
-- MySQL dump 10.13  Distrib 8.0.33, for Win64 (x86_64)
--
-- Host: 148.72.210.119    Database: admin_matrimony
-- ------------------------------------------------------
-- Server version	5.7.28

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!50503 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `addresses`
--

DROP TABLE IF EXISTS `addresses`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `addresses` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `addressLine1` varchar(500) DEFAULT NULL,
  `addressLine2` varchar(500) DEFAULT NULL,
  `pincode` varchar(10) DEFAULT NULL,
  `cityId` int(11) DEFAULT NULL,
  `stateId` int(11) DEFAULT NULL,
  `countryId` int(11) DEFAULT NULL,
  `countryName` varchar(100) DEFAULT NULL,
  `stateName` varchar(100) DEFAULT NULL,
  `cityName` varchar(100) DEFAULT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `addresses`
--

--
-- Table structure for table `annualincome`
--

DROP TABLE IF EXISTS `annualincome`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `annualincome` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `value` varchar(200) NOT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `application`
--

DROP TABLE IF EXISTS `application`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `application` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(45) NOT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `application`
--

LOCK TABLES `application` WRITE;
/*!40000 ALTER TABLE `application` DISABLE KEYS */;
INSERT INTO `application` VALUES (1,'MatrimonyAdmin',1,0,'2022-10-17 14:43:27','2022-10-17 14:43:27'),(2,'MatrimonyAndroid',1,0,'2022-10-17 14:43:27','2022-10-17 14:43:27'),(3,'matrimonyiOS',1,0,'2022-10-17 14:43:27','2022-10-17 14:43:27');
/*!40000 ALTER TABLE `application` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `authproviders`
--

DROP TABLE IF EXISTS `authproviders`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `authproviders` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `providerName` varchar(45) NOT NULL,
  `providerIcon` varchar(500) DEFAULT NULL,
  `applicationId` varchar(300) DEFAULT NULL,
  `secretKey` varchar(300) DEFAULT NULL,
  `loginURL` varchar(300) NOT NULL,
  `tokenURL` varchar(300) NOT NULL,
  `userInfoURL` varchar(300) NOT NULL,
  `callbackURL` varchar(300) NOT NULL,
  `permission` varchar(200) NOT NULL,
  `description` varchar(500) DEFAULT NULL,
  `isActive` tinyint(4) NOT NULL DEFAULT '1',
  `isDelete` tinyint(4) NOT NULL DEFAULT '0',
  `createdDate` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `authproviders`
--

LOCK TABLES `authproviders` WRITE;
/*!40000 ALTER TABLE `authproviders` DISABLE KEYS */;
INSERT INTO `authproviders` VALUES (1,'google',NULL,NULL,NULL,'http//google.com','http//google.com','http//google.com','http//google.com','yes',NULL,1,0,'2023-03-21 14:50:03','2023-03-21 14:50:03'),(2,'facebook',NULL,NULL,NULL,'http//google.com','http//google.com','http//google.com','http//google.com','yes',NULL,1,0,'2023-03-21 14:50:03','2023-03-21 14:50:03'),(3,'apple',NULL,NULL,NULL,'http//google.com','http//google.com','http//google.com','http//google.com','yes',NULL,1,0,'2023-03-21 14:50:03','2023-03-21 14:50:03');
/*!40000 ALTER TABLE `authproviders` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `districts`
--

DROP TABLE IF EXISTS `districts`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `districts` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `stateId` int(11) DEFAULT NULL,
  `name` varchar(200) DEFAULT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `fk_stateId_idx` (`stateId`),
  CONSTRAINT `fk_stateId` FOREIGN KEY (`stateId`) REFERENCES `state` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `districts`
--

LOCK TABLES `districts` WRITE;
/*!40000 ALTER TABLE `districts` DISABLE KEYS */;
INSERT INTO `districts` VALUES (1,1,'Ahmedabad',1,0,'2022-03-03 12:16:12','2022-03-03 12:16:12'),(2,1,'Gandhi Nagar',1,0,'2022-03-03 12:16:12','2022-03-03 12:16:12'),(3,1,'Banaskantha',1,0,'2022-03-03 12:16:12','2022-03-03 12:16:12'),(4,1,'Mahesana',1,0,'2022-03-03 12:16:12','2022-03-03 12:16:12'),(5,1,'Surendra Nagar',1,0,'2022-03-03 12:16:12','2022-03-03 12:16:12'),(6,1,'Patan',1,0,'2022-03-03 12:16:12','2022-03-03 12:16:12'),(7,1,'Sabarkantha',1,0,'2022-03-03 12:16:12','2022-03-03 12:16:12'),(8,1,'Amreli',1,0,'2022-03-03 12:16:12','2022-03-03 12:16:12'),(9,1,'Rajkot',1,0,'2022-03-03 12:16:12','2022-03-03 12:16:12'),(10,1,'Junagadh',1,0,'2022-03-03 12:16:12','2022-03-03 12:16:12'),(11,1,'Bhavnagar',1,0,'2022-03-03 12:16:12','2022-03-03 12:16:12'),(12,1,'Jamnagar',1,0,'2022-03-03 12:16:12','2022-03-03 12:16:12'),(13,1,'Porbandar',1,0,'2022-03-03 12:16:12','2022-03-03 12:16:12'),(14,1,'Kachchh',1,0,'2022-03-03 12:16:12','2022-03-03 12:16:12'),(15,1,'Anand',1,0,'2022-03-03 12:16:12','2022-03-03 12:16:12'),(16,1,'Kheda',1,0,'2022-03-03 12:16:12','2022-03-03 12:16:12'),(17,1,'Surat',1,0,'2022-03-03 12:16:12','2022-03-03 12:16:12'),(18,1,'The Dangs',1,0,'2022-03-03 12:16:12','2022-03-03 12:16:12'),(19,1,'Tapi',1,0,'2022-03-03 12:16:12','2022-03-03 12:16:12'),(20,1,'Navsari',1,0,'2022-03-03 12:16:12','2022-03-03 12:16:12'),(21,1,'Vadodara',1,0,'2022-03-03 12:16:12','2022-03-03 12:16:12'),(22,1,'Bharuch',1,0,'2022-03-03 12:16:12','2022-03-03 12:16:12'),(23,1,'Narmada',1,0,'2022-03-03 12:16:12','2022-03-03 12:16:12'),(24,1,'Dahod',1,0,'2022-03-03 12:16:12','2022-03-03 12:16:12'),(25,1,'Panch Mahals',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(26,1,'Valsad',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(27,2,'Ahmed Nagar',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(28,2,'Akola',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(29,2,'Amravati',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(30,2,'Aurangabad',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(31,2,'Beed',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(32,2,'Bhandara',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(33,2,'Buldhana',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(34,2,'Chandrapur',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(35,2,'Dhule',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(36,2,'Gadchiroli',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(37,2,'Gondia',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(38,2,'Hingoli',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(39,2,'Jalgaon',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(40,2,'Jalna',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(41,2,'Kolhapur',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(42,2,'Latur',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(43,2,'Mumbai',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(44,2,'Nagpur',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(45,2,'Nanded',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(46,2,'Nandurbar',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(47,2,'Nashik',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(48,2,'Osmanabad',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(49,2,'Parbhani',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(50,2,'Pune',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(51,2,'Raigarh(MH)',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(52,2,'Ratnagiri',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(53,2,'Sangli',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(54,2,'Satara',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(55,2,'Sindhudurg',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(56,2,'Solapur',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(57,2,'Thane',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(58,2,'Wardha',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(59,2,'Washim',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(60,2,'Yavatmal',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(61,3,'Central Delhi',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(62,3,'East Delhi',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(63,3,'New Delhi',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(64,3,'North Delhi',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(65,3,'North East Delhi',1,0,'2022-03-03 12:16:13','2022-03-03 12:16:13'),(66,3,'North West Delhi',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(67,3,'South Delhi',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(68,3,'South West Delhi',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(69,3,'West Delhi',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(70,4,'Bagalkot',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(71,4,'Bangalore',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(72,4,'Bangalore Rural',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(73,4,'Belgaum',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(74,4,'Bellary',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(75,4,'Bidar',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(76,4,'Bijapur(KAR)',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(77,4,'Chamrajnagar',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(78,4,'Chickmagalur',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(79,4,'Chikkaballapur',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(80,4,'Chitradurga',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(81,4,'Dakshina Kannada',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(82,4,'Davangere',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(83,4,'Dharwad',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(84,4,'Gadag',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(85,4,'Gulbarga',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(86,4,'Hassan',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(87,4,'Haveri',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(88,4,'Kodagu',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(89,4,'Kolar',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(90,4,'Koppal',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(91,4,'Mandya',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(92,4,'Mysore',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(93,4,'Raichur',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(94,4,'Ramanagar',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(95,4,'Shimoga',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(96,4,'Tumkur',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(97,4,'Udupi',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(98,4,'Uttara Kannada',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(99,4,'Yadgir',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(100,5,'Adilabad',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(101,5,'Hyderabad',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(102,5,'K.V.Rangareddy',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(103,5,'Karim Nagar',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(104,5,'Khammam',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(105,5,'Mahabub Nagar',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(106,5,'Medak',1,0,'2022-03-03 12:16:14','2022-03-03 12:16:14'),(107,5,'Nalgonda',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(108,5,'Nizamabad',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(109,5,'Warangal',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(110,6,'Ariyalur',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(111,6,'Chennai',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(112,6,'Coimbatore',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(113,6,'Cuddalore',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(114,6,'Dharmapuri',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(115,6,'Dindigul',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(116,6,'Erode',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(117,6,'Kanchipuram',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(118,6,'Kanyakumari',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(119,6,'Karur',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(120,6,'Krishnagiri',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(121,6,'Madurai',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(122,6,'Nagapattinam',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(123,6,'Namakkal',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(124,6,'Nilgiris',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(125,6,'Perambalur',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(126,6,'Pudukkottai',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(127,6,'Ramanathapuram',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(128,6,'Salem',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(129,6,'Sivaganga',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(130,6,'Thanjavur',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(131,6,'Theni',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(132,6,'Tiruchirappalli',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(133,6,'Tirunelveli',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(134,6,'Tiruvallur',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(135,6,'Tiruvannamalai',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(136,6,'Tiruvarur',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(137,6,'Tuticorin',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(138,6,'Vellore',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(139,6,'Villupuram',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(140,6,'Virudhunagar',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(141,7,'Bankura',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(142,7,'Bardhaman',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(143,7,'Birbhum',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(144,7,'Cooch Behar',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(145,7,'Darjiling',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(146,7,'East Midnapore',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(147,7,'Hooghly',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(148,7,'Howrah',1,0,'2022-03-03 12:16:15','2022-03-03 12:16:15'),(149,7,'Jalpaiguri',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(150,7,'Kolkata',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(151,7,'Malda',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(152,7,'Medinipur',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(153,7,'Murshidabad',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(154,7,'Nadia',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(155,7,'North 24 Parganas',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(156,7,'North Dinajpur',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(157,7,'Puruliya',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(158,7,'South 24 Parganas',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(159,7,'South Dinajpur',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(160,7,'West Midnapore',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(161,8,'Ajmer',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(162,8,'Alwar',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(163,8,'Banswara',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(164,8,'Baran',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(165,8,'Barmer',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(166,8,'Bharatpur',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(167,8,'Bhilwara',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(168,8,'Bikaner',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(169,8,'Bundi',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(170,8,'Chittorgarh',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(171,8,'Churu',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(172,8,'Dausa',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(173,8,'Dholpur',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(174,8,'Dungarpur',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(175,8,'Ganganagar',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(176,8,'Hanumangarh',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(177,8,'Jaipur',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(178,8,'Jaisalmer',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(179,8,'Jalor',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(180,8,'Jhalawar',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(181,8,'Jhujhunu',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(182,8,'Jodhpur',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(183,8,'Karauli',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(184,8,'Kota',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(185,8,'Nagaur',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(186,8,'Pali',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(187,8,'Rajsamand',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(188,8,'Sawai Madhopur',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(189,8,'Sikar',1,0,'2022-03-03 12:16:16','2022-03-03 12:16:16'),(190,8,'Sirohi',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(191,8,'Tonk',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(192,8,'Udaipur',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(193,9,'Agra',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(194,9,'Aligarh',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(195,9,'Allahabad',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(196,9,'Ambedkar Nagar',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(197,9,'Auraiya',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(198,9,'Azamgarh',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(199,9,'Bagpat',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(200,9,'Bahraich',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(201,9,'Ballia',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(202,9,'Balrampur',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(203,9,'Banda',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(204,9,'Barabanki',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(205,9,'Bareilly',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(206,9,'Basti',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(207,9,'Bijnor//207',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(208,9,'Budaun',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(209,9,'Bulandshahr',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(210,9,'Chandauli',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(211,9,'Chitrakoot',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(212,9,'Deoria',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(213,9,'Etah',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(214,9,'Etawah',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(215,9,'Faizabad',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(216,9,'Farrukhabad',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(217,9,'Fatehpur',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(218,9,'Firozabad',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(219,9,'Gautam Buddha Nagar',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(220,9,'Ghaziabad',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(221,9,'Ghazipur',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(222,9,'Gonda',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(223,9,'Gorakhpur',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(224,9,'Hamirpur',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(225,9,'Hardoi',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(226,9,'Hathras',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(227,9,'Jalaun',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(228,9,'Jaunpur',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(229,9,'Jhansi',1,0,'2022-03-03 12:16:17','2022-03-03 12:16:17'),(230,9,'Jyotiba Phule Nagar',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(231,9,'Kannauj',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(232,9,'Kanpur Dehat',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(233,9,'Kanpur Nagar',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(234,9,'Kaushambi',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(235,9,'Kheri',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(236,9,'Kushinagar',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(237,9,'Lalitpur',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(238,9,'Lucknow',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(239,9,'Maharajganj',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(240,9,'Mahoba',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(241,9,'Mainpuri',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(242,9,'Mathura',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(243,9,'Mau',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(244,9,'Meerut',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(245,9,'Mirzapur',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(246,9,'Moradabad',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(247,9,'Muzaffarnagar',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(248,9,'Pilibhit',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(249,9,'Pratapgarh',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(250,9,'Raebareli',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(251,9,'Rampur',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(252,9,'Saharanpur',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(253,9,'Sant Kabir Nagar',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(254,9,'Sant Ravidas Nagar',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(255,9,'Shahjahanpur',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(256,9,'Shrawasti',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(257,9,'Siddharthnagar',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(258,9,'Sitapur',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(259,9,'Sonbhadra',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(260,9,'Sultanpur',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(261,9,'Unnao',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(262,9,'Varanasi',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(263,10,'Ananthapur',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(264,10,'Chittoor',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(265,10,'Cuddapah',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(266,10,'East Godavari',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(267,10,'Guntur',1,0,'2022-03-03 12:16:18','2022-03-03 12:16:18'),(268,10,'Krishna',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(269,10,'Kurnool',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(270,10,'Nellore',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(271,10,'Prakasam',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(272,10,'Srikakulam',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(273,10,'Visakhapatnam',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(274,10,'Vizianagaram',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(275,10,'West Godavari',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(276,11,'Karaikal',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(277,11,'Mahe',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(278,11,'Pondicherry',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(279,12,'Barpeta',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(280,12,'Bongaigaon',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(281,12,'Cachar',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(282,12,'Darrang',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(283,12,'Dhemaji',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(284,12,'Dhubri',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(285,12,'Dibrugarh',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(286,12,'Goalpara',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(287,12,'Golaghat',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(288,12,'Hailakandi',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(289,12,'Jorhat',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(290,12,'Kamrup',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(291,12,'Karbi Anglong',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(292,12,'Karimganj',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(293,12,'Kokrajhar',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(294,12,'Lakhimpur',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(295,12,'Marigaon',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(296,12,'Nagaon',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(297,12,'Nalbari',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(298,12,'North Cachar Hills',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(299,12,'Sibsagar',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(300,12,'Sonitpur',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(301,12,'Tinsukia',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(302,13,'Araria',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(303,13,'Arwal',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(304,13,'Aurangabad(BH)',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(305,13,'Banka',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(306,13,'Begusarai',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(307,13,'Bhagalpur',1,0,'2022-03-03 12:16:19','2022-03-03 12:16:19'),(308,13,'Bhojpur',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(309,13,'Buxar',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(310,13,'Darbhanga',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(311,13,'East Champaran',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(312,13,'Gaya',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(313,13,'Gopalganj',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(314,13,'Jamui',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(315,13,'Jehanabad',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(316,13,'Kaimur (Bhabua)',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(317,13,'Katihar',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(318,13,'Khagaria',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(319,13,'Kishanganj',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(320,13,'Lakhisarai',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(321,13,'Madhepura',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(322,13,'Madhubani',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(323,13,'Munger',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(324,13,'Muzaffarpur',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(325,13,'Nalanda',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(326,13,'Nawada',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(327,13,'Patna',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(328,13,'Purnia',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(329,13,'Rohtas',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(330,13,'Saharsa',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(331,13,'Samastipur',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(332,13,'Saran',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(333,13,'Sheikhpura',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(334,13,'Sheohar',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(335,13,'Sitamarhi',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(336,13,'Siwan',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(337,13,'Supaul',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(338,13,'Vaishali',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(339,13,'West Champaran',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(340,14,'Bastar',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(341,14,'Bijapur(CGH)',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(342,14,'Bilaspur(CGH)',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(343,14,'Chandigarh',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(344,14,'Dantewada',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(345,14,'Dhamtari',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(346,14,'Durg',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(347,14,'Gariaband',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(348,14,'Janjgir-champa',1,0,'2022-03-03 12:16:20','2022-03-03 12:16:20'),(349,14,'Jashpur',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(350,14,'Kanker',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(351,14,'Kawardha',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(352,14,'Korba',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(353,14,'Koriya',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(354,14,'Mahasamund',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(355,14,'Narayanpur',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(356,14,'Raigarh',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(357,14,'Raipur',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(358,14,'Rajnandgaon',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(359,14,'Surguja',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(360,15,'Daman',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(361,15,'Diu',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(362,16,'Dadra & Nagar Haveli',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(363,17,'Ambala',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(364,17,'Bhiwani',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(365,17,'Faridabad',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(366,17,'Fatehabad',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(367,17,'Gurgaon',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(368,17,'Hisar',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(369,17,'Jhajjar',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(370,17,'Jind',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(371,17,'Kaithal',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(372,17,'Karnal',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(373,17,'Kurukshetra',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(374,17,'Mahendragarh',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(375,17,'Panchkula',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(376,17,'Panipat',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(377,17,'Rewari',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(378,17,'Rohtak',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(379,17,'Sirsa',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(380,17,'Sonipat',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(381,17,'Yamuna Nagar',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(382,18,'Bilaspur (HP)',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(383,18,'Chamba',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(384,18,'Hamirpur(HP)',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(385,18,'Kangra',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(386,18,'Kinnaur',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(387,18,'Kullu',1,0,'2022-03-03 12:16:21','2022-03-03 12:16:21'),(388,18,'Lahul & Spiti',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(389,18,'Mandi',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(390,18,'Shimla',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(391,18,'Sirmaur',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(392,18,'Solan',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(393,18,'Una',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(394,19,'Ananthnag',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(395,19,'Bandipur ',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(396,19,'Baramulla ',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(397,19,'Budgam  ',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(398,19,'Doda ',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(399,19,'Jammu ',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(400,19,'Kargil ',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(401,19,'Kathua ',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(402,19,'Kulgam',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(403,19,'Kupwara',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(404,19,'Leh ',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(405,19,'Poonch ',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(406,19,'Pulwama',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(407,19,'Rajauri ',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(408,19,'Reasi ',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(409,19,'Shopian ',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(410,19,'Srinagar ',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(411,19,'Udhampur',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(412,20,'Bokaro ',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(413,20,'Chatra ',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(414,20,'Deoghar ',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(415,20,'Dhanbad ',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(416,20,'Dumka ',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(417,20,'East Singhbhum ',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(418,20,'Garhwa ',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(419,20,'Giridh ',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(420,20,'Godda ',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(421,20,'Gumla ',1,0,'2022-03-03 12:16:22','2022-03-03 12:16:22'),(422,20,'Hazaribag',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(423,20,'Jamtara ',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(424,20,'Khunti ',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(425,20,'Koderma',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(426,20,'Latehar',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(427,20,'Lohardaga',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(428,20,'Pakur ',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(429,20,'Palamau',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(430,20,'Ramgarh ',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(431,20,'Ranchi ',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(432,20,'Sahibganj ',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(433,20,'Seraikela-kharsawan ',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(434,20,'Simdega ',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(435,20,'West Singhbhum ',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(436,21,'Alappuzha ',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(437,21,'Ernakulam',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(438,21,'Idukki ',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(439,21,'Kannur ',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(440,21,'Kasargod ',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(441,21,'Kollam ',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(442,21,'Kottayam ',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(443,21,'Kozhikode ',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(444,21,'Malappuram',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(445,21,'Palakkad ',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(446,21,'Pathanamthitta ',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(447,21,'Thiruvananthapuram ',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(448,21,'Thrissur ',1,0,'2022-03-03 12:16:23','2022-03-03 12:16:23'),(449,21,'Wayanad',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(450,22,'Lakshadweep',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(451,23,'Alirajpur',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(452,23,'Anuppur ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(453,23,'Ashok Nagar ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(454,23,'Balaghat ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(455,23,'Barwani ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(456,23,'Betul ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(457,23,'Bhind ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(458,23,'Bhopal ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(459,23,'Burhanpur ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(460,23,'Chhatarpur ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(461,23,'Chhindwara ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(462,23,'Damoh ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(463,23,'Datia ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(464,23,'Dewas ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(465,23,'Dhar ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(466,23,'Dindori ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(467,23,'East Nimar ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(468,23,'Guna ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(469,23,'Gwalior',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(470,23,'Harda',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(471,23,'Hoshangabad ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(472,23,'Indore ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(473,23,'Jabalpur ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(474,23,'Jhabua ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(475,23,'Katni ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(476,23,'Khandwa ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(477,23,'Khargone ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(478,23,'Mandla ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(479,23,'Mandsaur ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(480,23,'Morena ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(481,23,'Narsinghpur ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(482,23,'Neemuch',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(483,23,'Panna ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(484,23,'Raisen ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(485,23,'Rajgarh ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(486,23,'Ratlam ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(487,23,'Rewa ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(488,23,'Sagar ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(489,23,'Satna ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(490,23,'Sehore ',1,0,'2022-03-03 12:16:24','2022-03-03 12:16:24'),(491,23,'Seoni',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(492,23,'Shahdol ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(493,23,'Shajapur ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(494,23,'Sheopur ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(495,23,'Shivpuri ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(496,23,'Sidhi ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(497,23,'Singrauli ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(498,23,'Tikamgarh ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(499,23,'Ujjain',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(500,23,'Umaria ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(501,23,'Vidisha',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(502,23,'West Nimar',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(503,24,'North Goa ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(504,24,'South Goa',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(505,25,'Bishnupur ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(506,25,'Chandel ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(507,25,'Churachandpur ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(508,25,'Imphal East ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(509,25,'Imphal West ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(510,25,'Senapati ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(511,25,'Tamenglong ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(512,25,'Thoubal ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(513,25,'Ukhrul',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(514,26,'Aizawl ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(515,26,'Champhai ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(516,26,'Kolasib ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(517,26,'Lawngtlai ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(518,26,'Lunglei ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(519,26,'Mammit ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(520,26,'Saiha ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(521,26,'Serchhip',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(522,27,'Dimapur ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(523,27,'Kiphire ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(524,27,'Kohima ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(525,27,'Longleng ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(526,27,'Mokokchung ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(527,27,'Mon ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(528,27,'Peren ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(529,27,'Phek ',1,0,'2022-03-03 12:16:25','2022-03-03 12:16:25'),(530,27,'Tuensang ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(531,27,'Wokha ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(532,27,'Zunhebotto ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(533,28,'Dhalai ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(534,28,'North Tripura ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(535,28,'South Tripura ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(536,28,'West Tripura ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(537,29,'Changlang ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(538,29,'Dibang Valley ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(539,29,'East Kameng',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(540,29,'East Siang ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(541,29,'Kurung Kumey ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(542,29,'Lohit ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(543,29,'Lower Dibang Valley ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(544,29,'Lower Subansiri ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(545,29,'Papum Pare ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(546,29,'Tawang',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(547,29,'Tirap ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(548,29,'Upper Siang ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(549,29,'Upper Subansiri ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(550,29,'West Kameng ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(551,29,'West Siang ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(552,30,'East Garo Hills ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(553,30,'East Khasi Hills',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(554,30,'Jaintia Hills ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(555,30,'Ri Bhoi ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(556,30,'South Garo Hills ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(557,30,'West Garo Hills ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(558,30,'West Khasi Hills',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(559,31,'Angul ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(560,31,'Balangir ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(561,31,'Baleswar ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(562,31,'Bargarh ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(563,31,'Bhadrak ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(564,31,'Boudh ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(565,31,'Cuttack ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(566,31,'Debagarh',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(567,31,'Dhenkanal ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(568,31,'Gajapati',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(569,31,'Ganjam ',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(570,31,'Jagatsinghapur',1,0,'2022-03-03 12:16:26','2022-03-03 12:16:26'),(571,31,'Jajapur ',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(572,31,'Jharsuguda ',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(573,31,'Kalahandi',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(574,31,'Kandhamal ',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(575,31,'Kendrapara ',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(576,31,'Kendujhar',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(577,31,'Khorda ',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(578,31,'Koraput ',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(579,31,'Malkangiri ',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(580,31,'Mayurbhanj ',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(581,31,'Nabarangapur ',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(582,31,'Nayagarh ',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(583,31,'Nuapada ',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(584,31,'Puri ',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(585,31,'Rayagada ',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(586,31,'Sambalpur ',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(587,31,'Sonapur ',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(588,31,'Sundergarh',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(589,32,'Chandigarh',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(590,33,'Amritsar ',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(591,33,'Barnala',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(592,33,'Bathinda',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(593,33,'Faridkot ',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(594,33,'Fatehgarh Sahib ',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(595,33,'Fazilka ',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(596,33,'Firozpur',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(597,33,'Gurdaspur',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(598,33,'Hoshiarpur',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(599,33,'Jalandhar ',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(600,33,'Kapurthala',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(601,33,'Ludhiana',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(602,33,'Mansa',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(603,33,'Moga',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(604,33,'Mohali',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(605,33,'Muktsar',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(606,33,'Nawanshahr ',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(607,33,'Pathankot ',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(608,33,'Patiala ',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(609,33,'Ropar',1,0,'2022-03-03 12:16:27','2022-03-03 12:16:27'),(610,33,'Rupnagar',1,0,'2022-03-03 12:16:28','2022-03-03 12:16:28'),(611,33,'Sangrur ',1,0,'2022-03-03 12:16:28','2022-03-03 12:16:28'),(612,33,'Tarn Taran',1,0,'2022-03-03 12:16:28','2022-03-03 12:16:28'),(613,34,'Almora',1,0,'2022-03-03 12:16:28','2022-03-03 12:16:28'),(614,34,'Bageshwar',1,0,'2022-03-03 12:16:28','2022-03-03 12:16:28'),(615,34,'Chamoli',1,0,'2022-03-03 12:16:28','2022-03-03 12:16:28'),(616,34,'Champawat',1,0,'2022-03-03 12:16:28','2022-03-03 12:16:28'),(617,34,'Dehradun',1,0,'2022-03-03 12:16:28','2022-03-03 12:16:28'),(618,34,'Haridwar',1,0,'2022-03-03 12:16:28','2022-03-03 12:16:28'),(619,34,'Nainital',1,0,'2022-03-03 12:16:28','2022-03-03 12:16:28'),(620,34,'Pauri Garhwal',1,0,'2022-03-03 12:16:28','2022-03-03 12:16:28'),(621,34,'Pithoragarh',1,0,'2022-03-03 12:16:28','2022-03-03 12:16:28'),(622,34,'Rudraprayag',1,0,'2022-03-03 12:16:28','2022-03-03 12:16:28'),(623,34,'Tehri Garhwal',1,0,'2022-03-03 12:16:28','2022-03-03 12:16:28'),(624,34,'Udham Singh Nagar',1,0,'2022-03-03 12:16:28','2022-03-03 12:16:28'),(625,34,'Uttarkashi',1,0,'2022-03-03 12:16:28','2022-03-03 12:16:28'),(626,35,'Nicobar',1,0,'2022-03-03 12:16:28','2022-03-03 12:16:28'),(627,35,'North And Middle Andaman',1,0,'2022-03-03 12:16:28','2022-03-03 12:16:28'),(628,35,'South Andaman',1,0,'2022-03-03 12:16:28','2022-03-03 12:16:28'),(629,36,'East Sikkim',1,0,'2022-03-03 12:16:28','2022-03-03 12:16:28'),(630,36,'North Sikkim ',1,0,'2022-03-03 12:16:28','2022-03-03 12:16:28'),(631,36,'South Sikkim',1,0,'2022-03-03 12:16:28','2022-03-03 12:16:28'),(632,36,'West Sikkim',1,0,'2022-03-03 12:16:28','2022-03-03 12:16:28');
/*!40000 ALTER TABLE `districts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cities`
--

DROP TABLE IF EXISTS `cities`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `cities` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `districtId` int(11) DEFAULT NULL,
  `name` varchar(200) DEFAULT NULL,
  `pincode` varchar(10) DEFAULT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `fk_districtId_idx` (`districtId`),
  CONSTRAINT `fk_districtId` FOREIGN KEY (`districtId`) REFERENCES `districts` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1  DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cities`
--

LOCK TABLES `cities` WRITE;
/*!40000 ALTER TABLE `cities` DISABLE KEYS */;
INSERT INTO `cities` VALUES (1,1,'Ambawadi (Ahmedabad)','380006',1,0,'2022-03-03 12:18:30','2022-03-03 12:18:30'),(2,1,'Ambli','380058',1,0,'2022-03-03 12:18:30','2022-03-03 12:18:30'),(3,1,'Amraiwadi','380026',1,0,'2022-03-03 12:18:30','2022-03-03 12:18:30'),(4,1,'Anandnagar (Ahmedabad)','380007',1,0,'2022-03-03 12:18:30','2022-03-03 12:18:30'),(5,1,'Asarwa Chakla','380016',1,0,'2022-03-03 12:18:30','2022-03-03 12:18:30'),(6,1,'Asarwa Ext South','380024',1,0,'2022-03-03 12:18:30','2022-03-03 12:18:30'),(7,1,'Ashram Road P.O','380009',1,0,'2022-03-03 12:18:30','2022-03-03 12:18:30'),(8,1,'Aslali','382427',1,0,'2022-03-03 12:18:30','2022-03-03 12:18:30'),(9,1,'Azad Society','380015',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(10,1,'Bakrol','382430',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(11,1,'Bakrol','382210',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(12,1,'Bapunagar','380024',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(13,1,'Bareja (Ahmedabad)','382425',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(14,1,'Behrampura','380022',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(15,1,'Bhairavnath Road','380028',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(16,1,'Bhat','382210',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(17,1,'Bhavda','382433',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(18,1,'Bhuvaldi','382430',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(19,1,'Bilasia','382330',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(20,1,'Bodakdev','380054',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(21,1,'Bopal','380058',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(22,1,'Calico Mills','380022',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(23,1,'Cantonment','380004',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(24,1,'Chandial','382433',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(25,1,'Chandkheda','382424',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(26,1,'Chandkheda Society Area','382424',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(27,1,'Chaulaj','382433',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(28,1,'Civil Hospital','380016',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(29,1,'Ctm Char Rasta','380026',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(30,1,'D Cabin','380019',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(31,1,'Dariapur (Ahmedabad)','380001',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(32,1,'Darpan Society','380009',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(33,1,'Daxini Society','380008',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(34,1,'Delhi Gate (Ahmedabad)','380004',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(35,1,'Dhamatvan','382435',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(36,1,'District Court (Ahmedabad)','380001',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(37,1,'Dudheshwar Tavdipura','380004',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(38,1,'Ellisbridge','380006',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(39,1,'Fatewadi','382210',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(40,1,'Gamdi','382435',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(41,1,'Gandhi Ashram (Ahmedabad)','380027',1,0,'2022-03-03 12:18:31','2022-03-03 12:18:31'),(42,1,'Gandhi Road (Ahmedabad)','380001',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(43,1,'Geratpur','382435',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(44,1,'Ghatlodia','380061',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(45,1,'Gheekanta Road','380001',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(46,1,'Ghodasar (Ahmedabad)','380050',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(47,1,'Ghuma','380058',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(48,1,'Girdharnagar','380004',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(49,1,'Girmatha','382425',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(50,1,'Gita Mandir Road','380022',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(51,1,'Gomtipur','380021',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(52,1,'Gujarat University','380009',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(53,1,'Gyaspur','382405',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(54,1,'Harniav','382435',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(55,1,'Hirapur','382435',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(56,1,'I E Bapunagar','380024',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(57,1,'I I M','380015',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(58,1,'Isanpur','382443',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(59,1,'Jamalpur (Ahmedabad)','380001',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(60,1,'Jawahar Chowk','380008',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(61,1,'Jetalpur','382427',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(62,1,'Jivraj Park','380051',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(63,1,'Jodhpur Char Rasta','380015',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(64,1,'Juhapura','380055',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(65,1,'Kabir Chowk','380005',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(66,1,'Kalupur Chakla','380001',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(67,1,'Kanbha','382430',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(68,1,'Kaniyel','382433',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(69,1,'Kasindra','382210',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(70,1,'Kathwada','382430',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(71,1,'Kathwada Maize Product','382430',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(72,1,'Khadia','380001',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(73,1,'Khanpur (Ahmedabad)','380001',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(74,1,'Khodiyarnagar','382350',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(75,1,'Khokhara Mehmadabad','380008',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(76,1,'Kolat','382210',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(77,1,'Krishnanagar (Ahmedabad)','382345',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(78,1,'Kubadthal','382430',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(79,1,'Kubernagar B A','382340',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(80,1,'Kubernagar','382340',1,0,'2022-03-03 12:18:32','2022-03-03 12:18:32'),(81,1,'Kuha','382433',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(82,1,'Kujad','382430',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(83,1,'L G Hospital','380008',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(84,1,'Lal Darwaja','380001',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(85,1,'Lambha','382405',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(86,1,'Limbadia','382330',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(87,1,'M D Marg','380022',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(88,1,'Madhupura Market','380004',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(89,1,'Mahijada','382425',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(90,1,'Manek Chowk','380001',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(91,1,'Manekbag','380015',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(92,1,'Maninagar','380008',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(93,1,'Medra','382330',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(94,1,'Meghaningar','380016',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(95,1,'Memnagar','380052',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(96,1,'Miroli','382425',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(97,1,'Motera','380005',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(98,1,'Muktipur','382425',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(99,1,'Municipal Corporation','380001',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(100,1,'N C Market','380002',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(101,1,'N C Mills','382345',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(102,1,'Nana Chiloda','382330',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(103,1,'Nandej','382435',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(104,1,'Naranpura Vistar','380013',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(105,1,'Narayannagar','380007',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(106,1,'Naroda I E','382330',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(107,1,'Naroda Road','382345',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(108,1,'Naroda S A','382330',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(109,1,'Naroda','382330',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(110,1,'Narol','382405',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(111,1,'Nava Vadaj','380013',1,0,'2022-03-03 12:18:33','2022-03-03 12:18:33'),(112,1,'Navapura','382210',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(113,1,'Navjivan','380014',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(114,1,'Navrangpura H.O','380009',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(115,1,'Nikol','382350',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(116,1,'Noblenagar','382340',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(117,1,'O N G C','380005',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(118,1,'Ode','382427',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(119,1,'Odhav Industrial Estate','382415',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(120,1,'Odhav','382415',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(121,1,'Paldi Kankaj','382425',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(122,1,'Paldi (Ahmedabad)','380007',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(123,1,'Pardhol','382330',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(124,1,'Pasunj','382430',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(125,1,'Pirana','382425',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(126,1,'Polytechnic (Ahmedabad)','380015',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(127,1,'Public Office (Ahmedabad)','380016',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(128,1,'Raikhad','380001',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(129,1,'Railway Colony (Ahmedabad)','380019',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(130,1,'Railwaypura','380002',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(131,1,'Raipur (Ahmedabad)','380001',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(132,1,'Rajpur Gomtipur','380021',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(133,1,'Rakhial','380023',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(134,1,'Rakhial Udyog Vistar','380023',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(135,1,'Ranip','382480',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(136,1,'Ranodra','382433',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(137,1,'Revdibazar H.O','380002',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(138,1,'S A C','380015',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(139,1,'S A Mills','380008',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(140,1,'Sabarmati','380005',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(141,1,'Saijpur','382405',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(142,1,'Saijpur Bogha','382345',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(143,1,'Sanathal','382210',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(144,1,'Saraspur','380018',1,0,'2022-03-03 12:18:34','2022-03-03 12:18:34'),(145,1,'Sardarnagar','382475',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(146,1,'Sarkhej Road','380007',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(147,1,'Sarkhej','382210',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(148,1,'Shah Alam Roza','380028',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(149,1,'Shahibag','380004',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(150,1,'Shahpur (Ahmedabad)','380004',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(151,1,'Shahwadi','382405',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(152,1,'Shardanagar','380007',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(153,1,'Shastrinagar (Ahmedabad)','380013',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(154,1,'Shela','380058',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(155,1,'Sola H B C','380063',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(156,1,'Stadium Marg','380013',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(157,1,'Sub Foreign','380004',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(158,1,'Sukhrampura','380023',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(159,1,'T B Nagar','382350',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(160,1,'Telav','382210',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(161,1,'Thaltej Road','380054',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(162,1,'Timba','382425',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(163,1,'Undrel','382433',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(164,1,'Vadaj','380013',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(165,1,'Vadod','382433',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(166,1,'Vasai','382425',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(167,1,'Vasisthnagar','380008',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(168,1,'Vastral','382418',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(169,1,'Vatva','382440',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(170,1,'Vehlal','382330',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(171,1,'Vishalpur','382210',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(172,1,'Zanu','382430',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(173,1,'Ahmedabad G.P.O.','380001',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(174,1,'Abasana','382120',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(175,1,'Adroda','382220',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(176,1,'Adval','382460',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(177,1,'Akru','382250',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(178,1,'Alampur','382245',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(179,1,'Alau','382255',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(180,1,'Ambaliara','382225',1,0,'2022-03-03 12:18:35','2022-03-03 12:18:35'),(181,1,'Ambareli','382225',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(182,1,'Ambli','382463',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(183,1,'Andej','382115',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(184,1,'Aniali ( K )','382245',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(185,1,'Aniali Bhimji','382460',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(186,1,'Arnej','382230',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(187,1,'Asalgam','382150',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(188,1,'Ashoknagar','382140',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(189,1,'Badarkha','382260',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(190,1,'Bagad','382255',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(191,1,'Bagodara','382230',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(192,1,'Bajarda','382460',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(193,1,'Bakrana','382170',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(194,1,'Baldana','382240',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(195,1,'Balsasan','382145',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(196,1,'Bamroli','382145',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(197,1,'Bamsara','382240',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(198,1,'Barwala Ghelasha','382450',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(199,1,'Bavaliary','382455',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(200,1,'Bavla Market Yard','382220',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(201,1,'Bavla','382220',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(202,1,'Bhadaj','380060',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(203,1,'Bhadana','382140',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(204,1,'Bhadiad','382463',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(205,1,'Bhangadh','382455',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(206,1,'Bhankoda','382140',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(207,1,'Bhayla','382220',1,0,'2022-03-03 12:18:36','2022-03-03 12:18:36'),(208,1,'Bhojwa','382150',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(209,1,'Bholad','382230',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(210,1,'Bhoyani','382145',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(211,1,'Bhurkhi','382230',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(212,1,'Bodia','382245',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(213,1,'Bol','382170',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(214,1,'Bordibazar Viramgam','382150',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(215,1,'Buranpur','382465',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(216,1,'Chaloda','382260',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(217,1,'Chandarva','382255',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(218,1,'Chandisar','382260',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(219,1,'Chandlodia','382481',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(220,1,'Chandranagar','382150',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(221,1,'Changodar','382213',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(222,1,'Charanki','382450',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(223,1,'Charel','382110',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(224,1,'Chekhla','382115',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(225,1,'Chhabasar','382220',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(226,1,'Chhaniar','382140',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(227,1,'Chharodi','382170',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(228,1,'Chhasiana','382460',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(229,1,'Chiada','382220',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(230,1,'Chokdi','382250',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(231,1,'Chuval Dangarva','382145',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(232,1,'Dabhsar','382120',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(233,1,'Dadhana','382120',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(234,1,'Daduka','382110',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(235,1,'Dadusar','382225',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(236,1,'Dalod','382130',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(237,1,'Daran','382220',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(238,1,'Daslana','382150',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(239,1,'Dehgamda','382220',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(240,1,'Dekawada','382120',1,0,'2022-03-03 12:18:37','2022-03-03 12:18:37'),(241,1,'Deo Dholera','382240',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(242,1,'Detroj','382120',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(243,1,'Devaliya','382245',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(244,1,'Devpura','382140',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(245,1,'Devtimoti','382213',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(246,1,'Dhakdi','382150',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(247,1,'Dhanala','382465',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(248,1,'Dhandhuka','382460',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(249,1,'Dhanwada','382220',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(250,1,'Dharpipla','382245',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(251,1,'Dhedasana','382130',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(252,1,'Dhingada','382230',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(253,1,'Dholera','382455',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(254,1,'Dholi','382240',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(255,1,'Dholka H.O','382225',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(256,1,'Digvijaynagar','382470',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(257,1,'Dodar','382170',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(258,1,'Dumana','382150',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(259,1,'Durgi','382230',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(260,1,'Endla','382130',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(261,1,'Fangadi','382110',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(262,1,'Fatepur','382465',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(263,1,'Fedra','382465',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(264,1,'Galsana','382245',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(265,1,'Gamanpura','382120',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(266,1,'Gamph','382465',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(267,1,'Gangad','382240',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(268,1,'Ganol','382265',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(269,1,'Garodia','382115',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(270,1,'Gatrad','382449',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(271,1,'Ghatisana','382140',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(272,1,'Ghoda','382150',1,0,'2022-03-03 12:18:38','2022-03-03 12:18:38'),(273,1,'Godhavata','382255',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(274,1,'Godhavi','382115',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(275,1,'Gogla','382463',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(276,1,'Goraiya','382150',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(277,1,'Goraj','382110',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(278,1,'Gorasu','382463',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(279,1,'Gota','382481',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(280,1,'Gunda','382255',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(281,1,'Gundi Sarvodaya Ashram','382230',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(282,1,'Gunjala','382120',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(283,1,'Gunjar','382460',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(284,1,'Hansalpur','382150',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(285,1,'Hathijan','382445',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(286,1,'Hebatpur','382455',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(287,1,'Hirapura','382150',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(288,1,'Iawa (Vasna)','382170',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(289,1,'Ingoli','382265',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(290,1,'Jagatpur','382470',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(291,1,'Jakhada','382230',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(292,1,'Jakwada','382150',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(293,1,'Jalalpur Vajifa','382225',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(294,1,'Jalampur','382150',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(295,1,'Jalila','382255',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(296,1,'Jalisana','382120',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(297,1,'Jaliya','382460',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(298,1,'Jamp','382110',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(299,1,'Jantanagar','382449',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(300,1,'Jawaraj','382230',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(301,1,'Jeska','382250',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(302,1,'Jholapur','382170',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(303,1,'Joshipura','382150',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(304,1,'Junapadhar','382150',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(305,1,'Juval','382220',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(306,1,'Juval Rupavati','382220',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(307,1,'Kadipur','382463',1,0,'2022-03-03 12:18:39','2022-03-03 12:18:39'),(308,1,'Kadvasan','382130',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(309,1,'Kalana','382170',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(310,1,'Kali','382470',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(311,1,'Kalyangadh','382240',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(312,1,'Kamiala','382465',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(313,1,'Kamijala','382150',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(314,1,'Kaneti','382110',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(315,1,'Kankravadi','382150',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(316,1,'Kanz','382140',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(317,1,'Karakthal','382150',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(318,1,'Kasindra','382465',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(319,1,'Katosan Road','382145',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(320,1,'Kauka','382265',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(321,1,'Kavitha','382260',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(322,1,'Kelia  Vasna','382225',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(323,1,'Kerala','382220',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(324,1,'Keria','382245',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(325,1,'Kesardi','382240',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(326,1,'Khadol','382460',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(327,1,'Khambhada','382450',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(328,1,'Khamidana','382450',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(329,1,'Khandachora Dhandhuka','382460',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(330,1,'Kharad','382460',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(331,1,'Kharakuva Dholka','382225',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(332,1,'Khas','382255',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(333,1,'Khasta','382460',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(334,1,'Khoda','382170',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(335,1,'Khodiyar','382421',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(336,1,'Khokarnesh','382245',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(337,1,'Khorajnanoda','382170',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(338,1,'Khudad','382150',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(339,1,'Khun','382455',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(340,1,'Kocharia','382220',1,0,'2022-03-03 12:18:40','2022-03-03 12:18:40'),(341,1,'Kointia','382140',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(342,1,'Kokta','382150',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(343,1,'Koth','382240',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(344,1,'Kothadia','382460',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(345,1,'Kukvav','382120',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(346,1,'Kumarkhan','382150',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(347,1,'Kundal','382110',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(348,1,'Kundal','382450',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(349,1,'Kundli','382245',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(350,1,'Kunpur','382130',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(351,1,'Kunvar','382110',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(352,1,'Lapkaman','380060',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(353,1,'Loliya','382465',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(354,1,'Lothal Bhurkhi RS','382230',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(355,1,'Madrisana','382145',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(356,1,'Makhiav','382110',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(357,1,'Mandal (Ahmedabad)','382130',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(358,1,'Manipur','382150',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(359,1,'Mankol','382110',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(360,1,'Marusana','382120',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(361,1,'Matoda','382213',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(362,1,'Melaj','382150',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(363,1,'Mingalpur','382455',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(364,1,'Mithapur','382230',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(365,1,'Modasar','382220',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(366,1,'Moraiya','382213',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(367,1,'Mota Tradia','382460',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(368,1,'Moti  Kishol','382110',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(369,1,'Moti Boru','382230',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(370,1,'Moti Rantai','382145',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(371,1,'Moti Vavdi','382255',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(372,1,'Nadishala','382120',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(373,1,'Nana Ubhada','382130',1,0,'2022-03-03 12:18:41','2022-03-03 12:18:41'),(374,1,'Nani Boru','382230',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(375,1,'Nani Devti','382220',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(376,1,'Nani Vavdi','382245',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(377,1,'Nanodara','382220',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(378,1,'Navagam','382130',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(379,1,'Navda','382450',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(380,1,'Nayakpur','382130',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(381,1,'Nedharad','382115',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(382,1,'Nesda','382225',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(383,1,'Nirnaynagar','382481',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(384,1,'Odhav','382120',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(385,1,'Ogan','382150',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(386,1,'Ognaj','380060',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(387,1,'Otaria','382463',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(388,1,'Otaria Sarvodaya Ashram','382463',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(389,1,'Padana','382460',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(390,1,'Panar','382140',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(391,1,'Panchham','382465',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(392,1,'Panchhi','382455',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(393,1,'Pandharpura','382140',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(394,1,'Parabadi','382250',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(395,1,'Pimpan','382110',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(396,1,'Piplaj','382315',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(397,1,'Pipli','382465',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(398,1,'Pisawada','382265',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(399,1,'Polarpur','382250',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(400,1,'Rahemalpur','382150',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(401,1,'Rajoda','382220',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(402,1,'Rajpura','382245',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(403,1,'Rakhiana','382130',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(404,1,'Ramol','382449',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(405,1,'Rampur','382225',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(406,1,'Rampura','382450',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(407,1,'Rampura (Ahmedabad)','382140',1,0,'2022-03-03 12:18:42','2022-03-03 12:18:42'),(408,1,'Ranesar','382220',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(409,1,'Rangpur','382150',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(410,1,'Ranoda','382225',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(411,1,'Ranpur','382245',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(412,1,'Rasam','382220',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(413,1,'Rayka','382460',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(414,1,'Refda','382255',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(415,1,'Rethal','382110',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(416,1,'Ribadi','382130',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(417,1,'Rohika','382230',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(418,1,'Rojid','382450',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(419,1,'Rojka','382460',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(420,1,'Rudatal','382120',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(421,1,'Rupal','382220',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(422,1,'Rupgadh','382240',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(423,1,'Sachana','382150',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(424,1,'Sadatpura','382120',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(425,1,'Sahij','382225',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(426,1,'Saiwada','382225',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(427,1,'Salajada','382220',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(428,1,'Salangpur - Hanuman','382450',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(429,1,'Salasar','382460',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(430,1,'Sanand','382110',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(431,1,'Sandhida','382455',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(432,1,'Sangasar','382463',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(433,1,'Sangpura','382120',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(434,1,'Sankod','382220',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(435,1,'Sarandi','382225',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(436,1,'Sargwala','382230',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(437,1,'Sari','382220',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(438,1,'Saroda','382260',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(439,1,'Sarsavadi','382150',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(440,1,'Sathal','382225',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(441,1,'Shahpur','382250',1,0,'2022-03-03 12:18:43','2022-03-03 12:18:43'),(442,1,'Shahpur','382150',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(443,1,'Shela','382465',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(444,1,'Sher','382130',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(445,1,'Sherpura','382225',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(446,1,'Shilaj','380059',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(447,1,'Shivpura','382140',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(448,1,'Shiyal','382230',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(449,1,'Siawada','382170',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(450,1,'Sihor','382140',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(451,1,'Simej','382265',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(452,1,'Sinaj','382120',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(453,1,'Sindharej','382225',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(454,1,'Sitapur','382130',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(455,1,'Sobhasan','382145',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(456,1,'Sodhi','382463',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(457,1,'Sola','380060',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(458,1,'Solgam','382130',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(459,1,'Sunderiana','382255',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(460,1,'Sunvala','382145',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(461,1,'Tagadi','382250',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(462,1,'Telavi','382145',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(463,1,'Thaltej','380059',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(464,1,'Thori Mubarak','382150',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(465,1,'Thori Thumbha','382150',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(466,1,'Thuleta','382150',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(467,1,'Tragad','382470',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(468,1,'Transad','382225',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(469,1,'Trent','382150',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(470,1,'Ughroj','382120',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(471,1,'Ukardi','382140',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(472,1,'Ukhlod','382150',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(473,1,'Umrela','382245',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(474,1,'Unchadi','382250',1,0,'2022-03-03 12:18:44','2022-03-03 12:18:44'),(475,1,'Upardal','382110',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(476,1,'Utelia','382230',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(477,1,'Vadgas','382150',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(478,1,'Vadhela','382450',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(479,1,'Vagad','382245',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(480,1,'Valdhera','382225',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(481,1,'Valhia','382450',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(482,1,'Valinda','382463',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(483,1,'Vanch','382449',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(484,1,'Vani','382150',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(485,1,'Vanpardi','382130',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(486,1,'Vansva','382150',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(487,1,'Vanthal','382150',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(488,1,'Varmor','382130',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(489,1,'Varna','382265',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(490,1,'Vasna  (Iawa)','382170',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(491,1,'Vasna  Chacharvadi','382213',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(492,1,'Vasna','382460',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(493,1,'Vataman','382265',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(494,1,'Vatva Industrial Estate','382445',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(495,1,'Vautha','382225',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(496,1,'Vejalka','382230',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(497,1,'Vekaria','382110',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(498,1,'Vinchhan','382120',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(499,1,'Vinchhiya','382110',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(500,1,'Vinzol','382445',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(501,1,'Vinzuvada','382130',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(502,1,'Viramgam','382150',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(503,1,'Virdi','382265',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(504,1,'Virochannagar','382170',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(505,1,'Vithlpura','382120',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(506,1,'VivekanandNagar','382445',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(507,1,'Zanzarka','382460',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(508,1,'Zanzarva','382120',1,0,'2022-03-03 12:18:45','2022-03-03 12:18:45'),(509,1,'Zezra','382150',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(510,1,'Zinzar','382250',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(511,1,'Ambalia','383345',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(512,2,'Chamla','382433',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(513,2,'Sughad','382424',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(514,2,'(Gandhinagar) Sector 16','382016',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(515,2,'(Gandhinagar) Sector 17','382016',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(516,2,'(Gandhinagar) Sector 19','382021',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(517,2,'(Gandhinagar) Sector 21','382021',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(518,2,'(Gandhinagar) Sector 22','382021',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(519,2,'(Gandhinagar) Sector 23','382024',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(520,2,'(Gandhinagar) Sector 24','382024',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(521,2,'(Gandhinagar) Sector 28','382028',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(522,2,'(Gandhinagar) Sector 29','382030',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(523,2,'(Gandhinagar) Sector 30','382030',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(524,2,'(Gandhinagar) Sector 6','382006',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(525,2,'(Gandhinagar) Sector 7','382007',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(526,2,'(Gandhinagar) Sector 8','382007',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(527,2,'(Gandhinagar) Sector 9','382007',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(528,2,'Adalaj','382421',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(529,2,'Adrajmoti','382640',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(530,2,'Ajol','382810',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(531,2,'Alampur','382042',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(532,2,'Aluva','382721',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(533,2,'Ambapur','382421',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(534,2,'Ambika Society Kalol','382721',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(535,2,'Ambod','382845',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(536,2,'Amja','382735',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(537,2,'Amrajinamuvada','382305',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(538,2,'Amrapur Gram Bharti','382721',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(539,2,'Anguthala','382305',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(540,2,'Anodia','382855',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(541,2,'Badpura','382845',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(542,2,'Bahiyal','382308',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(543,2,'Balva','382721',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(544,2,'Bapupura','382845',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(545,2,'Bardoli-koti','382305',1,0,'2022-03-03 12:18:46','2022-03-03 12:18:46'),(546,2,'Baria','382308',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(547,2,'Basan','382355',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(548,2,'Bhat','382428',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(549,2,'Bhoyan  Moti','382721',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(550,2,'Bhoyan Rathod','382422',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(551,2,'Bilodra','382810',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(552,2,'Borisana','382721',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(553,2,'Boru','382845',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(554,2,'BSF GANDHINAGAR','382045',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(555,2,'Chadasana','382810',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(556,2,'Chandrala','382321',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(557,2,'Charada','382810',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(558,2,'Chekhala Pagi','382321',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(559,2,'Chhala','382321',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(560,2,'Chhatral','382729',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(561,2,'Chiloda','382355',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(562,2,'Chiskari','382308',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(563,2,'CRPF Campus G Nagar','382042',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(564,2,'Dabhoda','382355',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(565,2,'Dashela','382355',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(566,2,'Dehgam','382305',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(567,2,'Delvada','382810',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(568,2,'Devkaran Na Muvada','382308',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(569,2,'Dhamasana','382740',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(570,2,'Dhanap','382355',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(571,2,'Dharisana','382315',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(572,2,'Dholakuva','382845',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(573,2,'Dingucha','382740',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(574,2,'Dolarana Vasna','382320',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(575,2,'Fatepura','382845',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(576,2,'Galudan','382355',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(577,2,'Gandhinagar (Gujarat) H.O','382010',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(578,2,'Ghamij','382308',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(579,2,'Gift City','382355',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(580,2,'Giyod','382321',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(581,2,'Golthara','382735',1,0,'2022-03-03 12:18:47','2022-03-03 12:18:47'),(582,2,'Gujrat High Court','380060',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(583,2,'Hajipur','382721',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(584,2,'Halisa','382321',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(585,2,'Harkhji Na Muvada','382305',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(586,2,'Harsoli','382305',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(587,2,'Hathijan','382308',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(588,2,'Hilol','382308',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(589,2,'Indrapura','382845',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(590,2,'Indroda','382007',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(591,2,'Isand','382721',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(592,2,'Isanpur-dodia','382308',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(593,2,'Isanpur-mota','382355',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(594,2,'Itadar','382845',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(595,2,'Jakhora','382320',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(596,2,'Jalia No Math','382305',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(597,2,'Jamiyatpura','382423',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(598,2,'Jamla','382735',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(599,2,'Jaspur','382721',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(600,2,'Jawaharmarket Dehgam','382305',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(601,2,'Jethlaj','382721',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(602,2,'Jindva','382315',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(603,2,'Kadjodara','382315',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(604,2,'Kadodara','382305',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(605,2,'Kalol Desaivada','382721',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(606,2,'Kalol Gandhi Road','382721',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(607,2,'Kalol H.O','382721',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(608,2,'Kalol Industrial Estate','382725',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(609,2,'Kalol Society Area','382721',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(610,2,'Kanipur','382308',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(611,2,'Karoli','382305',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(612,2,'Kasturba Vidyalaya','382007',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(613,2,'Kasturinagar','382423',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(614,2,'Khadat','382855',1,0,'2022-03-03 12:18:48','2022-03-03 12:18:48'),(615,2,'Khanpur','382315',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(616,2,'Kharana','382845',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(617,2,'Khatraj I E','382721',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(618,2,'Khoraj','382735',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(619,2,'Koba','382007',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(620,2,'Kolavada','382028',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(621,2,'Kotha','382735',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(622,2,'Kudasan','382421',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(623,2,'Lakroda','382835',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(624,2,'Lavad','382305',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(625,2,'Lavarpur','382355',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(626,2,'Lekawada','382042',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(627,2,'Lihoda','382315',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(628,2,'Limbodra','382721',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(629,2,'Lodra','382835',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(630,2,'Madhavgadh','382320',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(631,2,'Magodi','382355',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(632,2,'Mahudi','382855',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(633,2,'Manekpura','382845',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(634,2,'Mansa Bazar','382845',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(635,2,'Mansa (Gandhi Nagar)','382845',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(636,2,'Masang Moti','382315',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(637,2,'Mokhasan','382740',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(638,2,'Mota Jalundra','382305',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(639,2,'Motipura','382308',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(640,2,'Mubarakpura','382721',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(641,2,'Nana Jalundra','382321',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(642,2,'Nandol','382305',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(643,2,'Nardipur','382735',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(644,2,'Navanagar','382315',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(645,2,'New Sachivalaya Complex','382010',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(646,2,'Padusma','382810',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(647,2,'Palaj','382355',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(648,2,'Paliyed  (Veda)','382735',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(649,2,'Palsana','382721',1,0,'2022-03-03 12:18:49','2022-03-03 12:18:49'),(650,2,'Palundra','382308',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(651,2,'Pansar','382740',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(652,2,'Parbatpura','382845',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(653,2,'Parsa','382845',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(654,2,'Patna Kuva','382315',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(655,2,'Pethapur','382610',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(656,2,'Pindarda','382610',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(657,2,'Piplaj','382610',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(658,2,'Piyaj','382721',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(659,2,'Por','382421',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(660,2,'Prantiya','382355',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(661,2,'Pratapnagar','382845',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(662,2,'Pundhara','382855',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(663,2,'Pundrasan','382422',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(664,2,'Rakhial','382315',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(665,2,'Rakhial RS','382315',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(666,2,'Ramnagar','382721',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(667,2,'Randheja','382620',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(668,2,'Rangpur','382835',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(669,2,'Raysan','382007',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(670,2,'Ridrol','382835',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(671,2,'Rupal','382630',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(672,2,'Sadra','382320',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(673,2,'Sahebji Na  Muvada','382315',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(674,2,'Saij','382721',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(675,2,'Salki','382305',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(676,2,'Samau','382810',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(677,2,'Sametri','382315',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(678,2,'Sampa','382315',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(679,2,'Sanoda','382305',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(680,2,'Santej','382721',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(681,2,'Sardhav','382640',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(682,2,'Sargasan','382421',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(683,2,'Serisa','382721',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(684,2,'Shahpur','382355',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(685,2,'Shertha','382423',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(686,2,'Shiholi Moti','382355',1,0,'2022-03-03 12:18:50','2022-03-03 12:18:50'),(687,2,'Siawada','382308',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(688,2,'Soja','382735',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(689,2,'Solaiya','382810',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(690,2,'Thermal Power Station','382041',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(691,2,'Tintoda','382422',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(692,2,'Udan','382315',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(693,2,'Unava  Balva','382650',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(694,2,'Uvarsad','382422',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(695,2,'Vadodara','382355',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(696,2,'Vadsar Air Force','382721',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(697,2,'Vadsar','382721',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(698,2,'Vadvasa','382305',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(699,2,'Vagosana','382845',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(700,2,'Valad','382355',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(701,2,'Varsoda','382835',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(702,2,'Vasan','382650',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(703,2,'Vasna  Sogthi','382308',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(704,2,'Vasna Rathod','382305',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(705,2,'Vasnachaudhary','382321',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(706,2,'Vavol','382016',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(707,2,'Veda   (Paliyed)','382735',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(708,2,'Veda','382855',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(709,2,'Vibrant Gujarat','382010',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(710,2,'Vidhansabha','382010',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(711,2,'Vihar','382810',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(712,2,'Zundal','382421',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(713,3,'Aganwada','385555',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(714,3,'Agthala','385535',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(715,3,'Akoli','385566',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(716,3,'Alwada','385545',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(717,3,'Ambaji','385110',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(718,3,'Anapur Chhota','385545',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(719,3,'Antroli','385010',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(720,3,'Arkhi','385545',1,0,'2022-03-03 12:18:51','2022-03-03 12:18:51'),(721,3,'Asara','385575',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(722,3,'Asarada','385535',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(723,3,'Asodar','385565',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(724,3,'Badargadh','385410',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(725,3,'Badarpura','385520',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(726,3,'Baiwada','385535',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(727,3,'Baiyak','385575',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(728,3,'Balodhan','385320',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(729,3,'Balodhar','385530',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(730,3,'Balundra','385135',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(731,3,'Baluntri','385575',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(732,3,'Bamnoj','385110',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(733,3,'Bapla','385545',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(734,3,'Barwala','385320',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(735,3,'Basu','385520',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(736,3,'Bavalchudi','385210',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(737,3,'Benap','385570',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(738,3,'Bevta','385565',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(739,3,'Bhabhar','385320',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(740,3,'Bhachali','385575',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(741,3,'Bhachalva','385535',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(742,3,'Bhadath','385535',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(743,3,'Bhadli (Jhat)','385545',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(744,3,'Bhadli-kotha','385505',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(745,3,'Bhadramali','385535',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(746,3,'Bhadrewadi','385560',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(747,3,'Bhagal (J)','385001',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(748,3,'Bhagal (P)','385001',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(749,3,'Bhakhari','385120',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(750,3,'Bhakhari','385566',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(751,3,'Bhakharmoti','385510',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(752,3,'Bhakodar','385505',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(753,3,'Bhalgam','385421',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(754,3,'Bhalgam','385560',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(755,3,'Bhandotra','385545',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(756,3,'Bhanjana','385310',1,0,'2022-03-03 12:18:52','2022-03-03 12:18:52'),(757,3,'Bharadva','385570',1,0,'2022-03-03 12:18:53','2022-03-03 12:18:53'),(758,3,'Bhatamal-moti','385010',1,0,'2022-03-03 12:18:53','2022-03-03 12:18:53'),(759,3,'Bhatib','385310',1,0,'2022-03-03 12:18:53','2022-03-03 12:18:53'),(760,3,'Bhatram','385545',1,0,'2022-03-03 12:18:53','2022-03-03 12:18:53'),(761,3,'Bhatvar','385575',1,0,'2022-03-03 12:18:53','2022-03-03 12:18:53'),(762,3,'Bhesana','385330',1,0,'2022-03-03 12:18:53','2022-03-03 12:18:53'),(763,3,'Bhilachal','385505',1,0,'2022-03-03 12:18:53','2022-03-03 12:18:53'),(764,3,'Bhildi','385530',1,0,'2022-03-03 12:18:53','2022-03-03 12:18:53'),(765,3,'Bhordu','385565',1,0,'2022-03-03 12:18:53','2022-03-03 12:18:53'),(766,3,'Bhorol','385566',1,0,'2022-03-03 12:18:53','2022-03-03 12:18:53'),(767,3,'Bhoyan','385535',1,0,'2022-03-03 12:18:53','2022-03-03 12:18:53'),(768,3,'Bhutedi','385010',1,0,'2022-03-03 12:18:53','2022-03-03 12:18:53'),(769,3,'Bukna','385575',1,0,'2022-03-03 12:18:53','2022-03-03 12:18:53'),(770,3,'Bukoli','385550',1,0,'2022-03-03 12:18:53','2022-03-03 12:18:53'),(771,3,'Chadotar','385001',1,0,'2022-03-03 12:18:53','2022-03-03 12:18:53'),(772,3,'Chala','385570',1,0,'2022-03-03 12:18:53','2022-03-03 12:18:53'),(773,3,'Chalva','385535',1,0,'2022-03-03 12:18:53','2022-03-03 12:18:53'),(774,3,'Chandisar','385510',1,0,'2022-03-03 12:18:53','2022-03-03 12:18:53'),(775,3,'Changa','385555',1,0,'2022-03-03 12:18:53','2022-03-03 12:18:53'),(776,3,'Changa','385520',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(777,3,'Changda','385565',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(778,3,'Changwada','385520',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(779,3,'Charda','385565',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(780,3,'Chatra','385320',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(781,3,'Chekhala','385550',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(782,3,'Chekra','385535',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(783,3,'Chembuva','385320',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(784,3,'Chhaniyana','385410',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(785,3,'Chhapi','385210',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(786,3,'Chhatrala','385530',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(787,3,'Chibhada','385330',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(788,3,'Chitrasani','385010',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(789,3,'Chudmer','385565',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(790,3,'Chuva','385566',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(791,3,'Dabhela','385130',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(792,3,'Daiyap','385566',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(793,3,'Dalpura','385120',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(794,3,'Dalwada','385515',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(795,3,'Dalwana','385421',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(796,3,'Dangia','385510',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(797,3,'Danta Bhavangadh','385120',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(798,3,'Dantiwada','385505',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(799,3,'Dantiwada Colony','385505',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(800,3,'Dendava','385575',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(801,3,'Deodar','385330',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(802,3,'Dethli','385575',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(803,3,'Dhagadia','385110',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(804,3,'Dhakha','385310',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(805,3,'Dhanakwada','385330',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(806,3,'Dhanali','385120',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(807,3,'Dhandha','385001',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(808,3,'Dhanera','385310',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(809,3,'Dhaniawada','385545',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(810,3,'Dhanpura','385001',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(811,3,'Dharadhara','385575',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(812,3,'Dharnodhar','385310',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(813,3,'Dhima','385566',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(814,3,'Dholia','385135',1,0,'2022-03-03 12:18:54','2022-03-03 12:18:54'),(815,3,'Dhota','385421',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(816,3,'Dhrechana','385320',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(817,3,'Dhuva','385540',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(818,3,'Disa Bazar','385535',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(819,3,'Disa M.Y. Pedal','385535',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(820,3,'Disa Mukhya Dak Ghar','385535',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(821,3,'Dodgam','385565',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(822,3,'Duchakwada','385330',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(823,3,'Dudhava','385565',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(824,3,'Dugdol','385310',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(825,3,'Dungrasan','385550',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(826,3,'Duva','385310',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(827,3,'Edrana','385210',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(828,3,'Eta','385320',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(829,3,'Forna','385330',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(830,3,'Gadh','385515',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(831,3,'Gadsisar','385566',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(832,3,'Gangva','385120',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(833,3,'Garambadi','385320',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(834,3,'Gathaman','385001',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(835,3,'Ghada','385535',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(836,3,'Ghana','385310',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(837,3,'Ghodasar','385310',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(838,3,'Ghodiyal','385421',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(839,3,'Gidasan','385421',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(840,3,'Gola','385410',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(841,3,'Golgam','385575',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(842,3,'Golvi','385330',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(843,3,'Gorad','385120',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(844,3,'Gundri','385545',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(845,3,'Hadad','385110',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(846,3,'Hasanpur','385001',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(847,3,'Hathidra','385001',1,0,'2022-03-03 12:18:55','2022-03-03 12:18:55'),(848,3,'Hoda','385001',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(849,3,'Idhata','385566',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(850,3,'Iqbalgadh','385135',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(851,3,'Isarva','385555',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(852,3,'Jada','385330',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(853,3,'Jadi','385310',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(854,3,'Jadia','385310',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(855,3,'Jadiali','385310',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(856,3,'Jagana','385001',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(857,3,'Jakhel','385555',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(858,3,'Jalodha','385330',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(859,3,'Jalotra','385001',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(860,3,'Jamda','385565',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(861,3,'Jamru','385110',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(862,3,'Jasali','385330',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(863,3,'Jasanwada','385320',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(864,3,'Jasleni','385410',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(865,3,'Jaswant Gadh','385120',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(866,3,'Jegol','385505',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(867,3,'Jelana','385575',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(868,3,'Jetda','385535',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(869,3,'Jethi','385135',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(870,3,'Jhabadia','385540',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(871,3,'Jhat','385545',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(872,3,'Jherda','385535',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(873,3,'Jitpur','385120',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(874,3,'Jiwana','385310',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(875,3,'Jodhsar','385110',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(876,3,'Junadisa','385540',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(877,3,'Kakar','385550',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(878,3,'Kaleda','385421',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(879,3,'Kamali','385565',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(880,3,'Kamboi','385550',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(881,3,'Kanodar','385520',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(882,3,'Kansari','385535',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(883,3,'Kapasia','385135',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(884,3,'Kapra-mota','385535',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(885,3,'Karbun','385566',1,0,'2022-03-03 12:18:56','2022-03-03 12:18:56'),(886,3,'Karjoda','385001',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(887,3,'Kasara','385555',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(888,3,'Katarva','385535',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(889,3,'Katav','385320',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(890,3,'Khandhor (U)','385110',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(891,3,'Khardosan','385540',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(892,3,'Kharia','385555',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(893,3,'Khengarpura','385565',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(894,3,'Khentva','385530',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(895,3,'Kherola','385310',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(896,3,'Khimana','385550',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(897,3,'Khimat','385545',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(898,3,'Khoda','385565',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(899,3,'Khoda','385550',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(900,3,'Khodla','385550',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(901,3,'Khodla','385510',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(902,3,'Kidotar','385130',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(903,3,'Kodram','385421',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(904,3,'Kotarwada','385330',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(905,3,'Kotda','385535',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(906,3,'Koteshwar','385110',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(907,3,'Kuchawada','385545',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(908,3,'Kuda','385535',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(909,3,'Kukadi','385120',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(910,3,'Kumar','385545',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(911,3,'Kumbhalmer','385510',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(912,3,'Kumbharkha','385570',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(913,3,'Kumbhasan','385515',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(914,3,'Kundaliya.','385575',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(915,3,'Kundel','385120',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(916,3,'Kunvarva','385550',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(917,3,'Kushkal','385510',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(918,3,'Kuvala','385320',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(919,3,'Kuvarla','385310',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(920,3,'Kuvarshi','385120',1,0,'2022-03-03 12:18:57','2022-03-03 12:18:57'),(921,3,'Lakhani','385535',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(922,3,'Lalawada','385001',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(923,3,'Lalpur','385565',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(924,3,'Lavana','385535',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(925,3,'Lavara','385310',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(926,3,'Laxmipura','385550',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(927,3,'Limbuni','385570',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(928,3,'Lodrani','385575',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(929,3,'Lorwada','385530',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(930,3,'Ludra','385330',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(931,3,'Lunpur','385540',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(932,3,'Lunva','385001',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(933,3,'Luvana','385565',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(934,3,'Madal','385565',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(935,3,'Madana (Dangia )','385510',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(936,3,'Madana','385515',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(937,3,'Madhpura','385320',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(938,3,'Madka','385575',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(939,3,'Magarwada','385410',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(940,3,'Mahadevia','385535',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(941,3,'Mahi','385210',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(942,3,'Majadar','385210',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(943,3,'Malan','385001',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(944,3,'Malana','385001',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(945,3,'Malgadh','385535',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(946,3,'Malotra','385310',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(947,3,'Malupur','385565',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(948,3,'Mamana','385570',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(949,3,'Mandal','385545',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(950,3,'Mandla','385560',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(951,3,'Mankdi','385120',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(952,3,'Manpur','385550',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(953,3,'Manpura','385210',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(954,3,'Manpuria','385135',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(955,3,'Mavsari','385566',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(956,3,'Memadpur','385421',1,0,'2022-03-03 12:18:58','2022-03-03 12:18:58'),(957,3,'Meta','385520',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(958,3,'Mitha','385320',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(959,3,'Moria  (P)','385001',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(960,3,'Moria (N)','385120',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(961,3,'Morikha','385575',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(962,3,'Morthal','385310',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(963,3,'Morwada','385320',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(964,3,'Mota','385510',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(965,3,'Mota Mesra','385565',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(966,3,'Mota-jampur','385555',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(967,3,'Motasada','385120',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(968,3,'Moti Pavad','385565',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(969,3,'Motimahudi','385545',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(970,3,'Mudetha','385530',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(971,3,'Mumanvas','385120',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(972,3,'Nagfana','385535',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(973,3,'Nandla','385310',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(974,3,'Nandotra','385421',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(975,3,'Nani','385310',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(976,3,'Naroli','385566',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(977,3,'Nathpura','385555',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(978,3,'Navavas','385120',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(979,3,'Navisana','385421',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(980,3,'Nenava','385310',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(981,3,'Nesada-juna','385530',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(982,3,'Nokha','385330',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(983,3,'Odhava (D)','385535',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(984,3,'Odhava','385505',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(985,3,'Padan','385575',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(986,3,'Padar','385560',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(987,3,'Padardi','385550',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(988,3,'Palanpur Delhigate','385001',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(989,3,'Palanpur Ganjbazar','385001',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(990,3,'Palanpur H.O','385001',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(991,3,'Palanpur Kamalpura','385001',1,0,'2022-03-03 12:18:59','2022-03-03 12:18:59'),(992,3,'Palanpur Kirtistambh','385001',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(993,3,'Paldi','385330',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(994,3,'Panchada','385421',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(995,3,'Panchha','385110',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(996,3,'Panthawada','385545',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(997,3,'Pasvadal','385210',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(998,3,'Patosan','385515',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(999,3,'Pechhadal','385310',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1000,3,'Peplu','385530',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1001,3,'Pepol','385421',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1002,3,'Pethapur','385120',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1003,3,'Pilucha','385421',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1004,3,'Piluda','385565',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1005,3,'Pirojpura','385210',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1006,3,'Punjpur','385120',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1007,3,'Radka','385320',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1008,3,'Radosan','385570',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1009,3,'Rah','385310',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1010,3,'Raiya','385330',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1011,3,'Rajpur (D)','385535',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1012,3,'Rampura (D)','385535',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1013,3,'Rampura','385566',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1014,3,'Ramsan','385310',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1015,3,'Ranavas','385010',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1016,3,'Raner','385550',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1017,3,'Rangpur','385120',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1018,3,'Ranpur','385110',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1019,3,'Ranpur V-vas','385535',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1020,3,'Rantila','385535',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1021,3,'Rasana Mota','385535',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1022,3,'Ratanpur Lokniketan','385001',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1023,3,'Ravel','385330',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1024,3,'Raviya','385310',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1025,3,'Raviyana','385550',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1026,3,'Robas Moti','385535',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1027,3,'Runi','385320',1,0,'2022-03-03 12:19:00','2022-03-03 12:19:00'),(1028,3,'Runi','385545',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1029,3,'Rupal','385421',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1030,3,'Ruvel','385320',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1031,3,'Sadarpur','385001',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1032,3,'Saghankshetra','385010',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1033,3,'Sagrosana','385001',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1034,3,'Salla','385515',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1035,3,'Samarvada','385310',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1036,3,'Samau','385535',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1037,3,'Samdhi','385515',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1038,3,'Sanali','385110',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1039,3,'Sanavia','385565',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1040,3,'Sandhosi','385120',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1041,3,'Sangra','385001',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1042,3,'Sanval','385566',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1043,3,'Sapreda','385566',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1044,3,'Saral','385310',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1045,3,'Sardar Krishinagar','385506',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1046,3,'Sarotra','385135',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1047,3,'Sasam','385515',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1048,3,'Savapura','385566',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1049,3,'Saviyana','385535',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1050,3,'Sembal Pani','385110',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1051,3,'Semodra','385410',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1052,3,'Sendhani','385421',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1053,3,'Sherau','385566',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1054,3,'Shri Amirgadh','385130',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1055,3,'Sia','385310',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1056,3,'Sihori','385550',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1057,3,'Sisrana','385421',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1058,3,'Siya','385560',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1059,3,'Soneth','385320',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1060,3,'Soni','385330',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1061,3,'Suigam','385570',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1062,3,'Surana','385330',1,0,'2022-03-03 12:19:01','2022-03-03 12:19:01'),(1063,3,'Suthar Nesdi','385320',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1064,3,'Tadav','385566',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1065,3,'Takarwada','385520',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1066,3,'Tanvad','385320',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1067,3,'Tatiyana','385560',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1068,3,'Teniwada','385210',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1069,3,'Terwada','385320',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1070,3,'Thara','385555',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1071,3,'Tharad','385565',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1072,3,'Thavar','385310',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1073,3,'Thervada','385535',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1074,3,'Timbachudi','385210',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1075,3,'Tintoda','385535',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1076,3,'Tithgam','385575',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1077,3,'Totana','385560',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1078,3,'Uchosan','385320',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1079,3,'Ujjanwada','385320',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1080,3,'Umbari','385550',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1081,3,'Un (Banaskantha)','385560',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1082,3,'Undai','385320',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1083,3,'Undrana','385565',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1084,3,'Vachhadal','385545',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1085,3,'Vachhol','385545',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1086,3,'Vada','385555',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1087,3,'Vadgam','385410',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1088,3,'Vadgamda','385565',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1089,3,'Vadhana','385001',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1090,3,'Vagda','385001',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1091,3,'Vaghasan','385566',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1092,3,'Vaghrol','385510',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1093,3,'Vajapur Juna','385320',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1094,3,'Vakha','385330',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1095,3,'Valadar','385565',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1096,3,'Valer','385310',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1097,3,'Valpura','385560',1,0,'2022-03-03 12:19:02','2022-03-03 12:19:02'),(1098,3,'Vami','385565',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1099,3,'Vansol','385421',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1100,3,'Varasada','385320',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1101,3,'Varnoda','385535',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1102,3,'Vasan','385001',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1103,3,'Vasana Vatam','385535',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1104,3,'Vasarda','385575',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1105,3,'Vasi','385120',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1106,3,'Vasna','385540',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1107,3,'Vatam-juna','385330',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1108,3,'Vav','385575',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1109,3,'Vavdi','385575',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1110,3,'Vedancha','385510',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1111,3,'Velavapura','385535',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1112,3,'Vesa','385421',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1113,3,'Vijlasan','385120',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1114,3,'Vinchhivadi','385310',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1115,3,'Virampur','385001',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1116,3,'Viruna','385545',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1117,3,'Vithodar','385535',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1118,3,'Zalmor','385550',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1119,3,'Zenal','385310',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1120,4,'Chandrasan','382170',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1121,4,'Charol','382120',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1122,4,'Khanderaopura','382115',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1123,4,'Rancharada','382115',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1124,4,'Adraj Merda','382728',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1125,4,'Adundra','382715',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1126,4,'Aglod','382870',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1127,4,'Agol','382165',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1128,4,'Aithor','384170',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1129,4,'Akhaj','382710',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1130,4,'Aloda','384205',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1131,4,'Ambala','384210',1,0,'2022-03-03 12:19:03','2022-03-03 12:19:03'),(1132,4,'Ambaliasan','382732',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1133,4,'Ambasan','384435',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1134,4,'Ambavada','384335',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1135,4,'Amudh','384170',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1136,4,'Ankaliyara','384330',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1137,4,'Asjol','384410',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1138,4,'Badarpur','384355',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1139,4,'Balad','384325',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1140,4,'Balasar','382715',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1141,4,'Balol','384410',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1142,4,'Bamanva','384355',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1143,4,'Bamosana','384120',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1144,4,'Basana','384001',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1145,4,'Bavlu','382165',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1146,4,'Becharaji','384210',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1147,4,'Bedasma Mumanvas','384330',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1148,4,'Bhalak','384315',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1149,4,'Bhalusana','384330',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1150,4,'Bhandu','384120',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1151,4,'Bhankhar','384170',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1152,4,'Bhasaria','382732',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1153,4,'Bhatasan','382705',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1154,4,'Bhatvas','384330',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1155,4,'Bhavsor','382870',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1156,4,'Bhesana','384421',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1157,4,'Bhimpura','384330',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1158,4,'Bhunav','384130',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1159,4,'Bilia','382870',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1160,4,'Bokarwada','384120',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1161,4,'Boriavi','384435',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1162,4,'Borisana (Kadi)','382728',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1163,4,'Brahmanwada','384215',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1164,4,'Budasan','382715',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1165,4,'Butta Paldi','384120',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1166,4,'Chada','384325',1,0,'2022-03-03 12:19:04','2022-03-03 12:19:04'),(1167,4,'Chadasana','384210',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1168,4,'Chaluva','382732',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1169,4,'Chansol','384325',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1170,4,'Charadu','382730',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1171,4,'Chhabalia','384355',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1172,4,'Chhathiarda','384205',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1173,4,'Chotia','384325',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1174,4,'Dabhad','384325',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1175,4,'Dabhala','382865',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1176,4,'Dabhi','384170',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1177,4,'Dabhoda','384325',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1178,4,'Dadhial','384305',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1179,4,'Dagavadia','382830',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1180,4,'Dalisana','384325',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1181,4,'Dangarwa','382705',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1182,4,'Daran','382165',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1183,4,'Dasaj','384170',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1184,4,'Davada','384120',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1185,4,'Davol','384325',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1186,4,'Dedana','384210',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1187,4,'Dela','384001',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1188,4,'Deloli','384410',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1189,4,'Delvada (Khant)','384210',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1190,4,'Denap','384315',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1191,4,'Dethali','384210',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1192,4,'Deusana','382715',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1193,4,'Devda','382830',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1194,4,'Devpura','382870',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1195,4,'Devrasan','382710',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1196,4,'Dhamanva','384001',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1197,4,'Dhanali','382732',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1198,4,'Dharampur','382165',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1199,4,'Dharoi DSC','384360',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1200,4,'Dholasan','382732',1,0,'2022-03-03 12:19:05','2022-03-03 12:19:05'),(1201,4,'Diwanpura','384421',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1202,4,'Dodiwada','384210',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1203,4,'Falu','382870',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1204,4,'Fudeda','382860',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1205,4,'Fuletra','382728',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1206,4,'Gadha','384001',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1207,4,'Gambhu','384212',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1208,4,'Ganeshpura','382705',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1209,4,'Ganpat Vidyanagar','384012',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1210,4,'Gavada','382815',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1211,4,'Gerita Kolavda RS','382820',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1212,4,'Ghantu Dhanpura','382870',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1213,4,'Ghumasan','382705',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1214,4,'Gorad','384001',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1215,4,'Gorisana','384335',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1216,4,'Gothada','384330',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1217,4,'Gothva','384315',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1218,4,'Gozaria','382825',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1219,4,'Gundrasan','384355',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1220,4,'Gunja','384315',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1221,4,'Hadol','384360',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1222,4,'Hajipur','384170',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1223,4,'Hirpura','382870',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1224,4,'Indrad','382715',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1225,4,'Jagnathpura','384140',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1226,4,'Jagudan','382710',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1227,4,'Jakasana','384421',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1228,4,'Jantral','382860',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1229,4,'Jasalpur','382715',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1230,4,'Jaska','384315',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1231,4,'Jepur','382870',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1232,4,'Jeshangpura','382165',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1233,4,'Jetalvasana','384120',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1234,4,'Jhotana','384421',1,0,'2022-03-03 12:19:06','2022-03-03 12:19:06'),(1235,4,'Jhulasan','382705',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1236,4,'Jornang','382732',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1237,4,'Juni Sedhavi','382705',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1238,4,'Kada (Mahesana)','384305',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1239,4,'Kadi Mkt Yard','382715',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1240,4,'Kadi','382715',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1241,4,'Kahipur','384355',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1242,4,'Kahoda','384130',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1243,4,'Kaiyal','382705',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1244,4,'Kalri','384210',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1245,4,'Kalyanpura','382165',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1246,4,'Kamana','384315',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1247,4,'Kamli','384140',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1248,4,'Kanoda','384212',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1249,4,'Kansa','384315',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1250,4,'Kansarakui','384001',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1251,4,'Kanzari','382165',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1252,4,'Karannagar','382715',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1253,4,'Karbatia','384355',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1254,4,'Karjisan','382705',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1255,4,'Karli','384170',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1256,4,'Karsanpura','384335',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1257,4,'Kaswa','382715',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1258,4,'Katosan','384430',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1259,4,'Kelisana','382830',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1260,4,'Keshimpa','384325',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1261,4,'Khadalpur','384421',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1262,4,'Khambhei','384210',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1263,4,'Khandosan','384310',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1264,4,'Khanusa','382850',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1265,4,'Kharod','382840',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1266,4,'Kharvada','384305',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1267,4,'Khatoda','384355',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1268,4,'Khavad','382165',1,0,'2022-03-03 12:19:07','2022-03-03 12:19:07'),(1269,4,'Kheralu','384325',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1270,4,'Kherva','384001',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1271,4,'Khodamali','384360',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1272,4,'Kolad','382165',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1273,4,'Kot','382870',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1274,4,'Kothasana','384330',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1275,4,'Kukarwada','382830',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1276,4,'Kundal','382715',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1277,4,'Kuvasana','384315',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1278,4,'Lacjjadi','384305',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1279,4,'Ladol','382840',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1280,4,'Lakhvad','384001',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1281,4,'Langhnaj','382730',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1282,4,'Laxmipura','384315',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1283,4,'Lhor','382165',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1284,4,'Linch','384435',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1285,4,'Lunasan','382715',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1286,4,'Lunva','384130',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1287,4,'Machhava','384130',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1288,4,'Madhasana','384335',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1289,4,'Madhi','382860',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1290,4,'Magroda','384305',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1291,4,'Maguna','384410',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1292,4,'Mahervada','384130',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1293,4,'Mahesana Bazar','384001',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1294,4,'Mahesana H.O','384001',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1295,4,'Mahesana I E','384002',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1296,4,'Mahesana JSM','384001',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1297,4,'Mahesana Ongc Colony','384003',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1298,4,'Mahesana Railway Colony','384002',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1299,4,'Mahiyal','384325',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1300,4,'Maktupur','384170',1,0,'2022-03-03 12:19:08','2022-03-03 12:19:08'),(1301,4,'Malekpur (Vad)','384355',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1302,4,'Malosan','382815',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1303,4,'Mandali','382840',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1304,4,'Mandali','384130',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1305,4,'Mandropur','384325',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1306,4,'Manipur','382728',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1307,4,'Manknaj','384421',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1308,4,'Martoli','384430',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1309,4,'Mathasul','382705',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1310,4,'Medha','382165',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1311,4,'Meghaliasana','384001',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1312,4,'Meu','382730',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1313,4,'Mevad','382710',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1314,4,'Mitha','384001',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1315,4,'Modhera','384212',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1316,4,'Molipur','384355',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1317,4,'Motap','384212',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1318,4,'Moti Bhalu','384330',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1319,4,'Moti Dau','384120',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1320,4,'Moti Hirvani','384325',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1321,4,'Mudarda','384421',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1322,4,'Mulsan','382710',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1323,4,'Nadasa','384410',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1324,4,'Nagalpur','384001',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1325,4,'Nagrasan','382715',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1326,4,'Nandasan','382705',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1327,4,'Nani Kadi','382715',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1328,4,'Nanivada','384325',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1329,4,'Navasangpur','382870',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1330,4,'Nugar','384205',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1331,4,'Padharia','382865',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1332,4,'Paladi','384315',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1333,4,'Palaj','384410',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1334,4,'Palodar','384205',1,0,'2022-03-03 12:19:09','2022-03-03 12:19:09'),(1335,4,'Pamol','382820',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1336,4,'Panchot','384205',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1337,4,'Pedhamali','382870',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1338,4,'Piludra','384001',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1339,4,'Pilvai','382850',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1340,4,'Pudgam','384310',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1341,4,'Punasan','382710',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1342,4,'Rajgadh','384315',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1343,4,'Rajpur','382715',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1344,4,'Ralisana','384315',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1345,4,'Rampur (Kot)','382870',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1346,4,'Ranasan','382870',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1347,4,'Ranchhodpura','384170',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1348,4,'Ranela','384212',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1349,4,'Rangakui','384315',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1350,4,'Ransipur','382870',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1351,4,'Rantej','384410',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1352,4,'Rasulpur','384325',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1353,4,'Sabalpur','384355',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1354,4,'Sadra','382715',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1355,4,'Saduthala','384315',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1356,4,'Sagthala','384325',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1357,4,'Saldi','382730',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1358,4,'Sametra','384001',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1359,4,'Sampawada','384210',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1360,4,'Sanganpur','382710',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1361,4,'Santhal','384430',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1362,4,'Sardarpur','384340',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1363,4,'Sardarpur (Mahesana)','382860',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1364,4,'Sarsav','382715',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1365,4,'Sartanpur','384330',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1366,4,'Sarvoday Ashram','384310',1,0,'2022-03-03 12:19:10','2022-03-03 12:19:10'),(1367,4,'Satlasana','384330',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1368,4,'Savala','384001',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1369,4,'Shankhalpur','384210',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1370,4,'Sihi','384170',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1371,4,'Sipor','384335',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1372,4,'Sobhasan','384335',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1373,4,'Sobhasan','384001',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1374,4,'Sokhda','382830',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1375,4,'Sudasana','384340',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1376,4,'Sujatpura','382715',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1377,4,'Sultanpur','384355',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1378,4,'Sundarpur','382860',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1379,4,'Sundhia','384345',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1380,4,'Sunok','384170',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1381,4,'Suraj','382715',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1382,4,'Surpura','384210',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1383,4,'Tarabh','384310',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1384,4,'Tarangaji Temple','384330',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1385,4,'Tareti','384001',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1386,4,'Tatosan','382820',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1387,4,'Thol','382728',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1388,4,'Thol I E','382728',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1389,4,'Timba','384330',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1390,4,'Titodan','382865',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1391,4,'Tundali','382732',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1392,4,'Tundav','384170',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1393,4,'Udalpur','384001',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1394,4,'Umari','384340',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1395,4,'Umta','384320',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1396,4,'Unad','384335',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1397,4,'Unava','384160',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1398,4,'Undani','384355',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1399,4,'Undhai','384335',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1400,4,'Unjha Kotkuva','384170',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1401,4,'Unjha','384170',1,0,'2022-03-03 12:19:11','2022-03-03 12:19:11'),(1402,4,'Unjha Umiya Mataji','384170',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1403,4,'Untva','382715',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1404,4,'Upera','384170',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1405,4,'Vadasan','382830',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1406,4,'Vadasma','382705',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1407,4,'Vadharoda','382165',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1408,4,'Vadnagar','384355',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1409,4,'Vadosan','384001',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1410,4,'Vadu','382705',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1411,4,'Vaghawadi','384335',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1412,4,'Valam','384310',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1413,4,'Valasana','384335',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1414,4,'Vamaj','382728',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1415,4,'Vanagala','384170',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1416,4,'Varetha','384325',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1417,4,'Varvada','384215',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1418,4,'Vasai','384340',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1419,4,'Vasai Dabhala','382865',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1420,4,'Vekra','382165',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1421,4,'Venpura','384210',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1422,4,'Vidaj','382715',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1423,4,'Vijapur Bazar','382870',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1424,4,'Vijapur','382870',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1425,4,'Vijapurda','384212',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1426,4,'Virsoda','384430',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1427,4,'Virta','384001',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1428,4,'Visatpur','382715',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1429,4,'Vishol','384215',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1430,4,'Visnagar Collage(Urban)','384315',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1431,4,'Visnagar Market Yard','384315',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1432,4,'Visnagar','384315',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1433,4,'Visnagar Station Road','384315',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1434,4,'Vithoda','384325',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1435,4,'Kanthravi','384260',1,0,'2022-03-03 12:19:12','2022-03-03 12:19:12'),(1436,4,'Pali','384260',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1437,5,'Malanpur','382130',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1438,5,'Vaghada','382130',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1439,5,'Ori','360055',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1440,5,'Adalsar','382775',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1441,5,'Adariyana','382780',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1442,5,'Ajitgadh','363330',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1443,5,'Akhiyana','382745',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1444,5,'Anandpur Bhadla','363520',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1445,5,'Anandpur Bhal','363425',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1446,5,'Anindra','363110',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1447,5,'Ankevaliya','363421',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1448,5,'Bajana','382745',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1449,5,'Bajarangpura','363110',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1450,5,'Bakarthali','363040',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1451,5,'Bala','363030',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1452,5,'Baldana','363421',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1453,5,'Balol','363425',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1454,5,'Bamanbor','363520',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1455,5,'Bamanva','382765',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1456,5,'Bavli','363310',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1457,5,'Bhadena','382775',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1458,5,'Bhadreshi','363040',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1459,5,'Bhaduka','363510',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1460,5,'Bhadvana','382775',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1461,5,'Bhalgamda','363421',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1462,5,'Bharad','363320',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1463,5,'Bharada','363310',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1464,5,'Bhathan','363421',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1465,5,'Bhechda','363310',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1466,5,'Bhensjal','363410',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1467,5,'Bhoika','363421',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1468,5,'Bhojpara','363423',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1469,5,'Bhragupur','363415',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1470,5,'Borana','363410',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1471,5,'Borna','363421',1,0,'2022-03-03 12:19:13','2022-03-03 12:19:13'),(1472,5,'Bubvana','382750',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1473,5,'Chachana','363421',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1474,5,'Chachka','363410',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1475,5,'Chamaraj','363040',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1476,5,'Charadva','363330',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1477,5,'Chhalala','363415',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1478,5,'Chharad','363115',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1479,5,'Chhatriyala','363415',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1480,5,'Chikasar','382765',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1481,5,'Chiroda','363520',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1482,5,'Chobari','363520',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1483,5,'Chokdi','363410',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1484,5,'Choki','363421',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1485,5,'Chorvira','363530',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1486,5,'Chotila','363520',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1487,5,'Chuda','363410',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1488,5,'Chuli','363310',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1489,5,'Danavada','363510',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1490,5,'Dasada','382750',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1491,5,'Dedadra','363030',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1492,5,'Degam','382745',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1493,5,'Dervala','382775',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1494,5,'Devaliya','363330',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1495,5,'Devaliya','382775',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1496,5,'Devcharadi','363320',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1497,5,'Devpara','363425',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1498,5,'Devsar','363520',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1499,5,'Dhajala','363440',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1500,5,'Dhama','382755',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1501,5,'Dhanala','363351',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1502,5,'Dhandhalpur','363440',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1503,5,'Dhanki (Surendra Nagar)','363115',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1504,5,'Dharai','363520',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1505,5,'Dhavana','363330',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1506,5,'Dhokalva','363520',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1507,5,'Dholi','363320',1,0,'2022-03-03 12:19:14','2022-03-03 12:19:14'),(1508,5,'Dholi Bhal','363425',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1509,5,'Dhrangadhra','363310',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1510,5,'Dhrumath','363310',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1511,5,'Digsar','363510',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1512,5,'Doliya','363430',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1513,5,'Dudhai','363510',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1514,5,'Dudhrej','363040',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1515,5,'Dumana','363320',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1516,5,'Echhvada','382750',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1517,5,'Enjar','363330',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1518,5,'Ervada','382750',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1519,5,'Fatepur','382755',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1520,5,'Fulgram','363435',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1521,5,'Gadhad','363510',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1522,5,'Gajanvav','363310',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1523,5,'Gala','363310',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1524,5,'Gangad','363115',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1525,5,'Ganjela','363320',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1526,5,'Garambhadi','363440',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1527,5,'Gautamgadh','363510',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1528,5,'Gavana','382750',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1529,5,'Gedi','363421',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1530,5,'Gediya','382745',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1531,5,'Ghaghretiya','363427',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1532,5,'Ghanad','363110',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1533,5,'Ghanshyampur','363330',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1534,5,'Goraiya','363440',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1535,5,'Goriyavad','382765',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1536,5,'Gosal','363430',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1537,5,'Gujarvadi','363040',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1538,5,'Gunda','363520',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1539,5,'Gundiyala','363435',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1540,5,'Hadalabhal','363425',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1541,5,'Halvad','363330',1,0,'2022-03-03 12:19:15','2022-03-03 12:19:15'),(1542,5,'Hampar','363320',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1543,5,'Haripar','363310',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1544,5,'Hebatpur','363115',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1545,5,'Ingorala','363351',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1546,5,'Ingrodi','363115',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1547,5,'Isanpur','363351',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1548,5,'Jainabad','382765',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1549,5,'Jambu','363421',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1550,5,'Janivadla','363520',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1551,5,'Janshali','363425',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1552,5,'Jarvala','382765',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1553,5,'Jasapar','363510',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1554,5,'Jasmatpur','363310',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1555,5,'Jegadva','363310',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1556,5,'Jesda','363310',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1557,5,'Jiva','363310',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1558,5,'Jobala','363415',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1559,5,'Joravarnagar','363020',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1560,5,'Junajasapar','363430',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1561,5,'Kacholiya','382745',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1562,5,'Kadiyana','363330',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1563,5,'Kadu','382775',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1564,5,'Kalam','382775',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1565,5,'Kalmad','363510',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1566,5,'Kamalpar','363425',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1567,5,'Kankavati','363310',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1568,5,'Kanthariya','363410',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1569,5,'Karala','363115',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1570,5,'Karol','363410',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1571,5,'Katariya','363421',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1572,5,'Kathada','382750',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1573,5,'Katuda','363040',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1574,5,'Kavadiya','363330',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1575,5,'Khajeli','363427',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1576,5,'Khambhada','363320',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1577,5,'Khambhalav','363423',1,0,'2022-03-03 12:19:16','2022-03-03 12:19:16'),(1578,5,'Khandiya','363410',1,0,'2022-03-03 12:19:17','2022-03-03 12:19:17'),(1579,5,'Kharaghoda','382760',1,0,'2022-03-03 12:19:17','2022-03-03 12:19:17'),(1580,5,'Kharva','363030',1,0,'2022-03-03 12:19:17','2022-03-03 12:19:17'),(1581,5,'Khatdi','363510',1,0,'2022-03-03 12:19:17','2022-03-03 12:19:17'),(1582,5,'Khatdi','363520',1,0,'2022-03-03 12:19:17','2022-03-03 12:19:17'),(1583,5,'Kherali','363020',1,0,'2022-03-03 12:19:17','2022-03-03 12:19:17'),(1584,5,'Kherana','363520',1,0,'2022-03-03 12:19:17','2022-03-03 12:19:17'),(1585,5,'Kherdi','363520',1,0,'2022-03-03 12:19:17','2022-03-03 12:19:17'),(1586,5,'Kherva(Jat)','382745',1,0,'2022-03-03 12:19:17','2022-03-03 12:19:17'),(1587,5,'Khintala','363440',1,0,'2022-03-03 12:19:17','2022-03-03 12:19:17'),(1588,5,'Khodu','363040',1,0,'2022-03-03 12:19:17','2022-03-03 12:19:17'),(1589,5,'Kholadiyad','363020',1,0,'2022-03-03 12:19:17','2022-03-03 12:19:17'),(1590,5,'Kidi','363351',1,0,'2022-03-03 12:19:17','2022-03-03 12:19:17'),(1591,5,'Kondh','363310',1,0,'2022-03-03 12:19:17','2022-03-03 12:19:17'),(1592,5,'Koparani','363330',1,0,'2022-03-03 12:19:17','2022-03-03 12:19:17'),(1593,5,'Korda','363410',1,0,'2022-03-03 12:19:17','2022-03-03 12:19:17'),(1594,5,'Kothariya','363030',1,0,'2022-03-03 12:19:17','2022-03-03 12:19:17'),(1595,5,'Koyba','363330',1,0,'2022-03-03 12:19:17','2022-03-03 12:19:17'),(1596,5,'Kuda','363310',1,0,'2022-03-03 12:19:17','2022-03-03 12:19:17'),(1597,5,'Kudla','363410',1,0,'2022-03-03 12:19:17','2022-03-03 12:19:17'),(1598,5,'Kukda','363510',1,0,'2022-03-03 12:19:17','2022-03-03 12:19:17'),(1599,5,'Kuntalpur','363510',1,0,'2022-03-03 12:19:17','2022-03-03 12:19:17'),(1600,5,'Lakhtar','382775',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1601,5,'Laliyad','363410',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1602,5,'Lilapur','382775',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1603,5,'Limbdi','363421',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1604,5,'Limli','363020',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1605,5,'Liya','363510',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1606,5,'Loya','363410',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1607,5,'Malaniyad','363330',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1608,5,'Malika','363115',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1609,5,'Malod','363020',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1610,5,'Malvan','363310',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1611,5,'Malvan(Jat)','382745',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1612,5,'Mandlasar','363530',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1613,5,'Manpar','363310',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1614,5,'Mathak','363330',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1615,5,'Mayurnagar','363351',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1616,5,'Memka','363030',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1617,5,'Merupar','363330',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1618,5,'Methan','363310',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1619,5,'Minapur','363415',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1620,5,'Modhvana','363110',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1621,5,'Mojidad','363410',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1622,5,'Morthala','363530',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1623,5,'Morvad(Juni)','363410',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1624,5,'Mota Ankevaliya','363040',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1625,5,'Motamadhad','363435',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1626,5,'Motatimbla','363421',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1627,5,'Moti Moldi','363520',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1628,5,'Motimajethi','382765',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1629,5,'Mulbavla','363427',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1630,5,'Muli','363510',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1631,5,'Munjpar','363020',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1632,5,'Nadala','363440',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1633,5,'Nagadka','363410',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1634,5,'Nagadka(Jat)','382745',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1635,5,'Nagnesh','363415',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1636,5,'Nagra','363040',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1637,5,'Nagvada','382755',1,0,'2022-03-03 12:19:18','2022-03-03 12:19:18'),(1638,5,'Nana Ankevaliya','363110',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1639,5,'Nana Goraiya','382745',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1640,5,'Nana Matra','363440',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1641,5,'Nanikathechi','382775',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1642,5,'Narali','363310',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1643,5,'Narichana','363310',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1644,5,'Natvargadh','363427',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1645,5,'Nava','363520',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1646,5,'Nava Savlas','382745',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1647,5,'Navagam (S)','363440',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1648,5,'Navaghanshyamgadh','363330',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1649,5,'Navalgadh','363320',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1650,5,'Navaniya','363430',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1651,5,'Naviyani','382750',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1652,5,'Ninama','363440',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1653,5,'Noli','363440',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1654,5,'Odu','382760',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1655,5,'Olak','363115',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1656,5,'Panchvada','363520',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1657,5,'Pandavara','363510',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1658,5,'Panshina','363423',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1659,5,'Panva','382750',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1660,5,'Parali','363427',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1661,5,'Parnala','363427',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1662,5,'Patdi','382765',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1663,5,'Pedhda','363110',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1664,5,'Pipali','382745',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1665,5,'Pipaliya (Dhora)','363520',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1666,5,'Pipaliya Dhandhal','363520',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1667,5,'Piprali','363440',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1668,5,'Piyava','363520',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1669,5,'Porda','382765',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1670,5,'Pratappur','363320',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1671,5,'Rajcharadi','363320',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1672,5,'Rajpar','363030',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1673,5,'Rajpara','363520',1,0,'2022-03-03 12:19:19','2022-03-03 12:19:19'),(1674,5,'Rajsitapur','363320',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1675,5,'Ralol','363423',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1676,5,'Ramgadh','363310',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1677,5,'Rampara','363435',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1678,5,'Ranagadh','363427',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1679,5,'Ranakpur','363330',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1680,5,'Rangpur','363421',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1681,5,'Ranipat','363530',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1682,5,'Ranjitgadh','363351',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1683,5,'Ranmalpur','363330',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1684,5,'Raska','363421',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1685,5,'Ratabhe','363330',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1686,5,'Ratanpar','363020',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1687,5,'Ravaliyavadar','363040',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1688,5,'Reshamiya','363520',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1689,5,'Rojasar','363427',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1690,5,'Sadad','382775',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1691,5,'Sakar','382775',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1692,5,'Samadhiyala','363440',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1693,5,'Samla','363421',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1694,5,'Sankali','363030',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1695,5,'Sanosara','363520',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1696,5,'Sapakda','363330',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1697,5,'Sapar','363520',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1698,5,'Sara','363310',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1699,5,'Sarla','363510',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1700,5,'Sarval','363310',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1701,5,'Sauka','363421',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1702,5,'Savda','382765',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1703,5,'Savlana','382775',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1704,5,'Sayla (Surendra Nagar)','363430',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1705,5,'Sedla','382745',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1706,5,'Sejakpar','363440',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1707,5,'Shekhpar','363510',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1708,5,'Shirvaniya','363410',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1709,5,'Shiyani','363427',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1710,5,'Sidhsar','363430',1,0,'2022-03-03 12:19:20','2022-03-03 12:19:20'),(1711,5,'Sokhda','382745',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1712,5,'Soldi','363310',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1713,5,'Somasar','363510',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1714,5,'Songadh','363530',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1715,5,'Sudamada','363440',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1716,5,'Sundari','363330',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1717,5,'Surel','382780',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1718,5,'Surendranagar H.O','363001',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1719,5,'Surendranagar M.P.S.C.','363002',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1720,5,'Surendranagar Station Road','363002',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1721,5,'Surendranagar Udyognagar','363002',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1722,5,'Surendranagar Vadipara','363001',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1723,5,'Survadar','363351',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1724,5,'Sushiya','382750',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1725,5,'Susvav','363351',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1726,5,'Talsana','363427',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1727,5,'Tarmaniya','382775',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1728,5,'Tarnetar','363530',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1729,5,'Tavi','363427',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1730,5,'Thala','363310',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1731,5,'Thangadh','363530',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1732,5,'Thoriyali','363430',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1733,5,'Tikar (Ran)','363330',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1734,5,'Tikar Parmar','363510',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1735,5,'Timba','363030',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1736,5,'Tokrala','363421',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1737,5,'Tuva','363421',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1738,5,'Umarda','363510',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1739,5,'Untadi','363421',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1740,5,'Upariyala','382765',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1741,5,'Vadali','363520',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1742,5,'Vadgam','382750',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1743,5,'Vadia','363430',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1744,5,'Vadla','363030',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1745,5,'Vadod','363421',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1746,5,'Vagadiya','363530',1,0,'2022-03-03 12:19:21','2022-03-03 12:19:21'),(1747,5,'Vaghela','363030',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1748,5,'Vakhatpar','363430',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1749,5,'Vana','363110',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1750,5,'Vanala','363421',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1751,5,'Vanod','382750',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1752,5,'Varsani','363427',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1753,5,'Vastadi','363410',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1754,5,'Vavdi','363310',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1755,5,'Vegadvav','363330',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1756,5,'Velavadar','363040',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1757,5,'Vijaliya','363530',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1758,5,'Visavadi','382750',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1759,5,'Vithalgadh','363115',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1760,5,'Wadhwancity Bazar','363030',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1761,5,'Wadhwancity Ind. Estate','363035',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1762,5,'Wadhwancity','363030',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1763,5,'Zadiyana','382780',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1764,5,'Zamar','382775',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1765,5,'Zampodad','363030',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1766,5,'Zinzuda','363520',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1767,5,'Zinzuwada','382755',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1768,6,'Abiyana','385360',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1769,6,'Abluva','384285',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1770,6,'Adgam','384245',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1771,6,'Adiya','384255',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1772,6,'Aghar','384265',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1773,6,'Agichana','385360',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1774,6,'Ajimana','384265',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1775,6,'Allahabad','385340',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1776,6,'Amrapuara','384245',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1777,6,'Anawada','384265',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1778,6,'Anvarpura','384245',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1779,6,'Aritha','384240',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1780,6,'Arjansar','385340',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1781,6,'Babra','385360',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1782,6,'Balisana','384110',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1783,6,'Bamroli','385360',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1784,6,'Bandhvad','385340',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1785,6,'Baspa','384245',1,0,'2022-03-03 12:19:22','2022-03-03 12:19:22'),(1786,6,'Bepadar','384272',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1787,6,'Bhadrada','384245',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1788,6,'Bhatsan','384285',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1789,6,'Bhilot','385340',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1790,6,'Bhilvan','384285',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1791,6,'Bilia','384151',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1792,6,'Bilia','384240',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1793,6,'Bolera','384246',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1794,6,'Boratwada','384240',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1795,6,'Borsan','384275',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1796,6,'Brahmanwada','384220',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1797,6,'Chalvada','385340',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1798,6,'Chanasma','384220',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1799,6,'Chandravati','384151',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1800,6,'Chandrumana','384255',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1801,6,'Chandur Moti','384241',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1802,6,'Chandur Nani','384245',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1803,6,'Charanka','385350',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1804,6,'Charup','384285',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1805,6,'Chaveli','384225',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1806,6,'Chhamichha','384221',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1807,6,'D R.S.','385340',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1808,6,'Dadar','384245',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1809,6,'Danodarda','384225',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1810,6,'Dantisana','384246',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1811,6,'Dasawada','384265',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1812,6,'Daudpur','384245',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1813,6,'Delmal','384230',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1814,6,'Der','384110',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1815,6,'Dethli','384151',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1816,6,'Detrana','385350',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1817,6,'Dhadhana','384240',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1818,6,'Dhanawada','384265',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1819,6,'Dhanodharda','384220',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1820,6,'Dhanora','384246',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1821,6,'Dharmoda','384220',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1822,6,'Dharnoj','384265',1,0,'2022-03-03 12:19:23','2022-03-03 12:19:23'),(1823,6,'Dharpur','384265',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1824,6,'Dharusan','384285',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1825,6,'Dharvadi','385340',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1826,6,'Dhinoj','384225',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1827,6,'Dhokavada','385350',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1828,6,'Dholakda','385360',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1829,6,'Dindrol','384290',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1830,6,'Dudkha','384245',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1831,6,'Dunawada','384265',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1832,6,'Ekalva','384240',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1833,6,'Endla','384285',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1834,6,'Gadha','385360',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1835,6,'Gadsai','385360',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1836,6,'Gajdinpura','384245',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1837,6,'Gangalasan','384151',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1838,6,'Ganget','384275',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1839,6,'Ganjisar','385340',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1840,6,'Ganvada','384151',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1841,6,'Garambadi','385350',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1842,6,'Gochnath','385340',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1843,6,'Gokhantar','385360',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1844,6,'Goliwada','384272',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1845,6,'Gotarka','385360',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1846,6,'Gujarwada','384245',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1847,6,'Hansapur','384265',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1848,6,'Harij','384240',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1849,6,'Islampura','384275',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1850,6,'Itoda','384230',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1851,6,'Jakhana','384220',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1852,6,'Jakhel','385360',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1853,6,'Jakhotra','385350',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1854,6,'Jamanpur','384240',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1855,6,'Jangral','384285',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1856,6,'Jarusha','385360',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1857,6,'Jasomav','384240',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1858,6,'Jasvantpura','384240',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1859,6,'Javantri','385340',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1860,6,'Jesda','384241',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1861,6,'Jitoda','384220',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1862,6,'Juna Manka','384240',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1863,6,'Kakoshi','384290',1,0,'2022-03-03 12:19:24','2022-03-03 12:19:24'),(1864,6,'Kalyana','384265',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1865,6,'Kamalpur (D)','385340',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1866,6,'Kamalpur (S)','385340',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1867,6,'Kamboi','384230',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1868,6,'Kamliwada','384265',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1869,6,'Kani','384110',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1870,6,'Kanij','384245',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1871,6,'Kansa','384265',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1872,6,'Kathi','384240',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1873,6,'Katra (Samal)','384265',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1874,6,'Katra','384240',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1875,6,'Keshni','384225',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1876,6,'Khakhal','384240',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1877,6,'Khali','384151',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1878,6,'Khanpur Rajkuva','384255',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1879,6,'Khareda','384285',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1880,6,'Khari Ghariayal','384230',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1881,6,'Khari Vavdi','384255',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1882,6,'Khijdiyari','384241',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1883,6,'Khodana','384285',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1884,6,'Kholvada','384151',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1885,6,'Khorsam','384220',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1886,6,'Kilana','385360',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1887,6,'Kimbuva','384285',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1888,6,'Koita','384285',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1889,6,'Koliwada','385340',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1890,6,'Korda','385360',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1891,6,'Kotavad','384265',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1892,6,'Kukrana','384240',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1893,6,'Kumbhana','384240',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1894,6,'Kungher','384255',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1895,6,'Kunvar','384241',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1896,6,'Kunvarad','384241',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1897,6,'Kunwara','384265',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1898,6,'Kureja','384255',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1899,6,'Lanva','384229',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1900,6,'Laxmipura','384285',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1901,6,'Lodra','385340',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1902,6,'Lolada','384241',1,0,'2022-03-03 12:19:25','2022-03-03 12:19:25'),(1903,6,'Loteshwar','384241',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1904,6,'Lotia','385340',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1905,6,'Madhutra','385350',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1906,6,'Mandvi','384245',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1907,6,'Maniyari','384221',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1908,6,'Manund','384260',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1909,6,'Masali','385340',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1910,6,'Matpur','384275',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1911,6,'Matrota','384240',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1912,6,'Meloj','384151',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1913,6,'Memdavad','385340',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1914,6,'Memna','384241',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1915,6,'Mesar','384265',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1916,6,'Methan','384290',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1917,6,'Metrana','384290',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1918,6,'Mitha Dharva','384229',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1919,6,'Mithi Gariyal','384221',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1920,6,'Mithi Vavdi','384220',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1921,6,'Morpa','384285',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1922,6,'Mota Joravarpura','384245',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1923,6,'Moti Pipli','385340',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1924,6,'Mudana','384151',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1925,6,'Mudvada','384290',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1926,6,'Mujpur','384241',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1927,6,'Muna','384285',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1928,6,'Nagvasana','384151',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1929,6,'Nana','384240',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1930,6,'Nandotri','384151',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1931,6,'Nani Pipli','385340',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1932,6,'Nanpura','385340',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1933,6,'Nava Manka','384240',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1934,6,'Nayka','384245',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1935,6,'Nayta','384265',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1936,6,'Nedra','384151',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1937,6,'Norta','384275',1,0,'2022-03-03 12:19:26','2022-03-03 12:19:26'),(1938,6,'Odhva','384265',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1939,6,'Pachakvada','384265',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1940,6,'Padla','384246',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1941,6,'Palasar','384229',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1942,6,'Panchasar','384246',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1943,6,'Par','385350',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1944,6,'Patan City','384265',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1945,6,'Patan H N G University','384265',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1946,6,'Patan H.O','384265',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1947,6,'Patan Rajkawada','384265',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1948,6,'Patan Siddhraj Road','384265',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1949,6,'Patan Three Gate','384265',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1950,6,'Pimpal','384225',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1951,6,'Pindharpura','384229',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1952,6,'Piplana','384240',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1953,6,'Piprana','385350',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1954,6,'Radhanpur Rajgadhi','385340',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1955,6,'Radhanpur Rly Colony','385340',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1956,6,'Radhanpur','385340',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1957,6,'Rafu','384245',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1958,6,'Rajpur','384265',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1959,6,'Rampura','384265',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1960,6,'Ranavada','384245',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1961,6,'Ranod','384241',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1962,6,'Ranuj','384275',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1963,6,'Ravad','384240',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1964,6,'Ravindra','384240',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1965,6,'Raviyana','384285',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1966,6,'Roda','384240',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1967,6,'Runi','384265',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1968,6,'Ruppur','384220',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1969,6,'Ruvavi','384275',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1970,6,'Sagodiya','384265',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1971,6,'Sahesa','384290',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1972,6,'Sami','384245',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1973,6,'Samoda','384151',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1974,6,'Samoda','384275',1,0,'2022-03-03 12:19:27','2022-03-03 12:19:27'),(1975,6,'Sampra','384272',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(1976,6,'Samsherpura','384245',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(1977,6,'Sander','384275',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(1978,6,'Sankhari','384275',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(1979,6,'Sankheshwar','384246',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(1980,6,'Sankra','384255',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(1981,6,'Santalpur','385350',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(1982,6,'Santhli','385340',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(1983,6,'Sariyad','384272',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(1984,6,'Sarval','384240',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(1985,6,'Satun','385340',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(1986,6,'Sedrana','384151',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(1987,6,'Sevala','384220',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(1988,6,'Sidhada','385360',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(1989,6,'Sidhpur Jafri Baug','384151',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(1990,6,'Sidhpur Jam Chakla','384151',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(1991,6,'Sidhpur Market Yard','384151',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(1992,6,'Sidhpur','384151',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(1993,6,'Sinad','385340',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(1994,6,'Sipur','384241',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(1995,6,'Sodhav','384230',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(1996,6,'Subapura','385340',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(1997,6,'Sujnipur','384265',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(1998,6,'Sunsar','384225',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(1999,6,'Takodi','384221',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(2000,6,'Tambolia','384230',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(2001,6,'Taranagar','384241',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(2002,6,'Tarora','384240',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(2003,6,'Tavadia','384151',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(2004,6,'Tuvad','384241',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(2005,6,'Umru','384151',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(2006,6,'Undra','384272',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(2007,6,'Vadavali','384221',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(2008,6,'Vadhana','384151',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(2009,6,'Vadli','384265',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(2010,6,'Vadu','384285',1,0,'2022-03-03 12:19:28','2022-03-03 12:19:28'),(2011,6,'Vaghel','384240',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2012,6,'Vagosan','384240',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2013,6,'Vahana','384285',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2014,6,'Vahuva','385350',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2015,6,'Vamaiya','384265',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2016,6,'Vanasan','384151',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2017,6,'Vansa','384240',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2018,6,'Varahi','385360',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2019,6,'Varana','384245',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2020,6,'Varsila','384151',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2021,6,'Vasai','384275',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2022,6,'Vayad','384285',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2023,6,'Ved','384245',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2024,6,'Vejawada','384240',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2025,6,'Veloda','384272',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2026,6,'Wagdod','384285',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2027,6,'Zandala','385360',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2028,6,'Zazam','385360',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2029,6,'Zekhada','385360',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2030,6,'Zilia','3842256',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2031,6,'Zilvana','384245',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2032,7,'Abhapur','383460',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2033,7,'Ada Hathrol','383240',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2034,7,'Adhera','383250',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2035,7,'Adpodra','383276',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2036,7,'Agiol','383001',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2037,7,'Agiya','383270',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2038,7,'Ajavas','383422',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2039,7,'Akrund','383260',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2040,7,'Alwa','383325',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2041,7,'Ambabar','383246',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2042,7,'Ambagam','383325',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2043,7,'Ambaigadha','383270',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2044,7,'Ambaliara','383325',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2045,7,'Ambamahuda','383422',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2046,7,'Ambasar','383307',1,0,'2022-03-03 12:19:29','2022-03-03 12:19:29'),(2047,7,'Ambawada','383210',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2048,7,'Amiapura','383325',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2049,7,'Amlai','383315',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2050,7,'Amodara','383330',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2051,7,'Amodara','383310',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2052,7,'Amrapur','383215',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2053,7,'Androkha','383460',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2054,7,'Aniod','383305',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2055,7,'Aniyor','383345',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2056,7,'Aniyor Kampa','383345',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2057,7,'Ankala','383410',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2058,7,'Ansol','383251',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2059,7,'Antroli','383305',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2060,7,'Aroda','383110',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2061,7,'Arsodia','383225',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2062,7,'Asai','383235',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2063,7,'Atarsumba','383460',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2064,7,'Babsar','383235',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2065,7,'Badarpura','383335',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2066,7,'Badodara','383315',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2067,7,'Badodara','383305',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2068,7,'Badol','383434',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2069,7,'Badoli','383410',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2070,7,'Bahediya','383255',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2071,7,'Baleta','383462',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2072,7,'Balisana','383205',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2073,7,'Bamanvad','383250',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2074,7,'Bamna','383240',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2075,7,'Bandiyana Talav','383270',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2076,7,'Bankhor','383240',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2077,7,'Banthiwada','383350',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2078,7,'Barnoli','383335',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2079,7,'Barvav','383430',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2080,7,'Bavsar','383001',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2081,7,'Bayad','383325',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2082,7,'Bayal Dhankhrol','383316',1,0,'2022-03-03 12:19:30','2022-03-03 12:19:30'),(2083,7,'Behdaj','383350',1,0,'2022-03-03 12:19:31','2022-03-03 12:19:31'),(2084,7,'Belyo','383350',1,0,'2022-03-03 12:19:31','2022-03-03 12:19:31'),(2085,7,'Berna','383001',1,0,'2022-03-03 12:19:31','2022-03-03 12:19:31'),(2086,7,'Bhachediya','383316',1,0,'2022-03-03 12:19:31','2022-03-03 12:19:31'),(2087,7,'Bhadresar','383110',1,0,'2022-03-03 12:19:31','2022-03-03 12:19:31'),(2088,7,'Bhandval','383235',1,0,'2022-03-03 12:19:31','2022-03-03 12:19:31'),(2089,7,'Bhankhara','383460',1,0,'2022-03-03 12:19:31','2022-03-03 12:19:31'),(2090,7,'Bhanmer','383246',1,0,'2022-03-03 12:19:31','2022-03-03 12:19:31'),(2091,7,'Bhanpur','383410',1,0,'2022-03-03 12:19:31','2022-03-03 12:19:31'),(2092,7,'Bhatera','383245',1,0,'2022-03-03 12:19:31','2022-03-03 12:19:31'),(2093,7,'Bhavangadh','383430',1,0,'2022-03-03 12:19:31','2022-03-03 12:19:31'),(2094,7,'Bhavanpura Kampa','383316',1,0,'2022-03-03 12:19:31','2022-03-03 12:19:31'),(2095,7,'Bhemapur','383350',1,0,'2022-03-03 12:19:31','2022-03-03 12:19:31'),(2096,7,'Bhempoda','383335',1,0,'2022-03-03 12:19:31','2022-03-03 12:19:31'),(2097,7,'Bhensawada','383310',1,0,'2022-03-03 12:19:31','2022-03-03 12:19:31'),(2098,7,'Bherunda','383315',1,0,'2022-03-03 12:19:31','2022-03-03 12:19:31'),(2099,7,'Bhetali','383245',1,0,'2022-03-03 12:19:31','2022-03-03 12:19:31'),(2100,7,'Bhiloda Bazar','383245',1,0,'2022-03-03 12:19:31','2022-03-03 12:19:31'),(2101,7,'Bhiloda','383245',1,0,'2022-03-03 12:19:31','2022-03-03 12:19:31'),(2102,7,'Bhukhel','383325',1,0,'2022-03-03 12:19:31','2022-03-03 12:19:31'),(2103,7,'Bhundasan','383325',1,0,'2022-03-03 12:19:31','2022-03-03 12:19:31'),(2104,7,'Bhutavad','383245',1,0,'2022-03-03 12:19:31','2022-03-03 12:19:31'),(2105,7,'Bhutiya','383440',1,0,'2022-03-03 12:19:31','2022-03-03 12:19:31'),(2106,7,'Bibinivav','383325',1,0,'2022-03-03 12:19:31','2022-03-03 12:19:31'),(2107,7,'Biladia','383462',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2108,7,'Bilwania','383310',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2109,7,'Bobha','383205',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2110,7,'Bolundra (S)','383230',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2111,7,'Bolundra','383250',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2112,7,'Bolundra(R)','383421',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2113,7,'Boral','383330',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2114,7,'Bordi','383340',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2115,7,'Borditimba','383260',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2116,7,'Boria Bechraji','383215',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2117,7,'Boria (Sabarkantha)','383006',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2118,7,'Budheli','383230',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2119,7,'Budheli','383246',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2120,7,'Budhrasan','383246',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2121,7,'Butal','383310',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2122,7,'Chadasana','383110',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2123,7,'Chamthan','383246',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2124,7,'Chandap','383434',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2125,7,'Chandarni','383001',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2126,7,'Chandrana','383422',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2127,7,'Chandrej','383260',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2128,7,'Chandvasa','383460',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2129,7,'Chhabhou','383330',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2130,7,'Chhapi','383230',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2131,7,'Chiboda','383245',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2132,7,'Chikhala','383255',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2133,7,'Chitariya','383462',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2134,7,'Chithoda','383462',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2135,7,'Chitroda','383421',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2136,7,'Chitrodi','383246',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2137,7,'Choila','383325',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2138,7,'Chorimala','383246',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2139,7,'Choriwad','383440',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2140,7,'Chulla','383440',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2141,7,'Chunakhan','383245',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2142,7,'Dabha','383325',1,0,'2022-03-03 12:19:32','2022-03-03 12:19:32'),(2143,7,'Dadarda','383305',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2144,7,'Dadhalia','383317',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2145,7,'Dadhvav','383462',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2146,7,'Dahegamda','383251',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2147,7,'Dakhneshwar','383325',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2148,7,'Dalani Muvadi','383205',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2149,7,'Dalpur','383120',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2150,7,'Damavas','383275',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2151,7,'Dan Mahudi','383270',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2152,7,'Dantod','383462',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2153,7,'Dantral','383422',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2154,7,'Dantroli','383235',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2155,7,'Daramali','383110',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2156,7,'Davad','383225',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2157,7,'Davli','383320',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2158,7,'Dedhrota','383220',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2159,7,'Delwada','383255',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2160,7,'Delwada','383422',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2161,7,'Demai','383330',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2162,7,'Demti','383270',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2163,7,'Derol','383220',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2164,7,'Deroli','383330',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2165,7,'Desaipura','383330',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2166,7,'Deshotar','383230',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2167,7,'Devnimori','383355',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2168,7,'Dhamadi (Gadu)','383235',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2169,7,'Dhamania','383310',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2170,7,'Dhambolia','383355',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2171,7,'Dhandhasan','383355',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2172,7,'Dhansor','383246',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2173,7,'Dhansura','383310',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2174,7,'Dharapur','383421',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2175,7,'Dharoi','383255',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2176,7,'Dholvani','383245',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2177,7,'Dhundhar','383030',1,0,'2022-03-03 12:19:33','2022-03-03 12:19:33'),(2178,7,'Didhiya','383255',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2179,7,'Diyoli','383410',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2180,7,'Dobhada','383235',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2181,7,'Dodisara','383355',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2182,7,'Dolpur','383310',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2183,7,'Doltabad','383215',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2184,7,'Dotad','383270',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2185,7,'Dugarvada','383315',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2186,7,'Dungri','383110',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2187,7,'Eklara','383225',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2188,7,'Falasan','383230',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2189,7,'Faredi','383345',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2190,7,'Fatepur Mota','383210',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2191,7,'Finchod','383230',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2192,7,'Gabat','383335',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2193,7,'Gadha','383316',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2194,7,'Gadha','383010',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2195,7,'Gadhada','383320',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2196,7,'Gadhada Shamlaji','383270',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2197,7,'Gadhoda','383001',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2198,7,'Gadi','383462',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2199,7,'Gadu','383235',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2200,7,'Gajan','383315',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2201,7,'Gajipur','383434',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2202,7,'Gali Semro','383251',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2203,7,'Galodiya','383275',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2204,7,'Gambhirpura','383430',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2205,7,'Gambhoi','383030',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2206,7,'Ganer','383422',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2207,7,'Ganeshpur','383315',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2208,7,'Ganeshpura','383325',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2209,7,'Ganthiol','383410',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2210,7,'Ganva','383422',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2211,7,'Ghadi','383215',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2212,7,'Ghadkan','383205',1,0,'2022-03-03 12:19:34','2022-03-03 12:19:34'),(2213,7,'Golwada','383434',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2214,7,'Gora Anjana','383215',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2215,7,'Goral','383410',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2216,7,'Gota','383255',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2217,7,'Gotapur','383335',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2218,7,'Gulabpura','383434',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2219,7,'Gundel','383270',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2220,7,'Hadiol','383001',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2221,7,'Hajipur','383120',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2222,7,'Hajipura','383001',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2223,7,'Hapa','383001',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2224,7,'Harsol','383305',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2225,7,'Hatharva','383235',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2226,7,'Hathipura','383340',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2227,7,'Hathoj','383235',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2228,7,'Hathrol','383030',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2229,7,'Helodar','383345',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2230,7,'Himatnagar H.O','383001',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2231,7,'Himatnagar Station Road','383001',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2232,7,'Himatpur','383010',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2233,7,'Himmatpur','383240',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2234,7,'Hirapur','383310',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2235,7,'Hunj','383240',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2236,7,'Idar','383430',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2237,7,'Idar Town','383430',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2238,7,'Ilol','383220',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2239,7,'Indran','383340',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2240,7,'Intva','383251',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2241,7,'Iploda','383350',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2242,7,'Isari','383251',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2243,7,'Itadi','383316',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2244,7,'Itavadi','383246',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2245,7,'Jab Chitaria','383355',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2246,7,'Jadar','383110',1,0,'2022-03-03 12:19:35','2022-03-03 12:19:35'),(2247,7,'Jalampur','383340',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2248,7,'Jaleti','383462',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2249,7,'Jambudi','383001',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2250,7,'Jamla','383010',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2251,7,'Jasvantpura Kampa','383310',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2252,7,'Jayla','383246',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2253,7,'Jenpur','383205',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2254,7,'Jeshingpur','383245',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2255,7,'Jhalodar','383315',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2256,7,'Jinjudi','383246',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2257,7,'Jitpur','383325',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2258,7,'Jorajini Muvadi','383215',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2259,7,'Jumsar','383450',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2260,7,'Juna Chamu','383440',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2261,7,'Kabodara','383305',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2262,7,'Kabso','383225',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2263,7,'Kadiadra','383440',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2264,7,'Kadoli','383220',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2265,7,'Kadvadi','383350',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2266,7,'Kagda Mahuda','383251',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2267,7,'Kalikankar','383422',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2268,7,'Kaliya Kuva','383350',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2269,7,'Kalol Kampa','383275',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2270,7,'Kalvan','383440',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2271,7,'Kamalpur','383434',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2272,7,'Kamalpur','383205',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2273,7,'Kanadar','383246',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2274,7,'Kanai','383220',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2275,7,'Kanda','383220',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2276,7,'Kaniol','383010',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2277,7,'Kankrol','383001',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2278,7,'Kanpur','383450',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2279,7,'Kapoda','383010',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2280,7,'Karanpur','383030',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2281,7,'Karchha','383355',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2282,7,'Karol','383205',1,0,'2022-03-03 12:19:36','2022-03-03 12:19:36'),(2283,7,'Kasana','383350',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2284,7,'Kaswada','383345',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2285,7,'Kathvavdi','383440',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2286,7,'Katwad','383001',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2287,7,'Kau','383315',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2288,7,'Kava','383434',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2289,7,'Kelava','383460',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2290,7,'Kesharganj','383235',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2291,7,'Kesharpura','383230',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2292,7,'Khadoda','383310',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2293,7,'Khadol','383310',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2294,7,'Khalikpur','383335',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2295,7,'Khalvad','383245',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2296,7,'Khambhisar','383276',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2297,7,'Khed','383001',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2298,7,'Khedavada','383220',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2299,7,'Khedbrahma','383255',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2300,7,'Khedva','383255',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2301,7,'Kheradi','383250',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2302,7,'Kherancha','383355',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2303,7,'Khergadh','383275',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2304,7,'Kheroj','383270',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2305,7,'Kherol','383215',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2306,7,'Khiloda','383250',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2307,7,'Khilodia','383307',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2308,7,'Kidi','383310',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2309,7,'Kishangadh','383450',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2310,7,'Kodiawada','383462',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2311,7,'Kolikhad','383315',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2312,7,'Kolundra','383350',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2313,7,'Kolvada','383310',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2314,7,'Kotda','383422',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2315,7,'Kotda Nana','383110',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2316,7,'Kuba Dharol','383235',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2317,7,'Kudol','383250',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2318,7,'Kukadia','383410',1,0,'2022-03-03 12:19:37','2022-03-03 12:19:37'),(2319,7,'Kundol Pal','383246',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2320,7,'Kunol','383350',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2321,7,'Kushki','383250',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2322,7,'Lalinomath','383307',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2323,7,'Laloda','383430',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2324,7,'Lalpur','383410',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2325,7,'Lalpur','383350',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2326,7,'Lambadiya','383270',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2327,7,'Lank','383330',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2328,7,'Lavari','383305',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2329,7,'Laxmipura (Sabarkantha)','383275',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2330,7,'Lei','383430',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2331,7,'Likhi','383010',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2332,7,'Lilchha','383245',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2333,7,'Limb','383325',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2334,7,'Limbhoi','383430',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2335,7,'Limbhoi','383316',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2336,7,'Limbodara','383350',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2337,7,'Limda','383462',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2338,7,'Lolasan','383010',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2339,7,'Lusadia','383251',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2340,7,'Madapur Kampa','383315',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2341,7,'Madhavgadh','383330',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2342,7,'Madhavgadh','383305',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2343,7,'Magodi','383335',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2344,7,'Mahadevgram','383317',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2345,7,'Mahadevpura','383210',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2346,7,'Mahadevpura Kampa','383315',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2347,7,'Mahiyal','383215',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2348,7,'Mahiyapur','383345',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2349,7,'Mahor','383235',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2350,7,'Majra','383205',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2351,7,'Malasa','383450',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2352,7,'Malpur','383345',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2353,7,'Mangadh','383110',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2354,7,'Mangalpur','383345',1,0,'2022-03-03 12:19:38','2022-03-03 12:19:38'),(2355,7,'Maniyor','383230',1,0,'2022-03-03 12:19:39','2022-03-03 12:19:39'),(2356,7,'Mankdi','383240',1,0,'2022-03-03 12:19:39','2022-03-03 12:19:39'),(2357,7,'Manorpur','383030',1,0,'2022-03-03 12:19:39','2022-03-03 12:19:39'),(2358,7,'Masal','383230',1,0,'2022-03-03 12:19:39','2022-03-03 12:19:39'),(2359,7,'Masota','383246',1,0,'2022-03-03 12:19:39','2022-03-03 12:19:39'),(2360,7,'Mathasulia','383276',1,0,'2022-03-03 12:19:39','2022-03-03 12:19:39'),(2361,7,'Mathasur','383430',1,0,'2022-03-03 12:19:39','2022-03-03 12:19:39'),(2362,7,'Matoda','383270',1,0,'2022-03-03 12:19:39','2022-03-03 12:19:39'),(2363,7,'Mau Bhavnath','383245',1,0,'2022-03-03 12:19:39','2022-03-03 12:19:39'),(2364,7,'Mauchha','383210',1,0,'2022-03-03 12:19:39','2022-03-03 12:19:39'),(2365,7,'Medh','383235',1,0,'2022-03-03 12:19:39','2022-03-03 12:19:39'),(2366,7,'Medhasan','383276',1,0,'2022-03-03 12:19:39','2022-03-03 12:19:39'),(2367,7,'Meditimba','383240',1,0,'2022-03-03 12:19:39','2022-03-03 12:19:39'),(2368,7,'Meghraj','383350',1,0,'2022-03-03 12:19:39','2022-03-03 12:19:39'),(2369,7,'Mehru','383245',1,0,'2022-03-03 12:19:39','2022-03-03 12:19:39'),(2370,7,'Mehtapura','383001',1,0,'2022-03-03 12:19:39','2022-03-03 12:19:39'),(2371,7,'Mesan','383450',1,0,'2022-03-03 12:19:39','2022-03-03 12:19:39'),(2372,7,'Mevda','383315',1,0,'2022-03-03 12:19:40','2022-03-03 12:19:40'),(2373,7,'Modasa Bazar','383315',1,0,'2022-03-03 12:19:40','2022-03-03 12:19:40'),(2374,7,'Modasa','383315',1,0,'2022-03-03 12:19:40','2022-03-03 12:19:40'),(2375,7,'Modhuka','383305',1,0,'2022-03-03 12:19:40','2022-03-03 12:19:40'),(2376,7,'Mohanpur','383305',1,0,'2022-03-03 12:19:40','2022-03-03 12:19:40'),(2377,7,'Mota Baval','383270',1,0,'2022-03-03 12:19:40','2022-03-03 12:19:40'),(2378,7,'Mota Chekhla','383305',1,0,'2022-03-03 12:19:40','2022-03-03 12:19:40'),(2379,7,'Mota Kantharia','383251',1,0,'2022-03-03 12:19:40','2022-03-03 12:19:40'),(2380,7,'Mota Kotda','383421',1,0,'2022-03-03 12:19:40','2022-03-03 12:19:40'),(2381,7,'Motesari','383305',1,0,'2022-03-03 12:19:40','2022-03-03 12:19:40'),(2382,7,'Moti Bebar','383250',1,0,'2022-03-03 12:19:40','2022-03-03 12:19:40'),(2383,7,'Moti Chinchano','383316',1,0,'2022-03-03 12:19:40','2022-03-03 12:19:40'),(2384,7,'Moti Isrol','383317',1,0,'2022-03-03 12:19:40','2022-03-03 12:19:40'),(2385,7,'Moti Mori','383350',1,0,'2022-03-03 12:19:40','2022-03-03 12:19:40'),(2386,7,'Moti Moydi','383350',1,0,'2022-03-03 12:19:40','2022-03-03 12:19:40'),(2387,7,'Moti Panduri','383350',1,0,'2022-03-03 12:19:40','2022-03-03 12:19:40'),(2388,7,'Moyad','383120',1,0,'2022-03-03 12:19:40','2022-03-03 12:19:40'),(2389,7,'Mudeti','383450',1,0,'2022-03-03 12:19:40','2022-03-03 12:19:40'),(2390,7,'Mudhasana','383215',1,0,'2022-03-03 12:19:41','2022-03-03 12:19:41'),(2391,7,'Muloj','383315',1,0,'2022-03-03 12:19:41','2022-03-03 12:19:41'),(2392,7,'Munai','383450',1,0,'2022-03-03 12:19:41','2022-03-03 12:19:41'),(2393,7,'Nada','383270',1,0,'2022-03-03 12:19:41','2022-03-03 12:19:41'),(2394,7,'Nadri','383235',1,0,'2022-03-03 12:19:41','2022-03-03 12:19:41'),(2395,7,'Nalseri','383460',1,0,'2022-03-03 12:19:41','2022-03-03 12:19:41'),(2396,7,'Nana Chekhla','383305',1,0,'2022-03-03 12:19:41','2022-03-03 12:19:41'),(2397,7,'Nana Sembalia','383270',1,0,'2022-03-03 12:19:41','2022-03-03 12:19:41'),(2398,7,'Nananpur','383210',1,0,'2022-03-03 12:19:41','2022-03-03 12:19:41'),(2399,7,'Nanawada','383345',1,0,'2022-03-03 12:19:41','2022-03-03 12:19:41'),(2400,7,'Nandisan','383250',1,0,'2022-03-03 12:19:41','2022-03-03 12:19:41'),(2401,7,'Nandoj','383245',1,0,'2022-03-03 12:19:41','2022-03-03 12:19:41'),(2402,7,'Nankhi','383450',1,0,'2022-03-03 12:19:41','2022-03-03 12:19:41'),(2403,7,'Napda','383355',1,0,'2022-03-03 12:19:41','2022-03-03 12:19:41'),(2404,7,'Naranpura Kampa','383310',1,0,'2022-03-03 12:19:41','2022-03-03 12:19:41'),(2405,7,'Narsoli','383245',1,0,'2022-03-03 12:19:41','2022-03-03 12:19:41'),(2406,7,'Nathavas','383315',1,0,'2022-03-03 12:19:41','2022-03-03 12:19:41'),(2407,7,'Nava','383305',1,0,'2022-03-03 12:19:41','2022-03-03 12:19:41'),(2408,7,'Nava','383001',1,0,'2022-03-03 12:19:42','2022-03-03 12:19:42'),(2409,7,'Nava Bhavnath','383245',1,0,'2022-03-03 12:19:42','2022-03-03 12:19:42'),(2410,7,'Nava Mota','383270',1,0,'2022-03-03 12:19:42','2022-03-03 12:19:42'),(2411,7,'Nava Revas','383450',1,0,'2022-03-03 12:19:42','2022-03-03 12:19:42'),(2412,7,'Navagam (Dhanela)','383460',1,0,'2022-03-03 12:19:42','2022-03-03 12:19:42'),(2413,7,'Navagam(Isri)','383251',1,0,'2022-03-03 12:19:42','2022-03-03 12:19:42'),(2414,7,'Navalpur','383001',1,0,'2022-03-03 12:19:42','2022-03-03 12:19:42'),(2415,7,'Navanagar','383220',1,0,'2022-03-03 12:19:42','2022-03-03 12:19:42'),(2416,7,'Navi Metral','383255',1,0,'2022-03-03 12:19:42','2022-03-03 12:19:42'),(2417,7,'Navi Shinol','383310',1,0,'2022-03-03 12:19:42','2022-03-03 12:19:42'),(2418,7,'Netramali','383430',1,0,'2022-03-03 12:19:42','2022-03-03 12:19:42'),(2419,7,'Nichi Dhanal','383255',1,0,'2022-03-03 12:19:42','2022-03-03 12:19:42'),(2420,7,'Nikoda','383210',1,0,'2022-03-03 12:19:42','2022-03-03 12:19:42'),(2421,7,'Oda','383230',1,0,'2022-03-03 12:19:42','2022-03-03 12:19:42'),(2422,7,'Ode','383355',1,0,'2022-03-03 12:19:42','2022-03-03 12:19:42'),(2423,7,'Odha','383340',1,0,'2022-03-03 12:19:42','2022-03-03 12:19:42'),(2424,7,'Oran','383205',1,0,'2022-03-03 12:19:43','2022-03-03 12:19:43'),(2425,7,'Padardi','383255',1,0,'2022-03-03 12:19:43','2022-03-03 12:19:43'),(2426,7,'Padela','383460',1,0,'2022-03-03 12:19:43','2022-03-03 12:19:43'),(2427,7,'Padhara','383255',1,0,'2022-03-03 12:19:43','2022-03-03 12:19:43'),(2428,7,'Padusan','383305',1,0,'2022-03-03 12:19:43','2022-03-03 12:19:43'),(2429,7,'Pahadpur','383315',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2430,7,'Pal','383462',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2431,7,'Palla','383355',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2432,7,'Pallachar','383205',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2433,7,'Panch Mahuda','383270',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2434,7,'Panch Mahudi','383355',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2435,7,'Panchal','383350',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2436,7,'Panibar','383251',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2437,7,'Panol','383430',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2438,7,'Parosada','383460',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2439,7,'Paroya','383255',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2440,7,'Patadiya','383270',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2441,7,'Patelna Dhundha','383350',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2442,7,'Pedhmala','383030',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2443,7,'Petachhapra','383422',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2444,7,'Pethapur','383225',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2445,7,'Piludra','383120',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2446,7,'Pipliya','383422',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2447,7,'Pipodara','383325',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2448,7,'Piprana','383345',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2449,7,'Poglu','383205',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2450,7,'Poshina','383421',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2451,7,'Poshina','383422',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2452,7,'Poyda','383215',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2453,7,'Prantij','383205',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2454,7,'Pratapgadh Kampa','383440',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2455,7,'Pratappura','383430',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2456,7,'Prempur','383225',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2457,7,'Punasan','383240',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2458,7,'Punsari','383307',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2459,7,'Pural','383001',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2460,7,'Radhiwad','383270',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2461,7,'Radodara','383325',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2462,7,'Raheda','383235',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2463,7,'Raigadh','383276',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2464,7,'Raipur','383245',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2465,7,'Raisingpur','383246',1,0,'2022-03-03 12:19:44','2022-03-03 12:19:44'),(2466,7,'Rajendranagar','383276',1,0,'2022-03-03 12:19:45','2022-03-03 12:19:45'),(2467,7,'Rajpur','383307',1,0,'2022-03-03 12:19:45','2022-03-03 12:19:45'),(2468,7,'Rajpur','383010',1,0,'2022-03-03 12:19:45','2022-03-03 12:19:45'),(2469,7,'Rajpur','383460',1,0,'2022-03-03 12:19:45','2022-03-03 12:19:45'),(2470,7,'Rakhiyal','383276',1,0,'2022-03-03 12:19:45','2022-03-03 12:19:45'),(2471,7,'Ramana','383315',1,0,'2022-03-03 12:19:45','2022-03-03 12:19:45'),(2472,7,'Rambhoda','383345',1,0,'2022-03-03 12:19:45','2022-03-03 12:19:45'),(2473,7,'Ramgadhi','383350',1,0,'2022-03-03 12:19:45','2022-03-03 12:19:45'),(2474,7,'Ramos','383316',1,0,'2022-03-03 12:19:45','2022-03-03 12:19:45'),(2475,7,'Ramos','383325',1,0,'2022-03-03 12:19:45','2022-03-03 12:19:45'),(2476,7,'Rampur (A)','383210',1,0,'2022-03-03 12:19:45','2022-03-03 12:19:45'),(2477,7,'Rampur (Fudeda)','383434',1,0,'2022-03-03 12:19:46','2022-03-03 12:19:46'),(2478,7,'Rampura Kampa','383260',1,0,'2022-03-03 12:19:46','2022-03-03 12:19:46'),(2479,7,'Rampura Kampa','383330',1,0,'2022-03-03 12:19:46','2022-03-03 12:19:46'),(2480,7,'Rampuri','383246',1,0,'2022-03-03 12:19:46','2022-03-03 12:19:46'),(2481,7,'Ranasan','383305',1,0,'2022-03-03 12:19:46','2022-03-03 12:19:46'),(2482,7,'Ranechi','383325',1,0,'2022-03-03 12:19:46','2022-03-03 12:19:46'),(2483,7,'Ranipura','383307',1,0,'2022-03-03 12:19:46','2022-03-03 12:19:46'),(2484,7,'Ratanpur','383430',1,0,'2022-03-03 12:19:46','2022-03-03 12:19:46'),(2485,7,'Ratanpur','383270',1,0,'2022-03-03 12:19:47','2022-03-03 12:19:47'),(2486,7,'Ravol','383434',1,0,'2022-03-03 12:19:47','2022-03-03 12:19:47'),(2487,7,'Rayawada','383350',1,0,'2022-03-03 12:19:47','2022-03-03 12:19:47'),(2488,7,'Rellawada','383251',1,0,'2022-03-03 12:19:47','2022-03-03 12:19:47'),(2489,7,'Relyo','383350',1,0,'2022-03-03 12:19:47','2022-03-03 12:19:47'),(2490,7,'Rinchvad','383315',1,0,'2022-03-03 12:19:47','2022-03-03 12:19:47'),(2491,7,'Rudardi','383110',1,0,'2022-03-03 12:19:47','2022-03-03 12:19:47'),(2492,7,'Rupal','383030',1,0,'2022-03-03 12:19:47','2022-03-03 12:19:47'),(2493,7,'Sabalwad','383430',1,0,'2022-03-03 12:19:47','2022-03-03 12:19:47'),(2494,7,'Sabli','383421',1,0,'2022-03-03 12:19:47','2022-03-03 12:19:47'),(2495,7,'Sachodar','383110',1,0,'2022-03-03 12:19:47','2022-03-03 12:19:47'),(2496,7,'Sadha','383030',1,0,'2022-03-03 12:19:47','2022-03-03 12:19:47'),(2497,7,'Sagpur','383307',1,0,'2022-03-03 12:19:47','2022-03-03 12:19:47'),(2498,7,'Sahebapura','383001',1,0,'2022-03-03 12:19:47','2022-03-03 12:19:47'),(2499,7,'Sakariya','383315',1,0,'2022-03-03 12:19:47','2022-03-03 12:19:47'),(2500,7,'Salal','383120',1,0,'2022-03-03 12:19:47','2022-03-03 12:19:47'),(2501,7,'Salatpur','383215',1,0,'2022-03-03 12:19:47','2022-03-03 12:19:47'),(2502,7,'Salera','383422',1,0,'2022-03-03 12:19:47','2022-03-03 12:19:47'),(2503,7,'Sampad','383120',1,0,'2022-03-03 12:19:47','2022-03-03 12:19:47'),(2504,7,'Sapawada','383430',1,0,'2022-03-03 12:19:47','2022-03-03 12:19:47'),(2505,7,'Sardoi','383320',1,0,'2022-03-03 12:19:48','2022-03-03 12:19:48'),(2506,7,'Saroli','383460',1,0,'2022-03-03 12:19:48','2022-03-03 12:19:48'),(2507,7,'Sarsav','383460',1,0,'2022-03-03 12:19:48','2022-03-03 12:19:48'),(2508,7,'Sarsoli','383335',1,0,'2022-03-03 12:19:48','2022-03-03 12:19:48'),(2509,7,'Sarvoday Kendra','383355',1,0,'2022-03-03 12:19:48','2022-03-03 12:19:48'),(2510,7,'Satarda','383345',1,0,'2022-03-03 12:19:48','2022-03-03 12:19:48'),(2511,7,'Sathamba','383340',1,0,'2022-03-03 12:19:48','2022-03-03 12:19:48'),(2512,7,'Savela','383340',1,0,'2022-03-03 12:19:48','2022-03-03 12:19:48'),(2513,7,'Savgadh','383001',1,0,'2022-03-03 12:19:48','2022-03-03 12:19:48'),(2514,7,'Sayra','383315',1,0,'2022-03-03 12:19:48','2022-03-03 12:19:48'),(2515,7,'Semalia','383215',1,0,'2022-03-03 12:19:48','2022-03-03 12:19:48'),(2516,7,'Sembalia (Poshina)','383422',1,0,'2022-03-03 12:19:48','2022-03-03 12:19:48'),(2517,7,'Shamlaji','383355',1,0,'2022-03-03 12:19:48','2022-03-03 12:19:48'),(2518,7,'Shampur','383320',1,0,'2022-03-03 12:19:48','2022-03-03 12:19:48'),(2519,7,'Shangal','383350',1,0,'2022-03-03 12:19:48','2022-03-03 12:19:48'),(2520,7,'Shantipura','383310',1,0,'2022-03-03 12:19:48','2022-03-03 12:19:48'),(2521,7,'Sherpur','383410',1,0,'2022-03-03 12:19:48','2022-03-03 12:19:48'),(2522,7,'Shinavad','383315',1,0,'2022-03-03 12:19:48','2022-03-03 12:19:48'),(2523,7,'Shinol','383310',1,0,'2022-03-03 12:19:49','2022-03-03 12:19:49'),(2524,7,'Shravana','383030',1,0,'2022-03-03 12:19:49','2022-03-03 12:19:49'),(2525,7,'Sika','383310',1,0,'2022-03-03 12:19:49','2022-03-03 12:19:49'),(2526,7,'Singa','383225',1,0,'2022-03-03 12:19:49','2022-03-03 12:19:49'),(2527,7,'Sisodara (A)','383350',1,0,'2022-03-03 12:19:49','2022-03-03 12:19:49'),(2528,7,'Sitol','383255',1,0,'2022-03-03 12:19:49','2022-03-03 12:19:49'),(2529,7,'Sitwada','383205',1,0,'2022-03-03 12:19:49','2022-03-03 12:19:49'),(2530,7,'Siyasan','383450',1,0,'2022-03-03 12:19:49','2022-03-03 12:19:49'),(2531,7,'Sonasan','383210',1,0,'2022-03-03 12:19:49','2022-03-03 12:19:49'),(2532,7,'Sunokh','383250',1,0,'2022-03-03 12:19:49','2022-03-03 12:19:49'),(2533,7,'Sunsar','383450',1,0,'2022-03-03 12:19:49','2022-03-03 12:19:49'),(2534,7,'Surpur','383430',1,0,'2022-03-03 12:19:49','2022-03-03 12:19:49'),(2535,7,'Tadhivedi','383422',1,0,'2022-03-03 12:19:49','2022-03-03 12:19:49'),(2536,7,'Tajpur (Camp)','383305',1,0,'2022-03-03 12:19:49','2022-03-03 12:19:49'),(2537,7,'Tajpur','383205',1,0,'2022-03-03 12:19:49','2022-03-03 12:19:49'),(2538,7,'Tajpuri','383001',1,0,'2022-03-03 12:19:49','2022-03-03 12:19:49'),(2539,7,'Takatuka','383246',1,0,'2022-03-03 12:19:50','2022-03-03 12:19:50'),(2540,7,'Takhatgadh','383210',1,0,'2022-03-03 12:19:50','2022-03-03 12:19:50'),(2541,7,'Talod','383340',1,0,'2022-03-03 12:19:50','2022-03-03 12:19:50'),(2542,7,'Talod M Y','383215',1,0,'2022-03-03 12:19:50','2022-03-03 12:19:50'),(2543,7,'Talod','383215',1,0,'2022-03-03 12:19:50','2022-03-03 12:19:50'),(2544,7,'Tandaliya','383275',1,0,'2022-03-03 12:19:50','2022-03-03 12:19:50'),(2545,7,'Tembada','383270',1,0,'2022-03-03 12:19:50','2022-03-03 12:19:50'),(2546,7,'Tenpur','383325',1,0,'2022-03-03 12:19:50','2022-03-03 12:19:50'),(2547,7,'Therasana','383235',1,0,'2022-03-03 12:19:50','2022-03-03 12:19:50'),(2548,7,'Tintoi','383250',1,0,'2022-03-03 12:19:50','2022-03-03 12:19:50'),(2549,7,'Torda','383246',1,0,'2022-03-03 12:19:50','2022-03-03 12:19:50'),(2550,7,'Tunadar','383335',1,0,'2022-03-03 12:19:50','2022-03-03 12:19:50'),(2551,7,'Ubharan','383335',1,0,'2022-03-03 12:19:50','2022-03-03 12:19:50'),(2552,7,'Ubsal','383246',1,0,'2022-03-03 12:19:50','2022-03-03 12:19:50'),(2553,7,'Ujedia','383215',1,0,'2022-03-03 12:19:50','2022-03-03 12:19:50'),(2554,7,'Ujleshvar','383310',1,0,'2022-03-03 12:19:50','2022-03-03 12:19:50'),(2555,7,'Ukhala Dungri','383460',1,0,'2022-03-03 12:19:50','2022-03-03 12:19:50'),(2556,7,'Umedgadh','383230',1,0,'2022-03-03 12:19:50','2022-03-03 12:19:50'),(2557,7,'Umedpura','383430',1,0,'2022-03-03 12:19:50','2022-03-03 12:19:50'),(2558,7,'Unchha','383205',1,0,'2022-03-03 12:19:51','2022-03-03 12:19:51'),(2559,7,'Unchi Dhanal','383270',1,0,'2022-03-03 12:19:51','2022-03-03 12:19:51'),(2560,7,'Undava','383350',1,0,'2022-03-03 12:19:51','2022-03-03 12:19:51'),(2561,7,'Untarda','383325',1,0,'2022-03-03 12:19:51','2022-03-03 12:19:51'),(2562,7,'Vadagam','383307',1,0,'2022-03-03 12:19:51','2022-03-03 12:19:51'),(2563,7,'Vadali (Sabarkantha)','383235',1,0,'2022-03-03 12:19:51','2022-03-03 12:19:51'),(2564,7,'Vadoth','383235',1,0,'2022-03-03 12:19:51','2022-03-03 12:19:51'),(2565,7,'Vadrad','383205',1,0,'2022-03-03 12:19:51','2022-03-03 12:19:51'),(2566,7,'Vadvasa','383205',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2567,7,'Vagdi','383276',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2568,7,'Vaghela Derol','383275',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2569,7,'Vagheswari','383450',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2570,7,'Vaghpur','383251',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2571,7,'Vaghpur','383205',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2572,7,'Vaghpur','383350',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2573,7,'Vaghrota','383210',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2574,7,'Vaktapur','383010',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2575,7,'Valaran','383255',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2576,7,'Valiampura','383215',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2577,7,'Valuna','383350',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2578,7,'Vandhiyol','383250',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2579,7,'Vandhol','383460',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2580,7,'Vaniad Kokapur','383315',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2581,7,'Vaniawada','383350',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2582,7,'Vankaneda','383335',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2583,7,'Vankaner','383245',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2584,7,'Vankda','383462',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2585,7,'Vantda Bayad','383325',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2586,7,'Vanzar','383250',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2587,7,'Varthu','383317',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2588,7,'Vartol','383255',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2589,7,'Varvada','383305',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2590,7,'Vasai','383460',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2591,7,'Vasai','383450',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2592,7,'Vasan','383235',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2593,7,'Vasana','383255',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2594,7,'Vasna','383350',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2595,7,'Vasnirel','383325',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2596,7,'Vatrakgadh','383260',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2597,7,'Vavdi','383345',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2598,7,'Vavdi','383030',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2599,7,'Vejpur','383245',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2600,7,'Verabar','383434',1,0,'2022-03-03 12:19:52','2022-03-03 12:19:52'),(2601,7,'Vijaynagar','383460',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2602,7,'Vinchhi','383422',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2603,7,'Viravada','383001',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2604,7,'Virpur','383230',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2605,7,'Virpur','383246',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2606,7,'Virpur','383010',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2607,7,'Vishwamangalam','383001',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2608,7,'Zanzva Panai','383255',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2609,7,'Zarda','383350',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2610,7,'Zinzva','383210',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2611,8,'Abhrampara','364522',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2612,8,'Adsang','364522',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2613,8,'Adtala','365430',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2614,8,'Akala','365430',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2615,8,'Amarpur','365450',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2616,8,'Amba','365535',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2617,8,'Ambaradi','365630',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2618,8,'Ambardi','365220',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2619,8,'Ambardi J','364522',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2620,8,'Amreli H.O','365601',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2621,8,'Amreli J P','365601',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2622,8,'Amreli M P','365601',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2623,8,'Amreli S R','365601',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2624,8,'Amreli T.R','365601',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2625,8,'Amrpur V','365601',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2626,8,'Amrutpur','365660',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2627,8,'Amrutvel','364521',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2628,8,'Anida','365635',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2629,8,'Anida','365450',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2630,8,'Ankadia-nana','365620',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2631,8,'Ansodar','365220',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2632,8,'Arjansukh','365480',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2633,8,'Babapur','365610',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2634,8,'Babarkot','365540',1,0,'2022-03-03 12:19:53','2022-03-03 12:19:53'),(2635,8,'Babra (Amreli)','365421',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2636,8,'Babriyadhar','365560',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2637,8,'Badhada','364522',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2638,8,'Bagasara S.R.','365440',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2639,8,'Bagasra','365440',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2640,8,'Bagoya','364522',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2641,8,'Balapur','365456',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2642,8,'Balel-piparia','365460',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2643,8,'Bambhaniya','365460',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2644,8,'Bantva-devli','365480',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2645,8,'Barbtana','365560',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2646,8,'Barman-nana','365545',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2647,8,'Barpatoli','365560',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2648,8,'Barvala-baval','365480',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2649,8,'Barvala-bavishi','365450',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2650,8,'Barwala Jam','365435',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2651,8,'Bavada','365565',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2652,8,'Bhad','365650',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2653,8,'Bhada','362730',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2654,8,'Bhader','365645',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2655,8,'Bhalgam','365440',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2656,8,'Bhalvav','365220',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2657,8,'Bhamar','364530',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2658,8,'Bhandaria Nana','365601',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2659,8,'Bhandriya Mota','365610',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2660,8,'Bhattvadar','365220',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2661,8,'Bhavrdi','365650',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2662,8,'Bhayavadar','365450',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2663,8,'Bherai','365560',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2664,8,'Bhesvadi','365535',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2665,8,'Bhingrad','365220',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2666,8,'Bhmodra-mota','364525',1,0,'2022-03-03 12:19:54','2022-03-03 12:19:54'),(2667,8,'Bhriangda','365565',1,0,'2022-03-03 12:19:55','2022-03-03 12:19:55'),(2668,8,'Bhurakhiya','365220',1,0,'2022-03-03 12:19:55','2022-03-03 12:19:55'),(2669,8,'Bhuva','364521',1,0,'2022-03-03 12:19:55','2022-03-03 12:19:55'),(2670,8,'Borala','364521',1,0,'2022-03-03 12:19:55','2022-03-03 12:19:55'),(2671,8,'Borala','365650',1,0,'2022-03-03 12:19:55','2022-03-03 12:19:55'),(2672,8,'Bordi','365640',1,0,'2022-03-03 12:19:55','2022-03-03 12:19:55'),(2673,8,'Chadiya','365630',1,0,'2022-03-03 12:19:55','2022-03-03 12:19:55'),(2674,8,'Chakkargadh','365601',1,0,'2022-03-03 12:19:55','2022-03-03 12:19:55'),(2675,8,'Chalala','365630',1,0,'2022-03-03 12:19:55','2022-03-03 12:19:55'),(2676,8,'Chamaradi','365410',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2677,8,'Chanch','365555',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2678,8,'Chandgadh','365601',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2679,8,'Charakhadiya','364515',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2680,8,'Charkha','365421',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2681,8,'Charkha','365630',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2682,8,'Chavand','365435',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2683,8,'Chhabhadiya','365220',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2684,8,'Chhatadiya','365630',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2685,8,'Chikhali','364530',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2686,8,'Chital','365620',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2687,8,'Dadali','365550',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2688,8,'Dadva(Randal)','365460',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2689,8,'Dalkhaniya','365640',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2690,8,'Damnagar','365220',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2691,8,'Dangavadar','365640',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2692,8,'Dantardi','365555',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2693,8,'Dared','365435',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2694,8,'Dedakadi','364530',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2695,8,'Dedan','365550',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2696,8,'Derdi J','365435',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2697,8,'Deripipariya','365440',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2698,8,'Devaliya','365601',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2699,8,'Devalki','365480',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2700,8,'Devarajiya','365630',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2701,8,'Devgam','365460',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2702,8,'Devla','365640',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2703,8,'Dhangla','365220',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2704,8,'Dhar','364515',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2705,8,'Dharai','365410',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2706,8,'Dhargni','365630',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2707,8,'Dhari','365640',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2708,8,'Dhari SR','365640',1,0,'2022-03-03 12:19:56','2022-03-03 12:19:56'),(2709,8,'Dhemal','365220',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2710,8,'Dhrufaniya','365220',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2711,8,'Dhundhia-pipaliya','365480',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2712,8,'Ditla','365630',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2713,8,'Doliya','365555',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2714,8,'Dolti','364530',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2715,8,'Dudhala','365545',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2716,8,'Dudhala','365430',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2717,8,'Dudhala','365660',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2718,8,'Dungar','365555',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2719,8,'Eklera','365220',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2720,8,'Fatepur','365601',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2721,8,'Fifad','364525',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2722,8,'Gadhakda','364522',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2723,8,'Gadhiya','365640',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2724,8,'Gakharvalamota','365601',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2725,8,'Gama-pialiya','365410',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2726,8,'Garmali C','365630',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2727,8,'Garmali Moti','365630',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2728,8,'Garni','365421',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2729,8,'Gavdka','365610',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2730,8,'Ghandla','364530',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2731,8,'Ghoba','364525',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2732,8,'Ghugharala','365410',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2733,8,'Gidardi','365650',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2734,8,'Gigasan','365640',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2735,8,'Gopalgram','365630',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2736,8,'Govindpur','365640',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2737,8,'Gundaran','365220',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2738,8,'Hadala(S)','365456',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2739,8,'Hadida','364530',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2740,8,'Hahtsani','364515',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2741,8,'Halariya','365630',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2742,8,'Hamapur','365440',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2743,8,'Haripur','365220',1,0,'2022-03-03 12:19:57','2022-03-03 12:19:57'),(2744,8,'Haripura','365430',1,0,'2022-03-03 12:19:58','2022-03-03 12:19:58'),(2745,8,'Harsurpur','365435',1,0,'2022-03-03 12:19:58','2022-03-03 12:19:58'),(2746,8,'Hathigadh','365535',1,0,'2022-03-03 12:19:58','2022-03-03 12:19:58'),(2747,8,'Hemal','365545',1,0,'2022-03-03 12:19:58','2022-03-03 12:19:58'),(2748,8,'Hipavadli','364525',1,0,'2022-03-03 12:19:58','2022-03-03 12:19:58'),(2749,8,'Hudli','365630',1,0,'2022-03-03 12:19:58','2022-03-03 12:19:58'),(2750,8,'Ingorala Bhad','365635',1,0,'2022-03-03 12:19:58','2022-03-03 12:19:58'),(2751,8,'Ingorala-2','365620',1,0,'2022-03-03 12:19:58','2022-03-03 12:19:58'),(2752,8,'Ingorala-dand','365565',1,0,'2022-03-03 12:19:58','2022-03-03 12:19:58'),(2753,8,'Ingorala-j','365220',1,0,'2022-03-03 12:19:58','2022-03-03 12:19:58'),(2754,8,'Ishavariya','365601',1,0,'2022-03-03 12:19:58','2022-03-03 12:19:58'),(2755,8,'Jabal','364522',1,0,'2022-03-03 12:19:58','2022-03-03 12:19:58'),(2756,8,'Jafrabad (Amreli)','365540',1,0,'2022-03-03 12:19:58','2022-03-03 12:19:58'),(2757,8,'Jaliya','365610',1,0,'2022-03-03 12:19:58','2022-03-03 12:19:58'),(2758,8,'Jamka','365440',1,0,'2022-03-03 12:19:58','2022-03-03 12:19:58'),(2759,8,'Jamka','365550',1,0,'2022-03-03 12:19:58','2022-03-03 12:19:58'),(2760,8,'Jangar','365455',1,0,'2022-03-03 12:19:58','2022-03-03 12:19:58'),(2761,8,'Janjariya-juna','365440',1,0,'2022-03-03 12:19:58','2022-03-03 12:19:58'),(2762,8,'Jarakhiya','365430',1,0,'2022-03-03 12:19:58','2022-03-03 12:19:58'),(2763,8,'Jasvantgadh','365620',1,0,'2022-03-03 12:19:58','2022-03-03 12:19:58'),(2764,8,'Jatroda','365535',1,0,'2022-03-03 12:19:58','2022-03-03 12:19:58'),(2765,8,'Jhar','365630',1,0,'2022-03-03 12:19:58','2022-03-03 12:19:58'),(2766,8,'Jhijadia(H)','365480',1,0,'2022-03-03 12:19:58','2022-03-03 12:19:58'),(2767,8,'Jihtudi','365460',1,0,'2022-03-03 12:19:58','2022-03-03 12:19:58'),(2768,8,'Jikiyali','365635',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2769,8,'Jira','365660',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2770,8,'Jira','364521',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2771,8,'Juna-savar','364521',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2772,8,'Juni-haliyad','365440',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2773,8,'Kadaya','365645',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2774,8,'Kadiyali','365560',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2775,8,'Kagvadar','365545',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2776,8,'Kamigadh','365440',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2777,8,'Kanatalav','364515',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2778,8,'Kanchardi','365220',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2779,8,'Kariyana','365421',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2780,8,'Karjala','364515',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2781,8,'Karmdadi','365660',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2782,8,'Katar','365560',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2783,8,'Katrodi','364525',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2784,8,'Kerala','364515',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2785,8,'Kerala','365630',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2786,8,'Kerala-j','365430',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2787,8,'Keriyachad','365630',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2788,8,'Keriyanagas','365601',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2789,8,'Khadadhar','365650',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2790,8,'Khadkala','364521',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2791,8,'Khadkhad','365480',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2792,8,'Khakhbai','365560',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2793,8,'Khakhriya','365421',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2794,8,'Khalpar','364525',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2795,8,'Khambha','365650',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2796,8,'Khambhala','365421',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2797,8,'Khara','365220',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2798,8,'Khari','365456',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2799,8,'Khasdali','364530',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2800,8,'Kherali-moti','365560',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2801,8,'Khicha','365640',1,0,'2022-03-03 12:19:59','2022-03-03 12:19:59'),(2802,8,'Khijadia(Khan)','365480',1,0,'2022-03-03 12:20:00','2022-03-03 12:20:00'),(2803,8,'Khijadia-khara','365456',1,0,'2022-03-03 12:20:00','2022-03-03 12:20:00'),(2804,8,'Khisari','365660',1,0,'2022-03-03 12:20:00','2022-03-03 12:20:00'),(2805,8,'Khjadia( R.S.','365430',1,0,'2022-03-03 12:20:00','2022-03-03 12:20:00'),(2806,8,'Khjuripipalia','365480',1,0,'2022-03-03 12:20:00','2022-03-03 12:20:00'),(2807,8,'Kotadi','365560',1,0,'2022-03-03 12:20:00','2022-03-03 12:20:00'),(2808,8,'Kotdapitha','365421',1,0,'2022-03-03 12:20:00','2022-03-03 12:20:00'),(2809,8,'Kotdapitha','365640',1,0,'2022-03-03 12:20:00','2022-03-03 12:20:00'),(2810,8,'Kovaya','365541',1,0,'2022-03-03 12:20:00','2022-03-03 12:20:00'),(2811,8,'Krankach','365565',1,0,'2022-03-03 12:20:00','2022-03-03 12:20:00'),(2812,8,'Kubda','365640',1,0,'2022-03-03 12:20:00','2022-03-03 12:20:00'),(2813,8,'Kumbhariya','365555',1,0,'2022-03-03 12:20:00','2022-03-03 12:20:00'),(2814,8,'Kunkavav','365450',1,0,'2022-03-03 12:20:00','2022-03-03 12:20:00'),(2815,8,'Kutana','365565',1,0,'2022-03-03 12:20:00','2022-03-03 12:20:00'),(2816,8,'Lakhapadar','365460',1,0,'2022-03-03 12:20:00','2022-03-03 12:20:00'),(2817,8,'Lakhapadar','365635',1,0,'2022-03-03 12:20:00','2022-03-03 12:20:00'),(2818,8,'Lalavadar','365601',1,0,'2022-03-03 12:20:00','2022-03-03 12:20:00'),(2819,8,'Lathi (Amreli)','365430',1,0,'2022-03-03 12:20:00','2022-03-03 12:20:00'),(2820,8,'Light House','364515',1,0,'2022-03-03 12:20:00','2022-03-03 12:20:00'),(2821,8,'Likhala','364522',1,0,'2022-03-03 12:20:01','2022-03-03 12:20:01'),(2822,8,'Liliya','365535',1,0,'2022-03-03 12:20:01','2022-03-03 12:20:01'),(2823,8,'Lonhtpur','365540',1,0,'2022-03-03 12:20:01','2022-03-03 12:20:01'),(2824,8,'Lunghiya','365645',1,0,'2022-03-03 12:20:01','2022-03-03 12:20:01'),(2825,8,'Lunidhar','365460',1,0,'2022-03-03 12:20:01','2022-03-03 12:20:01'),(2826,8,'Lunki','365421',1,0,'2022-03-03 12:20:01','2022-03-03 12:20:01'),(2827,8,'Lunsapur','365540',1,0,'2022-03-03 12:20:01','2022-03-03 12:20:01'),(2828,8,'Luvara','364522',1,0,'2022-03-03 12:20:01','2022-03-03 12:20:01'),(2829,8,'Luvariya','365430',1,0,'2022-03-03 12:20:01','2022-03-03 12:20:01'),(2830,8,'Machyalanana','365601',1,0,'2022-03-03 12:20:01','2022-03-03 12:20:01'),(2831,8,'Malila','365630',1,0,'2022-03-03 12:20:01','2022-03-03 12:20:01'),(2832,8,'Malsika','365640',1,0,'2022-03-03 12:20:01','2022-03-03 12:20:01'),(2833,8,'Mandal','365555',1,0,'2022-03-03 12:20:01','2022-03-03 12:20:01'),(2834,8,'Mandardi','365560',1,0,'2022-03-03 12:20:01','2022-03-03 12:20:01'),(2835,8,'Manekvada','365440',1,0,'2022-03-03 12:20:01','2022-03-03 12:20:01'),(2836,8,'Mangvapal','365601',1,0,'2022-03-03 12:20:01','2022-03-03 12:20:01'),(2837,8,'Matirala','365430',1,0,'2022-03-03 12:20:01','2022-03-03 12:20:01'),(2838,8,'Mavjinjva','365456',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2839,8,'Meghapipalia','365480',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2840,8,'Mekda','364525',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2841,8,'Meriyana','364522',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2842,8,'Mitiyala','364522',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2843,8,'Moldi','364521',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2844,8,'Monpur','365620',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2845,8,'Monvel','365645',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2846,8,'Morangi','365555',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2847,8,'Mota-agariya','365560',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2848,8,'Mota-ankadiya','365455',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2849,8,'Mota-devaliya','365410',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2850,8,'Mota-kankot','365535',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2851,8,'Mota-mandvada','365440',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2852,8,'Motamansa','362730',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2853,8,'Mota-munjiyasar','365440',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2854,8,'Motasamdhiyala','365635',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2855,8,'Mota-ujla','365450',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2856,8,'Mota-zinjuda','364515',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2857,8,'Nadala','365410',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2858,8,'Nagadhra','365635',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2859,8,'Nageshri','365545',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2860,8,'Najapur','365456',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2861,8,'Nana Rajkot','365435',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2862,8,'Nanaliliya','365535',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2863,8,'Nanan-bhmodra','364515',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2864,8,'Nani-dhari','365635',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2865,8,'Nani-kunkavav','365450',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2866,8,'Nani-vadal','364522',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2867,8,'Narangadh','365220',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2868,8,'Navaniya','365421',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2869,8,'Nesdi','364515',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2870,8,'Nilvala','365421',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2871,8,'Ningla-2','365550',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2872,8,'Oliya','364515',1,0,'2022-03-03 12:20:02','2022-03-03 12:20:02'),(2873,8,'P.A.Victor','365555',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2874,8,'Padarsinga','365220',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2875,8,'Panchtalvda','365220',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2876,8,'Paniya','365440',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2877,8,'Pansada','365421',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2878,8,'Pipallag','365455',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2879,8,'Pipalva','365430',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2880,8,'Pipalva','365650',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2881,8,'Piparadi','364525',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2882,8,'Pirkhijadiya','365410',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2883,8,'Pithadia','365456',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2884,8,'Pithvadi','364515',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2885,8,'Pithvajal','365610',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2886,8,'Piyava','364515',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2887,8,'Rabarika','365550',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2888,8,'Rabhda','365555',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2889,8,'Rajsathli','365610',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2890,8,'Rajula','365560',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2891,8,'Rampara','365560',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2892,8,'Rampur','365430',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2893,8,'Rampur','365480',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2894,8,'Randhiya','365620',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2895,8,'Rangpur','365601',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2896,8,'Raydi','365550',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2897,8,'Ringanvala-mota','365555',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2898,8,'Rohisa','362730',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2899,8,'Rughnathpur','365635',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2900,8,'Sajanvav','365555',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2901,8,'Sajiyavadar','365630',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2902,8,'Sajnatimba','365535',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2903,8,'Saladi','365535',1,0,'2022-03-03 12:20:03','2022-03-03 12:20:03'),(2904,8,'Samdhiyala','365440',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2905,8,'Samdhiyala-1','365555',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2906,8,'Sanala','365450',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2907,8,'Sanali','365450',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2908,8,'Sanaliya','365535',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2909,8,'Sanosara','365610',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2910,8,'Santhali-bhukhli','365480',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2911,8,'Sarakadiya','365550',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2912,8,'Sarmbhda','365630',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2913,8,'Sarsiya','365660',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2914,8,'Savar','364515',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2915,8,'Savarkundla','364515',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2916,8,'Senjal','364515',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2917,8,'Shakhpur','365220',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2918,8,'Shedubhar','365430',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2919,8,'Shekhpipariya','365435',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2920,8,'Shelana','364525',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2921,8,'Shilana','365440',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2922,8,'Shiyalbet','365560',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2923,8,'Simran','364521',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2924,8,'Sonariya','365601',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2925,8,'Talda','365550',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2926,8,'Taraktalv','365610',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2927,8,'Tarvada','365610',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2928,8,'Tatania','365650',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2929,8,'Thavi','364525',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2930,8,'Thnsa','365220',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2931,8,'Thoradi','364522',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2932,8,'Timbi','362730',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2933,8,'Toda','365430',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2934,8,'Tori','365480',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2935,8,'Trakuda','365550',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2936,8,'Trambakpur','365660',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2937,8,'Tramboda','365410',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2938,8,'Uchaiya','365560',1,0,'2022-03-03 12:20:04','2022-03-03 12:20:04'),(2939,8,'Umaraia','365650',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2940,8,'Untvad','365421',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2941,8,'UTCL Kovaya','365541',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2942,8,'Vadera','365610',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2943,8,'Vadhera','365540',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2944,8,'Vadia','365480',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2945,8,'Vadli','365560',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2946,8,'Vaghaniya','365456',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2947,8,'Vanda','364525',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2948,8,'Vandliya','365421',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2949,8,'Vankiya','365610',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2950,8,'Vankiya','365635',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2951,8,'Vanot','364530',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2952,8,'Vanshiyali','364525',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2953,8,'Varsada','365430',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2954,8,'Vathalpur K','365601',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2955,8,'Vavda','365421',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2956,8,'Vavdi (D)','365410',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2957,8,'Vavdi-road','365450',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2958,8,'Vavera','365560',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2959,8,'Vijpadi','364530',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2960,8,'Virdi','364525',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2961,8,'Virpur','365640',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2962,8,'Virpur','365435',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2963,9,'Charania','365480',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2964,9,'Ajmer','360055',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2965,9,'Akala','360360',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2966,9,'Amarnagar (Rajkot)','364485',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2967,9,'Ambardi','360311',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2968,9,'Amrapar','360490',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2969,9,'Amrapar','360055',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2970,9,'Anida Bhalodi','360311',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2971,9,'Anida Vachhra','360070',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2972,9,'Ardoi','360030',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2973,9,'Arni','360450',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2974,9,'Atkot','360040',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2975,9,'Bakhalvad','360050',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2976,9,'Bandhiya','360330',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2977,9,'Bandra','360330',1,0,'2022-03-03 12:20:05','2022-03-03 12:20:05'),(2978,9,'Baradiya','360452',1,0,'2022-03-03 12:20:06','2022-03-03 12:20:06'),(2979,9,'Bava Pipaliya','360360',1,0,'2022-03-03 12:20:06','2022-03-03 12:20:06'),(2980,9,'Bhadajalia','360421',1,0,'2022-03-03 12:20:06','2022-03-03 12:20:06'),(2981,9,'Bhadala','360050',1,0,'2022-03-03 12:20:06','2022-03-03 12:20:06'),(2982,9,'Bhader','360410',1,0,'2022-03-03 12:20:06','2022-03-03 12:20:06'),(2983,9,'Bhadra','360405',1,0,'2022-03-03 12:20:06','2022-03-03 12:20:06'),(2984,9,'Bhadva','360030',1,0,'2022-03-03 12:20:06','2022-03-03 12:20:06'),(2985,9,'Bhankh','360490',1,0,'2022-03-03 12:20:06','2022-03-03 12:20:06'),(2986,9,'Bhayavadar','360450',1,0,'2022-03-03 12:20:06','2022-03-03 12:20:06'),(2987,9,'Bhimora','360490',1,0,'2022-03-03 12:20:06','2022-03-03 12:20:06'),(2988,9,'Bhola','360410',1,0,'2022-03-03 12:20:06','2022-03-03 12:20:06'),(2989,9,'Bhukhi','360410',1,0,'2022-03-03 12:20:06','2022-03-03 12:20:06'),(2990,9,'Bhunava','360311',1,0,'2022-03-03 12:20:06','2022-03-03 12:20:06'),(2991,9,'Bildi','364490',1,0,'2022-03-03 12:20:06','2022-03-03 12:20:06'),(2992,9,'Biliyala','360311',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(2993,9,'Boria','360405',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(2994,9,'Champabeda','360070',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(2995,9,'Champrajpur','360370',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(2996,9,'Chandli','360035',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(2997,9,'Charakhadi','360311',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(2998,9,'Charel','360452',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(2999,9,'Chavandi','360452',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3000,9,'Chhadvavadar','360410',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3001,9,'Chhasiya','360055',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3002,9,'Chhatrasa','360410',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3003,9,'Chibhda','360035',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3004,9,'Chichod','360430',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3005,9,'Chikhaliya','360410',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3006,9,'Chitravad','360452',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3007,9,'Chordi','360311',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3008,9,'Dadar','360452',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3009,9,'Dadva Mota','360311',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3010,9,'Dadvi','360405',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3011,9,'Daiya','360311',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3012,9,'Dalia','360070',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3013,9,'Dedarva','360360',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3014,9,'Derdi','360370',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3015,9,'Derdi Kumbaji','364465',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3016,9,'Devchadi','360330',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3017,9,'Devdhari','360055',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3018,9,'Devki Galol','360370',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3019,9,'Devla','364485',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3020,9,'Dhank','360460',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3021,9,'Dholidhar','360405',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3022,9,'Dhoraji D.G. ND T.S.O','360410',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3023,9,'Dhoraji G.P. ND.T.S.O','360410',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3024,9,'Dhoraji','360410',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3025,9,'Dhoraji S.R. ND.T.S.O','360410',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3026,9,'Dhudasiya','364470',1,0,'2022-03-03 12:20:07','2022-03-03 12:20:07'),(3027,9,'Dodiyala','364490',1,0,'2022-03-03 12:20:08','2022-03-03 12:20:08'),(3028,9,'Dudhivadar','360410',1,0,'2022-03-03 12:20:08','2022-03-03 12:20:08'),(3029,9,'Dumiyani','360440',1,0,'2022-03-03 12:20:08','2022-03-03 12:20:08'),(3030,9,'Fareni','360370',1,0,'2022-03-03 12:20:08','2022-03-03 12:20:08'),(3031,9,'Gadhadia','360050',1,0,'2022-03-03 12:20:08','2022-03-03 12:20:08'),(3032,9,'Ganod','360490',1,0,'2022-03-03 12:20:08','2022-03-03 12:20:08'),(3033,9,'Garnara','360311',1,0,'2022-03-03 12:20:08','2022-03-03 12:20:08'),(3034,9,'Ghela Somnath','360050',1,0,'2022-03-03 12:20:08','2022-03-03 12:20:08'),(3035,9,'Ghoghavadar','360311',1,0,'2022-03-03 12:20:08','2022-03-03 12:20:08'),(3036,9,'Gokhlana','360050',1,0,'2022-03-03 12:20:08','2022-03-03 12:20:08'),(3037,9,'Gomta','360320',1,0,'2022-03-03 12:20:08','2022-03-03 12:20:08'),(3038,9,'Gondal Bhagvatpara','360311',1,0,'2022-03-03 12:20:08','2022-03-03 12:20:08'),(3039,9,'Gondal Bhojrajpara','360311',1,0,'2022-03-03 12:20:08','2022-03-03 12:20:08'),(3040,9,'Gondal Bhuvneshwari Pith','360311',1,0,'2022-03-03 12:20:08','2022-03-03 12:20:08'),(3041,9,'Gondal College Chowk','360311',1,0,'2022-03-03 12:20:08','2022-03-03 12:20:08'),(3042,9,'Gondal H.O','360311',1,0,'2022-03-03 12:20:08','2022-03-03 12:20:08'),(3043,9,'Gondal Market Yard','360311',1,0,'2022-03-03 12:20:08','2022-03-03 12:20:08'),(3044,9,'Gundala (Jas)','360055',1,0,'2022-03-03 12:20:08','2022-03-03 12:20:08'),(3045,9,'Gundasara','360311',1,0,'2022-03-03 12:20:08','2022-03-03 12:20:08'),(3046,9,'Gundasari','360452',1,0,'2022-03-03 12:20:09','2022-03-03 12:20:09'),(3047,9,'Hadamtala (Kolithad)','360311',1,0,'2022-03-03 12:20:09','2022-03-03 12:20:09'),(3048,9,'Hadamtala (Shemla)','360311',1,0,'2022-03-03 12:20:09','2022-03-03 12:20:09'),(3049,9,'Hariyasan','360480',1,0,'2022-03-03 12:20:09','2022-03-03 12:20:09'),(3050,9,'Hathasani','360055',1,0,'2022-03-03 12:20:09','2022-03-03 12:20:09'),(3051,9,'Ishavariya','360040',1,0,'2022-03-03 12:20:09','2022-03-03 12:20:09'),(3052,9,'Ishra','360490',1,0,'2022-03-03 12:20:09','2022-03-03 12:20:09'),(3053,9,'Jambudi','360370',1,0,'2022-03-03 12:20:09','2022-03-03 12:20:09'),(3054,9,'Jamkandorna','360405',1,0,'2022-03-03 12:20:09','2022-03-03 12:20:09'),(3055,9,'Jamnavad','360410',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3056,9,'Jamvadi','360311',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3057,9,'Jangvad','360040',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3058,9,'Jasapar','360040',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3059,9,'Jasdan','360050',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3060,9,'Jetalsar Gam','360360',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3061,9,'Jetalsar Jn.','360360',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3062,9,'Jetpur F.W. ND T.S.O','360370',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3063,9,'Jetpur K.B. ND T.S.O','360370',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3064,9,'Jetpur','360370',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3065,9,'Jivapar','360040',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3066,9,'Juna Pipaliya','364490',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3067,9,'Juni Sankli','360360',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3068,9,'Kaduka','360050',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3069,9,'Kagvad','360380',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3070,9,'Kalana','360410',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3071,9,'Kalariya','360490',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3072,9,'Kalasar','360050',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3073,9,'Kamar Kotda','360330',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3074,9,'Kanpar','360040',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3075,9,'Kerali','360370',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3076,9,'Khadvanthali','360311',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3077,9,'Khajurda','360440',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3078,9,'Khakhijaliya','360490',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3079,9,'Khambha','360311',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3080,9,'Khandadhar','360311',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3081,9,'Khandhevadia','360055',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3082,9,'Kharachiya','360370',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3083,9,'Kharachiya','360470',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3084,9,'Khareda','360030',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3085,9,'Khatli','360452',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3086,9,'Khirasara','364485',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3087,9,'Khirsara (Ghed)','360450',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3088,9,'Kolithad','360311',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3089,9,'Kolki (Rajkot)','360470',1,0,'2022-03-03 12:20:10','2022-03-03 12:20:10'),(3090,9,'Kotda Sangani','360030',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3091,9,'Kotha Pipalia','360035',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3092,9,'Lakhavad Moti','360055',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3093,9,'Lath','360490',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3094,9,'Lilapur','360050',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3095,9,'Lodhika','360035',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3096,9,'Lunivav','360311',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3097,9,'Mandan Kundla','360330',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3098,9,'Mandlikpur','360370',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3099,9,'Manekwada','360030',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3100,9,'Meghpar','364490',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3101,9,'Mekha Timbi','360470',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3102,9,'Mengni','360070',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3103,9,'Mervadar','360490',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3104,9,'Meta Khambhaliya','364465',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3105,9,'Mevasa','360370',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3106,9,'Modhuka','360055',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3107,9,'Mojira','360490',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3108,9,'Mota Gundala','360370',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3109,9,'Mota Mandva','360311',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3110,9,'Moti Khilori','364465',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3111,9,'Moti Marad','360421',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3112,9,'Moti Parabadi','360360',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3113,9,'Moti Vavdi','360440',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3114,9,'Moviya','360330',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3115,9,'Nagalkhada','360410',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3116,9,'Nagvadar','360490',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3117,9,'Nana Mandva','360311',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3118,9,'Nani Parabadi','360360',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3119,9,'Nani Vavdi','360440',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3120,9,'Nava Matravad','360450',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3121,9,'Navagadh','360375',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3122,9,'Navagam','360320',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3123,9,'Nilakha','360490',1,0,'2022-03-03 12:20:11','2022-03-03 12:20:11'),(3124,9,'Nonghanchora','360070',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3125,9,'Padavla','360480',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3126,9,'Panch Pipla','360370',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3127,9,'Panchavda','360040',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3128,9,'Paneli','360480',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3129,9,'Patanvav','360430',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3130,9,'Patidad','360311',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3131,9,'Pedhla','360370',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3132,9,'Pipaliya','360410',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3133,9,'Pipaliya(Sadak)','360311',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3134,9,'Pipalva','360360',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3135,9,'Pipardi','360405',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3136,9,'Pipardi','360055',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3137,9,'Pithadia','360370',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3138,9,'Pransla','360490',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3139,9,'Premgadh','360370',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3140,9,'Rabarika','360370',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3141,9,'Rabarika','360470',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3142,9,'Raidi','360410',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3143,9,'Rajapara','360030',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3144,9,'Ramod','360311',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3145,9,'Ravna','364490',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3146,9,'Reshamdi Galol','360370',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3147,9,'Rib','360311',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3148,9,'Ribda','360311',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3149,9,'Roghel','360410',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3150,9,'Rupavati','360360',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3151,9,'Sajadiyali','360405',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3152,9,'Sajadiyali','360450',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3153,9,'Samadhiyala','360370',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3154,9,'Samadhiyala','360490',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3155,9,'Sanali','360055',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3156,9,'Sanathali','364490',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3157,9,'Sandhvaya','360311',1,0,'2022-03-03 12:20:12','2022-03-03 12:20:12'),(3158,9,'Sanganva','360035',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3159,9,'Sardharpur','360375',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3160,9,'Satapar','360330',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3161,9,'Satodad','360405',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3162,9,'Semla','360311',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3163,9,'Shishak','360330',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3164,9,'Shivrajgadh','360311',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3165,9,'Shivrajpur','360050',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3166,9,'Shrinathgadh','360330',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3167,9,'Sodvadar','360440',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3168,9,'Sultanpur (Rajkot)','364470',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3169,9,'Supedi','360440',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3170,9,'Talagana','360490',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3171,9,'Tanasva','360490',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3172,9,'Thana Galol','360370',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3173,9,'Timbdi Arab','360360',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3174,9,'Timbdi Jam','360450',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3175,9,'Torania','360360',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3176,9,'Trakuda','360311',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3177,9,'Umrali','360311',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3178,9,'Upleta Lati Plot','360490',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3179,9,'Upleta ND T.S.O','360490',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3180,9,'Vachhra','360311',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3181,9,'Vadala','360490',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3182,9,'Vadali','360450',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3183,9,'Vadasada','364485',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3184,9,'Vadod','360050',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3185,9,'Vadodar','360410',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3186,9,'Vangadhra','360055',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3187,9,'Varjang Jalia','360490',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3188,9,'Vasavad','364490',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3189,9,'Vavdi','360405',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3190,9,'Vavdi Station','364485',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3191,9,'Vekri','360311',1,0,'2022-03-03 12:20:13','2022-03-03 12:20:13'),(3192,9,'Vinchhiya','360055',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3193,9,'Vinzivad','364470',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3194,9,'Virpur','360380',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3195,9,'Vora Kotda','360311',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3196,9,'Zanzmer','360440',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3197,9,'Zundala','364490',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3198,9,'Adbalka','360110',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3199,9,'Amarpara Wankaner','363621',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3200,9,'Anandpar Navagam','360003',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3201,9,'Anandpar(Morbi)','360003',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3202,9,'Arnitimba','363621',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3203,9,'Bagathala','363641',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3204,9,'Baldhoi','360060',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3205,9,'Bangavadi','363650',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3206,9,'Barvala','363641',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3207,9,'Bedi( Tankara)','363650',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3208,9,'Bedi(Rajkot)','360003',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3209,9,'Bedla','360025',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3210,9,'Bhadiyad','363642',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3211,9,'Bhalgam','363621',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3212,9,'Bhandaria','360025',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3213,9,'Bhavpar','363660',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3214,9,'Bherda','363621',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3215,9,'Bhimguda','363621',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3216,9,'Bhupgadh','360025',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3217,9,'Biliya','363641',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3218,9,'Bodki','363660',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3219,9,'Bogharavadar','360025',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3220,9,'Chachapar','363641',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3221,9,'Chandrapur','363621',1,0,'2022-03-03 12:20:14','2022-03-03 12:20:14'),(3222,9,'Dahisara','360025',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3223,9,'Dahisara (Rajkot)','363660',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3224,9,'Daldi','363621',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3225,9,'Derala','363660',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3226,9,'Devgam','360021',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3227,9,'Dholara','360022',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3228,9,'Dhulia Domda','360021',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3229,9,'Dhuva','363621',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3230,9,'Dungarka','360110',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3231,9,'Gadhaka','360020',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3232,9,'Gadhdiya','360025',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3233,9,'Gala','363630',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3234,9,'Gariya','363621',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3235,9,'Gauridad','360003',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3236,9,'Ghiyavad','363621',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3237,9,'Ghunda (S)','363641',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3238,9,'Ghunda Khanpar','363641',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3239,9,'Ghuntu','363641',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3240,9,'Gungan','363642',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3241,9,'Hadmatia','360025',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3242,9,'Hadmatiya','363641',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3243,9,'Hadmatiya','360110',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3244,9,'Halenda','360025',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3245,9,'Harbatiyali','363650',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3246,9,'Haripar','363630',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3247,9,'Haripar','360025',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3248,9,'Hirapar','363650',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3249,9,'Ishwariya','360110',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3250,9,'Jabalpur','363650',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3251,9,'Jajasar','363670',1,0,'2022-03-03 12:20:15','2022-03-03 12:20:15'),(3252,9,'Jalida','363621',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3253,9,'Jaliya(Dhrol)','360003',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3254,9,'Jambudiya','363642',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3255,9,'Jetpar (M)','363630',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3256,9,'Jivapar','363650',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3257,9,'Jivapar(c)','363630',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3258,9,'Jodjpar Nadi','363642',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3259,9,'Juna Ghantila','363630',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3260,9,'Juna Nagdavas','363670',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3261,9,'Juna Rajpipala','360025',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3262,9,'Kagadadi','360003',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3263,9,'Kamalapur','360025',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3264,9,'Kanesara','360060',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3265,9,'Kankot','360005',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3266,9,'Kankot','363621',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3267,9,'Kasturbadham','360020',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3268,9,'Kerala','363621',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3269,9,'Khajurdi','360110',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3270,9,'Khakhdabela','360110',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3271,9,'Khakhrala','363641',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3272,9,'Khakhrechi','363630',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3273,9,'Khambhala','360110',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3274,9,'Khamta','360110',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3275,9,'Khandheri','360110',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3276,9,'Khanpar','363641',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3277,9,'Kharchiya(Jam)','360060',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3278,9,'Kharechiya','360025',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3279,9,'Kherda','363641',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3280,9,'Kherdi','360002',1,0,'2022-03-03 12:20:16','2022-03-03 12:20:16'),(3281,9,'Kherva','363621',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3282,9,'Khevaliya','363641',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3283,9,'Khijadia','363621',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3284,9,'Khirai','363670',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3285,9,'Khirsara','360021',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3286,9,'Khodapipar','360110',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3287,9,'Khokhaddad','360022',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3288,9,'Khorana','360003',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3289,9,'Kotda Nayani','360003',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3290,9,'Kotharia','363621',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3291,9,'KOTHARIA (Rajkot)','360022',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3292,9,'Kotharia(Tankara)','363650',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3293,9,'Kotharia(TB Hosp)','360022',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3294,9,'Kothi','360060',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3295,9,'Kothi','363621',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3296,9,'Kuchiyadad','360023',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3297,9,'Kumbhariya','363630',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3298,9,'Kundani','360060',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3299,9,'Kuntasi','363660',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3300,9,'KUVADAVA','360023',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3301,9,'Lajai','363641',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3302,9,'Lakhavad(Nani)','360060',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3303,9,'Lalpar','363642',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3304,9,'Lavanpur','363660',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3305,9,'Lilapar','363641',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3306,9,'Lunsar','363621',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3307,9,'Lunsariya','363621',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3308,9,'Madhapar','360006',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3309,9,'Magharvada','360023',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3310,9,'Mahendranagar','363642',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3311,9,'Mahika','360002',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3312,9,'Mahika','363621',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3313,9,'Makansar','363642',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3314,9,'Maliya Miyana','363670',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3315,9,'Maliyasan','360003',1,0,'2022-03-03 12:20:17','2022-03-03 12:20:17'),(3316,9,'Manekwada','363641',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3317,9,'Matel','363621',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3318,9,'Mavdi','360004',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3319,9,'Meghpar Zala','363650',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3320,9,'Mesariya','363621',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3321,9,'Mesavada','360023',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3322,9,'Mitana','363650',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3323,9,'Morbi GIDC','363641',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3324,9,'Morbi MDG','363641',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3325,9,'Morbi Nani Bazar','363641',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3326,9,'Morbi Ppw','363642',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3327,9,'Morbi Shakti Plot','363641',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3328,9,'Mota  Bhela','363660',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3329,9,'Mota Khijadia','363650',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3330,9,'Mota Mava','360005',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3331,9,'Mota Vada','360021',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3332,9,'Motakhijadia','360110',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3333,9,'Motibarar','363670',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3334,9,'Motichanol','360110',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3335,9,'Nagar Pipaliya','360021',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3336,9,'Nana Khijadia','360110',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3337,9,'Nani Barar','363670',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3338,9,'Nani Vavdi','363641',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3339,9,'Nasitpar','363641',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3340,9,'Navagam','363670',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3341,9,'Neknam','363650',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3342,9,'Nesda (K)','363641',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3343,9,'Nichimandal','363641',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3344,9,'Otala','363650',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3345,9,'Padasan','360020',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3346,9,'Paddhara','363621',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3347,9,'Paddhari','360110',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3348,9,'Pal','360004',1,0,'2022-03-03 12:20:18','2022-03-03 12:20:18'),(3349,9,'Panchasar','363641',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3350,9,'Panchasia','363621',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3351,9,'Panchdwarka','363621',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3352,9,'Paneli','363642',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3353,9,'Para  Pipaliya','360006',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3354,9,'Pardi','360024',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3355,9,'Pipaliya','363660',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3356,9,'Pipaliya Raj','363621',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3357,9,'Pipaliya(A)','360003',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3358,9,'Pipli','363642',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3359,9,'Rafala','360023',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3360,9,'Rafaleshwar','363642',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3361,9,'Raiya','360005',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3362,9,'Rajavadala','363621',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3363,9,'Rajkot  Raiya Road','360007',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3364,9,'Rajkot Aji Ind Estate','360003',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3365,9,'Rajkot Bedipara','360003',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3366,9,'Rajkot Bhaktinagar','360002',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3367,9,'Rajkot Bhomeshwar Plot','360006',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3368,9,'Rajkot City','360001',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3369,9,'Rajkot Collectorate','360001',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3370,9,'Rajkot D H College','360001',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3371,9,'Rajkot H.O','360001',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3372,9,'Rajkot Jairaj Plot','360001',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3373,9,'Rajkot Jn. Plot','360001',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3374,9,'Rajkot Kalavad Road','360001',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3375,9,'Rajkot Malviyanagar','360004',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3376,9,'Rajkot Manahar Plot','360002',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3377,9,'Rajkot Mandvi Chowk','360001',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3378,9,'Rajkot Marketing Yard','360003',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3379,9,'Rajkot Metoda Gidc','360021',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3380,9,'Rajkot Millpara','360002',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3381,9,'Rajkot Mochi Bazar','360001',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3382,9,'Rajkot Municipal Corporation','360001',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3383,9,'Rajkot New Jagnath Plot','360001',1,0,'2022-03-03 12:20:19','2022-03-03 12:20:19'),(3384,9,'Rajkot Parsi Agiyari Chowk','360001',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3385,9,'Rajkot Popatpara','360001',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3386,9,'Rajkot Postal Colony','360004',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3387,9,'Rajkot Race Course Road','360001',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3388,9,'Rajkot Sau Uni Area','360005',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3389,9,'Rajkot Sorathiawadi','360002',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3390,9,'Rajkot Udyognagar','360002',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3391,9,'Rajkot Vivekanandnagar','360002',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3392,9,'Rajpar','363641',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3393,9,'Rampar Mota','360110',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3394,9,'Rampar Pati','360110',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3395,9,'Ranekpar','363621',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3396,9,'Rangpar (Bela)','363641',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3397,9,'Rangpar','363641',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3398,9,'Ratidevdi','363621',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3399,9,'Ravapar(Nadi)','363642',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3400,9,'Ravki','360004',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3401,9,'Rohishala','363650',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3402,9,'Rupavati','360110',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3403,9,'Sadulkanava','363642',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3404,9,'Sajanpar','363641',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3405,9,'Sal Pipalia','360110',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3406,9,'Samadhiyala','363621',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3407,9,'Samadhiyala','360020',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3408,9,'Sanosara','360003',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3409,9,'Sapar','363630',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3410,9,'Sarapdad','360110',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3411,9,'Saravad','363660',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3412,9,'Sardhar','360025',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3413,9,'Sardharka','363621',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3414,9,'Savadi','363650',1,0,'2022-03-03 12:20:20','2022-03-03 12:20:20'),(3415,9,'Shakat Sanala','363641',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3416,9,'Shapar( Halar)','360024',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3417,9,'Shri Sardanagar','363641',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3418,9,'Sindhavadar','363621',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3419,9,'Sokhda','363670',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3420,9,'SRPF Gr-XIII  Ghanteshwar','360006',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3421,9,'Sultanpur','363630',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3422,9,'Suvag','360110',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3423,9,'Tankara','363650',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3424,9,'Tarakiya','363621',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3425,9,'Targhadi','363660',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3426,9,'Targhadia','360023',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3427,9,'Targhari','360110',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3428,9,'Thorala','363641',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3429,9,'Thoriyali','360110',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3430,9,'Tithva','363621',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3431,9,'Ukarda','360110',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3432,9,'Umrali','360025',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3433,9,'Unchi Mandal','363641',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3434,9,'Vachhakapar','363650',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3435,9,'Vadali','360020',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3436,9,'Vadharva','363670',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3437,9,'Vaghasiya','363621',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3438,9,'Vaghpar','363630',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3439,9,'Valasan','363621',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3440,9,'Vankada','363641',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3441,9,'Vardusar','363621',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3442,9,'Varsamedi','363660',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3443,9,'Vavania','363660',1,0,'2022-03-03 12:20:21','2022-03-03 12:20:21'),(3444,9,'Vavdi','360004',1,0,'2022-03-03 12:20:22','2022-03-03 12:20:22'),(3445,9,'Vejalpar','363630',1,0,'2022-03-03 12:20:22','2022-03-03 12:20:22'),(3446,9,'Venasar','363630',1,0,'2022-03-03 12:20:22','2022-03-03 12:20:22'),(3447,9,'Veraval (Shapar)','360024',1,0,'2022-03-03 12:20:22','2022-03-03 12:20:22'),(3448,9,'Virnagar','360060',1,0,'2022-03-03 12:20:22','2022-03-03 12:20:22'),(3449,9,'Virpar (M)','363641',1,0,'2022-03-03 12:20:22','2022-03-03 12:20:22'),(3450,9,'Virparda','363660',1,0,'2022-03-03 12:20:22','2022-03-03 12:20:22'),(3451,9,'Virvadrka','363670',1,0,'2022-03-03 12:20:22','2022-03-03 12:20:22'),(3452,9,'Virvav','363650',1,0,'2022-03-03 12:20:22','2022-03-03 12:20:22'),(3453,9,'Visaman','360110',1,0,'2022-03-03 12:20:22','2022-03-03 12:20:22'),(3454,9,'Wankaner','363621',1,0,'2022-03-03 12:20:22','2022-03-03 12:20:22'),(3455,9,'Zilariya','360110',1,0,'2022-03-03 12:20:22','2022-03-03 12:20:22'),(3456,9,'Zinkiyali','363641',1,0,'2022-03-03 12:20:22','2022-03-03 12:20:22'),(3457,9,'Ziyana','360023',1,0,'2022-03-03 12:20:22','2022-03-03 12:20:22'),(3458,10,'Shapar','365440',1,0,'2022-03-03 12:20:22','2022-03-03 12:20:22'),(3459,10,'Vadasada','360490',1,0,'2022-03-03 12:20:22','2022-03-03 12:20:22'),(3460,10,'Aalidar','362720',1,0,'2022-03-03 12:20:22','2022-03-03 12:20:22'),(3461,10,'Achhidra','362255',1,0,'2022-03-03 12:20:22','2022-03-03 12:20:22'),(3462,10,'Adri','362255',1,0,'2022-03-03 12:20:22','2022-03-03 12:20:22'),(3463,10,'Agatrai','362222',1,0,'2022-03-03 12:20:22','2022-03-03 12:20:22'),(3464,10,'Ajab','362229',1,0,'2022-03-03 12:20:22','2022-03-03 12:20:22'),(3465,10,'Ajotha','362268',1,0,'2022-03-03 12:20:22','2022-03-03 12:20:22'),(3466,10,'Akala','362150',1,0,'2022-03-03 12:20:22','2022-03-03 12:20:22'),(3467,10,'Akala','362245',1,0,'2022-03-03 12:20:22','2022-03-03 12:20:22'),(3468,10,'Akha','362222',1,0,'2022-03-03 12:20:22','2022-03-03 12:20:22'),(3469,10,'Akhodad So','362220',1,0,'2022-03-03 12:20:22','2022-03-03 12:20:22'),(3470,10,'Akolvadi','362140',1,0,'2022-03-03 12:20:23','2022-03-03 12:20:23'),(3471,10,'Alidhra','362260',1,0,'2022-03-03 12:20:23','2022-03-03 12:20:23'),(3472,10,'Ambala','362260',1,0,'2022-03-03 12:20:23','2022-03-03 12:20:23'),(3473,10,'Ambala','362565',1,0,'2022-03-03 12:20:23','2022-03-03 12:20:23'),(3474,10,'Ambavad','362560',1,0,'2022-03-03 12:20:23','2022-03-03 12:20:23'),(3475,10,'Ambecha','362245',1,0,'2022-03-03 12:20:23','2022-03-03 12:20:23'),(3476,10,'Amblash','362150',1,0,'2022-03-03 12:20:23','2022-03-03 12:20:23'),(3477,10,'Ambujanagar','362715',1,0,'2022-03-03 12:20:23','2022-03-03 12:20:23'),(3478,10,'Amodra','362560',1,0,'2022-03-03 12:20:23','2022-03-03 12:20:23'),(3479,10,'Amrapur','362268',1,0,'2022-03-03 12:20:23','2022-03-03 12:20:23'),(3480,10,'Amrapur Gir','362245',1,0,'2022-03-03 12:20:23','2022-03-03 12:20:23'),(3481,10,'Anandpur','362263',1,0,'2022-03-03 12:20:23','2022-03-03 12:20:23'),(3482,10,'Aniala','362215',1,0,'2022-03-03 12:20:23','2022-03-03 12:20:23'),(3483,10,'Anjar','362510',1,0,'2022-03-03 12:20:23','2022-03-03 12:20:23'),(3484,10,'Arena','362250',1,0,'2022-03-03 12:20:23','2022-03-03 12:20:23'),(3485,10,'Arnej','362725',1,0,'2022-03-03 12:20:23','2022-03-03 12:20:23'),(3486,10,'Avania','362245',1,0,'2022-03-03 12:20:23','2022-03-03 12:20:23'),(3487,10,'Babra Gir','362245',1,0,'2022-03-03 12:20:23','2022-03-03 12:20:23'),(3488,10,'Badodar','362229',1,0,'2022-03-03 12:20:23','2022-03-03 12:20:23'),(3489,10,'Bagdu','362263',1,0,'2022-03-03 12:20:23','2022-03-03 12:20:23'),(3490,10,'Bakula Dhanej','362150',1,0,'2022-03-03 12:20:23','2022-03-03 12:20:23'),(3491,10,'Balagam','362220',1,0,'2022-03-03 12:20:23','2022-03-03 12:20:23'),(3492,10,'Balot','362610',1,0,'2022-03-03 12:20:23','2022-03-03 12:20:23'),(3493,10,'Bamangadh','362030',1,0,'2022-03-03 12:20:23','2022-03-03 12:20:23'),(3494,10,'Bamnasa Gir','362140',1,0,'2022-03-03 12:20:23','2022-03-03 12:20:23'),(3495,10,'Bandhala','362110',1,0,'2022-03-03 12:20:23','2022-03-03 12:20:23'),(3496,10,'Bandharda','362565',1,0,'2022-03-03 12:20:24','2022-03-03 12:20:24'),(3497,10,'Bantia','362610',1,0,'2022-03-03 12:20:24','2022-03-03 12:20:24'),(3498,10,'Baradiya','362120',1,0,'2022-03-03 12:20:24','2022-03-03 12:20:24'),(3499,10,'Barula','362255',1,0,'2022-03-03 12:20:24','2022-03-03 12:20:24'),(3500,10,'Barvala Galath','362020',1,0,'2022-03-03 12:20:24','2022-03-03 12:20:24'),(3501,10,'Bediya','362565',1,0,'2022-03-03 12:20:24','2022-03-03 12:20:24'),(3502,10,'Bhacha','362560',1,0,'2022-03-03 12:20:24','2022-03-03 12:20:24'),(3503,10,'Bhadiyadhar','362560',1,0,'2022-03-03 12:20:24','2022-03-03 12:20:24'),(3504,10,'Bhalpara','362268',1,0,'2022-03-03 12:20:24','2022-03-03 12:20:24'),(3505,10,'Bhanduri','362245',1,0,'2022-03-03 12:20:24','2022-03-03 12:20:24'),(3506,10,'Bhatiya','362215',1,0,'2022-03-03 12:20:24','2022-03-03 12:20:24'),(3507,10,'Bhatsimroli','362220',1,0,'2022-03-03 12:20:24','2022-03-03 12:20:24'),(3508,10,'Bhesan','362020',1,0,'2022-03-03 12:20:24','2022-03-03 12:20:24'),(3509,10,'Bhiyal','362310',1,0,'2022-03-03 12:20:24','2022-03-03 12:20:24'),(3510,10,'Bilkha','362110',1,0,'2022-03-03 12:20:24','2022-03-03 12:20:24'),(3511,10,'Bodidhar','362560',1,0,'2022-03-03 12:20:24','2022-03-03 12:20:24'),(3512,10,'Bodka','362610',1,0,'2022-03-03 12:20:24','2022-03-03 12:20:24'),(3513,10,'Borvav','362150',1,0,'2022-03-03 12:20:24','2022-03-03 12:20:24'),(3514,10,'Budhecha','362250',1,0,'2022-03-03 12:20:24','2022-03-03 12:20:24'),(3515,10,'Butdi','362130',1,0,'2022-03-03 12:20:24','2022-03-03 12:20:24'),(3516,10,'Chanaka','362020',1,0,'2022-03-03 12:20:24','2022-03-03 12:20:24'),(3517,10,'Chandigadh','362220',1,0,'2022-03-03 12:20:24','2022-03-03 12:20:24'),(3518,10,'Chaparda','362120',1,0,'2022-03-03 12:20:24','2022-03-03 12:20:24'),(3519,10,'Char','362220',1,0,'2022-03-03 12:20:24','2022-03-03 12:20:24'),(3520,10,'Chhachhar','362710',1,0,'2022-03-03 12:20:24','2022-03-03 12:20:24'),(3521,10,'Chhara','362720',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3522,10,'Chhodavadi','362030',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3523,10,'Chiroda','362260',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3524,10,'Chitravad','362150',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3525,10,'Chitrod','362135',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3526,10,'Choki','362315',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3527,10,'Chokli','362310',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3528,10,'Chorvad Holiday Home','362250',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3529,10,'Chorvad','362250',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3530,10,'Chorvadi','362110',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3531,10,'Chuda','362020',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3532,10,'Chuldi','362255',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3533,10,'Dabhor','362266',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3534,10,'Dadar','362120',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3535,10,'Dari','362266',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3536,10,'Datrana','362260',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3537,10,'Deda','362255',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3538,10,'Dedakiyal','362260',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3539,10,'Delvada','362510',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3540,10,'Devli','362720',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3541,10,'Dhamlej','362275',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3542,10,'Dhandhusar','362002',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3543,10,'Dhanfuliya','362205',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3544,10,'Dharigundali Juni','362020',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3545,10,'Dhava','362150',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3546,10,'Dhebar','362130',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3547,10,'Dhokadva','362565',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3548,10,'Dholva','362020',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3549,10,'Dhrabavad','362215',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3550,10,'Dhramanva','362150',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3551,10,'Divrana','362220',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3552,10,'Dolasa','362720',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3553,10,'Dolatpara','362037',1,0,'2022-03-03 12:20:25','2022-03-03 12:20:25'),(3554,10,'Dron','362530',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3555,10,'Dudhala','362245',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3556,10,'Dungarpur','362263',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3557,10,'Dungri','362610',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3558,10,'Fatsar','362530',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3559,10,'Fulka','362530',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3560,10,'Fulrama','362220',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3561,10,'Gabha','362150',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3562,10,'Gadhali','362260',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3563,10,'Galath','362020',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3564,10,'Galiavad','362037',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3565,10,'Galodar','362245',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3566,10,'Gangda','362560',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3567,10,'Gangecha','362245',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3568,10,'Ganthila','362215',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3569,10,'Gelana','362227',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3570,10,'Ghantvad','362710',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3571,10,'Gharal','362550',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3572,10,'Ghodasan','362130',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3573,10,'Ghunsiya','362150',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3574,10,'Gir Devli','362710',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3575,10,'Girgadhda','362530',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3576,10,'Goladhar','362011',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3577,10,'Gorakhmadhi','362268',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3578,10,'Govindpara','362269',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3579,10,'Gundala','362263',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3580,10,'Gundran','362150',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3581,10,'Hadmatiya  Vishal','362030',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3582,10,'Hadmatiya','362140',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3583,10,'Hadmatiya Khajuri','362020',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3584,10,'Haripur','362150',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3585,10,'Harmadiya','362720',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3586,10,'Inaj','362269',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3587,10,'Intvaya','362530',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3588,10,'Ivnagar','362015',1,0,'2022-03-03 12:20:26','2022-03-03 12:20:26'),(3589,10,'Jalondhar','362245',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3590,10,'Jamanvada','362720',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3591,10,'Jambuda','362130',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3592,10,'Jamka','362263',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3593,10,'Jamvala','362530',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3594,10,'Jangar','362255',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3595,10,'Jargali','362530',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3596,10,'Jasadhar','362560',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3597,10,'Jasadhar','362140',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3598,10,'Javantri','362140',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3599,10,'Jepur','362150',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3600,10,'Jetalvad','362130',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3601,10,'Jhalansar','362011',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3602,10,'Jonpur','362222',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3603,10,'Junagadh Agri Campus','362001',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3604,10,'Junagadh Azad Chowk','362001',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3605,10,'Junagadh Bhavnath','362004',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3606,10,'Junagadh Diwan Chowk','362001',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3607,10,'Junagadh Girnar Road','362001',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3608,10,'Junagadh H.O','362001',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3609,10,'Junagadh Joshipura','362002',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3610,10,'Junagadh Mangnath Road','362001',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3611,10,'Junagadh PTC','362001',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3612,10,'Junagadh Sardarbag','362001',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3613,10,'Junagadh Station Road','362001',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3614,10,'Junagadh Udyognagar','362037',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3615,10,'Juni Chavand','362120',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3616,10,'Juthal','362245',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3617,10,'Kadaya','362245',1,0,'2022-03-03 12:20:27','2022-03-03 12:20:27'),(3618,10,'Kadvar','362268',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3619,10,'Kadvasan','362725',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3620,10,'Kaj','362720',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3621,10,'Kajardi','362560',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3622,10,'Kajli','362268',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3623,10,'Kalapan','362510',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3624,10,'Kalavad Gir','362130',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3625,10,'Kalsari','362130',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3626,10,'Kalvani','362227',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3627,10,'Kanakia','362560',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3628,10,'Kandhi','362560',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3629,10,'Kaneri','362229',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3630,10,'Kanjha','362610',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3631,10,'Kansari','362560',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3632,10,'Kariya','362030',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3633,10,'Kathrota','362315',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3634,10,'Kenedipur','362260',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3635,10,'Kesariya','362560',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3636,10,'Keshod Aerodrome','362220',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3637,10,'Keshod Akshaygadh','362229',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3638,10,'Keshod','362220',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3639,10,'Kevadra','362227',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3640,10,'Khadia','362263',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3641,10,'Khadpipli','362260',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3642,10,'Khambha Gir','362130',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3643,10,'Khambhaliya','362250',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3644,10,'Khambhaliya','362030',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3645,10,'Khamdhrol','362037',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3646,10,'Khamidana','362220',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3647,10,'Khandheri','362150',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3648,10,'Khapat','362530',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3649,10,'Kharachiya (V)','362030',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3650,10,'Khatrivada','362550',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3651,10,'Khera','362250',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3652,10,'Khijadiya','362260',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3653,10,'Khilavad','362530',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3654,10,'Khirsara Ghed','362220',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3655,10,'Khokharda','362215',1,0,'2022-03-03 12:20:28','2022-03-03 12:20:28'),(3656,10,'Khorasa Ahir','362215',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3657,10,'Khorasa Gir','362255',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3658,10,'Kindarva','362255',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3659,10,'Kob','362510',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3660,10,'Kodidra','362150',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3661,10,'Kodinar Khadudyog','362725',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3662,10,'Kodinar','362720',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3663,10,'Kodiya','362530',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3664,10,'Kotda','362720',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3665,10,'Kotda Mota','362020',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3666,10,'Koyali','362205',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3667,10,'Kukasvada','362250',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3668,10,'Ladudi','362255',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3669,10,'Lati','362268',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3670,10,'Leriya','362130',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3671,10,'Limadhra','362120',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3672,10,'Lodhva','362275',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3673,10,'Lumbha','362150',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3674,10,'Lushala','362215',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3675,10,'Madhupur Jambur','362150',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3676,10,'Magharvada','362215',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3677,10,'Majevadi','362011',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3678,10,'Makhiyala','362011',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3679,10,'Malanka','362260',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3680,10,'Malia Hatina','362245',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3681,10,'Maljinjva','362150',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3682,10,'Mandorna','362140',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3683,10,'Manekvada','362222',1,0,'2022-03-03 12:20:29','2022-03-03 12:20:29'),(3684,10,'Mangalpur','362222',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3685,10,'Mangnathpipli','362110',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3686,10,'Manpur','362260',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3687,10,'Matarvaniya','362245',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3688,10,'Meghpur','362610',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3689,10,'Mendarda','362260',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3690,10,'Mendpara','362030',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3691,10,'Meswan','362227',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3692,10,'Mitiyaj','362720',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3693,10,'Mohabatpur','362205',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3694,10,'Monia','362120',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3695,10,'Moradiya','362268',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3696,10,'Moruka','362140',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3697,10,'Morvada','362720',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3698,10,'Morvada','362020',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3699,10,'Mota Hadmatia','362110',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3700,10,'Mota Kajaliyara','362610',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3701,10,'Mota Samadhiyala','362565',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3702,10,'Motadesar','362560',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3703,10,'Motha','362550',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3704,10,'Moti Fafdi','362720',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3705,10,'Motidhanej','362245',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3706,10,'Motighansari','362220',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3707,10,'Motimonpari','362130',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3708,10,'Movana','362220',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3709,10,'Muldwarka','362725',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3710,10,'Muliyasa','362222',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3711,10,'Nagalpur','362263',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3712,10,'Naliya Mandvi','362510',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3713,10,'Nana Samadhiyala','362565',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3714,10,'Nanakotda','362110',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3715,10,'Nandarkhi','362002',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3716,10,'Nani Monpari','362120',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3717,10,'Nanighansari','362220',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3718,10,'Nathal','362560',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3719,10,'Nava Bandar','362510',1,0,'2022-03-03 12:20:30','2022-03-03 12:20:30'),(3720,10,'Navadra','362268',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3721,10,'Navania','362110',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3722,10,'Navapipalia','362110',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3723,10,'Navda','362610',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3724,10,'Nonjanvav','362215',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3725,10,'Nunarda','362220',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3726,10,'Osa','362220',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3727,10,'Padodar','362220',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3728,10,'Paldi','362510',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3729,10,'Panadar','362720',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3730,10,'Panchala','362220',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3731,10,'Panidhra','362245',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3732,10,'Pankhan','362227',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3733,10,'Parabvavdi','362020',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3734,10,'Patrapasar','362011',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3735,10,'Pedhavada','362720',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3736,10,'Pikhor','362268',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3737,10,'Pikhor','362245',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3738,10,'Piplana','362610',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3739,10,'Pipli','362220',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3740,10,'Plasva','362015',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3741,10,'Prabhas Patan','362268',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3742,10,'Pranchi','362268',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3743,10,'Pransli','362229',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3744,10,'Pransli','362268',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3745,10,'Prasnavada','362275',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3746,10,'Prempara','362130',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3747,10,'Rafalia','362020',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3748,10,'Rajesar','362260',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3749,10,'Rakhej','362275',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3750,10,'Rameshwar','362110',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3751,10,'Rampara','362268',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3752,10,'Rampara Gir','362140',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3753,10,'Rangpur','362227',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3754,10,'Rangpur','362268',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3755,10,'Ranpur(S)','362030',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3756,10,'Rasulpara','362140',1,0,'2022-03-03 12:20:31','2022-03-03 12:20:31'),(3757,10,'Ratang','362120',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3758,10,'Ratidhar','362140',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3759,10,'Ravni','362002',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3760,10,'Ravni Kuba','362130',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3761,10,'Saiyad Rajpara','362550',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3762,10,'Sakhdavadar','362263',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3763,10,'Samadhiyala','362260',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3764,10,'Samter','362560',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3765,10,'Sanakhda','362550',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3766,10,'Sandha','362220',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3767,10,'Sandhnidhar','362710',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3768,10,'Sangodra','362150',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3769,10,'Santalpur','362610',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3770,10,'Sanvav','362530',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3771,10,'Sardarpur','362020',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3772,10,'Sarkhadi','362720',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3773,10,'Sarsai','362120',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3774,10,'Sasan Gir','362135',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3775,10,'Savni','362268',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3776,10,'Semarvav','362150',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3777,10,'Shapur(S)','362205',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3778,10,'Sherbaug','362255',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3779,10,'Shergadh','362245',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3780,10,'Sheriyakhan','362250',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3781,10,'Shobha Vadla','362020',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3782,10,'Siddhigram','362276',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3783,10,'Sidokar','362255',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3784,10,'Simar','362550',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3785,10,'Simar','362255',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3786,10,'Simasi','362215',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3787,10,'Simasi','362560',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3788,10,'Simrolibava','362220',1,0,'2022-03-03 12:20:32','2022-03-03 12:20:32'),(3789,10,'Sindhaj','362710',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3790,10,'Singsar','362275',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3791,10,'Solaj','362268',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3792,10,'Sonardi','362205',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3793,10,'Sondarda','362227',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3794,10,'Sukhpur','362310',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3795,10,'Surva','362140',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3796,10,'Sutrapada','362275',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3797,10,'Tad','362510',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3798,10,'Talala','362150',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3799,10,'Tarsingda','362245',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3800,10,'Thanapipli','362215',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3801,10,'Thordi','362530',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3802,10,'Timbavadi','362015',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3803,10,'Tinmas','362222',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3804,10,'Tobra','362268',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3805,10,'Toraniya','362263',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3806,10,'Tulsishyam','362560',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3807,10,'Ugla','362565',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3808,10,'Ukadiya','362150',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3809,10,'Umbari','362268',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3810,10,'Umej','362560',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3811,10,'Umrali','362020',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3812,10,'Una','362560',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3813,10,'Untvada','362560',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3814,10,'Vadal','362310',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3815,10,'Vadala','362140',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3816,10,'Vadhavi','362002',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3817,10,'Vadiya','362245',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3818,10,'Vadla','362205',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3819,10,'Vadnagar','362725',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3820,10,'Vadodara Dodia','362255',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3821,10,'Vadodarazala','362275',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3822,10,'Vadviyala','362530',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3823,10,'Vankia','362560',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3824,10,'Vanthali(S)','362610',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3825,10,'Varsingpur','362560',1,0,'2022-03-03 12:20:33','2022-03-03 12:20:33'),(3826,10,'Vasoj','362510',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3827,10,'Vavarda','362560',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3828,10,'Vavdi','362255',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3829,10,'Vekariya','362130',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3830,10,'Velan','362720',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3831,10,'Velva','362720',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3832,10,'Veraval Rayon Factory','362266',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3833,10,'Veraval','362265',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3834,10,'Veraval Udyognagar','362269',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3835,10,'Vichhavad','362020',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3836,10,'Vijapur','362015',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3837,10,'Virdi','362245',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3838,10,'Virpur','362110',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3839,10,'Virpur','362150',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3840,10,'Visanvel','362250',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3841,10,'Visavadar','362130',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3842,10,'Vithalpur','362720',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3843,10,'Zampodad','362610',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3844,10,'Zudvali','362530',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3845,10,'Ajak','362240',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3846,10,'Ambalia','362625',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3847,10,'Antroli','362240',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3848,10,'Bagasara Ghed','362620',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3849,10,'Bamanvada','362240',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3850,10,'Bamnasa Ghed','362625',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3851,10,'Bantwa','362620',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3852,10,'Bantwa Subhash Road','362620',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3853,10,'Bhalgam','362620',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3854,10,'Bhathrot','362620',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3855,10,'Bhindora','362640',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3856,10,'Buri','362630',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3857,10,'Chandvana','362225',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3858,10,'Chikhlodra','362650',1,0,'2022-03-03 12:20:34','2022-03-03 12:20:34'),(3859,10,'Chudva','362640',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3860,10,'Dadva','362620',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3861,10,'Deshinga','362620',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3862,10,'Dhelana','362225',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3863,10,'Divasa','362240',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3864,10,'Galvav','362630',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3865,10,'Ghodadar','362230',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3866,10,'Husenabad','362225',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3867,10,'Indra','362640',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3868,10,'Jambuda','362630',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3869,10,'Kalej','362240',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3870,10,'Khadia','362640',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3871,10,'Kodvav','362620',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3872,10,'Kotharia','362630',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3873,10,'Kothdi','362630',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3874,10,'Koylana Ghed','362630',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3875,10,'Limbuda','362620',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3876,10,'Loej','362225',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3877,10,'Maktupur','362225',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3878,10,'Manavadar','362630',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3879,10,'Mangrol Bazar','362225',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3880,10,'Mangrol Bundar','362226',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3881,10,'Mangrol (Junagadh)','362225',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3882,10,'Mankhetra','362225',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3883,10,'Marmath','362620',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3884,10,'Matiyana','362625',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3885,10,'Mekhdi','362240',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3886,10,'Miti','362620',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3887,10,'Nagichana','362240',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3888,10,'Nakra','362625',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3889,10,'Nanadarkhi','362240',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3890,10,'Nanadia','362625',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3891,10,'Nandarkha','362630',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3892,10,'Pajod','362620',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3893,10,'Rahij','362225',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3894,10,'Samarda','362230',1,0,'2022-03-03 12:20:35','2022-03-03 12:20:35'),(3895,10,'Samega','362620',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3896,10,'Sanosara','362630',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3897,10,'Sardargadh','362640',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3898,10,'Shardagram','362235',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3899,10,'Sharma','362230',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3900,10,'Sherdi','362640',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3901,10,'Sheriaj','362225',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3902,10,'Shil','362240',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3903,10,'Sitana','362625',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3904,10,'Sultanabad','362630',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3905,10,'Sultanpur','362225',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3906,10,'Talodra','362240',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3907,10,'Thaniyana','362640',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3908,10,'Tikar','362630',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3909,10,'Vadala Ghed','362625',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3910,10,'Vekri','362620',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3911,10,'Velva','362630',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3912,10,'Zinjri','362640',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3913,11,'Vadal-moti','364530',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3914,11,'Adhewada','364002',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3915,11,'Adtala','364765',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3916,11,'Agiyali','364260',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3917,11,'Akwada','364002',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3918,11,'Alampar','364320',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3919,11,'Alang SBY','364081',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3920,11,'Amargadh','364210',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3921,11,'Ambla','364210',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3922,11,'Anandpur','364310',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3923,11,'Anida','364270',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3924,11,'Anida','364740',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3925,11,'Ankolali','364760',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3926,11,'Awaniya','364002',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3927,11,'Ayavej','364510',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3928,11,'Bagdana','364145',1,0,'2022-03-03 12:20:36','2022-03-03 12:20:36'),(3929,11,'Bahadurpur','364760',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3930,11,'Bajud','364210',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3931,11,'Bambhan','364710',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3932,11,'Bambhania','364280',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3933,11,'Bapada','364150',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3934,11,'Bela','364150',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3935,11,'Belampur','364290',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3936,11,'Bhadbhid','364313',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3937,11,'Bhadla Nana','364720',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3938,11,'Bhadli','364240',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3939,11,'Bhadra','364290',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3940,11,'Bhadravadi','364710',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3941,11,'Bhadraval','364150',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3942,11,'Bhadrod','364295',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3943,11,'Bhadvav','364270',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3944,11,'Bhandariya','364505',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3945,11,'Bhandariya','364270',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3946,11,'Bhandariya','364050',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3947,11,'Bhankhal','364120',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3948,11,'Bharoli','364120',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3949,11,'Bhavnagar Anandnagar','364005',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3950,11,'Bhavnagar Bharatnagar','364002',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3951,11,'Bhavnagar BPTI','364002',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3952,11,'Bhavnagar Chitra','364004',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3953,11,'Bhavnagar Collectorate','364001',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3954,11,'Bhavnagar Gogha Circle','364001',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3955,11,'Bhavnagar H.O','364001',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3956,11,'Bhavnagar K Nagar','364001',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3957,11,'Bhavnagar Khargate','364001',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3958,11,'Bhavnagar Kumbharwada','364006',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3959,11,'Bhavnagar M K Road','364001',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3960,11,'Bhavnagar Nirmalnagar','364001',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3961,11,'Bhavnagar Para','364003',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3962,11,'Bhavnagar Shivaji Circle Area','364001',1,0,'2022-03-03 12:20:37','2022-03-03 12:20:37'),(3963,11,'Bhavnagar Station Road','364006',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3964,11,'Bhavnagar Takhteshwar','364002',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3965,11,'Bhavnagar Vora Bazar','364001',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3966,11,'Bhavnagar Wadva','364001',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3967,11,'Bhikda','364060',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3968,11,'Bhimdad','364710',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3969,11,'Bhojavadar','364320',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3970,11,'Bhojpara','364060',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3971,11,'Bhumbhli','364110',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3972,11,'Bhutiya','364270',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3973,11,'Bhutiya','364230',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3974,11,'Bila','364280',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3975,11,'Boda','364295',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3976,11,'Bodi','364720',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3977,11,'Bodki','364750',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3978,11,'Borda','364130',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3979,11,'Bordi','364280',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3980,11,'Botad','364710',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3981,11,'Botad Statoin Road','364710',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3982,11,'Botad Town','364710',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3983,11,'Budhana','364240',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3984,11,'Budhel','364002',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3985,11,'Chabhadia','364320',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3986,11,'Chamardi','364310',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3987,11,'Chhapariyali','364510',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3988,11,'Chhapri Juni','364145',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3989,11,'Chogath','364330',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3990,11,'Chok','364510',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3991,11,'Concret Jetty','364005',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3992,11,'Dadva','364320',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3993,11,'Dakana','364140',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3994,11,'Damrala','364265',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3995,11,'Dared','364760',1,0,'2022-03-03 12:20:38','2022-03-03 12:20:38'),(3996,11,'Datha','364130',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(3997,11,'Dayal','364130',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(3998,11,'Dedarda','364265',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(3999,11,'Degvada','364295',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4000,11,'Depla','364510',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4001,11,'Devaliya','364140',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4002,11,'Devgana','364260',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4003,11,'Devli','364140',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4004,11,'Dhakania','364710',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4005,11,'Dhankankunda','364230',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4006,11,'Dharai','364145',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4007,11,'Dharuka','364330',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4008,11,'Dharwala','364740',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4009,11,'Dhasa Gam','364730',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4010,11,'Dhasa Jn','364740',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4011,11,'Dhola','364320',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4012,11,'Dhrufania','364750',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4013,11,'Dhundsar','364260',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4014,11,'Dihor','364150',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4015,11,'Dudhala','364265',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4016,11,'Dudhala No. 2','364280',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4017,11,'Dudheri','364290',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4018,11,'Dundas','364290',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4019,11,'Fariyadka','364060',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4020,11,'Fulsar','364140',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4021,11,'Gadhada Sn','364750',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4022,11,'Gadhadiya','364720',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4023,11,'Gadhali','364750',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4024,11,'Gadhesar','364130',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4025,11,'Galthar','364295',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4026,11,'Ganeshgadh','364275',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4027,11,'Gariyadhar','364505',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4028,11,'Ghanghli','364240',1,0,'2022-03-03 12:20:39','2022-03-03 12:20:39'),(4029,11,'Gheti','364265',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4030,11,'Gogha','364110',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4031,11,'Goradka','364765',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4032,11,'Goras','364280',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4033,11,'Gorkhi','364140',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4034,11,'Gujarda','364505',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4035,11,'Gundala','364730',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4036,11,'Gundala','364260',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4037,11,'Gundarna','364295',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4038,11,'Gundarni','364290',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4039,11,'Habukvad','364150',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4040,11,'Haddad','364710',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4041,11,'Hadmatiya','364230',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4042,11,'Hajipur','364250',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4043,11,'Haliyad','364330',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4044,11,'Hanol','364760',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4045,11,'Haripar','364750',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4046,11,'Hathab','364070',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4047,11,'Hathasani','364270',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4048,11,'Hoidad','364070',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4049,11,'Ingorala','364320',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4050,11,'Ingorala','364730',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4051,11,'Ishwariya','364230',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4052,11,'Itaria','364750',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4053,11,'Jalalpur','364740',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4054,11,'Jaliya (Amraji)','364270',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4055,11,'Jaliya','364740',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4056,11,'Jaliya(P)','364275',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4057,11,'Jamanvav','364270',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4058,11,'Jambala','364260',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4059,11,'Jaspara','364120',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4060,11,'Jesar','364510',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4061,11,'Junarampar','364330',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4062,11,'Junvadar','364730',1,0,'2022-03-03 12:20:40','2022-03-03 12:20:40'),(4063,11,'Kalsar','364130',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4064,11,'Kalyanpur','364310',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4065,11,'Kamlej','364060',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4066,11,'Kamlol Nani','364140',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4067,11,'Kanad','364240',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4068,11,'Kanjarda','364265',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4069,11,'Kanpar','364310',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4070,11,'Kantasar','364295',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4071,11,'Kanthariya','364310',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4072,11,'Kardej','364060',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4073,11,'Kariyani','364710',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4074,11,'Karla','364280',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4075,11,'Karmadiya','364145',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4076,11,'Katpar','364290',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4077,11,'Kerala','364135',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4078,11,'Kerala','364750',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4079,11,'Khadarpar','364120',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4080,11,'Khadsaliya','364070',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4081,11,'Khandhera','364140',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4082,11,'Kharakadi','364260',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4083,11,'Khared','364290',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4084,11,'Kharedi','364275',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4085,11,'Khari','364295',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4086,11,'Khari','364240',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4087,11,'Khijadiya','364730',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4088,11,'Khopala','364320',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4089,11,'Kinkariya','364280',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4090,11,'Koliyak','364070',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4091,11,'Konjli','364290',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4092,11,'Kukad','364120',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4093,11,'Kumbhan','364250',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4094,11,'Kumbhan','364290',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4095,11,'Kumbhara','364720',1,0,'2022-03-03 12:20:41','2022-03-03 12:20:41'),(4096,11,'Kumbhariya','364145',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4097,11,'Kundhada','364145',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4098,11,'Kundheli','364140',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4099,11,'Lakadiya','364150',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4100,11,'Lakhanka','364070',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4101,11,'Lakhanka','364765',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4102,11,'Lakheni','364760',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4103,11,'Langala','364320',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4104,11,'Lathidad','364710',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4105,11,'Limbdiya','364730',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4106,11,'Limda (H)','364740',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4107,11,'Loinga','364295',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4108,11,'Lokshala','364150',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4109,11,'Loliyana','364330',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4110,11,'Longdi','364295',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4111,11,'Lundhara','364310',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4112,11,'Lusdi','364290',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4113,11,'Luvara','364505',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4114,11,'Luvarvav','364270',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4115,11,'Madhada','364240',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4116,11,'Madhiya','364290',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4117,11,'Mahuva Bazar','364290',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4118,11,'Mahuva Gandhibaug','364290',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4119,11,'Mahuva (Bhavnagar)','364290',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4120,11,'Makhania','364140',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4121,11,'Malanka','364002',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4122,11,'Malpara','364002',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4123,11,'Malpara','364730',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4124,11,'Malvav','364130',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4125,11,'Manar','364150',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4126,11,'Mandavdhar','364750',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4127,11,'Mandva','364740',1,0,'2022-03-03 12:20:42','2022-03-03 12:20:42'),(4128,11,'Mandvi','364275',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4129,11,'Mangadh','364275',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4130,11,'Melana','364760',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4131,11,'Mendha','364140',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4132,11,'Mevasa','364313',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4133,11,'Mokhada','364270',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4134,11,'Monpar','364313',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4135,11,'Monpar','364145',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4136,11,'Morba','364505',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4137,11,'Morchand','364050',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4138,11,'Morchupna','364510',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4139,11,'Mota Asrana','364280',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4140,11,'Mota Charodiya','364505',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4141,11,'Mota Khokhra','364050',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4142,11,'Mota Surka','364240',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4143,11,'Mota Umarda','364740',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4144,11,'Mota Zadra','364290',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4145,11,'Motakhuntavada','364280',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4146,11,'Moti Dharai','364313',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4147,11,'Moti Jagdhar','364295',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4148,11,'Moti Kundal','364730',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4149,11,'Moti Rajasthali','364270',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4150,11,'Moti Vavdi','364275',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4151,11,'Muldharai','364310',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4152,11,'Nagalpar','364710',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4153,11,'Nagdhaniba','364050',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4154,11,'Naip','364290',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4155,11,'Nana Asrana','364280',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4156,11,'Nana Jadra','364290',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4157,11,'Nana Khuntavada','364295',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4158,11,'Nana Surka','364250',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4159,11,'Nani Rajashtali','364270',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4160,11,'Nani Vavdi','364505',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4161,11,'Nanimal','364265',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4162,11,'Nari','364004',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4163,11,'Nava Ratanpar','364070',1,0,'2022-03-03 12:20:43','2022-03-03 12:20:43'),(4164,11,'Nava Sangana','364140',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4165,11,'Nava Sarod','364270',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4166,11,'Navagam','364250',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4167,11,'Navagam','364313',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4168,11,'Navagam','364120',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4169,11,'Navania','364310',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4170,11,'Nesda','364240',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4171,11,'Nesvad','364290',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4172,11,'Nincha Kotda','364130',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4173,11,'Ningala','364760',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4174,11,'Nonghanvadar','364230',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4175,11,'Otha','364295',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4176,11,'Pachhegam','364275',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4177,11,'Pachhegam','364310',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4178,11,'Padapan','364230',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4179,11,'Padri (G)','364150',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4180,11,'Padva','364050',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4181,11,'Padvadar','364730',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4182,11,'Paldi','364250',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4183,11,'Palitana Dc','364270',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4184,11,'Palitana','364270',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4185,11,'Palitana SR','364270',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4186,11,'Paliyad','364720',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4187,11,'Panchpipla','364265',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4188,11,'Panchtobra','364505',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4189,11,'Panchvada','364250',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4190,11,'Panvi','364310',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4191,11,'Parvadi','364275',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4192,11,'Parvala','364320',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4193,11,'Pasvi','364140',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4194,11,'Pati','364760',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4195,11,'Patna (Malji)','364730',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4196,11,'Patna Bhal','364310',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4197,11,'Pavthi','364140',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4198,11,'Pingli','364260',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4199,11,'Pipaliya','364240',1,0,'2022-03-03 12:20:44','2022-03-03 12:20:44'),(4200,11,'Pipaliya','364765',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4201,11,'Pipardi','364730',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4202,11,'Pipardi','364230',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4203,11,'Pipardi','364320',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4204,11,'Pithalpur','364135',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4205,11,'Pratappara','364135',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4206,11,'Rajavadar','364290',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4207,11,'Rajgadh','364313',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4208,11,'Rajpara','364310',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4209,11,'Rajpara No. 2','364120',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4210,11,'Rajpipla','364750',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4211,11,'Ralgon','364145',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4212,11,'Ramanka','364320',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4213,11,'Ramdhari','364210',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4214,11,'Randola','364240',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4215,11,'Ranghola','364230',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4216,11,'Rangpur','364710',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4217,11,'Ranigam','364510',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4218,11,'Raniwada','364130',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4219,11,'Ranparda','364265',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4220,11,'Rasnal','364730',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4221,11,'Ratanpar','364270',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4222,11,'Ratanpur Bhal','364313',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4223,11,'Ratanvav','364310',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4224,11,'Ratol','364290',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4225,11,'Reliya','364135',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4226,11,'Reliyana','364750',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4227,11,'Reva','364230',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4228,11,'Rohishala','364760',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4229,11,'Rohishala','364270',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4230,11,'Rojiya','364130',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4231,11,'Royal','364150',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4232,11,'Rupavati','364505',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4233,11,'Sakhdasar No.2','364120',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4234,11,'Sakhpar Mota','364750',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4235,11,'Sakhvadar','364140',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4236,11,'Salaiya','364710',1,0,'2022-03-03 12:20:45','2022-03-03 12:20:45'),(4237,11,'Salangpur','364750',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4238,11,'Samadhiyala  ( Mulani)','364230',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4239,11,'Samadhiyala','364320',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4240,11,'Samadhiyala No. 1','364710',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4241,11,'Samadhiyala No. 2','364710',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4242,11,'Sanala','364510',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4243,11,'Sandhkhakhara','364275',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4244,11,'Sanesh','364313',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4245,11,'Sangvadar','364710',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4246,11,'Sankhadasar No.1','364140',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4247,11,'Sanodar','364050',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4248,11,'Sanosara','364230',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4249,11,'Sarera','364280',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4250,11,'Sartanpar','364050',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4251,11,'Sartanpar','364140',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4252,11,'Sarva','364720',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4253,11,'Sathra','364290',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4254,11,'Sathra','364150',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4255,11,'Satpada','364265',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4256,11,'Sedarda','364280',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4257,11,'Senjaliya','364270',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4258,11,'Shantinagar','364280',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4259,11,'Sherthali','364710',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4260,11,'Shetruji Dam','364270',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4261,11,'Shivendra Nagar','364265',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4262,11,'Shiyanagar','364760',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4263,11,'Shobhavad','364140',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4264,11,'Sidsar','364060',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4265,11,'Sihor','364240',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4266,11,'Songadh','364250',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4267,11,'Sosiya','364081',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4268,11,'Surka','364765',1,0,'2022-03-03 12:20:46','2022-03-03 12:20:46'),(4269,11,'Surnagar','364275',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4270,11,'Surnivas','364505',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4271,11,'Tajpar','364710',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4272,11,'Talaja','364140',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4273,11,'Talgajarda','364290',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4274,11,'Tana','364260',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4275,11,'Tansa','364120',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4276,11,'Tared','364290',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4277,11,'Targhara','364710',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4278,11,'Tarsara','364140',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4279,11,'Tatam','364765',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4280,11,'Tatania','364280',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4281,11,'Thadach','364140',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4282,11,'Thaliya','364145',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4283,11,'Thansa','364505',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4284,11,'Thordi','364110',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4285,11,'Timana','364150',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4286,11,'Timba','364275',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4287,11,'Timbi','364320',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4288,11,'Trapaj','364150',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4289,11,'Turkha','364710',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4290,11,'Ugalvan','364280',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4291,11,'Ugamedi','364765',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4292,11,'Ujalvav','364320',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4293,11,'Ukharla','364050',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4294,11,'Umrala','364330',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4295,11,'Unchadi','364140',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4296,11,'Usrad','364240',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4297,11,'Vadiya','364270',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4298,11,'Vadod','364320',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4299,11,'Vaghnagar','364290',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4300,11,'Valar','364130',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4301,11,'Vallabhipur','364310',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4302,11,'Valukad','364270',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4303,11,'Valukad','364060',1,0,'2022-03-03 12:20:47','2022-03-03 12:20:47'),(4304,11,'Varal','364260',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4305,11,'Vartej','364060',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4306,11,'Vav','364210',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4307,11,'Vavdi','364750',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4308,11,'Vavdi','364230',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4309,11,'Vavdi','364120',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4310,11,'Vavdi','364330',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4311,11,'Vejodari','364130',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4312,11,'Velavadar','364313',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4313,11,'Velavadar','364505',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4314,11,'Vikaliya','364740',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4315,11,'Zadakla','364510',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4316,11,'Zamrala','364710',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4317,11,'Zanjmer','364135',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4318,11,'Zinza Vadar Mota','364760',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4319,11,'Zinzavadar Nana','364760',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4320,11,'Ambardi','364750',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4321,11,'Bhadli','364750',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4322,12,'Bagadhra','360480',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4323,12,'Butavadar','360480',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4324,12,'Mandasan','360480',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4325,12,'Paradva','360490',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4326,12,'Valasan','360480',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4327,12,'Aerodromme','361003',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4328,12,'Aliabada','361110',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4329,12,'Ambala','363655',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4330,12,'Ambardi','360515',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4331,12,'Ambavadi','361305',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4332,12,'Amra','361006',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4333,12,'Amran','363655',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4334,12,'Anandpur','361162',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4335,12,'Arablush','361280',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4336,12,'Arambhada','361345',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4337,12,'Arikhana','361170',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4338,12,'Arla','361160',1,0,'2022-03-03 12:20:48','2022-03-03 12:20:48'),(4339,12,'Ashiavadar','361325',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4340,12,'Asota Mota','361305',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4341,12,'Bada','361110',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4342,12,'Badanpar','361250',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4343,12,'Badanpar','363655',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4344,12,'Baid','361006',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4345,12,'Bajana','361305',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4346,12,'Balachadi','361230',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4347,12,'Balambha','361240',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4348,12,'Balambhadi','361160',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4349,12,'Balva','360530',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4350,12,'Bamangam','360540',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4351,12,'Banga','361013',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4352,12,'Bankodi','361315',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4353,12,'Banugar Moti','361120',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4354,12,'Baradia','361335',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4355,12,'Bavakhakharia','361162',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4356,12,'Bedeshwar','361002',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4357,12,'Bedi','361009',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4358,12,'Beh','361310',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4359,12,'Bela','363655',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4360,12,'Beraja','361305',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4361,12,'Beraja Bhalsan','361013',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4362,12,'Beraja Fala','361011',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4363,12,'Beraja Pasaya','361110',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4364,12,'Bet','361330',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4365,12,'Bhadthar','361306',1,0,'2022-03-03 12:20:49','2022-03-03 12:20:49'),(4366,12,'Bhadukiya Mota','361160',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4367,12,'Bhagat Khijadia','360540',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4368,12,'Bhandaria','361306',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4369,12,'Bhangor','360515',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4370,12,'Bhankhokhri','361306',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4371,12,'Bhanvad','360510',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4372,12,'Bharana','361010',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4373,12,'Bharatpur','360510',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4374,12,'Bhatel','361305',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4375,12,'Bhatia','361315',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4376,12,'Bhatvadia','361315',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4377,12,'Bhavabhi Khijadia','360540',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4378,12,'Bhenakvad','360510',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4379,12,'Bhensdad','361220',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4380,12,'Bhimkata','363655',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4381,12,'Bhimrana','361345',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4382,12,'Bhinda','361306',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4383,12,'Bhogat','361315',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4384,12,'Bhojabedi','360520',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4385,12,'Bhopalka','361315',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4386,12,'Bodi','361160',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4387,12,'Bodka','361220',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4388,12,'Chachlana','361320',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4389,12,'Chandravada','361325',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4390,12,'Changa','361012',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4391,12,'Charakala','361335',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4392,12,'Chavda','361130',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4393,12,'Chela','361012',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4394,12,'Chelabedi','361160',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4395,12,'Chhapar','361306',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4396,12,'Chhatar','361160',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4397,12,'Chirodasang','360520',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4398,12,'Chokhanda','360510',1,0,'2022-03-03 12:20:50','2022-03-03 12:20:50'),(4399,12,'Chur','361306',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4400,12,'Dabasang','361280',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4401,12,'Dadia','361012',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4402,12,'Daltungi','361280',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4403,12,'Danta','361305',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4404,12,'Dantrana','361305',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4405,12,'Deri','360540',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4406,12,'Devalia','360510',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4407,12,'Devalia Targhadi','361010',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4408,12,'Dharampur','361170',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4409,12,'Dhaturia','361306',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4410,12,'Dhebar','360510',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4411,12,'Dhichada','361009',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4412,12,'Dhinki','361335',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4413,12,'Dhrafa','360520',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4414,12,'Dhrol','361210',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4415,12,'Dhudasia','361130',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4416,12,'Dhudkot','363655',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4417,12,'Dhundhoraji','361160',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4418,12,'Dhunia','361280',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4419,12,'Dhutarpur','361130',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4420,12,'Dhuvav','361120',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4421,12,'Digvijay Plot','361005',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4422,12,'Digvijaygram','361140',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4423,12,'Dwarka','361335',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4424,12,'Dwarka Town','361335',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4425,12,'Fadsar','363655',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4426,12,'Fagas','361160',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4427,12,'Falla','361120',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4428,12,'Fatsar','363655',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4429,12,'Fot','360510',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4430,12,'Gadhechi','361335',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4431,12,'Gaga','361315',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4432,12,'Gagva','361140',1,0,'2022-03-03 12:20:51','2022-03-03 12:20:51'),(4433,12,'Gajana','361170',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4434,12,'Gajedi','361220',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4435,12,'Gandhavi','361315',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4436,12,'Gingni','360530',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4437,12,'Goinj','361310',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4438,12,'Gorakhadi','360520',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4439,12,'Gorana','361325',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4440,12,'Govana','361170',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4441,12,'Grain Market (Jamnagar)','361001',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4442,12,'Gulabnagar','361007',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4443,12,'Gunatitnagar','361250',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4444,12,'Gunda','360510',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4445,12,'Ha R.S.','361120',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4446,12,'Habardi','361305',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4447,12,'Hadatoda','361210',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4448,12,'Hadiana','361011',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4449,12,'Hajamchora','361240',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4450,12,'Haripar','361013',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4451,12,'Haripar','361320',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4452,12,'Haripar','361170',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4453,12,'Haripar','361305',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4454,12,'Harshadpur','361012',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4455,12,'Hothijikhadba','360530',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4456,12,'Jaga','361130',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4457,12,'Jaiva','361210',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4458,12,'Jaliadevani','361130',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4459,12,'Jam Dudhai','363655',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4460,12,'Jambuda','361120',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4461,12,'Jamdevalia','361320',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4462,12,'Jamgadhka','361320',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4463,12,'Jamjodhpur Darbargadh','360530',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4464,12,'Jamjodhpur','360530',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4465,12,'Jamkalyanpur','361320',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4466,12,'Jamnagar H.O','361001',1,0,'2022-03-03 12:20:52','2022-03-03 12:20:52'),(4467,12,'Jampar','361320',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4468,12,'Jampar','360510',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4469,12,'Jamsar','363655',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4470,12,'Jamsukhpur','360531',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4471,12,'Jamwali','360530',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4472,12,'Jamwali','361160',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4473,12,'Jamwanthali','361130',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4474,12,'Jasapar','361162',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4475,12,'Jasapar','360531',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4476,12,'Jasapar','361220',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4477,12,'Jasapar','360520',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4478,12,'Jiragadh','361220',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4479,12,'Jivapar','361006',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4480,12,'Jivapar','363655',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4481,12,'Jodia','361250',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4482,12,'Juvangadh','361305',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4483,12,'Juvanpar','361315',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4484,12,'Juvanpar','361162',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4485,12,'Kabarka','360515',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4486,12,'Kadbal','360530',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4487,12,'Kajurada','361010',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4488,12,'Kakabhai Sihan','361305',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4489,12,'Kalavad','361160',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4490,12,'Kalmeghda','360540',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4491,12,'Kalyanpur','361335',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4492,12,'Kalyanpur','360531',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4493,12,'Kanakpar','361306',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4494,12,'Kanalush','361280',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4495,12,'Kansumara','361006',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4496,12,'Katkola','360531',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4497,12,'Kenedi','361315',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4498,12,'Kerali','363655',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4499,12,'Keshiya','361250',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4500,12,'Keshod','361306',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4501,12,'Khadba','361170',1,0,'2022-03-03 12:20:53','2022-03-03 12:20:53'),(4502,12,'Khadkhambhalia','361012',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4503,12,'Khambhalia Gate','361001',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4504,12,'Khambhalia','361305',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4505,12,'Khambhalida Motavas','361210',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4506,12,'Khandhera','361013',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4507,12,'Khankharda','361315',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4508,12,'Khankotda','361013',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4509,12,'Kharachia','363655',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4510,12,'Kharedi','360540',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4511,12,'Kharva','361210',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4512,12,'Khatumba','361335',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4513,12,'Khijadia','361120',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4514,12,'Khijdad','361320',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4515,12,'Khilosh','361130',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4516,12,'Khimrana','361120',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4517,12,'Khirasara','361170',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4518,12,'Khirasara','361325',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4519,12,'Khodiyar Colony','361006',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4520,12,'Khojaberaja','361012',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4521,12,'Kolva','361306',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4522,12,'Kotdabavisi','360530',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4523,12,'Kotha Bhadukia','361162',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4524,12,'Kotharia','363655',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4525,12,'Koyli','361220',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4526,12,'Kunad','361250',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4527,12,'Kuranga','361335',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4528,12,'Laiyala','361210',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4529,12,'Lakhabavad','361006',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4530,12,'Lakhtar','361250',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4531,12,'Lal Bunglow','361001',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4532,12,'Laloi','361013',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4533,12,'Lalparda','361306',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4534,12,'Lalpur (Jamnagar)','361170',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4535,12,'Lamba','361315',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4536,12,'Latipur','361220',1,0,'2022-03-03 12:20:54','2022-03-03 12:20:54'),(4537,12,'Lavadia','361012',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4538,12,'Limbuda','361011',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4539,12,'Machharda','361160',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4540,12,'Machhlivad','361160',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4541,12,'Madhapar','361240',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4542,12,'Mahadevia','361315',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4543,12,'Mahiki','360530',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4544,12,'Majoth','361210',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4545,12,'Makhakarod','360540',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4546,12,'Makrani Sanosara','361160',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4547,12,'Maleta','361320',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4548,12,'Manamora','363655',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4549,12,'Mandvi Chowk','361001',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4550,12,'Manekpur','361210',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4551,12,'Manpar','360515',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4552,12,'Masitia','361006',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4553,12,'Matva','361013',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4554,12,'Mavnagam','363655',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4555,12,'Medical Campus','361008',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4556,12,'Meghpar Titodi','361305',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4557,12,'Meghpur','361220',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4558,12,'Memana','361170',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4559,12,'Mevasa','361315',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4560,12,'Mevasa','360510',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4561,12,'Mithapur (Jamnagar)','361345',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4562,12,'Moda','361110',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4563,12,'Modpar (Matva)','361013',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4564,12,'Modpar','361280',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4565,12,'Modpar','360531',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4566,12,'Mojap','361345',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4567,12,'Moridad','360540',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4568,12,'Morkanda','361120',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4569,12,'Morzar','360510',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4570,12,'Mota Bharudiya','361170',1,0,'2022-03-03 12:20:55','2022-03-03 12:20:55'),(4571,12,'Mota Itala','361210',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4572,12,'Mota Thavaria','361110',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4573,12,'Mota Vagudad','361210',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4574,12,'Motakalavad','360515',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4575,12,'Motamandha','361010',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4576,12,'Motavadia','360515',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4577,12,'Moti Khavdi','361140',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4578,12,'Moti Khokhari','361306',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4579,12,'Motibhalsan','361012',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4580,12,'Motigop','360515',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4581,12,'Motimatli','361013',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4582,12,'Motivavdi','361160',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4583,12,'Movan','361305',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4584,12,'Mulila','361160',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4585,12,'Nagadia','361325',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4586,12,'Nagpur','361013',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4587,12,'Nana Vadala','360540',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4588,12,'Nanabhavda','361335',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4589,12,'Nandana','360520',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4590,12,'Nandana','361315',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4591,12,'Nanduri','361170',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4592,12,'Nani Vavdi','361160',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4593,12,'Nanibhagedi','361160',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4594,12,'Napania Khijadia','361160',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4595,12,'Naranpur','361012',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4596,12,'Nathuvadala','361210',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4597,12,'Navadra','361315',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4598,12,'Navagam','361160',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4599,12,'Navagam','361006',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4600,12,'Navagam','360510',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4601,12,'Navagam Ghed','361008',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4602,12,'Navanagna','361007',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4603,12,'New Super Market','361001',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4604,12,'Nikava','361162',1,0,'2022-03-03 12:20:56','2022-03-03 12:20:56'),(4605,12,'Okha','361350',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4606,12,'Okhamadhi','361335',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4607,12,'Pachhtar','360510',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4608,12,'Padana','361280',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4609,12,'Padli','361345',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4610,12,'Panch Hatdi Pedal','361140',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4611,12,'Panchdevda Mota','361160',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4612,12,'Pancheshwar Tower Chowk','361001',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4613,12,'Pata Meghpar','361162',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4614,12,'Patan','360530',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4615,12,'Patel Colony','361008',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4616,12,'Patelka','361320',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4617,12,'Pavan Chakki','361005',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4618,12,'Pindhara','361315',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4619,12,'Pipar','360540',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4620,12,'Pipartoda','361012',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4621,12,'Pipli','361280',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4622,12,'Pithad','361220',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4623,12,'Pithadia','361162',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4624,12,'Positra','361335',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4625,12,'Rafudadnani','361170',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4626,12,'Rajasthali','361160',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4627,12,'Rajpara','361306',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4628,12,'Rajpara','361335',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4629,12,'Rajpara','363655',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4630,12,'Rampar','361120',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4631,12,'Ran','361315',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4632,12,'Rangpur','361280',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4633,12,'Ranjit Nagar','361005',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4634,12,'Ranjitpar','361315',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4635,12,'Rasangpar','361280',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4636,12,'Raval','361325',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4637,12,'Reliance Greens','361142',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4638,12,'Rentala Kalavad','360510',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4639,12,'Rozivada','360510',1,0,'2022-03-03 12:20:57','2022-03-03 12:20:57'),(4640,12,'Rupamora','360510',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4641,12,'Sachana','361230',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4642,12,'Sadodar','360520',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4643,12,'Sai Devalia','360510',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4644,12,'Salaya','361310',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4645,12,'Samana','360520',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4646,12,'Samor','361310',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4647,12,'Sanala','361160',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4648,12,'Sanosara','360515',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4649,12,'Sanosari','361320',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4650,12,'Sansori','360515',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4651,12,'Sarmat','361006',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4652,12,'Sarvania','361160',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4653,12,'Satapar','360531',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4654,12,'Satapar','361320',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4655,12,'Satiya','361162',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4656,12,'Shampar','361240',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4657,12,'Shiva','360531',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4658,12,'Sidhsar','360530',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4659,12,'Sidsara','361315',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4660,12,'Sikka Mahajanpada','361140',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4661,12,'Sikka Tps','361141',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4662,12,'Singach','361010',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4663,12,'Sinhan Aher','361305',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4664,12,'Sisang','361162',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4665,12,'Sonardi','361305',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4666,12,'Sonvadia','360515',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4667,12,'Soyal','361210',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4668,12,'Station Road (Jamnagar)','361001',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4669,12,'Surajkaradi','361347',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4670,12,'Suryavadar','361325',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4671,12,'Tankaria','361320',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4672,12,'Tarsai','360531',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4673,12,'Theba','361120',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4674,12,'Timbadi','360510',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4675,12,'Toda','361160',1,0,'2022-03-03 12:20:58','2022-03-03 12:20:58'),(4676,12,'Tupni','361335',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4677,12,'Udyognagar','361004',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4678,12,'Umrala','361160',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4679,12,'Untbet Shampar','363655',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4680,12,'Vachalabara','361310',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4681,12,'Vadala Moti Metana','361162',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4682,12,'Vadala Sethna','360520',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4683,12,'Vadalia Sinhan','361305',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4684,12,'Vadatra','361305',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4685,12,'Vadinar','361010',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4686,12,'Vadpanchasara','361012',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4687,12,'Valsura','361150',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4688,12,'Vanavad','360530',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4689,12,'Vankiya','361210',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4690,12,'Vansjalia','360531',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4691,12,'Varna','361130',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4692,12,'Varvala','361335',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4693,12,'Vasai','361335',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4694,12,'Vasai','361006',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4695,12,'Vasantpur','360530',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4696,12,'Verad','360515',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4697,12,'Veratia','361130',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4698,12,'Veraval Moti','361012',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4699,12,'Vibhapar','361007',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4700,12,'Vinzalpar','361306',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4701,12,'Viramdad','361305',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4702,12,'Zakhar','361010',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4703,12,'Zinvari','360515',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4704,12,'Zinzuda','363655',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4705,12,'Gadu','360590',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4706,12,'Hathla','360590',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4707,12,'Rozda','360590',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4708,12,'Makajimeghpar','360110',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4709,13,'Malanka','360490',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4710,13,'Bhomiyavadar','360510',1,0,'2022-03-03 12:20:59','2022-03-03 12:20:59'),(4711,13,'Ishwaria','360530',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4712,13,'Simar','360510',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4713,13,'Adityana','360545',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4714,13,'Advana','360590',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4715,13,'Amar','360570',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4716,13,'Amardad','360560',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4717,13,'Amipur','362620',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4718,13,'Aniyari','360570',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4719,13,'Bagvadar','360590',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4720,13,'Bakharla','360579',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4721,13,'Balej','362230',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4722,13,'Bapodar','360570',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4723,13,'Bhad','360576',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4724,13,'Bhadula','362620',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4725,13,'Bharvada','360590',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4726,13,'Bhavpara','360579',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4727,13,'Bhetakadi','360590',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4728,13,'Bhod','360550',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4729,13,'Bhoddar','360570',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4730,13,'Bileshwar','360550',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4731,13,'Bokhira','360579',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4732,13,'Boricha','360545',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4733,13,'Chauta','362650',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4734,13,'Chhatrava','362650',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4735,13,'Chhaya','360578',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4736,13,'Degam','360579',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4737,13,'Devda','362650',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4738,13,'Dharampur','360560',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4739,13,'Erda','360576',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4740,13,'Farer','362620',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4741,13,'Fatana','360590',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4742,13,'Garej','360576',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4743,13,'Gokran','362650',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4744,13,'Gosa','360576',1,0,'2022-03-03 12:21:00','2022-03-03 12:21:00'),(4745,13,'Ishwaria','362650',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4746,13,'Jamboo','360570',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4747,13,'Jamra','362620',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4748,13,'Kadachh','362230',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4749,13,'Kadegi','362620',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4750,13,'Kansavad','362620',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4751,13,'Kantol','362620',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4752,13,'Kavalka','362620',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4753,13,'Khageshri','362650',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4754,13,'Khambhodar','360590',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4755,13,'Khapat','360579',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4756,13,'Khistri','360579',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4757,13,'Kindarkheda','360590',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4758,13,'Kotda','362650',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4759,13,'Kuchhdi','360579',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4760,13,'Kutiyana Bazar','362650',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4761,13,'Kutiyana','362650',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4762,13,'Madhavpur','362230',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4763,13,'Mahiyari','362620',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4764,13,'Mahobatpara','362650',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4765,13,'Majivana','360590',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4766,13,'Mal','362650',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4767,13,'Mander','362230',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4768,13,'Mandva','362650',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4769,13,'Mitrala','360576',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4770,13,'Miyani','360579',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4771,13,'Moddar','362650',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4772,13,'Modhvada','360590',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4773,13,'Mokal','360570',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4774,13,'Morana','360590',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4775,13,'Mul Madhavpur','362230',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4776,13,'Nagka','360579',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4777,13,'Navibandar','360576',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4778,13,'Odadar','360576',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4779,13,'Pandavadar','360579',1,0,'2022-03-03 12:21:01','2022-03-03 12:21:01'),(4780,13,'Paswali','362650',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4781,13,'Pata','362230',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4782,13,'Porbandar Bhojeshwar','360575',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4783,13,'Porbandar Birla Sagar','360576',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4784,13,'Porbandar Chhaya Plot','360575',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4785,13,'Porbandar G.I.D.C.','360577',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4786,13,'Porbandar H.O','360575',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4787,13,'Porbandar Hanuman Gufa','360575',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4788,13,'Porbandar M G Road','360575',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4789,13,'Porbandar Manek Chowk','360575',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4790,13,'Porbandar Mill Pura','360575',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4791,13,'Ranabordi','360570',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4792,13,'Ranakandorana','360570',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4793,13,'Ranakhirasara','360570',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4794,13,'Ranavav Railway Station','360560',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4795,13,'Ranavav','360550',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4796,13,'Ratdi','360579',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4797,13,'Ratia','360576',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4798,13,'Segras','362650',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4799,13,'Shingda','360590',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4800,13,'Sisli','360590',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4801,13,'Sodhana','360590',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4802,13,'Thoyana','360570',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4803,13,'Tukda Gosa','360576',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4804,13,'Tukda Miyani','360579',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4805,13,'Vadala Rana','360590',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4806,13,'Vadvalarana','360570',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4807,13,'Valotra','360570',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4808,13,'Visavada','360579',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4809,14,'Adani Port','370421',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4810,14,'Adesar','370155',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4811,14,'Adhoi','370135',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4812,14,'Adipur','370205',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4813,14,'Aida','370655',1,0,'2022-03-03 12:21:02','2022-03-03 12:21:02'),(4814,14,'Aiyar','370605',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4815,14,'Akri moti','370511',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4816,14,'Amaliyara','370150',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4817,14,'Amara','370605',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4818,14,'Amardi','370140',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4819,14,'Anandpar','370610',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4820,14,'Anandpar','370165',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4821,14,'Anandsar','370610',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4822,14,'Angiya Mota','370675',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4823,14,'Anjar','370110',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4824,14,'Anjar Savasar Naka','370110',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4825,14,'Antarjar','370205',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4826,14,'Aral Moti','370665',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4827,14,'Arikhana','370645',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4828,14,'Asambia Mota','370485',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4829,14,'Ashapar','370655',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4830,14,'Ashram Chakar','370105',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4831,14,'ATPS Nani Chher','370602',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4832,14,'Bada','370475',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4833,14,'Badalpar','370145',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4834,14,'Badargadh','370165',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4835,14,'Balachod Moti','370650',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4836,14,'Balachod Nani','370650',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4837,14,'Baladia','370427',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4838,14,'Balapar -b','370650',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4839,14,'Balasar','370165',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4840,14,'Bambhadai','370475',1,0,'2022-03-03 12:21:03','2022-03-03 12:21:03'),(4841,14,'Bandhadi','370140',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4842,14,'Bandiya','370620',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4843,14,'Baniyari','370020',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4844,14,'Bara Mota','370660',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4845,14,'Baranda','370511',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4846,14,'Baraya','370415',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4847,14,'Baroi','370421',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4848,14,'Baug','370455',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4849,14,'Bayath','370475',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4850,14,'Bela','370165',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4851,14,'Ber moti','370511',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4852,14,'Berachiya','370650',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4853,14,'Beraja','370405',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4854,14,'Bhachau','370140',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4855,14,'Bhachunda','370645',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4856,14,'Bhadai Moti','370465',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4857,14,'Bhadli','370675',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4858,14,'Bhadra','370625',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4859,14,'Bhadreshwar','370410',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4860,14,'Bhagadia','370001',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4861,14,'Bhalot','370130',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4862,14,'Bhanada','370645',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4863,14,'Bharapar','370625',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4864,14,'Bharapar','370660',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4865,14,'Bharapar','370427',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4866,14,'Bharasar','370030',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4867,14,'Bharudia','370140',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4868,14,'Bhavanipar','370650',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4869,14,'Bhimasar )','370240',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4870,14,'Bhimasar','370160',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4871,14,'Bhinsara','370475',1,0,'2022-03-03 12:21:04','2022-03-03 12:21:04'),(4872,14,'Bhirandiara','370510',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4873,14,'Bhitara','370030',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4874,14,'Bhojay','370450',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4875,14,'Bhorara','370410',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4876,14,'Bhuj B S F Camp','370015',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4877,14,'Bhuj Darbargadh Chowk','370001',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4878,14,'Bhuj Din Dayal Nagar','370001',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4879,14,'Bhuj H.O','370001',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4880,14,'Bhuj Ravalwadi','370001',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4881,14,'Bhujodi','370020',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4882,14,'Bhujpur','370405',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4883,14,'Bhutakia','370155',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4884,14,'Bhuvad','370130',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4885,14,'Bibar','370001',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4886,14,'Bidada','370435',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4887,14,'Bitta','370650',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4888,14,'Bitta Valadia','370110',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4889,14,'Bsf Camp Khavda','370510',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4890,14,'Budharmora','370020',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4891,14,'Butta','370655',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4892,14,'Chandia','370130',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4893,14,'Chandrani','370020',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4894,14,'Chandroda','370130',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4895,14,'Chapredi','370105',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4896,14,'Charopadi Moti','370655',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4897,14,'Chhadura','370655',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4898,14,'Chhadwara','370140',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4899,14,'Chhasara','370655',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4900,14,'Chhasara','370410',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4901,14,'Chirai','370140',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4902,14,'Chitrod','370145',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4903,14,'Chiyasar','370650',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4904,14,'Chobari','370140',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4905,14,'Chopadva','370140',1,0,'2022-03-03 12:21:05','2022-03-03 12:21:05'),(4906,14,'Chundi','370430',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4907,14,'Dabhunda','370165',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4908,14,'Dagara','370020',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4909,14,'Dahisara (Kachchh)','370485',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4910,14,'Darshadi','370445',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4911,14,'Davri','370165',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4912,14,'Daypar','370630',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4913,14,'Dedhiya','370450',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4914,14,'Depa','370435',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4915,14,'Desalpar (N)','370605',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4916,14,'Deshalpar (V)','370165',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4917,14,'Deshalpar','370405',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4918,14,'Deshalpar','370040',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4919,14,'Devalia','370110',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4920,14,'Devisar','370665',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4921,14,'Devpar Gadh','370445',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4922,14,'Devpar Jakh','370675',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4923,14,'Dhamadka','370020',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4924,14,'Dhanavada','370650',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4925,14,'Dhaneti','370020',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4926,14,'Dhareshi','370627',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4927,14,'Dhavda','370675',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4928,14,'Dholavira','370165',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4929,14,'Dhoravar','370510',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4930,14,'Dhori','370001',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4931,14,'Dhrab','370421',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4932,14,'Dhrang','370001',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4933,14,'Dhrobana','370510',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4934,14,'Dhufi moti','370660',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4935,14,'Dhunai','370485',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4936,14,'Dinara','370510',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4937,14,'Dolatpar','370630',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4938,14,'Don','370465',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4939,14,'Dudhai','370020',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4940,14,'Dumado','370510',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4941,14,'Dumara','370490',1,0,'2022-03-03 12:21:06','2022-03-03 12:21:06'),(4942,14,'Durgapur','370465',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4943,14,'Fatehgadh','370155',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4944,14,'Fotdi','370040',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4945,14,'Fulay (Chhari)','370665',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4946,14,'Fulay','370511',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4947,14,'Fulra','370627',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4948,14,'Gadani','370625',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4949,14,'Gadhasisa','370445',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4950,14,'Gadhda (Khadir)','370165',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4951,14,'Gadpadar','370240',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4952,14,'Gaduli','370627',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4953,14,'Gagodar','370145',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4954,14,'Gajod','370430',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4955,14,'Gandhidham','370201',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4956,14,'Ganeshnagar','370201',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4957,14,'Ganeshpar','370165',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4958,14,'Gedi','370165',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4959,14,'Gelda','370405',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4960,14,'Ghanithar','370155',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4961,14,'Gharana','370150',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4962,14,'Godhra','370450',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4963,14,'Godpar','370485',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4964,14,'Goniasar','370485',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4965,14,'Gopalpuri','370240',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4966,14,'Gorevali','370510',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4967,14,'Goyala (Mokhra)','370655',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4968,14,'Gundala','370410',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4969,14,'Gundiyali','370455',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4970,14,'Guneri','370627',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4971,14,'Guvar Moti','370601',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4972,14,'Habay','370001',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4973,14,'Hajapar','370105',1,0,'2022-03-03 12:21:07','2022-03-03 12:21:07'),(4974,14,'Hajapar','370650',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(4975,14,'Hajipir','370605',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(4976,14,'Halapar','370450',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(4977,14,'Halra','370135',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(4978,14,'Hamirpar','370155',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(4979,14,'Hamripar','370660',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(4980,14,'Haripar','370625',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(4981,14,'Hatdi','370410',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(4982,14,'Hirapar','370665',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(4983,14,'Hodka','370510',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(4984,14,'Jadodar','370605',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(4985,14,'Jakhau','370640',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(4986,14,'Janan','370165',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(4987,14,'Jangadia','370655',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(4988,14,'Jangi','370150',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(4989,14,'Jashapar','370655',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(4990,14,'Jatavada','370165',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(4991,14,'Jatavira','370665',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(4992,14,'Javaharnagar','370020',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(4993,14,'Jesda','370165',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(4994,14,'Jinjay','370605',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(4995,14,'Jiyapar','370030',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(4996,14,'Juna','370510',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(4997,14,'Kachchh Mandvi','370465',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(4998,14,'Kachchh Mandvi Sanjipadi','370465',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(4999,14,'Kadia Mota','370670',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(5000,14,'Kadia Nana','370670',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(5001,14,'Kadol','370140',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(5002,14,'Kakarva','370140',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(5003,14,'Kalatalav','370660',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(5004,14,'Kali Talawali','370105',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(5005,14,'Kalyanpar','370610',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(5006,14,'Kalyanpar','370165',1,0,'2022-03-03 12:21:08','2022-03-03 12:21:08'),(5007,14,'Kalyanpar Gadhda','370165',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5008,14,'Kanaiyabe','370020',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5009,14,'Kanakpar','370650',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5010,14,'Kandagara','370435',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5011,14,'Kanday','370650',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5012,14,'Kandla Free Trade Zone','370230',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5013,14,'Kandla Harbour','370210',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5014,14,'Kandla Port','370210',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5015,14,'Kanjara','370425',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5016,14,'Kanmer','370155',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5017,14,'Kanthkot','370135',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5018,14,'Kapaya','370415',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5019,14,'Karaghogha','370415',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5020,14,'Karodiya Mota','370450',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5021,14,'Kathda','370465',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5022,14,'Kera','370430',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5023,14,'Kervandh','370655',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5024,14,'Khambhara','370110',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5025,14,'Khanay','370650',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5026,14,'Khandek','370155',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5027,14,'Khari','370510',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5028,14,'Khari Rohar','370240',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5029,14,'Kharoi','370140',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5030,14,'Kharuva','370650',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5031,14,'Khavda','370510',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5032,14,'Khedoi','370130',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5033,14,'Khengarpar','370165',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5034,14,'Kherai','370165',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5035,14,'Khirsara (Vinjhan)','370490',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5036,14,'Khirsara','370645',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5037,14,'Khirsara','370620',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5038,14,'Khodasar','370145',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5039,14,'Khokhara','370020',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5040,14,'Khombhadi','370670',1,0,'2022-03-03 12:21:09','2022-03-03 12:21:09'),(5041,14,'Kidana','370205',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5042,14,'Kidiyanagar','370145',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5043,14,'Koday','370460',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5044,14,'Kodki','370030',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5045,14,'Kojachora','370485',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5046,14,'Kokalia','370450',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5047,14,'Koriyani','370601',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5048,14,'Kotay','370001',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5049,14,'Kotda (C)','370020',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5050,14,'Kotda (Madh)','370625',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5051,14,'Kotda (Reha)','370105',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5052,14,'Kotda Roha','370030',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5053,14,'Kotda-N','370605',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5054,14,'Kotdi (M)','370450',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5055,14,'Kothara','370645',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5056,14,'Kukma','370105',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5057,14,'Kumbharadi','370140',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5058,14,'Kumbharia','370110',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5059,14,'Kumbharia','370145',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5060,14,'Kunariya (K)','370510',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5061,14,'Kunariya','370001',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5062,14,'Kundrodi','370410',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5063,14,'Kuran','370510',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5064,14,'Kurbai','370030',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5065,14,'Laija','370475',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5066,14,'Lakadia','370145',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5067,14,'Lakhagadh','370155',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5068,14,'Lakhania','370660',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5069,14,'Lakhapar','370110',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5070,14,'Lakhapar','370425',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5071,14,'Lakhapar','370627',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5072,14,'Lakhiyarvira','370665',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5073,14,'Lakhond','370105',1,0,'2022-03-03 12:21:10','2022-03-03 12:21:10'),(5074,14,'Lala','370640',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5075,14,'Laliyana','370150',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5076,14,'Lathedi','370490',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5077,14,'Laxmipar (N)','370620',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5078,14,'Lodai','370001',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5079,14,'Lodrani','370165',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5080,14,'Loharia','370130',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5081,14,'Loria','370001',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5082,14,'Ludva','370445',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5083,14,'Luni','370410',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5084,14,'Madh','370625',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5085,14,'Madhapar','370020',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5086,14,'Makda','370445',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5087,14,'Makhel','370155',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5088,14,'Mamaymora','370155',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5089,14,'Mamuara','370020',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5090,14,'Manaba','370145',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5091,14,'Manfara','370140',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5092,14,'Mangvana','370030',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5093,14,'Manjal ( R )','370490',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5094,14,'Manjal (H)','370465',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5095,14,'Manjal','370610',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5096,14,'Mankuwa','370030',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5097,14,'Mapar','370475',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5098,14,'Maska','370465',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5099,14,'Mathada','370130',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5100,14,'Mathak','370205',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5101,14,'Mathal','370605',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5102,14,'Mau','370445',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5103,14,'Mauvana','370165',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5104,14,'Maye','370140',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5105,14,'Meghpar (Lakhpat)','370625',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5106,14,'Meghpar','370430',1,0,'2022-03-03 12:21:11','2022-03-03 12:21:11'),(5107,14,'Meghpar','370140',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5108,14,'Merau','370465',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5109,14,'Mindhiara','370130',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5110,14,'Mindhiari','370601',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5111,14,'Mirzapar','370001',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5112,14,'Misariado','370510',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5113,14,'Mithadi','370510',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5114,14,'Mithi Rohar','370240',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5115,14,'Moda','370155',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5116,14,'Modvadar','370110',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5117,14,'Mokha','370410',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5118,14,'Momaymora','370445',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5119,14,'Mota Bandra','370105',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5120,14,'Mota Bhadia','370455',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5121,14,'Mothara','370650',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5122,14,'Moti Khakhar','370435',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5123,14,'Moti Sindhodi','370640',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5124,14,'Moti Sudadhro','370655',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5125,14,'Mudhan','370627',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5126,14,'Mundra','370421',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5127,14,'Muru','370605',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5128,14,'Nadapa','370020',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5129,14,'Nagalpar (Dhindh)','370465',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5130,14,'Nagalpar','370110',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5131,14,'Nagor','370001',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5132,14,'Nagrecha','370450',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5133,14,'Nakhatrana','370615',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5134,14,'Naliya','370655',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5135,14,'Nana Angia','370675',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5136,14,'Nana Asambia','370485',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5137,14,'Nana Bhadia','370455',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5138,14,'Nana Laija','370475',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5139,14,'Nandasar','370165',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5140,14,'Nangia','370660',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5141,14,'Nani Aral','370665',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5142,14,'Nani Khakhar','370435',1,0,'2022-03-03 12:21:12','2022-03-03 12:21:12'),(5143,14,'Nara','370605',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5144,14,'Naranpar (R)','370615',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5145,14,'Naranpar','370430',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5146,14,'Narayan Sarovar','370601',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5147,14,'Naredi','370030',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5148,14,'Navagam','370020',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5149,14,'Navinal','370405',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5150,14,'Ner','370140',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5151,14,'Netra','370620',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5152,14,'New Dudhai','370115',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5153,14,'Nilpar','370165',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5154,14,'Ningal','370105',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5155,14,'Nirona','370001',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5156,14,'Nundhatad','370650',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5157,14,'Padampar','370160',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5158,14,'Padana','370240',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5159,14,'Padhar','370105',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5160,14,'Palansava','370155',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5161,14,'Panandhro','370601',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5162,14,'Panchotiya','370475',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5163,14,'Paneli','370630',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5164,14,'Parjau','370640',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5165,14,'Patri','370425',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5166,14,'Pharadi','370435',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5167,14,'Pipar','370511',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5168,14,'Poladia','370450',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5169,14,'Praghpar','370155',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5170,14,'Pragpar','370415',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5171,14,'Pratappar','370405',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5172,14,'Pundi','370485',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5173,14,'Rahpar (Khokhara)','370020',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5174,14,'Rahpar','370165',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5175,14,'Rajpar','370445',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5176,14,'Ramania','370405',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5177,14,'Rampar - B','370140',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5178,14,'Rampar (Abda)','370655',1,0,'2022-03-03 12:21:13','2022-03-03 12:21:13'),(5179,14,'Rampar (N)','370620',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5180,14,'Rampar (R)','370615',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5181,14,'Rampar (Vekra)','370445',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5182,14,'Ramvav','370165',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5183,14,'Rapar (Gadhvali)','370645',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5184,14,'Rasalia','370670',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5185,14,'Ratadia (N)','370605',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5186,14,'Ratadia','370465',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5187,14,'Ratadiya','370410',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5188,14,'Ratiya','370040',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5189,14,'Ratnal','370105',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5190,14,'Rav','370165',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5191,14,'Rava','370645',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5192,14,'Ravapar','370625',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5193,14,'Rayan Moti','370465',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5194,14,'Raydhanjar','370490',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5195,14,'Reha','370105',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5196,14,'Roha','370030',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5197,14,'Sadau','370421',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5198,14,'Sai','370165',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5199,14,'Salaya Mota','370465',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5200,14,'Samaghogha','370415',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5201,14,'Sambharai','370450',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5202,14,'Samkhiyali','370150',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5203,14,'Samtra','370040',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5204,14,'Sandhan','370490',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5205,14,'Sandhav','370645',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5206,14,'Sanghad','370205',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5207,14,'Sanghipuram','370511',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5208,14,'Sangnara','370675',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5209,14,'Sanosara','370030',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5210,14,'Sanva','370155',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5211,14,'Sany','370145',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5212,14,'Sanyra (J)','370610',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5213,14,'Sapeda','370105',1,0,'2022-03-03 12:21:14','2022-03-03 12:21:14'),(5214,14,'Sarli','370485',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5215,14,'Satapar','370110',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5216,14,'Selari','370165',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5217,14,'Sherdi','370465',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5218,14,'Shikara','370140',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5219,14,'Shirva','370465',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5220,14,'Shivlakha','370145',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5221,14,'Shyamji Krishna Varma Nagar','370601',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5222,14,'Sikarpur','370150',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5223,14,'Sinay','370205',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5224,14,'Sinugara','370110',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5225,14,'Siracha','370435',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5226,14,'Siyot','370627',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5227,14,'Subhashpar','370601',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5228,14,'Sugaria','370105',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5229,14,'Sujapar','370660',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5230,14,'Sukhpar (B)','370020',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5231,14,'Sukhpar (S)','370655',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5232,14,'Sukhpar (V)','370155',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5233,14,'Sukhpar Roha','370030',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5234,14,'Sukhpar','370040',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5235,14,'Sumrasar (S)','370001',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5236,14,'Sumrasar Jat','370030',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5237,14,'Suthri','370490',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5238,14,'Suvai','370165',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5239,14,'Taga','370155',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5240,14,'Talwana','370460',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5241,14,'Tappar (S)','370425',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5242,14,'Tappar','370110',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5243,14,'Tb Sanatorium','370427',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5244,14,'Tera','370660',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5245,14,'Thoriyari','370145',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5246,14,'Tindalva','370165',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5247,14,'Toda','370415',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5248,14,'Todiya','370670',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5249,14,'Trambau','370165',1,0,'2022-03-03 12:21:15','2022-03-03 12:21:15'),(5250,14,'Tumbadi','370435',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5251,14,'Tuna','370205',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5252,14,'Tunda','370435',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5253,14,'Udaynagar','370203',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5254,14,'Ugedi','370605',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5255,14,'Ukheda','370670',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5256,14,'Umaiya','370155',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5257,14,'Umrapar','370165',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5258,14,'Undoth','370450',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5259,14,'United Salt Work','370210',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5260,14,'Ustiya','370620',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5261,14,'Vada','370465',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5262,14,'Vadala','370410',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5263,14,'Vadapadhar','370645',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5264,14,'Vadasar','370445',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5265,14,'Vadva','370445',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5266,14,'Vadzar','370427',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5267,14,'Vaghura','370410',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5268,14,'Valka Mota','370625',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5269,14,'Vallabhapar (K)','370145',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5270,14,'Vallabhapar','370155',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5271,14,'Valsara','370511',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5272,14,'Vamka','370135',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5273,14,'Vamoti moti','370650',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5274,14,'Vamoti nani','370650',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5275,14,'Vandh','370485',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5276,14,'Vandhiya','370150',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5277,14,'Vang','370001',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5278,14,'Vanki','370425',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5279,14,'Vanku','370645',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5280,14,'Vanoi','370165',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5281,14,'Varadia','370490',1,0,'2022-03-03 12:21:16','2022-03-03 12:21:16'),(5282,14,'Varandi Moti','370490',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5283,14,'Varli','370130',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5284,14,'Varsamedi','370110',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5285,14,'Vayor','370511',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5286,14,'Vibhapar','370030',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5287,14,'Vidh','370450',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5288,14,'Vidi','370110',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5289,14,'Vigodi','370605',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5290,14,'Vijapasar','370140',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5291,14,'Vijayapar','370165',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5292,14,'Vinjhan','370490',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5293,14,'Vira','370110',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5294,14,'Virani (Gadh)','370445',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5295,14,'Virani Nani','370630',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5296,14,'Virani','370665',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5297,14,'Vithon','370675',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5298,14,'Vondh','370140',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5299,14,'Vondhada','370140',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5300,14,'Vovar','370410',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5301,14,'Zarpara','370405',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5302,14,'Zaru','370110',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5303,14,'Zinkdi','370001',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5304,14,'Zura','370001',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5305,15,'Adas','388305',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5306,15,'Agas','388130',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5307,15,'Ahima','388210',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5308,15,'Ajarpura','388310',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5309,15,'Ajupura','388360',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5310,15,'Alarsa','388543',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5311,15,'Ambali','388307',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5312,15,'Ambav (Kantharia)B.O','388307',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5313,15,'Amrol','388307',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5314,15,'Amuldairy  (Anand)','388001',1,0,'2022-03-03 12:21:17','2022-03-03 12:21:17'),(5315,15,'Anand Agri Inst  (Anand)','388110',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5316,15,'Anand H.O','388001',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5317,15,'Anand Town  (Anand)','388001',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5318,15,'Anklav','388510',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5319,15,'Asarma','388510',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5320,15,'Ashi','388130',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5321,15,'Ashipura','388205',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5322,15,'Asodar','388307',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5323,15,'Badapura','388205',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5324,15,'Bajipura','388210',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5325,15,'Bakrol','388315',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5326,15,'Bamangam','388520',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5327,15,'Bechri','388220',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5328,15,'Bedva','388320',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5329,15,'Bhadran','388530',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5330,15,'Bhalej','388205',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5331,15,'Bharoda','388210',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5332,15,'Bhetasi','388307',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5333,15,'Bilpad','388520',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5334,15,'Bodal','388540',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5335,15,'Boria (Anand)','388130',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5336,15,'Borsad','388540',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5337,15,'Chamara','388520',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5338,15,'Chikhodra','388320',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5339,15,'Dagjipura','388205',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5340,15,'Davol','388540',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5341,15,'Dedarda','388560',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5342,15,'Dehmi','388560',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5343,15,'Dholi','388365',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5344,15,'Dhundakuva','388130',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5345,15,'District Court (Anand)','388001',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5346,15,'Gajna','388530',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5347,15,'Gambhira','388520',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5348,15,'Gamdi','388320',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5349,15,'Gana','388345',1,0,'2022-03-03 12:21:18','2022-03-03 12:21:18'),(5350,15,'Ghora','388220',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5351,15,'Gopalpura','388370',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5352,15,'Hadgood','388110',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5353,15,'Hamidpura','388220',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5354,15,'Jakhala','388205',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5355,15,'Jitodia','388345',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5356,15,'Jol','388315',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5357,15,'Joshikuva','388510',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5358,15,'Kahanvadi','388307',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5359,15,'Kanbhaipura','388205',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5360,15,'Kantharia','388307',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5361,15,'Karamsad','388325',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5362,15,'Kashipura  (Borsad)','388540',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5363,15,'Kasor','388205',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5364,15,'Kasumbad','388540',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5365,15,'Kathol','388530',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5366,15,'Kavitha','388545',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5367,15,'Khadol','388350',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5368,15,'Khambholej','388330',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5369,15,'Khandhli','388560',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5370,15,'Khankhanpur','388220',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5371,15,'Khankuva','388205',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5372,15,'Khanpur','388365',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5373,15,'Khedasa','388530',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5374,15,'Kherda','388365',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5375,15,'Khorvad','388365',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5376,15,'Kinkhlod','388510',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5377,15,'Kosindra','388510',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5378,15,'Kothiakhad','388520',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5379,15,'Kunjrav','388335',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5380,15,'Lingda','388220',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5381,15,'Meghva','388345',1,0,'2022-03-03 12:21:19','2022-03-03 12:21:19'),(5382,15,'Menpura','388235',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5383,15,'Mogar','388340',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5384,15,'Mogri','388345',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5385,15,'Morad','388130',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5386,15,'Mujkuva','388307',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5387,15,'Napa','388560',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5388,15,'Napad','388350',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5389,15,'Navakhal','388510',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5390,15,'Navapura','388520',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5391,15,'Navli','388355',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5392,15,'Nisraya','388540',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5393,15,'Ode','388210',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5394,15,'Pamol','388560',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5395,15,'Panchvati   (Umreth)','388220',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5396,15,'Pansora','388220',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5397,15,'Pipli','388530',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5398,15,'Porda','388130',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5399,15,'Pratappura','388365',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5400,15,'Rajupura','388306',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5401,15,'Ramnagar','388340',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5402,15,'Rasnol','388335',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5403,15,'Ratanpura','388220',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5404,15,'Ravlapura','388360',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5405,15,'Samarkha','388360',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5406,15,'Sandesar','388130',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5407,15,'Sardarganj   (Anand)','388001',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5408,15,'Sarol','388530',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5409,15,'Sarsa','388365',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5410,15,'Shili','388210',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5411,15,'Singlav','388560',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5412,15,'Sinhol','388130',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5413,15,'Sisva','388530',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5414,15,'Sundalpura','388210',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5415,15,'Sundan','388305',1,0,'2022-03-03 12:21:20','2022-03-03 12:21:20'),(5416,15,'Sureli','388210',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5417,15,'Surkuva','388130',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5418,15,'Thamna (Anand)','388215',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5419,15,'Tranol','388335',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5420,15,'Umeta','388510',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5421,15,'Umreth','388220',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5422,15,'Untkhari','388205',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5423,15,'Vadod','388370',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5424,15,'Vaghashi','388320',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5425,15,'Valasan','388325',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5426,15,'Vallabh  Vidyanagar','388120',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5427,15,'Valvod','388530',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5428,15,'Vasad','388306',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5429,15,'Vasna','388540',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5430,15,'Vera','388540',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5431,15,'Verakhadi','388365',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5432,15,'Veternary College  (Anand)','388001',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5433,15,'Vithal Udyognagar','388121',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5434,15,'Amiyad','388570',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5435,15,'Amod','388160',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5436,15,'Ardi','388450',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5437,15,'Badalpur','388550',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5438,15,'Balinta','387240',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5439,15,'Bamanva','388580',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5440,15,'Bamroli','387345',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5441,15,'Banejada','388580',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5442,15,'Bhalada','387240',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5443,15,'Bhavanipura','388450',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5444,15,'Bhurakui','388430',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5445,15,'Bhuvel','388640',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5446,15,'Bochasan RS','388140',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5447,15,'Boriavi','387310',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5448,15,'Budhej','388620',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5449,15,'Chagada','388180',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5450,15,'Chitari Bazar','388620',1,0,'2022-03-03 12:21:21','2022-03-03 12:21:21'),(5451,15,'Dabhasi','388140',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5452,15,'Dabhou','387210',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5453,15,'Daheda','388620',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5454,15,'Dahevan','388550',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5455,15,'Dali','388550',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5456,15,'Dantali','388450',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5457,15,'Davalpura','388450',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5458,15,'Devataj','387240',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5459,15,'Dharmaj','388430',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5460,15,'Dharmaj-ranoli','388430',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5461,15,'Dhuvaran','388610',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5462,15,'Dhuvaran Power Station','388610',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5463,15,'Dugari','388625',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5464,15,'Fangani','388450',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5465,15,'Finav','388580',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5466,15,'Gada','387240',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5467,15,'Galiana','388625',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5468,15,'Ghunteli','388440',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5469,15,'Golana','388625',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5470,15,'Golel','388480',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5471,15,'Gorad','388180',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5472,15,'Gudel','388625',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5473,15,'Hadeva','388180',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5474,15,'Indranaj','388180',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5475,15,'Isarvada','388180',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5476,15,'Isnav','388460',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5477,15,'Jalsan','388580',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5478,15,'Jalundh','388640',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5479,15,'Jantral','388580',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5480,15,'Jharola','388590',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5481,15,'Jichka','388180',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5482,15,'Jinaj','388620',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5483,15,'Kalamsar','388640',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5484,15,'Kalitalavadi','388170',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5485,15,'Kalu','388550',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5486,15,'Kanavada','388180',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5487,15,'Kanbha','388550',1,0,'2022-03-03 12:21:22','2022-03-03 12:21:22'),(5488,15,'Kanisa','388170',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5489,15,'Kankapura','388550',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5490,15,'Kansari','388630',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5491,15,'Kanzat','388170',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5492,15,'Kasari','388590',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5493,15,'Kasbara','388180',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5494,15,'Kasor','388460',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5495,15,'Kathana','388550',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5496,15,'Kathana RS','388550',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5497,15,'Khadana','388160',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5498,15,'Khadodhi','388610',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5499,15,'Khaksar','388625',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5500,15,'Khambhat','388620',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5501,15,'Khanpur','388430',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5502,15,'Khanpur','388180',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5503,15,'Khatnal','388640',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5504,15,'Lambhvel','387310',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5505,15,'Laxmipura','388620',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5506,15,'Lunej','388620',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5507,15,'Mahelav','388440',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5508,15,'Mahiyari','388180',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5509,15,'Malataj','387220',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5510,15,'Malu','388620',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5511,15,'Manaj','388150',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5512,15,'Manghrol','387210',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5513,15,'Manpura','388150',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5514,15,'Mariumpura','388450',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5515,15,'Metpur','388620',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5516,15,'Milarampura','388180',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5517,15,'Mitli','388180',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5518,15,'Mobha','388170',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5519,15,'Moraj','388180',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5520,15,'Nagra','388620',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5521,15,'Nana Kalodara','388630',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5522,15,'Nar','388150',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5523,15,'Naviakhol','388625',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5524,15,'Pachegam','388625',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5525,15,'Padgol','388440',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5526,15,'Padra','388180',1,0,'2022-03-03 12:21:23','2022-03-03 12:21:23'),(5527,15,'Palaj','388465',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5528,15,'Palol','387240',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5529,15,'Pandad','388625',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5530,15,'Pandoli','388160',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5531,15,'Pariej','388180',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5532,15,'Petlad RS','388450',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5533,15,'Petlad','388450',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5534,15,'Petli','387220',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5535,15,'Piplav','388460',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5536,15,'Piploi','388640',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5537,15,'Pith Baza- Khambhat','388620',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5538,15,'Ralej','388640',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5539,15,'Ramol','387710',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5540,15,'Rangaipura','388450',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5541,15,'Rangpur','388620',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5542,15,'Ras','388570',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5543,15,'Rudel','388140',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5544,15,'Runaj','388150',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5545,15,'Rupiapura','388480',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5546,15,'Saijpur','388570',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5547,15,'Sansej','388180',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5548,15,'Sayma','388170',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5549,15,'Shakarpur','388620',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5550,15,'Simarda','388480',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5551,15,'Sojitra','387240',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5552,15,'Sunav','388470',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5553,15,'Sundarna','388480',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5554,15,'Sundra','388150',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5555,15,'Tarapur (Anand)','388180',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5556,15,'Timba','388170',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5557,15,'Trambovad','387240',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5558,15,'Undel','388640',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5559,15,'Untvada','388170',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5560,15,'Vadadla','388430',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5561,15,'Vadeli','388590',1,0,'2022-03-03 12:21:24','2022-03-03 12:21:24'),(5562,15,'Vadgam','388625',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5563,15,'Vainaj','388625',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5564,15,'Varsada','388180',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5565,15,'Vatadara','388580',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5566,15,'Vatra','388640',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5567,15,'Virol [simarda]','388480',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5568,15,'Virol','387240',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5569,15,'Virsad','388580',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5570,16,'Agarwa','388230',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5571,16,'Ajupura','388225',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5572,16,'Aklacha','388230',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5573,16,'Alela','388265',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5574,16,'Ambav (Thasra)','388250',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5575,16,'Angadi','388250',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5576,16,'Bar','388265',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5577,16,'Bhadrasa','388230',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5578,16,'Bhanthala','388255',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5579,16,'Bharodi','388260',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5580,16,'Bhatpur','388260',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5581,16,'Bhatpura','388220',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5582,16,'Bhavan \' S College','388225',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5583,16,'Birpur (Kheda)','388260',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5584,16,'Bordi','388225',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5585,16,'Chandasar','388225',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5586,16,'Chetarsumba','388225',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5587,16,'Chitlav','388230',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5588,16,'Dabhali','388250',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5589,16,'Dakor','388225',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5590,16,'Debhari','388260',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5591,16,'Dev','388265',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5592,16,'Dhunadra','388230',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5593,16,'Dhundi','388250',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5594,16,'Felsani','388255',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5595,16,'Gadhavada','388255',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5596,16,'Gandhari','388260',1,0,'2022-03-03 12:21:25','2022-03-03 12:21:25'),(5597,16,'Golaj','388250',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5598,16,'Gumadia','388250',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5599,16,'Guntheli','388255',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5600,16,'Handia','388265',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5601,16,'Janod','388255',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5602,16,'Jetholi','388265',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5603,16,'Jodhpur','388265',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5604,16,'Jorapura','388255',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5605,16,'Kalsar','388230',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5606,16,'Kambopa','388265',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5607,16,'Kasodi','388260',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5608,16,'Khadgodhra','388255',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5609,16,'Kharod','388265',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5610,16,'Khata','388260',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5611,16,'Kheroli','388260',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5612,16,'Khijalpur','388215',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5613,16,'Kosam','388250',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5614,16,'Kotlindra','388230',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5615,16,'Koydam','388260',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5616,16,'Koyla','388260',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5617,16,'Kumbharwadi','388260',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5618,16,'Kuni','388235',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5619,16,'Limbarwada','388260',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5620,16,'Mahi  Itadi','388235',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5621,16,'Malai','388225',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5622,16,'Malvan','388245',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5623,16,'Manjipura','388230',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5624,16,'Masra','388215',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5625,16,'Mithapura (Jesapura)','388230',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5626,16,'Muliad','388225',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5627,16,'Nanadara','388250',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5628,16,'Navagama','388255',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5629,16,'Nepalpura','388250',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5630,16,'Nes','388230',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5631,16,'Othwad','388255',1,0,'2022-03-03 12:21:26','2022-03-03 12:21:26'),(5632,16,'Ozarala','388225',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5633,16,'Padal','388235',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5634,16,'Pandva','388265',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5635,16,'Pandvania','388220',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5636,16,'Pansroda','388265',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5637,16,'Pipalwada','388250',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5638,16,'Rajpur','388255',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5639,16,'Rakhial','388225',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5640,16,'Rampura','388260',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5641,16,'Rania','388230',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5642,16,'Rasulpur','388250',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5643,16,'Rasulpur','388260',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5644,16,'Ratankuva','388260',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5645,16,'Ravalia','388225',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5646,16,'Rozva','388235',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5647,16,'Rustampura','388245',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5648,16,'Saiyat','388225',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5649,16,'Salaiya','388260',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5650,16,'Saliawadi','388255',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5651,16,'Sanadra','388235',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5652,16,'Sandheli','388250',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5653,16,'Saradia','388260',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5654,16,'Saroda','388255',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5655,16,'Sevalia  Rs','388245',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5656,16,'Sonaiya','388245',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5657,16,'Sonipur','388245',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5658,16,'Sui','388225',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5659,16,'Sutaria','388265',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5660,16,'Thasra','388250',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5661,16,'Vadad','388250',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5662,16,'Vadasinor','388255',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5663,16,'Vadasinor Town (Vadasinor)','388255',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5664,16,'Vaddala','388255',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5665,16,'Vaghas','388260',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5666,16,'Vanoda','388235',1,0,'2022-03-03 12:21:27','2022-03-03 12:21:27'),(5667,16,'Vanoti','388225',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5668,16,'Vaso','388245',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5669,16,'Vinzol','388220',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5670,16,'Wanakbori .T.P.S.','388239',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5671,16,'Wanakbori','388235',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5672,16,'Wanghroli','388235',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5673,16,'Abhripur','387335',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5674,16,'Abvel','387650',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5675,16,'Ajmavatkot','387610',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5676,16,'Akhdol','387355',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5677,16,'Aklacha','387430',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5678,16,'Alina','387305',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5679,16,'Alindra (Matar)','387510',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5680,16,'Alindra (Nadiad)','387115',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5681,16,'Alwa','387620',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5682,16,'Ambaliara','387620',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5683,16,'Aminpura','387620',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5684,16,'Amrapura','387130',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5685,16,'Anara','387630',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5686,16,'Antisar','387620',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5687,16,'Antisar Gat- Kpdvj','387620',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5688,16,'Antroli','387365',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5689,16,'Antroli','387570',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5690,16,'Apruji','387610',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5691,16,'Arera','387320',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5692,16,'Asamli','387530',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5693,16,'Ashram Road -Nadiad','387001',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5694,16,'Attarsumba','387610',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5695,16,'Badarpur','387635',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5696,16,'Bamangam','388180',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5697,16,'Bandhani','388410',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5698,16,'Bavra','387130',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5699,16,'Betawada','387650',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5700,16,'Bhadkad','387380',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5701,16,'Bhailakui','387610',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5702,16,'Bhaner','387630',1,0,'2022-03-03 12:21:28','2022-03-03 12:21:28'),(5703,16,'Bharkunda','387430',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5704,16,'Bhatera','387630',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5705,16,'Bhoja Na Muvada','387650',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5706,16,'Bhumel','387370',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5707,16,'Bhungalia','387620',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5708,16,'Bhutia','387620',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5709,16,'Bidaj','387120',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5710,16,'Bilodara','387002',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5711,16,'Bngroli','387350',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5712,16,'Bnmroli','387350',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5713,16,'Bochasan','388140',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5714,16,'Chaklashi','387315',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5715,16,'Chalali','387115',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5716,16,'Chandana','387560',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5717,16,'Changa','388421',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5718,16,'Charan Nikol','387640',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5719,16,'Chhapra','387130',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5720,16,'Chhipdi','387635',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5721,16,'Chhipial','387635',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5722,16,'Chikhlod','387640',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5723,16,'Chunel','387330',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5724,16,'Chuva','388140',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5725,16,'Dabhan','387320',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5726,16,'Dadusar','387335',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5727,16,'Dahiup','387620',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5728,16,'Dampat','387630',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5729,16,'Dana','387630',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5730,16,'Danadra','387620',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5731,16,'Dasalwada','387365',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5732,16,'Davda','387350',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5733,16,'Degam','387320',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5734,16,'Demol','387710',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5735,16,'Desai Vago','387001',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5736,16,'Dethli','387210',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5737,16,'Deva','387380',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5738,16,'Devki Vansol','387130',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5739,16,'Dharoda','387540',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5740,16,'Dhathal','387550',1,0,'2022-03-03 12:21:29','2022-03-03 12:21:29'),(5741,16,'Dudhathal','387620',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5742,16,'Dumaral','387355',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5743,16,'Dumral Bazar','387001',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5744,16,'Fagvel','387640',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5745,16,'Fatepur','387370',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5746,16,'Garmala','387510',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5747,16,'Garod','387620',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5748,16,'Ghadia','387620',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5749,16,'Ghodali','387130',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5750,16,'Ghodasar (Kheda)','387110',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5751,16,'Ghogawada','387630',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5752,16,'Gobalaj','387540',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5753,16,'Gothaj','387130',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5754,16,'Gutal','387370',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5755,16,'Haldarvas','387110',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5756,16,'Hariala','387570',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5757,16,'Hathaj','387360',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5758,16,'Hathnoli','387110',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5759,16,'Heranj','387510',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5760,16,'Heranj','387330',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5761,16,'Jalia','387335',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5762,16,'Jamni','387630',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5763,16,'Jaravat','387110',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5764,16,'Jher','387620',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5765,16,'Kachchhai','387130',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5766,16,'Kakarkhad','387635',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5767,16,'Kalaji','387620',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5768,16,'Kaloli','387550',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5769,16,'Kanera','387540',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5770,16,'Kaniel','387365',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5771,16,'Kanij','387120',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5772,16,'Kanjari','387325',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5773,16,'Kanjoda','387115',1,0,'2022-03-03 12:21:30','2022-03-03 12:21:30'),(5774,16,'Kapadwanj','387620',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5775,16,'Kaparupur','387305',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5776,16,'Karoli','387710',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5777,16,'Karoli','387335',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5778,16,'Kathana','387640',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5779,16,'Kathlal','387630',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5780,16,'Kavath','387620',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5781,16,'Keriavi','387355',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5782,16,'Kesara','387430',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5783,16,'Khada','387530',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5784,16,'Khadol','387365',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5785,16,'Khandhli','387510',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5786,16,'Kharanti','387520',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5787,16,'Khatraj','387130',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5788,16,'Kheda H.O','387411',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5789,16,'Khumarwad','387570',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5790,16,'Khuntaj','387430',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5791,16,'Kosam','387610',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5792,16,'Koshiyal','387530',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5793,16,'Kuna','387110',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5794,16,'Ladvel','387640',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5795,16,'Lali','387120',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5796,16,'Lasundra','387640',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5797,16,'Laval','387380',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5798,16,'Letar','387620',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5799,16,'Limbasi','387520',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5800,16,'Machhiel','387530',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5801,16,'Mahelaj','387530',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5802,16,'Mahemdavad','387130',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5803,16,'Mahij','387120',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5804,16,'Mahisa','387340',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5805,16,'Mahudha','387335',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5806,16,'Mal Itadi','387640',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5807,16,'Malavada','387520',1,0,'2022-03-03 12:21:31','2022-03-03 12:21:31'),(5808,16,'Maliataj','387380',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5809,16,'Manghroli','387115',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5810,16,'Manjipura','387320',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5811,16,'Mankwa','387130',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5812,16,'Marida','387360',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5813,16,'Matar','387530',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5814,16,'Methodist Hospital Tso Nad','387002',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5815,16,'Minavada','387630',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5816,16,'Mitral','387710',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5817,16,'Modaj','387110',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5818,16,'Mohlel','387330',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5819,16,'Nadhanpur','387530',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5820,16,'Nadiad H.O','387001',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5821,16,'Nani Khadol','387335',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5822,16,'Narsanda','387345',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5823,16,'Navagam','387620',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5824,16,'Navagam','387710',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5825,16,'Navagam','387540',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5826,16,'Nayka','387550',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5827,16,'Nenpur','387130',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5828,16,'Nirmali (Kheda)','387650',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5829,16,'Nizampura','387340',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5830,16,'Palaiya','387330',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5831,16,'Palana','387350',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5832,16,'Palla','387530',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5833,16,'Parsaantaj','387130',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5834,16,'Patel Society Area Tso Nad','387002',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5835,16,'Pij','387230',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5836,16,'Piplag','387355',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5837,16,'Piplata','387355',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5838,16,'Pithai','387630',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5839,16,'Porda (Bhatera)','387630',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5840,16,'Porda Fagvel','387640',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5841,16,'Punadra','387610',1,0,'2022-03-03 12:21:32','2022-03-03 12:21:32'),(5842,16,'Radhu','387560',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5843,16,'Radhvanaj','387570',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5844,16,'Rajnagar','387345',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5845,16,'Rampur','387710',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5846,16,'Rasikpura','387560',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5847,16,'Raska','387120',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5848,16,'Ratanpur (Kheda)','387570',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5849,16,'Ravdavat','387610',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5850,16,'Ravli','387375',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5851,16,'Rinchhol','387430',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5852,16,'Rudan','387335',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5853,16,'Ruppura','387335',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5854,16,'Salun','387360',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5855,16,'Samadara','387120',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5856,16,'Sanali','387330',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5857,16,'Sandesar','387610',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5858,16,'Sandhana','387350',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5859,16,'Sanjaya','387375',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5860,16,'Sankhej','387120',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5861,16,'Sansoli','387130',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5862,16,'Sarali','387630',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5863,16,'Saraswani','387430',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5864,16,'Sarkhej','387635',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5865,16,'Sastapur','387335',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5866,16,'Savli','387620',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5867,16,'Sayla','387530',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5868,16,'Shatrunda','387430',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5869,16,'Sheri','387305',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5870,16,'Shetra','387560',1,0,'2022-03-03 12:21:33','2022-03-03 12:21:33'),(5871,16,'Shurasamal','387115',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5872,16,'Silod','387320',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5873,16,'Singhali','387430',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5874,16,'Sinhuj','387430',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5875,16,'Sinjivada','388180',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5876,16,'Sodpur','387330',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5877,16,'Sokhada','387570',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5878,16,'Sorna','387620',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5879,16,'SRP Group Area Nadiad','387001',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5880,16,'Sunda','387620',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5881,16,'Telnar','387650',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5882,16,'Thavad','387620',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5883,16,'Torania','387335',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5884,16,'Torna','387365',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5885,16,'Traj','387530',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5886,16,'Tranja','387530',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5887,16,'Tundel','387230',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5888,16,'Ukardina Muvada','387610',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5889,16,'Undhela','387510',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5890,16,'Undra','387335',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5891,16,'Uttarsanda','387370',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5892,16,'Vadadla','387130',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5893,16,'Vadali','387620',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5894,16,'Vadol','387640',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5895,16,'Vadtal','387375',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5896,16,'Vadthal','387335',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5897,16,'Vaghas','387620',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5898,16,'Vaghjipur','387610',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5899,16,'Valetva','388440',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5900,16,'Vansol','387335',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5901,16,'Vansol','387115',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5902,16,'Vansol Sundha','387430',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5903,16,'Vanthavali','387430',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5904,16,'Varsang','387560',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5905,16,'Varsola','387130',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5906,16,'Vasna','387340',1,0,'2022-03-03 12:21:34','2022-03-03 12:21:34'),(5907,16,'Vasna Buzarg','387560',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5908,16,'Vasna Margia','387120',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5909,16,'Vaso','387380',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5910,16,'Vastana','388180',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5911,16,'Vina','387430',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5912,16,'Vishnupura','387620',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5913,16,'Vyas Vasna','387650',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5914,17,'Abrama','394150',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5915,17,'Afva Isroli','394620',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5916,17,'Agasvan','394651',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5917,17,'Akoti','394355',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5918,17,'Algat','394246',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5919,17,'Allu','394620',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5920,17,'Amalgundi','394365',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5921,17,'Amalsadi','394350',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5922,17,'Amalsadi','394163',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5923,17,'Amba','394163',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5924,17,'Ambach','394641',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5925,17,'Ambheti','394352',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5926,17,'Ambia','394633',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5927,17,'Amchak','394250',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5928,17,'Amoda','394380',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5929,17,'Anaval','396510',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5930,17,'Andhatri','394630',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5931,17,'Antapur','394635',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5932,17,'Antroli','394150',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5933,17,'Antroli','394325',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5934,17,'Antroli','394170',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5935,17,'Areth','394170',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5936,17,'Asta','394320',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5937,17,'Babarghat','394375',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5938,17,'Bagumara','394305',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5939,17,'Bahedaraipura','394630',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5940,17,'Bajipura','394690',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5941,17,'Balda','394340',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5942,17,'Baleshwar','394317',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5943,17,'Balpur','394655',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5944,17,'Bamni','394335',1,0,'2022-03-03 12:21:35','2022-03-03 12:21:35'),(5945,17,'Barasado','394310',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5946,17,'Bardipada','394635',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5947,17,'Bardipada','394715',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5948,17,'Bardoli H.O','394601',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5949,17,'Bartad','394240',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5950,17,'Bedchit','394630',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5951,17,'Bedkuva','394340',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5952,17,'Bedkuvadoor','394360',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5953,17,'Bedkuvanajik','394650',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5954,17,'Bhadbhunja','394375',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5955,17,'Bhagvanpura','394246',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5956,17,'Bhalkhet','394715',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5957,17,'Bhamaiya','394335',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5958,17,'Bhatwada','394680',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5959,17,'Bhimpor','394640',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5960,17,'Bhitkhurd','394375',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5961,17,'Bhljamboli','394370',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5962,17,'Bhojpur Najik','394690',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5963,17,'Bhoria','394248',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5964,17,'Bhutwada','394690',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5965,17,'Bilkhadi','394250',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5966,17,'Bodhan (Surat)','394140',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5967,17,'Borkhadi','394690',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5968,17,'Borsavar','394670',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5969,17,'Bortha','394370',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5970,17,'Butwada','394248',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5971,17,'Centrap Pulp Mill','394660',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5972,17,'Chalthan','394305',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5973,17,'Champavadi','394650',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5974,17,'Chhapti','394375',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5975,17,'Chhindia','394655',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5976,17,'Chhitpur','394375',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5977,17,'Chhitra','394350',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5978,17,'Chikalda','394650',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5979,17,'Chikhali Dungar','394320',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5980,17,'Chikhali Khadka','394650',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5981,17,'Chikhalvav','394650',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5982,17,'Chikhlinani','394650',1,0,'2022-03-03 12:21:36','2022-03-03 12:21:36'),(5983,17,'Chinchinagaontha','394715',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(5984,17,'Chirmati','394380',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(5985,17,'Chokhiamli','394380',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(5986,17,'Chorvad','394650',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(5987,17,'Chunavadi','394635',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(5988,17,'Dadaria','394630',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(5989,17,'Dadhwada','394160',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(5990,17,'Dastan','394310',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(5991,17,'Dedvasan','394250',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(5992,17,'Degama','394690',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(5993,17,'Delad','394330',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(5994,17,'Delvada','394620',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(5995,17,'Dhajamba','394670',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(5996,17,'Dhamdod Lumbha','394355',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(5997,17,'Dhamkhadi','394248',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(5998,17,'Dhamodi','394650',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(5999,17,'Dhamodla','394340',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(6000,17,'Dhanturi','394633',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(6001,17,'Dhat','394655',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(6002,17,'Dhatva','394180',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(6003,17,'Dholikui','394250',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(6004,17,'Dhoranpardi','394150',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(6005,17,'Digas','394330',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(6006,17,'Dolara','394655',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(6007,17,'Doswada','394365',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(6008,17,'Dungra','394180',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(6009,17,'Dungri','394240',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(6010,17,'Ena','394310',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(6011,17,'Fali','394163',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(6012,17,'Fort Songadh','394670',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(6013,17,'Fulwadi','394160',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(6014,17,'Galkuva','394650',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(6015,17,'Gamtalv Bujrang','394163',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(6016,17,'Gandhi Vidyapith','394641',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(6017,17,'Gangadhara RS','394310',1,0,'2022-03-03 12:21:37','2022-03-03 12:21:37'),(6018,17,'Gangadia','396510',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6019,17,'Gangtha','394380',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6020,17,'Gavachhi','394140',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6021,17,'Gavan','394375',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6022,17,'Ghadoi','394245',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6023,17,'Ghala','394155',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6024,17,'Ghani','394630',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6025,17,'Ghantoli','394160',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6026,17,'Ghasiamedha','394360',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6027,17,'Ghata','394651',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6028,17,'Gherivan','394630',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6029,17,'Ghoda','394670',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6030,17,'Godawadi','394163',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6031,17,'Goddha','394630',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6032,17,'Goddha','394160',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6033,17,'Godsamba','394163',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6034,17,'Goji','394350',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6035,17,'Gopalpura','394365',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6036,17,'Gujarpur','394370',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6037,17,'Gunesvel','394240',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6038,17,'Gunkhadi','394365',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6039,17,'Haladva','394248',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6040,17,'Haldharu','394310',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6041,17,'Haripur','394375',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6042,17,'Haripura','394335',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6043,17,'Hathoda','394380',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6044,17,'Hatuka','394640',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6045,17,'Hindla','394365',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6046,17,'Hiravadi','394365',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6047,17,'Italva','394315',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6048,17,'Itwai','394380',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6049,17,'Jakhala','394160',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6050,17,'Jamania','394246',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6051,17,'Jamankuva','394160',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6052,17,'Jamkhadi','394365',1,0,'2022-03-03 12:21:38','2022-03-03 12:21:38'),(6053,17,'Jesingpur','394633',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6054,17,'Jokha','394326',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6055,17,'Jolwa','394305',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6056,17,'Kadhaiya','394246',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6057,17,'Kadod','394335',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6058,17,'Kadodara','394327',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6059,17,'Kaher','394690',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6060,17,'Kakadva','394635',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6061,17,'Kakarapargam','394160',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6062,17,'Kakrapar','394360',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6063,17,'Kalakva','394630',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6064,17,'Kalamkui','394635',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6065,17,'Kalamkui','394340',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6066,17,'Kalibel','394715',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6067,17,'Kamlapore','394335',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6068,17,'Kamrej Char Rasta','394185',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6069,17,'Kamrej','394180',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6070,17,'Kanav','394315',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6071,17,'Kani','394350',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6072,17,'Kanjan','394655',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6073,17,'Kanjod','394640',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6074,17,'Kankaria','394248',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6075,17,'Kantifalia','394340',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6076,17,'Karachka','394340',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6077,17,'Karan','394305',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6078,17,'Karanjkhed','394635',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6079,17,'Karanjvel','394655',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6080,17,'Karchelia','394240',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6081,17,'Karjan','394155',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6082,17,'Karod','394375',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6083,17,'Karvali','394163',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6084,17,'Kasal','394163',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6085,17,'Kasvav','394633',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6086,17,'Katasvan','394650',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6087,17,'Kathodara','394326',1,0,'2022-03-03 12:21:39','2022-03-03 12:21:39'),(6088,17,'Kathor','394150',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6089,17,'Kelkui','394630',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6090,17,'Khabda','394375',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6091,17,'Khanjar','394365',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6092,17,'Khanjroli','394335',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6093,17,'Khanpur','394641',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6094,17,'Khanpur','394320',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6095,17,'Kharoli','394163',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6096,17,'Kharvan','394245',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6097,17,'Kharvasa','394355',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6098,17,'Khatal','394715',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6099,17,'Khodamba','394163',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6100,17,'Khodtalav','394651',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6101,17,'Khojpardi','394355',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6102,17,'Kholeshwar','394180',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6103,17,'Kholvad','394190',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6104,17,'Khorda','394370',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6105,17,'Khurdi','394655',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6106,17,'Khushalpura','394650',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6107,17,'Khutadia','394655',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6108,17,'Kikakui','394650',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6109,17,'Kikwad','394620',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6110,17,'Kim Dungara','394160',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6111,17,'Kodada','394250',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6112,17,'Kolibharthana','394180',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6113,17,'Kos','396510',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6114,17,'Kosadi','394335',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6115,17,'Kosimda','394715',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6116,17,'Kosmadi','394326',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6117,17,'Kulda','394375',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6118,17,'Kumkotar','396510',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6119,17,'Kumkuva','394670',1,0,'2022-03-03 12:21:40','2022-03-03 12:21:40'),(6120,17,'Ladvi','394325',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6121,17,'Lakhali','394655',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6122,17,'Lakhanpur','394352',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6123,17,'Lakhgam','394160',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6124,17,'Lasanpor','396510',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6125,17,'Laxmikheda','394370',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6126,17,'Limberda','394651',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6127,17,'Limbi','394680',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6128,17,'Lotarva','394690',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6129,17,'Madhi','394340',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6130,17,'Magalia','394633',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6131,17,'Magarbara','394375',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6132,17,'Magarkui','394655',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6133,17,'Mahuva (Surat)','394250',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6134,17,'Mahuvaria','394248',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6135,17,'Malangdev','394716',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6136,17,'Malekpor','394315',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6137,17,'Mandvi SR','394160',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6138,17,'Manekpor','394340',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6139,17,'Mankna','394325',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6140,17,'Masad','394335',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6141,17,'Mataval','394380',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6142,17,'Mirkot','394670',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6143,17,'Mirpur','394655',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6144,17,'Miyapur','394250',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6145,17,'Moghvan','394650',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6146,17,'Mohni','394305',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6147,17,'Moramba','394380',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6148,17,'Mordevi','394250',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6149,17,'Moritha','394160',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6150,17,'Morthana','394325',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6151,17,'Mota','394345',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6152,17,'Mota Tarpada','394365',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6153,17,'Moti Khervan','394670',1,0,'2022-03-03 12:21:41','2022-03-03 12:21:41'),(6154,17,'Moticheir','394651',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6155,17,'Motifalod','394355',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6156,17,'Mubarakpur','394370',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6157,17,'Munjlav','394140',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6158,17,'Nagod','394320',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6159,17,'Naldhara','394240',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6160,17,'Nandpore','394163',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6161,17,'Nansad','394180',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6162,17,'Narayanpur','394375',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6163,17,'Naren','394163',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6164,17,'Naugama','394350',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6165,17,'Navafalia','394640',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6166,17,'Navagam','394185',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6167,17,'Navipardi','394150',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6168,17,'Netrang','394180',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6169,17,'Nijhar','394370',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6170,17,'Nimbhora','394380',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6171,17,'Ninat','394350',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6172,17,'Niol','394325',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6173,17,'Nishana','394650',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6174,17,'Nizar','394350',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6175,17,'Nogama','394170',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6176,17,'Orgam','394340',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6177,17,'Orna','394330',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6178,17,'Padamdungri','394635',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6179,17,'Palawadi','394633',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6180,17,'Palsana (Surat)','394315',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6181,17,'Palsod','394355',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6182,17,'Panchol','394635',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6183,17,'Panchpipla','394360',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6184,17,'Paniyari','394650',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6185,17,'Parab','394325',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6186,17,'Patal','394163',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6187,17,'Pathakvadi','394635',1,0,'2022-03-03 12:21:42','2022-03-03 12:21:42'),(6188,17,'Pathran','394620',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6189,17,'Pati','394635',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6190,17,'Pelad','394630',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6191,17,'Phulwadi','394380',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6192,17,'Pipaldahad','394716',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6193,17,'Pipalkuva','394670',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6194,17,'Piplod','394370',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6195,17,'Pisavar','394380',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6196,17,'Pithadara','394635',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6197,17,'Puna','394163',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6198,17,'Puna','394248',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6199,17,'Puni','394352',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6200,17,'Raigadh','394370',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6201,17,'Ranat','394350',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6202,17,'Raniamba','394655',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6203,17,'Ranveri','394640',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6204,17,'Ratania','394360',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6205,17,'Rayam','394355',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6206,17,'Regama','394160',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6207,17,'Roswad','394170',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6208,17,'Rumkitalav','394370',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6209,17,'Rupan','394160',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6210,17,'Rupvada','394690',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6211,17,'Sadadvel','394365',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6212,17,'Sadgavan','394380',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6213,17,'Salaiya','394160',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6214,17,'Samba','394248',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6215,17,'Samrod','394315',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6216,17,'Samthan','394335',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6217,17,'Sankarda','394375',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6218,17,'Sankli','394655',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6219,17,'Sarbhon','394350',1,0,'2022-03-03 12:21:43','2022-03-03 12:21:43'),(6220,17,'Sardarbaug (Bardoli)','394601',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6221,17,'Sarkui','394160',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6222,17,'Sarovar','394715',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6223,17,'Sarvala','394370',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6224,17,'Sathvav','394160',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6225,17,'Sayla','394370',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6226,17,'Segupada','394365',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6227,17,'Segva','394320',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6228,17,'Sejvad','394620',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6229,17,'Selud','394375',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6230,17,'Sevni','394320',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6231,17,'Shampura','394330',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6232,17,'Shekhpur','394250',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6233,17,'Siker','394620',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6234,17,'Singod','394335',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6235,17,'Singpur','394670',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6236,17,'Sisor','394651',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6237,17,'Soyani','394310',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6238,17,'Sugar Factory Bamania','394246',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6239,17,'Sugar Factory Bardoli','394601',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6240,17,'Sunderpur','394375',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6241,17,'Surali','394340',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6242,17,'Syadla','394340',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6243,17,'Tadkeshwar','394170',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6244,17,'Taparwada','394365',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6245,17,'Taraj','394315',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6246,17,'Tarbhon','394350',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6247,17,'Tarsada','394160',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6248,17,'Tarsadi','394350',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6249,17,'Tatithaiya','394305',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6250,17,'Thuti','394670',1,0,'2022-03-03 12:21:44','2022-03-03 12:21:44'),(6251,17,'Timba','394330',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6252,17,'Timbarva','394305',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6253,17,'Timbarva Sankri','394355',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6254,17,'Tokarva','394375',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6255,17,'Tuked','394163',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6256,17,'Tundi','394310',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6257,17,'Ukahlda','394670',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6258,17,'Umarakh','394345',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6259,17,'Umarkui','394630',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6260,17,'Umarkutch','394630',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6261,17,'Umarvavdoor','394635',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6262,17,'Umbhel','394325',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6263,17,'Umra','394248',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6264,17,'Unchamala','394651',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6265,17,'Unteva','394163',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6266,17,'Uva','394340',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6267,17,'Vadadla Tanti','394317',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6268,17,'Vadhvania','394335',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6269,17,'Vadia','394246',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6270,17,'Vadibehsrot','394670',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6271,17,'Vadoli','394350',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6272,17,'Vaghecha','394355',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6273,17,'Vaheval','394248',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6274,17,'Valod','394640',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6275,17,'Valvada','394248',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6276,17,'Vanisa Pisadi','394310',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6277,17,'Vanka','394370',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6278,17,'Vankaner (SR)','394620',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6279,17,'Vankla','394630',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6280,17,'Vanskui','394340',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6281,17,'Vanskui','394651',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6282,17,'Vanskui','394240',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6283,17,'Vanzarda','394651',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6284,17,'Varad','394355',1,0,'2022-03-03 12:21:45','2022-03-03 12:21:45'),(6285,17,'Vareli','394140',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6286,17,'Vareth','394160',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6287,17,'Vatsalyadham','394340',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6288,17,'Vav Kathodara','394326',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6289,17,'Vegi','394170',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6290,17,'Velanja','394150',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6291,17,'Velanpur','394245',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6292,17,'Veldha','394370',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6293,17,'Vihan','394320',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6294,17,'Virpur','394155',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6295,17,'Virpur','394650',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6296,17,'Vyara RS','394650',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6297,17,'Vyara','394650',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6298,17,'Vyaval','394370',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6299,17,'Wcc Ukai','394680',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6300,17,'Zab','394163',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6301,17,'Zankhari','394655',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6302,17,'Zervavra','394245',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6303,17,'Ankhi','392150',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6304,17,'Babda','393130',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6305,17,'Borda','393050',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6306,17,'Kuilivel','393050',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6307,17,'Sabaria','393125',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6308,17,'A. K. Road','395008',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6309,17,'Abhva','395007',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6310,17,'Adajan Dn','395009',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6311,17,'Adityanagar','394516',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6312,17,'Aganovad','395003',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6313,17,'Althan','395017',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6314,17,'Ambawadi','394430',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6315,17,'Ambheta','395005',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6316,17,'Amkhuta','394430',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6317,17,'Amroli','394107',1,0,'2022-03-03 12:21:46','2022-03-03 12:21:46'),(6318,17,'Anand Mahal Road','395009',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6319,17,'Anita','394110',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6320,17,'Ankodod','394410',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6321,17,'Ariana','395005',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6322,17,'Asaram','394405',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6323,17,'Asnad','394540',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6324,17,'Athwa','395007',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6325,17,'Athwalines','395001',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6326,17,'Atodara','394130',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6327,17,'Balethi','394440',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6328,17,'Bamroli','394210',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6329,17,'Barbodhan','395005',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6330,17,'Bhadol','394540',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6331,17,'Bhagal','395003',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6332,17,'Bhagwa','394530',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6333,17,'Bhandut','395005',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6334,17,'Bharan','394125',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6335,17,'Bharthana','395007',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6336,17,'Bharundi','394130',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6337,17,'Bhatgam','394540',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6338,17,'Bhatha','394510',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6339,17,'Bhatlai','394517',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6340,17,'Bhatpore','394510',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6341,17,'Bhavanivad','395003',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6342,17,'Bhedvad','394210',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6343,17,'Bhesan','395005',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6344,17,'Bhestan','395023',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6345,17,'Bhilvada','394421',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6346,17,'Bhimpore','394550',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6347,17,'Bilvan','394445',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6348,17,'Bombay Market','395010',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6349,17,'Bonandh','394230',1,0,'2022-03-03 12:21:47','2022-03-03 12:21:47'),(6350,17,'Boria','394430',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6351,17,'Boridra','394125',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6352,17,'Borsad','394110',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6353,17,'Budia','394210',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6354,17,'Bundha','394440',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6355,17,'Chavda','394445',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6356,17,'Chhapra Bhatha','394107',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6357,17,'Chimipatal','394445',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6358,17,'Chitalda','394440',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6359,17,'Chokhvada','394445',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6360,17,'Choramba','394440',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6361,17,'Dabholi','395004',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6362,17,'Damka','394517',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6363,17,'Dandi','394540',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6364,17,'Deladva','394210',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6365,17,'Delasa','394530',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6366,17,'Devadh','394210',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6367,17,'Devadh','394440',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6368,17,'Dhamdod','394125',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6369,17,'Dholikui','394430',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6370,17,'Dhrampur','394110',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6371,17,'Dihen','395005',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6372,17,'Dindoli','394210',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6373,17,'Dinod','394125',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6374,17,'Dumas','394550',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6375,17,'Dumasgam','394550',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6376,17,'Dungri','394110',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6377,17,'Eklera','394230',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6378,17,'Erthan','394540',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6379,17,'Fulpada','395008',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6380,17,'G.I.P.C.L.','394110',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6381,17,'Gabheni','394230',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6382,17,'Gavier','395007',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6383,17,'Ghanavad','394445',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6384,17,'Gijram','394410',1,0,'2022-03-03 12:21:48','2022-03-03 12:21:48'),(6385,17,'Godadara','395012',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6386,17,'Godbar','394440',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6387,17,'Gopipura','395001',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6388,17,'Gotalawadi','395004',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6389,17,'Gothan','394130',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6390,17,'Govt. Medical College','395001',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6391,17,'Hajira','394270',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6392,17,'Harsani','394421',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6393,17,'Hathoda','394405',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6394,17,'Hathuran','394125',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6395,17,'Ichhapore','394510',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6396,17,'Inderpura','395002',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6397,17,'Isanpur','394430',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6398,17,'Ishanpore','394540',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6399,17,'Jhampa','395003',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6400,17,'Kachholi','394235',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6401,17,'Kadrama','394540',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6402,17,'Kafleta','394235',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6403,17,'Kamroli','394540',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6404,17,'Kanakpur','394230',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6405,17,'Kansad','394230',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6406,17,'Kantva','394405',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6407,17,'Karanj','394530',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6408,17,'Karanj','394110',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6409,17,'Karmala','394130',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6410,17,'Katargam GIDC','395004',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6411,17,'Katargam','395004',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6412,17,'Kawas','394510',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6413,17,'Keori','394445',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6414,17,'Khajod','395007',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6415,17,'Kharvasa','394210',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6416,17,'Khatodara','395002',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6417,17,'Khota Rampura','394445',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6418,17,'Kim Char Rasta','394111',1,0,'2022-03-03 12:21:49','2022-03-03 12:21:49'),(6419,17,'Kim','394110',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6420,17,'Koba','394540',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6421,17,'Kosad','394107',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6422,17,'Kosadi','394405',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6423,17,'Kosam','394520',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6424,17,'Kosamba Bazar','394120',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6425,17,'Kosamba','394120',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6426,17,'Kosmada','395006',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6427,17,'Kothwa','394110',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6428,17,'Kribhconagar','394515',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6429,17,'Kudiana','394540',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6430,17,'Kudsad','394110',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6431,17,'Kumbharia','395010',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6432,17,'Kunvarda','394120',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6433,17,'Lajpore','394235',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6434,17,'Laskana','395006',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6435,17,'Lavachha','394540',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6436,17,'Lavet','394430',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6437,17,'Limbada','394405',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6438,17,'Limbayat','395012',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6439,17,'Limodra','394110',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6440,17,'Lingad','394230',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6441,17,'Luharvad','394440',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6442,17,'Luvara','394405',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6443,17,'Madan Boria','394440',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6444,17,'Madhar','394130',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6445,17,'Magdalla','395007',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6446,17,'Mahidharpura','395003',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6447,17,'Mahuvej','394125',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6448,17,'Maldha','394440',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6449,17,'Mandroi','394540',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6450,17,'Masma','394540',1,0,'2022-03-03 12:21:50','2022-03-03 12:21:50'),(6451,17,'Mohamedpur','394540',1,0,'2022-03-03 12:21:51','2022-03-03 12:21:51'),(6452,17,'Mor','394530',1,0,'2022-03-03 12:21:51','2022-03-03 12:21:51'),(6453,17,'Mora (Surat)','394517',1,0,'2022-03-03 12:21:51','2022-03-03 12:21:51'),(6454,17,'Morthana','394130',1,0,'2022-03-03 12:21:51','2022-03-03 12:21:51'),(6455,17,'Mosali','394421',1,0,'2022-03-03 12:21:51','2022-03-03 12:21:51'),(6456,17,'Mota Borsara','394110',1,0,'2022-03-03 12:21:51','2022-03-03 12:21:51'),(6457,17,'Mota Miya Mangrol','394410',1,0,'2022-03-03 12:21:51','2022-03-03 12:21:51'),(6458,17,'Mota Varachha','394101',1,0,'2022-03-03 12:21:51','2022-03-03 12:21:51'),(6459,17,'Motived','395004',1,0,'2022-03-03 12:21:51','2022-03-03 12:21:51'),(6460,17,'Muglisara','395003',1,0,'2022-03-03 12:21:51','2022-03-03 12:21:51'),(6461,17,'Mulad','394110',1,0,'2022-03-03 12:21:51','2022-03-03 12:21:51'),(6462,17,'Nandav','394125',1,0,'2022-03-03 12:21:51','2022-03-03 12:21:51'),(6463,17,'Nandniketan','394270',1,0,'2022-03-03 12:21:51','2022-03-03 12:21:51'),(6464,17,'Nandola','394430',1,0,'2022-03-03 12:21:51','2022-03-03 12:21:51'),(6465,17,'Nani Naroli','394110',1,0,'2022-03-03 12:21:51','2022-03-03 12:21:51'),(6466,17,'Nanpura H.O','395001',1,0,'2022-03-03 12:21:51','2022-03-03 12:21:51'),(6467,17,'Narthan','395005',1,0,'2022-03-03 12:21:51','2022-03-03 12:21:51'),(6468,17,'Nasarpur','394440',1,0,'2022-03-03 12:21:51','2022-03-03 12:21:51'),(6469,17,'Navyug College','395009',1,0,'2022-03-03 12:21:51','2022-03-03 12:21:51'),(6470,17,'Nawabwadi','395003',1,0,'2022-03-03 12:21:51','2022-03-03 12:21:51'),(6471,17,'Nogama','394405',1,0,'2022-03-03 12:21:51','2022-03-03 12:21:51'),(6472,17,'Olpad','394540',1,0,'2022-03-03 12:21:51','2022-03-03 12:21:51'),(6473,17,'Ongc Nagar','394518',1,0,'2022-03-03 12:21:51','2022-03-03 12:21:51'),(6474,17,'Orma','394540',1,0,'2022-03-03 12:21:51','2022-03-03 12:21:51'),(6475,17,'Pal Bhatha','394510',1,0,'2022-03-03 12:21:51','2022-03-03 12:21:51'),(6476,17,'Palanpur Nd','395009',1,0,'2022-03-03 12:21:51','2022-03-03 12:21:51'),(6477,17,'Pandesara','394221',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6478,17,'Panjroli','394120',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6479,17,'Pardi Bhadol','394540',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6480,17,'Paria','394130',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6481,17,'Parvat','395012',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6482,17,'Parvat Patia','395010',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6483,17,'Pasodara','395006',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6484,17,'Pinjrat','395005',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6485,17,'Piplod (Surat)','395007',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6486,17,'Pipodara','394110',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6487,17,'Popda','394235',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6488,17,'Puna Kumbharia','395011',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6489,17,'Ramnagar (Surat)','395009',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6490,17,'Rander','395005',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6491,17,'Rustampura (Surat)','395002',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6492,17,'Sachin G.I.D.C.','394230',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6493,17,'Sachin R.S.','394230',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6494,17,'Sachin','394230',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6495,17,'Sagrampura Putli','395002',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6496,17,'Sandhier','394130',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6497,17,'Sania Hemad','395006',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6498,17,'Sania Kande','394210',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6499,17,'Saras','394540',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6500,17,'Sarda','394445',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6501,17,'Saroli','394520',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6502,17,'Saroli','395010',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6503,17,'Sarthana','395013',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6504,17,'Sarvan Fokdi','394445',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6505,17,'Sava','394120',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6506,17,'Sayan','394130',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6507,17,'Segva','394130',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6508,17,'Segva Chhama','395005',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6509,17,'Selut','395005',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6510,17,'Shah','394421',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6511,17,'Sherdi','394520',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6512,17,'Simodra','394405',1,0,'2022-03-03 12:21:52','2022-03-03 12:21:52'),(6513,17,'Singanpore','395004',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6514,17,'Sithan','394130',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6515,17,'Siyalaj','394110',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6516,17,'Sondla Khara','394540',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6517,17,'Sonsak','394540',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6518,17,'Surat City','395003',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6519,17,'Surat H.O','395003',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6520,17,'Surat RS','395003',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6521,17,'Surat Textile Market','395002',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6522,17,'Suvali','394517',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6523,17,'Svr College','395007',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6524,17,'Syadla','394130',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6525,17,'Takarma','394540',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6526,17,'Talangpur','394230',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6527,17,'Tarapur','394440',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6528,17,'Udharia','394440',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6529,17,'Udhna','394210',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6530,17,'Udhnagam','394210',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6531,17,'Umarda','394445',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6532,17,'Umargot','394445',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6533,17,'Umarpada','394445',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6534,17,'Umarzar','394440',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6535,17,'Umber','394230',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6536,17,'Umra','394130',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6537,17,'Umra','395007',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6538,17,'Un','394210',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6539,17,'Utran','394105',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6540,17,'Utran Power House','394105',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6541,17,'Vad','394440',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6542,17,'Vadi','394440',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6543,17,'Vadod','394540',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6544,17,'Vadoli','394110',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6545,17,'Vadpada','394445',1,0,'2022-03-03 12:21:53','2022-03-03 12:21:53'),(6546,17,'Vahar','394440',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6547,17,'Valak','395006',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6548,17,'Vankal','394430',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6549,17,'Vanz','394230',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6550,17,'Varachha Road','395006',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6551,17,'Varachhali','395006',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6552,17,'Varethi','394110',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6553,17,'Variav','394520',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6554,17,'Variavi Bhagal','395003',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6555,17,'Vasava','394517',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6556,17,'Vasravi','394421',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6557,17,'Vasta Devdi Road','395004',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6558,17,'Veer Narmad South Gujarat University','395007',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6559,17,'Vektana','394230',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6560,17,'Velachha','394405',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6561,17,'Verakui','394430',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6562,17,'Vesu','395007',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6563,17,'Vihara','394540',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6564,17,'Zankhvav','394440',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6565,18,'Ahwadangs','394710',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6566,18,'Barkhandhia','394730',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6567,18,'Bhavandgad','394710',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6568,18,'Borkhal','394710',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6569,18,'Chankhal','394710',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6570,18,'Chikar','394730',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6571,18,'Chikatia','394710',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6572,18,'Chikhali Dangs','394730',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6573,18,'Chinchli','394710',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6574,18,'Dagadiamba','394730',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6575,18,'Dagunia','394730',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6576,18,'Dhavlidhod','394710',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6577,18,'Galkund','394710',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6578,18,'Garakhadi','394710',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6579,18,'Ghadvi','394710',1,0,'2022-03-03 12:21:54','2022-03-03 12:21:54'),(6580,18,'Gondalvihir','394710',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6581,18,'Gotiamal','394720',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6582,18,'Jakhana','394710',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6583,18,'Jhavda','394730',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6584,18,'Kadmal','394716',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6585,18,'Keshbandh','394716',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6586,18,'Khambhala','394716',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6587,18,'Lavchali','394716',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6588,18,'Linga','394710',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6589,18,'Mahal','394716',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6590,18,'Mahalpada','394710',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6591,18,'Mahwshkatri','394715',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6592,18,'Malegaon','394720',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6593,18,'Manmodi','394730',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6594,18,'Morzira','394710',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6595,18,'Nadagchond','394730',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6596,18,'Nakatia Hanvant','394710',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6597,18,'Nanapada','394730',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6598,18,'Nishana','394716',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6599,18,'Pandva','394710',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6600,18,'Pimpri','394715',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6601,18,'Piplaidevi','394716',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6602,18,'Rambhas','394730',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6603,18,'Sakarpatal','394730',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6604,18,'Samgahan','394730',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6605,18,'Saputara','394720',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6606,18,'Singana','394716',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6607,18,'Subir','394716',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6608,18,'Tanklipada','394716',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6609,18,'Vasurna','394730',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6610,19,'Anumala','394651',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6611,19,'Buhari','394630',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6612,19,'Dolvan','394635',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6613,19,'Gadat (Tapi)','394633',1,0,'2022-03-03 12:21:55','2022-03-03 12:21:55'),(6614,19,'Kapura','394655',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6615,19,'Kukurmunda','394380',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6616,19,'Raniamba','394365',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6617,19,'Uchchhal','394375',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6618,19,'Ukai Dam','394680',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6619,19,'Vadkui','394651',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6620,19,'Vedchhi','394641',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6621,20,'Waghai','394730',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6622,20,'Zaridungarda','394730',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6623,20,'Aat','396403',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6624,20,'Abrama','396406',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6625,20,'Achhavani','396040',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6626,20,'Adada','396445',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6627,20,'Agasi','396060',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6628,20,'Ajarai','396360',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6629,20,'Alipore','396409',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6630,20,'Amadhara','396521',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6631,20,'Amadpore','396445',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6632,20,'Amalsad','396310',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6633,20,'Ambabari','396580',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6634,20,'Ambach(Chikhli)','396540',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6635,20,'Ambada','396469',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6636,20,'Ambapani','396580',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6637,20,'Ambheta','396409',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6638,20,'Amli Kasba','396445',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6639,20,'Ancheli','396310',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6640,20,'Antalia','396325',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6641,20,'Arak Sisodra','396475',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6642,20,'Asna','396415',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6643,20,'Astagam','396433',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6644,20,'Avada Falia','396439',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6645,20,'Bahej','396040',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6646,20,'Balvada','396521',1,0,'2022-03-03 12:21:56','2022-03-03 12:21:56'),(6647,20,'Bamanvel','396409',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6648,20,'Bartad','396590',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6649,20,'Bhatfalia','396310',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6650,20,'Bhatha','396310',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6651,20,'Bhattai','396427',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6652,20,'Bhinar','396436',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6653,20,'Bhinar','396590',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6654,20,'Bigri','396110',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6655,20,'Bilimora H.O','396321',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6656,20,'Bilimora RS','396321',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6657,20,'Bodali','396445',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6658,20,'Bodvank','396560',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6659,20,'Bori Falia','396412',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6660,20,'Boriach','396580',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6661,20,'Borsi','396436',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6662,20,'Chandravasansupa','396472',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6663,20,'Chapaldhara','396570',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6664,20,'Chapar','396310',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6665,20,'Charanvada','396580',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6666,20,'Chari','396040',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6667,20,'Chasa','396530',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6668,20,'Chhapra','396445',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6669,20,'Chhinam','396436',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6670,20,'Chijgam','396460',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6671,20,'Chikhli (Navsari)','396521',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6672,20,'Chokhad','396415',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6673,20,'Chondha','396580',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6674,20,'Chorvani','396580',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6675,20,'Chovisi','396427',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6676,20,'Dabhel','396415',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6677,20,'Dabhlai','396466',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6678,20,'Dambher','396472',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6679,20,'Dandi','396439',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6680,20,'Danti','396436',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6681,20,'Debarpada','396040',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6682,20,'Degam','396530',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6683,20,'Delvada Vadoli','396436',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6684,20,'Devdha','396310',1,0,'2022-03-03 12:21:57','2022-03-03 12:21:57'),(6685,20,'Devsar','396380',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6686,20,'Dhaman','396415',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6687,20,'Dhamdachha','396310',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6688,20,'Dhamdhuma','396060',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6689,20,'Dhanori(Gandevi)','396360',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6690,20,'Dharampuri','396590',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6691,20,'Dholai Falia','396110',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6692,20,'Dholumber  (Chikhli)','396060',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6693,20,'Dholumber','396321',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6694,20,'Digendranagar','396570',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6695,20,'Dipla Falia','396436',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6696,20,'Doldha','396321',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6697,20,'Donja','396560',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6698,20,'Dubalfalia','396580',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6699,20,'Duwada','396360',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6700,20,'Endhal','396430',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6701,20,'Eru Ac','396450',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6702,20,'Eru','396450',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6703,20,'Fadvel','396540',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6704,20,'Gadat (Navsari)','396350',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6705,20,'Gandeva','396430',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6706,20,'Gandevi','396360',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6707,20,'Gangpur','396580',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6708,20,'Gauri','396040',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6709,20,'Ghej','396521',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6710,20,'Ghodmal','396580',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6711,20,'Ghodvani','396060',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6712,20,'Gholar','396060',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6713,20,'Godhabari','396580',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6714,20,'Godthalbo','396060',1,0,'2022-03-03 12:21:58','2022-03-03 12:21:58'),(6715,20,'Gurukulsupa','396418',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6716,20,'Hansapore','396445',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6717,20,'Harangam','396560',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6718,20,'Ichhapore','396350',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6719,20,'Italva','396445',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6720,20,'Jalalpore','396421',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6721,20,'Jamalia','396580',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6722,20,'Jamalpore','396445',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6723,20,'Jamanpada','396040',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6724,20,'Jogvad','396560',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6725,20,'Junathana','396445',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6726,20,'Kabilpore','396424',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6727,20,'Kachholi','396370',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6728,20,'Kadoli','396436',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6729,20,'Kakadvel','396540',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6730,20,'Kakadveri','396040',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6731,20,'Kalakachha','396415',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6732,20,'Kalamtha','396310',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6733,20,'Kaliari','396540',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6734,20,'Kaliawadi','396427',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6735,20,'Kalthan','396406',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6736,20,'Kalvach','396409',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6737,20,'Kanbhai','396060',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6738,20,'Kandha','396580',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6739,20,'Kanera','396460',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6740,20,'Kangvai','396560',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6741,20,'Kansaria','396580',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6742,20,'Kantasvel','396321',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6743,20,'Karadi','396440',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6744,20,'Kasbapar','396445',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6745,20,'Kavdej','396580',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6746,20,'Kelia','396060',1,0,'2022-03-03 12:21:59','2022-03-03 12:21:59'),(6747,20,'Kesli','396360',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6748,20,'Khadsupa','396433',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6749,20,'Khadsupa Boarding','396433',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6750,20,'Khakhvada','396350',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6751,20,'Khambhda','396540',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6752,20,'Khambhla(Vansda)','396580',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6753,20,'Khaparia B0','396430',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6754,20,'Khaparvada','396321',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6755,20,'Kharel','396430',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6756,20,'Kharoli','396570',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6757,20,'Kharsad','396406',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6758,20,'Khata Ambha','396580',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6759,20,'Khergam (Ugat)','396469',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6760,20,'Khergam','396040',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6761,20,'Khergam(Gandevi)','396360',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6762,20,'Khudvel','396540',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6763,20,'Khundh','396521',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6764,20,'Kolva','396350',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6765,20,'Kotha','396310',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6766,20,'Kothamadi','396445',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6767,20,'Krishanapur','396460',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6768,20,'Kuched','396475',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6769,20,'Kukeri','396560',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6770,20,'Kumbhar Falia','396466',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6771,20,'Kurel','396469',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6772,20,'Kurelia','396590',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6773,20,'Lakhawadi','396321',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6774,20,'Limzar','396580',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6775,20,'Lusvada','396310',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6776,20,'Machhad','396440',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6777,20,'Machhia Vasan','396310',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6778,20,'Magob Bhatha','396436',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6779,20,'Mahudi','396466',1,0,'2022-03-03 12:22:00','2022-03-03 12:22:00'),(6780,20,'Mahuvas','396580',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6781,20,'Majigam','396521',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6782,20,'Malesar','396445',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6783,20,'Maliadhara','396521',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6784,20,'Mandavkhadak','396060',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6785,20,'Mandir','396472',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6786,20,'Manekpore Tankoli','396445',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6787,20,'Manekpore(Chikhli)','396560',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6788,20,'Manekpore(Gadat)','396350',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6789,20,'Mangrol','396436',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6790,20,'Mankunia','396580',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6791,20,'Manpur','396580',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6792,20,'Maroli','396436',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6793,20,'Maroli Bazar','396436',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6794,20,'Masa','396310',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6795,20,'Matvad','396439',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6796,20,'Mendhar','396310',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6797,20,'Minkachha','396430',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6798,20,'Mirzapore','396436',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6799,20,'Mogar','396445',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6800,20,'Mogravadi','396060',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6801,20,'Mohanpur','396310',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6802,20,'Molaamba','396580',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6803,20,'Moldhara','396427',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6804,20,'Moti Valzar','396321',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6805,20,'Motibhamti','396580',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6806,20,'Motikaarod','396406',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6807,20,'Motikakrad','396412',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6808,20,'Movasa Falia','396310',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6809,20,'Munsad','396463',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6810,20,'Nagdhara','396466',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6811,20,'Nandarkha','396325',1,0,'2022-03-03 12:22:01','2022-03-03 12:22:01'),(6812,20,'Nandhai','396040',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6813,20,'Naranpore','396040',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6814,20,'Navanagar','396580',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6815,20,'Navsari H.O','396445',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6816,20,'Navtad','396580',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6817,20,'Nogama','396430',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6818,20,'Ond','396521',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6819,20,'Onjal','396412',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6820,20,'Onjal Machhivad','396412',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6821,20,'Padgha','396445',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6822,20,'Palgabhan','396590',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6823,20,'Panaj','396040',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6824,20,'Panar','396460',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6825,20,'Panikhadak','396060',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6826,20,'Parthan','396475',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6827,20,'Parujan','396436',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6828,20,'Pati(Gandevi)','396360',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6829,20,'Patibo','396040',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6830,20,'Pera','396418',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6831,20,'Pethan','396445',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6832,20,'Pinsad','396475',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6833,20,'Pipalgabhan','396521',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6834,20,'Pipalkhed','396060',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6835,20,'Ponsra','396436',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6836,20,'Pratapnagarr','396321',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6837,20,'Raibor','396580',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6838,20,'Ranifalia','396580',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6839,20,'Rankuva','396560',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6840,20,'Ranverikalla','396560',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6841,20,'Ranverikhurd','396570',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6842,20,'Ravania','396060',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6843,20,'Rethvania','396560',1,0,'2022-03-03 12:22:02','2022-03-03 12:22:02'),(6844,20,'Rumla','396060',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6845,20,'Rupvel','396321',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6846,20,'Ruzvani','396040',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6847,20,'Sadadvel','396560',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6848,20,'Sadakpore','396521',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6849,20,'Sadlav','396463',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6850,20,'Sagra','396445',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6851,20,'Salej','396350',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6852,20,'Samapur','396439',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6853,20,'Samroli','396521',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6854,20,'Sandalpore','396475',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6855,20,'Sara','396590',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6856,20,'Saraiya','396560',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6857,20,'Sarav','396406',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6858,20,'Sarpore Pardi','396433',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6859,20,'Sarvani','396540',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6860,20,'Satem','396466',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6861,20,'Simalgam','396436',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6862,20,'Simlak','396415',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6863,20,'Sindhai','396590',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6864,20,'Singad','396321',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6865,20,'Sisodra','396463',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6866,20,'Siyada','396540',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6867,20,'Soldhara','396521',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6868,20,'Sonvadi','396350',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6869,20,'Sugar Factory','396360',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6870,20,'Sukhabari','396540',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6871,20,'Sultanpur','396406',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6872,20,'Supakurel','396418',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6873,20,'Surkhai','396560',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6874,20,'Suthvad','396530',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6875,20,'Talavchora','396521',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6876,20,'Taliarabo','396310',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6877,20,'Tankal','396560',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6878,20,'Tarsadi','396418',1,0,'2022-03-03 12:22:03','2022-03-03 12:22:03'),(6879,20,'Tavdi','396445',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6880,20,'Tejlav','396521',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6881,20,'Thala','396521',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6882,20,'Toli','396469',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6883,20,'Torangam','396360',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6884,20,'Toranvera','396040',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6885,20,'Ugat','396469',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6886,20,'Umarkui','396580',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6887,20,'Umbharat','396436',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6888,20,'Unai','396590',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6889,20,'Undach Luhar  Falia','396325',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6890,20,'Undach Vania Falia','396325',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6891,20,'Upsal','396580',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6892,20,'Vad','396040',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6893,20,'Vaghabari','396321',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6894,20,'Vaghrej','396321',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6895,20,'Valoti','396380',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6896,20,'Vanarasi','396580',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6897,20,'Vandervela','396540',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6898,20,'Vankal (Chikhli)','396325',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6899,20,'Vansda','396580',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6900,20,'Vanzana','396560',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6901,20,'Vasan(Gandevi)','396310',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6902,20,'Vav','396040',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6903,20,'Vedchha','396472',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6904,20,'Vegam','396350',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6905,20,'Vejalpore','396475',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6906,20,'Velanpore','396540',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6907,20,'Vesma','396475',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6908,20,'Viraval','396445',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6909,20,'Zari(Chikhli)','396060',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6910,20,'Zari(Vansda)','396321',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6911,20,'Khanpur','396051',1,0,'2022-03-03 12:22:04','2022-03-03 12:22:04'),(6912,20,'Lakadbari','396051',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6913,20,'Satimal','396051',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6914,21,'Achhod','392110',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6915,21,'Angareshwar','392030',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6916,21,'Ankleshwar IE','393002',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6917,21,'Arethi','393130',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6918,21,'Bhalod (Vadodara)','393105',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6919,21,'Bhersam','392012',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6920,21,'Chikda','393041',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6921,21,'Dabha','392150',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6922,21,'Haldarva','392220',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6923,21,'Jambusar Bazar','392150',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6924,21,'Koliad','392220',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6925,21,'Koral','393105',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6926,21,'Kothia','392140',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6927,21,'Lilod','393105',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6928,21,'Manad','392130',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6929,21,'Manubar','392160',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6930,21,'Matroj','392220',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6931,21,'Mesrad','392220',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6932,21,'Oz','393105',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6933,21,'Pachhiapura','392220',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6934,21,'Pursa','392110',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6935,21,'Rarod','393105',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6936,21,'Ropa','393105',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6937,21,'Samoj','392180',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6938,21,'Samor','393010',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6939,21,'Sansrod','392220',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6940,21,'Saring','392220',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6941,21,'Sayar','393105',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6942,21,'Segva','392210',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6943,21,'Sherpura','392015',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6944,21,'Vachchhesar','388710',1,0,'2022-03-03 12:22:05','2022-03-03 12:22:05'),(6945,21,'Achisara','391250',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6946,21,'Agar','391121',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6947,21,'Ajwa Road','390019',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6948,21,'Akakheda','391145',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6949,21,'Akona','391150',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6950,21,'Alhadpura','391135',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6951,21,'Amaliyara','390022',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6952,21,'Ambadungar','391175',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6953,21,'Ambala','391165',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6954,21,'Ambali','391115',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6955,21,'Ambapura','391145',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6956,21,'Amodar','390019',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6957,21,'Amroli','391150',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6958,21,'Anandi','391110',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6959,21,'Anguthan','391107',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6960,21,'Aniyadri','391160',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6961,21,'Ankhol','390019',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6962,21,'Asar','391168',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6963,21,'Athadungri','391170',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6964,21,'Athavali','391140',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6965,21,'Avakhal','391250',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6966,21,'Bahadarpur (Vadodara)','391125',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6967,21,'Bakrol','390019',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6968,21,'Bamroli','391125',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6969,21,'Bangapura','391145',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6970,21,'Bar','391160',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6971,21,'Baranpura','390001',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6972,21,'Baravad','391160',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6973,21,'Barkal','391105',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6974,21,'Baroli','391150',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6975,21,'Bavaria','391250',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6976,21,'Bedia','391168',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6977,21,'Bhaka','391152',1,0,'2022-03-03 12:22:06','2022-03-03 12:22:06'),(6978,21,'Bhanpur','391160',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(6979,21,'Bharvada','391150',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(6980,21,'Bhatpur','391130',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(6981,21,'Bhensavali','391160',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(6982,21,'Bhikhapur','391160',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(6983,21,'Bhilapur','391107',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(6984,21,'Bhilodia','391110',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(6985,21,'Bhilpur','391160',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(6986,21,'Bhindol','391135',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(6987,21,'Bhorda','391165',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(6988,21,'Bhumaswada','391168',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(6989,21,'Bithli','391105',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(6990,21,'Bodeli','391135',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(6991,21,'Borbar','391107',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(6992,21,'Bordha','391135',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(6993,21,'Bortalav','391145',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(6994,21,'Chalamali','391140',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(6995,21,'Chametha','391150',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(6996,21,'Chandod','391105',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(6997,21,'Chanvada','391110',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(6998,21,'Chhanbhoi','391250',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(6999,21,'Chhatrali','391135',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(7000,21,'Chhota-udepur','391165',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(7001,21,'Chhuchhapura','391125',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(7002,21,'Chikhodara','390009',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(7003,21,'Chisadiya','391165',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(7004,21,'Chorngala','391130',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(7005,21,'Chudel','391160',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(7006,21,'Dabhoi H.O','391110',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(7007,21,'Dabhoi R.S.','391110',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(7008,21,'Dabhoi Vadodari Bhagol','391110',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(7009,21,'Dani','391152',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(7010,21,'Danteshwar','390004',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(7011,21,'Dena','390022',1,0,'2022-03-03 12:22:07','2022-03-03 12:22:07'),(7012,21,'Deroli','391250',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7013,21,'Deroli','391130',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7014,21,'Devalia','391160',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7015,21,'Dhamasiya','391150',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7016,21,'Dhandhoda','391165',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7017,21,'Dhaniavi','390014',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7018,21,'Dharmpuri','391110',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7019,21,'Dharsimel','391150',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7020,21,'Dholar','391107',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7021,21,'Dholi Simal','391165',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7022,21,'Diver','391250',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7023,21,'Dolaria','391165',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7024,21,'Dormar','391125',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7025,21,'Dugdha','391150',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7026,21,'Dumali','391160',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7027,21,'Dungargam','391168',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7028,21,'Dungarvant','391160',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7029,21,'Ekalbara','391165',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7030,21,'Fanta','391125',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7031,21,'Fartikui','391107',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7032,21,'Fatepura (Vadodara)','390006',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7033,21,'Ferkuva','391135',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7034,21,'Gadhboriad','391152',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7035,21,'Garda','391145',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7036,21,'Ghantoli','391150',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7037,21,'Ghelawant','391165',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7038,21,'Gola Gamdi','391125',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7039,21,'Goyawant','391150',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7040,21,'Gundicha','391145',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7041,21,'Handod','391145',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7042,21,'Harakhapur','391160',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7043,21,'Hareshwar','391125',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7044,21,'Haripura','391150',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7045,21,'Harni','390022',1,0,'2022-03-03 12:22:08','2022-03-03 12:22:08'),(7046,21,'Harni Colony','390022',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7047,21,'Indral','391130',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7048,21,'Jabugam','391155',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7049,21,'Jakshi','391150',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7050,21,'Jaloda','391160',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7051,21,'Jamba','391160',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7052,21,'Jambua','390014',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7053,21,'Jamli','391152',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7054,21,'Jemalgadh','391150',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7055,21,'Jojwa  R.S.','391125',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7056,21,'Kadachhala','391140',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7057,21,'Kadadhara','391107',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7058,21,'Kadipani','391175',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7059,21,'Kadvad','391160',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7060,21,'Kalarani','391135',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7061,21,'Kaledia','391150',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7062,21,'Kalidoli','391140',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7063,21,'Kaliyapura','391150',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7064,21,'Kanalva','391168',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7065,21,'Kanda','391160',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7066,21,'Kanjetha','391115',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7067,21,'Kanteshwar','391125',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7068,21,'Kapurai','390004',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7069,21,'Karali','391135',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7070,21,'Karalipura','391110',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7071,21,'Karanjwant','391168',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7072,21,'Karelibaug','390018',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7073,21,'Karnali','391105',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7074,21,'Karnet','391110',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7075,21,'Kavitha','391125',1,0,'2022-03-03 12:22:09','2022-03-03 12:22:09'),(7076,21,'Kawant','391170',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7077,21,'Kelanpur','390004',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7078,21,'Khadkhad','391165',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7079,21,'Khanderao Market','390001',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7080,21,'Khapariya','391150',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7081,21,'Kharmada','391152',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7082,21,'Khatiawant','391168',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7083,21,'Khunvad','391130',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7084,21,'Kikavada','391160',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7085,21,'Kohivav','391160',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7086,21,'Kolamba','391152',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7087,21,'Kosindra','391140',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7088,21,'Kukad','391110',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7089,21,'Kukarda','391150',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7090,21,'Kukas','391250',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7091,21,'Kumetha','390019',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7092,21,'Kundal','391165',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7093,21,'Kundhela','391107',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7094,21,'Lachharas','391130',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7095,21,'Ladod','391135',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7096,21,'Lavakui','391150',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7097,21,'Lotia','391125',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7098,21,'M.I. Estate','390010',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7099,21,'Madanzampa','390001',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7100,21,'Makarpura','390014',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7101,21,'Makni','391145',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7102,21,'Malpur','391145',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7103,21,'Malpur','391250',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7104,21,'Malsar','391115',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7105,21,'Manavant','391168',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7106,21,'Mandlava','391165',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7107,21,'Mandva','391115',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7108,21,'Mandva','391105',1,0,'2022-03-03 12:22:10','2022-03-03 12:22:10'),(7109,21,'Mandvi (Vadodara)','390001',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7110,21,'Maneja','390013',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7111,21,'Manjalpur','390011',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7112,21,'Manjrol','391110',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7113,21,'Manjrol','391250',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7114,21,'Manka','391170',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7115,21,'Mankodi','391170',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7116,21,'Meghakui','391107',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7117,21,'Mindhol','391250',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7118,21,'Mithibor','391165',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7119,21,'Modasar','391135',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7120,21,'Moghela','391152',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7121,21,'Moletha','391105',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7122,21,'Moradungari','391140',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7123,21,'Morakhala','391125',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7124,21,'Morangana','391168',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7125,21,'Mota  Habipura','391110',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7126,21,'Mota Amadra','391160',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7127,21,'Mota Fofalia','391115',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7128,21,'Mota Karala','391105',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7129,21,'Motaghoda','391168',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7130,21,'Motavanta','391170',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7131,21,'Moti  Amroli','391160',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7132,21,'Moti  Beg','391160',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7133,21,'Moti  Rasli','391160',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7134,21,'Motibumadi','391155',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7135,21,'Muldhar','391155',1,0,'2022-03-03 12:22:11','2022-03-03 12:22:11'),(7136,21,'Mundamore','391168',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7137,21,'Muvada','391160',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7138,21,'Nalvant','391152',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7139,21,'Nana Amadara','391135',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7140,21,'Nana Karala','391105',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7141,21,'Nanderia','391105',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7142,21,'Nandpur','391145',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7143,21,'Nani Tokri','391168',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7144,21,'Naria','391107',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7145,21,'Naswadi','391150',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7146,21,'Navagam','391152',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7147,21,'Navalja','391170',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7148,21,'Navapura','391125',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7149,21,'Nimetha','390019',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7150,21,'Ongc Col','390009',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7151,21,'Padharwant','391165',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7152,21,'Pala','391150',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7153,21,'Palasani','391152',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7154,21,'Palaswada','391107',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7155,21,'Palsanda','391160',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7156,21,'Pandhara','391155',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7157,21,'Panej','391140',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7158,21,'Pani','391160',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7159,21,'Pansoli','391110',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7160,21,'Panvad','391168',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7161,21,'Parvata','391150',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7162,21,'Pavijetpur','391160',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7163,21,'Picchuwada','391145',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7164,21,'Pipaldi','391170',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7165,21,'Pipalsat','391145',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7166,21,'Pisai','391110',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7167,21,'Pochamba','391150',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7168,21,'Pratapnagar R.S.','390004',1,0,'2022-03-03 12:22:12','2022-03-03 12:22:12'),(7169,21,'Pratapnagar (Vadodara)','390004',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7170,21,'Puniad','391110',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7171,21,'Puniavant','391165',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7172,21,'Raichha','391168',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7173,21,'Raipur','391150',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7174,21,'Raisingpura','391170',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7175,21,'Raisingpura','391160',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7176,21,'Rajbodeli','391140',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7177,21,'Rampura','391145',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7178,21,'Ranapur','391250',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7179,21,'Rangpur (K)','391168',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7180,21,'Rangpur(Z)','391165',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7181,21,'Ratanpur','391160',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7182,21,'Ratanpura','391145',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7183,21,'Rodadha','391168',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7184,21,'Rumadia','391168',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7185,21,'Sadhli','391168',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7186,21,'Sadhli','391250',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7187,21,'Sagwa','391105',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7188,21,'Saidivasana','391170',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7189,21,'Saloj','391135',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7190,21,'Samsabad','391107',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7191,21,'Sanada','391168',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7192,21,'Sanada','391165',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7193,21,'Sankhandra','391135',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7194,21,'Sankheda','391145',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7195,21,'Sanor','391105',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7196,21,'Santkawnar Colony','390006',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7197,21,'Sargi','391140',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7198,21,'Sarsinda','391130',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7199,21,'Sathod','391110',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7200,21,'Savli','391121',1,0,'2022-03-03 12:22:13','2022-03-03 12:22:13'),(7201,21,'Sayajipura','390019',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7202,21,'Segwa Simli','391155',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7203,21,'Sejwa','391135',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7204,21,'Sengpur','391152',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7205,21,'Sharadnagar','390009',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7206,21,'Shira','391121',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7207,21,'Simalia','391110',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7208,21,'Simli','391105',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7209,21,'Sindhikuva','391150',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7210,21,'Singla','391168',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7211,21,'Sinor','391115',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7212,21,'Sitpur','391110',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7213,21,'Sodhaliya','391152',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7214,21,'Soma Talav','390025',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7215,21,'SRP Group I','390001',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7216,21,'Sukal','391155',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7217,21,'Sunderpura','391145',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7218,21,'Surasamal','391115',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7219,21,'Surkheda','391165',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7220,21,'Tadkachhla','391135',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7221,21,'Tanakhala','391150',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7222,21,'Tandalja','391135',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7223,21,'Targol','391125',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7224,21,'Tarsali','390009',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7225,21,'Tatarpura','390004',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7226,21,'Tejgadh','391156',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7227,21,'Tentalav','391105',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7228,21,'Thadgam','391170',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7229,21,'Thuwavi','391107',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7230,21,'Timba','391130',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7231,21,'Timbarva','391250',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7232,21,'Totarmata','391125',1,0,'2022-03-03 12:22:14','2022-03-03 12:22:14'),(7233,21,'Uchapan','391160',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7234,21,'Umarva','391160',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7235,21,'Umathi','391170',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7236,21,'Unada','391140',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7237,21,'Utraj','391250',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7238,21,'Vadaj','391105',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7239,21,'Vadeli','391145',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7240,21,'Vadia','391121',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7241,21,'Vadodara H.O','390001',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7242,21,'Vadsar','390010',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7243,21,'Vaguma','391152',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7244,21,'Valothi','391160',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7245,21,'Vanadara','391107',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7246,21,'Vaniad','391105',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7247,21,'Vaniadri','391135',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7248,21,'Vankla','391152',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7249,21,'Vanta','391135',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7250,21,'Vasai','391110',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7251,21,'Vasan Sevada','391145',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7252,21,'Vasna','391140',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7253,21,'Vijli','391170',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7254,21,'Virod','390022',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7255,21,'Virpur','391165',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7256,21,'Wadhwana','391110',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7257,21,'Wadi S.N. Road','390017',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7258,21,'Wagach','391152',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7259,21,'Waghodia Road','390025',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7260,21,'Waghva','391160',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7261,21,'Zanzad','391115',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7262,21,'Zer','391152',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7263,21,'Zoz','391165',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7264,21,'Abhol','391421',1,0,'2022-03-03 12:22:15','2022-03-03 12:22:15'),(7265,21,'Adiran','391510',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7266,21,'Ajod','391740',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7267,21,'Ajwa Compound','391510',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7268,21,'Akota','390020',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7269,21,'Alkapuri','390007',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7270,21,'Alva','391760',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7271,21,'Ambada','391445',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7272,21,'Ambali','391760',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7273,21,'Amla','391445',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7274,21,'Ampad','391101',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7275,21,'Amreshwar','391761',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7276,21,'Anandpura','391761',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7277,21,'Anastu','391240',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7278,21,'Angadh','391330',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7279,21,'Anjesar','391775',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7280,21,'Ankodia','391330',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7281,21,'Anti','391445',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7282,21,'Antoli','391761',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7283,21,'Asoj','391510',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7284,21,'Asoj','391745',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7285,21,'Atali','391244',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7286,21,'Atladara','390012',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7287,21,'Bachar','391244',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7288,21,'Bahutha','391775',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7289,21,'Bajwa','391310',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7290,21,'Baman Gam','391243',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7291,21,'Bhadara','391445',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7292,21,'Bhadarwa','391780',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7293,21,'Bhaily','391410',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7294,21,'Bhaniara','391510',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7295,21,'Bharthana','391244',1,0,'2022-03-03 12:22:16','2022-03-03 12:22:16'),(7296,21,'Bhoj','391445',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7297,21,'Bill','391410',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7298,21,'Bodka','391240',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7299,21,'Brahamanvashi','391421',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7300,21,'Champaner Road','391510',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7301,21,'Chandranagar','391520',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7302,21,'Chansad','391440',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7303,21,'Chapad','391410',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7304,21,'Chemical Industries','390003',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7305,21,'Chhaliar','391530',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7306,21,'Chhanchava','391244',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7307,21,'Chhani Rd','390024',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7308,21,'Chhani (Vadodara)','391740',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7309,21,'Chhatral','391210',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7310,21,'Chipad','391760',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7311,21,'Chitral','391430',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7312,21,'Chokari','391450',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7313,21,'Choranda','391244',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7314,21,'Chorbhuj','391240',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7315,21,'Dabhasa','391440',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7316,21,'Dabka','391440',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7317,21,'Dajipura','391774',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7318,21,'Darapura','391440',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7319,21,'Dashrath','391740',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7320,21,'Desar','391774',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7321,21,'Dhanora','391510',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7322,21,'Dhanora','391346',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7323,21,'Dhantej','391530',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7324,21,'Dhavat','391210',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7325,21,'Dodka','391340',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7326,21,'Dudhwada','391450',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7327,21,'Dumad','391740',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7328,21,'Ekelbara','391440',1,0,'2022-03-03 12:22:17','2022-03-03 12:22:17'),(7329,21,'Eme','390008',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7330,21,'Falod','391760',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7331,21,'Fartilizer Nagar','391750',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7332,21,'Fateganj H.O','390002',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7333,21,'Fazalpur','391340',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7334,21,'Gabhirpura','391761',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7335,21,'Gametha','391430',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7336,21,'Gandhara','391210',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7337,21,'Ganeshpura','391510',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7338,21,'Gangadia','391520',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7339,21,'Ganpatpura','391210',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7340,21,'Ganpatpura','391760',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7341,21,'Gardhia','391520',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7342,21,'Gavasad','391430',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7343,21,'Geb','390007',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7344,21,'Ghantiyal','391510',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7345,21,'Ghayaj','391440',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7346,21,'Ghodadara','391760',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7347,21,'Goraj','391761',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7348,21,'Goriyad','391440',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7349,21,'Gorwa','390003',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7350,21,'Gosindra','391240',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7351,21,'Gothda','391770',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7352,21,'Gotri','391101',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7353,21,'Gutal','391760',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7354,21,'Handod','391240',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7355,21,'Himmatpura','391774',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7356,21,'Husepura','391445',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7357,21,'Indrad','391510',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7358,21,'Industrial Estate (Vadodara)','390016',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7359,21,'Itola','391243',1,0,'2022-03-03 12:22:18','2022-03-03 12:22:18'),(7360,21,'Itola R.S.','391243',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7361,21,'Itwad','391774',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7362,21,'Jalalpura','391430',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7363,21,'Jambugoral','391774',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7364,21,'Jarod','391510',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7365,21,'Jaspura','391440',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7366,21,'Jawahar Nagar (Vadodara)','391320',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7367,21,'Jiyatalavdi','391220',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7368,21,'Juna Samlaya','391520',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7369,21,'Junarampura','391760',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7370,21,'Juni Jathardi','391240',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7371,21,'Kadchhala','391774',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7372,21,'Kalali','390012',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7373,21,'Kamalpura','391520',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7374,21,'Kambola','391240',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7375,21,'Kamrol','391510',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7376,21,'Kanbha','391240',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7377,21,'Kanda','391430',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7378,21,'Kandari','391210',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7379,21,'Karamdi','391240',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7380,21,'Karchia','391520',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7381,21,'Karchiya','391310',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7382,21,'Karkhadi','391450',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7383,21,'Karmal','391210',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7384,21,'Karmaliyapura','391761',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7385,21,'Karodia','391310',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7386,21,'Kasumbia','391761',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7387,21,'Kayavahron','391220',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7388,21,'Khakharia','391510',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7389,21,'Khanda','391760',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7390,21,'Khandiya','391761',1,0,'2022-03-03 12:22:19','2022-03-03 12:22:19'),(7391,21,'Kheda Karmasiya','391510',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7392,21,'Khervadi','391761',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7393,21,'Kiya','392310',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7394,21,'Kotambi','391510',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7395,21,'Kotna','391330',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7396,21,'Koyali','391330',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7397,21,'Kurai','391240',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7398,21,'Kural','391430',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7399,21,'Kurali','391240',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7400,21,'Kuvarpura','391220',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7401,21,'Kuvarpura','391761',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7402,21,'Kuvarvada','391760',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7403,21,'Lakodara','391244',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7404,21,'Lamdapura','391775',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7405,21,'Lanchanpura','391770',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7406,21,'Latipura','391440',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7407,21,'Latwa','391530',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7408,21,'Lilora','391510',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7409,21,'Limda','391760',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7410,21,'Limdi','391530',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7411,21,'Lingsthali','391220',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7412,21,'Luna','391440',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7413,21,'Madheli','391760',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7414,21,'Mahmadpura','391440',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7415,21,'Mahuvad','391440',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7416,21,'Majatan','391450',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7417,21,'Malu','391761',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7418,21,'Mandala','391210',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7419,21,'Manglej','391243',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7420,21,'Manjusar','391775',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7421,21,'Manpur','391240',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7422,21,'Masar','391421',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7423,21,'Masar Road','391421',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7424,21,'Menpura','391220',1,0,'2022-03-03 12:22:20','2022-03-03 12:22:20'),(7425,21,'Merakuva','391774',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7426,21,'Methi','391240',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7427,21,'Mevli','391770',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7428,21,'Miyagam','391240',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7429,21,'Miyagam Karjan','391240',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7430,21,'Mobha','391430',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7431,21,'Mobha Road','391430',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7432,21,'Mokshi','391780',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7433,21,'Motimanekpur','391761',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7434,21,'Motipura','391520',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7435,21,'Motivarnoli','391774',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7436,21,'Mudhela','391510',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7437,21,'Mujpur','391440',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7438,21,'Muval','391770',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7439,21,'Muval','391430',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7440,21,'Nada','391210',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7441,21,'Nahra','391770',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7442,21,'Namisara','391775',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7443,21,'Nana Fofalia','391210',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7444,21,'Nandesari','391340',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7445,21,'Nandesari Ind. Estate','391340',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7446,21,'Nani Bhadol','391520',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7447,21,'Narpura','391530',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7448,21,'Narshihpura','391440',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7449,21,'Natwar Nagar','391780',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7450,21,'Navagam','391510',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7451,21,'Oslam','391244',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7452,21,'Padmala','391350',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7453,21,'Padra','391440',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7454,21,'Panchdevla','391510',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7455,21,'Panchvati','390016',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7456,21,'Pandu','391530',1,0,'2022-03-03 12:22:21','2022-03-03 12:22:21'),(7457,21,'Parikha','391210',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7458,21,'Pasva','391520',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7459,21,'Patarveni','391220',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7460,21,'Petrochemical  T Ship','391345',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7461,21,'Petrochemical','391346',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7462,21,'Pilol','391745',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7463,21,'Pindappa','391430',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7464,21,'Pingalvada','391240',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7465,21,'Pipalchhat','391530',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7466,21,'Pipalia','391760',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7467,21,'Pipli','391445',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7468,21,'Poicha','391780',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7469,21,'Poicha','391770',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7470,21,'POR','391243',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7471,21,'Pratapganj (Vadodara)','390002',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7472,21,'Pratappura','391774',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7473,21,'Prathampura','391780',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7474,21,'Prathampura','391770',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7475,21,'Racecourse','390007',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7476,21,'Rahkui','391510',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7477,21,'Raika','391340',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7478,21,'Raipura','391410',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7479,21,'Rajpura','391510',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7480,21,'Rajupura','391445',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7481,21,'Rajupura','391530',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7482,21,'Ramnath','391243',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7483,21,'Rania','391780',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7484,21,'Raniapura','391520',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7485,21,'Ranjit Nagar','391780',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7486,21,'Ranoli (Vadodara)','391350',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7487,21,'Ranu','391445',1,0,'2022-03-03 12:22:22','2022-03-03 12:22:22'),(7488,21,'Rasulabad','391510',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7489,21,'Rasulpur','391770',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7490,21,'Raval','391760',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7491,21,'Remeshwarpura','391761',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7492,21,'Rustampura (Vadodara)','391761',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7493,21,'Ruvand','391220',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7494,21,'Sadhi','391445',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7495,21,'Sadra','391510',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7496,21,'Sadra','391430',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7497,21,'Saidal','391761',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7498,21,'Sambhoi','391240',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7499,21,'Samiyala','391410',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7500,21,'Samlaya R S','391520',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7501,21,'Sampa','391240',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7502,21,'Sampla','391421',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7503,21,'Samra','391244',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7504,21,'Sandasal','391530',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7505,21,'Sandha','391440',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7506,21,'Sangadol','391760',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7507,21,'Sangma','391440',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7508,21,'Saniad','391244',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7509,21,'Sankarda','391350',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7510,21,'Sanpur','391430',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7511,21,'Sarar','391243',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7512,21,'Sarasavani','391445',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7513,21,'Sardar Nagar Society','390002',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7514,21,'Sarnej','391510',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7515,21,'Savli','391770',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7516,21,'Sayajiganj','390020',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7517,21,'Sejakuva','391440',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7518,21,'Sevasi','391101',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7519,21,'Shahpura','391220',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7520,21,'Sherkhi','391330',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7521,21,'Sihora','391440',1,0,'2022-03-03 12:22:23','2022-03-03 12:22:23'),(7522,21,'Sihora','391530',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7523,21,'Simri','391244',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7524,21,'Sindhrot','391330',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7525,21,'Sisva','391740',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7526,21,'Sokhda','391745',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7527,21,'Sokhdaradhu','391240',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7528,21,'Subhanpura','390023',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7529,21,'Subhelav','391775',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7530,21,'Sundarpura','391243',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7531,21,'T B Sanatorium','390021',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7532,21,'Tajpura','391440',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7533,21,'Tandalja','390012',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7534,21,'Tithor','391450',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7535,21,'Tulsipura','391510',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7536,21,'Tundav','391775',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7537,21,'Umaraya','391440',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7538,21,'Undera','391330',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7539,21,'Urad','391244',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7540,21,'Vadadla','391445',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7541,21,'Vadia','391520',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7542,21,'Vadsala','391243',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7543,21,'Vadu','391440',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7544,21,'Vaghodia','391760',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7545,21,'Vakaner','391780',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7546,21,'Vaktapura','391530',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7547,21,'Valan','392310',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7548,21,'Valavav','391774',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7549,21,'Valva','391761',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7550,21,'Vanchhara','391430',1,0,'2022-03-03 12:22:24','2022-03-03 12:22:24'),(7551,21,'Vandarda','391761',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7552,21,'Vankaneda','391774',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7553,21,'Varnama','391243',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7554,21,'Varsada','391774',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7555,21,'Vasanpura','391770',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7556,21,'Vasia','391530',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7557,21,'Vasna Kotaria','391745',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7558,21,'Vasna Road','390007',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7559,21,'Vasvel','391760',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7560,21,'Vedpur','391761',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7561,21,'Vejalpura','391760',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7562,21,'Vejpur','391774',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7563,21,'Vemar','391520',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7564,21,'Vemar','391240',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7565,21,'Vemardi','391210',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7566,21,'Vesania','391760',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7567,21,'Vidhyut Nagar Colony','390007',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7568,21,'Vintoz','391770',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7569,21,'Virjai','391240',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7570,21,'Virpur','391445',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7571,21,'Vishrampura','391440',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7572,21,'Vyankatpura','391510',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7573,21,'Vyara Antoli','391760',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7574,22,'Adol','392240',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7575,22,'Advala','392110',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7576,22,'Akod','392130',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7577,22,'Alonj','394115',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7578,22,'Amanpur','392150',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7579,22,'Ambagam','393025',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7580,22,'Ambawadi (Bharuch)','393041',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7581,22,'Ambheta','392130',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7582,22,'Ambheta','393030',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7583,22,'Ambos','393110',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7584,22,'Amleshwar','392012',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7585,22,'Amod','392110',1,0,'2022-03-03 12:22:25','2022-03-03 12:22:25'),(7586,22,'Anadhara','393110',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7587,22,'Andada','393010',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7588,22,'Anjoli','393130',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7589,22,'Ankalva','393030',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7590,22,'Ankleshwar RS','393001',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7591,22,'Ankleshwar','393001',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7592,22,'Anor','392025',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7593,22,'Argama','392012',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7594,22,'Asarma','394810',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7595,22,'Asha','393120',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7596,22,'Asta','393030',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7597,22,'Atali','392130',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7598,22,'Atkhol','393130',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7599,22,'Avadar','393001',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7600,22,'Avidha','393017',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7601,22,'Badodara','393030',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7602,22,'Bahruch City','392001',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7603,22,'Bahruch R.S','392001',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7604,22,'Baladva','393130',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7605,22,'Bhadbhut','392012',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7606,22,'Bhadi','394115',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7607,22,'Bhadkodra','392155',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7608,22,'Bhamadia','393125',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7609,22,'Bharadia','393135',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7610,22,'Bharthana','392210',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7611,22,'Bharuch H.O','392001',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7612,22,'Bhenskhetar','393135',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7613,22,'Bhilod','393135',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7614,22,'Bhodar','392150',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7615,22,'Bhuva','392110',1,0,'2022-03-03 12:22:26','2022-03-03 12:22:26'),(7616,22,'Bhuva','392012',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7617,22,'Bilothi','393130',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7618,22,'Boidra','393001',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7619,22,'Bojadra','392150',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7620,22,'Borbhathabet','393001',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7621,22,'Chaklad','392035',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7622,22,'Chancvel','392140',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7623,22,'Chandravan','393130',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7624,22,'Chasvad','393130',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7625,22,'Chhidra','392155',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7626,22,'Chikhli','393135',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7627,22,'Dabhali','392210',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7628,22,'Dadhal','393001',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7629,22,'Dadheda','393110',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7630,22,'Dahej','392130',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7631,22,'Danda','392230',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7632,22,'Dashan','392012',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7633,22,'Dattanagar','393130',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7634,22,'Dayadra','392020',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7635,22,'Dediapada','393040',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7636,22,'Dehali','393125',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7637,22,'Dehgam','392012',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7638,22,'Dehgam','392170',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7639,22,'Derol','392020',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7640,22,'Desad','393135',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7641,22,'Devla','392040',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7642,22,'Dhamrad','394810',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7643,22,'Dhanturia','393020',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7644,22,'Dharoli','393110',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7645,22,'Dholgam','393135',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7646,22,'Digas','393030',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7647,22,'Diwa','393001',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7648,22,'Dolatpur','393135',1,0,'2022-03-03 12:22:27','2022-03-03 12:22:27'),(7649,22,'Dolia','392150',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7650,22,'Dora','392230',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7651,22,'Dungari','393135',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7652,22,'Eksal','392130',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7653,22,'Gajera','391810',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7654,22,'Galenda','392130',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7655,22,'Gandhar','392140',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7656,22,'Gayatri Nagar','392001',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7657,22,'Ghamnad','392025',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7658,22,'Ghodadra','394115',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7659,22,'Goladra','392165',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7660,22,'Gora Colony','393155',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7661,22,'Goratia','393115',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7662,22,'Govali','393001',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7663,22,'Goya Bazar','393001',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7664,22,'Gundecha','393110',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7665,22,'Gundia','393125',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7666,22,'Hajat','393020',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7667,22,'Hajikhana Bazar','392001',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7668,22,'Haldar','392210',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7669,22,'Haldarva','392011',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7670,22,'Hansot','393030',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7671,22,'Haripura','393120',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7672,22,'Hingalla','392210',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7673,22,'Hinglot','392012',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7674,22,'Ikhar','392230',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7675,22,'Ilav','394810',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7676,22,'Islampur','392040',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7677,22,'Itakla','393125',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7678,22,'Itola','392110',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7679,22,'Jabugam','393125',1,0,'2022-03-03 12:22:28','2022-03-03 12:22:28'),(7680,22,'Jambusar','392150',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7681,22,'Janiadra','392165',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7682,22,'Janor','392210',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7683,22,'Jantran','392155',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7684,22,'Jhagadia','393110',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7685,22,'Jhangar','392210',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7686,22,'Jitali','393001',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7687,22,'Jolva','392135',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7688,22,'Kabirgam','393135',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7689,22,'Kadodara','392165',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7690,22,'Kadvali','393115',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7691,22,'Kahan','392240',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7692,22,'Kahanva','391810',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7693,22,'Kakdapada','392020',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7694,22,'Kaladra','392130',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7695,22,'Kalak','392150',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7696,22,'Kalam','393030',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7697,22,'Kalam','392140',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7698,22,'Kaliari','392155',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7699,22,'Kamalia','393135',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7700,22,'Kambodia','393130',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7701,22,'Kamboli','392220',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7702,22,'Kansia','393010',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7703,22,'Kantharia','392015',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7704,22,'Kantiajal','393030',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7705,22,'Kantipada','393130',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7706,22,'Kapalsadi','393001',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7707,22,'Kapodra','393001',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7708,22,'Karavel','393001',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7709,22,'Karela','392025',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7710,22,'Kareli','393151',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7711,22,'Kareli','391810',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7712,22,'Karena','392230',1,0,'2022-03-03 12:22:29','2022-03-03 12:22:29'),(7713,22,'Karjan','392210',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7714,22,'Karmad','392150',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7715,22,'Karmad','392160',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7716,22,'Kasad','392020',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7717,22,'Katpor','393030',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7718,22,'Kava','392150',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7719,22,'Kavachia','393130',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7720,22,'Kavi','392170',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7721,22,'Kavitha','392210',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7722,22,'Kavli','392180',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7723,22,'Kelod','392020',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7724,22,'Kervada','392025',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7725,22,'Keshlu','392025',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7726,22,'Keshwan','392140',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7727,22,'Khanpurdeh','392150',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7728,22,'Kharchi','393001',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7729,22,'Khardipada','393130',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7730,22,'Kharetha','393130',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7731,22,'Kharod','394115',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7732,22,'Khojbal','392130',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7733,22,'Kimoj','392170',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7734,22,'Kishnad','392220',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7735,22,'Kobla','392035',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7736,22,'Kolavana','392140',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7737,22,'Kolvan','393025',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7738,22,'Kondh','393001',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7739,22,'Kora (Bharuch)','392155',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7740,22,'Kosamdi','393001',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7741,22,'Kothi','392020',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7742,22,'Kothi','393151',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7743,22,'Kothi Vantarsa','392220',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7744,22,'Kudadra','393030',1,0,'2022-03-03 12:22:30','2022-03-03 12:22:30'),(7745,22,'Kurchan','392025',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7746,22,'Kurla','392160',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7747,22,'Kuvadar','392210',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7748,22,'L.B.Chakla','392001',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7749,22,'Lakhigam','392130',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7750,22,'Limdi','392165',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7751,22,'Limdi','393155',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7752,22,'Limet','393135',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7753,22,'Limodra','393110',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7754,22,'Luna','393135',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7755,22,'Luvara','392210',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7756,22,'Madafar','392040',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7757,22,'Magnad','392150',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7758,22,'Mahudhala','392020',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7759,22,'Maktampur','392012',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7760,22,'Malanpur','393030',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7761,22,'Malpur','392155',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7762,22,'Manchhasara','392110',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7763,22,'Mandala','393130',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7764,22,'Mandvabuzarg','393001',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7765,22,'Mangleshwar','392030',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7766,22,'Mangrol','392230',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7767,22,'Mangrol','393150',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7768,22,'Manjola','392035',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7769,22,'Matied','393020',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7770,22,'Mauza','393130',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7771,22,'Mela','393135',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7772,22,'Miamatar','392035',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7773,22,'Mohmedpura','392001',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7774,22,'Mongrol','392110',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7775,22,'Mortalav','393110',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7776,22,'Mosam','392140',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7777,22,'Mota Sorva','393115',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7778,22,'Motali','393001',1,0,'2022-03-03 12:22:31','2022-03-03 12:22:31'),(7779,22,'Muler','392140',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7780,22,'Nabipur','392210',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7781,22,'Nahar','392170',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7782,22,'Nahier','392110',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7783,22,'Naldhari','393135',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7784,22,'Nandeal','392015',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7785,22,'Nandida','392130',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7786,22,'Narmada Nagar (Bharuch)','392015',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7787,22,'Narnavi','392165',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7788,22,'Navetha','392012',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7789,22,'Netrang','393130',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7790,22,'Nikora','392001',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7791,22,'Nikora','392030',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7792,22,'Ninam','392110',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7793,22,'Nobar','392150',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7794,22,'Nodhna','392150',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7795,22,'O.N.G.C. Colony','393010',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7796,22,'Obha','394810',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7797,22,'Ochhan','392140',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7798,22,'Ochhan','392230',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7799,22,'Ora','392140',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7800,22,'Padal','393110',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7801,22,'Padvania','393110',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7802,22,'Paguthan','392015',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7803,22,'Pahaj','392140',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7804,22,'Pakhajan','392165',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7805,22,'Palej','392220',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7806,22,'Panch Fanas','392001',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7807,22,'Pangam','393040',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7808,22,'Paniadra','392165',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7809,22,'Panoli I.E.','394116',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7810,22,'Panoli','394115',1,0,'2022-03-03 12:22:32','2022-03-03 12:22:32'),(7811,22,'Panuda','393130',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7812,22,'Pardi Idris','394115',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7813,22,'Pariej','392020',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7814,22,'Parkhet','392020',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7815,22,'Pichhipura','393151',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7816,22,'Piludra','393020',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7817,22,'Pipadhara','393115',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7818,22,'Pipalia','392165',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7819,22,'Pipaliya','392020',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7820,22,'Piraman','393001',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7821,22,'Pungam','393020',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7822,22,'Rahad','392012',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7823,22,'Rahiad','392130',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7824,22,'Raima','393030',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7825,22,'Rajpardi','393115',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7826,22,'Ranipura','393110',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7827,22,'Ravidra','394115',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7828,22,'Razalwada','393115',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7829,22,'Roza Tankaria','392140',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7830,22,'Sabuti','393041',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7831,22,'Sagbara','393050',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7832,22,'Sajod','393020',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7833,22,'Sakkarpore','393020',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7834,22,'Saladra','392012',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7835,22,'Sambha','392155',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7836,22,'Samlod','392210',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7837,22,'Samni','392025',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7838,22,'Sanjali','393120',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7839,22,'Sanjali','394115',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7840,22,'Saran','392140',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7841,22,'Sarbhan','392035',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7842,22,'Sarod','392180',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7843,22,'Sayan','393030',1,0,'2022-03-03 12:22:33','2022-03-03 12:22:33'),(7844,22,'Saykha','392140',1,0,'2022-03-03 12:22:34','2022-03-03 12:22:34'),(7845,22,'Selamba','393025',1,0,'2022-03-03 12:22:34','2022-03-03 12:22:34'),(7846,22,'Selod','393001',1,0,'2022-03-03 12:22:34','2022-03-03 12:22:34'),(7847,22,'Sengpur','393001',1,0,'2022-03-03 12:22:34','2022-03-03 12:22:34'),(7848,22,'Sevad','393135',1,0,'2022-03-03 12:22:34','2022-03-03 12:22:34'),(7849,22,'Shahpur','392210',1,0,'2022-03-03 12:22:34','2022-03-03 12:22:34'),(7850,22,'Shera','393030',1,0,'2022-03-03 12:22:34','2022-03-03 12:22:34'),(7851,22,'Shrikothi','392110',1,0,'2022-03-03 12:22:34','2022-03-03 12:22:34'),(7852,22,'Shuklatirth','392030',1,0,'2022-03-03 12:22:34','2022-03-03 12:22:34'),(7853,22,'Sigam','392170',1,0,'2022-03-03 12:22:34','2022-03-03 12:22:34'),(7854,22,'Simadhra','393115',1,0,'2022-03-03 12:22:34','2022-03-03 12:22:34'),(7855,22,'Simalia','392220',1,0,'2022-03-03 12:22:34','2022-03-03 12:22:34'),(7856,22,'Simartha','392220',1,0,'2022-03-03 12:22:34','2022-03-03 12:22:34'),(7857,22,'Sindhot','392210',1,0,'2022-03-03 12:22:34','2022-03-03 12:22:34'),(7858,22,'Sindhvai','392001',1,0,'2022-03-03 12:22:34','2022-03-03 12:22:34'),(7859,22,'Sitpon','392210',1,0,'2022-03-03 12:22:34','2022-03-03 12:22:34'),(7860,22,'Sodgam','393135',1,0,'2022-03-03 12:22:34','2022-03-03 12:22:34'),(7861,22,'Sunderpura','393145',1,0,'2022-03-03 12:22:34','2022-03-03 12:22:34'),(7862,22,'Sutrel','392140',1,0,'2022-03-03 12:22:34','2022-03-03 12:22:34'),(7863,22,'Talodra','393110',1,0,'2022-03-03 12:22:34','2022-03-03 12:22:34'),(7864,22,'Tanchha','392025',1,0,'2022-03-03 12:22:34','2022-03-03 12:22:34'),(7865,22,'Tankari','392040',1,0,'2022-03-03 12:22:34','2022-03-03 12:22:34'),(7866,22,'Tankaria','392240',1,0,'2022-03-03 12:22:34','2022-03-03 12:22:34'),(7867,22,'Tavra','392011',1,0,'2022-03-03 12:22:34','2022-03-03 12:22:34'),(7868,22,'Tham','392020',1,0,'2022-03-03 12:22:34','2022-03-03 12:22:34'),(7869,22,'Thava','393130',1,0,'2022-03-03 12:22:34','2022-03-03 12:22:34'),(7870,22,'Tralsa','392020',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7871,22,'Trankal','392140',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7872,22,'Tundaj','392150',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7873,22,'Uber','392150',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7874,22,'Uchedia','393110',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7875,22,'Uchhad','392150',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7876,22,'Umalla','393120',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7877,22,'Umargam','393135',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7878,22,'Umarwada','393001',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7879,22,'Umraj','392015',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7880,22,'Urja Nagar','392215',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7881,22,'Vadadala','392155',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7882,22,'Vadadla','392015',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7883,22,'Vadadla','392130',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7884,22,'Vadfalia','393125',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7885,22,'Vadkhunta','393115',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7886,22,'Vaghvan','393030',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7887,22,'Vagra','392140',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7888,22,'Vahalu','392020',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7889,22,'Vahelam','392150',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7890,22,'Vahial','392140',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7891,22,'Valia','393135',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7892,22,'Valner','393030',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7893,22,'Vamleshwar','393030',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7894,22,'Vanakpore','393115',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7895,22,'Vansi','392160',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7896,22,'Varedia','392210',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7897,22,'Vasna','393110',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7898,22,'Vasti Khandali','392140',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7899,22,'Vedach','391810',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7900,22,'Vegni','392130',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7901,22,'Velugam','393120',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7902,22,'Vilayat','392012',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7903,22,'Vora Samni','392012',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7904,22,'Zadeshwar','392011',1,0,'2022-03-03 12:22:35','2022-03-03 12:22:35'),(7905,22,'Zak','393130',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7906,22,'Kharach','394120',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7907,23,'Almawadi','393130',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7908,23,'Amiyar','393050',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7909,23,'Amletha','393140',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7910,23,'Atkeshwar','393151',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7911,23,'Balota','394810',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7912,23,'Bamalla','393120',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7913,23,'Barkatura','393025',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7914,23,'Besna','393040',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7915,23,'Bhadam','393145',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7916,23,'Bhilvashi','393155',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7917,23,'Bhoramali','393050',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7918,23,'Bitada','393145',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7919,23,'Bogaj','393040',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7920,23,'Boridra','393145',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7921,23,'Chopadvav','393050',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7922,23,'Dabhvan','393041',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7923,23,'Dbhavan','392020',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7924,23,'Devsaki','393050',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7925,23,'Dhamnacha','393145',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7926,23,'Dhanpore','393145',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7927,23,'Dhavliver','393025',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7928,23,'Dholar','393140',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7929,23,'Dumkhal','393040',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7930,23,'Fitchwada','393120',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7931,23,'Fulsar','393040',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7932,23,'Fulwadi','393145',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7933,23,'Gadit','393145',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7934,23,'Gaganpur','393041',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7935,23,'Garudeshwar','393151',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7936,23,'Ghamkuva','393140',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7937,23,'Ghantoli','393040',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7938,23,'Gnagapur','392020',1,0,'2022-03-03 12:22:36','2022-03-03 12:22:36'),(7939,23,'Godada','393050',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7940,23,'Gopalpura','393145',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7941,23,'Gora','393155',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7942,23,'Hajarpura','393145',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7943,23,'Indore','393120',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7944,23,'Indravarna','393155',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7945,23,'Jamboi','393120',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7946,23,'Jaoli','393025',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7947,23,'Jargam','393041',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7948,23,'Jarsad','393115',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7949,23,'Jesalpore','393145',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7950,23,'Jespor','393115',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7951,23,'Jior','393150',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7952,23,'Juna Mosda','393040',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7953,23,'Kadagada','393151',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7954,23,'Kakadpada','393041',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7955,23,'Kanbudi','393040',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7956,23,'Kandroj','393140',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7957,23,'Kangam','392170',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7958,23,'Kapat','393120',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7959,23,'Kara','393135',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7960,23,'Kelvikuva','393130',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7961,23,'Kevadia Colony','393151',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7962,23,'Kevdi','393041',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7963,23,'Kevdi','392020',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7964,23,'Kherpada','393025',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7965,23,'Khokhraumar','393040',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7966,23,'Khopi','393050',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7967,23,'Koyli Mandvi','393130',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7968,23,'Kukdada','392020',1,0,'2022-03-03 12:22:37','2022-03-03 12:22:37'),(7969,23,'Kukdada','393041',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7970,23,'Lachhras','393150',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7971,23,'Langdi','393025',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7972,23,'Mahunipada','393050',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7973,23,'Mahupada','393050',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7974,23,'Mithivav','393151',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7975,23,'Mokhdi','393125',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7976,23,'Moriana','393130',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7977,23,'Moskut','393041',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7978,23,'Mota Jambuda','393130',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7979,23,'Motamalpur','393110',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7980,23,'Motasukamba','393040',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7981,23,'Motidevrupam','393050',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7982,23,'Muskut','392020',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7983,23,'Nada','392040',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7984,23,'Nangal','393020',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7985,23,'Nani Bedwan','393041',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7986,23,'Nanibedwan','392020',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7987,23,'Nava Rajuvadia','393140',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7988,23,'Navagamvborjai','393110',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7989,23,'Navapura','393140',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7990,23,'Navitothidra','393105',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7991,23,'Navra','393140',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7992,23,'Nevdiamba','393025',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7993,23,'Ori','393145',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7994,23,'Orpa','393151',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7995,23,'Padaria','392025',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7996,23,'Palaswada','393025',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7997,23,'Panetha','393120',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7998,23,'Pansar','393040',1,0,'2022-03-03 12:22:38','2022-03-03 12:22:38'),(7999,23,'Pantalavdi','393151',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8000,23,'Parvat','394810',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8001,23,'Pat','393050',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8002,23,'Pather','393135',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8003,23,'Patna','393145',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8004,23,'Patnamau','393050',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8005,23,'Patvali','393040',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8006,23,'Piplod','393040',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8007,23,'Pipludra','391810',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8008,23,'Poicha','393145',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8009,23,'Pratap Nagar (Narmada)','393140',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8010,23,'Raisingpura','393120',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8011,23,'Rajgadh','393135',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8012,23,'Rajnivad','393025',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8013,23,'Rajpara','393125',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8014,23,'Rajpipla D.R.','393145',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8015,23,'Rajpipla','393145',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8016,23,'Rozdev','393050',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8017,23,'Runad','392170',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8018,23,'Rundh','393145',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8019,23,'Sabuti','392020',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8020,23,'Samaria','393145',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8021,23,'Samarpada','393040',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8022,23,'Samot','393040',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8023,23,'Sarsa','393115',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8024,23,'Sarsad','393120',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8025,23,'Shehrav','393150',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8026,23,'Siludi','393135',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8027,23,'Sisiodra','393145',1,0,'2022-03-03 12:22:39','2022-03-03 12:22:39'),(8028,23,'Sisodra','394810',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8029,23,'Siyali','393110',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8030,23,'Solia','393040',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8031,23,'Songam','393151',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8032,23,'Sorapada','393050',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8033,23,'Suka','393151',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8034,23,'Sukvel','393040',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8035,23,'Sunevkalla','394810',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8036,23,'Tankari','393150',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8037,23,'Taropa','393140',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8038,23,'Tavdi','393140',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8039,23,'Tawal','393050',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8040,23,'Thali','393145',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8041,23,'Timbi','393140',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8042,23,'Tuna','393125',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8043,23,'Ubharia','393050',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8044,23,'Umadhra','393115',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8045,23,'Umarva','393120',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8046,23,'Umra','392150',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8047,23,'Umra','393041',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8048,23,'Umra','392020',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8049,23,'Undhva','393151',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8050,23,'Vadhava','393041',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8051,23,'Vadhva','392020',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8052,23,'Vagharali','393151',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8053,23,'Vaghetha','393140',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8054,23,'Vaghodia','393140',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8055,23,'Vaghrali','393151',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8056,23,'Vajpur','393050',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8057,23,'Valvi','392150',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8058,23,'Vankal','393115',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8059,23,'Vataria','393001',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8060,23,'Vavdi','393145',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8061,23,'Vavharali','393151',1,0,'2022-03-03 12:22:40','2022-03-03 12:22:40'),(8062,23,'Vaviala','393151',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8063,23,'Virpor','393140',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8064,23,'Wali','393120',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8065,23,'Zariawadi','393151',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8066,23,'Zarnawadi','393040',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8067,23,'Zarwani','393155',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8068,23,'Alwa','391121',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8069,23,'Ambalia','391120',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8070,23,'Bhadarwa','391121',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8071,23,'Bujetha','391120',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8072,23,'Chudeshwar','391120',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8073,23,'Devaliya','391121',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8074,23,'Fatepura','391120',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8075,23,'Gamod','391120',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8076,23,'Jalodra','391120',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8077,23,'Kamsoli','391120',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8078,23,'Kantharpura','391121',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8079,23,'Moria','391120',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8080,23,'Nalia','391120',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8081,23,'Namaria','391120',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8082,23,'Puchhpura','391121',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8083,23,'Rengan','391121',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8084,23,'Sevada','391120',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8085,23,'Shirola','391110',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8086,23,'Tilakwada','391120',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8087,23,'Uchad','391121',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8088,23,'Utavali','391120',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8089,23,'Vagheli','391120',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8090,23,'Vajiria','391120',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8091,23,'Vandh','391121',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8092,23,'Vanmala','391120',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8093,23,'Vora','391120',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8094,23,'Vydhar','391121',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8095,24,'Aasayadi','389130',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8096,24,'Abhlod','389152',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8097,24,'Afwa','389190',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8098,24,'Agara','389140',1,0,'2022-03-03 12:22:41','2022-03-03 12:22:41'),(8099,24,'Agara','389175',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8100,24,'Agaswani','389382',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8101,24,'Agavada','389154',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8102,24,'Amba','389180',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8103,24,'Andheri','389140',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8104,24,'Anika','389175',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8105,24,'Antela','389380',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8106,24,'Baina','389380',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8107,24,'Bajarwada','389170',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8108,24,'Balaiya','389190',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8109,24,'Bamroli','389380',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8110,24,'Bandibar','389140',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8111,24,'Bar','389140',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8112,24,'Bara','389380',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8113,24,'Batakvada','389172',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8114,24,'Bavka','389152',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8115,24,'Bhanasimal','389172',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8116,24,'Bhanpur','389175',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8117,24,'Bharamkheda','389160',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8118,24,'Bhathiwada','389160',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8119,24,'Bhe','389155',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8120,24,'Bhichor','389172',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8121,24,'Bhojela','389190',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8122,24,'Bhorva','389382',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8123,24,'Bhutaradi','389155',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8124,24,'Bilwani','389180',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8125,24,'Bordi R.S.','389160',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8126,24,'Boriala','389155',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8127,24,'Budhpur','389140',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8128,24,'Chakalia','389180',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8129,24,'Chamaria','389175',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8130,24,'Chandwana','389154',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8131,24,'Chenpur','389380',1,0,'2022-03-03 12:22:42','2022-03-03 12:22:42'),(8132,24,'Chhalor','389172',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8133,24,'Chhaparwad','389130',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8134,24,'Chhayan','389180',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8135,24,'Chilakota','389152',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8136,24,'Chitrodia','389170',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8137,24,'Chopda Buzarg','389110',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8138,24,'Chorbaria','389380',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8139,24,'Chosala','389160',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8140,24,'Chundadi','389130',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8141,24,'Dabhada','389140',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8142,24,'Dadur','389155',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8143,24,'Dahod H.O','389151',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8144,24,'Dahod R.S','389151',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8145,24,'Dantia','389140',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8146,24,'Dantia','389180',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8147,24,'Dasa','389130',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8148,24,'Dasla','389154',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8149,24,'Devgadh Baria','389380',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8150,24,'Devirampura','389380',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8151,24,'Dhadhela','389170',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8152,24,'Dhadhela','389140',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8153,24,'Dhanpur','389382',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8154,24,'Dharadungar','389160',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8155,24,'Dhavadia','389170',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8156,24,'Dhediya','389175',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8157,24,'Dudhamali','389382',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8158,24,'Dudhia','389380',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8159,24,'Dudhia','389146',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8160,24,'Dumka','389382',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8161,24,'Dungar','389172',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8162,24,'Dungri','389180',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8163,24,'Fangia','389380',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8164,24,'Fatepura (Dahod)','389172',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8165,24,'Freelandganj','389160',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8166,24,'Fulpura','389170',1,0,'2022-03-03 12:22:43','2022-03-03 12:22:43'),(8167,24,'G P College','389160',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8168,24,'Gamdi','389170',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8169,24,'Gamla','389154',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8170,24,'Gangardi','389155',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8171,24,'Garadu','389170',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8172,24,'Garbada','389155',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8173,24,'Ghada','389382',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8174,24,'Ghughas','389172',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8175,24,'Gothib','389190',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8176,24,'Gultora','389180',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8177,24,'Himala','389160',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8178,24,'Hindolia','389190',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8179,24,'Hirola','389170',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8180,24,'Itawa','389154',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8181,24,'Jada Kheria','389140',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8182,24,'Jafarpura','389170',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8183,24,'Jalat','389154',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8184,24,'Jambua','389155',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8185,24,'Javesi','389190',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8186,24,'Jekot','389160',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8187,24,'Jesawada','389152',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8188,24,'Jetpur','389140',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8189,24,'Jetpur','389170',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8190,24,'Jhalod','389170',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8191,24,'Jhunsa','389175',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8192,24,'Juna Baria','389380',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8193,24,'Kadval','389170',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8194,24,'Kali Dungri','389380',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8195,24,'Kaliarai','389180',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8196,24,'Kaliavad','389152',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8197,24,'KaligamGujar','389160',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8198,24,'Kalijini Saraswani','389170',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8199,24,'Kamboi','389140',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8200,24,'Kanjeta','389382',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8201,24,'Karamba','389180',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8202,24,'Karath','389180',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8203,24,'Kathla','389154',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8204,24,'Katwara','389154',1,0,'2022-03-03 12:22:44','2022-03-03 12:22:44'),(8205,24,'Kelia','389380',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8206,24,'Khandania','389380',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8207,24,'Khangela','389154',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8208,24,'Kharod','389160',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8209,24,'Kharoda','389160',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8210,24,'Kharsana','389170',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8211,24,'Kharvani','389180',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8212,24,'Khirkhai','389140',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8213,24,'Khredi','389160',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8214,24,'Kundha','389140',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8215,24,'Lakhanpur','389190',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8216,24,'Limdi','389180',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8217,24,'Limkheda','389140',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8218,24,'Lukhavada','389140',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8219,24,'Machhelai','389130',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8220,24,'Mahudi','389170',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8221,24,'Malvasi','389180',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8222,24,'Mander','389130',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8223,24,'Mandli','389175',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8224,24,'Mandor','389155',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8225,24,'Manli','389140',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8226,24,'Margala','389190',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8227,24,'Matva','389152',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8228,24,'Methan','389175',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8229,24,'Minakyar','389155',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8230,24,'Mira Khedi','389160',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8231,24,'Moli','389175',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8232,24,'Moti Khajuri','389380',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8233,24,'Moti Kharaj','389160',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8234,24,'Moti Nan Dukan','389172',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8235,24,'Moti Rel Purv','389172',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8236,24,'Moti Zari','389130',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8237,24,'Mundaheda','389180',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8238,24,'Munkhosla','389170',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8239,24,'Muvalia','389160',1,0,'2022-03-03 12:22:45','2022-03-03 12:22:45'),(8240,24,'Nadatod','389380',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8241,24,'Naghrala','389160',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8242,24,'Nakti','389380',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8243,24,'Nalu','389382',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8244,24,'Nandhelav','389152',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8245,24,'Nani Dhadheli','389190',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8246,24,'Nava Nagar','389155',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8247,24,'Nava Vadia','389146',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8248,24,'Navagam','389160',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8249,24,'Nenki','389175',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8250,24,'Nes Molara','389172',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8251,24,'Nindka','389190',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8252,24,'Padalia','389146',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8253,24,'Pahad','389146',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8254,24,'Panchela','389130',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8255,24,'Panchvada','389155',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8256,24,'Pandadi','389152',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8257,24,'Pania','389140',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8258,24,'Parathampur','389180',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8259,24,'Patangdi','389130',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8260,24,'Patia','389155',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8261,24,'Pavdi','389160',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8262,24,'Pethapur','389180',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8263,24,'Pichhoda','389175',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8264,24,'Pipero','389382',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8265,24,'Piplod (Dahod)','389130',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8266,24,'Pipodra','389140',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8267,24,'Rabdal','389160',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8268,24,'Rai','389140',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8269,24,'Rama','389130',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8270,24,'Randhikpur','389130',1,0,'2022-03-03 12:22:46','2022-03-03 12:22:46'),(8271,24,'Raniyar Kanbi','389180',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8272,24,'Rentia','389160',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8273,24,'Rozam','389160',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8274,24,'Rupa Kheda','389190',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8275,24,'Ruvabari','389380',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8276,24,'Sagdapada','389190',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8277,24,'Sagtala','389380',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8278,24,'Sajoi','389382',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8279,24,'Salara','389172',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8280,24,'Salia','389130',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8281,24,'Sanjeli','389175',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8282,24,'Sevania','389380',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8283,24,'Shankarpura','389170',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8284,24,'Simalia','389172',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8285,24,'Simalia Khurd','389154',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8286,24,'Simamoi','389382',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8287,24,'Simlia','389180',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8288,24,'Simlia Buzarg','389155',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8289,24,'Singapur','389146',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8290,24,'Singedi','389380',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8291,24,'Sudia','389180',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8292,24,'Sukhsar','389190',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8293,24,'Sutharvansa','389180',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8294,24,'Tanda','389160',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8295,24,'Tandi','389180',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8296,24,'Tarvadia Himat','389154',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8297,24,'Tarvadia Vaja','389154',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8298,24,'Thala','389175',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8299,24,'Thala','389180',1,0,'2022-03-03 12:22:47','2022-03-03 12:22:47'),(8300,24,'Therka','389170',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8301,24,'Tokarva','389382',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8302,24,'Toyani','389130',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8303,24,'Training College','389380',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8304,24,'Uchvania','389160',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8305,24,'Udhavada','389380',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8306,24,'Vadbhet','389380',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8307,24,'Vadela','389140',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8308,24,'Vadva','389152',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8309,24,'Vadvas','389172',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8310,24,'Vagela','389170',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8311,24,'Valagota','389130',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8312,24,'Vangad','389172',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8313,24,'Vankiya','389154',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8314,24,'Vansia','389175',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8315,24,'Vansia Kui','389190',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8316,24,'Varod','389180',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8317,24,'Ved','389382',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8318,24,'Vejelav','389152',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8319,24,'Velpura','389170',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8320,24,'Virol','389380',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8321,24,'Zab','389380',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8322,24,'Zabu','389382',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8323,24,'Zari Buzarg','389155',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8324,24,'Zerjitagadh','389146',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8325,25,'Adadra','389341',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8326,25,'Agarwada','388270',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8327,25,'Agarwada','389115',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8328,25,'Alwa','389310',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8329,25,'Ambakhunt','389380',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8330,25,'Ambali','389001',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8331,25,'Amthani','389240',1,0,'2022-03-03 12:22:48','2022-03-03 12:22:48'),(8332,25,'Aniyad','389210',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8333,25,'Anjanwa','389110',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8334,25,'Ankalia','389240',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8335,25,'Antalwada','389240',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8336,25,'Arad','389350',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8337,25,'Bablia','389232',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8338,25,'Babrol','389260',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8339,25,'Bachkaria','389240',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8340,25,'Bahi','389001',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8341,25,'Bakkhar','389120',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8342,25,'Bakor','389232',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8343,25,'Bakrol','389365',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8344,25,'Bamroda','389230',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8345,25,'Bapotia','389370',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8346,25,'Baska','389350',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8347,25,'Bedhiya','389310',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8348,25,'Bhadkhadabar','389180',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8349,25,'Bhadrala','389210',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8350,25,'Bhadrod','389230',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8351,25,'Bhadroli Khurd','389320',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8352,25,'Bhalada','388270',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8353,25,'Bhalania','389340',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8354,25,'Bhamaiya','389120',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8355,25,'Bhamaria','389360',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8356,25,'Bhandoi','389115',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8357,25,'Bhilod','389341',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8358,25,'Bhuvar','389110',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8359,25,'Bodidra Buzarg','389120',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8360,25,'Bodidra Khurd','389210',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8361,25,'Bor','389380',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8362,25,'Boriavi','389210',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8363,25,'Boriya','389210',1,0,'2022-03-03 12:22:49','2022-03-03 12:22:49'),(8364,25,'Boru Bakorl','389330',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8365,25,'Borvai','389232',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8366,25,'Chalali','389341',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8367,25,'Champeli','388270',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8368,25,'Chandranagar','389360',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8369,25,'Chandrpura','389350',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8370,25,'Chapra','389360',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8371,25,'Charangam','388270',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8372,25,'Chatkabeli','389230',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8373,25,'Chelawada','389360',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8374,25,'Chhanip','389210',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8375,25,'Chhavad','389120',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8376,25,'Chhogala','389210',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8377,25,'Chitwa','389260',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8378,25,'Chori','388270',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8379,25,'Dadhalia','389250',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8380,25,'Dalwada','389210',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8381,25,'Damavav','389380',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8382,25,'Dangaria','389115',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8383,25,'Davadra','389365',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8384,25,'Delol','389310',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8385,25,'Derol Gam','389320',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8386,25,'Derol R S','389320',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8387,25,'Dhamnod','389120',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8388,25,'Dhamod','388270',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8389,25,'Dhandhalpur','389210',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8390,25,'Dhaneshawar','389365',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8391,25,'Dhanitra','389001',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8392,25,'Dhankuva','389360',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8393,25,'Dhanol','388713',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8394,25,'Dharapur','389220',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8395,25,'Dharola','389001',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8396,25,'Dhesia','388270',1,0,'2022-03-03 12:22:50','2022-03-03 12:22:50'),(8397,25,'Dhingalwada','389240',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8398,25,'Dhinkva','389360',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8399,25,'Ditwas','389240',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8400,25,'Diwda Colony','389250',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8401,25,'Doli','389110',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8402,25,'Duma','389390',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8403,25,'Eral','389340',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8404,25,'Erandi','389120',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8405,25,'Farod','389365',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8406,25,'Gada','389260',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8407,25,'Gadia','389110',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8408,25,'Gamani','389365',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8409,25,'Gangadiya','389210',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8410,25,'Gangta','389230',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8411,25,'Ghansar Muvadi','389350',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8412,25,'Ghaswada','389240',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8413,25,'Ghoghmba','389365',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8414,25,'Godhar','389230',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8415,25,'Godhar( North)','389240',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8416,25,'Godhra Bhuravav','389002',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8417,25,'Godhra City','389001',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8418,25,'Godhra Civil Lines','389001',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8419,25,'Godhra H.O','389001',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8420,25,'Godhra Shroff Bazar','389001',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8421,25,'Godhra Vorwad','389001',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8422,25,'Godli','389380',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8423,25,'Gollav','389380',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8424,25,'Gothibada','389230',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8425,25,'Govindi','389001',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8426,25,'Goya Sundal','389341',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8427,25,'Gundi','389380',1,0,'2022-03-03 12:22:51','2022-03-03 12:22:51'),(8428,25,'Guneli','389220',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8429,25,'Gunesia','389341',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8430,25,'Halol Bazar','389350',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8431,25,'Halol','389350',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8432,25,'Hardaspur','389230',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8433,25,'Hareda','389110',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8434,25,'Harkundi','389340',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8435,25,'Hathivan','389220',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8436,25,'Haveli','389390',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8437,25,'Hirapur','389260',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8438,25,'Hirapur','389390',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8439,25,'Indral','389350',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8440,25,'Jaban','389390',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8441,25,'Jambughoda','389390',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8442,25,'Jantral','389320',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8443,25,'Janvad','389260',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8444,25,'Jepura','389360',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8445,25,'Jhara','389220',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8446,25,'Jitpura','389340',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8447,25,'Jitpura','389360',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8448,25,'Juni Dhari','388710',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8449,25,'Kadachhala','388270',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8450,25,'Kadadara','389115',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8451,25,'Kadana','389240',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8452,25,'Kajali','389265',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8453,25,'Kakachiya','389230',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8454,25,'Kakana Bhesavada','389230',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8455,25,'Kakanpur','388713',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8456,25,'Kalibel','389235',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8457,25,'Kalol (Panch Mahals)','389330',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8458,25,'Kalyana','388710',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8459,25,'Kanajra','389260',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8460,25,'Kandach','389310',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8461,25,'Kanesar','389230',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8462,25,'Kanjipani','389390',1,0,'2022-03-03 12:22:52','2022-03-03 12:22:52'),(8463,25,'Kanjri','389350',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8464,25,'Kanod','389320',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8465,25,'Kanpur','389365',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8466,25,'Kanteli','389370',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8467,25,'Kantu','389380',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8468,25,'Karada','389320',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8469,25,'Karanta','389230',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8470,25,'Karoli','389341',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8471,25,'Kavali','389210',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8472,25,'Kelamul','389265',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8473,25,'Kenpur','389110',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8474,25,'Khadodi','389232',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8475,25,'Khandivav','389390',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8476,25,'Khanpur','389230',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8477,25,'Kharkhadi','389365',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8478,25,'Kharod','389365',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8479,25,'Kharol','389220',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8480,25,'Khojalvasa','389210',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8481,25,'Kidia','388270',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8482,25,'Kolvan','388270',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8483,25,'Kotha','389210',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8484,25,'Kothamba','389220',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8485,25,'Kuwazar','389115',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8486,25,'Labadadhara','389365',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8487,25,'Ladpur','389265',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8488,25,'Ladvel','389220',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8489,25,'Lakdi Poyada','388270',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8490,25,'Limadia','389230',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8491,25,'Limbhola','389250',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8492,25,'Limbodara','389230',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8493,25,'Limdi Doli','389110',1,0,'2022-03-03 12:22:53','2022-03-03 12:22:53'),(8494,25,'Limdi Timba','389232',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8495,25,'Lunawada','389230',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8496,25,'Madar','389350',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8497,25,'Madhvas','389330',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8498,25,'Madhvas','389230',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8499,25,'Maghasar','389330',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8500,25,'Mahulia','389001',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8501,25,'Makhalia','389210',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8502,25,'Malav','389310',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8503,25,'Malekpur','389235',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8504,25,'Malu','389365',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8505,25,'Malvan','389265',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8506,25,'Manchi Haveli','389360',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8507,25,'Mangliana','389210',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8508,25,'Manipur (C)','388713',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8509,25,'Masabar','389390',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8510,25,'Mataria Vadi','389120',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8511,25,'Mataria Vejam','389115',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8512,25,'Matariya Vyas','389210',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8513,25,'Medapur','389310',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8514,25,'Mehlol','389340',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8515,25,'Mekhar','389115',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8516,25,'Metral','389110',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8517,25,'Mirap','389120',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8518,25,'Mithali','389001',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8519,25,'Mojari','389120',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8520,25,'Mol','389365',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8521,25,'Mor','389210',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8522,25,'Mora (Panch Mahals)','389110',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8523,25,'Morva ( Rena)','389001',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8524,25,'Morva Hadaf','389115',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8525,25,'Mota Sonela','389230',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8526,25,'Motal','389001',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8527,25,'Moti Ghoda','389230',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8528,25,'Moti Kantadi','388710',1,0,'2022-03-03 12:22:54','2022-03-03 12:22:54'),(8529,25,'Moti Sarsan','389230',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8530,25,'Moti Umaravan','389370',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8531,25,'Motikayar','389260',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8532,25,'Motipura','389350',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8533,25,'Motirath','389240',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8534,25,'Motirel(W)','389110',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8535,25,'Movasa','389235',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8536,25,'Mudavadekh','389230',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8537,25,'Munpur','389240',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8538,25,'Nada','389120',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8539,25,'Nadisar','388710',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8540,25,'Namnar','388270',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8541,25,'Nana Rajanpur','389250',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8542,25,'Nanavadadala','389235',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8543,25,'Nandarkha','389340',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8544,25,'Nandarva','389210',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8545,25,'Nani Bhugedi','389190',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8546,25,'Nani Kharsoli','389265',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8547,25,'Nanidenavad','389230',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8548,25,'Naroda','389230',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8549,25,'Narukot','389390',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8550,25,'Nasikpur','389230',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8551,25,'Natapur','389120',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8552,25,'Nathkuwa','389360',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8553,25,'Nava Muvada','389230',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8554,25,'Navagam','389365',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8555,25,'Navagam','389110',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8556,25,'Navakuwa','389360',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8557,25,'Nesda','389320',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8558,25,'Orvada','389120',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8559,25,'Padardi','389210',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8560,25,'Padedi Ador','389260',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8561,25,'Padedi Rampur','389235',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8562,25,'Padhiyar','388713',1,0,'2022-03-03 12:22:55','2022-03-03 12:22:55'),(8563,25,'Padhora','389365',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8564,25,'Palikhanda','389370',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8565,25,'Palla','389365',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8566,25,'Pandaravada','389232',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8567,25,'Paroli','389365',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8568,25,'Parvadi','389120',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8569,25,'Pavagadh','389360',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8570,25,'Pingli','389320',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8571,25,'Pratapgadh Khedapa','389172',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8572,25,'Rabadia','389220',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8573,25,'Rabod','389310',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8574,25,'Rajayata','389115',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8575,25,'Rambhem Na Muvada','389230',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8576,25,'Rameshra','389350',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8577,25,'Rampatel Na Muvada','389230',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8578,25,'Rampur Jodka','389340',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8579,25,'Rampur Kasanpur','389115',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8580,25,'Ranijini Padedi','389230',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8581,25,'Ranjitnagar','389360',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8582,25,'Rasulpur','389120',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8583,25,'Ratanpur (R)','388713',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8584,25,'Ratanpur Kantdi','388710',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8585,25,'Ratanpura','389330',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8586,25,'Ravalia','389350',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8587,25,'Rayan Muvada','389365',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8588,25,'Rayanwadia','389360',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8589,25,'Rena','389001',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8590,25,'Rinchhia','389340',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8591,25,'Rinchhia','389360',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8592,25,'Rinchhvani','389380',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8593,25,'Sagawada','389115',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8594,25,'Sajivav','389210',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8595,25,'Sajora','389341',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8596,25,'Sama','389320',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8597,25,'Samalkuva','389365',1,0,'2022-03-03 12:22:56','2022-03-03 12:22:56'),(8598,25,'Samli','389001',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8599,25,'Sampa','389001',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8600,25,'Sangavada','389260',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8601,25,'Saniada','389380',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8602,25,'Sansoli','389320',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8603,25,'Sant','389260',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8604,25,'Sant Road','389120',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8605,25,'Santrampur','389260',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8606,25,'Saraswa','389110',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8607,25,'Saraswa','389365',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8608,25,'Saraswa( North)','389240',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8609,25,'Sarsadi','389240',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8610,25,'Sarsav','389120',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8611,25,'Sat Talav','389230',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8612,25,'Sathrota','389350',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8613,25,'Satmana','389320',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8614,25,'Shamna','389230',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8615,25,'Shehera','389210',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8616,25,'Shekhpur','389210',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8617,25,'Sherpura','389341',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8618,25,'Shivrajpur','389370',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8619,25,'Simalia','389341',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8620,25,'Siyal','389265',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8621,25,'Suliyat','389110',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8622,25,'Sureli','389210',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8623,25,'Sureli','389340',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8624,25,'Surpur','389260',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8625,25,'Tadva','389210',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8626,25,'Tajpura','389350',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8627,25,'Talavdi','389370',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8628,25,'Tarkhanda','389350',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8629,25,'Thanasavli','389220',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8630,25,'Timba Gam','388710',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8631,25,'Timba Road','388710',1,0,'2022-03-03 12:22:57','2022-03-03 12:22:57'),(8632,25,'Timbla','389260',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8633,25,'Tuwa','388713',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8634,25,'Ucharpi','388270',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8635,25,'Uchet','389390',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8636,25,'Ujeti','389350',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8637,25,'Ukhreli','389260',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8638,25,'Umber','389110',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8639,25,'Undra','388270',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8640,25,'Vada Talav','389360',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8641,25,'Vadagam','389230',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8642,25,'Vadelav','389120',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8643,25,'Vadi','389001',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8644,25,'Vadina Gorda','389235',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8645,25,'Vadodar','389115',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8646,25,'Vagadia Ni Andhari','389240',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8647,25,'Vaghbod','389370',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8648,25,'Vaghjipur','389120',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8649,25,'Vallavpur','389001',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8650,25,'Vandeli','389115',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8651,25,'Vania Vada Gorada','389235',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8652,25,'Vanjiakhut','389260',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8653,25,'Vankadi','389110',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8654,25,'Vardhari','388270',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8655,25,'Varsda','389350',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8656,25,'Vav','389390',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8657,25,'Vavdi Buzarg','389001',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8658,25,'Vavkulli','389341',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8659,25,'Veganpur','388713',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8660,25,'Vejalpur','389340',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8661,25,'Velanvada','389240',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8662,25,'Vintoz','389350',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8663,25,'Viraniya','389230',1,0,'2022-03-03 12:22:58','2022-03-03 12:22:58'),(8664,25,'Vyasda','389340',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8665,25,'Zankharia','389360',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8666,25,'Zinzari','389365',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8667,25,'Zinzwa','389265',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8668,26,'Achhari','396105',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8669,26,'Amba Jungle','396065',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8670,26,'Amba Talat','396051',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8671,26,'Ambach (Paria)','396145',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8672,26,'Ambheti','396191',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8673,26,'Amboli','396230',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8674,26,'Amdha','396126',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8675,26,'Amli','396125',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8676,26,'Angam','396155',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8677,26,'Anjlav','396055',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8678,26,'Anklas','396235',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8679,26,'Anklash','396051',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8680,26,'Arnai','396065',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8681,26,'Aslona','396065',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8682,26,'Asma','396125',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8683,26,'Astol','396065',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8684,26,'Asura','396050',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8685,26,'Atak Pardi','396007',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8686,26,'Atgam','396045',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8687,26,'Atul','396020',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8688,26,'Avdha','396050',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8689,26,'Babarkhadak','396126',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8690,26,'Bagwada','396185',1,0,'2022-03-03 12:22:59','2022-03-03 12:22:59'),(8691,26,'Balda','396125',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8692,26,'Balitha','396191',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8693,26,'Balohondi','396126',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8694,26,'Bamti','396050',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8695,26,'Barai','396145',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8696,26,'Baroliya','396050',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8697,26,'Barpuda','396065',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8698,26,'Barsol','396050',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8699,26,'Bartad','396051',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8700,26,'Barumal','396050',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8701,26,'Bhadeli','396030',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8702,26,'Bhadeli Jagalala','396030',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8703,26,'Bhagal','396385',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8704,26,'Bhagod','396020',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8705,26,'Bhambha','396050',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8706,26,'Bhathi Karmbeli','396165',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8707,26,'Bhavthan Ambosi','396051',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8708,26,'Bhensdara','396050',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8709,26,'Bhilad','396105',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8710,26,'Bhutsar','396055',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8711,26,'Bildha','396051',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8712,26,'Bilpudi','396050',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8713,26,'Binwada','396020',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8714,26,'Bodlai','396055',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8715,26,'Bopi','396051',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8716,26,'Borigam','396235',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8717,26,'Borlai','396105',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8718,26,'Burla','396065',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8719,26,'Chala','396191',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8720,26,'Chandor','396191',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8721,26,'Chandvegan','396065',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8722,26,'Chanod Md','396195',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8723,26,'Chanvai','396020',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8724,26,'Chavshala','396065',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8725,26,'Chepa','396065',1,0,'2022-03-03 12:23:00','2022-03-03 12:23:00'),(8726,26,'Chharwada','396030',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8727,26,'Chhiri','396191',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8728,26,'Chichozar','396050',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8729,26,'Chival','396126',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8730,26,'Dabkhal','396065',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8731,26,'Dehli','396105',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8732,26,'Dehri','396170',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8733,26,'Deli','396126',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8734,26,'Dhamani','396050',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8735,26,'Dhamdachi','396001',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8736,26,'Dhanoli','396105',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8737,26,'Dhanori','396045',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8738,26,'Dharampur (Valsad)','396050',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8739,26,'Dharasana','396375',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8740,26,'Dhodhadkuva','396126',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8741,26,'Dhodipada','396130',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8742,26,'Dived','396020',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8743,26,'Divsi','396065',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8744,26,'Dulsad','396007',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8745,26,'Dumlav','396145',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8746,26,'Dungra','396193',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8747,26,'Dungri (Udava RS)','396185',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8748,26,'Dungri (Valsad)','396375',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8749,26,'Endergota','396375',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8750,26,'Faldhara','396007',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8751,26,'Fanaswada','396045',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8752,26,'Gadaria','396055',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8753,26,'Gadi','396051',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8754,26,'Ghadoi','396001',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8755,26,'Ghanveri','396065',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8756,26,'Ghotan','396065',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8757,26,'Girnala','396065',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8758,26,'Goima','396145',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8759,26,'Gorgam','396375',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8760,26,'Gowada','396170',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8761,26,'Gundia','396050',1,0,'2022-03-03 12:23:01','2022-03-03 12:23:01'),(8762,26,'Hanuman Bhagda','396030',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8763,26,'Hanumatmal','396051',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8764,26,'Haria','396020',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8765,26,'Jamalia','396051',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8766,26,'Jamburi','396105',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8767,26,'Jesia','396375',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8768,26,'Jespore','396375',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8769,26,'Jirval','396065',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8770,26,'Jogvel','396126',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8771,26,'Jujwa','396007',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8772,26,'Kachigam','396007',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8773,26,'Kachigam','396235',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8774,26,'Kakadkopar','396126',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8775,26,'Kakadkuva','396065',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8776,26,'Kakadmati','396007',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8777,26,'Kakwadi','396385',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8778,26,'Kalai','396105',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8779,26,'Kalgam','396140',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8780,26,'Kalsar','396185',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8781,26,'Kalwada','396045',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8782,26,'Kamparia','396055',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8783,26,'Kanadu','396105',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8784,26,'Kangvi','396051',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8785,26,'Kanjan Hari','396055',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8786,26,'Kanjan Ranchhod','396055',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8787,26,'Kaprada','396065',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8788,26,'Karajgam','396155',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8789,26,'Karambeli','396105',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8790,26,'Karambeli R.S.','396105',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8791,26,'Karanjveri','396051',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8792,26,'Karaya','396191',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8793,26,'Kewada','396001',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8794,26,'Khadakwal','396065',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8795,26,'Khadki','396185',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8796,26,'Khadoli','396230',1,0,'2022-03-03 12:23:02','2022-03-03 12:23:02'),(8797,26,'Khajurdi','396001',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8798,26,'Khanda','396051',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8799,26,'Kharvel','396050',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8800,26,'Khatalwada','396120',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8801,26,'Khatana','396051',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8802,26,'Kherlav','396145',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8803,26,'Killa Pardi','396125',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8804,26,'Kolak','396115',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8805,26,'Koparli','396191',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8806,26,'Kosamba (Valsad)','396007',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8807,26,'Kosamkuwa','396050',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8808,26,'Kumbharia','396125',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8809,26,'Kundi','396375',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8810,26,'Kurgam','396007',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8811,26,'Lavachha','396193',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8812,26,'Lilapore','396030',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8813,26,'Machhiwad','396125',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8814,26,'Magod','396020',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8815,26,'Magod Dungri','396020',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8816,26,'Makadban','396050',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8817,26,'Malav','396105',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8818,26,'Malvan','396385',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8819,26,'Manaichondi','396051',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8820,26,'Manda','396155',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8821,26,'Mandva','396065',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8822,26,'Manekpore','396120',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8823,26,'Marla','396055',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8824,26,'Maroli Sanjan','396130',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8825,26,'Meghval','396240',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8826,26,'Meh','396020',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8827,26,'Mohan','396105',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8828,26,'Mohpada','396065',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8829,26,'Morai','396191',1,0,'2022-03-03 12:23:03','2022-03-03 12:23:03'),(8830,26,'Mota Pondha','396191',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8831,26,'Moti Tambadi','396193',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8832,26,'Moti Vahiyal','396065',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8833,26,'Muli','396045',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8834,26,'Murdad','396051',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8835,26,'Nadagdhari','396051',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8836,26,'Nagvas','396235',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8837,26,'Nahuli','396105',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8838,26,'Namdha','396191',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8839,26,'Nanapondha','396126',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8840,26,'Nandigam','396105',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8841,26,'Nani Dholdungri','396051',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8842,26,'Nani Tambadi','396193',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8843,26,'Nanivahiyal','396065',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8844,26,'Nargol','396135',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8845,26,'Navera','396055',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8846,26,'Nevri','396126',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8847,26,'Ozar','396191',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8848,26,'Ozar','396055',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8849,26,'Ozarda','396065',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8850,26,'Pachlai','396125',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8851,26,'Palan','396001',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8852,26,'Palgam','396170',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8853,26,'Pali','396105',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8854,26,'Palsana Pardi','396185',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8855,26,'Panas','396126',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8856,26,'Pandor','396191',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8857,26,'Pardi Paria','396145',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8858,26,'Pardi R.S.','396125',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8859,26,'Parnera (Urban)','396020',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8860,26,'Parnera Pardi','396007',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8861,26,'Parwasa','396125',1,0,'2022-03-03 12:23:04','2022-03-03 12:23:04'),(8862,26,'Patel Faliya','396145',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8863,26,'Phansa','396140',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8864,26,'Pindval','396050',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8865,26,'Pitha','396045',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8866,26,'Punat','396155',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8867,26,'Rabda','396055',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8868,26,'Rajpur Talat','396051',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8869,26,'Rata','396191',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8870,26,'Rohina','396145',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8871,26,'Rola','396375',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8872,26,'Ronvel','396055',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8873,26,'Sahuda','396065',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8874,26,'Salvav','396191',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8875,26,'Samarpada','396126',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8876,26,'Sanjan Bandar','396150',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8877,26,'Sanjan','396150',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8878,26,'Sarai','396130',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8879,26,'Sarigam','396155',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8880,26,'Sarodhi','396001',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8881,26,'Sarodhi','396185',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8882,26,'Saron','396001',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8883,26,'Saronda','396135',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8884,26,'Segva','396045',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8885,26,'Segvi','396007',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8886,26,'Shankar Talav','396375',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8887,26,'Shildha','396065',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8888,26,'Sidumber','396050',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8889,26,'Solsumba','396165',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8890,26,'Sondhal Wada','396125',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8891,26,'Sonwada','396375',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8892,26,'Sonwada','396125',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8893,26,'Sukesh','396125',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8894,26,'Sukhala','396126',1,0,'2022-03-03 12:23:05','2022-03-03 12:23:05'),(8895,26,'Sukhlav','396125',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8896,26,'Surwada','396007',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8897,26,'Tadgam','396135',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8898,26,'Tarmalia','396145',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8899,26,'Tembhi','396150',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8900,26,'Tighasa','396375',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8901,26,'Tiskari','396050',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8902,26,'Tithal','396001',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8903,26,'Tukwada','396185',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8904,26,'Tumb','396150',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8905,26,'Udvada R.S.','396185',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8906,26,'Udvada','396180',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8907,26,'Ukta','396050',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8908,26,'Umargam I.E.','396171',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8909,26,'Umargam','396170',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8910,26,'Umarsadi','396125',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8911,26,'Untdi','396385',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8912,26,'Vadoli','396065',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8913,26,'Vaghaldhara','396375',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8914,26,'Vaghchhipa','396125',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8915,26,'Valsad - Vankal','396007',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8916,26,'Valsad Abrama','396002',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8917,26,'Valsad Chhipwad','396001',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8918,26,'Valsad H.O','396001',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8919,26,'Valsad I.E.','396035',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8920,26,'Valsad Mograwadi','396001',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8921,26,'Valsad Mota Bazar','396001',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8922,26,'Valsad Sugar Factory','396007',1,0,'2022-03-03 12:23:06','2022-03-03 12:23:06'),(8923,26,'Valvada','396105',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8924,26,'Vankas','396150',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8925,26,'Vapi I.E.','396195',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8926,26,'Vapi','396191',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8927,26,'Varna','396126',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8928,26,'Varoli Talat','396126',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8929,26,'Varvath','396065',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8930,26,'Vasan','396375',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8931,26,'Vatar','396191',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8932,26,'Velparwa','396125',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8933,26,'Velvach','396007',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8934,26,'Veribhavada','396050',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8935,26,'Virakset','396065',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8936,26,'Virval','396051',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8937,26,'Zaroli','396105',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8938,27,'Ac.Depot','414001',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8939,27,'Adhalgaon','413701',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8940,27,'Agadgaon','414002',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8941,27,'Ahmednagar Camp','414002',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8942,27,'Ahmednagar City','414001',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8943,27,'Ahmednagar H.O','414001',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8944,27,'Ahmednagar R.S.','414005',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8945,27,'Ajnuj','414701',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8946,27,'Akhatwade','414502',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8947,27,'Akhegaon Titarfa','414102',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8948,27,'Akola','414102',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8949,27,'Akolner','414005',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8950,27,'Alhanwadi','414102',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8951,27,'Alkuti','414305',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8952,27,'Alsunde','414402',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8953,27,'Amarapur','414505',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8954,27,'Ambi Jalgaon','414402',1,0,'2022-03-03 12:23:07','2022-03-03 12:23:07'),(8955,27,'Anandibazar','414001',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8956,27,'Apdhup','414301',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8957,27,'Arangaon','413201',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8958,27,'Arangaon Dumala','413702',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8959,27,'Astagaon','414005',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8960,27,'Avane BK','414505',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8961,27,'Babhulgaon Khalsa','414401',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8962,27,'Babhurdi','413703',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8963,27,'Babulwade','414302',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8964,27,'Baburdi Ghumat','414006',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8965,27,'Bahirobawadi','414402',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8966,27,'Balamtakali','414504',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8967,27,'Baradgaon Sudrik','414403',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8968,27,'Bavi','413205',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8969,27,'Belwandi S.F.','413702',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8970,27,'Belwandi','413702',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8971,27,'Benwadi','414402',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8972,27,'Bhalgaon','414113',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8973,27,'Bhambora','414403',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8974,27,'Bhandgaon','414103',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8975,27,'Bhangaon','413728',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8976,27,'Bhatkudgaon','414502',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8977,27,'Bhatodi','414201',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8978,27,'Bhavinimgaon','414502',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8979,27,'Bhawlani','414103',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8980,27,'Bhingar','414002',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8981,27,'Bhingar Wes','414002',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8982,27,'Bhorwadi','414005',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8983,27,'Bhoyare Gangarda','413703',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8984,27,'Bhoyare Pathar','414005',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8985,27,'Bhutetakali','414113',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8986,27,'Bitkewadi','414402',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8987,27,'Bodhegaon','414503',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8988,27,'Brahmni','414105',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8989,27,'Burhan Nagar','414002',1,0,'2022-03-03 12:23:08','2022-03-03 12:23:08'),(8990,27,'Chamburdi','413703',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(8991,27,'Chanda','414606',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(8992,27,'Chande BK','414401',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(8993,27,'Chandgaon','413701',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(8994,27,'Chapadgaon','414401',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(8995,27,'Chapadgaon','414503',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(8996,27,'Chas','414005',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(8997,27,'Chichondi Patil','414201',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(8998,27,'Chichondi Shiral','414106',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(8999,27,'Chichpur Pangul','414102',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(9000,27,'Chikhali','413728',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(9001,27,'Chilwadi','414403',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(9002,27,'Chimbhale','414701',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(9003,27,'Chincholi','414302',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(9004,27,'Chincholi Kaldat','414402',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(9005,27,'Chinchpur Ijde','414102',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(9006,27,'Chombhut','414305',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(9007,27,'Chondi','413205',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(9008,27,'Dahigaon','414502',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(9009,27,'Daithane Gunjal','414103',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(9010,27,'Darewadi','414002',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(9011,27,'Darodi','414305',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(9012,27,'Dehere','414111',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(9013,27,'Deodaithan','413702',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(9014,27,'Deotakli','414502',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(9015,27,'Deulgaon','413728',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(9016,27,'Deulgaon Sidhhi','414006',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(9017,27,'Devi Bhoyare','414306',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(9018,27,'Devrai','414106',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(9019,27,'Dhamori','413704',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(9020,27,'Dhavalgaon','413702',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(9021,27,'Dhawalpuri','414103',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(9022,27,'Dhondpargaon','413205',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(9023,27,'Dhorjalgaon','414501',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(9024,27,'Dhorje','413728',1,0,'2022-03-03 12:23:09','2022-03-03 12:23:09'),(9025,27,'Dhotre BK','414304',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9026,27,'Dighi','414401',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9027,27,'Dighol','413204',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9028,27,'Diksal','414401',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9029,27,'Durgaon','414402',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9030,27,'Erandoli','413703',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9031,27,'Fakrabad','413205',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9032,27,'Gaikwad Jalgaon','414504',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9033,27,'Ganjibhoyare','414302',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9034,27,'Gargundi','414303',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9035,27,'Ghargaon','413728',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9036,27,'Ghatshiras','414106',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9037,27,'Ghodegaon','413205',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9038,27,'Ghodegaon (Ahmed Nagar)','414607',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9039,27,'Ghogargaon','414401',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9040,27,'Ghospuri','414005',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9041,27,'Ghotan','414502',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9042,27,'Ghotvi','413728',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9043,27,'Golegaon','414502',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9044,27,'Goregaon','414103',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9045,27,'Gundegaon','414101',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9046,27,'Gunore','414306',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9047,27,'Gunwadi','414002',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9048,27,'Guravpimpri','414401',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9049,27,'Halgaon','413205',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9050,27,'Hanga','414301',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9051,27,'Hangewadi','414701',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9052,27,'Hasnapur','414502',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9053,27,'Hatgaon','414503',1,0,'2022-03-03 12:23:10','2022-03-03 12:23:10'),(9054,27,'Hingangaon','414103',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9055,27,'Hiradgaon','413701',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9056,27,'Hivare Zare','414006',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9057,27,'Hiware Korda','414103',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9058,27,'Jalalpur','414403',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9059,27,'Jamgaon','414103',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9060,27,'Jamkhed','413201',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9061,27,'Jatdeola','414102',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9062,27,'Jategaon','413204',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9063,27,'Jategaon','414301',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9064,27,'Javala','413201',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9065,27,'Jawala','414306',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9066,27,'Jawkhede Khalsa','414505',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9067,27,'Jeur (Ahmed Nagar)','414601',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9068,27,'Joharapur','414502',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9069,27,'Jssk','414403',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9070,27,'Kalas','414305',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9071,27,'Kamargaon','414005',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9072,27,'Kambi','414503',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9073,27,'Kangoni','414607',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9074,27,'Kanhur','414303',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9075,27,'Kapurwadi','414002',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9076,27,'Karajgaon','414105',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9077,27,'Karandi','414303',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9078,27,'Karanji','414106',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9079,27,'Karjat (Ahmed Nagar)','414402',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9080,27,'Karjule Hariya','414304',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9081,27,'Karjune Khare','414111',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9082,27,'Kasar Pimpalgaon','414505',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9083,27,'Kasba Pathardi','414102',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9084,27,'Kashti','414701',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9085,27,'Katrad','413704',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9086,27,'Kaudgaon','413201',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9087,27,'Kaudgaon','414002',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9088,27,'Kaundane','414401',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9089,27,'Kauthe','414606',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9090,27,'Kauthe','414701',1,0,'2022-03-03 12:23:11','2022-03-03 12:23:11'),(9091,27,'Kendal BK','414105',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9092,27,'Khadakwadi','414304',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9093,27,'Khadamba','413704',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9094,27,'Khampimpri','414503',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9095,27,'Khanapur  BO','414502',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9096,27,'Khandala','414006',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9097,27,'Khandgaon Lohsar','414106',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9098,27,'Khandvi','414401',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9099,27,'Kharadgaon','414502',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9100,27,'Kharda','413204',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9101,27,'Kharwandi','414602',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9102,27,'Kharwandi Kasar','414113',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9103,27,'Khedle Permananda','414105',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9104,27,'Khednagar','414403',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9105,27,'Khospuri','414501',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9106,27,'Kinhi','414303',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9107,27,'Kokangaon','414401',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9108,27,'Kolgaon','413728',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9109,27,'Kolhar','414106',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9110,27,'Kombli','414401',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9111,27,'Koradgaon','414102',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9112,27,'Koregoan','414402',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9113,27,'Kotul','413728',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9114,27,'Kuldharan','414402',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9115,27,'Kusadgaon','413201',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9116,27,'Ladjalgaon','414502',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9117,27,'Limpangaon','413726',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9118,27,'Lohgaon','414607',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9119,27,'Loni Haveli','414302',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9120,27,'Loni Masadpur','414402',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9121,27,'Loni Mavala','414305',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9122,27,'Loni Vyanknath','413702',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9123,27,'M.G.Udyan','414001',1,0,'2022-03-03 12:23:12','2022-03-03 12:23:12'),(9124,27,'Madhe Wadgaon','413726',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9125,27,'Mahalaxmi Hiware','414501',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9126,27,'Mahijalgaon','414401',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9127,27,'Majle Chincholi','414106',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9128,27,'Maka','414501',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9129,27,'Malangi','414402',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9130,27,'Malegaon','414502',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9131,27,'Mali Chinchore','414602',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9132,27,'Malkup','414103',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9133,27,'Mandavgan','414101',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9134,27,'Mandve','414106',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9135,27,'Manikdaundi','414102',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9136,27,'Math Pimpari','413726',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9137,27,'Mehekari','414002',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9138,27,'Meherabad','414006',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9139,27,'Mhasane','414302',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9140,27,'Mhase','413702',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9141,27,'MIDC (ANR)','414111',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9142,27,'Midsangavi','414113',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9143,27,'Mintolines','414001',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9144,27,'Mirajgaon','414401',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9145,27,'MIRC','414110',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9146,27,'Miri','414501',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9147,27,'Moha','413201',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9148,27,'Mohoj BK','414501',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9149,27,'Mohojdeoda','414102',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9150,27,'Mohote','414102',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9151,27,'Mungi','414503',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9152,27,'Munguswade','414113',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9153,27,'Nagardeola','414002',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9154,27,'Naigaon','413201',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9155,27,'Nanaj (Ahmed Nagar)','413205',1,0,'2022-03-03 12:23:13','2022-03-03 12:23:13'),(9156,27,'Nandur Nimba Daitya','414113',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9157,27,'Nandur Pathar','414304',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9158,27,'Narayan Doho','414201',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9159,27,'Narayan Gavan','414301',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9160,27,'Nepti','414005',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9161,27,'Nibavi','413703',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9162,27,'Nighoj','414306',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9163,27,'Nimbe Nandur','414501',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9164,27,'Nimblak','414111',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9165,27,'Nimbodi','414002',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9166,27,'Nimbodi','413201',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9167,27,'Nimgaon Daku','414401',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9168,27,'Nimgaon Gangarda','414401',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9169,27,'Nimgaon Khalu','414701',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9170,27,'Nimgaon Wagha','414005',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9171,27,'Nipani Jalgaon','414102',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9172,27,'Nivdunga','414106',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9173,27,'Padali Ale','414305',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9174,27,'Padali','414505',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9175,27,'Padali Darya','414302',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9176,27,'Padali Ranjangaon','413702',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9177,27,'Pagori Pimpalgaon','414102',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9178,27,'Palashi','414304',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9179,27,'Palaspur','414304',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9180,27,'Palve BK','414301',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9181,27,'Panoli','414302',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9182,27,'Pargaon Sudrik','413702',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9183,27,'Parner','414302',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9184,27,'Parner SSK','414306',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9185,27,'Pategaon','414401',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9186,27,'Patewadi','414401',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9187,27,'Pathardi','414102',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9188,27,'Patoda','413201',1,0,'2022-03-03 12:23:14','2022-03-03 12:23:14'),(9189,27,'Pedgaon','413701',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9190,27,'Pimpalgaon Kauda','414005',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9191,27,'Pimpalgaon Malvi','414601',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9192,27,'Pimpalgaon Pisa','413703',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9193,27,'Pimpalgaon Rotha','414303',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9194,27,'Pimpalgaon Ujjani','414601',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9195,27,'Pimpalgaontappa','414102',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9196,27,'Pimpalner','414302',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9197,27,'Pimparkhed','413205',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9198,27,'Pimpri Kolandar','413702',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9199,27,'Pimprijalsen','414302',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9200,27,'Pisorekhand','414101',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9201,27,'Pokhari Kanher','414304',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9202,27,'Punewadi','414302',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9203,27,'Rajapur','413702',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9204,27,'Rajuri','413204',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9205,27,'Rakshi','414502',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9206,27,'Ralegan','414101',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9207,27,'Ralegan Siddhi','414302',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9208,27,'Ralegan Therpal','414306',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9209,27,'Ranegaon','414502',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9210,27,'Ranjangaon','413703',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9211,27,'Ranjangaondevi','414602',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9212,27,'Rashin','414403',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9213,27,'Rastapur','414606',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9214,27,'Rehekuri','414402',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9215,27,'Rui Chhatrapati','413703',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9216,27,'Ruichattisi','414002',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9217,27,'Sade','413704',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9218,27,'Sakat','413201',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9219,27,'Sakegaon','414102',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9220,27,'Samangaon','414502',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9221,27,'Samsud Erandgaon','414502',1,0,'2022-03-03 12:23:15','2022-03-03 12:23:15'),(9222,27,'Sandve','414201',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9223,27,'Sarjepura','414001',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9224,27,'Sarola Kasar','414005',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9225,27,'Sarolabadhi','414201',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9226,27,'Sarolasomvanshi','413703',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9227,27,'Savargaon','414304',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9228,27,'Savedi Road','414003',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9229,27,'Shahar Takali','414502',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9230,27,'Shani Shinganapur','414105',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9231,27,'Shedgaon','413701',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9232,27,'Shekte','414504',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9233,27,'Shendi','414601',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9234,27,'Shevgaon','414502',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9235,27,'Shinde','414402',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9236,27,'Shingave Keshav','414501',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9237,27,'Shingave Naik','414111',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9238,27,'Shingori','414502',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9239,27,'Shiradhon','414002',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9240,27,'Shiral','414106',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9241,27,'Shirapur','414106',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9242,27,'Shrigonda','413701',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9243,27,'Shrigonda SSK','413726',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9244,27,'Singave Tukai','414607',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9245,27,'Sonai (Ahmed Nagar)','414105',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9246,27,'Sonegaon','413204',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9247,27,'Sultanpur BK','414502',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9248,27,'Sultanpur KHD','414505',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9249,27,'Supa (Ahmed Nagar)','414301',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9250,27,'Suregaon','413703',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9251,27,'Susare','414505',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9252,27,'Tajnapur','414502',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9253,27,'Takali Dhokeshwar','414304',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9254,27,'Takali Kadewalit','413701',1,0,'2022-03-03 12:23:16','2022-03-03 12:23:16'),(9255,27,'Takali Kazi','414201',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9256,27,'Takali Khandeshwari','414402',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9257,27,'Takali Khatgaon','414103',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9258,27,'Takali Lonar','413701',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9259,27,'Takali Manur','414102',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9260,27,'Tamaswadi','414602',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9261,27,'Tandali Dumala','413701',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9262,27,'Telanghashi','413204',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9263,27,'Thakur Pimpalgaon','414503',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9264,27,'Thergaon','414401',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9265,27,'Tisgaon','414106',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9266,27,'Tondoli','414102',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9267,27,'Ukkadgaon','413702',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9268,27,'Ukkhalgaon','413703',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9269,27,'Umbra','414105',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9270,27,'Vadalamission','414602',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9271,27,'Vadegavan','414302',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9272,27,'Vadgaon Gupta','414111',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9273,27,'Vadgaon Tandali','414006',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9274,27,'Vadner BK','414306',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9275,27,'Vadner Haveli','414302',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9276,27,'Vadule BK','414502',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9277,27,'Vadzire','414302',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9278,27,'Vagholi','414501',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9279,27,'Vaghunde KH','414301',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9280,27,'Vahannagar','414006',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9281,27,'Vaiju Babhulgaon','414106',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9282,27,'Valvane','414301',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9283,27,'Vambori','413704',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9284,27,'Vangdari','413726',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9285,27,'Vankute','414304',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9286,27,'Varur BK','414502',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9287,27,'Vasunde','414304',1,0,'2022-03-03 12:23:17','2022-03-03 12:23:17'),(9288,27,'Vilad','414111',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9289,27,'Visapur (Ahmed Nagar)','413703',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9290,27,'Vridheshwar SSK','414505',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9291,27,'Wadali','413728',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9292,27,'Wadgaon','414102',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9293,27,'Walki','414006',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9294,27,'Watephal','414002',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9295,27,'Yelapane','414701',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9296,27,'Yeli','414113',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9297,27,'Agasti SSK','422601',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9298,27,'Aklapur','422620',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9299,27,'Akole','422601',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9300,27,'Ambhaol','422610',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9301,27,'Ambhore','422605',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9302,27,'Ambi','413715',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9303,27,'Aradgaon','413705',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9304,27,'Ashvi BK','413714',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9305,27,'Ashvi KH','413738',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9306,27,'Astgaon','423107',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9307,27,'Babhleshwar','413737',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9308,27,'Badgi','422602',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9309,27,'Baragaon Nandur','413705',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9310,27,'Bari','422604',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9311,27,'Belapur Badgi','422602',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9312,27,'Belapur Khd','413715',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9313,27,'Belapur','413715',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9314,27,'Belpimpalgaon','413725',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9315,27,'Bhalgaon','414603',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9316,27,'Bhamathan','413739',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9317,27,'Bhanashivara','414609',1,0,'2022-03-03 12:23:18','2022-03-03 12:23:18'),(9318,27,'Bhandardara','422604',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9319,27,'Bhende SK','414605',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9320,27,'Bherdapur','413721',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9321,27,'Bhojade','413708',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9322,27,'Bhojdari','422602',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9323,27,'Bhokar','413739',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9324,27,'Bota','422602',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9325,27,'Bramhangaon','423601',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9326,27,'Bramhanwada','422610',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9327,27,'Chandanapuri','422605',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9328,27,'Chandekasare','423601',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9329,27,'Changdeonagar','413723',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9330,27,'Chas','422610',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9331,27,'Chas-nali','423604',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9332,27,'Chikalthan','413706',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9333,27,'Chikani','422605',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9334,27,'Chikhali','422605',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9335,27,'Chinchale','413705',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9336,27,'Chinchavane','422604',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9337,27,'Chincholi Bk','413710',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9338,27,'Chincholi Gurav','422611',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9339,27,'Chinchpur BK','413736',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9340,27,'Chitali','413723',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9341,27,'Chitalvedhe','422604',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9342,27,'Dadh BK','413714',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9343,27,'Dahigaon Bolka','423603',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9344,27,'Dedgaon','414604',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9345,27,'Deogaon','422604',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9346,27,'Deogaon','414604',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9347,27,'Deolali -pravara','413716',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9348,27,'Deothan','422601',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9349,27,'Derde Korhale','423601',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9350,27,'Dhamangaon Awari','422601',1,0,'2022-03-03 12:23:19','2022-03-03 12:23:19'),(9351,27,'Dhamanvan','422604',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9352,27,'Dhamngaon Pat','422610',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9353,27,'Dhamori','423607',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9354,27,'Dhandharphal','422603',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9355,27,'Dharangaon','423601',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9356,27,'Dhokari','422601',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9357,27,'Dhotre','413708',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9358,27,'Dolasane','422620',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9359,27,'Dongargaon','422605',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9360,27,'Ekdara','422601',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9361,27,'Ekrukha','413719',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9362,27,'Fatyabad','413710',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9363,27,'Galnimb','413710',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9364,27,'Galnimb','414603',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9365,27,'Ganeshnagar','422605',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9366,27,'Ganore','422605',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9367,27,'Gardani','422601',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9368,27,'Georai','414604',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9369,27,'Ghargaon','422620',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9370,27,'Ghatghar','422604',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9371,27,'Ghogargaon','413725',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9372,27,'Godhegaon','423603',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9373,27,'Gogalgaon','413736',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9374,27,'Gondegaon','413723',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9375,27,'Guha','413706',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9376,27,'Harigaon','413718',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9377,27,'Hasanapur','413736',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9378,27,'Hivargaon Pathar','422622',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9379,27,'Hiwargaon Pawasa','422605',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9380,27,'IE Shrirampur. Shrirampur.','413709',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9381,27,'Jalgaon','413723',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9382,27,'Jalke Khd','414603',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9383,27,'Jambhali','413705',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9384,27,'Jambut','422622',1,0,'2022-03-03 12:23:20','2022-03-03 12:23:20'),(9385,27,'Jawale Baleshwar','422620',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9386,27,'Jawale Kadlag','422605',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9387,27,'Jawalke','423605',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9388,27,'Jeur','414604',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9389,27,'Jeur Kumbhari','423601',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9390,27,'Jorve','422605',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9391,27,'Kalas Bk','422603',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9392,27,'Kamalpur','413725',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9393,27,'Kanadgaon','413706',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9394,27,'Kangar','413706',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9395,27,'Kanhegaon','413708',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9396,27,'Kanoli','422605',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9397,27,'Karandi','422610',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9398,27,'Karanji Bk','423603',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9399,27,'Karegaon','413717',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9400,27,'Karegaon Factory','413717',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9401,27,'Karwadi','423604',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9402,27,'Katalapur','422604',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9403,27,'Kawathe Kamaleshwar','422611',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9404,27,'Keli Kotul','422610',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9405,27,'Keli Rumhanwadi','422601',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9406,27,'Kelwad','423107',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9407,27,'Khandala Nandur','413720',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9408,27,'Khandgaon','422605',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9409,27,'Kharshinde','413738',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9410,27,'Khedle Kajali','414603',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9411,27,'Khirdi','413725',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9412,27,'Khirvire','422601',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9413,27,'Khokar','413739',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9414,27,'Kohane','422610',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9415,27,'Kokamthan','423601',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9416,27,'Kokangaon','413714',1,0,'2022-03-03 12:23:21','2022-03-03 12:23:21'),(9417,27,'Kolewadi','413706',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9418,27,'Kolgaon Thadi','423602',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9419,27,'Kolhar Khd','413710',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9420,27,'Kolhar (Ahmed Nagar)','413710',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9421,27,'Kolhewadi','422605',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9422,27,'Kolpewadi','423602',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9423,27,'Kombhalane','422601',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9424,27,'Kondhwad','413705',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9425,27,'Kopergaon Bet','423601',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9426,27,'Kopergaon','423601',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9427,27,'Korhale','423107',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9428,27,'Kothe BK','422620',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9429,27,'Kotul','422610',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9430,27,'Kukana','414604',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9431,27,'Kumbephal','422601',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9432,27,'Kumbhari','423602',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9433,27,'Kuran','422605',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9434,27,'Kuthe Malkapur','422622',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9435,27,'Lakh','413721',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9436,27,'Lavhali Otur','422604',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9437,27,'Laxmiwadi','423109',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9438,27,'Lingdeo','422610',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9439,27,'Lohare Mirpur','413736',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9440,27,'Lohgaon','413712',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9441,27,'Loni Bk','413736',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9442,27,'Loni Kurd','413713',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9443,27,'Lonkarwasti','423603',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9444,27,'Madhi BK','423601',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9445,27,'Mahegaon Dushmukh','423602',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9446,27,'Maldad','422608',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9447,27,'Malegaon','422604',1,0,'2022-03-03 12:23:22','2022-03-03 12:23:22'),(9448,27,'Malegaon Thadi','423602',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9449,27,'Malewadi','413718',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9450,27,'Malunja','422605',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9451,27,'Malunja BK','413721',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9452,27,'Malunja Khd','413721',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9453,27,'Malvadgaon','413739',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9454,27,'Mamdapur','413737',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9455,27,'Mandve Bk.','422622',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9456,27,'Mandve Khd','422622',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9457,27,'Manhere','422604',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9458,27,'Manjari','413705',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9459,27,'Manjur','423604',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9460,27,'Manori','413705',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9461,27,'Matapur','413717',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9462,27,'Maveshi','422604',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9463,27,'Maygaon Devi','423607',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9464,27,'Mhaisgaon','413706',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9465,27,'Mukindpur','414603',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9466,27,'Mulanagar','413722',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9467,27,'Murme (Deogad)','414603',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9468,27,'Murshatpur','423601',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9469,27,'Musalwadi','413716',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9470,27,'Muthalane','422601',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9471,27,'Muthkhel','422604',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9472,27,'Nanaj Dumala','422611',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9473,27,'Nandur Khandarmal','422620',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9474,27,'Nanduri Dumala','422603',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9475,27,'Narsali','413715',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9476,27,'Naur','413707',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9477,27,'Nevasa','414603',1,0,'2022-03-03 12:23:23','2022-03-03 12:23:23'),(9478,27,'Newasa Bk','414603',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9479,27,'Nilwande','422605',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9480,27,'Nimaj','422605',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9481,27,'Nimbhere','413711',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9482,27,'Nimgaon Bhojapur','422605',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9483,27,'Nimgaon Bk','422603',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9484,27,'Nimgaon Jali','413714',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9485,27,'Nimgaon Khairi','413723',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9486,27,'Nimgaon Tembhi','422605',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9487,27,'Nimon','422611',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9488,27,'Nipani Vadgaon','413739',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9489,27,'Pachegaon','413725',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9490,27,'Padalane','422604',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9491,27,'Padhegaon','423603',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9492,27,'Padhegaon','413721',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9493,27,'Padoshi','422601',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9494,27,'Palsunde','422610',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9495,27,'Pangari','422610',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9496,27,'Panwadi','413738',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9497,27,'Paregaon BK','422611',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9498,27,'Pathare Khd','413721',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9499,27,'Pathre Bk','413711',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9500,27,'Pemgiri','422603',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9501,27,'Pimpalgaon Depa','422622',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9502,27,'Pimpalgaon Khad','422610',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9503,27,'Pimpalgaon Matha','422605',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9504,27,'Pimpalgaon Nakvinda','422604',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9505,27,'Pimpalgaon Nipani','422605',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9506,27,'Pimparane','422605',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9507,27,'Pimparkane','422604',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9508,27,'Pimplwadi','423109',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9509,27,'Pimpri Lauki','413738',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9510,27,'Pimpri Nirmal','423107',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9511,27,'Pohegaon','423605',1,0,'2022-03-03 12:23:24','2022-03-03 12:23:24'),(9512,27,'Pravaranagar','413712',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9513,27,'Pun Tamba','413707',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9514,27,'Rahata','423107',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9515,27,'Rahuri Factory','413706',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9516,27,'Rahuri MPKV','413722',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9517,27,'Rahuri','413705',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9518,27,'Rahuri Town','413705',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9519,27,'Rajapur','422605',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9520,27,'Rajur','422604',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9521,27,'Rajuri','413737',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9522,27,'Ramdoh','414603',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9523,27,'Rampur','413710',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9524,27,'Ranad Bk','422604',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9525,27,'Ranjangaon Deshmukh','423605',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9526,27,'Ranjangaon Khurd','413719',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9527,27,'Ravande','423601',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9528,27,'Rui','423109',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9529,27,'Rumbhodi','422601',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9530,27,'Sakarwadi','413708',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9531,27,'Sakirwadi','422604',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9532,27,'Sakur','422622',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9533,27,'Sakuri','423107',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9534,27,'Salabatpur','414603',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9535,27,'Samesherpur','422601',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9536,27,'Samnapur','422605',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9537,27,'Samvatsar','423603',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9538,27,'Sangamner S.K.','422608',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9539,27,'Sangamner','422605',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9540,27,'Sangvi','422601',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9541,27,'Sangvi Bhusar','423602',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9542,27,'Sarole Pathar','422620',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9543,27,'Satewadi','422610',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9544,27,'Savali Vihir BK','423109',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9545,27,'Savali Vihir Farm','423109',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9546,27,'Savargaon Ghule','422620',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9547,27,'Savargaon Pat','422601',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9548,27,'Savargaon Tal','422605',1,0,'2022-03-03 12:23:25','2022-03-03 12:23:25'),(9549,27,'Shedgaon','413738',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9550,27,'Shenti','422604',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9551,27,'Shinganapur','423603',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9552,27,'Shingave','413708',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9553,27,'Shirasgaon','423603',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9554,27,'Shirasgaon','414603',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9555,27,'Shirasgaon','413739',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9556,27,'Shirdi','423109',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9557,27,'Shrirampur H.O','413709',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9558,27,'Sonewadi','423605',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9559,27,'Songaon','413711',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9560,27,'Subhashwadi','413720',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9561,27,'Sukewadi','422605',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9562,27,'Suregaon','414603',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9563,27,'Tahakari','422601',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9564,27,'Taharabad','413706',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9565,27,'Takali','423601',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9566,27,'Takalibhan','413725',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9567,27,'Taklimiya','413716',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9568,27,'Talegaon Dighe','422611',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9569,27,'Tambhere','413706',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9570,27,'Tambhol','422601',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9571,27,'Tandulwadi','413705',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9572,27,'Tarwadi','414604',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9573,27,'Telkudgaon','414604',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9574,27,'Thugaon BK','422601',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9575,27,'Tilaknagar (Ahmed Nagar)','413720',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9576,27,'Tirdhe','422601',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9577,27,'Tisgaon','413712',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9578,27,'Toka','414603',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9579,27,'Udadawane','422604',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9580,27,'Ukkalgaon','413715',1,0,'2022-03-03 12:23:26','2022-03-03 12:23:26'),(9581,27,'Umbargaon','413715',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9582,27,'Undirgaon','413718',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9583,27,'Usthal Dumala','414609',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9584,27,'Vadala Mahadeo','413739',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9585,27,'Vadgaon Landaga','422603',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9586,27,'Vadgaon Pan','422605',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9587,27,'Valan','413705',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9588,27,'Varkhed','414603',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9589,27,'Varshinde','413706',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9590,27,'Varudi Pathar','422620',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9591,27,'Vavrath','413705',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9592,27,'Velapur','423602',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9593,27,'Virgaon','422605',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9594,27,'Vithe','422604',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9595,27,'Waghapur','422610',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9596,27,'Waghapur','422605',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9597,27,'Wakadi','414604',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9598,27,'Wakadi','413719',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9599,27,'Waki','422604',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9600,27,'Waranghushi','422604',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9601,27,'Wari','413708',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9602,27,'Warwandi','413738',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9603,27,'Yesgaon','423601',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9604,27,'Zarekathi','413714',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9605,28,'Adgaon Bk','444126',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9606,28,'Adgaon KD','444126',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9607,28,'Adsul','444108',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9608,28,'Agar','444006',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9609,28,'Akola City','444002',1,0,'2022-03-03 12:23:27','2022-03-03 12:23:27'),(9610,28,'Akola H.O','444001',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9611,28,'Akoli Jahangir','444101',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9612,28,'Akolkhed','444101',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9613,28,'Akot Kut','444101',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9614,28,'Akot','444101',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9615,28,'Alanda','444401',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9616,28,'Alegaon','444511',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9617,28,'Anbhora','444107',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9618,28,'Andura','444311',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9619,28,'Anvi','444102',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9620,28,'Apoti','444003',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9621,28,'Assegaon Bazar','444101',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9622,28,'Babhulgaon','444501',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9623,28,'Babhulgaon Jahangir','444104',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9624,28,'Bahadura','444311',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9625,28,'Balapur','444302',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9626,28,'Balegaon','444117',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9627,28,'Bapori','444106',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9628,28,'Barshitakli','444401',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9629,28,'Batwadi','444302',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9630,28,'Belkhed','444108',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9631,28,'Bhamberi','444108',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9632,28,'Bhandaraj','444501',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9633,28,'Bhar','444506',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9634,28,'Bhatori','444107',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9635,28,'Bhendi Mahal','444407',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9636,28,'Bhurad','444002',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9637,28,'Bordi','444101',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9638,28,'Borgaon KD','444407',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9639,28,'Borgaon Manju','444102',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9640,28,'Borta','444106',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9641,28,'Bramhi','444106',1,0,'2022-03-03 12:23:28','2022-03-03 12:23:28'),(9642,28,'Chandikapur','444101',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9643,28,'Channi','444501',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9644,28,'Charangaon','444511',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9645,28,'Chatari','444501',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9646,28,'Chikhalgaon','444006',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9647,28,'Chittalwadi','444103',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9648,28,'Chohatta','444101',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9649,28,'Chondhi','444511',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9650,28,'Dagadparwa','444401',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9651,28,'Dahigaon','444102',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9652,28,'Dahigaon','444108',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9653,28,'Dahihanda','444111',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9654,28,'Danori Panori','444101',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9655,28,'Dapura','444003',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9656,28,'Degaon','444502',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9657,28,'Deoli','444102',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9658,28,'Deori','444101',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9659,28,'Deulgaon Bramhan','444501',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9660,28,'Dhabha','444401',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9661,28,'Dhotardi','444102',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9662,28,'Digras','444501',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9663,28,'Dongargaon','444104',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9664,28,'Dongargaon','444311',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9665,28,'Donwada','444003',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9666,28,'Durgwada','444107',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9667,28,'Gaigaon','444109',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9668,28,'Gajanan Nagar','444002',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9669,28,'Gandhigram','444006',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9670,28,'Gandhinagar (Akola)','444004',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9671,28,'Gawandgaon','444501',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9672,28,'Ghodegaon','444108',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9673,28,'Ghota','444107',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9674,28,'Ghungshi','444107',1,0,'2022-03-03 12:23:29','2022-03-03 12:23:29'),(9675,28,'Ghusar','444003',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9676,28,'Goregaon','444102',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9677,28,'Goregaon KD','444006',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9678,28,'Gudadhi','444005',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9679,28,'Hanwadi','444108',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9680,28,'Hata','444311',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9681,28,'Hatgaon','444107',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9682,28,'Hatola','444405',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9683,28,'Hatrun','444109',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9684,28,'Hingani KD','444103',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9685,28,'Hirpur','444107',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9686,28,'Hivara Mana','444106',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9687,28,'Hiverkhed Ruprao','444103',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9688,28,'Jalgaon Nahate','444126',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9689,28,'Jamakeshwar','444405',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9690,28,'Jambha','444102',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9691,28,'Jampthi','444106',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9692,28,'Januna','444405',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9693,28,'Jatherpeth Akola','444005',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9694,28,'Jaulkhed','444111',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9695,28,'Kajaleshwar','444401',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9696,28,'Kajaleshwar','444107',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9697,28,'Kalambi Mahagaon','444109',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9698,28,'Kalwadi','444101',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9699,28,'Kanadi','444107',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9700,28,'Kanheri Gawali','444302',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9701,28,'Kanheri Sarap','444401',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9702,28,'Kanshoni','444102',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9703,28,'Kanzara','444107',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9704,28,'Kanzara','444402',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9705,28,'Kapsi','444006',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9706,28,'Karanja Ramzanpur','444311',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9707,28,'Kasura','444109',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9708,28,'Kaulkhed','444102',1,0,'2022-03-03 12:23:30','2022-03-03 12:23:30'),(9709,28,'Kaulkhed','444004',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9710,28,'Kawasa','444101',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9711,28,'Kazikhed','444311',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9712,28,'Keliveli','444111',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9713,28,'Khambora','444006',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9714,28,'Khanapur','444501',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9715,28,'Khandala','444103',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9716,28,'Khandala','444109',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9717,28,'Kheldeshpande','444108',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9718,28,'Kherda Bhagai','444407',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9719,28,'Kherda Vilegaon','444107',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9720,28,'Khetri','444501',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9721,28,'Khirkund','444101',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9722,28,'Khirpuri','444302',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9723,28,'Kinkhed','444107',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9724,28,'Kinkhed','444111',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9725,28,'Kolambi','444102',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9726,28,'Kothali','444405',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9727,28,'Krishinagar Akola','444104',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9728,28,'Kurankhed','444102',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9729,28,'Kutasa','444101',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9730,28,'Lakhpuri','444107',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9731,28,'Lohagad','444401',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9732,28,'Lohara','444311',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9733,28,'Lonagra','444006',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9734,28,'Madhapuri','444106',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9735,28,'Mahagaon','444107',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9736,28,'Mahan','444405',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9737,28,'Malegaon Bazar','444108',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9738,28,'Malrajura','444501',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9739,28,'Malsoor','444501',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9740,28,'Mana','444106',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9741,28,'Manabda','444108',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9742,28,'Manarkhed','444109',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9743,28,'Mangrul Kambe','444107',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9744,28,'Manjari','444109',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9745,28,'Mathodi','444003',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9746,28,'Mazod','444006',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9747,28,'Mhaisang','444003',1,0,'2022-03-03 12:23:31','2022-03-03 12:23:31'),(9748,28,'Mhaispur','444006',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9749,28,'Midc Shivar','444104',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9750,28,'Mohala','444101',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9751,28,'Mokha','444311',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9752,28,'Morgaon Bhakre','444109',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9753,28,'Morgaon Kakad','444102',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9754,28,'Morgaon Sadijan','444311',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9755,28,'Morzadi','444109',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9756,28,'Mundgaon','444117',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9757,28,'Murtizapur City','444107',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9758,28,'Murtizapur','444107',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9759,28,'Ner','444108',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9760,28,'Nimba','444311',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9761,28,'Nimbha','444107',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9762,28,'Nimbhora','444006',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9763,28,'Nimbi Malokar','444006',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9764,28,'Nimkarda','444109',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9765,28,'Nipana','444102',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9766,28,'Pailpada','444102',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9767,28,'Palso Badhe','444102',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9768,28,'Palsod','444101',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9769,28,'Panaj','444101',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9770,28,'Panchagavan','444108',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9771,28,'Paras','444109',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9772,28,'Pardi Tad','444402',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9773,28,'Pathardi','444117',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9774,28,'Patkhed','444006',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9775,28,'Patur Nandapur','444407',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9776,28,'Patur','444501',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9777,28,'Pedgaon','444402',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9778,28,'Pimpalkhuta','444501',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9779,28,'Pimpri Kd','444126',1,0,'2022-03-03 12:23:32','2022-03-03 12:23:32'),(9780,28,'Pinjar','444407',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9781,28,'Pohi','444106',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9782,28,'Popatkheda','444101',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9783,28,'Punda','444101',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9784,28,'Punoti KD','444401',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9785,28,'Rahit','444407',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9786,28,'Rail','444111',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9787,28,'Rajanda','444006',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9788,28,'Rajankhed','444401',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9789,28,'Rajnapur Kinkinhi','444106',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9790,28,'Ramdaspeth Akola','444001',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9791,28,'Ramtek','444106',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9792,28,'Ranpisenagar Akola','444001',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9793,28,'Raundala','444108',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9794,28,'Ridhora','444302',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9795,28,'Rpts Akola','444002',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9796,28,'Ruikhed','444101',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9797,28,'Sanglood','444102',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9798,28,'Sangvi Kd','444006',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9799,28,'Sasti','444501',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9800,28,'Saundala','444103',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9801,28,'Sawara','444101',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9802,28,'Sawargaon','444501',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9803,28,'Shelubazar Mana','444106',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9804,28,'Shelubazar','444402',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9805,28,'Shirla Andhare','444501',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9806,28,'Shivaji Park Akola','444003',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9807,28,'Shoni','444104',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9808,28,'Sindkhed','444006',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9809,28,'Sirso','444107',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9810,28,'Sirsoli','444126',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9811,28,'Sonala Washim','444402',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9812,28,'Sonori','444107',1,0,'2022-03-03 12:23:33','2022-03-03 12:23:33'),(9813,28,'Sukoda','444006',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9814,28,'Tajnapeth Akola','444006',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9815,28,'Talegaon Bazar','444103',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9816,28,'Tandali','444501',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9817,28,'Tarhala','444402',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9818,28,'Telhara (Akola)','444108',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9819,28,'Tilak Road Akola','444001',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9820,28,'Titwa','444405',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9821,28,'Tulanga BK','444501',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9822,28,'Ugawa','444006',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9823,28,'Ukali Bazar','444108',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9824,28,'Umara','444101',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9825,28,'Umara Balapur','444501',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9826,28,'Umari','444005',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9827,28,'Ural','444311',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9828,28,'Vadali Deshmukh','444101',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9829,28,'Vadegaon','444502',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9830,28,'Vidyutnagar Paras','444109',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9831,28,'Vivra','444511',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9832,28,'Viwara','444501',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9833,28,'Vizora','444401',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9834,28,'Vyala','444302',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9835,28,'Wadad','444003',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9836,28,'Wadi Adampur','444108',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9837,28,'Wagha','444405',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9838,28,'Wai Pargane Mana','444107',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9839,28,'Wairat Rajapur','444006',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9840,28,'Wanoja','444402',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9841,28,'Wari','444103',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9842,28,'Warud','444108',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9843,28,'Warudjaula','444101',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9844,28,'Yeranda','444401',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9845,28,'Zodga','444405',1,0,'2022-03-03 12:23:34','2022-03-03 12:23:34'),(9846,29,'Achalpur City','444806',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9847,29,'Adgaon','444901',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9848,29,'Adgaon Navapur','444705',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9849,29,'Adula Bazar','444706',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9850,29,'Alangaon','444801',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9851,29,'Aloda','444908',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9852,29,'Ambada EB.O','444905',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9853,29,'Ambapati','444717',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9854,29,'Ambapeth','444601',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9855,29,'Amla','444802',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9856,29,'Amla Vishweshwar','444904',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9857,29,'Amner','444906',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9858,29,'Amravati Camp','444602',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9859,29,'Amravati H.O','444601',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9860,29,'Anjangaon Bari EB.O','444701',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9861,29,'Anjangaon','444705',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9862,29,'Anjansingi','444709',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9863,29,'Anjanwati','444709',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9864,29,'Antargaon','444706',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9865,29,'Arala','444705',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9866,29,'Asadpur','444806',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9867,29,'Asegaon Purna','444806',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9868,29,'Ashoknagar','444709',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9869,29,'Ashti','444801',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9870,29,'Ashtoli','444905',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9871,29,'Asra','444602',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9872,29,'Badhli','444705',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9873,29,'Badnapur','444717',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9874,29,'Badnera','444701',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9875,29,'Badnera Town','444701',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9876,29,'Baggi','444904',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9877,29,'Bairagad','444702',1,0,'2022-03-03 12:23:35','2022-03-03 12:23:35'),(9878,29,'Bargaon','444908',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9879,29,'Belaj','444723',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9880,29,'Belora','444704',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9881,29,'Benoda','444908',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9882,29,'Bhaji Bazar Amravati','444601',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9883,29,'Bhamod','444706',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9884,29,'Bhandaraj','444705',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9885,29,'Bhankheda Khurd','444904',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9886,29,'Bhatkkuli Ranak','444709',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9887,29,'Bhatkuli','444602',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9888,29,'Bhemdi','444906',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9889,29,'Bhilona','444806',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9890,29,'Bhokarbardi','444719',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9891,29,'Bhugaon','444806',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9892,29,'Bijudhawadi','444702',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9893,29,'Bobdo','444702',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9894,29,'Bodform','444702',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9895,29,'Bopapur','444806',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9896,29,'Borala','444704',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9897,29,'Borala','444808',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9898,29,'Borda','444709',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9899,29,'Bordi','444806',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9900,29,'Borgan','444602',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9901,29,'Borgaon Dhande','444709',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9902,29,'Borgaon Peth','444806',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9903,29,'Bori','444708',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9904,29,'Brahmanwada Gov','444901',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9905,29,'Brahmanwada Thadi','444720',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9906,29,'Chakarda','444702',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9907,29,'Chamak BK','444806',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9908,29,'Chandas Wathoda','444906',1,0,'2022-03-03 12:23:36','2022-03-03 12:23:36'),(9909,29,'Chandur Bazar','444704',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9910,29,'Chandur Railway','444904',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9911,29,'Chatwabod','444702',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9912,29,'Chausala','444705',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9913,29,'Chendakapur','444802',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9914,29,'Chhota Bazar','444805',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9915,29,'Chikhal Savangi','444905',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9916,29,'Chikhaldara','444807',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9917,29,'Chikhali','444813',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9918,29,'Chikhali Vaidya','444708',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9919,29,'Chincholi BK','444705',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9920,29,'Chincholi Gawal','444905',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9921,29,'Chincholi Kale','444801',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9922,29,'Chincholi Shinghane','444705',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9923,29,'Chinchpur','444709',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9924,29,'Chourakund','444813',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9925,29,'Churni','444807',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9926,29,'Congress Nagar (Amravati)','444606',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9927,29,'Cotton Market','444806',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9928,29,'Dabha','444701',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9929,29,'Dabhada','444709',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9930,29,'Dabida','444719',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9931,29,'Dabka','444719',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9932,29,'Dadhi','444602',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9933,29,'Dahenda','444702',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9934,29,'Dahigaon','444701',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9935,29,'Dahigaon Reche','444705',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9936,29,'Dahigaonpura','444704',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9937,29,'Dapori','444905',1,0,'2022-03-03 12:23:37','2022-03-03 12:23:37'),(9938,29,'Dapori Khurd','444707',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9939,29,'Darapur','444802',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9940,29,'Daryapur','444803',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9941,29,'Daryapur Town','444803',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9942,29,'Dawargaon','444901',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9943,29,'Deogaon','444709',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9944,29,'Deurwada','444704',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9945,29,'Dewara Antora','444901',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9946,29,'Dewara','444901',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9947,29,'Dhamak','444708',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9948,29,'Dhamangaon','444707',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9949,29,'Dhamangaon Gadhi','444717',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9950,29,'Dhamangaon R.S.','444709',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9951,29,'Dhamangaon Town','444709',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9952,29,'Dhamodi','444705',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9953,29,'Dhamori Kasba','444801',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9954,29,'Dhanegaon','444705',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9955,29,'Dhanodi','444906',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9956,29,'Dhanodi','444710',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9957,29,'Dhanora Fasi','444701',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9958,29,'Dhanora Gurav','444701',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9959,29,'Dhanora Mhali','444904',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9960,29,'Dhanora Mogal','444708',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9961,29,'Dharan Mahu','444702',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9962,29,'Dharni','444702',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9963,29,'Dhoter Kheda','444806',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9964,29,'Dhulghat Rly','444719',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9965,29,'Dhulghat Road','444719',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9966,29,'Dighi','444711',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9967,29,'Diya','444702',1,0,'2022-03-03 12:23:38','2022-03-03 12:23:38'),(9968,29,'Doma','444807',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9969,29,'Duni','444702',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9970,29,'Ekdara','444906',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9971,29,'Gadegaon','444906',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9972,29,'Gaiwadi','444705',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9973,29,'Gangarkheda','444807',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9974,29,'Ganoja','444602',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9975,29,'Ganori','444602',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9976,29,'Gaurkheda','444806',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9977,29,'Gaurkheda Bazar','444717',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9978,29,'Gavandkund','444906',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9979,29,'Gawandgaon','444705',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9980,29,'Gawhan','444705',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9981,29,'Ghatladki','444720',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9982,29,'Ghuikhed','444904',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9983,29,'Gokul Market','444606',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9984,29,'Gurukunj Ashram','444902',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9985,29,'H. V. Nagar','444605',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9986,29,'Hantoda','444705',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9987,29,'Haram','444806',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9988,29,'Harisal','444813',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9989,29,'Hartala','444802',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9990,29,'Hatru','444813',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9991,29,'Haturna','444801',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9992,29,'Haturna','444906',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9993,29,'Hirabambai','444702',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9994,29,'Hirpur','444709',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9995,29,'Hirur','444704',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9996,29,'Hiwara BK','444701',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9997,29,'Hiwarkhed','444905',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9998,29,'Isambari','444908',1,0,'2022-03-03 12:23:39','2022-03-03 12:23:39'),(9999,29,'Itki Antargaon','444705',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10000,29,'Ittamgaon','444908',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10001,29,'Jainpur','444706',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10002,29,'Jalka Hirapur','444801',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10003,29,'Jalka Jagtap','444904',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10004,29,'Jalka Patache','444709',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10005,29,'Jamgaon','444908',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10006,29,'Jamli','444717',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10007,29,'Jamthi Ganeshpur','444906',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10008,29,'Januna','444701',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10009,29,'Jarud','444908',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10010,29,'Jasapur','444704',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10011,29,'Jawala','444904',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10012,29,'Jawala BK','444705',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10013,29,'Jawala Shahpur','444801',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10014,29,'Juna Dhamangaon','444709',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10015,29,'Kajna','444701',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10016,29,'Kakda','444808',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10017,29,'Kalamgaon','444904',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10018,29,'Kalamkhar','444719',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10019,29,'Kalashi','444705',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10020,29,'Kalgawhan','444705',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10021,29,'Kamalpur Taroda','444705',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10022,29,'Kamnapur Ghusal','444709',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10023,29,'Kandli','444806',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10024,29,'Kanholi','444705',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10025,29,'Kapustalni','444901',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10026,29,'Kapustalni','444705',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10027,29,'Karajgaon (Gadlighat)','444908',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10028,29,'Karajgaon','444809',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10029,29,'Karanja Bahiram','444809',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10030,29,'Karla','444705',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10031,29,'Karla','444904',1,0,'2022-03-03 12:23:40','2022-03-03 12:23:40'),(10032,29,'Kasarkheda','444709',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10033,29,'Kathora','444602',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10034,29,'Kati','444906',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10035,29,'Katkumbha','444807',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10036,29,'Katpur','444707',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10037,29,'Katsur','444901',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10038,29,'Kawadgavan','444903',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10039,29,'Kawali','444709',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10040,29,'Kawatha','444602',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10041,29,'Kawatha Kadu','444904',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10042,29,'Kawathal','444707',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10043,29,'Kawitha','444723',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10044,29,'Kekatpur','444901',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10045,29,'Khairi','444804',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10046,29,'Khairi Tembhru','444702',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10047,29,'Khalkoni','444602',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10048,29,'Khallar','444803',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10049,29,'Khanapur','444905',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10050,29,'Khaparkheda','444719',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10051,29,'Kharala','444704',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10052,29,'Kharpi','444809',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10053,29,'Khartalegaon','444801',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10054,29,'Khaspur','444705',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10055,29,'Khed','444905',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10056,29,'Kholapur','444802',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10057,29,'Khondgaon','444705',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10058,29,'Khopada','444905',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10059,29,'Kohana','444806',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10060,29,'Kokarda','444803',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10061,29,'Kolha','444808',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10062,29,'Kolvihir','444905',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10063,29,'Kulangana','444717',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10064,29,'Kumbhargaon','444705',1,0,'2022-03-03 12:23:41','2022-03-03 12:23:41'),(10065,29,'Kural','444723',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10066,29,'Kurha','444809',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10067,29,'Kurha','444709',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10068,29,'Kushta BK','444808',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10069,29,'Kusumkot','444702',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10070,29,'Kutanga','444702',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10071,29,'Ladki','444905',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10072,29,'Lahegaon','444707',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10073,29,'Lakhad','444705',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10074,29,'Lehegaon','444705',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10075,29,'Linga','444906',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10076,29,'Lohgaon','444701',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10077,29,'Loni','444906',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10078,29,'Loni Takli','444701',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10079,29,'Lotwada','444706',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10080,29,'Madhan','444704',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10081,29,'Maheriam','444807',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10082,29,'Mahuli Chor','444701',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10083,29,'Mahuli Dhande','444705',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10084,29,'Mahuli Jahagir','444901',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10085,29,'Malhara','444806',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10086,29,'Malkhed','444904',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10087,29,'Mandwa','444702',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10088,29,'Mangrul Bhilasp','444901',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10089,29,'Mangrul Chawala','444708',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10090,29,'Mangrul Dastgir','444711',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10091,29,'Mangruli','444908',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10092,29,'Manjarkhed','444904',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10093,29,'Manjri Masla','444701',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10094,29,'Marda','444709',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10095,29,'Mardi','444904',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10096,29,'Markanda','444802',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10097,29,'Mhaispur','444801',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10098,29,'Mokhad','444708',1,0,'2022-03-03 12:23:42','2022-03-03 12:23:42'),(10099,29,'Morgad','444808',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10100,29,'Morshi','444905',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10101,29,'Motha','444807',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10102,29,'Mozri','444902',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10103,29,'Murha','444705',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10104,29,'Murtizapur Taro','444709',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10105,29,'Nalwada','444705',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10106,29,'Nanded BK','444802',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10107,29,'Nandgaon Khandeshwar','444708',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10108,29,'Nandgaon Peth','444901',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10109,29,'Nandrun','444706',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10110,29,'Nandsawangi','444701',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10111,29,'Nandura Bl','444801',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10112,29,'Nanduri','444813',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10113,29,'Narayanpur','444806',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10114,29,'Naya Akola','444801',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10115,29,'Nerpingalai','444707',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10116,29,'Nimbha','444602',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10117,29,'Nimbhari','444705',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10118,29,'Nimbhi','444905',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10119,29,'Nimbhora Bodkhe','444711',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10120,29,'Nimbhora Delwad','444903',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10121,29,'Nimboli','444711',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10122,29,'Nimgavan','444904',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10123,29,'Nimkhed Bazar','444705',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10124,29,'Nirul','444804',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10125,29,'Old Cotton Market','444601',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10126,29,'Pala','444905',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10127,29,'Palaskhed','444904',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10128,29,'Palasmandal','444701',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10129,29,'Pandhari','444808',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10130,29,'Papal','444701',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10131,29,'Paplam','444602',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10132,29,'Parasapur','444808',1,0,'2022-03-03 12:23:43','2022-03-03 12:23:43'),(10133,29,'Paratwada H.O','444805',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10134,29,'Pardi','444701',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10135,29,'Pardi','444905',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10136,29,'Pathrot','444808',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10137,29,'Pauni','444906',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10138,29,'Phubgaon','444708',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10139,29,'Phulamala','444701',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10140,29,'Pimpal Vihir','444902',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10141,29,'Pimpalgaon Nipa','444701',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10142,29,'Pimpalkhuta','444904',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10143,29,'Pimpalkhuta','444709',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10144,29,'Pimpalkhuta','444905',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10145,29,'Pimplod','444706',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10146,29,'Pimpri','444723',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10147,29,'Pimpri Nipani','444701',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10148,29,'Pohara','444904',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10149,29,'Porgawhan','444707',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10150,29,'Purna Nagar','444804',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10151,29,'Pusda','444801',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10152,29,'Pusla','444906',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10153,29,'Rahatgaon','444602',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10154,29,'Rahu','444813',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10155,29,'Raipur','444813',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10156,29,'Rajapeth','444601',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10157,29,'Rajna Purna','444806',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10158,29,'Rajura','444708',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10159,29,'Rajura Bazar','444906',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10160,29,'Rajurwadi','444707',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10161,29,'Rama','444804',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10162,29,'Ramtirth','444705',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10163,29,'Ranitamboli','444702',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10164,29,'Rasegaon','444806',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10165,29,'Ratnapur','444702',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10166,29,'Rewasa','444801',1,0,'2022-03-03 12:23:44','2022-03-03 12:23:44'),(10167,29,'Rithpur','444704',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10168,29,'Roshankheda','444906',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10169,29,'Rukhmini Nagar','444606',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10170,29,'Sadrabadi','444719',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10171,29,'Sai Nagar','444607',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10172,29,'Salepur','444806',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10173,29,'Salod','444708',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10174,29,'Salona','444807',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10175,29,'Salora Khurd','444901',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10176,29,'Samda','444705',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10177,29,'Sanglood','444706',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10178,29,'Sant GadgebabaAmravatiUniversityS.O','444602',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10179,29,'Sarfapur','444809',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10180,29,'Sarsi Kothoda','444701',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10181,29,'Sasan Ramapur','444706',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10182,29,'Satargaon','444701',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10183,29,'Satargaon','444903',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10184,29,'Sategaon','444705',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10185,29,'Satephal','444904',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10186,29,'Satnoor','444907',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10187,29,'Saur','444801',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10188,29,'Sawalapur','444804',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10189,29,'Sawalikheda','444719',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10190,29,'Sawaner','444708',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10191,29,'Sawanga','444908',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10192,29,'Sawangi','444906',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10193,29,'Sawangi Magrapur','444904',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10194,29,'Sawarkheda','444707',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10195,29,'Sayat','444602',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10196,29,'Semadoh','444813',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10197,29,'Shahapur','444807',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10198,29,'Shendola BK','444902',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10199,29,'Shendola KH','444902',1,0,'2022-03-03 12:23:45','2022-03-03 12:23:45'),(10200,29,'Shendurjana Bazar','444903',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10201,29,'Shendurjana Dha','444710',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10202,29,'Shendurjana Ghat','444907',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10203,29,'Shingnapur','444802',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10204,29,'Shingori','444905',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10205,29,'Shirala','444801',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10206,29,'Shirkhed','444707',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10207,29,'Shirpur','444702',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10208,29,'Shivaji Nagar (Amravati)','444603',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10209,29,'Shivangaon','444902',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10210,29,'Shivani Rasulpu','444708',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10211,29,'Shivar','444705',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10212,29,'Sindi BK','444808',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10213,29,'Sirajgaon Band','444723',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10214,29,'Sirasgaon','444901',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10215,29,'Sirasgaon Kasba','444810',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10216,29,'Sirasgaon Korde','444904',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10217,29,'Sirasgaon Mozar','444902',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10218,29,'Sonapur','444808',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10219,29,'Songaon','444705',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10220,29,'Sonora BK','444904',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10221,29,'Sonori','444704',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10222,29,'SRPF Camp','444602',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10223,29,'Sultanpur Nandu','444708',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10224,29,'Surali','444720',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10225,29,'Surji  (Anjangaon)','444705',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10226,29,'Surli','444906',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10227,29,'Susarda','444719',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10228,29,'Takarkheda','444801',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10229,29,'Takarkheda More','444705',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10230,29,'Takli','444705',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10231,29,'Takli','444801',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10232,29,'Takli BK','444701',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10233,29,'Talegaon','444707',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10234,29,'Talegaon Dashasar','444710',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10235,29,'Talegaon Mohana','444723',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10236,29,'Talegaon Thakur','444902',1,0,'2022-03-03 12:23:46','2022-03-03 12:23:46'),(10237,29,'Talni Purna','444806',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10238,29,'Talwel','444801',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10239,29,'Tambursonda','444717',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10240,29,'Tapovan','444602',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10241,29,'Taroda','444905',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10242,29,'Tarubanda','444813',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10243,29,'Tawlar','444808',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10244,29,'Tembhurkheda','444906',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10245,29,'Tembli','444702',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10246,29,'Teosa Ghat','444907',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10247,29,'Thilori','444705',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10248,29,'Tiosa','444903',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10249,29,'Titamba','444702',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10250,29,'Tiwara','444709',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10251,29,'Tolkhari','444717',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10252,29,'Tondgaon','444723',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10253,29,'Tonglabad','444705',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10254,29,'Tuljapur Gadhi','444723',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10255,29,'Turkhed','444705',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10256,29,'Udapur','444906',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10257,29,'Udkhed','444905',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10258,29,'Umri Mamadabad','444706',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10259,29,'Uttamsara','444602',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10260,29,'V.M.V. (Amravati)','444604',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10261,29,'Veni Ganeshpur','444708',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10262,29,'Verha','444903',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10263,29,'Vichori','444901',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10264,29,'Vihigaon','444705',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10265,29,'Virshi','444801',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10266,29,'Virul Ronghe','444709',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10267,29,'Vishnora','444707',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10268,29,'Vishroli','444720',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10269,29,'Wadgaon Fatepur','444808',1,0,'2022-03-03 12:23:47','2022-03-03 12:23:47'),(10270,29,'Wadgaon Mahore','444602',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10271,29,'Wadgaon Rajdi','444709',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10272,29,'Wadhona','444710',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10273,29,'Wadhona Ramnath','444701',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10274,29,'Wadnergangai','444706',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10275,29,'Wadura','444701',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10276,29,'Waigaon','444801',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10277,29,'Waki Raipur','444804',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10278,29,'Walgaon Road Tso Amravati','444601',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10279,29,'Walgaon','444801',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10280,29,'Wani','444720',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10281,29,'Warud Bk','444706',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10282,29,'Warud','444906',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10283,29,'Wasni Bzk','444806',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10284,29,'Wastapur','444717',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10285,29,'Wathoda Naya','444905',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10286,29,'Wathoda Sh.','444802',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10287,29,'Werkhed','444903',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10288,29,'Yawali','444901',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10289,29,'Yawali Dongar','444905',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10290,29,'Yenas','444708',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10291,29,'Yeoda','444706',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10292,29,'Yeota','444806',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10293,29,'Yeoti','444708',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10294,29,'Yerad','444708',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10295,29,'Yerandgaon','444701',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10296,29,'Yerla','444905',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10297,29,'Yesurna','444804',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10298,29,'Zada','444711',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10299,29,'Zilpi','444719',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10300,29,'Chincholi','442302',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10301,30,'Adgaon','431104',1,0,'2022-03-03 12:23:48','2022-03-03 12:23:48'),(10302,30,'Adgaon BK','431007',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10303,30,'Adgaon Sarak','431008',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10304,30,'Adul Budruk','431121',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10305,30,'Agarwadgaon','431110',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10306,30,'Ajantha Caves','431118',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10307,30,'Ajantha','431117',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10308,30,'Akoli Wadgaon','423701',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10309,30,'Aland','431134',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10310,30,'Amba (Upla)','431103',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10311,30,'Ambelohal','431133',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10312,30,'Ambhai','431112',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10313,30,'Amthana','431113',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10314,30,'Andhaner','431103',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10315,30,'Andhari','431151',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10316,30,'Antarwali Khandi','431121',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10317,30,'Anwa','431112',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10318,30,'Anwi','431112',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10319,30,'Apegaon','431107',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10320,30,'Assegaon','431002',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10321,30,'Aurala','431103',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10322,30,'Aurangabad (MH) H.O','431001',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10323,30,'Aurangabad Cantonment','431002',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10324,30,'Aurangabad City','431001',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10325,30,'Aurangabad Railway Station','431005',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10326,30,'Babhulgaon (Pirachi)','431115',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10327,30,'Babra','431151',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10328,30,'Badnapur','431202',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10329,30,'Badod Bazar','431134',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10330,30,'Badod Pan','431112',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10331,30,'Bahirgaon','431103',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10332,30,'Bahulkheda','431120',1,0,'2022-03-03 12:23:49','2022-03-03 12:23:49'),(10333,30,'Bajaj Nagar Midc Waluj','431136',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10334,30,'Balanagar','431105',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10335,30,'Balapur','431117',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10336,30,'Balegaon','431116',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10337,30,'Bankinhola','431135',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10338,30,'Banoti','431150',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10339,30,'Banshendra','431103',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10340,30,'Basadi','431104',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10341,30,'Begumpura','431004',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10342,30,'Bhaggaon','423701',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10343,30,'Bhagur','423701',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10344,30,'Bhakarwadi','431154',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10345,30,'Bhalgaon','431007',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10346,30,'Bharadi','431113',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10347,30,'Bharamba','431104',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10348,30,'Bhendala','431110',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10349,30,'Bhivgaon','423703',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10350,30,'Bhokardan','431114',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10351,30,'Bidkingaon','431105',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10352,30,'Bihamandwa','431137',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10353,30,'Bilda','431008',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10354,30,'Biloni','431116',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10355,30,'Bodhegaon','431151',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10356,30,'Bodkha','431111',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10357,30,'Bokud Jalgaon','431105',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10358,30,'Borgaon Arj','431134',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10359,30,'Borgaon Bazar','431113',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10360,30,'Borgaon Kasari','431135',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10361,30,'Borsar BK','431102',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10362,30,'Borsar(Bhingi)','423703',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10363,30,'Bramhani','431103',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10364,30,'Chandgon','423701',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10365,30,'Changatpuri','431107',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10366,30,'Chapaner','431103',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10367,30,'Charner','431113',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10368,30,'Chikalthana Industrial Area','431006',1,0,'2022-03-03 12:23:50','2022-03-03 12:23:50'),(10369,30,'Chikalthana','431007',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10370,30,'Chikatgaon','431116',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10371,30,'Chikhalthan','431103',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10372,30,'Chinchadgaon','423701',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10373,30,'Chincholi Limbaji','431147',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10374,30,'Chitegaon','431105',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10375,30,'Chittepimpalgaon','431007',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10376,30,'Chorwaghalgaon','423701',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10377,30,'Chouka','431008',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10378,30,'Cidco Colony (Aurangabad)','431003',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10379,30,'Dahegaon','431147',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10380,30,'Dahegaon','423703',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10381,30,'Daulatabad','431002',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10382,30,'Dawarwadi','431107',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10383,30,'Debhegaon','431102',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10384,30,'Deogaon Rangari','431115',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10385,30,'Deulgaon Bazar','431113',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10386,30,'Devlana','431102',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10387,30,'Dhamangaon','431111',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10388,30,'Dhkephal','431105',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10389,30,'Dhondalgaon','423703',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10390,30,'Dhorkingaon','431105',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10391,30,'Dhupkheda','431105',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10392,30,'Dongaon','423702',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10393,30,'Dr. B.A. Marathwada University','431004',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10394,30,'Dudhad','431154',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10395,30,'Ektuni','431121',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10396,30,'Ellora Caves','431102',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10397,30,'Ellora','431102',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10398,30,'Eta','431103',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10399,30,'Fazalpura','431001',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10400,30,'Gadana','431101',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10401,30,'Gadhejalgaon','431154',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10402,30,'Gadhepimpalgaon','423701',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10403,30,'Gajgaon','423702',1,0,'2022-03-03 12:23:51','2022-03-03 12:23:51'),(10404,30,'Galle Borgaon','431102',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10405,30,'Gangapur (Aurangabad-MH)','431109',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10406,30,'Ganori','431008',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10407,30,'Garaj','431115',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10408,30,'Garkheda','431009',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10409,30,'Gavli Tanda','431135',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10410,30,'Gawali Shivra','423702',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10411,30,'Georai Kuber','431154',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10412,30,'Gevarai','431002',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10413,30,'Gevarai BK','431121',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10414,30,'Gevrai Shami','431135',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10415,30,'Ghanegaon','431136',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10416,30,'Ghardon','431007',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10417,30,'Gharegaon Ektuni','431121',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10418,30,'Ghat Shendra','431147',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10419,30,'Ghatnanadra','431113',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10420,30,'Ghodegaon','423702',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10421,30,'Golatgaon','431154',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10422,30,'Golegaon','431112',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10423,30,'Golegaon','431101',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10424,30,'Gondegaon','431150',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10425,30,'Halda','431112',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10426,30,'Hanumantkheda','431150',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10427,30,'Harshi','431107',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10428,30,'Harsool','431008',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10429,30,'Hasnabad','431114',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10430,30,'Hasta','431104',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10431,30,'Hatnoor','431103',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10432,30,'Hatti','431112',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10433,30,'High Court Building (Aurangabad)','431005',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10434,30,'Hingoni','423701',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10435,30,'Hiradpuri','431137',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10436,30,'Issarwadi','431148',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10437,30,'Jaitapur','431103',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10438,30,'Jaitkheda','431103',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10439,30,'Jalgaon','423702',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10440,30,'Jalgaon','431112',1,0,'2022-03-03 12:23:52','2022-03-03 12:23:52'),(10441,30,'Jambhargaon','423701',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10442,30,'Jamdi Jahangir','431147',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10443,30,'Jamthi','431118',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10444,30,'Janephal','431116',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10445,30,'Jarandi','431120',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10446,30,'Jategaon','423701',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10447,30,'Jategaon','431111',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10448,30,'Jatwada','431008',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10449,30,'Jehur','431103',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10450,30,'Jikthan','431133',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10451,30,'Kachner','431007',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10452,30,'Kadethan','431121',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10453,30,'Kagazipura','431101',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10454,30,'Kaigaon','431110',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10455,30,'Kaigaon','431135',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10456,30,'Kalandrabad (Kasabkheda)','431102',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10457,30,'Kalimath','431103',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10458,30,'Kanhori','431111',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10459,30,'Kankori','423702',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10460,30,'Kannad','431103',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10461,30,'Karanjgaon','423703',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10462,30,'Karanjkheda','431147',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10463,30,'Karkin','431105',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10464,30,'Karmad','431154',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10465,30,'Kasoda','431133',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10466,30,'Katepimpalgaon','423701',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10467,30,'Katpur','431148',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10468,30,'Kelgaon','431112',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10469,30,'Kerhala','431135',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10470,30,'Khadgaon','431121',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10471,30,'Khamgaon','431151',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10472,30,'Khandala','431116',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10473,30,'Khirdi','431101',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10474,30,'Khodegaon','431007',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10475,30,'Khuldabad','431101',1,0,'2022-03-03 12:23:53','2022-03-03 12:23:53'),(10476,30,'Khumbhephal','431154',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10477,30,'Kingaon','431111',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10478,30,'Kolhi','431116',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10479,30,'Kolwadi','431103',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10480,30,'Kranti Chowk','431005',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10481,30,'Ladgaon','423701',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10482,30,'Ladsawangi','431154',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10483,30,'Lakhani','431115',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10484,30,'Lakhegaon','431105',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10485,30,'Lamangaon','431115',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10486,30,'Lasur Station','423702',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10487,30,'Lasurgaon','423702',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10488,30,'Liha Khedi','431112',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10489,30,'Lohgaon','431105',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10490,30,'Loni KH','431116',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10491,30,'Lonwadi','431151',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10492,30,'Madni','431132',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10493,30,'Mahalgaon','423701',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10494,30,'Mahora','431104',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10495,30,'Maleghogargaon','423701',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10496,30,'Mali Wadgaon','431115',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10497,30,'Maliwada','431002',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10498,30,'Malunja','431109',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10499,30,'Mangrul','431112',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10500,30,'Manjri','431109',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10501,30,'Manur','431115',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10502,30,'Marsawali','431134',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10503,30,'Medical College (Aurangabad)','431001',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10504,30,'Mehaboobkheda','423702',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10505,30,'Modha BK','431112',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10506,30,'Mulani Wadgaon','431105',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10507,30,'Mundwadi','431103',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10508,30,'Nachanwel','431104',1,0,'2022-03-03 12:23:54','2022-03-03 12:23:54'),(10509,30,'Nagad','431103',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10510,30,'Nagamthan','423701',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10511,30,'Nagapur','431147',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10512,30,'Naigavhan','431154',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10513,30,'Nakshtrawadi','431002',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10514,30,'Nalegaon','423703',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10515,30,'Nander','431107',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10516,30,'Nandra','431111',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10517,30,'Narayangaon','431148',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10518,30,'Naregaon','431007',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10519,30,'Nathnagar North','431106',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10520,30,'Navgaon','431137',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10521,30,'Nevargaon','431110',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10522,30,'Nevpur','431147',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10523,30,'Nidhona','431151',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10524,30,'Nilajgaon','431105',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10525,30,'Nillod','431135',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10526,30,'Nimbhora','431104',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10527,30,'Nizamganj','431003',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10528,30,'Osmanpura','431005',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10529,30,'Pachod','431121',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10530,30,'Padali','431111',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10531,30,'Padegaon','431002',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10532,30,'Paithan','431107',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10533,30,'Paithan Sakhar Karkhana','431148',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10534,30,'Pal','431111',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10535,30,'Palaskheda','431118',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10536,30,'Palaswadi','431102',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10537,30,'Palkheda','423703',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10538,30,'Palod','431112',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10539,30,'Palshi (Shahar)','431008',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10540,30,'Palshi','431135',1,0,'2022-03-03 12:23:55','2022-03-03 12:23:55'),(10541,30,'Palshi BK','431104',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10542,30,'Paradh','431114',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10543,30,'Parala','431116',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10544,30,'Parsoda','423703',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10545,30,'Parsoda Sk','423703',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10546,30,'Parundi','431121',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10547,30,'Pathri','431111',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10548,30,'Pendapur','431133',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10549,30,'Phardapur','431118',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10550,30,'Phulmbri','431111',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10551,30,'Pimpalgaon Diwashi','423702',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10552,30,'Pimpalgaon Gangdev','431111',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10553,30,'Pimpalwadi (Pirachi)','431148',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10554,30,'Pimparkheda','431104',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10555,30,'Pimpri','431102',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10556,30,'Pimpri Raja','431007',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10557,30,'Pir Bawada','431134',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10558,30,'Pishore','431104',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10559,30,'Pokhari','431115',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10560,30,'Porgaon','431105',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10561,30,'Raghunath Nagar (Aurangabad)','431110',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10562,30,'Rahatgaon','431107',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10563,30,'Rahegaon','423702',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10564,30,'Rahemabad','431112',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10565,30,'Rail','431103',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10566,30,'Ranjagaon Pol','423702',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10567,30,'Ranjangaon Pan','431105',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10568,30,'Relgaon','431113',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10569,30,'Rotegaon R.S.','423701',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10570,30,'Saigavan','431103',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10571,30,'Samarthnagar','431001',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10572,30,'Saraswati Colony','431001',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10573,30,'Sarola','431104',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10574,30,'Satara','431002',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10575,30,'Satara Parisar','431010',1,0,'2022-03-03 12:23:56','2022-03-03 12:23:56'),(10576,30,'Savandgaon','423703',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10577,30,'Sawaladbara','431118',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10578,30,'Sawangi Bazar','431111',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10579,30,'Sawkheda','431133',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10580,30,'Session Court (Aurangabad)','431005',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10581,30,'Shahaganj (Aurangabad)','431001',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10582,30,'Shekta','431105',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10583,30,'Shekta','431154',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10584,30,'Shendra MIDC Area','431154',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10585,30,'Shendurwada','431133',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10586,30,'Sheoga','431154',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10587,30,'Shevta','431105',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10588,30,'Shirodi','431111',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10589,30,'Shivar','431116',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10590,30,'Shivna','431132',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10591,30,'Shivrai','423703',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10592,30,'Sidhanath Wadgaon','423702',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10593,30,'Sillegaon','423702',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10594,30,'Sillod','431112',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10595,30,'Sillod Sakhar Karkhana','431135',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10596,30,'Singhi','431109',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10597,30,'Sirasgaon','423701',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10598,30,'Soegaon','431120',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10599,30,'Solegaon','431133',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10600,30,'Sultanpur','431101',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10601,30,'Tadpimpalgaon','431115',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10602,30,'Takali Ambad','431137',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10603,30,'Takali Kadim','431002',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10604,30,'Takali Raje Rai','431101',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10605,30,'Talni','431113',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10606,30,'Talpimpri','431133',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10607,30,'Talwada','431116',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10608,30,'Tanda Bazar','431135',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10609,30,'Tapargaon','431103',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10610,30,'Tembhapuri','431133',1,0,'2022-03-03 12:23:57','2022-03-03 12:23:57'),(10611,30,'Thergaon','431121',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10612,30,'Tidka','431150',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10613,30,'Tisgaon','431102',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10614,30,'Tuljapur Sawangi','431008',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10615,30,'Tunki','431116',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10616,30,'Turkabad','431133',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10617,30,'Umarkheda','431147',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10618,30,'Undangaon','431112',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10619,30,'Upali','431135',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10620,30,'Vaijapur','423701',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10621,30,'Vaijapur Town','423701',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10622,30,'Veergaon','423701',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10623,30,'Wadali','431103',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10624,30,'Wadgaon Tigji','431150',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10625,30,'Wadner','431103',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10626,30,'Wadwali','431107',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10627,30,'Wahegaon','431148',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10628,30,'Wahegaon','431109',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10629,30,'Wakla','431116',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10630,30,'Wakod','431147',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10631,30,'Wakulni','431154',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10632,30,'Waladgaon','431136',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10633,30,'Waluj','431133',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10634,30,'Wanegaon','431111',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10635,30,'Wangi Khurd','431113',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10636,30,'Wanjargaon','423701',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10637,30,'Waregaon','431111',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10638,30,'Warkheda','431109',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10639,30,'Warud KH','431135',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10640,30,'Warudkazi','431154',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10641,30,'Warzadi','431154',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10642,30,'Yesgaon','431101',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10643,30,'Yesgaon','423702',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10644,31,'Adas','431517',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10645,31,'Adgaon','431153',1,0,'2022-03-03 12:23:58','2022-03-03 12:23:58'),(10646,31,'Aherwahegaon','431143',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10647,31,'Amalner (Beed)','413207',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10648,31,'Ambajogai','431517',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10649,31,'Ambasakhar','431523',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10650,31,'Ambewadgaon','431124',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10651,31,'Ambhora','414202',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10652,31,'Anandgaon','431131',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10653,31,'Anjandoha','431124',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10654,31,'Anjanwati','431126',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10655,31,'Antarwali BK','431127',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10656,31,'Antharwan Pimpri','431153',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10657,31,'Apegaon','431517',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10658,31,'Ardha Pimpri','431130',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10659,31,'Arvi','413249',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10660,31,'Asardoha','431124',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10661,31,'Ashta Harinarayan','414203',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10662,31,'Ashti (Beed)','414203',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10663,31,'Badibadi','431131',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10664,31,'Bagpimpalgoan','431127',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10665,31,'Bangali Pimpla','431130',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10666,31,'Bansorala','431518',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10667,31,'Bardapur','431517',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10668,31,'Beed H.O','431122',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10669,31,'Beed Sangvi','414203',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10670,31,'Beed ST Stand','431153',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10671,31,'Belamba','431530',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10672,31,'Belgaon','414208',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10673,31,'Belura','414205',1,0,'2022-03-03 12:23:59','2022-03-03 12:23:59'),(10674,31,'Belura','431128',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10675,31,'Bensur','414204',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10676,31,'Bhalwani','414203',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10677,31,'Bhendtakli','431129',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10678,31,'Bhogalgaon','431127',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10679,31,'Bhogalwadi','431124',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10680,31,'Borgaon','431123',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10681,31,'Borgaon BK','431130',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10682,31,'Borisawargaon','431518',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10683,31,'Borkhed','431126',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10684,31,'Borphadi','431153',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10685,31,'Brahmagaon','414203',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10686,31,'Chakarwadi','431125',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10687,31,'Chaklamba','431130',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10688,31,'Chanai','431517',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10689,31,'Chandan Sawargaon','431123',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10690,31,'Chardari','431144',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10691,31,'Chartha','431153',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10692,31,'Chichala','431144',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10693,31,'Chikhalbeed','431124',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10694,31,'Chikhali','414203',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10695,31,'Chikhali','413207',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10696,31,'Chincholi','431123',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10697,31,'Chinchwan','431124',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10698,31,'Chondi','431124',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10699,31,'Choramba','431124',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10700,31,'Chousala','431126',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10701,31,'Court Road','431122',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10702,31,'Dadahari Wadgaon','431515',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10703,31,'Dadegaon','414202',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10704,31,'Dahiphal Wadmauli','431123',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10705,31,'Daithan','431127',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10706,31,'Daskhed','414204',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10707,31,'Deo Pimpri','431130',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10708,31,'Deodahiphal','431128',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10709,31,'Deogaon','431123',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10710,31,'Deola','431523',1,0,'2022-03-03 12:24:00','2022-03-03 12:24:00'),(10711,31,'Deolali','414202',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10712,31,'Deulgaon Ghat','414202',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10713,31,'Devala','431144',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10714,31,'Devi Babhulgoan','431126',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10715,31,'Devinimgaon','414202',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10716,31,'Dhamangaon','414202',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10717,31,'Dhanegaon Camp','431518',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10718,31,'Dhangarjawalka','414204',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10719,31,'Dhanora','414202',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10720,31,'Dhanora','431523',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10721,31,'Dharmapuri','431515',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10722,31,'Dhekanmoha','431153',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10723,31,'DHONDIPURA','431122',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10724,31,'Dhondrai','431127',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10725,31,'Dighol Amba','431517',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10726,31,'Dindrood','431128',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10727,31,'Doithan','414203',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10728,31,'Domri','414204',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10729,31,'Dongar Patoda','414205',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10730,31,'Dongar Pimpla','431517',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10731,31,'Dongargan','414202',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10732,31,'Dongarkinhi','413229',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10733,31,'Gangadevi','414203',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10734,31,'Gangamasla','431131',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10735,31,'Gevrai','431127',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10736,31,'Ghagarwada','431124',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10737,31,'Ghatapimpri','414202',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10738,31,'Ghatnandur','431519',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10739,31,'Ghatsawali','431144',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10740,31,'Ghatshilpargaon','413249',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10741,31,'Ghogas Pargaon','431130',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10742,31,'Girwali','431519',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10743,31,'Gomalwada','413249',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10744,31,'Goverdhan Hiwara','431128',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10745,31,'Gulaj','431130',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10746,31,'Halam','431515',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10747,31,'Harichanra Pimpri','431144',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10748,31,'Harkinnimgaon','431129',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10749,31,'Hatola','431517',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10750,31,'Hingni BK','431126',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10751,31,'Hingni BK','431128',1,0,'2022-03-03 12:24:01','2022-03-03 12:24:01'),(10752,31,'Hirapur','431143',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10753,31,'Hiwara','431129',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10754,31,'Hiwara','414202',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10755,31,'Hoal','431517',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10756,31,'Jamgoan','414203',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10757,31,'Jategaon','431127',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10758,31,'Jatnandur','413229',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10759,31,'Jawalban','431518',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10760,31,'Jawalgaon','431517',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10761,31,'JBSSK GADI','431143',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10762,31,'Jeba Pimpri','431126',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10763,31,'Jiwachiwadi','431123',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10764,31,'Jogeswari Pargaon','414203',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10765,31,'Kada (Beed)','414202',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10766,31,'Kadasakhar','414208',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10767,31,'Kadiwadgaon','431153',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10768,31,'Kaij','431123',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10769,31,'Kalamamba','431123',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10770,31,'Kalegoanghat','431123',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10771,31,'Kalsambar','431125',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10772,31,'Kamkheda','431153',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10773,31,'Kanherwadi','431515',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10774,31,'Karegaon','413229',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10775,31,'Karhewadgaon','414203',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10776,31,'Kari','431124',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10777,31,'Kauthali','431530',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10778,31,'Kawadgaon','431153',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10779,31,'Kekat Pangri','431127',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10780,31,'Kelsangvi','414208',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10781,31,'Kerul','414208',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10782,31,'Kesapuri Camp','431142',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10783,31,'Khadkat','414203',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10784,31,'Khadkighat','431126',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10785,31,'Khalapuri','414205',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10786,31,'Khalegaon','431130',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10787,31,'Khalwatnimgaon','431153',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10788,31,'Khandvi','431143',1,0,'2022-03-03 12:24:02','2022-03-03 12:24:02'),(10789,31,'Khilad','414208',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10790,31,'Khodwa Sawargaon','431515',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10791,31,'Khokarmoha','414205',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10792,31,'Kille Dharur','431124',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10793,31,'Kittiadgaon','431142',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10794,31,'Kolgaon','431143',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10795,31,'Kotan','413207',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10796,31,'Kumbephal','431123',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10797,31,'Kuntephal Pundi','414202',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10798,31,'Kuppa','431144',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10799,31,'Kurla','431153',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10800,31,'Kuslamb','413207',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10801,31,'Ladewadgaon','431517',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10802,31,'Lahuri','431123',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10803,31,'Laul','431131',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10804,31,'Limbaganesh','431126',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10805,31,'Lokhandi Sawargaon','431517',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10806,31,'Loni','414202',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10807,31,'Loni','413249',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10808,31,'Lonighat','431126',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10809,31,'M.GANJ','431122',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10810,31,'Madalmohi','431143',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10811,31,'Mahalas Jawala','431153',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10812,31,'Majalgaon','431131',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10813,31,'Malapuri','431153',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10814,31,'Malegaon','431123',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10815,31,'Malegaon KHD','431130',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10816,31,'Manarsumba','431125',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10817,31,'Mandva','431515',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10818,31,'Mangrul','431131',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10819,31,'Mangwadgaon','431123',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10820,31,'Manjrath','431131',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10821,31,'Manur','413249',1,0,'2022-03-03 12:24:03','2022-03-03 12:24:03'),(10822,31,'MARKET YARD (Beed)','431122',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10823,31,'Massajog','431123',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10824,31,'Matawali','414203',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10825,31,'Mategoan','431130',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10826,31,'Matkuli','414203',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10827,31,'Matori','431130',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10828,31,'Mauj','431153',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10829,31,'MEDICAL COLLEGE ','431517',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10830,31,'Mirwat','431515',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10831,31,'Moha','431128',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10832,31,'Mohkhed','431128',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10833,31,'Morgaon','431126',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10834,31,'Muggaon','414204',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10835,31,'Murshadpur','414205',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10836,31,'Nagapur','431530',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10837,31,'Nagtala','414203',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10838,31,'Naholi','431126',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10839,31,'Naigaon','414205',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10840,31,'Naigaon','431518',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10841,31,'Naiknoor','431125',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10842,31,'Nalwandi','431153',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10843,31,'Nandagaul','431519',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10844,31,'Nandurghat','431126',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10845,31,'Nathapur','431153',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10846,31,'Nehru chowk','431515',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10847,31,'Nimgaon Choba','414208',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10848,31,'Nimgaon Mayamba','431130',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10849,31,'Nirgudi','414205',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10850,31,'Nithrud','431131',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10851,31,'Pachangri','414204',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10852,31,'Pachegaon','431143',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10853,31,'Padali','413249',1,0,'2022-03-03 12:24:04','2022-03-03 12:24:04'),(10854,31,'Padalsingi','431143',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10855,31,'Pahadi Pargaon','431144',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10856,31,'Pali','431153',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10857,31,'Palshingan','431126',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10858,31,'Palwan','431153',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10859,31,'Pangri','413229',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10860,31,'Pangri','431530',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10861,31,'Parbhani Kesapuri','431153',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10862,31,'Pargaon Ghumra','414204',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10863,31,'Pargaon Shiras','414205',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10864,31,'Parli Tps','431520',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10865,31,'Parli Vaijinath','431515',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10866,31,'Parner','414204',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10867,31,'Pathrood','431131',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10868,31,'Patoda','431523',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10869,31,'Patoda (Beed)','414204',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10870,31,'Patsara','414203',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10871,31,'Pattiwadgaon','431519',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10872,31,'Phulepimpalgoan','431142',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10873,31,'Phulsangvi','431143',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10874,31,'Pimpalgaon Dhas','413229',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10875,31,'Pimpalgaon Ghat','431126',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10876,31,'Pimpalgoan Gadhe','431530',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10877,31,'Pimpalner','413207',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10878,31,'Pimpalner','431153',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10879,31,'Pimpalwadi','431153',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10880,31,'Pimpalwandi (Beed)','413229',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10881,31,'Pimpla','414202',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10882,31,'Pimpla Dhaiguda','431517',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10883,31,'Pimpri BK','431128',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10884,31,'Pipmarkhed','431144',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10885,31,'Pohner','431128',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10886,31,'Poos','431519',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10887,31,'Pothra','431126',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10888,31,'Purshottampuri','431131',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10889,31,'Radi','431523',1,0,'2022-03-03 12:24:05','2022-03-03 12:24:05'),(10890,31,'Raimoha','414205',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10891,31,'Raj Pimpri','431127',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10892,31,'Rajegaon','431129',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10893,31,'Rajewadi','431131',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10894,31,'Rajuri Navgan','414205',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10895,31,'Rakashasbhuwan Shani','431130',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10896,31,'Rakshas Bhuwan Tamba','413249',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10897,31,'Rampuri','431129',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10898,31,'Ranjani','431143',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10899,31,'Reoki','431127',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10900,31,'Rohatwadi','414204',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10901,31,'Rui','431129',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10902,31,'Ruinalkol','414202',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10903,31,'Ruithal','431127',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10904,31,'Sadola','431131',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10905,31,'Saigaon','431523',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10906,31,'Sakshas Pimpri','414205',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10907,31,'Salegaon','431123',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10908,31,'Salunkwadi','431519',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10909,31,'Sandas Chincholi','431131',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10910,31,'Saratewadgoan','414202',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10911,31,'Sarni Sangvi','431123',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10912,31,'Sautada','414204',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10913,31,'Sawaleswar Paithan','431518',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10914,31,'Sawargaon','414203',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10915,31,'Sawargaon Ghat','413207',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10916,31,'Shekta','431130',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10917,31,'Shindi','431123',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10918,31,'Shiral','414208',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10919,31,'Shirasdevi','431129',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10920,31,'Shirasmarg','431143',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10921,31,'Shirur (Beed)','413249',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10922,31,'Shirurghat','431126',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10923,31,'Shivni','431153',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10924,31,'Sirsala','431128',1,0,'2022-03-03 12:24:06','2022-03-03 12:24:06'),(10925,31,'Somnath Borgaon','431517',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10926,31,'Sonasangvi','431123',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10927,31,'Sonnathadi','431131',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10928,31,'Sonwala','431517',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10929,31,'Suggaon','431523',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10930,31,'Suleman Deola','414202',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10931,31,'Sushi','431143',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10932,31,'Tadsonna','431153',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10933,31,'Takalsingi','414203',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10934,31,'Takarwan','431129',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10935,31,'Takli Amiya','414202',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10936,31,'Takli','431123',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10937,31,'Talkhed','431129',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10938,31,'Talnewadi','431127',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10939,31,'Talwada','431127',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10940,31,'Tambarajuri','414204',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10941,31,'Tambwa','431123',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10942,31,'Telgoan','431131',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10943,31,'Therla','414204',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10944,31,'Tintarwani','431130',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10945,31,'Tokwadi','431530',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10946,31,'Ujani','431519',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10947,31,'Umapur','431130',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10948,31,'Umri','431128',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10949,31,'Undri','431123',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10950,31,'Upali','431144',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10951,31,'Vaidyakinhi','414204',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10952,31,'Vida','431123',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10953,31,'Vssk Pangri','431530',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10954,31,'Wadgaon Daula','414202',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10955,31,'Wadwani','431144',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10956,31,'Waghebabhulgaon','431126',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10957,31,'Waghira','414204',1,0,'2022-03-03 12:24:07','2022-03-03 12:24:07'),(10958,31,'Waghluj','414202',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10959,31,'Waghora','431129',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10960,31,'Wahegaon Amla','431129',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10961,31,'Wahira','414202',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10962,31,'Wangi','431128',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10963,31,'Warapgoan','431123',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10964,31,'Warni','413249',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10965,31,'Warola','431129',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10966,31,'Warwati','431517',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10967,31,'Welturi','414203',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10968,31,'YCC','431517',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10969,31,'Yelda','431517',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10970,31,'Yellamb Bhrahmanath','413249',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10971,31,'Yellambghat','431125',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10972,31,'Yeota','431123',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10973,31,'Yusuf Wadgaon','431517',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10974,32,'Adyar (Bhandara)','441903',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10975,32,'Akot','441908',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10976,32,'Alesure','441912',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10977,32,'Amgaon Adarsh Pauni','441910',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10978,32,'Amgaon BK','441802',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10979,32,'Amgaon Dighori','441804',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10980,32,'Andhalgaon','441914',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10981,32,'Asgaon','441910',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10982,32,'Ashti','441907',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10983,32,'Bampewada','441802',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10984,32,'Bapera','441915',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10985,32,'Barwa','441805',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10986,32,'Bela','441906',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10987,32,'Belati','441908',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10988,32,'Betara','441905',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10989,32,'Bhagdi','441803',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10990,32,'Bhandara H.O','441904',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10991,32,'Bhandara Of','441906',1,0,'2022-03-03 12:24:08','2022-03-03 12:24:08'),(10992,32,'Bhandara Road','441905',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(10993,32,'Bhandara Town','441904',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(10994,32,'Bhawad','441908',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(10995,32,'Bhendala','441910',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(10996,32,'Bhugaon','441809',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(10997,32,'Bhuyar','441910',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(10998,32,'Chandori','441924',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(10999,32,'Chandori','441802',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11000,32,'Channa','441809',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11001,32,'Chikhala','441907',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11002,32,'Chikhla Basti','441907',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11003,32,'Chinchal','441903',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11004,32,'Chincholi (Tumsar)','441912',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11005,32,'Chulhad','441915',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11006,32,'Dawadipar','441924',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11007,32,'Devada Bzk','441913',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11008,32,'Dhargaon','441804',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11009,32,'Dighori','441805',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11010,32,'Dongargaon','441909',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11011,32,'Dongri BK','441907',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11012,32,'Erli Khandar','441903',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11013,32,'Gadegaon','441804',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11014,32,'Garra Bageda','441912',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11015,32,'Gobarwahi','441907',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11016,32,'Gosi BK','441903',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11017,32,'Gunthara','441804',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11018,32,'Gurdha','441809',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11019,32,'Hardoli','441909',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11020,32,'Hardoli','441805',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11021,32,'Irli BK','441910',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11022,32,'Itan','441910',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11023,32,'Jamb','441914',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11024,32,'Kanalgaon','441909',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11025,32,'Kandri','441914',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11026,32,'Kanhalgaon','441910',1,0,'2022-03-03 12:24:09','2022-03-03 12:24:09'),(11027,32,'Kanheri','441809',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11028,32,'Kardha','441924',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11029,32,'Kardi','441912',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11030,32,'Kesalwada','441804',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11031,32,'Khandala','441802',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11032,32,'Khapa','441912',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11033,32,'Khapri','441910',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11034,32,'Kharashi','441805',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11035,32,'Kitadi','441903',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11036,32,'Kodurli','441910',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11037,32,'Koka','441905',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11038,32,'Kolari','441809',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11039,32,'Konda Kosra','441908',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11040,32,'Kothurna','441905',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11041,32,'Kudegaon','441803',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11042,32,'Kumbhali','441802',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11043,32,'Kurza','441903',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11044,32,'Lakhandur','441803',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11045,32,'Lakhni','441804',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11046,32,'Lakhori','441804',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11047,32,'Lawri Umri','441802',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11048,32,'Lendezari','441912',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11049,32,'Lobhi','441907',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11050,32,'Madgi','441913',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11051,32,'Malutola','441802',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11052,32,'Mandesar','441909',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11053,32,'Mandvi','441905',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11054,32,'Manegaon','441924',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11055,32,'Mangli','441910',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11056,32,'Masal','441908',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11057,32,'Matora','441924',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11058,32,'Minshi','441924',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11059,32,'Miregaon','441809',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11060,32,'Mitewani','441912',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11061,32,'Mohadi','441909',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11062,32,'Moharna','441803',1,0,'2022-03-03 12:24:10','2022-03-03 12:24:10'),(11063,32,'Mohdura','441906',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11064,32,'Mohgaon Devi','441905',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11065,32,'Mohgaon Khadan','441915',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11066,32,'Mundri BK','441905',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11067,32,'Murmadi','441809',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11068,32,'Nakadongri','441907',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11069,32,'Navegaon BK','441905',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11070,32,'Neri','441905',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11071,32,'Nerla','441903',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11072,32,'Opera','441803',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11073,32,'Pahela','441924',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11074,32,'Palandur(Chauras)','441809',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11075,32,'Palora','441905',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11076,32,'Palora','441908',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11077,32,'Pardi','441805',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11078,32,'Pauni','441910',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11079,32,'Pimpalgaon Kohli','441803',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11080,32,'Pimpalgaon Nipani','441903',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11081,32,'Pimpalgaon Sadak','441804',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11082,32,'Pindkepar','441802',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11083,32,'Pipri','441906',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11084,32,'Pohra','441809',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11085,32,'Rengepar','441804',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11086,32,'Sakoli','441802',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11087,32,'Salaikhurd','441914',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11088,32,'Salebhata','441804',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11089,32,'Sangadi','441802',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11090,32,'Sarandi','441908',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11091,32,'Sasra','441802',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11092,32,'Satalwada','441802',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11093,32,'Sawarla','441910',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11094,32,'Seloti','441809',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11095,32,'Sendurwafa','441802',1,0,'2022-03-03 12:24:11','2022-03-03 12:24:11'),(11096,32,'Shahpur','441906',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11097,32,'Shioni','441809',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11098,32,'Sihora (Bhandara)','441915',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11099,32,'Silli','441924',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11100,32,'Soni Chapral','441803',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11101,32,'Thana Petrol Pump','441906',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11102,32,'Tumsar Road','441913',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11103,32,'Tumsar','441912',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11104,32,'Umarwada','441912',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11105,32,'Virshi','441802',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11106,32,'Wadad','441802',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11107,32,'Wahani','441915',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11108,32,'Walni','441910',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11109,32,'Yekodi (Sakoli)','441802',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11110,32,'Yerli','441912',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11111,33,'Adgaon Raja','443203',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11112,33,'Adol BK','443403',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11113,33,'Adsul','444203',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11114,33,'Advihir','443103',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11115,33,'Alampur','443404',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11116,33,'Aland','443206',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11117,33,'Alsana','444203',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11118,33,'Ambashi','443201',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11119,33,'Ambetakli','444303',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11120,33,'Amboda','444312',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11121,33,'Amdapur','444301',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11122,33,'Ancharwadi','443201',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11123,33,'Andhera','443201',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11124,33,'Anjani','443301',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11125,33,'Anjani Khurd','443301',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11126,33,'Antraj','444303',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11127,33,'Antri Deshmukh','443301',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11128,33,'Antri Khedekar','443201',1,0,'2022-03-03 12:24:12','2022-03-03 12:24:12'),(11129,33,'Aregaon','443303',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11130,33,'Asalgaon','443402',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11131,33,'Atali','444303',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11132,33,'Awar','444303',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11133,33,'Awha Yunuspur','443101',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11134,33,'Banoda Eklara','444204',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11135,33,'Bawanbir','444204',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11136,33,'Belad','443102',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11137,33,'Belgaon','443303',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11138,33,'Bhadgani','443102',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11139,33,'Bhadgaon','443106',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11140,33,'Bhadola','443002',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11141,33,'Bhajisath Nandura','443404',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11142,33,'Bhalegaon','443101',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11143,33,'Bhalegaon Bazar','444306',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11144,33,'Bharosa','443201',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11145,33,'Bhenwad','443402',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11146,33,'Bhongaon','444203',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11147,33,'Bhosa','443301',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11148,33,'Bhota','443404',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11149,33,'Bhumrala','443202',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11150,33,'Bibi','443202',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11151,33,'Bodkha','444202',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11152,33,'Borakhedi','443103',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11153,33,'Borakhedi Bawra','443204',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11154,33,'Borgaon Kakde','443201',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11155,33,'Bori Adgaon','444303',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11156,33,'Borjawala','444306',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11157,33,'Botha Kazi','444303',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11158,33,'Bramhapuri','443301',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11159,33,'Buldana H.O','443001',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11160,33,'Chaigaon','443301',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11161,33,'Chaitanya Wadi','443002',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11162,33,'Chandol','443106',1,0,'2022-03-03 12:24:13','2022-03-03 12:24:13'),(11163,33,'Chandur Biswa','443401',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11164,33,'Changephal','443308',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11165,33,'Chaora','443402',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11166,33,'Chikhali','443112',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11167,33,'Chikhli (Buldhana)','443201',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11168,33,'Chincholi Bore','443301',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11169,33,'Chincholi Karfarma','444203',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11170,33,'Chinchpur','444301',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11171,33,'Chitoda','444303',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11172,33,'Cotton Market Chikhli','443201',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11173,33,'Dabhadi','443102',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11174,33,'Dadulgaon','443403',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11175,33,'Dahid','443002',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11176,33,'Dahigaon','443201',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11177,33,'Dahigaon M','443404',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11178,33,'Daregaon','443202',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11179,33,'Dasarkhed','443112',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11180,33,'Datala','443102',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11181,33,'Dawargaon','443203',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11182,33,'Deodhaba','443101',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11183,33,'Deulgaon Dhangar','443201',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11184,33,'Deulgaon Kol','443301',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11185,33,'Deulgaon Mahi','443206',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11186,33,'Deulgaon Mali','443301',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11187,33,'Deulgaon Raja','443204',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11188,33,'Deulgaon Sakharsha','443304',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11189,33,'Deulghat','443002',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11190,33,'Dhad','443106',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11191,33,'Dhalsawangi','443106',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11192,33,'Dhamangaon','443106',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11193,33,'Dhamangaon Badhe','443104',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11194,33,'Dhanora Mahasidha','443403',1,0,'2022-03-03 12:24:14','2022-03-03 12:24:14'),(11195,33,'Dhanora Vitali','443401',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11196,33,'Dharangaon (Buldhana)','443112',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11197,33,'Dhorapgaon','444306',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11198,33,'Dhotra Bhangoji','443002',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11199,33,'Dhotra Naik','444301',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11200,33,'Dighi','443401',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11201,33,'Digras BK','443206',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11202,33,'Dongaon','443303',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11203,33,'Dongar Khandala','443002',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11204,33,'Dongarshewali','443002',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11205,33,'Dudha','443106',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11206,33,'Dudhalgaon BK','443101',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11207,33,'Dusarbid','443308',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11208,33,'Eklara','443201',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11209,33,'G.S.College Khamgaon','444312',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11210,33,'Gadegaon Khurd','443403',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11211,33,'Gandhari','443302',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11212,33,'Ganeshpur','444303',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11213,33,'Gangalgaon','443201',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11214,33,'Garadgaon','444303',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11215,33,'Gawhan','444303',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11216,33,'Ghanegaon','444306',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11217,33,'Gharod','444303',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11218,33,'Ghatbori','443301',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11219,33,'Ghirni','443102',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11220,33,'Godri','443201',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11221,33,'Gohogaon','443303',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11222,33,'Gondhanapur','444303',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11223,33,'Gummi','443002',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11224,33,'Gunj','443202',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11225,33,'Harankhed','443101',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11226,33,'Harsoda','443112',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11227,33,'Hatedi','443106',1,0,'2022-03-03 12:24:15','2022-03-03 12:24:15'),(11228,33,'Hatni','443201',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11229,33,'Hingna Karegaon','444303',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11230,33,'Hirdao','443302',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11231,33,'Hiwara BK','443301',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11232,33,'Hiwara Khurd','443304',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11233,33,'Hiwarkhed','443203',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11234,33,'Hiwarkhed','444303',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11235,33,'Isoli','444301',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11236,33,'Isrul','443201',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11237,33,'Jaipur','443103',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11238,33,'Jalamb','444303',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11239,33,'Jalgaon','443402',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11240,33,'Jalka Bhadang','444306',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11241,33,'Jamb','443106',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11242,33,'Jambhora','443308',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11243,33,'Jambhul','443302',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11244,33,'Jambhuldhaba','443101',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11245,33,'Jamod','443402',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11246,33,'Janephal','443304',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11247,33,'Janori Nipana','444203',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11248,33,'Jastgaon','444201',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11249,33,'Jawala BK','444203',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11250,33,'Jigaon','443401',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11251,33,'Kalambeshwar','443304',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11252,33,'Kalegaon','444303',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11253,33,'Kalyana','443301',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11254,33,'Kankanwada','444202',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11255,33,'Karwand','444301',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11256,33,'Katel Kolad','444204',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11257,33,'Kavthal','444201',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11258,33,'Kawhala','443201',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11259,33,'Kelanagar','444303',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11260,33,'Kelwad','443002',1,0,'2022-03-03 12:24:16','2022-03-03 12:24:16'),(11261,33,'Kesapur','443002',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11262,33,'Khaira','443103',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11263,33,'Khalegaon','443301',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11264,33,'Khallad Gavhan','443204',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11265,33,'Khamgaon H.O','444303',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11266,33,'Khamkhed','443101',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11267,33,'Khandala Makardhwaj','443201',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11268,33,'Khandvi','443403',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11269,33,'Kharbadi','443103',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11270,33,'Kherda','443402',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11271,33,'Kherda','444203',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11272,33,'Khumgaon','443404',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11273,33,'Kingaon Jattu','443202',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11274,33,'Kingaon Raja','443203',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11275,33,'Kinhi Mahadeo','444303',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11276,33,'Kinhola','443002',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11277,33,'Kodri','444201',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11278,33,'Kolara','443201',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11279,33,'Kolwad','443002',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11280,33,'Korhala','443104',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11281,33,'Kothali','443103',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11282,33,'Ladnapur','444204',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11283,33,'Lakhanwada','444303',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11284,33,'Lanjud','444312',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11285,33,'Lasura Khurd','444303',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11286,33,'Lawhala','443301',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11287,33,'Liha BK','443101',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11288,33,'Lokhanda','444303',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11289,33,'Lonar','443302',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11290,33,'Loni Gaoli','443301',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11291,33,'Loni Gurao','444303',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11292,33,'M.I.D.C. (Khamgaon)','444312',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11293,33,'Madakhed','443402',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11294,33,'Madh','443002',1,0,'2022-03-03 12:24:17','2022-03-03 12:24:17'),(11295,33,'Makodi','443102',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11296,33,'Malegaon','443404',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11297,33,'Malkapur City','443101',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11298,33,'Malkapur Pangra','443202',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11299,33,'Malkapur (Buldhana)','443101',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11300,33,'Mamulwadi','443401',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11301,33,'Manasgaon','444203',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11302,33,'Mangrul Navghare','444301',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11303,33,'Masrul','443106',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11304,33,'Matergaon','444304',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11305,33,'Mehkar','443301',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11306,33,'Mehuna','443206',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11307,33,'Mendgaon','443201',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11308,33,'Mendhali','443102',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11309,33,'Mera BK','443201',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11310,33,'Mera Khurd','443201',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11311,33,'Mhaiswadi','443112',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11312,33,'Mhasla BK','443106',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11313,33,'Mola','443301',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11314,33,'Mominabad','443401',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11315,33,'Motala','443103',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11316,33,'Nagzari','444203',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11317,33,'Naigaon','443404',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11318,33,'Naigaon','443302',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11319,33,'Naigaon Duttapur','443301',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11320,33,'Nalgangapur','443101',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11321,33,'Nandra','443302',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11322,33,'Nandra Koli','443002',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11323,33,'Nandura','443404',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11324,33,'Nandura Town','443404',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11325,33,'Narkhed','443404',1,0,'2022-03-03 12:24:18','2022-03-03 12:24:18'),(11326,33,'Narvel','443112',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11327,33,'Nimgaon','443404',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11328,33,'Nimkhed','443103',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11329,33,'Nipana','444306',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11330,33,'Nipana','443101',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11331,33,'Niwana','443402',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11332,33,'Padali','443002',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11333,33,'Pahurjira','444312',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11334,33,'Palaskhed Daulat','443201',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11335,33,'Palshi BK','444303',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11336,33,'Palsi Supo','443403',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11337,33,'Palsi Zanshi','444202',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11338,33,'Pangarkhed','443303',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11339,33,'Pangra Dole','443302',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11340,33,'Pangri','443002',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11341,33,'Panhera','443104',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11342,33,'Panhera Wadoda','443101',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11343,33,'Parkhed','444306',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11344,33,'Paturda','444201',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11345,33,'Peth','443201',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11346,33,'Pimpalgaon BK','443206',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11347,33,'Pimpalgaon Devi','443101',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11348,33,'Pimpalgaon Kale','443403',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11349,33,'Pimpalgaon Nath','443103',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11350,33,'Pimpalgaon Raja','444306',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11351,33,'Pimpalgaon Sarai','443002',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11352,33,'Pimpalgaon Unda','443301',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11353,33,'Pimpri Deshmukh','444312',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11354,33,'Pimpri Gaoli','444303',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11355,33,'Pimpri Gawali','443102',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11356,33,'Pimpri Khandare','443301',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11357,33,'Pimpri Mali','443301',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11358,33,'Pophali','443102',1,0,'2022-03-03 12:24:19','2022-03-03 12:24:19'),(11359,33,'Poraj','444306',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11360,33,'Raheri BK','443308',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11361,33,'Raipur','443002',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11362,33,'Rajegaon','443301',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11363,33,'Rajur','443103',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11364,33,'Rohana','444303',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11365,33,'Rohinkhed','443103',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11366,33,'Rokdiya Nagar','444203',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11367,33,'Rudhana','443402',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11368,33,'Sagoda','444203',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11369,33,'Sagwan','443002',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11370,33,'Sakegaon','443201',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11371,33,'Sakhali','443002',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11372,33,'Sakhar Kherda','443202',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11373,33,'Sangrampur (Buldhana)','444202',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11374,33,'Sao','443002',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11375,33,'Saokhed Bhoi','443204',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11376,33,'Saokhed Tejan','443203',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11377,33,'Sarafa Khamgaon','444303',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11378,33,'Saramba','443206',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11379,33,'Sarola Maroti','443102',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11380,33,'Sarshiv','443304',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11381,33,'Satgaon Bhusari','443201',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11382,33,'Satgaon Mhasla','443106',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11383,33,'Savkhed Nagare','443201',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11384,33,'Sawadad','443202',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11385,33,'Sawana','443201',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11386,33,'Sawangi Tekale','443206',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11387,33,'Sawargaon','443402',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11388,33,'Sawargaon Dukare','443201',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11389,33,'Shahapur','444303',1,0,'2022-03-03 12:24:20','2022-03-03 12:24:20'),(11390,33,'Shara','443302',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11391,33,'Shegaon','444203',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11392,33,'Shelapur','443101',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11393,33,'Shelgaon Atol','443201',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11394,33,'Shelgaon Bazar','443102',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11395,33,'Shelgaon Deshmukh','443303',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11396,33,'Shelgaon Mukund','443404',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11397,33,'Shelsur','443002',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11398,33,'Shemba','443103',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11399,33,'Shendla','443301',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11400,33,'Shendurjan','443202',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11401,33,'Shioni Pisa','443301',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11402,33,'Shioni Taka','443203',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11403,33,'Shiradhon','443102',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11404,33,'Shirala Nemane','444303',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11405,33,'Shirpur','443002',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11406,33,'Sindi','443202',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11407,33,'Sindkhed Lapali','443101',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11408,33,'Sindkhed Raja','443203',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11409,33,'Singaon Jahagir','443204',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11410,33,'Somthana','443301',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11411,33,'Sonala','444204',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11412,33,'Sonati','443301',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11413,33,'Sonoshi','443308',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11414,33,'Sultanpur','443302',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11415,33,'Sundarkhed','443002',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11416,33,'Sungaon','443402',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11417,33,'Sutala BK','444312',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11418,33,'Tadshioni','443308',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11419,33,'Tadulwadi','443112',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11420,33,'Takarkhed','443103',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11421,33,'Takarkhed Helga','444301',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11422,33,'Takli Viro','444203',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11423,33,'Talkhed','443101',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11424,33,'Talni','443102',1,0,'2022-03-03 12:24:21','2022-03-03 12:24:21'),(11425,33,'Tambola','443302',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11426,33,'Tembhurna','444303',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11427,33,'Tivtivi','443302',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11428,33,'Toranwada','444301',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11429,33,'Tuljapur','443204',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11430,33,'Tunki','444204',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11431,33,'Ukali','443301',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11432,33,'Umali','443102',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11433,33,'Umbarkhed','443204',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11434,33,'Umrad','443203',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11435,33,'Undri','444303',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11436,33,'Uti','443304',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11437,33,'Veni','443302',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11438,33,'Vihigaon','444303',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11439,33,'Vishvi','443303',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11440,33,'Vivara','443112',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11441,33,'Wadaji','443101',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11442,33,'Wadgaon Mali','443202',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11443,33,'Wadgaon Tejan','443302',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11444,33,'Wadhao','443302',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11445,33,'Wadi','443404',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11446,33,'Wadner Bholaji','443101',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11447,33,'Wadshingi','443402',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11448,33,'Waghala','443202',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11449,33,'Wankhed','444201',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11450,33,'Wardadi BK','443308',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11451,33,'Warkhed','443102',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11452,33,'Warna','444303',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11453,33,'Warud','443106',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11454,33,'Warwand','443304',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11455,33,'Warwand','443002',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11456,33,'Warwat Bakal','444202',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11457,33,'Warwat Khanderao','444201',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11458,33,'Wasadi BK','443404',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11459,33,'Wazar','444303',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11460,33,'Yelgaon','443002',1,0,'2022-03-03 12:24:22','2022-03-03 12:24:22'),(11461,33,'Yerli','443404',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11462,33,'Zadegaon','444203',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11463,33,'Zodga','443112',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11464,33,'Zotinga','443202',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11465,34,'Adegaon','442904',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11466,34,'Adyal Tekadi','441206',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11467,34,'Aheri','442905',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11468,34,'Aksapur','442702',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11469,34,'Alwahi','441221',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11470,34,'Amadi Beguide','442906',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11471,34,'Ambenri','442903',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11472,34,'Amgaon Buti','441207',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11473,34,'Anandwan','442914',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11474,34,'Antargaon','441223',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11475,34,'Antargaon','441215',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11476,34,'Antargaon','442917',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11477,34,'Arher Nawargaon','441206',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11478,34,'Arjuni','442906',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11479,34,'Arvi','442905',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11480,34,'Ashta','442906',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11481,34,'Awalapur','442917',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11482,34,'Awalgaon','441206',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11483,34,'Awalpur Cement Project','442917',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11484,34,'Babupeth','442403',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11485,34,'Bakhardi','442908',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11486,34,'Balapur','441221',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11487,34,'Ballarpur Paper Mill','442901',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11488,34,'Ballarpur','442701',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11489,34,'Baradkinhi','441206',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11490,34,'Belgaon','442906',1,0,'2022-03-03 12:24:23','2022-03-03 12:24:23'),(11491,34,'Bembal','441226',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11492,34,'Bhadrawati','442902',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11493,34,'Bhari','442908',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11494,34,'Bhatala','442914',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11495,34,'Bhedoda','442905',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11496,34,'Bhejgaon','441226',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11497,34,'Bhendala','442906',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11498,34,'Bhisi','442903',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11499,34,'Bhoygaon','442908',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11500,34,'Bond','441221',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11501,34,'Borda','441224',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11502,34,'Borgaon','442702',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11503,34,'Bormala','441215',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11504,34,'Bothali','442906',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11505,34,'Bothali','441225',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11506,34,'Bramhapuri','441206',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11507,34,'Cementnagar','442502',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11508,34,'Chakdarur','442702',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11509,34,'Chandankheda','442906',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11510,34,'Chandanwahi','442905',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11511,34,'Chandrapur City','442402',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11512,34,'Chandrapur H.O','442401',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11513,34,'Chandrapur Ord Fact','442501',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11514,34,'Chandrapur TPS','442404',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11515,34,'Chandur (Chandrapur)','442908',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11516,34,'Chargaon BK','442906',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11517,34,'Chargaon KD','442906',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11518,34,'Charli','442905',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11519,34,'Charur Khati','442907',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11520,34,'Chaugaon','441206',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11521,34,'Chichpalli','441224',1,0,'2022-03-03 12:24:24','2022-03-03 12:24:24'),(11522,34,'Chikani','442907',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11523,34,'Chikhali','441212',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11524,34,'Chikhli','441207',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11525,34,'Chimda','441224',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11526,34,'Chimur','442903',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11527,34,'Chinchala','441224',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11528,34,'Chincholi','442905',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11529,34,'Chinora','442914',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11530,34,'Chintaldhaba','442702',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11531,34,'Chiroli','441224',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11532,34,'Chora','442906',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11533,34,'Chunala','442905',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11534,34,'Dabgaon Maktha','442918',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11535,34,'Dahegaon','442907',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11536,34,'Dewada','442905',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11537,34,'Dewada Khurd','442918',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11538,34,'Dhaba','442702',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11539,34,'Dhamangaon','442702',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11540,34,'Dhanoli','442916',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11541,34,'Dhanora Pipri','442505',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11542,34,'Dighori','441226',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11543,34,'Doma','442903',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11544,34,'Dongargaon','441212',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11545,34,'Dongargaon','442907',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11546,34,'Dongargaon BK','441205',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11547,34,'Dongargaon Khadi','442907',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11548,34,'Dudholi Bamini','442701',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11549,34,'Durgapur','442404',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11550,34,'Ekarjuna','442907',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11551,34,'Fiskuti','441225',1,0,'2022-03-03 12:24:25','2022-03-03 12:24:25'),(11552,34,'Futana','441226',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11553,34,'Gadbori','441223',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11554,34,'Gangalwadi','441206',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11555,34,'Gewara BK','441215',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11556,34,'Gewardha','441207',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11557,34,'Ghatkul','442702',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11558,34,'Ghodpeth','442902',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11559,34,'Ghugus','442505',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11560,34,'Ghugus Colliery','442505',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11561,34,'Girgaon','441223',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11562,34,'Gogaon','442605',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11563,34,'Gojoli Maktha','442702',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11564,34,'Gondpipri','442702',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11565,34,'Govindpur','441221',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11566,34,'Gowardhan','441226',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11567,34,'Gowari','442905',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11568,34,'Gramsevak Trg','441222',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11569,34,'Gulgaon','442906',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11570,34,'Gunjewahi','441215',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11571,34,'H.L.C.','442507',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11572,34,'Halda','441206',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11573,34,'Haramba','441225',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11574,34,'Hardoli','441206',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11575,34,'Hirapur','442903',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11576,34,'Jambhulghat','442903',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11577,34,'Jamgaon Komti','442903',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11578,34,'Jamni','442907',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11579,34,'Jamsala','441222',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11580,34,'Jamtukam','442918',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11581,34,'Janampalli','442504',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11582,34,'Jena','442902',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11583,34,'Jibgaon','441225',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11584,34,'Jiwati','442908',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11585,34,'Jugnala','441206',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11586,34,'Junona','442403',1,0,'2022-03-03 12:24:26','2022-03-03 12:24:26'),(11587,34,'Kacharala','442902',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11588,34,'Kadholi','442905',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11589,34,'Kadholi','442916',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11590,34,'Kahali','441206',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11591,34,'Kajalsar','442904',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11592,34,'Kalamgaon','441206',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11593,34,'Kalamgaon Ganna','441222',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11594,34,'Kanhalgaon','442916',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11595,34,'Kanhalgaon Sonule','441221',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11596,34,'Kanpa','441205',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11597,34,'Kapsi','441225',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11598,34,'Karanji','442702',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11599,34,'Kasargatta','442918',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11600,34,'Kawathi','441225',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11601,34,'Kelzar','442918',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11602,34,'Keroda','441225',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11603,34,'Kewada Mokasa','442904',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11604,34,'Khadsangi','442906',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11605,34,'Khambada','442904',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11606,34,'Khambada','442907',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11607,34,'Khatgaon','441222',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11608,34,'Khed','441206',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11609,34,'Khemjai','442914',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11610,34,'Khirdi','442908',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11611,34,'Khutala Mokasa','442904',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11612,34,'Kinhi','441206',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11613,34,'Kinhi','441222',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11614,34,'Kirmitimendha','441206',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11615,34,'Kitali Bormal','441221',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11616,34,'Kodsi','442916',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11617,34,'Kokdi','441207',1,0,'2022-03-03 12:24:27','2022-03-03 12:24:27'),(11618,34,'Kolara Tukum','442903',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11619,34,'Kolsa','441224',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11620,34,'Kondali','441207',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11621,34,'Kondha','442503',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11622,34,'Koregaon','441207',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11623,34,'Korpana','442916',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11624,34,'Kosarsar','442907',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11625,34,'Kotgaon','441205',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11626,34,'Kothada','442916',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11627,34,'Kothari','442701',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11628,34,'Kuchana','442503',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11629,34,'Kurud','441207',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11630,34,'Kurumwelli','442710',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11631,34,'Kurza','441206',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11632,34,'Ladbori','441222',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11633,34,'Lakhadkot','442905',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11634,34,'Lakhampur','442908',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11635,34,'Lathi','442702',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11636,34,'Likithwada','442702',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11637,34,'Londholi','441225',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11638,34,'Madhali','442907',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11639,34,'Madnapur','442903',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11640,34,'Mahalgaon Kalu','442903',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11641,34,'Malewada','442903',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11642,34,'Mandwa','442916',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11643,34,'Mangalgaon','442903',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11644,34,'Mangali Arab','441205',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11645,34,'Mangrul','441221',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11646,34,'Manora','442701',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11647,34,'Marda','442402',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11648,34,'Maroda','441224',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11649,34,'Masal','442903',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11650,34,'Matha','442916',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11651,34,'Maushi','441206',1,0,'2022-03-03 12:24:28','2022-03-03 12:24:28'),(11652,34,'Meha BK','441215',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11653,34,'Mel','442402',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11654,34,'Mendki','441206',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11655,34,'Metepar','442903',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11656,34,'Mhasali','442904',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11657,34,'MIDC (P)','442406',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11658,34,'Mindhala','441205',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11659,34,'Mohali Mokasa','441205',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11660,34,'Mohali Naleshwar','441222',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11661,34,'Mohorli','442404',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11662,34,'Mokhala','441225',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11663,34,'Motegaon','442904',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11664,34,'Mudholi','442906',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11665,34,'Mudza','441206',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11666,34,'Mul','441224',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11667,34,'Nachanbhatti','441223',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11668,34,'Nagbhid','441205',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11669,34,'Nagri','442907',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11670,34,'Nalfadi','442905',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11671,34,'Nanda','442917',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11672,34,'Nanded','441221',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11673,34,'Nandgaon','442908',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11674,34,'Nandgaon','441226',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11675,34,'Nandgaon','441223',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11676,34,'Nandgaon Podey','442507',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11677,34,'Nandori','442907',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11678,34,'Nandpa','442908',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11679,34,'Nanhori','441206',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11680,34,'Naranda','442916',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11681,34,'Navegaon Hundeshwari','441205',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11682,34,'Navegaon Lonkhairi','441212',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11683,34,'Navegaon Pandav','441205',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11684,34,'Navkhala','441205',1,0,'2022-03-03 12:24:29','2022-03-03 12:24:29'),(11685,34,'Navtala','442903',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11686,34,'Nawargaon','441223',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11687,34,'Nawegaon More','442702',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11688,34,'Neri','442904',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11689,34,'Nifandra','441215',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11690,34,'Nilaj','441206',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11691,34,'Nilsani Pedgaon','441225',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11692,34,'Nimgaon','441215',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11693,34,'Nokewada','442908',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11694,34,'Pachgaon','442905',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11695,34,'Padmapur Rayatwari','442404',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11696,34,'Padoli','442406',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11697,34,'Paharni','441205',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11698,34,'Palasgaon','442701',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11699,34,'Palasgaon Jat','441222',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11700,34,'Palasgaon Khurd','441221',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11701,34,'Palasgaon Piparda','442903',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11702,34,'Palebarsa','441215',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11703,34,'Pandharpauni','442905',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11704,34,'Panjurni','442907',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11705,34,'Paradgaon','441206',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11706,34,'Pardi','442916',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11707,34,'Pardi','441205',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11708,34,'Patala','442503',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11709,34,'Patan','442908',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11710,34,'Pathanpura','442402',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11711,34,'Pathari (Chandrapur)','441215',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11712,34,'Payali Bhatali','442404',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11713,34,'Pedgaon','441212',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11714,34,'Pendhari','442606',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11715,34,'Pendhari','442904',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11716,34,'Pendhari Maktha','441225',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11717,34,'Pimpalgaon','441206',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11718,34,'Pimpalneri','442903',1,0,'2022-03-03 12:24:30','2022-03-03 12:24:30'),(11719,34,'Pipri (Naranda)','442916',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11720,34,'Pirli','442902',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11721,34,'Pombhurna','442918',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11722,34,'Pudiyal Mohada','442908',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11723,34,'Rajgad','441225',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11724,34,'Rajoli (Chandrapur)','441212',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11725,34,'Rajura (M)','442905',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11726,34,'Ratnapur','441223',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11727,34,'Rupapet','442916',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11728,34,'Sagra','442906',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11729,34,'Sakhara Rajapur','442906',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11730,34,'Sakhari','442905',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11731,34,'Sakharwahi','442902',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11732,34,'Salori','442914',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11733,34,'Samda Buzruk','441225',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11734,34,'Saoli','441225',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11735,34,'Saori','442906',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11736,34,'Saradpar','441212',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11737,34,'Sasti','442905',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11738,34,'Sathgaon','442903',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11739,34,'Sawangi','441207',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11740,34,'Sawargaon','441221',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11741,34,'Sawargaon','442904',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11742,34,'Segaon KD','442906',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11743,34,'Segaon (Chandrapur)','442906',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11744,34,'Sembal','442907',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11745,34,'Serja','442916',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11746,34,'Shankarpur','442903',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11747,34,'Shashtrinagar','442401',1,0,'2022-03-03 12:24:31','2022-03-03 12:24:31'),(11748,34,'Shengaon','442908',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11749,34,'Shengaon','442505',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11750,34,'Sheoni','441223',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11751,34,'Shiora','442903',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11752,34,'Shivjinagar','442503',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11753,34,'Sindewahi','441222',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11754,34,'Sindhi','442905',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11755,34,'Sirpur','442904',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11756,34,'Soit','442907',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11757,34,'Somnath Prakala','441224',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11758,34,'Sonapur Deshpande','442702',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11759,34,'Sondo','442905',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11760,34,'Sonurli','442916',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11761,34,'Sonurli BK','441221',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11762,34,'Subai','442905',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11763,34,'Sumthana','442902',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11764,34,'Surla','441226',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11765,34,'Tadali','442406',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11766,34,'Talodhi Balapur','441221',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11767,34,'Talodhi Bhangaram','442702',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11768,34,'Talodhi Naik','442903',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11769,34,'Tambegadimendha','441215',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11770,34,'Tekamandava','442908',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11771,34,'Tembhurda','442907',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11772,34,'Tembhuwahi','442905',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11773,34,'Tohogaon','442701',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11774,34,'Umari Potdar','442701',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11775,34,'Uparwahi','442908',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11776,34,'Ushral Mendha','441221',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11777,34,'Vansadi','442916',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11778,34,'Vihirgaon','441207',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11779,34,'Vihirgaon','442905',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11780,34,'Vihirgaon','441215',1,0,'2022-03-03 12:24:32','2022-03-03 12:24:32'),(11781,34,'Vilam','441205',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11782,34,'Viloda','442906',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11783,34,'Vir R.S.','442905',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11784,34,'Virur Gadegaon','442917',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11785,34,'Visapur','442701',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11786,34,'Visora','441207',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11787,34,'Vithalwada','442702',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11788,34,'Vyahad BK','441225',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11789,34,'Vyhad Khurd','441225',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11790,34,'Wadadha','442906',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11791,34,'Wadegaon','441207',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11792,34,'Wadholi','442702',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11793,34,'Wadhona','441221',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11794,34,'Wadkuli','442702',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11795,34,'Wadsi','442904',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11796,34,'Waghnakh','442907',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11797,34,'Wahangaon','442906',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11798,34,'Waigaon','441206',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11799,34,'Waigaon Tukum','442906',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11800,34,'Waneri','441222',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11801,34,'Warora','442907',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11802,34,'Warud Road','442905',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11803,34,'Wasera','441223',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11804,34,'Yellapur','442908',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11805,34,'Yergavhan','442916',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11806,34,'Yergawhan (Dewada)','442905',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11807,35,'Agriculture College','424004',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11808,35,'Ahilyapur','425405',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11809,35,'Aichale','425408',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11810,35,'Ajande BK','425403',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11811,35,'Ajande KH','425404',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11812,35,'Ajang','424301',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11813,35,'Akhade','424305',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11814,35,'Ambe','425405',1,0,'2022-03-03 12:24:33','2022-03-03 12:24:33'),(11815,35,'Ambode','424318',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11816,35,'Amkhel','424305',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11817,35,'Amrale','425407',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11818,35,'Arthe','425427',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11819,35,'Arvi','424006',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11820,35,'Ashtane','424304',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11821,35,'Babhalaj','425421',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11822,35,'Babhulvadi','424002',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11823,35,'Balde','425405',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11824,35,'Balhane','424306',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11825,35,'Balkuwa','425427',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11826,35,'Balsane','424304',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11827,35,'Bamhane','425408',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11828,35,'Behed','424310',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11829,35,'Betawad','425403',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11830,35,'Bhadane','424303',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11831,35,'Bhadne','424304',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11832,35,'Bhadne','425406',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11833,35,'Bhamer','424305',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11834,35,'Bhamte','425427',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11835,35,'Bhatpure','425405',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11836,35,'Bhorkheda','425421',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11837,35,'Bodgaon','424304',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11838,35,'Boradi','425428',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11839,35,'Boris','424307',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11840,35,'Borkund','424308',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11841,35,'Borvihir','424311',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11842,35,'Brahamanvel','424305',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11843,35,'Burzad','424307',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11844,35,'Chadvel','424305',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11845,35,'Chaugaon','424302',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11846,35,'Chaupale','424304',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11847,35,'Chhail','424310',1,0,'2022-03-03 12:24:34','2022-03-03 12:24:34'),(11848,35,'Chikase','424306',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11849,35,'Chilane','425406',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11850,35,'Chimthana','425407',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11851,35,'Chinchkheda','424301',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11852,35,'Chinchkhede','424304',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11853,35,'Chinchwar','424002',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11854,35,'Chinoda','425413',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11855,35,'Dabhashi','425405',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11856,35,'Dahivad','425405',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11857,35,'Dahivel','424304',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11858,35,'Dangshirvade','424306',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11859,35,'Dangurne','425407',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11860,35,'Datarti','424304',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11861,35,'Daul','425408',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11862,35,'Dayane','424002',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11863,35,'Degaon','424306',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11864,35,'Deobhane','424307',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11865,35,'Deour-bk','424302',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11866,35,'Deshshirwade','424306',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11867,35,'Devjipada','424304',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11868,35,'Dhadne','424306',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11869,35,'Dhadre','424006',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11870,35,'Dhamane','425408',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11871,35,'Dhamangaon','424308',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11872,35,'Dhamnar','424304',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11873,35,'Dhandarne','425406',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11874,35,'Dhanur','424307',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11875,35,'Dhule Chaini Road','424001',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11876,35,'Dhule City','424001',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11877,35,'Dhule Collectorate','424001',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11878,35,'Dhule Deopur','424002',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11879,35,'Dhule H.O','424001',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11880,35,'Dhule Jaihind Colony','424002',1,0,'2022-03-03 12:24:35','2022-03-03 12:24:35'),(11881,35,'Dhule Market Yard','424004',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11882,35,'Dhule Midc','424006',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11883,35,'Dhule Pramod Nagar','424002',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11884,35,'Dhule Station Road','424001',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11885,35,'Dhule Vidya Nagari','424005',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11886,35,'Dighave','424310',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11887,35,'Divi','425407',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11888,35,'Dondaicha','425408',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11889,35,'Dondaicha-town','425408',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11890,35,'Dusane','424304',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11891,35,'Fagana','424301',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11892,35,'Ganeshpur','424310',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11893,35,'Gartad','425405',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11894,35,'Ghodade','424304',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11895,35,'Gidhade','425405',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11896,35,'Gondur','424002',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11897,35,'Gorane','424309',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11898,35,'Hatti-kh','425408',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11899,35,'Hendrun','424308',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11900,35,'Hisale','425421',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11901,35,'Hol','425406',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11902,35,'Holnantha','425405',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11903,35,'Indave','425408',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11904,35,'Jakhane','425407',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11905,35,'Jatode','425405',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11906,35,'Jebapur','424306',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11907,35,'Jogshelu','425406',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11908,35,'Junawane','424311',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11909,35,'Kadane','425406',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11910,35,'Kakani','424304',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11911,35,'Kalambhir','424304',1,0,'2022-03-03 12:24:36','2022-03-03 12:24:36'),(11912,35,'Kalkheda','424301',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11913,35,'Kamkheda','425404',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11914,35,'Kapadna','424307',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11915,35,'Karle','425408',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11916,35,'Karvand','425405',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11917,35,'Kasara (Dhule)','424310',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11918,35,'Katharde Digar','425422',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11919,35,'Kavthe','424304',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11920,35,'Khalane','425407',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11921,35,'Khambale','425405',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11922,35,'Khamkheda','425405',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11923,35,'Khandalai','424303',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11924,35,'Kharadbari','424304',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11925,35,'Kharde-BK','425408',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11926,35,'Kharde-KH','425408',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11927,35,'Kheda','424302',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11928,35,'Khori','424305',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11929,35,'Khudane','424305',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11930,35,'Kodade','425408',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11931,35,'Kodid','425428',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11932,35,'Kudashi','424306',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11933,35,'Kumar Nagar','424002',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11934,35,'Kurkwade','425408',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11935,35,'Kusumba','424302',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11936,35,'Lakdya-hanuman','425405',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11937,35,'Laling','424006',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11938,35,'Lamkani','424307',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11939,35,'Lauki','425405',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11940,35,'Lonkheda','424307',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11941,35,'Lonkhedi','424303',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11942,35,'Mahalpur','425406',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11943,35,'Maikatar','425428',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11944,35,'Malpur','425408',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11945,35,'Malpur','424310',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11946,35,'Mandi-shirpur','425405',1,0,'2022-03-03 12:24:37','2022-03-03 12:24:37'),(11947,35,'Manjrod','425421',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11948,35,'Mauje-chadvel','424304',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11949,35,'Mehergaon','424002',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11950,35,'Methi','425408',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11951,35,'Mhasale','424305',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11952,35,'Mhasdi','424304',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11953,35,'Modalpada','425413',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11954,35,'Moghan','424308',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11955,35,'Mohadi Laling','424311',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11956,35,'Mohadi-dangri','424318',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11957,35,'Morane-laling','424002',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11958,35,'Morane-pner','424302',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11959,35,'Mordad','424308',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11960,35,'Mudawad','425403',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11961,35,'Mukti','424301',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11962,35,'Nadse','424310',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11963,35,'Nagaon','424005',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11964,35,'Nakane','424002',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11965,35,'Nala','425413',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11966,35,'Nalgavhan','425413',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11967,35,'Nandale','424308',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11968,35,'Nandane','424307',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11969,35,'Nandre','424302',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11970,35,'Nardana','425404',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11971,35,'Narvhal','424311',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11972,35,'Naval Nagar','424318',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11973,35,'Navapada','424304',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11974,35,'Navara-navari','424318',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11975,35,'Ner','424303',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11976,35,'Nihali','425408',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11977,35,'Nihalod','424002',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11978,35,'Nimdale','424002',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11979,35,'Nimgul','424311',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11980,35,'Nimgul','425408',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11981,35,'Nizampur (Dhule)','424305',1,0,'2022-03-03 12:24:38','2022-03-03 12:24:38'),(11982,35,'Old Dhule','424002',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(11983,35,'Padalda','424002',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(11984,35,'Padhavad','425403',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(11985,35,'Palasner','425405',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(11986,35,'Pankheda','424306',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(11987,35,'Pashta','425404',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(11988,35,'Patan','425406',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(11989,35,'Perejpur','424304',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(11990,35,'Phohare','424002',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(11991,35,'Piloda','425405',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(11992,35,'Pimpalenr','424306',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(11993,35,'Pimpalgaon','424306',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(11994,35,'Pimparkheda','424309',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(11995,35,'Pinjarzadi','424304',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(11996,35,'Pratappur','424310',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(11997,35,'Purmepada','424006',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(11998,35,'Rainpada','424304',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(11999,35,'Rajale','425408',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(12000,35,'Rami','424307',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(12001,35,'Rami','425408',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(12002,35,'Ramwadi','424002',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(12003,35,'Ranjane','425406',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(12004,35,'Rohane','425407',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(12005,35,'Rohini','425405',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(12006,35,'Rohod','424304',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(12007,35,'Runmaili','424305',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(12008,35,'S.P. Bhadne','424304',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(12009,35,'Sadgaon','424006',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(12010,35,'Sakri (Dhule)','424304',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(12011,35,'Salve','425407',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(12012,35,'Samode','424306',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(12013,35,'Sangvi','425405',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(12014,35,'Satarne','424318',1,0,'2022-03-03 12:24:39','2022-03-03 12:24:39'),(12015,35,'Savaimukti','425407',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12016,35,'Savalde','425405',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12017,35,'Shanimandal','425408',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12018,35,'Shendwad','424306',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12019,35,'Shenpur','424306',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12020,35,'Shevade','425407',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12021,35,'Shevge','424306',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12022,35,'Shewali','424304',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12023,35,'Shindkheda','425406',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12024,35,'Shirdane','424318',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12025,35,'Shirdhane','424303',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12026,35,'Shirpur','425405',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12027,35,'Shirsole','424304',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12028,35,'Shirud','424308',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12029,35,'Shivre','425413',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12030,35,'Sonewadi','425406',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12031,35,'Songir','424309',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12032,35,'Sukapur','424306',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12033,35,'Sukwad','425405',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12034,35,'Sule','425405',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12035,35,'Suray','425408',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12036,35,'Talvade','424311',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12037,35,'Tamasvadi','424304',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12038,35,'Tamthare','425407',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12039,35,'Tarhadi T.T.','425427',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12040,35,'Tarhadkasbe','425427',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12041,35,'Tavkheda','425408',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12042,35,'Tekvade','425427',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12043,35,'Tembhe','425428',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12044,35,'Tembhe','424306',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12045,35,'Thalner','425421',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12046,35,'Tikhi','424311',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12047,35,'Titane','424305',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12048,35,'Tonde','425421',1,0,'2022-03-03 12:24:40','2022-03-03 12:24:40'),(12049,35,'Udane','424302',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12050,35,'Umarde','425428',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12051,35,'Umarpatta','424306',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12052,35,'Umbharti','424306',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12053,35,'Umtavad','425405',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12054,35,'Uppr Shirpur','425405',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12055,35,'Vadjai','424002',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12056,35,'Vaijali','425422',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12057,35,'Vaindane','425408',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12058,35,'Valvadi','424002',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12059,35,'Vani','424318',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12060,35,'Vardhane','424304',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12061,35,'Varkheda','424301',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12062,35,'Varpada','425406',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12063,35,'Varshi','425404',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12064,35,'Varud','425404',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12065,35,'Varul','425406',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12066,35,'Varul','425427',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12067,35,'Varzadi','425405',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12068,35,'Vaskhedi','424305',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12069,35,'Vasmar','424304',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12070,35,'Vehergaon','424305',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12071,35,'Velhane','424311',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12072,35,'Vikharan (Shirpur)','425427',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12073,35,'Vikhran','425408',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12074,35,'Vinchur','424311',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12075,35,'Virdel','425406',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12076,35,'Vishvanath','424318',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12077,35,'Vitai','424310',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12078,35,'Wadi','425405',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12079,35,'Waghadi','425405',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12080,35,'Waghadi-bk','424309',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12081,35,'Wakvad','425428',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12082,35,'Walkheda','424309',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12083,35,'War','424002',1,0,'2022-03-03 12:24:41','2022-03-03 12:24:41'),(12084,35,'Warsa','424306',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12085,35,'Wasardi','425405',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12086,35,'Wathode','425421',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12087,35,'Waypur','424309',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12088,35,'Zende-anjan','425428',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12089,36,'Adapalli','442707',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12090,36,'Aheri','442705',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12091,36,'Allapalli','442703',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12092,36,'Ambeshioni','442605',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12093,36,'Amboli','442903',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12094,36,'Amgaon (Mal)','442603',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12095,36,'Amirza','442605',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12096,36,'Andhali','441207',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12097,36,'Angara','441217',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12098,36,'Ankhoda','442707',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12099,36,'Ankisa','442504',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12100,36,'Arda','442504',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12101,36,'Armori','441208',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12102,36,'Armurkasa','441209',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12103,36,'Arsoda','441208',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12104,36,'Asaralli','442504',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12105,36,'Ashti (Gadchiroli)','442707',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12106,36,'Bamni','442504',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12107,36,'Bamni','442605',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12108,36,'Bedgaon','441209',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12109,36,'Bethakathi','441209',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12110,36,'Bhadbhidi','442604',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12111,36,'Bhakrondi','441217',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12112,36,'Bhamragadh','442710',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12113,36,'Bhendala','442603',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12114,36,'Bodhali','442605',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12115,36,'Bori','442705',1,0,'2022-03-03 12:24:42','2022-03-03 12:24:42'),(12116,36,'Botekasa','441209',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12117,36,'Burgi','442704',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12118,36,'Chakpetala','442604',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12119,36,'Challewada','442709',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12120,36,'Chamorshi','442603',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12121,36,'Chandagad','441209',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12122,36,'Chandankhedi','442707',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12123,36,'Chapalwada','442604',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12124,36,'Charbhatti','441209',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12125,36,'Chatgaon','442606',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12126,36,'Chaudampalli','442707',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12127,36,'Chavela','442606',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12128,36,'Chittaranjan','442707',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12129,36,'Churchura','442605',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12130,36,'Churmura','441208',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12131,36,'Dampur','442705',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12132,36,'Dechalipeta','442709',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12133,36,'Delanwadi','441217',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12134,36,'Deloda','442605',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12135,36,'Desaiganj','441207',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12136,36,'Deulgaon','441208',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12137,36,'Devalmari','442705',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12138,36,'Dhamrancha','442709',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12139,36,'Dhanora','442606',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12140,36,'Dudhmala','442606',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12141,36,'Elgur','442703',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12142,36,'Ettapalli','442704',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12143,36,'Gadchiroli Coll','442605',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12144,36,'Gadchiroli','442605',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12145,36,'Ganpur Rayatwari','442707',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12146,36,'Gatta','442606',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12147,36,'Gatta','442704',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12148,36,'Geda','442704',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12149,36,'Ghati','441217',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12150,36,'Ghot','442604',1,0,'2022-03-03 12:24:43','2022-03-03 12:24:43'),(12151,36,'Ghotsur','442704',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12152,36,'Gilgaon(zamindari)','442603',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12153,36,'Gothangaon','441209',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12154,36,'Govindpur','442703',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12155,36,'Gudigudam','442709',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12156,36,'Gundapalli','442707',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12157,36,'Guruwala','442605',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12158,36,'Heti','442606',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12159,36,'Indaram','442705',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12160,36,'Jairampur','442707',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12161,36,'Jambhali','442605',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12162,36,'Jarawandi','442606',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12163,36,'Jepra','442605',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12164,36,'Jimalgatta','442709',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12165,36,'Jinganur','442504',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12166,36,'Jivangatta','442704',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12167,36,'Jogisakhara','441208',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12168,36,'Kadholi','441217',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12169,36,'Kalinagar','442707',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12170,36,'Kamlapur (Gadchiroli)','442709',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12171,36,'Kandoli','442710',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12172,36,'Kaneri','442605',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12173,36,'Karwafa','442606',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12174,36,'Kasansur','442704',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12175,36,'Khamancheru','442705',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12176,36,'Khudirampalli','442707',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12177,36,'Konsari','442707',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12178,36,'Koparalli','442707',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12179,36,'Korchi','441209',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12180,36,'Korla Mal','442504',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12181,36,'Kotgul','441209',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12182,36,'Kotra','441209',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12183,36,'Kunghada','442603',1,0,'2022-03-03 12:24:44','2022-03-03 12:24:44'),(12184,36,'Kurkheda','441209',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12185,36,'Kurud','442603',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12186,36,'Kurundi','441217',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12187,36,'Lagam','442705',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12188,36,'Lakhamapur','442603',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12189,36,'Mahagaon BK','442705',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12190,36,'Makepalli','442604',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12191,36,'Malewada','441209',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12192,36,'Manapur','441217',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12193,36,'Manne Rajaram','442710',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12194,36,'Markanda Deo','442603',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12195,36,'Markhanda (K)','442707',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12196,36,'Marpalli','442709',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12197,36,'Masali','441209',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12198,36,'Maushi Khamb','442605',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12199,36,'Medpalli','442703',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12200,36,'Mendhatola','442606',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12201,36,'Mohali','442606',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12202,36,'Moyabinpetta','442504',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12203,36,'Mudholi Chak No. Ii','442707',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12204,36,'Mudza','442605',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12205,36,'Mulchera','442707',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12206,36,'Muramgaon','442606',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12207,36,'Murkhada','442603',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12208,36,'Murkhada Chak','442603',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12209,36,'Murmadi','442605',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12210,36,'Murmuri','442603',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12211,36,'Nagram','442504',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12212,36,'Nagrinavegaon','442605',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12213,36,'Nanhi','441209',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12214,36,'Narayanpur','442504',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12215,36,'Navegaon','442605',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12216,36,'Navegaon Rayatwari','442603',1,0,'2022-03-03 12:24:45','2022-03-03 12:24:45'),(12217,36,'Palasgad','441209',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12218,36,'Pardikupi','442605',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12219,36,'Pavimuranda','442603',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12220,36,'Permelli','442710',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12221,36,'Porla','442605',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12222,36,'Potegaon','442603',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12223,36,'Purada','441209',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12224,36,'Rajaram','442709',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12225,36,'Ramgarh','441209',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12226,36,'Rangaapalli','442504',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12227,36,'Rangi','442606',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12228,36,'Regadi','442604',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12229,36,'Regunta','442504',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12230,36,'Sakhara','442605',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12231,36,'Sawalkheda','441217',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12232,36,'Sawargaon','442606',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12233,36,'Shioni BK','441208',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12234,36,'Sironcha Mal','442504',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12235,36,'Sironcha','442504',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12236,36,'Sirshi','441217',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12237,36,'Sonapur','442603',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12238,36,'Sonsari','441209',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12239,36,'Sukala','441217',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12240,36,'Sursundi','441209',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12241,36,'Tadgaon','442710',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12242,36,'Talegaon','441209',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12243,36,'Talodhi Mokasa','442603',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12244,36,'Tekada','442504',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12245,36,'Thakri','442707',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12246,36,'Thanegaon','441208',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12247,36,'Todsa','442704',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12248,36,'Udera','442704',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12249,36,'Vairagadh','441217',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12250,36,'Venkatraopetta','442705',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12251,36,'Vikaspalli','442604',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12252,36,'Vishnupur','442603',1,0,'2022-03-03 12:24:46','2022-03-03 12:24:46'),(12253,36,'Wadadha','442605',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12254,36,'Wagholi','442603',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12255,36,'Walsara','442603',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12256,36,'Wasa','442605',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12257,36,'Wasala','441208',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12258,36,'Yenapur','442707',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12259,36,'Yengalkheda','441209',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12260,36,'Yeoli','442605',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12261,36,'Yerkad','442606',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12262,37,'Adasi','441614',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12263,37,'Alewada','441901',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12264,37,'Amgaon','441902',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12265,37,'Anjora','441902',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12266,37,'Arjuni (Tirora)','441911',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12267,37,'Arjuni Morgaon','441701',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12268,37,'Asoli','441601',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12269,37,'Bakti','441701',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12270,37,'Bamni','441807',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12271,37,'Banathar','441601',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12272,37,'Barabhati','441702',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12273,37,'Batana','441601',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12274,37,'Berdipar','441614',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12275,37,'Bhasgaon','441801',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12276,37,'Bhivkhidki','441702',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12277,37,'Bijepar','441902',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12278,37,'Boda','441614',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12279,37,'Bondegaon (Surban)','441702',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12280,37,'Bondgaon Devi','441701',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12281,37,'Bopabodi','441806',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12282,37,'Borgaon','441901',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12283,37,'Borkanhar','441902',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12284,37,'Channa','441702',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12285,37,'Chichgarh','441901',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12286,37,'Chikhali','441806',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12287,37,'Chikhali','441911',1,0,'2022-03-03 12:24:47','2022-03-03 12:24:47'),(12288,37,'Chipiya','441601',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12289,37,'Chirchal Bandh','441614',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12290,37,'Chopa','441807',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12291,37,'Chutiya','441601',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12292,37,'Dandegaon','441614',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12293,37,'Darekasa','441916',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12294,37,'Dasgaon Khurd','441614',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12295,37,'Datora','441614',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12296,37,'Dawaniwada','441614',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12297,37,'Dawki','441901',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12298,37,'Dawwa','441807',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12299,37,'Deori (Gondia)','441901',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12300,37,'Dhabetekdi','441702',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12301,37,'Dhakni','441614',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12302,37,'Dhanoli','441916',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12303,37,'Dhapewada','441911',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12304,37,'Dongargaon','441614',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12305,37,'Dongargaon Sadak','441807',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12306,37,'Etikheda','441701',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12307,37,'Futana','441901',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12308,37,'Gangazari','441614',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12309,37,'Gangla','441911',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12310,37,'Gankhaira','441801',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12311,37,'Garra','441601',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12312,37,'Ghonadi','441702',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12313,37,'Ghoti','441801',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12314,37,'Gidhadi','441801',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12315,37,'Girola','441601',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12316,37,'Gond Mohadi','441911',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12317,37,'Gondia Bazar','441601',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12318,37,'Gondia City','441614',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12319,37,'Gondia H.O','441601',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12320,37,'Gondia Khurd','441601',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12321,37,'Gondumri','441806',1,0,'2022-03-03 12:24:48','2022-03-03 12:24:48'),(12322,37,'Goregaon (Gondia)','441801',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12323,37,'Gothangaon','441702',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12324,37,'Gumdhawada','441911',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12325,37,'Hirapur','441801',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12326,37,'Hirdamali','441801',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12327,37,'Indora Khurd','441911',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12328,37,'Kachewani','441614',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12329,37,'Kadikasa','441901',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12330,37,'Kalimati','441902',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12331,37,'Kalimati','441801',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12332,37,'Kamtha','441601',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12333,37,'Karanja','441601',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12334,37,'Karti BK','441911',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12335,37,'Katangi BK','441801',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12336,37,'Kati (Birsola)','441614',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12337,37,'Kattipar','441902',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12338,37,'Kawalewada','441911',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12339,37,'Kawarabandh','441916',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12340,37,'Kawlewada','441601',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12341,37,'Kesalwada','441911',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12342,37,'Kesori','441702',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12343,37,'Khajari Dongargaon','441807',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12344,37,'Khamari','441601',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12345,37,'Khatiya','441601',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12346,37,'Khodseoni','441801',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12347,37,'Kodelohara','441911',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12348,37,'Kokna','441806',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12349,37,'Kokodi','441901',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12350,37,'Korambitola','441701',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12351,37,'Kosamthondi','441801',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12352,37,'Kotra','441902',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12353,37,'Kudwa','441614',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12354,37,'Kurhadi','441801',1,0,'2022-03-03 12:24:49','2022-03-03 12:24:49'),(12355,37,'Lakhegaon','441911',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12356,37,'Latori','441916',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12357,37,'Lohara','441902',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12358,37,'Lohara','441916',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12359,37,'Makkatola','441902',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12360,37,'Mohadi','441807',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12361,37,'Mohgaon BK','441614',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12362,37,'Mohgaon R.S.','441701',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12363,37,'Mundikota','441911',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12364,37,'Mundipar (Ishwar)','441801',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12365,37,'Mundipar','441807',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12366,37,'Murdada','441911',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12367,37,'Murdoli','441901',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12368,37,'Nagpura','441614',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12369,37,'Nagra','441601',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12370,37,'Nagrakatangi','441601',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12371,37,'Navegaon Bandh','441702',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12372,37,'Navegaon Kalan','441601',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12373,37,'Navezari','441911',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12374,37,'Nilaj','441901',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12375,37,'Palandur Zamindari','441702',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12376,37,'Palasgaon','441806',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12377,37,'Palasgaon','441702',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12378,37,'Pandharbodi','441614',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12379,37,'Pandhari','441801',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12380,37,'Pandharwani','441902',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12381,37,'Parastola','441702',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12382,37,'Paraswada','441911',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12383,37,'Paraswada','441601',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12384,37,'Parsodi','441806',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12385,37,'Parsodi Rayatwadi','441702',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12386,37,'Pathri (Gondia)','441801',1,0,'2022-03-03 12:24:50','2022-03-03 12:24:50'),(12387,37,'Pauldauna','441916',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12388,37,'Phukimeta','441902',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12389,37,'Phulchur','441601',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12390,37,'Pimpalgaon Khambi','441702',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12391,37,'Pipariya','441916',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12392,37,'Pratapgarh','441702',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12393,37,'Purada','441902',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12394,37,'Rajegaon','441601',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12395,37,'Rajori (Bharnoli)','441702',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12396,37,'Ratnara','441614',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12397,37,'Rawanwadi','441601',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12398,37,'Sadak Arjuni','441807',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12399,37,'Salekasa','441916',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12400,37,'Saoli Dongargaon','441902',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12401,37,'Sarandi','441911',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12402,37,'Sarkartola','441902',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12403,37,'Satgaon','441902',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12404,37,'Satona','441601',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12405,37,'Sawri','441601',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12406,37,'Shejgaon','441614',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12407,37,'Shenda','441807',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12408,37,'Shirpurbagh Colony','441901',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12409,37,'Sitepar','441614',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12410,37,'Soni','441801',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12411,37,'Sonpuri','441916',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12412,37,'Soundad','441806',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12413,37,'Sukhali Dakaram','441911',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12414,37,'Suplipar','441902',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12415,37,'Tanda','441614',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12416,37,'Tedha','441807',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12417,37,'Thana','441902',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12418,37,'Thanegaon','441911',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12419,37,'Tigaon','441902',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12420,37,'Tilli Mohgaon','441807',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12421,37,'Timezari','441801',1,0,'2022-03-03 12:24:51','2022-03-03 12:24:51'),(12422,37,'Tirkhedi','441916',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12423,37,'Tirora','441911',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12424,37,'Tukum Narayan','441702',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12425,37,'Tumkheda Khurd','441601',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12426,37,'Wadegaon','441911',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12427,37,'Wadegaon R.S.','441701',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12428,37,'Yekodi (Gondia)','441614',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12429,37,'Zarpada','441701',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12430,38,'Adgaon','431513',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12431,38,'Adgaon','431705',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12432,38,'Adol','431513',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12433,38,'Ajegaon','431703',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12434,38,'Akhada Balapur','431701',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12435,38,'Amba','431501',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12436,38,'Aral','431512',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12437,38,'Aundha Nagnath','431705',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12438,38,'Babhali','431702',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12439,38,'Babhulgaon','431703',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12440,38,'Basamba','431513',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12441,38,'Basmathnagar','431512',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12442,38,'Basmathnagar Town','431512',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12443,38,'Bhandegaon','431513',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12444,38,'Bhankheda','431542',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12445,38,'Bhatsawangi','431513',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12446,38,'Bolda','431701',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12447,38,'Borisawant','431705',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12448,38,'Bour','431701',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12449,38,'Chincholi','431513',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12450,38,'Chondi','431512',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12451,38,'Darefal','431512',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12452,38,'Datala','431542',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12453,38,'Daudgaon','431509',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12454,38,'Dhawanda Kasba','431701',1,0,'2022-03-03 12:24:52','2022-03-03 12:24:52'),(12455,38,'Digras','431705',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12456,38,'Dongargaon Pool','431701',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12457,38,'Dongarkada','431701',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12458,38,'Ganjapur','431513',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12459,38,'Gaul','431702',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12460,38,'Ghoda','431702',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12461,38,'Girgaon','431512',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12462,38,'Gojegaon','431509',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12463,38,'Golegaon Camp','431705',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12464,38,'Goregaon (Hingoli)','431703',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12465,38,'Gunda','431705',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12466,38,'Hatala','431703',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12467,38,'Hatta','431542',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12468,38,'Hatta','431705',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12469,38,'Hayatnagar','431512',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12470,38,'Hingani','431702',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12471,38,'Hingoli','431513',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12472,38,'Jaipur','431542',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12473,38,'Jawala Bazar','431705',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12474,38,'Jawala BK','431703',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12475,38,'Jawala Panchal','431701',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12476,38,'Kadoli','431703',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12477,38,'Kalamnuri','431702',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12478,38,'Kandali','431701',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12479,38,'Kanergaon','431513',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12480,38,'Karanjala','431705',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12481,38,'Kautha','431512',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12482,38,'Kautha','431542',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12483,38,'Kendra BK','431703',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12484,38,'Khanapur Chitta','431702',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12485,38,'Khandala','431513',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12486,38,'Khandegaon','431512',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12487,38,'Kharwad','431702',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12488,38,'Khudaj','431513',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12489,38,'Kille Wadgaon','431701',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12490,38,'Kondhur','431701',1,0,'2022-03-03 12:24:53','2022-03-03 12:24:53'),(12491,38,'Kurtadi','431701',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12492,38,'Kurunda','431512',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12493,38,'Lakh','431702',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12494,38,'Lohara BK','431705',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12495,38,'Lohgaon','431705',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12496,38,'Malhiwara','431513',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12497,38,'Mangalwara Hingoli','431513',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12498,38,'Masod','431702',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12499,38,'Mazod','431703',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12500,38,'Mssk Dongarkada','431701',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12501,38,'Murtijapur Sawangi','431705',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12502,38,'Nahad','431705',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12503,38,'Nandapur','431702',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12504,38,'Narsi Namdev','431513',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12505,38,'Paheni','431513',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12506,38,'Palsi','431703',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12507,38,'Pangra Shinde','431701',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12508,38,'Pankanhergaon','431542',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12509,38,'Pardi BK','431512',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12510,38,'Pedgaon','431513',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12511,38,'Phalegaon','431513',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12512,38,'Pimpaldari','431702',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12513,38,'Potra','431701',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12514,38,'Purjal','431705',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12515,38,'Pusegaon','431513',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12516,38,'Rameshwar Tanda','431701',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12517,38,'Sakhra','431542',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12518,38,'Salna','431509',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12519,38,'Salva','431701',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12520,38,'Sandas','431702',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12521,38,'Sapatgaon','431542',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12522,38,'Sawad','431513',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12523,38,'Sawana','431703',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12524,38,'Sawangi BK','431705',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12525,38,'Sawargaon','431513',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12526,38,'Sendursena','431705',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12527,38,'Sengaon','431542',1,0,'2022-03-03 12:24:54','2022-03-03 12:24:54'),(12528,38,'Shegaon','431542',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12529,38,'Shewala','431701',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12530,38,'Shirad Shahapur','431705',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12531,38,'Siddheshwar','431705',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12532,38,'Siddheshwar Camp','431705',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12533,38,'Sindagi','431701',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12534,38,'Sindagikhamba','431542',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12535,38,'Sirli','431701',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12536,38,'Sirsam BK','431513',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12537,38,'Sukli Veer','431701',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12538,38,'Undegaon','431509',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12539,38,'Wakodi','431702',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12540,38,'Wapti','431701',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12541,38,'Waranga','431701',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12542,38,'Warud Chakrapani','431542',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12543,38,'Yedsi','431701',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12544,38,'Yehlegaon Solanke','431705',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12545,38,'Yelegaon (T)','431702',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12546,38,'Yelegaon Gawali','431701',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12547,38,'Yelki','431701',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12548,39,'Abhoda','425508',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12549,39,'Achegaon','425305',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12550,39,'Adavad','425303',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12551,39,'Adgaon','425107',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12552,39,'Adgaon','425302',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12553,39,'Ahirwadi','425508',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12554,39,'Ainpur','425507',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12555,39,'Ajnad','425508',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12556,39,'Akulkheda','425108',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12557,39,'Amoda','425524',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12558,39,'Anjale','425304',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12559,39,'Anturli','425306',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12560,39,'Anwarde K H','425108',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12561,39,'Atraval','425301',1,0,'2022-03-03 12:24:55','2022-03-03 12:24:55'),(12562,39,'Balwadi','425507',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12563,39,'Bamnod','425503',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12564,39,'Betawad','425310',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12565,39,'Bhalod (Jalgaon)','425304',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12566,39,'Bhokari','425107',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12567,39,'Bhusawal Athawade Bazar','425201',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12568,39,'Bhusawal H.O','425201',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12569,39,'Bhusawal Kutchery','425201',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12570,39,'Bhusawal Ordnance Factory','425203',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12571,39,'Bhusawal Shivaji Nagar','425201',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12572,39,'Bidgaon','425303',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12573,39,'Bodwad','425310',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12574,39,'Borkheda','425304',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12575,39,'Chahardi','425107',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12576,39,'Changdeo','425306',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12577,39,'Charthana','425327',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12578,39,'Chikali','425304',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12579,39,'Chinawal','425505',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12580,39,'Chincholi','425302',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12581,39,'Chincholi Pimpri','424208',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12582,39,'Chinkhol','425306',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12583,39,'Chopda','425107',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12584,39,'Chorwad','425311',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12585,39,'Chunchale','425107',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12586,39,'Chunchale','425302',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12587,39,'Dahigaon','425301',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12588,39,'Dambhurni','425302',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12589,39,'Dasnoor','425506',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12590,39,'Deepnagar','425307',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12591,39,'Deulgaon','424208',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12592,39,'Devgaon','425303',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12593,39,'Devpimpri','425114',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12594,39,'Dhamodi','425507',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12595,39,'Dhanora','425303',1,0,'2022-03-03 12:24:56','2022-03-03 12:24:56'),(12596,39,'Dondwade','424204',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12597,39,'Dongaon','425302',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12598,39,'Duskheda','425203',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12599,39,'Engaon','425310',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12600,39,'Faizpur','425503',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12601,39,'Fattepur','424208',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12602,39,'Fekari','425307',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12603,39,'Fulgaon','425305',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12604,39,'Ganpur','425108',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12605,39,'Garkheda','424206',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12606,39,'Gate','425501',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12607,39,'Ghadvel','425107',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12608,39,'Ghankheda','425310',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12609,39,'Ghodasgaon','425306',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12610,39,'Ghodgaon','425108',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12611,39,'Godri','424208',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12612,39,'Gojore','425311',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12613,39,'Gondedaon','424204',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12614,39,'Gondkhed','424206',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12615,39,'Gorgavale','425107',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12616,39,'Hambardi','425503',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12617,39,'Harankheda','425310',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12618,39,'Hartala','425306',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12619,39,'Hated','425107',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12620,39,'Hingona','425503',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12621,39,'Hiwarkheda','425114',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12622,39,'Jalgaon K H','425309',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12623,39,'Jamner','424206',1,0,'2022-03-03 12:24:57','2022-03-03 12:24:57'),(12624,39,'Jamthi','425310',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12625,39,'Kahurkheda','425308',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12626,39,'Kalamsare','424204',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12627,39,'Kandari','425203',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12628,39,'Kanhale','425307',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12629,39,'Kapuswadi','425310',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12630,39,'Karkee','425306',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12631,39,'Kasali','424206',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12632,39,'Kasba Pimpri','424208',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12633,39,'Kathora','425301',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12634,39,'Kazipura','425108',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12635,39,'Kekat Nimbhora','425114',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12636,39,'Khachane','425107',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12637,39,'Khadgaon','424206',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12638,39,'Khadke','425307',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12639,39,'Khadki','424206',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12640,39,'Khanapur','425508',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12641,39,'Kherala','425508',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12642,39,'Khirdi','425507',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12643,39,'Khiroda','425504',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12644,39,'Khirwad','425508',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12645,39,'Kingaon','425302',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12646,39,'Kinhi','425311',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12647,39,'Kochur','425502',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12648,39,'Kolambe','425107',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12649,39,'Kolhadi','425310',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12650,39,'Korpavalli','425301',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12651,39,'Kothali','425306',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12652,39,'Kumbharkheda','425505',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12653,39,'Kurha Hardo','425310',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12654,39,'Kurha','425311',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12655,39,'Kurha-kakoda','425327',1,0,'2022-03-03 12:24:58','2022-03-03 12:24:58'),(12656,39,'Kurvel','425107',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12657,39,'Kusumbe B K','425504',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12658,39,'Lahasar','424206',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12659,39,'Lasur','425107',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12660,39,'Lihedigar','424204',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12661,39,'Lohare','425504',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12662,39,'Londhari','424206',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12663,39,'Loni','424207',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12664,39,'M.S.S.K.Faizpur','425524',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12665,39,'Maldabhadi','424206',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12666,39,'Malkheda','424204',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12667,39,'Mamalde','425107',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12668,39,'Mandeve K H','424207',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12669,39,'Mangrul','425107',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12670,39,'Manje Hingona','425108',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12671,39,'Manur','425310',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12672,39,'Manvel','425302',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12673,39,'Marul','425503',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12674,39,'Maskawad','425502',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12675,39,'Melane','425107',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12676,39,'Melsangve','425306',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12677,39,'Mengaon','424204',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12678,39,'Mohadi','425114',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12679,39,'Moharala','425301',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12680,39,'Mondhale','425311',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12681,39,'Morgaon','425508',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12682,39,'Moygaon','424206',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12683,39,'Moykheda','424206',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12684,39,'Muktainagar','425306',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12685,39,'Muktal','425310',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12686,39,'Nachankheda','424206',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12687,39,'Nadgaon','425310',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12688,39,'Nagalwadi','425107',1,0,'2022-03-03 12:24:59','2022-03-03 12:24:59'),(12689,39,'Naigaon','425306',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12690,39,'Naigaon','425302',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12691,39,'Nandra Haveli','425310',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12692,39,'Nashirabad','425309',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12693,39,'Neri BK','425114',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12694,39,'Nhavi','425524',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12695,39,'Nimbhora','425506',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12696,39,'Nimdya','425504',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12697,39,'Nimgaon','425304',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12698,39,'Nimgavhan','425107',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12699,39,'Nimkhedi BK','425327',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12700,39,'Nimkhedi KH','425306',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12701,39,'Old Muktainagar','425306',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12702,39,'Padala','425508',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12703,39,'Padalsa','425503',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12704,39,'Pahur','424205',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12705,39,'PAL','425504',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12706,39,'Palaskheda','424206',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12707,39,'Palaskheda Mirache','425114',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12708,39,'Paldhi Pahur','424205',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12709,39,'Panchak','425303',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12710,39,'Parambi','425327',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12711,39,'Patondi','425508',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12712,39,'Pimpalgaon K H','425305',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12713,39,'Pimprala','425327',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12714,39,'Pimpri Nandu','425306',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12715,39,'Punkheda','425508',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12716,39,'Raipur','425203',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12717,39,'Ranjani','425310',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12718,39,'Rasalpur','425508',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12719,39,'Raver','425508',1,0,'2022-03-03 12:25:00','2022-03-03 12:25:00'),(12720,39,'Rotwad','425114',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12721,39,'Rozoda','425504',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12722,39,'Ruikheda','425306',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12723,39,'Sakali','425302',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12724,39,'Sakari','425307',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12725,39,'Sakegaon','425201',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12726,39,'Salshingi','425310',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12727,39,'Samrod','424206',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12728,39,'Sangvi','425304',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12729,39,'Sanpule','425107',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12730,39,'Satod Kolwad','425301',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12731,39,'Satrasen','425107',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12732,39,'Savda','425502',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12733,39,'Savkheda B K','425504',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12734,39,'Shahpur','424206',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12735,39,'Shelgaon','424206',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12736,39,'Shelwad','425310',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12737,39,'Shendurni','424204',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12738,39,'Shengole','424207',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12739,39,'Shindi','425311',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12740,39,'Sunasgaon','425309',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12741,39,'Sunasgaon','425114',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12742,39,'Surwade B K','425311',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12743,39,'Tahakali','425308',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12744,39,'Takali','424206',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12745,39,'Talvel','425305',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12746,39,'Tandalwadi','425502',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12747,39,'Tawase','425107',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12748,39,'Therola','425508',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12749,39,'Thorgavan','425501',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12750,39,'Tondapur','424207',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12751,39,'Tornala','424208',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12752,39,'Uchande','425306',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12753,39,'Udhali','425501',1,0,'2022-03-03 12:25:01','2022-03-03 12:25:01'),(12754,39,'Umarti','425107',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12755,39,'Utkheda','425504',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12756,39,'Vadgaon B K','425303',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12757,39,'Vadhoda','425327',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12758,39,'Vadhode','425108',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12759,39,'Vadri','425301',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12760,39,'Vadti','425107',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12761,39,'Vaijpur Settelement','425107',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12762,39,'Varadsim','425311',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12763,39,'Varangaon Ord.Factory','425308',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12764,39,'Varangaon','425305',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12765,39,'Vardi','425107',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12766,39,'Vazarkheda','425305',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12767,39,'Vele','425107',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12768,39,'Velhale','425305',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12769,39,'Velode','425108',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12770,39,'Viravalli K H','425301',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12771,39,'Viroda','425503',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12772,39,'Virwade','425107',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12773,39,'Vishnapur','425107',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12774,39,'Vitve','425507',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12775,39,'Vivra','425508',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12776,39,'Waghari','424206',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12777,39,'Waghod','425508',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12778,39,'Waghoda B K','425502',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12779,39,'Waghoda K H','425502',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12780,39,'Waghur Dam Colony','425311',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12781,39,'Waghzira','425302',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12782,39,'Wakadi','424207',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12783,39,'Walaki','425108',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12784,39,'Warkod','424205',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12785,39,'Yawal','425301',1,0,'2022-03-03 12:25:02','2022-03-03 12:25:02'),(12786,39,'Adgaon','425111',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12787,39,'Adgaon','425110',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12788,39,'Akhatwade','424104',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12789,39,'Amadade','424105',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12790,39,'Amalgaon','425420',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12791,39,'Amalner Pratap Nagar','425401',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12792,39,'Amalner (Jalgaon)','425401',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12793,39,'Amba Pimpri','425401',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12794,39,'Amoda','425002',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12795,39,'Anjanvihire','425103',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12796,39,'Anjanvihire','424105',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12797,39,'Anturli  -  Ii','424201',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12798,39,'Anturli  -- IIi','424201',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12799,39,'Anturli --i','424201',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12800,39,'Asankheda','425115',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12801,39,'Asoda','425101',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12802,39,'Audyogik Vasahat Jalgaon','425003',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12803,39,'Avhane','425002',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12804,39,'Badarkha Hardo','424104',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12805,39,'Bahadarpur (Jalgaon)','425113',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12806,39,'Bahal','424107',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12807,39,'Bahute','425111',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12808,39,'Balad','424104',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12809,39,'Bambhori','425002',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12810,39,'Bambrud Raniche','425115',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12811,39,'Bamrud Budruk','424201',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12812,39,'Beldarwadi','424119',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12813,39,'Bhadgaon','424105',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12814,39,'Bhadli BK','425102',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12815,39,'Bharwas','425401',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12816,39,'Bhatkheda','425109',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12817,39,'Bhaur','424106',1,0,'2022-03-03 12:25:03','2022-03-03 12:25:03'),(12818,39,'Bhavarkheda','425109',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12819,39,'Bhilali','425113',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12820,39,'Bhokar','425002',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12821,39,'Bholane','425113',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12822,39,'Bholane','425102',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12823,39,'Bhone','425105',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12824,39,'Bhoras Budruk','424119',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12825,39,'Bilakhed','424119',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12826,39,'Bohare','425402',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12827,39,'Bole','425111',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12828,39,'Borgaon BK','425109',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12829,39,'Borkheda','424119',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12830,39,'Borkheda','425104',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12831,39,'Bornar','425116',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12832,39,'Bramhanshevage','424108',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12833,39,'C.T. Mill Road','424119',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12834,39,'Chalisgaon Adarsha Nagar','424101',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12835,39,'Chalisgaon H.O','424101',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12836,39,'Chalisgaon R S','424101',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12837,39,'Chalisgaon Town','424101',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12838,39,'Chandsar','425103',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12839,39,'Chaubari','425401',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12840,39,'Chincholi','425003',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12841,39,'Chinchpure','424203',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12842,39,'Choragaon','425103',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12843,39,'Chorwad','425111',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12844,39,'Dahigaon','425116',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12845,39,'Dahiwad','425401',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12846,39,'Dahiwad','424106',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12847,39,'Dangar','425401',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12848,39,'Dangari','425402',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12849,39,'Daskebardi','424107',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12850,39,'Deogaon (Jalgaon)','425112',1,0,'2022-03-03 12:25:04','2022-03-03 12:25:04'),(12851,39,'Deoli','424119',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12852,39,'Devgaon','425401',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12853,39,'Dhamangaon','425002',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12854,39,'Dhamangaon','424106',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12855,39,'Dhanora','425105',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12856,39,'Dhanwad','425003',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12857,39,'Dhar','425401',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12858,39,'Dharangaon (Jalgaon)','425105',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12859,39,'Dheku','425105',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12860,39,'Dholi','425111',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12861,39,'Dhul Pimpri','425111',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12862,39,'Dodhwad','425420',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12863,39,'Dongaon','425103',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12864,39,'Eklahare','425401',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12865,39,'Erandol','425109',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12866,39,'Farkande','425110',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12867,39,'Galan','424201',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12868,39,'Galwade BK','425401',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12869,39,'Gandhli','425420',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12870,39,'Ganeshpur','424119',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12871,39,'Ghodegaon','424108',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12872,39,'Girad','424201',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12873,39,'Gondgaon','424103',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12874,39,'Goradkheda','424201',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12875,39,'Gudhe','424107',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12876,39,'Hanmantkheda','425109',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12877,39,'Hatgaon','424108',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12878,39,'Hatle','424119',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12879,39,'Hedave','425401',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12880,39,'Hingona Budruk','425104',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12881,39,'Hingone Khurd','424102',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12882,39,'Hirapur','424108',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12883,39,'Hol Pimrpi','425111',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12884,39,'Idgaon','425002',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12885,39,'Jaitpeer','425401',1,0,'2022-03-03 12:25:05','2022-03-03 12:25:05'),(12886,39,'Jalgaon Bazar','425001',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12887,39,'Jalgaon Collectorate','425001',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12888,39,'Jalgaon H.O','425001',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12889,39,'Jalgaon Kawarnagar','425001',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12890,39,'Jalgaon Peth','425001',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12891,39,'Jalgaon Premnagar','425001',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12892,39,'Jalke','425116',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12893,39,'Jalod','425420',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12894,39,'Jambhore','425105',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12895,39,'Jamda','424106',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12896,39,'Janve','425401',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12897,39,'Javkhede','425401',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12898,39,'Jirali','425113',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12899,39,'Juvardi','424107',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12900,39,'Kadgaon','425003',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12901,39,'Kadholi','425103',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12902,39,'Kajgaon (Jalgaon)','424103',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12903,39,'Kalali','425420',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12904,39,'Kalamsare','425402',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12905,39,'Kalmadu','424106',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12906,39,'Kanalda','425002',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12907,39,'Kandari','425003',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12908,39,'Karankheda','425402',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12909,39,'Kargaon','424119',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12910,39,'Karmad','425111',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12911,39,'Kasampura','424201',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12912,39,'Kasoda','425110',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12913,39,'Kathora','425002',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12914,39,'Kavpimpri','425401',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12915,39,'Khadakdeola','424201',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12916,39,'Khadke Budruk','425109',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12917,39,'Khadke Khurd','425109',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12918,39,'Khakdesim','424106',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12919,39,'Kharchi','425103',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12920,39,'Kharde','425105',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12921,39,'Kharjai','424119',1,0,'2022-03-03 12:25:06','2022-03-03 12:25:06'),(12922,39,'Khedgaon Khurd','424105',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12923,39,'Khedgaon Nandiche','424201',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12924,39,'Khedgaon (Jalgaon)','424107',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12925,39,'Kherde','424119',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12926,39,'Kinod','425002',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12927,39,'Kol Pimpri','425401',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12928,39,'Kolegaon','424103',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12929,39,'Kunjhar','424106',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12930,39,'Kurangi','425115',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12931,39,'Kurhad','424202',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12932,39,'Kurhe Khurd','425105',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12933,39,'Kusumba','425003',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12934,39,'Lohare','424201',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12935,39,'Lohari Budruk','424202',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12936,39,'Lohtar','424201',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12937,39,'Lon BK','425401',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12938,39,'Lon Pirache','424103',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12939,39,'Londhave','425401',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12940,39,'Londhe','424106',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12941,39,'Lonje','424119',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12942,39,'M.J.College Jalgaon','425002',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12943,39,'Maheji','425115',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12944,39,'Mahindale','424105',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12945,39,'Malshevage','424108',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12946,39,'Mamurabad','425002',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12947,39,'Mandal','425401',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12948,39,'Mangrul','425111',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12949,39,'Mangrul','425401',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12950,39,'Marwad','425402',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12951,39,'Mathgavan','425105',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12952,39,'Meharun','425003',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12953,39,'Mehunbare','424106',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12954,39,'Mhasave','425111',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12955,39,'Mhasawad (Jalgaon)','425116',1,0,'2022-03-03 12:25:07','2022-03-03 12:25:07'),(12956,39,'Mohadi','425002',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12957,39,'Mondhale','425111',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12958,39,'Mudi','425401',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12959,39,'Mundane','425111',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12960,39,'N M University Jalgaon','425004',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12961,39,'Nagardeola R S','424104',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12962,39,'Nagardeola','424104',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12963,39,'Nagav','425401',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12964,39,'Nanded','425105',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12965,39,'Nandra','425002',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12966,39,'Nandra Pachora','425115',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12967,39,'Navi Peth Jalgaon','425001',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12968,39,'Neri','424104',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12969,39,'Nimb','425402',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12970,39,'Nimbhora','424105',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12971,39,'Nimbhora','425420',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12972,39,'Nimbhori','424201',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12973,39,'Nipane','425110',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12974,39,'Ozar','424119',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12975,39,'Pachora','424201',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12976,39,'Padmalaya','425109',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12977,39,'Pahan','425115',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12978,39,'Palaskheda Sim','425111',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12979,39,'Paldhi','425103',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12980,39,'Pardhade','424201',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12981,39,'Parola','425111',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12982,39,'Pashtane Budruk','425105',1,0,'2022-03-03 12:25:08','2022-03-03 12:25:08'),(12983,39,'Pathri','425115',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(12984,39,'Patnadevi','424119',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(12985,39,'Patonda','425401',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(12986,39,'Patonda','424102',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(12987,39,'Phafore','425401',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(12988,39,'Phupnagari','425002',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(12989,39,'Picharde','424105',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(12990,39,'Pilkhod','424119',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(12991,39,'Pilode','425420',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(12992,39,'Pimpale Budruk','425401',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(12993,39,'Pimpalgaon','424203',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(12994,39,'Pimpali','425420',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(12995,39,'Pimpalkotha','425103',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(12996,39,'Pimparkhed','424119',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(12997,39,'Pimparkhed','424105',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(12998,39,'Pimpri Budruk','424103',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(12999,39,'Pimpri Khurd','425104',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(13000,39,'Pohara','424107',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(13001,39,'Rajwad','425105',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(13002,39,'Ranaiche','425401',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(13003,39,'Ranjangaon','424119',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(13004,39,'Ravanje','425103',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(13005,39,'Ringangaon','425103',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(13006,39,'Rohini','424108',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(13007,39,'Rotwad','425105',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(13008,39,'Sadavan','425111',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(13009,39,'Sakare','425105',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(13010,39,'Salve','425105',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(13011,39,'Samner','425115',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(13012,39,'Sangavi','424119',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(13013,39,'Sarbete','425105',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(13014,39,'Sarole','424201',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(13015,39,'Sarve','425111',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(13016,39,'Satgaon','424201',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(13017,39,'Satkheda','425104',1,0,'2022-03-03 12:25:09','2022-03-03 12:25:09'),(13018,39,'Savde','424103',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13019,39,'Savkheda','425105',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13020,39,'Savkheda','425002',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13021,39,'Savkheda Hol','425109',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13022,39,'Saygaon','424119',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13023,39,'Shahpur','425401',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13024,39,'Shelave','425105',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13025,39,'Shevge','425113',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13026,39,'Shindad','424202',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13027,39,'Shindi','424119',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13028,39,'Shindi','424103',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13029,39,'Shirasgaon','424119',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13030,39,'Shirasmani','425111',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13031,39,'Shirsale','425401',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13032,39,'Shirsoli','425002',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13033,39,'Shirud','425401',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13034,39,'Shivani','424105',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13035,39,'Shivare Digar','425111',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13036,39,'Sonwad','425104',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13037,39,'Takarkheda','425105',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13038,39,'Takli P.D.','424119',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13039,39,'Talai','425110',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13040,39,'Talegaon','424108',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13041,39,'Talki Budruk','424103',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13042,39,'Talonde Digar','424119',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13043,39,'Tamaswadi','425111',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13044,39,'Tambole Budruk','424119',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13045,39,'Tandulwadi','424102',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13046,39,'Tarkheda','424201',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13047,39,'Tarsod','425003',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13048,39,'Tarwade','424119',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13049,39,'Taskheda','425401',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13050,39,'Tehu','425111',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13051,39,'Titvi','425111',1,0,'2022-03-03 12:25:10','2022-03-03 12:25:10'),(13052,39,'Toli','425112',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13053,39,'Toli Khurd','425109',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13054,39,'Umbarkhed','424119',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13055,39,'Undirkhede','425111',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13056,39,'Upkhed','424119',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13057,39,'Utran','425109',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13058,39,'Vadale Vadali','424102',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13059,39,'Vadali','425115',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13060,39,'Vadgaon Ambe','424202',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13061,39,'Vadgaon Budruk','424104',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13062,39,'Vadgaon Khurd','424104',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13063,39,'Vadgaon Lambe','424119',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13064,39,'Vadji','424105',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13065,39,'Vankothe','425110',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13066,39,'Varad','425103',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13067,39,'Varad Budruk','425115',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13068,39,'Varkhede Budruk','424106',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13069,39,'Varkhedi','424202',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13070,39,'Veruli Khurd','424201',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13071,39,'Vikhran','425109',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13072,39,'Vitner','425116',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13073,39,'Vivekanand nagar Pachora','424201',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13074,39,'Wade','424119',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13075,39,'Wadi','424201',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13076,39,'Waghali','424102',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13077,39,'Waghdu','424119',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13078,39,'Wavdade','425116',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13079,39,'Wavde','425401',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13080,39,'Zurkheda','425103',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13081,40,'Adgaon','431132',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13082,40,'Akola (Niklak)','431202',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13083,40,'Akola','431208',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13084,40,'Ambad Bazar','431204',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13085,40,'Ambad','431204',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13086,40,'Ambika Market Jalna','431203',1,0,'2022-03-03 12:25:11','2022-03-03 12:25:11'),(13087,40,'Ankush Nagar','431212',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13088,40,'Anterwali Tembhi','431211',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13089,40,'Avana','431114',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13090,40,'Babhulgaon','431114',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13091,40,'Bawne Pangri','431215',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13092,40,'Bharaj','431206',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13093,40,'Bhatepuri','431214',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13094,40,'Bodkha BK','431209',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13095,40,'Borgaon','431214',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13096,40,'Chandai Eco','431215',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13097,40,'Chikangaon','431202',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13098,40,'Chikhali','431215',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13099,40,'Chinchkheda','431121',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13100,40,'Chitili Putli','431214',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13101,40,'Collectorate Complex Jalna','431213',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13102,40,'Dabhadi','431215',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13103,40,'Dahipuri','431204',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13104,40,'Dahyala','431137',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13105,40,'Danapur','431114',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13106,40,'Delegavan','431215',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13107,40,'Deogaon Kusali','431202',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13108,40,'Dhakalgaon','431205',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13109,40,'Dhakephal','431209',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13110,40,'Dhasala','431202',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13111,40,'Dhavda','431132',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13112,40,'Dongaon','431121',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13113,40,'Dongaon','431215',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13114,40,'Dudhna Kelgaon','431213',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13115,40,'Georai(Bazar)','431202',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13116,40,'Ghansawangi','431209',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13117,40,'Ghungurde Hadgaon','431212',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13118,40,'Golapangri','431213',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13119,40,'Gondegaon','431213',1,0,'2022-03-03 12:25:12','2022-03-03 12:25:12'),(13120,40,'Gondi','431212',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13121,40,'Gunj BK','431211',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13122,40,'Guru Pimpri','431204',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13123,40,'Hastepimpalgaon','431214',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13124,40,'Hastepokhari','431204',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13125,40,'Hiswan','431207',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13126,40,'Hivra  Kabli','431208',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13127,40,'Hivra Roshangaon','431207',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13128,40,'Jaffrabad','431206',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13129,40,'Jalna H.O','431203',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13130,40,'Jalna Industrial Area','431203',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13131,40,'Jalna Mondha','431203',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13132,40,'Jalna Railway Station','431213',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13133,40,'Jam Samarth','431211',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13134,40,'Jamkhed','431121',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13135,40,'Jamwadi','431213',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13136,40,'Janephal','431206',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13137,40,'Javkheda BK','431215',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13138,40,'Jiradgaon','431207',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13139,40,'Kajala','431213',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13140,40,'Kandharai Partur','431207',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13141,40,'Kandhari (Bk)','431202',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13142,40,'Karadgaon','431207',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13143,40,'Karla','431207',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13144,40,'Kathora','431114',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13145,40,'Kedarkheda','431215',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13146,40,'Keligavahan','431202',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13147,40,'Khamgaon','431215',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13148,40,'Khapardev Hivra','431209',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13149,40,'Khasgaon','431206',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13150,40,'Kosgaon','431114',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13151,40,'Kumbhar Pimpalgaon','431211',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13152,40,'Kumbharzari','431208',1,0,'2022-03-03 12:25:13','2022-03-03 12:25:13'),(13153,40,'Longaon','431215',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13154,40,'Machindra Chincholi','431209',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13155,40,'Mahakala','431212',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13156,40,'Mahora','431206',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13157,40,'Manegaon','431214',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13158,40,'Mangrul','431211',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13159,40,'Maujpuri','431214',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13160,40,'Midc Jalna','431213',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13161,40,'Nalewadi','431205',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13162,40,'Nalni','431215',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13163,40,'Nanegaon','431202',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13164,40,'Navha','431213',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13165,40,'Ner','431214',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13166,40,'Old Jalna','431213',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13167,40,'Pachan Wadgaon','431213',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13168,40,'Pahtepur','431114',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13169,40,'Panewadi','431204',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13170,40,'Paradggaon','431207',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13171,40,'Parner','431204',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13172,40,'Parundi','431204',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13173,40,'Patharwala','431212',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13174,40,'Pathrud','431214',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13175,40,'Pimalgaon Kolte','431134',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13176,40,'Pimpalgaon R','431114',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13177,40,'Pimpalgaon Saste','431212',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13178,40,'Pimparkheda (Bk)','431211',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13179,40,'Pir Pimpalgaon','431213',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13180,40,'Pirkalyan','431213',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13181,40,'Raja Takli','431211',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13182,40,'Rajur','431215',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13183,40,'Rakhiv Police Bal Jalna','431203',1,0,'2022-03-03 12:25:14','2022-03-03 12:25:14'),(13184,40,'Ramasgaon','431209',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13185,40,'Ramnagar','431214',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13186,40,'Rani Unchegaon','431204',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13187,40,'Ranjani (Jalna)','431207',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13188,40,'Revgaon','431213',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13189,40,'Rohilagad','431121',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13190,40,'Roshangaon','431202',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13191,40,'Saigaon (Dongargaon)','431202',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13192,40,'Sawangi A','431114',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13193,40,'Sawargaon Hadap','431214',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13194,40,'Seoli','431214',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13195,40,'Shahagad','431212',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13196,40,'Shahapur','431205',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13197,40,'Shelgaon','431202',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13198,40,'Shelud','431132',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13199,40,'Sheoga','431204',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13200,40,'Shindekelgaon','431214',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13201,40,'Sipora Ambhora','431206',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13202,40,'Sipora','431114',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13203,40,'Soegaon Devi','431114',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13204,40,'Somthana','431202',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13205,40,'Sonakpimpalgaon','431205',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13206,40,'Sukhapuri','431205',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13207,40,'Surangali','431114',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13208,40,'Tadegaon','431215',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13209,40,'Tadhadgaon','431204',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13210,40,'Takli Kolta','431134',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13211,40,'Talegaon','431134',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15');
INSERT INTO `cities` VALUES (13212,40,'Tapowan Gondhan','431208',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13213,40,'Tembhurni (Jalna)','431208',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13214,40,'Tirthpuri','431209',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13215,40,'Utwad','431214',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13216,40,'Wadi BK','431114',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13217,40,'Wadigodri','431205',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13218,40,'Waghrul','431213',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13219,40,'Wakhari','431213',1,0,'2022-03-03 12:25:15','2022-03-03 12:25:15'),(13220,40,'Walsa Khalsa','431215',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13221,40,'Walsa Wadala','431114',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13222,40,'Walsawangi','431132',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13223,40,'Warud BK','431114',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13224,40,'Warud BK','431206',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13225,40,'Warud KH','431206',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13226,40,'Warud Tangde','431132',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13227,40,'Zirpi','431204',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13228,40,'Akani','431504',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13229,40,'Amba','431512',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13230,40,'Anandwadi','431501',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13231,40,'Ashti (Jalna)','431507',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13232,40,'Babultara','431501',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13233,40,'Bellora','431501',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13234,40,'Dahifal','431504',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13235,40,'Devgaon','431504',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13236,40,'Golegaon','431507',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13237,40,'Hatdi','431501',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13238,40,'Helas','431504',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13239,40,'Idoli','431504',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13240,40,'Jaipur','431501',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13241,40,'K. Hadgaon','431507',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13242,40,'K. Sawangi','431504',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13243,40,'Kendhali','431504',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13244,40,'Khandavi','431502',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13245,40,'Kirla','431504',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13246,40,'Lingasa','431501',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13247,40,'Loni','431507',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13248,40,'Mantha','431504',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13249,40,'Mapegaon','431502',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13250,40,'Osmanpur','431502',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13251,40,'P. Dhamangaon','431507',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13252,40,'Pande Pokhari','431507',1,0,'2022-03-03 12:25:16','2022-03-03 12:25:16'),(13253,40,'Pangri BK','431504',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13254,40,'Pangri Gosavi','431501',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13255,40,'Partur','431501',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13256,40,'Patoda','431503',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13257,40,'Patoda Mav','431501',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13258,40,'Pimparkheda','431504',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13259,40,'Raigavan','431507',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13260,40,'Rohina','431501',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13261,40,'Satona','431502',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13262,40,'Shelgaon','431502',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13263,40,'Shrishti','431501',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13264,40,'Talni','431504',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13265,40,'Uswad','431504',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13266,40,'Vaidya Wadgaon','431501',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13267,40,'Warphal','431501',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13268,40,'Watur','431501',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13269,41,'5 Star MIDC Kagal','416236',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13270,41,'Adkur','416509',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13271,41,'Adoli','416210',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13272,41,'Ainapur','416526',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13273,41,'Ajara','416505',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13274,41,'Akanur','416212',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13275,41,'Akiwat','416106',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13276,41,'Akiwate Industrial Estate','416144',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13277,41,'Akurle','416214',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13278,41,'Alas','416104',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13279,41,'Alate','416109',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13280,41,'Ambap','416112',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13281,41,'Ambarde','416215',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13282,41,'Ambavade','416201',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13283,41,'Ambewadi','416552',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13284,41,'Ambewadi (Kolhapur)','416229',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13285,41,'Amroli','416509',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13286,41,'Amshi Dumala','416204',1,0,'2022-03-03 12:25:17','2022-03-03 12:25:17'),(13287,41,'Anap Khurd','416210',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13288,41,'Anur','416235',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13289,41,'Arale','416114',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13290,41,'Aralgundi','416220',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13291,41,'Ardal','416220',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13292,41,'Are','416001',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13293,41,'Arjuni','416235',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13294,41,'Arjunwad','416120',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13295,41,'Arjunwada','416208',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13296,41,'Arjunwadi','416504',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13297,41,'Arul','416215',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13298,41,'Asandoli','416206',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13299,41,'Aslaj','416206',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13300,41,'Atigre','416118',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13301,41,'Atyal','416502',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13302,41,'Aurwad','416104',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13303,41,'Awali','416213',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13304,41,'Awali BK','416211',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13305,41,'Awali KH','416211',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13306,41,'Babujamal','416012',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13307,41,'Bachani','416001',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13308,41,'Bachani','416221',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13309,41,'Badyachiwadi','416502',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13310,41,'Bahireshwar','416011',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13311,41,'Bahirewadi','416220',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13312,41,'Bahubali','416110',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13313,41,'Bajar Bhogaon','416205',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13314,41,'Baleghol','416218',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13315,41,'Balinge','416010',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13316,41,'Bamani','416232',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13317,41,'Bambavada','416213',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13318,41,'Banage','416235',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13319,41,'Bandiwade','416230',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13320,41,'Baradwadi','416208',1,0,'2022-03-03 12:25:18','2022-03-03 12:25:18'),(13321,41,'Barve','416209',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13322,41,'Basarge','416507',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13323,41,'Basarge BK','416506',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13324,41,'Bastavade','416235',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13325,41,'Bastwad','416106',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13326,41,'Batkangale','416503',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13327,41,'Beed','416011',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13328,41,'Belawale BK','416221',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13329,41,'Belewadi Kalamma','416218',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13330,41,'Bhadale','416213',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13331,41,'Bhadgaon','416502',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13332,41,'Bhadole','416112',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13333,41,'Bhadvan','416505',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13334,41,'Bhamate','416204',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13335,41,'Bhativade','416223',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13336,41,'Bhedasgaon','416214',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13337,41,'Bhendegalli','416002',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13338,41,'Bhendwade','416112',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13339,41,'Bhuye','416229',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13340,41,'Bidri','416208',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13341,41,'Bolavi','416218',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13342,41,'Boravade','416208',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13343,41,'Borbet','416206',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13344,41,'Borgaon','416230',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13345,41,'Borivade','416213',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13346,41,'Borpadale','416213',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13347,41,'Bubnal','416104',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13348,41,'Bugadikatti','416506',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13349,41,'Buvache Vathar','416112',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13350,41,'Chandgad','416509',1,0,'2022-03-03 12:25:19','2022-03-03 12:25:19'),(13351,41,'Chandoli','415101',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13352,41,'Chandur','416116',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13353,41,'Channe Kuppi','416502',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13354,41,'Charan','416213',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13355,41,'Chavare','416112',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13356,41,'Chikhali','416235',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13357,41,'Chikhali','416229',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13358,41,'Chimane','416220',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13359,41,'Chinchwad','416120',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13360,41,'Chinchwad','416119',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13361,41,'Chipri','416101',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13362,41,'Chokak','416118',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13363,41,'Chuye','416207',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13364,41,'Dajipur','416212',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13365,41,'Danoli','416101',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13366,41,'Danwad','416107',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13367,41,'Date','416552',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13368,41,'Dattanagar','416120',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13369,41,'Dattawad','416107',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13370,41,'Daulat Sugar Factory','416552',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13371,41,'Dewale','416213',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13372,41,'Dhamane','416220',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13373,41,'Dhamod','416211',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13374,41,'Dharangutti','416102',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13375,41,'Dholgarwadi','416507',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13376,41,'Dhundwade','416205',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13377,41,'Dindnerli','416207',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13378,41,'Dudhganganagar','416231',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13379,41,'Dukkarwadi','416507',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13380,41,'Dundage','416501',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13381,41,'Durgamanwad','416211',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13382,41,'Ekondi','416232',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13383,41,'Gadhinglaj','416502',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13384,41,'Gadhinglaj Shivaji Chowk','416502',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13385,41,'Gadhinglaj Tilakpath','416502',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13386,41,'Gadmudshingi','416119',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13387,41,'Gaganbavada','416206',1,0,'2022-03-03 12:25:20','2022-03-03 12:25:20'),(13388,41,'Gajapur','415101',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13389,41,'Gajargaon','416502',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13390,41,'Gandhinagar (Kolhapur)','416119',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13391,41,'Ganeshwadi (Kolhapur)','416105',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13392,41,'Ganganagar Ichalkaranji','416116',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13393,41,'Gangapur','416209',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13394,41,'Gargoti','416209',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13395,41,'Gariwade','416206',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13396,41,'Gavase','416509',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13397,41,'Gavase','416505',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13398,41,'Ghalwad','416103',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13399,41,'Ghanavade','416001',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13400,41,'Ghosarwad','416107',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13401,41,'Ghotavade','416230',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13402,41,'Ghunki','416112',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13403,41,'Gijawane','416502',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13404,41,'Girgaon','416013',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13405,41,'Gogave','416213',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13406,41,'Gorambe','416216',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13407,41,'Gudal','416211',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13408,41,'Gur Market Yard','416005',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13409,41,'Hadalage','416504',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13410,41,'Hajgoli','416507',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13411,41,'Haldi','416001',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13412,41,'Halewadi','416220',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13413,41,'Halkarni (Chandgad)','416552',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13414,41,'Halkarni','416506',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13415,41,'Halsawade','416202',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13416,41,'Hamidwada','416235',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13417,41,'Hanimnal','416501',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13418,41,'Hanmantwadi','416010',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13419,41,'Harali BK','416502',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13420,41,'Haroli','416102',1,0,'2022-03-03 12:25:21','2022-03-03 12:25:21'),(13421,41,'Hasur','416103',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13422,41,'Hasur Champu','416501',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13423,41,'Hasur Dumala','416001',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13424,41,'Hasur Khurd','416218',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13425,41,'Hasur Sasgiri','416506',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13426,41,'Hativade','416505',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13427,41,'Hatkalangada','416109',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13428,41,'Hebbal','416501',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13429,41,'Hebbal Jaldyal','416503',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13430,41,'Hedawade','416223',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13431,41,'Hera','416509',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13432,41,'Herla','416005',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13433,41,'Herwad','416106',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13434,41,'Hindgaon','416509',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13435,41,'Hiralge','416526',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13436,41,'Hitni','416501',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13437,41,'Honyali','416220',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13438,41,'Hosur','416508',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13439,41,'Hupari','416203',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13440,41,'Ibrahimpur','416509',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13441,41,'Ichalkaranji H.O','416115',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13442,41,'ICO Spinning Mills','416143',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13443,41,'Inchnal','416502',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13444,41,'Ingali','416202',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13445,41,'Isapur','416509',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13446,41,'Ispurli','416207',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13447,41,'Jaisingpur R.S.','416101',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13448,41,'Jakhale','416113',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13449,41,'Jambhali','416121',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13450,41,'Jangamhatti','416507',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13451,41,'Jarali','416551',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13452,41,'Jatharwadi','416122',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13453,41,'Jawaharnagar Ichalkaranji','416115',1,0,'2022-03-03 12:25:22','2022-03-03 12:25:22'),(13454,41,'Jaysingpur','416101',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13455,41,'June Pargaon','416113',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13456,41,'Kabnur','416116',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13457,41,'Kadalage','416506',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13458,41,'Kadave','415101',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13459,41,'Kadgaon Gadhinglaj','416502',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13460,41,'Kadgaon Gargoti','416210',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13461,41,'Kagal','416216',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13462,41,'Kakhe','416114',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13463,41,'Kalamba','416007',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13464,41,'Kale (Kolhapur)','416205',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13465,41,'Kalkundri','416508',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13466,41,'Kalnakwadi','416209',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13467,41,'Kalvikatti','416506',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13468,41,'Kanadewadi','416504',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13469,41,'Kandgaon','416011',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13470,41,'Kaneri (Panhala)','416230',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13471,41,'Kaneri','416234',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13472,41,'Kanoli','416503',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13473,41,'Kanur Khurd','416507',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13474,41,'Kanwad','416103',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13475,41,'Kapadmarket Ichalkaranji','416115',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13476,41,'Kapshi','416214',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13477,41,'Kapshi','416218',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13478,41,'Karadwadi','416209',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13479,41,'Karambali','416526',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13480,41,'Karanjivane','416219',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13481,41,'Karanjphen','416230',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13482,41,'Karanjphen','416205',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13483,41,'Kardyal','416218',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13484,41,'Karnur','416216',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13485,41,'Karungale','415101',1,0,'2022-03-03 12:25:23','2022-03-03 12:25:23'),(13486,41,'Karve','416507',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13487,41,'Kasar Kandgaon','416505',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13488,41,'Kasari','416218',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13489,41,'Kasarwada','416212',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13490,41,'Kasba Bavada','416006',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13491,41,'Kasba Sangaon','416216',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13492,41,'Kasba Thane','416205',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13493,41,'Katali','416206',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13494,41,'Kate Bhogaon','416205',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13495,41,'Kaulav','416211',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13496,41,'Kavane','416207',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13497,41,'Kavatheguland','416105',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13498,41,'Kavathesar','416111',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13499,41,'Kenavade','416216',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13500,41,'Keravade','416509',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13501,41,'Kerle','416229',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13502,41,'Kerli','416229',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13503,41,'Khadakewada','416235',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13504,41,'Khandal','416551',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13505,41,'Khatangale','416204',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13506,41,'Khebavade','416221',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13507,41,'Khidrapur','416108',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13508,41,'Khochi','416110',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13509,41,'Khupire','416205',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13510,41,'Kine','416504',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13511,41,'Kini','416112',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13512,41,'Kini','416508',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13513,41,'Kisrul','416205',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13514,41,'Kitawade','416505',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13515,41,'Kodavade','416211',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13516,41,'Kodoli','416114',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13517,41,'Koge','416010',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13518,41,'Kolhapur City H.O','416012',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13519,41,'Kolhapur H.O','416003',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13520,41,'Kolhapur RS','416001',1,0,'2022-03-03 12:25:24','2022-03-03 12:25:24'),(13521,41,'Kolik','416205',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13522,41,'Kolindre','416503',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13523,41,'Kololi','416230',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13524,41,'Kolwan','416223',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13525,41,'Kondoshi','416210',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13526,41,'Koor','416209',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13527,41,'Koparde','416204',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13528,41,'Korochi','416109',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13529,41,'Kothali','416101',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13530,41,'Kothali','416001',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13531,41,'Kotoli (Warna)','416214',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13532,41,'Kotoli','416230',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13533,41,'Koulage','416235',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13534,41,'Koulage','416526',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13535,41,'Kowad','416508',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13536,41,'Kowade','416503',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13537,41,'Kuditre','416204',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13538,41,'Kudnur','416508',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13539,41,'Kumbhoj','416111',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13540,41,'Kurani Buzawade','416509',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13541,41,'Kurukali','416001',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13542,41,'Kurundwad','416106',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13543,41,'Kutwad','416103',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13544,41,'Lakudwadi','416503',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13545,41,'Lat','416143',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13546,41,'Latwade','416112',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13547,41,'Laxmipuri','416002',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13548,41,'Lingnur Dumala','416216',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13549,41,'Madilage','416505',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13550,41,'Madilage BK','416209',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13551,41,'Madyal','416218',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13552,41,'Mahagaon (Kolhapur)','416503',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13553,41,'Mahagond','416220',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13554,41,'Mahalewadi','416508',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13555,41,'Majale','416109',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13556,41,'Majgaon','416205',1,0,'2022-03-03 12:25:25','2022-03-03 12:25:25'),(13557,41,'Malage BK','416219',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13558,41,'Malapude','416205',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13559,41,'Malatwadi','416508',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13560,41,'Male','416114',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13561,41,'Male','416118',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13562,41,'Maligre','416503',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13563,41,'Malkapur (Kolhapur)','415101',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13564,41,'Malyachi Shiroli','416001',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13565,41,'Man','415101',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13566,41,'Manapadale','416112',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13567,41,'Manawale','416209',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13568,41,'Mandukali','416206',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13569,41,'Mangalwar Peth (Kolhapur)','416012',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13570,41,'Mangaon','416507',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13571,41,'Mangaon','416118',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13572,41,'Mangnoor','416209',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13573,41,'Mangnoor T/F Sawantwadi','416503',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13574,41,'Manjarewadi','416106',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13575,41,'Manwad','416506',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13576,41,'Masewadi','416220',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13577,41,'Mathgaon','416210',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13578,41,'Mhakave','416216',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13579,41,'Mhalsavade','416001',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13580,41,'Mhalunge','416207',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13581,41,'Mhalunge Khalsa','416507',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13582,41,'Mhasrang','416210',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13583,41,'Mhasurli','416205',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13584,41,'Mhasve','416223',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13585,41,'MIDC Gokul Shirgaon','416234',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13586,41,'MIDC Shiroli','416122',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13587,41,'Minche','416109',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13588,41,'Minche BK','416223',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13589,41,'Minche KH','416223',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13590,41,'Mohare','416114',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13591,41,'Molawade','416215',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13592,41,'Mouje Haladi','416219',1,0,'2022-03-03 12:25:26','2022-03-03 12:25:26'),(13593,41,'Mouje Sangaon','416216',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13594,41,'Mudhal','416208',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13595,41,'Mugali','416551',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13596,41,'Mugali','416218',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13597,41,'Mumewadi','416220',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13598,41,'Mungurwadi','416503',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13599,41,'Murgud','416219',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13600,41,'Mutnal','416501',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13601,41,'Nadhavade','416209',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13602,41,'Naganwadi','416509',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13603,41,'Nagaon','416122',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13604,41,'Nagave','416509',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13605,41,'Nandani','416102',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13606,41,'Nandanwad','416506',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13607,41,'Nandavade','416509',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13608,41,'Nandgaon','416207',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13609,41,'Nandgaon','416230',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13610,41,'Nangnoor','416551',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13611,41,'Narande','416110',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13612,41,'Narewadi','416506',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13613,41,'Narsobawadi','416104',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13614,41,'Nartavade','416212',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13615,41,'Navale','416210',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13616,41,'Navkud','416506',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13617,41,'Nej','416110',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13618,41,'Nerli','416234',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13619,41,'Nesari','416504',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13620,41,'Nidhori','416219',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13621,41,'Nigave Dumala','416229',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13622,41,'Nigave Khalasa','416207',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13623,41,'Nilji','416501',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13624,41,'Nilpan','416223',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13625,41,'Nimshirgaon','416101',1,0,'2022-03-03 12:25:27','2022-03-03 12:25:27'),(13626,41,'Ningudage','416526',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13627,41,'Nittur','416508',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13628,41,'Nool','416551',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13629,41,'P. Shiroli','416122',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13630,41,'Pachgaon','416013',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13631,41,'Padal','416205',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13632,41,'Padali','416212',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13633,41,'Padali Khurd','416010',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13634,41,'Pal','416209',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13635,41,'Palshivane','416209',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13636,41,'Panhala','416201',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13637,41,'Panori','416231',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13638,41,'Panuandre','416215',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13639,41,'Panutre','416205',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13640,41,'Parali Ninai','415101',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13641,41,'Pargaon','416113',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13642,41,'Parite','416211',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13643,41,'Parkhandale','416205',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13644,41,'Parkhandale','416213',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13645,41,'Parvati Industrial Estate','416146',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13646,41,'Pat Panhala','416205',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13647,41,'Patgaon','416210',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13648,41,'Patne','416552',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13649,41,'Pattankodoli','416202',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13650,41,'Pernoli','416505',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13651,41,'Phanaswadi','416209',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13652,41,'Phejiwade','416212',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13653,41,'Phulewadi','416010',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13654,41,'Pimpalgaon','416209',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13655,41,'Pimpalgaon BK','416235',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13656,41,'Pimpalgaon KH','416216',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13657,41,'Piral','416211',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13658,41,'Pisatri','416205',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13659,41,'Pishavi','416213',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13660,41,'Pohale T/F Borgaon','416205',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13661,41,'Pohale Turf Alate','416229',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13662,41,'Porle Turf Thane','416229',1,0,'2022-03-03 12:25:28','2022-03-03 12:25:28'),(13663,41,'Pratibhanagar','416008',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13664,41,'Punal','416205',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13665,41,'Pungaon','416211',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13666,41,'R K Nagar Ichalkaranji','416121',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13667,41,'R K Nagar (Kolhapur)','416013',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13668,41,'Radhanagari','416212',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13669,41,'Rajagoli KH','416508',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13670,41,'Rajapur','416106',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13671,41,'Rajapurwadi','416108',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13672,41,'Rajarampuri','416008',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13673,41,'Rakshi','416201',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13674,41,'Randivewadi','416203',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13675,41,'Rangoli','416143',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13676,41,'Rankala','416012',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13677,41,'Rashivade','416211',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13678,41,'Rendal','416203',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13679,41,'Rethare','416214',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13680,41,'Rhe Works','416212',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13681,41,'Rui','416116',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13682,41,'Ruikar Colony','416005',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13683,41,'Rukadi','416118',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13684,41,'Sadashivnagar','416235',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13685,41,'Sadoli Khalsa','416001',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13686,41,'Sajani','416116',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13687,41,'Sake','416221',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13688,41,'Salshi','416213',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13689,41,'Salvan','416206',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13690,41,'Sambre','416504',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13691,41,'Sane Guruji Vasahat','416011',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13692,41,'Sangashi','416206',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13693,41,'Sangavade','416202',1,0,'2022-03-03 12:25:29','2022-03-03 12:25:29'),(13694,41,'Sangrul','416526',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13695,41,'Sarambalwadi','416503',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13696,41,'Sarawade','416212',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13697,41,'Sarud','416214',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13698,41,'Satavane','416509',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13699,41,'Satave','416114',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13700,41,'Savarde','416109',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13701,41,'Savarde BK','416219',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13702,41,'Savarde Dumala','416001',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13703,41,'Savarde Patankar','416212',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13704,41,'Savarde T/F Satave','416114',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13705,41,'Save','416213',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13706,41,'Shahapur','416121',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13707,41,'Shahupuri','416001',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13708,41,'Shahuwadi','416215',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13709,41,'Shaniwar Peth (Kolhapur)','416002',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13710,41,'Shankarwadi','416232',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13711,41,'Shedshal','416105',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13712,41,'Sheloli','416210',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13713,41,'Shenawade','416206',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13714,41,'Shendur','416232',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13715,41,'Shengaon','416209',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13716,41,'Shimpe','416214',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13717,41,'Shingnapur','416010',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13718,41,'Shinoli KH','416507',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13719,41,'Shippur T/F Nesari','416504',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13720,41,'Shipur T/F Ajara','416220',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13721,41,'Shiradwad','416143',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13722,41,'Shirala','416215',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13723,41,'Shirale T/Ff Warun','416214',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13724,41,'Shirdhon','416121',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13725,41,'Shirgaon','416211',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13726,41,'Shirgaon','415101',1,0,'2022-03-03 12:25:30','2022-03-03 12:25:30'),(13727,41,'Shirol','416103',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13728,41,'Shiroli (Sonyachi)','416212',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13729,41,'Shirse','416211',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13730,41,'Shirti','416103',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13731,41,'Shittur T/F Warun','416214',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13732,41,'Shittur Turf Malkapur','416213',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13733,41,'Shivaji Peth','416012',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13734,41,'Shivaji Udyam Nagar','416008',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13735,41,'Shivaji University','416004',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13736,41,'Shivaji Veedyapeeth Marg','416008',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13737,41,'Shivajinagar Ichalkaranji','416115',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13738,41,'Shivanage Lakkikatte','416507',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13739,41,'Shivdav','416210',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13740,41,'Shiye','416122',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13741,41,'Shukrawar Peth (Kolhapur)','416002',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13742,41,'Sidhnerli','416232',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13743,41,'Sohale','416505',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13744,41,'Solankur','416212',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13745,41,'Sonage','416235',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13746,41,'Sonali','416219',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13747,41,'Sonarwadi','416209',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13748,41,'Sondoli','416214',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13749,41,'Sule','416205',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13750,41,'Sule','416503',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13751,41,'Sulkud','416216',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13752,41,'Sundi','416507',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13753,41,'Supatre','416213',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13754,41,'Surupali','416235',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13755,41,'Surute','416507',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13756,41,'Takali','416108',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13757,41,'Takaliwadi','416108',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13758,41,'Takawade','416121',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13759,41,'Talandage','416236',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13760,41,'Talasande','416112',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13761,41,'Talashi','416208',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13762,41,'Tamadalage','416101',1,0,'2022-03-03 12:25:31','2022-03-03 12:25:31'),(13763,41,'Tambale','416210',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13764,41,'Tambyachiwadi','416210',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13765,41,'Tamnakwada','416218',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13766,41,'Tarale','416211',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13767,41,'Tardal','416121',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13768,41,'Tarsambale','416211',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13769,41,'Tasgaon','416122',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13770,41,'Tekoli','416215',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13771,41,'Terni','416506',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13772,41,'Terwad','416106',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13773,41,'Teurwadi','416508',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13774,41,'Thergaon','416213',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13775,41,'Thikpurli','416208',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13776,41,'Tikkewadi','416209',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13777,41,'Tillarinagar','416527',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13778,41,'Tilwani','416116',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13779,41,'Tirpan','416230',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13780,41,'Tisangi','416206',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13781,41,'Titave','416208',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13782,41,'Top','416122',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13783,41,'Tudiye','416507',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13784,41,'Turambe','416208',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13785,41,'Turkewadi','416507',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13786,41,'Uchgaon','416005',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13787,41,'Udgaon','416101',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13788,41,'Udyog Nagar Ichalkaranji','416115',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13789,41,'Ujlaiwadi','416004',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13790,41,'Ukhalu','416214',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13791,41,'Ukoli','416215',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13792,41,'Umalwad','416101',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13793,41,'Umgaon','416509',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13794,41,'Undarwadi','416208',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13795,41,'Uttur','416220',1,0,'2022-03-03 12:25:32','2022-03-03 12:25:32'),(13796,41,'Vadange','416229',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13797,41,'Vadarage Majare','416502',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13798,41,'Vadgaon','416218',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13799,41,'Vadgaon (Kolhapur)','416112',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13800,41,'Vakare','416526',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13801,41,'Valivade','416119',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13802,41,'Vandur','416216',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13803,41,'Varange Padali','416229',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13804,41,'Vasagade','416202',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13805,41,'Vathar T/F vadgaon','416112',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13806,41,'Vengrul','416210',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13807,41,'Vesarde','416210',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13808,41,'Vetawade','416205',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13809,41,'Vhanali','416221',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13810,41,'Vhannur','416216',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13811,41,'Virale','416214',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13812,41,'Vishalgad Amba','415101',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13813,41,'Vite','416505',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13814,41,'Wadi Ratnagiri','416229',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13815,41,'Waghapur','416209',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13816,41,'Waghave','416230',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13817,41,'Walwa Bk','416221',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13818,41,'Walwa KH','416221',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13819,41,'Warnanagar','416113',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13820,41,'Warul','415101',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13821,41,'Washi','416011',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13822,41,'Watangi','416504',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13823,41,'Yadrav','416146',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13824,41,'Yalgud','416236',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13825,41,'Yamage','416219',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13826,41,'Yavluj','416205',1,0,'2022-03-03 12:25:33','2022-03-03 12:25:33'),(13827,41,'Yelvan Jugai','415101',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13828,41,'Yenechavandi','416506',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13829,41,'Yerandol','416505',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13830,41,'Zulpewadi','416220',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13831,42,'Abulga BK','413521',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13832,42,'Ahmedpur (Latur)','413515',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13833,42,'Almala','413520',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13834,42,'Ambegaon Masalga','413530',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13835,42,'Anjansonda','413513',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13836,42,'Ashiv','413520',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13837,42,'Atnoor','413532',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13838,42,'Atola','413524',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13839,42,'Aurad Shahajani','413522',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13840,42,'Ausa','413520',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13841,42,'Awalkonda','413517',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13842,42,'Badur','413607',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13843,42,'Banshelki','413517',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13844,42,'Belkund','413520',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13845,42,'Bhada','413520',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13846,42,'Bheta','413511',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13847,42,'Bholegaon','413524',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13848,42,'Bolegaon','413519',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13849,42,'Boral','413519',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13850,42,'Borgaon (Latur)','413511',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13851,42,'Borphal','413520',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13852,42,'Borsuri','413522',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13853,42,'Budhada','413520',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13854,42,'Chakur','413513',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13855,42,'Chapoli','413513',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13856,42,'Chavani Hipperga','413519',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13857,42,'Chikhali','413582',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13858,42,'Chikurda','413511',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13859,42,'Chincholi Ballalnath','413511',1,0,'2022-03-03 12:25:34','2022-03-03 12:25:34'),(13860,42,'Chinchondi','413522',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13861,42,'Daithana','413517',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13862,42,'Dawan Hipperga','413519',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13863,42,'Dawangaon','413517',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13864,42,'De Vtala','413520',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13865,42,'Deoni','413519',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13866,42,'Deulwadi','413532',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13867,42,'Devarjan','413517',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13868,42,'Dhanegaon','413519',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13869,42,'Dhondi Hipperga','413517',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13870,42,'Dongarshelki','413517',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13871,42,'Ekurga','413511',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13872,42,'Gadwad','413511',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13873,42,'Ganga Hipperga','413515',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13874,42,'Gategaon','413511',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13875,42,'Ghansargaon','413527',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13876,42,'Gharani','413513',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13877,42,'Gharsoli','413527',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13878,42,'Ghonshi','413532',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13879,42,'Gondgaon','413519',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13880,42,'Gudsur','413518',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13881,42,'Gunjarga','413521',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13882,42,'Gurnal','413519',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13883,42,'Gutti','413532',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13884,42,'Halgara','413522',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13885,42,'Halli','413518',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13886,42,'Halsi','413522',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13887,42,'Handargulli','413518',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13888,42,'Hangarga','413522',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13889,42,'Haregaon','413520',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13890,42,'Harewadi','413527',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13891,42,'Hari Javalga','413607',1,0,'2022-03-03 12:25:35','2022-03-03 12:25:35'),(13892,42,'Hasegaon','413531',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13893,42,'Hatte Road Latur','413512',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13894,42,'Helamb','413519',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13895,42,'Her','413517',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13896,42,'Hipalner','413513',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13897,42,'Hippalgaon','413531',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13898,42,'Hippalgaon','413514',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13899,42,'Hipperga Kajala','413515',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13900,42,'Honali','413519',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13901,42,'Hosur','413522',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13902,42,'Jalkot','413532',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13903,42,'Janwal','413529',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13904,42,'Javalga','413519',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13905,42,'Javali','413516',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13906,42,'Jawala (BK)','413511',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13907,42,'Jawalga Pomodevi','413520',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13908,42,'JJJKSSK Nalegaon','413581',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13909,42,'Kaban Sangvi','413524',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13910,42,'Kallur','413517',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13911,42,'Kalmugali','413522',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13912,42,'Karadkhed','413517',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13913,42,'Kasarsirsi','413607',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13914,42,'Kate Javalga','413530',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13915,42,'Kawathali','413519',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13916,42,'Kelgaon','413530',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13917,42,'Khandali','413515',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13918,42,'Kharola','413527',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13919,42,'Khuntegaon','413520',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13920,42,'Killari S F','413516',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13921,42,'Killari','413516',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13922,42,'Kingaon','413523',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13923,42,'Kini Yeladevi','413518',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13924,42,'Kokalgaon','413521',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13925,42,'Korangala','413520',1,0,'2022-03-03 12:25:36','2022-03-03 12:25:36'),(13926,42,'Kumtha KH','413517',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13927,42,'Labour Colony Latur','413512',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13928,42,'Lambota','413530',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13929,42,'Lamjana','413516',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13930,42,'Lasona','413519',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13931,42,'Latur Bazar','413512',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13932,42,'Latur H.O','413512',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13933,42,'Latur Rs','413512',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13934,42,'Lohara','413517',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13935,42,'Loni','413517',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13936,42,'Mahalangra','413581',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13937,42,'Makani','413522',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13938,42,'Mal Hipperga','413532',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13939,42,'Malegaon','413522',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13940,42,'Malewadi','413517',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13941,42,'Mangrul','413532',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13942,42,'Mangrul','413516',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13943,42,'Manjara SK','413531',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13944,42,'Matola','413520',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13945,42,'MIDC Latur','413531',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13946,42,'Mogha','413517',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13947,42,'Mohnal','413513',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13948,42,'Morwad','413527',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13949,42,'Motegaon','413527',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13950,42,'Murud Akola','413511',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13951,42,'Murud','413510',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13952,42,'Nagalgaon','413517',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13953,42,'Nagarsoga','413520',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13954,42,'Nalegaon','413524',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13955,42,'Nalgir','413517',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13956,42,'Nandurga','413516',1,0,'2022-03-03 12:25:37','2022-03-03 12:25:37'),(13957,42,'Nawani','413518',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13958,42,'Nevali','413511',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13959,42,'Nilanga','413521',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13960,42,'Nitoor','413530',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13961,42,'Omerga Court','413513',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13962,42,'Pakharsangvi','413531',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13963,42,'Pangaon (Latur)','431522',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13964,42,'Parchanda','413515',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13965,42,'Patoda','413532',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13966,42,'Ramegaon','413511',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13967,42,'Rameshwar','413511',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13968,42,'Ramnagar Latur','413512',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13969,42,'Rapka','413524',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13970,42,'Ravankola','413532',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13971,42,'Rawangaon','413517',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13972,42,'Renapur','413527',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13973,42,'Sambhu Omerga','413517',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13974,42,'Sangam','413519',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13975,42,'Sanghvi','413515',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13976,42,'Sarola','413520',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13977,42,'Sawargaon','413531',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13978,42,'Sawargaon Rokda','413515',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13979,42,'Sawari','413522',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13980,42,'Selu','413520',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13981,42,'Shirala','413511',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13982,42,'Shirol Janapur','413517',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13983,42,'Shirol Wanjarwada','413530',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13984,42,'Shirur Anantpal','413544',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13985,42,'Shirur Tajband','413514',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13986,42,'Shivankhed','413529',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13987,42,'Shivli','413520',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13988,42,'Sindala Shivpur','413524',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13989,42,'Somnathpur','413517',1,0,'2022-03-03 12:25:38','2022-03-03 12:25:38'),(13990,42,'Sondgaon','413527',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(13991,42,'Sugaon','413531',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(13992,42,'Sugaon Mahalang','413529',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(13993,42,'Tadmugali','413522',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(13994,42,'Taka','413520',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(13995,42,'Talegaon','413519',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(13996,42,'Tambhaia','413607',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(13997,42,'Tandulja','413511',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(13998,42,'Telgaon','413513',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(13999,42,'Thergaon','413524',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(14000,42,'Tilaknagar Latur','413531',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(14001,42,'Tirth','413515',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(14002,42,'Tiruka','413532',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(14003,42,'Togri','413517',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(14004,42,'Tondar','413517',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(14005,42,'Tondchira','413517',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(14006,42,'Tungi(BK)','413520',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(14007,42,'Udgir','413517',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(14008,42,'Udgirganj','413517',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(14009,42,'Ujani','413520',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(14010,42,'Uti (BK)','413520',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(14011,42,'Wadhona','413518',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(14012,42,'Wadmurambi','413519',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(14013,42,'Wadwal Nagnath','413529',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(14014,42,'Wagholi','413511',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(14015,42,'Wakadi','413502',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(14016,42,'Walandi','413519',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(14017,42,'Wanjarkheda','413511',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(14018,43,'Antop Hill','400037',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(14019,43,'B P T Colony','400037',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(14020,43,'B.P.Lane','400003',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(14021,43,'BEST STaff Quarters','400012',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(14022,43,'C G S Colony','400037',1,0,'2022-03-03 12:25:39','2022-03-03 12:25:39'),(14023,43,'Chamarbaug','400012',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14024,43,'Chinchbunder H.O','400009',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14025,43,'Cotton Exchange','400033',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14026,43,'Dadar Colony','400014',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14027,43,'Dadar H.O','400014',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14028,43,'Dockyard Road','400010',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14029,43,'Haffkin Institute','400012',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14030,43,'Kalachowki','400033',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14031,43,'Kidwai Nagar (Mumbai)','400031',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14032,43,'L B S N E collage','400033',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14033,43,'Lal Baug','400012',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14034,43,'Mandvi (Mumbai)','400003',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14035,43,'Masjid','400003',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14036,43,'Mazgaon Dock','400010',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14037,43,'Mazgaon Road','400010',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14038,43,'Mazgaon','400010',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14039,43,'Naigaon (Mumbai)','400014',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14040,43,'Noor Baug','400009',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14041,43,'Null Bazar','400003',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14042,43,'Parel Naka','400012',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14043,43,'Parel Rly Work Shop','400012',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14044,43,'Parel','400012',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14045,43,'Princess Dock','400009',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14046,43,'Reay Road','400033',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14047,43,'Sewri','400015',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14048,43,'Tank Road','400033',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14049,43,'V J B Udyan','400027',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14050,43,'V K Bhavan','400010',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14051,43,'Wadala Rs','400031',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14052,43,'Wadala','400031',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14053,43,'Wadala Truck Terminal','400037',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14054,43,'A I Staff Colony','400029',1,0,'2022-03-03 12:25:40','2022-03-03 12:25:40'),(14055,43,'Airport (Mumbai)','400099',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14056,43,'Andheri East','400069',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14057,43,'Andheri H.O','400053',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14058,43,'Andheri Railway Station','400058',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14059,43,'Audit Bhavan','400051',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14060,43,'Azad Nagar (Mumbai)','400053',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14061,43,'B.N. Bhavan','400051',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14062,43,'Bandra West','400050',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14063,43,'Bandra(East)','400051',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14064,43,'Chakala Midc','400093',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14065,43,'Danda','400052',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14066,43,'Government Colony','400051',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14067,43,'H.M.P. School','400058',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14068,43,'Hanuman Road','400057',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14069,43,'International Airport','400099',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14070,43,'IRLA','400056',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14071,43,'J.B. Nagar','400059',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14072,43,'Juhu','400049',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14073,43,'Khar Colony','400052',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14074,43,'Khar Delivery','400052',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14075,43,'Kherwadi','400051',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14076,43,'Madh','400061',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14077,43,'Marol Bazar','400059',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14078,43,'Marol Naka','400059',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14079,43,'Nagardas Road','400069',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14080,43,'Sahar P & T Colony','400099',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14081,43,'Sahargaon','400099',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14082,43,'Santacruz Central','400054',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14083,43,'Santacruz P&t Colony','400029',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14084,43,'Santacruz(East)','400055',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14085,43,'Santacruz(West)','400054',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14086,43,'Seepz','400096',1,0,'2022-03-03 12:25:41','2022-03-03 12:25:41'),(14087,43,'V.P. Road','400052',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14088,43,'Vakola','400055',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14089,43,'Vesava','400061',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14090,43,'Vidyanagari','400098',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14091,43,'Vileeparle (East)','400057',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14092,43,'Vileparle Railway Station','400057',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14093,43,'Vileparle(West)','400056',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14094,43,'Anushakti Nagar','400094',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14095,43,'BARC','400085',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14096,43,'Barve Nagar','400084',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14097,43,'Best Staff Colony','400075',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14098,43,'Bhandup Complex','400082',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14099,43,'Bhandup East','400042',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14100,43,'Bhandup Ind. Estate','400078',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14101,43,'Bhandup West','400078',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14102,43,'Chembur Extension','400074',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14103,43,'Chembur H.O','400071',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14104,43,'Chembur Rs','400089',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14105,43,'Chunabhatti','400022',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14106,43,'D.M. Colony','400043',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14107,43,'FCI','400074',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14108,43,'Ghatkopar West','400086',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14109,43,'Govandi','400088',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14110,43,'J.M. Road','400078',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14111,43,'Kannamwar Nagar','400083',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14112,43,'Kurla North','400070',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14113,43,'Kurla','400070',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14114,43,'Mahul Road','400074',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14115,43,'Matunga','400019',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14116,43,'Mhada Colony','400081',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14117,43,'Mulund Colony','400082',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14118,43,'Mulund Dd Road','400080',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14119,43,'Mulund East','400081',1,0,'2022-03-03 12:25:42','2022-03-03 12:25:42'),(14120,43,'Mulund West','400080',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14121,43,'Nahur','400080',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14122,43,'Nehru Nagar (Mumbai)','400024',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14123,43,'Nehru Road (Mumbai)','400080',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14124,43,'Netajinagar','400070',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14125,43,'NITIE','400087',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14126,43,'P.H. Colony','400078',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14127,43,'Pant Nagar','400075',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14128,43,'Powai Iit','400076',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14129,43,'Psm Colony','400079',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14130,43,'R.A.Nagar','400075',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14131,43,'Rajawadi','400077',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14132,43,'Raoli Camp','400022',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14133,43,'Rifle Range','400086',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14134,43,'S.B. Road','400080',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14135,43,'Sahakar Bhavan','400086',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14136,43,'Sakinaka','400072',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14137,43,'Shivaji Nagar (Mumbai)','400043',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14138,43,'Sindhi Society','400071',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14139,43,'Sion','400022',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14140,43,'T.F.Donar','400088',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14141,43,'Tagore Nagar','400083',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14142,43,'Tilak Nagar (Mumbai)','400089',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14143,43,'Transit Camp','400022',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14144,43,'Trombay','400088',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14145,43,'Usha Nagar','400078',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14146,43,'Vihar Road','400072',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14147,43,'Vikhroli','400079',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14148,43,'Aareymilk Colony','400065',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14149,43,'Bangur Nagar','400104',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14150,43,'Borivali East','400066',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14151,43,'Borivali H.O','400091',1,0,'2022-03-03 12:25:43','2022-03-03 12:25:43'),(14152,43,'Borivali West','400092',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14153,43,'Charkop','400067',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14154,43,'Dahisar RS','400068',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14155,43,'Dahisar','400068',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14156,43,'Daulat Nagar (Mumbai)','400066',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14157,43,'Goregaon East','400063',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14158,43,'Goregaon RS','400104',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14159,43,'Goregaon (Mumbai)','400104',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14160,43,'Ins Hamla','400095',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14161,43,'Jogeshwari East','400060',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14162,43,'Jogeshwari West','400102',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14163,43,'Kandivali East','400101',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14164,43,'Kandivali RS','400067',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14165,43,'Kandivali West','400067',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14166,43,'Ketkipada','400068',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14167,43,'Kharodi','400095',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14168,43,'Liberty Garden','400064',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14169,43,'Magthane','400066',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14170,43,'Malad East','400097',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14171,43,'Malad','400064',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14172,43,'Malad West Dely','400064',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14173,43,'Mandapeshwar','400103',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14174,43,'Motilal Nagar','400104',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14175,43,'Nagari Niwara','400065',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14176,43,'Orlem','400064',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14177,43,'Oshiwara','400102',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14178,43,'Rajendra Nagar (Mumbai)','400066',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14179,43,'Rani Sati Marg','400097',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14180,43,'S R P F Camp','400065',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14181,43,'S. K.Nagar','400066',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14182,43,'Sharma Estate','400063',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14183,43,'Ambewadi (Mumbai)','400004',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14184,43,'Asvini','400005',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14185,43,'Bazargate','400001',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14186,43,'Central Building','400020',1,0,'2022-03-03 12:25:44','2022-03-03 12:25:44'),(14187,43,'Charni Road','400004',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14188,43,'Chaupati','400004',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14189,43,'Churchgate','400020',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14190,43,'Colaba Bazar','400005',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14191,43,'Colaba','400005',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14192,43,'Girgaon','400004',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14193,43,'High Court Building (Mumbai)','400032',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14194,43,'Holiday Camp','400005',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14195,43,'Kalbadevi H.O','400002',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14196,43,'M.P.T.','400001',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14197,43,'Madhavbaug','400004',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14198,43,'Mantralaya (Mumbai)','400032',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14199,43,'Marine Lines','400020',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14200,43,'Nariman Point','400021',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14201,43,'New Yogakshema','400021',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14202,43,'Opera House','400004',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14203,43,'Ramwadi','400002',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14204,43,'S. C. Court','400002',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14205,43,'Secretariate','400032',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14206,43,'Stock Exchange','400001',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14207,43,'Tajmahal','400001',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14208,43,'Thakurdwar','400002',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14209,43,'Town Hall (Mumbai)','400001',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14210,43,'V.W.T.C.','400005',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14211,43,'Agripada','400011',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14212,43,'Bharat Nagar (Mumbai)','400007',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14213,43,'Bhawani Shankar Rd','400028',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14214,43,'Bhawani Shankar','400028',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14215,43,'BPC  Jacob Circle','400011',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14216,43,'Century Mill','400030',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14217,43,'Chinchpokli','400011',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14218,43,'Cumballa Hill','400026',1,0,'2022-03-03 12:25:45','2022-03-03 12:25:45'),(14219,43,'Cumballa Sea Face','400026',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14220,43,'Delisle Road','400013',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14221,43,'Dharavi Road','400017',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14222,43,'Dharavi','400017',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14223,43,'Dr Deshmukh Marg','400026',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14224,43,'Falkland Road','400008',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14225,43,'Gokhale Road (Mumbai)','400028',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14226,43,'Gowalia Tank','400026',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14227,43,'Grant Road','400007',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14228,43,'Haines Road','400011',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14229,43,'Haji Ali','400034',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14230,43,'J.J.Hospital','400008',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14231,43,'Jacob Circle','400011',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14232,43,'Kamathipura','400008',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14233,43,'Kapad Bazar','400016',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14234,43,'M A Marg','400008',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14235,43,'Mahim Bazar','400016',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14236,43,'Mahim East','400016',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14237,43,'Mahim H.O','400016',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14238,43,'Malabar Hill','400006',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14239,43,'Mori Road','400016',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14240,43,'Mumbai Central H.O','400008',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14241,43,'N.S.Patkar Marg','400007',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14242,43,'New Prabhadevi Road','400025',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14243,43,'Prabhadevi','400025',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14244,43,'Rajbhavan (Mumbai)','400035',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14245,43,'Ranade Road','400028',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14246,43,'S V Marg','400007',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14247,43,'S V S Marg','400028',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14248,43,'Shivaji Park (Mumbai)','400028',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14249,43,'Tardeo','400007',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14250,43,'Tulsiwadi','400034',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14251,43,'Worli Colony','400030',1,0,'2022-03-03 12:25:46','2022-03-03 12:25:46'),(14252,43,'Worli Naka','400018',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14253,43,'Worli Police Camp','400030',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14254,43,'Worli','400018',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14255,43,'Worli Sea Face','400030',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14256,43,'Mumbai G.P.O.','400001',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14257,44,'Abhyankar Nagar','440010',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14258,44,'Ajni','440003',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14259,44,'Ayodhya Nagar','440024',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14260,44,'Bagadganj','440008',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14261,44,'BESA Road','440037',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14262,44,'Bezonbagh','440014',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14263,44,'Borgaon Road','440013',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14264,44,'Bureau Of Mines','440001',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14265,44,'C.R.P.F. Nagpur','440019',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14266,44,'Coal Estate','440001',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14267,44,'Congress Nagar (Nagpur)','440012',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14268,44,'Dhantoli','440012',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14269,44,'Dighori Naka','440024',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14270,44,'Dr.Ambedkar Marg','440017',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14271,44,'Ganjipeth','440018',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14272,44,'Giripeth','440010',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14273,44,'Gokulpeth','440010',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14274,44,'Hanuman Nagar','440024',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14275,44,'Hitavada','440012',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14276,44,'Imamwada','440003',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14277,44,'Jaitala','440036',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14278,44,'Jaripatka','440014',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14279,44,'Kalmna Market Yard','440035',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14280,44,'Kasturchand Park','440001',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14281,44,'Katolroad','440013',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14282,44,'Khamla','440025',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14283,44,'Khare Town','440010',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14284,44,'Laxmi Nagar (Nagpur)','440022',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14285,44,'Mahal (Nagpur)','440032',1,0,'2022-03-03 12:25:47','2022-03-03 12:25:47'),(14286,44,'Mahatma Fule Bazar','440018',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14287,44,'Manewada Road','440024',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14288,44,'Mankapur (Nagpur)','440030',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14289,44,'Medical College (Nagpur)','440003',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14290,44,'Mhalginagar','440034',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14291,44,'Mohan Nagar (Nagpur)','440001',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14292,44,'Mominpura','440018',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14293,44,'Nadt Campus','440030',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14294,44,'Nagpur Airport','440005',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14295,44,'Nagpur City H.O','440002',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14296,44,'Nagpur GPO','440001',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14297,44,'Nandavan Colony','440024',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14298,44,'Narendra Nagar (Nagpur)','440015',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14299,44,'Nayapura','440002',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14300,44,'Neeri','440020',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14301,44,'Netaji Market','440012',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14302,44,'Panchsheel Nagar','440017',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14303,44,'Parvati Nagar','440027',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14304,44,'Patwardhan Ground','440012',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14305,44,'Raje Raghujinagar','440024',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14306,44,'Ranapratap Nagar','440022',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14307,44,'Ravi Nagar','440001',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14308,44,'Sadar Bazar (Nagpur)','440001',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14309,44,'Samartha Nagar','440015',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14310,44,'Seminary Hills','440006',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14311,44,'Shankar Nagar','440010',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14312,44,'Shradhananpeth','440022',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14313,44,'Sitabuldi','440012',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14314,44,'SRPF','440016',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14315,44,'Trimurti Nagar','440022',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14316,44,'Ujwal Nagar (Nagpur)','440025',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14317,44,'University Campus (Nagpur)','440033',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14318,44,'Uppalwadi','440026',1,0,'2022-03-03 12:25:48','2022-03-03 12:25:48'),(14319,44,'V R C E','440010',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14320,44,'Vayusena Nagar','440007',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14321,44,'Vishwakarma Nagar','440027',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14322,44,'Vivekanand Nagar','440015',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14323,44,'A.D. Project','440021',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14324,44,'Adam','441210',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14325,44,'Adasa','441107',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14326,44,'Adegaon','440023',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14327,44,'Adyar Dupache','441201',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14328,44,'Ajni','441401',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14329,44,'Ambadi','441202',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14330,44,'Ambhora','441210',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14331,44,'Amgaon Deori','441110',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14332,44,'Aptur','441203',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14333,44,'Aroli','441106',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14334,44,'Ashta','441108',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14335,44,'Babdeo','441106',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14336,44,'Badegaon','441101',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14337,44,'Bamhni','441501',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14338,44,'Bamhni','441203',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14339,44,'Bazargaon','440023',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14340,44,'Bela','441108',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14341,44,'Belda','441401',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14342,44,'Belona','441304',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14343,44,'Besur','441214',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14344,44,'Bhagwanpur','441203',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14345,44,'Bhandarbodi','441106',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14346,44,'Bhandewadi','440035',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14347,44,'Bharsingi','441305',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14348,44,'Bhishnoor','441305',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14349,44,'Bhiwapur','441201',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14350,44,'Bhondewada','441106',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14351,44,'Bhugaon','441104',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14352,44,'Bichwa','441101',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14353,44,'Bina','441102',1,0,'2022-03-03 12:25:49','2022-03-03 12:25:49'),(14354,44,'Borda','441401',1,0,'2022-03-03 12:25:50','2022-03-03 12:25:50'),(14355,44,'Bori (Nagpur)','441108',1,0,'2022-03-03 12:25:50','2022-03-03 12:25:50'),(14356,44,'Borkhedi','441108',1,0,'2022-03-03 12:25:50','2022-03-03 12:25:50'),(14357,44,'Chacher','441106',1,0,'2022-03-03 12:25:50','2022-03-03 12:25:50'),(14358,44,'Champa','441113',1,0,'2022-03-03 12:25:50','2022-03-03 12:25:50'),(14359,44,'Champa','441204',1,0,'2022-03-03 12:25:50','2022-03-03 12:25:50'),(14360,44,'Channa','441210',1,0,'2022-03-03 12:25:50','2022-03-03 12:25:50'),(14361,44,'Chapegadi','441202',1,0,'2022-03-03 12:25:50','2022-03-03 12:25:50'),(14362,44,'Chirwa','441104',1,0,'2022-03-03 12:25:50','2022-03-03 12:25:50'),(14363,44,'Dahegaon Joshi','441105',1,0,'2022-03-03 12:25:50','2022-03-03 12:25:50'),(14364,44,'Dahegaon Rangari','441113',1,0,'2022-03-03 12:25:50','2022-03-03 12:25:50'),(14365,44,'Datewadi','441301',1,0,'2022-03-03 12:25:50','2022-03-03 12:25:50'),(14366,44,'Dattawadi','440023',1,0,'2022-03-03 12:25:50','2022-03-03 12:25:50'),(14367,44,'Dawha','441203',1,0,'2022-03-03 12:25:50','2022-03-03 12:25:50'),(14368,44,'Dawlameti','440023',1,0,'2022-03-03 12:25:50','2022-03-03 12:25:50'),(14369,44,'Dawsa','441301',1,0,'2022-03-03 12:25:50','2022-03-03 12:25:50'),(14370,44,'Deolapar','441401',1,0,'2022-03-03 12:25:50','2022-03-03 12:25:50'),(14371,44,'Deoli Kalan','441202',1,0,'2022-03-03 12:25:50','2022-03-03 12:25:50'),(14372,44,'Deoli Kalbande','440023',1,0,'2022-03-03 12:25:50','2022-03-03 12:25:50'),(14373,44,'Dhamna','440023',1,0,'2022-03-03 12:25:50','2022-03-03 12:25:50'),(14374,44,'Dhanla','441104',1,0,'2022-03-03 12:25:50','2022-03-03 12:25:50'),(14375,44,'Dhapewada','441501',1,0,'2022-03-03 12:25:50','2022-03-03 12:25:50'),(14376,44,'Dhawlapur','441302',1,0,'2022-03-03 12:25:50','2022-03-03 12:25:50'),(14377,44,'Dighori Kale','441202',1,0,'2022-03-03 12:25:50','2022-03-03 12:25:50'),(14378,44,'Digras BK','441305',1,0,'2022-03-03 12:25:50','2022-03-03 12:25:50'),(14379,44,'Dodma','441202',1,0,'2022-03-03 12:25:50','2022-03-03 12:25:50'),(14380,44,'Dongargaon','441108',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14381,44,'Donger Mauda','441210',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14382,44,'Dorli Bhandwalkar','441306',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14383,44,'Dorli Bhingare','441502',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14384,44,'Dudhala','441103',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14385,44,'Dudhala','441106',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14386,44,'Fegad','441210',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14387,44,'Fetri','441501',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14388,44,'Gaimukh Nanda','441107',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14389,44,'Ghorad','441501',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14390,44,'Godhani','441203',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14391,44,'Godhani','441123',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14392,44,'Gohna','441210',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14393,44,'Gondegaon','441404',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14394,44,'Gondkhairi','440023',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14395,44,'Gothangaon','441210',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14396,44,'Gowri','441104',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14397,44,'Gumgaon','441122',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14398,44,'Gumthala','441104',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14399,44,'Gumthi','441111',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14400,44,'Hingna Barabhai','441102',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14401,44,'Hingna','441110',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14402,44,'Hiwra Bazar','441401',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14403,44,'Hiwra Hiwri','441214',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14404,44,'Indl.Area Nagpur','440016',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14405,44,'Indora','441106',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14406,44,'Industrial Area Butibori','441122',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14407,44,'Isapur Khurd','441302',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14408,44,'Itgaon','441105',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14409,44,'Jalalkheda','441301',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14410,44,'Jamgaon BK','441305',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14411,44,'Jaoli','441201',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14412,44,'Jiwnapur','441210',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14413,44,'Kachari Sawanga','441103',1,0,'2022-03-03 12:25:51','2022-03-03 12:25:51'),(14414,44,'Kachurwahi','441106',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14415,44,'Kalambi','441501',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14416,44,'Kalamna','441204',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14417,44,'Kalmeshwar','441501',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14418,44,'Kamthi City SO','441001',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14419,44,'Kamthi Colliery','441404',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14420,44,'Kamthi H.O','441001',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14421,44,'Kandri','441401',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14422,44,'Kanhan Pipri','441401',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14423,44,'Kanholibara','441110',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14424,44,'Kapsi BK','440035',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14425,44,'Kargaon','441203',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14426,44,'Karwahi','441401',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14427,44,'Katol','441302',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14428,44,'Kavikulguru Nagar','441106',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14429,44,'Kawdas','441110',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14430,44,'Kelod','441112',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14431,44,'Khairgaon','441303',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14432,44,'Khairi Akashwani','440026',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14433,44,'Khairi Bijewada','441106',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14434,44,'Khairi Dhalgaon','441112',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14435,44,'Khandala','441105',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14436,44,'Khangaon','441107',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14437,44,'Khangaon','441302',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14438,44,'Khapa Ghudan','441305',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14439,44,'Khapa','441101',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14440,44,'Khaperkheda','441102',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14441,44,'Khapri','441108',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14442,44,'Kharbadi','441301',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14443,44,'Kharsoli','441304',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14444,44,'Khat','441106',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14445,44,'Khubala','441101',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14446,44,'Khumari','441401',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14447,44,'Khursapar','441103',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14448,44,'Kodamendhi','441106',1,0,'2022-03-03 12:25:52','2022-03-03 12:25:52'),(14449,44,'Kodegaon','441101',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14450,44,'Kohli','441502',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14451,44,'Kondhali','441103',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14452,44,'Koradi Tps','441111',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14453,44,'Kothurna','441101',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14454,44,'Kuhi','441202',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14455,44,'Kujba','441210',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14456,44,'Ladgaon','441302',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14457,44,'Lava','440023',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14458,44,'Lohari Sawanga','441305',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14459,44,'Lohgad','441302',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14460,44,'Lonkhairi','441111',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14461,44,'Mahadula (Ramtek)','441106',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14462,44,'Mahalgaon','441214',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14463,44,'Mahuli','441105',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14464,44,'Mahurzari','441501',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14465,44,'Makardhokda','441203',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14466,44,'Malegaon','441107',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14467,44,'Malewada','441201',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14468,44,'Mandhal','441210',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14469,44,'Manegaon Tek','441401',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14470,44,'Mangrud','441203',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14471,44,'Mangsa','441112',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14472,44,'Mansar','441401',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14473,44,'Marni','441202',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14474,44,'Marodi','441104',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14475,44,'Masod','441103',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14476,44,'Masora','441306',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14477,44,'Mathni','441104',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14478,44,'Matkazari','441204',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14479,44,'Mauda','441104',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14480,44,'Maywadi','441305',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14481,44,'Menda','441201',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14482,44,'Mendhala','441301',1,0,'2022-03-03 12:25:53','2022-03-03 12:25:53'),(14483,44,'Mendhepathar','441302',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14484,44,'Metpanjra','441302',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14485,44,'Midc Kalmeshwar','441501',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14486,44,'MIDC Nagpur','440016',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14487,44,'Mohadi Dalvi','441304',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14488,44,'Mohgaon','441110',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14489,44,'Mohgaon Bhadade','441306',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14490,44,'Mohpa','441502',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14491,44,'Mokhebardi','441201',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14492,44,'Mondha','441110',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14493,44,'Morgaon','441106',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14494,44,'Mowad','441303',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14495,44,'Murti','441302',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14496,44,'Musalgaon','441202',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14497,44,'Musewadi','441106',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14498,44,'Nagalwadi','441101',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14499,44,'Nagardhan','441106',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14500,44,'Nand','441203',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14501,44,'Narkher','441304',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14502,44,'Narsala','440034',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14503,44,'Navegaon Chinchghat','441202',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14504,44,'Navegaon Isapur','441202',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14505,44,'Navegaon Khairi','441105',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14506,44,'Navegaon Sadhu','441203',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14507,44,'Naxi','441201',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14508,44,'Nayakund','441105',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14509,44,'Niharwani','441104',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14510,44,'Nimkheda','441106',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14511,44,'Pachgaon','441204',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14512,44,'Pachkhedi','441210',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14513,44,'Padri Thana','441108',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14514,44,'Pahani Chinchala','441203',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14515,44,'Paradsinga','441305',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14516,44,'Pardi Deshmukh','441502',1,0,'2022-03-03 12:25:54','2022-03-03 12:25:54'),(14517,44,'Parseoni','441105',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14518,44,'Patansaongi','441113',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14519,44,'Patharai','441401',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14520,44,'Pauni','441401',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14521,44,'Pipariya','441401',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14522,44,'Pipla','440034',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14523,44,'Pipla Dakbanglow','441113',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14524,44,'Pipla Kewalram','441306',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14525,44,'Pipla Kinkhede','441502',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14526,44,'Pipra','441108',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14527,44,'Rajola','441202',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14528,44,'Rama','441108',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14529,44,'Ramtek','441106',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14530,44,'Ramthi','441301',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14531,44,'Ranala','441401',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14532,44,'Raulgaon','441502',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14533,44,'Rewral','441401',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14534,44,'Ridhora','441108',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14535,44,'Ridhora','441103',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14536,44,'Rohna','441305',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14537,44,'Rui','441108',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14538,44,'Salaidhabha','441122',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14539,44,'Salaigodhni','441204',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14540,44,'Salva','441202',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14541,44,'Salwa','441401',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14542,44,'Saoner','441107',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14543,44,'Satak','441106',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14544,44,'Sawangi Asola','441108',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14545,44,'Sawargaon','441306',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14546,44,'Seo','441203',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14547,44,'Seoni','441106',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14548,44,'Shirpur','441203',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14549,44,'Shiwa Sawanga','440023',1,0,'2022-03-03 12:25:55','2022-03-03 12:25:55'),(14550,44,'Shiwapur','441203',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14551,44,'Sillewara Project','441109',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14552,44,'Silli','441202',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14553,44,'Sindhi Umri','441306',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14554,44,'Sirsi Navegaon','441210',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14555,44,'Sirsi (Nagpur)','441214',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14556,44,'Sonoli','441306',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14557,44,'Surgaon','441204',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14558,44,'Takalghat','441122',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14559,44,'Takli Bhansali','441113',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14560,44,'Tamaswadi','441102',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14561,44,'Tangla','441401',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14562,44,'Tarna','441203',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14563,44,'Tarsa','441106',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14564,44,'Tas','441201',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14565,44,'Tekepar','441210',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14566,44,'Telgaon','441107',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14567,44,'Telkamathi','441107',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14568,44,'Temsana','441202',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14569,44,'Thadipauni','441301',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14570,44,'Thaturwada','441305',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14571,44,'Thugaon Deo','441301',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14572,44,'Thutanbori','441201',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14573,44,'Tinkheda','441304',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14574,44,'Titur','441202',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14575,44,'Ubali','441501',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14576,44,'Udasa','441204',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14577,44,'Umred Bazar','441203',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14578,44,'Umred Project','441204',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14579,44,'Umred','441203',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14580,44,'Umri','441107',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14581,44,'Umri Wagh','440023',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14582,44,'Ungaon','441104',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14583,44,'Uparwahi','441501',1,0,'2022-03-03 12:25:56','2022-03-03 12:25:56'),(14584,44,'Veltur','441210',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14585,44,'Vihirgaon','441204',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14586,44,'Virkhandi','441201',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14587,44,'Vyahad Bzk','440023',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14588,44,'Wadamba','441401',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14589,44,'Waddhamna','440023',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14590,44,'Wadi (Nagpur)','440023',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14591,44,'Wadoda','441104',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14592,44,'Wagh','441210',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14593,44,'Waghoda','441107',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14594,44,'Waki','441113',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14595,44,'Wakodi','441101',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14596,44,'Walni','441501',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14597,44,'Walni Colliery','441102',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14598,44,'Wanadongri','441110',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14599,44,'Yenikoni','441306',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14600,44,'Yenwa','441302',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14601,44,'Yerla (Dhote)','441305',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14602,44,'Zilpa','441302',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14603,45,'Adampur','431736',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14604,45,'Adgaon','431708',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14605,45,'Aithala','431808',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14606,45,'Alandi','431736',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14607,45,'Alur','431723',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14608,45,'Ambadi','431804',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14609,45,'Ambulga','431714',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14610,45,'Ambulga','431715',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14611,45,'Andbori','431811',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14612,45,'Andbori','431803',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14613,45,'Anjankhed','431721',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14614,45,'Anmal','431721',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14615,45,'Apparaopeth','431803',1,0,'2022-03-03 12:25:57','2022-03-03 12:25:57'),(14616,45,'Ardhapur','431704',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14617,45,'Arjapur','431711',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14618,45,'Arli','431710',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14619,45,'Ashoknagar (Nanded)','431605',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14620,45,'Ashta','431721',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14621,45,'Ashti','431712',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14622,45,'Ashtoor','431708',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14623,45,'Asoli','431721',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14624,45,'Asrjan','431606',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14625,45,'Atkali','431736',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14626,45,'Bachoti','431714',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14627,45,'Bahadarpura','431714',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14628,45,'Balegaon','431807',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14629,45,'Ballur','431717',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14630,45,'Bamni','431710',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14631,45,'Banchincholi','431712',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14632,45,'Barad','431745',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14633,45,'Baradshewala','431712',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14634,45,'Barahali','431715',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14635,45,'Barasgaon','431745',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14636,45,'Barbada','431602',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14637,45,'Barul','431746',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14638,45,'Bdur','431710',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14639,45,'Belkoni','431710',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14640,45,'Belkoni BK','431710',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14641,45,'Bembari','431801',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14642,45,'Bendi','431811',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14643,45,'Berli','431708',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14644,45,'Berli BK','431715',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14645,45,'Betmogara','431715',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14646,45,'Betsangavi','431708',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14647,45,'Bhategaon','431743',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14648,45,'Bhayegaon','431717',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14649,45,'Bhendegaon KH','431715',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14650,45,'Bhishi','431803',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14651,45,'Bhokar','431801',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14652,45,'Bhorad','431721',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14653,45,'Bhoshi','431745',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14654,45,'Bhutan Hiparga','431741',1,0,'2022-03-03 12:25:58','2022-03-03 12:25:58'),(14655,45,'Bijegaon','431807',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14656,45,'Bijur','431736',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14657,45,'Bilali','431715',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14658,45,'Biloli','431710',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14659,45,'Bitnal','431807',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14660,45,'Bodhadi KH','431810',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14661,45,'Bodhadi','431810',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14662,45,'Bolka','431742',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14663,45,'Bolsa','431807',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14664,45,'Bolsa','431808',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14665,45,'Bomnali','431715',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14666,45,'Bondgavan','431805',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14667,45,'Bori BK','431714',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14668,45,'Bothi','431807',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14669,45,'Chabhara','431704',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14670,45,'Chaitanynagar Nanded ','431605',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14671,45,'Chandola','431715',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14672,45,'Chauphala','431604',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14673,45,'Chikana','431808',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14674,45,'Chikhala','431806',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14675,45,'Chikhali','431746',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14676,45,'Chikhali','431803',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14677,45,'Chikhli','431811',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14678,45,'Chinchala','431710',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14679,45,'Chinchgavan','431712',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14680,45,'Chinchkhed','431805',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14681,45,'Chincholi','431809',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14682,45,'Chondi','431717',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14683,45,'Choramba','431712',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14684,45,'Chuncha','431712',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14685,45,'Cidco Nanded','431603',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14686,45,'Dabhad','431745',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14687,45,'Dagadgaon','431708',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14688,45,'Dahegaon','431811',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14689,45,'Daheli','431805',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14690,45,'Dahelitanda','431805',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14691,45,'Dahikalamba','431707',1,0,'2022-03-03 12:25:59','2022-03-03 12:25:59'),(14692,45,'Dapaka G','431715',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14693,45,'Dapka Raja','431716',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14694,45,'Daregaon','431806',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14695,45,'Darsangvi','431811',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14696,45,'Darsangvi','431805',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14697,45,'Dattamanjari','431721',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14698,45,'Degaon','431719',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14699,45,'Degaon','431709',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14700,45,'Degaon BK','431717',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14701,45,'Degloor','431717',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14702,45,'Degloor Town','431717',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14703,45,'Delub','431704',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14704,45,'Deoshi','431801',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14705,45,'Deothana','431801',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14706,45,'Dhanegaon','431603',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14707,45,'Dhanora','431801',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14708,45,'Dhanora','431808',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14709,45,'Dhanora','431810',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14710,45,'Dhanora','431709',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14711,45,'Dhanora','431708',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14712,45,'Dharmabad','431809',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14713,45,'Dhoki','431602',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14714,45,'Digdi','431804',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14715,45,'Digras','431713',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14716,45,'Digras','431742',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14717,45,'Dogargaon','431810',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14718,45,'Dongaon','431806',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14719,45,'Dongaon KH','431710',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14720,45,'Dongargaon','431708',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14721,45,'Dudhad','431802',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14722,45,'Dugaon','431809',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14723,45,'Dundara','431805',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14724,45,'Ekalara','431717',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14725,45,'Gadga','431722',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14726,45,'Gaglegaon','431809',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14727,45,'Gaul','431714',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14728,45,'Ghodaj','431714',1,0,'2022-03-03 12:26:00','2022-03-03 12:26:00'),(14729,45,'Ghogari','431713',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14730,45,'Ghoti','431804',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14731,45,'Ghungarala','431709',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14732,45,'Gojegaon','431718',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14733,45,'Gokunda','431811',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14734,45,'Golegaon','431714',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14735,45,'Golegaon','431807',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14736,45,'Golegaon','431731',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14737,45,'Gonar','431714',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14738,45,'Gondegaon','431721',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14739,45,'Gondjavli','431803',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14740,45,'Gondmahagaon','431803',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14741,45,'Gondwadsa','431721',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14742,45,'Gorlegaon','431712',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14743,45,'Gortha','431807',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14744,45,'Guntur','431742',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14745,45,'Hadgaon','431712',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14746,45,'Hadoli','431742',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14747,45,'Hadoli J','431714',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14748,45,'Hadsani','431721',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14749,45,'Halda','431801',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14750,45,'Halda','431746',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14751,45,'Halli','431718',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14752,45,'Halni','431719',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14753,45,'Hanegaon','431741',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14754,45,'Hardaf','431712',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14755,45,'Hardaf','431721',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14756,45,'Hastara','431743',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14757,45,'Hatral','431715',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14758,45,'Hawarga','431717',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14759,45,'Himayatnagar','431802',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14760,45,'Hingani','431721',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14761,45,'Honwadaj','431715',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14762,45,'Hottal','431717',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14763,45,'Hungunda','431711',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14764,45,'Hussa','431809',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14765,45,'Iregaon','431803',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14766,45,'Islapur','431803',1,0,'2022-03-03 12:26:01','2022-03-03 12:26:01'),(14767,45,'Itwara Nanded','431604',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14768,45,'Ivaleshwar','431721',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14769,45,'Jahur','431715',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14770,45,'Jaldhara','431810',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14771,45,'Jamb B K','431716',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14772,45,'Jambhala','431713',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14773,45,'Jarikot','431808',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14774,45,'Jarur','431805',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14775,45,'Jawalgaon','431802',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14776,45,'Jawarala','431805',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14777,45,'Joshisangavi','431707',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14778,45,'Kahala','431709',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14779,45,'Kakandi','431602',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14780,45,'Kalambar','431746',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14781,45,'Kalambar','431715',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14782,45,'Kamari','431802',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14783,45,'Kamjalga','431716',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14784,45,'Kamtha','431704',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14785,45,'Kamthala','431804',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14786,45,'Kanchali','431803',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14787,45,'Kandali','431713',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14788,45,'Kandali KH','431801',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14789,45,'Kandhar','431714',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14790,45,'Kangti','431809',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14791,45,'Kanki','431805',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14792,45,'Kapsi','431602',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14793,45,'Karala','431807',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14794,45,'Karala Kalam','431710',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14795,45,'Karanji','431805',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14796,45,'Kardkhed','431718',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14797,45,'Karegaon','431708',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14798,45,'Karimabad Nanded','431604',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14799,45,'Karkheli','431808',1,0,'2022-03-03 12:26:02','2022-03-03 12:26:02'),(14800,45,'Kasarali','431736',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14801,45,'Kasarkheda','431704',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14802,45,'Kasrali','431710',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14803,45,'Katkalamba','431746',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14804,45,'Kaudgaon','431602',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14805,45,'Kautha','431746',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14806,45,'Kawalgaon','431718',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14807,45,'Kawana','431712',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14808,45,'Kerur','431715',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14809,45,'Khadki','431802',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14810,45,'Khambala','431805',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14811,45,'Khanapur','431717',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14812,45,'Kharbkhandgaon','431715',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14813,45,'Khatgaon','431736',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14814,45,'Khndgaon','431722',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14815,45,'Khtgaon','431719',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14816,45,'Kinala','431736',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14817,45,'Kini','431801',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14818,45,'Kinwat','431804',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14819,45,'Kiwala','431707',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14820,45,'Koklegaon','431741',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14821,45,'Koklegaon','431709',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14822,45,'Kolahari','431803',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14823,45,'Kolambi','431722',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14824,45,'Kolheborgaon','431710',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14825,45,'Koli','431743',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14826,45,'Kopara','431810',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14827,45,'Kosmet','431803',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14828,45,'Kothari','431805',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14829,45,'Kothari','431811',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14830,45,'Krushnur','431709',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14831,45,'Kundalwadi','431711',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14832,45,'Kundarala','431715',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14833,45,'Kunmarpalli','431741',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14834,45,'Kuntur','431709',1,0,'2022-03-03 12:26:03','2022-03-03 12:26:03'),(14835,45,'Kupati','431803',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14836,45,'Kupati','431804',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14837,45,'Kurula','431742',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14838,45,'Laghul','431710',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14839,45,'Laglud','431801',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14840,45,'Lahan','431704',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14841,45,'Lakhamapur','431721',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14842,45,'Lakshminar','431605',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14843,45,'Limbgaon','431602',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14844,45,'Lingi','431805',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14845,45,'Loha','431713',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14846,45,'Loha','431708',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14847,45,'Lohgaon','431710',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14848,45,'Lohrala','431708',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14849,45,'Loni','431741',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14850,45,'Loni','431804',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14851,45,'Loni','431704',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14852,45,'Machandrapardi','431721',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14853,45,'Machnur','431711',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14854,45,'Madnapur','431721',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14855,45,'Mahore (Nanded)','431721',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14856,45,'Malakaguda','431721',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14857,45,'Malakjamb','431803',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14858,45,'Malakoli','431708',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14859,45,'Malborgaon','431804',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14860,45,'Malegaon','431708',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14861,45,'Malegaon Makata','431718',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14862,45,'Malegaon','431750',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14863,45,'Malkapur','431804',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14864,45,'Malkautha','431806',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14865,45,'Manatha','431712',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14866,45,'Mandhava','431804',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14867,45,'Mandvi (Nanded)','431805',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14868,45,'Mangalsangavi','431746',1,0,'2022-03-03 12:26:04','2022-03-03 12:26:04'),(14869,45,'Mangnali','431809',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14870,45,'Mangrul','431802',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14871,45,'Manjram','431722',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14872,45,'Manoor','431807',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14873,45,'Manoor','431709',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14874,45,'Manur','431741',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14875,45,'Maralak','431605',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14876,45,'Maratala','431602',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14877,45,'Maregaon','431804',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14878,45,'Markhel','431718',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14879,45,'Martoli','431718',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14880,45,'Marwali','431722',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14881,45,'Matul','431801',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14882,45,'Mendka','431806',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14883,45,'MIDC','431603',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14884,45,'Millgate Nanded','431601',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14885,45,'Moghali','431801',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14886,45,'Mohapur','431804',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14887,45,'Motarga','431717',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14888,45,'Mudkhed Station','431806',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14889,45,'Mugaon','431722',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14890,45,'Mugat','431806',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14891,45,'Mukaramabad','431719',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14892,45,'Mukhed','431715',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14893,45,'Mulzara','431803',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14894,45,'Mungashi','431804',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14895,45,'Nagapur','431805',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14896,45,'Nagzari','431804',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14897,45,'Naigaon (Nanded)','431709',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14898,45,'Nanded H.O','431601',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14899,45,'Nanded Town','431601',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14900,45,'Nandgaon Tanda','431803',1,0,'2022-03-03 12:26:05','2022-03-03 12:26:05'),(14901,45,'Nandur','431723',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14902,45,'Nandusa','431704',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14903,45,'Narangal','431723',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14904,45,'Narsi','431709',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14905,45,'Navandi','431722',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14906,45,'Nayamondha Nanded','431602',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14907,45,'Nehrunagar','431742',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14908,45,'Nerli','431605',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14909,45,'Newgha','431806',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14910,45,'Nichpur','431804',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14911,45,'Nimgaon','431704',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14912,45,'Nirala','431805',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14913,45,'Niwagha','431743',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14914,45,'Osmannagar (Nanded)','431707',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14915,45,'P. Sawargaon','431716',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14916,45,'Padsa','431721',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14917,45,'Pala','431715',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14918,45,'Palaj','431801',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14919,45,'Palsa','431712',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14920,45,'Palsi','431805',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14921,45,'Panbhoshi','431714',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14922,45,'Pandhara','431804',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14923,45,'Pandhurana','431801',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14924,45,'Pangara','431714',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14925,45,'Panshewadi','431714',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14926,45,'Papalwadi','431721',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14927,45,'Pardi KH','431810',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14928,45,'Pardi Makata','431704',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14929,45,'Paroti','431803',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14930,45,'Patharad','431713',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14931,45,'Pathari','431805',1,0,'2022-03-03 12:26:06','2022-03-03 12:26:06'),(14932,45,'Patoda','431805',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14933,45,'Patoda','431709',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14934,45,'Patoda','431811',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14935,45,'Pawana','431802',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14936,45,'Penoor','431708',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14937,45,'Pethwadj','431714',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14938,45,'Pewa','431743',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14939,45,'Phulwal','431714',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14940,45,'Pimpalgaon','431711',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14941,45,'Pimpalgaon','431805',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14942,45,'Pimpalgaon','431605',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14943,45,'Pimparkhed','431712',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14944,45,'Pota BK','431802',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14945,45,'Punegaon','431806',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14946,45,'Rahati','431602',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14947,45,'Raher','431809',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14948,45,'Raipurtanda','431805',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14949,45,'Raiwadi','431708',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14950,45,'Rajgad','431804',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14951,45,'Rajura BK','431715',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14952,45,'Ramtirth','431736',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14953,45,'Ratoli','431722',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14954,45,'Ravangaon','431715',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14955,45,'Ravankola','431719',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14956,45,'Ravi','431719',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14957,45,'Risangaon','431708',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14958,45,'Ritha','431810',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14959,45,'Rohipimpalgaon','431806',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14960,45,'Rui','431715',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14961,45,'Rui','431721',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14962,45,'Rui','431743',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14963,45,'Rui BK','431709',1,0,'2022-03-03 12:26:07','2022-03-03 12:26:07'),(14964,45,'Sachkhand Nanded','431601',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14965,45,'Sagroli','431731',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14966,45,'Saiphal','431721',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14967,45,'Sakrunail Tanda','431805',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14968,45,'Salegaon','431809',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14969,45,'Sangvi','431709',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14970,45,'Sarkhani','431805',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14971,45,'Sarsam','431802',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14972,45,'Sattiguda','431805',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14973,45,'Sawaleshwar','431746',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14974,45,'Sawali','431710',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14975,45,'Sawali','431718',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14976,45,'Sawana','431802',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14977,45,'Sawargaon','431810',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14978,45,'Sawargaon','431708',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14979,45,'Sawargaon','431712',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14980,45,'Sawarmal','431719',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14981,45,'Selgaon','431736',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14982,45,'Shahapur (Nanded)','431723',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14983,45,'Shankarnagar','431736',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14984,45,'Shekapur','431714',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14985,45,'Shelgaon','431807',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14986,45,'Shelgaon','431723',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14987,45,'Shemboli','431745',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14988,45,'Sheniwarpeth','431811',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14989,45,'Shewadi','431708',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14990,45,'Shewala','431723',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14991,45,'Shikara','431715',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14992,45,'Shilvani','431741',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14993,45,'Shirad','431743',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14994,45,'Shiradhone','431707',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14995,45,'Shiranjani','431802',1,0,'2022-03-03 12:26:08','2022-03-03 12:26:08'),(14996,45,'Shirur','431743',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(14997,45,'Shirur Dabhade','431715',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(14998,45,'Shivajinagar (Nanded)','431602',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(14999,45,'Shivani','431803',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15000,45,'Sindgi','431804',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15001,45,'Sindhi','431807',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15002,45,'Sindkhed','431805',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15003,45,'Singarwadi','431810',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15004,45,'Singoda','431805',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15005,45,'Somthana','431807',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15006,45,'Sonari','431801',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15007,45,'Sonkhed','431708',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15008,45,'SRTMU Nanded','431606',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15009,45,'Sugaon','431723',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15010,45,'Sugaon','431722',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15011,45,'Sujlegaon','431709',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15012,45,'Sunegaon','431708',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15013,45,'Tadkhel','431717',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15014,45,'Takali','431736',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15015,45,'Talang','431712',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15016,45,'Talani','431743',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15017,45,'Talegaon','431713',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15018,45,'Talegaon','431807',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15019,45,'Talhari','431803',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15020,45,'Talni','431710',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15021,45,'Tamlur','431723',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15022,45,'Tamsa','431713',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15023,45,'Taroda BK','431605',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15024,45,'Taroda Road Nanded','431605',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15025,45,'Telki','431707',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15026,45,'Tembhurni','431722',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15027,45,'Thadihiparga','431731',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15028,45,'Thara','431810',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15029,45,'Theraban','431801',1,0,'2022-03-03 12:26:09','2022-03-03 12:26:09'),(15030,45,'Totamba','431803',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15031,45,'Tulshi','431721',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15032,45,'Tuppa','431603',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15033,45,'Umara','431707',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15034,45,'Umaraj','431714',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15035,45,'Umardari','431715',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15036,45,'Umari','431805',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15037,45,'Umari','431807',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15038,45,'Umari(J)','431713',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15039,45,'Unakdev','431805',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15040,45,'Unchegaon','431743',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15041,45,'Unchegaon','431712',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15042,45,'Undari','431715',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15043,45,'Vasantnagar','431715',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15044,45,'Veersani','431802',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15045,45,'Vishnupuri','431606',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15046,45,'Wadepuri','431606',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15047,45,'Wadgaon','431715',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15048,45,'Wadi BK','431605',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15049,45,'Wadoli','431804',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15050,45,'Wadsa','431721',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15051,45,'Waghala','431807',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15052,45,'Waghi','431602',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15053,45,'Wai','431721',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15054,45,'Waipana','431713',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15055,45,'Wajegaon','431602',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15056,45,'Waka','431709',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15057,45,'Wakad','431745',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15058,45,'Walag','431718',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15059,45,'Walki','431712',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15060,45,'Walki','431803',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15061,45,'Wannali','431723',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15062,45,'Wanola','431804',1,0,'2022-03-03 12:26:10','2022-03-03 12:26:10'),(15063,45,'Wartala','431716',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15064,45,'Warwnt','431746',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15065,45,'Wasur','431715',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15066,45,'Wazar','431741',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15067,45,'Yeoti','431715',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15068,45,'Yeshwantnagar  Nanded','431602',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15069,45,'Yetala','431809',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15070,46,'Akkalkuwa','425415',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15071,46,'Ambapur','425409',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15072,46,'Amlad','425413',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15073,46,'Amoni','425413',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15074,46,'Anarad','425410',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15075,46,'Anjane','425417',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15076,46,'Ankushvihir','425415',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15077,46,'Arditara','425412',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15078,46,'Ashte','425412',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15079,46,'Aslod','425444',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15080,46,'Bahyane','425411',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15081,46,'Bamangaon','425419',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15082,46,'Bamkheda T.T.','425423',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15083,46,'Bandhare','425417',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15084,46,'Bhade','425409',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15085,46,'Bhadvad','425416',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15086,46,'Bhagdari','425452',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15087,46,'Bhaler','425412',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15088,46,'Bhandarpada','425426',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15089,46,'Bhangaranpani','425452',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15090,46,'Bharadu','425426',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15091,46,'Bhone','425412',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15092,46,'Bijari','425414',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15093,46,'Biladi T.S','425410',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15094,46,'Borad','425442',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15095,46,'Borale','425412',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15096,46,'Borchek','425416',1,0,'2022-03-03 12:26:11','2022-03-03 12:26:11'),(15097,46,'Brahmanpuri','425409',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15098,46,'Chandsaily','425444',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15099,46,'Chaupale','425411',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15100,46,'Chikhali','425414',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15101,46,'Chikhali-BK','425432',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15102,46,'Chinchpada','425417',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15103,46,'Chirkan','425444',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15104,46,'Chitvi','425426',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15105,46,'Chulvad','425414',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15106,46,'Dab','425452',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15107,46,'Damrkheda','425422',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15108,46,'Davlipada','425426',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15109,46,'Dhadgaon','425414',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15110,46,'Dhaite','425418',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15111,46,'Dhamdai','425412',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15112,46,'Dhanaje','425414',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15113,46,'Dhanarat','425418',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15114,46,'Dhaonra','425412',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15115,46,'Dhekwad','425412',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15116,46,'Dhong','425416',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15117,46,'Dhulwad','425412',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15118,46,'Dhurkheda','425409',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15119,46,'Dogegaon','425416',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15120,46,'Dongargaon','425424',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15121,46,'Fattepur','425432',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15122,46,'Fes','425423',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15123,46,'Gadat','425418',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15124,46,'Gangapur','425417',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15125,46,'Gavhali','425419',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15126,46,'Gogapur','425424',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15127,46,'Gujarbhavali','425412',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15128,46,'Haldani','425426',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15129,46,'Jainagar','425423',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15130,46,'Jamane','425415',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15131,46,'Javde-TB','425432',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15132,46,'Javde-TH','425444',1,0,'2022-03-03 12:26:12','2022-03-03 12:26:12'),(15133,46,'June Mohide','425412',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15134,46,'Kaharvad','425442',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15135,46,'Kahatul','425409',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15136,46,'Kakadkut','425419',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15137,46,'Kakarda','425423',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15138,46,'Kakarda','425414',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15139,46,'Kalamboo','425410',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15140,46,'Kalmadi','425409',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15141,46,'Kalsadi','425409',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15142,46,'Kansai','425432',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15143,46,'Karajkupa','425412',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15144,46,'Karanjali','425416',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15145,46,'Karanji-KH','425418',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15146,46,'Karjot','425444',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15147,46,'Katari','425414',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15148,46,'Kathi','425452',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15149,46,'Kavlith','425424',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15150,46,'Khadki','425416',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15151,46,'Khanapur','425426',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15152,46,'Khandbara','425416',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15153,46,'Khapar','425419',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15154,46,'Khekada','425418',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15155,46,'Khokse','425418',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15156,46,'Kholvohir','425416',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15157,46,'Khondamali','425412',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15158,46,'Khuntamodi','425414',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15159,46,'Kolda','425412',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15160,46,'Kolde','425417',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15161,46,'Kondhaval','425423',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15162,46,'Koparli','425411',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15163,46,'Korit','425412',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15164,46,'Kothali KH','425412',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15165,46,'Kudhavad','425432',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15166,46,'Kukavel','425423',1,0,'2022-03-03 12:26:13','2022-03-03 12:26:13'),(15167,46,'Lahan-shahada','425412',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15168,46,'Lakhapur','425442',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15169,46,'Lokadkot','425432',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15170,46,'Londhare','425409',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15171,46,'Lonkheda','425409',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15172,46,'Mandana','425444',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15173,46,'Mandvi-BK','425414',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15174,46,'Manjare','425411',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15175,46,'Mhasawad (Nandurbar)','425432',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15176,46,'M-mohida','425409',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15177,46,'Mod','425442',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15178,46,'Mograni','425416',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15179,46,'Mohida','425442',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15180,46,'Mohida TH','425409',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15181,46,'Molgi','425452',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15182,46,'Moramba','425419',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15183,46,'Mothi-kadvan','425416',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15184,46,'Mubarakpur','425409',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15185,46,'Mundalvad','425414',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15186,46,'Nagziri','425418',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15187,46,'Nandarkhe','425412',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15188,46,'Nandarkheda','425422',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15189,46,'Nandurbar Bazar','425412',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15190,46,'Nandurbar Kutchery','425412',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15191,46,'Nandurbar','425412',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15192,46,'Natavad','425412',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15193,46,'Navagaon','425418',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15194,46,'Navapur','425418',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15195,46,'Nizampur-digar','425416',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15196,46,'Pachorabari','425412',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15197,46,'Padalda','425409',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15198,46,'Palashi','425412',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15199,46,'Patibedaki','425417',1,0,'2022-03-03 12:26:14','2022-03-03 12:26:14'),(15200,46,'Patonda','425412',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15201,46,'Pimpalkutha','425452',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15202,46,'Pimplod','425412',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15203,46,'Pimpri','425432',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15204,46,'Prakasha','425422',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15205,46,'Pratappur','425413',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15206,46,'Purushottam Nagar','425424',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15207,46,'Radikalam','425414',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15208,46,'Raikhed','425409',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15209,46,'Raingaon','425418',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15210,46,'Raipur','425418',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15211,46,'Raisingpur','425419',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15212,46,'Raj Mohi','425415',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15213,46,'Rajabardi','425414',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15214,46,'Rajvira','425413',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15215,46,'Rampur','425432',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15216,46,'Ranala','425411',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15217,46,'Ranipur','425432',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15218,46,'Samsherpur','425412',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15219,46,'Sarangkheda','425410',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15220,46,'Shahada','425409',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15221,46,'Shahada Town','425409',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15222,46,'Shahane','425444',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15223,46,'Shegave','425416',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15224,46,'Shehi','425416',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15225,46,'Shelti','425409',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15226,46,'Shinde','425412',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15227,46,'Shirud-digar','425409',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15228,46,'Sidgavan','425412',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15229,46,'Sisa','425414',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15230,46,'Sonare Digar','425417',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15231,46,'Songirpada','425412',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15232,46,'Sonwad','425409',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15233,46,'Srawani','425416',1,0,'2022-03-03 12:26:15','2022-03-03 12:26:15'),(15234,46,'Sudarde Digar','425412',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15235,46,'Sulvade','425409',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15236,46,'Survani','425414',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15237,46,'Sutare','425412',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15238,46,'Talai','425414',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15239,46,'Talamba','425419',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15240,46,'Taloda','425413',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15241,46,'Talve','425442',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15242,46,'Thanepada','425412',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15243,46,'Toranmal','425432',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15244,46,'Torkheda','425423',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15245,46,'Tulja','425442',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15246,46,'Umarde-KH','425412',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15247,46,'Vadali (Nandurbar)','425423',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15248,46,'Vadfali','425452',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15249,46,'Vadfali','425426',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15250,46,'Vadgaon','425444',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15251,46,'Vanyavihir','425413',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15252,46,'Vardhe','425409',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15253,46,'Vasalai','425412',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15254,46,'Velli','425415',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15255,46,'Vikharan','425412',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15256,46,'Visarwadi','425426',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15257,46,'Waghale','425412',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15258,46,'Wavad','425411',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15259,47,'Abhona','423502',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15260,47,'Adgaon','423101',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15261,47,'Aghar BK','423201',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15262,47,'Aghar KH','423208',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15263,47,'Ahergaon','422209',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15264,47,'Ajmer Saundana','423301',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15265,47,'Akhatwade','423301',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15266,47,'Aliyabad','423302',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15267,47,'Ambasan','423204',1,0,'2022-03-03 12:26:16','2022-03-03 12:26:16'),(15268,47,'Andarsul','423402',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15269,47,'Angangaon','423401',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15270,47,'Angulgaon','423402',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15271,47,'Ankai','423104',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15272,47,'Antapur','423302',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15273,47,'Arai','423301',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15274,47,'Askheda','423303',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15275,47,'Astane','423205',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15276,47,'Athambe','423501',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15277,47,'Aundane','423301',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15278,47,'Bahaduri','422205',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15279,47,'Bangaon','423106',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15280,47,'Bej','423501',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15281,47,'Bhalur','423106',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15282,47,'Bharam','423401',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15283,47,'Bhatgaon','423101',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15284,47,'Bhatgaon','423401',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15285,47,'Bhaur','423102',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15286,47,'Bhayale','423117',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15287,47,'Bhilwad','423302',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15288,47,'Bhutayane','423101',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15289,47,'Bokte','423402',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15290,47,'Bolthan','423106',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15291,47,'Bopegaon','422205',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15292,47,'Borale','423106',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15293,47,'Bordaivat','423502',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15294,47,'Brahmangaon','423213',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15295,47,'Bramanpade','423303',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15296,47,'Chandanpuri','423212',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15297,47,'Chandora','424109',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15298,47,'Chandwad','423101',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15299,47,'Chankapur','423502',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15300,47,'Chaugaon','423301',1,0,'2022-03-03 12:26:17','2022-03-03 12:26:17'),(15301,47,'Chaundana','423301',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15302,47,'Chikhalohal','423205',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15303,47,'Chinchave','423110',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15304,47,'Chinchave Galane','423206',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15305,47,'Chinchgavan','423105',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15306,47,'Chinchkhed','422209',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15307,47,'Chinchondi','423401',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15308,47,'Chirai','423204',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15309,47,'Dabhadi','423201',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15310,47,'Dahiwad','423102',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15311,47,'Dahiwal','423105',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15312,47,'Dalwat','423502',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15313,47,'Dangsaundane','423301',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15314,47,'Daraswadi','423101',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15315,47,'Daregaon','423104',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15316,47,'Daswel','423302',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15317,47,'Dawachwadi','422209',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15318,47,'Deogaon','422305',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15319,47,'Deoghat','423105',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15320,47,'Deopur','422308',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15321,47,'Desgaon','423502',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15322,47,'Deshmane','423401',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15323,47,'Desrane','423501',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15324,47,'Devargaon','423101',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15325,47,'Devla','423102',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15326,47,'Dhamode','423403',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15327,47,'Dhandri','423213',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15328,47,'Dhavaleshwar','423201',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15329,47,'Dheku KH','423106',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15330,47,'Dhodamba','423117',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15331,47,'Dhondgavan','422209',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15332,47,'Dhrangaon Veer','422303',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15333,47,'Dhulgaon','423401',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15334,47,'Dighwad','423101',1,0,'2022-03-03 12:26:18','2022-03-03 12:26:18'),(15335,47,'Dongargaon','423110',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15336,47,'Dongargaon','422305',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15337,47,'Dongrale','423205',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15338,47,'Dugaon','423104',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15339,47,'Dyane','423204',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15340,47,'Erandgaon','423208',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15341,47,'Erandgaon Jeur','423401',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15342,47,'G.S.S.K.','423202',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15343,47,'Gajarwadi','422303',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15344,47,'Galane','423205',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15345,47,'Ganore','423501',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15346,47,'Ganur','423101',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15347,47,'Girnadam','423106',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15348,47,'Girnare','423110',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15349,47,'Golwad','423302',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15350,47,'Gondegaon','422305',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15351,47,'Gosrane','423502',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15352,47,'Harnul','423104',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15353,47,'Hatti','423117',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15354,47,'Hiswal BK','423106',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15355,47,'Hiswal KH','423106',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15356,47,'Hiwarkheda','423101',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15357,47,'Jaidhar','423502',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15358,47,'Jaikheda','423303',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15359,47,'Jalgaon Galane','423202',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15360,47,'Jalgaon KH','424109',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15361,47,'Jalgaon Neur','423401',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15362,47,'Jalgaon Nimbayati','423104',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15363,47,'Jamdhari','423106',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15364,47,'Jategaon','423106',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15365,47,'Jawalkewani','422209',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15366,47,'Jopul','423101',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15367,47,'Jopul','422209',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15368,47,'Jorandigar','423301',1,0,'2022-03-03 12:26:19','2022-03-03 12:26:19'),(15369,47,'K.K.Nagar (Nashik)','422308',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15370,47,'Kalamdari','423106',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15371,47,'Kalwadi','423105',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15372,47,'Kalwan','423501',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15373,47,'Kanadgaon','423104',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15374,47,'Kanashi','423502',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15375,47,'Kandane','423301',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15376,47,'Kanmandale','423117',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15377,47,'Kapshi','423102',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15378,47,'Karanjad','423301',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15379,47,'Karanjgavan','423105',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15380,47,'Karhe','423301',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15381,47,'Karsul','422209',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15382,47,'Kasari','423106',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15383,47,'Kashti','423206',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15384,47,'Katarni','423104',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15385,47,'Kathargaon','422303',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15386,47,'Kaulana','423208',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15387,47,'Kaulana','423205',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15388,47,'Kazisangvi','423101',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15389,47,'Kelzar','423301',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15390,47,'Kersane','423301',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15391,47,'Khadak Malegaon','422304',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15392,47,'Khadakjamb','423117',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15393,47,'Khadgaon','423104',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15394,47,'Khadki','423105',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15395,47,'Khakurdi','423206',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15396,47,'Khalap','423301',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15397,47,'Khamkheda','423301',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15398,47,'Khamtane','423301',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15399,47,'Kharde Wakhari','423102',1,0,'2022-03-03 12:26:20','2022-03-03 12:26:20'),(15400,47,'Khayde','423212',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15401,47,'Khedgaon (Nashik)','422205',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15402,47,'Khedlezung','422305',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15403,47,'Khirdisathe','423403',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15404,47,'Khirmani','423204',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15405,47,'Khuntewadi','423102',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15406,47,'Kikwari KH','423301',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15407,47,'Kotamgaon','422306',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15408,47,'Kotbel','423204',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15409,47,'Kothare','423502',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15410,47,'Kothure','422303',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15411,47,'Kukane','423105',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15412,47,'Kumbharde','423110',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15413,47,'Kumbhardi','422308',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15414,47,'Kundalgaon','423104',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15415,47,'Kundane','423502',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15416,47,'Kundegaon','422303',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15417,47,'Kusmadi','423403',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15418,47,'Kusur','423403',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15419,47,'Lakhamapur','423213',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15420,47,'Lasalgaon','422306',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15421,47,'Lohoner','423301',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15422,47,'Lonwadi','422209',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15423,47,'Mahalpatane','423213',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15424,47,'Malegaon Camp','423105',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15425,47,'Malegaon City','423203',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15426,47,'Malegaon H.O','423203',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15427,47,'Malegaon Karyat','423104',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15428,47,'Malegaon Nayapura Ward','423203',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15429,47,'Malgaon','423212',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15430,47,'Malwadi','423102',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15431,47,'Mamdapur','423403',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15432,47,'Mandwad','423106',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15433,47,'Mangrul','423101',1,0,'2022-03-03 12:26:21','2022-03-03 12:26:21'),(15434,47,'Manmad','423104',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15435,47,'Manmad Shiwaji Chouk','423104',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15436,47,'Manur','423501',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15437,47,'Market Yard Malegaon','423203',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15438,47,'Matane','423102',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15439,47,'Materewadi','422209',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15440,47,'Matulthan','423403',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15441,47,'Mehune','423212',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15442,47,'Meshi','423102',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15443,47,'Mohegaon','423106',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15444,47,'Mokbhangi','423501',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15445,47,'Morenagar','423301',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15446,47,'Mukhed','423401',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15447,47,'Mukhed','422209',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15448,47,'Mulane','423301',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15449,47,'Mulher','423302',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15450,47,'Mungse','423201',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15451,47,'Munjwad','423301',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15452,47,'Nagada','423401',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15453,47,'Nagapur','423104',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15454,47,'Nagarsul','423403',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15455,47,'Naitale','422303',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15456,47,'Nampur','423204',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15457,47,'Nandgaon','423208',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15458,47,'Nandgaon','422305',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15459,47,'Nandgaon','423106',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15460,47,'Nandur Madhmeshwar','422303',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15461,47,'Nandurdi','422308',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15462,47,'Nanduri','423501',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15463,47,'Narul','423501',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15464,47,'Naydongri','424109',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15465,47,'Neminagar','423101',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15466,47,'Nimbayati','423212',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15467,47,'Nimgaon Madh','423401',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15468,47,'Nimgaon','423212',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15469,47,'Nimon','423104',1,0,'2022-03-03 12:26:22','2022-03-03 12:26:22'),(15470,47,'Niphad','422303',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15471,47,'Nitane','423301',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15472,47,'Nivane','423501',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15473,47,'Otur','423501',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15474,47,'Ozar','423502',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15475,47,'Pachore BK','422306',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15476,47,'Pachorewani','422209',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15477,47,'Padalde','423105',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15478,47,'Palasdare','423205',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15479,47,'Pale BK','423501',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15480,47,'Palkhed','422209',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15481,47,'Pardhadi','424109',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15482,47,'Pate','423101',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15483,47,'Patne','423201',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15484,47,'Patoda','423401',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15485,47,'Pilkos','423501',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15486,47,'Pimpalgaon','423202',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15487,47,'Pimpalgaon Baswant','422209',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15488,47,'Pimpalgaon Jalal','423401',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15489,47,'Pimpalgaon Wakhari','423102',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15490,47,'Pimpalkotha','423302',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15491,47,'Pimpalnare','423111',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15492,47,'Pimparkhed','424109',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15493,47,'Pimplad','422306',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15494,47,'Pimple KH','423502',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15495,47,'Pohane','423206',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15496,47,'Pokhari','423106',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15497,47,'Puri','423101',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15498,47,'Raipur','423104',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15499,47,'Rajapur','423403',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15500,47,'Rajapur','422205',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15501,47,'Rajmane','423205',1,0,'2022-03-03 12:26:23','2022-03-03 12:26:23'),(15502,47,'Rameshwar','423102',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15503,47,'Ranwad','422308',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15504,47,'Ravalgaon','423108',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15505,47,'Ravalji','423501',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15506,47,'Redgaon BK','423111',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15507,47,'Redgaon KH','422306',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15508,47,'Ronzane','423105',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15509,47,'Rui','422305',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15510,47,'Sakora','423501',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15511,47,'Sakore','423106',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15512,47,'Sakorewani','422209',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15513,47,'Sakuri','423212',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15514,47,'Salher','423302',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15515,47,'Sangmeshwar Malegaon','423203',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15516,47,'Sapthshringigarh','423501',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15517,47,'Sarde','423204',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15518,47,'Sarolethadi','422303',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15519,47,'Satana Market','423301',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15520,47,'Satana','423301',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15521,47,'Saundana','423208',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15522,47,'Savargaon','423401',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15523,47,'Savargaon','423106',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15524,47,'Savkarwadi','423208',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15525,47,'Savki  Lohoner','423301',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15526,47,'Saygaon','423402',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15527,47,'Sayne BK','423105',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15528,47,'Shelu','423101',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15529,47,'Shemli','423213',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15530,47,'Sherul','423105',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15531,47,'Shindwad','422205',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15532,47,'Shingve','423104',1,0,'2022-03-03 12:26:24','2022-03-03 12:26:24'),(15533,47,'Shirasgaon Lauki','423401',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15534,47,'Shirasmani','423501',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15535,47,'Shirpurwade','423204',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15536,47,'Shirsondi','423208',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15537,47,'Shirwade','423111',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15538,47,'Shivare','422303',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15539,47,'Sogras','423101',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15540,47,'Sompur','423303',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15541,47,'Somthandesh','423401',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15542,47,'Sonaj','423208',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15543,47,'Sonjamb','422205',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15544,47,'Soygaon','423105',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15545,47,'Suregaon Rasta','423402',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15546,47,'Taharabad','423302',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15547,47,'Takali','423208',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15548,47,'Takali KH','422306',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15549,47,'Talegaon Rui','423104',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15550,47,'Talwade','423108',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15551,47,'Talwade','423401',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15552,47,'Talwade','423101',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15553,47,'Talwadedigar','423301',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15554,47,'Tandulwadi','423303',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15555,47,'Tehare','423105',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15556,47,'Tembhe','423204',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15557,47,'Thangaon','423401',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15558,47,'Thengoda','423301',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15559,47,'Tilwan','423301',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15560,47,'Tingri','423205',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15561,47,'Tisgaon','422205',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15562,47,'Tisgaon','423110',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15563,47,'Tokade','423105',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15564,47,'Ugaon','422304',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15565,47,'Umbarkhed','422209',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15566,47,'Umrana','423110',1,0,'2022-03-03 12:26:25','2022-03-03 12:26:25'),(15567,47,'Undirwadi','423402',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15568,47,'Uswad','423104',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15569,47,'Utrane','423204',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15570,47,'Vadali Bhoi','423117',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15571,47,'Vadali BK','423106',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15572,47,'Vadbare','423101',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15573,47,'Vadel','423206',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15574,47,'Vadgaon','423105',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15575,47,'Vadgaon Pangu','423104',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15576,47,'Vadner Bhairav','423111',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15577,47,'Vadner Malegaon','423206',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15578,47,'Vahegaon Sal','422306',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15579,47,'Vajirkheda','423105',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15580,47,'Valwade','423206',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15581,47,'Vanasgaon','422304',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15582,47,'Vanjarwadi','423104',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15583,47,'Vanoli','423301',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15584,47,'Varkheda','422205',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15585,47,'Vasol','423301',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15586,47,'Vaygaon','423108',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15587,47,'Vehelgaon','423106',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15588,47,'Vikharni','423401',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15589,47,'Vinchur','422305',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15590,47,'Virane','423206',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15591,47,'Virgaon','423301',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15592,47,'Visapur','423501',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15593,47,'Vitave','423101',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15594,47,'Vithewadi','423301',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15595,47,'Waghamba','423302',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15596,47,'Wajgaon','423102',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15597,47,'Wakad','422305',1,0,'2022-03-03 12:26:26','2022-03-03 12:26:26'),(15598,47,'Wakhari','423102',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15599,47,'Wakhari','423106',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15600,47,'Warwandi','423102',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15601,47,'Yeola Kutcheri Road','423401',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15602,47,'Yeola','423401',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15603,47,'Yesgaon','423212',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15604,47,'Zadi','423208',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15605,47,'Zodga','423205',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15606,47,'Adgaon','422003',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15607,47,'Agaskhind','422502',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15608,47,'Ahiwantwadi','422215',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15609,47,'Akrale','422004',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15610,47,'Alangun','422211',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15611,47,'Alwand','422212',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15612,47,'Amba (Peint)','422208',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15613,47,'Amba','422207',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15614,47,'Ambad A.S.','422010',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15615,47,'Ambegaon','422003',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15616,47,'Ambode','422007',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15617,47,'Amboli','422212',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15618,47,'Ambupada','422007',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15619,47,'Amlon','422204',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15620,47,'Anjneri','422213',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15621,47,'Asarbari','422208',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15622,47,'Ashewadi','422003',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15623,47,'Ashok Nagar (Nashik)','422012',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15624,47,'Aswali Harsh','422212',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15625,47,'Aswali R.S','422403',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15626,47,'Awankhed','422202',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15627,47,'B.S. Nagar','422301',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15628,47,'Baragaonpimpri','422103',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15629,47,'Barhe','422007',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15630,47,'Barnes High School','422401',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15631,47,'Belatgavhan','422401',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15632,47,'Belgaon Tarhale','422403',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15633,47,'Berwal','422204',1,0,'2022-03-03 12:26:27','2022-03-03 12:26:27'),(15634,47,'Bhagur','422502',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15635,47,'Bhanwad','422202',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15636,47,'Bharvir BK','422403',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15637,47,'Bhatode','422215',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15638,47,'Bhavali Khurd','422403',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15639,47,'Bhendali','422210',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15640,47,'Bhojapur','422606',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15641,47,'Bhonsala Military School','422005',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15642,47,'Bhormal','422211',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15643,47,'Bhuvan','422208',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15644,47,'Borgaon','422211',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15645,47,'Borwat','422208',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15646,47,'Boy\'s Town','422007',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15647,47,'Brahmanwade','422212',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15648,47,'Brahmanwade','422102',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15649,47,'Bubli','422211',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15650,47,'Budhwar Peth','422001',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15651,47,'Chachadgaon','422003',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15652,47,'Chandori','422201',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15653,47,'Chas','422606',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15654,47,'Chatori','422210',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15655,47,'Chausale','422215',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15656,47,'Chinchohol','422204',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15657,47,'Chincholi','422102',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15658,47,'Chinchwade','422204',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15659,47,'Chitegaon','422003',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15660,47,'Cidco Colony (Nashik)','422009',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15661,47,'Dahiwadi','422104',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15662,47,'Dalpatpur','422204',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15663,47,'Dapur','422606',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15664,47,'Dari','422003',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15665,47,'Darnasangvi','422003',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15666,47,'Datli','422112',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15667,47,'Deodongra','422204',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15668,47,'Devargaon','422203',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15669,47,'Devgaon','422214',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15670,47,'Devlali Air Force','422501',1,0,'2022-03-03 12:26:28','2022-03-03 12:26:28'),(15671,47,'Devlali Bazar','422401',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15672,47,'Devlali','422401',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15673,47,'Devpur','422103',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15674,47,'Devsane','422202',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15675,47,'Devthan','422202',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15676,47,'Dhakambe','422004',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15677,47,'Dhamangaon','422403',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15678,47,'Dhondbhar','422103',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15679,47,'Dhondmal','422208',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15680,47,'Dindori (Nashik)','422202',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15681,47,'Dixi','422302',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15682,47,'Dodi','422606',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15683,47,'Dondegaon','422203',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15684,47,'Dubera','422103',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15685,47,'Dugaon','422203',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15686,47,'Dwarka Corner','422011',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15687,47,'Gandhi Nagar (Nashik)','422006',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15688,47,'Gandole','422007',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15689,47,'Gangamhalungi','422203',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15690,47,'Gangapur','422222',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15691,47,'Ghoti','422402',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15692,47,'Girnara','422203',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15693,47,'Gole Colony','422002',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15694,47,'Gonde','422606',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15695,47,'Gonde','422208',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15696,47,'Gondedumala','422403',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15697,47,'Gulvanch','422112',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15698,47,'H P T College','422005',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15699,47,'Harsul','422204',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15700,47,'Haste','422215',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15701,47,'Haste','422007',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15702,47,'Hatgad','422211',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15703,47,'Hatrundi (Peint)','422208',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15704,47,'Hatrundi (Surgana)','422211',1,0,'2022-03-03 12:26:29','2022-03-03 12:26:29'),(15705,47,'Hatti','422211',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15706,47,'I.A. Musalgaon Sinnar','422112',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15707,47,'Idgaon Devlali','422101',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15708,47,'Igatpuri','422403',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15709,47,'Ind. Est. Malegaon Sinnar','422113',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15710,47,'India Security Press','422101',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15711,47,'Indira Nagar (Nashik)','422009',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15712,47,'Indore','422202',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15713,47,'Industrial Estate (Nashik)','422007',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15714,47,'Jahule','422007',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15715,47,'Jaigaon','422102',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15716,47,'Jakhori','422102',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15717,47,'Jalkhed','422007',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15718,47,'Jambutke','422003',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15719,47,'Janori','422207',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15720,47,'Jategaon BK','422204',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15721,47,'Jaulke','422207',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15722,47,'Jeevan Prakash','422002',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15723,47,'Jogalthembi','422102',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15724,47,'Kadwanagar','422202',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15725,47,'Kalaram Mandir','422003',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15726,47,'Kalmuste','422204',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15727,47,'Kaluste','422402',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15728,47,'Kankuri','422606',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15729,47,'Karanjali','422208',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15730,47,'Karanjaon','422210',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15731,47,'Karanjwan','422202',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15732,47,'Kaudasar','422007',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15733,47,'Kavnai','422402',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15734,47,'Kazimale','422202',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15735,47,'Khadak Sukena','422207',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15736,47,'Khadked','422402',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15737,47,'Khairgaon','422402',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15738,47,'Khambala Anjeri','422213',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15739,47,'Khambale','422606',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15740,47,'Kharshet','422204',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15741,47,'Kharwal','422204',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15742,47,'Khatwad','422004',1,0,'2022-03-03 12:26:30','2022-03-03 12:26:30'),(15743,47,'Khed','422402',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15744,47,'Khedle','422202',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15745,47,'Kherwadi R.S','422201',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15746,47,'Khirad','422211',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15747,47,'Khopadi BK','422112',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15748,47,'Kochargaon','422203',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15749,47,'Kohor','422208',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15750,47,'Kokangaon','422207',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15751,47,'Konambe','422103',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15752,47,'Kopurli','422208',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15753,47,'Korahte','422207',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15754,47,'Korapgaon','422402',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15755,47,'Koshimbe','422202',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15756,47,'Kotamgaon','422105',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15757,47,'Kukudane','422211',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15758,47,'Kulwandi','422204',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15759,47,'Kumbhale','422208',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15760,47,'Lahavit','422502',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15761,47,'Lakhalgaon','422003',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15762,47,'Lakhmapur','422202',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15763,47,'Lonarwadi','422103',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15764,47,'Madhmeshwar','422103',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15765,47,'Madkijamb','422202',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15766,47,'Madsangvi','422003',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15767,47,'Mahaje','422007',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15768,47,'Mahiravani','422213',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15769,47,'Makhmalabad','422003',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15770,47,'Maledumala','422215',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15771,47,'Malegaon (Peint)','422208',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15772,47,'Malegaon','422203',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15773,47,'Manegaon','422103',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15774,47,'Mangone','422208',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15775,47,'Mani','422211',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15776,47,'Mankhed','422007',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15777,47,'Marhal BK','422606',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15778,47,'Matori','422003',1,0,'2022-03-03 12:26:31','2022-03-03 12:26:31'),(15779,47,'Mavdi','422215',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15780,47,'Meri Colony','422004',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15781,47,'Mhalsakore','422103',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15782,47,'Mhasgan','422208',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15783,47,'Mhasrul','422004',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15784,47,'Mithsagare','422104',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15785,47,'Mohadi','422207',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15786,47,'Mohpada','422211',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15787,47,'MUHS','422004',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15788,47,'Mukane','422403',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15789,47,'Mundhegaon','422403',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15790,47,'Mungsara','422003',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15791,47,'Murambi','422403',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15792,47,'Musalgaon','422112',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15793,47,'Nachlondi','422204',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15794,47,'Naigaon','422102',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15795,47,'Nalwadi','422202',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15796,47,'Nalwadpada','422202',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15797,47,'Nanashi','422007',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15798,47,'Nandgaon','422403',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15799,47,'Nandurshingote','422606',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15800,47,'Nanegaon','422502',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15801,47,'Nashik City','422001',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15802,47,'Nashik H.O','422001',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15803,47,'Nashik Main Road','422001',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15804,47,'Nashik Road Camp','422102',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15805,47,'Nashik Road H.O','422101',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15806,47,'Nehru Nagar (Nashik)','422101',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15807,47,'Nigdol','422202',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15808,47,'Nilwandi','422202',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15809,47,'Nimgaon (Sinnar)','422103',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15810,47,'Nirgude','422208',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15811,47,'Nirhale','422606',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15812,47,'Odha','422003',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15813,47,'Ojhar A.F. Stn.','422221',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15814,47,'Ojhar','422206',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15815,47,'Ojhar T.S.','422207',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15816,47,'Ojharkhed','422202',1,0,'2022-03-03 12:26:32','2022-03-03 12:26:32'),(15817,47,'Ojharkhed','422204',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15818,47,'Oney','422302',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15819,47,'Pade','422202',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15820,47,'Pahuchibari','422007',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15821,47,'Palasvihir','422007',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15822,47,'Palkhed Bandhara','422202',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15823,47,'Palsan','422211',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15824,47,'Palse','422102',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15825,47,'Panchale','422103',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15826,47,'Panchvati','422003',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15827,47,'Pandane','422215',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15828,47,'Pandurli','422502',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15829,47,'Pangarne','422211',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15830,47,'Pangri BK','422104',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15831,47,'Paregaon','422215',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15832,47,'Paste','422113',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15833,47,'Pathardi','422010',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15834,47,'Pathare','422104',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15835,47,'Patole','422103',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15836,47,'Peint','422208',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15837,47,'Pimpale','422103',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15838,47,'Pimpalgaon Bahula','422213',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15839,47,'Pimpalgaon Dukra','422502',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15840,47,'Pimpalgaon Garudeshwar','422213',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15841,47,'Pimpalgaon Khamb','422010',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15842,47,'Pimpalgaon Nipani','422102',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15843,47,'Pimpalnare','422004',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15844,47,'Pimparkhed','422202',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15845,47,'Pimplad','422010',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15846,47,'Pimplus','422301',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15847,47,'Pimpri -achala','422215',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15848,47,'Pimpri','422301',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15849,47,'Pimpri-sayyed','422003',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15850,47,'Police Training School','422007',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15851,47,'Puria Park','422003',1,0,'2022-03-03 12:26:33','2022-03-03 12:26:33'),(15852,47,'Rakshasbhuvan','422007',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15853,47,'Rasegaon','422003',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15854,47,'Rohile','422203',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15855,47,'Sakur','422502',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15856,47,'Salbhoye','422211',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15857,47,'Samundi','422212',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15858,47,'Sanjegaon','422402',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15859,47,'Sapte','422203',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15860,47,'Sarad','422211',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15861,47,'Satkhamb','422211',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15862,47,'Satpur Township','422007',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15863,47,'Sawarkar Nagar','422013',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15864,47,'Sayale','422104',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15865,47,'Saykheda','422210',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15866,47,'Shaha','422104',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15867,47,'Shenit','422502',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15868,47,'Shevgedang','422402',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15869,47,'Shinde','422102',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15870,47,'Shingwe','422210',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15871,47,'Shirasgaon (Peint)','422204',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15872,47,'Shirasgaon','422207',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15873,47,'Shivde','422502',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15874,47,'Shivre','422215',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15875,47,'Shribhuvan','422211',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15876,47,'Sinnar','422103',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15877,47,'Somthane','422103',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15878,47,'Sonambe','422103',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15879,47,'Sukena','422302',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15880,47,'Surgana (Peint)','422208',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15881,47,'Surgana','422211',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15882,47,'Taked BK','422403',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15883,47,'Talegaon (Igatpuri)','422403',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15884,47,'Talegaon (Trimbak)','422212',1,0,'2022-03-03 12:26:34','2022-03-03 12:26:34'),(15885,47,'Talegaon Anjneri','422213',1,0,'2022-03-03 12:26:35','2022-03-03 12:26:35'),(15886,47,'Talegaon(Dindori)','422004',1,0,'2022-03-03 12:26:35','2022-03-03 12:26:35'),(15887,47,'Tamaswadi','422103',1,0,'2022-03-03 12:26:35','2022-03-03 12:26:35'),(15888,47,'Thana (Peint)','422204',1,0,'2022-03-03 12:26:35','2022-03-03 12:26:35'),(15889,47,'Thangaon','422007',1,0,'2022-03-03 12:26:35','2022-03-03 12:26:35'),(15890,47,'Thangaon','422103',1,0,'2022-03-03 12:26:35','2022-03-03 12:26:35'),(15891,47,'Titwe','422202',1,0,'2022-03-03 12:26:35','2022-03-03 12:26:35'),(15892,47,'Torangan','422212',1,0,'2022-03-03 12:26:35','2022-03-03 12:26:35'),(15893,47,'TP Station Eklahre','422105',1,0,'2022-03-03 12:26:35','2022-03-03 12:26:35'),(15894,47,'Trimbak','422212',1,0,'2022-03-03 12:26:35','2022-03-03 12:26:35'),(15895,47,'Trimbak Vidya Mandir','422213',1,0,'2022-03-03 12:26:35','2022-03-03 12:26:35'),(15896,47,'Trimurti Chowk','422008',1,0,'2022-03-03 12:26:35','2022-03-03 12:26:35'),(15897,47,'Tringalwadi','422402',1,0,'2022-03-03 12:26:35','2022-03-03 12:26:35'),(15898,47,'Udhoji Maratha Boarding','422005',1,0,'2022-03-03 12:26:35','2022-03-03 12:26:35'),(15899,47,'Umbarpada','422211',1,0,'2022-03-03 12:26:35','2022-03-03 12:26:35'),(15900,47,'Umbarthan','422211',1,0,'2022-03-03 12:26:35','2022-03-03 12:26:35'),(15901,47,'Umrala','422003',1,0,'2022-03-03 12:26:35','2022-03-03 12:26:35'),(15902,47,'Upnagar','422006',1,0,'2022-03-03 12:26:35','2022-03-03 12:26:35'),(15903,47,'Usthale','422208',1,0,'2022-03-03 12:26:35','2022-03-03 12:26:35'),(15904,47,'Vadangli','422103',1,0,'2022-03-03 12:26:35','2022-03-03 12:26:35'),(15905,47,'Vadgaon Pingala','422502',1,0,'2022-03-03 12:26:35','2022-03-03 12:26:35'),(15906,47,'Vadner Dumala','422401',1,0,'2022-03-03 12:26:35','2022-03-03 12:26:35'),(15907,47,'Vadzire','422102',1,0,'2022-03-03 12:26:35','2022-03-03 12:26:35'),(15908,47,'Vaitarna Nagar','422214',1,0,'2022-03-03 12:26:35','2022-03-03 12:26:35'),(15909,47,'Vani Khurd','422202',1,0,'2022-03-03 12:26:35','2022-03-03 12:26:35'),(15910,47,'Vani','422215',1,0,'2022-03-03 12:26:35','2022-03-03 12:26:35'),(15911,47,'Velunje','422212',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15912,47,'Vilholi','422010',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15913,47,'Vilwandi','422203',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15914,47,'Vinchuri-dalvi','422502',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15915,47,'Wadala','422006',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15916,47,'Wadali Nazik','422207',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15917,47,'Wadgaon','422203',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15918,47,'Wadivarhe','422403',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15919,47,'Waghare','422403',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15920,47,'Waghdad Dam','422003',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15921,47,'Waghera','422203',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15922,47,'Waki','422402',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15923,47,'Walkhed','422202',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15924,47,'Ware','422202',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15925,47,'Wasali','422402',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15926,47,'Wavi Harsh','422214',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15927,47,'Wavi','422104',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15928,47,'Ycm Open Univesity','422222',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15929,47,'Zarwad','422212',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15930,48,'Achler','413602',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15931,48,'Ajni (BK)','413544',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15932,48,'Akulga Rani','413544',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15933,48,'Alani','413582',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15934,48,'Aloor','413605',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15935,48,'Ambejavalge','413582',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15936,48,'Ambhi','413505',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15937,48,'Anala','413505',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15938,48,'Anandnagar (Osmanabad)','413582',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15939,48,'Andora','413507',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15940,48,'Andora','413603',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15941,48,'Andori','413523',1,0,'2022-03-03 12:26:36','2022-03-03 12:26:36'),(15942,48,'Ankulga Sayed','413544',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15943,48,'Ansarwada','413521',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15944,48,'Ansurda','413582',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15945,48,'Antargaon','413502',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15946,48,'Antarwali','413504',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15947,48,'Apsinga','413601',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15948,48,'Arali Bk.','413601',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15949,48,'Arali Khurd','413601',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15950,48,'Arangaon','413502',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15951,48,'Arani','413509',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15952,48,'Ashta (Kasar)','413604',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15953,48,'Ashta','413504',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15954,48,'Ashta','413581',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15955,48,'Asu','413502',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15956,48,'Aurad','413606',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15957,48,'Awad Shirpura','413528',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15958,48,'Babhalgaon','413531',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15959,48,'Balsur','413604',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15960,48,'Bamni','413506',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15961,48,'Bamniwadi','413506',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15962,48,'Barul','413601',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15963,48,'Bavi (YRM)','413525',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15964,48,'Bavi','413582',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15965,48,'Bawachi','413502',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15966,48,'Bedga','413606',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15967,48,'Belamb','413605',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15968,48,'Bembli','413506',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15969,48,'Bhandarwadi','413509',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15970,48,'Bhatangali','413531',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15971,48,'Bhatangli','413608',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15972,48,'Bhatsirpura','413507',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15973,48,'Bhavani Mandir-Tuljapur','413601',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15974,48,'Bhokrama','413527',1,0,'2022-03-03 12:26:37','2022-03-03 12:26:37'),(15975,48,'Bhoom','413504',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(15976,48,'Bhusani','413605',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(15977,48,'Bhutmugali','413521',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(15978,48,'Bittergaon','431522',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(15979,48,'Bokangaon','413531',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(15980,48,'Borda','413507',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(15981,48,'Borgaon (NLD)','413602',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(15982,48,'Borgaon Dargi','413527',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(15983,48,'Bori','413531',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(15984,48,'Bukanwadi','413509',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(15985,48,'Chera','413514',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(15986,48,'Chikhali','413523',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(15987,48,'Chilwadi','413582',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(15988,48,'Chincali (S)','413607',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(15989,48,'Chincholi Bhuyar','413605',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(15990,48,'Chincholi Jahagir','413606',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(15991,48,'Chincholi Pan','413531',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(15992,48,'Chincholi Tapse','413516',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(15993,48,'Chinchpur Bk.','413505',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(15994,48,'Chinchpur Dhage','413504',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(15995,48,'Chivari','413603',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(15996,48,'Chorakhali','413405',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(15997,48,'Dahiphal','413525',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(15998,48,'Dalimb','413604',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(15999,48,'Darphal','413582',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(16000,48,'Dasmegaon','413503',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(16001,48,'Dastapur','413602',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(16002,48,'Deodhanora','413507',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(16003,48,'Deokurali','413623',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(16004,48,'Deolali','413582',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(16005,48,'Deolali','413504',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(16006,48,'Deolali','413508',1,0,'2022-03-03 12:26:38','2022-03-03 12:26:38'),(16007,48,'Deosinga','413601',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16008,48,'Devangra','413581',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16009,48,'Dhalegaon','413523',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16010,48,'Dhamangaon','413514',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16011,48,'Dhamangaon','413544',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16012,48,'Dhanora','413523',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16013,48,'Dhanora','413521',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16014,48,'Dhanuri','413604',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16015,48,'Dharur','413601',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16016,48,'Dhoki','413508',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16017,48,'Dhorala','413508',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16018,48,'Diggi','413606',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16019,48,'Dighoi','413517',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16020,48,'Domgaon','413505',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16021,48,'Donja','413505',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16022,48,'Ekurga','413604',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16023,48,'Gad (Sonegaon)','413582',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16024,48,'Gandhora','413601',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16025,48,'Ganegaon','413504',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16026,48,'Gangapur','413531',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16027,48,'Ganjur','413581',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16028,48,'Gaur','413531',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16029,48,'Ghargaon','413528',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16030,48,'Ghatangri','413582',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16031,48,'Ghatpimpri','413534',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16032,48,'Ghodki','413503',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16033,48,'Girwali','413526',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16034,48,'Gojwada','413525',1,0,'2022-03-03 12:26:39','2022-03-03 12:26:39'),(16035,48,'Gour','413525',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16036,48,'Govindpur','413507',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16037,48,'Gunjoti','413606',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16038,48,'Hadga','413521',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16039,48,'Hadolti','413514',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16040,48,'Hadongri','413504',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16041,48,'Hagloor','413601',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16042,48,'Halki','413544',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16043,48,'Hangarga (NLD)','413602',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16044,48,'Harangai BK','413531',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16045,48,'Harangul KH','413531',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16046,48,'Harwargaon','413507',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16047,48,'Hasori BK','413607',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16048,48,'Hatola','413526',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16049,48,'Hatterga Halsi','413607',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16050,48,'Hingalajwadi','413509',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16051,48,'Hipparga Rava','413608',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16052,48,'Hipperga Sayad','413608',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16053,48,'Hismabad','413544',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16054,48,'Holi','413531',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16055,48,'Horti','413602',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16056,48,'Ida-Pida','413502',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16057,48,'Ieet','413534',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16058,48,'Indapur','413525',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16059,48,'Irla','413509',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16060,48,'Itkal','413603',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16061,48,'Itkur','413507',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16062,48,'Izora','413503',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16063,48,'Jagaji','413509',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16064,48,'Jagalpur (BK)','413514',1,0,'2022-03-03 12:26:40','2022-03-03 12:26:40'),(16065,48,'Jakekur','413604',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16066,48,'Jalkot (NLD)','413602',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16067,48,'Jamb','413504',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16068,48,'Jawala (Nizamudin)','413504',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16069,48,'Jawala Kh.','413507',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16070,48,'Jewali','413531',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16071,48,'Jewali','413608',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16072,48,'Jewari','413521',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16073,48,'Kadaknathwadi','413525',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16074,48,'Kadepur','431522',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16075,48,'Kadher','413606',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16076,48,'Kajala','413582',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16077,48,'Kakramba','413601',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16078,48,'Kaldeo Nimbala','413604',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16079,48,'Kallam','413507',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16080,48,'Kallambgaon','413544',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16081,48,'Kamegaon','413582',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16082,48,'Kamkheda','431522',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16083,48,'Kandari','413505',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16084,48,'Kanegaon','413608',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16085,48,'Kangara','413506',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16086,48,'Kanherwadi','413507',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16087,48,'Kapilapuri','413502',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16088,48,'Karajkheda','413608',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16089,48,'Karanjkalla','413507',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16090,48,'Karla','413516',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16091,48,'Kasagi','413606',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16092,48,'Kasarkheda','413531',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16093,48,'Kasasr Belkunda','413607',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16094,48,'Kasbe Tadvale','413405',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16095,48,'Kasti Bk.','413608',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16096,48,'Katgaon','413531',1,0,'2022-03-03 12:26:41','2022-03-03 12:26:41'),(16097,48,'Katgaon','413603',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16098,48,'Kati','413624',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16099,48,'Kawa','413531',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16100,48,'Kawatha (OMG)','413606',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16101,48,'Kesar Javalga','413605',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16102,48,'Keshegaon','413506',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16103,48,'Keshegaon','413603',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16104,48,'Khadgaon','413531',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16105,48,'Khamaswadi','413507',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16106,48,'Khamgaon','413508',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16107,48,'Kharosa','413521',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16108,48,'Khasapuri','413502',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16109,48,'Khasgaon','413502',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16110,48,'Khed','413508',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16111,48,'Khudawadi','413603',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16112,48,'Kilaj','413601',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16113,48,'Kini','413582',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16114,48,'Kini Thot','413516',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16115,48,'Kodli','413532',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16116,48,'Kolsur','413606',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16117,48,'Kond','413509',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16118,48,'Koral','413604',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16119,48,'Korali','413607',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16120,48,'Koshtgaon','413523',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16121,48,'Kothala','413528',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16122,48,'Kothali','413605',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16123,48,'Kukadgaon','413505',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16124,48,'Kumbhari','413601',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16125,48,'Kumtha (BK)','413514',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16126,48,'Kunhali','413606',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16127,48,'Kunthalgiri','413503',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16128,48,'Lakadjawalga','413544',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16129,48,'Lakhangaon','413526',1,0,'2022-03-03 12:26:42','2022-03-03 12:26:42'),(16130,48,'Lanjeshwar','413534',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16131,48,'Lodga','413531',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16132,48,'Lohara','413608',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16133,48,'Lohata (East)','413507',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16134,48,'Lohgaon','413602',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16135,48,'Loni','413502',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16136,48,'Madaj','413606',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16137,48,'Madansuri','413521',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16138,48,'Mahapur','413527',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16139,48,'Makani','413604',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16140,48,'Malgi','413606',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16141,48,'Malkapur','413517',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16142,48,'Malkaranja','413508',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16143,48,'Malumbra','413623',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16144,48,'Mandva','413507',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16145,48,'Mangrool (TJR)','413601',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16146,48,'Mangrool','413507',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16147,48,'Mankeshwar','413504',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16148,48,'Mardi','413608',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16149,48,'Masla Khurd','413624',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16150,48,'Massa Khandeshwari','413507',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16151,48,'Medsinga','413582',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16152,48,'Mendha','413582',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16153,48,'Mogara','413516',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16154,48,'Moha','413507',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16155,48,'Morta','413602',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16156,48,'Mudgad Ramling','413607',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16157,48,'Mulaj','413606',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16158,48,'Murum','413605',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16159,48,'Nadi Hatterga','413516',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16160,48,'Nagur','413608',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16161,48,'Nai Chakur','413606',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16162,48,'Naigaon','413510',1,0,'2022-03-03 12:26:43','2022-03-03 12:26:43'),(16163,48,'Naldurg','413602',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16164,48,'Nanand','413521',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16165,48,'Nandgaon','413602',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16166,48,'Nanduri','413601',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16167,48,'Narangwadi','413606',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16168,48,'Nelwad','413607',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16169,48,'Nilegaon','413603',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16170,48,'Nipani','413510',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16171,48,'Nipani','413534',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16172,48,'Nitali','413509',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16173,48,'Omerga Bazar','413606',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16174,48,'Omerga Chivari','413603',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16175,48,'Omerga','413606',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16176,48,'Osmanabad H.O','413501',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16177,48,'Osmanabad Town','413501',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16178,48,'Pach Pimpla','413502',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16179,48,'Padoli','413582',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16180,48,'Padoli','413510',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16181,48,'Pakhrud','413534',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16182,48,'Palsap','413509',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16183,48,'Pangaon (YRM)','413525',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16184,48,'Para','413507',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16185,48,'Paranda','413502',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16186,48,'Pardi','413503',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16187,48,'Pargaon','413526',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16188,48,'Pat Sangvi','413504',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16189,48,'Patharwadi','431522',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16190,48,'Pathrud','413504',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16191,48,'Patoda','413506',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16192,48,'Peth','413531',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16193,48,'Peth Sangvi','413606',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16194,48,'Pimpalgaon (Kothawale)','413507',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16195,48,'Pimpalgaon Kamleshwari','413526',1,0,'2022-03-03 12:26:44','2022-03-03 12:26:44'),(16196,48,'Pimpalgaon Lingi','413503',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16197,48,'Pimpalwadi','413502',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16198,48,'Pimpla Khurd','413623',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16199,48,'Pimpri','413582',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16200,48,'Poharegaon','413527',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16201,48,'Pohner','413582',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16202,48,'Rajuri','413582',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16203,48,'Ranjani','413528',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16204,48,'Rathoda','413521',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16205,48,'Ratnapur','413525',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16206,48,'Rohina','413517',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16207,48,'Rohkal','413505',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16208,48,'Ruibhar','413582',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16209,48,'Sakol','413544',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16210,48,'Salegaon','413604',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16211,48,'Salgara Divti','413601',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16212,48,'Salgara Maddi','413602',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16213,48,'Samudrawani','413582',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16214,48,'Sangvi Kati','413623',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16215,48,'Sangvi Mardi','413623',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16216,48,'Sanja','413582',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16217,48,'Sapnai','413525',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16218,48,'Saramkundi','413503',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16219,48,'Sarola Bk','413582',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16220,48,'Sarola Mandva','413507',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16221,48,'Sastur','413606',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16222,48,'Satala','413523',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16223,48,'Satephal','413405',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16224,48,'Sawargaon (Shiradhon)','413528',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16225,48,'Sawargaon','413517',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16226,48,'Sawargaon','413504',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16227,48,'Sawargaon Kati','413624',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16228,48,'Sawargaon Thot','413514',1,0,'2022-03-03 12:26:45','2022-03-03 12:26:45'),(16229,48,'Selu','413507',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16230,48,'Shahapur','413603',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16231,48,'Shedol','413521',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16232,48,'Shelgaon','413518',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16233,48,'Shelgaon(Sonari)','413505',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16234,48,'Shingoli','413582',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16235,48,'Shiradhon','413607',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16236,48,'Shiradhon','413528',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16237,48,'Shirala','413502',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16238,48,'Shivani BK','413531',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16239,48,'Shivani Kothal','413521',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16240,48,'Shivani Lakh','413521',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16241,48,'Sihdhakhed','413521',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16242,48,'Sindgaon (NLD)','413602',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16243,48,'Sindphal','413623',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16244,48,'Sirsav','413504',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16245,48,'Sonari (Osmanabad)','413505',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16246,48,'Songiri','413504',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16247,48,'Sonwati','413531',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16248,48,'Sukani','413518',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16249,48,'Sukta','413504',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16250,48,'Sumbha','413509',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16251,48,'Sundarwadi','413605',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16252,48,'Suratgaon','413623',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16253,48,'Surdi','413582',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16254,48,'Takali','413517',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16255,48,'Takali','413531',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16256,48,'Takviki','413506',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16257,48,'Talani','413516',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16258,48,'Talikhed','413521',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16259,48,'Talmod','413606',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16260,48,'Talni','431522',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16261,48,'Tamalwadi','413623',1,0,'2022-03-03 12:26:46','2022-03-03 12:26:46'),(16262,48,'Tandulwadi (Sonari)','413505',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16263,48,'Tandulwadi (Vasi)','413503',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16264,48,'Tavshigad','413604',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16265,48,'Tawarajkheda','413511',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16266,48,'TBSSK Naldurg','413602',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16267,48,'Ter','413509',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16268,48,'Terkheda','413525',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16269,48,'Ternanagar','413580',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16270,48,'Tirth Bk.','413601',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16271,48,'Tirth kh.','413601',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16272,48,'Toramba','413604',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16273,48,'Trikoli','413606',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16274,48,'Tugaon','413604',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16275,48,'Tugaon','413508',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16276,48,'Tuljapur','413601',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16277,48,'Turori','413606',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16278,48,'Ujlamb','413524',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16279,48,'Uloop','413504',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16280,48,'Upla (M)','413582',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16281,48,'Usturi','413607',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16282,48,'Vashi (Osmanabad)','413503',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16283,48,'Vidyanagar (Osmanabad)','413501',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16284,48,'Wadgaon (G)','413608',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16285,48,'Wadgaon (S)','413582',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16286,48,'Wadgaon Deo.','413601',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16287,48,'Wadgaon Jahagir','413405',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16288,48,'Wadgaon Kati','413623',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16289,48,'Wadgaon Lakh','413601',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16290,48,'Wagdari (NLD)','413602',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16291,48,'Wagholi (YDS)','413405',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16292,48,'Wagholi','413582',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16293,48,'Waigaon','413514',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16294,48,'Walsangi','413514',1,0,'2022-03-03 12:26:47','2022-03-03 12:26:47'),(16295,48,'Walwad','413504',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16296,48,'Wanewadi','413509',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16297,48,'Wangdhari','413527',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16298,48,'Wangi Bk.','413502',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16299,48,'Wanjarwada','413514',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16300,48,'Wanjarwadi','413504',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16301,48,'Ware Wadgaon','413504',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16302,48,'Waruda','413582',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16303,48,'Wasangaon','413531',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16304,48,'Watephal','413505',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16305,48,'Wathoda','413510',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16306,48,'Yedshi','413405',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16307,48,'Yelnoor','413521',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16308,48,'Yenegur','413604',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16309,48,'Yeoti','413603',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16310,48,'Yeoti','413509',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16311,48,'Yermala','413525',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16312,48,'Yerola','413544',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16313,48,'Zari','413529',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16314,49,'Aherborgaon','431503',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16315,49,'Aherwadi','431511',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16316,49,'Ambarwadi','431510',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16317,49,'Arvi','431540',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16318,49,'Asegaon','431509',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16319,49,'Asola','431402',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16320,49,'Badwani','431514',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16321,49,'Ballur','431503',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16322,49,'Bamni','431510',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16323,49,'Banvas','431536',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16324,49,'Bhahulgaon','431506',1,0,'2022-03-03 12:26:48','2022-03-03 12:26:48'),(16325,49,'Bharaswada','431521',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16326,49,'Bhogaon','431537',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16327,49,'Bhogaon Devi','431509',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16328,49,'Bhosi','431509',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16329,49,'Bobde Takli','431540',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16330,49,'Borda','431514',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16331,49,'Bori (Parbhani)','431508',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16332,49,'Borkini','431509',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16333,49,'Borwand BK','431521',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16334,49,'Brahmangaon','431402',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16335,49,'Chandaj','431508',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16336,49,'Charthana','431509',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16337,49,'Chatori','431536',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16338,49,'Chikalthana','431503',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16339,49,'Chincholi Niloba','431509',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16340,49,'Chudawa','431511',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16341,49,'Daithana','431521',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16342,49,'Dasala','431503',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16343,49,'Devalgaon Awchar','431505',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16344,49,'Devalgaon Dudhate','431514',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16345,49,'Devalgaon Gat','431503',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16346,49,'Dhangar Takli','431511',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16347,49,'Dhanora','431509',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16348,49,'Dhar','431402',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16349,49,'Dharasur','431521',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16350,49,'Dhasadi','431521',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16351,49,'Dhengali Pimpalgaon','431505',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16352,49,'Dighol Islampur','431516',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16353,49,'Dongargaon','431506',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16354,49,'Dongarpimpla','431514',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16355,49,'Dudhgaon','431540',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16356,49,'Erandeshwar','431511',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16357,49,'Gadadgavan','431509',1,0,'2022-03-03 12:26:49','2022-03-03 12:26:49'),(16358,49,'Gangakhed','431514',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16359,49,'Gaundgaon','431514',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16360,49,'Gaur','431511',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16361,49,'Ghantangra','431536',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16362,49,'Gomewakdi','431503',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16363,49,'Gugali Dhamangaon','431503',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16364,49,'Gunj KH','431506',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16365,49,'Hadgaon','431506',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16366,49,'Hamdapur','431541',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16367,49,'Harangul','431514',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16368,49,'Hatnoor','431503',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16369,49,'Isad','431514',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16370,49,'Itoli','431509',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16371,49,'Jamb','431537',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16372,49,'Jamb BK','431509',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16373,49,'Jintur','431509',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16374,49,'Jogwada','431509',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16375,49,'K Adgaon','431509',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16376,49,'Kalgaon','431402',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16377,49,'Kanegaon','431516',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16378,49,'Kansur','431506',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16379,49,'Karanji','431505',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16380,49,'Karegaon','431402',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16381,49,'Kasapuri','431506',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16382,49,'Katneshwar','431511',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16383,49,'Kausadi','431508',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16384,49,'Kavi','431509',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16385,49,'Kawada','431509',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16386,49,'Kawalgaon','431511',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16387,49,'Kehal','431510',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16388,49,'Kekar Jawala','431541',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16389,49,'Kerwadi','431720',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16390,49,'Khadka','431516',1,0,'2022-03-03 12:26:50','2022-03-03 12:26:50'),(16391,49,'Khali','431514',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16392,49,'Khavane Pimpri','431506',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16393,49,'Kinhola','431541',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16394,49,'Kodri','431514',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16395,49,'Kok','431508',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16396,49,'Kolha','431505',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16397,49,'Kothala','431505',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16398,49,'Kranti Chowk-Parbhani','431401',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16399,49,'Kundi','431503',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16400,49,'Kupta','431503',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16401,49,'Limba','431541',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16402,49,'Lohgaon','431402',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16403,49,'Mahatpuri','431514',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16404,49,'Majlapur','431402',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16405,49,'Makhani','431514',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16406,49,'Malewadi','431514',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16407,49,'Mandakhali','431537',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16408,49,'Mangrul','431541',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16409,49,'Manoli','431505',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16410,49,'Manwath','431505',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16411,49,'Manwath Town','431505',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16412,49,'Mardasgaon','431514',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16413,49,'Mategaon','431511',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16414,49,'Mau Parbhani','431402',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16415,49,'Mirkhel','431402',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16416,49,'Moregaon','431503',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16417,49,'Mudgal','431541',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16418,49,'Muli','431514',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16419,49,'Naikota','431514',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16420,49,'Nandapur','431540',1,0,'2022-03-03 12:26:51','2022-03-03 12:26:51'),(16421,49,'Nandkheda','431402',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16422,49,'Narwadi','431516',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16423,49,'Nathra','431506',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16424,49,'Nava','431536',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16425,49,'Naya Mondha Parbhani','431401',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16426,49,'Neel','431511',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16427,49,'Nivali','431508',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16428,49,'Pachalegaon','431509',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16429,49,'Pachegaon','431509',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16430,49,'Palam','431720',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16431,49,'Palodi','431505',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16432,49,'Pangri','431509',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16433,49,'Parbhani H.O','431401',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16434,49,'Parbhani Town','431401',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16435,49,'Pathargavan','431506',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16436,49,'Pathri','431506',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16437,49,'Pedgaon','431537',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16438,49,'Pethpimpalgaon','431720',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16439,49,'Pethshivani','431720',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16440,49,'Pharkanda','431720',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16441,49,'Pimpaldari','431514',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16442,49,'Pimpalgaon','431537',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16443,49,'Pimpalgaon Gayke','431508',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16444,49,'Pimpalgaon Kajale','431510',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16445,49,'Pimpla Lokhande','431511',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16446,49,'Pimpri Deshmukh','431402',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16447,49,'Pimprizola','431514',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16448,49,'Pingali','431402',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16449,49,'Pokharni','431521',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16450,49,'Pungala','431509',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16451,49,'Purna','431511',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16452,49,'Rametakli','431541',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16453,49,'Rampuri BK','431541',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16454,49,'Rampuri KH','431506',1,0,'2022-03-03 12:26:52','2022-03-03 12:26:52'),(16455,49,'Ranisawargaon','431536',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16456,49,'Raorajura','431514',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16457,49,'Rawalgaon','431503',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16458,49,'Renakhali','431506',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16459,49,'Renapur','431506',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16460,49,'Rudhi','431505',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16461,49,'Sadegaon','431540',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16462,49,'Sailu','431720',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16463,49,'Sailu','431503',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16464,49,'Sailu Town','431503',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16465,49,'Salapuri','431521',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16466,49,'Sawali BK','431510',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16467,49,'Sawangi Bhambale','431510',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16468,49,'Shelgaon','431516',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16469,49,'Shewadi','431509',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16470,49,'Shikh Rajura','431720',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16471,49,'Shivajinagar Parbhani','431401',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16472,49,'Simangaon','431508',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16473,49,'Singanapur','431402',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16474,49,'Sirsam','431536',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16475,49,'Sirshi BK','431516',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16476,49,'Sonna','431503',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16477,49,'Sonpeth','431516',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16478,49,'Station Parbhani','431401',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16479,49,'Suppa','431514',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16480,49,'Tadborgaon','431505',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16481,49,'Tadkalas','431402',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16482,49,'Takli Kumbhakarna','431540',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16483,49,'Tandulwadi','431536',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16484,49,'Taroda','431402',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16485,49,'Ukhali','431514',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16486,49,'Ukhali','431509',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16487,49,'Ukkadgaon','431536',1,0,'2022-03-03 12:26:53','2022-03-03 12:26:53'),(16488,49,'Ukkalgaon','431505',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16489,49,'Umari','431521',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16490,49,'Vassa','431509',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16491,49,'Vita','431541',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16492,49,'Wadgaon','431514',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16493,49,'Wadi','431506',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16494,49,'Waghala','431541',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16495,49,'Waghi','431509',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16496,49,'Waghi Bobde','431508',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16497,49,'Warud','431509',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16498,49,'Wazar','431510',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16499,49,'Wazur','431514',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16500,49,'Yeldari','431510',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16501,49,'Zari','431505',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16502,49,'Zari','431540',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16503,50,'9 DRD','411014',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16504,50,'AFMC','411040',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16505,50,'Airport (Pune)','411032',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16506,50,'Akurdi','411035',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16507,50,'Ammunition Factory Khadki','411003',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16508,50,'Aundh Camp','411027',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16509,50,'Bhosari I.E.','411026',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16510,50,'Bhosarigoan','411039',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16511,50,'Bibvewadi','411037',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16512,50,'C D A (O)','411001',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16513,50,'C M E','411031',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16514,50,'Chikhali','411062',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16515,50,'Chinchwad East','411019',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16516,50,'Chinchwadgaon','411033',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16517,50,'Dapodi Bazar','411012',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16518,50,'Dapodi','411012',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16519,50,'Dhanori','411015',1,0,'2022-03-03 12:26:54','2022-03-03 12:26:54'),(16520,50,'Dighi Camp','411015',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16521,50,'Dr.B.A. Chowk','411001',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16522,50,'Dukirkline','411014',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16523,50,'East Khadki','411003',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16524,50,'Ghorpuri Bazar','411001',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16525,50,'Gondhale Nagar','411028',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16526,50,'H.E. Factory','411003',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16527,50,'Hadapsar','411028',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16528,50,'Hadpsar I.E.','411013',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16529,50,'Iaf Station','411032',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16530,50,'Indrayaninagar','411026',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16531,50,'Infotech  Park (Hinjawadi)','411057',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16532,50,'Jambhe','411033',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16533,50,'Kalewadi','411017',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16534,50,'Kasarwadi','411034',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16535,50,'Khadki Bazar','411003',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16536,50,'Khadki','411003',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16537,50,'Khondhwa KH','411048',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16538,50,'Kondhwa BK','411048',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16539,50,'Kondhwa Lh','411048',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16540,50,'Lohogaon','411047',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16541,50,'M.Phulenagar','411019',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16542,50,'Market Yard (Pune)','411037',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16543,50,'Marunji','411057',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16544,50,'Masulkar Colony','411018',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16545,50,'Mohamadwadi','411060',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16546,50,'Mundhva AV','411036',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16547,50,'Mundhva','411036',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16548,50,'N I B M','411048',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16549,50,'N.W. College','411001',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16550,50,'Nehrunagar (Pune)','411018',1,0,'2022-03-03 12:26:55','2022-03-03 12:26:55'),(16551,50,'P.C.N.T.','411044',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16552,50,'Pimple Gurav','411061',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16553,50,'Pimpri Colony','411017',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16554,50,'Pimpri P F','411018',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16555,50,'Pimpri Waghire','411017',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16556,50,'Punawale','411033',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16557,50,'Pune Cantt East','411001',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16558,50,'Pune H.O','411001',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16559,50,'Pune New Bazar','411001',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16560,50,'Rupeenagar','411062',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16561,50,'Sachapir Street','411001',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16562,50,'Salisbury Park','411037',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16563,50,'Sangavi','411027',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16564,50,'Sasanenagar','411028',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16565,50,'Srpf','411022',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16566,50,'T.V. Nagar','411037',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16567,50,'Talwade','411062',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16568,50,'Thathawade','411033',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16569,50,'Thergaon','411033',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16570,50,'Vadgaon Sheri','411014',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16571,50,'Vidyanagar (Pune)','411032',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16572,50,'Viman nagar','411014',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16573,50,'Vishrantwadi','411015',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16574,50,'Wakad','411057',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16575,50,'Wanowarie','411040',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16576,50,'Yamunanagar','411044',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16577,50,'Yerwada','411006',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16578,50,'Yerwada T.S.','411006',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16579,50,'A.R. Shala','411004',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16580,50,'Ambegaon BK','411046',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16581,50,'Anandnagar (Pune)','411051',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16582,50,'Armament','411021',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16583,50,'Aundh','411007',1,0,'2022-03-03 12:26:56','2022-03-03 12:26:56'),(16584,50,'Aundh T.S.','411007',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16585,50,'Bajirao Road','411002',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16586,50,'Baner Gaon','411045',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16587,50,'Baner Road','411008',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16588,50,'Bavdhan','411021',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16589,50,'Bhavani Peth','411042',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16590,50,'Bhusari Colony','411038',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16591,50,'Botanical Garden (Pune)','411020',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16592,50,'Congress House Road','411005',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16593,50,'Deccan Gymkhana','411004',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16594,50,'Dhankawadi','411043',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16595,50,'Dhayari','411041',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16596,50,'Ex. Serviceman Colony','411038',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16597,50,'Film Institute','411004',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16598,50,'Ganeshkhind','411007',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16599,50,'Ghorpade Peth','411042',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16600,50,'Gokhalenagar','411016',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16601,50,'Govt. Polytechnic','411016',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16602,50,'Guruwar Peth','411042',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16603,50,'Kapad Ganj','411002',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16604,50,'Karvenagar','411052',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16605,50,'Kasba Peth','411011',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16606,50,'Katraj','411046',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16607,50,'Khadakwasla R.S.','411024',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16608,50,'Kothrud','411038',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16609,50,'Kudje','411023',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16610,50,'Lokmanyanagar','411030',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16611,50,'Mandvi BK','411023',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16612,50,'Mangalwar Peth (Pune)','411011',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16613,50,'Model Colony','411016',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16614,50,'N.C.L. Pune','411008',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16615,50,'N.D.A. Khadakwasla','411023',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16616,50,'N.I.A.','411045',1,0,'2022-03-03 12:26:57','2022-03-03 12:26:57'),(16617,50,'Nana Peth','411002',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16618,50,'Nanded','411041',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16619,50,'Narayan Peth','411030',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16620,50,'Navsahyadri','411052',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16621,50,'Parvati Gaon','411009',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16622,50,'Parvati','411009',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16623,50,'Pune City H.O','411002',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16624,50,'Range Hills','411020',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16625,50,'Rashtra Bhasha Bhavan','411030',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16626,50,'Rasta Peth','411011',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16627,50,'Raviwar Peth','411002',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16628,50,'S.P. College','411030',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16629,50,'S.S.C.Exam Board','411005',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16630,50,'Sadashiv Peth','411030',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16631,50,'Shaniwar Peth (Pune)','411030',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16632,50,'Shivaji Housing Society','411016',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16633,50,'Shivajinagar (Pune)','411005',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16634,50,'Shivane','411023',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16635,50,'Shukrawar Peth (Pune)','411002',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16636,50,'Sinhgad Technical Education Society','411041',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16637,50,'Sus','411021',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16638,50,'Swargate Chowk','411042',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16639,50,'Swargate','411042',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16640,50,'Uttamnagar','411023',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16641,50,'Vadgaon Budruk','411041',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16642,50,'Warje','411058',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16643,50,'Adhale BK','410506',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16644,50,'Adivare','410509',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16645,50,'Agoti','413132',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16646,50,'Ala (Pune)','412411',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16647,50,'Alande','412205',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16648,50,'Alandi Chorachi','412201',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16649,50,'Alandi Devachi','412105',1,0,'2022-03-03 12:26:58','2022-03-03 12:26:58'),(16650,50,'Alegaon','413801',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16651,50,'Alegaon','412211',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16652,50,'Alephata','412411',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16653,50,'Ambade','412206',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16654,50,'Ambale','410507',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16655,50,'Ambarvet','412115',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16656,50,'Ambavade','412206',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16657,50,'Ambavane','410401',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16658,50,'Ambavane','412213',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16659,50,'Ambeghar','412206',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16660,50,'Ambethan','410501',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16661,50,'Ambi','410507',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16662,50,'Amble','412211',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16663,50,'Amboli','410505',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16664,50,'Amboli','410502',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16665,50,'Amdabad','412218',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16666,50,'Amondi','412408',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16667,50,'Anantnagar Nigade','412205',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16668,50,'Andgaon','412115',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16669,50,'Andhalgaon','412211',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16670,50,'Ane','412410',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16671,50,'Anjanavale','410502',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16672,50,'Anthurne','413114',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16673,50,'Antroli','412212',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16674,50,'Aptale','410502',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16675,50,'Apti','412206',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16676,50,'Arvi (Pune)','412401',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16677,50,'Arvi(Haveli)','412205',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16678,50,'Asane','410509',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16679,50,'Ashtapur','412207',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16680,50,'Audar','412404',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16681,50,'Avasari BK','412406',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16682,50,'Avhat','412402',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16683,50,'Avsari KH','412405',1,0,'2022-03-03 12:26:59','2022-03-03 12:26:59'),(16684,50,'Babhurdi','412204',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16685,50,'Bahul','410501',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16686,50,'Ballalwadi','410502',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16687,50,'Baramati Court','413102',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16688,50,'Baramati MIDC','413133',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16689,50,'Baramati','413102',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16690,50,'Barhanpur','413102',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16691,50,'Bari BK','412206',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16692,50,'Bawada','413103',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16693,50,'Bazarwadi','412206',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16694,50,'Beam Wirelee Station','413801',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16695,50,'Bebedhol','410506',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16696,50,'Belawade','412108',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16697,50,'Belawadi','413104',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16698,50,'Belha','412410',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16699,50,'Belsar','412303',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16700,50,'Bet Narayan Maharaj','412203',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16701,50,'Bhadas','412108',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16702,50,'Bhamburde','412209',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16703,50,'Bhandgaon','412214',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16704,50,'Bhandgaon','413103',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16705,50,'Bhavaninagar (Pune)','413104',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16706,50,'Bhigwan R S','413105',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16707,50,'Bhigwan','413130',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16708,50,'Bhimashankar','410509',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16709,50,'Bhivadi','412301',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16710,50,'Bhivari','412301',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16711,50,'Bhodani','413103',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16712,50,'Bhondave Wadi','412204',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16713,50,'Bhongavali','412205',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16714,50,'Bhor','412206',1,0,'2022-03-03 12:27:00','2022-03-03 12:27:00'),(16715,50,'Bhorghar','410509',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16716,50,'Bhorgiri','412402',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16717,50,'Bhose','410501',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16718,50,'Bhoyare','412106',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16719,50,'Bhugaon','412115',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16720,50,'Bhukum','412115',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16721,50,'Bhutonde','412206',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16722,50,'Bibi','410513',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16723,50,'Bijawadi','413106',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16724,50,'Bopgaon','412301',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16725,50,'Bori Aindi','412202',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16726,50,'Bori','413104',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16727,50,'Bori BK','412411',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16728,50,'Bori Paradhi','412203',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16729,50,'Boribyal','413801',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16730,50,'Burunjwadi','412208',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16731,50,'Chakan','410501',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16732,50,'Chambli','412301',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16733,50,'Chandkhed','410506',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16734,50,'Chandoli BK','410503',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16735,50,'Charoli BK','412105',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16736,50,'Chas','410515',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16737,50,'Chas (Pune)','410513',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16738,50,'Chavand','410502',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16739,50,'Chikhalgaon','412206',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16740,50,'Chilewadi','412409',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16741,50,'Chimbli','412105',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16742,50,'Chinchani Camp','412211',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16743,50,'Chincholi','412218',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16744,50,'Chincholi','413130',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16745,50,'Chinchoshi','410505',1,0,'2022-03-03 12:27:01','2022-03-03 12:27:01'),(16746,50,'Cod Dehu Road','412101',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16747,50,'Dahitane','412207',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16748,50,'Dalaj','413132',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16749,50,'Dapode','412213',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16750,50,'Dasve Lavasa','412112',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16751,50,'Daund','413801',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16752,50,'Daundaj','412305',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16753,50,'Dawadi','410505',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16754,50,'Dawanewadi','412311',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16755,50,'Degaon','412213',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16756,50,'Dehane','412402',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16757,50,'Dehu Road Cantt','412101',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16758,50,'Dehu','412109',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16759,50,'Delwadi','412214',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16760,50,'Deulgaonraja','413801',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16761,50,'Devale','410502',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16762,50,'Dhakale','413110',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16763,50,'Dhamane','410506',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16764,50,'Dhamani','410508',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16765,50,'Dhamari','412403',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16766,50,'Dhangavadi','412205',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16767,50,'Dhanore','412105',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16768,50,'Dhanore','412208',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16769,50,'Dhekalwadi','413104',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16770,50,'Dholwad','412409',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16771,50,'Dimbhe Colony','410509',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16772,50,'Dingore','412409',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16773,50,'Diwa','412301',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16774,50,'Donda','410505',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16775,50,'Donje','411025',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16776,50,'Dorlewadi','413102',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16777,50,'Eklahare','412402',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16778,50,'Fulgaon','412216',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16779,50,'Gadad','410501',1,0,'2022-03-03 12:27:02','2022-03-03 12:27:02'),(16780,50,'Galandwadi','412203',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16781,50,'Ganegaon Dumala','412211',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16782,50,'Ganegaon Khalasa','412209',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16783,50,'Gangapur KH','410516',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16784,50,'Garade','412301',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16785,50,'Gawadewadi','412405',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16786,50,'Ghodegaon (Pune)','412408',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16787,50,'Ghotavade','412115',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16788,50,'Ghotawadi','410505',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16789,50,'Ghotondi','413120',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16790,50,'Girawali','412408',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16791,50,'Girim','413801',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16792,50,'Godre','410502',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16793,50,'Gogalwadi(E)','412205',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16794,50,'Gohe BK','410509',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16795,50,'Golegaon','412210',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16796,50,'Gopalwadi','413801',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16797,50,'Gulani','410505',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16798,50,'Gulunche','412102',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16799,50,'Gunawadi','413102',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16800,50,'Gunjalwadi','412401',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16801,50,'Gunjawane','412213',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16802,50,'Gurholi','412104',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16803,50,'Hargude','412311',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16804,50,'Harnas','412206',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16805,50,'Harni','412305',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16806,50,'Hatve BK','412213',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16807,50,'Hingangaon','413106',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16808,50,'Hingniberdi','413801',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16809,50,'Hirdoshi','412206',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16810,50,'Hivare','412301',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16811,50,'Hivare','412208',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16812,50,'Hivare BK','410504',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16813,50,'Hivare KH','412409',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16814,50,'Hol','412306',1,0,'2022-03-03 12:27:03','2022-03-03 12:27:03'),(16815,50,'I.A.T','411025',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16816,50,'Inamgaon','412210',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16817,50,'Indapur Bazar','413106',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16818,50,'Indapur','413106',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16819,50,'Induri','410507',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16820,50,'Inglun','410502',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16821,50,'Inglun','412106',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16822,50,'Ins Shivaji Lonavale','410402',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16823,50,'Jalgaon Kadepathar','413102',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16824,50,'Jambhali BK','412213',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16825,50,'Jambhori','410509',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16826,50,'Jambhut','410504',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16827,50,'Jategaon BK','412208',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16828,50,'Javalarjun','412303',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16829,50,'Jejuri','412303',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16830,50,'Jeur','412305',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16831,50,'Jhargadwadi','413102',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16832,50,'Jogwadi','412206',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16833,50,'Junnar','410502',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16834,50,'Kadadhe','410513',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16835,50,'Kadam Wak Wasti','412201',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16836,50,'Kadethan','412215',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16837,50,'Kadus','412404',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16838,50,'Kadve','412107',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16839,50,'Kaivalyadham','410403',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16840,50,'Kalamb','413114',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16841,50,'Kalamb (Pune)','410515',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16842,50,'Kalas','413105',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16843,50,'Kalashi','413106',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16844,50,'Kaldari','412311',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16845,50,'Kalewadi','413801',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16846,50,'Kalthan No 1','413106',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16847,50,'Kalus','410501',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16848,50,'Kalyan','412205',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16849,50,'Kambaleshwar','413110',1,0,'2022-03-03 12:27:04','2022-03-03 12:27:04'),(16850,50,'Kambegi','412107',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16851,50,'Kamdhenunagar','412202',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16852,50,'Kamshet','410405',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16853,50,'Kamthadi','412213',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16854,50,'Kanakwadi','412206',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16855,50,'Kandali','412412',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16856,50,'Kangaon','412219',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16857,50,'Kanhe','412106',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16858,50,'Kanhersar','410505',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16859,50,'Kanhur','412218',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16860,50,'Kapurhol','412205',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16861,50,'Karandi','412208',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16862,50,'Karandi BK','412206',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16863,50,'Karandi Khedebare','412213',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16864,50,'Karanjawane','412209',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16865,50,'Karanjawane','412213',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16866,50,'Karanje','412306',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16867,50,'Karanjgaon','410405',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16868,50,'Karawaghaj','413102',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16869,50,'Karda','412210',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16870,50,'Karegaon','412220',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16871,50,'Karegaon','410512',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16872,50,'Karhati','412204',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16873,50,'Kari','412206',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16874,50,'Karkhel','413102',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16875,50,'Karla','410405',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16876,50,'Karnawad','412206',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16877,50,'Karunj','410405',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16878,50,'Kasari','412208',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16879,50,'Kasarsai','410506',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16880,50,'Kashedi','412107',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16881,50,'Kashing','412108',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16882,50,'Kasurdi','412214',1,0,'2022-03-03 12:27:05','2022-03-03 12:27:05'),(16883,50,'Katfal','413133',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16884,50,'Kati','413120',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16885,50,'Katyachiwadi','413104',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16886,50,'Kawtha','412218',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16887,50,'Kazad','413104',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16888,50,'Kedgaon (Pune)','412203',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16889,50,'Kelawade','412213',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16890,50,'Kendur','412403',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16891,50,'Kenjal','412205',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16892,50,'Kesnand','412207',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16893,50,'Ketkavale','412205',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16894,50,'Khadaki','413130',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16895,50,'Khadkumbe(Exptl)','410502',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16896,50,'Khalad','412301',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16897,50,'Khalumbre','410501',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16898,50,'Khamboli','412115',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16899,50,'Khamgaon','410502',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16900,50,'Khamgaon BK','412214',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16901,50,'Khamundi','410504',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16902,50,'Khanapur','412206',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16903,50,'Khanapur','410502',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16904,50,'Khanapur Haveli','411025',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16905,50,'Khandaj','413116',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16906,50,'Khandala','410301',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16907,50,'Khandi','412106',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16908,50,'Khandobachi Wadi','412102',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16909,50,'Khangaon','410502',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16910,50,'Khanote','413105',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16911,50,'Kharoshi','412402',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16912,50,'Khechare','412108',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16913,50,'Khed Shivapur','412205',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16914,50,'Khed Shivapur Baug','412205',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16915,50,'Khodad','410504',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16916,50,'Khopodi','412203',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16917,50,'Khor','412203',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16918,50,'Khorochi','413114',1,0,'2022-03-03 12:27:06','2022-03-03 12:27:06'),(16919,50,'Khubi','412409',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16920,50,'Khutbhav','412203',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16921,50,'Kikvi','412205',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16922,50,'Kiwale','410505',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16923,50,'Kiwale','412101',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16924,50,'Kodapur','412212',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16925,50,'Kodit','412301',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16926,50,'Kohinde BK','412404',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16927,50,'Kolawade','412115',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16928,50,'Kolvadi','412412',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16929,50,'Kolvihire','412303',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16930,50,'Kolwadi','412213',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16931,50,'Kolwadi','412110',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16932,50,'Kolwan','412108',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16933,50,'Kondhanpur','412205',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16934,50,'Kondhapuri','412209',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16935,50,'Kondhawale','412108',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16936,50,'Kondhwal','410509',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16937,50,'Koregaon Bhima','412216',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16938,50,'Koregaon Bhivar','412207',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16939,50,'Koregaon Mul','412202',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16940,50,'Korhale BK','412103',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16941,50,'Korhale KH','412103',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16942,50,'Kothale','412303',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16943,50,'Koyali','410501',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16944,50,'Kude BK','410505',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16945,50,'Kule','412108',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16946,50,'Kunjirwadi','412201',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16947,50,'Kuran','410511',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16948,50,'Kuran BK','412107',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16949,50,'Kuravali','413104',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16950,50,'Kurkumbh','413802',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16951,50,'Kurkundi','410505',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16952,50,'Kuruli','410501',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16953,50,'Kurungwadi','412213',1,0,'2022-03-03 12:27:07','2022-03-03 12:27:07'),(16954,50,'Kurwande','410402',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16955,50,'Kurwandi','410512',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16956,50,'Kusgaon','412219',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16957,50,'Kusgaon','412205',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16958,50,'Kusgaon BK','410401',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16959,50,'Kushire BK','410509',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16960,50,'Kusur','410502',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16961,50,'Lakhangaon','412406',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16962,50,'Lakhewadi','413103',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16963,50,'Landewadi','410503',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16964,50,'Lasurna','413114',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16965,50,'Late','412103',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16966,50,'Lawale','412115',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16967,50,'Lonavala Bazar','410401',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16968,50,'Lonavala','410401',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16969,50,'Loni Bhapkar','413110',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16970,50,'Loni Deokar','413132',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16971,50,'Loni Dhamani','410510',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16972,50,'Loni Kalbhor','412201',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16973,50,'Lonikand','412216',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16974,50,'Madanwadi','413130',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16975,50,'Madh','412409',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16976,50,'Madhukarnagar Patas','412219',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16977,50,'Mahalunge Ingale','410501',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16978,50,'Mahalunge Padwal','410515',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16979,50,'Mahude BK','412206',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16980,50,'Mahur','412311',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16981,50,'Malad','413102',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16982,50,'Malad','413130',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16983,50,'Malawali','410405',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16984,50,'Male','412206',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16985,50,'Male','412108',1,0,'2022-03-03 12:27:08','2022-03-03 12:27:08'),(16986,50,'Malegaon BK','413115',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(16987,50,'Malegaon IRR Colony','413115',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(16988,50,'Malewadi','412206',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(16989,50,'Malshiras','412104',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(16990,50,'Malthan','413801',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(16991,50,'Malthan','412218',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(16992,50,'Manappawasti','413110',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(16993,50,'Manchar','410503',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(16994,50,'Mandave','412409',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(16995,50,'Mandavgan Farata','412211',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(16996,50,'Mandhar','412311',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(16997,50,'Mandki','412305',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(16998,50,'Mangaon','412107',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(16999,50,'Mangrul','412410',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(17000,50,'Manikdoh','410502',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(17001,50,'Manjal Asani','412213',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(17002,50,'Manjari BK','412307',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(17003,50,'Manjari Farm','412307',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(17004,50,'Margasni','412213',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(17005,50,'Markal','412105',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(17006,50,'Mavdi Kade Pathar','412303',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(17007,50,'Medad','413102',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(17008,50,'Mekhali','413102',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(17009,50,'Midc Kurkumbh','413802',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(17010,50,'Midc Ranjangaon Ganpati','412220',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(17011,50,'Morgaon','412304',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(17012,50,'Mose KH','412107',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(17013,50,'Moshi','412105',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(17014,50,'Mudhale','413110',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(17015,50,'Mukhai','412208',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(17016,50,'Murti Modhave','412304',1,0,'2022-03-03 12:27:09','2022-03-03 12:27:09'),(17017,50,'Murum','412306',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17018,50,'Muthe','412115',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17019,50,'Naiphad','412402',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17020,50,'Nalavane','412410',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17021,50,'Nandgaon','412108',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17022,50,'Nane','410405',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17023,50,'Nangaon','412203',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17024,50,'Nanvij','413801',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17025,50,'Narayangaon','410504',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17026,50,'Narodi','410503',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17027,50,'Nasrapur','412213',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17028,50,'Natambi','412206',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17029,50,'Nathachi Wadi','412214',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17030,50,'Naygaon','412110',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17031,50,'Naygaon','412104',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17032,50,'Nazare','412206',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17033,50,'Nazare Kade Pathar','412303',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17034,50,'Nere','412206',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17035,50,'Netwad','412409',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17036,50,'Nhavare','412211',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17037,50,'Nhavi','413132',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17038,50,'Nhavi','412205',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17039,50,'Nighoje','410501',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17040,50,'Nimbut','412102',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17041,50,'Nimgaon Bhogi','412220',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17042,50,'Nimgaon Ketki','413120',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17043,50,'Nimgaon Khed','410505',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17044,50,'Nimgaon Mahalungi','412209',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17045,50,'Nimgaon Sava','410504',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17046,50,'Nimgiri','410502',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17047,50,'Nimone','412210',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17048,50,'Nimsakhar','413114',1,0,'2022-03-03 12:27:10','2022-03-03 12:27:10'),(17049,50,'Nira R S','412102',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17050,50,'Nirawaghaj','413102',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17051,50,'Nirgude','410502',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17052,50,'Nirgude','413130',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17053,50,'Nirgudsar','412406',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17054,50,'Nirvi','412210',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17055,50,'Nirwangi','413114',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17056,50,'Ordanance Dep Talegaon Dabhade','410506',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17057,50,'Ordnance Factory Dehu Road','412101',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17058,50,'Osade','411025',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17059,50,'Otur','412409',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17060,50,'Ozar','410504',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17061,50,'Pabal','412403',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17062,50,'Pabe','412212',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17063,50,'Padvi','412203',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17064,50,'Pait','410505',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17065,50,'Palasdeo','413132',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17066,50,'Palu','410505',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17067,50,'Panawadi','412301',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17068,50,'Pandare','413110',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17069,50,'Pandheshwar','412303',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17070,50,'Pangare','412301',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17071,50,'Pangari','412206',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17072,50,'Panshet','412107',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17073,50,'Pargaon','412203',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17074,50,'Pargaon Memane','412104',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17075,50,'Pargaon Tarfe Ala','410504',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17076,50,'Pargaon Tarfe Avasari','412406',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17077,50,'Pargaon Tarfe Khed','410512',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17078,50,'Pargaon Tarfe Madh','412409',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17079,50,'Parinche','412311',1,0,'2022-03-03 12:27:11','2022-03-03 12:27:11'),(17080,50,'Parunde','410502',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17081,50,'Parwadi','413130',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17082,50,'Pasure','412206',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17083,50,'Patas','412219',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17084,50,'Paud','412108',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17085,50,'Pawananagar','410406',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17086,50,'Perne','412216',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17087,50,'Peth (Pune)','410512',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17088,50,'Phulawade','410509',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17089,50,'Phursungi','412308',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17090,50,'Pimpalgaon Joga','412409',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17091,50,'Pimpalgaon Mahalunge','410503',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17092,50,'Pimpalgaon Tarfa Narayangaon','412401',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17093,50,'Pimpalgaon Tarfe Chakan','410501',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17094,50,'Pimpalgaon Tarfe Ghoda','412408',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17095,50,'Pimpali','413102',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17096,50,'Pimpalwandi (Pune)','412412',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17097,50,'Pimparkhed','410504',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17098,50,'Pimple','412301',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17099,50,'Pimpri','412303',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17100,50,'Pimpri BK','413103',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17101,50,'Pimpri BK','410505',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17102,50,'Pimpri Pendhar','410504',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17103,50,'Pimpri Sandas','412216',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17104,50,'Pingori','412305',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17105,50,'Pirangut','412115',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17106,50,'Pisarve','412104',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17107,50,'Pisavare','412206',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17108,50,'Pokhari','410509',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17109,50,'Pomgaon','412108',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17110,50,'R P T S Khandala','410302',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17111,50,'Rahu','412207',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17112,50,'Rahu Pimpalgaon','412214',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17113,50,'Rajegaon','413105',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17114,50,'Rajewadi','412104',1,0,'2022-03-03 12:27:12','2022-03-03 12:27:12'),(17115,50,'Rajgurunagar','410505',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17116,50,'Rajpur','410509',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17117,50,'Rajur','410502',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17118,50,'Rajuri','412411',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17119,50,'Rajuri','412104',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17120,50,'Rakh','412305',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17121,50,'Rangaon','413114',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17122,50,'Ranjane','411025',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17123,50,'Ranjangaon Ganpati','412209',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17124,50,'Ranjangaon Sandas','412211',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17125,50,'Ranjani','410504',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17126,50,'Ranmala','412303',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17127,50,'Rase','410501',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17128,50,'Ravangaon','413130',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17129,50,'Ravet','412101',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17130,50,'Rayari','412206',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17131,50,'Redni','413114',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17132,50,'Retwadi','410505',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17133,50,'Rihe','412115',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17134,50,'Rohokadi','412409',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17135,50,'Roti','412219',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17136,50,'Rule','412107',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17137,50,'S R P F Daund','413801',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17138,50,'Saburdi','412404',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17139,50,'Sadalgaon','412211',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17140,50,'Sadumbre','412109',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17141,50,'Sahajpurwadi','412202',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17142,50,'Sakhar','412213',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17143,50,'Sakore','410515',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17144,50,'Sakori Tarfe Belha','412410',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17145,50,'Sakurde','412303',1,0,'2022-03-03 12:27:13','2022-03-03 12:27:13'),(17146,50,'Sal','412408',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17147,50,'Salumbre','412101',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17148,50,'Sanaswadi','412208',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17149,50,'Sandbhorwadi(Exptl)','410505',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17150,50,'Sangamner','412206',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17151,50,'Sangavi','412206',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17152,50,'Sangrun','412115',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17153,50,'Sangvi','413102',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17154,50,'Sansar','413104',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17155,50,'Sapkalwadi','413104',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17156,50,'Sarati','413103',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17157,50,'Sarole','412205',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17158,50,'Saswad','412301',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17159,50,'Sate','412106',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17160,50,'Saval','413133',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17161,50,'Savargaon','412401',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17162,50,'Savindane','410510',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17163,50,'Saygaon','412404',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17164,50,'Shelgaon','413114',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17165,50,'Shere','412108',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17166,50,'Shetfalgade','413130',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17167,50,'Shetphal Haveli','413103',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17168,50,'Shiavane','410506',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17169,50,'Shikrapur','412208',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17170,50,'Shind','412206',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17171,50,'Shindavane','412202',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17172,50,'Shindewadi','412205',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17173,50,'Shinoli','410516',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17174,50,'Shirapur','413801',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17175,50,'Shirasane','413110',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17176,50,'Shirasgaonkata','412210',1,0,'2022-03-03 12:27:14','2022-03-03 12:27:14'),(17177,50,'Shiravali','413102',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17178,50,'Shirgaon','412402',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17179,50,'Shirgaon','412206',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17180,50,'Shirkoli','412107',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17181,50,'Shiroli B K','410511',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17182,50,'Shiroli','410505',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17183,50,'Shirsatwadi','413114',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17184,50,'Shirsuphal','413102',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17185,50,'Shirur (Pune)','412210',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17186,50,'Shivajinagar H.O','411005',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17187,50,'Shivali','410406',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17188,50,'Shivare','412205',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17189,50,'Shivari','412301',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17190,50,'Shive','410501',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17191,50,'Shivnagar','413116',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17192,50,'Shriprayagdham','412202',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17193,50,'Solu','412105',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17194,50,'Someshwarnagar','412306',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17195,50,'Sonari','412301',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17196,50,'Songaon','413102',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17197,50,'Sopannagar','412301',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17198,50,'Supa (Pune)','412204',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17199,50,'Surwad','413103',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17200,50,'Takali Bhima','412208',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17201,50,'Takave KH','410405',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17202,50,'Takawe BK','412106',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17203,50,'Taklihaji','412218',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17204,50,'Talegaon Dabhade','410506',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17205,50,'Talegaon Dhamdhere','412208',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17206,50,'Talegaon G H','410507',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17207,50,'Taleghar','410509',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17208,50,'Taleran','412409',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17209,50,'Tambad','412213',1,0,'2022-03-03 12:27:15','2022-03-03 12:27:15'),(17210,50,'Tambe','410502',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17211,50,'Tandali','412211',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17212,50,'Tandulwadi','413102',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17213,50,'Taparewadi','412205',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17214,50,'Tav','412107',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17215,50,'Tavshi','413104',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17216,50,'Tekawade','412104',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17217,50,'Telewadi','412207',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17218,50,'Theur','412110',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17219,50,'Thugaon','410512',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17220,50,'Tirpad','410509',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17221,50,'Titeghar','412206',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17222,50,'Tiwai Hills','410513',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17223,50,'Tokawade','412402',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17224,50,'Tondal','412312',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17225,50,'Udapur','412409',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17226,50,'Udhat','413104',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17227,50,'Umbraj','412412',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17228,50,'Umbre Navlakh','410507',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17229,50,'Undawadi K P','413102',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17230,50,'Undawadi Supa','413102',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17231,50,'Uralgaon','412211',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17232,50,'Uravade','412115',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17233,50,'Urse','410506',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17234,50,'Uruli Devachi','412308',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17235,50,'Urulikanchan','412202',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17236,50,'Utchil','410502',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17237,50,'Utroli','412206',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17238,50,'Vada (Pune)','412402',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17239,50,'Vadaj','410502',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17240,50,'Vadapuri','413106',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17241,50,'Vadebholhai','412207',1,0,'2022-03-03 12:27:16','2022-03-03 12:27:16'),(17242,50,'Vadeshwar','412106',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17243,50,'Vadgaon Anand','412411',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17244,50,'Vadgaon Dalache','412206',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17245,50,'Vadgaon Ghenanad','410501',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17246,50,'Vadgaon Kandali','412412',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17247,50,'Vadgaon Kashimbeg','410503',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17248,50,'Vadgaon Nimbalkar','412103',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17249,50,'Vadgaon Peer','410510',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17250,50,'Vadgaon Rasai','412211',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17251,50,'Vadgaon (Pune)','412106',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17252,50,'Vadgaon Sahani','412401',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17253,50,'Vadhu BK','412216',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17254,50,'Vadki','412308',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17255,50,'Vagholi','412207',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17256,50,'Valati','410504',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17257,50,'Valha','412305',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17258,50,'Vanpuri','412301',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17259,50,'Vaphgaon','410505',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17260,50,'Varale','410507',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17261,50,'Vardade','411025',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17262,50,'Varkute KH','413120',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17263,50,'Varodi KH','412206',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17264,50,'Varoti BK','412212',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17265,50,'Varude','410505',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17266,50,'Varude','412209',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17267,50,'Varvand','412215',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17268,50,'Varye BK','412205',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17269,50,'Vasuli','410501',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17270,50,'Veer','412312',1,0,'2022-03-03 12:27:17','2022-03-03 12:27:17'),(17271,50,'Vehergaon','410405',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17272,50,'Velhe','412212',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17273,50,'Velu','412205',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17274,50,'Velvand','412206',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17275,50,'Venavadi','412206',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17276,50,'Vetale','412404',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17277,50,'Vishnupuri','410507',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17278,50,'Vithalwadi','412208',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17279,50,'Vyahali','413120',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17280,50,'Waghapur','412104',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17281,50,'Waki','412306',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17282,50,'Waki BK','410501',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17283,50,'Walchandnagar','413114',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17284,50,'Walki','412207',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17285,50,'Walunj','412303',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17286,50,'Wangani','412213',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17287,50,'Washere','412404',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17288,50,'Watluj','413105',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17289,50,'Winzer','412213',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17290,50,'Yavat R S','412214',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17291,50,'Yavat','412214',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17292,50,'Yedgaon','410504',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17293,50,'Yenere','410502',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17294,50,'Yeniye BK','410505',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17295,51,'Elephanta Caves Po','400001',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17296,51,'Adai','410206',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17297,51,'Ajivali','410221',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17298,51,'Ambivali','410201',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17299,51,'Apta','410207',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17300,51,'Awre','410206',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17301,51,'Barapada','410221',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17302,51,'Beed Budruk','410201',1,0,'2022-03-03 12:27:18','2022-03-03 12:27:18'),(17303,51,'Bhivpuri Camp','410201',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17304,51,'Bokadvira','400702',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17305,51,'Borgaon','410101',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17306,51,'Chanje','400702',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17307,51,'Chawk','410206',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17308,51,'Chikhale','410221',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17309,51,'Chinchwali','410201',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17310,51,'Chirner','410206',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17311,51,'Dahivali T.Need','410201',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17312,51,'Dahivali T.Varedi','410101',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17313,51,'Devichapada','410208',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17314,51,'Dighode','410206',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17315,51,'Donwat','410203',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17316,51,'Gaulwadi','410201',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17317,51,'Gaurkamath','410201',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17318,51,'Gavan','410206',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17319,51,'Gulsunde','410207',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17320,51,'Gundge','410201',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17321,51,'Humgaon','410201',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17322,51,'Jagdish Nagar','410216',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17323,51,'Jambrung','410201',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17324,51,'Jasai','410206',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17325,51,'Jaskhar','400707',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17326,51,'Jci Kamothe','410206',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17327,51,'Jnpt','400707',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17328,51,'Jui','410206',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17329,51,'Kadav','410201',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17330,51,'Kalamb','410101',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17331,51,'Kalamboli Node','410218',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17332,51,'Karanja','400702',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17333,51,'Karjat (Raigarh(MH))','410201',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17334,51,'Kashele','410201',1,0,'2022-03-03 12:27:19','2022-03-03 12:27:19'),(17335,51,'Kegaon','400702',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17336,51,'Kelevane','410206',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17337,51,'Khalapur','410202',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17338,51,'Khambewadi','410203',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17339,51,'Khanda Colony','410206',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17340,51,'Khandas','410201',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17341,51,'Kharghar','410210',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17342,51,'Khopoli Power House','410204',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17343,51,'Khopoli','410203',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17344,51,'Kirwali','410201',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17345,51,'Kondivade','410201',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17346,51,'Koproli','410206',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17347,51,'Koshane','410201',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17348,51,'Koynavale','410208',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17349,51,'Kundevahal','410206',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17350,51,'Lodhivali','410206',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17351,51,'Mandavane','410201',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17352,51,'Mangaon T.Varedi','410101',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17353,51,'Manivali','410101',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17354,51,'Matheran','410102',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17355,51,'Mazgaon','410220',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17356,51,'Mohopada','410222',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17357,51,'Mora','400704',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17358,51,'Morbe','410206',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17359,51,'N.S.Karanja','400704',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17360,51,'Nandgaon','410201',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17361,51,'Nasarapur','410201',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17362,51,'Navde','410208',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17363,51,'Navghar','400707',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17364,51,'Neral','410101',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17365,51,'Nere','410206',1,0,'2022-03-03 12:27:20','2022-03-03 12:27:20'),(17366,51,'Nhava','410206',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17367,51,'Ongc Complex','panvel',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17368,51,'ONGC-dronagiri','400702',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17369,51,'Padghe','410208',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17370,51,'Palasdari','410201',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17371,51,'Palaspe','410221',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17372,51,'Panvel City','410206',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17373,51,'Panvel H.O','410206',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17374,51,'Pargaon','410206',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17375,51,'Patalganga','410220',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17376,51,'Pathraj','410201',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17377,51,'Poshir','410101',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17378,51,'Poyanje','410221',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17379,51,'Rasayani','410207',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17380,51,'Sai','410221',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17381,51,'Sajgaon','410203',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17382,51,'Salokh T.Need','410201',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17383,51,'Shelu','410101',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17384,51,'Sheva','400702',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17385,51,'Shilphata','410203',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17386,51,'Shirdhon','410221',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17387,51,'Somatane','410206',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17388,51,'Sugawe','410201',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17389,51,'Taloja A.V.','410208',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17390,51,'Taloja','410208',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17391,51,'Tiware','410201',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17392,51,'Tondra','410208',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17393,51,'Ulwa','410206',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17394,51,'Uran','400702',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17395,51,'Vahal','410206',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17396,51,'Vaje','410206',1,0,'2022-03-03 12:27:21','2022-03-03 12:27:21'),(17397,51,'Vakas','410101',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17398,51,'Vasheni','410206',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17399,51,'Vashivali','410220',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17400,51,'Vavoshi','410203',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17401,51,'Vengaon','410201',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17402,51,'Wavandhal','410206',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17403,51,'Wavarle','410206',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17404,51,'Wawanje','410208',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17405,51,'Achloli','402305',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17406,51,'Adavale Budruk','402303',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17407,51,'Adgaon','402403',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17408,51,'Adhi','402103',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17409,51,'Agardanda','402401',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17410,51,'Agrav','402203',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17411,51,'Ainghar','402126',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17412,51,'Akshi','402204',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17413,51,'Alibag H.O','402201',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17414,51,'Ambavade','402307',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17415,51,'Ambeghar','402107',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17416,51,'Ambet','402101',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17417,51,'Ambivali','402301',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17418,51,'Amtem','402106',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17419,51,'Aravi','402113',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17420,51,'Ashtami','402109',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17421,51,'Atone','410205',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17422,51,'Awas','402208',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17423,51,'Bagmandla','402114',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17424,51,'Balavali','402107',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17425,51,'Bamangaon','402204',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17426,51,'Bamnoli','402104',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17427,51,'Bapale','402203',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17428,51,'Barasgaon','402306',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17429,51,'Bense','402106',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17430,51,'Bhairav','410205',1,0,'2022-03-03 12:27:22','2022-03-03 12:27:22'),(17431,51,'Bhale','402120',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17432,51,'Bhalgaon','402109',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17433,51,'Bharadkhol','402404',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17434,51,'Bharje','410205',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17435,51,'Bhave','402302',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17436,51,'Bhira (Raigarh(MH))','402308',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17437,51,'Bhonang','402111',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17438,51,'Bhoste','402110',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17439,51,'Birwadi','402302',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17440,51,'Borghar','402303',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17441,51,'Borghar Haveli','402111',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17442,51,'Borlimandla','402202',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17443,51,'Borlipanchatan','402403',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17444,51,'Borwadi','402120',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17445,51,'Chambhargani','402303',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17446,51,'Chandgaon','402109',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17447,51,'Chandhave Budruk','402301',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17448,51,'Chandore','402122',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17449,51,'Chanera','402109',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17450,51,'Chaul','402203',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17451,51,'Chikhlap','402105',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17452,51,'Chikhlap','402113',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17453,51,'Chimbhave','415213',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17454,51,'Chinchoti','402203',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17455,51,'Chinchwali Tarfe Atone','402304',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17456,51,'Chive','410205',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17457,51,'Chochinde','402301',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17458,51,'Chondhi','402208',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17459,51,'Chordhe','402109',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17460,51,'Dabhol','402102',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17461,51,'Dadar','402107',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17462,51,'Dahigaon','410205',1,0,'2022-03-03 12:27:23','2022-03-03 12:27:23'),(17463,51,'Dahivad','402302',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17464,51,'Dahivali','402117',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17465,51,'Dandguri','402404',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17466,51,'Dapoli','402302',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17467,51,'Dasgaon','402102',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17468,51,'Degaon','402117',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17469,51,'Deopur','402303',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17470,51,'Devali','402103',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17471,51,'Devkanhe','402304',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17472,51,'Devla','402303',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17473,51,'Dhamandevi','402303',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17474,51,'Dhamansai','402109',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17475,51,'Dhamne','402302',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17476,51,'Dharavali','402301',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17477,51,'Dhokawade','402208',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17478,51,'Dighi','402402',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17479,51,'Diveagar','402404',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17480,51,'Divil','402303',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17481,51,'Dolvi','402107',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17482,51,'Gadab','402107',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17483,51,'Gagode Budruk','402107',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17484,51,'Galsure','402110',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17485,51,'Ghosale','402109',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17486,51,'Ghotawade','410205',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17487,51,'Golegani','402303',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17488,51,'Gondale','402301',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17489,51,'Gondghar','402105',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17490,51,'Goregaon (Raigarh(MH))','402103',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17491,51,'Govele','402122',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17492,51,'Hamrapur','402107',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17493,51,'Hareshwar','402110',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17494,51,'Harkol','402103',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17495,51,'Hashiware','402209',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17496,51,'Hatond','410205',1,0,'2022-03-03 12:27:24','2022-03-03 12:27:24'),(17497,51,'Hodgaon','402104',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17498,51,'Jambhulpada','410205',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17499,51,'Jamgaon','402308',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17500,51,'Janjira Murud','402401',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17501,51,'Jasawali','402110',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17502,51,'Jite','402120',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17503,51,'Jite','402302',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17504,51,'Jite','402107',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17505,51,'Johe','402107',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17506,51,'Jui Budruk','402115',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17507,51,'Kalavali','402301',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17508,51,'Kamarle','402209',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17509,51,'Kamarli','402107',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17510,51,'Kamble Tarfe Birwadi','402309',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17511,51,'Kamble Tarfe Mahad','402309',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17512,51,'Kandale','402107',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17513,51,'Kapade Budruk','402303',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17514,51,'Karanjadi','402301',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17515,51,'Kashid','402401',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17516,51,'Kasu','402107',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17517,51,'Kavale','402307',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17518,51,'Kavil Vahal','402104',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17519,51,'Kelte','402105',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17520,51,'Kemburli','402301',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17521,51,'Khaire Budruk','402109',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17522,51,'Khamb','402304',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17523,51,'Khamgaon','402105',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17524,51,'Khandale','402209',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17525,51,'Khandpoli','410205',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17526,51,'Kharavali','402104',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17527,51,'Khardi','402305',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17528,51,'Khargaon','402109',1,0,'2022-03-03 12:27:25','2022-03-03 12:27:25'),(17529,51,'Kharpale','402107',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17530,51,'Kharsai','402105',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17531,51,'Khavali','410205',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17532,51,'Kihim','402208',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17533,51,'Kinjaloli Budruk','402301',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17534,51,'Kokban','402109',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17535,51,'Kolad','402304',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17536,51,'Kolmandla','402114',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17537,51,'Kolose','402305',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17538,51,'Kolwat','402105',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17539,51,'Kondhavi','402303',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17540,51,'Konzar','402305',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17541,51,'Koproli','402107',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17542,51,'Korlai','402202',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17543,51,'Koste Khurd','402120',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17544,51,'Kotheri','402301',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17545,51,'Kotwal Budruk','402303',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17546,51,'Kudgaon','402402',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17547,51,'Kudli','402308',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17548,51,'Kumbheshivthar','402306',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17549,51,'Kurdus','402108',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17550,51,'Kurle','402301',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17551,51,'Kurul','402209',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17552,51,'Kurul RCF Colony','402209',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17553,51,'Kusgaon','402309',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17554,51,'Kusumbale','402108',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17555,51,'Limpniwave','402101',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17556,51,'Lohare','402303',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17557,51,'Lonere','402103',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17558,51,'Lonshi','402104',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17559,51,'Mahad','402301',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17560,51,'Mahagaon','402112',1,0,'2022-03-03 12:27:26','2022-03-03 12:27:26'),(17561,51,'Mahagaon','410205',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17562,51,'Mahal Mirya Dongar','410205',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17563,51,'Mahargul','402303',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17564,51,'Majgaon Tamhane','402105',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17565,51,'Malyan','402203',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17566,51,'Mandad','402111',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17567,51,'Mandle','402305',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17568,51,'Mangaon Budruk','410205',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17569,51,'Mangaon (Raigarh(MH))','402104',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17570,51,'Mangarul','402103',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17571,51,'Mangrun','402302',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17572,51,'Manjaravane','402122',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17573,51,'Mapgaon','402208',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17574,51,'Mazeri','402306',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17575,51,'Mazgaon','402401',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17576,51,'Medha','402109',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17577,51,'Mendadi','402105',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17578,51,'Mhasla','402105',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17579,51,'Midc Mahad','402309',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17580,51,'Mohot','402302',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17581,51,'Morba','402117',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17582,51,'Mumurshi','402301',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17583,51,'Muthavali Tarfe Tala','402112',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17584,51,'Nadsur','410205',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17585,51,'Nagaon','402103',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17586,51,'Nagaon','402301',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17587,51,'Nagaon','402204',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17588,51,'Nagloli','402404',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17589,51,'Nagothane','402106',1,0,'2022-03-03 12:27:27','2022-03-03 12:27:27'),(17590,51,'Nandgaon','410205',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17591,51,'Nandgaon','402401',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17592,51,'Nandvi','402103',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17593,51,'Narangi','402209',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17594,51,'Narvan','402115',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17595,51,'Nate','402305',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17596,51,'Natondi','402301',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17597,51,'Navadar Navagaon','402208',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17598,51,'Navghar','410205',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17599,51,'Navipeth Mahad','402301',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17600,51,'Nhave','402109',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17601,51,'Nigade','402302',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17602,51,'Nizampur (Raigarh(MH))','402120',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17603,51,'Ombali','402303',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17604,51,'Pabal','402107',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17605,51,'Pabhre','402105',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17606,51,'Pachad','402305',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17607,51,'Pachhapur','410205',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17608,51,'Padvi','402306',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17609,51,'Paithan','402303',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17610,51,'Palas','402106',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17611,51,'Palasgaon Khurd','402104',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17612,51,'Palchil','402303',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17613,51,'Pali (Raigarh(MH))','410205',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17614,51,'Pangari','402307',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17615,51,'Pangloli','402101',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17616,51,'Panhalghar','402103',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17617,51,'Parali','410205',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17618,51,'Patnus','402308',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17619,51,'PCTS Nagothane','402125',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17620,51,'Pen','402107',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17621,51,'Pen Tarfe Tale','402104',1,0,'2022-03-03 12:27:28','2022-03-03 12:27:28'),(17622,51,'Pigonde','402106',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17623,51,'Pingalsai','402109',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17624,51,'Pipenagar','402126',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17625,51,'Pitsai','402111',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17626,51,'Poladpur','402303',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17627,51,'Poynad','402108',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17628,51,'Pugaon','402304',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17629,51,'Purar','402103',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17630,51,'Rahatad','402111',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17631,51,'Rajapuri','402401',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17632,51,'Rajewadi','402309',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17633,51,'Ramraj','402203',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17634,51,'Ranawali','402110',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17635,51,'Ransai','402107',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17636,51,'Ratwad','402112',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17637,51,'Ravalje','410205',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17638,51,'Ravdhal','402115',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17639,51,'Rave','402107',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17640,51,'RCF Thal','402208',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17641,51,'Revdanda','402202',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17642,51,'Revtale','402301',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17643,51,'Roha AV','402116',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17644,51,'Roha','402109',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17645,51,'Roth Khurd','402116',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17646,51,'Sadavali','402303',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17647,51,'Sai','402122',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17648,51,'Saigaon','402110',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17649,51,'Sakhar','402303',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17650,51,'Salvadnaka Mahad No Dly.','402301',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17651,51,'Salvinde','402105',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17652,51,'Sanderi','402101',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17653,51,'Sandoshi','402305',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17654,51,'Sanegaon','402109',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17655,51,'Saral','402209',1,0,'2022-03-03 12:27:29','2022-03-03 12:27:29'),(17656,51,'Sarsoli','402109',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17657,51,'Sarve','402403',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17658,51,'Sasawane','402208',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17659,51,'Sav','402301',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17660,51,'Savli','402401',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17661,51,'Savrat','402305',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17662,51,'Sawad','402301',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17663,51,'Sawarsai','402107',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17664,51,'Shahabaj','402108',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17665,51,'Shahapur','402108',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17666,51,'Shedsai','402109',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17667,51,'Shekhadi','402113',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17668,51,'Shenwai','402109',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17669,51,'Shighre','402401',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17670,51,'Shirawali','402120',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17671,51,'Shirki','402107',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17672,51,'Shriwardhan','402110',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17673,51,'Siddheshwar','410205',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17674,51,'Sonkhar','402107',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17675,51,'Sudkoli','402203',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17676,51,'Tala (Raigarh(MH))','402111',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17677,51,'Talashet','402112',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17678,51,'Talavade','402105',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17679,51,'Talawali Terfe Diwali','402304',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17680,51,'Talegaon','402111',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17681,51,'Talegaon Tarfe Goregaon','402104',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17682,51,'Taliye','402306',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17683,51,'Taloshi','402305',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17684,51,'Tambadi','402109',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17685,51,'Tamhane','402307',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17686,51,'Tarankhop','402107',1,0,'2022-03-03 12:27:30','2022-03-03 12:27:30'),(17687,51,'Tempale','402104',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17688,51,'Tetghar','402305',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17689,51,'Thal (Raigarh(MH))','402207',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17690,51,'Tiware','410205',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17691,51,'Tokarde','402111',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17692,51,'TolBudruk','402102',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17693,51,'Turbhe Khurd','402303',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17694,51,'Underi','402301',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17695,51,'Unegaon','402104',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17696,51,'Upper Tudul','402115',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17697,51,'Usar','402203',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17698,51,'Usar Khurd','402104',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17699,51,'Usarghar','402103',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17700,51,'Usroli','402401',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17701,51,'Vadghar','402110',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17702,51,'Vadhav','402107',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17703,51,'Vadkhal','402107',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17704,51,'Vadshetvave','402110',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17705,51,'Varandh','402306',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17706,51,'Varandoli','402305',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17707,51,'Varsai','402107',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17708,51,'Varsoli','402209',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17709,51,'Varvatane','402105',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17710,51,'Veer','402102',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17711,51,'Velas','402403',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17712,51,'Veshvi','402209',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17713,51,'Vihoor','402401',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17714,51,'Vikram Baug','402202',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17715,51,'Vile','402308',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17716,51,'Vinhere','402307',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17717,51,'Virjoli','402109',1,0,'2022-03-03 12:27:31','2022-03-03 12:27:31'),(17718,51,'Wadvali','402103',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17719,51,'Wadwali','402403',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17720,51,'Wagheri','402305',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17721,51,'Wagholi','402302',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17722,51,'Wahoor','402301',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17723,51,'Wakan','402303',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17724,51,'Wakanfata','402106',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17725,51,'Waki Budruk','402302',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17726,51,'Walan Budruk','402302',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17727,51,'Walan Khurd','402302',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17728,51,'Walang','402115',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17729,51,'Wali','402109',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17730,51,'Walke','402202',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17731,51,'Walwati','402113',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17732,51,'Washi','402107',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17733,51,'Wavediwali','402112',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17734,51,'Wighawali','402112',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17735,51,'Zirad','402208',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17736,52,'Abaloli','415726',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17737,52,'Adavali','415802',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17738,52,'Ade','415714',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17739,52,'Adivare','416707',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17740,52,'Adkhaltari','415714',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17741,52,'Adre','415604',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17742,52,'Adur (Ratnagiri)','415705',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17743,52,'Agarwaingani','415712',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17744,52,'Agave','415616',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17745,52,'Agave','415606',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17746,52,'Ajiwali','416704',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17747,52,'Akale','415604',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17748,52,'Alore','415603',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17749,52,'Alsure','415709',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17750,52,'Ambav','415804',1,0,'2022-03-03 12:27:32','2022-03-03 12:27:32'),(17751,52,'Ambav','415608',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17752,52,'Ambavali','415804',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17753,52,'Ambavali','415730',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17754,52,'Ambaye','415709',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17755,52,'Ambdas','415605',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17756,52,'Ambed Budruk','415637',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17757,52,'Ambitgaon','415641',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17758,52,'Ambolgad','415806',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17759,52,'Amdave','415203',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17760,52,'Anari','415604',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17761,52,'Angale','416702',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17762,52,'Angavali','415804',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17763,52,'Anjanari','415803',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17764,52,'Anjanvel','415634',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17765,52,'Anjarla','415714',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17766,52,'Ansure','416702',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17767,52,'Antravali','415610',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17768,52,'Aravali','415608',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17769,52,'Are','415703',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17770,52,'Argaon','415643',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17771,52,'Asage','416712',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17772,52,'Asgani','415708',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17773,52,'Asgoli','415703',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17774,52,'Ashti','415709',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17775,52,'Asond','415711',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17776,52,'Asore','415726',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17777,52,'Astan','415730',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17778,52,'Asud','415713',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17779,52,'Asurda','415606',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17780,52,'Avashi','415722',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17781,52,'Ayani','415708',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17782,52,'Bagave Wadi','416704',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17783,52,'Bahiravali','415727',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17784,52,'Bamnoli','415701',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17785,52,'Bamnoli','415804',1,0,'2022-03-03 12:27:33','2022-03-03 12:27:33'),(17786,52,'Bankot','415208',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17787,52,'Bapere','416701',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17788,52,'Basani','415629',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17789,52,'Belari Budruk','415804',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17790,52,'Beni Budruk','416712',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17791,52,'Bhade','416712',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17792,52,'Bhadkamba','415801',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17793,52,'Bhalavali','416702',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17794,52,'Bhambed','416701',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17795,52,'Bharane','415621',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17796,52,'Bhatgaon','415726',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17797,52,'Bhatye','415612',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17798,52,'Bhelsai','415605',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17799,52,'Bhile','415605',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17800,52,'Bhoke','415639',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17801,52,'Bhom','415628',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17802,52,'Bhoo','416713',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17803,52,'Bhopan','415711',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17804,52,'Bijghar','415715',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17805,52,'Biwali','415628',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17806,52,'Boraj','415709',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17807,52,'Borgaon','415701',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17808,52,'Burambad','415608',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17809,52,'Burambe Wadi','416702',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17810,52,'Burondi','415720',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17811,52,'Chafavali','415807',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17812,52,'Chafe','415620',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17813,52,'Chandor','415616',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17814,52,'Charveli','415619',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17815,52,'Chave','415620',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17816,52,'Chickalgaon','415712',1,0,'2022-03-03 12:27:34','2022-03-03 12:27:34'),(17817,52,'Chikhali','415609',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17818,52,'Chikhali','415724',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17819,52,'Chinchavali','415640',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17820,52,'Chinchghar','415203',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17821,52,'Chinchghar','415709',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17822,52,'Chinchghari','415604',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17823,52,'Chinchkhari','415612',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17824,52,'Chindravale','415728',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17825,52,'Chiplun H.O','415605',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17826,52,'Chirni','415605',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17827,52,'Chiveli','415701',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17828,52,'Choravane','415803',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17829,52,'Choravane','415718',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17830,52,'Dabhil','415711',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17831,52,'Dabhol','415706',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17832,52,'Dabhole','415803',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17833,52,'Dahagaon','415203',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17834,52,'Dahivali Budruk','415606',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17835,52,'Dale','415805',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17836,52,'Dalvatane','415604',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17837,52,'Dande Adom','415612',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17838,52,'Dapoli','415712',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17839,52,'Dasur','416713',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17840,52,'Dayal','415710',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17841,52,'Degaon','415711',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17842,52,'Dehen','415712',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17843,52,'Deole Ghera Prachitgad','415611',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17844,52,'Dervan','415606',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17845,52,'Deud','415620',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17846,52,'Devache Gothane','416702',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17847,52,'Devade','415801',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17848,52,'Devadhe','416712',1,0,'2022-03-03 12:27:35','2022-03-03 12:27:35'),(17849,52,'Devale','415807',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17850,52,'Devghar','415730',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17851,52,'Devhare','415208',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17852,52,'Devihasol','416713',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17853,52,'Devrukh','415804',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17854,52,'Dhakmoli','415641',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17855,52,'Dhamanand','415718',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17856,52,'Dhamandevi','415605',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17857,52,'Dhamani','415709',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17858,52,'Dhamani','415611',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17859,52,'Dhamanse','415620',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17860,52,'Dhamapur','415608',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17861,52,'Dhamnavane','415604',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17862,52,'Dhaulwali','416702',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17863,52,'Dhopave','415703',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17864,52,'Dhopeshwar','416702',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17865,52,'Dhutroli','415203',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17866,52,'Dingni','415611',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17867,52,'Dodavali','415728',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17868,52,'Donavali','415628',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17869,52,'Dongar','416702',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17870,52,'Donivade','416702',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17871,52,'Dorle','415626',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17872,52,'Durgawadi','415606',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17873,52,'Fungus','415611',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17874,52,'Furus','415606',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17875,52,'Furus','415710',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17876,52,'Ganeshgule','415616',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17877,52,'Ganpatipule','415615',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17878,52,'Gavade Ambere','415626',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17879,52,'Gavane','416712',1,0,'2022-03-03 12:27:36','2022-03-03 12:27:36'),(17880,52,'Gavkhadi','415626',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17881,52,'Gharadi','415203',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17882,52,'Ghativale','415803',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17883,52,'Ghera Rasalgad','415730',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17884,52,'Ghodavali','415639',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17885,52,'Ghude','415701',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17886,52,'Gimvi','415702',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17887,52,'Golap','415616',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17888,52,'Golavali','415611',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17889,52,'Golawashi','416701',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17890,52,'Gondhale','415628',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17891,52,'Gothane Doniwade','416705',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17892,52,'Gothe','415208',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17893,52,'Goval','416702',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17894,52,'Govil','416701',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17895,52,'Guhagar','415703',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17896,52,'Gunade','415722',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17897,52,'Haral','416704',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17898,52,'Harche','416712',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17899,52,'Harcheri','416712',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17900,52,'Hardakhale','416701',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17901,52,'Harnai','415713',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17902,52,'Harpude','415804',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17903,52,'Hasol Tarf Saundal','416702',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17904,52,'Hatade','416704',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17905,52,'Hativ','415804',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17906,52,'Hatkhamba','415619',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17907,52,'Hedali','415709',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17908,52,'Hedavi','415728',1,0,'2022-03-03 12:27:37','2022-03-03 12:27:37'),(17909,52,'Holi','415805',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17910,52,'Humbri','415730',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17911,52,'Ibrahimpattan','416712',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17912,52,'Ilne','415714',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17913,52,'Indavati','416701',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17914,52,'Isavali','416701',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17915,52,'Jaigad','415614',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17916,52,'Jaitapur','415805',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17917,52,'Jalgaon','415712',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17918,52,'Jamage','415709',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17919,52,'Jamage','415716',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17920,52,'Jambhari','415613',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17921,52,'Jamsud','415703',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17922,52,'Javade','416701',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17923,52,'Jawalethar','416704',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17924,52,'Juwathi','416702',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17925,52,'Kadavali','415605',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17926,52,'Kadivali','415712',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17927,52,'Kadwad','415604',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17928,52,'Kadwai','415609',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17929,52,'Kajarikar Mohalla','415628',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17930,52,'Kajirda','416704',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17931,52,'Kajurli','415726',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17932,52,'Kalamani Budruk','415621',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17933,52,'Kalamani Khurd','415730',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17934,52,'Kalambaste','415605',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17935,52,'Kalambaste','415610',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17936,52,'Kalambat','415712',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17937,52,'Kalambat','415641',1,0,'2022-03-03 12:27:38','2022-03-03 12:27:38'),(17938,52,'Kalambushi','415608',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17939,52,'Kalamundi','415702',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17940,52,'Kalbadevi','415629',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17941,52,'Kalkavane','415604',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17942,52,'Kalsavali','416705',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17943,52,'Kalsur Koundhar','415724',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17944,52,'Kaluste','415605',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17945,52,'Kalzondi','415620',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17946,52,'Kamathe','415605',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17947,52,'Kaneri','416702',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17948,52,'Kangwai','415712',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17949,52,'Kanhe','415604',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17950,52,'Kankadi','415803',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17951,52,'Kapad Gaon','415619',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17952,52,'Kapre','415628',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17953,52,'Kapsal','415605',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17954,52,'Karak','416704',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17955,52,'Karambavane','415628',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17956,52,'Karambele Tarf Devale','415804',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17957,52,'Karanjani','415712',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17958,52,'Karanjgaon','415720',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17959,52,'Karavali','416704',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17960,52,'Karbhatale','415610',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17961,52,'Karbude','415639',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17962,52,'Karde','415713',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17963,52,'Karji','415727',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17964,52,'Karjuve','415608',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17965,52,'Karla','415612',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17966,52,'Karli','415804',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17967,52,'Karul','415719',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17968,52,'Kasai','415718',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17969,52,'Kasar Kolwan','415804',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17970,52,'Kasarveli','415629',1,0,'2022-03-03 12:27:39','2022-03-03 12:27:39'),(17971,52,'Kasba (Ratnagiri)','415610',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17972,52,'Kase','415608',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17973,52,'Kashedi','415640',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17974,52,'Kasheli','416707',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17975,52,'Katali Sagave','416709',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17976,52,'Katavali','415804',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17977,52,'Katroli','415701',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17978,52,'Kaundhar Tamhane','415702',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17979,52,'Kelambe','416701',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17980,52,'Kelavali','416702',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17981,52,'Kelawali','415726',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17982,52,'Kelne','415605',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17983,52,'Kelshi','415717',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17984,52,'Kelye','415612',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17985,52,'Kespuri','415620',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17986,52,'Khadpoli','415603',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17987,52,'Khalgaon','415620',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17988,52,'Khanavali','416712',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17989,52,'Khanu','415803',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17990,52,'Kharvate','416705',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17991,52,'Kharvate','415628',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17992,52,'Khavadi','416701',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17993,52,'Khavati','415640',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17994,52,'Khed (RTG)','415709',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17995,52,'Khed City','415709',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17996,52,'Khedashi','415639',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17997,52,'Kherdi','415712',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17998,52,'Kherdi','415604',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(17999,52,'Khodade','415726',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(18000,52,'Khopad','415628',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(18001,52,'Khopi','415715',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(18002,52,'Khorninko','416701',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(18003,52,'Kirbet','415801',1,0,'2022-03-03 12:27:40','2022-03-03 12:27:40'),(18004,52,'Kirduve','415804',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18005,52,'Kochari','415802',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18006,52,'Kodavali','416702',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18007,52,'Kokare','415608',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18008,52,'Kolamb','416704',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18009,52,'Kolambe','415612',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18010,52,'Kolambe(S)','415637',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18011,52,'Kolbandre','415711',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18012,52,'Koldhe','416712',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18013,52,'Kolisare','415620',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18014,52,'Kolke Wadi','415603',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18015,52,'Kolthare','415712',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18016,52,'Kolvande','415605',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18017,52,'Kolwan Chuna','416705',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18018,52,'Kolwan Khadi','416704',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18019,52,'Kondge','415643',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18020,52,'Kondivali','415709',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18021,52,'Kondivare','415608',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18022,52,'Kondmala','415606',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18023,52,'Kondsur Budruk','416707',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18024,52,'Kondye','415620',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18025,52,'Kondye','416701',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18026,52,'Kondye','416702',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18027,52,'Koregaon','415709',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18028,52,'Korle','416701',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18029,52,'Kosbi','415606',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18030,52,'Kosumb','415804',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18031,52,'Kot','416712',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18032,52,'Kotapur','416702',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18033,52,'Kotavali','415722',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18034,52,'Kotawada','415617',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18035,52,'Kotluk','415703',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18036,52,'Kudali','415613',1,0,'2022-03-03 12:27:41','2022-03-03 12:27:41'),(18037,52,'Kudavale','415712',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18038,52,'Kulvandi','415715',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18039,52,'Kumbale','415203',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18040,52,'Kumbhad','415715',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18041,52,'Kumbharkhani','415607',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18042,52,'Kumbharli','415602',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18043,52,'Kumbhavade','416702',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18044,52,'Kundi','415804',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18045,52,'Kurang','415643',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18046,52,'Kurdhunda','415611',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18047,52,'Kurne','416712',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18048,52,'Kurtade','416712',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18049,52,'Kurwal Jawali','415718',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18050,52,'Kutgiri','415702',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18051,52,'Kutra','415607',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18052,52,'Kuvarbav','415639',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18053,52,'Kuve','416701',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18054,52,'Kuveshi','416702',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18055,52,'Ladghar','415712',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18056,52,'Lanja','416701',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18057,52,'Latwan','415202',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18058,52,'Lavel','415708',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18059,52,'Lavgan','416712',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18060,52,'Lote (Ratnagiri)','415722',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18061,52,'Lowale','415611',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18062,52,'Mabhale','415611',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18063,52,'Madban','416702',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18064,52,'Mahalunge','415730',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18065,52,'Majal','416701',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18066,52,'Majgaon','415612',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18067,52,'Makhajan','415608',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18068,52,'Malan','415724',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18069,52,'Maldoli','415628',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18070,52,'Malghar','415701',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18071,52,'Malgund','415615',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18072,52,'Mandangad','415203',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18073,52,'Mandivali','415203',1,0,'2022-03-03 12:27:42','2022-03-03 12:27:42'),(18074,52,'Mandki','415606',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18075,52,'Mandva','415709',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18076,52,'Mani','415709',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18077,52,'Manjare','415620',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18078,52,'Maral','415804',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18079,52,'Margatamhane','415702',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18080,52,'Markandi','415605',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18081,52,'Masrang','415609',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18082,52,'Masu','415726',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18083,52,'Math','415803',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18084,52,'Matwan','415712',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18085,52,'Mavlange','415616',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18086,52,'Meghi','415807',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18087,52,'Mervi','415616',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18088,52,'Mhapral','415203',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18089,52,'MIDC (RTG)','415639',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18090,52,'Miland','416704',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18091,52,'Miravane','415701',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18092,52,'Mirjole','415639',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18093,52,'Mirya','415612',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18094,52,'Mithgavane','416702',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18095,52,'Mohane','415730',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18096,52,'Moor','416704',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18097,52,'Moravane','415604',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18098,52,'Morde','415804',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18099,52,'Moroshi','416702',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18100,52,'Morvande','415709',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18101,52,'Mosam','416702',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18102,52,'Muchari','415611',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18103,52,'Mudhe Tarf Sawarda','415606',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18104,52,'Mugij','415716',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18105,52,'Mumbake','415727',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18106,52,'Mundhar','415719',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18107,52,'Mundhe','415602',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18108,52,'Murdav','415608',1,0,'2022-03-03 12:27:43','2022-03-03 12:27:43'),(18109,52,'Murde','415709',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18110,52,'Murshi','415801',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18111,52,'Murtavade','415641',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18112,52,'Murud','415713',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18113,52,'Musad','415605',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18114,52,'Nachane','415639',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18115,52,'Nakhare','415616',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18116,52,'Nanar','416702',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18117,52,'Nandgaon (CPN)','415607',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18118,52,'Nandgaon (Khed)','415709',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18119,52,'Nandivase','415604',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18120,52,'Nandivili','415730',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18121,52,'Nanij','415803',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18122,52,'Nante','415712',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18123,52,'Narduve','415608',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18124,52,'Narvan','415728',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18125,52,'Nata','415806',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18126,52,'Natunagar','415640',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18127,52,'Nayari','415610',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18128,52,'Nayashi','415608',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18129,52,'Nevare','415620',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18130,52,'Nigadi','415208',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18131,52,'Nigundal','415719',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18132,52,'Nilavane','415621',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18133,52,'Nirul','415616',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18134,52,'Nirvhal','415701',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18135,52,'Nive Budruk','415804',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18136,52,'Niveli','416702',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18137,52,'Nivendi','415615',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18138,52,'Nivsar','415803',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18139,52,'Niwali (CPN)','415641',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18140,52,'Niwali','415639',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18141,52,'Omali','415628',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18142,52,'Oni','416705',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18143,52,'Oni-navase','415706',1,0,'2022-03-03 12:27:44','2022-03-03 12:27:44'),(18144,52,'Ori','415620',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18145,52,'Oshivale','416704',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18146,52,'Ovali','415604',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18147,52,'Ozare','416705',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18148,52,'Ozare Budruk','415801',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18149,52,'Ozare Khurd','415804',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18150,52,'Pachal (Ratnagiri)','416704',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18151,52,'Pachambe','415607',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18152,52,'Pachavali','415712',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18153,52,'Pacheri Sada','415726',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18154,52,'Padave','416702',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18155,52,'Padve','415214',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18156,52,'Padve','415613',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18157,52,'Paj','415713',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18158,52,'Palavani','415712',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18159,52,'Palgad','415716',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18160,52,'Pali (RTG)','415803',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18161,52,'Pali(CPN)','415605',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18162,52,'Palpene','415724',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18163,52,'Palshet','415703',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18164,52,'Palu','416701',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18165,52,'Palvan','415641',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18166,52,'Panchnadi','415712',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18167,52,'Panderi','415214',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18168,52,'Pangare','416702',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18169,52,'Pangari','415639',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18170,52,'Pangari','415719',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18171,52,'Pangari Tarf Haveli','415711',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18172,52,'Pangari Tarf Velamb','415724',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18173,52,'Panhale','415643',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18174,52,'Panhale','415711',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18175,52,'Panhale Tarf Saundal','416702',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18176,52,'Panhalje','415727',1,0,'2022-03-03 12:27:45','2022-03-03 12:27:45'),(18177,52,'Panval','415619',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18178,52,'Parchuri','415719',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18179,52,'Parchuri','415637',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18180,52,'Parshuram','415605',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18181,52,'Parule','416704',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18182,52,'Pate Pillavali','415641',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18183,52,'Patgaon','415804',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18184,52,'Patpanhale','415724',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18185,52,'Pawas','415616',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18186,52,'Pedhambe','415603',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18187,52,'Pedhe','415605',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18188,52,'Pendkhale','416713',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18189,52,'Peve','415214',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18190,52,'Peve','415719',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18191,52,'Phansavale','415612',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18192,52,'Phansavane','415610',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18193,52,'Phansop','415612',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18194,52,'Phansu','415711',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18195,52,'Pilavali','415641',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18196,52,'Pimpar','415703',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18197,52,'Pimpli Khurd','415604',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18198,52,'Pimploli','415202',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18199,52,'Pirandavane','415617',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18200,52,'Pirandavane','415611',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18201,52,'Pisai','415712',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18202,52,'Pochari','415620',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18203,52,'Pomendi','415724',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18204,52,'Pomendi Budruk','415612',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18205,52,'Pomendi Khurd','415612',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18206,52,'Pophali','415601',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18207,52,'Pophlavane','415727',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18208,52,'Posare','415628',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18209,52,'Posare Budruk','415718',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18210,52,'Poynar','415710',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18211,52,'Prabhanvalli','416701',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18212,52,'Prindavan','416702',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18213,52,'Punas','416712',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18214,52,'Purnagad','415616',1,0,'2022-03-03 12:27:46','2022-03-03 12:27:46'),(18215,52,'Purye T/F Devale','415801',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18216,52,'Rai','415620',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18217,52,'Rajapur (Ratnagiri)','416702',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18218,52,'Rajivili','415607',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18219,52,'Rajwadi','416707',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18220,52,'Rajwadi','415611',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18221,52,'Rampur (Ratnagiri)','415701',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18222,52,'Ranpat','415620',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18223,52,'Ratnagiri Collectorate','415612',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18224,52,'Ratnagiri H.O','415612',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18225,52,'Raypatan','416704',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18226,52,'RGPPL Anjanvel','415634',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18227,52,'Ringane','415643',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18228,52,'Roon','416701',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18229,52,'Sada Jambhari','415726',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18230,52,'Sadavali','415804',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18231,52,'Sagave','416709',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18232,52,'Saitavada','415613',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18233,52,'Sakhar','415718',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18234,52,'Sakhar','416702',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18235,52,'Sakhari Agar','415729',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18236,52,'Sakhari Budruk','415724',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18237,52,'Sakhari Trishul','415724',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18238,52,'Sakharpa','415801',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18239,52,'Sakhloli','415712',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18240,52,'Sakhroli','415709',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18241,52,'Salpe','415802',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18242,52,'Sangave','415804',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18243,52,'Sanglat','415709',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18244,52,'Sangmeshwar','415611',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18245,52,'Sapirili','415718',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18246,52,'Sarang','415712',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18247,52,'Sasale','416702',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18248,52,'Satavali','416701',1,0,'2022-03-03 12:27:47','2022-03-03 12:27:47'),(18249,52,'Satere Tarf Natu','415716',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18250,52,'Sathare Bambar','415803',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18251,52,'Satvingaon','415708',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18252,52,'Saundal','416704',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18253,52,'Savdav','416704',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18254,52,'Saveni','415709',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18255,52,'Savnas','415727',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18256,52,'Sawarda','415606',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18257,52,'Sayale','415804',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18258,52,'Sheldi','415722',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18259,52,'Shembavane','415611',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18260,52,'Shingri','415709',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18261,52,'Shipole','415208',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18262,52,'Shiposhi','415802',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18263,52,'Shir','415724',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18264,52,'Shiral','415628',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18265,52,'Shirambavali','415803',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18266,52,'Shirambe','415641',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18267,52,'Shiravali','415643',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18268,52,'Shirgaon (CPN)','415602',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18269,52,'Shirgaon (RTG)','415629',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18270,52,'Shirgaon','415715',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18271,52,'Shirkhal','415716',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18272,52,'Shirshi','415727',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18273,52,'Shirsoli','415712',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18274,52,'Shiv Budruk','415709',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18275,52,'Shivaji Nagar (RTG)','415612',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18276,52,'Shivane Budruk','416713',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18277,52,'Shivane Khurd','416702',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18278,52,'Shivar Ambere','415626',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18279,52,'Shivtar','415709',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18280,52,'Shringarpur','415610',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18281,52,'Shringartali','415724',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18282,52,'Solgaon','416702',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18283,52,'Soliwade','416704',1,0,'2022-03-03 12:27:48','2022-03-03 12:27:48'),(18284,52,'Someshwar','415612',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18285,52,'Sonavade','415611',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18286,52,'Sondeghar','415716',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18287,52,'Songaon','415722',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18288,52,'Soveli','415203',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18289,52,'Sukivili','415621',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18290,52,'Sukondi','415714',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18291,52,'Susheri','415709',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18292,52,'Tadil','415712',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18293,52,'Takede','415203',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18294,52,'Tala Mandva','415709',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18295,52,'Talavade','416712',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18296,52,'Talavade','416704',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18297,52,'Talavade','415607',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18298,52,'Talavali','415719',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18299,52,'Talekante','415637',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18300,52,'Talgaon','416702',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18301,52,'Talsar','415602',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18302,52,'Talsure','415712',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18303,52,'Talvat','415718',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18304,52,'Tambedi','415610',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18305,52,'Tamhane','415804',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18306,52,'Tamhane','416704',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18307,52,'Tamhanmala','415628',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18308,52,'Tanali','415702',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18309,52,'Tangar','415712',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18310,52,'Taral','416702',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18311,52,'Tarval','415620',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18312,52,'Tavsal','415613',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18313,52,'Tembye','415612',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18314,52,'Teru','415605',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18315,52,'Terye','415611',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18316,52,'Tetavali','415711',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18317,52,'Tide','415202',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18318,52,'Tike','416712',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18319,52,'Tilak Memorial (RTG)','415612',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18320,52,'Tisangi','415709',1,0,'2022-03-03 12:27:49','2022-03-03 12:27:49'),(18321,52,'Tise','415709',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18322,52,'Tiware','415604',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18323,52,'Tiware','416705',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18324,52,'Tiware Ghera Prachitgad','415610',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18325,52,'Tiware Medhe Tarfe Devale','415801',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18326,52,'Tonade','415612',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18327,52,'Tondali','415641',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18328,52,'Tulsani','415804',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18329,52,'Tulshi','415203',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18330,52,'Tulshi Khurd','415640',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18331,52,'Tural','415609',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18332,52,'Turambav','415641',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18333,52,'Ubhale','415702',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18334,52,'Udhale Budruk','415640',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18335,52,'Ujgaon','415804',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18336,52,'Ukshi','415637',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18337,52,'Umare','415610',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18338,52,'Umbarghar','415706',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18339,52,'Umbarle','415712',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18340,52,'Umrath','415728',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18341,52,'Umroli','415208',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18342,52,'Umroli','415702',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18343,52,'Upale','416712',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18344,52,'Upale','416702',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18345,52,'Vadad','415701',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18346,52,'Vadad Hasol','416713',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18347,52,'Vadgaon','416701',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18348,52,'Vahal','415641',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18349,52,'Vakavali','415711',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18350,52,'Valote','415202',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18351,52,'Vandri','415637',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18352,52,'Vangule','416701',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18353,52,'Vanzole','415804',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18354,52,'Varawade','415620',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18355,52,'Varnoshi Tarf Panchanadi','415712',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18356,52,'Varveli','415703',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18357,52,'Veer','415641',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18358,52,'Vehele','415604',1,0,'2022-03-03 12:27:50','2022-03-03 12:27:50'),(18359,52,'Velamb','415724',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18360,52,'Velas','415208',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18361,52,'Veldur','415703',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18362,52,'Velvand','415619',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18363,52,'Velvi','415712',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18364,52,'Veral','415621',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18365,52,'Veral','416712',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18366,52,'Veravali Budruk','416701',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18367,52,'Veravali Khurd','416701',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18368,52,'Veshvi','415208',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18369,52,'Vetoshi','415617',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18370,52,'Vhel','415643',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18371,52,'Vilavade','415643',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18372,52,'Vilye','416702',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18373,52,'Visapur','415716',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18374,52,'Wadavali','416705',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18375,52,'Waghambe','415728',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18376,52,'Waghangaon','415643',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18377,52,'Waghivare','415701',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18378,52,'Waghrat','416712',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18379,52,'Waingane','415804',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18380,52,'Waked','415643',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18381,52,'Walope','415605',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18382,52,'Walye','416702',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18383,52,'Wanke','415803',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18384,52,'Washi Tarf Devrukh','415804',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18385,52,'Washi Tarf Sangmeshwar','415611',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18386,52,'Watad','415613',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18387,52,'Watul','415643',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18388,52,'Wave','415718',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18389,52,'Wavghar','415711',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18390,52,'Welneshwar','415729',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18391,52,'Yegaon','415607',1,0,'2022-03-03 12:27:51','2022-03-03 12:27:51'),(18392,52,'Yelvan','416704',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18393,52,'Yerdav','416704',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18394,52,'Zapade','416701',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18395,52,'Zare Wadi','415619',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18396,52,'Zombadi','415702',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18397,53,'Agalgaon','416403',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18398,53,'Agran Dhulgaon','416411',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18399,53,'Ainwadi','415311',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18400,53,'Aitawade BK','415401',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18401,53,'Aitawade Khurd','415409',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18402,53,'Alkud  (S)','416411',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18403,53,'Alkud (M)','416419',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18404,53,'Alsund','415311',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18405,53,'Amanapur','416308',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18406,53,'Amarapur','415305',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18407,53,'Ambak','415303',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18408,53,'Andhali','416310',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18409,53,'Anjani','416311',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18410,53,'Ankalagi','416412',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18411,53,'Ankale','416402',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18412,53,'Ankali','416416',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18413,53,'Ankalkhop','416316',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18414,53,'Antral','416404',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18415,53,'Antri Budruk','415408',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18416,53,'Arag','416401',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18417,53,'Arala','415415',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18418,53,'Arawade','416312',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18419,53,'Arewadi','416403',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18420,53,'Asangi J','416412',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18421,53,'Asangi K','416412',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18422,53,'Ashte','416301',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18423,53,'Atpadi','415301',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18424,53,'Audumbar','416303',1,0,'2022-03-03 12:27:52','2022-03-03 12:27:52'),(18425,53,'Aundhi','415408',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18426,53,'Avandhi','416404',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18427,53,'Awalai','415315',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18428,53,'Bagani','416302',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18429,53,'Bahadurwadi','415411',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18430,53,'Bahe','415409',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18431,53,'Baj','416402',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18432,53,'Balagavade','416312',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18433,53,'Balavadi (KHN)','415307',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18434,53,'Balavadi(Bhalavani)','416309',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18435,53,'Balgaon','416413',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18436,53,'Bamani','415311',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18437,53,'Bambavade','416310',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18438,53,'Bambavade','415410',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18439,53,'Bamnoli','416436',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18440,53,'Banali','416404',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18441,53,'Banewadi','416410',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18442,53,'Banpuri','415306',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18443,53,'Banur','416311',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18444,53,'Basargi','416404',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18445,53,'Bastawade','416311',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18446,53,'Bavachi','416301',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18447,53,'Bedag','416410',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18448,53,'Belanki','416410',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18449,53,'Belavade','415305',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18450,53,'Bellondagi','416413',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18451,53,'Bendri','416312',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18452,53,'Bevnur','416404',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18453,53,'Bhadkimbe','416302',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18454,53,'Bhalavani','415311',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18455,53,'Bhatshirgaon','415408',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18456,53,'Bhavaninagar (Sangli)','415302',1,0,'2022-03-03 12:27:53','2022-03-03 12:27:53'),(18457,53,'Bhendavade','415310',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18458,53,'Bhikavadi BK','415310',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18459,53,'Bhikawadi Kurd','415311',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18460,53,'Bhilavadi','416303',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18461,53,'Bhilwadi R.S.','416303',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18462,53,'Bhood','415309',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18463,53,'Bhose','416420',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18464,53,'Bichud','415302',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18465,53,'Bilashi','415402',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18466,53,'Billur','416404',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18467,53,'Biranwadi','416312',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18468,53,'Bisur','416304',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18469,53,'Biur','415408',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18470,53,'Boblad Jadar','416413',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18471,53,'Boblad K','416412',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18472,53,'Bolwad','416410',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18473,53,'Borgaon (T)','416312',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18474,53,'Borgaon','416419',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18475,53,'Borgaon (Sangli)','415413',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18476,53,'Borgi(Khurd)','416413',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18477,53,'Brahmanal','416416',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18478,53,'Brahmanpuri Miraj','416410',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18479,53,'Budhgaon','416304',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18480,53,'Burli','416308',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18481,53,'Charan','415405',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18482,53,'Chikhalhol','415310',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18483,53,'Chikhali','415408',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18484,53,'Chikurde','415412',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18485,53,'Chinchani (T)','416312',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18486,53,'Chinchani Ambak','415303',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18487,53,'Chinchani Mangrul','415311',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18488,53,'Chincholi','415405',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18489,53,'Chorochi','416403',1,0,'2022-03-03 12:27:54','2022-03-03 12:27:54'),(18490,53,'Dahiwadi','416311',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18491,53,'Daphalapur','416402',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18492,53,'Daribadachi','416412',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18493,53,'Deshing','416410',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18494,53,'Devikhindi','415309',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18495,53,'Devrashtra','415303',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18496,53,'Devwadi','415412',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18497,53,'Dhagewadi','415401',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18498,53,'Dhalewadi','416405',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18499,53,'Dhalgaon','416403',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18500,53,'Dhamavade','415408',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18501,53,'Dhavadwadi','416403',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18502,53,'Dhavaleshwar','415311',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18503,53,'Dhavali (T)','416312',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18504,53,'Dhavali','416302',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18505,53,'Dhavali','416410',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18506,53,'Dhulgaon','416420',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18507,53,'Dighanchi','415315',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18508,53,'Digraj Kasaba Agri School','416305',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18509,53,'Digraj Kasaba','416305',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18510,53,'Dongarsoni','416311',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18511,53,'Dongarwadi','416407',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18512,53,'Dorli','416403',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18513,53,'Dudhgaon','416315',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18514,53,'Dudhondi','416308',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18515,53,'Factory Area Sangli','416416',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18516,53,'Gajanan Mills Sangli','416416',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18517,53,'Ganpati Peth Sangli','416416',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18518,53,'Gardi','415311',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18519,53,'Gaurgaon','416312',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18520,53,'Gavan','416408',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18521,53,'Ghanand','415308',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18522,53,'Gharniki','415308',1,0,'2022-03-03 12:27:55','2022-03-03 12:27:55'),(18523,53,'Ghatnandre','416405',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18524,53,'Ghogaon','416309',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18525,53,'Ghorpadi','416403',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18526,53,'Ghoti Khurd','415311',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18527,53,'Girgaon','416413',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18528,53,'Gomewadi','415306',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18529,53,'Gotkhindi','416301',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18530,53,'Govt. Colony','416415',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18531,53,'Govt.Medical College Miraj','416410',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18532,53,'Gugwad','416404',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18533,53,'Gundewadi','416407',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18534,53,'Guruwar Peth','tasgaon',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18535,53,'Hanmant Vadiye','415305',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18536,53,'Haripur','416416',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18537,53,'Hatnoli','416314',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18538,53,'Hatnur','416314',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18539,53,'Hingangade','415311',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18540,53,'Hingangaon','416405',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18541,53,'Hingangaon Bk','415305',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18542,53,'Hingangaon Khurd','415305',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18543,53,'Hivare','415307',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18544,53,'Hivtad','415306',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18545,53,'Inam Dhamni','416416',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18546,53,'Ingrul','415408',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18547,53,'Irali','416405',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18548,53,'Itkare','415403',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18549,53,'Jadhavwadi','415311',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18550,53,'Jaigavan','416419',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18551,53,'Jakhapur','416405',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18552,53,'Jarandi','416311',1,0,'2022-03-03 12:27:56','2022-03-03 12:27:56'),(18553,53,'Jath','416404',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18554,53,'Jirgyal','416402',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18555,53,'Jondhalkhindi','415309',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18556,53,'Junekhed','416313',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18557,53,'Kadegaon','415304',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18558,53,'Kadepur','415305',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18559,53,'Kalambi','416410',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18560,53,'Kalamwadi','415406',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18561,53,'Kalundre','415415',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18562,53,'Kameri','415403',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18563,53,'Kanchanpur','416306',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18564,53,'Kande','415412',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18565,53,'Kandur','415408',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18566,53,'Kanegaon','415411',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18567,53,'Kapuskhed','415409',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18568,53,'Karandwadi','416301',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18569,53,'Karanguli','415415',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18570,53,'Karanjawade','415401',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18571,53,'Karanje','416312',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18572,53,'Kargani','415306',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18573,53,'Karmala','415408',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18574,53,'Karnal','416416',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18575,53,'Karoli  T','416405',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18576,53,'Karoli (M)','416408',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18577,53,'Karve','415401',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18578,53,'Karve','415311',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18579,53,'Kasegaon','415404',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18580,53,'Kautholi','415301',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18581,53,'Kavaji Khotwadi','416304',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18582,53,'Kavalapur','416306',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18583,53,'Kavathe Ekand','416307',1,0,'2022-03-03 12:27:57','2022-03-03 12:27:57'),(18584,53,'Kavathe Mahankal','416405',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18585,53,'Kavathe Piran','416417',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18586,53,'Kerewadi','416403',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18587,53,'Khalati','416402',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18588,53,'Khalsa Dhamni','416314',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18589,53,'Khambale','415311',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18590,53,'Khanapur (Sangli)','415307',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18591,53,'Khanderajuri','416410',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18592,53,'Kharshing','416410',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18593,53,'Kharsundi','415308',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18594,53,'Khatav','416401',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18595,53,'Kherade','415311',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18596,53,'Khujgaon','416311',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18597,53,'Khujgaon','415405',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18598,53,'Killemachindragad','415302',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18599,53,'Kirloskarwadi','416308',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18600,53,'Kognoli','416418',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18601,53,'Kokale','416405',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18602,53,'Kokrud','415405',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18603,53,'Koregaon','416302',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18604,53,'Kosari','416403',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18605,53,'Kuchi','416405',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18606,53,'Kuktoli','416418',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18607,53,'Kumatha','416306',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18608,53,'Kumbhari','416403',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18609,53,'Kundal (Sangli)','416309',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18610,53,'Kundalapur','416405',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18611,53,'Kundalwadi','415411',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18612,53,'Kunikonnur','416404',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18613,53,'Kupwad','416436',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18614,53,'Kupwad MIDC Area','416436',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18615,53,'Kurlap','415411',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18616,53,'Ladegaon','415401',1,0,'2022-03-03 12:27:58','2022-03-03 12:27:58'),(18617,53,'Landgewadi','416419',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18618,53,'Langarpeth','416405',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18619,53,'Lengare','415309',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18620,53,'Limb','416312',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18621,53,'Lingiware','415315',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18622,53,'Lingnoor','416401',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18623,53,'Lode','416312',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18624,53,'Lonarwadi','416411',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18625,53,'Madgule','415301',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18626,53,'Madgyal','416413',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18627,53,'Madhavnagar','416406',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18628,53,'Mahuli (Sangli)','415310',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18629,53,'Malangaon','416419',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18630,53,'Malgaon','416407',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18631,53,'Mallewadi','416410',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18632,53,'Malwadi','416315',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18633,53,'Manerajuri','416408',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18634,53,'Mangale','415412',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18635,53,'Mangalwar Peth Miraj','416410',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18636,53,'Mangrul','415402',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18637,53,'Manikwadi','415407',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18638,53,'Manjarde','416312',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18639,53,'Mardwadi','416301',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18640,53,'Market Yard Sangli','416416',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18641,53,'Masuchiwadi','415413',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18642,53,'Mendhigiri','416404',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18643,53,'Meni','415405',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18644,53,'Mhaisal','416409',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18645,53,'Miraj Audyogik Vasahat','416410',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18646,53,'Miraj H.O','416410',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18647,53,'Miraj Station Road','416410',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18648,53,'Mirajwadi','416301',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18649,53,'Mohi','415307',1,0,'2022-03-03 12:27:59','2022-03-03 12:27:59'),(18650,53,'Morale','416310',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18651,53,'Mouje Digraj','416416',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18652,53,'Muchandi','416404',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18653,53,'Nagaj','416403',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18654,53,'Nagaon','416302',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18655,53,'Nagarale','416308',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18656,53,'Nagewadi','415311',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18657,53,'Nagthane','416313',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18658,53,'Nandre','416416',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18659,53,'Nangole','416405',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18660,53,'Narsinhpur','415409',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18661,53,'Narwad','416409',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18662,53,'Nathawade','415405',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18663,53,'Natoli','415408',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18664,53,'Nelkaranji','415308',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18665,53,'Nerla','415406',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18666,53,'Nerli','415304',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18667,53,'Nevari','415311',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18668,53,'Nigadi','415408',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18669,53,'Nigdi Khurd','416404',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18670,53,'Nimani','416312',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18671,53,'Nimbavade','415301',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18672,53,'Nimblak','416312',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18673,53,'Ozarde','415407',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18674,53,'Pachumbri','415410',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18675,53,'Padali','416314',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18676,53,'Padalichiwadi','415408',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18677,53,'Padmale','416416',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18678,53,'Palashi','415307',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18679,53,'Palus','416310',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18680,53,'Panumbre Turf Shirala','415410',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18681,53,'Panumbre Turf Warun','415405',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18682,53,'Pare','415311',1,0,'2022-03-03 12:28:00','2022-03-03 12:28:00'),(18683,53,'Payappachiwadi','416410',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18684,53,'Ped','416312',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18685,53,'Peth (Sangli)','415407',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18686,53,'Phuphire','415408',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18687,53,'Pimpri Budruk','415308',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18688,53,'Pokharni','416301',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18689,53,'Punadi (T)','416312',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18690,53,'Punadi T/F Walwa','416308',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18691,53,'Punvat','415408',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18692,53,'R K Extension Sangli','416416',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18693,53,'Rajapur','416310',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18694,53,'Ramanandnagar','416308',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18695,53,'Ramapur','415303',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18696,53,'Ranjani (Sangli)','416411',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18697,53,'Red','415407',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18698,53,'Renavi','415311',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18699,53,'Rethare Dharan','415407',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18700,53,'Rethare Harnaksha','415302',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18701,53,'Revangaon','415311',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18702,53,'Revnal','416404',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18703,53,'Rile','415408',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18704,53,'S S K Sakharale','415414',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18705,53,'S S K Sangli','416416',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18706,53,'Sagaon','415408',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18707,53,'Saholi','415305',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18708,53,'Sakharale','415414',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18709,53,'Salgare','416418',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18710,53,'Salshinge','415311',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18711,53,'Samdolii','416416',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18712,53,'Sangalwadi','416416',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18713,53,'Sangli City','416416',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18714,53,'Sangli H.O','416416',1,0,'2022-03-03 12:28:01','2022-03-03 12:28:01'),(18715,53,'Sankh','416412',1,0,'2022-03-03 12:28:02','2022-03-03 12:28:02'),(18716,53,'Sanmadi','416404',1,0,'2022-03-03 12:28:02','2022-03-03 12:28:02'),(18717,53,'Savarde','416408',1,0,'2022-03-03 12:28:02','2022-03-03 12:28:02'),(18718,53,'Savlaj','416311',1,0,'2022-03-03 12:28:02','2022-03-03 12:28:02'),(18719,53,'Sawantpur','416310',1,0,'2022-03-03 12:28:02','2022-03-03 12:28:02'),(18720,53,'Shalgaon','415304',1,0,'2022-03-03 12:28:02','2022-03-03 12:28:02'),(18721,53,'Shaniwar Peth Miraj','416410',1,0,'2022-03-03 12:28:02','2022-03-03 12:28:02'),(18722,53,'Shegaon','416404',1,0,'2022-03-03 12:28:02','2022-03-03 12:28:02'),(18723,53,'Shelakbav','415305',1,0,'2022-03-03 12:28:02','2022-03-03 12:28:02'),(18724,53,'Shetphale','415306',1,0,'2022-03-03 12:28:02','2022-03-03 12:28:02'),(18725,53,'Shigaon','416302',1,0,'2022-03-03 12:28:02','2022-03-03 12:28:02'),(18726,53,'Shindewadi','416401',1,0,'2022-03-03 12:28:02','2022-03-03 12:28:02'),(18727,53,'Shinganapur','416405',1,0,'2022-03-03 12:28:02','2022-03-03 12:28:02'),(18728,53,'Shinganhalli','416404',1,0,'2022-03-03 12:28:02','2022-03-03 12:28:02'),(18729,53,'Shipur','416410',1,0,'2022-03-03 12:28:02','2022-03-03 12:28:02'),(18730,53,'Shirala','415408',1,0,'2022-03-03 12:28:02','2022-03-03 12:28:02'),(18731,53,'Shirasgaon','415303',1,0,'2022-03-03 12:28:02','2022-03-03 12:28:02'),(18732,53,'Shirashi','415408',1,0,'2022-03-03 12:28:02','2022-03-03 12:28:02'),(18733,53,'Shirdhon','416419',1,0,'2022-03-03 12:28:02','2022-03-03 12:28:02'),(18734,53,'Shirte','415409',1,0,'2022-03-03 12:28:03','2022-03-03 12:28:03'),(18735,53,'Shivajinagar','415304',1,0,'2022-03-03 12:28:03','2022-03-03 12:28:03'),(18736,53,'Shivani','415305',1,0,'2022-03-03 12:28:03','2022-03-03 12:28:03'),(18737,53,'Siddhewadi','416410',1,0,'2022-03-03 12:28:03','2022-03-03 12:28:03'),(18738,53,'Siddhewadi Savalaj','416311',1,0,'2022-03-03 12:28:03','2022-03-03 12:28:03'),(18739,53,'Sidhnath','416412',1,0,'2022-03-03 12:28:03','2022-03-03 12:28:03'),(18740,53,'Sindur','416404',1,0,'2022-03-03 12:28:03','2022-03-03 12:28:03'),(18741,53,'Sonavade','415415',1,0,'2022-03-03 12:28:03','2022-03-03 12:28:03'),(18742,53,'Soni','416420',1,0,'2022-03-03 12:28:03','2022-03-03 12:28:03'),(18743,53,'Sonkire','415303',1,0,'2022-03-03 12:28:03','2022-03-03 12:28:03'),(18744,53,'Sonsal','415303',1,0,'2022-03-03 12:28:03','2022-03-03 12:28:03'),(18745,53,'Sonyal','416413',1,0,'2022-03-03 12:28:03','2022-03-03 12:28:03'),(18746,53,'Sordi','416412',1,0,'2022-03-03 12:28:03','2022-03-03 12:28:03'),(18747,53,'Subhashnagar','416437',1,0,'2022-03-03 12:28:03','2022-03-03 12:28:03'),(18748,53,'Sultangade','415307',1,0,'2022-03-03 12:28:03','2022-03-03 12:28:03'),(18749,53,'Surul','415407',1,0,'2022-03-03 12:28:04','2022-03-03 12:28:04'),(18750,53,'Suslad','416413',1,0,'2022-03-03 12:28:04','2022-03-03 12:28:04'),(18751,53,'Tadavale','415408',1,0,'2022-03-03 12:28:04','2022-03-03 12:28:04'),(18752,53,'Tadawale','415306',1,0,'2022-03-03 12:28:04','2022-03-03 12:28:04'),(18753,53,'Tadsar','415304',1,0,'2022-03-03 12:28:04','2022-03-03 12:28:04'),(18754,53,'Takari','415313',1,0,'2022-03-03 12:28:04','2022-03-03 12:28:04'),(18755,53,'Takave','415410',1,0,'2022-03-03 12:28:04','2022-03-03 12:28:04'),(18756,53,'Tambave','415404',1,0,'2022-03-03 12:28:04','2022-03-03 12:28:04'),(18757,53,'Tanang','416410',1,0,'2022-03-03 12:28:04','2022-03-03 12:28:04'),(18758,53,'Tandulwadi','415411',1,0,'2022-03-03 12:28:04','2022-03-03 12:28:04'),(18759,53,'Tasgaon M.D.G','416312',1,0,'2022-03-03 12:28:04','2022-03-03 12:28:04'),(18760,53,'Tavadarwadi','416303',1,0,'2022-03-03 12:28:04','2022-03-03 12:28:04'),(18761,53,'Thanapude','415412',1,0,'2022-03-03 12:28:04','2022-03-03 12:28:04'),(18762,53,'Tikundi','416412',1,0,'2022-03-03 12:28:04','2022-03-03 12:28:04'),(18763,53,'Tisangi','416405',1,0,'2022-03-03 12:28:05','2022-03-03 12:28:05'),(18764,53,'Tondoli','415305',1,0,'2022-03-03 12:28:05','2022-03-03 12:28:05'),(18765,53,'Tujarpur','415403',1,0,'2022-03-03 12:28:05','2022-03-03 12:28:05'),(18766,53,'Tung','416301',1,0,'2022-03-03 12:28:05','2022-03-03 12:28:05'),(18767,53,'Tupari','415313',1,0,'2022-03-03 12:28:05','2022-03-03 12:28:05'),(18768,53,'Turchi','416312',1,0,'2022-03-03 12:28:05','2022-03-03 12:28:05'),(18769,53,'Umadi','416413',1,0,'2022-03-03 12:28:05','2022-03-03 12:28:05'),(18770,53,'Umarani','416404',1,0,'2022-03-03 12:28:05','2022-03-03 12:28:05'),(18771,53,'Upalavi','416306',1,0,'2022-03-03 12:28:05','2022-03-03 12:28:05'),(18772,53,'Upale Mayani','415305',1,0,'2022-03-03 12:28:05','2022-03-03 12:28:05'),(18773,53,'Urun Islampur','415409',1,0,'2022-03-03 12:28:05','2022-03-03 12:28:05'),(18774,53,'Utagi','416413',1,0,'2022-03-03 12:28:05','2022-03-03 12:28:05'),(18775,53,'Vaddi','416410',1,0,'2022-03-03 12:28:06','2022-03-03 12:28:06'),(18776,53,'Vadgaon','416311',1,0,'2022-03-03 12:28:06','2022-03-03 12:28:06'),(18777,53,'Vadgaon Mohite','415303',1,0,'2022-03-03 12:28:06','2022-03-03 12:28:06'),(18778,53,'Vadiye Raibag','415305',1,0,'2022-03-03 12:28:06','2022-03-03 12:28:06'),(18779,53,'Vajrawad','416404',1,0,'2022-03-03 12:28:06','2022-03-03 12:28:06'),(18780,53,'Valkhad','415310',1,0,'2022-03-03 12:28:06','2022-03-03 12:28:06'),(18781,53,'Valsang','416404',1,0,'2022-03-03 12:28:06','2022-03-03 12:28:06'),(18782,53,'Valuj','415309',1,0,'2022-03-03 12:28:06','2022-03-03 12:28:06'),(18783,53,'Valvan','415308',1,0,'2022-03-03 12:28:06','2022-03-03 12:28:06'),(18784,53,'Vangi','415305',1,0,'2022-03-03 12:28:07','2022-03-03 12:28:07'),(18785,53,'Vasgade','416416',1,0,'2022-03-03 12:28:07','2022-03-03 12:28:07'),(18786,53,'Vasumbe (T)','416312',1,0,'2022-03-03 12:28:07','2022-03-03 12:28:07'),(18787,53,'Vasumbe','415309',1,0,'2022-03-03 12:28:07','2022-03-03 12:28:07'),(18788,53,'Vejegaon','415310',1,0,'2022-03-03 12:28:07','2022-03-03 12:28:07'),(18789,53,'Vhaspet','416413',1,0,'2022-03-03 12:28:08','2022-03-03 12:28:08'),(18790,53,'Vibhutwadi','415301',1,0,'2022-03-03 12:28:08','2022-03-03 12:28:08'),(18791,53,'Vihapur','415304',1,0,'2022-03-03 12:28:08','2022-03-03 12:28:08'),(18792,53,'Visapur (Sangli)','416314',1,0,'2022-03-03 12:28:08','2022-03-03 12:28:08'),(18793,53,'Vite City','415311',1,0,'2022-03-03 12:28:08','2022-03-03 12:28:08'),(18794,53,'Vite','415311',1,0,'2022-03-03 12:28:08','2022-03-03 12:28:08'),(18795,53,'Waiphale','416312',1,0,'2022-03-03 12:28:08','2022-03-03 12:28:08'),(18796,53,'Wakurde BK','415408',1,0,'2022-03-03 12:28:08','2022-03-03 12:28:08'),(18797,53,'Wakurde Khurd','415408',1,0,'2022-03-03 12:28:08','2022-03-03 12:28:08'),(18798,53,'Walekhindi','416404',1,0,'2022-03-03 12:28:09','2022-03-03 12:28:09'),(18799,53,'Walwa','416313',1,0,'2022-03-03 12:28:09','2022-03-03 12:28:09'),(18800,53,'Wanlsswadi','416414',1,0,'2022-03-03 12:28:09','2022-03-03 12:28:09'),(18801,53,'Warnavati Vasahat','415415',1,0,'2022-03-03 12:28:09','2022-03-03 12:28:09'),(18802,53,'Washan','416402',1,0,'2022-03-03 12:28:09','2022-03-03 12:28:09'),(18803,53,'Wategaon','415410',1,0,'2022-03-03 12:28:09','2022-03-03 12:28:09'),(18804,53,'Willingdon College Sangli','416415',1,0,'2022-03-03 12:28:09','2022-03-03 12:28:09'),(18805,53,'Yamgarwadi','416312',1,0,'2022-03-03 12:28:09','2022-03-03 12:28:09'),(18806,53,'Yedemachindra','415409',1,0,'2022-03-03 12:28:09','2022-03-03 12:28:09'),(18807,53,'Yedenipani','415403',1,0,'2022-03-03 12:28:10','2022-03-03 12:28:10'),(18808,53,'Yelapur','415405',1,0,'2022-03-03 12:28:10','2022-03-03 12:28:10'),(18809,53,'Yelavi','416416',1,0,'2022-03-03 12:28:10','2022-03-03 12:28:10'),(18810,53,'Yelur','415411',1,0,'2022-03-03 12:28:10','2022-03-03 12:28:10'),(18811,53,'Yelvi','416404',1,0,'2022-03-03 12:28:10','2022-03-03 12:28:10'),(18812,53,'Yerandoli','416410',1,0,'2022-03-03 12:28:10','2022-03-03 12:28:10'),(18813,53,'Yetgaon','415311',1,0,'2022-03-03 12:28:10','2022-03-03 12:28:10'),(18814,53,'Zare','415301',1,0,'2022-03-03 12:28:10','2022-03-03 12:28:10'),(18815,54,'Shindi','415715',1,0,'2022-03-03 12:28:11','2022-03-03 12:28:11'),(18816,54,'Uchat','415715',1,0,'2022-03-03 12:28:11','2022-03-03 12:28:11'),(18817,54,'Bhatghar','412206',1,0,'2022-03-03 12:28:11','2022-03-03 12:28:11'),(18818,54,'Abhepuri','412803',1,0,'2022-03-03 12:28:11','2022-03-03 12:28:11'),(18819,54,'Adarki BK','415537',1,0,'2022-03-03 12:28:11','2022-03-03 12:28:11'),(18820,54,'Adarki Khurd','415537',1,0,'2022-03-03 12:28:11','2022-03-03 12:28:11'),(18821,54,'Adul','415205',1,0,'2022-03-03 12:28:11','2022-03-03 12:28:11'),(18822,54,'Agashivnagar','415539',1,0,'2022-03-03 12:28:11','2022-03-03 12:28:11'),(18823,54,'Ahir','412806',1,0,'2022-03-03 12:28:11','2022-03-03 12:28:11'),(18824,54,'Ahire','412802',1,0,'2022-03-03 12:28:11','2022-03-03 12:28:11'),(18825,54,'Akoshi','412803',1,0,'2022-03-03 12:28:11','2022-03-03 12:28:11'),(18826,54,'Alewadi','415012',1,0,'2022-03-03 12:28:12','2022-03-03 12:28:12'),(18827,54,'Ambale','415014',1,0,'2022-03-03 12:28:12','2022-03-03 12:28:12'),(18828,54,'Ambavade S Wagholi','415011',1,0,'2022-03-03 12:28:12','2022-03-03 12:28:12'),(18829,54,'Ambavawde KHD','415112',1,0,'2022-03-03 12:28:12','2022-03-03 12:28:12'),(18830,54,'Ambawade','415506',1,0,'2022-03-03 12:28:12','2022-03-03 12:28:12'),(18831,54,'Ambawade','415013',1,0,'2022-03-03 12:28:12','2022-03-03 12:28:12'),(18832,54,'Ambawade S Koregaon','415021',1,0,'2022-03-03 12:28:13','2022-03-03 12:28:13'),(18833,54,'Ambedare Bk','415002',1,0,'2022-03-03 12:28:13','2022-03-03 12:28:13'),(18834,54,'Ambheri','415511',1,0,'2022-03-03 12:28:13','2022-03-03 12:28:13'),(18835,54,'Ambheri','415527',1,0,'2022-03-03 12:28:13','2022-03-03 12:28:13'),(18836,54,'Ambrag','415206',1,0,'2022-03-03 12:28:13','2022-03-03 12:28:13'),(18837,54,'Ambrule','415205',1,0,'2022-03-03 12:28:13','2022-03-03 12:28:13'),(18838,54,'Anapatwadi','415525',1,0,'2022-03-03 12:28:13','2022-03-03 12:28:13'),(18839,54,'Andali','415508',1,0,'2022-03-03 12:28:13','2022-03-03 12:28:13'),(18840,54,'Andarud','415523',1,0,'2022-03-03 12:28:13','2022-03-03 12:28:13'),(18841,54,'Andhari','415002',1,0,'2022-03-03 12:28:13','2022-03-03 12:28:13'),(18842,54,'Andori','415521',1,0,'2022-03-03 12:28:13','2022-03-03 12:28:13'),(18843,54,'Anewadi','415020',1,0,'2022-03-03 12:28:13','2022-03-03 12:28:13'),(18844,54,'Angapur Vandan','415019',1,0,'2022-03-03 12:28:13','2022-03-03 12:28:13'),(18845,54,'Antavadi','415106',1,0,'2022-03-03 12:28:13','2022-03-03 12:28:13'),(18846,54,'Apashinge (Rahimatpur)','415511',1,0,'2022-03-03 12:28:13','2022-03-03 12:28:13'),(18847,54,'Apashinge','415518',1,0,'2022-03-03 12:28:13','2022-03-03 12:28:13'),(18848,54,'Apati','412806',1,0,'2022-03-03 12:28:13','2022-03-03 12:28:13'),(18849,54,'Aradgaon','415521',1,0,'2022-03-03 12:28:13','2022-03-03 12:28:13'),(18850,54,'Arale','415011',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18851,54,'Are','415002',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18852,54,'Arewadi','415114',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18853,54,'Arvi','415116',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18854,54,'Asagaon Vasahat','415011',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18855,54,'Asale','415513',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18856,54,'Asangaon','415002',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18857,54,'Asani','415012',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18858,54,'Asare','412803',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18859,54,'Asawali','412802',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18860,54,'Asia Plato','412805',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18861,54,'Asu','415523',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18862,54,'Atake','415539',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18863,54,'Atit','415519',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18864,54,'Atit','412802',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18865,54,'Aundh','415510',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18866,54,'Avarde','415014',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18867,54,'Bahule','415209',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18868,54,'Baleghar','412803',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18869,54,'Bamanoli','415002',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18870,54,'Bambawade','415014',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18871,54,'Bamnoli Tarf Kudal','415514',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18872,54,'Banavadi','415011',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18873,54,'Banavady Colony','415124',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18874,54,'Banghar','415013',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18875,54,'Banpuri','415112',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18876,54,'Banpuri','415507',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18877,54,'Barad','415523',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18878,54,'Bavadhan','412804',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18879,54,'Bawada','412802',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18880,54,'Beladare','415114',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18881,54,'Belawade BK','415539',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18882,54,'Belawade Hawali','415109',1,0,'2022-03-03 12:28:14','2022-03-03 12:28:14'),(18883,54,'Belawade KH','415205',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18884,54,'Bhadale','415021',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18885,54,'Bhade','415526',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18886,54,'Bhaktawadi','415010',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18887,54,'Bhanang','415022',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18888,54,'Bharatgaon Wadi','415519',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18889,54,'Bhatmarli','415002',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18890,54,'Bhilar','412805',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18891,54,'Bhiwadi','415514',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18892,54,'Bhogaon','412803',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18893,54,'Bholi','415526',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18894,54,'Bhosare','415527',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18895,54,'Bhose','415501',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18896,54,'Bhuinj','415515',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18897,54,'Bhurkawadi','415505',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18898,54,'Bibhavi','415012',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18899,54,'Bibi','415537',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18900,54,'Bibi(Patan)','415206',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18901,54,'Bichukale','415524',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18902,54,'Bidal','415508',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18903,54,'Bijawadi','415508',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18904,54,'Biramani','412806',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18905,54,'Birwadi','412806',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18906,54,'Bombale','415507',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18907,54,'Bondri','415206',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18908,54,'Bopardi','412803',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18909,54,'Bopoli','415207',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18910,54,'Boposhi','415013',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18911,54,'Boragaon','415519',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18912,54,'Boregaon  Agricultural School','415519',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18913,54,'Borgaon','415511',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18914,54,'Borgaon BK','412803',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18915,54,'Borjaiwadi','415501',1,0,'2022-03-03 12:28:15','2022-03-03 12:28:15'),(18916,54,'Borkhal','415011',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18917,54,'Budh','415503',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18918,54,'Budhawar Naka Satara','415002',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18919,54,'Chanchali','415021',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18920,54,'Chandak','415536',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18921,54,'Chaphal','415520',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18922,54,'Charegaon','415109',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18923,54,'Chavan Wadi','415521',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18924,54,'Chavanwadi','415520',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18925,54,'Chchegaon','415122',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18926,54,'Chikhaewadi','415103',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18927,54,'Chikhali','412803',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18928,54,'Chikhali(Masur)','415106',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18929,54,'Chimangaon','415501',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18930,54,'Chinchaner S. Nimb','415501',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18931,54,'Chinchaner Vandan','415004',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18932,54,'Chindhawali','415513',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18933,54,'Chitali','415538',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18934,54,'Chopadi','415205',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18935,54,'Chorade','415538',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18936,54,'Chore','415109',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18937,54,'Dadholi','415520',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18938,54,'Dahigaon','415524',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18939,54,'Dahivad','415013',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18940,54,'Dahivadi','415508',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18941,54,'Dapavadi','412805',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18942,54,'Dare Khurd','415020',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18943,54,'Daruj','415505',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18944,54,'Daulat Nagar (Satara)','415211',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18945,54,'Degaon Shirgaon','412803',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18946,54,'Degaon Tambe','415004',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18947,54,'Dervan','415520',1,0,'2022-03-03 12:28:16','2022-03-03 12:28:16'),(18948,54,'Deur','415524',1,0,'2022-03-03 12:28:17','2022-03-03 12:28:17'),(18949,54,'Devapur','415509',1,0,'2022-03-03 12:28:17','2022-03-03 12:28:17'),(18950,54,'Dhamner','415511',1,0,'2022-03-03 12:28:17','2022-03-03 12:28:17'),(18951,54,'Dhamni','415112',1,0,'2022-03-03 12:28:17','2022-03-03 12:28:17'),(18952,54,'Dharpudi','415505',1,0,'2022-03-03 12:28:17','2022-03-03 12:28:17'),(18953,54,'Dhavadi','412803',1,0,'2022-03-03 12:28:17','2022-03-03 12:28:17'),(18954,54,'Dhaval','415523',1,0,'2022-03-03 12:28:17','2022-03-03 12:28:17'),(18955,54,'Dhawad Wadi','412802',1,0,'2022-03-03 12:28:17','2022-03-03 12:28:17'),(18956,54,'Dhawadshi','415022',1,0,'2022-03-03 12:28:17','2022-03-03 12:28:17'),(18957,54,'Dhebewadi','415112',1,0,'2022-03-03 12:28:17','2022-03-03 12:28:17'),(18958,54,'Dhom','412803',1,0,'2022-03-03 12:28:17','2022-03-03 12:28:17'),(18959,54,'Dhondewadi (K. Khatav)','415507',1,0,'2022-03-03 12:28:17','2022-03-03 12:28:17'),(18960,54,'Dhondewadi','415104',1,0,'2022-03-03 12:28:17','2022-03-03 12:28:17'),(18961,54,'Dhoroshi','415014',1,0,'2022-03-03 12:28:17','2022-03-03 12:28:17'),(18962,54,'Dhudhebavi','415523',1,0,'2022-03-03 12:28:17','2022-03-03 12:28:17'),(18963,54,'Dhuldev','415509',1,0,'2022-03-03 12:28:17','2022-03-03 12:28:17'),(18964,54,'Dhumalwadi','415010',1,0,'2022-03-03 12:28:18','2022-03-03 12:28:18'),(18965,54,'Diskal Mol','415504',1,0,'2022-03-03 12:28:18','2022-03-03 12:28:18'),(18966,54,'Divad','415509',1,0,'2022-03-03 12:28:18','2022-03-03 12:28:18'),(18967,54,'Divashi BK','415209',1,0,'2022-03-03 12:28:18','2022-03-03 12:28:18'),(18968,54,'Divashi Khrud','415206',1,0,'2022-03-03 12:28:18','2022-03-03 12:28:18'),(18969,54,'Dixi','415206',1,0,'2022-03-03 12:28:18','2022-03-03 12:28:18'),(18970,54,'Dund','415012',1,0,'2022-03-03 12:28:18','2022-03-03 12:28:18'),(18971,54,'Ekambe','415501',1,0,'2022-03-03 12:28:18','2022-03-03 12:28:18'),(18972,54,'Eksare','412803',1,0,'2022-03-03 12:28:18','2022-03-03 12:28:18'),(18973,54,'Gajavadi','415013',1,0,'2022-03-03 12:28:18','2022-03-03 12:28:18'),(18974,54,'Galmewadi','415103',1,0,'2022-03-03 12:28:18','2022-03-03 12:28:18'),(18975,54,'Gamewadi','415114',1,0,'2022-03-03 12:28:18','2022-03-03 12:28:18'),(18976,54,'Ganje','415012',1,0,'2022-03-03 12:28:18','2022-03-03 12:28:18'),(18977,54,'Garwade','415209',1,0,'2022-03-03 12:28:18','2022-03-03 12:28:18'),(18978,54,'Gavadi','415012',1,0,'2022-03-03 12:28:18','2022-03-03 12:28:18'),(18979,54,'Gavdoshi','412806',1,0,'2022-03-03 12:28:18','2022-03-03 12:28:18'),(18980,54,'Ghadagewadi','415537',1,0,'2022-03-03 12:28:18','2022-03-03 12:28:18'),(18981,54,'Gharewadi','415103',1,0,'2022-03-03 12:28:19','2022-03-03 12:28:19'),(18982,54,'Ghogaon','415111',1,0,'2022-03-03 12:28:19','2022-03-03 12:28:19'),(18983,54,'Ghosatawadi','415206',1,0,'2022-03-03 12:28:19','2022-03-03 12:28:19'),(18984,54,'Ghot','415014',1,0,'2022-03-03 12:28:19','2022-03-03 12:28:19'),(18985,54,'Girvi','415523',1,0,'2022-03-03 12:28:19','2022-03-03 12:28:19'),(18986,54,'Gogave','412806',1,0,'2022-03-03 12:28:19','2022-03-03 12:28:19'),(18987,54,'Gojegaon','415004',1,0,'2022-03-03 12:28:19','2022-03-03 12:28:19'),(18988,54,'Gokhali','415523',1,0,'2022-03-03 12:28:19','2022-03-03 12:28:19'),(18989,54,'Gondawale BK','415540',1,0,'2022-03-03 12:28:19','2022-03-03 12:28:19'),(18990,54,'Gondawale KHD','415540',1,0,'2022-03-03 12:28:19','2022-03-03 12:28:19'),(18991,54,'Gopuj','415510',1,0,'2022-03-03 12:28:19','2022-03-03 12:28:19'),(18992,54,'Goregaon Vangi','415512',1,0,'2022-03-03 12:28:19','2022-03-03 12:28:19'),(18993,54,'Govare','415105',1,0,'2022-03-03 12:28:19','2022-03-03 12:28:19'),(18994,54,'Govare','415207',1,0,'2022-03-03 12:28:19','2022-03-03 12:28:19'),(18995,54,'Gove','415015',1,0,'2022-03-03 12:28:19','2022-03-03 12:28:19'),(18996,54,'Gudhe','415112',1,0,'2022-03-03 12:28:19','2022-03-03 12:28:19'),(18997,54,'Gulumb','415536',1,0,'2022-03-03 12:28:19','2022-03-03 12:28:19'),(18998,54,'Gunavare','415523',1,0,'2022-03-03 12:28:19','2022-03-03 12:28:19'),(18999,54,'Gurusale','415506',1,0,'2022-03-03 12:28:20','2022-03-03 12:28:20'),(19000,54,'Hajarmachi','415105',1,0,'2022-03-03 12:28:20','2022-03-03 12:28:20'),(19001,54,'Harchandi','412806',1,0,'2022-03-03 12:28:20','2022-03-03 12:28:20'),(19002,54,'Hateghar','415514',1,0,'2022-03-03 12:28:20','2022-03-03 12:28:20'),(19003,54,'Hatlot','412806',1,0,'2022-03-03 12:28:20','2022-03-03 12:28:20'),(19004,54,'Helagaon','415106',1,0,'2022-03-03 12:28:20','2022-03-03 12:28:20'),(19005,54,'Helwak','415207',1,0,'2022-03-03 12:28:20','2022-03-03 12:28:20'),(19006,54,'Hingangaon','415521',1,0,'2022-03-03 12:28:20','2022-03-03 12:28:20'),(19007,54,'Hivare','415021',1,0,'2022-03-03 12:28:20','2022-03-03 12:28:20'),(19008,54,'Hol','415522',1,0,'2022-03-03 12:28:20','2022-03-03 12:28:20'),(19009,54,'Holichagaon','415538',1,0,'2022-03-03 12:28:20','2022-03-03 12:28:20'),(19010,54,'Humgaon','415514',1,0,'2022-03-03 12:28:20','2022-03-03 12:28:20'),(19011,54,'Indoli','415109',1,0,'2022-03-03 12:28:20','2022-03-03 12:28:20'),(19012,54,'Injabav','415509',1,0,'2022-03-03 12:28:20','2022-03-03 12:28:20'),(19013,54,'ITI Satara','415002',1,0,'2022-03-03 12:28:20','2022-03-03 12:28:20'),(19014,54,'Jaigaon','415510',1,0,'2022-03-03 12:28:20','2022-03-03 12:28:20'),(19015,54,'Jakatwadi','415002',1,0,'2022-03-03 12:28:20','2022-03-03 12:28:20'),(19016,54,'Jakhangaon','415505',1,0,'2022-03-03 12:28:20','2022-03-03 12:28:20'),(19017,54,'Jalagewadi','415520',1,0,'2022-03-03 12:28:21','2022-03-03 12:28:21'),(19018,54,'Jalav','415014',1,0,'2022-03-03 12:28:21','2022-03-03 12:28:21'),(19019,54,'Jalgaon','415010',1,0,'2022-03-03 12:28:21','2022-03-03 12:28:21'),(19020,54,'Jamb (Kikali)','415530',1,0,'2022-03-03 12:28:21','2022-03-03 12:28:21'),(19021,54,'Jamb Budurk','415501',1,0,'2022-03-03 12:28:21','2022-03-03 12:28:21'),(19022,54,'Jamb Khurd','415021',1,0,'2022-03-03 12:28:21','2022-03-03 12:28:21'),(19023,54,'Jamb(Khatav)','415505',1,0,'2022-03-03 12:28:21','2022-03-03 12:28:21'),(19024,54,'Janugade Wadi','415112',1,0,'2022-03-03 12:28:21','2022-03-03 12:28:21'),(19025,54,'Javale','412801',1,0,'2022-03-03 12:28:21','2022-03-03 12:28:21'),(19026,54,'Javli','415523',1,0,'2022-03-03 12:28:21','2022-03-03 12:28:21'),(19027,54,'Jihe','415004',1,0,'2022-03-03 12:28:21','2022-03-03 12:28:21'),(19028,54,'Jinti (Ond)','415111',1,0,'2022-03-03 12:28:21','2022-03-03 12:28:21'),(19029,54,'Jinti','415522',1,0,'2022-03-03 12:28:21','2022-03-03 12:28:21'),(19030,54,'Jinti.','415112',1,0,'2022-03-03 12:28:21','2022-03-03 12:28:21'),(19031,54,'Kadavebuduruk','415014',1,0,'2022-03-03 12:28:21','2022-03-03 12:28:21'),(19032,54,'Kadegaon','412803',1,0,'2022-03-03 12:28:21','2022-03-03 12:28:21'),(19033,54,'Kadhane','415103',1,0,'2022-03-03 12:28:21','2022-03-03 12:28:21'),(19034,54,'Kalagaon(Umbraj)','415109',1,0,'2022-03-03 12:28:21','2022-03-03 12:28:21'),(19035,54,'Kalaj','415528',1,0,'2022-03-03 12:28:21','2022-03-03 12:28:21'),(19036,54,'Kalambi','415512',1,0,'2022-03-03 12:28:22','2022-03-03 12:28:22'),(19037,54,'Kalawade','415539',1,0,'2022-03-03 12:28:22','2022-03-03 12:28:22'),(19038,54,'Kale (Satara)','415104',1,0,'2022-03-03 12:28:22','2022-03-03 12:28:22'),(19039,54,'Kaledhon','415312',1,0,'2022-03-03 12:28:22','2022-03-03 12:28:22'),(19040,54,'Kalgaon','415112',1,0,'2022-03-03 12:28:22','2022-03-03 12:28:22'),(19041,54,'Kameri','415019',1,0,'2022-03-03 12:28:22','2022-03-03 12:28:22'),(19042,54,'Kanher Khed','415501',1,0,'2022-03-03 12:28:22','2022-03-03 12:28:22'),(19043,54,'Kanher-akale','415022',1,0,'2022-03-03 12:28:22','2022-03-03 12:28:22'),(19044,54,'Kanheri','412802',1,0,'2022-03-03 12:28:22','2022-03-03 12:28:22'),(19045,54,'Kanur','412804',1,0,'2022-03-03 12:28:22','2022-03-03 12:28:22'),(19046,54,'Kapil Goleshwar','415124',1,0,'2022-03-03 12:28:22','2022-03-03 12:28:22'),(19047,54,'Kapshi','415537',1,0,'2022-03-03 12:28:22','2022-03-03 12:28:22'),(19048,54,'Karad H.O','415110',1,0,'2022-03-03 12:28:22','2022-03-03 12:28:22'),(19049,54,'Karadcity','415110',1,0,'2022-03-03 12:28:22','2022-03-03 12:28:22'),(19050,54,'Karandi (Kudal)','415514',1,0,'2022-03-03 12:28:22','2022-03-03 12:28:22'),(19051,54,'Karandi','415002',1,0,'2022-03-03 12:28:22','2022-03-03 12:28:22'),(19052,54,'Karanjkhop','415525',1,0,'2022-03-03 12:28:22','2022-03-03 12:28:22'),(19053,54,'Karavadi','415105',1,0,'2022-03-03 12:28:22','2022-03-03 12:28:22'),(19054,54,'Kari','415013',1,0,'2022-03-03 12:28:23','2022-03-03 12:28:23'),(19055,54,'Karnawadi','412802',1,0,'2022-03-03 12:28:23','2022-03-03 12:28:23'),(19056,54,'Karve','415124',1,0,'2022-03-03 12:28:23','2022-03-03 12:28:23'),(19057,54,'Kasarshirambe','415539',1,0,'2022-03-03 12:28:23','2022-03-03 12:28:23'),(19058,54,'Kashil','415519',1,0,'2022-03-03 12:28:23','2022-03-03 12:28:23'),(19059,54,'Kasur','415103',1,0,'2022-03-03 12:28:23','2022-03-03 12:28:23'),(19060,54,'Katahapur','415501',1,0,'2022-03-03 12:28:23','2022-03-03 12:28:23'),(19061,54,'Katarkhatav','415507',1,0,'2022-03-03 12:28:23','2022-03-03 12:28:23'),(19062,54,'Katgun','415502',1,0,'2022-03-03 12:28:23','2022-03-03 12:28:23'),(19063,54,'Kavathe','415516',1,0,'2022-03-03 12:28:23','2022-03-03 12:28:23'),(19064,54,'Kavathe.','415106',1,0,'2022-03-03 12:28:23','2022-03-03 12:28:23'),(19065,54,'Kedambe','415012',1,0,'2022-03-03 12:28:23','2022-03-03 12:28:23'),(19066,54,'Kelaghar','415012',1,0,'2022-03-03 12:28:23','2022-03-03 12:28:23'),(19067,54,'Kelambe','415014',1,0,'2022-03-03 12:28:23','2022-03-03 12:28:23'),(19068,54,'Kelembe','415022',1,0,'2022-03-03 12:28:23','2022-03-03 12:28:23'),(19069,54,'Keloli','415520',1,0,'2022-03-03 12:28:23','2022-03-03 12:28:23'),(19070,54,'Kenjal','415536',1,0,'2022-03-03 12:28:23','2022-03-03 12:28:23'),(19071,54,'Keral','415206',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19072,54,'Khale','415103',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19073,54,'Khanapur','412803',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19074,54,'Khandala Bavada','412802',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19075,54,'Kharshi','415020',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19076,54,'Kharshi','415514',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19077,54,'Khatagun','415502',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19078,54,'Khatav','415505',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19079,54,'Khed (Nandgiri)','415010',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19080,54,'Khed BK','415521',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19081,54,'Khed(Wadhe)','415003',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19082,54,'Khengar','412805',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19083,54,'Khodoshi','415124',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19084,54,'Khojewadi','415518',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19085,54,'Khubi','415108',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19086,54,'Khunte','415523',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19087,54,'Kidgaon','415015',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19088,54,'Kikali','415530',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19089,54,'Kindawadi','415004',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19090,54,'Kinhai','415021',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19091,54,'Kiroli','415116',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19092,54,'Kisanveernagar','415530',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19093,54,'Kival','415106',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19094,54,'Kodoli','415004',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19095,54,'Kodoli(Karad)','415124',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19096,54,'Kokarale','415527',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19097,54,'Kokisare','415206',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19098,54,'Kole (Satara)','415103',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19099,54,'Kolewadi','415103',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19100,54,'Kolki (Satara)','415523',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19101,54,'Kondhav Satara','415002',1,0,'2022-03-03 12:28:24','2022-03-03 12:28:24'),(19102,54,'Konegaon','415106',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19103,54,'Koparde (Lonand)','415521',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19104,54,'Koparde','415518',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19105,54,'Koprde Hawali','415115',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19106,54,'Koregaon City','415501',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19107,54,'Koregaon','415501',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19108,54,'Korivale','415109',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19109,54,'Koriwale','415209',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19110,54,'Koyana','415207',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19111,54,'Krti','415109',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19112,54,'Kshatra Mahuli','415003',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19113,54,'Kshetra Mahabaleshwar.','412806',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19114,54,'Kudal (Satara)','415514',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19115,54,'Kukudwad','415509',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19116,54,'Kulakjai','415503',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19117,54,'Kumathe','415501',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19118,54,'Kumathe Nagache','415527',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19119,54,'Kumbhargaon','415103',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19120,54,'Kumbharoshi','412806',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19121,54,'Kumthe','415002',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19122,54,'Kuroli Sidheshwar','415527',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19123,54,'Kuroshi','412806',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19124,54,'Kusawade','415206',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19125,54,'Kusumbi','415012',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19126,54,'Kusurund','415206',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19127,54,'Kuthare','415112',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19128,54,'Ladegaon','415512',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19129,54,'Lahasurne','415501',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19130,54,'Lalgun','415503',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19131,54,'Limbgove','415015',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19132,54,'Loham','412802',1,0,'2022-03-03 12:28:25','2022-03-03 12:28:25'),(19133,54,'Lonand','415521',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19134,54,'Loni','415527',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19135,54,'Loni','415526',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19136,54,'Machutar','412806',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19137,54,'Mahabaleshwar','412806',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19138,54,'Mahasave','415513',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19139,54,'Mahathe BK','415012',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19140,54,'Mahawashi','415206',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19141,54,'Mahawshi','415002',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19142,54,'Mahiamngad','415023',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19143,54,'Mahigaon','415020',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19144,54,'Mahind','415112',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19145,54,'Majgaon','415520',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19146,54,'Majgaon','415518',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19147,54,'Malagaon','415011',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19148,54,'Malakapur Karad','415539',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19149,54,'Malashi','415014',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19150,54,'Malawadi','415508',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19151,54,'Maldan','415112',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19152,54,'Malharpeth Karad','415205',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19153,54,'Mamuradi','415012',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19154,54,'Mandave','415506',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19155,54,'Mandhar Deo','412803',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19156,54,'Mandhave','415519',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19157,54,'Mandrul Haveli','415205',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19158,54,'Mandrulkole','415112',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19159,54,'Mane Wadi','415103',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19160,54,'Mangalwar Peth Karad','415110',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19161,54,'Mangalwar Peth Satara','415002',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19162,54,'Marali','415211',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19163,54,'Marali(Chore)','415109',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19164,54,'Mardhe','415020',1,0,'2022-03-03 12:28:26','2022-03-03 12:28:26'),(19165,54,'Mardi','415508',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19166,54,'Mariechi Wadi','415521',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19167,54,'Market yarad Phaltan','415523',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19168,54,'Market Yard Karad','415110',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19169,54,'Marul','415206',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19170,54,'Marul Haveli','415212',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19171,54,'Masur (Satara)','415106',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19172,54,'Mayani','415102',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19173,54,'Medha','415012',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19174,54,'Menavali','412803',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19175,54,'Mendh','415112',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19176,54,'Mendhoshi','415206',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19177,54,'Met Gutad','412806',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19178,54,'Mhaopre','415114',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19179,54,'Mhasoli','415111',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19180,54,'Mhasurne','415538',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19181,54,'Mhaswad','415509',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19182,54,'MIDC Satara','415004',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19183,54,'Mohat.','415012',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19184,54,'Mohi','415508',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19185,54,'Mol (Diskal)','415504',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19186,54,'Morale','415102',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19187,54,'Morawale','415022',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19188,54,'Morghar','415020',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19189,54,'Morgiri','415206',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19190,54,'Morve','412802',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19191,54,'Mouje Tasgaon','415004',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19192,54,'Munawale','415002',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19193,54,'Mundhe','415124',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19194,54,'Murud','415014',1,0,'2022-03-03 12:28:27','2022-03-03 12:28:27'),(19195,54,'Nade','415205',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19196,54,'Nadoli','415205',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19197,54,'Nagewadi','415015',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19198,54,'Nagthane','415519',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19199,54,'Nagzari','415116',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19200,54,'Naigaon','415525',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19201,54,'Naigaon','412801',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19202,54,'Nandal','415528',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19203,54,'Nandalapur','415539',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19204,54,'Nandawal','415525',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19205,54,'Nandgaon (Ond)','415111',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19206,54,'Nandgaon','415107',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19207,54,'Nandoshi','415510',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19208,54,'Nanegaon BK','415520',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19209,54,'Nanegaon KH','415520',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19210,54,'Naravane','415540',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19211,54,'Narayanwadi','415539',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19212,54,'Natoshi','415206',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19213,54,'Navadi','415209',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19214,54,'Navaja','415207',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19215,54,'Ner','415502',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19216,54,'Nhavi BK','415511',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19217,54,'Nidhal','415023',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19218,54,'Nigadi','415501',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19219,54,'Nigadi Masur','415106',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19220,54,'Nigadi Traf','415004',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19221,54,'Nimbhore','415528',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19222,54,'Nimblak','415523',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19223,54,'Nimsode','415538',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19224,54,'Nirgudi','415523',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19225,54,'Nisarale','415519',1,0,'2022-03-03 12:28:28','2022-03-03 12:28:28'),(19226,54,'Nisare','415205',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19227,54,'Nitral','415013',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19228,54,'Nune','415022',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19229,54,'Nune','415014',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19230,54,'Ogalewadi','415105',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19231,54,'Ond','415111',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19232,54,'Ozarde','412803',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19233,54,'Pachvad','415513',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19234,54,'Padal','415507',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19235,54,'Padali (Lonand)','415521',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19236,54,'Padali Masur','415106',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19237,54,'Padali Ninam','415519',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19238,54,'Padaloshi','415520',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19239,54,'Padegaon','415506',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19240,54,'Padegaon','415521',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19241,54,'Pal','415014',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19242,54,'Palasgaon','415507',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19243,54,'Palashi (Man)','415540',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19244,54,'Palashi (Vaduth)','415011',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19245,54,'Palashi','415512',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19246,54,'Palshi','412801',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19247,54,'Panchagani','412805',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19248,54,'Panchwad','415312',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19249,54,'Pande','415515',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19250,54,'Pangari','415508',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19251,54,'Paparde','415205',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19252,54,'Parali','415013',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19253,54,'Parayanti','415509',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19254,54,'Parkhandi','412803',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19255,54,'Parle','415124',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19256,54,'Pasarni','412803',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19257,54,'Patan (Satara)','415206',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19258,54,'Patkhal','415011',1,0,'2022-03-03 12:28:29','2022-03-03 12:28:29'),(19259,54,'Patole Khadaki','415509',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19260,54,'Pawar Wadi','415523',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19261,54,'Perale','415109',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19262,54,'Petpar','412806',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19263,54,'Phaltan','415523',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19264,54,'Phulenagar Wai','412803',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19265,54,'Pimpaloshi','415206',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19266,54,'Pimpari (K.Khatav)','415507',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19267,54,'Pimpari (Man)','415540',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19268,54,'Pimpari','415511',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19269,54,'Pimpode BK','415525',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19270,54,'Pimpode KH','415011',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19271,54,'Pimprad','415523',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19272,54,'Pimpre BK','415521',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19273,54,'Pingali BK','415506',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19274,54,'Potale','415103',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19275,54,'Pratapgad','412806',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19276,54,'Prtri','415002',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19277,54,'Pulkoti','415509',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19278,54,'Pusegaon','415502',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19279,54,'Pusesawali','415512',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19280,54,'Rahimatpur','415511',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19281,54,'Rahude','415014',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19282,54,'Raigaon','415020',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19283,54,'Rajachekurale','415512',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19284,54,'Rajale','415523',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19285,54,'Rajapuri','415013',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19286,54,'Rajapuri(Budh)','415503',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19287,54,'Rajuri','415523',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19288,54,'Ranand','415508',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19289,54,'Ranashingwadi','415503',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19290,54,'Randullahabad','415525',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19291,54,'Ranjani','412805',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19292,54,'Rasati','415207',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19293,54,'Rautwadi','415525',1,0,'2022-03-03 12:28:30','2022-03-03 12:28:30'),(19294,54,'Rawadi BK','415528',1,0,'2022-03-03 12:28:31','2022-03-03 12:28:31'),(19295,54,'Rethare BK','415108',1,0,'2022-03-03 12:28:31','2022-03-03 12:28:31'),(19296,54,'Rethare KH','415108',1,0,'2022-03-03 12:28:31','2022-03-03 12:28:31'),(19297,54,'Revadi','415011',1,0,'2022-03-03 12:28:31','2022-03-03 12:28:31'),(19298,54,'Riswad','415106',1,0,'2022-03-03 12:28:31','2022-03-03 12:28:31'),(19299,54,'Rohot','415013',1,0,'2022-03-03 12:28:31','2022-03-03 12:28:31'),(19300,54,'Rui','415501',1,0,'2022-03-03 12:28:31','2022-03-03 12:28:31'),(19301,54,'Sadawaghapur','415206',1,0,'2022-03-03 12:28:31','2022-03-03 12:28:31'),(19302,54,'Saidapur','415124',1,0,'2022-03-03 12:28:31','2022-03-03 12:28:31'),(19303,54,'Saigaon','415020',1,0,'2022-03-03 12:28:31','2022-03-03 12:28:31'),(19304,54,'Saikade','415103',1,0,'2022-03-03 12:28:31','2022-03-03 12:28:31'),(19305,54,'Sajjangad','415013',1,0,'2022-03-03 12:28:31','2022-03-03 12:28:31'),(19306,54,'Sajur','415209',1,0,'2022-03-03 12:28:31','2022-03-03 12:28:31'),(19307,54,'Sakharwadi','415522',1,0,'2022-03-03 12:28:31','2022-03-03 12:28:31'),(19308,54,'Sakurdi','415114',1,0,'2022-03-03 12:28:31','2022-03-03 12:28:31'),(19309,54,'Salave','415112',1,0,'2022-03-03 12:28:31','2022-03-03 12:28:31'),(19310,54,'Salpe','415521',1,0,'2022-03-03 12:28:31','2022-03-03 12:28:31'),(19311,54,'Salshirambe','415111',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19312,54,'Sangamnagar Satara','415003',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19313,54,'Sangavi','415523',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19314,54,'Sangvad','415205',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19315,54,'Sanpane','415514',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19316,54,'Sap','415511',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19317,54,'Saratale','415513',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19318,54,'Sarde','415523',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19319,54,'Sarjapur','415514',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19320,54,'Sarkalwadi.','415525',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19321,54,'Saskal','415523',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19322,54,'Saspade','415519',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19323,54,'Sasurve','415511',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19324,54,'Saswad (Lonand)','415521',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19325,54,'Satara H.O','415001',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19326,54,'Sataracity','415002',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19327,54,'Satararoad','415010',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19328,54,'Savade','415111',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19329,54,'Savarghar','415014',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19330,54,'Senawadi','415538',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19331,54,'Shahupuri Satara','415002',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19332,54,'Shamgaon','415106',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19333,54,'Shantinagar','415112',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19334,54,'Shapur','415115',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19335,54,'Shendare','415519',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19336,54,'Shendurjane','415021',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19337,54,'Shendurjane','412803',1,0,'2022-03-03 12:28:32','2022-03-03 12:28:32'),(19338,54,'Shere','415108',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19339,54,'Sherechiwadi','415521',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19340,54,'Shinde Khurd','415503',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19341,54,'Shindenagar','415523',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19342,54,'Shindewadi','412801',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19343,54,'Shinganapur','415508',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19344,54,'Shirambe','415501',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19345,54,'Shirawade','415115',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19346,54,'Shirdhon','415501',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19347,54,'Shirgaon','412803',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19348,54,'Shirgaon(Umbraj)','415109',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19349,54,'Shirsurwadi','415506',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19350,54,'Shirwal','412801',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19351,54,'Shivajinagar','412802',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19352,54,'Shivanagar','415108',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19353,54,'Shivthar','415011',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19354,54,'Shnoli','415108',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19355,54,'Shri Plavan','415503',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19356,54,'Shukarwar Peth Phaltan','415523',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19357,54,'Snboor','415112',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19358,54,'Somanthali','415523',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19359,54,'Somardi','415514',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19360,54,'Sonaichi Wadi','415209',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19361,54,'Sonake','415525',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19362,54,'Sonat','412806',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19363,54,'Sonavadi','415523',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19364,54,'Sonawade','415211',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19365,54,'Songaon','415514',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19366,54,'Songaon','415523',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19367,54,'Songaon','415002',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19368,54,'Sukhed','415521',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19369,54,'Supane','415114',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19370,54,'Surali','415511',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19371,54,'Surawadi','415528',1,0,'2022-03-03 12:28:33','2022-03-03 12:28:33'),(19372,54,'Suruli','415105',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19373,54,'Surur','415517',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19374,54,'Tadavale S. Koregaon','415010',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19375,54,'Tadavale(Vaduj)','415506',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19376,54,'Tadawale','415524',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19377,54,'Talbid','415109',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19378,54,'Taldeo','412806',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19379,54,'Taliye','415524',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19380,54,'Talmavale','415103',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19381,54,'Tambave (Lonand)','415521',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19382,54,'Tambave','415114',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19383,54,'Tamkane','415206',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19384,54,'Tandulawadi','415501',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19385,54,'Tapola','412806',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19386,54,'Taradgaon','415528',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19387,54,'Tarale','415014',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19388,54,'Tardaf','415523',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19389,54,'Targaon','415107',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19390,54,'Tarukha','415103',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19391,54,'Tasavade','415109',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19392,54,'Tembu','415105',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19393,54,'Tetali','415002',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19394,54,'Thathavada','415523',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19395,54,'Thomase','415109',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19396,54,'Thoseghar','415013',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19397,54,'Tilak Path Karad','415110',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19398,54,'Tondale','415508',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19399,54,'Tondhoshi','415014',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19400,54,'Trimali','415510',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19401,54,'Triputi','415501',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19402,54,'Tulsan','415111',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19403,54,'Udatare','415513',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19404,54,'Umarkanchan','415112',1,0,'2022-03-03 12:28:34','2022-03-03 12:28:34'),(19405,54,'Umbraj','415109',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19406,54,'Undale','415111',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19407,54,'Upalave','415523',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19408,54,'Urul','415109',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19409,54,'Vadagaon','415109',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19410,54,'Vadagaon Haweli','415124',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19411,54,'Vadajal','415509',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19412,54,'Vadale','415523',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19413,54,'Vadgaon J.S','415512',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19414,54,'Vadoli Bhikeshwar','415106',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19415,54,'Vadoli Nileshwar','415115',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19416,54,'Vaduj','415506',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19417,54,'Vaduj Town','415506',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19418,54,'Vaduth','415011',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19419,54,'Vahagaon','415124',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19420,54,'Vaigaon','412803',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19421,54,'Vajroshi','415014',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19422,54,'Vakhari','415523',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19423,54,'Valuth','415514',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19424,54,'Vanzole','415112',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19425,54,'Vardhangad','415501',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19426,54,'Varkute Malawadi','415509',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19427,54,'Varkute Mhaswad','415509',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19428,54,'Varne','415019',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19429,54,'Varoshi','415012',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19430,54,'Varud','415527',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19431,54,'Varungji','415124',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19432,54,'Varye','415015',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19433,54,'Vasantgad','415114',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19434,54,'Vasole','412803',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19435,54,'Vathar BK','415526',1,0,'2022-03-03 12:28:35','2022-03-03 12:28:35'),(19436,54,'Vathar KH','415539',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19437,54,'Vathar Kiroli','415116',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19438,54,'Vathar Mimbalkar','415523',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19439,54,'Vathar','415524',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19440,54,'Vavarhire','415508',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19441,54,'Vechale','415519',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19442,54,'Velang','412803',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19443,54,'Velapur','412806',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19444,54,'Vele (Kamthi)','415022',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19445,54,'Vele','415517',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19446,54,'Velu','415511',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19447,54,'Venegaon','415518',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19448,54,'Vennanagar','415022',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19449,54,'Vetane','415503',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19450,54,'Vidani','415523',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19451,54,'Vidyanagar Karad','415124',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19452,54,'Vihe','415114',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19453,54,'Vihe Vasahat','415114',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19454,54,'Vikhale','415524',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19455,54,'Vikhale','415312',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19456,54,'Virali','415540',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19457,54,'Viravade','415105',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19458,54,'Virmade','415020',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19459,54,'Visapur','415502',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19460,54,'Vyahali','412803',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19461,54,'Vyajawadi','412803',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19462,54,'Wadhe','415011',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19463,54,'Wagheri','415105',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19464,54,'Wagholi','415525',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19465,54,'Wai City','412803',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19466,54,'Wai','412803',1,0,'2022-03-03 12:28:36','2022-03-03 12:28:36'),(19467,54,'Wakeshwar','415506',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19468,54,'Wing (Shirwal)','412801',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19469,54,'Wing','415122',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19470,54,'Yadogophal Peth','415002',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19471,54,'Yashwantnagar','415115',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19472,54,'Yelagaon','415111',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19473,54,'Yeliv','415512',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19474,54,'Yenape','415111',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19475,54,'Yenke','415103',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19476,54,'Yenkul','415507',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19477,54,'Yeoti','415111',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19478,54,'Yerad','415206',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19479,54,'Yeralwadi','415507',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19480,54,'Yeraphale','415205',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19481,54,'Yeravale','415122',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19482,54,'Yevateshwar','415002',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19483,54,'Zanzwad','412806',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19484,55,'Jambhavade','416704',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19485,55,'Nerle','416704',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19486,55,'Achara','416614',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19487,55,'Achirne','416810',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19488,55,'Adavli','416614',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19489,55,'Adeli','416516',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19490,55,'Ajgaon','416518',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19491,55,'Akeri','416510',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19492,55,'Akhavane','416813',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19493,55,'Ambegaon','416510',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19494,55,'Amberi','416605',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19495,55,'Amboli','416510',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19496,55,'Ambrad','416628',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19497,55,'Anav','416812',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19498,55,'Andurla','416520',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19499,55,'Ansur','416516',1,0,'2022-03-03 12:28:37','2022-03-03 12:28:37'),(19500,55,'Aravli','416518',1,0,'2022-03-03 12:28:38','2022-03-03 12:28:38'),(19501,55,'Are','416611',1,0,'2022-03-03 12:28:38','2022-03-03 12:28:38'),(19502,55,'Aronda','416513',1,0,'2022-03-03 12:28:38','2022-03-03 12:28:38'),(19503,55,'Aros','416514',1,0,'2022-03-03 12:28:38','2022-03-03 12:28:38'),(19504,55,'Arule','416810',1,0,'2022-03-03 12:28:38','2022-03-03 12:28:38'),(19505,55,'Asalda','416610',1,0,'2022-03-03 12:28:38','2022-03-03 12:28:38'),(19506,55,'Asoli','416518',1,0,'2022-03-03 12:28:38','2022-03-03 12:28:38'),(19507,55,'Asolipal','416516',1,0,'2022-03-03 12:28:38','2022-03-03 12:28:38'),(19508,55,'Asrondi','416602',1,0,'2022-03-03 12:28:38','2022-03-03 12:28:38'),(19509,55,'Avalegaon','416521',1,0,'2022-03-03 12:28:38','2022-03-03 12:28:38'),(19510,55,'Ayee','416512',1,0,'2022-03-03 12:28:38','2022-03-03 12:28:38'),(19511,55,'Aynal','416602',1,0,'2022-03-03 12:28:38','2022-03-03 12:28:38'),(19512,55,'Bambuli','416520',1,0,'2022-03-03 12:28:38','2022-03-03 12:28:38'),(19513,55,'Banda (Sindhudurg)','416511',1,0,'2022-03-03 12:28:38','2022-03-03 12:28:38'),(19514,55,'Bandivade','416608',1,0,'2022-03-03 12:28:38','2022-03-03 12:28:38'),(19515,55,'Baparde','416613',1,0,'2022-03-03 12:28:38','2022-03-03 12:28:38'),(19516,55,'Bav','416520',1,0,'2022-03-03 12:28:38','2022-03-03 12:28:38'),(19517,55,'Belnekhurd','416601',1,0,'2022-03-03 12:28:38','2022-03-03 12:28:38'),(19518,55,'Bhadgaon Budruk','416521',1,0,'2022-03-03 12:28:38','2022-03-03 12:28:38'),(19519,55,'Bhalaval','416511',1,0,'2022-03-03 12:28:38','2022-03-03 12:28:38'),(19520,55,'Bharni','416602',1,0,'2022-03-03 12:28:38','2022-03-03 12:28:38'),(19521,55,'Bharni','416632',1,0,'2022-03-03 12:28:38','2022-03-03 12:28:38'),(19522,55,'Bhirvande','416609',1,0,'2022-03-03 12:28:38','2022-03-03 12:28:38'),(19523,55,'Bhogave','416523',1,0,'2022-03-03 12:28:38','2022-03-03 12:28:38'),(19524,55,'Bhuibavda','416813',1,0,'2022-03-03 12:28:38','2022-03-03 12:28:38'),(19525,55,'Bibavane','416520',1,0,'2022-03-03 12:28:38','2022-03-03 12:28:38'),(19526,55,'Bidwadi','416602',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19527,55,'Bilwas','416606',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19528,55,'Bordave','416603',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19529,55,'Budhavale','416616',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19530,55,'Burambavade','416811',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19531,55,'Chafekhol','416604',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19532,55,'Charatha','416510',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19533,55,'Chendavan','416524',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19534,55,'Chindar','416614',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19535,55,'Chindar Bazar','416614',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19536,55,'Chouke','416605',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19537,55,'Choukul','416510',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19538,55,'Dabhachiwadi','416812',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19539,55,'Dabhole','416612',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19540,55,'Dabholi','416516',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19541,55,'Dahibav','416630',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19542,55,'Damre','416601',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19543,55,'Danoli','416510',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19544,55,'Dariste','416609',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19545,55,'Degave','416511',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19546,55,'Deulwada','416608',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19547,55,'Deulwada Nerur','416525',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19548,55,'Devbag','416606',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19549,55,'Devgad','416613',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19550,55,'Devli','416606',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19551,55,'Devsu','416510',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19552,55,'Dhakore','416518',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19553,55,'Dhamapur','416605',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19554,55,'Digas','416521',1,0,'2022-03-03 12:28:39','2022-03-03 12:28:39'),(19555,55,'Digavle','416609',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19556,55,'Dingane','416511',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19557,55,'Dodamarg','416512',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19558,55,'Dukanwad','416519',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19559,55,'Gadhitamhane','416611',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19560,55,'Gadmath','416810',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19561,55,'Gaudwadi','416614',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19562,55,'Gavane','416801',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19563,55,'Gavrai','416534',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19564,55,'Ghavanale','416520',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19565,55,'Ghotage','416512',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19566,55,'Ghotage','416632',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19567,55,'Ghotagewadi','416549',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19568,55,'Ghousari','416601',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19569,55,'Girye','416806',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19570,55,'Golvan','416604',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19571,55,'Gopuri','416602',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19572,55,'Gothane','416616',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19573,55,'Gothos','416519',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19574,55,'Goveri','416520',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19575,55,'Hadi','416626',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19576,55,'Hadpid','416610',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19577,55,'Halval','416602',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19578,55,'Harkul Budruk','416602',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19579,55,'Harkul Khurd','416601',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19580,55,'Hedul','416603',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19581,55,'Het','416813',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19582,55,'Hindale','416630',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19583,55,'Hirlewadi','416614',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19584,55,'Hirlok','416520',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19585,55,'Hiwale','416603',1,0,'2022-03-03 12:28:40','2022-03-03 12:28:40'),(19586,55,'Hodavade','416529',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19587,55,'Humarmala','416812',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19588,55,'Humbrat','416602',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19589,55,'Ilye','416612',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19590,55,'Industrial Area Pinguli','416528',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19591,55,'Insuli','416510',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19592,55,'Jambhavade','416632',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19593,55,'Jamsande','416612',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19594,55,'Janavali','416602',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19595,55,'Kadaval','416521',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19596,55,'Kalane','416511',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19597,55,'Kaleli','416519',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19598,55,'Kalmath','416602',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19599,55,'Kalmist','416531',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19600,55,'Kalse','416605',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19601,55,'Kalsuli','416620',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19602,55,'Kandalgaon','416606',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19603,55,'Kankavli','416602',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19604,55,'Karanje','416602',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19605,55,'Karivade','416510',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19606,55,'Karliwadi','416523',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19607,55,'Karul','416601',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19608,55,'Karulbavada','416810',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19609,55,'Kas','416514',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19610,55,'Kasal','416603',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19611,55,'Kasaral','416602',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19612,55,'Kasarde','416801',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19613,55,'Kasavan','416602',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19614,55,'Katta','416612',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19615,55,'Katta','416604',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19616,55,'Kavathani','416514',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19617,55,'Kavathi','416524',1,0,'2022-03-03 12:28:41','2022-03-03 12:28:41'),(19618,55,'Kelus','416520',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19619,55,'Ker','416549',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19620,55,'Keravade','416520',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19621,55,'Khaida','416606',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19622,55,'Khambale','416810',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19623,55,'Khanoli','416516',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19624,55,'Kharepatan','416703',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19625,55,'Khavane','416522',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19626,55,'Khotale','416603',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19627,55,'Khudi','416611',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19628,55,'Khutvalwadi','416520',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19629,55,'Kinjavade','416611',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19630,55,'Kirlos','416616',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19631,55,'Kochara','416522',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19632,55,'Kokisara','416810',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19633,55,'Kolamb','416606',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19634,55,'Kolgaon','416510',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19635,55,'Koloshi','416610',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19636,55,'Kolzar','416511',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19637,55,'Konal','416549',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19638,55,'Konalkatta Colony','416549',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19639,55,'Korla','416703',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19640,55,'Kotkamte','416611',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19641,55,'Kudal Audyogik Samuha','416550',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19642,55,'Kudal (Sindhudurg)','416520',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19643,55,'Kudase','416512',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19644,55,'Kumbharmath','416606',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19645,55,'Kumbhavade','416810',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19646,55,'Kumbhavade','416609',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19647,55,'Kumbral','416511',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19648,55,'Kunde','416628',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19649,55,'Kunkavale','416604',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19650,55,'Kunkavan','416703',1,0,'2022-03-03 12:28:42','2022-03-03 12:28:42'),(19651,55,'Kunkeri','416510',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19652,55,'Kunkeshwar','416612',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19653,55,'Kupavade','416632',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19654,55,'Kurangavane','416703',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19655,55,'Kurli','416601',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19656,55,'Kusur','416813',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19657,55,'Kuvale','416610',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19658,55,'Lore-i','416601',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19659,55,'Lore-II','416601',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19660,55,'Madkhol','416510',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19661,55,'Madura','416514',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19662,55,'Madyachiwadi','416520',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19663,55,'Mahadevache Kervade','416519',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19664,55,'Mahalunge','416811',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19665,55,'Main','416602',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19666,55,'Malewad','416510',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19667,55,'Malgaon','416510',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19668,55,'Malgaon','416606',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19669,55,'Malond','416608',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19670,55,'Malvan H.O','416606',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19671,55,'Manche','416811',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19672,55,'Mandkuli','416520',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19673,55,'Maneri','416512',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19674,55,'Mangaon (Sindhudurg)','416519',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19675,55,'Mangavli','416813',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19676,55,'Mangeli','416512',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19677,55,'Masde','416608',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19678,55,'Masura','416608',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19679,55,'Math','416516',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19680,55,'Math Budruk','416616',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19681,55,'Matond','416529',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19682,55,'Mazgaon','416510',1,0,'2022-03-03 12:28:43','2022-03-03 12:28:43'),(19683,55,'Mhapan','416522',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19684,55,'Mithbav','416615',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19685,55,'Mithmumbari','416612',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19686,55,'Mogarne','416604',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19687,55,'Mond','416623',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19688,55,'Morgaon','416511',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19689,55,'Mulde','416520',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19690,55,'Munge','416630',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19691,55,'Mutat','416803',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19692,55,'Nad','416801',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19693,55,'Nadan','416805',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19694,55,'Nadgive','416703',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19695,55,'Nadhavade','416810',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19696,55,'Nagve','416602',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19697,55,'Nandgaon','416602',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19698,55,'Nandos','416604',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19699,55,'Nandrukh','416605',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19700,55,'Naneli','416519',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19701,55,'Nanivade','416703',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19702,55,'Napne','416813',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19703,55,'Nardave','416609',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19704,55,'Naringre','416630',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19705,55,'Narur','416519',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19706,55,'Natal','416609',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19707,55,'Nemle','416510',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19708,55,'Nerur','416525',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19709,55,'Netarde','416511',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19710,55,'Nhaveli','416510',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19711,55,'Nigude','416514',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19712,55,'Nileli','416519',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19713,55,'Niravade','416510',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19714,55,'Nirom','416616',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19715,55,'Nirukhe','416521',1,0,'2022-03-03 12:28:44','2022-03-03 12:28:44'),(19716,55,'Nivaje','416519',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19717,55,'Niwatiwadi','416522',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19718,55,'Oros','416812',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19719,55,'Osargaon','416603',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19720,55,'Otav','416602',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19721,55,'Otavane','416510',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19722,55,'Ovaliye','416603',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19723,55,'Ozaram','416801',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19724,55,'Padel','416804',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19725,55,'Padve','416534',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19726,55,'Palsamb','416614',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19727,55,'Pandur','416812',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19728,55,'Pangrad','416521',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19729,55,'Parme','416512',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19730,55,'Parula','416523',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19731,55,'Pat','416522',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19732,55,'Patgaon','416811',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19733,55,'Pawashi','416520',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19734,55,'Pendhari','416811',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19735,55,'Pendhryachiwadi','416529',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19736,55,'Pendur','416604',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19737,55,'Phanasgaon','416811',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19738,55,'Phondaghat','416601',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19739,55,'Pikule','416512',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19740,55,'Pinguli','416528',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19741,55,'Pirawadi','416614',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19742,55,'Poip','416608',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19743,55,'Pokharan','416628',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19744,55,'Pomburla','416811',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19745,55,'Poyare','416630',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19746,55,'Pural','416805',1,0,'2022-03-03 12:28:45','2022-03-03 12:28:45'),(19747,55,'Ramgad','416616',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19748,55,'Ran Bambuli','416812',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19749,55,'Rathivade','416616',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19750,55,'Redi','416517',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19751,55,'Revandi','416606',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19752,55,'Sadure','416810',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19753,55,'Sakedi','416602',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19754,55,'Salel','416605',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19755,55,'Salgaon','416510',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19756,55,'Salshi','416610',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19757,55,'Sandave','416616',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19758,55,'Sangeli','416531',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19759,55,'Sangulwadi','416810',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19760,55,'Sangve','416609',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19761,55,'Sarambal','416520',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19762,55,'Sarjekot','416606',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19763,55,'Sarmale','416511',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19764,55,'Sasoli','416511',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19765,55,'Satarda','416514',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19766,55,'Sateli Traf Bhedshi','416512',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19767,55,'Satose','416514',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19768,55,'Savdav','416602',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19769,55,'Sawantwadi H.O','416510',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19770,55,'Sherla','416514',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19771,55,'Shidavane','416801',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19772,55,'Shirange','416512',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19773,55,'Shirgaon','416610',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19774,55,'Shiroda (Sindhudurg)','416518',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19775,55,'Shirshinge','416531',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19776,55,'Shirval','416620',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19777,55,'Shirvande','416602',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19778,55,'Shivapur','416519',1,0,'2022-03-03 12:28:46','2022-03-03 12:28:46'),(19779,55,'Shivdav','416620',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19780,55,'Shravan','416616',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19781,55,'Sindhudurgnagari MDG','416812',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19782,55,'Sonavade','416632',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19783,55,'Sonavade','416520',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19784,55,'Sonurli','416510',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19785,55,'Soundale','416804',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19786,55,'Sukalwadi','416534',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19787,55,'Tak','416518',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19788,55,'Talavade','416611',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19789,55,'Talavade','416529',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19790,55,'Talavane','416513',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19791,55,'Talebazar','416611',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19792,55,'Talekhol','416512',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19793,55,'Talera (Sindhudurg)','416801',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19794,55,'Talgaon','416534',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19795,55,'Talkat','416511',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19796,55,'Tambaldeg','416615',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19797,55,'Tambuli','416511',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19798,55,'Taramumbari','416613',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19799,55,'Tarandale','416602',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19800,55,'Tarkarli','416606',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19801,55,'Tembavli','416612',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19802,55,'Tendoli','416520',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19803,55,'Terawalewadi','416523',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19804,55,'Terse Bambarde','416520',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19805,55,'Tervan Medhe','416549',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19806,55,'Thakurwadi','416804',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19807,55,'Tiravade','416604',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19808,55,'Tiravade','416518',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19809,55,'Tirlot','416807',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19810,55,'Tithavli','416703',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19811,55,'Tondavali','416626',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19812,55,'Tondavali','416601',1,0,'2022-03-03 12:28:47','2022-03-03 12:28:47'),(19813,55,'Torsole','416611',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19814,55,'Trimbak','416614',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19815,55,'Tulas','416515',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19816,55,'Tulsuli','416520',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19817,55,'Ubhadanda','416516',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19818,55,'Umbarde','416813',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19819,55,'Upale','416813',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19820,55,'Usap','416512',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19821,55,'Vada (Sindhudurg)','416805',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19822,55,'Vadivaravde','416520',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19823,55,'Vados','416519',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19824,55,'Vaibhavwadi','416810',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19825,55,'Vajarat','416516',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19826,55,'Valivande','416611',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19827,55,'Varad','416604',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19828,55,'Varavde','416602',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19829,55,'Varde','416521',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19830,55,'Vasoli','416519',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19831,55,'Vazare','416512',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19832,55,'Vengurla Camp','416516',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19833,55,'Vengurla','416516',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19834,55,'Veral','416608',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19835,55,'Verle','416531',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19836,55,'Vetal Bambarde','416520',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19837,55,'Vetore','416516',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19838,55,'Vijaydurg','416806',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19839,55,'Vilvade','416511',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19840,55,'Wadkhol','416518',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19841,55,'Wafoli','416511',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19842,55,'Wagheri','416601',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19843,55,'Waghivare','416801',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19844,55,'Waghotan','416804',1,0,'2022-03-03 12:28:48','2022-03-03 12:28:48'),(19845,55,'Waingani','416614',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19846,55,'Wainganiwadi','416516',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19847,55,'Waingavde','416603',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19848,55,'Wairy Bhutnath','416606',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19849,55,'Walaval','416524',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19850,55,'Waniwade','416613',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19851,55,'Wargaon','416801',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19852,55,'Zarapi','416510',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19853,55,'Zarebambar Vasahat','416512',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19854,55,'Zolambe','416511',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19855,56,'Achakdani','413306',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19856,56,'Adhegaon','413212',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19857,56,'Ajnale','413308',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19858,56,'Akluj','413101',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19859,56,'Akola Wasud','413307',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19860,56,'Akole(KH)','413211',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19861,56,'Akulgaon','413208',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19862,56,'Akumbhe','413211',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19863,56,'Alegaon','413309',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19864,56,'Ambe','413304',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19865,56,'Anawali','413304',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19866,56,'Andhalgaon','413305',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19867,56,'Anjandoh','413203',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19868,56,'Anjangaon Umate','413209',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19869,56,'Arali','413305',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19870,56,'Aran','413301',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19871,56,'Awati','413203',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19872,56,'Babhulgaon','413304',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19873,56,'Bagechiwadi','413101',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19874,56,'Balwadi','413308',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19875,56,'Bardi','413302',1,0,'2022-03-03 12:28:49','2022-03-03 12:28:49'),(19876,56,'Barloni','413252',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19877,56,'Bavi','413301',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19878,56,'Bembale','413211',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19879,56,'Bhalvani','413202',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19880,56,'Bhalvani','413319',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19881,56,'Bhalwani','413310',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19882,56,'Bhamburdi','413111',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19883,56,'Bhandishegaon','413304',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19884,56,'Bhimanagar','413212',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19885,56,'Bhogewadi','413223',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19886,56,'Bhosa (K)','413315',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19887,56,'Bhosa (M)','413322',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19888,56,'Bhosare','413208',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19889,56,'Bhutashte','413208',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19890,56,'Bitergaon ( Wangi )','413202',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19891,56,'Bitergaon','413252',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19892,56,'Bohali','413317',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19893,56,'Bondle','413113',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19894,56,'Borale','413305',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19895,56,'Borgaon (Kml)','413203',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19896,56,'Borgaon','413112',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19897,56,'Bramhapuri','413305',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19898,56,'Chakore','413101',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19899,56,'Chale','413304',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19900,56,'Chandapuri','413310',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19901,56,'Chikhalthan','413202',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19902,56,'Chikmahud','413306',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19903,56,'Chincholi','413208',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19904,56,'Chincholi','413307',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19905,56,'Chinke','413308',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19906,56,'Chopadi','413308',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19907,56,'Dahigaon ( Karmala )','413202',1,0,'2022-03-03 12:28:50','2022-03-03 12:28:50'),(19908,56,'Dahigaon','413109',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19909,56,'Dahiwali','413210',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19910,56,'Darfal','413209',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19911,56,'Degaon (PPR)','413304',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19912,56,'Devlali','413203',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19913,56,'Dharmapuri','413109',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19914,56,'Dhavlas','413208',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19915,56,'Dhyati (E)','413317',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19916,56,'Donaj','413319',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19917,56,'Dongargaon','413309',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19918,56,'Dongargaon','413305',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19919,56,'Ekhatpur','413307',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19920,56,'Ekshiv','413109',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19921,56,'Gadegaon','413304',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19922,56,'Gaigavan','413306',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19923,56,'Gardi','413306',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19924,56,'Gaudwadi','413314',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19925,56,'Gherdi','413309',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19926,56,'Ghoti','413251',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19927,56,'Ghoti','413211',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19928,56,'Girvi','413111',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19929,56,'Gopalpur','413304',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19930,56,'Gulsade','413203',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19931,56,'Gunjegaon','413305',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19932,56,'Gursale','413109',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19933,56,'Gursale','413304',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19934,56,'Hangirge','413309',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19935,56,'Hatid','413307',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19936,56,'Hole','413315',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19937,56,'Huljanti','413319',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19938,56,'Hunnur','413322',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19939,56,'Islampur','413107',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19940,56,'Jainwadi','413310',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19941,56,'Jambhood','413112',1,0,'2022-03-03 12:28:51','2022-03-03 12:28:51'),(19942,56,'Jamgaon','413209',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19943,56,'Jategaon','413203',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19944,56,'Jawala (Solapur)','413309',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19945,56,'Jeur (Solapur)','413202',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19946,56,'Jinti','413203',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19947,56,'Junoni','413307',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19948,56,'Kadlas','413309',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19949,56,'Kamalapur','413307',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19950,56,'Kandar','413202',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19951,56,'Kanhapuri','413211',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19952,56,'Karanje','413203',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19953,56,'Karkam','413302',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19954,56,'Karmala','413203',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19955,56,'Karmala Town ( Karmala)','413203',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19956,56,'Kasegaon','413304',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19957,56,'Katphal','413306',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19958,56,'Kavhe','413252',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19959,56,'Kedgaon','413202',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19960,56,'Kem','413223',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19961,56,'Kettur-II','413206',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19962,56,'Khandali','413113',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19963,56,'Khardi','413317',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19964,56,'Khavaspur','413306',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19965,56,'Khudus','413113',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19966,56,'Kole (Solapur)','413314',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19967,56,'Kolegaon ( E)','413203',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19968,56,'Kolegaon','413306',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19969,56,'Kondbhav','413101',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19970,56,'Kondhej','413202',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19971,56,'Korti','413304',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19972,56,'Korti','413203',1,0,'2022-03-03 12:28:52','2022-03-03 12:28:52'),(19973,56,'Kugaon','413202',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(19974,56,'Kumbhargaon','413203',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(19975,56,'Kumbhej','413202',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(19976,56,'Kurbavi','413109',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(19977,56,'Kurdu','413208',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(19978,56,'Kurduvadi','413208',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(19979,56,'Laul','413208',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(19980,56,'Lavang','413112',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(19981,56,'Laxmi-dahiwadi','413305',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(19982,56,'Lendave Chinchali','413305',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(19983,56,'Lonand','413109',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(19984,56,'Lonvire','413309',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(19985,56,'Lotewadi','413306',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(19986,56,'Madha','413209',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(19987,56,'Mahadawar( Pandharpur)','413304',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(19988,56,'Mahalung','413112',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(19989,56,'Mahatpur','413209',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(19990,56,'Mahim','413306',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(19991,56,'Mahisgaon','413250',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(19992,56,'Mahud','413306',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(19993,56,'Malewadi','413101',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(19994,56,'Malinagar','413108',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(19995,56,'Malkhambi','413112',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(19996,56,'Maloli','413113',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(19997,56,'Malsiras','413107',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(19998,56,'Mandave','413111',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(19999,56,'Mandki','413107',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(20000,56,'Mangalvedha','413305',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(20001,56,'Mangalvedha Town','413305',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(20002,56,'Mangi','413203',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(20003,56,'Manishanagar(Pandharpur)','413304',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(20004,56,'Manjari','413317',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(20005,56,'Marapur','413305',1,0,'2022-03-03 12:28:53','2022-03-03 12:28:53'),(20006,56,'Marwade','413319',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20007,56,'Mauje Ujani','413210',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20008,56,'Medad','413107',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20009,56,'Medshingi','413307',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20010,56,'Mendhapur','413304',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20011,56,'Methawade','413317',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20012,56,'Modnimb','413301',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20013,56,'Morochi','413109',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20014,56,'Mundhewadi','413304',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20015,56,'Nandeshwar','413322',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20016,56,'Nandur','413319',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20017,56,'Natepute','413109',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20018,56,'Navi Peth (Pandharpur)','413304',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20019,56,'Nazara','413308',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20020,56,'Nerle','413251',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20021,56,'Nevare','413112',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20022,56,'Nimbhore','413202',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20023,56,'Nimboni','413322',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20024,56,'Nimgaon','413113',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20025,56,'Nimgaon T','413210',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20026,56,'Niranarshingpur','413211',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20027,56,'Ozewadi','413304',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20028,56,'Pachegaon (BK)','413314',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20029,56,'Pachegaon','413307',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20030,56,'Padasali','413208',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20031,56,'Palashi','413310',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20032,56,'Palasmandal','413109',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20033,56,'Pande','413203',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20034,56,'Pandharechiwadi','413304',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20035,56,'Pandharpur H.O','413304',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20036,56,'Paniv','413113',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20037,56,'Pare','413309',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20038,56,'Parite','413211',1,0,'2022-03-03 12:28:54','2022-03-03 12:28:54'),(20039,56,'Patkhal','413305',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20040,56,'Patwardhan Kuroli','413315',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20041,56,'Phadtari','413109',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20042,56,'Phalwani','413306',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20043,56,'Phisare','413203',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20044,56,'Phondshiras','413109',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20045,56,'Phulchincholi','413304',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20046,56,'Piliv','413310',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20047,56,'Pimpalkhunte','413208',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20048,56,'Pimpelner','413210',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20049,56,'Pimpri','413109',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20050,56,'Pothare','413203',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20051,56,'Puluj','413304',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20052,56,'Purandawade','413111',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20053,56,'Rajuri','413203',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20054,56,'Rajuri','413307',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20055,56,'Ranjani','413304',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20056,56,'Raogaon','413203',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20057,56,'Redde','413322',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20058,56,'Ridhore','413250',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20059,56,'Ropla ( Kvd )','413252',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20060,56,'Rople BK','413304',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20061,56,'Sadashivenagar','413111',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20062,56,'Sade','413251',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20063,56,'Salase','413251',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20064,56,'Salgar BK','413319',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20065,56,'Sangavi ( BK)','413202',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20066,56,'Sangewadi','413317',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20067,56,'Sangola','413307',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20068,56,'Sangola Town (Sangola)','413307',1,0,'2022-03-03 12:28:55','2022-03-03 12:28:55'),(20069,56,'Sapatane ( Bhose )','413208',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20070,56,'Sapatane T','413210',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20071,56,'Sarkoli','413304',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20072,56,'Save','413317',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20073,56,'Sawadi','413203',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20074,56,'Shelgaon Kekan','413202',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20075,56,'Shelve','413304',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20076,56,'Shetphal ( Jeur )','413202',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20077,56,'Shetphal','413317',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20078,56,'Shevate','413315',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20079,56,'Shindewadi','413109',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20080,56,'Shirbhavi','413317',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20081,56,'Shirnandgi','413322',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20082,56,'Shivane','413307',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20083,56,'Shivangi','413319',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20084,56,'Shreepur','413112',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20085,56,'Siddhapur','413305',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20086,56,'Siddhewadi','413304',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20087,56,'Sogaon','413206',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20088,56,'Sonand','413309',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20089,56,'Sonka','413304',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20090,56,'Suste','413304',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20091,56,'Tadvale','413208',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20092,56,'Takli Rasin','413203',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20093,56,'Talsangi','413319',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20094,56,'Tambave','413108',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20095,56,'Tandulwadi','413310',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20096,56,'Tandulwadi','413250',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20097,56,'Tarangphal','413107',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20098,56,'Tarapur','413304',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20099,56,'Tawashi','413304',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20100,56,'Tembhurni (Solapur)','413211',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20101,56,'Tulshi','413302',1,0,'2022-03-03 12:28:56','2022-03-03 12:28:56'),(20102,56,'Tungat','413304',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20103,56,'Udanwadi','413307',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20104,56,'Ughadewadi','413113',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20105,56,'Umbare (Karkam )','413302',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20106,56,'Umrad','413202',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20107,56,'Undargaon','413209',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20108,56,'Upalwate','413223',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20109,56,'Upari','413310',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20110,56,'Uplai Budruk','413209',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20111,56,'Uplai Khurd','413209',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20112,56,'Vadshinge','413209',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20113,56,'Varkute','413251',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20114,56,'Veet','413203',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20115,56,'Velapur','413113',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20116,56,'Vihal','413203',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20117,56,'Wadhegaon','413307',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20118,56,'Wadshivane','413223',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20119,56,'Wagholi(E)','413112',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20120,56,'Wakhari','413304',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20121,56,'Waki','413309',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20122,56,'Waki(Sangola)','413307',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20123,56,'Wangi- IIi','413202',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20124,56,'Wangi-i','413202',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20125,56,'Warwade','413211',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20126,56,'Washimbe','413206',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20127,56,'Watambre','413307',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20128,56,'Yelmarmangewadi','413307',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20129,56,'Yeshwantnagar (Solapur)','413118',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20130,56,'Zare','413202',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20131,56,'Achegaon','413228',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20132,56,'Agalgaon','413409',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20133,56,'Aherwadi','413215',1,0,'2022-03-03 12:28:57','2022-03-03 12:28:57'),(20134,56,'Akkalkot','413216',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20135,56,'Akolekati','413222',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20136,56,'Anagar','413214',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20137,56,'Anjangaon  Khilobache','413214',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20138,56,'Ankalge','413219',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20139,56,'Ankoli','413253',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20140,56,'Antroli','413221',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20141,56,'Arali','413002',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20142,56,'Ashok Chowk','413006',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20143,56,'Ashti (Solapur)','413303',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20144,56,'Auj','413221',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20145,56,'Aundhi','413248',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20146,56,'Aurad','413008',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20147,56,'Babalad','413220',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20148,56,'Babhulgaon','413409',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20149,56,'Badole BK','413218',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20150,56,'Bagehalli','413216',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20151,56,'Bale','413255',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20152,56,'Barhanpur','413226',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20153,56,'Barshi','413401',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20154,56,'Barur','413008',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20155,56,'Basalegaon','413216',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20156,56,'Bavi','413403',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20157,56,'Bazarpeth Mohol','413213',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20158,56,'Belati','413002',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20159,56,'Bhalgaon','413406',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20160,56,'Bhandar Kavathe','413221',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20161,56,'Bhatambre','413401',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20162,56,'Bhurikavathe','413218',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20163,56,'Bitale','413214',1,0,'2022-03-03 12:28:58','2022-03-03 12:28:58'),(20164,56,'Boramani','413002',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20165,56,'Borgaon','413218',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20166,56,'Boroti','413216',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20167,56,'Chapalgaon','413226',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20168,56,'Chare','413409',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20169,56,'Chikharde','413404',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20170,56,'Chikkehalli','413216',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20171,56,'Chumb','413409',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20172,56,'Chungi','413226',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20173,56,'Dahitane','413412',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20174,56,'Dahitne','413226',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20175,56,'Daji Peth','413005',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20176,56,'Darganhalli','413002',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20177,56,'Darphalbibi','413222',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20178,56,'Darphalgawadi','413222',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20179,56,'Dayanand Collage','413002',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20180,56,'Degaon  ( Valuj )','413410',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20181,56,'Degaon','413002',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20182,56,'Deodi','413324',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20183,56,'Deogaon','413401',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20184,56,'Dhamangaon','413402',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20185,56,'Dhokbabhulgaon','413213',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20186,56,'Dhotri','413228',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20187,56,'Dombarjawalge','413226',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20188,56,'Dongaon','413002',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20189,56,'Dudhani','413220',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20190,56,'Ekurkhe','413213',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20191,56,'Gadegaon','413401',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20192,56,'Gaudgaon','413227',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20193,56,'Gaudgaon','413406',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20194,56,'Ghanegaon','413403',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20195,56,'Ghari','413404',1,0,'2022-03-03 12:28:59','2022-03-03 12:28:59'),(20196,56,'Ghatane','413213',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20197,56,'Ghodeshwar','413253',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20198,56,'Gholasgaon','413218',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20199,56,'Gogaon','413218',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20200,56,'Gormale','413404',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20201,56,'Gotewadi','413213',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20202,56,'Gulpoli','413401',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20203,56,'Gunjegaon','413221',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20204,56,'Gurunanak Nagar','413003',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20205,56,'Hagloor','413002',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20206,56,'Haidra','413227',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20207,56,'Halduge','413401',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20208,56,'Hanjagi','413216',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20209,56,'Hannur','413226',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20210,56,'Hatti Kanabus','413216',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20211,56,'Hattij','413406',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20212,56,'Hattur','413008',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20213,56,'Hiraj','413255',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20214,56,'Hiware','413324',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20215,56,'Honmurgi','413008',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20216,56,'Honsal','413002',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20217,56,'Hotagi','413215',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20218,56,'Hotgigaon','413215',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20219,56,'Ichgaon','413253',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20220,56,'Indiranagar (Solapur)','413004',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20221,56,'Ingalgi','413002',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20222,56,'Irle','413412',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20223,56,'Jamgaon  (Agalgaon)','413401',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20224,56,'Jamgaon  (Pangari)','413401',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20225,56,'Javalgaon','413406',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20226,56,'Jawaharlal Nehru Vastigrah','413001',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20227,56,'Jeur  (Akkalkot)','413219',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20228,56,'Jule Solapur','413008',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20229,56,'K.V.Nagar Barshi','413411',1,0,'2022-03-03 12:29:00','2022-03-03 12:29:00'),(20230,56,'Kadabgaon','413227',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20231,56,'Kajikanabus','413216',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20232,56,'Kalamwadi','413403',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20233,56,'Kalman','413222',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20234,56,'Kamati Khurd','413253',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20235,56,'Kanbus (Gangadhar)','413215',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20236,56,'Kandalgaon','413221',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20237,56,'Karajagi (Solapur)','413219',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20238,56,'Karamba','413222',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20239,56,'Kardehalli','413006',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20240,56,'Kari','413404',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20241,56,'Karjal','413228',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20242,56,'Kasegaon','413002',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20243,56,'Kategaon','413409',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20244,56,'Kauthali','413222',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20245,56,'Kavathe','413002',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20246,56,'Kegaon','413255',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20247,56,'Khairao','413410',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20248,56,'Khamgaon','413401',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20249,56,'Khandali','413324',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20250,56,'Khandvi','413401',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20251,56,'Khuneshwar','413222',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20252,56,'Khvhe','413401',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20253,56,'Kini','413216',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20254,56,'Kolegaon','413213',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20255,56,'Kondi','413255',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20256,56,'Konheri','413248',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20257,56,'Koravali','413253',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20258,56,'Korphale','413401',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20259,56,'Korsegaon','413219',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20260,56,'Kumathe','413224',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20261,56,'Kumbhari','413006',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20262,56,'Kurnoor','413226',1,0,'2022-03-03 12:29:01','2022-03-03 12:29:01'),(20263,56,'Kurul','413213',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20264,56,'Kuslumb','413401',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20265,56,'Kusur','413221',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20266,56,'Lamboti','413213',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20267,56,'Limbi Chincholi','413228',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20268,56,'Londewadi','413214',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20269,56,'Maindargi','413217',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20270,56,'Malegaon (Vairag)','413406',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20271,56,'Malegaon','413401',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20272,56,'Malikpeth','413214',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20273,56,'Malkavathe','413221',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20274,56,'Malvandi','413401',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20275,56,'Mandegaon','413409',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20276,56,'Mandrup','413221',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20277,56,'Manegaon','413410',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20278,56,'Mangalwar Peth (Solapur)','413002',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20279,56,'Mangrul','413219',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20280,56,'Mardi','413002',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20281,56,'Market Yard Barshi','413401',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20282,56,'Market Yard Solapur','413005',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20283,56,'Masale Chaudhari','413222',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20284,56,'Medical College (Solapur)','413003',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20285,56,'Mhaisalge','413219',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20286,56,'Midc Chincholi','413255',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20287,56,'Midc Solapur','413006',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20288,56,'Mohol','413213',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20289,56,'Motyal','413216',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20290,56,'Mouje Tadvale','413412',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20291,56,'Mugali','413220',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20292,56,'Mulegaon','413006',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20293,56,'Mundewadi','413219',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20294,56,'Musti','413002',1,0,'2022-03-03 12:29:02','2022-03-03 12:29:02'),(20295,56,'Nagansur','413227',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20296,56,'Nagore','413217',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20297,56,'Nai Zindagi','413224',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20298,56,'Nanaj (Solapur)','413222',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20299,56,'Nandani','413008',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20300,56,'Nari','413404',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20301,56,'Narkhed','413213',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20302,56,'Navi Peth Solapur','413001',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20303,56,'Navindgi','413227',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20304,56,'Nimbargi','413221',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20305,56,'Padsali','413222',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20306,56,'Pakani','413255',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20307,56,'Pandhari','413404',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20308,56,'Pangaon (Solapur)','413403',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20309,56,'Pangri','413404',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20310,56,'Papari','413324',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20311,56,'Pathari','413002',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20312,56,'Patkul','413248',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20313,56,'Pennur','413248',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20314,56,'Pimpalgaon','413401',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20315,56,'Pitapur','413226',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20316,56,'Pokharapur','413248',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20317,56,'Raleras','413402',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20318,56,'Ranmasale','413222',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20319,56,'Ratanjan','413406',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20320,56,'Ruddewadi','413220',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20321,56,'Sadar Bazar (Solapur)','413003',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20322,56,'Safale','413218',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20323,56,'Sakat','413403',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20324,56,'Sakhar Peth','413005',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20325,56,'Salgar','413216',1,0,'2022-03-03 12:29:03','2022-03-03 12:29:03'),(20326,56,'Sangvi Budruk','413216',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20327,56,'Sarole','413402',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20328,56,'Sasure','413402',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20329,56,'Satan Dudhani','413216',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20330,56,'Savaleshwar','413213',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20331,56,'Sayyed Virwade','413213',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20332,56,'Shaval','413216',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20333,56,'Shelgaon (R)','413222',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20334,56,'Shendri','413401',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20335,56,'Shetphal','413324',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20336,56,'Shingadgaon','413228',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20337,56,'Shirale','413404',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20338,56,'Shirapur (Solapur)','413213',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20339,56,'Shirwal','413216',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20340,56,'Shivshahi','413224',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20341,56,'Shripat Pimpari','413401',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20342,56,'Sidheswar Peth','413001',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20343,56,'Sinnur','413220',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20344,56,'Sohale','413253',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20345,56,'Solapur City','413007',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20346,56,'Solapur H.O','413001',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20347,56,'Solapur Mkt','413002',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20348,56,'Solapur Vidyapeeth','413255',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20349,56,'Sondare','413401',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20350,56,'Soregaon','413008',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20351,56,'SRPF Camp Solapur','413008',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20352,56,'Subhash Nagar Barshi','413401',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20353,56,'Suler Jawalage','413215',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20354,56,'Surdi','413401',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20355,56,'Tadsoundane','413401',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20356,56,'Tadwal  (Hotagi)','413219',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20357,56,'Takali','413008',1,0,'2022-03-03 12:29:04','2022-03-03 12:29:04'),(20358,56,'Takali Sikandar','413248',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20359,56,'Tambole','413213',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20360,56,'Tandulwadi','413002',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20361,56,'Tikekarwadi','413224',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20362,56,'Tirhe','413002',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20363,56,'Tolnur','413227',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20364,56,'Torni','413217',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20365,56,'Tulsidas Nagar','413412',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20366,56,'Udagi','413216',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20367,56,'Ukadgaon','413404',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20368,56,'Ule','413002',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20369,56,'Umarge','413216',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20370,56,'Umbarge','413409',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20371,56,'Umedpur','413002',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20372,56,'Upalai  ( Thonge )','413401',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20373,56,'Upale Dhumala','413401',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20374,56,'Vairag','413402',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20375,56,'Valsang','413228',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20376,56,'Valuj','413222',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20377,56,'Vinchur','413221',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20378,56,'Virvade','413253',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20379,56,'Wadala','413222',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20380,56,'Wadwal','413213',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20381,56,'Wafale','413214',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20382,56,'Wagadari','413218',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20383,56,'Wakaw','413214',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20384,56,'Wangi','413221',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20385,56,'Yavali','413412',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20386,56,'Yawali','413213',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20387,56,'Yeoti','413248',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20388,57,'Airoli','400708',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20389,57,'Airoli','400708',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20390,57,'Belapur Node-- III','400614',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20391,57,'Belapur Node- V','400614',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20392,57,'Darave','400706',1,0,'2022-03-03 12:29:05','2022-03-03 12:29:05'),(20393,57,'Ghansoli','400701',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20394,57,'K.U.Bazar','400703',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20395,57,'Konkan Bhavan','400614',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20396,57,'Kopar Khairne','400709',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20397,57,'Millenium Business Park','400710',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20398,57,'Nerul Node-II','400706',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20399,57,'Nerul Node-III','400706',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20400,57,'Nerul Sec-48','400706',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20401,57,'Sanpada','400703',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20402,57,'Turbhe Market','400703',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20403,57,'Turbhe','400703',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20404,57,'Vashi (Thane)','400703',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20405,57,'Vashi Sec-26','400703',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20406,57,'Vashi-VII','400703',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20407,57,'Additional Ambernath','421506',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20408,57,'Aghai','421601',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20409,57,'Alyani','421601',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20410,57,'Amane','421302',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20411,57,'Ambarje','421601',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20412,57,'Ambernath','421501',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20413,57,'Ambernath South','421501',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20414,57,'Andad','421601',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20415,57,'Angaon','421302',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20416,57,'Anjur','421302',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20417,57,'Apna Bazar','400610',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20418,57,'Asangaon','421601',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20419,57,'Atali','421102',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20420,57,'Atgaon','421601',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20421,57,'Aware','421601',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20422,57,'Badlapur E.D.','421503',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20423,57,'Balegaon','421402',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20424,57,'Balkum','400608',1,0,'2022-03-03 12:29:06','2022-03-03 12:29:06'),(20425,57,'Bhaji Market','421002',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20426,57,'Bhatsanagar','421603',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20427,57,'Bhiwandi','421308',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20428,57,'Birwadi','421603',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20429,57,'Bus Terminus','421002',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20430,57,'Chamble','421312',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20431,57,'Chande','421601',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20432,57,'Chargaon','421503',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20433,57,'Chimbipada','421302',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20434,57,'Chinchwali','421302',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20435,57,'Chitalsar Manpada','400607',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20436,57,'Chondhe Colony','421601',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20437,57,'Dabhad','421302',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20438,57,'Dahisar','400612',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20439,57,'Dalkhan','421601',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20440,57,'Dandekarwadi','421302',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20441,57,'Dawale','400612',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20442,57,'Dhasai','421601',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20443,57,'Dhasai','421402',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20444,57,'Dighashi','421302',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20445,57,'Diwa','400612',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20446,57,'Dolkhamb','421601',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20447,57,'Dombivali I.A.','421203',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20448,57,'Dombivali','421201',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20449,57,'Dugad','421302',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20450,57,'Dunge','421302',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20451,57,'Dwarli','421306',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20452,57,'Ganeshwadi (Thane)','421306',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20453,57,'Gegaon','421403',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20454,57,'Gokhale Road (Thane)','400602',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20455,57,'Gunde','421601',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20456,57,'Jambhul','421505',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20457,57,'Jekegram','400606',1,0,'2022-03-03 12:29:07','2022-03-03 12:29:07'),(20458,57,'Kalamgaon','421601',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20459,57,'Kalher','421302',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20460,57,'Kalwa','400605',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20461,57,'Kalyan City H.O','421301',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20462,57,'Kalyan D.C.','421301',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20463,57,'Kalyan Rs','421301',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20464,57,'Kansai','421501',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20465,57,'Kasara (Thane)','421602',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20466,57,'Kasarvadavali','400615',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20467,57,'Kasegaon','421401',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20468,57,'Katemanivali','421306',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20469,57,'Kausa','400612',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20470,57,'Khadavali','421605',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20471,57,'Kharade','421601',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20472,57,'Kharbav','421302',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20473,57,'Khardi','421601',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20474,57,'Kharid','421403',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20475,57,'Kharivali','421403',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20476,57,'Khoni','421204',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20477,57,'Khupri','421312',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20478,57,'Khutal Baragaon','421401',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20479,57,'Khutghar','421601',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20480,57,'Kinholi','421403',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20481,57,'Kishore','421401',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20482,57,'Kolthan','421401',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20483,57,'Kon','421311',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20484,57,'Kondhale','421312',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20485,57,'Kopri Colony','400603',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20486,57,'Kudus','421312',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20487,57,'Kulgaon','421503',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20488,57,'Kunde','421302',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20489,57,'Lenad Khurd','421601',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20490,57,'Lonad','421302',1,0,'2022-03-03 12:29:08','2022-03-03 12:29:08'),(20491,57,'Mahapoli','421302',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20492,57,'Majgaon','421401',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20493,57,'Mal','421402',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20494,57,'Malegaon','421403',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20495,57,'Mamnoli','421103',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20496,57,'Manda','421605',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20497,57,'Mangrul','421306',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20498,57,'Manivali','421102',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20499,57,'Manjarli','421503',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20500,57,'Manpada','421204',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20501,57,'Met','421312',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20502,57,'Mhasa','421401',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20503,57,'Milhe','421401',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20504,57,'Mohone','421102',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20505,57,'Mokhawane','421602',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20506,57,'Moroshi','421401',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20507,57,'Mugaon','421403',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20508,57,'Mumbra','400612',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20509,57,'Murbad','421401',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20510,57,'Nandgaon','421601',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20511,57,'Narivali','421401',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20512,57,'Naupada (Thane)','400602',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20513,57,'Nehroli','421312',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20514,57,'Netaji Bazar','421505',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20515,57,'Nilje','421204',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20516,57,'O.E.Ambernath','421502',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20517,57,'Pachhapur','421302',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20518,57,'Padgha Extension Counter','421101',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20519,57,'Padgha','421101',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20520,57,'Padle','421204',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20521,57,'Palsai','421312',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20522,57,'Palu','421402',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20523,57,'Patgaon','421401',1,0,'2022-03-03 12:29:09','2022-03-03 12:29:09'),(20524,57,'Paye','421302',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20525,57,'Phalegaon','421605',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20526,57,'Pimpaloli','421503',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20527,57,'Pimplas','421311',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20528,57,'Pisavli','421306',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20529,57,'Piwali','421601',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20530,57,'Ramnagar (Thane)','421201',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20531,57,'Rayate','421103',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20532,57,'Rehnal','421302',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20533,57,'Sakadbav','421601',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20534,57,'Sakurli','421601',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20535,57,'Sandozbaugh','400607',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20536,57,'Saralambe','421601',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20537,57,'Saralgaon','421401',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20538,57,'Saravali','421311',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20539,57,'Sasne','421401',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20540,57,'Sawaroli','421601',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20541,57,'Sayale','421401',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20542,57,'Shahad','421103',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20543,57,'Shahapur (Thane)','421601',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20544,57,'Shantinagar E.D.','421302',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20545,57,'Shastrinagar (Thane)','421302',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20546,57,'Shelar','421302',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20547,57,'Shenwa','421601',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20548,57,'Shere','421601',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20549,57,'Shirgaon','421601',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20550,57,'Shirol','421602',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20551,57,'Shiroshi','421402',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20552,57,'Shivale','421401',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20553,57,'Shrirangnagar','400608',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20554,57,'Sogaon','421403',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20555,57,'Station Road Unr-3','421002',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20556,57,'Subhash Road (Thane)','421301',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20557,57,'Talegaon','421401',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20558,57,'Tansa','421601',1,0,'2022-03-03 12:29:10','2022-03-03 12:29:10'),(20559,57,'Tapasenagar','400608',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20560,57,'Tembhurli','421601',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20561,57,'Thakurli','421201',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20562,57,'Thane Bazar','400601',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20563,57,'Thane East','400603',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20564,57,'Thane H.O','400601',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20565,57,'Thane R.S.','400601',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20566,57,'Thune','421403',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20567,57,'Tilaknagar (Thane)','421201',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20568,57,'Titwala','421605',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20569,57,'Tokawade','421402',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20570,57,'Tulai','421401',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20571,57,'Uchat','421312',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20572,57,'Ulhasnagar 1','421002',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20573,57,'Ulhasnagar-2','421002',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20574,57,'Ulhasnagar-4','421004',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20575,57,'Ulhasnagar-5','421005',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20576,57,'Vadavali','421302',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20577,57,'Vadpe','421302',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20578,57,'Vaholi','421103',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20579,57,'Vaishakhare','421402',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20580,57,'Vaitarna','421601',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20581,57,'Vangani','421503',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20582,57,'Varap','421103',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20583,57,'Vashala','421602',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20584,57,'Vashind E.D.','421601',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20585,57,'Vehele','421601',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20586,57,'Vehloli','421601',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20587,57,'Vehloli','421601',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20588,57,'Vidyashram','421305',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20589,57,'Vihigaon','421602',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20590,57,'Vishnunagar','421202',1,0,'2022-03-03 12:29:11','2022-03-03 12:29:11'),(20591,57,'Wadi','421306',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20592,57,'Wagle I.E.','400604',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20593,57,'Waklan','400612',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20594,57,'Yeranjad','421503',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20595,57,'Abitghar','421303',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20596,57,'Abje','421303',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20597,57,'Acchad','401606',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20598,57,'Agarwadi','401102',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20599,57,'Agashi','401301',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20600,57,'Agawan','401602',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20601,57,'Akkarpatti','401501',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20602,57,'Alonde','421303',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20603,57,'Arnala','401302',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20604,57,'Asangaon','401103',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20605,57,'Ase','401604',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20606,57,'Ashagad','401602',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20607,57,'Audhani','401403',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20608,57,'Badapokharan','401601',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20609,57,'Baliwali','421303',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20610,57,'Bandhan','401403',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20611,57,'Bapugaon','401602',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20612,57,'Bassein Road','401202',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20613,57,'Bassein','401201',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20614,57,'Bategaon','401501',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20615,57,'Bavada','401103',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20616,57,'Beriste','401604',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20617,57,'Bhatane','401303',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20618,57,'Bhayander East','401105',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20619,57,'Bhayander West','401101',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20620,57,'Bhopoli','401403',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20621,57,'Bhuigaon','401201',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20622,57,'Boisar','401501',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20623,57,'Bolinj','401303',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20624,57,'Bordi','401701',1,0,'2022-03-03 12:29:12','2022-03-03 12:29:12'),(20625,57,'Borigaon','401701',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20626,57,'Chandansar','401303',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20627,57,'Chandigaon','401103',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20628,57,'Charoti','401602',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20629,57,'Chas','401604',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20630,57,'Chikhal Dongre','401301',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20631,57,'Chikhale','401602',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20632,57,'Chinchani','401503',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20633,57,'Dabhadi','401606',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20634,57,'Dabheri','401603',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20635,57,'Dadade','401605',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20636,57,'Dahanu Road','401602',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20637,57,'Dahanu','401601',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20638,57,'Dahanu TPS','401608',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20639,57,'Dahisar Tarapur','401502',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20640,57,'Dahisar tymanor','401102',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20641,57,'Dahtsar T','401303',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20642,57,'Dandi','401501',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20643,57,'Dapchari','401610',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20644,57,'Dapoli','401405',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20645,57,'Datiware','401102',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20646,57,'Dehere','401603',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20647,57,'Dengachimet','401603',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20648,57,'Dhaniwari','401606',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20649,57,'Dhanoshi','401603',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20650,57,'Dhekale','401102',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20651,57,'Dhundalwadi','401606',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20652,57,'Dohe','421303',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20653,57,'Dolhara','401604',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20654,57,'Dongri','401106',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20655,57,'Dongri','401606',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20656,57,'Durves','401403',1,0,'2022-03-03 12:29:13','2022-03-03 12:29:13'),(20657,57,'Edwan','401102',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20658,57,'Ganeshpuri','401206',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20659,57,'Ganjad','401602',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20660,57,'Gargoan','421303',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20661,57,'Gass','401203',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20662,57,'Ghiwali','401502',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20663,57,'Ghodbander','401107',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20664,57,'Gholvad','401702',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20665,57,'Girgaon','401606',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20666,57,'Girij','401201',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20667,57,'Gokhiware','401208',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20668,57,'Gomghar','401604',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20669,57,'Gorhe','421303',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20670,57,'Govade','401403',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20671,57,'Gowane','401103',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20672,57,'Hamarapur','421303',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20673,57,'Holi Bazar','401201',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20674,57,'Jamsar','401603',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20675,57,'Jamshet','401602',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20676,57,'Jawhar','401603',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20677,57,'Juchandra','401208',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20678,57,'Kainad','401602',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20679,57,'Kalamb','401304',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20680,57,'Kalambe','421303',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20681,57,'Kaman','401208',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20682,57,'Kanchad','421303',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20683,57,'Karaj Gaon','401602',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20684,57,'Karhe','401603',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20685,57,'Kasa Budruk','401607',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20686,57,'Kasa','401607',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20687,57,'Kashi','401107',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20688,57,'Katale','401405',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20689,57,'Kaular Budruk','401201',1,0,'2022-03-03 12:29:14','2022-03-03 12:29:14'),(20690,57,'Kelthan','401204',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20691,57,'Kelwa Road','401401',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20692,57,'Kelwa (Thane)','401401',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20693,57,'Kelwa-mahim','401402',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20694,57,'Kev','401403',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20695,57,'Khaniwade','401303',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20696,57,'Khaniwali','401204',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20697,57,'Khare Ambiwali','421303',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20698,57,'Kharegaon','401604',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20699,57,'Kharekuran','401405',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20700,57,'Khariwali','421303',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20701,57,'Khodale','401604',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20702,57,'Khoste','401605',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20703,57,'Khuded','401603',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20704,57,'Koch','401604',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20705,57,'Kochai','401606',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20706,57,'Kogade','401603',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20707,57,'Kondhan','401403',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20708,57,'Kone','421303',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20709,57,'Kophrad','401301',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20710,57,'Kosbad-hill','401703',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20711,57,'Kudan','401502',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20712,57,'Kumbhawali','401501',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20713,57,'Kurze','401403',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20714,57,'Kurze','401606',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20715,57,'Mahagaon','401501',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20716,57,'Mala','421303',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20717,57,'Malwada','421303',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20718,57,'Mandvi','401303',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20719,57,'Maniwali','421303',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20720,57,'Manor','401403',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20721,57,'Maswan','401403',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20722,57,'Medhi','401605',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20723,57,'Mira Road','401107',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20724,57,'Mira','401107',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20725,57,'Modgaon','401606',1,0,'2022-03-03 12:29:15','2022-03-03 12:29:15'),(20726,57,'Moj','421303',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20727,57,'Mokhada','401604',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20728,57,'Morhanda','401604',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20729,57,'Mulgaon','401201',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20730,57,'Murbe','401501',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20731,57,'Nadore','401405',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20732,57,'Naigaon','401207',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20733,57,'Nala','401203',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20734,57,'Nallosapare E','401209',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20735,57,'Nanapur','401501',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20736,57,'Nandgaon','401603',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20737,57,'Nandgaon Tarapur','401501',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20738,57,'Narpad','401601',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20739,57,'Navghar','401102',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20740,57,'Nihe','401405',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20741,57,'Nikane','401602',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20742,57,'Nirmal (Thane)','401304',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20743,57,'Nyhale Budruk','401603',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20744,57,'Nyhale Khurdh','401603',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20745,57,'Ondhe','401605',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20746,57,'Palghar H.O','401404',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20747,57,'Papdi','401207',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20748,57,'Parali','421303',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20749,57,'Pargaon','401102',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20750,57,'Parnali','401504',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20751,57,'Parol','401303',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20752,57,'Pathardi','401603',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20753,57,'Pelhar','401208',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20754,57,'Pik','421303',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20755,57,'Pimpalshet','401603',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20756,57,'Poshera','401604',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20757,57,'Posheri','421303',1,0,'2022-03-03 12:29:16','2022-03-03 12:29:16'),(20758,57,'Rai','401101',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20759,57,'Rajawali','401208',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20760,57,'Rankol','401607',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20761,57,'Ranshet','401602',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20762,57,'Saiwan','401303',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20763,57,'Saiwan','401602',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20764,57,'Sakhare','401603',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20765,57,'Sakharshet','401603',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20766,57,'Saloli','401201',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20767,57,'Salwad','401504',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20768,57,'Sankhare','401603',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20769,57,'Sarawali','401501',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20770,57,'Sasun Navghar','401208',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20771,57,'Satiwai','401208',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20772,57,'Satpati','401405',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20773,57,'Sawata','401602',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20774,57,'Shigaon','401501',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20775,57,'Shirgaon','401405',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20776,57,'Shiroshi','401603',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20777,57,'Somta','401403',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20778,57,'Sonale','421303',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20779,57,'Sopara','401203',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20780,57,'Sukhasale','401605',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20781,57,'Suryanagar (Thane)','401609',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20782,57,'Talasari','401606',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20783,57,'Talawada','401607',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20784,57,'Tanashi','401503',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20785,57,'Tandulwadi','401102',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20786,57,'Tarapur App','401504',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20787,57,'Tarapur (Thane)','401502',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20788,57,'Tarapur Ti','401506',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20789,57,'Tawa','401607',1,0,'2022-03-03 12:29:17','2022-03-03 12:29:17'),(20790,57,'Tembhikhodave','401102',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20791,57,'Tembhode','401405',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20792,57,'Tilher','401303',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20793,57,'Tuse','421303',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20794,57,'Udhale','401604',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20795,57,'Udhave','401606',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20796,57,'Umbarpada','401102',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20797,57,'Umela','401202',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20798,57,'Umrale','401203',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20799,57,'Umroli','401501',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20800,57,'Uplat','401606',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20801,57,'Urse','401602',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20802,57,'Usarani','401102',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20803,57,'Utawali','421303',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20804,57,'Uttan','401106',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20805,57,'Vadhavan','401503',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20806,57,'Vajreshwari','401204',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20807,57,'Valiv','401208',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20808,57,'Valvande','401603',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20809,57,'Vangaon','401103',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20810,57,'Varale','421303',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20811,57,'Varor','401503',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20812,57,'Vasai East IE','401208',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20813,57,'Vasai Road E','401202',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20814,57,'Vashala','401604',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20815,57,'Vatar','401301',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20816,57,'Vedhe','401204',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20817,57,'Vengani','401502',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20818,57,'Veti','401607',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20819,57,'Veur','401405',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20820,57,'Vevji','401606',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20821,57,'Vikramgad','401605',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20822,57,'Vilkos','421303',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20823,57,'Virar East','401305',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20824,57,'Virar','401303',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20825,57,'Virathan Budruk','401102',1,0,'2022-03-03 12:29:18','2022-03-03 12:29:18'),(20826,57,'Wada','421303',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20827,57,'Waki','401602',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20828,57,'Waki','421303',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20829,57,'Zap','401603',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20830,57,'Zari','401606',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20831,58,'Agargaon','442101',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20832,58,'Ajansara','442307',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20833,58,'Akoli','442001',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20834,58,'Allipur (Wardha)','442304',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20835,58,'Andori','442101',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20836,58,'Anji','442001',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20837,58,'Antora','442202',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20838,58,'Arvi Chhoti','442307',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20839,58,'Arvi (Wardha)','442201',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20840,58,'Ashti (Wardha)','442202',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20841,58,'Bela','442301',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20842,58,'Bhankheda','442304',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20843,58,'Bharaswara','442202',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20844,58,'Bhidi','442101',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20845,58,'Bhishnoor','442202',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20846,58,'Bokenagar','442201',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20847,58,'Borgaon Hatla','442302',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20848,58,'Borgaon Meghe','442001',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20849,58,'Borgaon Tumni','442202',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20850,58,'Bori Bordharan','442104',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20851,58,'Bothuda','442102',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20852,58,'Chikni','442101',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20853,58,'Chincholi','442301',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20854,58,'Chincholi','442203',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20855,58,'Chincholi Dange','442201',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20856,58,'Chistur','442201',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20857,58,'Cottom Market','442003',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20858,58,'Cotton Market','442003',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20859,58,'Dahegaon Dhande','442306',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20860,58,'Dahegaon Gawande','442001',1,0,'2022-03-03 12:29:19','2022-03-03 12:29:19'),(20861,58,'Dahegaon Gondi','442106',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20862,58,'Dahegaon Gosavi','442001',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20863,58,'Dahegaon Miskin','442001',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20864,58,'Dahegaon Mustafa','442201',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20865,58,'Daroda','442307',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20866,58,'Dattapur','442001',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20867,58,'Delwadi','442202',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20868,58,'Deoli (Wardha)','442101',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20869,58,'Deorwara','442201',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20870,58,'Dhanodi Bahaddarpur','442302',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20871,58,'Dhanoli','442203',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20872,58,'Dhotra','442304',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20873,58,'Dongargaon','442301',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20874,58,'Gaul','442101',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20875,58,'Ghorad','442104',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20876,58,'Girad','442305',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20877,58,'Giroli','442101',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20878,58,'Goji','442304',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20879,58,'Gopuri','442001',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20880,58,'Hamdapur','442102',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20881,58,'Hindinagar','442003',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20882,58,'Hinganghat','442301',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20883,58,'Hinganghat Town','442301',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20884,58,'Hingani','442104',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20885,58,'Indira Market-Wardha','442001',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20886,58,'Inzala','442306',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20887,58,'Jalgaon','442201',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20888,58,'Jam','442301',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20889,58,'Jamalpur','442201',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20890,58,'Jasapur','442201',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20891,58,'Junapani','442203',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20892,58,'Junona','442102',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20893,58,'Juwadi','442104',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20894,58,'Kachnoor','442106',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20895,58,'Kajali','442203',1,0,'2022-03-03 12:29:20','2022-03-03 12:29:20'),(20896,58,'Kajalsara','442301',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20897,58,'Kakda','442203',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20898,58,'Kandegaon','442306',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20899,58,'Kandhali','442301',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20900,58,'Kangaon','442101',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20901,58,'Kannamwargram','442203',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20902,58,'Kaotha','442302',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20903,58,'Kapsi','442101',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20904,58,'Karanja (Wardha)','442203',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20905,58,'Kasarkheda','442106',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20906,58,'Kelzar','442104',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20907,58,'Khadki','442202',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20908,58,'Khandala','442301',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20909,58,'Khangaon','442101',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20910,58,'Khapari','442104',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20911,58,'Kharangna Gode','442102',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20912,58,'Kharangna','442106',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20913,58,'Khubgaon','442201',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20914,58,'Kopra','442102',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20915,58,'Kora','442301',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20916,58,'Kotamba','442104',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20917,58,'Lahan Arvi','442202',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20918,58,'Madni Karanji','442102',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20919,58,'Mahabala','442104',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20920,58,'Malegaon Theka','442106',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20921,58,'Manas Mandir-Wardha','442001',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20922,58,'Mandgaon','442102',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20923,58,'Mandwa','442001',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20924,58,'Mangrul Dasoda','442301',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20925,58,'Manikwara','442202',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20926,58,'Masod','442106',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20927,58,'MGIHU','442001',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20928,58,'Mozari','442101',1,0,'2022-03-03 12:29:21','2022-03-03 12:29:21'),(20929,58,'Nachangaon','442306',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20930,58,'Nagzari','442101',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20931,58,'Nalwadi','442001',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20932,58,'Nandora Dafre','442101',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20933,58,'Nandori','442301',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20934,58,'Nandpur','442201',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20935,58,'Nara','442203',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20936,58,'Neri Mirzapur','442201',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20937,58,'Nimbha','442301',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20938,58,'Nimboli','442201',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20939,58,'Padegaon','442101',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20940,58,'Paloti','442001',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20941,58,'Panwadi','442106',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20942,58,'Pardi (Nagaji)','442301',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20943,58,'Pardi','442201',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20944,58,'Paunar','442111',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20945,58,'Paunoor','442001',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20946,58,'Pimpalgaon Lute','442101',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20947,58,'Pimpalkhuta','442106',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20948,58,'Pimpri','442307',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20949,58,'Pipri Meghe','442001',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20950,58,'Pipri Pargothan','442302',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20951,58,'Pohana','442307',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20952,58,'Pulgaon Camp','442303',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20953,58,'Pulgaon','442302',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20954,58,'Ramnagar-Wardha','442001',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20955,58,'Rasulabad','442302',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20956,58,'Rehaki Kala','442104',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20957,58,'Rohana','442302',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20958,58,'Rohini','442306',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20959,58,'Sahur','442202',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20960,58,'Salaipevath','442104',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20961,58,'Salod Hirapur','442001',1,0,'2022-03-03 12:29:22','2022-03-03 12:29:22'),(20962,58,'Samudrapur','442305',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20963,58,'Sarwadi','442201',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20964,58,'Sawali BK','442201',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20965,58,'Sawali Khurd','442203',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20966,58,'Sawali Wagh','442301',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20967,58,'Sawangi Meghe','442001',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20968,58,'Seldoha','442104',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20969,58,'Seloo Kate','442001',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20970,58,'Seloo','442104',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20971,58,'Selsura','442101',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20972,58,'Sewagram','442102',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20973,58,'Shegaon Kund','442301',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20974,58,'Shekapur Bai','442307',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20975,58,'Shirpur','442101',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20976,58,'Sindi','442105',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20977,58,'Sindi Vihiri','442203',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20978,58,'Sirasgaon Bazar','442304',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20979,58,'Sonegaon Abaji','442101',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20980,58,'Sonora','442306',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20981,58,'Sorta','442302',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20982,58,'Sukali Bai','442001',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20983,58,'Sukli Station','442104',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20984,58,'Surgaon','442104',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20985,58,'Takarkheda','442201',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20986,58,'Talegaon Talatule','442001',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20987,58,'Talegaon(SP)','442201',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20988,58,'Tarasawanga','442202',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20989,58,'Taroda','442102',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20990,58,'Thanegaon','442203',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20991,58,'Umri','442203',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20992,58,'Vijaygopal','442306',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20993,58,'Virul','442302',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20994,58,'Wabgaon','442101',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20995,58,'Wadala','442202',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20996,58,'Wadhona','442201',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20997,58,'Wadner','442307',1,0,'2022-03-03 12:29:23','2022-03-03 12:29:23'),(20998,58,'Wagholi','442301',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(20999,58,'Waifad','442001',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21000,58,'Waigaon Gond','442305',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21001,58,'Waigaon Haldya','442305',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21002,58,'Waigaon Nipani','442001',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21003,58,'Wardha Ganj','442003',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21004,58,'Wardha H.O','442001',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21005,58,'Wardha Market','442001',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21006,58,'Wardhamaneri','442201',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21007,58,'Washi','442301',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21008,58,'Watkhed','442101',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21009,58,'YAC Wardha','442001',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21010,58,'Yelakeli','442001',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21011,58,'Yerala','442307',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21012,58,'Zadgaon Gosavi','442001',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21013,58,'Zadsi','442104',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21014,59,'Adoli','444510',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21015,59,'Amana','444503',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21016,59,'Amkheda','444503',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21017,59,'Anchal','444503',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21018,59,'Ansing','444507',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21019,59,'Arak','444409',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21020,59,'Asegaon','444409',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21021,59,'Asola KD','444404',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21022,59,'Assegaon Pen','444510',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21023,59,'Bembla','444110',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21024,59,'Bhamb','444110',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21025,59,'Bhatumra','444505',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21026,59,'Bhuli','444404',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21027,59,'Chandur','444004',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21028,59,'Chikhali','444510',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21029,59,'Chinchamba Bhar','444506',1,0,'2022-03-03 12:29:24','2022-03-03 12:29:24'),(21030,59,'Chinchambapen','444504',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21031,59,'Chivara','444505',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21032,59,'Dabha','444403',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21033,59,'Dapura Kd','444404',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21034,59,'Dawha','444503',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21035,59,'Dhamni','444403',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21036,59,'Dhanaj BK','444110',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21037,59,'Dhanaj KD','444110',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21038,59,'Dhanora Ghadge','444404',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21039,59,'Dhanora KD','444409',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21040,59,'Dhawanda','444404',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21041,59,'Dhumka','444505',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21042,59,'Dongarkinhi','444503',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21043,59,'Falegaon','444409',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21044,59,'Fulumari','444403',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21045,59,'Gaiwal','444403',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21046,59,'Girda','444403',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21047,59,'Giroli','444403',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21048,59,'Gobhani','444504',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21049,59,'Gowardhan','444504',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21050,59,'Gurumandir Karanja','444105',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21051,59,'Gwaha','444404',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21052,59,'Haral','444510',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21053,59,'Hinganwadi','444110',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21054,59,'Hivara Rohila','444510',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21055,59,'Hivra BK','444403',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21056,59,'Inzori','444404',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21057,59,'Jaipur','444507',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21058,59,'Jamb','444105',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21059,59,'Jaulka','444503',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21060,59,'Kajalamba','444505',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21061,59,'Kalamba Bodkhe','444409',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21062,59,'Kalamba Mahali','444505',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21063,59,'Kalambeshwar','444503',1,0,'2022-03-03 12:29:25','2022-03-03 12:29:25'),(21064,59,'Kamargaon (Washim)','444110',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21065,59,'Karanja (Washim)','444105',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21066,59,'Karanji','444504',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21067,59,'Karkheda','444404',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21068,59,'Karli','444404',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21069,59,'Karli','444505',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21070,59,'Kasola','444403',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21071,59,'Kata','444505',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21072,59,'Kawatha Naik','444506',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21073,59,'Kawathal','444403',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21074,59,'Kekatumara','444505',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21075,59,'Kenwad','444503',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21076,59,'Keshavnagar','444504',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21077,59,'Khandala Shinde','444504',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21078,59,'Kherda','444105',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21079,59,'Kiniraja','444503',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21080,59,'Kokalgaon','444505',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21081,59,'Kondoli','444404',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21082,59,'Kothari','444403',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21083,59,'Koyali','444510',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21084,59,'Kupta','444404',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21085,59,'Kurum','444106',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21086,59,'Ladegaon','444110',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21087,59,'Lehani','444504',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21088,59,'Linga Kotwal','444504',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21089,59,'Loni Arab','444105',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21090,59,'Loni Sm','444506',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21091,59,'Mahagaon','444506',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21092,59,'Malegaon','444503',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21093,59,'Malkapur','444004',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21094,59,'Manabha','444105',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21095,59,'Mandwa','444506',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21096,59,'Mangrulpir','444403',1,0,'2022-03-03 12:29:26','2022-03-03 12:29:26'),(21097,59,'Mangrulzanak','444504',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21098,59,'Manora (Washim)','444404',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21099,59,'Marsul','444503',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21100,59,'Masalapen','444504',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21101,59,'Medshi','444503',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21102,59,'Mendra','444403',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21103,59,'Mohari','444403',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21104,59,'Mohoja','444505',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21105,59,'Mop','444506',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21106,59,'Mothegaon','444506',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21107,59,'Mungla','444503',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21108,59,'Nagardas','444503',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21109,59,'Nagthana','444510',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21110,59,'Nandhana','444503',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21111,59,'Navali','444504',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21112,59,'Netansa','444504',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21113,59,'Palodi','444403',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21114,59,'Pangra Bandi','444503',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21115,59,'Pangri Kute','444503',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21116,59,'Pangri Navghare','444503',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21117,59,'Pardi Asra','444507',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21118,59,'Pardi Takmore','444505',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21119,59,'Parwa','444403',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21120,59,'Pimpalgaon','444507',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21121,59,'Pimpri Modak','444110',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21122,59,'Poghat','444403',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21123,59,'Poha','444105',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21124,59,'Pohara Devi','444404',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21125,59,'Poti','444403',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21126,59,'Rajura','444503',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21127,59,'Risod','444506',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21128,59,'Rithad','444510',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21129,59,'Rui','444404',1,0,'2022-03-03 12:29:27','2022-03-03 12:29:27'),(21130,59,'Sakhardoh','444403',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21131,59,'Sawad','444506',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21132,59,'Sawali','444507',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21133,59,'Sawargaon Jire','444510',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21134,59,'Shaha','444105',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21135,59,'Shegi','444403',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21136,59,'Shelukhadse','444506',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21137,59,'Shendona','444404',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21138,59,'Shendurjana','444403',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21139,59,'Sirpur','444504',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21140,59,'Soyata','444505',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21141,59,'Sukali','444105',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21142,59,'Talap BK','444404',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21143,59,'Tamsi','444505',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21144,59,'Tandali BK','444505',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21145,59,'Tandali Shewai','444505',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21146,59,'Tiwali','444504',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21147,59,'Tondgaon','444505',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21148,59,'Tornala','444404',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21149,59,'Tornala','444505',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21150,59,'Ukali Jahangir','444505',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21151,59,'Umara Shamshuddin','444507',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21152,59,'Umari','444404',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21153,59,'Umbarda Bazar','444105',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21154,59,'Vilegaon','444110',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21155,59,'Vitholi','444404',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21156,59,'Vyad','444510',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21157,59,'Wai','444105',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21158,59,'Waigual','444404',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21159,59,'Wakad','444506',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21160,59,'Wara Jahangir','444409',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21161,59,'Warala','444507',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21162,59,'Waroli','444404',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21163,59,'Wasari','444504',1,0,'2022-03-03 12:29:28','2022-03-03 12:29:28'),(21164,59,'Washim City','444505',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21165,59,'Washim','444505',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21166,59,'Yawardi','444105',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21167,59,'Yekamba','444503',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21168,59,'Yeota','444504',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21169,59,'Yeota','444105',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21170,59,'Yeoti','444510',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21171,59,'Yeranda','444505',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21172,59,'Zodga','444105',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21173,60,'Adegaon','445304',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21174,60,'Adegaon','445210',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21175,60,'Adegaon','445215',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21176,60,'Ajanti','445102',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21177,60,'Akhada Ward(Pandharkawada)','445302',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21178,60,'Akola Bazar','445109',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21179,60,'Akoli','445207',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21180,60,'Akoli','445302',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21181,60,'Akpuri','445301',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21182,60,'Amboda','445205',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21183,60,'Anji (Nrusinha)','445301',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21184,60,'Apti Rampur','445402',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21185,60,'Arali','445305',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21186,60,'Arambhi','445110',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21187,60,'Arjuna','445105',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21188,60,'Arni','445103',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21189,60,'Asegaon Devi','445001',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21190,60,'Ashti','445101',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21191,60,'Asola','445001',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21192,60,'Awdhutwadi (Yavatma)l','445001',1,0,'2022-03-03 12:29:29','2022-03-03 12:29:29'),(21193,60,'Ayata','445106',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21194,60,'Babhulgaon','445101',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21195,60,'Bangaon','445102',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21196,60,'Bansi','445204',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21197,60,'Belkhed','445206',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21198,60,'Belora','445105',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21199,60,'Belora','445304',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21200,60,'Belura','445215',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21201,60,'Bhalar','445304',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21202,60,'Bhamb Raja','445105',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21203,60,'Bhandari','445204',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21204,60,'Bhandegaon','445202',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21205,60,'Bhansara','445106',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21206,60,'Bhari','445002',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21207,60,'Bhavani Jahagir','445230',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21208,60,'Bhojla','445204',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21209,60,'Bhosa','445002',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21210,60,'Bhulai','445202',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21211,60,'Bittergaon','445207',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21212,60,'Borda','445304',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21213,60,'Borgaon (Linga )','445201',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21214,60,'Borgaon','445002',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21215,60,'Borgaon Vitholi','445103',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21216,60,'Bori Arab','445201',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21217,60,'Bori Khurd','445215',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21218,60,'Both','445302',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21219,60,'Brahmangaon','445204',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21220,60,'Brahmangaon','445206',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21221,60,'Brahmanwada','445102',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21222,60,'Buranda','445303',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21223,60,'Chahand','445308',1,0,'2022-03-03 12:29:30','2022-03-03 12:29:30'),(21224,60,'Chalbardi','445302',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21225,60,'Chanakha','445305',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21226,60,'Chatari','445206',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21227,60,'Chhoti Gujri (Yavatmal)','445001',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21228,60,'Chikani','445201',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21229,60,'Chikhali Camp','445204',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21230,60,'Chikhali Domga','445102',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21231,60,'Chikhali Kanhoba','445102',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21232,60,'Chikhali Kelapur','445402',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21233,60,'Chikhali Ramnath','445202',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21234,60,'Chikhalwardha','445306',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21235,60,'Chikhli Izara','445103',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21236,60,'Chikparam','445307',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21237,60,'Chinchala','445303',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21238,60,'Chinchghat','445002',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21239,60,'Chinchmandal','445303',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21240,60,'Chinchoni Botoni','445303',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21241,60,'Chopan','445303',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21242,60,'Dabha (Pahur)','445101',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21243,60,'Dabha','445323',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21244,60,'Dabhadi','445103',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21245,60,'Dahegaon','445308',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21246,60,'Daheli','445110',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21247,60,'Darati','445207',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21248,60,'Darwha','445202',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21249,60,'Datodi','445106',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21250,60,'Dehni','445203',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21251,60,'Deodhari','445306',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21252,60,'Deosari','445206',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21253,60,'Deurwada','445203',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21254,60,'Deurwadi Lad','445110',1,0,'2022-03-03 12:29:31','2022-03-03 12:29:31'),(21255,60,'Dhamangaon Deo','445202',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21256,60,'Dhanki (Yavatmal)','445207',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21257,60,'Dhanora','445402',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21258,60,'Dhanora','445305',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21259,60,'Dhanora Sachaldev','445206',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21260,60,'Dhansal','445215',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21261,60,'Dharna','445302',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21262,60,'Dhoki','445305',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21263,60,'Dhotra','445401',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21264,60,'Dighi','445101',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21265,60,'Digras','445203',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21266,60,'Dongargaon','445215',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21267,60,'Dongarkharda','445323',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21268,60,'Falegaon','445101',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21269,60,'Fetra','445215',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21270,60,'Fubgaon Kharbi','445202',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21271,60,'Fulsavangi','445230',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21272,60,'Gahuli','445204',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21273,60,'Ganori','445101',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21274,60,'Gaul',' Khurd',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21275,60,'Gharfal','445101',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21276,60,'Ghatanji','445301',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21277,60,'Ghodkhindi','445002',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21278,60,'Ghonsa','445304',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21279,60,'Ghoti','445301',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21280,60,'Gondegaon','445110',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21281,60,'Govt Poly (Yavatmal)','445001',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21282,60,'Gujari','445402',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21283,60,'Gunj','445205',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21284,60,'Harshi','445215',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21285,60,'Harsul','445203',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21286,60,'Haru','445110',1,0,'2022-03-03 12:29:32','2022-03-03 12:29:32'),(21287,60,'Hatola','445210',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21288,60,'Hiwara','445204',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21289,60,'Hiwari','445105',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21290,60,'Hiwra Majra','445303',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21291,60,'Hudi','445205',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21292,60,'Issapur','445209',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21293,60,'Jalka','445402',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21294,60,'Jalka Road','445303',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21295,60,'Jamb','445306',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21296,60,'Jamb','445002',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21297,60,'Jamb Bazar','445204',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21298,60,'Jamni','445305',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21299,60,'Jamni Dhundi','445204',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21300,60,'Januna','445215',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21301,60,'Jatra Road(Wani)','445304',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21302,60,'Jawala (Yavatmal)','445105',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21303,60,'Jawalgaon','445201',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21304,60,'Jeoli','445207',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21305,60,'Jodmoha','445002',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21306,60,'Kalamb (Yavatmal)','445401',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21307,60,'Kalgaon','445203',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21308,60,'Kali Daulat Khan','445204',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21309,60,'Kamathwada','445201',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21310,60,'Kandali','445203',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21311,60,'Kanha','445205',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21312,60,'Kapra Methad','445001',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21313,60,'Karajgaon','445202',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21314,60,'Karalgaon','445001',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21315,60,'Karanji','445302',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21316,60,'Kasola','445204',1,0,'2022-03-03 12:29:33','2022-03-03 12:29:33'),(21317,60,'Katri','445401',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21318,60,'Kawatha Bazar','445103',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21319,60,'Kayar','445304',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21320,60,'Kelapur','445302',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21321,60,'Khadakdari','445215',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21322,60,'Khairi','445308',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21323,60,'Khandala','445215',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21324,60,'Kharadgaon','445102',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21325,60,'Kharda','445101',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21326,60,'Kharus BK','445206',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21327,60,'Khedbid','445110',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21328,60,'Khopadi BK','445202',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21329,60,'Kinhi','445002',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21330,60,'Kolambi','445109',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21331,60,'Kolura','445102',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21332,60,'Kona','445304',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21333,60,'Kondri','445204',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21334,60,'Korta','445207',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21335,60,'Kotamba','445101',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21336,60,'Krishi Samiti (Umarkhed)','445206',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21337,60,'Krishnapur','445207',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21338,60,'Kumbha','445303',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21339,60,'Kurai','445307',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21340,60,'Kurli','445230',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21341,60,'Kurli','445306',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21342,60,'Ladkhed','445201',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21343,60,'Lakh Khind','445202',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21344,60,'Lakh Rayachi','445203',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21345,60,'Lakhi Jehangir','445215',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21346,60,'Lasina','445002',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21347,60,'Lewa','445204',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21348,60,'Lohara','445002',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21349,60,'Lohara Izara','445209',1,0,'2022-03-03 12:29:34','2022-03-03 12:29:34'),(21350,60,'Lohi','445210',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21351,60,'Lonbehel','445103',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21352,60,'Loni','445323',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21353,60,'Loni','445105',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21354,60,'M.I.D.C.','445002',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21355,60,'Madkona','445002',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21356,60,'Madni','445002',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21357,60,'Mahagaon (Yavatmal)','445205',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21358,60,'Mahagaon Kasba','445110',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21359,60,'Mahalungi','445103',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21360,60,'Mal Hivara','445203',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21361,60,'Malked Khurd','445102',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21362,60,'Malkhed BK','445102',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21363,60,'Mandar','445304',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21364,60,'Mandawa','445215',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21365,60,'Mang Kinhi','445202',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21366,60,'Mangala Devi','445102',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21367,60,'Mangurda','445302',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21368,60,'Manikdoh','445215',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21369,60,'Manikwada','445102',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21370,60,'Mardi','445303',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21371,60,'Maregaon Road','445303',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21372,60,'Marki','445305',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21373,60,'Marlegaon','445206',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21374,60,'Marsul','445206',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21375,60,'Matharjun','445302',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21376,60,'Mendholi','445304',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21377,60,'Metikheda','445323',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21378,60,'Mhaisdodka','445303',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21379,60,'Mhasola','445105',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21380,60,'Moha','445001',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21381,60,'Moha','445204',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21382,60,'Mohadi','445204',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21383,60,'Mohatoli','445110',1,0,'2022-03-03 12:29:35','2022-03-03 12:29:35'),(21384,60,'Mohda','445323',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21385,60,'Mohurli','445304',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21386,60,'Mokh','445203',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21387,60,'Mokhad','445204',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21388,60,'Mop Jawala','445215',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21389,60,'Morath','445205',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21390,60,'Mowada','445301',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21391,60,'Mozar','445102',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21392,60,'Mozar Izara','445201',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21393,60,'Mudana','445205',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21394,60,'Mukutban','445304',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21395,60,'Mulawa','445211',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21396,60,'Munzala','445308',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21397,60,'Murzadi','445002',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21398,60,'Naigaon','445101',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21399,60,'Naigaon','445304',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21400,60,'Nakapardi','445105',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21401,60,'Nandepera','445304',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21402,60,'Nanza','445002',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21403,60,'Narsala','445303',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21404,60,'Nawargaon','445303',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21405,60,'Ner Parsopant','445102',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21406,60,'Nerad Purad','445304',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21407,60,'Ningnoor','445230',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21408,60,'P.N.C. Pusad','445216',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21409,60,'Pachkhed','445101',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21410,60,'Pahapal','445302',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21411,60,'Pahur (Dabha)','445101',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21412,60,'Pahur Izara','445323',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21413,60,'Pahur Naskari','445109',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21414,60,'Palsi','445211',1,0,'2022-03-03 12:29:36','2022-03-03 12:29:36'),(21415,60,'Palsi','445106',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21416,60,'Palsoni','445304',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21417,60,'Pandharkawda','445302',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21418,60,'Pandhurna Khurd','445301',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21419,60,'Pardi (Sawlapur)','445101',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21420,60,'Pardi Limbi','445215',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21421,60,'Pardi Naskari','445109',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21422,60,'Parwa','445204',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21423,60,'Parwa','445306',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21424,60,'Patan','445305',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21425,60,'Patanbori','445305',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21426,60,'Patapangra','445301',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21427,60,'Patharot','445102',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21428,60,'Pedhi','445204',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21429,60,'Pendhari','445303',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21430,60,'Pimpalapur','445308',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21431,60,'Pimpalgaon Raja','445401',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21432,60,'Pimpalkhuta (R)','445202',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21433,60,'Pimpalkhuta','445101',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21434,60,'Pimpri','445302',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21435,60,'Pimpri Buti','445109',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21436,60,'Pimpri Kalga','445102',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21437,60,'Pisgaon','445303',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21438,60,'Pohandul','445204',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21439,60,'Pophali','445204',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21440,60,'Postal Colony (Yavatmal)','445001',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21441,60,'Punwat','445304',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21442,60,'Pusad','445204',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21443,60,'Pusad Town ( Pusad)','445204',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21444,60,'Rajur','445304',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21445,60,'Rajurwadi','445301',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21446,60,'Ralegaon','445402',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21447,60,'Ramgaon Rameshwar','445202',1,0,'2022-03-03 12:29:37','2022-03-03 12:29:37'),(21448,60,'Rani Amravati','445101',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21449,60,'Rani Dhanora','445103',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21450,60,'Rasa','445304',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21451,60,'Rohda','445215',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21452,60,'Rui','445105',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21453,60,'Runza','445323',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21454,60,'Sagnapur','445303',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21455,60,'Saikhada BK','445301',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21456,60,'Saikheda','445302',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21457,60,'Sakhara Wai','445203',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21458,60,'Sakharadara','445304',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21459,60,'Sakhra Khurd','445301',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21460,60,'Sakhra Kolgaon','445307',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21461,60,'Sakur','445103',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21462,60,'Salod','445109',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21463,60,'Sandawa','445215',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21464,60,'Sarul','445101',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21465,60,'Satefal','445210',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21466,60,'Satpalli','445305',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21467,60,'Sawali Sadoba','445106',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21468,60,'Sawana','445205',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21469,60,'Sawangi Perka','445402',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21470,60,'Sawar','445001',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21471,60,'Sawargad','445002',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21472,60,'Sawargaon','445401',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21473,60,'Sawargaon Bunglow','445209',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21474,60,'Sawargaon Gore','445215',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21475,60,'Sawarkheda','445323',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21476,60,'Sayat Kharda','445301',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21477,60,'Shelodi','445201',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21478,60,'Sheloo','445103',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21479,60,'Shelu BK','445215',1,0,'2022-03-03 12:29:38','2022-03-03 12:29:38'),(21480,60,'Shembal Pimpri','445209',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21481,60,'Shendri (Bk) B..','445202',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21482,60,'Shibala','445302',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21483,60,'Shiroli','445301',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21484,60,'Shirpur','445304',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21485,60,'Shivani','445301',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21486,60,'Sindhola Mines','445307',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21487,60,'Singad','445203',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21488,60,'Sirasgaon Pandhari','445102',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21489,60,'Sonbardi','445302',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21490,60,'Sonegaon','445401',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21491,60,'Soot Girni','445215',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21492,60,'Sukli','445103',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21493,60,'Sukli Jehangir','445206',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21494,60,'Suknegaon','445304',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21495,60,'Sunna','445305',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21496,60,'Tadsawali','445306',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21497,60,'Talegaon','445002',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21498,60,'Talegaon Deshmukh','445202',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21499,60,'Talni','445109',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21500,60,'Tarnoli','445210',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21501,60,'Taroda','445211',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21502,60,'Tembhi','445230',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21503,60,'Tilakwadi (Yavatmal)','445001',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21504,60,'Tiwari','445203',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21505,60,'Tiwasa','445201',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21506,60,'Tuptakli','445203',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21507,60,'Ukni','445304',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21508,60,'Umari Road','445302',1,0,'2022-03-03 12:29:39','2022-03-03 12:29:39'),(21509,60,'Umarkhed','445206',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21510,60,'Umarsara','445002',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21511,60,'Umri Kap','445106',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21512,60,'Undari','445402',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21513,60,'Uttarwadhona','445102',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21514,60,'Vasant Nagar','445203',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21515,60,'Velabai','445307',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21516,60,'Veni (Kotha)','445101',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21517,60,'Veni Kasba','445101',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21518,60,'Vidul','445206',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21519,60,'Vithala','445203',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21520,60,'Wadad','445205',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21521,60,'Wadgaon Gadhwe','445201',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21522,60,'Wadgaon P.S.','445002',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21523,60,'Wadgaon Road','445002',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21524,60,'Wadhona Bazar','445402',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21525,60,'Wadki','445308',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21526,60,'Waghapur','445002',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21527,60,'Waghar Takli','445306',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21528,60,'Wai','445302',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21529,60,'Wani Bazar','445304',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21530,60,'Wani','445304',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21531,60,'Wanwarla','445204',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21532,60,'Wanzari','445304',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21533,60,'Wardh','445323',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21534,60,'Warud JR','445402',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21535,60,'Watfali','445102',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21536,60,'Watkhed','445101',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21537,60,'Wegaon','445303',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21538,60,'Yavatmal H.O','445001',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21539,60,'Yavatmal Town','445001',1,0,'2022-03-03 12:29:40','2022-03-03 12:29:40'),(21540,60,'Yawali','445002',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21541,60,'Yelabara','445301',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21542,60,'Zadgaon','445402',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21543,60,'Zamkola','445304',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21544,60,'Zatala','445306',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21545,60,'Zillla Parishad (Yavatmal)','445002',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21546,61,'A.G.C.R.','110002',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21547,61,'A.K.Market','110055',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21548,61,'Ajmeri Gate Extn.','110002',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21549,61,'Anand Parbat Indl. Area','110005',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21550,61,'Anand Parbat','110005',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21551,61,'Bank Street (Central Delhi)','110005',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21552,61,'Baroda House','110001',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21553,61,'Bengali Market','110001',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21554,61,'Bhagat Singh Market','110001',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21555,61,'Connaught Place','110001',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21556,61,'Constitution House','110001',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21557,61,'Dada Ghosh Bhawan','110008',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21558,61,'Darya Ganj','110002',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21559,61,'Delhi High Court Extension Counter','110003',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21560,61,'Delhi High Court','110003',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21561,61,'Desh Bandhu Gupta Road','110005',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21562,61,'Election Commission','110001',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21563,61,'Gandhi Smarak Nidhi','110002',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21564,61,'Guru Gobind Singh Marg','110005',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21565,61,'Hauz Qazi','110006',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21566,61,'I.A.R.I.','110012',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21567,61,'I.P.Estate','110002',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21568,61,'Inderpuri','110012',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21569,61,'Indraprastha H.O','110002',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21570,61,'Jama Masjid','110006',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21571,61,'Janpath','110001',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21572,61,'Karol Bagh','110005',1,0,'2022-03-03 12:29:41','2022-03-03 12:29:41'),(21573,61,'Krishi Bhawan','110001',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21574,61,'Lady Harding Medical College','110001',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21575,61,'Master Prithvi Nath Marg','110005',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21576,61,'Minto Road','110002',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21577,61,'Multani Dhanda','110055',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21578,61,'National Physical Laboratory','110012',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21579,61,'Nirman Bhawan','110011',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21580,61,'North Avenue','110001',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21581,61,'Pahar Ganj','110055',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21582,61,'Pandara Road','110003',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21583,61,'Parliament House','110001',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21584,61,'Patel Nagar East','110008',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21585,61,'Patel Nagar (Central Delhi)','110008',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21586,61,'Patel Nagar South','110008',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21587,61,'Patel Nagar West','110008',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21588,61,'Patiala House','110001',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21589,61,'Pragati Maidan Camp','110001',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21590,61,'Pragati Maidan','110001',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21591,61,'Rail Bhawan','110001',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21592,61,'Rajender Nagar','110060',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21593,61,'Rashtrapati Bhawan','110004',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21594,61,'Sansad Marg H.O','110001',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21595,61,'Sansadiya Soudh','110001',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21596,61,'Sat Nagar','110005',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21597,61,'Secretariat North','110001',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21598,61,'Shastri Bhawan','110001',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21599,61,'South Avenue','110011',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21600,61,'Supreme Court','110001',1,0,'2022-03-03 12:29:42','2022-03-03 12:29:42'),(21601,61,'Swami Ram Tirth Nagar','110055',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21602,61,'Udyog Bhawan','110011',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21603,61,'Union Public Service Commission','110069',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21604,62,'Anand Vihar','110092',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21605,62,'Azad Nagar (East Delhi)','110051',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21606,62,'Badarpur Khadar','110090',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21607,62,'Balbir Nagar','110032',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21608,62,'Bhola Nath Nagar','110032',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21609,62,'Brahampuri','110053',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21610,62,'Chilla','110091',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21611,62,'Dilshad Garden','110095',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21612,62,'Distt. Court (KKD)','110032',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21613,62,'G.T.B. Hospital','110095',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21614,62,'Gandhi Nagar Bazar','110031',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21615,62,'Gandhi Nagar (East Delhi)','110031',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21616,62,'Garhi Mandu','110053',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21617,62,'Geeta Colony','110031',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21618,62,'Ghazipur','110096',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21619,62,'Ghonda','110053',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21620,62,'Gokal Puri','110094',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21621,62,'Goverdhan Bihari Colony','110032',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21622,62,'Govind Pura','110051',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21623,62,'Harsh Vihar','110093',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21624,62,'Himmatpuri','110091',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21625,62,'IP Extension','110092',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21626,62,'Jafrabad (East Delhi)','110053',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21627,62,'Jagjit Nagar','110053',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21628,62,'Jhilmil H.O','110095',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21629,62,'Jhilmil Tahirpur','110095',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21630,62,'Johripur','110094',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21631,62,'Kailash Nagar','110031',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21632,62,'Kalyanpuri','110091',1,0,'2022-03-03 12:29:43','2022-03-03 12:29:43'),(21633,62,'Kalyanvas','110091',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21634,62,'Karawal Nagar','110090',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21635,62,'Khazuri Khas','110094',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21636,62,'Krishna Nagar H.O','110051',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21637,62,'Laxmi Nagar (East Delhi)','110092',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21638,62,'Loni Road Housing Complex','110093',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21639,62,'Loni Road','110032',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21640,62,'Man Sarovar Park','110032',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21641,62,'Mandawali Fazalpur','110092',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21642,62,'Maujpur','110053',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21643,62,'Mayur Vihar Ph-I','110091',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21644,62,'Mayur Vihar Ph-III','110096',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21645,62,'Nand Nagri A\"\"','110093',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21646,62,'Nand Nagri C\"\"','110093',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21647,62,'New Seemapuri','110095',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21648,62,'New Usmanpur','110053',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21649,62,'Nirman Vihar','110092',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21650,62,'Old Seemapuri','110095',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21651,62,'Patparganj','110091',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21652,62,'Raghubar Pura','110031',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21653,62,'Rajgarh Colony','110031',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21654,62,'Ram Nagar (East Delhi)','110051',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21655,62,'Rohtash Nagar','110032',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21656,62,'Seelampur','110053',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21657,62,'Shahdara Mandi','110032',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21658,62,'Shahdara','110032',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21659,62,'Shakarpur','110092',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21660,62,'Shastri Nagar (East Delhi)','110031',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21661,62,'Shivaji Park (East Delhi)','110032',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21662,62,'Sonia Vihar','110090',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21663,62,'Surajmal Vihar','110092',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21664,62,'Telewara','110032',1,0,'2022-03-03 12:29:44','2022-03-03 12:29:44'),(21665,62,'Trilok Puri','110091',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21666,62,'V.K. Nagar','110095',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21667,62,'Vasundhra Enclave','110096',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21668,62,'Vishwas Nagar','110032',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21669,62,'Vivek Vihar','110095',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21670,62,'Yamuna Vihar','110053',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21671,62,'Yozna Vihar','110092',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21672,63,'New Delhi G.P.O.','110001',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21673,63,'F F C Okhla','110020',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21674,63,'Nauroji Nagar','110029',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21675,64,'Delhi G.P.O.','110006',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21676,64,'Aruna Nagar','110054',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21677,64,'Avantika','110085',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21678,64,'Baratooti','110006',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21679,64,'Burari','110084',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21680,64,'C.C.I.','110007',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21681,64,'Chandni Chowk','110006',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21682,64,'Chawri Bazar','110006',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21683,64,'Civil Lines (North Delhi)','110054',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21684,64,'Dareeba','110006',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21685,64,'Delhi Sadar Bazar','110006',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21686,64,'Delhi University','110007',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21687,64,'District Courts (North Delhi)','110054',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21688,64,'Gulabi Bagh','110007',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21689,64,'Jagatpur','110084',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21690,64,'Jawahar Nagar (North Delhi)','110007',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21691,64,'Jharoda Majraa','110084',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21692,64,'Kamla Nagar (North Delhi)','110007',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21693,64,'Majnu ka Tila','110054',1,0,'2022-03-03 12:29:45','2022-03-03 12:29:45'),(21694,64,'Malka Ganj','110007',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21695,64,'Padam Nagar (North Delhi)','110007',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21696,64,'Patrachar Vidyalay','110054',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21697,64,'R.C.A.O.','110007',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21698,64,'Rana Pratap Bagh','110007',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21699,64,'Roop Nagar','110007',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21700,64,'Roshan Ara Road','110007',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21701,64,'S.T. Road','110006',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21702,64,'Shakti Nagar (North Delhi)','110007',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21703,64,'Timarpur','110054',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21704,64,'Wazirabad Village','110084',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21705,65,'Babarpur (North East Delhi)','110032',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21706,65,'Bhajan Pura','110053',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21707,65,'Dayalpur','110094',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21708,65,'Mandoli Saboli','110093',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21709,65,'Shaheed Bhagat Singh Colony','110090',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21710,65,'Shriram Colony Rajeev Nagar','110090',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21711,65,'Sunder Nagari','110093',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21712,66,'Sabhapur','110094',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21713,66,'Adrash Nagar','110033',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21714,66,'Alipur','110036',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21715,66,'Anandvas Shakurpur','110034',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21716,66,'Ashok Vihar H.O','110052',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21717,66,'Auchandi','110039',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21718,66,'Badli (North West Delhi)','110042',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21719,66,'Bakhtawar Pur','110036',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21720,66,'Bakoli','110036',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21721,66,'Bankner','110040',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21722,66,'Barwala','110039',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21723,66,'Bawana','110039',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21724,66,'Begumpur','110086',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21725,66,'Bhalaswa','110033',1,0,'2022-03-03 12:29:46','2022-03-03 12:29:46'),(21726,66,'Bhorgarh','110040',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21727,66,'Budh Vihar','110086',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21728,66,'Chand Pur','110081',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21729,66,'Daryapur Kalan','110039',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21730,66,'Delhi Engg. College','110042',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21731,66,'Dr.Mukerjee Nagar','110009',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21732,66,'G.T.B.Nagar','110009',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21733,66,'Ganeshpura','110035',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21734,66,'Gheora','110081',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21735,66,'Ghoga','110039',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21736,66,'Gujranwala Colony','110009',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21737,66,'H.S.Sangh','110009',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21738,66,'Haiderpur','110088',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21739,66,'Hareveli','110039',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21740,66,'Hiranki','110036',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21741,66,'Holambi Kalan','110082',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21742,66,'Jahangir Puri A Block','110033',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21743,66,'Jahangir Puri D Block','110033',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21744,66,'Jahangir Puri H Block','110033',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21745,66,'Jat Khore','110039',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21746,66,'Jaunti','110081',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21747,66,'Kadipur','110036',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21748,66,'Kanjhawla','110081',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21749,66,'Kanya Gurukul','110040',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21750,66,'Karala','110081',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21751,66,'Katewara','110039',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21752,66,'Keshav Puram (North West Delhi)','110035',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21753,66,'Khampur','110036',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21754,66,'Khera Kalan','110082',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21755,66,'Khera Khurd','110082',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21756,66,'Lad Pur','110081',1,0,'2022-03-03 12:29:47','2022-03-03 12:29:47'),(21757,66,'Lampur','110040',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21758,66,'Majra Dabas','110081',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21759,66,'Mangolpuri A Block','110083',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21760,66,'Mangolpuri I  Block','110083',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21761,66,'Mangolpuri N Block','110083',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21762,66,'Mangolpuri S Block','110083',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21763,66,'Maurya Enclave','110034',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21764,66,'Model Town II','110009',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21765,66,'Model Town III','110009',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21766,66,'Mubarak Pur Dabas','110081',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21767,66,'Mukhmelpur','110036',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21768,66,'Mungeshpur','110039',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21769,66,'N.S.Mandi','110033',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21770,66,'Naharpur','110085',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21771,66,'Nangal Poona','110036',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21772,66,'Nangal Thakran','110039',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21773,66,'Narela','110040',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21774,66,'Naya Bans','110082',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21775,66,'New Multan Nagar','110056',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21776,66,'Nimri','110052',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21777,66,'Nirankari Colony','110009',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21778,66,'Nizampur','110081',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21779,66,'Onkar Nagar','110035',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21780,66,'Palla','110036',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21781,66,'Pehlad Pur','110042',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21782,66,'Pooth Kalan','110086',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21783,66,'Pooth Kalan Resettlement','110086',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21784,66,'Pooth Khurd','110039',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21785,66,'Power House','110035',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21786,66,'Prashant Vihar','110085',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21787,66,'Prem Nagar','110086',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21788,66,'Punjab Khor','110081',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21789,66,'Qutabagarh','110039',1,0,'2022-03-03 12:29:48','2022-03-03 12:29:48'),(21790,66,'Rampura','110035',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21791,66,'Rani Bagh','110034',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21792,66,'Rani Khera','110081',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21793,66,'Rithala','110085',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21794,66,'Rohini Courts','110085',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21795,66,'Rohini sec-11','110085',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21796,66,'Rohini Sector 15','110089',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21797,66,'Rohini Sector 5','110085',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21798,66,'Rohini Sector-7','110085',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21799,66,'Samai Pur','110042',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21800,66,'Sanoth','110040',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21801,66,'Sarai Rohilla','110035',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21802,66,'Saraswati Vihar','110034',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21803,66,'Satyawati Nagar','110052',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21804,66,'Shahbad Daulatpur','110042',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21805,66,'Shakur Basti Depot','110056',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21806,66,'Shakur Pur I  Block','110034',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21807,66,'Shakurbasti Rs','110034',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21808,66,'Shalamar','110088',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21809,66,'Shalimar Bagh (North West Delhi)','110088',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21810,66,'Shastri Nagar (North West Delhi)','110052',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21811,66,'Singhu','110040',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21812,66,'Siraspur','110042',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21813,66,'Sri Nagar Colony','110034',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21814,66,'Sultanpuri B Block','110086',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21815,66,'Sultanpuri C Block','110086',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21816,66,'Sultanpuri F Block','110086',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21817,66,'Tajpur Kalan','110036',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21818,66,'Tikri Khurd','110040',1,0,'2022-03-03 12:29:49','2022-03-03 12:29:49'),(21819,66,'Wazir Pur III','110052',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21820,67,'Abul Fazal Enclave-I','110025',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21821,67,'Air Force Station Tugalkabad','110062',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21822,67,'Alaknanda','110019',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21823,67,'Ali','110076',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21824,67,'Aliganj (South Delhi)','110003',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21825,67,'Amar Colony','110024',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21826,67,'Andrewsganj','110049',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21827,67,'Badarpur (South Delhi)','110044',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21828,67,'BSF Camp Tigri','110062',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21829,67,'BTPS (South Delhi)','110044',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21830,67,'C G O Complex','110003',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21831,67,'C R R I (South Delhi)','110020',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21832,67,'Chittranjan Park','110019',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21833,67,'Dakshinpuri Phase-I','110062',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21834,67,'Dakshinpuri Phase-II','110062',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21835,67,'Dakshinpuri Phase-III','110062',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21836,67,'Dargah Sharif','110013',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21837,67,'Defence Colony (South Delhi)','110024',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21838,67,'Deoli','110062',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21839,67,'Distt. Court Complex',' Saket',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21840,67,'Dr. Ambedkar Nagar (South Delhi)','110062',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21841,67,'East Of Kailash Phase-I','110065',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21842,67,'East Of Kailash','110065',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21843,67,'Gautam Nagar','110049',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21844,67,'Golf Links','110003',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21845,67,'Greater Kailash','110048',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21846,67,'Gulmohar Park','110049',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21847,67,'Hamdard Nagar','110062',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21848,67,'Hari Nagar Ashram','110014',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21849,67,'Hazrat Nizamuddin','110013',1,0,'2022-03-03 12:29:50','2022-03-03 12:29:50'),(21850,67,'Jaitpur','110044',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21851,67,'Jaitpur (South Delhi)','110044',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21852,67,'Jamia Nagar','110025',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21853,67,'Jeevan Nagar','110014',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21854,67,'Jungpura','110014',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21855,67,'Kailash Colony','110048',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21856,67,'Kalkaji H.O','110019',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21857,67,'Kasturba Nagar (South Delhi)','110003',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21858,67,'Khanpur (South Delhi)','110062',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21859,67,'Krishna Market','110024',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21860,67,'Lajpat Nagar (South Delhi)','110024',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21861,67,'Lal Kuan','110044',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21862,67,'Lodi Road H.O','110003',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21863,67,'Madanpur Khadar','110076',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21864,67,'Malviya Nagar (South Delhi)','110017',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21865,67,'Masjid Moth','110048',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21866,67,'MMTC/STC Colony','110017',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21867,67,'Molarband','110044',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21868,67,'Nehru Nagar (South Delhi)','110065',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21869,67,'Nehru Place','110019',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21870,67,'New Delhi South Ext-II','110049',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21871,67,'New Friends Colony','110025',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21872,67,'Okhla Industrial Area Phase-i','110020',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21873,67,'Okhla Industrial Estate','110020',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21874,67,'Panchsheel Enclave','110017',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21875,67,'Pragati Vihar','110003',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21876,67,'Pratap Market','110014',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21877,67,'Pul Pahladpur','110044',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21878,67,'Pushp Vihar','110017',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21879,67,'Pushpa Bhawan','110062',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21880,67,'Sadiq Nagar','110049',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21881,67,'Safdarjung Air Port','110003',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21882,67,'Sahpurjat','110049',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21883,67,'Saket (South Delhi)','110017',1,0,'2022-03-03 12:29:51','2022-03-03 12:29:51'),(21884,67,'Sangam Vihar','110080',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21885,67,'Sant Nagar (South Delhi)','110065',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21886,67,'Sarita Vihar','110076',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21887,67,'Sarvodya Enclave','110017',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21888,67,'South Malviya Nagar','110017',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21889,67,'Sriniwaspuri','110065',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21890,67,'Sukhdev Vihar','110025',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21891,67,'Talimabad','110062',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21892,67,'Tehkhand','110020',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21893,67,'Tugalkabad','110044',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21894,67,'Tugalkabad Railway Colony','110044',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21895,67,'Zakir Nagar','110025',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21896,68,'505 A B Workshop','110010',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21897,68,'A F Palam','110010',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21898,68,'A F Rajokari','110038',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21899,68,'Anand Niketan','110021',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21900,68,'Ansari Nagar','110029',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21901,68,'Aps Colony','110010',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21902,68,'Arjungarh','110047',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21903,68,'Aya Nagar','110047',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21904,68,'Bazar Road','110010',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21905,68,'Bijwasan','110061',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21906,68,'C.S.K.M. School','110074',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21907,68,'C.V.D.','110010',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21908,68,'Chanakya Puri','110021',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21909,68,'Chandanhoola','110074',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21910,68,'Chattarpur','110074',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21911,68,'COD (South West Delhi)','110010',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21912,68,'Delhi Cantt','110010',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21913,68,'Dera','110074',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21914,68,'Dhaula Kuan','110010',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21915,68,'Fatehpur Beri','110074',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21916,68,'Gadaipur','110030',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21917,68,'Ghitorni','110030',1,0,'2022-03-03 12:29:52','2022-03-03 12:29:52'),(21918,68,'Green Park Market','110016',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21919,68,'Gurgaon Road','110037',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21920,68,'Hauz Khas Market','110016',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21921,68,'Hauz Khas','110016',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21922,68,'IGI Airport','110037',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21923,68,'Ignou','110068',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21924,68,'IT Hauz Khas','110016',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21925,68,'J.N.U.','110067',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21926,68,'Jaunapur','110047',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21927,68,'JNU New Campus','110067',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21928,68,'Kapashera.','110097',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21929,68,'Kidwai Nagar East','110023',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21930,68,'Kidwai Nagar West','110023',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21931,68,'Kirby Place','110010',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21932,68,'Lado Sarai','110030',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21933,68,'Laxmi Bai Nagar','110023',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21934,68,'Mahipalpur','110037',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21935,68,'Maidan Garhi','110068',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21936,68,'Malcha Marg','110021',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21937,68,'Mandi','110047',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21938,68,'Masood Pur','110070',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21939,68,'Mehrauli','110030',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21940,68,'Moti Bagh','110021',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21941,68,'Munirka','110067',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21942,68,'Nanak Pura','110021',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21943,68,'Nangal Dewat','110037',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21944,68,'Netaji Nagar (South West Delhi)','110023',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21945,68,'NIE Campus','110016',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21946,68,'Palam Airport','110037',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21947,68,'Paryavaran Complex','110030',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21948,68,'Pinto Park','110010',1,0,'2022-03-03 12:29:53','2022-03-03 12:29:53'),(21949,68,'R K Puram (Main)','110066',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21950,68,'R K Puram Sect-1','110022',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21951,68,'R K Puram Sect-12','110022',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21952,68,'R K Puram Sect-3','110022',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21953,68,'R K Puram Sect-4','110022',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21954,68,'R K Puram Sect-5','110022',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21955,68,'R K Puram Sect7','110022',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21956,68,'R K Puram Sect-8','110022',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21957,68,'R K Puram Sector - 6 Postal SB','110022',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21958,68,'R K Puram West','110066',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21959,68,'R R Hospital','110010',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21960,68,'Rajokari','110038',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21961,68,'Safdarjung Enclave','110029',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21962,68,'Sanjay Colony Bhati Mines','110074',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21963,68,'Sarojini Nagar H.O','110023',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21964,68,'Satbari','110074',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21965,68,'Sawan Public School','110074',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21966,68,'Shahbad Mohammadpur','110061',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21967,68,'Signal Enclave','110010',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21968,68,'South Delhi Campus','110021',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21969,68,'Station Road (South West Delhi)','110010',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21970,68,'Subroto Park','110010',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21971,68,'Sultanpur','110030',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21972,68,'T B Hospital','110030',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21973,68,'Technology Bhawan','110016',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21974,68,'Vasant Kunj Pkt-A','110070',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21975,68,'Vasant Kunj','110070',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21976,68,'Vasant Vihar-1','110057',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21977,68,'Vasant Vihar-2','110057',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21978,68,'Amberhai','110075',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21979,68,'Badusarai','110071',1,0,'2022-03-03 12:29:54','2022-03-03 12:29:54'),(21980,68,'Bagdola','110077',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(21981,68,'Baprola','110043',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(21982,68,'Barthal','110077',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(21983,68,'Chhawla','110071',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(21984,68,'CRPF Jharoda Kalan','110072',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(21985,68,'Dabri','110045',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(21986,68,'Daulatpur','110043',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(21987,68,'DC Goyla','110071',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(21988,68,'Dhansa','110073',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(21989,68,'Dhulsiras','110077',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(21990,68,'Dichaun Kalan','110043',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(21991,68,'Dindarpur','110043',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(21992,68,'District Court Complex Dwarka','110075',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(21993,68,'Dwarka Sec-6','110075',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(21994,68,'Galib Pur','110073',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(21995,68,'Ghuman Hera','110073',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(21996,68,'Indira Park','110045',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(21997,68,'Issapur','110073',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(21998,68,'Jafarpur','110073',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(21999,68,'Jharoda Kalan','110072',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(22000,68,'Jhatikara','110043',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(22001,68,'Kair','110028',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(22002,68,'Kakrola','110078',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(22003,68,'Kangan Heri','110071',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(22004,68,'Khaira','110028',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(22005,68,'Khera Dabur','110073',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(22006,68,'Malik Pur','110073',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(22007,68,'Maya Puri','110064',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(22008,68,'Mayapuri Shopping Centre','110064',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(22009,68,'Mitraon','110043',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(22010,68,'Mundela Kalan','110073',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(22011,68,'N.S.I.T. Dwarka','110078',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(22012,68,'Najafgarh','110043',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(22013,68,'Nangal Raya','110046',1,0,'2022-03-03 12:29:55','2022-03-03 12:29:55'),(22014,68,'Naraina Industrial Estate H.O','110028',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22015,68,'Naraina Village','110028',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22016,68,'Nasirpur','110045',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22017,68,'Palam Village','110045',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22018,68,'Pandwala Kalan','110043',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22019,68,'Papravat','110043',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22020,68,'Quazipur','110073',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22021,68,'Raj Nagar - II','110077',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22022,68,'Raota','110073',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22023,68,'Rewla Khanpur','110043',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22024,68,'Sagarpur','110046',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22025,68,'Surehra','110043',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22026,68,'Tilangpur Kotla','110043',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22027,68,'Ujwa','110073',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22028,69,'Ashok Nagar (West Delhi)','110018',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22029,69,'Ashoka Park Extn.','110026',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22030,69,'Bakkarwala','110041',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22031,69,'Chand Nagar','110018',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22032,69,'Chaukhandi','110018',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22033,69,'D. K. Mohan Garden','110059',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22034,69,'D.E.S.U. Colony','110058',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22035,69,'Delhi Industrial Area','110015',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22036,69,'Distt. Court Complex',' Dwarka',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22037,69,'ESI','110015',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22038,69,'Fateh Nagar','110018',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22039,69,'GGSIP University','110078',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22040,69,'Hari Nagar BE Block','110064',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22041,69,'Hari Nagar Dadb Block','110064',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22042,69,'Hari Nagar (West Delhi)','110064',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22043,69,'Hastal Village','110059',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22044,69,'Hirankudna','110041',1,0,'2022-03-03 12:29:56','2022-03-03 12:29:56'),(22045,69,'Jail Road (West Delhi)','110058',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22046,69,'Janakpuri A-3','110058',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22047,69,'Janakpuri B-1','110058',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22048,69,'Janakpuri C-4','110058',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22049,69,'Janta Market','110027',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22050,69,'Jawala Heri','110063',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22051,69,'Jeevan Park','110059',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22052,69,'Jwala Puri','110087',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22053,69,'Karam Pura','110015',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22054,69,'Khyala Phase -  I','110018',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22055,69,'Khyala Phase - II','110018',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22056,69,'L. M. Nagar Indl. Area','110015',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22057,69,'M.B.S. Nagar','110018',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22058,69,'Madipur Slum Quarter','110063',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22059,69,'Madipur Village','110063',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22060,69,'Mahabir Nagar','110018',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22061,69,'Mansarover Garden','110015',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22062,69,'Matiala','110059',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22063,69,'Mundka','110041',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22064,69,'N.I.Area','110015',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22065,69,'Nangloi - II','110041',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22066,69,'Nangloi - III','110041',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22067,69,'Nangloi','110041',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22068,69,'Nilothi','110041',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22069,69,'Palam Extn (Harijan Basti)','110077',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22070,69,'Paschim Vihar B Block','110063',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22071,69,'Paschim Vihar','110063',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22072,69,'Peeragarhi','110063',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22073,69,'Punjabi Bagh','110026',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22074,69,'Punjabi Bagh Sec - III','110026',1,0,'2022-03-03 12:29:57','2022-03-03 12:29:57'),(22075,69,'Rajouri Garden J-6','110027',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22076,69,'Rajouri Market','110027',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22077,69,'Ramesh Nagar H.O','110015',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22078,69,'Ranhola','110041',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22079,69,'Shivaji Park (West Delhi)','110026',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22080,69,'Subhash Nagar (West Delhi)','110027',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22081,69,'Subhash Nagar West','110027',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22082,69,'Sunder Vihar','110087',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22083,69,'Tagore Garden','110027',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22084,69,'Tikri Kalan','110041',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22085,69,'Tilak Nagar East','110018',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22086,69,'Tilak Nagar (West Delhi)','110018',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22087,69,'Uttam Nagar','110059',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22088,69,'Vikas Puri','110018',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22089,69,'Vishnu Garden','110018',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22090,69,'Zakhira','110015',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22091,70,'Achanur','587111',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22092,70,'Adagal','587201',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22093,70,'Adihudi','587330',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22094,70,'Agasarkoppa','587206',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22095,70,'Aihole','587124',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22096,70,'Albal','587119',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22097,70,'Algundi','587116',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22098,70,'Algur','587301',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22099,70,'Alur S.K.','587155',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22100,70,'Amalzeri','587121',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22101,70,'Amaravati','587118',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22102,70,'Amarawadgi','587125',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22103,70,'Amingad','587112',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22104,70,'Anagwadi','587116',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22105,70,'Anawal','587206',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22106,70,'Arakeri','587116',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22107,70,'Asangi','587311',1,0,'2022-03-03 12:29:58','2022-03-03 12:29:58'),(22108,70,'Bachingudd','587201',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22109,70,'Badagandi','587116',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22110,70,'Badagi','587117',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22111,70,'Badami Extension','587201',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22112,70,'Badami','587201',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22113,70,'Bagalkot Alokudyog','587111',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22114,70,'Bagalkot B.H.School','587101',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22115,70,'Bagalkot DC Complex','587103',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22116,70,'Bagalkot H.O','587101',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22117,70,'Bagalkot Navanagar','587103',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22118,70,'Bagalkot UHS Campus','587104',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22119,70,'Balkundi','587125',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22120,70,'Banahatti','587311',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22121,70,'Banahatti Somaarpeth','587311',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22122,70,'Banakanadoni','587125',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22123,70,'Bantanur','587204',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22124,70,'Baragi','587313',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22125,70,'Belagali','587113',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22126,70,'Belavalakoppa','587155',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22127,70,'Belgal','587112',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22128,70,'Belur (Bagalkot)','587114',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22129,70,'Benkatti','587111',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22130,70,'Bennur','587111',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22131,70,'Bevinmatti','587112',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22132,70,'Bevinmattti','587111',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22133,70,'Bevur (Bagalkot)','587115',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22134,70,'Bhagavati','587115',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22135,70,'Bhairmatti','587115',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22136,70,'Bhimangad','587202',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22137,70,'Bidari','587313',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22138,70,'Bilgi (Bagalkot)','587116',1,0,'2022-03-03 12:29:59','2022-03-03 12:29:59'),(22139,70,'Bilkerur','587207',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22140,70,'Bisaldinni','587115',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22141,70,'Bisnal','587117',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22142,70,'Bodanaikanadinni','587115',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22143,70,'Budihal S.K.','587125',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22144,70,'Budni','587121',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22145,70,'Chichakandi  K.D.','587313',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22146,70,'Chichakhandi B.K.','587313',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22147,70,'Chikhodlur','587111',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22148,70,'Chikkadapur','587125',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22149,70,'Chikkur','587122',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22150,70,'Chikmagi','587120',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22151,70,'Chikmuchalgudda','587201',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22152,70,'Chikmyageri','587207',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22153,70,'Chikpadasalagi','587301',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22154,70,'Chikshellikeri','587204',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22155,70,'Chilapur','587124',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22156,70,'Chimmad','587312',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22157,70,'Chinchalkatti','587206',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22158,70,'Chingundi','587301',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22159,70,'Chinnapur','587125',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22160,70,'Chittargi','587112',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22161,70,'Chitwadgi','587118',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22162,70,'Cholachagudd','587201',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22163,70,'Choudapur','587115',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22164,70,'Dadnatti','587122',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22165,70,'Devanal','587204',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22166,70,'Dhanakshirur','587114',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22167,70,'Dhannur','587118',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22168,70,'Dhavaleshwar','587312',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22169,70,'Dhavaleshwar','587116',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22170,70,'Gaddankeri','587102',1,0,'2022-03-03 12:30:00','2022-03-03 12:30:00'),(22171,70,'Gaddankeri Cross','587102',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22172,70,'Gadyal','587330',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22173,70,'Galagali','587117',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22174,70,'Gandhinagar','587103',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22175,70,'Gani','587121',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22176,70,'Ganjihal','587115',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22177,70,'Girisagar','587116',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22178,70,'Golbhavi','587315',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22179,70,'Gorbal','587154',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22180,70,'Gothe','587330',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22181,70,'Govankoppa','587155',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22182,70,'Guddadmallapur','587114',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22183,70,'Gudur (Bagalkot)','587202',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22184,70,'Guledgudd','587203',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22185,70,'Gulgal Jambgi','587313',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22186,70,'Hadagalli','587112',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22187,70,'Haladoor','587203',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22188,70,'Halagali','587121',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22189,70,'Haligeri','587206',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22190,70,'Halingali','587315',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22191,70,'Halkurki','587201',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22192,70,'Hallur','587115',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22193,70,'Hanagandi','587315',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22194,70,'Hanapur','587203',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22195,70,'Hanchinal','587117',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22196,70,'Hangaragi','587205',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22197,70,'Haunsnur','587203',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22198,70,'Havaragi','587118',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22199,70,'Haveli','587103',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22200,70,'Hebbal','587122',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22201,70,'Hebballi','587201',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22202,70,'Herkal','587102',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22203,70,'Herur','587154',1,0,'2022-03-03 12:30:01','2022-03-03 12:30:01'),(22204,70,'Hipparagi','587311',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22205,70,'Hirebadwadgi','587118',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22206,70,'Hirebudihal','587205',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22207,70,'Hiregulbal','587207',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22208,70,'Hirekodagali','587154',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22209,70,'Hiremagi','587112',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22210,70,'Hiremalgavi','587115',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22211,70,'Hirenabasi','587114',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22212,70,'Hireotageri','587154',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22213,70,'Hirepadasalagi','587301',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22214,70,'Hiresingangutti','587154',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22215,70,'Honnakatti','587111',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22216,70,'Honnihal','587116',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22217,70,'Hoolgeri','587206',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22218,70,'Hospet- Kerur','587206',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22219,70,'Hosur','587314',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22220,70,'Hosur','587207',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22221,70,'Hosur','587114',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22222,70,'Hulaginal','587112',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22223,70,'Hullikeri','587201',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22224,70,'Hulyal','587301',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22225,70,'Hungund Bazar','587118',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22226,70,'Hungund','587118',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22227,70,'Hunnur','587119',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22228,70,'Hunshikatti','587301',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22229,70,'Huvanur','587115',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22230,70,'Iddalgi','587112',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22231,70,'Ilal','587202',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22232,70,'Ilkal  Alampurpet','587154',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22233,70,'Ilkal  Town','587125',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22234,70,'Ilkal Gandhi Chowk.','587125',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22235,70,'Ilkal','587125',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22236,70,'Illal','587111',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22237,70,'Ingalagi','587313',1,0,'2022-03-03 12:30:02','2022-03-03 12:30:02'),(22238,70,'Jadramkunti','587111',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22239,70,'Jagadal','587311',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22240,70,'Jakanur','587201',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22241,70,'Jalgeri','587206',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22242,70,'Jalihal','587114',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22243,70,'Jalkamaladinni','587125',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22244,70,'Jambagi','587330',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22245,70,'Jamkhandi  B.S.R.','587301',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22246,70,'Jamkhandi  Chavadi','587301',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22247,70,'Jamkhandi Girishanagar','587301',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22248,70,'Jamkhandi H.O','587301',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22249,70,'Jammaldinni','587154',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22250,70,'Jammankatti','587205',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22251,70,'Janmatti','587116',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22252,70,'Jeergal','587313',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22253,70,'Kabbalgerii','587201',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22254,70,'Kadakol','587119',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22255,70,'Kadampur','587102',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22256,70,'Kadapatti','587119',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22257,70,'Kadarkoppa','587122',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22258,70,'Kadiwal','587125',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22259,70,'Kadiwal Kallapur','587120',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22260,70,'Kadlimatti','587111',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22261,70,'Kagalgomba','587205',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22262,70,'Kainkatti','587206',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22263,70,'Kajibilgi','587330',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22264,70,'Kakanur','587155',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22265,70,'Kalabilagi','587330',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22266,70,'Kaladgi  Bazar','587204',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22267,70,'Kaladgi','587204',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22268,70,'Kalahalli','587119',1,0,'2022-03-03 12:30:03','2022-03-03 12:30:03'),(22269,70,'Kamaldinni Village','587118',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22270,70,'Kamatgi','587120',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22271,70,'Kamblihal','587125',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22272,70,'Kandgal','587116',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22273,70,'Kandgal','587154',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22274,70,'Kankanwadi','587119',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22275,70,'Kannolli','587330',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22276,70,'Karadi','587125',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22277,70,'Kasabajambgi','587122',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22278,70,'Katageri','587205',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22279,70,'Katagur','587207',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22280,70,'Kataraki','587116',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22281,70,'Katarki','587201',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22282,70,'Kavatagi','587301',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22283,70,'Kelawadi','587205',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22284,70,'Kelur','587124',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22285,70,'Kerakalmatti','587206',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22286,70,'Kerur','587206',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22287,70,'Kesargoppa','587312',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22288,70,'Khajjidoni','587204',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22289,70,'Khyad','587201',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22290,70,'Kirsur','587111',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22291,70,'Kittali','587155',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22292,70,'Kodihal','587125',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22293,70,'Kolur','587301',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22294,70,'Konnur (Bagalkot)','587121',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22295,70,'Koppa','587116',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22296,70,'Kulahalli','587311',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22297,70,'Kulali','587113',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22298,70,'Kulgeri Cross','587155',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22299,70,'Kumbarhal','587301',1,0,'2022-03-03 12:30:04','2022-03-03 12:30:04'),(22300,70,'Kunchanur','587301',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22301,70,'Kundaragi','587116',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22302,70,'Kutkankeri','587203',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22303,70,'Lakhamapur','587201',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22304,70,'Layadgundi','587203',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22305,70,'Linganur','587301',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22306,70,'Lingapur','587116',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22307,70,'Lokapur','587122',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22308,70,'Machakanur','587313',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22309,70,'Madabhavi','587316',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22310,70,'Madarkhandi','587119',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22311,70,'Mahalingpur','587312',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22312,70,'Mahalingpur Town','587312',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22313,70,'Maigur','587119',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22314,70,'Malali','587113',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22315,70,'Malapur','587313',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22316,70,'Mallapur','587111',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22317,70,'Mamatgeri','587155',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22318,70,'Mangalgudda','587202',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22319,70,'Mannikeri','587116',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22320,70,'Mantur','587121',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22321,70,'Marapur','587316',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22322,70,'Mareguddi','587121',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22323,70,'Marol','587118',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22324,70,'Melligeri','587121',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22325,70,'Metgudd','587313',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22326,70,'Mirji','587313',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22327,70,'Moratageri','587154',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22328,70,'Muchakandi','587111',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22329,70,'Muddapur','587122',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22330,70,'Mudhol (Bagalkot)','587313',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22331,70,'Mudhol Extension','587313',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22332,70,'Mugalkhod','587113',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22333,70,'Mugalolli','587111',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22334,70,'Muganur','587120',1,0,'2022-03-03 12:30:05','2022-03-03 12:30:05'),(22335,70,'Mundagnur','587301',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22336,70,'Murdi','587202',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22337,70,'Murnal','587104',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22338,70,'Mushtigeri','587206',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22339,70,'Muttaldinni','587116',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22340,70,'Muttalgeri','587201',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22341,70,'Muttur','587119',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22342,70,'Naganur','587301',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22343,70,'Nagaral','587113',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22344,70,'Nagaral','587116',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22345,70,'Nagur','587118',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22346,70,'Nainegali','587207',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22347,70,'Nandgaon','587312',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22348,70,'Nandikeshwar','587201',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22349,70,'Nandwadgi','587125',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22350,70,'Narasapur','587155',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22351,70,'Narenur','587206',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22352,70,'Navalagi','587311',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22353,70,'Nilgund','587201',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22354,70,'Ningapur','587313',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22355,70,'Niralkeri','587111',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22356,70,'Niralkeri','587206',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22357,70,'Nirbudihal','587206',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22358,70,'Parvati','587203',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22359,70,'Pattadkal','587201',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22360,70,'Petlur','587122',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22361,70,'Rabkavi','587314',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22362,70,'Rabkavi Town','587314',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22363,70,'Radder Timmapur','587206',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22364,70,'Rakkasagi','587112',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22365,70,'Rampur','587314',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22366,70,'Rampur (Bagalkot)','587207',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22367,70,'Ramthal','587120',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22368,70,'Ramwadgi','587118',1,0,'2022-03-03 12:30:06','2022-03-03 12:30:06'),(22369,70,'Rolli','587116',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22370,70,'Rugi','587313',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22371,70,'Saidapur','587316',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22372,70,'Sameerwadi','587316',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22373,70,'Sangam','587115',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22374,70,'Sasalatti','587315',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22375,70,'Savalagi','587330',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22376,70,'Shigikeri','587111',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22377,70,'Shiraguppi','587116',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22378,70,'Shiraguppi','587119',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22379,70,'Shirbadagi','587201',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22380,70,'Shirol','587313',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22381,70,'Shirur','587120',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22382,70,'Shivayogmandir','587201',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22383,70,'Shurpali','587119',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22384,70,'Siddapur','587301',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22385,70,'Siddapur','587117',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22386,70,'Simikeri','587104',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22387,70,'Sokanadagi','587204',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22388,70,'Sonna','587116',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22389,70,'Sorakoppa','587102',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22390,70,'Sorgaon','587113',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22391,70,'Sulebhavi','587124',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22392,70,'Sulikeri','587205',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22393,70,'Sulla','587155',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22394,70,'Sunag','587116',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22395,70,'Surlikal','587120',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22396,70,'Sutagundar','587207',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22397,70,'Takkalki','587330',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22398,70,'Tallikeri','587124',1,0,'2022-03-03 12:30:07','2022-03-03 12:30:07'),(22399,70,'Tamadaddi','587315',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22400,70,'Teggi','587117',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22401,70,'Terdal  Bazar','587315',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22402,70,'Terdal','587315',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22403,70,'Timmapur','587118',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22404,70,'Todalbagi','587301',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22405,70,'Togunshi','587203',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22406,70,'Tolmatti','587116',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22407,70,'Tubachi','587119',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22408,70,'Tulsigeri','587204',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22409,70,'Tumba','587154',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22410,70,'Tummarmatti','587116',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22411,70,'Tungal','587330',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22412,70,'Udagatti','587204',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22413,70,'Ugalwat','587206',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22414,70,'Uttur','587313',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22415,70,'Vajjarmatti','587313',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22416,70,'Vantigodi','587313',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22417,70,'Varchagal','587122',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22418,70,'Wadageri','587202',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22419,70,'Yadahalli','587313',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22420,70,'Yadahalli','587117',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22421,70,'Yadhalli','587102',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22422,70,'Yallatti','587311',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22423,70,'Yandigeri','587206',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22424,70,'Yankanchi','587201',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22425,70,'Yaragoppa','587201',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22426,70,'Bidari (Jkd)','586125',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22427,70,'Bolachikkalki (JKD)','586125',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22428,70,'Chikkalki','586113',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22429,71,'A F Station Yelahanka','560063',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22430,71,'Agram','560007',1,0,'2022-03-03 12:30:08','2022-03-03 12:30:08'),(22431,71,'Air Force Hospital','560007',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22432,71,'Amruthahalli','560092',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22433,71,'Anandnagar (Bangalore)','560024',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22434,71,'Arabic College','560045',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22435,71,'Attur','560064',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22436,71,'Austin Town','560047',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22437,71,'Banaswadi','560043',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22438,71,'Bangalore Bazaar','560001',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22439,71,'Bangalore International Airport','560300',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22440,71,'Bangalore Sub Foreign Post','560025',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22441,71,'Bellandur','560103',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22442,71,'Benson Town','560046',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22443,71,'Bhattarahalli','560049',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22444,71,'Bidrahalli','560049',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22445,71,'BSF Campus Yelahanka','560063',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22446,71,'Byatarayanapura','560092',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22447,71,'C.V.Raman Nagar','560093',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22448,71,'CMM Court Complex','560001',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22449,71,'CMP Centre And School','560025',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22450,71,'CRPF Campus Yelahanka','560064',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22451,71,'Devanagundi','560067',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22452,71,'Devasandra','560036',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22453,71,'Doddagubbi','560077',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22454,71,'Doddanekkundi','560037',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22455,71,'Domlur','560071',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22456,71,'Doorvaninagar','560016',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22457,71,'Dr. Ambedkar Veedhi','560001',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22458,71,'Dr. Shivarama Karanth Nagar','560077',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22459,71,'EPIP','560066',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22460,71,'Fraser Town','560005',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22461,71,'G.K.V.K.','560065',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22462,71,'Gunjur','560087',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22463,71,'H.A. Farm','560024',1,0,'2022-03-03 12:30:09','2022-03-03 12:30:09'),(22464,71,'H.A.L II Stage H.O','560008',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22465,71,'H.K.P. Road','560051',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22466,71,'Hebbal Kempapura','560024',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22467,71,'HighCourt','560001',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22468,71,'Hoodi','560048',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22469,71,'Horamavu','560043',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22470,71,'Hulsur Bazaar','560008',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22471,71,'Indiranagar (Bangalore)','560038',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22472,71,'ISRO Anthariksha Bhavan','560094',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22473,71,'J.C.Nagar','560006',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22474,71,'Jakkur','560064',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22475,71,'Jalavayuvihar','560043',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22476,71,'Jeevanbhimanagar','560075',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22477,71,'Kadugodi Extention SO','560067',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22478,71,'Kadugodi','560067',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22479,71,'Kalyananagar','560043',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22480,71,'Kannamangala','560067',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22481,71,'Kodigehalli','560092',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22482,71,'Kothanur','560077',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22483,71,'Krishnarajapuram R S','560016',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22484,71,'Krishnarajapuram','560036',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22485,71,'Kundalahalli','560037',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22486,71,'Legislators Home','560001',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22487,71,'Lingarajapuram','560084',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22488,71,'Mahadevapura','560048',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22489,71,'Mahatma Gandhi Road','560001',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22490,71,'Marathahalli Colony','560037',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22491,71,'Maruthi Sevanagar','560033',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22492,71,'Medimallasandra','560067',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22493,71,'Mundur','560049',1,0,'2022-03-03 12:30:10','2022-03-03 12:30:10'),(22494,71,'Museum Road','560025',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22495,71,'Muthusandra','560087',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22496,71,'NAL','560017',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22497,71,'New Thippasandra','560075',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22498,71,'P&T Col. Kavalbyrasandra','560032',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22499,71,'Panathur','560103',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22500,71,'R T Nagar H.O','560032',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22501,71,'R.M.V. Extension II Stage','560094',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22502,71,'Rajanakunte','560064',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22503,71,'Rajbhavan (Bangalore)','560001',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22504,71,'Ramamurthy Nagar','560016',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22505,71,'Rameshnagar','560037',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22506,71,'Richmond Town','560025',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22507,71,'Sadashivanagar','560080',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22508,71,'Sahakaranagar P.O','560092',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22509,71,'Singanayakanahalli','560064',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22510,71,'Sivan Chetty Gardens','560042',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22511,71,'St. Thomas Town','560084',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22512,71,'Training Command IAF','560006',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22513,71,'Vartur','560087',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22514,71,'Vasanthanagar','560001',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22515,71,'Venkateshapura','560045',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22516,71,'Vidhana Soudha','560001',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22517,71,'Vimanapura','560017',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22518,71,'Virgonagar','560049',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22519,71,'Viveknagar (Bangalore)','560047',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22520,71,'Whitefield','560066',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22521,71,'Yelahanka','560064',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22522,71,'Yelahanka Satellite Town','560064',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22523,71,'Bangalore G.P.O.','560001',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22524,71,'Adugodi','560030',1,0,'2022-03-03 12:30:11','2022-03-03 12:30:11'),(22525,71,'Agara','560034',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22526,71,'Anjanapura','560108',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22527,71,'Ashoknagar (Bangalore)','560050',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22528,71,'B Sk II Stage','560070',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22529,71,'Banashankari III Stage','560085',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22530,71,'Banashankari','560050',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22531,71,'Bangalore Corporation Building','560002',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22532,71,'Bannerghatta Road','560076',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22533,71,'Bannerghatta','560083',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22534,71,'Basavanagudi H.O','560004',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22535,71,'Begur','560068',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22536,71,'Bnagalore Viswavidalaya','560056',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22537,71,'Bolare','560082',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22538,71,'Bommanahalli (Bangalore)','560068',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22539,71,'Bommasandra Industrial Estate','560099',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22540,71,'Carmelram','560035',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22541,71,'Chamrajpet (Bangalore)','560018',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22542,71,'Chandapura','560099',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22543,71,'Chandapura','560081',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22544,71,'Chickpet','560053',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22545,71,'Chikkalasandra','560061',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22546,71,'Chudenapura','560060',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22547,71,'Dasarahalli(Srinagar)','560050',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22548,71,'Deepanjalinagar','560026',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22549,71,'Dharmaram College','560029',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22550,71,'Doddakallasandra','560062',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22551,71,'Electronics City','560100',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22552,71,'Gaviopuram Extension','560019',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22553,71,'Girinagar (Bangalore)','560085',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22554,71,'Gottigere','560083',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22555,71,'Governmemnt Electric Factory','560026',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22556,71,'Haragadde','560105',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22557,71,'Hennagara','560105',1,0,'2022-03-03 12:30:12','2022-03-03 12:30:12'),(22558,71,'HSR Layout','560102',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22559,71,'Hulimangala','560105',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22560,71,'Hulimavu','560076',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22561,71,'Hulimavu','560076',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22562,71,'J P Nagar','560078',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22563,71,'Jayanagar H.O','560041',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22564,71,'Jayanagar West','560070',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22565,71,'Jayangar III Block','560011',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22566,71,'Jigani','560105',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22567,71,'JP Nagar III Phase','560078',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22568,71,'JP Nagar VIII phase','560076',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22569,71,'Kallubalu','560105',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22570,71,'Kathriguppe','560085',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22571,71,'Konanakunte','560062',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22572,71,'Koramangala I Block','560034',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22573,71,'Koramangala','560034',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22574,71,'Koramangala VI Bk','560095',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22575,71,'Kumaraswamy Layout','560078',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22576,71,'Kumbalagodu','560074',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22577,71,'Kumbalgodu Gollahalli','560074',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22578,71,'Madhavan Park','560011',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22579,71,'Madivala','560068',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22580,71,'Mallathahalli','560056',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22581,71,'Mavalli','560004',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22582,71,'Mico Layout','560076',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22583,71,'Mount St Joseph','560076',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22584,71,'Muthanallur','560099',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22585,71,'Nayandahalli','560039',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22586,71,'Padmanabhnagar','560070',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22587,71,'Pampamahakavi Road','560004',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22588,71,'Ragihalli','560083',1,0,'2022-03-03 12:30:13','2022-03-03 12:30:13'),(22589,71,'Rajarajeshwarinagar','560098',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22590,71,'Ramohalli','560074',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22591,71,'Rv Niketan','560059',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22592,71,'Sampangiramnagar','560027',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22593,71,'Shanthinagar','560027',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22594,71,'St. John\'s Medical College','560034',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22595,71,'State Bank Of Mysore Colony','560050',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22596,71,'Subramanyapura','560061',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22597,71,'Tavarekere','560029',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22598,71,'Thalaghattapura','560109',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22599,71,'Thataguni','560082',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22600,71,'Thyagarajnagar','560004',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22601,71,'Tilaknagar (Bangalore)','560041',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22602,71,'Tyagrajnagar','560070',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22603,71,'Ullalu Upanagar','560110',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22604,71,'Wilson Garden','560027',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22605,71,'Wipro Limited','560100',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22606,71,'Yelachenahalli','560078',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22607,71,'Bagalgunte','560073',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22608,71,'Bangalore City','560002',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22609,71,'Bangalore Dist Offices Bldg','560009',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22610,71,'Bapagrama','560091',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22611,71,'Basaveshwaranagar','560079',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22612,71,'Chandra Lay Out','560040',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22613,71,'Chikkabidarkal','560073',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22614,71,'Gayathrinagar','560021',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22615,71,'Hampinagar','560104',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22616,71,'Herohalli','560091',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22617,71,'Industrial Estate (Bangalore)','560010',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22618,71,'Jalahalli East','560014',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22619,71,'Jalahalli H.O','560013',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22620,71,'Jalahalli West','560015',1,0,'2022-03-03 12:30:14','2022-03-03 12:30:14'),(22621,71,'K H B Colony','560079',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22622,71,'K. G. Road','560009',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22623,71,'Kamakshipalya','560079',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22624,71,'Kodigehalli','560112',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22625,71,'Laggere','560058',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22626,71,'Magadi Road','560023',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22627,71,'Mahalakshmipuram Layout','560086',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22628,71,'Malleswaram','560003',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22629,71,'Malleswaram West','560055',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22630,71,'Mathikere','560054',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22631,71,'Msrit','560054',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22632,71,'Nagarbhavi','560072',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22633,71,'Nagasandra (Bangalore)','560073',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22634,71,'Nandinilayout','560096',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22635,71,'Nelakadiranahalli','560073',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22636,71,'Palace Guttahalli','560003',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22637,71,'Peenya Dasarahalli','560057',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22638,71,'Peenya I Stage','560058',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22639,71,'Peenya Small Industries','560058',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22640,71,'Rajajinagar H.O','560010',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22641,71,'Rajajinagar IVth Block','560010',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22642,71,'Science Institute','560012',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22643,71,'Seshadripuram','560020',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22644,71,'Sri Chowdeshwari','560054',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22645,71,'Srirampuram','560021',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22646,71,'Swimming Pool Extn','560003',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22647,71,'Tarabanahalli','560090',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22648,71,'Vidyaranyapura','560097',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22649,71,'Vijayanagar East','560040',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22650,71,'Vijayanagar (Bangalore)','560040',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22651,71,'Viswaneedam','560091',1,0,'2022-03-03 12:30:15','2022-03-03 12:30:15'),(22652,71,'Vyalikaval Extn','560003',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22653,71,'West of Chord Road II stage','560086',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22654,71,'Yeshwanthpur Bazar','560022',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22655,71,'Yeswanthpura','560022',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22656,71,'Anekal','562106',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22657,71,'Attibele','562107',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22658,71,'Avathi','562164',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22659,71,'Bagalur (Bangalore)','562149',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22660,71,'Bandikodigehalli','562149',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22661,71,'Bestamaranahalli','562106',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22662,71,'Bettahalsur','562157',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22663,71,'Bidaraguppe','562107',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22664,71,'Byagadadenahalli','562106',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22665,71,'Chamarajasagara','562120',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22666,71,'Chikkajala','562157',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22667,71,'Chikkanahalli','562130',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22668,71,'Chunchanakuppe','562130',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22669,71,'Dasanapura','562162',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22670,71,'Doddajala','562157',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22671,71,'Dommasandra','562125',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22672,71,'Guddanahalli','562106',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22673,71,'Handenahalli','562125',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22674,71,'Hunasamaranahalli','562157',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22675,71,'Indalavadi','562106',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22676,71,'Kadabagere','562130',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22677,71,'Kannur','562149',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22678,71,'Kugur','562125',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22679,71,'Madanayakanahalli','562162',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22680,71,'Marsur','562106',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22681,71,'Mayasandra','562107',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22682,71,'Neralur','562107',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22683,71,'Neriga','562125',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22684,71,'Samandur','562106',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22685,71,'Sarjapura','562125',1,0,'2022-03-03 12:30:16','2022-03-03 12:30:16'),(22686,71,'Sidihoskote','562106',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22687,71,'Tarahunise','562157',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22688,71,'Tavarekere (Bangalore)','562130',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22689,71,'Thammanayakanahalli','562106',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22690,71,'Vanakanahalli','562106',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22691,71,'Vidyanagara','562157',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22692,71,'Yadavanahalli','562107',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22693,72,'Kalkunte','560067',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22694,72,'Naduvathi','560067',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22695,72,'Samethanahalli','560067',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22696,72,'Huskur','560099',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22697,72,'Kagalipura','560082',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22698,72,'Kalkere','560083',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22699,72,'Kengeri','560060',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22700,72,'Sakalavara','560083',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22701,72,'Singasandra','560068',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22702,72,'Somanhalli','560082',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22703,72,'Sulikere','560060',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22704,72,'Taralu','560082',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22705,72,'Thattekuppe','560082',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22706,72,'Udaypura','560082',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22707,72,'Achitnagar','560107',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22708,72,'Byatha','560089',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22709,72,'Chikkabanavara','560090',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22710,72,'Hessarghatta Lake','560089',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22711,72,'Hessarghatta','560088',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22712,72,'Kakolu','560089',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22713,72,'Kodigehalli','560091',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22714,72,'Shivakote','560089',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22715,72,'Silvepura','560090',1,0,'2022-03-03 12:30:17','2022-03-03 12:30:17'),(22716,72,'Adarangi','561101',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22717,72,'Ajjanahalli','561201',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22718,72,'Alurduddanahalli','562110',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22719,72,'Aluru','562162',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22720,72,'Anneshwara','562110',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22721,72,'Antharahalli','561203',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22722,72,'Aradeshanahalli','562110',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22723,72,'Arakere','562163',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22724,72,'Arallumallige','561203',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22725,72,'Arasinakunte','562123',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22726,72,'Arebommnahalli','562111',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22727,72,'Arudi','561204',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22728,72,'Baginigere','562131',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22729,72,'Baktharahalli','561204',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22730,72,'Banavadi','562127',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22731,72,'Baragenahalli','562111',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22732,72,'Basettihalli','562163',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22733,72,'Begur','562122',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22734,72,'Bendiganahalli','562129',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22735,72,'Bettakote','562129',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22736,72,'Bidalur','562164',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22737,72,'Bijjawara','562164',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22738,72,'Billanakote','562111',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22739,72,'Biskur','562131',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22740,72,'Budigere','562129',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22741,72,'Budihal','562123',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22742,72,'Bylakere','562127',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22743,72,'Bylanarasapura','562122',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22744,72,'Channarayapatna','562135',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22745,72,'Devanahalli','562110',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22746,72,'Devarahosahalli','562111',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22747,72,'Dobbespet','562111',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22748,72,'Dodballapura Bazar','561203',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22749,72,'Dodballapura','561203',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22750,72,'Doddabelavangala','561204',1,0,'2022-03-03 12:30:18','2022-03-03 12:30:18'),(22751,72,'Doddabele','562132',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22752,72,'Doddagattiganabbe','562114',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22753,72,'Doddahejjaji','561204',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22754,72,'Doddamudigere','562131',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22755,72,'Doddanallala','562114',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22756,72,'Doddasanne','562110',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22757,72,'Doddasomanahalli','562131',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22758,72,'Doddatumkur','562163',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22759,72,'Gangonahalli','562131',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22760,72,'Gantiganahalli','561205',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22761,72,'Gollahalli','562123',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22762,72,'Gudemaranahalli','562127',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22763,72,'Gundamgere','561203',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22764,72,'Hadonahalli','561205',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22765,72,'Hanabe','561203',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22766,72,'Harohalli','562135',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22767,72,'Hasigala','562114',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22768,72,'Heggadahalli','561205',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22769,72,'Hegganahalli','562110',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22770,72,'Heggunda','562111',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22771,72,'Hindaganala','562122',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22772,72,'Honnasandra','562123',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22773,72,'Hosahalli','561203',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22774,72,'Hoskote Indl. Area','562114',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22775,72,'Hoskote','562114',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22776,72,'Hulikal','561101',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22777,72,'Hulikunte','561204',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22778,72,'Hullegowdanahalli','562162',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22779,72,'Hullenahalli','562131',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22780,72,'Huskur','562162',1,0,'2022-03-03 12:30:19','2022-03-03 12:30:19'),(22781,72,'Ibasapura','562129',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22782,72,'Jadigenahalli','562114',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22783,72,'Jakkanahalli','562123',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22784,72,'Jalige','562110',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22785,72,'Jodidasarahalli','562114',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22786,72,'K.Satyavara','562122',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22787,72,'Kadalappanahalli','561204',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22788,72,'Kadanur','561204',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22789,72,'Kambalu','562111',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22790,72,'Kanasavadi','561203',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22791,72,'Kannamangala','561203',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22792,72,'Kannamangala','562110',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22793,72,'Karahalli','562164',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22794,72,'Kattigenahalli','562114',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22795,72,'Kembliganahalli','562114',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22796,72,'Kithanahalli','562130',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22797,72,'Kodigehalli','561203',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22798,72,'Koira','562164',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22799,72,'Koligere','561204',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22800,72,'Kollalagatta','562132',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22801,72,'Kollathur','562114',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22802,72,'Kongadiyappa Road','561203',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22803,72,'Konnagatta','562163',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22804,72,'Korati','562122',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22805,72,'Kudur','561101',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22806,72,'Kuluvanahalli','562111',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22807,72,'Kumbalahalli','562114',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22808,72,'Kundana','562110',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22809,72,'Lakkenahalli','562127',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22810,72,'Lakkondanahalli','562114',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22811,72,'Lakkur','562111',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22812,72,'Lakshmipura','562162',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22813,72,'Madalakote','562123',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22814,72,'Madavara','562162',1,0,'2022-03-03 12:30:20','2022-03-03 12:30:20'),(22815,72,'Madigondanahalli','562127',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22816,72,'Mahadevapura','562123',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22817,72,'Makali','562162',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22818,72,'Mallarabanavadi','562123',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22819,72,'Mallathahalli','561203',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22820,72,'Mandibele','562135',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22821,72,'Mandigere','562123',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22822,72,'Manne','562132',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22823,72,'Manniganahalli','562127',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22824,72,'Maralakunte','562111',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22825,72,'Marasandra','561101',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22826,72,'Marikuppe','562127',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22827,72,'Mathahalli','562162',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22828,72,'Mayasandra','561101',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22829,72,'Melekote','561205',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22830,72,'Motagondanahalli','562127',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22831,72,'Mugabala','562114',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22832,72,'Mullahalli','562119',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22833,72,'Mylanahalli','562123',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22834,72,'NAGADENAHALLI','562163',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22835,72,'Nandagudi','562122',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22836,72,'Narasandra','562127',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22837,72,'Narasipura','562111',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22838,72,'Narayanapura','562135',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22839,72,'Nelamangala','562123',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22840,72,'Nelavagilu','562122',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22841,72,'Niduvanda','562132',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22842,72,'Obalapura','562132',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22843,72,'Purushanahalli','561204',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22844,72,'Rajaghatta','561203',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22845,72,'Rameshwara','561204',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22846,72,'Reddihalli','562129',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22847,72,'Sadahalli','562110',1,0,'2022-03-03 12:30:21','2022-03-03 12:30:21'),(22848,72,'Sakkaaregollahalli','561204',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22849,72,'Sankighatta','562131',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22850,72,'Sasalu','561204',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22851,72,'Shivagange','562111',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22852,72,'Shivanapura','562162',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22853,72,'Shivanapura','562122',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22854,72,'Shivapura','562163',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22855,72,'Sirigiripura','561101',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22856,72,'Soladevanahalli','562130',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22857,72,'Solur','562127',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22858,72,'Sondekoppa','562130',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22859,72,'Sri Subramanyaghati','561203',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22860,72,'Sugganahalli','561101',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22861,72,'Sulebele','562129',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22862,72,'Syakaladevanapura','561204',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22863,72,'Tavarekere','562122',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22864,72,'Teppadabeguru','562123',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22865,72,'Thippasandra','562131',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22866,72,'Tippur','561203',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22867,72,'Tubugere','561205',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22868,72,'Tyamagondlu','562132',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22869,72,'Udukunte','562127',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22870,72,'Uganavadi','562110',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22871,72,'Vagata Agrahara','562114',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22872,72,'Veerapura','562163',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22873,72,'Venkatagirikote','562164',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22874,72,'Vijayapaura','562135',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22875,72,'Vishwanathapura','562110',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22876,72,'Yelekyathanahalli','562111',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22877,72,'Yeliyur','562110',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22878,72,'Yennegere','562127',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22879,72,'Yentiganahalli','562123',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22880,73,'Achmatti','591110',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22881,73,'Agasage','591143',1,0,'2022-03-03 12:30:22','2022-03-03 12:30:22'),(22882,73,'Akkisagar','591129',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22883,73,'Alarwad','590020',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22884,73,'Aluminium Factory','590010',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22885,73,'Ambadgatti','591112',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22886,73,'Ambewadi','591108',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22887,73,'Amte','591345',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22888,73,'Amtur','591102',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22889,73,'Angol','590006',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22890,73,'Anigol','591102',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22891,73,'Ankalgi','591109',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22892,73,'Apmc Saundatti','591126',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22893,73,'Aralikatti','591109',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22894,73,'Aratgal','591117',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22895,73,'Ashte','590016',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22896,73,'Asundi','591126',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22897,73,'Avaradi','591115',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22898,73,'Avaradi','591127',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22899,73,'Avarolli','591131',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22900,73,'Badas Khalsa','591131',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22901,73,'Badli','591111',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22902,73,'Bailhongal Bazar','591102',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22903,73,'Bailhongal H.O','591102',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22904,73,'Bailhongal S.R. Chowk','591102',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22905,73,'Bailur','590018',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22906,73,'Bailur','591115',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22907,73,'Bailwad','591102',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22908,73,'Balekundri Kshetra','591103',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22909,73,'Balekundri','591103',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22910,73,'Bannur','591130',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22911,73,'Baragaon','591302',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22912,73,'Basarkod','591115',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22913,73,'Bastwad','590020',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22914,73,'Basvan Kudchi','591124',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22915,73,'Batakurki','591123',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22916,73,'Bekkinkeri','591128',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22917,73,'Bekwad','591120',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22918,73,'Belagundi','591108',1,0,'2022-03-03 12:30:23','2022-03-03 12:30:23'),(22919,73,'Belavatti','591108',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22920,73,'Belgaum Bus Stand','590016',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22921,73,'Belgaum Camp','590001',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22922,73,'Belgaum City','590001',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22923,73,'Belgaum College Road','590001',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22924,73,'Belgaum Doordarshan Nagar','590019',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22925,73,'Belgaum Fort','590016',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22926,73,'Belgaum H.O','590001',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22927,73,'Belgaum Kapileshwar Road','590001',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22928,73,'Belgaum Khasbag','590003',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22929,73,'Belgaum Kutchery','590001',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22930,73,'Belgaum M. Vadgaon','590005',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22931,73,'Belgaum MalMaruti Extension','590017',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22932,73,'Belgaum Nehru Nagar','590010',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22933,73,'Belgaum Records MLI','590009',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22934,73,'Belgaum Shahapur','590003',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22935,73,'Belgaum Shivaji Nagar','590016',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22936,73,'Belgaum Vishweswaraih Nagar','590001',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22937,73,'Belvadi','591104',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22938,73,'Benakanhalli','591108',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22939,73,'Benkatti','591117',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22940,73,'Betsur','591126',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22941,73,'Bhagyanagar (Belgaum)','590006',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22942,73,'Bhandarhalli','591117',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22943,73,'Bhavihal','591125',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22944,73,'Bhendigeri','591109',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22945,73,'Bhutaramanahatti','591156',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22946,73,'Bidi','591106',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22947,73,'Bijagarni','591108',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22948,73,'Bijaguppi','591130',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22949,73,'Bogur','591112',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22950,73,'Bombarge','591143',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22951,73,'Budarkatti','591104',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22952,73,'Budihal','591104',1,0,'2022-03-03 12:30:24','2022-03-03 12:30:24'),(22953,73,'Buranaki','591106',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22954,73,'Chachadi','591102',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22955,73,'Chandargi','591114',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22956,73,'Channapur','591123',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22957,73,'Chapagaon','591120',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22958,73,'Chidambar Nagar Saundatti','591126',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22959,73,'Chikahattiholi','591131',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22960,73,'Chikbagewadi','591109',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22961,73,'Chikkop','591119',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22962,73,'Chikkumbi','591110',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22963,73,'Chikmanoli','591112',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22964,73,'Chilmur','591130',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22965,73,'Chipalkatti','591130',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22966,73,'Chulaki','591110',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22967,73,'Chunchnur','591114',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22968,73,'Dastikop','591153',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22969,73,'Degaon','591115',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22970,73,'Deshnur','591147',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22971,73,'Desur','590014',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22972,73,'Devalapur','591102',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22973,73,'Devalatti','591131',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22974,73,'Devara Shigihalli','591153',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22975,73,'Devarai','591301',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22976,73,'Dhaderkoppa','591110',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22977,73,'Dhamne','590005',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22978,73,'Dharnatti','590016',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22979,73,'Dodwad','591104',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22980,73,'Gajminhal','591121',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22981,73,'Gandigwad','591112',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22982,73,'Garalgunji','591302',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22983,73,'Ghataknur','591123',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22984,73,'Giriyal','591109',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22985,73,'Godachi','591114',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22986,73,'Goddikurvinkoppa','591109',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22987,73,'Godholi','591301',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22988,73,'Gojage','591128',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22989,73,'Golyali','591345',1,0,'2022-03-03 12:30:25','2022-03-03 12:30:25'),(22990,73,'Gonnagar','591127',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(22991,73,'Goravankolla','591116',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(22992,73,'Gorbal','591126',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(22993,73,'Govankop','591104',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(22994,73,'Gunji','591302',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(22995,73,'Halagatti','591123',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(22996,73,'Halasal','591120',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(22997,73,'Halashi','591120',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(22998,73,'Haletorgal','591123',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(22999,73,'Halga','590020',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(23000,73,'Halga','591120',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(23001,73,'Hanabaratti','591121',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(23002,73,'Hanamgeri','591126',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(23003,73,'Hanchinal','591110',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(23004,73,'Handignur','591143',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(23005,73,'Hannikeri','591102',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(23006,73,'Harugoppa','591102',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(23007,73,'Hebbal','591120',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(23008,73,'Hindalga','591108',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(23009,73,'Hindawadi','590011',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(23010,73,'Hirebagewadi','591109',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(23011,73,'Hirebellikatti','591104',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(23012,73,'Hirebudnur','591119',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(23013,73,'Hirehattiholi','591131',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(23014,73,'Hirekop','591114',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(23015,73,'Hirekumbi','591110',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(23016,73,'Hiremanoli','591112',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(23017,73,'Hirenandihalli','591115',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(23018,73,'Hireulligeri','591126',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(23019,73,'Holehosur','591118',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(23020,73,'Holenaglapur','591153',1,0,'2022-03-03 12:30:26','2022-03-03 12:30:26'),(23021,73,'Honaga','591156',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23022,73,'Hooli','591126',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23023,73,'Hoolikatti (KTR)','591112',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23024,73,'Hoolikatti','591126',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23025,73,'Horalkatti','591126',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23026,73,'Hosavantmuri','591156',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23027,73,'Hoskoti','591130',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23028,73,'Hosur (Belgaum)','591111',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23029,73,'Hudli','591346',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23030,73,'Hulkund','591114',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23031,73,'Hunshikatti','591153',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23032,73,'Idalahonda','591302',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23033,73,'Idgal','591123',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23034,73,'Inamhongal','591126',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23035,73,'Inchal','591102',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23036,73,'Ingalgi','591111',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23037,73,'Itagi','591112',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23038,73,'Jakabal','591117',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23039,73,'Jamboti','591345',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23040,73,'K.K.Koppa','591109',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23041,73,'Kadabi','591129',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23042,73,'Kadoli','591143',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23043,73,'Kadrolli','591153',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23044,73,'Kagdhal','591126',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23045,73,'Kailasnagar','590010',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23046,73,'Kakati','591113',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23047,73,'Kakkeri','591106',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23048,73,'Kalbhavi','591115',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23049,73,'Kalhal','591127',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23050,73,'Kallehal','591128',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23051,73,'Kalmad','591123',1,0,'2022-03-03 12:30:27','2022-03-03 12:30:27'),(23052,73,'Kanabargi','590015',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23053,73,'Kanakumbi','591345',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23054,73,'Kangali KH','590010',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23055,73,'Kangrali BK','590010',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23056,73,'Kapoli','591120',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23057,73,'Karadiguddi','591103',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23058,73,'Karalga','591120',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23059,73,'Karalkatti','591111',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23060,73,'Karambal','591302',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23061,73,'Karikatti','591126',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23062,73,'Karvinkumpi','590016',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23063,73,'Kasaba Nandgad','591120',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23064,73,'Katkol','591114',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23065,73,'Kednur','591143',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23066,73,'Kenganur','591104',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23067,73,'Khanagaon','590016',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23068,73,'Khanapur (Belgaum)','591302',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23069,73,'Khanapur Town','591302',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23070,73,'Khudanpur','591104',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23071,73,'Kinaye','590018',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23072,73,'Kittur (SDT)','591127',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23073,73,'Kittur Channamma School','591115',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23074,73,'Kittur','591115',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23075,73,'Kittur Somwarpeth','591115',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23076,73,'Kodachwad','591131',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23077,73,'Kodliwad','591129',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23078,73,'Kudarimani','591128',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23079,73,'Kukdolli','591131',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23080,73,'Kullur','591130',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23081,73,'Kulvalli','591115',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23082,73,'Kunnal','591114',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23083,73,'Kurihal','591143',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23084,73,'Lakkundi','591102',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23085,73,'Linganmath','591106',1,0,'2022-03-03 12:30:28','2022-03-03 12:30:28'),(23086,73,'Lokali','591302',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23087,73,'Londa','591301',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23088,73,'M Timmapur','591123',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23089,73,'M.K.Hubli S.F.','591153',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23090,73,'M.K.Hubli','591118',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23091,73,'Machhe','590014',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23092,73,'Madamgeri','591129',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23093,73,'Madanbhavi','591121',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23094,73,'Madlur','591117',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23095,73,'Majagaon','590008',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23096,73,'Mallur','591111',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23097,73,'Mandoli','590008',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23098,73,'Mangyankop','591106',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23099,73,'Manoli','591117',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23100,73,'Manturge','591302',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23101,73,'Mardinagalapur','591125',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23102,73,'Margankop','591112',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23103,73,'Marihal','591103',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23104,73,'Marikatti','591125',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23105,73,'Markumbi','591119',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23106,73,'Mastamardi','590020',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23107,73,'Mattikoppa','591147',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23108,73,'Mavinkatti','591103',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23109,73,'Modge','591103',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23110,73,'Muchandi','590016',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23111,73,'Mudenur','591123',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23112,73,'Mudkavi','591123',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23113,73,'Mugalihal','591129',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23114,73,'Mugalihal','591106',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23115,73,'Mugbasav','591104',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23116,73,'Mullur','591126',1,0,'2022-03-03 12:30:29','2022-03-03 12:30:29'),(23117,73,'Murgod','591119',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23118,73,'Murkibhavi','591121',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23119,73,'Mutage','591124',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23120,73,'Mutnal','591109',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23121,73,'Mutwad','591121',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23122,73,'Myakalmardi','591121',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23123,73,'Nagaragali','591301',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23124,73,'Nagnur','591102',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23125,73,'Nandgad','591120',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23126,73,'Nandihal','591123',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23127,73,'Nandihalli','590014',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23128,73,'Nanjankodal','591120',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23129,73,'Narasapur','591130',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23130,73,'Navage','590018',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23131,73,'Navalgatti','591125',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23132,73,'Naviluteertha','591116',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23133,73,'Nayanagar','591102',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23134,73,'Neginhal','591102',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23135,73,'Nekarpeth Ramdurg','591123',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23136,73,'Nerse','591302',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23137,73,'Nesargi','591121',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23138,73,'Nichanki','591115',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23139,73,'Nilaji','591124',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23140,73,'Nilwade','591302',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23141,73,'Nittur','591302',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23142,73,'Nugganatti','591119',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23143,73,'Oblapur','591123',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23144,73,'Olmani','591345',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23145,73,'Pariswad','591131',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23146,73,'Parwad','591345',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23147,73,'Pattihal','591104',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23148,73,'Peeranwadi','590014',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23149,73,'Rainapur','591129',1,0,'2022-03-03 12:30:30','2022-03-03 12:30:30'),(23150,73,'Rakasakoppa','591108',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23151,73,'Ramdurg H.O','591123',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23152,73,'Ramdurg Town','591123',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23153,73,'Ramgurwadi','591302',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23154,73,'Ranichannamma Nagar','590006',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23155,73,'Rudrapur','591119',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23156,73,'Salahalli','591130',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23157,73,'Salapur','591123',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23158,73,'Sambra','591124',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23159,73,'Sampgaon','591125',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23160,73,'Sangal','591127',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23161,73,'Sangolli','591115',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23162,73,'Sangreshkop','591126',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23163,73,'Santibastwad','590018',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23164,73,'Sattigeri','591129',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23165,73,'Saundatti','591126',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23166,73,'Shindogi','591117',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23167,73,'Shindolli','591302',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23168,73,'Shiroli','591302',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23169,73,'Shivapur','591129',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23170,73,'Sidnal','591114',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23171,73,'Sindholi','591124',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23172,73,'Sirsangi','591126',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23173,73,'Soppadla','591129',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23174,73,'Sri Kshetra Kengeri','591119',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23175,73,'Sri Kshetra Sogal','591111',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23176,73,'Sulage','591108',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23177,73,'Sulebhavi','591103',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23178,73,'Sulge ( Yellur)','590005',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23179,73,'Sunnal','591123',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23180,73,'Sureban','591127',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23181,73,'Surpur Kerwad','591106',1,0,'2022-03-03 12:30:31','2022-03-03 12:30:31'),(23182,73,'Sutagatti (SDT)','591126',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23183,73,'Sutgatti','591147',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23184,73,'Suvarna Soudha Belgaum','590020',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23185,73,'Tadsalur','591119',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23186,73,'Tallur','591117',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23187,73,'Tarihal','590020',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23188,73,'Tavaragatti','591301',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23189,73,'Tegghal','591117',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23190,73,'Tigadi','591125',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23191,73,'Tigadolli','591115',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23192,73,'Tilakwadi','590006',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23193,73,'Tolgi','591112',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23194,73,'Tondikatti','591130',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23195,73,'Topinkatti','591302',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23196,73,'Torangatti','591114',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23197,73,'Torgal','591114',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23198,73,'Tummarguddi','590016',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23199,73,'Turamari','591128',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23200,73,'Turkarshigihalli','591115',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23201,73,'Turmuri','591153',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23202,73,'Uchgaon','591128',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23203,73,'Udikeri','591104',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23204,73,'Udpudi','591130',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23205,73,'Udyambag','590008',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23206,73,'Ugargol','591110',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23207,73,'Ugarkhod','591115',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23208,73,'Umtar','591123',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23209,73,'Vakkund','591102',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23210,73,'Vannur','591121',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23211,73,'Vantmuri Colony Belgaum S. O','590017',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23212,73,'Veerapur','591118',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23213,73,'Vijayanagar','591108',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23214,73,'VTU Campus Belgaum','590018',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23215,73,'Wagawade RC','590014',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23216,73,'Yakkundi','591111',1,0,'2022-03-03 12:30:32','2022-03-03 12:30:32'),(23217,73,'Yallammahill','591173',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23218,73,'Yardal','591102',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23219,73,'Yargatti','591129',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23220,73,'Yarzarvi','591119',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23221,73,'Yellur','590005',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23222,73,'Abbihal','591304',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23223,73,'Adhalli','591248',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23224,73,'Adi','591215',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23225,73,'Aigali','591248',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23226,73,'Ainapur','591303',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23227,73,'Ajur','591212',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23228,73,'Akol','591211',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23229,73,'Alagwadi','591317',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23230,73,'Alaknur','591220',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23231,73,'Anantpur','591212',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23232,73,'Ankali','591213',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23233,73,'Appachiwadi','591241',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23234,73,'Aralihatti','591232',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23235,73,'Arjunnagar','591237',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23236,73,'Artal','591248',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23237,73,'Athani Bazar','591304',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23238,73,'Athani H.O','591304',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23239,73,'Awarkhod','591304',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23240,73,'Badchi','591230',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23241,73,'Badgi','591248',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23242,73,'Balligeri','591212',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23243,73,'Balwad','591304',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23244,73,'Bambalwad','591226',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23245,73,'Bannur','591265',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23246,73,'Barwad','591263',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23247,73,'Bastwad','591317',1,0,'2022-03-03 12:30:33','2022-03-03 12:30:33'),(23248,73,'Bedkihal','591214',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23249,73,'Bekkeri','591317',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23250,73,'Belkud','591222',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23251,73,'Benadi','591215',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23252,73,'Bevanur','591212',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23253,73,'Bhendwad','591222',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23254,73,'Bhiradi','591217',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23255,73,'Bhivashi','591241',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23256,73,'Bhoj','591263',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23257,73,'Borgaon (Belgaum)','591216',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23258,73,'Budihal','591317',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23259,73,'Byakud','591317',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23260,73,'Chamakeri','591248',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23261,73,'Chandur','591213',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23262,73,'Chikalwal','591237',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23263,73,'Chikodi Bazar','591201',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23264,73,'Chikodi College Road','591201',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23265,73,'Chikodi Extension','591201',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23266,73,'Chikodi H.O','591201',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23267,73,'Chikodi Road','591222',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23268,73,'Chikodi Sugar Factory','591247',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23269,73,'Chinchali','591217',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23270,73,'Chinchani','591287',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23271,73,'Darur','591304',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23272,73,'Desairhatti','591230',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23273,73,'Dhonewadi','591263',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23274,73,'Dhulaganwadi','591238',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23275,73,'Faridkhanwadi','591316',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23276,73,'Galataga','591219',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23277,73,'Ghatnatti','591304',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23278,73,'Gondikuppi','591237',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23279,73,'Gundewadi','591304',1,0,'2022-03-03 12:30:34','2022-03-03 12:30:34'),(23280,73,'Gundwad','591311',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23281,73,'Hadnal','591241',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23282,73,'Halhalli','591265',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23283,73,'Hallihal','591304',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23284,73,'Hanamapur','591232',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23285,73,'Hanchinal K.S.','591229',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23286,73,'Handigund','591235',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23287,73,'Harugeri','591220',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23288,73,'Hattarwat','591226',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23289,73,'Hidkal','591220',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23290,73,'Hirekudi','591247',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23291,73,'Hulagbali','591304',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23292,73,'Hunnargi','591215',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23293,73,'Ingalgaon','591304',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23294,73,'Ingali','591242',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23295,73,'Itnal','591235',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23296,73,'Jainapur','591226',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23297,73,'Jakkarhatti','591232',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23298,73,'Jalalpur','591317',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23299,73,'Jambagi','591232',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23300,73,'Janwad','591240',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23301,73,'Janwad','591216',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23302,73,'Jatrat','591237',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23303,73,'Jodkurli','591213',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23304,73,'Jugul','591242',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23305,73,'Kabbur','591222',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23306,73,'Kadapur','591247',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23307,73,'Kagvad','591223',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23308,73,'Kakmari','591265',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23309,73,'Kallol','591244',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23310,73,'Kankanwadi','591222',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23311,73,'Kannal','591265',1,0,'2022-03-03 12:30:35','2022-03-03 12:30:35'),(23312,73,'Kappalguddi','591235',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23313,73,'Karadaga','591263',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23314,73,'Karagaon','591226',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23315,73,'Karoshi','591226',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23316,73,'Katakbhavi','591222',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23317,73,'Katgeri','591304',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23318,73,'Katral','591303',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23319,73,'Kempwad','591234',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23320,73,'Kerur','591213',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23321,73,'Khadaklat','591228',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23322,73,'Khanadal','591235',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23323,73,'Khavtkoppa','591220',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23324,73,'Khemalapur','591311',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23325,73,'Khilegaon','591212',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23326,73,'Kirangi','591212',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23327,73,'Kodaganur','591304',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23328,73,'Kodni','591237',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23329,73,'Kognoli','591229',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23330,73,'Kohalli','591248',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23331,73,'Kokatnur','591230',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23332,73,'Koligudda','591220',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23333,73,'Kothali','591287',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23334,73,'Kottalgi','591265',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23335,73,'Krishna Kittur','591303',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23336,73,'Kudchi','591311',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23337,73,'Kudchi Town','591311',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23338,73,'Kunnur','591215',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23339,73,'Kurli','591241',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23340,73,'Kusnal','591316',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23341,73,'Kuthali','591287',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23342,73,'Lakhanapur','591211',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23343,73,'Lokur','591234',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23344,73,'Madbhavi','591232',1,0,'2022-03-03 12:30:36','2022-03-03 12:30:36'),(23345,73,'Mahishwadgi','591240',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23346,73,'Malabad','591212',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23347,73,'Malikwad','591244',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23348,73,'Mamadapur K L','591211',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23349,73,'Mangavati','591242',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23350,73,'Mangsuli','591234',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23351,73,'Mangur','591215',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23352,73,'Manjari','591213',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23353,73,'Mankapur','591216',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23354,73,'Mantur','591222',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23355,73,'Masarguppi','591232',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23356,73,'Mattiwade','591229',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23357,73,'Mavinhunda','591317',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23358,73,'Mekhali','591317',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23359,73,'Mole','591303',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23360,73,'Molwad','591316',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23361,73,'Morab','591317',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23362,73,'Mugali','591226',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23363,73,'Mugalkhod','591235',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23364,73,'Murgundi','591304',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23365,73,'Nagarmunoli','591222',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23366,73,'Nagnur  P.K.','591240',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23367,73,'Nagnur','591241',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23368,73,'Nagral','591247',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23369,73,'Nainglaj','591238',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23370,73,'Nanadi','591244',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23371,73,'Nandeshwar','591240',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23372,73,'Nandgaon','591304',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23373,73,'Nandikurli','591317',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23374,73,'Nasalapur','591213',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23375,73,'Navalihal','591234',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23376,73,'Navalihal','591287',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23377,73,'Nej','591239',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23378,73,'New Diggewadi','591317',1,0,'2022-03-03 12:30:37','2022-03-03 12:30:37'),(23379,73,'Nidagundi','591317',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23380,73,'Nilaji','591217',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23381,73,'Nipani Bazar','591237',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23382,73,'Nipani Malbag','591237',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23383,73,'Nipani Nehru Chowk','591237',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23384,73,'Nipani','591237',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23385,73,'Nipnal','591222',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23386,73,'Padlihal','591211',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23387,73,'Palbhavi','591235',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23388,73,'Pangire (A)','591211',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23389,73,'Pangire (B)','591237',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23390,73,'Parmanandwadi','591311',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23391,73,'Parthanhalli','591304',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23392,73,'Pattankudi','591238',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23393,73,'Phadatarwadi','591248',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23394,73,'Radderhatti','591240',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23395,73,'Raibag R.S.','591317',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23396,73,'Raibag','591317',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23397,73,'Raibag Vidyalaya','591317',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23398,73,'Rampur','591237',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23399,73,'Ramtirth','591265',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23400,73,'Sadalga','591239',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23401,73,'Sambargi','591232',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23402,73,'Sankanwadi','591228',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23403,73,'Sankonahatti','591304',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23404,73,'Sankratti','591220',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23405,73,'Saptasagar','591304',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23406,73,'Satti','591240',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23407,73,'Saundalga','591241',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23408,73,'Saundatti','591213',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23409,73,'Saunsuddi','591235',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23410,73,'Savadi','591240',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23411,73,'Shamanewadi','591214',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23412,73,'Shedbal R.S.','591315',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23413,73,'Shedbal','591315',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23414,73,'Shegunshi','591220',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23415,73,'Shendur','591237',1,0,'2022-03-03 12:30:38','2022-03-03 12:30:38'),(23416,73,'Shiradwad','591214',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23417,73,'Shirgaon','591214',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23418,73,'Shirguppi','591237',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23419,73,'Shirguppi','591242',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23420,73,'Shirgur','591311',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23421,73,'Shirhatti','591304',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23422,73,'Shirur','591212',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23423,73,'Shivanur','591232',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23424,73,'Shivayoginagar','591304',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23425,73,'Siddapurwadi','591213',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23426,73,'Siddewadi','591232',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23427,73,'Sidnal','591211',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23428,73,'Sulgaon','591229',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23429,73,'Sultanpur','591235',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23430,73,'Suttatti','591230',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23431,73,'Suttatti','591217',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23432,73,'Tangadi','591303',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23433,73,'Tavandi','591237',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23434,73,'Tavashi','591212',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23435,73,'Telsang','591265',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23436,73,'Tirth','591304',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23437,73,'Ugarbudruk','591316',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23438,73,'Ugarkhurd','591316',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23439,73,'Ugarkhurd Town','591316',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23440,73,'Umarani','591222',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23441,73,'Vadral','591226',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23442,73,'Vijaynagar','591222',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23443,73,'Vishnuwadi','591232',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23444,73,'Walki','591238',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23445,73,'Yabaratti','591220',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23446,73,'Yadrav','591317',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23447,73,'Yadur','591213',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23448,73,'Yaksamba','591244',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23449,73,'Yamagarni','591241',1,0,'2022-03-03 12:30:39','2022-03-03 12:30:39'),(23450,73,'Yelihadalgi','591248',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23451,73,'Yelparhatti','591311',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23452,73,'Zunzurwad','591230',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23453,73,'Akkatangerhal','591101',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23454,73,'Akkiwat','591225',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23455,73,'Ammanagi','591236',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23456,73,'Amminbhavi','591236',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23457,73,'Ankalgi','591101',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23458,73,'Ankle','591313',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23459,73,'Arabhavifarm','591218',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23460,73,'Arabhavimath','591218',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23461,73,'Arjunwad','591309',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23462,73,'Avaradi','591310',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23463,73,'Avargol','591309',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23464,73,'Bad','591225',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23465,73,'Badakundri','591221',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23466,73,'Badigwad','591306',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23467,73,'Basapur','591122',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23468,73,'Bastwad','591309',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23469,73,'Beerangaddi','591218',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23470,73,'Bellad Bagewadi','591305',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23471,73,'Belvi(Bellumbi)','591309',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23472,73,'Benchinmardi','591344',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23473,73,'Beniwad','591309',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23474,73,'Berranholi','591243',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23475,73,'Betageri','591233',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23476,73,'Bhairnatti','591310',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23477,73,'Bhartesh Gurukul','591305',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23478,73,'Borgal','591236',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23479,73,'Bugatealur','591313',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23480,73,'Chiknandi','591233',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23481,73,'Daddi','591254',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23482,73,'Dharmatti','591312',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23483,73,'Dhavaleshwar','591310',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23484,73,'Dhupdal','591306',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23485,73,'Duradundi','591218',1,0,'2022-03-03 12:30:40','2022-03-03 12:30:40'),(23486,73,'Fulgaddi','591224',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23487,73,'Ghataprabha RS','591306',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23488,73,'Ghataprabha SF','591218',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23489,73,'Ghodgeri','591107',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23490,73,'Gokak College Road','591307',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23491,73,'Gokak Falls','591308',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23492,73,'Gokak Fort','591307',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23493,73,'Gokak Guruwarpeth','591307',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23494,73,'Gokak H.O','591307',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23495,73,'Gosbal','591227',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23496,73,'Gubalgudda','591306',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23497,73,'Gudas','591306',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23498,73,'Gurlapur','591312',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23499,73,'Gutagaddi','591243',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23500,73,'Hadalga','591313',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23501,73,'Hadiginal','591218',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23502,73,'Hallur','591312',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23503,73,'Hanchinal','591243',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23504,73,'Haragapur','591313',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23505,73,'Hattialur','591107',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23506,73,'Hebbal','591221',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23507,73,'Hidkal Dam','591107',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23508,73,'Hitni','591225',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23509,73,'Honakuppi','591227',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23510,73,'Hukeri Bazar','591309',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23511,73,'Hukeri Kutchery Road','591309',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23512,73,'Hukeri','591309',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23513,73,'Hulloli','591305',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23514,73,'Hunshyal P.G. Cross','591224',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23515,73,'Hunshyal P.Y','591310',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23516,73,'Hunshyal PG','591224',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23517,73,'Islampur','591243',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23518,73,'Jaganur','591305',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23519,73,'Kaitnal','591344',1,0,'2022-03-03 12:30:41','2022-03-03 12:30:41'),(23520,73,'Kalliguddi','591227',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23521,73,'Kalloli','591224',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23522,73,'Kamaldinni','591312',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23523,73,'Kamatnur','591340',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23524,73,'Kanagala (Belgaum)','591225',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23525,73,'Karaguppi','591122',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23526,73,'Karnataka Health Institute','591306',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23527,73,'Kaujalgi','591227',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23528,73,'Kemmankol','591233',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23529,73,'Keshappanatti','591344',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23530,73,'Kesti','591236',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23531,73,'Khanatti','591312',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23532,73,'Khandratti','591233',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23533,73,'Khangaon','591344',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23534,73,'Kochari','591340',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23535,73,'Kolvi','591344',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23536,73,'Koninkeri','591225',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23537,73,'Konnur (Belgaum)','591231',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23538,73,'Kot','591254',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23539,73,'Kotabagi','591306',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23540,73,'Kulgod','591310',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23541,73,'Kundargi','591122',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23542,73,'Kurni','591221',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23543,73,'Lolsur','591218',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23544,73,'Madihali','591309',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23545,73,'Madwal','591101',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23546,73,'Makkalgeri','591344',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23547,73,'Maldinni','591233',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23548,73,'Mallapur KA','591101',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23549,73,'Mamadapur','591233',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23550,73,'Managutti','591243',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23551,73,'Mannikeri','591227',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23552,73,'Maradimath','591231',1,0,'2022-03-03 12:30:42','2022-03-03 12:30:42'),(23553,73,'Market Yard','591307',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23554,73,'Masaguppi','591312',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23555,73,'Mattiwade','591225',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23556,73,'Mavanur','591122',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23557,73,'Melmanhatti','591231',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23558,73,'Melvanki','591218',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23559,73,'Mudalgi','591312',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23560,73,'Munyal','591312',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23561,73,'Naganur','591224',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23562,73,'Naganur KM','591254',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23563,73,'Nallanatti','591218',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23564,73,'Nandgaon','591231',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23565,73,'Narasinghpur','591243',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23566,73,'Nerli','591340',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23567,73,'Nidasoshi','591236',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23568,73,'Nirwanhatti','591107',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23569,73,'Pachhapur','591122',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23570,73,'Pamaldinni','591306',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23571,73,'Patagundi','591312',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23572,73,'Rajapur','591224',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23573,73,'Rashing','591313',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23574,73,'Salamwadi','591254',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23575,73,'Sangankeri','591224',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23576,73,'Sankeshwar Bazar','591313',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23577,73,'Sankeshwar College Road','591313',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23578,73,'Sankeshwar Market Yard','591313',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23579,73,'Sankeshwar','591313',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23580,73,'Sankeshwar Subhas Circle','591313',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23581,73,'Sankeshwar Sugar Factory','591314',1,0,'2022-03-03 12:30:43','2022-03-03 12:30:43'),(23582,73,'Sarapur','591305',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23583,73,'Shiltibhavi','591344',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23584,73,'Shindikurbet','591306',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23585,73,'Shippur','591225',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23586,73,'Shirgaon','591309',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23587,73,'Shirhatti','591305',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23588,73,'Shivapur H','591312',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23589,73,'Shivapur K','591231',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23590,73,'Solapur','591313',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23591,73,'Suldhal','591101',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23592,73,'Sultanpur','591309',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23593,73,'Sunadholi','591310',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23594,73,'Sutagatti','591243',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23595,73,'Talakatnal','591233',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23596,73,'Tavag','591101',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23597,73,'Thana Hattargi','591243',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23598,73,'Tigadi','591227',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23599,73,'Tukkanatti','591224',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23600,73,'Ullagaddi Khanapur','591221',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23601,73,'Urabinatti','591122',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23602,73,'Venkatapur','591310',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23603,73,'Waderhatti','591224',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23604,73,'Yadgud','591309',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23605,73,'Yadwad','591136',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23606,73,'Yamakanmardi','591246',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23607,73,'Yaragudri','591136',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23608,73,'Yarnal','591221',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23609,73,'Yelimanoli','591309',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23610,73,'Zangatihal','591306',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23611,74,'Agasanur','583114',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23612,74,'Agrahara','583128',1,0,'2022-03-03 12:30:44','2022-03-03 12:30:44'),(23613,74,'Agricultural Research Centre','583121',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23614,74,'Alabur','583220',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23615,74,'Allipur','583104',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23616,74,'Alur Kudligi','583218',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23617,74,'Amalapura','583135',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23618,74,'Amaradevaragudda','583135',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23619,74,'Amaravathi','583211',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23620,74,'Ambli','583134',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23621,74,'Ananthashayanagudi','583201',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23622,74,'Anekal','583212',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23623,74,'Ankasamudra','583212',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23624,74,'Anthapura','583115',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23625,74,'Appayyanahalli','583130',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23626,74,'Arliganur','583122',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23627,74,'Asundi','583103',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23628,74,'B Belagal','583115',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23629,74,'Bachigondanahalli','583212',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23630,74,'Badanahatti','583116',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23631,74,'Badeladuku','583135',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23632,74,'Bagewadi','583121',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23633,74,'Bailtumbaraguddi','583218',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23634,74,'Balakundi','583122',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23635,74,'Bandihatti','583102',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23636,74,'Bandrahalu','583121',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23637,74,'Bandri','583124',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23638,74,'Bannigola','583224',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23639,74,'Bannikallu','583214',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23640,74,'Banvikal','583126',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23641,74,'Basarahalli','583114',1,0,'2022-03-03 12:30:45','2022-03-03 12:30:45'),(23642,74,'Basarakodu','583224',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23643,74,'Basarakodu','583117',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23644,74,'Beerabbi','583216',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23645,74,'Beeravalli','583114',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23646,74,'Belachinta','583117',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23647,74,'Bellary Brucepettah','583101',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23648,74,'Bellary Cantonment','583104',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23649,74,'Bellary City','583101',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23650,74,'Bellary Cowl Bazar','583102',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23651,74,'Bellary District Court','583101',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23652,74,'Bellary Gandhinagar','583103',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23653,74,'Bellary H.O','583101',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23654,74,'Bellary Herialukadam','583101',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23655,74,'Bellary Jnanasagara','583105',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23656,74,'Bellary M V Nagar','583103',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23657,74,'Bellary Parvathi Nagar','583103',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23658,74,'Bellary Patel Nagar','583101',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23659,74,'Bellary Satyanarayanapet','583101',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23660,74,'Bellary Thermal Power Station','583152',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23661,74,'Bellary Zilla Parishad','583102',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23662,74,'Bellighatta','583130',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23663,74,'Belugoduhal','583132',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23664,74,'Bennikallu','583117',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23665,74,'Bennikallu','583212',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23666,74,'Bevinamarada Sugur','583114',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23667,74,'Bhairadevanahalli','583117',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23668,74,'Bhairapura','583120',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23669,74,'Bhujanganagar','583119',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23670,74,'Bisalahalli','583103',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23671,74,'Bommagatta','583128',1,0,'2022-03-03 12:30:46','2022-03-03 12:30:46'),(23672,74,'Budanur','583217',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23673,74,'Buduguppa','583120',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23674,74,'Bukkasagara','583132',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23675,74,'Byasidgeri','583224',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23676,74,'Byloor','583120',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23677,74,'Byluvaddigere','583223',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23678,74,'Chaganur','583111',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23679,74,'Chanahal','583116',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23680,74,'Chanakanur','583121',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23681,74,'Chandrashekharapura','583130',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23682,74,'Channapatna','583113',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23683,74,'Chapparada Halli','583134',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23684,74,'Chellakurki','583111',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23685,74,'Chickanthapura','583115',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23686,74,'Chickbellary','583114',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23687,74,'Chikkajayaganur','583129',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23688,74,'Chikkajogihalli','583126',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23689,74,'Chilagodu','583224',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23690,74,'Chilakanahatti','583222',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23691,74,'Chintrapalli','583212',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23692,74,'Chiratagundu','583126',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23693,74,'Chitwadgi','583211',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23694,74,'Choranur','583128',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23695,74,'Chowdapura','583135',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23696,74,'D Kaggal','583116',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23697,74,'D Mallapura','583128',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23698,74,'D T Ship','583118',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23699,74,'Dammuru','583116',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23700,74,'Dananayakanakere','583222',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23701,74,'Danapura','583222',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23702,74,'Darur','583120',1,0,'2022-03-03 12:30:47','2022-03-03 12:30:47'),(23703,74,'Dasamapura','583212',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23704,74,'Dasanahalli','583217',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23705,74,'Dasarahalli','583219',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23706,74,'Dasaranagenahalli','583117',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23707,74,'Dawlatpur','583119',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23708,74,'Deogiri','583112',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23709,74,'Desanur','583121',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23710,74,'Devagondanahalli','583219',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23711,74,'Devalapura (Bellary)','583129',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23712,74,'Devasamudra','583129',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23713,74,'Devinagara','583122',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23714,74,'Dharmasagara','583223',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23715,74,'Doopadahalli','583134',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23716,74,'Emmiganur','583113',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23717,74,'Enigi','583224',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23718,74,'Enigi Basapura','583214',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23719,74,'Eriangalgi','583115',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23720,74,'Erragudi','583117',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23721,74,'G Kodihalli','583214',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23722,74,'G Nagalapura','583222',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23723,74,'Gaddikere','583214',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23724,74,'Gadiganur','583223',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23725,74,'Gandabommanahalli','583130',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23726,74,'Gangammanahalli','583134',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23727,74,'Geddalagatta','583135',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23728,74,'Genikihal','583116',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23729,74,'Gollalingammanahalli','583112',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23730,74,'Gotur','583117',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23731,74,'Gudekota','583130',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23732,74,'Gududur','583103',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23733,74,'Gunda','583222',1,0,'2022-03-03 12:30:48','2022-03-03 12:30:48'),(23734,74,'Gundumunugu','583126',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23735,74,'H B Halli Town','583212',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23736,74,'H Hosahalli','583120',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23737,74,'H Veerapura','583113',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23738,74,'Hadligi','583117',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23739,74,'Hagaranur','583216',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23740,74,'Hagari Gajapura','583134',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23741,74,'Hagaribommanahalli','583212',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23742,74,'Hakkandi','583214',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23743,74,'Halagapura','583222',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23744,74,'Halakundi','583102',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23745,74,'Halekota','583122',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23746,74,'Hampa Patna','583222',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23747,74,'Hampadevanahalli','583129',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23748,74,'Hampasagara','583214',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23749,74,'Hampi Power House','583215',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23750,74,'Hampi','583239',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23751,74,'Handihal Gududur','583103',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23752,74,'Hansi','583135',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23753,74,'Haraginadoni','583115',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23754,74,'Harakabhavi','583126',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23755,74,'Harakanahalu','583136',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23756,74,'Haralu','583134',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23757,74,'Harvi','583217',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23758,74,'Hatcholi','583114',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23759,74,'Havinal','583120',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23760,74,'Herkal','583122',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23761,74,'Hirebannimatti','583216',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23762,74,'Hirehadagali','583216',1,0,'2022-03-03 12:30:49','2022-03-03 12:30:49'),(23763,74,'Hireheggadahal','583135',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23764,74,'Hirekeriginalli','583124',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23765,74,'Hirekolachi','583216',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23766,74,'Hirekumblagunta','583218',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23767,74,'Hiremallanakere','583214',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23768,74,'Holagundi','583219',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23769,74,'Holalu','583217',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23770,74,'Hosahalli','583218',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23771,74,'Hospet H.O','583201',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23772,74,'Hospet J P Nagar','583201',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23773,74,'Hospet N C C','583203',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23774,74,'Hospet Patel Nagar','583201',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23775,74,'Hospet Ranipet','583201',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23776,74,'Hudem','583218',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23777,74,'Hulikere','583218',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23778,74,'Hulikunta','583130',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23779,74,'Huralihal','583126',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23780,74,'Huvinahadagali Bazar','583219',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23781,74,'Huvinahadagali','583219',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23782,74,'Hyalya','583134',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23783,74,'Hyarada','583217',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23784,74,'Ibrahimpura','583102',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23785,74,'Imdapura','583218',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23786,74,'Ittigi Muddapura','583113',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23787,74,'Ittigi','583220',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23788,74,'Ittigihal','583114',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23789,74,'Jalibenchi','583103',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23790,74,'Jalihal','583117',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23791,74,'Janekunta','583115',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23792,74,'Jarimale','583135',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23793,74,'Jiginihalli','583128',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23794,74,'Jolada Kudligi','583134',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23795,74,'Joladarashi','583111',1,0,'2022-03-03 12:30:50','2022-03-03 12:30:50'),(23796,74,'Jummobanahalli','583126',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23797,74,'K Ayyanahalli','583134',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23798,74,'K Gajapura','583134',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23799,74,'K S Factory','583132',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23800,74,'K U Campus','583276',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23801,74,'K Veerapura','583111',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23802,74,'K.Belagal','583121',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23803,74,'K.Rayapura','583130',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23804,74,'K.Sugur','583121',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23805,74,'Kaddi Rampura','583239',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23806,74,'Kadekola','583126',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23807,74,'Kadlebalu','583212',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23808,74,'Kakarlathota','583102',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23809,74,'Kakkabevinahalli','583103',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23810,74,'Kakkuppi','583135',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23811,74,'Kakubal','583223',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23812,74,'Kalapura','583136',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23813,74,'Kalingere','583128',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23814,74,'Kallukamba','583113',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23815,74,'Kalvi','583214',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23816,74,'Kamalapura','583221',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23817,74,'Kammarchedu','583102',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23818,74,'Kampli Bazar','583132',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23819,74,'Kampli Fort','583132',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23820,74,'Kampli','583132',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23821,74,'Kanamadugu','583218',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23822,74,'Kanvi Thimmalapura','583132',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23823,74,'Karadi Ayyanahalli','583216',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23824,74,'Karekallu','583111',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23825,74,'Karichedu','583117',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23826,74,'Kariganur','583223',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23827,74,'Karur','583120',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23828,74,'Katriki Halli','583218',1,0,'2022-03-03 12:30:51','2022-03-03 12:30:51'),(23829,74,'Kattebennur','583216',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23830,74,'Kenchamallanahalli','583218',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23831,74,'Kenchanagudda','583121',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23832,74,'Kittanur','583224',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23833,74,'Kogali','583220',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23834,74,'Kolagallu','583102',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23835,74,'Kolur','583102',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23836,74,'Kombli','583219',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23837,74,'Konchigere','583120',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23838,74,'Kondanayakanahalli','583239',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23839,74,'Korlagundi','583103',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23840,74,'Kottal','583113',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23841,74,'Kottalachinta','583114',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23842,74,'Kottur Bazar','583134',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23843,74,'Kottur (Bellary)','583134',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23844,74,'Krishna Nagar','583119',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23845,74,'Kudadarahal','583121',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23846,74,'Kudathini','583115',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23847,74,'Kudligi','583135',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23848,74,'Kumati','583126',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23849,74,'Kuppinakere','583135',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23850,74,'Kurekuppa','583123',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23851,74,'Kurugodu','583116',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23852,74,'Kuruvalli','583121',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23853,74,'Kuruvathi','583217',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23854,74,'Lakshmipura Sandur','583119',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23855,74,'Laxmipura','583113',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23856,74,'Lokikere','583218',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23857,74,'M B Ayyanahalli','583126',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23858,74,'M S Kota','583102',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23859,74,'Magala','583216',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23860,74,'Mahadevapura','583130',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23861,74,'Mahajanadahalli','583220',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23862,74,'Makanadaku','583126',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23863,74,'Makarabbi','583216',1,0,'2022-03-03 12:30:52','2022-03-03 12:30:52'),(23864,74,'Malpanagudi','583239',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23865,74,'Malvi','583212',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23866,74,'Mangapura','583136',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23867,74,'Mannur Masalawada','583216',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23868,74,'Mannur Sugur','583120',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23869,74,'Marebbihal','583212',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23870,74,'Mariammanahalli','583222',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23871,74,'Meenakere','583126',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23872,74,'Metri','583129',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23873,74,'Metriki','583115',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23874,74,'Moka Gonehal','583117',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23875,74,'Moka','583117',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23876,74,'Moraba','583135',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23877,74,'Morigere','583220',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23878,74,'Motalakunta','583112',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23879,74,'Muddapura','583132',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23880,74,'Muddatanur','583120',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23881,74,'Mudenur','583219',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23882,74,'Mustagatta','583116',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23883,74,'Musuvinalli Kalahalli','583220',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23884,74,'Muthukuru','583224',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23885,74,'Mylar','583217',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23886,74,'Nadanga','583114',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23887,74,'Nadavi','583122',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23888,74,'Nagalapura','583123',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23889,74,'Nagalapura','583121',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23890,74,'Nagarahal','583114',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23891,74,'Nagarakatte','583136',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23892,74,'Nagatibasapura','583219',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23893,74,'Nagenahalli','583211',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23894,74,'Nandi Halli','583219',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23895,74,'Nandibanda','583222',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23896,74,'Nandihalli','583119',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23897,74,'Nanyapura','583212',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23898,74,'Navali','583219',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23899,74,'Nelkudri','583220',1,0,'2022-03-03 12:30:53','2022-03-03 12:30:53'),(23900,74,'Nelludi','583113',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23901,74,'New Daroji','583129',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23902,74,'Nidugurthi','583124',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23903,74,'Nimbalgere','583136',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23904,74,'Nittur','583122',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23905,74,'Old Daroji','583129',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23906,74,'Oojein','583136',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23907,74,'Oruvai','583113',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23908,74,'P D Halli','583111',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23909,74,'Papinayakanahalli','583223',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23910,74,'Park Road','583102',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23911,74,'Pinjaraheggadehal','583212',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23912,74,'Poojarahalli','583218',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23913,74,'Rajapura','583115',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23914,74,'Ramadurga','583130',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23915,74,'Ramasagara','583132',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23916,74,'Rampura','583134',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23917,74,'Raravi','583121',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23918,74,'Ravihal','583114',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23919,74,'Rupangudi','583102',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23920,74,'Sanapura','583132',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23921,74,'Sanavasapura','583120',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23922,74,'Sandur','583119',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23923,74,'Sanganakal','583103',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23924,74,'Sanjay Gandhi Nagar','583104',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23925,74,'Shaliyappanahalli','583128',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23926,74,'Shankarabanda','583102',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23927,74,'Shastri Nagar','583103',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23928,74,'Shidigallu','583130',1,0,'2022-03-03 12:30:54','2022-03-03 12:30:54'),(23929,74,'Shivapura','583135',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23930,74,'Siddammanahalli','583115',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23931,74,'Siddapura','583126',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23932,74,'Sidiginamola','583111',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23933,74,'Sindhavalam','583117',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23934,74,'Sindhigere','583120',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23935,74,'Sirigere (Bellary)','583120',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23936,74,'Siriwara Kappagal','583103',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23937,74,'Siruguppa','583121',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23938,74,'Siruguppa Sadashivanagar','583121',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23939,74,'Sogi','583219',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23940,74,'Somalapura','583113',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23941,74,'Somasamudra','583102',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23942,74,'Sonna','583220',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23943,74,'Sovenahalli','583128',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23944,74,'Sovenahalli','583214',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23945,74,'Sreedharagadda','583103',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23946,74,'Srikanthapura','583130',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23947,74,'Srirama Rangapura','583129',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23948,74,'Subbarayanahalli','583112',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23949,74,'Suggenahalli','583129',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23950,74,'Suladahalli','583126',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23951,74,'Sushilanagar','583119',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23952,74,'Swamihalli','583112',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23953,74,'T B Dam','583225',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23954,74,'Talur','583123',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23955,74,'Talur','583103',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23956,74,'Tamalapura','583216',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23957,74,'Taranagar','583119',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23958,74,'Tasalakudlur','583114',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23959,74,'Tayanakanahalli','583218',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23960,74,'Tekkalakota','583122',1,0,'2022-03-03 12:30:55','2022-03-03 12:30:55'),(23961,74,'Telugoli','583224',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23962,74,'Thambrahalli','583224',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23963,74,'Thimmalapura','583134',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23964,74,'Thimmalapura','583222',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23965,74,'Thimmanahalli','583130',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23966,74,'Thippapura','583219',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23967,74,'Toolahalli','583136',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23968,74,'Toranagallu','583123',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23969,74,'Tumbaraguddi','583128',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23970,74,'Tyagadahal','583128',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23971,74,'Udegolam','583122',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23972,74,'Uluvathi','583212',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23973,74,'Uppanayakanahalli','583219',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23974,74,'Uppara Hosahalli','583122',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23975,74,'Upparagatta','583212',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23976,74,'Uramma Temple','583135',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23977,74,'Uttangi','583219',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23978,74,'Uttanur','583120',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23979,74,'Vaddatti','583116',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23980,74,'Vaddu','583123',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23981,74,'Varakanahalli','583219',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23982,74,'Varlahalli','583212',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23983,74,'Vattamuruvani','583114',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23984,74,'Veniveerapura','583115',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23985,74,'Venkatapura','583221',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23986,74,'Vidyanagar (Bellary)','583275',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23987,74,'Vittalapura','583115',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23988,74,'Vyasanakere','583222',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23989,74,'Y.Kaggallu','583111',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23990,74,'Yalpi','583111',1,0,'2022-03-03 12:30:56','2022-03-03 12:30:56'),(23991,74,'Yaradammanahalli','583112',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(23992,74,'Yelubenchi','583115',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(23993,74,'Yeshwantnagar (Bellary)','583124',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(23994,74,'Yettinabudihal','583102',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(23995,75,'Ahmadabad','585444',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(23996,75,'Alandi','585328',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(23997,75,'Algood','585419',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(23998,75,'Aliember','585402',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(23999,75,'Alura','585414',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(24000,75,'Alwai','585416',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(24001,75,'Ambesangvi','585328',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(24002,75,'Amlapur','585403',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(24003,75,'Andur','585402',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(24004,75,'Astoor','585403',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(24005,75,'Attarga','585416',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(24006,75,'Aurad (B)','585326',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(24007,75,'Aurad (S)','585226',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(24008,75,'Badalgaon','585326',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(24009,75,'Bagdal','585226',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(24010,75,'Bakchowdi','585402',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(24011,75,'Balat (K)','585436',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(24012,75,'Balur','585444',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(24013,75,'Banhalli','585412',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(24014,75,'Baroor','585403',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(24015,75,'Basavakalyan Bazar','585327',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(24016,75,'Basavakalyan Eng College','585327',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(24017,75,'Basavakalyan','585327',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(24018,75,'Bawalgaon','585326',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(24019,75,'Bawgi','585226',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(24020,75,'Bedkunda','585436',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(24021,75,'Beeri (B)','585328',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(24022,75,'Beeri (K)','585328',1,0,'2022-03-03 12:30:57','2022-03-03 12:30:57'),(24023,75,'Belkhera','585412',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24024,75,'Belkoni (M)','585443',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24025,75,'Belkoni','585436',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24026,75,'Belura','585327',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24027,75,'Bemalkhed','585227',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24028,75,'Bembalgi','585227',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24029,75,'Benchincholli','585414',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24030,75,'Bet Balkunda','585327',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24031,75,'Betgera','585419',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24032,75,'Bhairnalli','585226',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24033,75,'Bhalki','585328',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24034,75,'Bhalki Town','585328',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24035,75,'Bhandarkumta','585326',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24036,75,'Bhatambra','585411',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24037,75,'Bhatasangvi','585411',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24038,75,'Bhosga','585419',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24039,75,'Bidar G.N.Jhira','585402',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24040,75,'Bidar Gandhi Gunj','585403',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24041,75,'Bidar H.O','585401',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24042,75,'Bidar Osman Gunj','585401',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24043,75,'Bidar Shah Gunj','585401',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24044,75,'Bolegaon','585416',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24045,75,'Bonthi','585326',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24046,75,'Budhera','585226',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24047,75,'Byalhalli','585415',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24048,75,'C B College','585328',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24049,75,'Chalakapur','585414',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24050,75,'Chambol','585402',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24051,75,'Chandakapur','585419',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24052,75,'Chandanhalli','585418',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24053,75,'Chandapur','585444',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24054,75,'Chandeshwar','585417',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24055,75,'Chandori','585443',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24056,75,'Changler','585227',1,0,'2022-03-03 12:30:58','2022-03-03 12:30:58'),(24057,75,'Chatnalli','585226',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24058,75,'Chidri','585403',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24059,75,'Chikli (J)','585421',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24060,75,'Chikli (U)','585326',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24061,75,'Chiknagaon','585437',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24062,75,'Chillargi','585403',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24063,75,'Chimegaon','585443',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24064,75,'Chimkod','585402',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24065,75,'Chintaki','585326',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24066,75,'Chintalgera','585403',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24067,75,'Chitguppa','585412',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24068,75,'Chitta (K)','585419',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24069,75,'Chitta','585403',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24070,75,'Chordapka','585326',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24071,75,'Dadgi','585328',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24072,75,'Dakulgi','585415',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24073,75,'Dawargaon','585328',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24074,75,'Dhannura (H)','585413',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24075,75,'Dhannura (R)','585330',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24076,75,'Dhannura(K)','585327',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24077,75,'Dhumansur','585353',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24078,75,'Dhupat Mahagaon','585421',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24079,75,'Diggi','585417',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24080,75,'Dongam (M)','585417',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24081,75,'Dongapur','585328',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24082,75,'Dubalgundi','585418',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24083,75,'Ekamba','585326',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24084,75,'Ekamba','585419',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24085,75,'Eklera','585326',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24086,75,'Gadgi','585402',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24087,75,'Gadlegaon','585437',1,0,'2022-03-03 12:30:59','2022-03-03 12:30:59'),(24088,75,'Gadwanti','585353',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24089,75,'Ghatboral','585418',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24090,75,'Ghodwadi','585418',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24091,75,'Ghotala','585419',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24092,75,'Goonalli','585403',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24093,75,'Gorchincholli','585411',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24094,75,'Gorta (B)','585327',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24095,75,'Goundgaon','585416',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24096,75,'Gour','585327',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24097,75,'Gundoor','585419',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24098,75,'Hajnal','585444',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24099,75,'Haladkeri','585403',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24100,75,'Halbarga','585413',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24101,75,'Halhalli (K)','585415',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24102,75,'Halhalli','585436',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24103,75,'Halli','585419',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24104,75,'Hallikhed (B)','585414',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24105,75,'Hallikhed (K)','585330',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24106,75,'Hallikhed SF','585415',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24107,75,'Halsi (L)','585411',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24108,75,'Halsi Tugaon','585416',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24109,75,'Handikera','585418',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24110,75,'Hangarga(B)','585326',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24111,75,'Hankuni','585330',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24112,75,'Harkud','585437',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24113,75,'Hattarga','585419',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24114,75,'Hedgapur','585436',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24115,75,'Hippalgaon(A)','585436',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24116,75,'Hipparga Bagh','585437',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24117,75,'Hipparga Ghat','585437',1,0,'2022-03-03 12:31:00','2022-03-03 12:31:00'),(24118,75,'Hirenagaon','585437',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24119,75,'Hokarana','585326',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24120,75,'Hokrana (K)','585403',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24121,75,'Holsamunder','585417',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24122,75,'Honalli','585419',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24123,75,'Hoodgi','585329',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24124,75,'Horandi','585417',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24125,75,'Hulsoor Khed','585417',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24126,75,'Hulsoor','585416',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24127,75,'Humnabad Industrial Area','585330',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24128,75,'Humnabad','585330',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24129,75,'Hunsgera','585353',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24130,75,'Hunsnal','585418',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24131,75,'Hupla','585444',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24132,75,'IAF Stn \"','585401',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24133,75,'Islampur','585331',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24134,75,'Itga','585412',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24135,75,'Jaigaon','585328',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24136,75,'Jajanmugali','585419',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24137,75,'Jalsangi','585418',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24138,75,'Jamgi','585421',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24139,75,'Jamkhandi','585416',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24140,75,'Janthi','585413',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24141,75,'Janwada','585402',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24142,75,'Jojana','585421',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24143,75,'Joldapka','585413',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24144,75,'K.H.B. Colony Bidar','585402',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24145,75,'Kadepur','585327',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24146,75,'Kadwad','585226',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24147,75,'Kalgapur','585417',1,0,'2022-03-03 12:31:01','2022-03-03 12:31:01'),(24148,75,'Kalkhora','585437',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24149,75,'Kallur','585330',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24150,75,'Kalsar Tugaon','585411',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24151,75,'Kamalnagar','585417',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24152,75,'Kamthana','585226',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24153,75,'Kanji','585413',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24154,75,'Kankatta','585353',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24155,75,'Kaplapur (A)','585402',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24156,75,'Kappargaon','585329',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24157,75,'Karaknalli','585227',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24158,75,'Kardyal','585413',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24159,75,'Karkyal','585443',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24160,75,'Kawadgaon','585421',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24161,75,'Kesar Jawalga','585416',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24162,75,'Khanapur (K)','585327',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24163,75,'Khasampur','585226',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24164,75,'Khatak Chincholli','585328',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24165,75,'Khatgaon','585417',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24166,75,'Kherda (A)','585326',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24167,75,'Kherda','585437',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24168,75,'Kinni','585437',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24169,75,'Kitta','585327',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24170,75,'Kodambal','585412',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24171,75,'Kohinoor','585419',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24172,75,'Kolhar (K)','585402',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24173,75,'Kollur (A)','585326',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24174,75,'Kon Melkunda','585413',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24175,75,'Korekal','585443',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24176,75,'Kosam','585413',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24177,75,'Kotgyal','585417',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24178,75,'Koutha (B)','585421',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24179,75,'Kumar Chincholli','585418',1,0,'2022-03-03 12:31:02','2022-03-03 12:31:02'),(24180,75,'Kurubkhelagi','585328',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24181,75,'Kushnoor Gadi','585421',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24182,75,'Ladha (A)','585421',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24183,75,'Ladha (B)','585411',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24184,75,'Ladwanti','585419',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24185,75,'Lakhangaon','585411',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24186,75,'Madargaon','585329',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24187,75,'Madargi','585227',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24188,75,'Madkatti','585411',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24189,75,'Madnoor','585417',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24190,75,'Mailoor','585403',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24191,75,'Maisalga','585437',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24192,75,'Malchapur','585413',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24193,75,'Malegaon','585403',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24194,75,'Malkapur','585403',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24195,75,'Mandaknalli','585226',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24196,75,'Mangalgi','585329',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24197,75,'Mangalpeth','585401',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24198,75,'Manhalli','585403',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24199,75,'Maniknagar','585353',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24200,75,'Mannakhelli','585227',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24201,75,'Markhal','585402',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24202,75,'Markhal','585414',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24203,75,'Markunda','585227',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24204,75,'Maroor','585413',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24205,75,'Masimadu','585414',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24206,75,'Maskal','585436',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24207,75,'Matala','585419',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24208,75,'Medpalli','585421',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24209,75,'Meenkera','585227',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24210,75,'Mehkar','585416',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24211,75,'Methi Melkunda','585411',1,0,'2022-03-03 12:31:03','2022-03-03 12:31:03'),(24212,75,'Mirkhal','585416',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24213,75,'Mohmadapur','585326',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24214,75,'Morambi','585328',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24215,75,'Morkhandi','585327',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24216,75,'Muchlam','585327',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24217,75,'Mudbi','585437',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24218,75,'Mudhol (B)','585443',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24219,75,'Mugnal','585326',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24220,75,'Mugnoor','585418',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24221,75,'Murki','585417',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24222,75,'Mustari','585412',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24223,75,'Muttangi','585227',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24224,75,'Nagankhera','585329',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24225,75,'Nagmarpalli','585326',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24226,75,'Nagora','585403',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24227,75,'Nandgaon','585329',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24228,75,'Nandi Bijalgaon','585326',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24229,75,'Narayanpur','585327',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24230,75,'Naubad','585402',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24231,75,'Nidoda','585436',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24232,75,'Nirgudi','585331',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24233,75,'Nirna','585227',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24234,75,'Nittur','585444',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24235,75,'Othagi','585418',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24236,75,'Pandargera','585331',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24237,75,'Partapur','585327',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24238,75,'Raipalli','585326',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24239,75,'Rajeshwar','585331',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24240,75,'Rajgira','585403',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24241,75,'Rajnal','585402',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24242,75,'Rajola','585331',1,0,'2022-03-03 12:31:04','2022-03-03 12:31:04'),(24243,75,'Ranjol Kheni','585329',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24244,75,'Rekulgi','585227',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24245,75,'Rola','585331',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24246,75,'Rudnoor','585413',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24247,75,'Saigaon','585416',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24248,75,'Sangam','585417',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24249,75,'Sangolgi','585226',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24250,75,'Santhpur','585421',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24251,75,'Sastapur','585327',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24252,75,'Sawali','585417',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24253,75,'Sawargaon','585326',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24254,75,'Secundrapur','585402',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24255,75,'Sedol','585353',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24256,75,'Shembelli','585421',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24257,75,'Shivani','585411',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24258,75,'Siddeshwar','585413',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24259,75,'Siddharudh Math Area','585403',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24260,75,'Sinbandgi','585415',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24261,75,'Sindankera','585330',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24262,75,'Sindol','585403',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24263,75,'Sirkatnalli','585329',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24264,75,'Sirsi (A)','585226',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24265,75,'Sitalgera','585329',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24266,75,'Sonala','585417',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24267,75,'Srimandal','585402',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24268,75,'Sultanbad','585418',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24269,75,'Sundal','585326',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24270,75,'Surhalli','585421',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24271,75,'Tadola','585331',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24272,75,'Tadpalli','585403',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24273,75,'Talmadgi','585329',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24274,75,'Talwada (K)','585413',1,0,'2022-03-03 12:31:05','2022-03-03 12:31:05'),(24275,75,'Talwada (M)','585328',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24276,75,'Telgaon','585328',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24277,75,'Thanna Kushnoor','585436',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24278,75,'Toglur','585327',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24279,75,'Torna','585443',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24280,75,'Tugaon (C) Katti','585415',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24281,75,'Udamnalli','585227',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24282,75,'Udbal','585412',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24283,75,'Ujani','585421',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24284,75,'Ujlam','585419',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24285,75,'Veterinary Univ. Campus','585226',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24286,75,'Wadgaon (D)','585421',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24287,75,'Walkhindi','585412',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24288,75,'Wanjarkhed','585416',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24289,75,'Warwatti (B)','585328',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24290,75,'Yakatpur','585403',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24291,75,'Yedlapur','585226',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24292,75,'Yeklera','585437',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24293,75,'Yelladgundi','585419',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24294,75,'Yengunda','585326',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24295,75,'Yenkura','585328',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24296,75,'Yerandi','585437',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24297,75,'Yerbagh','585331',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24298,75,'Yernalli','585402',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24299,76,'Shirbur','587117',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24300,76,'Abbihal','586213',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24301,76,'Agarkhed','586111',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24302,76,'Agasanal','586117',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24303,76,'Aheri (Sindgi)','586123',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24304,76,'Aheri','586112',1,0,'2022-03-03 12:31:06','2022-03-03 12:31:06'),(24305,76,'Ahirsang','586211',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24306,76,'Ainapur','586104',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24307,76,'Algur','586118',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24308,76,'Aliyabad','586112',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24309,76,'Almat R.S.','586201',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24310,76,'Almatti  Damsite','586201',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24311,76,'Almel','586202',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24312,76,'Alur (Indi)','586111',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24313,76,'Alur','586129',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24314,76,'Amargol','586129',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24315,76,'Angadgeri','586216',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24316,76,'Anjutgi','586204',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24317,76,'Ankalgi','586127',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24318,76,'Aralichandi','586203',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24319,76,'Arjanal','586207',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24320,76,'Arjunagi','586217',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24321,76,'Arjunagi','586113',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24322,76,'Arkeri','586104',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24323,76,'Asangi Khurd','586210',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24324,76,'Asantapur','586128',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24325,76,'Aski','586118',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24326,76,'Atharga','586112',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24327,76,'B.Salwadgi','586214',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24328,76,'Babanagar','586114',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24329,76,'Bablad','586117',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24330,76,'Bablad','586125',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24331,76,'Bableshwar','586113',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24332,76,'Bagalur','586123',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24333,76,'Balabatti','586213',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24334,76,'Balaganur','586214',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24335,76,'Balaganur','586128',1,0,'2022-03-03 12:31:07','2022-03-03 12:31:07'),(24336,76,'Ballolli','586117',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24337,76,'Baluti','586210',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24338,76,'Balwat','586116',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24339,76,'Bandal','586128',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24340,76,'Bankalgi','586123',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24341,76,'Bannihatti Pa','586128',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24342,76,'Banthanal','586215',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24343,76,'Baratgi','586119',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24344,76,'Bardol (Bijapur(KAR))','586204',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24345,76,'Bargudi','586211',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24346,76,'Basanal','586117',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24347,76,'Basarkod','586116',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24348,76,'Basavan Bagewadi','586203',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24349,76,'Bavur','586212',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24350,76,'Bekinal','586118',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24351,76,'Bellubbi','586113',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24352,76,'Benakanhalli','586112',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24353,76,'Benal','586201',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24354,76,'Bhairungi','586207',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24355,76,'Bhairwadgi','586203',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24356,76,'Bhantanur (TKT)','586214',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24357,76,'Bhantanur','586123',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24358,76,'Bhatgunki','586207',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24359,76,'Bhutnal','586103',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24360,76,'Bhuyar','586111',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24361,76,'Bibi-ingalgi','586120',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24362,76,'Bidarkundi','586212',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24363,76,'Bijapur Amc','586108',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24364,76,'Bijapur Basava Nagar','586101',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24365,76,'Bijapur Bazar','586101',1,0,'2022-03-03 12:31:08','2022-03-03 12:31:08'),(24366,76,'Bijapur Darbargalli','586109',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24367,76,'Bijapur H.O','586101',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24368,76,'Bijapur Jalanagar','586109',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24369,76,'Bijapur Jorapur Peth','586101',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24370,76,'Bijapur Jummamasjid','586104',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24371,76,'Bijapur Kutchery','586101',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24372,76,'Bijapur Market Yard','586101',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24373,76,'Bijapur Railway Station','586104',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24374,76,'Bijapur Sainik School','586102',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24375,76,'Bijapur Tajbavadi','586101',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24376,76,'Bijapur Vijaya College','586103',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24377,76,'Bijjargi','586114',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24378,76,'Bijjur','586124',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24379,76,'Bilebhavi','586214',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24380,76,'Binjalbhavi','586118',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24381,76,'Bisnal','586203',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24382,76,'Bommanahalli','586214',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24383,76,'Bommanahalli','586206',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24384,76,'Bommanjogi','586115',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24385,76,'Borgi','586128',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24386,76,'Budihal Ph','586115',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24387,76,'Budihal Pn','586213',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24388,76,'Budihal;','586208',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24389,76,'Byakod (BGW)','586208',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24390,76,'Byakod','586128',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24391,76,'Byalal','586203',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24392,76,'Chabanur','586214',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24393,76,'Chadchan','586205',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24394,76,'Chandkavathe','586128',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24395,76,'Channegaon','586207',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24396,76,'Chattarki','586215',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24397,76,'Chawadihal','586117',1,0,'2022-03-03 12:31:09','2022-03-03 12:31:09'),(24398,76,'Chick Sindgi','586128',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24399,76,'Chik Bevanur','586211',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24400,76,'Chikrugi','586215',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24401,76,'Chimmalagi','586201',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24402,76,'Darga (Bijapur)','586103',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24403,76,'Dashyal','586130',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24404,76,'Deginal','586117',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24405,76,'Devangaon','586206',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24406,76,'Devapur','586125',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24407,76,'Devar Gennur','586125',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24408,76,'Devar Hippargi','586115',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24409,76,'Devar Hulagbal','586212',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24410,76,'Devar Navadagi','586206',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24411,76,'Devur','586129',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24412,76,'Dhannargi','586130',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24413,76,'Dhanyal','586130',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24414,76,'Dhavalgi','586116',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24415,76,'Dhulkhed','586207',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24416,76,'Dindwar','586203',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24417,76,'Domanal','586117',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24418,76,'Donur','586203',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24419,76,'Dyaberi','586112',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24420,76,'Gabsavalgi','586123',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24421,76,'Gadisomanal','586214',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24422,76,'Ganihar','586128',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24423,76,'Ghani','586201',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24424,76,'Ghonasagi','586114',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24425,76,'Godihal','586204',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24426,76,'Golasangi','586216',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24427,76,'Golgeri','586128',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24428,76,'Golsar','586217',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24429,76,'Goravgundgi','586123',1,0,'2022-03-03 12:31:10','2022-03-03 12:31:10'),(24430,76,'Gornal','586215',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24431,76,'Gubbewad (Indi)','586111',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24432,76,'Gubbewad','586128',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24433,76,'Gundagi','586202',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24434,76,'Gundal','586125',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24435,76,'Gundkarajagi','586116',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24436,76,'Gunki','586108',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24437,76,'Hachyal','586215',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24438,76,'Hadagali','586127',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24439,76,'Hadalgeri','586212',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24440,76,'Hadalsang','586117',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24441,76,'Hagargond','586212',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24442,76,'Halagani','586125',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24443,76,'Halagunki','586117',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24444,76,'Halahalli','586205',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24445,76,'Halerolli','586210',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24446,76,'Halladgennur','586210',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24447,76,'Hallur','586116',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24448,76,'Halsangi','586207',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24449,76,'Hanamapur','586210',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24450,76,'Hanchli','586120',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24451,76,'Handargal','586129',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24452,76,'Handiganur','586120',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24453,76,'Hangargi','586216',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24454,76,'Hangargi','586210',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24455,76,'Hanjagi','586211',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24456,76,'Harnal','586115',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24457,76,'Hattalli','586205',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24458,76,'Hattarkihal','586122',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24459,76,'Havinal','586205',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24460,76,'Hebbal','586213',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24461,76,'Hebbalatti','586113',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24462,76,'Hegadihal','586102',1,0,'2022-03-03 12:31:11','2022-03-03 12:31:11'),(24463,76,'Hikkangutti','586202',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24464,76,'Hingani','586207',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24465,76,'Hirebevanur','586111',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24466,76,'Hiremasali','586215',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24467,76,'Hiremural','586124',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24468,76,'Hirerugi','586215',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24469,76,'Hirur','586214',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24470,76,'Hitinhalli','586122',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24471,76,'Hittinhalli (LT)','586215',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24472,76,'Hokkundi','586113',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24473,76,'Honaganhalli','586108',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24474,76,'Honawad','586130',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24475,76,'Honnalli','586128',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24476,76,'Honnalli','586112',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24477,76,'Honnutgi','586127',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24478,76,'Horti','586117',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24479,76,'Hosur','586113',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24480,76,'Hubnur','586114',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24481,76,'Hulagbal','586212',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24482,76,'Hullur','586213',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24483,76,'Hullur Lt','586213',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24484,76,'Hunakunti','586129',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24485,76,'Hunshyal','586208',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24486,76,'Hunsyal (SDG)','586118',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24487,76,'Huvin Hippargi','586208',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24488,76,'Huvinhalli','586202',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24489,76,'Inchageri','586117',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24490,76,'Indi Road','586211',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24491,76,'Indi','586209',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24492,76,'Ingaleshwar','586203',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24493,76,'Ingalgeri','586212',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24494,76,'Ingalgi','586111',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24495,76,'Ingalgi','586115',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24496,76,'Itagi','586213',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24497,76,'Ittangihal','586104',1,0,'2022-03-03 12:31:12','2022-03-03 12:31:12'),(24498,76,'Ivanagi','586203',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24499,76,'Jainapur','586113',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24500,76,'Jalgeri','586104',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24501,76,'Jalwad','586120',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24502,76,'Jambagi','586113',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24503,76,'JAMBAGI H','586113',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24504,76,'Jammaldinni','586212',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24505,76,'Jeerankalgi','586204',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24506,76,'Jevoor','586204',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24507,76,'Jigjivani','586204',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24508,76,'Jumanal','586122',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24509,76,'K.Salwadgi','586208',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24510,76,'Kadkol','586203',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24511,76,'Kadlewad(Pa)','586206',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24512,76,'Kadni','586202',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24513,76,'Kaggod','586127',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24514,76,'Kakhandki','586113',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24515,76,'Kakkalmeli','586123',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24516,76,'Kalgi','586213',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24517,76,'Kalgurki','586121',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24518,76,'Kalhalli','586202',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24519,76,'Kalkeri','586118',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24520,76,'Kambagi','586125',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24521,76,'KANABUR','586113',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24522,76,'Kandaganur','586129',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24523,76,'Kankal','586203',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24524,76,'Kanmadi','586114',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24525,76,'Kanmuchnal','586125',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24526,76,'Kannal','586203',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24527,76,'Kannal','586119',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24528,76,'Kannolli','586115',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24529,76,'Kannur','586119',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24530,76,'Kapanimbargi','586117',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24531,76,'Karjol','586108',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24532,76,'Katakanhalli','586102',1,0,'2022-03-03 12:31:13','2022-03-03 12:31:13'),(24533,76,'Kavadimatti','586212',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24534,76,'Kenginal','586112',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24535,76,'Kerutgi','586118',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24536,76,'Kesaratti','586118',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24537,76,'Khainur','586128',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24538,76,'Khanapur','586128',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24539,76,'Khatijapur','586125',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24540,76,'Khedgi','586217',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24541,76,'Kodaganur','586214',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24542,76,'Kokatnur','586115',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24543,76,'Kolhar (Bijapur(KAR))','586210',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24544,76,'Kolur','586129',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24545,76,'Kolur Lt','586129',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24546,76,'Kondguli','586120',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24547,76,'Konnur','586208',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24548,76,'Korahalli','586202',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24549,76,'Korwar','586120',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24550,76,'Kotyal','586130',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24551,76,'Koulagi','586216',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24552,76,'Kudgi','586121',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24553,76,'Kumathe','586113',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24554,76,'Kumshi','586206',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24555,76,'Kunchaganur','586129',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24556,76,'Kuntoji','586212',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24557,76,'Kupakaddi','586210',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24558,76,'Kurabardinni','586210',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24559,76,'Kurabathalli','586202',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24560,76,'Lachyan','586211',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24561,76,'Lingadahalli','586116',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24562,76,'Lohagaon','586104',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24563,76,'Loni BK','586204',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24564,76,'M.Devarhatti','586130',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24565,76,'Madanahalli','586202',1,0,'2022-03-03 12:31:14','2022-03-03 12:31:14'),(24566,76,'Madari','586129',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24567,76,'Madasanal','586119',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24568,76,'Madbal','586128',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24569,76,'Madhbhavi','586104',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24570,76,'Madikeshwar','586116',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24571,76,'Madinal','586212',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24572,76,'Maileshwar','586214',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24573,76,'Majre Sangapur','586125',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24574,76,'Makhanapur','586119',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24575,76,'Malghan','586121',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24576,76,'Malghan','586128',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24577,76,'Mamadapur','586113',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24578,76,'Manankalgi','586204',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24579,76,'Mangoli','586122',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24580,76,'Mannur','586216',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24581,76,'Mannur','586120',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24582,76,'Manur','586111',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24583,76,'Markabbinhalli','586115',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24584,76,'Masabinal','586203',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24585,76,'Masuti','586121',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24586,76,'Mattihal','586210',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24587,76,'Minajagi','586214',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24588,76,'Minchanal Lt','586108',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24589,76,'Mirgi','586217',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24590,76,'Moratgi','586123',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24591,76,'Muddebiahl','586212',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24592,76,'Muddebihal Fort','586212',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24593,76,'Mukihal','586212',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24594,76,'Mulasavalgi','586127',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24595,76,'Mulawad','586108',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24596,76,'Muttagi','586216',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24597,76,'Nadkhurd','586217',1,0,'2022-03-03 12:31:15','2022-03-03 12:31:15'),(24598,76,'Nagabenal','586124',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24599,76,'Nagaral','586113',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24600,76,'Nagarbetta','586124',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24601,76,'Nagathan','586112',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24602,76,'Nagavi','586123',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24603,76,'Nagur','586212',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24604,76,'Nalatwad','586124',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24605,76,'Nandargi','586117',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24606,76,'Nandihal','586122',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24607,76,'Narasalagi','586203',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24608,76,'Narebenchi','586212',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24609,76,'Navadagi','586214',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24610,76,'Nebageri','586129',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24611,76,'Neeralgi','586118',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24612,76,'Nidgundi','586213',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24613,76,'Nidoni','586113',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24614,76,'Nimb R.S.','586211',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24615,76,'Nimbal','586211',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24616,76,'Nimbargi','586204',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24617,76,'Nivargi','586205',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24618,76,'Otihal','586115',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24619,76,'Padaganur','586127',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24620,76,'Padekanur','586116',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24621,76,'Padnur','586211',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24622,76,'Peerapur','586214',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24623,76,'Phattepur','586214',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24624,76,'Rabinal','586203',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24625,76,'Rakkasagi','586129',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24626,76,'Rampur','586202',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24627,76,'Revatgaon','586205',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24628,76,'Rodagi','586217',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24629,76,'Ronihal','586210',1,0,'2022-03-03 12:31:16','2022-03-03 12:31:16'),(24630,76,'Rudgi','586116',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24631,76,'Salotgi','586217',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24632,76,'Sangapur Sh','586125',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24633,76,'Sankh','586205',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24634,76,'Sarur','586129',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24635,76,'Sarwad','586125',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24636,76,'Sasabal','586128',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24637,76,'Sasanur','586214',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24638,76,'Satalgaon (PB)','586117',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24639,76,'Satalgaon','586217',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24640,76,'Satihal','586115',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24641,76,'Savalsang','586117',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24642,76,'Shanti Kutir','586119',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24643,76,'Shegunshi','586125',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24644,76,'Shiradon','586205',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24645,76,'Shirakanhalli','586112',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24646,76,'Shirbur','586113',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24647,76,'Shirnal','586119',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24648,76,'Shirshyad','586217',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24649,76,'Shivangi','586127',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24650,76,'Shivapur','586212',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24651,76,'Siddanath','586210',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24652,76,'Siddapur','586104',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24653,76,'Siddapur Ds','586124',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24654,76,'Sindgi','586128',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24655,76,'Somadevarhatti','586114',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24656,76,'Somanal','586208',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24657,76,'Somjal','586128',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24658,76,'Sungthan','586128',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24659,76,'Surgihalli','586215',1,0,'2022-03-03 12:31:17','2022-03-03 12:31:17'),(24660,76,'Tadavalga','586112',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24661,76,'Taddewadi','586204',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24662,76,'Tajpur','586130',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24663,76,'Takkalki','586129',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24664,76,'Takkalki','586216',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24665,76,'Takkalki','586130',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24666,76,'Talewad','586121',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24667,76,'Talikoti','586214',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24668,76,'Tamadaddi','586214',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24669,76,'Tamba','586215',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24670,76,'Tangadgi','586129',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24671,76,'Teggihalli','586217',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24672,76,'Telgi','586216',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24673,76,'Tenihalli','586215',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24674,76,'Tidgundi','586119',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24675,76,'Tiganibidari','586113',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24676,76,'Tikota','586130',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24677,76,'Tilgul','586118',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24678,76,'Tonshyal','586108',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24679,76,'Torvi','586108',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24680,76,'Tumbagi','586214',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24681,76,'Ukkali','586102',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24682,76,'Umaraj','586205',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24683,76,'Umrani','586205',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24684,76,'Uppaladinni','586113',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24685,76,'Utnal','586102',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24686,76,'Vanahalli','586116',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24687,76,'Vandal','586201',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24688,76,'Vibhuthalli','586217',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24689,76,'Wadwadgi','586208',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24690,76,'Yakkundi','586113',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24691,76,'Yalgod','586120',1,0,'2022-03-03 12:31:18','2022-03-03 12:31:18'),(24692,76,'Yalgur','586213',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24693,76,'Yalwar','586203',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24694,76,'Yambatnal','586127',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24695,76,'Yankanchi','586128',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24696,76,'Yargal (TGD)','586129',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24697,76,'Yargal','586123',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24698,76,'Yarnal','586122',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24699,76,'Yarzeri','586212',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24700,76,'Yatnal','586104',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24701,76,'Zalki','586204',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24702,77,'Agara','571442',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24703,77,'Ajjipura','571439',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24704,77,'Alahalli','571442',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24705,77,'Alathur','571111',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24706,77,'Alur','571117',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24707,77,'Amachavadi','571127',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24708,77,'Ambale','571441',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24709,77,'Ankasettypura','571127',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24710,77,'Annurkeri','571111',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24711,77,'Arakalavadi','571127',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24712,77,'Attagulipura','571127',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24713,77,'Attikane','571313',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24714,77,'B R Hills','571441',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24715,77,'Bachahalli','571111',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24716,77,'Badanaguppe','571313',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24717,77,'Bagali','571316',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24718,77,'Bailur','571457',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24719,77,'Balachavadi','571123',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24720,77,'Bandalli','571439',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24721,77,'Bandipura','571126',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24722,77,'Baragi','571111',1,0,'2022-03-03 12:31:19','2022-03-03 12:31:19'),(24723,77,'Bedaguli','571313',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24724,77,'Begur','571109',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24725,77,'Belachalavadi','571109',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24726,77,'Berambadi','571111',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24727,77,'Berthahallli','571123',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24728,77,'Bettahalli','571111',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24729,77,'Bheemanabeedu','571111',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24730,77,'Bhogapura','571115',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24731,77,'Bisalavadi','571127',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24732,77,'Bnnithalapura','571111',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24733,77,'Bodimuthanahalli','571439',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24734,77,'Bommalapura','571111',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24735,77,'Bommanahalli','571123',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24736,77,'Chamarajanagara Bazar','571313',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24737,77,'Chamarajanagara Pwd Colony','571342',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24738,77,'Chamarajanagara','571313',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24739,77,'Chandakavadi','571342',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24740,77,'Channalingadahalli','571443',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24741,77,'Chikkahomma','571316',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24742,77,'Chikkamallapura','571440',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24743,77,'Chikkati','571109',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24744,77,'Chikkatuppur','571111',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24745,77,'Chilukavadi','571442',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24746,77,'Chirakanahalli','571123',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24747,77,'Cowdalli','571320',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24748,77,'Dasanur','571316',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24749,77,'Demahalli','571316',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24750,77,'Depapura','571123',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24751,77,'Devarahalli','571126',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24752,77,'Dinnahalli','571444',1,0,'2022-03-03 12:31:20','2022-03-03 12:31:20'),(24753,77,'Doddalathur','571320',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24754,77,'Doddamole','571127',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24755,77,'Doddarayapet','571313',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24756,77,'Doddinduvadi','571443',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24757,77,'Ellemela','571439',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24758,77,'Ganiganur','571441',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24759,77,'Gopinatham','571490',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24760,77,'Goreyur','571439',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24761,77,'Gowdahalli','571441',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24762,77,'Gulipura','571117',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24763,77,'Gundlupet Bazar','571111',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24764,77,'Gundlupet','571111',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24765,77,'Hangala','571126',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24766,77,'Hanur','571439',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24767,77,'Haradanahalli','571127',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24768,77,'Harave','571128',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24769,77,'Hasaguli','571111',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24770,77,'Hebbasur','571342',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24771,77,'Heggadahalli','571109',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24772,77,'Heggavady','571316',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24773,77,'Heggotara','571313',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24774,77,'Hirikati','571109',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24775,77,'Hondarabalu','571342',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24776,77,'Hongalli','571111',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24777,77,'Honganur','571117',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24778,77,'Honnahalli','571127',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24779,77,'Honnur','571441',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24780,77,'Hoogiam','571444',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24781,77,'Horeyala','571109',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24782,77,'Hosamalangi','571442',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24783,77,'Hundipura','571111',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24784,77,'Irasavadi','571441',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24785,77,'Jannur','571316',1,0,'2022-03-03 12:31:21','2022-03-03 12:31:21'),(24786,77,'Jyothigowdanapura','571117',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24787,77,'Kabbahalli','571109',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24788,77,'Kagalavadi','571117',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24789,77,'Kaggala','571123',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24790,77,'Kalanahundi','571128',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24791,77,'Kaligowdanahalli','571126',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24792,77,'Kaliyur','571442',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24793,77,'Kallahalli','571109',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24794,77,'Kalpura','571128',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24795,77,'Kamakerai','571443',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24796,77,'Kaniyanapura','571126',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24797,77,'Kannagala','571115',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24798,77,'Kannegala','571111',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24799,77,'Kannur','571443',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24800,77,'Kastur Chamarajanagara','571115',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24801,77,'Kavudavadi','571115',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24802,77,'Kelasur','571123',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24803,77,'Kellamballi','571313',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24804,77,'Kempanapalya','571440',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24805,77,'Kempanapura','571115',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24806,77,'Kestur Yelandur','571441',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24807,77,'Kilagere','571123',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24808,77,'Kinakanahalli','571442',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24809,77,'Kodasoge','571111',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24810,77,'Kodimole','571342',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24811,77,'Kollegal Devangapet','571440',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24812,77,'Kollegal H.O','571440',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24813,77,'Kollegal Southern Extension','571440',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24814,77,'Komaranapura','571441',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24815,77,'Kotamballi','571117',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24816,77,'Kotekere','571109',1,0,'2022-03-03 12:31:22','2022-03-03 12:31:22'),(24817,77,'Kothalavadi','571123',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24818,77,'Kothanur','571440',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24819,77,'Kuderu (Chamrajnagar)','571316',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24820,77,'Kudlur','571444',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24821,77,'Kudlur','571342',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24822,77,'Kulugana','571109',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24823,77,'Kunaganahalli','571442',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24824,77,'Kundakere','571111',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24825,77,'Kunthur','571442',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24826,77,'Kurahatti Hosur','571320',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24827,77,'Kyathadevaragudi','571342',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24828,77,'Lakkur','571123',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24829,77,'Lokkanahalli','571440',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24830,77,'M K Hundi','571110',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24831,77,'Madapura','571313',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24832,77,'Maddur','571111',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24833,77,'Maddur Yelandur','571441',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24834,77,'Madhuvinahalli','571440',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24835,77,'Mahadeshwara Malai','571490',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24836,77,'Mahanthalapura','571115',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24837,77,'Malangi','571442',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24838,77,'Maleyur','571128',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24839,77,'Mamballi','571442',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24840,77,'Managahalli','571439',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24841,77,'Manchapura','571444',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24842,77,'Mangala','571126',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24843,77,'Mangala','571115',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24844,77,'Mangalam','571443',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24845,77,'Mariyala','571313',1,0,'2022-03-03 12:31:23','2022-03-03 12:31:23'),(24846,77,'Marthalli','571320',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24847,77,'Marukotai','571490',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24848,77,'Masanapura','571117',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24849,77,'Minya','571444',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24850,77,'Mudigundam','571440',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24851,77,'Mudnakudu','571128',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24852,77,'Muduguru','571123',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24853,77,'Mukanapalya','571127',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24854,77,'Mukkadahalli','571128',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24855,77,'Mullur','571442',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24856,77,'Nagavalli','571342',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24857,77,'Nanjedevanapura','571128',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24858,77,'Nenekatte','571111',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24859,77,'Nitre','571109',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24860,77,'Odeyarapalyam','571457',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24861,77,'Paduguru','571123',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24862,77,'Palyam','571440',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24863,77,'Parasegowdanapalya','571457',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24864,77,'Ponnachi','571320',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24865,77,'Punajanur','571127',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24866,77,'Puttanapura','571126',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24867,77,'Raghavapura','571109',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24868,77,'Ramapuram Ghat','571444',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24869,77,'Ramasamudra (Chamrajnagar)','571342',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24870,77,'Sagade','571128',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24871,77,'Saggiam','571439',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24872,77,'Santhemaranahalli','571115',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24873,77,'Saragur Chamarajanagara','571117',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24874,77,'Sargur Kollegal','571440',1,0,'2022-03-03 12:31:24','2022-03-03 12:31:24'),(24875,77,'Sathegala','571440',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24876,77,'Shivakalli','571441',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24877,77,'Shivapura','571313',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24878,77,'Shivapura','571111',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24879,77,'Siddainapura','571440',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24880,77,'Sindanapura','571111',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24881,77,'Singanallur','571443',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24882,77,'Somahallli','571109',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24883,77,'Somvarpet','571313',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24884,77,'Suleripalyam','571439',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24885,77,'Tellanur','571440',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24886,77,'Thammadahalli','571128',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24887,77,'Thondavadi','571109',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24888,77,'Tibetan Settlement','571457',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24889,77,'Tirukanambi','571123',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24890,77,'Uddanur','571439',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24891,77,'Udigala','571313',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24892,77,'Ummathur','571316',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24893,77,'Uttamballi','571442',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24894,77,'Uttuvalli','571313',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24895,77,'Vaddagere','571123',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24896,77,'Veeranapura','571111',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24897,77,'Venkatainachatra','571127',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24898,77,'Yanaganahalli','571127',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24899,77,'Yelandur Balepete','571441',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24900,77,'Yelandur','571441',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24901,77,'Yeragamballi','571441',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24902,77,'Yeraganahlli','571127',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24903,77,'Yeriyur','571111',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24904,77,'Yeriyur','571441',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24905,77,'Zilla Adalitha Bhavan','571313',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24906,78,'Addada','577126',1,0,'2022-03-03 12:31:25','2022-03-03 12:31:25'),(24907,78,'Addagadde','577126',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24908,78,'Agalagandi','577139',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24909,78,'Ajjampura Bazar','577547',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24910,78,'Ajjampura','577547',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24911,78,'Alageshwara','577123',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24912,78,'Alaghatta','577548',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24913,78,'Aldur','577111',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24914,78,'Amble','577101',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24915,78,'Amruthapura','577228',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24916,78,'Andagaru','577126',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24917,78,'Anegere','577182',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24918,78,'Annigere(Y)','577138',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24919,78,'Antharaghatta','577547',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24920,78,'Anur','577101',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24921,78,'Asandi','577550',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24922,78,'Attigundi','577131',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24923,78,'Avathi','577101',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24924,78,'B.H. Kaimara','577134',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24925,78,'Baggavalli','577547',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24926,78,'Balehole','577179',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24927,78,'Balehonnur','577112',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24928,78,'Balliganur','577116',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24929,78,'Balur','577122',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24930,78,'Banakal','577113',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24931,78,'Bannur','577112',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24932,78,'Banur','577135',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24933,78,'Baragenahalli','577144',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24934,78,'Basarikatte','577114',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24935,78,'Baskal','577132',1,0,'2022-03-03 12:31:26','2022-03-03 12:31:26'),(24936,78,'Basoor','577116',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24937,78,'Begar','577120',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24938,78,'Begur','577550',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24939,78,'Belanahalli','577228',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24940,78,'Belavadi','577146',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24941,78,'Belavinakodige','577126',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24942,78,'Bellur','577127',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24943,78,'Berukodige','577126',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24944,78,'Bettadahalli','577228',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24945,78,'Bettadamane','577132',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24946,78,'Bettagere','577113',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24947,78,'Bhandigadi','577126',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24948,78,'Bhavikere','577144',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24949,78,'Bidre','577136',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24950,78,'Bidrehalli','577132',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24951,78,'Bilagadde','577120',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24952,78,'Bilalkoppa','577114',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24953,78,'Billurkadidal','577132',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24954,78,'Biluvala','577548',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24955,78,'Birur','577116',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24956,78,'Bisagnimutt','577131',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24957,78,'Bisalehalli','577548',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24958,78,'Bislere','577116',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24959,78,'Bogase','577130',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24960,78,'Bomlapura','577120',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24961,78,'Bukkambudhi','577145',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24962,78,'C.R.Station','577117',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24963,78,'Cheeranahalli','577549',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24964,78,'Chikkaballekere','577140',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24965,78,'Chikkanallur','577550',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24966,78,'Chikkanavangala','577145',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24967,78,'Chikkangala','577548',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24968,78,'Chikmagalur District Office','577101',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24969,78,'Chikmagalur Fort','577101',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24970,78,'Chikmagalur H.O','577101',1,0,'2022-03-03 12:31:27','2022-03-03 12:31:27'),(24971,78,'Chikmagalur ZP','577102',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24972,78,'Chowlahiriyur','577180',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24973,78,'Coove','577160',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24974,78,'Dandur','577549',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24975,78,'Daradahalli','577132',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24976,78,'Darekoppa','577139',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24977,78,'Dayamballi','577126',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24978,78,'Devagodu','577112',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24979,78,'Devanur','577175',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24980,78,'Devarinda','577132',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24981,78,'Doddabokikere','577547',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24982,78,'Doranalu','577228',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24983,78,'Duglapura','577144',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24984,78,'Durgadabetta','577118',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24985,78,'Eshwarahalli','577146',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24986,78,'G. Hosahalli','577132',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24987,78,'G. Yaradakere','577180',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24988,78,'Gadihalli','577547',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24989,78,'Gandaghatta','577139',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24990,78,'Ganganakodige','577124',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24991,78,'Gangenahalli','577182',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24992,78,'Garje','577140',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24993,78,'Gejjegondanahalli','577547',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24994,78,'Giriyapura','577550',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24995,78,'Gonibeedu','577132',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24996,78,'Gopala','577144',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24997,78,'Gowdahalli','577132',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24998,78,'Gubbiga (Sutta)','577134',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(24999,78,'Gubgal','577160',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(25000,78,'Guddadamane','577111',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(25001,78,'Guddethota','577123',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(25002,78,'Gullanpet','577111',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(25003,78,'Gunavanthe','577126',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(25004,78,'Guthi','577113',1,0,'2022-03-03 12:31:28','2022-03-03 12:31:28'),(25005,78,'Hadikere','577228',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25006,78,'Halandur','577139',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25007,78,'Halase','577132',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25008,78,'Halasumane','577133',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25009,78,'Halasur','577144',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25010,78,'Halmathur','577126',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25011,78,'Haluvalli','577124',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25012,78,'Handi','577111',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25013,78,'Hangaravalli','577111',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25014,78,'Hanthur','577132',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25015,78,'Hariharapura','577120',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25016,78,'Heggudlu','577113',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25017,78,'Hemmakki','577121',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25018,78,'Herur','577118',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25019,78,'Hesgal','577132',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25020,78,'Hirebyle','577121',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25021,78,'Hiregadde','577117',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25022,78,'Hiregouza','577168',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25023,78,'Hirekodige','577126',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25024,78,'Hirekolale','577101',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25025,78,'Hiremagalur','577102',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25026,78,'Hirenallur','577550',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25027,78,'Hochihalli','577182',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25028,78,'Hogarehalli','577116',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25029,78,'Honnavalli','577139',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25030,78,'Honnekodige','577134',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25031,78,'Honnenahalli','577182',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25032,78,'Horanadu','577181',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25033,78,'Hosahalli','577113',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25034,78,'Hosahallipet','577130',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25035,78,'Hosakoppa','577126',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25036,78,'Hosur(Koppa)','577123',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25037,78,'Huigere','577160',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25038,78,'Huligere','577138',1,0,'2022-03-03 12:31:29','2022-03-03 12:31:29'),(25039,78,'Hulikere','577168',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25040,78,'Hunsaghatta','577228',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25041,78,'Indavara','577101',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25042,78,'Jagara','577130',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25043,78,'Jakkanahalli','577130',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25044,78,'Jannagadde','577136',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25045,78,'Jannapura','577132',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25046,78,'Javali','577122',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25047,78,'Javoor','577145',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25048,78,'Jayapura','577123',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25049,78,'Jiganehalli','577548',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25050,78,'Jodimachenahalli','577146',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25051,78,'Jogannakere','577132',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25052,78,'Joldal','577130',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25053,78,'Jyothinagar (Chickmagalur)','577102',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25054,78,'K. Chattnahalli','577228',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25055,78,'K.Kelagur','577179',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25056,78,'K.R. Pete(Bigganahalli)','577133',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25057,78,'Kabbinahalli','577101',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25058,78,'Kachakalli','577126',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25059,78,'Kadavanthi','577136',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25060,78,'Kadur RS','577548',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25061,78,'Kadur','577548',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25062,78,'Kadurhalli','577548',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25063,78,'Kaimara','577131',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25064,78,'Kalasa','577124',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25065,78,'Kalasapura','577146',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25066,78,'Kalkere','577180',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25067,78,'Kalkere','577123',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25068,78,'Kallathipura','577129',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25069,78,'Kallugudde','577114',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25070,78,'Kamanakere','577116',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25071,78,'Kammaradi','577125',1,0,'2022-03-03 12:31:30','2022-03-03 12:31:30'),(25072,78,'Kammaragodu','577132',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25073,78,'Kanabur','577112',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25074,78,'Kanathi','577111',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25075,78,'Kanchugal Bidre','577138',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25076,78,'Kanur','577127',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25077,78,'Karakuchi','577144',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25078,78,'Karthikere','577101',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25079,78,'Katignere','577550',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25080,78,'Kattinamane','577127',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25081,78,'Kavadi','577139',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25082,78,'Kelagur','577111',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25083,78,'Kelagur(J)','577122',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25084,78,'Kelakuli','577126',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25085,78,'Kenjige','577113',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25086,78,'Kerekatte','577139',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25087,78,'Keresanthe','577548',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25088,78,'Kesave','577126',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25089,78,'Kesavinamane','577131',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25090,78,'Kirugunda','577132',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25091,78,'Konakere','577127',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25092,78,'Konkalamane','577136',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25093,78,'Koppa H.O','577126',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25094,78,'Kottigehara','577113',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25095,78,'Kudlur','577116',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25096,78,'Kudregundi','577127',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25097,78,'Kudremukh','577142',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25098,78,'Kuduvalli','577133',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25099,78,'Kulur','577123',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25100,78,'Kunchebyle','577139',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25101,78,'Kundur','577132',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25102,78,'Kunkanadu','577182',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25103,78,'Kurubarabudihal','577146',1,0,'2022-03-03 12:31:31','2022-03-03 12:31:31'),(25104,78,'Kuruvangi','577102',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25105,78,'Lakkammanahalli','577168',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25106,78,'Lakkavalli','577128',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25107,78,'Lakya','577168',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25108,78,'Lingadahalli','577129',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25109,78,'Lokanathapura','577123',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25110,78,'Madabur','577134',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25111,78,'Magundi','577160',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25112,78,'Makonahalli','577132',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25113,78,'Malalichennenahalli','577228',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25114,78,'Malalur(CKM)','577133',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25115,78,'Mallandur','577130',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25116,78,'Mallenahalli','577131',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25117,78,'Marasanige','577124',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25118,78,'Maravanji','577182',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25119,78,'Marle','577101',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25120,78,'Masige','577139',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25121,78,'Mathighatta','577548',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25122,78,'Megaramakki','577112',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25123,78,'Megur','577139',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25124,78,'Megur','577122',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25125,78,'Mekanagadde','577132',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25126,78,'Melpal','577112',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25127,78,'Melubellare','577120',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25128,78,'Melukoppa','577126',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25129,78,'Melukoppa Begane','577139',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25130,78,'Mudabagilu','577134',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25131,78,'Mudigere','577550',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25132,78,'Mudigere','577132',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25133,78,'Mugthihalli','577133',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25134,78,'Muguluvalli','577101',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25135,78,'Mundre','577116',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25136,78,'Muthanagere','577182',1,0,'2022-03-03 12:31:32','2022-03-03 12:31:32'),(25137,78,'Muthinakoppa','577134',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25138,78,'Nagaralu','577175',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25139,78,'Nagenahalli','577168',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25140,78,'Nallur','577139',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25141,78,'Nandi','577228',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25142,78,'Nandibatlu','577129',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25143,78,'Nandipura','577132',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25144,78,'Narasimharajapura','577134',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25145,78,'Narve','577126',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25146,78,'Nemmar','577139',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25147,78,'Neralakere','577228',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25148,78,'Nidaghatta','577548',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25149,78,'Niduvale','577122',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25150,78,'Niduvalli','577182',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25151,78,'Niluvagilu','577120',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25152,78,'Panchanahalli','577182',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25153,78,'Pandaavalli','577131',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25154,78,'Patnagere','577548',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25155,78,'Phalguni','577113',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25156,78,'Pillenahally','577168',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25157,78,'Porterpet','577101',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25158,78,'Ramanahalli','577101',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25159,78,'Rampura','577133',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25160,78,'Rangenahalli','577144',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25161,78,'Rushyashringapura','577139',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25162,78,'S. Bidare','577146',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25163,78,'S. Madapura','577138',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25164,78,'Sakrepatna','577135',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25165,78,'Sampigekhan','577129',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25166,78,'Samse','577124',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25167,78,'Sangameshwarapete','577136',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25168,78,'Santaveri','577137',1,0,'2022-03-03 12:31:33','2022-03-03 12:31:33'),(25169,78,'Saraswathipura','577548',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25170,78,'Seethur','577127',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25171,78,'Shanthigrama','577114',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25172,78,'Shanuboganahalli','577547',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25173,78,'Shanuvalli','577120',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25174,78,'Shettykoppa','577134',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25175,78,'Sindigere','577146',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25176,78,'Singatagere','577138',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25177,78,'Sirvase','577130',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25178,78,'Siva R.S.','577549',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25179,78,'Sivane','577549',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25180,78,'Sokke','577547',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25181,78,'Sollapura','577550',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25182,78,'Somanahalli','577138',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25183,78,'Sringeri','577139',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25184,78,'Sunkasale','577121',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25185,78,'Suryadevasthana','577126',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25186,78,'Tangli','577548',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25187,78,'Tanigebyle','577129',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25188,78,'Tarikere','577228',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25189,78,'Tekkur','577139',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25190,78,'Thotadur','577179',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25191,78,'Thyagadakatte','577549',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25192,78,'Thyavana','577139',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25193,78,'Togarihanakal','577137',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25194,78,'Uddeboranahalli','577168',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25195,78,'Udeva','577129',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25196,78,'Udugere','577140',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25197,78,'Urubage','577132',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25198,78,'Uttameshwara','577126',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25199,78,'Vakkalagere','577180',1,0,'2022-03-03 12:31:34','2022-03-03 12:31:34'),(25200,78,'Vastare','577133',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25201,78,'Vidyaranyapura','577139',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25202,78,'Vijayapuram (Chickmagalur)','577101',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25203,78,'Y. Mallapura','577548',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25204,78,'Yagati','577140',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25205,78,'Yellambalase','577548',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25206,78,'Yemmedoddi','577548',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25207,79,'Ablodu','562105',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25208,79,'Agalagurki','562103',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25209,79,'Ajjavara','562101',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25210,79,'Alakapura','561213',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25211,79,'Avalagurki','562101',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25212,79,'Basettihalli','562105',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25213,79,'Beechaganahalli','561209',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25214,79,'Bislahalli','561211',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25215,79,'Chandandur','561208',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25216,79,'Cheemangala','562102',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25217,79,'Chenchurayanapalli','561207',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25218,79,'Chickballapur H.O','562101',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25219,79,'Chickballapur Mandy Bazarr','562101',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25220,79,'Chikkapyalagurkj','562104',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25221,79,'Chintamani Bazar','563125',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25222,79,'Chintamani Market','563125',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25223,79,'Cholasettyhalli','561209',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25224,79,'Chowtakuntapalli','561209',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25225,79,'Dapparthi','561209',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25226,79,'Devaramallur','562105',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25227,79,'Dibbur','562101',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25228,79,'Dibburhalli','562105',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25229,79,'Dn Palya','561206',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25230,79,'Doddakurugodu','561208',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25231,79,'E. Thimmasandra','563159',1,0,'2022-03-03 12:31:35','2022-03-03 12:31:35'),(25232,79,'Gadare Bommasandra','561213',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25233,79,'Gangasandra','561208',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25234,79,'Ganjigunte','563125',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25235,79,'Gauribidanur Bzr','561208',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25236,79,'Gerehalli','562101',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25237,79,'Gorthapalli','561207',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25238,79,'Gundlagurki','562101',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25239,79,'H. Nagasandra','561208',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25240,79,'Halaganahalli','561208',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25241,79,'Haleupparahalli','561210',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25242,79,'Hemaranahalli','562102',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25243,79,'Huduguru','561206',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25244,79,'Jangamkote','562102',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25245,79,'Jathavara','562101',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25246,79,'Kadabur','561206',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25247,79,'Kalavara','562103',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25248,79,'Kalludi','561208',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25249,79,'Kamaganahalli','561213',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25250,79,'Kanganahalli','562101',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25251,79,'Kenkere','561210',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25252,79,'Kethenahalli','562101',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25253,79,'Kodigal','563123',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25254,79,'Kondenahalli','562103',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25255,79,'Kothakote','561207',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25256,79,'Kothnur','562105',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25257,79,'Kundlagurki','562105',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25258,79,'Malamachanahalli','562102',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25259,79,'Mallasandra','561207',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25260,79,'Mallur','562102',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25261,79,'Manchenabele','562101',1,0,'2022-03-03 12:31:36','2022-03-03 12:31:36'),(25262,79,'Maraganakunte','561207',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25263,79,'Maralakunte','562101',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25264,79,'Melya','561208',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25265,79,'Mittahalli','563159',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25266,79,'Mittemari','561207',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25267,79,'Muddenahalli','562101',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25268,79,'N. Kothur','563125',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25269,79,'Nagamangala','562102',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25270,79,'Nallappareddipalli','561207',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25271,79,'Nandi Hills','562101',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25272,79,'Naravalapalli','561207',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25273,79,'Naremaddepalli','561212',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25274,79,'Neerantipalli','561207',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25275,79,'Pallicherlu','562105',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25276,79,'Palyakere','563124',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25277,79,'Papathimmanahalli','563159',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25278,79,'Paragodu','561207',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25279,79,'Patrenahalli','562101',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25280,79,'Peddapalli','563121',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25281,79,'Peresandra','562104',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25282,79,'Polinayakanahalli','563159',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25283,79,'Puligal','563124',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25284,79,'Ramapatna','561209',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25285,79,'Rasicheruvu','563124',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25286,79,'S.Devaganahalli','562104',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25287,79,'Sadali','562104',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25288,79,'Settihalli','563125',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25289,79,'Sidlagatta Bazar','562105',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25290,79,'Somanathapura','561212',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25291,79,'Somayajalapalli','563138',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25292,79,'Srirampura','562103',1,0,'2022-03-03 12:31:37','2022-03-03 12:31:37'),(25293,79,'Subbarayanpet','562101',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25294,79,'T. Gollahalli','563125',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25295,79,'Thippenahalli','562105',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25296,79,'Thokalahalli','561228',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25297,79,'Tholapalli','561212',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25298,79,'Thondebhavi Old Town','561213',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25299,79,'Town Hall Sqaure','562101',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25300,79,'Varavani','561211',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25301,79,'Venkatapura','563124',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25302,79,'Venkatapura','562102',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25303,79,'Y.Hosakote','563125',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25304,79,'Yagavakote','563146',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25305,79,'Yallampalli','561207',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25306,79,'Yenigadale','563125',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25307,79,'Yenumalapadi','563123',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25308,79,'Yidagur','561208',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25309,80,'Abbaiahnahalli','577536',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25310,80,'Abbinahole','577546',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25311,80,'Adanur','577518',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25312,80,'Adanur','577526',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25313,80,'Adivala','577511',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25314,80,'Aimangala','577558',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25315,80,'Alagawadi','577541',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25316,80,'Alaghatta','577541',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25317,80,'Alaghatta','577597',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25318,80,'Alur','577598',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25319,80,'Ambalagere','577545',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25320,80,'Amruthapura','577557',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25321,80,'Annehal','577555',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25322,80,'Annivala','577554',1,0,'2022-03-03 12:31:38','2022-03-03 12:31:38'),(25323,80,'Arabhaghatta','577554',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25324,80,'Aralahalli','577527',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25325,80,'Aralihally','577515',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25326,80,'Arnakatte','577511',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25327,80,'Attimagge','577527',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25328,80,'B.G.Kere','577529',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25329,80,'Babbur Farm','577598',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25330,80,'Bagur (Chitradurga)','577515',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25331,80,'Balenahalli','577522',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25332,80,'Ballalasamudra','577597',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25333,80,'Bangarakkanahally','577517',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25334,80,'Basavasivanakere','577541',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25335,80,'Beeranahally','577599',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25336,80,'Beesanahally','577526',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25337,80,'Belagere','577522',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25338,80,'Belaghatta','577517',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25339,80,'Belagur','577597',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25340,80,'Bhahadurghatta','577519',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25341,80,'Bharamasagara','577519',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25342,80,'Bharampura','577558',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25343,80,'Bheemasamudra','577520',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25344,80,'Bidarakere','577521',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25345,80,'Bistuvalli','577521',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25346,80,'Bokikere','577527',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25347,80,'Bommenahalli','577520',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25348,80,'Bosedevarahatti','577536',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25349,80,'Buddanahatty','577543',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25350,80,'Bukkasagara','577533',1,0,'2022-03-03 12:31:39','2022-03-03 12:31:39'),(25351,80,'Burudekatte','577554',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25352,80,'Burujanaroppa','577532',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25353,80,'Byadarahally','577546',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25354,80,'Byadareddyhally','577543',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25355,80,'Byalahal','577541',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25356,80,'Byrapura','577535',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25357,80,'Challakere Bazar','577522',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25358,80,'Challakere','577522',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25359,80,'Channammanagathihally','577538',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25360,80,'Chickjajur','577523',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25361,80,'Chikkabennur','577541',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25362,80,'Chikkabyaladakere','577533',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25363,80,'Chikkagondanahally','577502',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25364,80,'Chikkammanahally','577543',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25365,80,'Chikkandawadi','577523',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25366,80,'Chikkapura','577520',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25367,80,'Chikkayemmiganur','577523',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25368,80,'Chikkerahally','577535',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25369,80,'Chikkobanahally','577535',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25370,80,'Chitradurga  Collegeroad','577501',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25371,80,'Chitradurga  Fort','577501',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25372,80,'Chitradurga Chickpet','577501',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25373,80,'Chitradurga H.O','577501',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25374,80,'Chitrahally','577557',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25375,80,'Chitranaikanahalli','577537',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25376,80,'Chowlihalli','577519',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25377,80,'Chowlur','577538',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25378,80,'Dadagur','577540',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25379,80,'Dandinakurubarahatti','577524',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25380,80,'Devapura','577527',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25381,80,'Devaredduyhally','577529',1,0,'2022-03-03 12:31:40','2022-03-03 12:31:40'),(25382,80,'Devasamudra','577540',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25383,80,'Devigere','577527',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25384,80,'Dharmapura','577596',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25385,80,'Dindavara','577598',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25386,80,'Doddabeeranahally','577538',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25387,80,'Doddachelur','577538',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25388,80,'Doddaghatta','577598',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25389,80,'Doddaghatta','577527',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25390,80,'Doddakittadahalli','577557',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25391,80,'Doddasiddavvanahalli','577524',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25392,80,'Doddatekalavatti','577533',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25393,80,'Doddaullarthi','577537',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25394,80,'Dodderi','577522',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25395,80,'Doddiganahal','577541',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25396,80,'Dogganahal','577531',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25397,80,'Donehalli','577537',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25398,80,'Dummi','577531',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25399,80,'Durgavara','577537',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25400,80,'Dyamavvanahally','577524',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25401,80,'Echagatta','577557',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25402,80,'Ganaikanahally','577599',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25403,80,'Gangasamudra','577539',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25404,80,'Gattihosahally','577527',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25405,80,'Gavirangapura','577542',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25406,80,'Ghataparthy','577543',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25407,80,'Gilikenahalli','577526',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25408,80,'Godabanahal','577555',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25409,80,'Gonjiganur','577523',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25410,80,'Gonuru','577517',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25411,80,'Gopanahalli','577522',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25412,80,'Gosikere','577538',1,0,'2022-03-03 12:31:41','2022-03-03 12:31:41'),(25413,80,'Gowdagere','577536',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25414,80,'Gowdanahally','577598',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25415,80,'Gowdihalli','577539',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25416,80,'Gownahally','577599',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25417,80,'Gowrasamudra','577529',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25418,80,'Guddadaneralakere','577533',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25419,80,'Guddadarangavanahally','577502',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25420,80,'Guilal','577558',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25421,80,'Gunderi','577526',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25422,80,'Haikal','577517',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25423,80,'Halagaladdi','577596',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25424,80,'Halavadara','577541',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25425,80,'Halmadenahalli','577598',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25426,80,'Hampanur','577519',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25427,80,'Hangal','577535',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25428,80,'Hanumanthanahally','577529',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25429,80,'Haravigondanahalli','577522',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25430,80,'Hariyabbe','577546',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25431,80,'Harthikote','577545',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25432,80,'Hebbali','577554',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25433,80,'Heggere','577542',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25434,80,'Hemadala','577545',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25435,80,'Hireguntanur','577520',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25436,80,'Hirehally','577529',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25437,80,'Hirekandawadi','577518',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25438,80,'Hirekerehally','577535',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25439,80,'Hiremadhure','577532',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25440,80,'Hireyemmiganur','577523',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25441,80,'Hiriyur  Sugar Factory','577599',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25442,80,'Hiriyur','577598',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25443,80,'Holalkere R.S','577526',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25444,80,'Holalkere','577526',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25445,80,'Honnenahalli','577527',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25446,80,'Hosadurga','577527',1,0,'2022-03-03 12:31:42','2022-03-03 12:31:42'),(25447,80,'Hottappanahalli','577522',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25448,80,'Hulikunte','577522',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25449,80,'Hulithotlu','577558',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25450,80,'Hullehal','577521',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25451,80,'Hullur','577555',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25452,80,'Hunavinadu','577527',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25453,80,'Hunsekatte','577517',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25454,80,'Huvinahole','577598',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25455,80,'Ikkanur','577511',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25456,80,'Ingaladahal','577524',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25457,80,'Isamudra','577519',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25458,80,'Iyyanahalli','577502',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25459,80,'Jagirbuddenahally','577540',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25460,80,'Jajur','577522',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25461,80,'Jampannaikanakote','577532',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25462,80,'Janakal','577527',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25463,80,'Janthikolalu','577554',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25464,80,'Javanagondanahally','577511',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25465,80,'Jayachamarajendra Extn.','577502',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25466,80,'Junjaragunte','577538',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25467,80,'Kabbala','577597',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25468,80,'Kadabanakatte','577517',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25469,80,'Kadleguddu','577520',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25470,80,'Kadur','577523',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25471,80,'Kainadu','577542',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25472,80,'Kalaghatta','577518',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25473,80,'Kalgere','577519',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25474,80,'Kalkere','577531',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25475,80,'Kanajanahalli','577596',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25476,80,'Kanaka Circle Chitradurga','577501',1,0,'2022-03-03 12:31:43','2022-03-03 12:31:43'),(25477,80,'Kanchipura','577533',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25478,80,'Kaparahally','577522',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25479,80,'Karehalli','577533',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25480,80,'Karikere','577522',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25481,80,'Kariyala','577511',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25482,80,'Karpurakatte','577533',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25483,80,'Kasavanahally','577598',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25484,80,'Kasturirangappanahally','577511',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25485,80,'Katammadevarakote','577537',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25486,80,'Kattigehally','577521',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25487,80,'Kellodu','577527',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25488,80,'Kengunte','577531',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25489,80,'Kerehosahally','577597',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25490,80,'Khandenahalli','577596',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25491,80,'Kittadhahal','577533',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25492,80,'Kodagavalli','577523',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25493,80,'Kodihally','577543',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25494,80,'Kodihally','577511',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25495,80,'Kogunde','577519',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25496,80,'Kolahalli','577557',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25497,80,'Kolahalu','577519',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25498,80,'Konasagara','577529',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25499,80,'Kondajji','577515',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25500,80,'Kondlahalli','577529',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25501,80,'Konguvalli','577515',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25502,80,'Korlakunte','577538',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25503,80,'Kunabevu','577517',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25504,80,'Kunigali','577531',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25505,80,'Kurubarahally','577599',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25506,80,'Kurubarahally','577542',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25507,80,'Kurubarahally','577520',1,0,'2022-03-03 12:31:44','2022-03-03 12:31:44'),(25508,80,'Kurumaradikere','577524',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25509,80,'Kyadigere','577524',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25510,80,'Lakkihally','577527',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25511,80,'Lakshmisagara','577541',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25512,80,'Madadakere','577527',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25513,80,'Madakarinayakanakote','577532',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25514,80,'Madanayakanahalli','577502',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25515,80,'Madderu','577527',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25516,80,'Madhure','577527',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25517,80,'Madikerepura','577524',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25518,80,'Malali','577515',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25519,80,'Malenahalli','577526',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25520,80,'Malladihalli','577531',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25521,80,'Mallappanahalli','577554',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25522,80,'Mallappanahally','577545',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25523,80,'Mallurahalli','577536',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25524,80,'Mannekote','577543',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25525,80,'Marabhaghatta','577515',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25526,80,'Maradihalli','577532',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25527,80,'Maragondanadibba','577527',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25528,80,'Marikunte','577538',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25529,80,'Maskal','577546',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25530,80,'Matadakurabarahatty','577502',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25531,80,'Mathodu','577533',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25532,80,'Meerasabihally','577522',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25533,80,'Megalahally','577502',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25534,80,'Metikurke','577599',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25535,80,'Molakalmuru','577535',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25536,80,'Muddapura','577521',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25537,80,'Murudi','577540',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25538,80,'Mustalagummi','577536',1,0,'2022-03-03 12:31:45','2022-03-03 12:31:45'),(25539,80,'Muthugadur','577518',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25540,80,'Myaklurahally','577599',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25541,80,'Mylanahally','577537',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25542,80,'N.Mahadevapura','577536',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25543,80,'Nagaramgere','577522',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25544,80,'Nagasamudra','577535',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25545,80,'Nagathihally','577533',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25546,80,'Nannivala','577522',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25547,80,'Narayanagondanahally','577526',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25548,80,'Nayakanahatti','577536',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25549,80,'Nelagathanahatti','577536',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25550,80,'Neralahalli','577529',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25551,80,'Nerlagunte','577536',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25552,80,'Obalapura','577542',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25553,80,'Obalapura','577537',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25554,80,'P. Mahadevapura','577538',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25555,80,'Pagadalabande','577522',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25556,80,'Palavvanahally','577532',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25557,80,'Palya','577520',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25558,80,'Pandarahally','577555',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25559,80,'Parasurampura','577538',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25560,80,'Peelali','577598',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25561,80,'Pitlali','577511',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25562,80,'R. Nulenur','577539',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25563,80,'Ramaghatta','577531',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25564,80,'Ramagiri (Chitradurga)','577539',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25565,80,'Ramajogihally','577522',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25566,80,'Rampura (Chitradurga)','577540',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25567,80,'Ranganathapura','577511',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25568,80,'Rangapura','577539',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25569,80,'Rangenahally','577545',1,0,'2022-03-03 12:31:46','2022-03-03 12:31:46'),(25570,80,'Rayanahally','577502',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25571,80,'Rayapura','577535',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25572,80,'Renukapura','577537',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25573,80,'S. Nerlakere','577542',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25574,80,'Sanehally','577515',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25575,80,'Sanikere','577522',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25576,80,'Santhgudda','577540',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25577,80,'Shivaganaga','577526',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25578,80,'Shivapura','577531',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25579,80,'Siddapura','577535',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25580,80,'Siddapura','577520',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25581,80,'Siddeswaranadurga','577538',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25582,80,'Sidlaiahnakote','577545',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25583,80,'Singenahally','577539',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25584,80,'Sirigere (Chitradurga)','577541',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25585,80,'Somaguddu','577522',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25586,80,'Somenahally','577542',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25587,80,'Sondekere','577532',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25588,80,'Sondekola','577555',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25589,80,'Srirampura','577542',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25590,80,'Station Road-chitradurga','577502',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25591,80,'Sugur','577546',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25592,80,'Suragondanahally','577558',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25593,80,'Suranahally','577538',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25594,80,'T. Nagenahally','577511',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25595,80,'T.Nulenur','577557',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25596,80,'Talakatta','577539',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25597,80,'Talavatti','577558',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25598,80,'Talikatte','577539',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25599,80,'Talya','577527',1,0,'2022-03-03 12:31:47','2022-03-03 12:31:47'),(25600,80,'Tambranagara','577502',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25601,80,'Taralabalu Circle','577518',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25602,80,'Tekalavatti','577557',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25603,80,'Thallak','577543',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25604,80,'Thammenahally','577540',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25605,80,'Thandaga','577597',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25606,80,'Thimmalapura','577540',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25607,80,'Thimmanayakanakote','577538',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25608,80,'Thimmappaiahnahally','577543',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25609,80,'Thippareddyhally','577537',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25610,80,'Toparamalige','577524',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25611,80,'Toranaghatta','577521',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25612,80,'Tumkurlahalli','577535',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25613,80,'Tuppadahalli','577539',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25614,80,'Turuvanur','577517',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25615,80,'Uduvally','577598',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25616,80,'Upparigenahalli','577557',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25617,80,'Valase','577543',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25618,80,'Vanivilasapura','577599',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25619,80,'Vengalapura','577542',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25620,80,'Venkalgudda','577546',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25621,80,'Venkatapura','577540',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25622,80,'Vishwanathanahally','577526',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25623,80,'Yadalaghatta','577522',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25624,80,'Yalanadu','577598',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25625,80,'Yelagodu','577521',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25626,80,'Yelladakere','577598',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25627,80,'Yerabally','577545',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25628,81,'Addoor','574145',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25629,81,'Adyapady','574142',1,0,'2022-03-03 12:31:48','2022-03-03 12:31:48'),(25630,81,'Adyar','575007',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25631,81,'Aikala','574141',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25632,81,'Amblamogaru','575017',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25633,81,'Ashoknagar(MR)','575006',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25634,81,'Assaigoli','574199',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25635,81,'Athikaribettu','574154',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25636,81,'Badagayedapadavu','574267',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25637,81,'Baikampady','575011',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25638,81,'Bajal','575007',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25639,81,'Bajpe Airport','574142',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25640,81,'Bajpe','574142',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25641,81,'Bala','575030',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25642,81,'Balepuni','574153',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25643,81,'Balkunje','574154',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25644,81,'Balmatta','575002',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25645,81,'Bijai','575004',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25646,81,'Bikkarnakatte','575008',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25647,81,'Boliyar','574153',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25648,81,'Boloor','575003',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25649,81,'Bondanthila','575029',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25650,81,'Bondel','575008',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25651,81,'Chelairu','574146',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25652,81,'Chelur','574153',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25653,81,'Chitrapu','574154',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25654,81,'Delanthabettu','575030',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25655,81,'Derlakatte','575018',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25656,81,'District Courts (Dakshina Kannada)','575003',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25657,81,'Elathur','574150',1,0,'2022-03-03 12:31:49','2022-03-03 12:31:49'),(25658,81,'Elinje','574141',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25659,81,'Falnir','575001',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25660,81,'Farangipet','574143',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25661,81,'Fisheries College','575002',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25662,81,'Gandhinagar (Dakshina Kannada)','575003',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25663,81,'Ganjimat','574144',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25664,81,'Gurpur','574145',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25665,81,'Haleangady','574146',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25666,81,'Hampankatta','575001',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25667,81,'Harekala','574199',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25668,81,'Jeppinamogaru','575007',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25669,81,'Jokatte','575011',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25670,81,'Kairangala','574153',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25671,81,'Kakva','574154',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25672,81,'Kalavara','574142',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25673,81,'Kandavara','574151',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25674,81,'Kankanady','575002',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25675,81,'Kannur','575007',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25676,81,'Karnad','574154',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25677,81,'Karnire','574154',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25678,81,'Kateel','574148',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25679,81,'Katipalla','575030',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25680,81,'Kavathar','574154',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25681,81,'Kavur','575015',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25682,81,'Kemral Panchayat','574146',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25683,81,'Kenchanakere','574154',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25684,81,'Kenjar','574142',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25685,81,'Kinnigoli','574150',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25686,81,'Kinnikambla','574151',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25687,81,'Kinya','575023',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25688,81,'Kodiyalbail','575003',1,0,'2022-03-03 12:31:50','2022-03-03 12:31:50'),(25689,81,'Kodmannu','574143',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25690,81,'Koikude','574146',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25691,81,'Kolambe','574142',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25692,81,'Kolavoor','574144',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25693,81,'Kollur','574141',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25694,81,'Kompadavu','574144',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25695,81,'Konaje','574199',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25696,81,'Konchady','575008',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25697,81,'Kotekar','575022',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25698,81,'Krishnapura','575014',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25699,81,'Kudupu','575028',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25700,81,'Kulai','575019',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25701,81,'Kulshekar H.O','575005',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25702,81,'Kulur','575013',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25703,81,'Kumpala','575022',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25704,81,'Kunjathbail','575015',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25705,81,'Kuppepadavu','574144',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25706,81,'Kurnad','574153',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25707,81,'Kuthethur','575030',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25708,81,'Kuthethur Bajav','575030',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25709,81,'Leewell','575001',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25710,81,'Madhya','575030',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25711,81,'Malalipanchayath','574151',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25712,81,'Mallur','575029',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25713,81,'Mangalagangothri','574199',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25714,81,'Mangalanthi','575018',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25715,81,'Mangalore Collectorate','575001',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25716,81,'Mangalore H.O','575001',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25717,81,'Meenakaliya','575010',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25718,81,'Mercara Hill','575002',1,0,'2022-03-03 12:31:51','2022-03-03 12:31:51'),(25719,81,'Mermajal','574143',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25720,81,'Mogaru','574144',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25721,81,'Montepadavu','574153',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25722,81,'Moodushedde','575028',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25723,81,'MSEZ Colony','575019',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25724,81,'Muchur','574144',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25725,81,'Muduperar','574151',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25726,81,'Mukka','574146',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25727,81,'Mulki Bazar','574154',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25728,81,'Mulki East','574154',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25729,81,'Mulki','574154',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25730,81,'Munnur','575017',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25731,81,'Nadugodu','574150',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25732,81,'Nagori','575007',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25733,81,'Naringana','575018',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25734,81,'Neermarga','575029',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25735,81,'Neerude','574144',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25736,81,'PACE Campus','574199',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25737,81,'Padil','575007',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25738,81,'Padu','575029',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25739,81,'Padupanambur','574146',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25740,81,'Paduperar','574142',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25741,81,'Panambur','575010',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25742,81,'Panjimogaru','575013',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25743,81,'Panjinadka','574154',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25744,81,'Pavur','574199',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25745,81,'Pedamale','575029',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25746,81,'Pejavara','574142',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25747,81,'Permannur','575017',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25748,81,'Permude','574509',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25749,81,'Phajiru','574199',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25750,81,'Pudu','574143',1,0,'2022-03-03 12:31:52','2022-03-03 12:31:52'),(25751,81,'Punaroor','574150',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25752,81,'Sadashivanagar','574154',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25753,81,'Sandspit','575013',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25754,81,'Sasihithlu','574146',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25755,81,'Shakthinagar (Dakshina Kannada)','575016',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25756,81,'Shimanthoor','574154',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25757,81,'Sibrikere','574144',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25758,81,'Someshwar Uchil','575023',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25759,81,'Srinivasnagar','575025',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25760,81,'Surathkal','575014',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25761,81,'Surinje','575030',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25762,81,'Talapady','575023',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25763,81,'Thokur','574146',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25764,81,'Thumbe','574143',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25765,81,'Ulaibettu','574145',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25766,81,'Ullal','575020',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25767,81,'Valachil','574143',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25768,81,'Vamanjoor','575028',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25769,81,'Yekkar','574509',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25770,81,'Adyanadka','574260',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25771,81,'Agrar','574211',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25772,81,'Aivernad','574239',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25773,81,'Ajilamogru','574211',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25774,81,'Ajjavara','574239',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25775,81,'Ajjibettu','574324',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25776,81,'Alangar','574227',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25777,81,'Alankar','574285',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25778,81,'Aldangady','574217',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25779,81,'Aletty','574239',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25780,81,'Alike','574235',1,0,'2022-03-03 12:31:53','2022-03-03 12:31:53'),(25781,81,'Allipade','574211',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25782,81,'Ammunje','574219',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25783,81,'Amtady','574211',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25784,81,'Anathady','574253',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25785,81,'Andinje','574242',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25786,81,'Arambody','574237',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25787,81,'Aramboor','574314',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25788,81,'Aranthodu','574314',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25789,81,'Arasinamakki','574198',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25790,81,'Ariadka','574223',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25791,81,'Arla','574211',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25792,81,'Aryapu','574210',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25793,81,'Ashwathapura','574227',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25794,81,'Badagabellur','574219',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25795,81,'Badagakajekar','574233',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25796,81,'Badagannur','574223',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25797,81,'Bajathur','574241',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25798,81,'Bajre','574242',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25799,81,'Balanja','574217',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25800,81,'Balila','574212',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25801,81,'Ballya','574221',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25802,81,'Balpa','574232',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25803,81,'Balthila','574253',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25804,81,'Balugodu','574218',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25805,81,'Banangady','574274',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25806,81,'Bandar','574326',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25807,81,'Bangady','574214',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25808,81,'Bannur','574203',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25809,81,'Bantval','574211',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25810,81,'Barebettu','574323',1,0,'2022-03-03 12:31:54','2022-03-03 12:31:54'),(25811,81,'Barya','574326',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25812,81,'Belal','574240',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25813,81,'Bellare','574212',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25814,81,'Belloor','574219',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25815,81,'Belthangady','574214',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25816,81,'Belvai','574213',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25817,81,'Benjanapadavu','574219',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25818,81,'Bettampady','574259',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25819,81,'Bilinele','574238',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25820,81,'Biliyoor','574325',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25821,81,'Biliyoorkatte','574243',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25822,81,'Bobbekri','574328',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25823,81,'Bolanthuru','574222',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25824,81,'Bollaje','574248',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25825,81,'Bolwar','574201',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25826,81,'Borimar','574253',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25827,81,'Budoli','574253',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25828,81,'Charmadi','574228',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25829,81,'Charvaka','574328',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25830,81,'Chickmudnoor','574203',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25831,81,'Chokkadi','574212',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25832,81,'Court Hill(Puttur)','574201',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25833,81,'Dandegoli','574324',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25834,81,'Darbe(Puttur)','574202',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25835,81,'Darbethadka','574210',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25836,81,'Daregudde','574213',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25837,81,'Devachalla','574218',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25838,81,'Devarahalli','574238',1,0,'2022-03-03 12:31:55','2022-03-03 12:31:55'),(25839,81,'Dharmasthala','574216',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25840,81,'Doddathota','574248',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25841,81,'Dolpady','574328',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25842,81,'Duggaladka','574239',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25843,81,'Gandibagilu','574228',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25844,81,'Gardady','574217',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25845,81,'Gerukatte','574217',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25846,81,'Golithattu','574229',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25847,81,'Goonadka','574234',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25848,81,'Gundia','574229',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25849,81,'Guruvayanakere','574217',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25850,81,'Guthigar','574218',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25851,81,'Haleneranky','574241',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25852,81,'Hariharapallathadka','574218',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25853,81,'Hirebandady','574241',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25854,81,'Hosabettu','574227',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25855,81,'Ichilampady','574229',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25856,81,'Idkidu','574220',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25857,81,'Ilanthila','574241',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25858,81,'IRA','574323',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25859,81,'Irde','574259',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25860,81,'Ishwaramangala','574313',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25861,81,'Jakribettu','574211',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25862,81,'Jalsur','574239',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25863,81,'Jodumarga','574219',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25864,81,'Kabaka','574220',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25865,81,'Kadaba (Dakshina Kannada)','574221',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25866,81,'Kadabettu','574265',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25867,81,'Kadandale','574226',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25868,81,'Kaddya','574230',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25869,81,'Kadeshwalya','574325',1,0,'2022-03-03 12:31:56','2022-03-03 12:31:56'),(25870,81,'Kadirudyavara','574228',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25871,81,'Kagekana','574253',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25872,81,'Kaikara','574210',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25873,81,'Kaimana','574202',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25874,81,'Kakkinje','574228',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25875,81,'Kalanja','574212',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25876,81,'Kallabettu','574197',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25877,81,'Kalladka','574222',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25878,81,'Kallamundkur','574274',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25879,81,'Kalleri','574326',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25880,81,'Kallige','574219',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25881,81,'Kalmadka','574212',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25882,81,'Kalmakar','574218',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25883,81,'Kalmanja','574228',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25884,81,'Kamila','574218',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25885,81,'Kanakamajal','574223',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25886,81,'Kaniyur(Beltangady)','574217',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25887,81,'Kaniyur(Puttur)','574328',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25888,81,'Kanyadi','574240',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25889,81,'Kanyana','574279',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25890,81,'Karaya','574326',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25891,81,'Karikala','574232',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25892,81,'Karimanel','574242',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25893,81,'Karingana','574222',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25894,81,'Karinje','574265',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25895,81,'Karnoor','574313',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25896,81,'Karopady','574279',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25897,81,'Karpe','574237',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25898,81,'Kashipatna','574236',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25899,81,'Kav','574223',1,0,'2022-03-03 12:31:57','2022-03-03 12:31:57'),(25900,81,'Kavalkatte','574265',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25901,81,'Kayarthadka','574216',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25902,81,'Kedambady','574210',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25903,81,'Kedila','574220',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25904,81,'Kemminje','574202',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25905,81,'Kenya','574232',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25906,81,'Killur','574214',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25907,81,'Kodangai','574243',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25908,81,'Kodangallu','574197',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25909,81,'Kodapadavu','574222',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25910,81,'Kodimbady','574325',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25911,81,'Kodimbala','574221',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25912,81,'Kodiyala','574212',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25913,81,'Koila','574211',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25914,81,'Koila Cattle Farm(K.C. Farm)','574241',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25915,81,'Kokkada','574198',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25916,81,'Kokrady','574242',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25917,81,'Kolchar','574239',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25918,81,'Kollamogru','574218',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25919,81,'Kolnadu','574323',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25920,81,'Kombar','574230',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25921,81,'Konalu','574229',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25922,81,'Koyyur','574214',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25923,81,'Kudambettu','574324',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25924,81,'Kudippady','574220',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25925,81,'Kudmar','574202',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25926,81,'Kudripadavu','574274',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25927,81,'Kudupallathadka','574279',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25928,81,'Kukkedy','574242',1,0,'2022-03-03 12:31:58','2022-03-03 12:31:58'),(25929,81,'Kukkujadka','574212',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25930,81,'Kula','574243',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25931,81,'Kulalu','574323',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25932,81,'Kumbra','574210',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25933,81,'Kuriya','574210',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25934,81,'Kuriyala','574211',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25935,81,'Kurunjibag','574327',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25936,81,'Kuthkunja','574232',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25937,81,'Kutlur','574109',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25938,81,'Kutrupady','574221',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25939,81,'Kuvettu','574224',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25940,81,'Laila','574214',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25941,81,'Loretto','574211',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25942,81,'Machina','574224',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25943,81,'Madanthyar','574224',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25944,81,'Madappady','574218',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25945,81,'Madav','574210',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25946,81,'Malady','574224',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25947,81,'Malavanthige','574214',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25948,81,'Manchi','574323',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25949,81,'Mandekole','574239',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25950,81,'Mangalapadavu','574243',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25951,81,'Mani','574253',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25952,81,'Manikar','574212',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25953,81,'Maninalkur','574265',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25954,81,'Mantrady','574236',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25955,81,'Mardala','574230',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25956,81,'Markanja','574248',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25957,81,'Marody','574236',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25958,81,'Maroor','574197',1,0,'2022-03-03 12:31:59','2022-03-03 12:31:59'),(25959,81,'Mavinakatte','574324',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25960,81,'Melanthabettu','574214',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25961,81,'Mijar','574225',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25962,81,'Mithabail','574226',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25963,81,'Modankap','574219',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25964,81,'Mogru','574241',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25965,81,'Moodambail','574260',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25966,81,'Moodbidri','574227',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25967,81,'Moodumarnad','574213',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25968,81,'Mottethadka','574202',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25969,81,'Mudukodi','574242',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25970,81,'Mudupadukodi','574265',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25971,81,'Mundaje','574228',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25972,81,'Mundur','574202',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25973,81,'Mupperia','574212',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25974,81,'Murulya','574328',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25975,81,'Murva','574243',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25976,81,'Nadugallu','574218',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25977,81,'Nainad','574233',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25978,81,'Nala','574217',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25979,81,'Naravi','574109',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25980,81,'Narikombu','574231',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25981,81,'Narimogru','574202',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25982,81,'Navoor(Bantval)','574211',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25983,81,'Navoor(Belt)','574214',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25984,81,'Nayarmoole','574243',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25985,81,'Neerkaje','574243',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25986,81,'Nehrunagar(Puttur DK)','574203',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25987,81,'Nekkilady(34)','574325',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25988,81,'Nellikar','574107',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25989,81,'Nellur Kemraje','574248',1,0,'2022-03-03 12:32:00','2022-03-03 12:32:00'),(25990,81,'Nellyadi','574229',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(25991,81,'Neralakatte','574253',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(25992,81,'Neria','574228',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(25993,81,'Nettana','574230',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(25994,81,'Niddodi','574274',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(25995,81,'Nidle','574216',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(25996,81,'Nidpalli','574259',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(25997,81,'Nittade','574242',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(25998,81,'Noojibalthila','574221',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(25999,81,'Odiyoor','574243',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(26000,81,'Old Town Ujire','574240',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(26001,81,'Padangady','574217',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(26002,81,'Padnur','574220',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(26003,81,'Padukonaje','574236',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(26004,81,'Padumarnad','574213',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(26005,81,'Pailar','574248',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(26006,81,'Paladka','574226',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(26007,81,'Palthady','574210',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(26008,81,'Pambethady','574232',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(26009,81,'Panaje','574259',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(26010,81,'Panakaje','574224',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(26011,81,'Panemangalore','574231',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(26012,81,'Panja','574232',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(26013,81,'Panjikal','574211',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(26014,81,'Perabe','574285',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(26015,81,'Perady','574236',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(26016,81,'Peral','574239',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(26017,81,'Peramogru','574325',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(26018,81,'Peranja','574197',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(26019,81,'Perlampady','574212',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(26020,81,'Permanu','574214',1,0,'2022-03-03 12:32:01','2022-03-03 12:32:01'),(26021,81,'Pernaje','574223',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26022,81,'Perne','574325',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26023,81,'Peruvai','574260',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26024,81,'Peruvaje','574212',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26025,81,'Petrame','574198',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26026,81,'Pilya','574217',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26027,81,'Polali','574219',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26028,81,'Puchamogru','574237',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26029,81,'Puduvettu','574216',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26030,81,'Puncha','574243',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26031,81,'Punchappady','574202',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26032,81,'Punjalkatte','574233',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26033,81,'Puthila','574326',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26034,81,'Puttur(D.K.) H.O','574201',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26035,81,'Ramakunja','574241',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26036,81,'Rayee','574211',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26037,81,'Rekya','574229',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26038,81,'Renjilady','574221',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26039,81,'S.D.M.C.Ujire','574240',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26040,81,'Sajipamudu','574231',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26041,81,'Sajipamunnur','574231',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26042,81,'Sajipanadu','574231',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26043,81,'Sajipapadu','574231',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26044,81,'Salethur','574323',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26045,81,'Samedakalapu','574216',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26046,81,'Sampaje','574234',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26047,81,'Sampige','574227',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26048,81,'Sarapady','574211',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26049,81,'Sarve','574202',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26050,81,'Sathya Sai Vihar','574235',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26051,81,'Savanal','574214',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26052,81,'Savanur(Puttur)','574202',1,0,'2022-03-03 12:32:02','2022-03-03 12:32:02'),(26053,81,'Savya','574242',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26054,81,'Shamboor','574231',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26055,81,'Shanthigodu','574202',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26056,81,'Sharavoor','574285',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26057,81,'Shibaje','574198',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26058,81,'Shirady','574229',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26059,81,'Shirthady','574236',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26060,81,'Shishila','574198',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26061,81,'Siddakatte','574237',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26062,81,'Sirlalu','574217',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26063,81,'Sonangeri','574239',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26064,81,'Soole Padavu','574313',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26065,81,'Sornad','574211',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26066,81,'Subramanya','574238',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26067,81,'Sulkeri','574109',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26068,81,'Sullia Gandhinagar','574239',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26069,81,'Sullia','574239',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26070,81,'Sunkadakatte','574230',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26071,81,'Taccode','574197',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26072,81,'Tannirpantha','574326',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26073,81,'Tenkakajekar','574233',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26074,81,'Tenkakarandur','574217',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26075,81,'Thekkar','574241',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26076,81,'Thodar','574227',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26077,81,'Thodikana','574314',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26078,81,'Thotathady','574228',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26079,81,'Ubbaradka Mithur','574248',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26080,81,'Ujire','574240',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26081,81,'Ujirpade','574203',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26082,81,'Uli','574326',1,0,'2022-03-03 12:32:03','2022-03-03 12:32:03'),(26083,81,'Uppinangady','574241',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26084,81,'Uruvalu','574326',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26085,81,'Valpady','574236',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26086,81,'Vamadapadavu','574324',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26087,81,'Veerakamba','574222',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26088,81,'Venur','574242',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26089,81,'Vidyagiri (Moodbidri)','574227',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26090,81,'Vittal Mudnur','574243',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26091,81,'Vittal','574243',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26092,81,'Vodilnala','574217',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04');
INSERT INTO `cities` VALUES (26093,81,'Vogga','574265',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26094,81,'Volalu','574241',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26095,81,'Yedamangala','574221',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26096,81,'Yenekal','574238',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26097,81,'Yenmur','574328',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26098,82,'Adavihalli','583131',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26099,82,'Aladahalli','583127',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26100,82,'Alagilawada','583137',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26101,82,'Anajigere','583125',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26102,82,'Arasanahalu','583213',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26103,82,'Arasikere','583125',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26104,82,'Bagali','583131',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26105,82,'Bendigere','583137',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26106,82,'Bennihalli','583127',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26107,82,'Chatnihalli','583125',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26108,82,'Chigatere','583127',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26109,82,'Chirastahalli','583137',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26110,82,'Duggavati','583137',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26111,82,'Garbhagudi ','583213',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26112,82,'Goverahalli','583131',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26113,82,'Gundagatti','583137',1,0,'2022-03-03 12:32:04','2022-03-03 12:32:04'),(26114,82,'Hagarigudihalli','583127',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26115,82,'Halavagalu','583213',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26116,82,'Halli Kere','583125',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26117,82,'Harakanahalu','583131',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26118,82,'Harapanahalli Joshi Street','583131',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26119,82,'Harapanahalli','583131',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26120,82,'Harapanahalli Town','583131',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26121,82,'Hiremagalagere','583125',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26122,82,'Hosakota','583125',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26123,82,'Hulikatti','583131',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26124,82,'Ittigudi','583213',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26125,82,'Kadabagere','583125',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26126,82,'Kadathi','583137',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26127,82,'Kallahalli','583213',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26128,82,'Kammathahalli','583125',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26129,82,'Kanchikere','583125',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26130,82,'Kanvihalli','583131',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26131,82,'Kulahalli','583131',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26132,82,'Kunchur','583213',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26133,82,'Kyarakatte','583125',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26134,82,'Machihalli','583137',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26135,82,'Madihalli','583125',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26136,82,'Madlagere','583131',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26137,82,'Mattihalli','583127',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26138,82,'Mydur','583127',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26139,82,'Nandibevoor','583131',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26140,82,'Neelagunda','583213',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26141,82,'Nichapura','583127',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26142,82,'Nichavvanahalli','583125',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26143,82,'Nittur','583213',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26144,82,'Pothalakatta','583125',1,0,'2022-03-03 12:32:05','2022-03-03 12:32:05'),(26145,82,'Punabhagatta','583125',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26146,82,'Ragimasalawada','583137',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26147,82,'Ramagatta','583125',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26148,82,'Sasvihalli','583127',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26149,82,'Sattur','583125',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26150,82,'Singrihalli','583137',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26151,82,'Siriganahalli','583137',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26152,82,'Talavagalu','583137',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26153,82,'Tavadur','583125',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26154,82,'Tavaragundi','583213',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26155,82,'Teligi','583137',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26156,82,'Togarikatti','583131',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26157,82,'Uchangidurga','583125',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26158,82,'Upparagere','583131',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26159,82,'Yarabalu','583137',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26160,82,'Yedihalli','583137',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26161,82,'Ukkadagatri','581119',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26162,82,'Alur','577512',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26163,82,'Amaravathi','577601',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26164,82,'Anaberu','577534',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26165,82,'Anaburu','577528',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26166,82,'Anagodu','577556',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26167,82,'Anaji','577512',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26168,82,'Annapura','577534',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26169,82,'Asagodu','577513',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26170,82,'Attigere','577514',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26171,82,'Avaragere','577003',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26172,82,'Avaragolla','577589',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26173,82,'Bada','577514',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26174,82,'Ballur','577525',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26175,82,'Bannikodu','577516',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26176,82,'Bapuji Vidyanagara','577005',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26177,82,'Barline Road-Davanagere','577001',1,0,'2022-03-03 12:32:06','2022-03-03 12:32:06'),(26178,82,'Basavanahal','577002',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26179,82,'Basavanakote','577513',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26180,82,'Belavanur','577002',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26181,82,'Belludi','577601',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26182,82,'Bethur','577002',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26183,82,'Bhanuvally','577516',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26184,82,'Bharamapuri Extension','577601',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26185,82,'Bharamasamudra','577528',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26186,82,'Bilasanur','577516',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26187,82,'Bilichodu','577553',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26188,82,'Bndurga','577518',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26189,82,'Cg Hospital','577004',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26190,82,'Chaduragolla','577553',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26191,82,'Chikkamallanahole','577528',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26192,82,'Chitradurga  Dist Office','577501',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26193,82,'Davanagere City','577002',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26194,82,'Davangere H.O','577001',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26195,82,'Devarabelakere','577002',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26196,82,'Devaraj Urs Layout-Dvg','577006',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26197,82,'Devikere','577553',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26198,82,'Diddige','577513',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26199,82,'Doddabathi','577566',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26200,82,'Donehalli','577528',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26201,82,'Dulehole','577516',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26202,82,'Echaghatta','577534',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26203,82,'Gadimakunte','577528',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26204,82,'Gopanahalu','577514',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26205,82,'Govinahalu','577530',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26206,82,'Gudahal','577512',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26207,82,'Guddadabevinahalli','577530',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26208,82,'Gulladahalli','577530',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26209,82,'Gurusiddapura','577513',1,0,'2022-03-03 12:32:07','2022-03-03 12:32:07'),(26210,82,'Guttidurga','577553',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26211,82,'Guttur','577601',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26212,82,'H.D.Pura','577557',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26213,82,'Hadadi','577525',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26214,82,'Halivana','577530',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26215,82,'Hanagawadi','577601',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26216,82,'Hanumanthapura','577528',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26217,82,'Harihara Fort','577601',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26218,82,'Harihara','577601',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26219,82,'Hebbal','577556',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26220,82,'Helekallu','577553',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26221,82,'Hemmanabethur','577512',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26222,82,'Hiremallanahole','577528',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26223,82,'Hirethogaleri','577514',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26224,82,'Hlebathi','577566',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26225,82,'Honnur','577556',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26226,82,'Hosakere','577528',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26227,82,'Hucchavvanahalli','577528',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26228,82,'Huchhavvanahalli','577534',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26229,82,'Hulikatte','577512',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26230,82,'Igoor','577512',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26231,82,'Jagalur','577528',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26232,82,'Jayadeva Circle-Davanagere','577002',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26233,82,'Jigali','577530',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26234,82,'Kadajji','577002',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26235,82,'Kadlebalu','577589',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26236,82,'Kadrinayakanahalli','577516',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26237,82,'Kaidale','577525',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26238,82,'Kakkaragolla','577589',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26239,82,'Kalledevarapura','577528',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26240,82,'Kamalapura','577516',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26241,82,'Kanagondanahalli','577525',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26242,82,'Kandagal','577514',1,0,'2022-03-03 12:32:08','2022-03-03 12:32:08'),(26243,82,'Kanukuppa','577528',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26244,82,'Kasturaba Extension','577002',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26245,82,'Kenchanahalli','577528',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26246,82,'Kenchenahalli','577589',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26247,82,'Kittur','577512',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26248,82,'Kodaganur','577534',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26249,82,'Kokkanur','577530',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26250,82,'Kolkunte','577002',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26251,82,'Komaranahalli','577530',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26252,82,'Kondajji','577589',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26253,82,'Krishnarajendra Road-DVG','577001',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26254,82,'Kukkuwada','577525',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26255,82,'Kumbalur','577530',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26256,82,'Kundawada','577566',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26257,82,'Kunibelakere','577601',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26258,82,'Kurki','577514',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26259,82,'Kyasenahalli','577528',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26260,82,'Lokikere','577002',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26261,82,'Malalkere','577514',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26262,82,'Malebennur','577530',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26263,82,'Mallekatte','577512',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26264,82,'Mandalur','577556',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26265,82,'Marenahalli','577528',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26266,82,'Mathi','577525',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26267,82,'Mayakonda','577534',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26268,82,'Medegenaikere','577553',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26269,82,'Medekerenahalli','577553',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26270,82,'Mini Vidhanasoudha','577006',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26271,82,'Modi Circle-Davanagere','577004',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26272,82,'Mudahadadi','577002',1,0,'2022-03-03 12:32:09','2022-03-03 12:32:09'),(26273,82,'Murikunte','577513',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26274,82,'Mustegerahalli','577553',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26275,82,'Mustur','577528',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26276,82,'Nalikunda','577534',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26277,82,'Nandigavi','577516',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26278,82,'Nanditavare','577601',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26279,82,'Naraganahalli','577534',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26280,82,'Nerligi','577556',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26281,82,'Nirthadi','577556',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26282,82,'Nittur','577530',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26283,82,'Nittuvalli','577004',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26284,82,'Pallaghatta','577513',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26285,82,'Rajanahalli','577601',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26286,82,'Rajaramnagar Colony-','577601',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26287,82,'Ramagondanahalli','577514',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26288,82,'Rastemachikere','577553',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26289,82,'Rm Yard- Davanagere','577003',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26290,82,'S.S.Layout','577004',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26291,82,'Salahalli','577528',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26292,82,'Sarathi','577601',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26293,82,'Shyagale','577002',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26294,82,'Shyamanur','577004',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26295,82,'Siddainakote','577513',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26296,82,'Siramagondanahalli','577005',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26297,82,'Sirigere (Harihara)','577516',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26298,82,'Sks Nagar-Davanagere','577005',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26299,82,'Sokke','577528',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26300,82,'Southern Extension-DVG','577004',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26301,82,'Tholahunse','577002',1,0,'2022-03-03 12:32:10','2022-03-03 12:32:10'),(26302,82,'Tumbigre','577512',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26303,82,'Vasana','577516',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26304,82,'Vinobhanagara Extn-DVG','577006',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26305,82,'Yantrapura-Harihara','577601',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26306,82,'Yelehole','577516',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26307,82,'Agarabannihatti','577213',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26308,82,'Ajjihalli','577213',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26309,82,'Arabagatta','577217',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26310,82,'Aralikatte','577552',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26311,82,'Arekere','577217',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26312,82,'Arundi','577223',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26313,82,'Bannikodu','577219',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26314,82,'Basavanahalli','577217',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26315,82,'Basavapatna (Davangere)','577551',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26316,82,'Beeragondanahalli','577224',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26317,82,'Belagutti','577223',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26318,82,'Belalagere','577231',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26319,82,'Belimallur','577217',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26320,82,'Belliganoodu','577552',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26321,82,'Benakanahalli','577224',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26322,82,'Bulsagar','577221',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26323,82,'Channagiri','577213',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26324,82,'Channapura','577218',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26325,82,'Channeshapura','577221',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26326,82,'Channnagiri Town','577213',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26327,82,'Chattanahalli','577225',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26328,82,'Chikkagangoor','577215',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26329,82,'Chilur','577230',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26330,82,'Chilurkadadakatte','577230',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26331,82,'Chinnikatte','577225',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26332,82,'Chirdoni','577231',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26333,82,'Daginakatte','577551',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26334,82,'Devanaikanahalli','577217',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26335,82,'Devarahalli','577213',1,0,'2022-03-03 12:32:11','2022-03-03 12:32:11'),(26336,82,'Doddabbigere','577552',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26337,82,'Doddaghatta','577544',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26338,82,'Doddethinahalli','577223',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26339,82,'Donihalli','577213',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26340,82,'Durvegere','577213',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26341,82,'Gondichatnahalli','577216',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26342,82,'Gopagondanahalli','577217',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26343,82,'Goppenahalli','577215',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26344,82,'Govinakovi','577230',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26345,82,'Guddada Kommaranahalli','577221',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26346,82,'Guddehalli','577223',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26347,82,'Hanagawadi','577243',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26348,82,'Hanumanahalli','577224',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26349,82,'Hanumasagara','577217',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26350,82,'Haralahalli','577230',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26351,82,'Haronahalli','577213',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26352,82,'Hathurbalmuri','577217',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26353,82,'Hebbalagere','577215',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26354,82,'Hiregonigere','577217',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26355,82,'Hirekogalur','577552',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26356,82,'Hiremalali','577221',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26357,82,'Hodikere','577215',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26358,82,'Holeharalahalli','577217',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26359,82,'Honnali','577217',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26360,82,'Hosahalli','577224',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26361,82,'Ittige','577221',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26362,82,'Jeenahalli','577223',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26363,82,'Joga','577225',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26364,82,'Joladhall','577213',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26365,82,'Kagathur','577221',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26366,82,'Kakanur','577552',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26367,82,'Kammaragatte','577224',1,0,'2022-03-03 12:32:12','2022-03-03 12:32:12'),(26368,82,'Kanchiganahalu','577215',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26369,82,'Kanivebilichi','577231',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26370,82,'Karekatte','577544',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26371,82,'Kariganur','577219',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26372,82,'Kathige','577223',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26373,82,'Kathlagere','577219',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26374,82,'Kenchikoppa','577223',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26375,82,'Kerebilichi','577218',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26376,82,'Kondadahalli','577552',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26377,82,'Kortikere','577215',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26378,82,'Kotehal','577230',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26379,82,'Kulaghatte','577224',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26380,82,'Kulambi','577219',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26381,82,'Kumblur','577219',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26382,82,'Kundur','577219',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26383,82,'Kyasinakere','577224',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26384,82,'Lingadahalli','577221',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26385,82,'Madanabhavi','577223',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26386,82,'Mallapura','577218',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26387,82,'Marabanahalli','577551',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26388,82,'Masadi','577217',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26389,82,'Medikere','577552',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26390,82,'Medugondanahalli','577213',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26391,82,'Muddanahalli','577427',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26392,82,'Mugalihalli','577213',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26393,82,'Mujarehanumanahalli','577219',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26394,82,'Muktenahalli','577219',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26395,82,'Nalkudre','577544',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26396,82,'Nallur (Davangere)','577221',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26397,82,'Navilehalu','577544',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26398,82,'Neetigere','577215',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26399,82,'Nyamthi','577223',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26400,82,'Pandomatti','577213',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26401,82,'Punyasthla','577551',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26402,82,'Rajagondanahalli','577213',1,0,'2022-03-03 12:32:13','2022-03-03 12:32:13'),(26403,82,'Rampura(Honnali)','577224',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26404,82,'Rudrapura','577218',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26405,82,'Santhebennur','577552',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26406,82,'Sasvehalli','577224',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26407,82,'Saualanga','577225',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26408,82,'Siddanamatha','577552',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26409,82,'Somlapura','577218',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26410,82,'Soratur','577217',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26411,82,'Sunkadakatte','577217',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26412,82,'Surahonne','577223',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26413,82,'Tanigere','577552',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26414,82,'Taraganahalli','577217',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26415,82,'Tavarekere','577213',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26416,82,'Thippegondanahalli','577213',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26417,82,'Thyavanige','577544',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26418,82,'Vaderahathur','577223',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26419,82,'Voddanahalu','577215',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26420,82,'Yakkanahalli','577219',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26421,82,'Yaraganahalu','577223',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26422,83,'Adaragunchi','580028',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26423,83,'Agadi','581207',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26424,83,'Alagawadi','582208',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26425,83,'Alnavar','581103',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26426,83,'Amargol','582208',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26427,83,'Amminabhavi','581201',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26428,83,'Amragol','580025',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26429,83,'Anchatageri','580024',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26430,83,'Annegeri Market','582201',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26431,83,'Annigeri','582201',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26432,83,'Aralikatti','581207',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26433,83,'Aravatagi','580007',1,0,'2022-03-03 12:32:14','2022-03-03 12:32:14'),(26434,83,'Arekurahatti','582208',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26435,83,'B K Tarlagatta','581113',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26436,83,'Bagadageri','581196',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26437,83,'Ballarwad','581209',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26438,83,'Bammigatti','581204',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26439,83,'Banagitti Gudihal','580114',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26440,83,'Baradwad','581195',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26441,83,'Basapur','582201',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26442,83,'Begur','581204',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26443,83,'Belagali','580024',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26444,83,'Belavantar','581204',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26445,83,'Belavatgi','582208',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26446,83,'Benachi','581103',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26447,83,'Betdur','581207',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26448,83,'Bhadrapur','582201',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26449,83,'Bhairidevarkoppa','580025',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26450,83,'Biravalli','581204',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26451,83,'Byahatti','580023',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26452,83,'Byalal','581201',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26453,83,'Chakalabbi','581113',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26454,83,'Chebbi','581207',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26455,83,'Chikkamalligawad','580007',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26456,83,'Dastikoppa','581204',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26457,83,'Datnal','582208',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26458,83,'Devanur','581113',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26459,83,'Devarahubballi','580118',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26460,83,'Devikoppa','581204',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26461,83,'Dharwad City','580001',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26462,83,'Dharwad Farm','580007',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26463,83,'Dharwad Gtc','580007',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26464,83,'Dharwad H.O','580001',1,0,'2022-03-03 12:32:15','2022-03-03 12:32:15'),(26465,83,'Dharwad High Court','580011',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26466,83,'Dharwad K V V','580003',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26467,83,'Dharwad K.C.Park','580008',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26468,83,'Dharwad Kalyan Nagar','580007',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26469,83,'Dharwad Kutchery','580001',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26470,83,'Dharwad Line Bazar','580001',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26471,83,'Dharwad M B Nagar','580008',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26472,83,'Dharwad M J Nagar','580006',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26473,83,'Dharwad Market','580001',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26474,83,'Dharwad Narayanpur','580008',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26475,83,'Dharwad R S','580007',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26476,83,'Dharwad S D M E college','580002',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26477,83,'Dharwad Saptapur','580001',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26478,83,'Dharwad Saraswatpur','580002',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26479,83,'Dharwad Sattur','580009',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26480,83,'Dharwad Tejaswi Nagar','580002',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26481,83,'Dharwad U A S','580005',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26482,83,'Dharwad Vidyagiri','580004',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26483,83,'Dhumwad','580114',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26484,83,'G Basavanakoppa','580114',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26485,83,'Gambhyapur','580114',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26486,83,'Ganjigatti','581196',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26487,83,'Garag','581105',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26488,83,'Gokul','580030',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26489,83,'Gopankoppa','580023',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26490,83,'Goudageri','581107',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26491,83,'Guddadhulikatti','580024',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26492,83,'Gudenakatti','581113',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26493,83,'Gudgeri','581107',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26494,83,'Gudisagar','582208',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26495,83,'Halekusugal','582208',1,0,'2022-03-03 12:32:16','2022-03-03 12:32:16'),(26496,83,'Halligeri','580118',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26497,83,'Hallihal','580023',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26498,83,'Hallikeri','582201',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26499,83,'Harlapur','581107',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26500,83,'Harobelvadi','581201',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26501,83,'Hebbal','582208',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26502,83,'Hebballi','580112',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26503,83,'Hebsur','581209',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26504,83,'Hiregunjal','581117',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26505,83,'Hireharakuni','581113',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26506,83,'Hirehonnihalli','580114',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26507,83,'Hirenarthi','581113',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26508,83,'Honnapur','580007',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26509,83,'Hubli Bankapur Chowki','580028',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26510,83,'Hubli Bengeri','580023',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26511,83,'Hubli Bharat Mill','580029',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26512,83,'Hubli City','580020',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26513,83,'Hubli Eng College','580031',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26514,83,'Hubli Gandhi Nagar','580030',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26515,83,'Hubli H.O','580020',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26516,83,'Hubli Keshwapur','580023',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26517,83,'Hubli KMC','580021',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26518,83,'Hubli Mangalwar Peth','580020',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26519,83,'Hubli Moorsavirmath','580028',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26520,83,'Hubli Mv Galli','580028',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26521,83,'Hubli Navanagar','580025',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26522,83,'Hubli Nekarnagar','580024',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26523,83,'Hubli Sarafkatta','580020',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26524,83,'Hubli Siddharoodnagar','580024',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26525,83,'Hubli Tabibland','580020',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26526,83,'Hubli Tarihal Indl. Estate','580026',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26527,83,'Hubli Traffic Island','580029',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26528,83,'Hubli Udyamnagar','580030',1,0,'2022-03-03 12:32:17','2022-03-03 12:32:17'),(26529,83,'Hubli Unkal','580031',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26530,83,'Hubli Vidyanagar','580021',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26531,83,'Hubli Vijayanagar','580032',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26532,83,'Hubli Vinobanagar','580020',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26533,83,'Hulkoppa','580118',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26534,83,'Ibrahimpur','582208',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26535,83,'Ingalahalli','581209',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26536,83,'Ingalgi','580028',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26537,83,'Jawoor','582208',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26538,83,'Jinnur','581204',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26539,83,'Kabbenur','581201',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26540,83,'Kadabagatti','581103',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26541,83,'Kalakundi','581204',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26542,83,'Kalas','581107',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26543,83,'Kalghatagi','581204',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26544,83,'Kalkeri','580007',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26545,83,'Kallur','581206',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26546,83,'Kalwad','582208',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26547,83,'Kamadenu','581196',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26548,83,'Kamadolli','581113',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26549,83,'Kambarganavi','580007',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26550,83,'Kanavihonnapur','580114',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26551,83,'Karadigudda','581201',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26552,83,'Karadikoppa','580024',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26553,83,'Katnur','580024',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26554,83,'Kavalgeri','580006',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26555,83,'Kelageri','580007',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26556,83,'Kittur','582201',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26557,83,'Koliwad','581195',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26558,83,'Kondikoppa','582201',1,0,'2022-03-03 12:32:18','2022-03-03 12:32:18'),(26559,83,'Kotabagi','581105',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26560,83,'Kotur','580011',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26561,83,'Kubihal','580028',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26562,83,'Kudalagi','581204',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26563,83,'Kundgol','581113',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26564,83,'Kurabagatti','581105',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26565,83,'Kusugal','580023',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26566,83,'Kyarakoppa','580007',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26567,83,'Lokur','581206',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26568,83,'Madhanabhavi','581105',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26569,83,'Majjigudda','581195',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26570,83,'Malali','580024',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26571,83,'Managundi','580007',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26572,83,'Manakawad','581209',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26573,83,'Mantur','580023',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26574,83,'Maradagi','580112',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26575,83,'Marewad','581201',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26576,83,'Mattigatti','580028',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26577,83,'Mishrikoti','581196',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26578,83,'Morab','580112',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26579,83,'Mugad','580007',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26580,83,'Mukkal','581204',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26581,83,'Mummigatti','580011',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26582,83,'Muttagi','581204',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26583,83,'Naganur','582208',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26584,83,'Naiknur','582208',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26585,83,'Nalawadi','580023',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26586,83,'Narendra','580005',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26587,83,'Navalgund','582208',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26588,83,'Navalur','580009',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26589,83,'Nigadi','580118',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26590,83,'Nulvi','580028',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26591,83,'Old Hubli','580024',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26592,83,'Pashupatihal','581117',1,0,'2022-03-03 12:32:19','2022-03-03 12:32:19'),(26593,83,'Pudakalakatti','581206',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26594,83,'Ramankoppa','580024',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26595,83,'Ramapur','580007',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26596,83,'Rayanal','580024',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26597,83,'Rayapur','580009',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26598,83,'Rottigawad','581195',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26599,83,'Sadhankeri','580007',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26600,83,'Salakinkoppa','580118',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26601,83,'Saswihalli','582201',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26602,83,'Saunshi','581117',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26603,83,'Shanawad','582208',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26604,83,'Shelwadi','582208',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26605,83,'Sherewad','580028',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26606,83,'Shinganalli','580011',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26607,83,'Shiraguppi','580023',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26608,83,'Shirkol','580112',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26609,83,'Shirur','581113',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26610,83,'Shirur','581201',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26611,83,'Shishuvinahalli','581209',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26612,83,'Shivalli','580112',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26613,83,'Sulikatti','581204',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26614,83,'Sulla','580023',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26615,83,'Surashettikoppa','581196',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26616,83,'Tabakadhonnihalli','581204',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26617,83,'Tadahal','582208',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26618,83,'Tadakod','581105',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26619,83,'Tambur','581204',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26620,83,'Tavarageri','581204',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26621,83,'Tegur','580011',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26622,83,'Tirlapur','582208',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26623,83,'Tumarikoppa','581204',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26624,83,'Tuppadkurahatti','582208',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26625,83,'Ugginakeri','581196',1,0,'2022-03-03 12:32:20','2022-03-03 12:32:20'),(26626,83,'Umachagi','581195',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26627,83,'Uppinabetageri','581206',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26628,83,'Varur','581207',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26629,83,'Yadwad','581206',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26630,83,'Yaliwal','581207',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26631,83,'Yamanur','582208',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26632,83,'Yeraguppi','580023',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26633,83,'Yerebudhihal','581117',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26634,83,'Yerikoppa','580114',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26635,84,'Abbigeri','582111',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26636,84,'Adarkatti','582116',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26637,84,'Adrahalli','582116',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26638,84,'Advisomapur','582103',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26639,84,'Anturbentur','582205',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26640,84,'Arahunsi','582209',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26641,84,'Asuti','582203',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26642,84,'Attikatti','582103',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26643,84,'Bagewadi','582118',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26644,84,'Balaganur','582102',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26645,84,'Balehosur','582116',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26646,84,'Banhatti','582207',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26647,84,'Bannikoppa','582112',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26648,84,'Bardur','582113',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26649,84,'Battur','582116',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26650,84,'Beldhadi','582103',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26651,84,'Belhod','582204',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26652,84,'Bellatti','582112',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26653,84,'Belvanki','582202',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26654,84,'Bhairanhatti','582207',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26655,84,'Bidarahalli','582118',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26656,84,'Bidinhal','582118',1,0,'2022-03-03 12:32:21','2022-03-03 12:32:21'),(26657,84,'Binkadkatti','582103',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26658,84,'Bsavanna Camp','583229',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26659,84,'Chebbi','582120',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26660,84,'Chickhandigol','582205',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26661,84,'Chicknargund','582207',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26662,84,'Chickwaddatti','582118',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26663,84,'Chikamannur','582209',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26664,84,'Chilzeri','582114',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26665,84,'Chinchali','582117',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26666,84,'D S Hadagali','582102',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26667,84,'Dambal','582113',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26668,84,'Doddur','582116',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26669,84,'Doni','582103',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26670,84,'Futgaon Badni','582116',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26671,84,'Gadag Bazar','582101',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26672,84,'Gadag Betgeri','582102',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26673,84,'Gadag City','582103',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26674,84,'Gadag Cotton Market','582101',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26675,84,'Gadag Extension','582101',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26676,84,'Gadag Gangapurpeth','582103',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26677,84,'Gadag H.O','582101',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26678,84,'Gadag J T College','582102',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26679,84,'Gadag Mulgund Naka','582103',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26680,84,'Gajendragad','582114',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26681,84,'Gangavathi ARS','583227',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26682,84,'Gogeri','582114',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26683,84,'Gojanur','582116',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26684,84,'Gujamagadi','582102',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26685,84,'Gundur Camp','583282',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26686,84,'Hadli','582207',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26687,84,'Halkeri','582119',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26688,84,'Halligudi','582115',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26689,84,'Hallikeri','582115',1,0,'2022-03-03 12:32:22','2022-03-03 12:32:22'),(26690,84,'Halwagali','583226',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26691,84,'Hammigi','582118',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26692,84,'Harlapur','582115',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26693,84,'Harogeri','582113',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26694,84,'Harti','582103',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26695,84,'Hatalgeri','582115',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26696,84,'Hebbal','582112',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26697,84,'Hesrur','582118',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26698,84,'Hirehal','582209',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26699,84,'Hirekoppa','582207',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26700,84,'Hirekoppa','582102',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26701,84,'Hiremannur','582209',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26702,84,'Hirewaddatti','582113',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26703,84,'Holealur','582203',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26704,84,'Holehadagali','582203',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26705,84,'Holemannur','582203',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26706,84,'Hombal','582204',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26707,84,'Honniganur','582209',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26708,84,'Hosahalli','582205',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26709,84,'Hosalli','582209',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26710,84,'Huilgol','582102',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26711,84,'Hulkoti','582205',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26712,84,'Hullur','582209',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26713,84,'Hullur','582112',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26714,84,'Hungundi','582203',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26715,84,'Itagi','582112',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26716,84,'Itagi','582211',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26717,84,'Jagapur','582207',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26718,84,'Jakkali','582111',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26719,84,'Jantli','582113',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26720,84,'Jigalur','582209',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26721,84,'Kadadi','582102',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26722,84,'Kadampur','582103',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26723,84,'Kadkol','582120',1,0,'2022-03-03 12:32:23','2022-03-03 12:32:23'),(26724,84,'Kalakeri','582118',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26725,84,'Kalasapur','582103',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26726,84,'Kanaginahal','582102',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26727,84,'Kanakikoppa','582207',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26728,84,'Kanvi','582103',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26729,84,'Katarki','583238',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26730,84,'Kodikoppa','582111',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26731,84,'Kognur','582112',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26732,84,'Konchigeri','582112',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26733,84,'Konnur (Gadag)','582206',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26734,84,'Korlahalli','582118',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26735,84,'Kotbal','582209',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26736,84,'Kotumachagi','582111',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26737,84,'Koujageri','582202',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26738,84,'Kundralli','582116',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26739,84,'Kuntoji','582114',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26740,84,'Kuradagi','582102',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26741,84,'Kurhatti','582209',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26742,84,'Kurthkoti','582205',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26743,84,'Kusthagi Kut','583277',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26744,84,'Lakamapur','583238',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26745,84,'Lakkalkatti','582211',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26746,84,'Lakkundi','582115',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26747,84,'Lakshmeshwar Court','582116',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26748,84,'Lakshmeshwar','582116',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26749,84,'Lingdhal','582204',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26750,84,'Machenhalli','582120',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26751,84,'Madalgeri','582209',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26752,84,'Madhalli','582117',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26753,84,'Magadi','582117',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26754,84,'Malasamudra','582103',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26755,84,'Mallapur','582209',1,0,'2022-03-03 12:32:24','2022-03-03 12:32:24'),(26756,84,'Malvad','582203',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26757,84,'Maranabasari','582119',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26758,84,'Menasigi','582207',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26759,84,'Mewundi','582113',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26760,84,'Mugali','582209',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26761,84,'Mulgund','582117',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26762,84,'Mundargi','582118',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26763,84,'Mundwad','582118',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26764,84,'Munirabad','583233',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26765,84,'Mushigeri','582211',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26766,84,'Nagarahalli','582118',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26767,84,'Nagavi','582103',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26768,84,'Nagendragad','582211',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26769,84,'Naregal','582119',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26770,84,'Nargund Bazar','582207',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26771,84,'Nargund','582207',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26772,84,'Neelgund','582117',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26773,84,'Neeralagi','582102',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26774,84,'Nidagundikoppa','582119',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26775,84,'Nidgundi','582114',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26776,84,'Papanashi','582103',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26777,84,'Pethalur','582113',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26778,84,'Pragathinagar','583268',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26779,84,'Raddernagnur','582207',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26780,84,'Rajur','582114',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26781,84,'Ramgeri','582116',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26782,84,'Rampur','582114',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26783,84,'Rantur','582112',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26784,84,'Ron','582209',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26785,84,'Ron Taluk Kut','582209',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26786,84,'Sanganhal','583279',1,0,'2022-03-03 12:32:25','2022-03-03 12:32:25'),(26787,84,'Sarjapur','582211',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26788,84,'Savadi','582209',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26789,84,'Shagoti','582205',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26790,84,'Shantageri','582211',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26791,84,'Shigli','582210',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26792,84,'Shingatalur','582118',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26793,84,'Shirahatti Haripur','582120',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26794,84,'Shiratti Kuktchery','582120',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26795,84,'Shiratti','582120',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26796,84,'Shirol','582207',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26797,84,'Singatarayanakeri','582103',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26798,84,'Somanakatti','582209',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26799,84,'Sortur','582120',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26800,84,'Sudi','582211',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26801,84,'Suganhalli','582112',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26802,84,'Surangi','582116',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26803,84,'Surkod','582207',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26804,84,'Tarikoppa','582112',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26805,84,'Timmapur','582115',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26806,84,'Vadavi','582112',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26807,84,'Venkatapur','582113',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26808,84,'Wadderhatti','583235',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26809,84,'Y S Hadagali','582202',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26810,84,'Yaklaspur','582113',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26811,84,'Yatanhalli','582117',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26812,84,'Yavagal','582202',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26813,84,'Yelavatti','582117',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26814,84,'Yelisirur','582120',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26815,84,'Yeribeleri','582102',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26816,85,'Adki','585222',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26817,85,'Afjalpur','585301',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26818,85,'Alanga','585314',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26819,85,'Alhalli','585211',1,0,'2022-03-03 12:32:26','2022-03-03 12:32:26'),(26820,85,'Alund Bazar','585302',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26821,85,'Alund','585302',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26822,85,'Alur','585325',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26823,85,'Ambalga','585316',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26824,85,'Andola','585303',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26825,85,'Ankalga','585301',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26826,85,'Ankalgi','585212',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26827,85,'Anoor','585301',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26828,85,'Anoor','585314',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26829,85,'Anpur','585306',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26830,85,'Anwar','585305',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26831,85,'Aralgundagi','585310',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26832,85,'Arankallur','585322',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26833,85,'Arjunagi','585236',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26834,85,'Asta','585104',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26835,85,'Atnoor','585301',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26836,85,'Aurad','585212',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26837,85,'Bablad','585316',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26838,85,'Badadal','585301',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26839,85,'Balbatti','585309',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26840,85,'Ballundagi','585310',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26841,85,'Bandarwad','585265',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26842,85,'Bangarga','585314',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26843,85,'Bankalga','585211',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26844,85,'Bankepalli','585306',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26845,85,'Basavapattan','585308',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26846,85,'Beeranahalli','585317',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26847,85,'Belambagi','585316',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26848,85,'Belgumpa','585317',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26849,85,'Belkota','585316',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26850,85,'Bellurgi','585301',1,0,'2022-03-03 12:32:27','2022-03-03 12:32:27'),(26851,85,'Belwadgi','585225',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26852,85,'Benakanahalli','585222',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26853,85,'Bennisiroor','585236',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26854,85,'Bennur','585317',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26855,85,'Bhagewadi','585211',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26856,85,'Bhairamadgi','585265',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26857,85,'Bhankur','585228',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26858,85,'Bhedsoor','585322',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26859,85,'Bheemanahalli','585222',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26860,85,'Bhimalli','585311',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26861,85,'Bhoganhalli','585301',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26862,85,'Bhopal Tegnoor','585102',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26863,85,'Bhosga','585301',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26864,85,'Bhusanoor','585302',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26865,85,'Bidnoor','585265',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26866,85,'Bilgunda','585316',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26867,85,'Bilwar','585310',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26868,85,'Biriyala B','585303',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26869,85,'Bolewad','585312',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26870,85,'Bommanahalli','585213',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26871,85,'C J  Colony','585102',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26872,85,'Central University of Karnataka','Kad',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26873,85,'Chalgera','585236',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26874,85,'Chandankera','585313',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26875,85,'Chandapur','585318',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26876,85,'Chandapur (Gulbarga)','585305',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26877,85,'Chandrampalli','585307',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26878,85,'Chengta','585313',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26879,85,'Chik Kallur','585310',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26880,85,'Chimmaidlai','585307',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26881,85,'Chimmanchod','585306',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26882,85,'Chinamgera','585265',1,0,'2022-03-03 12:32:28','2022-03-03 12:32:28'),(26883,85,'Chinchansoor','585104',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26884,85,'Chincholi','585302',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26885,85,'Chincholi','585301',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26886,85,'Chincholi H','585312',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26887,85,'Chincholi','585307',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26888,85,'Chintapalli','585320',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26889,85,'Chintapalli','585321',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26890,85,'Chitakanapalli','585222',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26891,85,'Chittapur','585211',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26892,85,'Chowdapur','585265',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26893,85,'Dandgund','585211',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26894,85,'Dandothi','585211',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26895,85,'Dannur','585311',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26896,85,'Degalmadi','585307',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26897,85,'Desangi','585310',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26898,85,'Devanoor','585318',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26899,85,'Devartegnoor','585228',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26900,85,'Dhangapur','585213',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26901,85,'Diggaaon','585211',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26902,85,'Diksanga','585301',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26903,85,'Dongaon','585211',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26904,85,'Dongargaon','585313',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26905,85,'Duganoor','585318',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26906,85,'Duttargaon','585311',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26907,85,'Farhatabad','585308',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26908,85,'Firozabad','585308',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26909,85,'Gadikeshwar','585324',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26910,85,'Gadilingadahalli','585306',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26911,85,'Ganjankhed','585104',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26912,85,'Ganwar','585303',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26913,85,'Garagapalli','585305',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26914,85,'Garampalli','585306',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26915,85,'GB Bahamanipura','585103',1,0,'2022-03-03 12:32:29','2022-03-03 12:32:29'),(26916,85,'GB Central Bus Stand','585102',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26917,85,'GB Court','585102',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26918,85,'GB Darga','585104',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26919,85,'GB Ggh','585105',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26920,85,'GB Jagath','585101',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26921,85,'GB Jnanaganga','585106',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26922,85,'Gb M.B.Nagar','585105',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26923,85,'GB M.S.K.Mill','585103',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26924,85,'GB Mominpura','585104',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26925,85,'GB N Gunj','585104',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26926,85,'GB RS','585102',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26927,85,'Gb Santrashwadi','585105',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26928,85,'GB Shahabazar','585101',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26929,85,'Gb Sharannagar','585103',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26930,85,'GB Shivajinagar','585104',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26931,85,'Ghanagapur T','585212',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26932,85,'Ghangapur Sangam','585212',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26933,85,'Ghattarga','585301',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26934,85,'Gobbur','585265',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26935,85,'Gola B','585311',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26936,85,'Gola K','585228',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26937,85,'Gotur','585312',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26938,85,'Goudampalli','585222',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26939,85,'Gudur','585310',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26940,85,'Gudur','585213',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26941,85,'Gulbarga H C C B','585103',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26942,85,'Gulbarga H.O','585101',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26943,85,'Gundgurthi','585317',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26944,85,'Habal','585320',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26945,85,'Hadagil Haruthi','585102',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26946,85,'Hadalgi','585236',1,0,'2022-03-03 12:32:30','2022-03-03 12:32:30'),(26947,85,'Hagargi','585102',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26948,85,'Hagargundagi','585308',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26949,85,'Halchar','585324',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26950,85,'Halkatta','585225',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26951,85,'Hallisalgar','585302',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26952,85,'Handarki','585222',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26953,85,'Hangarga K','585325',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26954,85,'Hanharga B','585325',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26955,85,'Harnoor','585310',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26956,85,'Harsoor','585102',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26957,85,'Harwal','585310',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26958,85,'Hasargundagi','585306',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26959,85,'Hasargundagi','585265',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26960,85,'Havnoor','585265',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26961,85,'Hebbal','585312',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26962,85,'Hebli','585302',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26963,85,'Heroor K','585322',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26964,85,'Hinchgera','585301',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26965,85,'Hipparga J','585310',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26966,85,'Hirapur','585103',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26967,85,'Hire Bennur','585102',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26968,85,'Hire Heroor','585265',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26969,85,'Hire Jewargi','585301',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26970,85,'Hirealgi','585301',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26971,85,'Hirealur','585222',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26972,85,'Hireaurad','585316',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26973,85,'Hirebetgera','585222',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26974,85,'Hiregour','585301',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26975,85,'Hirekawalga','585308',1,0,'2022-03-03 12:32:31','2022-03-03 12:32:31'),(26976,85,'Hirenandur','585228',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(26977,85,'Hiroli','585302',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(26978,85,'Hittal Siroor','585213',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(26979,85,'Hodlur','585314',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(26980,85,'Holkunda','585313',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(26981,85,'Hongunta','585228',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(26982,85,'Hoolgera','585322',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(26983,85,'Hosalli','585324',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(26984,85,'Hosurwadi','585217',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(26985,85,'Hudebeeranahalli','585324',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(26986,85,'Hullur','585212',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(26987,85,'Hunashi Hadagil','585213',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(26988,85,'Ijjeri','585310',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(26989,85,'Ingalgi','585225',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(26990,85,'Inoli','585307',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(26991,85,'Iranapalli','585318',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(26992,85,'Itagi','585212',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(26993,85,'Ivani','585317',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(26994,85,'Jakanpalli','585318',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(26995,85,'Jamaga J','585302',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(26996,85,'Jamaga R','585314',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(26997,85,'Jawalga J','585314',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(26998,85,'Jawali','585213',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(26999,85,'Jeeratagi','585310',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(27000,85,'Jeevanagi','585313',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(27001,85,'Jettur','585320',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(27002,85,'Jewargi','585310',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(27003,85,'Jidaga','585302',1,0,'2022-03-03 12:32:32','2022-03-03 12:32:32'),(27004,85,'Jogur','585265',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27005,85,'Kachapur','585325',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27006,85,'Kadaganchi','585311',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27007,85,'Kadboor','585225',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27008,85,'Kadcherla','585318',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27009,85,'Kadkol','585325',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27010,85,'Kadni','585308',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27011,85,'Kalgi','585312',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27012,85,'Kalgurhi','585312',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27013,85,'Kalhangarga','585104',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27014,85,'Kalhangarga','585310',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27015,85,'Kalhipparga','585322',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27016,85,'Kalkham','585222',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27017,85,'Kallur','585301',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27018,85,'Kallur Road','585305',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27019,85,'Kalmandargi','585313',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27020,85,'Kalmood','585313',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27021,85,'Kamalapur (Gulbarga)','585313',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27022,85,'Kamalnagar','585104',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27023,85,'Kanameshwar','585325',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27024,85,'Kanganahalli','585218',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27025,85,'Kanmus','585302',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27026,85,'Kapanoor','585104',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27027,85,'Karachkhed','585320',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27028,85,'Karajagi','585217',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27029,85,'Karakmukli','585306',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27030,85,'Kardal','585211',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27031,85,'Karhari','585104',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27032,85,'Kasar Bhosga','585310',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27033,85,'Kattisangavi','585310',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27034,85,'Kawalga','585302',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27035,85,'Kellur','585303',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27036,85,'Keriambalga','585104',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27037,85,'Kerolli','585320',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27038,85,'Khajuri (Gulbarga)','585314',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27039,85,'Khanapur','585306',1,0,'2022-03-03 12:32:33','2022-03-03 12:32:33'),(27040,85,'Khanapur','585302',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27041,85,'Khandal','585102',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27042,85,'Kinnisadak','585313',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27043,85,'Kinnisultan','585302',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27044,85,'Kiranagi','585308',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27045,85,'Kodadur','585312',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27046,85,'Kodalhangarga','585302',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27047,85,'Kodla','585222',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27048,85,'Kodli','585312',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27049,85,'Koganoor','585213',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27050,85,'Kolkunda','585318',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27051,85,'Kolkur','585310',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27052,85,'Kollur','585218',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27053,85,'Kollur','585307',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27054,85,'Konasirasgi','585325',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27055,85,'Konpur','585318',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27056,85,'Koodi','585310',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27057,85,'Koradampalli','585320',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27058,85,'Koralli','585302',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27059,85,'Korvi','585324',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27060,85,'Korwar','585312',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27061,85,'Kotanhipparga','585314',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27062,85,'Kudhalli','585324',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27063,85,'Kuknoor','585325',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27064,85,'Kukunda','585312',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27065,85,'Kulkunta','585218',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27066,85,'Kumsi','585104',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27067,85,'Kunchavaram','585305',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27068,85,'Kundnur','585225',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27069,85,'Kupnoor','585324',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27070,85,'Kuralgera','585325',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27071,85,'Kurikota','585316',1,0,'2022-03-03 12:32:34','2022-03-03 12:32:34'),(27072,85,'Kurkunda','585319',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27073,85,'Kurkunta','585210',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27074,85,'Kurkunta C.F','585210',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27075,85,'Lad Chincholi','585311',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27076,85,'Lad Mugali','585316',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27077,85,'Ladlapur','585225',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27078,85,'Lingampalli','585318',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27079,85,'Madan Hipparga','585236',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27080,85,'Madiyal','585236',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27081,85,'Madki','585316',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27082,85,'Madkol','585210',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27083,85,'Madna','585318',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27084,85,'Madra B','585213',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27085,85,'Madri','585310',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27086,85,'Magingera','585325',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27087,85,'Mahagaon (Gulbarga)','585316',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27088,85,'Malgatti','585228',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27089,85,'Malgod','585317',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27090,85,'Malkhed Road','585292',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27091,85,'Malkhed','585317',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27092,85,'Malkood','585317',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27093,85,'Malla B','585303',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27094,85,'Mallabad','585301',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27095,85,'Malli','585325',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27096,85,'Mandewal','585310',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27097,85,'Mangalgi','585312',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27098,85,'Mannur','585217',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27099,85,'Maradgi','585303',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27100,85,'Margol','585211',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27101,85,'Margutti','585313',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27102,85,'Marpalli','585306',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27103,85,'Martur','585228',1,0,'2022-03-03 12:32:35','2022-03-03 12:32:35'),(27104,85,'Mashal','585217',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27105,85,'Matki','585302',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27106,85,'Mattimadu','585312',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27107,85,'Melkunda','585213',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27108,85,'Miriyan','585305',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27109,85,'Mogha','585324',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27110,85,'Mogha.K','585302',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27111,85,'Mothakpalli','585318',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27112,85,'Mudbal B','585310',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27113,85,'Muddadga','585316',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27114,85,'Mudhol (Gulbarga)','585318',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27115,85,'Mugalnagaon','585228',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27116,85,'Mukramba','585322',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27117,85,'Munalli','585302',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27118,85,'Mutaga','585228',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27119,85,'Muthkod','585310',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27120,85,'Nadepalli','585318',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27121,85,'Naduvinahalli','585308',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27122,85,'Nagaidlai','585307',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27123,85,'Nagoor','585322',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27124,85,'Nalwar','585218',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27125,85,'Nalwar Station','585218',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27126,85,'Nandikur','585102',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27127,85,'Naribol','585310',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27128,85,'Narona','585311',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27129,85,'Navadgi','585324',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27130,85,'Neelhalli','585317',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27131,85,'Neemhsalli','585307',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27132,85,'Nellogi','585310',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27133,85,'Nidgunda','585320',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27134,85,'Niloor','585213',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27135,85,'Nimbal','585236',1,0,'2022-03-03 12:32:36','2022-03-03 12:32:36'),(27136,85,'Nimbarga','585213',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27137,85,'Ningadahalli','585236',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27138,85,'Nirgudi','585302',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27139,85,'Nndargi','585301',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27140,85,'Okali','585313',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27141,85,'Padsavalgi','585302',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27142,85,'Pala','585228',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27143,85,'Pastapur','585324',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27144,85,'Pattan','585311',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27145,85,'Patwada','585313',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27146,85,'Pethsiroor','585317',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27147,85,'Polakpalli','585305',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27148,85,'Ptc Naganahalli','585102',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27149,85,'Raddewadgi','585310',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27150,85,'Rajapur','585105',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27151,85,'Rajapur','585312',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27152,85,'Rajnal','585313',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27153,85,'Rajola','585211',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27154,85,'Rampurhalli','585218',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27155,85,'Ranjol','585222',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27156,85,'Rasanagi','585310',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27157,85,'Ratkal','585322',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27158,85,'Rawoor','585225',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27159,85,'Revoor','585301',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27160,85,'Ribbanpalli','585318',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27161,85,'Rudrawadi','585314',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27162,85,'Rummanagod','585324',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27163,85,'Rustumpur','585306',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27164,85,'Sagnoor','585265',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27165,85,'Sakkarga','585302',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27166,85,'Salebeeranahalli','585306',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27167,85,'Salegaon','585302',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27168,85,'Salgara V K','585316',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27169,85,'Salgarbasanthpur','585306',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27170,85,'Sangunda','585316',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27171,85,'Sannathi','585218',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27172,85,'Sannur','585102',1,0,'2022-03-03 12:32:37','2022-03-03 12:32:37'),(27173,85,'Saradgi Battad','585308',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27174,85,'Sarasamba','585302',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27175,85,'Sathkhed','585310',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27176,85,'Satnoor','585211',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27177,85,'Savaleshwar','585302',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27178,85,'Savalgi','585102',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27179,85,'Sedam','585222',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27180,85,'Shadipura','585305',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27181,85,'Shahabad ACC','585229',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27182,85,'Shahabad Kasaba','585228',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27183,85,'Shahabad (Gulbarga)','585228',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27184,85,'Shivoor','585217',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27185,85,'Siddanamadu','585222',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27186,85,'Silarkot','585318',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27187,85,'Sindagi','585103',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27188,85,'Sirasgi','585103',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27189,85,'Sirchand','585316',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27190,85,'Sirnoor','585308',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27191,85,'Siroli','585320',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27192,85,'Sirur Darga','585236',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27193,85,'Soan','585310',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27194,85,'Soan','585301',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27195,85,'Somalingadahalli','585305',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27196,85,'Sonth','585313',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27197,85,'Srinivasa Saradagi','585102',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27198,85,'Station Ghanagapur','585213',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27199,85,'Sugoor','585322',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27200,85,'Sugur','585218',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27201,85,'Sulahalli','585225',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27202,85,'Sulahpeth','585324',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27203,85,'Sultanpur','585104',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27204,85,'Sumbad','585325',1,0,'2022-03-03 12:32:38','2022-03-03 12:32:38'),(27205,85,'Suntanur','585311',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27206,85,'Sunthan','585322',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27207,85,'Syed Chincholi','585104',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27208,85,'Tadkal','585322',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27209,85,'Tadkal','585302',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27210,85,'Tadola','585314',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27211,85,'Tadtegnoor','585308',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27212,85,'Taranahalli','585228',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27213,85,'Telakuni','585302',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27214,85,'Telkur','585320',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27215,85,'Tellur','585212',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27216,85,'Tengli','585317',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27217,85,'Thirth','585302',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27218,85,'Tilgool','585308',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27219,85,'Tonasinahalli','585228',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27220,85,'Totanhalli','585317',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27221,85,'Udachan','585217',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27222,85,'Udagi','585222',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27223,85,'Vasavadatta C F','585222',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27224,85,'Venkatapur','585305',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27225,85,'Wadgera','585325',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27226,85,'Wadi (Gulbarga)','585225',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27227,85,'Wastari','585325',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27228,85,'Yagapur','585218',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27229,85,'Yargal','585211',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27230,85,'Yedga','585312',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27231,85,'Yedrami','585325',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27232,85,'Yelgood','585325',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27233,85,'Yelmamidi','585306',1,0,'2022-03-03 12:32:39','2022-03-03 12:32:39'),(27234,85,'Yelsangi','585236',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27235,85,'Yelwar','585310',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27236,85,'Yergol','585218',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27237,85,'Zalki K','585236',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27238,85,'Zalki.B','585236',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27239,86,'Abbana','573214',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27240,86,'Abburmachagowdanahalli','573102',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27241,86,'Adagur','573116',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27242,86,'Adagur','573121',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27243,86,'Aggunda','573103',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27244,86,'Agile','573128',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27245,86,'Agrahara','573116',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27246,86,'Agrahara','573133',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27247,86,'Agraharabelaguli','573131',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27248,86,'Agriculture College Campus Dly','573225',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27249,86,'Ajjur','573102',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27250,86,'Akkanahalli','573131',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27251,86,'Aldahalli','573102',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27252,86,'Alur (Hassan)','573213',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27253,86,'Amaragiri Tirupathi','573103',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27254,86,'Ambuga','573212',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27255,86,'Anandur','573150',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27256,86,'Anathi','573131',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27257,86,'Andale','573216',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27258,86,'Anekannambadi','573210',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27259,86,'Anekere','573116',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27260,86,'Anemahal','573134',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27261,86,'Ankanayakanahalli','573120',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27262,86,'Ankapura','573120',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27263,86,'Ankihalli','573215',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27264,86,'Annaikanahalli','573122',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27265,86,'Antharikshanagar','573202',1,0,'2022-03-03 12:32:40','2022-03-03 12:32:40'),(27266,86,'Anughatta','573101',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27267,86,'Appihalli','573125',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27268,86,'Arakere','573112',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27269,86,'Arehalli','573101',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27270,86,'Arekere','573134',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27271,86,'Arkalgud','573102',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27272,86,'Arsikere East','573103',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27273,86,'Arsikere H.O','573103',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27274,86,'Attavara','573118',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27275,86,'Atthihalli','573131',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27276,86,'Attihalli','573123',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27277,86,'Baddikere','573131',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27278,86,'Bage','573214',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27279,86,'Bageshpura','573162',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27280,86,'Bagivalu','573211',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27281,86,'Bagivalu','573164',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27282,86,'Bagur (Hassan)','573111',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27283,86,'Balaganchi','573124',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27284,86,'Balaghatta','573111',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27285,86,'Baldare','573225',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27286,86,'Ballupet','573214',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27287,86,'Ballur','573115',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27288,86,'Banavara R S','573112',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27289,86,'Banavara','573112',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27290,86,'Bandur','573125',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27291,86,'Bannur','573130',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27292,86,'Bantenahalli','573115',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27293,86,'Baragur','573225',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27294,86,'Baralu','573135',1,0,'2022-03-03 12:32:41','2022-03-03 12:32:41'),(27295,86,'Basavaghatta','573162',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27296,86,'Basavanahalli','573112',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27297,86,'Basavanahalli','573136',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27298,86,'Basavapatna (Hassan)','573113',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27299,86,'Beechanahalli','573211',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27300,86,'Bekka','573135',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27301,86,'Belagihalli','573124',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27302,86,'Belagodu','573214',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27303,86,'Belagumba','573103',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27304,86,'Belavadi','573113',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27305,86,'Bellame','573130',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27306,86,'Belluru','573213',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27307,86,'Belur Hassan','573115',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27308,86,'Belur-fort','573115',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27309,86,'Bendekere','573103',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27310,86,'Bennur','573115',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27311,86,'Bharathur','573129',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27312,86,'Bhoovanahalli','573211',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27313,86,'Bhuvanahalli','573131',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27314,86,'Bidarakka','573136',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27315,86,'Bikkodu','573215',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27316,86,'Boovanahalli','573220',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27317,86,'Byadarahalli','573128',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27318,86,'Byadarahalli','573111',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27319,86,'Byakaravalli','573134',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27320,86,'Bychanahalli','573102',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27321,86,'Bykere','573127',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27322,86,'Bylahalli','573217',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27323,86,'Byrapura','573218',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27324,86,'Chagachagere','573164',1,0,'2022-03-03 12:32:42','2022-03-03 12:32:42'),(27325,86,'Chaluvanahalli','573112',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27326,86,'Chalya','573135',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27327,86,'Changadihalli','573137',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27328,86,'Channapatna Extn','573201',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27329,86,'Channarayapatna Fort','573116',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27330,86,'Channarayapatna','573116',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27331,86,'Chatchatahalli','573121',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27332,86,'Cheekanahalli','573115',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27333,86,'Cheelanayakanahalli','573121',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27334,86,'Chikarkalgud','573102',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27335,86,'Chikkahalli','573130',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27336,86,'Chikkur','573103',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27337,86,'Chikmedur','573115',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27338,86,'Chilkur','573216',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27339,86,'Chowlagala','573111',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27340,86,'Dabbe','573115',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27341,86,'Dadighatta','573135',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27342,86,'Dammaningala','573135',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27343,86,'Dandiganahalli','573225',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27344,86,'Deshani','573122',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27345,86,'Devaladakere','573165',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27346,86,'Didaga','573141',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27347,86,'Dindagur','573116',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27348,86,'District Office','573201',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27349,86,'Doddabemmathi','573130',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27350,86,'Doddabyagathavalli','573211',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27351,86,'Doddagaddavalli','573216',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27352,86,'Doddagenigere','573220',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27353,86,'Doddahalli','573210',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27354,86,'Doddahalli','573133',1,0,'2022-03-03 12:32:43','2022-03-03 12:32:43'),(27355,86,'Doddakadanur','573211',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27356,86,'Doddakunche','573211',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27357,86,'Doddakundur','573137',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27358,86,'Doddamagge','573142',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27359,86,'Doddamettikurke','573117',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27360,86,'Doddapura','573118',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27361,86,'Doddenahalli','573122',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27362,86,'Donanakatte','573117',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27363,86,'Donigal','573134',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27364,86,'Dudda','573118',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27365,86,'Dudda R S','573118',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27366,86,'Dummenahalli','573103',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27367,86,'Dundanayakanahalli','573128',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27368,86,'Dyavalapura','573220',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27369,86,'Eachalabeedu','573137',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27370,86,'Eastern Extn','573201',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27371,86,'Gadenahalli','573220',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27372,86,'Gandasi','573119',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27373,86,'Gandhibazar (Hassan)','573201',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27374,86,'Gangur','573133',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27375,86,'Ganjalgud','573102',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27376,86,'Ganjigere','573128',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27377,86,'Gendehalli','573115',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27378,86,'Ghattadahalli','573121',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27379,86,'Goddu','573123',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27380,86,'Gollarahosahalli','573116',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27381,86,'Gonisomanahalli','573121',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27382,86,'Gorur','573120',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27383,86,'Gowdagere','573116',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27384,86,'Gulsinda','573116',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27385,86,'Hadige','573165',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27386,86,'Hadlahalli','573123',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27387,86,'Hagare','573216',1,0,'2022-03-03 12:32:44','2022-03-03 12:32:44'),(27388,86,'Halasulige','573127',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27389,86,'Halebeedu','573121',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27390,86,'Halebelagola','573116',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27391,86,'Halebelur','573134',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27392,86,'Halekoppalu','573219',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27393,86,'Hallymysore','573210',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27394,86,'Hanbalu','573165',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27395,86,'Hanchur','573218',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27396,86,'Handarangi','573130',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27397,86,'Handralu','573122',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27398,86,'Hangal','573113',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27399,86,'Hanike','573115',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27400,86,'Hanumanthapura','573128',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27401,86,'Haradanahalli','573211',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27402,86,'Haralakatte','573117',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27403,86,'Haranahalli','573122',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27404,86,'Harihalli','573129',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27405,86,'Hariharapura','573211',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27406,86,'Hassan H.O','573201',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27407,86,'Hebbale','573102',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27408,86,'Hebbalu','573121',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27409,86,'Hebbasale','573134',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27410,86,'Heggadde','573134',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27411,86,'Heggadihalli','573142',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27412,86,'Heggatta','573119',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27413,86,'Hemavathinagar','573202',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27414,86,'Hemmige','573129',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27415,86,'Heragu','573118',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27416,86,'Hethagodanahalli','573102',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27417,86,'Hethur','573123',1,0,'2022-03-03 12:32:45','2022-03-03 12:32:45'),(27418,86,'Hirihalli','573225',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27419,86,'Hirisadarahalli','573144',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27420,86,'Hirisave','573124',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27421,86,'Hiriyur','573103',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27422,86,'Holalkere','573126',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27423,86,'Holenarsipur','573211',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27424,86,'Hongadahalla','573123',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27425,86,'Hongere','573220',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27426,86,'Honnavalli','573102',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27427,86,'Honnavara','573118',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27428,86,'Honnenahalli','573124',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27429,86,'Hosahalli','573141',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27430,86,'Hosakoppalu','573201',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27431,86,'Hosur(SWP)','573137',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27432,86,'Hulikallu','573142',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27433,86,'Hullangala','573102',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27434,86,'Hullekere','573119',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27435,86,'Hullugundi','573216',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27436,86,'Hunsavalli','573213',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27437,86,'Hurudi','573165',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27438,86,'Ibbeedu','573216',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27439,86,'Igoor','573137',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27440,86,'Iravalli','573115',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27441,86,'Jajur','573103',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27442,86,'Jambur','573131',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27443,86,'Jammanahalli','573214',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27444,86,'Janivara','573116',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27445,86,'Javagal','573125',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27446,86,'Jaya Chamaraja Pura','573126',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27447,86,'Jinnenahalli','573124',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27448,86,'Jodigubbi','573102',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27449,86,'Jodihandankere','573217',1,0,'2022-03-03 12:32:46','2022-03-03 12:32:46'),(27450,86,'Jodithattekere','573217',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27451,86,'Juttanahalli','573124',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27452,86,'K Kittankere','573117',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27453,86,'K R Puram Ext(Hassan)','573201',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27454,86,'Kabbali','573141',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27455,86,'Kabbaligere','573130',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27456,86,'Kadabagala','573218',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27457,86,'Kadaga','573219',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27458,86,'Kadalu','573213',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27459,86,'Kadamane','573134',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27460,86,'Kadanur','573130',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27461,86,'Kadavina Hosahalli','573130',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27462,86,'Kalale','573137',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27463,86,'Kalenahalli','573113',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27464,86,'Kalkere','573116',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27465,86,'Kallanagere','573103',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27466,86,'Kallugundi','573144',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27467,86,'Kallusadarahalli','573144',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27468,86,'Kalyadi','573122',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27469,86,'Kamasamudra','573126',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27470,86,'Kanagal','573217',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27471,86,'Kanakatte','573144',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27472,86,'Kanathur','573213',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27473,86,'Kandali','573217',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27474,86,'Kanive Byadarahalli','573225',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27475,86,'Kantharajapura','573135',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27476,86,'Karagada','573115',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27477,86,'Karehalli','573131',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27478,86,'Kargunda','573122',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27479,86,'Karjuvalli','573213',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27480,86,'Karle','573120',1,0,'2022-03-03 12:32:47','2022-03-03 12:32:47'),(27481,86,'Kattaya','573128',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27482,86,'Kattepura','573130',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27483,86,'Kattimallenahalli','573102',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27484,86,'Kembalu','573111',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27485,86,'Kenchammanahosakote','573129',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27486,86,'Kenkere','573119',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27487,86,'Keragodu','573211',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27488,86,'Keralapura','573136',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27489,86,'Kesagodu','573215',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27490,86,'Kiragadalu','573213',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27491,86,'Kirisave','573124',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27492,86,'Kittane','573212',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27493,86,'Kittankere','573162',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27494,86,'Kodihalli','573125',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27495,86,'Kolagunda','573125',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27496,86,'Komaraghatta','573162',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27497,86,'Konanur','573130',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27498,86,'Kondavagilu','573103',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27499,86,'Koratikere','573142',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27500,86,'Koravangala','573118',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27501,86,'Kothanghatta','573135',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27502,86,'Kowshika','573212',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27503,86,'Kudrugundi','573219',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27504,86,'Kumbaradi','573134',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27505,86,'Kumbarahalli','573137',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27506,86,'Kumbenahalli','573116',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27507,86,'Kumbenahalli','573135',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27508,86,'Kunduru','573128',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27509,86,'Kunduru','573111',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27510,86,'Kuniganahalli','573214',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27511,86,'Kuppalli','573217',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27512,86,'Kuruvanka','573103',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27513,86,'Kushavara','573215',1,0,'2022-03-03 12:32:48','2022-03-03 12:32:48'),(27514,86,'Kyamanahalli','573165',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27515,86,'Kyanahalli','573134',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27516,86,'Lakkur','573150',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27517,86,'Lalanakere','573164',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27518,86,'Madabalu','573218',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27519,86,'Madaghatta','573213',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27520,86,'Madalu','573117',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27521,86,'Madanahalli','573125',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27522,86,'Madenur','573225',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27523,86,'Madihalli','573216',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27524,86,'Maduranahalli','573150',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27525,86,'Mageri','573123',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27526,86,'Magge','573129',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27527,86,'Malagalale','573129',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27528,86,'Malali','573134',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27529,86,'Malali','573220',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27530,86,'Malalikere','573102',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27531,86,'Malasavara','573101',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27532,86,'Malegere','573215',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27533,86,'Malladevarapura','573120',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27534,86,'Mallipatna','573102',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27535,86,'Mandalamane','573115',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27536,86,'Maraghushivara','573111',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27537,86,'Maranahalli','573134',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27538,86,'Maratagere','573103',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27539,86,'Marithammanahalli','573102',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27540,86,'Markuli','573212',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27541,86,'Marur','573102',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27542,86,'Masakanahalli','573141',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27543,86,'Masarangala','573102',1,0,'2022-03-03 12:32:49','2022-03-03 12:32:49'),(27544,86,'Matasagara','573134',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27545,86,'Mathighatta','573121',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27546,86,'Mathighatta','573124',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27547,86,'Mattanavile','573116',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27548,86,'Mavanur','573220',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27549,86,'Mavinakere','573211',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27550,86,'Melagodu','573220',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27551,86,'Mosale','573212',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27552,86,'Mosale Hosahalli','573212',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27553,86,'Mudalahippe','573211',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27554,86,'Mududi','573119',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27555,86,'Mugali','573214',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27556,86,'Murundi','573122',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27557,86,'Muthigehirehalli','573212',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27558,86,'Mylanahalli','573103',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27559,86,'Nagarahalli','573211',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27560,86,'Nagarahalli','573164',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27561,86,'Nagasamudra','573112',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27562,86,'Nagavedi','573126',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27563,86,'Nagenahalli','573115',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27564,86,'Nallur','573116',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27565,86,'Nandigondanahalli','573101',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27566,86,'Navile','573131',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27567,86,'Nelagahalli','573165',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27568,86,'Nerlige','573125',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27569,86,'Nidigere','573134',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27570,86,'Niduvani','573210',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27571,86,'Nittur','573219',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27572,86,'Norway','573127',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27573,86,'Nuggihalli','573131',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27574,86,'Obalapura','573111',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27575,86,'Paduvalahippe','573211',1,0,'2022-03-03 12:32:50','2022-03-03 12:32:50'),(27576,86,'Paduvalalu','573215',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27577,86,'Palya','573218',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27578,86,'Pension Mohalla','573201',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27579,86,'Ponnasamudra','573103',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27580,86,'Rajanasiriyur','573121',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27581,86,'Ramanahalli','573126',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27582,86,'Ramanathapura','573133',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27583,86,'Rampura','573126',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27584,86,'Rayarakoppal','573129',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27585,86,'Rudrapatna','573150',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27586,86,'S Ankanahalli','573211',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27587,86,'Sabbanahalli','573124',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27588,86,'Sagathavalli','573116',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27589,86,'Sakleshpur','573134',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27590,86,'Salagame','573219',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27591,86,'Sankihalli','573125',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27592,86,'Sannenahalli','573121',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27593,86,'Santhepet Hassan','573201',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27594,86,'Santheshivara','573131',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27595,86,'Sanyasihalli','573115',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27596,86,'Saragur','573130',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27597,86,'Sathangere','573144',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27598,86,'Sathenahalli','573212',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27599,86,'Savasihalli','573216',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27600,86,'Seege','573219',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27601,86,'Settihalli','573128',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27602,86,'Shanegere','573112',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27603,86,'Shanka','573219',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27604,86,'Shankaranahalli','573128',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27605,86,'Shankaranahalli','573103',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27606,86,'Shanthigrama','573220',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27607,86,'Shiragura','573115',1,0,'2022-03-03 12:32:51','2022-03-03 12:32:51'),(27608,86,'Shravanabelagola','573135',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27609,86,'Shukravarasanthe','573134',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27610,86,'Singapur','573211',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27611,86,'Singapur','573218',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27612,86,'Singodanahalli','573218',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27613,86,'Somanahalli','573136',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27614,86,'Sravanur R S','573211',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27615,86,'Srinivaspura','573116',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27616,86,'Sulekere','573103',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27617,86,'Sundahalli','573135',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27618,86,'Sundekere','573127',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27619,86,'T.Kodihalli','573103',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27620,86,'Tagare','573215',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27621,86,'Talalur','573103',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27622,86,'Talur','573213',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27623,86,'Tatanahalli','573210',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27624,86,'Tejur','573219',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27625,86,'Teranya','573220',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27626,86,'Thannirhalla','573201',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27627,86,'Thondiganahalli','573112',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27628,86,'Tolalu','573115',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27629,86,'Tumbadevanahalli','573101',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27630,86,'Tumkur','573141',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27631,86,'Uchangi','573137',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27632,86,'Udevara','573127',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27633,86,'Uduvare','573120',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27634,86,'Ugane','573216',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27635,86,'Undiganalu','573122',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27636,86,'Vaddarahalli','573135',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27637,86,'Valagerahalli','573118',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27638,86,'Valagerahalli','573131',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27639,86,'Valalahalli','573123',1,0,'2022-03-03 12:32:52','2022-03-03 12:32:52'),(27640,86,'Vanagur','573123',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27641,86,'Venkatipete','573215',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27642,86,'Vidyanagar (Hassan)','573202',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27643,86,'Votehole Project','573213',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27644,86,'Watehalli','573101',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27645,86,'Yadapura','573122',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27646,86,'Yadavanahalli','573119',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27647,86,'Yamasandhi','573115',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27648,86,'Yelagunda','573219',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27649,86,'Yelahanka','573216',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27650,86,'Yelechaganahalli','573211',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27651,86,'Yeliyur','573225',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27652,86,'Yeraganalu','573164',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27653,86,'Yeslur','573137',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27654,87,'Adur (Haveri)','581101',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27655,87,'Agadi','581128',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27656,87,'Airani','581115',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27657,87,'Akkialur Bazar','581102',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27658,87,'Akkialur','581102',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27659,87,'Aladakatti','581110',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27660,87,'Aladgeri','581109',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27661,87,'Alalageri','581106',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27662,87,'Anaji','581210',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27663,87,'Anandavan','581128',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27664,87,'Andalagi','581203',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27665,87,'Antravalli','581208',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27666,87,'Araleshwar','581104',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27667,87,'Aralikatti','581109',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27668,87,'Aremallapur','581115',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27669,87,'Asundi','581115',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27670,87,'Attigeri','581126',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27671,87,'Attikatti','581120',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27672,87,'Baichavalli','581104',1,0,'2022-03-03 12:32:53','2022-03-03 12:32:53'),(27673,87,'Balambid','581101',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27674,87,'Balihalli','581104',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27675,87,'Bankapur','581202',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27676,87,'Bannur','581205',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27677,87,'Basanal','581126',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27678,87,'Basapur','581108',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27679,87,'Belagalpet','581104',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27680,87,'Belivigi','581108',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27681,87,'Belur','581211',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27682,87,'Benakankonda','581208',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27683,87,'Betakerur','581109',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27684,87,'Bilahalli','581208',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27685,87,'Bisalalli','581106',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27686,87,'Bommanahalli (Haveri)','581203',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27687,87,'Budagatti','581128',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27688,87,'Budapanahalli','581115',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27689,87,'Buradikatti','581111',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27690,87,'Byadgi N.N.','581106',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27691,87,'Byadgi','581106',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27692,87,'Chalageri','581145',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27693,87,'Challal','581118',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27694,87,'Chandapur','581193',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27695,87,'Channalli`','581111',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27696,87,'Chikkabasur','581120',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27697,87,'Chikkabbar','581119',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27698,87,'Chikkalingadahalli','581110',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27699,87,'Chikkamagnur','581208',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27700,87,'Chikkaunshihosur','581104',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27701,87,'Chikkayadachi','581116',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27702,87,'Chikkerur','581111',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27703,87,'Chikkuravatti','581115',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27704,87,'Chillurbadni','581126',1,0,'2022-03-03 12:32:54','2022-03-03 12:32:54'),(27705,87,'Chinnamulagund','581106',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27706,87,'Chinnikatti','581106',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27707,87,'Choudadanapur','581115',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27708,87,'Choudal','581126',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27709,87,'Devagiri','581110',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27710,87,'Devaragudda','581115',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27711,87,'Devihosur','581110',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27712,87,'Dhundashi','581193',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27713,87,'Didagur','581148',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27714,87,'Divigihalli','581109',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27715,87,'Doddagubbi','581116',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27716,87,'Dombaramattur','581118',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27717,87,'Dudihalli','581111',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27718,87,'Gangebhavi','581205',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27719,87,'Gondi','581104',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27720,87,'Guddadamadapur','581210',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27721,87,'Gudgur','581115',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27722,87,'Gundagatti','581111',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27723,87,'Gundenhalli','581106',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27724,87,'Guttal','581108',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27725,87,'Hadrihalli','581111',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27726,87,'Halageri','581208',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27727,87,'Halagi','581213',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27728,87,'Halebankapur','581202',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27729,87,'Hallur','581119',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27730,87,'Handiganur','581213',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27731,87,'Hangal Bazar','581104',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27732,87,'Hangal','581104',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27733,87,'Hanumanamatti','581115',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27734,87,'Hanumapur','581115',1,0,'2022-03-03 12:32:55','2022-03-03 12:32:55'),(27735,87,'Haranagiri','581115',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27736,87,'Hattimattur','581118',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27737,87,'Haunsabhavi','581109',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27738,87,'Havanagi','581102',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27739,87,'Havanur','581108',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27740,87,'Haveri B.S.','581110',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27741,87,'Haveri Bazar','581110',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27742,87,'Haveri H.O','581110',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27743,87,'Haveri R.N.','581110',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27744,87,'Haveri V.N.','581110',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27745,87,'Hedigonda','581110',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27746,87,'Hediyal','581208',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27747,87,'Herur','581148',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27748,87,'Hesarur','581118',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27749,87,'Hireanaji','581120',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27750,87,'Hirebasur','581120',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27751,87,'Hirebendigeri','581205',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27752,87,'Hirebidari','581115',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27753,87,'Hirehullal','581148',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27754,87,'Hirekabbar','581119',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27755,87,'Hirekanagi','581104',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27756,87,'Hirekerur','581111',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27757,87,'Hirekonati','581109',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27758,87,'Hiremallur','581205',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27759,87,'Hiremanakatti','581205',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27760,87,'Hiremaralihalli','581118',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27761,87,'Hiremorab','581210',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27762,87,'Hiremugadur','581112',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27763,87,'Hirur','581104',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27764,87,'Hommaradi','581110',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27765,87,'Honnatti','581115',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27766,87,'Hosakatti','581210',1,0,'2022-03-03 12:32:56','2022-03-03 12:32:56'),(27767,87,'Hosaniralagi','581205',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27768,87,'Hosaritti','581213',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27769,87,'Hosur','581193',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27770,87,'Hotanahalli','581203',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27771,87,'Hulgur','581126',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27772,87,'Hullatti','581203',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27773,87,'Hullatti','581111',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27774,87,'Hungund','581203',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27775,87,'Huralikoppi','581118',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27776,87,'Huvinashigli','581118',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27777,87,'Ichangi','581118',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27778,87,'Ijarilakmapur','581110',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27779,87,'Ingalgondi','581111',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27780,87,'Itagi','581208',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27781,87,'Jallapur','581118',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27782,87,'Joisaraharalalli','581208',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27783,87,'Kabanur','581205',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27784,87,'Kabbur','581110',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27785,87,'Kachavi','581120',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27786,87,'Kadaramandalagi','581106',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27787,87,'Kadkol','581118',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27788,87,'Kadur','581116',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27789,87,'Kaginelli','581110',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27790,87,'Kajjari','581115',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27791,87,'Kakol','581115',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27792,87,'Kalagonda','581111',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27793,87,'Kalasur','581112',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27794,87,'Kaliwal','581118',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27795,87,'Kallapur','581102',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27796,87,'Kalledevaru','581106',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27797,87,'Kallihal','581110',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27798,87,'Kalvekallapur','581101',1,0,'2022-03-03 12:32:57','2022-03-03 12:32:57'),(27799,87,'Kamadod','581145',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27800,87,'Kamanahalli','581197',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27801,87,'Kanavalli','581110',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27802,87,'Kanavisiddageri','581116',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27803,87,'Kanchinegalur','581101',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27804,87,'Karadagi','581126',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27805,87,'Karagudri','581104',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27806,87,'Karajagi (Haveri)','581112',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27807,87,'Karnataka Janapada Vishwa Vidyalaya Gotagodi','581197',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27808,87,'Karur','581145',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27809,87,'Katenhalli','581110',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27810,87,'Kelavarakoppa','581120',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27811,87,'Keravadi','581106',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27812,87,'Kerimattihalli','581110',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27813,87,'Kirawadi','581120',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27814,87,'Kittur','581213',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27815,87,'Kod','581109',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27816,87,'Kolur','581112',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27817,87,'Konanakeri','581193',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27818,87,'Konanakoppa','581104',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27819,87,'Konanatambagi','581211',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27820,87,'Konanatambigi','581213',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27821,87,'Kopparshikoppa','581104',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27822,87,'Kotihal','581119',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27823,87,'Kudapali','581115',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27824,87,'Kumarapattanam','581123',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27825,87,'Kummur','581109',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27826,87,'Kunchur','581208',1,0,'2022-03-03 12:32:58','2022-03-03 12:32:58'),(27827,87,'Kundur','581202',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27828,87,'Kunimellihalli','581202',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27829,87,'Kunnur','581193',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27830,87,'Kuppelur','581119',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27831,87,'Kuragund','581108',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27832,87,'Kurubagonda','581110',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27833,87,'Kurubaramallur','581118',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27834,87,'Kusagur','581208',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27835,87,'Kusanur','581120',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27836,87,'Kyalakonda','581126',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27837,87,'Lingadahalli','581119',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27838,87,'Madlur','581120',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27839,87,'Magod','581115',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27840,87,'Makanur','581123',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27841,87,'Makari','581116',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27842,87,'Malanayakanhalli','581119',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27843,87,'Mallur','581106',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27844,87,'Manakur','581208',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27845,87,'Mantagi','581104',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27846,87,'Mantrodi','581126',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27847,87,'Maranbid','581101',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27848,87,'Masanagi','581106',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27849,87,'Masanakatti','581104',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27850,87,'Masur (Haveri)','581210',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27851,87,'Medleri','581211',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27852,87,'Medur','581210',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27853,87,'Motebennur','581198',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27854,87,'Mudenur','581123',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27855,87,'Mudur','581104',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27856,87,'Mugali','581205',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27857,87,'Muttur','581109',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27858,87,'Nadiharalalli','581123',1,0,'2022-03-03 12:32:59','2022-03-03 12:32:59'),(27859,87,'Naganur','581202',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27860,87,'Nagavand','581210',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27861,87,'Naikerur','581118',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27862,87,'Nalavagal','581123',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27863,87,'Narayanapur','581202',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27864,87,'Negalur','581213',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27865,87,'Nelogal','581110',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27866,87,'Neregal','581148',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27867,87,'Nesvi','581208',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27868,87,'Niralagi','581108',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27869,87,'Niralagi','581205',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27870,87,'Nittur','581119',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27871,87,'Ranebennur Bzr','581115',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27872,87,'Ranebennur Eng-college','581115',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27873,87,'Ranebennur Extn','581115',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27874,87,'Ranebennur','581115',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27875,87,'Rattihalli','581116',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27876,87,'Sammasagi','581104',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27877,87,'Sangur','581148',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27878,87,'Satenhalli','581120',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27879,87,'Savanur Bzr','581118',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27880,87,'Savanur','581118',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27881,87,'Savasagi','581104',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27882,87,'Shadaguppi','581102',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27883,87,'Sheshagiri','581102',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27884,87,'Shidenur','581106',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27885,87,'Shiggaon Bzr','581205',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27886,87,'Shiggaon','581205',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27887,87,'Shirabadagi','581118',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27888,87,'Shiragambi','581116',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27889,87,'Shirgod','581104',1,0,'2022-03-03 12:33:00','2022-03-03 12:33:00'),(27890,87,'Shishuvinhal','581126',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27891,87,'Siddapur','581118',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27892,87,'Sudambi','581120',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27893,87,'Sunakalbidari','581115',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27894,87,'Suraleshwar','581102',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27895,87,'Suttakoti','581109',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27896,87,'Tadakanahalli','581210',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27897,87,'Tadas','581106',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27898,87,'Tadas','581212',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27899,87,'Tallihalli','581118',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27900,87,'Tavaragi','581111',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27901,87,'Teggihalli','581118',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27902,87,'Tevaramellihalli','581202',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27903,87,'Tilavalli','581120',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27904,87,'Tumminakatti','581119',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27905,87,'Ukkund','581208',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27906,87,'Uppunashi','581148',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27907,87,'Veerapur','581210',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27908,87,'Wardi','581148',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27909,87,'Yalagach','581213',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27910,87,'Yalawatti','581203',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27911,87,'Yalivigi','581118',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27912,87,'Yettinahalli','581109',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27913,88,'Abburkatte','571236',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27914,88,'Abyathmangala','571253',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27915,88,'Aigoor','571251',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27916,88,'Alur Siddapura','571235',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27917,88,'Ammathi','571211',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27918,88,'Andagove','571237',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27919,88,'Ankanahalli','571235',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27920,88,'Arameri','571218',1,0,'2022-03-03 12:33:01','2022-03-03 12:33:01'),(27921,88,'Arapattu','571212',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27922,88,'Arecad','571253',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27923,88,'Arji','571218',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27924,88,'Aruvathoklu','571201',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27925,88,'Aruvathoklu','571213',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27926,88,'Athur','571215',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27927,88,'Attur Nallur','571237',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27928,88,'Avandur','571201',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27929,88,'B.Shettigeri','571218',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27930,88,'Badaga','571217',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27931,88,'Badaga Bannagala','571253',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27932,88,'Badagarakeri','571249',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27933,88,'Baichanahally','571234',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27934,88,'Balagunda','571236',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27935,88,'Balaji','571213',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27936,88,'Balamuri','571252',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27937,88,'Balele','571219',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27938,88,'Ballamavati','571214',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27939,88,'Balliamandur','571216',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27940,88,'Basavanahally','571234',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27941,88,'Begur','571216',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27942,88,'Bekkesodlur','571216',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27943,88,'Bellumadu','571218',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27944,88,'Belur-somwarpet','571236',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27945,88,'Bemblur','571235',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27946,88,'Bessur','571231',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27947,88,'Bethri','571252',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27948,88,'Betoli','571218',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27949,88,'Bettadahalli','571236',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27950,88,'Bettageri','571201',1,0,'2022-03-03 12:33:02','2022-03-03 12:33:02'),(27951,88,'Bhadragola','571254',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27952,88,'Bhagamandala','571247',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27953,88,'Biligeri','571251',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27954,88,'Biligeri','571201',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27955,88,'Bilugunda','571211',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27956,88,'Birunani','571249',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27957,88,'Bittangala','571218',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27958,88,'Boikeri','571201',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27959,88,'Chembebellore','571218',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27960,88,'Chennayanakote','571215',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27961,88,'Cherambane','571201',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27962,88,'CHES','571248',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27963,88,'Chettalli','571248',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27964,88,'Chettimani','571247',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27965,88,'Cheyandane','571212',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27966,88,'Chikkamandur','571216',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27967,88,'Devanageri','571218',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27968,88,'Devanur','571219',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27969,88,'Devarapura','571213',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27970,88,'Dhanugala','571213',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27971,88,'Dundalli','571235',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27972,88,'Engilageri','571253',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27973,88,'Galibeedu','571201',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27974,88,'Ganagur','571236',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27975,88,'Garagandur','571251',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27976,88,'Garvale','571251',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27977,88,'Gonikoppal','571213',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27978,88,'Gonimarur','571236',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27979,88,'Gopalapura','571235',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27980,88,'Gowdalli','571236',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27981,88,'Guddehosur','571234',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27982,88,'Guyya','571253',1,0,'2022-03-03 12:33:03','2022-03-03 12:33:03'),(27983,88,'Hakathur','571252',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(27984,88,'Halgunda','571211',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(27985,88,'Halligattu','571216',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(27986,88,'Hanagallu','571236',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(27987,88,'Hancode','571236',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(27988,88,'Handli','571235',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(27989,88,'Haradur','571237',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(27990,88,'Harangi Project','571234',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(27991,88,'Harihara','571249',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(27992,88,'Hathur','571218',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(27993,88,'Hattihole','571251',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(27994,88,'Hebbale','571232',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(27995,88,'Heggala','571218',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(27996,88,'Heravanadu','571201',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(27997,88,'Herur','571234',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(27998,88,'Hodavada','571214',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(27999,88,'Hoddur','571252',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(28000,88,'Horoor','571237',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(28001,88,'Hoskote','571237',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(28002,88,'Hosur(Ammathi)','571211',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(28003,88,'Hudikeri','571249',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(28004,88,'Hysodlur','571249',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(28005,88,'Imangala','571218',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(28006,88,'Jodubetti','571216',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(28007,88,'K. Nidugane','571201',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(28008,88,'K.Boikeri','571218',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(28009,88,'K.Bychanahalli','571237',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(28010,88,'K.Chettalli','571248',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(28011,88,'K.Parambu','571218',1,0,'2022-03-03 12:33:04','2022-03-03 12:33:04'),(28012,88,'Kadagadal','571248',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28013,88,'Kadanga','571212',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28014,88,'Kadanur','571218',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28015,88,'Kaggodlu','571201',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28016,88,'Kaikeri','571213',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28017,88,'Kakkabbe','571212',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28018,88,'Kalathmadu','571211',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28019,88,'Kallur','571237',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28020,88,'Kalur','571201',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28021,88,'Kanbile','571237',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28022,88,'Kandanakolli','571201',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28023,88,'Kandangala','571218',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28024,88,'Kanive','571232',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28025,88,'Kannangala','571211',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28026,88,'Kanur','571216',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28027,88,'Karada','571212',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28028,88,'Karadigodu','571253',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28029,88,'Karike','571247',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28030,88,'Karmadu','571211',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28031,88,'Kavadi','571211',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28032,88,'Kedakal','571237',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28033,88,'Kedamallur','571218',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28034,88,'Kiragandur','571251',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28035,88,'Kirgur','571216',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28036,88,'Kodagarahalli','571237',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28037,88,'Kodlipet','571231',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28038,88,'Kolakeri','571214',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28039,88,'Kondangeri','571252',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28040,88,'Kothur','571216',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28041,88,'Kotoor','571216',1,0,'2022-03-03 12:33:05','2022-03-03 12:33:05'),(28042,88,'Kottageri','571219',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28043,88,'Kottur','571201',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28044,88,'Koynad','571201',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28045,88,'Kudige','571232',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28046,88,'Kudumangalore','571232',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28047,88,'Kumarahalli','571236',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28048,88,'Kumbur','571251',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28049,88,'Kunda','571216',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28050,88,'Kundacherry','571247',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28051,88,'Kundalli','571236',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28052,88,'Kurchi','571217',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28053,88,'Kusbur','571236',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28054,88,'Kushalnagar','571234',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28055,88,'Kutta','571250',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28056,88,'Kuttandi','571218',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28057,88,'Madalapura','571232',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28058,88,'Madapura','571251',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28059,88,'Made','571201',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28060,88,'Madikeri H.O','571201',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28061,88,'Madikeri West','571201',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28062,88,'Makkandur','571201',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28063,88,'Makutta','571218',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28064,88,'Malambi','571235',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28065,88,'Maldare','571253',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28066,88,'Manchalli','571250',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28067,88,'Maragodu','571252',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28068,88,'Maroor','571254',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28069,88,'Masagodu','571236',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28070,88,'Mathikad','571237',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28071,88,'Mayamudi','571213',1,0,'2022-03-03 12:33:06','2022-03-03 12:33:06'),(28072,88,'Mekur Hoskeri','571215',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28073,88,'Moovathoklu','571251',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28074,88,'Mudravalli','571235',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28075,88,'Mukkodlu','571251',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28076,88,'Mullusoge','571234',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28077,88,'Murnad','571252',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28078,88,'Mythadi','571218',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28079,88,'N.Sirangala','571237',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28080,88,'Nadikeri','571216',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28081,88,'Nagarahole','571250',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28082,88,'Nalkeri','571217',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28083,88,'Nalvathoklu','571218',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28084,88,'Nandigunda','571235',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28085,88,'Nanjarayapatna','571234',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28086,88,'Napoklu','571214',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28087,88,'Nelji','571214',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28088,88,'Nelliahudikeri','571253',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28089,88,'Nidtha','571235',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28090,88,'Nirugunda','571231',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28091,88,'Nittur','571219',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28092,88,'Nokya','571254',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28093,88,'Palur','571214',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28094,88,'Parakatageri','571249',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28095,88,'Parane','571212',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28096,88,'Pollibetta','571215',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28097,88,'Ponnampet','571216',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28098,88,'Ponnappasanthe','571213',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28099,88,'Rangasamudra','571234',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28100,88,'S.Kattemadu','571252',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28101,88,'Sannapulikote','571247',1,0,'2022-03-03 12:33:07','2022-03-03 12:33:07'),(28102,88,'Shanivarasanthe','571235',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28103,88,'Shanthalli','571236',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28104,88,'Siddapura-Kodagu','571253',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28105,88,'Sirangala','571232',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28106,88,'Sirangalli','571251',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28107,88,'Somwarpet','571236',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28108,88,'Srimangala','571217',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28109,88,'Suntikoppa','571237',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28110,88,'Surlabi','571251',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28111,88,'T.Shettigeri','571249',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28112,88,'Thakeri','571236',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28113,88,'Thalathmane','571201',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28114,88,'Thannirahalla','571236',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28115,88,'Theralu','571249',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28116,88,'Thithimathi','571254',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28117,88,'Tholur Shettalli','571236',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28118,88,'Thorenur','571232',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28119,88,'Uluguli','571237',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28120,88,'Valnur','571234',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28121,88,'Virajpet','571218',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28122,88,'Vontiangadi','571211',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28123,88,'West Nemmale','571249',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28124,88,'Yavakapady','571212',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28125,88,'Yemmemadu','571214',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28126,88,'Balambi(Chembu)','574234',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28127,88,'Peraje','574314',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28128,88,'Sampaje Gate','574234',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28129,89,'Addagal','563161',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28130,89,'Agara','563138',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28131,89,'Alambadi','563160',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28132,89,'Alipura','561213',1,0,'2022-03-03 12:33:08','2022-03-03 12:33:08'),(28133,89,'Alngur','563132',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28134,89,'Amblical','563132',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28135,89,'Ammanallur','563128',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28136,89,'Andersonpet','563113',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28137,89,'Anemadagu','562105',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28138,89,'Angondahalli','563131',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28139,89,'Anoor','563125',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28140,89,'Apmcyard Bangarpet','563114',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28141,89,'Arabikothnur','563133',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28142,89,'Araleri','563130',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28143,89,'Arehalli','563102',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28144,89,'Aruru','562104',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28145,89,'Avani','563127',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28146,89,'Bagepalli','561207',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28147,89,'Balakuntanahalli','561211',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28148,89,'Balamande','563129',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28149,89,'Baliganahalli','563139',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28150,89,'Balla','563131',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28151,89,'Balthamari','563134',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28152,89,'Bangarpet Bazar','563114',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28153,89,'Bangarpet','563114',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28154,89,'Bathlahalli','563129',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28155,89,'Batlahalli','563123',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28156,89,'Bavanahalli','563130',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28157,89,'Begihosahalli','563102',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28158,89,'Belamaranahalli','563133',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28159,89,'Beml Nagar Colony','563115',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28160,89,'Beml Nagar','563115',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28161,89,'Bethamangala','563116',1,0,'2022-03-03 12:33:09','2022-03-03 12:33:09'),(28162,89,'Bevinahalli','561213',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28163,89,'Bhakthrahalli','562102',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28164,89,'Bharathnagar','563115',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28165,89,'Billur','563124',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28166,89,'Bodagurki','563129',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28167,89,'Bommekallu','563128',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28168,89,'Budikote','563114',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28169,89,'Burudugunte','563159',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28170,89,'Bychapura','561208',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28171,89,'Byraganahalli','563161',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28172,89,'Byrakur','563131',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28173,89,'Byranahalli','563130',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28174,89,'C.A. Halli','563114',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28175,89,'Chakarasanahalli','563133',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28176,89,'Chakavelu','563124',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28177,89,'Chaldiganahalli','563126',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28178,89,'Chamarahalli','563103',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28179,89,'Championreefs','563117',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28180,89,'Chandrahalli','563125',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28181,89,'Chelur (Kolar)','563124',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28182,89,'Chendur','561207',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28183,89,'Chenjimale','563102',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28184,89,'Chikkakurugodu','561208',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28185,89,'Chikkathirupathi','563160',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28186,89,'Chilakalanerpu','563125',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28187,89,'Chinnsandra','563125',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28188,89,'Chintamani','563125',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28189,89,'Coromandel','563118',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28190,89,'Dadinayakanadoddi','563139',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28191,89,'Dalasanur','563126',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28192,89,'Deshihalli Bangarpet','563162',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28193,89,'Devalapalli','563138',1,0,'2022-03-03 12:33:10','2022-03-03 12:33:10'),(28194,89,'Devarayasamudra','563127',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28195,89,'Dinnahalli','563139',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28196,89,'Doddachinnahalli','563120',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28197,89,'Doddaganjur','563125',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28198,89,'Doddakadathur','563130',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28199,89,'Doddakambali','563113',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28200,89,'Doddamarali','562103',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28201,89,'Doddavalagamdi','563120',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28202,89,'Dodduponnadahalli','563129',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28203,89,'Doddurukarapanahalli','563162',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28204,89,'Doddvallabi','563133',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28205,89,'Donimdagu','563129',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28206,89,'Emmenatha','563136',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28207,89,'G.Marandahalli','563132',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28208,89,'Gadre','561213',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28209,89,'Gandlahalli','563126',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28210,89,'Ganeshpuram','563122',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28211,89,'Gangrekalve','562101',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28212,89,'Gannerahalli','563116',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28213,89,'Gattamadamangala','563113',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28214,89,'Gauribidanur','561208',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28215,89,'Ghattakamadenahalli','563121',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28216,89,'Gokunte','563131',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28217,89,'Gollahalli','563116',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28218,89,'Gowdagere','561211',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28219,89,'Gownipalli','563161',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28220,89,'Gudemarlahalli','563146',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28221,89,'Gudibanda (Kolar)','561209',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28222,89,'Gudipalli','563132',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28223,89,'Gullahalli','563129',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28224,89,'Gulur','561207',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28225,89,'Gummareddipura','563126',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28226,89,'Gundlakothur','561228',1,0,'2022-03-03 12:33:11','2022-03-03 12:33:11'),(28227,89,'H.Gollahalli','563131',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28228,89,'H.Hosakote','563160',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28229,89,'Halehalli','561211',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28230,89,'Halepalya','563137',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28231,89,'Hampasandra','561209',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28232,89,'Hampasandra','561210',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28233,89,'Hanumanahalli','563127',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28234,89,'Harati','563103',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28235,89,'Hassandahalli','563139',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28236,89,'Hebbani','563131',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28237,89,'Hirebidanur','561208',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28238,89,'Hirekattigenahalli','563128',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28239,89,'Hirenagavalli','562104',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28240,89,'Hogalagere','563138',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28241,89,'Holur','563126',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28242,89,'Hongenahalli','563130',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28243,89,'Hosahudya','561207',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28244,89,'Hossur','561210',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28245,89,'Hudukula','563114',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28246,89,'Huladenahalli','563137',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28247,89,'Hulibele','563114',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28248,89,'Hulkur','563116',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28249,89,'Hunkunda','563162',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28250,89,'Hurulagere','563160',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28251,89,'Huthur','563103',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28252,89,'Imarakunte','563138',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28253,89,'Immareddipalli','563146',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28254,89,'Inorahosahalli','563114',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28255,89,'Irgampalli','563123',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28256,89,'J. Thimmasandra','563135',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28257,89,'Jakkarasanakuppa','563121',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28258,89,'Jannaghatta','563126',1,0,'2022-03-03 12:33:12','2022-03-03 12:33:12'),(28259,89,'Jarabandahalli','561211',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28260,89,'Jayamangala','563160',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28261,89,'Jeelakunte','561228',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28262,89,'JILIPIGARIPALLI','561212',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28263,89,'Jinkalavaripalli','563134',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28264,89,'Julapalya','563159',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28265,89,'K N sanitorium','563102',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28266,89,'Kadadanamari','563123',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28267,89,'Kadalaveni','561210',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28268,89,'Kadripura','563116',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28269,89,'Kagathi','563146',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28270,89,'Kaiwara','563128',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28271,89,'Kallahalli','563125',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28272,89,'Kallinayakanahalli','561213',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28273,89,'Kallur','563135',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28274,89,'Kamadenahalli','563103',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28275,89,'Kamasamudra','563129',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28276,89,'Kammasandra','563121',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28277,89,'Kandavara','562103',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28278,89,'Kangndlahalli','563121',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28279,89,'Kannasandra','563136',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28280,89,'Kappalamadagu','563131',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28281,89,'Karahalli','563162',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28282,89,'Karamangala','563114',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28283,89,'Kasettipalli','563135',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28284,89,'Kembodi','563103',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28285,89,'Kempapura','563113',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28286,89,'Kencharlahalli','563125',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28287,89,'Keshavara','562102',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28288,89,'Kethganahalli','563129',1,0,'2022-03-03 12:33:13','2022-03-03 12:33:13'),(28289,89,'Koladevi','563131',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28290,89,'Kolar Bazar','563101',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28291,89,'Kolar Doddapet','563101',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28292,89,'Kolar Extension','563102',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28293,89,'Kolar Gandhi Nagar','563101',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28294,89,'Kolar Gulpet','563102',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28295,89,'Kolar H.O','563101',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28296,89,'Kolar Hospital Circle','563101',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28297,89,'Konapalli','563125',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28298,89,'Kondasettihalli','563137',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28299,89,'Kongarahalli','563129',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28300,89,'Korlaparthi','563159',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28301,89,'Kotaballapalli','563135',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28302,89,'Kotegal','563125',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28303,89,'Kothmangala','563127',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28304,89,'Kudenoor','563130',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28305,89,'Kuduvathi','562103',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28306,89,'Kuppampalya','563136',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28307,89,'Kurgal','563102',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28308,89,'Kurgepalli','563134',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28309,89,'Kurudi','561210',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28310,89,'Kurudumale','563131',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28311,89,'Kyalnur','563102',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28312,89,'Kysamballi','563121',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28313,89,'Lakkur','563160',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28314,89,'Lakshmipura','563135',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28315,89,'Madderi','563102',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28316,89,'Maderahalli','563102',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28317,89,'Madivala','563130',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28318,89,'Magondhi','563114',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28319,89,'Mallanayakanahalli','563136',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28320,89,'Malur Railway Station','563160',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28321,89,'Malur','563130',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28322,89,'Manchennahalli','561211',1,0,'2022-03-03 12:33:14','2022-03-03 12:33:14'),(28323,89,'Manchineelakote','563134',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28324,89,'Mandikallu','562104',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28325,89,'Maniganapalli','563135',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28326,89,'Marasanapalli','563161',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28327,89,'Marikuppam','563119',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28328,89,'Masthi','563139',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28329,89,'Matakannsandra','563131',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28330,89,'Matnahalli','563102',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28331,89,'Mavahalli','563162',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28332,89,'Medihala','563102',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28333,89,'Melur (Kolar)','562102',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28334,89,'Mindigal','563125',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28335,89,'Mothakapalli','563138',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28336,89,'Mothakapalli','563136',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28337,89,'Mudimadagu','563134',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28338,89,'Mudiyanur','563127',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28339,89,'Mudlagollahalli','563123',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28340,89,'Muduvadi','563126',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28341,89,'Muduvathi','563102',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28342,89,'Mulbagal Bazar','563131',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28343,89,'Mulbagal','563131',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28344,89,'Murugamale','563146',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28345,89,'Mustoor','563116',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28346,89,'Mustoor','563132',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28347,89,'Mylandahalli','563125',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28348,89,'N.G. Hulkur','563116',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28349,89,'Nadampalli','563125',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28350,89,'Nagaragere','561228',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28351,89,'Nakkalahalli','561228',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28352,89,'Namagondlu','561206',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28353,89,'Nambihalli','563126',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28354,89,'Nandi (Kolar)','562103',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28355,89,'Nangli','563132',1,0,'2022-03-03 12:33:15','2022-03-03 12:33:15'),(28356,89,'Narasapura','563133',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28357,89,'Nayakarahalli','563126',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28358,89,'Nellahalli','563137',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28359,89,'Nidaramangala','563137',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28360,89,'Nndiganahalli','563146',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28361,89,'Nukkanahalli','563126',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28362,89,'Nutuve','563137',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28363,89,'Oolavadi','563125',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28364,89,'Oorgaum','563120',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28365,89,'Oorgaumpet','563121',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28366,89,'Oorkunte Mittur','563127',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28367,89,'Padmaghatta','563132',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28368,89,'Parandahalli','563122',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28369,89,'Pathanelavanki','563135',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28370,89,'Pathapalya','561212',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28371,89,'Peddur','563146',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28372,89,'Posettihalli','561211',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28373,89,'Pothenahalli','561213',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28374,89,'Pugurkote','563135',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28375,89,'Pura','561211',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28376,89,'Raghuttahalli','563123',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28377,89,'Rajakallahalli','563102',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28378,89,'Rajendrahalli','563132',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28379,89,'Ramapura','561210',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28380,89,'Ramasagara','563116',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28381,89,'Rayalpadu','563134',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28382,89,'Robertsonpet','563122',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28383,89,'Ronur','563135',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28384,89,'Ronurthimmasandra','563135',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28385,89,'S. Madamangala','563114',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28386,89,'Santhehalli','563130',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28387,89,'Santhekallahalli','563128',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28388,89,'Settikothanur','563130',1,0,'2022-03-03 12:33:16','2022-03-03 12:33:16'),(28389,89,'Shanubhoganahalli','563103',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28390,89,'Shapur','563103',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28391,89,'Shillengere','563103',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28392,89,'Shivarapatna','563130',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28393,89,'Sidlaghatta','562105',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28394,89,'Somenahalli','562104',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28395,89,'Someshwara','562104',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28396,89,'Someshwarpalya','563131',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28397,89,'Sonaganahalli','561210',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28398,89,'Soregowdanakote','563162',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28399,89,'Srinivaspur','563135',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28400,89,'Srinivsasandra','563121',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28401,89,'Sugatur','563102',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28402,89,'Suggondahalli','563139',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28403,89,'Sundarapalya','563116',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28404,89,'Tadigallu','563135',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28405,89,'Talagavara','563128',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28406,89,'Tamaka','563103',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28407,89,'Tamatamakanahalli','563129',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28408,89,'Taridalu','561213',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28409,89,'Tayalur','563136',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28410,89,'Tekal','563137',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28411,89,'Thimmampalli','561207',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28412,89,'Thimmaravathanahalli','563136',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28413,89,'Thippedoddi','563132',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28414,89,'Thippenahalli','562103',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28415,89,'Thondebhavi','561213',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28416,89,'Thoppanahalli','563129',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28417,89,'Thoradevanahalli','563126',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28418,89,'Thoralakki','563137',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28419,89,'Thotli','563102',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28420,89,'Thyvnahalli','563130',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28421,89,'Tirumani','562104',1,0,'2022-03-03 12:33:17','2022-03-03 12:33:17'),(28422,89,'Ullappanahalli','563125',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28423,89,'Ullodu','561209',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28424,89,'Uthnur','563127',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28425,89,'Varlakonda','562104',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28426,89,'Vatadahosahalli','561228',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28427,89,'Veerupakshi','563131',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28428,89,'Vegamadagu','563136',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28429,89,'Velagalaburre','563126',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28430,89,'Vemgal','563102',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28431,89,'Vengasandra','563116',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28432,89,'Vidurashwatha','561208',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28433,89,'Vokkaleri','563130',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28434,89,'Volegeranahalli','563126',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28435,89,'Yadaganahalli','563161',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28436,89,'Yarramavaripalli','563134',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28437,89,'Yedaruru','563138',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28438,89,'Yelagondahalli','563127',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28439,89,'Yeldur','563138',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28440,89,'Yelegere','562104',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28441,89,'Yelesandra','563114',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28442,89,'Yeshvanthapura','563130',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28443,90,'Adavibhavi','583277',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28444,90,'Agalkera','583234',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28445,90,'Agoli','583235',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28446,90,'Alawandi','583226',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28447,90,'Anegundi','583227',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28448,90,'Arhal','583235',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28449,90,'Arkeri','583230',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28450,90,'Ayodhya','583227',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28451,90,'Bahaddurbandi','583238',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28452,90,'Balgeri','583232',1,0,'2022-03-03 12:33:18','2022-03-03 12:33:18'),(28453,90,'Ballutagi','583278',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28454,90,'Ballutgi','583236',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28455,90,'Bandargallu','583281',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28456,90,'Bandi','583277',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28457,90,'Bandiharlapur','583234',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28458,90,'Bannikoppa','583238',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28459,90,'Bargoor','583282',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28460,90,'Basapatna','583235',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28461,90,'Basavanadurga','583227',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28462,90,'Benakanhal','583281',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28463,90,'Benkal','583232',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28464,90,'Betgera','583238',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28465,90,'Bevinhal','583229',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28466,90,'Bevinhalli','583234',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28467,90,'Bewoor','583237',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28468,90,'Bhagyanagar (Koppal)','583238',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28469,90,'Bhanapur','583238',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28470,90,'Bichkal','583278',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28471,90,'Bilekal','583280',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28472,90,'Binhal','583232',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28473,90,'Bisarahalli','583238',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28474,90,'Bochenhalli','583226',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28475,90,'Budgumpa','583229',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28476,90,'Budgumpa','583228',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28477,90,'Chalgera','583277',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28478,90,'Chellur','583229',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28479,90,'Chickbenkal','583235',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28480,90,'Chickdankankal','583283',1,0,'2022-03-03 12:33:19','2022-03-03 12:33:19'),(28481,90,'Chickjanthkal','583227',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28482,90,'Chickkabommanhal','583283',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28483,90,'Chickmendinhal','583283',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28484,90,'Chickmyageri','583236',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28485,90,'Chikenkoppa','583232',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28486,90,'Chilakmukhi','583237',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28487,90,'Dammur','583236',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28488,90,'Danapur','583268',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28489,90,'Dotihal','583278',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28490,90,'Dyampur','583232',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28491,90,'Gadgeri','583236',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28492,90,'Gandhal','583277',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28493,90,'Gangavathi','583227',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28494,90,'Gangavati Bazar','583227',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28495,90,'Gangavati Cbs Gunj','583227',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28496,90,'Gangavati Hireejankal','583227',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28497,90,'Gangavati Julynagar','583227',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28498,90,'Gangavati M V Circle','583227',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28499,90,'Ghattreddihal','583226',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28500,90,'Ginigera','583228',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28501,90,'Gondbal','583238',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28502,90,'Gotagi','583278',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28503,90,'Gouripur','583283',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28504,90,'Gudadur','583280',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28505,90,'Gudadurkal','583281',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28506,90,'Guladahalli','583228',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28507,90,'Gumgera','583277',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28508,90,'Gundur','583282',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28509,90,'Gunhal','583237',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28510,90,'Habbalkatti','583280',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28511,90,'Halagera','583238',1,0,'2022-03-03 12:33:20','2022-03-03 12:33:20'),(28512,90,'Hanamsagar','583281',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28513,90,'Handral','583238',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28514,90,'Hanumanhal','583280',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28515,90,'Hanwal','583268',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28516,90,'Hasgal','583237',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28517,90,'Hatti','583226',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28518,90,'Hebbal','583268',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28519,90,'Heroor','583227',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28520,90,'Hirearlihalli','583277',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28521,90,'Hirebaganal','583228',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28522,90,'Hirebannigol','583277',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28523,90,'Hirebidnal','583230',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28524,90,'Hirebommanhal','583237',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28525,90,'Hiregonnagar','583280',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28526,90,'Hirekhed','583283',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28527,90,'Hiremannapur','583277',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28528,90,'Hiremyageri','583236',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28529,90,'Hirenandihal','583277',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28530,90,'Hiresindogi','583238',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28531,90,'Hirewaddarkal','583237',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28532,90,'Hitnal','583234',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28533,90,'Hoolgera','583281',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28534,90,'Hosahalli','583227',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28535,90,'Hosahalli','583234',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28536,90,'Hoskera','583268',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28537,90,'Hulihyder','583283',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28538,90,'Huliyapur','583279',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28539,90,'Hulkihal','583229',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28540,90,'Hunsihal','583237',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28541,90,'Indargi','583228',1,0,'2022-03-03 12:33:21','2022-03-03 12:33:21'),(28542,90,'Irkalgad','583237',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28543,90,'Itagi','583232',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28544,90,'Jalihal','583278',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28545,90,'Jangamarakalgudi','583268',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28546,90,'Jeeral','583283',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28547,90,'Jumlapur','583278',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28548,90,'Kabbargi','583281',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28549,90,'Kadekoppa','583278',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28550,90,'Kalalbandi','583277',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28551,90,'Kalamalli','583279',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28552,90,'Kalkeri','583230',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28553,90,'Kalkeri','583283',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28554,90,'Kallur','583236',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28555,90,'Kamnoor','583237',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28556,90,'Kanakgiri','583283',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28557,90,'Kandakur','583277',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28558,90,'Karatgi','583229',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28559,90,'Kardoni','583229',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28560,90,'Karkihalli','583228',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28561,90,'Karmudi','583236',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28562,90,'Katapur','583281',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28563,90,'Kawaloor','583226',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28564,90,'Kesarhatti','583227',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28565,90,'Kilarhatti','583279',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28566,90,'Kinhal','583230',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28567,90,'Kolur','583238',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28568,90,'Konsagar','583277',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28569,90,'Koppal Bazar','583231',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28570,90,'Koppal G S Gunj','583231',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28571,90,'Koppal H.O','583231',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28572,90,'Koppal R S','583231',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28573,90,'Koradkera','583277',1,0,'2022-03-03 12:33:22','2022-03-03 12:33:22'),(28574,90,'Kudrimoti','583237',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28575,90,'Kuknoor','583232',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28576,90,'Kumbalavati','583281',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28577,90,'Kunikera','583228',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28578,90,'Kunkanpalli','583228',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28579,90,'Kushtagi','583277',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28580,90,'Kutaganahalli','583228',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28581,90,'Kyadiguppa','583278',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28582,90,'Lebgeri','583237',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28583,90,'Lingadhalli','583277',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28584,90,'Madapur','583278',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28585,90,'Madinur','583230',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28586,90,'Mailapur','583229',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28587,90,'Mainhalli','583238',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28588,90,'Malaksamudra','583236',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28589,90,'Malekoppa','583232',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28590,90,'Malgatti','583280',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28591,90,'Mallapur','583227',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28592,90,'Mandalgera','583232',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28593,90,'Mangalore','583230',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28594,90,'Mannerhal','583281',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28595,90,'Marlanhalli','583229',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28596,90,'Marli','583268',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28597,90,'Masbihanchinal','583232',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28598,90,'MataldinniB.O','583237',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28599,90,'Menedal','583279',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28600,90,'Muddaballi','583238',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28601,90,'Muddalgundi','583278',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28602,90,'Mudenur','583278',1,0,'2022-03-03 12:33:23','2022-03-03 12:33:23'),(28603,90,'Mudhol','583236',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28604,90,'Mukkumpi','583228',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28605,90,'Munirabad RS','583234',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28606,90,'Murdi','583237',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28607,90,'Mushtoor','583282',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28608,90,'Muslapur','583283',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28609,90,'Nandihalli','583229',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28610,90,'Navalhalli','583279',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28611,90,'Neeralgi','583238',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28612,90,'Nilogal','583280',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28613,90,'Nowli','583229',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28614,90,'Ojanhalli','583238',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28615,90,'Oolenur','583229',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28616,90,'Rajoor','583236',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28617,90,'Ryavanki','583230',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28618,90,'Sanapur','583234',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28619,90,'Sanganhal','583236',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28620,90,'Sangapur','583227',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28621,90,'Sankanoor','583236',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28622,90,'Shivapur','583234',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28623,90,'Siddapur','583282',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28624,90,'Singanhal','583282',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28625,90,'Sirur','583230',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28626,90,'Somapur','583232',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28627,90,'Sriramnagar (Koppal)','583282',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28628,90,'Sulekal','583283',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28629,90,'Tadakal','583238',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28630,90,'Talavagera','583277',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28631,90,'Talkeri','583277',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28632,90,'Taralakatti','583237',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28633,90,'Tavargera','583279',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28634,90,'Tigri','583226',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28635,90,'Tondihal','583232',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28636,90,'Tuggaldona','583280',1,0,'2022-03-03 12:33:24','2022-03-03 12:33:24'),(28637,90,'Udamkal','583235',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28638,90,'Vanagera','583277',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28639,90,'Vanageri','583237',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28640,90,'Vankalkunta','583237',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28641,90,'Venkatgiri','583235',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28642,90,'Yeddoni','583277',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28643,90,'Yediapur','583232',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28644,90,'Yelbunchi','583281',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28645,90,'Yelburga','583236',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28646,90,'Yerdoni','583229',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28647,90,'Yergera','583281',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28648,90,'Yerigonal','583281',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28649,90,'Yerihanchinal','583232',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28650,91,'Abalavadi','571425',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28651,91,'Acetate Town','571404',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28652,91,'Agasanapura','571475',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28653,91,'Aghalaya','571436',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28654,91,'Agraharabachahalli','571426',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28655,91,'Akkihebbal','571605',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28656,91,'Alagodu','571807',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28657,91,'Alambavadikaval','571605',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28658,91,'Alenahalli','571605',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28659,91,'Alisandra','571448',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28660,91,'Alpahalli','571434',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28661,91,'Alur-maddur','571433',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28662,91,'Anasale','571424',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28663,91,'Anchechittanahalli','571448',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28664,91,'Anegola','571423',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28665,91,'Arakere','571415',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28666,91,'Aralakuppe','571427',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28667,91,'Arani','571418',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28668,91,'Athgur','571433',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28669,91,'B.Gowdagere','571404',1,0,'2022-03-03 12:33:25','2022-03-03 12:33:25'),(28670,91,'Bachahalli','571812',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28671,91,'Balagangadaranathnagar','571448',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28672,91,'Balighatta','571431',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28673,91,'Ballekere','571426',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28674,91,'Ballekere','571415',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28675,91,'Ballenahalli','571812',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28676,91,'Ballenahalli','571807',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28677,91,'Bandihole','571426',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28678,91,'Bannangadi','571812',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28679,91,'Basaralu','571416',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28680,91,'Bebi','571416',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28681,91,'Beeraballi','571605',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28682,91,'Beereshwarapura','571432',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28683,91,'Bekkalale','571425',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28684,91,'Belagola','571606',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28685,91,'Belakavadi','571417',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28686,91,'Belathur','571419',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28687,91,'Bellur','571433',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28688,91,'Bellur','571418',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28689,91,'Belur-mandya','571404',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28690,91,'Benahatti','571416',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28691,91,'Besagarahalli','571419',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28692,91,'Bevinahalli','571478',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28693,91,'Bevkal','571405',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28694,91,'Bharathinagar','571422',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28695,91,'Bheemanahalli','571445',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28696,91,'Bidarahalli','571415',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28697,91,'Bidarahalli','571422',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28698,91,'Bidarakere','571802',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28699,91,'Bidarakote','571425',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28700,91,'Bilagunda','571418',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28701,91,'Billenahalli','571436',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28702,91,'Bindenahalli','571445',1,0,'2022-03-03 12:33:26','2022-03-03 12:33:26'),(28703,91,'Bindiganavile','571802',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28704,91,'Bogadi','571432',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28705,91,'Bommanahalli','571425',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28706,91,'Bommanayakanahalli','571432',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28707,91,'Boppegowdanapura','571417',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28708,91,'Bramhadevarahalli','571432',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28709,91,'Budanur','571404',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28710,91,'Buhalli','571463',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28711,91,'Bukkinakere','571812',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28712,91,'Byadarahalli','571421',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28713,91,'Byrapura','571426',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28714,91,'Chakenahalli','571418',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28715,91,'Chamanahalli','571429',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28716,91,'Chandagalu','571446',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28717,91,'Chandagalu','571405',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28718,91,'Chattamgere','571426',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28719,91,'Cheeranahalli','571403',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28720,91,'Chikkaballi','571446',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28721,91,'Chikkahebbagilu','571463',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28722,91,'Chikkankanahalli','571415',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28723,91,'Chikkarasinakere','571422',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28724,91,'Chinakurali','571455',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28725,91,'Chinya','571434',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28726,91,'Chottanahalli','571430',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28727,91,'Chowdenahalli','571423',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28728,91,'Chunchanahalli','571811',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28729,91,'Dadaga','571418',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28730,91,'Dadamahalli','571421',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28731,91,'Dalavoykodihalli','571421',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28732,91,'Daoddagarudanahalli','571416',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28733,91,'Dasanadoddi','571430',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28734,91,'Desihalli','571429',1,0,'2022-03-03 12:33:27','2022-03-03 12:33:27'),(28735,91,'Devalapura (Mandya)','571445',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28736,91,'Devaramallanayakanahalli','571445',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28737,91,'Dhangur','571475',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28738,91,'Dinka','571812',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28739,91,'Doddabala','571802',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28740,91,'Doddabyadarahalli','571434',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28741,91,'Doddachikkanahalli','571445',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28742,91,'Doddajataka','571418',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28743,91,'Doddapalya','571807',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28744,91,'Doddarasinakere','571422',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28745,91,'Doddasomanahalli','571436',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28746,91,'Doddayagati','571432',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28747,91,'Dudda-mandya','571405',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28748,91,'Dugganahalli','571430',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28749,91,'Dundanahalli','571476',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28750,91,'Dyavapatna','571417',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28751,91,'G Malligere','571416',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28752,91,'G Nagathihalli','571811',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28753,91,'Gajanur','571430',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28754,91,'Gamanahalli','571478',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28755,91,'Gandalu','571405',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28756,91,'Ganjam','571477',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28757,91,'Ganjigere','571812',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28758,91,'Gejjalagere','571428',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28759,91,'Gendehosahalli','571415',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28760,91,'Gondenahalli','571448',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28761,91,'Gopalapura','571402',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28762,91,'Goravale','571405',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28763,91,'Goravanahalli','571428',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28764,91,'Gowdagere','571475',1,0,'2022-03-03 12:33:28','2022-03-03 12:33:28'),(28765,91,'Gudigenahalli','571416',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28766,91,'Gulur','571425',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28767,91,'Guthal Colony','571403',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28768,91,'H Malligere','571402',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28769,91,'Hadli','571475',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28770,91,'Hagalahalli','571422',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28771,91,'Halagur','571421',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28772,91,'Halakere','571450',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28773,91,'Halebeedu','571434',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28774,91,'Hallegere','571446',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28775,91,'Hanakere','571404',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28776,91,'Haradanahalli','571445',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28777,91,'Haralahalli','571426',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28778,91,'Haralakere','571425',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28779,91,'Haravu','571427',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28780,91,'Hariharapura','571605',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28781,91,'Hebbadihundi','571477',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28782,91,'Hebbani','571430',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28783,91,'Hebbaralu','571476',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28784,91,'Hemmanahalli','571429',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28785,91,'Hirekalale','571423',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28786,91,'Hiremarali','571434',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28787,91,'Hittanahalli','571424',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28788,91,'Hodaghatta','571450',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28789,91,'Holalu','571402',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28790,91,'Honnaikanahalli','571450',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28791,91,'Honnalagere','571433',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28792,91,'Honnavara','571802',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28793,91,'Honnayakanahalli','571422',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28794,91,'Honnenahalli','571418',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28795,91,'Hosagavi','571425',1,0,'2022-03-03 12:33:29','2022-03-03 12:33:29'),(28796,91,'Hosahalli','571606',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28797,91,'Hosahalli','571417',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28798,91,'Hosakere','571419',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28799,91,'Hosur-mandya','571402',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28800,91,'Hubbanahalli','571436',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28801,91,'Hulikere','571606',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28802,91,'Hulikere','571448',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28803,91,'Hulivana','571446',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28804,91,'Hullenahalli','571405',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28805,91,'Hullikere','571405',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28806,91,'Huskur','571475',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28807,91,'Huthagere','571476',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28808,91,'Ikkanahalli','571423',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28809,91,'Induvalu','571403',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28810,91,'Jaginakere','571436',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28811,91,'Jainahalli','571605',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28812,91,'Jakkanahalli','571807',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28813,91,'Jodikaradahalli','571432',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28814,91,'K Gowdagere','571446',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28815,91,'K.Settahalli','571807',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28816,91,'Kachigere','571404',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28817,91,'Kadabahalli','571448',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28818,91,'Kadalagere','571431',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28819,91,'Kadalur','571433',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28820,91,'Kadukothanahalli','571422',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28821,91,'Kaggalipura','571417',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28822,91,'Kalenahalli','571402',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28823,91,'Kalenahalli','571434',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28824,91,'Kalinganahalli','571418',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28825,91,'Kalkuni','571424',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28826,91,'Kalludevanahalli','571432',1,0,'2022-03-03 12:33:30','2022-03-03 12:33:30'),(28827,91,'Kambadahalli','571802',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28828,91,'Kambadahalli','571416',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28829,91,'Kanaganahalli','571455',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28830,91,'Kanaganamaradi','571434',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28831,91,'Kanchanahalli','571811',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28832,91,'Kandegala','571430',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28833,91,'Kanivekoppal','571455',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28834,91,'Kannali','571404',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28835,91,'Kanthapura','571432',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28836,91,'Karadakere','571422',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28837,91,'Keelaghatta','571419',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28838,91,'Keelara','571450',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28839,91,'Kembuthagere','571475',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28840,91,'Kennalu','571435',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28841,91,'Keragodu','571446',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28842,91,'Kestur','571476',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28843,91,'Kikkeri','571423',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28844,91,'Kiragavalu','571424',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28845,91,'Kirangoor','571807',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28846,91,'Kirgandur','571403',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28847,91,'Kodagahalli','571417',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28848,91,'Kodiyala','571415',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28849,91,'Kommerahalli','571402',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28850,91,'Konanahalli','571403',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28851,91,'Konasale','571419',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28852,91,'Koppa-mandya','571425',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28853,91,'Koratigere','571436',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28854,91,'Kottatti','571478',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28855,91,'Kowdlay','571425',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28856,91,'Krishnaraja Sagar','571607',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28857,91,'Krishnarajapete','571426',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28858,91,'Kudagabalu','571445',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28859,91,'Kulagere','571433',1,0,'2022-03-03 12:33:31','2022-03-03 12:33:31'),(28860,91,'Kundur','571430',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28861,91,'Kundur','571423',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28862,91,'Kuppahalli','571426',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28863,91,'Kurubarabettahalli','571435',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28864,91,'Kyathaghatta','571422',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28865,91,'Kyathanahalli','571427',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28866,91,'Lalanakere','571802',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28867,91,'Lingapatna','571421',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28868,91,'Lokasara','571478',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28869,91,'M.Settahalli','571807',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28870,91,'Madahalli','571430',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28871,91,'Madapura','571423',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28872,91,'Madarahalli','571422',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28873,91,'Maddur (Mandya)','571428',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28874,91,'Madechakanahalli','571405',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28875,91,'Madenahalli','571422',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28876,91,'Maduvinakodi','571605',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28877,91,'Mahadeshwarapura','571434',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28878,91,'Mahadevapura','571415',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28879,91,'Makavalli','571426',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28880,91,'Malagaranahalli','571428',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28881,91,'Malagur','571436',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28882,91,'Malavalli Extn','571430',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28883,91,'Malavalli','571430',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28884,91,'Mallenahalli','571405',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28885,91,'Mallinaikanahalli','571476',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28886,91,'Mallinathapura','571463',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28887,91,'Manchegowdanahalli','571416',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28888,91,'Mandagere','571423',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28889,91,'Mandya Ashoknagar','571401',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28890,91,'Mandya Azadnagar','571401',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28891,91,'Mandya District','571401',1,0,'2022-03-03 12:33:32','2022-03-03 12:33:32'),(28892,91,'Mandya Gandhinagar','571401',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28893,91,'Mandya H.O','571401',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28894,91,'Mandya Shankarnagar','571401',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28895,91,'Mangala','571478',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28896,91,'Manikanahalli','571434',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28897,91,'Mannahalli','571432',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28898,91,'Maragowdanahalli','571446',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28899,91,'Maralagala','571807',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28900,91,'Maraliga','571419',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28901,91,'Margonahalli','571423',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28902,91,'Mavinakere','571812',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28903,91,'Mayigonahalli','571802',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28904,91,'Melapura','571477',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28905,91,'Melukote','571431',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28906,91,'Menasagere','571422',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28907,91,'Mikkere','571424',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28908,91,'Modur','571426',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28909,91,'Mudagandur','571416',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28910,91,'Mudalamellahalli','571448',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28911,91,'Mulukatte','571432',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28912,91,'Murukanahalli','571426',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28913,91,'Muthegere','571416',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28914,91,'Mylarapatna','571432',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28915,91,'Nagamangala','571432',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28916,91,'Nagarakere','571428',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28917,91,'Nagoonahalli','571477',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28918,91,'Najegowdanadoddi','571475',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28919,91,'Nambinayakanahalli','571425',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28920,91,'Narayanapura','571455',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28921,91,'Navile','571476',1,0,'2022-03-03 12:33:33','2022-03-03 12:33:33'),(28922,91,'Nayakanahalli','571436',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28923,91,'Nelamakanahalli','571430',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28924,91,'Nelamane','571435',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28925,91,'Nelligere','571418',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28926,91,'Neralakere','571415',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28927,91,'Netkallu','571430',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28928,91,'Nidaghatta','571430',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28929,91,'Nidaghatta','571433',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28930,91,'Niluvagilu','571419',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28931,91,'Nittur Halasahalli','571421',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28932,91,'Nittur Kodiahalli','571421',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28933,91,'Nyamanahalli','571431',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28934,91,'Paduvalapatna','571432',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28935,91,'Palagrahara','571432',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28936,91,'Palahalli','571606',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28937,91,'Pandavapura R S','571435',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28938,91,'Pandavapura','571434',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28939,91,'Pattasomanahalli','571434',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28940,91,'Purigali','571463',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28941,91,'Ragibommanahalli','571430',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28942,91,'Ragimudanahalli','571455',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28943,91,'Rampura','571427',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28944,91,'Ranganathapura','571436',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28945,91,'Ravani','571463',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28946,91,'Rayasamudra','571426',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28947,91,'S I Honnalagere','571422',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28948,91,'Sadhaholalu','571428',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28949,91,'Sanaba','571455',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28950,91,'Santhebachahalli','571436',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28951,91,'Santhekasalagere','571478',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28952,91,'Sargur','571463',1,0,'2022-03-03 12:33:34','2022-03-03 12:33:34'),(28953,91,'Sasalu','571423',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28954,91,'Sathenahalli','571802',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28955,91,'Sathnur','571402',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28956,91,'Seelenere','571426',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28957,91,'Settihalli','571430',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28958,91,'Shamboonahalli','571431',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28959,91,'Shivalli','571405',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28960,91,'Shivapura Maddur','571429',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28961,91,'Shivaraguda Vidya Peeta','571419',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28962,91,'Sindaghatta','571426',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28963,91,'Sivasamudram','571430',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28964,91,'Sollepura','571423',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28965,91,'Somanahalli','571605',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28966,91,'Somanahalli','571429',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28967,91,'Somanathapura','571605',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28968,91,'Soonagahalli','571403',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28969,91,'Srirangapatna H.O','571438',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28970,91,'Sugar Town','571402',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28971,91,'Sujjalur','571424',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28972,91,'Sunkathonnur','571434',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28973,91,'T Channapura','571432',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28974,91,'T.M.Hosur','571807',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28975,91,'Tadagavadi','571415',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28976,91,'Talagavadi','571430',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28977,91,'Tendekere','571426',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28978,91,'Tenginaghatta','571423',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28979,91,'Thaggahalli','571403',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28980,91,'Thaggahalli-koppa','571425',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28981,91,'Thattekere','571432',1,0,'2022-03-03 12:33:35','2022-03-03 12:33:35'),(28982,91,'Thattihalli','571445',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(28983,91,'Thiruganahalli','571436',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(28984,91,'Thuppadamadu','571432',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(28985,91,'Thyloor','571433',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(28986,91,'Tirumalasagara Chatra','571434',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(28987,91,'Tonnur','571434',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(28988,91,'Torekadanahalli','571421',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(28989,91,'Toresettihalli','571476',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(28990,91,'Uginahalli','571423',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(28991,91,'Ummadahalli','571404',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(28992,91,'V C Farm','571405',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(28993,91,'Vadiyandanahalli','571415',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(28994,91,'Valagarahalli','571428',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(28995,91,'Valagerememenesa','571426',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(28996,91,'Vittalapura','571426',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(28997,91,'Yadaganahalli','571422',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(28998,91,'Yathambadi','571421',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(28999,91,'Yelechakanahalli','571402',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(29000,91,'Yeliyur','571402',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(29001,91,'Yenneholekoppal','571427',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(29002,92,'Alanahalli','570026',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(29003,92,'Alanahalli','570028',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(29004,92,'Alanahlli','571107',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(29005,92,'Ambalare','571102',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(29006,92,'Anandur','571130',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(29007,92,'Ankanahalli','571604',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(29008,92,'Ankanahalli','571617',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(29009,92,'Annur','571114',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(29010,92,'Antharasanthe','571114',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(29011,92,'Arenahalli','571108',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(29012,92,'Arjunahalli','571601',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(29013,92,'Aswalu','571189',1,0,'2022-03-03 12:33:36','2022-03-03 12:33:36'),(29014,92,'Attigodu','571102',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29015,92,'Ayyarahalli','571311',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29016,92,'Ballenahalli','571189',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29017,92,'Ballur','571604',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29018,92,'Bannikuppe','571105',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29019,92,'Bannimantap','570015',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29020,92,'Barse','571102',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29021,92,'Basavarajapura','571602',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29022,92,'Beeramballi','571116',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29023,92,'Beeravalu','571121',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29024,92,'Belavadi','570018',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29025,92,'Bettadapura','571102',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29026,92,'Bettadathunga','571102',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29027,92,'Bheriya','571601',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29028,92,'Bhuvanahalli','571102',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29029,92,'Bidarahalli','571116',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29030,92,'Bilikere','571103',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29031,92,'Bogadi','570026',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29032,92,'Bolanahalli','571103',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29033,92,'Brindavan Extension','570020',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29034,92,'Byadarahalli','571602',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29035,92,'Bylakuppe','571104',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29036,92,'Chakkodanahalli','571114',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29037,92,'Chakkur','571125',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29038,92,'Chamundi Betta','570010',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29039,92,'Chamundi Extension','570004',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29040,92,'Chandagala','571602',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29041,92,'Channamgere','571617',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29042,92,'Chapparadahalli','571102',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29043,92,'Chikkabeechanahalli','571103',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29044,92,'Chikkadaganahalli','571610',1,0,'2022-03-03 12:33:37','2022-03-03 12:33:37'),(29045,92,'Chikkanayakanahalli','571604',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29046,92,'Chikkanerale','571102',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29047,92,'Chikkeriyur','571125',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29048,92,'Chilkunda','571105',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29049,92,'Chowthi','571107',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29050,92,'Chunchunakatte','571617',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29051,92,'Coimbatore Colony','571189',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29052,92,'Daddakallahalli','571130',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29053,92,'Danagalli','570008',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29054,92,'Devalapura','571311',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29055,92,'Dharmapura','571189',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29056,92,'Doddabylalu','571108',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29057,92,'Doddabyranakuppe','571114',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29058,92,'Doddahejjur','571106',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29059,92,'Doddakamaravalli','571187',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29060,92,'Doddakanya','571311',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29061,92,'Doddamaragowdanahalli','570026',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29062,92,'Doora','570008',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29063,92,'Dornahalli','571602',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29064,92,'Duddagere','570010',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29065,92,'G B Sargur','570026',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29066,92,'G S Ashram','570025',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29067,92,'Gagenahalli','571103',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29068,92,'Galigekere','571601',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29069,92,'Gandanahalli','571603',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29070,92,'Gavadagere','571610',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29071,92,'Gokulam','570002',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29072,92,'Gopalapura','570008',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29073,92,'Gorahalli','571102',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29074,92,'Gujjegowdanapura','570008',1,0,'2022-03-03 12:33:38','2022-03-03 12:33:38'),(29075,92,'Guluvina Attiguppe','571601',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29076,92,'Gurupura','571105',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29077,92,'Gurur','570008',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29078,92,'Hadajana','571311',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29079,92,'Hadanur','571121',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29080,92,'Hadya','571617',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29081,92,'Halaganahalli','571187',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29082,92,'Halebeedu','571103',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29083,92,'Haleyur','571617',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29084,92,'Hampapura (H D Kote)','571125',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29085,92,'Hampapura (K R Nagar)','571601',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29086,92,'Hanagodu','571106',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29087,92,'Hanasoge','571617',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29088,92,'Hanchipura','571121',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29089,92,'Haradanahalli','571604',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29090,92,'Haradur','571102',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29091,92,'Harave','571134',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29092,92,'Hareenahalli','571105',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29093,92,'Harohalli','570028',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29094,92,'Hebbal Layout','570016',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29095,92,'Hebbalaguppe','571114',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29096,92,'Hebbalu','571602',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29097,92,'Hebbathur','571107',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29098,92,'Heggadedevana Kote','571114',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29099,92,'Hirehalli','571114',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29100,92,'Hirekyathanahalli','571134',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29101,92,'Hitnehebbagilu','571107',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29102,92,'Honnapura','571187',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29103,92,'Honnenahalli','571604',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29104,92,'Honnenahalli','571106',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29105,92,'Hosa Agrahara','571601',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29106,92,'Hosaholalu','571114',1,0,'2022-03-03 12:33:39','2022-03-03 12:33:39'),(29107,92,'Hosakote','571617',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29108,92,'Hosur','571617',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29109,92,'Hosur Kallahalli','571602',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29110,92,'Hundimala','571189',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29111,92,'Hunsur','571105',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29112,92,'Hussainpura','571103',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29113,92,'Hyrige','571125',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29114,92,'Infosys Campus','570027',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29115,92,'Itna','571121',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29116,92,'Ittigegud','570010',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29117,92,'J.P.Nagar','570031',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29118,92,'Jakkahalli','571114',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29119,92,'Jampanahalli','571125',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29120,92,'Jaya Prakash Nagar','570008',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29121,92,'Jayalakshmipuram (Mysore)','570012',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29122,92,'Jayanagar (Mysore)','570014',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29123,92,'Jayapura','570008',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29124,92,'Kabini Colony','571116',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29125,92,'Kadakola','571311',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29126,92,'Kaggere','571602',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29127,92,'Kailasapura','571104',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29128,92,'Kalenahalli','571602',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29129,92,'Kallahalli','571105',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29130,92,'Kallur Naganahalli','571130',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29131,92,'Kamplapura','571107',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29132,92,'Kanagal','571187',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29133,92,'Kanchamalli','571125',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29134,92,'Kanchinakere','571601',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29135,92,'Kandegala','571107',1,0,'2022-03-03 12:33:40','2022-03-03 12:33:40'),(29136,92,'Karimuddanahalli','571189',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29137,92,'Karthalu','571617',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29138,92,'Kattemalalavadi','571134',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29139,92,'Keelanapura','570010',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29140,92,'Kelaganahalli','571108',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29141,92,'Kellur','571108',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29142,92,'Kergalli','570026',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29143,92,'Kestur(Hunsur)','571602',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29144,92,'Kittur','571617',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29145,92,'Kolagala','571125',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29146,92,'Kollegowdanahalli','571114',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29147,92,'Kolur','571617',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29148,92,'Komalapura','571102',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29149,92,'Konasur','571102',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29150,92,'Koorgalli','570018',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29151,92,'Koppa','571104',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29152,92,'Kothavalli','571102',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29153,92,'Kothegala','571121',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29154,92,'Kothegala','571134',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29155,92,'Kotige Yedathore','571114',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29156,92,'Krishna Raja Mohalla','570004',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29157,92,'Krishna Raja Nagar','571602',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29158,92,'Krishna Rajendra Circle','570001',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29159,92,'Krishnamurthypuram','570004',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29160,92,'Krishnapura','571602',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29161,92,'Kunthanabelathur','571125',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29162,92,'Kuppe','571617',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29163,92,'Kuvempunagar II Stage','570023',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29164,92,'Kuvempunagar (Mysore)','570023',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29165,92,'Kyathanahalli','570026',1,0,'2022-03-03 12:33:41','2022-03-03 12:33:41'),(29166,92,'Lakkikuppe','571604',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29167,92,'Lakshmipuram (Mysore)','570004',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29168,92,'Lalithadripura','570028',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29169,92,'M C Thalalu','571121',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29170,92,'Madapura','571125',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29171,92,'Maddur','571125',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29172,92,'Makodu','571108',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29173,92,'Malali','571116',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29174,92,'Malangi','571107',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29175,92,'Mallahalli','570026',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29176,92,'Manasagangothri','570006',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29177,92,'Mandakalli','571311',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29178,92,'Mandimohalla','570001',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29179,92,'Manuganahalli','571103',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29180,92,'Maradur','571105',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29181,92,'Marballi','570008',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29182,92,'Marchahalli','571602',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29183,92,'Martikyathanahalli','570026',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29184,92,'Matakere','571114',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29185,92,'Matakere','571121',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29186,92,'Mavathur','571602',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29187,92,'Melur','571604',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29188,92,'Melur','571102',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29189,92,'Metagalli','570016',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29190,92,'Metikuppe','571114',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29191,92,'Mirle','571603',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29192,92,'Modur','571134',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29193,92,'Moleyur','571121',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29194,92,'Mullur','571121',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29195,92,'Mullur','571610',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29196,92,'Mundur','571604',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29197,92,'Munjanahalli','571601',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29198,92,'Mutthur','571107',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29199,92,'Mydanahalli','571130',1,0,'2022-03-03 12:33:42','2022-03-03 12:33:42'),(29200,92,'Mysore Fort','570004',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29201,92,'Mysore H.O','570001',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29202,92,'Mysore Law Courts','570005',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29203,92,'Mysore South','570008',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29204,92,'Mysore University','570005',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29205,92,'N Begur','571116',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29206,92,'Naganahalli','571114',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29207,92,'Naganahalli','570003',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29208,92,'Nagawala','571130',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29209,92,'Nallurpala','571105',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29210,92,'Nandinathapura','571107',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29211,92,'Nanjipura','571121',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29212,92,'Narasimha Raja Mohalla','570007',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29213,92,'Natanahalli','571603',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29214,92,'Neralakuppe','571106',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29215,92,'Nerale','571116',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29216,92,'Nilavadi','571102',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29217,92,'Nisana Belathur','571114',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29218,92,'Note Mudran Nagar','570003',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29219,92,'Paduvakote','571189',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29220,92,'Panchavalli','571105',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29221,92,'Periyapatna','571107',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29222,92,'Poonadahalli','571107',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29223,92,'PTC Campus','570010',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29224,92,'Rajanabilugali','571187',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29225,92,'Ramakrishna Nagar (Mysore)','570022',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29226,92,'Ramanahalli','570019',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29227,92,'Ramapura','571604',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29228,92,'Rathnapuri Colony','571189',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29229,92,'Ravandur','571108',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29230,92,'Rayanakere','570008',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29231,92,'S Hemmanahalli','571130',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29232,92,'Sagare','571121',1,0,'2022-03-03 12:33:43','2022-03-03 12:33:43'),(29233,92,'Saligrama (Mysore)','571604',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29234,92,'Sangarasettihalli','571102',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29235,92,'Saraswathipuram H.O','570009',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29236,92,'Sargur','571121',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29237,92,'Shakthinagar','570029',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29238,92,'Shanuboganahalli','571103',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29239,92,'Shivaraathreeswar Nagar','570015',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29240,92,'Siddalingapura','570003',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29241,92,'Siddapura','571602',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29242,92,'Siddarthanagar Nagar','570011',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29243,92,'Sigavalu','571604',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29244,92,'Sindhuvalli','571311',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29245,92,'Singaramaranahalli','571189',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29246,92,'Somanahalli','571105',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29247,92,'Someshwarapura','571311',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29248,92,'Sri Rampura 2nd Stage','570023',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29249,92,'Srirampura','570008',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29250,92,'Taloor','571311',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29251,92,'Tattekere','571106',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29252,92,'Thammadahalli','571108',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29253,92,'Thandre','571604',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29254,92,'Thondalu','571610',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29255,92,'Thumbasoge','571121',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29256,92,'Tippur','571602',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29257,92,'Udayagiri (Mysore)','570019',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29258,92,'Udbur','570008',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29259,92,'Uddur','571105',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29260,92,'University Campus (Mysore)','570006',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29261,92,'Vajamangala','570028',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29262,92,'Vani Vilas Mohalla','570002',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29263,92,'Varakodu','570010',1,0,'2022-03-03 12:33:44','2022-03-03 12:33:44'),(29264,92,'Varuna','570010',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29265,92,'Vijayanagar III stage','570030',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29266,92,'Vijaynagar II Stage','570017',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29267,92,'Vijaynagar III Stage','570017',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29268,92,'Yadakola','570010',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29269,92,'Yadavagiri','570020',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29270,92,'Yelwal','571130',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29271,92,'Alaganchi','571119',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29272,92,'Aralikatte','571128',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29273,92,'Attahlli','571101',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29274,92,'Badanavalu','571312',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29275,92,'Banahalli','571124',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29276,92,'Bannahalli Hundi','571124',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29277,92,'Bannur','571101',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29278,92,'Bendravadi','571312',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29279,92,'Biligere','571129',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29280,92,'Bilugali','571129',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29281,92,'Binakanahalli','571110',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29282,92,'Bokkahalli','571302',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29283,92,'Byrapura','571124',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29284,92,'Chandrawadi','571314',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29285,92,'Chiduravalli','571120',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29286,92,'Chinnadagudihundi','571312',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29287,92,'Chunchanahalli','571119',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29288,92,'Danaikanapura','571124',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29289,92,'Debur','571314',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29290,92,'Devanur','571119',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29291,92,'Devarasanahalli','571118',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29292,92,'Devarayasettipura','571315',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29293,92,'Deveerammanahalli','571118',1,0,'2022-03-03 12:33:45','2022-03-03 12:33:45'),(29294,92,'Doddahebbagilu','571120',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29295,92,'Doddamulagodu','571101',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29296,92,'Ganaganur','571124',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29297,92,'Gargeshwari','571110',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29298,92,'Gattavadi','571312',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29299,92,'Gejjiganahalli','571129',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29300,92,'Hadinaru','571302',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29301,92,'Hadya','571315',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29302,92,'Hadya','571119',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29303,92,'Haginavalu','571315',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29304,92,'Halepura','571312',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29305,92,'Hallare','571315',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29306,92,'Hanumanalu','571101',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29307,92,'Haradanahalli','571314',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29308,92,'Hedathale','571312',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29309,92,'Hediyala','571315',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29310,92,'Heggadahalli','571314',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29311,92,'Heggur','571101',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29312,92,'Hemmaragala','571312',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29313,92,'Hemmige','571122',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29314,92,'Hiriyur','571124',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29315,92,'Horalahalli','571120',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29316,92,'Horalavadi','571129',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29317,92,'Hosa Alagodu','571124',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29318,92,'Hosakadajetty','571315',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29319,92,'Hullahalli','571314',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29320,92,'Hura (Mysore)','571315',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29321,92,'Hyakanur','571124',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29322,92,'K S Hundi','571302',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29323,92,'Kadabur','571314',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29324,92,'Kalale','571118',1,0,'2022-03-03 12:33:46','2022-03-03 12:33:46'),(29325,92,'Kalkunda','571129',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29326,92,'Kanahalli','571124',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29327,92,'Kanenur','571314',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29328,92,'Karuhatti','571124',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29329,92,'Karya','571119',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29330,92,'Kasuvinahalli','571118',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29331,92,'Katur','571314',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29332,92,'Kavalande','571312',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29333,92,'Kaveripura','571122',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29334,92,'Kempainahundi','571110',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29335,92,'Kethupura','571101',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29336,92,'Kiragasur','571124',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29337,92,'Kirugunda','571119',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29338,92,'Kodagahalli','571101',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29339,92,'Kolathur','571120',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29340,92,'Konanur','571312',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29341,92,'Kudlapura','571118',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29342,92,'Kugalur','571118',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29343,92,'Kukkur','571122',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29344,92,'Kupparavalli','571129',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29345,92,'Kupya','571110',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29346,92,'Kurahatti','571118',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29347,92,'Kurihundi','571314',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29348,92,'Kurubur','571124',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29349,92,'Madapura','571315',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29350,92,'Madigahalli','571101',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29351,92,'Maduvinahalli','571315',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29352,92,'Maliyur','571101',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29353,92,'Mallupura','571119',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29354,92,'Maralur','571302',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29355,92,'Mavinahallli','571122',1,0,'2022-03-03 12:33:47','2022-03-03 12:33:47'),(29356,92,'Muguru','571124',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29357,92,'Muthalavadi Kebbehundi','571110',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29358,92,'Naganapura','571315',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29359,92,'Nagarle','571129',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29360,92,'Nanjangud H.O','571301',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29361,92,'Navilur','571118',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29362,92,'Nerale','571312',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29363,92,'Nilasoge','571124',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29364,92,'Old Sosale','571120',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29365,92,'Rampura','571314',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29366,92,'Rangasamudra','571101',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29367,92,'S Hoskote','571129',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29368,92,'S K P Extension','571302',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29369,92,'Seehalli','571101',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29370,92,'Sinduvalli','571118',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29371,92,'Sirmalli','571314',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29372,92,'Somanathapura','571120',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29373,92,'Srikantapuri Extension','571301',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29374,92,'Suttur','571129',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29375,92,'T Bettahalli','571122',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29376,92,'T Narasipura','571124',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29377,92,'Tagadur','571119',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29378,92,'Talakad','571122',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29379,92,'Thandavapura','571302',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29380,92,'Thayur','571124',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29381,92,'Thumbala','571110',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29382,92,'Thumnerale','571129',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29383,92,'Turuganur','571101',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29384,92,'Ukkalagere','571120',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29385,92,'Valagere','571315',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29386,92,'Vatalu','571124',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29387,92,'Vidyapeetha','571312',1,0,'2022-03-03 12:33:48','2022-03-03 12:33:48'),(29388,92,'Vyasarajapura','571120',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29389,92,'Yachenahalli','571101',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29390,92,'Yechagalli','571302',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29391,93,'Alabanur','584128',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29392,93,'Aldhal','584123',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29393,93,'Alkod','584129',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29394,93,'Alkur','584140',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29395,93,'Amarapur','584128',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29396,93,'Amdhihal','584125',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29397,93,'Amingad','584120',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29398,93,'Anehosur','584122',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29399,93,'Ankasdoddi','584122',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29400,93,'Anwari','584120',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29401,93,'Arkera','584111',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29402,93,'Arlihalli','584128',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29403,93,'Aroli','584203',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29404,93,'Arshangi','584113',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29405,93,'Ashihal','584125',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29406,93,'Askihal','584104',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29407,93,'Athnur','584136',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29408,93,'Atkur','584102',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29409,93,'Badarli','584128',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29410,93,'Bagalwad','584120',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29411,93,'Balaganur','584138',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29412,93,'Ballutgi','584129',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29413,93,'Bannigol','584125',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29414,93,'Benchmardi','584122',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29415,93,'Bendarganekal','584116',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29416,93,'Bichal','584140',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29417,93,'Bommanahal','584113',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29418,93,'Budiwal Camp','584167',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29419,93,'Byagawat','584123',1,0,'2022-03-03 12:33:49','2022-03-03 12:33:49'),(29420,93,'C.S. Farm','584143',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29421,93,'Chandrabanda','584102',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29422,93,'Channahalli','584128',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29423,93,'Chickalparvi','584123',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29424,93,'Chickbudur','584126',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29425,93,'Chickhesarur','584120',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29426,93,'Chickkotnakal','584143',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29427,93,'Chicksugur','584134',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29428,93,'Chincharki','584115',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29429,93,'Chinchodi','584116',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29430,93,'Chitapur','584127',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29431,93,'Deodurga','584111',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29432,93,'Deosugur','584170',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29433,93,'Devarabhupur','584139',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29434,93,'Dhadesugur','584167',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29435,93,'Diddgi','584138',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29436,93,'Dinni','584104',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29437,93,'Dondambli','584111',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29438,93,'Dongarampur','584135',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29439,93,'Gabbur','584113',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29440,93,'Gajjalagatta','584115',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29441,93,'Galag','584116',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29442,93,'Ganadinni','584136',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29443,93,'Gandhal','584116',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29444,93,'Gandhal','584140',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29445,93,'Ganekal','584136',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29446,93,'Ganjahalli','584170',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29447,93,'Garaladinni','584203',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29448,93,'Ghanmur','584135',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29449,93,'Gillesugur','584140',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29450,93,'Gonhal','584134',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29451,93,'Gonwar','584143',1,0,'2022-03-03 12:33:50','2022-03-03 12:33:50'),(29452,93,'Gonwar','584122',1,0,'2022-03-03 12:33:51','2022-03-03 12:33:51'),(29453,93,'Gonwatla','584127',1,0,'2022-03-03 12:33:51','2022-03-03 12:33:51'),(29454,93,'Gopalpura','584111',1,0,'2022-03-03 12:33:51','2022-03-03 12:33:51'),(29455,93,'Gorebal','584127',1,0,'2022-03-03 12:33:51','2022-03-03 12:33:51'),(29456,93,'Gorebal','584128',1,0,'2022-03-03 12:33:51','2022-03-03 12:33:51'),(29457,93,'Gorkal','584203',1,0,'2022-03-03 12:33:51','2022-03-03 12:33:51'),(29458,93,'Gowdhan Bhavi','584138',1,0,'2022-03-03 12:33:51','2022-03-03 12:33:51'),(29459,93,'Gowdur','584139',1,0,'2022-03-03 12:33:51','2022-03-03 12:33:51'),(29460,93,'Gudadinni','584123',1,0,'2022-03-03 12:33:51','2022-03-03 12:33:51'),(29461,93,'Gudadur','584124',1,0,'2022-03-03 12:33:51','2022-03-03 12:33:51'),(29462,93,'Gudihal','584125',1,0,'2022-03-03 12:33:51','2022-03-03 12:33:51'),(29463,93,'Gunda','584132',1,0,'2022-03-03 12:33:51','2022-03-03 12:33:51'),(29464,93,'Gunjahalli','584132',1,0,'2022-03-03 12:33:51','2022-03-03 12:33:51'),(29465,93,'Gunjahalli','584140',1,0,'2022-03-03 12:33:51','2022-03-03 12:33:51'),(29466,93,'Gurgunta','584139',1,0,'2022-03-03 12:33:51','2022-03-03 12:33:51'),(29467,93,'Halapur','584120',1,0,'2022-03-03 12:33:51','2022-03-03 12:33:51'),(29468,93,'Halkawatgi','584127',1,0,'2022-03-03 12:33:51','2022-03-03 12:33:51'),(29469,93,'Hampanahal','584124',1,0,'2022-03-03 12:33:51','2022-03-03 12:33:51'),(29470,93,'Hanamapur','584202',1,0,'2022-03-03 12:33:51','2022-03-03 12:33:51'),(29471,93,'Hanchinal Camp','584128',1,0,'2022-03-03 12:33:51','2022-03-03 12:33:51'),(29472,93,'Harapur','584128',1,0,'2022-03-03 12:33:51','2022-03-03 12:33:51'),(29473,93,'Harvi','584123',1,0,'2022-03-03 12:33:51','2022-03-03 12:33:51'),(29474,93,'Hediginahal','584128',1,0,'2022-03-03 12:33:51','2022-03-03 12:33:51'),(29475,93,'Heera','584129',1,0,'2022-03-03 12:33:51','2022-03-03 12:33:51'),(29476,93,'Heggasanahalli','584134',1,0,'2022-03-03 12:33:51','2022-03-03 12:33:51'),(29477,93,'Hembarhal','584134',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29478,93,'Herundi','584116',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29479,93,'Hirapur','584202',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29480,93,'Hirebhergi','584132',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29481,93,'Hirebudur','584126',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29482,93,'Hirehanagi','584120',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29483,93,'Hirekottanakal','584123',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29484,93,'Hirelakkihal','584127',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29485,93,'Hirenaganur','584115',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29486,93,'Hireraikumpi','584113',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29487,93,'Hogarnal','584132',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29488,93,'Hokrani','584118',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29489,93,'Honnahalli','584115',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29490,93,'Hospet','584134',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29491,93,'Hosur','584143',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29492,93,'Hosur Siddapur','584116',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29493,93,'Huda','584167',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29494,93,'Hutti','584115',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29495,93,'Hutti Village','584115',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29496,93,'Huttigudda','584132',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29497,93,'Huvinbhavi','584122',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29498,93,'Idapanur','584140',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29499,93,'Itgi','584126',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29500,93,'Jadaladinni','584129',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29501,93,'Jagatkal','584126',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29502,93,'Jagir Venkatapur','584134',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29503,93,'Jakkarmadu','584125',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29504,93,'Jalahalli','584116',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29505,93,'Jalihal','584128',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29506,93,'Jalihal Camp','584128',1,0,'2022-03-03 12:33:52','2022-03-03 12:33:52'),(29507,93,'Jambaladinni','584129',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29508,93,'Janekal','584123',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29509,93,'Jawalgera','584143',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29510,93,'Jeerbandi','584111',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29511,93,'Jegarkal','584134',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29512,93,'Joldhadgi','584111',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29513,93,'Jookur','584202',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29514,93,'Julumgera','584133',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29515,93,'K. Mariammanahalli','584125',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29516,93,'Kadadinni','584129',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29517,93,'Kadlur','584170',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29518,93,'Kalapur','584122',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29519,93,'Kalasa Hosahalli','584132',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29520,93,'Kalli Lingasugur','584122',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29521,93,'Kallur (Raichur)','584118',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29522,93,'Kalmala','584136',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29523,93,'Kalmangi','584132',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29524,93,'Kamalapur','584133',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29525,93,'Kannal','584125',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29526,93,'Kansavi','584125',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29527,93,'Kapgal','584118',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29528,93,'Karadkal','584122',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29529,93,'Kardigudda','584123',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29530,93,'Karigudda','584111',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29531,93,'Kasba Lingasugur','584122',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29532,93,'Katlatkur','584102',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29533,93,'Kelagina Irabgera','584111',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29534,93,'Kengal','584167',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29535,93,'Khairwadgi','584125',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29536,93,'Khanapur','584113',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29537,93,'Kharabdinni','584143',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29538,93,'Kolbal','584128',1,0,'2022-03-03 12:33:53','2022-03-03 12:33:53'),(29539,93,'Konapur Pet','584123',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29540,93,'Konchapli','584111',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29541,93,'Kopparu','584111',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29542,93,'Korthakunda','584135',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29543,93,'Korvi','584123',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29544,93,'Kota','584139',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29545,93,'Kothadoddi','584111',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29546,93,'Kowthal','584120',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29547,93,'Kudlur','584135',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29548,93,'Kurdi','584203',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29549,93,'Kurkunda','584128',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29550,93,'Kurkundi','584129',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29551,93,'Kuruvapur','584102',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29552,93,'Kyadigera','584129',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29553,93,'Lakkamdinni','584129',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29554,93,'Lingankhan Doddi','584133',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29555,93,'Lingasugur Katchery','584122',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29556,93,'Lingasugur','584122',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29557,93,'Machanur','584118',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29558,93,'Madarkal','584113',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29559,93,'Madigera','584129',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29560,93,'Madlapur','584123',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29561,93,'Madsirwar','584128',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29562,93,'Makapur','584125',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29563,93,'Maladakal','584113',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29564,93,'Maliabad','584103',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29565,93,'Malladagudda','584123',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29566,93,'Mallapur','584128',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29567,93,'Mallat','584129',1,0,'2022-03-03 12:33:54','2022-03-03 12:33:54'),(29568,93,'Manjerla','584133',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29569,93,'Manslapur','584134',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29570,93,'Manvi','584123',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29571,93,'Maraladinni','584122',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29572,93,'Markam Dinni','584120',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29573,93,'Maski','584124',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29574,93,'Matmari','584202',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29575,93,'Mattur','584125',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29576,93,'Mavinabhavi','584122',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29577,93,'Medikinhal','584124',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29578,93,'Medinapur','584115',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29579,93,'Merchad','584134',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29580,93,'Merchthal','584104',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29581,93,'Mirzapur','584140',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29582,93,'Mitti Malkapur','584103',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29583,93,'Mosarkal','584126',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29584,93,'Mudgal','584125',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29585,93,'Mukkunda','584167',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29586,93,'Mundargi','584116',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29587,93,'Murhanpur','584136',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29588,93,'Mustoor','584123',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29589,93,'Mustoor','584126',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29590,93,'Nagadadinni','584129',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29591,93,'Nagalapur','584125',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29592,93,'Nagarabenchi','584124',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29593,93,'Nagarahal','584127',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29594,93,'Nagoli','584111',1,0,'2022-03-03 12:33:55','2022-03-03 12:33:55'),(29595,93,'Nakkunda','584123',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29596,93,'Nanjaladinni','584124',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29597,93,'Nawalkal','584129',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29598,93,'Nawli','584127',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29599,93,'Neeralkera','584122',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29600,93,'Neermanvi','584118',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29601,93,'Nelhal','584104',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29602,93,'Nilogal','584136',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29603,93,'Pagadadinni','584128',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29604,93,'Pamankallur','584120',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29605,93,'Potnal','584143',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29606,93,'Puchaldinni','584133',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29607,93,'Purtipli','584202',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29608,93,'R.H. Colony','584143',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29609,93,'Rabbanakal','584123',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29610,93,'Ragalparvi','584143',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29611,93,'Raichur H.O','584101',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29612,93,'Raichur Jawahar Nagar','584103',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29613,93,'Raichur Mukram Gunj','584102',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29614,93,'Raichur Naya Bazar','584101',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29615,93,'Raichur Nijalingappa Nagar','584101',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29616,93,'Raichur Patel Road','584103',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29617,93,'Raichur R.S.','584101',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29618,93,'Raichur Saath Katchery','584101',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29619,93,'Raichur UAS','584104',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29620,93,'Rajalbanda','584203',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29621,93,'Rajoli','584202',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29622,93,'Ramatnal','584143',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29623,93,'Ramdurga','584113',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29624,93,'Rampur','584104',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29625,93,'Rodalabanda','584115',1,0,'2022-03-03 12:33:56','2022-03-03 12:33:56'),(29626,93,'Rodalbanda','584127',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29627,93,'Roudkunda','584128',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29628,93,'Sagamkunta','584135',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29629,93,'Sajjalagudda','584127',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29630,93,'Salgunda','584167',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29631,93,'Santekallur','584122',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29632,93,'Sarjapur','584122',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29633,93,'Sasalmari Camp','584128',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29634,93,'Shaktinagar (Raichur)','584170',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29635,93,'Shavantagera','584113',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29636,93,'Shivangi','584126',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29637,93,'Sidrampur','584128',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29638,93,'Sindhanur Camp','584128',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29639,93,'Sindhanur','584128',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29640,93,'Singanodi','584102',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29641,93,'Singapur','584167',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29642,93,'Sirwar','584129',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29643,93,'Somalapur','584128',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29644,93,'Sultanpur','584113',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29645,93,'Sunkeshwar','584203',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29646,93,'Sunkeshwarhal','584126',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29647,93,'Sunnadakal','584116',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29648,93,'Tadakal','584138',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29649,93,'Talekhan','584124',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29650,93,'Talmari','584140',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29651,93,'Tidigol','584128',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29652,93,'Toranadinni','584120',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29653,93,'Turkondana','584202',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29654,93,'Turvihal','584132',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29655,93,'Udamgal','584133',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29656,93,'Udbal','584138',1,0,'2022-03-03 12:33:57','2022-03-03 12:33:57'),(29657,93,'Umloti','584132',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29658,93,'Uppal','584167',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29659,93,'Uppaldoddi','584128',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29660,93,'Upparhal','584140',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29661,93,'Upparnandihal','584125',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29662,93,'Valaballary','584128',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29663,93,'Vandli','584115',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29664,93,'Virupapur','584128',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29665,93,'Waddepalli','584135',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29666,93,'Watgal','584120',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29667,93,'Yadlapur','584170',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29668,93,'Yapaladinni','584102',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29669,93,'Yapalparvi','584143',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29670,93,'Yeachnal','584122',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29671,93,'Yeddaldoddi','584128',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29672,93,'Yeganur','584134',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29673,93,'Yelagatta','584139',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29674,93,'Yeramarus Camp','584135',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29675,93,'Yeramarus','584134',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29676,93,'Yerdona','584115',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29677,93,'Yergera','584133',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29678,94,'Abbur','562108',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29679,94,'Achalu','562117',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29680,94,'Agalakote','562120',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29681,94,'Akkur','562159',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29682,94,'Akkur','562138',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29683,94,'Alahalli','562117',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29684,94,'Alanatha','562119',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29685,94,'Ambadahalli','562138',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29686,94,'Anjanapura','562159',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29687,94,'Ankanahalli','562159',1,0,'2022-03-03 12:33:58','2022-03-03 12:33:58'),(29688,94,'Aralalasandra','562138',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29689,94,'Attihalli','562126',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29690,94,'Attikuppe','562112',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29691,94,'Attimagere','561201',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29692,94,'Averahalli','562159',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29693,94,'Bachenahatti','562120',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29694,94,'Banavasi','562121',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29695,94,'Bannikuppe','562159',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29696,94,'Bannimakodalu','562119',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29697,94,'Bevur (Ramanagar)','562108',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29698,94,'Bevurmandya','562108',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29699,94,'Bidadi','562109',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29700,94,'Bijjahalli','562119',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29701,94,'Bilagumba','562120',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29702,94,'Bilagumba','562159',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29703,94,'Byramangala','562109',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29704,94,'Chakarabhavi','562120',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29705,94,'Chakkalur','562160',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29706,94,'Chakkere','562160',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29707,94,'Channapatna Bazar','562160',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29708,94,'Channapatna H.O','562160',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29709,94,'Cheelur','562112',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29710,94,'Chikkalahalli','562126',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29711,94,'Chikkamuduvadi','562117',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29712,94,'Doddagangawadi','562159',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29713,94,'Doddakabballi','562119',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29714,94,'Ganakal','562109',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29715,94,'Ganalu','562117',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29716,94,'Garakahalli','562138',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29717,94,'GCEC Ramanagara','562159',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29718,94,'Gejjagaragupppe','562120',1,0,'2022-03-03 12:33:59','2022-03-03 12:33:59'),(29719,94,'Girenahalli','562112',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29720,94,'Gollahalli','562119',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29721,94,'Gottigehalli','562112',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29722,94,'Government Silk Farm','562161',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29723,94,'Gowdagere','562108',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29724,94,'Guttalahunase','562121',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29725,94,'H.Kothanuru','562117',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29726,94,'Hagalahalli','562128',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29727,94,'Hanchaguli','562119',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29728,94,'Harathi','562120',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29729,94,'Harisandra','562128',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29730,94,'Harobele','562126',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29731,94,'Harohalli','562112',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29732,94,'Hejjala','562109',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29733,94,'Helagahalli','562117',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29734,94,'Herandyappanahalli','562119',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29735,94,'Honganur','562138',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29736,94,'Honnayakanahalli','562108',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29737,94,'Honniganahalli','562126',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29738,94,'Horalagallu','562117',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29739,94,'Hosadurga','562119',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29740,94,'Hosur','562109',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29741,94,'Hunasanahalli','562119',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29742,94,'Hunkunda','562119',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29743,94,'Iggalur','562138',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29744,94,'Ijoor Ramangaram','562159',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29745,94,'Ittmadu','562109',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29746,94,'Jagadapura','562138',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29747,94,'Jakkasandra','562112',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29748,94,'Jalamangala','562159',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29749,94,'K.Karenahalli','562109',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29750,94,'Kabbal','562126',1,0,'2022-03-03 12:34:00','2022-03-03 12:34:00'),(29751,94,'Kadahalli','562126',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29752,94,'Kaggala Halli','562112',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29753,94,'Kailancha','562159',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29754,94,'Kalari','562120',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29755,94,'Kallahalli','562117',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29756,94,'Kallanakupppe','562121',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29757,94,'Kalludevanahalli','562120',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29758,94,'Kalya','562120',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29759,94,'Kanakapura Bazar','562117',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29760,94,'Kanakapura','562117',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29761,94,'Kanchugaranahalli','562109',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29762,94,'Kanva','562108',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29763,94,'Karikaldoddi','562112',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29764,94,'Karlamangala','561201',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29765,94,'Kempasagara','562120',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29766,94,'Kodamballi','562138',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29767,94,'Kodihalli','562119',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29768,94,'Kolagondanahalli','562119',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29769,94,'Kolliganahalli','562112',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29770,94,'Kottagalu','562117',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29771,94,'Krishnapuradoddi','562159',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29772,94,'Kudlur','562160',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29773,94,'Kurupet','562117',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29774,94,'Kutgal','562159',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29775,94,'Kyasapura','562108',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29776,94,'Lakkojanahalli','562159',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29777,94,'Lakshmipura','561201',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29778,94,'Lalaghatta','562160',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29779,94,'Madabal','561201',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29780,94,'Magadi','562120',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29781,94,'Makali','562108',1,0,'2022-03-03 12:34:01','2022-03-03 12:34:01'),(29782,94,'Malgal','562117',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29783,94,'Mallligemetlu','562121',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29784,94,'Malur','562160',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29785,94,'Manchanabele','562128',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29786,94,'Manchanayakanahalli','562109',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29787,94,'Manchegowdanapalya','562109',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29788,94,'Mankunda','562108',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29789,94,'Maralavadi','562121',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29790,94,'Marale','562117',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29791,94,'Marchanhalli','562160',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29792,94,'Marlebekuppe','562117',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29793,94,'Mathikere','562120',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29794,94,'Mayaganahalli','562128',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29795,94,'Medamaranahalli','562112',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29796,94,'Mogenahalli','562108',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29797,94,'Mudugere','562160',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29798,94,'Mylanayakanhalli','562160',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29799,94,'Nagavara','562108',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29800,94,'Narayanapura','562117',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29801,94,'Neralur','562138',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29802,94,'Ramanagaram','562159',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29803,94,'Rampura','562160',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29804,94,'Sathanur','562120',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29805,94,'Sathanur','562126',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29806,94,'Shanumangala','562109',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29807,94,'Shettihalli','562160',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29808,94,'Shivanahalli','562117',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29809,94,'Singarajipura','562138',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29810,94,'Sogala','562138',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29811,94,'Sugganahalli','562128',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29812,94,'Sulleri','562160',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29813,94,'T.Hosahalli','562112',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29814,94,'Tagachagere','562160',1,0,'2022-03-03 12:34:02','2022-03-03 12:34:02'),(29815,94,'Tattekere','562112',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29816,94,'Terubeedi','562121',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29817,94,'Thaggikuppe','562120',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29818,94,'Thimmasandra','561201',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29819,94,'Torebekuppe','562117',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29820,94,'Tungani','562117',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29821,94,'Uragapura','562109',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29822,94,'Veeregowdanadoddi','561201',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29823,94,'Venkatarayanadoddi','562117',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29824,94,'Virupakshipura','562138',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29825,94,'Yadamaranahalli','562117',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29826,94,'Yeletotadahalli','562138',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29827,94,'Yerehalli','562159',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29828,95,'Abbalagere','577204',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29829,95,'Achapura','577412',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29830,95,'Agaradahalli','577227',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29831,95,'Agasanahalli','577413',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29832,95,'Agraharamuchadi','577428',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29833,95,'Agumbe','577411',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29834,95,'Amatekoppa','577427',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29835,95,'Ambaragodlu','577453',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29836,95,'Ambaragoppa','577427',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29837,95,'Ambligola','577214',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29838,95,'Anandapuram (Shimoga)','577412',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29839,95,'Anavatti','577413',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29840,95,'Anaveri','577243',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29841,95,'Anjanapura','577214',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29842,95,'Antharagange','577245',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29843,95,'APMC Yard Shikaripura Town','577427',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29844,95,'Arabilichi','577233',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29845,95,'Arakere','577233',1,0,'2022-03-03 12:34:03','2022-03-03 12:34:03'),(29846,95,'Aralagodu','577421',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29847,95,'Aralapura','577414',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29848,95,'Aralasurali','577414',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29849,95,'Aralihalli','577233',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29850,95,'Arasalu','577426',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29851,95,'Arasinagere','577214',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29852,95,'Arga','577414',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29853,95,'Arhatolalu','577243',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29854,95,'Avinahalli','577453',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29855,95,'Ayanur','577211',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29856,95,'B.Beeranahalli','577227',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29857,95,'B.Dodderi','577434',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29858,95,'Baganakatte','577427',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29859,95,'Balekoppa','577423',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29860,95,'Bandigudda','577301',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29861,95,'Barandur','577245',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29862,95,'Barur','577431',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29863,95,'Basavani','577432',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29864,95,'Begur(Shikaripur)','577427',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29865,95,'Beguvalli','577226',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29866,95,'Bejjavalli','577232',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29867,95,'Belagavi','577428',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29868,95,'Bellur(Hosanagar)','577426',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29869,95,'Belur(Sagar)','577401',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29870,95,'Bennur','577429',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29871,95,'Bhadra Colony','577301',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29872,95,'Bhadra Reservoir Project','577115',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29873,95,'Bhadrapura','577427',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29874,95,'Bhadravathi Hudco Colony','577301',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29875,95,'Bhadravathi Jannapura','577301',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29876,95,'Bhadravathi New Model Colony','577301',1,0,'2022-03-03 12:34:04','2022-03-03 12:34:04'),(29877,95,'Bhadravathi Old Town','577301',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29878,95,'Bhadravathi Paper Town','577302',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29879,95,'Bhadravathi Railway Stn','577301',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29880,95,'Bhadravati H.O','577301',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29881,95,'Bhanukuli','577421',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29882,95,'Bharangi','577413',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29883,95,'Bharathipura','577432',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29884,95,'Bheemanakere','577418',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29885,95,'Bheemanakone','577417',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29886,95,'Bidare','577222',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29887,95,'Bidarehalli','577436',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29888,95,'Bilavani','577428',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29889,95,'Biliki','577428',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29890,95,'Brahmanakappige','577453',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29891,95,'Brahmanamanchale','577431',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29892,95,'Bullapura','577216',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29893,95,'Byacodu','577453',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29894,95,'Byranakoppa','577416',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29895,95,'Chadaravalli','577453',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29896,95,'Chakkodabylu','577432',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29897,95,'Chandragutti','577429',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29898,95,'Chikjambur','577428',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29899,95,'Chikjogihalli','577214',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29900,95,'Chordi','577423',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29901,95,'Churchugundi','577214',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29902,95,'Dasarakallahalli','577227',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29903,95,'Demlapura','577422',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29904,95,'Devangi','577415',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29905,95,'Devarahalli','577301',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29906,95,'Doddagoppenahalli','577302',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29907,95,'Donabaghatta','577229',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29908,95,'Dooravasapura','577432',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29909,95,'Dyavanahalli','577419',1,0,'2022-03-03 12:34:05','2022-03-03 12:34:05'),(29910,95,'Gajanur','577202',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29911,95,'Gama','577214',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29912,95,'Gandinagar-sagar','577401',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29913,95,'Gangur','577301',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29914,95,'Garaga','577213',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29915,95,'Genasinakuni','577453',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29916,95,'Gendla','577419',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29917,95,'Gilalagundi','577412',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29918,95,'Gonibeedu','577115',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29919,95,'Gopala Extension','577205',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29920,95,'Gouthmapura','577412',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29921,95,'Gudavi','577429',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29922,95,'Guddekere','577411',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29923,95,'Guddekoppa','577414',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29924,95,'Gulladahalli','577427',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29925,95,'Guthi Yedehalli','577226',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29926,95,'Hadigallu','577422',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29927,95,'Hadonahalli','577216',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29928,95,'Haihole','577202',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29929,95,'Halaga','577220',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29930,95,'Halagalale','577429',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29931,95,'Halesorab','577429',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29932,95,'Halugadde','577426',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29933,95,'Hamsagaru','577401',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29934,95,'Hanagere','577226',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29935,95,'Haniya','577418',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29936,95,'Hansawadi','577216',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29937,95,'Haramaghatta','577216',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29938,95,'Harathalu','577412',1,0,'2022-03-03 12:34:06','2022-03-03 12:34:06'),(29939,95,'Haridravathi','577412',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29940,95,'Harige','577433',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29941,95,'Harishi','577429',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29942,95,'Harnahalli','577416',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29943,95,'Harogoppa','577214',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29944,95,'Harogulige','577415',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29945,95,'Harohithlu','577426',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29946,95,'Hebbarige','577417',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29947,95,'Hebbige','577452',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29948,95,'Heche','577429',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29949,95,'Heddaripura','577436',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29950,95,'Heddur','577415',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29951,95,'Heggodu','577432',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29952,95,'Hirejambur','577428',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29953,95,'Hirekasavi','577428',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29954,95,'Hiremane','577430',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29955,95,'Hirenallur','577401',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29956,95,'Hiriyur','577302',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29957,95,'Hithla','577214',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29958,95,'Holalur','577216',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29959,95,'Holebenavalli','577222',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29960,95,'Holehonner','577227',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29961,95,'Honnesara','577417',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29962,95,'Hosa Agrahara','577415',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29963,95,'Hosabale','577434',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29964,95,'Hosagadde','577411',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29965,95,'Hosagodnakoppa','577427',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29966,95,'Hosahalli','577202',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29967,95,'Hosanagar','577418',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29968,95,'Hosudi','577222',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29969,95,'Hosur(Shikaaripur)','577427',1,0,'2022-03-03 12:34:07','2022-03-03 12:34:07'),(29970,95,'Hosur-anandapuram','577412',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29971,95,'Hulidevarabana','577453',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29972,95,'Hulikal','577448',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29973,95,'Humcha','577436',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29974,95,'Humchadakatte','577436',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29975,95,'Hunasakatte Junction','577115',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29976,95,'Huruli','577413',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29977,95,'Huruli','577424',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29978,95,'Iduvani','577421',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29979,95,'Issur','577214',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29980,95,'J.P.S.Colony','577302',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29981,95,'Jade','577419',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29982,95,'Jakkinakoppa','577427',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29983,95,'Jayanagar Nd','577201',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29984,95,'Jog Falls','577435',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29985,95,'Jog Falls View','577435',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29986,95,'K.B.Circle','577452',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29987,95,'Kachinakatte','577222',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29988,95,'Kadasur','577436',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29989,95,'Kadathur','577432',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29990,95,'Kadekal','577203',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29991,95,'Kadenandihalli','577428',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29992,95,'Kagenahalli','577427',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29993,95,'Kagodu','577401',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29994,95,'Kallihal','577233',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29995,95,'Kalmane','577214',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29996,95,'Kalmane(Sagar)','577401',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29997,95,'Kambadahal Hosur','577115',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29998,95,'Kammachi','577436',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(29999,95,'Kanle','577430',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(30000,95,'Kannangi','577226',1,0,'2022-03-03 12:34:08','2022-03-03 12:34:08'),(30001,95,'Kappanahalli','577427',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30002,95,'Kargal Colony','577421',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30003,95,'Karunapura','577424',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30004,95,'Kattehakklu','577415',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30005,95,'Kawalgundi','577229',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30006,95,'Kawrihaklu','577411',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30007,95,'Keladi','577401',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30008,95,'Kenchanala','577426',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30009,95,'Kendalbailu','577411',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30010,95,'Kerehalli','577419',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30011,95,'Keshavapura','577422',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30012,95,'Khandika','577401',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30013,95,'Kittadahalli','577427',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30014,95,'Kodakani','577429',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30015,95,'Koduru','577418',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30016,95,'Kogar','577421',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30017,95,'Kolagi','577433',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30018,95,'Kommanahalu','577225',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30019,95,'Konandur','577422',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30020,95,'Kongavalli','577416',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30021,95,'Kortikere','577428',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30022,95,'Kote Gangur','577204',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30023,95,'Kotethariga','577418',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30024,95,'Krishnarajendrapete-shimoga','577202',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30025,95,'Kubatur','577413',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30026,95,'Kudli','577227',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30027,95,'Kudligere','577233',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30028,95,'Kudumallige','577232',1,0,'2022-03-03 12:34:09','2022-03-03 12:34:09'),(30029,95,'Kuduvalli','577226',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30030,95,'Kugve','577401',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30031,95,'Kukke','577232',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30032,95,'Kumsi','577423',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30033,95,'Kunchenahalli','577225',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30034,95,'Kuppagadde','577429',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30035,95,'Kuruvalli Ndt','577432',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30036,95,'Kuskur','577428',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30037,95,'KVV Shankaraghattta','577451',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30038,95,'Linganamakki','577421',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30039,95,'Madakechilur','577216',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30040,95,'Madasurlingadahalli','577434',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30041,95,'Mahishi','577232',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30042,95,'Makkimane','577415',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30043,95,'Malalagadde','577434',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30044,95,'Malali','577425',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30045,95,'Malalur','577432',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30046,95,'Malavagoppa','577222',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30047,95,'Mallapura(Sorab)','577413',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30048,95,'Mallenahalli','577428',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30049,95,'Malur','577232',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30050,95,'Malur','577433',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30051,95,'Maluru','577453',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30052,95,'Malve','577401',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30053,95,'Manchikoppa','577428',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30054,95,'Mandagadde','577220',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30055,95,'Mandaghatta','577211',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30056,95,'Mandli','577202',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30057,95,'Marathur','577430',1,0,'2022-03-03 12:34:10','2022-03-03 12:34:10'),(30058,95,'Maravalli','577427',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30059,95,'Marketyard APMC-Shimoga','577204',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30060,95,'Maruthipura','577412',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30061,95,'Masthikatte','577448',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30062,95,'Masur(Sagar)','577401',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30063,95,'Mathikai','577452',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30064,95,'Mathimane','577425',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30065,95,'Mathur','577203',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30066,95,'Mattikote','577427',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30067,95,'Mavali','577429',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30068,95,'Mavinakere','577245',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30069,95,'Megaravalli','577424',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30070,95,'Melige','577415',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30071,95,'Melinabesige','577418',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30072,95,'Melinasampalli','577412',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30073,95,'Moody','577413',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30074,95,'Muguru','577413',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30075,95,'Mumbar','577418',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30076,95,'Muniyur','577436',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30077,95,'Mutugoppe','577434',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30078,95,'Mydolalau','577243',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30079,95,'Nagarakodige','577418',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30080,95,'Nagara-shimoga','577425',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30081,95,'Nagavalli','577421',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30082,95,'Nagodi','577452',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30083,95,'Nalur','577424',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30084,95,'Nanditale','577412',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30085,95,'Narasapura','577428',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30086,95,'Navile','577204',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30087,95,'Neechadi','577431',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30088,95,'Nelavagilu','577427',1,0,'2022-03-03 12:34:11','2022-03-03 12:34:11'),(30089,95,'New Hutha Ndt','577302',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30090,95,'Nidige','577222',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30091,95,'Nilskal','577425',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30092,95,'Nisrani','577434',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30093,95,'Nittur (Shimoga)','577452',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30094,95,'Nonabur','577414',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30095,95,'Padavagodu','577434',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30096,95,'Pillanagere','577227',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30097,95,'Purappemane','577417',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30098,95,'Purudal','577205',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30099,95,'Ramakrishnapura','577432',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30100,95,'Ravindranagr-shimoga','577201',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30101,95,'Ripponpet','577426',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30102,95,'Ryave','577425',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30103,95,'Sagar Bazar','577401',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30104,95,'Sagar H.O','577401',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30105,95,'Sagar Market Road','577401',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30106,95,'Sakunavalli','577419',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30107,95,'Salur','577214',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30108,95,'Salur(Thirthahalli)','577414',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30109,95,'Samanavalli','577413',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30110,95,'Sanda','577428',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30111,95,'Sankadahole','577432',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30112,95,'Santhekadur','577222',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30113,95,'Sanyasikodamaggi','577243',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30114,95,'Saru','577422',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30115,95,'Sasaravalli','577401',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30116,95,'Seebinakere','577432',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30117,95,'Settihalli','577227',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30118,95,'Shedgaru','577415',1,0,'2022-03-03 12:34:12','2022-03-03 12:34:12'),(30119,95,'Shigga','577434',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30120,95,'Shikaripur','577427',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30121,95,'Shimoga Ambedkarnagar','577201',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30122,95,'Shimoga District Office','577201',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30123,95,'Shimoga Doddapete','577202',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30124,95,'Shimoga H.O','577201',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30125,95,'Shimoga Kote','577202',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30126,95,'Shimoga Market','577202',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30127,95,'Shimoga Railway Station','577201',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30128,95,'Shiralakoppa','577428',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30129,95,'Shiravanthe','577401',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30130,95,'Siddapura','577301',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30131,95,'Sidlipura','577227',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30132,95,'Sindhuvadi','577220',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30133,95,'Singanabidre','577220',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30134,95,'Sirigere','577211',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30135,95,'Siriyur','577229',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30136,95,'Sirur','577424',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30137,95,'Sogane','577222',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30138,95,'Sonale','577418',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30139,95,'Sorab','577429',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30140,95,'Suguru','577216',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30141,95,'Sullali','577453',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30142,95,'Sunnadahalli','577245',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30143,95,'Sunnadakoppa','577428',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30144,95,'Suntikoppa','577401',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30145,95,'Suragihalli','577427',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30146,95,'Sydarakallahalli','577243',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30147,95,'Syduru','577430',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30148,95,'Tadagalale','577430',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30149,95,'Tadasanahalli','577428',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30150,95,'Talagadde','577419',1,0,'2022-03-03 12:34:13','2022-03-03 12:34:13'),(30151,95,'Talagunda','577428',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30152,95,'Talaguppa','577430',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30153,95,'Talale','577426',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30154,95,'Talavata','577421',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30155,95,'Tallur','577413',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30156,95,'Tattur','577433',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30157,95,'Tavanandi','577429',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30158,95,'Telagunda','577419',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30159,95,'Thagarthi','577431',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30160,95,'Thallikatte','577227',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30161,95,'Thenginakoppa','577414',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30162,95,'Thirthahalli','577432',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30163,95,'Thirthahalli Town','577432',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30164,95,'Thirthamathur','577415',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30165,95,'Thuppur','577423',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30166,95,'Togarsi','577433',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30167,95,'Tudur','577226',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30168,95,'Tumary','577453',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30169,95,'Udri','577433',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30170,95,'Udugani','577428',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30171,95,'Ulavi','577434',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30172,95,'Ullur','577412',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30173,95,'Umblebylu','577115',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30174,95,'Untoorkatte','577432',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30175,95,'Urgadur','577203',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30176,95,'Varadamoola','577417',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30177,95,'Veerannana   Benavalli','577211',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30178,95,'Vidyanagar Shimoga','577203',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30179,95,'Vinobanagar Shimoga','577204',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30180,95,'Yedehalli','577227',1,0,'2022-03-03 12:34:14','2022-03-03 12:34:14'),(30181,95,'Yedjigalamane','577401',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30182,95,'Yedur','577448',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30183,95,'Yelagere','577433',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30184,95,'Yennekoppa','577413',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30185,96,'A.Venkatapura','572129',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30186,96,'Adagur','572216',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30187,96,'Adalagere','572223',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30188,96,'Agrahara','572129',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30189,96,'Ajjenahalli','572220',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30190,96,'Alalaghatta','572222',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30191,96,'Albur','572224',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30192,96,'Ammanaghatta','572216',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30193,96,'Ammasandra','572211',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30194,96,'Amruthur','572111',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30195,96,'Anekere','572212',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30196,96,'Ankalakoppa','572213',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30197,96,'Ankasandra','572117',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30198,96,'Anupanahalli','572140',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30199,96,'Arakere','572106',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30200,96,'Arakere','572130',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30201,96,'Aralaguppe','572212',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30202,96,'Aralikere','572227',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30203,96,'Arasapura','572121',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30204,96,'Arasikere','572116',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30205,96,'Aregujjanahalli','572140',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30206,96,'Aremallenahalli','572224',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30207,96,'Ariyur','572118',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30208,96,'Attikatte','572225',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30209,96,'B.K.Hally','572136',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30210,96,'Badakanahalli','572175',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30211,96,'Badamaranahalli','572113',1,0,'2022-03-03 12:34:15','2022-03-03 12:34:15'),(30212,96,'Badavanahalli','572112',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30213,96,'Bajagur','572224',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30214,96,'Baluvaneralu','572217',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30215,96,'Banasandra','572212',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30216,96,'Bandakunte','572137',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30217,96,'Bandihalli','572223',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30218,96,'Bandihalli','572123',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30219,96,'Baragihally','572119',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30220,96,'Baragur','572119',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30221,96,'Baragur','572113',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30222,96,'Barakanalu','572228',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30223,96,'Barasidlahalli','572214',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30224,96,'Bedathur','572133',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30225,96,'Beechanahalli','572215',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30226,96,'Beerasandra','572114',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30227,96,'Begur','572130',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30228,96,'Beladhara','572106',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30229,96,'Belagarahali','572201',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30230,96,'Belaguli','572228',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30231,96,'Belagumba','572104',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30232,96,'Belavatha','572219',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30233,96,'Bellara','572218',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30234,96,'Bellavi','572107',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30235,96,'Benakanakere','572227',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30236,96,'Bettadahalli','572222',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30237,96,'Bettahalli','572111',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30238,96,'Bettahallimutt','572126',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30239,96,'Bevinahalli','572135',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30240,96,'Bhaktharahalli','572120',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30241,96,'Bhoopasandra','572125',1,0,'2022-03-03 12:34:16','2022-03-03 12:34:16'),(30242,96,'Bhyranayakanahalli','572201',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30243,96,'Bidanagere','572130',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30244,96,'Bidare','572117',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30245,96,'Bijavara','572132',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30246,96,'Bilidevalaya','572130',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30247,96,'Biligere','572114',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30248,96,'Bittagondanahalli','572220',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30249,96,'Bommaladevipura','572121',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30250,96,'Bommathanahally','561202',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30251,96,'Brahamasandra','572125',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30252,96,'Brahmasamudra','572124',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30253,96,'Brahmasandra','572128',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30254,96,'Budibetta','561202',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30255,96,'Bugudanahalli','572107',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30256,96,'Bukkapatna','572129',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30257,96,'Bukkapatna','572115',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30258,96,'Byadagere','572219',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30259,96,'Byalya','572175',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30260,96,'Byatha','572140',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30261,96,'Bydanur','561202',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30262,96,'C. Nandihalli','572117',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30263,96,'C.Kodigenahalli','572213',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30264,96,'Chandragiri','572112',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30265,96,'Chandrashekarapura','572213',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30266,96,'Channakeshavapura','572116',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30267,96,'Channanakunte','572137',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30268,96,'Channenahalli','572107',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30269,96,'Chelur (Tumkur)','572117',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30270,96,'Chengavara','572135',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30271,96,'Chengavi','572213',1,0,'2022-03-03 12:34:17','2022-03-03 12:34:17'),(30272,96,'Chikkabanagere','572113',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30273,96,'Chikkabidare','572228',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30274,96,'Chikkadalavatta','572127',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30275,96,'Chikkahalli','572141',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30276,96,'Chikkamalur','572175',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30277,96,'Chikkanahalli','572121',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30278,96,'Chikkanahalli','572125',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30279,96,'Chikkanayakana Halli','572214',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30280,96,'Chikkasarangi','572118',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30281,96,'Chikkatottalakere','572128',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30282,96,'Chikkonahally','572216',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30283,96,'Chinakavajra','572132',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30284,96,'Chinnenahally','572133',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30285,96,'Chirathahalli','572113',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30286,96,'Chowdanakuppe','572123',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30287,96,'Chowlakatte','572119',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30288,96,'Dabbeghatta','572227',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30289,96,'Dabbeghatta','572112',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30290,96,'Dabbegunte','572218',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30291,96,'Dandinashivara','572215',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30292,96,'Dasalakunte','572138',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30293,96,'Dasarahally','572129',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30294,96,'Dasarighatta','572201',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30295,96,'Dasihalli','572221',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30296,96,'Dasudi','572218',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30297,96,'Dawoodsab Palya','572120',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30298,96,'Devalapura','572138',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30299,96,'Devarayanadurga','572140',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30300,96,'Devarayapatna','572104',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30301,96,'Dibbur','572106',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30302,96,'Dodda Agrahara','572125',1,0,'2022-03-03 12:34:18','2022-03-03 12:34:18'),(30303,96,'Doddagoraghatta','572220',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30304,96,'Doddaguni','572211',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30305,96,'Doddahosahalli','572175',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30306,96,'Doddakunnala','572219',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30307,96,'Doddamadure','572142',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30308,96,'Doddamalligere','572221',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30309,96,'Doddamalur','572127',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30310,96,'Doddamavathuru','572130',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30311,96,'Doddanaravangala','572107',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30312,96,'Doddasaggere','572129',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30313,96,'Doddasettikere','572221',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30314,96,'Doddaveeragondanahalli','572132',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30315,96,'Doddayennegere','572119',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30316,96,'Dodderi','572112',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30317,96,'Dombaranahalli','572215',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30318,96,'Dommathamari','561202',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30319,96,'Dugudihalli','572226',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30320,96,'Dunda','572215',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30321,96,'Dwaranahalli','572227',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30322,96,'Dwaranakunte','572135',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30323,96,'Dyagerahalli','572139',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30324,96,'Echanur','572201',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30325,96,'Galaga','572216',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30326,96,'Galigekere','572222',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30327,96,'Ganadahunse','572115',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30328,96,'Ganadhal','572218',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30329,96,'Gandinagar Tumkur','572102',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30330,96,'Ganganaghatta','572224',1,0,'2022-03-03 12:34:19','2022-03-03 12:34:19'),(30331,96,'Ganjalagunte','572132',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30332,96,'Garani','572124',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30333,96,'Godekere','572214',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30334,96,'Gokula Extn Koratagere','572129',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30335,96,'Gondhihalli','572175',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30336,96,'Gonitumkur','572227',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30337,96,'Gopaladeverahalli','572125',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30338,96,'Gopalapura','572216',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30339,96,'Gowdagere','572130',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30340,96,'Gowdagere','572139',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30341,96,'Gowdety','561202',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30342,96,'Gowripur','572117',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30343,96,'Gubbi Bazar','572216',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30344,96,'Gubbi Hosahalli','572216',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30345,96,'Gubbi','572216',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30346,96,'Guddenahalli','572227',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30347,96,'Gudigondanahalli','572217',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30348,96,'Gujjanadu','572116',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30349,96,'Guligenehalli','572137',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30350,96,'Gulur','572118',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30351,96,'Gummaghatta','561202',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30352,96,'Gundagal','572127',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30353,96,'Gundlahalli','561202',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30354,96,'Gungaramale','572224',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30355,96,'Gunnagere','572130',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30356,96,'Gurugadahalli','572201',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30357,96,'Hadavanahalli','572211',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30358,96,'Hagalawadi','572222',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30359,96,'Halagere','572111',1,0,'2022-03-03 12:34:20','2022-03-03 12:34:20'),(30360,96,'Halanur','572107',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30361,96,'Haldodderi','572128',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30362,96,'Halenahalli','572125',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30363,96,'Halepalya','572201',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30364,96,'Halevoor','572123',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30365,96,'Halkurike','572201',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30366,96,'Hanchihalli','572129',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30367,96,'Handanahalli','572223',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30368,96,'Handanakere','572119',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30369,96,'Handikunte','572113',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30370,96,'Hanumanahalli','572112',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30371,96,'Hanumanthapura','572133',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30372,96,'Haradagere','572223',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30373,96,'Haralur','572104',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30374,96,'Hebbur','572120',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30375,96,'Heggere','572215',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30376,96,'Hemdore','572135',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30377,96,'Herur','572216',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30378,96,'Herur','572130',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30379,96,'Hindiskere','572213',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30380,96,'Hiredoddavadi','572140',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30381,96,'Hirehalli SO','572168',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30382,96,'HLV road','572201',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30383,96,'Hodalur','572223',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30384,96,'Hoisalakatte','572218',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30385,96,'Holalagunda','572111',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30386,96,'Holavanahalli','572121',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30387,96,'Honnagondanahalli','572137',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30388,96,'Honnavalli','572217',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30389,96,'Honnebagi','572214',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30390,96,'Honnudike','572122',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30391,96,'Honsigere','572122',1,0,'2022-03-03 12:34:21','2022-03-03 12:34:21'),(30392,96,'Hosahalli','572123',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30393,96,'Hosahalli','572112',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30394,96,'Hosakere','572222',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30395,96,'Hosakere','572111',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30396,96,'Hoskere','572132',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30397,96,'Hosur','572139',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30398,96,'Huiludore','572137',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30399,96,'Hulihalli','572217',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30400,96,'Hulikunte','572113',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30401,96,'Hulikunte','572129',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30402,96,'Huliyar','572218',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30403,96,'Huliyur Durga','572123',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30404,96,'Hullekere','572215',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30405,96,'Hullenahalii','572122',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30406,96,'Hunasehalli','572139',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30407,96,'Hunjanal','572128',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30408,96,'Hunsekatte','572115',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30409,96,'Hunuseghatta','572224',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30410,96,'Hussainpura','572136',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30411,96,'Huthri','572126',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30412,96,'Idagur','572213',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30413,96,'Ippadi','572126',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30414,96,'Irakasandra','572129',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30415,96,'Irkasandra','572117',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30416,96,'Ittakadibbanahalli','572124',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30417,96,'Jadeya','572221',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30418,96,'Jakkenahalli','572112',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30419,96,'Jalodu','572141',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30420,96,'Janakaloti','572124',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30421,96,'Jangamarahalli','572116',1,0,'2022-03-03 12:34:22','2022-03-03 12:34:22'),(30422,96,'Jayachamarajapura','572214',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30423,96,'Jayanagar Extn Tumkur ','572102',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30424,96,'Jiddagere','572134',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30425,96,'Jinnagara','572111',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30426,96,'K R Extn Tiptur','572201',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30427,96,'K R S Agrahara Kunigan','572130',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30428,96,'K.Honnamachanahalli','572111',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30429,96,'K.Kallahalli','572220',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30430,96,'K.Mathighatta','572220',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30431,96,'Kabbigere','572138',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30432,96,'Kadaba (Tumkur)','572219',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30433,96,'Kadagathur','572127',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30434,96,'Kadasettihalli','572111',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30435,96,'Kadavigere','572137',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30436,96,'Kaggere','572130',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30437,96,'Kalidevarapura','572127',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30438,96,'Kalkere','572201',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30439,96,'Kalkere','572221',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30440,96,'Kallambella','572125',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30441,96,'Kallegowdanapalya','572201',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30442,96,'Kallur (Tumkur)','572220',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30443,96,'Kamalapura','572217',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30444,96,'Kambathanahalli','572118',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30445,96,'Kanakuppe','572120',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30446,96,'Kanakur','572221',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30447,96,'Kanathur','572224',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30448,96,'Kandikere','572228',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30449,96,'Kanivenahalli','561202',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30450,96,'Kannamedi','572116',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30451,96,'Karadi','572114',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30452,96,'Karpenahalli','572112',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30453,96,'Kataveeranahalli','572125',1,0,'2022-03-03 12:34:23','2022-03-03 12:34:23'),(30454,96,'Katrighatta','572126',1,0,'2022-03-03 12:34:24','2022-03-03 12:34:24'),(30455,96,'Kattige Gollahalli','572104',1,0,'2022-03-03 12:34:24','2022-03-03 12:34:24'),(30456,96,'Kavanadala','572112',1,0,'2022-03-03 12:34:24','2022-03-03 12:34:24'),(30457,96,'Kembalalu','572120',1,0,'2022-03-03 12:34:24','2022-03-03 12:34:24'),(30458,96,'Kempanadodderi','572138',1,0,'2022-03-03 12:34:24','2022-03-03 12:34:24'),(30459,96,'Kempanahalli','572126',1,0,'2022-03-03 12:34:24','2022-03-03 12:34:24'),(30460,96,'Kenchanahalli','572123',1,0,'2022-03-03 12:34:24','2022-03-03 12:34:24'),(30461,96,'Kengalapura','572119',1,0,'2022-03-03 12:34:24','2022-03-03 12:34:24'),(30462,96,'Kenkere','572218',1,0,'2022-03-03 12:34:24','2022-03-03 12:34:24'),(30463,96,'Kesaramadu','572104',1,0,'2022-03-03 12:34:24','2022-03-03 12:34:24'),(30464,96,'Kestur','572138',1,0,'2022-03-03 12:34:24','2022-03-03 12:34:24'),(30465,96,'Kibbanahalli','572114',1,0,'2022-03-03 12:34:24','2022-03-03 12:34:24'),(30466,96,'Kilara','572111',1,0,'2022-03-03 12:34:24','2022-03-03 12:34:24'),(30467,96,'Kilarlahalli','572116',1,0,'2022-03-03 12:34:24','2022-03-03 12:34:24'),(30468,96,'Kithanagamangala','572130',1,0,'2022-03-03 12:34:24','2022-03-03 12:34:24'),(30469,96,'Kodagadala','572132',1,0,'2022-03-03 12:34:24','2022-03-03 12:34:24'),(30470,96,'Kodagihally','572227',1,0,'2022-03-03 12:34:24','2022-03-03 12:34:24'),(30471,96,'Kodamadagu','561202',1,0,'2022-03-03 12:34:24','2022-03-03 12:34:24'),(30472,96,'Kodavathi','572123',1,0,'2022-03-03 12:34:24','2022-03-03 12:34:24'),(30473,96,'Kodigenahalli','572127',1,0,'2022-03-03 12:34:24','2022-03-03 12:34:24'),(30474,96,'Kodiyala','572117',1,0,'2022-03-03 12:34:24','2022-03-03 12:34:24'),(30475,96,'Kodlahalli','572121',1,0,'2022-03-03 12:34:24','2022-03-03 12:34:24'),(30476,96,'Kodlapura','572175',1,0,'2022-03-03 12:34:24','2022-03-03 12:34:24'),(30477,96,'Kolala','572140',1,0,'2022-03-03 12:34:24','2022-03-03 12:34:24'),(30478,96,'Kondajji','572215',1,0,'2022-03-03 12:34:24','2022-03-03 12:34:24'),(30479,96,'Kondavadi','572175',1,0,'2022-03-03 12:34:24','2022-03-03 12:34:24'),(30480,96,'Kondethimmanahalli','572116',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30481,96,'Kondli','572211',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30482,96,'Kondlighatta','572114',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30483,96,'Koppa','572219',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30484,96,'Koppa','572142',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30485,96,'Kora (Tumkur)','572128',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30486,96,'Koratagere','572129',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30487,96,'Kotagarlahalli','572132',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30488,96,'Kotagudda','561202',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30489,96,'Kotanayakanahalli','572201',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30490,96,'Kothagere','572130',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30491,96,'Kothur','572116',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30492,96,'Kotta','572137',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30493,96,'Kunigal','572130',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30494,96,'Kunikenahalli','572212',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30495,96,'Kuntegowdanahalli','572125',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30496,96,'Kuppalu','572114',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30497,96,'Kuppur','572226',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30498,96,'Kuramkote','572138',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30499,96,'Kuvempunagara','572103',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30500,96,'Kyathaganahalli','572116',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30501,96,'Kyathaganakere','572136',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30502,96,'Kyathagondanahalli','572133',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30503,96,'Kyathasandra','572104',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30504,96,'Kyshavara','572121',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30505,96,'Lakkenahalli','572216',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30506,96,'Lakkenahalli','572113',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30507,96,'Lakshmipura','572133',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30508,96,'Lakshmisagara','572139',1,0,'2022-03-03 12:34:25','2022-03-03 12:34:25'),(30509,96,'Lingadahalli','561202',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30510,96,'M C Campus Tumkur','572107',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30511,96,'Machenahalli','572215',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30512,96,'Madalur','572137',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30513,96,'Madapura','572216',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30514,96,'Maddakkanahalli','572139',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30515,96,'Madde','572116',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30516,96,'Madenahalli','572216',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30517,96,'Madenahalli','572117',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30518,96,'Madenur','572201',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30519,96,'Madhugiri','572132',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30520,96,'Madihally','572227',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30521,96,'Madikehalli','572130',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30522,96,'Magodu','572137',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30523,96,'Makanahally','572118',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30524,96,'Malagondahalli','572114',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30525,96,'Mallasandra','572107',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30526,96,'Mallekavu','572129',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30527,96,'Malligehally','572214',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30528,96,'Manangi','572139',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30529,96,'Manchaladore','572117',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30530,96,'Mangalawada','572116',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30531,96,'Maralur SO','572105',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30532,96,'Marasettihalli','572225',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30533,96,'Maridasanahalli','572141',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30534,96,'Markonahalli','572111',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30535,96,'Masavanaghatta','572224',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30536,96,'Maskal','572122',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30537,96,'Mathighatta','572119',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30538,96,'Mathihally','572201',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30539,96,'Mavathur','572129',1,0,'2022-03-03 12:34:26','2022-03-03 12:34:26'),(30540,96,'Mavinahalli','572213',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30541,96,'Mavinakere','572221',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30542,96,'Mayasandra','572221',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30543,96,'Medigeshi','572133',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30544,96,'Mekerahally','572137',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30545,96,'Melekote','572105',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30546,96,'Melkunte','572137',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30547,96,'Modur','572130',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30548,96,'Mooganayakana Kote','572222',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30549,96,'Muddenahalli','572228',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30550,96,'Mugadalabetta','572116',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30551,96,'Mugalur','572221',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30552,96,'Mukanahallipatna','572216',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30553,96,'Mulukunte','572122',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30554,96,'Muniyur','572227',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30555,96,'Muthugadahalli','572221',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30556,96,'Mydala','572104',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30557,96,'Mydanahalli','572127',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30558,96,'N.Hosahalli','572211',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30559,96,'N.Mathighatta','572223',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30560,96,'Nadumavinapura','572130',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30561,96,'Nadur','572135',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30562,96,'Naduvanahalli','572119',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30563,96,'Nagalamadike','572136',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30564,96,'Nagalapura','572221',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30565,96,'Nagaraghatta','572224',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30566,96,'Nagasandra (Tumkur)','572134',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30567,96,'Nagasandra-gubbi','572216',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30568,96,'Nagavalli','572118',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30569,96,'Naliganahalli','561202',1,0,'2022-03-03 12:34:27','2022-03-03 12:34:27'),(30570,96,'Naranahalli','572213',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30571,96,'Naruganahalli','572122',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30572,96,'Navile','572226',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30573,96,'Neelammanahalli','561202',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30574,96,'Neeragunda','572212',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30575,96,'Negalala','572138',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30576,96,'Nelahal','572128',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30577,96,'Nellikere','572224',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30578,96,'Neralekere','572132',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30579,96,'Nidasale','572123',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30580,96,'Niduvalalu','572120',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30581,96,'Niruvagal','572119',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30582,96,'Nitrahalli','572132',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30583,96,'Nittur (Tumkur)','572223',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30584,96,'Nonavinakere','572224',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30585,96,'Northren Extension','572106',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30586,96,'Nyayadagunte','572116',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30587,96,'Obalapura','572106',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30588,96,'Oorkere','572106',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30589,96,'P N Halli','572135',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30590,96,'P. W. D. Colony (Madhugiri)','572132',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30591,96,'P.Honnamchenahalli','572123',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30592,96,'Paduvagere','572111',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30593,96,'Palasandra','572118',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30594,96,'Palavalli','572136',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30595,96,'Parthihalli','572127',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30596,96,'Pathaganahalli','572129',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30597,96,'Pavagada Fort','561202',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30598,96,'Pavagada','561202',1,0,'2022-03-03 12:34:28','2022-03-03 12:34:28'),(30599,96,'Ponnasamudra','561202',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30600,96,'Pothaganahalli','572141',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30601,96,'Prabhuvanahalli','572216',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30602,96,'Pura','572215',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30603,96,'Puradakatte','572119',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30604,96,'Puravara','572175',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30605,96,'R G Market Tumkur','572103',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30606,96,'R M Yard Madhugiri','572132',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30607,96,'R.Bydarahalli','572123',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30608,96,'Ragalahalli','572113',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30609,96,'Ragihally','572142',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30610,96,'Rajathadripura','572114',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30611,96,'Rajavanthi','561202',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30612,96,'Ramachandrapura','572201',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30613,96,'Ramalingapura','572115',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30614,96,'Ramanahalli','572217',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30615,96,'Ramanahalli','572228',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30616,96,'Rampura','572121',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30617,96,'Rangapura','572201',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30618,96,'Rangasamudra','561202',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30619,96,'Rantawalalu','572132',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30620,96,'Rathnasandra','572137',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30621,96,'Rayacherlu','572136',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30622,96,'Reddihalli','572133',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30623,96,'Roppa','561202',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30624,96,'S G Extn Tumkur','572102',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30625,96,'S.Kodigehalli','572213',1,0,'2022-03-03 12:34:29','2022-03-03 12:34:29'),(30626,96,'Sadarahalli','572228',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30627,96,'Sailapura','561202',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30628,96,'Samige Road Railway Station.','572225',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30629,96,'Sampige','572225',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30630,96,'Sampige-hosahalli','572225',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30631,96,'Sanaba','572111',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30632,96,'Santhmavathur','572130',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30633,96,'Sarthvally','572201',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30634,96,'Sasalakunte','561202',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30635,96,'Sasalu','572122',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30636,96,'Sasalu','572226',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30637,96,'Sathenahalli','572117',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30638,96,'Seebi Agrahara','572125',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30639,96,'Seegehalli','572213',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30640,96,'Seenappanahalli','572126',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30641,96,'Seethakal','572140',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30642,96,'Settihalli','572102',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30643,96,'Settihally','572132',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30644,96,'Settikere','572226',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30645,96,'Shakadadu','572137',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30646,96,'Shamarayanapalya','572116',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30647,96,'Shivapura','572222',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30648,96,'Shravandanahally','572127',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30649,96,'Sidadaragal','572112',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30650,96,'Siddaganga Mutt','572104',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30651,96,'Siddapura','572141',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30652,96,'Siddarthanagar','572107',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30653,96,'Singonahalli','572216',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30654,96,'Singonahally','572120',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30655,96,'Singonahally','572127',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30656,96,'Sira Bazar Sira','572137',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30657,96,'Sira','572137',1,0,'2022-03-03 12:34:30','2022-03-03 12:34:30'),(30658,96,'Siravara','572120',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30659,96,'Sit Campus','572102',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30660,96,'Somalapura','572222',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30661,96,'Someswarapuram','572102',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30662,96,'Sompura','572121',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30663,96,'Sondalagere','572126',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30664,96,'Soralamavu','572119',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30665,96,'Soravanahalli','572221',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30666,96,'Sorekunte','572128',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30667,96,'Srirangapura','572136',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30668,96,'SSIT Campus','572105',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30669,96,'Suddekunte','572127',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30670,96,'Sugur','572224',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30671,96,'Sulanaikanahalli','561202',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30672,96,'Swandenahalli','572104',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30673,96,'Tadasur','572201',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30674,96,'Talagunda','572125',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30675,96,'Talavaranahalli','572225',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30676,96,'Talekoppa','572117',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30677,96,'Talkere','572221',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30678,96,'Taredakuppe','572120',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30679,96,'Tarikere','572130',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30680,96,'Tarur','572125',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30681,96,'Tavarekere','572122',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30682,96,'Tavarekere','572123',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30683,96,'Tavarekere (Tumkur)','572139',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30684,96,'Teriyur','572127',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30685,96,'Thadakalur','572113',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30686,96,'Thadi','572124',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30687,96,'Thammadihalli','572226',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30688,96,'Thandaga','572224',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30689,96,'Theetha','572129',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30690,96,'Thimmalanayakanabetta','572116',1,0,'2022-03-03 12:34:31','2022-03-03 12:34:31'),(30691,96,'Thimmalapura','572112',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30692,96,'Thimmanahalli','572228',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30693,96,'Thippaiahnadurga','572141',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30694,96,'Thippapura','572124',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30695,96,'Thippur','572142',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30696,96,'Thirthapura','572214',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30697,96,'Thirumalapura','572218',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30698,96,'Thirumani','572136',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30699,96,'Thogarighatta','572121',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30700,96,'Thoremavinahalli','572212',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30701,96,'Thuilahalli','572213',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30702,96,'Thyagatur','572223',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30703,96,'Tippur','572216',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30704,96,'Tiptur Bazar','572201',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30705,96,'Tiptur H.O','572201',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30706,96,'Tovinakere','572138',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30707,96,'Tumbadi','572129',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30708,96,'Tumkur City','572101',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30709,96,'Tumkur H.O','572101',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30710,96,'Tuppadakona','572137',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30711,96,'Turuganur','572134',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30712,96,'Turuvekere','572227',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30713,96,'Tuvekere','572134',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30714,96,'Ujjini','572123',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30715,96,'Urdigere','572140',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30716,96,'Vaddagere','572129',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30717,96,'Vaddanahalli','572125',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30718,96,'Vaderahalli','572132',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30719,96,'Vajarahalli','572135',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30720,96,'Vajjanakurke','572129',1,0,'2022-03-03 12:34:32','2022-03-03 12:34:32'),(30721,96,'Vajrapura Colony','572211',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30722,96,'Vallur','572136',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30723,96,'Veeraganahalli','572135',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30724,96,'Venkatapura','561202',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30725,96,'Vignasanthe','572224',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30726,96,'Virupasamudra','561202',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30727,96,'Vittalapura','572221',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30728,96,'Volagerepura','572111',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30729,96,'Western Extn','572101',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30730,96,'Y N Hoskote','572141',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30731,96,'Yadavane','572111',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30732,96,'Yedaladaku','572135',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30733,96,'Yediyur (Tumkur)','572142',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30734,96,'Yeguvapalli','572136',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30735,96,'Yelachigere','572140',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30736,96,'Yelagalavadi','572126',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30737,96,'Yelakadakalu','572123',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30738,96,'Yelanadu','572218',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30739,96,'Yelerampura','572129',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30740,96,'Yeliyur','572137',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30741,96,'Yeliyur','572126',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30742,96,'Yelkur','572124',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30743,96,'Yenjalagere','572135',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30744,96,'Yeradakatte','572115',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30745,97,'Belmannu','576111',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30746,97,'Bolakodi','576121',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30747,97,'Inna','576121',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30748,97,'Iruvail','574144',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30749,97,'Mundkur','576121',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30750,97,'Nandalike','576111',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30751,97,'Sacherigudde','576121',1,0,'2022-03-03 12:34:33','2022-03-03 12:34:33'),(30752,97,'Ajekar','574101',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30753,97,'Andar','574101',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30754,97,'Attur','576117',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30755,97,'Bailur','574102',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30756,97,'Bajegoli','574122',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30757,97,'Belady','574129',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30758,97,'Belanje','576112',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30759,97,'Bola','574110',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30760,97,'Borkatte','574107',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30761,97,'Chara','576112',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30762,97,'Doopadakatte','574110',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30763,97,'Durga','576117',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30764,97,'Ellare','574108',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30765,97,'Gundyadka','574102',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30766,97,'Hadiangady','574101',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30767,97,'Hebri','576112',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30768,97,'Hermunde','574101',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30769,97,'Hirgana','576117',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30770,97,'Hiriangady','574104',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30771,97,'Hosmar','574107',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30772,97,'Idu','574109',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30773,97,'Irvathur','574114',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30774,97,'Jarkala','574101',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30775,97,'Kabbinale','576112',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30776,97,'Kadthala','574108',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30777,97,'Kallya','574110',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30778,97,'Kanajar','574102',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30779,97,'Kanthavara','574129',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30780,97,'Karkala Bazar','574104',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30781,97,'Karkala H.O','574104',1,0,'2022-03-03 12:34:34','2022-03-03 12:34:34'),(30782,97,'Karkala West','574104',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30783,97,'Kedinje','574110',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30784,97,'Kervashe','574122',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30785,97,'Kuchur','576112',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30786,97,'Kukkuje','574108',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30787,97,'Kukkundur','576117',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30788,97,'Kukkundur West','576117',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30789,97,'Kuntady','574244',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30790,97,'Mala','574122',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30791,97,'Manjalthar','574122',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30792,97,'Miyar','574107',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30793,97,'Mudradi','576112',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30794,97,'Muniyal','574108',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30795,97,'Nakre','576117',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30796,97,'Nallur','574122',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30797,97,'Ninjoor','574244',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30798,97,'Nire','574102',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30799,97,'Nitte','574110',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30800,97,'Nooralbettu','574107',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30801,97,'Palli','574244',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30802,97,'Parappadi','574110',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30803,97,'Renjala','574114',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30804,97,'Sanur','574114',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30805,97,'Shivapura','576112',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30806,97,'Sitanadi','576112',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30807,97,'Someshwara','576112',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30808,97,'Tellar','576117',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30809,97,'Vanjarakatte','574129',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30810,97,'Varanga','574108',1,0,'2022-03-03 12:34:35','2022-03-03 12:34:35'),(30811,97,'Vishwasnagar','574108',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30812,97,'Yennehole','574101',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30813,97,'Yerlapady','574102',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30814,97,'Achladi','576225',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30815,97,'Adi-udupi','576101',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30816,97,'Admar','574119',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30817,97,'Airody','576226',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30818,97,'Ajrihara','576283',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30819,97,'Alevoor','574118',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30820,97,'Alur','576233',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30821,97,'Amasebail','576227',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30822,97,'Ambalapadi','576103',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30823,97,'Ampar','576211',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30824,97,'Anagalli','576211',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30825,97,'Ardi','576212',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30826,97,'Arekandige','576124',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30827,97,'Aroor','576213',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30828,97,'Asodu','576222',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30829,97,'Athradi','576107',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30830,97,'Avarse','576223',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30831,97,'Avral','574103',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30832,97,'Bada','574117',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30833,97,'Badagabettu','576107',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30834,97,'Badakere','576224',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30835,97,'Badanidiyur','576115',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30836,97,'Baidabettu','576234',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30837,97,'Baikadi','576213',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30838,97,'Balkur','576211',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30839,97,'Bannadi','576225',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30840,97,'Bannanje','576101',1,0,'2022-03-03 12:34:36','2022-03-03 12:34:36'),(30841,97,'Barkur','576210',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30842,97,'Barkur Town','576210',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30843,97,'Basrur','576211',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30844,97,'Beejadi','576222',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30845,97,'Belapu','574117',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30846,97,'Bellampalli','576124',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30847,97,'Bellarpadi','576113',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30848,97,'Belur Devasthanabettu','576221',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30849,97,'Belve','576212',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30850,97,'Bennekudru','576210',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30851,97,'Bhairanje','576107',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30852,97,'Bhantakal','574115',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30853,97,'Bijur','576232',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30854,97,'Brahmavara','576213',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30855,97,'Byndoor','576214',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30856,97,'Chanthar','576213',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30857,97,'Cherkadi','576215',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30858,97,'Chitpadi','576101',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30859,97,'Chittoor','576233',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30860,97,'Devalkunda','576230',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30861,97,'Dist. Offices Complex Manipal','576104',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30862,97,'Doddanagudde','576102',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30863,97,'Gandhi-maidan','576201',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30864,97,'Ganguli','576216',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30865,97,'Golihole','576214',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30866,97,'Guddeangadi','576113',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30867,97,'Gujjadi','576247',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30868,97,'Gulvadi','576283',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30869,97,'Gummahola','576212',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30870,97,'Hadavu','576235',1,0,'2022-03-03 12:34:37','2022-03-03 12:34:37'),(30871,97,'Hakladi','576235',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30872,97,'Haladi-28','576222',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30873,97,'Haladi-76','576222',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30874,97,'Halasinakatte','574113',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30875,97,'Halladi-harkadi','576210',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30876,97,'Hallihole','576229',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30877,97,'Halnadu','576211',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30878,97,'Haluvalli','576215',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30879,97,'Hanehalli','576210',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30880,97,'Hanglur','576217',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30881,97,'Haradi','576213',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30882,97,'Hardalli-mandalli','576222',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30883,97,'Harkur','576233',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30884,97,'Hattiangadi','576283',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30885,97,'Havanje','576124',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30886,97,'Hejmadi','574103',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30887,97,'Hejmadikodi','574103',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30888,97,'Hemmadi','576230',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30889,97,'Hengavalli','576212',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30890,97,'Heranjal','576219',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30891,97,'Herga','576107',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30892,97,'Herikudru','576230',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30893,97,'Herur','576213',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30894,97,'Herur-92','574115',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30895,97,'Heskethur','576210',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30896,97,'Hiliyana','576212',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30897,97,'Hirebettu','576107',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30898,97,'Hiriadka','576113',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30899,97,'Hoode','576115',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30900,97,'Hosadu','576247',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30901,97,'Hosala','576210',1,0,'2022-03-03 12:34:38','2022-03-03 12:34:38'),(30902,97,'Hosangadi','576282',1,0,'2022-03-03 12:34:39','2022-03-03 12:34:39'),(30903,97,'Hungarcutta','576218',1,0,'2022-03-03 12:34:39','2022-03-03 12:34:39'),(30904,97,'Hunsemakki','576222',1,0,'2022-03-03 12:34:39','2022-03-03 12:34:39'),(30905,97,'Idurkunhady','576233',1,0,'2022-03-03 12:34:39','2022-03-03 12:34:39'),(30906,97,'Innanje','576122',1,0,'2022-03-03 12:34:39','2022-03-03 12:34:39'),(30907,97,'Jadkal','576233',1,0,'2022-03-03 12:34:39','2022-03-03 12:34:39'),(30908,97,'Jansale','576229',1,0,'2022-03-03 12:34:39','2022-03-03 12:34:39'),(30909,97,'Janvarkatte','576223',1,0,'2022-03-03 12:34:39','2022-03-03 12:34:39'),(30910,97,'Japthi','576211',1,0,'2022-03-03 12:34:39','2022-03-03 12:34:39'),(30911,97,'Kadekar','576103',1,0,'2022-03-03 12:34:39','2022-03-03 12:34:39'),(30912,97,'Kadur','576234',1,0,'2022-03-03 12:34:39','2022-03-03 12:34:39'),(30913,97,'Kakkunje','576222',1,0,'2022-03-03 12:34:39','2022-03-03 12:34:39'),(30914,97,'Kalathur South','574106',1,0,'2022-03-03 12:34:39','2022-03-03 12:34:39'),(30915,97,'Kallianapura','576114',1,0,'2022-03-03 12:34:39','2022-03-03 12:34:39'),(30916,97,'Kalthod','576219',1,0,'2022-03-03 12:34:39','2022-03-03 12:34:39'),(30917,97,'Kamalashile','576229',1,0,'2022-03-03 12:34:39','2022-03-03 12:34:39'),(30918,97,'Kandlur','576211',1,0,'2022-03-03 12:34:39','2022-03-03 12:34:39'),(30919,97,'Kanyana','576230',1,0,'2022-03-03 12:34:39','2022-03-03 12:34:39'),(30920,97,'Karje','576215',1,0,'2022-03-03 12:34:39','2022-03-03 12:34:39'),(30921,97,'Karkada','576225',1,0,'2022-03-03 12:34:39','2022-03-03 12:34:39'),(30922,97,'Karkunje','576283',1,0,'2022-03-03 12:34:39','2022-03-03 12:34:39'),(30923,97,'Katapadi(Udupi)','574105',1,0,'2022-03-03 12:34:39','2022-03-03 12:34:39'),(30924,97,'Kattebelthur','576230',1,0,'2022-03-03 12:34:39','2022-03-03 12:34:39'),(30925,97,'Kattingere','576120',1,0,'2022-03-03 12:34:39','2022-03-03 12:34:39'),(30926,97,'Kaup','574106',1,0,'2022-03-03 12:34:39','2022-03-03 12:34:39'),(30927,97,'Kavadi','576210',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30928,97,'Kavradi','576211',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30929,97,'Kedur','576231',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30930,97,'Kelarkalabettu','576105',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30931,97,'Kemmannu','576115',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30932,97,'Kemmundel','574119',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30933,97,'Kenchanur','576283',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30934,97,'Kenjur','576234',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30935,97,'Keradi','576233',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30936,97,'Kergal','576219',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30937,97,'Khambadakone','576219',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30938,97,'Kidiyur','576103',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30939,97,'Kirimanjeshwara','576219',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30940,97,'Koderi','576219',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30941,97,'Kodi','576217',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30942,97,'Kodi Kanyana','576226',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30943,97,'Kodibengre','576218',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30944,97,'Kodladi','576283',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30945,97,'Kodupanjimar','574116',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30946,97,'Kokkarne','576234',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30947,97,'Kolalagiri','576105',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30948,97,'Kollur','576220',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30949,97,'Koni','576217',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30950,97,'Korangrapadi','574118',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30951,97,'Korgi','576231',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30952,97,'Kota','576221',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30953,97,'Kotathattu','576221',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30954,97,'Koteshwara','576222',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30955,97,'Krodabailur','576227',1,0,'2022-03-03 12:34:40','2022-03-03 12:34:40'),(30956,97,'Krodashrama','576106',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30957,97,'Kudi','576113',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30958,97,'Kudrukere','576108',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30959,97,'Kukkehalli','576124',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30960,97,'Kukkikatte','576101',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30961,97,'Kulanje','576227',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30962,97,'Kumbhashi','576257',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30963,97,'Kumragodu','576213',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30964,97,'Kundabarandadi','576235',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30965,97,'Kundapura H.O','576201',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30966,97,'Kundapura Market','576201',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30967,97,'Kunjal','576213',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30968,97,'Kunjarugiri','574105',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30969,97,'Kunjibettu','576102',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30970,97,'Kuthpadi','574118',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30971,97,'Kuthyar','574116',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30972,97,'Machattu','576227',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30973,97,'Madamakki','576212',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30974,97,'Majur','574106',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30975,97,'Mallar','574106',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30976,97,'Malpe','576108',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30977,97,'Manchikodi','576102',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30978,97,'Mandarthi','576223',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30979,97,'Manipal East','576104',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30980,97,'Manipal H.O','576104',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30981,97,'Manipal Industrial Area','576104',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30982,97,'Manipura','576120',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30983,97,'Manipura West','574105',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30984,97,'Manur','576221',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30985,97,'Maravanthe','576224',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30986,97,'Marne','576120',1,0,'2022-03-03 12:34:41','2022-03-03 12:34:41'),(30987,97,'Matapadi','576213',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(30988,97,'Mattar','574116',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(30989,97,'Mattu','574105',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(30990,97,'Mayyadi','576214',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(30991,97,'Melhosur','576233',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(30992,97,'Mission Compound','576101',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(30993,97,'Molahalli','576222',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(30994,97,'Moodubelle','576120',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(30995,97,'Moodumata','576219',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(30996,97,'Muddumane','576223',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(30997,97,'Mudlakatte','576217',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(30998,97,'Mudmunda','576233',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(30999,97,'Mudur','576233',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(31000,97,'Nada','576230',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(31001,97,'Nadur','576223',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(31002,97,'Nalkur','576234',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(31003,97,'Nanchar','576234',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(31004,97,'Nandikur','574111',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(31005,97,'Navunda','576224',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(31006,97,'Neelavara','576213',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(31007,97,'Nittur','576103',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(31008,97,'Nujadi','576233',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(31009,97,'Padebettu','574111',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(31010,97,'Padubelle','574116',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(31011,97,'Padubidri','574111',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(31012,97,'Padur','574106',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(31013,97,'Paduvari','576214',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(31014,97,'Paduyermal','574119',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(31015,97,'Palimar','574112',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(31016,97,'Panchanbettu','576113',1,0,'2022-03-03 12:34:42','2022-03-03 12:34:42'),(31017,97,'Pangala','576122',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31018,97,'Paniyur','574117',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31019,97,'Parampalli','576225',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31020,97,'Parkala','576107',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31021,97,'Patla','576107',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31022,97,'Perdur','576124',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31023,97,'Pernal','574116',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31024,97,'Pernankila','576113',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31025,97,'Pilar (Udupi)','574113',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31026,97,'Pithrodi','574118',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31027,97,'Puttur','576105',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31028,97,'Ragihaklu','576224',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31029,97,'Rattadi','576227',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31030,97,'Saibarkatte','576210',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31031,97,'Saligrama (Udupi)','576225',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31032,97,'Salikeri','576213',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31033,97,'Salvadi','576222',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31034,97,'Santhekatte','576105',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31035,97,'Santhekatte-kalathur','576215',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31036,97,'Santhur','574111',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31037,97,'Sasthan','576226',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31038,97,'Shankaranarayana','576227',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31039,97,'Shankarapura','574115',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31040,97,'Shedimane','576212',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31041,97,'Shenapura','576235',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31042,97,'Shiriyara','576210',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31043,97,'Shiroor','576124',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31044,97,'Shiruru (Udupi)','576228',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31045,97,'Shirva','574116',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31046,97,'Shivalli','576102',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31047,97,'Siddapura (Udupi)','576229',1,0,'2022-03-03 12:34:43','2022-03-03 12:34:43'),(31048,97,'Sooda','574116',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31049,97,'Souda','576222',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31050,97,'Subhash Nagar','574105',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31051,97,'Taggarshe','576214',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31052,97,'Tallur (Udupi)','576230',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31053,97,'Tarapathi','576232',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31054,97,'Tekkatte','576231',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31055,97,'Tenkabettu','576105',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31056,97,'Tenkanidiyur','576106',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31057,97,'Thottam','576108',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31058,97,'Trasi','576235',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31059,97,'Uchila','574117',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31060,97,'Udupi Courts','576101',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31061,97,'Udupi H.O','576101',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31062,97,'Udyavara','574118',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31063,97,'Uliyaragoli','574106',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31064,97,'Ullur','576229',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31065,97,'Ultoor','576231',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31066,97,'Uppinakudru','576230',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31067,97,'Uppunda','576232',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31068,97,'Uppur','576105',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31069,97,'Vakwadi','576257',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31070,97,'Vandar','576223',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31071,97,'Vandse','576233',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31072,97,'Yadyadi-mathyadi','576222',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31073,97,'Yedabettu','576226',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31074,97,'Yedamoge','576282',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31075,97,'Yedthadi','576210',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31076,97,'Yedthare','576214',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31077,97,'Yelajith','576214',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31078,97,'Yellur','574113',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31079,97,'Yermal','574119',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31080,98,'Achve','581344',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31081,98,'Adigon','581319',1,0,'2022-03-03 12:34:44','2022-03-03 12:34:44'),(31082,98,'Adukal','581348',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31083,98,'Aggargon','581319',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31084,98,'Aghanashini','581351',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31085,98,'Agsur','581314',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31086,98,'Algeri','581314',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31087,98,'Alvekodi(BKTL)','581354',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31088,98,'Alvekodi(KMT)','581343',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31089,98,'Amdalli','581324',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31090,98,'Anantwadi','581350',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31091,98,'Andle','581344',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31092,98,'Angadi (Uttara Kannada)','581360',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31093,98,'Ankola','581314',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31094,98,'Antravalli','581440',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31095,98,'Apsarkonda','581342',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31096,98,'Areangadi','581334',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31097,98,'Arge','581308',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31098,98,'Asnoti','581317',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31099,98,'Aversa','581316',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31100,98,'Awara Road','581302',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31101,98,'Baad','581351',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31102,98,'Baad(KWR)','581306',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31103,98,'Bailur','581350',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31104,98,'Baleguli','581314',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31105,98,'Balkur','581423',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31106,98,'Balni','581317',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31107,98,'Bankikodla','581319',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31108,98,'Bargi','581440',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31109,98,'Basgod','581353',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31110,98,'Belambar','581353',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31111,98,'Belekeri','581321',1,0,'2022-03-03 12:34:45','2022-03-03 12:34:45'),(31112,98,'Belke','581320',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31113,98,'Belse','581357',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31114,98,'Bengre','581421',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31115,98,'Bengre Ulman','581421',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31116,98,'Beranki','581423',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31117,98,'Betkuli','581333',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31118,98,'Bhaire','581317',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31119,98,'Bhaskeri','581334',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31120,98,'Bhatkal Bazar','581320',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31121,98,'Bhatkal','581320',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31122,98,'Bhavikeri','581321',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31123,98,'Binga','581307',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31124,98,'Bobruwada','581314',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31125,98,'Bolshitta','581328',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31126,98,'Brahmur','581333',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31127,98,'Chandavar','581323',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31128,98,'Chendiye','581324',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31129,98,'Chikkankod','581361',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31130,98,'Devalmakki','581400',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31131,98,'Devbag','581352',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31132,98,'Dhareshwar','581327',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31133,98,'Divgi','581440',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31134,98,'Dongri','581314',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31135,98,'Dubbanshashi','581319',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31136,98,'Durgakeri','581334',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31137,98,'Gaongeri','581345',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31138,98,'Gersoppa','581384',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31139,98,'Gersoppa Jyothinagar','581384',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31140,98,'Gokarn Car Street','581326',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31141,98,'Gokarn','581326',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31142,98,'Gopshitta','581317',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31143,98,'Gorte','581320',1,0,'2022-03-03 12:34:46','2022-03-03 12:34:46'),(31144,98,'Gotegali','581317',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31145,98,'Gotnibag','581345',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31146,98,'Gudeangadi','581351',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31147,98,'Gunavante','581348',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31148,98,'Gundbala','581344',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31149,98,'Habbuwada','581306',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31150,98,'Hadav','581353',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31151,98,'Hadavalli','581320',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31152,98,'Hadil','581320',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31153,98,'Hadinbal','581361',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31154,98,'Haldipur','581327',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31155,98,'Halge Joog','581328',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31156,98,'Halge','581328',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31157,98,'Halkar','581362',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31158,98,'Halvalli','581314',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31159,98,'Handigon','581362',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31160,98,'Hanehalli','581319',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31161,98,'Hankon','581317',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31162,98,'Harwada','581316',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31163,98,'Hattikeri','581316',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31164,98,'Heble','581320',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31165,98,'Hegde','581330',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31166,98,'Heggar R.C.','581314',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31167,98,'Herangadi','581334',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31168,98,'Herwatta','581332',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31169,98,'Hichkad','581353',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31170,98,'Hillur','581344',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31171,98,'Hiregutti','581333',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31172,98,'Hodkeshirur','581338',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31173,98,'Holangadde','581351',1,0,'2022-03-03 12:34:47','2022-03-03 12:34:47'),(31174,98,'Holegadde','581327',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31175,98,'Honavar Bazar','581334',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31176,98,'Honavar Port','581334',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31177,98,'Honavar','581334',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31178,98,'Honmav','581343',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31179,98,'Hosad','581335',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31180,98,'Hosakuli','581334',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31181,98,'Hosali','581360',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31182,98,'Hosapattan','581342',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31183,98,'Hotegali','581317',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31184,98,'Hubbangeri','581351',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31185,98,'Jalavalli','581334',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31186,98,'Jali','581320',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31187,98,'Jognikatte','581327',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31188,98,'Kadime','581319',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31189,98,'Kadle','581334',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31190,98,'Kadra Bazar','581396',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31191,98,'Kadra','581396',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31192,98,'Kadtoka','581338',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31193,98,'Kadwad','581339',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31194,98,'Kagal','581351',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31195,98,'Kaiga','581400',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31196,98,'Kaiga Workers Colony','581400',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31197,98,'Kaikini','581421',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31198,98,'Kalbag','581332',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31199,98,'Kallabbe','581362',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31200,98,'Kalleswar','581314',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31201,98,'Kanasagiri','581352',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31202,98,'Karki','581341',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31203,98,'Karwar Baitkhol','581302',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31204,98,'Karwar H.O','581301',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31205,98,'Karwar Kutchery','581301',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31206,98,'Karwar Naval Base','581308',1,0,'2022-03-03 12:34:48','2022-03-03 12:34:48'),(31207,98,'Kasarkod','581342',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31208,98,'Kasarkod Tonka','581342',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31209,98,'Katgal','581362',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31210,98,'Katgar','581354',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31211,98,'Kathinkon','581305',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31212,98,'Kavalakki','581361',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31213,98,'Kekkar','581338',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31214,98,'Kelagin Idgunji','581423',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31215,98,'Kelagina Mudkani','581334',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31216,98,'Kelaginoor','581342',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31217,98,'Keni','581314',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31218,98,'Kerwadi','581400',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31219,98,'Kharwa','581361',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31220,98,'Kimani','581333',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31221,98,'Kinnar','581339',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31222,98,'Kodambale','581362',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31223,98,'Kodani','581423',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31224,98,'Kodibag','581303',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31225,98,'Kodkani','581440',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31226,98,'Kodsani','581357',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31227,98,'Konalli','581323',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31228,98,'Konar','581320',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31229,98,'Konkar','581341',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31230,98,'Koppa','581421',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31231,98,'Kudrige','581384',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31232,98,'Kujalli','581332',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31233,98,'Kumta H.O','581343',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31234,98,'Kumta Kanara College Road','581362',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31235,98,'Kumta Kutchery','581343',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31236,98,'Kumta Town','581343',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31237,98,'Lukkeri','581330',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31238,98,'Madangeri','581344',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31239,98,'Madgeri','581338',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31240,98,'Magod','581423',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31241,98,'Majali','581345',1,0,'2022-03-03 12:34:49','2022-03-03 12:34:49'),(31242,98,'Mallapur','581400',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31243,98,'Mallapur','581323',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31244,98,'Manaki','581362',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31245,98,'Manjuguni','581353',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31246,98,'Manki Banasale','581348',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31247,98,'Manki','581348',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31248,98,'Marukeri','581320',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31249,98,'Masur','581330',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31250,98,'Mathadhittal','581421',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31251,98,'Mavinkurve','581320',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31252,98,'Mavinkurve','581335',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31253,98,'Melin Idgunji','581423',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31254,98,'Melina Mannige','581423',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31255,98,'Mirjan','581440',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31256,98,'Mogta','581344',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31257,98,'Molkod','581335',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31258,98,'Mudga','581324',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31259,98,'Mudgeri','581360',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31260,98,'Mugva','581334',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31261,98,'Mugva Surkatte','581334',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31262,98,'Mundalli','581320',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31263,98,'Murdeshwar','581350',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31264,98,'Murur','581362',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31265,98,'Mutta','581361',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31266,98,'Muttolli','581320',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31267,98,'Nadumaskeri','581319',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31268,98,'Nagarbastikeri','581384',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31269,98,'Nagre','581335',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31270,98,'Nagur','581333',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31271,98,'Nandangadda','581304',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31272,98,'Navayat Colony','581320',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31273,98,'Navilgone','581338',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31274,98,'Nilkod','581334',1,0,'2022-03-03 12:34:50','2022-03-03 12:34:50'),(31275,98,'Nilkod','581440',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31276,98,'Paduvani','581333',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31277,98,'Pavinkurve','581341',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31278,98,'Prabhatnagar','581334',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31279,98,'Ramanagulli','581314',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31280,98,'S S Auditorium','581301',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31281,98,'Sadashivgad','581352',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31282,98,'Sagadgeri','581319',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31283,98,'Sakalben','581316',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31284,98,'Salkod','581334',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31285,98,'Samsi','581334',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31286,98,'Sangtal','581323',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31287,98,'Sanikatta','581326',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31288,98,'Santeguli','581323',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31289,98,'Saralgi','581384',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31290,98,'Shejwad','581306',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31291,98,'Shetgeri','581353',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31292,98,'Shirali Bazar','581354',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31293,98,'Shirali','581354',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31294,98,'Shirkuli','581314',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31295,98,'Shirur','581357',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31296,98,'Shirwada','581306',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31297,98,'Siddar','581339',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31298,98,'Soppinahosalli','581323',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31299,98,'Sunkeri','581305',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31300,98,'Sunksal','581314',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31301,98,'Tadri','581326',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31302,98,'Talamakki','581348',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31303,98,'Tenkankeri','581314',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31304,98,'Ternamakki','581421',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31305,98,'Todur','581324',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31306,98,'Todur Camp','581324',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31307,98,'Torke','581344',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31308,98,'Ulga','581328',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31309,98,'Ulware','581344',1,0,'2022-03-03 12:34:51','2022-03-03 12:34:51'),(31310,98,'Uppinapattan','581362',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31311,98,'Upponi','581334',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31312,98,'Urkeri','581332',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31313,98,'Valgalli','581332',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31314,98,'Valki','581335',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31315,98,'Vandige','581357',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31316,98,'Vandur','581341',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31317,98,'Vasarkudrige','581357',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31318,98,'Wailwada','581339',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31319,98,'Yelvadikavur','581320',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31320,98,'Yettinbail','581333',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31321,98,'Adkalli','581340',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31322,98,'Adukatta','581355',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31323,98,'Ajjibal','581340',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31324,98,'Akheti','581453',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31325,98,'Akkunji','581355',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31326,98,'Alur','581325',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31327,98,'Alvalli','581322',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31328,98,'Ambewadi (Uttara Kannada)','581325',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31329,98,'Ambikanagar','581363',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31330,98,'Aminalli','581315',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31331,98,'Ammankoppa','581329',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31332,98,'Andagi','581358',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31333,98,'Andalgi','581349',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31334,98,'Angod','581359',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31335,98,'Anmod','581453',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31336,98,'Anshi','581187',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31337,98,'Aralwada','581356',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31338,98,'Arbail','581337',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31339,98,'Arsapur','581402',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31340,98,'Asu','581129',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31341,98,'Avarguppa','581355',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31342,98,'Aveda','581365',1,0,'2022-03-03 12:34:52','2022-03-03 12:34:52'),(31343,98,'Bachanki','581349',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31344,98,'Bakkal','581336',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31345,98,'Balegadde','581336',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31346,98,'Balekoppa','581331',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31347,98,'Balesara','581340',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31348,98,'Balgar','581359',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31349,98,'Balgimane','581359',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31350,98,'Balvalli','581315',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31351,98,'Banavasi','581318',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31352,98,'Bandal','581315',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31353,98,'Bankanal','581358',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31354,98,'Barchi','581325',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31355,98,'Bare','581337',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31356,98,'Barur','581403',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31357,98,'Bazarkunang','581121',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31358,98,'Bazarkunchanalli','581329',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31359,98,'Bedkani','581355',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31360,98,'Belvatgi','581329',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31361,98,'Bhagwati','581363',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31362,98,'Bhasi','581318',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31363,98,'Bhedasgaon','581346',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31364,98,'Bhirumbe','581402',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31365,98,'Bidrakan','581355',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31366,98,'Bilgi (Uttara Kannada)','581322',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31367,98,'Bisgod','581359',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31368,98,'Bommanalli','581402',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31369,98,'Boppanalli','581358',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31370,98,'C.P.Bazar','581401',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31371,98,'Castlerock','581121',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31372,98,'Chandguli','581359',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31373,98,'Channammacircle','581325',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31374,98,'Chapoli','581186',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31375,98,'Chapparmane','581322',1,0,'2022-03-03 12:34:53','2022-03-03 12:34:53'),(31376,98,'Chavadalli','581349',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31377,98,'Chavatti','581347',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31378,98,'Chibbalgeri','581329',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31379,98,'Chigalli','581349',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31380,98,'Chipgeri','581402',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31381,98,'Chipgi','581402',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31382,98,'D.T.Road','581359',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31383,98,'Dandeli Bazar','581325',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31384,98,'Dandeli Paper Mills','581325',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31385,98,'Dandeli','581325',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31386,98,'Dasankoppa','581358',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31387,98,'Dehalli','581359',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31388,98,'Devanalli','581403',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31389,98,'Devisara','581340',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31390,98,'Dharma Colony','581346',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31391,98,'Dodmane','581322',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31392,98,'Dodnalli','581402',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31393,98,'Gandhinagar','581403',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31394,98,'Ganeshgudi','581365',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31395,98,'Geral','581359',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31396,98,'Godlabeel','581355',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31397,98,'Golgod','581355',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31398,98,'Gubgod','581322',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31399,98,'Gudnapur','581318',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31400,98,'Gullapur','581337',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31401,98,'Gund','581325',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31402,98,'Gundolli','581329',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31403,98,'Gunjagod','581355',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31404,98,'Gunjavati','581349',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31405,98,'Halgeri','581355',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31406,98,'Haliyal','581329',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31407,98,'Hallibail','581331',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31408,98,'Hanumapur','581346',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31409,98,'Harsikatta','581355',1,0,'2022-03-03 12:34:54','2022-03-03 12:34:54'),(31410,98,'Hasangi','581347',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31411,98,'Hasargod','581340',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31412,98,'Havagi','581356',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31413,98,'Hebbatti','581358',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31414,98,'Heepnalli','581403',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31415,98,'Hegadekatta','581403',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31416,98,'Heggarni','581331',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31417,98,'Hegnoor','581450',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31418,98,'Hemmadi','581402',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31419,98,'Herur','581450',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31420,98,'Hittlalli','581347',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31421,98,'Hosalli','581412',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31422,98,'Hospet','581401',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31423,98,'Hostota','581331',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31424,98,'Hudsa','581186',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31425,98,'Hukli','581331',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31426,98,'Hulekal','581336',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31427,98,'Hulgol','581402',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31428,98,'Hullunde','581331',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31429,98,'Hungund','581349',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31430,98,'Hunsekoppa','581403',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31431,98,'Hunshettikoppa','581359',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31432,98,'Hunswad','581356',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31433,98,'Husri','581402',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31434,98,'Hutkhanda','581359',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31435,98,'Idgundi','581337',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31436,98,'Indoor','581349',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31437,98,'Isloor','581358',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31438,98,'Itgi','581322',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31439,98,'Itguli','581336',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31440,98,'Jagalbet','581129',1,0,'2022-03-03 12:34:55','2022-03-03 12:34:55'),(31441,98,'Jange','581329',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31442,98,'Janmane','581315',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31443,98,'Joida','581186',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31444,98,'Kadbal','581402',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31445,98,'Kakkalli','581336',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31446,98,'Kalache','581337',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31447,98,'Kalasai','581187',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31448,98,'Kalginkoppa','581329',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31449,98,'Kalve','581402',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31450,98,'Kampli','581347',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31451,98,'Kanchikai','581331',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31452,98,'Kangod','581340',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31453,98,'Kangod','581355',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31454,98,'Kannadgal','581359',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31455,98,'Kannigeri','581359',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31456,98,'Kansur','581340',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31457,98,'Karajgi','581340',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31458,98,'Karanjoida','581186',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31459,98,'Karkisaval','581355',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31460,98,'Katur','581346',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31461,98,'Kaunchur','581355',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31462,98,'Kawalwada','581329',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31463,98,'Kegdal','581363',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31464,98,'Kesrolli','581329',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31465,98,'Khursi','581315',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31466,98,'Kirwatti','581412',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31467,98,'Kodangadde','581336',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31468,98,'Kodlagadde','581337',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31469,98,'Kodsar','581340',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31470,98,'Kodsaramuttalli','581340',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31471,98,'Koligar','581402',1,0,'2022-03-03 12:34:56','2022-03-03 12:34:56'),(31472,98,'Kolsirsi','581355',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31473,98,'Kondli','581355',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31474,98,'Korlakatta','581318',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31475,98,'Kulgi','581363',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31476,98,'Kulve','581403',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31477,98,'Kumbarwada','581187',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31478,98,'Kundargi','581402',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31479,98,'Kupgadde','581358',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31480,98,'Kurli','581346',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31481,98,'Kusur','581411',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31482,98,'Kyadgi','581322',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31483,98,'Madnalli','581356',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31484,98,'Madnoor','581412',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31485,98,'Madralli','581318',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31486,98,'Magod Colony','581359',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31487,98,'Mainalli','581349',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31488,98,'Malalgaon','581358',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31489,98,'Malgi','581346',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31490,98,'Manchikeri','581347',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31491,98,'Mangalwada','581356',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31492,98,'Manigar','581331',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31493,98,'Manjavalli','581402',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31494,98,'Manjguni','581315',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31495,98,'Manmane','581355',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31496,98,'Maratikoppa','581401',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31497,98,'Mathadeval','581336',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31498,98,'Matttigar','581450',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31499,98,'Mavingundi','581355',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31500,98,'Mavinmane','581337',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31501,98,'Melinonikeri','581402',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31502,98,'Mensi','581336',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31503,98,'Mundganmane','581403',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31504,98,'Mundgod','581349',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31505,98,'Murakwada','581329',1,0,'2022-03-03 12:34:57','2022-03-03 12:34:57'),(31506,98,'Muttalmuri','581356',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31507,98,'N.S.Koppa','581329',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31508,98,'Nagoda','581186',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31509,98,'Nandikatta','581411',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31510,98,'Nandolli','581359',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31511,98,'Narur','581318',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31512,98,'Navilgar','581315',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31513,98,'Neggu','581450',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31514,98,'Neharunagar','581349',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31515,98,'Nejjur','581355',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31516,98,'Nidgod','581340',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31517,98,'Nilekani','581403',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31518,98,'Nilkund','581331',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31519,98,'Nujji','581187',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31520,98,'Onikeri','581318',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31521,98,'Oralgi','581346',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31522,98,'Pala','581346',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31523,98,'Plywood Colony','581325',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31524,98,'Pradhani','581325',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31525,98,'Puttanmane','581402',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31526,98,'Ragihosalli','581315',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31527,98,'Ramnagar (Uttara Kannada)','581453',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31528,98,'Ravindranagar','581355',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31529,98,'Sahasralli','581359',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31530,98,'Salkani','581402',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31531,98,'Sambrani','581329',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31532,98,'Sampagod','581340',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31533,98,'Sampkhanda','581315',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31534,98,'Sarkuli','581450',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31535,98,'Shelur','581340',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31536,98,'Shingargaon','581129',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31537,98,'Shiralgi','581355',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31538,98,'Shirnal','581347',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31539,98,'Shivalli','581403',1,0,'2022-03-03 12:34:58','2022-03-03 12:34:58'),(31540,98,'Siddapur','581355',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31541,98,'Siddapurcourts','581355',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31542,98,'Sirsi Courts','581401',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31543,98,'Sirsi H.O','581401',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31544,98,'Sirsi Market','581402',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31545,98,'Sonda','581336',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31546,98,'Sovinkoppa','581322',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31547,98,'Sugavi','581318',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31548,98,'Targod','581402',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31549,98,'Tattigeri','581329',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31550,98,'Teginhalli','581329',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31551,98,'Telangeri','581337',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31552,98,'Tergaon','581356',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31553,98,'Thyagli','581340',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31554,98,'Tibetan Colony','581411',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31555,98,'Tinaighat','581453',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31556,98,'Tudguni','581450',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31557,98,'Tyarsi','581355',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31558,98,'Ulvi','581187',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31559,98,'Umblekoppa','581318',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31560,98,'Ummachgi','581347',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31561,98,'Unchalli','581318',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31562,98,'Urtota','581450',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31563,98,'Vajralli','581337',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31564,98,'Vanalli','581336',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31565,98,'Virnoli','581363',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31566,98,'Wajgod','581322',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31567,98,'Yedalli','581340',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31568,98,'Yedoga','581329',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31569,98,'Yekkambi','581358',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31570,98,'Yellapur Bazar','581359',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31571,98,'Yellapur','581359',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31572,99,'Adilapur','585223',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31573,99,'Agni','585216',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31574,99,'Aikur','585223',1,0,'2022-03-03 12:34:59','2022-03-03 12:34:59'),(31575,99,'Ajalapur','585315',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31576,99,'Aldal','585290',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31577,99,'Algera','585321',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31578,99,'Alhal','585216',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31579,99,'Allipur','585202',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31580,99,'Amblihal','585216',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31581,99,'Anabi','585223',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31582,99,'Anpur','585321',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31583,99,'Arkera B','585202',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31584,99,'Arkera J','585216',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31585,99,'Arkera K','585321',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31586,99,'Ashnal','585321',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31587,99,'Bablad','585202',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31588,99,'Bachimatti','585290',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31589,99,'Baddepalli','585221',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31590,99,'Badiyal','585221',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31591,99,'Baichbal','585290',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31592,99,'Balchad','585221',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31593,99,'Balichakra','585221',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31594,99,'Balkal','585319',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31595,99,'Bandhalli','585202',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31596,99,'Bapparga','585237',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31597,99,'Baradevanal','585237',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31598,99,'Belgera','585321',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31599,99,'Belgunda','585221',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31600,99,'Bendebembli','585355',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31601,99,'Bheemarayanagudi','585287',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31602,99,'Bijaspur','585304',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31603,99,'Bilhar','585355',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31604,99,'Birnoor','585304',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31605,99,'Bonhal','585290',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31606,99,'Budihal','585237',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31607,99,'Budnoor','585214',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31608,99,'Budnoor','585309',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31609,99,'Buragapalli','585214',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31610,99,'Chamnal','585309',1,0,'2022-03-03 12:35:00','2022-03-03 12:35:00'),(31611,99,'Chandraki','585214',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31612,99,'Chapatla','585214',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31613,99,'Chennur','585355',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31614,99,'Chincholi','585216',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31615,99,'Chinnakar','585321',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31616,99,'Chintapalli','585319',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31617,99,'Chintkunta','585214',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31618,99,'Devapur','585290',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31619,99,'Devargonal','585220',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31620,99,'Devatkal','585290',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31621,99,'Diggi','585287',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31622,99,'Doranahalli','585223',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31623,99,'Duppalli','585221',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31624,99,'Ekchinti','585223',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31625,99,'Gajarkot','585214',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31626,99,'Ganganal','585323',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31627,99,'Ganpur','585321',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31628,99,'Geddalmari','585291',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31629,99,'Godihal','585290',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31630,99,'Gogi','585309',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31631,99,'Goudgera','585216',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31632,99,'Gulsharam','585202',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31633,99,'Gundgurthi','585319',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31634,99,'Gunjanur','585321',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31635,99,'Gurmitkal','585214',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31636,99,'Hadanoor','585216',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31637,99,'Hagaratgi','585237',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31638,99,'Halgera','585202',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31639,99,'Hallisagar','585223',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31640,99,'Hattigudur','585223',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31641,99,'Hattikuni','585202',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31642,99,'Hayyal B','585223',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31643,99,'Hayyal K','585223',1,0,'2022-03-03 12:35:01','2022-03-03 12:35:01'),(31644,99,'Hebbal.B','585215',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31645,99,'Hedgimudra','585202',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31646,99,'Hegganadoddi','585216',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31647,99,'Hemnoor','585304',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31648,99,'Hireanur','585221',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31649,99,'Hiremudnoor','585216',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31650,99,'Hongera','585202',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31651,99,'Hoskera','585309',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31652,99,'Hothpeth','585287',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31653,99,'Hunasgi','585215',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31654,99,'Hunsihole','585290',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31655,99,'Hurusgundagi','585223',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31656,99,'Ibrahimpur','585223',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31657,99,'Idloor','585315',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31658,99,'Itkal','585214',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31659,99,'Jaigram','585315',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31660,99,'Jalibenchi','585290',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31661,99,'Jamalapur','585291',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31662,99,'Jinkera','585321',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31663,99,'Joganbhavi','585237',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31664,99,'Kadamgera','585319',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31665,99,'Kadechur','585221',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31666,99,'Kakalwar','585214',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31667,99,'Kakkera','585215',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31668,99,'Kalabelagundi','585315',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31669,99,'Kamanatagi','585291',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31670,99,'Kanagadda','585214',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31671,99,'Kandakur','585321',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31672,99,'Kanekal','585221',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31673,99,'Kanhalli','585290',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31674,99,'Kannekollur','585323',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31675,99,'Karangi','585315',1,0,'2022-03-03 12:35:02','2022-03-03 12:35:02'),(31676,99,'Katagi Shahapur','585202',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31677,99,'Kavadimatti','585290',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31678,99,'Kawalur','585202',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31679,99,'Kembhavi','585216',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31680,99,'Kembhavi Sanjeev Nagar','585216',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31681,99,'Keshwar','585214',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31682,99,'Khanapur','585319',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31683,99,'Killankera','585221',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31684,99,'Kodekal','585237',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31685,99,'Koilur','585202',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31686,99,'Kolihal','585215',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31687,99,'Kollur','585304',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31688,99,'Konekal','585321',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31689,99,'Kongandi','585304',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31690,99,'Konhal','585290',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31691,99,'Konkal','585355',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31692,99,'Kotgera','585214',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31693,99,'Kumbarpeth','585290',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31694,99,'Laxmipur','585304',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31695,99,'Madarkal','585223',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31696,99,'Maddarki','585287',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31697,99,'Madhwar','585315',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31698,99,'Malgatti','585216',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31699,99,'Malhar','585221',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31700,99,'Malla B','585216',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31701,99,'Malnoor','585215',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31702,99,'Mangalore','585290',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31703,99,'Manikgiri','585214',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31704,99,'Marnal','585237',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31705,99,'Medak','585214',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31706,99,'Minaspur','585321',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31707,99,'Mitatipdampalli','585214',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31708,99,'Motanhalli','585214',1,0,'2022-03-03 12:35:03','2022-03-03 12:35:03'),(31709,99,'Mudbal','585287',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31710,99,'Mudnal','585202',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31711,99,'Mundarga','585202',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31712,99,'Mungal','585221',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31713,99,'Munirbommanahalli','585216',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31714,99,'Naganoor','585216',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31715,99,'Naikal','585319',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31716,99,'Najarapur','585214',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31717,99,'Nandepalli','585315',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31718,99,'Narayanpur (Yadgir)','585219',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31719,99,'Narayanpura','585214',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31720,99,'Nasalwai','585315',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31721,99,'Parasanahalli','585216',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31722,99,'Paspul','585321',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31723,99,'Peth Ammapur','585290',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31724,99,'Putpak','585214',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31725,99,'Rajankollur','585291',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31726,99,'Rajapur','585309',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31727,99,'Ramasamudra (Yadgir)','585321',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31728,99,'Rangampeth','585220',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31729,99,'Rastapur','585323',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31730,99,'Rotnadgi','585355',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31731,99,'Rukmapur','585290',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31732,99,'Sagar','585323',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31733,99,'Saidapur (Yadgir)','585221',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31734,99,'Shahapur (Yadgir)','585223',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31735,99,'Shahapur Town','585223',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31736,99,'Sharadahalli','585304',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31737,99,'Shelgi','585290',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31738,99,'Shettihalli','585221',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31739,99,'Shivapur','585355',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31740,99,'Shorapur','585224',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31741,99,'Shorapur Town','585224',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31742,99,'Sirwal','585223',1,0,'2022-03-03 12:35:04','2022-03-03 12:35:04'),(31743,99,'Srinivasapur','585215',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31744,99,'Sugur','585290',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31745,99,'Tadibidi','585319',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31746,99,'Tatalgera','585321',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31747,99,'Thanagundi','585202',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31748,99,'Thinthani','585290',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31749,99,'Tulmamidi','585214',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31750,99,'Tumkur','585355',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31751,99,'Tumkur','585202',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31752,99,'Ukkinal','585309',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31753,99,'Ullesugur','585202',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31754,99,'Vajjal','585215',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31755,99,'Vanadurga','585309',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31756,99,'Venkasambra','585315',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31757,99,'Waddanahalli','585202',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31758,99,'Wadgera','585355',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31759,99,'Wagingera','585290',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31760,99,'Warkanahalli','585202',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31761,99,'Yadgiri Gunj','585201',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31762,99,'Yadgiri H.O','585201',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31763,99,'Yadgiri Station','585202',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31764,99,'Yadgiri Town','585201',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31765,99,'Yadlapur','585214',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31766,99,'Yanagundi','585214',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31767,99,'Yelgi','585216',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31768,99,'Yelhar','585321',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31769,99,'Yelsetty','585315',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31770,99,'Yempad','585321',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31771,99,'Yenniwadgera','585237',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31772,99,'Yewoor','585309',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31773,100,'Achalapur','504273',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31774,100,'Ada','504293',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31775,100,'Adegaon','504307',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31776,100,'Adilabad Collectorate','504001',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31777,100,'Adilabad H.O','504001',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31778,100,'Agm Colony','504251',1,0,'2022-03-03 12:35:05','2022-03-03 12:35:05'),(31779,100,'Ainam','504273',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31780,100,'Aknepalli','504251',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31781,100,'Akoli','504309',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31782,100,'Alegaon','504201',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31783,100,'Aloor','504110',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31784,100,'Ambaripet','504202',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31785,100,'Andavelli','504296',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31786,100,'Andugulpet','504231',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31787,100,'Andukur','504109',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31788,100,'Angarajpally','504201',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31789,100,'Ankhoda','504299',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31790,100,'Ankoli','504002',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31791,100,'Annaram','504201',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31792,100,'Arepally','504204',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31793,100,'Arli (T)','504312',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31794,100,'Ashepally','504313',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31795,100,'Ashta','504101',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31796,100,'Asifabad','504293',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31797,100,'Asnad','504201',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31798,100,'Awadam','504204',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31799,100,'Babapur','504293',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31800,100,'Babasagar','504299',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31801,100,'Badampally','504205',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31802,100,'Badankurthy','504203',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31803,100,'Bambara','504295',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31804,100,'Bangalpet','504106',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31805,100,'Bansapalli','504306',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31806,100,'Bapur','504299',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31807,100,'Bareguda','504296',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31808,100,'Basar (Adilabad)','504101',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31809,100,'Bazar Hathnur','504304',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31810,100,'Beernandi','504203',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31811,100,'Bejjur','504299',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31812,100,'Bela','504309',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31813,100,'Bellalbadi','504202',1,0,'2022-03-03 12:35:06','2022-03-03 12:35:06'),(31814,100,'Bellampalli R.S.','504251',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31815,100,'Bellampalli','504251',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31816,100,'Beltharoda','504103',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31817,100,'Bhagyanagar (Adilabad)','504001',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31818,100,'Bhainsa (Adilabad)','504103',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31819,100,'Bharampur','504308',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31820,100,'Bheemaram','504204',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31821,100,'Bheempur','504311',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31822,100,'Bheemsari','504002',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31823,100,'Bhimini','504273',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31824,100,'Bholsa','504103',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31825,100,'Bhosi','504103',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31826,100,'Bhuktapur','504001',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31827,100,'Bhutai','504304',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31828,100,'Bibra','504273',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31829,100,'Bidrelli','504101',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31830,100,'Birsaipet','504311',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31831,100,'Birvelli','504306',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31832,100,'Boath','504304',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31833,100,'Bodepalli','504273',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31834,100,'Boregaon','504101',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31835,100,'Boregaon','504307',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31836,100,'Borigaon','504110',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31837,100,'Boyapalli','504272',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31838,100,'Brahmangaon','504101',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31839,100,'Budakalan','504251',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31840,100,'Budakurd','504251',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31841,100,'Buggaram','504323',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31842,100,'Burguda','504293',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31843,100,'Chakepalli','504272',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31844,100,'Chanda (T)','504002',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31845,100,'Chandaram','504215',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31846,100,'Chandur','504311',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31847,100,'Chaprala','504309',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31848,100,'Chata','504103',1,0,'2022-03-03 12:35:07','2022-03-03 12:35:07'),(31849,100,'Chedwai','504296',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31850,100,'Chichdhari Khanapur','504346',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31851,100,'Chichondi','504103',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31852,100,'Chincholi (B)','504110',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31853,100,'Chinchughat','504002',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31854,100,'Chinnoor','504201',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31855,100,'Chintaguda','504296',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31856,100,'Chintaguda','504205',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31857,100,'Chintakunta','504299',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31858,100,'Chintalamanepalli','504299',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31859,100,'Chintalbori','504304',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31860,100,'Chintalchanda','504310',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31861,100,'Chirrakunta','504294',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31862,100,'Chityal','504306',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31863,100,'Chityal','504202',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31864,100,'Chondi','504103',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31865,100,'Chorpalli','504313',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31866,100,'Coal Chemical Complex','504302',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31867,100,'Cotton Market','504002',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31868,100,'Dabba','504299',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31869,100,'Dandepalli','504206',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31870,100,'Dantanpalli','504311',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31871,100,'Dasnapur','504346',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31872,100,'Dasnapur Colony  D.S.O','504002',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31873,100,'Dasnapur Colony','504001',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31874,100,'Dasturabad','504202',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31875,100,'Deepaiguda','504309',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31876,100,'Dehgaon','504304',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31877,100,'Dehgaon','504273',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31878,100,'Dehgaon','504102',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31879,100,'Devaiguda','504294',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31880,100,'Devapur','504293',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31881,100,'Devapur','504308',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31882,100,'Devapur Cement Works','504218',1,0,'2022-03-03 12:35:08','2022-03-03 12:35:08'),(31883,100,'Dewalwada','504201',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31884,100,'Dhaba','504311',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31885,100,'Dhaboli','504313',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31886,100,'Dhani','504110',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31887,100,'Dhannoor','504304',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31888,100,'Dhanora(B)','504346',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31889,100,'Dharmaram','504205',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31890,100,'Dharmaraopet','504231',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31891,100,'Dhorpalli','504299',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31892,100,'Dilawarpur','504203',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31893,100,'Dilawarpur','504306',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31894,100,'Dimda','504299',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31895,100,'Dimmadurthy','504310',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31896,100,'Doderna','504103',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31897,100,'Donabanda','504207',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31898,100,'Dowdepally','504215',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31899,100,'Dugnepally','504201',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31900,100,'Dwaraka','504206',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31901,100,'Dwarakapur','504272',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31902,100,'Easgaon - V','504296',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31903,100,'Easgaon Camp','504296',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31904,100,'Echoda','504307',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31905,100,'Elegaon','504102',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31906,100,'Elvi','504102',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31907,100,'Gadapur','504209',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31908,100,'Gadchanda','504104',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31909,100,'Gadiguda','504311',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31910,100,'Gandhi Chowk (Adilabad)','504001',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31911,100,'Gangapur','504292',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31912,100,'Ghanpur','504304',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31913,100,'Ghanpur','504311',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31914,100,'Ghotkuri','504309',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31915,100,'Ginnedhari','504297',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31916,100,'Ginnera','504346',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31917,100,'Girjam','504307',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31918,100,'Girnoor','504307',1,0,'2022-03-03 12:35:09','2022-03-03 12:35:09'),(31919,100,'Girvelli','504219',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31920,100,'Gokonda','504304',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31921,100,'Gollakota','504207',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31922,100,'Golleti','504292',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31923,100,'Gonedhanora','504312',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31924,100,'Gopalpet','504110',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31925,100,'Gourapur','504346',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31926,100,'Gowliguda','504323',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31927,100,'Goyagaon','504293',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31928,100,'Grain Market (Adilabad)','504208',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31929,100,'Guda','504309',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31930,100,'Gudamamda','504311',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31931,100,'Gudem','504215',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31932,100,'Gudem','504299',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31933,100,'Gudihatnoor','504308',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31934,100,'Gudipet','504273',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31935,100,'Gudlabori','504299',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31936,100,'Gulmadugu','504109',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31937,100,'Gumma (Adilabad)','504309',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31938,100,'Gundaipet','504299',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31939,100,'Gundampalli','504306',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31940,100,'Gundi','504293',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31941,100,'Gunjala','504311',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31942,100,'Gurjal','504251',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31943,100,'Gurjamannur','504308',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31944,100,'Gurudpet','504299',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31945,100,'Harkapur','504346',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31946,100,'Harnath Colony','504296',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31947,100,'Hasnapur','504311',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31948,100,'Hathini','504273',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31949,100,'Hazipur','504207',1,0,'2022-03-03 12:35:10','2022-03-03 12:35:10'),(31950,100,'Hudkuli','504299',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31951,100,'Indanpally','504205',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31952,100,'Indaram','504216',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31953,100,'Indervelli','504346',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31954,100,'Indhani','504295',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31955,100,'Indiranagar (Adilabad)','504106',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31956,100,'Industrial Area (Adilabad)','504296',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31957,100,'Itikyal','504215',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31958,100,'Ityal','504273',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31959,100,'Jainad','504309',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31960,100,'Jainoor','504313',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31961,100,'Jaipur','504216',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31962,100,'Jajjarvelli','504251',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31963,100,'Jam','504110',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31964,100,'Jamni','504313',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31965,100,'Janakapur','504251',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31966,100,'Jandavenkatapur','504207',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31967,100,'Jangaon','504214',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31968,100,'Jannaram','504205',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31969,100,'Jatharla','504304',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31970,100,'Jawla','504102',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31971,100,'Jhary','504312',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31972,100,'Jilleda','504219',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31973,100,'Kadthal','504105',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31974,100,'Kalamadugu','504205',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31975,100,'Kallur','504109',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31976,100,'Kalwa','504306',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31977,100,'Kalwada','504273',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31978,100,'Kalyani Khani','504231',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31979,100,'Kamalkot','504310',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31980,100,'Kamole','504102',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31981,100,'Kampamediguda','504002',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31982,100,'Kanchanpalli','504313',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31983,100,'Kanchevelli','504219',1,0,'2022-03-03 12:35:11','2022-03-03 12:35:11'),(31984,100,'Kankapur','504101',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(31985,100,'Kannepalli','504297',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(31986,100,'Kannepalli','504219',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(31987,100,'Kannergaon','504293',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(31988,100,'Kapparla','504312',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(31989,100,'Karanji','504312',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(31990,100,'Karathwada','504304',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(31991,100,'Karjavelli','504299',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(31992,100,'Karjibheempur','504273',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(31993,100,'Karnamamidi','504207',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(31994,100,'Kasba (Adilabad)','504106',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(31995,100,'Kasipet','504231',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(31996,100,'Kerameri','504293',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(31997,100,'Keslapur','504346',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(31998,100,'Khairdatwa','504311',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(31999,100,'Khairgaon','504292',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(32000,100,'Khamana','504295',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(32001,100,'Khanapur (Adilabad)','504203',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(32002,100,'Khirdi','504295',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(32003,100,'Khodad','504002',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(32004,100,'Khogdur','504309',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(32005,100,'Kirgul','504101',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(32006,100,'Kistampet','504204',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(32007,100,'Kistapur','504216',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(32008,100,'Kistapur','504205',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(32009,100,'Kokasmannur','504307',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(32010,100,'Kolhari','504308',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(32011,100,'Kollur','504201',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(32012,100,'Kolur','504102',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(32013,100,'Kommera','504201',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(32014,100,'Kondampally','504292',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(32015,100,'Koora','504309',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(32016,100,'Koratkal','504323',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(32017,100,'Kortakal','504310',1,0,'2022-03-03 12:35:12','2022-03-03 12:35:12'),(32018,100,'Korvichelma','504215',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32019,100,'Kosai R.S.','504312',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32020,100,'Kotapalli','504214',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32021,100,'Kothalgaon','504103',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32022,100,'Kothapalli','504311',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32023,100,'Kothmeer','504273',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32024,100,'Koutha (B)','504304',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32025,100,'Koutla (K)','504106',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32026,100,'Koutla','504110',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32027,100,'Kowthala','504299',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32028,100,'Kubeer','504103',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32029,100,'Kuchanpally','504105',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32030,100,'Kuchlapur','504304',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32031,100,'Kuchlapur','504312',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32032,100,'Kumhari','504323',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32033,100,'Kundaram','504216',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32034,100,'Kuntala','504109',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32035,100,'Kushnepalli','504219',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32036,100,'Kyathanpalli','504301',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32037,100,'Kyathanpally','504214',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32038,100,'Lachampur','504309',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32039,100,'Lakkaram','504311',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32040,100,'Laxmanchanda','504106',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32041,100,'Laxmipur','504207',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32042,100,'Limba (K)','504109',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32043,100,'Lingapur','504202',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32044,100,'Lingapur','504206',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32045,100,'Lingapur','504313',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32046,100,'Lingi','504312',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32047,100,'Lohesra','504104',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32048,100,'Lonavelli','504299',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32049,100,'Luxettipet','504215',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32050,100,'M.G. Road','504296',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32051,100,'Madapur','504105',1,0,'2022-03-03 12:35:13','2022-03-03 12:35:13'),(32052,100,'Madaram Township','504220',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32053,100,'Madaripeta','504206',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32054,100,'Maddikal','504204',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32055,100,'Maddipadaga','504202',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32056,100,'Mahagaon','504103',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32057,100,'Mahagaon','504313',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32058,100,'Mahalingi','504103',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32059,100,'Malak Chincholi','504110',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32060,100,'Malegoan','504103',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32061,100,'Mallampet','504214',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32062,100,'Mallapur','504106',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32063,100,'Malledi','504273',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32064,100,'Malyal','504307',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32065,100,'Mamda','504310',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32066,100,'Mamidighat','504204',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32067,100,'Mamidipalli','504206',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32068,100,'Mamidipalli','504313',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32069,100,'Mancherial Bazar','504208',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32070,100,'Mancherial Cement Works','504209',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32071,100,'Mancherial H.O','504208',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32072,100,'Mandamarri Colleries','504231',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32073,100,'Mandamarri R.S.','504231',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32074,100,'Mandapalli','504203',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32075,100,'Mangi','504297',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32076,100,'Manikyapur','504297',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32077,100,'Manjulapur','504106',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32078,100,'Mankapur','504311',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32079,100,'Manmad','504104',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32080,100,'Marlapally','504304',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32081,100,'Marlawai','504313',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32082,100,'Marthidi','504299',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32083,100,'Mavala','504002',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32084,100,'Medpalli','504310',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32085,100,'Metpalli','504219',1,0,'2022-03-03 12:35:14','2022-03-03 12:35:14'),(32086,100,'Metpally','504251',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32087,100,'Mittapalli Jagir','504216',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32088,100,'Modela','504215',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32089,100,'Modi','504293',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32090,100,'Mogardhagar','504299',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32091,100,'Moindagudipet','504297',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32092,100,'Moogavelli','504299',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32093,100,'Mosam','504296',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32094,100,'Movad','504293',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32095,100,'Mudhole','504102',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32096,100,'Mujgi','504306',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32097,100,'Mukhra (B)','504307',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32098,100,'Mulkala','504209',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32099,100,'Mulkalpet','504214',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32100,100,'Mulmadugu','504205',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32101,100,'Munial','504202',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32102,100,'Munjampalli','504299',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32103,100,'Muthnur','504346',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32104,100,'Muthnur','504308',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32105,100,'Muthyampet','504299',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32106,100,'Mylaram','504219',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32107,100,'Nachan Yelcapur','504203',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32108,100,'Nagalkonda','504311',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32109,100,'Nagapur','504311',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32110,100,'Nagapur','504201',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32111,100,'Nakkalapally','504214',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32112,100,'Nambal','504292',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32113,100,'Namnoor','504207',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32114,100,'Nandarampally','504214',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32115,100,'Narayanpur','504292',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32116,100,'Narnoor','504311',1,0,'2022-03-03 12:35:15','2022-03-03 12:35:15'),(32117,100,'Narsapur','504307',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32118,100,'Narsapur','504346',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32119,100,'Narsapur (Adilabad)','504104',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32120,100,'Naseerabad','504204',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32121,100,'Naspur','504302',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32122,100,'Natrajnagar','504106',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32123,100,'Navegaon','504292',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32124,100,'Neelwai','504214',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32125,100,'Nennel','504219',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32126,100,'Neradigonda','504323',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32127,100,'Netnoor','504313',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32128,100,'New Pipri','504104',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32129,100,'Nigwa','504103',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32130,100,'Nirala','504309',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32131,100,'Nirmal (Adilabad)','504106',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32132,100,'Ola','504109',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32133,100,'Old Town','504296',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32134,100,'Ootnur','504311',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32135,100,'Ootsurangapalli','504299',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32136,100,'Pakpatla','504105',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32137,100,'Palli (B)','504308',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32138,100,'Panchagudi','504104',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32139,100,'Pangdi','504313',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32140,100,'Pangidimadra','504297',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32141,100,'Papannapet','504299',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32142,100,'Pardi (B)','504103',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32143,100,'Pardi (K)','504304',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32144,100,'Pardi','504299',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32145,100,'Parimandal','504310',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32146,100,'Parpally','504201',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32147,100,'Parpally','504105',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32148,100,'Patha Mancherial','504208',1,0,'2022-03-03 12:35:16','2022-03-03 12:35:16'),(32149,100,'Patha Yelcapur','504203',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32150,100,'Patnapur','504304',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32151,100,'Patnapur','504311',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32152,100,'Peddampet','504207',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32153,100,'Peddapet','504206',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32154,100,'Peddur','504202',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32155,100,'Peechara','504105',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32156,100,'Pegdapally','504216',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32157,100,'Pembi','504203',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32158,100,'Penchikalpet','504296',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32159,100,'Pendalwada','504309',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32160,100,'Pendapally','504109',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32161,100,'Perkapally','504251',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32162,100,'Phulara','504313',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32163,100,'Pippaldhari','504002',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32164,100,'Pippalkoti','504312',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32165,100,'Pipri','504346',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32166,100,'Pipri','504307',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32167,100,'Pochera','504304',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32168,100,'Pochera','504002',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32169,100,'Pokkur','504201',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32170,100,'Police Colony','504251',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32171,100,'Ponkal','504310',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32172,100,'Ponkal','504205',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32173,100,'Ponkur','504110',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32174,100,'Ponnaram','504216',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32175,100,'Ponnari','504002',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32176,100,'Powna','504307',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32177,100,'Pownur','504216',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32178,100,'Pulimadugu','504346',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32179,100,'Pulsi','504103',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32180,100,'Puspur','504102',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32181,100,'Qawal','504205',1,0,'2022-03-03 12:35:17','2022-03-03 12:35:17'),(32182,100,'Raipally','504207',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32183,100,'Raipur Kandli','504104',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32184,100,'Rajura','504310',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32185,100,'Rajura','504104',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32186,100,'Ramai','504002',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32187,100,'Ramakrishnapur','504301',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32188,100,'Rampur','504306',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32189,100,'Rampur','504307',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32190,100,'Rasimetta','504313',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32191,100,'Raspalli','504296',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32192,100,'Ratnapur Kandli','504106',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32193,100,'Rebbanapally','504215',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32194,100,'Rebbena','504219',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32195,100,'Rebbena','504299',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32196,100,'Rebbena','504292',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32197,100,'Rechini','504273',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32198,100,'Repallewada','504272',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32199,100,'Revojipet','504202',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32200,100,'RGU IIIT Campus Basar','504107',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32201,100,'Rompalli','504297',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32202,100,'Rp Colony','504296',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32203,100,'Ruyyadi','504312',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32204,100,'Saidpur','504002',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32205,100,'Salewada','504346',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32206,100,'Sangvi','504311',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32207,100,'Sangvi','504309',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32208,100,'Sanjeevnagar','504296',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32209,100,'Sarangapur','504110',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32210,100,'Sathanapalli','504203',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32211,100,'Sawapur','504309',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32212,100,'Sawli','504103',1,0,'2022-03-03 12:35:18','2022-03-03 12:35:18'),(32213,100,'Shampur','504346',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32214,100,'Shantapur','504308',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32215,100,'Shanthi Khani','504251',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32216,100,'Shetpally','504216',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32217,100,'Shettihadapnur','504313',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32218,100,'Siddalkunta','504105',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32219,100,'Singapur','504302',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32220,100,'Sirchelma','504307',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32221,100,'Sirgapur','504306',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32222,100,'Sirkonda','504307',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32223,100,'Sirpur (T)','504299',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32224,100,'Sirpur (U)','504313',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32225,100,'Sirpur Khagaznagar','504296',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32226,100,'Sirsa','504201',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32227,100,'Sirsanna','504309',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32228,100,'Sitagondi','504308',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32229,100,'Soan','504105',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32230,100,'Soanpally','504307',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32231,100,'Somagudem Coal Mines','504251',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32232,100,'Somanpally','504201',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32233,100,'Sonala','504304',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32234,100,'Sonari','504103',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32235,100,'Srirampur Colony','504303',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32236,100,'Station Road (Adilabad)','504001',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32237,100,'Suddal','504204',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32238,100,'Sunkidi','504312',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32239,100,'Sunkli','504109',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32240,100,'Surdapur','504293',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32241,100,'Surjapur','504203',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32242,100,'Tadihadapnur','504311',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32243,100,'Talamadri','504307',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32244,100,'Talamadugu','504312',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32245,100,'Tallapet','504206',1,0,'2022-03-03 12:35:19','2022-03-03 12:35:19'),(32246,100,'Talodi','504299',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32247,100,'Tamsi','504312',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32248,100,'Tandra','504310',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32249,100,'Tandur (A)','504272',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32250,100,'Tantoli','504002',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32251,100,'Tanur','504102',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32252,100,'Tapalpur','504206',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32253,100,'Tarnam','504323',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32254,100,'Tekumatla','504216',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32255,100,'Tembi','504307',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32256,100,'Thammapur','504109',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32257,100,'Thimmapur','504209',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32258,100,'Tiryani','504297',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32259,100,'Tosham','504308',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32260,100,'Toyaguda','504002',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32261,100,'Tumpalli','504294',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32262,100,'Tungeda','504296',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32263,100,'Udumpur','504205',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32264,100,'Ullipittadorli','504294',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32265,100,'Umri','504346',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32266,100,'Ushegaon','504313',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32267,100,'Velagnur','504215',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32268,100,'Vemanpally','504214',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32269,100,'Vempalli','504296',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32270,100,'Vempalli','504209',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32271,100,'Vengwapet','504110',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32272,100,'Venkatapur','504106',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32273,100,'Venkatapur','504219',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32274,100,'Venkatapur','504206',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32275,100,'Venkatraopet','504215',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32276,100,'Waddial','504106',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32277,100,'Waddur','504323',1,0,'2022-03-03 12:35:20','2022-03-03 12:35:20'),(32278,100,'Wadgaon','504346',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32279,100,'Waghapur','504308',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32280,100,'Wankidi','504323',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32281,100,'Wankidi','504295',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32282,100,'Wegaon','504251',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32283,100,'Wellal','504216',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32284,100,'Yapalguda','504002',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32285,100,'Yedbid','504102',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32286,100,'Yellapalli','504106',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32287,100,'Yellaram','504293',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32288,100,'Yellawath','504101',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32289,100,'Yelmal','504105',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32290,100,'Yenda','504346',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32291,101,'A.Gs Office','500004',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32292,101,'A.Gs. Staff Quarters','500045',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32293,101,'Anandnagar (Hyderabad)','500004',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32294,101,'AP Police Academy PO','500091',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32295,101,'Banjara Hills','500034',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32296,101,'Bazarghat (Hyderabad)','500004',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32297,101,'Bhaskar Nagar','500075',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32298,101,'C.B.I.T','500075',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32299,101,'Central Secretariat','500022',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32300,101,'CUC','500046',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32301,101,'Cyberabad','500081',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32302,101,'Dargah Hussain Shahwali','500008',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32303,101,'Dr.B R Ambedkar O.U ','500033',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32304,101,'Erragadda','500018',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32305,101,'Film Nagar','500096',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32306,101,'Gagan Mahal','500029',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32307,101,'Gandhi Bhawan (Hyderabad)','500001',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32308,101,'Golconda','500008',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32309,101,'Himayathnagar','500029',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32310,101,'Humayunnagar','500028',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32311,101,'Hyder Shah Kote','500008',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32312,101,'Hydershahkote','500091',1,0,'2022-03-03 12:35:21','2022-03-03 12:35:21'),(32313,101,'I.M.Colony','500082',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32314,101,'Ibrahim Bagh Lines','500031',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32315,101,'Jubilee Hills','500033',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32316,101,'Kakatiya Nagar','500008',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32317,101,'Karwan Sahu','500006',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32318,101,'Khairatabad H.O','500004',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32319,101,'Kothaguda (K.V.Rangareddy)','500084',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32320,101,'Kulsumpura','500006',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32321,101,'LIC Division','500063',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32322,101,'Lunger House','500008',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32323,101,'Madhapur','500081',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32324,101,'Mangalhat','500006',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32325,101,'Manikonda','500089',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32326,101,'Manuu','500032',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32327,101,'Moazzampura','500001',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32328,101,'Murad Nagar (Hyderabad)','500028',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32329,101,'Nanakramguda','500008',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32330,101,'Narayanguda','500029',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32331,101,'New Mla Quarters','500063',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32332,101,'Parishram Bhawan','500004',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32333,101,'Putlibowli','500095',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32334,101,'Raj Bhawan (Hyderabad)','500041',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32335,101,'Ramakrishna Mutt','500029',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32336,101,'Sakkubai Nagar','500008',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32337,101,'Sanath Nagar Colony','500018',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32338,101,'Sanathnagar I E','500018',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32339,101,'Sanjeev Reddy Nagar','500038',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32340,101,'Seetharampet','500001',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32341,101,'Shantinagar (Hyderabad)','500028',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32342,101,'Somajiguda','500082',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32343,101,'Srinagar Colony','500073',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32344,101,'State Bank Of Hyderabad','500001',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32345,101,'State Bank Of India','500095',1,0,'2022-03-03 12:35:22','2022-03-03 12:35:22'),(32346,101,'Toli Chowki','500008',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32347,101,'Vengal Rao Nagar','500038',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32348,101,'Vidhan Sabha (Hyderabad)','500004',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32349,101,'Vijay Nagar Colony (Hyderabad)','500057',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32350,101,'Vivekananda Nagar Colony','500018',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32351,101,'Yousufguda','500045',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32352,101,'Hyderabad G.P.O.','500001',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32353,101,'Ambernagar','500044',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32354,101,'Amberpet','500013',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32355,101,'Andhra Mahila Sabha','500044',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32356,101,'Badangpet','500058',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32357,101,'Bahadurpura','500064',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32358,101,'Barkatpura','500027',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32359,101,'Begumbazar','500012',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32360,101,'Boduppal','500092',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32361,101,'Crp Camp (Hyderabad)','500005',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32362,101,'Darushifa','500024',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32363,101,'Don Bosco Nagar','500086',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32364,101,'Falaknuma','500053',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32365,101,'Fatehdarwaza','500065',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32366,101,'Gayatri Nagar','500097',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32367,101,'Gsi(Sr) Bandlaguda','500068',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32368,101,'High Court (Hyderabad)','500066',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32369,101,'Hindustan Cables Ltd','500051',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32370,101,'Hussainialam','500064',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32371,101,'Hyderabad Jubilee H.O','500002',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32372,101,'Hyderabad Public School','500013',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32373,101,'Hyderguda','500048',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32374,101,'I.E.Nacharam','500076',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32375,101,'Kanchanbagh','500058',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32376,101,'Kattedan Ie','500077',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32377,101,'Keshogiri','500005',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32378,101,'Kishanbagh','500064',1,0,'2022-03-03 12:35:23','2022-03-03 12:35:23'),(32379,101,'Kismathpur','500030',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32380,101,'L B Nagar','500074',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32381,101,'Malakpet Colony','500036',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32382,101,'Mamidipalli','500005',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32383,101,'Medipalli','500098',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32384,101,'Meerpet','500097',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32385,101,'Moghalpura','500002',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32386,101,'Nallakunta','500044',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32387,101,'New Nallakunta','500044',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32388,101,'Nimboliadda','500027',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32389,101,'Old Malakpet','500036',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32390,101,'Osmannagar (Hyderabad)','500036',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32391,101,'P & T Colony (K.V.Rangareddy)','500060',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32392,101,'Peerzadiguda','500039',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32393,101,'R.C.Imarat','500069',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32394,101,'Rajendranagar (K.V.Rangareddy)','500030',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32395,101,'Sahifa','500024',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32396,101,'Saidabad Colony','500059',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32397,101,'Saidabad (Hyderabad)','500059',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32398,101,'Santoshnagar Colony','500059',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32399,101,'Saroornagar','500035',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32400,101,'Seminary','500013',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32401,101,'Shahalibanda','500065',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32402,101,'Srinivasapuram (Hyderabad)','500013',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32403,101,'Sripuram Colony','500036',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32404,101,'Stn Kachiguda H.O','500027',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32405,101,'Svpnpa','500052',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32406,101,'Tadbun','500064',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32407,101,'Uppuguda','500053',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32408,101,'Vaishalinagar','500079',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32409,101,'Vanastalipuram','500070',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32410,101,'Vidyanagar (Hyderabad)','500044',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32411,101,'Yakutpura','500023',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32412,101,'Zindatelismath','500013',1,0,'2022-03-03 12:35:24','2022-03-03 12:35:24'),(32413,101,'Administrative Buildings','500007',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32414,101,'Airforce Academy','500043',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32415,101,'Aliabad','500101',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32416,101,'Allampalli.','501102',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32417,101,'Alwal','500010',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32418,101,'Anandbagh','500047',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32419,101,'Anantaram','500101',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32420,101,'Ankireddipalli','501301',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32421,101,'Ankushapur','501301',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32422,101,'Aoc Records','500015',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32423,101,'Aphb Colony Moulali','500040',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32424,101,'Ashoknagar (Hyderabad)','500020',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32425,101,'Bahadurpalli','500043',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32426,101,'Balanagar Township','500037',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32427,101,'Begumpet Policelines','500003',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32428,101,'Begumpet','500016',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32429,101,'BITS','500078',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32430,101,'Bogaram','501301',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32431,101,'Bolarum Bazar','500010',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32432,101,'Bolarum','500010',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32433,101,'Bowenpally','500011',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32434,101,'Chandanagar','500050',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32435,101,'Cherial','501301',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32436,101,'Cherlapalli','501301',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32437,101,'CIE Balangar','500037',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32438,101,'CRPF','500078',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32439,101,'Dabirpur','501401',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32440,101,'Dr As Rao Nagar','500062',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32441,101,'Ecil','500062',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32442,101,'EME Records','500015',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32443,101,'Gajularamaram','500055',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32444,101,'Gandhinagar (Hyderabad)','500080',1,0,'2022-03-03 12:35:25','2022-03-03 12:35:25'),(32445,101,'Girmapur','501401',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32446,101,'Golconda Chowrastha','500020',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32447,101,'Gowdavalli','501401',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32448,101,'Haiglines','500010',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32449,101,'Hakimpet','500014',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32450,101,'Hal (Hyderabad)','500042',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32451,101,'Hanumanpet','500047',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32452,101,'Himmatnagar','500025',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32453,101,'HMT Township','500054',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32454,101,'IDA Jeedimetla','500055',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32455,101,'Ie Moulali','500040',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32456,101,'IICT','500007',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32457,101,'Jaggamguda','500101',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32458,101,'Jai Jawan Colony','500062',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32459,101,'Jama I Osmania','500007',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32460,101,'Jawahar Nagar','500087',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32461,101,'JJ Nagar Colony','500087',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32462,101,'Jntu Kukat Pally','500085',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32463,101,'Katchavanisingaram','500088',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32464,101,'Keesara','501301',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32465,101,'Keesaragutta','501301',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32466,101,'Kingsway','500003',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32467,101,'Kolthur','500101',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32468,101,'Komplly','500100',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32469,101,'Korremal','500088',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32470,101,'Kowkoor','500010',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32471,101,'KPHB Colony','500085',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32472,101,'Kukatpally','500072',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32473,101,'Kushaiguda','500062',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32474,101,'Kutbullapur','500055',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32475,101,'Kyasaram','500101',1,0,'2022-03-03 12:35:26','2022-03-03 12:35:26'),(32476,101,'Lalgadi Malakpet','500101',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32477,101,'Lallaguda','500017',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32478,101,'Lallapet','500017',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32479,101,'Malkajgiri','500047',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32480,101,'Manovikasnagar','500009',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32481,101,'MG Road','500003',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32482,101,'Miyapur','500049',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32483,101,'Moulali','500040',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32484,101,'Mudchintanapalli','500101',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32485,101,'Musheerabad (Delivery)','500020',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32486,101,'Musheerabad (ND)','500020',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32487,101,'Nagaram (K.V.Rangareddy)','500083',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32488,101,'Nehrunagar (Hyderabad)','500026',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32489,101,'Neredmet','500056',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32490,101,'Ngri','500007',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32491,101,'Nisa Hakimpet','500078',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32492,101,'Nizampet ','500090',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32493,101,'Nutankal','501401',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32494,101,'Padmaraonagar','500025',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32495,101,'Peddalaxmapur','500101',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32496,101,'Picket','500009',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32497,101,'Pragatinagar','500090',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32498,101,'Prakashamnagar','500016',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32499,101,'Pratapsingaram','500088',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32500,101,'Rail Nilayam','500025',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32501,101,'Rajbolaram','501401',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32502,101,'Rajeevagruhakalpa','500088',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32503,101,'Ramakrishna Puram','500056',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32504,101,'Rampallidiara','501301',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32505,101,'Rangareddynagar','500037',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32506,101,'Ravalkol','501401',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32507,101,'Rompalli','501301',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32508,101,'Sainikpuri','500094',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32509,101,'Samskruthi','500088',1,0,'2022-03-03 12:35:27','2022-03-03 12:35:27'),(32510,101,'Secunderabad H.O','500003',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32511,101,'Shamirpet','500101',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32512,101,'Sitaphalmandi','500061',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32513,101,'Suchitra Junction','500067',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32514,101,'Suraram','500055',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32515,101,'Tarnaka','500007',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32516,101,'Thimmaipalli','501301',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32517,101,'Thumkunta','500078',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32518,101,'Trimulgherry H.O','500015',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32519,101,'Turkapalliyadaram','500101',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32520,101,'Vikarabad H.O','501101',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32521,101,'Vikasnagar (Hyderabad)','500093',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32522,101,'Vivekanandanagar Colony','500072',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32523,101,'Yadgarpalli','501301',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32524,101,'Zamistanpur','500020',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32525,102,'Dadapur','509339',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32526,102,'Mothkur','509335',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32527,102,'Pagidial','509371',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32528,102,'Peddawarval','509335',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32529,102,'Vennached','509339',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32530,102,'Ameerpet','509325',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32531,102,'Dubbacherla','509325',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32532,102,'Hythabad','509217',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32533,102,'Kalwakole','509325',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32534,102,'Manmarri','509410',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32535,102,'Mucharla','509358',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32536,102,'Sardarnagar','509217',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32537,102,'Shahabad (K.V.Rangareddy)','509217',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32538,102,'Tallapally','509217',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32539,102,'Tondapally','509325',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32540,102,'Appa Himayathsagar','500008',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32541,102,'Aziz Nagar','500075',1,0,'2022-03-03 12:35:28','2022-03-03 12:35:28'),(32542,102,'Bharat Nagar Colony','500018',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32543,102,'Fathenagar Colony','500018',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32544,102,'Gachibowli','500032',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32545,102,'Gandipet','500075',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32546,102,'Himayathnagar','500075',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32547,102,'Janwada','500075',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32548,102,'Kokapet','500075',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32549,102,'Kondapur','500084',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32550,102,'Lingampalli','500019',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32551,102,'Mancherevula','500075',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32552,102,'Moosapet','500018',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32553,102,'Narsingi','500075',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32554,102,'Swarajyanagar','500018',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32555,102,'Wattinagulapalli','500075',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32556,102,'A.G.College','500030',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32557,102,'Adibatla','501510',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32558,102,'Agapalli','501506',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32559,102,'Akulamailaram','501509',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32560,102,'Anajpur','501512',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32561,102,'Aperl','500030',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32562,102,'Arutla','501508',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32563,102,'Attapur','500048',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32564,102,'Balapur','500005',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32565,102,'Bandaraviryal','501505',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32566,102,'Batasingaram','501512',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32567,102,'Chaithanyapuri Colony','500060',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32568,102,'Cherlapatel Guda','501506',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32569,102,'Chinnagolkonda','501218',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32570,102,'Chintapatla','501509',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32571,102,'Chippalapalli','501359',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32572,102,'Chowderpalli','501509',1,0,'2022-03-03 12:35:29','2022-03-03 12:35:29'),(32573,102,'Dabbedguda','501359',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32574,102,'Dandumailaram','501508',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32575,102,'Dilsukhnagar Colony','500060',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32576,102,'Eleminedu','501506',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32577,102,'Gaganpahad','500052',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32578,102,'Gollapalli Kalan','501218',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32579,102,'Gowrelli','501505',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32580,102,'Gudur','501359',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32581,102,'Gummadavalli','501506',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32582,102,'Gungal','501506',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32583,102,'Hasannagar','500052',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32584,102,'Hayatnagar','501505',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32585,102,'Huda Residential Complex','500035',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32586,102,'Ibrahimpatnam (K.V.Rangareddy)','501506',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32587,102,'Jaitwaram','501359',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32588,102,'Japal','501508',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32589,102,'Jillellaguda','500079',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32590,102,'Kandukur','501359',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32591,102,'Kappapahad','501506',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32592,102,'Karmanghat','500079',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32593,102,'Kavadpalli','501505',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32594,102,'Koheda','501511',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32595,102,'Kongarakalan','501510',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32596,102,'Kongaraviryla','501510',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32597,102,'Kothapalli','501509',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32598,102,'Kotwalguda','501218',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32599,102,'Kuntloor','501505',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32600,102,'Kurmidda','501509',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32601,102,'Lemur','501359',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32602,102,'Lingampalli','501508',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32603,102,'Madhapur','501506',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32604,102,'Maisaram','501359',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32605,102,'Mallapur','500076',1,0,'2022-03-03 12:35:30','2022-03-03 12:35:30'),(32606,102,'Manchal','501508',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32607,102,'Mangalpalli','501510',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32608,102,'Mankhal','501359',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32609,102,'Mansoorabad','500068',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32610,102,'Manthangowd Gowrelli','501509',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32611,102,'Medipalli','501509',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32612,102,'Meerkhanpet','501509',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32613,102,'Mondigowrelli','501509',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32614,102,'Nadergul','501510',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32615,102,'Nagaram','501218',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32616,102,'Nallavalli','501509',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32617,102,'Nanajipur','501218',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32618,102,'Nandiwanaparthy','501509',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32619,102,'Narkhoda','501218',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32620,102,'Nazdiksingaram','501509',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32621,102,'Nedunur','501359',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32622,102,'Pahadishareef','500005',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32623,102,'Pasmamala','501505',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32624,102,'Pedda Amberpet','501505',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32625,102,'Pocharam','501506',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32626,102,'Polkampalli','501508',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32627,102,'Pulmamidi','501359',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32628,102,'Qutubullapur','501505',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32629,102,'Rachaloor','501359',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32630,102,'Ragannaguda X Roads','501510',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32631,102,'Raipole','501508',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32632,102,'Ramakrishanapuram','500035',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32633,102,'Ramdaspalli','501510',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32634,102,'Ramoji Film City','501512',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32635,102,'Rangapur','501508',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32636,102,'Rangareddy Dt Courts','500074',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32637,102,'Sanghinagar','501511',1,0,'2022-03-03 12:35:31','2022-03-03 12:35:31'),(32638,102,'Sarada Nagar','500070',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32639,102,'Seriguda','501510',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32640,102,'Shamshabad (K.V.Rangareddy)','501218',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32641,102,'Shivarampalli','500052',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32642,102,'Snehapuri Colony','500076',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32643,102,'Survey Of India','500039',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32644,102,'Tadlapalliguda','501508',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32645,102,'Taramatipeta','501505',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32646,102,'Tatiparthy','501509',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32647,102,'Thimmapur','501506',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32648,102,'Toolkalan','501509',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32649,102,'Toolkhurd','501509',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32650,102,'Torrur','501511',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32651,102,'Tummalur','501359',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32652,102,'Turkayamzal','501510',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32653,102,'Uppal (K.V.Rangareddy)','500039',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32654,102,'Vaidehinagar','500070',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32655,102,'Vinjapur','501510',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32656,102,'Yacharam','501509',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32657,102,'Adikcherla','501142',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32658,102,'Agnoor','501144',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32659,102,'Ainapur','501502',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32660,102,'Allapur','501141',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32661,102,'Alur','501503',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32662,102,'Amdapur','501504',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32663,102,'Amradikalan','501202',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32664,102,'Anantagiripally','501102',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32665,102,'Antaram','501503',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32666,102,'Antharam','501141',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32667,102,'Arkatala','501111',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32668,102,'Athveli','501401',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32669,102,'Atveli','501102',1,0,'2022-03-03 12:35:32','2022-03-03 12:35:32'),(32670,102,'Bachupally','500090',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32671,102,'Badampalli','501502',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32672,102,'Bandelkacherla','501502',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32673,102,'Bantwaram','501106',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32674,102,'Barwad','501106',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32675,102,'Basheerabad','501143',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32676,102,'Bennur','501144',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32677,102,'Bhulkapur','501203',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32678,102,'Bompalli','501502',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32679,102,'Bomraspet','500078',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32680,102,'Bowrampet','500043',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32681,102,'Buchampalli','501202',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32682,102,'CCI Tandur','501158',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32683,102,'Chanchalpet','501111',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32684,102,'Chandanvelly','501503',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32685,102,'Chengole','501141',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32686,102,'Chengomal','501501',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32687,102,'Chennaram','501144',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32688,102,'Chenvelli','501503',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32689,102,'Chevella','501503',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32690,102,'Chilkur','501504',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32691,102,'Chimaldari','501111',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32692,102,'Chinna Mangalaram','501504',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32693,102,'Chinnagottiga','501143',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32694,102,'Chittigadda','501111',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32695,102,'Chityal','501501',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32696,102,'CMR College (Kandlakoya)','501401',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32697,102,'Damarched','501143',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32698,102,'Damargidda','501503',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32699,102,'Devarampalli','501111',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32700,102,'Devaryamjal','500078',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32701,102,'Devnoor','501144',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32702,102,'Devuniyerravalli','501503',1,0,'2022-03-03 12:35:33','2022-03-03 12:35:33'),(32703,102,'Dhannaram','501102',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32704,102,'Dharur','501121',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32705,102,'Dhobhipet','501203',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32706,102,'Dindigul','500043',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32707,102,'Dirsampalli','501502',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32708,102,'Doma','501502',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32709,102,'Doolapalli','500100',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32710,102,'Dornal','501121',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32711,102,'Edulabad','501301',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32712,102,'Ekmamidi','501102',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32713,102,'Enkatala','501202',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32714,102,'Gagillapur','500043',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32715,102,'Gazipur','501142',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32716,102,'Gharsinghapur','501501',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32717,102,'Ghatepalli','501121',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32718,102,'Ghatkesar','501301',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32719,102,'Gingurthi','501141',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32720,102,'Girgitpalle','501102',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32721,102,'Godamguda','501102',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32722,102,'Gottimukkala','501102',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32723,102,'Gundal','501503',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32724,102,'Gunj','501141',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32725,102,'Haridasapalli','501121',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32726,102,'Indur','501142',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32727,102,'Jaidupalli','501102',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32728,102,'Jangaon','501142',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32729,102,'Jeevangi','501143',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32730,102,'Juntapalli','501144',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32731,102,'Kadcherla','501102',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32732,102,'Kalkhoda','501106',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32733,102,'Kanakamamidi','501504',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32734,102,'Kandanhalli','501141',1,0,'2022-03-03 12:35:34','2022-03-03 12:35:34'),(32735,102,'Kandlapalli','501503',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32736,102,'Kandwada','501503',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32737,102,'Kankal','501501',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32738,102,'Kanmeta','501503',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32739,102,'Karankot','501158',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32740,102,'Karvelli','501121',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32741,102,'Kasimpur','501143',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32742,102,'Kesaram','501202',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32743,102,'Kethireddipalli','501504',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32744,102,'Kistapur','501501',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32745,102,'Kodalkal','501203',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32746,102,'Kokat','501141',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32747,102,'Kolkonda','501202',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32748,102,'Kothagdi','501102',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32749,102,'Kothapalli','501106',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32750,102,'Kothapalli','501203',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32751,102,'Kothlapur','501202',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32752,102,'Kotmarpalli','501202',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32753,102,'Kotpalli','501106',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32754,102,'Kowkunta','501503',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32755,102,'Kudmoor','501501',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32756,102,'Kudvandapur','501501',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32757,102,'Kukonda','501121',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32758,102,'Kurviched','501143',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32759,102,'Madanapalli','501102',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32760,102,'Madireddipalli','501111',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32761,102,'Maharajpet','501203',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32762,102,'Mailwar','501143',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32763,102,'Malasomaram','501106',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32764,102,'Malkapur','501158',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32765,102,'Malkapur','501503',1,0,'2022-03-03 12:35:35','2022-03-03 12:35:35'),(32766,102,'Malwardevrampalli','501102',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32767,102,'Manchanpalli','501501',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32768,102,'Manneguda','501102',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32769,102,'Manthangod','501143',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32770,102,'Manthatti','501141',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32771,102,'Marpallikalan','501202',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32772,102,'Mathrusri Nagar','500049',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32773,102,'Medchal','501401',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32774,102,'Medipalli','501203',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32775,102,'Medpalli','501501',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32776,102,'Mekavanampalli','501202',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32777,102,'Mittabaspalle','501158',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32778,102,'Mittakorud','501501',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32779,102,'Moinabad','501504',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32780,102,'Mokila','501203',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32781,102,'Mombapur','501142',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32782,102,'Mominkalan','501121',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32783,102,'Mominpet','501202',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32784,102,'Morangpalli','501202',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32785,102,'Mothukapalli','501106',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32786,102,'Mubarakpur','501203',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32787,102,'Mudgul Chittempalle','501102',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32788,102,'Mudimial','501503',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32789,102,'Mujahidpur','501502',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32790,102,'Munnur Somaram','501102',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32791,102,'Nagasamunder','501106',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32792,102,'Nagawaram','501121',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32793,102,'Nagulapalli','501142',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32794,102,'Narayanpur','501141',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32795,102,'Naskal','501501',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32796,102,'Navalga','501143',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32797,102,'Nawabpet (K.V.Rangareddy)','501111',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32798,102,'Nizampet Medpalli','501501',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32799,102,'Nyalata','501503',1,0,'2022-03-03 12:35:36','2022-03-03 12:35:36'),(32800,102,'Orella','501503',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32801,102,'Pagdyal','501144',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32802,102,'Pamena','501503',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32803,102,'Panchalingal','501202',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32804,102,'Parveda','501203',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32805,102,'Patloor','501202',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32806,102,'Peda Umenthyal','501501',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32807,102,'Pedda Mangalaram','501504',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32808,102,'Peddimal','501142',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32809,102,'Peta Madaram','501501',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32810,102,'Phulmaddi','501102',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32811,102,'Pochampally','500100',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32812,102,'Ponnal','500078',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32813,102,'Proddatur','501203',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32814,102,'Pudur','501102',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32815,102,'Pudur','501401',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32816,102,'Pulapalli','501102',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32817,102,'Pulmamidi','501111',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32818,102,'Pulusmamidi','501102',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32819,102,'Purgi','501501',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32820,102,'Ramanathgudpally','501102',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32821,102,'Ramapur','501106',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32822,102,'Rasnam','501121',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32823,102,'Ravulapalli','501106',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32824,102,'Regad Ghanapur','501503',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32825,102,'Regadi Doswada','501501',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32826,102,'Regondi','501142',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32827,102,'Riapol','501501',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32828,102,'Rompalli','501106',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32829,102,'Rupkhanpet','501501',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32830,102,'Salbathapur','501106',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32831,102,'Sangamkalan','501158',1,0,'2022-03-03 12:35:37','2022-03-03 12:35:37'),(32832,102,'Shankarpalli','501203',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32833,102,'Siddaloor','501102',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32834,102,'Singapur','501203',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32835,102,'Sirpura','501202',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32836,102,'Sivareddipalli','501502',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32837,102,'Sivareddypet','501102',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32838,102,'Somangurthi','501501',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32839,102,'Srirangavaram','500043',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32840,102,'Sultanpur','501501',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32841,102,'Surangal','501504',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32842,102,'Syedpalli','501501',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32843,102,'Tandur','501141',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32844,102,'Tangadpalli','501503',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32845,102,'Tangutoor','501203',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32846,102,'Tarigopula','501121',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32847,102,'Tekulapalli','501202',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32848,102,'Thattepalli','501142',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32849,102,'Thummalapalli','501202',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32850,102,'Timmaipalli','501144',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32851,102,'Turmamidi','501142',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32852,102,'Uddemarri','500078',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32853,102,'Velchal','501202',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32854,102,'Venkatadri','500088',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32855,102,'Venkatapur','501504',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32856,102,'Wootpalli','501502',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32857,102,'Yakmai','501143',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32858,102,'Yalal','501144',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32859,102,'Yellakonda','501203',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32860,102,'Yelvawthy','501203',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32861,102,'Yenkepalle','501106',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32862,102,'Yennaram','501106',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32863,103,'Achampalli','505445',1,0,'2022-03-03 12:35:38','2022-03-03 12:35:38'),(32864,103,'Adivipadira','505305',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32865,103,'Aggimalla','505532',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32866,103,'Ailapur','505330',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32867,103,'Aithpalli','505531',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32868,103,'Akkannapet','505466',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32869,103,'Algunur','505527',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32870,103,'Allipur','505460',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32871,103,'Almaspur','505305',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32872,103,'Ambaripet','505526',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32873,103,'Ambaripet','505306',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32874,103,'Ammakkapet','505450',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32875,103,'Ananthagiri','505402',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32876,103,'Ananthapalli','505524',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32877,103,'Anantharam','505402',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32878,103,'Annaram','505469',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32879,103,'Anpur','505302',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32880,103,'Anthakpet','505466',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32881,103,'Anthergaon','505455',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32882,103,'Arepalli','505001',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32883,103,'Arevelli','505452',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32884,103,'Arnakonda','505415',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32885,103,'Arpapalli','505529',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32886,103,'Asifnagar','505401',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32887,103,'Atmakur','505325',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32888,103,'Atmakur','505526',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32889,103,'Badnapalli','505405',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32890,103,'Balarajpalli','505403',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32891,103,'Balwanthapur','505452',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32892,103,'Bandalingampalli','505303',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32893,103,'Bandankal','505404',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32894,103,'Bandapalli','505403',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32895,103,'Baswapur','505405',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32896,103,'Baswapur','505473',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32897,103,'Bathkapalli','505532',1,0,'2022-03-03 12:35:39','2022-03-03 12:35:39'),(32898,103,'Bavasaipet','505403',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32899,103,'Beerpur','505454',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32900,103,'Bejjanki','505528',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32901,103,'Bheemaram','505453',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32902,103,'Bhoopalapatnam','505415',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32903,103,'Bhoopathipur','505460',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32904,103,'Bhushanraopet','505462',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32905,103,'Boenpalli','505524',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32906,103,'Bommakal','505001',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32907,103,'Bommena','505306',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32908,103,'Bonala','505301',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32909,103,'Bornapalli','505460',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32910,103,'Buggaram','505454',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32911,103,'Chakunta','505415',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32912,103,'Chandoli','505532',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32913,103,'Chandrampet','505301',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32914,103,'Chandurthi','505403',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32915,103,'Chavulamaddi','505325',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32916,103,'Cheelapur','505473',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32917,103,'Cheerlavancha','505402',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32918,103,'Chegurthi','505001',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32919,103,'Chekkapalli','505302',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32920,103,'Chekode','505404',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32921,103,'Chelgal','505455',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32922,103,'Chengerla','505469',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32923,103,'Cheppial','505501',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32924,103,'Chigurumamidi','505467',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32925,103,'Chilvakodur','505532',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32926,103,'Chinnalingapur','505405',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32927,103,'Chinnametpalli','505453',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32928,103,'Chintakunta','505462',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32929,103,'Chintalathana','505405',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32930,103,'Chinthakunta','505001',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32931,103,'Chittapur','505331',1,0,'2022-03-03 12:35:40','2022-03-03 12:35:40'),(32932,103,'Chityalapalli','505415',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32933,103,'Choppadandi','505415',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32934,103,'Choutapalli','505466',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32935,103,'Collectorate Complex','505001',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32936,103,'Dabba','505450',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32937,103,'Dacharam','505405',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32938,103,'Dacharam','505528',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32939,103,'Dammannapet','505304',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32940,103,'Darur','505455',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32941,103,'Desaipet','505306',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32942,103,'Deshrajpalli','505451',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32943,103,'Dharmapuri','505425',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32944,103,'Dharmarajpalli','505331',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32945,103,'Dharmaram','505301',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32946,103,'Dist. Court Building','505001',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32947,103,'Donthapur','505425',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32948,103,'Donur','505454',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32949,103,'Dulur','505462',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32950,103,'Dumala','505303',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32951,103,'Dumpet','505462',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32952,103,'Durshed','505001',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32953,103,'Ekeenpur','505462',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32954,103,'Elgandal','505401',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32955,103,'Ellanthakunta','505402',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32956,103,'Endapalli','505526',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32957,103,'Erdandi','505450',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32958,103,'Fazilnagar','505524',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32959,103,'Gagillapur','505528',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32960,103,'Gajasingaram','505305',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32961,103,'Galipalli','505530',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32962,103,'Gambhiraopet','505304',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32963,103,'Gambirpur','505306',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32964,103,'Gandhichowk Srisilla','505301',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32965,103,'Gandhinagar','505455',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32966,103,'Gandipalli','505466',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32967,103,'Ganeervaram','505530',1,0,'2022-03-03 12:35:41','2022-03-03 12:35:41'),(32968,103,'Gangadhara','505445',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32969,103,'Garjanapalli','505305',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32970,103,'Garshakurthy','505445',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32971,103,'Gattubhuthkur','505445',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32972,103,'Gattududdenapalli','505469',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32973,103,'Godhalpet','505526',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32974,103,'Gollapalli','505305',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32975,103,'Gollapalli (Karim Nagar)','505532',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32976,103,'Gopalpur','505425',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32977,103,'Gopalraopet','505531',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32978,103,'Gorintial','505305',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32979,103,'Gouravelli','505467',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32980,103,'Govindaram','505306',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32981,103,'Gudem','505404',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32982,103,'Gudur','505325',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32983,103,'Gugilla','505528',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32984,103,'Gullakota','505526',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32985,103,'Gumlapur','505531',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32986,103,'Gundaram','505528',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32987,103,'Gundareddipalli','505473',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32988,103,'Gundi','505531',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32989,103,'Gunukula Kondapur','505530',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32990,103,'Habshipur','505454',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32991,103,'Hanmajipet','505403',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32992,103,'Husnabad (Karim Nagar)','505467',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32993,103,'Ibrahimnagar','505529',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32994,103,'Ibrahimpatnam (Karim Nagar)','505450',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32995,103,'Indurthi','505481',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32996,103,'Itikyal','505460',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32997,103,'Jabithapur','505455',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32998,103,'Jagadevpet','505526',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(32999,103,'Jaggasagar','505325',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(33000,103,'Jagtial H.O','505327',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(33001,103,'Jaina','505425',1,0,'2022-03-03 12:35:42','2022-03-03 12:35:42'),(33002,103,'Jangaon','505466',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33003,103,'Jangapalli','505530',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33004,103,'Jawaharnagar (Karim Nagar)','505001',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33005,103,'Jillella','505405',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33006,103,'Joganapalli','505460',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33007,103,'Jogapur','505307',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33008,103,'Jublikaman','505001',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33009,103,'Kachapur','505467',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33010,103,'Kalleda','505454',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33011,103,'Kallepalli','505528',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33012,103,'Kallur','505330',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33013,103,'Kalvakota','505453',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33014,103,'Kamalapur','505425',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33015,103,'Kamanpur','505001',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33016,103,'Kanagarthi','505301',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33017,103,'Kandikatkur','505401',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33018,103,'Kandlapalli','505454',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33019,103,'Kandrikala','505325',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33020,103,'Kapparaopet','505526',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33021,103,'Karimnagar H.O','505001',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33022,103,'Kathalapur','505462',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33023,103,'Katkapur','505460',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33024,103,'Katkur','505301',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33025,103,'Katkur','505466',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33026,103,'Katlakunta','505453',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33027,103,'Katnapalli','505531',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33028,103,'Keshavapur','505466',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33029,103,'Khila Jagtial','505327',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33030,103,'Kishandaspet','505303',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33031,103,'Kishanraopet','505526',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33032,103,'Kodimial','505501',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33033,103,'Kodurpaka','505402',1,0,'2022-03-03 12:35:43','2022-03-03 12:35:43'),(33034,103,'Koheda','505473',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33035,103,'Kolanur','505301',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33036,103,'Kolimikunta','505415',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33037,103,'Kolvai','505454',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33038,103,'Komatikondapur','505450',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33039,103,'Konapur','505325',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33040,103,'Konaraopet','505325',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33041,103,'Konaraopet','505301',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33042,103,'Kondapur','505453',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33043,103,'Kondapur','505526',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33044,103,'Kondapur','505303',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33045,103,'Koratla Bazar','505326',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33046,103,'Koratla','505326',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33047,103,'Koratlapet','505305',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33048,103,'Korem','505524',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33049,103,'Kothapalli','505304',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33050,103,'Kothapalli','505481',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33051,103,'Kothapalli (Karim Nagar)','505451',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33052,103,'Kothapet','505526',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33053,103,'Kuchanapalli','505467',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33054,103,'Kummarpalli','505460',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33055,103,'Kurella','505473',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33056,103,'Kurikyal','505445',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33057,103,'Laxmipur','505529',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33058,103,'Laxmipur','505531',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33059,103,'Laxmipuram','505405',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33060,103,'Left Flank Katta Rampur','505001',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33061,103,'Lingampet','505306',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33062,103,'Lingampet','505307',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33063,103,'Lingannapet','505304',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33064,103,'Lingapur','505532',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33065,103,'Lingapur','505325',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33066,103,'Lingapur','505469',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33067,103,'Lower Manair Dam Colony','505527',1,0,'2022-03-03 12:35:44','2022-03-03 12:35:44'),(33068,103,'Madampalli','505452',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33069,103,'Maddikunta','505404',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33070,103,'Maddulapalli','505452',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33071,103,'Maddutla','505452',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33072,103,'Madhapur','505330',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33073,103,'Madhunur','505425',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33074,103,'Maidpalli','505325',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33075,103,'Malakpet','505301',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33076,103,'Malkapur','505451',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33077,103,'Mallampalli','505466',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33078,103,'Mallannapet','505529',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33079,103,'Mallapur','505401',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33080,103,'Mallapur','505469',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33081,103,'Mallapur','505331',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33082,103,'Mallapur','505445',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33083,103,'Mallaram','505403',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33084,103,'Mallareddipet','505304',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33085,103,'Mallial','505307',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33086,103,'Mallial','505452',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33087,103,'Mamidipalli','505301',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33088,103,'Manair Project','505304',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33089,103,'Manakondur','505469',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33090,103,'Manala','505452',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33091,103,'Manala-i','505307',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33092,103,'Mandepalli','505405',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33093,103,'Mangala','505454',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33094,103,'Mannegudem','505462',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33095,103,'Mannempalli','505469',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33096,103,'Manwada','505401',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33097,103,'Marpaka','505302',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33098,103,'Marrigadda','505403',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33099,103,'Marripalli','505403',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33100,103,'Marthanpet','505301',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33101,103,'Medpalli','505453',1,0,'2022-03-03 12:35:45','2022-03-03 12:35:45'),(33102,103,'Mehtapur','505460',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33103,103,'Metpalli Bazar','505325',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33104,103,'Metpalli','505325',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33105,103,'Mettachittapur','505325',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33106,103,'Mirzapur','505466',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33107,103,'Mogalpet','505331',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33108,103,'Mohanraopet','505453',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33109,103,'Moodapalli','505403',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33110,103,'Mootapalli','505460',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33111,103,'Morapalli','505455',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33112,103,'Motha','505455',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33113,103,'Mothe','505531',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33114,103,'Mucherla','505304',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33115,103,'Mudimanikyam','505481',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33116,103,'Mukarampura','505001',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33117,103,'Mukshanpet','505402',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33118,103,'Mulkanur','505481',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33119,103,'Munjampalli','505469',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33120,103,'Mustabad (Karim Nagar)','505404',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33121,103,'Muthunur','505526',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33122,103,'Muthyampet','505452',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33123,103,'Muthyampet','505331',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33124,103,'Mylaram','505530',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33125,103,'Nachupalli','505501',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33126,103,'Nagaram','505301',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33127,103,'Nagireddipur','505445',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33128,103,'Nagnoor','505415',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33129,103,'Nagnur Lachakkapet','505529',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33130,103,'Nagulamallial','505401',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33131,103,'Nagumpet','505304',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33132,103,'Nakkalapet','505454',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33133,103,'Nallagonda','505481',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33134,103,'Namapur','505531',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33135,103,'Namapur','505404',1,0,'2022-03-03 12:35:46','2022-03-03 12:35:46'),(33136,103,'Namilikonda','505501',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33137,103,'Nancherla','505532',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33138,103,'Narayanapur','505303',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33139,103,'Narayanpur','505445',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33140,103,'Narayanpur','505481',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33141,103,'Narmala','505304',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33142,103,'Narsimulapalli','505454',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33143,103,'Narsingapur','505524',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33144,103,'Nawabpet','505467',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33145,103,'Nedunur','505530',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33146,103,'Nerella','505405',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33147,103,'Nerella','505454',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33148,103,'New Abadi Jagtial','505327',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33149,103,'New Bus Stand Jagtial','505455',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33150,103,'Nimmapalli','505301',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33151,103,'Nizamabad','505301',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33152,103,'Nookalamarri','505524',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33153,103,'Nookapalli','505452',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33154,103,'Nustulapur','505481',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33155,103,'Ottimalla','505524',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33156,103,'Ounur','505404',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33157,103,'Padira','505303',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33158,103,'Paidimadugu','505460',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33159,103,'Pandilla','505467',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33160,103,'Parlapalli','505469',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33161,103,'Parveda','505467',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33162,103,'Parvella','505530',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33163,103,'Peddalingapur','505405',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33164,103,'Peddapur','505325',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33165,103,'Peddapur','505415',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33166,103,'Peddur','505301',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33167,103,'Pegadapalli','505532',1,0,'2022-03-03 12:35:47','2022-03-03 12:35:47'),(33168,103,'Peggarla','505325',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33169,103,'Pembatla','505529',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33170,103,'Pochampad Project Colony','505455',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33171,103,'Polampalli','505469',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33172,103,'Polas','505529',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33173,103,'Poodur','505501',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33174,103,'Porandla','505529',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33175,103,'Porandla','505469',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33176,103,'Pormalla','505453',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33177,103,'Potharam','505467',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33178,103,'Potharam','505454',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33179,103,'Potharam','505452',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33180,103,'Potharam','505306',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33181,103,'Pothgal','505404',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33182,103,'Pothur','505401',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33183,103,'Potlapalli','505467',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33184,103,'Racherla Boppapur','505305',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33185,103,'Ragampet','505415',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33186,103,'Ragavpet','505331',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33187,103,'Raghavapatnam','505532',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33188,103,'Rahimkhanpet','505402',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33189,103,'Raichpapalli','505529',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33190,103,'Raikal','505460',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33191,103,'Raipatnam','505425',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33192,103,'Rajaram','505425',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33193,103,'Ramadugu','505531',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33194,103,'Ramajipet','505460',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33195,103,'Ramancha','505481',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33196,103,'Ramavaram','505466',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33197,103,'Ramchandrapuram','505528',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33198,103,'Ramnagar (Karim Nagar)','505001',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33199,103,'Rampur','505452',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33200,103,'Rampur','505001',1,0,'2022-03-03 12:35:48','2022-03-03 12:35:48'),(33201,103,'Ramsagar(Dabbathimmayapalli)','505501',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33202,103,'Rapalli','505532',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33203,103,'Ratnapur','505331',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33204,103,'Regonda','505467',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33205,103,'Regulapalli','505473',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33206,103,'Renikunta','505530',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33207,103,'Repaka','505528',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33208,103,'Revelli','505415',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33209,103,'Rudrangi','505307',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33210,103,'Rudraram','505531',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33211,103,'Rudraram','505402',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33212,103,'Rukmapur','505415',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33213,103,'Ryalapalli','505531',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33214,103,'Samudrala','505467',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33215,103,'Samudralingapur','505305',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33216,103,'Sangula','505307',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33217,103,'Sankepalli','505302',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33218,103,'Sarampalli','505405',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33219,103,'Sarangapur','505454',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33220,103,'Sarvareddypalli','505531',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33221,103,'Sataram','505331',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33222,103,'Satrajpalli','505302',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33223,103,'Shakkella','505532',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33224,103,'Shanagar','505531',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33225,103,'Shanigaram','505473',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33226,103,'Sharwapuram','505452',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33227,103,'Sirikonda (Karim Nagar)','505462',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33228,103,'Siripuram','505331',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33229,103,'Sirkonda','505425',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33230,103,'Sirsilla','505301',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33231,103,'Srigadha','505304',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33232,103,'Sriramulapalli','505467',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33233,103,'Stambampalli','505526',1,0,'2022-03-03 12:35:49','2022-03-03 12:35:49'),(33234,103,'Stambampalli','505302',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33235,103,'Suddala','505302',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33236,103,'Sunderagiri','505467',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33237,103,'Tadagonda','505524',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33238,103,'Tadoor','505405',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33239,103,'Takkallapalli','505454',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33240,103,'Takkallapalli','505462',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33241,103,'Tallapalli','505530',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33242,103,'Tandrial','505306',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33243,103,'Tangallapalli','505405',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33244,103,'Tattupalli','505452',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33245,103,'Terlamaddi','505404',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33246,103,'Thakkallapalli','505452',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33247,103,'Thangallapalli','505473',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33248,103,'Thatlavai','505460',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33249,103,'Thatpalli','505453',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33250,103,'Thimmapur','505307',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33251,103,'Thimmapur','505305',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33252,103,'Thimmapur','505425',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33253,103,'Thimmapur','505527',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33254,103,'Thimminala','505454',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33255,103,'Thippannapet','505529',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33256,103,'Thirumalapur','505532',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33257,103,'Thirumalapur','505531',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33258,103,'Thotapalli','505466',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33259,103,'Thotapalli (Karim Nagar)','505530',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33260,103,'Thungur','505454',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33261,103,'Tippaipalli','505501',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33262,103,'Tirumalapur','505501',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33263,103,'Uppermallial','505445',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33264,103,'Vachunur','505530',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33265,103,'Vadloor','505530',1,0,'2022-03-03 12:35:50','2022-03-03 12:35:50'),(33266,103,'Vadloorbegumpet','505530',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33267,103,'Valbhapur','505405',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33268,103,'Vallampalli','505453',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33269,103,'Vallampatla','505402',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33270,103,'Vamulakurthi','505450',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33271,103,'Vannaram','505451',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33272,103,'Vanthadupula','505402',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33273,103,'Vardavelli','505402',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33274,103,'Varkole','505530',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33275,103,'Varsikonda','505450',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33276,103,'Vedira','505451',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33277,103,'Vedurgatta','505415',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33278,103,'Veerlapalli','505305',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33279,103,'Velchal','505451',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33280,103,'Veldi','505469',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33281,103,'Velgatur','505526',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33282,103,'Velgipur','505402',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33283,103,'Velgonda','505454',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33284,103,'Vellolla','505325',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33285,103,'Vempalli Venkatraopet','505331',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33286,103,'Vempet','505331',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33287,103,'Vemulawada','505302',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33288,103,'Vengalaipet','505532',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33289,103,'Venkataipalli','505445',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33290,103,'Venkatapur','505330',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33291,103,'Venkatrapur','505301',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33292,103,'Venkatropet','505325',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33293,103,'Venkatropet','505301',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33294,103,'Venkatropet','505453',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33295,103,'Venugumatla','505532',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33296,103,'Vilasagar','505524',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33297,103,'Vinjapalli','505528',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33298,103,'Voblapur','505402',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33299,103,'Yamapur','505450',1,0,'2022-03-03 12:35:51','2022-03-03 12:35:51'),(33300,103,'Yellapur','505415',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33301,103,'Yengal','505403',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33302,103,'Yousufnagar','505330',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33303,103,'A.P.Colony (Karim Nagar)','505215',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33304,103,'Abadi Ramagundam','505208',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33305,103,'Adavi Srirampur','505184',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33306,103,'Adavisoman Palli','505184',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33307,103,'Adivarampet','505212',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33308,103,'Akunur','505472',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33309,103,'Ambala','505102',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33310,103,'Ambalapur','505474',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33311,103,'Ambatpalli','505504',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33312,103,'Ammanagurthi','505480',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33313,103,'Amudalapalli','505470',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33314,103,'Annaram','505503',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33315,103,'Anthergan Textiles','505514',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33316,103,'Appannapet','505174',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33317,103,'Arenda','505184',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33318,103,'Basanthnagar','505187',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33319,103,'Bavpet','505101',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33320,103,'Bayyaram','505503',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33321,103,'Bedigal','505129',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33322,103,'Begampet','505212',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33323,103,'Bheemadevarapally','505497',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33324,103,'Bheempalli','505101',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33325,103,'Bijgir Shariff','505475',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33326,103,'Bijnur','505475',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33327,103,'Bojannapet','505174',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33328,103,'Bommakal','505480',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33329,103,'Bommanapalli','505472',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33330,103,'Bommanapalli','505416',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33331,103,'Bommapur','505504',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33332,103,'Bonthakuntapalli','505186',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33333,103,'Borlagudem','505503',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33334,103,'Bornapalli','505498',1,0,'2022-03-03 12:35:52','2022-03-03 12:35:52'),(33335,103,'Botlavanaparthi','505187',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33336,103,'Brahmanpalli','505514',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33337,103,'Buttareddy Gudem','505102',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33338,103,'Centinary Colony','505212',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33339,103,'Challur','505505',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33340,103,'Chamanapalli','505416',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33341,103,'Chamanpalli','505186',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33342,103,'Chandapalli','505174',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33343,103,'Chegaon','505416',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33344,103,'Chelpur','505122',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33345,103,'Cherlabuthkur','505186',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33346,103,'Chinnakalavala','505174',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33347,103,'Chintakani','505503',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33348,103,'Damera','505476',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33349,103,'Damerakunta','505503',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33350,103,'Dandepalli','505101',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33351,103,'Desaipalli','505502',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33352,103,'Deshrajpalli','505102',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33353,103,'Devampalli','505505',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33354,103,'Dhanwada','505503',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33355,103,'Dharmarajpalli','505101',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33356,103,'Dharmaram','505416',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33357,103,'Dharmaram','505471',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33358,103,'Dharmaram','505122',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33359,103,'Dharmaram','505184',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33360,103,'Dongathurthi','505187',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33361,103,'Duddenapalli','505472',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33362,103,'Dulikatta','505525',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33363,103,'Eklaspur','505184',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33364,103,'Eklsapur','505490',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33365,103,'Elabotharam','505498',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33366,103,'Eligaid','505525',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33367,103,'Elkalapalli','505188',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33368,103,'Erukalagudem','505498',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33369,103,'Fertilizercity','505210',1,0,'2022-03-03 12:35:53','2022-03-03 12:35:53'),(33370,103,'G Narsingapur','505497',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33371,103,'Gaddapaka','505470',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33372,103,'Gangaram','505503',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33373,103,'Gangaram','505153',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33374,103,'Gangipalli','505474',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33375,103,'Garepalli','505186',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33376,103,'Gattepalli','505185',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33377,103,'Ghanmukulu','505502',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33378,103,'Ghanpur','505472',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33379,103,'Godavarikhani','505209',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33380,103,'Godishala','505498',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33381,103,'Gollapalli','505186',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33382,103,'Gopalapur','505476',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33383,103,'Gopalpur','505184',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33384,103,'Goyalwada','505514',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33385,103,'Gudur','505102',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33386,103,'Gujulapalli','505184',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33387,103,'Gumpula','505152',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33388,103,'Gundedu','505122',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33389,103,'Guniparthi','505102',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33390,103,'Gunjapadugu','505184',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33391,103,'Gv8incline','505211',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33392,103,'Huzurabad H.O','505468',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33393,103,'Indurthi','505152',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33394,103,'Isala Thakkallapalli','505187',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33395,103,'Itharajpalli','505186',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33396,103,'Jallaram','505184',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33397,103,'Jammikunta','505122',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33398,103,'Janagaon','505209',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33399,103,'Jayyaram','505187',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33400,103,'Jeelugula','505498',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33401,103,'Julapalli','505525',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33402,103,'Julapalli','505188',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33403,103,'Jupaka','505498',1,0,'2022-03-03 12:35:54','2022-03-03 12:35:54'),(33404,103,'Jyothinagar (Karim Nagar)','505215',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33405,103,'Kachapur','505525',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33406,103,'Kachapur','505470',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33407,103,'Kakathiya Canal Campus','505498',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33408,103,'Kaleswaram','505504',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33409,103,'Kalleda','505505',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33410,103,'Kalvacharla','505212',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33411,103,'Kalvasrirampur','505153',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33412,103,'Kamalapur (Karim Nagar)','505102',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33413,103,'Kamanpur','505188',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33414,103,'Kanagarthi','505187',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33415,103,'Kanagarthi','505122',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33416,103,'Kanagarthi','505152',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33417,103,'Kanaparthi','505102',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33418,103,'Kandugula','505101',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33419,103,'Kaniparthi','505129',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33420,103,'Kannal','505187',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33421,103,'Kannal','505184',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33422,103,'Kannapur','505470',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33423,103,'Kannaram','505471',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33424,103,'Kannur','505101',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33425,103,'Kanukula','505185',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33426,103,'Kanukulagidda','505498',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33427,103,'Kareemabadi','505129',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33428,103,'Kataram','505503',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33429,103,'Katekenapalli','505416',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33430,103,'Katrapalli','505480',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33431,103,'Keshanapalli','505153',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33432,103,'Keshavapatnam','505490',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33433,103,'Keshavapur','505102',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33434,103,'Khammampalli','505184',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33435,103,'Kistampet','505153',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33436,103,'Kodurupaka','505185',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33437,103,'Kolanur','505162',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33438,103,'Komera','505152',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33439,103,'Kondapaka','505502',1,0,'2022-03-03 12:35:55','2022-03-03 12:35:55'),(33440,103,'Kondapalakala','505474',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33441,103,'Koppur','505497',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33442,103,'Korapalli','505129',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33443,103,'Korkal','505502',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33444,103,'Kothagutta','505490',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33445,103,'Kothakonda','505471',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33446,103,'Kothapalli','505497',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33447,103,'Kothapalli','505162',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33448,103,'Kothur','505525',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33449,103,'Kukkalaguduru','505514',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33450,103,'Kummarikunta','505525',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33451,103,'Kunaram','505174',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33452,103,'Kundanapalli','505208',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33453,103,'Ladnapur','505212',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33454,103,'Lakkaram','505212',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33455,103,'Laxmipur','505505',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33456,103,'Legalamarri','505416',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33457,103,'Machinapalli','505129',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33458,103,'Madaka','505152',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33459,103,'Madannapeta','505102',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33460,103,'Madhuda','505472',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33461,103,'Madupalli','505122',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33462,103,'Mahadevpur (Karim Nagar)','505504',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33463,103,'Maidambanda','505212',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33464,103,'Maidpalli','505162',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33465,103,'Maidpalli','505209',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33466,103,'Mallapuram','505416',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33467,103,'Mallaram','505184',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33468,103,'Mallaram','505471',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33469,103,'Mallial','505122',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33470,103,'Mallial','505153',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33471,103,'Mallialpalli','505208',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33472,103,'Mamidalapalli','505505',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33473,103,'Mangampet','505174',1,0,'2022-03-03 12:35:56','2022-03-03 12:35:56'),(33474,103,'Manikyapur','505497',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33475,103,'Manthani','505184',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33476,103,'Maredugonda','505174',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33477,103,'Maredupaka','505209',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33478,103,'Medaram','505416',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33479,103,'Metpalli','505470',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33480,103,'Mirzampet','505153',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33481,103,'Mogilipalem','505474',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33482,103,'Mohammadapur','505472',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33483,103,'Molangur','505470',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33484,103,'Motlapalli','505153',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33485,103,'Mudriyal','505514',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33486,103,'Mukdumpur','505186',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33487,103,'Mulasala','505162',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33488,103,'Mulkanur','505471',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33489,103,'Munjampalli','505416',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33490,103,'Muppirithota','505525',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33491,103,'Murmur','505514',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33492,103,'Mustafapur','505471',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33493,103,'Mutharam','505470',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33494,103,'Mutharam','505184',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33495,103,'Mutharam','505503',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33496,103,'Mutharam','505471',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33497,103,'Nagaram','505184',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33498,103,'Narayanapur','505185',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33499,103,'Narsingapur','505502',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33500,103,'Neerukulla','505185',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33501,103,'Nerella','505102',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33502,103,'Nittur','505174',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33503,103,'Odedu','505184',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33504,103,'Odela','505152',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33505,103,'Ootur','505505',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33506,103,'Palakurthi','505187',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33507,103,'Palimela','505504',1,0,'2022-03-03 12:35:57','2022-03-03 12:35:57'),(33508,103,'Palitham','505187',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33509,103,'Pandilla','505152',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33510,103,'Papaiahpalli','505498',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33511,103,'Pathagudur','505416',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33512,103,'Pathipaka','505416',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33513,103,'Peddabonkur','505174',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33514,103,'Peddakalvala','505174',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33515,103,'Peddampet','505208',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33516,103,'Peddapalli H.O','505172',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33517,103,'Peddapalli RS','505172',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33518,103,'Peddathundla','505184',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33519,103,'Pegadapalli','505162',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33520,103,'Penchiklapet','505498',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33521,103,'Perapalli','505188',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33522,103,'Poosala','505185',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33523,103,'Pothireddy Palli','505129',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33524,103,'Pothireddypet','505498',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33525,103,'Pothkapalli','505152',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33526,103,'Potiyal','505514',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33527,103,'Pp Colony','505174',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33528,103,'Puchunur','505505',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33529,103,'Purupalli','505153',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33530,103,'Puttapaka','505184',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33531,103,'Rachapalli','505475',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33532,103,'Rachapalli','505187',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33533,103,'Raghavapur','505174',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33534,103,'Ragineedu','505187',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33535,103,'Raikaldevpalli','505185',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33536,103,'Rajapur','505470',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33537,103,'Rajkal','505480',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33538,103,'Ramagundam','505208',1,0,'2022-03-03 12:35:58','2022-03-03 12:35:58'),(33539,103,'Ramchandrapur','505472',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33540,103,'Rampalli','505174',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33541,103,'Rampur','505498',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33542,103,'Rangapuram','505188',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33543,103,'Rathapalli','505153',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33544,103,'Rathnagiri','505497',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33545,103,'Rathnapur','505212',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33546,103,'Reddypalli','505502',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33547,103,'Regadi Maddikunta','505162',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33548,103,'Rekonda','505474',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33549,103,'Rompikunta','505188',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33550,103,'Rudraram','505503',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33551,103,'Saidapur (Karim Nagar)','505472',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33552,103,'Sarsaid','505122',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33553,103,'Scab','505209',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33554,103,'Shaimpet','505122',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33555,103,'Shanagonda','505152',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33556,103,'Shanigaram','505102',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33557,103,'Shivapalli','505525',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33558,103,'Shivarampalli','505472',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33559,103,'Singapur','505498',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33560,103,'Siripuram','505184',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33561,103,'Sirsapalli','505498',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33562,103,'Suddala','505185',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33563,103,'Sultanabad','505185',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33564,103,'Sultanpur','505525',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33565,103,'Sundilla','505209',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33566,103,'Suraram','505504',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33567,103,'Suraram','505476',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33568,103,'T Maddikunta','505174',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33569,103,'Tadicherla','505184',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33570,103,'Tadikal','505474',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33571,103,'Tekurthi','505475',1,0,'2022-03-03 12:35:59','2022-03-03 12:35:59'),(33572,103,'Telukunta','505525',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33573,103,'Thanugula','505475',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33574,103,'Tharupalli','505153',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33575,103,'Thummanapalli','505498',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33576,103,'Tihimmapur','505102',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33577,103,'Togarrai','505185',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33578,103,'Ullampalli','505472',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33579,103,'Uppal (Karim Nagar)','505101',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33580,103,'Vadupulavancha','505503',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33581,103,'Valbhapur','505129',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33582,103,'Valbhapur','505476',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33583,103,'Vallamkunta','505503',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33584,103,'Vangapalli','505102',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33585,103,'Vangara','505480',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33586,103,'Vanthadupula','505475',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33587,103,'Vavilala','505475',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33588,103,'Veenavanka','505502',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33589,103,'Veeranarayapur','505476',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33590,103,'Vegurupalli','505505',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33591,103,'Venkatapur','505184',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33592,103,'Venkataraopalli','505525',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33593,103,'Vennampalli','505174',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33594,103,'Vennampalli','505490',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33595,103,'Vilasagar','505475',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33596,103,'Vilasagar','505503',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33597,103,'Vittalanagar','505214',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33598,103,'Wadakapur','505525',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33599,103,'Yedlapalli','505503',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33600,103,'Yelbaka','505502',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33601,103,'Yelkathurthi','505476',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33602,103,'Yellanthakunta','505122',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33603,103,'Yeradapalli','505474',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33604,103,'Yerraballi','505471',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33605,104,'Abbugudem','507316',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33606,104,'Abhicherla','507121',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33607,104,'Acharlagudem','507160',1,0,'2022-03-03 12:36:00','2022-03-03 12:36:00'),(33608,104,'Allapadu','507204',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33609,104,'Allapalli','507124',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33610,104,'Allinagaram','507203',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33611,104,'Allipuram','507318',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33612,104,'Alubaka','507133',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33613,104,'Amaravaram','507114',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33614,104,'Ambarupeta','507203',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33615,104,'Ammagaripalli','507116',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33616,104,'Ammagudem','507160',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33617,104,'Ammapalem','507305',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33618,104,'Ammapeta','507158',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33619,104,'Anantharam','507301',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33620,104,'Anantharampatti Mallur','507117',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33621,104,'Ananthasagar','507208',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33622,104,'Ananthogu','507124',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33623,104,'Anasagaram','507160',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33624,104,'Anisettipalli','507124',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33625,104,'Ankampale','507306',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33626,104,'Annapureddipalli','507316',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33627,104,'Annaruguda','507167',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33628,104,'Appalanarasimhapuram','507169',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33629,104,'Arasarlapadu','507164',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33630,104,'Aregudem','507160',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33631,104,'Arekodu','507163',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33632,104,'Arempula','507163',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33633,104,'Arikayalapadu','507168',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33634,104,'Arlagudem','507137',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33635,104,'Asthanagurthi','507304',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33636,104,'Asupaka','507301',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33637,104,'Aswapur','507116',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33638,104,'Aswaraopet','507301',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33639,104,'Atukuru','507203',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33640,104,'Ayyavarigudem','507202',1,0,'2022-03-03 12:36:01','2022-03-03 12:36:01'),(33641,104,'B N Thanda','507123',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33642,104,'B.R.Colony','507111',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33643,104,'Bachodu','507161',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33644,104,'Balajipeta','507211',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33645,104,'Ballepalli','507002',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33646,104,'Banapuram','507169',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33647,104,'Bangaruchelka','507118',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33648,104,'Banigandlapahad','507202',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33649,104,'Basavapuram','507318',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33650,104,'Bathulapalli','507209',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33651,104,'Bathupalli Ganagaram','507303',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33652,104,'Bayyannagudem','507302',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33653,104,'Bayyaram','507117',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33654,104,'Bayyaram','507211',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33655,104,'Beerole','507161',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33656,104,'Bethampudi','507123',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33657,104,'Bhadrachalam H.O','507111',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33658,104,'Bhagyavathaveedu','507157',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33659,104,'Bhairavunipalli','507160',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33660,104,'Bhajanamandir','507101',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33661,104,'Bhavannapalem','507316',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33662,104,'Bhimavaram','507202',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33663,104,'Bhupathiraopeta','507117',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33664,104,'Billupahad','507167',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33665,104,'Bodu','507124',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33666,104,'Bodulabanda','507160',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33667,104,'Bommakal','507204',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33668,104,'Brahmanapalli','507304',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33669,104,'Buddaram','507169',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33670,104,'Budharam','507210',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33671,104,'Budidampahad','507182',1,0,'2022-03-03 12:36:02','2022-03-03 12:36:02'),(33672,104,'Buradaraghavapuram','507168',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33673,104,'Burahanpuram','507001',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33674,104,'Burgampahad','507114',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33675,104,'Bus Station(KHM)','507001',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33676,104,'Challasamudram','507122',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33677,104,'Chandrupatla','507209',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33678,104,'Chandrupatla','507136',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33679,104,'Chapralla Palli','507316',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33680,104,'Charla','507133',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33681,104,'Chatagonda','507118',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33682,104,'Chatti','507129',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33683,104,'Chegomma','507170',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33684,104,'Chennaram','507160',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33685,104,'Chennur','507209',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33686,104,'Cherukuru','507136',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33687,104,'Cherupalli','507129',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33688,104,'Cheruvumadharam','507169',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33689,104,'Chidumuru','507129',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33690,104,'Chilkuru','507203',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33691,104,'Chimalapad','507122',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33692,104,'Chimmapudi','507182',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33693,104,'Chinabandirevu','507137',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33694,104,'Chinagopathi','507305',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33695,104,'Chinakorukondi','507209',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33696,104,'Chinamandava','507208',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33697,104,'Chintakani','507208',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33698,104,'Chintalagudem','507128',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33699,104,'Chintaregupalli','507135',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33700,104,'Chintrial','507116',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33701,104,'Chintur','507113',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33702,104,'Chirumarri','507158',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33703,104,'Chirunomula','507204',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33704,104,'Chnadrugonda','507166',1,0,'2022-03-03 12:36:03','2022-03-03 12:36:03'),(33705,104,'Chodavaram','507129',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33706,104,'Choppakatlapalem','507204',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33707,104,'Choppakatlapalem','507202',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33708,104,'Choppalli','507129',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33709,104,'Chowtapalli','507161',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33710,104,'Chuchirevulagudem','507121',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33711,104,'Chunchupalli','507118',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33712,104,'Church Road(KHM)','507001',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33713,104,'Collectorate (Khammam)','507002',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33714,104,'Dabala Bazar','507003',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33715,104,'Dabbanuthala','507137',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33716,104,'Dachavaram','507114',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33717,104,'Damaracharla','507114',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33718,104,'Damarcharla','507166',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33719,104,'Dammaigudem','507183',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33720,104,'Dammapeta','507306',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33721,104,'Dantalaboru','507115',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33722,104,'Dendukuru','507203',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33723,104,'Desinenipalem','507203',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33724,104,'Dharedu','507003',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33725,104,'Dubbagudem','507210',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33726,104,'Duddepudi','507303',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33727,104,'Duginepalli','507117',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33728,104,'Dummagudem','507137',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33729,104,'Edavalli','507170',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33730,104,'Edicharlapalli','507136',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33731,104,'Edira','507133',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33732,104,'Edulapuram','507163',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33733,104,'Edullacheruvu','507183',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33734,104,'Edurallapalli','507129',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33735,104,'Enagali','507201',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33736,104,'Enkoor','507168',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33737,104,'Eswaramadharam','507157',1,0,'2022-03-03 12:36:04','2022-03-03 12:36:04'),(33738,104,'Gaigollapalli','507161',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33739,104,'Gandhasiri','507158',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33740,104,'Gandhichowk (Khammam)','507003',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33741,104,'Gandugulapalli','507303',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33742,104,'Ganeshpadu','507306',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33743,104,'Gangolu','507137',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33744,104,'Gannavaram','507134',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33745,104,'Gannavaram','507165',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33746,104,'Gannerugoyyapadu','507134',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33747,104,'Ganugapadu','507120',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33748,104,'Garibpeta','507118',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33749,104,'Garikapadu','507165',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33750,104,'Garla','507210',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33751,104,'Gattusingaram','507159',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33752,104,'Godlagudem','507129',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33753,104,'Gogubaka','507129',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33754,104,'Gokinepalli','507158',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33755,104,'Gollapahad','507003',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33756,104,'Gollapudi','507165',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33757,104,'Gommugudem','507140',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33758,104,'Gondigudem','507116',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33759,104,'Gopalapuram','507163',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33760,104,'Gopalapuram','507002',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33761,104,'Gopalapuram','507210',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33762,104,'Gopalaraopeta','507117',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33763,104,'Gopathi','507305',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33764,104,'Gopavaram','507305',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33765,104,'Gouthampur','507138',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33766,104,'Govindarala','507182',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33767,104,'Gowraram','507211',1,0,'2022-03-03 12:36:05','2022-03-03 12:36:05'),(33768,104,'Gubbagurthi','507165',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33769,104,'Gudimalla','507003',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33770,104,'Gudurpahad','507003',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33771,104,'Gummadidoddi','507136',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33772,104,'Gummadivalli','507301',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33773,104,'Gundala','507129',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33774,104,'Gundala','507123',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33775,104,'Gundepudi','507166',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33776,104,'Guntupalli Gopavaram','507202',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33777,104,'Guravaigudem','507159',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33778,104,'Guttalabazar','507003',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33779,104,'Guvvalagudem`','507158',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33780,104,'Hasnabad','507161',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33781,104,'Hemachandrapuram','507118',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33782,104,'Hwp Aswapur Colony','507116',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33783,104,'Hydersaipeta','507183',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33784,104,'Illuru','507203',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33785,104,'Industrial Area (Khammam)','507002',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33786,104,'Irlapudi','507182',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33787,104,'Irusulapuram','507211',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33788,104,'Jagannadhapuram (KP)','507115',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33789,104,'Jagannadhapuram','507115',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33790,104,'Jagannadhapuram','507208',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33791,104,'Jakkepalli','507159',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33792,104,'Jallepalli','507183',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33793,104,'Jamalapuram','507201',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33794,104,'Janampeta','507117',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33795,104,'Jannaram','507168',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33796,104,'Jeediguppa','507135',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33797,104,'Jeelacheruvu','507170',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33798,104,'Jujjularaopet','507157',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33799,104,'Julurpahad','507166',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33800,104,'Jupeda','507161',1,0,'2022-03-03 12:36:06','2022-03-03 12:36:06'),(33801,104,'Kachanapalli','507123',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33802,104,'Kachavaram','507134',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33803,104,'Kachirajugudem','507003',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33804,104,'Kaikondaigudem','507002',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33805,104,'Kakaravai','507161',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33806,104,'Kakarla','507166',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33807,104,'Kakarlapalli','507303',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33808,104,'Kalakodima','507167',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33809,104,'Kalakota','507304',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33810,104,'Kallorgudem','507164',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33811,104,'Kallur (Khammam)','507209',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33812,104,'Kamalapuram','507158',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33813,104,'Kamalapuram','507210',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33814,104,'Kamalapuram','507115',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33815,104,'Kamanchikal','507003',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33816,104,'Kamepalli','507122',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33817,104,'Kandukur','507164',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33818,104,'Karakagudem','507117',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33819,104,'Karakavagu','507115',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33820,104,'Karepalli','507122',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33821,104,'Karivarigudem','507120',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33822,104,'Kattakuru','507170',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33823,104,'Kattukacharam','507169',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33824,104,'Katukuru','507135',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33825,104,'Kesavapuram','507170',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33826,104,'Khammam H.O','507001',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33827,104,'Khammampadu','507203',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33828,104,'Khanapuram','507165',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33829,104,'Khanapuram Haweli','507002',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33830,104,'Kinnersani Project','507115',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33831,104,'Kistapuram','507158',1,0,'2022-03-03 12:36:07','2022-03-03 12:36:07'),(33832,104,'Kistapuram','507159',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33833,104,'Kistaram','507303',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33834,104,'Kodumuru','507208',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33835,104,'Koida','507135',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33836,104,'Kokkireni','507163',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33837,104,'Kolturu','507129',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33838,104,'Komararam','507124',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33839,104,'Komatlagudem','507208',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33840,104,'Komatlagudem','507122',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33841,104,'Komminepalli','507182',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33842,104,'Kommuru','507129',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33843,104,'Kondaigudem','507117',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33844,104,'Kondakodima','507165',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33845,104,'Kondapuram','507170',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33846,104,'Kondavanamala','507305',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33847,104,'Kondrajupeta','507121',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33848,104,'Kongala','507136',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33849,104,'Kongara','507169',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33850,104,'Konijerla','507305',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33851,104,'Koratlagudem','507160',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33852,104,'Korlagudem','507209',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33853,104,'Kothaguda','507118',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33854,104,'Kothagudem Bazar','507101',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33855,104,'Kothagudem Colls H.O','507101',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33856,104,'Kothalingala','507182',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33857,104,'Kothapalem','507201',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33858,104,'Kothapeta','507211',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33859,104,'Kothuru','507159',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33860,104,'Koyachelaka','507002',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33861,104,'Koyagudem','507123',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33862,104,'Krishnasagar','507114',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33863,104,'Kukunoor','507114',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33864,104,'Kunavaram','507121',1,0,'2022-03-03 12:36:08','2022-03-03 12:36:08'),(33865,104,'Kunchaparthi','507164',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33866,104,'Kuppanakuntla','507302',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33867,104,'Kurnapalli','507140',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33868,104,'Kurnavalli','507167',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33869,104,'Kusumanchi','507159',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33870,104,'Kuturu','507121',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33871,104,'Lachaguda','507168',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33872,104,'Lachagudem','507208',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33873,104,'Lachagudem','507124',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33874,104,'Lakshmipuram','507204',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33875,104,'Lankapalli','507302',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33876,104,'Laxmidepalli','507101',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33877,104,'Laxminagaram','507137',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33878,104,'Laxmipuram','507129',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33879,104,'Laxmipuram','507003',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33880,104,'Lingagudem','507302',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33881,104,'Lingagudem','507123',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33882,104,'Lingagudem','507305',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33883,104,'Lingalapalli','507306',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33884,104,'Lingapuram','507133',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33885,104,'Lokya Thanda','507170',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33886,104,'M.E.Complex','507118',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33887,104,'Maddukur','507166',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33888,104,'Maddulagudem','507306',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33889,104,'Maddulapalli','507182',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33890,104,'Maddulapalli','507170',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33891,104,'Madhapuram','507170',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33892,104,'Madhavaram','507114',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33893,104,'Madhavaram','507122',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33894,104,'Madhira Bazar','507203',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33895,104,'Madhira','507203',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33896,104,'Madupalli','507203',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33897,104,'Mahadevapuram','507203',1,0,'2022-03-03 12:36:09','2022-03-03 12:36:09'),(33898,104,'Mahammadapuram','507161',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33899,104,'Mailaram','507118',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33900,104,'Malkaram','507306',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33901,104,'Mallannapalem','507158',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33902,104,'Mallaram','507167',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33903,104,'Mallaram','507117',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33904,104,'Mallaram','507169',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33905,104,'Mallaram','507304',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33906,104,'Mallemadugu','507003',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33907,104,'Mallepalli','507159',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33908,104,'Mallepalli Chintagurthi','507318',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33909,104,'Mamidigudem','507140',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33910,104,'Mamnoor','507202',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33911,104,'Manchigonda','507182',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33912,104,'Mandalapahad','507302',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33913,104,'Mandalapalli','507306',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33914,104,'Mandrajupalli','507160',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33915,104,'Mangapuram','507169',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33916,104,'Manikyaram','507122',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33917,104,'Manikyaram','507124',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33918,104,'Manuguru','507117',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33919,104,'Manuguru Colls','507117',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33920,104,'Markodu','507124',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33921,104,'Marlapadu','507164',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33922,104,'Marrigudem','507121',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33923,104,'Matkepalli Namavaram','507208',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33924,104,'Maturu','507203',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33925,104,'Medepalli','507158',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33926,104,'Medidepalli','507161',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33927,104,'Meenavolu','507201',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33928,104,'Mittagudem','507116',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33929,104,'Mittapalli','507167',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33930,104,'Modivari','507303',1,0,'2022-03-03 12:36:10','2022-03-03 12:36:10'),(33931,104,'Mogallapalli','507133',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33932,104,'Morampalli','507114',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33933,104,'Motamarri','507204',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33934,104,'Motapuram','507159',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33935,104,'Mothipattinagar','507128',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33936,104,'Mothugudem','507113',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33937,104,'Mucharam','507209',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33938,104,'Mucherla','507182',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33939,104,'Muddunuru','507167',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33940,104,'Mudigonda','507158',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33941,104,'Mujjugudem','507160',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33942,104,'Mukamamidi','507115',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33943,104,'Mukunuru','507129',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33944,104,'Mulakalapalli','507115',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33945,104,'Mulkanoor','507210',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33946,104,'Munagala','507305',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33947,104,'Munigepalli','507170',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33948,104,'Murumuru','507136',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33949,104,'Murumuru','507134',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33950,104,'Musalimadugu','507114',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33951,104,'Musalimadugu','507165',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33952,104,'Mustibanda','507306',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33953,104,'Mustikuntla','507204',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33954,104,'Muthagudem','507209',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33955,104,'Muthagudem','507163',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33956,104,'Muthapuram','507123',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33957,104,'Mutyalagudem','507159',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33958,104,'Nacharam','507306',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33959,104,'Nacharam','507168',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33960,104,'Nachepalli','507160',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33961,104,'Nagaram','507115',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33962,104,'Nagiligonda','507208',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33963,104,'Nagineniprolu','507114',1,0,'2022-03-03 12:36:11','2022-03-03 12:36:11'),(33964,104,'Nagulavancha','507208',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33965,104,'Nagupalli','507303',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33966,104,'Nallaballi','507137',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33967,104,'Nandigama','507134',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33968,104,'Naramvarigudem','507301',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33969,104,'Narapunenipalli','507165',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33970,104,'Narasapuram','507137',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33971,104,'Narasimhulagudem','507159',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33972,104,'Narayanapuram','507204',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33973,104,'Narayanapuram','507301',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33974,104,'Narayanapuram','507303',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33975,104,'Nargundukarnagar','507118',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33976,104,'Nayakangudem','507157',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33977,104,'Nelakondapalli','507160',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33978,104,'Nelapatla','507170',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33979,104,'Nellipaka','507128',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33980,104,'Nellipaka','507129',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33981,104,'Nereda','507208',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33982,104,'New Karaigudem','507302',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33983,104,'Nidanapuram','507203',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33984,104,'Noothankal','507167',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33985,104,'Nsc Campus','507002',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33986,104,'P.N.Puram','507166',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33987,104,'P.V.Township','507125',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33988,104,'Pagideru','507117',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33989,104,'Paladugu','507304',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33990,104,'Palair','507157',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33991,104,'Pallewada','507302',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33992,104,'Pallipadu','507165',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33993,104,'Paloncha','507115',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33994,104,'Pammi','507158',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33995,104,'Pandillapalli','507208',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33996,104,'Pandregupalli','507003',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33997,104,'Pandurangapuram','507115',1,0,'2022-03-03 12:36:12','2022-03-03 12:36:12'),(33998,104,'Papakole','507166',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(33999,104,'Papatpalli','507003',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34000,104,'Parnasala','507137',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34001,104,'Patha Paloncha','507115',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34002,104,'Pathalingala','507122',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34003,104,'Patharlapahad','507208',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34004,104,'Patharlapahad','507183',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34005,104,'Pathrapuram','507133',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34006,104,'Patwarigudem','507306',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34007,104,'Pedabeeravalli','507204',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34008,104,'Pedagopavaram','507202',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34009,104,'Pedakorukondi','507209',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34010,104,'Pedamandava','507169',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34011,104,'Pedamatasileru','507140',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34012,104,'Pedamittapalli','507135',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34013,104,'Pedarkur','507121',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34014,104,'Peddireddigudem','507316',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34015,104,'Pegallapadu','507201',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34016,104,'Pegallapadu','507123',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34017,104,'Penagadapa','507103',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34018,104,'Pentlam','507316',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34019,104,'Penuballi','507302',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34020,104,'Perikasingaram','507159',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34021,104,'Perupalli','507122',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34022,104,'Peruru','507136',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34023,104,'Peruvancha','507209',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34024,104,'Pinapaka','507165',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34025,104,'Pinapaka','507117',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34026,104,'Pinapaka Pattinagar','507114',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34027,104,'Pindipolu','507183',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34028,104,'Pinjaramadugu','507122',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34029,104,'Pocharam','507122',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34030,104,'Pocharam','507163',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34031,104,'Pogallapalli','507115',1,0,'2022-03-03 12:36:13','2022-03-03 12:36:13'),(34032,104,'Pokalagudem','507166',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34033,104,'Ponnekal','507210',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34034,104,'Ponnekal','507170',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34035,104,'Posugudem','507115',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34036,104,'Pragallapalli','507136',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34037,104,'Proddutur','507208',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34038,104,'Pullur','507210',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34039,104,'Pulluru Phc','507113',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34040,104,'Punyapur','507165',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34041,104,'Purushottapatnam','507129',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34042,104,'Pydigudem','507137',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34043,104,'Pynampalli','507161',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34044,104,'Pynampalli','507160',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34045,104,'Racharla','507164',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34046,104,'Ragaboinagudem','507123',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34047,104,'Raghavapuram','507120',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34048,104,'Raghunadhapalem','507002',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34049,104,'Raghunadhapalem','507161',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34050,104,'Raithwari Kothagudem','507140',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34051,104,'Rajapuram','507316',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34052,104,'Rajeswarapuram','507160',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34053,104,'Rajupeta','507157',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34054,104,'Rakapalli','507135',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34055,104,'Ramachandrapuram','507211',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34056,104,'Ramachandrapuram','507133',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34057,104,'Ramachandrapuram','507160',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34058,104,'Ramakrishnapuram','507208',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34059,104,'Ramalayam','507111',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34060,104,'Ramannapalem','507201',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34061,104,'Ramavaram','507118',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34062,104,'Rampuram','507210',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34063,104,'Ravigudem','507114',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34064,104,'Ravikampadu','507166',1,0,'2022-03-03 12:36:14','2022-03-03 12:36:14'),(34065,104,'Ravinoothala','507204',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34066,104,'Rayagudem','507169',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34067,104,'Rayamadharam','507168',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34068,104,'Rayapatnam','507203',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34069,104,'Rebbavaram','507165',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34070,104,'Regalla','507118',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34071,104,'Relakayalapalli','507122',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34072,104,'Remidicherla','507201',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34073,104,'Repakagommu','507121',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34074,104,'Repalle','507304',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34075,104,'Repallewada','507208',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34076,104,'Rompaid','507124',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34077,104,'Rudramkota','507121',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34078,104,'Rudrampur','507119',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34079,104,'S.N.Puram','507211',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34080,104,'S.N.Puram','507140',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34081,104,'Sadasivunipalem','507303',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34082,104,'Sakinaveedu','507201',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34083,104,'Sampathnagar','507124',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34084,104,'Sarapaka','507128',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34085,104,'Sarvaram','507120',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34086,104,'Sathupalli','507303',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34087,104,'Sayanapalli','507123',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34088,104,'Sca Bldg','507101',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34089,104,'Seethampeta','507120',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34090,104,'Seethampeta','507208',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34091,104,'Seethampeta','507210',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34092,104,'Seetharampuram','507123',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34093,104,'Seetharampuram','507003',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34094,104,'Seetharampuram','507137',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34095,104,'Settipalli','507124',1,0,'2022-03-03 12:36:15','2022-03-03 12:36:15'),(34096,104,'Siddaram','507303',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34097,104,'Siddinenigudem','507201',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34098,104,'Siil Campus','507154',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34099,104,'Singarayapalem','507165',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34100,104,'Singareddipalem','507160',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34101,104,'Singareddipalli','507117',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34102,104,'Singareni','507122',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34103,104,'Singavaram','507137',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34104,104,'Singhabhupalem','507120',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34105,104,'Siripuram Kanigiri','507165',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34106,104,'Siripuram (Khammam)','507304',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34107,104,'Snanala Laxmipuram','507165',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34108,104,'Somavaram','507165',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34109,104,'Sridhar Velair','507114',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34110,104,'Sriramgiri','507135',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34111,104,'Subbampeta','507133',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34112,104,'Subled','507161',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34113,104,'Sudimalla','507123',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34114,104,'Sujathanagar','507120',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34115,104,'Sulanagar','507123',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34116,104,'Sunnambatti','507137',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34117,104,'Suraveedu','507133',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34118,104,'Surdepalli','507160',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34119,104,'Suvarnapuram','507158',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34120,104,'T.P.Campus','507115',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34121,104,'Tadakalapudi','507122',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34122,104,'Takkellapadu','507201',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34123,104,'Tallacheruvu','507163',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34124,104,'Tallada','507167',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34125,104,'Tallampahad','507170',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34126,104,'Tallapenta','507209',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34127,104,'Talluri Venkatapuram','507209',1,0,'2022-03-03 12:36:16','2022-03-03 12:36:16'),(34128,104,'Taluk Office(STP)','507303',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34129,104,'Tangampadu','507003',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34130,104,'Tanikella','507305',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34131,104,'Tatipudi','507165',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34132,104,'Tegada','507140',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34133,104,'Tekubaka','507134',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34134,104,'Tekulapalli','507123',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34135,104,'Tekulapalli','507002',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34136,104,'Tekulapalli','507209',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34137,104,'Teldarupalli','507170',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34138,104,'Telgaram','507209',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34139,104,'Tetlapahad','507183',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34140,104,'Thatkurugommu','507121',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34141,104,'Theerthala','507003',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34142,104,'Thogugudem','507115',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34143,104,'Thondipaka','507114',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34144,104,'Thootakalingannapeta','507168',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34145,104,'Thotapalli (Khammam)','507134',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34146,104,'Timmampeta','507114',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34147,104,'Timmaraopeta','507168',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34148,104,'Timminenipalem','507208',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34149,104,'Tippanapalli','507120',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34150,104,'Tippareddiguem','507183',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34151,104,'Tirumalakunta','507301',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34152,104,'Tirumalapuram','507160',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34153,104,'Tirumalayapalem','507163',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34154,104,'Tondalagopavaram','507201',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34155,104,'Tootikuntla','507208',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34156,104,'Trunk Road (Khammam)','507003',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34157,104,'Tumburu','507303',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34158,104,'Tummala','507129',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34159,104,'Tummalapalli','507305',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34160,104,'Turakagudem','507159',1,0,'2022-03-03 12:36:17','2022-03-03 12:36:17'),(34161,104,'Turubaka','507137',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34162,104,'Ulvanoor','507115',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34163,104,'Ummadivaram','507135',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34164,104,'Uppaka','507117',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34165,104,'Uppalachelka','507302',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34166,104,'Uppalapahad','507211',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34167,104,'Upperu','507114',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34168,104,'Usirikayalapalli','507123',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34169,104,'V.R.Puram','507211',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34170,104,'V.R.Puram','507135',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34171,104,'V.V.Palem','507318',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34172,104,'Vaddigudem','507135',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34173,104,'Vallabhi','507169',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34174,104,'Vallapuram','507158',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34175,104,'Vandanam','507318',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34176,104,'Vangaveedu','507203',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34177,104,'Veerabhadravaram','507133',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34178,104,'Vegithota','507129',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34179,104,'Velairpahad','507121',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34180,104,'Velugumatla','507318',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34181,104,'Vemsur','507164',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34182,104,'Venkatagiri','507003',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34183,104,'Venkatapuram','507158',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34184,104,'Venkatapuram','507201',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34185,104,'Venkatapuram','507164',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34186,104,'Venkatapuram','507136',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34187,104,'Venkatareddipeta','507129',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34188,104,'Venkatayapalem','507003',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34189,104,'Venkateshkhani','507103',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34190,104,'Vepakuntla','507318',1,0,'2022-03-03 12:36:18','2022-03-03 12:36:18'),(34191,104,'Vinayakapuram','507301',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34192,104,'Vinjaram','507114',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34193,104,'Vippalamadaka','507165',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34194,104,'Viswanathapalli','507122',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34195,104,'Vootukuru','507122',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34196,104,'Wazeedu Nagaram','507136',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34197,104,'Wyra','507165',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34198,104,'Y.C. Roads','507002',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34199,104,'Yanamboil','507115',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34200,104,'Yatalakunta','507316',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34201,104,'Yatapaka','507128',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34202,104,'Yellandu Colls','507124',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34203,104,'Yellandu','507123',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34204,104,'Yerraboinapalli','507209',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34205,104,'Yerrupalem','507201',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34206,104,'Yerugatla','507302',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34207,105,'Abhangapur','509210',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34208,105,'Addakal','509382',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34209,105,'Advi Venkatapur','509002',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34210,105,'Alampally','509352',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34211,105,'Alampur (Mahabub Nagar)','509152',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34212,105,'Alur','509132',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34213,105,'Amdipur','509210',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34214,105,'Amerchinta','509130',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34215,105,'Amervoi','509132',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34216,105,'Amistapur','509382',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34217,105,'Ammapur','509340',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34218,105,'Angadi Raichur','509336',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34219,105,'Ankilla','509371',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34220,105,'Annaram','509336',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34221,105,'Annasagar','509407',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34222,105,'Annasagar','509382',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34223,105,'Antharam','509335',1,0,'2022-03-03 12:36:19','2022-03-03 12:36:19'),(34224,105,'Antharam','509336',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34225,105,'Anugonda','509208',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34226,105,'Appareddipalli','509210',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34227,105,'Aragidda','509132',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34228,105,'Arepally','509131',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34229,105,'Atmakur So (A)','509131',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34230,105,'Balajinagar','509338',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34231,105,'Balampet','509336',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34232,105,'Bandamedipally','509002',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34233,105,'Bandarpally','509409',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34234,105,'Bapanpally','509407',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34235,105,'Baswaipalli','509204',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34236,105,'Baswapur','509152',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34237,105,'Bhairamkonda','509210',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34238,105,'Bhogaram','509339',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34239,105,'Bhuneed','509411',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34240,105,'Bhutpur','509353',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34241,105,'Bhutpur','509382',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34242,105,'Bichal','509336',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34243,105,'Bijwar','509132',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34244,105,'Bijwar','509205',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34245,105,'Bingidoddi','509127',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34246,105,'Bommanpad','509407',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34247,105,'Bomraspet','509338',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34248,105,'Bonkur','509128',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34249,105,'Boyagudem','509129',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34250,105,'Boyapally','509002',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34251,105,'Buddaram','509334',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34252,105,'Bukkapur','509152',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34253,105,'Buranpur','509338',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34254,105,'Chagadona','509127',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34255,105,'Chagapur','509126',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34256,105,'Challapur','509336',1,0,'2022-03-03 12:36:20','2022-03-03 12:36:20'),(34257,105,'Chandapur','509208',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34258,105,'Chandrakallu','509336',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34259,105,'Chandraspalli','509371',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34260,105,'Chandravancha','509339',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34261,105,'Chegunta','509352',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34262,105,'Chellapur','509335',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34263,105,'Chennaram','509339',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34264,105,'Chennipad','509128',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34265,105,'Chilmulmailwar','509338',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34266,105,'Chinna Jatram','509205',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34267,105,'Chinna Tandrapad','509135',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34268,105,'Chinnadarpalli','509334',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34269,105,'Chinnaporla','509311',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34270,105,'Chinta Kunta Kurd','509131',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34271,105,'Chintalkunta','509129',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34272,105,'Chitlapally','509338',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34273,105,'Chittanur','509409',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34274,105,'Chityala','509208',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34275,105,'Chowdarpalli','509350',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34276,105,'Chowdarpalli','509204',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34277,105,'Chowdarpally','509340',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34278,105,'Damargidda','509407',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34279,105,'Damganpur','509409',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34280,105,'Damganpur','509411',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34281,105,'Dasardoddi','509208',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34282,105,'Desai Pally','509336',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34283,105,'Devalfaslawar','509336',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34284,105,'Devarkadra','509204',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34285,105,'Dhanwada','509205',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34286,105,'Dharmapur','509002',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34287,105,'Dharmavaram','509128',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34288,105,'Dokur','509204',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34289,105,'Dorepally','509411',1,0,'2022-03-03 12:36:21','2022-03-03 12:36:21'),(34290,105,'Doultabad','509336',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34291,105,'Dudiyal','509350',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34292,105,'Edavally','509311',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34293,105,'Eklaspur','509127',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34294,105,'Eligandla','509351',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34295,105,'Eranpally','509338',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34296,105,'Erikichedu','509129',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34297,105,'Erupmalla','509338',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34298,105,'Fareedpur','509409',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34299,105,'Fathepur','509340',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34300,105,'Gaddegudem','509204',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34301,105,'Gadwal H.O','509125',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34302,105,'Gajulapet','509382',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34303,105,'Gandwed','509337',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34304,105,'Garlapahad','509371',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34305,105,'Ghanpur','509380',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34306,105,'Ghattu','509129',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34307,105,'Gokhafaslawar','509336',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34308,105,'Gokul Nagar','509371',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34309,105,'Gopanpally','509219',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34310,105,'Gopanpet','509131',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34311,105,'Gorlakhan Doddi','509129',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34312,105,'Gotur','509204',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34313,105,'Gouraram','509350',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34314,105,'Gudeballur','509352',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34315,105,'Gudigandla','509205',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34316,105,'Gudimunkan Pally','509407',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34317,105,'Gundimalla','509152',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34318,105,'Gundiyal','509334',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34319,105,'Gundmal','509339',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34320,105,'Gunumukla','509205',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34321,105,'Gurakonda','509409',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34322,105,'Gurukunta','509340',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34323,105,'Hakeempet','509350',1,0,'2022-03-03 12:36:22','2022-03-03 12:36:22'),(34324,105,'Hanumanpura','509001',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34325,105,'Hindupur','509352',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34326,105,'Hunwada','509334',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34327,105,'Husnabad (Mahabub Nagar)','509350',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34328,105,'Ibrahimbad','509334',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34329,105,'Ibrahimpatnam','509351',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34330,105,'Ieeja','509127',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34331,105,'Ind. Estate','509002',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34332,105,'Indanur','509336',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34333,105,'Induvasi','509129',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34334,105,'Ippatur','509340',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34335,105,'Irladinne','509130',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34336,105,'Itkyala','509128',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34337,105,'Itkyalapad','509153',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34338,105,'Jajapur','509210',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34339,105,'Jaklair','509353',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34340,105,'Jalalpur','509210',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34341,105,'Jallapur','509153',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34342,105,'Janampet','509382',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34343,105,'Jatram Kalan','509205',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34344,105,'Jingirala','509204',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34345,105,'Jinnaram','509409',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34346,105,'Julaikal','509126',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34347,105,'Julapalli','509337',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34348,105,'Juriyala','509131',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34349,105,'Kachwar','509353',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34350,105,'Kadmoor','509130',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34351,105,'Kakarlapahad','509340',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34352,105,'Kalakuntla','509128',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34353,105,'Kalwal','509208',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34354,105,'Kamaluddinpur','509380',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34355,105,'Kamsanpally','509407',1,0,'2022-03-03 12:36:23','2022-03-03 12:36:23'),(34356,105,'Kancherla','509129',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34357,105,'Kandanpally','509407',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34358,105,'Kandur','509382',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34359,105,'Kankurthy','509407',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34360,105,'Kanmankalwa','509340',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34361,105,'Kanmanur','509351',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34362,105,'Karkonda','509340',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34363,105,'Karni','509208',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34364,105,'Karur','509340',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34365,105,'Kasturpally','509336',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34366,105,'Kazipur','509371',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34367,105,'Kistapur','509204',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34368,105,'Kodangal','509338',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34369,105,'Kodur','509002',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34370,105,'Koilkonda','509371',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34371,105,'Koilsagar','509204',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34372,105,'Kollampalli','509205',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34373,105,'Kollur','509311',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34374,105,'Komireddi Pally','509337',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34375,105,'Kondapur','509340',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34376,105,'Kondapuram','509371',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34377,105,'Kongat Pally','509334',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34378,105,'Konkal','509126',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34379,105,'Korvipad','509128',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34380,105,'Kosgi','509339',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34381,105,'Kotakadra','509204',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34382,105,'Kotakonda','509210',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34383,105,'Kothamolgara','509382',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34384,105,'Kothapally','509411',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34385,105,'Kothapally','509352',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34386,105,'Kothapally','509340',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34387,105,'Kothapet','509002',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34388,105,'Kothlabad','509371',1,0,'2022-03-03 12:36:24','2022-03-03 12:36:24'),(34389,105,'Kothur','509338',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34390,105,'Koukunt R.S.','509219',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34391,105,'Koukuntla','509219',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34392,105,'Kovaldinne','509126',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34393,105,'Krishna','509352',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34394,105,'Kuchur','509340',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34395,105,'Kudirmalla','509350',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34396,105,'Kulakcherla','509335',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34397,105,'Kulpur','509352',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34398,105,'Kunsi','509352',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34399,105,'Kusumasamudram','509335',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34400,105,'Kyathanpally','509407',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34401,105,'Kyathur','509153',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34402,105,'Lakcherla','509350',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34403,105,'Lalkot','509409',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34404,105,'Lankal','509130',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34405,105,'Laxmipally','509380',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34406,105,'Lingampally','509311',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34407,105,'Lingampaly','509340',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34408,105,'Linganvai','509153',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34409,105,'Lokurthy','509407',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34410,105,'Machanpalli','509204',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34411,105,'Macherla (Mahabub Nagar)','509129',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34412,105,'Maddelabanda','509132',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34413,105,'Maddigatla','509382',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34414,105,'Maddur (Mahabub Nagar)','509411',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34415,105,'Madhwar','509311',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34416,105,'Madhwar','509351',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34417,105,'Maganur','509208',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34418,105,'Mahabubnagar H.O','509001',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34419,105,'Makthal','509208',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34420,105,'Malkapuram','509371',1,0,'2022-03-03 12:36:25','2022-03-03 12:36:25'),(34421,105,'Mallepalli','509311',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34422,105,'Malreddy Pally','509407',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34423,105,'Mamidimada','509380',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34424,105,'Manajipet','509380',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34425,105,'Manavapad','509128',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34426,105,'Mandipalli','509205',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34427,105,'Mandoddi','509135',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34428,105,'Mangampet','509337',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34429,105,'Manikonda','509204',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34430,105,'Manthan Gode','509353',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34431,105,'Marmungal','509153',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34432,105,'Marrikal','509340',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34433,105,'Marrikal','509351',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34434,105,'Mastipur','509130',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34435,105,'Mbn Rs','509001',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34436,105,'Medikonda','509127',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34437,105,'Metlakunta','509338',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34438,105,'Mirzapur','509339',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34439,105,'Mittadoddi','509127',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34440,105,'Mogalmadka','509336',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34441,105,'Mohammadabad','509337',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34442,105,'Motlampally','509131',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34443,105,'Muchintala','509219',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34444,105,'Mudmal','509352',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34445,105,'Mulamalla','509131',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34446,105,'Muldakal','509132',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34447,105,'Munimoksham','509334',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34448,105,'Musapet','509380',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34449,105,'Mushrifa','509339',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34450,105,'Mustipalli','509208',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34451,105,'Nagal Kadmoor','509130',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34452,105,'Nagaram','509204',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34453,105,'Nancherla','509337',1,0,'2022-03-03 12:36:26','2022-03-03 12:36:26'),(34454,105,'Nandaram','509336',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34455,105,'Nandigam','509350',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34456,105,'Nandimalla','509131',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34457,105,'Nandinne','509129',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34458,105,'Narayanpet Bazar','509210',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34459,105,'Narayanpet','509210',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34460,105,'Narsapur','509407',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34461,105,'Narva','509130',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34462,105,'Nawabpet (Mahabub Nagar)','509340',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34463,105,'Neetur','509350',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34464,105,'Nellikondi','509409',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34465,105,'Neredgaon','509208',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34466,105,'Nidgurthy','509205',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34467,105,'Nidijinta','509411',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34468,105,'Osmangunj','509001',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34469,105,'P.C.Kunta','509409',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34470,105,'Pagdimarri','509210',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34471,105,'Paipadu','509126',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34472,105,'Palkonda','509002',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34473,105,'Pallamarri','509409',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34474,105,'Pallepad','509128',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34475,105,'Pallerla','509411',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34476,105,'Palvoi','509132',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34477,105,'Panchalingal','509208',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34478,105,'Panchdev Pahad','509208',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34479,105,'Parpally','509371',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34480,105,'Parsapur','509338',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34481,105,'Parvathapuram','509380',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34482,105,'Pathamolgara','509382',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34483,105,'Pathapalamur','509001',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34484,105,'Patherched','509353',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34485,105,'Pedda Darpally','509334',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34486,105,'Pedda Mungalched','509382',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34487,105,'Peddadinne','509128',1,0,'2022-03-03 12:36:27','2022-03-03 12:36:27'),(34488,105,'Peddamamidala Padu','509128',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34489,105,'Peddaporla','509311',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34490,105,'Peddapothulapad','509128',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34491,105,'Peddatandrapad','509135',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34492,105,'Peddatandrapad','509126',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34493,105,'Pedripadu','509411',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34494,105,'Penchikalpadu','509132',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34495,105,'Perapalla','509210',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34496,105,'Perur','509219',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34497,105,'Polepally','509350',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34498,105,'Polkampally','509382',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34499,105,'Ponnakallu','509382',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34500,105,'Pothreddipalli','509339',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34501,105,'Pothulmadugu','509382',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34502,105,'Pragatur','509153',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34503,105,'Pulikallu','509127',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34504,105,'Pulimamidi','509353',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34505,105,'Pullur','509153',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34506,105,'Pusalpahad','509204',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34507,105,'Puttandoddi','509128',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34508,105,'Puttapahad','509335',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34509,105,'Rachala','509219',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34510,105,'Raikode','509353',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34511,105,'Rajoli (Mahabub Nagar)','509126',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34512,105,'Rakonda','509409',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34513,105,'Ramapuram','509126',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34514,105,'Rampur','509371',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34515,105,'Rampur','509353',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34516,105,'Rawulapally','509336',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34517,105,'Rechintala','509131',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34518,105,'Regadmailwar','509338',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34519,105,'Rekulampalli','509219',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34520,105,'Renwatla','509411',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34521,105,'Rudraram','509336',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34522,105,'Rudrasamudram','509208',1,0,'2022-03-03 12:36:28','2022-03-03 12:36:28'),(34523,105,'Salkarpet','509337',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34524,105,'Sangambanda','509208',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34525,105,'Sarzakhanpet','509339',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34526,105,'Satarla','509128',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34527,105,'Satyawar','509208',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34528,105,'Seri Venkatapur','509371',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34529,105,'Shaik Pally','509337',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34530,105,'Shantinagar','509126',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34531,105,'Sindhanoor','509129',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34532,105,'Singwar','509152',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34533,105,'Singwar','509210',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34534,105,'Solipur','509380',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34535,105,'Suraram','509371',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34536,105,'T.D. Gutta','509001',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34537,105,'Takkasila','509153',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34538,105,'Tangadgi','509352',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34539,105,'Tangal','509135',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34540,105,'Tankara','509334',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34541,105,'Tatikonda','509382',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34542,105,'Tatikunta','509127',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34543,105,'Tekalkode','509336',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34544,105,'Theelair','509351',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34545,105,'Thipdampally','509131',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34546,105,'Thirmalapur','509340',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34547,105,'Thummala Chervu','509132',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34548,105,'Tipraspalli','509311',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34549,105,'Tirmalapur','509335',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34550,105,'Tirumalapur','509210',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34551,105,'Togapur','509339',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34552,105,'Tottinon Doddi','509129',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34553,105,'Tunkimetla','509338',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34554,105,'Udamalgidda','509407',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34555,105,'Udandapur','509128',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34556,105,'Ujjali','509208',1,0,'2022-03-03 12:36:29','2022-03-03 12:36:29'),(34557,105,'Undavelly','509153',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34558,105,'Undekode','509353',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34559,105,'Undiyal','509130',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34560,105,'Uppal','509135',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34561,105,'Uppal Camp','509135',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34562,105,'Utkur','509311',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34563,105,'Uttanur','509127',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34564,105,'Vallur','509128',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34565,105,'Varne','509219',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34566,105,'Veeraipally','509380',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34567,105,'Veerannapet','509001',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34568,105,'Veltur','509382',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34569,105,'Vemula','509128',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34570,105,'Vemula','509380',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34571,105,'Venkatreddypally','509337',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34572,105,'Vepur','509334',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34573,105,'Vinjamur','509371',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34574,105,'Vitalapur','509127',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34575,105,'Vithalapuram','509336',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34576,105,'Wadcherla','509338',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34577,105,'Waddeman','509409',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34578,105,'Waddepalli','509126',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34579,105,'Wadwat','509208',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34580,105,'Warkur','509208',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34581,105,'Wathugundla','509407',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34582,105,'Yamki','509130',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34583,105,'Yanmangandla','509340',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34584,105,'Yapadinne','509135',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34585,105,'Yedira','509002',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34586,105,'Yelkur','509132',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34587,105,'Yenkipalli','509338',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34588,105,'Yenugonda','509002',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34589,105,'Achampet','509375',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34590,105,'Agrial','509207',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34591,105,'Aithole','509209',1,0,'2022-03-03 12:36:30','2022-03-03 12:36:30'),(34592,105,'Ajilapuram','509360',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34593,105,'Ajjakole','509110',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34594,105,'Akkaram','509375',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34595,105,'Akuthotapally','509321',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34596,105,'Aleru','509412',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34597,105,'Alipur','509110',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34598,105,'Alwal','509408',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34599,105,'Amadabakula','509381',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34600,105,'Amangal','509321',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34601,105,'Ambatpally','509401',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34602,105,'Ammapuram','509110',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34603,105,'Ammayapally','509104',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34604,105,'Amrabad','509201',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34605,105,'Ananthavaram','509401',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34606,105,'Andugula','509321',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34607,105,'Annaram','509202',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34608,105,'Antharam','509357',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34609,105,'Appajipally','509406',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34610,105,'Appampally','509110',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34611,105,'Apparala','509110',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34612,105,'Appareddipally','509327',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34613,105,'Appayapally','509401',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34614,105,'Arkepally','509327',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34615,105,'Aurpally','509321',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34616,105,'Ausalikunta','509401',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34617,105,'Avancha','509302',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34618,105,'Ayyavaripalli','509357',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34619,105,'Ayyavaripally','509104',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34620,105,'Ayyavaripally','509105',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34621,105,'Balanagar','509202',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34622,105,'Balanpally','509215',1,0,'2022-03-03 12:36:31','2022-03-03 12:36:31'),(34623,105,'Balmoor','509401',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34624,105,'Banala','509401',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34625,105,'Barkatpally','509360',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34626,105,'Bawajipally','509406',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34627,105,'Bekkem','509104',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34628,105,'Bhairampuram','509360',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34629,105,'Bijnapally','509203',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34630,105,'Boinpally','509357',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34631,105,'Bollampally','509360',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34632,105,'Bollavaram','509105',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34633,105,'Bommanpally','509375',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34634,105,'Bramhanpally','509327',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34635,105,'Buddaram','509206',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34636,105,'Buddasamudram','509302',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34637,105,'Burgula','509202',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34638,105,'Busireddypally','509120',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34639,105,'C.Thirumalapuram','509110',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34640,105,'Chandapur','509120',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34641,105,'Chandapur','509375',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34642,105,'Chandrakal','509412',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34643,105,'Chandubatla','509209',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34644,105,'Charakonda','509324',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34645,105,'Chatanpally','509216',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34646,105,'Chedurpally','509360',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34647,105,'Cheepununthala','509321',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34648,105,'Chegunta','509406',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34649,105,'Chegur','509325',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34650,105,'Chennampally','509401',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34651,105,'Chennaram','509206',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34652,105,'Cherikonda','509321',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34653,105,'Cherkur','509360',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34654,105,'Chilivera','509357',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34655,105,'Chilkamarri','509216',1,0,'2022-03-03 12:36:32','2022-03-03 12:36:32'),(34656,105,'Chimanguntapally','509206',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34657,105,'Chinchod','509410',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34658,105,'Chinnamarur','509104',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34659,105,'Chinnarevally','509408',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34660,105,'Chintakunta','509120',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34661,105,'Chintalapally','509105',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34662,105,'Chitlamkunta','509201',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34663,105,'Chityal','509206',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34664,105,'Chndradana','509357',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34665,105,'Chowdergudem','509207',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34666,105,'Chowdur','509202',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34667,105,'Chowlapally','509408',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34668,105,'Chowlapally','509410',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34669,105,'Chukkapur','509321',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34670,105,'D.Chintalapally','509349',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34671,105,'D.Thirumalapur','509412',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34672,105,'Dagada','509104',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34673,105,'Dantanur','509110',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34674,105,'Dawajipally','509120',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34675,105,'Dhararam','509401',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34676,105,'Donuru','509357',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34677,105,'Doskal','509216',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34678,105,'Duppalli','509110',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34679,105,'Ediganipally','509302',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34680,105,'Eklaskhanpet','509408',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34681,105,'Ekvaipally','509358',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34682,105,'Farooqnagar','509216',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34683,105,'Fathimapur','509325',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34684,105,'Gaddampally','509385',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34685,105,'Gaggalapally','509385',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34686,105,'Gajra','509349',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34687,105,'Gandhichowk','509106',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34688,105,'Gandhichowk (Mahabub Nagar)','509103',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34689,105,'Gangapur','509302',1,0,'2022-03-03 12:36:33','2022-03-03 12:36:33'),(34690,105,'Gangaram','509203',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34691,105,'Gantaraopally','509412',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34692,105,'Ganyagula','509412',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34693,105,'Gattuippalapally','509320',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34694,105,'Gattunellikuduru','509385',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34695,105,'Gattuthumman','509375',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34696,105,'Ghanpur','509375',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34697,105,'Girikothapally','509321',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34698,105,'Godal','509401',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34699,105,'Gokaram','509324',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34700,105,'Gollapally','509302',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34701,105,'Gopalapuram','509105',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34702,105,'Gopalpet','509206',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34703,105,'Gopulapuram','509120',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34704,105,'Gorita','509406',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34705,105,'Gouraram','509385',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34706,105,'Goureddipally','509385',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34707,105,'Gudigani Pally','509357',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34708,105,'Gudipally','509235',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34709,105,'Gumkonda','509406',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34710,105,'Gummadam','509104',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34711,105,'Gunded','509202',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34712,105,'Gundlanarva','509215',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34713,105,'Gundur','509324',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34714,105,'Guntakodur','509209',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34715,105,'Hajipur','509375',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34716,105,'Indrakal','509209',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34717,105,'Inmulnarva','509228',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34718,105,'Inole','509375',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34719,105,'Ippalapally','509406',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34720,105,'Ippalapally','509201',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34721,105,'Ippapahad','509320',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34722,105,'Irwin','509321',1,0,'2022-03-03 12:36:34','2022-03-03 12:36:34'),(34723,105,'J.Thirumalapuram','509206',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34724,105,'Jajala','509324',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34725,105,'Jakinalapally','509320',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34726,105,'Jangamreddypally','509201',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34727,105,'Janumpally','509102',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34728,105,'Japtisadaguda','509376',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34729,105,'Jetaprole','509105',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34730,105,'Jinkunta','509385',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34731,105,'Jonnalabogada','509412',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34732,105,'Julapally','509357',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34733,105,'Jupally','509324',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34734,105,'Kadirepahad','509206',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34735,105,'Kadthal','509358',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34736,105,'Kadukuntla','509381',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34737,105,'Kakunur','509408',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34738,105,'Kalakonda','509360',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34739,105,'Kalwakole','509102',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34740,105,'Kalwakurthy','509324',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34741,105,'Kalwarala','509120',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34742,105,'Kammadanam','509216',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34743,105,'Kamsanipally','509376',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34744,105,'Kanchiraopally','509120',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34745,105,'Kanimetta','509381',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34746,105,'Kanmanur','509381',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34747,105,'Karivena','509302',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34748,105,'Karkalpahad','509358',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34749,105,'Karvanga','509385',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34750,105,'Keshampet','509206',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34751,105,'Keshampet','509408',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34752,105,'Kethepally','509120',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34753,105,'Khanapur','509215',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34754,105,'Khanapur','509321',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34755,105,'Kodair','509102',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34756,105,'Kodgal','509302',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34757,105,'Koduparthy','509406',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34758,105,'Kollapur','509102',1,0,'2022-03-03 12:36:35','2022-03-03 12:36:35'),(34759,105,'Kollur','509202',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34760,105,'Komatikunta','509401',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34761,105,'Konapur','509358',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34762,105,'Kondanagula','509401',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34763,105,'Kondaraopally','509102',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34764,105,'Kondareddipally','509324',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34765,105,'Kondareddipally','509401',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34766,105,'Kondur','509105',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34767,105,'Kondurgu','509207',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34768,105,'Konetipur','509349',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34769,105,'Konnur','509110',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34770,105,'Koppunur','509105',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34771,105,'Kothakota (Mahabub Nagar)','509381',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34772,105,'Kothapally','509357',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34773,105,'Kothapeta','509408',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34774,105,'Kothur','509357',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34775,105,'Kothur','509228',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34776,105,'Kotra','509360',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34777,105,'Kucherkal','509202',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34778,105,'Kudikilla','509102',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34779,105,'Kulkulpally','509327',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34780,105,'Kummaronipally','509201',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34781,105,'Kummera','509215',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34782,105,'Kuppugandla','509360',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34783,105,'Kurumidda','509320',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34784,105,'Laknaram','509385',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34785,105,'Latpally','509203',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34786,105,'Laxmapur','509201',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34787,105,'Laxmapur','509385',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34788,105,'Laxmipally','509104',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34789,105,'Lingala (Mahabub Nagar)','509401',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34790,105,'Lingasanipally','509324',1,0,'2022-03-03 12:36:36','2022-03-03 12:36:36'),(34791,105,'Lingasanipally','509215',1,0,'2022-03-03 12:36:37','2022-03-03 12:36:37'),(34792,105,'Macharam','509201',1,0,'2022-03-03 12:36:37','2022-03-03 12:36:37'),(34793,105,'Machupally','509206',1,0,'2022-03-03 12:36:37','2022-03-03 12:36:37'),(34794,105,'Madanapuram','509110',1,0,'2022-03-03 12:36:37','2022-03-03 12:36:37'),(34795,105,'Maddigatla','509406',1,0,'2022-03-03 12:36:37','2022-03-03 12:36:37'),(34796,105,'Maddimadugu','509201',1,0,'2022-03-03 12:36:37','2022-03-03 12:36:37'),(34797,105,'Maddur','509110',1,0,'2022-03-03 12:36:37','2022-03-03 12:36:37'),(34798,105,'Madgul','509327',1,0,'2022-03-03 12:36:37','2022-03-03 12:36:37'),(34799,105,'Madharam','509320',1,0,'2022-03-03 12:36:37','2022-03-03 12:36:37'),(34800,105,'Madhavanipally','509201',1,0,'2022-03-03 12:36:37','2022-03-03 12:36:37'),(34801,105,'Madhurapuram','509202',1,0,'2022-03-03 12:36:37','2022-03-03 12:36:37'),(34802,105,'Mahadeanpet','509203',1,0,'2022-03-03 12:36:37','2022-03-03 12:36:37'),(34803,105,'Mahmadapur','509120',1,0,'2022-03-03 12:36:37','2022-03-03 12:36:37'),(34804,105,'Malkapur','509385',1,0,'2022-03-03 12:36:37','2022-03-03 12:36:37'),(34805,105,'Malleboinpally','509302',1,0,'2022-03-03 12:36:37','2022-03-03 12:36:37'),(34806,105,'Malleswaram','509105',1,0,'2022-03-03 12:36:37','2022-03-03 12:36:37'),(34807,105,'Mamidipally','509217',1,0,'2022-03-03 12:36:37','2022-03-03 12:36:37'),(34808,105,'Mamidlapally','509385',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34809,105,'Manganoor','509203',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34810,105,'Manigilla','509106',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34811,105,'Mannanur','509201',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34812,105,'Mannevaripally','509375',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34813,105,'Manthati','509385',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34814,105,'Marchala','509320',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34815,105,'Maredu','509201',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34816,105,'Marepally','509406',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34817,105,'Marikal','509412',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34818,105,'Marrikal','509406',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34819,105,'Medipur','509209',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34820,105,'Midjil','509357',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34821,105,'Miraspally','509104',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34822,105,'Mittasadguda','509349',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34823,105,'Mogalgidda','509410',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34824,105,'Molachinthalapally','509102',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34825,105,'Mothighanapur','509202',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34826,105,'Muddunurkalan','509412',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34827,105,'Mudwin','509321',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34828,105,'Mukurala','509324',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34829,105,'Munnanoor','509206',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34830,105,'Mustipally','509412',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34831,105,'Muthireddypally','509206',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34832,105,'Mutpur','509207',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34833,105,'Nadimpally','509375',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34834,105,'Naganool','509209',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34835,105,'Nagapoor','509235',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34836,105,'Nagarkurnool','509209',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34837,105,'Nagilla','509327',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34838,105,'Nagulapally','509216',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34839,105,'Nagulapally','509206',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34840,105,'Nallavelly','509209',1,0,'2022-03-03 12:36:38','2022-03-03 12:36:38'),(34841,105,'Nandigaon','509228',1,0,'2022-03-03 12:36:39','2022-03-03 12:36:39'),(34842,105,'Narsayapally','509102',1,0,'2022-03-03 12:36:39','2022-03-03 12:36:39'),(34843,105,'Nasrullabad','509302',1,0,'2022-03-03 12:36:39','2022-03-03 12:36:39'),(34844,105,'Nerellapally','509302',1,0,'2022-03-03 12:36:39','2022-03-03 12:36:39'),(34845,105,'Nidadavelli','509408',1,0,'2022-03-03 12:36:39','2022-03-03 12:36:39'),(34846,105,'Nyetvally','509104',1,0,'2022-03-03 12:36:39','2022-03-03 12:36:39'),(34847,105,'Padakal','509408',1,0,'2022-03-03 12:36:39','2022-03-03 12:36:39'),(34848,105,'Padara','509201',1,0,'2022-03-03 12:36:39','2022-03-03 12:36:39'),(34849,105,'Palem','509381',1,0,'2022-03-03 12:36:39','2022-03-03 12:36:39'),(34850,105,'Palem','509215',1,0,'2022-03-03 12:36:39','2022-03-03 12:36:39'),(34851,105,'Palkapally','509376',1,0,'2022-03-03 12:36:39','2022-03-03 12:36:39'),(34852,105,'Palmakole','509325',1,0,'2022-03-03 12:36:39','2022-03-03 12:36:39'),(34853,105,'Pamireddipally','509206',1,0,'2022-03-03 12:36:39','2022-03-03 12:36:39'),(34854,105,'Pangal','509120',1,0,'2022-03-03 12:36:39','2022-03-03 12:36:39'),(34855,105,'Panjugula','509324',1,0,'2022-03-03 12:36:39','2022-03-03 12:36:39'),(34856,105,'Papagal','509209',1,0,'2022-03-03 12:36:39','2022-03-03 12:36:39'),(34857,105,'Papireddiguda','509216',1,0,'2022-03-03 12:36:39','2022-03-03 12:36:39'),(34858,105,'Pasupula','509412',1,0,'2022-03-03 12:36:40','2022-03-03 12:36:40'),(34859,105,'Pebbair','509104',1,0,'2022-03-03 12:36:40','2022-03-03 12:36:40'),(34860,105,'Pedamanddadi','509106',1,0,'2022-03-03 12:36:40','2022-03-03 12:36:40'),(34861,105,'Pedda-adirala','509408',1,0,'2022-03-03 12:36:40','2022-03-03 12:36:40'),(34862,105,'Peddagudem','509381',1,0,'2022-03-03 12:36:40','2022-03-03 12:36:40'),(34863,105,'Peddakarpamula','509412',1,0,'2022-03-03 12:36:40','2022-03-03 12:36:40'),(34864,105,'Peddakothapally','509412',1,0,'2022-03-03 12:36:40','2022-03-03 12:36:40'),(34865,105,'Peddamarur','509104',1,0,'2022-03-03 12:36:41','2022-03-03 12:36:41'),(34866,105,'Peddapally','509385',1,0,'2022-03-03 12:36:41','2022-03-03 12:36:41'),(34867,105,'Peddapur','509360',1,0,'2022-03-03 12:36:41','2022-03-03 12:36:41'),(34868,105,'Peddapur','509235',1,0,'2022-03-03 12:36:41','2022-03-03 12:36:41'),(34869,105,'Peddarevally','509408',1,0,'2022-03-03 12:36:41','2022-03-03 12:36:41'),(34870,105,'Peddur','509385',1,0,'2022-03-03 12:36:41','2022-03-03 12:36:41'),(34871,105,'Penimilla','509376',1,0,'2022-03-03 12:36:41','2022-03-03 12:36:41'),(34872,105,'Penjerla','509228',1,0,'2022-03-03 12:36:41','2022-03-03 12:36:41'),(34873,105,'Pentlavally','509105',1,0,'2022-03-03 12:36:41','2022-03-03 12:36:41'),(34874,105,'Pidikiryal','509410',1,0,'2022-03-03 12:36:41','2022-03-03 12:36:41'),(34875,105,'Piratvanipally','509376',1,0,'2022-03-03 12:36:41','2022-03-03 12:36:41'),(34876,105,'Polepally','509360',1,0,'2022-03-03 12:36:41','2022-03-03 12:36:41'),(34877,105,'Polepally','509302',1,0,'2022-03-03 12:36:41','2022-03-03 12:36:41'),(34878,105,'Polepally','509203',1,0,'2022-03-03 12:36:42','2022-03-03 12:36:42'),(34879,105,'Polisettipally','509376',1,0,'2022-03-03 12:36:42','2022-03-03 12:36:42'),(34880,105,'Polkampally','509349',1,0,'2022-03-03 12:36:42','2022-03-03 12:36:42'),(34881,105,'Polkepahad','509206',1,0,'2022-03-03 12:36:42','2022-03-03 12:36:42'),(34882,105,'Pomal','509202',1,0,'2022-03-03 12:36:42','2022-03-03 12:36:42'),(34883,105,'Pomalpally','509202',1,0,'2022-03-03 12:36:42','2022-03-03 12:36:42'),(34884,105,'Pothepally','509360',1,0,'2022-03-03 12:36:42','2022-03-03 12:36:42'),(34885,105,'Pothireddipally','509215',1,0,'2022-03-03 12:36:42','2022-03-03 12:36:42'),(34886,105,'Puljal','509376',1,0,'2022-03-03 12:36:42','2022-03-03 12:36:42'),(34887,105,'Puljala','509385',1,0,'2022-03-03 12:36:42','2022-03-03 12:36:42'),(34888,105,'Rachala Pally','509320',1,0,'2022-03-03 12:36:42','2022-03-03 12:36:42'),(34889,105,'Rachur','509320',1,0,'2022-03-03 12:36:42','2022-03-03 12:36:42'),(34890,105,'Raghupathipeta','509324',1,0,'2022-03-03 12:36:42','2022-03-03 12:36:42'),(34891,105,'Rajapet','509381',1,0,'2022-03-03 12:36:42','2022-03-03 12:36:42'),(34892,105,'Rajapur','509206',1,0,'2022-03-03 12:36:42','2022-03-03 12:36:42'),(34893,105,'Rajapur','509202',1,0,'2022-03-03 12:36:42','2022-03-03 12:36:42'),(34894,105,'Rakonda','509385',1,0,'2022-03-03 12:36:42','2022-03-03 12:36:42'),(34895,105,'Ramapuram','509357',1,0,'2022-03-03 12:36:42','2022-03-03 12:36:42'),(34896,105,'Ramojipally','509376',1,0,'2022-03-03 12:36:42','2022-03-03 12:36:42'),(34897,105,'Ramreddipally','509320',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34898,105,'Rangapur','509375',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34899,105,'Rangapur','509349',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34900,105,'Rangapur','509104',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34901,105,'Rangareddyguda','509202',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34902,105,'Ravichedu','509408',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34903,105,'Ravipakula','509235',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34904,105,'Rayakal','509202',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34905,105,'Rayanpet','509381',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34906,105,'Reddipalem','509325',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34907,105,'Remadla','509206',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34908,105,'Revally','509235',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34909,105,'Revally','509357',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34910,105,'Sangem','509216',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34911,105,'Sanginenipally','509105',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34912,105,'Sankireddypally','509381',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34913,105,'Santhapur','509408',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34914,105,'Sarvareddypally','509349',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34915,105,'Satapur','509412',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34916,105,'Savaigudem','509106',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34917,105,'Shadnagar','509216',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34918,105,'Shagapuram','509120',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34919,105,'Shakapur','509104',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34920,105,'Shapur','509325',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34921,105,'Shayanpally','509203',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34922,105,'Siddapur','509228',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34923,105,'Siddapur','509375',1,0,'2022-03-03 12:36:43','2022-03-03 12:36:43'),(34924,105,'Singayapally','509206',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34925,105,'Singotam','509102',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34926,105,'Sirasanagandla','509324',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34927,105,'Sirsawada','509209',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34928,105,'Sripur','509235',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34929,105,'Srirangapur','509410',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34930,105,'Srirangapur','509120',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34931,105,'Srisailam Dam (West)','509326',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34932,105,'Stn. Jadcherla H.O','509301',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34933,105,'Sugur','509104',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34934,105,'Surapuram','509401',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34935,105,'Tadoor','509209',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34936,105,'Tadoor','509376',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34937,105,'Talakondapally','509321',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34938,105,'Tallapally','509385',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34939,105,'Talpanoor','509235',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34940,105,'Tandra','509324',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34941,105,'Tangellapally','509207',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34942,105,'Tarnikal','509320',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34943,105,'Tatiparthy','509302',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34944,105,'Tatiparthy','509206',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34945,105,'Thelkapally','509385',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34946,105,'Thimmajipet','509406',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34947,105,'Thimmapur','509325',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34948,105,'Thippareddypally','509349',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34949,105,'Thirumalapuram','509201',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34950,105,'Thommidirekula','509408',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34951,105,'Thoodukurthy','509235',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34952,105,'Thotapally','509320',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34953,105,'Thummalapally','509207',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34954,105,'Thummanpet','509375',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34955,105,'Town Jadcherla','509302',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34956,105,'Tumkunta','509105',1,0,'2022-03-03 12:36:44','2022-03-03 12:36:44'),(34957,105,'Turkaplly','509201',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34958,105,'Udimilla','509201',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34959,105,'Udithyala','509202',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34960,105,'Ulpera','509349',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34961,105,'Umapur','509349',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34962,105,'Uppalpahad','509349',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34963,105,'Upparapally','509385',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34964,105,'Uppununthala','509376',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34965,105,'Urkonda','509320',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34966,105,'Urkondapeta','509320',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34967,105,'Uttaraspally','509207',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34968,105,'Uyyalawada','509209',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34969,105,'Vaddeman','509215',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34970,105,'Vadial','509357',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34971,105,'Vallabhapur','509401',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34972,105,'Vallur','509302',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34973,105,'Vangoor','509349',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34974,105,'Vankeswaram','509201',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34975,105,'Vasupala','509357',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34976,105,'Vattem','509203',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34977,105,'Vattipally','509412',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34978,105,'Vatvarlapally','509326',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34979,105,'Veepangandla','509105',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34980,105,'Veerlapally','509325',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34981,105,'Veldanda','509360',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34982,105,'Velgerla','509216',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34983,105,'Velgonda','509105',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34984,105,'Velgonda','509203',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34985,105,'Vellatur','509104',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34986,105,'Veltoor','509376',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34987,105,'Vemula','509357',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34988,105,'Vemulanarva','509408',1,0,'2022-03-03 12:36:45','2022-03-03 12:36:45'),(34989,105,'Venkatampally','509105',1,0,'2022-03-03 12:36:46','2022-03-03 12:36:46'),(34990,105,'Venkatapur','509104',1,0,'2022-03-03 12:36:46','2022-03-03 12:36:46'),(34991,105,'Vennacherla','509235',1,0,'2022-03-03 12:36:46','2022-03-03 12:36:46'),(34992,105,'Vepur','509320',1,0,'2022-03-03 12:36:46','2022-03-03 12:36:46'),(34993,105,'Vittaipally','509321',1,0,'2022-03-03 12:36:46','2022-03-03 12:36:46'),(34994,105,'Wanaparthy H.O','509103',1,0,'2022-03-03 12:36:46','2022-03-03 12:36:46'),(34995,105,'Wanapatla','509209',1,0,'2022-03-03 12:36:46','2022-03-03 12:36:46'),(34996,105,'Yadireddypally','509209',1,0,'2022-03-03 12:36:46','2022-03-03 12:36:46'),(34997,105,'Yaparla','509104',1,0,'2022-03-03 12:36:46','2022-03-03 12:36:46'),(34998,105,'Yapatla','509401',1,0,'2022-03-03 12:36:46','2022-03-03 12:36:46'),(34999,105,'Yedra','509207',1,0,'2022-03-03 12:36:46','2022-03-03 12:36:46'),(35000,105,'Yedula','509206',1,0,'2022-03-03 12:36:46','2022-03-03 12:36:46'),(35001,105,'Yedurepally','509406',1,0,'2022-03-03 12:36:46','2022-03-03 12:36:46'),(35002,105,'Yedutla','509206',1,0,'2022-03-03 12:36:46','2022-03-03 12:36:46'),(35003,105,'Yelikatta','509410',1,0,'2022-03-03 12:36:46','2022-03-03 12:36:46'),(35004,105,'Yelkicherla','509406',1,0,'2022-03-03 12:36:46','2022-03-03 12:36:46'),(35005,105,'Yelkicherla','509207',1,0,'2022-03-03 12:36:46','2022-03-03 12:36:46'),(35006,105,'Yellikal','509324',1,0,'2022-03-03 12:36:46','2022-03-03 12:36:46'),(35007,105,'Yellur','509102',1,0,'2022-03-03 12:36:47','2022-03-03 12:36:47'),(35008,105,'Yelyal','509357',1,0,'2022-03-03 12:36:47','2022-03-03 12:36:47'),(35009,105,'Yemmajipur','509202',1,0,'2022-03-03 12:36:47','2022-03-03 12:36:47'),(35010,105,'Yendabetla','509209',1,0,'2022-03-03 12:36:47','2022-03-03 12:36:47'),(35011,105,'Yenmanbetla','509102',1,0,'2022-03-03 12:36:47','2022-03-03 12:36:47'),(35012,105,'Yettam','509102',1,0,'2022-03-03 12:36:47','2022-03-03 12:36:47'),(35013,106,'Ahmedpur','502278',1,0,'2022-03-03 12:36:47','2022-03-03 12:36:47'),(35014,106,'Akaram','502108',1,0,'2022-03-03 12:36:47','2022-03-03 12:36:47'),(35015,106,'Akkannapet','502115',1,0,'2022-03-03 12:36:47','2022-03-03 12:36:47'),(35016,106,'Akkaram','502311',1,0,'2022-03-03 12:36:47','2022-03-03 12:36:47'),(35017,106,'Akkenapally','502280',1,0,'2022-03-03 12:36:47','2022-03-03 12:36:47'),(35018,106,'Alirajpet','502281',1,0,'2022-03-03 12:36:47','2022-03-03 12:36:47'),(35019,106,'Allipur (Medak)','502310',1,0,'2022-03-03 12:36:47','2022-03-03 12:36:47'),(35020,106,'Alwal','502247',1,0,'2022-03-03 12:36:47','2022-03-03 12:36:47'),(35021,106,'Ambedkarnagar','502103',1,0,'2022-03-03 12:36:47','2022-03-03 12:36:47'),(35022,106,'Amsanipally','502109',1,0,'2022-03-03 12:36:47','2022-03-03 12:36:47'),(35023,106,'Anajipur','502278',1,0,'2022-03-03 12:36:47','2022-03-03 12:36:47'),(35024,106,'Ananthasagar','502247',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35025,106,'Ananthsagar','502267',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35026,106,'Ande','502108',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35027,106,'Ankireddipally','502277',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35028,106,'Ankshapur','502280',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35029,106,'Appanapally','502114',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35030,106,'Arkela','502302',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35031,106,'Ausulapally','502113',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35032,106,'Bacharam','502302',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35033,106,'Baddipadaga','502375',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35034,106,'Bakrichepial','502277',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35035,106,'Banda Posanipally','502117',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35036,106,'Bandaram','502277',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35037,106,'Bangla Venkatapur','502334',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35038,106,'Bayyaram','502278',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35039,106,'Begumpet','502334',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35040,106,'Bejgaon','502278',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35041,106,'Bhailampur','502279',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35042,106,'Bharathnagar Town','502103',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35043,106,'Bhumpally','502102',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35044,106,'Bhupathipur','502117',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35045,106,'Bodagattu','502302',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35046,106,'Boguda Bhupathipur','502113',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35047,106,'Bonala','502247',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35048,106,'Brahamanpally','502334',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35049,106,'Bujrampet','502381',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35050,106,'Burugupally','502113',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35051,106,'Ch.Ankireddipally','502267',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35052,106,'Chandaipet','502247',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35053,106,'Chandampet','502255',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35054,106,'Chandi','502334',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35055,106,'Chandlapur','502276',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35056,106,'Chatlapally','502301',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35057,106,'Chebarthy','502279',1,0,'2022-03-03 12:36:48','2022-03-03 12:36:48'),(35058,106,'Cheelasagr','502279',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35059,106,'Chegunta','502255',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35060,106,'Chellapur','502108',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35061,106,'Chelmeda','502102',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35062,106,'Chepial','502247',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35063,106,'Chikode','502108',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35064,106,'Chinna Gundavelli','502107',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35065,106,'Chinna Kistapur','502301',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35066,106,'Chinna Shivnoor','502255',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35067,106,'Chinthamadaka','502107',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35068,106,'Chittapur','502108',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35069,106,'Choudaram','502310',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35070,106,'Dacharam','502278',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35071,106,'Daripally','502255',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35072,106,'Daulapur','502281',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35073,106,'Dhamarakunta','502281',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35074,106,'Dhanoora','502302',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35075,106,'Dharmajipet','502108',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35076,106,'Dharmaram','502108',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35077,106,'Dharmareddipally','502278',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35078,106,'Dilalpur','502278',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35079,106,'Dommat','502247',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35080,106,'Dongala Dharmaram','502102',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35081,106,'Donthi','502334',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35082,106,'Doulathabad','502247',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35083,106,'Dubbak','502108',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35084,106,'Duddeda','502277',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35085,106,'Dumpalapally','502108',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35086,106,'Elakurthy','502302',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35087,106,'Erraballi','502279',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35088,106,'Errabally','502301',1,0,'2022-03-03 12:36:49','2022-03-03 12:36:49'),(35089,106,'Etigadda Kistapur','502301',1,0,'2022-03-03 12:36:50','2022-03-03 12:36:50'),(35090,106,'Fareedpur','502130',1,0,'2022-03-03 12:36:50','2022-03-03 12:36:50'),(35091,106,'Gambheerpur','502108',1,0,'2022-03-03 12:36:50','2022-03-03 12:36:50'),(35092,106,'Gangapur','502115',1,0,'2022-03-03 12:36:50','2022-03-03 12:36:50'),(35093,106,'Gatlamalyal','502280',1,0,'2022-03-03 12:36:50','2022-03-03 12:36:50'),(35094,106,'Gavvalapally','502248',1,0,'2022-03-03 12:36:50','2022-03-03 12:36:50'),(35095,106,'Ghanpur','502114',1,0,'2022-03-03 12:36:50','2022-03-03 12:36:50'),(35096,106,'Ghanpur','502334',1,0,'2022-03-03 12:36:50','2022-03-03 12:36:50'),(35097,106,'Gollapally','502281',1,0,'2022-03-03 12:36:50','2022-03-03 12:36:50'),(35098,106,'Gonepally','502267',1,0,'2022-03-03 12:36:50','2022-03-03 12:36:50'),(35099,106,'Gouraram','502279',1,0,'2022-03-03 12:36:50','2022-03-03 12:36:50'),(35100,106,'Gudikandula','502114',1,0,'2022-03-03 12:36:50','2022-03-03 12:36:50'),(35101,106,'Gujvail','502278',1,0,'2022-03-03 12:36:50','2022-03-03 12:36:50'),(35102,106,'Gundavelly','502108',1,0,'2022-03-03 12:36:50','2022-03-03 12:36:50'),(35103,106,'Gunreddipally','502335',1,0,'2022-03-03 12:36:50','2022-03-03 12:36:50'),(35104,106,'Gurralagondi','502276',1,0,'2022-03-03 12:36:50','2022-03-03 12:36:50'),(35105,106,'Habsipur','502108',1,0,'2022-03-03 12:36:50','2022-03-03 12:36:50'),(35106,106,'Haveli Ghanpur','502113',1,0,'2022-03-03 12:36:50','2022-03-03 12:36:50'),(35107,106,'Ibrahimnagar','502267',1,0,'2022-03-03 12:36:50','2022-03-03 12:36:50'),(35108,106,'Ibrahimpur','502247',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35109,106,'Ibrahimpur','502107',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35110,106,'Indupial','502247',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35111,106,'Insanpally','502114',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35112,106,'Irkode','502114',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35113,106,'Islampur','502335',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35114,106,'Itikyala','502281',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35115,106,'Jagadevpur','502281',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35116,106,'Jakkapur','502276',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35117,106,'Jaligaon','502278',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35118,106,'Jangapally','502102',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35119,106,'Kadlakal','502336',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35120,106,'Kadloor','502302',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35121,106,'Kalwakunta','502102',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35122,106,'Kanugal','502114',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35123,106,'Kaslabad','502108',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35124,106,'Katrial','502115',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35125,106,'Khajapur','502248',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35126,106,'Khajipur','502102',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35127,106,'Khata','502280',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35128,106,'Kodakandla','502312',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35129,106,'Kodurkurd','502276',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35130,106,'Kokonda','502336',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35131,106,'Kolgur','502278',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35132,106,'Konapur','502102',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35133,106,'Kondapak','502372',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35134,106,'Kondapaka','502331',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35135,106,'Kondapur','502102',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35136,106,'Kongal Ghanpur','502381',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35137,106,'Kothapally','502331',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35138,106,'Kuchanpally','502130',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35139,106,'Kuchavaram','502336',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35140,106,'Kuknoor','502109',1,0,'2022-03-03 12:36:51','2022-03-03 12:36:51'),(35141,106,'Kuknoorpally','502301',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35142,106,'Kulcharam','502381',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35143,106,'Kunthanpally','502335',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35144,106,'Kurthiwada','502331',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35145,106,'Lachapet','502108',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35146,106,'Laxmapur','502115',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35147,106,'Laxminagar','502125',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35148,106,'Lingaipally','502303',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35149,106,'Lingareddipally','502276',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35150,106,'M. Jalalpur.','502109',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35151,106,'Machapur','502276',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35152,106,'Machavaram (Medak)','502109',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35153,106,'Maddulwai','502130',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35154,106,'Madur','502248',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35155,106,'Majeedpally','502334',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35156,106,'Makkarajpet','502247',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35157,106,'Mallampet','502303',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35158,106,'Malyal','502276',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35159,106,'Mamidial','502279',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35160,106,'Mandapally','502267',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35161,106,'Manepally','502109',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35162,106,'Mangalparthy','502109',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35163,106,'Mangole','502301',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35164,106,'Manoharabad','502336',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35165,106,'Markook','502279',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35166,106,'Marpadaga','502372',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35167,106,'Masaipet','502335',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35168,106,'Medak Buss stand','502110',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35169,106,'Medak H.O','502110',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35170,106,'Medak Town','502110',1,0,'2022-03-03 12:36:52','2022-03-03 12:36:52'),(35171,106,'Medipally','502267',1,0,'2022-03-03 12:36:53','2022-03-03 12:36:53'),(35172,106,'Meenajipet','502336',1,0,'2022-03-03 12:36:53','2022-03-03 12:36:53'),(35173,106,'Mirdiddi','502108',1,0,'2022-03-03 12:36:53','2022-03-03 12:36:53'),(35174,106,'Mirzapally','502248',1,0,'2022-03-03 12:36:53','2022-03-03 12:36:53'),(35175,106,'Mittapally','502375',1,0,'2022-03-03 12:36:53','2022-03-03 12:36:53'),(35176,106,'Mothe','502108',1,0,'2022-03-03 12:36:53','2022-03-03 12:36:53'),(35177,106,'Mulugu','502279',1,0,'2022-03-03 12:36:53','2022-03-03 12:36:53'),(35178,106,'Munigadapa','502312',1,0,'2022-03-03 12:36:53','2022-03-03 12:36:53'),(35179,106,'Mupparam','502302',1,0,'2022-03-03 12:36:53','2022-03-03 12:36:53'),(35180,106,'Mutrajpally','502278',1,0,'2022-03-03 12:36:53','2022-03-03 12:36:53'),(35181,106,'Mylaram','502310',1,0,'2022-03-03 12:36:53','2022-03-03 12:36:53'),(35182,106,'Mylaram','502279',1,0,'2022-03-03 12:36:53','2022-03-03 12:36:53'),(35183,106,'Nacharam','502334',1,0,'2022-03-03 12:36:53','2022-03-03 12:36:53'),(35184,106,'Nagapuram','502113',1,0,'2022-03-03 12:36:53','2022-03-03 12:36:53'),(35185,106,'Nagasanipally','502331',1,0,'2022-03-03 12:36:53','2022-03-03 12:36:53'),(35186,106,'Nagulapally','502335',1,0,'2022-03-03 12:36:53','2022-03-03 12:36:53'),(35187,106,'Nangnoor','502280',1,0,'2022-03-03 12:36:53','2022-03-03 12:36:53'),(35188,106,'Narayanaraopet','502107',1,0,'2022-03-03 12:36:53','2022-03-03 12:36:53'),(35189,106,'Narlapur','502102',1,0,'2022-03-03 12:36:53','2022-03-03 12:36:53'),(35190,106,'Narmetta','502375',1,0,'2022-03-03 12:36:53','2022-03-03 12:36:53'),(35191,106,'Narsampally','502279',1,0,'2022-03-03 12:36:53','2022-03-03 12:36:53'),(35192,106,'Narsingee','502248',1,0,'2022-03-03 12:36:54','2022-03-03 12:36:54'),(35193,106,'Naskal','502102',1,0,'2022-03-03 12:36:54','2022-03-03 12:36:54'),(35194,106,'Nehru Road Town','502103',1,0,'2022-03-03 12:36:54','2022-03-03 12:36:54'),(35195,106,'Nemtur','502334',1,0,'2022-03-03 12:36:54','2022-03-03 12:36:54'),(35196,106,'Nizampet (Medak)','502102',1,0,'2022-03-03 12:36:54','2022-03-03 12:36:54'),(35197,106,'Paitara','502381',1,0,'2022-03-03 12:36:54','2022-03-03 12:36:54'),(35198,106,'Palamakula','502375',1,0,'2022-03-03 12:36:54','2022-03-03 12:36:54'),(35199,106,'Pallepahad','502301',1,0,'2022-03-03 12:36:54','2022-03-03 12:36:54'),(35200,106,'Palvancha','502302',1,0,'2022-03-03 12:36:54','2022-03-03 12:36:54'),(35201,106,'Pambanda','502334',1,0,'2022-03-03 12:36:54','2022-03-03 12:36:54'),(35202,106,'Pamulaparthy','502279',1,0,'2022-03-03 12:36:54','2022-03-03 12:36:54'),(35203,106,'Papannapet','502303',1,0,'2022-03-03 12:36:54','2022-03-03 12:36:54'),(35204,106,'Parikibanda','502336',1,0,'2022-03-03 12:36:54','2022-03-03 12:36:54'),(35205,106,'Pathoor','502113',1,0,'2022-03-03 12:36:54','2022-03-03 12:36:54'),(35206,106,'Pedda Koduru','502276',1,0,'2022-03-03 12:36:54','2022-03-03 12:36:54'),(35207,106,'Pedda Masanipally','502372',1,0,'2022-03-03 12:36:54','2022-03-03 12:36:54'),(35208,106,'Peerlapally','502281',1,0,'2022-03-03 12:36:54','2022-03-03 12:36:54'),(35209,106,'Perur','502109',1,0,'2022-03-03 12:36:54','2022-03-03 12:36:54'),(35210,106,'Pidched','502278',1,0,'2022-03-03 12:36:54','2022-03-03 12:36:54'),(35211,106,'Podichanpally','502125',1,0,'2022-03-03 12:36:54','2022-03-03 12:36:54'),(35212,106,'Ponnal','502277',1,0,'2022-03-03 12:36:54','2022-03-03 12:36:54'),(35213,106,'Pothamshettipally','502109',1,0,'2022-03-03 12:36:54','2022-03-03 12:36:54'),(35214,106,'Pothireddipet','502102',1,0,'2022-03-03 12:36:54','2022-03-03 12:36:54'),(35215,106,'Prashanthnagar Town','502103',1,0,'2022-03-03 12:36:54','2022-03-03 12:36:54'),(35216,106,'Pregnapur','502311',1,0,'2022-03-03 12:36:54','2022-03-03 12:36:54'),(35217,106,'Pullur','502107',1,0,'2022-03-03 12:36:54','2022-03-03 12:36:54'),(35218,106,'Raghavapur','502107',1,0,'2022-03-03 12:36:55','2022-03-03 12:36:55'),(35219,106,'Raiploe','502278',1,0,'2022-03-03 12:36:55','2022-03-03 12:36:55'),(35220,106,'Rajakkapat','502108',1,0,'2022-03-03 12:36:55','2022-03-03 12:36:55'),(35221,106,'Rajgopalpet','502375',1,0,'2022-03-03 12:36:55','2022-03-03 12:36:55'),(35222,106,'Rajpally','502117',1,0,'2022-03-03 12:36:55','2022-03-03 12:36:55'),(35223,106,'Rajpet','502113',1,0,'2022-03-03 12:36:55','2022-03-03 12:36:55'),(35224,106,'Ramakkapet','502108',1,0,'2022-03-03 12:36:55','2022-03-03 12:36:55'),(35225,106,'Ramancha','502276',1,0,'2022-03-03 12:36:55','2022-03-03 12:36:55'),(35226,106,'Ramaram','502278',1,0,'2022-03-03 12:36:55','2022-03-03 12:36:55'),(35227,106,'Ramasagar','502278',1,0,'2022-03-03 12:36:55','2022-03-03 12:36:55'),(35228,106,'Ramayampet','502101',1,0,'2022-03-03 12:36:55','2022-03-03 12:36:55'),(35229,106,'Rampur','502109',1,0,'2022-03-03 12:36:55','2022-03-03 12:36:55'),(35230,106,'Rampur','502375',1,0,'2022-03-03 12:36:55','2022-03-03 12:36:55'),(35231,106,'Ramunipatla','502267',1,0,'2022-03-03 12:36:55','2022-03-03 12:36:55'),(35232,106,'Rangampet','502381',1,0,'2022-03-03 12:36:55','2022-03-03 12:36:55'),(35233,106,'Raorukala','502107',1,0,'2022-03-03 12:36:55','2022-03-03 12:36:55'),(35234,106,'Ravelli','502336',1,0,'2022-03-03 12:36:55','2022-03-03 12:36:55'),(35235,106,'Rayalapur','502102',1,0,'2022-03-03 12:36:55','2022-03-03 12:36:55'),(35236,106,'Reddipally','502255',1,0,'2022-03-03 12:36:55','2022-03-03 12:36:55'),(35237,106,'Remanguda','502312',1,0,'2022-03-03 12:36:55','2022-03-03 12:36:55'),(35238,106,'Rudraram','502102',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35239,106,'Ryalamagudu','502109',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35240,106,'S. Kondapur','502117',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35241,106,'Sangaipally','502381',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35242,106,'Sardana','502130',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35243,106,'Settipally Kalan','502117',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35244,106,'Shankarampet','502248',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35245,106,'Shivampet','502334',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35246,106,'Siddipet Busstand','502103',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35247,106,'Siddipet H.O','502103',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35248,106,'Sikindlapur','502267',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35249,106,'Singavatum','502278',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35250,106,'Sirigiripally','502311',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35251,106,'Sirisinagandla','502372',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35252,106,'Surampally','502247',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35253,106,'Suraram','502255',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35254,106,'Tadakapally','502114',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35255,106,'Tampulur','502302',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35256,106,'Teegul','502311',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35257,106,'Teegul Narsapur','502301',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35258,106,'Tekmal','502302',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35259,106,'Thonigandla','502115',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35260,106,'Timmaipally','502113',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35261,106,'Timmapur','502312',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35262,106,'Timmapur','502114',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35263,106,'Timmareddipally','502372',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35264,106,'Tipparam','502301',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35265,106,'Tirumalapur','502278',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35266,106,'Toguta','502130',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35267,106,'Toguta','502372',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35268,106,'Toopran','502334',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35269,106,'Tornal','502114',1,0,'2022-03-03 12:36:56','2022-03-03 12:36:56'),(35270,106,'Tuniki','502336',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35271,106,'Tuniki Bollaram','502279',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35272,106,'Uppu Lingapur','502255',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35273,106,'Varadarajapuram','502281',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35274,106,'Velikatta','502277',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35275,106,'Velkatur','502375',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35276,106,'Veloor','502336',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35277,106,'Vemulagattu','502301',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35278,106,'Venkatapur','502375',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35279,106,'Venkatapur','502114',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35280,106,'Venkatapur','502117',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35281,106,'Venkataraopet','502278',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35282,106,'Vittalapur','502310',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35283,106,'Waddepally','502334',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35284,106,'Wadiaram','502255',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35285,106,'Wargal','502279',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35286,106,'Wariguntham','502381',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35287,106,'Watipally','502312',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35288,106,'Yelapgonda','502302',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35289,106,'Yeldurthy','502255',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35290,106,'Yellapur','502125',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35291,106,'Yellareddypet','502372',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35292,106,'Yenagandla','502381',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35293,106,'Yenagurthy','502108',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35294,106,'Yousufpet','502331',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35295,106,'Zapthi Shivnoor','502248',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35296,106,'Zapti Lingareddipally','502372',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35297,106,'Zapti Nacharam','502372',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35298,106,'A.I.E. R.C.puram','502032',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35299,106,'Abbenda','502286',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35300,106,'Admn. Bldgs','502032',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35301,106,'Aie Bollaram','502325',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35302,106,'Ajjamarry','502314',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35303,106,'Aksanpally','502270',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35304,106,'Algole','502318',1,0,'2022-03-03 12:36:57','2022-03-03 12:36:57'),(35305,106,'Alladurg','502269',1,0,'2022-03-03 12:36:58','2022-03-03 12:36:58'),(35306,106,'Allipur','502318',1,0,'2022-03-03 12:36:58','2022-03-03 12:36:58'),(35307,106,'Almaipet','502273',1,0,'2022-03-03 12:36:58','2022-03-03 12:36:58'),(35308,106,'Ameenpur','502032',1,0,'2022-03-03 12:36:58','2022-03-03 12:36:58'),(35309,106,'Ananthasagar','502286',1,0,'2022-03-03 12:36:58','2022-03-03 12:36:58'),(35310,106,'Ananthavaram','502345',1,0,'2022-03-03 12:36:58','2022-03-03 12:36:58'),(35311,106,'Ananthsagar','502306',1,0,'2022-03-03 12:36:58','2022-03-03 12:36:58'),(35312,106,'Andole','502273',1,0,'2022-03-03 12:36:58','2022-03-03 12:36:58'),(35313,106,'Anegunta','502318',1,0,'2022-03-03 12:36:58','2022-03-03 12:36:58'),(35314,106,'Annaram','502313',1,0,'2022-03-03 12:36:58','2022-03-03 12:36:58'),(35315,106,'Anthargaon','502287',1,0,'2022-03-03 12:36:58','2022-03-03 12:36:58'),(35316,106,'Atmakur','502291',1,0,'2022-03-03 12:36:58','2022-03-03 12:36:58'),(35317,106,'Audatpur','502286',1,0,'2022-03-03 12:36:58','2022-03-03 12:36:58'),(35318,106,'Babulgaon','502291',1,0,'2022-03-03 12:36:58','2022-03-03 12:36:58'),(35319,106,'Bachepally','502371',1,0,'2022-03-03 12:36:58','2022-03-03 12:36:58'),(35320,106,'Badalgaon','502286',1,0,'2022-03-03 12:36:58','2022-03-03 12:36:58'),(35321,106,'Bagareddypally','502318',1,0,'2022-03-03 12:36:58','2022-03-03 12:36:58'),(35322,106,'Baswapur','502293',1,0,'2022-03-03 12:36:58','2022-03-03 12:36:58'),(35323,106,'Bdl Bhanur','502305',1,0,'2022-03-03 12:36:58','2022-03-03 12:36:58'),(35324,106,'Bellapur','502286',1,0,'2022-03-03 12:36:58','2022-03-03 12:36:58'),(35325,106,'Bhanur','502305',1,0,'2022-03-03 12:36:58','2022-03-03 12:36:58'),(35326,106,'Bharatinagar','502032',1,0,'2022-03-03 12:36:58','2022-03-03 12:36:58'),(35327,106,'Bibipet','502287',1,0,'2022-03-03 12:36:58','2022-03-03 12:36:58'),(35328,106,'Bilalpur','502210',1,0,'2022-03-03 12:36:58','2022-03-03 12:36:58'),(35329,106,'Bodamatpally','502269',1,0,'2022-03-03 12:36:58','2022-03-03 12:36:58'),(35330,106,'Bodupatla','502296',1,0,'2022-03-03 12:36:58','2022-03-03 12:36:58'),(35331,106,'Bonthapalli','502313',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35332,106,'Borancha','502290',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35333,106,'Buchnelly','502228',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35334,106,'Budhera','502345',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35335,106,'Burdipahad','502228',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35336,106,'Chalki','502256',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35337,106,'Chandur','502314',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35338,106,'Chapta','502286',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35339,106,'Charakpally','502221',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35340,106,'Cheekurthi','502256',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35341,106,'Cheelapalli','502271',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35342,106,'Cheelpechedu','502314',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35343,106,'Cheriyal','502285',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35344,106,'Chetlapotharam','502319',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35345,106,'Chevella','502269',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35346,106,'Chidruppa','502296',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35347,106,'Chilkepally','502321',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35348,106,'Chilver','502269',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35349,106,'Chinnagottimukla','502313',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35350,106,'Chintakunta','502270',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35351,106,'Chintalcheru','502296',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35352,106,'Chintalghat','502321',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35353,106,'Chitkul','502307',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35354,106,'Chitkul','502270',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35355,106,'Choutkur','502273',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35356,106,'Dakoor','502270',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35357,106,'Damargidda','502286',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35358,106,'Dappur','502251',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35359,106,'Dawoor','502286',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35360,106,'Devnoor','502269',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35361,106,'Dhanasiri','502221',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35362,106,'Didgi','502228',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35363,106,'Digwal','502321',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35364,106,'Doultabad','502296',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35365,106,'Edulapally','502321',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35366,106,'Elmela','502300',1,0,'2022-03-03 12:36:59','2022-03-03 12:36:59'),(35367,106,'Erdanur','502296',1,0,'2022-03-03 12:37:00','2022-03-03 12:37:00'),(35368,106,'Faizabad','502314',1,0,'2022-03-03 12:37:00','2022-03-03 12:37:00'),(35369,106,'Fasalwadi','502294',1,0,'2022-03-03 12:37:00','2022-03-03 12:37:00'),(35370,106,'Gajwada','502290',1,0,'2022-03-03 12:37:00','2022-03-03 12:37:00'),(35371,106,'Gollapalli','502295',1,0,'2022-03-03 12:37:00','2022-03-03 12:37:00'),(35372,106,'Gomaram','502313',1,0,'2022-03-03 12:37:00','2022-03-03 12:37:00'),(35373,106,'Gonglur','502293',1,0,'2022-03-03 12:37:00','2022-03-03 12:37:00'),(35374,106,'Gopanpally','502221',1,0,'2022-03-03 12:37:00','2022-03-03 12:37:00'),(35375,106,'Gorrekal','502269',1,0,'2022-03-03 12:37:00','2022-03-03 12:37:00'),(35376,106,'Gotgarpally','502318',1,0,'2022-03-03 12:37:00','2022-03-03 12:37:00'),(35377,106,'Gottimukla','502290',1,0,'2022-03-03 12:37:00','2022-03-03 12:37:00'),(35378,106,'Gudpally','502221',1,0,'2022-03-03 12:37:00','2022-03-03 12:37:00'),(35379,106,'Gummadidala','502313',1,0,'2022-03-03 12:37:00','2022-03-03 12:37:00'),(35380,106,'Gundlamachnoor','502296',1,0,'2022-03-03 12:37:00','2022-03-03 12:37:00'),(35381,106,'Guntamarpally','502246',1,0,'2022-03-03 12:37:00','2022-03-03 12:37:00'),(35382,106,'Guruzwada','502321',1,0,'2022-03-03 12:37:00','2022-03-03 12:37:00'),(35383,106,'Hadnur','502251',1,0,'2022-03-03 12:37:00','2022-03-03 12:37:00'),(35384,106,'Hanmanthraopet','502286',1,0,'2022-03-03 12:37:00','2022-03-03 12:37:00'),(35385,106,'Hasnabad','502257',1,0,'2022-03-03 12:37:00','2022-03-03 12:37:00'),(35386,106,'Hathnura','502296',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35387,106,'Hoti (B)','502318',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35388,106,'Hulgera','502256',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35389,106,'Icrisat','502324',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35390,106,'IDA Pashamailaram','502307',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35391,106,'Indrakaran','502329',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35392,106,'Indresham','502319',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35393,106,'Ippepally','502221',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35394,106,'Ismailkhanpet','502296',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35395,106,'Isnapur','502307',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35396,106,'Jambgi','502257',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35397,106,'Jeerlapally','502246',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35398,106,'Jinnaram','502319',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35399,106,'Jogipet','502270',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35400,106,'Jukal','502271',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35401,106,'Kadpal','502287',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35402,106,'Kagazmaddur','502313',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35403,106,'Kakijanwada','502256',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35404,106,'Kalbemal','502249',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35405,106,'Kalher','502371',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35406,106,'Kalivemula','502285',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35407,106,'Kamkole','502345',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35408,106,'Kanchanpally','502316',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35409,106,'Kandi','502285',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35410,106,'Kangti','502286',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35411,106,'Kanukunta','502313',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35412,106,'Karamungi','502286',1,0,'2022-03-03 12:37:01','2022-03-03 12:37:01'),(35413,106,'Karasgutti','502286',1,0,'2022-03-03 12:37:02','2022-03-03 12:37:02'),(35414,106,'Karchal','502257',1,0,'2022-03-03 12:37:02','2022-03-03 12:37:02'),(35415,106,'Kasala','502296',1,0,'2022-03-03 12:37:02','2022-03-03 12:37:02'),(35416,106,'Kaveli','502321',1,0,'2022-03-03 12:37:02','2022-03-03 12:37:02'),(35417,106,'Khadeerabad','502270',1,0,'2022-03-03 12:37:02','2022-03-03 12:37:02'),(35418,106,'Khajipet','502316',1,0,'2022-03-03 12:37:02','2022-03-03 12:37:02'),(35419,106,'Khammampally','502345',1,0,'2022-03-03 12:37:02','2022-03-03 12:37:02'),(35420,106,'Khanapur','502210',1,0,'2022-03-03 12:37:02','2022-03-03 12:37:02'),(35421,106,'Khasimpur','502221',1,0,'2022-03-03 12:37:02','2022-03-03 12:37:02'),(35422,106,'Kistareddypet','502319',1,0,'2022-03-03 12:37:02','2022-03-03 12:37:02'),(35423,106,'Kohir','502210',1,0,'2022-03-03 12:37:02','2022-03-03 12:37:02'),(35424,106,'Kolkur','502291',1,0,'2022-03-03 12:37:02','2022-03-03 12:37:02'),(35425,106,'Kollur','502300',1,0,'2022-03-03 12:37:02','2022-03-03 12:37:02'),(35426,106,'Komshetpally','502345',1,0,'2022-03-03 12:37:02','2022-03-03 12:37:02'),(35427,106,'Konapur','502295',1,0,'2022-03-03 12:37:02','2022-03-03 12:37:02'),(35428,106,'Konapur','502291',1,0,'2022-03-03 12:37:02','2022-03-03 12:37:02'),(35429,106,'Kondapur','502306',1,0,'2022-03-03 12:37:02','2022-03-03 12:37:02'),(35430,106,'Konyal','502314',1,0,'2022-03-03 12:37:02','2022-03-03 12:37:02'),(35431,106,'Korpole','502273',1,0,'2022-03-03 12:37:02','2022-03-03 12:37:02'),(35432,106,'Kowdipally','502316',1,0,'2022-03-03 12:37:02','2022-03-03 12:37:02'),(35433,106,'Kowlampet','502329',1,0,'2022-03-03 12:37:02','2022-03-03 12:37:02'),(35434,106,'Krishnapur','502246',1,0,'2022-03-03 12:37:02','2022-03-03 12:37:02'),(35435,106,'Krishnapur','502371',1,0,'2022-03-03 12:37:02','2022-03-03 12:37:02'),(35436,106,'Kuppanagar','502246',1,0,'2022-03-03 12:37:02','2022-03-03 12:37:02'),(35437,106,'Kusangi','502270',1,0,'2022-03-03 12:37:03','2022-03-03 12:37:03'),(35438,106,'Lakdaram','502307',1,0,'2022-03-03 12:37:03','2022-03-03 12:37:03'),(35439,106,'Lingampalli','502345',1,0,'2022-03-03 12:37:03','2022-03-03 12:37:03'),(35440,106,'Lingampalli','502290',1,0,'2022-03-03 12:37:03','2022-03-03 12:37:03'),(35441,106,'Lingapur','502286',1,0,'2022-03-03 12:37:03','2022-03-03 12:37:03'),(35442,106,'Lingapur','502313',1,0,'2022-03-03 12:37:03','2022-03-03 12:37:03'),(35443,106,'Lingapur','502314',1,0,'2022-03-03 12:37:03','2022-03-03 12:37:03'),(35444,106,'Lonikurd','502345',1,0,'2022-03-03 12:37:03','2022-03-03 12:37:03'),(35445,106,'Machireddypally','502210',1,0,'2022-03-03 12:37:03','2022-03-03 12:37:03'),(35446,106,'Machnoor','502246',1,0,'2022-03-03 12:37:03','2022-03-03 12:37:03'),(35447,106,'Maddikunta','502291',1,0,'2022-03-03 12:37:03','2022-03-03 12:37:03'),(35448,106,'Madgi','502221',1,0,'2022-03-03 12:37:03','2022-03-03 12:37:03'),(35449,106,'Madharam','502319',1,0,'2022-03-03 12:37:03','2022-03-03 12:37:03'),(35450,106,'Madhunagar','502228',1,0,'2022-03-03 12:37:03','2022-03-03 12:37:03'),(35451,106,'Madri','502321',1,0,'2022-03-03 12:37:03','2022-03-03 12:37:03'),(35452,106,'Makta Kyasaram','502345',1,0,'2022-03-03 12:37:03','2022-03-03 12:37:03'),(35453,106,'Makta Laxmapur','502271',1,0,'2022-03-03 12:37:03','2022-03-03 12:37:03'),(35454,106,'Malchalma','502318',1,0,'2022-03-03 12:37:03','2022-03-03 12:37:03'),(35455,106,'Malkapur (Jadi)','502318',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35456,106,'Malkapur','502295',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35457,106,'Mallepalli','502295',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35458,106,'Mallikarjunpally','502345',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35459,106,'Mamidgi','502249',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35460,106,'Mangapet','502319',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35461,106,'Maniyarpally','502210',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35462,106,'Manjira Barrage','502294',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35463,106,'Mannapur','502221',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35464,106,'Manthoor','502293',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35465,106,'Manur','502286',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35466,106,'Mardi','502287',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35467,106,'Marepalli','502306',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35468,106,'Marvelli','502270',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35469,106,'Masanpally','502371',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35470,106,'Metalkunta','502249',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35471,106,'Mig Colony','502032',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35472,106,'Minpur','502293',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35473,106,'Mirzapur (Medak)','502249',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35474,106,'Mogudampally','502221',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35475,106,'Mohammed Nagar','502316',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35476,106,'Moosapet','502271',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35477,106,'Moosapet','502313',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35478,106,'Morgi','502286',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35479,106,'Mudimanik','502273',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35480,106,'Mungi','502251',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35481,106,'Munipalli','502345',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35482,106,'Muslapur','502269',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35483,106,'Muthangi','502300',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35484,106,'Mutrajpally','502316',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35485,106,'Naganpally','502287',1,0,'2022-03-03 12:37:04','2022-03-03 12:37:04'),(35486,106,'Nagdhar','502371',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35487,106,'Nagoor','502286',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35488,106,'Nagulapalli','502300',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35489,106,'Nagulapalli','502313',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35490,106,'Nallvalli','502313',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35491,106,'Nandigaon','502300',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35492,106,'Nandikandi','502306',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35493,106,'Narayankhed','502286',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35494,106,'Narsapur (Medak)','502313',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35495,106,'Neredigunta','502270',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35496,106,'Ngo\'s Colony','502318',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35497,106,'Nidijipla','502270',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35498,106,'Nizampet (Sangareddy)','502371',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35499,106,'Nizampur','502291',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35500,106,'Nyalkal','502256',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35501,106,'O.F.Yeddumailaram','502205',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35502,106,'Ootla','502319',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35503,106,'P.R.Pally Chowrasta','502295',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35504,106,'Paidigummal','502210',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35505,106,'Pampad','502257',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35506,106,'Panyal','502314',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35507,106,'Pashamailaram','502307',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35508,106,'Pastapur','502318',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35509,106,'Patancheru Ie','502319',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35510,106,'Patancheru Ph.II','502319',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35511,106,'Patancheru','502319',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35512,106,'Pati','502300',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35513,106,'Pati Ghanpur','502300',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35514,106,'Peddachintakunta','502313',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35515,106,'Peddagottimukla','502313',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35516,106,'Peddakanjarla','502319',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35517,106,'Peddapur','502270',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35518,106,'Peddapur','502306',1,0,'2022-03-03 12:37:05','2022-03-03 12:37:05'),(35519,106,'Peddareddypet','502293',1,0,'2022-03-03 12:37:06','2022-03-03 12:37:06'),(35520,106,'Peepalpalli','502257',1,0,'2022-03-03 12:37:06','2022-03-03 12:37:06'),(35521,106,'Picharagadi','502210',1,0,'2022-03-03 12:37:06','2022-03-03 12:37:06'),(35522,106,'Pillutla','502313',1,0,'2022-03-03 12:37:06','2022-03-03 12:37:06'),(35523,106,'Pocharam','502293',1,0,'2022-03-03 12:37:06','2022-03-03 12:37:06'),(35524,106,'Posanipet','502270',1,0,'2022-03-03 12:37:06','2022-03-03 12:37:06'),(35525,106,'Pothareddypally','502210',1,0,'2022-03-03 12:37:06','2022-03-03 12:37:06'),(35526,106,'Pothulaboguda','502269',1,0,'2022-03-03 12:37:06','2022-03-03 12:37:06'),(35527,106,'Priyadarshininagar','502291',1,0,'2022-03-03 12:37:06','2022-03-03 12:37:06'),(35528,106,'Pulkal','502293',1,0,'2022-03-03 12:37:06','2022-03-03 12:37:06'),(35529,106,'Pulkurthi','502286',1,0,'2022-03-03 12:37:06','2022-03-03 12:37:06'),(35530,106,'Raikode','502257',1,0,'2022-03-03 12:37:06','2022-03-03 12:37:06'),(35531,106,'Raipally','502269',1,0,'2022-03-03 12:37:06','2022-03-03 12:37:06'),(35532,106,'Rajampet Colony','502001',1,0,'2022-03-03 12:37:06','2022-03-03 12:37:06'),(35533,106,'Rajnelli','502321',1,0,'2022-03-03 12:37:06','2022-03-03 12:37:06'),(35534,106,'Ramachandrapuram He','502032',1,0,'2022-03-03 12:37:06','2022-03-03 12:37:06'),(35535,106,'Ramachanrapuram Village','502032',1,0,'2022-03-03 12:37:06','2022-03-03 12:37:06'),(35536,106,'Ramsanpalli','502270',1,0,'2022-03-03 12:37:06','2022-03-03 12:37:06'),(35537,106,'Ranjhole','502318',1,0,'2022-03-03 12:37:07','2022-03-03 12:37:07'),(35538,106,'Rasool','502287',1,0,'2022-03-03 12:37:07','2022-03-03 12:37:07'),(35539,106,'Ratnapur','502251',1,0,'2022-03-03 12:37:07','2022-03-03 12:37:07'),(35540,106,'Ratnapur','502313',1,0,'2022-03-03 12:37:07','2022-03-03 12:37:07'),(35541,106,'Rayalapur','502316',1,0,'2022-03-03 12:37:07','2022-03-03 12:37:07'),(35542,106,'Regode','502290',1,0,'2022-03-03 12:37:07','2022-03-03 12:37:07'),(35543,106,'Rejinthal','502249',1,0,'2022-03-03 12:37:07','2022-03-03 12:37:07'),(35544,106,'Rudrar','502286',1,0,'2022-03-03 12:37:07','2022-03-03 12:37:07'),(35545,106,'Rudraram','502329',1,0,'2022-03-03 12:37:07','2022-03-03 12:37:07'),(35546,106,'Rustumpet','502313',1,0,'2022-03-03 12:37:07','2022-03-03 12:37:07'),(35547,106,'Ryakal','502287',1,0,'2022-03-03 12:37:07','2022-03-03 12:37:07'),(35548,106,'Sadasivpet','502291',1,0,'2022-03-03 12:37:07','2022-03-03 12:37:07'),(35549,106,'Sajjapur','502210',1,0,'2022-03-03 12:37:07','2022-03-03 12:37:07'),(35550,106,'Sangareddy B/s Complex','502001',1,0,'2022-03-03 12:37:07','2022-03-03 12:37:07'),(35551,106,'Sangareddy Collectorate','502001',1,0,'2022-03-03 12:37:07','2022-03-03 12:37:07'),(35552,106,'Sangareddy H.O','502001',1,0,'2022-03-03 12:37:07','2022-03-03 12:37:07'),(35553,106,'Sanjeevaraopet','502286',1,0,'2022-03-03 12:37:07','2022-03-03 12:37:07'),(35554,106,'Satwar','502221',1,0,'2022-03-03 12:37:07','2022-03-03 12:37:07'),(35555,106,'Shaikapur','502318',1,0,'2022-03-03 12:37:07','2022-03-03 12:37:07'),(35556,106,'Shankarampet Bazar','502271',1,0,'2022-03-03 12:37:07','2022-03-03 12:37:07'),(35557,106,'Shankarampet','502271',1,0,'2022-03-03 12:37:07','2022-03-03 12:37:07'),(35558,106,'Shelgera','502286',1,0,'2022-03-03 12:37:07','2022-03-03 12:37:07'),(35559,106,'Shivampet','502273',1,0,'2022-03-03 12:37:07','2022-03-03 12:37:07'),(35560,106,'Shivanagar','502319',1,0,'2022-03-03 12:37:08','2022-03-03 12:37:08'),(35561,106,'Sikindaspur','502296',1,0,'2022-03-03 12:37:08','2022-03-03 12:37:08'),(35562,106,'Singoor Project','502293',1,0,'2022-03-03 12:37:08','2022-03-03 12:37:08'),(35563,106,'Singtham','502257',1,0,'2022-03-03 12:37:08','2022-03-03 12:37:08'),(35564,106,'Sirgapur','502287',1,0,'2022-03-03 12:37:08','2022-03-03 12:37:08'),(35565,106,'Sirpura','502314',1,0,'2022-03-03 12:37:08','2022-03-03 12:37:08'),(35566,106,'Sommakkapet','502314',1,0,'2022-03-03 12:37:08','2022-03-03 12:37:08'),(35567,106,'Sultanabad','502287',1,0,'2022-03-03 12:37:08','2022-03-03 12:37:08'),(35568,106,'Sultanpur','502319',1,0,'2022-03-03 12:37:08','2022-03-03 12:37:08'),(35569,106,'Suraram','502291',1,0,'2022-03-03 12:37:08','2022-03-03 12:37:08'),(35570,106,'Sureddy Itikyal','502273',1,0,'2022-03-03 12:37:08','2022-03-03 12:37:08'),(35571,106,'Tadkal','502287',1,0,'2022-03-03 12:37:08','2022-03-03 12:37:08'),(35572,106,'Tadlapally','502294',1,0,'2022-03-03 12:37:08','2022-03-03 12:37:08'),(35573,106,'Taherkhanpet','502296',1,0,'2022-03-03 12:37:08','2022-03-03 12:37:08'),(35574,106,'Tangadpalli','502291',1,0,'2022-03-03 12:37:08','2022-03-03 12:37:08'),(35575,106,'Tatpalli','502345',1,0,'2022-03-03 12:37:08','2022-03-03 12:37:08'),(35576,106,'Tellapur','502032',1,0,'2022-03-03 12:37:08','2022-03-03 12:37:08'),(35577,106,'Tenkati','502271',1,0,'2022-03-03 12:37:08','2022-03-03 12:37:08'),(35578,106,'Terpole','502295',1,0,'2022-03-03 12:37:08','2022-03-03 12:37:08'),(35579,106,'Togarpalli','502306',1,0,'2022-03-03 12:37:08','2022-03-03 12:37:08'),(35580,106,'Topgonda','502285',1,0,'2022-03-03 12:37:08','2022-03-03 12:37:08'),(35581,106,'Tornal','502286',1,0,'2022-03-03 12:37:08','2022-03-03 12:37:08'),(35582,106,'Tunki','502316',1,0,'2022-03-03 12:37:08','2022-03-03 12:37:08'),(35583,106,'Uthloor','502271',1,0,'2022-03-03 12:37:08','2022-03-03 12:37:08'),(35584,106,'Vailal','502319',1,0,'2022-03-03 12:37:08','2022-03-03 12:37:08'),(35585,106,'Vallur','502286',1,0,'2022-03-03 12:37:09','2022-03-03 12:37:09'),(35586,106,'Veltoor','502291',1,0,'2022-03-03 12:37:09','2022-03-03 12:37:09'),(35587,106,'Vendikole','502273',1,0,'2022-03-03 12:37:09','2022-03-03 12:37:09'),(35588,106,'Venkatapur','502291',1,0,'2022-03-03 12:37:09','2022-03-03 12:37:09'),(35589,106,'Venkatapur','502321',1,0,'2022-03-03 12:37:09','2022-03-03 12:37:09'),(35590,106,'Waddepalli','502296',1,0,'2022-03-03 12:37:09','2022-03-03 12:37:09'),(35591,106,'Waddi','502251',1,0,'2022-03-03 12:37:09','2022-03-03 12:37:09'),(35592,106,'Wasar','502286',1,0,'2022-03-03 12:37:09','2022-03-03 12:37:09'),(35593,106,'Yedakulapalli','502321',1,0,'2022-03-03 12:37:09','2022-03-03 12:37:09'),(35594,106,'Yeddumailaram','502285',1,0,'2022-03-03 12:37:09','2022-03-03 12:37:09'),(35595,106,'Yelgoi','502249',1,0,'2022-03-03 12:37:09','2022-03-03 12:37:09'),(35596,106,'Yelgoi','502286',1,0,'2022-03-03 12:37:09','2022-03-03 12:37:09'),(35597,106,'Yelmakanna','502316',1,0,'2022-03-03 12:37:09','2022-03-03 12:37:09'),(35598,106,'Yenkemuri','502286',1,0,'2022-03-03 12:37:09','2022-03-03 12:37:09'),(35599,106,'Zaheerabad H.O','502220',1,0,'2022-03-03 12:37:09','2022-03-03 12:37:09'),(35600,106,'Zarasangam','502246',1,0,'2022-03-03 12:37:09','2022-03-03 12:37:09'),(35601,107,'Addagudur','508277',1,0,'2022-03-03 12:37:09','2022-03-03 12:37:09'),(35602,107,'Aipur','508114',1,0,'2022-03-03 12:37:09','2022-03-03 12:37:09'),(35603,107,'Akkinepally','508254',1,0,'2022-03-03 12:37:09','2022-03-03 12:37:09'),(35604,107,'Alair','508101',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35605,107,'Alwal','508377',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35606,107,'Ambala','508277',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35607,107,'Ammanabole','508254',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35608,107,'Anajipur','508285',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35609,107,'Anantharam','508101',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35610,107,'Anatharam','508117',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35611,107,'Angadipet','508255',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35612,107,'Anjajipur','508277',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35613,107,'Annerparthy','508254',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35614,107,'Anthampet','508245',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35615,107,'Anumula','508377',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35616,107,'Appajipet','508002',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35617,107,'Arroor','508112',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35618,107,'Athmakur','508111',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35619,107,'Azmapur','508243',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35620,107,'Banda Timmapur','508243',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35621,107,'Bangarigadda','508255',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35622,107,'Baswapur','508117',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35623,107,'Begumpeta','508105',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35624,107,'Bhattugudem','508126',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35625,107,'Bhongir Gunj','508117',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35626,107,'Bhongir H.O','508116',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35627,107,'Bibinagar','508126',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35628,107,'Bijilapuram','508277',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35629,107,'Bodangaparthy','508244',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35630,107,'Bodduguda','508277',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35631,107,'Bogaram','508113',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35632,107,'Bogguladone','508258',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35633,107,'Bollanpally','508258',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35634,107,'Bollepally','508285',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35635,107,'Bommalaramaram','508126',1,0,'2022-03-03 12:37:10','2022-03-03 12:37:10'),(35636,107,'Bondugula','508105',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35637,107,'Bottuguda','508001',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35638,107,'Brahmana Vellemla','508114',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35639,107,'Brahmanapally','508126',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35640,107,'Chada','508111',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35641,107,'Chalakuthy','508202',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35642,107,'Challur','508105',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35643,107,'Chamalapally','508256',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35644,107,'Chamdampet','508258',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35645,107,'Chandepally','508111',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35646,107,'Chandupatla','508286',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35647,107,'Chandur (Nalgonda)','508255',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35648,107,'Cheemalkondur','508286',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35649,107,'Chelmada','508253',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35650,107,'Chepur So','508256',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35651,107,'Cherla Gouraram','508004',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35652,107,'Cherlapally','508002',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35653,107,'Cherughat','508254',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35654,107,'Cherukupally','508258',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35655,107,'Chikatimamidi','508244',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35656,107,'Chikatimamidi','508117',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35657,107,'Chilakamarry','508257',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35658,107,'Chillapur','508253',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35659,107,'Chinakondur','508252',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35660,107,'Chinna Adisarlapally','508243',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35661,107,'Chinnakandukur','508286',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35662,107,'Chintakuntla','508243',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35663,107,'Chinthalapalem','508202',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35664,107,'Chinthapalli','508250',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35665,107,'Chirragudur','508277',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35666,107,'Chitriyala','508248',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35667,107,'Chittapur','508112',1,0,'2022-03-03 12:37:11','2022-03-03 12:37:11'),(35668,107,'Chityala','508114',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35669,107,'Cholla Ramaram','508277',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35670,107,'Choller','508286',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35671,107,'Choutupala','508252',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35672,107,'Clock Tower (Nalgonda)','508001',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35673,107,'Dacharam','508277',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35674,107,'Damera','508245',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35675,107,'Damera Bheemanapally','508245',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35676,107,'Dandampally','508002',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35677,107,'Dattaipally','508115',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35678,107,'Dattappagudem','508277',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35679,107,'Dattarpally','508115',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35680,107,'Devalammanagaram','508252',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35681,107,'Devathpally','508243',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35682,107,'Deverkonda','508248',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35683,107,'Dharmaram','508277',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35684,107,'Dindi Project','508258',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35685,107,'Domalapally','508244',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35686,107,'Dorepally','508004',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35687,107,'Dubbaka','508113',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35688,107,'Dudi Venkatapur','508105',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35689,107,'Duppally','508111',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35690,107,'Edullaguda','508112',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35691,107,'G. Aeroli','508255',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35692,107,'G. Bhimanapally','508257',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35693,107,'Gadia Gowraram','508250',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35694,107,'Gagillapur','508248',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35695,107,'Gandhamalla','508115',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35696,107,'Gandhinagar (Nalgonda)','508248',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35697,107,'Gatlamallepally','508373',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35698,107,'Gattusingaram','508277',1,0,'2022-03-03 12:37:12','2022-03-03 12:37:12'),(35699,107,'Ghanpur','508257',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35700,107,'Ghattuppala','508253',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35701,107,'Gokaram','508252',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35702,107,'Golankonda','508101',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35703,107,'Gonaboinpally','508258',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35704,107,'Goparajupally','508112',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35705,107,'Gottimukkala','508248',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35706,107,'Govindapuram','508277',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35707,107,'Gowraipally','508105',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35708,107,'Gudapur','508244',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35709,107,'Gudimalkapur','508253',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35710,107,'Gudipalli','508257',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35711,107,'Gudur','508126',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35712,107,'Gujja','508253',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35713,107,'Gummadavally','508257',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35714,107,'Gundala','508277',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35715,107,'Gundrampally','508114',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35716,107,'Gundrepalli','508255',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35717,107,'Gurrampode','508256',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35718,107,'Hajipur','508126',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35719,107,'Halia','508377',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35720,107,'Hanumapur','508117',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35721,107,'Hill Colony','508202',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35722,107,'Ibrahimpur','508115',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35723,107,'Iddampally','508248',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35724,107,'Idikuda','508255',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35725,107,'Ikkurthy','508286',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35726,107,'Indriyala','508284',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35727,107,'Indurthy','508245',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35728,107,'Injamoor','508250',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35729,107,'Inkriyala','508126',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35730,107,'Iskilla Boi','508113',1,0,'2022-03-03 12:37:13','2022-03-03 12:37:13'),(35731,107,'Jaikesaram','508252',1,0,'2022-03-03 12:37:14','2022-03-03 12:37:14'),(35732,107,'Jainapally','508126',1,0,'2022-03-03 12:37:14','2022-03-03 12:37:14'),(35733,107,'Jala Singaram','508105',1,0,'2022-03-03 12:37:14','2022-03-03 12:37:14'),(35734,107,'Jalapur','508126',1,0,'2022-03-03 12:37:14','2022-03-03 12:37:14'),(35735,107,'Jameelpet','508126',1,0,'2022-03-03 12:37:14','2022-03-03 12:37:14'),(35736,107,'Janampally','508113',1,0,'2022-03-03 12:37:14','2022-03-03 12:37:14'),(35737,107,'Jangampally','508115',1,0,'2022-03-03 12:37:14','2022-03-03 12:37:14'),(35738,107,'Jangaon','508253',1,0,'2022-03-03 12:37:14','2022-03-03 12:37:14'),(35739,107,'Jiblakpally','508284',1,0,'2022-03-03 12:37:14','2022-03-03 12:37:14'),(35740,107,'Julur','508284',1,0,'2022-03-03 12:37:14','2022-03-03 12:37:14'),(35741,107,'Junuthala','508256',1,0,'2022-03-03 12:37:14','2022-03-03 12:37:14'),(35742,107,'Kachamram','508115',1,0,'2022-03-03 12:37:14','2022-03-03 12:37:14'),(35743,107,'Kacharajupally','508248',1,0,'2022-03-03 12:37:14','2022-03-03 12:37:14'),(35744,107,'Kakkireni','508113',1,0,'2022-03-03 12:37:14','2022-03-03 12:37:14'),(35745,107,'Kakula Kondaram','508002',1,0,'2022-03-03 12:37:14','2022-03-03 12:37:14'),(35746,107,'Kambalapally','508248',1,0,'2022-03-03 12:37:14','2022-03-03 12:37:14'),(35747,107,'Kamepally','508258',1,0,'2022-03-03 12:37:14','2022-03-03 12:37:14'),(35748,107,'Kanagal','508255',1,0,'2022-03-03 12:37:14','2022-03-03 12:37:14'),(35749,107,'Kanchana Palli','508002',1,0,'2022-03-03 12:37:14','2022-03-03 12:37:14'),(35750,107,'Kanchanapally','508285',1,0,'2022-03-03 12:37:14','2022-03-03 12:37:14'),(35751,107,'Kanchariapally','508277',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35752,107,'Kandukur','508258',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35753,107,'Kaparthy Khurd','508114',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35754,107,'Kapraipally','508111',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35755,107,'Kastala','508255',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35756,107,'Katepally','508111',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35757,107,'Kesharajpally','508002',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35758,107,'Khanapur','508258',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35759,107,'Kistapur','508114',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35760,107,'Kolanpaka','508101',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35761,107,'Kollur','508101',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35762,107,'Kompally','508377',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35763,107,'Kompally','508244',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35764,107,'Kondabheemanapally','508248',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35765,107,'Kondagadapa','508277',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35766,107,'Kondamadugu','508126',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35767,107,'Kondamallepalli','508243',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35768,107,'Kondapur','508244',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35769,107,'Koppole','508256',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35770,107,'Koratikal','508111',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35771,107,'Koratikal','508244',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35772,107,'Kotamarthy','508277',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35773,107,'Kothapally','508248',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35774,107,'Koyyalagudem','508252',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35775,107,'Kudabakashpally','508245',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35776,107,'Kunur','508286',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35777,107,'Kurella','508111',1,0,'2022-03-03 12:37:15','2022-03-03 12:37:15'),(35778,107,'Kurmapally','508250',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35779,107,'Kurmedu','508250',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35780,107,'Laxmapur','508113',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35781,107,'Lenkalapally','508245',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35782,107,'Lingojigudem','508252',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35783,107,'Lohepally','508245',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35784,107,'M.Turkapally','508112',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35785,107,'Mada Yadavalli','508254',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35786,107,'Madanapur','508250',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35787,107,'Madhapur','508117',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35788,107,'Malkapuram','508252',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35789,107,'Mallapur','508115',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35790,107,'Mallareddypally','508248',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35791,107,'Mandra','508114',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35792,107,'Manyamchelka','508001',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35793,107,'Maqdoompally','508285',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35794,107,'Marepally','508377',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35795,107,'Marriguda','508002',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35796,107,'Marriguda','508245',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35797,107,'Marripadaga','508101',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35798,107,'Maryal','508117',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35799,107,'Masaipet','508115',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35800,107,'Masampally','508277',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35801,107,'Mattor','508286',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35802,107,'Medaram','508266',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35803,107,'Medipally','508117',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35804,107,'Medlavai','508373',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35805,107,'Merada','508114',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35806,107,'Mogilipaka','508112',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35807,107,'Mosangi','508257',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35808,107,'Motakondur','508286',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35809,107,'Mothcore','508277',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35810,107,'Mududandla','508258',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35811,107,'Mudugonda','508248',1,0,'2022-03-03 12:37:16','2022-03-03 12:37:16'),(35812,107,'Munipampula','508113',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35813,107,'Munugode','508244',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35814,107,'Muripirala','508111',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35815,107,'Murpunuthala','508248',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35816,107,'Musipatla','508277',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35817,107,'Mustipally','508243',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35818,107,'Nadikuda','508256',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35819,107,'Nagaram','508112',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35820,107,'Naginenipally','508126',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35821,107,'Nalgonda H.O','508001',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35822,107,'Namila','508105',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35823,107,'Nampalli','508373',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35824,107,'Nandanam','508285',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35825,107,'Narayanpur (Nalgonda)','508253',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35826,107,'Narketpalli','508254',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35827,107,'Narsinghbhatla','508244',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35828,107,'Nasarlapally','508250',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35829,107,'Nellikal','508202',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35830,107,'Nemmani','508254',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35831,107,'Neredugum','508248',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35832,107,'Nerellapally','508245',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35833,107,'Nermata','508255',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35834,107,'Nyalapatla','508252',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35835,107,'Oldabadi','508001',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35836,107,'Ookondi','508244',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35837,107,'Padmatpally','508248',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35838,107,'Pagidimarry','508004',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35839,107,'Pahilwanpur','508285',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35840,107,'Paladugu','508111',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35841,107,'Palivela','508244',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35842,107,'Pallepahad','508117',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35843,107,'Pallepahad','508111',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35844,107,'Pallepahada','508254',1,0,'2022-03-03 12:37:17','2022-03-03 12:37:17'),(35845,107,'Pallerla','508111',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35846,107,'Pallivada','508113',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35847,107,'Palvai','508257',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35848,107,'Pamukunta','508105',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35849,107,'Pangal','508002',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35850,107,'Panthangi','508252',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35851,107,'Parupally','508111',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35852,107,'Parupally','508105',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35853,107,'Parvedula','508266',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35854,107,'Pasnoor','508373',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35855,107,'Patimatla','508277',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35856,107,'Peda Adisarlapally','508243',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35857,107,'Peda Kandukur','508286',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35858,107,'Pedakaparthy','508114',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35859,107,'Pedavoora','508266',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35860,107,'Peddamunigal','508248',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35861,107,'Peddapuram','508373',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35862,107,'Peddatoor','508112',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35863,107,'Peepalpahad','508252',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35864,107,'Pendipakala','508243',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35865,107,'Perepally','508114',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35866,107,'Perur','508377',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35867,107,'Pervail','508248',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35868,107,'Pillaipally','508284',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35869,107,'Pittalaguda','508256',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35870,107,'Pochampalli (Nalgonda)','508284',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35871,107,'Pochamppaly','508256',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35872,107,'Podichedu','508277',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35873,107,'Pogilla','508248',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35874,107,'Polepally','508248',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35875,107,'Polepally Ramnagar','508245',1,0,'2022-03-03 12:37:18','2022-03-03 12:37:18'),(35876,107,'Ponugode','508255',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35877,107,'Pothunur','508266',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35878,107,'Powerhouse Hostel','508202',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35879,107,'Pulicherla','508266',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35880,107,'Puligilla','508285',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35881,107,'Pulipalupula','508244',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35882,107,'Pullemla','508255',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35883,107,'Puttapaka','508253',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35884,107,'Pyararam','508117',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35885,107,'Raghunathpur (Nalgonda)','508105',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35886,107,'Rahgavapur','508126',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35887,107,'Rahimkhanpeta','508111',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35888,107,'Rahmanthapur','508258',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35889,107,'Raigiri','508286',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35890,107,'Rajapeta','508105',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35891,107,'Rajavaram','508377',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35892,107,'Ramagiri','508002',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35893,107,'Ramalingampally','508126',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35894,107,'Ramamram','508277',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35895,107,'Ramannnapeta','508113',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35896,107,'Rangundla','508377',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35897,107,'Redlarepaka','508285',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35898,107,'Regatta','508255',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35899,107,'Renikunta','508105',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35900,107,'Repakapatti','508277',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35901,107,'Rustapur','508117',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35902,107,'Saidapuram','508115',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35903,107,'Sangam','508252',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35904,107,'Sarvepally','508111',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35905,107,'Seetharampur','508101',1,0,'2022-03-03 12:37:19','2022-03-03 12:37:19'),(35906,107,'Seripally','508248',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35907,107,'Shah Ghajipur','508257',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35908,107,'Shakavally','508248',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35909,107,'Sharjipet','508101',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35910,107,'Shobanadripuram','508113',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35911,107,'Siripuram','508113',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35912,107,'Sirisanagandla','508266',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35913,107,'Sivaneniguda','508114',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35914,107,'Sivannaguda','508245',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35915,107,'Slbc','508004',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35916,107,'Somaram','508105',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35917,107,'Suddala','508277',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35918,107,'Sultanpur','508257',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35919,107,'Sunkenapally','508252',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35920,107,'Sunkisala','508112',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35921,107,'Suraram','508113',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35922,107,'Survail','508253',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35923,107,'Swamivari Lingotam','508252',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35924,107,'Tadikole','508248',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35925,107,'Takkallapally','508250',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35926,107,'Talla Vellemla','508244',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35927,107,'Tangedapally','508252',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35928,107,'Tangutoor','508101',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35929,107,'Tekula Somaram','508285',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35930,107,'Teldevarapally','508248',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35931,107,'Tenepally','508256',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35932,107,'Teppalamadugu','508266',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35933,107,'Teppelaneni  Gouraram','508373',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35934,107,'Thanedarpally','508256',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35935,107,'Theratpally','508253',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35936,107,'Theriala','508111',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35937,107,'Timmapur','508248',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35938,107,'Tippalaneni Gouraram','508258',1,0,'2022-03-03 12:37:20','2022-03-03 12:37:20'),(35939,107,'Tirugandlapally','508245',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35940,107,'Tirumalagiri','508377',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35941,107,'Tondalvai','508254',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35942,107,'Tooruppally','508248',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35943,107,'Towklapur','508258',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35944,107,'Town Bhongiri','508117',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35945,107,'Tummalaguda','508112',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35946,107,'Tummlapally','508255',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35947,107,'Tungathurthy','508266',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35948,107,'Turkalshapuram','508277',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35949,107,'Turkapalli','508115',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35950,107,'Urumadla','508114',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35951,107,'Utlapally','508266',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35952,107,'Vaddepally','508373',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35953,107,'Vaddipatla','508243',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35954,107,'Vailapally','508253',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35955,107,'Valigonda','508112',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35956,107,'Vanipakala','508114',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35957,107,'Vankamamidi','508284',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35958,107,'Vartoor','508286',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35959,107,'Vasalmarry','508115',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35960,107,'Vattikode','508255',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35961,107,'Vattimarthy','508254',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35962,107,'Vattiparthy','508245',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35963,107,'Vavikole','508258',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35964,107,'Veeraboinapally','508258',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35965,107,'Veerareddypally','508115',1,0,'2022-03-03 12:37:21','2022-03-03 12:37:21'),(35966,107,'Veeravally','508286',1,0,'2022-03-03 12:37:22','2022-03-03 12:37:22'),(35967,107,'Velamjala','508101',1,0,'2022-03-03 12:37:22','2022-03-03 12:37:22'),(35968,107,'Veldevi','508277',1,0,'2022-03-03 12:37:22','2022-03-03 12:37:22'),(35969,107,'Veliminedu','508114',1,0,'2022-03-03 12:37:22','2022-03-03 12:37:22'),(35970,107,'Velmaguda','508266',1,0,'2022-03-03 12:37:22','2022-03-03 12:37:22'),(35971,107,'Velmakanne','508253',1,0,'2022-03-03 12:37:22','2022-03-03 12:37:22'),(35972,107,'Velwarthy','508112',1,0,'2022-03-03 12:37:22','2022-03-03 12:37:22'),(35973,107,'Vemulakonda','508112',1,0,'2022-03-03 12:37:22','2022-03-03 12:37:22'),(35974,107,'Venkampeta','508373',1,0,'2022-03-03 12:37:22','2022-03-03 12:37:22'),(35975,107,'Venkateshwara Nagar','508245',1,0,'2022-03-03 12:37:22','2022-03-03 12:37:22'),(35976,107,'Venkatpur','508115',1,0,'2022-03-03 12:37:22','2022-03-03 12:37:22'),(35977,107,'Vijayapuri North','508202',1,0,'2022-03-03 12:37:22','2022-03-03 12:37:22'),(35978,107,'Wadaparthy','508117',1,0,'2022-03-03 12:37:22','2022-03-03 12:37:22'),(35979,107,'Wangapalli','508286',1,0,'2022-03-03 12:37:22','2022-03-03 12:37:22'),(35980,107,'Yacharam','508377',1,0,'2022-03-03 12:37:23','2022-03-03 12:37:23'),(35981,107,'Yadagirigutta','508115',1,0,'2022-03-03 12:37:23','2022-03-03 12:37:23'),(35982,107,'Yadgarpalli','508115',1,0,'2022-03-03 12:37:23','2022-03-03 12:37:23'),(35983,107,'Yelikatta','508114',1,0,'2022-03-03 12:37:23','2022-03-03 12:37:23'),(35984,107,'Yellanki','508113',1,0,'2022-03-03 12:37:23','2022-03-03 12:37:23'),(35985,107,'Yellareddyguda','508254',1,0,'2022-03-03 12:37:23','2022-03-03 12:37:23'),(35986,107,'Yennaram','508113',1,0,'2022-03-03 12:37:23','2022-03-03 12:37:23'),(35987,107,'Yeragandlapally','508245',1,0,'2022-03-03 12:37:23','2022-03-03 12:37:23'),(35988,107,'Yerraram','508258',1,0,'2022-03-03 12:37:23','2022-03-03 12:37:23'),(35989,107,'Adavdevulapally','508208',1,0,'2022-03-03 12:37:23','2022-03-03 12:37:23'),(35990,107,'Adloor','508210',1,0,'2022-03-03 12:37:23','2022-03-03 12:37:23'),(35991,107,'Agamothkur','508374',1,0,'2022-03-03 12:37:23','2022-03-03 12:37:23'),(35992,107,'Aipur','508221',1,0,'2022-03-03 12:37:23','2022-03-03 12:37:23'),(35993,107,'Aitipamula','508205',1,0,'2022-03-03 12:37:23','2022-03-03 12:37:23'),(35994,107,'Akaram','508210',1,0,'2022-03-03 12:37:23','2022-03-03 12:37:23'),(35995,107,'Akupamula','508233',1,0,'2022-03-03 12:37:23','2022-03-03 12:37:23'),(35996,107,'Alagadapa','508208',1,0,'2022-03-03 12:37:23','2022-03-03 12:37:23'),(35997,107,'Amangal','508374',1,0,'2022-03-03 12:37:23','2022-03-03 12:37:23'),(35998,107,'Amaravaram','508204',1,0,'2022-03-03 12:37:23','2022-03-03 12:37:23'),(35999,107,'Ameenabad','508206',1,0,'2022-03-03 12:37:23','2022-03-03 12:37:23'),(36000,107,'Amruth Nagar','508208',1,0,'2022-03-03 12:37:23','2022-03-03 12:37:23'),(36001,107,'Anajpur','508213',1,0,'2022-03-03 12:37:23','2022-03-03 12:37:23'),(36002,107,'Ananthagiri','508206',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36003,107,'Anantharam','508213',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36004,107,'Anireddy Gudem','508213',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36005,107,'Anjanapally','508208',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36006,107,'Annaram','508278',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36007,107,'Annaram','508280',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36008,107,'Annaram','508213',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36009,107,'Annariguda','508212',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36010,107,'Arvapalli','508224',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36011,107,'Atmakur','508212',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36012,107,'Baba Saheb Peta','508208',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36013,107,'Balajinagar','508206',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36014,107,'Balemula','508376',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36015,107,'Bandakothapally','508223',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36016,107,'Bandapalem','508211',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36017,107,'Bangarigadda','508208',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36018,107,'Bank Street (Nalgonda)','508213',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36019,107,'Bethavolu','508204',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36020,107,'Bhairavanibanda','508210',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36021,107,'Bhaktalapuram','508213',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36022,107,'Bheemavaram','508374',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36023,107,'Bikumalla','508221',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36024,107,'Bodaladinne','508218',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36025,107,'Bokkamunthalapahad','508278',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36026,107,'Bollepally','508205',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36027,107,'Bommakal','508374',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36028,107,'Booruggadda','508204',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36029,107,'Bopparam','508211',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36030,107,'Bopparam','508221',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36031,107,'Borraipalem','508355',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36032,107,'Bothalapalem','508218',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36033,107,'Burkacharla','508212',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36034,107,'Chandampally','508211',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36035,107,'Chandanapally','508205',1,0,'2022-03-03 12:37:24','2022-03-03 12:37:24'),(36036,107,'Chandupatla','508211',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36037,107,'Chandupatla','508213',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36038,107,'Chandupatla','508221',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36039,107,'Chanupally','508206',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36040,107,'Cheedella','508233',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36041,107,'Chennaipalem','508208',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36042,107,'Cherukupally','508211',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36043,107,'Cheruvupally','508374',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36044,107,'Chervuannaram','508205',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36045,107,'Chetlachennaram','508247',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36046,107,'Chilkur','508206',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36047,107,'Chilpakunta','508221',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36048,107,'Chimiryala','508206',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36049,107,'Chinnamadharam','508247',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36050,107,'Chinnanemilla','508221',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36051,107,'Chintalacheruvu','508213',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36052,107,'Chintalapalem','508246',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36053,107,'Chintriyala','508246',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36054,107,'Chirumarthy','508374',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36055,107,'Chittaloor','508210',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36056,107,'Chivemula','508213',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36057,107,'Choutapally','508204',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36058,107,'D Kothapally','508279',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36059,107,'Dacharam','508218',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36060,107,'Damarcharla','508355',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36061,107,'Devulapally Calan','508208',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36062,107,'Dharmapuram','508213',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36063,107,'Dilvarpur','508355',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36064,107,'Dirsencharla','508218',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36065,107,'Dondapadu','508246',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36066,107,'Dugenevally','508205',1,0,'2022-03-03 12:37:25','2022-03-03 12:37:25'),(36067,107,'Duggepally','508278',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36068,107,'Duraj Pally','508213',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36069,107,'Dwarakunta','508206',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36070,107,'Edavalli','508221',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36071,107,'Eduloor','508205',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36072,107,'Enubamula','508213',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36073,107,'Etoor','508279',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36074,107,'Gaddipally','508201',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36075,107,'Gajulamalkapuram','508213',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36076,107,'Ganapavaram','508238',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36077,107,'Ganapavaram','508233',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36078,107,'Ganugabanda','508201',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36079,107,'Ganugabanda','508280',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36080,107,'Garidepally','508201',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36081,107,'Gattikal','508224',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36082,107,'Gondriyala','508206',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36083,107,'Gonrentla','508280',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36084,107,'Gorankalapally','508211',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36085,107,'Gottiparthi','508280',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36086,107,'Gudibanda (Nalgonda)','508238',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36087,107,'Gudimalkapuram','508246',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36088,107,'Gudivada','508211',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36089,107,'Guduguntlapalem','508218',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36090,107,'Gudur','508208',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36091,107,'Gummadavally','508280',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36092,107,'Gumpula Tirumalgiri','508213',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36093,107,'Gundepuri','508223',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36094,107,'Gundlapahad','508218',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36095,107,'Gundlapally','508204',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36096,107,'Gurajala','508210',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36097,107,'Hazarigudem','508278',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36098,107,'Hussainabad','508212',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36099,107,'Huzurnagar','508204',1,0,'2022-03-03 12:37:26','2022-03-03 12:37:26'),(36100,107,'I.E.Suryapet','508213',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36101,107,'Ibrahimpet','508278',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36102,107,'Imampet','508213',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36103,107,'Indloor','508247',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36104,107,'Indugula','508374',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36105,107,'Inupamula','508211',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36106,107,'Isthalapuram','508221',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36107,107,'Itukula Pahad','508210',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36108,107,'Jagannadhapuram','508233',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36109,107,'Jajireddy Gudem','508224',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36110,107,'Jalalpuram','508223',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36111,107,'Jammigadda','508213',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36112,107,'Janakipuram','508223',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36113,107,'Jangareddy Gudem','508247',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36114,107,'Janpahad','508218',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36115,107,'Jerripothula Gudem','508204',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36116,107,'K.K.Road','508213',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36117,107,'Kagitaramachandrapuram','508234',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36118,107,'Kalakova','508233',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36119,107,'Kalmalacheruvu','508201',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36120,107,'Kamareddy Gudem','508278',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36121,107,'Kandagatla','508224',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36122,107,'Kandibanda','508238',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36123,107,'Kannekal','508374',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36124,107,'Kapugal','508238',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36125,107,'Karakkayala Gudem','508204',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36126,107,'Karivirala','508234',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36127,107,'Karvirala Kothagudem','508280',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36128,107,'Kasarabaad','508213',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36129,107,'Kasarlapahad','508224',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36130,107,'Kattangur','508205',1,0,'2022-03-03 12:37:27','2022-03-03 12:37:27'),(36131,107,'Keethavarigudem','508201',1,0,'2022-03-03 12:37:28','2022-03-03 12:37:28'),(36132,107,'Keshavapuram','508208',1,0,'2022-03-03 12:37:28','2022-03-03 12:37:28'),(36133,107,'Kethepally','508211',1,0,'2022-03-03 12:37:28','2022-03-03 12:37:28'),(36134,107,'Kodad','508206',1,0,'2022-03-03 12:37:28','2022-03-03 12:37:28'),(36135,107,'Kodaparthy','508210',1,0,'2022-03-03 12:37:28','2022-03-03 12:37:28'),(36136,107,'Kodur','508224',1,0,'2022-03-03 12:37:28','2022-03-03 12:37:28'),(36137,107,'Kokkireni','508233',1,0,'2022-03-03 12:37:28','2022-03-03 12:37:28'),(36138,107,'Komarabanda','508206',1,0,'2022-03-03 12:37:28','2022-03-03 12:37:28'),(36139,107,'Kommala','508224',1,0,'2022-03-03 12:37:28','2022-03-03 12:37:28'),(36140,107,'Kondapuram','508204',1,0,'2022-03-03 12:37:28','2022-03-03 12:37:28'),(36141,107,'Kondrapole','508355',1,0,'2022-03-03 12:37:28','2022-03-03 12:37:28'),(36142,107,'Koppole','508376',1,0,'2022-03-03 12:37:28','2022-03-03 12:37:28'),(36143,107,'Korlapahad','508211',1,0,'2022-03-03 12:37:28','2022-03-03 12:37:28'),(36144,107,'Kotapahad','508212',1,0,'2022-03-03 12:37:28','2022-03-03 12:37:28'),(36145,107,'Kothapeta','508211',1,0,'2022-03-03 12:37:28','2022-03-03 12:37:28'),(36146,107,'Kuchipudi','508238',1,0,'2022-03-03 12:37:28','2022-03-03 12:37:28'),(36147,107,'Kuda Kuda','508213',1,0,'2022-03-03 12:37:28','2022-03-03 12:37:28'),(36148,107,'Kukkadam','508280',1,0,'2022-03-03 12:37:28','2022-03-03 12:37:28'),(36149,107,'Kukkadam','508217',1,0,'2022-03-03 12:37:28','2022-03-03 12:37:28'),(36150,107,'Kurumarthy','508205',1,0,'2022-03-03 12:37:28','2022-03-03 12:37:28'),(36151,107,'Lakkavaram','508204',1,0,'2022-03-03 12:37:28','2022-03-03 12:37:28'),(36152,107,'Lingagiri','508204',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36153,107,'Lingala','508201',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36154,107,'Lingampally','508221',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36155,107,'Madaram','508213',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36156,107,'Madaram Kalan','508210',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36157,107,'Maddirala','508280',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36158,107,'Madgulapally','508374',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36159,107,'Malipuram','508223',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36160,107,'Mamidyala','508223',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36161,107,'Mamidyala','508247',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36162,107,'Mamillaguda','508212',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36163,107,'Mangalapally','508211',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36164,107,'Manimadde','508210',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36165,107,'Marpaka','508278',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36166,107,'Marrur','508211',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36167,107,'Matoor','508208',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36168,107,'Mattampally','508204',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36169,107,'Medaram','508201',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36170,107,'Medlacheruvu','508246',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36171,107,'Miryala','508221',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36172,107,'Miryalguda H.O','508207',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36173,107,'Mogalaikota','508206',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36174,107,'Molkacharla','508208',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36175,107,'Molkapatnam','508217',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36176,107,'Mothey','508212',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36177,107,'Mukundapuram','508233',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36178,107,'Mukundapuram','508221',1,0,'2022-03-03 12:37:29','2022-03-03 12:37:29'),(36179,107,'Mukundapuram','508278',1,0,'2022-03-03 12:37:30','2022-03-03 12:37:30'),(36180,107,'Munagala','508233',1,0,'2022-03-03 12:37:30','2022-03-03 12:37:30'),(36181,107,'Munukuntla','508205',1,0,'2022-03-03 12:37:30','2022-03-03 12:37:30'),(36182,107,'Muppavaram','508278',1,0,'2022-03-03 12:37:30','2022-03-03 12:37:30'),(36183,107,'Mushampally','508247',1,0,'2022-03-03 12:37:30','2022-03-03 12:37:30'),(36184,107,'Nadigudem','508234',1,0,'2022-03-03 12:37:30','2022-03-03 12:37:30'),(36185,107,'Nagaram','508279',1,0,'2022-03-03 12:37:30','2022-03-03 12:37:30'),(36186,107,'Nakrekal','508211',1,0,'2022-03-03 12:37:30','2022-03-03 12:37:30'),(36187,107,'Nallabandagudem','508206',1,0,'2022-03-03 12:37:30','2022-03-03 12:37:30'),(36188,107,'Namavaram','508213',1,0,'2022-03-03 12:37:30','2022-03-03 12:37:30'),(36189,107,'Nandipahad','508208',1,0,'2022-03-03 12:37:30','2022-03-03 12:37:30'),(36190,107,'Naramma Gudem','508207',1,0,'2022-03-03 12:37:30','2022-03-03 12:37:30'),(36191,107,'Narayanagudem','508233',1,0,'2022-03-03 12:37:30','2022-03-03 12:37:30'),(36192,107,'Narsimhula Gudem','508213',1,0,'2022-03-03 12:37:30','2022-03-03 12:37:30'),(36193,107,'Nasimpet','508212',1,0,'2022-03-03 12:37:30','2022-03-03 12:37:30'),(36194,107,'Nelamarry','508213',1,0,'2022-03-03 12:37:30','2022-03-03 12:37:30'),(36195,107,'Nemmikal','508212',1,0,'2022-03-03 12:37:30','2022-03-03 12:37:30'),(36196,107,'Neredcharla','508218',1,0,'2022-03-03 12:37:30','2022-03-03 12:37:30'),(36197,107,'Nidmanoor','508278',1,0,'2022-03-03 12:37:30','2022-03-03 12:37:30'),(36198,107,'Nomula','508211',1,0,'2022-03-03 12:37:30','2022-03-03 12:37:30'),(36199,107,'Noothankal','508221',1,0,'2022-03-03 12:37:30','2022-03-03 12:37:30'),(36200,107,'NSP Camp Miryalaguda','508208',1,0,'2022-03-03 12:37:30','2022-03-03 12:37:30'),(36201,107,'Ogodu','508211',1,0,'2022-03-03 12:37:30','2022-03-03 12:37:30'),(36202,107,'Pajjur','508247',1,0,'2022-03-03 12:37:30','2022-03-03 12:37:30'),(36203,107,'Palakeedu','508218',1,0,'2022-03-03 12:37:30','2022-03-03 12:37:30'),(36204,107,'Palavaram','508206',1,0,'2022-03-03 12:37:30','2022-03-03 12:37:30'),(36205,107,'Pale Annaram','508238',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36206,107,'Pamulapahad','508374',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36207,107,'Parada','508205',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36208,107,'Parsaipally','508279',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36209,107,'Pasthala','508279',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36210,107,'Pasunoor','508279',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36211,107,'Patha Suryapet','508224',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36212,107,'Patharla Pahad','508221',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36213,107,'Pedanemilla','508221',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36214,107,'Pedapadisala','508223',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36215,107,'Pedaveedu','508204',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36216,107,'Penchikal Dinna','508218',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36217,107,'Penpahad','508213',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36218,107,'Perkakondaram','508210',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36219,107,'Phanigiri','508279',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36220,107,'Pillalamarry','508213',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36221,107,'Pinnaipalem','508376',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36222,107,'Polumalla','508221',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36223,107,'Ponugode','508201',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36224,107,'Ragadapa','508208',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36225,107,'Raghavapuram','508213',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36226,107,'Raghunadhapalem','508204',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36227,107,'Rainiguda','508201',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36228,107,'Rajannagudem','508278',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36229,107,'Rajupeta','508247',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36230,107,'Ramachandrapuram','508224',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36231,107,'Ramadugu','508278',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36232,107,'Ramagiri','508210',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36233,107,'Ramalaxmipuram','508238',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36234,107,'Ramapuram','508206',1,0,'2022-03-03 12:37:31','2022-03-03 12:37:31'),(36235,107,'Ramapuram','508246',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36236,107,'Ramavaram','508376',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36237,107,'Ratnavaram','508234',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36238,107,'Ravipahad','508212',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36239,107,'Ravulapally','508280',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36240,107,'Ravulapenta','508217',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36241,107,'Rayanaguda','508376',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36242,107,'Rayini Palem','508208',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36243,107,'Reddygudem','508280',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36244,107,'Redlakunta','508206',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36245,107,'Regulagadda','508207',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36246,107,'Repala','508213',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36247,107,'Revoor','508246',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36248,107,'Rudraram','508208',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36249,107,'Salkanoor','508374',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36250,107,'Sanjay Nagar','508208',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36251,107,'Sarvaram','508204',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36252,107,'Sarvaram','508212',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36253,107,'Sarvaram','508247',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36254,107,'Settipalem','508217',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36255,107,'Shaligouraram','508210',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36256,107,'Shantinagar','508206',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36257,107,'Shapally','508205',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36258,107,'Shobhanadrigudem','508246',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36259,107,'Simhapuri','508204',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36260,107,'Singareddy Palem','508213',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36261,107,'Singavaram','508206',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36262,107,'Sirikonda (Nalgonda)','508212',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36263,107,'Siripuram','508234',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36264,107,'Solipet','508224',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36265,107,'Somavaram','508218',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36266,107,'Srerangapuram','508234',1,0,'2022-03-03 12:37:32','2022-03-03 12:37:32'),(36267,107,'Sunyapahad','508355',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36268,107,'Suraram','508211',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36269,107,'Suryapet H.O','508213',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36270,107,'Tadakamalla','508217',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36271,107,'Taduvai','508233',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36272,107,'Takkella Pahad','508208',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36273,107,'Talla Khammam Pahad','508213',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36274,107,'Tallamalkapuram','508201',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36275,107,'Tallasingaram','508221',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36276,107,'Tatikal','508211',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36277,107,'Tatipamula','508223',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36278,107,'Tekumatla','508376',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36279,107,'Tellaballi','508233',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36280,107,'Thammara','508206',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36281,107,'Thammavaram','508246',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36282,107,'Thimmapuram','508213',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36283,107,'Thipparthi','508247',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36284,107,'Thonda','508223',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36285,107,'Thoorpugudem','508280',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36286,107,'Thungapahad','508208',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36287,107,'Thungathurthi','508280',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36288,107,'Thungathurthy','508211',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36289,107,'Tirumalgiri','508223',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36290,107,'Togarrai','508238',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36291,107,'Topucharla','508217',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36292,107,'Tripuraram','508208',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36293,107,'Tripuravaram','508234',1,0,'2022-03-03 12:37:33','2022-03-03 12:37:33'),(36294,107,'Tummadam','508207',1,0,'2022-03-03 12:37:34','2022-03-03 12:37:34'),(36295,107,'Tummagudem','508212',1,0,'2022-03-03 12:37:34','2022-03-03 12:37:34'),(36296,107,'Tummalapenpahad','508212',1,0,'2022-03-03 12:37:34','2022-03-03 12:37:34'),(36297,107,'Uppalancha','508210',1,0,'2022-03-03 12:37:34','2022-03-03 12:37:34'),(36298,107,'Urlugonda','508212',1,0,'2022-03-03 12:37:34','2022-03-03 12:37:34'),(36299,107,'Utkoor','508210',1,0,'2022-03-03 12:37:34','2022-03-03 12:37:34'),(36300,107,'Utkoor','508278',1,0,'2022-03-03 12:37:34','2022-03-03 12:37:34'),(36301,107,'Utlapally','508208',1,0,'2022-03-03 12:37:34','2022-03-03 12:37:34'),(36302,107,'Vallabha Puram','508213',1,0,'2022-03-03 12:37:34','2022-03-03 12:37:34'),(36303,107,'Vallala','508210',1,0,'2022-03-03 12:37:34','2022-03-03 12:37:34'),(36304,107,'Vallapuram','508234',1,0,'2022-03-03 12:37:34','2022-03-03 12:37:34'),(36305,107,'Vasthakonduru','508223',1,0,'2022-03-03 12:37:34','2022-03-03 12:37:34'),(36306,107,'Vatti Khammam Pahad','508213',1,0,'2022-03-03 12:37:34','2022-03-03 12:37:34'),(36307,107,'Veerlapalem','508208',1,0,'2022-03-03 12:37:34','2022-03-03 12:37:34'),(36308,107,'Velicharla','508223',1,0,'2022-03-03 12:37:34','2022-03-03 12:37:34'),(36309,107,'Velidanda','508201',1,0,'2022-03-03 12:37:34','2022-03-03 12:37:34'),(36310,107,'Vellatoor','508246',1,0,'2022-03-03 12:37:34','2022-03-03 12:37:34'),(36311,107,'Velugupally','508280',1,0,'2022-03-03 12:37:34','2022-03-03 12:37:34'),(36312,107,'Vempahad','508278',1,0,'2022-03-03 12:37:35','2022-03-03 12:37:35'),(36313,107,'Vempati','508280',1,0,'2022-03-03 12:37:35','2022-03-03 12:37:35'),(36314,107,'Vemulapally','508217',1,0,'2022-03-03 12:37:35','2022-03-03 12:37:35'),(36315,107,'Venkatadri Palem','508208',1,0,'2022-03-03 12:37:35','2022-03-03 12:37:35'),(36316,107,'Venkatramapuram','508206',1,0,'2022-03-03 12:37:35','2022-03-03 12:37:35'),(36317,107,'Venkepally','508224',1,0,'2022-03-03 12:37:35','2022-03-03 12:37:35'),(36318,107,'Venugopalapuram','508234',1,0,'2022-03-03 12:37:35','2022-03-03 12:37:35'),(36319,107,'Vibhalapuram','508212',1,0,'2022-03-03 12:37:35','2022-03-03 12:37:35'),(36320,107,'Vijaya Raghavapuram','508213',1,0,'2022-03-03 12:37:35','2022-03-03 12:37:35'),(36321,107,'Wadapally','508355',1,0,'2022-03-03 12:37:35','2022-03-03 12:37:35'),(36322,107,'Wangamarthy','508210',1,0,'2022-03-03 12:37:35','2022-03-03 12:37:35'),(36323,107,'Wardhamankota','508279',1,0,'2022-03-03 12:37:35','2022-03-03 12:37:35'),(36324,107,'Wardhapuram','508204',1,0,'2022-03-03 12:37:35','2022-03-03 12:37:35'),(36325,107,'X Roads',' Kodad',1,0,'2022-03-03 12:37:35','2022-03-03 12:37:35'),(36326,107,'Yadgarpally','508208',1,0,'2022-03-03 12:37:35','2022-03-03 12:37:35'),(36327,107,'Yathavakilla','508204',1,0,'2022-03-03 12:37:35','2022-03-03 12:37:35'),(36328,107,'Yendlapally','508376',1,0,'2022-03-03 12:37:36','2022-03-03 12:37:36'),(36329,107,'Yepalasingaram','508204',1,0,'2022-03-03 12:37:36','2022-03-03 12:37:36'),(36330,107,'Yerkaram','508376',1,0,'2022-03-03 12:37:36','2022-03-03 12:37:36'),(36331,107,'Yerrabally','508278',1,0,'2022-03-03 12:37:36','2022-03-03 12:37:36'),(36332,107,'Yerrapahad','508221',1,0,'2022-03-03 12:37:36','2022-03-03 12:37:36'),(36333,107,'Yerravaram','508238',1,0,'2022-03-03 12:37:36','2022-03-03 12:37:36'),(36334,108,'Abhangapatnam','503245',1,0,'2022-03-03 12:37:36','2022-03-03 12:37:36'),(36335,108,'Achampet','503302',1,0,'2022-03-03 12:37:36','2022-03-03 12:37:36'),(36336,108,'Adivilingal','503122',1,0,'2022-03-03 12:37:36','2022-03-03 12:37:36'),(36337,108,'Adloor','503145',1,0,'2022-03-03 12:37:36','2022-03-03 12:37:36'),(36338,108,'Adloor','503112',1,0,'2022-03-03 12:37:37','2022-03-03 12:37:37'),(36339,108,'Ailapur','503246',1,0,'2022-03-03 12:37:37','2022-03-03 12:37:37'),(36340,108,'Akloor','503311',1,0,'2022-03-03 12:37:37','2022-03-03 12:37:37'),(36341,108,'Aloor','503223',1,0,'2022-03-03 12:37:37','2022-03-03 12:37:37'),(36342,108,'Ambam','503235',1,0,'2022-03-03 12:37:37','2022-03-03 12:37:37'),(36343,108,'Amberipet','503123',1,0,'2022-03-03 12:37:37','2022-03-03 12:37:37'),(36344,108,'Amdapur','503180',1,0,'2022-03-03 12:37:37','2022-03-03 12:37:37'),(36345,108,'Amrad','503003',1,0,'2022-03-03 12:37:37','2022-03-03 12:37:37'),(36346,108,'Anandnagar','503188',1,0,'2022-03-03 12:37:37','2022-03-03 12:37:37'),(36347,108,'Ananthagiri','503186',1,0,'2022-03-03 12:37:37','2022-03-03 12:37:37'),(36348,108,'Anchanoor','503123',1,0,'2022-03-03 12:37:37','2022-03-03 12:37:37'),(36349,108,'Andhranagar','503213',1,0,'2022-03-03 12:37:37','2022-03-03 12:37:37'),(36350,108,'Ankapoor','503223',1,0,'2022-03-03 12:37:37','2022-03-03 12:37:37'),(36351,108,'Ankasapur','503311',1,0,'2022-03-03 12:37:37','2022-03-03 12:37:37'),(36352,108,'Ankole','503301',1,0,'2022-03-03 12:37:37','2022-03-03 12:37:37'),(36353,108,'Annaram','503144',1,0,'2022-03-03 12:37:38','2022-03-03 12:37:38'),(36354,108,'Annaramkalan','503310',1,0,'2022-03-03 12:37:38','2022-03-03 12:37:38'),(36355,108,'Annasagar','503302',1,0,'2022-03-03 12:37:38','2022-03-03 12:37:38'),(36356,108,'Ansanpalli','503164',1,0,'2022-03-03 12:37:38','2022-03-03 12:37:38'),(36357,108,'Anthampalli','503102',1,0,'2022-03-03 12:37:38','2022-03-03 12:37:38'),(36358,108,'APSP Camp (Nizamabad)','503174',1,0,'2022-03-03 12:37:38','2022-03-03 12:37:38'),(36359,108,'Argonda','503110',1,0,'2022-03-03 12:37:38','2022-03-03 12:37:38'),(36360,108,'Argul','503223',1,0,'2022-03-03 12:37:38','2022-03-03 12:37:38'),(36361,108,'Armoor H.O','503224',1,0,'2022-03-03 12:37:38','2022-03-03 12:37:38'),(36362,108,'Arsapalli','503186',1,0,'2022-03-03 12:37:38','2022-03-03 12:37:38'),(36363,108,'Ashok Farm','503246',1,0,'2022-03-03 12:37:38','2022-03-03 12:37:38'),(36364,108,'Atmakur','503122',1,0,'2022-03-03 12:37:38','2022-03-03 12:37:38'),(36365,108,'Babapur','503307',1,0,'2022-03-03 12:37:38','2022-03-03 12:37:38'),(36366,108,'Badguni','503212',1,0,'2022-03-03 12:37:38','2022-03-03 12:37:38'),(36367,108,'Badsi','503230',1,0,'2022-03-03 12:37:38','2022-03-03 12:37:38'),(36368,108,'Balkonda','503217',1,0,'2022-03-03 12:37:38','2022-03-03 12:37:38'),(36369,108,'Bandaranjal','503187',1,0,'2022-03-03 12:37:38','2022-03-03 12:37:38'),(36370,108,'Banswada','503187',1,0,'2022-03-03 12:37:38','2022-03-03 12:37:38'),(36371,108,'Barangedgi','503321',1,0,'2022-03-03 12:37:38','2022-03-03 12:37:38'),(36372,108,'Bardipur','503230',1,0,'2022-03-03 12:37:38','2022-03-03 12:37:38'),(36373,108,'Bashirabad','503225',1,0,'2022-03-03 12:37:38','2022-03-03 12:37:38'),(36374,108,'Baswannapalli','503110',1,0,'2022-03-03 12:37:38','2022-03-03 12:37:38'),(36375,108,'Baswapur','503101',1,0,'2022-03-03 12:37:38','2022-03-03 12:37:38'),(36376,108,'Baswapur','503305',1,0,'2022-03-03 12:37:38','2022-03-03 12:37:38'),(36377,108,'Bejjora','503307',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36378,108,'Bhagirathipalli','503101',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36379,108,'Bhavanipet','503112',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36380,108,'Bhavanipet','503122',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36381,108,'Bhikno R.S.','503101',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36382,108,'Bhiknoor','503101',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36383,108,'Bhimgal Busstand','503307',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36384,108,'Bhimgal Buzrug','503307',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36385,108,'Bhimgal','503307',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36386,108,'Bhoompalli','503145',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36387,108,'Bibipet','503125',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36388,108,'Bichkunda','503306',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36389,108,'Bikkanur','503122',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36390,108,'Binola','503246',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36391,108,'Birkur','503321',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36392,108,'Bodepalli','503217',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36393,108,'Bodhan (Nizamabad)','503185',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36394,108,'Bollaram','503122',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36395,108,'Bomandevpalli','503301',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36396,108,'Boregaon (K)','503003',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36397,108,'Boregaon','503235',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36398,108,'Boregaon','503230',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36399,108,'Borlam','503187',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36400,108,'Brahmanpalli','503112',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36401,108,'Budmi','503187',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36402,108,'Bussapur','503218',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36403,108,'Camp Ootpalli','503180',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36404,108,'Chakarnpalli','503175',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36405,108,'Challagarga','503165',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36406,108,'Chandrayanpalli','503164',1,0,'2022-03-03 12:37:39','2022-03-03 12:37:39'),(36407,108,'Chandur','503206',1,0,'2022-03-03 12:37:40','2022-03-03 12:37:40'),(36408,108,'Chengal','503307',1,0,'2022-03-03 12:37:40','2022-03-03 12:37:40'),(36409,108,'Chepur','503223',1,0,'2022-03-03 12:37:40','2022-03-03 12:37:40'),(36410,108,'Chikli','503246',1,0,'2022-03-03 12:37:40','2022-03-03 12:37:40'),(36411,108,'Chillargi','503310',1,0,'2022-03-03 12:37:40','2022-03-03 12:37:40'),(36412,108,'Chimanpalli','503165',1,0,'2022-03-03 12:37:40','2022-03-03 12:37:40'),(36413,108,'Chimrajpalli','503212',1,0,'2022-03-03 12:37:40','2022-03-03 12:37:40'),(36414,108,'Chinnamallareddy','503110',1,0,'2022-03-03 12:37:40','2022-03-03 12:37:40'),(36415,108,'Chinnur','503108',1,0,'2022-03-03 12:37:40','2022-03-03 12:37:40'),(36416,108,'Chintakunta','503206',1,0,'2022-03-03 12:37:40','2022-03-03 12:37:40'),(36417,108,'Chitial','503110',1,0,'2022-03-03 12:37:40','2022-03-03 12:37:40'),(36418,108,'Chittapur','503217',1,0,'2022-03-03 12:37:40','2022-03-03 12:37:40'),(36419,108,'Chotpalli','503308',1,0,'2022-03-03 12:37:40','2022-03-03 12:37:40'),(36420,108,'Chukkapur','503112',1,0,'2022-03-03 12:37:40','2022-03-03 12:37:40'),(36421,108,'Damannapet','503165',1,0,'2022-03-03 12:37:40','2022-03-03 12:37:40'),(36422,108,'Damarancha','503321',1,0,'2022-03-03 12:37:40','2022-03-03 12:37:40'),(36423,108,'Darpalli','503165',1,0,'2022-03-03 12:37:40','2022-03-03 12:37:40'),(36424,108,'Dattapur','503212',1,0,'2022-03-03 12:37:40','2022-03-03 12:37:40'),(36425,108,'Deekampalli','503213',1,0,'2022-03-03 12:37:40','2022-03-03 12:37:40'),(36426,108,'Degaon','503223',1,0,'2022-03-03 12:37:40','2022-03-03 12:37:40'),(36427,108,'Demi','503120',1,0,'2022-03-03 12:37:40','2022-03-03 12:37:40'),(36428,108,'Desaipet','503187',1,0,'2022-03-03 12:37:40','2022-03-03 12:37:40'),(36429,108,'Devakkapet','503307',1,0,'2022-03-03 12:37:40','2022-03-03 12:37:40'),(36430,108,'Devanappli','503112',1,0,'2022-03-03 12:37:40','2022-03-03 12:37:40'),(36431,108,'Dhadgi','503306',1,0,'2022-03-03 12:37:40','2022-03-03 12:37:40'),(36432,108,'Dharmaram (Nizamabad)','503230',1,0,'2022-03-03 12:37:40','2022-03-03 12:37:40'),(36433,108,'Dharmaraopet','503145',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36434,108,'Dharmora','503311',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36435,108,'Dichpalli','503175',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36436,108,'Dichpalli RS','503175',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36437,108,'Domakonda','503123',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36438,108,'Domaledgi','503207',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36439,108,'Dongaon','503305',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36440,108,'Dongli','503309',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36441,108,'Donkal','503311',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36442,108,'Donkeshwar','503212',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36443,108,'Doodgaon','503219',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36444,108,'Doodgaon Colony','503219',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36445,108,'Doosgaon','503175',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36446,108,'Dubbak','503165',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36447,108,'Dupalli','503245',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36448,108,'Durki','503301',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36449,108,'Edapalli','503202',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36450,108,'Edgikalan','503305',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36451,108,'Eklara','503309',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36452,108,'Endriyal','503120',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36453,108,'Eraspalli','503180',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36454,108,'Esaipet','503144',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36455,108,'Faridpet','503123',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36456,108,'Fathenagar','503245',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36457,108,'Fathepur','503217',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36458,108,'Fathlapur','503306',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36459,108,'Gadepalli','503212',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36460,108,'Gadkole','503165',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36461,108,'Gajulpet','503001',1,0,'2022-03-03 12:37:41','2022-03-03 12:37:41'),(36462,108,'Galipur','503187',1,0,'2022-03-03 12:37:42','2022-03-03 12:37:42'),(36463,108,'Gandhari','503114',1,0,'2022-03-03 12:37:42','2022-03-03 12:37:42'),(36464,108,'Gandhi Gunj','503001',1,0,'2022-03-03 12:37:42','2022-03-03 12:37:42'),(36465,108,'Gandhinagar','503246',1,0,'2022-03-03 12:37:42','2022-03-03 12:37:42'),(36466,108,'Gannaram','503164',1,0,'2022-03-03 12:37:42','2022-03-03 12:37:42'),(36467,108,'Gargul','503144',1,0,'2022-03-03 12:37:42','2022-03-03 12:37:42'),(36468,108,'Ghanpur','503206',1,0,'2022-03-03 12:37:42','2022-03-03 12:37:42'),(36469,108,'Ghanpur','503112',1,0,'2022-03-03 12:37:42','2022-03-03 12:37:42'),(36470,108,'Gidda','503144',1,0,'2022-03-03 12:37:42','2022-03-03 12:37:42'),(36471,108,'Godmegaon','503310',1,0,'2022-03-03 12:37:42','2022-03-03 12:37:42'),(36472,108,'Gongupalli','503307',1,0,'2022-03-03 12:37:42','2022-03-03 12:37:42'),(36473,108,'Gotmukla','503246',1,0,'2022-03-03 12:37:42','2022-03-03 12:37:42'),(36474,108,'Gouraram','503187',1,0,'2022-03-03 12:37:42','2022-03-03 12:37:42'),(36475,108,'Govindpet','503223',1,0,'2022-03-03 12:37:42','2022-03-03 12:37:42'),(36476,108,'Govur','503206',1,0,'2022-03-03 12:37:42','2022-03-03 12:37:42'),(36477,108,'Gullabuzrug','503305',1,0,'2022-03-03 12:37:42','2022-03-03 12:37:42'),(36478,108,'Gummiryal','503308',1,0,'2022-03-03 12:37:42','2022-03-03 12:37:42'),(36479,108,'Gundaram','503186',1,0,'2022-03-03 12:37:42','2022-03-03 12:37:42'),(36480,108,'Gundaram','503110',1,0,'2022-03-03 12:37:42','2022-03-03 12:37:42'),(36481,108,'Gundekallur','503309',1,0,'2022-03-03 12:37:42','2022-03-03 12:37:42'),(36482,108,'Gundiwait','503122',1,0,'2022-03-03 12:37:42','2022-03-03 12:37:42'),(36483,108,'Gurbabadi','503002',1,0,'2022-03-03 12:37:42','2022-03-03 12:37:42'),(36484,108,'Gurjal','503114',1,0,'2022-03-03 12:37:42','2022-03-03 12:37:42'),(36485,108,'Gutpa','503213',1,0,'2022-03-03 12:37:42','2022-03-03 12:37:42'),(36486,108,'Hangarga','503207',1,0,'2022-03-03 12:37:42','2022-03-03 12:37:42'),(36487,108,'Hangarga','503235',1,0,'2022-03-03 12:37:43','2022-03-03 12:37:43'),(36488,108,'Hangarga','503309',1,0,'2022-03-03 12:37:43','2022-03-03 12:37:43'),(36489,108,'Hanmajipet','503187',1,0,'2022-03-03 12:37:43','2022-03-03 12:37:43'),(36490,108,'Hanojipet','503165',1,0,'2022-03-03 12:37:43','2022-03-03 12:37:43'),(36491,108,'Hansa','503185',1,0,'2022-03-03 12:37:43','2022-03-03 12:37:43'),(36492,108,'Hasakothur','503308',1,0,'2022-03-03 12:37:43','2022-03-03 12:37:43'),(36493,108,'Hasanpalli','503302',1,0,'2022-03-03 12:37:43','2022-03-03 12:37:43'),(36494,108,'Hasgal','503306',1,0,'2022-03-03 12:37:43','2022-03-03 12:37:43'),(36495,108,'Hegdoli','503207',1,0,'2022-03-03 12:37:43','2022-03-03 12:37:43'),(36496,108,'Humnapur','503206',1,0,'2022-03-03 12:37:43','2022-03-03 12:37:43'),(36497,108,'Ibrahimpet','503187',1,0,'2022-03-03 12:37:43','2022-03-03 12:37:43'),(36498,108,'Indalwai','503164',1,0,'2022-03-03 12:37:43','2022-03-03 12:37:43'),(36499,108,'Indalwai RS','503164',1,0,'2022-03-03 12:37:43','2022-03-03 12:37:43'),(36500,108,'Isrojiwadi','503144',1,0,'2022-03-03 12:37:43','2022-03-03 12:37:43'),(36501,108,'Issanagar','503125',1,0,'2022-03-03 12:37:43','2022-03-03 12:37:43'),(36502,108,'Issapalli','503223',1,0,'2022-03-03 12:37:43','2022-03-03 12:37:43'),(36503,108,'Jadijamalpur','503185',1,0,'2022-03-03 12:37:43','2022-03-03 12:37:43'),(36504,108,'Jagiryal','503307',1,0,'2022-03-03 12:37:43','2022-03-03 12:37:43'),(36505,108,'Jakhora','503201',1,0,'2022-03-03 12:37:43','2022-03-03 12:37:43'),(36506,108,'Jalalpur','503201',1,0,'2022-03-03 12:37:43','2022-03-03 12:37:43'),(36507,108,'Jalalpur','503122',1,0,'2022-03-03 12:37:43','2022-03-03 12:37:43'),(36508,108,'Jalapur','503217',1,0,'2022-03-03 12:37:43','2022-03-03 12:37:43'),(36509,108,'Jamlam','503202',1,0,'2022-03-03 12:37:43','2022-03-03 12:37:43'),(36510,108,'Janakampet','503307',1,0,'2022-03-03 12:37:44','2022-03-03 12:37:44'),(36511,108,'Jangamaipalli','503122',1,0,'2022-03-03 12:37:44','2022-03-03 12:37:44'),(36512,108,'Jangampalli','503102',1,0,'2022-03-03 12:37:44','2022-03-03 12:37:44'),(36513,108,'Jangaon','503125',1,0,'2022-03-03 12:37:44','2022-03-03 12:37:44'),(36514,108,'Jankampet','503186',1,0,'2022-03-03 12:37:44','2022-03-03 12:37:44'),(36515,108,'Jannepalli','503246',1,0,'2022-03-03 12:37:44','2022-03-03 12:37:44'),(36516,108,'Jawahar Road','503001',1,0,'2022-03-03 12:37:44','2022-03-03 12:37:44'),(36517,108,'Jillapalli','503207',1,0,'2022-03-03 12:37:44','2022-03-03 12:37:44'),(36518,108,'Jukkal','503305',1,0,'2022-03-03 12:37:44','2022-03-03 12:37:44'),(36519,108,'Kachapur','503101',1,0,'2022-03-03 12:37:44','2022-03-03 12:37:44'),(36520,108,'Kakatiyanagar Colony','503111',1,0,'2022-03-03 12:37:44','2022-03-03 12:37:44'),(36521,108,'Kaldurki','503185',1,0,'2022-03-03 12:37:44','2022-03-03 12:37:44'),(36522,108,'Kalhadi','503213',1,0,'2022-03-03 12:37:44','2022-03-03 12:37:44'),(36523,108,'Kaligot','503175',1,0,'2022-03-03 12:37:44','2022-03-03 12:37:44'),(36524,108,'Kallur','503003',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36525,108,'Kallur','503207',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36526,108,'Kalwaral','503145',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36527,108,'Kalyani','503122',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36528,108,'Kamalapur','503245',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36529,108,'Kamalapur','503164',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36530,108,'Kamareddy Arts & Science','503112',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36531,108,'Kamareddy H.O','503111',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36532,108,'Kamareddy RS','503112',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36533,108,'Kammarpalli','503308',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36534,108,'Kandagaon','503235',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36535,108,'Kandakurthi','503235',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36536,108,'Kanjar','503175',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36537,108,'Kankal','503120',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36538,108,'Kanteshwar','503002',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36539,108,'Karadpalli','503120',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36540,108,'Kaslabad','503310',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36541,108,'Keshpalli','503175',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36542,108,'Keysanpalli','503112',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36543,108,'Khanapur','503223',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36544,108,'Khanapur','503003',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36545,108,'Khandeballur','503305',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36546,108,'Khazipur','503185',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36547,108,'Khudwanpur','503212',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36548,108,'Kissannagar','503218',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36549,108,'Kistapur','503321',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36550,108,'Kodapkal Kalan','503310',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36551,108,'Kodapkal Khurd','503310',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36552,108,'Kolas (I)','503305',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36553,108,'Kolpak','503223',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36554,108,'Komalancha','503187',1,0,'2022-03-03 12:37:45','2022-03-03 12:37:45'),(36555,108,'Komanpalli','503217',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36556,108,'Konapur','503187',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36557,108,'Konasamudram','503307',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36558,108,'Kondapur','503110',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36559,108,'Kondur','503212',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36560,108,'Kondur','503246',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36561,108,'Kondur','503165',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36562,108,'Konepalli','503245',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36563,108,'Koratpalli','503175',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36564,108,'Korpole','503124',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36565,108,'Kosli','503245',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36566,108,'Kotagalli','503001',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36567,108,'Kotaipalli','503310',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36568,108,'Kotchera','503309',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36569,108,'Kotgir','503207',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36570,108,'Kothapalli','503218',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36571,108,'Kothapalli','503207',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36572,108,'Kothapalli','503246',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36573,108,'Krishnajivadi','503112',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36574,108,'Kuknoor','503311',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36575,108,'Kulaspur','503175',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36576,108,'Kupriyal','503145',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36577,108,'Kurnapalli','503202',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36578,108,'Lachan','503309',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36579,108,'Lachapet','503112',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36580,108,'Lakhora','503311',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36581,108,'Lakshmikisan Farm','503245',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36582,108,'Limbur','503309',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36583,108,'Lingampalli','503124',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36584,108,'Lingampet','503124',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36585,108,'Lingapur','503112',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36586,108,'Lingareddy','503122',1,0,'2022-03-03 12:37:46','2022-03-03 12:37:46'),(36587,108,'Lingupalli','503102',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36588,108,'Machapur','503122',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36589,108,'Machareddy','503112',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36590,108,'Macherla','503223',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36591,108,'Madanpalli','503003',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36592,108,'Maddepalli','503245',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36593,108,'Maddikunta','503144',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36594,108,'Madduchervu','503187',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36595,108,'Madhapur','503213',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36596,108,'Madhavnagar','503230',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36597,108,'Madnoor','503309',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36598,108,'Magdi','503223',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36599,108,'Mahabub Farm','503202',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36600,108,'Mahmadpur','503101',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36601,108,'Mailaram','503301',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36602,108,'Makloor','503213',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36603,108,'Malkapoor','503206',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36604,108,'Malkapur','503125',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36605,108,'Mallapur','503164',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36606,108,'Mallaram','503003',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36607,108,'Mallareddy Kalan','503101',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36608,108,'Mallur','503302',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36609,108,'Malthummeda','503108',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36610,108,'Mamidipalli','503223',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36611,108,'Mamidipalli','503003',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36612,108,'Manchippa','503230',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36613,108,'Mandarna','503185',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36614,108,'Mangalpahad','503202',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36615,108,'Manikbhandar','503003',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36616,108,'Manoor (B)','503309',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36617,108,'Manthani','503223',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36618,108,'Marampalli','503212',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36619,108,'Markal','503145',1,0,'2022-03-03 12:37:47','2022-03-03 12:37:47'),(36620,108,'Masanipet','503122',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36621,108,'Mathumal','503122',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36622,108,'Mavandikalan','503185',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36623,108,'Mendora','503219',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36624,108,'Mendora','503307',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36625,108,'Mentrajpalli','503175',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36626,108,'Methusangam','503114',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36627,108,'Mirdhapalli','503223',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36628,108,'Mirzapur (Nizamabad)','503301',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36629,108,'Mittapalli','503164',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36630,108,'Mjp Nagar','503003',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36631,108,'Modtad','503225',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36632,108,'Mogha','503309',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36633,108,'Mohammad Nagar','503302',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36634,108,'Mokanpalli','503245',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36635,108,'Moshampur','503144',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36636,108,'Mosra','503206',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36637,108,'Motha','503311',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36638,108,'Motha','503120',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36639,108,'Mubaraknagar','503003',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36640,108,'Muchkur','503307',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36641,108,'Mudakpalli','503230',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36642,108,'Mudholi','503187',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36643,108,'Mullangi','503175',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36644,108,'Mullangi','503213',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36645,108,'Munpalli','503223',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36646,108,'Mupkal','503230',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36647,108,'Mupkal','503218',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36648,108,'Muthyampet','503123',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36649,108,'Nachapalli','503301',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36650,108,'Nadpalli','503175',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36651,108,'Nagampet','503218',1,0,'2022-03-03 12:37:48','2022-03-03 12:37:48'),(36652,108,'Nagapuram','503308',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36653,108,'Nagepur','503245',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36654,108,'Nagireddypet','503108',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36655,108,'Nallapalli','503164',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36656,108,'Nalleshwar','503246',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36657,108,'Nallur','503218',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36658,108,'Namli','503301',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36659,108,'Nandipet','503212',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36660,108,'Nandiwada','503120',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36661,108,'Narkhoda','503307',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36662,108,'Narkoda Jagir','503212',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36663,108,'Narsannapalli','503102',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36664,108,'Narsapur','503180',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36665,108,'Narsapuram','503307',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36666,108,'Narsingpalli','503230',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36667,108,'Nasrullabad','503321',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36668,108,'Navipet','503245',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36669,108,'Neela','503235',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36670,108,'Neeral','503114',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36671,108,'Nizamabad H.O','503001',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36672,108,'Nizamabad RS','503003',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36673,108,'Nizamsagar','503302',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36674,108,'Noothpalli','503212',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36675,108,'Nyalkal','503230',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36676,108,'Nyavanandi','503165',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36677,108,'Old Varni','503201',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36678,108,'Padgal','503311',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36679,108,'Padkal','503175',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36680,108,'Padmajiwadi','503145',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36681,108,'Palda','503246',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36682,108,'Palem','503225',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36683,108,'Pallikonda','503307',1,0,'2022-03-03 12:37:49','2022-03-03 12:37:49'),(36684,108,'Palvancha','503112',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36685,108,'Pegdapalli','503235',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36686,108,'Pentakalan','503235',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36687,108,'Pentakurd','503185',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36688,108,'Pepri','503307',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36689,108,'Perkit','503223',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36690,108,'Perumalla','503124',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36691,108,'Phullong','503001',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36692,108,'Pipri','503223',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36693,108,'Pitlam','503310',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36694,108,'Pochampadu LF','503219',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36695,108,'Pocharam','503186',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36696,108,'Pocharam','503108',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36697,108,'Polkampet','503124',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36698,108,'Pondurthy','503102',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36699,108,'Posanipet','503144',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36700,108,'Pothangal','503207',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36701,108,'Pothangal','503246',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36702,108,'Pothangalkalan','503114',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36703,108,'Pothiapalli','503124',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36704,108,'Pulkal','503306',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36705,108,'Raikur','503188',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36706,108,'Raithunagar','503185',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36707,108,'Rajampet','503110',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36708,108,'Rakasipet','503185',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36709,108,'Ramadgu','503164',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36710,108,'Ramannapet','503225',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36711,108,'Ramareddy','503144',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36712,108,'Ramchandrapalli','503213',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36713,108,'Rameshwarpalli','503101',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36714,108,'Rampur','503187',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36715,108,'Rampur','503164',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36716,108,'Ranampalli','503188',1,0,'2022-03-03 12:37:50','2022-03-03 12:37:50'),(36717,108,'Ranjal','503235',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36718,108,'Ranjarla','503218',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36719,108,'Rautla','503165',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36720,108,'Reddypet','503144',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36721,108,'Rudr R.S.','503188',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36722,108,'Rudraram','503122',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36723,108,'Rudrur','503188',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36724,108,'Sadasivanagar','503145',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36725,108,'Salampahad','503185',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36726,108,'Saloora','503185',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36727,108,'Sangam','503185',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36728,108,'Sangameshwar','503123',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36729,108,'Sarangapur','503186',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36730,108,'Satapur','503235',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36731,108,'Satapurfarm','503235',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36732,108,'Savel','503219',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36733,108,'Shakarga','503309',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36734,108,'Shakkarnagar','503180',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36735,108,'Shantapur','503305',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36736,108,'Shapur','503212',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36737,108,'Shetpalli','503218',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36738,108,'Shetpalli','503108',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36739,108,'Shetpalli','503124',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36740,108,'Shivajinagar (Nizamabad)','503001',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36741,108,'Sikandrapur','503307',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36742,108,'Sikkindrapur','503175',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36743,108,'Singitham','503187',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36744,108,'Sirkonda','503165',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36745,108,'Sirnapalli R.S.','503164',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36746,108,'Sirpur','503230',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36747,108,'Soanpet','503219',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36748,108,'Somarampet','503144',1,0,'2022-03-03 12:37:51','2022-03-03 12:37:51'),(36749,108,'Srinagar','503201',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36750,108,'Sriramsagar Project','503219',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36751,108,'Subhashnagar (Nizamabad)','503002',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36752,108,'Subriyal','503217',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36753,108,'Suddapalli','503175',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36754,108,'Sudlam','503164',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36755,108,'Sunket','503225',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36756,108,'Sunkini','503207',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36757,108,'Tadbiloli','503245',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36758,108,'Tadgur','503309',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36759,108,'Tadkole','503187',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36760,108,'Tadlarampur','503308',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36761,108,'Tadpakal','503308',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36762,108,'Tadwai','503120',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36763,108,'Talmadla','503102',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36764,108,'Talveda','503212',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36765,108,'Tandur','503108',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36766,108,'Teglaipalli','503188',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36767,108,'Tekriyal','503112',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36768,108,'Telangana University','503322',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36769,108,'Thanakalan','503202',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36770,108,'Thimmakapalli','503110',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36771,108,'Thimmanagar','503310',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36772,108,'Thimmapur','503225',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36773,108,'Thimmapuram','503321',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36774,108,'Thippapur','503101',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36775,108,'Thirumalapur','503187',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36776,108,'Thorath','503225',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36777,108,'Timmapur','503122',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36778,108,'Toompalli','503165',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36779,108,'Torlikonda','503223',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36780,108,'Tujlapur','503125',1,0,'2022-03-03 12:37:52','2022-03-03 12:37:52'),(36781,108,'Tungini','503246',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36782,108,'Ugrawai','503112',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36783,108,'Ummeda','503212',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36784,108,'Uploor','503308',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36785,108,'Uppalwai','503144',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36786,108,'Utnoor','503145',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36787,108,'Vaddepalli','503302',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36788,108,'Vailpur','503311',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36789,108,'Valgodkalan','503165',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36790,108,'Valmikinagar','503003',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36791,108,'Vannel k\"\"','503212',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36792,108,'Varni','503201',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36793,108,'Velgatur','503219',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36794,108,'Vempalli','503218',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36795,108,'Vencherial','503218',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36796,108,'Venkatapur','503311',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36797,108,'Vennelb\"\"','503217',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36798,108,'Waddiyat','503225',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36799,108,'Wajidnagar','503187',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36800,108,'Wajrakhandi','503305',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36801,108,'Yadaram','503125',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36802,108,'Yamcha','503245',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36803,108,'Yanampalli','503175',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36804,108,'Yellammagutta','503003',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36805,108,'Yellappagonda','503112',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36806,108,'Yellareddy','503122',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36807,108,'Yellareddypalli','503110',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36808,108,'Yellareddypalli','503164',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36809,108,'Yellutla','503122',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36810,108,'Yelmal','503213',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36811,108,'Yergatla','503308',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36812,108,'Yerrapahad','503120',1,0,'2022-03-03 12:37:53','2022-03-03 12:37:53'),(36813,108,'Yethonda','503207',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36814,108,'Zirayathnagar','503223',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36815,109,'Abadighanpur','506144',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36816,109,'Abbapur','506343',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36817,109,'Abdulnagaram','506145',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36818,109,'Adavikamalapur','506169',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36819,109,'Ainapur','506355',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36820,109,'Akinepalli','506366',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36821,109,'Akinepalli Mallaram','506172',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36822,109,'Akkampet','506342',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36823,109,'Akkarajpalli','506224',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36824,109,'Aknoor','506223',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36825,109,'Alimpur','506221',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36826,109,'Ammapur','506224',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36827,109,'Ananthasagar','506371',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36828,109,'Ankannagudem','506352',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36829,109,'Ankushapur','506367',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36830,109,'Appireddipalli','506303',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36831,109,'Arjunpatla','506223',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36832,109,'Aswaraopalli','506244',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36833,109,'Atmakur (Warangal)','506342',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36834,109,'Azamnagar','506169',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36835,109,'Bandanagaram','506224',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36836,109,'Bandarupalli','506343',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36837,109,'Banjipet','506244',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36838,109,'Bapujinagar (Warangal)','506003',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36839,109,'Beeravelli','506344',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36840,109,'Bhagirathipet','506345',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36841,109,'Bhairanpalli','506367',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36842,109,'Bhatpally','506003',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36843,109,'Bheemaram','506015',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36844,109,'Bhupalapalli','506169',1,0,'2022-03-03 12:37:54','2022-03-03 12:37:54'),(36845,109,'Bikkal','506367',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36846,109,'Bittupalli','506347',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36847,109,'Bollonipalli','506349',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36848,109,'Bommera','506252',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36849,109,'Borenarsapur','506172',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36850,109,'Brahmanpalli','506172',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36851,109,'Buchannapet','506172',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36852,109,'Buchannapet','506221',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36853,109,'Budharam','506345',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36854,109,'Bussapur','506344',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36855,109,'Buttaigudem','506165',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36856,109,'Chagal','506301',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36857,109,'Chainpak','506170',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36858,109,'Challagarige','506356',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36859,109,'Chalvai','506344',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36860,109,'Cheetur','506303',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36861,109,'Chelpak','506165',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36862,109,'Chelpur','506168',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36863,109,'Chennapur','506319',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36864,109,'Cherlapalli','506391',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36865,109,'Cherupalli','506172',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36866,109,'Chilpur','506145',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36867,109,'China Raman Cherla','506221',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36868,109,'Chinchinkota','506223',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36869,109,'Chinnaboinapalli','506165',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36870,109,'Chinnakodepak','506319',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36871,109,'Chinnapendyal','506144',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36872,109,'Chintagattu','506015',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36873,109,'Chiryal','506223',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36874,109,'Chitakodur','506175',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36875,109,'Chityal','506355',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36876,109,'Chityal','506356',1,0,'2022-03-03 12:37:55','2022-03-03 12:37:55'),(36877,109,'Chowlapalli','506342',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36878,109,'Chowtaparthy','506391',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36879,109,'Chunchupalli','506172',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36880,109,'D H Suthoon','506011',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36881,109,'Dabbakunta Palli','506221',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36882,109,'Dammannapet','506348',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36883,109,'Danampalli','506355',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36884,109,'Devagiripatnam','506352',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36885,109,'Devannapet','506370',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36886,109,'Devaruppal','506302',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36887,109,'Devnoor','506371',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36888,109,'Dharmapuram','506144',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36889,109,'Dharmapuram','506302',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36890,109,'Dharmaram','506367',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36891,109,'Dharmaraopet','506345',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36892,109,'Dharmasagar','506142',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36893,109,'Dhulmitta','506367',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36894,109,'Domeda','506172',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36895,109,'Dommat','506223',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36896,109,'Dongalasingaram','506349',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36897,109,'Dubyal','506356',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36898,109,'Dumpaligudem','506344',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36899,109,'Empaid','506356',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36900,109,'Etur','506165',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36901,109,'Eturunagaram','506165',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36902,109,'Fathepur','506301',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36903,109,'Fatheshapur','506244',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36904,109,'Fatimanagar','506004',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36905,109,'Gabbeta','506244',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36906,109,'Gagillapur','506367',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36907,109,'Gangapur','506221',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36908,109,'Gangaram','506344',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36909,109,'Gangireni Gudem','506348',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36910,109,'Gangupahad','506175',1,0,'2022-03-03 12:37:56','2022-03-03 12:37:56'),(36911,109,'Garimillapalli','506356',1,0,'2022-03-03 12:37:57','2022-03-03 12:37:57'),(36912,109,'Garmillapalli','506143',1,0,'2022-03-03 12:37:57','2022-03-03 12:37:57'),(36913,109,'Gatlakaniparthy','506319',1,0,'2022-03-03 12:37:57','2022-03-03 12:37:57'),(36914,109,'Ghanpur (Mulug)','506345',1,0,'2022-03-03 12:37:57','2022-03-03 12:37:57'),(36915,109,'Ghanpur Station','506143',1,0,'2022-03-03 12:37:57','2022-03-03 12:37:57'),(36916,109,'Gollabudharam','506169',1,0,'2022-03-03 12:37:57','2022-03-03 12:37:57'),(36917,109,'Gollapalli','506302',1,0,'2022-03-03 12:37:57','2022-03-03 12:37:57'),(36918,109,'Gopalpur','506170',1,0,'2022-03-03 12:37:57','2022-03-03 12:37:57'),(36919,109,'Gorlavaid','506168',1,0,'2022-03-03 12:37:57','2022-03-03 12:37:57'),(36920,109,'Govardanagiri','506301',1,0,'2022-03-03 12:37:57','2022-03-03 12:37:57'),(36921,109,'Govindaraopet','506344',1,0,'2022-03-03 12:37:57','2022-03-03 12:37:57'),(36922,109,'Gudur','506252',1,0,'2022-03-03 12:37:57','2022-03-03 12:37:57'),(36923,109,'Gummadavalli','506201',1,0,'2022-03-03 12:37:57','2022-03-03 12:37:57'),(36924,109,'Gurrampaet','506168',1,0,'2022-03-03 12:37:57','2022-03-03 12:37:57'),(36925,109,'Gurrevula','506165',1,0,'2022-03-03 12:37:57','2022-03-03 12:37:57'),(36926,109,'Gurujakunta','506223',1,0,'2022-03-03 12:37:57','2022-03-03 12:37:57'),(36927,109,'Guruvannapet','506355',1,0,'2022-03-03 12:37:57','2022-03-03 12:37:57'),(36928,109,'Gutta','506145',1,0,'2022-03-03 12:37:57','2022-03-03 12:37:57'),(36929,109,'Hanamkonda H.O','506001',1,0,'2022-03-03 12:37:57','2022-03-03 12:37:57'),(36930,109,'Hanumanthapur','506175',1,0,'2022-03-03 12:37:57','2022-03-03 12:37:57'),(36931,109,'Hasanparthy','506371',1,0,'2022-03-03 12:37:57','2022-03-03 12:37:57'),(36932,109,'Hussainpalli','506319',1,0,'2022-03-03 12:37:57','2022-03-03 12:37:57'),(36933,109,'Ibrahimpur','506244',1,0,'2022-03-03 12:37:57','2022-03-03 12:37:57'),(36934,109,'Ilapuram','506165',1,0,'2022-03-03 12:37:58','2022-03-03 12:37:58'),(36935,109,'Inchencherupalli','506343',1,0,'2022-03-03 12:37:58','2022-03-03 12:37:58'),(36936,109,'Incherla','506352',1,0,'2022-03-03 12:37:58','2022-03-03 12:37:58'),(36937,109,'Ippaguda','506252',1,0,'2022-03-03 12:37:58','2022-03-03 12:37:58'),(36938,109,'Iravennur','506244',1,0,'2022-03-03 12:37:58','2022-03-03 12:37:58'),(36939,109,'Issipet','506366',1,0,'2022-03-03 12:37:58','2022-03-03 12:37:58'),(36940,109,'Itikalapalli','506221',1,0,'2022-03-03 12:37:58','2022-03-03 12:37:58'),(36941,109,'Jadalpet','506170',1,0,'2022-03-03 12:37:58','2022-03-03 12:37:58'),(36942,109,'Jaggaiahpet','506348',1,0,'2022-03-03 12:37:58','2022-03-03 12:37:58'),(36943,109,'Jaggannapet','506343',1,0,'2022-03-03 12:37:58','2022-03-03 12:37:58'),(36944,109,'Jakaram','506343',1,0,'2022-03-03 12:37:58','2022-03-03 12:37:58'),(36945,109,'Jalapalli','506367',1,0,'2022-03-03 12:37:58','2022-03-03 12:37:58'),(36946,109,'Janakipuram','506151',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36947,109,'Jangalapally','506352',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36948,109,'Jangaon Bazar','506175',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36949,109,'Jangaon H.O','506167',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36950,109,'Jayagiri','506371',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36951,109,'Jeedikal','506201',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36952,109,'Jhengaid','506169',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36953,109,'Jookal','506356',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36954,109,'K C Colony','506015',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36955,109,'Kadavendi','506302',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36956,109,'Kadaverugu','506223',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36957,109,'Kadipikonda','506003',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36958,109,'Kalvapalli','506347',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36959,109,'Kalyam','506201',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36960,109,'Kamalapur Town Ship','506172',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36961,109,'Kamaram','506344',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36962,109,'Kamareddigudem','506302',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36963,109,'Kamareddipalli','506319',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36964,109,'Kanchanpalli','506244',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36965,109,'Kaniparthy (Ch)','506348',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36966,109,'Kannaigudem','506352',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36967,109,'Kantatmakur','506391',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36968,109,'Karlapalli','506347',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36969,109,'Kasimdevipet','506352',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36970,109,'Katapur','506344',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36971,109,'Kathigudem','506172',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36972,109,'Katkur','506224',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36973,109,'Katrepalli','506349',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36974,109,'Kazipet','506003',1,0,'2022-03-03 12:37:59','2022-03-03 12:37:59'),(36975,109,'Keshavapur','506343',1,0,'2022-03-03 12:38:00','2022-03-03 12:38:00'),(36976,109,'Kesireddypalli','506221',1,0,'2022-03-03 12:38:00','2022-03-03 12:38:00'),(36977,109,'Kodavatancha','506348',1,0,'2022-03-03 12:38:00','2022-03-03 12:38:00'),(36978,109,'Kodavatur','506221',1,0,'2022-03-03 12:38:00','2022-03-03 12:38:00'),(36979,109,'Kodur','506303',1,0,'2022-03-03 12:38:00','2022-03-03 12:38:00'),(36980,109,'Kolkonda','506303',1,0,'2022-03-03 12:38:00','2022-03-03 12:38:00'),(36981,109,'Komandla','506244',1,0,'2022-03-03 12:38:00','2022-03-03 12:38:00'),(36982,109,'Komaravalli','506355',1,0,'2022-03-03 12:38:00','2022-03-03 12:38:00'),(36983,109,'Komatipalli','506172',1,0,'2022-03-03 12:38:00','2022-03-03 12:38:00'),(36984,109,'Kompalli','506168',1,0,'2022-03-03 12:38:00','2022-03-03 12:38:00'),(36985,109,'Kondai','506165',1,0,'2022-03-03 12:38:00','2022-03-03 12:38:00'),(36986,109,'Kondaparthy','506003',1,0,'2022-03-03 12:38:00','2022-03-03 12:38:00'),(36987,109,'Kondapur','506367',1,0,'2022-03-03 12:38:00','2022-03-03 12:38:00'),(36988,109,'Kondapur','506145',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(36989,109,'Kondapur','506345',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(36990,109,'Konney','506221',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(36991,109,'Kootigal','506367',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(36992,109,'Koppula','506319',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(36993,109,'Kothagattu Singaram','506319',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(36994,109,'Kothapalli (G)','506170',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(36995,109,'Kothapalli','506301',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(36996,109,'Kothapalli','506303',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(36997,109,'Kothapalli(V)','506348',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(36998,109,'Kothur','506352',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(36999,109,'Kowkonda','506391',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(37000,109,'Krishnajigudem','506301',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(37001,109,'KTPP','506170',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(37002,109,'Kundanpalli','506356',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(37003,109,'Kundaram','506303',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(37004,109,'Kunur','506143',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(37005,109,'Kurchapalli','506252',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(37006,109,'Kyathampalli','506151',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(37007,109,'Ladnoor','506224',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(37008,109,'Laknavaram','506347',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(37009,109,'Lashkar Bazar','506001',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(37010,109,'Laxmakkapalli','506302',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(37011,109,'Laxmareddipalli','506168',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(37012,109,'Laxmidevipet','506345',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(37013,109,'Laxmipur','506342',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(37014,109,'Lingal','506348',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(37015,109,'Lingala','506347',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(37016,109,'Lingala Ghanpur','506201',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(37017,109,'Lingampalli','506223',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(37018,109,'Lingampalli','506145',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(37019,109,'Lingapur','506367',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(37020,109,'Machapur','506344',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(37021,109,'Madanpalli','506343',1,0,'2022-03-03 12:38:01','2022-03-03 12:38:01'),(37022,109,'Maddur (Warangal)','506367',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37023,109,'Madhapur','506302',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37024,109,'Madikonda','506142',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37025,109,'Madipalli','506371',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37026,109,'Madthapalli','506348',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37027,109,'Malakpalli','506003',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37028,109,'Malkapur (Warangal)','506145',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37029,109,'Mallampalli','506349',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37030,109,'Mallikudurla','506151',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37031,109,'Mallur','506172',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37032,109,'Manchupahad','506244',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37033,109,'Mandelagudem','506244',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37034,109,'Mangapet','506172',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37035,109,'Marigadi','506175',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37036,109,'Marmamul','506224',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37037,109,'Marrimuchal','506355',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37038,109,'Marudkalan','506303',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37039,109,'Meedikonda','506301',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37040,109,'Mekhal Ghat','506244',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37041,109,'Metpalli','506366',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37042,109,'Mogullapalli','506366',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37043,109,'Mohd.Gouspalli','506349',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37044,109,'Mondrai','506302',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37045,109,'Motlapalli','506366',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37046,109,'Mucherla','506015',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37047,109,'Muddunur','506349',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37048,109,'Mulkalagudem','506003',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37049,109,'Mulkalapally','506366',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37050,109,'Mulug','506343',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37051,109,'Muppanapalli','506165',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37052,109,'Mupparam','506142',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37053,109,'Mustial','506224',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37054,109,'Mustialapalli','506342',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37055,109,'Mylaram','506345',1,0,'2022-03-03 12:38:02','2022-03-03 12:38:02'),(37056,109,'Nadikuda','506391',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37057,109,'Nagapuri','506223',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37058,109,'Nagaram','506169',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37059,109,'Nagaram','506391',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37060,109,'Nagaram','506371',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37061,109,'Nagireddipalli','506221',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37062,109,'Naimnagar','506009',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37063,109,'Nainpak','506170',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37064,109,'Nallabelli','506349',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37065,109,'Nallakunta','506345',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37066,109,'Narayanagiri','506142',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37067,109,'Narayanpur','506244',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37068,109,'Narlapur','506347',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37069,109,'Narlapur','506391',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37070,109,'Narmetta','506175',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37071,109,'Narsaipalli','506223',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37072,109,'Narsakkapalli','506391',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37073,109,'Narsapur','506224',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37074,109,'Narsapur','506343',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37075,109,'Narsapur(Bore)','506344',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37076,109,'Narsimhasagar','506172',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37077,109,'Naskal','506144',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37078,109,'Nawabpet','506356',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37079,109,'Neerukulla','506342',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37080,109,'Nelapogula','506303',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37081,109,'Nellutla','506175',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37082,109,'Nemiligonda','506143',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37083,109,'Neredupalli','506349',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37084,109,'Nidigonda','506244',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37085,109,'Nirmal','506303',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37086,109,'Obulkeshavapur','506221',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37087,109,'Oorattam','506347',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37088,109,'Oorugonda','506342',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37089,109,'Padamatikeshavapur','506223',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37090,109,'Palakurthy','506252',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37091,109,'Palampet','506165',1,0,'2022-03-03 12:38:03','2022-03-03 12:38:03'),(37092,109,'Pallagutta','506144',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37093,109,'Pambapur','506344',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37094,109,'Pamnoor','506143',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37095,109,'Pandikunta','506349',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37096,109,'Pangidipalli','506356',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37097,109,'Parkal H.O','506164',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37098,109,'Parlapalli','506366',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37099,109,'Pasaragonda','506342',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37100,109,'Pasaramadla','506201',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37101,109,'Pasra','506347',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37102,109,'Pathipak','506319',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37103,109,'Pathipalli','506352',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37104,109,'Peddakodepak','506319',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37105,109,'Peddakomati Palli','506366',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37106,109,'Peddapahad','506175',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37107,109,'Peddapendyal','506151',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37108,109,'Peddapur','506342',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37109,109,'Peddapur','506168',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37110,109,'Peddaramancherla','506221',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37111,109,'Peesara','506145',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37112,109,'Pegadapalli','506015',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37113,109,'Pembarthy','506371',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37114,109,'Pembarthy','506201',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37115,109,'Pidicilla','506366',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37116,109,'Pochannapet','506221',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37117,109,'Poredupalli','506172',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37118,109,'Posanpalli','506355',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37119,109,'Pothireddipalli','506223',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37120,109,'Pothugal','506366',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37121,109,'Puligilla','506391',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37122,109,'Pullampet','506345',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37123,109,'Pulukurthy','506342',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37124,109,'Quilashapur','506244',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37125,109,'R E College','506004',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37126,109,'Raghavapatnam','506344',1,0,'2022-03-03 12:38:04','2022-03-03 12:38:04'),(37127,109,'Raghavapur','506301',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37128,109,'Raghavareddipet','506356',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37129,109,'Raghunath Pally','506244',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37130,109,'Raghunathpalli','506143',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37131,109,'Raiparthy','506391',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37132,109,'Rajannapet','506165',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37133,109,'Rajavaram','506144',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37134,109,'Rajupet','506172',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37135,109,'Ramachandrapuram','506221',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37136,109,'Ramachandrapuram','506349',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37137,109,'Ramachandrunipet','506172',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37138,109,'Ramakistapur','506356',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37139,109,'Ramanakkapet','506172',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37140,109,'Ramannagudem','506165',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37141,109,'Ramannagudem','506348',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37142,109,'Ramanujpur','506345',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37143,109,'Ramarajpalli','506303',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37144,109,'Rampur','506151',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37145,109,'Rampur','506347',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37146,109,'Ramsagar','506223',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37147,109,'Rangaiahpalli','506348',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37148,109,'Rangapur','506344',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37149,109,'Rangapur','506349',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37150,109,'Rangapur','506366',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37151,109,'Rangapur Project Nagar','506347',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37152,109,'Rebarthy','506367',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37153,109,'Reddicolony','506011',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37154,109,'Regonda','506348',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37155,109,'Relakunta','506349',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37156,109,'Repak','506348',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37157,109,'Repakpalli','506348',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37158,109,'Roheer','506165',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37159,109,'Rudragudem','506349',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37160,109,'Saipet','506142',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37161,109,'Salakpur','506224',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37162,109,'Salvapur','506223',1,0,'2022-03-03 12:38:05','2022-03-03 12:38:05'),(37163,109,'Samudrala','506252',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37164,109,'Sarvapur','506352',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37165,109,'Seetarampur','506302',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37166,109,'Seethampet','506371',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37167,109,'Shahpalli','506165',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37168,109,'Shalapalli','506142',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37169,109,'Shamirpet','506175',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37170,109,'Shanigaram','506349',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37171,109,'Shatapur','506302',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37172,109,'Shayampet','506319',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37173,109,'Shivapuram','506165',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37174,109,'Shivunipalli','506143',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37175,109,'Shodesha Palli','506151',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37176,109,'Siddanki','506201',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37177,109,'Singarajpalli','506303',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37178,109,'Siripuram','506201',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37179,109,'Solipuram','506367',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37180,109,'Sreepathipalli','506145',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37181,109,'Subedari','506001',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37182,109,'Sultanpur','506348',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37183,109,'Tadur Bo\'','506355',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37184,109,'Tadvai','506344',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37185,109,'Taharapur','506319',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37186,109,'Tammadapalli','506221',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37187,109,'Tanedarpalli','506143',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37188,109,'Taralapalli','506003',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37189,109,'Tatikayala','506151',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37190,109,'Tatikonda','506301',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37191,109,'Teegaram','506143',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37192,109,'Tekulagudem','506003',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37193,109,'Tekumatla','506356',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37194,109,'Thammadapalli','506143',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37195,109,'Tharigoppula','506224',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37196,109,'Thimmampet','506172',1,0,'2022-03-03 12:38:06','2022-03-03 12:38:06'),(37197,109,'Thimmampet','506143',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37198,109,'Thimmapur','506345',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37199,109,'Tirumalagiri','506348',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37200,109,'Tirumalapur','506356',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37201,109,'Torrur','506302',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37202,109,'Tupakulagudem','506165',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37203,109,'Unikicherla','506370',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37204,109,'Uppugal','506143',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37205,109,'Vadlakonda','506175',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37206,109,'Vadthal','506170',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37207,109,'Vallampatla','506367',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37208,109,'Varikol','506391',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37209,109,'Veecharani','506223',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37210,109,'Veerannapet','506224',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37211,109,'Velair','506142',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37212,109,'Veldanda','506221',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37213,109,'Veldi','506244',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37214,109,'Vellampalli','506391',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37215,109,'Vemulapalli','506366',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37216,109,'Venkatadripet','506145',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37217,109,'Venkatapur','506352',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37218,109,'Venkatapur','506366',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37219,109,'Venkatapur','506003',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37220,109,'Venkataraopalli','506356',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37221,109,'Venkeswaraswamygutta','506145',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37222,109,'Vidyaranyapuri','506009',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37223,109,'Viswanathapur','506143',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37224,109,'Vodagudem','506172',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37225,109,'Waddepalli','506370',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37226,109,'Waddicherla','506303',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37227,109,'Waddicherla Nawabpet','506303',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37228,109,'Wanaparthy','506303',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37229,109,'Yelkurthy','506142',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37230,109,'Yellamula','506201',1,0,'2022-03-03 12:38:07','2022-03-03 12:38:07'),(37231,109,'Yellapur','506371',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37232,109,'Yenkiryal','506175',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37233,109,'Yerragolla Pahad','506175',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37234,109,'Yeswantapur','506175',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37235,109,'Aanole','506310',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37236,109,'Abbaipalem','506315',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37237,109,'Agapet','506324',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37238,109,'Agricultur Research Station','506007',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37239,109,'Alair','506102',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37240,109,'Alankhanipet','506112',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37241,109,'Amangala','506102',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37242,109,'Ameenabad','506122',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37243,109,'Ammapalem','506381',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37244,109,'Ammapur','506163',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37245,109,'Anantharam','506102',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37246,109,'Andanalapadu','506381',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37247,109,'Anepur','506315',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37248,109,'Annaram','506102',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37249,109,'Annaram','506365',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37250,109,'Appalraopet','506369',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37251,109,'Apparajpalli','506102',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37252,109,'Arepalli','506006',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37253,109,'Ashalapalli','506005',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37254,109,'Ashoknagar','506132',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37255,109,'Authapur','506317',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37256,109,'Ayodhyapur','506134',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37257,109,'Ayyagaripalli','506105',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37258,109,'Balapala','506381',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37259,109,'Bandouthapur','506313',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37260,109,'Beat Bazar','506002',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37261,109,'Beersettigudem','506324',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37262,109,'Bethole','506105',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37263,109,'Bhanjipet','506132',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37264,109,'Bhathulapalli','506135',1,0,'2022-03-03 12:38:08','2022-03-03 12:38:08'),(37265,109,'Bhavajigudem','506315',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37266,109,'Bheriwada','506102',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37267,109,'Bhudharaopet','506134',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37268,109,'Bhupathipet','506134',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37269,109,'Bodlada','506324',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37270,109,'Bollepalli','506134',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37271,109,'Bollikunta','506005',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37272,109,'Bommakal','506318',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37273,109,'Brahmanakothapalli','506324',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37274,109,'Buddugonda','506102',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37275,109,'Burgumadla','506369',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37276,109,'Burhanpur','506315',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37277,109,'Cathedrol Compound','506381',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37278,109,'Chandrugonda','506122',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37279,109,'Chengapur','506104',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37280,109,'Chennaram','506310',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37281,109,'Chennaraopet','506332',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37282,109,'Chennur','506222',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37283,109,'Cheralpalem','506163',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37284,109,'Chilkode','506381',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37285,109,'Chillamcherla','506315',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37286,109,'Chinnagaram','506112',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37287,109,'Chinnavangara','506317',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37288,109,'Chintalapalli','506329',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37289,109,'Chintanekkonda','506369',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37290,109,'Chintapalli','506105',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37291,109,'Chityal','506318',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37292,109,'Choutapalli','506365',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37293,109,'Dabeerpet','506132',1,0,'2022-03-03 12:38:09','2022-03-03 12:38:09'),(37294,109,'Damera','506006',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37295,109,'Dameravancha','506134',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37296,109,'Dammannapet','506316',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37297,109,'Dantalapalli','506324',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37298,109,'Dardepalli','506316',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37299,109,'Datla','506324',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37300,109,'Deekshakunta','506122',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37301,109,'Deshaipet','506006',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37302,109,'Dhansari','506112',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37303,109,'Dharmaram','506315',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37304,109,'Dharmaram (Warangal)','506330',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37305,109,'Dharmaraopet','506134',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37306,109,'Dornakal','506381',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37307,109,'Duggondi','506331',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37308,109,'Dwarakapet','506132',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37309,109,'Edulapalli','506135',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37310,109,'Edulapoosalapalli','506102',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37311,109,'Edunuthala','506222',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37312,109,'Elgur','506329',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37313,109,'Elgur Station','506329',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37314,109,'Elkurthy','506330',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37315,109,'Engal','506369',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37316,109,'Fathepur','506163',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37317,109,'Fort Warangal.','506008',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37318,109,'Gadepalli','506005',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37319,109,'Gajulagattu','506134',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37320,109,'Galivarigudem','506315',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37321,109,'Gangaram','506135',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37322,109,'Gantlakunta','506318',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37323,109,'Gavicherla','506310',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37324,109,'Geegugonda','506330',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37325,109,'Gollacherla','506381',1,0,'2022-03-03 12:38:10','2022-03-03 12:38:10'),(37326,109,'Gopanpalli','506365',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37327,109,'Gorrekunta','506006',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37328,109,'Govindapur','506132',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37329,109,'Grainmarket','506002',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37330,109,'Gudur','506104',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37331,109,'Gudur (Warangal)','506134',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37332,109,'Gundalpahad','506132',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37333,109,'Gundamrajpalli','506104',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37334,109,'Gundenga','506332',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37335,109,'Gundepudi','506315',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37336,109,'Gundrathimadugu','506102',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37337,109,'Gunnepalli','506324',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37338,109,'Gurijala','506331',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37339,109,'Gurthur','506163',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37340,109,'Haripirala','506163',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37341,109,'Inchaguda','506135',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37342,109,'Industrial Estate','506007',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37343,109,'Ingurthy','506112',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37344,109,'Intikanne','506112',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37345,109,'Itikalapalli','506132',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37346,109,'Jaipur','506324',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37347,109,'Jamandlapalli','506102',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37348,109,'Jangamvarigudem','506135',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37349,109,'Jangligonda','506104',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37350,109,'Jayyaram','506104',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37351,109,'Jhalli','506122',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37352,109,'K.M.College','506007',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37353,109,'Kakkiralapalli','506313',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37354,109,'Kalleda','506369',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37355,109,'Kalvala','506112',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37356,109,'Kambalapalli','506102',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37357,109,'Kamepalli','506105',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37358,109,'Kammepalli','506331',1,0,'2022-03-03 12:38:11','2022-03-03 12:38:11'),(37359,109,'Kandikonda','506105',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37360,109,'Kannegundla','506381',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37361,109,'Kantaipalem','506163',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37362,109,'Kantharamavaram','506222',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37363,109,'Kapulakanparthy','506005',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37364,109,'Karimabad','506002',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37365,109,'Karkala','506318',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37366,109,'Kasibugga (Warangal)','506002',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37367,109,'Katrepalli','506112',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37368,109,'Katrepalli','506314',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37369,109,'Katrepalli','506329',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37370,109,'Katrial','506313',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37371,109,'Kesamudram','506112',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37372,109,'Kesamudram Town','506112',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37373,109,'Keshavapur','506314',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37374,109,'Khanapur','506132',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37375,109,'Kodakondla','506222',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37376,109,'Kogilvai','506006',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37377,109,'Kolanpalli','506314',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37378,109,'Kollapur','506102',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37379,109,'Komatipalli','506112',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37380,109,'Komatlagudem','506135',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37381,109,'Kommulavancha','506324',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37382,109,'Konapuram','506332',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37383,109,'Kondapur','506314',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37384,109,'Kondapur','506316',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37385,109,'Kondur','506314',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37386,109,'Konkapaka','506365',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37387,109,'Korepalli','506318',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37388,109,'Korukondapalli','506112',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37389,109,'Kothaguda (Warangal)','506135',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37390,109,'Kothapeta','506006',1,0,'2022-03-03 12:38:12','2022-03-03 12:38:12'),(37391,109,'Kothareddial','506102',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37392,109,'Kothur','506313',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37393,109,'Kothur','506132',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37394,109,'Kousalyadevipalli','506104',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37395,109,'Kummarikunta','506324',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37396,109,'Kuravi','506105',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37397,109,'Ladella','506006',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37398,109,'Laknepalli','506331',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37399,109,'Laxmipur (Warangal)','506013',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37400,109,'Laxmipur','506102',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37401,109,'Liabarthy','506313',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37402,109,'Lingagiri','506122',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37403,109,'Lingapuram','506332',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37404,109,'Lohitha','506310',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37405,109,'M.G.M Hospital','506007',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37406,109,'Machapur','506330',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37407,109,'Macherla','506134',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37408,109,'Madaguda','506135',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37409,109,'Madannapet','506132',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37410,109,'Madanthurthi','506368',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37411,109,'Madapur','506105',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37412,109,'Madhupalli\'','506163',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37413,109,'Mahabubabad H.O','506101',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37414,109,'Mahathma Gandhi Road','506002',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37415,109,'Maheshwaram','506331',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37416,109,'Mallampalli','506331',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37417,109,'Mallampally','506317',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37418,109,'Mallareddipalli','506006',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37419,109,'Mallial','506102',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37420,109,'Mamnoor (V)','506166',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37421,109,'Mamnoor','506166',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37422,109,'Manchuppal','506222',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37423,109,'Mandapalli','506331',1,0,'2022-03-03 12:38:13','2022-03-03 12:38:13'),(37424,109,'Mandi Bazar','506002',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37425,109,'Mangalvaripet','506134',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37426,109,'Manneguda','506381',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37427,109,'Manugonda','506330',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37428,109,'Maqdumpuram','506332',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37429,109,'Maripeda (V)','506315',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37430,109,'Maripeda','506315',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37431,109,'Marrigudem','506135',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37432,109,'Matair','506163',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37433,109,'Matwada','506102',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37434,109,'Matwada','506002',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37435,109,'Mecharajpalli','506368',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37436,109,'Medapalli','506132',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37437,109,'Modugulaguda','506105',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37438,109,'Mogilcherla','506006',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37439,109,'Mogilcherla','506105',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37440,109,'Mohammadapur','506331',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37441,109,'Mondrai','506331',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37442,109,'Mudigonda','506122',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37443,109,'Mudupugal','506102',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37444,109,'Mulkalapalli','506381',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37445,109,'Mungalveedu','506368',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37446,109,'Mungimadugu','506324',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37447,109,'Mupparamkalan','506324',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37448,109,'Mupparamkurd','506112',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37449,109,'Muripirala','506314',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37450,109,'Musmi','506135',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37451,109,'Mutharam','506222',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37452,109,'Muthojipet','506132',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37453,109,'Mylaram','506314',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37454,109,'Nachenapalli','506331',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37455,109,'Nadiwada','506102',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37456,109,'Nagaram','506122',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37457,109,'Nagaram','506324',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37458,109,'Naikpalli','506112',1,0,'2022-03-03 12:38:14','2022-03-03 12:38:14'),(37459,109,'Nainala','506368',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37460,109,'Nallballi','506310',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37461,109,'Nallela','506105',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37462,109,'Nallikaddur','506368',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37463,109,'Nancharimadur','506317',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37464,109,'Nandanam','506313',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37465,109,'Narakkapet','506132',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37466,109,'Narasimlaguda','506104',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37467,109,'Narasimulapet','506324',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37468,109,'Narsampet','506132',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37469,109,'Neelkurthi','506315',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37470,109,'Neerada','506104',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37471,109,'Nekkonda','506122',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37472,109,'New Abadi','506102',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37473,109,'Oblapur','506316',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37474,109,'Ontimamidipalli','506310',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37475,109,'Ookal','506330',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37476,109,'Ookal Raiparthy','506314',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37477,109,'Ootai','506135',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37478,109,'Paidipalli','506006',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37479,109,'Pakhal','506222',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37480,109,'Pallarguda','506330',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37481,109,'Panthani','506310',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37482,109,'Papaiahpet','506332',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37483,109,'Parvathagiri','506104',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37484,109,'Parwathagiri','506365',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37485,109,'Peddakorpole','506112',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37486,109,'Peddavangara','506317',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37487,109,'Penugonda','506102',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37488,109,'Perkaveid','506314',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37489,109,'Perumandlasankeesa','506381',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37490,109,'Pochampalli','506317',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37491,109,'Pogullapalli','506135',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37492,109,'Pungode','506134',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37493,109,'Punnel','506310',1,0,'2022-03-03 12:38:15','2022-03-03 12:38:15'),(37494,109,'Punugondla','506135',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37495,109,'Purushothamaigudem','506315',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37496,109,'Railway Gate','506008',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37497,109,'Railway Gate','506002',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37498,109,'Raiparthy','506314',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37499,109,'Rajanpalli','506112',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37500,109,'Rajole','506102',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37501,109,'Rajulakothapalli','506368',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37502,109,'Rampur','506315',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37503,109,'Rangapur','506318',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37504,109,'Rangshaipet','506005',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37505,109,'Ravirala','506368',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37506,109,'Reddial','506102',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37507,109,'Reddipalem','506313',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37508,109,'Redlawada','506369',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37509,109,'Regula','506317',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37510,109,'Reponi','506324',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37511,109,'Rollakal','506365',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37512,109,'Sadireddipalli','506135',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37513,109,'Sagaram','506313',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37514,109,'Saireddipalli','506369',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37515,109,'Sangam','506329',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37516,109,'Sangem','506330',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37517,109,'Sannur','506163',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37518,109,'Seethanagar','506134',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37519,109,'Serole','506105',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37520,109,'Shayampet (H)','506329',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37521,109,'Shivnagar','506002',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37522,109,'Siddapur','506006',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37523,109,'Singaram','506005',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37524,109,'Singaram','506104',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37525,109,'Somaram','506365',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37526,109,'Soorpalli','506122',1,0,'2022-03-03 12:38:16','2022-03-03 12:38:16'),(37527,109,'Sriramgiri','506368',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37528,109,'Stn. Gundrathimadugu','506102',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37529,109,'Sudenapalli','506105',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37530,109,'Svn Road','506002',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37531,109,'Tadla Ookal','506315',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37532,109,'Tadlapoosalapalli','506102',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37533,109,'Tallasankeesa','506105',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37534,109,'Tattupalli','506105',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37535,109,'Teegalavenii','506112',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37536,109,'Teegarajpalli','506310',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37537,109,'Thammadapalli','506316',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37538,109,'Thanamcherla','506315',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37539,109,'Thimmarayanpahad','506332',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37540,109,'Thirumalaipalli','506314',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37541,109,'Timmapet','506331',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37542,109,'Timmapur','506005',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37543,109,'Timmapuram','506316',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37544,109,'Togarrai','506331',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37545,109,'Topanapalli','506369',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37546,109,'Turrur','506163',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37547,109,'Uggampalli','506315',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37548,109,'Upparapalli','506122',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37549,109,'Upparapalli','506310',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37550,109,'Upparapalli','506112',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37551,109,'Upparguda','506105',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37552,109,'Urus Jagir','506002',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37553,109,'Vancahnagiri','506329',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37554,109,'Vangapahad','506006',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37555,109,'Vanthadapala','506324',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37556,109,'Vavila','506317',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37557,109,'Vavilala','506102',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37558,109,'Veeram','506315',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37559,109,'Velbelli','506135',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37560,109,'Vemnoor','506102',1,0,'2022-03-03 12:38:17','2022-03-03 12:38:17'),(37561,109,'Venkatapur','506006',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37562,109,'Venkatapur','506163',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37563,109,'Venkatapur Haveli','506329',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37564,109,'Venkatapuram','506331',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37565,109,'Vennaram','506381',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37566,109,'Visnoor','506222',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37567,109,'Viswanathapur','506331',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37568,109,'Vuyyalawada','506381',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37569,109,'Waddekothapally','506318',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37570,109,'Wadlakonda','506365',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37571,109,'Walmidi','506222',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37572,109,'Warangal H.O','506002',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37573,109,'Wardhannapet','506313',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37574,109,'Yelkatte','506163',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37575,109,'Yellaigudem','506332',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37576,109,'Yellampet','506315',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37577,109,'Yellanda','506313',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37578,109,'Yerjerla','506315',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37579,109,'Yerrabelligudem','506368',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37580,109,'Zaffargadh','506316',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37581,110,'Sriraman','608703',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37582,110,'Adhanakurichi','621719',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37583,110,'Adhikudikadu','621714',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37584,110,'Alagapuram','608901',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37585,110,'Alagiamanavalam','621715',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37586,110,'Alathipallam','612903',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37587,110,'Alathiyur','621719',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37588,110,'Allinagaram','621713',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37589,110,'Ambapur','621701',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37590,110,'Ameenabad','621713',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37591,110,'Anaikudam','612902',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37592,110,'Anandavadi','621718',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37593,110,'Andimadam','621801',1,0,'2022-03-03 12:38:18','2022-03-03 12:38:18'),(37594,110,'Anganur','621709',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37595,110,'Angarayanallur','621802',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37596,110,'Anikduichan','621803',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37597,110,'Annanagar','621713',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37598,110,'Aranmanaikurichi','621851',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37599,110,'Ariyalur (Ariyalur)','621704',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37600,110,'Ariyalur Bazaar','621704',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37601,110,'Ariyalur Cement Factory','621729',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37602,110,'Arungal','621707',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37603,110,'Asaveerankudikadu','621719',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37604,110,'Attukurichi','608901',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37605,110,'Ayanathur','621705',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37606,110,'Ayantattanur','621709',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37607,110,'Ayuthakalam','612901',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37608,110,'Ayyappanaickenpettai','612903',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37609,110,'Ayyur','608901',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37610,110,'Cement Nagar Dalavoy','621730',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37611,110,'Chinnavalayam','621802',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37612,110,'Dalavoy','621730',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37613,110,'Devamangalam','612902',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37614,110,'Devanur','621806',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37615,110,'Edayakurichi','621719',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37616,110,'Edayar','621804',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37617,110,'Edayathangudi','621707',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37618,110,'Edayathimangalam','621218',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37619,110,'Elakurichi','621715',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37620,110,'Elangaicheri','621714',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37621,110,'Eravangudi','621803',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37622,110,'Gangaikondacholapuram','612901',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37623,110,'Govindapuram','621713',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37624,110,'Govindaputhur','621701',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37625,110,'Hasthinapuram','621704',1,0,'2022-03-03 12:38:19','2022-03-03 12:38:19'),(37626,110,'Idanganni','612904',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37627,110,'Ilaiyur','621806',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37628,110,'Ilandaikudam','621851',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37629,110,'Ilayaperumanallur','612903',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37630,110,'Iluppaikudi','621713',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37631,110,'Iluppaiyur','621718',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37632,110,'Inamattur','621704',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37633,110,'Irugaiyur','612904',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37634,110,'Irumbilikurichi','621804',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37635,110,'Jayamkondacholapuram','621802',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37636,110,'JC Puram West','621802',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37637,110,'Kadambur','621701',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37638,110,'Kadugur','621705',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37639,110,'Kaduvettankurichi','612904',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37640,110,'Kallankurichi','621705',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37641,110,'Kallathur Thandalai','621803',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37642,110,'Kalleri','621803',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37643,110,'Kaluvanthondi','621802',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37644,110,'Kamarasavalli','621715',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37645,110,'Kandiankollai','621806',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37646,110,'Kandirathitham','621851',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37647,110,'Karadikulam','621802',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37648,110,'Karaikurichi','612904',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37649,110,'Kargudi','612904',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37650,110,'Karuppilakattalai','621707',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37651,110,'Karuppur Senapathy','621707',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37652,110,'Kasankottai','621701',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37653,110,'Kattagaram','612903',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37654,110,'Kattathur','621803',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37655,110,'Kavanur','621704',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37656,110,'Kavarapalayam','608901',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37657,110,'Keelamichaelpatti','612904',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37658,110,'Kidaramkondan','612901',1,0,'2022-03-03 12:38:20','2022-03-03 12:38:20'),(37659,110,'Kilaiyur','621707',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37660,110,'Kilakavattankurichi','621715',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37661,110,'Kilakolathur','621715',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37662,110,'Kilakudiyiruppu','621802',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37663,110,'Kilamaligai','621710',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37664,110,'Kilamathur','621713',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37665,110,'Kilaneduvoi','621805',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37666,110,'Kilapaluvur','621707',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37667,110,'Kilaveli','621804',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37668,110,'Kodali','612902',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37669,110,'Kodalikaruppur','612902',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37670,110,'Kodukkur','621719',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37671,110,'Koilesanai','621851',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37672,110,'Kollapuram','612901',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37673,110,'Koovathur','621803',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37674,110,'Kottiyal','612904',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37675,110,'Kulathur','621803',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37676,110,'Kulumur','621714',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37677,110,'Kumiliam','621804',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37678,110,'Kumiliankuli','621803',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37679,110,'Kunamangalam','621701',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37680,110,'Kundaveli','612903',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37681,110,'Kuruvadi','621715',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37682,110,'Kuruvalapparkoil','612901',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37683,110,'Kuvagam','621710',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37684,110,'Lingathadimedu','621705',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37685,110,'Malathankulam','621707',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37686,110,'Managethi','621804',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37687,110,'Manakkal (Ariyalur)','621713',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37688,110,'Manakudayan','621719',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37689,110,'Manakudi','621705',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37690,110,'Manapathur','621709',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37691,110,'Manjamedu Karaipakkam','621715',1,0,'2022-03-03 12:38:21','2022-03-03 12:38:21'),(37692,110,'Marudur','621710',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37693,110,'Maruvathur','621710',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37694,110,'Mathur (Ariyalur)','621709',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37695,110,'Meikavalputhur','612901',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37696,110,'Melanikuli','612903',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37697,110,'Minsuritti','612903',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37698,110,'Muthuservaimadam','612903',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37699,110,'Muthuvancheri','621701',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37700,110,'Naduvalur','612904',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37701,110,'Nagalkuli','621806',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37702,110,'Nagamangalam','621701',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37703,110,'Nagampandal','608901',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37704,110,'Nakkambadi','621714',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37705,110,'Nallampalayam','621714',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37706,110,'Nayanganaipiriyal','621804',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37707,110,'Neivanam','621714',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37708,110,'O Koothur','621705',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37709,110,'Olaiyur','608901',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37710,110,'Ottakoil','621705',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37711,110,'P.Kudikadu','621710',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37712,110,'Padanilai','612903',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37713,110,'Palanganatham','621651',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37714,110,'Palayakudi','621804',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37715,110,'Pappakudi','612903',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37716,110,'Paranam','621804',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37717,110,'Parukkal','621804',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37718,110,'Pattanamkurichi','621801',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37719,110,'Peraiyur','621713',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37720,110,'Periakrishnapuram','621805',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37721,110,'Periyakurichi','621719',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37722,110,'Periyanagalur','621704',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37723,110,'Periyattirukonam','621701',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37724,110,'Periyavalayam','621802',1,0,'2022-03-03 12:38:22','2022-03-03 12:38:22'),(37725,110,'Periyavenmani','621704',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37726,110,'Pichanur','612901',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37727,110,'Pilakurichi','621806',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37728,110,'Pilichikuli','621804',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37729,110,'Pilimisai','621713',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37730,110,'Ponparappi','621710',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37731,110,'Poondi','621653',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37732,110,'Pottaveli','621718',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37733,110,'Poyyadhanallur','621718',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37734,110,'Pudukkottai-Tirumalaivadi','621851',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37735,110,'Pudukudi','621806',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37736,110,'Pungangudi','621701',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37737,110,'Rajajinagar (Ariyalur)','621713',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37738,110,'Rangiam','608901',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37739,110,'Rayambaram','621718',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37740,110,'Reddipalayam','621704',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37741,110,'Saluppai','612903',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37742,110,'Sannasinallur','621730',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37743,110,'Sathambadi','621701',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37744,110,'Sedankudikadu','621710',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37745,110,'Sendurai (Ariyalur)','621714',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37746,110,'Sengunthapuram','621802',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37747,110,'Sennivanam','621718',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37748,110,'Silambur','608901',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37749,110,'Siluppanur','621730',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37750,110,'Sirukalathur','621710',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37751,110,'Siruvalur','621704',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37752,110,'Solamadevi','612902',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37753,110,'Solankudikadu','621709',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37754,110,'Srinivasapuram','621705',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37755,110,'Sripurandan','621701',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37756,110,'Subbarayapuram','621704',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37757,110,'Sullangudi','621715',1,0,'2022-03-03 12:38:23','2022-03-03 12:38:23'),(37758,110,'Sundakudi','621701',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37759,110,'Suthamalli','621707',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37760,110,'T.Solankurichi','621804',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37761,110,'Tamaraikulam','621705',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37762,110,'Tattanur','621804',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37763,110,'Telur','621704',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37764,110,'Thaluthalaimedu','612901',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37765,110,'Thathampettai Palur','612904',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37766,110,'Thavuthaikulam','621704',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37767,110,'Thengachiperumalnatham','612904',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37768,110,'Thennur','621805',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37769,110,'Therkupatti','621710',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37770,110,'Thirumazhapadi','621851',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37771,110,'Thular','621719',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37772,110,'Thuthur','621701',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37773,110,'Tirukalappur','621805',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37774,110,'Tirumanur','621715',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37775,110,'Tiruppeyar','621715',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37776,110,'Udayanatham','612902',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37777,110,'Udayarpalayam (Ariyalur)','621804',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37778,110,'Udayarpalayam West','621804',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37779,110,'Ulkottai','612901',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37780,110,'Ulliakudi','621701',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37781,110,'Unjini','621714',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37782,110,'Vadugarpalayam','621803',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37783,110,'Valajanagaram','621704',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37784,110,'Vallam','621710',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37785,110,'Vanarathirayankuppam','612901',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37786,110,'Vanathirayanpattinam','621804',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37787,110,'Vanavanallur','612901',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37788,110,'Vangudi','612903',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37789,110,'Vanjinapuram','621714',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37790,110,'Varadarajampettai','621805',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37791,110,'Varanavasi','621704',1,0,'2022-03-03 12:38:24','2022-03-03 12:38:24'),(37792,110,'Variyankaval','621806',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37793,110,'Vazhaikurichi','612904',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37794,110,'Vellur','621718',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37795,110,'Venganur','621851',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37796,110,'Venmankondan','621804',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37797,110,'Vettiarvettu','621803',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37798,110,'Vettiyur','621707',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37799,110,'Vilangudi','621704',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37800,110,'Vizhapallam','621803',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37801,110,'Z.Melur','621803',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37802,110,'Zamin Suthamalli','621804',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37803,111,'Anna Road H.O','600002',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37804,111,'Chepauk','600005',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37805,111,'Chintadripet','600002',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37806,111,'Choolaimedu','600094',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37807,111,'Gopalapuram (Chennai)','600086',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37808,111,'Greams Road','600006',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37809,111,'Hindi Prachar Sabha','600017',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37810,111,'Lloyds Estate','600014',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37811,111,'Loyola College','600034',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37812,111,'Madras Electricity System','600002',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37813,111,'Madras University','600005',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37814,111,'Mandaveli','600004',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37815,111,'Mylapore H.O','600004',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37816,111,'Nungambakkam High Road','600034',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37817,111,'Nungambakkam','600034',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37818,111,'Old College Buildings','600006',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37819,111,'Pr. Accountant General','600018',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37820,111,'Royapettah','600014',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37821,111,'Shastri Bhavan','600006',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37822,111,'Teynampet','600018',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37823,111,'Teynampet West','600006',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37824,111,'Thygarayanagar H.O','600017',1,0,'2022-03-03 12:38:25','2022-03-03 12:38:25'),(37825,111,'Thygarayanagar North ND','600017',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37826,111,'Thygarayanagar South NDS.O','600017',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37827,111,'Tiruvallikkeni','600005',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37828,111,'Triplicane South','600014',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37829,111,'Vivekananda College Madras','600004',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37830,111,'Agaram','600082',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37831,111,'Aminjikarai','600030',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37832,111,'Anna Nagar East','600102',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37833,111,'Anna Nagar (Chennai)','600040',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37834,111,'Anna Nagar Western Extn','600101',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37835,111,'Arumbakkam','600106',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37836,111,'Aynavaram','600023',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37837,111,'Chetput','600031',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37838,111,'D G Vaishnav College','600106',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37839,111,'Edapalayam','600003',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37840,111,'Egmore ND','600008',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37841,111,'Egmore','600008',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37842,111,'Ethiraj Salai','600008',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37843,111,'Flower Bazaar','600001',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37844,111,'Flowers Road','600084',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37845,111,'Fort St George','600009',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37846,111,'G K M Colony','600082',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37847,111,'Govt Stanley Hospital','600001',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37848,111,'High Court Building (Chennai)','600104',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37849,111,'Icf Colony','600038',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37850,111,'Jawahar Nagar (Chennai)','600082',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37851,111,'Kilpauk Medical College','600010',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37852,111,'Kilpauk','600010',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37853,111,'Koyambedu','600107',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37854,111,'Kumaran Nagar','600082',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37855,111,'Madras Medical College','600003',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37856,111,'Mannady (Chennai)','600001',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37857,111,'Medavakkam Tank Road','600010',1,0,'2022-03-03 12:38:26','2022-03-03 12:38:26'),(37858,111,'Mint Building','600001',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37859,111,'MPT AO','600001',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37860,111,'Park Town H.O','600003',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37861,111,'Perambur Barracks','600012',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37862,111,'Perambur North','600011',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37863,111,'Perambur','600011',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37864,111,'Puliyanthope','600012',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37865,111,'Rayapuram','600013',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37866,111,'Ripon Buildings','600003',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37867,111,'Sembiam','600011',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37868,111,'Shenoy Nagar','600030',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37869,111,'Sowcarpet','600001',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37870,111,'Tondiarpet Bazaar','600081',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37871,111,'Tondiarpet','600081',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37872,111,'Tondiarpet West','600081',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37873,111,'Venkatesapuram','600012',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37874,111,'Vepery','600007',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37875,111,'Vyasar Nagar Colony','600039',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37876,111,'Vyasarpadi','600039',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37877,111,'Washermanpet East','600021',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37878,111,'Washermanpet','600021',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37879,111,'World University Centre','600031',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37880,111,'Adyar (Chennai)','600020',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37881,111,'Ashoknagar (Chennai)','600083',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37882,111,'Besantnagar','600090',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37883,111,'Ekkaduthangal','600032',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37884,111,'Engineering College (Chennai)','600025',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37885,111,'Guindy Industrial Estate','600032',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37886,111,'Guindy North','600015',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37887,111,'Indian Institute Of Technology','600036',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37888,111,'Jafferkhanpet','600083',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37889,111,'Kalaignar Karunanidhi Nagar','600078',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37890,111,'Kasturibai Nagar','600020',1,0,'2022-03-03 12:38:27','2022-03-03 12:38:27'),(37891,111,'Kodambakkam','600024',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37892,111,'Kotturpuram','600085',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37893,111,'Koyambedu Wholesale Market Com','600092',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37894,111,'Mambalam R.S.','600033',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37895,111,'Nandanam','600035',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37896,111,'Raja Annamalaipuram','600028',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37897,111,'Rajaji Bhavan','600090',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37898,111,'Rajbhavan (Chennai)','600022',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37899,111,'Ramakrishna Nagar (Chennai)','600028',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37900,111,'Saidapet (Chennai)','600015',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37901,111,'Saligramam','600093',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37902,111,'Shastri Nagar (Chennai)','600020',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37903,111,'Tidel Park','600113',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37904,111,'Tiruvanmiyur','600041',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37905,111,'TTTI Taramani','600113',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37906,111,'Vadapalani','600026',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37907,111,'Valmiki Nagar','600041',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37908,111,'Velacheri','600042',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37909,111,'Virugambakkam','600092',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37910,111,'West Mambalam','600033',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37911,111,'Chennai G.P.O.','600001',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37912,111,'Erukkancheri','600118',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37913,111,'Kodungaiyur','600118',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37914,111,'Rv Nagar','600118',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37915,112,'Agraharasamakulam','641110',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37916,112,'Alandurai','641101',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37917,112,'Amritanagar','641112',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37918,112,'Anaikatti','641108',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37919,112,'Arisipalayam','641032',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37920,112,'Athipalayam','641110',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37921,112,'Bharathiyar University','641046',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37922,112,'Bilichi','641019',1,0,'2022-03-03 12:38:28','2022-03-03 12:38:28'),(37923,112,'Bodipalayam','641105',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37924,112,'CBE Mpl.Central Busstand','641018',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37925,112,'Cherannagar','641029',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37926,112,'Chettipalayam','641201',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37927,112,'Chinnavedampatti','641049',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37928,112,'Coimbatore Aerodrome','641014',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37929,112,'Coimbatore Bazaar','641001',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37930,112,'Coimbatore Central','641018',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37931,112,'Coimbatore Collectorate','641018',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37932,112,'Coimbatore Courts','641018',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37933,112,'Coimbatore Fort','641001',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37934,112,'Coimbatore H.O','641001',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37935,112,'Coimbatore Industrial Estate','641021',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37936,112,'Coimbatore Press Colony','641019',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37937,112,'Coimbatore Racecourse','641018',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37938,112,'Coimbatore Tidel Park','641014',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37939,112,'Coimbatore Ukkadam','641008',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37940,112,'Coimbatore West','641001',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37941,112,'Commercial Tax Office Building','641018',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37942,112,'Deenampalayam','641109',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37943,112,'Devarayapuram','641109',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37944,112,'Dhaliyur','641109',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37945,112,'Eachanari','641021',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37946,112,'Edayapalayam','641016',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37947,112,'Edayarpalayam','641025',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37948,112,'Elur','641032',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37949,112,'Ettimadai','641112',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37950,112,'Ganapathy','641006',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37951,112,'Gandhimaanagar','641004',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37952,112,'Gandhipuram (Coimbatore)','641012',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37953,112,'Ganesapuram','641107',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37954,112,'Gnanambika Mills','641029',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37955,112,'Govt.College Of Technology','641013',1,0,'2022-03-03 12:38:29','2022-03-03 12:38:29'),(37956,112,'Gudalur-coimbatore','641047',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37957,112,'Idigarai','641022',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37958,112,'Ikkarai Boluvampatti','641109',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37959,112,'Ishana Vihar','641114',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37960,112,'Jakkirnaickenpalayam','641109',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37961,112,'Jothipuram','641047',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37962,112,'Kalampalayam','641010',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37963,112,'Kalapatti','641048',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37964,112,'Kallapalayam','641201',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37965,112,'Kallipalayam','641107',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37966,112,'Kandegounden Salai','641105',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37967,112,'Karunyanagar','641114',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37968,112,'Kattampatti-coimbatore','641107',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37969,112,'Kavundampalayam','641030',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37970,112,'Kavundampalayam Colony','641030',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37971,112,'Keeranatham','641035',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37972,112,'Komarapalayam Coimbatore','641026',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37973,112,'Konavaikalpalayam','641023',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37974,112,'Kondayampalayam','641110',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37975,112,'Kottaipalayam','641110',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37976,112,'Kovaipudur','641042',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37977,112,'Krishnarayapuram','641006',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37978,112,'Krishnaswamy Nagar','641045',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37979,112,'Kumittipathi','641032',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37980,112,'Kuniamuthur','641008',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37981,112,'Kunnathurpudur','641107',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37982,112,'Kuppaipalayam','641107',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37983,112,'Kuppakonanpudur','641038',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37984,112,'Kuppanur','641010',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37985,112,'Kurumbapalayam','641107',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37986,112,'Lawley Road','641003',1,0,'2022-03-03 12:38:30','2022-03-03 12:38:30'),(37987,112,'Madampatti','641010',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(37988,112,'Madhvarayapuram','641101',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(37989,112,'Madukkarai Cusba','641105',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(37990,112,'Madukkarai','641105',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(37991,112,'Malumichampatti','641050',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(37992,112,'Maniakarampalayam','641006',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(37993,112,'Marudamalai','641046',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(37994,112,'Masagoundenchettipalayam','641107',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(37995,112,'Masthigoundenpathi','641032',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(37996,112,'Mathipalayam','641101',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(37997,112,'Meenakshipuram','641032',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(37998,112,'Mylampatti','641062',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(37999,112,'Myleripalayam','641032',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(38000,112,'N.G.G.O Colony','641022',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(38001,112,'Naickenpalayam','641020',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(38002,112,'Nanjundapuram','641036',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(38003,112,'Nanjundapuram-tadagam','641108',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(38004,112,'Narasimhanaickenpalayam','641031',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(38005,112,'Narasipuram','641109',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(38006,112,'Nathegoundenpudur','641101',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(38007,112,'Neelikonampalayam','641033',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(38008,112,'Nilambur','641062',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(38009,112,'Odayampalayam','641028',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(38010,112,'Ondipudur','641016',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(38011,112,'Othakkalmandapam','641032',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(38012,112,'P&t Staff Quarters','641011',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(38013,112,'Pachapalayam','641107',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(38014,112,'Palathurai','641105',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(38015,112,'Panapatti','641201',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(38016,112,'Pannimadai','641017',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(38017,112,'Pappampatti','641016',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(38018,112,'Pappanaickenpalayam','641037',1,0,'2022-03-03 12:38:31','2022-03-03 12:38:31'),(38019,112,'Pappanaickenpalayam West','641037',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38020,112,'Pappanaickenpudur','641041',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38021,112,'Pathanjalipuri','641108',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38022,112,'Pattanam','641016',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38023,112,'Peedampalli','641016',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38024,112,'Peelamedu East','641004',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38025,112,'Peelamedu','641004',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38026,112,'Periyakuyilai','641201',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38027,112,'Periyanaickenpalayam','641020',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38028,112,'Perur Chettipalayam','641010',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38029,112,'Perur (Coimbatore)','641010',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38030,112,'Pichanur','641105',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38031,112,'Podanur Newtown','641023',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38032,112,'Podanur','641023',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38033,112,'Ponnegoundenpudur','641107',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38034,112,'Puliyakulam','641045',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38035,112,'Puluvapatti','641101',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38036,112,'R.S.Puram East','641002',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38037,112,'R.S.Puram South','641002',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38038,112,'R.S.Puram West','641002',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38039,112,'Rakkipalayam','641031',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38040,112,'Ramanathapuram Coimbatore','641045',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38041,112,'Ramnagar Coimbatore','641009',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38042,112,'Rathinapuri','641027',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38043,112,'Rathinasabapathy Puram H.O','641002',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38044,112,'Redfields','641018',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38045,112,'S.B.Institute','641007',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38046,112,'Sahs College','641043',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38047,112,'Saibaba Mission','641011',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38048,112,'Samichettipalayam','641047',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38049,112,'Saravanampatti','641035',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38050,112,'Sarkarsamakulam','641107',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38051,112,'Seeranaickenpalayam','641007',1,0,'2022-03-03 12:38:32','2022-03-03 12:38:32'),(38052,112,'Selvapuram','641026',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38053,112,'Semmedu','641114',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38054,112,'Sengalipalayam','641022',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38055,112,'Siddhapudur','641044',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38056,112,'Singanallur','641005',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38057,112,'Sinnanavakkarai','641105',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38058,112,'Sinniampalayam','641062',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38059,112,'Siruvani Adivaram','641114',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38060,112,'Somayampalayam','641108',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38061,112,'Sowripalayam','641028',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38062,112,'Sri Ramakrishna Vidyalaya','641020',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38063,112,'Sugunapuram','641008',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38064,112,'Sukrawarpettai','641001',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38065,112,'Sundakkamuthur','641010',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38066,112,'Sundapalayam','641007',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38067,112,'Sundarapuram','641024',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38068,112,'Tadagam','641108',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38069,112,'Tatabad','641012',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38070,112,'Tekkupalayam','641020',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38071,112,'Telungupalayam','641039',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38072,112,'Tenkarai','641101',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38073,112,'Thennamanallur','641109',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38074,112,'Thirumalayampalayam','641105',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38075,112,'Thondamuthur','641109',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38076,112,'Thoppampatti','641017',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38077,112,'Titipalayam','641010',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38078,112,'Tudiyalur','641034',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38079,112,'Uppilipalayam','641015',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38080,112,'Vadamadurai Kurudampalayam','641017',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38081,112,'Vadavalli','641041',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38082,112,'Vadugapalayam','641107',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38083,112,'Vaiyampalayam','641110',1,0,'2022-03-03 12:38:33','2022-03-03 12:38:33'),(38084,112,'Valukkuparai','641032',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38085,112,'Vedapatti','641007',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38086,112,'Veerakeralam','641007',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38087,112,'Veerapandi Periyanaickenpalaya','641019',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38088,112,'Veerapandi-tadagam','641108',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38089,112,'Velandipalayam','641025',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38090,112,'Vellakinar','641029',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38091,112,'Vellalapalayam Podanur','641111',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38092,112,'Vellalore','641111',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38093,112,'Vellamadai','641110',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38094,112,'Vellanaipatti','641048',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38095,112,'Venkitapuram','641062',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38096,112,'Vilankurichi','641035',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38097,112,'Viraliyur','641109',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38098,112,'Kuttagam','638462',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38099,112,'Merkupathi','638103',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38100,112,'Pattampalayam','638458',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38101,112,'Sokkanur','638103',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38102,112,'Thirumalaigoundenpalayam','638462',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38103,112,'Vallipuram','638103',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38104,112,'A.Nagore','642205',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38105,112,'Achipatti','642002',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38106,112,'Agrahara Kannadiputhur','642111',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38107,112,'Akilandapuram','642004',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38108,112,'Akkamalai','642127',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38109,112,'Alagirichettipalayam','642110',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38110,112,'Aliyar Nagar','642101',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38111,112,'Amandakadavoo','642201',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38112,112,'Amaravathi Nagar','642102',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38113,112,'Ambarampalayam','642103',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38114,112,'Ammapatti','642205',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38115,112,'Anaimalai','642104',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38116,112,'Andigoundanur','642154',1,0,'2022-03-03 12:38:34','2022-03-03 12:38:34'),(38117,112,'Andipalayam','642120',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38118,112,'Angalakurichi','642007',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38119,112,'Arasampalayam','642109',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38120,112,'Athu Pollachi','642103',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38121,112,'Athukinathupatti','642206',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38122,112,'Bodipatti','642154',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38123,112,'Chellappampalayam','642207',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38124,112,'Chinna Negamam','642120',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38125,112,'Chinnakallar','642106',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38126,112,'Chinnappampalayam','642104',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38127,112,'Cinchona East','642106',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38128,112,'Cinchona','642106',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38129,112,'Dasanaicken Palayam','642202',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38130,112,'Deepalapatti','642132',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38131,112,'Devambadi','642005',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38132,112,'Devanurpudur','642207',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38133,112,'Devarayapuram','642110',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38134,112,'Devenampalayam','642120',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38135,112,'Dhully','642112',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38136,112,'Divansapudur','642103',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38137,112,'Doddampatti','642205',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38138,112,'Elayamuthur','642154',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38139,112,'Eripalayam','642126',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38140,112,'Eripatti','642205',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38141,112,'Erisinampatti','642207',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38142,112,'Ganapathipalayam','642103',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38143,112,'Ganapathipalayam','642122',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38144,112,'Gandhi Market (Coimbatore)','642001',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38145,112,'Gandhinagar (Pollachi)','642154',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38146,112,'Gomangalam','642107',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38147,112,'Gudimangalam','642201',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38148,112,'High Forest','642127',1,0,'2022-03-03 12:38:35','2022-03-03 12:38:35'),(38149,112,'Iyerpadi','642108',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38150,112,'Jakkarpalayam','642202',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38151,112,'Jallipatti','642112',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38152,112,'Jothampatti','642203',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38153,112,'Kadamparai Power House','642101',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38154,112,'Kadathur','642203',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38155,112,'Kakkadavoo','642120',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38156,112,'Kaliapuram','642110',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38157,112,'Kaliapuram','642129',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38158,112,'Kallapuram','642102',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38159,112,'Kambalapatti','642007',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38160,112,'Kaniyur','642203',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38161,112,'Kanjampatti','642003',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38162,112,'Kannamanaickanur','642154',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38163,112,'Kappalankarai','642120',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38164,112,'Karamalai Bazaar','642130',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38165,112,'Karatholuvu','642203',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38166,112,'Karuppampalayam','642004',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38167,112,'Kattampatti','642202',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38168,112,'Kinathukadavoo','642109',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38169,112,'Kodingium','642122',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38170,112,'Kolarpatti','642107',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38171,112,'Kolumam','642204',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38172,112,'Komaralingam','642204',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38173,112,'Kondampatti','641202',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38174,112,'Kondampatti','642201',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38175,112,'Kondegoundenpalayam','642120',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38176,112,'Kongalnagaram','642205',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38177,112,'Korangumudi','642127',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38178,112,'Kothavadi','642109',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38179,112,'Kottamangalam','642201',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38180,112,'Kovilpalayam','642110',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38181,112,'Krishnapuram (Coimbatore)','642111',1,0,'2022-03-03 12:38:36','2022-03-03 12:38:36'),(38182,112,'Kuralkuttai','642154',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38183,112,'Kurichikottai','642112',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38184,112,'Kurumbapalayam','642002',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38185,112,'Kurunallipalayam','641202',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38186,112,'Lakshmapuram','642107',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38187,112,'Madathukulam','642113',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38188,112,'Mahalinga Puram','642002',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38189,112,'Makkinaicken Patti','642003',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38190,112,'Malayandipattinam','642114',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38191,112,'Manamboli','642127',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38192,112,'Mannur','642005',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38193,112,'Manupatti','642112',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38194,112,'Mappillaigoundenpudur','642005',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38195,112,'Marapettai','642001',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38196,112,'Marappagoundenpudur','642103',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38197,112,'Metrathi','642203',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38198,112,'Mettubavi','641202',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38199,112,'Mettupalayam','642110',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38200,112,'Minparai','642101',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38201,112,'Mohavanur','642202',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38202,112,'Moongiltholuvu','642202',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38203,112,'Mount Stuart','642105',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38204,112,'Mudis','642117',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38205,112,'Munduvelampatti','642206',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38206,112,'Murugali Bazaar','642125',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38207,112,'Muthur','642109',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38208,112,'Myvadi','642203',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38209,112,'N.G.M College','642001',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38210,112,'Nallamudi','642117',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38211,112,'Nallannagoundanpudur','642204',1,0,'2022-03-03 12:38:37','2022-03-03 12:38:37'),(38212,112,'Nallattipalayam','642109',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38213,112,'Nalluthukuli','642005',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38214,112,'Navamalai Camp','642101',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38215,112,'Negamam','642120',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38216,112,'Nirar Dam','642127',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38217,112,'Odayakulam','642129',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38218,112,'Old Valparai','642127',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38219,112,'Palanigoundenpudur','642002',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38220,112,'Palarpathy','642109',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38221,112,'Pallapalayam','642112',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38222,112,'Pannimade','642127',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38223,112,'Pappankulam','642204',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38224,112,'Paralai','642108',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38225,112,'Pedappampatti','642205',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38226,112,'Periakomarapalayam','642201',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38227,112,'Periapatti','642201',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38228,112,'Periapodu','642103',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38229,112,'Periya Kallar','642106',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38230,112,'Pethanaickanur','642134',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38231,112,'Pollachi Bazaar','642001',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38232,112,'Pollachi H.O','642001',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38233,112,'Pollachi RS','642001',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38234,112,'Pollachi West','642001',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38235,112,'Poosaripatti','642205',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38236,112,'Poravipalayam','642110',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38237,112,'Pudupalayam','642205',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38238,112,'Pukkulam','642154',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38239,112,'Pulankinar','642122',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38240,112,'Pulavadi','642206',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38241,112,'Puliampatti','642002',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38242,112,'Pungamuthur','642207',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38243,112,'R.Ponnapuram','642002',1,0,'2022-03-03 12:38:38','2022-03-03 12:38:38'),(38244,112,'Ramachandrapuram','642120',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38245,112,'Ramanamudali Pudur','642134',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38246,112,'Ramapattinam','642005',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38247,112,'Ravanapuram','642207',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38248,112,'Reddiarur','642007',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38249,112,'Rudrapalayam','642204',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38250,112,'Samarayapatti','642204',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38251,112,'Samathur','642123',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38252,112,'Sarkarkannadipudur','642113',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38253,112,'Sarkarpathi','642133',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38254,112,'Seelakkampatti','642205',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38255,112,'Senguttaipalayam','642120',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38256,112,'Senjellappagoundenpudur','642122',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38257,112,'Sethumadai','642133',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38258,112,'Settiakkapalayam','642120',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38259,112,'Sheikalmudi','642125',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38260,112,'Sholayar','642127',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38261,112,'Sholayar Nagar','642125',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38262,112,'Singarampalayam','642109',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38263,112,'Sirukalandai','642202',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38264,112,'Sirukundra','642127',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38265,112,'Sokkanur','642109',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38266,112,'Solamadevi','642113',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38267,112,'Solvampalayam','642109',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38268,112,'Somandurai','642134',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38269,112,'Subbegoundenpudur','642103',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38270,112,'Sulakkal','642110',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38271,112,'Suleeswaran Patti','642006',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38272,112,'Sundakkampalayam','642132',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38273,112,'T.Kottampatti','642002',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38274,112,'Thalakarai','642005',1,0,'2022-03-03 12:38:39','2022-03-03 12:38:39'),(38275,112,'Thalanar','642105',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38276,112,'Thamaraikulam','642109',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38277,112,'Thathur','642104',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38278,112,'Thenkumarapalayam','642107',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38279,112,'Thimmankothu','642005',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38280,112,'Thippampatti','642107',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38281,112,'Thirumurthi Nagar','642112',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38282,112,'Thondamuthur','642123',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38283,112,'Thumbalapatti','642154',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38284,112,'Thungavi','642203',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38285,112,'Topslip','642133',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38286,112,'Udamalpet Bazaar','642126',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38287,112,'Udamalpet East','642126',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38288,112,'Udamalpet H.O','642126',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38289,112,'Udamalpet South','642126',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38290,112,'Udukkampalayam','642207',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38291,112,'Unjavelampatti','642003',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38292,112,'Upper Aliyar Dam','642101',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38293,112,'Uralpatti','642204',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38294,112,'Urulikkal','642127',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38295,112,'Uthukuli Zamin','642004',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38296,112,'Vadakkipalayam','642110',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38297,112,'Vadasithur','641202',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38298,112,'Vadugapalayam','642205',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38299,112,'Vadugapalayam','642001',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38300,112,'Vagatholuvu','642202',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38301,112,'Valavadi','642132',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38302,112,'Vallakondapuram','642207',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38303,112,'Valparai','642127',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38304,112,'Vazhai Thottam','642127',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38305,112,'Vedapatti','642203',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38306,112,'Vedasanthur','642007',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38307,112,'Vellalapalayam','642120',1,0,'2022-03-03 12:38:40','2022-03-03 12:38:40'),(38308,112,'Vellamalai','642130',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38309,112,'Vellonie','642127',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38310,112,'Venkatesa Mills','642128',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38311,112,'Vettaikaran Pudur','642129',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38312,112,'Vilamarathupatti','642207',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38313,112,'Virugalpatti','642120',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38314,112,'Water Falls Estate','642105',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38315,112,'Waverly','642105',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38316,112,'Zamin Kottampatti','642123',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38317,112,'Zamin Muthur','642005',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38318,112,'15 Velampalayam','641652',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38319,112,'63 Velampalayam','641663',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38320,112,'Agraharapudur','641663',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38321,112,'Akkaraisengapalli','641302',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38322,112,'Alagumalai','641665',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38323,112,'Alancombu','641302',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38324,112,'Alathur','641655',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38325,112,'Allapalayam','641653',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38326,112,'Andipalayam','641687',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38327,112,'Annupapatti','641664',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38328,112,'Annur','641653',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38329,112,'Annur-mettupalayam','641653',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38330,112,'Anuppapalayam','641652',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38331,112,'Appanaickenpatti','641402',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38332,112,'Arasampalayam','641604',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38333,112,'Arasur','641407',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38334,112,'Athappagoundenpudur','641103',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38335,112,'Avanash','641654',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38336,112,'Ayyankalipalayam','641603',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38337,112,'Belladi','641104',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38338,112,'Bellaipalayam','641302',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38339,112,'Bhujanganur','641113',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38340,112,'Bogampatti','641658',1,0,'2022-03-03 12:38:41','2022-03-03 12:38:41'),(38341,112,'Chandrapuram','641669',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38342,112,'Chennappachettipudur','641659',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38343,112,'Cheyur (Coimbatore)','641655',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38344,112,'Chikkarampalayam','641104',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38345,112,'Chinthamanipudur','641103',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38346,112,'Chittambalam','641664',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38347,112,'Dasanur','641305',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38348,112,'Devanampalayam','641667',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38349,112,'Doddampatti','641667',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38350,112,'Elavanthi','641664',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38351,112,'Ellapalayam','641697',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38352,112,'Gandhinagar (Coimbatore)','641603',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38353,112,'Ganganaickenpalayam','641667',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38354,112,'Giddampalayam','641659',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38355,112,'Golenpet','641401',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38356,112,'Ichipatti','641668',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38357,112,'Iduvampalayam','641687',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38358,112,'Iduvoi','641687',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38359,112,'Illuppapalayam','641302',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38360,112,'Irugur','641103',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38361,112,'Ittiveerampalayam','641666',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38362,112,'J.Krishnapuram','641671',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38363,112,'Jadayampalayam','641302',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38364,112,'Jalakarichal','641658',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38365,112,'Jallipatti','641671',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38366,112,'K.Ayyampalayam','641662',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38367,112,'Kadampadi','641401',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38368,112,'Kaduvettipalayam','641659',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38369,112,'Kalingal','641402',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38370,112,'Kallampalayam Road','641602',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38371,112,'Kallar','641305',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38372,112,'Kallivelampatti','641662',1,0,'2022-03-03 12:38:42','2022-03-03 12:38:42'),(38373,112,'Kamanaickenpalayam','641658',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38374,112,'Kamatchipuram','641103',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38375,112,'Kammalapatti','641671',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38376,112,'Kandiankoil','641665',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38377,112,'Kangayampalayam','641401',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38378,112,'Kaniyur-palladam','641659',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38379,112,'Kanjapalli','641653',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38380,112,'Kannakkampalayam','641666',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38381,112,'Kannampalayam','641402',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38382,112,'Kanur','641655',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38383,112,'Karadibavi','641658',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38384,112,'Karamadai','641104',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38385,112,'Karavalimadapur','641668',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38386,112,'Karavalur','641670',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38387,112,'Karegoundenpalayam','641697',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38388,112,'Kariampalayam','641671',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38389,112,'Karukkampalayam','641654',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38390,112,'Karukkankattupudur','641654',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38391,112,'Karukkankattupudur','641601',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38392,112,'Karumathampatti','641659',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38393,112,'Karunampathi','641666',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38394,112,'Karuvampalayam','641604',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38395,112,'Kathankanni','641604',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38396,112,'Katturpalldam','641667',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38397,112,'Kettanur','641671',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38398,112,'Kodangipalayam','641662',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38399,112,'Komarapalayam','641669',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38400,112,'Komarapalayam','641653',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38401,112,'Ksn Puram','641662',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38402,112,'Kumarnagar','641603',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38403,112,'Kuppandampalayam','641654',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38404,112,'Kuppanur','641653',1,0,'2022-03-03 12:38:43','2022-03-03 12:38:43'),(38405,112,'Lakshminaickenpalayam','641658',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38406,112,'Madapur','641664',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38407,112,'Mahadevapuram','641305',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38408,112,'Malayadipalayam','641669',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38409,112,'Mandiripalayam','641671',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38410,112,'Mangalakaraipudur','641104',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38411,112,'Mangalam (Coimbatore)','641663',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38412,112,'Mangarasavalayapalayam','641655',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38413,112,'Mannarai','641607',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38414,112,'Manur','641606',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38415,112,'Marudur','641104',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38416,112,'Maruduraiyanvalasu','641604',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38417,112,'Medur','641113',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38418,112,'Mettupalayam Bazaar','641301',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38419,112,'Mettupalayam H.O','641301',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38420,112,'Moperipalayam','641659',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38421,112,'Mudalipalayam','641606',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38422,112,'Muriandampalayam','641655',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38423,112,'Muthanampalayam','641606',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38424,112,'Muthugoundenpudur','641402',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38425,112,'Nachipalayam','641606',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38426,112,'Nagammapudur','641653',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38427,112,'Nallichettipalayam','641653',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38428,112,'Nallur','641606',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38429,112,'Nambiampalayam','641670',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38430,112,'Naranapuram','641664',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38431,112,'Nathagoundenpalayam','641664',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38432,112,'Nellithurai','641305',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38433,112,'Ngr Road','641664',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38434,112,'Oddarpalayam','641103',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38435,112,'Odderpalayam','641653',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38436,112,'P.Vadugapalayam','641664',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38437,112,'Paduvampalli','641659',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38438,112,'Palapatti','641305',1,0,'2022-03-03 12:38:44','2022-03-03 12:38:44'),(38439,112,'Palladam','641664',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38440,112,'Pallapalayam','641663',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38441,112,'Pallikalipalayam','641665',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38442,112,'Panickampatti','641664',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38443,112,'Pappankulam','641655',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38444,112,'Paralipower House','641104',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38445,112,'Paruvoi','641658',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38446,112,'Pasur-avanashi','641653',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38447,112,'Periakallipatti','641302',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38448,112,'Periaputhur','641697',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38449,112,'Periyayipalayam','641654',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38450,112,'Perumanallur','641666',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38451,112,'Peruntholuvu','641665',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38452,112,'Pichampalayampudur','641603',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38453,112,'Pilliappampalayam','641653',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38454,112,'Pillurdam','641104',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38455,112,'Pn Road','641602',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38456,112,'Pogalur','641697',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38457,112,'Pongalur','641667',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38458,112,'Pongupalayam','641666',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38459,112,'Poomalur','641663',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38460,112,'Pudupalayam','641654',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38461,112,'Puliamarathupalayam','641669',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38462,112,'Puliampatti','641658',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38463,112,'Puluvapatti','641602',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38464,112,'Purandampalayam','641669',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38465,112,'Rakkiapalayam','641654',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38466,112,'Ramanathapuram','641670',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38467,112,'Ranganathapuram','641654',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38468,112,'Rasipalayam','641402',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38469,112,'Ravathur','641103',1,0,'2022-03-03 12:38:45','2022-03-03 12:38:45'),(38470,112,'S.Ayyampalayam','641671',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38471,112,'Samalapuram','641663',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38472,112,'Seeliyur','641113',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38473,112,'Sembianallur','641654',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38474,112,'Semmandampalayam','641668',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38475,112,'Senjeri','641669',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38476,112,'Senjeriputhur','641671',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38477,112,'Siddanaickenpalayam','641658',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38478,112,'Sinnakallipatti','641302',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38479,112,'Sirumugai','641302',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38480,112,'Sirupuluvapatti','641603',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38481,112,'Sokkampalayam','641653',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38482,112,'Somanur','641668',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38483,112,'Subarayanpudur','641668',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38484,112,'Sukkampalayam','641662',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38485,112,'Sultanpet','641669',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38486,112,'Sulur','641402',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38487,112,'Sundakkampalayam','638402',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38488,112,'T.C.Market','641604',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38489,112,'Talakarai','641671',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38490,112,'Tea Nagar','641606',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38491,112,'Thandukaranpalayam','641655',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38492,112,'Thekkalur','641654',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38493,112,'Thekkampatti','641113',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38494,112,'Therampalayam','641697',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38495,112,'Thimmanur','641302',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38496,112,'Tholampalayam','641113',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38497,112,'Thomaspuram','641654',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38498,112,'Thonguttipalayam','641665',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38499,112,'Thulukkamuthur','641654',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38500,112,'Tirumuruganpoondi','641652',1,0,'2022-03-03 12:38:46','2022-03-03 12:38:46'),(38501,112,'Tiruneelakandapuram','641607',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38502,112,'Tirupur Bazaar','641604',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38503,112,'Tirupur East','641607',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38504,112,'Tirupur H.O','641601',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38505,112,'Tirupur North','641602',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38506,112,'Uppilipalayam','641670',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38507,112,'V.Kallipalayam','641664',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38508,112,'V.Vadamalaipalayam','641664',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38509,112,'Vadakkalur','641653',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38510,112,'Vadambacherry','641669',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38511,112,'Vadavalli-karamadai','641697',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38512,112,'Vadavedampatti','641671',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38513,112,'Vadugankallipalayam','641663',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38514,112,'Vadugapalayam','641654',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38515,112,'Vaharayampalayam','641659',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38516,112,'Vanjipalayam','641663',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38517,112,'Vavipalayam','641666',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38518,112,'Vavipalayamkettanur','641671',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38519,112,'Veerapandi (Coimbatore)','641605',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38520,112,'Velappanaickenpalayam','641669',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38521,112,'Velayuthampalayam','641654',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38522,112,'Velliankadu','641104',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38523,112,'Vengitapuram','641664',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38524,112,'Vettuvapalayam','641670',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38525,112,'Vijayapuram (Coimbatore)','641606',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38526,112,'Vivekanandapuram','641113',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38527,112,'Pappanampatti','624622',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38528,113,'Chellanchery','605106',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38529,113,'Mathalapattu','605007',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38530,113,'Nallathur','605106',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38531,113,'Pakkam','605106',1,0,'2022-03-03 12:38:47','2022-03-03 12:38:47'),(38532,113,'Reddichavadi','607403',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38533,113,'Singirikoil','605007',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38534,113,'Thokkanambakkam','607402',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38535,113,'A.Kuravankuppam','607802',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38536,113,'Adinarayananpuram','608801',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38537,113,'Adur Agaram','607302',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38538,113,'Agara Alambadi','608702',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38539,113,'Agaram','608502',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38540,113,'Akkadavalli','607205',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38541,113,'Akkarai Gori','607003',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38542,113,'Alagaperumalkuppam','607101',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38543,113,'Alaginatham','607109',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38544,113,'Alapakkam','608801',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38545,113,'Alkondanatham','608305',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38546,113,'Ambalavananpettai','607301',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38547,113,'Ambapuram','608704',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38548,113,'Ammapettai','608401',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38549,113,'Ammeri','607802',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38550,113,'Andarmullipallam','608801',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38551,113,'Anguchettipalayam','607106',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38552,113,'Annamalai University','608002',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38553,113,'Annamalainagar','608002',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38554,113,'Annavalli','607003',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38555,113,'Anukkampattu','607301',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38556,113,'Arangamangalam','607302',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38557,113,'Arantangi','608301',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38558,113,'Arasadikkuppam','607103',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38559,113,'Ariyakoshti','608502',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38560,113,'Athipatu','608401',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38561,113,'Aviyanur','607101',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38562,113,'Ayangudi','608306',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38563,113,'Ayikuppam','607301',1,0,'2022-03-03 12:38:48','2022-03-03 12:38:48'),(38564,113,'Ayyanur Akkaramangalam','608201',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38565,113,'Azhisikudi','608601',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38566,113,'B.Adivaraganallur','608501',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38567,113,'B.Kolakudi','608704',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38568,113,'B.Mutlur','608501',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38569,113,'B.Odaiyur','608601',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38570,113,'Badrakottai','607102',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38571,113,'Bandarakottai','607108',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38572,113,'Bhuvanagiri','608601',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38573,113,'Block 1',' Neyveli',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38574,113,'Block 10','neyveli',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38575,113,'Block 18',' Neyveli',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38576,113,'Block 24',' Neyveli',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38577,113,'Block 26',' Neyveli',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38578,113,'Block 29',' Neyveli',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38579,113,'Block 5',' Neyveli',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38580,113,'Budangudi','608702',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38581,113,'Budavarayanpettai','608601',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38582,113,'C.Arasur','608302',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38583,113,'C.Mutlur','608102',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38584,113,'C.Pudupettai','608502',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38585,113,'C.Sathamangalam','608201',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38586,113,'C.Veeracholagam','608602',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38587,113,'Capperquary','607005',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38588,113,'Chettithangal','608304',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38589,113,'Chidambaram East','608001',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38590,113,'Chidambaram H.O','608001',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38591,113,'Chidambaram North','608001',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38592,113,'Chidambaram West','608001',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38593,113,'Chinnakannadi','607302',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38594,113,'Chinnanargunam','608704',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38595,113,'Chinnapanaickenpalayam','607102',1,0,'2022-03-03 12:38:49','2022-03-03 12:38:49'),(38596,113,'Cuddalore Court Buildings','607001',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38597,113,'Cuddalore H.O','607001',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38598,113,'Cuddalore Old Town','607003',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38599,113,'Cuddalore Ot Bazaar','607003',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38600,113,'Cuddalore Port','607003',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38601,113,'Cuddalore Public Offices','607001',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38602,113,'Edayarkuppam','607102',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38603,113,'Elleri','608303',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38604,113,'Elumedu','607104',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38605,113,'Enathirimangalam','607108',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38606,113,'Ennanagaram','608602',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38607,113,'Erumbur','608704',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38608,113,'Eyyalur','608304',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38609,113,'Fort St.David','607001',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38610,113,'Gandhi Nagar (Cuddalore)','607308',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38611,113,'Gavarappattu','608002',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38612,113,'Gudithangi','607105',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38613,113,'Gunamangalam','607109',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38614,113,'Gundu Uppalavadi','607006',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38615,113,'Guruvappanpettai','607302',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38616,113,'Iruppu','607805',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38617,113,'Jayankondapattinam','608002',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38618,113,'K.Adur','608602',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38619,113,'K.Alambadi','608602',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38620,113,'Kadambuliyur','607103',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38621,113,'Kalaiyur','607109',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38622,113,'Kalinjikuppam','607104',1,0,'2022-03-03 12:38:50','2022-03-03 12:38:50'),(38623,113,'Kalkunam','607302',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38624,113,'Kandakumaran','608305',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38625,113,'Kandamangalam','608301',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38626,113,'Kandrakottai','607205',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38627,113,'Kanisapakkam','607106',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38628,113,'Kanjankollai','608304',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38629,113,'Kanur','608701',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38630,113,'Karumbur','607108',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38631,113,'Karunakaranallur','608301',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38632,113,'Karunguli','607303',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38633,113,'Karuppur','608401',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38634,113,'Kattamuthupalayam','607205',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38635,113,'Kattugudalur','607805',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38636,113,'Kattumannarkoil','608301',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38637,113,'Kavalakudi','608702',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38638,113,'Kavanur','608703',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38639,113,'Keelamoongiladi','608102',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38640,113,'Keelanuvampattu','608102',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38641,113,'Keerapalayam','608602',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38642,113,'Kilarungunam','607105',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38643,113,'Kiliruppu','607103',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38644,113,'Kilkangeyankuppam','607805',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38645,113,'Kilkavarappattu','607112',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38646,113,'Killai','608102',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38647,113,'Kilmampattu','607106',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38648,113,'Kilur','607302',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38649,113,'Kodiyampalayam','608002',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38650,113,'Kodukkanpalayam','607003',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38651,113,'Kollimalai Kilpathi','608303',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38652,113,'Kollumedu','608303',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38653,113,'Komaratchi','608302',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38654,113,'Kondasamudram','608701',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38655,113,'Kondur','607006',1,0,'2022-03-03 12:38:51','2022-03-03 12:38:51'),(38656,113,'Kongarayanur','607104',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38657,113,'Kothattai','608501',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38658,113,'Kothavacheri','608601',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38659,113,'Kothavasal','608305',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38660,113,'Kottagam','607802',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38661,113,'Kovilampoondi','608002',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38662,113,'Kozhai','608703',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38663,113,'Krishnankuppam','607301',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38664,113,'Krishnapuram','608602',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38665,113,'Kudimiyankuppam','607101',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38666,113,'Kuduveli','608305',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38667,113,'Kullanchavadi','607301',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38668,113,'Kumarakud','608702',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38669,113,'Kumaramangalam','607205',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38670,113,'Kummidimulai','608601',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38671,113,'Kunamangalam','608703',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38672,113,'Kundiyamallur','607301',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38673,113,'Kunjimedu','608306',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38674,113,'Kuriamangalam','608501',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38675,113,'Kurinjipadi','607302',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38676,113,'Lakshminarayanapuram','607106',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38677,113,'Lalpet','608303',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38678,113,'Lalpuram','608602',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38679,113,'M.Adhanur','608304',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38680,113,'M.Kolakudi','608301',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38681,113,'M.Odaiyur','608303',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38682,113,'M.Pudur','607004',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38683,113,'M.Puliyangudi','608302',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38684,113,'Madanagopalapuram','607301',1,0,'2022-03-03 12:38:52','2022-03-03 12:38:52'),(38685,113,'Maduranthaganallur','608201',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38686,113,'Maligaimedu','607112',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38687,113,'Maligampattu','607106',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38688,113,'Mamangalam','608701',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38689,113,'Manamthavizhnthaputhur','607101',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38690,113,'Maniadur','608303',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38691,113,'Manikollai','608501',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38692,113,'Manjakkuppam','607001',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38693,113,'Manjakollai','608601',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38694,113,'Manjakuli','608501',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38695,113,'Marudadu','607109',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38696,113,'Marudur','608704',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38697,113,'Marungur','608703',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38698,113,'Marungur','607103',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38699,113,'Maruvai','607303',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38700,113,'Melakadambur','608304',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38701,113,'Melakolakudi','607802',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38702,113,'Melakuppam','607802',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38703,113,'Melamanakudi','608601',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38704,113,'Melapalachanallur','608301',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38705,113,'Melaparuthikudi','608302',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38706,113,'Melavanniyur','608302',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38707,113,'Melkavrapattu','607112',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38708,113,'Melmampattu','607103',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38709,113,'Melpattambakkam','607104',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38710,113,'Mettukkuppam','607802',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38711,113,'Miralur','608601',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38712,113,'Mogaiyur','608305',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38713,113,'Moolakuppam','607303',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38714,113,'Movur','608306',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38715,113,'Mudapuli','607805',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38716,113,'Mudikandanallur','608702',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38717,113,'Mullangudi','608302',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38718,113,'Muthukamatchithottam','608001',1,0,'2022-03-03 12:38:53','2022-03-03 12:38:53'),(38719,113,'Muttam','608306',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38720,113,'N.Moolakuppam','607102',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38721,113,'Nadukkuppam','607103',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38722,113,'Naduveerappattu','607102',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38723,113,'Nagarapadi','608703',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38724,113,'Nakkaravanthankudi','608002',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38725,113,'Nandesswaramangalam','608702',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38726,113,'Nangudi','608702',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38727,113,'Nanjalur','608302',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38728,113,'Nanjamahathuvazkai','608102',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38729,113,'Natham','607101',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38730,113,'Nathapattu','607109',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38731,113,'Nattarmangalam','608301',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38732,113,'Nellikkuppam','607105',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38733,113,'Nellikuppam Bazaar','607105',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38734,113,'Neyvasal','608303',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38735,113,'Neyveli 1','607801',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38736,113,'Neyveli 2','607802',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38737,113,'Neyveli 3','607803',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38738,113,'Neyveli Ii Thermal Station','607807',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38739,113,'Neyveli Second Mines','607802',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38740,113,'Neyveli Thermal Bus Stand','607807',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54');
INSERT INTO `cities` VALUES (38741,113,'Odakkanallur','608201',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38742,113,'Omampuliyur','608306',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38743,113,'Oraiyur','607108',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38744,113,'Orathur','608201',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38745,113,'Pachayankuppam','607003',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38746,113,'Padirikuppam','607401',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38747,113,'Pagandai','607112',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38748,113,'Palayamkottai Melpathy','608701',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38749,113,'Palayamkottai(CDL)','608701',1,0,'2022-03-03 12:38:54','2022-03-03 12:38:54'),(38750,113,'Pallavarayanatham','607102',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38751,113,'Palur','607102',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38752,113,'Panikuppam','607106',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38753,113,'Pannapattu','608201',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38754,113,'Panruti East','607106',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38755,113,'Panruti','607106',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38756,113,'Panruti West','607106',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38757,113,'Paradur','608201',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38758,113,'Parangipettai','608502',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38759,113,'Perampattu','608002',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38760,113,'Periyakappankulam','607802',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38761,113,'Periyakomatti','608501',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38762,113,'Periyakuppam','608801',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38763,113,'Periyanellikkollai','608704',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38764,113,'Perperiyankuppam','607805',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38765,113,'Perumalnaickenpalayam','607104',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38766,113,'Perungalur','608305',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38767,113,'Perur','608701',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38768,113,'Pethanaickenkuppam','607302',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38769,113,'Pichavaram','608002',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38770,113,'Pillaiyarthangal','608303',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38771,113,'Pinnalur','608704',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38772,113,'Pinnathur','608102',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38773,113,'Ponnanthittu','608102',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38774,113,'Poochimedu','608801',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38775,113,'Poondi','608703',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38776,113,'Poondiyankuppam','607005',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38777,113,'Poovanikkuppam','608801',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38778,113,'Pudaiyur','608701',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38779,113,'Puduchatram','608501',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38780,113,'Pulamedu','608302',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38781,113,'Pulavanur','607205',1,0,'2022-03-03 12:38:55','2022-03-03 12:38:55'),(38782,113,'Puliyur','607301',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38783,113,'Puthupet (CDL)','607108',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38784,113,'Puvalai','608601',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38785,113,'Pythambadi','607101',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38786,113,'Rajendra Cholagam','608301',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38787,113,'Rajendra Pattinam','608703',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38788,113,'Ramapuram','608701',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38789,113,'Ramapuram','607003',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38790,113,'Reddiyur','608304',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38791,113,'Sakkangudi','608201',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38792,113,'Salianthoppu','608401',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38793,113,'Samattikuppam','607301',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38794,113,'Samiyarpettai','608502',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38795,113,'Sangolikuppam','607005',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38796,113,'Sathankuppam','607004',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38797,113,'Sathapadi','608601',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38798,113,'Sathipattu','607106',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38799,113,'Sedapalayam','607003',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38800,113,'Sellankuppam','607003',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38801,113,'Semmandalam','607001',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38802,113,'Semmedu','607106',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38803,113,'Semokottai','607106',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38804,113,'Seplanatham','607802',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38805,113,'Serakuppam','607303',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38806,113,'Sethiathope','608702',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38807,113,'Shandan','608304',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38808,113,'Sholathiram','608701',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38809,113,'Sholavalli','607105',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38810,113,'Silambimangalam','608801',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38811,113,'Silambinathanpettai','607102',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38812,113,'Sipcot Cuddalore','607005',1,0,'2022-03-03 12:38:56','2022-03-03 12:38:56'),(38813,113,'Sirugramam','607101',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38814,113,'Sirukattur','608304',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38815,113,'Siruthondamadevi','607103',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38816,113,'Siruvathur','607106',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38817,113,'Sithamalli','608301',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38818,113,'Sivapuri','608002',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38819,113,'Sorathur','607805',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38820,113,'Sornavur Melpathi','607104',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38821,113,'Sri Adivaraganallur','608703',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38822,113,'Sri Pudur','608703',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38823,113,'Sri Vakkaramari','608703',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38824,113,'Srimushnam','608703',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38825,113,'Srinedunjeri','608703',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38826,113,'Suba Uppalavadi','607006',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38827,113,'Subramaniyapuram','607301',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38828,113,'Sundaravandi','607401',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38829,113,'Suravilandur','608302',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38830,113,'T.Nedunjeri','608305',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38831,113,'T.Palayam','607301',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38832,113,'Temmur','608302',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38833,113,'Terkuviruthangam','608305',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38834,113,'Thatchakadu','608501',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38835,113,'Thattampalayam','607205',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38836,113,'Theerthanagiri','608801',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38837,113,'Theethampalayam','608501',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38838,113,'Thillaividangan','608102',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38839,113,'Thiyagavalli','608801',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38840,113,'Thondamanatham','607301',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38841,113,'Tirukandeeswaram','607105',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38842,113,'Tirumanikuzhi','607401',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38843,113,'Tirunaraiyur','608303',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38844,113,'Tirupadiripuliyur','607002',1,0,'2022-03-03 12:38:57','2022-03-03 12:38:57'),(38845,113,'Tiruppadiripuliyur Bazaar','607002',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38846,113,'Tiruppadiripuliyur West','607002',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38847,113,'Tiruthuraiyur','607205',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38848,113,'Tiruvamur','607106',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38849,113,'Tiruvendhipuram','607401',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38850,113,'Udayargudi','608301',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38851,113,'Uthamacholamangalam','608002',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38852,113,'Vadakkumangudi','608401',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38853,113,'Vadakkupalayam','608701',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38854,113,'Vadakkuvelur','607802',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38855,113,'Vadakuthu','607303',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38856,113,'Vadalur','607303',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38857,113,'Vadathalaikulam','608704',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38858,113,'Vaiyur','608401',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38859,113,'Vakkur','608201',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38860,113,'Valakollai','608702',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38861,113,'Valasakkadu','608701',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38862,113,'Valayamadevi','608704',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38863,113,'Valisodanaipalayam','607003',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38864,113,'Vallam','607805',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38865,113,'Vallampadugai','608401',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38866,113,'Valudalampattu','607301',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38867,113,'Vanamadevi','608701',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38868,113,'Vanamadevi','607105',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38869,113,'Vanathirayapuram','607303',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38870,113,'Vandipalayam','607004',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38871,113,'Vannaiyur','608302',1,0,'2022-03-03 12:38:58','2022-03-03 12:38:58'),(38872,113,'Vanpakkam','607105',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38873,113,'Varakalpattu','607109',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38874,113,'Varinjipakkam','607205',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38875,113,'Vasanankuppam','607301',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38876,113,'Vasantharayanpalayam','607003',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38877,113,'Vattathur','608702',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38878,113,'Vayalur','608602',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38879,113,'Veeramudayanatham','608702',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38880,113,'Veeranandapuram','608301',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38881,113,'Veerraperumanallur','607101',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38882,113,'Vehakollai','607302',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38883,113,'Vellakarai','607003',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38884,113,'Vellapakkam','607109',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38885,113,'Venkatampettai','607302',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38886,113,'Vilagam','608305',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38887,113,'Villiyanallur','608501',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38888,113,'Virupakshi','607302',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38889,113,'Visoor','607805',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38890,113,'Adari','606304',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38891,113,'Akkanur','606106',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38892,113,'Alambadi','606108',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38893,113,'Alathur','606303',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38894,113,'Avatti','606108',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38895,113,'Avinangudi','606111',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38896,113,'Budamur','606003',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38897,113,'C  Keeranur','606110',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38898,113,'Chinnaparur','606104',1,0,'2022-03-03 12:38:59','2022-03-03 12:38:59'),(38899,113,'Deevalur','606110',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38900,113,'Dharmanallur','606103',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38901,113,'E.Keeranur','606106',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38902,113,'Edaiyur','606302',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38903,113,'Eluthur','606303',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38904,113,'Erumanur','606003',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38905,113,'Gopalapuram','606103',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38906,113,'Gudalur','606111',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38907,113,'Idaichittur','606104',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38908,113,'Kaludur','606304',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38909,113,'Kammapuram','606103',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38910,113,'Kargudal','606003',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38911,113,'Karmangudi','606110',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38912,113,'Karnatham','606104',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38913,113,'Karuvepilankurichi','606110',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38914,113,'Kathazhai','606103',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38915,113,'Kattumailur','606304',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38916,113,'Kilacheruvoi','606106',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38917,113,'Kilakalpoondi','606303',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38918,113,'Kilapalaiyur','606103',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38919,113,'Kilimangalam','606105',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38920,113,'Ko  Adhanur','606003',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38921,113,'Ko Pavalangudi','606104',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38922,113,'Konankuppam','606104',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38923,113,'Konur','606105',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38924,113,'Korakkavadi','606303',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38925,113,'Kosapallam','606105',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38926,113,'Kothattai','606111',1,0,'2022-03-03 12:39:00','2022-03-03 12:39:00'),(38927,113,'Kotteri','607804',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38928,113,'Kuppanatham','606003',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38929,113,'Lakkur','606303',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38930,113,'Ma Podaiyur','606108',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38931,113,'Malayanur','606108',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38932,113,'Manavalanallur','606003',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38933,113,'Mangalur','606108',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38934,113,'Mathur','606104',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38935,113,'Melur','606111',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38936,113,'Mudanai','607804',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38937,113,'Murugangudi','606105',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38938,113,'N. Naraiyur','606304',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38939,113,'Nagar','606302',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38940,113,'Nallur (Cuddalore)','606302',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38941,113,'Nithinatham','606304',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38942,113,'Oomangalam','607804',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38943,113,'Orangur','606108',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38944,113,'Ottimedu','606103',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38945,113,'Palayapattinam','606104',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38946,113,'Pali','606104',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38947,113,'Paravalur','606003',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38948,113,'Pasar','606304',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38949,113,'Pelandurai','606105',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38950,113,'Pennadam R.S.','606111',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38951,113,'Pennadam','606105',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38952,113,'Perambalur','606302',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38953,113,'Periyakottumulai','606103',1,0,'2022-03-03 12:39:01','2022-03-03 12:39:01'),(38954,113,'Periyanesalur','606304',1,0,'2022-03-03 12:39:02','2022-03-03 12:39:02'),(38955,113,'Perumulai','606106',1,0,'2022-03-03 12:39:02','2022-03-03 12:39:02'),(38956,113,'Pillur','606304',1,0,'2022-03-03 12:39:02','2022-03-03 12:39:02'),(38957,113,'Poolambadi','606304',1,0,'2022-03-03 12:39:02','2022-03-03 12:39:02'),(38958,113,'Pothiramangalam','606111',1,0,'2022-03-03 12:39:02','2022-03-03 12:39:02'),(38959,113,'Poynapadi','606304',1,0,'2022-03-03 12:39:02','2022-03-03 12:39:02'),(38960,113,'Puvanur','606104',1,0,'2022-03-03 12:39:02','2022-03-03 12:39:02'),(38961,113,'Rettakurichi','606304',1,0,'2022-03-03 12:39:02','2022-03-03 12:39:02'),(38962,113,'Sathamangalam','606003',1,0,'2022-03-03 12:39:02','2022-03-03 12:39:02'),(38963,113,'Sathanatham','606111',1,0,'2022-03-03 12:39:02','2022-03-03 12:39:02'),(38964,113,'Sathapadi','606103',1,0,'2022-03-03 12:39:02','2022-03-03 12:39:02'),(38965,113,'Sathiyam','606302',1,0,'2022-03-03 12:39:02','2022-03-03 12:39:02'),(38966,113,'Sathiyavadi','606110',1,0,'2022-03-03 12:39:02','2022-03-03 12:39:02'),(38967,113,'Sathukudal','606110',1,0,'2022-03-03 12:39:02','2022-03-03 12:39:02'),(38968,113,'Seppakkam','606302',1,0,'2022-03-03 12:39:02','2022-03-03 12:39:02'),(38969,113,'Sevveri','606106',1,0,'2022-03-03 12:39:02','2022-03-03 12:39:02'),(38970,113,'Sirumangalam','606302',1,0,'2022-03-03 12:39:02','2022-03-03 12:39:02'),(38971,113,'Sirumulai','606106',1,0,'2022-03-03 12:39:02','2022-03-03 12:39:02'),(38972,113,'Sirupakkam','606108',1,0,'2022-03-03 12:39:02','2022-03-03 12:39:02'),(38973,113,'T   Gopurapuram','606003',1,0,'2022-03-03 12:39:02','2022-03-03 12:39:02'),(38974,113,'Thachur','606303',1,0,'2022-03-03 12:39:02','2022-03-03 12:39:02'),(38975,113,'Therku Vadakku Puthur','606110',1,0,'2022-03-03 12:39:02','2022-03-03 12:39:02'),(38976,113,'Tholar','606111',1,0,'2022-03-03 12:39:02','2022-03-03 12:39:02'),(38977,113,'Thoravalur','606003',1,0,'2022-03-03 12:39:02','2022-03-03 12:39:02'),(38978,113,'Tiruvattathurai','606111',1,0,'2022-03-03 12:39:02','2022-03-03 12:39:02'),(38979,113,'Tittagudi','606106',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(38980,113,'Toludur','606303',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(38981,113,'U  Agaram','607804',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(38982,113,'Uttangal','607804',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(38983,113,'Vagaiyur','606106',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(38984,113,'Vaithiyanathapuram','606303',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(38985,113,'Vallimaduram','606108',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(38986,113,'Varambanur','606302',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(38987,113,'Venganur','606303',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(38988,113,'Veppur (SA)','606304',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(38989,113,'Vijayamanagaram','606104',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(38990,113,'Vilangattur','606302',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(38991,113,'Vriddhachalam Bazaar','606001',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(38992,113,'Vriddhachalam Cutchery','606001',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(38993,113,'Vriddhachalam H.O','606001',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(38994,114,'A.Gollahalli','636704',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(38995,114,'A.Jettihalli','636807',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(38996,114,'A.Pallipatti','636905',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(38997,114,'A.Sappanipatti','635205',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(38998,114,'Achalvadi','636903',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(38999,114,'Adagapadi','636803',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(39000,114,'Adikarapatti','636905',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(39001,114,'Adiyamankottai','636807',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(39002,114,'Agraharam','636903',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(39003,114,'Ajjanahalli','636810',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(39004,114,'Akkamanahalli','636704',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(39005,114,'Alamelupuram','636905',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(39006,114,'Alapuram','636904',1,0,'2022-03-03 12:39:03','2022-03-03 12:39:03'),(39007,114,'Ammanimallapuram','636806',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39008,114,'Andiyur','636906',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39009,114,'Anjehalli','636813',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39010,114,'Annasagaram','636704',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39011,114,'Arakasanahalli','636811',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39012,114,'Arasampatti','635201',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39013,114,'Attornahalli','636805',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39014,114,'B Pallipatti','635301',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39015,114,'Badrahalli','636810',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39016,114,'Bairnaickenpatti','636906',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39017,114,'Bairnatham','636905',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39018,114,'Baisuhalli','635205',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39019,114,'Balajangamanahalli','636807',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39020,114,'Barur','635201',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39021,114,'Batchapet','636903',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39022,114,'Bedrahalli','636803',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39023,114,'Begarahalli','636808',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39024,114,'Belarahalli','636808',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39025,114,'Bendrahalli','635201',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39026,114,'Bettamugulalam','636806',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39027,114,'Bikkampatti','636813',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39028,114,'Biliyanur Agraharam','636813',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39029,114,'Bommanur','636805',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39030,114,'Bommidi','635301',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39031,114,'Boodanahalli','636804',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39032,114,'Buddireddipatti','635302',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39033,114,'Chellampatti','636903',1,0,'2022-03-03 12:39:04','2022-03-03 12:39:04'),(39034,114,'Chetthalli','636809',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39035,114,'Chikkadornabetta','636806',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39036,114,'Chinnampalli','636811',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39037,114,'Chinnankuppam','636903',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39038,114,'Chintalpadi','635302',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39039,114,'D Thurinjipatti','635202',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39040,114,'Dalavaihalli','636803',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39041,114,'Dandukaranahalli','636808',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39042,114,'Dasarahalli','635305',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39043,114,'Dharmapuri Collectorate','636705',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39044,114,'Dharmapuri Fort','636701',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39045,114,'Dharmapuri H.O','636701',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39046,114,'Dharmapuri Public Offices','636001',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39047,114,'Dharmapuri R.S','636701',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39048,114,'Dharmapuri South','636701',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39049,114,'Dinnabelur','636810',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39050,114,'Doddampatti','636903',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39051,114,'Dokkubothanahalli','636807',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39052,114,'Donnakuttahalli','636810',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39053,114,'Eachambadi','636902',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39054,114,'Elagiri','636807',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39055,114,'Elavadai','635305',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39056,114,'Ellapudayampatti','636903',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39057,114,'Erranahalli','636808',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39058,114,'Errapayanahalli','636813',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39059,114,'Erupalli','636813',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39060,114,'Esalpatti','636807',1,0,'2022-03-03 12:39:05','2022-03-03 12:39:05'),(39061,114,'Gendenahalli','636811',1,0,'2022-03-03 12:39:06','2022-03-03 12:39:06'),(39062,114,'Gendiganahalli','635205',1,0,'2022-03-03 12:39:06','2022-03-03 12:39:06'),(39063,114,'Giddanahalli','636809',1,0,'2022-03-03 12:39:06','2022-03-03 12:39:06'),(39064,114,'Gobichettipalayam','635305',1,0,'2022-03-03 12:39:06','2022-03-03 12:39:06'),(39065,114,'Gobinathampatti','635305',1,0,'2022-03-03 12:39:06','2022-03-03 12:39:06'),(39066,114,'Gudalur','636906',1,0,'2022-03-03 12:39:06','2022-03-03 12:39:06'),(39067,114,'Gujjarahalli','636806',1,0,'2022-03-03 12:39:06','2022-03-03 12:39:06'),(39068,114,'Hale Dharmapuri','636701',1,0,'2022-03-03 12:39:06','2022-03-03 12:39:06'),(39069,114,'Hanumanthapuram','636808',1,0,'2022-03-03 12:39:06','2022-03-03 12:39:06'),(39070,114,'Hanumantheertham','636902',1,0,'2022-03-03 12:39:06','2022-03-03 12:39:06'),(39071,114,'Harur','636903',1,0,'2022-03-03 12:39:06','2022-03-03 12:39:06'),(39072,114,'Hogenakkal','636810',1,0,'2022-03-03 12:39:06','2022-03-03 12:39:06'),(39073,114,'Ichambadi','635202',1,0,'2022-03-03 12:39:06','2022-03-03 12:39:06'),(39074,114,'Ichampatti','636807',1,0,'2022-03-03 12:39:06','2022-03-03 12:39:06'),(39075,114,'Indur','636803',1,0,'2022-03-03 12:39:06','2022-03-03 12:39:06'),(39076,114,'Irumathur','635201',1,0,'2022-03-03 12:39:06','2022-03-03 12:39:06'),(39077,114,'Ittiampatti','636903',1,0,'2022-03-03 12:39:06','2022-03-03 12:39:06'),(39078,114,'Jakkasamudram','636805',1,0,'2022-03-03 12:39:06','2022-03-03 12:39:06'),(39079,114,'Jakkupatti','635202',1,0,'2022-03-03 12:39:06','2022-03-03 12:39:06'),(39080,114,'Jammanahalli','636904',1,0,'2022-03-03 12:39:06','2022-03-03 12:39:06'),(39081,114,'Jertalav','636808',1,0,'2022-03-03 12:39:06','2022-03-03 12:39:06'),(39082,114,'Jingalkathirampatti','635201',1,0,'2022-03-03 12:39:06','2022-03-03 12:39:06'),(39083,114,'Jittandahalli','636805',1,0,'2022-03-03 12:39:06','2022-03-03 12:39:06'),(39084,114,'K.Vetrapatti','636902',1,0,'2022-03-03 12:39:06','2022-03-03 12:39:06'),(39085,114,'Kadagathur','636809',1,0,'2022-03-03 12:39:06','2022-03-03 12:39:06'),(39086,114,'Kadathur','635303',1,0,'2022-03-03 12:39:06','2022-03-03 12:39:06'),(39087,114,'Kalappambadi','636811',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39088,114,'Kalasapadi','636903',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39089,114,'Kalipettai','636905',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39090,114,'Kambainallore','635202',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39091,114,'Kammampatti','636352',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39092,114,'Kandagavundanur','635302',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39093,114,'Kandenahalli','636806',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39094,114,'Kannipatti','635205',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39095,114,'Karungalpadi','636906',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39096,114,'Kathanahalli','636808',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39097,114,'Kathirinaickenahalli','635303',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39098,114,'Kathiripatti','636906',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39099,114,'Kattampatti','636808',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39100,114,'Katteri','636902',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39101,114,'Keelkuppam','636902',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39102,114,'Keeraipatti','636903',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39103,114,'Kelavalli','635202',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39104,114,'Keraikodahalli','635305',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39105,114,'Kethureddipatti','635302',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39106,114,'Kokkarapatti','636905',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39107,114,'Kolagampatti','636903',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39108,114,'Komarasamipatti','636701',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39109,114,'Kombur','636905',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39110,114,'Konangihalli','636813',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39111,114,'Kongarapatti','635202',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39112,114,'Kongavembu','636902',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39113,114,'Koothapadi','636810',1,0,'2022-03-03 12:39:07','2022-03-03 12:39:07'),(39114,114,'Kottapatti','636906',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39115,114,'Kottumaranahalli','635205',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39116,114,'Kovilur','635205',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39117,114,'Krishnapuram','635202',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39118,114,'Kuppangarai','635205',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39119,114,'Kuppur','636704',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39120,114,'Kurubarahalli','635302',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39121,114,'Lakshmapuram','636905',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39122,114,'Laligam','636804',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39123,114,'M Velampatti','635305',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39124,114,'M.Maravadi','636805',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39125,114,'Mademangalam','636804',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39126,114,'Mahendramangalam','636805',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39127,114,'Makkanur','636803',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39128,114,'Mallikuttai','635205',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39129,114,'Mallupatti','636805',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39130,114,'Mampatti','636902',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39131,114,'Manchinayakkanahalli','636813',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39132,114,'Mangarai','636813',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39133,114,'Maniyadahalli','636807',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39134,114,'Maniyambadi','635303',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39135,114,'Manjarahalli','636810',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39136,114,'Marandahalli','636806',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39137,114,'Maravadi','635205',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39138,114,'Maruthipatti','635305',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39139,114,'Mathikonpalayam','636701',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39140,114,'Matlamapatti','635205',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39141,114,'Menisi','636904',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39142,114,'Mittadinnahalli','636804',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39143,114,'Mittanoolahalli','636704',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39144,114,'Mobiripatti','636902',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39145,114,'Modur','635205',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39146,114,'Molayanur','636904',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39147,114,'Moolakadu','636352',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39148,114,'Morappur','635305',1,0,'2022-03-03 12:39:08','2022-03-03 12:39:08'),(39149,114,'Mottankurichi','635302',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39150,114,'Mukkanahalli','635202',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39151,114,'Mullikadu','636905',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39152,114,'Murukkampatti','635202',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39153,114,'Nagamarai','636810',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39154,114,'Nagarkudal','636803',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39155,114,'Nallampalli','636807',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39156,114,'Nallasenahalli','636804',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39157,114,'Nammanadahalli','636812',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39158,114,'Naripalli','636906',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39159,114,'Narthampatti','636804',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39160,114,'Navalai','635305',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39161,114,'Nettadahalli','636803',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39162,114,'Nochikuttai','636903',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39163,114,'Noolahalli','636813',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39164,114,'Obilinaickenahalli','635303',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39165,114,'Odasahalli','635303',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39166,114,'Onnappagoundanahalli','636809',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39167,114,'P.Agraharam','636809',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39168,114,'P.Chettihalli','636808',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39169,114,'Padi','636809',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39170,114,'Pagalahalli','636807',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39171,114,'Palacode','636808',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39172,114,'Palavadi','636809',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39173,114,'Palayam','636807',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39174,114,'Panjapalli','636812',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39175,114,'Pappambadi','636905',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39176,114,'Pappinaickenpatti','636808',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39177,114,'Pappireddipatti','636905',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39178,114,'Parayapatti','635305',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39179,114,'Parayapattipudur','636903',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39180,114,'Pattukonampatti','636905',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39181,114,'Paupparapatti','636809',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39182,114,'Pennagaram','636810',1,0,'2022-03-03 12:39:09','2022-03-03 12:39:09'),(39183,114,'Pereripudur','636903',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39184,114,'Periyanahalli','635205',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39185,114,'Periyapatti','636906',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39186,114,'Perumbalai','636811',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39187,114,'Petatampatti','636903',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39188,114,'Pikkili','636809',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39189,114,'Pilparuthi','635301',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39190,114,'Poduthampatti','636808',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39191,114,'Polayampalli','635305',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39192,114,'Poyyapatti','636906',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39193,114,'Pudupatti','636905',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39194,114,'Pulidikarai','635202',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39195,114,'Pulikarai','636808',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39196,114,'Pungunatham','636803',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39197,114,'Rajagollahalli','636813',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39198,114,'Ramagondahalli','636810',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39199,114,'Ramenahalli','635302',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39200,114,'Ranimookanur','635303',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39201,114,'Regadahalli','635301',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39202,114,'Samanur','636806',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39203,114,'Samichettipatti','636807',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39204,114,'Sandapatti','635305',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39205,114,'Sathiyanathapuram','636813',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39206,114,'Seeriyanahalli','636808',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39207,114,'Selliampatti','636809',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39208,114,'Senganur','636810',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39209,114,'Settikarai','636704',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39210,114,'Sikkalur','636906',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39211,114,'Sillarahalli','635303',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39212,114,'Sitrapatti','635305',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39213,114,'Sitteri','636903',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39214,114,'Sittilingi','636906',1,0,'2022-03-03 12:39:10','2022-03-03 12:39:10'),(39215,114,'Sogathur','636809',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39216,114,'Solaikottai','636704',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39217,114,'Somenahalli','636803',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39218,114,'Sunchalnatham','636810',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39219,114,'Sunnampatti','636808',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39220,114,'T.Ganigarahalli','636352',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39221,114,'Tenkaraikottai','636904',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39222,114,'Thalanatham','635302',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39223,114,'Thathampatti','635201',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39224,114,'Thippampatti','635202',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39225,114,'Thippireddihalli','635301',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39226,114,'Thirumalvadi','636808',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39227,114,'Thokkampatti','636705',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39228,114,'Thoppur','636352',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39229,114,'Thumbalammaepettai','636906',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39230,114,'Thumjepalli','636812',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39231,114,'Thurinjipatti','635301',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39232,114,'Tirtamalai','636906',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39233,114,'Ungaranahalli','636704',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39234,114,'Vagurappampatti','635202',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39235,114,'Vaguthupatti','635302',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39236,114,'Vathalmalai','636804',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39237,114,'Vattuvanahalli','636810',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39238,114,'Vedakattumaduvu','636906',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39239,114,'Vedarampatti','635202',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39240,114,'Veerappanaickenpatti','636906',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39241,114,'Velanur','636906',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39242,114,'Vellalapatti','635202',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39243,114,'Venkatadrihalli','635303',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39244,114,'Venkatasamudram','636905',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39245,114,'Venkatenahalli','636704',1,0,'2022-03-03 12:39:11','2022-03-03 12:39:11'),(39246,114,'Vennampatti','636705',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39247,114,'Veppalahalli','636805',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39248,114,'Veppampatti','636903',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39249,114,'Veppilaimuthampatti','635301',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39250,114,'Yelangalpatti','636808',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39251,114,'Bommahalli','635111',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39252,114,'Devarmukkulam','635111',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39253,114,'Karagur','635111',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39254,115,'Saminathapuram','642113',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39255,115,'19 Pudur','624614',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39256,115,'A.Nadupatti','624302',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39257,115,'Achanampatti','624702',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39258,115,'Adalur','624212',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39259,115,'Adiyanuthu','624003',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39260,115,'Adukkam','624101',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39261,115,'Agaram','624709',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39262,115,'Alagapuri','624710',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39263,115,'Alamarathupatti','624303',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39264,115,'Alambadi','624620',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39265,115,'Alambadimines','624703',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39266,115,'Amarapundi','624613',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39267,115,'Ambathurai','624302',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39268,115,'Ambathurai R.S','624302',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39269,115,'Ambilikai','624612',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39270,115,'Ammapatti','624206',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39271,115,'Ammapatti','624622',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39272,115,'Ammayanaickanur','624201',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39273,115,'Anaipatti','624219',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39274,115,'Anaipatti','624620',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39275,115,'Andipatti','624621',1,0,'2022-03-03 12:39:12','2022-03-03 12:39:12'),(39276,115,'Angunagar','624001',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39277,115,'Anjukulipatti','624308',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39278,115,'Appanuthu','624617',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39279,115,'Aranmanaivalasu','624616',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39280,115,'Arasappapillaipatti','624619',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39281,115,'Athikombai','624619',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39282,115,'Attur','624701',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39283,115,'Attuvampatti','624101',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39284,115,'Avichipatti','624401',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39285,115,'Avilipatti','624304',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39286,115,'Ayakudi','624613',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39287,115,'Ayyalur','624801',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39288,115,'Ayyankottai','624211',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39289,115,'Balakrishnapurampudur','624005',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39290,115,'Balasamudram (Dindigul)','624610',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39291,115,'Batlagundu Bazar','624202',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39292,115,'Batlagundu','624202',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39293,115,'Begampur (Dindigul)','624002',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39294,115,'Bodikamanvadi','624708',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39295,115,'Boduvarpatti','624614',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39296,115,'Bojanampatti','624802',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39297,115,'Boothagudi','624402',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39298,115,'Chatirapatti','624620',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39299,115,'Chatrapatti (Dindigul)','624614',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39300,115,'Chettiapatti','624302',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39301,115,'Chinnakalayamputhur','624615',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39302,115,'Chinnakkampatti','624712',1,0,'2022-03-03 12:39:13','2022-03-03 12:39:13'),(39303,115,'Chinnalapatti','624301',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39304,115,'Chinnamandavadi','624612',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39305,115,'Chittoor','624702',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39306,115,'D.Gudalur','624620',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39307,115,'Dasaripatti','624614',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39308,115,'Devarappanpatti','624204',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39309,115,'Devathur','624614',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39310,115,'Devinaickenpatti','624711',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39311,115,'Dharmathupatti','624705',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39312,115,'Dindigul Bus Stand','624003',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39313,115,'Dindigul Collectorate','624004',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39314,115,'Dindigul East','624003',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39315,115,'Dindigul Fort','624001',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39316,115,'Dindigul H.O','624001',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39317,115,'Emakkalapuram','624304',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39318,115,'Eriyodu','624702',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39319,115,'Erramanaickenpatti','624613',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39320,115,'Ethilodu','624219',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39321,115,'G.Thummalapatti','624202',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39322,115,'Gandhigram (Dindigul)','624302',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39323,115,'Gurunathanaickanur','624622',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39324,115,'Guziliamparai','624703',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39325,115,'H.R.Kottai','624002',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39326,115,'I.Vadipatti','624616',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39327,115,'Idayakottai','624704',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39328,115,'Iyyampalayam','624204',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39329,115,'Jambudarikottai','624206',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39330,115,'Jambuliapatti','624005',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39331,115,'Javadhupatti','624704',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39332,115,'Jenankottai','624710',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39333,115,'Jogipatti','624704',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39334,115,'Jothampatti','624308',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39335,115,'K.Ayyapatti','624308',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39336,115,'K.C.Patti','624212',1,0,'2022-03-03 12:39:14','2022-03-03 12:39:14'),(39337,115,'K.Keeranur','624616',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39338,115,'K.Pudukottai','624622',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39339,115,'K.Rajathanikottai','624206',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39340,115,'K.Singarakottai','624708',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39341,115,'Kalanampatti','624710',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39342,115,'Kalanjipatti','624619',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39343,115,'Kalayamputhur','624615',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39344,115,'Kalikkampatti','624303',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39345,115,'Kalladipatti','624201',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39346,115,'Kallimandayam','624616',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39347,115,'Kallipatti','624709',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39348,115,'Kalvarpatti','624711',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39349,115,'Kamanur','624216',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39350,115,'Kamatchipuram','624622',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39351,115,'Kambiliampatti','624306',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39352,115,'Kanakkanpatti','624613',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39353,115,'Kanalkadu','624216',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39354,115,'Kanapadi','624802',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39355,115,'Kanavoipatti','624308',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39356,115,'Kanavoipatti','624202',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39357,115,'Kanniapuram','624308',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39358,115,'Kannivadi','624705',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39359,115,'Kappalapatti','624614',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39360,115,'Kappiliapatti','624612',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39361,115,'Kariampatti','624215',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39362,115,'Kariampatti','624616',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39363,115,'Karikali','624703',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39364,115,'Karikaranpudur','624615',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39365,115,'Kasampatti','624401',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39366,115,'Kasavanampatti','624705',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39367,115,'Kasipalayam (Dindigul)','624711',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39368,115,'Kattakamanpatti','624202',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39369,115,'Kattakoothanpatti','624215',1,0,'2022-03-03 12:39:15','2022-03-03 12:39:15'),(39370,115,'Kattupatti','624306',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39371,115,'Kavalapatti','624621',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39372,115,'Kaveriammapatti','624619',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39373,115,'Kaviakadu','624212',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39374,115,'Kavunji','624103',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39375,115,'Kazhutharukkipalayam','624616',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39376,115,'Keeranur(MA)','624617',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39377,115,'Kethaiyarumbu','624619',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39378,115,'Kilanavayal','624103',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39379,115,'Kilavarai','624103',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39380,115,'Kodagipatti','624403',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39381,115,'Kodaikanal Observatory','624103',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39382,115,'Kodaikanal','624101',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39383,115,'Kodaimangalam','624618',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39384,115,'Kodairoad R.S.','624206',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39385,115,'Kodalangadu','624216',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39386,115,'Kodanginaickenpatti','624215',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39387,115,'Kodangipatti','624710',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39388,115,'Kolinjipatti','624304',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39389,115,'Kollapatti','624801',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39390,115,'Kollapatti','624619',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39391,115,'Komberipatti','624801',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39392,115,'Konapatti','624304',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39393,115,'Konur','624705',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39394,115,'Kookal','624103',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39395,115,'Koovakkapatti','624710',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39396,115,'Koovanuthu','624003',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39397,115,'Kosavapatti','624304',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39398,115,'Kosikurichi','624401',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39399,115,'Kothayam','624614',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39400,115,'Kottaipatti','624403',1,0,'2022-03-03 12:39:16','2022-03-03 12:39:16'),(39401,115,'Kottaiyur','624402',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39402,115,'Kottanatham','624620',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39403,115,'Kottapatti','624002',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39404,115,'Kottathurai','624617',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39405,115,'Kottur','624215',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39406,115,'Kovilammapatti','624618',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39407,115,'Kovilur','624005',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39408,115,'Kovilur','624706',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39409,115,'Kulathupatti','624706',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39410,115,'Kulathur','624005',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39411,115,'Kullalagundu','624201',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39412,115,'Kullichettipatti','624219',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39413,115,'Kumbaraiyur','624202',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39414,115,'Kumbur','624103',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39415,115,'Kumbur','624710',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39416,115,'Kumburvayal','624101',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39417,115,'Kunnuvarankottai','624220',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39418,115,'Kuppammalpatti','624212',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39419,115,'Kusavapatti','624802',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39420,115,'Kuthiluppai','624712',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39421,115,'Kuttam','624711',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39422,115,'Kuttampundi','624616',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39423,115,'Kuttathupatti','624002',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39424,115,'Kuttupatti','624401',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39425,115,'Kuzhipatti','624202',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39426,115,'Landakottai','624620',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39427,115,'Lingavadi','624401',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39428,115,'M.N.Patti','624002',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39429,115,'M.Vadipatti','624211',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39430,115,'Ma.Athappanpatti','624712',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39431,115,'Machur','624101',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39432,115,'Madur','624306',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39433,115,'Malayagondanpatti','624201',1,0,'2022-03-03 12:39:17','2022-03-03 12:39:17'),(39434,115,'Mallanampatti','624202',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39435,115,'Mallapuram','624703',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39436,115,'Mallayapuram','624707',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39437,115,'Malvarpatti','624709',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39438,115,'Manakkattur','624403',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39439,115,'Mandavadi','624612',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39440,115,'Mangarai','624622',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39441,115,'Manjalpirappu','624212',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39442,115,'Manjanaickenpatti','624614',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39443,115,'Mannavanur','624103',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39444,115,'Manur','624618',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39445,115,'Marambadi','624709',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39446,115,'Marichilambu','624613',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39447,115,'Markampatti','624306',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39448,115,'Markkampatti','624712',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39449,115,'Marunoothu','624304',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39450,115,'Maruthanathi-project','624204',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39451,115,'Melkaraipatti','624617',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39452,115,'Melpallam','624101',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39453,115,'Mettupatti','624616',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39454,115,'Mettupatti','624002',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39455,115,'Metturgate','624206',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39456,115,'Micheal Palayam','624215',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39457,115,'Minukampatti','624711',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39458,115,'Moolaiyar','624210',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39459,115,'Moongilpatti','624402',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39460,115,'Morepatti','624802',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39461,115,'Mottanampatti','624802',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39462,115,'Mulaiyur','624401',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39463,115,'Mullipadi','624005',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39464,115,'Munnilakottai','624303',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39465,115,'Murunellikottai','624710',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39466,115,'Musuvanuthu','624219',1,0,'2022-03-03 12:39:18','2022-03-03 12:39:18'),(39467,115,'Muthalagupatti','624002',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39468,115,'Muthanampattipudur','624622',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39469,115,'Muthunaickenpatti','624618',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39470,115,'N.G.O.Colony','624005',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39471,115,'N.Panjampatti','624303',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39472,115,'N.Paraipatti','624005',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39473,115,'N.Pudupatti','624401',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39474,115,'Nadakottai','624220',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39475,115,'Nadumandalam','624401',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39476,115,'Nadupatti','624212',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39477,115,'Naduvanur','624401',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39478,115,'Nagalnagar','624003',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39479,115,'Nagayakottai','624706',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39480,115,'Naidupuram','624101',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39481,115,'Nallamanaickenpatti','624003',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39482,115,'Nallamanarkottai','624005',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39483,115,'Nallurkadu','624212',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39484,115,'Nalupulikottai','624619',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39485,115,'Narasingapuram','624307',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39486,115,'Narikalpatti','624618',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39487,115,'Nariyuthu','624215',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39488,115,'Natham East','624401',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39489,115,'Natham Koilpatti','624401',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39490,115,'Natham','624401',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39491,115,'Nathambazar','624401',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39492,115,'Nathapatti','624710',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39493,115,'Neelamalaikottai','624619',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39494,115,'Neikkarapatti','624615',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39495,115,'Nellur','624204',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39496,115,'Nilakottai H.O','624208',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39497,115,'Nuthalapuram','624202',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39498,115,'Odaipatti','624612',1,0,'2022-03-03 12:39:19','2022-03-03 12:39:19'),(39499,115,'Oddanchatram North','624619',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39500,115,'Oddanchatram','624619',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39501,115,'Old Batlagundu','624202',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39502,115,'Old Oddanchatram','624619',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39503,115,'Oruthattu','624206',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39504,115,'Ottupatti','624708',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39505,115,'Pachalur','624212',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39506,115,'Pachamalayankottai','624707',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39507,115,'Padiyur','624005',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39508,115,'Paganattam','624702',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39509,115,'Palakkanuthu','624619',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39510,115,'Palamalai','624101',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39511,115,'Palani Bazaar','624601',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39512,115,'Palani Devastanam','624601',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39513,115,'Palani East','624601',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39514,115,'Palani H.O','624601',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39515,115,'Palani R.S','624601',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39516,115,'Palani West','624601',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39517,115,'Palappanpatti','624616',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39518,115,'Palarparundalar Dam','624610',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39519,115,'Palayakannivadi','624705',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39520,115,'Palayam','624620',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39521,115,'Palayankottai','624708',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39522,115,'Pallangi','624101',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39523,115,'Pallapatti','624002',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39524,115,'Pallapatti','624201',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39525,115,'Pallathukalvai','624212',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39526,115,'Pambarpuram','624103',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39527,115,'Pandianagar','624001',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39528,115,'Pandithakaranur','624620',1,0,'2022-03-03 12:39:20','2022-03-03 12:39:20'),(39529,115,'Pandrimalai','624212',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39530,115,'Pannaikadu','624210',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39531,115,'Pannaipatti','624705',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39532,115,'Pappampatti','624621',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39533,115,'Paraipatti','624707',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39534,115,'Paruthiyur','624616',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39535,115,'Pattiveeranpatti','624211',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39536,115,'Pazhamputhur','624103',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39537,115,'Periakuzhipatti','624704',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39538,115,'Perichipalayam','624617',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39539,115,'Periyakalayamputhur','624615',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39540,115,'Periyakottai','624614',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39541,115,'Periyakottai','624306',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39542,115,'Periyamottanuthu','624618',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39543,115,'Periyur','624212',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39544,115,'Perumalkoilpatti','624302',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39545,115,'Perumalmalai','624101',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39546,115,'Perumalnaickenvalasu','624614',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39547,115,'Perumalpudur','624615',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39548,115,'Perumbarai','624212',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39549,115,'Perumpallam','624101',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39550,115,'Pethanaickenpatti','624615',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39551,115,'Pilathu','624802',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39552,115,'Pillamanaickenpatti','624706',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39553,115,'Pillayarnatham','624219',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39554,115,'Pillayarnatham','624403',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39555,115,'Pithalaipatti','624002',1,0,'2022-03-03 12:39:21','2022-03-03 12:39:21'),(39556,115,'Polur','624103',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39557,115,'Ponnimandurai','624002',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39558,115,'Poolampati','624613',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39559,115,'Poombarai','624103',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39560,115,'Poonuthu','624711',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39561,115,'Poosaripatti','624202',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39562,115,'Poothampatti','624702',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39563,115,'Porulur','624616',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39564,115,'Prakasapuram','624101',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39565,115,'Puduchatram','624619',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39566,115,'Pudur(NTM)','624401',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39567,115,'Pudurchettiapatti','624710',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39568,115,'Pulathur','624202',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39569,115,'Puliamarathukottai','624710',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39570,115,'Puliampatti','624617',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39571,115,'Puliyurnatham','624704',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39572,115,'Pundi','624103',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39573,115,'Punnapatti','624401',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39574,115,'Pushpathur','624618',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39575,115,'Puthuputhur','624103',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39576,115,'Puthur','624801',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39577,115,'R.Iyyampalayam','624621',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39578,115,'R.Kombai','624706',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39579,115,'R.Pudukottai','624706',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39580,115,'R.Vellodu','624620',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39581,115,'Ragalapuram','624304',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39582,115,'Rajakkapatti','624306',1,0,'2022-03-03 12:39:22','2022-03-03 12:39:22'),(39583,115,'Rajampatti','624617',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39584,115,'Rajathanikottai','624220',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39585,115,'Ramagiri','624703',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39586,115,'Ramarajapuram','624219',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39587,115,'Reddiapatti','624003',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39588,115,'Reddiapatti','624401',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39589,115,'Reddiapatti','624202',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39590,115,'Reddiarchatram','624622',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39591,115,'S.R.G.Pudur','624619',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39592,115,'S.Vadipatti','624622',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39593,115,'Sadayampatti','624306',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39594,115,'Sakkampatti','624612',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39595,115,'Sakkiliankodai','624308',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39596,115,'Samiyarpatti','624302',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39597,115,'Samudrapatti','624402',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39598,115,'Sanarpatti','624304',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39599,115,'Sandaiyur','624220',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39600,115,'Sangalpatty','624215',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39601,115,'Sangampalayam','624617',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39602,115,'Sangareddikottai','624211',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39603,115,'Sankarapuram','624215',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39604,115,'Sathampadi','624401',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39605,115,'Sedapatti','624708',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39606,115,'Sellamanthadi','624005',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39607,115,'Sembatti','624707',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39608,115,'Sendurai (Dindigul)','624403',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39609,115,'Sengurichi','624306',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39610,115,'Senkattampatti','624708',1,0,'2022-03-03 12:39:23','2022-03-03 12:39:23'),(39611,115,'Sennamanaickenpatti','624004',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39612,115,'Servaikaranpatti','624620',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39613,115,'Sethur','624401',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39614,115,'Settinaickenpatti','624004',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39615,115,'Sevugampatti','624211',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39616,115,'Shenbaganur','624101',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39617,115,'Silaipadi','624005',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39618,115,'Silukkuvarpatti','624215',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39619,115,'Siluvathur','624306',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39620,115,'Silvarpatti','624709',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39621,115,'Sindalagundu','624002',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39622,115,'Singarakottai.V.','624802',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39623,115,'Sirugudi','624402',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39624,115,'Sirumalai','624003',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39625,115,'Sirumalaipudur','624003',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39626,115,'Sirunaickenpatti','624219',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39627,115,'Sirunaickenpatti','624307',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39628,115,'Sithargalnatham','624219',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39629,115,'Sithayankottai','624708',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39630,115,'Sitherevu','624204',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39631,115,'Sithuvarpatti','624801',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39632,115,'Solaikadu','624212',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39633,115,'Sreerankattupatti','624401',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39634,115,'Srinivasapuram','624101',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39635,115,'Sriramapuram','624622',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39636,115,'Sriramapuram','624702',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39637,115,'St.Marys Estate','624212',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39638,115,'Sukkampatti','624801',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39639,115,'Sukkampatti','624709',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39640,115,'Sullerumbu','624710',1,0,'2022-03-03 12:39:24','2022-03-03 12:39:24'),(39641,115,'T.Panjampatti','624304',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39642,115,'T.Pudupatti','624705',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39643,115,'T.Vadugapatti','624308',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39644,115,'Tadicombu','624709',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39645,115,'Tandigudi','624216',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39646,115,'Teppakulathupatti','624709',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39647,115,'Thalaiyuthu','624618',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39648,115,'Thamaraikulam','624615',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39649,115,'Thamaraipadi','624005',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39650,115,'Thangachiammapatti','624612',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39651,115,'Thathanaickenpatti','624621',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39652,115,'Thattarapatti','624710',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39653,115,'Thavasimadai','624304',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39654,115,'Thazhakadai','624003',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39655,115,'Theethagoundenvalasu','624616',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39656,115,'Thennampatti','624802',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39657,115,'Theppathupatti','624220',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39658,115,'Thettupatti','624705',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39659,115,'Thimmanallur','624308',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39660,115,'Thonimalai','624212',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39661,115,'Thoppampatti','624617',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39662,115,'Thottanampatti','624005',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39663,115,'Thottanuthu','624005',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39664,115,'Thozhipatti','624703',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39665,115,'Thummalagundu','624802',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39666,115,'Thummalapatti','624617',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39667,115,'Tirukoornam','624620',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39668,115,'Tirumalaigoundenvalasu','624616',1,0,'2022-03-03 12:39:25','2022-03-03 12:39:25'),(39669,115,'Ulliyakottai','624703',1,0,'2022-03-03 12:39:26','2022-03-03 12:39:26'),(39670,115,'Undarpatti','624709',1,0,'2022-03-03 12:39:26','2022-03-03 12:39:26'),(39671,115,'Uralipatti','624402',1,0,'2022-03-03 12:39:26','2022-03-03 12:39:26'),(39672,115,'Usilampatti','624706',1,0,'2022-03-03 12:39:26','2022-03-03 12:39:26'),(39673,115,'Uthupatti','624206',1,0,'2022-03-03 12:39:26','2022-03-03 12:39:26'),(39674,115,'V.S.K.Kurumbapatti','624306',1,0,'2022-03-03 12:39:26','2022-03-03 12:39:26'),(39675,115,'Vadagadu','624619',1,0,'2022-03-03 12:39:26','2022-03-03 12:39:26'),(39676,115,'Vadagounji','624101',1,0,'2022-03-03 12:39:26','2022-03-03 12:39:26'),(39677,115,'Vadakattupatti','624304',1,0,'2022-03-03 12:39:26','2022-03-03 12:39:26'),(39678,115,'Vadamadurai','624802',1,0,'2022-03-03 12:39:26','2022-03-03 12:39:26'),(39679,115,'Vadugampadi','624706',1,0,'2022-03-03 12:39:26','2022-03-03 12:39:26'),(39680,115,'Vagarai','624613',1,0,'2022-03-03 12:39:26','2022-03-03 12:39:26'),(39681,115,'Vaithilathoppampatti','624306',1,0,'2022-03-03 12:39:26','2022-03-03 12:39:26'),(39682,115,'Vakkampatti','624303',1,0,'2022-03-03 12:39:26','2022-03-03 12:39:26'),(39683,115,'Valayapatti','624704',1,0,'2022-03-03 12:39:26','2022-03-03 12:39:26'),(39684,115,'Vallipatti','624710',1,0,'2022-03-03 12:39:26','2022-03-03 12:39:26'),(39685,115,'Vanikarai','624710',1,0,'2022-03-03 12:39:26','2022-03-03 12:39:26'),(39686,115,'Vannampatti','624707',1,0,'2022-03-03 12:39:26','2022-03-03 12:39:26'),(39687,115,'Varthamanathi Dam Project','624613',1,0,'2022-03-03 12:39:26','2022-03-03 12:39:26'),(39688,115,'Vathipatti','624401',1,0,'2022-03-03 12:39:26','2022-03-03 12:39:26'),(39689,115,'Vedasandur','624710',1,0,'2022-03-03 12:39:26','2022-03-03 12:39:26'),(39690,115,'Veerakkal','624303',1,0,'2022-03-03 12:39:26','2022-03-03 12:39:26'),(39691,115,'Veeralapatti','624614',1,0,'2022-03-03 12:39:26','2022-03-03 12:39:26'),(39692,115,'Veerasinnnampatti','624304',1,0,'2022-03-03 12:39:26','2022-03-03 12:39:26'),(39693,115,'Velampatti','624401',1,0,'2022-03-03 12:39:26','2022-03-03 12:39:26'),(39694,115,'Velampatti','624617',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39695,115,'Vellagavi','624101',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39696,115,'Vellodu','624307',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39697,115,'Velvarkottai','624802',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39698,115,'Vembarpatti','624308',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39699,115,'Vengalapatti','624212',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39700,115,'Venkatasrikottai','624202',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39701,115,'Veriyappur','624619',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39702,115,'Vilampatti','624219',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39703,115,'Vilpatti','624101',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39704,115,'Viralimayanpatti','624220',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39705,115,'Viralipatti','624202',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39706,115,'Viralipatti','624709',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39707,115,'Virupatchi','624614',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39708,115,'Viruthalaipatti','624711',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39709,115,'Viruveedu','624220',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39710,115,'Yeluvanampatti','624202',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39711,115,'Soolapuram','639203',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39712,116,'A.Sembulichampalayam','638502',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39713,116,'Akkaraikodiveri','638454',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39714,116,'Alampalayam','638501',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39715,116,'Alathur','638455',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39716,116,'Alingiam(Gobi)','638457',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39717,116,'Alukuli','638453',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39718,116,'Ammankoil','638109',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39719,116,'Ammapettai','638311',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39720,116,'Anaipalayam','638752',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39721,116,'Anjanur(Vemandampalayam)','638462',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39722,116,'Anjur','638151',1,0,'2022-03-03 12:39:27','2022-03-03 12:39:27'),(39723,116,'Anthiyur','638501',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39724,116,'Appakudal','638315',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39725,116,'Arachalur','638101',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39726,116,'Arakkankottai','638506',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39727,116,'Arasur','638454',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39728,116,'Athani (Erode)','638502',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39729,116,'Athiyur','638103',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39730,116,'Attavanai Hanumanpalli','638101',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39731,116,'Avalpundurai','638115',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39732,116,'Avudayarparai','638151',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39733,116,'Ayalur','638453',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39734,116,'Ayyampalayam','638455',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39735,116,'Ayyampalayam','638151',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39736,116,'Bargur-Anthiyur','638501',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39737,116,'Basuvanapuram','638503',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39738,116,'Basuvapatti','638051',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39739,116,'Bhavani Cutcherry','638301',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39740,116,'Bhavani H.O','638301',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39741,116,'Bhavani Kudal','638301',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39742,116,'Brahmadesam','638315',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39743,116,'Budapadi','638311',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39744,116,'Cauvery Railway Station','638007',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39745,116,'Chennampatti','638504',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39746,116,'Chennimalai','638051',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39747,116,'Chikkaiah Naicker College','638004',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39748,116,'Chinnapallam','638311',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39749,116,'Chinniampalayam (Kunnathur)','638103',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39750,116,'Chittode','638102',1,0,'2022-03-03 12:39:28','2022-03-03 12:39:28'),(39751,116,'Dalavoipalayam','638751',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39752,116,'Dalavoipettai','638312',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39753,116,'Dasappagoundanpudur','638503',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39754,116,'Edayankattuvalsu','638009',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39755,116,'Elathur Chettipalayam','638458',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39756,116,'Elavamalai','638316',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39757,116,'Elavanatham','638101',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39758,116,'Elumathur','638104',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39759,116,'Ennamangalam','638501',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39760,116,'Erangattur','638505',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39761,116,'Erode Collectorate','638011',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39762,116,'Erode East','638001',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39763,116,'Erode Fort','638001',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39764,116,'Erode H.O','638001',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39765,116,'Erode Market','638001',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39766,116,'Erode North','638001',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39767,116,'Erode Railway Colony','638002',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39768,116,'Erode South','638001',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39769,116,'Ganapathipalayam','638153',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39770,116,'Gangapuram','638102',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39771,116,'Getticheyur','638110',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39772,116,'Gettisamudram','638501',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39773,116,'Gettisamudram Colony','638501',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39774,116,'Gnanipalayam','638112',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39775,116,'Gobichettipalayam East','638452',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39776,116,'Gobichettipalayam H.O','638452',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39777,116,'Gobichettipalayam South','638476',1,0,'2022-03-03 12:39:29','2022-03-03 12:39:29'),(39778,116,'Greynagar','638056',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39779,116,'Gudakkarai','638454',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39780,116,'Guruvareddiyur','638504',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39781,116,'Guthialathur','638503',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39782,116,'Ichipalayam','638151',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39783,116,'Ingur','638052',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39784,116,'Injampalli','638104',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39785,116,'Irugalur','638462',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39786,116,'Jambai','638312',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39787,116,'Kadappanalur','638311',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39788,116,'Kadathur (Gobi)','638454',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39789,116,'Kadayampatti','638312',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39790,116,'Kadirampatti','638107',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39791,116,'Kadukkampalayam','638476',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39792,116,'Kagam','638109',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39793,116,'Kaikolapalayam','638056',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39794,116,'Kalbhavi','638314',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39795,116,'Kaliappampalayam','638110',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39796,116,'Kalichettipalayam. Mettupalayam','638455',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39797,116,'Kalingarayanpalayam Pudur','638301',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39798,116,'Kalingiam','638453',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39799,116,'Kalkadambur','638503',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39800,116,'Kallipatti','638505',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39801,116,'Kambiliyampatti','638056',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39802,116,'Kanagapuram','638112',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39803,116,'Kanakkampalayam','638505',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39804,116,'Kandappagoundenvalasu','638051',1,0,'2022-03-03 12:39:30','2022-03-03 12:39:30'),(39805,116,'Kandasamipalayam','638109',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39806,116,'Kandikattuvalasu','638115',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39807,116,'Kanjikovil','638116',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39808,116,'Kannadipalayam','638314',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39809,116,'Karalayam','638503',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39810,116,'Karattadipalayam','638453',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39811,116,'Karattupalayam','638457',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39812,116,'Karukkampalayam','638109',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39813,116,'Karumandisellipalayam','638052',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39814,116,'Karungalpalayam','638003',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39815,116,'Kasbapettai','638115',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39816,116,'Kasipalayam','638009',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39817,116,'Kasipalayam (Erode)','638454',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39818,116,'Kasthurbagarm','638101',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39819,116,'Kasthuripalayam','638751',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39820,116,'Kavindapadi','638455',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39821,116,'Kavundichipalayam','638112',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39822,116,'Kavuthampalayam','638103',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39823,116,'Kembanaickenpalayam','638503',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39824,116,'Kesarimangalam','638311',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39825,116,'Kidarai','638458',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39826,116,'Kilwani','638502',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39827,116,'Kodiveri','638503',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39828,116,'Kodumudi','638151',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39829,116,'Kolanalli','638154',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39830,116,'Kolappalur (Erode)','638456',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39831,116,'Kolathupalayam','638152',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39832,116,'Kollampalayam','638002',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39833,116,'Komarayanur','638504',1,0,'2022-03-03 12:39:31','2022-03-03 12:39:31'),(39834,116,'Komarayeevalasu','638104',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39835,116,'Kondapanaickenpalayam','638503',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39836,116,'Kondayampalayam(Bhavani)','638505',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39837,116,'Kongarpalayam','638506',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39838,116,'Koothampalayam','638751',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39839,116,'Koothampatti','638101',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39840,116,'Koothampoondi','638315',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39841,116,'Koshanam','638458',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39842,116,'Kottupullampalayam','638453',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39843,116,'Kovilpalayam','638116',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39844,116,'Kugalur','638313',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39845,116,'Kullampalayam','638476',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39846,116,'Kummakalipalayam','638457',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39847,116,'Kunnathur (Erode)','638103',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39848,116,'Kuppandampalayam','638502',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39849,116,'Kurichi','638314',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39850,116,'Kurichi-kunnathur','638110',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39851,116,'Kurumandur','638457',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39852,116,'Kurupanaickenpalayam','638301',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39853,116,'Kuthambi','638055',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39854,116,'Kuttipalayam','638312',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39855,116,'L.M.Palapalayam','638455',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39856,116,'Lakkapuram','638002',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39857,116,'Malayampalayam','638154',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39858,116,'Mannathampalayam','638153',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39859,116,'Maravapalayam','638051',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39860,116,'Mathur','638314',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39861,116,'Melapalayam (Erode)','638051',1,0,'2022-03-03 12:39:32','2022-03-03 12:39:32'),(39862,116,'Mettupalayam','638315',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39863,116,'Mevani','638313',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39864,116,'Michaelpalayam','638501',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39865,116,'Minnapalayam','638109',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39866,116,'Modakurichi','638104',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39867,116,'Morattupalayam','638752',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39868,116,'Mukasi Hanumanpalli','638101',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39869,116,'Mukasipidariyur','638051',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39870,116,'Mukasipudur','638314',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39871,116,'Mulapalayam','638002',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39872,116,'Mullampatti','638107',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39873,116,'Murali','638504',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39874,116,'Murungatholuvu','638051',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39875,116,'Muthayeepalayam','638153',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39876,116,'Mylambadi','638314',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39877,116,'Nadupatti','638056',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39878,116,'Nagadevampalayam','638476',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39879,116,'Nagalur','638502',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39880,116,'Nallampatti','638057',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39881,116,'Nambiyur','638458',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39882,116,'Nanjagoundenpalayam','638476',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39883,116,'Nanjai Puliampatti','638506',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39884,116,'Nanjai Uttukuli','638104',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39885,116,'Nasiyanur','638107',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39886,116,'Nathagoundenpalayam','638115',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39887,116,'Nerinjipettai','638311',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39888,116,'Nichampalayam','638055',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39889,116,'Odathurai','638455',1,0,'2022-03-03 12:39:33','2022-03-03 12:39:33'),(39890,116,'Odayagoundenpalayam','638454',1,0,'2022-03-03 12:39:34','2022-03-03 12:39:34'),(39891,116,'Olagadam','638314',1,0,'2022-03-03 12:39:34','2022-03-03 12:39:34'),(39892,116,'Olapalayam','638052',1,0,'2022-03-03 12:39:34','2022-03-03 12:39:34'),(39893,116,'Oricheri','638315',1,0,'2022-03-03 12:39:34','2022-03-03 12:39:34'),(39894,116,'Pachampalayam','638314',1,0,'2022-03-03 12:39:34','2022-03-03 12:39:34'),(39895,116,'Palakarai','638057',1,0,'2022-03-03 12:39:34','2022-03-03 12:39:34'),(39896,116,'Palakuttaipattipudur','638504',1,0,'2022-03-03 12:39:34','2022-03-03 12:39:34'),(39897,116,'Pallagoundenpalayam','638056',1,0,'2022-03-03 12:39:34','2022-03-03 12:39:34'),(39898,116,'Pallapalayam','638116',1,0,'2022-03-03 12:39:34','2022-03-03 12:39:34'),(39899,116,'Palliyuthu','638101',1,0,'2022-03-03 12:39:34','2022-03-03 12:39:34'),(39900,116,'Pandiampalayam','638455',1,0,'2022-03-03 12:39:34','2022-03-03 12:39:34'),(39901,116,'Pappampalayam','638055',1,0,'2022-03-03 12:39:34','2022-03-03 12:39:34'),(39902,116,'Pariyur Vellalapalayam','638476',1,0,'2022-03-03 12:39:34','2022-03-03 12:39:34'),(39903,116,'Paruvachi','638312',1,0,'2022-03-03 12:39:34','2022-03-03 12:39:34'),(39904,116,'Pasur','638154',1,0,'2022-03-03 12:39:34','2022-03-03 12:39:34'),(39905,116,'Patlur','638314',1,0,'2022-03-03 12:39:34','2022-03-03 12:39:34'),(39906,116,'Pattakaranpalayam','638057',1,0,'2022-03-03 12:39:34','2022-03-03 12:39:34'),(39907,116,'Pattimaniakaranpalayam','638462',1,0,'2022-03-03 12:39:34','2022-03-03 12:39:34'),(39908,116,'Peria Agraharam','638005',1,0,'2022-03-03 12:39:34','2022-03-03 12:39:34'),(39909,116,'Peria Semur','638004',1,0,'2022-03-03 12:39:34','2022-03-03 12:39:34'),(39910,116,'Periapuliyur','638455',1,0,'2022-03-03 12:39:34','2022-03-03 12:39:34'),(39911,116,'Periavattam','638151',1,0,'2022-03-03 12:39:34','2022-03-03 12:39:34'),(39912,116,'Periaveerasangli','638056',1,0,'2022-03-03 12:39:34','2022-03-03 12:39:34'),(39913,116,'Periyavettuvapalayam','638052',1,0,'2022-03-03 12:39:34','2022-03-03 12:39:34'),(39914,116,'Perode','638102',1,0,'2022-03-03 12:39:34','2022-03-03 12:39:34'),(39915,116,'Perumugaipudur','638505',1,0,'2022-03-03 12:39:34','2022-03-03 12:39:34'),(39916,116,'Perundalaiyur','638315',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39917,116,'Perundurai R.S.','638052',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39918,116,'Perundurai','638052',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39919,116,'Perundurai Sanitorium','638053',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39920,116,'Perundurai West','638052',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39921,116,'Pethampalayam','638116',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39922,116,'Pichandampalayam','638052',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39923,116,'Polavakalipalayam','638476',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39924,116,'Polavapalayam','638458',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39925,116,'Pondilingapuram','638151',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39926,116,'Ponmudi','638056',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39927,116,'Pudukkaraipudur','638313',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39928,116,'Pudupalayam (Erode)','638476',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39929,116,'Pudur','638002',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39930,116,'Pullappanaickenpalayam','638506',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39931,116,'Pundurai Semur','638115',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39932,116,'Pungambadi','638112',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39933,116,'Punjaipalatholuvu','638751',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39934,116,'Punjaithuraiyampalayam','638506',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39935,116,'Punnam','638312',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39936,116,'Purappalikattuvalasu','638104',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39937,116,'Ramalingapuram','638051',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39938,116,'Ramalingapuram South','638051',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39939,116,'Ramanathapuram Pudur','638005',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39940,116,'Rangampalayam','638009',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39941,116,'Rasampalayam','638151',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39942,116,'Reddipalayam','638504',1,0,'2022-03-03 12:39:35','2022-03-03 12:39:35'),(39943,116,'Sakthinagar','638315',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39944,116,'Salaipudur','638151',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39945,116,'Salangapalayam','638455',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39946,116,'Sanarpalayam','638051',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39947,116,'Sankarapalayam','638501',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39948,116,'Sanyasipatti','638311',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39949,116,'Satamugai','638503',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39950,116,'Savandapur','638502',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39951,116,'Seenapuram','638057',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39952,116,'Sembadapalayam','638314',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39953,116,'Sembulichampalayam','638501',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39954,116,'Senapathichettipalayam','638752',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39955,116,'Singampettai','638311',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39956,116,'Singanallur KVP','638455',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39957,116,'Sinniampalayam','638104',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39958,116,'Sinthagoundenpalayam','638315',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39959,116,'Sircarkathankanni','638752',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39960,116,'Sirukalanji','638751',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39961,116,'Siruvalur','638054',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39962,116,'Sivagiri (Erode)','638109',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39963,116,'Sokkumaripalayam','638110',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39964,116,'Solipalayam','638115',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39965,116,'SPB Colony','638010',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39966,116,'Sullipalayam','638057',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39967,116,'Sundakkampalayam','638103',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39968,116,'Surampatti','638009',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39969,116,'Suriappampalayam','638458',1,0,'2022-03-03 12:39:36','2022-03-03 12:39:36'),(39970,116,'Swaminathapuram','638104',1,0,'2022-03-03 12:39:37','2022-03-03 12:39:37'),(39971,116,'T.Mettupalayam','638112',1,0,'2022-03-03 12:39:37','2022-03-03 12:39:37'),(39972,116,'Talguni','638456',1,0,'2022-03-03 12:39:37','2022-03-03 12:39:37'),(39973,116,'Thamaraikarai','638501',1,0,'2022-03-03 12:39:37','2022-03-03 12:39:37'),(39974,116,'Thamaraipalayam','638152',1,0,'2022-03-03 12:39:37','2022-03-03 12:39:37'),(39975,116,'Thandampalayam','638109',1,0,'2022-03-03 12:39:37','2022-03-03 12:39:37'),(39976,116,'Thaneerpandalpalayam','638116',1,0,'2022-03-03 12:39:37','2022-03-03 12:39:37'),(39977,116,'Thattampalayam','638109',1,0,'2022-03-03 12:39:37','2022-03-03 12:39:37'),(39978,116,'Thavittupalayam','638501',1,0,'2022-03-03 12:39:37','2022-03-03 12:39:37'),(39979,116,'Theethampalayam','638456',1,0,'2022-03-03 12:39:37','2022-03-03 12:39:37'),(39980,116,'Thindal','638012',1,0,'2022-03-03 12:39:37','2022-03-03 12:39:37'),(39981,116,'Thippampalayam','638751',1,0,'2022-03-03 12:39:37','2022-03-03 12:39:37'),(39982,116,'Thoppupalayam','638051',1,0,'2022-03-03 12:39:37','2022-03-03 12:39:37'),(39983,116,'Thoppupalayam','638052',1,0,'2022-03-03 12:39:37','2022-03-03 12:39:37'),(39984,116,'Thoranavavi','638110',1,0,'2022-03-03 12:39:37','2022-03-03 12:39:37'),(39985,116,'Thottipalayam','638312',1,0,'2022-03-03 12:39:37','2022-03-03 12:39:37'),(39986,116,'Thuckanaickenpalayam','638506',1,0,'2022-03-03 12:39:37','2022-03-03 12:39:37'),(39987,116,'Thuyyampundurai','638115',1,0,'2022-03-03 12:39:37','2022-03-03 12:39:37'),(39988,116,'Tingalur','638055',1,0,'2022-03-03 12:39:37','2022-03-03 12:39:37'),(39989,116,'Tudupathi','638057',1,0,'2022-03-03 12:39:37','2022-03-03 12:39:37'),(39990,116,'Umareddiyur','638311',1,0,'2022-03-03 12:39:37','2022-03-03 12:39:37'),(39991,116,'Unjalur','638152',1,0,'2022-03-03 12:39:37','2022-03-03 12:39:37'),(39992,116,'Uttukuli Rs','638752',1,0,'2022-03-03 12:39:37','2022-03-03 12:39:37'),(39993,116,'Uttukuli','638751',1,0,'2022-03-03 12:39:37','2022-03-03 12:39:37'),(39994,116,'Vadakkupudupalayam','638152',1,0,'2022-03-03 12:39:37','2022-03-03 12:39:37'),(39995,116,'Vadakuthaiyurpalayam','638102',1,0,'2022-03-03 12:39:38','2022-03-03 12:39:38'),(39996,116,'Vadamugam Vellodu','638112',1,0,'2022-03-03 12:39:38','2022-03-03 12:39:38'),(39997,116,'Vadugapatti','638101',1,0,'2022-03-03 12:39:38','2022-03-03 12:39:38'),(39998,116,'Vairamangalam','638312',1,0,'2022-03-03 12:39:38','2022-03-03 12:39:38'),(39999,116,'Vairapalayam','638003',1,0,'2022-03-03 12:39:38','2022-03-03 12:39:38'),(40000,116,'Vallipurathanpalayam','638112',1,0,'2022-03-03 12:39:38','2022-03-03 12:39:38'),(40001,116,'Varadhanallur','638311',1,0,'2022-03-03 12:39:38','2022-03-03 12:39:38'),(40002,116,'Varapalayam','638462',1,0,'2022-03-03 12:39:38','2022-03-03 12:39:38'),(40003,116,'Varnapuram','638301',1,0,'2022-03-03 12:39:38','2022-03-03 12:39:38'),(40004,116,'Vasavi College','638316',1,0,'2022-03-03 12:39:38','2022-03-03 12:39:38'),(40005,116,'Vazhaithottam','638109',1,0,'2022-03-03 12:39:38','2022-03-03 12:39:38'),(40006,116,'Veerappampalayam','638101',1,0,'2022-03-03 12:39:38','2022-03-03 12:39:38'),(40007,116,'Veerappanchatram','638004',1,0,'2022-03-03 12:39:38','2022-03-03 12:39:38'),(40008,116,'Velampalayam','638104',1,0,'2022-03-03 12:39:38','2022-03-03 12:39:38'),(40009,116,'Velampalayam(Kunnathur)','638103',1,0,'2022-03-03 12:39:38','2022-03-03 12:39:38'),(40010,116,'Velankattuvalasu','638115',1,0,'2022-03-03 12:39:38','2022-03-03 12:39:38'),(40011,116,'Vellalapalayam','638315',1,0,'2022-03-03 12:39:38','2022-03-03 12:39:38'),(40012,116,'Vellankoil','638054',1,0,'2022-03-03 12:39:38','2022-03-03 12:39:38'),(40013,116,'Vellaraveli','638103',1,0,'2022-03-03 12:39:38','2022-03-03 12:39:38'),(40014,116,'Vellitirupur','638314',1,0,'2022-03-03 12:39:38','2022-03-03 12:39:38'),(40015,116,'Vellottamparappu','638154',1,0,'2022-03-03 12:39:38','2022-03-03 12:39:38'),(40016,116,'Vemandampalayam','638462',1,0,'2022-03-03 12:39:38','2022-03-03 12:39:38'),(40017,116,'Vengampur','638152',1,0,'2022-03-03 12:39:38','2022-03-03 12:39:38'),(40018,116,'Vettayankinar','638055',1,0,'2022-03-03 12:39:38','2022-03-03 12:39:38'),(40019,116,'Vijayamangalam','638056',1,0,'2022-03-03 12:39:38','2022-03-03 12:39:38'),(40020,116,'Vilakethi','638109',1,0,'2022-03-03 12:39:39','2022-03-03 12:39:39'),(40021,116,'Vilarasampatti','638107',1,0,'2022-03-03 12:39:39','2022-03-03 12:39:39'),(40022,116,'Voipodi','638056',1,0,'2022-03-03 12:39:39','2022-03-03 12:39:39'),(40023,116,'Pottikkampalayam','642206',1,0,'2022-03-03 12:39:39','2022-03-03 12:39:39'),(40024,116,'Sengattupalayam','642206',1,0,'2022-03-03 12:39:39','2022-03-03 12:39:39'),(40025,116,'Achur','638673',1,0,'2022-03-03 12:39:39','2022-03-03 12:39:39'),(40026,116,'Agalaraipalayam','638111',1,0,'2022-03-03 12:39:39','2022-03-03 12:39:39'),(40027,116,'Alampadi','638701',1,0,'2022-03-03 12:39:39','2022-03-03 12:39:39'),(40028,116,'Alampalayam','638105',1,0,'2022-03-03 12:39:39','2022-03-03 12:39:39'),(40029,116,'Alampalayam','638661',1,0,'2022-03-03 12:39:39','2022-03-03 12:39:39'),(40030,116,'Alangiam','638657',1,0,'2022-03-03 12:39:39','2022-03-03 12:39:39'),(40031,116,'Ambodi','638459',1,0,'2022-03-03 12:39:39','2022-03-03 12:39:39'),(40032,116,'Araipalayam','638401',1,0,'2022-03-03 12:39:39','2022-03-03 12:39:39'),(40033,116,'Aralavadi','638461',1,0,'2022-03-03 12:39:39','2022-03-03 12:39:39'),(40034,116,'Aratholuvu','638701',1,0,'2022-03-03 12:39:39','2022-03-03 12:39:39'),(40035,116,'Ariyappampalayam','638402',1,0,'2022-03-03 12:39:39','2022-03-03 12:39:39'),(40036,116,'Avanashipalayampudur','638701',1,0,'2022-03-03 12:39:39','2022-03-03 12:39:39'),(40037,116,'Avanashipalyaam','638660',1,0,'2022-03-03 12:39:39','2022-03-03 12:39:39'),(40038,116,'Bagavankoil','638673',1,0,'2022-03-03 12:39:39','2022-03-03 12:39:39'),(40039,116,'Bannari','638401',1,0,'2022-03-03 12:39:39','2022-03-03 12:39:39'),(40040,116,'Bellampatti','638702',1,0,'2022-03-03 12:39:39','2022-03-03 12:39:39'),(40041,116,'Bhavanisagar','638451',1,0,'2022-03-03 12:39:39','2022-03-03 12:39:39'),(40042,116,'Bommanallur','638673',1,0,'2022-03-03 12:39:39','2022-03-03 12:39:39'),(40043,116,'Chengapalli','638812',1,0,'2022-03-03 12:39:39','2022-03-03 12:39:39'),(40044,116,'Chikkahalli','638461',1,0,'2022-03-03 12:39:39','2022-03-03 12:39:39'),(40045,116,'Chikkarasampalayam','638401',1,0,'2022-03-03 12:39:39','2022-03-03 12:39:39'),(40046,116,'Chimtahalli','638461',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40047,116,'Chinnaickampalayam','638657',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40048,116,'Chinnamarudur','638106',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40049,116,'Chinnaputhur','638657',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40050,116,'Chitravuthampalayam','638657',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40051,116,'Cholakkadai Street','638656',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40052,116,'Dalavoipattinam','638672',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40053,116,'Dasarapatti','638657',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40054,116,'Dasavanaickenpatti','638111',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40055,116,'Desipalayam','638459',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40056,116,'Devarajapattinam','638702',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40057,116,'Dharapuram H.O','638656',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40058,116,'Dharapuram South','638656',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40059,116,'Dhimbam','638401',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40060,116,'Doddagajanur','638461',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40061,116,'Doddampalayam','638451',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40062,116,'Doddapura','638461',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40063,116,'Ellisnagar','638657',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40064,116,'Emmammpoondi','638460',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40065,116,'Erahanahalli','638461',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40066,116,'Erasinampalayam','638106',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40067,116,'Ganapathipalayam','641605',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40068,116,'Germalam','638401',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40069,116,'Gethalrev','638657',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40070,116,'Gettavadi','638461',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40071,116,'Govindapuram','638657',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40072,116,'Gumtapuram','638461',1,0,'2022-03-03 12:39:40','2022-03-03 12:39:40'),(40073,116,'Hanumanthapuram','638656',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40074,116,'Hassanur','638401',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40075,116,'Ikkarainegamam','638401',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40076,116,'Ikkaraithathapalli','638451',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40077,116,'Irumborai','638459',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40078,116,'Kadayur','638701',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40079,116,'Kalipalayam','638661',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40080,116,'Kallivalasu','638657',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40081,116,'Kambiliampatti','638706',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40082,116,'Kangayam East','638701',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40083,116,'Kangayam North','638701',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40084,116,'Kangayam','638701',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40085,116,'Kanuvakarai','638459',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40086,116,'Karaipudur','641605',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40087,116,'Karaiyur','638661',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40088,116,'Karapadi','638459',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40089,116,'Karattupalayam','638111',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40090,116,'Karuppanvalasu','638111',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40091,116,'Kavilipalayam','638402',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40092,116,'Keeranur','638701',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40093,116,'Kilankundal','638106',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40094,116,'Koduvoi','638660',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40095,116,'Kokkampalayam','638702',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40096,116,'Kolathupalayam','638661',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40097,116,'Kolinjivadi','638673',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40098,116,'Komarapalayam','638108',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40099,116,'Komarapalayam','638106',1,0,'2022-03-03 12:39:41','2022-03-03 12:39:41'),(40100,116,'Komarapalayam-sathy','638401',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40101,116,'Konamoolai','638402',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40102,116,'Koneripatti','638673',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40103,116,'Kosavampalayam','638701',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40104,116,'Kothamangalam','638451',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40105,116,'Kottaimulanur','638106',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40106,116,'Kottuveerampalayam','638401',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40107,116,'Kullaipalayam','638657',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40108,116,'Kundadam','638702',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40109,116,'Kungarupalayam','638703',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40110,116,'Kurukkapalayam','638660',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40111,116,'Kuttapalayam','638108',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40112,116,'Lakkamanaickenpatti','638111',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40113,116,'Madampalayam','638459',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40114,116,'Mallanguli','638461',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40115,116,'Mambadi','638106',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40116,116,'Manakadavu','638673',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40117,116,'Mangalapatti','638105',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40118,116,'Marudurai','638108',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40119,116,'Mettupalayam','638111',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40120,116,'Mettuvalasu','638661',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40121,116,'Mudalipalayam','638703',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40122,116,'Mudianerichal','638701',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40123,116,'Muduthurai','638459',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40124,116,'Mulanur','638106',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40125,116,'Mulayampoondi','638111',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40126,116,'Mullipuram','638108',1,0,'2022-03-03 12:39:42','2022-03-03 12:39:42'),(40127,116,'Muthugoundenpalayam','638702',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40128,116,'Muthur','638105',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40129,116,'Mylrangam','638111',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40130,116,'Nagalingapuram','638660',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40131,116,'Nagamanaickenpatti','638111',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40132,116,'Nallampalayam','638661',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40133,116,'Nallimadam','638706',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40134,116,'Nallur','638459',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40135,116,'Nandavanampalayam','638702',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40136,116,'Nanjiampalayam','638657',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40137,116,'Nanjundapuram','638657',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40138,116,'Nathachennigoundenvalasu','638106',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40139,116,'Nathakadaiyur','638108',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40140,116,'Nathakattuvalasu','638701',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40141,116,'Nathapalayam','638106',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40142,116,'Neithalapuram','638461',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40143,116,'Nelali','638660',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40144,116,'Nochikuttai','638459',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40145,116,'Nochipalayam','638706',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40146,116,'Olalakoil','638460',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40147,116,'Olapalayam','638701',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40148,116,'Orathupalyaam','638106',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40149,116,'Padiyur','638701',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40150,116,'Palayakottai','638108',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40151,116,'Panakkahalli','638461',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40152,116,'Panayampalli','638459',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40153,116,'Pappinipachapalayam','638701',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40154,116,'Paranjervali','638701',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40155,116,'Pattuthurai','638106',1,0,'2022-03-03 12:39:43','2022-03-03 12:39:43'),(40156,116,'Peramium','638661',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40157,116,'Periyur','638402',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40158,116,'Pethikuttai','638459',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40159,116,'Pichakalpatti','638106',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40160,116,'Pongalur-avanashi','638459',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40161,116,'Ponnapuram','638657',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40162,116,'Ponnivadi','638673',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40163,116,'Pothampalayam','638460',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40164,116,'Pothiapalayam','638701',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40165,116,'Pudupeerkadavu`','638451',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40166,116,'Puduppai','638111',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40167,116,'Puduvadavalli','638401',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40168,116,'Puliampatti','638106',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40169,116,'Pulipar','638460',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40170,116,'Punganthurai','638706',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40171,116,'Punjai Puliampatti','638459',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40172,116,'Punjaithamaraikulam','638460',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40173,116,'Rajannagar','638451',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40174,116,'Rakkiavalasu','638106',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40175,116,'Rangasamudram','638402',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40176,116,'Rettalavalasu','638661',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40177,116,'Rudravathi','638702',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40178,116,'Sadayapalayam','638702',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40179,116,'Sankarandampalayam','638706',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40180,116,'Sarkarperiapalayam','641607',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40181,116,'Sathy Bazaar','638401',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40182,116,'Sathyamangalam','638401',1,0,'2022-03-03 12:39:44','2022-03-03 12:39:44'),(40183,116,'Savakattupalayam','638460',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40184,116,'Selampalayam','638672',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40185,116,'Sellappampalayam','638459',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40186,116,'Semmangarai','638106',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40187,116,'Senapathipalayam','638111',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40188,116,'Sengodampalayam','638703',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40189,116,'Shenbagapudur','638402',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40190,116,'Sirukinar','638706',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40191,116,'Sivanmalai','638701',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40192,116,'Soosaipuram','638461',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40193,116,'Surianallur','638702',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40194,116,'Talamalai','638461',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40195,116,'Talavadi','638461',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40196,116,'Tegnarai','638461',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40197,116,'Thambureddipalayam','638701',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40198,116,'Thayamapalayam','638703',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40199,116,'Theethampalayam','638111',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40200,116,'Thengumarahada','638451',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40201,116,'Therpatti','638673',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40202,116,'Thingalur','638401',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40203,116,'Thoppampalayam','638451',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40204,116,'Thoppampatti','638657',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40205,116,'Thottiapalayam','638661',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40206,116,'Thurambadi','638106',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40207,116,'Udhiyur','638703',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40208,116,'Ugayanur','641605',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40209,116,'Undarapatti','638673',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40210,116,'Uppupalayam','638111',1,0,'2022-03-03 12:39:45','2022-03-03 12:39:45'),(40211,116,'Uthandiyur','638402',1,0,'2022-03-03 12:39:46','2022-03-03 12:39:46'),(40212,116,'Vadugapatti','638106',1,0,'2022-03-03 12:39:46','2022-03-03 12:39:46'),(40213,116,'Valipalayam','638402',1,0,'2022-03-03 12:39:46','2022-03-03 12:39:46'),(40214,116,'Varadampalayam','638401',1,0,'2022-03-03 12:39:46','2022-03-03 12:39:46'),(40215,116,'Veeracholapuram','638701',1,0,'2022-03-03 12:39:46','2022-03-03 12:39:46'),(40216,116,'Veerajimangalam','638673',1,0,'2022-03-03 12:39:46','2022-03-03 12:39:46'),(40217,116,'Veeranampalayam','638701',1,0,'2022-03-03 12:39:46','2022-03-03 12:39:46'),(40218,116,'Velappanaickenvalasu','638111',1,0,'2022-03-03 12:39:46','2022-03-03 12:39:46'),(40219,116,'Vellakoil Bazaar','638111',1,0,'2022-03-03 12:39:46','2022-03-03 12:39:46'),(40220,116,'Vellakoil','638111',1,0,'2022-03-03 12:39:46','2022-03-03 12:39:46'),(40221,116,'Vellavavipudur','638661',1,0,'2022-03-03 12:39:46','2022-03-03 12:39:46'),(40222,116,'Vellierichal','638105',1,0,'2022-03-03 12:39:46','2022-03-03 12:39:46'),(40223,116,'Vengipalayam','638703',1,0,'2022-03-03 12:39:46','2022-03-03 12:39:46'),(40224,116,'Vinnapalli','638402',1,0,'2022-03-03 12:39:46','2022-03-03 12:39:46'),(40225,116,'Virumandampalayam','638812',1,0,'2022-03-03 12:39:46','2022-03-03 12:39:46'),(40226,116,'Anangur','639202',1,0,'2022-03-03 12:39:46','2022-03-03 12:39:46'),(40227,116,'Arikkaranvalasu','639201',1,0,'2022-03-03 12:39:46','2022-03-03 12:39:46'),(40228,116,'Edakkalpadi','639202',1,0,'2022-03-03 12:39:46','2022-03-03 12:39:46'),(40229,116,'Erachapadi','639202',1,0,'2022-03-03 12:39:46','2022-03-03 12:39:46'),(40230,116,'Kannivadi','639202',1,0,'2022-03-03 12:39:46','2022-03-03 12:39:46'),(40231,116,'Malamedu','639201',1,0,'2022-03-03 12:39:46','2022-03-03 12:39:46'),(40232,116,'Nanjaithalaiyur','639202',1,0,'2022-03-03 12:39:46','2022-03-03 12:39:46'),(40233,116,'Velampundi','639201',1,0,'2022-03-03 12:39:46','2022-03-03 12:39:46'),(40234,117,'Acharapakkam R.S.','603301',1,0,'2022-03-03 12:39:46','2022-03-03 12:39:46'),(40235,117,'Acharapakkam','603301',1,0,'2022-03-03 12:39:46','2022-03-03 12:39:46'),(40236,117,'Alagesa Nagar','603001',1,0,'2022-03-03 12:39:46','2022-03-03 12:39:46'),(40237,117,'Alathur Industrial Estate','603110',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40238,117,'Ammanambakkam','603109',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40239,117,'Ammanambakkam','603003',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40240,117,'Anaicut','603312',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40241,117,'Anambakkam','603107',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40242,117,'Ananthamangalam','603307',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40243,117,'Andarkuppam','603401',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40244,117,'Anjur','603204',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40245,117,'Annai Anjugam Nagar','603211',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40246,117,'Anupuram','603127',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40247,117,'Anur','603405',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40248,117,'Appur','603204',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40249,117,'Arumbuliyur','603106',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40250,117,'Arungunam','603306',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40251,117,'Athur-chengalpattu','603101',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40252,117,'Ayakonamkolathur','603310',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40253,117,'Ayapakkam','603102',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40254,117,'Budur','603308',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40255,117,'Bukkathurai','603308',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40256,117,'Chengalpattu Bazaar','603002',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40257,117,'Chengalpattu Cutcherry','603001',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40258,117,'Chengalpattu H.O','603001',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40259,117,'Chengalpattu Med.College','603001',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40260,117,'Chengattur','603302',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40261,117,'Chettipunniam','603204',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40262,117,'Cheyur (Kanchipuram)','603302',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40263,117,'Cheyyur North','603302',1,0,'2022-03-03 12:39:47','2022-03-03 12:39:47'),(40264,117,'Chithamur','603313',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40265,117,'Chithanakkavur','603107',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40266,117,'Chunampet','603401',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40267,117,'Desumugipettai','603109',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40268,117,'Edaiyur','603109',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40269,117,'Edayambudur','603107',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40270,117,'Elapakkam','603201',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40271,117,'Elutchur','603204',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40272,117,'Guduvanchery','603202',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40273,117,'Gundur-chengalpattu','603002',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40274,117,'Hanumanthapuram','603108',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40275,117,'Illalur','603110',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40276,117,'Indalur','603301',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40277,117,'Iranya Sidhi','603312',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40278,117,'Irumbedu','603302',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40279,117,'Irumbuli','603301',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40280,117,'Irumbulichery','603109',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40281,117,'Isur','603310',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40282,117,'Isur','603308',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40283,117,'Janakipuram','603303',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40284,117,'K.Nelvoy','603312',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40285,117,'Kadalur','603305',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40286,117,'Kadambadi','603104',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40287,117,'Kadukkalur','603401',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40288,117,'Kalkulam','603312',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40289,117,'Kallabiranpuram','603308',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40290,117,'Kalpakkam','603102',1,0,'2022-03-03 12:39:48','2022-03-03 12:39:48'),(40291,117,'Kalvoy','603108',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40292,117,'Kannivakkam','603202',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40293,117,'Karanaipuduchery','603202',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40294,117,'Karasangal','603310',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40295,117,'Karumbakkam','603108',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40296,117,'Karunguli','603303',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40297,117,'Karunilam','603204',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40298,117,'Kathirichery','603303',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40299,117,'Kattankolathur','603203',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40300,117,'Kattiampandal','603314',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40301,117,'Kattudevadur','603313',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40302,117,'Kattugudalur','603301',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40303,117,'Kattukaranai','603201',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40304,117,'Kavanur','603203',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40305,117,'Kayapakkam','603301',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40306,117,'Kayar','603110',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40307,117,'Kayarambedu;','603202',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40308,117,'Keelavalam','603303',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40309,117,'Kilakadi','603107',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40310,117,'Kinar','603303',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40311,117,'Kinar Kandigai Pudur','603303',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40312,117,'Kodoovur','603305',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40313,117,'Kokilamedu','603104',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40314,117,'Kolampakkam','603308',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40315,117,'Kolathur','603304',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40316,117,'Koothavakkam','603104',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40317,117,'Kottaikadu','603304',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40318,117,'Kottamedu','603108',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40319,117,'Kudapakkam','603304',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40320,117,'Kunnavakkam','603107',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40321,117,'Kunnavakkam','603002',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40322,117,'Kuvathur','603305',1,0,'2022-03-03 12:39:49','2022-03-03 12:39:49'),(40323,117,'Kuzhipanthandalam','603105',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40324,117,'Lathur','603312',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40325,117,'Madambakkam','603202',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40326,117,'Madayathur','603108',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40327,117,'Madhur','603201',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40328,117,'Madurantakam','603306',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40329,117,'Mahindra World City (Kanchipuram)','603002',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40330,117,'Malaivaiyavur','603308',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40331,117,'Malapalayam','603303',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40332,117,'Malayalipettai','603303',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40333,117,'Mamallapuram','603104',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40334,117,'Mamandur','603111',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40335,117,'Manamai','603102',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40336,117,'Manambathi','603105',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40337,117,'Manapakkam','603111',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40338,117,'Maraimalai Nagar','603209',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40339,117,'Melaiyur','603108',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40340,117,'Melavalam','603303',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40341,117,'Meleripakkam','603003',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40342,117,'Melmaruvathur','603319',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40343,117,'Melprumal Chery','603102',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40344,117,'Melrosapuram','603204',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40345,117,'Meyyur','603111',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40346,117,'Minnal Sithamur','603307',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40347,117,'Morapakkam','603306',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40348,117,'Mugaiyur','603305',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40349,117,'Mugundagiri','603309',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40350,117,'Mullikolathur','603109',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40351,117,'Mullipakkam','603105',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40352,117,'Murugambakkam','603306',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40353,117,'Nainarkuppam','603302',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40354,117,'Natham-chengalpattu','603002',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40355,117,'Nedumaram','603305',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40356,117,'Neerpair','603313',1,0,'2022-03-03 12:39:50','2022-03-03 12:39:50'),(40357,117,'Nellikuppam','603108',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40358,117,'Nelvoy','603107',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40359,117,'Nenmeli','603003',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40360,117,'Nerkunam','603310',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40361,117,'Nerkunapattu','603305',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40362,117,'New Mambakkam','603306',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40363,117,'Ninnakarai','603203',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40364,117,'Nugumbal','603313',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40365,117,'Olaiyur','603107',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40366,117,'Onambakkam','603313',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40367,117,'Oragadam','603109',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40368,117,'Orakattupettai','603106',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40369,117,'Orathy','603307',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40370,117,'Ozhalur','603111',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40371,117,'Ozhavetti','603311',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40372,117,'Padalam','603308',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40373,117,'Padiri','603201',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40374,117,'Paiyambadi','603309',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40375,117,'Pakkam','603306',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40376,117,'Palaiyur','603302',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40377,117,'Palayanur','603308',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40378,117,'Palliagaram','603107',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40379,117,'Palur','603312',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40380,117,'Palur','603101',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40381,117,'Panaiyur','603302',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40382,117,'Panangottur','603209',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40383,117,'Pandur','603109',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40384,117,'Paranur','603002',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40385,117,'Parukkal','603301',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40386,117,'Pattaraikalani','603102',1,0,'2022-03-03 12:39:51','2022-03-03 12:39:51'),(40387,117,'Pattipulam','603104',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40388,117,'Pavunjur','603312',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40389,117,'Pazhamathur','603111',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40390,117,'Peria Irumbedu','603105',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40391,117,'Peria Venmani','603311',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40392,117,'Perukkaranai','603309',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40393,117,'Perumbakkam','603306',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40394,117,'Perumbakkam','603302',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40395,117,'Perumber Kandigai','603310',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40396,117,'Perungozhi','603314',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40397,117,'Perur','603104',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40398,117,'Polambakkam','603309',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40399,117,'Ponpathirkoodam','603405',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40400,117,'Ponvilainthakalathur','603405',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40401,117,'Poonjeri','603104',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40402,117,'Porpandal','603107',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40403,117,'Pudupattinam','603102',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40404,117,'Pudupattinam Colony','603102',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40405,117,'Pudupattu','603303',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40406,117,'Pulipakkam','603002',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40407,117,'Pulithivakkam','603314',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40408,117,'Puliyur','603109',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40409,117,'Puthirankottai','603401',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40410,117,'Ramapuram','603201',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40411,117,'Reactor Research Centre ','603102',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40412,117,'Reddipalayam','603101',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40413,117,'Salavakkam','603107',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40414,117,'Salur','603405',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40415,117,'Sathanjeri','603106',1,0,'2022-03-03 12:39:52','2022-03-03 12:39:52'),(40416,117,'Seekanankuppam','603305',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40417,117,'Seethananjeri','603106',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40418,117,'Seethapuram','603301',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40419,117,'Seevadi','603312',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40420,117,'Sembakkam','603108',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40421,117,'Sembulipuram','603304',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40422,117,'Sendivakkam','603319',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40423,117,'Senguntharpettai','603306',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40424,117,'Senneri','603108',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40425,117,'Singaperumalkoil','603204',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40426,117,'Sirudamur','603307',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40427,117,'Sirudavur','603105',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40428,117,'Sirumailur','603310',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40429,117,'Sirunagalur','603319',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40430,117,'Sirunagar','603310',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40431,117,'Sirunkundram','603108',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40432,117,'Sogandi','603405',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40433,117,'Suradimangalam','603102',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40434,117,'Thatchur','603306',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40435,117,'Thathalur','603109',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40436,117,'Thimmavaram','603101',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40437,117,'Thozhupedu','603310',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40438,117,'Tirukalikundram Bazaar','603109',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40439,117,'Tirukalikundram','603109',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40440,117,'Tirukatchur','603204',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40441,117,'Tirumani','603111',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40442,117,'Tiruporur','603110',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40443,117,'Tiruvadisoolam','603003',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40444,117,'Tiruvadur','603312',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40445,117,'Tiruvanaikoil','603106',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40446,117,'Unamalai','603306',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40447,117,'Urapakkam','603210',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40448,117,'Vadakadambadi','603104',1,0,'2022-03-03 12:39:53','2022-03-03 12:39:53'),(40449,117,'Vadakkupattu','603204',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40450,117,'Vadamanipakkam','603307',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40451,117,'Valathodu','603107',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40452,117,'Vallam','603003',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40453,117,'Vallipuram','603405',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40454,117,'Vannianallur','603401',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40455,117,'Vanniarpettai','603306',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40456,117,'Vayalur','603102',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40457,117,'Vazhuvadur','603102',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40458,117,'Vedal','603304',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40459,117,'Vedanthangal','603314',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40460,117,'Vedavakkam','603303',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40461,117,'Veeranakunnam','603306',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40462,117,'Veerapuram','603109',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40463,117,'Vellaputhur','603314',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40464,117,'Velur','603401',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40465,117,'Venbedu','603110',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40466,117,'Vengapakkam','603102',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40467,117,'Venkatapuram','603204',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40468,117,'Venpakkam','603111',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40469,117,'Vepancheri','603305',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40470,117,'Vilambur','603304',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40471,117,'Vilanganur','603313',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40472,117,'Villiambakkam','603101',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40473,117,'Vitchur','603106',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40474,117,'Vittalapuram','603102',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40475,117,'Zamin Budur','603302',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40476,117,'Zamin Endathur','603311',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40477,117,'Zamin Paiyanur','603104',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40478,117,'Adambakkam','600088',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40479,117,'Alandur(Reopened W.E.F.6.6.05)','600016',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40480,117,'Chennai Airport','600016',1,0,'2022-03-03 12:39:54','2022-03-03 12:39:54'),(40481,117,'Injambakkam','600115',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40482,117,'Karapakkam','600097',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40483,117,'Madipakkam','600091',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40484,117,'Madipakkam South','600091',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40485,117,'Meenambakkam','600016',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40486,117,'Nandambakkam Kudiyiruppu','600089',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40487,117,'Nanganallur Bazaar','600061',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40488,117,'Nanganallur','600061',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40489,117,'Neelankarai','600041',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40490,117,'Nilamangai Nagar','600088',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40491,117,'Oggiamthoraipakkam','600097',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40492,117,'Palavakkam (Kanchipuram)','600041',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40493,117,'Pazhavanthangal','600061',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40494,117,'Perungudi','600096',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40495,117,'Ramapuram (Kanchipuram)','600089',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40496,117,'Sathyabama University','600119',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40497,117,'Sholinganallur','600119',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40498,117,'St.Thomas Mount H.O','600016',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40499,117,'Agaramduli','603406',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40500,117,'Alisoor','603402',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40501,117,'Arasanimangalam','603402',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40502,117,'Arpakkam','631603',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40503,117,'Asoor','631605',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40504,117,'Athivakkam','601102',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40505,117,'Attuputhur','631561',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40506,117,'Avalur','631605',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40507,117,'Ayyampettai','631601',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40508,117,'Ayyankarkulam','631502',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40509,117,'Balchettychatram','631551',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40510,117,'Big Kanchipuram','631502',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40511,117,'Chellampattidai','631553',1,0,'2022-03-03 12:39:55','2022-03-03 12:39:55'),(40512,117,'Damal','631551',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40513,117,'Echoor','631604',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40514,117,'Edayarpakkam','631553',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40515,117,'Ekanampet','631601',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40516,117,'Ekanapuram','631553',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40517,117,'Elaganar','603402',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40518,117,'Enathur','631561',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40519,117,'Govindavadi','631502',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40520,117,'Gunduperumbedu','602105',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40521,117,'Hanumanthandalam','603402',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40522,117,'Irungattukottai','602117',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40523,117,'Kaliyampoondi','603402',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40524,117,'Kammalampoondi','603406',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40525,117,'Kammavarpalayam','631502',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40526,117,'Kanchipuram Collectorate','631501',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40527,117,'Kanchipuram Cutchery','631501',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40528,117,'Kanchipuram H.O','631501',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40529,117,'Kandoor','602108',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40530,117,'Kannur','602108',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40531,117,'Kappankottur','631553',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40532,117,'Karai','631552',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40533,117,'Karaipettai','631552',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40534,117,'Kavanthandalam','631603',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40535,117,'Kavanur Pudhucheri','603406',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40536,117,'Kilacheri','631402',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40537,117,'Kilakattur','631502',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40538,117,'Kiliyanagar','603406',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40539,117,'Kothakuppam','631202',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40540,117,'Krishnapuram','631551',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40541,117,'Kunnam','631604',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40542,117,'Kuram','631502',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40543,117,'Kuvam','631402',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40544,117,'L.Endathur','603406',1,0,'2022-03-03 12:39:56','2022-03-03 12:39:56'),(40545,117,'Little Kanchipuram','631501',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40546,117,'Madhur','631606',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40547,117,'Maduramangalam','602108',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40548,117,'Magaral','631603',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40549,117,'Malayankulam','631603',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40550,117,'Malliyankaranai','603406',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40551,117,'Mambakkam','602106',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40552,117,'Manampathi','603403',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40553,117,'Manampathikandigai','603403',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40554,117,'Mappedu','631402',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40555,117,'Maruthuvambadi','603406',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40556,117,'Mathur','602105',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40557,117,'Melkadirpur','631502',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40558,117,'Melmaduramangalam','631553',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40559,117,'Musaravakkam','631551',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40560,117,'Muthavedu','631551',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40561,117,'Muthialpet','631601',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40562,117,'Naickenpet','631601',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40563,117,'Narasingapuram','631402',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40564,117,'Nathanallur','631605',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40565,117,'Neyyadupakkam','631603',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40566,117,'Nirvalur','631561',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40567,117,'Olimohamedpet','631502',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40568,117,'Olugarai','631603',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40569,117,'Orikkai','631502',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40570,117,'Padur','631606',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40571,117,'Palayaseevaram','631606',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40572,117,'Pannur (Kanchipuram)','602108',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40573,117,'Panruti','631604',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40574,117,'Parandur','631552',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40575,117,'Pattunoolchatram','602105',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40576,117,'Pennalur','603402',1,0,'2022-03-03 12:39:57','2022-03-03 12:39:57'),(40577,117,'Pennalur','602105',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40578,117,'Perumanallur','631502',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40579,117,'Perunagar','603403',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40580,117,'Pichivakkam','631553',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40581,117,'Pillaipakkam','602105',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40582,117,'Pillayarpalayam','631501',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40583,117,'Pondur','602105',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40584,117,'Puliambakkam','631605',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40585,117,'Pullalur','631553',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40586,117,'Purisai','631553',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40587,117,'Puthali','631603',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40588,117,'R.N.Kandigai','603403',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40589,117,'Rajakulam','631561',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40590,117,'Sankaramutt','631502',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40591,117,'Sendamangalam','602106',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40592,117,'Serkadu','631605',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40593,117,'Sevilimedu','631502',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40594,117,'Singadivakkam','631561',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40595,117,'Sinnivakkam','631604',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40596,117,'Sirukaveripakkam','631502',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40597,117,'Sirungoli','603406',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40598,117,'Siruvakkam','631552',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40599,117,'Siruvallur','631552',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40600,117,'Sriperumbudur','602105',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40601,117,'Sunguvarchatram','602106',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40602,117,'Thammanur','631605',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40603,117,'Thandalam','602105',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40604,117,'Thandarai','603403',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40605,117,'Thenambakkam','631601',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40606,117,'Thenneri','631604',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40607,117,'Thimamsamudram','631502',1,0,'2022-03-03 12:39:58','2022-03-03 12:39:58'),(40608,117,'Thimmarajampettai','631601',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40609,117,'Thirumukkudal','631606',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40610,117,'Thoopul','631501',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40611,117,'Tirukachinambi Street','631501',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40612,117,'Tirupandiyur','602108',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40613,117,'Tirupulivanam','603406',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40614,117,'Tittalam','603406',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40615,117,'Ullavur','631606',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40616,117,'Uttiramerur','603406',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40617,117,'Uttukadu','631605',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40618,117,'Vadanallur','603406',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40619,117,'Vaiyavur','631561',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40620,117,'Valarpuram','602105',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40621,117,'Valathur','631553',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40622,117,'Varanavasi','631604',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40623,117,'Vayalakkavur','631603',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40624,117,'Vayalur','602105',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40625,117,'Vedal','631561',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40626,117,'Veliyur','631502',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40627,117,'Walajabad','631605',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40628,117,'Alapakkam','600116',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40629,117,'Anakaputhur','600070',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40630,117,'Bharathinagar','600117',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40631,117,'Bharathipuram (Kanchipuram)','600044',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40632,117,'Chitlapakkam','600064',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40633,117,'Christian College Tambaram','600059',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40634,117,'Chromepet','600044',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40635,117,'Darkash','600044',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40636,117,'Ganapathipuram(CMT)','600058',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40637,117,'Gerugambakkam','600122',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40638,117,'Gowriwakkam','600073',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40639,117,'Hasthinapuram','600064',1,0,'2022-03-03 12:39:59','2022-03-03 12:39:59'),(40640,117,'Irumbuliyur','600045',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40641,117,'Iyyappanthangal','600056',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40642,117,'Kadaperi','600047',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40643,117,'Kasthuribainagar','600059',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40644,117,'Keelakattalai','600117',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40645,117,'Kelambakkam','603103',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40646,117,'Kolapakkam','600127',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40647,117,'Kolathur','600127',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40648,117,'Kovalam (Kanchipuram)','603112',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40649,117,'Kovilambakkam','600129',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40650,117,'Kunnathur (Kanchipuram)','600069',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40651,117,'Lakshmipuram','600044',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40652,117,'LIC Colony','600059',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40653,117,'Lic Colony Tambaram','600059',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40654,117,'Madambakkam','600126',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40655,117,'Malaipattu','601301',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40656,117,'Mambakkam','600127',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40657,117,'Manapakkam','600125',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40658,117,'Mangadu','600122',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40659,117,'Manimangalam','601301',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40660,117,'Mannivakkam','600048',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40661,117,'Mappedu','600126',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40662,117,'Medavakkam ','600100',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40663,117,'Melakkottaiyur','600127',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40664,117,'MEPZ Tambaram','600045',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40665,117,'Mudichur','600048',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40666,117,'Mugalivakkam','600125',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40667,117,'Muttukadu','603112',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40668,117,'Nagalkeni','600044',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40669,117,'Nallambakkam','600127',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40670,117,'Nandambakkam','600069',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40671,117,'Navalur','600130',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40672,117,'Nehrunagar','600044',1,0,'2022-03-03 12:40:00','2022-03-03 12:40:00'),(40673,117,'Nemilichery','600044',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40674,117,'Old Pallavaram','600117',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40675,117,'Old Perungalathur','600063',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40676,117,'Otteri Extension','600048',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40677,117,'Padappai','601301',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40678,117,'Padur','603103',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40679,117,'Pallavaram','600043',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40680,117,'Pallikaranai','600100',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40681,117,'Pammal East','600075',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40682,117,'Pammal','600075',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40683,117,'Paraniputhur','600122',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40684,117,'Polichalur','600074',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40685,117,'Ponmar','600127',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40686,117,'Porur','600116',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40687,117,'Pudupakkam','603103',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40688,117,'Radhanagar (Kanchipuram)','600044',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40689,117,'Rajajinagar (Kanchipuram)','600043',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40690,117,'Rajakilpakkam','600073',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40691,117,'Selaiyur','600073',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40692,117,'Serpananchery','601301',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40693,117,'Sirukalathur','600069',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40694,117,'Sithalapakkam','600126',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40695,117,'Somangalam','600069',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40696,117,'South Malayambakkam','600069',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40697,117,'Srinivasanagar East','600063',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40698,117,'Srinivasanagar (Kanchipuram)','600063',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40699,117,'Sriramachandra Deemed Uty','600116',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40700,117,'State Bank Colony','600059',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40701,117,'Sundaram Colony','600059',1,0,'2022-03-03 12:40:01','2022-03-03 12:40:01'),(40702,117,'Tambaram East','600059',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40703,117,'Tambaram H.O','600045',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40704,117,'Tambaram IAF','600046',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40705,117,'Tambaram Sanatorium','600047',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40706,117,'Tambaram West','600045',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40707,117,'Thaiyur','603103',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40708,117,'Thandalam','600128',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40709,117,'Thazambur','600130',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40710,117,'Thiruvidanthai','603112',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40711,117,'Tirumudivakkam','600044',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40712,117,'Tiruneermalai','600044',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40713,117,'Tirusulam','600043',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40714,117,'Vandalur','600048',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40715,118,'Adaikkakuzhi','629153',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40716,118,'Agasteeswaram','629701',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40717,118,'Alagiamandapam','629167',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40718,118,'Alampara','629170',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40719,118,'Alanchi','629159',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40720,118,'Alancholai','629101',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40721,118,'Alancode','629802',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40722,118,'Aloor','629801',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40723,118,'Ammandivilai','629204',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40724,118,'Anandanadarkudy','629201',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40725,118,'Andirapuram','629851',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40726,118,'Anducode','629168',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40727,118,'Anjugramam','629401',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40728,118,'Aralvaymoli','629301',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40729,118,'Arukani','629101',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40730,118,'Arumanai','629151',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40731,118,'Arumanallur','629851',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40732,118,'Aruvikkarai','629177',1,0,'2022-03-03 12:40:02','2022-03-03 12:40:02'),(40733,118,'Asaripallam','629201',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40734,118,'Asiramam','629704',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40735,118,'Attur','629177',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40736,118,'Azhakamparai','629252',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40737,118,'Azhakappapuram','629401',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40738,118,'Azhakiapandipuram','629851',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40739,118,'Azhikkal','629202',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40740,118,'Bethelpuram','629803',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40741,118,'Bhoothapandy','629852',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40742,118,'Catherin Booth Hospital','629001',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40743,118,'Chathancode','629153',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40744,118,'Chemparuthivilai','629166',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40745,118,'Chemponvilai','629804',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40746,118,'Chenbagaramanputhur','629301',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40747,118,'Chenkody','629177',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40748,118,'Cherupallur','629161',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40749,118,'Cheruvallur','629152',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40750,118,'Chitharal','629151',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40751,118,'Chittardam Colony','629161',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40752,118,'Chunkankadai','629003',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40753,118,'Colachel Port','629251',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40754,118,'Colachel','629251',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40755,118,'Derisanamcope','629851',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40756,118,'Devakulam','629704',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40757,118,'Eathamozhi','629501',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40758,118,'Edalakudy','629002',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40759,118,'Elavuvilai','629171',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40760,118,'Enayam','629193',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40761,118,'Enayamputhenthurai','629193',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40762,118,'Erachakulam','629901',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40763,118,'Eravipudurkadai','629158',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40764,118,'Eraviputhur','629402',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40765,118,'Erumbukadu','629004',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40766,118,'Fathima Nagar','629160',1,0,'2022-03-03 12:40:03','2022-03-03 12:40:03'),(40767,118,'Friday Market','629203',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40768,118,'Ganapathipuram','629502',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40769,118,'Gnaramvilai','629165',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40770,118,'Idaikkode','629152',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40771,118,'Ilanchirai','629152',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40772,118,'Irenipuram','629162',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40773,118,'Irulappapuram','629002',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40774,118,'Isanthimangalam','629852',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40775,118,'James Town','629401',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40776,118,'Kadiyapattanam','629252',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40777,118,'Kadukkarai','629401',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40778,118,'Kaliakkavilai','629153',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40779,118,'Kaliyal','629101',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40780,118,'Kallankuzhi','629166',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40781,118,'Kallukoottam','629802',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40782,118,'Kalpadi','629204',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40783,118,'Kandanvilai','629810',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40784,118,'Kaniyakulam','629003',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40785,118,'Kanjampuram','629154',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40786,118,'Kanjikuzhi','629169',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40787,118,'Kanjiracode','629155',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40788,118,'Kannanore','629158',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40789,118,'Kannattuvilai','629802',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40790,118,'Kanniyakumari','629702',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40791,118,'Kannumamoodu','629170',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40792,118,'Kappiyarai','629156',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40793,118,'Kappukadu','629162',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40794,118,'Karankad','629809',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40795,118,'Karinkal','629157',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40796,118,'Karod','629151',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40797,118,'Kattathurai','629158',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40798,118,'Kattimancode','629801',1,0,'2022-03-03 12:40:04','2022-03-03 12:40:04'),(40799,118,'Keeriparai','629401',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40800,118,'Keezhkulam','629193',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40801,118,'Keralapuram','629174',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40802,118,'Kesavanputhenthurai','629501',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40803,118,'Killiyoor','629171',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40804,118,'Kirathur','629160',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40805,118,'Kodayarkilthangal','629102',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40806,118,'Kodimunai','629251',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40807,118,'Kollangodu','629160',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40808,118,'Konamkadu','629803',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40809,118,'Kottar','629002',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40810,118,'Kottaram','629703',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40811,118,'Kovalam','629702',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40812,118,'Kozhiporvilai','629167',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40813,118,'Krishnancoil','629001',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40814,118,'Kulapuram','629153',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40815,118,'Kulasekharam','629161',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40816,118,'Kulasekharapuram','629403',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40817,118,'Kumaracoil','629180',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40818,118,'Kumarapuram','629301',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40819,118,'Kumarapuram','629164',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40820,118,'Kumarapuramthoppur','629402',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40821,118,'Kurumpanai','629251',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40822,118,'Kurunthencode','629802',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40823,118,'Kuzhicode','629167',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40824,118,'Kuzhithurai','629163',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40825,118,'Kuzhithurai West','629163',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40826,118,'Leepuram','629702',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40827,118,'Lekshmipuram','629802',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40828,118,'Madathattuvilai','629180',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40829,118,'Madavalayam','629302',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40830,118,'Madichel','629163',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40831,118,'Mahadanapuram','629702',1,0,'2022-03-03 12:40:05','2022-03-03 12:40:05'),(40832,118,'Malamary','629152',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40833,118,'Malayadi','629153',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40834,118,'Manakarai','629180',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40835,118,'Manalikarai','629164',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40836,118,'Manalodai','629161',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40837,118,'Manavalakurichi','629252',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40838,118,'Mancode','629152',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40839,118,'Mangalakunnu','629178',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40840,118,'Mangarai','629157',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40841,118,'Mangavilai','629501',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40842,118,'Maniankuzhi','629161',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40843,118,'Manivilai','629170',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40844,118,'Manjalumoodu','629151',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40845,118,'Maramalai','629851',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40846,118,'Maravankudiyiruppu','629002',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40847,118,'Marthandam Bridge','629165',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40848,118,'Marthandam North','629165',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40849,118,'Marthandam','629165',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40850,118,'Marthandamthurai','629160',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40851,118,'Marungoor','629402',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40852,118,'Maruthemparai','629101',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40853,118,'Maruthencode','629163',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40854,118,'Maruthurkurichi','629158',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40855,118,'Mathiasnagar','629852',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40856,118,'Mayiladi','629403',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40857,118,'Meenachel','629153',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40858,118,'Mekkamandapam','629166',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40859,118,'Mekkode','629804',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40860,118,'Melakrishnanputhur','629601',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40861,118,'Melamanakudy','629602',1,0,'2022-03-03 12:40:06','2022-03-03 12:40:06'),(40862,118,'Meppalai','629152',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40863,118,'Methukummal','629172',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40864,118,'Mettukadai','629175',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40865,118,'Mondaikad','629252',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40866,118,'Monikettipottal','629501',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40867,118,'Moovattumugham','629177',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40868,118,'Mukkampala','629164',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40869,118,'Mulachel','629175',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40870,118,'Mulagumoodu','629167',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40871,118,'Mulankuzhi','629162',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40872,118,'Mullanginavilai','629157',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40873,118,'Munchirai','629171',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40874,118,'Muttom','629202',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40875,118,'Nagercoil Bazaar','629001',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40876,118,'Nagercoil Collectorate','629001',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40877,118,'Nagercoil H.O','629001',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40878,118,'Nagercoil Industrial Estate','629004',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40879,118,'Nagercoil Town','629001',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40880,118,'Nagercoil West','629001',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40881,118,'Nallur','629704',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40882,118,'Nallur-marthandam','629165',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40883,118,'Nattalam','629165',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40884,118,'Nesamony Nagar','629001',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40885,118,'Netta','629101',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40886,118,'Neyyoor','629802',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40887,118,'Neyyoor West','629803',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40888,118,'Nithiravilai','629154',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40889,118,'North Soorankudy','629501',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40890,118,'Oluganacheri','629001',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40891,118,'Pacode','629168',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40892,118,'Padanthalumoodu','629163',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40893,118,'Padmanabhapuram Fort','629175',1,0,'2022-03-03 12:40:07','2022-03-03 12:40:07'),(40894,118,'Painkulam','629173',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40895,118,'Palapalam','629159',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40896,118,'Palavilai','629160',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40897,118,'Palkulam','629851',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40898,118,'Pallam','629601',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40899,118,'Palliyadi','629169',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40900,118,'Palukal','629170',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40901,118,'Parakkai','629601',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40902,118,'Parvathipuram','629003',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40903,118,'Pathukani','629101',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40904,118,'Pazhavilai','629501',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40905,118,'Pechchipparai','629161',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40906,118,'Peruvilai','629003',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40907,118,'Peyankuzhi','629809',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40908,118,'Ponmanai','629161',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40909,118,'Poothurai','629176',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40910,118,'Potraiyadi','629703',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40911,118,'Pottakulam','629401',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40912,118,'Pottetty','629157',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40913,118,'Pozhikkarai','629501',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40914,118,'Pudukadai','629171',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40915,118,'Puliyurkurichi','629175',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40916,118,'Puthalam','629602',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40917,118,'Puthenthurai','629501',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40918,118,'Putheri','629001',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40919,118,'Rajakkamangalam','629502',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40920,118,'Rajakkamangalamthurai','629501',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40921,118,'Ramanthurai','629193',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40922,118,'Ramapuram','629302',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40923,118,'Ramavarmanchirai','629152',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40924,118,'Ratnapuram','629851',1,0,'2022-03-03 12:40:08','2022-03-03 12:40:08'),(40925,118,'Ritapuram','629159',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40926,118,'S.T.Mankad','629172',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40927,118,'Sahayanagar','629159',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40928,118,'Santhaiyadi','629703',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40929,118,'Santhapuram','629201',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40930,118,'Saral Agasteeswaram','629203',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40931,118,'Sasthankcoilvilai','629704',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40932,118,'Sooriacode','629153',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40933,118,'South Soorankudy','629501',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40934,118,'Suchindrum','629704',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40935,118,'Terur','629704',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40936,118,'Thadikarankonam','629851',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40937,118,'Thalakulam','629802',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40938,118,'Thamaraikulam','629704',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40939,118,'Thazhakudy','629901',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40940,118,'Thengamputhur','629602',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40941,118,'Thengapattanam','629173',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40942,118,'Therekalpudur','629901',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40943,118,'Therku Thamaraikulam','629701',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40944,118,'Theruvukadai','629157',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40945,118,'Thickanamcode','629804',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40946,118,'Thickurichy','629168',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40947,118,'Thirupathisaram','629901',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40948,118,'Thiruthuvapuram','629163',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40949,118,'Thiruvarambu','629161',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40950,118,'Thiruvithancode','629174',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40951,118,'Tholayavattai','629157',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40952,118,'Thovalai','629302',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40953,118,'Thuckalay H.O','629175',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40954,118,'Thumbode','629161',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40955,118,'Thuthur','629176',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40956,118,'Tiruparappu','629161',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40957,118,'Tiruvattar','629177',1,0,'2022-03-03 12:40:09','2022-03-03 12:40:09'),(40958,118,'Tittivilai','629852',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40959,118,'Udayamarthandam','629178',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40960,118,'Unnamalakada','629179',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40961,118,'Urambu','629160',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40962,118,'Vadasery','629001',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40963,118,'Vadiveeswaram','629001',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40964,118,'Vallavilai','629160',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40965,118,'Vaniyakudi','629251',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40966,118,'Vanniyur','629163',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40967,118,'Variyoor','629401',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40968,118,'Vazhukkamparai','629704',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40969,118,'Veeyannur','629177',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40970,118,'Velimalai','629164',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40971,118,'Vellachiparai','629152',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40972,118,'Vellamadam','629302',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40973,118,'Vembanur','629801',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40974,118,'Vencode','629171',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40975,118,'Vendalicode','629161',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40976,118,'Verkilambi','629166',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40977,118,'Vetturnimadam','629003',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40978,118,'Villukuri','629180',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40979,118,'Viricode','629165',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40980,118,'Vivekanandapuram','629702',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40981,118,'Vizhunthaiyambalam','629173',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40982,119,'Karvazhi','638151',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40983,119,'Thukkachi','638151',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40984,119,'A.Meenakshivalasu','639207',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40985,119,'Adhanur','621311',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40986,119,'Alamarathupatti','639207',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40987,119,'Alathur (Kulittalai)','621313',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40988,119,'Ammapatti','639203',1,0,'2022-03-03 12:40:10','2022-03-03 12:40:10'),(40989,119,'Andankoil','639008',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(40990,119,'Appipalayam','639003',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(40991,119,'Aravakurichi','639201',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(40992,119,'Ariyur','639111',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(40993,119,'Athipalayam','639111',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(40994,119,'Athur','639008',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(40995,119,'Chellandipatti','639118',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(40996,119,'Chinnadharapuram','639202',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(40997,119,'Chinnakariyampatti','639201',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(40998,119,'Chinnamookkanankuppam','639118',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(40999,119,'Chinnampatti','621311',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(41000,119,'Chinnavangalampalayam','639206',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(41001,119,'Chinniyampalayam','639120',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(41002,119,'Chinthalavadi','639105',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(41003,119,'Chinthamanipatti','621301',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(41004,119,'D.Idayapatti','621311',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(41005,119,'Dalavapalayam','639113',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(41006,119,'East Thavittupalayam','639113',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(41007,119,'Elavanur','639202',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(41008,119,'Emur','639007',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(41009,119,'Gandhigramam','639004',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(41010,119,'Ganesapuram','639107',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(41011,119,'Gudalur','639206',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(41012,119,'Hiranyamangalam','639107',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(41013,119,'Innungur','639110',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(41014,119,'Inunganur','639205',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(41015,119,'Isanatham','639203',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(41016,119,'Jegadabi','639118',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(41017,119,'K.Pitchampatti','639118',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(41018,119,'K.Pudupatti','639105',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(41019,119,'Kadambankurichi','639113',1,0,'2022-03-03 12:40:11','2022-03-03 12:40:11'),(41020,119,'Kadaparai','639006',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41021,119,'Kadavur','621311',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41022,119,'Kagtithapuram','639136',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41023,119,'Kakkavadi','639003',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41024,119,'Kalaiyapatti','621301',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41025,119,'Kalladai','621313',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41026,119,'Kallai','639110',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41027,119,'Kanakkuvelampatti','639201',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41028,119,'Kaniyalampatti','621301',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41029,119,'Karudayampalayam','639111',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41030,119,'Karunellivalasu','639206',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41031,119,'Karuppapillaipudur','639205',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41032,119,'Karuppathur','639105',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41033,119,'Karuppur','639108',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41034,119,'Karur Collectorate','639007',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41035,119,'Karur H.O','639001',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41036,119,'Karur West','639001',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41037,119,'Karuveppanaikenpettai','639105',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41038,119,'Kathalapatti','639007',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41039,119,'Kattalai','639108',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41040,119,'Kattumunnur','639111',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41041,119,'Kavalkaranpatti','621313',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41042,119,'Kazhugur','639120',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41043,119,'Keelaveliyur','621313',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41044,119,'Keeranur','639119',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41045,119,'Kilasakkarakottai','621301',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41046,119,'Kodangipatti','639005',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41047,119,'Kodanthur','639206',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41048,119,'Koonampatti','639206',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41049,119,'Kosur','639120',1,0,'2022-03-03 12:40:12','2022-03-03 12:40:12'),(41050,119,'Kottapatti','639205',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41051,119,'Kovakulam','639102',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41052,119,'Kovilur','639207',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41053,119,'Koyampalli','639114',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41054,119,'Krishnarayapuram','639102',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41055,119,'Kulittalai Bazaar','639104',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41056,119,'Kulittalai H.O','639104',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41057,119,'Kulittalai Periyapalam','639104',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41058,119,'Kunnagoundanpatti','639120',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41059,119,'Kuppachipalayam','639116',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41060,119,'Kuppachipatti','639120',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41061,119,'Kuppam','639111',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41062,119,'Kuppureddipatti','639105',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41063,119,'Kurichi','639110',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41064,119,'Kurikkaranvalasu','639205',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41065,119,'Kurinikulathupatti','621301',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41066,119,'L.N.Samudram','639008',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41067,119,'Lalapet','639105',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41068,119,'Lingamanaickenpatti','639207',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41069,119,'Mahadhanapuram','639102',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41070,119,'Malaikovil','639206',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41071,119,'Manathattai','639104',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41072,119,'Manavadi','639005',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41073,119,'Manavasi','639108',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41074,119,'Manickapuram','639102',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41075,119,'Manjanaickenpatti','621301',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41076,119,'Manjapulipatti','621301',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41077,119,'Manmangalam','639006',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41078,119,'Marudur','639107',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41079,119,'Mathagiri','621313',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41080,119,'Mavathur','621311',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41081,119,'Mayanur','639108',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41082,119,'Melapalayam','639114',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41083,119,'Mettumahadhanapuram','639105',1,0,'2022-03-03 12:40:13','2022-03-03 12:40:13'),(41084,119,'Mettumarudur','639107',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41085,119,'Minnampalli','639116',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41086,119,'Modakkur','639207',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41087,119,'Monjanur','639206',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41088,119,'Mookanankurichi','639005',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41089,119,'Moolapatti','639109',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41090,119,'Moolimangalam','639136',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41091,119,'Mudiganam','639002',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41092,119,'Munayanur','639102',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41093,119,'Munnur','639111',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41094,119,'Mushtakinathupatti','639118',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41095,119,'Muthanampalayam','639206',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41096,119,'Muthurengampatti','639119',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41097,119,'Mylampatti','621301',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41098,119,'Nachalur','639110',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41099,119,'Nadanthai North','639111',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41100,119,'Nadayanur','639117',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41101,119,'Nagampalli','639109',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41102,119,'Naganur','639120',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41103,119,'Nallur','639110',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41104,119,'Nambagoundanur','639201',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41105,119,'Nanjaikalakurichi','639201',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41106,119,'Nanjaipugalur','639113',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41107,119,'Nanniyur','639113',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41108,119,'Nedungur','639111',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41109,119,'Neidalur','639110',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41110,119,'Neidalur South','639110',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41111,119,'Nerur','639004',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41112,119,'Noyyal','639117',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41113,119,'Nungavaram','639110',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41114,119,'P.Udayapatti','639119',1,0,'2022-03-03 12:40:14','2022-03-03 12:40:14'),(41115,119,'Padiripatti','621306',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41116,119,'Paganatham','639005',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41117,119,'Palaiyur','639004',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41118,119,'Palaviduthi','621311',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41119,119,'Palayajeyankondam','639102',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41120,119,'Pallamarudapatti','639002',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41121,119,'Pallapalayam','639002',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41122,119,'Pallapatti Bazaar','639207',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41123,119,'Pallapatti (Karur)','639205',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41124,119,'Panickampatti','639107',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41125,119,'Panjamadevi','639004',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41126,119,'Panjapatti','639119',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41127,119,'Pappakkapatti','639119',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41128,119,'Pappanaickenpatti','639205',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41129,119,'Parali','639107',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41130,119,'Paramathi (Karur)','639111',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41131,119,'Pasupathipalayam','639004',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41132,119,'Pavithram','639002',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41133,119,'Perityamanjuveli','639207',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41134,119,'Periyamathiagudalur','639202',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41135,119,'Periyathirumangalam','639206',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41136,119,'Pethachinagar','639203',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41137,119,'Ponnagoundanur','639207',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41138,119,'Poolampalayam','639008',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41139,119,'Porani','639118',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41140,119,'Porundalur','621313',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41141,119,'Potharavuthanpatti','639119',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41142,119,'Poyyamani','639110',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41143,119,'Pugalur Sugar Factory','639113',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41144,119,'Puliyur','639114',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41145,119,'Puliyur Cement Factory','639114',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41146,119,'Punavasipatti','639105',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41147,119,'Pungambadi','639201',1,0,'2022-03-03 12:40:15','2022-03-03 12:40:15'),(41148,119,'Punjaikalakurichi','639201',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41149,119,'Punjaipugalur','639113',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41150,119,'Punjaithottakurichi','639113',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41151,119,'Punnam','639136',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41152,119,'Punnamchatram','639136',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41153,119,'Puthambur','639003',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41154,119,'Puthur','621313',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41155,119,'Rachandarthirumalai','621313',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41156,119,'Rajapuram','639201',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41157,119,'Rakkampatti','639120',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41158,119,'Ramakrishnapuram','639001',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41159,119,'Rengachipatti','639110',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41160,119,'Rengamalaipudupatti','639205',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41161,119,'Renganathampettai','639004',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41162,119,'Renganathapuram','639108',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41163,119,'Rengapalayam','639202',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41164,119,'S.Vellalapatti','639004',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41165,119,'Sandapadi','639207',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41166,119,'Sathiyamangalam','639120',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41167,119,'Savarimedu','639110',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41168,119,'Sellivalasu','639205',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41169,119,'Semangi','639117',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41170,119,'Sembianatham','621311',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41171,119,'Senapiratti','639004',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41172,119,'Sendamangalam','639205',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41173,119,'Sengal','639102',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41174,119,'Sengunthapuram','639002',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41175,119,'Servaikaranpatti','621315',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41176,119,'Sevapur','621311',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41177,119,'Singampatti','621311',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41178,119,'Sivayam','639120',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41179,119,'Somur','639114',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41180,119,'Sukkaliyur','639003',1,0,'2022-03-03 12:40:16','2022-03-03 12:40:16'),(41181,119,'Tennilai','639206',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41182,119,'Thalapatti','639003',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41183,119,'Thaliyampatti','639120',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41184,119,'Thannirpalli','639107',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41185,119,'Thanthonimalai','639005',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41186,119,'Tharagampatti','621311',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41187,119,'Thogaimalai','621313',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41188,119,'Thokkupattipudur','639202',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41189,119,'Thondamanginam','621313',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41190,119,'Thoranakkalpatti','639003',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41191,119,'Thumbivadi','639002',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41192,119,'Timmachipuram','639105',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41193,119,'Tirukkampuliyur','639102',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41194,119,'Tirumanilaiyur','639003',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41195,119,'Uppidamangalam','639114',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41196,119,'Uttupatti','639202',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41197,119,'Vadaseri','621313',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41198,119,'Vadiyam','639105',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41199,119,'Vaiganallur','639120',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41200,119,'Valayalkaranpudur','639108',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41201,119,'Vangal East','639116',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41202,119,'Vangal','639116',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41203,119,'Varavanai','621301',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41204,119,'Varikkapatti','639109',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41205,119,'Vayalur','639119',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41206,119,'Vedichipalayam','639114',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41207,119,'Veeranampatti','621301',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41208,119,'Veerarakkiam','639114',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41209,119,'Veeriyapalayam','639119',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41210,119,'Velampadi','639205',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41211,119,'Velanchettiyur','639207',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41212,119,'Velayuthampalayam','639117',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41213,119,'Vellapatti Zamin','639119',1,0,'2022-03-03 12:40:17','2022-03-03 12:40:17'),(41214,119,'Velliyanai','639118',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41215,119,'Vengamedu','639006',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41216,119,'Venjamangudalur','639109',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41217,119,'Vennamalai','639006',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41218,119,'Verisinampatti','639207',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41219,119,'Vettamangalam','639117',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41220,119,'Viswanathapuri','639002',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41221,119,'West Orathai','639113',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41222,119,'Zamin Athur','639203',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41223,120,'A.Settipalli','635105',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41224,120,'Achamangalam','635108',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41225,120,'Achettipalli','635110',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41226,120,'Achubala','635118',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41227,120,'Agalakotta','635118',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41228,120,'Agaram','635119',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41229,120,'Agaram','635204',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41230,120,'Agaramittikkal','635122',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41231,120,'Agraharam','635002',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41232,120,'Aikondamkothapalli','635203',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41233,120,'Alapatti','635122',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41234,120,'Amballi','635104',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41235,120,'Anakode','635206',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41236,120,'Anandur','635304',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41237,120,'Anchetty','635102',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41238,120,'Anchoor','635203',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41239,120,'Anderipatti','635306',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41240,120,'Andevanapalli','635107',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41241,120,'Andiyur','635307',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41242,120,'Angampatti','635206',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41243,120,'Ankinayanapalli','635104',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41244,120,'Anniyalam','635107',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41245,120,'Arasakuppam','635107',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41246,120,'Athiganur','635203',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41247,120,'Athimugam','635105',1,0,'2022-03-03 12:40:18','2022-03-03 12:40:18'),(41248,120,'Athipadi','635307',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41249,120,'Avalapalli','635109',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41250,120,'Avathavadi','635204',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41251,120,'Badapalli','635306',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41252,120,'Bagalur (Krishnagiri)','635103',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41253,120,'Bairamangalam','635113',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41254,120,'Balanapalli','635121',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41255,120,'Balanayanapalli','635108',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41256,120,'Balathottanapalli','635107',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41257,120,'Baleguli','635204',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41258,120,'Balethottam','635206',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41259,120,'Baliganapalli','635103',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41260,120,'Baliganur','635116',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41261,120,'Bandarahalli','635123',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41262,120,'Bandaseemanur','635104',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41263,120,'Bannihalli','635106',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41264,120,'Barugur','635104',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41265,120,'Basthi','635109',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41266,120,'Batlapalli','635104',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41267,120,'Beerpalli','635115',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41268,120,'Begepalli','635126',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41269,120,'Belalam','635118',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41270,120,'Belathur','635124',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41271,120,'Belavarthi','635120',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41272,120,'Bellarampalli','635122',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41273,120,'Bennangur','635107',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41274,120,'Berigai','635105',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41275,120,'Bikkanapalli','635107',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41276,120,'Bikkanapalli','635115',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41277,120,'Billanakuppam','635115',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41278,120,'Bimandapalli','635115',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41279,120,'Binnamangalam','635118',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41280,120,'Bodichipalli','635113',1,0,'2022-03-03 12:40:19','2022-03-03 12:40:19'),(41281,120,'Bommathathanur','635113',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41282,120,'Bukkasagaram','635109',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41283,120,'Chaparthi','635106',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41284,120,'Chappadi','635117',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41285,120,'Chembarasanapalli','635117',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41286,120,'Chennapalli','635117',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41287,120,'Chennasandiram','635121',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41288,120,'Chennathur','635109',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41289,120,'Chigaralapalli','635104',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41290,120,'Chigaramaganapalli','635121',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41291,120,'Chinnamattarapalli','635120',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41292,120,'Chinnappareddypalayam','635114',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41293,120,'Chintagampalli','635104',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41294,120,'Chowtahalli','635112',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41295,120,'Damodarahalli','635123',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41296,120,'Dasiripalli','635121',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41297,120,'Denkanikotta','635107',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41298,120,'Devaganapalli','635114',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41299,120,'Devarulimangalam','635107',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41300,120,'Deveerahalli','635123',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41301,120,'Deveerapalli','635103',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41302,120,'Dindal','635111',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41303,120,'Doddabelur','635113',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41304,120,'Doddamanchi','635102',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41305,120,'Doddampat R.S.','635304',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41306,120,'Doddapoovathi','635122',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41307,120,'Doddathimmanahalli','635116',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41308,120,'Doddaubbanur','635118',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41309,120,'Doripalli','635109',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41310,120,'Dowlatabad','635001',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41311,120,'Eggur','635307',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41312,120,'Elathagiri','635108',1,0,'2022-03-03 12:40:20','2022-03-03 12:40:20'),(41313,120,'Emakkalnatham','635104',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41314,120,'Ennegolpudur','635122',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41315,120,'Enusonai','635117',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41316,120,'Errasigalahalli','635106',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41317,120,'Erudukotta','635107',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41318,120,'Ettipatti','635306',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41319,120,'Gangaleri','635122',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41320,120,'Gangojikothur','635121',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41321,120,'Gendiganapalli','635107',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41322,120,'Gopanapalli','635110',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41323,120,'Govindapuram','635307',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41324,120,'Gudisadanapalli','635105',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41325,120,'Gummalapuram','635118',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41326,120,'Gummanur','635116',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41327,120,'Gundalapatti','635101',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41328,120,'Guruvinayanapalli','635120',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41329,120,'Guttahalli','635107',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41330,120,'Haleseebam','635119',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41331,120,'Hosur Cattle Farm','635110',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41332,120,'Hosur East','635109',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41333,120,'Hosur Indl. Complex','635126',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41334,120,'Hosur (Dharmapuri)','635109',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41335,120,'Iruthalam','635113',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41336,120,'Jagadab','635112',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41337,120,'Jagadevi','635203',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41338,120,'Jakkeri','635113',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41339,120,'Javalagiri','635118',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41340,120,'Kakkadasam','635107',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41341,120,'Kalarpathi','635203',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41342,120,'Kalingavaram','635117',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41343,120,'Kallavi','635304',1,0,'2022-03-03 12:40:21','2022-03-03 12:40:21'),(41344,120,'Kallukurukki','635002',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41345,120,'Kalvehalli','635101',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41346,120,'Kamandoddi','635109',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41347,120,'Kammampalli','635120',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41348,120,'Kanakamutulu','635002',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41349,120,'Kandikuppam','635108',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41350,120,'Kannandahalli','635203',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41351,120,'Karadiguri','635002',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41352,120,'Karaikodihalli','635111',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41353,120,'Karapattu','635207',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41354,120,'Karimangalam','635111',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41355,120,'Karupalli','635113',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41356,120,'Kathiripuram','635112',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41357,120,'Kattinayanapalli','635001',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41358,120,'Kavandanur','635203',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41359,120,'Kaveripattinam Bazaar','635112',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41360,120,'Kaveripattinam (Krishnagiri)','635112',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41361,120,'Kelamangalam','635113',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41362,120,'Kethunaickenpatti','635307',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41363,120,'Kodamandapatti','635306',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41364,120,'Kodipalli','635115',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41365,120,'Kondappanayanapalli','635104',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41366,120,'Konegoundanur','635121',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41367,120,'Koneripalli','635117',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41368,120,'Koppakarai','635116',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41369,120,'Kothagondapalli','635109',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41370,120,'Kothalam','635106',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41371,120,'Kothapeta(Hosur)','635109',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41372,120,'Kottaiyur','635102',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41373,120,'Kottur','635121',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41374,120,'Krishnagiri Collectorate','635115',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41375,120,'Krishnagiri Courts','635001',1,0,'2022-03-03 12:40:22','2022-03-03 12:40:22'),(41376,120,'Krishnagiri H.O','635001',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41377,120,'Krishnagiri Indl. Estate','635002',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41378,120,'Krishnagiri Project','635101',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41379,120,'Kullampatti','635203',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41380,120,'Kumbalam','635117',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41381,120,'Kumudepalli','635109',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41382,120,'Kundukottai','635107',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41383,120,'Kundumaranapalli','635113',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41384,120,'Kunnathur','635306',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41385,120,'Kuriyanapalli','635121',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41386,120,'Kurubarahalli','635115',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41387,120,'Kurumpatti','635101',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41388,120,'M.Vellalapatti','635304',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41389,120,'Madepalli','635121',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41390,120,'Madepalli','635104',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41391,120,'Madrahalli','635203',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41392,120,'Maganurpatti','635307',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41393,120,'Mahadevagollahalli','635206',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41394,120,'Maharajakadai','635120',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41395,120,'Malaiyandahalli','635112',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41396,120,'Mallapadi','635104',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41397,120,'Mallinayanapalli','635120',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41398,120,'Manavaranapalli','635121',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41399,120,'Manchukondapalli','635102',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41400,120,'Mannadapatti','635207',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41401,120,'Maradanapalli','635107',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41402,120,'Marampatti','635207',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41403,120,'Marasandiram','635121',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41404,120,'Marichettihalli','635204',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41405,120,'Mariyalam','635102',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41406,120,'Marudepalli','635108',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41407,120,'Maruderi','635204',1,0,'2022-03-03 12:40:23','2022-03-03 12:40:23'),(41408,120,'Marupalli','635118',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41409,120,'Mathagondapalli','635114',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41410,120,'Mathur (Dharmapuri)','635203',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41411,120,'Mekalachinnampalli','635120',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41412,120,'Mittahalli','635112',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41413,120,'Mittapalli','635307',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41414,120,'Mookandapalli','635126',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41415,120,'Moramadugu','635122',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41416,120,'Mottur','635112',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41417,120,'Mottur','635207',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41418,120,'Muduganapalli','635110',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41419,120,'Mudukurukki','635105',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41420,120,'Mugalur','635110',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41421,120,'Mukkulam','635111',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41422,120,'Muthali','635109',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41423,120,'Muthur','635114',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41424,120,'Nadupatti','635307',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41425,120,'Nadupatti','635203',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41426,120,'Nagamangalam','635113',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41427,120,'Nagarasampatti','635204',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41428,120,'Nagondapalli','635110',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41429,120,'Naickanur','635307',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41430,120,'Nakkalpatti','635203',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41431,120,'Nallore','635103',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41432,120,'Nallur','635121',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41433,120,'Nandimangalam','635105',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41434,120,'Naralapalli','635120',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41435,120,'Nedumaruthi','635115',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41436,120,'Nedungal','635112',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41437,120,'Neralagiri','635121',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41438,120,'Nochikuppam','635121',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41439,120,'Nochipatti','635207',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41440,120,'Noganur','635107',1,0,'2022-03-03 12:40:24','2022-03-03 12:40:24'),(41441,120,'Odayandahalli','635116',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41442,120,'Oddapatti','635203',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41443,120,'Onnalvadi','635109',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41444,120,'Oppadavadi','635104',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41445,120,'Orappam','635108',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41446,120,'Pachappanatti','635113',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41447,120,'Padiganalam','635107',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41448,120,'Paiyur','635112',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41449,120,'Panakamutulu','635106',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41450,120,'Panchakshipuram','635110',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41451,120,'Pannandur','635123',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41452,120,'Papparapatti','635123',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41453,120,'Parandapalli','635206',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41454,120,'Pathakota','635119',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41455,120,'Pavakkal','635307',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41456,120,'Peddabelagondapalli','635114',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41457,120,'Peddachigaralapalli','635117',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41458,120,'Peddamelupalli','635002',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41459,120,'Peddanapalli','635002',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41460,120,'Peddathalapalli','635002',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41461,120,'Penneswaramadam','635112',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41462,120,'Perandapalli','635109',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41463,120,'Periyakaradiyur','635206',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41464,120,'Periyakottakulam','635304',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41465,120,'Periyakottapalli','635002',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41466,120,'Periyathallapadi','635307',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41467,120,'Periyathallihalli','635112',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41468,120,'Perugopanapalli','635203',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41469,120,'Pochampalli (Krishnagiri)','635206',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41470,120,'Pothapuram','635112',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41471,120,'Pothinayanapalli','635002',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41472,120,'Puliampatti','635206',1,0,'2022-03-03 12:40:25','2022-03-03 12:40:25'),(41473,120,'Ramapuram (Dharmapuri)','635115',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41474,120,'Royakottah','635116',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41475,120,'Sadanapalli','635108',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41476,120,'Salamarathupatti','635304',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41477,120,'Salivaram','635107',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41478,120,'Samalpatti R.S','635306',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41479,120,'Samanapalli','635117',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41480,120,'Samanthamalai','635115',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41481,120,'Sandanapalli','635107',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41482,120,'Santhur','635206',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41483,120,'Saragapalli','635114',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41484,120,'Sarandapalli','635107',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41485,120,'Sembadamuthur','635122',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41486,120,'Senamavu','635119',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41487,120,'Seshurajapuram','635102',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41488,120,'Sevaganapalli','635103',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41489,120,'Shoolagiri','635117',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41490,120,'Shoolingunta','635118',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41491,120,'Singarapettai','635307',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41492,120,'Sivampatti','635203',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41493,120,'Sulakarai','635304',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41494,120,'Sundekuppam','635101',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41495,120,'Thadigal','635107',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41496,120,'Thagatti','635102',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41497,120,'Thally Kothanur','635118',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41498,120,'Thally','635118',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41499,120,'Thatrahalli','635123',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41500,120,'Thimmapuram','635112',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41501,120,'Thimmarayanahalli','635106',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41502,120,'Thippanapalli','635115',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41503,120,'Thogarapalli','635203',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41504,120,'Thorapalli Agraharam','635109',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41505,120,'Thummanapalli','635105',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41506,120,'Thuppuganapalli','635119',1,0,'2022-03-03 12:40:26','2022-03-03 12:40:26'),(41507,120,'Tiruvanapatti','635304',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41508,120,'Uddanapalli','635119',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41509,120,'Ullukurukki','635113',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41510,120,'Upparapatti','635207',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41511,120,'Urigam','635102',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41512,120,'Uttangarai','635207',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41513,120,'Vadamangalam','635123',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41514,120,'Valipatti','635306',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41515,120,'Varattanapalli','635120',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41516,120,'Velampatti','635204',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41517,120,'Venkatadampatti','635207',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41518,120,'Venkatasamudram','635104',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41519,120,'Venkatesapuram','635109',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41520,120,'Veppanapalli','635121',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41521,120,'Vilangamudi','635204',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41522,120,'Viramalai','635204',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41523,120,'Virupasandiram','635121',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41524,121,'A.Ammapatti','625706',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41525,121,'A.Kokkulam','625514',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41526,121,'A.Pudupatti','625501',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41527,121,'A.Thottiapatti','625704',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41528,121,'A.Vellalapatti','625301',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41529,121,'Achampatti','625706',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41530,121,'Achampatti','625501',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41531,121,'Alagappa Nagar','625003',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41532,121,'Alagapuri','625501',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41533,121,'Alagarkoil','625301',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41534,121,'Alagichipatti','625109',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41535,121,'Alampatti','625706',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41536,121,'Alanganallur','625501',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41537,121,'Alappalacheri','625704',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41538,121,'Ambalakaranpatti','625109',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41539,121,'Anaiyur H.B. Colony','625017',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41540,121,'Anaiyur','625017',1,0,'2022-03-03 12:40:27','2022-03-03 12:40:27'),(41541,121,'Andarkottaram','625020',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41542,121,'Andipatti','625218',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41543,121,'Anna Nagar (Madurai)','625020',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41544,121,'Anuppanadi Housing Board Colon','625009',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41545,121,'Anuppanady','625009',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41546,121,'Appakarai','625704',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41547,121,'Appantiruppathi','625301',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41548,121,'Arasapatti','625706',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41549,121,'Arasaradi H.O','625016',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41550,121,'Arittapatti','625106',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41551,121,'Arukkampatti','625105',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41552,121,'Arumbanur','625104',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41553,121,'Attapatti','625108',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41554,121,'Austinpatti','625008',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41555,121,'Avalsurampatti','625701',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41556,121,'Avanivapuram','625012',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41557,121,'Ayyankottai','625221',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41558,121,'Ayyankuruvithurai','625207',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41559,121,'Ayyapatti','625103',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41560,121,'Ayyur','625501',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41561,121,'Budamangalam','625108',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41562,121,'Buthagudi','625017',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41563,121,'Chatrapatti','625014',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41564,121,'Chatravellalapatti','625503',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41565,121,'Checkanurani','625514',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41566,121,'Chellampatti','625514',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41567,121,'Chettikulam','625514',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41568,121,'Chintamani','625009',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41569,121,'Chitoor','625707',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41570,121,'Chittampatti','625122',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41571,121,'Chockalingapuram','625103',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41572,121,'Deivanayagapuram','625703',1,0,'2022-03-03 12:40:28','2022-03-03 12:40:28'),(41573,121,'Denobli Press','625007',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41574,121,'Ellis Nagar','625016',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41575,121,'Erkudi Achampathu','625019',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41576,121,'Errampatti','625501',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41577,121,'Ettimangalam','625105',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41578,121,'Gandhi Nagar (MA)','625020',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41579,121,'Ganjampatti','625708',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41580,121,'Gnanaolivupuram','625016',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41581,121,'Harveypatti','625005',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41582,121,'Ilamanur','625201',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41583,121,'Irumbadi','625205',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41584,121,'Jaihindpuram','625011',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41585,121,'Jari Usilampatti','625702',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41586,121,'Jayankondanilai','625102',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41587,121,'Jothimanickam','625514',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41588,121,'K.Pudur','625007',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41589,121,'K.Sennampatti','625701',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41590,121,'Kachakatti','625218',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41591,121,'Kachirayanpatti','625101',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41592,121,'Kachirayiruppu','625234',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41593,121,'Kadaneri','625702',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41594,121,'Kadupatti','625207',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41595,121,'Kalimangalam','625020',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41596,121,'Kallampatti','625106',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41597,121,'Kallanai','625501',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41598,121,'Kallandiri','625301',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41599,121,'Kalligudi','625701',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41600,121,'Kalvelipatti','625221',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41601,121,'Kambur','625101',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41602,121,'Kancharampettai','625014',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41603,121,'Kangeyanatham','625706',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41604,121,'Kappalur','625008',1,0,'2022-03-03 12:40:29','2022-03-03 12:40:29'),(41605,121,'Kappalur Indl.Estate','625008',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41606,121,'Karadikal','625706',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41607,121,'Karaikeni','625702',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41608,121,'Karumathur','625514',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41609,121,'Karungalakudi','625101',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41610,121,'Karupatti','625205',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41611,121,'Karuppayurani','625020',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41612,121,'Karuvanur','625014',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41613,121,'Kathakinaru','625107',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41614,121,'Keelamathur','625234',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41615,121,'Keerathurai','625001',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41616,121,'Kesampatti','625105',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41617,121,'Kidaripatti','625301',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41618,121,'Kilaiyur','625106',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41619,121,'Kilakuyilkudi','625019',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41620,121,'Kilavalavu','625102',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41621,121,'Kilavaneri','625704',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41622,121,'Kinnimangalam','625514',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41623,121,'Kochadai','625016',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41624,121,'Kodangipatti','625503',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41625,121,'Kodikulam','625514',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41626,121,'Kodikulam','625104',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41627,121,'Kodimangalam','625234',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41628,121,'Kodukkampatti','625108',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41629,121,'Kondayampatti','625221',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41630,121,'Kongampatti','625102',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41631,121,'Koothiyargundu','625008',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41632,121,'Koovalapuram','625703',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41633,121,'Koppinaickanpatti','625702',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41634,121,'Kottagudi','625106',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41635,121,'Kottampatti','625103',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41636,121,'Kottanathampatti','625109',1,0,'2022-03-03 12:40:30','2022-03-03 12:40:30'),(41637,121,'Kovilangulam','625514',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41638,121,'Krishnapuram Colony','625014',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41639,121,'Kudakoil','625022',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41640,121,'Kulamangalam','625017',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41641,121,'Kulasekarankottai','625218',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41642,121,'Kumaram','625018',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41643,121,'Kunnarampatti','625101',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41644,121,'Kuraiyur','625701',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41645,121,'Kurichipatti','625109',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41646,121,'Kusavangundu','625022',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41647,121,'Kuttimeichanpatti','625501',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41648,121,'Lakshmipuram','625301',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41649,121,'Lalapuram','625707',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41650,121,'M.Pudupatti','625702',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41651,121,'M.Puliyankulam','625707',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41652,121,'M.Subbulapuram','625702',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41653,121,'Ma Munichalai Road','625009',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41654,121,'Ma Periyar Bus Stand','625001',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41655,121,'Ma Race Course','625002',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41656,121,'Ma Rajaji Hospital','625020',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41657,121,'Ma Reserve Lines','625014',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41658,121,'Ma West Masi Street','625001',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41659,121,'Madakkulam','625003',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41660,121,'Madipanur','625704',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41661,121,'Madras High Court Madurai Bench','625023',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41662,121,'Madurai Agricultural College','625104',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41663,121,'Madurai Bazaar','625001',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41664,121,'Madurai Bibikulam','625002',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41665,121,'Madurai Corporation Building','625002',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41666,121,'Madurai Courts','625020',1,0,'2022-03-03 12:40:31','2022-03-03 12:40:31'),(41667,121,'Madurai H.O','625001',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41668,121,'Madurai North','625014',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41669,121,'Madurai Palace','625001',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41670,121,'Madurai Railway Divl Office','625016',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41671,121,'Madurai West','625001',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41672,121,'Malampatti','625102',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41673,121,'Manappachery','625103',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41674,121,'Mangalampatti','625101',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41675,121,'Mangalrevu','625703',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41676,121,'Mangulam','625301',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41677,121,'Mannadimangalam','625207',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41678,121,'Mariammalkulam','625221',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41679,121,'Marudangudi','625701',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41680,121,'Mathur','625301',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41681,121,'Meenambalpuram','625002',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41682,121,'Melakkal','625234',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41683,121,'Melakottai','625706',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41684,121,'Melanachikulam','625205',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41685,121,'Melauppiligundu','625022',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41686,121,'Melavlavu','625105',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41687,121,'Melur East','625106',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41688,121,'Melur (Madurai)','625106',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41689,121,'Melur South','625106',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41690,121,'Mettupatti','625501',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41691,121,'Mudakkuchalai','625016',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41692,121,'Mudalaikulam','625514',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41693,121,'Muduvarpatti','625503',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41694,121,'Mullipallam','625207',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41695,121,'Muthusamypatti','625102',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41696,121,'Nachikulam','625205',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41697,121,'Nadumudalaikulam','625514',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41698,121,'Nagamalai','625019',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41699,121,'Nallamaram','625702',1,0,'2022-03-03 12:40:32','2022-03-03 12:40:32'),(41700,121,'Nallur','625022',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41701,121,'Nariampatti','625207',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41702,121,'Narimedu','625002',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41703,121,'Narsingampatti','625122',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41704,121,'Nattarmangalam','625101',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41705,121,'Navinipatti','625106',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41706,121,'Nedungulam','625706',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41707,121,'Nilaiyur','625005',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41708,121,'Odaipatti','625701',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41709,121,'Othakadai','625107',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41710,121,'Othakoilpatti','625101',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41711,121,'P.Thottiapatti','625703',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41712,121,'Palamedu','625503',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41713,121,'Palanganatham','625003',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41714,121,'Palkalai Nagar','625021',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41715,121,'Pallapatti','625103',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41716,121,'Panaiyur','625009',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41717,121,'Pandangudi','625103',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41718,121,'Pandian Nagar','625006',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41719,121,'Pandiarajapuram','625218',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41720,121,'Pappanaickenpatti','625708',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41721,121,'Pappayapuram','625703',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41722,121,'Paravai','625402',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41723,121,'Pasumalai','625004',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41724,121,'Pathinettangudi','625106',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41725,121,'Pattur','625105',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41726,121,'Peraiyur (Madurai)','625703',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41727,121,'Periyapoolampatti','625703',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41728,121,'Perungudi','625022',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41729,121,'Petchiamman Paditurai','625001',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41730,121,'Podumbu','625018',1,0,'2022-03-03 12:40:33','2022-03-03 12:40:33'),(41731,121,'Ponmeni','625016',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41732,121,'Ponnamangalam','625706',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41733,121,'Poonjuthi','625110',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41734,121,'Poosaripatti','625122',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41735,121,'Postal Training Centre','625022',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41736,121,'Pottapatti','625103',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41737,121,'Pudunagar','625706',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41738,121,'Pudur Bazaar','625007',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41739,121,'Pudusukkampatti','625106',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41740,121,'Puduthamaraipatti','625107',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41741,121,'Puliankulam','625201',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41742,121,'Pulipatti','625301',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41743,121,'Pulluthu','625019',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41744,121,'Rajakkur','625107',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41745,121,'Royapalayam','625706',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41746,121,'Royapuram','625234',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41747,121,'S.N.College','625022',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41748,121,'S.P.Natham','625706',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41749,121,'Sakkarappanaickanur','625207',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41750,121,'Sakkimangalam','625201',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41751,121,'Sakkudi','625020',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41752,121,'Samanatham','625009',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41753,121,'Samayanallur','625402',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41754,121,'Sandaiyur','625703',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41755,121,'Saruguvalayapatti','625109',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41756,121,'Sathangudi','625706',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41757,121,'Sekkipatti','625101',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41758,121,'Sellur (Madurai)','625002',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41759,121,'Sendamangalam','625503',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41760,121,'Sengapadai','625704',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41761,121,'Sennagarampatti','625105',1,0,'2022-03-03 12:40:34','2022-03-03 12:40:34'),(41762,121,'Sevarakottai','625706',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41763,121,'Shanthi Nagar','625018',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41764,121,'Sholavandan Bazaar','625214',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41765,121,'Sholavandan','625214',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41766,121,'Silaiman','625201',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41767,121,'Silamalaipatti','625703',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41768,121,'Silarpatti','625702',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41769,121,'Simmakkal','625001',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41770,121,'Siruvalai','625402',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41771,121,'Sithalai','625706',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41772,121,'Sithalangudi','625221',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41773,121,'Sithireddipatti','625704',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41774,121,'Sivanandanagar','625008',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41775,121,'Sokkampatti','625103',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41776,121,'Sokkikulam','625002',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41777,121,'Solaipatti','625708',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41778,121,'Solanguruni','625022',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41779,121,'South Gate','625001',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41780,121,'Sowdarpatti','625704',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41781,121,'Ss Colony','625016',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41782,121,'Subramaniapuram (Madurai)','625011',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41783,121,'Suragundu','625106',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41784,121,'Surapatti','625103',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41785,121,'Surveyor Colony','625007',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41786,121,'T.Kallupatti','625702',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41787,121,'T.Kokkulam','625022',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41788,121,'T.Kunnathur','625708',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41789,121,'T.Pudupatti','625704',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41790,121,'T.Vellalapatti','625122',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41791,121,'Tallakulam H.O','625002',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41792,121,'Tallakulam Housing Board Colon','625020',1,0,'2022-03-03 12:40:35','2022-03-03 12:40:35'),(41793,121,'Tettur','625503',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41794,121,'Thanakkankulam','625006',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41795,121,'Thangalacheri','625706',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41796,121,'Thanichiyam','625221',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41797,121,'Thaniyamangalam','625109',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41798,121,'Thathaneri','625018',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41799,121,'Thenkarai','625207',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41800,121,'Thenpalanji','625021',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41801,121,'Thenur','625402',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41802,121,'Therkilamur','625110',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41803,121,'Therkutheru','625122',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41804,121,'Thiagarajar College','625009',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41805,121,'Thiagarajar Engg College','625015',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41806,121,'Thiruparankundram','625005',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41807,121,'Thiruvalavayanallur','625221',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41808,121,'Thodaneri','625402',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41809,121,'Thonthilingapuram','625103',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41810,121,'Thoppur','625008',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41811,121,'Thumbaipatti','625108',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41812,121,'Thuvariman','625019',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41813,121,'Tirali','625706',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41814,121,'Tirumal','625022',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41815,121,'Tirumalpuram','625014',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41816,121,'Tirumangalam','625706',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41817,121,'Tirumangalam South','625706',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41818,121,'Tirumoghur','625107',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41819,121,'Tirunagar','625006',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41820,121,'Tiruppalai','625014',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41821,121,'Tiruvadur','625110',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41822,121,'Tiruvedagam','625234',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41823,121,'Tiruvedagam West','625234',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41824,121,'Town Hall Road','625001',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41825,121,'Tvs Nagar','625003',1,0,'2022-03-03 12:40:36','2022-03-03 12:40:36'),(41826,121,'Uranganpatti','625109',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41827,121,'Urappanur','625706',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41828,121,'Uthangudi','625107',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41829,121,'Vadakkampatti','625701',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41830,121,'Vadapalanji','625021',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41831,121,'Vadipatti','625218',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41832,121,'Vadivelkarai','625019',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41833,121,'Vagaikulam','625706',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41834,121,'Vagaikulam','625017',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41835,121,'Valaicheripatti','625103',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41836,121,'Valasai','625501',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41837,121,'Valayankulam','625022',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41838,121,'Valayapatti','625022',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41839,121,'Vandiyur','625020',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41840,121,'Vanjinagaram','625101',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41841,121,'Vannivelampatti','625702',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41842,121,'Varichiyur','625020',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41843,121,'Vavidaimaruthur','625501',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41844,121,'Vayalur','625402',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41845,121,'Veeraperumalpuram','625706',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41846,121,'Velambur','625702',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41847,121,'Velichanatham','625014',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41848,121,'Vellakulam','625701',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41849,121,'Vellalur','625109',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41850,121,'Vellaripatti','625122',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41851,121,'Vellayampatti','625503',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41852,121,'Vidathakulam','625706',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41853,121,'Vikramangalam','625207',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41854,121,'Vilacheri','625006',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41855,121,'Vilakkuthoon','625001',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41856,121,'Vilangudi','625018',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41857,121,'Villapuram','625012',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41858,121,'Villur','625707',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41859,121,'Viradhanur','625009',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41860,121,'Viraganur','625009',1,0,'2022-03-03 12:40:37','2022-03-03 12:40:37'),(41861,121,'Virattipathu','625016',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41862,121,'Visalakshi Nagar','625018',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41863,121,'Vowalthottam','625104',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41864,121,'Yanaikkal','625001',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41865,121,'Allikundam','625527',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41866,121,'Ariyapatti','625532',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41867,121,'Athikaripatti','625527',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41868,121,'Athipatti','625705',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41869,121,'Ayyanarkulam','625537',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41870,121,'Boothipuram','625532',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41871,121,'Doddappanayakanur','625532',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41872,121,'E.Kottapatty','625535',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41873,121,'Eravarpatti','625537',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41874,121,'Erumarpatti','625527',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41875,121,'Jothilnayakanur','625535',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41876,121,'Kalappanpatti','625529',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41877,121,'Kalluthu','625537',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41878,121,'Kattathevanpatti','625529',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41879,121,'Kethuvarpatti','625705',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41880,121,'Kuduseri','625705',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41881,121,'Kuppalnatham','625527',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41882,121,'Kuravagudi','625537',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41883,121,'M.Kallupatti','625535',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41884,121,'Mallapuram','625535',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41885,121,'Manuthu','625527',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41886,121,'Meikilarpatti','625532',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41887,121,'Nakkalapatti','625532',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41888,121,'Nattamangalam','625532',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41889,121,'Palaiyur','625705',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41890,121,'Pappapatti','625537',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41891,121,'Perungamanallur','625527',1,0,'2022-03-03 12:40:38','2022-03-03 12:40:38'),(41892,121,'Poosalapuram','625527',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41893,121,'Poruppumettupatti','625529',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41894,121,'Pothampati','625532',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41895,121,'S.Kottaipatti','625527',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41896,121,'Saptur','625705',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41897,121,'Sedapatti','625527',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41898,121,'Seelnayakanpatti','625535',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41899,121,'Sembarani','625527',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41900,121,'Sindhupatti','625529',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41901,121,'Sulapuram','625535',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41902,121,'T.Krishnapuram','625705',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41903,121,'T.Ramanathapuram','625535',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41904,121,'T.Uchapatti','625529',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41905,121,'Thadayampatti','625535',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41906,121,'Thimmanatham','625537',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41907,121,'Thummagundu','625529',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41908,121,'Tidiyan','625529',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41909,121,'Tirumanickam','625535',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41910,121,'Usilampatti Pettai','625532',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41911,121,'Usilampatti','625532',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41912,121,'Uthappanayakanur','625537',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41913,121,'Uthapuram','625535',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41914,121,'Vadugapatti','625532',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41915,121,'Vagurani','625532',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41916,121,'Valandur','625532',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41917,121,'Vandapuli','625705',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41918,121,'Vandari','625705',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41919,121,'Vellamalaipatti','625537',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41920,121,'Veppampatti','625705',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41921,121,'Veppanuthu','625529',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41922,121,'Yelumalai','625535',1,0,'2022-03-03 12:40:39','2022-03-03 12:40:39'),(41923,122,'Alangudi','609801',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41924,122,'Anniyur','612201',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41925,122,'Athur','609204',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41926,122,'Edakiam','609805',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41927,122,'Eravancheri','609501',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41928,122,'Gangadarapuram','609805',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41929,122,'Kali','609811',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41930,122,'Kanjivoy','612203',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41931,122,'Komal','609805',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41932,122,'Konerirajapuram','612201',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41933,122,'Kozhaiyur','609805',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41934,122,'Kuttalam East','609801',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41935,122,'Kuttalam','609801',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41936,122,'Madirimangalam','609801',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41937,122,'Mallapuram','612201',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41938,122,'Malliyam','609806',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41939,122,'Mandai','612203',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41940,122,'Maraiyur','609806',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41941,122,'Marathurai','609204',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41942,122,'Moovalur','609806',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41943,122,'Nakkampadi','612203',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41944,122,'Namasivayapuram','609811',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41945,122,'Narasinganpettai','609802',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41946,122,'Palaiyur','612203',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41947,122,'Palayagudalur','609801',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41948,122,'Pandanallur','609807',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41949,122,'Paravakkarai','612201',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41950,122,'Suraikkayur','612203',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41951,122,'Terizhandur','609808',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41952,122,'Thuhili','609804',1,0,'2022-03-03 12:40:40','2022-03-03 12:40:40'),(41953,122,'Tiruchitrambalam','609204',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41954,122,'Tirumananjeri','609801',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41955,122,'Tirumangalakudi','612102',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41956,122,'Tirumangalam','609811',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41957,122,'Tirumeniarkoil','609204',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41958,122,'Tiruvalangadu','609810',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41959,122,'Tiruvavaduthurai','609803',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41960,122,'Tiruvidavasal','613702',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41961,122,'Vanathirajapuram','609806',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41962,122,'Vayalur','612201',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41963,122,'Villiyanallur','609801',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41964,122,'A. Kiliyanur','609403',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41965,122,'Achalpuram','609101',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41966,122,'Akkur (Nagapattinam)','609301',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41967,122,'Alakkudi','609101',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41968,122,'Alaveli','609118',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41969,122,'Ambal','609503',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41970,122,'Anaikaranchatram','609102',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41971,122,'Anaikaranchatram South','609102',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41972,122,'Anandatandavapuram','609103',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41973,122,'Annamperumalkoil','609109',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41974,122,'Arangakudi','609302',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41975,122,'Arapallam','609101',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41976,122,'Arappakkam','609111',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41977,122,'Arulmozhithevan','609203',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41978,122,'Arupathy','609309',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41979,122,'Aruvapadi','609203',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41980,122,'Athukudi','609117',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41981,122,'Ayappadi','609303',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41982,122,'Buthanur','609312',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41983,122,'Chandrapadi','609307',1,0,'2022-03-03 12:40:41','2022-03-03 12:40:41'),(41984,122,'Chittarkadu','609003',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(41985,122,'Dharmapuram','609001',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(41986,122,'Edamanal','609115',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(41987,122,'Eduthukatti','609312',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(41988,122,'Elandangudi','609401',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(41989,122,'Elathur','609116',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(41990,122,'Elayalur','609302',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(41991,122,'Erukkattanchery','609307',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(41992,122,'Erukkur','609108',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(41993,122,'Gopalasamudram','609108',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(41994,122,'Hanumanthapuram','609102',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(41995,122,'Idaikudi-vadapathy','609117',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(41996,122,'Ilanthope','609201',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(41997,122,'Iluppur','609308',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(41998,122,'Kadavasal','609104',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(41999,122,'Kalahasthinapuram','609309',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(42000,122,'Kalamanallur','609301',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(42001,122,'Kaliyappanallur','609307',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(42002,122,'Kalukkanimuttam','609203',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(42003,122,'Kanganamputhur','609203',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(42004,122,'Kanjanagaram','609304',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(42005,122,'Kannukiniyanar Koil','609104',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(42006,122,'Karaimedu','609109',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(42007,122,'Karkoil','609112',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(42008,122,'Karuvazhakarai','609304',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(42009,122,'Kattiyaniruppu','609109',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(42010,122,'Kattuchery','609303',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(42011,122,'Kaveripattinam Beach','609105',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(42012,122,'Kaveripattinam (Nagapattinam)','609105',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(42013,122,'Keelamaruthandanallur','609103',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(42014,122,'Keeranallur','609115',1,0,'2022-03-03 12:40:42','2022-03-03 12:40:42'),(42015,122,'Kidarankondan','609304',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42016,122,'Kilaiyur','609304',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42017,122,'Kilaperumpallam','609107',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42018,122,'Kilasattanathapuram','609106',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42019,122,'Kiliyanur (Nagapattinam)','609402',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42020,122,'Kilmathur','609116',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42021,122,'Kiloy','609202',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42022,122,'Kodakkaramoolai','609101',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42023,122,'Kodangudi','609314',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42024,122,'Koilthirukolakkal','609111',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42025,122,'Kondathur','609117',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42026,122,'Koolaiyar','609113',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42027,122,'Koranad','609001',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42028,122,'Koranad South','609003',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42029,122,'Korukkai','609203',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42030,122,'Kothandapuram','609101',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42031,122,'Kovilpathu','609111',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42032,122,'Kunnam','609108',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42033,122,'Madanam','609104',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42034,122,'Madervelur','609102',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42035,122,'Mahendrapalli','609101',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42036,122,'Mamakudi','609301',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42037,122,'Manakudi','609118',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42038,122,'Manalmedu East','609202',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42039,122,'Manalmedu','609202',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42040,122,'Mangamadam','609106',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42041,122,'Manganallur','609404',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42042,122,'Manganallur Bazaar','609404',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42043,122,'Manickapangu','609313',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42044,122,'Manigramam','609114',1,0,'2022-03-03 12:40:43','2022-03-03 12:40:43'),(42045,122,'Mannampandal','609305',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42046,122,'Mannipallam','609112',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42047,122,'Mappadugai','609003',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42048,122,'Maruthampallam','609301',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42049,122,'Mathur','609301',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42050,122,'Mayiladuthurai Bazaar','609001',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42051,122,'Mayiladuthurai Cutchery','609001',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42052,122,'Mayiladuthurai H.O','609001',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42053,122,'Mayiladuthurai North','609001',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42054,122,'Mayiladuthurai R.S','609003',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42055,122,'Mayiladuthurai South','609001',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42056,122,'Mayiladuthurai West','609003',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42057,122,'Melaiyur TVG','609107',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42058,122,'Melapathi','609304',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42059,122,'Melaperumpallam','609107',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42060,122,'Memathur','609309',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42061,122,'Molaiyur','609118',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42062,122,'Mudikondanallur','609202',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42063,122,'Mudikondanallur','609309',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42064,122,'Muthur','609302',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42065,122,'Nalladai','609306',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42066,122,'Nallanayagapuram','609102',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42067,122,'Nallathukudi','609001',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42068,122,'Nalluchery','609308',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42069,122,'Nangur','609106',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42070,122,'Natarajapillai Chavadi','609107',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42071,122,'Neidavasal','609105',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42072,122,'Neipathur','609106',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42073,122,'Nemmeli(SRK)','609116',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42074,122,'Nidur','609203',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42075,122,'Pachaiperumal Nallur','609104',1,0,'2022-03-03 12:40:44','2022-03-03 12:40:44'),(42076,122,'Pagasalai','609117',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42077,122,'Palayapalayam','609101',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42078,122,'Palayar','609101',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42079,122,'Pandur','609203',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42080,122,'Parasalur','609309',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42081,122,'Pattamangalam','609001',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42082,122,'Pattavilagam','609116',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42083,122,'Perambur (AKC)','609108',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42084,122,'Perambur','609402',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42085,122,'Peruncheri','609404',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42086,122,'Perunthottam','609106',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42087,122,'Porayar Market','609307',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42088,122,'Porayar R.S.','609307',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42089,122,'Porayar','609307',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42090,122,'Pudupattinam','609101',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42091,122,'Puduthurai','609106',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42092,122,'Pulavanur','609205',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42093,122,'Puliyanthurai','609101',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42094,122,'Punganur','609117',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42095,122,'Puthur (SRK)','609108',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42096,122,'Radhanallur  (SRK)','609115',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42097,122,'Radhanallur (TVG)','609114',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42098,122,'Sankaranpandal','609308',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42099,122,'Sattanathapuram','609109',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42100,122,'Seithur Srk','609112',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42101,122,'Sembadaniruppu','609109',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42102,122,'Sembanarkoil','609309',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42103,122,'Semmangudi(SRK)','609104',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42104,122,'Sendamangalam','609310',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42105,122,'Sholampettai','609003',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42106,122,'Siddamalli','609205',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42107,122,'Sirkali East','609111',1,0,'2022-03-03 12:40:45','2022-03-03 12:40:45'),(42108,122,'Sirkali H.O','609110',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42109,122,'Sirkali Thenpathi','609111',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42110,122,'Sirkali West','609111',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42111,122,'Sodiyakudi','609108',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42112,122,'Solasakkaranallur','609118',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42113,122,'Talachangadu','609107',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42114,122,'Talanayar Vsk','609201',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42115,122,'Tarangambadi','609313',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42116,122,'Thandavankulam','609101',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42117,122,'Thennampattinam','609106',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42118,122,'Tillaiyadi','609310',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42119,122,'Tirucadaiyur','609311',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42120,122,'Tiruchempalli','609309',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42121,122,'Tirukkalachery','609312',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42122,122,'Tirumailadi','609108',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42123,122,'Tirumeignanam','609311',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42124,122,'Tirumullaivasal','609113',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42125,122,'Tirunagari','609106',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42126,122,'Tirunandriyur','609118',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42127,122,'Tirupungur','609112',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42128,122,'Tiruvalaputhur','609205',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42129,122,'Tiruvali','609109',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42130,122,'Tiruvengadu','609114',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42131,122,'Tiruvidaikali','609310',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42132,122,'Tiruvilandur','609001',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42133,122,'Tiruvilayattam','609306',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42134,122,'Tittai (SRK)','609111',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42135,122,'Umayalpathi','609104',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42136,122,'Umayalpuram','609301',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42137,122,'Vadakarai (Nagapattinam)','609314',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42138,122,'Vaithiswarankoil','609117',1,0,'2022-03-03 12:40:46','2022-03-03 12:40:46'),(42139,122,'Vaithiswarankoil West','609117',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42140,122,'Vallalagaram','609118',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42141,122,'Valluvakudi','609116',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42142,122,'Valuvur','609401',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42143,122,'Vanagiri','609105',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42144,122,'Varisapathu Vadagal','609115',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42145,122,'Velampudukudi','609306',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42146,122,'Vettangudi','609115',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42147,122,'Vilanthida Samudram','609111',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42148,122,'Villiyanallur','609203',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42149,122,'Agara Kondagai','609703',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42150,122,'Akkaraipettai','611106',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42151,122,'Alangudichery','609703',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42152,122,'Alathur','609604',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42153,122,'Aliyur','611104',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42154,122,'Andakudi','610106',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42155,122,'Andanapettai','611102',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42156,122,'Athipuliyur','611105',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42157,122,'Avaranipuducherri','611108',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42158,122,'Aymazhai','611102',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42159,122,'Chinnathumbur','611102',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42160,122,'Durgashariff','611002',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42161,122,'Enangudi','609701',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42162,122,'Eravancherry','611105',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42163,122,'Erayangudi','611109',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42164,122,'Ervadi','609702',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42165,122,'Ettukudi','610204',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42166,122,'Gopurajapuram','609703',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42167,122,'Iluppur','611105',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42168,122,'Kakkalani','611101',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42169,122,'Kameswaram','611110',1,0,'2022-03-03 12:40:47','2022-03-03 12:40:47'),(42170,122,'Kangalanchery','610101',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42171,122,'Karaiyur','610101',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42172,122,'Karapidagai','611110',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42173,122,'Karunkanni','611103',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42174,122,'Kilaiyur (Tiruvarur)','611103',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42175,122,'Kilathanilapadi','611109',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42176,122,'Kilathanjavur','610101',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42177,122,'Killukudi','611109',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42178,122,'Kilvelur Bazar','611104',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42179,122,'Kilvelur','611104',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42180,122,'Kohur','611104',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42181,122,'Koilkannapur','610207',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42182,122,'Koilpathu','611112',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42183,122,'Kolapadu','610207',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42184,122,'Koorathangudi','610207',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42185,122,'Kottarakudi','610101',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42186,122,'Kurukathi','611105',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42187,122,'Kuthur','611105',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42188,122,'Madapuram','611103',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42189,122,'Manjakollai','611106',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42190,122,'Marungur','609702',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42191,122,'Melavanjore','611002',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42192,122,'Melavazhakarai','610204',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42193,122,'Mohanur','611109',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42194,122,'Mutharasapuram','610201',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42195,122,'Muttam','611002',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42196,122,'Nagapattinam Bazaar','611001',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42197,122,'Nagapattinam Collectorate','611003',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42198,122,'Nagapattinam H.O','611001',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42199,122,'Nagore','611002',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42200,122,'Nagore South','611002',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42201,122,'Naluvedapathy','611112',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42202,122,'Narimanam','611002',1,0,'2022-03-03 12:40:48','2022-03-03 12:40:48'),(42203,122,'Nirthanamangalam','611102',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42204,122,'Okkur','611002',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42205,122,'Orathur','611108',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42206,122,'P.Kondagai','609703',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42207,122,'Pakkamkottur','609701',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42208,122,'Palaiyur','611106',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42209,122,'Palakurichi','611109',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42210,122,'Palpannaichery','611003',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42211,122,'Panangudi','611002',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42212,122,'Papakoil','611102',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42213,122,'Pattamangalam','611104',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42214,122,'Perunkadambanur','611108',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42215,122,'Pillali','609704',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42216,122,'Polagam','609702',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42217,122,'Poravacherry','611108',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42218,122,'Pragramam','609703',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42219,122,'Prathabaramapuram','611111',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42220,122,'Pudupalli','611112',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42221,122,'Puliyur','611108',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42222,122,'Radhamangalam','611109',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42223,122,'Sannanallur','609504',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42224,122,'Seeyathamangai','609702',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42225,122,'Sembianmahadevi','611109',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42226,122,'Sengamangalam','611108',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42227,122,'Serudur','611111',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42228,122,'Serunallur','611105',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42229,122,'Seshamoolai','609702',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42230,122,'Sigar','610106',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42231,122,'Sikkal (Nagapattinam)','611108',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42232,122,'Sithaimur','610203',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42233,122,'Solavidyapuram','611103',1,0,'2022-03-03 12:40:49','2022-03-03 12:40:49'),(42234,122,'Suramangalam','610201',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42235,122,'Terkupanaiyur','610207',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42236,122,'Terkupoigainallur','611111',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42237,122,'Thevur (Nagapattinam)','611109',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42238,122,'Tiruchenkattangudi','609704',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42239,122,'Tirukannangudi','611104',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42240,122,'Tirukannapuram','609704',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42241,122,'Tirukuvalai','610204',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42242,122,'Tirumarugal','609702',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42243,122,'Tirupayathangudi','610101',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42244,122,'Tirupugalur','609704',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42245,122,'Tirupundi','611110',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42246,122,'Tirupundi South','611110',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42247,122,'Tiruvoimur','610204',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42248,122,'Tittachery','609703',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42249,122,'Vadagarai','609701',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42250,122,'Vadakkupoigainallur','611106',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42251,122,'Vadugachery','611109',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42252,122,'Vailankanni','611111',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42253,122,'Vailankanni West','611111',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42254,122,'Valivalam','610207',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42255,122,'Velippalayam','611001',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42256,122,'Vellapallam','611112',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42257,122,'Venmanachery','611103',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42258,122,'Vettaikaraniruppu','611112',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42259,122,'Vilundamavadi','611112',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42260,122,'Virkudi','610101',1,0,'2022-03-03 12:40:50','2022-03-03 12:40:50'),(42261,122,'Adanur','614707',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42262,122,'Agasthiampalli','614810',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42263,122,'Annapettai','614714',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42264,122,'Arkattuthurai','614809',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42265,122,'Arunthavambulam','614711',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42266,122,'Avarikadu','614806',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42267,122,'Ayakkarambalam I Sethi','614707',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42268,122,'Ayakkarambalam Ii Sethi','614707',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42269,122,'Ayakkarambalam III Sethi','614707',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42270,122,'Aymoor','614711',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42271,122,'Chettipulam','614806',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42272,122,'Kadinavayal','614707',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42273,122,'Kallimodu','614809',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42274,122,'Kariyapattinam R.S','614806',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42275,122,'Kariyapattinam','614806',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42276,122,'Karuppanpulam','614707',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42277,122,'Katripulam','614808',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42278,122,'Kodiakkadu','614807',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42279,122,'Kodiakkarai','614807',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42280,122,'Kuruvapulam','614808',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42281,122,'Manakudi','614712',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42282,122,'Maracheri','614711',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42283,122,'Maraignanallur','614810',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42284,122,'Marudur Therkusethi','614714',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42285,122,'Marudur Vadakku Sethi','614714',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42286,122,'Nagakudaiyan','614808',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42287,122,'Nathapallam','614711',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42288,122,'Neermulai','614711',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42289,122,'Neivilakku','614808',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42290,122,'Panayadikuthagai','614808',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42291,122,'Panchanathikulam','614714',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42292,122,'Panchanathikulam East','614714',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42293,122,'Panchanathikulam Nadu Sethi','614714',1,0,'2022-03-03 12:40:51','2022-03-03 12:40:51'),(42294,122,'Pannal','614707',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42295,122,'Periyakuthagai','614809',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42296,122,'Pirandiankarai','614806',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42297,122,'Pirinjimulai','614712',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42298,122,'Pushpavanam','614809',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42299,122,'Rajapuram','614806',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42300,122,'Sembodai','614809',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42301,122,'Senbagarayanallur','614806',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42302,122,'Takattur','614714',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42303,122,'Talanayar Agraharam','614712',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42304,122,'Talanayar III Sethi','614712',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42305,122,'Talanayar IV Sethi','614712',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42306,122,'Thalaikadu','614711',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42307,122,'Thanikottagam','614716',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42308,122,'Thennampulam','614806',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42309,122,'Thethakudi Therkusethi','614809',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42310,122,'Thethakudivadakkusethi','614809',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42311,122,'Thulajapattinam','614714',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42312,122,'Thulasapuram','614711',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42313,122,'Topputhurai','614809',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42314,122,'Umbalacheri','614711',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42315,122,'Uvoimedu','614714',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42316,122,'Vadamalaimanakadu','614716',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42317,122,'Vadugur','614712',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42318,122,'Vanduvancheri','614714',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42319,122,'Vedaraniam','614810',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42320,122,'Yadhavapuram','614809',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42321,123,'Kokkarayanpettai','638007',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42322,123,'Pallipalayam','638006',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42323,123,'Pappampalayam','638007',1,0,'2022-03-03 12:40:52','2022-03-03 12:40:52'),(42324,123,'A.Erayamangalam','637210',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42325,123,'Adukkam','637411',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42326,123,'Agaram','637202',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42327,123,'Akkalampatti','637212',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42328,123,'Akkammapettai','637301',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42329,123,'Akkaraipatti','637503',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42330,123,'Akkiampatti','637409',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42331,123,'Alachampalayam','637101',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42332,123,'Alampalayam','638008',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42333,123,'Alampatti','637020',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42334,123,'Alanganatham','637013',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42335,123,'Alathurnadu','637411',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42336,123,'Anangur','637304',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42337,123,'Andapuram','637020',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42338,123,'Andipalayam','637214',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42339,123,'Anichampalayam','638182',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42340,123,'Animoor','637214',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42341,123,'Aniyapuram','637017',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42342,123,'Arasanatham','637020',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42343,123,'Ariyur','637015',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42344,123,'Ariyurkashpa','637411',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42345,123,'Ariyurnadu','637411',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42346,123,'Arur','637020',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42347,123,'Avalnaickenpatti','637019',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42348,123,'Avanasipatti','637202',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42349,123,'Bailnadu','637411',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42350,123,'Belukurichi','637402',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42351,123,'Bodinaickenpatti','637405',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42352,123,'Bodinaickenpatti','637105',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42353,123,'Bodupatti','637003',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42354,123,'Bommampatti','637212',1,0,'2022-03-03 12:40:53','2022-03-03 12:40:53'),(42355,123,'Bommasamudram','637002',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42356,123,'Chettipatti','637101',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42357,123,'Chidambarapatti','637405',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42358,123,'Chinandipalayam','637103',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42359,123,'Chinnamanali','637410',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42360,123,'Chinnathambipalayam','637209',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42361,123,'Chittalandur','637201',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42362,123,'Chittoornadu','637411',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42363,123,'Dadhadripuram','637018',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42364,123,'Devanankurichi','637209',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42365,123,'Devanurnadu','637411',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42366,123,'Devarayapuram','637021',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42367,123,'E Pudupatti','637018',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42368,123,'Edappulinadu','637411',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42369,123,'Elachipalayam','637202',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42370,123,'Elanagar','637212',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42371,123,'Elandakuttai','638008',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42372,123,'Elayampalayam','637205',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42373,123,'Elur','637018',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42374,123,'Emapalli','637214',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42375,123,'Erampatti','637013',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42376,123,'Eranapuram','637003',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42377,123,'Gandhiashram','637201',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42378,123,'Gandhipuram','637409',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42379,123,'Ganesapuram','637002',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42380,123,'Gunduninadu','637411',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42381,123,'Gundurnadu','637411',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42382,123,'Iluppili','637202',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42383,123,'Irukkur','637204',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42384,123,'Iruppali','637101',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42385,123,'Jedarpalayam','637213',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42386,123,'K.Ayyampalayam','637213',1,0,'2022-03-03 12:40:54','2022-03-03 12:40:54'),(42387,123,'K.Pudupalayam','637017',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42388,123,'K.Vadugapatti','637102',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42389,123,'Kadachanallur','638008',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42390,123,'Kadappalli','637019',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42391,123,'Kailasampalayam','637209',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42392,123,'Kalangani','637014',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42393,123,'Kalappanaickenpatti','637404',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42394,123,'Kaliyanur','638008',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42395,123,'Kalkurichi','637402',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42396,123,'Kallankattuvalasu','638183',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42397,123,'Kalyanni','637018',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42398,123,'Kandampalayam','637203',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42399,123,'Kannurpatti','637014',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42400,123,'Kapilamalai','637204',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42401,123,'Karadipatti','637019',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42402,123,'Karaikurichi (Namakkal)','637014',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42403,123,'Karichipalayam','637201',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42404,123,'Karumanur','637503',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42405,123,'Karungalpatti','637410',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42406,123,'Karuveppampatti','637304',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42407,123,'Kasthuripatti','637302',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42408,123,'Kavakarapatti','637013',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42409,123,'Kavandampatti','637018',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42410,123,'Kavundampalayam','637210',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42411,123,'Kavundipalayam','637203',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42412,123,'Keerambur','637207',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42413,123,'Kilapalayam','637202',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42414,123,'Kilsathampur','637207',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42415,123,'Kodurmitta','637212',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42416,123,'Kokkalai','637410',1,0,'2022-03-03 12:40:55','2022-03-03 12:40:55'),(42417,123,'Kolakattupudur','637208',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42418,123,'Kolankondai','637503',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42419,123,'Kolaram','637201',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42420,123,'Kolathupalayam','637019',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42421,123,'Komarapalayam East','638183',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42422,123,'Komarapalayam','638183',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42423,123,'Konangipatti','637013',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42424,123,'Kondalam','637208',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42425,123,'Kondamanaickenpatti','637405',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42426,123,'Kondarasampalayam','637203',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42427,123,'Koneripatti','637107',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42428,123,'Konganapuram','637102',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42429,123,'Konnaiyar','637202',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42430,123,'Konur','637207',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42431,123,'Koodachery','637206',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42432,123,'Koothampalayam','637102',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42433,123,'Koothampoondi','637202',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42434,123,'Koottapalli','637214',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42435,123,'Koranampatti','637102',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42436,123,'Kosavampalayam','637201',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42437,123,'Kothamangalam','637213',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42438,123,'Kottapalayam','637503',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42439,123,'Kozhikalnatham','637302',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42440,123,'Kuchi Palayam','637215',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42441,123,'Kulivalavu','637411',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42442,123,'Kullampatti','637101',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42443,123,'Kullanaickenpalayam','638183',1,0,'2022-03-03 12:40:56','2022-03-03 12:40:56'),(42444,123,'Kumaramangalam','637205',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42445,123,'Kumarapalayam','637209',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42446,123,'Kumaripalyam','637015',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42447,123,'Kunnamalai','637203',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42448,123,'Kuppandapalayam','637205',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42449,123,'Kuppanur','637301',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42450,123,'Kuppuchipalayam','638182',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42451,123,'Kurukkapatti','637101',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42452,123,'Kurumbalamahadevi','637213',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42453,123,'L.Kanavaipatti','637002',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42454,123,'Laddivadi','637002',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42455,123,'M.Rasampalayam','637207',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42456,123,'Mac Donalds Choultry','637103',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42457,123,'Malaveepankuttai','637404',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42458,123,'Mallasamudram','637503',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42459,123,'Mamundi','637503',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42460,123,'Manappalli','637017',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42461,123,'Manathi','637212',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42462,123,'Maniyanur','637201',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42463,123,'Marurpatti','637019',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42464,123,'Mavelipalayam','637301',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42465,123,'Mavureddipatti','637212',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42466,123,'Mekkinikadu','637411',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42467,123,'Melkalingampatti','637411',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42468,123,'Melsathampur','637206',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42469,123,'Mettankadu','637104',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42470,123,'Mettupatti','637020',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42471,123,'Minnampalli','637019',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42472,123,'Modamangalam','637304',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42473,123,'Mohanur North','637015',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42474,123,'Mohanur','637015',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42475,123,'Molasi','637210',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42476,123,'Molippalli','637201',1,0,'2022-03-03 12:40:57','2022-03-03 12:40:57'),(42477,123,'Morangam','637410',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42478,123,'Morasapatti','637101',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42479,123,'Mothaiyanur','637303',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42480,123,'Mudalaipatti','637003',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42481,123,'Musiri','637018',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42482,123,'Muthugapati','637405',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42483,123,'Muttanchetti','637013',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42484,123,'N.Kosavampatti','637002',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42485,123,'N.Pudupatti','637020',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42486,123,'N.Seerappali','637206',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42487,123,'Nadandai','637206',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42488,123,'Nadukombai','637404',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42489,123,'Nagichettipatti','637302',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42490,123,'Nallakumarampalayam','637212',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42491,123,'Nallipalayam','637003',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42492,123,'Namakkal Bazaar','637001',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42493,123,'Namakkal Fort','637001',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42494,123,'Namakkal H.O','637001',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42495,123,'Nanjai Edaiyar','638182',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42496,123,'Natarajanagar','638183',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42497,123,'Natarajapuram (Namakkal)','637001',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42498,123,'Navakkadu','637411',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42499,123,'Navaladipatti','637021',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42500,123,'Navanipallipatti','637018',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42501,123,'O.Rajapalayam','637209',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42502,123,'Okkilipaltti','637107',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42503,123,'Oruvandur','637015',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42504,123,'Pachal','637018',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42505,123,'Pachudaiyampattipudur','637409',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42506,123,'Padaiveedu','637303',1,0,'2022-03-03 12:40:58','2022-03-03 12:40:58'),(42507,123,'Palamedu','637503',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42508,123,'Palapatti','637017',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42509,123,'Palayapalayam','637405',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42510,123,'Pallakkapalayam','637303',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42511,123,'Pallipalayamagraharam','638008',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42512,123,'Pappinaickenpatti','637003',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42513,123,'Parali','637020',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42514,123,'Paramathi','637207',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42515,123,'Paruthipalli','637503',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42516,123,'Patlur','637210',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42517,123,'Pattathaiyankuttai','637404',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42518,123,'Paundamangalam','637208',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42519,123,'Pavithiram','637021',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42520,123,'Pavthirampudur','637021',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42521,123,'Perakarainadu','637411',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42522,123,'Periamanali','637410',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42523,123,'Periyakovilur','637411',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42524,123,'Periyapatti','637002',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42525,123,'Periyasolipalayam','637204',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42526,123,'Pettapalayam','637015',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42527,123,'Pilikkalpalayam','637213',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42528,123,'Pillanatham','637205',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42529,123,'Pillur','637206',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42530,123,'Pirandagam','637212',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42531,123,'Ponneri','637013',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42532,123,'Poolampatti','637107',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42533,123,'Pothanur','638181',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42534,123,'Pottanam','637409',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42535,123,'Pottireddipatti','637013',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42536,123,'Puduchatram','637018',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42537,123,'Pudukottai','637013',1,0,'2022-03-03 12:40:59','2022-03-03 12:40:59'),(42538,123,'Pullagoundampatti','637104',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42539,123,'Pullagoundampatti','637202',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42540,123,'Punjaiedayarkilmugam','638182',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42541,123,'Ramadevam','637203',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42542,123,'Ramanathapuram','637409',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42543,123,'Ramapuram','637202',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42544,123,'Ramapuram Pudur','637001',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42545,123,'Rangampalayam','637102',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42546,123,'Reddipatti','637102',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42547,123,'Reddipatti','637002',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42548,123,'Reddipudur','637014',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42549,123,'S.Uduppam','637019',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42550,123,'S.Valavanthi','637017',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42551,123,'Samayasangiliagraharam','638008',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42552,123,'Samiyampalayam','638183',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42553,123,'Sankari West','637303',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42554,123,'Sankaridrug RS','637302',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42555,123,'Sanniyasikaradu','637002',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42556,123,'Santhaipettaipudur','637001',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42557,123,'Sathinaickenpalayam','637205',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42558,123,'Seerampalayam','638008',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42559,123,'Seetharamapalayam','637209',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42560,123,'Sellappampatti','637019',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42561,123,'Selur','637208',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42562,123,'Selurnadu','637411',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42563,123,'Semmedu','637411',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42564,123,'Sendamangalam','637409',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42565,123,'Serukkalai','637212',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42566,123,'Sevetturanganpatti','637015',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42567,123,'Siluvampatti','637003',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42568,123,'Sirumolasi','637209',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42569,123,'Sirunallikoil','637213',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42570,123,'Sithampoondi','637203',1,0,'2022-03-03 12:41:00','2022-03-03 12:41:00'),(42571,123,'Solakkadu','637411',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42572,123,'Solasiramani','637210',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42573,123,'Sowdapuram','638008',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42574,123,'Sullipalayam','637203',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42575,123,'Sultanpet','638182',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42576,123,'Sundakattupatti','637411',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42577,123,'Sundamettupudur','637102',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42578,123,'Sungakaranpatti','637206',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42579,123,'Suriyampalayam','637209',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42580,123,'Talambadi','637019',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42581,123,'Thaligai','637212',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42582,123,'Thanneerpandalpalayam','637304',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42583,123,'Thathaiyangarpatti','637014',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42584,123,'Thethukadu','637404',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42585,123,'Thevur (Namakkal)','637104',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42586,123,'Thidumal','637204',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42587,123,'Thillaipuram','637001',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42588,123,'Thindamangalam','637207',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42589,123,'Thinnanurnadu','637411',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42590,123,'Thiruppulinadu','637411',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42591,123,'Thokkavadi','637215',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42592,123,'Tholur','637017',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42593,123,'Thottiaptti','637410',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42594,123,'Thummankurichi','637003',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42595,123,'Thusur','637002',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42596,123,'Thuthikulam','637404',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42597,123,'Thuthipalayam','637503',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42598,123,'Thuvarapallam','637411',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42599,123,'Tiruchengodu H.O','637211',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42600,123,'Tiruchengodu North','637211',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42601,123,'Tiruchengodu South','637211',1,0,'2022-03-03 12:41:01','2022-03-03 12:41:01'),(42602,123,'Tirumalaipatti','637404',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42603,123,'Unjanai','637205',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42604,123,'Unjanaigoundampalayam','637205',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42605,123,'Unjapalayam','638182',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42606,123,'Uppupalayam','637201',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42607,123,'Vadakaraiatur','637213',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42608,123,'Vadavathur','637013',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42609,123,'Vadugapalayam','637503',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42610,123,'Vaiappamalai','637410',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42611,123,'Valapurnadu','637411',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42612,123,'Valavanthikombai','637404',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42613,123,'Valavanthinadu','637411',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42614,123,'Valayakaranur','638183',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42615,123,'Valayapatti (Namakkal)','637020',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42616,123,'Vallipuram','637003',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42617,123,'Varadarajapuram','637013',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42618,123,'Varagur','637021',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42619,123,'Vasanthapuram','637002',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42620,123,'Vattur','637205',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42621,123,'Veeraganurpatti','637411',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42622,123,'Veeranampalayam','638181',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42623,123,'Veerappampalayam','637105',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42624,123,'Velagoundampatti','637212',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42625,123,'Vellaiyampalayam','637103',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42626,123,'Vellandivalasai','637105',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42627,123,'Vellarinaickenpalayam','637101',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42628,123,'Velur (Namakkal)','638182',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42629,123,'Velur Bazaar SL','638182',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42630,123,'Vengarai','637208',1,0,'2022-03-03 12:41:02','2022-03-03 12:41:02'),(42631,123,'Vengipalayam','637304',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42632,123,'Veppanpattibudur','637018',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42633,123,'Vettamvbadi','637405',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42634,123,'Villipalayam','637207',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42635,123,'Visanam','637405',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42636,123,'Zamin Elampalli','637210',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42637,123,'Mullukurichi','636142',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42638,123,'Naraikinar','636118',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42639,123,'Periyakombai','636113',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42640,123,'Unanthangal','636142',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42641,123,'85 R.Komarapalayam','637403',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42642,123,'Agraharam','637403',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42643,123,'Alavaipatti','637505',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42644,123,'Anaipalayam','637401',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42645,123,'Andagalur','637401',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42646,123,'Ariyagoundampatti','637406',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42647,123,'Attanur','636301',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42648,123,'Ayilpatti','636202',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42649,123,'Bodinaickenpatti','637412',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42650,123,'Chandrasekarapuram','637401',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42651,123,'Eswaramurthipalayam','636202',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42652,123,'Gurusamipalayam','637403',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42653,123,'Kadiranallur','637412',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42654,123,'Kakkaveri','637408',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42655,123,'Kalkattanur','637505',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42656,123,'Kammalapatti','636202',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42657,123,'Karkudalpatti','636202',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42658,123,'Kattanachampatti','637408',1,0,'2022-03-03 12:41:03','2022-03-03 12:41:03'),(42659,123,'Kattur','636202',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42660,123,'Kavundampalayam','637408',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42661,123,'Kullamanaickenpatti','637412',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42662,123,'Kunavelampatti','637401',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42663,123,'Kurukkupuram','637401',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42664,123,'Malayampatti','637407',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42665,123,'Mangalapuram','636202',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42666,123,'Masakalipatti','637401',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42667,123,'Mathuruttu','636202',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42668,123,'Melkallupalayam','637403',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42669,123,'Melur','637407',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42670,123,'Minnakkal Agraharam','637505',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42671,123,'Moolapallipatti','637406',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42672,123,'Munjanur','637403',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42673,123,'Muthukalipatti','637401',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42674,123,'Namagiripettai','637406',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42675,123,'Oduvankurichi','637406',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42676,123,'Olaipatti Sowdapuram','637505',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42677,123,'P.Muniappampalayam','637407',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42678,123,'Pachudayampalayam','637406',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42679,123,'Palaniappanur','637412',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42680,123,'Palanthinnipatti','637505',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42681,123,'Pattanam','637408',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42682,123,'Pillanallur','637403',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42683,123,'Pudupalayam','637408',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42684,123,'Rasipuram Bazaar','637408',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42685,123,'Rasipuram East','637408',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42686,123,'Rasipuram','637408',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42687,123,'Sappayapuram','637505',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42688,123,'Sarkar Nattamangalam','637403',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42689,123,'Singalandapuram','637412',1,0,'2022-03-03 12:41:04','2022-03-03 12:41:04'),(42690,123,'Singiliankombai','636202',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42691,123,'Sirapalli','637406',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42692,123,'T.Jedarpalayam','637406',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42693,123,'Thandagoundanpalayam','636202',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42694,123,'Thengalpalayam','636301',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42695,123,'Thimmanaickenpatti','636202',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42696,123,'Thirumanur','636202',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42697,123,'Thoppapatti','637406',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42698,123,'Thottivalasu','636301',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42699,123,'Vadugam','637407',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42700,123,'Vadugam Muniappampalayam','637407',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42701,123,'Vellakkalpatti','637406',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42702,123,'Vennandur','637505',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42703,123,'Veppilaipatti','636202',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42704,123,'Seventhipatti','621215',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42705,124,'Adderly','643102',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42706,124,'Ambalamoola','643240',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42707,124,'Anikorai','643206',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42708,124,'Aracode','643216',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42709,124,'Araihatty','643221',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42710,124,'Aravenu','643201',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42711,124,'Aruvankadu','643202',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42712,124,'Athigaratti','643203',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42713,124,'Athikunna','643241',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42714,124,'Athipalli','643212',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42715,124,'Avalanchi Power House','643209',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42716,124,'Balacola','643203',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42717,124,'Bellevue','643224',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42718,124,'Bengalmattam','643204',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42719,124,'Berhatti','643231',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42720,124,'Bickatti','643209',1,0,'2022-03-03 12:41:05','2022-03-03 12:41:05'),(42721,124,'Billicombai','643214',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42722,124,'Bitherkad','643240',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42723,124,'Burliar','643102',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42724,124,'Chamraj Estate','643204',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42725,124,'Charing Cross','643001',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42726,124,'Cherambadi','643205',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42727,124,'Cherambadi Tea Division','643220',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42728,124,'Cherangode','643220',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42729,124,'Cherumulli','643211',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42730,124,'Chinna Coonoor','643206',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42731,124,'Choondi','643211',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42732,124,'Coonoor Bazaar','643102',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42733,124,'Coonoor H.O','643101',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42734,124,'Coonoor RS','643102',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42735,124,'Defence Service Staff College','643231',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42736,124,'Denaducombai','643206',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42737,124,'Devala','643212',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42738,124,'Devarshola','643207',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42739,124,'Dhavani','643007',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42740,124,'Doddabetta','643002',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42741,124,'Doddacombai','643219',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42742,124,'Donnington','643217',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42743,124,'Down Hills','643217',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42744,124,'Dr. Basuviah Nagar','643007',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42745,124,'Dunsandle','643005',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42746,124,'Ebbanad','643206',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42747,124,'Emerald','643209',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42748,124,'Farm Tea Estate','643217',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42749,124,'Fernhill','643004',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42750,124,'Finger Post','643006',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42751,124,'Glenmorgan','643237',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42752,124,'Glenvans','643226',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42753,124,'Gudalur Bazaar','643212',1,0,'2022-03-03 12:41:06','2022-03-03 12:41:06'),(42754,124,'Gudalur Nilgiris','643211',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42755,124,'Gundada','643217',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42756,124,'Gurrency','643102',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42757,124,'Halakkarai','643103',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42758,124,'Hettakal','643236',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42759,124,'Hillgrove','643102',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42760,124,'Hubbathalai','643202',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42761,124,'Hulical','643102',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42762,124,'Hullathi','643007',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42763,124,'Iduhatti','643002',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42764,124,'Indunagar','643005',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42765,124,'Ithalar','643004',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42766,124,'Jegathala','643202',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42767,124,'Kadanad','643206',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42768,124,'Kadinamalai','643216',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42769,124,'Kagguchi','643214',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42770,124,'Kaikatti','643217',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42771,124,'Kalhatti','643005',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42772,124,'Kannerimukku','643217',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42773,124,'Kargudi','643211',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42774,124,'Kariashola','643225',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42775,124,'Karumbalam','643102',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42776,124,'Katary  R.S.','643102',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42777,124,'Katary Dam','643213',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42778,124,'Katary','643213',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42779,124,'Kattabettu','643214',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42780,124,'Kayyunni','643205',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42781,124,'Kengarai','643236',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42782,124,'Kenthorai','643002',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42783,124,'Ketti Palada','643215',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42784,124,'Ketti','643215',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42785,124,'Kil Kotagiri Bazaar','643216',1,0,'2022-03-03 12:41:07','2022-03-03 12:41:07'),(42786,124,'Kil Kotagiri','643216',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42787,124,'Kil Kundah','643219',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42788,124,'Kilinjada','643213',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42789,124,'Kinnakorai','643219',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42790,124,'Kodanad','643217',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42791,124,'Koderi','643213',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42792,124,'Kokkal','643005',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42793,124,'Kolapalli','643253',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42794,124,'Kollimalai Oranalli','643215',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42795,124,'Konavakorai','643217',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42796,124,'Konnachal','643239',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42797,124,'Korakundah','643219',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42798,124,'Kotada Estate','643236',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42799,124,'Kotagiri Bazaar','643217',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42800,124,'Kotagiri','643217',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42801,124,'Kukalthorai','643217',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42802,124,'Kullakamby','643218',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42803,124,'Kundah Bridge','643219',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42804,124,'Kunjapanai','643242',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42805,124,'Kunnalady','643241',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42806,124,'Kuruthukuli','643004',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42807,124,'Lauriston','643211',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42808,124,'Lovedale','643003',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42809,124,'M.Palada','643004',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42810,124,'Machikolli','643211',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42811,124,'Mangorange','643220',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42812,124,'Manihatti','643003',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42813,124,'Manjacombai Bazaar','643221',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42814,124,'Manjoor','643219',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42815,124,'Marthoma Nagar','643211',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42816,124,'Masakkal','643217',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42817,124,'Masinagudi','643223',1,0,'2022-03-03 12:41:08','2022-03-03 12:41:08'),(42818,124,'Mavanahalla','643223',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42819,124,'Mayfield','643207',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42820,124,'Melur Nilgiris','643221',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42821,124,'Milidane','643217',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42822,124,'Moyarcamp','643223',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42823,124,'Mudugula','643003',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42824,124,'Mudumalai Sanctuary','643211',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42825,124,'Mulligoor','643209',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42826,124,'Mullikorai','643004',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42827,124,'Munnanad GDS','643239',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42828,124,'Muthorai','643004',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42829,124,'Nadugani','643211',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42830,124,'Naduvattam','643224',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42831,124,'Nandhatti','643212',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42832,124,'Nanjanad','643004',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42833,124,'Nedugula','643217',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42834,124,'Nellakotta','643225',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42835,124,'Newhope','643226',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42836,124,'Nihung','643217',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42837,124,'Nonsuch','643238',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42838,124,'Nunthala','643003',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42839,124,'Ottupattarai','643105',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42840,124,'Padanthorai','643211',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42841,124,'Pandalur','643233',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42842,124,'Parsons Valley','643004',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42843,124,'Pasteur Institute','643103',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42844,124,'Pattavayal','643240',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42845,124,'Pegumbahalla Camp','643219',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42846,124,'Periashola','643228',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42847,124,'Pilloormattam','643238',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42848,124,'Prospect','643224',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42849,124,'Puliampara','643212',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42850,124,'Pykaradam','643237',1,0,'2022-03-03 12:41:09','2022-03-03 12:41:09'),(42851,124,'Rockwood Estate','643225',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42852,124,'Sandynallah','643237',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42853,124,'Seaforth','643228',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42854,124,'Shanthur','643215',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42855,124,'Sholur','643005',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42856,124,'Singara','643223',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42857,124,'Sogathorai','643102',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42858,124,'Sree Madurai','643212',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42859,124,'St Josephs College','643102',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42860,124,'St Marys Hill','643001',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42861,124,'Stone House Hill','643002',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42862,124,'T Mynalai','643002',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42863,124,'T R Bazaar','643224',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42864,124,'T.Manihatti','643214',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42865,124,'Thalakundah','643005',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42866,124,'Thangadu Oranali','643003',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42867,124,'Thiashoa','643219',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42868,124,'Thoraihatty','643206',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42869,124,'Thorapalli','643211',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42870,124,'Thummanatti','643002',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42871,124,'Thuneri','643002',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42872,124,'Thuthurmattam','643218',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42873,124,'Tuttapallam','643242',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42874,124,'Udagamandalam H.O','643001',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42875,124,'Udagamandalam Market','643001',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42876,124,'Udagamandalam Race Course','643001',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42877,124,'Uppatti','643241',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42878,124,'Vannarpet','643102',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42879,124,'Welbeck Estate','643003',1,0,'2022-03-03 12:41:10','2022-03-03 12:41:10'),(42880,124,'Wellington Bazaar','643231',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42881,124,'Wellington','643231',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42882,124,'Yedakadu','643209',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42883,124,'Yedappalli','643103',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42884,124,'Yellamalai','643228',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42885,124,'Yellanhalli','643243',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42886,125,'A.Mettur','621103',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42887,125,'Adaikkampatti','621118',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42888,125,'Adhanur','621708',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42889,125,'Agaramsigur','621108',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42890,125,'Alambadi','621107',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42891,125,'Alathur Gate','621109',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42892,125,'Ammapalayam','621101',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42893,125,'Andikurumbalur','621717',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42894,125,'Annamangalam','621102',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42895,125,'Anukkur','621219',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42896,125,'Aranarai','621212',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42897,125,'Arasalur','621102',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42898,125,'Arumbavur','621103',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42899,125,'Asoor','621708',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42900,125,'Athiyur','621108',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42901,125,'Ayikudi','621115',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42902,125,'Ayilur','621113',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42903,125,'Bommanapadi','621104',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42904,125,'Brammadesam','621115',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42905,125,'C.Mavilingai','621104',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42906,125,'Chathiramanai','621104',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42907,125,'Chettikulam','621104',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42908,125,'Elambalur','621212',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42909,125,'Elumur','621115',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42910,125,'Eraiyur','621113',1,0,'2022-03-03 12:41:11','2022-03-03 12:41:11'),(42911,125,'Eraiyur (Perambalur)','621133',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42912,125,'Fathimapuram','621115',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42913,125,'Garudamangalam','621106',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42914,125,'Ilandaikuli','621708',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42915,125,'Kadambur','621110',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42916,125,'Kadur','621716',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42917,125,'Kaikalathur','621117',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42918,125,'Kalarampatti','621101',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42919,125,'Kalpadi','621113',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42920,125,'Kannapadi','621114',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42921,125,'Karai','621109',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42922,125,'Karianur','621117',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42923,125,'Kilakanavai','621104',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42924,125,'Kilaperambalur','621716',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42925,125,'Kilapuliyur','621115',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42926,125,'Kilumathur','621717',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42927,125,'Kolakkanatham','621106',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42928,125,'Kolathur','621106',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42929,125,'Koneripalayam','621212',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42930,125,'Krishnapuram','621116',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42931,125,'Kunnam (Perambalur)','621708',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42932,125,'Kurumbalur','621107',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42933,125,'Kurumbapalayam','621708',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42934,125,'Labbaikudikadu','621108',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42935,125,'Ladapuram','621101',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42936,125,'Madanagopalapuram','621212',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42937,125,'Maruvathur-ariyalur','621708',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42938,125,'Melamathur','621708',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42939,125,'Melapuliyur','621101',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42940,125,'Moongilpadi','621708',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42941,125,'Murukkankudi','621133',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42942,125,'Nakkasalem','621118',1,0,'2022-03-03 12:41:12','2022-03-03 12:41:12'),(42943,125,'Nallarikkai','621716',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42944,125,'Namangunam','621716',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42945,125,'Nannai','621717',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42946,125,'Nattarmangalam','621104',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42947,125,'Neikuppai','621116',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42948,125,'Nerkunam','621117',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42949,125,'Nochiam','621212',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42950,125,'Nuthapur','621117',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42951,125,'Odhiyam','621708',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42952,125,'Ogalur','621108',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42953,125,'Olaipadi','621717',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42954,125,'Ootathur','621109',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42955,125,'P.Mettupalayam','621115',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42956,125,'Padalur','621109',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42957,125,'Palayam','621107',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42958,125,'Panampatti','621103',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42959,125,'Pandagapadi','621117',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42960,125,'Paravai','621717',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42961,125,'Pasumbalur','621117',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42962,125,'Pennakonam','621108',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42963,125,'Peraiyur','621117',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42964,125,'Perali','621708',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42965,125,'Perambalur Collectorate','621212',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42966,125,'Perambalur H.O','621212',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42967,125,'Periyammapalayam','621110',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42968,125,'Perumathur','621717',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42969,125,'Pillankulam','621117',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42970,125,'Pimbalur','621117',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42971,125,'Puduammapalayam','621118',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42972,125,'Pudunaduvalur','621212',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42973,125,'Puduvettakudi','621716',1,0,'2022-03-03 12:41:13','2022-03-03 12:41:13'),(42974,125,'Ranjankudi','621115',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(42975,125,'S.Aduthurai','621108',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(42976,125,'Sathanur','621106',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(42977,125,'Seedevimangalam','621109',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(42978,125,'Sengonam','621220',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(42979,125,'Senjeri','621107',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(42980,125,'Siruganpur','621113',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(42981,125,'Sirukudal','621115',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(42982,125,'Sirumathur','621133',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(42983,125,'Siruvachur','621113',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(42984,125,'Siruvayalur','621118',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(42985,125,'Sithali','621708',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(42986,125,'T.Kalathur','621114',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(42987,125,'Tenur','621114',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(42988,125,'Thaluthalai','621103',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(42989,125,'Therani','621109',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(42990,125,'Thevaiyur','621115',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(42991,125,'Thirumanthurai','621108',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(42992,125,'Thiruvalandurai','621117',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(42993,125,'Thondamandurai','621103',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(42994,125,'Thondapadi','621116',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(42995,125,'Thoramangalam','621220',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(42996,125,'Tirupayar','621107',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(42997,125,'Tungapuram','621716',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(42998,125,'V.Kalathur','621117',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(42999,125,'Vadakkalur','621108',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(43000,125,'Vadakkumadevi','621219',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(43001,125,'Vaithiyanathapuram','621717',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(43002,125,'Valikondapuram','621115',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(43003,125,'Varagupadi','621113',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(43004,125,'Varagur','621708',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(43005,125,'Vasistapuram','621716',1,0,'2022-03-03 12:41:14','2022-03-03 12:41:14'),(43006,125,'Vayalapadi','621716',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43007,125,'Vayalur','621716',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43008,125,'Vembavur','621116',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43009,125,'Vengalam','621103',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43010,125,'Venganur','621116',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43011,125,'Veppanthattai','621116',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43012,125,'Veppur','621717',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43013,125,'Viralipattipudur','621118',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43014,125,'Viswagudi','621102',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43015,125,'Yesanai','621219',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43016,125,'Gudalur','621713',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43017,125,'Koothur','621713',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43018,125,'Nochikulam','621713',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43019,126,'Minaveli','621305',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43020,126,'Oliyamangalam','621308',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43021,126,'Rasalipatti','621312',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43022,126,'Athankaraipatti','614902',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43023,126,'Mudalipatti','614902',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43024,126,'Aambukoil','622302',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43025,126,'Adambur','614629',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43026,126,'Adanakottai','622203',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43027,126,'Aharapatti','622003',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43028,126,'Akkachipatti','613301',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43029,126,'Alangudi','622301',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43030,126,'Alavayal','622401',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43031,126,'Alinjiyendal','614618',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43032,126,'Aliyanilai','614616',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43033,126,'Amaradakki','614618',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43034,126,'Amarasimhendrapuram','614805',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43035,126,'Ambalpuram','622005',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43036,126,'Ammachatram','622504',1,0,'2022-03-03 12:41:15','2022-03-03 12:41:15'),(43037,126,'Ammapattinam','614617',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43038,126,'Anavayal','622304',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43039,126,'Andakulam','622203',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43040,126,'Annavasal','622101',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43041,126,'Arantangi Fort','614616',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43042,126,'Arantangi','614616',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43043,126,'Arasamalai','622402',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43044,126,'Arasanagaripattinam','614621',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43045,126,'Arasarkulam','614801',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43046,126,'Arayapatti','614622',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43047,126,'Arimalam','622201',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43048,126,'Arputhapuram','622506',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43049,126,'Athanur','622503',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43050,126,'Attangudi','622003',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43051,126,'Attani','614630',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43052,126,'Avanathankottai','614624',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43053,126,'Avur','622515',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43054,126,'Ayingudi','614801',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43055,126,'Bayamariyanendal','614619',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43056,126,'Bhuvaneswarinagar','622001',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43057,126,'Bramanavayal','614630',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43058,126,'Cauvery Nagar','622501',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43059,126,'Chidambaraviduthi','614622',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43060,126,'Chittannavasal','622101',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43061,126,'Chockanathapatti','622203',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43062,126,'Edaiyathur','614616',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43063,126,'Edayathimangalam','614620',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43064,126,'Eganivayal','614616',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43065,126,'Ennai','622102',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43066,126,'Erasanayakkanpatti','621316',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43067,126,'Erukkalakkottai','614624',1,0,'2022-03-03 12:41:16','2022-03-03 12:41:16'),(43068,126,'Ganapathipuram','622203',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43069,126,'Gandhinagar','622001',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43070,126,'Ganesh Nagar','622001',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43071,126,'Ghandarvakottai','613301',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43072,126,'Gudalur','622412',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43073,126,'Hirudayapuram','622505',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43074,126,'Idaiyathur','622002',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43075,126,'Idaiyur','614629',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43076,126,'Illuppur','622102',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43077,126,'Irumbanadu','622204',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43078,126,'Irundirapatti','622102',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43079,126,'Jegathapattinam','614619',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43080,126,'K.Rasiamangalam','622301',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43081,126,'Kadampatti','622302',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43082,126,'Kadayakudi','622003',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43083,126,'Kadukkakadu','622304',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43084,126,'Kaikurichi','622303',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43085,126,'Kalabam','614629',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43086,126,'Kalabam','622301',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43087,126,'Kalamavur','622502',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43088,126,'Kallakottai','622302',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43089,126,'Kallur-kilanilai','622209',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43090,126,'Kammangadu','614616',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43091,126,'Kanadu','614621',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43092,126,'Kannangudi','622504',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43093,126,'Kannanur','622409',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43094,126,'Karaikottai','614630',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43095,126,'Karaiyur','622002',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43096,126,'Karakathikottai','614619',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43097,126,'Karambakudi','622302',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43098,126,'Karukkakurichi','622302',1,0,'2022-03-03 12:41:17','2022-03-03 12:41:17'),(43099,126,'Karuvur','622204',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43100,126,'Kasimpudupet','614624',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43101,126,'Kattubawa Pallivasal','622503',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43102,126,'Kattumavadi','614630',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43103,126,'Keeramangalam','614624',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43104,126,'Keeranur','622502',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43105,126,'Keerathur','622302',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43106,126,'Kesarapatti','622411',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43107,126,'Kilaiyur','622502',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43108,126,'Kilakurichi','622101',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43109,126,'Kilanilai','622202',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43110,126,'Kilanilaikottai','622209',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43111,126,'Kilanilai-rayavaram','622209',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43112,126,'Kilapanaiyur','622201',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43113,126,'Kilathaniyam','622002',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43114,126,'Kilikudi','622102',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43115,126,'Killanur','622203',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43116,126,'Killukkottai','622502',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43117,126,'Kodivayal','614805',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43118,126,'Kodumbalur','621316',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43119,126,'Komapuram','613301',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43120,126,'Konapet','622503',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43121,126,'Kongudi','622202',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43122,126,'Koppanapatti','622401',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43123,126,'Kothakottai','622303',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43124,126,'Kothamangalam','614624',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43125,126,'Kothirapatti','622102',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43126,126,'Kottaikadu','622304',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43127,126,'Kottaipattinam','614619',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43128,126,'Kottur','622404',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43129,126,'Kovilur (Gandarvakottai)','613301',1,0,'2022-03-03 12:41:18','2022-03-03 12:41:18'),(43130,126,'Kovilur Alangudi','622301',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43131,126,'Krishnajipattinam','614630',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43132,126,'Kudimianmalai','622104',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43133,126,'Kulamangalam','622404',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43134,126,'Kulamangalam','614624',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43135,126,'Kulandiranpattu','622302',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43136,126,'Kulathupatti','622507',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43137,126,'Kulathur Kli','622202',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43138,126,'Kulathur (Pudukkottai)','622504',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43139,126,'Kulavaipatti','622201',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43140,126,'Kulipirai','622402',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43141,126,'Kummangudi','622202',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43142,126,'Kummangulam','622301',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43143,126,'Kundagavayal','614616',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43144,126,'Kunnandarkoil','622502',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43145,126,'Kunnathur','621316',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43146,126,'Kuppakudi','622301',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43147,126,'Kurumbur','614622',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43148,126,'Kurungalur','622204',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43149,126,'Kuruvikondanpatti','622409',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43150,126,'L.N.Puram','614616',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43151,126,'Lembalakudi','622412',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43152,126,'Letchumanapatti','622502',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43153,126,'Machuvadi','622001',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43154,126,'Madianallur','622101',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43155,126,'Malaikudipatti','622102',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43156,126,'Malaiyur','622301',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43157,126,'Manalur','614620',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43158,126,'Manamelkudii','614620',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43159,126,'Manaviduthi','622203',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43160,126,'Mandaiyur','622515',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43161,126,'Mangadu','622304',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43162,126,'Mangalanadu','614805',1,0,'2022-03-03 12:41:19','2022-03-03 12:41:19'),(43163,126,'Manganur','613301',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43164,126,'Mangottai','622301',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43165,126,'Mangudi','622101',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43166,126,'Maramadakki','614622',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43167,126,'Maravamadurai','622002',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43168,126,'Marudakonviduthi','622302',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43169,126,'Mathur','622515',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43170,126,'Mathur Ind. Estate','622515',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43171,126,'Mattangal','613301',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43172,126,'Melamelanilai','622401',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43173,126,'Melanilaivayal','622202',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43174,126,'Melapanaiyur','622412',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43175,126,'Melapattu','614616',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43176,126,'Melasivapuri','622403',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43177,126,'Melathaniyam','622002',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43178,126,'Melur','622507',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43179,126,'Memangalam','614616',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43180,126,'Meppopdakudi','621316',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43181,126,'Merpanaikadu','614624',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43182,126,'Merpanaikadu West','614624',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43183,126,'Mimisal','614621',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43184,126,'Minnathur','622203',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43185,126,'Mirattunilai','622201',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43186,126,'Mohanur','613301',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43187,126,'Muckanamalaipatti','622103',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43188,126,'Mudalipatti','622409',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43189,126,'Mullaiyur','621316',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43190,126,'Mullankurichi','622304',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43191,126,'Mullur','622004',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43192,126,'Muslim Street','614616',1,0,'2022-03-03 12:41:20','2022-03-03 12:41:20'),(43193,126,'Muthukuda','614621',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43194,126,'N.Shanmuganathapuri','622503',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43195,126,'Nachandupatti','622404',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43196,126,'Nagaram','614624',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43197,126,'Nagarapatti','622401',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43198,126,'Nakkudi','614616',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43199,126,'Nallur','622002',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43200,126,'Namanasamudram','622422',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43201,126,'Nanjur','622502',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43202,126,'Narthamalai','622101',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43203,126,'Nedungudi','622209',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43204,126,'Neduvasal','622304',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43205,126,'Neerpalani','622515',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43206,126,'Odayalipatti','622502',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43207,126,'Odugampatti','622502',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43208,126,'Odukkur','622504',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43209,126,'Okkur Perunthamarai','622204',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43210,126,'Onangudi','622201',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43211,126,'Oonaiyur','622505',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43212,126,'P.Alagapuri','622503',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43213,126,'Padirakudi','614629',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43214,126,'Palayanerinjikudi','622002',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43215,126,'Palayavanam','614622',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43216,126,'Pallathividuthi','622301',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43217,126,'Pallavarampatti','622302',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43218,126,'Panangudi','622505',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43219,126,'Panangulam','614624',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43220,126,'Panayapatti','622402',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43221,126,'Pandipathiram','614618',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43222,126,'Panjatti','614616',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43223,126,'Parambur','622104',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43224,126,'Pathampatti','622301',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43225,126,'Peraiyur','622422',1,0,'2022-03-03 12:41:21','2022-03-03 12:41:21'),(43226,126,'Perambur','621316',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43227,126,'Periyalur','614624',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43228,126,'Perumanadu','622104',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43229,126,'Perumarudur','614618',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43230,126,'Perunavalur','614618',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43231,126,'Perungalur','622203',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43232,126,'Perungudi','622506',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43233,126,'Perunjinai','622002',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43234,126,'Pilaviduthi','622302',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43235,126,'Pilivalam','622507',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43236,126,'Pillaithannirpandal','622001',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43237,126,'Ponbethi','614629',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43238,126,'Ponnamaravathy','622407',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43239,126,'Ponnanviduthi','622301',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43240,126,'Poovaimanagar','614624',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43241,126,'Poovalur','614618',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43242,126,'Poovarasakudi','622303',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43243,126,'Poovathakudi','614624',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43244,126,'Poruvai','621316',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43245,126,'Poyyadanallur','614621',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43246,126,'Pudukkottai Bus Stand','622001',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43247,126,'Pudukkottai Collectrate','622005',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43248,126,'Pudukkottai East','622001',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43249,126,'Pudukkottai H.O','622001',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43250,126,'Pudukkottai Ind. Estate','622004',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43251,126,'Pudukkottai Pub Offices','622001',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43252,126,'Pudukkottaividuthi','622301',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43253,126,'Pudunagar','613301',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43254,126,'Pudupatti (Pudukkottai)','622407',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43255,126,'Pudur-pdk','622103',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43256,126,'Puduvakottai','614616',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43257,126,'Puliyur','622504',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43258,126,'Pullanviduthi','622304',1,0,'2022-03-03 12:41:22','2022-03-03 12:41:22'),(43259,126,'Pulvayal','622104',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43260,126,'Puthambur','622501',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43261,126,'Raghunathapuram','622302',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43262,126,'Rajagiri','621316',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43263,126,'Rajagopalapuram','622003',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43264,126,'Rajakulathur','622501',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43265,126,'Rajapatti','622004',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43266,126,'Ramachandrapuram (Pudukkottai)','622505',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43267,126,'Rangiem','622409',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43268,126,'Rappusal','622102',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43269,126,'Rarapuram','622404',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43270,126,'Ratnakottai','614616',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43271,126,'Rayavaram (Pudukkottai)','622506',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43272,126,'Sadayampatti','622002',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43273,126,'Sambattividuthi','622301',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43274,126,'SanthaNatha puram','622005',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43275,126,'Satyamangalam','622501',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43276,126,'Selliampatti','622403',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43277,126,'Semboodi','622401',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43278,126,'Sengalur','622502',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43279,126,'Sengirai','622506',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43280,126,'Sevalur','622402',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43281,126,'Silattur','614622',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43282,126,'Singavanam','614630',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43283,126,'Sipcot-pdk','622002',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43284,126,'Sithakoor','622204',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43285,126,'Sivapuram','622422',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43286,126,'Sooranviduthi','622301',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43287,126,'Srinivasanagar','622502',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43288,126,'Subramaniapuram (Pudukkottai)','614805',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43289,126,'Sunayakadu','614622',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43290,126,'Sundampatti','613301',1,0,'2022-03-03 12:41:23','2022-03-03 12:41:23'),(43291,126,'Sundaram','622402',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43292,126,'Talanur','614621',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43293,126,'Thachankurichi','613301',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43294,126,'Thanjur-tym','622201',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43295,126,'Thanthani','614622',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43296,126,'Thekkattur','622506',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43297,126,'Themmavur','622203',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43298,126,'Thengaithinnipatti','621316',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43299,126,'Thenur','622401',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43300,126,'Theravur','621316',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43301,126,'Thiruppunavasal','614629',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43302,126,'Thiyathur','614629',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43303,126,'Thodaiyur','622501',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43304,126,'Thondaimanendal','614616',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43305,126,'Thondamanallur','622515',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43306,126,'Thulayanur','622507',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43307,126,'Tirugokarnam','622002',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43308,126,'Tirukkalambur','622403',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43309,126,'Tirukkattalai','622303',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43310,126,'Tirumalairayapuram','622504',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43311,126,'Tirumananjeri','622302',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43312,126,'Tirumayam','622507',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43313,126,'Tirunalur','614624',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43314,126,'Tirupperunthurai','614618',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43315,126,'Tiruppur','622502',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43316,126,'Tiruvappur','622003',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43317,126,'Tiruvarankulam','622303',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43318,126,'Tuvar','622301',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43319,126,'Unaiyur','622102',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43320,126,'Uppiliyakudi','622504',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43321,126,'Uthkuli','622102',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43322,126,'V.Lakshmipuram','622412',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43323,126,'Vadakadu','622304',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43324,126,'Vadakattupatti','622202',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43325,126,'Vadavalam','622004',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43326,126,'Vaithur','622203',1,0,'2022-03-03 12:41:24','2022-03-03 12:41:24'),(43327,126,'Valamangalam','622504',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43328,126,'Valaramanickam','622202',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43329,126,'Valavampatti','613301',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43330,126,'Valayapatti (Pudukkottai)','622411',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43331,126,'Vallathirakottai','622303',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43332,126,'Vallavari','614801',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43333,126,'Vamban','622303',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43334,126,'Vamban Colony','622303',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43335,126,'Vambarampatti','622209',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43336,126,'Vanakkankadu','622304',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43337,126,'Vanniampatti','622003',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43338,126,'Varappur','622203',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43339,126,'Varpattu','622403',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43340,126,'Vathanakottai','622203',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43341,126,'Vayalogam','622104',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43342,126,'Veeramangalam','614616',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43343,126,'Veerapatti','622103',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43344,126,'Vegupatti','622407',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43345,126,'Veladipatti','613301',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43346,126,'Vellalaviduthi','622301',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43347,126,'Vellalaviduthi','613301',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43348,126,'Vellanur','622501',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43349,126,'Vellore','614620',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43350,126,'Velur','621316',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43351,126,'Vembanpatti','613301',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43352,126,'Vembanur','622102',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43353,126,'Vendan patti','622403',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43354,126,'Venkatakulam','622303',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43355,126,'Vennavalkudi','622201',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43356,126,'Vettanur','614630',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43357,126,'Vichchur','614617',1,0,'2022-03-03 12:41:25','2022-03-03 12:41:25'),(43358,126,'Vilanur','614618',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43359,126,'Vilapatti','622504',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43360,126,'Vilathupatti','622101',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43361,126,'Virachilai','622412',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43362,126,'Viralimalai','621316',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43363,126,'Viralur','621316',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43364,127,'T.Nagani','630312',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43365,127,'Abiramam','623601',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43366,127,'Achangulam','623601',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43367,127,'Achunthanvayal','623502',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43368,127,'Akkamadam','623521',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43369,127,'Akkiramesi','623705',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43370,127,'Alagankulam','623512',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43371,127,'Alanganoor','623712',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43372,127,'Alimadurai','623701',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43373,127,'Anaiyur','623601',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43374,127,'Anandur','623401',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43375,127,'Andavoorani','623308',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43376,127,'Anjukottai','623407',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43377,127,'Appanur','623703',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43378,127,'Ariyakudi','623527',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43379,127,'Ariyanendal','623701',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43380,127,'Ariyangundu','623529',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43381,127,'Ariyankottai','623525',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43382,127,'Arunoothimangalam','623538',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43383,127,'Athankarai','623512',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43384,127,'Athiyuhtu','623513',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43385,127,'Athiyur','623407',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43386,127,'Attangudi','623525',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43387,127,'Avarendal','623525',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43388,127,'Ayinkudi','623401',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43389,127,'Bharathinagar (PMK)','623707',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43390,127,'Bogalur','623527',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43391,127,'Chathirakudi','623527',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43392,127,'Chathurvethamangalam','623705',1,0,'2022-03-03 12:41:26','2022-03-03 12:41:26'),(43393,127,'Chinnakeeramangalam','623402',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43394,127,'Chitharkottai','623513',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43395,127,'Chithoor','623502',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43396,127,'Chithrankudi','623704',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43397,127,'Devipattinam','623514',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43398,127,'Devipattinam South','623514',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43399,127,'Devipattinam West','623514',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43400,127,'Ekkakudi','623533',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43401,127,'Eluvanur','623605',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43402,127,'Emaneswaram','623701',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43403,127,'Ervadi Dargha','623566',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43404,127,'Ervadi','623515',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43405,127,'Ettivayal','623527',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43406,127,'Gangaikondan','623705',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43407,127,'Gopalapattinam','623705',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43408,127,'Govindamangalam','623401',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43409,127,'Gudalur','623538',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43410,127,'Idambadal','623515',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43411,127,'Idivilagi','623115',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43412,127,'Ilanjembur','623704',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43413,127,'Irudhayapuram','623525',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43414,127,'Irumeni','623516',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43415,127,'K.Veppankulam','623115',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43416,127,'Kadaladi (Ramanathapuram)','623703',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43417,127,'Kadamangalam','623115',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43418,127,'Kadugusandai','623703',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43419,127,'Kadukkavalasai','623516',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43420,127,'Kakkur','623711',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43421,127,'Kalaiyur','623712',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43422,127,'Kalari','623533',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43423,127,'Kalimangundu','623523',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43424,127,'Kalugoorani','623536',1,0,'2022-03-03 12:41:27','2022-03-03 12:41:27'),(43425,127,'Kamankottai','623527',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43426,127,'Kamudakudi','623608',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43427,127,'Kamudi','623603',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43428,127,'Kanjirangudi','623517',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43429,127,'Kannirajapuram','623135',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43430,127,'Karadarnthakudi','623705',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43431,127,'Karankadu','623403',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43432,127,'Karkathakudi','623538',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43433,127,'Karumal','623711',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43434,127,'Kattoorani','623504',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43435,127,'Kavadipatti','623603',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43436,127,'Kavalaivendran','623308',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43437,127,'Kavanur (TOR)','623530',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43438,127,'Kavanur','623525',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43439,127,'Keeranur','623704',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43440,127,'Kidathirukkai','623704',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43441,127,'Kilakarai','623517',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43442,127,'Kilakidaram','623528',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43443,127,'Kilakottai','623527',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43444,127,'Kilamudimannarkottai','623603',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43445,127,'Kilaperungarai','623608',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43446,127,'Kilaramanithi','623603',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43447,127,'Kilaselvanur','623703',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43448,127,'Kilathooval','623706',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43449,127,'Kiliyur','623530',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43450,127,'Kokkarankottai','623115',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43451,127,'Kokkurani','623538',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43452,127,'Kombuthi (KMU)','623603',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43453,127,'Kombuthi','623517',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43454,127,'Koodakulam','623605',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43455,127,'Kookudi','623308',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43456,127,'Kothiyarkottai','623531',1,0,'2022-03-03 12:41:28','2022-03-03 12:41:28'),(43457,127,'Kottaimedu','623604',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43458,127,'Kottakudi','623407',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43459,127,'Kovilangulam','623603',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43460,127,'Kulathur','623530',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43461,127,'Kumbaram','623523',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43462,127,'Kumbidumadurai','623517',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43463,127,'Kunjankulam','623308',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43464,127,'Kurumilangudi','623409',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43465,127,'Kuruvadi','623120',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43466,127,'Kuthakottai','623532',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43467,127,'M M Pattinam','623706',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43468,127,'Madavanur','623514',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43469,127,'Malapanaiyur','623538',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43470,127,'Mallal','623533',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43471,127,'Mandalamanickam','623605',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43472,127,'Mandapam Camp','623519',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43473,127,'Mandapam','623518',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43474,127,'Mangalakudi','623308',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43475,127,'Mangundu','623534',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43476,127,'Marandai','623703',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43477,127,'Marine Fisheries','623520',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43478,127,'Marttiyarendal','623533',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43479,127,'Marungoor','623406',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43480,127,'Mayakulam','623515',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43481,127,'Melakanniseri','623601',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43482,127,'Melakavanur','623706',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43483,127,'Melakidaram','623528',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43484,127,'Melakodumalur','623601',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43485,127,'Melakottai','623504',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43486,127,'Melaperungarai','623608',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43487,127,'Melapudukudi','623532',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43488,127,'Melaselvanur','623703',1,0,'2022-03-03 12:41:29','2022-03-03 12:41:29'),(43489,127,'Melasirupothu','623704',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43490,127,'Melayakudi','623706',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43491,127,'Mennanthi','623527',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43492,127,'Methalodai','623532',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43493,127,'Misal','623712',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43494,127,'Mudaliarpudukulam','623120',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43495,127,'Mudalur','623502',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43496,127,'Mudukulathur','623704',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43497,127,'Muhilthagam','623403',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43498,127,'Mukkaiyur','623120',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43499,127,'Mustakurichi','623603',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43500,127,'Muthupettai','623523',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43501,127,'Muthuvayal','623527',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43502,127,'Mv Salt Complex','623528',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43503,127,'Nagachi','623534',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43504,127,'Nagaram','623705',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43505,127,'Nagaratharkurichi','623601',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43506,127,'Nagarikathan','623404',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43507,127,'Nainamaraickan','623523',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43508,127,'Nainarkoil','623705',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43509,127,'Nallirukkai','623533',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43510,127,'Nallukurichi','623601',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43511,127,'Nambuthalai','623403',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43512,127,'Naranamangalam','623537',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43513,127,'Narippaiyur','623135',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43514,127,'Natham','623601',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43515,127,'Nathamkulapatham','623517',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43516,127,'Neeravikarisalkulam','623603',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43517,127,'Nelmadur','623608',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43518,127,'Nerinchipatti','623603',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43519,127,'Nilamalagiamangalam','623315',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43520,127,'Olaikuda','623526',1,0,'2022-03-03 12:41:30','2022-03-03 12:41:30'),(43521,127,'Ooranikottai','623308',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43522,127,'Oppilan','623703',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43523,127,'Orikottai','623402',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43524,127,'Oriyur','623406',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43525,127,'P.Kodikulam','623537',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43526,127,'P.Sirahikottai','623705',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43527,127,'Pakkuvetti','623604',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43528,127,'Pamban','623521',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43529,127,'Pambur','623706',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43530,127,'Pammanendal','623115',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43531,127,'Panaikulam','623522',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43532,127,'Pananchayal','623315',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43533,127,'Pandikanmoi','623527',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43534,127,'Pandugudi','623404',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43535,127,'Pannandai','623528',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43536,127,'Paramakudi Bazaar','623707',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43537,127,'Paramakudi H.O','623707',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43538,127,'Paramakudi ITI','623527',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43539,127,'Parthibanur','623608',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43540,127,'Pasipattinam','623409',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43541,127,'Pasumpon','623604',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43542,127,'Pattanamkathan','623503',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43543,127,'Peraiyur (Ramanathapuram)','623708',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43544,127,'Peravoor','623504',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43545,127,'Periyakulam','623703',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43546,127,'Periyapattinam','623523',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43547,127,'Perumalthevanpatti','623603',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43548,127,'Perunali','623115',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43549,127,'Perungulam (Ramanathapuram)','623536',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43550,127,'Peruvakottai','623308',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43551,127,'Peruvayal','623513',1,0,'2022-03-03 12:41:31','2022-03-03 12:41:31'),(43552,127,'Pidariseri','623608',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43553,127,'Pillaiyarkulam','623120',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43554,127,'Pirappanvalasai','623516',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43555,127,'Pooseri','623711',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43556,127,'Pothikulam','623704',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43557,127,'Pottagavayal','623537',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43558,127,'Pudukoil','623532',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43559,127,'Pudukottai','623603',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43560,127,'Pudukudi','623608',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43561,127,'Pudumadam','623524',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43562,127,'Pudupattinam','623403',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43563,127,'Puduvalasai','623522',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43564,127,'Pullangudi','623513',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43565,127,'Punavasal','623601',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43566,127,'Puthenthal','623502',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43567,127,'Radhanur','623401',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43568,127,'Rajasingamangalam','623525',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43569,127,'Rajasooriyamadai','623504',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43570,127,'Ramanathapuram Bazaar','623501',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43571,127,'Ramanathapuram Collectorate','623503',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43572,127,'Ramanathapuram H.O','623501',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43573,127,'Ramasamypatti','623603',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43574,127,'Rameswaram Road','623526',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43575,127,'Rameswaram','623526',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43576,127,'Regunathamadai','623701',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43577,127,'Regunathapuram','623523',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43578,127,'Rettaiyurani','623534',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43579,127,'S.Kavanur','623706',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43580,127,'S.Kodikulam','623527',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43581,127,'S.Mariyur','623703',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43582,127,'S.Tharaikudi','623135',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43583,127,'Sadayanendal','623601',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43584,127,'Sadayaneri','623704',1,0,'2022-03-03 12:41:32','2022-03-03 12:41:32'),(43585,127,'Sakkarakottai','623504',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43586,127,'Sambai','623531',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43587,127,'Sambakulam','623706',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43588,127,'Sanaveli','623538',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43589,127,'Sathaksalai','623806',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43590,127,'Sathankulam','623536',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43591,127,'Sathanur (PMK)','623706',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43592,127,'Saveriyarpattinam','623703',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43593,127,'Saveriyarpattinam','623538',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43594,127,'Sayalgudi','623120',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43595,127,'Sellur','623712',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43596,127,'Sembidaiyarkulam','623536',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43597,127,'Sembongudi','623712',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43598,127,'Sengudi','623525',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43599,127,'Senkottaipatti','623708',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43600,127,'Sevalpatti','623135',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43601,127,'Sevvaipettai','623402',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43602,127,'Seyyamangalam','623601',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43603,127,'Sholandur','623537',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43604,127,'Sikkal (Ramanathapuram)','623528',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43605,127,'Sirumalaikottai','623308',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43606,127,'Siruvayal','623530',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43607,127,'Sudiyur','623608',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43608,127,'Sundaramudaiyan','623519',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43609,127,'Sundarapandiapattinam','623406',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43610,127,'Surankottai','623504',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43611,127,'T. Karungulam','623527',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43612,127,'T.Mariyur','623703',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43613,127,'T.Pudukottai','623701',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43614,127,'T.Veppankulam','623120',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43615,127,'Teriruveli','623711',1,0,'2022-03-03 12:41:33','2022-03-03 12:41:33'),(43616,127,'Thaduthalankottai','623608',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43617,127,'Thangachimadam','623529',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43618,127,'Thelichathanallur','623701',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43619,127,'Therkutharavai','623504',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43620,127,'Thinaikulam','623532',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43621,127,'Thinaiyathur','623407',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43622,127,'Thiruppullani','623532',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43623,127,'Thonithurai','623518',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43624,127,'Thuthinatham','623115',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43625,127,'Tirumalkanthankottai','623115',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43626,127,'Tirupalaikudi','623531',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43627,127,'Tiruvadanai','623407',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43628,127,'Tiruvarangam','623712',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43629,127,'Tiruvetriyur','623407',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43630,127,'Tondi','623409',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43631,127,'Toruvalur','623530',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43632,127,'Uchinatham','623115',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43633,127,'Uchipuli','623534',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43634,127,'Ulaiyur','623712',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43635,127,'Uppoor','623525',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43636,127,'Urapuli','623701',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43637,127,'Uthayakudi','623705',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43638,127,'Uthirakosamangai','623533',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43639,127,'Vairavanendal','623502',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43640,127,'Valanadu','623527',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43641,127,'Valanai','623401',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43642,127,'Valantharavai','623536',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43643,127,'Valasai','623527',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43644,127,'Valayapukulam','623605',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43645,127,'Valinokkam','623528',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43646,127,'Vallakulam','623711',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43647,127,'Vallam','623705',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43648,127,'Vani','623536',1,0,'2022-03-03 12:41:34','2022-03-03 12:41:34'),(43649,127,'Vannangundu','623523',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43650,127,'Vattanam','623409',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43651,127,'Vedalai','623519',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43652,127,'Veerambal','623704',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43653,127,'Velipattanam','623504',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43654,127,'Vellariodai','623524',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43655,127,'Vellayapuram','623315',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43656,127,'Vendhoni','623701',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43657,127,'Vengalur','623608',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43658,127,'Venkittankurichi','623712',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43659,127,'Vennirvaikkal','623704',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43660,127,'Vettukulam','623525',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43661,127,'Vilangulathur','623704',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43662,127,'Vilathur','623706',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43663,128,'Ammapalayam','636906',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43664,128,'A.Thalaiyur','637103',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43665,128,'Alathur','637303',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43666,128,'Chettimankurichi','637101',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43667,128,'Chinnagoundanur','637303',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43668,128,'Chittoor','637101',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43669,128,'Dadapuram','637105',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43670,128,'Devagoundanur','637301',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43671,128,'Erumaipatti','637102',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43672,128,'Gudalur','637103',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43673,128,'Idappadi','637101',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43674,128,'Irugalur','637103',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43675,128,'Kachuppalli','637102',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43676,128,'Kaligoundampalayam','637103',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43677,128,'Kannanderi','637102',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43678,128,'Karumapuram','637302',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43679,128,'Kaveripatti','637104',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43680,128,'Konasamudram','637102',1,0,'2022-03-03 12:41:35','2022-03-03 12:41:35'),(43681,128,'Kurumbapatti','637105',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43682,128,'Manjakkalpatti','637301',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43683,128,'Marapparai','637410',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43684,128,'Morur','637304',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43685,128,'Nedunkulam','637107',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43686,128,'Olakkachinnanur','637102',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43687,128,'Sankaridrug','637301',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43688,128,'Sanyasipatti Agraharam','637303',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43689,128,'Thangayur','637102',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43690,128,'Tirumangalam','637302',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43691,128,'Vadugapatti','637301',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43692,128,'Vaikuntham','637103',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43693,128,'Veerachipalayam','637303',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43694,128,'Vellarivalli','637101',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43695,128,'Vembaneri','637105',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43696,128,'A.Komarapalayam','636117',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43697,128,'A.N.Mangalam','636106',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43698,128,'Achankuttapatti','636122',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43699,128,'Adikarai','636204',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43700,128,'Akkarapalayam','636308',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43701,128,'Aladipatti','636104',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43702,128,'Alagapuram','636004',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43703,128,'Allikuttai','636003',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43704,128,'Ammampalayam','636141',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43705,128,'Ammapet Bazaar','636003',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43706,128,'Ammapettai Salem','636003',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43707,128,'Anaiyampatti','636105',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43708,128,'Annadanapatti','636002',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43709,128,'Anuppur','636139',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43710,128,'Appamasamudram','636108',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43711,128,'Aragalur','636101',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43712,128,'Aranoothumalai','636104',1,0,'2022-03-03 12:41:36','2022-03-03 12:41:36'),(43713,128,'Arasanatham','636107',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43714,128,'Ariyampalayam','636119',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43715,128,'Ariyanur','636308',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43716,128,'Asambur','636602',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43717,128,'Athanurpatti','636115',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43718,128,'Attayampatti','637501',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43719,128,'Atur H.O','636102',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43720,128,'Aturbazaar','636102',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43721,128,'Ayodhiyapattinam East','636103',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43722,128,'Ayodhiyapattinam','636103',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43723,128,'Ayyanthirumaligai','636008',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43724,128,'Bairoji Agraharam','636308',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43725,128,'Belur (Salem)','636104',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43726,128,'C.N.Palayam','636104',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43727,128,'C.P.Valasu','636104',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43728,128,'Cauvery Peak','636602',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43729,128,'Chendrayampalayam','636111',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43730,128,'Chennagiri','637501',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43731,128,'Chinnanur','636122',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43732,128,'Chinnaseeragapadi','636308',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43733,128,'Chinnatirupathy','636008',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43734,128,'Chokkanathapuram','636108',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43735,128,'D.Perumapalayam','636122',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43736,128,'Dadagapatti','636006',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43737,128,'Dadubaikuttai','636015',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43738,128,'Dalavaipatti','636109',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43739,128,'Dasanaickenpatti','636201',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43740,128,'Devendrapuram','636001',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43741,128,'Deviyakurichi','636112',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43742,128,'E.Pethampatti','636203',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43743,128,'Edappadi','636105',1,0,'2022-03-03 12:41:37','2022-03-03 12:41:37'),(43744,128,'Erumapalayam','636015',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43745,128,'Fairlands','636016',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43746,128,'Gajjalnaickenpatti','636201',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43747,128,'Gandhinagar (Salem)','636102',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43748,128,'Gangavalli','636105',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43749,128,'Gopalapuram','636107',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43750,128,'Gorimedu','636008',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43751,128,'Govindampalayam','636101',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43752,128,'Gugai','636006',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43753,128,'Hasthampatti','636007',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43754,128,'Idayapatti','636114',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43755,128,'Iluppanatham','636116',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43756,128,'Jangammasamudram','636113',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43757,128,'Kadambur','636105',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43758,128,'Kalarampatti','636107',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43759,128,'Kalipatti','637501',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43760,128,'Kallanatham','636141',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43761,128,'Kalleripatti','636117',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43762,128,'Kalpaganur','636109',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43763,128,'Kamakkapalayam','636112',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43764,128,'Kamaraj Nagar Colony','636014',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43765,128,'Kandashramam','636140',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43766,128,'Kannankurichi','636008',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43767,128,'Karadiyur','636602',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43768,128,'Karipatti','636106',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43769,128,'Kariyakoil','636138',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43770,128,'Karumanthurai','636138',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43771,128,'Karumapuram','636106',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43772,128,'Karungalpatti','636006',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43773,128,'Kattukottai','636121',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43774,128,'Kavarpanai','636116',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43775,128,'Keeraikadu','636601',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43776,128,'Keeripatti','636107',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43777,128,'Kitchipalayam','636015',1,0,'2022-03-03 12:41:38','2022-03-03 12:41:38'),(43778,128,'Koil Puthur','636138',1,0,'2022-03-03 12:41:39','2022-03-03 12:41:39'),(43779,128,'Kolathukombai','636139',1,0,'2022-03-03 12:41:39','2022-03-03 12:41:39'),(43780,128,'Kombuthooki','636601',1,0,'2022-03-03 12:41:39','2022-03-03 12:41:39'),(43781,128,'Konanchettiyur','636104',1,0,'2022-03-03 12:41:39','2022-03-03 12:41:39'),(43782,128,'Kondalampatti','636010',1,0,'2022-03-03 12:41:39','2022-03-03 12:41:39'),(43783,128,'Kondappanaickenpatti','636008',1,0,'2022-03-03 12:41:39','2022-03-03 12:41:39'),(43784,128,'Kondayampalli','636110',1,0,'2022-03-03 12:41:39','2022-03-03 12:41:39'),(43785,128,'Koneripatti','636113',1,0,'2022-03-03 12:41:39','2022-03-03 12:41:39'),(43786,128,'Kootathupatti','636139',1,0,'2022-03-03 12:41:39','2022-03-03 12:41:39'),(43787,128,'Kottaichedu','636601',1,0,'2022-03-03 12:41:39','2022-03-03 12:41:39'),(43788,128,'Kottavadi','636115',1,0,'2022-03-03 12:41:39','2022-03-03 12:41:39'),(43789,128,'Krishnapuram','636105',1,0,'2022-03-03 12:41:39','2022-03-03 12:41:39'),(43790,128,'Kudamalai','636105',1,0,'2022-03-03 12:41:39','2022-03-03 12:41:39'),(43791,128,'Kullampatti','636103',1,0,'2022-03-03 12:41:39','2022-03-03 12:41:39'),(43792,128,'Kunnur','636138',1,0,'2022-03-03 12:41:39','2022-03-03 12:41:39'),(43793,128,'Kuppanur','636122',1,0,'2022-03-03 12:41:39','2022-03-03 12:41:39'),(43794,128,'Kuralnatham','636204',1,0,'2022-03-03 12:41:39','2022-03-03 12:41:39'),(43795,128,'Kurichi','636104',1,0,'2022-03-03 12:41:39','2022-03-03 12:41:39'),(43796,128,'Laddivadi','636116',1,0,'2022-03-03 12:41:39','2022-03-03 12:41:39'),(43797,128,'M. Perumapalayam','636111',1,0,'2022-03-03 12:41:39','2022-03-03 12:41:39'),(43798,128,'Malliakarai','636107',1,0,'2022-03-03 12:41:39','2022-03-03 12:41:39'),(43799,128,'Mangalam','637501',1,0,'2022-03-03 12:41:39','2022-03-03 12:41:39'),(43800,128,'Manivilundan','636121',1,0,'2022-03-03 12:41:39','2022-03-03 12:41:39'),(43801,128,'Manivilundan Colony','636112',1,0,'2022-03-03 12:41:39','2022-03-03 12:41:39'),(43802,128,'Maniyanur','636010',1,0,'2022-03-03 12:41:39','2022-03-03 12:41:39'),(43803,128,'Maniyaragundam','636138',1,0,'2022-03-03 12:41:39','2022-03-03 12:41:39'),(43804,128,'Manjakuttai','636602',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43805,128,'Manjini','636141',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43806,128,'Manmalai','636110',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43807,128,'Mannarpalayam Valapady','636115',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43808,128,'Mannur','636114',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43809,128,'Marakkadai','636004',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43810,128,'Maramangalam','636601',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43811,128,'Maravaneri','636007',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43812,128,'Masinaickenpatti','636103',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43813,128,'Mayambadi','636105',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43814,128,'Melthombai','636107',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43815,128,'Mettu Street','636001',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43816,128,'Mettupatti Karipatti','636111',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43817,128,'Mettupatti Tadanur','636103',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43818,128,'Minnampalli','636106',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43819,128,'Mookuthipalayam','636203',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43820,128,'Moolakurichi','636142',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43821,128,'Mullur','636203',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43822,128,'Mulluvadi','636141',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43823,128,'Muluvi','636602',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43824,128,'Muthampatti','636111',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43825,128,'Naduvalur','636105',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43826,128,'Nagalur','636602',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43827,128,'Nagiampatti','636113',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43828,128,'Nalikalpatti','636201',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43829,128,'Narasingapuram (Salem)','636108',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43830,128,'Narasothipatti','636004',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43831,128,'Narayananagar','636015',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43832,128,'Naripadi','636105',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43833,128,'Nattamangalam','636010',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43834,128,'Navakurichi','636112',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43835,128,'Navalur','636116',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43836,128,'Neikkarapatti','636010',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43837,128,'Nethimedu','636002',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43838,128,'Neyyamalai','636114',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43839,128,'Nilavarapatti','636201',1,0,'2022-03-03 12:41:40','2022-03-03 12:41:40'),(43840,128,'Nirmullikuttai','636139',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43841,128,'Odayapatti','636140',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43842,128,'Odiyathur','636105',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43843,128,'Olapadi','636109',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43844,128,'Ondikadai','636602',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43845,128,'P.Mettur','636203',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43846,128,'Pagadupattu','636138',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43847,128,'Paithur','636141',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43848,128,'Palakadu','636601',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43849,128,'Palakadu','636110',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43850,128,'Palaniyapuri','636108',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43851,128,'Pallipatti','636122',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43852,128,'Panaimadal','636117',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43853,128,'Panamarathupatti','636204',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43854,128,'Pappanaickenpatti','636114',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43855,128,'Papparapatti','637501',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43856,128,'Parapatti','636203',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43857,128,'Parapatti Mannarpalayam','636008',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43858,128,'Pattipadi','636601',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43859,128,'Pattuthurai','636112',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43860,128,'Peramanur','636007',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43861,128,'Perappancholai','636113',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43862,128,'Periakrishnapuram','636115',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43863,128,'Periaseeragapadi','636308',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43864,128,'Periyagoundapuram','636106',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43865,128,'Periyakuttimaduvu','636104',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43866,128,'Periyeri','636101',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43867,128,'Pethanaickenpalayam','636109',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43868,128,'Piliyur','636602',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43869,128,'Ponnammapet','636001',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43870,128,'Ponnarampatti','636115',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43871,128,'Poolavari Agraharam','636010',1,0,'2022-03-03 12:41:41','2022-03-03 12:41:41'),(43872,128,'Poovanur','636122',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43873,128,'Pudupet (Salem)','636141',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43874,128,'Puliyankurichi','636101',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43875,128,'Puluthikuttai','636104',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43876,128,'Punavasal','636116',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43877,128,'Pungavadi','636141',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43878,128,'Puthiragoundampalayam','636119',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43879,128,'Puthumariamman Koil','636003',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43880,128,'Puthur','636010',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43881,128,'Puthur','636112',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43882,128,'Puthur','636601',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43883,128,'R.Komarapalayam','636203',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43884,128,'Rajapalayam','637501',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43885,128,'Rajapalayam East','636116',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43886,128,'Ramalingapuram','636106',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43887,128,'Ramanaickenpalayam','636108',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43888,128,'Ramanathapuram','636104',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43889,128,'S.Attayampatti','636203',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43890,128,'S.N.Mangalam','636106',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43891,128,'Sadasivapuram','636121',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43892,128,'Salem Bazaar','636001',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43893,128,'Salem Collectorate','636001',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43894,128,'Salem Dt. Court Buildings','636007',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43895,128,'Salem Dt.Board Buildings','636001',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43896,128,'Salem East','636001',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43897,128,'Salem Extension','636007',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43898,128,'Salem Fort','636001',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43899,128,'Salem H.O','636001',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43900,128,'Salem North','636007',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43901,128,'Salem Pension Lines','636006',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43902,128,'Salem Second Agraharam','636001',1,0,'2022-03-03 12:41:42','2022-03-03 12:41:42'),(43903,128,'Salem South','636006',1,0,'2022-03-03 12:41:43','2022-03-03 12:41:43'),(43904,128,'Sandaipettai','636010',1,0,'2022-03-03 12:41:43','2022-03-03 12:41:43'),(43905,128,'Sanjeevarayanpettai','636006',1,0,'2022-03-03 12:41:43','2022-03-03 12:41:43'),(43906,128,'Sanniyasigundu','636015',1,0,'2022-03-03 12:41:43','2022-03-03 12:41:43'),(43907,128,'Sarvoy','636121',1,0,'2022-03-03 12:41:43','2022-03-03 12:41:43'),(43908,128,'Sathapadi','636121',1,0,'2022-03-03 12:41:43','2022-03-03 12:41:43'),(43909,128,'Seelanaickenpatti','636201',1,0,'2022-03-03 12:41:43','2022-03-03 12:41:43'),(43910,128,'Seeliampatti','636107',1,0,'2022-03-03 12:41:43','2022-03-03 12:41:43'),(43911,128,'Sekkadipatti','636104',1,0,'2022-03-03 12:41:43','2022-03-03 12:41:43'),(43912,128,'Semmanatham','636602',1,0,'2022-03-03 12:41:43','2022-03-03 12:41:43'),(43913,128,'Sendarapatti','636110',1,0,'2022-03-03 12:41:43','2022-03-03 12:41:43'),(43914,128,'Sengadu','636601',1,0,'2022-03-03 12:41:43','2022-03-03 12:41:43'),(43915,128,'Seshanchavadi','636111',1,0,'2022-03-03 12:41:43','2022-03-03 12:41:43'),(43916,128,'Sheepfarm','636112',1,0,'2022-03-03 12:41:43','2022-03-03 12:41:43'),(43917,128,'Shenbagamadevi','637501',1,0,'2022-03-03 12:41:43','2022-03-03 12:41:43'),(43918,128,'Shevapet Bazaar','636002',1,0,'2022-03-03 12:41:43','2022-03-03 12:41:43'),(43919,128,'Shevapet','636002',1,0,'2022-03-03 12:41:43','2022-03-03 12:41:43'),(43920,128,'Shevaroy Mines','636203',1,0,'2022-03-03 12:41:43','2022-03-03 12:41:43'),(43921,128,'Singipuram','636115',1,0,'2022-03-03 12:41:43','2022-03-03 12:41:43'),(43922,128,'Siruvachur','636112',1,0,'2022-03-03 12:41:43','2022-03-03 12:41:43'),(43923,128,'Sitheri','636101',1,0,'2022-03-03 12:41:43','2022-03-03 12:41:43'),(43924,128,'Sittampatti','636138',1,0,'2022-03-03 12:41:43','2022-03-03 12:41:43'),(43925,128,'Soolankurichi','636138',1,0,'2022-03-03 12:41:43','2022-03-03 12:41:43'),(43926,128,'Sukkampatti','636122',1,0,'2022-03-03 12:41:43','2022-03-03 12:41:43'),(43927,128,'Tadampatti','636014',1,0,'2022-03-03 12:41:43','2022-03-03 12:41:43'),(43928,128,'Tagarapudur','636110',1,0,'2022-03-03 12:41:43','2022-03-03 12:41:43'),(43929,128,'Talaivasal','636112',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43930,128,'Thalaisolai','636601',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43931,128,'Thamaiyanur','636115',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43932,128,'Thammampatti','636113',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43933,128,'Thammanaickenpatti','636010',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43934,128,'Thandanur','636117',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43935,128,'Thandavarayapuram','636108',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43936,128,'Thedavur','636116',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43937,128,'Thekkampattu','636138',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43938,128,'Thenkumarai','636121',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43939,128,'Thillainagar','636001',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43940,128,'Thiyaganur','636101',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43941,128,'Thukkiampalayam','636115',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43942,128,'Thumbal','636114',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43943,128,'Thumbalpatti','636204',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43944,128,'Tippampatti','636204',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43945,128,'Udayarpalayam','636113',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43946,128,'Udayarpalayam (Salem)','636102',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43947,128,'Ulipuram','636118',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43948,128,'Umayapuram','636119',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43949,128,'Unathur','636112',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43950,128,'Uthamasolapuram','636010',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43951,128,'Vadachennimalai','636121',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43952,128,'Vaidhyagoundampudur','636115',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43953,128,'Valapady','636115',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43954,128,'Valasaiyur','636122',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43955,128,'Valayamadevi','636121',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43956,128,'Varagur','636112',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43957,128,'Vazhakombai','636113',1,0,'2022-03-03 12:41:44','2022-03-03 12:41:44'),(43958,128,'Vazhavandhi','636601',1,0,'2022-03-03 12:41:45','2022-03-03 12:41:45'),(43959,128,'Veeragoundanur','636119',1,0,'2022-03-03 12:41:45','2022-03-03 12:41:45'),(43960,128,'Veeranam','636122',1,0,'2022-03-03 12:41:45','2022-03-03 12:41:45'),(43961,128,'Veerapandi Salem','636308',1,0,'2022-03-03 12:41:45','2022-03-03 12:41:45'),(43962,128,'Velampatti','636139',1,0,'2022-03-03 12:41:45','2022-03-03 12:41:45'),(43963,128,'Vellaiyur','636116',1,0,'2022-03-03 12:41:45','2022-03-03 12:41:45'),(43964,128,'Vellakadai','636602',1,0,'2022-03-03 12:41:45','2022-03-03 12:41:45'),(43965,128,'Vellalagundam','636111',1,0,'2022-03-03 12:41:45','2022-03-03 12:41:45'),(43966,128,'Vellalapatti','636114',1,0,'2022-03-03 12:41:45','2022-03-03 12:41:45'),(43967,128,'Velur','636601',1,0,'2022-03-03 12:41:45','2022-03-03 12:41:45'),(43968,128,'Veppampoondi','636101',1,0,'2022-03-03 12:41:45','2022-03-03 12:41:45'),(43969,128,'Vilaripalayam','636115',1,0,'2022-03-03 12:41:45','2022-03-03 12:41:45'),(43970,128,'Vinayagapuram','636102',1,0,'2022-03-03 12:41:45','2022-03-03 12:41:45'),(43971,128,'Viraganur','636116',1,0,'2022-03-03 12:41:45','2022-03-03 12:41:45'),(43972,128,'West Rajapalayam','636115',1,0,'2022-03-03 12:41:45','2022-03-03 12:41:45'),(43973,128,'Yercaud','636601',1,0,'2022-03-03 12:41:45','2022-03-03 12:41:45'),(43974,128,'Yethapur','636117',1,0,'2022-03-03 12:41:45','2022-03-03 12:41:45'),(43975,128,'Adaiyur','636501',1,0,'2022-03-03 12:41:45','2022-03-03 12:41:45'),(43976,128,'Amaragundhi','636503',1,0,'2022-03-03 12:41:45','2022-03-03 12:41:45'),(43977,128,'Amaram','636451',1,0,'2022-03-03 12:41:45','2022-03-03 12:41:45'),(43978,128,'Andikarai','636404',1,0,'2022-03-03 12:41:45','2022-03-03 12:41:45'),(43979,128,'Andipatti','636307',1,0,'2022-03-03 12:41:45','2022-03-03 12:41:45'),(43980,128,'Aranganur','636451',1,0,'2022-03-03 12:41:45','2022-03-03 12:41:45'),(43981,128,'Arisipalayam','636009',1,0,'2022-03-03 12:41:45','2022-03-03 12:41:45'),(43982,128,'Arurpatti','636502',1,0,'2022-03-03 12:41:45','2022-03-03 12:41:45'),(43983,128,'Attukaranur','636304',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(43984,128,'Ayyamperumalpatti','636302',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(43985,128,'Banapuram','636451',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(43986,128,'Bodinaickenpatti','636307',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(43987,128,'Bommiampatti','636351',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(43988,128,'Boominaickenpatti','636304',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(43989,128,'Bukkampatti','636451',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(43990,128,'Chamrajpet (Salem)','636451',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(43991,128,'Chellapillaikuttai','636304',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(43992,128,'Chettichavadi','636012',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(43993,128,'Chettipatti','636455',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(43994,128,'Chinnasoragai','636502',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(43995,128,'Chinnathanda','636303',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(43996,128,'Dalavaipatti','636302',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(43997,128,'Danishpet','636354',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(43998,128,'Darapuram','636309',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(43999,128,'Dasavilakku','636306',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(44000,128,'Deevattipatti','636351',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(44001,128,'Dinnapatti','636303',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(44002,128,'Doramangalam','636501',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(44003,128,'Duddampatti','636306',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(44004,128,'Edanganasalai','637502',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(44005,128,'Egapuram','637502',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(44006,128,'Elampillai','637502',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(44007,128,'Erakondampatti','636451',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(44008,128,'Gonur','636404',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(44009,128,'Govindapadi','636303',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(44010,128,'Govt. College Of Engg','636011',1,0,'2022-03-03 12:41:46','2022-03-03 12:41:46'),(44011,128,'Guttapatti','636453',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44012,128,'Ilavampatti','636501',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44013,128,'Jagir Ammapalayam','636302',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44014,128,'Jalakantapuram','636501',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44015,128,'Jawahar Mills','636005',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44016,128,'Jodukuli','636351',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44017,128,'K.Morur','636354',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44018,128,'Kachakaranur','636302',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44019,128,'Kadayampatti','636351',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44020,128,'Kakkapalayam','637504',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44021,128,'Kalparapatti','637504',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44022,128,'Kamalapuram (Salem)','636309',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44023,128,'Kamarajnagar','636202',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44024,128,'Kanakkampatti','636454',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44025,128,'Kanavaipudur','636354',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44026,128,'Kandampatti','636307',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44027,128,'Kandarkulamanickam','637504',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44028,128,'Kanjanaickenpatti','636305',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44029,128,'Kannamoochi','636303',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44030,128,'Kannapadi','636354',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44031,128,'Karukkalvadi','636013',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44032,128,'Karumalaikudal','636403',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44033,128,'Karungallur','636303',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44034,128,'Karuppur','636012',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44035,128,'Karuppureddiyur','636404',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44036,128,'Karuvalli','636305',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44037,128,'Kaveripuram','636303',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44038,128,'Kethunaickenpattipudur','636354',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44039,128,'Kolanaickenpatti','636452',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44040,128,'Kolathur (Salem)S.O','636303',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44041,128,'Koneripatti','637502',1,0,'2022-03-03 12:41:47','2022-03-03 12:41:47'),(44042,128,'Kongupatti','636305',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44043,128,'Konreddiyur','636351',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44044,128,'Koonandiyur','636458',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44045,128,'Koppampudur','636453',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44046,128,'Kosavapatti','637502',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44047,128,'Kottagoundampatti','636011',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44048,128,'Kullamudayanur','636453',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44049,128,'Kuppampatti','636501',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44050,128,'Kurumbarur','636303',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44051,128,'Leigh Bazaar','636009',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44052,128,'M.Kalipatti','636453',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44053,128,'M.Pallipatti','636458',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44054,128,'Madayankuttai','636452',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44055,128,'Magnesite Mines','636302',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44056,128,'Mallikundam','636458',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44057,128,'Mallikuttai','636503',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44058,128,'Mamangam','636302',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44059,128,'Manathal','636503',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44060,128,'Manathal Nallagoundampatti','636503',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44061,128,'Marakottai','636451',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44062,128,'Maramangalam','636503',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44063,128,'Maramangalathupatti','636030',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44064,128,'Masilapalayam','636452',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44065,128,'Mattukaranpudur','636305',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44066,128,'Mattukaranur','636011',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44067,128,'Mecheri','636453',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44068,128,'Mettupatti','636455',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44069,128,'Mettur Thermal Project','636406',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44070,128,'Metturdam RS','636402',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44071,128,'Metturdam','636401',1,0,'2022-03-03 12:41:48','2022-03-03 12:41:48'),(44072,128,'Metturdam South','636401',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44073,128,'Meyyanur','636005',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44074,128,'Mohan Nagar (Salem)','636030',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44075,128,'Moongilerichettipatti','636455',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44076,128,'Moongilpadi','636012',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44077,128,'Mukkanur','636351',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44078,128,'Mulakadu','636452',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44079,128,'Murungapatti','636307',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44080,128,'Muthampatti','636503',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44081,128,'Muthunaickenpatti','636304',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44082,128,'Nadupatti','636351',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44083,128,'Naduvaneri','637504',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44084,128,'Naickenpatti','636307',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44085,128,'Nallagoundampatti','636304',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44086,128,'Nangavalli','636454',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44087,128,'Nariyanur','636458',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44088,128,'Navapatti','636452',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44089,128,'Nedunchalai Nagar','636402',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44090,128,'Olaipatti','636455',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44091,128,'Omalur Cutcherry','636455',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44092,128,'Omalur','636455',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44093,128,'Pachanampatti','636455',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44094,128,'Pakalpatti','636304',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44095,128,'Pakkanadu','636501',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44096,128,'Palamalai Hills','636303',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44097,128,'Panankattur','636455',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44098,128,'Pannapatti','636305',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44099,128,'Pannavadi','636303',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44100,128,'Pappampadi','636306',1,0,'2022-03-03 12:41:49','2022-03-03 12:41:49'),(44101,128,'Pavalathanur','636502',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44102,128,'Periakadampatti','636502',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44103,128,'Periapatti','636309',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44104,128,'Periasathapadi','636451',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44105,128,'Periasoragai','636502',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44106,128,'Periavadugampatti','636354',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44107,128,'Periavanavasi','636457',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44108,128,'Periyeripatti','636503',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44109,128,'Perumagoudampatti','637502',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44110,128,'Perumampatti','636307',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44111,128,'Poosaripatti','636305',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44112,128,'Pottaneri','636453',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44113,128,'Pottipuram','636309',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44114,128,'Pudupalayam','636306',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44115,128,'Pudupatti (Salem)','637407',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44116,128,'Pudusampalli','636403',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44117,128,'Rakkipatti','637504',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44118,128,'Ramamurthinagar','636354',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44119,128,'Raman Nagar','636403',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44120,128,'Ramireddipatti','636501',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44121,128,'Salem Camp','636456',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44122,128,'Salem Steel Plant','636013',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44123,128,'Saminaickenpatti','636011',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44124,128,'Samudram','636306',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44125,128,'Sanarapatti','636457',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44126,128,'Sarkar Kollapatti','636030',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44127,128,'Sarkaraichettipatti','636305',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44128,128,'Sarkkapillaiyur','636305',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44129,128,'Savariyarpalayam','636303',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44130,128,'Savariyur','636501',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44131,128,'Selavadai','636501',1,0,'2022-03-03 12:41:50','2022-03-03 12:41:50'),(44132,128,'Semmandapatti','636309',1,0,'2022-03-03 12:41:51','2022-03-03 12:41:51'),(44133,128,'Semmankudal','636304',1,0,'2022-03-03 12:41:51','2022-03-03 12:41:51'),(44134,128,'Settiyur','636303',1,0,'2022-03-03 12:41:51','2022-03-03 12:41:51'),(44135,128,'Sikkanampatti','636309',1,0,'2022-03-03 12:41:51','2022-03-03 12:41:51'),(44136,128,'Singiripatti','636303',1,0,'2022-03-03 12:41:51','2022-03-03 12:41:51'),(44137,128,'Sinnappampatti','636306',1,0,'2022-03-03 12:41:51','2022-03-03 12:41:51'),(44138,128,'Sivadapuram','636307',1,0,'2022-03-03 12:41:51','2022-03-03 12:41:51'),(44139,128,'Suramangalam H.O','636005',1,0,'2022-03-03 12:41:51','2022-03-03 12:41:51'),(44140,128,'Suramangalam Railway Colony','636005',1,0,'2022-03-03 12:41:51','2022-03-03 12:41:51'),(44141,128,'Surapalli','636501',1,0,'2022-03-03 12:41:51','2022-03-03 12:41:51'),(44142,128,'Swaminathapuram','636009',1,0,'2022-03-03 12:41:51','2022-03-03 12:41:51'),(44143,128,'T.Konagapadi','636502',1,0,'2022-03-03 12:41:51','2022-03-03 12:41:51'),(44144,128,'Teppakuttai','637502',1,0,'2022-03-03 12:41:51','2022-03-03 12:41:51'),(44145,128,'Thangamapuripattinam','636005',1,0,'2022-03-03 12:41:51','2022-03-03 12:41:51'),(44146,128,'Tharamangalam','636502',1,0,'2022-03-03 12:41:51','2022-03-03 12:41:51'),(44147,128,'Tharkadusundarapuram','636303',1,0,'2022-03-03 12:41:51','2022-03-03 12:41:51'),(44148,128,'Thathiengarpatti','636012',1,0,'2022-03-03 12:41:51','2022-03-03 12:41:51'),(44149,128,'Thettigiripatti','636451',1,0,'2022-03-03 12:41:51','2022-03-03 12:41:51'),(44150,128,'Thinnapatti','636305',1,0,'2022-03-03 12:41:51','2022-03-03 12:41:51'),(44151,128,'Thirumalagiri','636307',1,0,'2022-03-03 12:41:51','2022-03-03 12:41:51'),(44152,128,'Tholasampatti','636503',1,0,'2022-03-03 12:41:51','2022-03-03 12:41:51'),(44153,128,'Thumbipadi','636305',1,0,'2022-03-03 12:41:51','2022-03-03 12:41:51'),(44154,128,'Umbilickampatti','636351',1,0,'2022-03-03 12:41:52','2022-03-03 12:41:52'),(44155,128,'V.Kongarapatti','636351',1,0,'2022-03-03 12:41:52','2022-03-03 12:41:52'),(44156,128,'Vanavasi','636457',1,0,'2022-03-03 12:41:52','2022-03-03 12:41:52'),(44157,128,'Vattakadu','636012',1,0,'2022-03-03 12:41:52','2022-03-03 12:41:52'),(44158,128,'Veerakkal','636454',1,0,'2022-03-03 12:41:52','2022-03-03 12:41:52'),(44159,128,'Vellalapatti','636012',1,0,'2022-03-03 12:41:52','2022-03-03 12:41:52'),(44160,128,'Vellar','636451',1,0,'2022-03-03 12:41:52','2022-03-03 12:41:52'),(44161,128,'Vembadithalam','637504',1,0,'2022-03-03 12:41:52','2022-03-03 12:41:52'),(44162,128,'Virudasampatti','636453',1,0,'2022-03-03 12:41:52','2022-03-03 12:41:52'),(44163,128,'Veppadi','621110',1,0,'2022-03-03 12:41:52','2022-03-03 12:41:52'),(44164,129,'A.Thekkur','630201',1,0,'2022-03-03 12:41:52','2022-03-03 12:41:52'),(44165,129,'Ac.School','630107',1,0,'2022-03-03 12:41:52','2022-03-03 12:41:52'),(44166,129,'Ae.College','630003',1,0,'2022-03-03 12:41:52','2022-03-03 12:41:52'),(44167,129,'Alagappapuram','630003',1,0,'2022-03-03 12:41:52','2022-03-03 12:41:52'),(44168,129,'Alangudi','630307',1,0,'2022-03-03 12:41:52','2022-03-03 12:41:52'),(44169,129,'Amaravathipudur','630301',1,0,'2022-03-03 12:41:52','2022-03-03 12:41:52'),(44170,129,'Arakottai','630303',1,0,'2022-03-03 12:41:52','2022-03-03 12:41:52'),(44171,129,'Ariyakudi','630202',1,0,'2022-03-03 12:41:52','2022-03-03 12:41:52'),(44172,129,'Athikaram','630207',1,0,'2022-03-03 12:41:52','2022-03-03 12:41:52'),(44173,129,'Attangudi','630101',1,0,'2022-03-03 12:41:52','2022-03-03 12:41:52'),(44174,129,'Avanipatti','630205',1,0,'2022-03-03 12:41:52','2022-03-03 12:41:52'),(44175,129,'Cecri Campus','630003',1,0,'2022-03-03 12:41:52','2022-03-03 12:41:52'),(44176,129,'Chettinad','630102',1,0,'2022-03-03 12:41:52','2022-03-03 12:41:52'),(44177,129,'Chockalingampudur','630101',1,0,'2022-03-03 12:41:52','2022-03-03 12:41:52'),(44178,129,'CVmangalam','630501',1,0,'2022-03-03 12:41:53','2022-03-03 12:41:53'),(44179,129,'Devakottai Extension','630303',1,0,'2022-03-03 12:41:53','2022-03-03 12:41:53'),(44180,129,'Devakottai H.O','630302',1,0,'2022-03-03 12:41:53','2022-03-03 12:41:53'),(44181,129,'Devakottai Palace','630302',1,0,'2022-03-03 12:41:53','2022-03-03 12:41:53'),(44182,129,'Devakottai Road','630005',1,0,'2022-03-03 12:41:53','2022-03-03 12:41:53'),(44183,129,'Devakottai South','630302',1,0,'2022-03-03 12:41:53','2022-03-03 12:41:53'),(44184,129,'Devakottai West','630302',1,0,'2022-03-03 12:41:53','2022-03-03 12:41:53'),(44185,129,'Dharmapatti','630309',1,0,'2022-03-03 12:41:53','2022-03-03 12:41:53'),(44186,129,'Eluvankottai','630303',1,0,'2022-03-03 12:41:53','2022-03-03 12:41:53'),(44187,129,'Hanumanthagudi','630303',1,0,'2022-03-03 12:41:53','2022-03-03 12:41:53'),(44188,129,'Ilayathakudi','630205',1,0,'2022-03-03 12:41:53','2022-03-03 12:41:53'),(44189,129,'Illuppakudi','630202',1,0,'2022-03-03 12:41:53','2022-03-03 12:41:53'),(44190,129,'Iraniyur','630212',1,0,'2022-03-03 12:41:53','2022-03-03 12:41:53'),(44191,129,'Jayankondan','630108',1,0,'2022-03-03 12:41:53','2022-03-03 12:41:53'),(44192,129,'K.Alagapuri','630106',1,0,'2022-03-03 12:41:53','2022-03-03 12:41:53'),(44193,129,'Kalapur','630501',1,0,'2022-03-03 12:41:53','2022-03-03 12:41:53'),(44194,129,'Kallampatti','630501',1,0,'2022-03-03 12:41:53','2022-03-03 12:41:53'),(44195,129,'Kallukatti','630001',1,0,'2022-03-03 12:41:53','2022-03-03 12:41:53'),(44196,129,'Kallupatti (Sivaganga)','630306',1,0,'2022-03-03 12:41:53','2022-03-03 12:41:53'),(44197,129,'Kambanur','630207',1,0,'2022-03-03 12:41:53','2022-03-03 12:41:53'),(44198,129,'Kanadukathan','630103',1,0,'2022-03-03 12:41:53','2022-03-03 12:41:53'),(44199,129,'Kandadevi','630314',1,0,'2022-03-03 12:41:53','2022-03-03 12:41:53'),(44200,129,'Kandanur','630104',1,0,'2022-03-03 12:41:53','2022-03-03 12:41:53'),(44201,129,'Kandanurperumalkoil','630104',1,0,'2022-03-03 12:41:53','2022-03-03 12:41:53'),(44202,129,'Kannamangalapatti','630502',1,0,'2022-03-03 12:41:53','2022-03-03 12:41:53'),(44203,129,'Kannangudi','630303',1,0,'2022-03-03 12:41:53','2022-03-03 12:41:53'),(44204,129,'Karaikudi Angadi','630001',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44205,129,'Karaikudi H.O','630001',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44206,129,'Karaikudi Southstreet','630002',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44207,129,'Karisalpatti','630309',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44208,129,'Karuthavoorani','630302',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44209,129,'Kattukudipatti','630410',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44210,129,'Kilasevalpatti','630205',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44211,129,'Kilavayal','630410',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44212,129,'Kiliyur','630312',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44213,129,'Kirungakottai','630502',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44214,129,'Konnathanpatti','630405',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44215,129,'Koratti','630206',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44216,129,'Kothamangalam (Sivaganga)','630105',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44217,129,'Kottaiyur','630106',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44218,129,'Kovilur','630307',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44219,129,'Kunnakudi','630206',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44220,129,'Kuthalur','630307',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44221,129,'Lakshmipuram','630105',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44222,129,'Managiri','630307',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44223,129,'Mandakudipatti','630410',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44224,129,'Maviduthikottai','630303',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44225,129,'Melapatti','630502',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44226,129,'Mitravayal','630108',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44227,129,'Muraiyur','630501',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44228,129,'Musundapatti','630309',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44229,129,'Muthupatnam','630001',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44230,129,'Nachiapuram','630207',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44231,129,'Neduvayal','630410',1,0,'2022-03-03 12:41:54','2022-03-03 12:41:54'),(44232,129,'Nemathanpatti','630103',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44233,129,'Nerkuppai','630405',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44234,129,'O.Siruvayal','630208',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44235,129,'Palavangudi','630208',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44236,129,'Pallattur','630107',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44237,129,'Patharakudi','630307',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44238,129,'Pavanakottai','630311',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44239,129,'Peerkalaikadu','630108',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44240,129,'Periakottai','630108',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44241,129,'Periyakarai','630311',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44242,129,'Pillayarpatti','630207',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44243,129,'Piranmalai','630502',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44244,129,'Piranpatti','630309',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44245,129,'Puduvayal','630108',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44246,129,'Pulankurichi','630405',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44247,129,'Pulidipatti','630309',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44248,129,'Puliyal','630312',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44249,129,'Sakkavayal','630108',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44250,129,'Sakkottai','630108',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44251,129,'Sekkalai','630002',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44252,129,'Senjai','630001',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44253,129,'Sevvur','630405',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44254,129,'Shanmuganathapuram','630314',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44255,129,'Silambani','630302',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44256,129,'Singampunari','630502',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44257,129,'Siravayal','630207',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44258,129,'Sirukudalpatti','630212',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44259,129,'Sithivayal','630108',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44260,129,'Surakudi','630501',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44261,129,'Teralapur','630303',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44262,129,'Thidakottai','630312',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44263,129,'Tirukolakudi','630405',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44264,129,'Tiruppakottai','630303',1,0,'2022-03-03 12:41:55','2022-03-03 12:41:55'),(44265,129,'Tiruvalandur','630410',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44266,129,'Tuvar','630405',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44267,129,'Ulagampatti','630410',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44268,129,'Unjanai','630202',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44269,129,'V.Pudur','630410',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44270,129,'Vadagudi','630107',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44271,129,'Vaiyapuripatti','630501',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44272,129,'Vanjinipatti','630201',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44273,129,'Varapur','630410',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44274,129,'Velayuthapattinam','630311',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44275,129,'Vengaipatti','630502',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44276,129,'Vengalore','630303',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44277,129,'Viramathi','630212',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44278,129,'Visalayankottai','630306',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44279,129,'Kalladithidal','623401',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44280,129,'Karkalathur','623402',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44281,129,'Konnapanendal','623701',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44282,129,'Kumarakurichi','623701',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44283,129,'Munaivendri','623701',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44284,129,'Muppaiyur','623402',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44285,129,'Thoonugudi','623402',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44286,129,'A.Karungulam','630321',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44287,129,'A.Mukkulam','630611',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44288,129,'A.Siruvayal','630305',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44289,129,'Akkavayal','630713',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44290,129,'Alagamanagiri','630553',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44291,129,'Alagapuri','630556',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44292,129,'Alampatti','630211',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44293,129,'Alavakottai','630553',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44294,129,'Alavidangan','630713',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44295,129,'Allinagaram','630611',1,0,'2022-03-03 12:41:56','2022-03-03 12:41:56'),(44296,129,'Ambalathadi','630612',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44297,129,'Andichoorani','630551',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44298,129,'Aralikottai','630566',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44299,129,'Ariyandipuram','630702',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44300,129,'Arumuganagar','630211',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44301,129,'Athapadakki','630562',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44302,129,'Ayyapatti','630211',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44303,129,'Bhramanampatti','630210',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44304,129,'Bosenagar (Sivaganga)','630561',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44305,129,'Chinnakannanur','630609',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44306,129,'Chockanathapuram','630313',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44307,129,'Enathi','630562',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44308,129,'Eriyur','630566',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44309,129,'Idaikattur','630602',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44310,129,'Idayamelur','630562',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44311,129,'Ilayangudi','630702',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44312,129,'Ilayangudi West','630702',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44313,129,'Indankulam','630709',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44314,129,'Jawahar Bazaar','630561',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44315,129,'K.Sukkanurani','630551',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44316,129,'Kalagathankottai','630710',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44317,129,'Kalakanmoi','630555',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44318,129,'Kalayarkoil','630551',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44319,129,'Kalayarmangalam','630557',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44320,129,'Kallal','630305',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44321,129,'Kallurani','630559',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44322,129,'Kalugarkadai','630611',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44323,129,'Kanakkangudi','630562',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44324,129,'Kandangipatti','630562',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44325,129,'Kandani','630562',1,0,'2022-03-03 12:41:57','2022-03-03 12:41:57'),(44326,129,'Kandavarayanpatti','630203',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44327,129,'Kandramanickam','630204',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44328,129,'Kanjirangal','630562',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44329,129,'Kannamangalam','630709',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44330,129,'Kannar Street','630606',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44331,129,'Kanur','630610',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44332,129,'Karaiyur','630211',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44333,129,'Karunchutti','630702',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44334,129,'Kattambur','630210',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44335,129,'Kattanipatti','630553',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44336,129,'Kattanur','630610',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44337,129,'Kattikulam','630609',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44338,129,'Kavathugudi','630408',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44339,129,'Keeladi','630612',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44340,129,'Keelakottai','630313',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44341,129,'Keelauchani','630408',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44342,129,'Keelayur','630702',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44343,129,'Kilamelgudi','630609',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44344,129,'Kilapasalai','630609',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44345,129,'Kilapungudi','630305',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44346,129,'Kilapungudi','630552',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44347,129,'Konthagai North','630612',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44348,129,'Koothandam','630562',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44349,129,'Kothangulam','630610',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44350,129,'Kottaiyiruppu','630211',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44351,129,'Kottaiyur','630702',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44352,129,'Kumaravelur','630411',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44353,129,'Kurunthampattu','630305',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44354,129,'Ladanendal','630611',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44355,129,'M.Pudur','630210',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44356,129,'Madagupatti','630553',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44357,129,'Mahibalanpatti','630203',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44358,129,'Malampatti','630562',1,0,'2022-03-03 12:41:58','2022-03-03 12:41:58'),(44359,129,'Mallakottai','630566',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44360,129,'Manalur','630611',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44361,129,'Manamadurai H.O','630606',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44362,129,'Manamadurai RS','630606',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44363,129,'Manamadurai Town','630606',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44364,129,'Mangalam (Sivaganga)','630554',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44365,129,'Marakathur','630551',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44366,129,'Maranadu','630610',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44367,129,'Marathur','630551',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44368,129,'Melamarungur','630554',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44369,129,'Melapasalai','630609',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44370,129,'Melapidavur','630609',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44371,129,'Melarangiam','630611',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44372,129,'Melaseithur','630709',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44373,129,'Melayur','630702',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44374,129,'Milaganoor','630609',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44375,129,'Mudikandam','630562',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44376,129,'Mudikarai','630551',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44377,129,'Muthanendhal','630602',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44378,129,'Mutharasan','630559',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44379,129,'Muthupatti','630562',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44380,129,'Muthur','630710',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44381,129,'Muthur','630556',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44382,129,'Naduvikottai','630204',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44383,129,'Nagamuguthangudi','630709',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44384,129,'Nagarampatti','630558',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44385,129,'Nalukottai','630557',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44386,129,'Namanur','630553',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44387,129,'Natarajapuram (Sivaganga)','630555',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44388,129,'Nattarasankottai','630556',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44389,129,'Nedumaram','630211',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44390,129,'Nettur','630702',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44391,129,'North Andakudi','630702',1,0,'2022-03-03 12:41:59','2022-03-03 12:41:59'),(44392,129,'Okkur','630557',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44393,129,'P.Karungulam','630204',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44394,129,'Padamathur','630562',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44395,129,'Padathanpatti','630305',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44396,129,'Paganeri','630558',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44397,129,'Pahaianchan','630554',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44398,129,'Palayanur','630610',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44399,129,'Pallithammam','630551',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44400,129,'Panangudi','630556',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44401,129,'Pannangudi','630556',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44402,129,'Paruthikanmoi','630551',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44403,129,'Pattamangalam','630204',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44404,129,'Periakottai','630559',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44405,129,'Periyakannanur','630562',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44406,129,'Pilar','630305',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44407,129,'Pillur','630562',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44408,129,'Piramanur','630611',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44409,129,'Poovanthi','630611',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44410,129,'Pottapalayam','630612',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44411,129,'Pudur Ilayangudi','630709',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44412,129,'Pulikanmoi','630551',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44413,129,'Puliyadithamam','630411',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44414,129,'Pulvoikarai','630611',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44415,129,'Rajagambiram','630609',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44416,129,'Rajani','630713',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44417,129,'Ranasingapuram','630211',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44418,129,'S.Karaikudi','630609',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44419,129,'S.N Pattinam','630411',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44420,129,'S.S.Kottai','630211',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44421,129,'Sakkandhi','630562',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44422,129,'Sakkur','630713',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44423,129,'Salaigramam','630710',1,0,'2022-03-03 12:42:00','2022-03-03 12:42:00'),(44424,129,'Salur','630562',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44425,129,'Samudram','630710',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44426,129,'Sarakeni','630411',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44427,129,'Sathani','630709',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44428,129,'Sathanur','630710',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44429,129,'Satharasankottai','630562',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44430,129,'Satharasanpatti','630555',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44431,129,'Saveriarpattinam','630609',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44432,129,'Seikalathur','630609',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44433,129,'Sekkakudi','630408',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44434,129,'Sembanur','630313',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44435,129,'Sengulipatti','630555',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44436,129,'Sevalpatti','630211',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44437,129,'Sevarakottai','630305',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44438,129,'Sholapuram','630557',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44439,129,'Silukkapatti','630554',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44440,129,'Siramam','630554',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44441,129,'Sivaganga Collectorate','630562',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44442,129,'Sivaganga Courts','630561',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44443,129,'Sivaganga H.O','630561',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44444,129,'Sivaganga North','630561',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44445,129,'Sm Hospital','630211',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44446,129,'Sokkananthapuram','630411',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44447,129,'Sothugudi','630709',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44448,129,'Surakulam Pudukottai','630562',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44449,129,'Suranam','630713',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44450,129,'T.Pudupatti','630211',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44451,129,'Tamarakki','630562',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44452,129,'Thanjakur','630610',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44453,129,'Thayamangalam','630709',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44454,129,'Thirani','630411',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44455,129,'Thogavur','630710',1,0,'2022-03-03 12:42:01','2022-03-03 12:42:01'),(44456,129,'Thuvaralankanmoi','630551',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44457,129,'Tirukalapatti','630211',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44458,129,'Tirukoshtiyur','630210',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44459,129,'Tirumalaikoneripatti','630552',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44460,129,'Tirumanjolai','630562',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44461,129,'Tirupattur Bus Stand','630211',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44462,129,'Tirupattur','630211',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44463,129,'Tiruppachetti','630610',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44464,129,'Tiruppuvanam Pudur','630611',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44465,129,'Tiruppuvanam','630611',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44466,129,'Tiruvegampet','630408',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44467,129,'Uluthimadai','630610',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44468,129,'Uruvati','630411',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44469,129,'Usilangulam','630554',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44470,129,'Uthamanoor','630702',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44471,129,'Vaiyakalathur','630203',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44472,129,'Valacheri','630611',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44473,129,'Vandal','630710',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44474,129,'Velangudi','630203',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44475,129,'Velarendal','630554',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44476,129,'Vellikurichi','630610',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44477,129,'Vembattur','630559',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44478,129,'Veppangulam','630305',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44479,129,'Vethiyur','630321',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44480,129,'Vilangattur','630408',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44481,129,'Viswanoor','630713',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44482,129,'Vittaneri','630556',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44483,129,'Kulathupatti','621308',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44484,130,'Aduthurai Bazar','612101',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44485,130,'Aduthurai','612101',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44486,130,'Ammachathiram','612103',1,0,'2022-03-03 12:42:02','2022-03-03 12:42:02'),(44487,130,'Ammangudi','612202',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44488,130,'Anaikudi','612105',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44489,130,'Andalampettai','612104',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44490,130,'Annalagraharam','612401',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44491,130,'Aralur','612106',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44492,130,'Asoor','612501',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44493,130,'Atthiyur','612503',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44494,130,'Avaniapuram','612101',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44495,130,'Ayyavadi','612204',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44496,130,'Baburajapuram','612302',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44497,130,'Cholanmaligai','612703',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44498,130,'Darasuram','612702',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44499,130,'Devanancheri','612501',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44500,130,'Engan','612603',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44501,130,'Eraharam','612303',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44502,130,'Gangadarapuram','612302',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44503,130,'Govindapuram','612101',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44504,130,'Injikollai','612605',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44505,130,'Innambur','612303',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44506,130,'Kadichambadi','612501',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44507,130,'Kadiramangalam','612106',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44508,130,'Kallapuliyur','612501',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44509,130,'Kallur','612503',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44510,130,'Kamakshipuram','609807',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44511,130,'Kanjanur','609804',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44512,130,'Karuppur','609807',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44513,130,'Kilakattur','609807',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44514,130,'Konulampallam','609807',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44515,130,'Koohur','612602',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44516,130,'Koorchi','612504',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44517,130,'Koranattukkaruppur','612501',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44518,130,'Korukkai Thottam','612401',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44519,130,'Kothangudi','612602',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44520,130,'Kottaiyur','612302',1,0,'2022-03-03 12:42:03','2022-03-03 12:42:03'),(44521,130,'Kovilacherri','612503',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44522,130,'Krishnapuram','612401',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44523,130,'Krishnarayar Agraharam','612001',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44524,130,'Kumaramangalam','612602',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44525,130,'Kumbakonam Bazar','612001',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44526,130,'Kumbakonam City','612001',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44527,130,'Kumbakonam Cutchery','612001',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44528,130,'Kumbakonam East','612001',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44529,130,'Kumbakonam H.O','612001',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44530,130,'Kumbakonam Market','612001',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44531,130,'Kumbakonam R.S.','612001',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44532,130,'Kumbakonam West','612001',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44533,130,'Lower Anicut','612502',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44534,130,'Madalampettai','612001',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44535,130,'Mahadana Street','612104',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44536,130,'Maharajapuram','612503',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44537,130,'Manalur','609804',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44538,130,'Manambadi','612503',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44539,130,'Manikudi','612504',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44540,130,'Marudanallur','612402',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44541,130,'Maruthuvakudi','612101',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44542,130,'Mathur','612602',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44543,130,'Mattiyur','612504',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44544,130,'Melaiyur','612101',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44545,130,'Melakaveri H.O','612002',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44546,130,'Mullangudi','612502',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44547,130,'Murukkangudi','612202',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44548,130,'Nagarasampettai','612605',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44549,130,'Natchar Koil','612602',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44550,130,'Nirathanallur','612501',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44551,130,'Oppiliappankoil','612204',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44552,130,'Palakudi','612102',1,0,'2022-03-03 12:42:04','2022-03-03 12:42:04'),(44553,130,'Palavathankattalai','612401',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44554,130,'Pampappadaiyur','612703',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44555,130,'Paruthicherri','612605',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44556,130,'Paruthikudi','612102',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44557,130,'Patteeswaram','612703',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44558,130,'Poundarigapuram','612202',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44559,130,'Rendankattalai','612202',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44560,130,'Sakkottai','612401',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44561,130,'Sannapuram','612204',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44562,130,'Sathanur','609802',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44563,130,'Semmangudi','612605',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44564,130,'Senganur','612504',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44565,130,'Sengarangudi Pudur','612201',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44566,130,'Sholapuram','612503',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44567,130,'Sickinaickanpettai','612504',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44568,130,'Sivapuram','612401',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44569,130,'Suriyanarkoil','612102',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44570,130,'Swamimalai East','612302',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44571,130,'Swamimalai','612302',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44572,130,'Tepperumanallur','612204',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44573,130,'Teynampadugai','612703',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44574,130,'Thandanthottam','612202',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44575,130,'Thathuvancheri','612502',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44576,130,'Thukkachi','612602',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44577,130,'Thuvarankurichi','612001',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44578,130,'Tippirajapuram','612402',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44579,130,'Tirukodikaval','609802',1,0,'2022-03-03 12:42:05','2022-03-03 12:42:05'),(44580,130,'Tiruloki','609804',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44581,130,'Tirumangaicherry','609807',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44582,130,'Tirunageswaram','612204',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44583,130,'Tirunaraiyur','612602',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44584,130,'Tirunilakudi','612101',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44585,130,'Tirupanandal','612504',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44586,130,'Tirupirambiyam','612303',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44587,130,'Tirupuvanam','612103',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44588,130,'Tiruvalanjuli','612302',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44589,130,'Tiruvidaimarudur R.S.','612104',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44590,130,'Tiruvidaimarudur West','612104',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44591,130,'Tiruvidamarudur','612104',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44592,130,'Tiruvisalur','612105',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44593,130,'Tiyagarajapuram','609802',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44594,130,'Ullur','612001',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44595,130,'Umamaheswarapuram','612103',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44596,130,'Valayapettai','612702',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44597,130,'Veppathur','612105',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44598,130,'Virakkan','612504',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44599,130,'Visalur','612402',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44600,130,'Adambai','614602',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44601,130,'Adirampattinam R.S','614701',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44602,130,'Adirampattinam','614701',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44603,130,'Akkaraivattam','614614',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44604,130,'Aladikkumulai','614615',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44605,130,'Alagiyanayakipuram','614723',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44606,130,'Alampallam','614901',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44607,130,'Alathur','614901',1,0,'2022-03-03 12:42:06','2022-03-03 12:42:06'),(44608,130,'Alivalam','614602',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44609,130,'Ambalapattu','614626',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44610,130,'Ambalapattu North','614626',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44611,130,'Ammaiyandi','614623',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44612,130,'Ammanichatram','614612',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44613,130,'Anaikadu','614602',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44614,130,'Andami','614903',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44615,130,'Andikadu','614723',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44616,130,'Athikottai','614906',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44617,130,'Attivetti','614613',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44618,130,'Avanam','614623',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44619,130,'Azhiavaikal','614904',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44620,130,'Chokkanathapuram','614803',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44621,130,'Cholagankarai','614626',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44622,130,'Cholapuram','614902',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44623,130,'Eachankottai','614902',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44624,130,'Enadi','614615',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44625,130,'Enathikarambai','614623',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44626,130,'Eripurakarai','614701',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44627,130,'Idayathi','614628',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44628,130,'Ilangadu','614903',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44629,130,'Kadanthankudi','614903',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44630,130,'Kaduvettividuthi','614614',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44631,130,'Kakkarai','614625',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44632,130,'Kakkaraikottai','614902',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44633,130,'Kalagam','614804',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44634,130,'Kalanivasal','614804',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44635,130,'Kalathur','614804',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44636,130,'Kallurnikadu','614628',1,0,'2022-03-03 12:42:07','2022-03-03 12:42:07'),(44637,130,'Kalyanaodai','614903',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44638,130,'Kamatchinayakkanpalayam','614602',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44639,130,'Kandithampattu','614904',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44640,130,'Kannandangudi','614625',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44641,130,'Kannanthangudi Melaiyur','614625',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44642,130,'Kannugudi','614901',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44643,130,'Kannugudi Kilpathi','614901',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44644,130,'Karambakadu','614802',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44645,130,'Karambayam','614626',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44646,130,'Karukadipatti','614902',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44647,130,'Karuppamanai','614804',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44648,130,'Karuppur','614903',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44649,130,'Kasanadupudur','614904',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44650,130,'Kasangadu','614613',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44651,130,'Kattayankadu','614803',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44652,130,'Kavarapattu','614625',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44653,130,'Kilakadu','614704',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44654,130,'Kilamangalam','614615',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44655,130,'Kilauluvur','614904',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44656,130,'Kilavastachavadi','614904',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44657,130,'Kollaikadu','614628',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44658,130,'Kottaitheru','614902',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44659,130,'Kuruchi','614602',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44660,130,'Kuruvikarambai','614802',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44661,130,'Madukkur North','614903',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44662,130,'Madukkur','614903',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44663,130,'Magilankottai','614701',1,0,'2022-03-03 12:42:08','2022-03-03 12:42:08'),(44664,130,'Maliyakadu','614602',1,0,'2022-03-03 12:42:09','2022-03-03 12:42:09'),(44665,130,'Mallipattinam','614723',1,0,'2022-03-03 12:42:09','2022-03-03 12:42:09'),(44666,130,'Manakadu','614612',1,0,'2022-03-03 12:42:09','2022-03-03 12:42:09'),(44667,130,'Manjavayal','614613',1,0,'2022-03-03 12:42:09','2022-03-03 12:42:09'),(44668,130,'Mannangadu','614613',1,0,'2022-03-03 12:42:09','2022-03-03 12:42:09'),(44669,130,'Maravakadu','614704',1,0,'2022-03-03 12:42:09','2022-03-03 12:42:09'),(44670,130,'Marungapallam','614802',1,0,'2022-03-03 12:42:09','2022-03-03 12:42:09'),(44671,130,'Mavadukurichi','614804',1,0,'2022-03-03 12:42:09','2022-03-03 12:42:09'),(44672,130,'Melauluvur','614904',1,0,'2022-03-03 12:42:09','2022-03-03 12:42:09'),(44673,130,'Moothakurichi','614906',1,0,'2022-03-03 12:42:09','2022-03-03 12:42:09'),(44674,130,'Mudachikadu','614804',1,0,'2022-03-03 12:42:09','2022-03-03 12:42:09'),(44675,130,'Mudalseri','614602',1,0,'2022-03-03 12:42:09','2022-03-03 12:42:09'),(44676,130,'Mudukadu','614612',1,0,'2022-03-03 12:42:09','2022-03-03 12:42:09'),(44677,130,'Mullurpattikadu','614901',1,0,'2022-03-03 12:42:09','2022-03-03 12:42:09'),(44678,130,'Nadimuthunagar','614602',1,0,'2022-03-03 12:42:09','2022-03-03 12:42:09'),(44679,130,'Nadiyam','614802',1,0,'2022-03-03 12:42:09','2022-03-03 12:42:09'),(44680,130,'Nadur','614904',1,0,'2022-03-03 12:42:09','2022-03-03 12:42:09'),(44681,130,'Naduvikottai','614602',1,0,'2022-03-03 12:42:09','2022-03-03 12:42:09'),(44682,130,'Nainankulam','614602',1,0,'2022-03-03 12:42:09','2022-03-03 12:42:09'),(44683,130,'Nambivayal','614615',1,0,'2022-03-03 12:42:09','2022-03-03 12:42:09'),(44684,130,'Nattuchalai','614906',1,0,'2022-03-03 12:42:09','2022-03-03 12:42:09'),(44685,130,'Neduvakottai','614625',1,0,'2022-03-03 12:42:09','2022-03-03 12:42:09'),(44686,130,'Neyvelivadapathi','614628',1,0,'2022-03-03 12:42:09','2022-03-03 12:42:09'),(44687,130,'Okkanad Kilaiyur','614625',1,0,'2022-03-03 12:42:09','2022-03-03 12:42:09'),(44688,130,'Okkanadumelaiyur','614625',1,0,'2022-03-03 12:42:09','2022-03-03 12:42:09'),(44689,130,'Orantharayankudikadu','614625',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44690,130,'Orattanad','614625',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44691,130,'Ottangadu','614803',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44692,130,'Pachiyur','614902',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44693,130,'Padirankottai','614614',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44694,130,'Paingal','614623',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44695,130,'Palanjore','614701',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44696,130,'Palaya Peravurni','614804',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44697,130,'Pallathur','614803',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44698,130,'Pallikondan','614602',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44699,130,'Panchanathikottai','614904',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44700,130,'Pannavayal','614602',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44701,130,'Pappanad','614626',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44702,130,'Parakkalakottai','614613',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44703,130,'Parangivettikadu','614626',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44704,130,'Paruthikottai','614904',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44705,130,'Pattukottai H.O','614601',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44706,130,'Pattukottai R.S.','614602',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44707,130,'Peikarambankottai','614626',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44708,130,'Peravurni','614804',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44709,130,'Periyakottai','614903',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44710,130,'Perumagalur','614612',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44711,130,'Pinnaiyur','614902',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44712,130,'Pinnavasal','614804',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44713,130,'Ponnapur','614904',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44714,130,'Ponnavarayankottai','614602',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44715,130,'Poyyundarkottai','614902',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44716,130,'Pudukottai Ullur','614701',1,0,'2022-03-03 12:42:10','2022-03-03 12:42:10'),(44717,130,'Pulavanji','614903',1,0,'2022-03-03 12:42:11','2022-03-03 12:42:11'),(44718,130,'Pulavankadu','614625',1,0,'2022-03-03 12:42:11','2022-03-03 12:42:11'),(44719,130,'Punaikuthikadu','614804',1,0,'2022-03-03 12:42:11','2022-03-03 12:42:11'),(44720,130,'Punavasal','614803',1,0,'2022-03-03 12:42:11','2022-03-03 12:42:11'),(44721,130,'Puvathur','614625',1,0,'2022-03-03 12:42:11','2022-03-03 12:42:11'),(44722,130,'Rajamadam','614701',1,0,'2022-03-03 12:42:11','2022-03-03 12:42:11'),(44723,130,'Rendampulikadu','614723',1,0,'2022-03-03 12:42:11','2022-03-03 12:42:11'),(44724,130,'Rudrachinthamani','614612',1,0,'2022-03-03 12:42:11','2022-03-03 12:42:11'),(44725,130,'Sandangadu','614615',1,0,'2022-03-03 12:42:11','2022-03-03 12:42:11'),(44726,130,'Sarabendrarajanpattinam','614723',1,0,'2022-03-03 12:42:11','2022-03-03 12:42:11'),(44727,130,'Sembalur','614901',1,0,'2022-03-03 12:42:11','2022-03-03 12:42:11'),(44728,130,'Sendankadu','614901',1,0,'2022-03-03 12:42:11','2022-03-03 12:42:11'),(44729,130,'Sengamangalam','614804',1,0,'2022-03-03 12:42:11','2022-03-03 12:42:11'),(44730,130,'Sengapaduthankadu','614613',1,0,'2022-03-03 12:42:11','2022-03-03 12:42:11'),(44731,130,'Sethubavachatram','614802',1,0,'2022-03-03 12:42:11','2022-03-03 12:42:11'),(44732,130,'Sethurayankudikadu','614902',1,0,'2022-03-03 12:42:11','2022-03-03 12:42:11'),(44733,130,'Sillathur Ktu','614902',1,0,'2022-03-03 12:42:11','2022-03-03 12:42:11'),(44734,130,'Siramelkudi','614903',1,0,'2022-03-03 12:42:11','2022-03-03 12:42:11'),(44735,130,'Siruvalakadu','614803',1,0,'2022-03-03 12:42:11','2022-03-03 12:42:11'),(44736,130,'Siruvaviduthi','614628',1,0,'2022-03-03 12:42:11','2022-03-03 12:42:11'),(44737,130,'Soorapallam','614602',1,0,'2022-03-03 12:42:11','2022-03-03 12:42:11'),(44738,130,'Sornakadu','614804',1,0,'2022-03-03 12:42:11','2022-03-03 12:42:11'),(44739,130,'Srinivasapuram (Thanjavur)','614602',1,0,'2022-03-03 12:42:11','2022-03-03 12:42:11'),(44740,130,'Sydambalpuram','614904',1,0,'2022-03-03 12:42:11','2022-03-03 12:42:11'),(44741,130,'Tamarankottai','614613',1,0,'2022-03-03 12:42:11','2022-03-03 12:42:11'),(44742,130,'Thaligaividuthy','614614',1,0,'2022-03-03 12:42:11','2022-03-03 12:42:11'),(44743,130,'Thambikottai','614704',1,0,'2022-03-03 12:42:12','2022-03-03 12:42:12'),(44744,130,'Thambikottai Melakadu','614704',1,0,'2022-03-03 12:42:12','2022-03-03 12:42:12'),(44745,130,'Thennamanad','614625',1,0,'2022-03-03 12:42:12','2022-03-03 12:42:12'),(44746,130,'Thuvarankurichi','614613',1,0,'2022-03-03 12:42:12','2022-03-03 12:42:12'),(44747,130,'Tiruchitrambalam','614628',1,0,'2022-03-03 12:42:12','2022-03-03 12:42:12'),(44748,130,'Tirumangalakottai','614905',1,0,'2022-03-03 12:42:12','2022-03-03 12:42:12'),(44749,130,'Tirumangalakottai Kilayur','614905',1,0,'2022-03-03 12:42:12','2022-03-03 12:42:12'),(44750,130,'Tirumangalakottai West','614905',1,0,'2022-03-03 12:42:12','2022-03-03 12:42:12'),(44751,130,'Tirunallur Ond','614626',1,0,'2022-03-03 12:42:12','2022-03-03 12:42:12'),(44752,130,'Tiruvattevan','614612',1,0,'2022-03-03 12:42:12','2022-03-03 12:42:12'),(44753,130,'Tiruvonam','614614',1,0,'2022-03-03 12:42:12','2022-03-03 12:42:12'),(44754,130,'Umattanad','614802',1,0,'2022-03-03 12:42:12','2022-03-03 12:42:12'),(44755,130,'Unjividuthi','614614',1,0,'2022-03-03 12:42:12','2022-03-03 12:42:12'),(44756,130,'Uranipuram','614614',1,0,'2022-03-03 12:42:12','2022-03-03 12:42:12'),(44757,130,'Vadakkur','614902',1,0,'2022-03-03 12:42:12','2022-03-03 12:42:12'),(44758,130,'Vadaseri','614905',1,0,'2022-03-03 12:42:12','2022-03-03 12:42:12'),(44759,130,'Vattakudi','614613',1,0,'2022-03-03 12:42:12','2022-03-03 12:42:12'),(44760,130,'Vellur-ond','614626',1,0,'2022-03-03 12:42:12','2022-03-03 12:42:12'),(44761,130,'Vendakottai','614906',1,0,'2022-03-03 12:42:12','2022-03-03 12:42:12'),(44762,130,'Vengarai','614628',1,0,'2022-03-03 12:42:12','2022-03-03 12:42:12'),(44763,130,'Vengarai East','614628',1,0,'2022-03-03 12:42:12','2022-03-03 12:42:12'),(44764,130,'Veppankulam','614906',1,0,'2022-03-03 12:42:12','2022-03-03 12:42:12'),(44765,130,'Vettikadu','614902',1,0,'2022-03-03 12:42:12','2022-03-03 12:42:12'),(44766,130,'Vettuvakottai','614614',1,0,'2022-03-03 12:42:12','2022-03-03 12:42:12'),(44767,130,'Vikramam','614903',1,0,'2022-03-03 12:42:12','2022-03-03 12:42:12'),(44768,130,'Vilankulam','614612',1,0,'2022-03-03 12:42:12','2022-03-03 12:42:12'),(44769,130,'Virayankottai','614802',1,0,'2022-03-03 12:42:13','2022-03-03 12:42:13'),(44770,130,'Achampatti','613402',1,0,'2022-03-03 12:42:13','2022-03-03 12:42:13'),(44771,130,'Adanur','612301',1,0,'2022-03-03 12:42:13','2022-03-03 12:42:13'),(44772,130,'Agaramangudi','614303',1,0,'2022-03-03 12:42:13','2022-03-03 12:42:13'),(44773,130,'Aimbadumelnagaram','613101',1,0,'2022-03-03 12:42:13','2022-03-03 12:42:13'),(44774,130,'Aiyanapuram','613602',1,0,'2022-03-03 12:42:13','2022-03-03 12:42:13'),(44775,130,'Alakkudi','613601',1,0,'2022-03-03 12:42:13','2022-03-03 12:42:13'),(44776,130,'Allur','613101',1,0,'2022-03-03 12:42:13','2022-03-03 12:42:13'),(44777,130,'Ammapet','614401',1,0,'2022-03-03 12:42:13','2022-03-03 12:42:13'),(44778,130,'Anaikudi','613204',1,0,'2022-03-03 12:42:13','2022-03-03 12:42:13'),(44779,130,'Annappanpettai','613003',1,0,'2022-03-03 12:42:13','2022-03-03 12:42:13'),(44780,130,'Arasapattu','614019',1,0,'2022-03-03 12:42:13','2022-03-03 12:42:13'),(44781,130,'Arisikara Street','613001',1,0,'2022-03-03 12:42:13','2022-03-03 12:42:13'),(44782,130,'Arkadu','613205',1,0,'2022-03-03 12:42:13','2022-03-03 12:42:13'),(44783,130,'Arsuthipattu','613504',1,0,'2022-03-03 12:42:13','2022-03-03 12:42:13'),(44784,130,'Arundavapuram','614402',1,0,'2022-03-03 12:42:13','2022-03-03 12:42:13'),(44785,130,'Avarampatti','613602',1,0,'2022-03-03 12:42:13','2022-03-03 12:42:13'),(44786,130,'Ayyampet R.S','614211',1,0,'2022-03-03 12:42:13','2022-03-03 12:42:13'),(44787,130,'Ayyampet','614201',1,0,'2022-03-03 12:42:13','2022-03-03 12:42:13'),(44788,130,'Budalur','613602',1,0,'2022-03-03 12:42:13','2022-03-03 12:42:13'),(44789,130,'Chakrapalli','614211',1,0,'2022-03-03 12:42:13','2022-03-03 12:42:13'),(44790,130,'Chennampatti','613403',1,0,'2022-03-03 12:42:13','2022-03-03 12:42:13'),(44791,130,'Chinnakadaitheru','614401',1,0,'2022-03-03 12:42:13','2022-03-03 12:42:13'),(44792,130,'Chitrakudi','613602',1,0,'2022-03-03 12:42:13','2022-03-03 12:42:13'),(44793,130,'Co-operative Buildings','613009',1,0,'2022-03-03 12:42:13','2022-03-03 12:42:13'),(44794,130,'Devarayanpettai','614204',1,0,'2022-03-03 12:42:13','2022-03-03 12:42:13'),(44795,130,'Elangadu-TPL','613104',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44796,130,'Ganapathi Agraharam','614202',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44797,130,'Ganapathi Nagar','613007',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44798,130,'Gudalur','613003',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44799,130,'Ichangudi','613204',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44800,130,'Idaiyiruppu','614302',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44801,130,'Ilangarkudi','614203',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44802,130,'Iluppakorai','614202',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44803,130,'Inayathukkanpatti','613005',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44804,130,'Indalur','613102',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44805,130,'Irudayapuram','613001',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44806,130,'Irumbuthalai','613504',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44807,130,'Jambugambalpuram','613502',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44808,130,'Kabistalam','614203',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44809,130,'Kachamangalam','613102',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44810,130,'Kadakadappai','613003',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44811,130,'Kalancheri','613504',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44812,130,'Kalathur','612802',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44813,130,'Kalimedu','613002',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44814,130,'Kallaperambur','613601',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44815,130,'Kalumangalam','613602',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44816,130,'Kalvirayanpettai','613601',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44817,130,'Kalyanapuram','613201',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44818,130,'Kambayarnatham','613504',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44819,130,'Kandamangalam','613104',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44820,130,'Kandiyur','613202',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44821,130,'Kangeyampatti','613602',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44822,130,'Kaniyakurichi','614017',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44823,130,'Karuntattankudi','613002',1,0,'2022-03-03 12:42:14','2022-03-03 12:42:14'),(44824,130,'Karuppur-KBS','614203',1,0,'2022-03-03 12:42:15','2022-03-03 12:42:15'),(44825,130,'Kattur','614019',1,0,'2022-03-03 12:42:15','2022-03-03 12:42:15'),(44826,130,'Kavalur','614303',1,0,'2022-03-03 12:42:15','2022-03-03 12:42:15'),(44827,130,'Kilakurichi','614015',1,0,'2022-03-03 12:42:15','2022-03-03 12:42:15'),(44828,130,'Kilathiruppanthuruthi','613103',1,0,'2022-03-03 12:42:15','2022-03-03 12:42:15'),(44829,130,'Kiliyur','614208',1,0,'2022-03-03 12:42:15','2022-03-03 12:42:15'),(44830,130,'Koildevarayanpettai','614204',1,0,'2022-03-03 12:42:15','2022-03-03 12:42:15'),(44831,130,'Kokkeri','614402',1,0,'2022-03-03 12:42:15','2022-03-03 12:42:15'),(44832,130,'Konerirajapuram','613101',1,0,'2022-03-03 12:42:15','2022-03-03 12:42:15'),(44833,130,'Kovathagudi','614301',1,0,'2022-03-03 12:42:15','2022-03-03 12:42:15'),(44834,130,'Koviladi-TPL','613105',1,0,'2022-03-03 12:42:15','2022-03-03 12:42:15'),(44835,130,'Kovilur (Pundi-Tj)','613502',1,0,'2022-03-03 12:42:15','2022-03-03 12:42:15'),(44836,130,'Kulamangalam','614019',1,0,'2022-03-03 12:42:15','2022-03-03 12:42:15'),(44837,130,'Kulichapattu','613501',1,0,'2022-03-03 12:42:15','2022-03-03 12:42:15'),(44838,130,'Kumilakudi','613502',1,0,'2022-03-03 12:42:15','2022-03-03 12:42:15'),(44839,130,'Kurungulam','613303',1,0,'2022-03-03 12:42:15','2022-03-03 12:42:15'),(44840,130,'Kurungulam Melpathi','613303',1,0,'2022-03-03 12:42:15','2022-03-03 12:42:15'),(44841,130,'Kuthur','613104',1,0,'2022-03-03 12:42:15','2022-03-03 12:42:15'),(44842,130,'Maharajapuram','613104',1,0,'2022-03-03 12:42:15','2022-03-03 12:42:15'),(44843,130,'Mahimalai','614401',1,0,'2022-03-03 12:42:15','2022-03-03 12:42:15'),(44844,130,'Manalur','614202',1,0,'2022-03-03 12:42:15','2022-03-03 12:42:15'),(44845,130,'Manambuchavadi','613001',1,0,'2022-03-03 12:42:15','2022-03-03 12:42:15'),(44846,130,'Manangorai','614206',1,0,'2022-03-03 12:42:15','2022-03-03 12:42:15'),(44847,130,'Manayeripatti','613402',1,0,'2022-03-03 12:42:15','2022-03-03 12:42:15'),(44848,130,'Manojipatti','613004',1,0,'2022-03-03 12:42:15','2022-03-03 12:42:15'),(44849,130,'Mariammancoil','613501',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44850,130,'Marudakudi','613602',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44851,130,'Marungulam','613006',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44852,130,'Maruvur','613203',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44853,130,'Mathur-AYP','614206',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44854,130,'Mattayanthidal','614302',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44855,130,'Mekalathur','613102',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44856,130,'Melakalakudi','613501',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44857,130,'Melattur (Thanjavur)','614301',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44858,130,'Melavasthachavadi','613005',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44859,130,'MGM Sanatorium','613402',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44860,130,'Michaelpatti','613104',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44861,130,'Mohamed Bunder','613201',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44862,130,'Mukasa Nanjikottai','613006',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44863,130,'Mukasakaduveli','613203',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44864,130,'Mullakudi','613104',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44865,130,'Murthiambalpuram','614019',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44866,130,'Muthandipatti','613402',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44867,130,'Nadukaveri','613101',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44868,130,'Nagathi','613205',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44869,130,'Nallavanniyankudikadu','613502',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44870,130,'Nariyanur','614301',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44871,130,'Neduntheru','614210',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44872,130,'Neivasal','614019',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44873,130,'Nemam','613104',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44874,130,'Odayalur','612804',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44875,130,'Odayarkoil','614402',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44876,130,'Ombathuveli','614302',1,0,'2022-03-03 12:42:16','2022-03-03 12:42:16'),(44877,130,'Orathur','613602',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44878,130,'Palamaneri','613104',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44879,130,'Palayapatti South','613402',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44880,130,'Palliagraharam','613003',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44881,130,'Palliyur','613504',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44882,130,'Pandaravadai','614204',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44883,130,'Papanasam Bazaar','614205',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44884,130,'Papanasam H.O','614205',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44885,130,'Papanasam Public Office','614205',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44886,130,'Papanasam West','614205',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44887,130,'Pasupathikoil','614206',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44888,130,'Peramur','613204',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44889,130,'Pillaiyarpatti','613403',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44890,130,'Ponavasal','613204',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44891,130,'Pookkara Street','613001',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44892,130,'Poondi-TPL','613105',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44893,130,'Puduchatram','613105',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44894,130,'Pudukudi','613402',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44895,130,'Pulavarnatham','613501',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44896,130,'Puliyakudi','614402',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44897,130,'Pullabudangudi','612301',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44898,130,'Pundi-TJ','613502',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44899,130,'Puthur-AME','614402',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44900,130,'Puthur-PSM','614202',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44901,130,'Ragavambalpuram','614019',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44902,130,'Raja Serfoji Govt College','613005',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44903,130,'Rajaghiri','614207',1,0,'2022-03-03 12:42:17','2022-03-03 12:42:17'),(44904,130,'Rajappa Nagar','613007',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44905,130,'Ramanathapuram','613004',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44906,130,'Ramapuram','613003',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44907,130,'Raramuthirakottai','613501',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44908,130,'Ravusapatti','613403',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44909,130,'Rayamundanpatti','613402',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44910,130,'Renganathapuram','613104',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44911,130,'Royampettai','613204',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44912,130,'Royandur','613602',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44913,130,'Sakkarasamandam','613002',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44914,130,'Saliamangalam Bazaar','613504',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44915,130,'Saliamangalam','613504',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44916,130,'Sarukkai','614203',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44917,130,'Sathanur','613203',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44918,130,'Sathyamangalam','614203',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44919,130,'Sendalai','613101',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44920,130,'Sengipatti','613402',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44921,130,'Seyyamangalam','613102',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44922,130,'Sholagampatti','613102',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44923,130,'Someswarapuram','613204',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44924,130,'Soolamangalam','614206',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44925,130,'Sri Pushpam College','613503',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44926,130,'Srinivasapuram','613009',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44927,130,'State Bank Colony','613004',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44928,130,'Suliyakottai','613504',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44929,130,'Sundaraperumalkoil','614208',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44930,130,'Talayamangalam(VDR)','614019',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44931,130,'Tamil University','613010',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44932,130,'Tandankorai','614206',1,0,'2022-03-03 12:42:18','2022-03-03 12:42:18'),(44933,130,'Tennangudi','613601',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44934,130,'Thanjavur Bazaar','613001',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44935,130,'Thanjavur City','613001',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44936,130,'Thanjavur Collectorate','613001',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44937,130,'Thanjavur East Gate','613001',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44938,130,'Thanjavur East','613001',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44939,130,'Thanjavur H.O','613001',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44940,130,'Thanjavur Housing Unit','613007',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44941,130,'Thanjavur Medical College','613004',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44942,130,'Thanjavur North Gate','613008',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44943,130,'Thanjavur P&t Colony','613006',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44944,130,'Thanjavur South','613001',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44945,130,'Thanjavur West','613009',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44946,130,'Thethuvasalpatti','613303',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44947,130,'Thillaisthanam','613203',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44948,130,'Thillaiyambur','612804',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44949,130,'Thiruppanthuruthi','613103',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44950,130,'Thiruvaiyaru','613204',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44951,130,'Thiruvaiyaru Thiyagaraja Colony','613204',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44952,130,'Thiruvalampozhil','613103',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44953,130,'Thogur','613102',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44954,130,'Tiruchinampoondi','613105',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44955,130,'Tiruchottuthurai','613202',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44956,130,'Tirukanurpatti','613303',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44957,130,'Tirukattupalli East','613104',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44958,130,'Tirukattupalli','613104',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44959,130,'Tirukkarugavur','614302',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44960,130,'Tirukoilpathu','614402',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44961,130,'Tirumalaisamudram','613401',1,0,'2022-03-03 12:42:19','2022-03-03 12:42:19'),(44962,130,'Tirumalaisamudram East','613401',1,0,'2022-03-03 12:42:20','2022-03-03 12:42:20'),(44963,130,'Tirumandangudi','612301',1,0,'2022-03-03 12:42:20','2022-03-03 12:42:20'),(44964,130,'Tiruppayanam','613204',1,0,'2022-03-03 12:42:20','2022-03-03 12:42:20'),(44965,130,'Tiruvaikavur','612301',1,0,'2022-03-03 12:42:20','2022-03-03 12:42:20'),(44966,130,'Tittai','613003',1,0,'2022-03-03 12:42:20','2022-03-03 12:42:20'),(44967,130,'TJ Busstand','613001',1,0,'2022-03-03 12:42:20','2022-03-03 12:42:20'),(44968,130,'TJ Co-operative Housing Colony','613007',1,0,'2022-03-03 12:42:20','2022-03-03 12:42:20'),(44969,130,'Tyagasamudram','612301',1,0,'2022-03-03 12:42:20','2022-03-03 12:42:20'),(44970,130,'Ukkadai','614401',1,0,'2022-03-03 12:42:20','2022-03-03 12:42:20'),(44971,130,'Ullikadai','614202',1,0,'2022-03-03 12:42:20','2022-03-03 12:42:20'),(44972,130,'Umayalpuram','614203',1,0,'2022-03-03 12:42:20','2022-03-03 12:42:20'),(44973,130,'Umbalapadi','614203',1,0,'2022-03-03 12:42:20','2022-03-03 12:42:20'),(44974,130,'Uthamadhanapuram','614205',1,0,'2022-03-03 12:42:20','2022-03-03 12:42:20'),(44975,130,'Uthamanallur','613201',1,0,'2022-03-03 12:42:20','2022-03-03 12:42:20'),(44976,130,'Vadakkumangudi','614303',1,0,'2022-03-03 12:42:20','2022-03-03 12:42:20'),(44977,130,'Vaidyanathanpettai','613203',1,0,'2022-03-03 12:42:20','2022-03-03 12:42:20'),(44978,130,'Vaiyacheri','614206',1,0,'2022-03-03 12:42:20','2022-03-03 12:42:20'),(44979,130,'Valamarkottai','614019',1,0,'2022-03-03 12:42:20','2022-03-03 12:42:20'),(44980,130,'Valappakudi','613104',1,0,'2022-03-03 12:42:20','2022-03-03 12:42:20'),(44981,130,'Vallam East','613403',1,0,'2022-03-03 12:42:20','2022-03-03 12:42:20'),(44982,130,'Vallam Pudur','613401',1,0,'2022-03-03 12:42:20','2022-03-03 12:42:20'),(44983,130,'Vallam-TJ','613403',1,0,'2022-03-03 12:42:20','2022-03-03 12:42:20'),(44984,130,'Valoothoor','614210',1,0,'2022-03-03 12:42:20','2022-03-03 12:42:20'),(44985,130,'Vandayariruppu','614019',1,0,'2022-03-03 12:42:20','2022-03-03 12:42:20'),(44986,130,'Vannarapettai','613601',1,0,'2022-03-03 12:42:20','2022-03-03 12:42:20'),(44987,130,'Varagur','613101',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(44988,130,'Vediapuram','613205',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(44989,130,'Veeramangudi','613204',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(44990,130,'Vellamperambur','613101',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(44991,130,'Vembakudi','614303',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(44992,130,'Vendayampatti','613402',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(44993,130,'Vennamangalam','613602',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(44994,130,'Vennar Bank','613003',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(44995,130,'Vilangudi','613204',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(44996,130,'Vilar','613006',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(44997,130,'Vishnampettai','613105',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(44998,130,'Voc Nagar','613007',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(44999,131,'A.Vadipatti','625602',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(45000,131,'Agamalai','625605',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(45001,131,'Alagapuri','625523',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(45002,131,'Allinagaram','625531',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(45003,131,'Ammapatti','625512',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(45004,131,'Ammatchiapuram','625531',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(45005,131,'Anaikaraipatti','625582',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(45006,131,'Anamalayanpatti','625526',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(45007,131,'Angoorpal','625518',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(45008,131,'Annanji','625531',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(45009,131,'Appipatti','625515',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(45010,131,'Athankaraipatti','625517',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(45011,131,'Aundipatti','625512',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(45012,131,'B.Ammapatti','625528',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(45013,131,'B.Meenakshipuram','625582',1,0,'2022-03-03 12:42:21','2022-03-03 12:42:21'),(45014,131,'Bangalamedu','625531',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45015,131,'Bodidasanpatti','625536',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45016,131,'Bodimettu','625582',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45017,131,'Bodinayakanur H.O','625513',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45018,131,'Bodinayakanur R.S.','625582',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45019,131,'Bomminayakanpatti','625602',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45020,131,'Buthipuram','625531',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45021,131,'C.Pudupatti','625556',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45022,131,'Central Station','625582',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45023,131,'Chinnakattalai','625527',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45024,131,'Chinnamanur','625515',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45025,131,'Chinnaovalapuram','625515',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45026,131,'Cumbum (Theni)','625516',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45027,131,'Devadanapatti','625602',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45028,131,'Dharmapuri','625520',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45029,131,'Dombcherry','625582',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45030,131,'Endapuli','625604',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45031,131,'Erasakkanayakanur','625515',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45032,131,'Erumalainayakanpatti','625602',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45033,131,'Ethakovil','625536',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45034,131,'G.Kallupatti','625203',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45035,131,'G.Usilampatti','625517',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45036,131,'Gandamanayakanur','625517',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45037,131,'Gandhinagar (Cumbum)','625516',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45038,131,'Genguvarpatti','625203',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45039,131,'Gokilapuram','625526',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45040,131,'Gopalapuram','625534',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45041,131,'Govindagaram','625517',1,0,'2022-03-03 12:42:22','2022-03-03 12:42:22'),(45042,131,'Gudalur','625518',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45043,131,'Gullapuram','625562',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45044,131,'Hanumanthanpatti','625533',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45045,131,'Highwavys','625519',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45046,131,'Jangalpatti','625520',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45047,131,'Jeyamangalam','625603',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45048,131,'Kadamalaikundu','625579',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45049,131,'Kamarajapuram','625582',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45050,131,'Kamatchipuram','625520',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45051,131,'Kamayakoundanpatti','625521',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45052,131,'Kanniappapillaipatti','625512',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45053,131,'Kanniservaipatti','625515',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45054,131,'Karunagamuthanpatti','625516',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45055,131,'Keelagudalur','625518',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45056,131,'Kodangipatti','625531',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45057,131,'Koduvilarpatti','625534',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45058,131,'Koilpatti','625562',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45059,131,'Kombai','625522',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45060,131,'Kombaitholu','625579',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45061,131,'Koolayanur','625515',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45062,131,'Kothaloothu','625512',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45063,131,'Kothapatti','625512',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45064,131,'Kottagudi','625582',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45065,131,'Kottur','625534',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45066,131,'Kovilparai','625579',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45067,131,'Krishnampatti','625530',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45068,131,'Kujjanur','625515',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45069,131,'Kullappagoundanpatti','625516',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45070,131,'Kumizhantholu','625579',1,0,'2022-03-03 12:42:23','2022-03-03 12:42:23'),(45071,131,'Kunnur','625531',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45072,131,'Kuppinayakanpatti','625520',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45073,131,'Kurangani','625582',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45074,131,'Lakshminayakanpatti','625530',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45075,131,'Lakshmipuram (Theni)','625523',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45076,131,'Manalar','625519',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45077,131,'Manjalar Dam','625602',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45078,131,'Marikundu','625517',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45079,131,'Markeyankottai','625515',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45080,131,'Mayiladumparai','625579',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45081,131,'Megamalai','625515',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45082,131,'Melachokkanathapuram','625582',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45083,131,'Melasindalachery','625524',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45084,131,'Melmangalam','625603',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45085,131,'Moolakadai','625579',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45086,131,'Mottanuthu','625512',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45087,131,'Murugamalainagar','625605',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45088,131,'Muthulapuram','625515',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45089,131,'Nagalapuram','625528',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45090,131,'Nallakaruppanpatti','625604',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45091,131,'Narayanathevanpatti','625521',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45092,131,'Odaipatti','625540',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45093,131,'Okkaraipatti','625517',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45094,131,'P.Dharmathupatti','625536',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45095,131,'Palacombai','625512',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45096,131,'Palanichettipatti','625531',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45097,131,'Pallavarayanpatti','625524',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45098,131,'Pannaipuram','625524',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45099,131,'Periyakulam Bazaar','625601',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45100,131,'Periyakulam East','625604',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45101,131,'Periyakulam H.O','625601',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45102,131,'Periyar Project','625525',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45103,131,'Poomalaikundu','625520',1,0,'2022-03-03 12:42:24','2022-03-03 12:42:24'),(45104,131,'Poosanuthu','625579',1,0,'2022-03-03 12:42:25','2022-03-03 12:42:25'),(45105,131,'Pottipuram','625528',1,0,'2022-03-03 12:42:25','2022-03-03 12:42:25'),(45106,131,'Pulikuthi','625524',1,0,'2022-03-03 12:42:25','2022-03-03 12:42:25'),(45107,131,'Pullimankombai','625536',1,0,'2022-03-03 12:42:25','2022-03-03 12:42:25'),(45108,131,'Rajadhani','625512',1,0,'2022-03-03 12:42:25','2022-03-03 12:42:25'),(45109,131,'Rajagopalanpatti','625536',1,0,'2022-03-03 12:42:25','2022-03-03 12:42:25'),(45110,131,'Rasingapuram','625528',1,0,'2022-03-03 12:42:25','2022-03-03 12:42:25'),(45111,131,'Rengasamudram','625562',1,0,'2022-03-03 12:42:25','2022-03-03 12:42:25'),(45112,131,'Rosanampatti','625512',1,0,'2022-03-03 12:42:25','2022-03-03 12:42:25'),(45113,131,'Royappanpatti','625526',1,0,'2022-03-03 12:42:25','2022-03-03 12:42:25'),(45114,131,'Sankarapuram','625530',1,0,'2022-03-03 12:42:25','2022-03-03 12:42:25'),(45115,131,'Saruthupatti','625523',1,0,'2022-03-03 12:42:25','2022-03-03 12:42:25'),(45116,131,'Sathakoilpatti','625602',1,0,'2022-03-03 12:42:25','2022-03-03 12:42:25'),(45117,131,'Seelayampatti','625515',1,0,'2022-03-03 12:42:25','2022-03-03 12:42:25'),(45118,131,'Seepalakottai','625540',1,0,'2022-03-03 12:42:25','2022-03-03 12:42:25'),(45119,131,'Shunmugasundarapuram','625512',1,0,'2022-03-03 12:42:25','2022-03-03 12:42:25'),(45120,131,'Silamalai','625528',1,0,'2022-03-03 12:42:25','2022-03-03 12:42:25'),(45121,131,'Sillamarathupatti','625528',1,0,'2022-03-03 12:42:25','2022-03-03 12:42:25'),(45122,131,'Silvarpatti','625602',1,0,'2022-03-03 12:42:25','2022-03-03 12:42:25'),(45123,131,'Sindalacherry','625530',1,0,'2022-03-03 12:42:25','2022-03-03 12:42:25'),(45124,131,'Siraparai','625579',1,0,'2022-03-03 12:42:25','2022-03-03 12:42:25'),(45125,131,'Srirengapuram','625534',1,0,'2022-03-03 12:42:25','2022-03-03 12:42:25'),(45126,131,'Subburajnagar','625582',1,0,'2022-03-03 12:42:25','2022-03-03 12:42:25'),(45127,131,'Sukkangalpatti','625540',1,0,'2022-03-03 12:42:25','2022-03-03 12:42:25'),(45128,131,'Surulipatti','625516',1,0,'2022-03-03 12:42:25','2022-03-03 12:42:25'),(45129,131,'Suruliyar Lower Camp','625525',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45130,131,'T.Kallipatti','625605',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45131,131,'T.Meenatchipuram','625530',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45132,131,'T.Nagar (Theni)','625531',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45133,131,'T.Subbulapuram','625536',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45134,131,'T.V.Renganathapuram','625536',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45135,131,'Tadichery','625534',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45136,131,'Tamarakulam','625605',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45137,131,'Thamminayakanpatti','625530',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45138,131,'Thangammalpuram','625579',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45139,131,'Thekkampatti','625517',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45140,131,'Theni','625531',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45141,131,'Theppampatti','625512',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45142,131,'Thevaram','625530',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45143,131,'Thimmarasanayakanur','625536',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45144,131,'Thullukuttinayakanur','625705',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45145,131,'Thummagundu','625579',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45146,131,'U.Ammapatti','625533',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45147,131,'Upparpatti','625534',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45148,131,'Uppukottai','625534',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45149,131,'Uthamapalayam Bazar','625533',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45150,131,'Uthamapalayam','625533',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45151,131,'Uthamapalayam West','625533',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45152,131,'Vadagarai','625601',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45153,131,'Vadugapatti','625603',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45154,131,'Vaigaidamsite','625562',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45155,131,'Vaigaiproject','625562',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45156,131,'Varadharajnagar','625562',1,0,'2022-03-03 12:42:26','2022-03-03 12:42:26'),(45157,131,'Varushanadu','625579',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45158,131,'Veerapandi (Theni)','625534',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45159,131,'Vellaiyammalpuram','625540',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45160,131,'Venkatachalapuram','625534',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45161,131,'Venniar Estate','625519',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45162,132,'A.Pudupatti','621308',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45163,132,'Adhigaram','621314',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45164,132,'Alagagoundanpatti','621310',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45165,132,'Alipatti','621306',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45166,132,'Amayapuram','621307',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45167,132,'Anampatti','621312',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45168,132,'Aniyapur','621307',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45169,132,'Avarampatti','621307',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45170,132,'Ayanporuvai','621308',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45171,132,'Chettiapatti','621307',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45172,132,'Chithanatham','621312',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45173,132,'Elamanam','621302',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45174,132,'Elangakurichi','621302',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45175,132,'Endapuli','621310',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45176,132,'Firka Kilaiyur','621312',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45177,132,'Ikkaraikosikurichi','621314',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45178,132,'Inamponnambalapatti','621315',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45179,132,'K.Periyapatti','621306',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45180,132,'Kalingapatti','621308',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45181,132,'Kallupatti','621305',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45182,132,'Kalpatti','621315',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45183,132,'Kanjanaickenpatti','621314',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45184,132,'Kannivadugapatti','621310',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45185,132,'Kannudayanpatti','621312',1,0,'2022-03-03 12:42:27','2022-03-03 12:42:27'),(45186,132,'Kannuthu','621315',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45187,132,'Karaipatti','621314',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45188,132,'Karumakavundanpatti','621307',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45189,132,'Karumalai','621310',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45190,132,'Karungulam','621315',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45191,132,'Karuppur (Manaparai)','621310',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45192,132,'Kodumbapatti','621308',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45193,132,'Kovilpatti','621305',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45194,132,'Kumaravadi','621302',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45195,132,'Malayadipatti','621307',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45196,132,'Manaparai R.S','621306',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45197,132,'Manaparai','621306',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45198,132,'Maniyankurichi','621310',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45199,132,'Manjampatti','621307',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45200,132,'Marungapuri','621305',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45201,132,'Mohavanur','621302',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45202,132,'Mutalvarapatti','621305',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45203,132,'Muthapudayanpatti','621306',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45204,132,'N.Poolampatti','621302',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45205,132,'Nadupatti','621315',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45206,132,'Nallampillai','621307',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45207,132,'Palakurichi','621308',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45208,132,'Palayakottai','621302',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45209,132,'Palayapalayam','621314',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45210,132,'Paluvanji','621305',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45211,132,'Pannankombu','621306',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45212,132,'Pannipatti','621302',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45213,132,'Periya Anaikaraipatti','621315',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45214,132,'Pillupatti','621314',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45215,132,'Piranpatti  (Manaparai)','621305',1,0,'2022-03-03 12:42:28','2022-03-03 12:42:28'),(45216,132,'Poigaipatti','621306',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45217,132,'Ponnaiar Dam','621315',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45218,132,'Poosaripatti','621307',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45219,132,'Porathakudi','621302',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45220,132,'Pothamettupatti','621306',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45221,132,'Pudukkottai (Vaiyampatti)','621315',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45222,132,'Puthanatham','621310',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45223,132,'Samudram','621312',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45224,132,'Sevalpatti','621314',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45225,132,'Sevalur','621306',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45226,132,'T.Idayapatti','621308',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45227,132,'Tadakkavundanpatti','621305',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45228,132,'Thavalaveeranpatti','621311',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45229,132,'Thenur (Manaparai)','621308',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45230,132,'Thethur','621314',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45231,132,'Thiagesaralai','621312',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45232,132,'Thoppanaickenpatti','621315',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45233,132,'Thottiapatti','621305',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45234,132,'Thuvarankurichi','621314',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45235,132,'Tirunellipatti','621310',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45236,132,'V.Periyapatti','621302',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45237,132,'Vaiyampatti','621315',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45238,132,'Valanadu','621308',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45239,132,'Valayapatti (Manaparai)','621302',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45240,132,'Vellalapatti','621307',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45241,132,'Vengaikurichi','621307',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45242,132,'Yagapuram','621305',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45243,132,'A.A. College','621211',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45244,132,'Abinimangalam','621007',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45245,132,'Adhanur','621014',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45246,132,'Alagapuri','621210',1,0,'2022-03-03 12:42:29','2022-03-03 12:42:29'),(45247,132,'Alagarai','621209',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45248,132,'Alagiamanavalam','621005',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45249,132,'Alathudayanpatti','621003',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45250,132,'Ammamandapam','620006',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45251,132,'Ammangudi','621208',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45252,132,'Ammapatti','621014',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45253,132,'Amur','621204',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45254,132,'Angiyam','621210',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45255,132,'Appanallur','621208',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45256,132,'Arachi','621214',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45257,132,'Arangoor','621215',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45258,132,'Arasalur','621203',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45259,132,'Ayyampalayam','621202',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45260,132,'B.Mettur','621003',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45261,132,'Baderpettai','621001',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45262,132,'Balakrishnampatti','621003',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45263,132,'Balasamudram (Tiruchirappalli)','621203',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45264,132,'Bikshandarkoil','621216',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45265,132,'C.Ayyampalayam','621005',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45266,132,'Chinnakodunthurai','621202',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45267,132,'Chinnapallipalayam','621207',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45268,132,'Cholanganallur','621213',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45269,132,'Devanur','621214',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45270,132,'Devarappampatti','621206',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45271,132,'Devimangalam','621112',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45272,132,'Edumalai','621007',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45273,132,'Erakudi','621001',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45274,132,'EVR Nagar','620005',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45275,132,'Evur','621202',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45276,132,'Govindapuram','621008',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45277,132,'Gunasilam','621204',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45278,132,'Irungalur','621105',1,0,'2022-03-03 12:42:30','2022-03-03 12:42:30'),(45279,132,'Iyyampalayam','621206',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45280,132,'Jadamangalam','621214',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45281,132,'Jambumadai','621214',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45282,132,'Jambunathapuram','621205',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45283,132,'Jayankondam','621205',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45284,132,'K.Palayam','621206',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45285,132,'Kaduvetti','621207',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45286,132,'Kalingamudayanpatti','621008',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45287,132,'Kaliyampatti','621014',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45288,132,'Kalladipatti','621014',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45289,132,'Kalpalayam','621005',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45290,132,'Kamalapuram','621215',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45291,132,'Kannanur','621206',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45292,132,'Karattampatti','621014',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45293,132,'Kargudi','621210',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45294,132,'Karikali','621210',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45295,132,'Kariyamanickam','621005',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45296,132,'Kattanampatti','621206',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45297,132,'Kattukulam','621009',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45298,132,'Kattuputhur','621207',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45299,132,'Kidaram','621207',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45300,132,'Kilakunnupatti','621004',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45301,132,'Kilianallur','621213',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45302,132,'Kinathur','621002',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45303,132,'Kirambur','621002',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45304,132,'Kolakkudi','621208',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45305,132,'Konalai','621105',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45306,132,'Konappampatti','621208',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45307,132,'Kondayampettai','620005',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45308,132,'Koppampatti','621012',1,0,'2022-03-03 12:42:31','2022-03-03 12:42:31'),(45309,132,'Kothampatti','621206',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45310,132,'Kottaiyur','621001',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45311,132,'Kottapalayam','621003',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45312,132,'Kottathur','621004',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45313,132,'Kovathakudi','621005',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45314,132,'Kurichi','621002',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45315,132,'Kuthur','621216',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45316,132,'M.Pudupatti','621211',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45317,132,'M.Puthur','621203',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45318,132,'Mahadevi','621214',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45319,132,'Mambarai','621006',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45320,132,'Manachanalloor','621005',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45321,132,'Manalodai','621002',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45322,132,'Manamedu','621209',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45323,132,'Mangalam','621205',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45324,132,'Maradi','621003',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45325,132,'Marudur','621112',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45326,132,'Maruvathur','621002',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45327,132,'Mavilipatti','621205',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45328,132,'Melur','620006',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45329,132,'Mettupalayam','621210',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45330,132,'Mettupatti','621211',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45331,132,'Minnathampatti','621215',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45332,132,'Moovanur','621006',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45333,132,'Murukkur','621008',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45334,132,'Murungai','621207',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45335,132,'Murungai Kalathur','621207',1,0,'2022-03-03 12:42:32','2022-03-03 12:42:32'),(45336,132,'Musiri','621211',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45337,132,'Muthiyampalayam','621004',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45338,132,'Nachilipatti','621011',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45339,132,'Naduvalur','621004',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45340,132,'Nagaiyanallur','621207',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45341,132,'Nagalapuram','621002',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45342,132,'Nagamanaickenpatti','621001',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45343,132,'Naganallur','621012',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45344,132,'Natham Balasamudram','621008',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45345,132,'Nedungur','621105',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45346,132,'Neeliampatti','621208',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45347,132,'Neikuppai','621111',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45348,132,'Neiveli','621217',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45349,132,'Nettavelampatti','621003',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45350,132,'Nochiam','621216',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45351,132,'Odayalampudur','621215',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45352,132,'Oddampatti','621008',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45353,132,'Okkarai','621008',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45354,132,'Omandur','621006',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45355,132,'Pachaperumalpatti','621003',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45356,132,'Pagalavadi','621014',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45357,132,'Paithamparai','621205',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45358,132,'Pallividai','621112',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45359,132,'Parvathipuram','621211',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45360,132,'Perahambi','621104',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45361,132,'Peramangalam','621006',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45362,132,'Periyakurukkai','621105',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45363,132,'Periyamangalam','621011',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45364,132,'Perur','621205',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45365,132,'Pidaramangalam','621207',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45366,132,'Pillapalayam','621210',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45367,132,'Ponnusangampatti','621206',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45368,132,'Poolambadi','621110',1,0,'2022-03-03 12:42:33','2022-03-03 12:42:33'),(45369,132,'Poolancheri','621208',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45370,132,'Poonampalayam','621009',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45371,132,'Puduattur','621101',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45372,132,'Pudur','621002',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45373,132,'Pukkathurai','621213',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45374,132,'Pulivalam (Tiruchirappalli)','621006',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45375,132,'Purathakudi','621111',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45376,132,'Puthanampatti','621007',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45377,132,'Puthur','621011',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45378,132,'R.Valavanur','621111',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45379,132,'Rajampalayam','621005',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45380,132,'Reddiapatti','621001',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45381,132,'Reddimangudi','621105',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45382,132,'Renganagar','620006',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45383,132,'Samayapuram','621112',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45384,132,'Sangampatti','621001',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45385,132,'Sellipalayam','621002',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45386,132,'Sembulichampatti','621002',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45387,132,'Senappanallur','621001',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45388,132,'Sengattupatti','621002',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45389,132,'Sennakarai','621213',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45390,132,'Sergudi','621208',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45391,132,'Servaikaranpatti','621215',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45392,132,'Shanamangalam','621104',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45393,132,'Sikkathambur','621008',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45394,132,'Silaipillaiyarputhur','621207',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45395,132,'Singalandapuram','621014',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45396,132,'Sirugambur','621213',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45397,132,'Siruganur','621105',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45398,132,'Sirunavalur','621001',1,0,'2022-03-03 12:42:34','2022-03-03 12:42:34'),(45399,132,'Sirupathur','621009',1,0,'2022-03-03 12:42:35','2022-03-03 12:42:35'),(45400,132,'Sithambur','621204',1,0,'2022-03-03 12:42:35','2022-03-03 12:42:35'),(45401,132,'Sittalarai','621211',1,0,'2022-03-03 12:42:35','2022-03-03 12:42:35'),(45402,132,'Sorathur','621002',1,0,'2022-03-03 12:42:35','2022-03-03 12:42:35'),(45403,132,'Srinivasanagar (Tiruchirappalli)','620005',1,0,'2022-03-03 12:42:35','2022-03-03 12:42:35'),(45404,132,'Srinivasanallur','621209',1,0,'2022-03-03 12:42:35','2022-03-03 12:42:35'),(45405,132,'Sriramasamudram','621207',1,0,'2022-03-03 12:42:35','2022-03-03 12:42:35'),(45406,132,'Srirangam H.O','620006',1,0,'2022-03-03 12:42:35','2022-03-03 12:42:35'),(45407,132,'Srirangam North','620006',1,0,'2022-03-03 12:42:35','2022-03-03 12:42:35'),(45408,132,'Srirangam West','620006',1,0,'2022-03-03 12:42:35','2022-03-03 12:42:35'),(45409,132,'Sundaikkai','621202',1,0,'2022-03-03 12:42:35','2022-03-03 12:42:35'),(45410,132,'Surampatti','621208',1,0,'2022-03-03 12:42:35','2022-03-03 12:42:35'),(45411,132,'T','pudupatti',1,0,'2022-03-03 12:42:35','2022-03-03 12:42:35'),(45412,132,'T.Baderpettai','621012',1,0,'2022-03-03 12:42:35','2022-03-03 12:42:35'),(45413,132,'T.Murungaipatti','621012',1,0,'2022-03-03 12:42:35','2022-03-03 12:42:35'),(45414,132,'T.Narasingapuram','621008',1,0,'2022-03-03 12:42:35','2022-03-03 12:42:35'),(45415,132,'T.Renganathapuram','621002',1,0,'2022-03-03 12:42:35','2022-03-03 12:42:35'),(45416,132,'T.Sathanur','621004',1,0,'2022-03-03 12:42:35','2022-03-03 12:42:35'),(45417,132,'T.Valaiyur','621104',1,0,'2022-03-03 12:42:35','2022-03-03 12:42:35'),(45418,132,'Tattamangalam','621005',1,0,'2022-03-03 12:42:35','2022-03-03 12:42:35'),(45419,132,'Thalakudi','621216',1,0,'2022-03-03 12:42:35','2022-03-03 12:42:35'),(45420,132,'Thalamalaipatti','621215',1,0,'2022-03-03 12:42:35','2022-03-03 12:42:35'),(45421,132,'Thalugaimangapattipudur','621012',1,0,'2022-03-03 12:42:35','2022-03-03 12:42:35'),(45422,132,'Thandalai','621217',1,0,'2022-03-03 12:42:35','2022-03-03 12:42:35'),(45423,132,'Thandalaiputhur','621217',1,0,'2022-03-03 12:42:35','2022-03-03 12:42:35'),(45424,132,'Thanneerpallam','621011',1,0,'2022-03-03 12:42:36','2022-03-03 12:42:36'),(45425,132,'Thathiengarpet','621214',1,0,'2022-03-03 12:42:36','2022-03-03 12:42:36'),(45426,132,'Thinnakonam','621202',1,0,'2022-03-03 12:42:36','2022-03-03 12:42:36'),(45427,132,'Thinnanur','621006',1,0,'2022-03-03 12:42:36','2022-03-03 12:42:36'),(45428,132,'Thirunarayanapuram','621203',1,0,'2022-03-03 12:42:36','2022-03-03 12:42:36'),(45429,132,'Thiruthalaiyur','621217',1,0,'2022-03-03 12:42:36','2022-03-03 12:42:36'),(45430,132,'Thiruvasi','621216',1,0,'2022-03-03 12:42:36','2022-03-03 12:42:36'),(45431,132,'Thiruvengimalai','621209',1,0,'2022-03-03 12:42:36','2022-03-03 12:42:36'),(45432,132,'Tholurpatti','621215',1,0,'2022-03-03 12:42:36','2022-03-03 12:42:36'),(45433,132,'Thottiam','621215',1,0,'2022-03-03 12:42:36','2022-03-03 12:42:36'),(45434,132,'Thulayanatham','621205',1,0,'2022-03-03 12:42:36','2022-03-03 12:42:36'),(45435,132,'Thumbalam','621211',1,0,'2022-03-03 12:42:36','2022-03-03 12:42:36'),(45436,132,'Tirupanjili','621005',1,0,'2022-03-03 12:42:36','2022-03-03 12:42:36'),(45437,132,'Tirupattur','621105',1,0,'2022-03-03 12:42:36','2022-03-03 12:42:36'),(45438,132,'Tiruthiamalai','621006',1,0,'2022-03-03 12:42:36','2022-03-03 12:42:36'),(45439,132,'Tiruvalarsolai','620005',1,0,'2022-03-03 12:42:36','2022-03-03 12:42:36'),(45440,132,'Tiruvanaikoil','620005',1,0,'2022-03-03 12:42:36','2022-03-03 12:42:36'),(45441,132,'Tiruvellerai','621009',1,0,'2022-03-03 12:42:36','2022-03-03 12:42:36'),(45442,132,'Todaiyur','621213',1,0,'2022-03-03 12:42:36','2022-03-03 12:42:36'),(45443,132,'Top Sengattupatti','621011',1,0,'2022-03-03 12:42:36','2022-03-03 12:42:36'),(45444,132,'Turaiyur Bus Stand','621010',1,0,'2022-03-03 12:42:36','2022-03-03 12:42:36'),(45445,132,'Turaiyur Extension','621010',1,0,'2022-03-03 12:42:36','2022-03-03 12:42:36'),(45446,132,'Turaiyur H.O','621010',1,0,'2022-03-03 12:42:36','2022-03-03 12:42:36'),(45447,132,'Unniyur','621207',1,0,'2022-03-03 12:42:36','2022-03-03 12:42:36'),(45448,132,'Uppliapuram','621011',1,0,'2022-03-03 12:42:36','2022-03-03 12:42:36'),(45449,132,'Urakkarai','621214',1,0,'2022-03-03 12:42:37','2022-03-03 12:42:37'),(45450,132,'Uthamaseri','620005',1,0,'2022-03-03 12:42:37','2022-03-03 12:42:37'),(45451,132,'Vadamalaipatti','621214',1,0,'2022-03-03 12:42:37','2022-03-03 12:42:37'),(45452,132,'Valaiyeduppu','621205',1,0,'2022-03-03 12:42:37','2022-03-03 12:42:37'),(45453,132,'Valaiyur','621005',1,0,'2022-03-03 12:42:37','2022-03-03 12:42:37'),(45454,132,'Valasiramani','621214',1,0,'2022-03-03 12:42:37','2022-03-03 12:42:37'),(45455,132,'Valavandhi','621211',1,0,'2022-03-03 12:42:37','2022-03-03 12:42:37'),(45456,132,'Varadarajapuram','621215',1,0,'2022-03-03 12:42:37','2022-03-03 12:42:37'),(45457,132,'Vathalai Gudalur','621204',1,0,'2022-03-03 12:42:37','2022-03-03 12:42:37'),(45458,132,'Veeramachampatti','621206',1,0,'2022-03-03 12:42:37','2022-03-03 12:42:37'),(45459,132,'Veeramanipatti','621202',1,0,'2022-03-03 12:42:37','2022-03-03 12:42:37'),(45460,132,'Velakkanatham','621217',1,0,'2022-03-03 12:42:37','2022-03-03 12:42:37'),(45461,132,'Vellalapatti','621211',1,0,'2022-03-03 12:42:37','2022-03-03 12:42:37'),(45462,132,'Velur','621104',1,0,'2022-03-03 12:42:37','2022-03-03 12:42:37'),(45463,132,'Velur-ayyampalayam','621202',1,0,'2022-03-03 12:42:37','2022-03-03 12:42:37'),(45464,132,'Vengadathanur','621002',1,0,'2022-03-03 12:42:37','2022-03-03 12:42:37'),(45465,132,'Venkatachalapuram','621011',1,0,'2022-03-03 12:42:37','2022-03-03 12:42:37'),(45466,132,'Venkatesapuram','621008',1,0,'2022-03-03 12:42:37','2022-03-03 12:42:37'),(45467,132,'Vishalakshi Ammal Samudram','621001',1,0,'2022-03-03 12:42:37','2022-03-03 12:42:37'),(45468,132,'Viswambalsamudram','621003',1,0,'2022-03-03 12:42:37','2022-03-03 12:42:37'),(45469,132,'Vyrichettipalayam','621012',1,0,'2022-03-03 12:42:37','2022-03-03 12:42:37'),(45470,132,'Yelurpatti','621215',1,0,'2022-03-03 12:42:37','2022-03-03 12:42:37'),(45471,132,'Adavathur','620102',1,0,'2022-03-03 12:42:37','2022-03-03 12:42:37'),(45472,132,'Administrative Office(BHEL)','620014',1,0,'2022-03-03 12:42:37','2022-03-03 12:42:37'),(45473,132,'Agalanganallur','621712',1,0,'2022-03-03 12:42:37','2022-03-03 12:42:37'),(45474,132,'Alambadi','621722',1,0,'2022-03-03 12:42:37','2022-03-03 12:42:37'),(45475,132,'Alambakkam','621711',1,0,'2022-03-03 12:42:38','2022-03-03 12:42:38'),(45476,132,'Alangudi Mahajanam','621702',1,0,'2022-03-03 12:42:38','2022-03-03 12:42:38'),(45477,132,'Alathur','620011',1,0,'2022-03-03 12:42:38','2022-03-03 12:42:38'),(45478,132,'Allur','620101',1,0,'2022-03-03 12:42:38','2022-03-03 12:42:38'),(45479,132,'Alundalaipur','621651',1,0,'2022-03-03 12:42:38','2022-03-03 12:42:38'),(45480,132,'Ambikapuram (Tiruchirappalli)','620004',1,0,'2022-03-03 12:42:38','2022-03-03 12:42:38'),(45481,132,'Ambil','621702',1,0,'2022-03-03 12:42:38','2022-03-03 12:42:38'),(45482,132,'Andanallur','639101',1,0,'2022-03-03 12:42:38','2022-03-03 12:42:38'),(45483,132,'Angarai','621703',1,0,'2022-03-03 12:42:38','2022-03-03 12:42:38'),(45484,132,'Annanagar','620026',1,0,'2022-03-03 12:42:38','2022-03-03 12:42:38'),(45485,132,'Arasangudi','620013',1,0,'2022-03-03 12:42:38','2022-03-03 12:42:38'),(45486,132,'Ariyamangalam','620010',1,0,'2022-03-03 12:42:38','2022-03-03 12:42:38'),(45487,132,'Ariyavur','620009',1,0,'2022-03-03 12:42:38','2022-03-03 12:42:38'),(45488,132,'Ariyur','621702',1,0,'2022-03-03 12:42:38','2022-03-03 12:42:38'),(45489,132,'Asoor','620015',1,0,'2022-03-03 12:42:38','2022-03-03 12:42:38'),(45490,132,'Athigudi','621702',1,0,'2022-03-03 12:42:38','2022-03-03 12:42:38'),(45491,132,'Ayyampatti','620015',1,0,'2022-03-03 12:42:38','2022-03-03 12:42:38'),(45492,132,'Bharathidasan University','620024',1,0,'2022-03-03 12:42:38','2022-03-03 12:42:38'),(45493,132,'Bheemanagar','620001',1,0,'2022-03-03 12:42:38','2022-03-03 12:42:38'),(45494,132,'Boiler Project - TR','620014',1,0,'2022-03-03 12:42:38','2022-03-03 12:42:38'),(45495,132,'C Sector (BHEL) - TR','620014',1,0,'2022-03-03 12:42:38','2022-03-03 12:42:38'),(45496,132,'Clock Tower (Tiruchirappalli)','620008',1,0,'2022-03-03 12:42:38','2022-03-03 12:42:38'),(45497,132,'Craw Ford Colony','620012',1,0,'2022-03-03 12:42:38','2022-03-03 12:42:38'),(45498,132,'Edamalaipatti Pudur','620012',1,0,'2022-03-03 12:42:38','2022-03-03 12:42:38'),(45499,132,'Edangimangalam','621712',1,0,'2022-03-03 12:42:38','2022-03-03 12:42:38'),(45500,132,'Esanakorai','621218',1,0,'2022-03-03 12:42:38','2022-03-03 12:42:38'),(45501,132,'Ettarai','639103',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45502,132,'Fathimanagar','620012',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45503,132,'Golden Rock Market','620004',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45504,132,'Golden Rock North','620004',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45505,132,'Golden Rock','620004',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45506,132,'Gundur','620007',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45507,132,'Hapf Township','620025',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45508,132,'Inamkulathur','620009',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45509,132,'Inampuliyur','639103',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45510,132,'Industrial Colony','620010',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45511,132,'Jainagar (Tiruchirappalli)','620013',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45512,132,'Jamal Mohamed College','620020',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45513,132,'Jiyapuram','639101',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45514,132,'K.K.Nagar (Tiruchirappalli)','620021',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45515,132,'K.Sathanur','620021',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45516,132,'Kallagam','621653',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45517,132,'Kallakudi North','621652',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45518,132,'Kallakudi TR','621651',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45519,132,'Kamarajanagar','620010',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45520,132,'Kamarajapuram (BHEL)','620014',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45521,132,'Kambarasampettai','620101',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45522,132,'Kanakiliyanallur','621651',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45523,132,'Kannakudi','621711',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45524,132,'Kattur Puvalur','621706',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45525,132,'Keelarasur','621653',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45526,132,'Khajamalai Colony','620020',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45527,132,'Khajanagar','620023',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45528,132,'Kilakalkandarkottai','620011',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45529,132,'Kilakurichi','620011',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45530,132,'Kodiyalam','639115',1,0,'2022-03-03 12:42:39','2022-03-03 12:42:39'),(45531,132,'Kokkudi','621653',1,0,'2022-03-03 12:42:40','2022-03-03 12:42:40'),(45532,132,'Konnagudi','621702',1,0,'2022-03-03 12:42:40','2022-03-03 12:42:40'),(45533,132,'Koothappar','620013',1,0,'2022-03-03 12:42:40','2022-03-03 12:42:40'),(45534,132,'Koppu','639103',1,0,'2022-03-03 12:42:40','2022-03-03 12:42:40'),(45535,132,'Kovandakurichi','621711',1,0,'2022-03-03 12:42:40','2022-03-03 12:42:40'),(45536,132,'Kovilur','621715',1,0,'2022-03-03 12:42:40','2022-03-03 12:42:40'),(45537,132,'Kuhur','621703',1,0,'2022-03-03 12:42:40','2022-03-03 12:42:40'),(45538,132,'Kulamanickam','621722',1,0,'2022-03-03 12:42:40','2022-03-03 12:42:40'),(45539,132,'Kulumani','639103',1,0,'2022-03-03 12:42:40','2022-03-03 12:42:40'),(45540,132,'Kumaravayalur','620102',1,0,'2022-03-03 12:42:40','2022-03-03 12:42:40'),(45541,132,'Kumulur','621712',1,0,'2022-03-03 12:42:40','2022-03-03 12:42:40'),(45542,132,'Lalgudi H.O','621601',1,0,'2022-03-03 12:42:40','2022-03-03 12:42:40'),(45543,132,'Malaiadivaram','620013',1,0,'2022-03-03 12:42:40','2022-03-03 12:42:40'),(45544,132,'Malliampattu','620102',1,0,'2022-03-03 12:42:40','2022-03-03 12:42:40'),(45545,132,'Malvoy','621652',1,0,'2022-03-03 12:42:40','2022-03-03 12:42:40'),(45546,132,'Malvoy Kannanur','621652',1,0,'2022-03-03 12:42:40','2022-03-03 12:42:40'),(45547,132,'Manakkal','621703',1,0,'2022-03-03 12:42:40','2022-03-03 12:42:40'),(45548,132,'Manikandam','620012',1,0,'2022-03-03 12:42:40','2022-03-03 12:42:40'),(45549,132,'Mannarpuram','620020',1,0,'2022-03-03 12:42:40','2022-03-03 12:42:40'),(45550,132,'Manthurai','621703',1,0,'2022-03-03 12:42:40','2022-03-03 12:42:40'),(45551,132,'Maruthandakurichi','620102',1,0,'2022-03-03 12:42:40','2022-03-03 12:42:40'),(45552,132,'Mekkudi','639101',1,0,'2022-03-03 12:42:40','2022-03-03 12:42:40'),(45553,132,'Melakalkandarkottai','620011',1,0,'2022-03-03 12:42:40','2022-03-03 12:42:40'),(45554,132,'Melaperungavur','621218',1,0,'2022-03-03 12:42:40','2022-03-03 12:42:40'),(45555,132,'Melarasur','621652',1,0,'2022-03-03 12:42:40','2022-03-03 12:42:40'),(45556,132,'Melavalady','621218',1,0,'2022-03-03 12:42:40','2022-03-03 12:42:40'),(45557,132,'Methal','621653',1,0,'2022-03-03 12:42:41','2022-03-03 12:42:41'),(45558,132,'Mettupatti','621706',1,0,'2022-03-03 12:42:41','2022-03-03 12:42:41'),(45559,132,'Mullal','621706',1,0,'2022-03-03 12:42:41','2022-03-03 12:42:41'),(45560,132,'Mutharasanallur','620101',1,0,'2022-03-03 12:42:41','2022-03-03 12:42:41'),(45561,132,'Nagamangalam','620012',1,0,'2022-03-03 12:42:41','2022-03-03 12:42:41'),(45562,132,'Nagar','621703',1,0,'2022-03-03 12:42:41','2022-03-03 12:42:41'),(45563,132,'Natarajapuram','620013',1,0,'2022-03-03 12:42:41','2022-03-03 12:42:41'),(45564,132,'Nathamangudi','621711',1,0,'2022-03-03 12:42:41','2022-03-03 12:42:41'),(45565,132,'National Institute of Technology','620015',1,0,'2022-03-03 12:42:41','2022-03-03 12:42:41'),(45566,132,'Navalpattu','620016',1,0,'2022-03-03 12:42:41','2022-03-03 12:42:41'),(45567,132,'Navalurkottapattu','620009',1,0,'2022-03-03 12:42:41','2022-03-03 12:42:41'),(45568,132,'Ordnance Estate - TR','620016',1,0,'2022-03-03 12:42:41','2022-03-03 12:42:41'),(45569,132,'P & T Colony (Tiruchirappalli)','620020',1,0,'2022-03-03 12:42:41','2022-03-03 12:42:41'),(45570,132,'Paganur','620009',1,0,'2022-03-03 12:42:41','2022-03-03 12:42:41'),(45571,132,'Palakkarai','620008',1,0,'2022-03-03 12:42:41','2022-03-03 12:42:41'),(45572,132,'Palanganangudi','620025',1,0,'2022-03-03 12:42:41','2022-03-03 12:42:41'),(45573,132,'Pallakadu','620102',1,0,'2022-03-03 12:42:41','2022-03-03 12:42:41'),(45574,132,'Pallapuram','621712',1,0,'2022-03-03 12:42:41','2022-03-03 12:42:41'),(45575,132,'Pappakurichi Kattur','620019',1,0,'2022-03-03 12:42:41','2022-03-03 12:42:41'),(45576,132,'Pathalapettai','620013',1,0,'2022-03-03 12:42:41','2022-03-03 12:42:41'),(45577,132,'Periavarsili','621218',1,0,'2022-03-03 12:42:41','2022-03-03 12:42:41'),(45578,132,'Perugamani','639115',1,0,'2022-03-03 12:42:41','2022-03-03 12:42:41'),(45579,132,'Peruvalanallur','621712',1,0,'2022-03-03 12:42:41','2022-03-03 12:42:41'),(45580,132,'Peruvalappur','621651',1,0,'2022-03-03 12:42:41','2022-03-03 12:42:41'),(45581,132,'Pettavaithalai','639112',1,0,'2022-03-03 12:42:41','2022-03-03 12:42:41'),(45582,132,'Pirattiyur','620009',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45583,132,'Ponnagar','620001',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45584,132,'Ponniah School Buildings','620001',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45585,132,'Pudukottai','639112',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45586,132,'Pudur Uthamanur','621712',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45587,132,'Pudurpalayam','621711',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45588,132,'Pulangulathupatti','620009',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45589,132,'Pullambadi','621711',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45590,132,'Punjai Sangentai','621711',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45591,132,'Pushpanagar','620001',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45592,132,'Puthur','620017',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45593,132,'Puvalur','621712',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45594,132,'Ramalinganagar South','620017',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45595,132,'Ramjeenagar','620009',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45596,132,'Ranjithapuram','620020',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45597,132,'Rock Fort','620002',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45598,132,'Salainagar','620003',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45599,132,'Sannavur','621651',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45600,132,'Sathamangalam','621703',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45601,132,'Sengaraiyur','621702',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45602,132,'Senthanneerpuram','620004',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45603,132,'Sillakudi','621653',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45604,132,'Sirathope','620102',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45605,132,'Sircarpalayam','620010',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45606,132,'Sirugamani','639115',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45607,132,'Sirukalappur','621651',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45608,132,'Sirumayankudi','621706',1,0,'2022-03-03 12:42:42','2022-03-03 12:42:42'),(45609,132,'Sivankoil','621703',1,0,'2022-03-03 12:42:43','2022-03-03 12:42:43'),(45610,132,'Somarasampettai','620102',1,0,'2022-03-03 12:42:43','2022-03-03 12:42:43'),(45611,132,'Subramaniapuram (Tiruchirappalli)','620020',1,0,'2022-03-03 12:42:43','2022-03-03 12:42:43'),(45612,132,'Sundararajanagar','620020',1,0,'2022-03-03 12:42:43','2022-03-03 12:42:43'),(45613,132,'Suriyur','620025',1,0,'2022-03-03 12:42:43','2022-03-03 12:42:43'),(45614,132,'Tappay','621651',1,0,'2022-03-03 12:42:43','2022-03-03 12:42:43'),(45615,132,'Tennur','620017',1,0,'2022-03-03 12:42:43','2022-03-03 12:42:43'),(45616,132,'Teppakulam','620002',1,0,'2022-03-03 12:42:43','2022-03-03 12:42:43'),(45617,132,'Thachankurichi','621712',1,0,'2022-03-03 12:42:43','2022-03-03 12:42:43'),(45618,132,'Thayanur','620102',1,0,'2022-03-03 12:42:43','2022-03-03 12:42:43'),(45619,132,'Thillai Nagar','620018',1,0,'2022-03-03 12:42:43','2022-03-03 12:42:43'),(45620,132,'Thinniam','621706',1,0,'2022-03-03 12:42:43','2022-03-03 12:42:43'),(45621,132,'Thirumangalam','621703',1,0,'2022-03-03 12:42:43','2022-03-03 12:42:43'),(45622,132,'Thiruverumbur','620013',1,0,'2022-03-03 12:42:43','2022-03-03 12:42:43'),(45623,132,'Thuvakudi','620015',1,0,'2022-03-03 12:42:43','2022-03-03 12:42:43'),(45624,132,'Thuvakudimalai','620022',1,0,'2022-03-03 12:42:43','2022-03-03 12:42:43'),(45625,132,'Tiruchirappalli Airport','620007',1,0,'2022-03-03 12:42:43','2022-03-03 12:42:43'),(45626,132,'Tiruchirappalli Cantonment','620001',1,0,'2022-03-03 12:42:43','2022-03-03 12:42:43'),(45627,132,'Tiruchirappalli Collectorate','620001',1,0,'2022-03-03 12:42:43','2022-03-03 12:42:43'),(45628,132,'Tiruchirappalli Fort','620008',1,0,'2022-03-03 12:42:43','2022-03-03 12:42:43'),(45629,132,'Tiruchirappalli H.O','620001',1,0,'2022-03-03 12:42:43','2022-03-03 12:42:43'),(45630,132,'Tiruchirappalli R.S.','620001',1,0,'2022-03-03 12:42:43','2022-03-03 12:42:43'),(45631,132,'Tiruchirappalli Townhall','620002',1,0,'2022-03-03 12:42:43','2022-03-03 12:42:43'),(45632,132,'Tirumanamedu','621218',1,0,'2022-03-03 12:42:43','2022-03-03 12:42:43'),(45633,132,'Tirunedungulam','620015',1,0,'2022-03-03 12:42:43','2022-03-03 12:42:43'),(45634,132,'Tirupparaithurai','639115',1,0,'2022-03-03 12:42:43','2022-03-03 12:42:43'),(45635,132,'Uyyakondanthirumalai','620102',1,0,'2022-03-03 12:42:44','2022-03-03 12:42:44'),(45636,132,'Vadugarpet','621651',1,0,'2022-03-03 12:42:44','2022-03-03 12:42:44'),(45637,132,'Valady','621218',1,0,'2022-03-03 12:42:44','2022-03-03 12:42:44'),(45638,132,'Valavandankottai','620015',1,0,'2022-03-03 12:42:44','2022-03-03 12:42:44'),(45639,132,'Vandalaigudalur','621711',1,0,'2022-03-03 12:42:44','2022-03-03 12:42:44'),(45640,132,'Varakuppai','621651',1,0,'2022-03-03 12:42:44','2022-03-03 12:42:44'),(45641,132,'Vengur','620013',1,0,'2022-03-03 12:42:44','2022-03-03 12:42:44'),(45642,132,'Venkatachalapuram','621711',1,0,'2022-03-03 12:42:44','2022-03-03 12:42:44'),(45643,132,'Viragalur','621722',1,0,'2022-03-03 12:42:44','2022-03-03 12:42:44'),(45644,132,'Woriur Bazaar','620003',1,0,'2022-03-03 12:42:44','2022-03-03 12:42:44'),(45645,132,'Woriur','620003',1,0,'2022-03-03 12:42:44','2022-03-03 12:42:44'),(45646,132,'Kunjaram','607201',1,0,'2022-03-03 12:42:44','2022-03-03 12:42:44'),(45647,134,'Nerkundram','600107',1,0,'2022-03-03 12:42:46','2022-03-03 12:42:46'),(45648,134,'Alwarthirunagar','600087',1,0,'2022-03-03 12:42:46','2022-03-03 12:42:46'),(45649,134,'Valasaravakkam','600087',1,0,'2022-03-03 12:42:46','2022-03-03 12:42:46'),(45650,134,'Adivaragapuram','631303',1,0,'2022-03-03 12:42:46','2022-03-03 12:42:46'),(45651,134,'Agooru','631209',1,0,'2022-03-03 12:42:46','2022-03-03 12:42:46'),(45652,134,'Alamelumangapuram','631213',1,0,'2022-03-03 12:42:46','2022-03-03 12:42:46'),(45653,134,'Allikuzhi','602023',1,0,'2022-03-03 12:42:46','2022-03-03 12:42:46'),(45654,134,'Ammaneri','631303',1,0,'2022-03-03 12:42:46','2022-03-03 12:42:46'),(45655,134,'Ammavarikuppam','631301',1,0,'2022-03-03 12:42:46','2022-03-03 12:42:46'),(45656,134,'Aranvoyal','602025',1,0,'2022-03-03 12:42:46','2022-03-03 12:42:46'),(45657,134,'Arcot','631204',1,0,'2022-03-03 12:42:46','2022-03-03 12:42:46'),(45658,134,'Arungolam','631201',1,0,'2022-03-03 12:42:46','2022-03-03 12:42:46'),(45659,134,'Athimanjeri','631202',1,0,'2022-03-03 12:42:46','2022-03-03 12:42:46'),(45660,134,'Athimanjeripeta','631202',1,0,'2022-03-03 12:42:46','2022-03-03 12:42:46'),(45661,134,'Athipattu','631210',1,0,'2022-03-03 12:42:46','2022-03-03 12:42:46'),(45662,134,'Balakrishnapuram','631202',1,0,'2022-03-03 12:42:46','2022-03-03 12:42:46'),(45663,134,'Balapuram','631301',1,0,'2022-03-03 12:42:46','2022-03-03 12:42:46'),(45664,134,'Beerakuppam','631205',1,0,'2022-03-03 12:42:46','2022-03-03 12:42:46'),(45665,134,'Bommarajupeta','631208',1,0,'2022-03-03 12:42:46','2022-03-03 12:42:46'),(45666,134,'Buchireddipalli','631206',1,0,'2022-03-03 12:42:46','2022-03-03 12:42:46'),(45667,134,'C.N.Kandigai','631208',1,0,'2022-03-03 12:42:46','2022-03-03 12:42:46'),(45668,134,'Chandravilasapuram','631301',1,0,'2022-03-03 12:42:46','2022-03-03 12:42:46'),(45669,134,'Chanurmallavaram','631302',1,0,'2022-03-03 12:42:46','2022-03-03 12:42:46'),(45670,134,'Cherukkanur','631205',1,0,'2022-03-03 12:42:46','2022-03-03 12:42:46'),(45671,134,'Chinnammapet','631210',1,0,'2022-03-03 12:42:46','2022-03-03 12:42:46'),(45672,134,'Chivada','631201',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45673,134,'Damaraipakkam','601103',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45674,134,'Devandavakkam','602023',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45675,134,'Echambadi','631207',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45676,134,'Egattur','631203',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45677,134,'Emrkandigai','631304',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45678,134,'Enambakkam','601103',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45679,134,'Erumbi','631302',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45680,134,'Goonipalayam','602026',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45681,134,'Harichandrapuram','631210',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45682,134,'Ikkadu','602021',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45683,134,'Illuppur','631204',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45684,134,'Illupur','602002',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45685,134,'Jangalapalli','631208',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45686,134,'Kadambathur','631203',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45687,134,'Kadananagaram','631301',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45688,134,'Kaivandur','631203',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45689,134,'Kakalur','631208',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45690,134,'Kakalur Ind Estate','602003',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45691,134,'Kalambakkam','602025',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45692,134,'Kalpattu','601103',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45693,134,'Kanakammachatram','631204',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45694,134,'Kanchipadi','631204',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45695,134,'Kannigaipair','601102',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45696,134,'Karikalavakkam','602021',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45697,134,'Karimbedu','631207',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45698,134,'Karlambakkam','631202',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45699,134,'Karlapakkam','602024',1,0,'2022-03-03 12:42:47','2022-03-03 12:42:47'),(45700,134,'Karthikeyapuram','631211',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45701,134,'Kasavarajpetta','631211',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45702,134,'Kaverirajapuram','631210',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45703,134,'Keechalam','631208',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45704,134,'Kg Kandigai','631205',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45705,134,'Kilanur','602021',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45706,134,'Kilnallathur','602002',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45707,134,'Kodivalasa','631202',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45708,134,'Kolathur','631207',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45709,134,'Komakkambedu','602024',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45710,134,'Konasamudram','631202',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45711,134,'Kondancheri','631402',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45712,134,'Konetampet','631207',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45713,134,'Koppur','602025',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45714,134,'Koramangalam','631205',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45715,134,'Kottamedu','602024',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45716,134,'Krishnasamudram','631206',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45717,134,'Kumararajupeta','631207',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45718,134,'Kunnavalam','631210',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45719,134,'Kurmavilasapuram','631210',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45720,134,'Lakshipuram','602024',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45721,134,'Madduru','631206',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45722,134,'Mahankalikapuram','631301',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45723,134,'Majankaranai','601102',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45724,134,'Mambakkam','631205',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45725,134,'Mambakkam','602026',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45726,134,'Manavalanagar','602002',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45727,134,'Mannur','631210',1,0,'2022-03-03 12:42:48','2022-03-03 12:42:48'),(45728,134,'Melapudi','631208',1,0,'2022-03-03 12:42:49','2022-03-03 12:42:49'),(45729,134,'Melnallathur','602002',1,0,'2022-03-03 12:42:49','2022-03-03 12:42:49'),(45730,134,'Meyyur','601103',1,0,'2022-03-03 12:42:49','2022-03-03 12:42:49'),(45731,134,'Monnavedu','602021',1,0,'2022-03-03 12:42:49','2022-03-03 12:42:49'),(45732,134,'Mukkarambakkam','601102',1,0,'2022-03-03 12:42:49','2022-03-03 12:42:49'),(45733,134,'Murukkambattu','631209',1,0,'2022-03-03 12:42:49','2022-03-03 12:42:49'),(45734,134,'Muthukondapuram','631204',1,0,'2022-03-03 12:42:49','2022-03-03 12:42:49'),(45735,134,'Myladumparai','631302',1,0,'2022-03-03 12:42:49','2022-03-03 12:42:49'),(45736,134,'Nabalur','631204',1,0,'2022-03-03 12:42:49','2022-03-03 12:42:49'),(45737,134,'Nallathur','631212',1,0,'2022-03-03 12:42:49','2022-03-03 12:42:49'),(45738,134,'Nambakkam','602023',1,0,'2022-03-03 12:42:49','2022-03-03 12:42:49'),(45739,134,'Nedambaram','631204',1,0,'2022-03-03 12:42:49','2022-03-03 12:42:49'),(45740,134,'Nedigallu','631208',1,0,'2022-03-03 12:42:49','2022-03-03 12:42:49'),(45741,134,'Nediyam','631207',1,0,'2022-03-03 12:42:49','2022-03-03 12:42:49'),(45742,134,'Neiveli','602023',1,0,'2022-03-03 12:42:49','2022-03-03 12:42:49'),(45743,134,'Nelvoy','601102',1,0,'2022-03-03 12:42:49','2022-03-03 12:42:49'),(45744,134,'Nelvoy','602023',1,0,'2022-03-03 12:42:49','2022-03-03 12:42:49'),(45745,134,'Nemili','631201',1,0,'2022-03-03 12:42:49','2022-03-03 12:42:49'),(45746,134,'Nemilichery','602024',1,0,'2022-03-03 12:42:49','2022-03-03 12:42:49'),(45747,134,'Netterikandigai','631209',1,0,'2022-03-03 12:42:49','2022-03-03 12:42:49'),(45748,134,'Nggo Colony Tiruvallur','602001',1,0,'2022-03-03 12:42:49','2022-03-03 12:42:49'),(45749,134,'Nochili','631202',1,0,'2022-03-03 12:42:49','2022-03-03 12:42:49'),(45750,134,'Nungambakkam','602002',1,0,'2022-03-03 12:42:49','2022-03-03 12:42:49'),(45751,134,'Odappai','602023',1,0,'2022-03-03 12:42:49','2022-03-03 12:42:49'),(45752,134,'Odikkadu','602021',1,0,'2022-03-03 12:42:49','2022-03-03 12:42:49'),(45753,134,'Paivalasa','631302',1,0,'2022-03-03 12:42:49','2022-03-03 12:42:49'),(45754,134,'Pakasala','631210',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45755,134,'Pakkam','602024',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45756,134,'Palavakkam (TiruvallB.O','602026',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45757,134,'Palayanur','631210',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45758,134,'Pallipat','631207',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45759,134,'Pandravedu','631208',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45760,134,'Pandur','631203',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45761,134,'Papparambakkam','602025',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45762,134,'Pattabiramapuram','631209',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45763,134,'Pattaraiperumbudur','631203',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45764,134,'Peddakalakattur','631210',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45765,134,'Peddanagapudi','631302',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45766,134,'Peddaramapuram','631302',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45767,134,'Pennaluripeta','602026',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45768,134,'Perambakkam','631402',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45769,134,'Perandur','602026',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45770,134,'Perattur','602021',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45771,134,'Periapalayam','601102',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45772,134,'Perumalpattu','602024',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45773,134,'Perumanallur','631208',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45774,134,'Pettaikandigai','631208',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45775,134,'Placepalayam','602023',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45776,134,'Podaturpeta','631208',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45777,134,'Polivakkam','602002',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45778,134,'Pondavakkam','602026',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45779,134,'Ponpadi','631213',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45780,134,'Ponpadi Rs','631213',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45781,134,'Poondi','602023',1,0,'2022-03-03 12:42:50','2022-03-03 12:42:50'),(45782,134,'Poonimangadu','631212',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45783,134,'Poorivakkam','601103',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45784,134,'Pudumavilangai','631203',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45785,134,'Pullarambakkam','602023',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45786,134,'Punyam','631207',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45787,134,'Putlur','602025',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45788,134,'Rajanagaram','631304',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45789,134,'Ramakrishnarajupeta','631303',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45790,134,'Ramanjeri','631204',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45791,134,'Ramapuram','631204',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45792,134,'Ramasamudram','631206',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45793,134,'Rangapuram','631302',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45794,134,'S.Agraharam','631205',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45795,134,'Samanthavada','631207',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45796,134,'Sanakuppam','631207',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45797,134,'Sandarayanpalayam','602023',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45798,134,'Saraswathinagar','631211',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45799,134,'Savattur','631208',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45800,134,'Seethanjeri','602026',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45801,134,'Selai','631203',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45802,134,'Sembedu','601103',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45803,134,'Sengadu','602002',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45804,134,'Senji','631203',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45805,134,'Sgbkandigai','631304',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45806,134,'Sirugumi','631205',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45807,134,'Sivanvoyal','602024',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45808,134,'Sorakayapeta','631208',1,0,'2022-03-03 12:42:51','2022-03-03 12:42:51'),(45809,134,'Srikalikapuram','631302',1,0,'2022-03-03 12:42:52','2022-03-03 12:42:52'),(45810,134,'Srinivasapuram','631209',1,0,'2022-03-03 12:42:52','2022-03-03 12:42:52'),(45811,134,'Sulaimeni','602026',1,0,'2022-03-03 12:42:52','2022-03-03 12:42:52'),(45812,134,'Suryanagaram','631209',1,0,'2022-03-03 12:42:52','2022-03-03 12:42:52'),(45813,134,'T.C.Kandigai','631205',1,0,'2022-03-03 12:42:52','2022-03-03 12:42:52'),(45814,134,'T.T.Kandigai','631208',1,0,'2022-03-03 12:42:52','2022-03-03 12:42:52'),(45815,134,'Thadur','631205',1,0,'2022-03-03 12:42:52','2022-03-03 12:42:52'),(45816,134,'Thalakancheri','602021',1,0,'2022-03-03 12:42:52','2022-03-03 12:42:52'),(45817,134,'Thalavedu','631212',1,0,'2022-03-03 12:42:52','2022-03-03 12:42:52'),(45818,134,'Thamaraikulam','631302',1,0,'2022-03-03 12:42:52','2022-03-03 12:42:52'),(45819,134,'Thandalam','601102',1,0,'2022-03-03 12:42:52','2022-03-03 12:42:52'),(45820,134,'Tharakshi','602026',1,0,'2022-03-03 12:42:52','2022-03-03 12:42:52'),(45821,134,'Thodukadu','602105',1,0,'2022-03-03 12:42:52','2022-03-03 12:42:52'),(45822,134,'Thozhur','602025',1,0,'2022-03-03 12:42:52','2022-03-03 12:42:52'),(45823,134,'Thyagapuram','631301',1,0,'2022-03-03 12:42:52','2022-03-03 12:42:52'),(45824,134,'Timmaboopalapuram','602023',1,0,'2022-03-03 12:42:52','2022-03-03 12:42:52'),(45825,134,'Tirukandalam','601103',1,0,'2022-03-03 12:42:52','2022-03-03 12:42:52'),(45826,134,'Tiruninravur','602024',1,0,'2022-03-03 12:42:52','2022-03-03 12:42:52'),(45827,134,'Tiruninravur Rs','602024',1,0,'2022-03-03 12:42:52','2022-03-03 12:42:52'),(45828,134,'Tirupasur','631203',1,0,'2022-03-03 12:42:52','2022-03-03 12:42:52'),(45829,134,'Tirur Cpt','602025',1,0,'2022-03-03 12:42:52','2022-03-03 12:42:52'),(45830,134,'Tirutani Hills','631209',1,0,'2022-03-03 12:42:52','2022-03-03 12:42:52'),(45831,134,'Tiruttani','631209',1,0,'2022-03-03 12:42:52','2022-03-03 12:42:52'),(45832,134,'Tiruttanieast','631209',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45833,134,'Tiruttanisouth','631209',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45834,134,'Tiruttaniwest','631209',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45835,134,'Tiruvallur H.O','602001',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45836,134,'Tiruvallur Nethaji Road','602001',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45837,134,'Tiruvelangadu','631210',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45838,134,'Ulundai','602105',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45839,134,'Upper Tirutani','631209',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45840,134,'Uttukottai','602026',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45841,134,'V.K.N.Kandigai','631205',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45842,134,'V.P.R.Puram','631302',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45843,134,'Vadamadurai','601102',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45844,134,'Vadattur','602024',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45845,134,'Vanganur','631304',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45846,134,'Vediyangadu','631302',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45847,134,'Veerakaverirajapuram','631205',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45848,134,'Veeramangalam','631302',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45849,134,'Veeranathur','631303',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45850,134,'Veeraraghavapuram','631210',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45851,134,'Velanjeri','631209',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45852,134,'Veliagaram','631207',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45853,134,'Vellathukottai','602023',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45854,134,'Velliyur','601103',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45855,134,'Vengal','601103',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45856,134,'Venkatarajakuppam','631207',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45857,134,'Veppambattu','602024',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45858,134,'Vidaiyur','631203',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45859,134,'Vyasapuram','631210',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45860,134,'Aladu','601204',1,0,'2022-03-03 12:42:53','2022-03-03 12:42:53'),(45861,134,'Alamathi','600052',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45862,134,'Alinjivakkam','600067',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45863,134,'Ambattur H.O','600053',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45864,134,'Ambattur Indl Estate','600058',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45865,134,'Amoor','601204',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45866,134,'Andarkuppam','600103',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45867,134,'Anuppampattu','601203',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45868,134,'Arambakkam','601201',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45869,134,'Arasur','601204',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45870,134,'Arignar Anna Nagar','600072',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45871,134,'Arni CPT','601101',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45872,134,'Athipattu','600058',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45873,134,'Avadi Camp H.O','600054',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45874,134,'Avadi IAF','600055',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45875,134,'Avadi','600054',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45876,134,'Ayanambakkam','600095',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45877,134,'Ayapakkam','600077',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45878,134,'Boochiathipattu','600052',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45879,134,'Budur','600067',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45880,134,'Chinnambedu','601206',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45881,134,'CRP camp (Tiruvallur)','600065',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45882,134,'Cvrde','600054',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45883,134,'Devadanam','601203',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45884,134,'Devampattu','601201',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45885,134,'Edapalayam','600052',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45886,134,'Edoor','601201',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45887,134,'Elavur','601201',1,0,'2022-03-03 12:42:54','2022-03-03 12:42:54'),(45888,134,'Ennore RS','600057',1,0,'2022-03-03 12:42:55','2022-03-03 12:42:55'),(45889,134,'Ennore Thermal Station','600057',1,0,'2022-03-03 12:42:55','2022-03-03 12:42:55'),(45890,134,'Ernavur','600057',1,0,'2022-03-03 12:42:55','2022-03-03 12:42:55'),(45891,134,'Erumaivettipalayam','600067',1,0,'2022-03-03 12:42:55','2022-03-03 12:42:55'),(45892,134,'Gandhinagar','600054',1,0,'2022-03-03 12:42:55','2022-03-03 12:42:55'),(45893,134,'Gummidipundi','601201',1,0,'2022-03-03 12:42:55','2022-03-03 12:42:55'),(45894,134,'Guruvoyal','600052',1,0,'2022-03-03 12:42:55','2022-03-03 12:42:55'),(45895,134,'Iguvarpalayam','601201',1,0,'2022-03-03 12:42:55','2022-03-03 12:42:55'),(45896,134,'Jagadambigainagar','600050',1,0,'2022-03-03 12:42:55','2022-03-03 12:42:55'),(45897,134,'Jagannathapuram','600067',1,0,'2022-03-03 12:42:55','2022-03-03 12:42:55'),(45898,134,'Jothi Nagar','601203',1,0,'2022-03-03 12:42:55','2022-03-03 12:42:55'),(45899,134,'Kadirvedu','600066',1,0,'2022-03-03 12:42:55','2022-03-03 12:42:55'),(45900,134,'Kaladipet','600019',1,0,'2022-03-03 12:42:55','2022-03-03 12:42:55'),(45901,134,'Kallur','601201',1,0,'2022-03-03 12:42:55','2022-03-03 12:42:55'),(45902,134,'Kamarajnagar','600057',1,0,'2022-03-03 12:42:55','2022-03-03 12:42:55'),(45903,134,'Kamarajnagar','600071',1,0,'2022-03-03 12:42:55','2022-03-03 12:42:55'),(45904,134,'Kannankottai','601202',1,0,'2022-03-03 12:42:55','2022-03-03 12:42:55'),(45905,134,'Kattupakkam','600056',1,0,'2022-03-03 12:42:55','2022-03-03 12:42:55'),(45906,134,'Kattur','601203',1,0,'2022-03-03 12:42:55','2022-03-03 12:42:55'),(45907,134,'Kavarapettai','601206',1,0,'2022-03-03 12:42:55','2022-03-03 12:42:55'),(45908,134,'Kilikodi','601206',1,0,'2022-03-03 12:42:55','2022-03-03 12:42:55'),(45909,134,'Kilmudalambedu','601206',1,0,'2022-03-03 12:42:55','2022-03-03 12:42:55'),(45910,134,'Koduvalli','600055',1,0,'2022-03-03 12:42:55','2022-03-03 12:42:55'),(45911,134,'Kolappancheri','600072',1,0,'2022-03-03 12:42:56','2022-03-03 12:42:56'),(45912,134,'Kolathur','600099',1,0,'2022-03-03 12:42:56','2022-03-03 12:42:56'),(45913,134,'Kolur','601205',1,0,'2022-03-03 12:42:56','2022-03-03 12:42:56'),(45914,134,'Korattur RS','600076',1,0,'2022-03-03 12:42:56','2022-03-03 12:42:56'),(45915,134,'Korattur','600050',1,0,'2022-03-03 12:42:56','2022-03-03 12:42:56'),(45916,134,'Kovilpadagai','600062',1,0,'2022-03-03 12:42:56','2022-03-03 12:42:56'),(45917,134,'Kovur','600128',1,0,'2022-03-03 12:42:56','2022-03-03 12:42:56'),(45918,134,'Krishnapuram','601204',1,0,'2022-03-03 12:42:56','2022-03-03 12:42:56'),(45919,134,'Kuttambakkam','600124',1,0,'2022-03-03 12:42:56','2022-03-03 12:42:56'),(45920,134,'Lakshmipuram','600099',1,0,'2022-03-03 12:42:56','2022-03-03 12:42:56'),(45921,134,'Madarpakkam','601202',1,0,'2022-03-03 12:42:56','2022-03-03 12:42:56'),(45922,134,'Madhavaram Milk Colony','600051',1,0,'2022-03-03 12:42:56','2022-03-03 12:42:56'),(45923,134,'Madhavaram (Tiruvallur)','600060',1,0,'2022-03-03 12:42:56','2022-03-03 12:42:56'),(45924,134,'Maduravoyal','600095',1,0,'2022-03-03 12:42:56','2022-03-03 12:42:56'),(45925,134,'Malayambakkam','600123',1,0,'2022-03-03 12:42:56','2022-03-03 12:42:56'),(45926,134,'Manali New Town','600103',1,0,'2022-03-03 12:42:56','2022-03-03 12:42:56'),(45927,134,'Manali (Tiruvallur)','600068',1,0,'2022-03-03 12:42:56','2022-03-03 12:42:56'),(45928,134,'Manellore','601202',1,0,'2022-03-03 12:42:56','2022-03-03 12:42:56'),(45929,134,'Mangavaram','601201',1,0,'2022-03-03 12:42:56','2022-03-03 12:42:56'),(45930,134,'Medur','601204',1,0,'2022-03-03 12:42:56','2022-03-03 12:42:56'),(45931,134,'Menambedu','600053',1,0,'2022-03-03 12:42:56','2022-03-03 12:42:56'),(45932,134,'Minjur','601203',1,0,'2022-03-03 12:42:56','2022-03-03 12:42:56'),(45933,134,'Mittanamalli','600055',1,0,'2022-03-03 12:42:56','2022-03-03 12:42:56'),(45934,134,'Mogappair','600037',1,0,'2022-03-03 12:42:56','2022-03-03 12:42:56'),(45935,134,'Mogappair West','600037',1,0,'2022-03-03 12:42:56','2022-03-03 12:42:56'),(45936,134,'Moolakadai','600060',1,0,'2022-03-03 12:42:57','2022-03-03 12:42:57'),(45937,134,'Morai','600055',1,0,'2022-03-03 12:42:57','2022-03-03 12:42:57'),(45938,134,'Nallur','601203',1,0,'2022-03-03 12:42:57','2022-03-03 12:42:57'),(45939,134,'Nandiambakkam','600120',1,0,'2022-03-03 12:42:57','2022-03-03 12:42:57'),(45940,134,'Nayar','600067',1,0,'2022-03-03 12:42:57','2022-03-03 12:42:57'),(45941,134,'Nazarethpettai','600123',1,0,'2022-03-03 12:42:57','2022-03-03 12:42:57'),(45942,134,'Neidavoyal','601203',1,0,'2022-03-03 12:42:57','2022-03-03 12:42:57'),(45943,134,'Nemam','600124',1,0,'2022-03-03 12:42:57','2022-03-03 12:42:57'),(45944,134,'New Gummidipundi','601201',1,0,'2022-03-03 12:42:57','2022-03-03 12:42:57'),(45945,134,'North Chennai Thermal PP','600120',1,0,'2022-03-03 12:42:57','2022-03-03 12:42:57'),(45946,134,'Numbal','600077',1,0,'2022-03-03 12:42:57','2022-03-03 12:42:57'),(45947,134,'Oragadam','600053',1,0,'2022-03-03 12:42:57','2022-03-03 12:42:57'),(45948,134,'Orakadu','600067',1,0,'2022-03-03 12:42:57','2022-03-03 12:42:57'),(45949,134,'Padi','600050',1,0,'2022-03-03 12:42:57','2022-03-03 12:42:57'),(45950,134,'Padianallur','600052',1,0,'2022-03-03 12:42:57','2022-03-03 12:42:57'),(45951,134,'Palavedu','600055',1,0,'2022-03-03 12:42:57','2022-03-03 12:42:57'),(45952,134,'Pallavada','601202',1,0,'2022-03-03 12:42:57','2022-03-03 12:42:57'),(45953,134,'Pammadukulam','600052',1,0,'2022-03-03 12:42:57','2022-03-03 12:42:57'),(45954,134,'Panayancheri','601101',1,0,'2022-03-03 12:42:57','2022-03-03 12:42:57'),(45955,134,'Pandeeswaram','600055',1,0,'2022-03-03 12:42:57','2022-03-03 12:42:57'),(45956,134,'Panjetti','601204',1,0,'2022-03-03 12:42:57','2022-03-03 12:42:57'),(45957,134,'Paruthipattu','600071',1,0,'2022-03-03 12:42:57','2022-03-03 12:42:57'),(45958,134,'Pattabiram','600072',1,0,'2022-03-03 12:42:58','2022-03-03 12:42:58'),(45959,134,'Periaobulapuam','601201',1,0,'2022-03-03 12:42:58','2022-03-03 12:42:58'),(45960,134,'Perumbedu','601204',1,0,'2022-03-03 12:42:58','2022-03-03 12:42:58'),(45961,134,'Podiyarankulam','601201',1,0,'2022-03-03 12:42:58','2022-03-03 12:42:58'),(45962,134,'Pondavakkam','601101',1,0,'2022-03-03 12:42:58','2022-03-03 12:42:58'),(45963,134,'Ponneri Public Office','601204',1,0,'2022-03-03 12:42:58','2022-03-03 12:42:58'),(45964,134,'Ponneri','601204',1,0,'2022-03-03 12:42:58','2022-03-03 12:42:58'),(45965,134,'Ponniammanmedu','600110',1,0,'2022-03-03 12:42:58','2022-03-03 12:42:58'),(45966,134,'Poonamallee East','600056',1,0,'2022-03-03 12:42:58','2022-03-03 12:42:58'),(45967,134,'Poonamallee','600056',1,0,'2022-03-03 12:42:58','2022-03-03 12:42:58'),(45968,134,'Pozhal','600066',1,0,'2022-03-03 12:42:58','2022-03-03 12:42:58'),(45969,134,'Prithivipakkam','600053',1,0,'2022-03-03 12:42:58','2022-03-03 12:42:58'),(45970,134,'Puduchatram','600124',1,0,'2022-03-03 12:42:58','2022-03-03 12:42:58'),(45971,134,'Puduvoyal','601206',1,0,'2022-03-03 12:42:58','2022-03-03 12:42:58'),(45972,134,'Pulicat','601205',1,0,'2022-03-03 12:42:58','2022-03-03 12:42:58'),(45973,134,'Puvalambedu','601206',1,0,'2022-03-03 12:42:58','2022-03-03 12:42:58'),(45974,134,'Railway Carshed Complex','600062',1,0,'2022-03-03 12:42:58','2022-03-03 12:42:58'),(45975,134,'Rajajinagar','600049',1,0,'2022-03-03 12:42:58','2022-03-03 12:42:58'),(45976,134,'Rallapadi','601101',1,0,'2022-03-03 12:42:58','2022-03-03 12:42:58'),(45977,134,'Reddipalayam','601204',1,0,'2022-03-03 12:42:58','2022-03-03 12:42:58'),(45978,134,'Redhills','600052',1,0,'2022-03-03 12:42:58','2022-03-03 12:42:58'),(45979,134,'Roshanagaram','601202',1,0,'2022-03-03 12:42:58','2022-03-03 12:42:58'),(45980,134,'Seemapuram South','601203',1,0,'2022-03-03 12:42:58','2022-03-03 12:42:58'),(45981,134,'Sembarambakkam','600123',1,0,'2022-03-03 12:42:58','2022-03-03 12:42:58'),(45982,134,'Senneerkuppam','600056',1,0,'2022-03-03 12:42:58','2022-03-03 12:42:58'),(45983,134,'Senthilnagar','600062',1,0,'2022-03-03 12:42:58','2022-03-03 12:42:58'),(45984,134,'Shanmugapuram','600019',1,0,'2022-03-03 12:42:59','2022-03-03 12:42:59'),(45985,134,'Sholavaram','600067',1,0,'2022-03-03 12:42:59','2022-03-03 12:42:59'),(45986,134,'Sidco Estate','600098',1,0,'2022-03-03 12:42:59','2022-03-03 12:42:59'),(45987,134,'Siddharajakandigai','601201',1,0,'2022-03-03 12:42:59','2022-03-03 12:42:59'),(45988,134,'Sirupulalpettai','601201',1,0,'2022-03-03 12:42:59','2022-03-03 12:42:59'),(45989,134,'Soranjeri','600072',1,0,'2022-03-03 12:42:59','2022-03-03 12:42:59'),(45990,134,'Spicto Industrial Estate','601201',1,0,'2022-03-03 12:42:59','2022-03-03 12:42:59'),(45991,134,'Srinivasanagar','600049',1,0,'2022-03-03 12:42:59','2022-03-03 12:42:59'),(45992,134,'Subbareddypalayam','600120',1,0,'2022-03-03 12:42:59','2022-03-03 12:42:59'),(45993,134,'Sunnambukulam','601201',1,0,'2022-03-03 12:42:59','2022-03-03 12:42:59'),(45994,134,'Tank Factory Avadi','600054',1,0,'2022-03-03 12:42:59','2022-03-03 12:42:59'),(45995,134,'Tervali','601201',1,0,'2022-03-03 12:42:59','2022-03-03 12:42:59'),(45996,134,'Thandarai','600072',1,0,'2022-03-03 12:42:59','2022-03-03 12:42:59'),(45997,134,'Thanipoondi','601202',1,0,'2022-03-03 12:42:59','2022-03-03 12:42:59'),(45998,134,'Thervoy','601202',1,0,'2022-03-03 12:42:59','2022-03-03 12:42:59'),(45999,134,'Thirumushi','600124',1,0,'2022-03-03 12:42:59','2022-03-03 12:42:59'),(46000,134,'Thirupalavanam','601205',1,0,'2022-03-03 12:42:59','2022-03-03 12:42:59'),(46001,134,'Thiruvengadnagar','600053',1,0,'2022-03-03 12:42:59','2022-03-03 12:42:59'),(46002,134,'Thiruverkadu','600077',1,0,'2022-03-03 12:42:59','2022-03-03 12:42:59'),(46003,134,'Thriuvellavoyal','601203',1,0,'2022-03-03 12:42:59','2022-03-03 12:42:59'),(46004,134,'Tirumangalam Road','600049',1,0,'2022-03-03 12:42:59','2022-03-03 12:42:59'),(46005,134,'Tirumullaivoyal','600062',1,0,'2022-03-03 12:42:59','2022-03-03 12:42:59'),(46006,134,'Tiruvottiyur','600019',1,0,'2022-03-03 12:42:59','2022-03-03 12:42:59'),(46007,134,'Tiruvottiyur West','600019',1,0,'2022-03-03 12:42:59','2022-03-03 12:42:59'),(46008,134,'Tondiarpet Rly Colony','600019',1,0,'2022-03-03 12:42:59','2022-03-03 12:42:59'),(46009,134,'Udayarkoil','600124',1,0,'2022-03-03 12:43:00','2022-03-03 12:43:00'),(46010,134,'Vadakarai','600052',1,0,'2022-03-03 12:43:00','2022-03-03 12:43:00'),(46011,134,'Vadaperumbakkam','600060',1,0,'2022-03-03 12:43:00','2022-03-03 12:43:00'),(46012,134,'Vallur','600120',1,0,'2022-03-03 12:43:00','2022-03-03 12:43:00'),(46013,134,'Vanagaram','600095',1,0,'2022-03-03 12:43:00','2022-03-03 12:43:00'),(46014,134,'Veeraraghavapuram','600077',1,0,'2022-03-03 12:43:00','2022-03-03 12:43:00'),(46015,134,'Vellanur','600062',1,0,'2022-03-03 12:43:00','2022-03-03 12:43:00'),(46016,134,'Vellavedu','600124',1,0,'2022-03-03 12:43:00','2022-03-03 12:43:00'),(46017,134,'Vellivoyalchavadi','600103',1,0,'2022-03-03 12:43:00','2022-03-03 12:43:00'),(46018,134,'Velnagar Vellanur','600062',1,0,'2022-03-03 12:43:00','2022-03-03 12:43:00'),(46019,134,'Velur','601203',1,0,'2022-03-03 12:43:00','2022-03-03 12:43:00'),(46020,134,'Vichoor','600103',1,0,'2022-03-03 12:43:00','2022-03-03 12:43:00'),(46021,134,'Vijayalakshmipuram','600053',1,0,'2022-03-03 12:43:00','2022-03-03 12:43:00'),(46022,134,'Vilangadupakkam','600052',1,0,'2022-03-03 12:43:00','2022-03-03 12:43:00'),(46023,134,'Villivakkam','600049',1,0,'2022-03-03 12:43:00','2022-03-03 12:43:00'),(46024,134,'Voyalanallur','600072',1,0,'2022-03-03 12:43:00','2022-03-03 12:43:00'),(46025,134,'Voyalur','601203',1,0,'2022-03-03 12:43:00','2022-03-03 12:43:00'),(46026,135,'Brammadesam','632511',1,0,'2022-03-03 12:43:00','2022-03-03 12:43:00'),(46027,135,'Mullandrum','632512',1,0,'2022-03-03 12:43:00','2022-03-03 12:43:00'),(46028,135,'Natteri','632511',1,0,'2022-03-03 12:43:00','2022-03-03 12:43:00'),(46029,135,'Poosimalaikuppam','632512',1,0,'2022-03-03 12:43:00','2022-03-03 12:43:00'),(46030,135,'Pulivalam- Sunaipattu','632511',1,0,'2022-03-03 12:43:00','2022-03-03 12:43:00'),(46031,135,'Puthur','632512',1,0,'2022-03-03 12:43:00','2022-03-03 12:43:00'),(46032,135,'Sattuvanthangal','632511',1,0,'2022-03-03 12:43:00','2022-03-03 12:43:00'),(46033,135,'Thennampattu','632511',1,0,'2022-03-03 12:43:00','2022-03-03 12:43:00'),(46034,135,'Vadailluppai','632511',1,0,'2022-03-03 12:43:00','2022-03-03 12:43:00'),(46035,135,'Vethajipuram','632507',1,0,'2022-03-03 12:43:01','2022-03-03 12:43:01'),(46036,135,'A K Padavedu','606905',1,0,'2022-03-03 12:43:01','2022-03-03 12:43:01'),(46037,135,'Adaiyur','606604',1,0,'2022-03-03 12:43:01','2022-03-03 12:43:01'),(46038,135,'Adamangalam','606901',1,0,'2022-03-03 12:43:01','2022-03-03 12:43:01'),(46039,135,'Adanur','632317',1,0,'2022-03-03 12:43:01','2022-03-03 12:43:01'),(46040,135,'Adiannamalai','606604',1,0,'2022-03-03 12:43:01','2022-03-03 12:43:01'),(46041,135,'Adiyanur','604403',1,0,'2022-03-03 12:43:01','2022-03-03 12:43:01'),(46042,135,'Agraharapalayam','632314',1,0,'2022-03-03 12:43:01','2022-03-03 12:43:01'),(46043,135,'Akkur (Tiruvannamalai)','631701',1,0,'2022-03-03 12:43:01','2022-03-03 12:43:01'),(46044,135,'Alathur','606702',1,0,'2022-03-03 12:43:01','2022-03-03 12:43:01'),(46045,135,'Alathur','604408',1,0,'2022-03-03 12:43:01','2022-03-03 12:43:01'),(46046,135,'Alividaithangi','604402',1,0,'2022-03-03 12:43:01','2022-03-03 12:43:01'),(46047,135,'Allialamangalam','606904',1,0,'2022-03-03 12:43:01','2022-03-03 12:43:01'),(46048,135,'Allikondapattu','606753',1,0,'2022-03-03 12:43:01','2022-03-03 12:43:01'),(46049,135,'Alliyandal','604503',1,0,'2022-03-03 12:43:01','2022-03-03 12:43:01'),(46050,135,'Ammapalayam','632315',1,0,'2022-03-03 12:43:01','2022-03-03 12:43:01'),(46051,135,'Ammayapattu','604408',1,0,'2022-03-03 12:43:01','2022-03-03 12:43:01'),(46052,135,'Amudur','604405',1,0,'2022-03-03 12:43:01','2022-03-03 12:43:01'),(46053,135,'Ananthapuram','632315',1,0,'2022-03-03 12:43:01','2022-03-03 12:43:01'),(46054,135,'Anapathur','604401',1,0,'2022-03-03 12:43:01','2022-03-03 12:43:01'),(46055,135,'Andampallam','606804',1,0,'2022-03-03 12:43:01','2022-03-03 12:43:01'),(46056,135,'Andipattu','606703',1,0,'2022-03-03 12:43:01','2022-03-03 12:43:01'),(46057,135,'Anmarudai','604504',1,0,'2022-03-03 12:43:01','2022-03-03 12:43:01'),(46058,135,'Anukkavoor','604401',1,0,'2022-03-03 12:43:01','2022-03-03 12:43:01'),(46059,135,'Aradapattu','606808',1,0,'2022-03-03 12:43:01','2022-03-03 12:43:01'),(46060,135,'Arasampattu','606807',1,0,'2022-03-03 12:43:01','2022-03-03 12:43:01'),(46061,135,'Arasanipalai','631702',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46062,135,'Arasankanni','606703',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46063,135,'Arasur','604408',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46064,135,'Arattavadi','606709',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46065,135,'Arayalam','632326',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46066,135,'Ariyapadi','632314',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46067,135,'Arjunapuram','606905',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46068,135,'Arni Fort','632301',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46069,135,'Arni H.O','632301',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46070,135,'Arpakkam','606752',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46071,135,'Arudirapattu','606806',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46072,135,'Arugavur','604407',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46073,135,'Arunagirichatram','632301',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46074,135,'Arunthodu','604501',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46075,135,'Athimoor Tindivanam','606803',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46076,135,'Athipadi','606708',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46077,135,'Athurai','606902',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46078,135,'Athuvambadi','606907',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46079,135,'Avaniapuram','604504',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46080,135,'Avur','606755',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46081,135,'Ayalpadi','604505',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46082,135,'Ayyampalayam','606603',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46083,135,'Ayyampalayam','632315',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46084,135,'Ayyankulam','606601',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46085,135,'Badur','604403',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46086,135,'Banambattu','606908',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46087,135,'Bhimarapatti','606708',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46088,135,'Budamangalam','606902',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46089,135,'C Nammiandal','606702',1,0,'2022-03-03 12:43:02','2022-03-03 12:43:02'),(46090,135,'Chellankuppam','606755',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46091,135,'Chengam','606701',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46092,135,'Chennasamudram','606701',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46093,135,'Chettupattu Polur','606801',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46094,135,'Chevur','632316',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46095,135,'Cheyyar','604407',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46096,135,'Cheyyaturvendran','604401',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46097,135,'Chinnaelacheri','631702',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46098,135,'Chinnaimpettai','606708',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46099,135,'Chinnakallapadi','606806',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46100,135,'Chithathur','604410',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46101,135,'Chitragavur Pudur','604501',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46102,135,'Desur','604501',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46103,135,'Devanampattu','606802',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46104,135,'Devanur','606806',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46105,135,'Devikapuram','606902',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46106,135,'Dusi','631702',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46107,135,'Echur','604404',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46108,135,'Edathanur','606707',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46109,135,'Elaneerkundram','604401',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46110,135,'Elangadu','604408',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46111,135,'Elangunni','606703',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46112,135,'Elathur','606906',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46113,135,'Elayankanni','606753',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46114,135,'Embalam','604406',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46115,135,'Endal','604502',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46116,135,'Eraiyur','606704',1,0,'2022-03-03 12:43:03','2022-03-03 12:43:03'),(46117,135,'Erumaivetti','604401',1,0,'2022-03-03 12:43:04','2022-03-03 12:43:04'),(46118,135,'Erumbur','604404',1,0,'2022-03-03 12:43:04','2022-03-03 12:43:04'),(46119,135,'Erumpoondi','604601',1,0,'2022-03-03 12:43:04','2022-03-03 12:43:04'),(46120,135,'Esanyamadam','606604',1,0,'2022-03-03 12:43:04','2022-03-03 12:43:04'),(46121,135,'Ettivadi','606907',1,0,'2022-03-03 12:43:04','2022-03-03 12:43:04'),(46122,135,'Gangapattu','606804',1,0,'2022-03-03 12:43:04','2022-03-03 12:43:04'),(46123,135,'Gangavaram','606901',1,0,'2022-03-03 12:43:04','2022-03-03 12:43:04'),(46124,135,'Gudalur','606755',1,0,'2022-03-03 12:43:04','2022-03-03 12:43:04'),(46125,135,'Gudalur','606907',1,0,'2022-03-03 12:43:04','2022-03-03 12:43:04'),(46126,135,'Hasanamapettai','604402',1,0,'2022-03-03 12:43:04','2022-03-03 12:43:04'),(46127,135,'Inamkariyandal','606604',1,0,'2022-03-03 12:43:04','2022-03-03 12:43:04'),(46128,135,'Indiravanam','632313',1,0,'2022-03-03 12:43:04','2022-03-03 12:43:04'),(46129,135,'Injimedu','604503',1,0,'2022-03-03 12:43:04','2022-03-03 12:43:04'),(46130,135,'Irumbedu','632317',1,0,'2022-03-03 12:43:04','2022-03-03 12:43:04'),(46131,135,'Irumbedu','604403',1,0,'2022-03-03 12:43:04','2022-03-03 12:43:04'),(46132,135,'Isukkalikatteri','606804',1,0,'2022-03-03 12:43:04','2022-03-03 12:43:04'),(46133,135,'Japthikarani','604406',1,0,'2022-03-03 12:43:04','2022-03-03 12:43:04'),(46134,135,'Japthikariandal','606702',1,0,'2022-03-03 12:43:04','2022-03-03 12:43:04'),(46135,135,'Kadagaman','606804',1,0,'2022-03-03 12:43:04','2022-03-03 12:43:04'),(46136,135,'Kadaladi (Tiruvannamalai)','606908',1,0,'2022-03-03 12:43:04','2022-03-03 12:43:04'),(46137,135,'Kadambai','604502',1,0,'2022-03-03 12:43:04','2022-03-03 12:43:04'),(46138,135,'Kaduganur','604503',1,0,'2022-03-03 12:43:04','2022-03-03 12:43:04'),(46139,135,'Kaganam','604410',1,0,'2022-03-03 12:43:04','2022-03-03 12:43:04'),(46140,135,'Kalambur','606903',1,0,'2022-03-03 12:43:04','2022-03-03 12:43:04'),(46141,135,'Kalasamudram','632311',1,0,'2022-03-03 12:43:04','2022-03-03 12:43:04'),(46142,135,'Kalasapakkam','606751',1,0,'2022-03-03 12:43:04','2022-03-03 12:43:04'),(46143,135,'Kalasthambadi','606805',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46144,135,'Kaliyur','604407',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46145,135,'Kallarai Padi','606702',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46146,135,'Kallathur','606710',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46147,135,'Kallayee Sorathur','606754',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46148,135,'Kalnagar','606601',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46149,135,'Kalur','606751',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46150,135,'Kalvasal','606903',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46151,135,'Kamakkur','606903',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46152,135,'Kanalapadi','606611',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46153,135,'Kandavaratti','604502',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46154,135,'Kangeyanur','606803',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46155,135,'Kanji','606702',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46156,135,'Kannamangalam Bazaar','632311',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46157,135,'Kannamangalam','632311',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46158,135,'Kanthapalayam','606901',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46159,135,'Kappalur','606751',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46160,135,'Karapattu','606705',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46161,135,'Karapundi','606803',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46162,135,'Kariamangalam','606709',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46163,135,'Karkonam','606751',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46164,135,'Karungalikuppam','604601',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46165,135,'Kasthambadi','606903',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46166,135,'Kattampoondi','606808',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46167,135,'Kattukanur','632312',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46168,135,'Kattumalayanur','606804',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46169,135,'Kayambattu','606701',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46170,135,'Kelur','606907',1,0,'2022-03-03 12:43:05','2022-03-03 12:43:05'),(46171,135,'Kesavapuram','606905',1,0,'2022-03-03 12:43:06','2022-03-03 12:43:06'),(46172,135,'Kettavarampalayam','606901',1,0,'2022-03-03 12:43:06','2022-03-03 12:43:06'),(46173,135,'Kidampalayam','606901',1,0,'2022-03-03 12:43:06','2022-03-03 12:43:06'),(46174,135,'Kikkalur','604601',1,0,'2022-03-03 12:43:06','2022-03-03 12:43:06'),(46175,135,'Kilaiyur','606710',1,0,'2022-03-03 12:43:06','2022-03-03 12:43:06'),(46176,135,'Kiliyapattu','606604',1,0,'2022-03-03 12:43:06','2022-03-03 12:43:06'),(46177,135,'Kilkarippur','606755',1,0,'2022-03-03 12:43:06','2022-03-03 12:43:06'),(46178,135,'Kilkodungalur','604403',1,0,'2022-03-03 12:43:06','2022-03-03 12:43:06'),(46179,135,'Kilkovalavedu','604404',1,0,'2022-03-03 12:43:06','2022-03-03 12:43:06'),(46180,135,'Kilkuppam','606705',1,0,'2022-03-03 12:43:06','2022-03-03 12:43:06'),(46181,135,'Kilnachipattu','606611',1,0,'2022-03-03 12:43:06','2022-03-03 12:43:06'),(46182,135,'Kilnamandi','604501',1,0,'2022-03-03 12:43:06','2022-03-03 12:43:06'),(46183,135,'Kilnarma','604403',1,0,'2022-03-03 12:43:06','2022-03-03 12:43:06'),(46184,135,'Kilnathur','606601',1,0,'2022-03-03 12:43:06','2022-03-03 12:43:06'),(46185,135,'Kilpaliyapattu','606704',1,0,'2022-03-03 12:43:06','2022-03-03 12:43:06'),(46186,135,'Kilpalur','606908',1,0,'2022-03-03 12:43:06','2022-03-03 12:43:06'),(46187,135,'Kilpennathur','604601',1,0,'2022-03-03 12:43:06','2022-03-03 12:43:06'),(46188,135,'Kilputhur','604501',1,0,'2022-03-03 12:43:06','2022-03-03 12:43:06'),(46189,135,'Kilsathamangalam','604408',1,0,'2022-03-03 12:43:06','2022-03-03 12:43:06'),(46190,135,'Kilsirupakkam','606707',1,0,'2022-03-03 12:43:06','2022-03-03 12:43:06'),(46191,135,'Kilvanakkambadi','606707',1,0,'2022-03-03 12:43:06','2022-03-03 12:43:06'),(46192,135,'Kilvillivalam','604408',1,0,'2022-03-03 12:43:06','2022-03-03 12:43:06'),(46193,135,'Kodanagar','604407',1,0,'2022-03-03 12:43:06','2022-03-03 12:43:06'),(46194,135,'Kodanallur','604405',1,0,'2022-03-03 12:43:06','2022-03-03 12:43:06'),(46195,135,'Kodiyalam','604406',1,0,'2022-03-03 12:43:06','2022-03-03 12:43:06'),(46196,135,'Kolakkaravadi','606805',1,0,'2022-03-03 12:43:07','2022-03-03 12:43:07'),(46197,135,'Kolakudi','606808',1,0,'2022-03-03 12:43:07','2022-03-03 12:43:07'),(46198,135,'Kolappalur (Tiruvannamalai)','632313',1,0,'2022-03-03 12:43:07','2022-03-03 12:43:07'),(46199,135,'Kolundampattu','606706',1,0,'2022-03-03 12:43:07','2022-03-03 12:43:07'),(46200,135,'Konalur','606755',1,0,'2022-03-03 12:43:07','2022-03-03 12:43:07'),(46201,135,'Korakkai','604409',1,0,'2022-03-03 12:43:07','2022-03-03 12:43:07'),(46202,135,'Kothandavadi','606752',1,0,'2022-03-03 12:43:07','2022-03-03 12:43:07'),(46203,135,'Kottai','604403',1,0,'2022-03-03 12:43:07','2022-03-03 12:43:07'),(46204,135,'Kovilur','604404',1,0,'2022-03-03 12:43:07','2022-03-03 12:43:07'),(46205,135,'Krishnapuram','606905',1,0,'2022-03-03 12:43:07','2022-03-03 12:43:07'),(46206,135,'Kulathur','632311',1,0,'2022-03-03 12:43:07','2022-03-03 12:43:07'),(46207,135,'Kulathur','606755',1,0,'2022-03-03 12:43:07','2022-03-03 12:43:07'),(46208,135,'Kunnakampoondi','604501',1,0,'2022-03-03 12:43:07','2022-03-03 12:43:07'),(46209,135,'Kunnathur Arni','632314',1,0,'2022-03-03 12:43:07','2022-03-03 12:43:07'),(46210,135,'Kunnathur','604402',1,0,'2022-03-03 12:43:07','2022-03-03 12:43:07'),(46211,135,'Kuppam','632311',1,0,'2022-03-03 12:43:07','2022-03-03 12:43:07'),(46212,135,'Kuppanatham','606710',1,0,'2022-03-03 12:43:07','2022-03-03 12:43:07'),(46213,135,'Kuruvimalai','606751',1,0,'2022-03-03 12:43:07','2022-03-03 12:43:07'),(46214,135,'Kuthanur','604402',1,0,'2022-03-03 12:43:07','2022-03-03 12:43:07'),(46215,135,'Kuttar','606708',1,0,'2022-03-03 12:43:07','2022-03-03 12:43:07'),(46216,135,'Kuvalai','604403',1,0,'2022-03-03 12:43:07','2022-03-03 12:43:07'),(46217,135,'Kuyilam','606710',1,0,'2022-03-03 12:43:07','2022-03-03 12:43:07'),(46218,135,'Ladavaram','606751',1,0,'2022-03-03 12:43:07','2022-03-03 12:43:07'),(46219,135,'Madipakkam','631701',1,0,'2022-03-03 12:43:07','2022-03-03 12:43:07'),(46220,135,'Madurampattu','606804',1,0,'2022-03-03 12:43:07','2022-03-03 12:43:07'),(46221,135,'Mahamayee Tirumani','604501',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46222,135,'Malamanjanur','606708',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46223,135,'Malappambadi','606611',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46224,135,'Malayur','604502',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46225,135,'Maligaipattu','604409',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46226,135,'Mallavadi','606805',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46227,135,'Mamandur','632317',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46228,135,'Mamandur Kanchipuram','631702',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46229,135,'Mambattu','606803',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46230,135,'Mandakolathur','606904',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46231,135,'Mangalam (Tiruvannamalai)','606752',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46232,135,'Manganallur','604408',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46233,135,'Mansurabad','606902',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46234,135,'Marudadu','604405',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46235,135,'Maruthuvambadi','606801',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46236,135,'Maruthuvambadi','606802',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46237,135,'Matam','604502',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46238,135,'Mathur','631701',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46239,135,'Mavalavadi','604406',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46240,135,'Mekkalur','604601',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46241,135,'Melachery','604502',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46242,135,'Melarvandavadi','606703',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46243,135,'Melathangal','606807',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46244,135,'Melchengam','606703',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46245,135,'Melma','604408',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46246,135,'Melmattaivinnamangalam','604503',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46247,135,'Melmudiyanur','606704',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46248,135,'Melnachipattu','606704',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46249,135,'Melnagar','632315',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46250,135,'Melnemili','604505',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46251,135,'Melpadur','606702',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46252,135,'Melpallipattu','606703',1,0,'2022-03-03 12:43:08','2022-03-03 12:43:08'),(46253,135,'Melpathi','604505',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46254,135,'Melpennathur','606704',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46255,135,'Melpuludiyur','606709',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46256,135,'Melsishamangalam','604504',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46257,135,'Melsolankuppam','606901',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46258,135,'Melvanakakambadi','606703',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46259,135,'Menalur','631702',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46260,135,'Meyyur','632317',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46261,135,'Meyyur','606753',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46262,135,'Modaiyur','606902',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46263,135,'Molugampoondi','632317',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46264,135,'Morakaniyanur','606801',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46265,135,'Moranam','604407',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46266,135,'Mosavadi','604503',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46267,135,'Mottakkal','606708',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46268,135,'Mukkur','604409',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46269,135,'Mukkurumbai','606903',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46270,135,'Mullipattu','632316',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46271,135,'Munnurmangalam','606705',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46272,135,'Munugapattu','604504',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46273,135,'Murugapadi','606803',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46274,135,'Murukattampundi','604407',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46275,135,'Nachipattu','606709',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46276,135,'Nadukuppam','606903',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46277,135,'Nallavanpalayam','606603',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46278,135,'Nallur','604406',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46279,135,'Namandi','604410',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46280,135,'Namathodu','632313',1,0,'2022-03-03 12:43:09','2022-03-03 12:43:09'),(46281,135,'Nambedu','604505',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46282,135,'Nambedu','606902',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46283,135,'Naraiyur','606754',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46284,135,'Narasingapuram','606902',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46285,135,'Narayanakuppam','606708',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46286,135,'Narayanamangalam','632313',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46287,135,'Nariyapattu','606753',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46288,135,'Navalpakkam','604503',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46289,135,'Nayudumangalam','606802',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46290,135,'Nedumbarai','604407',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46291,135,'Nedungunam','606807',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46292,135,'Neepathurai','606703',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46293,135,'Neivanatham','606754',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46294,135,'Nelliyankulam','604405',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46295,135,'Nerkunam','604406',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46296,135,'Nesal','632316',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46297,135,'Nookambadi','606752',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46298,135,'Northampoondi','606802',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46299,135,'Odalavadi','632326',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46300,135,'Olaipadi','606754',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46301,135,'Onnupuram','632315',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46302,135,'Oorgoundanur','606710',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46303,135,'Osur','604405',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46304,135,'P Quilam','606708',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46305,135,'Pachal (Tiruvannamalai)','606704',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46306,135,'Padagam','606904',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46307,135,'Padiagraharam','606705',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46308,135,'Paiyur','632317',1,0,'2022-03-03 12:43:10','2022-03-03 12:43:10'),(46309,135,'Pakkiripalayam','606709',1,0,'2022-03-03 12:43:11','2022-03-03 12:43:11'),(46310,135,'Palampettai','606801',1,0,'2022-03-03 12:43:11','2022-03-03 12:43:11'),(46311,135,'Palanandal','606752',1,0,'2022-03-03 12:43:11','2022-03-03 12:43:11'),(46312,135,'Palankoil','606751',1,0,'2022-03-03 12:43:11','2022-03-03 12:43:11'),(46313,135,'Palavalam','606754',1,0,'2022-03-03 12:43:11','2022-03-03 12:43:11'),(46314,135,'Palayanur','606753',1,0,'2022-03-03 12:43:11','2022-03-03 12:43:11'),(46315,135,'Palli','604407',1,0,'2022-03-03 12:43:11','2022-03-03 12:43:11'),(46316,135,'Pallikondapattu','606611',1,0,'2022-03-03 12:43:11','2022-03-03 12:43:11'),(46317,135,'Pandithapattu','606603',1,0,'2022-03-03 12:43:11','2022-03-03 12:43:11'),(46318,135,'Pappanthangal','604407',1,0,'2022-03-03 12:43:11','2022-03-03 12:43:11'),(46319,135,'Paramanandal','606710',1,0,'2022-03-03 12:43:11','2022-03-03 12:43:11'),(46320,135,'Parasur','604409',1,0,'2022-03-03 12:43:11','2022-03-03 12:43:11'),(46321,135,'Parayampattu','606808',1,0,'2022-03-03 12:43:11','2022-03-03 12:43:11'),(46322,135,'Pathiyavadi','606751',1,0,'2022-03-03 12:43:11','2022-03-03 12:43:11'),(46323,135,'Pavithiram','606806',1,0,'2022-03-03 12:43:11','2022-03-03 12:43:11'),(46324,135,'Pelasur','606803',1,0,'2022-03-03 12:43:11','2022-03-03 12:43:11'),(46325,135,'Pennattagaram','604406',1,0,'2022-03-03 12:43:11','2022-03-03 12:43:11'),(46326,135,'Periagaram','606803',1,0,'2022-03-03 12:43:11','2022-03-03 12:43:11'),(46327,135,'Periyakilambadi','606802',1,0,'2022-03-03 12:43:11','2022-03-03 12:43:11'),(46328,135,'Periyakolapadi','606704',1,0,'2022-03-03 12:43:11','2022-03-03 12:43:11'),(46329,135,'Pernamallur','604503',1,0,'2022-03-03 12:43:11','2022-03-03 12:43:11'),(46330,135,'Perumanam','606806',1,0,'2022-03-03 12:43:11','2022-03-03 12:43:11'),(46331,135,'Perumbalai','604401',1,0,'2022-03-03 12:43:11','2022-03-03 12:43:11'),(46332,135,'Perungulathur','604407',1,0,'2022-03-03 12:43:11','2022-03-03 12:43:11'),(46333,135,'Perunkolathur','606708',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46334,135,'Perunthuraipattu','606753',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46335,135,'Pillanthangal','604410',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46336,135,'Pinjur','606709',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46337,135,'Polur (Tiruvannamalai)','606803',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46338,135,'Polur Town','606803',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46339,135,'Ponnur','604408',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46340,135,'Porkunam','606802',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46341,135,'Potharai','606803',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46342,135,'Pudupalayam','631702',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46343,135,'Pudupalayam (Tiruvannamalai)','606705',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46344,135,'Pudupattu','606710',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46345,135,'Pudur Chekkadi','606708',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46346,135,'Pudur Chengam','606705',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46347,135,'Pulavanpadi','606903',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46348,135,'Pulivanandal','606904',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46349,135,'Puliyampatti','606703',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46350,135,'Pundi Polur','606751',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46351,135,'Pungambadi','606903',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46352,135,'Punnai','604405',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46353,135,'Purisai','604401',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46354,135,'Puthur','632315',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46355,135,'R.Kunnathur','606803',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46356,135,'Radhapuram','606707',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46357,135,'Ragunathapuram','632316',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46358,135,'Ragunathasamudram','604503',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46359,135,'Rajapalayam','606755',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46360,135,'Ramakrishnapuram','604402',1,0,'2022-03-03 12:43:12','2022-03-03 12:43:12'),(46361,135,'Ramanathapuram','606905',1,0,'2022-03-03 12:43:13','2022-03-03 12:43:13'),(46362,135,'Randam','604407',1,0,'2022-03-03 12:43:13','2022-03-03 12:43:13'),(46363,135,'Rattinamangalam','632316',1,0,'2022-03-03 12:43:13','2022-03-03 12:43:13'),(46364,135,'Rayampettai','604601',1,0,'2022-03-03 12:43:13','2022-03-03 12:43:13'),(46365,135,'Rayandapuram','606708',1,0,'2022-03-03 12:43:13','2022-03-03 12:43:13'),(46366,135,'Reddiarpalayam','606708',1,0,'2022-03-03 12:43:13','2022-03-03 12:43:13'),(46367,135,'S Sorpanandal','606706',1,0,'2022-03-03 12:43:13','2022-03-03 12:43:13'),(46368,135,'Saduperipalayam','606907',1,0,'2022-03-03 12:43:13','2022-03-03 12:43:13'),(46369,135,'Saidapettai Arni','632301',1,0,'2022-03-03 12:43:13','2022-03-03 12:43:13'),(46370,135,'Salukkai','604408',1,0,'2022-03-03 12:43:13','2022-03-03 12:43:13'),(46371,135,'Salvedu','604403',1,0,'2022-03-03 12:43:13','2022-03-03 12:43:13'),(46372,135,'Sanikkavadi','606803',1,0,'2022-03-03 12:43:13','2022-03-03 12:43:13'),(46373,135,'Sanipundi','606755',1,0,'2022-03-03 12:43:13','2022-03-03 12:43:13'),(46374,135,'Santhavasal','606905',1,0,'2022-03-03 12:43:13','2022-03-03 12:43:13'),(46375,135,'Saron','606601',1,0,'2022-03-03 12:43:13','2022-03-03 12:43:13'),(46376,135,'Sathanur','606706',1,0,'2022-03-03 12:43:13','2022-03-03 12:43:13'),(46377,135,'Sathanurdam','606706',1,0,'2022-03-03 12:43:13','2022-03-03 12:43:13'),(46378,135,'Sathiyaviziyanagaram','632317',1,0,'2022-03-03 12:43:13','2022-03-03 12:43:13'),(46379,135,'Sattapundi','604501',1,0,'2022-03-03 12:43:13','2022-03-03 12:43:13'),(46380,135,'Sedarampattu','632315',1,0,'2022-03-03 12:43:13','2022-03-03 12:43:13'),(46381,135,'Semmambadi','632313',1,0,'2022-03-03 12:43:13','2022-03-03 12:43:13'),(46382,135,'Semmiyamangalam','606904',1,0,'2022-03-03 12:43:13','2022-03-03 12:43:13'),(46383,135,'Senal','604406',1,0,'2022-03-03 12:43:13','2022-03-03 12:43:13'),(46384,135,'Sengadu','604505',1,0,'2022-03-03 12:43:13','2022-03-03 12:43:13'),(46385,135,'Sengattankundil','604407',1,0,'2022-03-03 12:43:13','2022-03-03 12:43:13'),(46386,135,'Sengunam','606803',1,0,'2022-03-03 12:43:13','2022-03-03 12:43:13'),(46387,135,'Sennavaram','604408',1,0,'2022-03-03 12:43:14','2022-03-03 12:43:14'),(46388,135,'Serpapattu','606753',1,0,'2022-03-03 12:43:14','2022-03-03 12:43:14'),(46389,135,'Sevarapundi','606902',1,0,'2022-03-03 12:43:14','2022-03-03 12:43:14'),(46390,135,'Shro. Navalpakkam','604408',1,0,'2022-03-03 12:43:14','2022-03-03 12:43:14'),(46391,135,'Sirumur','632314',1,0,'2022-03-03 12:43:14','2022-03-03 12:43:14'),(46392,135,'Sirunathur','604601',1,0,'2022-03-03 12:43:14','2022-03-03 12:43:14'),(46393,135,'Siruvallur','606906',1,0,'2022-03-03 12:43:14','2022-03-03 12:43:14'),(46394,135,'Somasipadi','606611',1,0,'2022-03-03 12:43:14','2022-03-03 12:43:14'),(46395,135,'Sorakulathur','606802',1,0,'2022-03-03 12:43:14','2022-03-03 12:43:14'),(46396,135,'Sozhavaram','631701',1,0,'2022-03-03 12:43:14','2022-03-03 12:43:14'),(46397,135,'Srinivasaudayanavaram','632314',1,0,'2022-03-03 12:43:14','2022-03-03 12:43:14'),(46398,135,'Sriramanashramam','606603',1,0,'2022-03-03 12:43:14','2022-03-03 12:43:14'),(46399,135,'Su Valavetti','606806',1,0,'2022-03-03 12:43:14','2022-03-03 12:43:14'),(46400,135,'Su. Andapattu','606808',1,0,'2022-03-03 12:43:14','2022-03-03 12:43:14'),(46401,135,'Su. Pappambadi','606808',1,0,'2022-03-03 12:43:14','2022-03-03 12:43:14'),(46402,135,'Sumangali','604402',1,0,'2022-03-03 12:43:14','2022-03-03 12:43:14'),(46403,135,'Susainagar','632326',1,0,'2022-03-03 12:43:14','2022-03-03 12:43:14'),(46404,135,'Tandarai','606804',1,0,'2022-03-03 12:43:14','2022-03-03 12:43:14'),(46405,135,'Tandarampattu','606707',1,0,'2022-03-03 12:43:14','2022-03-03 12:43:14'),(46406,135,'Tanipadi','606708',1,0,'2022-03-03 12:43:14','2022-03-03 12:43:14'),(46407,135,'Taradapattu','606707',1,0,'2022-03-03 12:43:14','2022-03-03 12:43:14'),(46408,135,'Tellar','604406',1,0,'2022-03-03 12:43:14','2022-03-03 12:43:14'),(46409,135,'Tellur-Arni','632313',1,0,'2022-03-03 12:43:14','2022-03-03 12:43:14'),(46410,135,'Thachampattu','606811',1,0,'2022-03-03 12:43:14','2022-03-03 12:43:14'),(46411,135,'Thaiyar','604406',1,0,'2022-03-03 12:43:14','2022-03-03 12:43:14'),(46412,135,'Thatchambadi','606902',1,0,'2022-03-03 12:43:14','2022-03-03 12:43:14'),(46413,135,'Thatchur','632326',1,0,'2022-03-03 12:43:15','2022-03-03 12:43:15'),(46414,135,'Thenelapakkam','604408',1,0,'2022-03-03 12:43:15','2022-03-03 12:43:15'),(46415,135,'Thenkarimbalur','606753',1,0,'2022-03-03 12:43:15','2022-03-03 12:43:15'),(46416,135,'Thenmahadevamangalam','606908',1,0,'2022-03-03 12:43:15','2022-03-03 12:43:15'),(46417,135,'Thenmathur','606603',1,0,'2022-03-03 12:43:15','2022-03-03 12:43:15'),(46418,135,'Thenmudiyanur','606707',1,0,'2022-03-03 12:43:15','2022-03-03 12:43:15'),(46419,135,'Thennagaram','606802',1,0,'2022-03-03 12:43:15','2022-03-03 12:43:15'),(46420,135,'Thennankur','604408',1,0,'2022-03-03 12:43:15','2022-03-03 12:43:15'),(46421,135,'Thennathur','604501',1,0,'2022-03-03 12:43:15','2022-03-03 12:43:15'),(46422,135,'Thenpallipattu','606751',1,0,'2022-03-03 12:43:15','2022-03-03 12:43:15'),(46423,135,'Thenthinnalur','604501',1,0,'2022-03-03 12:43:15','2022-03-03 12:43:15'),(46424,135,'Therasapuram','604406',1,0,'2022-03-03 12:43:15','2022-03-03 12:43:15'),(46425,135,'Thethurai','604408',1,0,'2022-03-03 12:43:15','2022-03-03 12:43:15'),(46426,135,'Thithandapattu','606701',1,0,'2022-03-03 12:43:15','2022-03-03 12:43:15'),(46427,135,'Thorapadi','606704',1,0,'2022-03-03 12:43:15','2022-03-03 12:43:15'),(46428,135,'Thozhupedu','604409',1,0,'2022-03-03 12:43:15','2022-03-03 12:43:15'),(46429,135,'Thukkapettai','606709',1,0,'2022-03-03 12:43:15','2022-03-03 12:43:15'),(46430,135,'Thumbakkadu','606803',1,0,'2022-03-03 12:43:15','2022-03-03 12:43:15'),(46431,135,'Thumbur','606902',1,0,'2022-03-03 12:43:15','2022-03-03 12:43:15'),(46432,135,'Tirumalai','606907',1,0,'2022-03-03 12:43:15','2022-03-03 12:43:15'),(46433,135,'Tirumani','604504',1,0,'2022-03-03 12:43:15','2022-03-03 12:43:15'),(46434,135,'Tirumpundi','604404',1,0,'2022-03-03 12:43:15','2022-03-03 12:43:15'),(46435,135,'Tiruppanangadu','604410',1,0,'2022-03-03 12:43:15','2022-03-03 12:43:15'),(46436,135,'Tirusur','606803',1,0,'2022-03-03 12:43:15','2022-03-03 12:43:15'),(46437,135,'Tiruvadathanur','606708',1,0,'2022-03-03 12:43:15','2022-03-03 12:43:15'),(46438,135,'Tiruvannamalai Bazaar','606601',1,0,'2022-03-03 12:43:16','2022-03-03 12:43:16'),(46439,135,'Tiruvannamalai H.O','606601',1,0,'2022-03-03 12:43:16','2022-03-03 12:43:16'),(46440,135,'Tiruvannamalai RS','606601',1,0,'2022-03-03 12:43:16','2022-03-03 12:43:16'),(46441,135,'Tiruvettipuram Cutcherry','604407',1,0,'2022-03-03 12:43:16','2022-03-03 12:43:16'),(46442,135,'Tiruvettipuram','604407',1,0,'2022-03-03 12:43:16','2022-03-03 12:43:16'),(46443,135,'Turinjapuram','606805',1,0,'2022-03-03 12:43:16','2022-03-03 12:43:16'),(46444,135,'Ukkal','631701',1,0,'2022-03-03 12:43:16','2022-03-03 12:43:16'),(46445,135,'Ulagampattu','606801',1,0,'2022-03-03 12:43:16','2022-03-03 12:43:16'),(46446,135,'Ulundai','604403',1,0,'2022-03-03 12:43:16','2022-03-03 12:43:16'),(46447,135,'Vadakalpakkam','631702',1,0,'2022-03-03 12:43:16','2022-03-03 12:43:16'),(46448,135,'Vadamadimangalam','606907',1,0,'2022-03-03 12:43:16','2022-03-03 12:43:16'),(46449,135,'Vadamanapakkam','604402',1,0,'2022-03-03 12:43:16','2022-03-03 12:43:16'),(46450,135,'Vadamathur','606702',1,0,'2022-03-03 12:43:16','2022-03-03 12:43:16'),(46451,135,'Vadathinallur','604409',1,0,'2022-03-03 12:43:16','2022-03-03 12:43:16'),(46452,135,'Vadavanakkambadi','604505',1,0,'2022-03-03 12:43:16','2022-03-03 12:43:16'),(46453,135,'Vadugasathu','632316',1,0,'2022-03-03 12:43:16','2022-03-03 12:43:16'),(46454,135,'Vaipur','606754',1,0,'2022-03-03 12:43:16','2022-03-03 12:43:16'),(46455,135,'Valavachanur','606753',1,0,'2022-03-03 12:43:16','2022-03-03 12:43:16'),(46456,135,'Valayampattu','606701',1,0,'2022-03-03 12:43:16','2022-03-03 12:43:16'),(46457,135,'Valkadai','604409',1,0,'2022-03-03 12:43:16','2022-03-03 12:43:16'),(46458,135,'Vallivagai','606752',1,0,'2022-03-03 12:43:16','2022-03-03 12:43:16'),(46459,135,'Valudalangunam','604601',1,0,'2022-03-03 12:43:16','2022-03-03 12:43:16'),(46460,135,'Vanapuram','606753',1,0,'2022-03-03 12:43:16','2022-03-03 12:43:16'),(46461,135,'Vandavasi','604408',1,0,'2022-03-03 12:43:16','2022-03-03 12:43:16'),(46462,135,'Vannankulam','632315',1,0,'2022-03-03 12:43:16','2022-03-03 12:43:16'),(46463,135,'Varagur','606753',1,0,'2022-03-03 12:43:16','2022-03-03 12:43:16'),(46464,135,'Varagur Pudur','632319',1,0,'2022-03-03 12:43:17','2022-03-03 12:43:17'),(46465,135,'Vasudevampattu','606704',1,0,'2022-03-03 12:43:17','2022-03-03 12:43:17'),(46466,135,'Vasur','606803',1,0,'2022-03-03 12:43:17','2022-03-03 12:43:17'),(46467,135,'Vayalamoor','604406',1,0,'2022-03-03 12:43:17','2022-03-03 12:43:17'),(46468,135,'Vayalur','604501',1,0,'2022-03-03 12:43:17','2022-03-03 12:43:17'),(46469,135,'Vazhiyur','632315',1,0,'2022-03-03 12:43:17','2022-03-03 12:43:17'),(46470,135,'Vazhur','604405',1,0,'2022-03-03 12:43:17','2022-03-03 12:43:17'),(46471,135,'Vedal','604501',1,0,'2022-03-03 12:43:17','2022-03-03 12:43:17'),(46472,135,'Vedanatham','606611',1,0,'2022-03-03 12:43:17','2022-03-03 12:43:17'),(46473,135,'Vedandavadi','606752',1,0,'2022-03-03 12:43:17','2022-03-03 12:43:17'),(46474,135,'Veerambakkam-pudur','604408',1,0,'2022-03-03 12:43:17','2022-03-03 12:43:17'),(46475,135,'Veeranandal','606705',1,0,'2022-03-03 12:43:17','2022-03-03 12:43:17'),(46476,135,'Velapadi-Arni','632317',1,0,'2022-03-03 12:43:17','2022-03-03 12:43:17'),(46477,135,'Velayampakkam','606753',1,0,'2022-03-03 12:43:17','2022-03-03 12:43:17'),(46478,135,'Velleri','632317',1,0,'2022-03-03 12:43:17','2022-03-03 12:43:17'),(46479,135,'Velliambakkam','604403',1,0,'2022-03-03 12:43:17','2022-03-03 12:43:17'),(46480,135,'Vellur','606905',1,0,'2022-03-03 12:43:17','2022-03-03 12:43:17'),(46481,135,'Veluganandal','606802',1,0,'2022-03-03 12:43:17','2022-03-03 12:43:17'),(46482,135,'Vembakkam','604410',1,0,'2022-03-03 12:43:17','2022-03-03 12:43:17'),(46483,135,'Vengalathur','604410',1,0,'2022-03-03 12:43:17','2022-03-03 12:43:17'),(46484,135,'Vengaram','604408',1,0,'2022-03-03 12:43:17','2022-03-03 12:43:17'),(46485,135,'Vengikkal','606604',1,0,'2022-03-03 12:43:17','2022-03-03 12:43:17'),(46486,135,'Veppambattu','606807',1,0,'2022-03-03 12:43:17','2022-03-03 12:43:17'),(46487,135,'Veppurchekkadi','606706',1,0,'2022-03-03 12:43:17','2022-03-03 12:43:17'),(46488,135,'Veraiyur','606806',1,0,'2022-03-03 12:43:17','2022-03-03 12:43:17'),(46489,135,'Vettavalam','606754',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46490,135,'Vettiyantholuvam','632314',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46491,135,'Vilapakkam','606904',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46492,135,'Vilvarani','606906',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46493,135,'Vinnamangalamarni','632316',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46494,135,'Vinnavadi','604407',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46495,135,'Viralur','606901',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46496,135,'Athipattu(T)','635703',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46497,135,'Attiyanur','635703',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46498,135,'Gunikanthur','635703',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46499,135,'Jamanamarathur','635703',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46500,135,'Kovilur','635703',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46501,135,'Kuttakarai','635703',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46502,135,'Kuttathur','635703',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46503,135,'Mandaparai','635703',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46504,135,'Melpattu (T)','635703',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46505,135,'Melsilambadi','635703',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46506,135,'Nachamalai','635703',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46507,135,'Palamarathur','635703',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46508,135,'Pattaraikadu','635703',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46509,135,'Puliyur (T)','635703',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46510,135,'Veerappanur','635703',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46511,135,'Moongilthuraipattu','605702',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46512,136,'Abivirthiswaram','613705',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46513,136,'Agaraohai','612601',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46514,136,'Arasavanangadu','612603',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46515,136,'Attikkadai','613702',1,0,'2022-03-03 12:43:18','2022-03-03 12:43:18'),(46516,136,'Barakadabad','613705',1,0,'2022-03-03 12:43:19','2022-03-03 12:43:19'),(46517,136,'Hanumanthapuram','613703',1,0,'2022-03-03 12:43:19','2022-03-03 12:43:19'),(46518,136,'Ilaiyur','613705',1,0,'2022-03-03 12:43:19','2022-03-03 12:43:19'),(46519,136,'Kadalangudi','609501',1,0,'2022-03-03 12:43:19','2022-03-03 12:43:19'),(46520,136,'Kalathur','613703',1,0,'2022-03-03 12:43:19','2022-03-03 12:43:19'),(46521,136,'Kandramanickam','612604',1,0,'2022-03-03 12:43:19','2022-03-03 12:43:19'),(46522,136,'Kilapalaiyur','612610',1,0,'2022-03-03 12:43:19','2022-03-03 12:43:19'),(46523,136,'Kilariam','613703',1,0,'2022-03-03 12:43:19','2022-03-03 12:43:19'),(46524,136,'Kodavasal','612601',1,0,'2022-03-03 12:43:19','2022-03-03 12:43:19'),(46525,136,'Koradacheri','613703',1,0,'2022-03-03 12:43:19','2022-03-03 12:43:19'),(46526,136,'Kundalur','609501',1,0,'2022-03-03 12:43:19','2022-03-03 12:43:19'),(46527,136,'Manjakudi','612610',1,0,'2022-03-03 12:43:19','2022-03-03 12:43:19'),(46528,136,'Melapalayur','612601',1,0,'2022-03-03 12:43:19','2022-03-03 12:43:19'),(46529,136,'Moolangudi','612610',1,0,'2022-03-03 12:43:19','2022-03-03 12:43:19'),(46530,136,'Oorgudi','613703',1,0,'2022-03-03 12:43:19','2022-03-03 12:43:19'),(46531,136,'Pakkamparuthiyur','610107',1,0,'2022-03-03 12:43:19','2022-03-03 12:43:19'),(46532,136,'Paruthiyur','612604',1,0,'2022-03-03 12:43:19','2022-03-03 12:43:19'),(46533,136,'Pathur','613703',1,0,'2022-03-03 12:43:19','2022-03-03 12:43:19'),(46534,136,'Perumalagaram','613703',1,0,'2022-03-03 12:43:19','2022-03-03 12:43:19'),(46535,136,'Perumpannaiyur','612603',1,0,'2022-03-03 12:43:19','2022-03-03 12:43:19'),(46536,136,'Pudukudi','609501',1,0,'2022-03-03 12:43:19','2022-03-03 12:43:19'),(46537,136,'Pudukudi','612610',1,0,'2022-03-03 12:43:19','2022-03-03 12:43:19'),(46538,136,'Sarguneswarapuram','609501',1,0,'2022-03-03 12:43:19','2022-03-03 12:43:19'),(46539,136,'Sellur (Tiruvarur)','613705',1,0,'2022-03-03 12:43:19','2022-03-03 12:43:19'),(46540,136,'Sembangudi','612603',1,0,'2022-03-03 12:43:19','2022-03-03 12:43:19'),(46541,136,'Sengalipuram','612604',1,0,'2022-03-03 12:43:19','2022-03-03 12:43:19'),(46542,136,'Senganur','610107',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46543,136,'Serukalathur','612604',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46544,136,'Sidakkamangalam','612604',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46545,136,'Simili','612603',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46546,136,'Sithadi','612604',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46547,136,'Srivanjiam','610107',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46548,136,'Tiruchirai','612605',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46549,136,'Tiruvidacherry','610107',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46550,136,'Tiruvizhimizhalai','609501',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46551,136,'Vadamattam','612201',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46552,136,'Vadaver','612604',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46553,136,'Veedhividangan','610107',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46554,136,'Vellakulam','612601',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46555,136,'Vennavasal','613703',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46556,136,'Vidayalkaruppur','612605',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46557,136,'Vikrapandiyam','610107',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46558,136,'Vilagam','609501',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46559,136,'Vishnupuram','609501',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46560,136,'Agarathirumalam','609503',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46561,136,'Alathur','609405',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46562,136,'Injikudi','609405',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46563,136,'Kaliyakudi','609403',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46564,136,'Keeranur','609403',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46565,136,'Kollumangudi','609403',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46566,136,'Koothanur','609503',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46567,136,'Manandakudi','609503',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46568,136,'Maruduvancheri','609503',1,0,'2022-03-03 12:43:20','2022-03-03 12:43:20'),(46569,136,'Nedungulam','609403',1,0,'2022-03-03 12:43:21','2022-03-03 12:43:21'),(46570,136,'Pavattakudi','609403',1,0,'2022-03-03 12:43:21','2022-03-03 12:43:21'),(46571,136,'Peralam','609405',1,0,'2022-03-03 12:43:21','2022-03-03 12:43:21'),(46572,136,'Pillur','609403',1,0,'2022-03-03 12:43:21','2022-03-03 12:43:21'),(46573,136,'Punthottam','609503',1,0,'2022-03-03 12:43:21','2022-03-03 12:43:21'),(46574,136,'Sarabojirajapuram','609503',1,0,'2022-03-03 12:43:21','2022-03-03 12:43:21'),(46575,136,'Sembiyanallur','609503',1,0,'2022-03-03 12:43:21','2022-03-03 12:43:21'),(46576,136,'Sirupuliyur','609403',1,0,'2022-03-03 12:43:21','2022-03-03 12:43:21'),(46577,136,'Tirumeichur','609405',1,0,'2022-03-03 12:43:21','2022-03-03 12:43:21'),(46578,136,'Achuthamangalam','610105',1,0,'2022-03-03 12:43:21','2022-03-03 12:43:21'),(46579,136,'Adambar','610105',1,0,'2022-03-03 12:43:21','2022-03-03 12:43:21'),(46580,136,'Adiakkamangalam','611101',1,0,'2022-03-03 12:43:21','2022-03-03 12:43:21'),(46581,136,'Alangudi','609502',1,0,'2022-03-03 12:43:21','2022-03-03 12:43:21'),(46582,136,'Alathambadi','610203',1,0,'2022-03-03 12:43:21','2022-03-03 12:43:21'),(46583,136,'Alivalam','610106',1,0,'2022-03-03 12:43:21','2022-03-03 12:43:21'),(46584,136,'Ammanur','610201',1,0,'2022-03-03 12:43:21','2022-03-03 12:43:21'),(46585,136,'Ammayappan','613701',1,0,'2022-03-03 12:43:21','2022-03-03 12:43:21'),(46586,136,'Amur','610101',1,0,'2022-03-03 12:43:21','2022-03-03 12:43:21'),(46587,136,'Anaikuppam','610105',1,0,'2022-03-03 12:43:21','2022-03-03 12:43:21'),(46588,136,'Andankarai','610203',1,0,'2022-03-03 12:43:21','2022-03-03 12:43:21'),(46589,136,'Andipalayam','611101',1,0,'2022-03-03 12:43:21','2022-03-03 12:43:21'),(46590,136,'Athisolamangalam','613701',1,0,'2022-03-03 12:43:21','2022-03-03 12:43:21'),(46591,136,'Authur','610103',1,0,'2022-03-03 12:43:21','2022-03-03 12:43:21'),(46592,136,'Budamangalam','610102',1,0,'2022-03-03 12:43:21','2022-03-03 12:43:21'),(46593,136,'Dakshinamurthi Mutt','610001',1,0,'2022-03-03 12:43:21','2022-03-03 12:43:21'),(46594,136,'ELVANGARGUDI','610104',1,0,'2022-03-03 12:43:21','2022-03-03 12:43:21'),(46595,136,'Erukattur','610102',1,0,'2022-03-03 12:43:22','2022-03-03 12:43:22'),(46596,136,'Kachanam','610201',1,0,'2022-03-03 12:43:22','2022-03-03 12:43:22'),(46597,136,'Kallikudi','611101',1,0,'2022-03-03 12:43:22','2022-03-03 12:43:22'),(46598,136,'Kalyanamahadevi','613704',1,0,'2022-03-03 12:43:22','2022-03-03 12:43:22'),(46599,136,'Kamalapuram (Tiruvarur)','610102',1,0,'2022-03-03 12:43:22','2022-03-03 12:43:22'),(46600,136,'Kandodathavanitham','610102',1,0,'2022-03-03 12:43:22','2022-03-03 12:43:22'),(46601,136,'Kattur','610104',1,0,'2022-03-03 12:43:22','2022-03-03 12:43:22'),(46602,136,'Keeralathur','610205',1,0,'2022-03-03 12:43:22','2022-03-03 12:43:22'),(46603,136,'Kekkarai','610003',1,0,'2022-03-03 12:43:22','2022-03-03 12:43:22'),(46604,136,'Kidarankondan','610003',1,0,'2022-03-03 12:43:22','2022-03-03 12:43:22'),(46605,136,'Kilamanali','610103',1,0,'2022-03-03 12:43:22','2022-03-03 12:43:22'),(46606,136,'Kilapadugai','610109',1,0,'2022-03-03 12:43:22','2022-03-03 12:43:22'),(46607,136,'Kodikalpalayam','610001',1,0,'2022-03-03 12:43:22','2022-03-03 12:43:22'),(46608,136,'Kollapuram','609608',1,0,'2022-03-03 12:43:22','2022-03-03 12:43:22'),(46609,136,'Komal','610202',1,0,'2022-03-03 12:43:22','2022-03-03 12:43:22'),(46610,136,'Kulikarai','613704',1,0,'2022-03-03 12:43:22','2022-03-03 12:43:22'),(46611,136,'Kunnur','610203',1,0,'2022-03-03 12:43:22','2022-03-03 12:43:22'),(46612,136,'Kurungulam','609608',1,0,'2022-03-03 12:43:22','2022-03-03 12:43:22'),(46613,136,'Madapuram','610001',1,0,'2022-03-03 12:43:22','2022-03-03 12:43:22'),(46614,136,'Manakkal Ayyampet','610104',1,0,'2022-03-03 12:43:22','2022-03-03 12:43:22'),(46615,136,'Manali','610203',1,0,'2022-03-03 12:43:22','2022-03-03 12:43:22'),(46616,136,'Mangudi','610103',1,0,'2022-03-03 12:43:22','2022-03-03 12:43:22'),(46617,136,'Mappilaikuppam','610105',1,0,'2022-03-03 12:43:22','2022-03-03 12:43:22'),(46618,136,'Mavoor (Tiruvarur)','610202',1,0,'2022-03-03 12:43:22','2022-03-03 12:43:22'),(46619,136,'Meiporul Nagar','610001',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46620,136,'Menangudi','609608',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46621,136,'Moongilkudi','610101',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46622,136,'Mudikondan','609502',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46623,136,'Mukundanur','613701',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46624,136,'Nadapur','610101',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46625,136,'Nannilam Cutchery','610105',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46626,136,'Nannilam','610105',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46627,136,'Nemmeli','610105',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46628,136,'New Street','610001',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46629,136,'Palayavalam','610101',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46630,136,'Panangudi','609504',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46631,136,'Ponnirai','610203',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46632,136,'Pudupathur','610106',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46633,136,'Pulivalam (Tiruvarur)','610109',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46634,136,'Salipperi','610105',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46635,136,'Selvapuram','610101',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46636,136,'Semangalam','611101',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46637,136,'Seruvamani','610205',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46638,136,'Solachery','613701',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46639,136,'Suranur','610101',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46640,136,'Thandalai','610004',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46641,136,'Thappalampuliyur','610106',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46642,136,'Thazhakudi','613701',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46643,136,'Thuthukudi','609504',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46644,136,'Tirukannamangai','610104',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46645,136,'Tirukaravasal','610202',1,0,'2022-03-03 12:43:23','2022-03-03 12:43:23'),(46646,136,'Tirukottaram','609603',1,0,'2022-03-03 12:43:24','2022-03-03 12:43:24'),(46647,136,'Tirunattiyathankudi','610202',1,0,'2022-03-03 12:43:24','2022-03-03 12:43:24'),(46648,136,'Tiruneipair','610103',1,0,'2022-03-03 12:43:24','2022-03-03 12:43:24'),(46649,136,'Tirunellikaval','610205',1,0,'2022-03-03 12:43:24','2022-03-03 12:43:24'),(46650,136,'Tiruvarur Collectorate','610004',1,0,'2022-03-03 12:43:24','2022-03-03 12:43:24'),(46651,136,'Tiruvarur H.O','610001',1,0,'2022-03-03 12:43:24','2022-03-03 12:43:24'),(46652,136,'Tiruvarur North','610001',1,0,'2022-03-03 12:43:24','2022-03-03 12:43:24'),(46653,136,'Ubayavedanthapuram','609608',1,0,'2022-03-03 12:43:24','2022-03-03 12:43:24'),(46654,136,'Vadagudi','610105',1,0,'2022-03-03 12:43:24','2022-03-03 12:43:24'),(46655,136,'Vaipur','610101',1,0,'2022-03-03 12:43:24','2022-03-03 12:43:24'),(46656,136,'Valkkai','610105',1,0,'2022-03-03 12:43:24','2022-03-03 12:43:24'),(46657,136,'Velangudi','609603',1,0,'2022-03-03 12:43:24','2022-03-03 12:43:24'),(46658,136,'Velukudi','610102',1,0,'2022-03-03 12:43:24','2022-03-03 12:43:24'),(46659,136,'Vikkirapandiyam','610203',1,0,'2022-03-03 12:43:24','2022-03-03 12:43:24'),(46660,136,'Vilamal','610004',1,0,'2022-03-03 12:43:24','2022-03-03 12:43:24'),(46661,136,'Visalur','610101',1,0,'2022-03-03 12:43:24','2022-03-03 12:43:24'),(46662,136,'Alangadu','614704',1,0,'2022-03-03 12:43:24','2022-03-03 12:43:24'),(46663,136,'Alangadu Uppur','614704',1,0,'2022-03-03 12:43:24','2022-03-03 12:43:24'),(46664,136,'Ariyalur','614702',1,0,'2022-03-03 12:43:24','2022-03-03 12:43:24'),(46665,136,'Devadanam','614702',1,0,'2022-03-03 12:43:24','2022-03-03 12:43:24'),(46666,136,'Divammapuram','614715',1,0,'2022-03-03 12:43:24','2022-03-03 12:43:24'),(46667,136,'Ezhilur','614715',1,0,'2022-03-03 12:43:24','2022-03-03 12:43:24'),(46668,136,'Idaiyur','614702',1,0,'2022-03-03 12:43:24','2022-03-03 12:43:24'),(46669,136,'Idumbavanam','614703',1,0,'2022-03-03 12:43:24','2022-03-03 12:43:24'),(46670,136,'Jambavanodai','614738',1,0,'2022-03-03 12:43:24','2022-03-03 12:43:24'),(46671,136,'Kadiacheri','614715',1,0,'2022-03-03 12:43:25','2022-03-03 12:43:25'),(46672,136,'Karpaganatharkulam','614703',1,0,'2022-03-03 12:43:25','2022-03-03 12:43:25'),(46673,136,'Kattimodu','614716',1,0,'2022-03-03 12:43:25','2022-03-03 12:43:25'),(46674,136,'Keelapandi','614703',1,0,'2022-03-03 12:43:25','2022-03-03 12:43:25'),(46675,136,'Keerakalur','614715',1,0,'2022-03-03 12:43:25','2022-03-03 12:43:25'),(46676,136,'Kilanammankurichi','614704',1,0,'2022-03-03 12:43:25','2022-03-03 12:43:25'),(46677,136,'Kilaperumalai','614703',1,0,'2022-03-03 12:43:25','2022-03-03 12:43:25'),(46678,136,'Korukkai','614711',1,0,'2022-03-03 12:43:25','2022-03-03 12:43:25'),(46679,136,'Kothamangalam','614715',1,0,'2022-03-03 12:43:25','2022-03-03 12:43:25'),(46680,136,'Kovilur','614704',1,0,'2022-03-03 12:43:25','2022-03-03 12:43:25'),(46681,136,'Kulamanickam','614702',1,0,'2022-03-03 12:43:25','2022-03-03 12:43:25'),(46682,136,'Kummattitidal','614706',1,0,'2022-03-03 12:43:25','2022-03-03 12:43:25'),(46683,136,'Kunnalur','614703',1,0,'2022-03-03 12:43:25','2022-03-03 12:43:25'),(46684,136,'Melamarudur','614716',1,0,'2022-03-03 12:43:25','2022-03-03 12:43:25'),(46685,136,'Melanammankurichi','614903',1,0,'2022-03-03 12:43:25','2022-03-03 12:43:25'),(46686,136,'Melaperumalai','614703',1,0,'2022-03-03 12:43:25','2022-03-03 12:43:25'),(46687,136,'Mettupalayam','614715',1,0,'2022-03-03 12:43:25','2022-03-03 12:43:25'),(46688,136,'Mutupet','614704',1,0,'2022-03-03 12:43:25','2022-03-03 12:43:25'),(46689,136,'Nedumbalam','614703',1,0,'2022-03-03 12:43:25','2022-03-03 12:43:25'),(46690,136,'Ovarur','614703',1,0,'2022-03-03 12:43:25','2022-03-03 12:43:25'),(46691,136,'Pamani-TTP','614711',1,0,'2022-03-03 12:43:25','2022-03-03 12:43:25'),(46692,136,'Pettai','614704',1,0,'2022-03-03 12:43:25','2022-03-03 12:43:25'),(46693,136,'Pichankottagam','614716',1,0,'2022-03-03 12:43:25','2022-03-03 12:43:25'),(46694,136,'Pinnathur','614706',1,0,'2022-03-03 12:43:25','2022-03-03 12:43:25'),(46695,136,'Rayanallur','614715',1,0,'2022-03-03 12:43:25','2022-03-03 12:43:25'),(46696,136,'Sembadavankadu','614704',1,0,'2022-03-03 12:43:25','2022-03-03 12:43:25'),(46697,136,'Thillaivilagam','614706',1,0,'2022-03-03 12:43:26','2022-03-03 12:43:26'),(46698,136,'Thillaivilagam South','614706',1,0,'2022-03-03 12:43:26','2022-03-03 12:43:26'),(46699,136,'Tiruturaipundi Bazaar','614713',1,0,'2022-03-03 12:43:26','2022-03-03 12:43:26'),(46700,136,'Tiruturaipundi H.O','614713',1,0,'2022-03-03 12:43:26','2022-03-03 12:43:26'),(46701,136,'Tiruturaipundi R.S.','614713',1,0,'2022-03-03 12:43:26','2022-03-03 12:43:26'),(46702,136,'Tondiakkadu','614703',1,0,'2022-03-03 12:43:26','2022-03-03 12:43:26'),(46703,136,'Udayamarthandapuram','614706',1,0,'2022-03-03 12:43:26','2022-03-03 12:43:26'),(46704,136,'Vadiakadu','614703',1,0,'2022-03-03 12:43:26','2022-03-03 12:43:26'),(46705,136,'Vellur-ttp','614715',1,0,'2022-03-03 12:43:26','2022-03-03 12:43:26'),(46706,136,'Veppancheri','614703',1,0,'2022-03-03 12:43:26','2022-03-03 12:43:26'),(46707,136,'Vilakudi','614715',1,0,'2022-03-03 12:43:26','2022-03-03 12:43:26'),(46708,136,'Vittukatti','614715',1,0,'2022-03-03 12:43:26','2022-03-03 12:43:26'),(46709,136,'Adangudi','614103',1,0,'2022-03-03 12:43:26','2022-03-03 12:43:26'),(46710,136,'Adanur(KVN)','614403',1,0,'2022-03-03 12:43:26','2022-03-03 12:43:26'),(46711,136,'Adichamangalam','612804',1,0,'2022-03-03 12:43:26','2022-03-03 12:43:26'),(46712,136,'Adichapuram','614717',1,0,'2022-03-03 12:43:26','2022-03-03 12:43:26'),(46713,136,'Alangudi-NID','612801',1,0,'2022-03-03 12:43:26','2022-03-03 12:43:26'),(46714,136,'Alankottai','614018',1,0,'2022-03-03 12:43:26','2022-03-03 12:43:26'),(46715,136,'Andankoil','612804',1,0,'2022-03-03 12:43:26','2022-03-03 12:43:26'),(46716,136,'Aravoor','614404',1,0,'2022-03-03 12:43:26','2022-03-03 12:43:26'),(46717,136,'Asesham','614016',1,0,'2022-03-03 12:43:26','2022-03-03 12:43:26'),(46718,136,'Avalivanallur','612802',1,0,'2022-03-03 12:43:26','2022-03-03 12:43:26'),(46719,136,'Avoor','612701',1,0,'2022-03-03 12:43:26','2022-03-03 12:43:26'),(46720,136,'Chandrasekarapuram','612804',1,0,'2022-03-03 12:43:26','2022-03-03 12:43:26'),(46721,136,'Chettichatram','614403',1,0,'2022-03-03 12:43:27','2022-03-03 12:43:27'),(46722,136,'Chittamalli-nid','614404',1,0,'2022-03-03 12:43:27','2022-03-03 12:43:27'),(46723,136,'Devangudi','612803',1,0,'2022-03-03 12:43:27','2022-03-03 12:43:27'),(46724,136,'Elavanur','614017',1,0,'2022-03-03 12:43:27','2022-03-03 12:43:27'),(46725,136,'Gopalasamudram','614001',1,0,'2022-03-03 12:43:27','2022-03-03 12:43:27'),(46726,136,'Govindakudi','612701',1,0,'2022-03-03 12:43:27','2022-03-03 12:43:27'),(46727,136,'Haridranathi','614001',1,0,'2022-03-03 12:43:27','2022-03-03 12:43:27'),(46728,136,'Haridwaramangalam','612802',1,0,'2022-03-03 12:43:27','2022-03-03 12:43:27'),(46729,136,'Harischandrapuram','610206',1,0,'2022-03-03 12:43:27','2022-03-03 12:43:27'),(46730,136,'Idangankottai Keelaiyur','614013',1,0,'2022-03-03 12:43:27','2022-03-03 12:43:27'),(46731,136,'Idangankottai Melaiyur','614013',1,0,'2022-03-03 12:43:27','2022-03-03 12:43:27'),(46732,136,'Irulneeki','614708',1,0,'2022-03-03 12:43:27','2022-03-03 12:43:27'),(46733,136,'Kalacheri','612803',1,0,'2022-03-03 12:43:27','2022-03-03 12:43:27'),(46734,136,'Kalanjimodu','612803',1,0,'2022-03-03 12:43:27','2022-03-03 12:43:27'),(46735,136,'Kalavaikarai','614001',1,0,'2022-03-03 12:43:27','2022-03-03 12:43:27'),(46736,136,'Kandithampettai','614018',1,0,'2022-03-03 12:43:27','2022-03-03 12:43:27'),(46737,136,'Karaikottai','614013',1,0,'2022-03-03 12:43:27','2022-03-03 12:43:27'),(46738,136,'Karunavur','614705',1,0,'2022-03-03 12:43:27','2022-03-03 12:43:27'),(46739,136,'Karunavur','614014',1,0,'2022-03-03 12:43:27','2022-03-03 12:43:27'),(46740,136,'Karuppakilar','614708',1,0,'2022-03-03 12:43:27','2022-03-03 12:43:27'),(46741,136,'Karuvakurichi','614018',1,0,'2022-03-03 12:43:27','2022-03-03 12:43:27'),(46742,136,'Kattakudi','614013',1,0,'2022-03-03 12:43:27','2022-03-03 12:43:27'),(46743,136,'Kezhuvathur','614705',1,0,'2022-03-03 12:43:27','2022-03-03 12:43:27'),(46744,136,'Kilapalam','614001',1,0,'2022-03-03 12:43:27','2022-03-03 12:43:27'),(46745,136,'Kilapanaiyur','614708',1,0,'2022-03-03 12:43:27','2022-03-03 12:43:27'),(46746,136,'Kilapattu','612803',1,0,'2022-03-03 12:43:27','2022-03-03 12:43:27'),(46747,136,'Koopachikottai','614015',1,0,'2022-03-03 12:43:28','2022-03-03 12:43:28'),(46748,136,'Koothanallur East','614101',1,0,'2022-03-03 12:43:28','2022-03-03 12:43:28'),(46749,136,'Koothanallur','614101',1,0,'2022-03-03 12:43:28','2022-03-03 12:43:28'),(46750,136,'Kothangudi','614101',1,0,'2022-03-03 12:43:28','2022-03-03 12:43:28'),(46751,136,'Kottugacheri','614101',1,0,'2022-03-03 12:43:28','2022-03-03 12:43:28'),(46752,136,'Kottur (Tiruvarur)','614708',1,0,'2022-03-03 12:43:28','2022-03-03 12:43:28'),(46753,136,'Kovilvenni Bazaar','614403',1,0,'2022-03-03 12:43:28','2022-03-03 12:43:28'),(46754,136,'Kovilvenni','614403',1,0,'2022-03-03 12:43:28','2022-03-03 12:43:28'),(46755,136,'Kudithangicheri','614102',1,0,'2022-03-03 12:43:28','2022-03-03 12:43:28'),(46756,136,'Kunniyur','614717',1,0,'2022-03-03 12:43:28','2022-03-03 12:43:28'),(46757,136,'Kuvalaiveli','612801',1,0,'2022-03-03 12:43:28','2022-03-03 12:43:28'),(46758,136,'Lakshmangudi','614102',1,0,'2022-03-03 12:43:28','2022-03-03 12:43:28'),(46759,136,'Mahadevapattinam','614018',1,0,'2022-03-03 12:43:28','2022-03-03 12:43:28'),(46760,136,'Manakkondu','614302',1,0,'2022-03-03 12:43:28','2022-03-03 12:43:28'),(46761,136,'Mangudi','614710',1,0,'2022-03-03 12:43:28','2022-03-03 12:43:28'),(46762,136,'Manickamangalam','614404',1,0,'2022-03-03 12:43:28','2022-03-03 12:43:28'),(46763,136,'Manjanavadi','614101',1,0,'2022-03-03 12:43:28','2022-03-03 12:43:28'),(46764,136,'Mannargudi Bazaar','614001',1,0,'2022-03-03 12:43:28','2022-03-03 12:43:28'),(46765,136,'Mannargudi H.O','614001',1,0,'2022-03-03 12:43:28','2022-03-03 12:43:28'),(46766,136,'Mannargudi South','614001',1,0,'2022-03-03 12:43:28','2022-03-03 12:43:28'),(46767,136,'Mannargudi West','614001',1,0,'2022-03-03 12:43:28','2022-03-03 12:43:28'),(46768,136,'Mannukkumundan','614705',1,0,'2022-03-03 12:43:28','2022-03-03 12:43:28'),(46769,136,'Marudavanam','614710',1,0,'2022-03-03 12:43:28','2022-03-03 12:43:28'),(46770,136,'Maruvathur','612802',1,0,'2022-03-03 12:43:28','2022-03-03 12:43:28'),(46771,136,'Mathur-NID','612801',1,0,'2022-03-03 12:43:28','2022-03-03 12:43:28'),(46772,136,'Mavattagudi','610206',1,0,'2022-03-03 12:43:28','2022-03-03 12:43:28'),(46773,136,'Melalavandaseri','612803',1,0,'2022-03-03 12:43:29','2022-03-03 12:43:29'),(46774,136,'Melamaravathy','612801',1,0,'2022-03-03 12:43:29','2022-03-03 12:43:29'),(46775,136,'Melanatham','614015',1,0,'2022-03-03 12:43:29','2022-03-03 12:43:29'),(46776,136,'Melanemmeli','614018',1,0,'2022-03-03 12:43:29','2022-03-03 12:43:29'),(46777,136,'Melapanaiyur','614717',1,0,'2022-03-03 12:43:29','2022-03-03 12:43:29'),(46778,136,'Melavasal','614014',1,0,'2022-03-03 12:43:29','2022-03-03 12:43:29'),(46779,136,'Melavidayal Ramnagar','612804',1,0,'2022-03-03 12:43:29','2022-03-03 12:43:29'),(46780,136,'Mukkul.Am Sathanur','614018',1,0,'2022-03-03 12:43:29','2022-03-03 12:43:29'),(46781,136,'Mullaivasal','614404',1,0,'2022-03-03 12:43:29','2022-03-03 12:43:29'),(46782,136,'Muniyur','612802',1,0,'2022-03-03 12:43:29','2022-03-03 12:43:29'),(46783,136,'Munnavalkottai','614403',1,0,'2022-03-03 12:43:29','2022-03-03 12:43:29'),(46784,136,'Muvanallur','614014',1,0,'2022-03-03 12:43:29','2022-03-03 12:43:29'),(46785,136,'Muvarkottai','614019',1,0,'2022-03-03 12:43:29','2022-03-03 12:43:29'),(46786,136,'Naduvakalappal','614710',1,0,'2022-03-03 12:43:29','2022-03-03 12:43:29'),(46787,136,'Nagai','614016',1,0,'2022-03-03 12:43:29','2022-03-03 12:43:29'),(46788,136,'Nahangudi','614101',1,0,'2022-03-03 12:43:29','2022-03-03 12:43:29'),(46789,136,'Nallikottai','614018',1,0,'2022-03-03 12:43:29','2022-03-03 12:43:29'),(46790,136,'Nallur','614208',1,0,'2022-03-03 12:43:29','2022-03-03 12:43:29'),(46791,136,'Nallur-TTP','614717',1,0,'2022-03-03 12:43:29','2022-03-03 12:43:29'),(46792,136,'Narasingamangalam','614404',1,0,'2022-03-03 12:43:29','2022-03-03 12:43:29'),(46793,136,'Narthangudi','614404',1,0,'2022-03-03 12:43:29','2022-03-03 12:43:29'),(46794,136,'Naruvelikalappal','614710',1,0,'2022-03-03 12:43:29','2022-03-03 12:43:29'),(46795,136,'Neduvakottai','614014',1,0,'2022-03-03 12:43:29','2022-03-03 12:43:29'),(46796,136,'Nemmeli-MNG','614016',1,0,'2022-03-03 12:43:29','2022-03-03 12:43:29'),(46797,136,'Nidamangalam Bazaar','614404',1,0,'2022-03-03 12:43:29','2022-03-03 12:43:29'),(46798,136,'Nidamangalam','614404',1,0,'2022-03-03 12:43:30','2022-03-03 12:43:30'),(46799,136,'Olimidi','614404',1,0,'2022-03-03 12:43:30','2022-03-03 12:43:30'),(46800,136,'Oothucadu','612701',1,0,'2022-03-03 12:43:30','2022-03-03 12:43:30'),(46801,136,'Padagacheri','612804',1,0,'2022-03-03 12:43:30','2022-03-03 12:43:30'),(46802,136,'Painganadu','614020',1,0,'2022-03-03 12:43:30','2022-03-03 12:43:30'),(46803,136,'Paingattur','614717',1,0,'2022-03-03 12:43:30','2022-03-03 12:43:30'),(46804,136,'Palaiyur','614705',1,0,'2022-03-03 12:43:30','2022-03-03 12:43:30'),(46805,136,'Palayakottai','614017',1,0,'2022-03-03 12:43:30','2022-03-03 12:43:30'),(46806,136,'Palayanur-ktn','614101',1,0,'2022-03-03 12:43:30','2022-03-03 12:43:30'),(46807,136,'Pamani-MNG','614014',1,0,'2022-03-03 12:43:30','2022-03-03 12:43:30'),(46808,136,'Paravakottai','614015',1,0,'2022-03-03 12:43:30','2022-03-03 12:43:30'),(46809,136,'Peraiyur','614018',1,0,'2022-03-03 12:43:30','2022-03-03 12:43:30'),(46810,136,'Perambur','614404',1,0,'2022-03-03 12:43:30','2022-03-03 12:43:30'),(46811,136,'Periyakuruvadi','610206',1,0,'2022-03-03 12:43:30','2022-03-03 12:43:30'),(46812,136,'Peruvazhandan','614705',1,0,'2022-03-03 12:43:30','2022-03-03 12:43:30'),(46813,136,'Podakudi','614103',1,0,'2022-03-03 12:43:30','2022-03-03 12:43:30'),(46814,136,'Pulithikudi','614708',1,0,'2022-03-03 12:43:30','2022-03-03 12:43:30'),(46815,136,'Pullamangalam','610206',1,0,'2022-03-03 12:43:30','2022-03-03 12:43:30'),(46816,136,'Pullavarayankudikadu','614013',1,0,'2022-03-03 12:43:30','2022-03-03 12:43:30'),(46817,136,'Puthagaram','614705',1,0,'2022-03-03 12:43:30','2022-03-03 12:43:30'),(46818,136,'Puvanur','612803',1,0,'2022-03-03 12:43:30','2022-03-03 12:43:30'),(46819,136,'Radhanarasimhapuram','614020',1,0,'2022-03-03 12:43:30','2022-03-03 12:43:30'),(46820,136,'Rajappayyanchavadi','612803',1,0,'2022-03-03 12:43:30','2022-03-03 12:43:30'),(46821,136,'Rayapuram','612803',1,0,'2022-03-03 12:43:30','2022-03-03 12:43:30'),(46822,136,'Renganathapuram','614717',1,0,'2022-03-03 12:43:31','2022-03-03 12:43:31'),(46823,136,'Sadayarkoil','614019',1,0,'2022-03-03 12:43:31','2022-03-03 12:43:31'),(46824,136,'Sathanur(KTN)','614101',1,0,'2022-03-03 12:43:31','2022-03-03 12:43:31'),(46825,136,'Sathanur-PSM','612801',1,0,'2022-03-03 12:43:31','2022-03-03 12:43:31'),(46826,136,'Savalakkaran','614014',1,0,'2022-03-03 12:43:31','2022-03-03 12:43:31'),(46827,136,'Segarai','614103',1,0,'2022-03-03 12:43:31','2022-03-03 12:43:31'),(46828,136,'Sendamangalam(TTP)','614708',1,0,'2022-03-03 12:43:31','2022-03-03 12:43:31'),(46829,136,'Sendangudi','610206',1,0,'2022-03-03 12:43:31','2022-03-03 12:43:31'),(46830,136,'Serangolam','614016',1,0,'2022-03-03 12:43:31','2022-03-03 12:43:31'),(46831,136,'Serumangalam','614014',1,0,'2022-03-03 12:43:31','2022-03-03 12:43:31'),(46832,136,'Sithamalli','614705',1,0,'2022-03-03 12:43:31','2022-03-03 12:43:31'),(46833,136,'Sithanvalur','612804',1,0,'2022-03-03 12:43:31','2022-03-03 12:43:31'),(46834,136,'Sokkanavur','614017',1,0,'2022-03-03 12:43:31','2022-03-03 12:43:31'),(46835,136,'Solapandi','614016',1,0,'2022-03-03 12:43:31','2022-03-03 12:43:31'),(46836,136,'Sundarakottai','614016',1,0,'2022-03-03 12:43:31','2022-03-03 12:43:31'),(46837,136,'Talayamangalam(MNG)','614016',1,0,'2022-03-03 12:43:31','2022-03-03 12:43:31'),(46838,136,'Tanneerkunnam','614101',1,0,'2022-03-03 12:43:31','2022-03-03 12:43:31'),(46839,136,'Tenparai','614020',1,0,'2022-03-03 12:43:31','2022-03-03 12:43:31'),(46840,136,'Terkunanallur','614710',1,0,'2022-03-03 12:43:31','2022-03-03 12:43:31'),(46841,136,'Terkupattam','612802',1,0,'2022-03-03 12:43:31','2022-03-03 12:43:31'),(46842,136,'Thalikottai','614018',1,0,'2022-03-03 12:43:31','2022-03-03 12:43:31'),(46843,136,'Thiruvanduthurai','614717',1,0,'2022-03-03 12:43:31','2022-03-03 12:43:31'),(46844,136,'Tholuvur','612804',1,0,'2022-03-03 12:43:31','2022-03-03 12:43:31'),(46845,136,'Tirukalar','614710',1,0,'2022-03-03 12:43:31','2022-03-03 12:43:31'),(46846,136,'Tirumakottai','614017',1,0,'2022-03-03 12:43:31','2022-03-03 12:43:31'),(46847,136,'Tirupalakudi','614018',1,0,'2022-03-03 12:43:31','2022-03-03 12:43:31'),(46848,136,'Ullikottai','614018',1,0,'2022-03-03 12:43:32','2022-03-03 12:43:32'),(46849,136,'Vadakarai Alathur','614302',1,0,'2022-03-03 12:43:32','2022-03-03 12:43:32'),(46850,136,'Vadakovanur','614102',1,0,'2022-03-03 12:43:32','2022-03-03 12:43:32'),(46851,136,'Vadapathimangalam','610206',1,0,'2022-03-03 12:43:32','2022-03-03 12:43:32'),(46852,136,'Vaduvur','614019',1,0,'2022-03-03 12:43:32','2022-03-03 12:43:32'),(46853,136,'Vaduvur Thenpathi','614019',1,0,'2022-03-03 12:43:32','2022-03-03 12:43:32'),(46854,136,'Vaduvur Vadapathi','614019',1,0,'2022-03-03 12:43:32','2022-03-03 12:43:32'),(46855,136,'Valangaman','612804',1,0,'2022-03-03 12:43:32','2022-03-03 12:43:32'),(46856,136,'Vallur','614017',1,0,'2022-03-03 12:43:32','2022-03-03 12:43:32'),(46857,136,'Vanakkara Street','614001',1,0,'2022-03-03 12:43:32','2022-03-03 12:43:32'),(46858,136,'Vattar','614717',1,0,'2022-03-03 12:43:32','2022-03-03 12:43:32'),(46859,136,'Vilathur','612802',1,0,'2022-03-03 12:43:32','2022-03-03 12:43:32'),(46860,137,'Achankulam','628718',1,0,'2022-03-03 12:43:32','2022-03-03 12:43:32'),(46861,137,'Adanur','628712',1,0,'2022-03-03 12:43:32','2022-03-03 12:43:32'),(46862,137,'Ahilandapuram','628714',1,0,'2022-03-03 12:43:32','2022-03-03 12:43:32'),(46863,137,'Alagappapuram','628721',1,0,'2022-03-03 12:43:32','2022-03-03 12:43:32'),(46864,137,'Alampatti','628503',1,0,'2022-03-03 12:43:32','2022-03-03 12:43:32'),(46865,137,'Ariyanayagipuram','628901',1,0,'2022-03-03 12:43:32','2022-03-03 12:43:32'),(46866,137,'Arungulam','628712',1,0,'2022-03-03 12:43:32','2022-03-03 12:43:32'),(46867,137,'Athikulam','628952',1,0,'2022-03-03 12:43:32','2022-03-03 12:43:32'),(46868,137,'Attankarai','628904',1,0,'2022-03-03 12:43:32','2022-03-03 12:43:32'),(46869,137,'Avalnatham','628502',1,0,'2022-03-03 12:43:32','2022-03-03 12:43:32'),(46870,137,'Ayyanaruthu','628952',1,0,'2022-03-03 12:43:32','2022-03-03 12:43:32'),(46871,137,'Bommiahpuram','628907',1,0,'2022-03-03 12:43:32','2022-03-03 12:43:32'),(46872,137,'Boothalapuram','628905',1,0,'2022-03-03 12:43:32','2022-03-03 12:43:32'),(46873,137,'Chettikurichi','628552',1,0,'2022-03-03 12:43:32','2022-03-03 12:43:32'),(46874,137,'Chinnamalaikundru','628902',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46875,137,'Duraisamypuram','628904',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46876,137,'East Pandavarmangalam','628502',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46877,137,'Eppodumvendran','628712',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46878,137,'Ettaiyapuram','628902',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46879,137,'Guruvarpatti','628904',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46880,137,'Idaiseval','628716',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46881,137,'Ilambuvanam','628902',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46882,137,'Ilavelangal','628714',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46883,137,'Illupaiyurani','628502',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46884,137,'Irachi','628720',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46885,137,'K.Duraisamypuram','628712',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46886,137,'K.R.Nagar','628503',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46887,137,'K.Sivagnanapuram','628716',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46888,137,'Kadalai','628902',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46889,137,'Kadalkudi','628907',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46890,137,'Kadambur (Tuticorin)','628714',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46891,137,'Kalangaraipatti','628721',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46892,137,'Kalugachalapuram','628902',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46893,137,'Kalugumalai','628552',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46894,137,'Kamanaickanpatti','628720',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46895,137,'Kandasamypuram','628905',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46896,137,'Kappulingampatti','628714',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46897,137,'Karadikulam','628552',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46898,137,'Karisalkulam','628907',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46899,137,'Kattalankulam','628721',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46900,137,'Kayathar','628952',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46901,137,'Kilaarunachalapuram','628905',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46902,137,'Kilairal','628908',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46903,137,'Kilakarandai','628904',1,0,'2022-03-03 12:43:33','2022-03-03 12:43:33'),(46904,137,'Kilavaippar','628903',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46905,137,'Kilavilathikulam','628907',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46906,137,'Koppampatti','628720',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46907,137,'Kottali','628714',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46908,137,'Kovilpatti H.O','628501',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46909,137,'Kovilpatti Indl.Estate','628502',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46910,137,'Kovilpatti North','628502',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46911,137,'Kovilpatti R.S','628502',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46912,137,'Kovilpatti Town','628501',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46913,137,'Kulathur (TVL)','628903',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46914,137,'Kuppanapuram','628714',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46915,137,'Kurukkuchalai','628722',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46916,137,'Kurumalai','628714',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46917,137,'L.Venkateswarapuram','628905',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46918,137,'Lakshmipuram (Tuticorin)','628502',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46919,137,'Lingampatti','628502',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46920,137,'Maniyakaranpatti','628905',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46921,137,'Manthithope','628502',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46922,137,'Meenakshipuram','628718',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46923,137,'Meenakshipuram','628907',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46924,137,'Melaseithalai','628722',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46925,137,'Melmandai','628901',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46926,137,'Mettilpatti','628905',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46927,137,'Moortheeswaram','628952',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46928,137,'Mudukkalankulam','628720',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46929,137,'Muthulapuram','628902',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46930,137,'Nachiyarpuram','628721',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46931,137,'Nagalapuram (Tuticorin)','628904',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46932,137,'Nagampatti','628718',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46933,137,'Naickerpatti','628552',1,0,'2022-03-03 12:43:34','2022-03-03 12:43:34'),(46934,137,'Nalatinputhur','628716',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46935,137,'Nambipuram','628902',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46936,137,'Padanthapuli 2','628503',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46937,137,'Padanthapuli','628902',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46938,137,'Pannikulam','628952',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46939,137,'Parivillikottai','628714',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46940,137,'Pasuvandanai','628718',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46941,137,'Perilovanpatti','628902',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46942,137,'Periyasamipuram','628906',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46943,137,'Pillaiyarnatham','628721',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46944,137,'Pillaiyarnatham','628902',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46945,137,'Pudur','628905',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46946,137,'Pugavarnatham','628908',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46947,137,'Punniahpuram','627855',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46948,137,'Ramachandrapuram','628907',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46949,137,'Sakkammalpuram','628712',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46950,137,'Sambakulam','628552',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46951,137,'Sankaralingapuram','628904',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46952,137,'Semmapudur','628720',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46953,137,'Sennamareddipatti','628905',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46954,137,'Sholpuram','628908',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46955,137,'Sillankulam','628718',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46956,137,'Sindalakarai','628902',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46957,137,'Sippikulam','628903',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46958,137,'Sivagnanapuram','628712',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46959,137,'Sivalarpatti','628905',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46960,137,'Surangudi','628901',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46961,137,'Tattaneri','628901',1,0,'2022-03-03 12:43:35','2022-03-03 12:43:35'),(46962,137,'Tennampatti','628714',1,0,'2022-03-03 12:43:36','2022-03-03 12:43:36'),(46963,137,'Thalaikattupuram','628902',1,0,'2022-03-03 12:43:36','2022-03-03 12:43:36'),(46964,137,'Therkkuilandaikulam','628952',1,0,'2022-03-03 12:43:36','2022-03-03 12:43:36'),(46965,137,'Turaiyur','628720',1,0,'2022-03-03 12:43:36','2022-03-03 12:43:36'),(46966,137,'Uthupatti','628502',1,0,'2022-03-03 12:43:36','2022-03-03 12:43:36'),(46967,137,'V.Vedapatti','628907',1,0,'2022-03-03 12:43:36','2022-03-03 12:43:36'),(46968,137,'Vadakkuvandanam','628714',1,0,'2022-03-03 12:43:36','2022-03-03 12:43:36'),(46969,137,'Vadamalaisamudram','628907',1,0,'2022-03-03 12:43:36','2022-03-03 12:43:36'),(46970,137,'Vaippar','628903',1,0,'2022-03-03 12:43:36','2022-03-03 12:43:36'),(46971,137,'Vanaramutti','628721',1,0,'2022-03-03 12:43:36','2022-03-03 12:43:36'),(46972,137,'Vedanatham','628722',1,0,'2022-03-03 12:43:36','2022-03-03 12:43:36'),(46973,137,'Vedapatti','628904',1,0,'2022-03-03 12:43:36','2022-03-03 12:43:36'),(46974,137,'Velayuthapuram','628552',1,0,'2022-03-03 12:43:36','2022-03-03 12:43:36'),(46975,137,'Vellalankottai','628952',1,0,'2022-03-03 12:43:36','2022-03-03 12:43:36'),(46976,137,'Vellanaikottai','627758',1,0,'2022-03-03 12:43:36','2022-03-03 12:43:36'),(46977,137,'Vembar','628906',1,0,'2022-03-03 12:43:36','2022-03-03 12:43:36'),(46978,137,'Vembur','628905',1,0,'2022-03-03 12:43:36','2022-03-03 12:43:36'),(46979,137,'Venkatesawarapuram','628552',1,0,'2022-03-03 12:43:36','2022-03-03 12:43:36'),(46980,137,'Veppalodai','628903',1,0,'2022-03-03 12:43:36','2022-03-03 12:43:36'),(46981,137,'Vijayapuri','628502',1,0,'2022-03-03 12:43:36','2022-03-03 12:43:36'),(46982,137,'Vilathikulam','628907',1,0,'2022-03-03 12:43:36','2022-03-03 12:43:36'),(46983,137,'Villiseri','628716',1,0,'2022-03-03 12:43:36','2022-03-03 12:43:36'),(46984,137,'Vowalthothi','628904',1,0,'2022-03-03 12:43:36','2022-03-03 12:43:36'),(46985,137,'Zamindevarkulam','628721',1,0,'2022-03-03 12:43:36','2022-03-03 12:43:36'),(46986,137,'Adaikalapuram','628217',1,0,'2022-03-03 12:43:36','2022-03-03 12:43:36'),(46987,137,'Agaram','628152',1,0,'2022-03-03 12:43:36','2022-03-03 12:43:36'),(46988,137,'Akilandapuram','628401',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(46989,137,'Akkanaickenpatti','628303',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(46990,137,'Alagappapuram','628703',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(46991,137,'Alagesapuram','628002',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(46992,137,'Alankinar','628704',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(46993,137,'Alanthalai','628206',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(46994,137,'Alwarkarkulam','628619',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(46995,137,'Alwarthope West','628612',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(46996,137,'Alwartirunagari','628612',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(46997,137,'Alwartirunagari West','628612',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(46998,137,'Amalinagar','628215',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(46999,137,'Ambalaseri','628701',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(47000,137,'Ammanpuram','628201',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(47001,137,'Anaiyur','628210',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(47002,137,'Anandapuram (Tuticorin)','628701',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(47003,137,'Anavaradanallur','628809',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(47004,137,'Anbinnagaram','628702',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(47005,137,'Aniaparanallur','628851',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(47006,137,'Appankoil','628612',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(47007,137,'Arampannai','628619',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(47008,137,'Ariyanayagipuram','628621',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(47009,137,'Arockiapuram','628002',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(47010,137,'Arumugamangalam','628802',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(47011,137,'Arumuganeri','628202',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(47012,137,'Asirvathapuram','628613',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(47013,137,'Athalikulam','628621',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(47014,137,'Athichanallur','628621',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(47015,137,'Athimarapatti','628005',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(47016,137,'Autoor','628151',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(47017,137,'C.G.S. Colony','628003',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(47018,137,'Campbellabad','628614',1,0,'2022-03-03 12:43:37','2022-03-03 12:43:37'),(47019,137,'Cherakulam','628622',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47020,137,'Chettikulam','628701',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47021,137,'Chidambaranagar','628008',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47022,137,'Chinnamadankudiyiruppu','628617',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47023,137,'Chockalingapuram','628104',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47024,137,'Cruz Fernandespuram','628001',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47025,137,'Dalavaipuram','628301',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47026,137,'Duraisamypuram','628105',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47027,137,'Ellanaickenpatti','628851',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47028,137,'Eluvaraimukki','628617',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47029,137,'Eral','628801',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47030,137,'Heavy Water Project Colony','628007',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47031,137,'Idaichivilai','628656',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47032,137,'Idaiyanvilai','628211',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47033,137,'Idaiyarkadu','628802',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47034,137,'Ilanganathapuram','628210',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47035,137,'Iruvappapuram','628251',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47036,137,'Jambulingapuram','628402',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47037,137,'Jerusalempatnam','628218',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47038,137,'Kadakulam','628656',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47039,137,'Kadashapuram','628702',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47040,137,'Kadayanodaiai','628614',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47041,137,'Kailasapuram (Tuticorin)','628301',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47042,137,'Kalankudiyiruppu','628203',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47043,137,'Kalinguvilai','628704',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47044,137,'Kaliyavoor','628252',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47045,137,'Kallamozhi','628206',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47046,137,'Kalvilai','628210',1,0,'2022-03-03 12:43:38','2022-03-03 12:43:38'),(47047,137,'Kalvoy','628622',1,0,'2022-03-03 12:43:39','2022-03-03 12:43:39'),(47048,137,'Kanam','628201',1,0,'2022-03-03 12:43:39','2022-03-03 12:43:39'),(47049,137,'Kandasamypuram','628202',1,0,'2022-03-03 12:43:39','2022-03-03 12:43:39'),(47050,137,'Kandasamypuram','628301',1,0,'2022-03-03 12:43:39','2022-03-03 12:43:39'),(47051,137,'Karungulam','628615',1,0,'2022-03-03 12:43:39','2022-03-03 12:43:39'),(47052,137,'Karunkadal','628613',1,0,'2022-03-03 12:43:39','2022-03-03 12:43:39'),(47053,137,'Karuvelampadu','628701',1,0,'2022-03-03 12:43:39','2022-03-03 12:43:39'),(47054,137,'Katchanavilai','628618',1,0,'2022-03-03 12:43:39','2022-03-03 12:43:39'),(47055,137,'Katcheri Dhalavaipuram','628401',1,0,'2022-03-03 12:43:39','2022-03-03 12:43:39'),(47056,137,'Kattalangulam','628251',1,0,'2022-03-03 12:43:39','2022-03-03 12:43:39'),(47057,137,'Kattarimangalam','628613',1,0,'2022-03-03 12:43:39','2022-03-03 12:43:39'),(47058,137,'Kayalpatnam Bazaar','628204',1,0,'2022-03-03 12:43:39','2022-03-03 12:43:39'),(47059,137,'Kayalpatnam','628204',1,0,'2022-03-03 12:43:39','2022-03-03 12:43:39'),(47060,137,'Kayamozhi','628205',1,0,'2022-03-03 12:43:39','2022-03-03 12:43:39'),(47061,137,'Keelashanmugapuram','628002',1,0,'2022-03-03 12:43:39','2022-03-03 12:43:39'),(47062,137,'Keelatattaparai','628304',1,0,'2022-03-03 12:43:39','2022-03-03 12:43:39'),(47063,137,'Keeranur','628151',1,0,'2022-03-03 12:43:39','2022-03-03 12:43:39'),(47064,137,'Kilamudiman','628401',1,0,'2022-03-03 12:43:39','2022-03-03 12:43:39'),(47065,137,'Kilaramasamypuram','628210',1,0,'2022-03-03 12:43:39','2022-03-03 12:43:39'),(47066,137,'Kollampirambu-dalavaipuram','628104',1,0,'2022-03-03 12:43:39','2022-03-03 12:43:39'),(47067,137,'Kollankinar','628302',1,0,'2022-03-03 12:43:39','2022-03-03 12:43:39'),(47068,137,'Kolunthuthattu','628653',1,0,'2022-03-03 12:43:39','2022-03-03 12:43:39'),(47069,137,'Kombankulam','628704',1,0,'2022-03-03 12:43:39','2022-03-03 12:43:39'),(47070,137,'Kommadikottai','628653',1,0,'2022-03-03 12:43:39','2022-03-03 12:43:39'),(47071,137,'Kongarayankurichi','628619',1,0,'2022-03-03 12:43:39','2022-03-03 12:43:39'),(47072,137,'Kootampuli','628103',1,0,'2022-03-03 12:43:39','2022-03-03 12:43:39'),(47073,137,'Kootankadu','628203',1,0,'2022-03-03 12:43:40','2022-03-03 12:43:40'),(47074,137,'Korampollam','628101',1,0,'2022-03-03 12:43:40','2022-03-03 12:43:40'),(47075,137,'Korkai','628801',1,0,'2022-03-03 12:43:40','2022-03-03 12:43:40'),(47076,137,'Kothalarivilai','628251',1,0,'2022-03-03 12:43:40','2022-03-03 12:43:40'),(47077,137,'Kottarakurichi','628802',1,0,'2022-03-03 12:43:40','2022-03-03 12:43:40'),(47078,137,'Kovankadu','628152',1,0,'2022-03-03 12:43:40','2022-03-03 12:43:40'),(47079,137,'Kulasekaranallur','628401',1,0,'2022-03-03 12:43:40','2022-03-03 12:43:40'),(47080,137,'Kulasekarapatnam','628206',1,0,'2022-03-03 12:43:40','2022-03-03 12:43:40'),(47081,137,'Kulasekarapatnam South','628206',1,0,'2022-03-03 12:43:40','2022-03-03 12:43:40'),(47082,137,'Kulayankarisal','628103',1,0,'2022-03-03 12:43:40','2022-03-03 12:43:40'),(47083,137,'Kurangani','628623',1,0,'2022-03-03 12:43:40','2022-03-03 12:43:40'),(47084,137,'Kurippankulam','628617',1,0,'2022-03-03 12:43:40','2022-03-03 12:43:40'),(47085,137,'Kurukattur','628623',1,0,'2022-03-03 12:43:40','2022-03-03 12:43:40'),(47086,137,'Kurumbur','628207',1,0,'2022-03-03 12:43:40','2022-03-03 12:43:40'),(47087,137,'Kuthiraimozhi','628213',1,0,'2022-03-03 12:43:40','2022-03-03 12:43:40'),(47088,137,'Lakshmimanagaram','628202',1,0,'2022-03-03 12:43:40','2022-03-03 12:43:40'),(47089,137,'Lakshmipuram','628210',1,0,'2022-03-03 12:43:40','2022-03-03 12:43:40'),(47090,137,'Levingipuram','628008',1,0,'2022-03-03 12:43:40','2022-03-03 12:43:40'),(47091,137,'Madathur','628008',1,0,'2022-03-03 12:43:40','2022-03-03 12:43:40'),(47092,137,'Madavankurichi','628206',1,0,'2022-03-03 12:43:40','2022-03-03 12:43:40'),(47093,137,'Manaduthandapathu','628208',1,0,'2022-03-03 12:43:40','2022-03-03 12:43:40'),(47094,137,'Manakad','628205',1,0,'2022-03-03 12:43:40','2022-03-03 12:43:40'),(47095,137,'Manakarai','628619',1,0,'2022-03-03 12:43:40','2022-03-03 12:43:40'),(47096,137,'Manapad','628209',1,0,'2022-03-03 12:43:40','2022-03-03 12:43:40'),(47097,137,'Mangalagiri','628103',1,0,'2022-03-03 12:43:41','2022-03-03 12:43:41'),(47098,137,'Maniyac R.S.','628302',1,0,'2022-03-03 12:43:41','2022-03-03 12:43:41'),(47099,137,'Mannanvilai','628218',1,0,'2022-03-03 12:43:41','2022-03-03 12:43:41'),(47100,137,'Mappillaiyurani','628002',1,0,'2022-03-03 12:43:41','2022-03-03 12:43:41'),(47101,137,'Maramangalam','628802',1,0,'2022-03-03 12:43:41','2022-03-03 12:43:41'),(47102,137,'Maravanmadam','628101',1,0,'2022-03-03 12:43:41','2022-03-03 12:43:41'),(47103,137,'Marudanvalvoo','628303',1,0,'2022-03-03 12:43:41','2022-03-03 12:43:41'),(47104,137,'Megnanapuram','628210',1,0,'2022-03-03 12:43:41','2022-03-03 12:43:41'),(47105,137,'Mela Autoor','628151',1,0,'2022-03-03 12:43:41','2022-03-03 12:43:41'),(47106,137,'Mela Tiruchendur','628205',1,0,'2022-03-03 12:43:41','2022-03-03 12:43:41'),(47107,137,'Melaarasadi','628002',1,0,'2022-03-03 12:43:41','2022-03-03 12:43:41'),(47108,137,'Melakootudankadu','628103',1,0,'2022-03-03 12:43:41','2022-03-03 12:43:41'),(47109,137,'Melaputhukudi','628201',1,0,'2022-03-03 12:43:41','2022-03-03 12:43:41'),(47110,137,'Melatattaparai','628304',1,0,'2022-03-03 12:43:41','2022-03-03 12:43:41'),(47111,137,'Melur Tuticorin','628002',1,0,'2022-03-03 12:43:41','2022-03-03 12:43:41'),(47112,137,'Meyoor','628203',1,0,'2022-03-03 12:43:41','2022-03-03 12:43:41'),(47113,137,'Milavittan R S','628002',1,0,'2022-03-03 12:43:41','2022-03-03 12:43:41'),(47114,137,'Millerpuram','628008',1,0,'2022-03-03 12:43:41','2022-03-03 12:43:41'),(47115,137,'Mirankulam','628613',1,0,'2022-03-03 12:43:41','2022-03-03 12:43:41'),(47116,137,'Moolakarai','628201',1,0,'2022-03-03 12:43:41','2022-03-03 12:43:41'),(47117,137,'Mudalur','628702',1,0,'2022-03-03 12:43:41','2022-03-03 12:43:41'),(47118,137,'Mudittanendal Pudur','628102',1,0,'2022-03-03 12:43:41','2022-03-03 12:43:41'),(47119,137,'Mudittanendal','628102',1,0,'2022-03-03 12:43:41','2022-03-03 12:43:41'),(47120,137,'Mukkani','628151',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47121,137,'Mukuperi','628616',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47122,137,'Mullaakadu','628005',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47123,137,'Muramban','628302',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47124,137,'Murappanad','628252',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47125,137,'Muthiahpuram','628005',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47126,137,'Nadunallumoolaikinar','628213',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47127,137,'Naduvakurichi','628251',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47128,137,'Naduvakurichi','628653',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47129,137,'Nainapuram','628402',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47130,137,'Nallur','628207',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47131,137,'Nallur-kommadikottai','628653',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47132,137,'Nalumavadi','628211',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47133,137,'Naraikinar','628303',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47134,137,'Nathankinar','628205',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47135,137,'Nattathi','628751',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47136,137,'Nazareth R S','628616',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47137,137,'Nazareth','628617',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47138,137,'Nedungulam','628704',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47139,137,'Neivilai','628618',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47140,137,'New Colony (Tuticorin)','628003',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47141,137,'Omarikadu','628151',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47142,137,'Otapidaram','628401',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47143,137,'Ottanatham','628302',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47144,137,'Oyyangudi','628616',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47145,137,'Padmanabamangalam','628619',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47146,137,'Padukkapathu','628703',1,0,'2022-03-03 12:43:42','2022-03-03 12:43:42'),(47147,137,'Palaniappapuram','628613',1,0,'2022-03-03 12:43:43','2022-03-03 12:43:43'),(47148,137,'Palankulam','628701',1,0,'2022-03-03 12:43:43','2022-03-03 12:43:43'),(47149,137,'Pallakurichi','628703',1,0,'2022-03-03 12:43:43','2022-03-03 12:43:43'),(47150,137,'Pallipathu','628218',1,0,'2022-03-03 12:43:43','2022-03-03 12:43:43'),(47151,137,'Pandarapuram','628704',1,0,'2022-03-03 12:43:43','2022-03-03 12:43:43'),(47152,137,'Pandaravilai','628751',1,0,'2022-03-03 12:43:43','2022-03-03 12:43:43'),(47153,137,'Panickanadarkudiyiruppu','628212',1,0,'2022-03-03 12:43:43','2022-03-03 12:43:43'),(47154,137,'Pannaivilai','628751',1,0,'2022-03-03 12:43:43','2022-03-03 12:43:43'),(47155,137,'Pannamparai','628704',1,0,'2022-03-03 12:43:43','2022-03-03 12:43:43'),(47156,137,'Paraikuttam','628301',1,0,'2022-03-03 12:43:43','2022-03-03 12:43:43'),(47157,137,'Parakkiramapandi','628620',1,0,'2022-03-03 12:43:43','2022-03-03 12:43:43'),(47158,137,'Paramankurichi','628213',1,0,'2022-03-03 12:43:43','2022-03-03 12:43:43'),(47159,137,'Patemanagaram','628620',1,0,'2022-03-03 12:43:43','2022-03-03 12:43:43'),(47160,137,'Pattakarai','628618',1,0,'2022-03-03 12:43:43','2022-03-03 12:43:43'),(47161,137,'Pazhaiyalkayal','628152',1,0,'2022-03-03 12:43:43','2022-03-03 12:43:43'),(47162,137,'Periyanayagipuram','628101',1,0,'2022-03-03 12:43:43','2022-03-03 12:43:43'),(47163,137,'Periyathalai','628703',1,0,'2022-03-03 12:43:43','2022-03-03 12:43:43'),(47164,137,'Perungulam (Tuticorin)','628752',1,0,'2022-03-03 12:43:43','2022-03-03 12:43:43'),(47165,137,'Perur','628620',1,0,'2022-03-03 12:43:43','2022-03-03 12:43:43'),(47166,137,'Peyanvilai','628202',1,0,'2022-03-03 12:43:43','2022-03-03 12:43:43'),(47167,137,'Pillaiyanmanai','628617',1,0,'2022-03-03 12:43:43','2022-03-03 12:43:43'),(47168,137,'Pitchivilai','628219',1,0,'2022-03-03 12:43:43','2022-03-03 12:43:43'),(47169,137,'Pitchivilai','628703',1,0,'2022-03-03 12:43:43','2022-03-03 12:43:43'),(47170,137,'Polayarpuram','628653',1,0,'2022-03-03 12:43:43','2022-03-03 12:43:43'),(47171,137,'Polenaickenpettai','628002',1,0,'2022-03-03 12:43:44','2022-03-03 12:43:44'),(47172,137,'Pothakalanvilai','628702',1,0,'2022-03-03 12:43:44','2022-03-03 12:43:44'),(47173,137,'Pottalurani','628851',1,0,'2022-03-03 12:43:44','2022-03-03 12:43:44'),(47174,137,'Puchikadu','628653',1,0,'2022-03-03 12:43:44','2022-03-03 12:43:44'),(47175,137,'Pudiyamputhur','628402',1,0,'2022-03-03 12:43:44','2022-03-03 12:43:44'),(47176,137,'Pudukottai','628103',1,0,'2022-03-03 12:43:44','2022-03-03 12:43:44'),(47177,137,'Pudukulam','628704',1,0,'2022-03-03 12:43:44','2022-03-03 12:43:44'),(47178,137,'Pudumanai','628203',1,0,'2022-03-03 12:43:44','2022-03-03 12:43:44'),(47179,137,'Pudupatcheri','628402',1,0,'2022-03-03 12:43:44','2022-03-03 12:43:44'),(47180,137,'Pudupatti','628851',1,0,'2022-03-03 12:43:44','2022-03-03 12:43:44'),(47181,137,'Pudurpandiapuram','628002',1,0,'2022-03-03 12:43:44','2022-03-03 12:43:44'),(47182,137,'Puliankulam','628613',1,0,'2022-03-03 12:43:44','2022-03-03 12:43:44'),(47183,137,'Puliyampatti','628303',1,0,'2022-03-03 12:43:44','2022-03-03 12:43:44'),(47184,137,'Punnakayal','628151',1,0,'2022-03-03 12:43:44','2022-03-03 12:43:44'),(47185,137,'Puraiyur','628207',1,0,'2022-03-03 12:43:44','2022-03-03 12:43:44'),(47186,137,'Puthantharuvai','628656',1,0,'2022-03-03 12:43:44','2022-03-03 12:43:44'),(47187,137,'Puthukudi 3rd Mile','628008',1,0,'2022-03-03 12:43:44','2022-03-03 12:43:44'),(47188,137,'Puthukudi','628621',1,0,'2022-03-03 12:43:44','2022-03-03 12:43:44'),(47189,137,'Puvani','628303',1,0,'2022-03-03 12:43:44','2022-03-03 12:43:44'),(47190,137,'Rajamaniapuram','628202',1,0,'2022-03-03 12:43:44','2022-03-03 12:43:44'),(47191,137,'Ramanujampudur','628622',1,0,'2022-03-03 12:43:44','2022-03-03 12:43:44'),(47192,137,'Sahupuram','628229',1,0,'2022-03-03 12:43:44','2022-03-03 12:43:44'),(47193,137,'Sankarankudiyiruppu','628704',1,0,'2022-03-03 12:43:44','2022-03-03 12:43:44'),(47194,137,'Sankaraperi','628002',1,0,'2022-03-03 12:43:44','2022-03-03 12:43:44'),(47195,137,'Satankulam','628704',1,0,'2022-03-03 12:43:44','2022-03-03 12:43:44'),(47196,137,'Savalaperi','628303',1,0,'2022-03-03 12:43:44','2022-03-03 12:43:44'),(47197,137,'Savariarpuram','628613',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47198,137,'Savarimangalam','628301',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47199,137,'Sawyerpuram','628251',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47200,137,'Sebathiahpuram','628251',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47201,137,'Seerkatchi','628208',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47202,137,'Seerudaiyarpuram','628213',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47203,137,'Sekkarakudi','628104',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47204,137,'Semmarikulam','628210',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47205,137,'Sendamangalam','628151',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47206,137,'Servaikaranmadam','628103',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47207,137,'Sethukuvaithan','628207',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47208,137,'Settiapathu','628203',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47209,137,'Seydunganallur','628809',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47210,137,'Siluvaipatti','628002',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47211,137,'Singathakurichi','628851',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47212,137,'Sirunadarkudiyiruppu','628206',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47213,137,'Siruthondanallur','628802',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47214,137,'Sivagalai','628753',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47215,137,'Sokkankudiyiruppu','628653',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47216,137,'Solaikudiyiruppu','628210',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47217,137,'Sonaganvilai','628201',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47218,137,'Srimoolakarai','628620',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47219,137,'Sriparangusanallur','628621',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47220,137,'Srivaikuntam H.O','628601',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47221,137,'Subbarayapuram','628702',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47222,137,'Subramaniapuram','628702',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47223,137,'Subramaniapuram','628205',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47224,137,'Subramaniapuram','628251',1,0,'2022-03-03 12:43:45','2022-03-03 12:43:45'),(47225,137,'Suganthalai','628207',1,0,'2022-03-03 12:43:46','2022-03-03 12:43:46'),(47226,137,'Sundankottai','628703',1,0,'2022-03-03 12:43:46','2022-03-03 12:43:46'),(47227,137,'Swaminatham','628402',1,0,'2022-03-03 12:43:46','2022-03-03 12:43:46'),(47228,137,'Taruvaikulam','628105',1,0,'2022-03-03 12:43:46','2022-03-03 12:43:46'),(47229,137,'Tattaparai','628304',1,0,'2022-03-03 12:43:46','2022-03-03 12:43:46'),(47230,137,'Tattarmadam','628653',1,0,'2022-03-03 12:43:46','2022-03-03 12:43:46'),(47231,137,'Terikudiyiruppu','628205',1,0,'2022-03-03 12:43:46','2022-03-03 12:43:46'),(47232,137,'Thailapuram','628617',1,0,'2022-03-03 12:43:46','2022-03-03 12:43:46'),(47233,137,'Thandavankadu','628206',1,0,'2022-03-03 12:43:46','2022-03-03 12:43:46'),(47234,137,'Thatchanvilai','628656',1,0,'2022-03-03 12:43:46','2022-03-03 12:43:46'),(47235,137,'Thathankulam','628622',1,0,'2022-03-03 12:43:46','2022-03-03 12:43:46'),(47236,137,'Thenthiruperai','628623',1,0,'2022-03-03 12:43:46','2022-03-03 12:43:46'),(47237,137,'Therikudiyiruppu','628205',1,0,'2022-03-03 12:43:46','2022-03-03 12:43:46'),(47238,137,'Theripanai','628701',1,0,'2022-03-03 12:43:46','2022-03-03 12:43:46'),(47239,137,'Therkankulam','628613',1,0,'2022-03-03 12:43:46','2022-03-03 12:43:46'),(47240,137,'Therku Autoor','628151',1,0,'2022-03-03 12:43:46','2022-03-03 12:43:46'),(47241,137,'Therkusilukkanpatti','628103',1,0,'2022-03-03 12:43:46','2022-03-03 12:43:46'),(47242,137,'Therkuvirapandiapuram','628002',1,0,'2022-03-03 12:43:46','2022-03-03 12:43:46'),(47243,137,'Thermal Nagagr','628006',1,0,'2022-03-03 12:43:46','2022-03-03 12:43:46'),(47244,137,'Thimmarajapuraam','628102',1,0,'2022-03-03 12:43:46','2022-03-03 12:43:46'),(47245,137,'Thoppuvalam','628702',1,0,'2022-03-03 12:43:46','2022-03-03 12:43:46'),(47246,137,'Tiruchendur Devasthanam','628215',1,0,'2022-03-03 12:43:46','2022-03-03 12:43:46'),(47247,137,'Tiruchendur H.O','628215',1,0,'2022-03-03 12:43:46','2022-03-03 12:43:46'),(47248,137,'Tirukkalur','628612',1,0,'2022-03-03 12:43:46','2022-03-03 12:43:46'),(47249,137,'Tirupuliyangudi','628621',1,0,'2022-03-03 12:43:46','2022-03-03 12:43:46'),(47250,137,'Toovipuram','628002',1,0,'2022-03-03 12:43:47','2022-03-03 12:43:47'),(47251,137,'Tt. Thermal Power Plant','628004',1,0,'2022-03-03 12:43:47','2022-03-03 12:43:47'),(47252,137,'Tuticorin Cathedral','628001',1,0,'2022-03-03 12:43:47','2022-03-03 12:43:47'),(47253,137,'Tuticorin Central Bus Stand','628002',1,0,'2022-03-03 12:43:47','2022-03-03 12:43:47'),(47254,137,'Tuticorin courts','628003',1,0,'2022-03-03 12:43:47','2022-03-03 12:43:47'),(47255,137,'Tuticorin H.O','628001',1,0,'2022-03-03 12:43:47','2022-03-03 12:43:47'),(47256,137,'Tuticorin Harbour Estate','628004',1,0,'2022-03-03 12:43:47','2022-03-03 12:43:47'),(47257,137,'Tuticorin Keelur','628001',1,0,'2022-03-03 12:43:47','2022-03-03 12:43:47'),(47258,137,'Udangudi Christianagaram','628203',1,0,'2022-03-03 12:43:47','2022-03-03 12:43:47'),(47259,137,'Udayarkulam','628617',1,0,'2022-03-03 12:43:47','2022-03-03 12:43:47'),(47260,137,'Umarikottai','628301',1,0,'2022-03-03 12:43:47','2022-03-03 12:43:47'),(47261,137,'Uthiramadankudiyiruppu','628203',1,0,'2022-03-03 12:43:47','2022-03-03 12:43:47'),(47262,137,'Uyarathukudiyiruppu','628703',1,0,'2022-03-03 12:43:47','2022-03-03 12:43:47'),(47263,137,'Vadakkukariseri','628851',1,0,'2022-03-03 12:43:47','2022-03-03 12:43:47'),(47264,137,'Vadakkur Tuticorin','628001',1,0,'2022-03-03 12:43:47','2022-03-03 12:43:47'),(47265,137,'Valasakaran Vilai','628251',1,0,'2022-03-03 12:43:47','2022-03-03 12:43:47'),(47266,137,'Vallakulam','628622',1,0,'2022-03-03 12:43:47','2022-03-03 12:43:47'),(47267,137,'Vallanad','628252',1,0,'2022-03-03 12:43:47','2022-03-03 12:43:47'),(47268,137,'Vallavallan','628801',1,0,'2022-03-03 12:43:47','2022-03-03 12:43:47'),(47269,137,'Vallivilai','628218',1,0,'2022-03-03 12:43:47','2022-03-03 12:43:47'),(47270,137,'Varandiavel','628207',1,0,'2022-03-03 12:43:47','2022-03-03 12:43:47'),(47271,137,'Varthagareddipatti','628102',1,0,'2022-03-03 12:43:47','2022-03-03 12:43:47'),(47272,137,'Vasavappapuram','628252',1,0,'2022-03-03 12:43:47','2022-03-03 12:43:47'),(47273,137,'Vedakottaivilai','628203',1,0,'2022-03-03 12:43:47','2022-03-03 12:43:47'),(47274,137,'Vellalanvilai','628219',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47275,137,'Vellamadam','628617',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47276,137,'Vellaram','628401',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47277,137,'Velur','628621',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47278,137,'Vetrivelpuram','628001',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47279,137,'Victoria Extension Road','628002',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47280,137,'Vijayaramapuram','628704',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47281,137,'Viramanickam','628212',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47282,137,'Virapandianpatanam','628216',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47283,137,'Vittilapuram','628809',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47284,137,'Karuppur','626205',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47285,137,'Masarpatti','626202',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47286,138,'Agaram','632506',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47287,138,'Akkachikuppam','632510',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47288,138,'Alapakkam','632508',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47289,138,'Ammanur','631002',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47290,138,'Ammoor','632501',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47291,138,'Ammundi','632519',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47292,138,'Anaimallur','632507',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47293,138,'Anaipakkam','631003',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47294,138,'Anandhalai','632513',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47295,138,'Ananthangal','632511',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47296,138,'Anvardhikhanpet','632502',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47297,138,'Arakkonam H.O','631001',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47298,138,'Arapakkam','632517',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47299,138,'Arcot Bazaar','632503',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47300,138,'Arcot','632503',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47301,138,'Arcot West','632503',1,0,'2022-03-03 12:43:48','2022-03-03 12:43:48'),(47302,138,'Arigilapadi','631151',1,0,'2022-03-03 12:43:49','2022-03-03 12:43:49'),(47303,138,'Arumbakkam','632506',1,0,'2022-03-03 12:43:49','2022-03-03 12:43:49'),(47304,138,'Arungundram','632509',1,0,'2022-03-03 12:43:49','2022-03-03 12:43:49'),(47305,138,'Asamandhur','632502',1,0,'2022-03-03 12:43:49','2022-03-03 12:43:49'),(47306,138,'Ashoknagar (Vellore)','631001',1,0,'2022-03-03 12:43:49','2022-03-03 12:43:49'),(47307,138,'Attupakkam','631051',1,0,'2022-03-03 12:43:49','2022-03-03 12:43:49'),(47308,138,'Ayal','632505',1,0,'2022-03-03 12:43:49','2022-03-03 12:43:49'),(47309,138,'Ayarpadi','632531',1,0,'2022-03-03 12:43:49','2022-03-03 12:43:49'),(47310,138,'Ayilam','632509',1,0,'2022-03-03 12:43:49','2022-03-03 12:43:49'),(47311,138,'Ayipedu','631102',1,0,'2022-03-03 12:43:49','2022-03-03 12:43:49'),(47312,138,'Banavaram','632505',1,0,'2022-03-03 12:43:49','2022-03-03 12:43:49'),(47313,138,'Bhel Ranipet','632406',1,0,'2022-03-03 12:43:49','2022-03-03 12:43:49'),(47314,138,'Chengalnatham','632520',1,0,'2022-03-03 12:43:49','2022-03-03 12:43:49'),(47315,138,'Chennasamudram','632506',1,0,'2022-03-03 12:43:49','2022-03-03 12:43:49'),(47316,138,'Chitteri','631003',1,0,'2022-03-03 12:43:49','2022-03-03 12:43:49'),(47317,138,'Damarapakkam','632504',1,0,'2022-03-03 12:43:49','2022-03-03 12:43:49'),(47318,138,'Durgam','632512',1,0,'2022-03-03 12:43:49','2022-03-03 12:43:49'),(47319,138,'Ekambaranallur','632405',1,0,'2022-03-03 12:43:49','2022-03-03 12:43:49'),(47320,138,'Ekhunagar','631004',1,0,'2022-03-03 12:43:49','2022-03-03 12:43:49'),(47321,138,'Eranthangal','632519',1,0,'2022-03-03 12:43:49','2022-03-03 12:43:49'),(47322,138,'Esayanur','632511',1,0,'2022-03-03 12:43:49','2022-03-03 12:43:49'),(47323,138,'Federation Buildings','632509',1,0,'2022-03-03 12:43:49','2022-03-03 12:43:49'),(47324,138,'G.B.Nagar','632506',1,0,'2022-03-03 12:43:49','2022-03-03 12:43:49'),(47325,138,'Ganapathipuram','631051',1,0,'2022-03-03 12:43:49','2022-03-03 12:43:49'),(47326,138,'Govindacherrykuppam','632505',1,0,'2022-03-03 12:43:49','2022-03-03 12:43:49'),(47327,138,'Gudalur','632510',1,0,'2022-03-03 12:43:49','2022-03-03 12:43:49'),(47328,138,'Gudimallur','632513',1,0,'2022-03-03 12:43:50','2022-03-03 12:43:50'),(47329,138,'Gugainallore','632515',1,0,'2022-03-03 12:43:50','2022-03-03 12:43:50'),(47330,138,'Gundaleri','632512',1,0,'2022-03-03 12:43:50','2022-03-03 12:43:50'),(47331,138,'Guruvarajpet','631101',1,0,'2022-03-03 12:43:50','2022-03-03 12:43:50'),(47332,138,'Hakeemnagar','632509',1,0,'2022-03-03 12:43:50','2022-03-03 12:43:50'),(47333,138,'Ichiputhur','631003',1,0,'2022-03-03 12:43:50','2022-03-03 12:43:50'),(47334,138,'Iluppaithandalam','631151',1,0,'2022-03-03 12:43:50','2022-03-03 12:43:50'),(47335,138,'Ins Rajali','631006',1,0,'2022-03-03 12:43:50','2022-03-03 12:43:50'),(47336,138,'Jagirthandalam','631052',1,0,'2022-03-03 12:43:50','2022-03-03 12:43:50'),(47337,138,'Jagirvalavanur','632511',1,0,'2022-03-03 12:43:50','2022-03-03 12:43:50'),(47338,138,'Jambukulam','631102',1,0,'2022-03-03 12:43:50','2022-03-03 12:43:50'),(47339,138,'Jawaharpuram','632503',1,0,'2022-03-03 12:43:50','2022-03-03 12:43:50'),(47340,138,'Jothinagar','631003',1,0,'2022-03-03 12:43:50','2022-03-03 12:43:50'),(47341,138,'Kadambainallore','631151',1,0,'2022-03-03 12:43:50','2022-03-03 12:43:50'),(47342,138,'Kadaperi','632508',1,0,'2022-03-03 12:43:50','2022-03-03 12:43:50'),(47343,138,'Kainoor','631003',1,0,'2022-03-03 12:43:50','2022-03-03 12:43:50'),(47344,138,'Kalathur','632531',1,0,'2022-03-03 12:43:50','2022-03-03 12:43:50'),(47345,138,'Kalavai','632506',1,0,'2022-03-03 12:43:50','2022-03-03 12:43:50'),(47346,138,'Kalmelkuppam','632501',1,0,'2022-03-03 12:43:50','2022-03-03 12:43:50'),(47347,138,'Kaniyanur','632506',1,0,'2022-03-03 12:43:50','2022-03-03 12:43:50'),(47348,138,'Karai','632404',1,0,'2022-03-03 12:43:50','2022-03-03 12:43:50'),(47349,138,'Karikkal','631102',1,0,'2022-03-03 12:43:50','2022-03-03 12:43:50'),(47350,138,'Karikkanthangal','632506',1,0,'2022-03-03 12:43:50','2022-03-03 12:43:50'),(47351,138,'Karnambut','632519',1,0,'2022-03-03 12:43:50','2022-03-03 12:43:50'),(47352,138,'Karnavur','631052',1,0,'2022-03-03 12:43:50','2022-03-03 12:43:50'),(47353,138,'Katrambakkam','632501',1,0,'2022-03-03 12:43:50','2022-03-03 12:43:50'),(47354,138,'Kattupakkam','632502',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47355,138,'Kavanur','631004',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47356,138,'Kavanur','632507',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47357,138,'Kaveripak','632508',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47358,138,'Keerasathu','632514',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47359,138,'Kesavanankuppam','631102',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47360,138,'Kilandur','631003',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47361,138,'Kilandurai','631002',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47362,138,'Kilkuppam','631004',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47363,138,'Kilminnal','632517',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47364,138,'Kilpakkam','631003',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47365,138,'Kilveedhi','632502',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47366,138,'Kilveeranam','632505',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47367,138,'Kilvenkatapuram','631051',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47368,138,'Kilvisharam','632509',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47369,138,'Kizhavanam','631101',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47370,138,'Kodakkal','631102',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47371,138,'Kokkeri','632520',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47372,138,'Kondakuppam','632520',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47373,138,'Kondapalayam','631102',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47374,138,'Kumpinipet','631003',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47375,138,'Kunnathur','632510',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47376,138,'Kuppireddithangal','632516',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47377,138,'Ladavaram','632503',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47378,138,'Mahendravadi','632502',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47379,138,'Mahimandalam','632516',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47380,138,'Mambakkam','632318',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47381,138,'Manamadurai','632502',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47382,138,'Mangattucherry','631151',1,0,'2022-03-03 12:43:51','2022-03-03 12:43:51'),(47383,138,'Manthangal','632404',1,0,'2022-03-03 12:43:52','2022-03-03 12:43:52'),(47384,138,'Marudhalam','632501',1,0,'2022-03-03 12:43:52','2022-03-03 12:43:52'),(47385,138,'Mazharyur','632506',1,0,'2022-03-03 12:43:52','2022-03-03 12:43:52'),(47386,138,'Mecheri','632506',1,0,'2022-03-03 12:43:52','2022-03-03 12:43:52'),(47387,138,'Melakuppam','632517',1,0,'2022-03-03 12:43:52','2022-03-03 12:43:52'),(47388,138,'Melapudupakkam','632318',1,0,'2022-03-03 12:43:52','2022-03-03 12:43:52'),(47389,138,'Melapulam','631052',1,0,'2022-03-03 12:43:52','2022-03-03 12:43:52'),(47390,138,'Meleri','632502',1,0,'2022-03-03 12:43:52','2022-03-03 12:43:52'),(47391,138,'Melkalathur','632502',1,0,'2022-03-03 12:43:52','2022-03-03 12:43:52'),(47392,138,'Melnathambakkam','632506',1,0,'2022-03-03 12:43:52','2022-03-03 12:43:52'),(47393,138,'Melpadi','632520',1,0,'2022-03-03 12:43:52','2022-03-03 12:43:52'),(47394,138,'Melvisharam','632509',1,0,'2022-03-03 12:43:52','2022-03-03 12:43:52'),(47395,138,'Minnal','632510',1,0,'2022-03-03 12:43:52','2022-03-03 12:43:52'),(47396,138,'Mittapettai','631101',1,0,'2022-03-03 12:43:52','2022-03-03 12:43:52'),(47397,138,'Mohamedpet','632512',1,0,'2022-03-03 12:43:52','2022-03-03 12:43:52'),(47398,138,'Mosur','631004',1,0,'2022-03-03 12:43:52','2022-03-03 12:43:52'),(47399,138,'Mudur','631003',1,0,'2022-03-03 12:43:52','2022-03-03 12:43:52'),(47400,138,'Mukundarayapuram','632405',1,0,'2022-03-03 12:43:52','2022-03-03 12:43:52'),(47401,138,'Muppathuvetti','632503',1,0,'2022-03-03 12:43:52','2022-03-03 12:43:52'),(47402,138,'Nagavedu','631002',1,0,'2022-03-03 12:43:52','2022-03-03 12:43:52'),(47403,138,'Namali','631051',1,0,'2022-03-03 12:43:52','2022-03-03 12:43:52'),(47404,138,'Nambarai','632512',1,0,'2022-03-03 12:43:52','2022-03-03 12:43:52'),(47405,138,'Nandiveduthangal','631101',1,0,'2022-03-03 12:43:52','2022-03-03 12:43:52'),(47406,138,'Nandiyalam','632517',1,0,'2022-03-03 12:43:52','2022-03-03 12:43:52'),(47407,138,'Navalpur','632401',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47408,138,'Neelakandarayanpattai','632501',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47409,138,'Ocheri','632531',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47410,138,'Ozhughur','632501',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47411,138,'Pagaveli','632508',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47412,138,'Palanipet','631002',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47413,138,'Palayamangadu','632503',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47414,138,'Palayanur','632512',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47415,138,'Palayapalayamottur','632505',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47416,138,'Pallur','631051',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47417,138,'Panaiyur','632518',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47418,138,'Panapakkam','631052',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47419,138,'Pandianallore','631102',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47420,138,'Paradarami','632512',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47421,138,'Paranji','632510',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47422,138,'Paravathur','632510',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47423,138,'Parithiputhur','631002',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47424,138,'Pennagar','632518',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47425,138,'Periamittoor','632516',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47426,138,'Periasengadu','632501',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47427,138,'Perumalkuppam','632520',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47428,138,'Perumbulipakkam','632531',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47429,138,'Perumuchi','631002',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47430,138,'Perungalathur','631003',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47431,138,'Perunkanchi','631102',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47432,138,'Peruvalayam','631052',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47433,138,'Pillaipakkam','631052',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47434,138,'Polipakkam','632505',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47435,138,'Ponnai','632514',1,0,'2022-03-03 12:43:53','2022-03-03 12:43:53'),(47436,138,'Poondi','632513',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47437,138,'Pudupadi','632503',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47438,138,'Pudur- Kaniyanur','632506',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47439,138,'Pulivalam','632505',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47440,138,'Puliyamangalam','631004',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47441,138,'Puliyankannu','632404',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47442,138,'Punganur','632507',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47443,138,'Puttuthakku','632517',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47444,138,'Ranipet Bazar','632401',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47445,138,'Ranipet H.O','632401',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47446,138,'Ranipet Industrial Estate','632403',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47447,138,'Ratnagiri Kilminnal','632517',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47448,138,'Reddivalam','631052',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47449,138,'Rendadi','631102',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47450,138,'Rottukadai','632508',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47451,138,'Sagayathottam','631151',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47452,138,'Sakkaramallur','632511',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47453,138,'Sambasivapuram','632507',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47454,138,'Sathambakkam','632513',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47455,138,'Sattur','632521',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47456,138,'Sayanavaram','631051',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47457,138,'Seekarajapuram','632515',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47458,138,'Sembarayanallur','632519',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47459,138,'Sendamangalam','631051',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47460,138,'Senganavaram','632518',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47461,138,'Seri','632508',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47462,138,'Seyyoor','631004',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47463,138,'Sholingur Bazaar','631102',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47464,138,'Sholingur','631102',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47465,138,'Sirukarumbur','632531',1,0,'2022-03-03 12:43:54','2022-03-03 12:43:54'),(47466,138,'Sirunamalli','631002',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47467,138,'Somasamudram','631102',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47468,138,'Soraiyur','632318',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47469,138,'Sumaithangi','632508',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47470,138,'Surai','632505',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47471,138,'Suraksha Cisf Campus','631152',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47472,138,'Tajpura','632521',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47473,138,'Takkolam','631151',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47474,138,'Talikkal','631102',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47475,138,'Tempalle','632515',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47476,138,'Thalangai','632501',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47477,138,'Thanigaipolur','631003',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47478,138,'Thathireddipalle','632516',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47479,138,'Thengal','632404',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47480,138,'Thengal','632514',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47481,138,'Thenkadapanthangal','632513',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47482,138,'Thirumalaicheryy','632513',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47483,138,'Thiruparkadal','632508',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47484,138,'Thoppukhana','632503',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47485,138,'Thuraiperumbakkam','632508',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47486,138,'Timiri','632512',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47487,138,'Tirumalpur','631051',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47488,138,'Tiruvalam','632515',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47489,138,'Ulianallore','631052',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47490,138,'Uppupettai','632521',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47491,138,'Uriyur','631151',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47492,138,'Vadamambakkam','631003',1,0,'2022-03-03 12:43:55','2022-03-03 12:43:55'),(47493,138,'Valaikulam','631003',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47494,138,'Valapandal','632318',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47495,138,'Valayathur','632504',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47496,138,'Vallimalai','632520',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47497,138,'Valluvambakkam','632513',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47498,138,'Vanapadi','632404',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47499,138,'Vangupattu','631102',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47500,138,'Vangur','632501',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47501,138,'Vannivedu','632513',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47502,138,'Varagur','632507',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47503,138,'Vasur','632514',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47504,138,'Velam','632501',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47505,138,'Vellambi','632506',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47506,138,'Vellore Sugar Mills','632519',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47507,138,'Velur- Kalavai','632506',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47508,138,'Vembi','632518',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47509,138,'Venkatapuram','632507',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47510,138,'Vennampalle','632516',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47511,138,'Veppalai','632520',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47512,138,'Vilapakkam','632521',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47513,138,'Walajapet Bazaar','632513',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47514,138,'Walajapet','632513',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47515,138,'Winterpet','631005',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47516,138,'Irungur','604407',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47517,138,'Kammasamudram','632319',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47518,138,'Kammavanpettai','632319',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47519,138,'Kattazhambattu','632312',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47520,138,'Kilarasampattu','632312',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47521,138,'Mottakkal','632319',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47522,138,'Nanjukondapuram','632312',1,0,'2022-03-03 12:43:56','2022-03-03 12:43:56'),(47523,138,'Vallam Arni','604505',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47524,138,'Vallam Kannamangalam','632311',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47525,138,'A Kattupadi','632011',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47526,138,'Abdullapuram','632010',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47527,138,'Alleri','632101',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47528,138,'Amirdhi','632102',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47529,138,'Ampuram','632009',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47530,138,'Anaikkattu','632101',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47531,138,'Angarankuppam','632204',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47532,138,'Annangudi','632202',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47533,138,'Appukal','632101',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47534,138,'Arimalai','632107',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47535,138,'Ariyur (Vellore)','632055',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47536,138,'Ariyur Spinning Mills','632055',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47537,138,'Arumbakkam','632202',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47538,138,'Arumparuthi','632106',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47539,138,'Asanamabattu','632107',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47540,138,'Bagayam','632002',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47541,138,'Bakiyath','632004',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47542,138,'Bn Palayam','632202',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47543,138,'Bramhapuram','632014',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47544,138,'Budur','632105',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47545,138,'Chinnapalampakkam','632113',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47546,138,'Chinnapallikuppam','632107',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47547,138,'Chitteri','632002',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47548,138,'Cholavaram','632113',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47549,138,'Christianpet','632059',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47550,138,'CMC H','632004',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47551,138,'CMC (Vellore)','632002',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47552,138,'Devichettikuppam','632107',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47553,138,'Edayansathu','632002',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47554,138,'Elavambadi','632105',1,0,'2022-03-03 12:43:57','2022-03-03 12:43:57'),(47555,138,'Erayangadu','632104',1,0,'2022-03-03 12:43:58','2022-03-03 12:43:58'),(47556,138,'Eripudhur','632101',1,0,'2022-03-03 12:43:58','2022-03-03 12:43:58'),(47557,138,'Eriyur Amirdhi','632102',1,0,'2022-03-03 12:43:58','2022-03-03 12:43:58'),(47558,138,'Eriyur','632103',1,0,'2022-03-03 12:43:58','2022-03-03 12:43:58'),(47559,138,'Gandhinagar East','632006',1,0,'2022-03-03 12:43:58','2022-03-03 12:43:58'),(47560,138,'Gandhinagar (Vellore)','632006',1,0,'2022-03-03 12:43:58','2022-03-03 12:43:58'),(47561,138,'Gandhinagar West','632006',1,0,'2022-03-03 12:43:58','2022-03-03 12:43:58'),(47562,138,'Gandhiroad','632004',1,0,'2022-03-03 12:43:58','2022-03-03 12:43:58'),(47563,138,'Ganganallur','632101',1,0,'2022-03-03 12:43:58','2022-03-03 12:43:58'),(47564,138,'Govindareddipalayam','632105',1,0,'2022-03-03 12:43:58','2022-03-03 12:43:58'),(47565,138,'Guruvarajapalayam','632107',1,0,'2022-03-03 12:43:58','2022-03-03 12:43:58'),(47566,138,'Jaffarapettai','632006',1,0,'2022-03-03 12:43:58','2022-03-03 12:43:58'),(47567,138,'Jordhankollai','632113',1,0,'2022-03-03 12:43:58','2022-03-03 12:43:58'),(47568,138,'Ka Farm','632007',1,0,'2022-03-03 12:43:58','2022-03-03 12:43:58'),(47569,138,'Kagithapattarai','632012',1,0,'2022-03-03 12:43:58','2022-03-03 12:43:58'),(47570,138,'Kalambattu','632202',1,0,'2022-03-03 12:43:58','2022-03-03 12:43:58'),(47571,138,'Kandhipedu','632106',1,0,'2022-03-03 12:43:58','2022-03-03 12:43:58'),(47572,138,'Kangeyanallur','632006',1,0,'2022-03-03 12:43:58','2022-03-03 12:43:58'),(47573,138,'Kaniyambadi','632102',1,0,'2022-03-03 12:43:58','2022-03-03 12:43:58'),(47574,138,'Karasamangalam','632202',1,0,'2022-03-03 12:43:58','2022-03-03 12:43:58'),(47575,138,'Karigiri','632106',1,0,'2022-03-03 12:43:58','2022-03-03 12:43:58'),(47576,138,'Karugambathur','632013',1,0,'2022-03-03 12:43:58','2022-03-03 12:43:58'),(47577,138,'Kasba (Vellore)','632001',1,0,'2022-03-03 12:43:58','2022-03-03 12:43:58'),(47578,138,'Katpadi North','632007',1,0,'2022-03-03 12:43:58','2022-03-03 12:43:58'),(47579,138,'Katpadi','632007',1,0,'2022-03-03 12:43:58','2022-03-03 12:43:58'),(47580,138,'Kattipattu','632103',1,0,'2022-03-03 12:43:58','2022-03-03 12:43:58'),(47581,138,'Kattuputhur','632058',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47582,138,'Kavasampattu','632204',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47583,138,'Kilkothur','632103',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47584,138,'Kilmuttukur','632204',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47585,138,'Kilsaranakuppam','632102',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47586,138,'Konavattam','632013',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47587,138,'Koranthangal','632106',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47588,138,'Kosapet (Vellore)','632001',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47589,138,'Kothamangalam','632104',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47590,138,'Kovilandur','632102',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47591,138,'Krishnanagar (Vellore)','632001',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47592,138,'Latteri','632202',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47593,138,'Maruthavallipalayam','632104',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47594,138,'Melarasambattu','632103',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47595,138,'Melkuppachinna','632102',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47596,138,'Melmonavur','632010',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47597,138,'Mudinampattu','632204',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47598,138,'Munjurpattu','632057',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47599,138,'Mutharasikuppam','632106',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47600,138,'Nadanur','632102',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47601,138,'Nagalur','632102',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47602,138,'Naganadhi','632113',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47603,138,'Nammiyambattu','632102',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47604,138,'Nelvoy','632011',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47605,138,'Nemandhapura','m',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47606,138,'Odugathur','632103',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47607,138,'Old District Board Buildings','632001',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47608,138,'Old Town (Vellore)','632001',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47609,138,'Ongapadi','632101',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47610,138,'Pakkampalayam','632107',1,0,'2022-03-03 12:43:59','2022-03-03 12:43:59'),(47611,138,'Palamathi','632002',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47612,138,'Palambattu','632102',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47613,138,'Palaparambattu','632102',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47614,138,'Pallikuppam','632007',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47615,138,'Panamadangi','632202',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47616,138,'Peenjamandai','632103',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47617,138,'Pennathur','632058',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47618,138,'Periyapudhur','632059',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47619,138,'Perumugai','632009',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47620,138,'Pinnathurai','632103',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47621,138,'Poigai','632114',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47622,138,'Poigaimottur','632114',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47623,138,'Pulimedu','632105',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47624,138,'R N Palayam','632001',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47625,138,'Ramanayanikuppam','632107',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47626,138,'Rangapuram','632009',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47627,138,'Saduperi','632002',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47628,138,'Saidapet (Vellore)','632012',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47629,138,'Sainathapuram','632001',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47630,138,'Sankaranpalayam','632001',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47631,138,'Sathupalayam','632113',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47632,138,'Sathuvacahri Extension','632009',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47633,138,'Sathuvachari','632009',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47634,138,'Sathyamangalam (Vellore)S.O','632114',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47635,138,'Sedhuvalai','632104',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47636,138,'Sekkanur','632105',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47637,138,'Sembedu','632002',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47638,138,'Senji','632202',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47639,138,'Senur','632006',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47640,138,'Serkadu','632106',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47641,138,'Serpadi','632103',1,0,'2022-03-03 12:44:00','2022-03-03 12:44:00'),(47642,138,'Sevur','632106',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47643,138,'Shenbakkam','632008',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47644,138,'Sivanathapuram','632105',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47645,138,'Slr Sanatorium','632106',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47646,138,'Sozhamur','632202',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47647,138,'Sullivanpet','632001',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47648,138,'TB Sanatorium','632011',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47649,138,'TEL','632059',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47650,138,'Tellai','632113',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47651,138,'Tellur','632105',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47652,138,'Thandalam Krishnapuram','632006',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47653,138,'Thiruvalluvar University','632115',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47654,138,'Thondanthualsi','632202',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47655,138,'Thongumalai','632103',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47656,138,'Thorapadi','632002',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47657,138,'Thuthikkadu','632113',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47658,138,'Thuthipattu','632011',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47659,138,'Tirumani','632202',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47660,138,'Unai','632101',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47661,138,'Unai Vaniyambadi','632101',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47662,138,'Unaipalathur','632101',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47663,138,'Ussoor','632105',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47664,138,'Vaduganthangal','632204',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47665,138,'Vallandramam','632104',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47666,138,'Vandranthangal','632059',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47667,138,'Vannanthangal','632103',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47668,138,'Varadalambattu','632101',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47669,138,'Velangadu','632101',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47670,138,'Velapadi','632001',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47671,138,'Vellore Bazaar','632004',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47672,138,'Vellore Cantonment','632001',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47673,138,'Vellore Collectorate','632004',1,0,'2022-03-03 12:44:01','2022-03-03 12:44:01'),(47674,138,'Vellore Collectorate','632009',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47675,138,'Vellore Fort','632004',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47676,138,'Vellore H.O','632001',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47677,138,'Vellore Institute Of Technolog','632014',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47678,138,'Vellore Market','632004',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47679,138,'Vellore South','632001',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47680,138,'Veppampattu','632113',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47681,138,'Veppankuppam','632107',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47682,138,'Virnjipuram','632104',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47683,138,'Virudhambattu','632006',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47684,138,'Virupakshipuram','632002',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47685,138,'Voorhees College','632001',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47686,138,'Achamangalam','635651',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47687,138,'Adiyur','635602',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47688,138,'Agaram','635804',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47689,138,'Agaram(TPT)','635653',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47690,138,'Agaramcherry','635804',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47691,138,'Agraharam','632604',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47692,138,'Agraharam','635651',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47693,138,'Alangayam','635701',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47694,138,'Alankuppam','635814',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47695,138,'Alasandapuram','635801',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47696,138,'Ambalur','635801',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47697,138,'Ambur Bazaar','635802',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47698,138,'Ambur','635802',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47699,138,'Ananganallore','635806',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47700,138,'Andiappanur','635702',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47701,138,'Anganathavalasai','635652',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47702,138,'Arangaldurgam','635811',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47703,138,'Aravatla','635810',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47704,138,'Asiriyar Nagar','635601',1,0,'2022-03-03 12:44:02','2022-03-03 12:44:02'),(47705,138,'Athiperumanur','635852',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47706,138,'Athipet','635703',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47707,138,'Athurkuppam','635815',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47708,138,'Avarankuppam','635801',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47709,138,'Bandarapalli','635854',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47710,138,'Bheemakulam','635701',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47711,138,'Bhuvaneswaripet','632602',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47712,138,'Bommikuppam','635653',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47713,138,'Chandrapuram','635651',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47714,138,'Chendathur','635805',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47715,138,'Chennankuppam','632209',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47716,138,'Chettiappanur','635751',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47717,138,'Chettikuppam','635806',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47718,138,'Chikkanankuppam','635801',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47719,138,'Chinnadamalcheruvu','635810',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47720,138,'Chinnakandili','635901',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47721,138,'Chinnakarumbur','635811',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47722,138,'Chinnapallikuppam','635754',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47723,138,'Chinnasamudram','635653',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47724,138,'Chinnathottalam','635813',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47725,138,'Chinnavarikam','635811',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47726,138,'Chinnavattanur','635655',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47727,138,'Chittoor','635655',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47728,138,'Christukula Ashram','635602',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47729,138,'Dakshinapathapalyaam','632603',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47730,138,'Damalerimuthur','635853',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47731,138,'Devalapuram','635802',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47732,138,'Devarishikuppam','632209',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47733,138,'Devasthanam','635751',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47734,138,'Dharanampet','632601',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47735,138,'Eachangal','635801',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47736,138,'East Badanavadi','635901',1,0,'2022-03-03 12:44:03','2022-03-03 12:44:03'),(47737,138,'Elagiri','635853',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47738,138,'Elavampatti','635602',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47739,138,'Erikutti','635810',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47740,138,'Erthangal','632604',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47741,138,'Erukkambattu','635810',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47742,138,'Gandhipet - TPT','635601',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47743,138,'Gangapuram','635802',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47744,138,'Girisamudram','635751',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47745,138,'Gollamangalam','635809',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47746,138,'Govindapuram','635751',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47747,138,'Gudanagaram','635806',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47748,138,'Gudiyattam Cutcherry','632602',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47749,138,'Gudiyattam H.O','632602',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47750,138,'Gudiyattam RS','635803',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47751,138,'Gudiyattam South','632602',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47752,138,'Gummidigampatti','635901',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47753,138,'Ilayanagaram','635754',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47754,138,'Irunapattu','635702',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47755,138,'Jaffarabad','635754',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47756,138,'Jamnapudur','635652',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47757,138,'Jangalapuram','635852',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47758,138,'Jayapuram','635651',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47759,138,'Jolarpettai','635851',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47760,138,'Kadhavalam','635811',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47761,138,'Kadirimangalam','635602',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47762,138,'Kakangarai R.S.','635654',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47763,138,'Kalendira','635751',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47764,138,'Kallapadi','632601',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47765,138,'Kamalapuram','635810',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47766,138,'Kambugudi','635655',1,0,'2022-03-03 12:44:04','2022-03-03 12:44:04'),(47767,138,'Kandaneri','635809',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47768,138,'Kandili','635901',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47769,138,'Kanguppam','632209',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47770,138,'Karapattu','635811',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47771,138,'Karungali','635804',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47772,138,'Karuppanur','635602',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47773,138,'Kathari','635852',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47774,138,'Kavalur','635701',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47775,138,'Kethandapatti','635815',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47776,138,'Kethandapatti Sugar Mills','635815',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47777,138,'Khaderpet','635751',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47778,138,'Kilalathur','635803',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47779,138,'Kilanur','635655',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47780,138,'Kilmurungai','635812',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47781,138,'Kilpatti','635805',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47782,138,'Kilur','635655',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47783,138,'Kilvayathinankuppam','632201',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47784,138,'Kodayanchi','635801',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47785,138,'Kodiyur','635851',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47786,138,'Kodumampalli','635653',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47787,138,'Kokkalur','635810',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47788,138,'Kombai','635655',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47789,138,'Koratti','635602',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47790,138,'Kosavanpudur','635803',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47791,138,'Kothakottai','635752',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47792,138,'Kothur','635854',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47793,138,'Kottaiyur','635853',1,0,'2022-03-03 12:44:05','2022-03-03 12:44:05'),(47794,138,'Kottamitta','632601',1,0,'2022-03-03 12:44:06','2022-03-03 12:44:06'),(47795,138,'Kottur','635808',1,0,'2022-03-03 12:44:06','2022-03-03 12:44:06'),(47796,138,'Kumaramangalam','635802',1,0,'2022-03-03 12:44:06','2022-03-03 12:44:06'),(47797,138,'Kurumbakeri','635653',1,0,'2022-03-03 12:44:06','2022-03-03 12:44:06'),(47798,138,'Kurumberi','635652',1,0,'2022-03-03 12:44:06','2022-03-03 12:44:06'),(47799,138,'Kurusilapattu','635702',1,0,'2022-03-03 12:44:06','2022-03-03 12:44:06'),(47800,138,'Lakkinaickenpatti','635654',1,0,'2022-03-03 12:44:06','2022-03-03 12:44:06'),(47801,138,'Lalapettai','635710',1,0,'2022-03-03 12:44:06','2022-03-03 12:44:06'),(47802,138,'Machanur','632209',1,0,'2022-03-03 12:44:06','2022-03-03 12:44:06'),(47803,138,'Madanancherry','635754',1,0,'2022-03-03 12:44:06','2022-03-03 12:44:06'),(47804,138,'Madanur','635804',1,0,'2022-03-03 12:44:06','2022-03-03 12:44:06'),(47805,138,'Madavalam','635653',1,0,'2022-03-03 12:44:06','2022-03-03 12:44:06'),(47806,138,'Mailpatti','635805',1,0,'2022-03-03 12:44:06','2022-03-03 12:44:06'),(47807,138,'Malaiyandipatti','635655',1,0,'2022-03-03 12:44:06','2022-03-03 12:44:06'),(47808,138,'Mallagunta','635852',1,0,'2022-03-03 12:44:06','2022-03-03 12:44:06'),(47809,138,'Mallapalli','635854',1,0,'2022-03-03 12:44:06','2022-03-03 12:44:06'),(47810,138,'Mandalanayanagunda','635901',1,0,'2022-03-03 12:44:06','2022-03-03 12:44:06'),(47811,138,'Mandalavadi','635851',1,0,'2022-03-03 12:44:06','2022-03-03 12:44:06'),(47812,138,'Mandarakuttai','635701',1,0,'2022-03-03 12:44:06','2022-03-03 12:44:06'),(47813,138,'Mangalam','635853',1,0,'2022-03-03 12:44:06','2022-03-03 12:44:06'),(47814,138,'Marimanikuppam','635710',1,0,'2022-03-03 12:44:06','2022-03-03 12:44:06'),(47815,138,'Masigam','635810',1,0,'2022-03-03 12:44:06','2022-03-03 12:44:06'),(47816,138,'Matrapalli','635652',1,0,'2022-03-03 12:44:06','2022-03-03 12:44:06'),(47817,138,'Melalathur','635806',1,0,'2022-03-03 12:44:06','2022-03-03 12:44:06'),(47818,138,'Melkavanur','632209',1,0,'2022-03-03 12:44:06','2022-03-03 12:44:06'),(47819,138,'Melmankuppam','632203',1,0,'2022-03-03 12:44:06','2022-03-03 12:44:06'),(47820,138,'Melmayil','632203',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47821,138,'Melmuttukur','635806',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47822,138,'Melpattu','635655',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47823,138,'Melvayathinankuppam','635805',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47824,138,'Minnur','635807',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47825,138,'Mittalam','635811',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47826,138,'Mittur','635710',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47827,138,'Modikuppam','632601',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47828,138,'Morasapalli','635810',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47829,138,'Mordhana','632604',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47830,138,'Mukkanur','635651',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47831,138,'Nachiarkuppam','635710',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47832,138,'Nadukuppam','635655',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47833,138,'Naickaneri','635802',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47834,138,'Naickanur','635701',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47835,138,'Narasingapuram','635701',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47836,138,'Nariyambattu','635808',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47837,138,'Nariyaneri','635901',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47838,138,'Natham','635654',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47839,138,'Natrampalli','635852',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47840,138,'Nayakkanur','635652',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47841,138,'Nayanacheruvu','635852',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47842,138,'Nellipattu','635655',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47843,138,'Nellivasalnadu','635655',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47844,138,'Newtown Vaniyambadi','635752',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47845,138,'Nilavur','635853',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47846,138,'Nimmiyambattu','635752',1,0,'2022-03-03 12:44:07','2022-03-03 12:44:07'),(47847,138,'Odiyathur','635809',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47848,138,'Oomerabad','635808',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47849,138,'Pachal','635602',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47850,138,'Pachur','635854',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47851,138,'Pakkamvenkatapuram','632601',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47852,138,'Pakkirithakka','635853',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47853,138,'Palayakrishnapuram','632209',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47854,138,'Palayapalayam','635655',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47855,138,'Pallalakuppam','635805',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47856,138,'Pallathur','635901',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47857,138,'Pallavalli','635702',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47858,138,'Pallikonda Bazaar','635809',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47859,138,'Pallikonda','635809',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47860,138,'Palur','635804',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47861,138,'Paniyandapalli','635651',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47862,138,'Paradarami','632603',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47863,138,'Parandapalli','635651',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47864,138,'Pasumathur','635803',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47865,138,'Peddur','635701',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47866,138,'Perambattu','635652',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47867,138,'Periagaram','635901',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47868,138,'Periyakannalapatti','635654',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47869,138,'Periyakasinaickenpatti','635901',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47870,138,'Periyakonapattu','635651',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47871,138,'Periyakunichi','635602',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47872,138,'Periyankuppam','635814',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47873,138,'Periyapet','635751',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47874,138,'Pernambut','635810',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47875,138,'Perumalpet','635751',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47876,138,'Perumankuppam','632201',1,0,'2022-03-03 12:44:08','2022-03-03 12:44:08'),(47877,138,'Perumapattu','635702',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47878,138,'Perumpalli','635655',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47879,138,'Pogalur','635813',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47880,138,'Ponneri','635851',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47881,138,'Poongulam','635710',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47882,138,'Pudukottai','635602',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47883,138,'Pudupettai','635651',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47884,138,'Pudur Nadu','635655',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47885,138,'Pudur Vaniyambadi','635751',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47886,138,'Puliyur Tpt','635655',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47887,138,'Pullaneri','635851',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47888,138,'Puthagaram','635651',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47889,138,'Puttavaripalli','632603',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47890,138,'Rachamangalam','635653',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47891,138,'Rajakkal','635805',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47892,138,'Rajakuppam','635806',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47893,138,'Rajapalayam','635653',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47894,138,'Ramalai','632601',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47895,138,'Ramanaickenpettai','635801',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47896,138,'Reddiyur','635851',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47897,138,'Ruhsa Campus','632209',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47898,138,'Sathambakkam','635808',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47899,138,'Sathugudi','635810',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47900,138,'Sedukarai','635803',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47901,138,'Selandampalli','635653',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47902,138,'Sembedu','635813',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47903,138,'Sempalli','632604',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47904,138,'Sengundram','632601',1,0,'2022-03-03 12:44:09','2022-03-03 12:44:09'),(47905,138,'Sethubandai','635803',1,0,'2022-03-03 12:44:10','2022-03-03 12:44:10'),(47906,138,'Sevathur','635654',1,0,'2022-03-03 12:44:10','2022-03-03 12:44:10'),(47907,138,'Sevur','632601',1,0,'2022-03-03 12:44:10','2022-03-03 12:44:10'),(47908,138,'Shanankuppam','635814',1,0,'2022-03-03 12:44:10','2022-03-03 12:44:10'),(47909,138,'Simnapudur','635652',1,0,'2022-03-03 12:44:10','2022-03-03 12:44:10'),(47910,138,'Somalapuram','635802',1,0,'2022-03-03 12:44:10','2022-03-03 12:44:10'),(47911,138,'Somanaickenpatti','635851',1,0,'2022-03-03 12:44:10','2022-03-03 12:44:10'),(47912,138,'Sorakayalnatham','635854',1,0,'2022-03-03 12:44:10','2022-03-03 12:44:10'),(47913,138,'Sundarampalli','635654',1,0,'2022-03-03 12:44:10','2022-03-03 12:44:10'),(47914,138,'Thagarakuppam','635655',1,0,'2022-03-03 12:44:10','2022-03-03 12:44:10'),(47915,138,'Thattaparai','632601',1,0,'2022-03-03 12:44:10','2022-03-03 12:44:10'),(47916,138,'Thattimanapalli','632601',1,0,'2022-03-03 12:44:10','2022-03-03 12:44:10'),(47917,138,'Thekkupattu','635801',1,0,'2022-03-03 12:44:10','2022-03-03 12:44:10'),(47918,138,'Thennambattu','635802',1,0,'2022-03-03 12:44:10','2022-03-03 12:44:10'),(47919,138,'Thimmampet','635801',1,0,'2022-03-03 12:44:10','2022-03-03 12:44:10'),(47920,138,'Thimmanamuthur','635653',1,0,'2022-03-03 12:44:10','2022-03-03 12:44:10'),(47921,138,'Thokkiyam','635901',1,0,'2022-03-03 12:44:10','2022-03-03 12:44:10'),(47922,138,'Thollapalli','635804',1,0,'2022-03-03 12:44:10','2022-03-03 12:44:10'),(47923,138,'Thornampathy','635602',1,0,'2022-03-03 12:44:10','2022-03-03 12:44:10'),(47924,138,'Thottalam','635804',1,0,'2022-03-03 12:44:10','2022-03-03 12:44:10'),(47925,138,'Thottithuraimottur','635810',1,0,'2022-03-03 12:44:10','2022-03-03 12:44:10'),(47926,138,'Thumberi','635754',1,0,'2022-03-03 12:44:10','2022-03-03 12:44:10'),(47927,138,'Thuthipattu','635811',1,0,'2022-03-03 12:44:10','2022-03-03 12:44:10'),(47928,138,'Tippasamudram','635809',1,0,'2022-03-03 12:44:10','2022-03-03 12:44:10'),(47929,138,'Tiriyalam','635851',1,0,'2022-03-03 12:44:10','2022-03-03 12:44:10'),(47930,138,'Tirupattur Bazaar','635602',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47931,138,'Tirupattur Fort','635602',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47932,138,'Tirupattur H.O','635601',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47933,138,'Tirupattur TNHB','635601',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47934,138,'Udayamuthur','635652',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47935,138,'Udayendiram','635754',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47936,138,'Ulli','635813',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47937,138,'Vadacheri','635754',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47938,138,'Vadakkathipatti','635804',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47939,138,'Vadakkupattu','635801',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47940,138,'Vadapudupet','635812',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47941,138,'Vakkanampatti','635851',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47942,138,'Valathoor','635813',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47943,138,'Valayalkarapatti','635804',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47944,138,'Valayambattu','635751',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47945,138,'Vallipattu','635752',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47946,138,'Vaniyambadi R.S','635751',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47947,138,'Vaniyambadi','635751',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47948,138,'Varadareddipalli','632603',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47949,138,'Vasanthapuram','635701',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47950,138,'Veerichettipalli','632603',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47951,138,'Velakalnatham','635854',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47952,138,'Vellakuttai','635752',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47953,138,'Vengalapuram','635653',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47954,138,'Vengili','635812',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47955,138,'Venkatasamudram','635811',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47956,138,'Veppalnatham','635651',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47957,138,'Veppur','635803',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47958,138,'Vettapattu','635852',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47959,138,'Vettuvanam','635809',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47960,138,'Viludonpalayam','632603',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47961,138,'Vinnamangalam','635807',1,0,'2022-03-03 12:44:11','2022-03-03 12:44:11'),(47962,138,'Vishamangalam','635652',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47963,138,'Yelagiri Hills','635853',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47964,139,'Adanur','605402',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47965,139,'Adavallikuthan','604301',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47966,139,'Akkur','604207',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47967,139,'Akshipakkam','604101',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47968,139,'Alagrammam','604302',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47969,139,'Alampoondi','604151',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47970,139,'Alankuppam','604301',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47971,139,'Alathur','604303',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47972,139,'Anaiyeri','605201',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47973,139,'Anangur','605103',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47974,139,'Anangur','604203',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47975,139,'Ananthapuram','605201',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47976,139,'Anathur','604202',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47977,139,'Andapattu','604101',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47978,139,'Anilady','605651',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47979,139,'Annamangalam','604210',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47980,139,'Anniyur','605202',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47981,139,'Anumandai','604303',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47982,139,'Ariyalur Tirukkai','605402',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47983,139,'Arpisampalayam','605108',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47984,139,'Arugavur','604203',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47985,139,'Asokapuri','605203',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47986,139,'Asur','605652',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47987,139,'Athipakkam','604207',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47988,139,'Athipattu','604152',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47989,139,'Athiyur','605201',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47990,139,'Athiyur Thiruvadi','605401',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47991,139,'Attur','604307',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47992,139,'Auroville','605101',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47993,139,'Avadayarpattu','605652',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47994,139,'Avalurpet','604201',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47995,139,'Avanipur','604101',1,0,'2022-03-03 12:44:12','2022-03-03 12:44:12'),(47996,139,'Avarapakkam','604001',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(47997,139,'Aviyur','604203',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(47998,139,'Ayyanthoppu','604307',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(47999,139,'Ayyur Agaram','605601',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48000,139,'Brahmadesam','605203',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48001,139,'Brahmadesam (Villupuram)','604301',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48002,139,'Chellapiratti','604210',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48003,139,'Chendur','604302',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48004,139,'Chinnababusamudram','605102',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48005,139,'Chinnanerkunam','604302',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48006,139,'Chinthamani','605601',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48007,139,'Dadapuram','604207',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48008,139,'Devadanampettai','604151',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48009,139,'Devandavadi','604208',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48010,139,'Devanur','604208',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48011,139,'Eachur','604203',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48012,139,'Endiyur','604307',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48013,139,'Eraiyanur','604102',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48014,139,'Eraiyur','604304',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48015,139,'Eyyakunam','604204',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48016,139,'Eyyal','604204',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48017,139,'Gengarampalayam','605108',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48018,139,'Gingee Bazaar','604202',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48019,139,'Gingee','604202',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48020,139,'Guduvampoondi','604208',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48021,139,'Hemerjickx Cente','605111',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48022,139,'Idapattu','604201',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48023,139,'Illodu','604210',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48024,139,'Irumbai','605111',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48025,139,'Jayankondam','604202',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48026,139,'Kadali','604210',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48027,139,'Kadambur','604206',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48028,139,'Kadaperikuppam','605502',1,0,'2022-03-03 12:44:13','2022-03-03 12:44:13'),(48029,139,'Kakkanur','605402',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48030,139,'Kalaiyur','604206',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48031,139,'Kalayampoondi','605202',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48032,139,'Kallapattu','605108',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48033,139,'Kallapuliyur','604208',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48034,139,'Kalleri','604151',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48035,139,'Kallipattu','605105',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48036,139,'Kalpattu','605302',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48037,139,'Kaluperumbakkam','605014',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48038,139,'Kamala Nagar (Villupuram)','605602',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48039,139,'Kanai','605301',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48040,139,'Kanakkankuppam','604151',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48041,139,'Kandadu','604303',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48042,139,'Kandamangalam','605102',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48043,139,'Kandambakkam','605401',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48044,139,'Kandnamanadi','605401',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48045,139,'Kangiyanur','605302',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48046,139,'Kanjanur','605203',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48047,139,'Kappai','604205',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48048,139,'Kappalampadi','604201',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48049,139,'Kappiyampuliyur','605601',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48050,139,'Kappur','605301',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48051,139,'Karai','605201',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48052,139,'Karattai','604154',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48053,139,'Karnavur','604302',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48054,139,'Karuvakshi','605201',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48055,139,'Karuvampakkam','604207',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48056,139,'Katrambakkam','605109',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48057,139,'Kattalai','604307',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48058,139,'Kattusiviri','604207',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48059,139,'Kaveripakkam','604001',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48060,139,'Kedar','605402',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48061,139,'Kiladanur','604307',1,0,'2022-03-03 12:44:14','2022-03-03 12:44:14'),(48062,139,'Kiledayalam','604302',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48063,139,'Kilinjikuppam','605110',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48064,139,'Kiliyanur (Villupuram)','604102',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48065,139,'Kilmambattu','605651',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48066,139,'Kilmavilangai','604207',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48067,139,'Kilperumbakkam','605602',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48068,139,'Kilpudupattu','605014',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48069,139,'Kilsevur','604101',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48070,139,'Kilsirivi','604301',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48071,139,'Kodiyam','604207',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48072,139,'Kodukkur','605501',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48073,139,'Kolathur','604301',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48074,139,'Koliyanur','605103',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48075,139,'Kollar','604206',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48076,139,'Konai','604205',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48077,139,'Konalur','605201',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48078,139,'Kondangi','605301',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48079,139,'Kongarapattu','604306',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48080,139,'Konur','605301',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48081,139,'Korakeni','605501',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48082,139,'Kottapoondi','604201',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48083,139,'Kottayampoondi','605203',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48084,139,'Kovilporaiyur','604201',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48085,139,'Kumarakuppam','605108',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48086,139,'Kumulam','605107',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48087,139,'Kundalapuliyur','605203',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48088,139,'Kunimedu','604303',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48089,139,'Kunnapakkam','604101',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48090,139,'Kurunjipai','604205',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48091,139,'Kutteripattu','604302',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48092,139,'Lingareddpalayam','605107',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48093,139,'Madurapakkam','605501',1,0,'2022-03-03 12:44:15','2022-03-03 12:44:15'),(48094,139,'Mahadevimangalam','604210',1,0,'2022-03-03 12:44:16','2022-03-03 12:44:16'),(48095,139,'Maharajapuam','605602',1,0,'2022-03-03 12:44:16','2022-03-03 12:44:16'),(48096,139,'Mailam','604304',1,0,'2022-03-03 12:44:16','2022-03-03 12:44:16'),(48097,139,'Mambazhapattu','605302',1,0,'2022-03-03 12:44:16','2022-03-03 12:44:16'),(48098,139,'Manalapadi','604151',1,0,'2022-03-03 12:44:16','2022-03-03 12:44:16'),(48099,139,'Manandal','604204',1,0,'2022-03-03 12:44:16','2022-03-03 12:44:16'),(48100,139,'Mandagapet','605106',1,0,'2022-03-03 12:44:16','2022-03-03 12:44:16'),(48101,139,'Mandava','604303',1,0,'2022-03-03 12:44:16','2022-03-03 12:44:16'),(48102,139,'Maragadhapuram','605401',1,0,'2022-03-03 12:44:16','2022-03-03 12:44:16'),(48103,139,'Markanum','604303',1,0,'2022-03-03 12:44:16','2022-03-03 12:44:16'),(48104,139,'Markonam','604208',1,0,'2022-03-03 12:44:16','2022-03-03 12:44:16'),(48105,139,'Melacheri','604202',1,0,'2022-03-03 12:44:16','2022-03-03 12:44:16'),(48106,139,'Melakondai','605652',1,0,'2022-03-03 12:44:16','2022-03-03 12:44:16'),(48107,139,'Melathipakkam','604207',1,0,'2022-03-03 12:44:16','2022-03-03 12:44:16'),(48108,139,'Meledayalam','604202',1,0,'2022-03-03 12:44:16','2022-03-03 12:44:16'),(48109,139,'Melkaranai','605202',1,0,'2022-03-03 12:44:16','2022-03-03 12:44:16'),(48110,139,'Melmalayanur','604204',1,0,'2022-03-03 12:44:16','2022-03-03 12:44:16'),(48111,139,'Melmannur','604208',1,0,'2022-03-03 12:44:16','2022-03-03 12:44:16'),(48112,139,'Melolakkur','604203',1,0,'2022-03-03 12:44:16','2022-03-03 12:44:16'),(48113,139,'Melpathi','605103',1,0,'2022-03-03 12:44:16','2022-03-03 12:44:16'),(48114,139,'Melpettai','604307',1,0,'2022-03-03 12:44:16','2022-03-03 12:44:16'),(48115,139,'Melsevalambadi','604204',1,0,'2022-03-03 12:44:16','2022-03-03 12:44:16'),(48116,139,'Melsevur','604306',1,0,'2022-03-03 12:44:16','2022-03-03 12:44:16'),(48117,139,'Melsithamur','604206',1,0,'2022-03-03 12:44:16','2022-03-03 12:44:16'),(48118,139,'Melvailamur','604201',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48119,139,'Mettupalayam','605105',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48120,139,'Minambur','604205',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48121,139,'Modaiyur','604206',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48122,139,'Mokshakulam','605105',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48123,139,'Molasur','604102',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48124,139,'Morattandi','605101',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48125,139,'Mundiyambakkam','605601',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48126,139,'Munnur','604301',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48127,139,'Muppuli','604302',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48128,139,'Mutrampattu','605501',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48129,139,'Muttathur','605203',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48130,139,'Nadukuppam','604303',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48131,139,'Naduvanthangal','604207',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48132,139,'Nagar','604301',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48133,139,'Nallanpillaipetral','604152',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48134,139,'Nallathur','604307',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48135,139,'Nallavur','604154',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48136,139,'Nangathur','605202',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48137,139,'Nanndu','605301',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48138,139,'Naraiyur','605108',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48139,139,'Naranamangalam','604201',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48140,139,'Nayambadi','604151',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48141,139,'Nedimoliyanur','604306',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48142,139,'Negandur','605651',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48143,139,'Neganur','604202',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48144,139,'Nemur','605203',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48145,139,'Nochalur','604201',1,0,'2022-03-03 12:44:17','2022-03-03 12:44:17'),(48146,139,'Nolambur','604307',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48147,139,'Olagapuram','604154',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48148,139,'Olakkur','604305',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48149,139,'Olundiapet','605109',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48150,139,'Omandur','604102',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48151,139,'Omipper','604301',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48152,139,'Ongur','604307',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48153,139,'Orathur','605601',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48154,139,'Orukodi','605301',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48155,139,'P.Villiyanur','605105',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48156,139,'Padipallam','604151',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48157,139,'Padirapuliyur','604304',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48158,139,'Pakkam','604153',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48159,139,'Palakuppam','604302',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48160,139,'Palapadi','604153',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48161,139,'Palapattu','604205',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48162,139,'Palayam','605107',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48163,139,'Palliandur','605402',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48164,139,'Pallikulam','604203',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48165,139,'Pallineliyanur','605107',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48166,139,'Pallithennal','605102',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48167,139,'Panamalai','605201',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48168,139,'Panampattu','605103',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48169,139,'Panayapuram','605601',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48170,139,'Panchalam','604307',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48171,139,'Pankolathur','604101',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48172,139,'Pennangar','604210',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48173,139,'Peramandur','604302',1,0,'2022-03-03 12:44:18','2022-03-03 12:44:18'),(48174,139,'Perani','605651',1,0,'2022-03-03 12:44:19','2022-03-03 12:44:19'),(48175,139,'Periyababusamudram','605102',1,0,'2022-03-03 12:44:19','2022-03-03 12:44:19'),(48176,139,'Periyanmur','604151',1,0,'2022-03-03 12:44:19','2022-03-03 12:44:19'),(48177,139,'Periyanolambai','604204',1,0,'2022-03-03 12:44:19','2022-03-03 12:44:19'),(48178,139,'Periyathatchur','605651',1,0,'2022-03-03 12:44:19','2022-03-03 12:44:19'),(48179,139,'Perumbakkam','604304',1,0,'2022-03-03 12:44:19','2022-03-03 12:44:19'),(48180,139,'Perumbakkam','605301',1,0,'2022-03-03 12:44:19','2022-03-03 12:44:19'),(48181,139,'Perumukkal','604301',1,0,'2022-03-03 12:44:19','2022-03-03 12:44:19'),(48182,139,'Perungappur','604151',1,0,'2022-03-03 12:44:19','2022-03-03 12:44:19'),(48183,139,'Peruvalur','604208',1,0,'2022-03-03 12:44:19','2022-03-03 12:44:19'),(48184,139,'Pidagam','605401',1,0,'2022-03-03 12:44:19','2022-03-03 12:44:19'),(48185,139,'Pidaripattu','605651',1,0,'2022-03-03 12:44:19','2022-03-03 12:44:19'),(48186,139,'Pillur','605103',1,0,'2022-03-03 12:44:19','2022-03-03 12:44:19'),(48187,139,'Pombur','605652',1,0,'2022-03-03 12:44:19','2022-03-03 12:44:19'),(48188,139,'Ponnankuppam','605201',1,0,'2022-03-03 12:44:19','2022-03-03 12:44:19'),(48189,139,'Poothurai','605111',1,0,'2022-03-03 12:44:19','2022-03-03 12:44:19'),(48190,139,'Poovarasankuppam','605105',1,0,'2022-03-03 12:44:19','2022-03-03 12:44:19'),(48191,139,'Porur','605202',1,0,'2022-03-03 12:44:19','2022-03-03 12:44:19'),(48192,139,'Poyyapakkam','605103',1,0,'2022-03-03 12:44:19','2022-03-03 12:44:19'),(48193,139,'Pudupakkam','604303',1,0,'2022-03-03 12:44:19','2022-03-03 12:44:19'),(48194,139,'Pulichapllam','605109',1,0,'2022-03-03 12:44:19','2022-03-03 12:44:19'),(48195,139,'Radhhapuram','605501',1,0,'2022-03-03 12:44:19','2022-03-03 12:44:19'),(48196,139,'Rampakkam','605105',1,0,'2022-03-03 12:44:19','2022-03-03 12:44:19'),(48197,139,'Rayapudupakkam','605111',1,0,'2022-03-03 12:44:19','2022-03-03 12:44:19'),(48198,139,'Rettanai','604306',1,0,'2022-03-03 12:44:19','2022-03-03 12:44:19'),(48199,139,'Salamedu','605401',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48200,139,'Salayampalayam','605108',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48201,139,'Sangeethamangalam','605202',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48202,139,'Santhanagopalapuram','605602',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48203,139,'Saram ( Tindivanam )','604307',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48204,139,'Sathambadi','604204',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48205,139,'Sathyamagalam','604153',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48206,139,'Se.Kunnatur','605651',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48207,139,'Semangalam','605109',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48208,139,'Semmedu','604153',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48209,139,'Sepettai','604152',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48210,139,'Serndanur','605103',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48211,139,'Seshangur','605501',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48212,139,'Sevalapuri','604202',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48213,139,'Sholangunam','604210',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48214,139,'Singanur','604302',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48215,139,'Siruthalaipoondi','604204',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48216,139,'Siruvadi','604301',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48217,139,'Siruvalai','605402',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48218,139,'Sithani','605652',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48219,139,'Sokuppam','604153',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48220,139,'T.Mettupalayam','605601',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48221,139,'T.Pudupalayam','605652',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48222,139,'Teli','605302',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48223,139,'Thadagam','604152',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48224,139,'Thailapuram','604102',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48225,139,'Thaiyur','604205',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48226,139,'Thalangadu','604303',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48227,139,'Thalangunam','604201',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48228,139,'Thalavanur','604205',1,0,'2022-03-03 12:44:20','2022-03-03 12:44:20'),(48229,139,'Thaludali','604304',1,0,'2022-03-03 12:44:21','2022-03-03 12:44:21'),(48230,139,'Thamanur','604210',1,0,'2022-03-03 12:44:21','2022-03-03 12:44:21'),(48231,139,'Thandavasamudram','604151',1,0,'2022-03-03 12:44:21','2022-03-03 12:44:21'),(48232,139,'Thaniyal','604207',1,0,'2022-03-03 12:44:21','2022-03-03 12:44:21'),(48233,139,'Thayanur','604204',1,0,'2022-03-03 12:44:21','2022-03-03 12:44:21'),(48234,139,'Thenkalavoy','604302',1,0,'2022-03-03 12:44:21','2022-03-03 12:44:21'),(48235,139,'Thenkodipakkam','604102',1,0,'2022-03-03 12:44:21','2022-03-03 12:44:21'),(48236,139,'Thenpalai','604151',1,0,'2022-03-03 12:44:21','2022-03-03 12:44:21'),(48237,139,'Thenpasiyar','604302',1,0,'2022-03-03 12:44:21','2022-03-03 12:44:21'),(48238,139,'Thenputhur','604306',1,0,'2022-03-03 12:44:21','2022-03-03 12:44:21'),(48239,139,'Thensiruvalur','604102',1,0,'2022-03-03 12:44:21','2022-03-03 12:44:21'),(48240,139,'Theppirampattu','604204',1,0,'2022-03-03 12:44:21','2022-03-03 12:44:21'),(48241,139,'Thiruvamathr','605402',1,0,'2022-03-03 12:44:21','2022-03-03 12:44:21'),(48242,139,'Thiruvampattu','604205',1,0,'2022-03-03 12:44:21','2022-03-03 12:44:21'),(48243,139,'Thiruvathikunnam','604205',1,0,'2022-03-03 12:44:21','2022-03-03 12:44:21'),(48244,139,'Thiurvakkarai','604304',1,0,'2022-03-03 12:44:21','2022-03-03 12:44:21'),(48245,139,'Thorapadi','604204',1,0,'2022-03-03 12:44:21','2022-03-03 12:44:21'),(48246,139,'Thoravi','605601',1,0,'2022-03-03 12:44:21','2022-03-03 12:44:21'),(48247,139,'Tindivanam Bazaar','604001',1,0,'2022-03-03 12:44:21','2022-03-03 12:44:21'),(48248,139,'Tindivanam East','604001',1,0,'2022-03-03 12:44:21','2022-03-03 12:44:21'),(48249,139,'Tindivanam H.O','604001',1,0,'2022-03-03 12:44:21','2022-03-03 12:44:21'),(48250,139,'Tindivanam West','604001',1,0,'2022-03-03 12:44:21','2022-03-03 12:44:21'),(48251,139,'Tiruchitambalam','605111',1,0,'2022-03-03 12:44:21','2022-03-03 12:44:21'),(48252,139,'Tirumangalam','605501',1,0,'2022-03-03 12:44:21','2022-03-03 12:44:21'),(48253,139,'Tirupachanur','605103',1,0,'2022-03-03 12:44:21','2022-03-03 12:44:21'),(48254,139,'Tivanur','604206',1,0,'2022-03-03 12:44:21','2022-03-03 12:44:21'),(48255,139,'Ural','604307',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48256,139,'V.Budur','605108',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48257,139,'V.Marudur','605602',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48258,139,'V.Mathur','605201',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48259,139,'V.Mathur','605107',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48260,139,'V.Nallalam','605651',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48261,139,'V.Nerkunam','605501',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48262,139,'V.Parangani','605109',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48263,139,'V.Salai','605652',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48264,139,'V.Sathanur','605652',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48265,139,'Vadanerkunam','604301',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48266,139,'Vadapalai','604204',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48267,139,'Vaidapakkam','604301',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48268,139,'Vairapuram','604207',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48269,139,'Vakkur','605501',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48270,139,'Valathi','604208',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48271,139,'Valavanur','605108',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48272,139,'Vallam','604206',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48273,139,'Valudareddy','605401',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48274,139,'Valudavur','605502',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48275,139,'Vanur','605109',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48276,139,'Velanthangal','604152',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48277,139,'Veliyanur','604304',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48278,139,'Vellimeudpettai','604207',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48279,139,'Velur (SA)','604154',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48280,139,'Vembi','605203',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48281,139,'Vengandur','604306',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48282,139,'Vengandur','605402',1,0,'2022-03-03 12:44:22','2022-03-03 12:44:22'),(48283,139,'Venkatadri  Agaram','605105',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48284,139,'Vidur','605652',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48285,139,'Vidur Dam','605652',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48286,139,'Vikravandi R.S.','605652',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48287,139,'Vikravandi','605652',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48288,139,'Villupuram Collectorate','605602',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48289,139,'Villupuram East','605602',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48290,139,'Villupuram H.O','605602',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48291,139,'Villupuram West','605602',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48292,139,'Vilukkam','604206',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48293,139,'Viramur','605402',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48294,139,'Viranam','605106',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48295,139,'Viranamur','604203',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48296,139,'Anathur','607101',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48297,139,'Melthaniyalampattu','607101',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48298,139,'Odappankuppam','607805',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48299,139,'Somasipalayam','607101',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48300,139,'Adaiyur','607201',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48301,139,'Adhanur','606102',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48302,139,'Adichanur','605758',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48303,139,'Agarakottalam','606213',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48304,139,'Aladi','606115',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48305,139,'Alambadi','605701',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48306,139,'Alathur','606208',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48307,139,'Ammaiagaram','606201',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48308,139,'Ammakalathur','606204',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48309,139,'Amur','607209',1,0,'2022-03-03 12:44:23','2022-03-03 12:44:23'),(48310,139,'Andrayanur','605803',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48311,139,'Anganur','606107',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48312,139,'Anumanandal','606301',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48313,139,'Arakandanallur','605752',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48314,139,'Arampoondi','606209',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48315,139,'Arasampattu','606401',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48316,139,'Arasur','607107',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48317,139,'Arcadu','605755',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48318,139,'Ariyalur (Villupuram)','605801',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48319,139,'Ariyur (Villupuram)','605751',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48320,139,'Arulavadi','605755',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48321,139,'Arumpattu','607107',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48322,139,'Arunkurukkai','605803',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48323,139,'Arur','606402',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48324,139,'Aruthangudi','605766',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48325,139,'Asakalathur','606204',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48326,139,'Asanur','606305',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48327,139,'Athiyur Thirukkai','605701',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48328,139,'Attur','606102',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48329,139,'Ayandur','605755',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48330,139,'B. Arulambadi','605702',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48331,139,'Brammakundam','605702',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48332,139,'C Meyyur','605803',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48333,139,'Chellampattu','606207',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48334,139,'Chinnasalem','606201',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48335,139,'Cholampattu','606208',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48336,139,'Cholavandipuram','605751',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48337,139,'Dagamtheerthapuram','606201',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48338,139,'Devanur','605752',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48339,139,'Devaradiyarkuppam','605754',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48340,139,'Deviagaram','605766',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48341,139,'Edaikkal','606107',1,0,'2022-03-03 12:44:24','2022-03-03 12:44:24'),(48342,139,'Edapalayam','605803',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48343,139,'Eduthanur','605802',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48344,139,'Eduthavainatham','606207',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48345,139,'Elavanasur','607202',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48346,139,'Elayanarkuppam','605802',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48347,139,'Ellaigramam','607201',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48348,139,'Elrampattu','605803',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48349,139,'Emappur','607203',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48350,139,'Enathimangalam','607107',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48351,139,'Endal','605801',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48352,139,'Eraiyur (Villupuram)','607201',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48353,139,'Eranji','606305',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48354,139,'Eruvaipattinam','606207',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48355,139,'Eruvelipattu','607107',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48356,139,'Eswarakandanallur','607204',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48357,139,'Eyyanur','606204',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48358,139,'Gramam','607203',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48359,139,'Gurupeedapuram','606305',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48360,139,'Innadu','606209',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48361,139,'Iriyur','606204',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48362,139,'Irudayampattu','605702',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48363,139,'Irulakurichi','606115',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48364,139,'Irundai','607204',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48365,139,'Jambai','605754',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48366,139,'K.Alambalam','606213',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48367,139,'Kachirapalayam','606207',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48368,139,'Kadaganur','605755',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48369,139,'Kadambur (Villupuram)','605802',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48370,139,'Kaduvanur','605801',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48371,139,'Kalamarudur','606102',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48372,139,'Kallakurichi H.O','606202',1,0,'2022-03-03 12:44:25','2022-03-03 12:44:25'),(48373,139,'Kallakurichi South','606213',1,0,'2022-03-03 12:44:26','2022-03-03 12:44:26'),(48374,139,'Kanaiyar','606107',1,0,'2022-03-03 12:44:26','2022-03-03 12:44:26'),(48375,139,'Kandachipuram','605701',1,0,'2022-03-03 12:44:26','2022-03-03 12:44:26'),(48376,139,'Kangeyanur','605754',1,0,'2022-03-03 12:44:26','2022-03-03 12:44:26'),(48377,139,'Kaniyamur','606201',1,0,'2022-03-03 12:44:26','2022-03-03 12:44:26'),(48378,139,'Kannarampattu','607203',1,0,'2022-03-03 12:44:26','2022-03-03 12:44:26'),(48379,139,'Karadi','605766',1,0,'2022-03-03 12:44:26','2022-03-03 12:44:26'),(48380,139,'Karadichittur','606207',1,0,'2022-03-03 12:44:26','2022-03-03 12:44:26'),(48381,139,'Karanai','605755',1,0,'2022-03-03 12:44:26','2022-03-03 12:44:26'),(48382,139,'Kariyalur','606209',1,0,'2022-03-03 12:44:26','2022-03-03 12:44:26'),(48383,139,'Karunthalakurichi','606301',1,0,'2022-03-03 12:44:26','2022-03-03 12:44:26'),(48384,139,'Kattu Edaiyur','605751',1,0,'2022-03-03 12:44:26','2022-03-03 12:44:26'),(48385,139,'Kattupaiyur','605766',1,0,'2022-03-03 12:44:26','2022-03-03 12:44:26'),(48386,139,'Kazhumalam','605754',1,0,'2022-03-03 12:44:26','2022-03-03 12:44:26'),(48387,139,'Keelathalanur','605766',1,0,'2022-03-03 12:44:26','2022-03-03 12:44:26'),(48388,139,'Kilakkadu','606401',1,0,'2022-03-03 12:44:26','2022-03-03 12:44:26'),(48389,139,'Kilapattu','606208',1,0,'2022-03-03 12:44:26','2022-03-03 12:44:26'),(48390,139,'Kiliyur','606102',1,0,'2022-03-03 12:44:26','2022-03-03 12:44:26'),(48391,139,'Kizakkumarudur','607204',1,0,'2022-03-03 12:44:26','2022-03-03 12:44:26'),(48392,139,'Kodumathi','606209',1,0,'2022-03-03 12:44:26','2022-03-03 12:44:26'),(48393,139,'Komalur','606205',1,0,'2022-03-03 12:44:26','2022-03-03 12:44:26'),(48394,139,'Kongarayanur','607203',1,0,'2022-03-03 12:44:26','2022-03-03 12:44:26'),(48395,139,'Kongarayapalayam','606203',1,0,'2022-03-03 12:44:26','2022-03-03 12:44:26'),(48396,139,'Koo-kallakurichi','606115',1,0,'2022-03-03 12:44:26','2022-03-03 12:44:26'),(48397,139,'Koothakudi','606305',1,0,'2022-03-03 12:44:26','2022-03-03 12:44:26'),(48398,139,'Kosapadi','606401',1,0,'2022-03-03 12:44:26','2022-03-03 12:44:26'),(48399,139,'Kottamarudur','605756',1,0,'2022-03-03 12:44:27','2022-03-03 12:44:27'),(48400,139,'Kottapudur','606209',1,0,'2022-03-03 12:44:27','2022-03-03 12:44:27'),(48401,139,'Kudiraichandal','606213',1,0,'2022-03-03 12:44:27','2022-03-03 12:44:27'),(48402,139,'Kugaiyur','606301',1,0,'2022-03-03 12:44:27','2022-03-03 12:44:27'),(48403,139,'Kuladeepamangalam','605756',1,0,'2022-03-03 12:44:27','2022-03-03 12:44:27'),(48404,139,'Kuvadu','607201',1,0,'2022-03-03 12:44:27','2022-03-03 12:44:27'),(48405,139,'Kuvagam','606102',1,0,'2022-03-03 12:44:27','2022-03-03 12:44:27'),(48406,139,'Kuvanur','605766',1,0,'2022-03-03 12:44:27','2022-03-03 12:44:27'),(48407,139,'La- Gudalur','606205',1,0,'2022-03-03 12:44:27','2022-03-03 12:44:27'),(48408,139,'Lakkinayakkanpatti','606402',1,0,'2022-03-03 12:44:27','2022-03-03 12:44:27'),(48409,139,'Madam','605766',1,0,'2022-03-03 12:44:27','2022-03-03 12:44:27'),(48410,139,'Madapattu','607204',1,0,'2022-03-03 12:44:27','2022-03-03 12:44:27'),(48411,139,'Madavacherry','606207',1,0,'2022-03-03 12:44:27','2022-03-03 12:44:27'),(48412,139,'Madhur','606209',1,0,'2022-03-03 12:44:27','2022-03-03 12:44:27'),(48413,139,'Madiyanur','606107',1,0,'2022-03-03 12:44:27','2022-03-03 12:44:27'),(48414,139,'Madur','606206',1,0,'2022-03-03 12:44:27','2022-03-03 12:44:27'),(48415,139,'Maiyanur','605801',1,0,'2022-03-03 12:44:27','2022-03-03 12:44:27'),(48416,139,'Ma-kunnathur','606102',1,0,'2022-03-03 12:44:27','2022-03-03 12:44:27'),(48417,139,'Malaikottalam','606203',1,0,'2022-03-03 12:44:27','2022-03-03 12:44:27'),(48418,139,'Malavanthangal','605701',1,0,'2022-03-03 12:44:27','2022-03-03 12:44:27'),(48419,139,'Maligaimedu','606204',1,0,'2022-03-03 12:44:27','2022-03-03 12:44:27'),(48420,139,'Malliyapadi','606207',1,0,'2022-03-03 12:44:27','2022-03-03 12:44:27'),(48421,139,'Manakuppam','607209',1,0,'2022-03-03 12:44:27','2022-03-03 12:44:27'),(48422,139,'Manalurpet','605754',1,0,'2022-03-03 12:44:27','2022-03-03 12:44:27'),(48423,139,'Manampoondi','605759',1,0,'2022-03-03 12:44:27','2022-03-03 12:44:27'),(48424,139,'Mandagapadi','606205',1,0,'2022-03-03 12:44:27','2022-03-03 12:44:27'),(48425,139,'Mangalam (SA)','606104',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48426,139,'Maniyampalayam','606209',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48427,139,'Manjaputhur','606208',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48428,139,'Manmalai','606207',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48429,139,'Marangiyur','607203',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48430,139,'Mathur','606207',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48431,139,'Mattaparai','606207',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48432,139,'Melnariyappanur','606201',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48433,139,'Melsiruvallur','605702',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48434,139,'Melur','606201',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48435,139,'Melvalai','605701',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48436,139,'Memalur','605751',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48437,139,'Michaelpuram','605702',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48438,139,'Mogaiyur','605755',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48439,139,'Mookanur','606402',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48440,139,'Moolasamudram','606107',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48441,139,'Moongilpadi','606201',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48442,139,'Mottampatti','606401',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48443,139,'Mudiyanur','606203',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48444,139,'Mukhasaparur','606104',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48445,139,'Mundiyur','606209',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48446,139,'Munivalai','606205',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48447,139,'Murarbad','606208',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48448,139,'Murukkambadi','605754',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48449,139,'Nagalur','606203',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48450,139,'Nainarpalayam','606301',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48451,139,'Nallapalayam','605701',1,0,'2022-03-03 12:44:28','2022-03-03 12:44:28'),(48452,139,'Nallathur','606213',1,0,'2022-03-03 12:44:29','2022-03-03 12:44:29'),(48453,139,'Nannaram','606102',1,0,'2022-03-03 12:44:29','2022-03-03 12:44:29'),(48454,139,'Nathamur','606102',1,0,'2022-03-03 12:44:29','2022-03-03 12:44:29'),(48455,139,'Nedumanur','606208',1,0,'2022-03-03 12:44:29','2022-03-03 12:44:29'),(48456,139,'Neelamangalam','606213',1,0,'2022-03-03 12:44:29','2022-03-03 12:44:29'),(48457,139,'Ninnaiyur','606305',1,0,'2022-03-03 12:44:29','2022-03-03 12:44:29'),(48458,139,'Nochimedu','606209',1,0,'2022-03-03 12:44:29','2022-03-03 12:44:29'),(48459,139,'Nurolai','606205',1,0,'2022-03-03 12:44:29','2022-03-03 12:44:29'),(48460,139,'Oddampattu','605758',1,0,'2022-03-03 12:44:29','2022-03-03 12:44:29'),(48461,139,'Odiyathur','605701',1,0,'2022-03-03 12:44:29','2022-03-03 12:44:29'),(48462,139,'Olagankathan','606213',1,0,'2022-03-03 12:44:29','2022-03-03 12:44:29'),(48463,139,'Olagiyanallur','606204',1,0,'2022-03-03 12:44:29','2022-03-03 12:44:29'),(48464,139,'Orathur','606102',1,0,'2022-03-03 12:44:29','2022-03-03 12:44:29'),(48465,139,'Padiyandal','605751',1,0,'2022-03-03 12:44:29','2022-03-03 12:44:29'),(48466,139,'Padur','606115',1,0,'2022-03-03 12:44:29','2022-03-03 12:44:29'),(48467,139,'Paithanthurai','606201',1,0,'2022-03-03 12:44:29','2022-03-03 12:44:29'),(48468,139,'Paiyur','607203',1,0,'2022-03-03 12:44:29','2022-03-03 12:44:29'),(48469,139,'Pakkam','605801',1,0,'2022-03-03 12:44:29','2022-03-03 12:44:29'),(48470,139,'Pakkampadi','606301',1,0,'2022-03-03 12:44:29','2022-03-03 12:44:29'),(48471,139,'Palakollai','606115',1,0,'2022-03-03 12:44:29','2022-03-03 12:44:29'),(48472,139,'Palayasiruvangur','606206',1,0,'2022-03-03 12:44:29','2022-03-03 12:44:29'),(48473,139,'Pallagacherry','606206',1,0,'2022-03-03 12:44:29','2022-03-03 12:44:29'),(48474,139,'Pallavadi','607201',1,0,'2022-03-03 12:44:29','2022-03-03 12:44:29'),(48475,139,'Pandalam (Villupuram)','606402',1,0,'2022-03-03 12:44:29','2022-03-03 12:44:29'),(48476,139,'Pandiyankuppam','606201',1,0,'2022-03-03 12:44:29','2022-03-03 12:44:29'),(48477,139,'Pandur','606102',1,0,'2022-03-03 12:44:29','2022-03-03 12:44:29'),(48478,139,'Paranur','605755',1,0,'2022-03-03 12:44:30','2022-03-03 12:44:30'),(48479,139,'Parikkal','607204',1,0,'2022-03-03 12:44:30','2022-03-03 12:44:30'),(48480,139,'Parindal','606305',1,0,'2022-03-03 12:44:30','2022-03-03 12:44:30'),(48481,139,'Pasar','606205',1,0,'2022-03-03 12:44:30','2022-03-03 12:44:30'),(48482,139,'Pavandur','607209',1,0,'2022-03-03 12:44:30','2022-03-03 12:44:30'),(48483,139,'Pazhangur','605751',1,0,'2022-03-03 12:44:30','2022-03-03 12:44:30'),(48484,139,'Peelamedu','606206',1,0,'2022-03-03 12:44:30','2022-03-03 12:44:30'),(48485,139,'Perangiyur','607107',1,0,'2022-03-03 12:44:30','2022-03-03 12:44:30'),(48486,139,'Periyakolliyur','605801',1,0,'2022-03-03 12:44:30','2022-03-03 12:44:30'),(48487,139,'Periyakuppam','607204',1,0,'2022-03-03 12:44:30','2022-03-03 12:44:30'),(48488,139,'Periyakurukkai','607201',1,0,'2022-03-03 12:44:30','2022-03-03 12:44:30'),(48489,139,'Periyamampattu','606206',1,0,'2022-03-03 12:44:30','2022-03-03 12:44:30'),(48490,139,'Periyasevalai','607209',1,0,'2022-03-03 12:44:30','2022-03-03 12:44:30'),(48491,139,'Perumangalam','606204',1,0,'2022-03-03 12:44:30','2022-03-03 12:44:30'),(48492,139,'Perumbakkam','607204',1,0,'2022-03-03 12:44:30','2022-03-03 12:44:30'),(48493,139,'Perumbur','606401',1,0,'2022-03-03 12:44:30','2022-03-03 12:44:30'),(48494,139,'Pethanur','606201',1,0,'2022-03-03 12:44:30','2022-03-03 12:44:30'),(48495,139,'Pilrampattu','605701',1,0,'2022-03-03 12:44:30','2022-03-03 12:44:30'),(48496,139,'Pinnalavadi','607202',1,0,'2022-03-03 12:44:30','2022-03-03 12:44:30'),(48497,139,'Pootai','606401',1,0,'2022-03-03 12:44:30','2022-03-03 12:44:30'),(48498,139,'Porasakurichi','606203',1,0,'2022-03-03 12:44:30','2022-03-03 12:44:30'),(48499,139,'Porasapattu','605702',1,0,'2022-03-03 12:44:30','2022-03-03 12:44:30'),(48500,139,'Pottiyam','606207',1,0,'2022-03-03 12:44:30','2022-03-03 12:44:30'),(48501,139,'Pounjipattu','605702',1,0,'2022-03-03 12:44:30','2022-03-03 12:44:30'),(48502,139,'Poykunam','606401',1,0,'2022-03-03 12:44:30','2022-03-03 12:44:30'),(48503,139,'Prithivimangalam','606206',1,0,'2022-03-03 12:44:30','2022-03-03 12:44:30'),(48504,139,'Pu.Mambakkam','606107',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48505,139,'Pudu Uchimedu','606203',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48506,139,'Pudupalapattu','606401',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48507,139,'Pudupattu','606402',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48508,139,'Pugaipatti','607202',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48509,139,'Pu-killanur','606107',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48510,139,'Pukkiravari','606204',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48511,139,'Pu-konalavadi','606107',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48512,139,'Puliyur','606107',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48513,139,'Pu-malayanur','607202',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48514,139,'Puthirampattu','606402',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48515,139,'Rangappanur','606402',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48516,139,'Ravathanallur','606402',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48517,139,'Rishivandiyam','606205',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48518,139,'S. Naraiyur','606301',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48519,139,'S. Ohaiyur','606204',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48520,139,'S.Kodungal','605755',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48521,139,'S.Kolathur','606402',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48522,139,'Sangiyam','605754',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48523,139,'Sankarapuram (Villupuram)','606401',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48524,139,'Santhapettai','605766',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48525,139,'Saravanapakkam','607209',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48526,139,'Sathaputhur','606205',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48527,139,'Sathiyakandanur','605755',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48528,139,'Seedevi','606205',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48529,139,'Sembiamadevi','607202',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48530,139,'Semmanangur','606107',1,0,'2022-03-03 12:44:31','2022-03-03 12:44:31'),(48531,139,'Semmar','607107',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48532,139,'Sendamangalam','607204',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48533,139,'Sendanadu','607204',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48534,139,'Senkurichi','606115',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48535,139,'Sennakunam','605755',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48536,139,'Serapattu','606401',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48537,139,'Sethuvarayankuppam','606203',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48538,139,'Sikkadu','606205',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48539,139,'Sirpadanallur','605802',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48540,139,'Sirpanandal','605802',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48541,139,'Sirumadurai','607203',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48542,139,'Siruvangur','606213',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48543,139,'Siruvathur','606201',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48544,139,'Sithalingamadam','605803',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48545,139,'Sithalur','606206',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48546,139,'Sithanangur','607107',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48547,139,'Sithathur','605701',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48548,139,'Somandargudi','606213',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48549,139,'Soundaravallipalayam','606401',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48550,139,'Sulankurichi','606206',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48551,139,'T  . Edayar','607203',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48552,139,'T  . Kolathur','607209',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48553,139,'T  . Kunnathur','605803',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48554,139,'T  . Pudupalayam','605803',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48555,139,'T Athipakkam','605766',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48556,139,'T.Mavidanthal','606305',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48557,139,'Thachur','606213',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48558,139,'Thaduthatkondur','607203',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48559,139,'Thagadi','605766',1,0,'2022-03-03 12:44:32','2022-03-03 12:44:32'),(48560,139,'Thandalai','606213',1,0,'2022-03-03 12:44:33','2022-03-03 12:44:33'),(48561,139,'Thapovanam','605756',1,0,'2022-03-03 12:44:33','2022-03-03 12:44:33'),(48562,139,'Thekkampattu','606401',1,0,'2022-03-03 12:44:33','2022-03-03 12:44:33'),(48563,139,'Thengiyanatham','606201',1,0,'2022-03-03 12:44:33','2022-03-03 12:44:33'),(48564,139,'Thenkeeranur','606213',1,0,'2022-03-03 12:44:33','2022-03-03 12:44:33'),(48565,139,'Thensiruvalur','606204',1,0,'2022-03-03 12:44:33','2022-03-03 12:44:33'),(48566,139,'Thenthorasalur','606204',1,0,'2022-03-03 12:44:33','2022-03-03 12:44:33'),(48567,139,'Tholuvanthangal','605801',1,0,'2022-03-03 12:44:33','2022-03-03 12:44:33'),(48568,139,'Thottapadi','606301',1,0,'2022-03-03 12:44:33','2022-03-03 12:44:33'),(48569,139,'Thottiyam','606201',1,0,'2022-03-03 12:44:33','2022-03-03 12:44:33'),(48570,139,'Throadipattu','606209',1,0,'2022-03-03 12:44:33','2022-03-03 12:44:33'),(48571,139,'Timmalai','606206',1,0,'2022-03-03 12:44:33','2022-03-03 12:44:33'),(48572,139,'Tirukkoyilur Bazaar','605757',1,0,'2022-03-03 12:44:33','2022-03-03 12:44:33'),(48573,139,'Tirukkoyilur H.O','605757',1,0,'2022-03-03 12:44:33','2022-03-03 12:44:33'),(48574,139,'Tirunavalur','607204',1,0,'2022-03-03 12:44:33','2022-03-03 12:44:33'),(48575,139,'Tiruppalapandal','605766',1,0,'2022-03-03 12:44:33','2022-03-03 12:44:33'),(48576,139,'Tiruppayar','606305',1,0,'2022-03-03 12:44:33','2022-03-03 12:44:33'),(48577,139,'Tiruvarangam','605802',1,0,'2022-03-03 12:44:33','2022-03-03 12:44:33'),(48578,139,'Tiruvennainallur','607203',1,0,'2022-03-03 12:44:33','2022-03-03 12:44:33'),(48579,139,'Tiyagadrug','606206',1,0,'2022-03-03 12:44:33','2022-03-03 12:44:33'),(48580,139,'Tiyagai','606206',1,0,'2022-03-03 12:44:33','2022-03-03 12:44:33'),(48581,139,'Ulundurpet Busstand','606107',1,0,'2022-03-03 12:44:33','2022-03-03 12:44:33'),(48582,139,'Ulundurpet','606107',1,0,'2022-03-03 12:44:33','2022-03-03 12:44:33'),(48583,139,'Uppur','606209',1,0,'2022-03-03 12:44:33','2022-03-03 12:44:33'),(48584,139,'V  Alambalam','606301',1,0,'2022-03-03 12:44:33','2022-03-03 12:44:33'),(48585,139,'V  Mamandur','606301',1,0,'2022-03-03 12:44:33','2022-03-03 12:44:33'),(48586,139,'V . Puthur','605752',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48587,139,'Vadakaraithayanur','605752',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48588,139,'Vadakkanandal','606207',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48589,139,'Vadamarudur','605803',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48590,139,'Vadaponparappi','605702',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48591,139,'Vadathorasalur','606206',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48592,139,'Valayampattu','607107',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48593,139,'Vanampattu','607204',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48594,139,'Vanjikuli','606401',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48595,139,'Varanjaram','606203',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48596,139,'Vasanthakrishnapuram','605758',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48597,139,'Vazhapadi','606209',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48598,139,'Veeracholapuram','606206',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48599,139,'Vellaiyur','606107',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48600,139,'Vellarikadu','606401',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48601,139,'Vellimalai','606209',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48602,139,'Velur','606102',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48603,139,'Vengaivadi','606206',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48604,139,'Vengamur','605701',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48605,139,'Vengodu','606401',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48606,139,'Vengur','605751',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48607,139,'Venkatampettai','606207',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48608,139,'Vettiperumalagaram','606201',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48609,139,'Vilakkur','606206',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48610,139,'Vilambar','606213',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48611,139,'Vilandai','605756',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48612,139,'Virapandi','605758',1,0,'2022-03-03 12:44:34','2022-03-03 12:44:34'),(48613,139,'Viriyur','606402',1,0,'2022-03-03 12:44:35','2022-03-03 12:44:35'),(48614,139,'Virugavur','606203',1,0,'2022-03-03 12:44:35','2022-03-03 12:44:35'),(48615,140,'A.Ramalingapuram','626203',1,0,'2022-03-03 12:44:35','2022-03-03 12:44:35'),(48616,140,'Achankulam','626141',1,0,'2022-03-03 12:44:35','2022-03-03 12:44:35'),(48617,140,'Achanthavirthan','626137',1,0,'2022-03-03 12:44:35','2022-03-03 12:44:35'),(48618,140,'Aladipatti','626129',1,0,'2022-03-03 12:44:35','2022-03-03 12:44:35'),(48619,140,'Alagapuri','626607',1,0,'2022-03-03 12:44:35','2022-03-03 12:44:35'),(48620,140,'Alagianallur','626109',1,0,'2022-03-03 12:44:35','2022-03-03 12:44:35'),(48621,140,'Alamarathupatti','626130',1,0,'2022-03-03 12:44:35','2022-03-03 12:44:35'),(48622,140,'Alangulam','626127',1,0,'2022-03-03 12:44:35','2022-03-03 12:44:35'),(48623,140,'Allalaperi','626106',1,0,'2022-03-03 12:44:35','2022-03-03 12:44:35'),(48624,140,'Amanakkunatham','626112',1,0,'2022-03-03 12:44:35','2022-03-03 12:44:35'),(48625,140,'Amathur','626005',1,0,'2022-03-03 12:44:35','2022-03-03 12:44:35'),(48626,140,'Anaikulam','626129',1,0,'2022-03-03 12:44:35','2022-03-03 12:44:35'),(48627,140,'Anaikuttam','626130',1,0,'2022-03-03 12:44:35','2022-03-03 12:44:35'),(48628,140,'Anaiyur','626124',1,0,'2022-03-03 12:44:35','2022-03-03 12:44:35'),(48629,140,'Anuppankulam','626189',1,0,'2022-03-03 12:44:35','2022-03-03 12:44:35'),(48630,140,'Appayanaickenpatti','626127',1,0,'2022-03-03 12:44:35','2022-03-03 12:44:35'),(48631,140,'Appayanaickenpatti','626204',1,0,'2022-03-03 12:44:35','2022-03-03 12:44:35'),(48632,140,'Appayanaickenpatti','626141',1,0,'2022-03-03 12:44:35','2022-03-03 12:44:35'),(48633,140,'Aruppukottai Bazzar','626101',1,0,'2022-03-03 12:44:35','2022-03-03 12:44:35'),(48634,140,'Aruppukottai Court','626101',1,0,'2022-03-03 12:44:35','2022-03-03 12:44:35'),(48635,140,'Aruppukottai East','626101',1,0,'2022-03-03 12:44:35','2022-03-03 12:44:35'),(48636,140,'Aruppukottai H.O','626101',1,0,'2022-03-03 12:44:35','2022-03-03 12:44:35'),(48637,140,'Aruppukottai Nehru Maidanam','626101',1,0,'2022-03-03 12:44:35','2022-03-03 12:44:35'),(48638,140,'Aruppukottai West','626101',1,0,'2022-03-03 12:44:36','2022-03-03 12:44:36'),(48639,140,'Athikulam','626135',1,0,'2022-03-03 12:44:36','2022-03-03 12:44:36'),(48640,140,'Aviyur','626115',1,0,'2022-03-03 12:44:36','2022-03-03 12:44:36'),(48641,140,'Avudayapuram','626204',1,0,'2022-03-03 12:44:36','2022-03-03 12:44:36'),(48642,140,'Ayanathampatti','626138',1,0,'2022-03-03 12:44:36','2022-03-03 12:44:36'),(48643,140,'Ayankollangondan','626142',1,0,'2022-03-03 12:44:36','2022-03-03 12:44:36'),(48644,140,'Boovanathapuram','626124',1,0,'2022-03-03 12:44:36','2022-03-03 12:44:36'),(48645,140,'Chatrapatti (Virudhunagar)','626102',1,0,'2022-03-03 12:44:36','2022-03-03 12:44:36'),(48646,140,'Chatrapuliyankulam','626106',1,0,'2022-03-03 12:44:36','2022-03-03 12:44:36'),(48647,140,'Chatrareddiapatti','626002',1,0,'2022-03-03 12:44:36','2022-03-03 12:44:36'),(48648,140,'Chettikurichi','626134',1,0,'2022-03-03 12:44:36','2022-03-03 12:44:36'),(48649,140,'Chidambarapuram','626134',1,0,'2022-03-03 12:44:36','2022-03-03 12:44:36'),(48650,140,'Chithunundradaippu','626106',1,0,'2022-03-03 12:44:36','2022-03-03 12:44:36'),(48651,140,'Chockalingapuram','626202',1,0,'2022-03-03 12:44:36','2022-03-03 12:44:36'),(48652,140,'Chockalingapuram','626108',1,0,'2022-03-03 12:44:36','2022-03-03 12:44:36'),(48653,140,'Chockanathanpudur','626121',1,0,'2022-03-03 12:44:36','2022-03-03 12:44:36'),(48654,140,'Cholapuram South','626139',1,0,'2022-03-03 12:44:36','2022-03-03 12:44:36'),(48655,140,'Devadanam','626121',1,0,'2022-03-03 12:44:36','2022-03-03 12:44:36'),(48656,140,'Dhalavaipuram','626188',1,0,'2022-03-03 12:44:36','2022-03-03 12:44:36'),(48657,140,'Dharmam','626612',1,0,'2022-03-03 12:44:36','2022-03-03 12:44:36'),(48658,140,'Edirkottai','626131',1,0,'2022-03-03 12:44:36','2022-03-03 12:44:36'),(48659,140,'Elayirampannai','626201',1,0,'2022-03-03 12:44:36','2022-03-03 12:44:36'),(48660,140,'Erichanatham','626103',1,0,'2022-03-03 12:44:36','2022-03-03 12:44:36'),(48661,140,'Gollapatti','626203',1,0,'2022-03-03 12:44:36','2022-03-03 12:44:36'),(48662,140,'Gopalapuram','626136',1,0,'2022-03-03 12:44:36','2022-03-03 12:44:36'),(48663,140,'Guhanparai','626140',1,0,'2022-03-03 12:44:36','2022-03-03 12:44:36'),(48664,140,'Ilandaikulam','626149',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48665,140,'Iluppaiyur','626129',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48666,140,'Inamkarisalkulam','626125',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48667,140,'Inamreddiapatti','626003',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48668,140,'Injar','626124',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48669,140,'Irukkangaudi','626202',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48670,140,'Irunjirai','626612',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48671,140,'Isali','626607',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48672,140,'K.Chettikulam','626114',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48673,140,'Kadaneri','626149',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48674,140,'Kakkivadanpatti','626124',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48675,140,'Kalayar Karisalkulam','626105',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48676,140,'Kalkurichi','626104',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48677,140,'Kallamanaickenpatti','626131',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48678,140,'Kallurani','626105',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48679,140,'Kamaraj Nagar','626001',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48680,140,'Kambigudi','626115',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48681,140,'Kangarseval','626131',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48682,140,'Kansapuram','626133',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48683,140,'Karendal','626129',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48684,140,'Kariapatti','626106',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48685,140,'Karisalkulam','626149',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48686,140,'Karisalpatti','626201',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48687,140,'Kattangudi','626107',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48688,140,'Kilarajakularaman','626136',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48689,140,'Kilavikulam','626139',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48690,140,'Kilgudi','626114',1,0,'2022-03-03 12:44:37','2022-03-03 12:44:37'),(48691,140,'Kokkalanjeri','626002',1,0,'2022-03-03 12:44:38','2022-03-03 12:44:38'),(48692,140,'Kooraikundu','626001',1,0,'2022-03-03 12:44:38','2022-03-03 12:44:38'),(48693,140,'Koppusithampatti','626113',1,0,'2022-03-03 12:44:38','2022-03-03 12:44:38'),(48694,140,'Kosugundu','626202',1,0,'2022-03-03 12:44:38','2022-03-03 12:44:38'),(48695,140,'Kottaiyur','626149',1,0,'2022-03-03 12:44:38','2022-03-03 12:44:38'),(48696,140,'Kotthiyur Gurusamykoil','626204',1,0,'2022-03-03 12:44:38','2022-03-03 12:44:38'),(48697,140,'Kovilangulam','626107',1,0,'2022-03-03 12:44:38','2022-03-03 12:44:38'),(48698,140,'Krishnapuram','626142',1,0,'2022-03-03 12:44:38','2022-03-03 12:44:38'),(48699,140,'Kuchampatti','626129',1,0,'2022-03-03 12:44:38','2022-03-03 12:44:38'),(48700,140,'Kullursandai','626004',1,0,'2022-03-03 12:44:38','2022-03-03 12:44:38'),(48701,140,'Kumarasamy Raja Nagar','626108',1,0,'2022-03-03 12:44:38','2022-03-03 12:44:38'),(48702,140,'Kummapatti','626133',1,0,'2022-03-03 12:44:38','2022-03-03 12:44:38'),(48703,140,'Kundayiruppu','626131',1,0,'2022-03-03 12:44:38','2022-03-03 12:44:38'),(48704,140,'Kunnur','626138',1,0,'2022-03-03 12:44:38','2022-03-03 12:44:38'),(48705,140,'Kunnur South','626126',1,0,'2022-03-03 12:44:38','2022-03-03 12:44:38'),(48706,140,'Kurandi','626115',1,0,'2022-03-03 12:44:38','2022-03-03 12:44:38'),(48707,140,'Kurundamadam','626112',1,0,'2022-03-03 12:44:38','2022-03-03 12:44:38'),(48708,140,'Lakshmipuram','626127',1,0,'2022-03-03 12:44:38','2022-03-03 12:44:38'),(48709,140,'M.Pudupatti','626130',1,0,'2022-03-03 12:44:38','2022-03-03 12:44:38'),(48710,140,'M.Reddiapatti','626118',1,0,'2022-03-03 12:44:38','2022-03-03 12:44:38'),(48711,140,'Madavar Vilagam','626125',1,0,'2022-03-03 12:44:38','2022-03-03 12:44:38'),(48712,140,'Maharajapuram','626149',1,0,'2022-03-03 12:44:38','2022-03-03 12:44:38'),(48713,140,'Malaipatti','626004',1,0,'2022-03-03 12:44:38','2022-03-03 12:44:38'),(48714,140,'Mallanginar','626109',1,0,'2022-03-03 12:44:38','2022-03-03 12:44:38'),(48715,140,'Malli','626141',1,0,'2022-03-03 12:44:38','2022-03-03 12:44:38'),(48716,140,'Mallipudur','626141',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48717,140,'Mamsapuram','626124',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48718,140,'Mandapasalai','626118',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48719,140,'Mangalam','626138',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48720,140,'Manthoppu','626104',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48721,140,'Maraikulam','626607',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48722,140,'Maraneri','626124',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48723,140,'Maravarperungudi','626118',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48724,140,'Mavilpatti','626202',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48725,140,'Meenakshipuram','626111',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48726,140,'Meenakshipuram','626125',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48727,140,'Meenampatti','626189',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48728,140,'Meesalur','626003',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48729,140,'Melanmarainadu','626127',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48730,140,'Melapattamkarisalkulam','626110',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48731,140,'Melathulukkankulam','626109',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48732,140,'Mepco.Engg.College','626005',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48733,140,'Mettamalai','626203',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48734,140,'Mettugundu','626004',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48735,140,'Mohamed Sahibpuram','626110',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48736,140,'Moovaraivendran','626138',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48737,140,'Mudalipatti','626189',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48738,140,'Mudukkankulam','626106',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48739,140,'Muhavur','626111',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48740,140,'Mullipatti','626005',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48741,140,'Mulliseval','626205',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48742,140,'Musttakurichi','626106',1,0,'2022-03-03 12:44:39','2022-03-03 12:44:39'),(48743,140,'Muthulapuram','626119',1,0,'2022-03-03 12:44:40','2022-03-03 12:44:40'),(48744,140,'N.Subbiahpuram','626205',1,0,'2022-03-03 12:44:40','2022-03-03 12:44:40'),(48745,140,'Nachiyarkoil','626135',1,0,'2022-03-03 12:44:40','2022-03-03 12:44:40'),(48746,140,'Naduvapatti','626203',1,0,'2022-03-03 12:44:40','2022-03-03 12:44:40'),(48747,140,'Nallamanaickenpatti','626102',1,0,'2022-03-03 12:44:40','2022-03-03 12:44:40'),(48748,140,'Nalli','626205',1,0,'2022-03-03 12:44:40','2022-03-03 12:44:40'),(48749,140,'Nalur','626607',1,0,'2022-03-03 12:44:40','2022-03-03 12:44:40'),(48750,140,'Naranapuram','626189',1,0,'2022-03-03 12:44:40','2022-03-03 12:44:40'),(48751,140,'Narikudi','626607',1,0,'2022-03-03 12:44:40','2022-03-03 12:44:40'),(48752,140,'Nathampatti','626102',1,0,'2022-03-03 12:44:40','2022-03-03 12:44:40'),(48753,140,'Nathathupatti','626202',1,0,'2022-03-03 12:44:40','2022-03-03 12:44:40'),(48754,140,'Nathikudi','626137',1,0,'2022-03-03 12:44:40','2022-03-03 12:44:40'),(48755,140,'Nedungulam','626138',1,0,'2022-03-03 12:44:40','2022-03-03 12:44:40'),(48756,140,'Nenmeni','626202',1,0,'2022-03-03 12:44:40','2022-03-03 12:44:40'),(48757,140,'Odaipatti','626205',1,0,'2022-03-03 12:44:40','2022-03-03 12:44:40'),(48758,140,'Othayal Mettupatti','626203',1,0,'2022-03-03 12:44:40','2022-03-03 12:44:40'),(48759,140,'P Thottiankulam','626129',1,0,'2022-03-03 12:44:40','2022-03-03 12:44:40'),(48760,140,'P.Ramachandrapuram','626137',1,0,'2022-03-03 12:44:40','2022-03-03 12:44:40'),(48761,140,'P.Sallipatti','626138',1,0,'2022-03-03 12:44:40','2022-03-03 12:44:40'),(48762,140,'Padanthal','626203',1,0,'2022-03-03 12:44:40','2022-03-03 12:44:40'),(48763,140,'Palavantham','626004',1,0,'2022-03-03 12:44:40','2022-03-03 12:44:40'),(48764,140,'Palayampatti','626112',1,0,'2022-03-03 12:44:40','2022-03-03 12:44:40'),(48765,140,'Pampatti','626106',1,0,'2022-03-03 12:44:40','2022-03-03 12:44:40'),(48766,140,'Panaiyur','626129',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48767,140,'Panayadipatti','626201',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48768,140,'Pandalgudi','626113',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48769,140,'Pappakudi','626134',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48770,140,'Paralachi','626114',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48771,140,'Pattampudur','626003',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48772,140,'Pavali','626103',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48773,140,'Periaperali','626109',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48774,140,'Periavallikulam','626004',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48775,140,'Perunjalai Pudupatti','626104',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48776,140,'Pervelangudi','626612',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48777,140,'Pilavakkaldam','626133',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48778,140,'Pillayarkulam','626137',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48779,140,'Pillayarnatham','626125',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48780,140,'Poolangal','626114',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48781,140,'Pottalpatti','626111',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48782,140,'Pudukottai','626103',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48783,140,'Pudupalayam (Virudhunagar)','626117',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48784,140,'Pudupatti','626204',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48785,140,'Puliyuran','626105',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48786,140,'Pungamarathupatti','626118',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48787,140,'Puthur','626111',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48788,140,'R.Kallumadam','626118',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48789,140,'R.Reddiapatti','626136',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48790,140,'Rajapalayam Ambalapuli Bazzar','626117',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48791,140,'Rajapalayam Bazzar','626117',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48792,140,'Rajapalayam Bus Stand','626117',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48793,140,'Rajapalayam H.O','626117',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48794,140,'Ramalingapuram','626102',1,0,'2022-03-03 12:44:41','2022-03-03 12:44:41'),(48795,140,'Ramasamy Nagar','626105',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48796,140,'Ramasamy Raja Nagar','626204',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48797,140,'S.Ramachandrapuram','626126',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48798,140,'Salvarpatti','626128',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48799,140,'Samsigapuram','626102',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48800,140,'Sankaralingapuram','626119',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48801,140,'Sankarapandiapuram','626201',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48802,140,'Sattur','626203',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48803,140,'Sattur West','626203',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48804,140,'Seithur','626121',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48805,140,'Sembatti','626105',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48806,140,'Sengamalanachiapuram','626130',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48807,140,'Sengulam','626114',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48808,140,'Sengundrapuram','626103',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48809,140,'Sennelgudi','626004',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48810,140,'Sennilaikudi','626129',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48811,140,'Seshapuram','626116',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48812,140,'Sethu Institute of Technology','626115',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48813,140,'Sethunarayanapuram','626132',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48814,140,'Settiyarpatti','626122',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48815,140,'Settudayanpatti','626203',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48816,140,'Sevalpatti','626140',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48817,140,'Sinnakamanpatti','626189',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48818,140,'Siruvanur','626607',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48819,140,'Sithurajapuram','626189',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48820,140,'Sivakasi Bazzar','626123',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48821,140,'Sivakasi Bus Stand','626123',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48822,140,'Sivakasi East','626189',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48823,140,'Sivakasi H.O','626123',1,0,'2022-03-03 12:44:42','2022-03-03 12:44:42'),(48824,140,'Sivakasi R S','626123',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48825,140,'Sivakasi West','626124',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48826,140,'Sivalingapuram','626136',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48827,140,'Solapuram','626139',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48828,140,'Soolakkarai','626003',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48829,140,'Srivilliputhur Court Complexe','626135',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48830,140,'Srivilliputhur North','626125',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48831,140,'Srivilliputhur','626125',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48832,140,'Subramaniapuram','626128',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48833,140,'Sudhamadam','626114',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48834,140,'Sukkilanatham','626112',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48835,140,'Sundaranachiarpuram','626142',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48836,140,'Sundarapandiam','626126',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48837,140,'Sundararajapuram','626142',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48838,140,'Surangudi','626203',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48839,140,'T.Managaseri','626141',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48840,140,'T.Meenakshipuram','626112',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48841,140,'T.Sedapatti','626204',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48842,140,'Tamilnadu Cements Alangulam','626127',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48843,140,'Tamilpadi','626129',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48844,140,'Terkuvenganllur','626142',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48845,140,'Thailapuram','626149',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48846,140,'Thayilpatti','626128',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48847,140,'Thombakulam','626136',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48848,140,'Thoppalakarai','626114',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48849,140,'Thulukkapatti','626204',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48850,140,'Thulukkapatti R.S.','626204',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48851,140,'Thummusinnampatti','626118',1,0,'2022-03-03 12:44:43','2022-03-03 12:44:43'),(48852,140,'Thungareddiapatti','626203',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48853,140,'Tiruchuli','626129',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48854,140,'Tiruthangal','626130',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48855,140,'Ulagudi','626607',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48856,140,'Uppathur','626205',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48857,140,'V.Muthulingapuram','626119',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48858,140,'Vadakarai','626136',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48859,140,'Vadakkunatham','626114',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48860,140,'Vadamalaikurichi','626002',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48861,140,'Vadamalapuram','626130',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48862,140,'Vadhuvarpatti','626134',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48863,140,'Vairavanangoor','626106',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48864,140,'Vaithilingapuram','626125',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48865,140,'Vakkanangundu','626104',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48866,140,'Valayapatti','626127',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48867,140,'Valliyur','626005',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48868,140,'Varaganur','626140',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48869,140,'Vedanatham','626118',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48870,140,'Vellayapuram','626112',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48871,140,'Vellur','626005',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48872,140,'Vembakottai','626131',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48873,140,'Venkatachalapuram','626203',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48874,140,'Vetrilaiyurani','626128',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48875,140,'Vijayakarisalkulam','626131',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48876,140,'Vilampatti','626124',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48877,140,'Villipathiri','626109',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48878,140,'Villupanur','626138',1,0,'2022-03-03 12:44:44','2022-03-03 12:44:44'),(48879,140,'Viracholan','626612',1,0,'2022-03-03 12:44:45','2022-03-03 12:44:45'),(48880,140,'Virudhunagar Bazaar','626001',1,0,'2022-03-03 12:44:45','2022-03-03 12:44:45'),(48881,140,'Virudhunagar Bus Stand','626001',1,0,'2022-03-03 12:44:45','2022-03-03 12:44:45'),(48882,140,'Virudhunagar Collectorate','626002',1,0,'2022-03-03 12:44:45','2022-03-03 12:44:45'),(48883,140,'Virudhunagar Extension','626001',1,0,'2022-03-03 12:44:45','2022-03-03 12:44:45'),(48884,140,'Virudhunagar H.O','626001',1,0,'2022-03-03 12:44:45','2022-03-03 12:44:45'),(48885,140,'Virudhunagar Housing Unit Colo','626001',1,0,'2022-03-03 12:44:45','2022-03-03 12:44:45'),(48886,140,'Virudhunagar Industrial Estate','626003',1,0,'2022-03-03 12:44:45','2022-03-03 12:44:45'),(48887,140,'Virudhunagar North','626001',1,0,'2022-03-03 12:44:45','2022-03-03 12:44:45'),(48888,140,'Virudhunagar Town','626001',1,0,'2022-03-03 12:44:45','2022-03-03 12:44:45'),(48889,140,'Viswanatham','626189',1,0,'2022-03-03 12:44:45','2022-03-03 12:44:45'),(48890,140,'W Pudupatti','626116',1,0,'2022-03-03 12:44:45','2022-03-03 12:44:45'),(48891,140,'Watrap','626132',1,0,'2022-03-03 12:44:45','2022-03-03 12:44:45'),(48892,140,'Zaminkollangondan','626142',1,0,'2022-03-03 12:44:45','2022-03-03 12:44:45'),(48893,141,'Agarda','722144',1,0,'2022-03-03 12:44:45','2022-03-03 12:44:45'),(48894,141,'Ahanda','722173',1,0,'2022-03-03 12:44:45','2022-03-03 12:44:45'),(48895,141,'Ajodhya','722122',1,0,'2022-03-03 12:44:45','2022-03-03 12:44:45'),(48896,141,'Akhrasole','722206',1,0,'2022-03-03 12:44:45','2022-03-03 12:44:45'),(48897,141,'Akhuapal','722134',1,0,'2022-03-03 12:44:45','2022-03-03 12:44:45'),(48898,141,'Akkhuta','722148',1,0,'2022-03-03 12:44:45','2022-03-03 12:44:45'),(48899,141,'Akui','722201',1,0,'2022-03-03 12:44:45','2022-03-03 12:44:45'),(48900,141,'Alijhara','722137',1,0,'2022-03-03 12:44:45','2022-03-03 12:44:45'),(48901,141,'Amarkanan','722133',1,0,'2022-03-03 12:44:45','2022-03-03 12:44:45'),(48902,141,'Ambikanagar','722135',1,0,'2022-03-03 12:44:45','2022-03-03 12:44:45'),(48903,141,'Amchura','722134',1,0,'2022-03-03 12:44:45','2022-03-03 12:44:45'),(48904,141,'Amdahi','722141',1,0,'2022-03-03 12:44:45','2022-03-03 12:44:45'),(48905,141,'Amral','722122',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48906,141,'Amritpara','722207',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48907,141,'Amrul','722206',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48908,141,'Anchuri Salboni','722102',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48909,141,'Andharthole','722146',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48910,141,'Anur','722161',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48911,141,'Arabani','722144',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48912,141,'Araldihi','722121',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48913,141,'Ardhagram','722143',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48914,141,'Arkama','722154',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48915,141,'Arrah','722137',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48916,141,'Asurali','722154',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48917,141,'Aswinkota','722141',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48918,141,'Ayma','722138',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48919,141,'Bagdiha','722136',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48920,141,'Baidyalokhesole','722139',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48921,141,'Baidyanathpur','722140',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48922,141,'Baital','722138',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48923,141,'Bakulia','722143',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48924,141,'Baliara','722144',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48925,141,'Balitha','722141',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48926,141,'Balsi','722206',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48927,141,'Bamira','722206',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48928,141,'Bamuntore','722153',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48929,141,'Banasuria','722133',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48930,141,'Bandubrajpur','722151',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48931,141,'Banjora','722142',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48932,141,'Bankadaha','722164',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48933,141,'Bankata','722121',1,0,'2022-03-03 12:44:46','2022-03-03 12:44:46'),(48934,141,'Bankati','722102',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48935,141,'Bankisole','722206',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48936,141,'Bankura  DSB','722101',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48937,141,'Bankura H.O','722101',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48938,141,'Bansarenga','722160',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48939,141,'Bansichandipur','722154',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48940,141,'Bansidih','722121',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48941,141,'Barachingra','722136',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48942,141,'Baragarrah','722150',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48943,141,'Barakalibari','722143',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48944,141,'Barbendya','722203',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48945,141,'Baricha','722151',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48946,141,'Barikul','722162',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48947,141,'Barjora','722202',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48948,141,'Barkona','722133',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48949,141,'Barkura','722203',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48950,141,'Basantimela','722122',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48951,141,'Basubati','722154',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48952,141,'Basudebpur','722134',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48953,141,'Beharjuria','722155',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48954,141,'Beliadangarpara','722122',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48955,141,'Beliatore','722203',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48956,141,'Belsulia','722138',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48957,141,'Belut','722206',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48958,141,'Benabaid','722143',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48959,141,'Besora','722137',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48960,141,'Betur','722206',1,0,'2022-03-03 12:44:47','2022-03-03 12:44:47'),(48961,141,'Bhadul','722155',1,0,'2022-03-03 12:44:48','2022-03-03 12:44:48'),(48962,141,'Bhagabandh','722146',1,0,'2022-03-03 12:44:48','2022-03-03 12:44:48'),(48963,141,'Bhagaldighi','722154',1,0,'2022-03-03 12:44:48','2022-03-03 12:44:48'),(48964,141,'Bhagalpur','722141',1,0,'2022-03-03 12:44:48','2022-03-03 12:44:48'),(48965,141,'Bhalaidiha','722139',1,0,'2022-03-03 12:44:48','2022-03-03 12:44:48'),(48966,141,'Bhalukbasa','722121',1,0,'2022-03-03 12:44:48','2022-03-03 12:44:48'),(48967,141,'Bhalukgenjar','722136',1,0,'2022-03-03 12:44:48','2022-03-03 12:44:48'),(48968,141,'Bhara','722157',1,0,'2022-03-03 12:44:48','2022-03-03 12:44:48'),(48969,141,'Bhatra','722136',1,0,'2022-03-03 12:44:48','2022-03-03 12:44:48'),(48970,141,'Bhattapara','722203',1,0,'2022-03-03 12:44:48','2022-03-03 12:44:48'),(48971,141,'Bhedua','722151',1,0,'2022-03-03 12:44:48','2022-03-03 12:44:48'),(48972,141,'Bheduasole','722121',1,0,'2022-03-03 12:44:48','2022-03-03 12:44:48'),(48973,141,'Bhethuala','722135',1,0,'2022-03-03 12:44:48','2022-03-03 12:44:48'),(48974,141,'Bhojda','722121',1,0,'2022-03-03 12:44:48','2022-03-03 12:44:48'),(48975,141,'Bhuakana','722140',1,0,'2022-03-03 12:44:48','2022-03-03 12:44:48'),(48976,141,'Bhutsahar','722156',1,0,'2022-03-03 12:44:48','2022-03-03 12:44:48'),(48977,141,'Biborda','722152',1,0,'2022-03-03 12:44:48','2022-03-03 12:44:48'),(48978,141,'Bikrampur','722151',1,0,'2022-03-03 12:44:48','2022-03-03 12:44:48'),(48979,141,'Bikurdih','722146',1,0,'2022-03-03 12:44:48','2022-03-03 12:44:48'),(48980,141,'Birkham','722148',1,0,'2022-03-03 12:44:48','2022-03-03 12:44:48'),(48981,141,'Birsinghpur','722207',1,0,'2022-03-03 12:44:48','2022-03-03 12:44:48'),(48982,141,'Bishjore','722158',1,0,'2022-03-03 12:44:48','2022-03-03 12:44:48'),(48983,141,'Bishnupur (Bankura)','722122',1,0,'2022-03-03 12:44:48','2022-03-03 12:44:48'),(48984,141,'Bishnupur Stn Rd','722122',1,0,'2022-03-03 12:44:48','2022-03-03 12:44:48'),(48985,141,'Bisinda','722133',1,0,'2022-03-03 12:44:48','2022-03-03 12:44:48'),(48986,141,'Boga','722136',1,0,'2022-03-03 12:44:48','2022-03-03 12:44:48'),(48987,141,'Bonbirsingha','722207',1,0,'2022-03-03 12:44:49','2022-03-03 12:44:49'),(48988,141,'Bonradhanagar','722157',1,0,'2022-03-03 12:44:49','2022-03-03 12:44:49'),(48989,141,'Bouridihi','722121',1,0,'2022-03-03 12:44:49','2022-03-03 12:44:49'),(48990,141,'Brahmandiha','722173',1,0,'2022-03-03 12:44:49','2022-03-03 12:44:49'),(48991,141,'Brajarajpur','722121',1,0,'2022-03-03 12:44:49','2022-03-03 12:44:49'),(48992,141,'Brindabanpur Barsala','722142',1,0,'2022-03-03 12:44:49','2022-03-03 12:44:49'),(48993,141,'Brindabanpur-barsal','722142',1,0,'2022-03-03 12:44:49','2022-03-03 12:44:49'),(48994,141,'Budhanpur','722137',1,0,'2022-03-03 12:44:49','2022-03-03 12:44:49'),(48995,141,'Chaka','722140',1,0,'2022-03-03 12:44:49','2022-03-03 12:44:49'),(48996,141,'Chakaltore','722136',1,0,'2022-03-03 12:44:49','2022-03-03 12:44:49'),(48997,141,'Chakdaha','722122',1,0,'2022-03-03 12:44:49','2022-03-03 12:44:49'),(48998,141,'Chamtagora','722137',1,0,'2022-03-03 12:44:49','2022-03-03 12:44:49'),(48999,141,'Chandra','722132',1,0,'2022-03-03 12:44:49','2022-03-03 12:44:49'),(49000,141,'Chawkshyampur','722152',1,0,'2022-03-03 12:44:49','2022-03-03 12:44:49'),(49001,141,'Cheleiama-sunukpahari','722136',1,0,'2022-03-03 12:44:49','2022-03-03 12:44:49'),(49002,141,'Chhagulia','722152',1,0,'2022-03-03 12:44:49','2022-03-03 12:44:49'),(49003,141,'Chhandar','722203',1,0,'2022-03-03 12:44:49','2022-03-03 12:44:49'),(49004,141,'Chhatarkanali','722155',1,0,'2022-03-03 12:44:49','2022-03-03 12:44:49'),(49005,141,'Chhatna','722132',1,0,'2022-03-03 12:44:49','2022-03-03 12:44:49'),(49006,141,'Chingani','722152',1,0,'2022-03-03 12:44:49','2022-03-03 12:44:49'),(49007,141,'Chingra','722150',1,0,'2022-03-03 12:44:49','2022-03-03 12:44:49'),(49008,141,'Chourabaid','722136',1,0,'2022-03-03 12:44:49','2022-03-03 12:44:49'),(49009,141,'Chousal','722142',1,0,'2022-03-03 12:44:49','2022-03-03 12:44:49'),(49010,141,'Choutar','722150',1,0,'2022-03-03 12:44:49','2022-03-03 12:44:49'),(49011,141,'Chumosina','722157',1,0,'2022-03-03 12:44:49','2022-03-03 12:44:49'),(49012,141,'Dabri','722135',1,0,'2022-03-03 12:44:49','2022-03-03 12:44:49'),(49013,141,'Dahala','722160',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49014,141,'Damodarbati','722144',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49015,141,'Danga-barbendya','722173',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49016,141,'Dangmejhia','722143',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49017,141,'Darapur','722141',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49018,141,'Darsole','722140',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49019,141,'Dashere','722141',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49020,141,'Dauni','722149',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49021,141,'Dehuapara','722141',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49022,141,'Deshra','722141',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49023,141,'Deuli','722148',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49024,141,'Dhaban','722137',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49025,141,'Dhabani','722203',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49026,141,'Dhadanga','722140',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49027,141,'Dhagara','722135',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49028,141,'Dhansimla','722207',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49029,141,'Dhara','722138',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49030,141,'Dighalgram','722201',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49031,141,'Dighi','722121',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49032,141,'Digpar','722122',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49033,141,'Dipara','722207',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49034,141,'Dodhimukha','722203',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49035,141,'Doldere','722160',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49036,141,'Dubarajpur','722136',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49037,141,'Dudhya','722162',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49038,141,'Dumurtore','722150',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49039,141,'Dundar','722140',1,0,'2022-03-03 12:44:50','2022-03-03 12:44:50'),(49040,141,'Durlavpur','722133',1,0,'2022-03-03 12:44:51','2022-03-03 12:44:51'),(49041,141,'Dwarika','722122',1,0,'2022-03-03 12:44:51','2022-03-03 12:44:51'),(49042,141,'Feder Road','722101',1,0,'2022-03-03 12:44:51','2022-03-03 12:44:51'),(49043,141,'Fulkusma','722162',1,0,'2022-03-03 12:44:51','2022-03-03 12:44:51'),(49044,141,'Fulkusma-khattagram','722173',1,0,'2022-03-03 12:44:51','2022-03-03 12:44:51'),(49045,141,'Fulmati','722152',1,0,'2022-03-03 12:44:51','2022-03-03 12:44:51'),(49046,141,'Fulsusunia','722162',1,0,'2022-03-03 12:44:51','2022-03-03 12:44:51'),(49047,141,'Gangajalghati','722133',1,0,'2022-03-03 12:44:51','2022-03-03 12:44:51'),(49048,141,'Gangarampur Bamnia','722201',1,0,'2022-03-03 12:44:51','2022-03-03 12:44:51'),(49049,141,'Gangnala','722150',1,0,'2022-03-03 12:44:51','2022-03-03 12:44:51'),(49050,141,'Gargaria','722150',1,0,'2022-03-03 12:44:51','2022-03-03 12:44:51'),(49051,141,'Garh Kotalpur','722144',1,0,'2022-03-03 12:44:51','2022-03-03 12:44:51'),(49052,141,'Garhdubrajpur','722132',1,0,'2022-03-03 12:44:51','2022-03-03 12:44:51'),(49053,141,'Garhraipur','722134',1,0,'2022-03-03 12:44:51','2022-03-03 12:44:51'),(49054,141,'Gelia','722154',1,0,'2022-03-03 12:44:51','2022-03-03 12:44:51'),(49055,141,'Ghagra-haludkanali','722148',1,0,'2022-03-03 12:44:51','2022-03-03 12:44:51'),(49056,141,'Gholgoria','722136',1,0,'2022-03-03 12:44:51','2022-03-03 12:44:51'),(49057,141,'Gholkunda','722152',1,0,'2022-03-03 12:44:51','2022-03-03 12:44:51'),(49058,141,'Ghoradanga','722206',1,0,'2022-03-03 12:44:51','2022-03-03 12:44:51'),(49059,141,'Ghutgoria','722202',1,0,'2022-03-03 12:44:51','2022-03-03 12:44:51'),(49060,141,'Gobarda','722140',1,0,'2022-03-03 12:44:51','2022-03-03 12:44:51'),(49061,141,'Gobindadham','722133',1,0,'2022-03-03 12:44:51','2022-03-03 12:44:51'),(49062,141,'Godardihi','722203',1,0,'2022-03-03 12:44:51','2022-03-03 12:44:51'),(49063,141,'Gogra','722137',1,0,'2022-03-03 12:44:51','2022-03-03 12:44:51'),(49064,141,'Gokulnagar','722122',1,0,'2022-03-03 12:44:51','2022-03-03 12:44:51'),(49065,141,'Gopalnagar','722122',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49066,141,'Gopalpur','722136',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49067,141,'Gopikantapur','722207',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49068,141,'Gopinathpur','722161',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49069,141,'Gorabari','722135',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49070,141,'Gorasole','722144',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49071,141,'Gossainjanara','722121',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49072,141,'Gossainpur','722122',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49073,141,'Gossindihi','722158',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49074,141,'Gourbazar','722121',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49075,141,'Gouripur','722132',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49076,141,'Guniada','722136',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49077,141,'Gunnath','722121',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49078,141,'Gunpura','722135',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49079,141,'Hadal Narayanpur','722207',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49080,141,'Haludkanali','722140',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49081,141,'Hamirhati','722207',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49082,141,'Hamirpur','722206',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49083,141,'Harmasra','722152',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49084,141,'Hatagram','722136',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49085,141,'Hatasuria','722204',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49086,141,'Hatirampur','722121',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49087,141,'Hatkrishnanagar','722206',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49088,141,'Helna Susunia','722146',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49089,141,'Hetia','722138',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49090,141,'Hetiasole','722140',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49091,141,'Hetyagora','722151',1,0,'2022-03-03 12:44:52','2022-03-03 12:44:52'),(49092,141,'Hijaldihi','722138',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49093,141,'Hijlitilabani','722135',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49094,141,'Hirapur','722152',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49095,141,'Hirbandh','722121',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49096,141,'Ichharia','722157',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49097,141,'Indas','722205',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49098,141,'Indpur','722136',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49099,141,'J.J.Mirjapur','722154',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49100,141,'Jagadalla','722146',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49101,141,'Jagannathpur','722203',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49102,141,'Jalahari','722132',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49103,141,'Jambani','722150',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49104,141,'Jambedia','722139',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49105,141,'Jamda','722140',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49106,141,'Jamjuri','722144',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49107,141,'Jamkuri','722206',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49108,141,'Jamtora','722137',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49109,141,'Janta','722122',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49110,141,'Japamali','722143',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49111,141,'Jayrambati','722161',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49112,141,'Jeorda','722121',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49113,141,'Jhantipahari','722137',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49114,141,'Jhilimili','722135',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49115,141,'Jhoriakocha','722136',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49116,141,'Jiabandi','722164',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49117,141,'Jirabaid','722151',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49118,141,'Jorda','722173',1,0,'2022-03-03 12:44:53','2022-03-03 12:44:53'),(49119,141,'Jorehira','722137',1,0,'2022-03-03 12:44:54','2022-03-03 12:44:54'),(49120,141,'Joykrinhspur','722122',1,0,'2022-03-03 12:44:54','2022-03-03 12:44:54'),(49121,141,'Joypur','722138',1,0,'2022-03-03 12:44:54','2022-03-03 12:44:54'),(49122,141,'Jujur','722138',1,0,'2022-03-03 12:44:54','2022-03-03 12:44:54'),(49123,141,'Junbedia','722155',1,0,'2022-03-03 12:44:54','2022-03-03 12:44:54'),(49124,141,'Kabirchak','722206',1,0,'2022-03-03 12:44:54','2022-03-03 12:44:54'),(49125,141,'Kadma','722151',1,0,'2022-03-03 12:44:54','2022-03-03 12:44:54'),(49126,141,'Kadmagarh','722148',1,0,'2022-03-03 12:44:54','2022-03-03 12:44:54'),(49127,141,'Kakatia','722206',1,0,'2022-03-03 12:44:54','2022-03-03 12:44:54'),(49128,141,'Kakradara','722140',1,0,'2022-03-03 12:44:54','2022-03-03 12:44:54'),(49129,141,'Kalpathar','722146',1,0,'2022-03-03 12:44:54','2022-03-03 12:44:54'),(49130,141,'Kamalpur','722137',1,0,'2022-03-03 12:44:54','2022-03-03 12:44:54'),(49131,141,'Kamo','722135',1,0,'2022-03-03 12:44:54','2022-03-03 12:44:54'),(49132,141,'Kanchanpur','722155',1,0,'2022-03-03 12:44:54','2022-03-03 12:44:54'),(49133,141,'Kankatabati','722141',1,0,'2022-03-03 12:44:54','2022-03-03 12:44:54'),(49134,141,'Kansara','722143',1,0,'2022-03-03 12:44:54','2022-03-03 12:44:54'),(49135,141,'Kantabari','722122',1,0,'2022-03-03 12:44:54','2022-03-03 12:44:54'),(49136,141,'Kantapahari','722136',1,0,'2022-03-03 12:44:54','2022-03-03 12:44:54'),(49137,141,'Kanuri','722158',1,0,'2022-03-03 12:44:54','2022-03-03 12:44:54'),(49138,141,'Kapista','722133',1,0,'2022-03-03 12:44:54','2022-03-03 12:44:54'),(49139,141,'Karakberia','722141',1,0,'2022-03-03 12:44:54','2022-03-03 12:44:54'),(49140,141,'Karakberia Sadhuadal','722154',1,0,'2022-03-03 12:44:54','2022-03-03 12:44:54'),(49141,141,'Karrah','722132',1,0,'2022-03-03 12:44:54','2022-03-03 12:44:54'),(49142,141,'Kashipur','722140',1,0,'2022-03-03 12:44:54','2022-03-03 12:44:54'),(49143,141,'Kayabaid','722121',1,0,'2022-03-03 12:44:54','2022-03-03 12:44:54'),(49144,141,'Keliapathar','722136',1,0,'2022-03-03 12:44:54','2022-03-03 12:44:54'),(49145,141,'Kenduadihi','722102',1,0,'2022-03-03 12:44:55','2022-03-03 12:44:55'),(49146,141,'Kenety','722206',1,0,'2022-03-03 12:44:55','2022-03-03 12:44:55'),(49147,141,'Kenjakura','722139',1,0,'2022-03-03 12:44:55','2022-03-03 12:44:55'),(49148,141,'Keshbandi','722136',1,0,'2022-03-03 12:44:55','2022-03-03 12:44:55'),(49149,141,'Keshiara','722133',1,0,'2022-03-03 12:44:55','2022-03-03 12:44:55'),(49150,141,'Kesia','722140',1,0,'2022-03-03 12:44:55','2022-03-03 12:44:55'),(49151,141,'Kesiakole','722155',1,0,'2022-03-03 12:44:55','2022-03-03 12:44:55'),(49152,141,'Khalagram','722152',1,0,'2022-03-03 12:44:55','2022-03-03 12:44:55'),(49153,141,'Kharbona','722137',1,0,'2022-03-03 12:44:55','2022-03-03 12:44:55'),(49154,141,'Kharidungri','722140',1,0,'2022-03-03 12:44:55','2022-03-03 12:44:55'),(49155,141,'Kharigeria','722134',1,0,'2022-03-03 12:44:55','2022-03-03 12:44:55'),(49156,141,'Khatra','722140',1,0,'2022-03-03 12:44:55','2022-03-03 12:44:55'),(49157,141,'Khorsee','722201',1,0,'2022-03-03 12:44:55','2022-03-03 12:44:55'),(49158,141,'Khulyamuri','722152',1,0,'2022-03-03 12:44:55','2022-03-03 12:44:55'),(49159,141,'Kitchka','722151',1,0,'2022-03-03 12:44:55','2022-03-03 12:44:55'),(49160,141,'Kochdihi','722207',1,0,'2022-03-03 12:44:55','2022-03-03 12:44:55'),(49161,141,'Kostia','722144',1,0,'2022-03-03 12:44:55','2022-03-03 12:44:55'),(49162,141,'Kotalpur','722141',1,0,'2022-03-03 12:44:55','2022-03-03 12:44:55'),(49163,141,'Krishnanagar','722202',1,0,'2022-03-03 12:44:55','2022-03-03 12:44:55'),(49164,141,'Kuchiakole','722138',1,0,'2022-03-03 12:44:55','2022-03-03 12:44:55'),(49165,141,'Kukhrajhore','722133',1,0,'2022-03-03 12:44:55','2022-03-03 12:44:55'),(49166,141,'Kultuka','722133',1,0,'2022-03-03 12:44:55','2022-03-03 12:44:55'),(49167,141,'Kumidya','722146',1,0,'2022-03-03 12:44:55','2022-03-03 12:44:55'),(49168,141,'Kundapuskarani','722207',1,0,'2022-03-03 12:44:55','2022-03-03 12:44:55'),(49169,141,'Kushadwip','722207',1,0,'2022-03-03 12:44:56','2022-03-03 12:44:56'),(49170,141,'Kusthalia','722133',1,0,'2022-03-03 12:44:56','2022-03-03 12:44:56'),(49171,141,'Ladabrahmandiha','722152',1,0,'2022-03-03 12:44:56','2022-03-03 12:44:56'),(49172,141,'Lakshmisagar','722160',1,0,'2022-03-03 12:44:56','2022-03-03 12:44:56'),(49173,141,'Lalbandh','722122',1,0,'2022-03-03 12:44:56','2022-03-03 12:44:56'),(49174,141,'Lalbazar (Bankura)','722101',1,0,'2022-03-03 12:44:56','2022-03-03 12:44:56'),(49175,141,'Latbeliara','722157',1,0,'2022-03-03 12:44:56','2022-03-03 12:44:56'),(49176,141,'Laxmanpur','722133',1,0,'2022-03-03 12:44:56','2022-03-03 12:44:56'),(49177,141,'Layekbandh','722157',1,0,'2022-03-03 12:44:56','2022-03-03 12:44:56'),(49178,141,'Layekpara','722151',1,0,'2022-03-03 12:44:56','2022-03-03 12:44:56'),(49179,141,'Lego','722141',1,0,'2022-03-03 12:44:56','2022-03-03 12:44:56'),(49180,141,'Lodna (BankuB.O','722144',1,0,'2022-03-03 12:44:56','2022-03-03 12:44:56'),(49181,141,'Lokepur','722102',1,0,'2022-03-03 12:44:56','2022-03-03 12:44:56'),(49182,141,'Lokhasole','722157',1,0,'2022-03-03 12:44:56','2022-03-03 12:44:56'),(49183,141,'Louda','722136',1,0,'2022-03-03 12:44:56','2022-03-03 12:44:56'),(49184,141,'Lougram','722141',1,0,'2022-03-03 12:44:56','2022-03-03 12:44:56'),(49185,141,'Machatora','722151',1,0,'2022-03-03 12:44:56','2022-03-03 12:44:56'),(49186,141,'Machdoba','722207',1,0,'2022-03-03 12:44:56','2022-03-03 12:44:56'),(49187,141,'Madhanmohanpur','722141',1,0,'2022-03-03 12:44:56','2022-03-03 12:44:56'),(49188,141,'Magura','722138',1,0,'2022-03-03 12:44:56','2022-03-03 12:44:56'),(49189,141,'Maidhara','722160',1,0,'2022-03-03 12:44:56','2022-03-03 12:44:56'),(49190,141,'Majdiha','722144',1,0,'2022-03-03 12:44:56','2022-03-03 12:44:56'),(49191,141,'Majirdanga','722207',1,0,'2022-03-03 12:44:56','2022-03-03 12:44:56'),(49192,141,'Majurdanga','722206',1,0,'2022-03-03 12:44:56','2022-03-03 12:44:56'),(49193,141,'Makorkole','722144',1,0,'2022-03-03 12:44:56','2022-03-03 12:44:56'),(49194,141,'Maliara','722142',1,0,'2022-03-03 12:44:56','2022-03-03 12:44:56'),(49195,141,'Mamra','722149',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49196,141,'Mandalgram','722156',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49197,141,'Mandalkesra','722139',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49198,141,'Mandalkuli','722134',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49199,141,'Mandarboni','722152',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49200,141,'Mandra','722201',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49201,141,'Manikbazar','722207',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49202,141,'Mankanali','722132',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49203,141,'Mankhamar','722144',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49204,141,'Manohar','722142',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49205,141,'Matukbani','722158',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49206,141,'Medinipurgram','722144',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49207,141,'Mejhia','722143',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49208,141,'Mejia Th Power Station','722183',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49209,141,'Melera','722162',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49210,141,'Metali','722142',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49211,141,'Metha-am','722148',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49212,141,'Methana','722149',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49213,141,'Molian','722136',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49214,141,'Montumra','722137',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49215,141,'Morar','722164',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49216,141,'Mosanjhar','722121',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49217,141,'Mosiara','722121',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49218,141,'Motgoda','722134',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49219,141,'Moukura','722150',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49220,141,'Moulasole','722162',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49221,141,'Moynapur','722138',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49222,141,'Muchikata','722135',1,0,'2022-03-03 12:44:57','2022-03-03 12:44:57'),(49223,141,'Muktatore','722202',1,0,'2022-03-03 12:44:58','2022-03-03 12:44:58'),(49224,141,'Mukundapur','722151',1,0,'2022-03-03 12:44:58','2022-03-03 12:44:58'),(49225,141,'Muninagar','722122',1,0,'2022-03-03 12:44:58','2022-03-03 12:44:58'),(49226,141,'Muragram','722140',1,0,'2022-03-03 12:44:58','2022-03-03 12:44:58'),(49227,141,'Murakata','722144',1,0,'2022-03-03 12:44:58','2022-03-03 12:44:58'),(49228,141,'Murakati Saltora','722149',1,0,'2022-03-03 12:44:58','2022-03-03 12:44:58'),(49229,141,'Murlu','722158',1,0,'2022-03-03 12:44:58','2022-03-03 12:44:58'),(49230,141,'Nabachiada','722135',1,0,'2022-03-03 12:44:58','2022-03-03 12:44:58'),(49231,141,'Nabadeulvera','722136',1,0,'2022-03-03 12:44:58','2022-03-03 12:44:58'),(49232,141,'Nabajibanpur','722144',1,0,'2022-03-03 12:44:58','2022-03-03 12:44:58'),(49233,141,'Nabasan','722207',1,0,'2022-03-03 12:44:58','2022-03-03 12:44:58'),(49234,141,'Nachna','722152',1,0,'2022-03-03 12:44:58','2022-03-03 12:44:58'),(49235,141,'Nagri','722140',1,0,'2022-03-03 12:44:58','2022-03-03 12:44:58'),(49236,141,'Nakaijuri','722144',1,0,'2022-03-03 12:44:58','2022-03-03 12:44:58'),(49237,141,'Narrah','722155',1,0,'2022-03-03 12:44:58','2022-03-03 12:44:58'),(49238,141,'Natherdanga','722173',1,0,'2022-03-03 12:44:58','2022-03-03 12:44:58'),(49239,141,'Natungram','722152',1,0,'2022-03-03 12:44:58','2022-03-03 12:44:58'),(49240,141,'Nayada','722121',1,0,'2022-03-03 12:44:58','2022-03-03 12:44:58'),(49241,141,'Nemaipur','722151',1,0,'2022-03-03 12:44:58','2022-03-03 12:44:58'),(49242,141,'Nikunjapur','722144',1,0,'2022-03-03 12:44:58','2022-03-03 12:44:58'),(49243,141,'Nischintapur','722136',1,0,'2022-03-03 12:44:58','2022-03-03 12:44:58'),(49244,141,'Nityanandapur','722142',1,0,'2022-03-03 12:44:58','2022-03-03 12:44:58'),(49245,141,'Nutanbalarampur','722207',1,0,'2022-03-03 12:44:58','2022-03-03 12:44:58'),(49246,141,'Nutanchati','722101',1,0,'2022-03-03 12:44:58','2022-03-03 12:44:58'),(49247,141,'Nutangarh','722134',1,0,'2022-03-03 12:44:58','2022-03-03 12:44:58'),(49248,141,'Onda','722144',1,0,'2022-03-03 12:44:58','2022-03-03 12:44:58'),(49249,141,'Pabra','722143',1,0,'2022-03-03 12:44:59','2022-03-03 12:44:59'),(49250,141,'Pachhandapur','722153',1,0,'2022-03-03 12:44:59','2022-03-03 12:44:59'),(49251,141,'Pairaguri','722140',1,0,'2022-03-03 12:44:59','2022-03-03 12:44:59'),(49252,141,'Pairasole','722143',1,0,'2022-03-03 12:44:59','2022-03-03 12:44:59'),(49253,141,'Pakhanna','722208',1,0,'2022-03-03 12:44:59','2022-03-03 12:44:59'),(49254,141,'Paksara','722140',1,0,'2022-03-03 12:44:59','2022-03-03 12:44:59'),(49255,141,'Palashdanga','722208',1,0,'2022-03-03 12:44:59','2022-03-03 12:44:59'),(49256,141,'Palassboni','722152',1,0,'2022-03-03 12:44:59','2022-03-03 12:44:59'),(49257,141,'Pali','722134',1,0,'2022-03-03 12:44:59','2022-03-03 12:44:59'),(49258,141,'Panchal','722157',1,0,'2022-03-03 12:44:59','2022-03-03 12:44:59'),(49259,141,'Panchmura','722156',1,0,'2022-03-03 12:44:59','2022-03-03 12:44:59'),(49260,141,'Pandua','722206',1,0,'2022-03-03 12:44:59','2022-03-03 12:44:59'),(49261,141,'Panua','722141',1,0,'2022-03-03 12:44:59','2022-03-03 12:44:59'),(49262,141,'Papurdih','722132',1,0,'2022-03-03 12:44:59','2022-03-03 12:44:59'),(49263,141,'Parardanga','722152',1,0,'2022-03-03 12:44:59','2022-03-03 12:44:59'),(49264,141,'Parkura-anara','722134',1,0,'2022-03-03 12:44:59','2022-03-03 12:44:59'),(49265,141,'Parsola','722160',1,0,'2022-03-03 12:44:59','2022-03-03 12:44:59'),(49266,141,'Parulia','722206',1,0,'2022-03-03 12:44:59','2022-03-03 12:44:59'),(49267,141,'Pathardoba','722151',1,0,'2022-03-03 12:44:59','2022-03-03 12:44:59'),(49268,141,'Patit','722206',1,0,'2022-03-03 12:44:59','2022-03-03 12:44:59'),(49269,141,'Patpur','722147',1,0,'2022-03-03 12:44:59','2022-03-03 12:44:59'),(49270,141,'Patrasayer','722206',1,0,'2022-03-03 12:44:59','2022-03-03 12:44:59'),(49271,141,'Pearberia','722208',1,0,'2022-03-03 12:44:59','2022-03-03 12:44:59'),(49272,141,'Peardoba','722149',1,0,'2022-03-03 12:44:59','2022-03-03 12:44:59'),(49273,141,'Penchakola','722150',1,0,'2022-03-03 12:44:59','2022-03-03 12:44:59'),(49274,141,'Penchara Deuli','722150',1,0,'2022-03-03 12:45:00','2022-03-03 12:45:00'),(49275,141,'Pilgrim Road','722101',1,0,'2022-03-03 12:45:00','2022-03-03 12:45:00'),(49276,141,'Pirrabani','722203',1,0,'2022-03-03 12:45:00','2022-03-03 12:45:00'),(49277,141,'Pratappur','722152',1,0,'2022-03-03 12:45:00','2022-03-03 12:45:00'),(49278,141,'Puara','722136',1,0,'2022-03-03 12:45:00','2022-03-03 12:45:00'),(49279,141,'Puddi','722135',1,0,'2022-03-03 12:45:00','2022-03-03 12:45:00'),(49280,141,'Puipal','722151',1,0,'2022-03-03 12:45:00','2022-03-03 12:45:00'),(49281,141,'Pukhuria','722160',1,0,'2022-03-03 12:45:00','2022-03-03 12:45:00'),(49282,141,'Punisole','722152',1,0,'2022-03-03 12:45:00','2022-03-03 12:45:00'),(49283,141,'Purandapur','722155',1,0,'2022-03-03 12:45:00','2022-03-03 12:45:00'),(49284,141,'Puranpani','722148',1,0,'2022-03-03 12:45:00','2022-03-03 12:45:00'),(49285,141,'Purusottampur','722136',1,0,'2022-03-03 12:45:00','2022-03-03 12:45:00'),(49286,141,'Putiadaha','722151',1,0,'2022-03-03 12:45:00','2022-03-03 12:45:00'),(49287,141,'Radhakantapur','722208',1,0,'2022-03-03 12:45:00','2022-03-03 12:45:00'),(49288,141,'Radhamohanpur','722207',1,0,'2022-03-03 12:45:00','2022-03-03 12:45:00'),(49289,141,'Rahagram','722122',1,0,'2022-03-03 12:45:00','2022-03-03 12:45:00'),(49290,141,'Raibaghini','722122',1,0,'2022-03-03 12:45:00','2022-03-03 12:45:00'),(49291,141,'Raidihi','722140',1,0,'2022-03-03 12:45:00','2022-03-03 12:45:00'),(49292,141,'Rajagram','722146',1,0,'2022-03-03 12:45:00','2022-03-03 12:45:00'),(49293,141,'Ramharipur','722203',1,0,'2022-03-03 12:45:00','2022-03-03 12:45:00'),(49294,141,'Rampur','722121',1,0,'2022-03-03 12:45:00','2022-03-03 12:45:00'),(49295,141,'Ramsagar','722147',1,0,'2022-03-03 12:45:00','2022-03-03 12:45:00'),(49296,141,'Ranga','722136',1,0,'2022-03-03 12:45:00','2022-03-03 12:45:00'),(49297,141,'Ranibandh','722148',1,0,'2022-03-03 12:45:00','2022-03-03 12:45:00'),(49298,141,'Ranikhamar','722144',1,0,'2022-03-03 12:45:00','2022-03-03 12:45:00'),(49299,141,'Ranpur','722207',1,0,'2022-03-03 12:45:00','2022-03-03 12:45:00'),(49300,141,'Rapatganj','722207',1,0,'2022-03-03 12:45:01','2022-03-03 12:45:01'),(49301,141,'Rasikganj','722122',1,0,'2022-03-03 12:45:01','2022-03-03 12:45:01'),(49302,141,'Ratanpur (BankuB.O','722152',1,0,'2022-03-03 12:45:01','2022-03-03 12:45:01'),(49303,141,'Ratra','722201',1,0,'2022-03-03 12:45:01','2022-03-03 12:45:01'),(49304,141,'Routara','722135',1,0,'2022-03-03 12:45:01','2022-03-03 12:45:01'),(49305,141,'Routhkhanda','722138',1,0,'2022-03-03 12:45:01','2022-03-03 12:45:01'),(49306,141,'Rudra','722135',1,0,'2022-03-03 12:45:01','2022-03-03 12:45:01'),(49307,141,'Sabrakone','722149',1,0,'2022-03-03 12:45:01','2022-03-03 12:45:01'),(49308,141,'Sadhana Rangamati','722143',1,0,'2022-03-03 12:45:01','2022-03-03 12:45:01'),(49309,141,'Salbedia','722203',1,0,'2022-03-03 12:45:01','2022-03-03 12:45:01'),(49310,141,'Salda','722122',1,0,'2022-03-03 12:45:01','2022-03-03 12:45:01'),(49311,141,'Saldiha','722173',1,0,'2022-03-03 12:45:01','2022-03-03 12:45:01'),(49312,141,'Saldiha Pithabaid','722139',1,0,'2022-03-03 12:45:01','2022-03-03 12:45:01'),(49313,141,'Salma','722143',1,0,'2022-03-03 12:45:01','2022-03-03 12:45:01'),(49314,141,'Salna','722206',1,0,'2022-03-03 12:45:01','2022-03-03 12:45:01'),(49315,141,'Salroha','722133',1,0,'2022-03-03 12:45:01','2022-03-03 12:45:01'),(49316,141,'Saltora','722158',1,0,'2022-03-03 12:45:01','2022-03-03 12:45:01'),(49317,141,'Saluipahari','722136',1,0,'2022-03-03 12:45:01','2022-03-03 12:45:01'),(49318,141,'Samantakhanda','722141',1,0,'2022-03-03 12:45:01','2022-03-03 12:45:01'),(49319,141,'Sanbandha','722155',1,0,'2022-03-03 12:45:01','2022-03-03 12:45:01'),(49320,141,'Saralia','722152',1,0,'2022-03-03 12:45:01','2022-03-03 12:45:01'),(49321,141,'Sarenga','722150',1,0,'2022-03-03 12:45:01','2022-03-03 12:45:01'),(49322,141,'Satmouli','722149',1,0,'2022-03-03 12:45:01','2022-03-03 12:45:01'),(49323,141,'Satpatta','722134',1,0,'2022-03-03 12:45:01','2022-03-03 12:45:01'),(49324,141,'Satyayatan','722139',1,0,'2022-03-03 12:45:01','2022-03-03 12:45:01'),(49325,141,'Sendra','722155',1,0,'2022-03-03 12:45:01','2022-03-03 12:45:01'),(49326,141,'Shitla','722202',1,0,'2022-03-03 12:45:02','2022-03-03 12:45:02'),(49327,141,'Shyambazar','722140',1,0,'2022-03-03 12:45:02','2022-03-03 12:45:02'),(49328,141,'Shyamnagar','722138',1,0,'2022-03-03 12:45:02','2022-03-03 12:45:02'),(49329,141,'Shyampur','722158',1,0,'2022-03-03 12:45:02','2022-03-03 12:45:02'),(49330,141,'Shyamsundarpur','722134',1,0,'2022-03-03 12:45:02','2022-03-03 12:45:02'),(49331,141,'Sihar','722161',1,0,'2022-03-03 12:45:02','2022-03-03 12:45:02'),(49332,141,'Sihas','722141',1,0,'2022-03-03 12:45:02','2022-03-03 12:45:02'),(49333,141,'Sihika','722137',1,0,'2022-03-03 12:45:02','2022-03-03 12:45:02'),(49334,141,'Silpajambedia','722121',1,0,'2022-03-03 12:45:02','2022-03-03 12:45:02'),(49335,141,'Simlabandh','722121',1,0,'2022-03-03 12:45:02','2022-03-03 12:45:02'),(49336,141,'Simlapal','722151',1,0,'2022-03-03 12:45:02','2022-03-03 12:45:02'),(49337,141,'Sindri-am','722148',1,0,'2022-03-03 12:45:02','2022-03-03 12:45:02'),(49338,141,'Siromonipur','722134',1,0,'2022-03-03 12:45:02','2022-03-03 12:45:02'),(49339,141,'Sirsara','722155',1,0,'2022-03-03 12:45:02','2022-03-03 12:45:02'),(49340,141,'Sonagara','722140',1,0,'2022-03-03 12:45:02','2022-03-03 12:45:02'),(49341,141,'Sonamukhi Rath Tala','722207',1,0,'2022-03-03 12:45:02','2022-03-03 12:45:02'),(49342,141,'Sonamukhi (Bankura)','722207',1,0,'2022-03-03 12:45:02','2022-03-03 12:45:02'),(49343,141,'Sonardanga','722173',1,0,'2022-03-03 12:45:02','2022-03-03 12:45:02'),(49344,141,'Sripatpurnia','722143',1,0,'2022-03-03 12:45:02','2022-03-03 12:45:02'),(49345,141,'Sukhadali','722150',1,0,'2022-03-03 12:45:02','2022-03-03 12:45:02'),(49346,141,'Sunri-chitra','722136',1,0,'2022-03-03 12:45:02','2022-03-03 12:45:02'),(49347,141,'Supur','722121',1,0,'2022-03-03 12:45:02','2022-03-03 12:45:02'),(49348,141,'Susunia','722132',1,0,'2022-03-03 12:45:02','2022-03-03 12:45:02'),(49349,141,'Tajpur Purakona','722208',1,0,'2022-03-03 12:45:02','2022-03-03 12:45:02'),(49350,141,'Tajpurgram','722161',1,0,'2022-03-03 12:45:02','2022-03-03 12:45:02'),(49351,141,'Taldangra','722152',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49352,141,'Tapta-damdi','722134',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49353,141,'Teleberia','722144',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49354,141,'Thakurbari Ramchandrapur','722143',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49355,141,'Tilabani','722160',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49356,141,'Tiluri','722153',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49357,141,'Tiring','722140',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49358,141,'Trisalan','722201',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49359,141,'Tungcharar','722148',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49360,141,'Ukhradihi','722133',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49361,141,'Uliara','722122',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49362,141,'Unara Jambedia','722202',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49363,141,'West-sanabandh','722132',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49364,141,'Alampur','713150',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49365,141,'Barampur','713150',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49366,141,'Bileswar','713150',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49367,141,'Biswaramba','713513',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49368,141,'Chakbamongaria','713513',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49369,141,'Chakshanjandi','713519',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49370,141,'Charmaniknagar','713519',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49371,141,'Chatni','713512',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49372,141,'Chupi','713513',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49373,141,'Churpuni','713150',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49374,141,'Dupsa','713519',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49375,141,'Gourdanga','713514',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49376,141,'Haldinawapara','713513',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49377,141,'Hapania','713512',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49378,141,'Jahannagar','713513',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49379,141,'Kasthashali','713513',1,0,'2022-03-03 12:45:03','2022-03-03 12:45:03'),(49380,141,'Kosigram','713150',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49381,141,'Kowerpur','713519',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49382,141,'Kurchi','713514',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49383,141,'Kutirpara','713519',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49384,141,'Mertala','713513',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49385,141,'Minapur','713513',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49386,141,'Moail','713513',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49387,141,'Mukshinpara','713513',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49388,141,'Mulgram','713519',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49389,141,'Multikrishnanagar','713514',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49390,141,'Mustafapur','713150',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49391,141,'Nasaratpur','713519',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49392,141,'Okarsa','713514',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49393,141,'Parulia','713513',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49394,141,'Purbasthali','713513',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49395,141,'Raidogachi','713513',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49396,141,'Raipur','713519',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49397,141,'Samudragarh','713519',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49398,141,'Simlon','713425',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49399,141,'Singhi','713514',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49400,141,'Sribati','713514',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49401,141,'Srikhanda','713150',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49402,141,'Sudpur','713517',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49403,141,'Sutra','713513',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49404,141,'Tamaghata','713512',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49405,142,'Achra','713335',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49406,142,'Aldihi','713359',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49407,142,'Amdahi','713381',1,0,'2022-03-03 12:45:04','2022-03-03 12:45:04'),(49408,142,'Amladahi','713331',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49409,142,'Amlajora','713212',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49410,142,'Amrabati','713214',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49411,142,'Amrai','713203',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49412,142,'Amrasota','713358',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49413,142,'Amritnagar','713358',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49414,142,'Andal','713321',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49415,142,'Andal South Bazar','713321',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49416,142,'Andalgram','713347',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49417,142,'Angadpur','713215',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49418,142,'Asanboni','713360',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49419,142,'Asansol Bazar','713301',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49420,142,'Asansol Court','713304',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49421,142,'Asansol H.O','713301',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49422,142,'B.B.College','713303',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49423,142,'Bahadurpur','713362',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49424,142,'Bahula','713322',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49425,142,'Baktarnagar','713347',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49426,142,'Balijuri','713363',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49427,142,'Ballavpur','713323',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49428,142,'Baltoria','713324',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49429,142,'Bamunara','713212',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49430,142,'Bansra','713358',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49431,142,'Baraboni','713334',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49432,142,'Baradhemo','713359',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49433,142,'Barakar','713324',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49434,142,'Basudevpur Jemari','713335',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49435,142,'Begunia Bazar','713324',1,0,'2022-03-03 12:45:05','2022-03-03 12:45:05'),(49436,142,'Bejdih','713359',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49437,142,'Benachity Market','713204',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49438,142,'Benachity','713213',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49439,142,'Benali','713375',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49440,142,'Bhanora','713334',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49441,142,'Bhiringi','713213',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49442,142,'Bhuri','713378',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49443,142,'Bidhanbag','713337',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49444,142,'Bidhannagar','713212',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49445,142,'Bidyanandapur','713371',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49446,142,'Bijpur','713358',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49447,142,'Bilpahari','713378',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49448,142,'Birkulti','713334',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49449,142,'Bogra','713332',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49450,142,'Burdwan Arrah','713212',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49451,142,'Burnpur Mkt','713325',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49452,142,'Burnpur','713325',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49453,142,'Burnpur Works','713325',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49454,142,'Charanpur','713330',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49455,142,'Chelod','713339',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49456,142,'Chinakuri','713360',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49457,142,'Chinchuria','713378',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49458,142,'Chittaranjan','713331',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49459,142,'Chittaranjan TS','713365',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49460,142,'Chotodighari','713326',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49461,142,'Churulia','713368',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49462,142,'City Centre','713216',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49463,142,'Dakhin Dhadka','713302',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49464,142,'Dakhin Khanda','713321',1,0,'2022-03-03 12:45:06','2022-03-03 12:45:06'),(49465,142,'Damra','713339',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49466,142,'Devchandnagar','713332',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49467,142,'Dhabani','713205',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49468,142,'Dhandadihi','713376',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49469,142,'Dharampur','713325',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49470,142,'Disergarh','713333',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49471,142,'Domahani Bazar','713334',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49472,142,'Durgapur Abl Township','713206',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49473,142,'Durgapur Alloy Steel Probject','713208',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49474,142,'Durgapur ASP SB Bureau','713208',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49475,142,'Durgapur Brick Field','713215',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49476,142,'Durgapur C Zone','713202',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49477,142,'Durgapur Chemicals','713215',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49478,142,'Durgapur Coke Oven Colony','713202',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49479,142,'Durgapur CRPF Camp','713214',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49480,142,'Durgapur DSP SB Bureau','713203',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49481,142,'Durgapur H.O','713201',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49482,142,'Durgapur Heavy Engg Plant','713210',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49483,142,'Durgapur Mg Avenue','713209',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49484,142,'Durgapur Project B Zone','713202',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49485,142,'Durgapur Re College','713209',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49486,142,'Durgapur RS','713201',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49487,142,'Durgapur Sagarbhanga Colony','713211',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49488,142,'Durgapur Steel Project','713203',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49489,142,'Durgapur Steel Town East','713205',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49490,142,'Durgapur Steel Town West','713204',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49491,142,'Durgapur Thermal Power Station','713207',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49492,142,'Egara','713323',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49493,142,'Ethora','713359',1,0,'2022-03-03 12:45:07','2022-03-03 12:45:07'),(49494,142,'Fuljhore','713206',1,0,'2022-03-03 12:45:08','2022-03-03 12:45:08'),(49495,142,'Gangutia','713333',1,0,'2022-03-03 12:45:08','2022-03-03 12:45:08'),(49496,142,'Gogla','713381',1,0,'2022-03-03 12:45:08','2022-03-03 12:45:08'),(49497,142,'Gopalpur','713212',1,0,'2022-03-03 12:45:08','2022-03-03 12:45:08'),(49498,142,'Gopinathpur','713219',1,0,'2022-03-03 12:45:08','2022-03-03 12:45:08'),(49499,142,'Gourbazar','713377',1,0,'2022-03-03 12:45:08','2022-03-03 12:45:08'),(49500,142,'Haripur (Bardhaman)','713378',1,0,'2022-03-03 12:45:08','2022-03-03 12:45:08'),(49501,142,'Hijalgora','713362',1,0,'2022-03-03 12:45:08','2022-03-03 12:45:08'),(49502,142,'Hill View','713304',1,0,'2022-03-03 12:45:08','2022-03-03 12:45:08'),(49503,142,'Hindustan Cables','713335',1,0,'2022-03-03 12:45:08','2022-03-03 12:45:08'),(49504,142,'Hirapur','713325',1,0,'2022-03-03 12:45:08','2022-03-03 12:45:08'),(49505,142,'Hutton Road','713301',1,0,'2022-03-03 12:45:08','2022-03-03 12:45:08'),(49506,142,'Ichapur','713363',1,0,'2022-03-03 12:45:08','2022-03-03 12:45:08'),(49507,142,'Ikrah','713362',1,0,'2022-03-03 12:45:08','2022-03-03 12:45:08'),(49508,142,'Jamgora','713363',1,0,'2022-03-03 12:45:08','2022-03-03 12:45:08'),(49509,142,'Jamgram','713315',1,0,'2022-03-03 12:45:08','2022-03-03 12:45:08'),(49510,142,'Jamuriahat','713336',1,0,'2022-03-03 12:45:08','2022-03-03 12:45:08'),(49511,142,'Jemahari','713337',1,0,'2022-03-03 12:45:08','2022-03-03 12:45:08'),(49512,142,'Jemua','713206',1,0,'2022-03-03 12:45:08','2022-03-03 12:45:08'),(49513,142,'Jhanjhra','713363',1,0,'2022-03-03 12:45:08','2022-03-03 12:45:08'),(49514,142,'Jhingri Mohallah','713302',1,0,'2022-03-03 12:45:08','2022-03-03 12:45:08'),(49515,142,'Jote Janki','713362',1,0,'2022-03-03 12:45:08','2022-03-03 12:45:08'),(49516,142,'Kajoragram','713338',1,0,'2022-03-03 12:45:08','2022-03-03 12:45:08'),(49517,142,'Kalajhoria','713325',1,0,'2022-03-03 12:45:08','2022-03-03 12:45:08'),(49518,142,'Kalipahari','713339',1,0,'2022-03-03 12:45:08','2022-03-03 12:45:08'),(49519,142,'Kalla Central Hospital','713340',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49520,142,'Kalyaneshwari','713369',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49521,142,'Kamalpur','713204',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49522,142,'Kankhaya','713373',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49523,142,'Kanyapur','713341',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49524,142,'Kapista','713315',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49525,142,'Kelejora','713334',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49526,142,'Kenda','713342',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49527,142,'Kendra','713380',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49528,142,'Kendua','713343',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49529,142,'Khandra','713363',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49530,142,'Kharsuli Bazar','713347',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49531,142,'Khottadihi','713378',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49532,142,'Kuldiha','713212',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49533,142,'Kulti','713343',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49534,142,'Kumardihi','713363',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49535,142,'Kumarpur','713304',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49536,142,'Lalbazar','713343',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49537,142,'Lalganj','713359',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49538,142,'Laudoha','713385',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49539,142,'Madanpur','713321',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49540,142,'Madhusudhanpur','713338',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49541,142,'Majhiara','713330',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49542,142,'Malandighi','713212',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49543,142,'Mandalpur','713336',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49544,142,'Mithani','713371',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49545,142,'Mohishila','713339',1,0,'2022-03-03 12:45:09','2022-03-03 12:45:09'),(49546,142,'Mohishila Colony','713303',1,0,'2022-03-03 12:45:10','2022-03-03 12:45:10'),(49547,142,'Moira Colliery','713321',1,0,'2022-03-03 12:45:10','2022-03-03 12:45:10'),(49548,142,'Nabagram','713363',1,0,'2022-03-03 12:45:10','2022-03-03 12:45:10'),(49549,142,'Nakrakonda','713363',1,0,'2022-03-03 12:45:10','2022-03-03 12:45:10'),(49550,142,'Nandi (Bardhaman)','713344',1,0,'2022-03-03 12:45:10','2022-03-03 12:45:10'),(49551,142,'Narsinghbandh','713325',1,0,'2022-03-03 12:45:10','2022-03-03 12:45:10'),(49552,142,'Naudiha','713218',1,0,'2022-03-03 12:45:10','2022-03-03 12:45:10'),(49553,142,'Neamatpur','713359',1,0,'2022-03-03 12:45:10','2022-03-03 12:45:10'),(49554,142,'Nimcha','713358',1,0,'2022-03-03 12:45:10','2022-03-03 12:45:10'),(49555,142,'Ningha','713370',1,0,'2022-03-03 12:45:10','2022-03-03 12:45:10'),(49556,142,'Nischinta','713373',1,0,'2022-03-03 12:45:10','2022-03-03 12:45:10'),(49557,142,'Nuni','713341',1,0,'2022-03-03 12:45:10','2022-03-03 12:45:10'),(49558,142,'Nupur','713323',1,0,'2022-03-03 12:45:10','2022-03-03 12:45:10'),(49559,142,'Nutandanga','713381',1,0,'2022-03-03 12:45:10','2022-03-03 12:45:10'),(49560,142,'Old Sitarampur','713359',1,0,'2022-03-03 12:45:10','2022-03-03 12:45:10'),(49561,142,'Oyaria','713217',1,0,'2022-03-03 12:45:10','2022-03-03 12:45:10'),(49562,142,'Palashbagan','713302',1,0,'2022-03-03 12:45:10','2022-03-03 12:45:10'),(49563,142,'Pandaveshwar','713346',1,0,'2022-03-03 12:45:10','2022-03-03 12:45:10'),(49564,142,'Panuria','713315',1,0,'2022-03-03 12:45:10','2022-03-03 12:45:10'),(49565,142,'Parascole','713338',1,0,'2022-03-03 12:45:10','2022-03-03 12:45:10'),(49566,142,'Parasea','713384',1,0,'2022-03-03 12:45:10','2022-03-03 12:45:10'),(49567,142,'Pariharpur','713373',1,0,'2022-03-03 12:45:10','2022-03-03 12:45:10'),(49568,142,'Patmohana','713371',1,0,'2022-03-03 12:45:10','2022-03-03 12:45:10'),(49569,142,'Patsora','713363',1,0,'2022-03-03 12:45:11','2022-03-03 12:45:11'),(49570,142,'Pratappur','713204',1,0,'2022-03-03 12:45:11','2022-03-03 12:45:11'),(49571,142,'Radhanagar','713325',1,0,'2022-03-03 12:45:11','2022-03-03 12:45:11'),(49572,142,'Radhanagar Rly Colony','713372',1,0,'2022-03-03 12:45:11','2022-03-03 12:45:11'),(49573,142,'Raghunathchak','713359',1,0,'2022-03-03 12:45:11','2022-03-03 12:45:11'),(49574,142,'Rahmatdanga','713325',1,0,'2022-03-03 12:45:11','2022-03-03 12:45:11'),(49575,142,'Railpar (Bardhaman)','713302',1,0,'2022-03-03 12:45:11','2022-03-03 12:45:11'),(49576,142,'Rajbandh','713212',1,0,'2022-03-03 12:45:11','2022-03-03 12:45:11'),(49577,142,'Rakhitpur','713212',1,0,'2022-03-03 12:45:11','2022-03-03 12:45:11'),(49578,142,'Rambandh','713325',1,0,'2022-03-03 12:45:11','2022-03-03 12:45:11'),(49579,142,'Rambandhutalaw','713303',1,0,'2022-03-03 12:45:11','2022-03-03 12:45:11'),(49580,142,'Ramkrishna Mission','713305',1,0,'2022-03-03 12:45:11','2022-03-03 12:45:11'),(49581,142,'Ramnagar','713324',1,0,'2022-03-03 12:45:11','2022-03-03 12:45:11'),(49582,142,'Raniganj H.O','713347',1,0,'2022-03-03 12:45:11','2022-03-03 12:45:11'),(49583,142,'Rannagar Gram','713346',1,0,'2022-03-03 12:45:11','2022-03-03 12:45:11'),(49584,142,'Roshna','713315',1,0,'2022-03-03 12:45:11','2022-03-03 12:45:11'),(49585,142,'Rotibati','713339',1,0,'2022-03-03 12:45:11','2022-03-03 12:45:11'),(49586,142,'Rupnarayanpur Bazar','713386',1,0,'2022-03-03 12:45:11','2022-03-03 12:45:11'),(49587,142,'S.B.Gorai Road','713301',1,0,'2022-03-03 12:45:11','2022-03-03 12:45:11'),(49588,142,'S.D.Hospital','713303',1,0,'2022-03-03 12:45:11','2022-03-03 12:45:11'),(49589,142,'Salanpur','713357',1,0,'2022-03-03 12:45:11','2022-03-03 12:45:11'),(49590,142,'Samdi','713359',1,0,'2022-03-03 12:45:11','2022-03-03 12:45:11'),(49591,142,'Sankarpur','713363',1,0,'2022-03-03 12:45:11','2022-03-03 12:45:11'),(49592,142,'Santa','713325',1,0,'2022-03-03 12:45:11','2022-03-03 12:45:11'),(49593,142,'Santinagar (Bardhaman)','713325',1,0,'2022-03-03 12:45:11','2022-03-03 12:45:11'),(49594,142,'Sarpi','713363',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49595,142,'Satgram','713383',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49596,142,'Seakulberia','713335',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49597,142,'Searsole Rajbari','713358',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49598,142,'Semallya','713346',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49599,142,'Shibpur','713212',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49600,142,'Shivpur','713330',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49601,142,'Siduli','713322',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49602,142,'Simjuri','713331',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49603,142,'Sitalpur','713333',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49604,142,'Sitarampur','713359',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49605,142,'Sonepur','713378',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49606,142,'Sripur','713373',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49607,142,'Sripur Bazar (Bardhaman)','713373',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49608,142,'Srirampur','713321',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49609,142,'Sunderchak','713360',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49610,142,'Suryanagar (Bardhaman)','713361',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49611,142,'Taltore','713336',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49612,142,'Toposi','713362',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49613,142,'U C Danga','713304',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49614,142,'Ukhra Puratanhattala','713363',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49615,142,'Ukhra','713363',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49616,142,'Ushagram','713303',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49617,142,'V.K.Nagar','713210',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49618,142,'Abhirampur','713144',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49619,142,'Abujhati','713166',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49620,142,'Adrahati','713428',1,0,'2022-03-03 12:45:12','2022-03-03 12:45:12'),(49621,142,'Aduria','713148',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49622,142,'Agardanga','713123',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49623,142,'Agradwi R.S.','713502',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49624,142,'Agradwip','713512',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49625,142,'Agriculture Farm','713101',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49626,142,'Ajhapur','713401',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49627,142,'Akalpoush','713157',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49628,142,'Amadpur','713154',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49629,142,'Amar','713141',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49630,142,'Amaragarh','713155',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49631,142,'Amarun','713125',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49632,142,'Amarun Bazar','713125',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49633,142,'Amgoria','713129',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49634,142,'Amila','713423',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49635,142,'Amul','713514',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49636,142,'Anguna','713408',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49637,142,'Ankhona','713129',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49638,142,'Ankra','713502',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49639,142,'Anukhal','713122',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49640,142,'Aogram','713121',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49641,142,'Arjunpur (Bardhaman)','713402',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49642,142,'Aruar','713121',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49643,142,'Asanpur','713145',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49644,142,'Astogoria','713405',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49645,142,'Athghara','713147',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49646,142,'Atuhatpara','713130',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49647,142,'Auria','713143',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49648,142,'Ausgram','713156',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49649,142,'Badla','713122',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49650,142,'Bagila','713146',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49651,142,'Bagnapara','713501',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49652,142,'Bahabpur','713146',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49653,142,'Bahadurpur','713408',1,0,'2022-03-03 12:45:13','2022-03-03 12:45:13'),(49654,142,'Baharan','713123',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49655,142,'Bahirghanna','713406',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49656,142,'Baidyapur','713122',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49657,142,'Baikunthapur','713104',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49658,142,'Bajekumarpur','713427',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49659,142,'Bajepratappur NDDF','713101',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49660,142,'Balgona','713407',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49661,142,'Ballavpara','713502',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49662,142,'Bamnabagram','713152',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49663,142,'Bamsor','713125',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49664,142,'Bamunara','713131',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49665,142,'Bamundi','713129',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49666,142,'Bamunpara','713146',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49667,142,'Bandhmura','713150',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49668,142,'Bankati','713148',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49669,142,'Banwaribad Raj','713123',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49670,142,'Bara Balgona','713141',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49671,142,'Bara Mahesh','713146',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49672,142,'Barabainan','713421',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49673,142,'Barabelun','713158',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49674,142,'Barakashiara','713141',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49675,142,'Baramitrapara','713409',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49676,142,'Barapalashan','713429',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49677,142,'Barapurulia','713140',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49678,142,'Barashyambazar','713143',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49679,142,'Barsul Unnayani','713124',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49680,142,'Basuda','713125',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49681,142,'Bazar Bankapashi','713143',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49682,142,'Begpur','713422',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49683,142,'Begut','713407',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49684,142,'Bekta','713428',1,0,'2022-03-03 12:45:14','2022-03-03 12:45:14'),(49685,142,'Belan','713428',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49686,142,'Belar Bhurkunda','713427',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49687,142,'Belari','713141',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49688,142,'Belerhat','713512',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49689,142,'Belgona Tulshidanga','713125',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49690,142,'Belgram','713141',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49691,142,'Belkas','713102',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49692,142,'Belna','713124',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49693,142,'Bera','713502',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49694,142,'Berenda','713126',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49695,142,'Berugram','713408',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49696,142,'Bhaduripara','713409',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49697,142,'Bhaghar','713141',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49698,142,'Bhagra','713422',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49699,142,'Bhagyabantapur','713502',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49700,142,'Bhaita','713149',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49701,142,'Bhalgram','713143',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49702,142,'Bhandardihi','713426',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49703,142,'Bharatpur','713148',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49704,142,'Bhatakul','713125',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49705,142,'Bhatar','713125',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49706,142,'Bhatkunda','713153',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49707,142,'Bhedia','713126',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49708,142,'Bhita','713102',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49709,142,'Bhojpur','713145',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49710,142,'Bhota','713141',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49711,142,'Bhuera','713152',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49712,142,'Bhuri','713432',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49713,142,'Bijpur','713142',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49714,142,'Bijur','713422',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49715,142,'Birudiha','713148',1,0,'2022-03-03 12:45:15','2022-03-03 12:45:15'),(49716,142,'Biruha','713146',1,0,'2022-03-03 12:45:16','2022-03-03 12:45:16'),(49717,142,'Bishnubati','713404',1,0,'2022-03-03 12:45:16','2022-03-03 12:45:16'),(49718,142,'Bitra','713422',1,0,'2022-03-03 12:45:16','2022-03-03 12:45:16'),(49719,142,'Bohar','713430',1,0,'2022-03-03 12:45:16','2022-03-03 12:45:16'),(49720,142,'Boinchee','713143',1,0,'2022-03-03 12:45:16','2022-03-03 12:45:16'),(49721,142,'Bolpur','713103',1,0,'2022-03-03 12:45:16','2022-03-03 12:45:16'),(49722,142,'Bonogram','713407',1,0,'2022-03-03 12:45:16','2022-03-03 12:45:16'),(49723,142,'Bonpas','713127',1,0,'2022-03-03 12:45:16','2022-03-03 12:45:16'),(49724,142,'Bontir','713103',1,0,'2022-03-03 12:45:16','2022-03-03 12:45:16'),(49725,142,'Borar','713146',1,0,'2022-03-03 12:45:16','2022-03-03 12:45:16'),(49726,142,'Borar','713424',1,0,'2022-03-03 12:45:16','2022-03-03 12:45:16'),(49727,142,'Boro Balaram','713124',1,0,'2022-03-03 12:45:16','2022-03-03 12:45:16'),(49728,142,'Bowai','713423',1,0,'2022-03-03 12:45:16','2022-03-03 12:45:16'),(49729,142,'Brahmanigram','713129',1,0,'2022-03-03 12:45:16','2022-03-03 12:45:16'),(49730,142,'Budbud','713403',1,0,'2022-03-03 12:45:16','2022-03-03 12:45:16'),(49731,142,'Bujrukhdighi','713423',1,0,'2022-03-03 12:45:16','2022-03-03 12:45:16'),(49732,142,'Burdwan Bar Library','713101',1,0,'2022-03-03 12:45:16','2022-03-03 12:45:16'),(49733,142,'Burdwan District School Board','713101',1,0,'2022-03-03 12:45:16','2022-03-03 12:45:16'),(49734,142,'Burdwan H.O','713101',1,0,'2022-03-03 12:45:16','2022-03-03 12:45:16'),(49735,142,'Burdwan Medical College','713104',1,0,'2022-03-03 12:45:16','2022-03-03 12:45:16'),(49736,142,'Burdwan Rajbari','713104',1,0,'2022-03-03 12:45:16','2022-03-03 12:45:16'),(49737,142,'Burdwan Rs','713101',1,0,'2022-03-03 12:45:16','2022-03-03 12:45:16'),(49738,142,'Burdwan University','713104',1,0,'2022-03-03 12:45:16','2022-03-03 12:45:16'),(49739,142,'Chagram','713423',1,0,'2022-03-03 12:45:16','2022-03-03 12:45:16'),(49740,142,'Chakdighi','713404',1,0,'2022-03-03 12:45:17','2022-03-03 12:45:17'),(49741,142,'Chakmuria','713406',1,0,'2022-03-03 12:45:17','2022-03-03 12:45:17'),(49742,142,'Chakta','713129',1,0,'2022-03-03 12:45:17','2022-03-03 12:45:17'),(49743,142,'Chakuria','713143',1,0,'2022-03-03 12:45:17','2022-03-03 12:45:17'),(49744,142,'Chanak','713131',1,0,'2022-03-03 12:45:17','2022-03-03 12:45:17'),(49745,142,'Chanchai','713151',1,0,'2022-03-03 12:45:17','2022-03-03 12:45:17'),(49746,142,'Chandipur Berugram','713142',1,0,'2022-03-03 12:45:17','2022-03-03 12:45:17'),(49747,142,'Chandipur Kanpur','713125',1,0,'2022-03-03 12:45:17','2022-03-03 12:45:17'),(49748,142,'Chandrahati','713102',1,0,'2022-03-03 12:45:17','2022-03-03 12:45:17'),(49749,142,'Chandul','713141',1,0,'2022-03-03 12:45:17','2022-03-03 12:45:17'),(49750,142,'Chanduli','713502',1,0,'2022-03-03 12:45:17','2022-03-03 12:45:17'),(49751,142,'Chotkhanda','713146',1,0,'2022-03-03 12:45:17','2022-03-03 12:45:17'),(49752,142,'Chotobainan','713423',1,0,'2022-03-03 12:45:17','2022-03-03 12:45:17'),(49753,142,'Chotobelun','713102',1,0,'2022-03-03 12:45:17','2022-03-03 12:45:17'),(49754,142,'Chotonilpur','713103',1,0,'2022-03-03 12:45:17','2022-03-03 12:45:17'),(49755,142,'Chotoramchandrapur','713148',1,0,'2022-03-03 12:45:17','2022-03-03 12:45:17'),(49756,142,'Dainhat','713502',1,0,'2022-03-03 12:45:17','2022-03-03 12:45:17'),(49757,142,'Deasa Aligram','713128',1,0,'2022-03-03 12:45:17','2022-03-03 12:45:17'),(49758,142,'Deasin','713502',1,0,'2022-03-03 12:45:17','2022-03-03 12:45:17'),(49759,142,'Debip R.S.','713146',1,0,'2022-03-03 12:45:17','2022-03-03 12:45:17'),(49760,142,'Debipur','713146',1,0,'2022-03-03 12:45:17','2022-03-03 12:45:17'),(49761,142,'Debpur','713121',1,0,'2022-03-03 12:45:17','2022-03-03 12:45:17'),(49762,142,'Debsala','713148',1,0,'2022-03-03 12:45:17','2022-03-03 12:45:17'),(49763,142,'Denur','713145',1,0,'2022-03-03 12:45:17','2022-03-03 12:45:17'),(49764,142,'Deoradanga','713128',1,0,'2022-03-03 12:45:17','2022-03-03 12:45:17'),(49765,142,'Deriapur','713124',1,0,'2022-03-03 12:45:17','2022-03-03 12:45:17'),(49766,142,'Dewania','713422',1,0,'2022-03-03 12:45:18','2022-03-03 12:45:18'),(49767,142,'Dhatrigram','713405',1,0,'2022-03-03 12:45:18','2022-03-03 12:45:18'),(49768,142,'Dhenria','713125',1,0,'2022-03-03 12:45:18','2022-03-03 12:45:18'),(49769,142,'Dhuluk','713166',1,0,'2022-03-03 12:45:18','2022-03-03 12:45:18'),(49770,142,'Digha','713128',1,0,'2022-03-03 12:45:18','2022-03-03 12:45:18'),(49771,142,'Dignagar','713128',1,0,'2022-03-03 12:45:18','2022-03-03 12:45:18'),(49772,142,'Dirghapara','713515',1,0,'2022-03-03 12:45:18','2022-03-03 12:45:18'),(49773,142,'Dwarnari','713403',1,0,'2022-03-03 12:45:18','2022-03-03 12:45:18'),(49774,142,'Ehiapur','713129',1,0,'2022-03-03 12:45:18','2022-03-03 12:45:18'),(49775,142,'Eklakhi','713427',1,0,'2022-03-03 12:45:18','2022-03-03 12:45:18'),(49776,142,'Eral','713144',1,0,'2022-03-03 12:45:18','2022-03-03 12:45:18'),(49777,142,'Fagupur','713104',1,0,'2022-03-03 12:45:18','2022-03-03 12:45:18'),(49778,142,'Falishpur','713422',1,0,'2022-03-03 12:45:18','2022-03-03 12:45:18'),(49779,142,'Faridpur','713426',1,0,'2022-03-03 12:45:18','2022-03-03 12:45:18'),(49780,142,'Fulgram','713125',1,0,'2022-03-03 12:45:18','2022-03-03 12:45:18'),(49781,142,'Galsi','713406',1,0,'2022-03-03 12:45:18','2022-03-03 12:45:18'),(49782,142,'Gandhpur','713143',1,0,'2022-03-03 12:45:18','2022-03-03 12:45:18'),(49783,142,'Gangatikuri','713123',1,0,'2022-03-03 12:45:18','2022-03-03 12:45:18'),(49784,142,'Gatistha','713131',1,0,'2022-03-03 12:45:18','2022-03-03 12:45:18'),(49785,142,'Genna Deriapur','713128',1,0,'2022-03-03 12:45:18','2022-03-03 12:45:18'),(49786,142,'Genral','713152',1,0,'2022-03-03 12:45:18','2022-03-03 12:45:18'),(49787,142,'Ghordourchati','713103',1,0,'2022-03-03 12:45:18','2022-03-03 12:45:18'),(49788,142,'Ghosh','713146',1,0,'2022-03-03 12:45:18','2022-03-03 12:45:18'),(49789,142,'Gidhgram','713143',1,0,'2022-03-03 12:45:18','2022-03-03 12:45:18'),(49790,142,'Giur','713423',1,0,'2022-03-03 12:45:19','2022-03-03 12:45:19'),(49791,142,'Gobordhanpur','713143',1,0,'2022-03-03 12:45:19','2022-03-03 12:45:19'),(49792,142,'Goda Annada','713122',1,0,'2022-03-03 12:45:19','2022-03-03 12:45:19'),(49793,142,'Gohagram','713428',1,0,'2022-03-03 12:45:19','2022-03-03 12:45:19'),(49794,142,'Golapbag','713104',1,0,'2022-03-03 12:45:19','2022-03-03 12:45:19'),(49795,142,'Golatun','713145',1,0,'2022-03-03 12:45:19','2022-03-03 12:45:19'),(49796,142,'Golgram','713424',1,0,'2022-03-03 12:45:19','2022-03-03 12:45:19'),(49797,142,'Golgrammathurapur','713406',1,0,'2022-03-03 12:45:19','2022-03-03 12:45:19'),(49798,142,'Goligram','713126',1,0,'2022-03-03 12:45:19','2022-03-03 12:45:19'),(49799,142,'Gonpur','713128',1,0,'2022-03-03 12:45:19','2022-03-03 12:45:19'),(49800,142,'Gonpur','713160',1,0,'2022-03-03 12:45:19','2022-03-03 12:45:19'),(49801,142,'Gontar','713146',1,0,'2022-03-03 12:45:19','2022-03-03 12:45:19'),(49802,142,'Gopalbera','713426',1,0,'2022-03-03 12:45:19','2022-03-03 12:45:19'),(49803,142,'Gramdighi','713127',1,0,'2022-03-03 12:45:19','2022-03-03 12:45:19'),(49804,142,'Gushkara New Town','713128',1,0,'2022-03-03 12:45:19','2022-03-03 12:45:19'),(49805,142,'Gushkara','713128',1,0,'2022-03-03 12:45:19','2022-03-03 12:45:19'),(49806,142,'Habaspur','713401',1,0,'2022-03-03 12:45:19','2022-03-03 12:45:19'),(49807,142,'Hargram','713125',1,0,'2022-03-03 12:45:19','2022-03-03 12:45:19'),(49808,142,'Harisava','713104',1,0,'2022-03-03 12:45:19','2022-03-03 12:45:19'),(49809,142,'Hatbele','713409',1,0,'2022-03-03 12:45:19','2022-03-03 12:45:19'),(49810,142,'Hatgobindapur','713407',1,0,'2022-03-03 12:45:19','2022-03-03 12:45:19'),(49811,142,'Hatkalua','713129',1,0,'2022-03-03 12:45:19','2022-03-03 12:45:19'),(49812,142,'Hatkirtinagar','713128',1,0,'2022-03-03 12:45:19','2022-03-03 12:45:19'),(49813,142,'Hatkirtinagar','713162',1,0,'2022-03-03 12:45:19','2022-03-03 12:45:19'),(49814,142,'Hatsridharpur','713146',1,0,'2022-03-03 12:45:19','2022-03-03 12:45:19'),(49815,142,'Hedogora','713152',1,0,'2022-03-03 12:45:19','2022-03-03 12:45:19'),(49816,142,'Hijalna','713103',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49817,142,'Hossainpur','713125',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49818,142,'Huria','713424',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49819,142,'Ibrahambadsonadanga','713422',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49820,142,'Ichlabad','713103',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49821,142,'Ilsara','713166',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49822,142,'Irkona','713428',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49823,142,'Islampur','713502',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49824,142,'Jabagram','713143',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49825,142,'Jabui','713146',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49826,142,'Jadabganj','713128',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49827,142,'Jaipur','713128',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49828,142,'Jamalpur (Bardhaman)','713408',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49829,142,'Jamar','713102',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49830,142,'Jamna','713422',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49831,142,'Jamra','713143',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49832,142,'Jaragram','713404',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49833,142,'Jaugram','713166',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49834,142,'Jharul','713403',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49835,142,'Jhaudanga','713512',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49836,142,'Jhikra','713422',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49837,142,'Jhilu','713147',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49838,142,'Jogeswardihi','713143',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49839,142,'Joteram','713104',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49840,142,'Jotsrirampur','713408',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49841,142,'Joykrishnapur','713406',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49842,142,'Jubila','713424',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49843,142,'Kachutia','713123',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49844,142,'Kaigram','713145',1,0,'2022-03-03 12:45:20','2022-03-03 12:45:20'),(49845,142,'Kaiti','713423',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49846,142,'Kalanabagram','713124',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49847,142,'Kalanpur','713131',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49848,142,'Kalapahari','713125',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49849,142,'Kalibele','713146',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49850,142,'Kaligram','713102',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49851,142,'Kalikapur','713502',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49852,142,'Kalna Court','713409',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49853,142,'Kalna','713409',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49854,142,'Kalui','713145',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49855,142,'Kamalakanta Kalibari','713102',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49856,142,'Kamalpur','713103',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49857,142,'Kamargoria','713408',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49858,142,'Kamarhati','713421',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49859,142,'Kamarkita','713426',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49860,142,'Kanchannagar','713102',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49861,142,'Kandra (Bardhaman)','713129',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49862,142,'Kanksa','713148',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49863,142,'Kanpur','713422',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49864,142,'Kantodihi','713129',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49865,142,'Karajgram','713502',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49866,142,'Karanda','713422',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49867,142,'Karjanachati','713102',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49868,142,'Karui','713143',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49869,142,'Kasa','713145',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49870,142,'Kasba','713403',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49871,142,'Kasenagar','713131',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49872,142,'Kashiara','713407',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49873,142,'Kasthakurumba','713426',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49874,142,'Katshihi','713422',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49875,142,'Katwa Bazar','713130',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49876,142,'Katwa College','713130',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49877,142,'Katwa H.O','713130',1,0,'2022-03-03 12:45:21','2022-03-03 12:45:21'),(49878,142,'Katwa Station Bazar','713130',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49879,142,'Keleti','713128',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49880,142,'Kendur','713427',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49881,142,'Kenna','713401',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49882,142,'Keotara','713166',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49883,142,'Kerotia','713152',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49884,142,'Keshabpur','713423',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49885,142,'Ketugram','713140',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49886,142,'Keuguri','713123',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49887,142,'Keunta','713423',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49888,142,'Khagrakaranda','713149',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49889,142,'Khaithan','713143',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49890,142,'Khajurdihi','713150',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49891,142,'Khaluibill','713101',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49892,142,'Khana Jn.','713141',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49893,142,'Khandaghosh','713142',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49894,142,'Khandaridanga','713144',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49895,142,'Khandraparulia','713422',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49896,142,'Khanji','713129',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49897,142,'Khano','713141',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49898,142,'Khatundi','713519',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49899,142,'Kherur','713125',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49900,142,'Khirgram','713143',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49901,142,'Khurtuna','713147',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49902,142,'Khurul','713127',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49903,142,'Kolkol','713144',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49904,142,'Komarpur','713129',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49905,142,'Korar','713102',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49906,142,'Kota','713148',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49907,142,'Kotalhat','713102',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49908,142,'Koyar','713423',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49909,142,'Koychor','713143',1,0,'2022-03-03 12:45:22','2022-03-03 12:45:22'),(49910,142,'Krishnadebpur','713405',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49911,142,'Kshetia','713102',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49912,142,'Kuara','713143',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49913,142,'Kubajpur','713102',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49914,142,'Kuchut','713407',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49915,142,'Kulai','713143',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49916,142,'Kuldiha','713153',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49917,142,'Kuley','713422',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49918,142,'Kulingram','713166',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49919,142,'Kulut','713422',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49920,142,'Kumarganj','713427',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49921,142,'Kunda','713147',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49922,142,'Kurmun','713102',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49923,142,'Kurumba','713126',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49924,142,'Kusumgram','713422',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49925,142,'Lakhuria','713131',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49926,142,'Lakshmipur','713512',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49927,142,'Lakurdi','713102',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49928,142,'Lohar','713145',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49929,142,'Madabdihi','713424',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49930,142,'Madanagar','713424',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49931,142,'Madhyagram','713422',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49932,142,'Mahachanda','713102',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49933,142,'Mahachanda','713103',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49934,142,'Mahata','713128',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49935,142,'Maheshdanga','713151',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49936,142,'Majhigram','713143',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49937,142,'Majida','713512',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49938,142,'Malamba','713426',1,0,'2022-03-03 12:45:23','2022-03-03 12:45:23'),(49939,142,'Maldanga','713145',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49940,142,'Mamudpur','713422',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49941,142,'Mandalgram','713426',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49942,142,'Mandarbati','713127',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49943,142,'Mangalpur','713422',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49944,142,'Mankar','713144',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49945,142,'Manteswar','713145',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49946,142,'Masagram','713401',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49947,142,'Masidpur','713428',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49948,142,'Masthuli','713502',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49949,142,'Masundi','713129',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49950,142,'Mathrun','713143',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49951,142,'Medgachi','713405',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49952,142,'Memari Bazar','713146',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49953,142,'Memari','713146',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49954,142,'Meral','713424',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49955,142,'Mirjapur','713102',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49956,142,'Mohanpur','713127',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49957,142,'Mohara','713428',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49958,142,'Mollasarul','713428',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49959,142,'Mongalkote','713147',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49960,142,'Monoharsujapur','713406',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49961,142,'Mougram','713123',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49962,142,'Muraripur','713419',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49963,142,'Muratipur','713121',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49964,142,'Nabagram','713140',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49965,142,'Nabagram (Bardhaman)','713166',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49966,142,'Nabastha','713407',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49967,142,'Nadanghat','713515',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49968,142,'Nandai','713405',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49969,142,'Narayanapur (Bardhaman)','713512',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49970,142,'Narayanpur','713127',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49971,142,'Narugram','713424',1,0,'2022-03-03 12:45:24','2022-03-03 12:45:24'),(49972,142,'Nasigram','713165',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49973,142,'Natumohanpur','713124',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49974,142,'Nibhuji Bazar','713434',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49975,142,'Nigun','713143',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49976,142,'Nimo','713146',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49977,142,'Nirol','713140',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49978,142,'Nishchintapur','713142',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49979,142,'Nityanandapur','713125',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49980,142,'Nole','713424',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49981,142,'Nowapara','713515',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49982,142,'Nrisinghapur','713126',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49983,142,'Nrisinghapur','713520',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49984,142,'Nurkona','713403',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49985,142,'Nutanganj','713102',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49986,142,'Nutanhat','713147',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49987,142,'Nutanpalli','713101',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49988,142,'Oari','713142',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49989,142,'Orgram','713128',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49990,142,'Orgram','713167',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49991,142,'Pachim Kharampur','713125',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49992,142,'Pachkula','713141',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49993,142,'Pachundi','713123',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49994,142,'Pahalanpur','713427',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49995,142,'Paharhati','713168',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49996,142,'Painta','713427',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49997,142,'Palar','713125',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49998,142,'Palashan','713424',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(49999,142,'Paligram','713128',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(50000,142,'Palishgram','713147',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(50001,142,'Palita','713143',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(50002,142,'Palla','713151',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(50003,142,'Palla R.S.','713151',1,0,'2022-03-03 12:45:25','2022-03-03 12:45:25'),(50004,142,'Palsona','713143',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50005,142,'Panagar Bazara','713148',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50006,142,'Panagar (Bardhaman)','713420',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50007,142,'Panchra','713401',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50008,142,'Panduk','713152',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50009,142,'Panjua','713143',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50010,142,'Panuhat','713516',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50011,142,'Paraj','713403',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50012,142,'Paratal','713408',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50013,142,'Parbatpur','713408',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50014,142,'Parisha','713153',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50015,142,'Pasanda','713421',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50016,142,'Patuli','713512',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50017,142,'Patuli Station Bazar','713512',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50018,142,'Pichkuri','713128',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50019,142,'Pindira Boura','713143',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50020,142,'Piplon','713422',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50021,142,'Poshla','713125',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50022,142,'Pratappur','713144',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50023,142,'Puini','713143',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50024,142,'Purangaon','713428',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50025,142,'Purba Gopalpur','713143',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50026,142,'Purbo Khanpur Bamunpara','713143',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50027,142,'Purbo Noaapara','713147',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50028,142,'Purguna','713422',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50029,142,'Pursa','713406',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50030,142,'Pursura','713406',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50031,142,'Putsuri','713145',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50032,142,'Radhakantapur','713146',1,0,'2022-03-03 12:45:26','2022-03-03 12:45:26'),(50033,142,'Raigram','713422',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50034,142,'Raina','713421',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50035,142,'Rairamchandrapur','713128',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50036,142,'Rajganj Asthal','713102',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50037,142,'Rajoor','713129',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50038,142,'Rambati','713424',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50039,142,'Ramchandrapur','713426',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50040,142,'Ramgopalpur','713403',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50041,142,'Ranisayar','713101',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50042,142,'Rasulpur','713151',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50043,142,'Ratanpur','713121',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50044,142,'Rayan','713104',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50045,142,'Reora Gopalpur','713166',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50046,142,'Rondia','713420',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50047,142,'Roundi Srirampur','713140',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50048,142,'Runkini Mahalla','713404',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50049,142,'Rupsa','713142',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50050,142,'Sadipur','713408',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50051,142,'Sadipur Berugram','713129',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50052,142,'Sagrai','713424',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50053,142,'Sah Hossainpur','713408',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50054,142,'Saha Basantapur','713126',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50055,142,'Sahajpur','713405',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50056,142,'Sahajpur Hattala','713424',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50057,142,'Sahebganj','713121',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50058,142,'Saknara','713421',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50059,142,'Saktigarh (Bardhaman)','713149',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50060,142,'Saloon','713103',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50061,142,'Samantapara','713144',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50062,142,'Samanti','713426',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50063,142,'Sanchalida','713121',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50064,142,'Sanchra','713401',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50065,142,'Sankai','713123',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50066,142,'Sankari','713424',1,0,'2022-03-03 12:45:27','2022-03-03 12:45:27'),(50067,142,'Sankharipukur','713103',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50068,142,'Sanko','713141',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50069,142,'Sanktia','713408',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50070,142,'Saragram','713143',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50071,142,'Saranga','713423',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50072,142,'Sarbamangala Bari','713104',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50073,142,'Sarulia','713128',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50074,142,'Sasanga','713142',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50075,142,'Sasinara','713146',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50076,142,'Satgachia','713422',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50077,142,'Satinandi','713141',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50078,142,'Sehara','713423',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50079,142,'Serorai','713428',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50080,142,'Shar','713128',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50081,142,'Sherpur','713427',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50082,142,'Shibda','713128',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50083,142,'Shibloon','713140',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50084,142,'Shilampur','713169',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50085,142,'Shimulia','713123',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50086,142,'Shimulia Danga','713143',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50087,142,'Shyamdasbati','713424',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50088,142,'Shyamnabagram','713125',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50089,142,'Shyamsundar','713424',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50090,142,'Shyamsundarpur','713141',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50091,142,'Simdal','713141',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50092,142,'Singerkone','713170',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50093,142,'Singholi','713145',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50094,142,'Sitahati','713123',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50095,142,'Sodda','713407',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50096,142,'Somaipur','713128',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50097,142,'Somsar','713142',1,0,'2022-03-03 12:45:28','2022-03-03 12:45:28'),(50098,142,'Sonai','713148',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50099,142,'Sonapalashi','713407',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50100,142,'Sonargaria','713404',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50101,142,'Sotla','713422',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50102,142,'Srigopalpur','713129',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50103,142,'Srigram','713129',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50104,142,'Sripalli','713103',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50105,142,'Suata','713171',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50106,142,'Sudhanpur','713101',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50107,142,'Suhari','713407',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50108,142,'Sukur','713407',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50109,142,'Sultanpur','713146',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50110,142,'Sundarghat','713103',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50111,142,'Sunur','713125',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50112,142,'Surekanla','713408',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50113,142,'Susunia','713426',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50114,142,'Takipur','713141',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50115,142,'Talit','713141',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50116,142,'Tarasusunia','713145',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50117,142,'Teandul','713424',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50118,142,'Tehatta','713122',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50119,142,'Telua','713424',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50120,142,'Thangapara','713143',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50121,142,'Torkona','713423',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50122,142,'Trilokchandpur','713172',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50123,142,'Uchalan','713427',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50124,142,'Uchhagram','713406',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50125,142,'Ukhra Sarangpur','713512',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50126,142,'Ukhrid','713142',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50127,142,'Uniatatarpur','713128',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50128,142,'Uniatatarpur','713173',1,0,'2022-03-03 12:45:29','2022-03-03 12:45:29'),(50129,142,'Untia','713426',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50130,142,'Ura','713433',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50131,142,'Uttarramnagar','713152',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50132,142,'Amarpur','712410',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50133,142,'Gotan','712410',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50134,143,'Abadanga','731303',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50135,143,'Abinashpur','731121',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50136,143,'Adityapur','731204',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50137,143,'Ahmadpur','731201',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50138,143,'Albandha','731204',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50139,143,'Aligarh','731130',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50140,143,'Aligram','731302',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50141,143,'Ambhua','731222',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50142,143,'Amdole','731219',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50143,143,'Amjolpahari','731127',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50144,143,'Anantapurkanaipur','731242',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50145,143,'Atla','731233',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50146,143,'Ayas','731243',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50147,143,'B.Collectorate','731101',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50148,143,'Babuijore','731125',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50149,143,'Bagdola','731234',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50150,143,'Bagdowra','731204',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50151,143,'Bagrakonda','731201',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50152,143,'Bahadurpur','731219',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50153,143,'Bahiri','731240',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50154,143,'Bahutali','731222',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50155,143,'Baidyanathpur','731127',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50156,143,'Bakreswar','731123',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50157,143,'Baliharpur','731127',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50158,143,'Balijuri','731123',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50159,143,'Banagram','731240',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50160,143,'Bandar','731215',1,0,'2022-03-03 12:45:30','2022-03-03 12:45:30'),(50161,143,'Bandhaipur','731222',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50162,143,'Bandhkhola','731237',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50163,143,'Bangachhatra','731240',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50164,143,'Bangsabati','731221',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50165,143,'Banior','731243',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50166,143,'Bansanka','731121',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50167,143,'Bara','731237',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50168,143,'Baraalunda','731103',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50169,143,'Barabagan','731103',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50170,143,'Barakartickchungri','731202',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50171,143,'Baram','731103',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50172,143,'Barapahari','731223',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50173,143,'Barasija','731234',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50174,143,'Barha','731301',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50175,143,'Barhra','731125',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50176,143,'Barla','731220',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50177,143,'Barsal','731233',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50178,143,'Baruipara (Birbhum)','731101',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50179,143,'Basudevpur','731234',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50180,143,'Baswa (Birbhum)','731202',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50181,143,'Bataspur','731201',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50182,143,'Batikar','731121',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50183,143,'Bautia','731243',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50184,143,'Begunia','731245',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50185,143,'Belai','731215',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50186,143,'Belatisultanpur','731236',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50187,143,'Belhati','731301',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50188,143,'Belia','731201',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50189,143,'Beliakuricha','731234',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50190,143,'Beliamritunjoypur','731223',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50191,143,'Beliapalsa','731219',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50192,143,'Benuria','731236',1,0,'2022-03-03 12:45:31','2022-03-03 12:45:31'),(50193,143,'Bergram','731236',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50194,143,'Bhabanandapur','731243',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50195,143,'Bhabanipur','731126',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50196,143,'Bhabanipur Bhatra','731222',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50197,143,'Bhadista','731238',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50198,143,'Bhadrapur','731237',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50199,143,'Bhadulia','731125',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50200,143,'Bhalas','731303',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50201,143,'Bhalkuti','731201',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50202,143,'Bharkata','731216',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50203,143,'Bhatra','731303',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50204,143,'Bheramari','731236',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50205,143,'Bhimpur','731219',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50206,143,'Bhoromorekol','731201',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50207,143,'Bhurkuna','731102',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50208,143,'Bipranandigram','731219',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50209,143,'Bipratikuri','731303',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50210,143,'Birchandrapur','731245',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50211,143,'Bishnukhanda','731236',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50212,143,'Bishnupur (Birbhum)','731244',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50213,143,'Bishnupurkulkuri','731127',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50214,143,'Bishore','731238',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50215,143,'Bk.T.P.P','731104',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50216,143,'Bolpur Bazar','731204',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50217,143,'Bolpur Court','731204',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50218,143,'Bolpur','731204',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50219,143,'Bolpur Trisulapatty','731204',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50220,143,'Bolpur Ukilpatty','731204',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50221,143,'Bonha','731221',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50222,143,'Bon-mohurapur','731222',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50223,143,'Bonorampur','731222',1,0,'2022-03-03 12:45:32','2022-03-03 12:45:32'),(50224,143,'Boruagopalpur','731222',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50225,143,'Brahmanbahara','731213',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50226,143,'Brahmandihi','731302',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50227,143,'Brahmankhanda','731215',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50228,143,'Brahmanpara','731302',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50229,143,'Budhigram','731244',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50230,143,'Bujung','731242',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50231,143,'Bunia','731303',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50232,143,'Ch.Nanoor','731301',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50233,143,'Chakaipur','731233',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50234,143,'Chakdaha','731102',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50235,143,'Chakpara','731233',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50236,143,'Chandipur Tarapith','731233',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50237,143,'Chandpara','731241',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50238,143,'Changuria','731102',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50239,143,'Charicha','731127',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50240,143,'Charkolgram','731301',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50241,143,'Chatra (Birbhum)','731238',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50242,143,'Chautara','731234',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50243,143,'Chhamna','731213',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50244,143,'Chhatina','731238',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50245,143,'Chhototurigram','731213',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50246,143,'Chilinpur','731243',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50247,143,'Chinpai','731104',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50248,143,'Choto-sangra','731201',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50249,143,'Chowhatta','731201',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50250,143,'Chunpalasi','731214',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50251,143,'Churar','731133',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50252,143,'Dabuk','731216',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50253,143,'Dadpur','731223',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50254,143,'Dakhalbati','731202',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50255,143,'Dakshingram','731245',1,0,'2022-03-03 12:45:33','2022-03-03 12:45:33'),(50256,143,'Damdama','731129',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50257,143,'Damra','731216',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50258,143,'Dantura','731221',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50259,143,'Daranda','731236',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50260,143,'Daronda Ranipara','731302',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50261,143,'Darpasila','731204',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50262,143,'Daskalgram','731302',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50263,143,'Daspalsa','731213',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50264,143,'Debagram Anaipur','731302',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50265,143,'Debagram','731220',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50266,143,'Debagramchuramali','731127',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50267,143,'Debiparulia','731244',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50268,143,'Dekhuria','731233',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50269,143,'Delora','731124',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50270,143,'Deriapur','731234',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50271,143,'Derpur','731234',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50272,143,'Deucha','731132',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50273,143,'Dewas Chandpur','731201',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50274,143,'Dhalla','731214',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50275,143,'Dhananjoypur','731219',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50276,143,'Dholtikuri','731129',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50277,143,'Dhrubabati','731302',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50278,143,'Digha','731236',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50279,143,'Dighalgram','731216',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50280,143,'Diha','731220',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50281,143,'Dohira','731234',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50282,143,'Dubrajpur','731123',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50283,143,'Dumrut','731214',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50284,143,'Dumurgram','731219',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50285,143,'Dunigram','731241',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50286,143,'Duria','731238',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50287,143,'Dwarka','731303',1,0,'2022-03-03 12:45:34','2022-03-03 12:45:34'),(50288,143,'Dwaruri','731216',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50289,143,'Edrakpur','731219',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50290,143,'Fewgram','731302',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50291,143,'Fulur','731234',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50292,143,'Gadadharpur','731129',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50293,143,'Gadadharpur R.S.','731234',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50294,143,'Gaganpur','731221',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50295,143,'Ganeshpur','731126',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50296,143,'Gannaserandi','731215',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50297,143,'Ganra','731124',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50298,143,'Gargaria','731121',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50299,143,'Geruapahari','731125',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50300,143,'Ghatdurlavpur','731126',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50301,143,'Gheedaha','731240',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50302,143,'Ghoratori','731124',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50303,143,'Ghoshgram','731245',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50304,143,'Ghurisha','731214',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50305,143,'Goalmal','731238',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50306,143,'Gohaliara','731126',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50307,143,'Gonpur','731216',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50308,143,'Gopalchak','731237',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50309,143,'Gopalpur','731303',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50310,143,'Gopegram','731242',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50311,143,'Gorola','731234',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50312,143,'Gosainpur','731220',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50313,143,'Gug','731233',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50314,143,'Gunutia','731234',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50315,143,'Hansra','731214',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50316,143,'Haraipur','731102',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50317,143,'Haridaspur','731243',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50318,143,'Harinsingha','731132',1,0,'2022-03-03 12:45:35','2022-03-03 12:45:35'),(50319,143,'Harioka','731243',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50320,143,'Harowa','731221',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50321,143,'Hatia','731201',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50322,143,'Hatjanbazar','731102',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50323,143,'Hatora','731234',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50324,143,'Hatserandi','731240',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50325,143,'Hazratpur','731125',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50326,143,'Hetampur Rajbati','731124',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50327,143,'Hilora','731221',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50328,143,'Ikra','731129',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50329,143,'Ikra Hazrapur','731201',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50330,143,'Illambazar','731214',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50331,143,'Indus','731303',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50332,143,'Ishakpur','731303',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50333,143,'Iswarpurndtso','731201',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50334,143,'Itagoria','731103',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50335,143,'Jahidpur','731125',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50336,143,'Jajigram','731221',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50337,143,'Jalandi','731240',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50338,143,'Jangaldubrajpur','731123',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50339,143,'Janubazar','731124',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50340,143,'Januri','731102',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50341,143,'Jatra','731124',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50342,143,'Jesthabhabanipur','731237',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50343,143,'Jhirul','731124',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50344,143,'Jiwe','731234',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50345,143,'Jogai','731238',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50346,143,'Joplai','731123',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50347,143,'Joydevkenduli','731124',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50348,143,'Joykrishnapur','731202',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50349,143,'Joypur','731130',1,0,'2022-03-03 12:45:36','2022-03-03 12:45:36'),(50350,143,'Junidpur','731103',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50351,143,'Kabilpur','731132',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50352,143,'Kahinagar','731219',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50353,143,'Kaitha','731220',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50354,143,'Kajipara','731303',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50355,143,'Kalahapur','731219',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50356,143,'Kaleswar','731213',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50357,143,'Kalitha','731220',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50358,143,'Kaluha','731202',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50359,143,'Kamadpur','731303',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50360,143,'Kanachi','731216',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50361,143,'Kanaighat','731222',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50362,143,'Kanakpur','731219',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50363,143,'Kandighi','731124',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50364,143,'Kankartala','731125',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50365,143,'Kanserhat','731121',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50366,143,'Kanspai','731102',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50367,143,'Kantagoria','731237',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50368,143,'Kanutia','731213',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50369,143,'Kapista','731127',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50370,143,'Karidhya','731126',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50371,143,'Karkaria','731233',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50372,143,'Kasba','731236',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50373,143,'Kasimnagar','731221',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50374,143,'Kastogoria','731216',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50375,143,'Kathia','731219',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50376,143,'Katigram','731216',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50377,143,'Kendragoria','731125',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50378,143,'Khandagram','731124',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50379,143,'Khanjanpur','731236',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50380,143,'Khanpur','731238',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50381,143,'Khantanga','731103',1,0,'2022-03-03 12:45:37','2022-03-03 12:45:37'),(50382,143,'Kharbona','731233',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50383,143,'Kharun','731233',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50384,143,'Khemedda','731245',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50385,143,'Kheyerpara','731201',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50386,143,'Khoyrasole','731125',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50387,143,'Khujutipara','731215',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50388,143,'Kirnahar','731302',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50389,143,'Kogram','731220',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50390,143,'Konarpur','731201',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50391,143,'Koreya','731302',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50392,143,'Kota','731124',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50393,143,'Kotasur','731213',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50394,143,'Koyemba','731241',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50395,143,'Koyra','731214',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50396,143,'Krishnapur','731237',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50397,143,'Kuchligopalpur','731204',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50398,143,'Kuchuighata','731201',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50399,143,'Kukhudihi','731103',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50400,143,'Kukutia','731123',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50401,143,'Kuliara','731213',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50402,143,'Kumarpur','731234',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50403,143,'Kundala','731234',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50404,143,'Kundira','731130',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50405,143,'Kuniara','731303',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50406,143,'Kunuri','731234',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50407,143,'Kurmitha','731121',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50408,143,'Kurulmetia','731130',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50409,143,'Kurumgram','731242',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50410,143,'Kurumsha','731201',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50411,143,'Kurunnahar','731303',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50412,143,'Kusmore','731238',1,0,'2022-03-03 12:45:38','2022-03-03 12:45:38'),(50413,143,'Kusumba','731223',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50414,143,'Kusumba','731303',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50415,143,'Kusumi','731213',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50416,143,'Labpur Mastali','731303',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50417,143,'Labpur','731303',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50418,143,'Laghosa','731201',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50419,143,'Laha','731202',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50420,143,'Lakshmi Narayan Pur','731123',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50421,143,'Laldaha','731204',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50422,143,'Langalhata','731303',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50423,143,'Langulia','731103',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50424,143,'Latbhabanipur','731214',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50425,143,'Lauberia','731130',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50426,143,'Laujore','731130',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50427,143,'Loba','731124',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50428,143,'Lohapur','731237',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50429,143,'Lokpur','731123',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50430,143,'Madhaipur','731126',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50431,143,'Mahajanpatty','731224',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50432,143,'Maheshpur','731303',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50433,143,'Mahodory','731201',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50434,143,'Majhigram','731129',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50435,143,'Majiara','731234',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50436,143,'Majkhanda','731233',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50437,143,'Makdamnagar','731216',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50438,143,'Malaypur','731219',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50439,143,'Mallarpur','731216',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50440,143,'Mallickpur','731202',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50441,143,'Mangaldihi','731121',1,0,'2022-03-03 12:45:39','2022-03-03 12:45:39'),(50442,143,'Margram','731202',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50443,143,'Mathpalsa','731234',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50444,143,'Matikona','731214',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50445,143,'Mayureswar','731213',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50446,143,'Md.Bazar','731127',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50447,143,'Md.Bazar Town Ship','731132',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50448,143,'Metela','731123',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50449,143,'Mitrapur','731221',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50450,143,'Modhura','731220',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50451,143,'Mohanpur','731301',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50452,143,'Mohubona','731102',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50453,143,'Mohula','731216',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50454,143,'Mohurapur','731213',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50455,143,'Monoharpur','731236',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50456,143,'Moukhira','731214',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50457,143,'Muktipur','731130',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50458,143,'Muluk','731204',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50459,143,'Murarai','731219',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50460,143,'Muruli Dangal','731216',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50461,143,'Mustofadanga','731220',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50462,143,'Nabasan','731125',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50463,143,'Nachansaha','731236',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50464,143,'Nagari','731126',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50465,143,'Nahina','731240',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50466,143,'Nakrakonda','731125',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50467,143,'Nalhati','731220',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50468,143,'Nalhati Township','731243',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50469,143,'Narasinghapur','731103',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50470,143,'Narayanpur','731223',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50471,143,'Nayagram','731219',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50472,143,'Netaipur','731121',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50473,143,'Nimdaspur','731127',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50474,143,'Nimgoria','731201',1,0,'2022-03-03 12:45:40','2022-03-03 12:45:40'),(50475,143,'Ningha','731202',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50476,143,'Niramoy Sanetorium Giridangaed','731124',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50477,143,'Nirisha','731201',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50478,143,'Nischintapur Jagatpur','731132',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50479,143,'Nischintapur','731224',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50480,143,'Noapara','731237',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50481,143,'Nonadanga','731241',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50482,143,'Nowaparamahadipa','731234',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50483,143,'Nurpur','731302',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50484,143,'Omarpur','731222',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50485,143,'Pachhiara','731124',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50486,143,'Pafuri','731240',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50487,143,'Paharpur','731201',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50488,143,'Paigora','731133',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50489,143,'Paikar','731221',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50490,143,'Paikpara','731220',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50491,143,'Paikuni','731214',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50492,143,'Pakhuria','731245',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50493,143,'Pakurhans','731301',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50494,143,'Palita','731215',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50495,143,'Palsa','731302',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50496,143,'Panchahar','731221',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50497,143,'Panchrahat','731133',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50498,143,'Panchsowa','731240',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50499,143,'Panditpur','731123',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50500,143,'Panrui','731121',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50501,143,'Panuria','731102',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50502,143,'Paruldanga','731235',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50503,143,'Parulia','731213',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50504,143,'Paruliahazrapur','731126',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50505,143,'Paschimnarayanpur','731214',1,0,'2022-03-03 12:45:41','2022-03-03 12:45:41'),(50506,143,'Patadanga','731126',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50507,143,'Pathai','731234',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50508,143,'Patharchapuri','731126',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50509,143,'Patnil','731302',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50510,143,'Payer','731214',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50511,143,'Peruagopalpur','731123',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50512,143,'Poprasahapur','731233',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50513,143,'Pranabanandapally','731101',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50514,143,'Puranagram','731132',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50515,143,'Purbakadipur','731303',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50516,143,'Purbasiur','731201',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50517,143,'Pursundi','731125',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50518,143,'Purundarpur','731129',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50519,143,'Pusulia','731303',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50520,143,'R K Sikshapith','731223',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50521,143,'Railpar (Birbhum)','731224',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50522,143,'Raipur','731204',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50523,143,'Rajatpur','731204',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50524,143,'Rajganj','731126',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50525,143,'Rajgaon','731222',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50526,143,'Rajgramgram','731222',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50527,143,'Rajnagar (Birbhum)','731130',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50528,143,'Rakhakalitala','731234',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50529,143,'Ramchandrapur','731219',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50530,143,'Ramnagar','731234',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50531,143,'Rampur','731127',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50532,143,'Rampurhat H.O','731224',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50533,143,'Rangaipur','731234',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50534,143,'Ranigram','731130',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50535,143,'Ranipathar','731133',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50536,143,'Rasa','731125',1,0,'2022-03-03 12:45:42','2022-03-03 12:45:42'),(50537,143,'Raturi','731221',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50538,143,'Rautara','731126',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50539,143,'Rudranagar','731238',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50540,143,'Rupaspur','731123',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50541,143,'Ruppur','731236',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50542,143,'Ruprampur','731219',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50543,143,'Sagarbhanga','731125',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50544,143,'Sahapur','731104',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50545,143,'Sahora','731234',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50546,143,'Sainthia Bazar','731234',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50547,143,'Sainthia','731234',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50548,143,'Sajina','731126',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50549,143,'Sakodda','731215',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50550,143,'Salisanda','731237',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50551,143,'Sanakpur','731245',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50552,143,'Sandhigorabazar','731233',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50553,143,'Sandhyajole','731233',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50554,143,'Sansat','731240',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50555,143,'Santiniketan','731235',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50556,143,'Saraswatibazar','731215',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50557,143,'Sardha','731242',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50558,143,'Sarenda','731127',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50559,143,'Satpalsa','731234',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50560,143,'Sattore','731236',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50561,143,'Saugram','731234',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50562,143,'Sauta','731301',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50563,143,'Sehelaraipur','731127',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50564,143,'Seherakuri','731127',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50565,143,'Sekpur','731216',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50566,143,'Sian','731204',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50567,143,'Sidhori','731222',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50568,143,'Sikarpur','731121',1,0,'2022-03-03 12:45:43','2022-03-03 12:45:43'),(50569,143,'Sindurtopa','731201',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50570,143,'Singhee','731240',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50571,143,'Sirsha','731124',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50572,143,'Sitalgram','731237',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50573,143,'Sitapur','731204',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50574,143,'Sonarkundu','731243',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50575,143,'Sonatoresuri','731101',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50576,143,'Sonj','731216',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50577,143,'Srikrishnapur','731215',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50578,143,'Sriniketan','731236',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50579,143,'Srirampur','731222',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50580,143,'Sultanpur','731238',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50581,143,'Sunmuni','731214',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50582,143,'Supur','731204',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50583,143,'Suri Dist. School Board','731101',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50584,143,'Suri H.O','731101',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50585,143,'Suribazar','731101',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50586,143,'Suricollege','731101',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50587,143,'Swadhinpur','731223',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50588,143,'Tabadumra','731126',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50589,143,'Talibpur','731121',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50590,143,'Taloan','731216',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50591,143,'Tantipara','731126',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50592,143,'Tapaspur','731104',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50593,143,'Tarachua','731216',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50594,143,'Tarapur','731233',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50595,143,'Tatinapara','731303',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50596,143,'Tejhati','731220',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50597,143,'Tentulia','731244',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50598,143,'Thiba','731303',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50599,143,'Thupsara','731215',1,0,'2022-03-03 12:45:44','2022-03-03 12:45:44'),(50600,143,'Tirogram','731221',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50601,143,'Turigram','731245',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50602,143,'Uchkaran','731301',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50603,143,'Uchpur','731234',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50604,143,'Ujirpur','731237',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50605,143,'Ukrandi','731301',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50606,143,'Ulkunda','731234',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50607,143,'Ushardihi','731214',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50608,143,'Uttarbonogram','731234',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50609,143,'Uttarkhayerbuni','731201',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50610,144,'Airani Chitalia','736156',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50611,144,'Akrarhat Bandar','736157',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50612,144,'Ambari','736133',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50613,144,'Andaran Fulbari','736160',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50614,144,'Andaran Pakhihaga','736146',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50615,144,'Andaranfulbari West','736159',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50616,144,'Angerkata Paradubi','736157',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50617,144,'Baikunthapur','736156',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50618,144,'Bairati','736157',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50619,144,'Bajejama Pakhihaga','736145',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50620,144,'Bakla','736131',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50621,144,'Bakshirhat','736131',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50622,144,'Balabhut','736159',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50623,144,'Balaghat','736159',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50624,144,'Balairhat','736135',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50625,144,'Balakandi','736135',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50626,144,'Balakuthi','736131',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50627,144,'Balapukuri','736159',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50628,144,'Bamanhat','736168',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50629,144,'Bamanpara','736158',1,0,'2022-03-03 12:45:45','2022-03-03 12:45:45'),(50630,144,'Baneswar','736133',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50631,144,'Bangchatra','736101',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50632,144,'Bara Atiabari','736135',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50633,144,'Baradhaperchatra','736172',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50634,144,'Baramaricha','736158',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50635,144,'Baranachina','736135',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50636,144,'Baranatabari','736145',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50637,144,'Barasakdal','736169',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50638,144,'Barashalbari','736159',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50639,144,'Baravita','736135',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50640,144,'Barogharia Garkuta','736146',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50641,144,'Barogodaikhora','736172',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50642,144,'Barokodali','736159',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50643,144,'Begarkhata','736159',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50644,144,'Bhagni Parti','736135',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50645,144,'Bhainskuthi','736131',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50646,144,'Bhalka Putimari','736135',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50647,144,'Bhandijelash','736159',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50648,144,'Bhangamore','736146',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50649,144,'Bhanukumari','736131',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50650,144,'Bhatlaguri','736133',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50651,144,'Bhawairthana','736172',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50652,144,'Bhelakopa','736156',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50653,144,'Bhelapeta','736156',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50654,144,'Bhetaguri','736134',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50655,144,'Bhogmara','736157',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50656,144,'Bhulki','736134',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50657,144,'Bhurkush','736159',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50658,144,'Bhutkura','736135',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50659,144,'Bilshi','736160',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50660,144,'Bokalirmath','736133',1,0,'2022-03-03 12:45:46','2022-03-03 12:45:46'),(50661,144,'Borodanga','736134',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50662,144,'Brahmanir Chauki','736134',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50663,144,'Brahmottar Chatra','736167',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50664,144,'Chagalber','736133',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50665,144,'Chakchaka','736156',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50666,144,'Chamta','736167',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50667,144,'Chandanchaura','736165',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50668,144,'Chanderkuthi','736168',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50669,144,'Charaljani','736156',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50670,144,'Chaudanga','736133',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50671,144,'Chekadera','736134',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50672,144,'Chepani','736206',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50673,144,'Chhat Fulbari','736160',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50674,144,'Chhatbarachauki','736156',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50675,144,'Chhatoa','736156',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50676,144,'Chhatrampur','736159',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50677,144,'Chhitbaralaukuthi','736131',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50678,144,'Chhoto Atiabari','736135',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50679,144,'Chhoto Khairatibari','736165',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50680,144,'Chhoto Salbari','736172',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50681,144,'Chilakhana','736159',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50682,144,'Chilkirhat','736157',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50683,144,'Chorekhata','736167',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50684,144,'Chowdhurihat','736168',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50685,144,'Colony Chamta','736159',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50686,144,'Cooch Behar Bazar','736101',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50687,144,'Cooch Behar H.O','736101',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50688,144,'Cooch Behar New Town','736101',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50689,144,'Cooch Behar Railway Station','736101',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50690,144,'Dawaguri','736156',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50691,144,'Debagram','736159',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50692,144,'Deocharai','736156',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50693,144,'Dewanhat','736134',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50694,144,'Dewankot Jayduar','736172',1,0,'2022-03-03 12:45:47','2022-03-03 12:45:47'),(50695,144,'Dhadial','736159',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50696,144,'Dhalpal','736159',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50697,144,'Dhangdhinguri','736165',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50698,144,'Dhumerkhata','736167',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50699,144,'Dhumpur Balasi','736134',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50700,144,'Dighaltari','736134',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50701,144,'Dinhata Bazar','736135',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50702,144,'Dinhata','736135',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50703,144,'Domuka Nayarhat','736157',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50704,144,'Dorkochengtimari','736159',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50705,144,'Dudherkuthi Dewanbash','736170',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50706,144,'Durgabari Subhash Pally','736101',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50707,144,'Durganagar','736168',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50708,144,'Dwiperpar','736159',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50709,144,'East Sakunibala','736165',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50710,144,'Elajanerkuthi','736157',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50711,144,'Falimari','736131',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50712,144,'Gadaler Kuthi','736146',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50713,144,'Garopara','735217',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50714,144,'Gheghirhat','736134',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50715,144,'Ghogarkuthi','736159',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50716,144,'Ghoksadanga','736171',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50717,144,'Ghughumari','736170',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50718,144,'Gitaldaha Atiabari','736135',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50719,144,'Gitaldaha','736135',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50720,144,'Gobrasara','736135',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50721,144,'Golenawhati','736158',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50722,144,'Gopalpur','736133',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50723,144,'Gossairhat Bandar','736172',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50724,144,'Gossanimari','736145',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50725,144,'Gunjabari','736101',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50726,144,'Guriahati','736170',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50727,144,'Haribhanga','736134',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50728,144,'Harirhat','736159',1,0,'2022-03-03 12:45:48','2022-03-03 12:45:48'),(50729,144,'Hatiduba','736133',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50730,144,'Hatiram Salbari','736145',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50731,144,'Hokadaha','736168',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50732,144,'Holongerkuthi','736165',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50733,144,'Jaigir Chilakhana','736159',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50734,144,'Jamadarerbash','736135',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50735,144,'Jarabari','736135',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50736,144,'Jatamari','736146',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50737,144,'Jatigara','736167',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50738,144,'Jhaljhali','736159',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50739,144,'Jhaokuthi','736159',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50740,144,'Jiranpur','736134',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50741,144,'Jogendranagar','736204',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50742,144,'Jorepatki','736146',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50743,144,'Kajlikura','736167',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50744,144,'Kalika Bazar','736170',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50745,144,'Kaljani','736133',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50746,144,'Kalmati','736176',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50747,144,'Kalpani','736171',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50748,144,'Kamat Fulbari','736159',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50749,144,'Kamat Seoraguri','736134',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50750,144,'Kanfata','736146',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50751,144,'Karala','736135',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50752,144,'Kashidanga','736159',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50753,144,'Kawardera','736146',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50754,144,'Kawrai','736135',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50755,144,'Khagrabari','736179',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50756,144,'Khalishamari','736146',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50757,144,'Khapaidanga','736133',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50758,144,'Kharija Kakribari','736179',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50759,144,'Kharimala Khagrbari','736101',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50760,144,'Khatamari','736168',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50761,144,'Khattimari','736171',1,0,'2022-03-03 12:45:49','2022-03-03 12:45:49'),(50762,144,'Khochabari','736176',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50763,144,'Khutamara','736134',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50764,144,'Kismat Adabari','736167',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50765,144,'Kismat Dasgram','736169',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50766,144,'Koalidaha','736135',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50767,144,'Konamali Khapaidanga','736156',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50768,144,'Krishnapur','736156',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50769,144,'Kuchni','736169',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50770,144,'Kumarganj','736134',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50771,144,'Kurshamari','736146',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50772,144,'Lalbazar Part-II','736158',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50773,144,'Langalgram','736159',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50774,144,'Madhupur','736165',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50775,144,'Madhyam Madhusudan','736172',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50776,144,'Maghpala','736157',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50777,144,'Mahish Bathan','736179',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50778,144,'Mahishcharu','736146',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50779,144,'Mahishmuri','736172',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50780,144,'Mansab Seoraguri','736134',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50781,144,'Mansai','736159',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50782,144,'Mara Nadir Kuthi','736165',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50783,144,'Maruganj','736156',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50784,144,'Masanpath','736145',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50785,144,'Matalhat','736135',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50786,144,'Mathabhanga','736146',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50787,144,'Matiarkuthi','736157',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50788,144,'Moamari','736134',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50789,144,'Nagarlal Bazar','736158',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50790,144,'Nagurhat','736159',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50791,144,'Nakarjan','736167',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50792,144,'Nakarkhana','736131',1,0,'2022-03-03 12:45:50','2022-03-03 12:45:50'),(50793,144,'Nandina','736168',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50794,144,'Natabari','736156',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50795,144,'Natkobarihat','736135',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50796,144,'Nayarhat','736133',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50797,144,'Nazirhat','736134',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50798,144,'New Cooch Behar','736179',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50799,144,'Nigamnagar','736169',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50800,144,'Nilkuthi','736156',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50801,144,'Nishiganj','736157',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50802,144,'Nutanbash','736145',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50803,144,'Pachagarh','736146',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50804,144,'Pakhihaga','736145',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50805,144,'Panikhawa','736167',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50806,144,'Panisala','736134',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50807,144,'Patakamari','736171',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50808,144,'Patakura (Cooch Behar)','736101',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50809,144,'Patchhara','736157',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50810,144,'Patlakhawa','736165',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50811,144,'Patpishu','736157',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50812,144,'Pestarjhar','736156',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50813,144,'Petla','736135',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50814,144,'Phulbari','736145',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50815,144,'Pundibari','736165',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50816,144,'Purba Gopalpur','736133',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50817,144,'Purba Sitalkuchi','736158',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50818,144,'Pushnadanga','736134',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50819,144,'Putimari','736135',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50820,144,'Putimari Fuleswari','736157',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50821,144,'Rajarhat','736165',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50822,144,'Rakhalmari','736169',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50823,144,'Rashidanga','736170',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50824,144,'Rasikbil','736131',1,0,'2022-03-03 12:45:51','2022-03-03 12:45:51'),(50825,144,'Ratinandan Konamukta Payesthi','736135',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50826,144,'Ruerkuthi','736134',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50827,144,'Sahebganj (Cooch Behar)','736176',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50828,144,'Sajerpar Ghoramara','736165',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50829,144,'Salmara','736134',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50830,144,'Shalbari','736159',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50831,144,'Shibpur','736172',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50832,144,'Shikarpur','736146',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50833,144,'Shildanga','736157',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50834,144,'Shilghagri','736131',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50835,144,'Siddheswari','736133',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50836,144,'Silduar','736167',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50837,144,'Singimari Madnakura','736135',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50838,144,'Sitaihat','736167',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50839,144,'Sitalkuchi','736158',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50840,144,'Sonapur','736204',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50841,144,'Sonari','736133',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50842,144,'Souldhukri','736134',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50843,144,'South Bhangamore','736146',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50844,144,'Subachanirpath','736135',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50845,144,'Sukarurkuthi','736168',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50846,144,'Sukhdhanerkuthi','736165',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50847,144,'Sutarpara','736171',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50848,144,'Takagachh','736179',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50849,144,'Talliguri','736156',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50850,144,'Tapurhat','736170',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50851,144,'Tharaikhana','736168',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50852,144,'Tiadaha','736169',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50853,144,'Tufanganj New Town','736160',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50854,144,'Tufanganj','736159',1,0,'2022-03-03 12:45:52','2022-03-03 12:45:52'),(50855,144,'Unishbisha','736171',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50856,144,'Uttar Ambari','736133',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50857,144,'Uttar Andaranfulbari','736160',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50858,144,'Uttar Falimari','736131',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50859,144,'Uttar Ghogarkuthi','736159',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50860,144,'Alok Jhari','735224',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50861,144,'Amguri Bazar','735224',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50862,144,'Ashokebari','735303',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50863,144,'Atpukuria Nayahat','735211',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50864,144,'Bagdokra','735304',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50865,144,'Bagribarihat','735122',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50866,144,'Bairagirhat','735303',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50867,144,'Bamunia West','735303',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50868,144,'Bara Haldibari','735122',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50869,144,'Barogopalpur','735303',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50870,144,'Bhabani Nagar','735122',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50871,144,'Bhogramguri','735303',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50872,144,'Bhotebari','735301',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50873,144,'Boalmari','735122',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50874,144,'Boxiganj','735122',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50875,144,'Brahamattar Kuchilibari','735304',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50876,144,'Buraburi','735303',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50877,144,'Changrabandha','735301',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50878,144,'Daripattani','735122',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50879,144,'Debottar Boxiganj','735122',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50880,144,'Dewanganj','735122',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50881,144,'Dhulia Baldihati','735303',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50882,144,'Dhulia Khalisa','735303',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50883,144,'Dhulia Uchalpukuri','735303',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50884,144,'Doradabri','735301',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50885,144,'Fatehmamud','735122',1,0,'2022-03-03 12:45:53','2022-03-03 12:45:53'),(50886,144,'Fulkadabri','735304',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50887,144,'Giladanga','735303',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50888,144,'Haldibari','735122',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50889,144,'Joresimuli','735303',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50890,144,'Kamat Changrabandha','735301',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50891,144,'Keshoribari','735303',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50892,144,'Kharkharia','735304',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50893,144,'Khayerbari','735122',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50894,144,'Kuchlibari','735304',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50895,144,'Manikganjhat','735122',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50896,144,'Mekhliganj','735304',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50897,144,'N U Kuchlibari','735304',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50898,144,'Niztaraf','735304',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50899,144,'Panigram','735303',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50900,144,'Paschim Hemkumari','735122',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50901,144,'Ranirhat','735301',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50902,144,'Satkura','735122',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50903,144,'Thunkirjhar','735303',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50904,144,'Uchalpukuri','735303',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50905,144,'Upen Chowki Kuchlibari','735304',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50906,144,'Uttar Daribash','735122',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50907,145,'7th Mile Kalimpong','734301',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50908,145,'Adhikari','734427',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50909,145,'Algarah','734314',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50910,145,'Ambootia','734203',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50911,145,'Badamtam','734105',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50912,145,'Badrajote','734429',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50913,145,'Bagdogra Air Port','734421',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50914,145,'Bagdogra','734014',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50915,145,'Bagora','734224',1,0,'2022-03-03 12:45:54','2022-03-03 12:45:54'),(50916,145,'Baigunta Pur','734008',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50917,145,'Balasun','734219',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50918,145,'Bankim Park','734301',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50919,145,'Bannersberg','734104',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50920,145,'Bansbotey','734201',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50921,145,'Bar Dara','734312',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50922,145,'Batasia','734221',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50923,145,'Belgachi','734423',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50924,145,'Bendubi','734424',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50925,145,'Bhajanpur Jote','734427',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50926,145,'Bhanugram','734101',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50927,145,'Bhutia Busty','734101',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50928,145,'Bijanbari','734201',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50929,145,'Bilaksu','734427',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50930,145,'Bloom Field','734102',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50931,145,'Bong Busty','734301',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50932,145,'Buraganj','734426',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50933,145,'Champasari','734003',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50934,145,'Chathat','734436',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50935,145,'Chhotapubong','734102',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50936,145,'Chhumirchin Manchu','734314',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50937,145,'Chibo Busty','734301',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50938,145,'Chitalghatta','734426',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50939,145,'Chowpukuria','734014',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50940,145,'Chunbhati','734223',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50941,145,'Dara Goan','734201',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50942,145,'Darjeeling Bazar','734101',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50943,145,'Darjeeling Court','734101',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50944,145,'Darjeeling H.O','734101',1,0,'2022-03-03 12:45:55','2022-03-03 12:45:55'),(50945,145,'Deorali','734220',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50946,145,'Desbandhupara','734004',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50947,145,'Dhajea','734215',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50948,145,'Dooteriah','734121',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50949,145,'Dowhill','734204',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50950,145,'Dulal Jote','734429',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50951,145,'Dumaram Busty','734203',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50952,145,'Duptin-10','734214',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50953,145,'Echhey','734317',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50954,145,'Gayabari','734223',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50955,145,'Gayanganga','734426',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50956,145,'Geile Banjyang','734226',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50957,145,'Ghoom','734102',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50958,145,'Gitdubling','734314',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50959,145,'Goke Bazar','734201',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50960,145,'Gopal Dhara','734214',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50961,145,'Gossaipur','734014',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50962,145,'Gulma','734009',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50963,145,'Gumba','734102',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50964,145,'Hardigachh','734434',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50965,145,'Hatighisa','734429',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50966,145,'Jalpahar','734103',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50967,145,'Jamdar Vitta','734217',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50968,145,'Jhepi','734201',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50969,145,'Jyoti Nagar','734005',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50970,145,'Kadamtala (Darjiling)','734011',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50971,145,'Kafer','734314',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50972,145,'Kagay Bazar','734311',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50973,145,'Kaijalia','734201',1,0,'2022-03-03 12:45:56','2022-03-03 12:45:56'),(50974,145,'Kalachandgach','734426',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(50975,145,'Kalijhora','734320',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(50976,145,'Kalimpong Bazar','734301',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(50977,145,'Kalimpong','734301',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(50978,145,'Kamala Bagan','734426',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(50979,145,'Kantivitta','734434',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(50980,145,'Khoribari','734427',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(50981,145,'Kolbong','734201',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(50982,145,'Kurseong','734203',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(50983,145,'Lake Town (Darjiling)','734007',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(50984,145,'Lama Goan','734201',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(50985,145,'Lamahatta','734213',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(50986,145,'Latpanchar','734008',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(50987,145,'Lava','734319',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(50988,145,'Lebong','734105',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(50989,145,'Lensipokhari','734434',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(50990,145,'Lingia','734102',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(50991,145,'Lodhomahat','734201',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(50992,145,'Lohapool','734008',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(50993,145,'Lolay','734301',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(50994,145,'Lopchu','734213',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(50995,145,'Lower Chongtong','734102',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(50996,145,'Lower Soureni','734214',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(50997,145,'Madati','734426',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(50998,145,'Mahakal Dara','734316',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(50999,145,'Mahanadi','734203',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(51000,145,'Mahananda Bridge','734001',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(51001,145,'Malat Bazar','734215',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(51002,145,'Maney Dara','734213',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(51003,145,'Maneybhanjeng','734221',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(51004,145,'Mangarjung','734215',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(51005,145,'Margarets Hope','734224',1,0,'2022-03-03 12:45:57','2022-03-03 12:45:57'),(51006,145,'Marybong','734102',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51007,145,'Matigara','734010',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51008,145,'Mim','734221',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51009,145,'Mineral Spring','734105',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51010,145,'Mirik','734214',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51011,145,'Moonda Koti','734219',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51012,145,'Mungpoo','734313',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51013,145,'Munsong','734315',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51014,145,'Nagrispur','734215',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51015,145,'Naksalbari','734429',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51016,145,'Nalichor','734219',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51017,145,'Nemai','734010',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51018,145,'New Chumta','734009',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51019,145,'New Rangia','734013',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51020,145,'Nijbari','734434',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51021,145,'Nimbong','734314',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51022,145,'Norbung','734223',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51023,145,'North Bengal University','734013',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51024,145,'North Point','734104',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51025,145,'Ookayati','734214',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51026,145,'Pabring Tar','734314',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51027,145,'Pagag Gumpa','734314',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51028,145,'Pani Ghatta','734423',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51029,145,'Pankhabari','734217',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51030,145,'Pedong','734311',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51031,145,'Peshok','734312',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51032,145,'Phansidewa','734434',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51033,145,'Phuguri','734218',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51034,145,'Plungdung','734221',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51035,145,'Pokhriabong','734216',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51036,145,'Pradhan Nagar','734003',1,0,'2022-03-03 12:45:58','2022-03-03 12:45:58'),(51037,145,'Pudung','734301',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51038,145,'Pulbazar','734122',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51039,145,'Pussimbing','734102',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51040,145,'Putung','734423',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51041,145,'Rajbari','734103',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51042,145,'Rangali','734426',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51043,145,'Rangapani','734434',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51044,145,'Rangbang','734216',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51045,145,'Rangbull','734123',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51046,145,'Rangli Rangliot','734226',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51047,145,'Rangmook','734219',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51048,145,'Ranidanga','734012',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51049,145,'Ranju Valley','734313',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51050,145,'Rath Khola','734001',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51051,145,'Reang','734321',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51052,145,'Relling','734201',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51053,145,'Rimbick','734201',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51054,145,'Ringtong','734219',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51055,145,'Risheehat','734102',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51056,145,'Rose Bank','734101',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51057,145,'Rousay Bazar','734316',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51058,145,'Sahabad','734431',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51059,145,'Sakyong','734311',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51060,145,'Salbari','734002',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51061,145,'Salugarah','734008',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51062,145,'Samthar','734301',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51063,145,'Santook Mirik','734314',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51064,145,'School Dhura','734313',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51065,145,'School Dhura','734213',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51066,145,'Seeyok','734214',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51067,145,'Selimbong','734216',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51068,145,'Selpu','734008',1,0,'2022-03-03 12:45:59','2022-03-03 12:45:59'),(51069,145,'Seokbir','734301',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51070,145,'Sevoke Road','734001',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51071,145,'Siliguri Bazar','734005',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51072,145,'Siliguri H.O','734001',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51073,145,'Siliguri Junction','734001',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51074,145,'Siliguri New Market','734001',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51075,145,'Siliguri Road','734001',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51076,145,'Siliguri Town','734004',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51077,145,'Simkuna','734102',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51078,145,'Simulbari','734009',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51079,145,'Sindebong','734316',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51080,145,'Singbulli','734218',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51081,145,'Singla','734104',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51082,145,'Singritam','734213',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51083,145,'Singtam','734104',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51084,145,'Sinji','734301',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51085,145,'Sitong','734008',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51086,145,'Sonada','734219',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51087,145,'Soom','734104',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51088,145,'Soureni Bazar','734227',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51089,145,'St.Mary\'s Hill','734220',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51090,145,'Subashpally','734001',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51091,145,'Sukhiapokhari','734221',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51092,145,'Sukna','734009',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51093,145,'Suruk','734301',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51094,145,'Sushrut Nagar','734012',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51095,145,'Swansay','734316',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51096,145,'Takdah','734222',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51097,145,'Takling','734312',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51098,145,'Tamsang','734102',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51099,145,'Tamsing Dhura','734219',1,0,'2022-03-03 12:46:00','2022-03-03 12:46:00'),(51100,145,'Tarbandha','734014',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51101,145,'Tashiding','734301',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51102,145,'Teesta Valley','734226',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51103,145,'Tendrabong','734314',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51104,145,'Tharjhorabagan','734427',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51105,145,'Thurbo','734214',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51106,145,'Tinchuley','734222',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51107,145,'Tindharia','734223',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51108,145,'Tista Bridge','734312',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51109,145,'Topkhana','734316',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51110,145,'Tukvar','734124',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51111,145,'Tung','734224',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51112,145,'Udaigram','734104',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51113,145,'Upper Dalapchand','734316',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51114,145,'Yangmakum Pambu','734301',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51115,145,'Ahlay','735231',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51116,145,'Ambeok','735231',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51117,145,'Fagu (Darjiling)','735231',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51118,145,'Gairibas','734503',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51119,145,'Jaldhaka Hydel Project','734503',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51120,145,'Kumai','735206',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51121,145,'Rango','735206',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51122,145,'Todaygaon','734503',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51123,146,'Ajodhyapur','721401',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51124,146,'Ajoya','721430',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51125,146,'Alamchak Belda','721439',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51126,146,'Alangiri','721420',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51127,146,'Alankarpur','721441',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51128,146,'Alukaranbarh','721454',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51129,146,'Amarpur','721439',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51130,146,'Amarshi','721454',1,0,'2022-03-03 12:46:01','2022-03-03 12:46:01'),(51131,146,'Amtalia','721427',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51132,146,'Analberia','721444',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51133,146,'Argoal','721456',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51134,146,'Argora','721439',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51135,146,'Arjunnagar','721456',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51136,146,'Astichak','721422',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51137,146,'Aswathapur','721446',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51138,146,'Atbati','721422',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51139,146,'Athilagori','721401',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51140,146,'Aurai','721427',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51141,146,'Ayma Barbaria','721439',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51142,146,'Baharganj','721432',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51143,146,'Bahitrakunda','721401',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51144,146,'Baikunthapur','721442',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51145,146,'Baita Bazar','721420',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51146,146,'Baksispur','721401',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51147,146,'Balageria','721422',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51148,146,'Balighai','721422',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51149,146,'Balisai','721423',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51150,146,'Ballyagobindapur','721440',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51151,146,'Bamanbarh','721456',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51152,146,'Banamalichatta','721449',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51153,146,'Bankibheri','721458',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51154,146,'Bankiput','721442',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02');
INSERT INTO `cities` VALUES (51155,146,'Bansgora Bazar','721430',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51156,146,'Barabantalia','721450',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51157,146,'Barabari South','721430',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51158,146,'Barabatia','721443',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51159,146,'Barada Bazar','721448',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51160,146,'Baranihary','721429',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51161,146,'Baratala','721431',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51162,146,'Baraudaypur','721456',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51163,146,'Barhat','721454',1,0,'2022-03-03 12:46:02','2022-03-03 12:46:02'),(51164,146,'Barida','721135',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51165,146,'Barida Bazar','721429',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51166,146,'Barmakhal','721434',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51167,146,'Bartana','721429',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51168,146,'Basantia (East Midnapore)','721442',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51169,146,'Basudebberia','721444',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51170,146,'Basudebpur','721452',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51171,146,'Bathuary','721422',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51172,146,'Battala','721433',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51173,146,'Benachakri','721429',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51174,146,'Benichak','721442',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51175,146,'Bhajachauli','721452',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51176,146,'Bhatda','721422',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51177,146,'Bhawanichak','721427',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51178,146,'Bhimeswaribazar','721458',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51179,146,'Bhuniajibarh','721455',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51180,146,'Bhupatinagar','721425',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51181,146,'Bibhisanpur','721458',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51182,146,'Bidurpur','721422',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51183,146,'Bishnupur','721446',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51184,146,'Biswanathpur','721452',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51185,146,'Bodhra','721423',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51186,146,'Boga','721431',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51187,146,'Bolkhusda','721446',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51188,146,'Brajaballavpur','721456',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51189,146,'Bulakipur','721439',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51190,146,'Chakbhabani','721440',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51191,146,'Chandanpur','721439',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51192,146,'Chandanpur','721438',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51193,146,'Chandanpurhat','721446',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51194,146,'Chapatala','721442',1,0,'2022-03-03 12:46:03','2022-03-03 12:46:03'),(51195,146,'Chatla','721448',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51196,146,'Chauddachulli','721432',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51197,146,'Chaulkhola','721455',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51198,146,'Chhatri','721429',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51199,146,'Chhoto Srikrishnapur','721435',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51200,146,'Chingurdania','721430',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51201,146,'Chirulia','721448',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51202,146,'Chorpalia','721448',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51203,146,'Contai Bazar','721401',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51204,146,'Contai H.O','721401',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51205,146,'Contai Super Market','721401',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51206,146,'Dadanpatrabarh','721455',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51207,146,'Daisai','721449',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51208,146,'Dakhin Badalpur','721423',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51209,146,'Dakhin Sandalpur','721444',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51210,146,'Dakshin Dauki','721450',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51211,146,'Dakshin Kalamdan','721430',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51212,146,'Dakshin Kalyanpur','721455',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51213,146,'Damodarpur','721446',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51214,146,'Damodarpur- Contai','721401',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51215,146,'Dariapur','721442',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51216,146,'Darua','721401',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51217,146,'Daudpur','721401',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51218,146,'Dekhali','721430',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51219,146,'Depal','721453',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51220,146,'Deshdattabarh','721450',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51221,146,'Deulbarh','721427',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51222,146,'Deuli','721423',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51223,146,'Deulpota Keshabchak','721432',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51224,146,'Dhandalibarh','721452',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51225,146,'Dhangaon','721401',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51226,146,'Dhanghara','721444',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51227,146,'Dhankrabanka','721434',1,0,'2022-03-03 12:46:04','2022-03-03 12:46:04'),(51228,146,'Dholmari','721442',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51229,146,'Digha New Township','721463',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51230,146,'Digha (East Midnapore)','721428',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51231,146,'Dighadari','721444',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51232,146,'Dubda','721448',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51233,146,'Durmuth','721401',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51234,146,'Egra Kasba','721429',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51235,146,'Egra','721429',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51236,146,'Erenda','721429',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51237,146,'Fuleswar','721401',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51238,146,'Gangadharchak','721444',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51239,146,'Garia','721448',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51240,146,'Ghatua Purusottampur','721438',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51241,146,'Ghoraghata','721427',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51242,146,'Gobra','721441',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51243,146,'Gokulpur','721439',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51244,146,'Gopalchak','721423',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51245,146,'Gopichak','721431',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51246,146,'Haipur','721433',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51247,146,'Haldia Patna','721441',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51248,146,'Haludbari','721432',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51249,146,'Haria','721430',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51250,146,'Hatbaincha','721422',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51251,146,'Hatgopalpur','721454',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51252,146,'Hirapur','721441',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51253,146,'Ichhabari','721444',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51254,146,'Islampur','721455',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51255,146,'Itaberia','721456',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51256,146,'Jabda','721456',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51257,146,'Jahanabad','721432',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51258,146,'Jamua Sankarpur','721427',1,0,'2022-03-03 12:46:05','2022-03-03 12:46:05'),(51259,146,'Jamualachimpur','721422',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51260,146,'Janka','721431',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51261,146,'Jasteghori','721446',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51262,146,'Jerthan','721420',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51263,146,'Jhawa','721450',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51264,146,'Jhawgeria','721441',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51265,146,'Jukhia Bazar','721430',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51266,146,'Juki','721448',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51267,146,'Jumki','721448',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51268,146,'Junboni','721452',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51269,146,'Junput','721450',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51270,146,'Kaithore','721429',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51271,146,'Kajli','721422',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51272,146,'Kalagachia (East Midnapore)','721432',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51273,146,'Kalindi','721455',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51274,146,'Kalindi Teghari','721455',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51275,146,'Kalsi','721456',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51276,146,'Kalyanpur Tentulmuri','721447',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51277,146,'Kamarda Bazar','721432',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51278,146,'Kanaidighi','721444',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51279,146,'Kanakpur','721439',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51280,146,'Kandagram','721446',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51281,146,'Kantai','721401',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51282,146,'Karaldanimakbarh','721449',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51283,146,'Karanji','721423',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51284,146,'Karkuli','721401',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51285,146,'Kartickkhali','721431',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51286,146,'Kasaria','721431',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51287,146,'Kasbagola','721447',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51288,146,'Katka Debichak','721431',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51289,146,'Katranka','721454',1,0,'2022-03-03 12:46:06','2022-03-03 12:46:06'),(51290,146,'Kayemgeria','721444',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51291,146,'Kekai','721439',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51292,146,'Keunchia','721431',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51293,146,'Keutgeria','721422',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51294,146,'Khagda','721452',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51295,146,'Khalisabhanga','721433',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51296,146,'Khar','721429',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51297,146,'Kharuigarh','721429',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51298,146,'Khejurda','721422',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51299,146,'Khejuri','721431',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51300,146,'Khurutia','721448',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51301,146,'Koria','721435',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51302,146,'Krishnanagar Contai','721430',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51303,146,'Kulanjara','721427',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51304,146,'Kultikri Aranga','721448',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51305,146,'Kumirda','721444',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51306,146,'Kunjapur','721431',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51307,146,'Lakhi','721430',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51308,146,'Lakshmanchak','721431',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51309,146,'Lalua','721456',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51310,146,'Madanmohanpur','721454',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51311,146,'Mahespur','721452',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51312,146,'Mahisagote','721401',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51313,146,'Maisali','721434',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51314,146,'Maitana','721433',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51315,146,'Majna','721433',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51316,146,'Makrampur','721439',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51317,146,'Mandar','721441',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51318,146,'Mandarpur','721433',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51319,146,'Manglamaro','721434',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51320,146,'Manikabasan','721453',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51321,146,'Manikjore','721456',1,0,'2022-03-03 12:46:07','2022-03-03 12:46:07'),(51322,146,'Marisda','721449',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51323,146,'Mathura','721456',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51324,146,'Medakhali','721431',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51325,146,'Mirgoda','721446',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51326,146,'Mohati','721430',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51327,146,'Monoharchak','721401',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51328,146,'Mugberia','721425',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51329,146,'Murisai','721452',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51330,146,'Nachinda Bazar','721444',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51331,146,'Naipur','721439',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51332,146,'Namal','721401',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51333,146,'Namaldiha','721427',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51334,146,'Narandia','721423',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51335,146,'Narkuli','721423',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51336,146,'Naskarpur','721422',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51337,146,'Nayaput','721401',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51338,146,'Negua','721448',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51339,146,'Nijkasba','721431',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51340,146,'Noonhanda','721458',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51341,146,'North Biswanathpur','721439',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51342,146,'Pailachhanpur','721401',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51343,146,'Paldhui','721453',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51344,146,'Palpara (East Midnapore)','721458',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51345,146,'Panchahari','721458',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51346,146,'Panchetgarh','721438',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51347,146,'Panchrol','721447',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51348,146,'Panchuria','721434',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51349,146,'Pania','721440',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51350,146,'Panichiary','721444',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51351,146,'Paniparul','721448',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51352,146,'Pankhai','721431',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51353,146,'Paschim Bamunia','721450',1,0,'2022-03-03 12:46:08','2022-03-03 12:46:08'),(51354,146,'Paschim Manikpur','721452',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51355,146,'Patashpur','721439',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51356,146,'Paushi','721444',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51357,146,'Paya-medinipur','721428',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51358,146,'Pichabani','721455',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51359,146,'Pirijkhanbarh','721422',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51360,146,'Pratapdighi','721440',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51361,146,'Purba Madhabpur','721453',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51362,146,'Purbaradhapur','721425',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51363,146,'Raipur Paschimbarh','721401',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51364,146,'Ramchak','721431',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51365,146,'Ramnagar (East Midnapore)','721441',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51366,146,'Ranisai','721446',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51367,146,'Rasan','721429',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51368,146,'Sabajput','721401',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51369,146,'Sadihat','721446',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51370,146,'Sadikpur','721446',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51371,146,'Safiabad','721442',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51372,146,'Sagareswar','721446',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51373,146,'Sahara','721446',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51374,146,'Sarada','721427',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51375,146,'Saridaspur','721434',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51376,146,'Saripur','721428',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51377,146,'Sarpai','721444',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51378,146,'Satbahini','721439',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51379,146,'Satilapur','721423',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51380,146,'Satkhanda Sahebnagar','721431',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51381,146,'Satmile','721452',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51382,146,'Saulabheri','721454',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51383,146,'Selmabad','721454',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51384,146,'Serkhanchak','721432',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51385,146,'Shipur','721448',1,0,'2022-03-03 12:46:09','2022-03-03 12:46:09'),(51386,146,'Shyampur','721423',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51387,146,'Silampur','721455',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51388,146,'Sillyaberia','721431',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51389,146,'Sisusadan','721433',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51390,146,'Srirampur','721440',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51391,146,'Srirampur- Contai','721401',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51392,146,'Subdi','721430',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51393,146,'Sukhakhola','721456',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51394,146,'Susunia','721429',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51395,146,'Tagaria','721433',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51396,146,'Taghari','721434',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51397,146,'Takapura','721432',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51398,146,'Telami','721447',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51399,146,'Tengunia','721401',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51400,146,'Tentulmuri','721437',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51401,146,'Thakurnagar','721430',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51402,146,'Tikashi','721430',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51403,146,'Totanala','721458',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51404,146,'Udbadal','721425',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51405,146,'Urdhabpur','721422',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51406,146,'Ururi','721458',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51407,146,'Uttar Amtalia','721427',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51408,146,'Uttar Asda','721443',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51409,146,'Uttar Badalpur','721452',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51410,146,'Uttar Gobindapur','721453',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51411,146,'Uttar Kalamdan','721430',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51412,146,'Uttar Kanpur','721453',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51413,146,'Uttarharaschak','721442',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51414,146,'Uttar-tajpur','721422',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51415,146,'Amdan','721131',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51416,146,'Ghoshkira','721253',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51417,146,'Abasbari','721636',1,0,'2022-03-03 12:46:10','2022-03-03 12:46:10'),(51418,146,'Agadoro','721635',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51419,146,'Akandabari','721650',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51420,146,'Alinan','721137',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51421,146,'Amalhara','721134',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51422,146,'Amdabad','721650',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51423,146,'Amgachia','721631',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51424,146,'Amratala','721656',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51425,146,'Amritberia','721628',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51426,146,'Anantapur','721635',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51427,146,'Arankiarana','721642',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51428,146,'Arisanda','721139',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51429,146,'Arror','721134',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51430,146,'Asadtala','721656',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51431,146,'Ashutia','721626',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51432,146,'Ashutiabarh','721659',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51433,146,'Asnan','721642',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51434,146,'Atattar','721633',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51435,146,'Bahadurpur','721626',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51436,146,'Baharpota','721151',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51437,146,'Bahichard','721627',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51438,146,'Bainchberia','721649',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51439,146,'Baishnabchak','721158',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51440,146,'Bakcha','721642',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51441,146,'Bakulda','721139',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51442,146,'Balidangri','721139',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51443,146,'Ballukhat','721137',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51444,146,'Balughata','721645',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51445,146,'Bamunia','721628',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51446,146,'Bara Gokul Nagar','721152',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51447,146,'Barabari','721645',1,0,'2022-03-03 12:46:11','2022-03-03 12:46:11'),(51448,146,'Barabhuniakhali','721652',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51449,146,'Baraghuni','721656',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51450,146,'Baraibarh','721626',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51451,146,'Barakamarda','721648',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51452,146,'Barakurmarchak','721647',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51453,146,'Barbajitpur','721645',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51454,146,'Barbaria','721626',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51455,146,'Barbasudevpur','721645',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51456,146,'Bargabhima','721636',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51457,146,'Barghasipur','721657',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51458,146,'Bargoda','721651',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51459,146,'Bargodagodar','721652',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51460,146,'Barnan','721137',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51461,146,'Baroda','721658',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51462,146,'Baroj','721633',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51463,146,'Barsimulbari','721659',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51464,146,'Baruttarhingli','721654',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51465,146,'Basanchak','721654',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51466,146,'Basudevpur','721602',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51467,146,'Basulia','721628',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51468,146,'Bhagwanpur (East Midnapore)','721601',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51469,146,'Bhekutia','721656',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51470,146,'Bheturia','721650',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51471,146,'Bhogpur (East Midnapore)','721151',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51472,146,'Bhuniaraychak','721635',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51473,146,'Bijoyramchak','721152',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51474,146,'Birulia','721650',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51475,146,'Boyal','721656',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51476,146,'Brajalalchak','721659',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51477,146,'Brindabanpur','721633',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51478,146,'Burarihat','721137',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51479,146,'Byabattarhat','721648',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51480,146,'Chaitannyapur','721645',1,0,'2022-03-03 12:46:12','2022-03-03 12:46:12'),(51481,146,'Chakdwipa','721645',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51482,146,'Chakjiandighi','721649',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51483,146,'Chaknan','721633',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51484,146,'Chakradhaban','721152',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51485,146,'Champi','721628',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51486,146,'Changra','721629',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51487,146,'Changrachak','721644',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51488,146,'Changrakalaganda','721651',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51489,146,'Chanserpur','721653',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51490,146,'Chapda','721154',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51491,146,'Charabarh','721626',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51492,146,'Dabuapukur','721634',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51493,146,'Dakhinkasimnagar','721632',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51494,146,'Dakshin Changrachak','721644',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51495,146,'Dakshin Narikelda','721648',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51496,146,'Dakshinchak','721654',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51497,146,'Dakshindamodarpur','721652',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51498,146,'Dakshinmoyna','721629',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51499,146,'Dakshinsrikrishnapur','721648',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51500,146,'Dalpara','721167',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51501,146,'Daudpurnandi','721631',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51502,146,'Dayaldasi','721632',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51503,146,'Debhog','721657',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51504,146,'Debipur','721650',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51505,146,'Dehati','721139',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51506,146,'Demarihat','721172',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51507,146,'Deriachak','721151',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51508,146,'Deulia','721154',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51509,146,'Deulpota','721603',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51510,146,'Dhalhara','721636',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51511,146,'Dhanyaghar','721643',1,0,'2022-03-03 12:46:13','2022-03-03 12:46:13'),(51512,146,'Dhekua','721658',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51513,146,'Dhuliapur','721634',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51514,146,'Dobandi','721647',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51515,146,'Donachak','721644',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51516,146,'Dorojoynagar','721635',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51517,146,'Dorokashipur','721658',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51518,146,'Dorokrishnanagar','721635',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51519,146,'Dumdun','721152',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51520,146,'Durgachak Colony','721602',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51521,146,'Durgachak','721602',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51522,146,'Durgapur','721631',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51523,146,'Dwariberia','721654',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51524,146,'Ektarpur','721633',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51525,146,'Etamogra','721628',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51526,146,'Ganjanarayanpur','721648',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51527,146,'Garbari','721626',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51528,146,'Garh Krishna Nagar','721650',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51529,146,'Garhchakraberia','721631',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51530,146,'Garhkamalpur','721628',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51531,146,'Geondab','721657',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51532,146,'Geonkhali','721603',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51533,146,'Ghasipur','721628',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51534,146,'Gholpukuria','721650',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51535,146,'Gobindapur','721627',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51536,146,'Gobindapurbajitpur','721645',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51537,146,'Gobradan','721642',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51538,146,'Gokulnagar','721646',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51539,146,'Golapchak','721658',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51540,146,'Goleghat','721139',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51541,146,'Gopalnagar Hat','721139',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51542,146,'Gopalnagar (East Midnapore)','721130',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51543,146,'Gopalpur','721628',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51544,146,'Gopinathpur','721633',1,0,'2022-03-03 12:46:14','2022-03-03 12:46:14'),(51545,146,'Goramahal','721642',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51546,146,'Gourangachak','721644',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51547,146,'Gurgram','721633',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51548,146,'H.I.T','721606',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51549,146,'Hadia','721654',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51550,146,'Haldia O.R','721606',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51551,146,'Haldia Port','721607',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51552,146,'Haldia','721604',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51553,146,'Haldia T.S','721607',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51554,146,'Hanschara','721625',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51555,146,'Hanubhunia','721625',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51556,146,'Harasankar','721151',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51557,146,'Haridaspur','721653',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51558,146,'Harijhama','721152',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51559,146,'Haripur','721631',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51560,146,'Hatiberia','721657',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51561,146,'Hijalberia','721649',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51562,146,'Hogla','721137',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51563,146,'Illaspur','721601',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51564,146,'Iswardahajalpai','721654',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51565,146,'Iswarpur','721659',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51566,146,'Jagannathpur','721641',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51567,146,'Jagatpur','721603',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51568,146,'Jaigirchak','721644',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51569,146,'Jalpai','721652',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51570,146,'Jamitya','721134',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51571,146,'Jasora','721641',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51572,146,'Jawfullybibichak','721137',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51573,146,'Jiakhali','721641',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51574,146,'Jotenarayan','721139',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51575,146,'Joybalarampur','721137',1,0,'2022-03-03 12:46:15','2022-03-03 12:46:15'),(51576,146,'Kajlagarh','721626',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51577,146,'Kakgechia','721649',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51578,146,'Kakra','721659',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51579,146,'Kalagechhia Bara','721634',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51580,146,'Kalicharanpur','721646',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51581,146,'Kalikadari','721642',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51582,146,'Kalikakundu','721654',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51583,146,'Kalukhanra','721152',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51584,146,'Kalyanchak','721632',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51585,146,'Kalyanpur','721632',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51586,146,'Kamalpur','721650',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51587,146,'Kanchanpur','721628',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51588,146,'Kandapasra','721633',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51589,146,'Kapasaria','721628',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51590,146,'Kelomal','721627',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51591,146,'Kendamari','721631',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51592,146,'Keshabpur','721628',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51593,146,'Keshabpurjalpai','721628',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51594,146,'Keshapat','721139',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51595,146,'Khagdabirgram','721633',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51596,146,'Khanchi','721643',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51597,146,'Khanjanchak','721602',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51598,146,'Kharui','721134',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51599,146,'Khodambari','721650',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51600,146,'Kiakhali','721646',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51601,146,'Kiarana','721642',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51602,146,'Kishorechak','721642',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51603,146,'Kishorepur','721139',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51604,146,'Kismatbajkul','721655',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51605,146,'Kolaghat Natun Bazar','721134',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51606,146,'Kolaghat RS','721134',1,0,'2022-03-03 12:46:16','2022-03-03 12:46:16'),(51607,146,'Kolaghat','721134',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51608,146,'Kotebarh','721633',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51609,146,'Ktpp','721137',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51610,146,'Ktpp T.S','721171',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51611,146,'Kukrahati','721658',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51612,146,'Kulbari','721625',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51613,146,'Kulberia','721649',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51614,146,'Kultikri-ghatal','721153',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51615,146,'Kumarara','721632',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51616,146,'Kumarchak','721652',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51617,146,'Kumarpur','721654',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51618,146,'Kurpai','721649',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51619,146,'Lakshya','721654',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51620,146,'Lakshyakuri','721152',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51621,146,'Lalpur','721601',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51622,146,'Madhabpur','721626',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51623,146,'Madhusudanchak','721655',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51624,146,'Madhyahingli','721628',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51625,146,'Maguri Jagannathchak','721152',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51626,146,'Maguri Uttarsai','721152',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51627,146,'Mahadole','721634',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51628,146,'Mahammadpur','721601',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51629,146,'Mahisadal','721628',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51630,146,'Majnaberia','721633',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51631,146,'Manuchak','721656',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51632,146,'Mathchandipur','721659',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51633,146,'Mayachar','721648',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51634,146,'Mechada','721137',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51635,146,'Meghadangar','721152',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51636,146,'Mirikpur','721649',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51637,146,'Mirpur','721648',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51638,146,'Mirzanagar','721642',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51639,146,'Monoharpur','721650',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51640,146,'Motilalchak','721652',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51641,146,'Moyna','721629',1,0,'2022-03-03 12:46:17','2022-03-03 12:46:17'),(51642,146,'Moynakalagachia','721629',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51643,146,'Muradpur','721625',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51644,146,'Naba Anantapur','721601',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51645,146,'Nabatajpur','721601',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51646,146,'Nakibasan','721649',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51647,146,'Namalbarh','721151',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51648,146,'Nandakumar','721632',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51649,146,'Nandapur','721625',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51650,146,'Nandigram','721631',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51651,146,'Naranda','721139',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51652,146,'Narayanchak','721154',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51653,146,'Narayandari','721655',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51654,146,'Narghat L.S','721633',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51655,146,'Narghat','721633',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51656,146,'Natshal','721603',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51657,146,'Naynan','721631',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51658,146,'Nazirbaza5r','721655',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51659,146,'Nilpur','721631',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51660,146,'Nonakuribazar','721172',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51661,146,'Osmanchak','721631',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51662,146,'Padumbasan','721636',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51663,146,'Paikbheri','721601',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51664,146,'Paikpari','721134',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51665,146,'Pairachali','721633',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51666,146,'Panskura R.S','721152',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51667,146,'Panskura','721139',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51668,146,'Paramanandapur','721644',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51669,146,'Parbatipur','721636',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51670,146,'Parulbari','721631',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51671,146,'Paschimchilka','721647',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51672,146,'Paschimnaichanpur','721642',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51673,146,'Paschimpatna','721659',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51674,146,'Patanda','721139',1,0,'2022-03-03 12:46:18','2022-03-03 12:46:18'),(51675,146,'Payag','721154',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51676,146,'Pitambarchak','721657',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51677,146,'Porachingra','721655',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51678,146,'Pratappur','721152',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51679,146,'Priyanagar','721631',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51680,146,'Pulsita','721154',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51681,146,'Purba Itara','721634',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51682,146,'Purbachilka','721647',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51683,146,'Purbadakshinmoyna','721629',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51684,146,'Purbagopalchak','721656',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51685,146,'Purbasrikrishnapur','721635',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51686,146,'Purbasrirampur','721603',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51687,146,'Putputia','721651',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51688,146,'Radhaballavpur','721627',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51689,146,'Raghunathbari','721634',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51690,146,'Raghurampur','721645',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51691,146,'Raichak','721642',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51692,146,'Rain','721130',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51693,146,'Rajaniganj','721603',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51694,146,'Rajaramchak','721631',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51695,146,'Rajarampur','721628',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51696,146,'Rajnagar Baharjola','721651',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51697,146,'Rambag','721628',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51698,146,'Ramchakmoyna','721644',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51699,146,'Ramchandrapur (East Midnapore)','721647',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51700,146,'Rampur','721631',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51701,146,'Ramtarak Hat','721151',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51702,146,'Rangibasan','721628',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51703,146,'Ratulia','721139',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51704,146,'Reapara','721650',1,0,'2022-03-03 12:46:19','2022-03-03 12:46:19'),(51705,146,'Runkinipur','721650',1,0,'2022-03-03 12:46:20','2022-03-03 12:46:20'),(51706,146,'Sagarbarh','721151',1,0,'2022-03-03 12:46:20','2022-03-03 12:46:20'),(51707,146,'Sajinagechhia','721154',1,0,'2022-03-03 12:46:20','2022-03-03 12:46:20'),(51708,146,'Salgechhia','721636',1,0,'2022-03-03 12:46:20','2022-03-03 12:46:20'),(51709,146,'Salikagarchak','721653',1,0,'2022-03-03 12:46:20','2022-03-03 12:46:20'),(51710,146,'Saluka','721130',1,0,'2022-03-03 12:46:20','2022-03-03 12:46:20'),(51711,146,'Samsabad','721631',1,0,'2022-03-03 12:46:20','2022-03-03 12:46:20'),(51712,146,'Sankarara','721636',1,0,'2022-03-03 12:46:20','2022-03-03 12:46:20'),(51713,146,'Sarberia','721631',1,0,'2022-03-03 12:46:20','2022-03-03 12:46:20'),(51714,146,'Saudkhali','721646',1,0,'2022-03-03 12:46:20','2022-03-03 12:46:20'),(51715,146,'Shibramnagar','721635',1,0,'2022-03-03 12:46:20','2022-03-03 12:46:20'),(51716,146,'Shibrampur','721650',1,0,'2022-03-03 12:46:20','2022-03-03 12:46:20'),(51717,146,'Shyamsundarpatna','721139',1,0,'2022-03-03 12:46:20','2022-03-03 12:46:20'),(51718,146,'Siddha','721151',1,0,'2022-03-03 12:46:20','2022-03-03 12:46:20'),(51719,146,'Sijgeria','721139',1,0,'2022-03-03 12:46:20','2022-03-03 12:46:20'),(51720,146,'Simulia','721649',1,0,'2022-03-03 12:46:20','2022-03-03 12:46:20'),(51721,146,'Simulkundu','721646',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51722,146,'Sitalaparamanandapur','721151',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51723,146,'Sitalpur','721632',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51724,146,'Sitapur','721154',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51725,146,'Sonachura','721646',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51726,146,'Srikantapur','721601',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51727,146,'Srikantha','721629',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51728,146,'Srikrishnapur','721659',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51729,146,'Srirampur Mid','721651',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51730,146,'Sudampur','721644',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51731,146,'Sukrullapur','721626',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51732,146,'Sulani','721158',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51733,146,'Sulochanarambhadrapur','721651',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51734,146,'Sultanpurbazar','721659',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51735,146,'Sundarnagar','721634',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51736,146,'Sutahata','721635',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51737,146,'Tabakhali','721635',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51738,146,'Tajnagar','721635',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51739,146,'Tajpur','721656',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51740,146,'Tamluk H.O','721636',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51741,146,'Teghorijoteviram','721627',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51742,146,'Tekhalibazar','721646',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51743,146,'Terapakhia','721656',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51744,146,'Tilkhoja','721629',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51745,146,'Tiorkhali','721655',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51746,146,'Upalda','721152',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51747,146,'Uttar Sautanchak','721649',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51748,146,'Uttarjianda','721151',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51749,146,'Uttarkotebarh','721626',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51750,146,'Uttarmechogram','721139',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51751,146,'Uttarsonamui','721648',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51752,147,'Addconagar','712121',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51753,147,'Aidakismat','712512',1,0,'2022-03-03 12:46:21','2022-03-03 12:46:21'),(51754,147,'Akna','712148',1,0,'2022-03-03 12:46:22','2022-03-03 12:46:22'),(51755,147,'Alati','712414',1,0,'2022-03-03 12:46:22','2022-03-03 12:46:22'),(51756,147,'Alipur','712305',1,0,'2022-03-03 12:46:22','2022-03-03 12:46:22'),(51757,147,'Alipur Nayanagar','712301',1,0,'2022-03-03 12:46:22','2022-03-03 12:46:22'),(51758,147,'Amra','712149',1,0,'2022-03-03 12:46:22','2022-03-03 12:46:22'),(51759,147,'Arambagh Court','712601',1,0,'2022-03-03 12:46:22','2022-03-03 12:46:22'),(51760,147,'Arambagh H.O','712601',1,0,'2022-03-03 12:46:22','2022-03-03 12:46:22'),(51761,147,'Arandi','712413',1,0,'2022-03-03 12:46:22','2022-03-03 12:46:22'),(51762,147,'Arjuna','712146',1,0,'2022-03-03 12:46:22','2022-03-03 12:46:22'),(51763,147,'Aslahari','712616',1,0,'2022-03-03 12:46:22','2022-03-03 12:46:22'),(51764,147,'Asudkhola','712611',1,0,'2022-03-03 12:46:22','2022-03-03 12:46:22'),(51765,147,'Ati','712305',1,0,'2022-03-03 12:46:22','2022-03-03 12:46:22'),(51766,147,'Aymanawabpur','712149',1,0,'2022-03-03 12:46:22','2022-03-03 12:46:22'),(51767,147,'Babnan','712305',1,0,'2022-03-03 12:46:22','2022-03-03 12:46:22'),(51768,147,'Bachhanari','712413',1,0,'2022-03-03 12:46:22','2022-03-03 12:46:22'),(51769,147,'Badanganj','712122',1,0,'2022-03-03 12:46:22','2022-03-03 12:46:22'),(51770,147,'Bagnan Chaitanyabati','712301',1,0,'2022-03-03 12:46:22','2022-03-03 12:46:22'),(51771,147,'Baharkuli','712146',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51772,147,'Baikunthapur','712414',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51773,147,'Baira-kanpur','712413',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51774,147,'Bajua','712602',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51775,147,'Bakuliagram','712512',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51776,147,'Balagarh','712501',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51777,147,'Balaichak','712416',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51778,147,'Balidaha','712303',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51779,147,'Balidewanganj','712616',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51780,147,'Balindar','712134',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51781,147,'Ballaldighi','712135',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51782,147,'Balpai','712416',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51783,147,'Balundi','712413',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51784,147,'Bandel Junction','712123',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51785,147,'Baneswarpur','712515',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51786,147,'Bansberia Bazar','712502',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51787,147,'Bansberia','712502',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51788,147,'Baradangal','712617',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51789,147,'Baradigrui','712412',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51790,147,'Barul','712134',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51791,147,'Barunanpara','712148',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51792,147,'Basna','712501',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51793,147,'Batanal','712615',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51794,147,'BELMURI','712302',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51795,147,'BELOON','712149',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51796,147,'Bengai.','712611',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51797,147,'Beniajole','712613',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51798,147,'Berela','712134',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51799,147,'Bhadur','712602',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51800,147,'Bhalia','712615',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51801,147,'Bhandarhati','712301',1,0,'2022-03-03 12:46:23','2022-03-03 12:46:23'),(51802,147,'Bhastara','712303',1,0,'2022-03-03 12:46:24','2022-03-03 12:46:24'),(51803,147,'Bhitasin','712149',1,0,'2022-03-03 12:46:24','2022-03-03 12:46:24'),(51804,147,'Bhonpur','712134',1,0,'2022-03-03 12:46:24','2022-03-03 12:46:24'),(51805,147,'Bhuerah','712415',1,0,'2022-03-03 12:46:24','2022-03-03 12:46:24'),(51806,147,'Bhurkunda','712611',1,0,'2022-03-03 12:46:24','2022-03-03 12:46:24'),(51807,147,'BIKRAMNAGORE BALI','712103',1,0,'2022-03-03 12:46:24','2022-03-03 12:46:24'),(51808,147,'Bilsara','712134',1,0,'2022-03-03 12:46:24','2022-03-03 12:46:24'),(51809,147,'Boinchi','712134',1,0,'2022-03-03 12:46:24','2022-03-03 12:46:24'),(51810,147,'Boinchigram','712135',1,0,'2022-03-03 12:46:24','2022-03-03 12:46:24'),(51811,147,'Bonhijli','712417',1,0,'2022-03-03 12:46:24','2022-03-03 12:46:24'),(51812,147,'Boso','712302',1,0,'2022-03-03 12:46:24','2022-03-03 12:46:24'),(51813,147,'Brindabanpur','712146',1,0,'2022-03-03 12:46:24','2022-03-03 12:46:24'),(51814,147,'Btps (Hooghly)','712503',1,0,'2022-03-03 12:46:24','2022-03-03 12:46:24'),(51815,147,'Buroshibtala (Hooghly)','712105',1,0,'2022-03-03 12:46:24','2022-03-03 12:46:24'),(51816,147,'Chakhayatpur','712416',1,0,'2022-03-03 12:46:24','2022-03-03 12:46:24'),(51817,147,'Chandpur','712149',1,0,'2022-03-03 12:46:24','2022-03-03 12:46:24'),(51818,147,'Chandraban','712412',1,0,'2022-03-03 12:46:24','2022-03-03 12:46:24'),(51819,147,'Chandrahati','712504',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51820,147,'Chandur (Hooghly)','712602',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51821,147,'Chatosarsa','712147',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51822,147,'Chawk Bansberia.','712502',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51823,147,'Chenchua','712402',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51824,147,'Cheragram','712303',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51825,147,'Chingra','712416',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51826,147,'Chinsurah Bazar','712101',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51827,147,'Chinsurah Court','712101',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51828,147,'Chinsurah H.O','712101',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51829,147,'Chinsurah RS','712102',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51830,147,'Chopa','712308',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51831,147,'Chuadanga','712617',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51832,147,'Chunait','712413',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51833,147,'Dabra','712149',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51834,147,'Daharkunda','712617',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51835,147,'Dahia Kanda','712616',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51836,147,'Dakshin Basudebpur','712301',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51837,147,'Dakshin Rasulpur','712413',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51838,147,'Daminya Kabikankan','712413',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51839,147,'Damodarpur','712616',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51840,147,'Danrpur','712305',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51841,147,'Dasghara','712402',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51842,147,'Debanandapur','712123',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51843,147,'Debkhanda','712614',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51844,147,'Dedhara','712302',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51845,147,'Deulpara.','712414',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51846,147,'Dhaniakhali','712302',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51847,147,'Dharampur','712105',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51848,147,'Dharasimul','712416',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51849,147,'Dhobapara','712512',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51850,147,'Dhulepur','712616',1,0,'2022-03-03 12:46:25','2022-03-03 12:46:25'),(51851,147,'Digra','712512',1,0,'2022-03-03 12:46:26','2022-03-03 12:46:26'),(51852,147,'Digsui','712148',1,0,'2022-03-03 12:46:26','2022-03-03 12:46:26'),(51853,147,'Dihi Bagnan','712613',1,0,'2022-03-03 12:46:26','2022-03-03 12:46:26'),(51854,147,'Dihiboira','712413',1,0,'2022-03-03 12:46:26','2022-03-03 12:46:26'),(51855,147,'Duadanda','712613',1,0,'2022-03-03 12:46:26','2022-03-03 12:46:26'),(51856,147,'Dumurdaha','712515',1,0,'2022-03-03 12:46:26','2022-03-03 12:46:26'),(51857,147,'Dwarbasini','712149',1,0,'2022-03-03 12:46:26','2022-03-03 12:46:26'),(51858,147,'Ektarpur','712123',1,0,'2022-03-03 12:46:26','2022-03-03 12:46:26'),(51859,147,'Fului','712122',1,0,'2022-03-03 12:46:26','2022-03-03 12:46:26'),(51860,147,'Gajinadaspur','712146',1,0,'2022-03-03 12:46:26','2022-03-03 12:46:26'),(51861,147,'Ghargohal','712414',1,0,'2022-03-03 12:46:26','2022-03-03 12:46:26'),(51862,147,'Ghoshpur','712613',1,0,'2022-03-03 12:46:26','2022-03-03 12:46:26'),(51863,147,'Ghosla','712303',1,0,'2022-03-03 12:46:26','2022-03-03 12:46:26'),(51864,147,'Gobarara','712305',1,0,'2022-03-03 12:46:26','2022-03-03 12:46:26'),(51865,147,'Gobindapur','712602',1,0,'2022-03-03 12:46:26','2022-03-03 12:46:26'),(51866,147,'Goghat.','712614',1,0,'2022-03-03 12:46:26','2022-03-03 12:46:26'),(51867,147,'Golta','712615',1,0,'2022-03-03 12:46:26','2022-03-03 12:46:26'),(51868,147,'Gopalpur','712513',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51869,147,'GOPINAGAR','712402',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51870,147,'Goswamimalipara','712305',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51871,147,'Gourhati','712613',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51872,147,'Gram Kulti','712146',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51873,147,'Gramchagram','712146',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51874,147,'Gujrat','712617',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51875,147,'Guptipara','712512',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51876,147,'Gurap','712303',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51877,147,'Gurbari','712308',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51878,147,'Hanral','712149',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51879,147,'Hanraldaspur','712134',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51880,147,'Haridaspur','712147',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51881,147,'Harinkhola','712415',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51882,147,'Harishchak','712416',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51883,147,'Harit','712305',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51884,147,'Hatbasantapur','712413',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51885,147,'Hati','712415',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51886,147,'Hatni','712134',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51887,147,'Hazipur','712302',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51888,147,'Helan','712412',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51889,147,'Hiatpur','712412',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51890,147,'Hirapur','712406',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51891,147,'Hoera','712147',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51892,147,'Hooghly','712103',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51893,147,'Ilsobamondalai','712146',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51894,147,'Inchura Bazar','712123',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51895,147,'Insura','712134',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51896,147,'Itachuna','712147',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51897,147,'Jagatpur','712417',1,0,'2022-03-03 12:46:27','2022-03-03 12:46:27'),(51898,147,'Jamgram','712146',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51899,147,'Jasar','712415',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51900,147,'Jayer','712149',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51901,147,'Jharia','712122',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51902,147,'Jirat','712501',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51903,147,'Jolekul','712303',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51904,147,'Kadra','712122',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51905,147,'Kaiba','712412',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51906,147,'KAMARPARABAZAR','712105',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51907,147,'Kamarpukur','712612',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51908,147,'Kamdebpur','712102',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51909,147,'Kanakshally','712105',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51910,147,'Kananadi','712302',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51911,147,'Kankrakuli','712302',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51912,147,'Kantali','712614',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51913,147,'Kanui Banka','712301',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51914,147,'Kapasdanga Roybazarcolony','712103',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51915,147,'Karui','712615',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51916,147,'Katsara','712102',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51917,147,'Kedarpur','712406',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51918,147,'Keotalatbagan','712104',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51919,147,'Keshabpur','712413',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51920,147,'Khajurdaha','712149',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51921,147,'Khamargachi','712515',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51922,147,'Khanakul','712406',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51923,147,'Khanpur (Hooghly)','712308',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51924,147,'KHANYAN','712147',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51925,147,'Kharua','712308',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51926,147,'Khatul','712611',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51927,147,'Kishorepur','712617',1,0,'2022-03-03 12:46:28','2022-03-03 12:46:28'),(51928,147,'Krishanbatichar','712512',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51929,147,'Krishnapur (Hooghly)','712601',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51930,147,'Kulbatpur','712414',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51931,147,'Kumursha','712616',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51932,147,'Kupsit','712613',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51933,147,'Laluka','712614',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51934,147,'Lokabati','712302',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51935,147,'Madhabpur','712413',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51936,147,'Madhurpur','712413',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51937,147,'Magra','712148',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51938,147,'Magura','712149',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51939,147,'Mahisgot','712617',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51940,147,'Maigram','712602',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51941,147,'Mainan','712406',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51942,147,'Makalpur','712305',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51943,147,'Manaspur','712123',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51944,147,'Mandaran','712612',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51945,147,'Mandra','712301',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51946,147,'Manikpat','712617',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51947,147,'Mar0khana','712417',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51948,147,'Mayalbandipur','712617',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51949,147,'Mayapur (Hooghly)','712413',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51950,147,'Mazinan','712302',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51951,147,'Megshar','712149',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51952,147,'Melki','712149',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51953,147,'Milangarh','712501',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51954,147,'Mohanad','712149',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51955,147,'Mohipalpur','712146',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51956,147,'Mohisgoria','712402',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51957,147,'Moloypur','712615',1,0,'2022-03-03 12:46:29','2022-03-03 12:46:29'),(51958,147,'Mostafapur','712416',1,0,'2022-03-03 12:46:30','2022-03-03 12:46:30'),(51959,147,'Mriga Chatra','712602',1,0,'2022-03-03 12:46:30','2022-03-03 12:46:30'),(51960,147,'Muktarpur Belekusma','712616',1,0,'2022-03-03 12:46:30','2022-03-03 12:46:30'),(51961,147,'Nachipur','712414',1,0,'2022-03-03 12:46:30','2022-03-03 12:46:30'),(51962,147,'Nagbal','712305',1,0,'2022-03-03 12:46:30','2022-03-03 12:46:30'),(51963,147,'Naisarai','712602',1,0,'2022-03-03 12:46:30','2022-03-03 12:46:30'),(51964,147,'Nakunda','712614',1,0,'2022-03-03 12:46:30','2022-03-03 12:46:30'),(51965,147,'Naldanga','712123',1,0,'2022-03-03 12:46:30','2022-03-03 12:46:30'),(51966,147,'Nandanpur','712417',1,0,'2022-03-03 12:46:30','2022-03-03 12:46:30'),(51967,147,'Nangulpara','712406',1,0,'2022-03-03 12:46:30','2022-03-03 12:46:30'),(51968,147,'Narayanpur','712412',1,0,'2022-03-03 12:46:30','2022-03-03 12:46:30'),(51969,147,'Natibpur','712416',1,0,'2022-03-03 12:46:30','2022-03-03 12:46:30'),(51970,147,'Natunbazar (Hooghly)','712601',1,0,'2022-03-03 12:46:30','2022-03-03 12:46:30'),(51971,147,'Nayasarai','712513',1,0,'2022-03-03 12:46:30','2022-03-03 12:46:30'),(51972,147,'Netaji Mahavidyalaya','712601',1,0,'2022-03-03 12:46:30','2022-03-03 12:46:30'),(51973,147,'New Chandpur','712301',1,0,'2022-03-03 12:46:30','2022-03-03 12:46:30'),(51974,147,'Nimdanga','712402',1,0,'2022-03-03 12:46:30','2022-03-03 12:46:30'),(51975,147,'Nimdangi','712414',1,0,'2022-03-03 12:46:30','2022-03-03 12:46:30'),(51976,147,'Paba','712614',1,0,'2022-03-03 12:46:30','2022-03-03 12:46:30'),(51977,147,'Pakri','712148',1,0,'2022-03-03 12:46:30','2022-03-03 12:46:30'),(51978,147,'Palasi','712303',1,0,'2022-03-03 12:46:30','2022-03-03 12:46:30'),(51979,147,'Palaspai','712416',1,0,'2022-03-03 12:46:30','2022-03-03 12:46:30'),(51980,147,'Panchgora','712149',1,0,'2022-03-03 12:46:30','2022-03-03 12:46:30'),(51981,147,'Panchpara','712501',1,0,'2022-03-03 12:46:30','2022-03-03 12:46:30'),(51982,147,'Pandua','712149',1,0,'2022-03-03 12:46:31','2022-03-03 12:46:31'),(51983,147,'Pandugram','712122',1,0,'2022-03-03 12:46:31','2022-03-03 12:46:31'),(51984,147,'Parabagnan','712413',1,0,'2022-03-03 12:46:31','2022-03-03 12:46:31'),(51985,147,'Paschimpara','712612',1,0,'2022-03-03 12:46:31','2022-03-03 12:46:31'),(51986,147,'Patna','712148',1,0,'2022-03-03 12:46:31','2022-03-03 12:46:31'),(51987,147,'Patul','712406',1,0,'2022-03-03 12:46:31','2022-03-03 12:46:31'),(51988,147,'Patuligram','712501',1,0,'2022-03-03 12:46:31','2022-03-03 12:46:31'),(51989,147,'Pawnan','712305',1,0,'2022-03-03 12:46:31','2022-03-03 12:46:31'),(51990,147,'Pilkhan','712613',1,0,'2022-03-03 12:46:31','2022-03-03 12:46:31'),(51991,147,'Pindira','712146',1,0,'2022-03-03 12:46:31','2022-03-03 12:46:31'),(51992,147,'Pipulpati','712103',1,0,'2022-03-03 12:46:31','2022-03-03 12:46:31'),(51993,147,'POLBA','712148',1,0,'2022-03-03 12:46:31','2022-03-03 12:46:31'),(51994,147,'Pole','712406',1,0,'2022-03-03 12:46:31','2022-03-03 12:46:31'),(51995,147,'Porabazar','712305',1,0,'2022-03-03 12:46:31','2022-03-03 12:46:31'),(51996,147,'Pratapnagar (HooghB.O','712415',1,0,'2022-03-03 12:46:31','2022-03-03 12:46:31'),(51997,147,'Pratappur (Hooghly)','712101',1,0,'2022-03-03 12:46:31','2022-03-03 12:46:31'),(51998,147,'Puinan','712305',1,0,'2022-03-03 12:46:31','2022-03-03 12:46:31'),(51999,147,'Purba Krishnapur','712415',1,0,'2022-03-03 12:46:31','2022-03-03 12:46:31'),(52000,147,'Purba Satgachia','712512',1,0,'2022-03-03 12:46:31','2022-03-03 12:46:31'),(52001,147,'Rabindranagar','712103',1,0,'2022-03-03 12:46:31','2022-03-03 12:46:31'),(52002,147,'Radhaballavpur','712616',1,0,'2022-03-03 12:46:31','2022-03-03 12:46:31'),(52003,147,'Radhanagar','712147',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52004,147,'Raghubati','712614',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52005,147,'Ragpur','712415',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52006,147,'Raijamna','712134',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52007,147,'Rajhat','712123',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52008,147,'Rajhati Bandar','712417',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52009,147,'Rameswarpur','712152',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52010,147,'Ramnagar Mobarakpur','712616',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52011,147,'Ramnathpur','712148',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52012,147,'Ranagarh','712149',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52013,147,'Ranjitbati','712416',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52014,147,'Ratanpur','712614',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52015,147,'Rosna','712149',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52016,147,'Routh Khana','712417',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52017,147,'Routhpur','712402',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52018,147,'Rudrani','712302',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52019,147,'Sabalsingpur','712417',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52020,147,'Sahabazar','712402',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52021,147,'Sahaganj','712104',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52022,147,'Saidpur (Hooghly)','712415',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52023,147,'Salepur','712616',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52024,147,'Salikona','712611',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52025,147,'Sandeswartala J.C.','712101',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52026,147,'Sankarpur','712303',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52027,147,'Santipur','712122',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52028,147,'Santoshpur','712602',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52029,147,'Saora','712616',1,0,'2022-03-03 12:46:32','2022-03-03 12:46:32'),(52030,147,'Sarai','712149',1,0,'2022-03-03 12:46:33','2022-03-03 12:46:33'),(52031,147,'Satberia','712612',1,0,'2022-03-03 12:46:33','2022-03-03 12:46:33'),(52032,147,'Satithan','712149',1,0,'2022-03-03 12:46:33','2022-03-03 12:46:33'),(52033,147,'Selampur','712122',1,0,'2022-03-03 12:46:33','2022-03-03 12:46:33'),(52034,147,'Senai','712611',1,0,'2022-03-03 12:46:33','2022-03-03 12:46:33'),(52035,147,'Shibpur Bansberia','712502',1,0,'2022-03-03 12:46:33','2022-03-03 12:46:33'),(52036,147,'Shyambazar','712122',1,0,'2022-03-03 12:46:33','2022-03-03 12:46:33'),(52037,147,'SIMLAGARH','712135',1,0,'2022-03-03 12:46:33','2022-03-03 12:46:33'),(52038,147,'Singrapur','712614',1,0,'2022-03-03 12:46:33','2022-03-03 12:46:33'),(52039,147,'Sinhet','712305',1,0,'2022-03-03 12:46:33','2022-03-03 12:46:33'),(52040,147,'Siptai','712308',1,0,'2022-03-03 12:46:33','2022-03-03 12:46:33'),(52041,147,'Sogandha','712102',1,0,'2022-03-03 12:46:33','2022-03-03 12:46:33'),(52042,147,'Somra','712123',1,0,'2022-03-03 12:46:33','2022-03-03 12:46:33'),(52043,147,'Sonatikri','712406',1,0,'2022-03-03 12:46:33','2022-03-03 12:46:33'),(52044,147,'Sripur','712612',1,0,'2022-03-03 12:46:34','2022-03-03 12:46:34'),(52045,147,'Sripur Bazar (Hooghly)','712514',1,0,'2022-03-03 12:46:34','2022-03-03 12:46:34'),(52046,147,'Sultangacha','712148',1,0,'2022-03-03 12:46:34','2022-03-03 12:46:34'),(52047,147,'Sunia','712614',1,0,'2022-03-03 12:46:34','2022-03-03 12:46:34'),(52048,147,'Talandu','712148',1,0,'2022-03-03 12:46:34','2022-03-03 12:46:34'),(52049,147,'Talbona','712134',1,0,'2022-03-03 12:46:34','2022-03-03 12:46:34'),(52050,147,'Tamlipara','712103',1,0,'2022-03-03 12:46:34','2022-03-03 12:46:34'),(52051,147,'Tantisal','712412',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52052,147,'Tarahat','712612',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52053,147,'Thakuranichak','712613',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52054,147,'Tilari','712122',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52055,147,'Tinna','712149',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52056,147,'Tirol','712602',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52057,147,'Tribeni','712503',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52058,147,'Udaypur','712406',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52059,147,'Aimapaharpur','712401',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52060,147,'Akuni','712701',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52061,147,'Anandanagar','712409',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52062,147,'Angus','712221',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52063,147,'Aniya','712706',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52064,147,'Ankri-serampore','712401',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52065,147,'Antisara','712223',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52066,147,'Antpur','712424',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52067,147,'Astara','712401',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52068,147,'Baganda','712404',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52069,147,'Bahirkhand','712405',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52070,147,'Bahirserampore','712203',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52071,147,'Baidyabati','712222',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52072,147,'Baidyapur Shibtala','712410',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52073,147,'Bajemalia','712407',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52074,147,'Bajitpur','712405',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52075,147,'Baksha','712304',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52076,147,'Balarambati','712409',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52077,147,'Baligori','712410',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52078,147,'Balipur','712401',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52079,147,'Bamunari','712250',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52080,147,'Bandhpur','712701',1,0,'2022-03-03 12:46:35','2022-03-03 12:46:35'),(52081,147,'Bandipur','712407',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52082,147,'Bangurpark','712248',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52083,147,'Barabahera','712246',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52084,147,'Baratajpur','712306',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52085,147,'Baruipara','712306',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52086,147,'Basubati','712409',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52087,147,'Basuri','712403',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52088,147,'Begampur (Hooghly)','712306',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52089,147,'Belumilki','712223',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52090,147,'Beraberi','712407',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52091,147,'Bhadrakali','712232',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52092,147,'Bhadreswar','712124',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52093,147,'Bhagabatipur','712701',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52094,147,'Bhangamora','712410',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52095,147,'Bhata','712410',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52096,147,'Bighati','712124',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52097,147,'Binagram','712401',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52098,147,'Bishnupur','712410',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52099,147,'Bora','712306',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52100,147,'Borai','712306',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52101,147,'Boraichanditala','712136',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52102,147,'Brahmanpara','712405',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52103,147,'Chakundi','712310',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52104,147,'Champadanga','712401',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52105,147,'Champdani','712222',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52106,147,'Chandannagar Barasat','712136',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52107,147,'Chandannagar R.S','712136',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52108,147,'Chandannagar (Hooghly)','712136',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52109,147,'Chandanpur','712223',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52110,147,'Chanditala','712702',1,0,'2022-03-03 12:46:36','2022-03-03 12:46:36'),(52111,147,'Charpur','712706',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52112,147,'Chatra (Hooghly)','712204',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52113,147,'Chaulpatty','712410',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52114,147,'Chikranda','712304',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52115,147,'Chiladangi','712401',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52116,147,'Chinamore','712223',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52117,147,'Chitrasali','712407',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52118,147,'Criper Road','712235',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52119,147,'Dakshindihi','712706',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52120,147,'Dalapatipur','712403',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52121,147,'Dankuni Coal Complex','712310',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52122,147,'Dankuni','712311',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52123,147,'Dearah','712223',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52124,147,'Dewanbheri','712409',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52125,147,'Dihiratanpur','712409',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52126,147,'Dilakash','712404',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52127,147,'Dingalhati','712404',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52128,147,'Duttapur','712410',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52129,147,'Dwarhatta','712403',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52130,147,'Furfura','712706',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52131,147,'Ganderpukur','712409',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52132,147,'Gandhisarak','712248',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52133,147,'Gangadharpur Bazar','712306',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52134,147,'Garalgacha','712708',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52135,147,'Gholdigrui','712401',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52136,147,'Ghole','712401',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52137,147,'Gondalpara','712137',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52138,147,'Gopalnagar Harharia','712409',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52139,147,'Guti','712408',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52140,147,'Haripal','712403',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52141,147,'Haripur','712701',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52142,147,'Haripur Chak','712407',1,0,'2022-03-03 12:46:37','2022-03-03 12:46:37'),(52143,147,'Harishnagar','712409',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52144,147,'Hawakhana','712403',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52145,147,'Hindmotor','712233',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52146,147,'Illahipur','712707',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52147,147,'Jagalgori','712403',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52148,147,'Jagatnagar','712409',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52149,147,'Jalaghata','712409',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52150,147,'Jamdara','712410',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52151,147,'Janai','712304',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52152,147,'Jangalapara','712419',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52153,147,'Jangalpara Bazar','712701',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52154,147,'Jangipara','712404',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52155,147,'Jarura','712138',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52156,147,'Jejur','712405',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52157,147,'K G R S Path','712124',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52158,147,'Kaikala','712405',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52159,147,'Kalachara','712405',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52160,147,'Kalachara','712702',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52161,147,'Kalbazar','712201',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52162,147,'Kamarkundu','712407',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52163,147,'Kanaipur','712234',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52164,147,'Karicharbheri','712409',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52165,147,'Kashipur','712410',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52166,147,'Keshabchak','712410',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52167,147,'Ketera','712410',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52168,147,'Khalisani','712138',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52169,147,'Khamarchandi','712405',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52170,147,'Kharsarai','712304',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52171,147,'Kinkarbati','712407',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52172,147,'Konnagar','712235',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52173,147,'Krishanagar','712404',1,0,'2022-03-03 12:46:38','2022-03-03 12:46:38'),(52174,147,'Kristarampur','712705',1,0,'2022-03-03 12:46:39','2022-03-03 12:46:39'),(52175,147,'Kulakash','712404',1,0,'2022-03-03 12:46:39','2022-03-03 12:46:39'),(52176,147,'Kumarpara (Hooghly)','712222',1,0,'2022-03-03 12:46:39','2022-03-03 12:46:39'),(52177,147,'Kumirmorah','712704',1,0,'2022-03-03 12:46:39','2022-03-03 12:46:39'),(52178,147,'Kumrul','712410',1,0,'2022-03-03 12:46:39','2022-03-03 12:46:39'),(52179,147,'Kundughat','712136',1,0,'2022-03-03 12:46:39','2022-03-03 12:46:39'),(52180,147,'Lakshmandur','712404',1,0,'2022-03-03 12:46:39','2022-03-03 12:46:39'),(52181,147,'Madpur','712410',1,0,'2022-03-03 12:46:39','2022-03-03 12:46:39'),(52182,147,'Mahesh -1','712202',1,0,'2022-03-03 12:46:39','2022-03-03 12:46:39'),(52183,147,'Mahesh 2','712248',1,0,'2022-03-03 12:46:39','2022-03-03 12:46:39'),(52184,147,'Makhla','712245',1,0,'2022-03-03 12:46:39','2022-03-03 12:46:39'),(52185,147,'Malia','712405',1,0,'2022-03-03 12:46:39','2022-03-03 12:46:39'),(52186,147,'Mallickpara','712203',1,0,'2022-03-03 12:46:39','2022-03-03 12:46:39'),(52187,147,'Manicktala Bazar','712201',1,0,'2022-03-03 12:46:39','2022-03-03 12:46:39'),(52188,147,'Maniktala Bazar','712201',1,0,'2022-03-03 12:46:39','2022-03-03 12:46:39'),(52189,147,'Mankundu Govt.Colony','712139',1,0,'2022-03-03 12:46:39','2022-03-03 12:46:39'),(52190,147,'Mankundu','712139',1,0,'2022-03-03 12:46:40','2022-03-03 12:46:40'),(52191,147,'Masat','712701',1,0,'2022-03-03 12:46:40','2022-03-03 12:46:40'),(52192,147,'Masjidlane','712248',1,0,'2022-03-03 12:46:40','2022-03-03 12:46:40'),(52193,147,'Mirjapur Bankipur','712409',1,0,'2022-03-03 12:46:40','2022-03-03 12:46:40'),(52194,147,'Mohistikri','712223',1,0,'2022-03-03 12:46:40','2022-03-03 12:46:40'),(52195,147,'Moktarpur','712401',1,0,'2022-03-03 12:46:40','2022-03-03 12:46:40'),(52196,147,'Mollasimla','712223',1,0,'2022-03-03 12:46:40','2022-03-03 12:46:40'),(52197,147,'Mollerberh','712250',1,0,'2022-03-03 12:46:40','2022-03-03 12:46:40'),(52198,147,'Monirampur','712304',1,0,'2022-03-03 12:46:40','2022-03-03 12:46:40'),(52199,147,'Mora','712403',1,0,'2022-03-03 12:46:40','2022-03-03 12:46:40'),(52200,147,'Morepukur','712250',1,0,'2022-03-03 12:46:40','2022-03-03 12:46:40'),(52201,147,'Mrigala','712311',1,0,'2022-03-03 12:46:40','2022-03-03 12:46:40'),(52202,147,'Muidipur','712410',1,0,'2022-03-03 12:46:40','2022-03-03 12:46:40'),(52203,147,'Mundalika','712404',1,0,'2022-03-03 12:46:40','2022-03-03 12:46:40'),(52204,147,'Musapur','712405',1,0,'2022-03-03 12:46:40','2022-03-03 12:46:40'),(52205,147,'Nabagram (Hooghly)','712246',1,0,'2022-03-03 12:46:40','2022-03-03 12:46:40'),(52206,147,'Naity','712702',1,0,'2022-03-03 12:46:40','2022-03-03 12:46:40'),(52207,147,'Nalikul','712407',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52208,147,'Nanda','712124',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52209,147,'Nasibpur','712223',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52210,147,'Nawabpur','712701',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52211,147,'Noapara','712138',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52212,147,'Nutangram','712250',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52213,147,'Pahalampur','712223',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52214,147,'Palpara (Hooghly)','712136',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52215,147,'Paltagarh','712409',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52216,147,'Panchgharabazar','712306',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52217,147,'Paniseola','712405',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52218,147,'Pargopalnagar','712418',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52219,147,'Parshyampur','712401',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52220,147,'Paschimgopinathpur','712403',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52221,147,'Paschimtajpur','712706',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52222,147,'Poshpur','712408',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52223,147,'Prabasnagar','712249',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52224,147,'Prasadpur','712426',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52225,147,'Pursurah','712401',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52226,147,'Raghunathpur (Hooghly)','712247',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52227,147,'Rahimpur','712408',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52228,147,'Rajabazar (Hooghly)','712125',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52229,147,'Rajbalhat','712408',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52230,147,'Rajendra Avenue','712258',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52231,147,'Ramnagar (Hooghly)','712411',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52232,147,'Ramnarayanpur','712401',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52233,147,'Rashidpur','712408',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52234,147,'Rasulpur','712410',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52235,147,'Rishra','712248',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52236,147,'Sainta','712410',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52237,147,'Samserpur','712410',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52238,147,'Saradapally','712124',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52239,147,'Satghara','712404',1,0,'2022-03-03 12:46:41','2022-03-03 12:46:41'),(52240,147,'Seakhala','712706',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52241,147,'Serampore Court','712201',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52242,147,'Serampore H.O','712201',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52243,147,'Sheoraphuli','712223',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52244,147,'Shyampur','712410',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52245,147,'Simla','712203',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52246,147,'Singherbheri','712409',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52247,147,'Singur','712409',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52248,147,'Soaluk','712410',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52249,147,'Talpur','712410',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52250,147,'Tarakeswar Math','712410',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52251,147,'Tarakeswar','712410',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52252,147,'Teghari','712410',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52253,147,'Telinipara','712125',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52254,147,'Uttarpara Bazar','712258',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52255,147,'Uttarpara','712258',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52256,148,'Dihibhursut','712408',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52257,148,'A.Guha Road','711204',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52258,148,'A.Road(Bamungachi)','711106',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52259,148,'Abhoynagar','711205',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52260,148,'Agunshi','711303',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52261,148,'Ajodhyaghat','711312',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52262,148,'Alipur','711315',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52263,148,'Amaragori','711401',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52264,148,'Amardah','711312',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52265,148,'Amta','711401',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52266,148,'Anandanagar','711227',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52267,148,'Anantapur (Howrah)','711301',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52268,148,'Andul -mouri','711302',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52269,148,'Andul Road','711103',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52270,148,'Antila','711312',1,0,'2022-03-03 12:46:42','2022-03-03 12:46:42'),(52271,148,'Anulia','711401',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52272,148,'Argori','711302',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52273,148,'B.Garden','711103',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52274,148,'Bachhri','711312',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52275,148,'Baganda','711315',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52276,148,'Bagnan','711303',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52277,148,'Bagua','711401',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52278,148,'Bahira','711316',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52279,148,'Baidyanathpur','711312',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52280,148,'Bainan','711303',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52281,148,'Bairakurchi','711226',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52282,148,'Baisnabpara Bazar','711102',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52283,148,'Baksara','711110',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52284,148,'Bakshi','711303',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52285,148,'Bakultala','711109',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52286,148,'Balichaturi','711315',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52287,148,'Balitikuri','711113',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52288,148,'Bally Goswami Rd','711201',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52289,148,'Bally','711201',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52290,148,'Baluhati','711405',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52291,148,'Bamangachi','711106',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52292,148,'Bandhaghat','711106',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52293,148,'Bangalpur','711303',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52294,148,'Banharishpur','711322',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52295,148,'Baniban','711316',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52296,148,'Banipur (Howrah)','711304',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52297,148,'Banitala','711316',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52298,148,'Bankra','711403',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52299,148,'Bankura Bo(Howrah)','711303',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52300,148,'Bantul','711312',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52301,148,'Baramahera','711401',1,0,'2022-03-03 12:46:43','2022-03-03 12:46:43'),(52302,148,'Barda','711401',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52303,148,'Bargachia','711404',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52304,148,'Bargarchumuk','711312',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52305,148,'Bargram','711312',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52306,148,'Barunda','711303',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52307,148,'Basudebpur','711316',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52308,148,'Batai','711401',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52309,148,'Batiatala','711103',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52310,148,'Bauria','711305',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52311,148,'Begri','711411',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52312,148,'Belari','711315',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52313,148,'Beldubi','711322',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52314,148,'Belgachia Mansatala','711101',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52315,148,'Belkulai','711322',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52316,148,'Belur Bazar','711202',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52317,148,'Belur Math','711202',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52318,148,'Benapur Chandanpara','711312',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52319,148,'Bhairab Dutta Lane','711106',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52320,148,'Bhandardaha','711411',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52321,148,'Bhandargacha','711401',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52322,148,'Bharat Cooperative','711313',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52323,148,'Bhatora','711303',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52324,148,'Bhattanagar','711203',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52325,148,'Bhekutal','711315',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52326,148,'Bikihakola','711322',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52327,148,'Biprannapara','711411',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52328,148,'Birampur','711303',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52329,148,'Birshibpur','711316',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52330,148,'Brindabanpur','711316',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52331,148,'Burikhali','711310',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52332,148,'Chackasi','711307',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52333,148,'Chakpara','711204',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52334,148,'Chakraberia','711104',1,0,'2022-03-03 12:46:44','2022-03-03 12:46:44'),(52335,148,'Chakur','711303',1,0,'2022-03-03 12:46:45','2022-03-03 12:46:45'),(52336,148,'Chamrail','711114',1,0,'2022-03-03 12:46:45','2022-03-03 12:46:45'),(52337,148,'Chatterjee Hat','711104',1,0,'2022-03-03 12:46:45','2022-03-03 12:46:45'),(52338,148,'Chaturbhujkati','711313',1,0,'2022-03-03 12:46:45','2022-03-03 12:46:45'),(52339,148,'Chengail','711308',1,0,'2022-03-03 12:46:45','2022-03-03 12:46:45'),(52340,148,'Chitnan','711303',1,0,'2022-03-03 12:46:45','2022-03-03 12:46:45'),(52341,148,'Chitrasenpur','711412',1,0,'2022-03-03 12:46:45','2022-03-03 12:46:45'),(52342,148,'Circular Rd.','711104',1,0,'2022-03-03 12:46:45','2022-03-03 12:46:45'),(52343,148,'Cows Ghat Rd','711102',1,0,'2022-03-03 12:46:45','2022-03-03 12:46:45'),(52344,148,'D.G.Road','711103',1,0,'2022-03-03 12:46:45','2022-03-03 12:46:45'),(52345,148,'Dafarpur','711405',1,0,'2022-03-03 12:46:45','2022-03-03 12:46:45'),(52346,148,'Dakshin Durgapur','711301',1,0,'2022-03-03 12:46:45','2022-03-03 12:46:45'),(52347,148,'Dakshin Hirapur','711315',1,0,'2022-03-03 12:46:45','2022-03-03 12:46:45'),(52348,148,'Dakshin Jhapardaha','711405',1,0,'2022-03-03 12:46:45','2022-03-03 12:46:45'),(52349,148,'Dakshin Radhanagar','711312',1,0,'2022-03-03 12:46:45','2022-03-03 12:46:45'),(52350,148,'Dakshin Ramchandrapur','711315',1,0,'2022-03-03 12:46:45','2022-03-03 12:46:45'),(52351,148,'Dakshin Santoshpur','711404',1,0,'2022-03-03 12:46:45','2022-03-03 12:46:45'),(52352,148,'Dakshin Shibpur','711314',1,0,'2022-03-03 12:46:46','2022-03-03 12:46:46'),(52353,148,'Danesh Sk.Lane','711109',1,0,'2022-03-03 12:46:46','2022-03-03 12:46:46'),(52354,148,'Dasbhaga','711307',1,0,'2022-03-03 12:46:46','2022-03-03 12:46:46'),(52355,148,'Dasnagar','711105',1,0,'2022-03-03 12:46:46','2022-03-03 12:46:46'),(52356,148,'Daws Temple Rd','711205',1,0,'2022-03-03 12:46:46','2022-03-03 12:46:46'),(52357,148,'Debandi','711410',1,0,'2022-03-03 12:46:46','2022-03-03 12:46:46'),(52358,148,'Delta Mil','711309',1,0,'2022-03-03 12:46:46','2022-03-03 12:46:46'),(52359,148,'Deoly','711301',1,0,'2022-03-03 12:46:46','2022-03-03 12:46:46'),(52360,148,'Deora','711401',1,0,'2022-03-03 12:46:46','2022-03-03 12:46:46'),(52361,148,'Deul Gram','711303',1,0,'2022-03-03 12:46:46','2022-03-03 12:46:46'),(52362,148,'Deulpur','711411',1,0,'2022-03-03 12:46:46','2022-03-03 12:46:46'),(52363,148,'Deulti','711303',1,0,'2022-03-03 12:46:46','2022-03-03 12:46:46'),(52364,148,'Dhamsia','711322',1,0,'2022-03-03 12:46:46','2022-03-03 12:46:46'),(52365,148,'Dharmatala Rd','711106',1,0,'2022-03-03 12:46:46','2022-03-03 12:46:46'),(52366,148,'Dharsa','711104',1,0,'2022-03-03 12:46:46','2022-03-03 12:46:46'),(52367,148,'Dhulagori','711302',1,0,'2022-03-03 12:46:46','2022-03-03 12:46:46'),(52368,148,'Dhulasimla','711315',1,0,'2022-03-03 12:46:47','2022-03-03 12:46:47'),(52369,148,'Dhulopur','711316',1,0,'2022-03-03 12:46:47','2022-03-03 12:46:47'),(52370,148,'Dhunki','711322',1,0,'2022-03-03 12:46:47','2022-03-03 12:46:47'),(52371,148,'Dhurkhali','711410',1,0,'2022-03-03 12:46:47','2022-03-03 12:46:47'),(52372,148,'Dihimondal Ghat','711301',1,0,'2022-03-03 12:46:47','2022-03-03 12:46:47'),(52373,148,'Dinabandhu Instt.','711102',1,0,'2022-03-03 12:46:47','2022-03-03 12:46:47'),(52374,148,'Dingakhola','711314',1,0,'2022-03-03 12:46:47','2022-03-03 12:46:47'),(52375,148,'Domjur','711405',1,0,'2022-03-03 12:46:47','2022-03-03 12:46:47'),(52376,148,'Duillya','711302',1,0,'2022-03-03 12:46:47','2022-03-03 12:46:47'),(52377,148,'Durgapur','711205',1,0,'2022-03-03 12:46:47','2022-03-03 12:46:47'),(52378,148,'Fortgloster','711310',1,0,'2022-03-03 12:46:47','2022-03-03 12:46:47'),(52379,148,'Fuleswar','711316',1,0,'2022-03-03 12:46:47','2022-03-03 12:46:47'),(52380,148,'Gabberia','711322',1,0,'2022-03-03 12:46:47','2022-03-03 12:46:47'),(52381,148,'Gangadharpur','711302',1,0,'2022-03-03 12:46:47','2022-03-03 12:46:47'),(52382,148,'Garbalia','711410',1,0,'2022-03-03 12:46:47','2022-03-03 12:46:47'),(52383,148,'Gaza','711226',1,0,'2022-03-03 12:46:47','2022-03-03 12:46:47'),(52384,148,'Gazipur','711413',1,0,'2022-03-03 12:46:48','2022-03-03 12:46:48'),(52385,148,'Geneshpur','711312',1,0,'2022-03-03 12:46:48','2022-03-03 12:46:48'),(52386,148,'Ghoshpara (Howrah)','711227',1,0,'2022-03-03 12:46:48','2022-03-03 12:46:48'),(52387,148,'Ghoshpur','711401',1,0,'2022-03-03 12:46:48','2022-03-03 12:46:48'),(52388,148,'Ghusuri','711107',1,0,'2022-03-03 12:46:48','2022-03-03 12:46:48'),(52389,148,'Gip Colony','711112',1,0,'2022-03-03 12:46:48','2022-03-03 12:46:48'),(52390,148,'Goabaria','711109',1,0,'2022-03-03 12:46:48','2022-03-03 12:46:48'),(52391,148,'Gobardhanbati','711322',1,0,'2022-03-03 12:46:48','2022-03-03 12:46:48'),(52392,148,'Gobindapur','711314',1,0,'2022-03-03 12:46:48','2022-03-03 12:46:48'),(52393,148,'Gobindapur Shibtala','711414',1,0,'2022-03-03 12:46:48','2022-03-03 12:46:48'),(52394,148,'Gohalberia','711315',1,0,'2022-03-03 12:46:48','2022-03-03 12:46:48'),(52395,148,'Gondalpara','711302',1,0,'2022-03-03 12:46:48','2022-03-03 12:46:48'),(52396,148,'Gourangachak','711410',1,0,'2022-03-03 12:46:48','2022-03-03 12:46:48'),(52397,148,'Gurepole','711314',1,0,'2022-03-03 12:46:48','2022-03-03 12:46:48'),(52398,148,'Gutinagari','711315',1,0,'2022-03-03 12:46:48','2022-03-03 12:46:48'),(52399,148,'Guzarpur','711314',1,0,'2022-03-03 12:46:48','2022-03-03 12:46:48'),(52400,148,'Hallyan','711312',1,0,'2022-03-03 12:46:48','2022-03-03 12:46:48'),(52401,148,'Hantal Anantabati','711404',1,0,'2022-03-03 12:46:48','2022-03-03 12:46:48'),(52402,148,'Harali','711226',1,0,'2022-03-03 12:46:48','2022-03-03 12:46:48'),(52403,148,'Harishpur','711410',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52404,148,'Harop','711303',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52405,148,'Hatgacha','711316',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52406,148,'Haturia','711303',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52407,148,'Hirapur','711310',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52408,148,'Hooghly Dock','711106',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52409,148,'Howrah H.O','711101',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52410,148,'Howrah Loco Depot','711106',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52411,148,'Howrah R.S','711101',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52412,148,'Howrah Vic.Cot.Mill','711107',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52413,148,'Ichapur Rd','711104',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52414,148,'Islampur','711401',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52415,148,'Jadhuberia','711316',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52416,148,'Jagacha','711111',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52417,148,'Jagadishpur','711315',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52418,148,'Jagadishpur Hat','711114',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52419,148,'Jagatballavpur','711408',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52420,148,'Jagriti','711106',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52421,148,'Jalabiswanathpur','711322',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52422,148,'Jalalshi','711411',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52423,148,'Jallabaj','711314',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52424,148,'Jhamtia','711401',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52425,148,'Jhinkra','711401',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52426,148,'Jhorehat','711302',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52427,148,'Jhumjhumi','711301',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52428,148,'Joargori','711303',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52429,148,'Joka','711226',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52430,148,'Joynagar','711302',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52431,148,'Joypur','711401',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52432,148,'Joypur Bill','711205',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52433,148,'Joypur Fakirdas','711401',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52434,148,'Jujursa','711302',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52435,148,'Kadamtala (Howrah)','711101',1,0,'2022-03-03 12:46:49','2022-03-03 12:46:49'),(52436,148,'Kaijuri','711316',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52437,148,'Kalidaha','711314',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52438,148,'Kalyanpur','711303',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52439,148,'Kanjiakhali','711315',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52440,148,'Kankrol','711401',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52441,148,'Kanpur','711410',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52442,148,'Kanupath Majhpara','711412',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52443,148,'Karatberia','711316',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52444,148,'Kashmul','711315',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52445,148,'Kendua','711302',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52446,148,'Keorapara','711102',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52447,148,'Keshabpur','711411',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52448,148,'Khadinan','711303',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52449,148,'Khajutti','711303',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52450,148,'Khalisani','711307',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52451,148,'Khalna','711413',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52452,148,'Khantaberia','711316',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52453,148,'Khantapukur','711303',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52454,148,'Khantora','711411',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52455,148,'Khariamoynapur','711316',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52456,148,'Kharuberia','711314',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52457,148,'Khasmahal Balichak','711401',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52458,148,'Khasmali','711303',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52459,148,'Khasmora','711411',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52460,148,'Khila','711410',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52461,148,'Khorop','711401',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52462,148,'Khosalpur','711401',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52463,148,'Khurut Rd','711101',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52464,148,'Kolora','711411',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52465,148,'Kona','711114',1,0,'2022-03-03 12:46:50','2022-03-03 12:46:50'),(52466,148,'Kotra','711301',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52467,148,'Kuldanga','711302',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52468,148,'Kulgachia','711306',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52469,148,'Kulitapara','711312',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52470,148,'Kultikari','711312',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52471,148,'Kumarchak','711401',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52472,148,'Kurigachi','711315',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52473,148,'Kushberia','711413',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52474,148,'Kushberia','711316',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52475,148,'Lakshmanpur','711114',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52476,148,'Latibpur','711316',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52477,148,'Liluah','711204',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52478,148,'M.B.Road','711201',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52479,148,'Madhabpur','711315',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52480,148,'Mahishrekha','711303',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52481,148,'Maju','711414',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52482,148,'Makardaha','711409',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52483,148,'Manikura','711410',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52484,148,'Mankur','711303',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52485,148,'Mansinghpur','711404',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52486,148,'Mansuka','711410',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52487,148,'Mashila','711302',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52488,148,'Mato','711408',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52489,148,'Mellock','711303',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52490,148,'Mollahat','711314',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52491,148,'Mugkalyan','711312',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52492,148,'Munshidanga','711403',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52493,148,'Munshirhat','711410',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52494,148,'Nabaghara','711322',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52495,148,'Nabagram Sikipur','711315',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52496,148,'Nakol','711312',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52497,148,'Nalpur','711310',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52498,148,'Narit','711413',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52499,148,'Narna','711405',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52500,148,'Naskarpur','711414',1,0,'2022-03-03 12:46:51','2022-03-03 12:46:51'),(52501,148,'Naul','711312',1,0,'2022-03-03 12:46:52','2022-03-03 12:46:52'),(52502,148,'Nawpala','711303',1,0,'2022-03-03 12:46:52','2022-03-03 12:46:52'),(52503,148,'Nayachak','711322',1,0,'2022-03-03 12:46:52','2022-03-03 12:46:52'),(52504,148,'Netajigarh','711108',1,0,'2022-03-03 12:46:52','2022-03-03 12:46:52'),(52505,148,'New Kolora','711302',1,0,'2022-03-03 12:46:52','2022-03-03 12:46:52'),(52506,148,'Nibra','711409',1,0,'2022-03-03 12:46:52','2022-03-03 12:46:52'),(52507,148,'Nijbalia','711404',1,0,'2022-03-03 12:46:52','2022-03-03 12:46:52'),(52508,148,'Noapara','711401',1,0,'2022-03-03 12:46:52','2022-03-03 12:46:52'),(52509,148,'Nonakundu','711405',1,0,'2022-03-03 12:46:52','2022-03-03 12:46:52'),(52510,148,'Olabibitala','711104',1,0,'2022-03-03 12:46:52','2022-03-03 12:46:52'),(52511,148,'Olanpara','711303',1,0,'2022-03-03 12:46:52','2022-03-03 12:46:52'),(52512,148,'Old Jagacha','711112',1,0,'2022-03-03 12:46:52','2022-03-03 12:46:52'),(52513,148,'Orphuli','711303',1,0,'2022-03-03 12:46:52','2022-03-03 12:46:52'),(52514,148,'Pachalbazar','711101',1,0,'2022-03-03 12:46:52','2022-03-03 12:46:52'),(52515,148,'Pacharul','711225',1,0,'2022-03-03 12:46:52','2022-03-03 12:46:52'),(52516,148,'Paikpara','711410',1,0,'2022-03-03 12:46:52','2022-03-03 12:46:52'),(52517,148,'Panchanantala Road','711101',1,0,'2022-03-03 12:46:52','2022-03-03 12:46:52'),(52518,148,'Panchla','711322',1,0,'2022-03-03 12:46:52','2022-03-03 12:46:52'),(52519,148,'Paniara','711302',1,0,'2022-03-03 12:46:52','2022-03-03 12:46:52'),(52520,148,'Panitras','711303',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52521,148,'Panpur','711401',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52522,148,'Parbatipur','711405',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52523,148,'Patihal','711410',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52524,148,'Penro','711410',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52525,148,'Pichaldaha','711314',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52526,148,'Pirpur','711303',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52527,148,'Podra','711109',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52528,148,'Polgustia','711414',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52529,148,'Prosastha','711302',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52530,148,'Qumaresh','711106',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52531,148,'Rabibhag','711312',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52532,148,'Radhadasi','711317',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52533,148,'Radhanagar','711310',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52534,148,'Radhapur','711301',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52535,148,'Raghudebbati','711310',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52536,148,'Raghudevpur','711322',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52537,148,'Raichak','711412',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52538,148,'Ramchandrapur Bo (Sank.)','711313',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52539,148,'Ramchandrapur (HowrB.O','711303',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52540,148,'Rameswarnagar','711310',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52541,148,'Ramkrishnapur','711101',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52542,148,'Ramnagar','711312',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52543,148,'Rampur','711226',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52544,148,'Ramrajatala','711104',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52545,148,'Rashpur','711401',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52546,148,'Ross Road','711101',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52547,148,'Rudrapur','711411',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52548,148,'Rupasgori','711312',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52549,148,'Sahapur','711310',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52550,148,'Salkia H.O','711106',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52551,148,'Salop','711409',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52552,148,'Saltighat Gujarpur','711401',1,0,'2022-03-03 12:46:53','2022-03-03 12:46:53'),(52553,148,'Samabaypalli','711205',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52554,148,'Samruk','711316',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52555,148,'Samta','711303',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52556,148,'Sankrail Dakshinpara','711313',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52557,148,'Sankrail','711313',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52558,148,'Santoshnagar','711401',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52559,148,'Santoshpur','711310',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52560,148,'Santragachi','711104',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52561,148,'Sapuipara','711227',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52562,148,'Sarat Chatterjee Rd.','711104',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52563,148,'Sarda','711413',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52564,148,'Sarenga','711309',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52565,148,'Sasati','711312',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52566,148,'Sauria','711413',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52567,148,'Sealdanga','711410',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52568,148,'Shibganj','711314',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52569,148,'Shibtala Liluah','711204',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52570,148,'Shyampur (Howrah)','711314',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52571,148,'Sibnarayanchak','711410',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52572,148,'Sibpur Bazar','711102',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52573,148,'Sibpur','711102',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52574,148,'Siddheswar','711414',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52575,148,'Sijberia','711316',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52576,148,'Singti Sibpur','711226',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52577,148,'Sonagachi','711226',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52578,148,'Sonamui','711401',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52579,148,'Sonatala','711412',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52580,148,'South Joychanditala','711405',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52581,148,'Subhararah','711302',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52582,148,'Subsit','711303',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52583,148,'Sumda','711303',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52584,148,'Sundarpur','711316',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52585,148,'T.M.G Lane','711102',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52586,148,'Tajpur','711413',1,0,'2022-03-03 12:46:54','2022-03-03 12:46:54'),(52587,148,'Tehatta','711322',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52588,148,'Tentulkuli','711409',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52589,148,'Thalia','711401',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52590,148,'Tulsiberia','711401',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52591,148,'Udang','711401',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52592,148,'Udaynarayanpur','711226',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52593,148,'Ula','711310',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52594,148,'Uluberia R.S','711316',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52595,148,'Uluberia','711315',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52596,148,'Unsani','711302',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52597,148,'Uttar Batora','711303',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52598,148,'Uttar Durgapur','711312',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52599,148,'Uttar Jharpardah','711405',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52600,148,'Uttar Manasri','711412',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52601,148,'Wadipur','711411',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52602,149,'Alipurduar Court','736122',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52603,149,'Alipurduar Junction','736123',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52604,149,'Alipurduar New Town','736121',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52605,149,'Alipurduar','736121',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52606,149,'Atiabaribagan','735217',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52607,149,'Bakla Schooldanga','736206',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52608,149,'Bakshaduar','735227',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52609,149,'Banchukamari','736122',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52610,149,'Baniadabri','736206',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52611,149,'Baniagaon','736206',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52612,149,'Barachaukirbash','736206',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52613,149,'Bararangrash','736121',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52614,149,'Barobisha','736207',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52615,149,'Barodaldali','736203',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52616,149,'Baruipara','736207',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52617,149,'Bhatibari','736121',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52618,149,'Bhelukdabri','736208',1,0,'2022-03-03 12:46:55','2022-03-03 12:46:55'),(52619,149,'Bholardabri','736123',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52620,149,'Bindipara','736208',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52621,149,'Birpara Alipurduar','736121',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52622,149,'Boragari','736121',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52623,149,'Brajerkuthi','736202',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52624,149,'Chalnirpak','736121',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52625,149,'Chaparerpar','736121',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52626,149,'Chikliguri','736202',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52627,149,'Chinchula','735217',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52628,149,'Chuapara','735217',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52629,149,'Chuniajhora','736201',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52630,149,'Dakshin Chakoakheti','736204',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52631,149,'Dakshin Dhalkar','736208',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52632,149,'Dakshin Kamaskhyaguri','736202',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52633,149,'Dakshin Kamsingram','736204',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52634,149,'Dakshin Latabari','735214',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52635,149,'Dakshin Mahakalguri','736206',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52636,149,'Dakshin Nararthali','736202',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52637,149,'Dakshin Patkapara','736121',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52638,149,'Dakshin Satali','735214',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52639,149,'Dalshingpara','735208',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52640,149,'Damanpur','736123',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52641,149,'Damsibad','736206',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52642,149,'Dhaolajhora','736206',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52643,149,'Ghagra','736122',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52644,149,'Gharghariahat','736121',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52645,149,'Gopaldashat','736121',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52646,149,'Hamiltonganj','735214',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52647,149,'Hasimara','735215',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52648,149,'Hatidhura','736121',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52649,149,'Hatipotha','736201',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52650,149,'Hemaguri','736203',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52651,149,'Jaigaon','736182',1,0,'2022-03-03 12:46:56','2022-03-03 12:46:56'),(52652,149,'Jainti','735227',1,0,'2022-03-03 12:46:57','2022-03-03 12:46:57'),(52653,149,'Jaldapara','736204',1,0,'2022-03-03 12:46:57','2022-03-03 12:46:57'),(52654,149,'Jasodanga','736208',1,0,'2022-03-03 12:46:57','2022-03-03 12:46:57'),(52655,149,'Jorai','736207',1,0,'2022-03-03 12:46:57','2022-03-03 12:46:57'),(52656,149,'Kadampur','736206',1,0,'2022-03-03 12:46:57','2022-03-03 12:46:57'),(52657,149,'Kaijali Basti','736201',1,0,'2022-03-03 12:46:57','2022-03-03 12:46:57'),(52658,149,'Kalabaria','736204',1,0,'2022-03-03 12:46:57','2022-03-03 12:46:57'),(52659,149,'Kalchini','735217',1,0,'2022-03-03 12:46:57','2022-03-03 12:46:57'),(52660,149,'Kalipur','736204',1,0,'2022-03-03 12:46:57','2022-03-03 12:46:57'),(52661,149,'Kamaskhyaguri','736202',1,0,'2022-03-03 12:46:57','2022-03-03 12:46:57'),(52662,149,'Kartik Choupathi','736201',1,0,'2022-03-03 12:46:57','2022-03-03 12:46:57'),(52663,149,'Khoardanga','736202',1,0,'2022-03-03 12:46:57','2022-03-03 12:46:57'),(52664,149,'Khochabarihat','736121',1,0,'2022-03-03 12:46:57','2022-03-03 12:46:57'),(52665,149,'Kholta','736121',1,0,'2022-03-03 12:46:57','2022-03-03 12:46:57'),(52666,149,'Kohinoor Tea Estate','736206',1,0,'2022-03-03 12:46:57','2022-03-03 12:46:57'),(52667,149,'Kumargramduar','736203',1,0,'2022-03-03 12:46:57','2022-03-03 12:46:57'),(52668,149,'Kumarijan','736121',1,0,'2022-03-03 12:46:57','2022-03-03 12:46:57'),(52669,149,'Lalchandpur','736202',1,0,'2022-03-03 12:46:57','2022-03-03 12:46:57'),(52670,149,'Madhubagan','735215',1,0,'2022-03-03 12:46:57','2022-03-03 12:46:57'),(52671,149,'Majherdabri','736123',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52672,149,'Majidkhana','736208',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52673,149,'Marakhata','736202',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52674,149,'Marichbari','736121',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52675,149,'Mathurabagan','736204',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52676,149,'Nathuatari','736204',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52677,149,'New Lands','736205',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52678,149,'New Market Jaigaon','736182',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52679,149,'Nimti Domohani','735217',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52680,149,'Panabasti','735226',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52681,149,'Panbari','736206',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52682,149,'Panchkolguri','736121',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52683,149,'Paschim Chepani','736206',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52684,149,'Paschim Khalisamari','736121',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52685,149,'Paschim Satali','735214',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52686,149,'Paschim Shalbari','736121',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52687,149,'Pukurigram','736203',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52688,149,'Purba Khalisamari','736202',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52689,149,'Purba Satali','735214',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52690,149,'Purba Shalbari','736207',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52691,149,'Radhanagar','736207',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52692,149,'Raidak','736201',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52693,149,'Rajabhat Tea Estate','735217',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52694,149,'Rajabhatkhawa','735227',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52695,149,'Rampur','736207',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52696,149,'Salkumarhat','736204',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52697,149,'Salsalabari','736208',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52698,149,'Saontalpur','736206',1,0,'2022-03-03 12:46:58','2022-03-03 12:46:58'),(52699,149,'Satali Mandal Para','735214',1,0,'2022-03-03 12:46:59','2022-03-03 12:46:59'),(52700,149,'Shilbarihat','736204',1,0,'2022-03-03 12:46:59','2022-03-03 12:46:59'),(52701,149,'Sidhabari','736204',1,0,'2022-03-03 12:46:59','2022-03-03 12:46:59'),(52702,149,'Soudpara','736121',1,0,'2022-03-03 12:46:59','2022-03-03 12:46:59'),(52703,149,'Taleshwarguri','736206',1,0,'2022-03-03 12:46:59','2022-03-03 12:46:59'),(52704,149,'Tapshikhata','736121',1,0,'2022-03-03 12:46:59','2022-03-03 12:46:59'),(52705,149,'Tatpara','736208',1,0,'2022-03-03 12:46:59','2022-03-03 12:46:59'),(52706,149,'Telepara','736202',1,0,'2022-03-03 12:46:59','2022-03-03 12:46:59'),(52707,149,'Turturi','736206',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52708,149,'Uttar Mendabari','735214',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52709,149,'Uttar Nararthali','736202',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52710,149,'Uttar Parokata','736202',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52711,149,'Uttar Shibkhata','736208',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52712,149,'Uttar Simlabari','736204',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52713,149,'Uttarpatkapara','736121',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52714,149,'Bhaktinagar','734007',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52715,149,'Dabgram','734004',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52716,149,'East Bhaktinagar','734007',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52717,149,'Fulbari Hat','734015',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52718,149,'Ghugumali','734006',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52719,149,'Haidarpara','734006',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52720,149,'Mahananda Project','734015',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52721,149,'Rabindra Sarani','734006',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52722,149,'Saktigarh (Jalpaiguri)','734001',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52723,149,'Satellite Township','734015',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52724,149,'Vivekanandapally','734001',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52725,149,'Adarpara','735101',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52726,149,'Alinagar','735216',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52727,149,'Altagram Magurmari','735210',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52728,149,'Ambaribagan','735207',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52729,149,'Ananda Pur','735218',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52730,149,'Angrabhasa','735202',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52731,149,'Badaitari','735220',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52732,149,'Baganbari','735211',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52733,149,'Bagjan','735302',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52734,149,'Bagrakote','734501',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52735,149,'Bahadur','735121',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52736,149,'Bairatiguri','735210',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52737,149,'Bakali','735305',1,0,'2022-03-03 12:47:00','2022-03-03 12:47:00'),(52738,149,'Balaram','735135',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52739,149,'Balasunder','735211',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52740,149,'Bamni','735233',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52741,149,'Banarhat','735202',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52742,149,'Banesh Jn','735224',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52743,149,'Baradighi','735230',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52744,149,'Barakamat','735305',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52745,149,'Barapatia Natunbas','735121',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52746,149,'Barogharia','735210',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52747,149,'Baroshoulmari','735211',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52748,149,'Batabari','735206',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52749,149,'Bataigole Bazaar','735221',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52750,149,'Belocoba','735133',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52751,149,'Beltoli Bhandani','735211',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52752,149,'Benkandi','735224',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52753,149,'Berubari','735132',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52754,149,'Bhaktipara','735133',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52755,149,'Bhandani','735210',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52756,149,'Bhangamali','735224',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52757,149,'Bhangerhat','735224',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52758,149,'Bhotepatty','735305',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52759,149,'Bhuskadanga','735305',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52760,149,'Bhutkidangapara','735135',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52761,149,'Bhutnirghat','735211',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52762,149,'Binnaguri Cantt','735232',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52763,149,'Binnaguri','735203',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52764,149,'Birpara Bazar','735204',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52765,149,'Birpara','735204',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52766,149,'Boulbari','735302',1,0,'2022-03-03 12:47:01','2022-03-03 12:47:01'),(52767,149,'Bowbazar (Jalpaiguri)','735101',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52768,149,'Brajapur','735132',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52769,149,'Bundapani','735204',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52770,149,'Carron','735205',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52771,149,'Chakmoulani','735219',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52772,149,'Chalsa','735206',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52773,149,'Champaguri','735225',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52774,149,'Chamurchi','735207',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52775,149,'Chanda Company','734501',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52776,149,'Chapadanga','735218',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52777,149,'Chaulhati','735102',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52778,149,'Chengmari','735218',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52779,149,'Choto Salkumar','735220',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52780,149,'Chuakhola','735211',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52781,149,'Churabhander','735224',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52782,149,'Dakhin Dhulagaon','735216',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52783,149,'Dakhin Khattimari','735210',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52784,149,'Dakhin Khyerbari','735210',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52785,149,'Dakhin Moamari','735224',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52786,149,'Dakhin Parengarpar','735211',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52787,149,'Dalimpur','735211',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52788,149,'Damdim','735209',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52789,149,'Dangapara Ashram','735305',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52790,149,'Dangapara','735133',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52791,149,'Danguajhar','735121',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52792,149,'Daukimari','735210',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52793,149,'Debithakurbari','735133',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52794,149,'Debnagar','735102',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52795,149,'Debpara','735202',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52796,149,'Deogaon','735213',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52797,149,'Dhapganj','735132',1,0,'2022-03-03 12:47:02','2022-03-03 12:47:02'),(52798,149,'Dharampur','735305',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52799,149,'Dhawlaguri','735224',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52800,149,'Dhupguri','735210',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52801,149,'Dimdima','735204',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52802,149,'Dinbazar','735101',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52803,149,'Domohani','735302',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52804,149,'Dumchipara','735228',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52805,149,'Ethelbari Crossing','735204',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52806,149,'Falakata','735211',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52807,149,'Fatapukur','735134',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52808,149,'Fulbari','735210',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52809,149,'Futkipara','735135',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52810,149,'Gadra','735134',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52811,149,'Gairkata','735212',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52812,149,'Gajaldoba','735234',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52813,149,'Garalbari','735132',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52814,149,'Garganda','735228',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52815,149,'Garialtari','735233',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52816,149,'Gopal Bagan','735213',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52817,149,'Gossairhat','735210',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52818,149,'Haihaipathar','735230',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52819,149,'Helapakri','735305',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52820,149,'Hemkumari','735122',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52821,149,'Huntapara','735220',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52822,149,'Indong','735223',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52823,149,'Jabramali','735224',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52824,149,'Jalpaiguri Bank','735101',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52825,149,'Jalpaiguri H.O','735101',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52826,149,'Jalpesh Mandir','735224',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52827,149,'Jamaldah','735303',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52828,149,'Jateswar','735216',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52829,149,'Jharsalbari','735210',1,0,'2022-03-03 12:47:03','2022-03-03 12:47:03'),(52830,149,'Jiti','735225',1,0,'2022-03-03 12:47:04','2022-03-03 12:47:04'),(52831,149,'Jogendra Pur','735211',1,0,'2022-03-03 12:47:04','2022-03-03 12:47:04'),(52832,149,'Jorepakri','735305',1,0,'2022-03-03 12:47:04','2022-03-03 12:47:04'),(52833,149,'Jpg College Para','735101',1,0,'2022-03-03 12:47:04','2022-03-03 12:47:04'),(52834,149,'Jpg Court','735101',1,0,'2022-03-03 12:47:04','2022-03-03 12:47:04'),(52835,149,'Jpg Dist. School Board','735101',1,0,'2022-03-03 12:47:04','2022-03-03 12:47:04'),(52836,149,'Jpg Hindustan Ins.','735101',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52837,149,'Jpg.Govt Engg College','735102',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52838,149,'Jurapani','735210',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52839,149,'Kachua','735122',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52840,149,'Kadamtala (Jalpaiguri)','735101',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52841,149,'Kadobarihat','735132',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52842,149,'Kailashpur','735218',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52843,149,'Kajoldighi','735219',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52844,149,'Kalabari Bagan','735202',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52845,149,'Kalirhat','735210',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52846,149,'Kamarvita','735135',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52847,149,'Kamatpara','735132',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52848,149,'Kantipara','735121',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52849,149,'Karbala','735202',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52850,149,'Karjipara','735133',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52851,149,'Kathalguri','735202',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52852,149,'Kathambari','735218',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52853,149,'Kathapara','735210',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52854,149,'Khagenhat','735204',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52855,149,'Khairanti','735218',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52856,149,'Kharia','735102',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52857,149,'Kharija Berubari','735122',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52858,149,'Kheti','735210',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52859,149,'Khowchand Para','735220',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52860,149,'Krantihat','735218',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52861,149,'Kukurjan','735133',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52862,149,'Kumarpara','735302',1,0,'2022-03-03 12:47:05','2022-03-03 12:47:05'),(52863,149,'Kunderdighi','735135',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52864,149,'Kuripara','735132',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52865,149,'Kushiarbari','735211',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52866,149,'Lankaparahat','735228',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52867,149,'Lataguri','735219',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52868,149,'Laxmikantapara','735233',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52869,149,'Lotapata','735211',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52870,149,'M R Bazna','735213',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52871,149,'Madarihat','735220',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52872,149,'Madhabdanga','735224',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52873,149,'Madhya Khagrabari','735224',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52874,149,'Madhya Khayerbari','735220',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52875,149,'Madhya Madarihat','735220',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52876,149,'Mairadanga','735211',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52877,149,'Makrapara','735228',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52878,149,'Mal H.O','735221',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52879,149,'Malhati','735218',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52880,149,'Malkanipara Nayahat','735132',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52881,149,'Manabari','735222',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52882,149,'Mandalghat','735132',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52883,149,'Mantadari','735133',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52884,149,'Matelli','735223',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52885,149,'Mathachulka','735206',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52886,149,'Maynaguri','735224',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52887,149,'Menghora','735135',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52888,149,'Milanpally','735133',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52889,149,'Mogolkata','735202',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52890,149,'Mohantapara','735101',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52891,149,'Mohanvita','735135',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52892,149,'Mohitnagar','735102',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52893,149,'Monuaganj','735135',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52894,149,'Mujnai','735228',1,0,'2022-03-03 12:47:06','2022-03-03 12:47:06'),(52895,149,'Nabanagar','735216',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52896,149,'Nagrakata','735225',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52897,149,'Nakugach','735134',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52898,149,'Nangdala','735204',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52899,149,'Narsingpur','735204',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52900,149,'Nathuahat','735233',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52901,149,'Neora','735230',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52902,149,'Nutan Bazar','735224',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52903,149,'Oodlabari','735222',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52904,149,'Padamati','735305',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52905,149,'Paharpur','735121',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52906,149,'Panbari','735219',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52907,149,'Pandapara Kalibari','735132',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52908,149,'Pangasahebbari','735121',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52909,149,'Panpara','735101',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52910,149,'Panwar Basty','735221',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52911,149,'Parangerpar','735211',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52912,149,'Paschim Mallick Para','735210',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52913,149,'Patharjhora','735222',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52914,149,'Patkata','735133',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52915,149,'Patkidaha','735210',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52916,149,'Payachari','735135',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52917,149,'Pradhanpara','735212',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52918,149,'Prasannanagar','735133',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52919,149,'Promodnagar','735216',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52920,149,'Purbadalaigaon','735218',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52921,149,'Purbaduramari','735233',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52922,149,'Putimari','735305',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52923,149,'Race Cource Para','735101',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52924,149,'Raichenga','735211',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52925,149,'Rajadanga','735218',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52926,149,'Rajbari Para','735101',1,0,'2022-03-03 12:47:07','2022-03-03 12:47:07'),(52927,149,'Rajganj','735134',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52928,149,'Ramjhora','735228',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52929,149,'Ramsaihat','735219',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52930,149,'Ramthenga','735211',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52931,149,'Rangalibazna','735213',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52932,149,'Rangdhamali','735121',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52933,149,'Red Bank','735202',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52934,149,'Rungamatee','735229',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52935,149,'Sadhupur Chengmari','735205',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52936,149,'Sahebpara','735134',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52937,149,'Sahudangirhat','735135',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52938,149,'Sailihat','735229',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52939,149,'Sajnapara','735212',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52940,149,'Sakoajhora','735212',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52941,149,'Salbari','735210',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52942,149,'Samsing','735223',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52943,149,'Saptibari','735224',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52944,149,'Saraswatipur Bagan','735133',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52945,149,'Satkhamar','735133',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52946,149,'Satpukuria','735211',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52947,149,'Sawdavita','735134',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52948,149,'Senpara','735101',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52949,149,'Shibnathpur','735220',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52950,149,'Shoulmari','735224',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52951,149,'Sikarpur','735133',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52952,149,'Silpasamiti Para','735101',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52953,149,'Singijani','735211',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52954,149,'Singimari','735302',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52955,149,'Sirampara','735132',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52956,149,'Sulkapara','735225',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52957,149,'Tahsildarbari','735133',1,0,'2022-03-03 12:47:08','2022-03-03 12:47:08'),(52958,149,'Talma','735121',1,0,'2022-03-03 12:47:09','2022-03-03 12:47:09'),(52959,149,'Talukertari','735211',1,0,'2022-03-03 12:47:09','2022-03-03 12:47:09'),(52960,149,'Tasati','735204',1,0,'2022-03-03 12:47:09','2022-03-03 12:47:09'),(52961,149,'Tekatuli','735224',1,0,'2022-03-03 12:47:09','2022-03-03 12:47:09'),(52962,149,'Tengramari','735210',1,0,'2022-03-03 12:47:09','2022-03-03 12:47:09'),(52963,149,'Totopara','735220',1,0,'2022-03-03 12:47:09','2022-03-03 12:47:09'),(52964,149,'Tukra Jateswar','735204',1,0,'2022-03-03 12:47:09','2022-03-03 12:47:09'),(52965,149,'Ulladabri','735224',1,0,'2022-03-03 12:47:09','2022-03-03 12:47:09'),(52966,149,'Uttar Dhantala','735132',1,0,'2022-03-03 12:47:09','2022-03-03 12:47:09'),(52967,149,'Uttar Saptibari','735224',1,0,'2022-03-03 12:47:09','2022-03-03 12:47:09'),(52968,149,'Vidyashram','735210',1,0,'2022-03-03 12:47:09','2022-03-03 12:47:09'),(52969,149,'Vivekananda Pally','735121',1,0,'2022-03-03 12:47:09','2022-03-03 12:47:09'),(52970,149,'West Congress Para','735101',1,0,'2022-03-03 12:47:09','2022-03-03 12:47:09'),(52971,150,'Alipore H.O','700027',1,0,'2022-03-03 12:47:09','2022-03-03 12:47:09'),(52972,150,'Barabazar H.O','700007',1,0,'2022-03-03 12:47:09','2022-03-03 12:47:09'),(52973,150,'A.J.C.Bose Road','700020',1,0,'2022-03-03 12:47:09','2022-03-03 12:47:09'),(52974,150,'Alipore Bodyguard Line','700027',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(52975,150,'Alipore Civil Court','700027',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(52976,150,'Alipore Dist Board','700027',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(52977,150,'Badartala','700044',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(52978,150,'Baghajatin','700086',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(52979,150,'Bakery Road','700022',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(52980,150,'Ballygunge RS','700019',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(52981,150,'Ballygunge','700019',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(52982,150,'Ballygunge Sc College','700019',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(52983,150,'Barisha','700008',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(52984,150,'Bartala','700018',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(52985,150,'Behala Municipal Market','700034',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(52986,150,'Behala','700034',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(52987,150,'Bhawanipore','700025',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(52988,150,'Bidhangarh','700066',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(52989,150,'Bijoygarh','700032',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(52990,150,'Bosepukur Road','700042',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(52991,150,'Brace Bridge','700088',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(52992,150,'Brahma Samaj Road','700034',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(52993,150,'Chetla','700027',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(52994,150,'Dhakuria','700031',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(52995,150,'Dover Lane','700029',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(52996,150,'E.K.T','700107',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(52997,150,'Ganguly Bagan','700047',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(52998,150,'Garcha Road','700019',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(52999,150,'Garden Reach','700024',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(53000,150,'Garfa','700075',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(53001,150,'Garia BT','700047',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(53002,150,'Gariahat Market','700019',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(53003,150,'Gokhel Road','700020',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(53004,150,'Golf Green','700095',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(53005,150,'Golpark','700019',1,0,'2022-03-03 12:47:10','2022-03-03 12:47:10'),(53006,150,'Haltu','700078',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53007,150,'Haridevpur','700082',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53008,150,'Hastings','700022',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53009,150,'Hyde Road','700088',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53010,150,'Indrani Park','700033',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53011,150,'Jadavgarh','700078',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53012,150,'Jadavpur University','700032',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53013,150,'Jairampur (Kolkata)','700061',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53014,150,'Jayshree Park','700034',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53015,150,'Jodhpur Park','700068',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53016,150,'K.C.Mills','700024',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53017,150,'K.M.Hospital','700020',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53018,150,'K.P.Bazar (Kolkata)','700082',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53019,150,'K.P.Roy Lane','700031',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53020,150,'Kalabagan','700053',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53021,150,'Kalagachia (Kolkata)','700063',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53022,150,'Kalighat','700026',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53023,150,'Kalikapur','700099',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53024,150,'Kalimandir','700026',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53025,150,'Kasba (Kolkata)','700042',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53026,150,'Kasthadanga','700061',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53027,150,'Keoratala','700026',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53028,150,'Khiddirpore','700023',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53029,150,'Kolkata Mint','700053',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53030,150,'L.R.Sarani','700020',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53031,150,'Lake Gardens','700045',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53032,150,'Lake Market','700029',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53033,150,'Lansdowne Market','700025',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53034,150,'Mahendra Banerjee Road','700060',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53035,150,'Mansatala','700023',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53036,150,'Mominpur','700027',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53037,150,'Mukundapur','700099',1,0,'2022-03-03 12:47:11','2022-03-03 12:47:11'),(53038,150,'N.R.Avenue','700053',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53039,150,'Naktala','700047',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53040,150,'Natioinal Library','700027',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53041,150,'Netaji Nagar (Kolkata)','700040',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53042,150,'New Alipore','700053',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53043,150,'P.G.Reach','700024',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53044,150,'Panchanantala','700034',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53045,150,'Panchasayar','700094',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53046,150,'Parnasree Pally','700060',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53047,150,'Paschim Barisha','700063',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53048,150,'Paschim Putiari','700041',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53049,150,'Pgh Shah Road','700032',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53050,150,'R.K.Seva Pratisthan','700026',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53051,150,'Rabindra Nagar (Kolkata)','700018',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53052,150,'Raipur Jorabagan Road','700047',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53053,150,'Raja J.N.Market','700023',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53054,150,'Rajabagan Dock Yard','700044',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53055,150,'Ramkrishna Park','700025',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53056,150,'Rash Behari Avenue','700029',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53057,150,'Regent Estate','700092',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53058,150,'Regent Park','700040',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53059,150,'Russa','700040',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53060,150,'S.R.F.T.I.','700094',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53061,150,'Sahanagar (Kolkata)','700026',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53062,150,'Sahapur','700038',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53063,150,'Santoshpur Avenue','700075',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53064,150,'Santoshpur','700075',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53065,150,'Sarat Bose Road','700029',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53066,150,'Sarsoona','700061',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53067,150,'Senhati','700034',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53068,150,'Sirity','700041',1,0,'2022-03-03 12:47:12','2022-03-03 12:47:12'),(53069,150,'Sonai (Kolkata)','700043',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53070,150,'South Eastern Railway','700043',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53071,150,'Southern Market','700026',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53072,150,'T.C.Road','700033',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53073,150,'T.G.Road','700024',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53074,150,'Taratala Road','700088',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53075,150,'Telecom Factory','700088',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53076,150,'Thakurpukur','700063',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53077,150,'Tollygunge H.O','700033',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53078,150,'Viveknagar (Kolkata)','700075',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53079,150,'Watgunge','700023',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53080,150,'Asylum Lane','700014',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53081,150,'Bowbazar (Kolkata)','700012',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53082,150,'Chittaranjan Avenue (Kolkata)','700073',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53083,150,'College Square (Kolkata)','700007',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53084,150,'Colootola','700073',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53085,150,'Council House Street','700001',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53086,150,'Customs House','700001',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53087,150,'Dharmatala','700013',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53088,150,'Elliot Road','700016',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53089,150,'Esplanade','700069',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53090,150,'Fort William','700021',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53091,150,'Hindustan Building','700072',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53092,150,'Income Tax Building','700069',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53093,150,'Khengrapatti','700001',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53094,150,'Kolkata University','700073',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53095,150,'Lalbazar (Kolkata)','700001',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53096,150,'Little Russel Street','700071',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53097,150,'Madrassa','700016',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53098,150,'Middleton Row','700071',1,0,'2022-03-03 12:47:13','2022-03-03 12:47:13'),(53099,150,'New Market','700087',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53100,150,'New Secretariat Bldg.','700001',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53101,150,'Park Street H.O','700016',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53102,150,'Pollock Street','700001',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53103,150,'Princep Street','700072',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53104,150,'R.N. Mukherjee Road','700001',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53105,150,'Radha Bazar','700001',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53106,150,'Reserve Bank Building','700001',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53107,150,'Russel Street','700071',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53108,150,'Shakespeare Sarani','700017',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53109,150,'Sooterkin Street','700072',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53110,150,'Strand Road','700007',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53111,150,'Telephone Bhawan','700001',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53112,150,'Tiretta Bazar','700073',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53113,150,'Treasury Building','700001',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53114,150,'W.B.Assembly House','700001',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53115,150,'W.B.Governors Camp.','700062',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53116,150,'Writer\'s Building','700001',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53117,150,'Yogayog Bhawan','700012',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53118,150,'Abinash Chaowdhury Lane','700046',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53119,150,'Bamboovila','700014',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53120,150,'Beleghata H.O','700010',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53121,150,'Bengal Chemical','700054',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53122,150,'Circus Avenue','700017',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53123,150,'Cmda Abasan','700054',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53124,150,'Gobinda Khatick Road','700046',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53125,150,'Intally','700014',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53126,150,'Jhowtala','700017',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53127,150,'Joramandir','700010',1,0,'2022-03-03 12:47:14','2022-03-03 12:47:14'),(53128,150,'K.G Bose Sarani','700085',1,0,'2022-03-03 12:47:15','2022-03-03 12:47:15'),(53129,150,'Kalindi Housing Estate','700089',1,0,'2022-03-03 12:47:15','2022-03-03 12:47:15'),(53130,150,'Kankurgachi','700054',1,0,'2022-03-03 12:47:15','2022-03-03 12:47:15'),(53131,150,'Linton Street','700014',1,0,'2022-03-03 12:47:15','2022-03-03 12:47:15'),(53132,150,'Narkeldanga','700011',1,0,'2022-03-03 12:47:15','2022-03-03 12:47:15'),(53133,150,'Park Circus','700017',1,0,'2022-03-03 12:47:15','2022-03-03 12:47:15'),(53134,150,'Parsibagan','700009',1,0,'2022-03-03 12:47:15','2022-03-03 12:47:15'),(53135,150,'Phulbagan','700054',1,0,'2022-03-03 12:47:15','2022-03-03 12:47:15'),(53136,150,'Raja Ram Mohan Sarani','700009',1,0,'2022-03-03 12:47:15','2022-03-03 12:47:15'),(53137,150,'Ram Krishna Samadhi Road','700054',1,0,'2022-03-03 12:47:15','2022-03-03 12:47:15'),(53138,150,'Sales Tax Building','700015',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53139,150,'Sankaritola','700012',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53140,150,'Seal Lane','700015',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53141,150,'Sealdah','700014',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53142,150,'Subhash Sarabor','700010',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53143,150,'Taltala','700014',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53144,150,'Tangra','700015',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53145,150,'Kolkatta G.P.O.','700001',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53146,150,'Ahritola','700005',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53147,150,'Alambazar','700035',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53148,150,'Amrita Bazar Partika','700003',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53149,150,'Archana','700007',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53150,150,'Ashokegarh','700108',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53151,150,'Baghbazar','700003',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53152,150,'Baranagar','700036',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53153,150,'Beadon Street','700006',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53154,150,'Bediapara','700077',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53155,150,'Belgachia Road','700037',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53156,150,'Belgachia','700037',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53157,150,'Bengal Immunity','700036',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53158,150,'Bidhan Sarani','700006',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53159,150,'Bonhooghly','700108',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53160,150,'Cossipore Gun Factory','700002',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53161,150,'Cossipore H.O','700002',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53162,150,'Deshbandhu Road','700035',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53163,150,'Dumdum Road','700074',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53164,150,'Dumdum','700028',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53165,150,'Durganagar','700065',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53166,150,'Ghugudanga','700030',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53167,150,'Girish Avenue','700003',1,0,'2022-03-03 12:47:16','2022-03-03 12:47:16'),(53168,150,'Hatkhola','700005',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53169,150,'Health Institute','700065',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53170,150,'Indian Research','700002',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53171,150,'ISI PO','700108',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53172,150,'Jawpore','700074',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53173,150,'Jessore Road','700080',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53174,150,'Jorasanko','700006',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53175,150,'Jugipara Satganchi','700028',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53176,150,'Kalakar Street','700007',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53177,150,'Kamalapur','700028',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53178,150,'Kendriya Vihar','700052',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53179,150,'Kolkata Airport  Po','700052',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53180,150,'Kolkata Airport','700052',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53181,150,'Kolkata Armed Police','700002',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53182,150,'Kumarpara','700028',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53183,150,'Kuthighat Road','700036',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53184,150,'Lily Biscuit','700067',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53185,150,'Mall Road','700080',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53186,150,'Manicktala','700006',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53187,150,'Motijheel','700074',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53188,150,'Nagerbazar','700028',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53189,150,'Netaji Colony','700090',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53190,150,'Noapara','700090',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53191,150,'Northern Avenue','700037',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53192,150,'Ordnance Factory','700028',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53193,150,'Paikapara','700002',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53194,150,'Pathuriaghata','700006',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53195,150,'Postal Stores Depot','700002',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53196,150,'Purba Sinthee','700030',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53197,150,'R.G.Kar Medical College','700004',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53198,150,'Rabindra Nagar','700065',1,0,'2022-03-03 12:47:17','2022-03-03 12:47:17'),(53199,150,'Rajabagan','700028',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53200,150,'Sahitya Parisad','700006',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53201,150,'Satchasipara','700002',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53202,150,'Sethbagan','700030',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53203,150,'Shyambazar Mail','700004',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53204,150,'Simla','700006',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53205,150,'Sinthee','700050',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53206,150,'South Sinhee','700050',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53207,150,'Subhas Nagar','700065',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53208,150,'Tala','700002',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53209,150,'Ultadanga Main Road','700067',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53210,150,'Ultadanga','700004',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53211,150,'Vaishya Sabha','700007',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53212,151,'Adina Station','732128',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53213,151,'Agra Harishchandrapur','732122',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53214,151,'Ahil','732138',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53215,151,'Ahora','732124',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53216,151,'Aiho','732121',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53217,151,'Akalpur','732124',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53218,151,'Akandabaria','732216',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53219,151,'Alal','732128',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53220,151,'Alinagar','732201',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53221,151,'Alipur','732201',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53222,151,'Amarsinghi','732139',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53223,151,'Amrity','732208',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53224,151,'Araidanga','732214',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53225,151,'Araji Jalsa','732138',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53226,151,'Arapur','732143',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53227,151,'Arbora','732123',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53228,151,'Arjunpur','732124',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53229,151,'Asrafpur','732138',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53230,151,'Atgama','732208',1,0,'2022-03-03 12:47:18','2022-03-03 12:47:18'),(53231,151,'Babupur','732124',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53232,151,'Bachamari','732142',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53233,151,'Badnagra','732124',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53234,151,'Baghua','732125',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53235,151,'Bagsarai','732124',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53236,151,'Bahadurpur','732201',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53237,151,'Baharal','732205',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53238,151,'Bahirkap','732205',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53239,151,'Bairachhi','732102',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53240,151,'Baishnabnagar','732210',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53241,151,'Bakdukra Anantalalpur','732203',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53242,151,'Bakharpur','732206',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53243,151,'Baldiapukur','732139',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53244,151,'Balia Nawabganj','732128',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53245,151,'Baliadanga','732201',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53246,151,'Baluachara','732206',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53247,151,'Baluchar','732101',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53248,151,'Balupur','732205',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53249,151,'Bamangola','732147',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53250,151,'Bamangram','732206',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53251,151,'Bangitola','732207',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53252,151,'Bangrua','732140',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53253,151,'Banikantatala','732205',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53254,151,'Bansbari','732101',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53255,151,'Bansdol Daulatpur','732125',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53256,151,'Barduary','732125',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53257,151,'Barkol','732128',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53258,151,'Batna','732139',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53259,151,'Bedrabad','732210',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53260,151,'Bhabanipur','732209',1,0,'2022-03-03 12:47:19','2022-03-03 12:47:19'),(53261,151,'Bhado','732139',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53262,151,'Bhaluka Bazar','732125',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53263,151,'Bhatolchandipur','732140',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53264,151,'Bheba','732126',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53265,151,'Bhgabanpur','732210',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53266,151,'Bhingole','732123',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53267,151,'Bholaichak','732201',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53268,151,'Bhutni','732203',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53269,151,'Bilaimari','732205',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53270,151,'Binodpur','732138',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53271,151,'Birampur','732207',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53272,151,'Birosthali','732123',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53273,151,'Bishanpur','732140',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53274,151,'Boroi','732140',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53275,151,'Brahmangram','732204',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53276,151,'Budhia','732128',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53277,151,'Bulbulchadi','732122',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53278,151,'Chakbahadurpur','732210',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53279,151,'Chamagram','732127',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53280,151,'Chanchal','732123',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53281,151,'Chandipur','732140',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53282,151,'Chandmoni','732139',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53283,151,'Chandrapara','732126',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53284,151,'Char Sujapur Mandai','732210',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53285,151,'Charbabupur','732127',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53286,151,'Charianantapur','732201',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53287,151,'Chaspara','732206',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53288,151,'Chhoto Sujapur','732206',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53289,151,'Chorolmoni','732139',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53290,151,'Chowki Mirdadpur','732202',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53291,151,'Dahua','732125',1,0,'2022-03-03 12:47:20','2022-03-03 12:47:20'),(53292,151,'Dakshin Alinagar','732102',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53293,151,'Dakshin Lakshmipur','732201',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53294,151,'Dalla Madhyapara','732138',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53295,151,'Dallugram','732201',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53296,151,'Dallutola','732202',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53297,151,'Damaipur','732139',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53298,151,'Damodartola','732207',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53299,151,'Daulatnagar','732125',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53300,151,'Debiganj','732123',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53301,151,'Debipur Achintala','732207',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53302,151,'Debipur','732205',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53303,151,'Deotala','732124',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53304,151,'Dhangara','732125',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53305,151,'Dhaoel','732124',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53306,151,'Dharampur','732202',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53307,151,'Dharmadanga','732138',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53308,151,'Dhumadighi','732128',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53309,151,'Dighalbar','732138',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53310,151,'District School Board (Malda)','732101',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53311,151,'Dohil','732138',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53312,151,'Duisatabighi','732201',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53313,151,'Ekborna','732204',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53314,151,'Enayetpur','732202',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53315,151,'Fatehkhani','732206',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53316,151,'Fatehpur','732125',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53317,151,'Fulbari (Malda)','732101',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53318,151,'Gajol','732124',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53319,151,'Galimpur','732126',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53320,151,'Gandhinagar','732121',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53321,151,'Gangadevi','732139',1,0,'2022-03-03 12:47:21','2022-03-03 12:47:21'),(53322,151,'Gangaprasad','732207',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53323,151,'Gayeshbari','732206',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53324,151,'Goalpara','732126',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53325,151,'Golapganj','732201',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53326,151,'Gopalpur','732209',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53327,151,'Gopalpurhat','732122',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53328,151,'Goraksha','732204',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53329,151,'Gour','732103',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53330,151,'Gouramari','732121',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53331,151,'Gurutola','732127',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53332,151,'Habibpur','732122',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53333,151,'Hamidpur','732207',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53334,151,'Hardamnagar','732125',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53335,151,'Haripur','732102',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53336,151,'Harishchandrapur Bazar','732125',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53337,151,'Harishchandrapur','732125',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53338,151,'Harkharkha','732128',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53339,151,'Haruchak','732201',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53340,151,'Hatimari','732124',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53341,151,'Hatinda','732123',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53342,151,'Hazarat Jalalpur','732123',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53343,151,'Ichahar','732124',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53344,151,'Ishadpur','732123',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53345,151,'Ismailpur','732123',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53346,151,'Jabra','732140',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53347,151,'Jadupur','732212',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53348,151,'Jagannathpur','732125',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53349,151,'Jagannathpur Maltola','732123',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53350,151,'Jagannathpur Rathbari','732207',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53351,151,'Jagdala','732138',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53352,151,'Jagjibanpur','732122',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53353,151,'Jalalpur','732206',1,0,'2022-03-03 12:47:22','2022-03-03 12:47:22'),(53354,151,'Jaluabadhal Mallikpara','732216',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53355,151,'Jamirghata Sarkarpara','732206',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53356,151,'Janakiramtola','732202',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53357,151,'Jatradanga','732141',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53358,151,'Jhaljhalia Railway Colony','732102',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53359,151,'Jharpukhuria','732128',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53360,151,'Jitarpur','732139',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53361,151,'Jitnagar','732207',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53362,151,'Jote Basanta','732128',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53363,151,'Jotgopal Kagmari','732207',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53364,151,'Jotparam','732201',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53365,151,'Joyenpur','732201',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53366,151,'Jugaltola','732207',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53367,151,'K.B Jhowbona','732209',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53368,151,'Kadamtala','732216',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53369,151,'Kadamtali','732102',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53370,151,'Kahala','732205',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53371,151,'Kajigram Chandipur','732103',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53372,151,'Kaliachak','732201',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53373,151,'Kaligaon','732126',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53374,151,'Kamalabari','732103',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53375,151,'Kamaldanga','732138',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53376,151,'Kamalpur','732205',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53377,151,'Kanchantar','732103',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53378,151,'Kandaran','732139',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53379,151,'Kanturka','732122',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53380,151,'Karbona','732139',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53381,151,'Kariali','732125',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53382,151,'Kashimpur','732139',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53383,151,'Katikandar','732124',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53384,151,'Katlamari','732102',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53385,151,'Katna','732124',1,0,'2022-03-03 12:47:23','2022-03-03 12:47:23'),(53386,151,'Kendpukur','732122',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53387,151,'Khairtola','732203',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53388,151,'Khanta','732124',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53389,151,'Kharba','732150',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53390,151,'Khaschandpur','732201',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53391,151,'Khaskol Chandipur','732207',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53392,151,'Khejuriaghat','732127',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53393,151,'Khoilsona','732204',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53394,151,'Khopakati','732125',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53395,151,'Khoribari','732122',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53396,151,'Khutadaha','732138',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53397,151,'Koilabad','732102',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53398,151,'Koklamari','732208',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53399,151,'Kotalpur','732122',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53400,151,'Kotwali (Malda)','732144',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53401,151,'Krishnapur','732210',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53402,151,'Kumarga R.S.','732102',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53403,151,'Kushida','732140',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53404,151,'Kushmai','732126',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53405,151,'Kutubganj','732102',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53406,151,'Kutubsahar','732102',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53407,151,'Lakshmipur','732124',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53408,151,'Lakshmipur','732210',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53409,151,'Lalbathani','732203',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53410,151,'Laskarpur','732205',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53411,151,'Madapur','732208',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53412,151,'Madhaipur','732142',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53413,151,'Madhugaht Filature Estate','732206',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53414,151,'Magurai','732128',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53415,151,'Mahadevpur','732121',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53416,151,'Mahadipur','732216',1,0,'2022-03-03 12:47:24','2022-03-03 12:47:24'),(53417,151,'Mahakalbona','732102',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53418,151,'Mahanandatola','732125',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53419,151,'Maharajpur','732102',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53420,151,'Mahendrapur','732125',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53421,151,'Malatipur','732123',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53422,151,'Malda Court','732101',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53423,151,'Malda H.O','732101',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53424,151,'Maliha','732102',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53425,151,'Malikan','732123',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53426,151,'Malior','732125',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53427,151,'Malipara','732124',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53428,151,'Mallikpara','732123',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53429,151,'Mangalbari','732142',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53430,151,'Manikchak','732202',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53431,151,'Maniknagar','732125',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53432,151,'Manikora','732122',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53433,151,'Masheshpur','732138',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53434,151,'Mathurapur (Malda)','732203',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53435,151,'Mayna','732124',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53436,151,'Meherapur','732207',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53437,151,'Miahat','732125',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53438,151,'Milangarh','732125',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53439,151,'Milki','732211',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53440,151,'Mirchak','732101',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53441,151,'Mirjatpur','732204',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53442,151,'Mohana','732202',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53443,151,'Molladighi','732124',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53444,151,'Mosimpur','732206',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53445,151,'Mothabari','732207',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53446,151,'Motiharpur','732126',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53447,151,'Mudapur','732124',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53448,151,'Mukdumpur','732103',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53449,151,'Mulaibari','732126',1,0,'2022-03-03 12:47:25','2022-03-03 12:47:25'),(53450,151,'Nabinagar','732201',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53451,151,'Nageswarpur','732142',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53452,151,'Nagharia','732208',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53453,151,'Naikanda','732126',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53454,151,'Nakail','732122',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53455,151,'Nandalalpur','732210',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53456,151,'Narayanpur (Malda)','732141',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53457,151,'Nawada','732216',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53458,151,'Nayagram','732201',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53459,151,'Nazirpur','732203',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53460,151,'Netaji Subhas Road','732101',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53461,151,'New Sadlichak','732125',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53462,151,'Niamatpur','732208',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53463,151,'Noaborar Jaigir','732203',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53464,151,'Noorganj','732126',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53465,151,'Nurpur','732203',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53466,151,'Old Malda','732128',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53467,151,'Pakuahat','732138',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53468,151,'Palgachhi','732127',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53469,151,'Panchanandapur','732207',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53470,151,'Panchpara','732124',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53471,151,'Pannapur','732138',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53472,151,'Parail','732124',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53473,151,'Paraninagar','732123',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53474,151,'Paranpur','732204',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53475,151,'Parbatidanga','732138',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53476,151,'Paro','732140',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53477,151,'Patul','732138',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53478,151,'Phulbaria','732208',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53479,151,'Pipla','732125',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53480,151,'Pirganj','732102',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53481,151,'Pirpur','732209',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53482,151,'Popra','732141',1,0,'2022-03-03 12:47:26','2022-03-03 12:47:26'),(53483,151,'Pubarun','732215',1,0,'2022-03-03 12:47:27','2022-03-03 12:47:27'),(53484,151,'Pukhuria','732213',1,0,'2022-03-03 12:47:27','2022-03-03 12:47:27'),(53485,151,'Purba Bahadurpur','732201',1,0,'2022-03-03 12:47:27','2022-03-03 12:47:27'),(53486,151,'Purba Ranipur','732138',1,0,'2022-03-03 12:47:27','2022-03-03 12:47:27'),(53487,151,'Purbasaidpur','732202',1,0,'2022-03-03 12:47:27','2022-03-03 12:47:27'),(53488,151,'Rabindra Avenue','732101',1,0,'2022-03-03 12:47:27','2022-03-03 12:47:27'),(53489,151,'Rahimpur','732202',1,0,'2022-03-03 12:47:27','2022-03-03 12:47:27'),(53490,151,'Rahutara','732138',1,0,'2022-03-03 12:47:27','2022-03-03 12:47:27'),(53491,151,'Rajadighi','732102',1,0,'2022-03-03 12:47:27','2022-03-03 12:47:27'),(53492,151,'Rajapur','732102',1,0,'2022-03-03 12:47:27','2022-03-03 12:47:27'),(53493,151,'Rajbati Ramnagar','732103',1,0,'2022-03-03 12:47:27','2022-03-03 12:47:27'),(53494,151,'Rajnagar','732201',1,0,'2022-03-03 12:47:27','2022-03-03 12:47:27'),(53495,151,'Ramnagar','732201',1,0,'2022-03-03 12:47:27','2022-03-03 12:47:27'),(53496,151,'Ramsimul','732140',1,0,'2022-03-03 12:47:27','2022-03-03 12:47:27'),(53497,151,'Raninagar','732102',1,0,'2022-03-03 12:47:27','2022-03-03 12:47:27'),(53498,151,'Rasulpur','732123',1,0,'2022-03-03 12:47:27','2022-03-03 12:47:27'),(53499,151,'Rathbari','732101',1,0,'2022-03-03 12:47:27','2022-03-03 12:47:27'),(53500,151,'Ratua','732205',1,0,'2022-03-03 12:47:28','2022-03-03 12:47:28'),(53501,151,'Sabdalpur','732201',1,0,'2022-03-03 12:47:28','2022-03-03 12:47:28'),(53502,151,'Sadarpur','732123',1,0,'2022-03-03 12:47:28','2022-03-03 12:47:28'),(53503,151,'Sahabattola','732209',1,0,'2022-03-03 12:47:28','2022-03-03 12:47:28'),(53504,151,'Sahabazpur','732201',1,0,'2022-03-03 12:47:28','2022-03-03 12:47:28'),(53505,151,'Sahapur','732142',1,0,'2022-03-03 12:47:28','2022-03-03 12:47:28'),(53506,151,'Salaidanga','732124',1,0,'2022-03-03 12:47:28','2022-03-03 12:47:28'),(53507,151,'Sambalpur','732125',1,0,'2022-03-03 12:47:28','2022-03-03 12:47:28'),(53508,151,'Sambalpur Tal','732102',1,0,'2022-03-03 12:47:28','2022-03-03 12:47:28'),(53509,151,'Samsi','732139',1,0,'2022-03-03 12:47:28','2022-03-03 12:47:28'),(53510,151,'Santoshpur','732126',1,0,'2022-03-03 12:47:28','2022-03-03 12:47:28'),(53511,151,'Sapmari','732138',1,0,'2022-03-03 12:47:28','2022-03-03 12:47:28'),(53512,151,'Sarbamangalapally','732101',1,0,'2022-03-03 12:47:28','2022-03-03 12:47:28'),(53513,151,'Sattari','732208',1,0,'2022-03-03 12:47:28','2022-03-03 12:47:28'),(53514,151,'Serpur Mukdumpur','732123',1,0,'2022-03-03 12:47:28','2022-03-03 12:47:28'),(53515,151,'Shashani','732201',1,0,'2022-03-03 12:47:28','2022-03-03 12:47:28'),(53516,151,'Sherpur','732206',1,0,'2022-03-03 12:47:28','2022-03-03 12:47:28'),(53517,151,'Shersahi','732201',1,0,'2022-03-03 12:47:28','2022-03-03 12:47:28'),(53518,151,'Shivajinagar','732124',1,0,'2022-03-03 12:47:28','2022-03-03 12:47:28'),(53519,151,'Singabad','732122',1,0,'2022-03-03 12:47:28','2022-03-03 12:47:28'),(53520,151,'Singhia','732123',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53521,151,'Sirshi','732121',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53522,151,'Sonarai','732139',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53523,151,'South Kadamtala','732216',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53524,151,'Sovanagar','732209',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53525,151,'Sripur','732139',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53526,151,'Sripur Colony','732207',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53527,151,'Srirampur','732216',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53528,151,'Sujapur','732206',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53529,151,'Sukdevpur','732201',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53530,151,'Sukdevtola','732203',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53531,151,'Suksena','732203',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53532,151,'Sultanganj','732201',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53533,151,'Sultannagar','732125',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53534,151,'Taherpur','732124',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53535,151,'Talbangrua','732125',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53536,151,'Talgachhi','732125',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53537,151,'Talgramhat','732125',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53538,151,'Talsur','732125',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53539,151,'Tulsihatta','732140',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53540,151,'Umakantatola','732216',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53541,151,'Uttar Chandipur','732203',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53542,151,'Uttar Dariapur','732201',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53543,151,'Uttar Lakshmipur','732207',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53544,151,'Uttar Mahadipur','732216',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53545,151,'Chaksukdebpur','733142',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53546,151,'Dobakhokshan','733124',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53547,151,'Kupadaha','733142',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53548,151,'Madnabati','733124',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53549,151,'Nalagola','733124',1,0,'2022-03-03 12:47:29','2022-03-03 12:47:29'),(53550,152,'Dharma (West Midnapore)','721101',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53551,153,'Adibasi Beldanga','742122',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53552,153,'Adikantanagar','742227',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53553,153,'Aheripara','742226',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53554,153,'Ahiran','742223',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53555,153,'Ajgarpara','742223',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53556,153,'Akheriganj','742135',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53557,153,'Alampur','742223',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53558,153,'Alamsahi','742224',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53559,153,'Alugram','742301',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53560,153,'Amaipara','742123',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53561,153,'Amdahara','742123',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53562,153,'Aminabad','742406',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53563,153,'Amlai','742301',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53564,153,'Amritakunda','742136',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53565,153,'Amtala (Mobile)','742202',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53566,153,'Amtala','742121',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53567,153,'Anantapur','742202',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53568,153,'Andi','742168',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53569,153,'Andulberia','742189',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53570,153,'Andulberia Colony','742189',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53571,153,'Andulia','742138',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53572,153,'Arjunpur (MurshidabB.O','742202',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53573,153,'Ashariadaha','742148',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53574,153,'Atai','742159',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53575,153,'Aurangabad (Murshidabad)','742201',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53576,153,'Ayra','742147',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53577,153,'Azimganj','742122',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53578,153,'B.Durlavpur','742302',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53579,153,'B.Sahazadpur','742187',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53580,153,'B.Sherpur','742301',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53581,153,'Babultali','742308',1,0,'2022-03-03 12:47:30','2022-03-03 12:47:30'),(53582,153,'Bachra','742163',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53583,153,'Badua','742147',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53584,153,'Bagdabra','742212',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53585,153,'Bagdanga','742138',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53586,153,'Bagore','742136',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53587,153,'Bahadurpur','742135',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53588,153,'Bahadurpur Roypur','742223',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53589,153,'Bahagalpur','742202',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53590,153,'Bahara','742138',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53591,153,'Bajupur Madhupur','742148',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53592,153,'Balarampore Colony','742165',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53593,153,'Balia','742237',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53594,153,'Baligokulpur','742302',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53595,153,'Bamnabad','742306',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53596,153,'Banjetia','742102',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53597,153,'Bansgara','742148',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53598,153,'Barala','742235',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53599,153,'Barasimul','742213',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53600,153,'Barjumla','742148',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53601,153,'Barua','742189',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53602,153,'Baruipara (Murshidabad)','742165',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53603,153,'Barwan (Murshidabad)','742132',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53604,153,'Basantpur (Murshidabad)','742406',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53605,153,'Basudebkhali','742187',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53606,153,'Bazarshaw','742163',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53607,153,'Begunbari','742133',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53608,153,'Beharia','742175',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53609,153,'Beldanga','742133',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53610,153,'Belgram','742168',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53611,153,'Beniagram','742212',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53612,153,'Benipur','742140',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53613,153,'Berhampore (WB) H.O','742101',1,0,'2022-03-03 12:47:31','2022-03-03 12:47:31'),(53614,153,'Berhampore Civil Court','742101',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53615,153,'Berhampore Station Road','742101',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53616,153,'Bewa','742212',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53617,153,'Bezpara Saluadanga','742134',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53618,153,'Bhabanipur','742202',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53619,153,'Bhabta','742134',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53620,153,'Bhadur','742134',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53621,153,'Bhagabangola','742135',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53622,153,'Bhagabangola Sundarpur','742135',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53623,153,'Bhagirathpur','742406',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53624,153,'Bhairabpur','742302',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53625,153,'Bhalanagar','742121',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53626,153,'Bhalkundi','742159',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53627,153,'Bhandara','742123',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53628,153,'Bharatpur (Murshidabad)','742301',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53629,153,'Bhasai Paikar','742202',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53630,153,'Bhattabati','742149',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53631,153,'Bhola','742226',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53632,153,'Bikalnagar','742189',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53633,153,'Bilaspur','742303',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53634,153,'Bilbora Kopra','742148',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53635,153,'Bilcolony','742184',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53636,153,'Binodia','742301',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53637,153,'Bipra Sekhar','742168',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53638,153,'Bishannagar','742133',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53639,153,'Bishnupur Kalibari','742102',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53640,153,'Boaliadanga','742102',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53641,153,'Boincuitala','742302',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53642,153,'Bokhara','742226',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53643,153,'Borderpara','742308',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53644,153,'Boyar','742226',1,0,'2022-03-03 12:47:32','2022-03-03 12:47:32'),(53645,153,'Brahmanpara','742138',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53646,153,'Brindabanpur','742406',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53647,153,'Bundainagar','742175',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53648,153,'Chabghati','742201',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53649,153,'Chachanda','742224',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53650,153,'Chaitanyapur','742134',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53651,153,'Chaitpur','742161',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53652,153,'Chakshyapur','742202',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53653,153,'Chaltia','742407',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53654,153,'Chanak','742184',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53655,153,'Chandni Chak Hat','742223',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53656,153,'Chandpur','742121',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53657,153,'Char Rajapur','742306',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53658,153,'Charmahula','742405',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53659,153,'Charmunsipara','742306',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53660,153,'Chatai','742302',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53661,153,'Chatra','742302',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53662,153,'Chhaighari','742302',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53663,153,'Chhatina Kandi','742138',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53664,153,'Choa','742166',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53665,153,'Choapara','742305',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53666,153,'Choatore','742140',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53667,153,'Chotkalia','742213',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53668,153,'Chotobathan','742104',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53669,153,'Chourigacha','742405',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53670,153,'Chunakhali Nimtala','742102',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53671,153,'Cossimbazar Raj','742102',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53672,153,'D.L.S.S.J.dham','742104',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53673,153,'D.Pareshpur','742305',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53674,153,'Dadpur','742189',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53675,153,'Dafahat','742224',1,0,'2022-03-03 12:47:33','2022-03-03 12:47:33'),(53676,153,'Dafarpur','742227',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53677,153,'Daharpar','742201',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53678,153,'Daihatta Road','742103',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53679,153,'Dakatiapota','742174',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53680,153,'Dakshingram-sabitri','742235',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53681,153,'Dalelpara','742113',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53682,153,'Dalua','742133',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53683,153,'Dangapara','742302',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53684,153,'Dasturhat','742122',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53685,153,'Daulatabad (Murshidabad)','742302',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53686,153,'Dayarampur','742213',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53687,153,'Debaipur','742135',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53688,153,'Debipur','742306',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53689,153,'Debipur','742134',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53690,153,'Debipur','742113',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53691,153,'Debkunda','742133',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53692,153,'Dechapra','742401',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53693,153,'Deonapur','742202',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53694,153,'Dhanpatganj','742226',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53695,153,'Dhulari','742308',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53696,153,'Dhuliyan','742202',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53697,153,'Diar Fatepur','742135',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53698,153,'Diar Raninagar','742227',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53699,153,'Diar Shyampur','742135',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53700,153,'Diara','742122',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53701,153,'District School Board (Murshidabad)','742101',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53702,153,'Dogachi','742202',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53703,153,'Dohali Dangapara','742226',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53704,153,'Dudsar','742174',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53705,153,'Dumkal','742303',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53706,153,'Dupukuria','742163',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53707,153,'Durgapur','742187',1,0,'2022-03-03 12:47:34','2022-03-03 12:47:34'),(53708,153,'Dutta Barutia','742401',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53709,153,'Ekghoria Khanqua','742132',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53710,153,'Ekpaharia Sayedpur','742132',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53711,153,'Eroali','742147',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53712,153,'Etore','742104',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53713,153,'Farakka','742212',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53714,153,'Farakka Barrage','742212',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53715,153,'Farakka Project','742212',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53716,153,'Faridpur','742303',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53717,153,'Fatepur','742132',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53718,153,'Fatullapur','742223',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53719,153,'Fulpur','742135',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53720,153,'Fultala','742225',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53721,153,'Gangadaspara','742303',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53722,153,'Gangadhari','742121',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53723,153,'Gangaprasad','742213',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53724,153,'Gangedda','742140',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53725,153,'Gangin','742223',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53726,153,'Gankar','742227',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53727,153,'Ganthla','742136',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53728,153,'Garaimari','742303',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53729,153,'Garibpur','742121',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53730,153,'Garorah','742184',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53731,153,'Gayespur','742147',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53732,153,'Gazdharpara','742102',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53733,153,'Gaznipur','742166',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53734,153,'Ghoramara','742133',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53735,153,'Ghorshala','742235',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53736,153,'Ghorshala','742122',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53737,153,'Ghugridanga','742122',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53738,153,'Gidgram','742401',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53739,153,'Giria','742213',1,0,'2022-03-03 12:47:35','2022-03-03 12:47:35'),(53740,153,'Goaljan','742187',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53741,153,'Goas','742304',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53742,153,'Gobardhandanga','742122',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53743,153,'Gobindapur','742405',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53744,153,'Gobor Hati','742136',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53745,153,'Godagari','742305',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53746,153,'Godapara','742161',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53747,153,'Godda Sighari','742161',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53748,153,'Godhanpara','742304',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53749,153,'Gofurpur','742213',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53750,153,'Goghata','742121',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53751,153,'Gokarna','742136',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53752,153,'Gokul Gobindapur','742304',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53753,153,'Gopinathpur','742149',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53754,153,'Gopinathpur','742134',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53755,153,'Gopinathpur Madhyapara','742304',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53756,153,'Gorabazar','742101',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53757,153,'Gramshalika','742132',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53758,153,'Gudhia','742302',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53759,153,'Gulhatia','742401',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53760,153,'Gunanandabati','742140',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53761,153,'Gurah','742184',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53762,153,'Gurulia','742147',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53763,153,'Habaspur','742135',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53764,153,'Hanumanta Nagar','742135',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53765,153,'Hareknagar','742133',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53766,153,'Harekrishnapur','742305',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53767,153,'Harhari','742226',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53768,153,'Harharia Chak','742304',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53769,153,'Haribhanga','742302',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53770,153,'Hariharpara','742166',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53771,153,'Haripur','742147',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53772,153,'Harishchandrapur','742161',1,0,'2022-03-03 12:47:36','2022-03-03 12:47:36'),(53773,153,'Harudanga','742308',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53774,153,'Hasanpur','742302',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53775,153,'Hasanpur','742201',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53776,153,'Hastinapur','742161',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53777,153,'Hatinagar','742102',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53778,153,'Hazarpur Nabagram','742136',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53779,153,'Huda Herampur','742304',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53780,153,'Indrani','742159',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53781,153,'Indraprastha','742103',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53782,153,'Islampore','742304',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53783,153,'Jadupur','742405',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53784,153,'Jafrabad','742149',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53785,153,'Jafraganj','742202',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53786,153,'Jagaipur','742121',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53787,153,'Jagannathpur','742165',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53788,153,'Jagtai','742224',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53789,153,'Jahankosha','742149',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53790,153,'Jajan','742140',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53791,153,'Jajriachar Dumuria','742135',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53792,153,'Jalalpur','742189',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53793,153,'Jalangi','742305',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53794,153,'Jangipur Barrage','742223',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53795,153,'Jangipur','742213',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53796,153,'Jarur','742235',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53797,153,'Jasohari','742147',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53798,153,'Jawhari','742161',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53799,153,'Jemo','742138',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53800,153,'Jemo Rajbati','742140',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53801,153,'Jhikarhati','742168',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53802,153,'Jhikra','742174',1,0,'2022-03-03 12:47:37','2022-03-03 12:47:37'),(53803,153,'Jhunka','742134',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53804,153,'Jiaganj','742123',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53805,153,'Jibanpur','742135',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53806,153,'Jibanti','742136',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53807,153,'Jinnatpara','742308',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53808,153,'Jitpur','742121',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53809,153,'Joykrishnapur','742305',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53810,153,'Joykrishnapur Gangarampur','742187',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53811,153,'Joynagar','742189',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53812,153,'Joypur','742159',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53813,153,'Juginda','742406',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53814,153,'Jugsara','742132',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53815,153,'Juranpur','742406',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53816,153,'Kabilpur','742237',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53817,153,'Kadamtala','742224',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53818,153,'Kadkhali','742163',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53819,153,'Kagram','742401',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53820,153,'Kalabagh','742213',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53821,153,'Kaladanga','742304',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53822,153,'Kaliganj','742305',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53823,153,'Kalitala','742133',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53824,153,'Kalitaladiar','742165',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53825,153,'Kalukhali','742135',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53826,153,'Kamnagar','742405',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53827,153,'Kanainagar','742121',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53828,153,'Kandi Balia','742138',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53829,153,'Kandi Bazar','742137',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53830,153,'Kandi Bus Stand','742137',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53831,153,'Kandi Court','742137',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53832,153,'Kandi H.O','742137',1,0,'2022-03-03 12:47:38','2022-03-03 12:47:38'),(53833,153,'Kanfala','742184',1,0,'2022-03-03 12:47:39','2022-03-03 12:47:39'),(53834,153,'Kangali Mondalpara','742308',1,0,'2022-03-03 12:47:39','2022-03-03 12:47:39'),(53835,153,'Kankuria','742202',1,0,'2022-03-03 12:47:39','2022-03-03 12:47:39'),(53836,153,'Kansari Bazar','742101',1,0,'2022-03-03 12:47:39','2022-03-03 12:47:39'),(53837,153,'Kantanagar','742135',1,0,'2022-03-03 12:47:39','2022-03-03 12:47:39'),(53838,153,'Kanthalia','742405',1,0,'2022-03-03 12:47:39','2022-03-03 12:47:39'),(53839,153,'Kantur','742132',1,0,'2022-03-03 12:47:39','2022-03-03 12:47:39'),(53840,153,'Kanupur','742223',1,0,'2022-03-03 12:47:39','2022-03-03 12:47:39'),(53841,153,'Kapasdanga','742133',1,0,'2022-03-03 12:47:39','2022-03-03 12:47:39'),(53842,153,'Karaya','742237',1,0,'2022-03-03 12:47:39','2022-03-03 12:47:39'),(53843,153,'Karna Subarna','742405',1,0,'2022-03-03 12:47:39','2022-03-03 12:47:39'),(53844,153,'Kashiadanga','742213',1,0,'2022-03-03 12:47:39','2022-03-03 12:47:39'),(53845,153,'Kashidanga Mohammadpur','742159',1,0,'2022-03-03 12:47:39','2022-03-03 12:47:39'),(53846,153,'Kashimnagar','742224',1,0,'2022-03-03 12:47:39','2022-03-03 12:47:39'),(53847,153,'Kashipur (Murshidabad) ','742189',1,0,'2022-03-03 12:47:39','2022-03-03 12:47:39'),(53848,153,'Katlamari','742308',1,0,'2022-03-03 12:47:39','2022-03-03 12:47:39'),(53849,153,'Kazipara','742306',1,0,'2022-03-03 12:47:39','2022-03-03 12:47:39'),(53850,153,'Kazisaha','742133',1,0,'2022-03-03 12:47:39','2022-03-03 12:47:39'),(53851,153,'Kedarchandpur','742133',1,0,'2022-03-03 12:47:39','2022-03-03 12:47:39'),(53852,153,'Khagra','742103',1,0,'2022-03-03 12:47:39','2022-03-03 12:47:39'),(53853,153,'Khairamari','742303',1,0,'2022-03-03 12:47:39','2022-03-03 12:47:39'),(53854,153,'Khamer Diar','742135',1,0,'2022-03-03 12:47:39','2022-03-03 12:47:39'),(53855,153,'Khamra','742213',1,0,'2022-03-03 12:47:39','2022-03-03 12:47:39'),(53856,153,'Khandua','742148',1,0,'2022-03-03 12:47:39','2022-03-03 12:47:39'),(53857,153,'Kharati','742226',1,0,'2022-03-03 12:47:39','2022-03-03 12:47:39'),(53858,153,'Kharera','742401',1,0,'2022-03-03 12:47:39','2022-03-03 12:47:39'),(53859,153,'Khargram Hospital','742147',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53860,153,'Khargram','742147',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53861,153,'Kharjuna','742168',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53862,153,'Khatua','742122',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53863,153,'Kherur','742237',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53864,153,'Khidirpur','742134',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53865,153,'Khodarampur','742213',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53866,153,'Khosbaspur','742136',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53867,153,'Khoshbagh','742149',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53868,153,'Khoyra','742301',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53869,153,'Kiriteswari','742104',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53870,153,'Kirtipur','742147',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53871,153,'Kodla','742405',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53872,153,'Kolan Radhakantapur','742123',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53873,153,'Kolla','742140',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53874,153,'Koregram','742404',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53875,153,'Krishnapur Dinupara','742148',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53876,153,'Krishnapur (MurshidabB.O','742148',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53877,153,'Kuchiamora','742303',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53878,153,'Kulgachi','742213',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53879,153,'Kuli','742202',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53880,153,'Kuli Kandi','742168',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53881,153,'Kumar Shanda','742136',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53882,153,'Kumarpur','742189',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53883,153,'Kundal','742168',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53884,153,'Kunia','742168',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53885,153,'Kunjaghata','742103',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53886,153,'Kupila','742303',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53887,153,'Kurmitola','742149',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53888,153,'Kurnnarun','742161',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53889,153,'Kurulia','742132',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53890,153,'Kushberia','742406',1,0,'2022-03-03 12:47:40','2022-03-03 12:47:40'),(53891,153,'Labanchoa','742223',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53892,153,'Lakshminathpur','742303',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53893,153,'Lalbagh (Murshidabad)','742149',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53894,153,'Laldighi','742101',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53895,153,'Lalgola','742148',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53896,153,'Lalkhandiar','742213',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53897,153,'Lalpur','742202',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53898,153,'Laskarpur','742151',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53899,153,'Lochanmati Dangapara','742166',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53900,153,'Lochanpur','742304',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53901,153,'Lohadaha','742163',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53902,153,'Loharpur','742224',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53903,153,'Lokenathpur','742189',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53904,153,'Mackenzi Park','742225',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53905,153,'Madanpur','742304',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53906,153,'Madda','742133',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53907,153,'Madhupur','742121',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53908,153,'Madhupur Colony','742101',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53909,153,'Madhurkul','742406',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53910,153,'Mahadebbati','742161',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53911,153,'Mahadebnagar','742202',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53912,153,'Mahadia','742138',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53913,153,'Mahalandi','742136',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53914,153,'Mahisar','742147',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53915,153,'Mahisasthali','742135',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53916,153,'Mahishgram','742168',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53917,153,'Mahishmara','742133',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53918,153,'Mahula','742134',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53919,153,'Mahura Kandi','742132',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53920,153,'Mahurul Anantapur','742136',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53921,153,'Majhyampur','742189',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53922,153,'Makhaltore','742401',1,0,'2022-03-03 12:47:41','2022-03-03 12:47:41'),(53923,153,'Malancha','742202',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53924,153,'Maliandi','742161',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53925,153,'Malibari','742304',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53926,153,'Malihati','742401',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53927,153,'Mandra','742161',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53928,153,'Manigram','742237',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53929,153,'Manikahar','742163',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53930,153,'Manikchak','742148',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53931,153,'Maniknagar','742133',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53932,153,'Margram','742147',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53933,153,'Maricha','742304',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53934,153,'Marut','742161',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53935,153,'Masla','742301',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53936,153,'Masundi','742301',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53937,153,'Maya','742148',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53938,153,'Megha Siara','742226',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53939,153,'Mianpur','742235',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53940,153,'Milki','742163',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53941,153,'Mirzapur (MurshidabB.O','742133',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53942,153,'Mithipur','742213',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53943,153,'Miyan','742404',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53944,153,'Mohammadpur','742121',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53945,153,'Mohanganj','742308',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53946,153,'Mohasail','742201',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53947,153,'Moktarpur','742302',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53948,153,'Mominpur','742303',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53949,153,'Momrejpur','742202',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53950,153,'Moregram','742226',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53951,153,'Moshimpur','742163',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53952,153,'Mridadpur','742304',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53953,153,'Muktinagar','742102',1,0,'2022-03-03 12:47:42','2022-03-03 12:47:42'),(53954,153,'Mukundapur','742187',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53955,153,'Muniadihi','742161',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53956,153,'Muradpur Arji','742305',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53957,153,'Murshidabad','742149',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53958,153,'Nabadurga','742168',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53959,153,'Nabagram (Murshidabad)','742184',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53960,153,'Nabarun','742236',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53961,153,'Nabipur','742308',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53962,153,'Nagar (Murshidabad)','742159',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53963,153,'Nagra','742122',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53964,153,'Nashipur Balagachi','742135',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53965,153,'Nashipur Rajbati','742160',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53966,153,'Naskarpur','742224',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53967,153,'Natial','742308',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53968,153,'Naupukuria','742133',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53969,153,'Naya Bahadurpur','742223',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53970,153,'Nayakharida Babupur','742135',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53971,153,'Nayansukh','742202',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53972,153,'Nazirpur','742189',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53973,153,'Nazirpur','742304',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53974,153,'Nimgram Beluri','742226',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53975,153,'Nimtita Joykrishnapur','742224',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53976,153,'Nimtita','742224',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53977,153,'Nischintapur','742165',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53978,153,'Noapara','742226',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53979,153,'Nograjole','742102',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53980,153,'Nowda','742121',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53981,153,'Nowdapanur','742102',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53982,153,'Nowpara Simulia','742134',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53983,153,'Ntpc Farakka','742236',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53984,153,'Nurpur','742223',1,0,'2022-03-03 12:47:43','2022-03-03 12:47:43'),(53985,153,'Nutan Durgapur','742304',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(53986,153,'Nutanganj','742227',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(53987,153,'Nutangram','742140',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(53988,153,'Nutanpara-raipur','742165',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(53989,153,'P.T.Rasulpur','742303',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(53990,153,'Padmanavpur','742166',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(53991,153,'Paharpur','742148',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(53992,153,'Paikmari','742304',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(53993,153,'Palitpara','742163',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(53994,153,'Palsandamore','742238',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(53995,153,'Panchgram','742184',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(53996,153,'Panchthupi','742161',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(53997,153,'Par Raghunathpur','742303',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(53998,153,'Pardiar','742121',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(53999,153,'Pareshnathpur','742175',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(54000,153,'Parulia','742201',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(54001,153,'Pasai','742227',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(54002,153,'Pasla','742184',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(54003,153,'Patikabari','742121',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(54004,153,'Patkeldanga','742122',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(54005,153,'Pilky','742237',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(54006,153,'Polsanda','742159',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(54007,153,'Pomaipur','742302',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(54008,153,'Prosadpur','742401',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(54009,153,'Protappur','742166',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(54010,153,'Pulinda','742134',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(54011,153,'Pundi','742226',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(54012,153,'Purandarpur','742140',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(54013,153,'Puropara','742201',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(54014,153,'Radharghat','742187',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(54015,153,'Raghunathganj Bazar','742225',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(54016,153,'Raghunathganj H.O','742225',1,0,'2022-03-03 12:47:44','2022-03-03 12:47:44'),(54017,153,'Raghunathpur','742223',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54018,153,'Raigram','742401',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54019,153,'Rainda','742187',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54020,153,'Raipur','742303',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54021,153,'Raipur-mirpur','742121',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54022,153,'Rajapur','742306',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54023,153,'Rajarampur Monoharpur','742140',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54024,153,'Rajarampur','742151',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54025,153,'Rajdharpara','742165',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54026,153,'Rajhat','742161',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54027,153,'Rajnagar','742175',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54028,153,'Rajnagar','742227',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54029,153,'Rajput Teghari','742213',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54030,153,'Ramchandrapur','742159',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54031,153,'Ramdebpur','742213',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54032,153,'Rameswarpur','742134',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54033,153,'Ramkrishnapur','742166',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54034,153,'Ramna Chandpur','742175',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54035,153,'Ramna Sekhdighi','742227',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54036,153,'Ramnagar Dk','742308',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54037,153,'Rampara','742189',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54038,153,'Rampur','742113',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54039,153,'Raninagar','742308',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54040,153,'Rasorah','742138',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54041,153,'Rasulpur','742184',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54042,153,'Ratanpur','742202',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54043,153,'Rezinagar','742189',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54044,153,'Roshanbagh','742164',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54045,153,'Rukunpur','742166',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54046,153,'S.S.Sen Road','742101',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54047,153,'Sabaldaha','742159',1,0,'2022-03-03 12:47:45','2022-03-03 12:47:45'),(54048,153,'Sabdarnagar','742175',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54049,153,'Sabitrinagar','742405',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54050,153,'Sadal','742159',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54051,153,'Sadar Nashipur','742151',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54052,153,'Sadekbag','742123',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54053,153,'Sadekpur','742223',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54054,153,'Sadi Khan Diar','742303',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54055,153,'Sagardighi','742226',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54056,153,'Sagarpara','742306',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54057,153,'Sagia','742151',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54058,153,'Sahapur','742301',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54059,153,'Sahapur-barala','742122',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54060,153,'Sahazadpur','742166',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54061,153,'Saheb Nagar','742306',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54062,153,'Sahebrampur','742305',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54063,153,'Sahi Sherpur','742159',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54064,153,'Saidabad','742103',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54065,153,'Saktipur','742163',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54066,153,'Salar','742401',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54067,153,'Salinda','742401',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54068,153,'Salu','742401',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54069,153,'Samsabad','742226',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54070,153,'Sankarpur','742159',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54071,153,'Sankarpur Dharampur','742166',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54072,153,'Sanmatinagar','742213',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54073,153,'Sarangpur','742304',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54074,153,'Sarbangapur','742174',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54075,153,'Sargachi Ashram','742408',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54076,153,'Sarkarpara','742305',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54077,153,'Sarmastipur','742404',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54078,153,'Satitara','742132',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54079,153,'Satui','742405',1,0,'2022-03-03 12:47:46','2022-03-03 12:47:46'),(54080,153,'Sayed Kulut','742301',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54081,153,'Sehalai','742301',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54082,153,'Sekhalipur','742148',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54083,153,'Senai','742132',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54084,153,'Senda-jamur','742235',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54085,153,'Shaikhpara.','742409',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54086,153,'Shibnagar','742306',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54087,153,'Shibnagar Laskarpur','742406',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54088,153,'Shibrambati','742161',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54089,153,'Shyampur Nutanpara','742135',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54090,153,'Sijgram','742301',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54091,153,'Singer','742184',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54092,153,'Singheswari Gouripur','742122',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54093,153,'Siteshnagar','742151',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54094,153,'Sompara','742163',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54095,153,'Sonatikuri','742175',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54096,153,'Srikrishnapur','742405',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54097,153,'Srimantapur','742212',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54098,153,'Sripat Singh College','742123',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54099,153,'Sripur','742166',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54100,153,'Sujapur','742134',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54101,153,'Suki','742226',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54102,153,'Sundarpur','742161',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54103,153,'Sundipur','742102',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54104,153,'Sunuti','742401',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54105,153,'Swaruppur','742166',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54106,153,'Takipur','742189',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54107,153,'Talgachi','742149',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54108,153,'Talgram','742301',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54109,153,'Talibpur','742402',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54110,153,'Tanti Birol','742235',1,0,'2022-03-03 12:47:47','2022-03-03 12:47:47'),(54111,153,'Tarapur','742161',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54112,153,'Targram','742184',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54113,153,'Tartipur','742166',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54114,153,'Telkar Dafarpur','742187',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54115,153,'Tenka Raipur','742304',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54116,153,'Tentulia','742302',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54117,153,'Tenya','742404',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54118,153,'Tezsinghapur','742304',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54119,153,'Tikiapara','742187',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54120,153,'Tildanga','742212',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54121,153,'Tinpukuria','742202',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54122,153,'Trimohini','742175',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54123,153,'Udaynagar Colony','742305',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54124,153,'Ujunia','742401',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54125,153,'Upar Fatepur','742148',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54126,153,'Uttar Gopinathpur','742159',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54127,153,'Uttar Ramna','742235',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54128,153,'Dakshinkhanda','713123',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54129,154,'Akanda Danga','741137',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54130,154,'Akandaberia','741137',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54131,154,'Aluipara','741317',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54132,154,'Amghata','741315',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54133,154,'Aminbazar','741101',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54134,154,'Amiya Narayanpur','741165',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54135,154,'Anandanagar','741125',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54136,154,'Arabpur','741122',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54137,154,'Arbetai','741137',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54138,154,'Arpara','741126',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54139,154,'Ashachia','741137',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54140,154,'Assannagar','741161',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54141,154,'Bablari','741316',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54142,154,'Bagberia','741123',1,0,'2022-03-03 12:47:48','2022-03-03 12:47:48'),(54143,154,'Bagchi Jamsherpur','741122',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54144,154,'Bahadurpur','741125',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54145,154,'Bahirchara','741316',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54146,154,'Bahirgachhi','741154',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54147,154,'Bajitpur','741152',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54148,154,'Bakshipur','741155',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54149,154,'Bali','741156',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54150,154,'Baliadanga','741152',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54151,154,'Baliadanga Faridpur','741153',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54152,154,'Bamunpukur','741313',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54153,154,'Bandbelgaon','741126',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54154,154,'Bangaljhi','741123',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54155,154,'Baniakhari','741124',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54156,154,'Bansberia','741122',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54157,154,'Bara Andulia','741124',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54158,154,'Bara Atagi','741137',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54159,154,'Bara Kul Beria','741150',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54160,154,'Barachand Ghar','741156',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54161,154,'Barbakpur','741165',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54162,154,'Bareya','741156',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54163,154,'Barnia','741156',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54164,154,'Barui Para','741156',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54165,154,'Basarkhola','741150',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54166,154,'Baur','741155',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54167,154,'Belpukur','741125',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54168,154,'Berij','741103',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54169,154,'Betai','741163',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54170,154,'Bethuadahari','741126',1,0,'2022-03-03 12:47:49','2022-03-03 12:47:49'),(54171,154,'Bhanderkhola','741103',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54172,154,'Bharatpur','741181',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54173,154,'Bhatjangla','741102',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54174,154,'Bhawanipur','741155',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54175,154,'Bhimpur','741167',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54176,154,'Bholadanga','741126',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54177,154,'Bhurulia','741157',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54178,154,'Bidyanagar','741319',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54179,154,'Bikrampur','741126',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54180,154,'Bilkumari','741137',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54181,154,'Billwagram','741138',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54182,154,'Binod Nagar','741155',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54183,154,'Birpur','741126',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54184,154,'Bowbazar (Nadia)','741101',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54185,154,'Buroshibtala (Nadia)','741302',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54186,154,'Chandanpur','741162',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54187,154,'Chanderghat','741160',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54188,154,'Char Brahmanagar','741301',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54189,154,'Char Sambhu Nagar','741103',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54190,154,'Charatala','741123',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54191,154,'Charchua Danga','741153',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54192,154,'Charmuktarpur','741152',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54193,154,'Charuitipi','741123',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54194,154,'Chhatina','741160',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54195,154,'Chhitkadaspara','741163',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54196,154,'Chhoto Andulia','741124',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54197,154,'Chhotonalda','741156',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54198,154,'Chinchuria','741126',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54199,154,'Dadupur Nadia','741162',1,0,'2022-03-03 12:47:50','2022-03-03 12:47:50'),(54200,154,'Dakshin Bahirgachhi','741123',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54201,154,'Dalimoula','741140',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54202,154,'Darermath','741158',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54203,154,'Dayer Bazar','741164',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54204,154,'Dearapara','741302',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54205,154,'Debagram','741137',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54206,154,'Dhananjoypur','741126',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54207,154,'Dharmada','741138',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54208,154,'Dhawapara','741156',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54209,154,'Dhopatta','741103',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54210,154,'Dhoradaha','741152',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54211,154,'Dhubinagadi','741137',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54212,154,'Dhubulia','741139',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54213,154,'Dhubulia T B Hospital','741140',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54214,154,'Digha','741154',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54215,154,'Dighalkandi','741152',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54216,154,'Dingel','741137',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54217,154,'Dogachhi','741102',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54218,154,'Dompukuria','741123',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54219,154,'Fajil Nagar','741165',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54220,154,'Fakirdanga','741316',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54221,154,'Gachha','741154',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54222,154,'Gadigachha','741315',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54223,154,'Ganja Danga','741313',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54224,154,'Ghateswar','741154',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54225,154,'Ghoraikhetra','741137',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54226,154,'Ghurni','741103',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54227,154,'Goaldaha','741103',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54228,154,'Goas','741165',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54229,154,'Gobrapota','741103',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54230,154,'Golapati','741101',1,0,'2022-03-03 12:47:51','2022-03-03 12:47:51'),(54231,154,'Gopalpur','741165',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54232,154,'Gopalpur Ghat','741122',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54233,154,'Gopinathpur','741155',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54234,154,'Gotepara','741126',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54235,154,'Hanspukuria','741160',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54236,154,'Haranagar','741137',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54237,154,'Harinarayanpur','741126',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54238,154,'Haripur Chhitka','741163',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54239,154,'Hatisala','741124',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54240,154,'Hogal Beria','741122',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54241,154,'Hridaypur','741123',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54242,154,'Ichhapur','741164',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54243,154,'Idrakpur','741316',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54244,154,'Iswarchandrapur','741160',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54245,154,'Jahangirpur','741103',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54246,154,'Jalalkhali','741102',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54247,154,'Jhitkipota','741102',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54248,154,'Jitpur','741160',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54249,154,'Joania','741317',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54250,154,'Joania Bhaluka','741317',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54251,154,'Joypur','741102',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54252,154,'Joyrampur','741122',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54253,154,'Jugpur Colony','741126',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54254,154,'Juranpur','741150',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54255,154,'Kachharia Para','741122',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54256,154,'Kalamari','741102',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54257,154,'Kaliganj','741150',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54258,154,'Kalinga','741166',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54259,154,'Kalirhat','741102',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54260,154,'Kalyandaha','741123',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54261,154,'Kamarhati','741154',1,0,'2022-03-03 12:47:52','2022-03-03 12:47:52'),(54262,154,'Kamari','741137',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54263,154,'Kandoa','741138',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54264,154,'Karimpur','741152',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54265,154,'Karuigachi','741163',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54266,154,'Kasiadanga','741162',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54267,154,'Kathuriapara','741101',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54268,154,'Kechuadanga','741158',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54269,154,'Khanpur','741152',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54270,154,'Khaspur','741160',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54271,154,'Khidirpur Bethuadahari','741126',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54272,154,'Kishorepur','741165',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54273,154,'Kolerdanga','741302',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54274,154,'Krishna  Chandrapur','741160',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54275,154,'Krishnanagar Court','741101',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54276,154,'Krishnanagar H.O','741101',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54277,154,'Krishnanagar R.S.','741101',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54278,154,'Krishnanagar Road R.S.','741101',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54279,154,'Kulgachi','741161',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54280,154,'Lakshmipur','741123',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54281,154,'Lalbazar','741163',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54282,154,'Madandanga','741137',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54283,154,'Madhabpur','741164',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54284,154,'Mahakhola','741123',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54285,154,'Mahatpur','741164',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54286,154,'Mahesganj','741315',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54287,154,'Mahisura','741316',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54288,154,'Mahurapur','741137',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54289,154,'Majhergram','741137',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54290,154,'Maliapota','741103',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54291,154,'Malumgachha','741126',1,0,'2022-03-03 12:47:53','2022-03-03 12:47:53'),(54292,154,'Manikdihi','741150',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54293,154,'Matchpota','741124',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54294,154,'Matiari','741153',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54295,154,'Mayakole','741125',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54296,154,'Molandi','741156',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54297,154,'Moti Roy Bandh','741302',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54298,154,'Mrigi','741165',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54299,154,'Muragachha','741154',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54300,154,'Nabadwip Bazar','741302',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54301,154,'Nabadwip Dham RS','741302',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54302,154,'Nabadwip H.O','741302',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54303,154,'Nadia Bishnupur','741103',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54304,154,'Nadia School Board','741101',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54305,154,'Nadiasundalpur','741122',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54306,154,'Nagendranagar','741101',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54307,154,'Nakashipara','741126',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54308,154,'Nandanpur','741165',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54309,154,'Natiadanga','741152',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54310,154,'Natna','741160',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54311,154,'Natna Patabuka','741122',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54312,154,'Natunbazar (Nadia)','741101',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54313,154,'Nazirpur (Nadia)','741165',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54314,154,'Nidaya','741313',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54315,154,'Nischantapur','741160',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54316,154,'Notiapota','741160',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54317,154,'Nowpara','741140',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54318,154,'Padmamala','741123',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54319,154,'Paglachandi','741181',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54320,154,'Palashipara','741155',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54321,154,'Palit Behgia','741137',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54322,154,'Palsunda','741156',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54323,154,'Panchdara Abhaynagar','741156',1,0,'2022-03-03 12:47:54','2022-03-03 12:47:54'),(54324,154,'Panditpur','741140',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54325,154,'Pashim Dogachi','741152',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54326,154,'Patharghata','741103',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54327,154,'Patikabari','741126',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54328,154,'Petuabhanga','741124',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54329,154,'Pipragachhi','741123',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54330,154,'Pipulberia','741152',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54331,154,'Plassey','741156',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54332,154,'Plassey Sugar Mill','741157',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54333,154,'Poramatala Road','741302',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54334,154,'Pratapnagar (Nadia)','741302',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54335,154,'Putimari','741103',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54336,154,'Radhakantapur','741181',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54337,154,'Radhanagar','741103',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54338,154,'Radhanagar Colony','741126',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54339,154,'Raghunathpur','741160',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54340,154,'Raghunthpur-ramnagar','741158',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54341,154,'Rahamatpur','741165',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54342,154,'Rajapur','741125',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54343,154,'Rampur','741161',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54344,154,'Ranabanda','741123',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54345,154,'Roypara','741101',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54346,154,'Rudrapara','741302',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54347,154,'Rukunpur','741154',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54348,154,'Rupdaha','741140',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54349,154,'Sahebnagar','741156',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54350,154,'Sakdaha','741167',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54351,154,'Saktinagar','741102',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54352,154,'Saligram','741154',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54353,154,'Sapjola','741137',1,0,'2022-03-03 12:47:55','2022-03-03 12:47:55'),(54354,154,'Seemanagar','741166',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54355,154,'Senpara','741152',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54356,154,'Senpur','741137',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54357,154,'Shibpur','741124',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54358,154,'Shikarpur (Nadia)','741158',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54359,154,'Shondanga','741125',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54360,154,'Shyamnagar (Murshidabad)','741156',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54361,154,'Shyamnagar','741155',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54362,154,'Sonadanga','741126',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54363,154,'Sonda','741103',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54364,154,'Sreemayapur','741313',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54365,154,'Srirampur (Nadia)','741316',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54366,154,'Suksagar','741154',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54367,154,'Sutia','741103',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54368,154,'Swarupganj','741315',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54369,154,'Taibichara','741126',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54370,154,'Talukhuda','741123',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54371,154,'Tarakganj','741165',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54372,154,'Taranipur','741103',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54373,154,'Tatla','741125',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54374,154,'Teghari','741124',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54375,154,'Tegharipara','741302',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54376,154,'Tehatta','741160',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54377,154,'Tentulberia','741138',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54378,154,'Thanarpara','741152',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54379,154,'Tilakpur','741164',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54380,154,'Topla','741165',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54381,154,'Tungi','741156',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54382,154,'Udaychandrapur','741162',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54383,154,'Ukilpara','741101',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54384,154,'Ushidpur','741301',1,0,'2022-03-03 12:47:56','2022-03-03 12:47:56'),(54385,154,'Uttar Bahirgachhi','741126',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54386,154,'2no.Natunfulia','741402',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54387,154,'Alaipur','741245',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54388,154,'Ananda Nagar','741245',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54389,154,'Anishmali','741253',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54390,154,'Anulia','741255',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54391,154,'Arangahta','741501',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54392,154,'Arbandi','741121',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54393,154,'Ashanandapara Street','741404',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54394,154,'Bablagobindapur','741404',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54395,154,'Badkulla','741121',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54396,154,'Bagachra','741404',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54397,154,'Bagula','741502',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54398,154,'Balia','741223',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54399,154,'Banpur (Nadia)','741503',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54400,154,'Bapukinagar','741121',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54401,154,'Barabazar','741404',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54402,154,'Barajaguli','741221',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54403,154,'Barajiakur','741404',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54404,154,'Baranberia','741504',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54405,154,'Barbaria','741501',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54406,154,'Bathangachi','741507',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54407,154,'Bedibhavan','741250',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54408,154,'Begopara','741256',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54409,154,'Belemath','741402',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54410,154,'Benali','741502',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54411,154,'Betna','741505',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54412,154,'Bhaduri','741121',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54413,154,'Bhagirathisilpaashram','741248',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54414,154,'Bhairabchandrapur','741502',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54415,154,'Bhajanghat','741507',1,0,'2022-03-03 12:47:57','2022-03-03 12:47:57'),(54416,154,'Bhayna','741502',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54417,154,'Bidhanpark','741235',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54418,154,'Bijoypur','741503',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54419,154,'Birnagar','741127',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54420,154,'Birohiedso','741245',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54421,154,'Biswaspara','741201',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54422,154,'Boalia','741121',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54423,154,'Buddhapark','741235',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54424,154,'Buincha','741402',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54425,154,'Byaspur','741127',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54426,154,'Chakdah','741222',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54427,154,'Chandamari','741245',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54428,154,'Chandandaha','741121',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54429,154,'Chandannagar (Nadia)','741509',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54430,154,'Chandra','741121',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54431,154,'Chanduria','741248',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54432,154,'Chapra','741202',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54433,154,'Chapri','741151',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54434,154,'Charsarhati','741251',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54435,154,'Chitrasali','741151',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54436,154,'Chotobazar','741201',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54437,154,'Chowgacha','741222',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54438,154,'Chowgacha','741509',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54439,154,'Chunuripara','741201',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54440,154,'Chupria','741502',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54441,154,'Churni Raghunathpur','741501',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54442,154,'Cooper\'s Camp','741232',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54443,154,'Daharbuincha','741505',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54444,154,'Daluabari','741504',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54445,154,'Darappur','741223',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54446,154,'Dayabari','741256',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54447,154,'Debagram','741238',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54448,154,'Deuli','741222',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54449,154,'Dhakshinpara','741151',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54450,154,'Dhantala','741202',1,0,'2022-03-03 12:47:58','2022-03-03 12:47:58'),(54451,154,'Digambarpur','741508',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54452,154,'Dighalgram','741257',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54453,154,'Dighra','741222',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54454,154,'Dignagar','741401',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54455,154,'Durgapur','741506',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54456,154,'Duttapulia','741504',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54457,154,'Eruli','741253',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54458,154,'Fatepur','741249',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54459,154,'Fatepur Majdia','741507',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54460,154,'Fulia Boyra','741402',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54461,154,'Fulia Colony','741402',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54462,154,'Gandhi Memorial Hospital','741235',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54463,154,'Gangnapur','741238',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54464,154,'Gangsara Majhergram','741238',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54465,154,'Garapota-nadia','741502',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54466,154,'Gayeshpur Hazratala','741404',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54467,154,'Gayeshpur','741234',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54468,154,'Gazipur','741402',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54469,154,'Gazna','741507',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54470,154,'Gede','741503',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54471,154,'Ghetugachi','741222',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54472,154,'Ghola','741238',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54473,154,'Ghoragacha','741245',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54474,154,'Ghoralia','741404',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54475,154,'Ghoshpara (Nadia)','741235',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54476,154,'Gobindapur','741505',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54477,154,'Gopinagar','741238',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54478,154,'Gouripur','741223',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54479,154,'Habibpur','741402',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54480,154,'Halalpur-krishnapur','741202',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54481,154,'Haldipara','741502',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54482,154,'Hanskhali','741505',1,0,'2022-03-03 12:47:59','2022-03-03 12:47:59'),(54483,154,'Haradham','741255',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54484,154,'Haringhat River Research Insti','741246',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54485,154,'Haripukuria','741257',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54486,154,'Haripurnadia','741404',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54487,154,'Haritala','741502',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54488,154,'Hatbahirgachi','741501',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54489,154,'Hijuli','741202',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54490,154,'Hinghnara','741223',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54491,154,'Humaniapota','741238',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54492,154,'Itaberia','741151',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54493,154,'Jasra','741222',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54494,154,'Jm Nokari','741202',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54495,154,'Joyghata','741508',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54496,154,'Kadambagachi','741222',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54497,154,'Kalinarayanpur','741254',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54498,154,'Kalipur','741245',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54499,154,'Kalyani H.O','741235',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54500,154,'Kalyani Hospital','741235',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54501,154,'Kalyani RS','741235',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54502,154,'Kalyani Simanta','741235',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54503,154,'Kalyani University','741235',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54504,154,'Kamalpuredso','741222',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54505,154,'Kamgachi','741254',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54506,154,'Kasthadanga','741257',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54507,154,'Kataganj','741250',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54508,154,'Khalboalia','741508',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54509,154,'Khamarshumulia','741121',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54510,154,'Khandakhola','741404',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54511,154,'Khosbasmahalla','741222',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54512,154,'Krishivisyavidyalaya','741252',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54513,154,'Krishnaganj','741506',1,0,'2022-03-03 12:48:00','2022-03-03 12:48:00'),(54514,154,'Krishnakalitala','741404',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54515,154,'Kumari Ramnagar','741502',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54516,154,'Kutirpara','741404',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54517,154,'Lalpur (Nadia)','741222',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54518,154,'Madanpur (Nadia)','741245',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54519,154,'Mahadevpur','741257',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54520,154,'Mahaprabhupara','741201',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54521,154,'Maheshpur','741508',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54522,154,'Majdia','741507',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54523,154,'Majerchar','741251',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54524,154,'Mamjaon','741121',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54525,154,'Mathurapur','741507',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54526,154,'Matikumra','741202',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54527,154,'Mayurhat','741502',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54528,154,'Mohanpur (Nadia)','741246',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54529,154,'Mollabelia','741249',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54530,154,'Muraghachacolony','741502',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54531,154,'Nabarupdaha','741502',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54532,154,'Nadiasumalia','741508',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54533,154,'Nagarukhra','741257',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54534,154,'Nandighat','741255',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54535,154,'Narapatipara','741248',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54536,154,'Narayanpur','741249',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54537,154,'Naserkuli','741238',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54538,154,'Nasra','741202',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54539,154,'Netajisubhas Sanatorium','741251',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54540,154,'Nimtala Bazar','741257',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54541,154,'Noapara','741255',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54542,154,'Panchberia','741501',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54543,154,'Panpara','741402',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54544,154,'Panpur','741249',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54545,154,'Patikabari','741502',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54546,154,'Poradanga','741222',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54547,154,'Pritinagar','741247',1,0,'2022-03-03 12:48:01','2022-03-03 12:48:01'),(54548,154,'Purbabishnupur','741223',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54549,154,'Purbanowpara','741501',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54550,154,'Putikhali','741507',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54551,154,'Raghu Nandan Pur','741503',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54552,154,'Rajarmath','741223',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54553,154,'Ramnagar ','741201',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54554,154,'Ramnagarchar','741404',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54555,154,'Ranaghat Baidyapur','741256',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54556,154,'Ranaghat Bazar','741201',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54557,154,'Ranaghat College','741201',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54558,154,'Ranaghat Court','741201',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54559,154,'Ranaghat H.O','741201',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54560,154,'Ranaghat RS','741201',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54561,154,'Ranaghat Rupashreepally','741201',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54562,154,'Rautari','741248',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54563,154,'Saguna','741245',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54564,154,'Santinagar','741502',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54565,154,'Santipur College','741404',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54566,154,'Santipur RS','741404',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54567,154,'Santipur','741404',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54568,154,'Sanyalchar','741222',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54569,154,'Shibnarayanpur','741501',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54570,154,'Shibnibas','741509',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54571,154,'Shyamchandpara','741404',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54572,154,'Siddheswaritala','741201',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54573,154,'Silinda','741223',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54574,154,'Simhat','741249',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54575,154,'Simurali','741248',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54576,154,'Subarnapur','741249',1,0,'2022-03-03 12:48:02','2022-03-03 12:48:02'),(54577,154,'Sutragarh','741404',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54578,154,'Swarnakhali','741506',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54579,154,'Taherpur','741159',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54580,154,'Taldaha','741507',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54581,154,'Tangra','741506',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54582,154,'Taraknagar','741502',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54583,154,'Tarapur','741402',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54584,154,'Tatla','741222',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54585,154,'Ulashi','741502',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54586,154,'Uzirpukuria','741238',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54587,155,'Abad Kuliadanga','743456',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54588,155,'Abdalpur','700155',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54589,155,'Adampur','743425',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54590,155,'Adhata','743221',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54591,155,'Adikashimpur','743248',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54592,155,'Aharampur','700131',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54593,155,'Ajijnagar','743425',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54594,155,'Akaipur','743710',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54595,155,'Akandakeshari','700135',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54596,155,'Akrampur','743263',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54597,155,'Amankandi','743249',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54598,155,'Amberia','743435',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54599,155,'Ambikapur Mamudpur','743251',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54600,155,'Amdobe','743251',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54601,155,'Amodpur','743456',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54602,155,'Amta','743445',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54603,155,'Amudia','743273',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54604,155,'Andharmanik','743401',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54605,155,'Angrail','743235',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54606,155,'Arbelia','743437',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54607,155,'Arkhali Amdanga','743221',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54608,155,'Asharu','743251',1,0,'2022-03-03 12:48:03','2022-03-03 12:48:03'),(54609,155,'Asoknagar R/s','743222',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54610,155,'Asoknagar','743222',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54611,155,'Atapur','743446',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54612,155,'Atghara','743438',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54613,155,'Atpukur','743425',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54614,155,'Aturia','743427',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54615,155,'Badartala','743292',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54616,155,'Badu (North 24 Parganas)','700128',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54617,155,'Baduria','743401',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54618,155,'Bagangram','743251',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54619,155,'Bagdah','743232',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54620,155,'Bagu','700135',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54621,155,'Bahangatushkhali','743446',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54622,155,'Baidyapur','743423',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54623,155,'Baikara','743245',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54624,155,'Bairampur','743262',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54625,155,'Bajitpur','743427',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54626,155,'Bakra  Dabar','743435',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54627,155,'Baksha','743232',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54628,155,'Baliadanga','743251',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54629,155,'Balisha Chowmatha','743235',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54630,155,'Ballavpur','743245',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54631,155,'Balti','743273',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54632,155,'Bamangachi','743248',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54633,155,'Bamanibad','743442',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54634,155,'Bamanpukur','743425',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54635,155,'Baneswarpur','743270',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54636,155,'Bangaon Bazar','743235',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54637,155,'Bangaon RS','743235',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54638,155,'Bangaon (North 24 Parganas)','743235',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54639,155,'Banglani','743286',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54640,155,'Banipur (North 24 Parganas)','743233',1,0,'2022-03-03 12:48:04','2022-03-03 12:48:04'),(54641,155,'Bankra','743435',1,0,'2022-03-03 12:48:05','2022-03-03 12:48:05'),(54642,155,'Banshtala','743435',1,0,'2022-03-03 12:48:05','2022-03-03 12:48:05'),(54643,155,'Barabankra','743427',1,0,'2022-03-03 12:48:05','2022-03-03 12:48:05'),(54644,155,'Barasat Bazar','700124',1,0,'2022-03-03 12:48:05','2022-03-03 12:48:05'),(54645,155,'Barasat H.O','700124',1,0,'2022-03-03 12:48:05','2022-03-03 12:48:05'),(54646,155,'Barghorai','743247',1,0,'2022-03-03 12:48:05','2022-03-03 12:48:05'),(54647,155,'Barrackpore Sripalli','743262',1,0,'2022-03-03 12:48:05','2022-03-03 12:48:05'),(54648,155,'Barunhat','743426',1,0,'2022-03-03 12:48:05','2022-03-03 12:48:05'),(54649,155,'Basirhat Bazar','743411',1,0,'2022-03-03 12:48:05','2022-03-03 12:48:05'),(54650,155,'Basirhat College','743412',1,0,'2022-03-03 12:48:05','2022-03-03 12:48:05'),(54651,155,'Basirhat H.O','743411',1,0,'2022-03-03 12:48:05','2022-03-03 12:48:05'),(54652,155,'Basirhat RS','743412',1,0,'2022-03-03 12:48:05','2022-03-03 12:48:05'),(54653,155,'Beara','743251',1,0,'2022-03-03 12:48:05','2022-03-03 12:48:05'),(54654,155,'Bechra Mohanpur','743456',1,0,'2022-03-03 12:48:05','2022-03-03 12:48:05'),(54655,155,'Begumpur','743437',1,0,'2022-03-03 12:48:05','2022-03-03 12:48:05'),(54656,155,'Beliaghata Bridge','743423',1,0,'2022-03-03 12:48:05','2022-03-03 12:48:05'),(54657,155,'Belpur','743423',1,0,'2022-03-03 12:48:05','2022-03-03 12:48:05'),(54658,155,'Belta','743701',1,0,'2022-03-03 12:48:05','2022-03-03 12:48:05'),(54659,155,'Bena','743401',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54660,155,'Beraberi','743711',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54661,155,'Berbari','743270',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54662,155,'Bergoom','743263',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54663,155,'Bermajur','743442',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54664,155,'Bhabanipur','743445',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54665,155,'Bhabla','743422',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54666,155,'Bhaduria','743427',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54667,155,'Bhagyamantapur','700128',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54668,155,'Bhanderkhali','743439',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54669,155,'Bhanderkhola','743290',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54670,155,'Bharatpur','743251',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54671,155,'Bhasila','743423',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54672,155,'Bhawanipur','743270',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54673,155,'Bhebia','743456',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54674,155,'Bhojpara','743427',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54675,155,'Bhurkunda','743426',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54676,155,'Bira Ballavepara','743234',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54677,155,'Biramnagar','743422',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54678,155,'Bishpur','743435',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54679,155,'Bithari','743286',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54680,155,'Boaldah','743235',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54681,155,'Bodai','700126',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54682,155,'Bohara','743294',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54683,155,'Bowthakurani','743446',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54684,155,'Boyermari','743442',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54685,155,'Boyra','743232',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54686,155,'Buruj','743401',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54687,155,'Chaigharia','743405',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54688,155,'Chaita','743445',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54689,155,'Chaital','743456',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54690,155,'Chakla','743424',1,0,'2022-03-03 12:48:06','2022-03-03 12:48:06'),(54691,155,'Chakpatli','743426',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54692,155,'Champaberia','743235',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54693,155,'Champapukur','743291',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54694,155,'Chand Para Bazar','743245',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54695,155,'Chandanpur','743439',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54696,155,'Chandipur','743247',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54697,155,'Chandpur','700135',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54698,155,'Chandpur','743424',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54699,155,'Chandpur','743232',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54700,155,'Charghat','743247',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54701,155,'Chekati','743245',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54702,155,'Chhoto Jagulia','743294',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54703,155,'Chikanpara','743287',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54704,155,'Chimta Kachari','743456',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54705,155,'Chorashi','743424',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54706,155,'Choto Sahebkhali','743439',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54707,155,'Choto Sehara','743442',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54708,155,'Chowberia','743290',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54709,155,'Chowhata','743425',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54710,155,'Colony Ramchandra Pur','743287',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54711,155,'Colony Simulia','743249',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54712,155,'Dakshin Akratola','743442',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54713,155,'Dakshin Bagundi','743429',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54714,155,'Dakshin Bhebia','743456',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54715,155,'Dakshin Chatra','743247',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54716,155,'Dakshin Hatgachha','743439',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54717,155,'Dakshin Korakati','743446',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54718,155,'Dakshin Panchpota','743251',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54719,155,'Dandirhat','743412',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54720,155,'Dariapur','743711',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54721,155,'Deara','743247',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54722,155,'Debalaya','743424',1,0,'2022-03-03 12:48:07','2022-03-03 12:48:07'),(54723,155,'Deganga','743423',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54724,155,'Deuli Pukuria','743439',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54725,155,'Dhakuria Kali Bari','743245',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54726,155,'Dhaltita','743412',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54727,155,'Dhanyakuria','743437',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54728,155,'Dharamberia','743435',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54729,155,'Dharampukuria','743235',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54730,155,'Dharampur','743249',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54731,155,'Dheknamari','743442',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54732,155,'Dhuchnikhali','743446',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54733,155,'Dhutradaha','743425',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54734,155,'Digha','743248',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54735,155,'Digha','743245',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54736,155,'Dighari','743290',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54737,155,'Dinabandhunagar','743235',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54738,155,'Dogacha','743235',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54739,155,'Dogachhia Monmohanpur','743245',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54740,155,'Dulduli Mathbari','743439',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54741,155,'Duma','743245',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54742,155,'Durgamandap','743446',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54743,155,'Duttapara','743286',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54744,155,'Duttapukur','743248',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54745,155,'Dwarikjungale','743446',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54746,155,'East Bishnupur','743273',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54747,155,'East Udayrajpur','700129',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54748,155,'Eojnagar','743293',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54749,155,'Fultala','743263',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54750,155,'Gadpukuria','743710',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54751,155,'Gaighata','743249',1,0,'2022-03-03 12:48:08','2022-03-03 12:48:08'),(54752,155,'Gaipur','743252',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54753,155,'Ganadipayan','743263',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54754,155,'Gandharbpur','743427',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54755,155,'Ganganagar (North 24 Parganas)','700132',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54756,155,'Ganrapota','743251',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54757,155,'Ganti','700132',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54758,155,'Garakupi','743456',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54759,155,'Gazipur','743251',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54760,155,'Ghatbour','743235',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54761,155,'Ghatihara','743442',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54762,155,'Ghatpatila','743251',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54763,155,'Ghona','743445',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54764,155,'Ghoni','743426',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54765,155,'Ghonza','743249',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54766,155,'Ghosalbati','743426',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54767,155,'Ghoshpara','743442',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54768,155,'Ghoshpur','743289',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54769,155,'Goalbathan','743245',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54770,155,'Goaldaha','743427',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54771,155,'Gobardanga Ichapur','743252',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54772,155,'Gobardanga','743252',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54773,155,'Gobardhanpur','743423',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54774,155,'Gobila','743424',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54775,155,'Gobinda Pur','743273',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54776,155,'Gobrapur','743251',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54777,155,'Gokna','743293',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54778,155,'Gokulpur','743286',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54779,155,'Golabari Bazar','743423',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54780,155,'Gopalnagar (North 24 Parganas)','743262',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54781,155,'Gopalpur (North 24 Parganas)','743445',1,0,'2022-03-03 12:48:09','2022-03-03 12:48:09'),(54782,155,'Goribpur','743710',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54783,155,'Goshna','743292',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54784,155,'Gotra','743422',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54785,155,'Gotri','743251',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54786,155,'Gouribhoj','743445',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54787,155,'Guma','743704',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54788,155,'Habra Prafulla Nagar','743268',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54789,155,'Habra','743263',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54790,155,'Hadipur','743424',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54791,155,'Hakimpur','743273',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54792,155,'Harba Srinagar','743263',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54793,155,'Haripur (North 24 Parganas)','743223',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54794,155,'Harishpur','743412',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54795,155,'Haroa','743425',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54796,155,'Hasnabad Rampur','743439',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54797,155,'Hasnabad','743426',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54798,155,'Hatgachha','743439',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54799,155,'Hatisala','700135',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54800,155,'Hatkurulia','743232',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54801,155,'Hatthuba','743263',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54802,155,'Helencha Colony','743270',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54803,155,'Hemnagar','743439',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54804,155,'Hijalpukuria','743271',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54805,155,'Hingalganj','743435',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54806,155,'Hingli','743290',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54807,155,'Hishabi','743221',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54808,155,'Hridaypur','700127',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54809,155,'Ichapurabad','743426',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54810,155,'Iswarigacha','743222',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54811,155,'Itinda','743292',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54812,155,'Jadurhati','743293',1,0,'2022-03-03 12:48:10','2022-03-03 12:48:10'),(54813,155,'Jagadishpur','743251',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54814,155,'Jagannathpur','700126',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54815,155,'Jaleswar','743249',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54816,155,'Janaphul','743263',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54817,155,'Jangalpur','743438',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54818,155,'Jasaikati','743401',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54819,155,'Jesur Jeoldanga','743233',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54820,155,'Jhawdanga','743245',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54821,155,'Jhikra','743245',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54822,155,'Jhopkhali','743442',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54823,155,'Jogeshganj','743439',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54824,155,'Joygopalpur','743446',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54825,155,'Joygram','743425',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54826,155,'Joypul','743234',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54827,155,'Kachdaha','743247',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54828,155,'Kachua','743424',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54829,155,'Kachua Swarupnagar','743293',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54830,155,'Kadambagachi','700125',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54831,155,'Kadampukur','700135',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54832,155,'Kahankia','743245',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54833,155,'Kaijuri','743427',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54834,155,'Kaipukuria','743245',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54835,155,'Kaliani','743423',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54836,155,'Kalinagar Hat','743442',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54837,155,'Kalitala','743439',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54838,155,'Kalupur','743235',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54839,155,'Kalyangarh','743272',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54840,155,'Kamdevkati','743438',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54841,155,'Kamdevpur','700125',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54842,155,'Kamduni','700135',1,0,'2022-03-03 12:48:11','2022-03-03 12:48:11'),(54843,155,'Kanchanpur','743435',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54844,155,'Kanchiara','743711',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54845,155,'Kankpul','743272',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54846,155,'Kanmari','743442',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54847,155,'Kantabagan','743286',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54848,155,'Kapileswarpur','743247',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54849,155,'Karanga','743251',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54850,155,'Karnolkora','743412',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54851,155,'Karua Chandpur','743423',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54852,155,'Kashinathpur','700135',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54853,155,'Kathur','743422',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54854,155,'Katiahat','743427',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54855,155,'Kazipara','700125',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54856,155,'Khalisadi','743425',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54857,155,'Khalitpur','743405',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54858,155,'Khantura','743273',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54859,155,'Kharampur','743456',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54860,155,'Kharihatabad','743442',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54861,155,'Kharua Rajapur','743245',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54862,155,'Kharupala','743425',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54863,155,'Khasbalanda','743425',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54864,155,'Khilkapur','700125',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54865,155,'Kholapota','743428',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54866,155,'Khorgachi','743427',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54867,155,'Khulna','743446',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54868,155,'Kirtipur','700128',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54869,155,'Kishorenagar Jalalpur','743429',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54870,155,'Kodalia Agapur','700131',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54871,155,'Kolsur','743438',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54872,155,'Koniara','743251',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54873,155,'Korachandigarh','700130',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54874,155,'Korakati','743446',1,0,'2022-03-03 12:48:12','2022-03-03 12:48:12'),(54875,155,'Korarbagan','743235',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54876,155,'Kothabari','743435',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54877,155,'Krishnachandapur','743251',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54878,155,'Kulia','743270',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54879,155,'Kumarkhola','743270',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54880,155,'Kumarzole','743425',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54881,155,'Kumra Kashipur','743271',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54882,155,'Labukhali','743439',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54883,155,'Lauhati','700135',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54884,155,'Laxmipul','743234',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54885,155,'Machibhanga','700135',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54886,155,'Madanpur Krishnapur','700128',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54887,155,'Madhav Kathi','743439',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54888,155,'Madhyamgram Bazar','700130',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54889,155,'Madhyamgram','700129',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54890,155,'Madia','743273',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54891,155,'Madiahat','743262',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54892,155,'Mahananda Para','743251',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54893,155,'Makhalgacha','743422',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54894,155,'Malancha','743425',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54895,155,'Malekangumti','743439',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54896,155,'Malidah','743232',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54897,155,'Malikagherai','743456',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54898,155,'Malikapur','700126',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54899,155,'Mamabhagina','743232',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54900,155,'Manaikati','743439',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54901,155,'Mandra','743438',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54902,155,'Manicktala','743263',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54903,155,'Mashyampur','743232',1,0,'2022-03-03 12:48:13','2022-03-03 12:48:13'),(54904,155,'Maslandapur','743289',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54905,155,'Maslishpur','743423',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54906,155,'Masunda','743711',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54907,155,'Mathbariabad','743442',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54908,155,'Matia','743437',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54909,155,'Matiaghata','700135',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54910,155,'Merudandi','743292',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54911,155,'Michealnagar','700133',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54912,155,'Minakhan','743411',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54913,155,'Mirhati','700125',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54914,155,'Model Belghoria','743427',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54915,155,'Mominpur','743291',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54916,155,'Mongalganj','743297',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54917,155,'Monipur','743446',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54918,155,'Mothuadham Mondalpara','743245',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54919,155,'Motiganj (North 24 Parganas)','743235',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54920,155,'Mudiahat','700128',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54921,155,'Murarisah','743456',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54922,155,'Murighata','743251',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54923,155,'Nabapally','700126',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54924,155,'Nahata','743290',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54925,155,'Nakpul','743235',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54926,155,'Nakpul Kuchlia','743252',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54927,155,'Naksha','743294',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54928,155,'Naldugri','743297',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54929,155,'Nalkora','743442',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54930,155,'Narabunia','743425',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54931,155,'Narayanpur','700136',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54932,155,'Nataberia','743270',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54933,155,'Natagram','743249',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54934,155,'Naya Basti','743401',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54935,155,'Nazat Hatkhola','743442',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54936,155,'Nehalpur','743437',1,0,'2022-03-03 12:48:14','2022-03-03 12:48:14'),(54937,155,'Newbarackpur','700131',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54938,155,'Nimdaria','743294',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54939,155,'Nimichi','743456',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54940,155,'Nirman','743286',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54941,155,'Nityaberia','743442',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54942,155,'Nityanandakati','743273',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54943,155,'Noapara Madhavpur','700125',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54944,155,'Noapara (North 24 Parganas)','700125',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54945,155,'Nurpur','743456',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54946,155,'Nutungram','743245',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54947,155,'P/  Atapur','743446',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54948,155,'Paikparahat','743422',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54949,155,'Palla','743701',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54950,155,'Panchberia','743710',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54951,155,'Panchita','743235',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54952,155,'Panchpota','743273',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54953,155,'Panitar','743292',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54954,155,'Parghumti','743439',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54955,155,'Parpatna','743438',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54956,155,'Parulia','743423',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54957,155,'Paschim Madhyampur','743429',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54958,155,'Paschim Malikberia','743235',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54959,155,'Paschim Monipur','743446',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54960,155,'Paschim Palta','743427',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54961,155,'Paschim Parghumti','743439',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54962,155,'Paschim Sridharkati','743439',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54963,155,'Patharghata','700135',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54964,155,'Pathghoria','743439',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54965,155,'Pathsimulia','743251',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54966,155,'Petrapole','743405',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54967,155,'Phazilpur','743423',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54968,155,'Phulboniabad','743456',1,0,'2022-03-03 12:48:15','2022-03-03 12:48:15'),(54969,155,'Pifa','743422',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54970,155,'Pithapukuria','700135',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54971,155,'Prithiba','743704',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54972,155,'Punra','743427',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54973,155,'Purandarpur','743273',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54974,155,'Purantan Bongaon','743235',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54975,155,'Purba  Khejurberia','743435',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54976,155,'Purba Deuli','743439',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54977,155,'Purba Sankardaha','743442',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54978,155,'Putia','743263',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54979,155,'Raghunathpur','743401',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54980,155,'Raghunathpur','743428',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54981,155,'Raikhan','743425',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54982,155,'Rajarhat Bishnupur','700135',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54983,155,'Rajarhat Deara','700135',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54984,155,'Rajarhat Gopalpur','700136',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54985,155,'Rajarhat','700135',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54986,155,'Rajballavpur','743289',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54987,155,'Rajendrapur','743291',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54988,155,'Rajibpur','743702',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54989,155,'Ram Nagar Road','743235',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54990,155,'Ramchandrapur Khaspur','743247',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54991,155,'Rameswarpur','743426',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54992,155,'Ramnagar','743273',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54993,155,'Ramnathpur','743423',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54994,155,'Rampur Bhatpara','743249',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54995,155,'Ramshankarpur','743290',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54996,155,'Ranihati','743251',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54997,155,'Rohanda','700135',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54998,155,'Rowtara','743234',1,0,'2022-03-03 12:48:16','2022-03-03 12:48:16'),(54999,155,'Rudrapur','743401',1,0,'2022-03-03 12:48:17','2022-03-03 12:48:17'),(55000,155,'Rupmari','743435',1,0,'2022-03-03 12:48:17','2022-03-03 12:48:17'),(55001,155,'Sabdalpur','743222',1,0,'2022-03-03 12:48:17','2022-03-03 12:48:17'),(55002,155,'Sadhanpur Uludanga','743221',1,0,'2022-03-03 12:48:17','2022-03-03 12:48:17'),(55003,155,'Safirabad','743427',1,0,'2022-03-03 12:48:17','2022-03-03 12:48:17'),(55004,155,'Saguna','743273',1,0,'2022-03-03 12:48:17','2022-03-03 12:48:17'),(55005,155,'Sahebkhali','743439',1,0,'2022-03-03 12:48:17','2022-03-03 12:48:17'),(55006,155,'Sajirhat','700131',1,0,'2022-03-03 12:48:17','2022-03-03 12:48:17'),(55007,155,'Sakdah Jadabpur','743273',1,0,'2022-03-03 12:48:17','2022-03-03 12:48:17'),(55008,155,'Salua','743247',1,0,'2022-03-03 12:48:17','2022-03-03 12:48:17'),(55009,155,'Salua Govt. Colony','743263',1,0,'2022-03-03 12:48:17','2022-03-03 12:48:17'),(55010,155,'Samsernagar','743439',1,0,'2022-03-03 12:48:17','2022-03-03 12:48:17'),(55011,155,'Samudrapur','743272',1,0,'2022-03-03 12:48:17','2022-03-03 12:48:17'),(55012,155,'Sandalia','743423',1,0,'2022-03-03 12:48:17','2022-03-03 12:48:17'),(55013,155,'Sandeler Bil','743435',1,0,'2022-03-03 12:48:17','2022-03-03 12:48:17'),(55014,155,'Sandeshkhali','743446',1,0,'2022-03-03 12:48:18','2022-03-03 12:48:18'),(55015,155,'Sangrampur','743422',1,0,'2022-03-03 12:48:18','2022-03-03 12:48:18'),(55016,155,'Sanrapul','743286',1,0,'2022-03-03 12:48:18','2022-03-03 12:48:18'),(55017,155,'Sarkarpara Kuthipara','743252',1,0,'2022-03-03 12:48:18','2022-03-03 12:48:18'),(55018,155,'Sasan','743423',1,0,'2022-03-03 12:48:18','2022-03-03 12:48:18'),(55019,155,'Sassadanga','743245',1,0,'2022-03-03 12:48:18','2022-03-03 12:48:18'),(55020,155,'Satashi','743290',1,0,'2022-03-03 12:48:18','2022-03-03 12:48:18'),(55021,155,'Satberia','743262',1,0,'2022-03-03 12:48:18','2022-03-03 12:48:18'),(55022,155,'Satbhaya','700135',1,0,'2022-03-03 12:48:18','2022-03-03 12:48:18'),(55023,155,'Sayestanagar','743427',1,0,'2022-03-03 12:48:18','2022-03-03 12:48:18'),(55024,155,'Secondranagar','743424',1,0,'2022-03-03 12:48:18','2022-03-03 12:48:18'),(55025,155,'Sendanga','743272',1,0,'2022-03-03 12:48:18','2022-03-03 12:48:18'),(55026,155,'Sethpukur','700124',1,0,'2022-03-03 12:48:18','2022-03-03 12:48:18'),(55027,155,'Sethpur','743234',1,0,'2022-03-03 12:48:18','2022-03-03 12:48:18'),(55028,155,'Shyamnagar','700135',1,0,'2022-03-03 12:48:18','2022-03-03 12:48:18'),(55029,155,'Sibhati','743292',1,0,'2022-03-03 12:48:18','2022-03-03 12:48:18'),(55030,155,'Sikharpur','700135',1,0,'2022-03-03 12:48:18','2022-03-03 12:48:18'),(55031,155,'Sikrakulingarh','743428',1,0,'2022-03-03 12:48:18','2022-03-03 12:48:18'),(55032,155,'Simulia','743262',1,0,'2022-03-03 12:48:18','2022-03-03 12:48:18'),(55033,155,'Simulia Durgapur','743401',1,0,'2022-03-03 12:48:18','2022-03-03 12:48:18'),(55034,155,'Simulia Kalibari','743426',1,0,'2022-03-03 12:48:18','2022-03-03 12:48:18'),(55035,155,'Simulpur','743289',1,0,'2022-03-03 12:48:18','2022-03-03 12:48:18'),(55036,155,'Sindrani','743297',1,0,'2022-03-03 12:48:18','2022-03-03 12:48:18'),(55037,155,'Sitalia','743446',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55038,155,'Sodarpur-behala','743445',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55039,155,'Sohai Kumarpur','743423',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55040,155,'Soladana','743429',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55041,155,'Sonakenia','743271',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55042,155,'Sonekpur','743701',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55043,155,'South Charalkhali','743439',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55044,155,'South Sikargheri','743442',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55045,155,'Sridharkati','743439',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55046,155,'Srikrishnapur','743711',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55047,155,'Srinagar','743428',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55048,155,'Subhashnagar (North 24 Parganas)','743235',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55049,155,'Sukdwani','743446',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55050,155,'Sulka Durgapur','743701',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55051,155,'Sulkuniabad','743426',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55052,155,'Sundarpur','743251',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55053,155,'Suria','743711',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55054,155,'Sutia Barasat','743273',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55055,155,'Swarupnagar','743286',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55056,155,'Taki Market','743429',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55057,155,'Taki','743429',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55058,155,'Takimamudpur','743435',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55059,155,'Takipur','743429',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55060,155,'Talsa','743234',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55061,155,'Tangra Colony','743251',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55062,155,'Taragunia','743401',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55063,155,'Taranipur','743290',1,0,'2022-03-03 12:48:19','2022-03-03 12:48:19'),(55064,155,'Tentulia','743286',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55065,155,'Tetulbaria','743245',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55066,155,'Thakurnagar','743287',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55067,155,'Thoara','743297',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55068,155,'Tushklali','743446',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55069,155,'Uchildah','743425',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55070,155,'Udayrajpur','700129',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55071,155,'Uludanga','743289',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55072,155,'Uttar Malikanghumti','743439',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55073,155,'Zafarpur','743428',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55074,155,'Zirakpur','743422',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55075,155,'Arjunpur','700059',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55076,155,'Aswini Nagar','700159',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55077,155,'Bangur Avenue','700055',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55078,155,'Bidhan Nagar AE Market','700064',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55079,155,'Bidhan Nagar CK Market','700091',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55080,155,'Bidhan Nagar IB Market','700106',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55081,155,'Bidhan Nagar','700064',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55082,155,'Bidhan Nagar Sai Complex','700098',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55083,155,'Bidhannagr CC Block','700064',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55084,155,'Chakpanchuria','700059',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55085,155,'Desh Bandhu Nagar','700059',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55086,155,'Dum Dum Park','700055',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55087,155,'Ghuni','700059',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55088,155,'Gouranganagar','700059',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55089,155,'Hatgacha','700059',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55090,155,'Hatiara','700157',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55091,155,'Jyangra','700059',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55092,155,'Krishnapur (North 24 Parganas)','700102',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55093,155,'Labony Estate','700064',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55094,155,'Lake Town (North 24 Parganas)','700089',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55095,155,'Mahishbathan','700059',1,0,'2022-03-03 12:48:20','2022-03-03 12:48:20'),(55096,155,'Nabadiganta IT','700091',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55097,155,'New Town Action Area III','700160',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55098,155,'New Town','700156',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55099,155,'Nowbhanga','700105',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55100,155,'Nowbhanga','700105',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55101,155,'Patipukur','700048',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55102,155,'Prafulla Kanan','700101',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55103,155,'Purbachal','700097',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55104,155,'Raghunathpur','700059',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55105,155,'Sadhana Ausudhalaya Road','700048',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55106,155,'Sech Bhawan','700091',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55107,155,'Shyam Nagar Dum Dum','700055',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55108,155,'Sreebhumi','700048',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55109,155,'Agarpara','700109',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55110,155,'Anandamath','743144',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55111,155,'Anandapuri','700122',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55112,155,'Ariadaha','700057',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55113,155,'Athpur','743128',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55114,155,'B.D.Sopan','700116',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55115,155,'Bagermore','743145',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55116,155,'Bandipur','700119',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55117,155,'Bangodaya','700114',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55118,155,'Barajonepur','743145',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55119,155,'Barrackpore Bazar','700120',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55120,155,'Barrackpore Govt.Housing','700120',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55121,155,'Barrackpore H.O','700120',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55122,155,'Barrackpore RS','700123',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55123,155,'Belgharia H.O','700056',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55124,155,'Belgharia Mohini Mills','700056',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55125,155,'Bengal Enamel','743122',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55126,155,'Beraberia','700121',1,0,'2022-03-03 12:48:21','2022-03-03 12:48:21'),(55127,155,'Bhatpara','743123',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55128,155,'Bijoypur','700110',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55129,155,'Binodnagar','743145',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55130,155,'Birati','700051',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55131,155,'Bishalakshi Ghat','700119',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55132,155,'Bisharpara','700158',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55133,155,'Bramhasthan','700119',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55134,155,'Chandmari Road','743145',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55135,155,'Chandua','743145',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55136,155,'Dakshineswar','700076',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55137,155,'Dogachia','743130',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55138,155,'East Belghoria','700083',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55139,155,'Elias Road','700058',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55140,155,'ESD (M)','743124',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55141,155,'Feeder Road','743127',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55142,155,'Fingapara','743129',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55143,155,'Garulia','743133',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55144,155,'Ghola Bazar','700111',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55145,155,'Ghosh Para Road','700120',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55146,155,'Golghar','743125',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55147,155,'Gorifa','743166',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55148,155,'Gupter Bagan','743125',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55149,155,'Gurdah','743127',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55150,155,'Halishahar','743134',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55151,155,'Hazinagar','743135',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55152,155,'Ichapur Nawabganj','743144',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55153,155,'Ichapur Rifle Factory','743144',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55154,155,'Ichapur','743144',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55155,155,'Italghacha','700079',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55156,155,'Jaffarpur','700122',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55157,155,'Jagatdal','743125',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55158,155,'Jeliapara','700117',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55159,155,'Jetia','743135',1,0,'2022-03-03 12:48:22','2022-03-03 12:48:22'),(55160,155,'Jugberia','700110',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55161,155,'Kamarhati','700058',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55162,155,'Kampa','743193',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55163,155,'Kanchrapara Loco Shop','743145',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55164,155,'Kanchrapara','743145',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55165,155,'Kankinara','743126',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55166,155,'Kantadhar','743144',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55167,155,'Karnamadhabpur','700113',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55168,155,'Kelabagan','743194',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55169,155,'Keotia','743126',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55170,155,'Khardah','700117',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55171,155,'Kowgachi','743127',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55172,155,'Kuliagarh','743166',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55173,155,'Kushdanga','743126',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55174,155,'Lalkuthi','743135',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55175,155,'Madarpur','743166',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55176,155,'Madral','743126',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55177,155,'Majhipara','743145',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55178,155,'Malancha','743135',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55179,155,'Mamudpur','743166',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55180,155,'Metal & Steel Factory','743144',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55181,155,'Mondalpara','743127',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55182,155,'Monirampore','700120',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55183,155,'Muktarpur','743123',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55184,155,'Mulajore','743127',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55185,155,'Nabanagar','743136',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55186,155,'Naihati Anandabazar','743165',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55187,155,'Naihati','743165',1,0,'2022-03-03 12:48:23','2022-03-03 12:48:23'),(55188,155,'Nandan Nagar','700083',1,0,'2022-03-03 12:48:24','2022-03-03 12:48:24'),(55189,155,'Narayanpur','743126',1,0,'2022-03-03 12:48:24','2022-03-03 12:48:24'),(55190,155,'Natagarh','700113',1,0,'2022-03-03 12:48:24','2022-03-03 12:48:24'),(55191,155,'Nayapally','700120',1,0,'2022-03-03 12:48:24','2022-03-03 12:48:24'),(55192,155,'Nilachal','700134',1,0,'2022-03-03 12:48:24','2022-03-03 12:48:24'),(55193,155,'Nilganj Bazaar','700121',1,0,'2022-03-03 12:48:24','2022-03-03 12:48:24'),(55194,155,'Nimta','700049',1,0,'2022-03-03 12:48:24','2022-03-03 12:48:24'),(55195,155,'Nonachandanpukur','700122',1,0,'2022-03-03 12:48:24','2022-03-03 12:48:24'),(55196,155,'Nowdapara','700057',1,0,'2022-03-03 12:48:24','2022-03-03 12:48:24'),(55197,155,'Orderly Bazar','700120',1,0,'2022-03-03 12:48:24','2022-03-03 12:48:24'),(55198,155,'P.S.Bureau','743144',1,0,'2022-03-03 12:48:24','2022-03-03 12:48:24'),(55199,155,'Padmalavpur','743126',1,0,'2022-03-03 12:48:24','2022-03-03 12:48:24'),(55200,155,'Palashi','743145',1,0,'2022-03-03 12:48:24','2022-03-03 12:48:24'),(55201,155,'Paltapara','743127',1,0,'2022-03-03 12:48:24','2022-03-03 12:48:24'),(55202,155,'Panihati','700114',1,0,'2022-03-03 12:48:24','2022-03-03 12:48:24'),(55203,155,'Panpara (North 24 Parganas)','700123',1,0,'2022-03-03 12:48:24','2022-03-03 12:48:24'),(55204,155,'Pansila','700112',1,0,'2022-03-03 12:48:24','2022-03-03 12:48:24'),(55205,155,'Patulia','700119',1,0,'2022-03-03 12:48:24','2022-03-03 12:48:24'),(55206,155,'Pinkal','743133',1,0,'2022-03-03 12:48:24','2022-03-03 12:48:24'),(55207,155,'Puranandapally','743165',1,0,'2022-03-03 12:48:24','2022-03-03 12:48:24'),(55208,155,'Purbabidyadharpur','743127',1,0,'2022-03-03 12:48:24','2022-03-03 12:48:24'),(55209,155,'Rahara','700118',1,0,'2022-03-03 12:48:24','2022-03-03 12:48:24'),(55210,155,'Rajbari Colony','700081',1,0,'2022-03-03 12:48:24','2022-03-03 12:48:24'),(55211,155,'Ramchandra Pur','700110',1,0,'2022-03-03 12:48:24','2022-03-03 12:48:24'),(55212,155,'Ramghat (North 24 Parganas)','743166',1,0,'2022-03-03 12:48:24','2022-03-03 12:48:24'),(55213,155,'Ramlakshi Busti Lane','743194',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55214,155,'Rani Park','700056',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55215,155,'Rathtala','700056',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55216,155,'Saliadaha','743145',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55217,155,'Sewli Telinipara','700121',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55218,155,'Shyamnagar (North 24 Parganas)','743127',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55219,155,'Sodepur GHE','700110',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55220,155,'Sodepur','700110',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55221,155,'South Belgharia','700056',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55222,155,'Sukchar (North 24 Parganas)','700115',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55223,155,'Surya Sen Nagar','700117',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55224,155,'Suryapur','700121',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55225,155,'Talpukur','700123',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55226,155,'Texmaco','700056',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55227,155,'Tirtha Bharati','700110',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55228,155,'Titagarh','700119',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55229,155,'Udaipur','700049',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55230,155,'Vivekananda Math','700120',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55231,155,'Gabberia Daudpur','743611',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55232,155,'Jeliakhali Paschimkhanda','743329',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55233,156,'Akhanagar','733129',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55234,156,'Altapur','733215',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55235,156,'Amalia','733208',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55236,156,'Amaljhari','733202',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55237,156,'Andharia','733201',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55238,156,'Asharubasti','733207',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55239,156,'Asuragarh','733209',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55240,156,'Bagdob','733209',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55241,156,'Baghan','733129',1,0,'2022-03-03 12:48:25','2022-03-03 12:48:25'),(55242,156,'Bahar','733210',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55243,156,'Baharail','733134',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55244,156,'Bahin','733134',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55245,156,'Baidara','733128',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55246,156,'Baidyanandapur','733208',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55247,156,'Balihara','733125',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55248,156,'Bamangram','733134',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55249,156,'Bangalbari','733134',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55250,156,'Baramajlishpur','733210',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55251,156,'Barbilla','733210',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55252,156,'Basian','733156',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55253,156,'Bazargaon','733201',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55254,156,'Bekidanga','733143',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55255,156,'Berail','733123',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55256,156,'Betna','733210',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55257,156,'Bhabanbari','733210',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55258,156,'Bhagnail','733143',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55259,156,'Bhaispitta','733207',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55260,156,'Bhanail','733129',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55261,156,'Bharatpur','733156',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55262,156,'Bharna','733209',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55263,156,'Bhatolhat','733156',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55264,156,'Bhebra','733208',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55265,156,'Bhelai','733129',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55266,156,'Bhendabari','733210',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55267,156,'Bhitiar','733134',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55268,156,'Bhogram','733134',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55269,156,'Bhupalpur','733143',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55270,156,'Bilashpur','733134',1,0,'2022-03-03 12:48:26','2022-03-03 12:48:26'),(55271,156,'Bindole','733156',1,0,'2022-03-03 12:48:27','2022-03-03 12:48:27'),(55272,156,'Birghai','733123',1,0,'2022-03-03 12:48:27','2022-03-03 12:48:27'),(55273,156,'BurhijagirB.O','733202',1,0,'2022-03-03 12:48:27','2022-03-03 12:48:27'),(55274,156,'Chainagar','733156',1,0,'2022-03-03 12:48:27','2022-03-03 12:48:27'),(55275,156,'Chakulia Hat','733208',1,0,'2022-03-03 12:48:27','2022-03-03 12:48:27'),(55276,156,'Chandanidanga','733207',1,0,'2022-03-03 12:48:27','2022-03-03 12:48:27'),(55277,156,'Chapore','733208',1,0,'2022-03-03 12:48:27','2022-03-03 12:48:27'),(55278,156,'Chargharia','733207',1,0,'2022-03-03 12:48:27','2022-03-03 12:48:27'),(55279,156,'Chavote','733128',1,0,'2022-03-03 12:48:27','2022-03-03 12:48:27'),(55280,156,'Chhayghara','733128',1,0,'2022-03-03 12:48:27','2022-03-03 12:48:27'),(55281,156,'Chopra','733207',1,0,'2022-03-03 12:48:27','2022-03-03 12:48:27'),(55282,156,'Churaman','733128',1,0,'2022-03-03 12:48:27','2022-03-03 12:48:27'),(55283,156,'Dadhikotbari','733130',1,0,'2022-03-03 12:48:27','2022-03-03 12:48:27'),(55284,156,'Dalimgaon','733129',1,0,'2022-03-03 12:48:27','2022-03-03 12:48:27'),(55285,156,'Dalkhola','733201',1,0,'2022-03-03 12:48:27','2022-03-03 12:48:27'),(55286,156,'Daspara','733207',1,0,'2022-03-03 12:48:27','2022-03-03 12:48:27'),(55287,156,'Debiganj','733210',1,0,'2022-03-03 12:48:27','2022-03-03 12:48:27'),(55288,156,'Debijhora','733207',1,0,'2022-03-03 12:48:27','2022-03-03 12:48:27'),(55289,156,'Debinagar','733123',1,0,'2022-03-03 12:48:27','2022-03-03 12:48:27'),(55290,156,'Dehar','733210',1,0,'2022-03-03 12:48:27','2022-03-03 12:48:27'),(55291,156,'Dhankoil Hat','733129',1,0,'2022-03-03 12:48:27','2022-03-03 12:48:27'),(55292,156,'Dhantala','733202',1,0,'2022-03-03 12:48:27','2022-03-03 12:48:27'),(55293,156,'Dighabanahat','733207',1,0,'2022-03-03 12:48:27','2022-03-03 12:48:27'),(55294,156,'Dimrulla','733202',1,0,'2022-03-03 12:48:27','2022-03-03 12:48:27'),(55295,156,'Doarin','733215',1,0,'2022-03-03 12:48:28','2022-03-03 12:48:28'),(55296,156,'Domohana','733215',1,0,'2022-03-03 12:48:28','2022-03-03 12:48:28'),(55297,156,'Dulalibhita','733202',1,0,'2022-03-03 12:48:28','2022-03-03 12:48:28'),(55298,156,'Durgapur','733121',1,0,'2022-03-03 12:48:28','2022-03-03 12:48:28'),(55299,156,'Durlavpur','733143',1,0,'2022-03-03 12:48:28','2022-03-03 12:48:28'),(55300,156,'Faridpur','733129',1,0,'2022-03-03 12:48:28','2022-03-03 12:48:28'),(55301,156,'Fatepur Hat','733132',1,0,'2022-03-03 12:48:28','2022-03-03 12:48:28'),(55302,156,'Galia','733209',1,0,'2022-03-03 12:48:28','2022-03-03 12:48:28'),(55303,156,'Gendabari','733207',1,0,'2022-03-03 12:48:28','2022-03-03 12:48:28'),(55304,156,'Gendabari','733210',1,0,'2022-03-03 12:48:28','2022-03-03 12:48:28'),(55305,156,'Gharugachh','733207',1,0,'2022-03-03 12:48:28','2022-03-03 12:48:28'),(55306,156,'Goagaon','733210',1,0,'2022-03-03 12:48:28','2022-03-03 12:48:28'),(55307,156,'Goalgoan','733208',1,0,'2022-03-03 12:48:28','2022-03-03 12:48:28'),(55308,156,'Goalin','733210',1,0,'2022-03-03 12:48:28','2022-03-03 12:48:28'),(55309,156,'Goalpokher','733210',1,0,'2022-03-03 12:48:28','2022-03-03 12:48:28'),(55310,156,'Gohara','733208',1,0,'2022-03-03 12:48:28','2022-03-03 12:48:28'),(55311,156,'Gorahar','733123',1,0,'2022-03-03 12:48:28','2022-03-03 12:48:28'),(55312,156,'Goti','733210',1,0,'2022-03-03 12:48:28','2022-03-03 12:48:28'),(55313,156,'Gulandar','733128',1,0,'2022-03-03 12:48:28','2022-03-03 12:48:28'),(55314,156,'Gunjaria Bazar','733202',1,0,'2022-03-03 12:48:28','2022-03-03 12:48:28'),(55315,156,'Haptiagachh','733202',1,0,'2022-03-03 12:48:28','2022-03-03 12:48:28'),(55316,156,'Harigram','733134',1,0,'2022-03-03 12:48:28','2022-03-03 12:48:28'),(55317,156,'Hassan','733209',1,0,'2022-03-03 12:48:28','2022-03-03 12:48:28'),(55318,156,'Hasua Samadhimath','733143',1,0,'2022-03-03 12:48:28','2022-03-03 12:48:28'),(55319,156,'Hatgachhi','733143',1,0,'2022-03-03 12:48:28','2022-03-03 12:48:28'),(55320,156,'Hatia','733123',1,0,'2022-03-03 12:48:29','2022-03-03 12:48:29'),(55321,156,'Hatkholasahapur','733210',1,0,'2022-03-03 12:48:29','2022-03-03 12:48:29'),(55322,156,'Hatwar','733209',1,0,'2022-03-03 12:48:29','2022-03-03 12:48:29'),(55323,156,'Hemtabad','733130',1,0,'2022-03-03 12:48:29','2022-03-03 12:48:29'),(55324,156,'Ikarchala','733208',1,0,'2022-03-03 12:48:29','2022-03-03 12:48:29'),(55325,156,'Industrial Market','733134',1,0,'2022-03-03 12:48:29','2022-03-03 12:48:29'),(55326,156,'Islampur Court','733202',1,0,'2022-03-03 12:48:29','2022-03-03 12:48:29'),(55327,156,'Islampur (North Dinajpur)','733202',1,0,'2022-03-03 12:48:29','2022-03-03 12:48:29'),(55328,156,'Itahar','733128',1,0,'2022-03-03 12:48:29','2022-03-03 12:48:29'),(55329,156,'Ital','733123',1,0,'2022-03-03 12:48:29','2022-03-03 12:48:29'),(55330,156,'Jagadishpur','733201',1,0,'2022-03-03 12:48:29','2022-03-03 12:48:29'),(55331,156,'Jagtagaon','733202',1,0,'2022-03-03 12:48:29','2022-03-03 12:48:29'),(55332,156,'Jharbari','733210',1,0,'2022-03-03 12:48:29','2022-03-03 12:48:29'),(55333,156,'Joyhat','733128',1,0,'2022-03-03 12:48:29','2022-03-03 12:48:29'),(55334,156,'Kaimari','733207',1,0,'2022-03-03 12:48:29','2022-03-03 12:48:29'),(55335,156,'Kalanagin','733202',1,0,'2022-03-03 12:48:29','2022-03-03 12:48:29'),(55336,156,'Kaliyaganj Collegepara','733129',1,0,'2022-03-03 12:48:29','2022-03-03 12:48:29'),(55337,156,'Kaliyaganj','733129',1,0,'2022-03-03 12:48:29','2022-03-03 12:48:29'),(55338,156,'Kamartore','733215',1,0,'2022-03-03 12:48:29','2022-03-03 12:48:29'),(55339,156,'Kamlai','733143',1,0,'2022-03-03 12:48:29','2022-03-03 12:48:29'),(55340,156,'Kaniabhita','733208',1,0,'2022-03-03 12:48:29','2022-03-03 12:48:29'),(55341,156,'Kanki','733209',1,0,'2022-03-03 12:48:29','2022-03-03 12:48:29'),(55342,156,'Kantore','733156',1,0,'2022-03-03 12:48:29','2022-03-03 12:48:29'),(55343,156,'Kapasia','733128',1,0,'2022-03-03 12:48:29','2022-03-03 12:48:29'),(55344,156,'Karandighi','733215',1,0,'2022-03-03 12:48:29','2022-03-03 12:48:29'),(55345,156,'Karnojora','733130',1,0,'2022-03-03 12:48:30','2022-03-03 12:48:30'),(55346,156,'Keotal','733123',1,0,'2022-03-03 12:48:30','2022-03-03 12:48:30'),(55347,156,'Khagore','733210',1,0,'2022-03-03 12:48:30','2022-03-03 12:48:30'),(55348,156,'Khalshi','733134',1,0,'2022-03-03 12:48:30','2022-03-03 12:48:30'),(55349,156,'Khikirtola','733208',1,0,'2022-03-03 12:48:30','2022-03-03 12:48:30'),(55350,156,'Khokshan','733156',1,0,'2022-03-03 12:48:30','2022-03-03 12:48:30'),(55351,156,'Khunia','733207',1,0,'2022-03-03 12:48:30','2022-03-03 12:48:30'),(55352,156,'Khunti','733202',1,0,'2022-03-03 12:48:30','2022-03-03 12:48:30'),(55353,156,'Khurka','733201',1,0,'2022-03-03 12:48:30','2022-03-03 12:48:30'),(55354,156,'Kichaktola','733210',1,0,'2022-03-03 12:48:30','2022-03-03 12:48:30'),(55355,156,'Kodaldaha','733202',1,0,'2022-03-03 12:48:30','2022-03-03 12:48:30'),(55356,156,'Krishnabati','733129',1,0,'2022-03-03 12:48:30','2022-03-03 12:48:30'),(55357,156,'Kuchilagoan','733207',1,0,'2022-03-03 12:48:30','2022-03-03 12:48:30'),(55358,156,'Kunor','733129',1,0,'2022-03-03 12:48:30','2022-03-03 12:48:30'),(55359,156,'Lakshipur','733207',1,0,'2022-03-03 12:48:30','2022-03-03 12:48:30'),(55360,156,'Lalganj','733201',1,0,'2022-03-03 12:48:30','2022-03-03 12:48:30'),(55361,156,'Lalkuri','733210',1,0,'2022-03-03 12:48:30','2022-03-03 12:48:30'),(55362,156,'Larukhoa Gobindapur','733202',1,0,'2022-03-03 12:48:30','2022-03-03 12:48:30'),(55363,156,'Laxmonia','733156',1,0,'2022-03-03 12:48:30','2022-03-03 12:48:30'),(55364,156,'Lohanda','733134',1,0,'2022-03-03 12:48:30','2022-03-03 12:48:30'),(55365,156,'Madargachhi','733215',1,0,'2022-03-03 12:48:30','2022-03-03 12:48:30'),(55366,156,'Madhabpur','733129',1,0,'2022-03-03 12:48:30','2022-03-03 12:48:30'),(55367,156,'Madhupur Barduari','733134',1,0,'2022-03-03 12:48:30','2022-03-03 12:48:30'),(55368,156,'Magnavita','733201',1,0,'2022-03-03 12:48:30','2022-03-03 12:48:30'),(55369,156,'Maharajahat','733156',1,0,'2022-03-03 12:48:30','2022-03-03 12:48:30'),(55370,156,'Mahendraganj (North Dinajpur)','733129',1,0,'2022-03-03 12:48:31','2022-03-03 12:48:31'),(55371,156,'Maheshpur','733201',1,0,'2022-03-03 12:48:31','2022-03-03 12:48:31'),(55372,156,'Majhihar','733132',1,0,'2022-03-03 12:48:31','2022-03-03 12:48:31'),(55373,156,'Majlishpur','733209',1,0,'2022-03-03 12:48:31','2022-03-03 12:48:31'),(55374,156,'Malgaon','733129',1,0,'2022-03-03 12:48:31','2022-03-03 12:48:31'),(55375,156,'Malkunda','733210',1,0,'2022-03-03 12:48:31','2022-03-03 12:48:31'),(55376,156,'Manikpur','733207',1,0,'2022-03-03 12:48:31','2022-03-03 12:48:31'),(55377,156,'Manoharpur','733129',1,0,'2022-03-03 12:48:31','2022-03-03 12:48:31'),(55378,156,'Marnai','733128',1,0,'2022-03-03 12:48:31','2022-03-03 12:48:31'),(55379,156,'Matikundahat','733202',1,0,'2022-03-03 12:48:31','2022-03-03 12:48:31'),(55380,156,'Mirual','733130',1,0,'2022-03-03 12:48:31','2022-03-03 12:48:31'),(55381,156,'Mohanbati','733134',1,0,'2022-03-03 12:48:31','2022-03-03 12:48:31'),(55382,156,'Molani','733207',1,0,'2022-03-03 12:48:31','2022-03-03 12:48:31'),(55383,156,'Monora','733209',1,0,'2022-03-03 12:48:31','2022-03-03 12:48:31'),(55384,156,'Mudafat','733129',1,0,'2022-03-03 12:48:31','2022-03-03 12:48:31'),(55385,156,'Nando','733208',1,0,'2022-03-03 12:48:31','2022-03-03 12:48:31'),(55386,156,'Narayanpur','733207',1,0,'2022-03-03 12:48:31','2022-03-03 12:48:31'),(55387,156,'Nizampur','733209',1,0,'2022-03-03 12:48:31','2022-03-03 12:48:31'),(55388,156,'Nomunia','733128',1,0,'2022-03-03 12:48:31','2022-03-03 12:48:31'),(55389,156,'Panchbhaya','733156',1,0,'2022-03-03 12:48:31','2022-03-03 12:48:31'),(55390,156,'Panchdimthi','733202',1,0,'2022-03-03 12:48:31','2022-03-03 12:48:31'),(55391,156,'Panishalahat','733134',1,0,'2022-03-03 12:48:31','2022-03-03 12:48:31'),(55392,156,'Panjipara','733208',1,0,'2022-03-03 12:48:31','2022-03-03 12:48:31'),(55393,156,'Paraharipur','733143',1,0,'2022-03-03 12:48:32','2022-03-03 12:48:32'),(55394,156,'Parbatipur','733143',1,0,'2022-03-03 12:48:32','2022-03-03 12:48:32'),(55395,156,'Parergram','733143',1,0,'2022-03-03 12:48:32','2022-03-03 12:48:32'),(55396,156,'Paschim Manoharpur','733123',1,0,'2022-03-03 12:48:32','2022-03-03 12:48:32'),(55397,156,'Patirajpur','733128',1,0,'2022-03-03 12:48:32','2022-03-03 12:48:32'),(55398,156,'Patnaur','733201',1,0,'2022-03-03 12:48:32','2022-03-03 12:48:32'),(55399,156,'Pokhoria','733208',1,0,'2022-03-03 12:48:32','2022-03-03 12:48:32'),(55400,156,'Puria','733129',1,0,'2022-03-03 12:48:32','2022-03-03 12:48:32'),(55401,156,'Radha Nagar','733129',1,0,'2022-03-03 12:48:32','2022-03-03 12:48:32'),(55402,156,'Radhanagar','733128',1,0,'2022-03-03 12:48:32','2022-03-03 12:48:32'),(55403,156,'Raghunathpur','733129',1,0,'2022-03-03 12:48:32','2022-03-03 12:48:32'),(55404,156,'Raiganj Bandar','733134',1,0,'2022-03-03 12:48:32','2022-03-03 12:48:32'),(55405,156,'Raiganj','733134',1,0,'2022-03-03 12:48:32','2022-03-03 12:48:32'),(55406,156,'Raiganj Town','733134',1,0,'2022-03-03 12:48:32','2022-03-03 12:48:32'),(55407,156,'Raipur','733134',1,0,'2022-03-03 12:48:32','2022-03-03 12:48:32'),(55408,156,'Ramganj (North Dinajpur)','733207',1,0,'2022-03-03 12:48:32','2022-03-03 12:48:32'),(55409,156,'Rashbehari Market','733134',1,0,'2022-03-03 12:48:32','2022-03-03 12:48:32'),(55410,156,'Rashokhowahat','733201',1,0,'2022-03-03 12:48:32','2022-03-03 12:48:32'),(55411,156,'Runia','733134',1,0,'2022-03-03 12:48:32','2022-03-03 12:48:32'),(55412,156,'Rupahar','733123',1,0,'2022-03-03 12:48:32','2022-03-03 12:48:32'),(55413,156,'Sahapur','733210',1,0,'2022-03-03 12:48:32','2022-03-03 12:48:32'),(55414,156,'Sakuntala','733208',1,0,'2022-03-03 12:48:32','2022-03-03 12:48:32'),(55415,156,'Samaspur','733134',1,0,'2022-03-03 12:48:32','2022-03-03 12:48:32'),(55416,156,'Sandhiya','733125',1,0,'2022-03-03 12:48:33','2022-03-03 12:48:33'),(55417,156,'Sasan','733134',1,0,'2022-03-03 12:48:33','2022-03-03 12:48:33'),(55418,156,'Sawdhan','733215',1,0,'2022-03-03 12:48:33','2022-03-03 12:48:33'),(55419,156,'Sayedpur Bhamantali','733209',1,0,'2022-03-03 12:48:33','2022-03-03 12:48:33'),(55420,156,'Shikarpur','733201',1,0,'2022-03-03 12:48:33','2022-03-03 12:48:33'),(55421,156,'Simalia','733209',1,0,'2022-03-03 12:48:33','2022-03-03 12:48:33'),(55422,156,'Solpara','733210',1,0,'2022-03-03 12:48:33','2022-03-03 12:48:33'),(55423,156,'Sonapur','733143',1,0,'2022-03-03 12:48:33','2022-03-03 12:48:33'),(55424,156,'Sonapur Hat','733202',1,0,'2022-03-03 12:48:33','2022-03-03 12:48:33'),(55425,156,'Srikrishnapur Colony','733202',1,0,'2022-03-03 12:48:33','2022-03-03 12:48:33'),(55426,156,'Sripur','733201',1,0,'2022-03-03 12:48:33','2022-03-03 12:48:33'),(55427,156,'State Farm Colony','733202',1,0,'2022-03-03 12:48:33','2022-03-03 12:48:33'),(55428,156,'Subhashganj','733134',1,0,'2022-03-03 12:48:33','2022-03-03 12:48:33'),(55429,156,'Sudarshanpur','733134',1,0,'2022-03-03 12:48:33','2022-03-03 12:48:33'),(55430,156,'Sujali','733207',1,0,'2022-03-03 12:48:33','2022-03-03 12:48:33'),(55431,156,'Surjapur','733209',1,0,'2022-03-03 12:48:33','2022-03-03 12:48:33'),(55432,156,'Taherpur','733134',1,0,'2022-03-03 12:48:33','2022-03-03 12:48:33'),(55433,156,'Tamchari Mathbari','733129',1,0,'2022-03-03 12:48:33','2022-03-03 12:48:33'),(55434,156,'Tarangapur','733129',1,0,'2022-03-03 12:48:33','2022-03-03 12:48:33'),(55435,156,'Tarial','733208',1,0,'2022-03-03 12:48:33','2022-03-03 12:48:33'),(55436,156,'Tenohari','733123',1,0,'2022-03-03 12:48:33','2022-03-03 12:48:33'),(55437,156,'Thakurbari','733208',1,0,'2022-03-03 12:48:33','2022-03-03 12:48:33'),(55438,156,'Tilna','733128',1,0,'2022-03-03 12:48:33','2022-03-03 12:48:33'),(55439,156,'Tungail Bilpara','733129',1,0,'2022-03-03 12:48:33','2022-03-03 12:48:33'),(55440,156,'Tungidighi','733215',1,0,'2022-03-03 12:48:33','2022-03-03 12:48:33'),(55441,157,'Achkoda','723145',1,0,'2022-03-03 12:48:34','2022-03-03 12:48:34'),(55442,157,'Adra Market','723121',1,0,'2022-03-03 12:48:34','2022-03-03 12:48:34'),(55443,157,'Adra','723121',1,0,'2022-03-03 12:48:34','2022-03-03 12:48:34'),(55444,157,'Agaibari','723133',1,0,'2022-03-03 12:48:34','2022-03-03 12:48:34'),(55445,157,'Agaibil','723129',1,0,'2022-03-03 12:48:34','2022-03-03 12:48:34'),(55446,157,'Agardih','723130',1,0,'2022-03-03 12:48:34','2022-03-03 12:48:34'),(55447,157,'Aharrah','723154',1,0,'2022-03-03 12:48:34','2022-03-03 12:48:34'),(55448,157,'Ajodhya Hill','723152',1,0,'2022-03-03 12:48:34','2022-03-03 12:48:34'),(55449,157,'Alangidanga','723101',1,0,'2022-03-03 12:48:34','2022-03-03 12:48:34'),(55450,157,'Amrabera','723127',1,0,'2022-03-03 12:48:34','2022-03-03 12:48:34'),(55451,157,'Anaijambad','723148',1,0,'2022-03-03 12:48:34','2022-03-03 12:48:34'),(55452,157,'Anara','723126',1,0,'2022-03-03 12:48:34','2022-03-03 12:48:34'),(55453,157,'Anara RS','723126',1,0,'2022-03-03 12:48:34','2022-03-03 12:48:34'),(55454,157,'Ankro','723129',1,0,'2022-03-03 12:48:34','2022-03-03 12:48:34'),(55455,157,'Arjunjora','723148',1,0,'2022-03-03 12:48:34','2022-03-03 12:48:34'),(55456,157,'Arrah','723121',1,0,'2022-03-03 12:48:34','2022-03-03 12:48:34'),(55457,157,'Arsha','723201',1,0,'2022-03-03 12:48:34','2022-03-03 12:48:34'),(55458,157,'Atna','723212',1,0,'2022-03-03 12:48:34','2022-03-03 12:48:34'),(55459,157,'Babugram','723133',1,0,'2022-03-03 12:48:34','2022-03-03 12:48:34'),(55460,157,'Badaldih','723127',1,0,'2022-03-03 12:48:34','2022-03-03 12:48:34'),(55461,157,'Badra','723151',1,0,'2022-03-03 12:48:34','2022-03-03 12:48:34'),(55462,157,'Bagalia','723126',1,0,'2022-03-03 12:48:34','2022-03-03 12:48:34'),(55463,157,'Bagalmari','723147',1,0,'2022-03-03 12:48:34','2022-03-03 12:48:34'),(55464,157,'Bagbinda','723202',1,0,'2022-03-03 12:48:34','2022-03-03 12:48:34'),(55465,157,'Bagda','723151',1,0,'2022-03-03 12:48:35','2022-03-03 12:48:35'),(55466,157,'Bagdisha','723148',1,0,'2022-03-03 12:48:35','2022-03-03 12:48:35'),(55467,157,'Baghra','723147',1,0,'2022-03-03 12:48:35','2022-03-03 12:48:35'),(55468,157,'Baglata','723215',1,0,'2022-03-03 12:48:35','2022-03-03 12:48:35'),(55469,157,'Bagmundi','723152',1,0,'2022-03-03 12:48:35','2022-03-03 12:48:35'),(55470,157,'Bahara','723146',1,0,'2022-03-03 12:48:35','2022-03-03 12:48:35'),(55471,157,'Balakdih','723128',1,0,'2022-03-03 12:48:35','2022-03-03 12:48:35'),(55472,157,'Baligara','723149',1,0,'2022-03-03 12:48:35','2022-03-03 12:48:35'),(55473,157,'Bamni','723213',1,0,'2022-03-03 12:48:35','2022-03-03 12:48:35'),(55474,157,'Bamnia','723213',1,0,'2022-03-03 12:48:35','2022-03-03 12:48:35'),(55475,157,'Bamundiha','723127',1,0,'2022-03-03 12:48:35','2022-03-03 12:48:35'),(55476,157,'Banbahal','723127',1,0,'2022-03-03 12:48:35','2022-03-03 12:48:35'),(55477,157,'Banbaligara','723148',1,0,'2022-03-03 12:48:35','2022-03-03 12:48:35'),(55478,157,'Banjora','723148',1,0,'2022-03-03 12:48:35','2022-03-03 12:48:35'),(55479,157,'Bansa','723128',1,0,'2022-03-03 12:48:35','2022-03-03 12:48:35'),(55480,157,'Bansraya','723132',1,0,'2022-03-03 12:48:35','2022-03-03 12:48:35'),(55481,157,'Bara Urma','723153',1,0,'2022-03-03 12:48:35','2022-03-03 12:48:35'),(55482,157,'Barabendya','723201',1,0,'2022-03-03 12:48:35','2022-03-03 12:48:35'),(55483,157,'Barabhum','723127',1,0,'2022-03-03 12:48:35','2022-03-03 12:48:35'),(55484,157,'Baragram','723103',1,0,'2022-03-03 12:48:35','2022-03-03 12:48:35'),(55485,157,'Barakadam','723129',1,0,'2022-03-03 12:48:35','2022-03-03 12:48:35'),(55486,157,'Barametyala','723201',1,0,'2022-03-03 12:48:35','2022-03-03 12:48:35'),(55487,157,'Bararola','723213',1,0,'2022-03-03 12:48:35','2022-03-03 12:48:35'),(55488,157,'Bargoria','723131',1,0,'2022-03-03 12:48:35','2022-03-03 12:48:35'),(55489,157,'Bargoria','723161',1,0,'2022-03-03 12:48:35','2022-03-03 12:48:35'),(55490,157,'Bari','723131',1,0,'2022-03-03 12:48:35','2022-03-03 12:48:35'),(55491,157,'Barrah','723145',1,0,'2022-03-03 12:48:36','2022-03-03 12:48:36'),(55492,157,'Batikara','723128',1,0,'2022-03-03 12:48:36','2022-03-03 12:48:36'),(55493,157,'Begunkodar','723202',1,0,'2022-03-03 12:48:36','2022-03-03 12:48:36'),(55494,157,'Beko','723121',1,0,'2022-03-03 12:48:36','2022-03-03 12:48:36'),(55495,157,'Beldih','723102',1,0,'2022-03-03 12:48:36','2022-03-03 12:48:36'),(55496,157,'Belgoria','723131',1,0,'2022-03-03 12:48:36','2022-03-03 12:48:36'),(55497,157,'Belkuri','723149',1,0,'2022-03-03 12:48:36','2022-03-03 12:48:36'),(55498,157,'Belma','723126',1,0,'2022-03-03 12:48:36','2022-03-03 12:48:36'),(55499,157,'Berada','723143',1,0,'2022-03-03 12:48:36','2022-03-03 12:48:36'),(55500,157,'Bhabanipur','723143',1,0,'2022-03-03 12:48:36','2022-03-03 12:48:36'),(55501,157,'Bhagabandh','723151',1,0,'2022-03-03 12:48:36','2022-03-03 12:48:36'),(55502,157,'Bhamuria','723121',1,0,'2022-03-03 12:48:36','2022-03-03 12:48:36'),(55503,157,'Bhandarpuara','723101',1,0,'2022-03-03 12:48:36','2022-03-03 12:48:36'),(55504,157,'Bhangra','723148',1,0,'2022-03-03 12:48:36','2022-03-03 12:48:36'),(55505,157,'Bhawridih','723155',1,0,'2022-03-03 12:48:36','2022-03-03 12:48:36'),(55506,157,'Bhikari Chelyama','723143',1,0,'2022-03-03 12:48:36','2022-03-03 12:48:36'),(55507,157,'Bhul','723103',1,0,'2022-03-03 12:48:36','2022-03-03 12:48:36'),(55508,157,'Bhurkundabari','723133',1,0,'2022-03-03 12:48:36','2022-03-03 12:48:36'),(55509,157,'Bhutam','723151',1,0,'2022-03-03 12:48:36','2022-03-03 12:48:36'),(55510,157,'Bijoydih','723128',1,0,'2022-03-03 12:48:36','2022-03-03 12:48:36'),(55511,157,'Biltora','723126',1,0,'2022-03-03 12:48:36','2022-03-03 12:48:36'),(55512,157,'Biramdih','723143',1,0,'2022-03-03 12:48:36','2022-03-03 12:48:36'),(55513,157,'Birgram','723152',1,0,'2022-03-03 12:48:36','2022-03-03 12:48:36'),(55514,157,'Bishpuria','723130',1,0,'2022-03-03 12:48:36','2022-03-03 12:48:36'),(55515,157,'Bishri','723131',1,0,'2022-03-03 12:48:36','2022-03-03 12:48:36'),(55516,157,'Bogra','723161',1,0,'2022-03-03 12:48:37','2022-03-03 12:48:37'),(55517,157,'Bonra','723131',1,0,'2022-03-03 12:48:37','2022-03-03 12:48:37'),(55518,157,'Boro','723131',1,0,'2022-03-03 12:48:37','2022-03-03 12:48:37'),(55519,157,'Bortoria','723121',1,0,'2022-03-03 12:48:37','2022-03-03 12:48:37'),(55520,157,'Brajapur','723202',1,0,'2022-03-03 12:48:37','2022-03-03 12:48:37'),(55521,157,'Bundwan','723129',1,0,'2022-03-03 12:48:37','2022-03-03 12:48:37'),(55522,157,'Bundwan Uttar','723128',1,0,'2022-03-03 12:48:37','2022-03-03 12:48:37'),(55523,157,'Burda','723152',1,0,'2022-03-03 12:48:37','2022-03-03 12:48:37'),(55524,157,'Chainpur','723149',1,0,'2022-03-03 12:48:37','2022-03-03 12:48:37'),(55525,157,'Chakalta','723130',1,0,'2022-03-03 12:48:37','2022-03-03 12:48:37'),(55526,157,'Chakaltore','723101',1,0,'2022-03-03 12:48:37','2022-03-03 12:48:37'),(55527,157,'Chakirbon','723102',1,0,'2022-03-03 12:48:37','2022-03-03 12:48:37'),(55528,157,'Chakra','723149',1,0,'2022-03-03 12:48:37','2022-03-03 12:48:37'),(55529,157,'Chalmara Puapur','723121',1,0,'2022-03-03 12:48:37','2022-03-03 12:48:37'),(55530,157,'Chanchra','723148',1,0,'2022-03-03 12:48:37','2022-03-03 12:48:37'),(55531,157,'Chandra','723128',1,0,'2022-03-03 12:48:37','2022-03-03 12:48:37'),(55532,157,'Chapaitard','723201',1,0,'2022-03-03 12:48:37','2022-03-03 12:48:37'),(55533,157,'Chapri','723121',1,0,'2022-03-03 12:48:37','2022-03-03 12:48:37'),(55534,157,'Charida','723152',1,0,'2022-03-03 12:48:37','2022-03-03 12:48:37'),(55535,157,'Chatuhansa','723153',1,0,'2022-03-03 12:48:37','2022-03-03 12:48:37'),(55536,157,'Chatumadar','723130',1,0,'2022-03-03 12:48:37','2022-03-03 12:48:37'),(55537,157,'Chaturmohal','723152',1,0,'2022-03-03 12:48:37','2022-03-03 12:48:37'),(55538,157,'Chekya','723202',1,0,'2022-03-03 12:48:37','2022-03-03 12:48:37'),(55539,157,'Chelyama','723146',1,0,'2022-03-03 12:48:38','2022-03-03 12:48:38'),(55540,157,'Chepra','723148',1,0,'2022-03-03 12:48:38','2022-03-03 12:48:38'),(55541,157,'Chharrah','723147',1,0,'2022-03-03 12:48:38','2022-03-03 12:48:38'),(55542,157,'Chhirudi Chandanpur','723130',1,0,'2022-03-03 12:48:38','2022-03-03 12:48:38'),(55543,157,'Chhirudi Radhanagar','723129',1,0,'2022-03-03 12:48:38','2022-03-03 12:48:38'),(55544,157,'Chhota Sagan','723131',1,0,'2022-03-03 12:48:38','2022-03-03 12:48:38'),(55545,157,'Chirka','723103',1,0,'2022-03-03 12:48:38','2022-03-03 12:48:38'),(55546,157,'Chitmu','723215',1,0,'2022-03-03 12:48:38','2022-03-03 12:48:38'),(55547,157,'Chitora','723101',1,0,'2022-03-03 12:48:38','2022-03-03 12:48:38'),(55548,157,'Chitra','723155',1,0,'2022-03-03 12:48:38','2022-03-03 12:48:38'),(55549,157,'Chorpahari','723121',1,0,'2022-03-03 12:48:38','2022-03-03 12:48:38'),(55550,157,'Choutala Bhagabandh','723126',1,0,'2022-03-03 12:48:38','2022-03-03 12:48:38'),(55551,157,'Chowkbazar (Puruliya)','723101',1,0,'2022-03-03 12:48:38','2022-03-03 12:48:38'),(55552,157,'Chowkibera','723215',1,0,'2022-03-03 12:48:38','2022-03-03 12:48:38'),(55553,157,'Chuna','723126',1,0,'2022-03-03 12:48:38','2022-03-03 12:48:38'),(55554,157,'Dabar Balarampur','723103',1,0,'2022-03-03 12:48:38','2022-03-03 12:48:38'),(55555,157,'Daldali','723130',1,0,'2022-03-03 12:48:38','2022-03-03 12:48:38'),(55556,157,'Damankiary','723132',1,0,'2022-03-03 12:48:38','2022-03-03 12:48:38'),(55557,157,'Damda','723128',1,0,'2022-03-03 12:48:38','2022-03-03 12:48:38'),(55558,157,'Dangardih','723131',1,0,'2022-03-03 12:48:38','2022-03-03 12:48:38'),(55559,157,'Dapang','723148',1,0,'2022-03-03 12:48:38','2022-03-03 12:48:38'),(55560,157,'Darpa','723212',1,0,'2022-03-03 12:48:38','2022-03-03 12:48:38'),(55561,157,'Dava Torang','723152',1,0,'2022-03-03 12:48:38','2022-03-03 12:48:38'),(55562,157,'Deoli','723146',1,0,'2022-03-03 12:48:38','2022-03-03 12:48:38'),(55563,157,'Deshra','723128',1,0,'2022-03-03 12:48:38','2022-03-03 12:48:38'),(55564,157,'Dhabani','723130',1,0,'2022-03-03 12:48:38','2022-03-03 12:48:38'),(55565,157,'Dhabani Radhamohanpur','723130',1,0,'2022-03-03 12:48:39','2022-03-03 12:48:39'),(55566,157,'Dhadka','723129',1,0,'2022-03-03 12:48:39','2022-03-03 12:48:39'),(55567,157,'Dhadkidih','723127',1,0,'2022-03-03 12:48:39','2022-03-03 12:48:39'),(55568,157,'Dhagora','723131',1,0,'2022-03-03 12:48:39','2022-03-03 12:48:39'),(55569,157,'Dhakakendu','723128',1,0,'2022-03-03 12:48:39','2022-03-03 12:48:39'),(55570,157,'Dhanudih','723143',1,0,'2022-03-03 12:48:39','2022-03-03 12:48:39'),(55571,157,'Dhelat Bamu','723127',1,0,'2022-03-03 12:48:39','2022-03-03 12:48:39'),(55572,157,'Dhengakend','723128',1,0,'2022-03-03 12:48:39','2022-03-03 12:48:39'),(55573,157,'Digha','723121',1,0,'2022-03-03 12:48:39','2022-03-03 12:48:39'),(55574,157,'Dighi','723131',1,0,'2022-03-03 12:48:39','2022-03-03 12:48:39'),(55575,157,'Dimdiha','723103',1,0,'2022-03-03 12:48:39','2022-03-03 12:48:39'),(55576,157,'Dorodih','723101',1,0,'2022-03-03 12:48:39','2022-03-03 12:48:39'),(55577,157,'Dubra','723155',1,0,'2022-03-03 12:48:39','2022-03-03 12:48:39'),(55578,157,'Dulmi-nadiha','723102',1,0,'2022-03-03 12:48:39','2022-03-03 12:48:39'),(55579,157,'Dumdumi','723147',1,0,'2022-03-03 12:48:39','2022-03-03 12:48:39'),(55580,157,'Dumru','723213',1,0,'2022-03-03 12:48:39','2022-03-03 12:48:39'),(55581,157,'Dumurdih','723127',1,0,'2022-03-03 12:48:39','2022-03-03 12:48:39'),(55582,157,'Durgi','723202',1,0,'2022-03-03 12:48:39','2022-03-03 12:48:39'),(55583,157,'Durku','723102',1,0,'2022-03-03 12:48:39','2022-03-03 12:48:39'),(55584,157,'Durma','723201',1,0,'2022-03-03 12:48:39','2022-03-03 12:48:39'),(55585,157,'Ekra','723143',1,0,'2022-03-03 12:48:39','2022-03-03 12:48:39'),(55586,157,'Fatepur Sindri','723127',1,0,'2022-03-03 12:48:39','2022-03-03 12:48:39'),(55587,157,'Fuljhore','723127',1,0,'2022-03-03 12:48:39','2022-03-03 12:48:39'),(55588,157,'Fushrabad','723126',1,0,'2022-03-03 12:48:39','2022-03-03 12:48:39'),(55589,157,'Gagi','723212',1,0,'2022-03-03 12:48:39','2022-03-03 12:48:39'),(55590,157,'Gagnabad','723121',1,0,'2022-03-03 12:48:39','2022-03-03 12:48:39'),(55591,157,'Gamarkuri','723132',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55592,157,'Gangamanna','723129',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55593,157,'Garafushra','723103',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55594,157,'Garjaipur','723201',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55595,157,'Gengara','723103',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55596,157,'Gerua','723143',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55597,157,'Ghagarjuri','723103',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55598,157,'Ghagra','723213',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55599,157,'Ghanga','723149',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55600,157,'Ghatbera','723152',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55601,157,'Ghatrangamati','723121',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55602,157,'Gholkurd','723151',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55603,157,'Ghorabandha Sindri','723152',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55604,157,'Gobindapur','723101',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55605,157,'Godibera','723133',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55606,157,'Golamara','723147',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55607,157,'Golbera','723103',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55608,157,'Gopalnagar','723128',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55609,157,'Gopalpur','723151',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55610,157,'Goria','723202',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55611,157,'Gorsika','723133',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55612,157,'Gourangdih','723121',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55613,157,'Gunera','723133',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55614,157,'Hadalda','723130',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55615,157,'Haramjanga','723148',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55616,157,'Hargara','723201',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55617,157,'Hatikundar','723101',1,0,'2022-03-03 12:48:40','2022-03-03 12:48:40'),(55618,157,'Hatimuri','723201',1,0,'2022-03-03 12:48:41','2022-03-03 12:48:41'),(55619,157,'Hensahatu','723202',1,0,'2022-03-03 12:48:41','2022-03-03 12:48:41'),(55620,157,'Hensla','723154',1,0,'2022-03-03 12:48:41','2022-03-03 12:48:41'),(55621,157,'Herbona','723127',1,0,'2022-03-03 12:48:41','2022-03-03 12:48:41'),(55622,157,'Hetgugui','723202',1,0,'2022-03-03 12:48:41','2022-03-03 12:48:41'),(55623,157,'Hetyakole','723129',1,0,'2022-03-03 12:48:41','2022-03-03 12:48:41'),(55624,157,'Hinjuri Shyampur','723201',1,0,'2022-03-03 12:48:41','2022-03-03 12:48:41'),(55625,157,'Hizla','723127',1,0,'2022-03-03 12:48:41','2022-03-03 12:48:41'),(55626,157,'Hura Keshabpur','723101',1,0,'2022-03-03 12:48:41','2022-03-03 12:48:41'),(55627,157,'Hura (Puruliya)','723130',1,0,'2022-03-03 12:48:41','2022-03-03 12:48:41'),(55628,157,'Hurumda','723152',1,0,'2022-03-03 12:48:41','2022-03-03 12:48:41'),(55629,157,'Hutmura','723148',1,0,'2022-03-03 12:48:41','2022-03-03 12:48:41'),(55630,157,'Ichag','723202',1,0,'2022-03-03 12:48:41','2022-03-03 12:48:41'),(55631,157,'Ichhar','723145',1,0,'2022-03-03 12:48:41','2022-03-03 12:48:41'),(55632,157,'Iloo','723212',1,0,'2022-03-03 12:48:41','2022-03-03 12:48:41'),(55633,157,'Jabarrah','723101',1,0,'2022-03-03 12:48:41','2022-03-03 12:48:41'),(55634,157,'Jabla','723128',1,0,'2022-03-03 12:48:41','2022-03-03 12:48:41'),(55635,157,'Jalika','723126',1,0,'2022-03-03 12:48:41','2022-03-03 12:48:41'),(55636,157,'Jambad','723128',1,0,'2022-03-03 12:48:41','2022-03-03 12:48:41'),(55637,157,'Jamtoria','723131',1,0,'2022-03-03 12:48:41','2022-03-03 12:48:41'),(55638,157,'Jangidiri','723128',1,0,'2022-03-03 12:48:41','2022-03-03 12:48:41'),(55639,157,'Jargo','723212',1,0,'2022-03-03 12:48:41','2022-03-03 12:48:41'),(55640,157,'Jawrah','723131',1,0,'2022-03-03 12:48:41','2022-03-03 12:48:41'),(55641,157,'Jhalda','723202',1,0,'2022-03-03 12:48:41','2022-03-03 12:48:41'),(55642,157,'Jhapra','723126',1,0,'2022-03-03 12:48:41','2022-03-03 12:48:41'),(55643,157,'Jharbagda','723131',1,0,'2022-03-03 12:48:41','2022-03-03 12:48:41'),(55644,157,'Jhunjka','723154',1,0,'2022-03-03 12:48:42','2022-03-03 12:48:42'),(55645,157,'Jilling','723127',1,0,'2022-03-03 12:48:42','2022-03-03 12:48:42'),(55646,157,'Jitan','723129',1,0,'2022-03-03 12:48:42','2022-03-03 12:48:42'),(55647,157,'Jitujuri','723128',1,0,'2022-03-03 12:48:42','2022-03-03 12:48:42'),(55648,157,'Jiudaru','723213',1,0,'2022-03-03 12:48:42','2022-03-03 12:48:42'),(55649,157,'Jorabari','723131',1,0,'2022-03-03 12:48:42','2022-03-03 12:48:42'),(55650,157,'Joradih','723145',1,0,'2022-03-03 12:48:42','2022-03-03 12:48:42'),(55651,157,'Jorberia','723126',1,0,'2022-03-03 12:48:42','2022-03-03 12:48:42'),(55652,157,'Jubli Compound','723101',1,0,'2022-03-03 12:48:42','2022-03-03 12:48:42'),(55653,157,'Kadampur','723201',1,0,'2022-03-03 12:48:42','2022-03-03 12:48:42'),(55654,157,'Kalajore','723126',1,0,'2022-03-03 12:48:42','2022-03-03 12:48:42'),(55655,157,'Kalapathar (PuruliB.O','723121',1,0,'2022-03-03 12:48:42','2022-03-03 12:48:42'),(55656,157,'Kaliabasa','723130',1,0,'2022-03-03 12:48:42','2022-03-03 12:48:42'),(55657,157,'Kalidaha','723212',1,0,'2022-03-03 12:48:42','2022-03-03 12:48:42'),(55658,157,'Kalidaha','723121',1,0,'2022-03-03 12:48:42','2022-03-03 12:48:42'),(55659,157,'Kalma','723202',1,0,'2022-03-03 12:48:42','2022-03-03 12:48:42'),(55660,157,'Kaluhar','723126',1,0,'2022-03-03 12:48:42','2022-03-03 12:48:42'),(55661,157,'Kanali','723103',1,0,'2022-03-03 12:48:42','2022-03-03 12:48:42'),(55662,157,'Kantadih','723153',1,0,'2022-03-03 12:48:42','2022-03-03 12:48:42'),(55663,157,'Karkara','723213',1,0,'2022-03-03 12:48:42','2022-03-03 12:48:42'),(55664,157,'Karmadih','723212',1,0,'2022-03-03 12:48:42','2022-03-03 12:48:42'),(55665,157,'Karmatard','723213',1,0,'2022-03-03 12:48:42','2022-03-03 12:48:42'),(55666,157,'Kashidih','723131',1,0,'2022-03-03 12:48:42','2022-03-03 12:48:42'),(55667,157,'Ketika','723102',1,0,'2022-03-03 12:48:42','2022-03-03 12:48:42'),(55668,157,'Khairipihira','723101',1,0,'2022-03-03 12:48:42','2022-03-03 12:48:42'),(55669,157,'Khairipihira Rangadih','723148',1,0,'2022-03-03 12:48:42','2022-03-03 12:48:42'),(55670,157,'Khamar','723202',1,0,'2022-03-03 12:48:43','2022-03-03 12:48:43'),(55671,157,'Khatanga','723213',1,0,'2022-03-03 12:48:43','2022-03-03 12:48:43'),(55672,157,'Khiriduara','723131',1,0,'2022-03-03 12:48:43','2022-03-03 12:48:43'),(55673,157,'Kochahatu','723213',1,0,'2022-03-03 12:48:43','2022-03-03 12:48:43'),(55674,157,'Kolaboni','723101',1,0,'2022-03-03 12:48:43','2022-03-03 12:48:43'),(55675,157,'Konapara','723128',1,0,'2022-03-03 12:48:43','2022-03-03 12:48:43'),(55676,157,'Koreng','723152',1,0,'2022-03-03 12:48:43','2022-03-03 12:48:43'),(55677,157,'Kotloi','723102',1,0,'2022-03-03 12:48:43','2022-03-03 12:48:43'),(55678,157,'Kuda','723128',1,0,'2022-03-03 12:48:43','2022-03-03 12:48:43'),(55679,157,'Kudlung','723148',1,0,'2022-03-03 12:48:43','2022-03-03 12:48:43'),(55680,157,'Kuilapal','723129',1,0,'2022-03-03 12:48:43','2022-03-03 12:48:43'),(55681,157,'Kukurgoria','723149',1,0,'2022-03-03 12:48:43','2022-03-03 12:48:43'),(55682,157,'Kulabahal','723148',1,0,'2022-03-03 12:48:43','2022-03-03 12:48:43'),(55683,157,'Kulgora','723148',1,0,'2022-03-03 12:48:43','2022-03-03 12:48:43'),(55684,157,'Kumari','723131',1,0,'2022-03-03 12:48:43','2022-03-03 12:48:43'),(55685,157,'Kumra','723129',1,0,'2022-03-03 12:48:43','2022-03-03 12:48:43'),(55686,157,'Kunchia','723129',1,0,'2022-03-03 12:48:43','2022-03-03 12:48:43'),(55687,157,'Kundurka','723151',1,0,'2022-03-03 12:48:43','2022-03-03 12:48:43'),(55688,157,'Kurarbaid','723131',1,0,'2022-03-03 12:48:43','2022-03-03 12:48:43'),(55689,157,'Kurni','723143',1,0,'2022-03-03 12:48:43','2022-03-03 12:48:43'),(55690,157,'Kuruktopa','723128',1,0,'2022-03-03 12:48:43','2022-03-03 12:48:43'),(55691,157,'Kushaldih','723152',1,0,'2022-03-03 12:48:43','2022-03-03 12:48:43'),(55692,157,'Kustaur','723126',1,0,'2022-03-03 12:48:43','2022-03-03 12:48:43'),(55693,157,'Kustore','723130',1,0,'2022-03-03 12:48:43','2022-03-03 12:48:43'),(55694,157,'Kusumjoria','723101',1,0,'2022-03-03 12:48:43','2022-03-03 12:48:43'),(55695,157,'Kutni','723131',1,0,'2022-03-03 12:48:43','2022-03-03 12:48:43'),(55696,157,'Lagda','723149',1,0,'2022-03-03 12:48:44','2022-03-03 12:48:44'),(55697,157,'Lakhanpur','723101',1,0,'2022-03-03 12:48:44','2022-03-03 12:48:44'),(55698,157,'Lakhra','723151',1,0,'2022-03-03 12:48:44','2022-03-03 12:48:44'),(55699,157,'Lara','723130',1,0,'2022-03-03 12:48:44','2022-03-03 12:48:44'),(55700,157,'Lata','723129',1,0,'2022-03-03 12:48:44','2022-03-03 12:48:44'),(55701,157,'Lipania','723126',1,0,'2022-03-03 12:48:44','2022-03-03 12:48:44'),(55702,157,'Lodhurka','723148',1,0,'2022-03-03 12:48:44','2022-03-03 12:48:44'),(55703,157,'Loulara','723151',1,0,'2022-03-03 12:48:44','2022-03-03 12:48:44'),(55704,157,'Madhukunda','723121',1,0,'2022-03-03 12:48:44','2022-03-03 12:48:44'),(55705,157,'Madhutati','723133',1,0,'2022-03-03 12:48:44','2022-03-03 12:48:44'),(55706,157,'Madla','723152',1,0,'2022-03-03 12:48:44','2022-03-03 12:48:44'),(55707,157,'Mahara','723128',1,0,'2022-03-03 12:48:44','2022-03-03 12:48:44'),(55708,157,'Mahatomara','723202',1,0,'2022-03-03 12:48:44','2022-03-03 12:48:44'),(55709,157,'Majhidih','723213',1,0,'2022-03-03 12:48:44','2022-03-03 12:48:44'),(55710,157,'Majhihira','723128',1,0,'2022-03-03 12:48:44','2022-03-03 12:48:44'),(55711,157,'Malancha','723132',1,0,'2022-03-03 12:48:44','2022-03-03 12:48:44'),(55712,157,'Malthore','723126',1,0,'2022-03-03 12:48:44','2022-03-03 12:48:44'),(55713,157,'Mamro','723129',1,0,'2022-03-03 12:48:44','2022-03-03 12:48:44'),(55714,157,'Mamurjore','723126',1,0,'2022-03-03 12:48:44','2022-03-03 12:48:44'),(55715,157,'Manbazar','723131',1,0,'2022-03-03 12:48:44','2022-03-03 12:48:44'),(55716,157,'Mangalda','723133',1,0,'2022-03-03 12:48:44','2022-03-03 12:48:44'),(55717,157,'Manguria Lalpur','723101',1,0,'2022-03-03 12:48:44','2022-03-03 12:48:44'),(55718,157,'Manguria','723149',1,0,'2022-03-03 12:48:44','2022-03-03 12:48:44'),(55719,157,'Manihara','723168',1,0,'2022-03-03 12:48:44','2022-03-03 12:48:44'),(55720,157,'Marbedia','723133',1,0,'2022-03-03 12:48:45','2022-03-03 12:48:45'),(55721,157,'Matha','723128',1,0,'2022-03-03 12:48:45','2022-03-03 12:48:45'),(55722,157,'Matha Forest','723152',1,0,'2022-03-03 12:48:45','2022-03-03 12:48:45'),(55723,157,'Mehi','723130',1,0,'2022-03-03 12:48:45','2022-03-03 12:48:45'),(55724,157,'Mekhyada','723130',1,0,'2022-03-03 12:48:45','2022-03-03 12:48:45'),(55725,157,'Menidih','723151',1,0,'2022-03-03 12:48:45','2022-03-03 12:48:45'),(55726,157,'Metyala','723128',1,0,'2022-03-03 12:48:45','2022-03-03 12:48:45'),(55727,157,'Mohandih','723128',1,0,'2022-03-03 12:48:45','2022-03-03 12:48:45'),(55728,157,'Monihara','723121',1,0,'2022-03-03 12:48:45','2022-03-03 12:48:45'),(55729,157,'Mosina','723202',1,0,'2022-03-03 12:48:45','2022-03-03 12:48:45'),(55730,157,'Moutore','723145',1,0,'2022-03-03 12:48:45','2022-03-03 12:48:45'),(55731,157,'Mudali','723153',1,0,'2022-03-03 12:48:45','2022-03-03 12:48:45'),(55732,157,'Murardih','723156',1,0,'2022-03-03 12:48:45','2022-03-03 12:48:45'),(55733,157,'Murguma','723202',1,0,'2022-03-03 12:48:45','2022-03-03 12:48:45'),(55734,157,'Murulia','723121',1,0,'2022-03-03 12:48:45','2022-03-03 12:48:45'),(55735,157,'Mutukura','723213',1,0,'2022-03-03 12:48:45','2022-03-03 12:48:45'),(55736,157,'Nadiara','723149',1,0,'2022-03-03 12:48:45','2022-03-03 12:48:45'),(55737,157,'Nadiha','723126',1,0,'2022-03-03 12:48:45','2022-03-03 12:48:45'),(55738,157,'Namopara','723103',1,0,'2022-03-03 12:48:45','2022-03-03 12:48:45'),(55739,157,'Namsole','723143',1,0,'2022-03-03 12:48:45','2022-03-03 12:48:45'),(55740,157,'Nanduka','723145',1,0,'2022-03-03 12:48:45','2022-03-03 12:48:45'),(55741,157,'Napara','723151',1,0,'2022-03-03 12:48:45','2022-03-03 12:48:45'),(55742,157,'Napara Baragram','723151',1,0,'2022-03-03 12:48:45','2022-03-03 12:48:45'),(55743,157,'Naragoria','723133',1,0,'2022-03-03 12:48:45','2022-03-03 12:48:45'),(55744,157,'Narayanpur','723121',1,0,'2022-03-03 12:48:45','2022-03-03 12:48:45'),(55745,157,'Natua','723149',1,0,'2022-03-03 12:48:45','2022-03-03 12:48:45'),(55746,157,'Nayadih','723130',1,0,'2022-03-03 12:48:46','2022-03-03 12:48:46'),(55747,157,'Nekra','723143',1,0,'2022-03-03 12:48:46','2022-03-03 12:48:46'),(55748,157,'Neturia','723121',1,0,'2022-03-03 12:48:46','2022-03-03 12:48:46'),(55749,157,'Nildih','723133',1,0,'2022-03-03 12:48:46','2022-03-03 12:48:46'),(55750,157,'Nischintapur','723127',1,0,'2022-03-03 12:48:46','2022-03-03 12:48:46'),(55751,157,'Nowadhi','723212',1,0,'2022-03-03 12:48:46','2022-03-03 12:48:46'),(55752,157,'Nowahatu','723213',1,0,'2022-03-03 12:48:46','2022-03-03 12:48:46'),(55753,157,'Nutandih','723133',1,0,'2022-03-03 12:48:46','2022-03-03 12:48:46'),(55754,157,'Nutangram','723121',1,0,'2022-03-03 12:48:46','2022-03-03 12:48:46'),(55755,157,'Oldih','723213',1,0,'2022-03-03 12:48:46','2022-03-03 12:48:46'),(55756,157,'Pabra','723121',1,0,'2022-03-03 12:48:46','2022-03-03 12:48:46'),(55757,157,'Pabrapahari','723130',1,0,'2022-03-03 12:48:46','2022-03-03 12:48:46'),(55758,157,'Pairachali','723131',1,0,'2022-03-03 12:48:46','2022-03-03 12:48:46'),(55759,157,'Pakbirra','723151',1,0,'2022-03-03 12:48:46','2022-03-03 12:48:46'),(55760,157,'Palma Penchara','723101',1,0,'2022-03-03 12:48:46','2022-03-03 12:48:46'),(55761,157,'Panchakotraj','723132',1,0,'2022-03-03 12:48:46','2022-03-03 12:48:46'),(55762,157,'Pandua','723202',1,0,'2022-03-03 12:48:46','2022-03-03 12:48:46'),(55763,157,'Panipathar','723128',1,0,'2022-03-03 12:48:46','2022-03-03 12:48:46'),(55764,157,'Para','723155',1,0,'2022-03-03 12:48:46','2022-03-03 12:48:46'),(55765,157,'Parbedia','723121',1,0,'2022-03-03 12:48:46','2022-03-03 12:48:46'),(55766,157,'Pargelia','723129',1,0,'2022-03-03 12:48:46','2022-03-03 12:48:46'),(55767,157,'Pathahensal','723212',1,0,'2022-03-03 12:48:46','2022-03-03 12:48:46'),(55768,157,'Pathardih','723152',1,0,'2022-03-03 12:48:46','2022-03-03 12:48:46'),(55769,157,'Pathjhalda','723202',1,0,'2022-03-03 12:48:46','2022-03-03 12:48:46'),(55770,157,'Patuara','723153',1,0,'2022-03-03 12:48:47','2022-03-03 12:48:47'),(55771,157,'Pealsole','723131',1,0,'2022-03-03 12:48:47','2022-03-03 12:48:47'),(55772,157,'Pedda','723131',1,0,'2022-03-03 12:48:47','2022-03-03 12:48:47'),(55773,157,'Penchara','723131',1,0,'2022-03-03 12:48:47','2022-03-03 12:48:47'),(55774,157,'Pichasi','723101',1,0,'2022-03-03 12:48:47','2022-03-03 12:48:47'),(55775,157,'Pipratard','723201',1,0,'2022-03-03 12:48:47','2022-03-03 12:48:47'),(55776,157,'Pirorgoria','723147',1,0,'2022-03-03 12:48:47','2022-03-03 12:48:47'),(55777,157,'Pirorgoria','723131',1,0,'2022-03-03 12:48:47','2022-03-03 12:48:47'),(55778,157,'Pirrah','723128',1,0,'2022-03-03 12:48:47','2022-03-03 12:48:47'),(55779,157,'Pithajore','723126',1,0,'2022-03-03 12:48:47','2022-03-03 12:48:47'),(55780,157,'Polmi','723131',1,0,'2022-03-03 12:48:47','2022-03-03 12:48:47'),(55781,157,'Puara','723153',1,0,'2022-03-03 12:48:47','2022-03-03 12:48:47'),(55782,157,'Puncha','723151',1,0,'2022-03-03 12:48:47','2022-03-03 12:48:47'),(55783,157,'Pundag','723215',1,0,'2022-03-03 12:48:47','2022-03-03 12:48:47'),(55784,157,'Pundru','723101',1,0,'2022-03-03 12:48:47','2022-03-03 12:48:47'),(55785,157,'Purdaha','723131',1,0,'2022-03-03 12:48:47','2022-03-03 12:48:47'),(55786,157,'Puriara','723127',1,0,'2022-03-03 12:48:47','2022-03-03 12:48:47'),(55787,157,'Purulia H.O','723101',1,0,'2022-03-03 12:48:47','2022-03-03 12:48:47'),(55788,157,'Purulia R.S.','723101',1,0,'2022-03-03 12:48:47','2022-03-03 12:48:47'),(55789,157,'Pusti','723212',1,0,'2022-03-03 12:48:47','2022-03-03 12:48:47'),(55790,157,'Radha Gobindapur','723143',1,0,'2022-03-03 12:48:47','2022-03-03 12:48:47'),(55791,157,'Raghabpur','723149',1,0,'2022-03-03 12:48:47','2022-03-03 12:48:47'),(55792,157,'Raghunathpur (Puruliya)','723133',1,0,'2022-03-03 12:48:47','2022-03-03 12:48:47'),(55793,157,'Raibandh','723131',1,0,'2022-03-03 12:48:47','2022-03-03 12:48:47'),(55794,157,'Raigara','723153',1,0,'2022-03-03 12:48:47','2022-03-03 12:48:47'),(55795,157,'Rajagram','723129',1,0,'2022-03-03 12:48:47','2022-03-03 12:48:47'),(55796,157,'Rajnowagarh','723128',1,0,'2022-03-03 12:48:48','2022-03-03 12:48:48'),(55797,157,'Rajra Shibtola','723121',1,0,'2022-03-03 12:48:48','2022-03-03 12:48:48'),(55798,157,'Rakab','723130',1,0,'2022-03-03 12:48:48','2022-03-03 12:48:48'),(55799,157,'Rakhera','723130',1,0,'2022-03-03 12:48:48','2022-03-03 12:48:48'),(55800,157,'Rakshatpur','723133',1,0,'2022-03-03 12:48:48','2022-03-03 12:48:48'),(55801,157,'Ralibera','723101',1,0,'2022-03-03 12:48:48','2022-03-03 12:48:48'),(55802,157,'Ramamoti','723103',1,0,'2022-03-03 12:48:48','2022-03-03 12:48:48'),(55803,157,'Ramchandrapur Ashram','723142',1,0,'2022-03-03 12:48:48','2022-03-03 12:48:48'),(55804,157,'Ramkanali','723142',1,0,'2022-03-03 12:48:48','2022-03-03 12:48:48'),(55805,157,'Rampur','723121',1,0,'2022-03-03 12:48:48','2022-03-03 12:48:48'),(55806,157,'Ranga','723152',1,0,'2022-03-03 12:48:48','2022-03-03 12:48:48'),(55807,157,'Rangadih','723143',1,0,'2022-03-03 12:48:48','2022-03-03 12:48:48'),(55808,157,'Rangamati','723201',1,0,'2022-03-03 12:48:48','2022-03-03 12:48:48'),(55809,157,'Rangametya','723121',1,0,'2022-03-03 12:48:48','2022-03-03 12:48:48'),(55810,157,'Ranibandh','723103',1,0,'2022-03-03 12:48:48','2022-03-03 12:48:48'),(55811,157,'Raotora Bhagabandh','723153',1,0,'2022-03-03 12:48:48','2022-03-03 12:48:48'),(55812,157,'Ratiadih Nowadih','723212',1,0,'2022-03-03 12:48:48','2022-03-03 12:48:48'),(55813,157,'Ratiakocha','723131',1,0,'2022-03-03 12:48:48','2022-03-03 12:48:48'),(55814,157,'Rigid','723202',1,0,'2022-03-03 12:48:48','2022-03-03 12:48:48'),(55815,157,'Roladih','723127',1,0,'2022-03-03 12:48:48','2022-03-03 12:48:48'),(55816,157,'Ropo','723213',1,0,'2022-03-03 12:48:48','2022-03-03 12:48:48'),(55817,157,'Rukni','723145',1,0,'2022-03-03 12:48:48','2022-03-03 12:48:48'),(55818,157,'Rupapetya','723127',1,0,'2022-03-03 12:48:48','2022-03-03 12:48:48'),(55819,157,'Sagasupurari','723129',1,0,'2022-03-03 12:48:48','2022-03-03 12:48:48'),(55820,157,'Sagma','723153',1,0,'2022-03-03 12:48:48','2022-03-03 12:48:48'),(55821,157,'Sainik School (Puruliya)','723104',1,0,'2022-03-03 12:48:48','2022-03-03 12:48:48'),(55822,157,'Salboni','723143',1,0,'2022-03-03 12:48:49','2022-03-03 12:48:49'),(55823,157,'Saltore','723121',1,0,'2022-03-03 12:48:49','2022-03-03 12:48:49'),(55824,157,'Sanka','723121',1,0,'2022-03-03 12:48:49','2022-03-03 12:48:49'),(55825,157,'Sankra','723155',1,0,'2022-03-03 12:48:49','2022-03-03 12:48:49'),(55826,157,'Santaldih','723145',1,0,'2022-03-03 12:48:49','2022-03-03 12:48:49'),(55827,157,'Santaldih T.P.','723146',1,0,'2022-03-03 12:48:49','2022-03-03 12:48:49'),(55828,157,'Santuri','723133',1,0,'2022-03-03 12:48:49','2022-03-03 12:48:49'),(55829,157,'Sarberia','723127',1,0,'2022-03-03 12:48:49','2022-03-03 12:48:49'),(55830,157,'Sarengdih','723212',1,0,'2022-03-03 12:48:49','2022-03-03 12:48:49'),(55831,157,'Saridih','723212',1,0,'2022-03-03 12:48:49','2022-03-03 12:48:49'),(55832,157,'Satra','723154',1,0,'2022-03-03 12:48:49','2022-03-03 12:48:49'),(55833,157,'Seja','723132',1,0,'2022-03-03 12:48:49','2022-03-03 12:48:49'),(55834,157,'Senera Amra','723149',1,0,'2022-03-03 12:48:49','2022-03-03 12:48:49'),(55835,157,'Senera','723121',1,0,'2022-03-03 12:48:49','2022-03-03 12:48:49'),(55836,157,'Shaharjuri','723152',1,0,'2022-03-03 12:48:49','2022-03-03 12:48:49'),(55837,157,'Shibdih','723103',1,0,'2022-03-03 12:48:49','2022-03-03 12:48:49'),(55838,157,'Shyamnagar','723143',1,0,'2022-03-03 12:48:49','2022-03-03 12:48:49'),(55839,157,'Sidhi','723213',1,0,'2022-03-03 12:48:49','2022-03-03 12:48:49'),(55840,157,'Sihali','723149',1,0,'2022-03-03 12:48:49','2022-03-03 12:48:49'),(55841,157,'Simla','723132',1,0,'2022-03-03 12:48:49','2022-03-03 12:48:49'),(55842,157,'Simni','723213',1,0,'2022-03-03 12:48:49','2022-03-03 12:48:49'),(55843,157,'Simulia','723102',1,0,'2022-03-03 12:48:49','2022-03-03 12:48:49'),(55844,157,'Simultard','723128',1,0,'2022-03-03 12:48:49','2022-03-03 12:48:49'),(55845,157,'Sindhraidih','723131',1,0,'2022-03-03 12:48:49','2022-03-03 12:48:49'),(55846,157,'Sindri Chas Road','723148',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55847,157,'Sindurpur','723148',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55848,157,'Sirkabad','723154',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55849,157,'Siyada','723121',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55850,157,'Sonaijuri','723126',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55851,157,'Sonathali Ashram','723121',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55852,157,'Srirampur','723201',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55853,157,'Suisa','723212',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55854,157,'Suklara','723153',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55855,157,'Sukurhutu','723127',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55856,157,'Sunuri','723121',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55857,157,'Supurdih','723143',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55858,157,'Sutabai','723121',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55859,157,'Talberia','723156',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55860,157,'Taldabra','723131',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55861,157,'Tanasi','723201',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55862,157,'Tanginayada','723130',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55863,157,'Tara','723132',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55864,157,'Tarabari','723151',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55865,157,'Tatari','723151',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55866,157,'Tatuara','723201',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55867,157,'Tentlow','723143',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55868,157,'Tentulda','723126',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55869,157,'Tentulhiti','723155',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55870,157,'Thakursima','723201',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55871,157,'Thumba Jhalda','723154',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55872,157,'Timangda','723213',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55873,157,'Torang','723212',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55874,157,'Tulin','723212',1,0,'2022-03-03 12:48:50','2022-03-03 12:48:50'),(55875,157,'Tunta','723201',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55876,157,'Tunturi','723212',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55877,157,'Udaipur','723155',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55878,157,'Upansankra','723133',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55879,157,'Uparbatri','723201',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55880,157,'Uparjari','723201',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55881,157,'Uparkahan','723201',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55882,157,'Uttamdih','723152',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55883,157,'Vivekananda Nagar','723147',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55884,158,'Paikan','700135',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55885,158,'Pakka Polarhat','700135',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55886,158,'Polarhat','700135',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55887,158,'Sonepur','700135',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55888,158,'Uttar Kashipur','700135',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55889,158,'Bediadanga','700039',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55890,158,'Chowbhanga','700105',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55891,158,'Dhapa','700105',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55892,158,'Picnic Garden','700039',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55893,158,'Tiljala Bazar','700039',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55894,158,'Tiljala','700039',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55895,158,'Topsia','700039',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55896,158,'Vip Nagar','700100',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55897,158,'Abdalpur','743368',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55898,158,'Achhipur','700138',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55899,158,'Achintanagar','743383',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55900,158,'Agarhati','743329',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55901,158,'Akra Krishnanagar','700140',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55902,158,'Akshoynagar','743347',1,0,'2022-03-03 12:48:51','2022-03-03 12:48:51'),(55903,158,'Alida','743355',1,0,'2022-03-03 12:48:52','2022-03-03 12:48:52'),(55904,158,'Amgachi','700104',1,0,'2022-03-03 12:48:52','2022-03-03 12:48:52'),(55905,158,'Amira','743368',1,0,'2022-03-03 12:48:52','2022-03-03 12:48:52'),(55906,158,'Amjharahat','743329',1,0,'2022-03-03 12:48:52','2022-03-03 12:48:52'),(55907,158,'Amlamethi','743370',1,0,'2022-03-03 12:48:52','2022-03-03 12:48:52'),(55908,158,'Amtala','743337',1,0,'2022-03-03 12:48:52','2022-03-03 12:48:52'),(55909,158,'Amtali','743378',1,0,'2022-03-03 12:48:52','2022-03-03 12:48:52'),(55910,158,'Amtali Bazar','743378',1,0,'2022-03-03 12:48:52','2022-03-03 12:48:52'),(55911,158,'Anandabad','743312',1,0,'2022-03-03 12:48:52','2022-03-03 12:48:52'),(55912,158,'Anatarampur','743504',1,0,'2022-03-03 12:48:52','2022-03-03 12:48:52'),(55913,158,'Anchna','743336',1,0,'2022-03-03 12:48:52','2022-03-03 12:48:52'),(55914,158,'Andharmanik','743503',1,0,'2022-03-03 12:48:52','2022-03-03 12:48:52'),(55915,158,'Anwarpur','743336',1,0,'2022-03-03 12:48:52','2022-03-03 12:48:52'),(55916,158,'Arampur','743370',1,0,'2022-03-03 12:48:52','2022-03-03 12:48:52'),(55917,158,'Aryapara','743377',1,0,'2022-03-03 12:48:52','2022-03-03 12:48:52'),(55918,158,'Ashuti','700141',1,0,'2022-03-03 12:48:52','2022-03-03 12:48:52'),(55919,158,'Aswathtala','743374',1,0,'2022-03-03 12:48:52','2022-03-03 12:48:52'),(55920,158,'Atharobanki','743329',1,0,'2022-03-03 12:48:52','2022-03-03 12:48:52'),(55921,158,'Aushberia','743513',1,0,'2022-03-03 12:48:52','2022-03-03 12:48:52'),(55922,158,'Baburchak','743349',1,0,'2022-03-03 12:48:52','2022-03-03 12:48:52'),(55923,158,'Bagdanga','743357',1,0,'2022-03-03 12:48:52','2022-03-03 12:48:52'),(55924,158,'Baharu','743372',1,0,'2022-03-03 12:48:52','2022-03-03 12:48:52'),(55925,158,'Baharu Ramkrishnapur','743610',1,0,'2022-03-03 12:48:52','2022-03-03 12:48:52'),(55926,158,'Bahirchak','743399',1,0,'2022-03-03 12:48:52','2022-03-03 12:48:52'),(55927,158,'Bahirkunja','743318',1,0,'2022-03-03 12:48:53','2022-03-03 12:48:53'),(55928,158,'Baidyahat','743336',1,0,'2022-03-03 12:48:53','2022-03-03 12:48:53'),(55929,158,'Baikunthapur','743383',1,0,'2022-03-03 12:48:53','2022-03-03 12:48:53'),(55930,158,'Bairagir Chak','743354',1,0,'2022-03-03 12:48:53','2022-03-03 12:48:53'),(55931,158,'Baishata','743338',1,0,'2022-03-03 12:48:53','2022-03-03 12:48:53'),(55932,158,'Bakrahat','743377',1,0,'2022-03-03 12:48:53','2022-03-03 12:48:53'),(55933,158,'Bakultala','743349',1,0,'2022-03-03 12:48:53','2022-03-03 12:48:53'),(55934,158,'Bakultalahat','743338',1,0,'2022-03-03 12:48:53','2022-03-03 12:48:53'),(55935,158,'Balakhali','743503',1,0,'2022-03-03 12:48:53','2022-03-03 12:48:53'),(55936,158,'Balarampur','743354',1,0,'2022-03-03 12:48:53','2022-03-03 12:48:53'),(55937,158,'Bali Hatkhola','743370',1,0,'2022-03-03 12:48:53','2022-03-03 12:48:53'),(55938,158,'Baliara','743357',1,0,'2022-03-03 12:48:53','2022-03-03 12:48:53'),(55939,158,'Bamanagar','743347',1,0,'2022-03-03 12:48:53','2022-03-03 12:48:53'),(55940,158,'Bamangachi','700145',1,0,'2022-03-03 12:48:53','2022-03-03 12:48:53'),(55941,158,'Bamankhali','743373',1,0,'2022-03-03 12:48:53','2022-03-03 12:48:53'),(55942,158,'Bamna','743355',1,0,'2022-03-03 12:48:53','2022-03-03 12:48:53'),(55943,158,'Bamunia','743502',1,0,'2022-03-03 12:48:53','2022-03-03 12:48:53'),(55944,158,'Banashyamnagar','743371',1,0,'2022-03-03 12:48:53','2022-03-03 12:48:53'),(55945,158,'Banasundaria','743372',1,0,'2022-03-03 12:48:53','2022-03-03 12:48:53'),(55946,158,'Banerjee Chak','743337',1,0,'2022-03-03 12:48:53','2022-03-03 12:48:53'),(55947,158,'Baneswarpur','743375',1,0,'2022-03-03 12:48:53','2022-03-03 12:48:53'),(55948,158,'Banganagar','743513',1,0,'2022-03-03 12:48:53','2022-03-03 12:48:53'),(55949,158,'Bangla','700140',1,0,'2022-03-03 12:48:53','2022-03-03 12:48:53'),(55950,158,'Bansdroni','700070',1,0,'2022-03-03 12:48:54','2022-03-03 12:48:54'),(55951,158,'Bansra','743363',1,0,'2022-03-03 12:48:54','2022-03-03 12:48:54'),(55952,158,'Bantra','743337',1,0,'2022-03-03 12:48:54','2022-03-03 12:48:54'),(55953,158,'Bara Koipukuria','743336',1,0,'2022-03-03 12:48:54','2022-03-03 12:48:54'),(55954,158,'Bara Mollakhali','743378',1,0,'2022-03-03 12:48:54','2022-03-03 12:48:54'),(55955,158,'Baradapur','743371',1,0,'2022-03-03 12:48:54','2022-03-03 12:48:54'),(55956,158,'Baradrono','743332',1,0,'2022-03-03 12:48:54','2022-03-03 12:48:54'),(55957,158,'Barandari Baharia','743332',1,0,'2022-03-03 12:48:54','2022-03-03 12:48:54'),(55958,158,'Barashi','743349',1,0,'2022-03-03 12:48:54','2022-03-03 12:48:54'),(55959,158,'Bargagan Gohalia','743503',1,0,'2022-03-03 12:48:54','2022-03-03 12:48:54'),(55960,158,'Barhansfartabad','700152',1,0,'2022-03-03 12:48:54','2022-03-03 12:48:54'),(55961,158,'Bari Bhangabad','743349',1,0,'2022-03-03 12:48:54','2022-03-03 12:48:54'),(55962,158,'Barijpur','743375',1,0,'2022-03-03 12:48:54','2022-03-03 12:48:54'),(55963,158,'Baruipur Bazar','743387',1,0,'2022-03-03 12:48:54','2022-03-03 12:48:54'),(55964,158,'Baruipur H.O','700144',1,0,'2022-03-03 12:48:54','2022-03-03 12:48:54'),(55965,158,'Baruldanga','743368',1,0,'2022-03-03 12:48:54','2022-03-03 12:48:54'),(55966,158,'Basanti','743312',1,0,'2022-03-03 12:48:54','2022-03-03 12:48:54'),(55967,158,'Basar','743374',1,0,'2022-03-03 12:48:54','2022-03-03 12:48:54'),(55968,158,'Bat Tali','743611',1,0,'2022-03-03 12:48:54','2022-03-03 12:48:54'),(55969,158,'Batakhali Chandipur','743611',1,0,'2022-03-03 12:48:54','2022-03-03 12:48:54'),(55970,158,'Batanagar','700140',1,0,'2022-03-03 12:48:54','2022-03-03 12:48:54'),(55971,158,'Batiswar','743354',1,0,'2022-03-03 12:48:54','2022-03-03 12:48:54'),(55972,158,'Bawali','700137',1,0,'2022-03-03 12:48:54','2022-03-03 12:48:54'),(55973,158,'Bawali Chandipur','700137',1,0,'2022-03-03 12:48:54','2022-03-03 12:48:54'),(55974,158,'Bazarberia','743395',1,0,'2022-03-03 12:48:54','2022-03-03 12:48:54'),(55975,158,'Begampur','743387',1,0,'2022-03-03 12:48:55','2022-03-03 12:48:55'),(55976,158,'Beguakhali','743373',1,0,'2022-03-03 12:48:55','2022-03-03 12:48:55'),(55977,158,'Bele Durganagar','743337',1,0,'2022-03-03 12:48:55','2022-03-03 12:48:55'),(55978,158,'Belegachi','743376',1,0,'2022-03-03 12:48:55','2022-03-03 12:48:55'),(55979,158,'Belpukur','743348',1,0,'2022-03-03 12:48:55','2022-03-03 12:48:55'),(55980,158,'Belsinga','743504',1,0,'2022-03-03 12:48:55','2022-03-03 12:48:55'),(55981,158,'Benebow','743613',1,0,'2022-03-03 12:48:55','2022-03-03 12:48:55'),(55982,158,'Benipur','743355',1,0,'2022-03-03 12:48:55','2022-03-03 12:48:55'),(55983,158,'Benjanharia','700138',1,0,'2022-03-03 12:48:55','2022-03-03 12:48:55'),(55984,158,'Beonta','743502',1,0,'2022-03-03 12:48:55','2022-03-03 12:48:55'),(55985,158,'Beramara','743609',1,0,'2022-03-03 12:48:55','2022-03-03 12:48:55'),(55986,158,'Betberia','743503',1,0,'2022-03-03 12:48:55','2022-03-03 12:48:55'),(55987,158,'Bhadura','743504',1,0,'2022-03-03 12:48:55','2022-03-03 12:48:55'),(55988,158,'Bhagabatipur','743399',1,0,'2022-03-03 12:48:55','2022-03-03 12:48:55'),(55989,158,'Bhagabatipur','743371',1,0,'2022-03-03 12:48:55','2022-03-03 12:48:55'),(55990,158,'Bhajna Benepara','743399',1,0,'2022-03-03 12:48:55','2022-03-03 12:48:55'),(55991,158,'Bhalleya','743376',1,0,'2022-03-03 12:48:55','2022-03-03 12:48:55'),(55992,158,'Bhangankhali','743329',1,0,'2022-03-03 12:48:55','2022-03-03 12:48:55'),(55993,158,'Bhangar (NF)','743502',1,0,'2022-03-03 12:48:55','2022-03-03 12:48:55'),(55994,158,'Bhangar Chaltaberia','743502',1,0,'2022-03-03 12:48:55','2022-03-03 12:48:55'),(55995,158,'Bhangar Gobindapur','743502',1,0,'2022-03-03 12:48:55','2022-03-03 12:48:55'),(55996,158,'Bhangar Narayanpur','743502',1,0,'2022-03-03 12:48:55','2022-03-03 12:48:55'),(55997,158,'Bhangar Raghunathpur','743502',1,0,'2022-03-03 12:48:55','2022-03-03 12:48:55'),(55998,158,'Bharatgarh','743312',1,0,'2022-03-03 12:48:55','2022-03-03 12:48:55'),(55999,158,'Bhateria','743503',1,0,'2022-03-03 12:48:56','2022-03-03 12:48:56'),(56000,158,'Bhatia','743399',1,0,'2022-03-03 12:48:56','2022-03-03 12:48:56'),(56001,158,'Bhawanpur','743399',1,0,'2022-03-03 12:48:56','2022-03-03 12:48:56'),(56002,158,'Bhohalberia','743399',1,0,'2022-03-03 12:48:56','2022-03-03 12:48:56'),(56003,158,'Bhojerhat','743502',1,0,'2022-03-03 12:48:56','2022-03-03 12:48:56'),(56004,158,'Bhubaneswari Bazar','743383',1,0,'2022-03-03 12:48:56','2022-03-03 12:48:56'),(56005,158,'Bhubannagar','743347',1,0,'2022-03-03 12:48:56','2022-03-03 12:48:56'),(56006,158,'Bidyadharpur','743336',1,0,'2022-03-03 12:48:56','2022-03-03 12:48:56'),(56007,158,'Bijannagar','743347',1,0,'2022-03-03 12:48:56','2022-03-03 12:48:56'),(56008,158,'Bijoyganj Bazar','743345',1,0,'2022-03-03 12:48:56','2022-03-03 12:48:56'),(56009,158,'Bijoynagar','743370',1,0,'2022-03-03 12:48:56','2022-03-03 12:48:56'),(56010,158,'Binodpur Ambikanagar','743383',1,0,'2022-03-03 12:48:56','2022-03-03 12:48:56'),(56011,158,'Bireswarpur','743336',1,0,'2022-03-03 12:48:56','2022-03-03 12:48:56'),(56012,158,'Birlapur','743318',1,0,'2022-03-03 12:48:56','2022-03-03 12:48:56'),(56013,158,'Bishalakshmipur','743347',1,0,'2022-03-03 12:48:56','2022-03-03 12:48:56'),(56014,158,'Bishnupur (South 24 Parganas)','743503',1,0,'2022-03-03 12:48:56','2022-03-03 12:48:56'),(56015,158,'Bishra','743504',1,0,'2022-03-03 12:48:56','2022-03-03 12:48:56'),(56016,158,'Biswanathpur','743349',1,0,'2022-03-03 12:48:56','2022-03-03 12:48:56'),(56017,158,'Bodra','743502',1,0,'2022-03-03 12:48:56','2022-03-03 12:48:56'),(56018,158,'Boinchbati','743338',1,0,'2022-03-03 12:48:56','2022-03-03 12:48:56'),(56019,158,'Boinchberia','743375',1,0,'2022-03-03 12:48:56','2022-03-03 12:48:56'),(56020,158,'Bonganopara','700141',1,0,'2022-03-03 12:48:56','2022-03-03 12:48:56'),(56021,158,'Bonhooghly','700103',1,0,'2022-03-03 12:48:56','2022-03-03 12:48:56'),(56022,158,'Boral','700154',1,0,'2022-03-03 12:48:57','2022-03-03 12:48:57'),(56023,158,'Boria','743329',1,0,'2022-03-03 12:48:57','2022-03-03 12:48:57'),(56024,158,'Boria','743368',1,0,'2022-03-03 12:48:57','2022-03-03 12:48:57'),(56025,158,'Boyargadi','743349',1,0,'2022-03-03 12:48:57','2022-03-03 12:48:57'),(56026,158,'Brahmapur','700096',1,0,'2022-03-03 12:48:57','2022-03-03 12:48:57'),(56027,158,'Brajaballav Pur','743371',1,0,'2022-03-03 12:48:57','2022-03-03 12:48:57'),(56028,158,'Brindakhali','743387',1,0,'2022-03-03 12:48:57','2022-03-03 12:48:57'),(56029,158,'Budge Budge Natun Bazar','700137',1,0,'2022-03-03 12:48:57','2022-03-03 12:48:57'),(56030,158,'Budge Budge. (Hsg-ii)','700137',1,0,'2022-03-03 12:48:57','2022-03-03 12:48:57'),(56031,158,'Budhakhali','743347',1,0,'2022-03-03 12:48:57','2022-03-03 12:48:57'),(56032,158,'Buinta','700137',1,0,'2022-03-03 12:48:57','2022-03-03 12:48:57'),(56033,158,'Buraburirtat','743371',1,0,'2022-03-03 12:48:57','2022-03-03 12:48:57'),(56034,158,'Burul','743318',1,0,'2022-03-03 12:48:57','2022-03-03 12:48:57'),(56035,158,'Canning Town Ferry Ghat','743329',1,0,'2022-03-03 12:48:57','2022-03-03 12:48:57'),(56036,158,'Canning Town','743329',1,0,'2022-03-03 12:48:57','2022-03-03 12:48:57'),(56037,158,'Chaberia','743504',1,0,'2022-03-03 12:48:57','2022-03-03 12:48:57'),(56038,158,'Chaitanyapur','743395',1,0,'2022-03-03 12:48:57','2022-03-03 12:48:57'),(56039,158,'Chak Enayetnagar','743503',1,0,'2022-03-03 12:48:57','2022-03-03 12:48:57'),(56040,158,'Chak Haturia','743503',1,0,'2022-03-03 12:48:57','2022-03-03 12:48:57'),(56041,158,'Chak Kashipur','743318',1,0,'2022-03-03 12:48:57','2022-03-03 12:48:57'),(56042,158,'Chakalampur','743318',1,0,'2022-03-03 12:48:57','2022-03-03 12:48:57'),(56043,158,'Chakborali','743502',1,0,'2022-03-03 12:48:57','2022-03-03 12:48:57'),(56044,158,'Chakfuldubi','743373',1,0,'2022-03-03 12:48:58','2022-03-03 12:48:58'),(56045,158,'Chakjot Shibrampur','700141',1,0,'2022-03-03 12:48:58','2022-03-03 12:48:58'),(56046,158,'Chakparan Katakhali','743610',1,0,'2022-03-03 12:48:58','2022-03-03 12:48:58'),(56047,158,'Chaltaberia','743337',1,0,'2022-03-03 12:48:58','2022-03-03 12:48:58'),(56048,158,'Chaluary','743513',1,0,'2022-03-03 12:48:58','2022-03-03 12:48:58'),(56049,158,'Champahati','743330',1,0,'2022-03-03 12:48:58','2022-03-03 12:48:58'),(56050,158,'Chandandaha','743503',1,0,'2022-03-03 12:48:58','2022-03-03 12:48:58'),(56051,158,'Chandaneswar','743330',1,0,'2022-03-03 12:48:58','2022-03-03 12:48:58'),(56052,158,'Chandannagar','743368',1,0,'2022-03-03 12:48:58','2022-03-03 12:48:58'),(56053,158,'Chandanpiri','743357',1,0,'2022-03-03 12:48:58','2022-03-03 12:48:58'),(56054,158,'Chandi','743503',1,0,'2022-03-03 12:48:58','2022-03-03 12:48:58'),(56055,158,'Chandibari','743502',1,0,'2022-03-03 12:48:58','2022-03-03 12:48:58'),(56056,158,'Chandipur','743395',1,0,'2022-03-03 12:48:58','2022-03-03 12:48:58'),(56057,158,'Chandipur','743399',1,0,'2022-03-03 12:48:58','2022-03-03 12:48:58'),(56058,158,'Chandkhali','743376',1,0,'2022-03-03 12:48:58','2022-03-03 12:48:58'),(56059,158,'Chandpala','743503',1,0,'2022-03-03 12:48:58','2022-03-03 12:48:58'),(56060,158,'Chapla','743349',1,0,'2022-03-03 12:48:58','2022-03-03 12:48:58'),(56061,158,'Charaghata','743337',1,0,'2022-03-03 12:48:58','2022-03-03 12:48:58'),(56062,158,'Charashyambati','700137',1,0,'2022-03-03 12:48:58','2022-03-03 12:48:58'),(56063,158,'Charashyamdas','743503',1,0,'2022-03-03 12:48:58','2022-03-03 12:48:58'),(56064,158,'Charavidya','743329',1,0,'2022-03-03 12:48:58','2022-03-03 12:48:58'),(56065,158,'Chargheri','743370',1,0,'2022-03-03 12:48:58','2022-03-03 12:48:58'),(56066,158,'Chatakalikapur','700140',1,0,'2022-03-03 12:48:58','2022-03-03 12:48:58'),(56067,158,'Chatra Maldari','743337',1,0,'2022-03-03 12:48:58','2022-03-03 12:48:58'),(56068,158,'Chemaguri','743373',1,0,'2022-03-03 12:48:58','2022-03-03 12:48:58'),(56069,158,'Chhayani','743376',1,0,'2022-03-03 12:48:58','2022-03-03 12:48:58'),(56070,158,'Chhoto Mollakhali','743378',1,0,'2022-03-03 12:48:59','2022-03-03 12:48:59'),(56071,158,'Chhotrisher Hat','743338',1,0,'2022-03-03 12:48:59','2022-03-03 12:48:59'),(56072,158,'Chimta','743378',1,0,'2022-03-03 12:48:59','2022-03-03 12:48:59'),(56073,158,'Chitraganj','743337',1,0,'2022-03-03 12:48:59','2022-03-03 12:48:59'),(56074,158,'Choto Shyam Nagar','743371',1,0,'2022-03-03 12:48:59','2022-03-03 12:48:59'),(56075,158,'Chowhati','700149',1,0,'2022-03-03 12:48:59','2022-03-03 12:48:59'),(56076,158,'Chowl Khola','743377',1,0,'2022-03-03 12:48:59','2022-03-03 12:48:59'),(56077,158,'Chunakhali','743611',1,0,'2022-03-03 12:48:59','2022-03-03 12:48:59'),(56078,158,'Chuprijhara','743349',1,0,'2022-03-03 12:48:59','2022-03-03 12:48:59'),(56079,158,'Companir Char','743373',1,0,'2022-03-03 12:48:59','2022-03-03 12:48:59'),(56080,158,'D.Rajarampur','743348',1,0,'2022-03-03 12:48:59','2022-03-03 12:48:59'),(56081,158,'Dahakhanda','743354',1,0,'2022-03-03 12:48:59','2022-03-03 12:48:59'),(56082,158,'Daharani','743329',1,0,'2022-03-03 12:48:59','2022-03-03 12:48:59'),(56083,158,'Dakshin Alipore','743503',1,0,'2022-03-03 12:48:59','2022-03-03 12:48:59'),(56084,158,'Dakshin Bagi','743503',1,0,'2022-03-03 12:48:59','2022-03-03 12:48:59'),(56085,158,'Dakshin Barasat','743372',1,0,'2022-03-03 12:48:59','2022-03-03 12:48:59'),(56086,158,'Dakshin Bijoynagar','743338',1,0,'2022-03-03 12:48:59','2022-03-03 12:48:59'),(56087,158,'Dakshin Chandannagar','743357',1,0,'2022-03-03 12:48:59','2022-03-03 12:48:59'),(56088,158,'Dakshin Chandipur','743374',1,0,'2022-03-03 12:48:59','2022-03-03 12:48:59'),(56089,158,'Dakshin Durgapur','743349',1,0,'2022-03-03 12:48:59','2022-03-03 12:48:59'),(56090,158,'Dakshin Gangadharpur','743399',1,0,'2022-03-03 12:48:59','2022-03-03 12:48:59'),(56091,158,'Dakshin Gobindapur','700145',1,0,'2022-03-03 12:48:59','2022-03-03 12:48:59'),(56092,158,'Dakshin Gopalnagar','743347',1,0,'2022-03-03 12:49:00','2022-03-03 12:49:00'),(56093,158,'Dakshin Gouripur','743503',1,0,'2022-03-03 12:49:00','2022-03-03 12:49:00'),(56094,158,'Dakshin Haradhanpur','743373',1,0,'2022-03-03 12:49:00','2022-03-03 12:49:00'),(56095,158,'Dakshin Hazi Pur','743331',1,0,'2022-03-03 12:49:00','2022-03-03 12:49:00'),(56096,158,'Dakshin Jagadishpur','743399',1,0,'2022-03-03 12:49:00','2022-03-03 12:49:00'),(56097,158,'Dakshin Jagatdal','700151',1,0,'2022-03-03 12:49:00','2022-03-03 12:49:00'),(56098,158,'Dakshin Kashiabad','743347',1,0,'2022-03-03 12:49:00','2022-03-03 12:49:00'),(56099,158,'Dakshin Kashinagar','743383',1,0,'2022-03-03 12:49:00','2022-03-03 12:49:00'),(56100,158,'Dakshin Mokamberia','743312',1,0,'2022-03-03 12:49:00','2022-03-03 12:49:00'),(56101,158,'Dakshin Radhanagar','743378',1,0,'2022-03-03 12:49:00','2022-03-03 12:49:00'),(56102,158,'Dakshin Raipur','743318',1,0,'2022-03-03 12:49:00','2022-03-03 12:49:00'),(56103,158,'Dakshin Raipur No. 3','743349',1,0,'2022-03-03 12:49:00','2022-03-03 12:49:00'),(56104,158,'Dakshin Rajnagar','743374',1,0,'2022-03-03 12:49:00','2022-03-03 12:49:00'),(56105,158,'Dakshin Shibpur','743349',1,0,'2022-03-03 12:49:00','2022-03-03 12:49:00'),(56106,158,'Damkal','743383',1,0,'2022-03-03 12:49:00','2022-03-03 12:49:00'),(56107,158,'Dara','743337',1,0,'2022-03-03 12:49:00','2022-03-03 12:49:00'),(56108,158,'Daria','743332',1,0,'2022-03-03 12:49:00','2022-03-03 12:49:00'),(56109,158,'Darikrishna Nagar','743368',1,0,'2022-03-03 12:49:00','2022-03-03 12:49:00'),(56110,158,'Daspur','743371',1,0,'2022-03-03 12:49:00','2022-03-03 12:49:00'),(56111,158,'Daudpur Hatkhola','743611',1,0,'2022-03-03 12:49:00','2022-03-03 12:49:00'),(56112,158,'Daulatpur','700139',1,0,'2022-03-03 12:49:00','2022-03-03 12:49:00'),(56113,158,'Dayapur','743370',1,0,'2022-03-03 12:49:00','2022-03-03 12:49:00'),(56114,158,'Debipur','743383',1,0,'2022-03-03 12:49:00','2022-03-03 12:49:00'),(56115,158,'Debnagar','743357',1,0,'2022-03-03 12:49:00','2022-03-03 12:49:00'),(56116,158,'Debnibas','743357',1,0,'2022-03-03 12:49:00','2022-03-03 12:49:00'),(56117,158,'Deulbari','743349',1,0,'2022-03-03 12:49:01','2022-03-03 12:49:01'),(56118,158,'Deuli','743502',1,0,'2022-03-03 12:49:01','2022-03-03 12:49:01'),(56119,158,'Devisabad','743376',1,0,'2022-03-03 12:49:01','2022-03-03 12:49:01'),(56120,158,'Dewanchak','743337',1,0,'2022-03-03 12:49:01','2022-03-03 12:49:01'),(56121,158,'Dhabahat Shibpur','743373',1,0,'2022-03-03 12:49:01','2022-03-03 12:49:01'),(56122,158,'Dhalirbati','743376',1,0,'2022-03-03 12:49:01','2022-03-03 12:49:01'),(56123,158,'Dhalua','700152',1,0,'2022-03-03 12:49:01','2022-03-03 12:49:01'),(56124,158,'Dhamua','743610',1,0,'2022-03-03 12:49:01','2022-03-03 12:49:01'),(56125,158,'Dhanpota','743355',1,0,'2022-03-03 12:49:01','2022-03-03 12:49:01'),(56126,158,'Dhanurhat','743336',1,0,'2022-03-03 12:49:01','2022-03-03 12:49:01'),(56127,158,'Dhanyaghata','743355',1,0,'2022-03-03 12:49:01','2022-03-03 12:49:01'),(56128,158,'Dhapdhapi','743387',1,0,'2022-03-03 12:49:01','2022-03-03 12:49:01'),(56129,158,'Dharmatala Panchuria','743502',1,0,'2022-03-03 12:49:01','2022-03-03 12:49:01'),(56130,158,'Dholahat','743399',1,0,'2022-03-03 12:49:01','2022-03-03 12:49:01'),(56131,158,'Dhopahat Krishnapur','743336',1,0,'2022-03-03 12:49:01','2022-03-03 12:49:01'),(56132,158,'Dhosa','743337',1,0,'2022-03-03 12:49:01','2022-03-03 12:49:01'),(56133,158,'Diamond Harbour CC','743331',1,0,'2022-03-03 12:49:01','2022-03-03 12:49:01'),(56134,158,'Diamond Harbour H.O','743331',1,0,'2022-03-03 12:49:01','2022-03-03 12:49:01'),(56135,158,'Diamond Harbour New Town','743331',1,0,'2022-03-03 12:49:01','2022-03-03 12:49:01'),(56136,158,'Diamond Harbour RS','743331',1,0,'2022-03-03 12:49:01','2022-03-03 12:49:01'),(56137,158,'Digambarpur','743349',1,0,'2022-03-03 12:49:01','2022-03-03 12:49:01'),(56138,158,'Digberia','743395',1,0,'2022-03-03 12:49:01','2022-03-03 12:49:01'),(56139,158,'Dighirpar Bazar','743503',1,0,'2022-03-03 12:49:01','2022-03-03 12:49:01'),(56140,158,'Dihimathurapur Gobindapur','743373',1,0,'2022-03-03 12:49:01','2022-03-03 12:49:01'),(56141,158,'Dingelpota','700151',1,0,'2022-03-03 12:49:01','2022-03-03 12:49:01'),(56142,158,'Dodalia','743609',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56143,158,'Doltalaghola','743376',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56144,158,'Domdoma','743503',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56145,158,'Dongajora','743329',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56146,158,'Dongaria','743318',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56147,158,'Dosatina','743503',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56148,158,'Dostapur','743504',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56149,158,'Doulatabad','743503',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56150,158,'Dulalpur','743336',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56151,158,'Dulki','743370',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56152,158,'Durba Chati','743347',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56153,158,'Durganagar','743399',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56154,158,'Durgapur Baruipur','743610',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56155,158,'Durgapur Takerbazar','743357',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56156,158,'Dwariknagar','743357',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56157,158,'Enayetpur','743351',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56158,158,'Fakir Chand College','743331',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56159,158,'Falta','743504',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56160,158,'Fatehpur (South 24 Parganas)','743513',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56161,158,'Fatickpur','743347',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56162,158,'Fokirtakia Sarberiahat','743329',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56163,158,'Freser Ganj','743357',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56164,158,'Futigoda','743337',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56165,158,'Gabberia','743336',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56166,158,'Gandhabaduli','743503',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56167,158,'Ganesh Pur','743370',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56168,158,'Ganeshnagar','743357',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56169,158,'Ganeshpur 1st Gheri','743347',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56170,158,'Ganeshpur 4th Gheri','743347',1,0,'2022-03-03 12:49:02','2022-03-03 12:49:02'),(56171,158,'Ganeshpur Baikunthapur','743347',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56172,158,'Gangadharpur','743347',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56173,158,'Gangasagar','743373',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56174,158,'Gangrai','700145',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56175,158,'Garia Garden','700084',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56176,158,'Garia (South 24 Parganas)','700084',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56177,158,'Gazipur','743336',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56178,158,'Gazirmahal Chitamari','743374',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56179,158,'Ghatakpur','743332',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56180,158,'Ghateswar','743336',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56181,158,'Gheri Keorakhali','743349',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56182,158,'Gheri Raipur','743349',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56183,158,'Ghoradah','743354',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56184,158,'Ghorahata Mukundapur','743503',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56185,158,'Ghoramara Mandirtala','743356',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56186,158,'Ghoserpole','743354',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56187,158,'Ghoshpur','743502',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56188,158,'Gilarchat','743354',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56189,158,'Giripur','700141',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56190,158,'Goalara','743383',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56191,158,'Goanara Gobindapur','743368',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56192,158,'Gobinda Pura Bad','743371',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56193,158,'Gobindapur','743347',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56194,158,'Gocharan','743372',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56195,158,'Gokarnee','743355',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56196,158,'Golabari','743329',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56197,158,'Gopalganj Hat','743338',1,0,'2022-03-03 12:49:03','2022-03-03 12:49:03'),(56198,158,'Gopalkata','743611',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56199,158,'Gopalpurhat','743504',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56200,158,'Gorerhat','743372',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56201,158,'Gosaba','743370',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56202,158,'Gotalahat Krishnapur','743503',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56203,158,'Gourdaha','743363',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56204,158,'Gumukhberia','743332',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56205,158,'Gurudaspur','743349',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56206,158,'Hadia','700150',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56207,158,'Hansuri','743609',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56208,158,'Haradhan Pur','743373',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56209,158,'Haranandapur','743503',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56210,158,'Harbhangi','743329',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56211,158,'Harendranagar','743347',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56212,158,'Harinavi','700148',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56213,158,'Harinbari','743373',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56214,158,'Harindanga','743399',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56215,158,'Harinkhola','743399',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56216,158,'Haripur','743357',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56217,158,'Haripur','743355',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56218,158,'Harishpur Ramnagar','743370',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56219,158,'Hasimnagar','743513',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56220,158,'Hatuganj','743332',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56221,158,'Heramba Gopalpur','743383',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56222,158,'Herobhanga','743329',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56223,158,'Hetalkhali','700137',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56224,158,'Hironmoypur','743312',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56225,158,'Hotor','743610',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56226,158,'Iim Joka','700104',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56227,158,'Imamuddipur','743399',1,0,'2022-03-03 12:49:04','2022-03-03 12:49:04'),(56228,158,'Indirapur','743371',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56229,158,'Indrapala','743610',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56230,158,'Iswaripur','743502',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56231,158,'Iyarpur','743513',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56232,158,'Jadabpurhat','743336',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56233,158,'Jafarpur','743513',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56234,158,'Jagannathnagar','700140',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56235,158,'Jahar Colony','743370',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56236,158,'Jaharpur','743347',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56237,158,'Jalaberia','743338',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56238,158,'Jalghara','743609',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56239,158,'Jalkura','700141',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56240,158,'Jamira','743504',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56241,158,'Jamtala','743348',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56242,158,'Japtala','743338',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56243,158,'Jata','743383',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56244,158,'Jata Jogendranagar','743383',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56245,158,'Jeliabati','743336',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56246,158,'Jharkhali Bazar','743312',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56247,158,'Jhowkhali','743611',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56248,158,'Jibantala','743373',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56249,158,'Jibantala Sarangabad','743376',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56250,158,'Jogendranagar','743329',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56251,158,'Jogendrapurabad','743371',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56252,158,'Joka (South 24 Parganas)','700104',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56253,158,'Joygopal Pur N. Bazar','743312',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56254,158,'Joynagar Majilpur','743337',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56255,158,'Joypur','743502',1,0,'2022-03-03 12:49:05','2022-03-03 12:49:05'),(56256,158,'Joyramkhali','743329',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56257,158,'Jugdia','743355',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56258,158,'Jumainaskar','743399',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56259,158,'Jyotishpur','743312',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56260,158,'Kachiamara','743329',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56261,158,'Kachuberia','743373',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56262,158,'Kachukhali  Ramnagar Bazar','743370',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56263,158,'Kachukhali','743370',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56264,158,'Kadipukur','743355',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56265,158,'Kaikhali Ashram','743338',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56266,158,'Kaikhali Boinchbati','743503',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56267,158,'Kailashnagar','743329',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56268,158,'Kailaspur','743349',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56269,158,'Kakdwip Kalinagar','743347',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56270,158,'Kakdwip','743347',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56271,158,'Kalahazra','743312',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56272,158,'Kalash','743609',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56273,158,'Kalibari Temple','700070',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56274,158,'Kalidaspur','743378',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56275,158,'Kalikapota','743355',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56276,158,'Kalikapur','743330',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56277,158,'Kalikatala','743329',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56278,158,'Kalinagar','743610',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56279,158,'Kalitala Daspur','743373',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56280,158,'Kalsa','743503',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56281,158,'Kamakshyapur','743611',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56282,158,'Kamalpur','743609',1,0,'2022-03-03 12:49:06','2022-03-03 12:49:06'),(56283,158,'Kamalpur','743373',1,0,'2022-03-03 12:49:07','2022-03-03 12:49:07'),(56284,158,'Kamarganti','743502',1,0,'2022-03-03 12:49:07','2022-03-03 12:49:07'),(56285,158,'Kamaria','743337',1,0,'2022-03-03 12:49:07','2022-03-03 12:49:07'),(56286,158,'Kamarpole','743368',1,0,'2022-03-03 12:49:07','2022-03-03 12:49:07'),(56287,158,'Kamda Hari','700084',1,0,'2022-03-03 12:49:07','2022-03-03 12:49:07'),(56288,158,'Kamdevpur','743371',1,0,'2022-03-03 12:49:07','2022-03-03 12:49:07'),(56289,158,'Kamrabad','700150',1,0,'2022-03-03 12:49:07','2022-03-03 12:49:07'),(56290,158,'Kamte','743318',1,0,'2022-03-03 12:49:07','2022-03-03 12:49:07'),(56291,158,'Kanganberia','743503',1,0,'2022-03-03 12:49:07','2022-03-03 12:49:07'),(56292,158,'Kankandighi','743383',1,0,'2022-03-03 12:49:07','2022-03-03 12:49:07'),(56293,158,'Kantatala','743502',1,0,'2022-03-03 12:49:07','2022-03-03 12:49:07'),(56294,158,'Kanthalberia','743329',1,0,'2022-03-03 12:49:07','2022-03-03 12:49:07'),(56295,158,'Kanya Nagar','743503',1,0,'2022-03-03 12:49:07','2022-03-03 12:49:07'),(56296,158,'Karalberia','743504',1,0,'2022-03-03 12:49:07','2022-03-03 12:49:07'),(56297,158,'Karanjali','743348',1,0,'2022-03-03 12:49:07','2022-03-03 12:49:07'),(56298,158,'Kashimpur','743372',1,0,'2022-03-03 12:49:07','2022-03-03 12:49:07'),(56299,158,'Kashinagar (South 24 Parganas)','743349',1,0,'2022-03-03 12:49:07','2022-03-03 12:49:07'),(56300,158,'Kashipur','743345',1,0,'2022-03-03 12:49:07','2022-03-03 12:49:07'),(56301,158,'Katamari','743349',1,0,'2022-03-03 12:49:07','2022-03-03 12:49:07'),(56302,158,'Kautala','743349',1,0,'2022-03-03 12:49:07','2022-03-03 12:49:07'),(56303,158,'Kayalerchak','743354',1,0,'2022-03-03 12:49:07','2022-03-03 12:49:07'),(56304,158,'Kecharkur Gopalnagar','743395',1,0,'2022-03-03 12:49:07','2022-03-03 12:49:07'),(56305,158,'Kedarpur','743383',1,0,'2022-03-03 12:49:07','2022-03-03 12:49:07'),(56306,158,'Kensilly','743375',1,0,'2022-03-03 12:49:07','2022-03-03 12:49:07'),(56307,158,'Keorakhali','743338',1,0,'2022-03-03 12:49:07','2022-03-03 12:49:07'),(56308,158,'Keoratala','743348',1,0,'2022-03-03 12:49:08','2022-03-03 12:49:08'),(56309,158,'Keyatala','743372',1,0,'2022-03-03 12:49:08','2022-03-03 12:49:08'),(56310,158,'Khagramuri','700140',1,0,'2022-03-03 12:49:08','2022-03-03 12:49:08'),(56311,158,'Khaizamara','743337',1,0,'2022-03-03 12:49:08','2022-03-03 12:49:08'),(56312,158,'Khakurdaha','743372',1,0,'2022-03-03 12:49:08','2022-03-03 12:49:08'),(56313,158,'Khalisakhali','743329',1,0,'2022-03-03 12:49:08','2022-03-03 12:49:08'),(56314,158,'Khankarbazar','743355',1,0,'2022-03-03 12:49:08','2022-03-03 12:49:08'),(56315,158,'Khari','743349',1,0,'2022-03-03 12:49:08','2022-03-03 12:49:08'),(56316,158,'Khaskumirmari Chak','743373',1,0,'2022-03-03 12:49:08','2022-03-03 12:49:08'),(56317,158,'Khaskumrakhali','743376',1,0,'2022-03-03 12:49:08','2022-03-03 12:49:08'),(56318,158,'Khasmahal','743373',1,0,'2022-03-03 12:49:08','2022-03-03 12:49:08'),(56319,158,'Khayada','700150',1,0,'2022-03-03 12:49:08','2022-03-03 12:49:08'),(56320,158,'Khetramohan Pur','743371',1,0,'2022-03-03 12:49:08','2022-03-03 12:49:08'),(56321,158,'Khojkhidir','743354',1,0,'2022-03-03 12:49:08','2022-03-03 12:49:08'),(56322,158,'Kholakhali','743338',1,0,'2022-03-03 12:49:08','2022-03-03 12:49:08'),(56323,158,'Kholakhali','743368',1,0,'2022-03-03 12:49:08','2022-03-03 12:49:08'),(56324,158,'Khunsahabad','743373',1,0,'2022-03-03 12:49:08','2022-03-03 12:49:08'),(56325,158,'Kirtankhali','743373',1,0,'2022-03-03 12:49:08','2022-03-03 12:49:08'),(56326,158,'Kishorimohanpur','743383',1,0,'2022-03-03 12:49:08','2022-03-03 12:49:08'),(56327,158,'Koabati','743338',1,0,'2022-03-03 12:49:08','2022-03-03 12:49:08'),(56328,158,'Kodalia','700146',1,0,'2022-03-03 12:49:08','2022-03-03 12:49:08'),(56329,158,'Kodalia Shibpur','743368',1,0,'2022-03-03 12:49:08','2022-03-03 12:49:08'),(56330,158,'Kolarea','743363',1,0,'2022-03-03 12:49:08','2022-03-03 12:49:08'),(56331,158,'Konchfal','743399',1,0,'2022-03-03 12:49:08','2022-03-03 12:49:08'),(56332,158,'Kripakhali','743337',1,0,'2022-03-03 12:49:08','2022-03-03 12:49:08'),(56333,158,'Krishnachandrapur','743354',1,0,'2022-03-03 12:49:09','2022-03-03 12:49:09'),(56334,158,'Krishnadaspur','743371',1,0,'2022-03-03 12:49:09','2022-03-03 12:49:09'),(56335,158,'Krishnamoti','743502',1,0,'2022-03-03 12:49:09','2022-03-03 12:49:09'),(56336,158,'Krishnanagar','743345',1,0,'2022-03-03 12:49:09','2022-03-03 12:49:09'),(56337,158,'Kuemuri','743383',1,0,'2022-03-03 12:49:09','2022-03-03 12:49:09'),(56338,158,'Kulberia','743502',1,0,'2022-03-03 12:49:09','2022-03-03 12:49:09'),(56339,158,'Kuldia','743609',1,0,'2022-03-03 12:49:09','2022-03-03 12:49:09'),(56340,158,'Kuleswar','743375',1,0,'2022-03-03 12:49:09','2022-03-03 12:49:09'),(56341,158,'Kulpi','743351',1,0,'2022-03-03 12:49:09','2022-03-03 12:49:09'),(56342,158,'Kultalahat','743504',1,0,'2022-03-03 12:49:09','2022-03-03 12:49:09'),(56343,158,'Kultali','743338',1,0,'2022-03-03 12:49:09','2022-03-03 12:49:09'),(56344,158,'Kulti Lock Gate','743502',1,0,'2022-03-03 12:49:09','2022-03-03 12:49:09'),(56345,158,'Kumarhat','743387',1,0,'2022-03-03 12:49:09','2022-03-03 12:49:09'),(56346,158,'Kumarpur','743349',1,0,'2022-03-03 12:49:09','2022-03-03 12:49:09'),(56347,158,'Kumirmari','743378',1,0,'2022-03-03 12:49:09','2022-03-03 12:49:09'),(56348,158,'Kumirmari Narendrapur','743378',1,0,'2022-03-03 12:49:09','2022-03-03 12:49:09'),(56349,158,'Kumrakhali','743329',1,0,'2022-03-03 12:49:09','2022-03-03 12:49:09'),(56350,158,'Kumrapara','743383',1,0,'2022-03-03 12:49:09','2022-03-03 12:49:09'),(56351,158,'Kundarali','743610',1,0,'2022-03-03 12:49:09','2022-03-03 12:49:09'),(56352,158,'Kustia','743330',1,0,'2022-03-03 12:49:09','2022-03-03 12:49:09'),(56353,158,'Kusumtala','743357',1,0,'2022-03-03 12:49:09','2022-03-03 12:49:09'),(56354,158,'Lahiri Pur','743370',1,0,'2022-03-03 12:49:09','2022-03-03 12:49:09'),(56355,158,'Lakshmi Janardanpur','743383',1,0,'2022-03-03 12:49:09','2022-03-03 12:49:09'),(56356,158,'Lakshmi Pabartak','743357',1,0,'2022-03-03 12:49:10','2022-03-03 12:49:10'),(56357,158,'Lakshmikantapur','743355',1,0,'2022-03-03 12:49:10','2022-03-03 12:49:10'),(56358,158,'Lalpur','743354',1,0,'2022-03-03 12:49:10','2022-03-03 12:49:10'),(56359,158,'Lalpur','743373',1,0,'2022-03-03 12:49:10','2022-03-03 12:49:10'),(56360,158,'Laskar Pur','700153',1,0,'2022-03-03 12:49:10','2022-03-03 12:49:10'),(56361,158,'Luksh Bagan','743370',1,0,'2022-03-03 12:49:10','2022-03-03 12:49:10'),(56362,158,'Madanganj','743357',1,0,'2022-03-03 12:49:10','2022-03-03 12:49:10'),(56363,158,'Madarat','743610',1,0,'2022-03-03 12:49:10','2022-03-03 12:49:10'),(56364,158,'Madhabnagar','743374',1,0,'2022-03-03 12:49:10','2022-03-03 12:49:10'),(56365,158,'Madhabnagar Durgagobindapur','743371',1,0,'2022-03-03 12:49:10','2022-03-03 12:49:10'),(56366,158,'Madhabpur','743349',1,0,'2022-03-03 12:49:10','2022-03-03 12:49:10'),(56367,158,'Madhukhali','743329',1,0,'2022-03-03 12:49:10','2022-03-03 12:49:10'),(56368,158,'Madhusudanchak','743349',1,0,'2022-03-03 12:49:10','2022-03-03 12:49:10'),(56369,158,'Madhya Gurguria','743349',1,0,'2022-03-03 12:49:10','2022-03-03 12:49:10'),(56370,158,'Madhya Monirtat','743349',1,0,'2022-03-03 12:49:10','2022-03-03 12:49:10'),(56371,158,'Madhya Shibpur','743372',1,0,'2022-03-03 12:49:10','2022-03-03 12:49:10'),(56372,158,'Magrahat','743355',1,0,'2022-03-03 12:49:10','2022-03-03 12:49:10'),(56373,158,'Magrahat Shyamnagar','743355',1,0,'2022-03-03 12:49:10','2022-03-03 12:49:10'),(56374,158,'Magrahat Shyampur','743355',1,0,'2022-03-03 12:49:10','2022-03-03 12:49:10'),(56375,158,'Maharajganj','743357',1,0,'2022-03-03 12:49:10','2022-03-03 12:49:10'),(56376,158,'Mahendraganj','743373',1,0,'2022-03-03 12:49:10','2022-03-03 12:49:10'),(56377,158,'Maheshdari','743609',1,0,'2022-03-03 12:49:10','2022-03-03 12:49:10'),(56378,158,'Maheshmari','743332',1,0,'2022-03-03 12:49:10','2022-03-03 12:49:10'),(56379,158,'Maheshpur','743355',1,0,'2022-03-03 12:49:10','2022-03-03 12:49:10'),(56380,158,'Maheshtala Gobindapur','700141',1,0,'2022-03-03 12:49:11','2022-03-03 12:49:11'),(56381,158,'Maheshwara','743609',1,0,'2022-03-03 12:49:11','2022-03-03 12:49:11'),(56382,158,'Mahestala','700141',1,0,'2022-03-03 12:49:11','2022-03-03 12:49:11'),(56383,158,'Maheswara','743368',1,0,'2022-03-03 12:49:11','2022-03-03 12:49:11'),(56384,158,'Maitala','743355',1,0,'2022-03-03 12:49:11','2022-03-03 12:49:11'),(56385,158,'Maiterhat','743355',1,0,'2022-03-03 12:49:11','2022-03-03 12:49:11'),(56386,158,'Makhna','743503',1,0,'2022-03-03 12:49:11','2022-03-03 12:49:11'),(56387,158,'Malancha Mahinagar','700145',1,0,'2022-03-03 12:49:11','2022-03-03 12:49:11'),(56388,158,'Malaya','743399',1,0,'2022-03-03 12:49:11','2022-03-03 12:49:11'),(56389,158,'Mallick Kati','743502',1,0,'2022-03-03 12:49:11','2022-03-03 12:49:11'),(56390,158,'Mallick Pratap','743355',1,0,'2022-03-03 12:49:11','2022-03-03 12:49:11'),(56391,158,'Mallickpore','700145',1,0,'2022-03-03 12:49:11','2022-03-03 12:49:11'),(56392,158,'Mandir Bazar','743395',1,0,'2022-03-03 12:49:11','2022-03-03 12:49:11'),(56393,158,'Manicknagar','743374',1,0,'2022-03-03 12:49:11','2022-03-03 12:49:11'),(56394,158,'Manir Tala','743373',1,0,'2022-03-03 12:49:11','2022-03-03 12:49:11'),(56395,158,'Manirtat','743349',1,0,'2022-03-03 12:49:11','2022-03-03 12:49:11'),(56396,158,'Manmathanagar (M)','743370',1,0,'2022-03-03 12:49:11','2022-03-03 12:49:11'),(56397,158,'Manmathapur','743347',1,0,'2022-03-03 12:49:11','2022-03-03 12:49:11'),(56398,158,'Manoharpur','743332',1,0,'2022-03-03 12:49:11','2022-03-03 12:49:11'),(56399,158,'Mansadwip','743373',1,0,'2022-03-03 12:49:11','2022-03-03 12:49:11'),(56400,158,'Masat','743375',1,0,'2022-03-03 12:49:11','2022-03-03 12:49:11'),(56401,158,'Masjidbati','743312',1,0,'2022-03-03 12:49:11','2022-03-03 12:49:11'),(56402,158,'Matgaran','743312',1,0,'2022-03-03 12:49:11','2022-03-03 12:49:11'),(56403,158,'Matherdighi','743329',1,0,'2022-03-03 12:49:12','2022-03-03 12:49:12'),(56404,158,'Mathur','743368',1,0,'2022-03-03 12:49:12','2022-03-03 12:49:12'),(56405,158,'Mathura Pur','743354',1,0,'2022-03-03 12:49:12','2022-03-03 12:49:12'),(56406,158,'Mathurapur RS','743354',1,0,'2022-03-03 12:49:12','2022-03-03 12:49:12'),(56407,158,'Mayadah','743337',1,0,'2022-03-03 12:49:12','2022-03-03 12:49:12'),(56408,158,'Mayahauri','743337',1,0,'2022-03-03 12:49:12','2022-03-03 12:49:12'),(56409,158,'Mayapur','743318',1,0,'2022-03-03 12:49:12','2022-03-03 12:49:12'),(56410,158,'Meherpur','743349',1,0,'2022-03-03 12:49:12','2022-03-03 12:49:12'),(56411,158,'Memanpur Chandannagar','700139',1,0,'2022-03-03 12:49:12','2022-03-03 12:49:12'),(56412,158,'Mestakhali','743503',1,0,'2022-03-03 12:49:12','2022-03-03 12:49:12'),(56413,158,'Miraganj','743329',1,0,'2022-03-03 12:49:12','2022-03-03 12:49:12'),(56414,158,'Mirpur Daulatpur','743610',1,0,'2022-03-03 12:49:12','2022-03-03 12:49:12'),(56415,158,'Mohirampur','743504',1,0,'2022-03-03 12:49:12','2022-03-03 12:49:12'),(56416,158,'Mokamberia','743312',1,0,'2022-03-03 12:49:12','2022-03-03 12:49:12'),(56417,158,'Monchisa','743377',1,0,'2022-03-03 12:49:12','2022-03-03 12:49:12'),(56418,158,'Monipur Banstala','743337',1,0,'2022-03-03 12:49:12','2022-03-03 12:49:12'),(56419,158,'Morapai','743355',1,0,'2022-03-03 12:49:12','2022-03-03 12:49:12'),(56420,158,'Morigachi','743368',1,0,'2022-03-03 12:49:12','2022-03-03 12:49:12'),(56421,158,'Moukhali','743610',1,0,'2022-03-03 12:49:12','2022-03-03 12:49:12'),(56422,158,'Mrinalnagar','743347',1,0,'2022-03-03 12:49:12','2022-03-03 12:49:12'),(56423,158,'Mrityunjoynagar','743373',1,0,'2022-03-03 12:49:12','2022-03-03 12:49:12'),(56424,158,'Muchikata Baikunthapur','743347',1,0,'2022-03-03 12:49:12','2022-03-03 12:49:12'),(56425,158,'Mud Point','743356',1,0,'2022-03-03 12:49:12','2022-03-03 12:49:12'),(56426,158,'Mukundapur','743368',1,0,'2022-03-03 12:49:12','2022-03-03 12:49:12'),(56427,158,'Multi','743610',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56428,158,'Mundapur Kashiabad','743347',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56429,158,'Muri Ganga','743373',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56430,158,'Nabagram','743372',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56431,158,'Nafarganj','743312',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56432,158,'Nagartala','743376',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56433,158,'Nagenabad','743383',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56434,158,'Nagendraganj','743373',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56435,158,'Nagendrapur','743383',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56436,158,'Nahazari','700104',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56437,158,'Nainan','743504',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56438,158,'Nalua','743354',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56439,158,'Nam Khana','743357',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56440,158,'Namkhana Radhanagar','743357',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56441,158,'Nandakumarpur','743349',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56442,158,'Naosha','743368',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56443,158,'Narayanibad','743373',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56444,158,'Narayanipur','743383',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56445,158,'Narayanpur','743363',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56446,158,'Narayanpur Gouripur','743332',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56447,158,'Narayantala','743329',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56448,158,'Narendrapur','700103',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56449,158,'Naria','743609',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56450,158,'Naskarpara Jalaberia','743338',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56451,158,'Natendrapur','743373',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56452,158,'Nathpara','743378',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56453,158,'Nayabad','700150',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56454,158,'Nayabad Rajpur','743354',1,0,'2022-03-03 12:49:13','2022-03-03 12:49:13'),(56455,158,'Nazra','743375',1,0,'2022-03-03 12:49:14','2022-03-03 12:49:14'),(56456,158,'Nepalganj','700103',1,0,'2022-03-03 12:49:14','2022-03-03 12:49:14'),(56457,158,'Netra','743368',1,0,'2022-03-03 12:49:14','2022-03-03 12:49:14'),(56458,158,'Nikarighata','743329',1,0,'2022-03-03 12:49:14','2022-03-03 12:49:14'),(56459,158,'Nilambarpur','743336',1,0,'2022-03-03 12:49:14','2022-03-03 12:49:14'),(56460,158,'Nimpith Ashram','743338',1,0,'2022-03-03 12:49:14','2022-03-03 12:49:14'),(56461,158,'Nishchinta Pur','743374',1,0,'2022-03-03 12:49:14','2022-03-03 12:49:14'),(56462,158,'Nodakhali','743318',1,0,'2022-03-03 12:49:14','2022-03-03 12:49:14'),(56463,158,'Noorpur','743368',1,0,'2022-03-03 12:49:14','2022-03-03 12:49:14'),(56464,158,'Noridana','743330',1,0,'2022-03-03 12:49:14','2022-03-03 12:49:14'),(56465,158,'Nungi','700140',1,0,'2022-03-03 12:49:14','2022-03-03 12:49:14'),(56466,158,'Pailanhat','700104',1,0,'2022-03-03 12:49:14','2022-03-03 12:49:14'),(56467,158,'Pairachali','743503',1,0,'2022-03-03 12:49:14','2022-03-03 12:49:14'),(56468,158,'Pakhiralaya','743370',1,0,'2022-03-03 12:49:14','2022-03-03 12:49:14'),(56469,158,'Pakurtala','743349',1,0,'2022-03-03 12:49:14','2022-03-03 12:49:14'),(56470,158,'Panapukur','743354',1,0,'2022-03-03 12:49:14','2022-03-03 12:49:14'),(56471,158,'Panarhat','743504',1,0,'2022-03-03 12:49:14','2022-03-03 12:49:14'),(56472,158,'Panchagram Singhberia','743368',1,0,'2022-03-03 12:49:14','2022-03-03 12:49:14'),(56473,158,'Panchnan','743336',1,0,'2022-03-03 12:49:14','2022-03-03 12:49:14'),(56474,158,'Panchpota','700152',1,0,'2022-03-03 12:49:14','2022-03-03 12:49:14'),(56475,158,'Parash Moni','743370',1,0,'2022-03-03 12:49:14','2022-03-03 12:49:14'),(56476,158,'Parbangla','700140',1,0,'2022-03-03 12:49:14','2022-03-03 12:49:14'),(56477,158,'Paschim Chamni','743503',1,0,'2022-03-03 12:49:14','2022-03-03 12:49:14'),(56478,158,'Paschim Dighirpar','743329',1,0,'2022-03-03 12:49:15','2022-03-03 12:49:15'),(56479,158,'Paschim Gopalnagar','743351',1,0,'2022-03-03 12:49:15','2022-03-03 12:49:15'),(56480,158,'Paschim Jata','743383',1,0,'2022-03-03 12:49:15','2022-03-03 12:49:15'),(56481,158,'Paschim Kultali','743354',1,0,'2022-03-03 12:49:15','2022-03-03 12:49:15'),(56482,158,'Paschim Radhaballavpur','743349',1,0,'2022-03-03 12:49:15','2022-03-03 12:49:15'),(56483,158,'Paschim Radhanagar','743378',1,0,'2022-03-03 12:49:15','2022-03-03 12:49:15'),(56484,158,'Paschim Rameswarpur','700140',1,0,'2022-03-03 12:49:15','2022-03-03 12:49:15'),(56485,158,'Paschim Sripatinagar','743383',1,0,'2022-03-03 12:49:15','2022-03-03 12:49:15'),(56486,158,'Paschim Surendranagar','743347',1,0,'2022-03-03 12:49:15','2022-03-03 12:49:15'),(56487,158,'Pathan Khali','743611',1,0,'2022-03-03 12:49:15','2022-03-03 12:49:15'),(56488,158,'Pathanberia','743377',1,0,'2022-03-03 12:49:15','2022-03-03 12:49:15'),(56489,158,'Pathar Pratima','743371',1,0,'2022-03-03 12:49:15','2022-03-03 12:49:15'),(56490,158,'Patibunia','743357',1,0,'2022-03-03 12:49:15','2022-03-03 12:49:15'),(56491,158,'Patra','743368',1,0,'2022-03-03 12:49:15','2022-03-03 12:49:15'),(56492,158,'Paulpur','743611',1,0,'2022-03-03 12:49:15','2022-03-03 12:49:15'),(56493,158,'Phulmalancha','743329',1,0,'2022-03-03 12:49:15','2022-03-03 12:49:15'),(56494,158,'Pikhira','743513',1,0,'2022-03-03 12:49:15','2022-03-03 12:49:15'),(56495,158,'Piyali Town','743387',1,0,'2022-03-03 12:49:15','2022-03-03 12:49:15'),(56496,158,'Poali','743318',1,0,'2022-03-03 12:49:15','2022-03-03 12:49:15'),(56497,158,'Pranballavpur','743395',1,0,'2022-03-03 12:49:15','2022-03-03 12:49:15'),(56498,158,'Prasad Pur','743373',1,0,'2022-03-03 12:49:15','2022-03-03 12:49:15'),(56499,158,'Pratapnagar','743330',1,0,'2022-03-03 12:49:15','2022-03-03 12:49:15'),(56500,158,'Puinjali','743378',1,0,'2022-03-03 12:49:15','2022-03-03 12:49:15'),(56501,158,'Pujali','700138',1,0,'2022-03-03 12:49:15','2022-03-03 12:49:15'),(56502,158,'Pukurberia','743347',1,0,'2022-03-03 12:49:15','2022-03-03 12:49:15'),(56503,158,'Punpua','743372',1,0,'2022-03-03 12:49:16','2022-03-03 12:49:16'),(56504,158,'Purandarpur','743349',1,0,'2022-03-03 12:49:16','2022-03-03 12:49:16'),(56505,158,'Purandarpur Math','743610',1,0,'2022-03-03 12:49:16','2022-03-03 12:49:16'),(56506,158,'Puratan Ramgarh','743504',1,0,'2022-03-03 12:49:16','2022-03-03 12:49:16'),(56507,158,'Purba Boyarsingh','743611',1,0,'2022-03-03 12:49:16','2022-03-03 12:49:16'),(56508,158,'Purba Chandpur','743336',1,0,'2022-03-03 12:49:16','2022-03-03 12:49:16'),(56509,158,'Purba Dwariknagar','743383',1,0,'2022-03-03 12:49:16','2022-03-03 12:49:16'),(56510,158,'Purba Gopalnagar','743395',1,0,'2022-03-03 12:49:16','2022-03-03 12:49:16'),(56511,158,'Purba Nischintapur','700138',1,0,'2022-03-03 12:49:16','2022-03-03 12:49:16'),(56512,158,'Purba Putiary','700093',1,0,'2022-03-03 12:49:16','2022-03-03 12:49:16'),(56513,158,'Purba Radhanagar','743378',1,0,'2022-03-03 12:49:16','2022-03-03 12:49:16'),(56514,158,'Purba Ramnathnagar','743355',1,0,'2022-03-03 12:49:16','2022-03-03 12:49:16'),(56515,158,'Purba Ranaghata','743338',1,0,'2022-03-03 12:49:16','2022-03-03 12:49:16'),(56516,158,'Purba Sonatikari','743349',1,0,'2022-03-03 12:49:16','2022-03-03 12:49:16'),(56517,158,'Purba Sridharpur','743383',1,0,'2022-03-03 12:49:16','2022-03-03 12:49:16'),(56518,158,'Purkaitpara','743354',1,0,'2022-03-03 12:49:16','2022-03-03 12:49:16'),(56519,158,'Purnachandrapur','743349',1,0,'2022-03-03 12:49:16','2022-03-03 12:49:16'),(56520,158,'R. C. Thakurani','700104',1,0,'2022-03-03 12:49:16','2022-03-03 12:49:16'),(56521,158,'R.K.Pally','700150',1,0,'2022-03-03 12:49:16','2022-03-03 12:49:16'),(56522,158,'Radhaballavpur','743349',1,0,'2022-03-03 12:49:16','2022-03-03 12:49:16'),(56523,158,'Radhakantapur','743354',1,0,'2022-03-03 12:49:16','2022-03-03 12:49:16'),(56524,158,'Radhakrishna Nagar','743373',1,0,'2022-03-03 12:49:16','2022-03-03 12:49:16'),(56525,158,'Radhanagar','743332',1,0,'2022-03-03 12:49:16','2022-03-03 12:49:16'),(56526,158,'Raghudebpur','743399',1,0,'2022-03-03 12:49:16','2022-03-03 12:49:16'),(56527,158,'Raghunathpur','743374',1,0,'2022-03-03 12:49:17','2022-03-03 12:49:17'),(56528,158,'Raidighi','743383',1,0,'2022-03-03 12:49:17','2022-03-03 12:49:17'),(56529,158,'Raipur','700141',1,0,'2022-03-03 12:49:17','2022-03-03 12:49:17'),(56530,158,'Rajarampur','743504',1,0,'2022-03-03 12:49:17','2022-03-03 12:49:17'),(56531,158,'Rajnagar','743347',1,0,'2022-03-03 12:49:17','2022-03-03 12:49:17'),(56532,158,'Rajnagar Bishwambar','743357',1,0,'2022-03-03 12:49:17','2022-03-03 12:49:17'),(56533,158,'Rajpur Bazar','700149',1,0,'2022-03-03 12:49:17','2022-03-03 12:49:17'),(56534,158,'Rajpur Karibag','743337',1,0,'2022-03-03 12:49:17','2022-03-03 12:49:17'),(56535,158,'Rajpur (South 24 Parganas)','700149',1,0,'2022-03-03 12:49:17','2022-03-03 12:49:17'),(56536,158,'Rakhal Pur','743371',1,0,'2022-03-03 12:49:17','2022-03-03 12:49:17'),(56537,158,'Rakshkhali','743371',1,0,'2022-03-03 12:49:17','2022-03-03 12:49:17'),(56538,158,'Ramanandapur','743332',1,0,'2022-03-03 12:49:17','2022-03-03 12:49:17'),(56539,158,'Ramchandranagar','743503',1,0,'2022-03-03 12:49:17','2022-03-03 12:49:17'),(56540,158,'Ramchandranagar','743399',1,0,'2022-03-03 12:49:17','2022-03-03 12:49:17'),(56541,158,'Ramchandrapur','743399',1,0,'2022-03-03 12:49:17','2022-03-03 12:49:17'),(56542,158,'Ramdebpur','743399',1,0,'2022-03-03 12:49:17','2022-03-03 12:49:17'),(56543,158,'Ramganga','743371',1,0,'2022-03-03 12:49:17','2022-03-03 12:49:17'),(56544,158,'Ramgopalpur','743387',1,0,'2022-03-03 12:49:17','2022-03-03 12:49:17'),(56545,158,'Ramkantanagar','743395',1,0,'2022-03-03 12:49:17','2022-03-03 12:49:17'),(56546,158,'Ramkrishnapur','743351',1,0,'2022-03-03 12:49:17','2022-03-03 12:49:17'),(56547,158,'Ramlochanpur','743336',1,0,'2022-03-03 12:49:17','2022-03-03 12:49:17'),(56548,158,'Ramnagar Shibpur','743374',1,0,'2022-03-03 12:49:17','2022-03-03 12:49:17'),(56549,158,'Ramnagarabad','743349',1,0,'2022-03-03 12:49:17','2022-03-03 12:49:17'),(56550,158,'Rampur','743329',1,0,'2022-03-03 12:49:17','2022-03-03 12:49:17'),(56551,158,'Ramratannagar','743374',1,0,'2022-03-03 12:49:17','2022-03-03 12:49:17'),(56552,158,'Ramrathanpur','743374',1,0,'2022-03-03 12:49:18','2022-03-03 12:49:18'),(56553,158,'Rangabelia','743370',1,0,'2022-03-03 12:49:18','2022-03-03 12:49:18'),(56554,158,'Rangilabad','743609',1,0,'2022-03-03 12:49:18','2022-03-03 12:49:18'),(56555,158,'Rania Gobindapur','743318',1,0,'2022-03-03 12:49:18','2022-03-03 12:49:18'),(56556,158,'Rasa Dogacha','743375',1,0,'2022-03-03 12:49:18','2022-03-03 12:49:18'),(56557,158,'Rasapunja','700104',1,0,'2022-03-03 12:49:18','2022-03-03 12:49:18'),(56558,158,'Raskhali','743610',1,0,'2022-03-03 12:49:18','2022-03-03 12:49:18'),(56559,158,'Roypur Dayarampur','743336',1,0,'2022-03-03 12:49:18','2022-03-03 12:49:18'),(56560,158,'Rudra Nagar','743373',1,0,'2022-03-03 12:49:18','2022-03-03 12:49:18'),(56561,158,'Sadhu Pur','743370',1,0,'2022-03-03 12:49:18','2022-03-03 12:49:18'),(56562,158,'Sadhurhat','743504',1,0,'2022-03-03 12:49:18','2022-03-03 12:49:18'),(56563,158,'Sagar Bag Bazar','743373',1,0,'2022-03-03 12:49:18','2022-03-03 12:49:18'),(56564,158,'Sagar Barabari','743373',1,0,'2022-03-03 12:49:18','2022-03-03 12:49:18'),(56565,158,'Sagar Chandipur','743373',1,0,'2022-03-03 12:49:18','2022-03-03 12:49:18'),(56566,158,'Sagar Fulbari','743373',1,0,'2022-03-03 12:49:18','2022-03-03 12:49:18'),(56567,158,'Sagar Krishna Nagar','743373',1,0,'2022-03-03 12:49:18','2022-03-03 12:49:18'),(56568,158,'Sagar Krishnapur','743373',1,0,'2022-03-03 12:49:18','2022-03-03 12:49:18'),(56569,158,'Sagar Shibpur','743373',1,0,'2022-03-03 12:49:18','2022-03-03 12:49:18'),(56570,158,'Sahararhat','743504',1,0,'2022-03-03 12:49:18','2022-03-03 12:49:18'),(56571,158,'Sambhunagar','743611',1,0,'2022-03-03 12:49:18','2022-03-03 12:49:18'),(56572,158,'Sangrampur Hat','743355',1,0,'2022-03-03 12:49:18','2022-03-03 12:49:18'),(56573,158,'Sankarpur','743610',1,0,'2022-03-03 12:49:18','2022-03-03 12:49:18'),(56574,158,'Santi Gachi','743370',1,0,'2022-03-03 12:49:18','2022-03-03 12:49:18'),(56575,158,'Santosh Pur (Maheshtala)so','700142',1,0,'2022-03-03 12:49:18','2022-03-03 12:49:18'),(56576,158,'Sapkhali','743373',1,0,'2022-03-03 12:49:18','2022-03-03 12:49:18'),(56577,158,'Sarachi','743375',1,0,'2022-03-03 12:49:19','2022-03-03 12:49:19'),(56578,158,'Sarangabad','700137',1,0,'2022-03-03 12:49:19','2022-03-03 12:49:19'),(56579,158,'Saratnagar','743354',1,0,'2022-03-03 12:49:19','2022-03-03 12:49:19'),(56580,158,'Saratpally','743349',1,0,'2022-03-03 12:49:19','2022-03-03 12:49:19'),(56581,158,'Sarberia','743372',1,0,'2022-03-03 12:49:19','2022-03-03 12:49:19'),(56582,158,'Sarberia','743377',1,0,'2022-03-03 12:49:19','2022-03-03 12:49:19'),(56583,158,'Sarisha','743368',1,0,'2022-03-03 12:49:19','2022-03-03 12:49:19'),(56584,158,'Sarkarpool','700143',1,0,'2022-03-03 12:49:19','2022-03-03 12:49:19'),(56585,158,'Sastitala','743337',1,0,'2022-03-03 12:49:19','2022-03-03 12:49:19'),(56586,158,'Satghara Debipur','743395',1,0,'2022-03-03 12:49:19','2022-03-03 12:49:19'),(56587,158,'Satjelia','743370',1,0,'2022-03-03 12:49:19','2022-03-03 12:49:19'),(56588,158,'Satyanarayanpur','743370',1,0,'2022-03-03 12:49:19','2022-03-03 12:49:19'),(56589,158,'Sekrabad','743503',1,0,'2022-03-03 12:49:19','2022-03-03 12:49:19'),(56590,158,'Seorahati','743504',1,0,'2022-03-03 12:49:19','2022-03-03 12:49:19'),(56591,158,'Seoratala','743348',1,0,'2022-03-03 12:49:19','2022-03-03 12:49:19'),(56592,158,'Serakole','743513',1,0,'2022-03-03 12:49:19','2022-03-03 12:49:19'),(56593,158,'Shankshar','743502',1,0,'2022-03-03 12:49:19','2022-03-03 12:49:19'),(56594,158,'Shanpukur','743502',1,0,'2022-03-03 12:49:19','2022-03-03 12:49:19'),(56595,158,'Sherpur','743513',1,0,'2022-03-03 12:49:19','2022-03-03 12:49:19'),(56596,158,'Shibganj','743312',1,0,'2022-03-03 12:49:19','2022-03-03 12:49:19'),(56597,158,'Shibgobindapur','743371',1,0,'2022-03-03 12:49:19','2022-03-03 12:49:19'),(56598,158,'Shibkalinagar','743374',1,0,'2022-03-03 12:49:19','2022-03-03 12:49:19'),(56599,158,'Shibnagar','743399',1,0,'2022-03-03 12:49:19','2022-03-03 12:49:19'),(56600,158,'Shibrampur','743357',1,0,'2022-03-03 12:49:19','2022-03-03 12:49:19'),(56601,158,'Shirnagarabad','743357',1,0,'2022-03-03 12:49:19','2022-03-03 12:49:19'),(56602,158,'Shyambasurchak','743351',1,0,'2022-03-03 12:49:19','2022-03-03 12:49:19'),(56603,158,'Shyamnagar Gobindapur','743337',1,0,'2022-03-03 12:49:20','2022-03-03 12:49:20'),(56604,158,'Shyampur','700137',1,0,'2022-03-03 12:49:20','2022-03-03 12:49:20'),(56605,158,'Siddheswarpur','743336',1,0,'2022-03-03 12:49:20','2022-03-03 12:49:20'),(56606,158,'Siddhiberia','743399',1,0,'2022-03-03 12:49:20','2022-03-03 12:49:20'),(56607,158,'Sikharbali','743387',1,0,'2022-03-03 12:49:20','2022-03-03 12:49:20'),(56608,158,'Sitakundu','743387',1,0,'2022-03-03 12:49:20','2022-03-03 12:49:20'),(56609,158,'Sitalatala Rajarampur','743513',1,0,'2022-03-03 12:49:20','2022-03-03 12:49:20'),(56610,158,'Sitarampur','743351',1,0,'2022-03-03 12:49:20','2022-03-03 12:49:20'),(56611,158,'Sonakhali','743312',1,0,'2022-03-03 12:49:20','2022-03-03 12:49:20'),(56612,158,'Sonapukur','743502',1,0,'2022-03-03 12:49:20','2022-03-03 12:49:20'),(56613,158,'Sonariania','743377',1,0,'2022-03-03 12:49:20','2022-03-03 12:49:20'),(56614,158,'Sonarpur','700150',1,0,'2022-03-03 12:49:20','2022-03-03 12:49:20'),(56615,158,'Sonatikary','743349',1,0,'2022-03-03 12:49:20','2022-03-03 12:49:20'),(56616,158,'South Bishnupur','743395',1,0,'2022-03-03 12:49:20','2022-03-03 12:49:20'),(56617,158,'South Garia','743613',1,0,'2022-03-03 12:49:20','2022-03-03 12:49:20'),(56618,158,'South Mohanpur','743610',1,0,'2022-03-03 12:49:20','2022-03-03 12:49:20'),(56619,158,'South Ramnagar','743387',1,0,'2022-03-03 12:49:20','2022-03-03 12:49:20'),(56620,158,'Sridharnagar','743371',1,0,'2022-03-03 12:49:20','2022-03-03 12:49:20'),(56621,158,'Sridurganagar','743349',1,0,'2022-03-03 12:49:20','2022-03-03 12:49:20'),(56622,158,'Srikrishnanagar','743372',1,0,'2022-03-03 12:49:20','2022-03-03 12:49:20'),(56623,158,'Srinagar Makrapara','743374',1,0,'2022-03-03 12:49:20','2022-03-03 12:49:20'),(56624,158,'Srinarayanpara','743399',1,0,'2022-03-03 12:49:20','2022-03-03 12:49:20'),(56625,158,'Subhas Gram','700147',1,0,'2022-03-03 12:49:20','2022-03-03 12:49:20'),(56626,158,'Sukdebpur','743503',1,0,'2022-03-03 12:49:20','2022-03-03 12:49:20'),(56627,158,'Sultanpur','743332',1,0,'2022-03-03 12:49:21','2022-03-03 12:49:21'),(56628,158,'Sumatinagar','743373',1,0,'2022-03-03 12:49:21','2022-03-03 12:49:21'),(56629,158,'Surajapurhat','743372',1,0,'2022-03-03 12:49:21','2022-03-03 12:49:21'),(56630,158,'Surjanagar','743374',1,0,'2022-03-03 12:49:21','2022-03-03 12:49:21'),(56631,158,'Suta Becha','743395',1,0,'2022-03-03 12:49:21','2022-03-03 12:49:21'),(56632,158,'Takipurabad','743347',1,0,'2022-03-03 12:49:21','2022-03-03 12:49:21'),(56633,158,'Taldi','743376',1,0,'2022-03-03 12:49:21','2022-03-03 12:49:21'),(56634,158,'Taltala','743338',1,0,'2022-03-03 12:49:21','2022-03-03 12:49:21'),(56635,158,'Tangrabichi','743338',1,0,'2022-03-03 12:49:21','2022-03-03 12:49:21'),(56636,158,'Tangrachar','743348',1,0,'2022-03-03 12:49:21','2022-03-03 12:49:21'),(56637,158,'Taranagar','743399',1,0,'2022-03-03 12:49:21','2022-03-03 12:49:21'),(56638,158,'Taranagar','743378',1,0,'2022-03-03 12:49:21','2022-03-03 12:49:21'),(56639,158,'Tarda Kapasati','743330',1,0,'2022-03-03 12:49:21','2022-03-03 12:49:21'),(56640,158,'Tasarala','743372',1,0,'2022-03-03 12:49:21','2022-03-03 12:49:21'),(56641,158,'Tekpanja','743355',1,0,'2022-03-03 12:49:21','2022-03-03 12:49:21'),(56642,158,'Tengrakhali','743329',1,0,'2022-03-03 12:49:21','2022-03-03 12:49:21'),(56643,158,'Tentulia','743610',1,0,'2022-03-03 12:49:21','2022-03-03 12:49:21'),(56644,158,'Tepakhali','743374',1,0,'2022-03-03 12:49:21','2022-03-03 12:49:21'),(56645,158,'Tezpur','743354',1,0,'2022-03-03 12:49:21','2022-03-03 12:49:21'),(56646,158,'Thakuraniberia','743376',1,0,'2022-03-03 12:49:21','2022-03-03 12:49:21'),(56647,158,'Thakurchak','743338',1,0,'2022-03-03 12:49:21','2022-03-03 12:49:21'),(56648,158,'Tilpi','743337',1,0,'2022-03-03 12:49:21','2022-03-03 12:49:21'),(56649,158,'Titkumar','743329',1,0,'2022-03-03 12:49:21','2022-03-03 12:49:21'),(56650,158,'Uchhepota','700150',1,0,'2022-03-03 12:49:21','2022-03-03 12:49:21'),(56651,158,'Urel Chandpur','743355',1,0,'2022-03-03 12:49:22','2022-03-03 12:49:22'),(56652,158,'Usthi','743375',1,0,'2022-03-03 12:49:22','2022-03-03 12:49:22'),(56653,158,'Uttar Ballavpur','743336',1,0,'2022-03-03 12:49:22','2022-03-03 12:49:22'),(56654,158,'Uttar Gopalnagar','743347',1,0,'2022-03-03 12:49:22','2022-03-03 12:49:22'),(56655,158,'Uttar Kankandighi','743383',1,0,'2022-03-03 12:49:22','2022-03-03 12:49:22'),(56656,158,'Uttar Kasthamahal','743503',1,0,'2022-03-03 12:49:22','2022-03-03 12:49:22'),(56657,158,'Uttar Kusum','743375',1,0,'2022-03-03 12:49:22','2022-03-03 12:49:22'),(56658,158,'Uttar Lakshminarayanpur','743354',1,0,'2022-03-03 12:49:22','2022-03-03 12:49:22'),(56659,158,'Uttar Madhabpur','743502',1,0,'2022-03-03 12:49:22','2022-03-03 12:49:22'),(56660,158,'Uttar Moukhali','743329',1,0,'2022-03-03 12:49:22','2022-03-03 12:49:22'),(56661,158,'Uttar Mukundapur','743332',1,0,'2022-03-03 12:49:22','2022-03-03 12:49:22'),(56662,158,'Uttar Raipur','700137',1,0,'2022-03-03 12:49:22','2022-03-03 12:49:22'),(56663,158,'Uttar Rajarampur','743332',1,0,'2022-03-03 12:49:22','2022-03-03 12:49:22'),(56664,158,'Uttar Shibrampur','743399',1,0,'2022-03-03 12:49:22','2022-03-03 12:49:22'),(56665,158,'Uttardanga','743370',1,0,'2022-03-03 12:49:22','2022-03-03 12:49:22'),(56666,158,'Uttarsitaram Pur','743371',1,0,'2022-03-03 12:49:22','2022-03-03 12:49:22'),(56667,158,'Vivekananda Pally','700139',1,0,'2022-03-03 12:49:22','2022-03-03 12:49:22'),(56668,158,'Vivekanandapur','700141',1,0,'2022-03-03 12:49:22','2022-03-03 12:49:22'),(56669,159,'Ajmatpur','733127',1,0,'2022-03-03 12:49:22','2022-03-03 12:49:22'),(56670,159,'Aminpur','733132',1,0,'2022-03-03 12:49:22','2022-03-03 12:49:22'),(56671,159,'Amrail','733103',1,0,'2022-03-03 12:49:22','2022-03-03 12:49:22'),(56672,159,'Amritakhanda Hat','733103',1,0,'2022-03-03 12:49:22','2022-03-03 12:49:22'),(56673,159,'Angina','733141',1,0,'2022-03-03 12:49:22','2022-03-03 12:49:22'),(56674,159,'Arajipanishalahat','733132',1,0,'2022-03-03 12:49:22','2022-03-03 12:49:22'),(56675,159,'Ashokegram','733141',1,0,'2022-03-03 12:49:22','2022-03-03 12:49:22'),(56676,159,'Atrai','733158',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56677,159,'Badalpur','733121',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56678,159,'Bagichapur','733125',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56679,159,'Bairhatta','733125',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56680,159,'Balapur','733127',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56681,159,'Balurghat H.O','733101',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56682,159,'Balurghat Market','733101',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56683,159,'Bandighi','733140',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56684,159,'Banial','733127',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56685,159,'Banshihari','733121',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56686,159,'Baragarm','733128',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56687,159,'Barakashipur','733102',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56688,159,'BaraRaghunathpur','733103',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56689,159,'Bartakigram','733125',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56690,159,'Basoil','733132',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56691,159,'Basuria','733142',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56692,159,'Batun','733133',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56693,159,'Baul','733158',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56694,159,'Bedoypur','733103',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56695,159,'Belbari','733124',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56696,159,'Beltala Park','733103',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56697,159,'Beltara','733133',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56698,159,'Berail','733132',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56699,159,'Bhagabatipur','733141',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56700,159,'Bharila','733102',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56701,159,'Bhatra','733102',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56702,159,'Bhikahar','733142',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56703,159,'Bholanathpur','733141',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56704,159,'Bijoyshree','733103',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56705,159,'Birohini','733103',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56706,159,'Biswanathpur','733121',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56707,159,'Bolla','733158',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56708,159,'Buniadpur','733121',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56709,159,'Chakbaliram','733127',1,0,'2022-03-03 12:49:23','2022-03-03 12:49:23'),(56710,159,'Chakbhabani','733101',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56711,159,'Chakvrigu','733102',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56712,159,'Champatali','733124',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56713,159,'Chandganj','733141',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56714,159,'Chenchra','733124',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56715,159,'Cheragipara','733121',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56716,159,'Chingishpur','733145',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56717,159,'Chousa','733132',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56718,159,'Churail Krishnapur','733141',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56719,159,'Dakra','733102',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56720,159,'Dakshin Shibrampur','733103',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56721,159,'Danagram','733125',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56722,159,'Dangarhat','733141',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56723,159,'Daralhat','733127',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56724,159,'Daulatpur (South Dinajpur)B.O','733125',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56725,159,'Debipur','733141',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56726,159,'Dehaband','733132',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56727,159,'Deor','733140',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56728,159,'Dikul','733121',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56729,159,'District School Board (South Dinajpur)','733101',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56730,159,'Fatepur','733126',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56731,159,'Fulbari','733140',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56732,159,'Gangarampur','733124',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56733,159,'Gobindapur','733133',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56734,159,'Gofanagar','733102',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56735,159,'Gopalbati','733145',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56736,159,'Gopalganj','733141',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56737,159,'Gurail','733142',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56738,159,'Harirampur','733125',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56739,159,'Hili Aftair','733126',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56740,159,'Hili','733126',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56741,159,'Holidana','733127',1,0,'2022-03-03 12:49:24','2022-03-03 12:49:24'),(56742,159,'Jahangirpur','733124',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56743,159,'Jakhirpur','733141',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56744,159,'Jalalpur','733124',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56745,159,'Jalghar','733102',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56746,159,'Jamalpur','733145',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56747,159,'Janchi','733140',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56748,159,'Joredighi','733121',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56749,159,'Joypur','733142',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56750,159,'Kalaibari','733128',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56751,159,'Kaldighi','733124',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56752,159,'Kalikamora','733121',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56753,159,'Kamarpara','733145',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56754,159,'Kamdebbati','733127',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56755,159,'Kanaipur','733125',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56756,159,'Kantabari','733124',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56757,159,'Karai','733121',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56758,159,'Karaichenchra','733127',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56759,159,'Kardah','733142',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56760,159,'Karkha','733121',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56761,159,'Khadimpur','733101',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56762,159,'Khanpur','733133',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56763,159,'Khaspur','733102',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56764,159,'Khidirpur','733103',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56765,159,'Kuaran','733102',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56766,159,'Kumarganj','733141',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56767,159,'Kuraha','733141',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56768,159,'Kushkari','733121',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56769,159,'Kushmandi','733132',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56770,159,'Laskarhat','733127',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56771,159,'Laxmitola','733124',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56772,159,'Mahadebpur','733127',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56773,159,'Mahanaj','733140',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56774,159,'Mahipal','733121',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56775,159,'Mahipur','733141',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56776,159,'Maliandighi','733125',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56777,159,'Manikore','733132',1,0,'2022-03-03 12:49:25','2022-03-03 12:49:25'),(56778,159,'Manohali','733142',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56779,159,'Nahit','733132',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56780,159,'Nandanpur','733124',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56781,159,'Narai','733124',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56782,159,'Narayanpur','733141',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56783,159,'Narayanpur (South Dinajpur)','733101',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56784,159,'Nayabazar (South Dinajpur)','733142',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56785,159,'Nazirpur','733133',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56786,159,'Nilgambhir','733121',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56787,159,'Nunail','733103',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56788,159,'Panchagram','733140',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56789,159,'Panitara','733141',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56790,159,'Parameshwarpur','733132',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56791,159,'Patiram','733133',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56792,159,'Patkola','733127',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56793,159,'Powrahar','733145',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56794,159,'Pransagar','733140',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56795,159,'Pundari','733125',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56796,159,'Purba Mollapara','733124',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56797,159,'Radhakrishnapur','733133',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56798,159,'Radhanagar','733102',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56799,159,'Raghabpur','733124',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56800,159,'Rajibpur','733124',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56801,159,'Rajua','733102',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56802,159,'Ramchandrapur','733127',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56803,159,'Ramkrishnapur','733140',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56804,159,'Rampur (South Dinajpur)','733140',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56805,159,'Ratanpur','733124',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56806,159,'S.N.Pur','733125',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56807,159,'Safanagar','733141',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56808,159,'Sahapur Jharbari','733132',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56809,159,'Samjhia','733141',1,0,'2022-03-03 12:49:26','2022-03-03 12:49:26'),(56810,159,'Sarala','733132',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56811,159,'Sarangram','733103',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56812,159,'Sarbamangala','733124',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56813,159,'Sayedpur','733133',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56814,159,'School Para','733101',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56815,159,'Sibkrishnapur','733132',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56816,159,'Sihole','733121',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56817,159,'Singadaha','733125',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56818,159,'Sudarshannagar','733121',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56819,159,'Sukdebpur','733124',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56820,159,'Tapan','733127',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56821,159,'Telighata','733127',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56822,159,'Teor','733145',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56823,159,'Thakurpurahat','733145',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56824,159,'Tilon','733127',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56825,159,'Trimohini','733126',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56826,159,'Usha Haranhat','733132',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56827,159,'Uttar Karanji','733132',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56828,159,'Uttar Para','733132',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56829,160,'Adasimla','721467',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56830,160,'Akanda','721424',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56831,160,'Akpura','721457',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56832,160,'Amarda','721436',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56833,160,'Amda','721133',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56834,160,'Andhari','721143',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56835,160,'Andhari Maubhandar','721143',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56836,160,'Angua','721426',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56837,160,'Anikola','721457',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56838,160,'Asda','721445',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56839,160,'Babla','721445',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56840,160,'Bachhurkhoyar','721143',1,0,'2022-03-03 12:49:27','2022-03-03 12:49:27'),(56841,160,'Baghasti','721133',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56842,160,'Baharadari','721143',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56843,160,'Bahurupa','721437',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56844,160,'Bakhrabad','721424',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56845,160,'Bakrachak','721135',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56846,160,'Bakurpada','721451',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56847,160,'Baligeria','721125',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56848,160,'Bamanda','721426',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56849,160,'Bandhuchak','721443',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56850,160,'Banisole','721125',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56851,160,'Banjhatia','721426',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56852,160,'Banskuthi','721125',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56853,160,'Barachara','721467',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56854,160,'Barakalankai','721437',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56855,160,'Baranegui','721125',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56856,160,'Barangi','721457',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56857,160,'Basuli Bazar','721425',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56858,160,'Bayenda','721425',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56859,160,'Begunia','721436',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56860,160,'Belda','721424',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56861,160,'Belmula','721426',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56862,160,'Benadiha','721133',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56863,160,'Bhadrakali','721437',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56864,160,'Bhaghadari','721425',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56865,160,'Bhasra','721133',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56866,160,'Binandapur','721135',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56867,160,'Birbira','721437',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56868,160,'Bonai','721467',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56869,160,'Bonpura','721143',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56870,160,'Borah','721133',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56871,160,'Borai','721457',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56872,160,'Brahamankhalisa','721443',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56873,160,'Chak Islampur','721457',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56874,160,'Chakla','721133',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56875,160,'Chakmahima','721424',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56876,160,'Chandabila','721125',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56877,160,'Chandkuti-batikati','721467',1,0,'2022-03-03 12:49:28','2022-03-03 12:49:28'),(56878,160,'Chaulia','721426',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56879,160,'Chhatorkole','721467',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56880,160,'Chhorda','721135',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56881,160,'Chhoto-chatla','721424',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56882,160,'Chilkipada','721125',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56883,160,'Chunpara','721135',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56884,160,'Dantan','721426',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56885,160,'Dasagram','721467',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56886,160,'Deulinekurseni','721451',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56887,160,'Dhalbelun','721424',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56888,160,'Dhangarpara','721424',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56889,160,'Dhuipada','721457',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56890,160,'Dhumsai','721125',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56891,160,'Dobaria','721457',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56892,160,'Dokra','721125',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56893,160,'Dolgram','721125',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56894,160,'Dumandari','721425',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56895,160,'Dumuria Sirisboni','721135',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56896,160,'Duria','721467',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56897,160,'Ekarukhi','721445',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56898,160,'Fulgeria','721437',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56899,160,'Gaganeswar','721133',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56900,160,'Gaita','721424',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56901,160,'Ganasarisa','721133',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56902,160,'Garh Haripur','721443',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56903,160,'Garh Radhanagar','721445',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56904,160,'Garh-monoharpur','721451',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56905,160,'Gazipur','721426',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56906,160,'Gomunda','721457',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56907,160,'Handlarajgarh','721437',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56908,160,'Ibarpanda','721437',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56909,160,'Jahalda','721443',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56910,160,'Jamirapalgarh','721426',1,0,'2022-03-03 12:49:29','2022-03-03 12:49:29'),(56911,160,'Jamsole','721133',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56912,160,'Jenkapur','721435',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56913,160,'Jhanjianankar','721437',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56914,160,'Jharia','721159',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56915,160,'June Belda','721133',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56916,160,'Kakrajit','721426',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56917,160,'Kalasbarh','721467',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56918,160,'Kalmapukhuria','721159',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56919,160,'Kanpur','721424',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56920,160,'Kanthalia','721437',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56921,160,'Kashimpur','721451',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56922,160,'Kashipur','721424',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56923,160,'Keshiapada','721135',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56924,160,'Keshiary','721133',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56925,160,'Keshrambha','721451',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56926,160,'Keut Khalisa','721443',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56927,160,'Khakurda','721445',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56928,160,'Khalina','721424',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56929,160,'Kharikamathani','721159',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56930,160,'Khatnagar','721451',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56931,160,'Khurshi','721437',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56932,160,'Kolanda','721467',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56933,160,'Konarpur','721437',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56934,160,'Kotaigarh','721437',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56935,160,'Kotepada','721426',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56936,160,'Kukai','721133',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56937,160,'Kuldiha','721125',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56938,160,'Kultikri','721135',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56939,160,'Kumarda','721457',1,0,'2022-03-03 12:49:30','2022-03-03 12:49:30'),(56940,160,'Kushbasan','721445',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56941,160,'Kushgeria','721133',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56942,160,'Kutki','721451',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56943,160,'Lalat','721443',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56944,160,'Lalitapur','721426',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56945,160,'Lalnagar','721424',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56946,160,'Laudaha','721135',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56947,160,'Laudangri','721445',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56948,160,'Lengamara','721133',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56949,160,'Lohabaranchak','721437',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56950,160,'Makrampurbazar','721437',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56951,160,'Maljamuna','721451',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56952,160,'Markanda','721133',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56953,160,'Matibaruan','721457',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56954,160,'Menkapur','721435',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56955,160,'Mirzapur Belda','721445',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56956,160,'Mohanpur Market','721436',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56957,160,'Mohanpur (West Midnapore)','721436',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56958,160,'Morchi','721125',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56959,160,'Murabani','721426',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56960,160,'Mustafapur','721443',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56961,160,'Nachhipur','721133',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56962,160,'Nagripada','721125',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56963,160,'Nankarmaguria','721437',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56964,160,'Narayangarh (West Midnapore)','721437',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56965,160,'Narda','721143',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56966,160,'Nayagram','721159',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56967,160,'Nekrasole','721159',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56968,160,'Nekurseni','721451',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56969,160,'Nilda','721457',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56970,160,'Paika','721125',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56971,160,'Palsandapur','721451',1,0,'2022-03-03 12:49:31','2022-03-03 12:49:31'),(56972,160,'Paragana','721426',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56973,160,'Paroi','721436',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56974,160,'Pathra','721135',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56975,160,'Phandar','721424',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56976,160,'Porolda','721445',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56977,160,'Purunda','721445',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56978,160,'Rajnagar','721436',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56979,160,'Rampura','721437',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56980,160,'Ranbonia','721135',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56981,160,'Rautarabari','721467',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56982,160,'Rautarapur','721133',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56983,160,'Remu','721457',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56984,160,'Renjura','721443',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56985,160,'Reripur','721424',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56986,160,'Rohini','721143',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56987,160,'Sabra','721445',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56988,160,'Salikotha','721435',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56989,160,'Saljora','721424',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56990,160,'Saluka','721437',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56991,160,'Sansadgopinathpur','721437',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56992,160,'Santrapur','721133',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56993,160,'Saorapin','721426',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56994,160,'Sarrang','721426',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56995,160,'Sarta','721467',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56996,160,'Satpautia','721125',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56997,160,'Sauri','721445',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56998,160,'Sautia','721457',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(56999,160,'Singaijamuna','721133',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(57000,160,'Siyalsai','721436',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(57001,160,'Sonakonia','721426',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(57002,160,'Sukharole','721133',1,0,'2022-03-03 12:49:32','2022-03-03 12:49:32'),(57003,160,'Susinda','721445',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57004,160,'Talda Ratanchak','721435',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57005,160,'Tanua','721436',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57006,160,'Tararui','721451',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57007,160,'Tarua','721424',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57008,160,'Tentuliabhumjan','721437',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57009,160,'Thakurchak','721424',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57010,160,'Tilaboni Mahisamunda','721135',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57011,160,'Tufuria Kamalpur','721159',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57012,160,'Turka Garh','721445',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57013,160,'Turkagarh','721445',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57014,160,'Uchudiha','721451',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57015,160,'Uparjagatpur','721424',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57016,160,'Uttar Dumurkhola','721133',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57017,160,'Uttar Ranibarh','721426',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57018,160,'Abash','721102',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57019,160,'Agar','721222',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57020,160,'Agra','721121',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57021,160,'Aguibil','721501',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57022,160,'Aguiboni','721517',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57023,160,'Ajodhya Nagar','721150',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57024,160,'Akalpoush','721156',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57025,160,'Akanischintapur','721504',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57026,160,'Akchara','721253',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57027,160,'Aknageria','721140',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57028,160,'Alampur','721506',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57029,160,'Aloke Kendra','721156',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57030,160,'Alui','721232',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57031,160,'Ambi','721517',1,0,'2022-03-03 12:49:33','2022-03-03 12:49:33'),(57032,160,'Amdangra','721260',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57033,160,'Amdapal','721517',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57034,160,'Amdoi','721513',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57035,160,'Amjore','721157',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57036,160,'Amlagora','721121',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57037,160,'Amlasuli','721157',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57038,160,'Amlatora','721505',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57039,160,'Amrakuchi','721150',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57040,160,'Amritpur','721150',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57041,160,'Amsole','721201',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57042,160,'Amuria','721260',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57043,160,'Anandapur (West Midnapore)','721122',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57044,160,'Andharia','721504',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57045,160,'Andharia Bandri Sole','721128',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57046,160,'Andharnayan','721201',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57047,160,'Andulia','721144',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57048,160,'Antala','721124',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57049,160,'Arjuni','721126',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57050,160,'Asanboni','721506',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57051,160,'Ashakanthi','721515',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57052,160,'Asui','721506',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57053,160,'Athangi','721506',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57054,160,'Attrakhi','721149',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57055,160,'Badalpur','721166',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57056,160,'Baghuasole','721517',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57057,160,'Bagnabarh','721155',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57058,160,'Bagri Krishnanagar','721121',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57059,160,'Baichakuria','721503',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57060,160,'Bakra','721506',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57061,160,'Bala','721201',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57062,160,'Balarampur','721301',1,0,'2022-03-03 12:49:34','2022-03-03 12:49:34'),(57063,160,'Balia Bhutkahalia','721503',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57064,160,'Balidanga','721212',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57065,160,'Balidiha','721503',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57066,160,'Balipal','721517',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57067,160,'Ballichak','721124',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57068,160,'Balpai','721155',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57069,160,'Bamal','721516',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57070,160,'Bamundiha','721501',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57071,160,'Bandar','721212',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57072,160,'Bandgora','721514',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57073,160,'Bandipur','721260',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57074,160,'Banka','721201',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57075,160,'Banpatna','721301',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57076,160,'Banpukuria','721121',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57077,160,'Bansda Palashi','721160',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57078,160,'Banspahari','721501',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57079,160,'Barachu','721301',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57080,160,'Barageria','721140',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57081,160,'Barateghari','721122',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57082,160,'Barati','721136',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57083,160,'Barbasi','721149',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57084,160,'Bargokulpur','721301',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57085,160,'Barhgobinda','721211',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57086,160,'Barjagu','721144',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57087,160,'Barkand Ramchandrapur','721513',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57088,160,'Barkola','721301',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57089,160,'Barpara','721253',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57090,160,'Barsahara','721144',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57091,160,'Basanda','721506',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57092,160,'Belatikri','721516',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57093,160,'Belia Bhutkahalia','721517',1,0,'2022-03-03 12:49:35','2022-03-03 12:49:35'),(57094,160,'Beliabera','721517',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57095,160,'Belpahari','721501',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57096,160,'Beluria','721155',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57097,160,'Belyamaharajpur','721260',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57098,160,'Benachapra','721201',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57099,160,'Benai','721212',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57100,160,'Benapur','721301',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57101,160,'Benasuli','721505',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57102,160,'Betjharia','721121',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57103,160,'Beuncha','721129',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57104,160,'Bhadutala','721129',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57105,160,'Bhagabantapur','721201',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57106,160,'Bhagirathpur','721136',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57107,160,'Bhandaru','721504',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57108,160,'Bhangabandh','721515',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57109,160,'Bhangabandh','721211',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57110,160,'Bharatpur','721156',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57111,160,'Bhelaidiha','721515',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57112,160,'Bhemua','721155',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57113,160,'Bhila','721506',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57114,160,'Bhimpur','721516',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57115,160,'Bhoudi','721147',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57116,160,'Bhulaveda','721501',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57117,160,'Bhuta','721211',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57118,160,'Bikrampur','721136',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57119,160,'Binpur','721514',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57120,160,'Birihandi','721514',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57121,160,'Birsingha','721222',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57122,160,'Bishnupur Bazar','721144',1,0,'2022-03-03 12:49:36','2022-03-03 12:49:36'),(57123,160,'Biswanathpur Patna','721156',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57124,160,'Bodhna','721514',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57125,160,'Boicha','721301',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57126,160,'Borsole','721501',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57127,160,'Boulasini','721156',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57128,160,'Boxibazar','721101',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57129,160,'Brahmanbasan','721211',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57130,160,'Brahmansasan','721124',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57131,160,'Bulanpur','721128',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57132,160,'Buriapat','721260',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57133,160,'Burimole','721513',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57134,160,'Chabukiauttarbarh','721144',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57135,160,'Chakadoba','721501',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57136,160,'Chakbajit','721136',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57137,160,'Chaklachipur','721232',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57138,160,'Chaklahana','721126',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57139,160,'Chakmakrampur','721149',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57140,160,'Chaknarsing','721126',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57141,160,'Chakpurusottampur','721211',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57142,160,'Chakshyampur','721124',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57143,160,'Chamarbandh','721506',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57144,160,'Chandeabila Khudiasole','721127',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57145,160,'Chandra','721102',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57146,160,'Chandrakona','721201',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57147,160,'Chandri','721503',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57148,160,'Chandur','721260',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57149,160,'Changual','721301',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57150,160,'Charakpahari','721501',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57151,160,'Charchita','721506',1,0,'2022-03-03 12:49:37','2022-03-03 12:49:37'),(57152,160,'Charkabani','721513',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57153,160,'Chaulkuri','721144',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57154,160,'Chechua Gobinda Nagar','721146',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57155,160,'Chetua Makrampur','721211',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57156,160,'Chetua Rajnagar','721211',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57157,160,'Chhatinasole','721506',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57158,160,'Chhatraganj','721201',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57159,160,'Chhota Bhagabanpur','721126',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57160,160,'Chhotonakdona','721157',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57161,160,'Chhotosukjora','721515',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57162,160,'Chichra','721503',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57163,160,'Chilkigarh','721503',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57164,160,'Chingurkasa','721513',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57165,160,'Chowka','721232',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57166,160,'Dadpur','721211',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57167,160,'Dahijuri','721504',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57168,160,'Dandipur','721222',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57169,160,'Dangalsa','721131',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57170,160,'Darra','721124',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57171,160,'Daspur','721211',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57172,160,'Debagram','721128',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57173,160,'Debra Bazar','721126',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57174,160,'Demouli','721145',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57175,160,'Deopur Amdan','721242',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57176,160,'Dhadangri','721517',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57177,160,'Dhadika','721127',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57178,160,'Dhamcha','721121',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57179,160,'Dhamsai','721144',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57180,160,'Dhamsole','721506',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57181,160,'Dhamtore','721126',1,0,'2022-03-03 12:49:38','2022-03-03 12:49:38'),(57182,160,'Dhaneswarpur','721166',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57183,160,'Dhanyagachi','721201',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57184,160,'Dharampur','721516',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57185,160,'Dharampur','721211',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57186,160,'Dharenda','721304',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57187,160,'Dharsa','721505',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57188,160,'Dhekia','721304',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57189,160,'Dheko','721504',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57190,160,'Dherua','721102',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57191,160,'Dhuniapara','721513',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57192,160,'Dhyamkuria','721201',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57193,160,'Dianpur','721242',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57194,160,'Diasi','721515',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57195,160,'Dihiramnagar','721212',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57196,160,'Dingal','721160',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57197,160,'Dingal Kamargeria','721232',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57198,160,'Dirghagram','721212',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57199,160,'Dobati','721121',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57200,160,'Doriayodhya','721212',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57201,160,'Duan','721160',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57202,160,'Dubra','721505',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57203,160,'Dudhkundi','721513',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57204,160,'Duki','721253',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57205,160,'Dumuria','721505',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57206,160,'Duria Radhaballav','721122',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57207,160,'Dwarigeria','721253',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57208,160,'Ellaboni','721102',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57209,160,'Ergoda','721505',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57210,160,'Eriamara','721157',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57211,160,'Fatechak','721144',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57212,160,'Fatepur','721146',1,0,'2022-03-03 12:49:39','2022-03-03 12:49:39'),(57213,160,'Fatesingpur','721121',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57214,160,'Fulberia','721127',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57215,160,'Gajasimul','721513',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57216,160,'Garh Salboni','721514',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57217,160,'Garhbeta','721127',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57218,160,'Garhsenapatya','721260',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57219,160,'Ghatal Bazar','721212',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57220,160,'Ghatal','721212',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57221,160,'Ghatiara','721506',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57222,160,'Ghatmura','721201',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57223,160,'Ghoradaha','721212',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57224,160,'Ghoshdiha','721156',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57225,160,'Ghoshpur','721150',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57226,160,'Ghutia','721503',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57227,160,'Gidni','721505',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57228,160,'Goaltore','721128',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57229,160,'Gobardhanpur','721131',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57230,160,'Godapeasal','721129',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57231,160,'Gohaldanga','721232',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57232,160,'Gohaldihi','721129',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57233,160,'Golar','721260',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57234,160,'Gole Bazar','721301',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57235,160,'Golegram','721136',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57236,160,'Gopalsole','721127',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57237,160,'Gopi Ballavpur','721506',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57238,160,'Gopmahal','721212',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57239,160,'Goura','721146',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57240,160,'Guiadaha','721253',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57241,160,'Gurguripal','721102',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57242,160,'Gurmabhamal','721517',1,0,'2022-03-03 12:49:40','2022-03-03 12:49:40'),(57243,160,'Guruganj','721124',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57244,160,'Habibpur (West Midnapore)','721101',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57245,160,'Harda','721504',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57246,160,'Harekrishnapur','721211',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57247,160,'Hariatara','721304',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57248,160,'Hariharpur','721136',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57249,160,'Harinagar','721232',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57250,160,'Harinarayanpur Dharampur','721504',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57251,160,'Harirajpur','721211',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57252,160,'Harirampur','721211',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57253,160,'Harishpur','721305',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57254,160,'Hatsarberia','721146',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57255,160,'Hatsultanpur','721149',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57256,160,'Hematpur','721232',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57257,160,'Hijli Co-operative','721306',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57258,160,'Hijli','721306',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57259,160,'Hiradharpur','721232',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57260,160,'Hiradihi','721301',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57261,160,'Hodal Srirampur','721232',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57262,160,'Hoomgarh','721157',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57263,160,'Hour','721131',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57264,160,'Inda','721305',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57265,160,'Irpala','721222',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57266,160,'Jagardanga','721121',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57267,160,'Jagul','721149',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57268,160,'Jahanpur','721517',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57269,160,'Jakpur','721301',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57270,160,'Jalchak','721155',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57271,160,'Jamda (West Midnapore)','721507',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57272,160,'Jamna','721140',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57273,160,'Janaghati','721506',1,0,'2022-03-03 12:49:41','2022-03-03 12:49:41'),(57274,160,'Janardanpur','721149',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57275,160,'Jara','721232',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57276,160,'Jashorajpur','721160',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57277,160,'Jashpur','721504',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57278,160,'Jatrabishnupur','721147',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57279,160,'Jayantinarayanchak','721150',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57280,160,'Jayantipur','721201',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57281,160,'Jaynagar','721212',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57282,160,'Jhakra','721201',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57283,160,'Jhalka','721150',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57284,160,'Jhanjia','721124',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57285,160,'Jhantibandh','721513',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57286,160,'Jhargram H.O','721507',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57287,160,'Jhargram Rajbati','721514',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57288,160,'Jhariabandhgora','721517',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57289,160,'Jhentla','721150',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57290,160,'Jhikuria','721156',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57291,160,'Jirapara','721121',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57292,160,'Jorakhali','721514',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57293,160,'Jorananda','721517',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57294,160,'Jotebani','721211',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57295,160,'Jotekanuram Garh','721212',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57296,160,'Joypur','721513',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57297,160,'Jugdiha','721517',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57298,160,'Kadodiha','721505',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57299,160,'Kadra','721253',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57300,160,'Kaijuri','721212',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57301,160,'Kaima','721517',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57302,160,'Kalagram','721150',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57303,160,'Kalaikunda A F','721303',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57304,160,'Kalaimuri','721516',1,0,'2022-03-03 12:49:42','2022-03-03 12:49:42'),(57305,160,'Kalakari','721201',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57306,160,'Kalara','721146',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57307,160,'Kalidan','721131',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57308,160,'Kalikadihi','721124',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57309,160,'Kalikageria','721136',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57310,160,'Kalinja','721517',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57311,160,'Kalla','721201',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57312,160,'Kalmijore','721211',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57313,160,'Kamalpur Sriramnagar','721212',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57314,160,'Kamargeria','721122',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57315,160,'Kanasole','721122',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57316,160,'Kanikha','721149',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57317,160,'Kanimohuli','721503',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57318,160,'Kankabati','721232',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57319,160,'Kankra Atmaram','721136',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57320,160,'Kankrajhore','721501',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57321,160,'Kanpursalbani','721517',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57322,160,'Kantachowki','721140',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57323,160,'Kantadaraja','721232',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57324,160,'Kantapahari','721121',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57325,160,'Kantore','721157',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57326,160,'Kapasda','721144',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57327,160,'Kapgari','721505',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57328,160,'Karkai','721140',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57329,160,'Karnagarh','721129',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57330,160,'Kashijora','721129',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57331,160,'Kendugari','721506',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57332,160,'Keoshi','721126',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57333,160,'Kerur','721155',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57334,160,'Keshabchak','721212',1,0,'2022-03-03 12:49:43','2022-03-03 12:49:43'),(57335,160,'Keshadal','721201',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57336,160,'Keshia','721157',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57337,160,'Keshpur','721150',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57338,160,'Khagrageria','721144',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57339,160,'Khalakpur','721260',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57340,160,'Khalseuli','721513',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57341,160,'Khamarbarh','721253',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57342,160,'Khanjapur','721212',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57343,160,'Kharagpur New Settlement','721301',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57344,160,'Kharagpur','721301',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57345,160,'Kharagpur Technology','721302',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57346,160,'Kharagpur Work Shop','721301',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57347,160,'Kharar (West Midnapore)','721222',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57348,160,'Kharbandi','721513',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57349,160,'Kharigeria','721260',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57350,160,'Kharika','721144',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57351,160,'Kharikasuli','721516',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57352,160,'Kharkusma','721127',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57353,160,'Khasbarh','721212',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57354,160,'Khatkhura','721505',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57355,160,'Khatranga','721301',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57356,160,'Khelna','721166',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57357,160,'Khemasuli','721513',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57358,160,'Khirai','721140',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57359,160,'Khirati','721201',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57360,160,'Khirpai','721232',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57361,160,'Khunkhunia','721166',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57362,160,'Kiaboni','721253',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57363,160,'Kiageria','721201',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57364,160,'Kiamacha','721253',1,0,'2022-03-03 12:49:44','2022-03-03 12:49:44'),(57365,160,'Kismat Angua','721150',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57366,160,'Kismat Dhangori','721513',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57367,160,'Kismatjamboni','721503',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57368,160,'Kodapura','721501',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57369,160,'Kongarer Ayma','721122',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57370,160,'Korasia','721201',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57371,160,'Korkora','721504',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57372,160,'Kortia','721506',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57373,160,'Kotai','721122',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57374,160,'Krishnanagar','721149',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57375,160,'Krishnapriya','721140',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57376,160,'Krishnapur','721127',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57377,160,'Kuanpur','721201',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57378,160,'Kukrakhupi','721517',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57379,160,'Kuliara','721149',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57380,160,'Kundalpal','721140',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57381,160,'Kuran','721222',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57382,160,'Kuthikonarpur','721232',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57383,160,'Lachipur','721121',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57384,160,'Lakhibari','721155',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57385,160,'Lakhichak','721301',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57386,160,'Lakshmanpur','721222',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57387,160,'Lalgarh (West Midnapore)','721516',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57388,160,'Laupara','721517',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57389,160,'Laxmipur','721242',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57390,160,'Lodhasuli','721513',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57391,160,'Lokepith Bishnupur','721144',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57392,160,'Lowada','721136',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57393,160,'Lurka','721504',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57394,160,'Lutunia','721166',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57395,160,'Madanmohanchak','721166',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57396,160,'Madhupur','721516',1,0,'2022-03-03 12:49:45','2022-03-03 12:49:45'),(57397,160,'Madpur','721149',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57398,160,'Magra','721156',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57399,160,'Maharajpur','721232',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57400,160,'Mahatabnagar','721149',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57401,160,'Mahatapur','721516',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57402,160,'Mahespur Murakata','721201',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57403,160,'Mahim Nischinda','721513',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57404,160,'Mahisda','721150',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57405,160,'Mahulboni','721506',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57406,160,'Makli','721121',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57407,160,'Malbandi','721127',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57408,160,'Maligram','721140',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57409,160,'Malincha','721517',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57410,160,'Mangalbandhi','721253',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57411,160,'Manglapur','721121',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57412,160,'Mangrul','721232',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57413,160,'Manikpara','721513',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57414,160,'Manoharpur','721232',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57415,160,'Mansuka','721212',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57416,160,'Marhmaheshpur','721232',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57417,160,'Marhtala','721156',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57418,160,'Mataldanga','721102',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57419,160,'Math Bishnupur','721136',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57420,160,'Mathurakati','721301',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57421,160,'Matkatpur','721305',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57422,160,'Mayta','721121',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57423,160,'Midnapore Collectorate','721101',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57424,160,'Midnapore Court','721101',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57425,160,'Midnapore DSB','721101',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57426,160,'Midnapore H.O','721101',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57427,160,'Midnapore Police Line','721101',1,0,'2022-03-03 12:49:46','2022-03-03 12:49:46'),(57428,160,'Midnapore Sitala','721101',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57429,160,'Mohar','721161',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57430,160,'Mohoboni','721260',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57431,160,'Molighati','721211',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57432,160,'Monidaha','721102',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57433,160,'Montipa Mohanpur','721513',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57434,160,'Moulaparamanandapur','721242',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57435,160,'Moupal','721516',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57436,160,'Mugbasan','721150',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57437,160,'Mukshudpur','721126',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57438,160,'Mundumari','721140',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57439,160,'Muniada','721515',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57440,160,'Muraboni','721504',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57441,160,'Muramouli','721504',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57442,160,'Nadasuli','721253',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57443,160,'Nalbana','721253',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57444,160,'Narajole','721211',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57445,160,'Narangadihi','721155',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57446,160,'Narasimul','721506',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57447,160,'Narayanbarh','721144',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57448,160,'Narma','721166',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57449,160,'Natuk Jaykrishnapur','721232',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57450,160,'Natunbazar (West Midnapore)','721101',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57451,160,'Naya','721140',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57452,160,'Nayabasat','721253',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57453,160,'Nayagram Benasuli','721102',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57454,160,'Nedhua Bazar','721144',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57455,160,'Nepura','721121',1,0,'2022-03-03 12:49:47','2022-03-03 12:49:47'),(57456,160,'Neradeul','721260',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57457,160,'Netai','721516',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57458,160,'Nimpura','721304',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57459,160,'Nimtala','721212',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57460,160,'Nohari','721121',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57461,160,'Noharia','721513',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57462,160,'Odalchua','721501',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57463,160,'Old Kharagpur','721301',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57464,160,'Orali','721501',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57465,160,'Pachra','721149',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57466,160,'Paikmajita','721242',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57467,160,'Pakuria','721126',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57468,160,'Palaspai','721146',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57469,160,'Palshya','721301',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57470,160,'Panchberia','721146',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57471,160,'Panchgeria','721156',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57472,160,'Panchkhuri','721150',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57473,160,'Panchmaro Pratappur','721212',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57474,160,'Pandua','721201',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57475,160,'Panikotor','721127',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57476,160,'Panna','721212',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57477,160,'Paparara','721149',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57478,160,'Parhdaha','721157',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57479,160,'Parihati','721505',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57480,160,'Parsuli','721503',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57481,160,'Parsura','721150',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57482,160,'Pasang','721124',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57483,160,'Paschimbarh','721144',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57484,160,'Patharchakri','721501',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57485,160,'Patharpara','721121',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57486,160,'Pathartoria','721127',1,0,'2022-03-03 12:49:48','2022-03-03 12:49:48'),(57487,160,'Patina','721506',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57488,160,'Patnabazar','721156',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57489,160,'Perua','721155',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57490,160,'Petbindi','721517',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57491,160,'Phulbani','721506',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57492,160,'Pindrui','721131',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57493,160,'Pingboni','721128',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57494,160,'Pingla','721140',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57495,160,'Pirakata.','721516',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57496,160,'Prasadchak','721232',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57497,160,'Pratappur','721301',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57498,160,'Puichhara','721157',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57499,160,'Pukuria','721514',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57500,160,'Purnapani','721516',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57501,160,'Radhachandanpur','721160',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57502,160,'Radhakantapur','721211',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57503,160,'Radhakrishnapur','721140',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57504,160,'Radhamohanpur','721160',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57505,160,'Radhanagar','721212',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57506,160,'Raghunath Chak','721140',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57507,160,'Raghunathpur (West Midnapore)','721507',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57508,160,'Ragpur','721131',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57509,160,'Ragra','721517',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57510,160,'Rajabasa','721513',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57511,160,'Rajbati','721514',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57512,160,'Rajganj','721201',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57513,160,'Rakhajangle','721301',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57514,160,'Rambhadrapur','721144',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57515,160,'Rambhagawan','721506',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57516,160,'Ramgarh (West MidnapoB.O','721128',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57517,160,'Ramjibanpur','721242',1,0,'2022-03-03 12:49:49','2022-03-03 12:49:49'),(57518,160,'Ramnagar Gopinathpur','721305',1,0,'2022-03-03 12:49:50','2022-03-03 12:49:50'),(57519,160,'Ranarani','721504',1,0,'2022-03-03 12:49:50','2022-03-03 12:49:50'),(57520,160,'Rangmetia','721145',1,0,'2022-03-03 12:49:50','2022-03-03 12:49:50'),(57521,160,'Ranichak','721212',1,0,'2022-03-03 12:49:50','2022-03-03 12:49:50'),(57522,160,'Ranimadhabpur','721242',1,0,'2022-03-03 12:49:50','2022-03-03 12:49:50'),(57523,160,'Ranir Bazar Simulia','721212',1,0,'2022-03-03 12:49:50','2022-03-03 12:49:50'),(57524,160,'Rantua','721517',1,0,'2022-03-03 12:49:50','2022-03-03 12:49:50'),(57525,160,'Raskundu','721127',1,0,'2022-03-03 12:49:50','2022-03-03 12:49:50'),(57526,160,'Rathipur','721212',1,0,'2022-03-03 12:49:50','2022-03-03 12:49:50'),(57527,160,'Ratneswar Bati','721212',1,0,'2022-03-03 12:49:50','2022-03-03 12:49:50'),(57528,160,'Reserve Bank Nm Ltd.','721132',1,0,'2022-03-03 12:49:50','2022-03-03 12:49:50'),(57529,160,'Routa','721150',1,0,'2022-03-03 12:49:50','2022-03-03 12:49:50'),(57530,160,'Routara','721147',1,0,'2022-03-03 12:49:50','2022-03-03 12:49:50'),(57531,160,'Routmoni','721301',1,0,'2022-03-03 12:49:50','2022-03-03 12:49:50'),(57532,160,'Ruinan','721144',1,0,'2022-03-03 12:49:50','2022-03-03 12:49:50'),(57533,160,'Sabang','721144',1,0,'2022-03-03 12:49:50','2022-03-03 12:49:50'),(57534,160,'Sabong Shyamsundarpur','721155',1,0,'2022-03-03 12:49:50','2022-03-03 12:49:50'),(57535,160,'Sagarpur','721211',1,0,'2022-03-03 12:49:50','2022-03-03 12:49:50'),(57536,160,'Saharda','721131',1,0,'2022-03-03 12:49:50','2022-03-03 12:49:50'),(57537,160,'Sahari','721515',1,0,'2022-03-03 12:49:50','2022-03-03 12:49:50'),(57538,160,'Sahaspur','721122',1,0,'2022-03-03 12:49:50','2022-03-03 12:49:50'),(57539,160,'Saidpur','721147',1,0,'2022-03-03 12:49:50','2022-03-03 12:49:50'),(57540,160,'Sainthal','721149',1,0,'2022-03-03 12:49:50','2022-03-03 12:49:50'),(57541,160,'Saiyadbali','721260',1,0,'2022-03-03 12:49:50','2022-03-03 12:49:50'),(57542,160,'Sakpara','721145',1,0,'2022-03-03 12:49:50','2022-03-03 12:49:50'),(57543,160,'Salgeria','721157',1,0,'2022-03-03 12:49:50','2022-03-03 12:49:50'),(57544,160,'Salua','721145',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57545,160,'Samat','721211',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57546,160,'Sanatorium Digri','721253',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57547,160,'Sandapara','721501',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57548,160,'Sandhipur','721127',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57549,160,'Sankarpur','721211',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57550,160,'Sankoa','721301',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57551,160,'Sanmura','721127',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57552,160,'Sanpdaha','721127',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57553,160,'Saria','721506',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57554,160,'Sarisakhola','721150',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57555,160,'Sasra','721506',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57556,160,'Satbankura','721253',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57557,160,'Satpati','721516',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57558,160,'Sekendari','721146',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57559,160,'Sevayatan','721514',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57560,160,'Shalboni Raghunathpur','721147',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57561,160,'Shalboni','721147',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57562,160,'Shanrpur','721136',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57563,160,'Shaymraipur','721301',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57564,160,'Shyamchak','721301',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57565,160,'Shyamchandpur','721147',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57566,160,'Sibadumuria','721506',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57567,160,'Sijua','721121',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57568,160,'Silda','721515',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57569,160,'Sindurgoura','721513',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57570,160,'Sirisdanga','721102',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57571,160,'Siromoni','721102',1,0,'2022-03-03 12:49:51','2022-03-03 12:49:51'),(57572,160,'Sirsa','721260',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57573,160,'Sonakhali','721146',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57574,160,'Srinagar','721242',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57575,160,'Sultanpur','721222',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57576,160,'Sumitrapur','721506',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57577,160,'Supaparsuri','721260',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57578,160,'Swargachira','721506',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57579,160,'Taladiha','721144',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57580,160,'Talbagicha','721306',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57581,160,'Talbandhi','721156',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57582,160,'Tantigeria','721102',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57583,160,'Tapsia','721517',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57584,160,'Tatarpur','721242',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57585,160,'Tenpur','721201',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57586,160,'Tentulmuriuttar','721149',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57587,160,'Thakurnpahari','721501',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57588,160,'Tilaboni','721504',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57589,160,'Tilantapara','721155',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57590,160,'Toria','721260',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57591,160,'Tulibarh','721503',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57592,160,'Turia','721160',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57593,160,'Uchitpur','721166',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57594,160,'Uriasai','721260',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57595,160,'Uttar Eral','721144',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57596,160,'Uttarbarh','721140',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57597,160,'Uttarbil','721127',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57598,160,'Uttardhankhal','721211',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57599,160,'Vidyasagar University','721102',1,0,'2022-03-03 12:49:52','2022-03-03 12:49:52'),(57600,160,'Arit','721148',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57601,160,'Balakrouth','721641',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57602,160,'Brindaban Chak','721641',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57603,160,'Chaipat','721148',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57604,160,'Dudhkumrahat','721130',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57605,160,'Gochhati','721148',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57606,160,'Joteghanashyam','721153',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57607,160,'Kashinathpur','721641',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57608,160,'Khanyadihi','721641',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57609,160,'Kheput','721148',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57610,160,'Khukurdaha','721641',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57611,160,'Maguria','721153',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57612,160,'Nilkunthia','721627',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57613,160,'Nischintapur','721148',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57614,160,'Panchgechhia','721148',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57615,160,'Sahapur','721641',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57616,160,'Satpota','721153',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57617,160,'Shyamganj','721153',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57618,160,'Sreebora','721130',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57619,161,'Adarsh Nagar (Ajmer)','305002',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57620,161,'Aditya Mills','305801',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57621,161,'Ajai Nagra','305003',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57622,161,'Ajaiser','305005',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57623,161,'Ajmer H.O','305001',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57624,161,'Akodia','305813',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57625,161,'Alwar Gate Ajmer','305001',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57626,161,'Amarpura','305819',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57627,161,'Amba Masina','305206',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57628,161,'Arain','305813',1,0,'2022-03-03 12:49:53','2022-03-03 12:49:53'),(57629,161,'Ararka','305811',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57630,161,'Ashok Marg Ajmer','305001',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57631,161,'B.K.Kaul Nagar','305004',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57632,161,'Babaicha','305811',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57633,161,'Badlia','305025',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57634,161,'Bandar Sindari','305801',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57635,161,'Barna','305801',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57636,161,'Beer','305025',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57637,161,'Bhadoon','305814',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57638,161,'Bhagwan Pura','305022',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57639,161,'Bhajan Ganj Ajmer','305001',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57640,161,'Bhamolao','305813',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57641,161,'Bhaonta','305206',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57642,161,'Bhogadeet','305813',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57643,161,'Bhudol','305023',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57644,161,'Bithur','305205',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57645,161,'Bubani','305023',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57646,161,'Buharu','305812',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57647,161,'Chachiwas','305023',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57648,161,'Chanderverdai Nagar','305003',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57649,161,'Chandra Colony','305801',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57650,161,'Chhota Naraina','305812',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57651,161,'Chitakhera','305811',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57652,161,'Chorsiawas','305004',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57653,161,'Crpf Ajmer','305005',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57654,161,'Dadia','305813',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57655,161,'Dang','305813',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57656,161,'Danta','305025',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57657,161,'Dargha Shareef Ajmer','305001',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57658,161,'Deo Nagar','305022',1,0,'2022-03-03 12:49:54','2022-03-03 12:49:54'),(57659,161,'Deo Puri','305801',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57660,161,'Dhan Mandi - Kishan Garh','305802',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57661,161,'Dhan Mandi Ajmer','305001',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57662,161,'Dhasook','305801',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57663,161,'Dindwara','305801',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57664,161,'Dorai','305003',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57665,161,'Dumara','305206',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57666,161,'Farkia','305025',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57667,161,'Gagunda','305813',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57668,161,'Gagwana','305023',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57669,161,'Ganahera','305022',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57670,161,'Gandhi Nagar Madanganj','305801',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57671,161,'Ganj Ajmer','305001',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57672,161,'Gc Road Ajmer','305007',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57673,161,'Gegal Akhari','305023',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57674,161,'Googhra','305023',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57675,161,'Gothiana','305813',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57676,161,'Gujar Dharti Ajmer','305001',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57677,161,'Harmara','305812',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57678,161,'Hatikhera','305005',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57679,161,'Hatundi','305012',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57680,161,'Hmt Ajmer Dtso','305003',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57681,161,'Ie Makhu Pura Ajmer','305002',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57682,161,'Jajota','305814',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57683,161,'Jhalawara','305025',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57684,161,'Jheerota','305801',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57685,161,'Jln Hospital Ajmer','305001',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57686,161,'Jones Ganj Ajmer','305001',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57687,161,'Kaiser Ganj Ajmer','305001',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57688,161,'Kaklana','305205',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57689,161,'Kalanada','305813',1,0,'2022-03-03 12:49:55','2022-03-03 12:49:55'),(57690,161,'Kana Kheri','305025',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57691,161,'Kanas','305022',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57692,161,'Kanpura','305025',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57693,161,'Kanwalai','305021',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57694,161,'Karel','305021',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57695,161,'Karkeri','305819',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57696,161,'Katsura','305801',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57697,161,'Kayar','305023',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57698,161,'Kesarpura','305206',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57699,161,'Khandach','305801',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57700,161,'Kharkheri','305005',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57701,161,'Khatoli','305815',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57702,161,'Khori','305021',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57703,161,'Kishangarh City','305802',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57704,161,'Kishanpura','305022',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57705,161,'Kotaj','305205',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57706,161,'Kotdi','305814',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57707,161,'Kuchil','305811',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57708,161,'Kutchery (Ajmer)','305001',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57709,161,'Ladpura','305023',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57710,161,'Lamba','305813',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57711,161,'Loco Work Shop Ajmer','305001',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57712,161,'Madanganj Kishangarh H.O','305801',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57713,161,'Maday','305024',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57714,161,'Magara','305811',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57715,161,'Magari','305811',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57716,161,'Makarwali','305004',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57717,161,'Makhupura','305002',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57718,161,'Makrera','305206',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57719,161,'Marble Ind. Area Kishangarh','305801',1,0,'2022-03-03 12:49:56','2022-03-03 12:49:56'),(57720,161,'Maya Pur','305205',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57721,161,'Mayo','305007',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57722,161,'Mds University Ajmer','305009',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57723,161,'Mohami','305023',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57724,161,'Mss Hatundi','305012',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57725,161,'Mudoti','305801',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57726,161,'Mundolao','305025',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57727,161,'Nagra Ajmer','305001',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57728,161,'Naka Madar Ajmer','305007',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57729,161,'Nalu','305816',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57730,161,'Nand','305022',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57731,161,'Nareli','305024',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57732,161,'Narwar','305811',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57733,161,'Nawa','305814',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57734,161,'Naya Bazar (Ajmer)','305001',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57735,161,'Nitooti','305814',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57736,161,'Nooriawas','305206',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57737,161,'Nosal','305814',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57738,161,'Nosar','305004',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57739,161,'Pal Beesla Ajmer','305007',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57740,161,'Palran','305025',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57741,161,'Panchsheel Nagar ','305004',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57742,161,'Paner','305814',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57743,161,'Patan','305816',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57744,161,'Picholia','305022',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57745,161,'Pinglod','305815',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57746,161,'Pushkar Bazar','305022',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57747,161,'Pushkar','305022',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57748,161,'Raghunath Pura','305814',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57749,161,'Raj Garh (Ajmer)','305205',1,0,'2022-03-03 12:49:57','2022-03-03 12:49:57'),(57750,161,'Raj. Edu. Board Ajmer','305001',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57751,161,'Ralaota','305801',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57752,161,'Ram Ganj Ajmer','305003',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57753,161,'Rasoolpura','305024',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57754,161,'Regional College Ajmer','305004',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57755,161,'Roopnagar','305814',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57756,161,'RPSC Ajmer','305001',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57757,161,'Salemabad','305815',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57758,161,'Sandolia','305813',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57759,161,'Sanwatsar','305801',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57760,161,'Saradhana','305206',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57761,161,'Sardar Singh Ki Dhani','305801',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57762,161,'Sargoan','305802',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57763,161,'Sendaria','305002',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57764,161,'Session Court Ajmer','305001',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57765,161,'Shastri Nagar (Ajmer)','305001',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57766,161,'Shivaji Nagar (Ajmer)','305801',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57767,161,'Silora','305802',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57768,161,'Singara','305815',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57769,161,'Sinodia','305814',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57770,161,'Sironj','305813',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57771,161,'Somalpur','305003',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57772,161,'Srinagar (Ajmer)','305025',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57773,161,'Sursara','305801',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57774,161,'Tabiji','305206',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57775,161,'Thal','305801',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57776,161,'Tihari','305025',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57777,161,'Tikawara','305802',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57778,161,'Tiloniya','305816',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57779,161,'Tilora','305022',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57780,161,'Tityari','305815',1,0,'2022-03-03 12:49:58','2022-03-03 12:49:58'),(57781,161,'Tyod','305814',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57782,161,'Udaipur Kalan','305802',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57783,161,'Untra','305023',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57784,161,'Vaishali Nagar Ajmer','305004',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57785,161,'Ajgara','305404',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57786,161,'Alipura','305207',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57787,161,'Aloli','305405',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57788,161,'Anakar','305922',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57789,161,'Andheri Deori','305901',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57790,161,'Arjunpura','305203',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57791,161,'Arwar','305601',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57792,161,'Asan','305926',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57793,161,'Asha Pura','305601',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57794,161,'Atitmand','305925',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57795,161,'Badi','305624',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57796,161,'Baghera','305415',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57797,161,'Baghsuri','305401',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57798,161,'Bajata','305407',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57799,161,'Balad','305901',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57800,161,'Bamanheda','305926',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57801,161,'Bandanwara','305621',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57802,161,'Banewara','305401',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57803,161,'Banjari','305926',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57804,161,'Bar Kochara','305922',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57805,161,'Barakhan','305926',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57806,161,'Barakhera','305926',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57807,161,'Baral','305624',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57808,161,'Barala','305628',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57809,161,'Barali','305624',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57810,161,'Barol','305412',1,0,'2022-03-03 12:49:59','2022-03-03 12:49:59'),(57811,161,'Bayala','305901',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57812,161,'Beawar [Raj] H.O','305901',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57813,161,'Beawar City','305901',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57814,161,'Beawar Khas','305901',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57815,161,'Beawar R.S.','305901',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57816,161,'Begliawas','305630',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57817,161,'Bhadsuri','305207',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57818,161,'Bhagawant Pura','305601',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57819,161,'Bhagwan Pura','305403',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57820,161,'Bharai','305404',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57821,161,'Bhatiyani','305601',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57822,161,'Bhimpura','305203',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57823,161,'Bhimrawas','305405',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57824,161,'Bhinai','305622',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57825,161,'Bhwani Khera','305401',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57826,161,'Bidla','305412',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57827,161,'Bijainagar','305624',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57828,161,'Bisundri','305407',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57829,161,'Bogla','305408',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57830,161,'Boobaniya','305401',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57831,161,'Borada','305412',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57832,161,'Borwa','305901',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57833,161,'Brickchiawas','305203',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57834,161,'Bubkiya','305622',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57835,161,'Budhwara','305204',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57836,161,'Champaneri','305629',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57837,161,'Chhachhundra','305621',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57838,161,'Chitiawas','305407',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57839,161,'Dabrella','305412',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57840,161,'Dantra','305207',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57841,161,'Dedpura','305901',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57842,161,'Delwara','305901',1,0,'2022-03-03 12:50:00','2022-03-03 12:50:00'),(57843,161,'Deo Khera','305925',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57844,161,'Deogaon','305415',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57845,161,'Deolia Kalan','305629',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57846,161,'Deomali','305623',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57847,161,'Derathu','305601',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57848,161,'Dewas','305901',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57849,161,'Dewata','305922',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57850,161,'Dhal','305601',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57851,161,'Dhatol','305622',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57852,161,'Dholadanta','305623',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57853,161,'Dhundhari','305408',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57854,161,'Dilwara','305601',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57855,161,'Dodiana','305207',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57856,161,'Doulatpura','305624',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57857,161,'Doulatpura','305623',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57858,161,'Durgawas','305927',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57859,161,'Ekal Singha','305624',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57860,161,'Fathegarh','305412',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57861,161,'Fathepura','305204',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57862,161,'Ghatiyali','305407',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57863,161,'Gohana','305925',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57864,161,'Gola','305202',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57865,161,'Gordha','305407',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57866,161,'Govind Garh','305201',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57867,161,'Goyla','305601',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57868,161,'Gudha Khurd','305629',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57869,161,'Gulgaon','305407',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57870,161,'Hanutia','305625',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57871,161,'Harpura','305406',1,0,'2022-03-03 12:50:01','2022-03-03 12:50:01'),(57872,161,'Harrajpura','305623',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57873,161,'Hingonia','305406',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57874,161,'Jadana','305403',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57875,161,'Jain Gurukul','305901',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57876,161,'Jalia -II','305625',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57877,161,'Jalia-i','305901',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57878,161,'Jamola','305630',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57879,161,'Jawaja','305922',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57880,161,'Jeewana','305901',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57881,161,'Jethana','305207',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57882,161,'Jetpura','305404',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57883,161,'Jhadol','305402',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57884,161,'Jhak','305901',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57885,161,'Jharwasa','305621',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57886,161,'Jhipian','305630',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57887,161,'Jotayan','305627',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57888,161,'Junia','305406',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57889,161,'K.K.Gopal','305408',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57890,161,'Kabra','305927',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57891,161,'Kadera','305405',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57892,161,'Kalesara','305204',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57893,161,'Kalinjer','305925',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57894,161,'Kanai Kalan','305628',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57895,161,'Kanai Khurd','305628',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57896,161,'Kanakhera','305202',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57897,161,'Kaniya','305625',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57898,161,'Karanti','305621',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57899,161,'Karnos','305204',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57900,161,'Karonj','305415',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57901,161,'Kaseer','305412',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57902,161,'Kebania','305627',1,0,'2022-03-03 12:50:02','2022-03-03 12:50:02'),(57903,161,'Kekri','305404',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57904,161,'Kerot','305404',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57905,161,'Kharwa','305202',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57906,161,'Khawas','305405',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57907,161,'Khayda','305622',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57908,161,'Kheempura','305623',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57909,161,'Khiriya','305403',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57910,161,'Khodmal','305926',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57911,161,'Kirap','305623',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57912,161,'Kishanpura','305927',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57913,161,'Kitap','305627',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57914,161,'Kohda','305408',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57915,161,'Kotra','305927',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57916,161,'Kumharia','305621',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57917,161,'Kunwar Ji Ka Kalera','305407',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57918,161,'Kurthal','305628',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57919,161,'Kushayata','305407',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57920,161,'Lalai','305406',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57921,161,'Lamagra','305629',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57922,161,'Lamana','305202',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57923,161,'Lamba Kund Ka','305630',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57924,161,'Lasadia','305406',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57925,161,'Lawera','305601',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57926,161,'Leeri','305203',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57927,161,'Leswa','305201',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57928,161,'Lodiyana','305625',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57929,161,'Loharwara','305601',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57930,161,'Lotiyana','305923',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57931,161,'Lulwa','305623',1,0,'2022-03-03 12:50:03','2022-03-03 12:50:03'),(57932,161,'Malpura','305901',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57933,161,'Malto Ki Ber','305924',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57934,161,'Mandawaria','305402',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57935,161,'Mangliawas','305203',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57936,161,'Manoharpura','305412',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57937,161,'Manpura','305623',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57938,161,'Masuda','305623',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57939,161,'Mawasia','305402',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57940,161,'Mayala','305623',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57941,161,'Mehru Kalan','305405',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57942,161,'Mevada Kalan','305404',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57943,161,'MEWADAKHURD','305404',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57944,161,'Mewaria','305204',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57945,161,'Molkiya','305408',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57946,161,'Morajhari','305402',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57947,161,'Motipura','305601',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57948,161,'Moyana','305623',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57949,161,'Nagelao','305207',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57950,161,'Nagola','305628',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57951,161,'Nai Kalan','305927',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57952,161,'Nandla','305401',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57953,161,'Nandsi','305628',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57954,161,'Nandwara','305623',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57955,161,'Napa Khera','305407',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57956,161,'Narbad Khera','305901',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57957,161,'Nasirabad H.O','305601',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57958,161,'Nehru Nagar (Beawar)','305901',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57959,161,'Nimera','305624',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57960,161,'Niyara','305621',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57961,161,'Noondri-Maldev','305901',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57962,161,'Noondri-Mendratan','305901',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57963,161,'Padlia','305628',1,0,'2022-03-03 12:50:04','2022-03-03 12:50:04'),(57964,161,'Pagaran','305204',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57965,161,'Palri','305926',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57966,161,'Para','305408',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57967,161,'Paranga','305621',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57968,161,'Pharkia','305404',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57969,161,'Piplaj','305202',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57970,161,'Piplaj','305405',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57971,161,'Pisangan','305204',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57972,161,'Pranhera','305404',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57973,161,'Rajiawas','305925',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57974,161,'Rajosi','305401',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57975,161,'Ramgarh','305901',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57976,161,'Rammalia','305627',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57977,161,'Rampali','305404',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57978,161,'Rampura Dabla','305204',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57979,161,'Ramsar (Ajmer)','305402',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57980,161,'Ratakot','305624',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57981,161,'Rawatmal','305923',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57982,161,'Roop Nagar Arnali','305926',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57983,161,'Roopnagar','305901',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57984,161,'Rudlai','305202',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57985,161,'Sadara','305407',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57986,161,'Salari','305408',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57987,161,'Samproda','305402',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57988,161,'Sankariya','305405',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57989,161,'Sanod','305601',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57990,161,'Sanpla','305404',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57991,161,'Sarana','305601',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57992,161,'Sarmalia','305901',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57993,161,'Sarsari','305404',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57994,161,'Sarvena','305925',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57995,161,'Sarwar','305403',1,0,'2022-03-03 12:50:05','2022-03-03 12:50:05'),(57996,161,'Satawaria','305630',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(57997,161,'Sathana','305624',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(57998,161,'Satolav','305403',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(57999,161,'Sawar','305407',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58000,161,'Sedaria','305901',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58001,161,'Sendra Road (Beawar)','305901',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58002,161,'Shahpura','305925',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58003,161,'Shahpura Mohalla( Beawar )','305901',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58004,161,'Sher Garh','305412',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58005,161,'Shergarh','305623',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58006,161,'Shikhrani','305624',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58007,161,'Shivpura Ghata','305901',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58008,161,'Shokalia','305601',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58009,161,'Shyamgarh','305623',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58010,161,'Singhawal','305624',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58011,161,'Siyar','305412',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58012,161,'Sobri','305622',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58013,161,'Soniana','305923',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58014,161,'Suhawa','305901',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58015,161,'Sunpa','305404',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58016,161,'Surdiya','305925',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58017,161,'Surkhand','305628',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58018,161,'Tankawas','305407',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58019,161,'Tantoti','305627',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58020,161,'Taragarh Dadoli','305923',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58021,161,'Taswaria','305408',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58022,161,'Tilana','305402',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58023,161,'Todgarh','305924',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58024,162,'A.G.Dadhiya','301401',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58025,162,'Adoli','301035',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58026,162,'Agar','301027',1,0,'2022-03-03 12:50:06','2022-03-03 12:50:06'),(58027,162,'Ajabgarh','301027',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58028,162,'Ajabpura','301024',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58029,162,'Ajerka','301401',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58030,162,'Akbarpur','301001',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58031,162,'Aklimpur','301703',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58032,162,'Alamdika','301712',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58033,162,'Alanpur','301412',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58034,162,'Alaora','301026',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58035,162,'Alwar Bus Stand','301001',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58036,162,'Alwar H.O','301001',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58037,162,'Anantpura','301713',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58038,162,'Arwa','321605',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58039,162,'Aryanagar Alwar','301001',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58040,162,'Babari','301412',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58041,162,'Babaria','301412',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58042,162,'Bagarrajput','301001',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58043,162,'Bagheri  Kalan','301712',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58044,162,'Baghora','301411',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58045,162,'Baghore','301405',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58046,162,'Bahadurpur','301028',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58047,162,'Bahala','301030',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58048,162,'Bahali','301414',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58049,162,'Bahroj','301404',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58050,162,'Bahror H.O','301701',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58051,162,'Bahror Jat','301714',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58052,162,'Bahtookalan','321605',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58053,162,'Balata','301406',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58054,162,'Baldeogarh','301410',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58055,162,'Ballupura','301408',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58056,162,'Balluwas','301407',1,0,'2022-03-03 12:50:07','2022-03-03 12:50:07'),(58057,162,'Bamanwas','301412',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58058,162,'Bamanwas Kankar','301024',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58059,162,'Bamboli','301001',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58060,162,'Bambora','301405',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58061,162,'Bandra','301411',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58062,162,'Bansur','301402',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58063,162,'Barer','301408',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58064,162,'Barkhera','301406',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58065,162,'Barkokhurd','301413',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58066,162,'Barodakan','321607',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58067,162,'Barodameo','301021',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58068,162,'Barrod','301020',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58069,162,'Basai','301709',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58070,162,'Basai Kalan','301404',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58071,162,'Basaijogian','301024',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58072,162,'Baseth','321605',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58073,162,'Baskripal Nagar','301405',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58074,162,'Basmenpur','301407',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58075,162,'Basni','301401',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58076,162,'Beda','301021',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58077,162,'Bedar','321633',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58078,162,'Beejwa','301025',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58079,162,'Beejwar','301406',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58080,162,'Beejwar Chauhan','301401',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58081,162,'Beelaheri','301702',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58082,162,'Beleta','301414',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58083,162,'Berla','321633',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58084,162,'Bhagana','301702',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58085,162,'Bhageet','301030',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58086,162,'Bhagukawas','301412',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58087,162,'Bhajera','301028',1,0,'2022-03-03 12:50:08','2022-03-03 12:50:08'),(58088,162,'Bhajera','301409',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58089,162,'Bhandodi','301414',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58090,162,'Bhandrol','301022',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58091,162,'Bhangroli','301022',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58092,162,'Bhanokhar','301035',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58093,162,'Bhanot','301401',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58094,162,'Bhanwar','301035',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58095,162,'Bharkol','321633',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58096,162,'Bhikhaheri','301413',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58097,162,'Bhindoosi','301405',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58098,162,'Bhiwari Ind. Area. Alwar','301019',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58099,162,'Bhoggore','301001',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58100,162,'Bhonker','301707',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58101,162,'Bhuda','301409',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58102,162,'Bhungra Ahir','301427',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58103,162,'Bhupsera','301402',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58104,162,'Bichgaon','321607',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58105,162,'Bichhala','301411',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58106,162,'Bighota','301415',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58107,162,'Bilali','301024',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58108,162,'Bilaspur','301411',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58109,162,'Binjari','301408',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58110,162,'Birampur','301411',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58111,162,'Budhi Bawal','301707',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58112,162,'Budhwal','301709',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58113,162,'Bulari','301409',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58114,162,'Buntoli','301021',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58115,162,'Burja','301001',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58116,162,'Buteri','301402',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58117,162,'Butiyana','301021',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58118,162,'Chandoli','301023',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58119,162,'Chandpur','301407',1,0,'2022-03-03 12:50:09','2022-03-03 12:50:09'),(58120,162,'Chandupura','301414',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58121,162,'Chatarpura','301024',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58122,162,'Chaubara','301706',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58123,162,'Chauharpur','301707',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58124,162,'Cheerwa','301025',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58125,162,'Chhilori','321633',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58126,162,'Chikani','301028',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58127,162,'Chimrauli Gaur','321633',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58128,162,'Chomu','301026',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58129,162,'Choola','301402',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58130,162,'Chorotipahar','301028',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58131,162,'Dabarwas','301704',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58132,162,'Dantia','321606',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58133,162,'Dariba Project','301410',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58134,162,'Daroda','321606',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58135,162,'Deenar','301021',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58136,162,'Delhi Gate Alwar','301001',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58137,162,'Dera','301409',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58138,162,'Dera Bamanwas','301022',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58139,162,'Desula','301030',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58140,162,'Devli','321633',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58141,162,'Devti','301415',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58142,162,'Dhakpuri','301406',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58143,162,'Dhamred','301408',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58144,162,'Dhanwari','301025',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58145,162,'Dhigawara','301414',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58146,162,'Diwakari','301001',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58147,162,'Dongri','301604',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58148,162,'Dooghera','301020',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58149,162,'Doomroli','301703',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58150,162,'Doroli','321606',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58151,162,'Doroli','301408',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58152,162,'Dosod','301703',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58153,162,'Dubbi','301408',1,0,'2022-03-03 12:50:10','2022-03-03 12:50:10'),(58154,162,'Duhar Chogan','301022',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58155,162,'Dwarapur','301022',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58156,162,'Fetehpur','301402',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58157,162,'gadoj','301701',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58158,162,'Gaduwas','301401',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58159,162,'Gahankar','301405',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58160,162,'Gandala','301709',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58161,162,'Gandura','301021',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58162,162,'Garh Basai','301022',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58163,162,'Garhi','301024',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58164,162,'Garhi Sawai Ram','301413',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58165,162,'Garu','321606',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58166,162,'Ghasoli','301405',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58167,162,'Ghat','301001',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58168,162,'Ghatla','301404',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58169,162,'Gheelot','301705',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58170,162,'Ghewar','301410',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58171,162,'Giglana','301704',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58172,162,'Girudi','301402',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58173,162,'Golakabas','301410',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58174,162,'Gopipura','301407',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58175,162,'Gordhanpura','301410',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58176,162,'Gothra','301405',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58177,162,'Gothra','301413',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58178,162,'Gotoli','301411',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58179,162,'Govind Garh Alwar','301604',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58180,162,'Gudhachurani','301022',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58181,162,'Gugalkota','301706',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58182,162,'Gunta','301402',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58183,162,'Gunti','301701',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58184,162,'Guwana','301713',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58185,162,'Gwalda','301707',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58186,162,'Gyanpura','301024',1,0,'2022-03-03 12:50:11','2022-03-03 12:50:11'),(58187,162,'H.B.Colony Alwar','301001',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58188,162,'Haldeena','301406',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58189,162,'Hameerka','301411',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58190,162,'Hamidpur','301701',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58191,162,'Hamirpur','301402',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58192,162,'Harsana','321607',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58193,162,'Harsauli','301403',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58194,162,'Harsora','301412',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58195,162,'Hasanpur','321607',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58196,162,'Hatoondi','301427',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58197,162,'Hazipur','301402',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58198,162,'Hingwahera','301411',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58199,162,'Holawas','301402',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58200,162,'Huria Kalan','301704',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58201,162,'Ikrotia','301702',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58202,162,'Indpura','301026',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58203,162,'Intoli','301409',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58204,162,'Ismailpur','301404',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58205,162,'Isroda','301411',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58206,162,'Isrota','321605',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58207,162,'Itarana Alwar','301001',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58208,162,'Itera','301021',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58209,162,'Jadla','321607',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58210,162,'Jaguwas','301701',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58211,162,'Jainpurwas','301701',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58212,162,'Jakhrana','301713',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58213,162,'Jalawas','301714',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58214,162,'Jamalpur','301406',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58215,162,'Jamdoli','301409',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58216,162,'Jaoli','321607',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58217,162,'Jasai','301427',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58218,162,'Jatiyana','301403',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58219,162,'Jatiyana','301023',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58220,162,'Jatpur','301413',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58221,162,'Jatpur','301030',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58222,162,'Jatwara','301035',1,0,'2022-03-03 12:50:12','2022-03-03 12:50:12'),(58223,162,'Jeroli','301411',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58224,162,'Jhalatala','301413',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58225,162,'Jhiri','301027',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58226,162,'Jhiwana','301707',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58227,162,'Jindoli','301404',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58228,162,'Jodia','301702',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58229,162,'Jonal','301401',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58230,162,'Jonicha Khurd','301706',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58231,162,'Jonichakalan','301706',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58232,162,'Joria','301707',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58233,162,'Kakrali Meo','301028',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58234,162,'Kalgaon','301702',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58235,162,'Kalgaon','301405',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58236,162,'Kalsara','301406',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58237,162,'Kalwari','321606',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58238,162,'Kanethi','301413',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58239,162,'Kanhawas','301703',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58240,162,'Kankardopa','301701',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58241,162,'KARANA','301024',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58242,162,'Karanpura','301409',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58243,162,'Karni Kot','301427',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58244,162,'Karoda','301020',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58245,162,'Karoli','301028',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58246,162,'Karoth','301408',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58247,162,'Kathoowas','301704',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58248,162,'Kathumar','321605',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58249,162,'Kayasa','301703',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58250,162,'Keelpurkhera','301409',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58251,162,'Kerwawal','301406',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58252,162,'Khairthal','301404',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58253,162,'Khanpur Ahir','301403',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58254,162,'KHanpur','301702',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58255,162,'Khanpur Jat','301030',1,0,'2022-03-03 12:50:13','2022-03-03 12:50:13'),(58256,162,'Khanpur Mewan','301405',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58257,162,'Khareda','301406',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58258,162,'Khatankhera','301701',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58259,162,'Khazuri Bass','301018',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58260,162,'Kheda Kalyanpur','301035',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58261,162,'Khera','301402',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58262,162,'Khera Mahmood','301604',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58263,162,'Kherajahar','301028',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58264,162,'Kheramangal Singh','301413',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58265,162,'Kherameda','321605',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58266,162,'KHERI','301026',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58267,162,'kherkheri Kalan','301024',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58268,162,'Kherli','321606',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58269,162,'Kherli Syed','301030',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58270,162,'khilora','301026',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58271,162,'Khoh','301035',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58272,162,'Khoh','301410',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58273,162,'Khohar','301709',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58274,162,'Khohrana','301713',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58275,162,'Khohri','301713',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58276,162,'Khonkhar','301035',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58277,162,'Khoondrot','301704',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58278,162,'Khoramalawali','321633',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58279,162,'Khori','301402',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58280,162,'Khudiana','321607',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58281,162,'Khutabpura','301702',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58282,162,'Khuteta Kalan','301001',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58283,162,'Kishan Garh Bass','301405',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58284,162,'Kishori','301022',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58285,162,'Kithoor','301028',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58286,162,'Kkoh','301026',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58287,162,'Kolahera','301024',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58288,162,'Kolila','301020',1,0,'2022-03-03 12:50:14','2022-03-03 12:50:14'),(58289,162,'Koondla','301415',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58290,162,'Kotkassim','301702',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58291,162,'Kutina','301708',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58292,162,'Ladpur','301702',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58293,162,'Lakkakanagal','301402',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58294,162,'Lalpura','301027',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58295,162,'Langerwas','301405',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58296,162,'Laxman Garh','321607',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58297,162,'Leeli','321607',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58298,162,'Leeli','301406',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58299,162,'Lekri','301402',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58300,162,'Machari','301001',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58301,162,'Machari','301408',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58302,162,'Machari Chowk','rajgarh',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58303,162,'Machhroli','301712',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58304,162,'Madhogarh','301001',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58305,162,'Mahanpur','301402',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58306,162,'Maharajawas','301713',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58307,162,'Mahond','301405',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58308,162,'Mahuakhurd','301001',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58309,162,'Majari Kalan','301703',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58310,162,'Majrikanhawas','301703',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58311,162,'Malakhera Gate Alwar','301001',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58312,162,'Malakhera','301406',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58313,162,'Malpur','301026',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58314,162,'Malutana','301022',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58315,162,'Mancha','301405',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58316,162,'Manchal','301701',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58317,162,'Mandawar (Alwar)','301407',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58318,162,'Mandha','301405',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58319,162,'Mandhan','301704',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58320,162,'Manka','301401',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58321,162,'Masari','321605',1,0,'2022-03-03 12:50:15','2022-03-03 12:50:15'),(58322,162,'Maseet','301707',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58323,162,'Matalwas','301702',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58324,162,'Matasya Ind. Area','301030',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58325,162,'Mathuraheda','321605',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58326,162,'Mator','301404',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58327,162,'Mauj Pur','321633',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58328,162,'Mehesra','301707',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58329,162,'Mehtawas','301704',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58330,162,'Methna','321605',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58331,162,'Milakpur','301026',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58332,162,'Milakpur Turk','301707',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58333,162,'Mirjapur','301403',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58334,162,'Mohammedpur','301701',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58335,162,'Molia','301021',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58336,162,'Moonpur','301408',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58337,162,'Moosakhera','301405',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58338,162,'Mothuka','301405',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58339,162,'MOTIDOONGRI','301002',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58340,162,'Motiwara','301415',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58341,162,'Mubarikpur','301025',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58342,162,'Mundana','301411',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58343,162,'Mundanwara Kalan','301427',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58344,162,'Mundawar','301024',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58345,162,'Mundia','301409',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58346,162,'Naghori','301705',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58347,162,'Nagli','301708',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58348,162,'Nanagwas','301704',1,0,'2022-03-03 12:50:16','2022-03-03 12:50:16'),(58349,162,'Nangal Khoria','301701',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58350,162,'Nangal Salia','301712',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58351,162,'Nangalbani','301027',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58352,162,'Nangalkhanjadi','321607',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58353,162,'Nangli Megha','301001',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58354,162,'Narainpur (Alwar)','301024',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58355,162,'Naswari','301026',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58356,162,'Nathalwara','301415',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58357,162,'Natoj','321606',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58358,162,'Nawalpura','301414',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58359,162,'Nayabas','301024',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58360,162,'Neekuch','301025',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58361,162,'Neemla','301415',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58362,162,'Neemrana','301705',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58363,162,'Neemuchana','301024',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58364,162,'New Jahadu','301035',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58365,162,'Nibhera','301021',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58366,162,'Nithari','301406',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58367,162,'Nizamnagar','301021',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58368,162,'Nogaon','301025',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58369,162,'Noor Nagar','301404',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58370,162,'Noorpurganjpur','321607',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58371,162,'Pada','301408',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58372,162,'Padakchapli','301027',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58373,162,'Padmara Khurd','301427',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58374,162,'Pahari','301701',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58375,162,'Pahel','301404',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58376,162,'Pala','301406',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58377,162,'Palpur','301411',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58378,162,'Palpur','301702',1,0,'2022-03-03 12:50:17','2022-03-03 12:50:17'),(58379,162,'Palwa','301414',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58380,162,'Palwa','301706',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58381,162,'Parbeni','301409',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58382,162,'Parisal','301023',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58383,162,'Partapur','301704',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58384,162,'Pata','301025',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58385,162,'Patalia','301403',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58386,162,'Patan','301414',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58387,162,'Patan Mewan','301404',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58388,162,'Peepli','301427',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58389,162,'Peepli','301709',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58390,162,'Peproli','301026',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58391,162,'Phari','301604',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58392,162,'Pholadpur','301706',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58393,162,'Phullawas','301411',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58394,162,'Pinan','301413',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58395,162,'Piplai','301027',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58396,162,'Poonkher','301414',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58397,162,'Pragpura','301409',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58398,162,'Pratap Garh (Alwar)','301027',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58399,162,'Pratapsinghpura','301705',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58400,162,'Prithvipura','301406',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58401,162,'Pur','301702',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58402,162,'R.H.B. Bhiwari','301019',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58403,162,'Rabhana','301411',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58404,162,'Raghunathgarh','301025',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58405,162,'Raibka','301028',1,0,'2022-03-03 12:50:18','2022-03-03 12:50:18'),(58406,162,'Railway Station Alwar','301001',1,0,'2022-03-03 12:50:19','2022-03-03 12:50:19'),(58407,162,'Raisarana','301708',1,0,'2022-03-03 12:50:19','2022-03-03 12:50:19'),(58408,162,'Raisis','301001',1,0,'2022-03-03 12:50:19','2022-03-03 12:50:19'),(58409,162,'Rajgarh (Alwar)','301408',1,0,'2022-03-03 12:50:19','2022-03-03 12:50:19'),(58410,162,'Rajgarh R.S.','301408',1,0,'2022-03-03 12:50:19','2022-03-03 12:50:19'),(58411,162,'Rajpur (Alwar)','301415',1,0,'2022-03-03 12:50:19','2022-03-03 12:50:19'),(58412,162,'Rajwara','301427',1,0,'2022-03-03 12:50:19','2022-03-03 12:50:19'),(58413,162,'Rambas','301604',1,0,'2022-03-03 12:50:19','2022-03-03 12:50:19'),(58414,162,'Ramgarh (Alwar)','301026',1,0,'2022-03-03 12:50:19','2022-03-03 12:50:19'),(58415,162,'Ramjika Guwada','301027',1,0,'2022-03-03 12:50:19','2022-03-03 12:50:19'),(58416,162,'Ramnagar','321607',1,0,'2022-03-03 12:50:19','2022-03-03 12:50:19'),(58417,162,'Rampur (Alwar)','301416',1,0,'2022-03-03 12:50:19','2022-03-03 12:50:19'),(58418,162,'Ranjeet Nager','301001',1,0,'2022-03-03 12:50:19','2022-03-03 12:50:19'),(58419,162,'Ranoth','301404',1,0,'2022-03-03 12:50:19','2022-03-03 12:50:19'),(58420,162,'Rasgan','301404',1,0,'2022-03-03 12:50:19','2022-03-03 12:50:19'),(58421,162,'Rasgaon','301025',1,0,'2022-03-03 12:50:19','2022-03-03 12:50:19'),(58422,162,'Rata Khurd','301023',1,0,'2022-03-03 12:50:19','2022-03-03 12:50:19'),(58423,162,'Ratanpura','301402',1,0,'2022-03-03 12:50:19','2022-03-03 12:50:19'),(58424,162,'Reni','301409',1,0,'2022-03-03 12:50:19','2022-03-03 12:50:19'),(58425,162,'Reta','321605',1,0,'2022-03-03 12:50:19','2022-03-03 12:50:19'),(58426,162,'Rewali','301701',1,0,'2022-03-03 12:50:19','2022-03-03 12:50:19'),(58427,162,'Rodwal','301705',1,0,'2022-03-03 12:50:19','2022-03-03 12:50:19'),(58428,162,'Ronijathan','301035',1,0,'2022-03-03 12:50:19','2022-03-03 12:50:19'),(58429,162,'Sadhka','301021',1,0,'2022-03-03 12:50:19','2022-03-03 12:50:19'),(58430,162,'Sahari','301035',1,0,'2022-03-03 12:50:19','2022-03-03 12:50:19'),(58431,162,'Sainthli','301026',1,0,'2022-03-03 12:50:20','2022-03-03 12:50:20'),(58432,162,'Sakat','301415',1,0,'2022-03-03 12:50:20','2022-03-03 12:50:20'),(58433,162,'Sakatpura (Bawad)','301706',1,0,'2022-03-03 12:50:20','2022-03-03 12:50:20'),(58434,162,'Saleta','301022',1,0,'2022-03-03 12:50:20','2022-03-03 12:50:20'),(58435,162,'Saloli','301409',1,0,'2022-03-03 12:50:20','2022-03-03 12:50:20'),(58436,162,'Salpur','301030',1,0,'2022-03-03 12:50:20','2022-03-03 12:50:20'),(58437,162,'Salwari','301035',1,0,'2022-03-03 12:50:20','2022-03-03 12:50:20'),(58438,162,'Samra','301027',1,0,'2022-03-03 12:50:20','2022-03-03 12:50:20'),(58439,162,'Samuchi','321606',1,0,'2022-03-03 12:50:20','2022-03-03 12:50:20'),(58440,162,'Sanoli','301714',1,0,'2022-03-03 12:50:20','2022-03-03 12:50:20'),(58441,162,'Santhalpur','301402',1,0,'2022-03-03 12:50:20','2022-03-03 12:50:20'),(58442,162,'Santo','301708',1,0,'2022-03-03 12:50:20','2022-03-03 12:50:20'),(58443,162,'Saraikalan','301401',1,0,'2022-03-03 12:50:20','2022-03-03 12:50:20'),(58444,162,'Sarheta','301411',1,0,'2022-03-03 12:50:20','2022-03-03 12:50:20'),(58445,162,'Sariska Palace','301022',1,0,'2022-03-03 12:50:20','2022-03-03 12:50:20'),(58446,162,'Sectt. Alwar','301001',1,0,'2022-03-03 12:50:20','2022-03-03 12:50:20'),(58447,162,'Sedampur','301604',1,0,'2022-03-03 12:50:20','2022-03-03 12:50:20'),(58448,162,'Seelgaon','301401',1,0,'2022-03-03 12:50:20','2022-03-03 12:50:20'),(58449,162,'Seelibaori','301022',1,0,'2022-03-03 12:50:20','2022-03-03 12:50:20'),(58450,162,'Sehra','301413',1,0,'2022-03-03 12:50:20','2022-03-03 12:50:20'),(58451,162,'Semla Khurd','301604',1,0,'2022-03-03 12:50:20','2022-03-03 12:50:20'),(58452,162,'Shahbad','301411',1,0,'2022-03-03 12:50:20','2022-03-03 12:50:20'),(58453,162,'Shahdod','301019',1,0,'2022-03-03 12:50:20','2022-03-03 12:50:20'),(58454,162,'Shahdoli','301028',1,0,'2022-03-03 12:50:20','2022-03-03 12:50:20'),(58455,162,'Shahjahanpur','301706',1,0,'2022-03-03 12:50:20','2022-03-03 12:50:20'),(58456,162,'Shahpur','301023',1,0,'2022-03-03 12:50:20','2022-03-03 12:50:20'),(58457,162,'Shamda','301412',1,0,'2022-03-03 12:50:21','2022-03-03 12:50:21'),(58458,162,'Sheetal','301018',1,0,'2022-03-03 12:50:21','2022-03-03 12:50:21'),(58459,162,'Sheopur','301407',1,0,'2022-03-03 12:50:21','2022-03-03 12:50:21'),(58460,162,'Sherpur','301701',1,0,'2022-03-03 12:50:21','2022-03-03 12:50:21'),(58461,162,'Shivajee Park Alwar','301001',1,0,'2022-03-03 12:50:21','2022-03-03 12:50:21'),(58462,162,'Shyampura','301402',1,0,'2022-03-03 12:50:21','2022-03-03 12:50:21'),(58463,162,'Sihalikalan','301401',1,0,'2022-03-03 12:50:21','2022-03-03 12:50:21'),(58464,162,'Silarpur','301018',1,0,'2022-03-03 12:50:21','2022-03-03 12:50:21'),(58465,162,'Siliserh','301001',1,0,'2022-03-03 12:50:21','2022-03-03 12:50:21'),(58466,162,'Sirmor','301026',1,0,'2022-03-03 12:50:21','2022-03-03 12:50:21'),(58467,162,'Siryani','301708',1,0,'2022-03-03 12:50:21','2022-03-03 12:50:21'),(58468,162,'Sodawas','301427',1,0,'2022-03-03 12:50:21','2022-03-03 12:50:21'),(58469,162,'Sonkh','321605',1,0,'2022-03-03 12:50:21','2022-03-03 12:50:21'),(58470,162,'Sonkher','321606',1,0,'2022-03-03 12:50:21','2022-03-03 12:50:21'),(58471,162,'Sonkheri','321606',1,0,'2022-03-03 12:50:21','2022-03-03 12:50:21'),(58472,162,'Sorai','321607',1,0,'2022-03-03 12:50:21','2022-03-03 12:50:21'),(58473,162,'Sorkha Kalan','301404',1,0,'2022-03-03 12:50:21','2022-03-03 12:50:21'),(58474,162,'Srichandpura','301408',1,0,'2022-03-03 12:50:21','2022-03-03 12:50:21'),(58475,162,'Sudiana','321605',1,0,'2022-03-03 12:50:21','2022-03-03 12:50:21'),(58476,162,'Suratgarh','301022',1,0,'2022-03-03 12:50:21','2022-03-03 12:50:21'),(58477,162,'Surer','301408',1,0,'2022-03-03 12:50:21','2022-03-03 12:50:21'),(58478,162,'Syaluta','301410',1,0,'2022-03-03 12:50:21','2022-03-03 12:50:21'),(58479,162,'Talab','301410',1,0,'2022-03-03 12:50:21','2022-03-03 12:50:21'),(58480,162,'Talwana','301703',1,0,'2022-03-03 12:50:21','2022-03-03 12:50:21'),(58481,162,'Tapukara','301707',1,0,'2022-03-03 12:50:21','2022-03-03 12:50:21'),(58482,162,'Tarwala','301405',1,0,'2022-03-03 12:50:22','2022-03-03 12:50:22'),(58483,162,'Tasai','321605',1,0,'2022-03-03 12:50:22','2022-03-03 12:50:22'),(58484,162,'Tasing','301701',1,0,'2022-03-03 12:50:22','2022-03-03 12:50:22'),(58485,162,'Tatarpur','301404',1,0,'2022-03-03 12:50:22','2022-03-03 12:50:22'),(58486,162,'Tehla','301410',1,0,'2022-03-03 12:50:22','2022-03-03 12:50:22'),(58487,162,'Tehnoli','301405',1,0,'2022-03-03 12:50:22','2022-03-03 12:50:22'),(58488,162,'Tehtra','301409',1,0,'2022-03-03 12:50:22','2022-03-03 12:50:22'),(58489,162,'Thana','301408',1,0,'2022-03-03 12:50:22','2022-03-03 12:50:22'),(58490,162,'Thanagazi','301022',1,0,'2022-03-03 12:50:22','2022-03-03 12:50:22'),(58491,162,'Thons','301405',1,0,'2022-03-03 12:50:22','2022-03-03 12:50:22'),(58492,162,'Tikri','321605',1,0,'2022-03-03 12:50:22','2022-03-03 12:50:22'),(58493,162,'Tilwar','301410',1,0,'2022-03-03 12:50:22','2022-03-03 12:50:22'),(58494,162,'Titarka','301411',1,0,'2022-03-03 12:50:22','2022-03-03 12:50:22'),(58495,162,'Titpuri','321605',1,0,'2022-03-03 12:50:22','2022-03-03 12:50:22'),(58496,162,'Tizara','301411',1,0,'2022-03-03 12:50:22','2022-03-03 12:50:22'),(58497,162,'Toda','321607',1,0,'2022-03-03 12:50:22','2022-03-03 12:50:22'),(58498,162,'Todanagar','301413',1,0,'2022-03-03 12:50:22','2022-03-03 12:50:22'),(58499,162,'Toolera','301001',1,0,'2022-03-03 12:50:22','2022-03-03 12:50:22'),(58500,162,'Tripoliya Alwar','301001',1,0,'2022-03-03 12:50:22','2022-03-03 12:50:22'),(58501,162,'Ujoli','301702',1,0,'2022-03-03 12:50:22','2022-03-03 12:50:22'),(58502,162,'Umren','301001',1,0,'2022-03-03 12:50:22','2022-03-03 12:50:22'),(58503,162,'Untwal','301028',1,0,'2022-03-03 12:50:22','2022-03-03 12:50:22'),(58504,162,'Vabeli','301408',1,0,'2022-03-03 12:50:22','2022-03-03 12:50:22'),(58505,162,'Vallabhgram','301404',1,0,'2022-03-03 12:50:22','2022-03-03 12:50:22'),(58506,162,'Veersingh Pur','301405',1,0,'2022-03-03 12:50:22','2022-03-03 12:50:22'),(58507,162,'Vijai Mandir','301023',1,0,'2022-03-03 12:50:22','2022-03-03 12:50:22'),(58508,162,'Vijay Mandir','301023',1,0,'2022-03-03 12:50:23','2022-03-03 12:50:23'),(58509,162,'Vijayapura','301024',1,0,'2022-03-03 12:50:23','2022-03-03 12:50:23'),(58510,163,'Ador','327034',1,0,'2022-03-03 12:50:23','2022-03-03 12:50:23'),(58511,163,'Agarpura','327022',1,0,'2022-03-03 12:50:23','2022-03-03 12:50:23'),(58512,163,'Ajna','327032',1,0,'2022-03-03 12:50:23','2022-03-03 12:50:23'),(58513,163,'Akhebhanji Ka Gara','327605',1,0,'2022-03-03 12:50:23','2022-03-03 12:50:23'),(58514,163,'Amarsingh Ka Gara','327021',1,0,'2022-03-03 12:50:23','2022-03-03 12:50:23'),(58515,163,'Amarthun','327023',1,0,'2022-03-03 12:50:23','2022-03-03 12:50:23'),(58516,163,'Ambalia','327031',1,0,'2022-03-03 12:50:23','2022-03-03 12:50:23'),(58517,163,'Amja','327034',1,0,'2022-03-03 12:50:23','2022-03-03 12:50:23'),(58518,163,'Anandpuri (Banswara)','327031',1,0,'2022-03-03 12:50:23','2022-03-03 12:50:23'),(58519,163,'Andheshwar','327602',1,0,'2022-03-03 12:50:23','2022-03-03 12:50:23'),(58520,163,'Arthuna','327032',1,0,'2022-03-03 12:50:23','2022-03-03 12:50:23'),(58521,163,'Asan','327021',1,0,'2022-03-03 12:50:23','2022-03-03 12:50:23'),(58522,163,'Asoda','327022',1,0,'2022-03-03 12:50:23','2022-03-03 12:50:23'),(58523,163,'Bachadiya','327025',1,0,'2022-03-03 12:50:23','2022-03-03 12:50:23'),(58524,163,'Badana','327023',1,0,'2022-03-03 12:50:23','2022-03-03 12:50:23'),(58525,163,'Badgoan','327001',1,0,'2022-03-03 12:50:23','2022-03-03 12:50:23'),(58526,163,'Badgun','327026',1,0,'2022-03-03 12:50:23','2022-03-03 12:50:23'),(58527,163,'Badi Saredi','327025',1,0,'2022-03-03 12:50:23','2022-03-03 12:50:23'),(58528,163,'Badi Sarwa','327801',1,0,'2022-03-03 12:50:23','2022-03-03 12:50:23'),(58529,163,'Badli Pada','327801',1,0,'2022-03-03 12:50:23','2022-03-03 12:50:23'),(58530,163,'Badliya','327031',1,0,'2022-03-03 12:50:24','2022-03-03 12:50:24'),(58531,163,'Badliya','327001',1,0,'2022-03-03 12:50:24','2022-03-03 12:50:24'),(58532,163,'Badrel Khurd','327001',1,0,'2022-03-03 12:50:24','2022-03-03 12:50:24'),(58533,163,'Badwasa','327801',1,0,'2022-03-03 12:50:24','2022-03-03 12:50:24'),(58534,163,'Bagidora','327601',1,0,'2022-03-03 12:50:24','2022-03-03 12:50:24'),(58535,163,'Balwara','327603',1,0,'2022-03-03 12:50:24','2022-03-03 12:50:24'),(58536,163,'Bamanparda','327021',1,0,'2022-03-03 12:50:24','2022-03-03 12:50:24'),(58537,163,'Bansala','327603',1,0,'2022-03-03 12:50:24','2022-03-03 12:50:24'),(58538,163,'Banswara City','327001',1,0,'2022-03-03 12:50:24','2022-03-03 12:50:24'),(58539,163,'Banswara H.O','327001',1,0,'2022-03-03 12:50:24','2022-03-03 12:50:24'),(58540,163,'Banswara Ind. Area','327001',1,0,'2022-03-03 12:50:24','2022-03-03 12:50:24'),(58541,163,'Banswara Mahi Colony','327001',1,0,'2022-03-03 12:50:24','2022-03-03 12:50:24'),(58542,163,'Banswara Prathvi Ganj','327001',1,0,'2022-03-03 12:50:24','2022-03-03 12:50:24'),(58543,163,'Bareth','327031',1,0,'2022-03-03 12:50:24','2022-03-03 12:50:24'),(58544,163,'Bari','327001',1,0,'2022-03-03 12:50:24','2022-03-03 12:50:24'),(58545,163,'Barjodia','327031',1,0,'2022-03-03 12:50:24','2022-03-03 12:50:24'),(58546,163,'Barodia','327604',1,0,'2022-03-03 12:50:24','2022-03-03 12:50:24'),(58547,163,'Bassi','327801',1,0,'2022-03-03 12:50:24','2022-03-03 12:50:24'),(58548,163,'Bassi Badi','327032',1,0,'2022-03-03 12:50:24','2022-03-03 12:50:24'),(58549,163,'Berwa','327022',1,0,'2022-03-03 12:50:24','2022-03-03 12:50:24'),(58550,163,'Bhagora','327022',1,0,'2022-03-03 12:50:24','2022-03-03 12:50:24'),(58551,163,'Bhaler Bhodar','327601',1,0,'2022-03-03 12:50:24','2022-03-03 12:50:24'),(58552,163,'Bhapor','327001',1,0,'2022-03-03 12:50:24','2022-03-03 12:50:24'),(58553,163,'Bhatar','327034',1,0,'2022-03-03 12:50:24','2022-03-03 12:50:24'),(58554,163,'Bhimpur','327021',1,0,'2022-03-03 12:50:24','2022-03-03 12:50:24'),(58555,163,'Bhimsore','327025',1,0,'2022-03-03 12:50:24','2022-03-03 12:50:24'),(58556,163,'Bhoyar','327021',1,0,'2022-03-03 12:50:25','2022-03-03 12:50:25'),(58557,163,'Bhungda','327026',1,0,'2022-03-03 12:50:25','2022-03-03 12:50:25'),(58558,163,'Bhuwasa','327021',1,0,'2022-03-03 12:50:25','2022-03-03 12:50:25'),(58559,163,'Biladi','327606',1,0,'2022-03-03 12:50:25','2022-03-03 12:50:25'),(58560,163,'Biloda','327032',1,0,'2022-03-03 12:50:25','2022-03-03 12:50:25'),(58561,163,'Bodigama','327604',1,0,'2022-03-03 12:50:25','2022-03-03 12:50:25'),(58562,163,'Bodigama','327603',1,0,'2022-03-03 12:50:25','2022-03-03 12:50:25'),(58563,163,'Bor Khaber','327001',1,0,'2022-03-03 12:50:25','2022-03-03 12:50:25'),(58564,163,'Borda','327021',1,0,'2022-03-03 12:50:25','2022-03-03 12:50:25'),(58565,163,'Bori','327022',1,0,'2022-03-03 12:50:25','2022-03-03 12:50:25'),(58566,163,'Bori','327026',1,0,'2022-03-03 12:50:25','2022-03-03 12:50:25'),(58567,163,'Boriya','327001',1,0,'2022-03-03 12:50:25','2022-03-03 12:50:25'),(58568,163,'Borpi Khera','327027',1,0,'2022-03-03 12:50:25','2022-03-03 12:50:25'),(58569,163,'Borwat','327001',1,0,'2022-03-03 12:50:25','2022-03-03 12:50:25'),(58570,163,'Buda Bassi','327021',1,0,'2022-03-03 12:50:25','2022-03-03 12:50:25'),(58571,163,'Budwa','327604',1,0,'2022-03-03 12:50:25','2022-03-03 12:50:25'),(58572,163,'Chacha Kota','327001',1,0,'2022-03-03 12:50:25','2022-03-03 12:50:25'),(58573,163,'Chanduji Ka Gara','327001',1,0,'2022-03-03 12:50:25','2022-03-03 12:50:25'),(58574,163,'Chandwara','327031',1,0,'2022-03-03 12:50:25','2022-03-03 12:50:25'),(58575,163,'Charkani','327801',1,0,'2022-03-03 12:50:25','2022-03-03 12:50:25'),(58576,163,'Chaura Kalan','327602',1,0,'2022-03-03 12:50:25','2022-03-03 12:50:25'),(58577,163,'Cheekli Teja','327031',1,0,'2022-03-03 12:50:25','2022-03-03 12:50:25'),(58578,163,'Cheev','327026',1,0,'2022-03-03 12:50:25','2022-03-03 12:50:25'),(58579,163,'Chhaja','327031',1,0,'2022-03-03 12:50:25','2022-03-03 12:50:25'),(58580,163,'Chhari','327027',1,0,'2022-03-03 12:50:26','2022-03-03 12:50:26'),(58581,163,'Chhinch','327603',1,0,'2022-03-03 12:50:26','2022-03-03 12:50:26'),(58582,163,'Chhoti Sarwa','327801',1,0,'2022-03-03 12:50:26','2022-03-03 12:50:26'),(58583,163,'Chhoti Sarwan','327001',1,0,'2022-03-03 12:50:26','2022-03-03 12:50:26'),(58584,163,'Chokhala','327604',1,0,'2022-03-03 12:50:26','2022-03-03 12:50:26'),(58585,163,'Chopasang','327022',1,0,'2022-03-03 12:50:26','2022-03-03 12:50:26'),(58586,163,'Chordi','327601',1,0,'2022-03-03 12:50:26','2022-03-03 12:50:26'),(58587,163,'Chriyawasa','327001',1,0,'2022-03-03 12:50:26','2022-03-03 12:50:26'),(58588,163,'Daduka','327022',1,0,'2022-03-03 12:50:26','2022-03-03 12:50:26'),(58589,163,'Dagal','327027',1,0,'2022-03-03 12:50:26','2022-03-03 12:50:26'),(58590,163,'Dalwara Lokiya','327023',1,0,'2022-03-03 12:50:26','2022-03-03 12:50:26'),(58591,163,'Dana Khari','327001',1,0,'2022-03-03 12:50:26','2022-03-03 12:50:26'),(58592,163,'Danpur','327001',1,0,'2022-03-03 12:50:26','2022-03-03 12:50:26'),(58593,163,'Devda','327023',1,0,'2022-03-03 12:50:26','2022-03-03 12:50:26'),(58594,163,'Dhalar','327601',1,0,'2022-03-03 12:50:26','2022-03-03 12:50:26'),(58595,163,'Dhumath','327801',1,0,'2022-03-03 12:50:26','2022-03-03 12:50:26'),(58596,163,'Dokar','327031',1,0,'2022-03-03 12:50:26','2022-03-03 12:50:26'),(58597,163,'Doodka','327023',1,0,'2022-03-03 12:50:26','2022-03-03 12:50:26'),(58598,163,'Dukawara','327021',1,0,'2022-03-03 12:50:26','2022-03-03 12:50:26'),(58599,163,'Dungariya','327027',1,0,'2022-03-03 12:50:26','2022-03-03 12:50:26'),(58600,163,'Dunglavani','327027',1,0,'2022-03-03 12:50:26','2022-03-03 12:50:26'),(58601,163,'Dungra','327027',1,0,'2022-03-03 12:50:26','2022-03-03 12:50:26'),(58602,163,'Dungra Chhota','327602',1,0,'2022-03-03 12:50:26','2022-03-03 12:50:26'),(58603,163,'Dungra Kalan','327602',1,0,'2022-03-03 12:50:26','2022-03-03 12:50:26'),(58604,163,'Fefar','327001',1,0,'2022-03-03 12:50:26','2022-03-03 12:50:26'),(58605,163,'Galkiya','327001',1,0,'2022-03-03 12:50:26','2022-03-03 12:50:26'),(58606,163,'Gamdi','327025',1,0,'2022-03-03 12:50:27','2022-03-03 12:50:27'),(58607,163,'Gangad Talai','327601',1,0,'2022-03-03 12:50:27','2022-03-03 12:50:27'),(58608,163,'Ganoda','327021',1,0,'2022-03-03 12:50:27','2022-03-03 12:50:27'),(58609,163,'Garhi (Banswara)','327022',1,0,'2022-03-03 12:50:27','2022-03-03 12:50:27'),(58610,163,'Ghantali','327027',1,0,'2022-03-03 12:50:27','2022-03-03 12:50:27'),(58611,163,'Ghatol','327023',1,0,'2022-03-03 12:50:27','2022-03-03 12:50:27'),(58612,163,'Godi Tajpur','327001',1,0,'2022-03-03 12:50:27','2022-03-03 12:50:27'),(58613,163,'Godwara Noren','327602',1,0,'2022-03-03 12:50:27','2022-03-03 12:50:27'),(58614,163,'Gopinath Ka Garha','327034',1,0,'2022-03-03 12:50:27','2022-03-03 12:50:27'),(58615,163,'Handi','327601',1,0,'2022-03-03 12:50:27','2022-03-03 12:50:27'),(58616,163,'Harnathpura','327001',1,0,'2022-03-03 12:50:27','2022-03-03 12:50:27'),(58617,163,'Himmatgarh','327602',1,0,'2022-03-03 12:50:27','2022-03-03 12:50:27'),(58618,163,'Itala','327602',1,0,'2022-03-03 12:50:27','2022-03-03 12:50:27'),(58619,163,'Jagpura','327023',1,0,'2022-03-03 12:50:27','2022-03-03 12:50:27'),(58620,163,'Jahapura','327001',1,0,'2022-03-03 12:50:27','2022-03-03 12:50:27'),(58621,163,'Jalampura','327602',1,0,'2022-03-03 12:50:27','2022-03-03 12:50:27'),(58622,163,'Jambudi','327601',1,0,'2022-03-03 12:50:27','2022-03-03 12:50:27'),(58623,163,'Jethali','327027',1,0,'2022-03-03 12:50:27','2022-03-03 12:50:27'),(58624,163,'Jhanjharwa','327601',1,0,'2022-03-03 12:50:27','2022-03-03 12:50:27'),(58625,163,'Jharas','327022',1,0,'2022-03-03 12:50:27','2022-03-03 12:50:27'),(58626,163,'Jharkaniya','327023',1,0,'2022-03-03 12:50:27','2022-03-03 12:50:27'),(58627,163,'Jher Moti','327601',1,0,'2022-03-03 12:50:27','2022-03-03 12:50:27'),(58628,163,'Jhikali','327801',1,0,'2022-03-03 12:50:27','2022-03-03 12:50:27'),(58629,163,'Jhupel','327001',1,0,'2022-03-03 12:50:27','2022-03-03 12:50:27'),(58630,163,'Jolana','327034',1,0,'2022-03-03 12:50:27','2022-03-03 12:50:27'),(58631,163,'Kajelia','327031',1,0,'2022-03-03 12:50:28','2022-03-03 12:50:28'),(58632,163,'Kalakhet','327001',1,0,'2022-03-03 12:50:28','2022-03-03 12:50:28'),(58633,163,'Kalinjara','327801',1,0,'2022-03-03 12:50:28','2022-03-03 12:50:28'),(58634,163,'Kalinjara','327606',1,0,'2022-03-03 12:50:28','2022-03-03 12:50:28'),(58635,163,'Kanji Ka Gara','327023',1,0,'2022-03-03 12:50:28','2022-03-03 12:50:28'),(58636,163,'Kanthao','327027',1,0,'2022-03-03 12:50:28','2022-03-03 12:50:28'),(58637,163,'Karanpur','327021',1,0,'2022-03-03 12:50:28','2022-03-03 12:50:28'),(58638,163,'Karji','327604',1,0,'2022-03-03 12:50:28','2022-03-03 12:50:28'),(58639,163,'Kaserpura','327001',1,0,'2022-03-03 12:50:28','2022-03-03 12:50:28'),(58640,163,'Katumbi','327001',1,0,'2022-03-03 12:50:28','2022-03-03 12:50:28'),(58641,163,'Kelamela','327026',1,0,'2022-03-03 12:50:28','2022-03-03 12:50:28'),(58642,163,'Kesharpura','327032',1,0,'2022-03-03 12:50:28','2022-03-03 12:50:28'),(58643,163,'Kesharwadi','327602',1,0,'2022-03-03 12:50:28','2022-03-03 12:50:28'),(58644,163,'Khadalim','327601',1,0,'2022-03-03 12:50:28','2022-03-03 12:50:28'),(58645,163,'Khajuri','327001',1,0,'2022-03-03 12:50:28','2022-03-03 12:50:28'),(58646,163,'Khamera','327027',1,0,'2022-03-03 12:50:28','2022-03-03 12:50:28'),(58647,163,'Khandu','327001',1,0,'2022-03-03 12:50:28','2022-03-03 12:50:28'),(58648,163,'Kharan Ka Parda','327022',1,0,'2022-03-03 12:50:28','2022-03-03 12:50:28'),(58649,163,'Kheda','327025',1,0,'2022-03-03 12:50:28','2022-03-03 12:50:28'),(58650,163,'Kheda Khas','327001',1,0,'2022-03-03 12:50:28','2022-03-03 12:50:28'),(58651,163,'Kherdabada','327026',1,0,'2022-03-03 12:50:28','2022-03-03 12:50:28'),(58652,163,'Kherwa','327027',1,0,'2022-03-03 12:50:28','2022-03-03 12:50:28'),(58653,163,'Khodan','327022',1,0,'2022-03-03 12:50:28','2022-03-03 12:50:28'),(58654,163,'Khundni Rupa','327602',1,0,'2022-03-03 12:50:28','2022-03-03 12:50:28'),(58655,163,'Khunta Galia','327601',1,0,'2022-03-03 12:50:28','2022-03-03 12:50:28'),(58656,163,'Kopda','327001',1,0,'2022-03-03 12:50:28','2022-03-03 12:50:28'),(58657,163,'Kotada','327032',1,0,'2022-03-03 12:50:29','2022-03-03 12:50:29'),(58658,163,'Kotra','327001',1,0,'2022-03-03 12:50:29','2022-03-03 12:50:29'),(58659,163,'Kotra Ranga','327801',1,0,'2022-03-03 12:50:29','2022-03-03 12:50:29'),(58660,163,'Kundal','327001',1,0,'2022-03-03 12:50:29','2022-03-03 12:50:29'),(58661,163,'Kundla Kalan','327001',1,0,'2022-03-03 12:50:29','2022-03-03 12:50:29'),(58662,163,'Kunwala','327025',1,0,'2022-03-03 12:50:29','2022-03-03 12:50:29'),(58663,163,'Kupda','327026',1,0,'2022-03-03 12:50:29','2022-03-03 12:50:29'),(58664,163,'Kushal Garh Bazar','327801',1,0,'2022-03-03 12:50:29','2022-03-03 12:50:29'),(58665,163,'Kushalapada','327801',1,0,'2022-03-03 12:50:29','2022-03-03 12:50:29'),(58666,163,'Kushalgarh','327801',1,0,'2022-03-03 12:50:29','2022-03-03 12:50:29'),(58667,163,'Kushalpura','327025',1,0,'2022-03-03 12:50:29','2022-03-03 12:50:29'),(58668,163,'Kuwania','327001',1,0,'2022-03-03 12:50:29','2022-03-03 12:50:29'),(58669,163,'Lankai','327601',1,0,'2022-03-03 12:50:29','2022-03-03 12:50:29'),(58670,163,'Lasada','327605',1,0,'2022-03-03 12:50:29','2022-03-03 12:50:29'),(58671,163,'Lilwani','327606',1,0,'2022-03-03 12:50:29','2022-03-03 12:50:29'),(58672,163,'Limthan','327604',1,0,'2022-03-03 12:50:29','2022-03-03 12:50:29'),(58673,163,'Lodha','327001',1,0,'2022-03-03 12:50:29','2022-03-03 12:50:29'),(58674,163,'Loharia','327801',1,0,'2022-03-03 12:50:29','2022-03-03 12:50:29'),(58675,163,'Luharia','327605',1,0,'2022-03-03 12:50:29','2022-03-03 12:50:29'),(58676,163,'Machchar Para','327602',1,0,'2022-03-03 12:50:29','2022-03-03 12:50:29'),(58677,163,'Madkola','327031',1,0,'2022-03-03 12:50:29','2022-03-03 12:50:29'),(58678,163,'Madlada','327034',1,0,'2022-03-03 12:50:29','2022-03-03 12:50:29'),(58679,163,'Magarda Bada','327602',1,0,'2022-03-03 12:50:29','2022-03-03 12:50:29'),(58680,163,'Maheshpura','327001',1,0,'2022-03-03 12:50:29','2022-03-03 12:50:29'),(58681,163,'Mahidam','327026',1,0,'2022-03-03 12:50:29','2022-03-03 12:50:29'),(58682,163,'Mahudi','327606',1,0,'2022-03-03 12:50:29','2022-03-03 12:50:29'),(58683,163,'Mahudi Maska','327602',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58684,163,'Malana','327022',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58685,163,'Masotiya','327025',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58686,163,'Matwala','327022',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58687,163,'Minapadar','327031',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58688,163,'Miyasa','327027',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58689,163,'Mokampura','327001',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58690,163,'Mokampura','327801',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58691,163,'Mor','327022',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58692,163,'Mordi Nichali','327001',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58693,163,'Mota Goan','327021',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58694,163,'Mota Tanda','327021',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58695,163,'Moti Timbi','327601',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58696,163,'Mudsal','327027',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58697,163,'Mundri','327801',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58698,163,'Mundri','327031',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58699,163,'Nagawara','327606',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58700,163,'Nahali','327034',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58701,163,'Naharpura','327031',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58702,163,'Nalda','327001',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58703,163,'Napla','327001',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58704,163,'Narwali','327027',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58705,163,'Naugama','327034',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58706,163,'Navagoan','327001',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58707,163,'Nawadhara','327032',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58708,163,'Naya Goan','327022',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58709,163,'Nayan','327027',1,0,'2022-03-03 12:50:30','2022-03-03 12:50:30'),(58710,163,'Nichala Ghantala','327001',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58711,163,'Obla','327031',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58712,163,'Odwara','327034',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58713,163,'Padal Badi','327023',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58714,163,'Padal Chhoti','327023',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58715,163,'Paderi','327032',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58716,163,'Padikalan','327801',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58717,163,'Padoli Gordhan','327023',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58718,163,'Padoli Rathor','327023',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58719,163,'Palaswani','327001',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58720,163,'Pali Kalan','327604',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58721,163,'Paloda','327605',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58722,163,'Panasi Chhti','327034',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58723,163,'Panchalwasa','327001',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58724,163,'Panchawara','327032',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58725,163,'Paraheda','327034',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58726,163,'Partapur','327024',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58727,163,'Patan','327801',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58728,163,'Patan','327603',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58729,163,'Peeplod','327606',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58730,163,'Phalwa','327031',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58731,163,'Pindarama','327034',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58732,163,'Pipal Khunt','327023',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58733,163,'Prethvipura','327001',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58734,163,'Raiyana','327034',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58735,163,'Rakho','327606',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58736,163,'Ramgarh','327801',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58737,163,'Ramka Munna','327601',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58738,163,'Rath Dhanraj','327602',1,0,'2022-03-03 12:50:31','2022-03-03 12:50:31'),(58739,163,'Rohaniya','327601',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58740,163,'Rohaniya Laxman Singh','327602',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58741,163,'Rohanwari','327601',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58742,163,'Rohida','327001',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58743,163,'Runjia','327023',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58744,163,'Rupji Ka Kheda','327027',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58745,163,'Sabalpur','327801',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58746,163,'Sagrod','327604',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58747,163,'Sagwa','327606',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58748,163,'Sagwadiya','327025',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58749,163,'Sajjan Garh','327602',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58750,163,'Sakaria','327025',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58751,163,'Salia','327601',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58752,163,'Saliya','327604',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58753,163,'Sallopat','327601',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58754,163,'Samagarha','327022',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58755,163,'Samaria','327604',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58756,163,'Sanawasa','327023',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58757,163,'Sangariya','327601',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58758,163,'Saranpur','327032',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58759,163,'Saredi Chhoti','327025',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58760,163,'Sarodia','327027',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58761,163,'Semaliya','327027',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58762,163,'Sevna','327001',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58763,163,'Shergarh','327601',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58764,163,'Singhpura','327001',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58765,163,'Sodalpur','327027',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58766,163,'Sowaniya','327027',1,0,'2022-03-03 12:50:32','2022-03-03 12:50:32'),(58767,163,'Sundanpur','327025',1,0,'2022-03-03 12:50:33','2022-03-03 12:50:33'),(58768,163,'Sundni','327001',1,0,'2022-03-03 12:50:33','2022-03-03 12:50:33'),(58769,163,'Sundrao','327031',1,0,'2022-03-03 12:50:33','2022-03-03 12:50:33'),(58770,163,'Surpur','327001',1,0,'2022-03-03 12:50:33','2022-03-03 12:50:33'),(58771,163,'Surwania','327604',1,0,'2022-03-03 12:50:33','2022-03-03 12:50:33'),(58772,163,'Suwala','327606',1,0,'2022-03-03 12:50:33','2022-03-03 12:50:33'),(58773,163,'Tajpur','327001',1,0,'2022-03-03 12:50:33','2022-03-03 12:50:33'),(58774,163,'Talwara','327025',1,0,'2022-03-03 12:50:33','2022-03-03 12:50:33'),(58775,163,'Tambesara','327602',1,0,'2022-03-03 12:50:33','2022-03-03 12:50:33'),(58776,163,'Tamtiya','327001',1,0,'2022-03-03 12:50:33','2022-03-03 12:50:33'),(58777,163,'Tamtiya','327031',1,0,'2022-03-03 12:50:33','2022-03-03 12:50:33'),(58778,163,'Tamtiya Rathor','327034',1,0,'2022-03-03 12:50:33','2022-03-03 12:50:33'),(58779,163,'Tanda Mangla','327602',1,0,'2022-03-03 12:50:33','2022-03-03 12:50:33'),(58780,163,'Tandi Kalan','327602',1,0,'2022-03-03 12:50:33','2022-03-03 12:50:33'),(58781,163,'Thikariya','327001',1,0,'2022-03-03 12:50:33','2022-03-03 12:50:33'),(58782,163,'Thikariya','327605',1,0,'2022-03-03 12:50:33','2022-03-03 12:50:33'),(58783,163,'Timbada','327801',1,0,'2022-03-03 12:50:33','2022-03-03 12:50:33'),(58784,163,'Udaipura','327601',1,0,'2022-03-03 12:50:33','2022-03-03 12:50:33'),(58785,163,'Umbada','327022',1,0,'2022-03-03 12:50:33','2022-03-03 12:50:33'),(58786,163,'Ummadgarhi','327601',1,0,'2022-03-03 12:50:33','2022-03-03 12:50:33'),(58787,163,'Unkala','327801',1,0,'2022-03-03 12:50:33','2022-03-03 12:50:33'),(58788,163,'Upla Ghantala','327001',1,0,'2022-03-03 12:50:33','2022-03-03 12:50:33'),(58789,163,'Vajwanaia','327025',1,0,'2022-03-03 12:50:33','2022-03-03 12:50:33'),(58790,163,'Vakhatpura','327032',1,0,'2022-03-03 12:50:33','2022-03-03 12:50:33'),(58791,164,'Agar','325217',1,0,'2022-03-03 12:50:33','2022-03-03 12:50:33'),(58792,164,'Ajnawar','325221',1,0,'2022-03-03 12:50:34','2022-03-03 12:50:34'),(58793,164,'Anatana','325218',1,0,'2022-03-03 12:50:34','2022-03-03 12:50:34'),(58794,164,'Anta Gas Power Project Anta','325209',1,0,'2022-03-03 12:50:34','2022-03-03 12:50:34'),(58795,164,'Anta','325202',1,0,'2022-03-03 12:50:34','2022-03-03 12:50:34'),(58796,164,'Ardan','325218',1,0,'2022-03-03 12:50:34','2022-03-03 12:50:34'),(58797,164,'Asnawar','325215',1,0,'2022-03-03 12:50:34','2022-03-03 12:50:34'),(58798,164,'Atone','325223',1,0,'2022-03-03 12:50:34','2022-03-03 12:50:34'),(58799,164,'ATRU','325218',1,0,'2022-03-03 12:50:34','2022-03-03 12:50:34'),(58800,164,'Badan','325222',1,0,'2022-03-03 12:50:34','2022-03-03 12:50:34'),(58801,164,'Badgaon','325206',1,0,'2022-03-03 12:50:34','2022-03-03 12:50:34'),(58802,164,'Badipura','325216',1,0,'2022-03-03 12:50:34','2022-03-03 12:50:34'),(58803,164,'Badora','325223',1,0,'2022-03-03 12:50:34','2022-03-03 12:50:34'),(58804,164,'Badwa','325209',1,0,'2022-03-03 12:50:34','2022-03-03 12:50:34'),(58805,164,'Bajrang Garh','325216',1,0,'2022-03-03 12:50:34','2022-03-03 12:50:34'),(58806,164,'Balda','325216',1,0,'2022-03-03 12:50:34','2022-03-03 12:50:34'),(58807,164,'Baldarah','325206',1,0,'2022-03-03 12:50:34','2022-03-03 12:50:34'),(58808,164,'Bamangaon','325217',1,0,'2022-03-03 12:50:34','2022-03-03 12:50:34'),(58809,164,'Bamla','325205',1,0,'2022-03-03 12:50:34','2022-03-03 12:50:34'),(58810,164,'Bamolia Kalan','325209',1,0,'2022-03-03 12:50:34','2022-03-03 12:50:34'),(58811,164,'Bamori','325223',1,0,'2022-03-03 12:50:34','2022-03-03 12:50:34'),(58812,164,'Bamori Kalan','325215',1,0,'2022-03-03 12:50:34','2022-03-03 12:50:34'),(58813,164,'Bamorighata','325221',1,0,'2022-03-03 12:50:34','2022-03-03 12:50:34'),(58814,164,'Banjari','325221',1,0,'2022-03-03 12:50:34','2022-03-03 12:50:34'),(58815,164,'Bansthuni','325216',1,0,'2022-03-03 12:50:34','2022-03-03 12:50:34'),(58816,164,'Bapcha','325220',1,0,'2022-03-03 12:50:34','2022-03-03 12:50:34'),(58817,164,'Baran MDG','325205',1,0,'2022-03-03 12:50:34','2022-03-03 12:50:34'),(58818,164,'Barana','325205',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58819,164,'Barlan','325218',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58820,164,'Baroni','325216',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58821,164,'Batawada','325205',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58822,164,'Batawada Par','325220',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58823,164,'Beel Kheda','325217',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58824,164,'Beel Kheda Mal','325217',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58825,164,'Bengana','325205',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58826,164,'Benta','325217',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58827,164,'Bhanwargarh','325216',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58828,164,'Bhatwada','325215',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58829,164,'Bhavpura','325221',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58830,164,'Bhensara','325223',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58831,164,'Bhilwada Neecha','325220',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58832,164,'Bhojya Kheri','325202',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58833,164,'Bhoyal','325217',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58834,164,'Bhulon','325220',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58835,164,'Bhuwakheri','325220',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58836,164,'Bichalas','325223',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58837,164,'Bijora','325205',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58838,164,'Bilendi','325221',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58839,164,'Bohat','325222',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58840,164,'Chachoda','325220',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58841,164,'Chardana','325218',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58842,164,'Chhabra','325220',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58843,164,'Chhajawa','325205',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58844,164,'Chhatargang','325216',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58845,164,'Chhinod','325216',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58846,164,'Chhipa Barod','325221',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58847,164,'Deori','325217',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58848,164,'Deori','325221',1,0,'2022-03-03 12:50:35','2022-03-03 12:50:35'),(58849,164,'Dhikwani','325217',1,0,'2022-03-03 12:50:36','2022-03-03 12:50:36'),(58850,164,'Dholam','325221',1,0,'2022-03-03 12:50:36','2022-03-03 12:50:36'),(58851,164,'Dhoti','325205',1,0,'2022-03-03 12:50:36','2022-03-03 12:50:36'),(58852,164,'Dhumar Khedi','325215',1,0,'2022-03-03 12:50:36','2022-03-03 12:50:36'),(58853,164,'Digod Jagir','325221',1,0,'2022-03-03 12:50:36','2022-03-03 12:50:36'),(58854,164,'Digod Kalan','325221',1,0,'2022-03-03 12:50:36','2022-03-03 12:50:36'),(58855,164,'Digodpar','325216',1,0,'2022-03-03 12:50:36','2022-03-03 12:50:36'),(58856,164,'Dilod','325219',1,0,'2022-03-03 12:50:36','2022-03-03 12:50:36'),(58857,164,'Fatehpur','325205',1,0,'2022-03-03 12:50:36','2022-03-03 12:50:36'),(58858,164,'Gagchana','325221',1,0,'2022-03-03 12:50:36','2022-03-03 12:50:36'),(58859,164,'Gajanpura','325205',1,0,'2022-03-03 12:50:36','2022-03-03 12:50:36'),(58860,164,'Ganeshpura','325217',1,0,'2022-03-03 12:50:36','2022-03-03 12:50:36'),(58861,164,'Garda','325216',1,0,'2022-03-03 12:50:36','2022-03-03 12:50:36'),(58862,164,'Ghatti Colony','325216',1,0,'2022-03-03 12:50:36','2022-03-03 12:50:36'),(58863,164,'Godia Mehar','325220',1,0,'2022-03-03 12:50:36','2022-03-03 12:50:36'),(58864,164,'Gordhanpra','325221',1,0,'2022-03-03 12:50:36','2022-03-03 12:50:36'),(58865,164,'Halgana','325220',1,0,'2022-03-03 12:50:36','2022-03-03 12:50:36'),(58866,164,'Hana Heri','325220',1,0,'2022-03-03 12:50:36','2022-03-03 12:50:36'),(58867,164,'Hani Heda','325219',1,0,'2022-03-03 12:50:36','2022-03-03 12:50:36'),(58868,164,'Harnawda Shaji ED','325221',1,0,'2022-03-03 12:50:36','2022-03-03 12:50:36'),(58869,164,'Hathidilod','325219',1,0,'2022-03-03 12:50:36','2022-03-03 12:50:36'),(58870,164,'Hingonia','325222',1,0,'2022-03-03 12:50:36','2022-03-03 12:50:36'),(58871,164,'Iklera','325205',1,0,'2022-03-03 12:50:36','2022-03-03 12:50:36'),(58872,164,'Ishwarpura','325215',1,0,'2022-03-03 12:50:36','2022-03-03 12:50:36'),(58873,164,'Jai Nagar','325209',1,0,'2022-03-03 12:50:36','2022-03-03 12:50:36'),(58874,164,'Jaipla','325220',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58875,164,'Jaloda Tejaji','325215',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58876,164,'Jalwara','325218',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58877,164,'Jarela','325215',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58878,164,'Jhinjhni','325221',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58879,164,'Kachnariya','325221',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58880,164,'Kachra','325218',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58881,164,'Kachri','325209',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58882,164,'Kadia Ban','325220',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58883,164,'Kadia Hat','325220',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58884,164,'Kadia Nohar','325220',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58885,164,'Kalmanda','325205',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58886,164,'Kalmodiya','325221',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58887,164,'Kalpajagir','325221',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58888,164,'Karnaheda','325205',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58889,164,'Karwari Kalan','325215',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58890,164,'Kasba Nonera','325217',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58891,164,'Kasba Thana','325217',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58892,164,'Katawar','325223',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58893,164,'Kelwara','325216',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58894,164,'Khajurana Kalan','325202',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58895,164,'Khajuria','325221',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58896,164,'Khanda Sahrol','325217',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58897,164,'Khandela','325216',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58898,164,'Kharkheda Ramlothan','325219',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58899,164,'Khatka','325217',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58900,164,'Kherali','325205',1,0,'2022-03-03 12:50:37','2022-03-03 12:50:37'),(58901,164,'Kherli','325216',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58902,164,'Khuri','325218',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58903,164,'Kishan Ganj (Baran)','325216',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58904,164,'Kishanpura','325215',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58905,164,'Kotrapar','325220',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58906,164,'Kotri','325220',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58907,164,'Koyala','325222',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58908,164,'Krishi Upaj Mandi Baran','325205',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58909,164,'Kulinjara','325220',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58910,164,'Kundi','325219',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58911,164,'Kunjed','325207',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58912,164,'Lisadia','325205',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58913,164,'Mahodra','325217',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58914,164,'Mal Bamori','325215',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58915,164,'Mandola','325205',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58916,164,'Mangrol (Baran)','325215',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58917,164,'Marma Chah','325218',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58918,164,'Mathna','325205',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58919,164,'Mau','325215',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58920,164,'Mawasa','325219',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58921,164,'Melkheri','325205',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58922,164,'Merma Talab','325218',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58923,164,'Mirja Pur','325202',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58924,164,'Missai','325216',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58925,164,'Miyada','325222',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58926,164,'Mohkampura','325221',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58927,164,'Moondla Bisoti','325205',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58928,164,'Mothpur','325219',1,0,'2022-03-03 12:50:38','2022-03-03 12:50:38'),(58929,164,'Mundiyar','325217',1,0,'2022-03-03 12:50:39','2022-03-03 12:50:39'),(58930,164,'Mundkya','325220',1,0,'2022-03-03 12:50:39','2022-03-03 12:50:39'),(58931,164,'Mundla','325218',1,0,'2022-03-03 12:50:39','2022-03-03 12:50:39'),(58932,164,'Musai Gujaran','325219',1,0,'2022-03-03 12:50:39','2022-03-03 12:50:39'),(58933,164,'Nahar Garh','325216',1,0,'2022-03-03 12:50:39','2022-03-03 12:50:39'),(58934,164,'Nanwata','325219',1,0,'2022-03-03 12:50:39','2022-03-03 12:50:39'),(58935,164,'Nareda','325205',1,0,'2022-03-03 12:50:39','2022-03-03 12:50:39'),(58936,164,'Natai','325217',1,0,'2022-03-03 12:50:39','2022-03-03 12:50:39'),(58937,164,'Nipania','325220',1,0,'2022-03-03 12:50:39','2022-03-03 12:50:39'),(58938,164,'Pachel Kalan','325209',1,0,'2022-03-03 12:50:39','2022-03-03 12:50:39'),(58939,164,'Pachpada','325220',1,0,'2022-03-03 12:50:39','2022-03-03 12:50:39'),(58940,164,'Palaitha','325202',1,0,'2022-03-03 12:50:39','2022-03-03 12:50:39'),(58941,164,'Pali','325220',1,0,'2022-03-03 12:50:39','2022-03-03 12:50:39'),(58942,164,'Paraniya','325216',1,0,'2022-03-03 12:50:39','2022-03-03 12:50:39'),(58943,164,'Patheda','325205',1,0,'2022-03-03 12:50:39','2022-03-03 12:50:39'),(58944,164,'Patna','325218',1,0,'2022-03-03 12:50:39','2022-03-03 12:50:39'),(58945,164,'Patunda','325206',1,0,'2022-03-03 12:50:39','2022-03-03 12:50:39'),(58946,164,'Phalia','325220',1,0,'2022-03-03 12:50:39','2022-03-03 12:50:39'),(58947,164,'Phool Barod','325219',1,0,'2022-03-03 12:50:39','2022-03-03 12:50:39'),(58948,164,'Piplod','325218',1,0,'2022-03-03 12:50:39','2022-03-03 12:50:39'),(58949,164,'Piplod Kalan','325215',1,0,'2022-03-03 12:50:39','2022-03-03 12:50:39'),(58950,164,'Rai','325221',1,0,'2022-03-03 12:50:39','2022-03-03 12:50:39'),(58951,164,'Raingarh','325215',1,0,'2022-03-03 12:50:39','2022-03-03 12:50:39'),(58952,164,'Raithal','325206',1,0,'2022-03-03 12:50:39','2022-03-03 12:50:39'),(58953,164,'Raj Garh','325202',1,0,'2022-03-03 12:50:39','2022-03-03 12:50:39'),(58954,164,'Rajpur','325217',1,0,'2022-03-03 12:50:40','2022-03-03 12:50:40'),(58955,164,'Ramgarh','325215',1,0,'2022-03-03 12:50:40','2022-03-03 12:50:40'),(58956,164,'Ratawad','325205',1,0,'2022-03-03 12:50:40','2022-03-03 12:50:40'),(58957,164,'Relawan .','325215',1,0,'2022-03-03 12:50:40','2022-03-03 12:50:40'),(58958,164,'Richhanda','325223',1,0,'2022-03-03 12:50:40','2022-03-03 12:50:40'),(58959,164,'Sahjanpur','325221',1,0,'2022-03-03 12:50:40','2022-03-03 12:50:40'),(58960,164,'Sahrod','325207',1,0,'2022-03-03 12:50:40','2022-03-03 12:50:40'),(58961,164,'Sahrol Taleti','325217',1,0,'2022-03-03 12:50:40','2022-03-03 12:50:40'),(58962,164,'Sakatpur','325223',1,0,'2022-03-03 12:50:40','2022-03-03 12:50:40'),(58963,164,'Sakrawada','325216',1,0,'2022-03-03 12:50:40','2022-03-03 12:50:40'),(58964,164,'Salpura','325219',1,0,'2022-03-03 12:50:40','2022-03-03 12:50:40'),(58965,164,'Samrania','325217',1,0,'2022-03-03 12:50:40','2022-03-03 12:50:40'),(58966,164,'Sanwara','325217',1,0,'2022-03-03 12:50:40','2022-03-03 12:50:40'),(58967,164,'Sarthal','325221',1,0,'2022-03-03 12:50:40','2022-03-03 12:50:40'),(58968,164,'Semli','325220',1,0,'2022-03-03 12:50:40','2022-03-03 12:50:40'),(58969,164,'Sethkolu','325221',1,0,'2022-03-03 12:50:40','2022-03-03 12:50:40'),(58970,164,'Sevni','325215',1,0,'2022-03-03 12:50:40','2022-03-03 12:50:40'),(58971,164,'Shahabad (Baran)','325217',1,0,'2022-03-03 12:50:40','2022-03-03 12:50:40'),(58972,164,'Shahpura','325206',1,0,'2022-03-03 12:50:40','2022-03-03 12:50:40'),(58973,164,'Shergarh','325223',1,0,'2022-03-03 12:50:40','2022-03-03 12:50:40'),(58974,164,'Shubhadra Colony','325217',1,0,'2022-03-03 12:50:40','2022-03-03 12:50:40'),(58975,164,'Simli','325222',1,0,'2022-03-03 12:50:40','2022-03-03 12:50:40'),(58976,164,'Simlia','325215',1,0,'2022-03-03 12:50:40','2022-03-03 12:50:40'),(58977,164,'Siswali','325206',1,0,'2022-03-03 12:50:40','2022-03-03 12:50:40'),(58978,164,'Sorkhand Kalan','325209',1,0,'2022-03-03 12:50:41','2022-03-03 12:50:41'),(58979,164,'Sorsan','325202',1,0,'2022-03-03 12:50:41','2022-03-03 12:50:41'),(58980,164,'Sundlak','325205',1,0,'2022-03-03 12:50:41','2022-03-03 12:50:41'),(58981,164,'Tam Khera','325209',1,0,'2022-03-03 12:50:41','2022-03-03 12:50:41'),(58982,164,'Tancha','325219',1,0,'2022-03-03 12:50:41','2022-03-03 12:50:41'),(58983,164,'Teetar Kheri','325220',1,0,'2022-03-03 12:50:41','2022-03-03 12:50:41'),(58984,164,'Telni','325220',1,0,'2022-03-03 12:50:41','2022-03-03 12:50:41'),(58985,164,'Thikaria','325202',1,0,'2022-03-03 12:50:41','2022-03-03 12:50:41'),(58986,164,'Tisaya','325206',1,0,'2022-03-03 12:50:41','2022-03-03 12:50:41'),(58987,164,'Tisaya','325222',1,0,'2022-03-03 12:50:41','2022-03-03 12:50:41'),(58988,164,'Tulsan','325207',1,0,'2022-03-03 12:50:41','2022-03-03 12:50:41'),(58989,164,'Udpura','325206',1,0,'2022-03-03 12:50:41','2022-03-03 12:50:41'),(58990,165,'Abhey Ka Par','344502',1,0,'2022-03-03 12:50:41','2022-03-03 12:50:41'),(58991,165,'Adarsh Basti','344011',1,0,'2022-03-03 12:50:41','2022-03-03 12:50:41'),(58992,165,'Adel','344033',1,0,'2022-03-03 12:50:41','2022-03-03 12:50:41'),(58993,165,'Adrim Ka Tala','344702',1,0,'2022-03-03 12:50:41','2022-03-03 12:50:41'),(58994,165,'Ajit','344021',1,0,'2022-03-03 12:50:41','2022-03-03 12:50:41'),(58995,165,'Akadara','344034',1,0,'2022-03-03 12:50:41','2022-03-03 12:50:41'),(58996,165,'Akoda','344012',1,0,'2022-03-03 12:50:41','2022-03-03 12:50:41'),(58997,165,'Alamsar','344702',1,0,'2022-03-03 12:50:41','2022-03-03 12:50:41'),(58998,165,'Alamsariya','344704',1,0,'2022-03-03 12:50:41','2022-03-03 12:50:41'),(58999,165,'Alpura','344031',1,0,'2022-03-03 12:50:41','2022-03-03 12:50:41'),(59000,165,'Antia','344702',1,0,'2022-03-03 12:50:41','2022-03-03 12:50:41'),(59001,165,'Arang','344701',1,0,'2022-03-03 12:50:41','2022-03-03 12:50:41'),(59002,165,'Arniyali','344704',1,0,'2022-03-03 12:50:42','2022-03-03 12:50:42'),(59003,165,'Arthandi','344021',1,0,'2022-03-03 12:50:42','2022-03-03 12:50:42'),(59004,165,'Arti','344706',1,0,'2022-03-03 12:50:42','2022-03-03 12:50:42'),(59005,165,'Asada','344022',1,0,'2022-03-03 12:50:42','2022-03-03 12:50:42'),(59006,165,'Asadi','344011',1,0,'2022-03-03 12:50:42','2022-03-03 12:50:42'),(59007,165,'Asarwa [Araba]','344026',1,0,'2022-03-03 12:50:42','2022-03-03 12:50:42'),(59008,165,'Asotra','344022',1,0,'2022-03-03 12:50:42','2022-03-03 12:50:42'),(59009,165,'Atimalani','344001',1,0,'2022-03-03 12:50:42','2022-03-03 12:50:42'),(59010,165,'Babuguleria','344502',1,0,'2022-03-03 12:50:42','2022-03-03 12:50:42'),(59011,165,'Bachhrau','344708',1,0,'2022-03-03 12:50:42','2022-03-03 12:50:42'),(59012,165,'Badnava','344032',1,0,'2022-03-03 12:50:42','2022-03-03 12:50:42'),(59013,165,'Bagawas','344026',1,0,'2022-03-03 12:50:42','2022-03-03 12:50:42'),(59014,165,'Baitu Bhimji','344034',1,0,'2022-03-03 12:50:42','2022-03-03 12:50:42'),(59015,165,'Baitu Chimanji','344034',1,0,'2022-03-03 12:50:42','2022-03-03 12:50:42'),(59016,165,'Baitu Panji','344034',1,0,'2022-03-03 12:50:42','2022-03-03 12:50:42'),(59017,165,'Baitu','344034',1,0,'2022-03-03 12:50:42','2022-03-03 12:50:42'),(59018,165,'Bakhasar','344706',1,0,'2022-03-03 12:50:42','2022-03-03 12:50:42'),(59019,165,'Balai','344701',1,0,'2022-03-03 12:50:42','2022-03-03 12:50:42'),(59020,165,'Balasar','344701',1,0,'2022-03-03 12:50:42','2022-03-03 12:50:42'),(59021,165,'Balau','344012',1,0,'2022-03-03 12:50:42','2022-03-03 12:50:42'),(59022,165,'Balau Jati','344026',1,0,'2022-03-03 12:50:42','2022-03-03 12:50:42'),(59023,165,'Balera','344012',1,0,'2022-03-03 12:50:42','2022-03-03 12:50:42'),(59024,165,'Balewa','344011',1,0,'2022-03-03 12:50:42','2022-03-03 12:50:42'),(59025,165,'Balotra IA','344022',1,0,'2022-03-03 12:50:43','2022-03-03 12:50:43'),(59026,165,'Balotra','344022',1,0,'2022-03-03 12:50:43','2022-03-03 12:50:43'),(59027,165,'Balotra SB','344022',1,0,'2022-03-03 12:50:43','2022-03-03 12:50:43'),(59028,165,'Bamarla','344704',1,0,'2022-03-03 12:50:43','2022-03-03 12:50:43'),(59029,165,'Bamarwala','344706',1,0,'2022-03-03 12:50:43','2022-03-03 12:50:43'),(59030,165,'Bamnore Amarshah','344704',1,0,'2022-03-03 12:50:43','2022-03-03 12:50:43'),(59031,165,'Bamseen','344021',1,0,'2022-03-03 12:50:43','2022-03-03 12:50:43'),(59032,165,'Band','344033',1,0,'2022-03-03 12:50:43','2022-03-03 12:50:43'),(59033,165,'Bandasar','344501',1,0,'2022-03-03 12:50:43','2022-03-03 12:50:43'),(59034,165,'Bandhada','344011',1,0,'2022-03-03 12:50:43','2022-03-03 12:50:43'),(59035,165,'Bandra','344035',1,0,'2022-03-03 12:50:43','2022-03-03 12:50:43'),(59036,165,'Banta','344031',1,0,'2022-03-03 12:50:43','2022-03-03 12:50:43'),(59037,165,'Baori Kallan','344702',1,0,'2022-03-03 12:50:43','2022-03-03 12:50:43'),(59038,165,'Barmer Agore','344001',1,0,'2022-03-03 12:50:43','2022-03-03 12:50:43'),(59039,165,'Barmer Coll','344001',1,0,'2022-03-03 12:50:43','2022-03-03 12:50:43'),(59040,165,'Barmer DB','344001',1,0,'2022-03-03 12:50:43','2022-03-03 12:50:43'),(59041,165,'Barmer H.O','344001',1,0,'2022-03-03 12:50:43','2022-03-03 12:50:43'),(59042,165,'Barmer PR','344001',1,0,'2022-03-03 12:50:43','2022-03-03 12:50:43'),(59043,165,'Barmer RS','344001',1,0,'2022-03-03 12:50:43','2022-03-03 12:50:43'),(59044,165,'Batadu','344035',1,0,'2022-03-03 12:50:43','2022-03-03 12:50:43'),(59045,165,'Bhachbhar','344502',1,0,'2022-03-03 12:50:43','2022-03-03 12:50:43'),(59046,165,'Bhadkha','344001',1,0,'2022-03-03 12:50:43','2022-03-03 12:50:43'),(59047,165,'Bhadresh','344011',1,0,'2022-03-03 12:50:43','2022-03-03 12:50:43'),(59048,165,'Bhag Bhare Ki Beri','344704',1,0,'2022-03-03 12:50:43','2022-03-03 12:50:43'),(59049,165,'Bhagwa','344043',1,0,'2022-03-03 12:50:43','2022-03-03 12:50:43'),(59050,165,'Bhakharpura','344031',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59051,165,'Bhalgaon','344706',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59052,165,'Bhalikhal','344704',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59053,165,'Bhalisar','344704',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59054,165,'Bhalron Ka Bada','344021',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59055,165,'Bhandiyawas','344032',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59056,165,'Bhanwar','344706',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59057,165,'Bhanwarlai','344001',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59058,165,'Bhata','344801',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59059,165,'Bhawaria','344706',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59060,165,'Bhedana','344031',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59061,165,'Bherudi','344704',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59062,165,'Bhilon Ka Par','344502',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59063,165,'Bhimarl R.S.','344034',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59064,165,'Bhimarlai','344034',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59065,165,'Bhimda','344035',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59066,165,'Bhimthal','344704',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59067,165,'Bhinyad','344701',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59068,165,'Bhojaria','344702',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59069,165,'Bhojasar','344034',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59070,165,'Bhunia','344704',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59071,165,'Bhunka','344022',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59072,165,'Bhurtia','344035',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59073,165,'Binjasar','344702',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59074,165,'Binjrad','344702',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59075,165,'Bisarniya','344704',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59076,165,'Bisasar','344706',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59077,165,'Bishala Agore','344011',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59078,165,'Bishala','344011',1,0,'2022-03-03 12:50:44','2022-03-03 12:50:44'),(59079,165,'Bissukallan','344701',1,0,'2022-03-03 12:50:45','2022-03-03 12:50:45'),(59080,165,'Bithuja','344022',1,0,'2022-03-03 12:50:45','2022-03-03 12:50:45'),(59081,165,'Bola','344001',1,0,'2022-03-03 12:50:45','2022-03-03 12:50:45'),(59082,165,'Boli','344704',1,0,'2022-03-03 12:50:45','2022-03-03 12:50:45'),(59083,165,'Booth Jetmal','344708',1,0,'2022-03-03 12:50:45','2022-03-03 12:50:45'),(59084,165,'Booth Rathodan','344702',1,0,'2022-03-03 12:50:45','2022-03-03 12:50:45'),(59085,165,'Boothia','344501',1,0,'2022-03-03 12:50:45','2022-03-03 12:50:45'),(59086,165,'Bore Charnan','344704',1,0,'2022-03-03 12:50:45','2022-03-03 12:50:45'),(59087,165,'Borwa','344703',1,0,'2022-03-03 12:50:45','2022-03-03 12:50:45'),(59088,165,'Budiwara','344022',1,0,'2022-03-03 12:50:45','2022-03-03 12:50:45'),(59089,165,'Bukar','344502',1,0,'2022-03-03 12:50:45','2022-03-03 12:50:45'),(59090,165,'Burhan Ka Tala','344702',1,0,'2022-03-03 12:50:45','2022-03-03 12:50:45'),(59091,165,'Chadi','344502',1,0,'2022-03-03 12:50:45','2022-03-03 12:50:45'),(59092,165,'Chadon Ki Dhani','344033',1,0,'2022-03-03 12:50:45','2022-03-03 12:50:45'),(59093,165,'Chalkana','344704',1,0,'2022-03-03 12:50:45','2022-03-03 12:50:45'),(59094,165,'Chandesara','344034',1,0,'2022-03-03 12:50:45','2022-03-03 12:50:45'),(59095,165,'Chandi Ka Par','344501',1,0,'2022-03-03 12:50:45','2022-03-03 12:50:45'),(59096,165,'Chawa','344703',1,0,'2022-03-03 12:50:45','2022-03-03 12:50:45'),(59097,165,'Chetrodi','344011',1,0,'2022-03-03 12:50:45','2022-03-03 12:50:45'),(59098,165,'Chhotu','344033',1,0,'2022-03-03 12:50:45','2022-03-03 12:50:45'),(59099,165,'Chidiya','344034',1,0,'2022-03-03 12:50:45','2022-03-03 12:50:45'),(59100,165,'Chilanadi','344032',1,0,'2022-03-03 12:50:45','2022-03-03 12:50:45'),(59101,165,'Chinchrasar','344706',1,0,'2022-03-03 12:50:45','2022-03-03 12:50:45'),(59102,165,'Chitar Ka Par','344035',1,0,'2022-03-03 12:50:45','2022-03-03 12:50:45'),(59103,165,'Chochra','344701',1,0,'2022-03-03 12:50:45','2022-03-03 12:50:45'),(59104,165,'Chohtan','344702',1,0,'2022-03-03 12:50:46','2022-03-03 12:50:46'),(59105,165,'Chokhala','344035',1,0,'2022-03-03 12:50:46','2022-03-03 12:50:46'),(59106,165,'Chuli','344011',1,0,'2022-03-03 12:50:46','2022-03-03 12:50:46'),(59107,165,'Dabar','344011',1,0,'2022-03-03 12:50:46','2022-03-03 12:50:46'),(59108,165,'Daboi','344031',1,0,'2022-03-03 12:50:46','2022-03-03 12:50:46'),(59109,165,'Dakha','344022',1,0,'2022-03-03 12:50:46','2022-03-03 12:50:46'),(59110,165,'Dandali','344033',1,0,'2022-03-03 12:50:46','2022-03-03 12:50:46'),(59111,165,'Dangaria','344031',1,0,'2022-03-03 12:50:46','2022-03-03 12:50:46'),(59112,165,'Dedawas','344031',1,0,'2022-03-03 12:50:46','2022-03-03 12:50:46'),(59113,165,'Dedusar','344702',1,0,'2022-03-03 12:50:46','2022-03-03 12:50:46'),(59114,165,'Deedhas','344021',1,0,'2022-03-03 12:50:46','2022-03-03 12:50:46'),(59115,165,'Deora','344044',1,0,'2022-03-03 12:50:46','2022-03-03 12:50:46'),(59116,165,'Derasar','344001',1,0,'2022-03-03 12:50:46','2022-03-03 12:50:46'),(59117,165,'Detani','344502',1,0,'2022-03-03 12:50:46','2022-03-03 12:50:46'),(59118,165,'Devandi','344044',1,0,'2022-03-03 12:50:46','2022-03-03 12:50:46'),(59119,165,'Dhanau','344702',1,0,'2022-03-03 12:50:46','2022-03-03 12:50:46'),(59120,165,'Dhani Jan Singh Ki Beri','344701',1,0,'2022-03-03 12:50:46','2022-03-03 12:50:46'),(59121,165,'Dhanne Ki Dhani','344033',1,0,'2022-03-03 12:50:46','2022-03-03 12:50:46'),(59122,165,'Dhanwa','344801',1,0,'2022-03-03 12:50:46','2022-03-03 12:50:46'),(59123,165,'Dharasar','344702',1,0,'2022-03-03 12:50:46','2022-03-03 12:50:46'),(59124,165,'Dharna','344801',1,0,'2022-03-03 12:50:46','2022-03-03 12:50:46'),(59125,165,'Dharvi Kallan','344701',1,0,'2022-03-03 12:50:46','2022-03-03 12:50:46'),(59126,165,'Dharvi Khurd','344701',1,0,'2022-03-03 12:50:46','2022-03-03 12:50:46'),(59127,165,'Dhiran','344043',1,0,'2022-03-03 12:50:46','2022-03-03 12:50:46'),(59128,165,'Dhok','344702',1,0,'2022-03-03 12:50:46','2022-03-03 12:50:46'),(59129,165,'Dhorimana','344704',1,0,'2022-03-03 12:50:47','2022-03-03 12:50:47'),(59130,165,'Doli Rajguran','344026',1,0,'2022-03-03 12:50:47','2022-03-03 12:50:47'),(59131,165,'Dolikallan','344026',1,0,'2022-03-03 12:50:47','2022-03-03 12:50:47'),(59132,165,'Dudhiya Kallan','344708',1,0,'2022-03-03 12:50:47','2022-03-03 12:50:47'),(59133,165,'Dudhu','344704',1,0,'2022-03-03 12:50:47','2022-03-03 12:50:47'),(59134,165,'Dudhwa','344034',1,0,'2022-03-03 12:50:47','2022-03-03 12:50:47'),(59135,165,'Dudhwakhurd','344012',1,0,'2022-03-03 12:50:47','2022-03-03 12:50:47'),(59136,165,'Ed Sindhari','344033',1,0,'2022-03-03 12:50:47','2022-03-03 12:50:47'),(59137,165,'Ekal','344706',1,0,'2022-03-03 12:50:47','2022-03-03 12:50:47'),(59138,165,'Fogera','344011',1,0,'2022-03-03 12:50:47','2022-03-03 12:50:47'),(59139,165,'Gadra Road','344501',1,0,'2022-03-03 12:50:47','2022-03-03 12:50:47'),(59140,165,'Gagaria','344502',1,0,'2022-03-03 12:50:47','2022-03-03 12:50:47'),(59141,165,'Gandhavkallan','344031',1,0,'2022-03-03 12:50:47','2022-03-03 12:50:47'),(59142,165,'Gangala','344001',1,0,'2022-03-03 12:50:47','2022-03-03 12:50:47'),(59143,165,'Gangasara','344706',1,0,'2022-03-03 12:50:47','2022-03-03 12:50:47'),(59144,165,'Garal','344001',1,0,'2022-03-03 12:50:47','2022-03-03 12:50:47'),(59145,165,'Gardia','344502',1,0,'2022-03-03 12:50:47','2022-03-03 12:50:47'),(59146,165,'Gehun','344001',1,0,'2022-03-03 12:50:47','2022-03-03 12:50:47'),(59147,165,'Gida','344037',1,0,'2022-03-03 12:50:47','2022-03-03 12:50:47'),(59148,165,'Gidan','344706',1,0,'2022-03-03 12:50:47','2022-03-03 12:50:47'),(59149,165,'Girab','344011',1,0,'2022-03-03 12:50:47','2022-03-03 12:50:47'),(59150,165,'Go R.S.','344034',1,0,'2022-03-03 12:50:47','2022-03-03 12:50:47'),(59151,165,'Godawas','344026',1,0,'2022-03-03 12:50:47','2022-03-03 12:50:47'),(59152,165,'Gohar Ka Tala','344702',1,0,'2022-03-03 12:50:47','2022-03-03 12:50:47'),(59153,165,'Golia Bhailan','344044',1,0,'2022-03-03 12:50:47','2022-03-03 12:50:47'),(59154,165,'Golia Jet','344033',1,0,'2022-03-03 12:50:48','2022-03-03 12:50:48'),(59155,165,'Goliar','344012',1,0,'2022-03-03 12:50:48','2022-03-03 12:50:48'),(59156,165,'Gopari','344032',1,0,'2022-03-03 12:50:48','2022-03-03 12:50:48'),(59157,165,'Gora','344704',1,0,'2022-03-03 12:50:48','2022-03-03 12:50:48'),(59158,165,'Gudamalani','344031',1,0,'2022-03-03 12:50:48','2022-03-03 12:50:48'),(59159,165,'Gudanal','344044',1,0,'2022-03-03 12:50:48','2022-03-03 12:50:48'),(59160,165,'Gumane Ka Tala','344702',1,0,'2022-03-03 12:50:48','2022-03-03 12:50:48'),(59161,165,'Gunga','344705',1,0,'2022-03-03 12:50:48','2022-03-03 12:50:48'),(59162,165,'Gwalnada','344026',1,0,'2022-03-03 12:50:48','2022-03-03 12:50:48'),(59163,165,'Hadwa','344705',1,0,'2022-03-03 12:50:48','2022-03-03 12:50:48'),(59164,165,'Hapon Ki Dhani','344001',1,0,'2022-03-03 12:50:48','2022-03-03 12:50:48'),(59165,165,'Harkhali','344035',1,0,'2022-03-03 12:50:48','2022-03-03 12:50:48'),(59166,165,'Harpalia','344706',1,0,'2022-03-03 12:50:48','2022-03-03 12:50:48'),(59167,165,'Harsani','344011',1,0,'2022-03-03 12:50:48','2022-03-03 12:50:48'),(59168,165,'Hathala','344706',1,0,'2022-03-03 12:50:48','2022-03-03 12:50:48'),(59169,165,'Hathitala','344708',1,0,'2022-03-03 12:50:48','2022-03-03 12:50:48'),(59170,165,'Hathma','344001',1,0,'2022-03-03 12:50:48','2022-03-03 12:50:48'),(59171,165,'Hire Ki Dhani','344037',1,0,'2022-03-03 12:50:48','2022-03-03 12:50:48'),(59172,165,'Hodu','344033',1,0,'2022-03-03 12:50:48','2022-03-03 12:50:48'),(59173,165,'Hudon Ki Dhani','344035',1,0,'2022-03-03 12:50:48','2022-03-03 12:50:48'),(59174,165,'Indrana','344044',1,0,'2022-03-03 12:50:48','2022-03-03 12:50:48'),(59175,165,'Indroi','344001',1,0,'2022-03-03 12:50:48','2022-03-03 12:50:48'),(59176,165,'Intada','344702',1,0,'2022-03-03 12:50:48','2022-03-03 12:50:48'),(59177,165,'Ishrol','344708',1,0,'2022-03-03 12:50:48','2022-03-03 12:50:48'),(59178,165,'Itwaya','344801',1,0,'2022-03-03 12:50:49','2022-03-03 12:50:49'),(59179,165,'Jagsa','344022',1,0,'2022-03-03 12:50:49','2022-03-03 12:50:49'),(59180,165,'Jaisar','344702',1,0,'2022-03-03 12:50:49','2022-03-03 12:50:49'),(59181,165,'Jaisindh R.S.','344501',1,0,'2022-03-03 12:50:49','2022-03-03 12:50:49'),(59182,165,'Jaisindhar','344501',1,0,'2022-03-03 12:50:49','2022-03-03 12:50:49'),(59183,165,'Jajwa','344037',1,0,'2022-03-03 12:50:49','2022-03-03 12:50:49'),(59184,165,'Jakhada','344037',1,0,'2022-03-03 12:50:49','2022-03-03 12:50:49'),(59185,165,'Jakhdon Ki Dhani','344708',1,0,'2022-03-03 12:50:49','2022-03-03 12:50:49'),(59186,165,'Jalikheda','344031',1,0,'2022-03-03 12:50:49','2022-03-03 12:50:49'),(59187,165,'Jalila','344702',1,0,'2022-03-03 12:50:49','2022-03-03 12:50:49'),(59188,165,'Jalipa','344001',1,0,'2022-03-03 12:50:49','2022-03-03 12:50:49'),(59189,165,'Janiyana','344022',1,0,'2022-03-03 12:50:49','2022-03-03 12:50:49'),(59190,165,'Janpalia','344706',1,0,'2022-03-03 12:50:49','2022-03-03 12:50:49'),(59191,165,'Jasa Ka Gaon','344701',1,0,'2022-03-03 12:50:49','2022-03-03 12:50:49'),(59192,165,'Jasai','344001',1,0,'2022-03-03 12:50:49','2022-03-03 12:50:49'),(59193,165,'Jasol','344024',1,0,'2022-03-03 12:50:49','2022-03-03 12:50:49'),(59194,165,'Jaton Ka Bera','344706',1,0,'2022-03-03 12:50:49','2022-03-03 12:50:49'),(59195,165,'Jaydu','344001',1,0,'2022-03-03 12:50:49','2022-03-03 12:50:49'),(59196,165,'Jethantri','344027',1,0,'2022-03-03 12:50:49','2022-03-03 12:50:49'),(59197,165,'Jhak','344035',1,0,'2022-03-03 12:50:49','2022-03-03 12:50:49'),(59198,165,'Jhampli Kallan','344705',1,0,'2022-03-03 12:50:49','2022-03-03 12:50:49'),(59199,165,'Jhankali','344701',1,0,'2022-03-03 12:50:49','2022-03-03 12:50:49'),(59200,165,'Jharpa','344706',1,0,'2022-03-03 12:50:49','2022-03-03 12:50:49'),(59201,165,'Jogasar','344033',1,0,'2022-03-03 12:50:49','2022-03-03 12:50:49'),(59202,165,'Juna Lakhwara','344702',1,0,'2022-03-03 12:50:49','2022-03-03 12:50:49'),(59203,165,'Juna Mitha Kheda','344801',1,0,'2022-03-03 12:50:49','2022-03-03 12:50:49'),(59204,165,'Junapatrasar','344012',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59205,165,'Junejon Ki Basti','344701',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59206,165,'Junwa Jagir','344031',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59207,165,'Kabooli','344704',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59208,165,'Kachhabe Ki Dhani','344502',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59209,165,'Kagau','344001',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59210,165,'Kalewa','344032',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59211,165,'Kaludi','344022',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59212,165,'Kalyanpur (Barmer)','344026',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59213,165,'Kamon Ka Bada','344021',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59214,165,'Kamthai','344033',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59215,165,'Kanana','344027',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59216,165,'Kanasar','344701',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59217,165,'Kankhi','344801',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59218,165,'Kankrala','344027',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59219,165,'Kanod','344034',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59220,165,'Kantal Ka Par','344502',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59221,165,'Kaprau','344702',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59222,165,'Kapurdi','344001',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59223,165,'Karmawas','344021',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59224,165,'Kartia','344704',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59225,165,'Kashmir','344701',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59226,165,'Katarla','344704',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59227,165,'Kathadi','344043',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59228,165,'Kavas','344035',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59229,165,'Kekar','344704',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59230,165,'Kelnoor','344702',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59231,165,'Keshumbla Bhatian','344037',1,0,'2022-03-03 12:50:50','2022-03-03 12:50:50'),(59232,165,'Khadeen','344001',1,0,'2022-03-03 12:50:51','2022-03-03 12:50:51'),(59233,165,'Khandap','344043',1,0,'2022-03-03 12:50:51','2022-03-03 12:50:51'),(59234,165,'Khaniyani','344501',1,0,'2022-03-03 12:50:51','2022-03-03 12:50:51'),(59235,165,'Khanoda','344032',1,0,'2022-03-03 12:50:51','2022-03-03 12:50:51'),(59236,165,'Khara Mahechan','344033',1,0,'2022-03-03 12:50:51','2022-03-03 12:50:51'),(59237,165,'Khara Rathodan','344001',1,0,'2022-03-03 12:50:51','2022-03-03 12:50:51'),(59238,165,'Kharantia Khurd','344703',1,0,'2022-03-03 12:50:51','2022-03-03 12:50:51'),(59239,165,'Kharapar','344034',1,0,'2022-03-03 12:50:51','2022-03-03 12:50:51'),(59240,165,'Kharchi','344502',1,0,'2022-03-03 12:50:51','2022-03-03 12:50:51'),(59241,165,'Kharda BS','344032',1,0,'2022-03-03 12:50:51','2022-03-03 12:50:51'),(59242,165,'Khardi','344032',1,0,'2022-03-03 12:50:51','2022-03-03 12:50:51'),(59243,165,'Khari','344704',1,0,'2022-03-03 12:50:51','2022-03-03 12:50:51'),(59244,165,'Kharia Kallan','344502',1,0,'2022-03-03 12:50:51','2022-03-03 12:50:51'),(59245,165,'Kharia Khurd','344033',1,0,'2022-03-03 12:50:51','2022-03-03 12:50:51'),(59246,165,'Kharia Rathodan','344702',1,0,'2022-03-03 12:50:51','2022-03-03 12:50:51'),(59247,165,'Kharia Tala','344001',1,0,'2022-03-03 12:50:51','2022-03-03 12:50:51'),(59248,165,'Kharwa','344027',1,0,'2022-03-03 12:50:51','2022-03-03 12:50:51'),(59249,165,'Khattu','344034',1,0,'2022-03-03 12:50:51','2022-03-03 12:50:51'),(59250,165,'Khejadiyali','344021',1,0,'2022-03-03 12:50:51','2022-03-03 12:50:51'),(59251,165,'Khimpsar','344037',1,0,'2022-03-03 12:50:51','2022-03-03 12:50:51'),(59252,165,'Khokhsar','344032',1,0,'2022-03-03 12:50:51','2022-03-03 12:50:51'),(59253,165,'Khudal','344705',1,0,'2022-03-03 12:50:51','2022-03-03 12:50:51'),(59254,165,'Khudala','344033',1,0,'2022-03-03 12:50:51','2022-03-03 12:50:51'),(59255,165,'Khudasa','344001',1,0,'2022-03-03 12:50:51','2022-03-03 12:50:51'),(59256,165,'Kitnod','344022',1,0,'2022-03-03 12:50:52','2022-03-03 12:50:52'),(59257,165,'Kitnoria','344704',1,0,'2022-03-03 12:50:52','2022-03-03 12:50:52'),(59258,165,'Koja','344704',1,0,'2022-03-03 12:50:52','2022-03-03 12:50:52'),(59259,165,'Koliyana','344704',1,0,'2022-03-03 12:50:52','2022-03-03 12:50:52'),(59260,165,'Kolu','344034',1,0,'2022-03-03 12:50:52','2022-03-03 12:50:52'),(59261,165,'Konra','344702',1,0,'2022-03-03 12:50:52','2022-03-03 12:50:52'),(59262,165,'Korna','344026',1,0,'2022-03-03 12:50:52','2022-03-03 12:50:52'),(59263,165,'Kosariya','344035',1,0,'2022-03-03 12:50:52','2022-03-03 12:50:52'),(59264,165,'Koslu','344033',1,0,'2022-03-03 12:50:52','2022-03-03 12:50:52'),(59265,165,'Kotari','344021',1,0,'2022-03-03 12:50:52','2022-03-03 12:50:52'),(59266,165,'Kothala','344704',1,0,'2022-03-03 12:50:52','2022-03-03 12:50:52'),(59267,165,'Kotra','344701',1,0,'2022-03-03 12:50:52','2022-03-03 12:50:52'),(59268,165,'Kudi','344032',1,0,'2022-03-03 12:50:52','2022-03-03 12:50:52'),(59269,165,'Kumpalia','344032',1,0,'2022-03-03 12:50:52','2022-03-03 12:50:52'),(59270,165,'Kundal','344043',1,0,'2022-03-03 12:50:52','2022-03-03 12:50:52'),(59271,165,'Kundanpura','344706',1,0,'2022-03-03 12:50:52','2022-03-03 12:50:52'),(59272,165,'Kundawa','344704',1,0,'2022-03-03 12:50:52','2022-03-03 12:50:52'),(59273,165,'Kurla','344001',1,0,'2022-03-03 12:50:52','2022-03-03 12:50:52'),(59274,165,'Kuship','344044',1,0,'2022-03-03 12:50:52','2022-03-03 12:50:52'),(59275,165,'Lakhwara','344702',1,0,'2022-03-03 12:50:52','2022-03-03 12:50:52'),(59276,165,'Langera','344001',1,0,'2022-03-03 12:50:52','2022-03-03 12:50:52'),(59277,165,'Lapundara Tarli','344037',1,0,'2022-03-03 12:50:52','2022-03-03 12:50:52'),(59278,165,'Leelma','344501',1,0,'2022-03-03 12:50:52','2022-03-03 12:50:52'),(59279,165,'Leelsar','344708',1,0,'2022-03-03 12:50:52','2022-03-03 12:50:52'),(59280,165,'Loharwa','344704',1,0,'2022-03-03 12:50:52','2022-03-03 12:50:52'),(59281,165,'Lolawa','344033',1,0,'2022-03-03 12:50:53','2022-03-03 12:50:53'),(59282,165,'Lukhu','344704',1,0,'2022-03-03 12:50:53','2022-03-03 12:50:53'),(59283,165,'Lunada','344035',1,0,'2022-03-03 12:50:53','2022-03-03 12:50:53'),(59284,165,'Lunukhurd','344011',1,0,'2022-03-03 12:50:53','2022-03-03 12:50:53'),(59285,165,'Madhasar','344034',1,0,'2022-03-03 12:50:53','2022-03-03 12:50:53'),(59286,165,'Madpura Barwala','344035',1,0,'2022-03-03 12:50:53','2022-03-03 12:50:53'),(59287,165,'Madpura Sani','344035',1,0,'2022-03-03 12:50:53','2022-03-03 12:50:53'),(59288,165,'Magne Ki Dhani','344001',1,0,'2022-03-03 12:50:53','2022-03-03 12:50:53'),(59289,165,'Mahabar','344001',1,0,'2022-03-03 12:50:53','2022-03-03 12:50:53'),(59290,165,'Mahilawas','344043',1,0,'2022-03-03 12:50:53','2022-03-03 12:50:53'),(59291,165,'Majal','344021',1,0,'2022-03-03 12:50:53','2022-03-03 12:50:53'),(59292,165,'Malpura','344001',1,0,'2022-03-03 12:50:53','2022-03-03 12:50:53'),(59293,165,'Malwa','344011',1,0,'2022-03-03 12:50:53','2022-03-03 12:50:53'),(59294,165,'Mandali','344026',1,0,'2022-03-03 12:50:53','2022-03-03 12:50:53'),(59295,165,'Mandawala','344033',1,0,'2022-03-03 12:50:53','2022-03-03 12:50:53'),(59296,165,'Mangle Ki Beri','344033',1,0,'2022-03-03 12:50:53','2022-03-03 12:50:53'),(59297,165,'Mangta','344704',1,0,'2022-03-03 12:50:53','2022-03-03 12:50:53'),(59298,165,'Manki','344704',1,0,'2022-03-03 12:50:53','2022-03-03 12:50:53'),(59299,165,'Manpura Kharda','344037',1,0,'2022-03-03 12:50:53','2022-03-03 12:50:53'),(59300,165,'Maori','344044',1,0,'2022-03-03 12:50:53','2022-03-03 12:50:53'),(59301,165,'Marudi','344001',1,0,'2022-03-03 12:50:53','2022-03-03 12:50:53'),(59302,165,'Mate Ka Tala','344702',1,0,'2022-03-03 12:50:53','2022-03-03 12:50:53'),(59303,165,'Medusar','344501',1,0,'2022-03-03 12:50:53','2022-03-03 12:50:53'),(59304,165,'Mehlu','344708',1,0,'2022-03-03 12:50:54','2022-03-03 12:50:54'),(59305,165,'Meli Bandha','344044',1,0,'2022-03-03 12:50:54','2022-03-03 12:50:54'),(59306,165,'Mewanagar','344025',1,0,'2022-03-03 12:50:54','2022-03-03 12:50:54'),(59307,165,'Mithara Khurd','344704',1,0,'2022-03-03 12:50:54','2022-03-03 12:50:54'),(59308,165,'Mitharau','344702',1,0,'2022-03-03 12:50:54','2022-03-03 12:50:54'),(59309,165,'Mithe Ka Tala','344702',1,0,'2022-03-03 12:50:54','2022-03-03 12:50:54'),(59310,165,'Mithoda','344801',1,0,'2022-03-03 12:50:54','2022-03-03 12:50:54'),(59311,165,'Mithra Khurd','344001',1,0,'2022-03-03 12:50:54','2022-03-03 12:50:54'),(59312,165,'Mokalsar','344043',1,0,'2022-03-03 12:50:54','2022-03-03 12:50:54'),(59313,165,'Mokhab','344701',1,0,'2022-03-03 12:50:54','2022-03-03 12:50:54'),(59314,165,'Moolani','344706',1,0,'2022-03-03 12:50:54','2022-03-03 12:50:54'),(59315,165,'Moothali','344044',1,0,'2022-03-03 12:50:54','2022-03-03 12:50:54'),(59316,165,'Motisara','344043',1,0,'2022-03-03 12:50:54','2022-03-03 12:50:54'),(59317,165,'Munabao','344501',1,0,'2022-03-03 12:50:54','2022-03-03 12:50:54'),(59318,165,'Mungda','344022',1,0,'2022-03-03 12:50:54','2022-03-03 12:50:54'),(59319,165,'Mungeria','344701',1,0,'2022-03-03 12:50:54','2022-03-03 12:50:54'),(59320,165,'Nagana','344026',1,0,'2022-03-03 12:50:54','2022-03-03 12:50:54'),(59321,165,'Nagarda','344701',1,0,'2022-03-03 12:50:54','2022-03-03 12:50:54'),(59322,165,'Nagarnava','344031',1,0,'2022-03-03 12:50:54','2022-03-03 12:50:54'),(59323,165,'Nand','344011',1,0,'2022-03-03 12:50:54','2022-03-03 12:50:54'),(59324,165,'Navatala Bakhasar','344706',1,0,'2022-03-03 12:50:54','2022-03-03 12:50:54'),(59325,165,'Navatala Jetmal','344702',1,0,'2022-03-03 12:50:54','2022-03-03 12:50:54'),(59326,165,'Nehron Ka Tala','344702',1,0,'2022-03-03 12:50:54','2022-03-03 12:50:54'),(59327,165,'Nehron Ki Dhani','344033',1,0,'2022-03-03 12:50:54','2022-03-03 12:50:54'),(59328,165,'Neori','344026',1,0,'2022-03-03 12:50:54','2022-03-03 12:50:54'),(59329,165,'Netrad','344702',1,0,'2022-03-03 12:50:55','2022-03-03 12:50:55'),(59330,165,'Newai','344032',1,0,'2022-03-03 12:50:55','2022-03-03 12:50:55'),(59331,165,'Nimbalkot','344033',1,0,'2022-03-03 12:50:55','2022-03-03 12:50:55'),(59332,165,'Nimbla','344701',1,0,'2022-03-03 12:50:55','2022-03-03 12:50:55'),(59333,165,'Nokh','344001',1,0,'2022-03-03 12:50:55','2022-03-03 12:50:55'),(59334,165,'Nokhada','344033',1,0,'2022-03-03 12:50:55','2022-03-03 12:50:55'),(59335,165,'Nosar','344033',1,0,'2022-03-03 12:50:55','2022-03-03 12:50:55'),(59336,165,'Ogala','344704',1,0,'2022-03-03 12:50:55','2022-03-03 12:50:55'),(59337,165,'Pachpadra City','344032',1,0,'2022-03-03 12:50:55','2022-03-03 12:50:55'),(59338,165,'Pachpadra Salt','344032',1,0,'2022-03-03 12:50:55','2022-03-03 12:50:55'),(59339,165,'Padarli','344044',1,0,'2022-03-03 12:50:55','2022-03-03 12:50:55'),(59340,165,'Padru','344801',1,0,'2022-03-03 12:50:55','2022-03-03 12:50:55'),(59341,165,'Panawara','344034',1,0,'2022-03-03 12:50:55','2022-03-03 12:50:55'),(59342,165,'Panchala','344501',1,0,'2022-03-03 12:50:55','2022-03-03 12:50:55'),(59343,165,'Pandhi Ka Niwan','344706',1,0,'2022-03-03 12:50:55','2022-03-03 12:50:55'),(59344,165,'Pandhi Ka Par','344502',1,0,'2022-03-03 12:50:55','2022-03-03 12:50:55'),(59345,165,'Panoria','344704',1,0,'2022-03-03 12:50:55','2022-03-03 12:50:55'),(59346,165,'Panyala Kallan','344033',1,0,'2022-03-03 12:50:55','2022-03-03 12:50:55'),(59347,165,'Para','344001',1,0,'2022-03-03 12:50:55','2022-03-03 12:50:55'),(59348,165,'Paradia','344702',1,0,'2022-03-03 12:50:55','2022-03-03 12:50:55'),(59349,165,'Pareu','344032',1,0,'2022-03-03 12:50:55','2022-03-03 12:50:55'),(59350,165,'Parlu','344027',1,0,'2022-03-03 12:50:55','2022-03-03 12:50:55'),(59351,165,'Patau Khurd','344032',1,0,'2022-03-03 12:50:55','2022-03-03 12:50:55'),(59352,165,'Patodi','344032',1,0,'2022-03-03 12:50:55','2022-03-03 12:50:55'),(59353,165,'Patodi Navatala','344032',1,0,'2022-03-03 12:50:56','2022-03-03 12:50:56'),(59354,165,'Pau','344801',1,0,'2022-03-03 12:50:56','2022-03-03 12:50:56'),(59355,165,'Phagalia','344706',1,0,'2022-03-03 12:50:56','2022-03-03 12:50:56'),(59356,165,'Piprali','344031',1,0,'2022-03-03 12:50:56','2022-03-03 12:50:56'),(59357,165,'Punion Ka Tala','344037',1,0,'2022-03-03 12:50:56','2022-03-03 12:50:56'),(59358,165,'Punion Ki Basti','344703',1,0,'2022-03-03 12:50:56','2022-03-03 12:50:56'),(59359,165,'Punjasar','344702',1,0,'2022-03-03 12:50:56','2022-03-03 12:50:56'),(59360,165,'Purawa','344704',1,0,'2022-03-03 12:50:56','2022-03-03 12:50:56'),(59361,165,'Pusad','344701',1,0,'2022-03-03 12:50:56','2022-03-03 12:50:56'),(59362,165,'Rabasar','344702',1,0,'2022-03-03 12:50:56','2022-03-03 12:50:56'),(59363,165,'Radwa','344012',1,0,'2022-03-03 12:50:56','2022-03-03 12:50:56'),(59364,165,'Rajdal','344705',1,0,'2022-03-03 12:50:56','2022-03-03 12:50:56'),(59365,165,'Rakhi','344043',1,0,'2022-03-03 12:50:56','2022-03-03 12:50:56'),(59366,165,'Ramania','344043',1,0,'2022-03-03 12:50:56','2022-03-03 12:50:56'),(59367,165,'Ramdeoria','344708',1,0,'2022-03-03 12:50:56','2022-03-03 12:50:56'),(59368,165,'Ramjan Ki Gaffan','344702',1,0,'2022-03-03 12:50:56','2022-03-03 12:50:56'),(59369,165,'Rampura','344021',1,0,'2022-03-03 12:50:56','2022-03-03 12:50:56'),(59370,165,'Ramsar Ka Kua','344703',1,0,'2022-03-03 12:50:56','2022-03-03 12:50:56'),(59371,165,'Ramsar (Barmer)','344502',1,0,'2022-03-03 12:50:56','2022-03-03 12:50:56'),(59372,165,'Ranasar','344502',1,0,'2022-03-03 12:50:56','2022-03-03 12:50:56'),(59373,165,'Ranasar Kallan','344704',1,0,'2022-03-03 12:50:56','2022-03-03 12:50:56'),(59374,165,'Ranasar Khurd','344033',1,0,'2022-03-03 12:50:56','2022-03-03 12:50:56'),(59375,165,'Raniadashipura','344026',1,0,'2022-03-03 12:50:56','2022-03-03 12:50:56'),(59376,165,'Ranideshipura','344021',1,0,'2022-03-03 12:50:56','2022-03-03 12:50:56'),(59377,165,'Ranigaon','344012',1,0,'2022-03-03 12:50:56','2022-03-03 12:50:56'),(59378,165,'Ratanpura','344031',1,0,'2022-03-03 12:50:56','2022-03-03 12:50:56'),(59379,165,'Ratasar','344702',1,0,'2022-03-03 12:50:57','2022-03-03 12:50:57'),(59380,165,'Rateu','344035',1,0,'2022-03-03 12:50:57','2022-03-03 12:50:57'),(59381,165,'Ratri','344021',1,0,'2022-03-03 12:50:57','2022-03-03 12:50:57'),(59382,165,'Rawatsar (Barmer)','344703',1,0,'2022-03-03 12:50:57','2022-03-03 12:50:57'),(59383,165,'Redana','344001',1,0,'2022-03-03 12:50:57','2022-03-03 12:50:57'),(59384,165,'Richholi','344032',1,0,'2022-03-03 12:50:57','2022-03-03 12:50:57'),(59385,165,'Rohidi','344501',1,0,'2022-03-03 12:50:57','2022-03-03 12:50:57'),(59386,165,'Rohila','344704',1,0,'2022-03-03 12:50:57','2022-03-03 12:50:57'),(59387,165,'Rohila West','344704',1,0,'2022-03-03 12:50:57','2022-03-03 12:50:57'),(59388,165,'Rohili','344035',1,0,'2022-03-03 12:50:57','2022-03-03 12:50:57'),(59389,165,'Sada','344033',1,0,'2022-03-03 12:50:57','2022-03-03 12:50:57'),(59390,165,'Sadecha','344033',1,0,'2022-03-03 12:50:57','2022-03-03 12:50:57'),(59391,165,'Saiyon Ka Tala','344702',1,0,'2022-03-03 12:50:57','2022-03-03 12:50:57'),(59392,165,'Sajan Ka Par','344502',1,0,'2022-03-03 12:50:57','2022-03-03 12:50:57'),(59393,165,'Sajiyali Pk','344032',1,0,'2022-03-03 12:50:57','2022-03-03 12:50:57'),(59394,165,'Salaria','344706',1,0,'2022-03-03 12:50:57','2022-03-03 12:50:57'),(59395,165,'Samdari RS','344021',1,0,'2022-03-03 12:50:57','2022-03-03 12:50:57'),(59396,165,'Samdari','344021',1,0,'2022-03-03 12:50:57','2022-03-03 12:50:57'),(59397,165,'Sanau','344012',1,0,'2022-03-03 12:50:57','2022-03-03 12:50:57'),(59398,165,'Sanawara','344708',1,0,'2022-03-03 12:50:57','2022-03-03 12:50:57'),(59399,165,'Sanjata','344703',1,0,'2022-03-03 12:50:57','2022-03-03 12:50:57'),(59400,165,'Sanpa Manji','344033',1,0,'2022-03-03 12:50:57','2022-03-03 12:50:57'),(59401,165,'Santara','344034',1,0,'2022-03-03 12:50:57','2022-03-03 12:50:57'),(59402,165,'Sanwa','344702',1,0,'2022-03-03 12:50:58','2022-03-03 12:50:58'),(59403,165,'Sanwlore','344012',1,0,'2022-03-03 12:50:58','2022-03-03 12:50:58'),(59404,165,'Sarana','344022',1,0,'2022-03-03 12:50:58','2022-03-03 12:50:58'),(59405,165,'Sarla','344706',1,0,'2022-03-03 12:50:58','2022-03-03 12:50:58'),(59406,165,'Sarli','344703',1,0,'2022-03-03 12:50:58','2022-03-03 12:50:58'),(59407,165,'Sarnu','344703',1,0,'2022-03-03 12:50:58','2022-03-03 12:50:58'),(59408,165,'Sarupe Ka Tala','344702',1,0,'2022-03-03 12:50:58','2022-03-03 12:50:58'),(59409,165,'Sarwadi Purohitan','344026',1,0,'2022-03-03 12:50:58','2022-03-03 12:50:58'),(59410,165,'Sata','344706',1,0,'2022-03-03 12:50:58','2022-03-03 12:50:58'),(59411,165,'Sathuni Purohitan','344032',1,0,'2022-03-03 12:50:58','2022-03-03 12:50:58'),(59412,165,'Sedwa','344706',1,0,'2022-03-03 12:50:58','2022-03-03 12:50:58'),(59413,165,'Sella','344043',1,0,'2022-03-03 12:50:58','2022-03-03 12:50:58'),(59414,165,'Setrau','344502',1,0,'2022-03-03 12:50:58','2022-03-03 12:50:58'),(59415,165,'Sewali','344021',1,0,'2022-03-03 12:50:58','2022-03-03 12:50:58'),(59416,165,'Sewaniyala','344703',1,0,'2022-03-03 12:50:58','2022-03-03 12:50:58'),(59417,165,'Shahar','344037',1,0,'2022-03-03 12:50:58','2022-03-03 12:50:58'),(59418,165,'Shahdad Ka Par','344501',1,0,'2022-03-03 12:50:58','2022-03-03 12:50:58'),(59419,165,'Shiv','344701',1,0,'2022-03-03 12:50:58','2022-03-03 12:50:58'),(59420,165,'Shivkar','344001',1,0,'2022-03-03 12:50:58','2022-03-03 12:50:58'),(59421,165,'Shobhala','344702',1,0,'2022-03-03 12:50:58','2022-03-03 12:50:58'),(59422,165,'Shobhala Jetmal','344702',1,0,'2022-03-03 12:50:58','2022-03-03 12:50:58'),(59423,165,'Shobhala Jetmal II','344033',1,0,'2022-03-03 12:50:58','2022-03-03 12:50:58'),(59424,165,'Shohda','344037',1,0,'2022-03-03 12:50:58','2022-03-03 12:50:58'),(59425,165,'Sillore','344027',1,0,'2022-03-03 12:50:58','2022-03-03 12:50:58'),(59426,165,'Simarkhiya Khara','344032',1,0,'2022-03-03 12:50:58','2022-03-03 12:50:58'),(59427,165,'Simarkhiya Purohitan','344032',1,0,'2022-03-03 12:50:59','2022-03-03 12:50:59'),(59428,165,'Sindhari','344033',1,0,'2022-03-03 12:50:59','2022-03-03 12:50:59'),(59429,165,'Sindhasawa Chauhan','344031',1,0,'2022-03-03 12:50:59','2022-03-03 12:50:59'),(59430,165,'Sindhasawa Harniyan','344031',1,0,'2022-03-03 12:50:59','2022-03-03 12:50:59'),(59431,165,'Siner','344044',1,0,'2022-03-03 12:50:59','2022-03-03 12:50:59'),(59432,165,'Sinhaniya','344706',1,0,'2022-03-03 12:50:59','2022-03-03 12:50:59'),(59433,165,'Sinhar','344706',1,0,'2022-03-03 12:50:59','2022-03-03 12:50:59'),(59434,165,'Sinli Jagir','344022',1,0,'2022-03-03 12:50:59','2022-03-03 12:50:59'),(59435,165,'Sinyani','344001',1,0,'2022-03-03 12:50:59','2022-03-03 12:50:59'),(59436,165,'Siwana','344044',1,0,'2022-03-03 12:50:59','2022-03-03 12:50:59'),(59437,165,'Sodiyar','344708',1,0,'2022-03-03 12:50:59','2022-03-03 12:50:59'),(59438,165,'Somarad','344702',1,0,'2022-03-03 12:50:59','2022-03-03 12:50:59'),(59439,165,'Somesara','344034',1,0,'2022-03-03 12:50:59','2022-03-03 12:50:59'),(59440,165,'Sonari','344704',1,0,'2022-03-03 12:50:59','2022-03-03 12:50:59'),(59441,165,'Soorpura','344026',1,0,'2022-03-03 12:50:59','2022-03-03 12:50:59'),(59442,165,'Sriramwala','344702',1,0,'2022-03-03 12:50:59','2022-03-03 12:50:59'),(59443,165,'Sundra','344501',1,0,'2022-03-03 12:50:59','2022-03-03 12:50:59'),(59444,165,'Sura','344011',1,0,'2022-03-03 12:50:59','2022-03-03 12:50:59'),(59445,165,'Swamy Ka Gaon','344705',1,0,'2022-03-03 12:50:59','2022-03-03 12:50:59'),(59446,165,'Swau Moolraj','344037',1,0,'2022-03-03 12:50:59','2022-03-03 12:50:59'),(59447,165,'Swau Padamsingh','344037',1,0,'2022-03-03 12:50:59','2022-03-03 12:50:59'),(59448,165,'Taku Beri','344703',1,0,'2022-03-03 12:50:59','2022-03-03 12:50:59'),(59449,165,'Tamliyar','344502',1,0,'2022-03-03 12:50:59','2022-03-03 12:50:59'),(59450,165,'Tamlore','344501',1,0,'2022-03-03 12:51:00','2022-03-03 12:51:00'),(59451,165,'Tanu Mansingh','344701',1,0,'2022-03-03 12:51:00','2022-03-03 12:51:00'),(59452,165,'Tapra','344022',1,0,'2022-03-03 12:51:00','2022-03-03 12:51:00'),(59453,165,'Taratara','344012',1,0,'2022-03-03 12:51:00','2022-03-03 12:51:00'),(59454,165,'Taratara Math','344012',1,0,'2022-03-03 12:51:00','2022-03-03 12:51:00'),(59455,165,'Thapan','344044',1,0,'2022-03-03 12:51:00','2022-03-03 12:51:00'),(59456,165,'Thob','344032',1,0,'2022-03-03 12:51:00','2022-03-03 12:51:00'),(59457,165,'Thumbali','344701',1,0,'2022-03-03 12:51:00','2022-03-03 12:51:00'),(59458,165,'Thumbali','344026',1,0,'2022-03-03 12:51:00','2022-03-03 12:51:00'),(59459,165,'Tilwara','344022',1,0,'2022-03-03 12:51:00','2022-03-03 12:51:00'),(59460,165,'Tirsinghdi','344032',1,0,'2022-03-03 12:51:00','2022-03-03 12:51:00'),(59461,165,'Udasar','344704',1,0,'2022-03-03 12:51:00','2022-03-03 12:51:00'),(59462,165,'Umarlai','344027',1,0,'2022-03-03 12:51:00','2022-03-03 12:51:00'),(59463,165,'Undari Juni','344031',1,0,'2022-03-03 12:51:00','2022-03-03 12:51:00'),(59464,165,'Undkha','344012',1,0,'2022-03-03 12:51:00','2022-03-03 12:51:00'),(59465,165,'Undu','344701',1,0,'2022-03-03 12:51:00','2022-03-03 12:51:00'),(59466,165,'Unroad','344011',1,0,'2022-03-03 12:51:00','2022-03-03 12:51:00'),(59467,165,'Uparla','344702',1,0,'2022-03-03 12:51:00','2022-03-03 12:51:00'),(59468,165,'Uttarl R.S.','344001',1,0,'2022-03-03 12:51:00','2022-03-03 12:51:00'),(59469,165,'Uttarlai Mines','344035',1,0,'2022-03-03 12:51:00','2022-03-03 12:51:00'),(59470,165,'Uttarni','344034',1,0,'2022-03-03 12:51:00','2022-03-03 12:51:00'),(59471,166,'Abhorra','321202',1,0,'2022-03-03 12:51:00','2022-03-03 12:51:00'),(59472,166,'Aghapur','321001',1,0,'2022-03-03 12:51:00','2022-03-03 12:51:00'),(59473,166,'Ajan','321025',1,0,'2022-03-03 12:51:00','2022-03-03 12:51:00'),(59474,166,'Ajau','321303',1,0,'2022-03-03 12:51:00','2022-03-03 12:51:00'),(59475,166,'Akata','321022',1,0,'2022-03-03 12:51:00','2022-03-03 12:51:00'),(59476,166,'Akhaigarh','321614',1,0,'2022-03-03 12:51:01','2022-03-03 12:51:01'),(59477,166,'Alamshah','321024',1,0,'2022-03-03 12:51:01','2022-03-03 12:51:01'),(59478,166,'Alghani','321024',1,0,'2022-03-03 12:51:01','2022-03-03 12:51:01'),(59479,166,'Alipur','321615',1,0,'2022-03-03 12:51:01','2022-03-03 12:51:01'),(59480,166,'Amoli','321407',1,0,'2022-03-03 12:51:01','2022-03-03 12:51:01'),(59481,166,'Anahgatebharatpur','321001',1,0,'2022-03-03 12:51:01','2022-03-03 12:51:01'),(59482,166,'Anand Dadri','321022',1,0,'2022-03-03 12:51:01','2022-03-03 12:51:01'),(59483,166,'Anchera','321602',1,0,'2022-03-03 12:51:01','2022-03-03 12:51:01'),(59484,166,'Andhiyari','321302',1,0,'2022-03-03 12:51:01','2022-03-03 12:51:01'),(59485,166,'Astawan','321201',1,0,'2022-03-03 12:51:01','2022-03-03 12:51:01'),(59486,166,'Atari','321028',1,0,'2022-03-03 12:51:01','2022-03-03 12:51:01'),(59487,166,'Au','321203',1,0,'2022-03-03 12:51:01','2022-03-03 12:51:01'),(59488,166,'Awar','321202',1,0,'2022-03-03 12:51:01','2022-03-03 12:51:01'),(59489,166,'Babekhar','321615',1,0,'2022-03-03 12:51:01','2022-03-03 12:51:01'),(59490,166,'Baben','321026',1,0,'2022-03-03 12:51:01','2022-03-03 12:51:01'),(59491,166,'Bachhamdi','321302',1,0,'2022-03-03 12:51:01','2022-03-03 12:51:01'),(59492,166,'Bachhamdi Noh','321001',1,0,'2022-03-03 12:51:01','2022-03-03 12:51:01'),(59493,166,'Bachhren','321407',1,0,'2022-03-03 12:51:01','2022-03-03 12:51:01'),(59494,166,'Badangarh','321203',1,0,'2022-03-03 12:51:01','2022-03-03 12:51:01'),(59495,166,'Badipur','321023',1,0,'2022-03-03 12:51:01','2022-03-03 12:51:01'),(59496,166,'Bahaj','321203',1,0,'2022-03-03 12:51:01','2022-03-03 12:51:01'),(59497,166,'Bahtana','321203',1,0,'2022-03-03 12:51:01','2022-03-03 12:51:01'),(59498,166,'Ballabhgarh','321409',1,0,'2022-03-03 12:51:01','2022-03-03 12:51:01'),(59499,166,'Bamanwari','321023',1,0,'2022-03-03 12:51:01','2022-03-03 12:51:01'),(59500,166,'Bansi','321301',1,0,'2022-03-03 12:51:02','2022-03-03 12:51:02'),(59501,166,'Bansi Khurd','321303',1,0,'2022-03-03 12:51:02','2022-03-03 12:51:02'),(59502,166,'Barakhur','321021',1,0,'2022-03-03 12:51:02','2022-03-03 12:51:02'),(59503,166,'Barauli Chhar','321614',1,0,'2022-03-03 12:51:02','2022-03-03 12:51:02'),(59504,166,'Barauli Dhau','321022',1,0,'2022-03-03 12:51:02','2022-03-03 12:51:02'),(59505,166,'Bareh Mafi','321301',1,0,'2022-03-03 12:51:02','2022-03-03 12:51:02'),(59506,166,'Bargha','321301',1,0,'2022-03-03 12:51:02','2022-03-03 12:51:02'),(59507,166,'Barkheda','321028',1,0,'2022-03-03 12:51:02','2022-03-03 12:51:02'),(59508,166,'Baroli','321406',1,0,'2022-03-03 12:51:02','2022-03-03 12:51:02'),(59509,166,'Baroli Chuth','321203',1,0,'2022-03-03 12:51:02','2022-03-03 12:51:02'),(59510,166,'Baroli Ran','321614',1,0,'2022-03-03 12:51:02','2022-03-03 12:51:02'),(59511,166,'Barso','321001',1,0,'2022-03-03 12:51:02','2022-03-03 12:51:02'),(59512,166,'Bedham','321203',1,0,'2022-03-03 12:51:02','2022-03-03 12:51:02'),(59513,166,'Behnera','321001',1,0,'2022-03-03 12:51:02','2022-03-03 12:51:02'),(59514,166,'Belara','321602',1,0,'2022-03-03 12:51:02','2022-03-03 12:51:02'),(59515,166,'Berru','321024',1,0,'2022-03-03 12:51:02','2022-03-03 12:51:02'),(59516,166,'Bhadira','321602',1,0,'2022-03-03 12:51:02','2022-03-03 12:51:02'),(59517,166,'Bhainsa','321301',1,0,'2022-03-03 12:51:02','2022-03-03 12:51:02'),(59518,166,'Bhaiseena','321615',1,0,'2022-03-03 12:51:02','2022-03-03 12:51:02'),(59519,166,'Bhandara','321022',1,0,'2022-03-03 12:51:02','2022-03-03 12:51:02'),(59520,166,'Bhandore','321026',1,0,'2022-03-03 12:51:02','2022-03-03 12:51:02'),(59521,166,'Bharatpur Agency','321001',1,0,'2022-03-03 12:51:02','2022-03-03 12:51:02'),(59522,166,'Bharatpur City','321001',1,0,'2022-03-03 12:51:02','2022-03-03 12:51:02'),(59523,166,'Bharatpur H.O','321001',1,0,'2022-03-03 12:51:02','2022-03-03 12:51:02'),(59524,166,'Bhatawali','321602',1,0,'2022-03-03 12:51:02','2022-03-03 12:51:02'),(59525,166,'Bhatpura','321205',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59526,166,'Bhonri','321204',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59527,166,'Bhont','321303',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59528,166,'Bhusawar','321406',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59529,166,'Bhutoli','321642',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59530,166,'Bijwari','321407',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59531,166,'Bilond','321022',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59532,166,'Bilong','321022',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59533,166,'Bilothi','321025',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59534,166,'Birheru','321201',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59535,166,'Bodoli Dahar','321204',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59536,166,'Bolkhera','321022',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59537,166,'Boodli','321024',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59538,166,'Borai','321026',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59539,166,'Chentoli','321407',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59540,166,'Chhichhalwari','321022',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59541,166,'Chhonkarwara Kalan','321407',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59542,166,'Chichana','321001',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59543,166,'Chiksana','321001',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59544,166,'Chulhera','321203',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59545,166,'Collectorate BTP','321001',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59546,166,'Dandera','321023',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59547,166,'Dantlothi','321203',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59548,166,'Dawak','321024',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59549,166,'Deeg H.O','321203',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59550,166,'Dehra','321028',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59551,166,'Dehra','321026',1,0,'2022-03-03 12:51:03','2022-03-03 12:51:03'),(59552,166,'Dhamari','321022',1,0,'2022-03-03 12:51:04','2022-03-03 12:51:04'),(59553,166,'Dhanota','321303',1,0,'2022-03-03 12:51:04','2022-03-03 12:51:04'),(59554,166,'Dhanwara','321201',1,0,'2022-03-03 12:51:04','2022-03-03 12:51:04'),(59555,166,'Dharsoni','321028',1,0,'2022-03-03 12:51:04','2022-03-03 12:51:04'),(59556,166,'Dhilawati','321022',1,0,'2022-03-03 12:51:04','2022-03-03 12:51:04'),(59557,166,'Dhoolet','321204',1,0,'2022-03-03 12:51:04','2022-03-03 12:51:04'),(59558,166,'Dhormui','321025',1,0,'2022-03-03 12:51:04','2022-03-03 12:51:04'),(59559,166,'Didawali','321203',1,0,'2022-03-03 12:51:04','2022-03-03 12:51:04'),(59560,166,'Diwali','321406',1,0,'2022-03-03 12:51:04','2022-03-03 12:51:04'),(59561,166,'Dundawal','321205',1,0,'2022-03-03 12:51:04','2022-03-03 12:51:04'),(59562,166,'Ekta','321302',1,0,'2022-03-03 12:51:04','2022-03-03 12:51:04'),(59563,166,'Forest Lodge','321001',1,0,'2022-03-03 12:51:04','2022-03-03 12:51:04'),(59564,166,'Gadauli','321602',1,0,'2022-03-03 12:51:04','2022-03-03 12:51:04'),(59565,166,'Gagwana','321303',1,0,'2022-03-03 12:51:04','2022-03-03 12:51:04'),(59566,166,'Gangora','321204',1,0,'2022-03-03 12:51:04','2022-03-03 12:51:04'),(59567,166,'Gangrauli','321602',1,0,'2022-03-03 12:51:04','2022-03-03 12:51:04'),(59568,166,'Gaomdi','321021',1,0,'2022-03-03 12:51:04','2022-03-03 12:51:04'),(59569,166,'Gaomri','321023',1,0,'2022-03-03 12:51:04','2022-03-03 12:51:04'),(59570,166,'Garh Ajan','321022',1,0,'2022-03-03 12:51:04','2022-03-03 12:51:04'),(59571,166,'Ghatmika','321204',1,0,'2022-03-03 12:51:04','2022-03-03 12:51:04'),(59572,166,'Ghatri','321409',1,0,'2022-03-03 12:51:04','2022-03-03 12:51:04'),(59573,166,'Ghosinga','321023',1,0,'2022-03-03 12:51:04','2022-03-03 12:51:04'),(59574,166,'Ghusiyari','321001',1,0,'2022-03-03 12:51:04','2022-03-03 12:51:04'),(59575,166,'Gogera','321409',1,0,'2022-03-03 12:51:04','2022-03-03 12:51:04'),(59576,166,'Gopalgarh','321204',1,0,'2022-03-03 12:51:04','2022-03-03 12:51:04'),(59577,166,'Gopalgarh BTP','321001',1,0,'2022-03-03 12:51:05','2022-03-03 12:51:05'),(59578,166,'Gudawali','321642',1,0,'2022-03-03 12:51:05','2022-03-03 12:51:05'),(59579,166,'Guhana','321203',1,0,'2022-03-03 12:51:05','2022-03-03 12:51:05'),(59580,166,'Gulpada','321024',1,0,'2022-03-03 12:51:05','2022-03-03 12:51:05'),(59581,166,'Gunsara','321202',1,0,'2022-03-03 12:51:05','2022-03-03 12:51:05'),(59582,166,'Halena','321601',1,0,'2022-03-03 12:51:05','2022-03-03 12:51:05'),(59583,166,'Hantra','321601',1,0,'2022-03-03 12:51:05','2022-03-03 12:51:05'),(59584,166,'Hatheni','321021',1,0,'2022-03-03 12:51:05','2022-03-03 12:51:05'),(59585,166,'Hathodi','321409',1,0,'2022-03-03 12:51:05','2022-03-03 12:51:05'),(59586,166,'Hatizar','321028',1,0,'2022-03-03 12:51:05','2022-03-03 12:51:05'),(59587,166,'Helak','321303',1,0,'2022-03-03 12:51:05','2022-03-03 12:51:05'),(59588,166,'Hingota','321205',1,0,'2022-03-03 12:51:05','2022-03-03 12:51:05'),(59589,166,'Iklera','321203',1,0,'2022-03-03 12:51:05','2022-03-03 12:51:05'),(59590,166,'Ikran','321001',1,0,'2022-03-03 12:51:05','2022-03-03 12:51:05'),(59591,166,'Indrauli','321022',1,0,'2022-03-03 12:51:05','2022-03-03 12:51:05'),(59592,166,'Ishapur Katara','321602',1,0,'2022-03-03 12:51:05','2022-03-03 12:51:05'),(59593,166,'Jaghina','321021',1,0,'2022-03-03 12:51:05','2022-03-03 12:51:05'),(59594,166,'Jahaj','321409',1,0,'2022-03-03 12:51:05','2022-03-03 12:51:05'),(59595,166,'Jahangirpur','321028',1,0,'2022-03-03 12:51:05','2022-03-03 12:51:05'),(59596,166,'Jai Sri','321024',1,0,'2022-03-03 12:51:05','2022-03-03 12:51:05'),(59597,166,'Jalalpur','321024',1,0,'2022-03-03 12:51:05','2022-03-03 12:51:05'),(59598,166,'Jaluki','321205',1,0,'2022-03-03 12:51:05','2022-03-03 12:51:05'),(59599,166,'Janoothar','321206',1,0,'2022-03-03 12:51:05','2022-03-03 12:51:05'),(59600,166,'Jasupura','321409',1,0,'2022-03-03 12:51:05','2022-03-03 12:51:05'),(59601,166,'Jateri','321203',1,0,'2022-03-03 12:51:05','2022-03-03 12:51:05'),(59602,166,'Jatoli Rathbhan','321025',1,0,'2022-03-03 12:51:05','2022-03-03 12:51:05'),(59603,166,'Jatoli Thoon','321205',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59604,166,'Jhanjhar','321024',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59605,166,'Jharauti','321615',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59606,166,'Jharkai','321642',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59607,166,'Jharoli','321303',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59608,166,'Jotri Peepal','321204',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59609,166,'Jotruhalla','321204',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59610,166,'Jurhera','321023',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59611,166,'Kaithwara','321024',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59612,166,'Kakrala','321024',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59613,166,'Kalsada','321409',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59614,166,'Kamalpura','321407',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59615,166,'Kamanlsg','321022',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59616,166,'Kanjoli Line','321026',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59617,166,'Karai','321602',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59618,166,'Karawali','321409',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59619,166,'Karili','321602',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59620,166,'Kasoda','321026',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59621,166,'Kasot','321202',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59622,166,'Kathol','321204',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59623,166,'Kawai','321602',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59624,166,'Khakhawali','321205',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59625,166,'Khandeola','321204',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59626,166,'Khangri','321642',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59627,166,'Khatoti','321602',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59628,166,'Kherli Gadasia','321028',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59629,166,'Kherli Gujar','321601',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59630,166,'Khesti','321024',1,0,'2022-03-03 12:51:06','2022-03-03 12:51:06'),(59631,166,'Khoh','321203',1,0,'2022-03-03 12:51:07','2022-03-03 12:51:07'),(59632,166,'Khohri','321024',1,0,'2022-03-03 12:51:07','2022-03-03 12:51:07'),(59633,166,'Khohri','321203',1,0,'2022-03-03 12:51:07','2022-03-03 12:51:07'),(59634,166,'Konrer','321202',1,0,'2022-03-03 12:51:07','2022-03-03 12:51:07'),(59635,166,'Kotwalibharatpur','321001',1,0,'2022-03-03 12:51:07','2022-03-03 12:51:07'),(59636,166,'Krishna Colony BTP','321001',1,0,'2022-03-03 12:51:07','2022-03-03 12:51:07'),(59637,166,'Kumha','321303',1,0,'2022-03-03 12:51:07','2022-03-03 12:51:07'),(59638,166,'KUMHAREDI','321205',1,0,'2022-03-03 12:51:07','2022-03-03 12:51:07'),(59639,166,'Kumher','321201',1,0,'2022-03-03 12:51:07','2022-03-03 12:51:07'),(59640,166,'Kumhergate BTP','321001',1,0,'2022-03-03 12:51:07','2022-03-03 12:51:07'),(59641,166,'Kurka','321301',1,0,'2022-03-03 12:51:07','2022-03-03 12:51:07'),(59642,166,'Ladamka','321204',1,0,'2022-03-03 12:51:07','2022-03-03 12:51:07'),(59643,166,'Lakhanpur','321028',1,0,'2022-03-03 12:51:07','2022-03-03 12:51:07'),(59644,166,'Ludhawai','321303',1,0,'2022-03-03 12:51:07','2022-03-03 12:51:07'),(59645,166,'Luhasa','321602',1,0,'2022-03-03 12:51:07','2022-03-03 12:51:07'),(59646,166,'Luhesor','321022',1,0,'2022-03-03 12:51:07','2022-03-03 12:51:07'),(59647,166,'M.V.Peeth Bhusawar','321406',1,0,'2022-03-03 12:51:07','2022-03-03 12:51:07'),(59648,166,'Madhoni','321026',1,0,'2022-03-03 12:51:07','2022-03-03 12:51:07'),(59649,166,'Mahua','321303',1,0,'2022-03-03 12:51:07','2022-03-03 12:51:07'),(59650,166,'Mai','321028',1,0,'2022-03-03 12:51:07','2022-03-03 12:51:07'),(59651,166,'Mainapura','321409',1,0,'2022-03-03 12:51:07','2022-03-03 12:51:07'),(59652,166,'Majajpur','321409',1,0,'2022-03-03 12:51:07','2022-03-03 12:51:07'),(59653,166,'Malah','321001',1,0,'2022-03-03 12:51:07','2022-03-03 12:51:07'),(59654,166,'Manjhi','321602',1,0,'2022-03-03 12:51:07','2022-03-03 12:51:07'),(59655,166,'Manota Kalan','321205',1,0,'2022-03-03 12:51:07','2022-03-03 12:51:07'),(59656,166,'Mathura Gate BTP','321001',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59657,166,'Matuki','321022',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59658,166,'Mehrawar','321201',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59659,166,'Milakpur','321302',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59660,166,'Moloni','321601',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59661,166,'Moondoti','321205',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59662,166,'Moroli','321203',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59663,166,'Moroli Kalan','321025',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59664,166,'Mudhera','321302',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59665,166,'Mudia Sadh','321407',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59666,166,'Mudiya Lalita','321601',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59667,166,'Mudota','321303',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59668,166,'Mundiya','321205',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59669,166,'Murwara','321026',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59670,166,'Musepur','321022',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59671,166,'Nadbai','321602',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59672,166,'Nadbai Town','321602',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59673,166,'Nagar (Bharatpur)','321205',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59674,166,'Nagla Satwari','321204',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59675,166,'Nagla Tehriyan','321302',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59676,166,'Naom','321642',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59677,166,'Narharpur','321406',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59678,166,'Naroli','321615',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59679,166,'Nayabas','321614',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59680,166,'Nayagaom Khalsa','321406',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59681,166,'Nehra Chauth','321203',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59682,166,'Nekpur','321302',1,0,'2022-03-03 12:51:08','2022-03-03 12:51:08'),(59683,166,'New Mandi BTP','321001',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59684,166,'Newada','321407',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59685,166,'Nigoi','321203',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59686,166,'Nithar','321409',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59687,166,'Niyotha','321642',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59688,166,'Nogaom','321023',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59689,166,'Nonera','321023',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59690,166,'Olanda','321024',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59691,166,'Padalwas','321205',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59692,166,'Pahari (Bharatpur)','321204',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59693,166,'Paharsar','321602',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59694,166,'Pai','321023',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59695,166,'Pala','321201',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59696,166,'Pali','321601',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59697,166,'Palka','321024',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59698,166,'Panhori','321203',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59699,166,'Papra','321204',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59700,166,'Paprera','321602',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59701,166,'Par','321303',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59702,166,'Paraswara','321028',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59703,166,'Parmadra','321203',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59704,166,'Pasopa','321022',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59705,166,'Pasta','321203',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59706,166,'Pathena','321615',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59707,166,'Pathroli','321204',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59708,166,'Pendka','321205',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59709,166,'Penghore','321202',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59710,166,'Phulwara','321021',1,0,'2022-03-03 12:51:09','2022-03-03 12:51:09'),(59711,166,'Pichumar','321201',1,0,'2022-03-03 12:51:10','2022-03-03 12:51:10'),(59712,166,'Pichuna','321301',1,0,'2022-03-03 12:51:10','2022-03-03 12:51:10'),(59713,166,'Pili','321642',1,0,'2022-03-03 12:51:10','2022-03-03 12:51:10'),(59714,166,'Pingora','321028',1,0,'2022-03-03 12:51:10','2022-03-03 12:51:10'),(59715,166,'Pipalkheda','321024',1,0,'2022-03-03 12:51:10','2022-03-03 12:51:10'),(59716,166,'Pipla','321021',1,0,'2022-03-03 12:51:10','2022-03-03 12:51:10'),(59717,166,'Piprau','321614',1,0,'2022-03-03 12:51:10','2022-03-03 12:51:10'),(59718,166,'Poonchhari','321205',1,0,'2022-03-03 12:51:10','2022-03-03 12:51:10'),(59719,166,'Raisis','321602',1,0,'2022-03-03 12:51:10','2022-03-03 12:51:10'),(59720,166,'Randhirgarh','321406',1,0,'2022-03-03 12:51:10','2022-03-03 12:51:10'),(59721,166,'Ranf','321024',1,0,'2022-03-03 12:51:10','2022-03-03 12:51:10'),(59722,166,'Ranjeet Nagar BTP','321001',1,0,'2022-03-03 12:51:10','2022-03-03 12:51:10'),(59723,166,'Rareh','321025',1,0,'2022-03-03 12:51:10','2022-03-03 12:51:10'),(59724,166,'Ronija','321602',1,0,'2022-03-03 12:51:10','2022-03-03 12:51:10'),(59725,166,'Sablana','321022',1,0,'2022-03-03 12:51:10','2022-03-03 12:51:10'),(59726,166,'Sabora','321201',1,0,'2022-03-03 12:51:10','2022-03-03 12:51:10'),(59727,166,'Sadpuri','321205',1,0,'2022-03-03 12:51:10','2022-03-03 12:51:10'),(59728,166,'Saheda','321023',1,0,'2022-03-03 12:51:10','2022-03-03 12:51:10'),(59729,166,'Saindhli','321406',1,0,'2022-03-03 12:51:10','2022-03-03 12:51:10'),(59730,166,'Salempur Kalan','321409',1,0,'2022-03-03 12:51:10','2022-03-03 12:51:10'),(59731,166,'Salempur Khurd','321407',1,0,'2022-03-03 12:51:10','2022-03-03 12:51:10'),(59732,166,'Samai Kheda','321203',1,0,'2022-03-03 12:51:10','2022-03-03 12:51:10'),(59733,166,'Samler','321204',1,0,'2022-03-03 12:51:10','2022-03-03 12:51:10'),(59734,166,'Santruk','321025',1,0,'2022-03-03 12:51:10','2022-03-03 12:51:10'),(59735,166,'Sarsena','321642',1,0,'2022-03-03 12:51:10','2022-03-03 12:51:10'),(59736,166,'Satwas','321023',1,0,'2022-03-03 12:51:11','2022-03-03 12:51:11'),(59737,166,'Saumka','321204',1,0,'2022-03-03 12:51:11','2022-03-03 12:51:11'),(59738,166,'Sehna','321302',1,0,'2022-03-03 12:51:11','2022-03-03 12:51:11'),(59739,166,'Sehson','321023',1,0,'2022-03-03 12:51:11','2022-03-03 12:51:11'),(59740,166,'Semla Kalan','321205',1,0,'2022-03-03 12:51:11','2022-03-03 12:51:11'),(59741,166,'Semli','321205',1,0,'2022-03-03 12:51:11','2022-03-03 12:51:11'),(59742,166,'Sewar','321303',1,0,'2022-03-03 12:51:11','2022-03-03 12:51:11'),(59743,166,'Shekhpur','321028',1,0,'2022-03-03 12:51:11','2022-03-03 12:51:11'),(59744,166,'Shiswara','321203',1,0,'2022-03-03 12:51:11','2022-03-03 12:51:11'),(59745,166,'Sihi','321602',1,0,'2022-03-03 12:51:11','2022-03-03 12:51:11'),(59746,166,'Sikri','321024',1,0,'2022-03-03 12:51:11','2022-03-03 12:51:11'),(59747,166,'Sikrori','321201',1,0,'2022-03-03 12:51:11','2022-03-03 12:51:11'),(59748,166,'Sinsini','321201',1,0,'2022-03-03 12:51:11','2022-03-03 12:51:11'),(59749,166,'Sirthala','321205',1,0,'2022-03-03 12:51:11','2022-03-03 12:51:11'),(59750,166,'Sogar','321001',1,0,'2022-03-03 12:51:11','2022-03-03 12:51:11'),(59751,166,'Suhari','321406',1,0,'2022-03-03 12:51:11','2022-03-03 12:51:11'),(59752,166,'Sunari','321001',1,0,'2022-03-03 12:51:11','2022-03-03 12:51:11'),(59753,166,'Sundrawali','321205',1,0,'2022-03-03 12:51:11','2022-03-03 12:51:11'),(59754,166,'Sunhera','321022',1,0,'2022-03-03 12:51:11','2022-03-03 12:51:11'),(59755,166,'Syorawali','321203',1,0,'2022-03-03 12:51:11','2022-03-03 12:51:11'),(59756,166,'Takha','321025',1,0,'2022-03-03 12:51:11','2022-03-03 12:51:11'),(59757,166,'Talchhera','321614',1,0,'2022-03-03 12:51:11','2022-03-03 12:51:11'),(59758,166,'Talfara','321202',1,0,'2022-03-03 12:51:11','2022-03-03 12:51:11'),(59759,166,'Tamrer','321202',1,0,'2022-03-03 12:51:11','2022-03-03 12:51:11'),(59760,166,'Tarondar','321205',1,0,'2022-03-03 12:51:11','2022-03-03 12:51:11'),(59761,166,'Teski','321024',1,0,'2022-03-03 12:51:11','2022-03-03 12:51:11'),(59762,166,'Thairawar','321201',1,0,'2022-03-03 12:51:12','2022-03-03 12:51:12'),(59763,166,'Thoon','321205',1,0,'2022-03-03 12:51:12','2022-03-03 12:51:12'),(59764,166,'Tuhiya','321001',1,0,'2022-03-03 12:51:12','2022-03-03 12:51:12'),(59765,166,'Ubhaka','321204',1,0,'2022-03-03 12:51:12','2022-03-03 12:51:12'),(59766,166,'Uchain','321302',1,0,'2022-03-03 12:51:12','2022-03-03 12:51:12'),(59767,166,'Unch','321602',1,0,'2022-03-03 12:51:12','2022-03-03 12:51:12'),(59768,166,'Uncha Gaom','321303',1,0,'2022-03-03 12:51:12','2022-03-03 12:51:12'),(59769,166,'Unchera','321023',1,0,'2022-03-03 12:51:12','2022-03-03 12:51:12'),(59770,166,'Undra','321001',1,0,'2022-03-03 12:51:12','2022-03-03 12:51:12'),(59771,166,'Ushrani','321201',1,0,'2022-03-03 12:51:12','2022-03-03 12:51:12'),(59772,166,'Utarda','321614',1,0,'2022-03-03 12:51:12','2022-03-03 12:51:12'),(59773,166,'Veerampura','321302',1,0,'2022-03-03 12:51:12','2022-03-03 12:51:12'),(59774,166,'Adda','321411',1,0,'2022-03-03 12:51:12','2022-03-03 12:51:12'),(59775,166,'Aroda','321411',1,0,'2022-03-03 12:51:12','2022-03-03 12:51:12'),(59776,166,'Bagren','321411',1,0,'2022-03-03 12:51:12','2022-03-03 12:51:12'),(59777,166,'Bajhera Kalan','321408',1,0,'2022-03-03 12:51:12','2022-03-03 12:51:12'),(59778,166,'Band Baretha','321405',1,0,'2022-03-03 12:51:12','2022-03-03 12:51:12'),(59779,166,'Banshi Paharpur','321403',1,0,'2022-03-03 12:51:12','2022-03-03 12:51:12'),(59780,166,'Bansi','321408',1,0,'2022-03-03 12:51:12','2022-03-03 12:51:12'),(59781,166,'Baroda','321402',1,0,'2022-03-03 12:51:12','2022-03-03 12:51:12'),(59782,166,'Bayana','321401',1,0,'2022-03-03 12:51:12','2022-03-03 12:51:12'),(59783,166,'Bazariya Bayana','321401',1,0,'2022-03-03 12:51:12','2022-03-03 12:51:12'),(59784,166,'Bhawanpura','321405',1,0,'2022-03-03 12:51:12','2022-03-03 12:51:12'),(59785,166,'Bidiyari','321401',1,0,'2022-03-03 12:51:12','2022-03-03 12:51:12'),(59786,166,'Brahmbad','321410',1,0,'2022-03-03 12:51:12','2022-03-03 12:51:12'),(59787,166,'Chak Samri','321404',1,0,'2022-03-03 12:51:12','2022-03-03 12:51:12'),(59788,166,'Chenkora','321404',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59789,166,'Dahgaon','321401',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59790,166,'Dahina Gaon','321402',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59791,166,'Damdama','321401',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59792,166,'Dana Khedli','321403',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59793,166,'Daulat Garh','321404',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59794,166,'Dhadhren','321411',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59795,166,'Dorda','321404',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59796,166,'Dumaria','321405',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59797,166,'Farso','321401',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59798,166,'Gajipur','321411',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59799,166,'Garhi Bajna','321405',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59800,166,'Gobra','321401',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59801,166,'Hishamada','321408',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59802,166,'Ibrahimpur','321404',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59803,166,'Jagjiwanpur','321408',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59804,166,'Jatmasi','321403',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59805,166,'Jeewad','321408',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59806,166,'Jotroli','321403',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59807,166,'Kachahri Bayana','321401',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59808,166,'Kakraua','321402',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59809,166,'Kanavar','321401',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59810,166,'Kapoora Malooka','321411',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59811,166,'Karwari','321411',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59812,166,'Keir','321411',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59813,166,'Khan Kheda','321411',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59814,166,'Khan Surjapur','321404',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59815,166,'Khanwa','321404',1,0,'2022-03-03 12:51:13','2022-03-03 12:51:13'),(59816,166,'Khareri','321411',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59817,166,'Khera Thakur','321402',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59818,166,'Khohra','321401',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59819,166,'Khunt Kheda','321411',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59820,166,'Kot','321405',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59821,166,'Lakhanpur','321408',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59822,166,'Lehchora Kalan','321401',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59823,166,'Madanpur','321411',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59824,166,'Madha Pura','321402',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59825,166,'Mahaloni','321401',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59826,166,'Mahalpur Choora','321403',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59827,166,'Mahmadpura','321405',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59828,166,'Maloni','321404',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59829,166,'Mandoli','321402',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59830,166,'Mehrawar','321411',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59831,166,'Mertha','321404',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59832,166,'Milsama','321404',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59833,166,'Moroli Dang','321402',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59834,166,'Muhari','321408',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59835,166,'Nagla Tula','321405',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59836,166,'Nahroli','321401',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59837,166,'Naroli','321410',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59838,166,'Navali','321401',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59839,166,'Nayagaon','321404',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59840,166,'Nibhera','321402',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59841,166,'Noharda','321404',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59842,166,'Ondelgaddi','321404',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59843,166,'Pali Dang','321405',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59844,166,'Paraua','321405',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59845,166,'Purabai Kheda','321410',1,0,'2022-03-03 12:51:14','2022-03-03 12:51:14'),(59846,166,'Rahimgarh','321408',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59847,166,'Raroda','321411',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59848,166,'Rasilpur','321402',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59849,166,'Roopbas','321404',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59850,166,'Roopbas Town','321404',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59851,166,'Rudawal','321402',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59852,166,'Rundh','321404',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59853,166,'Sadpura','321410',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59854,166,'Salabad','321401',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59855,166,'Samogar','321411',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59856,166,'Samraya','321408',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59857,166,'Samri','321405',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59858,166,'Shahpur Dang','321401',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59859,166,'Shergarh','321401',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59860,166,'Sikandara','321401',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59861,166,'Singhada','321410',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59862,166,'Singhania','321405',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59863,166,'Siras','321408',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59864,166,'Sirrond','321403',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59865,166,'Soopa','321410',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59866,166,'Suhans','321408',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59867,166,'Tarsuma','321405',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59868,166,'Thana Tang','321401',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59869,166,'Turtipura','321405',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59870,166,'Umrend','321408',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59871,166,'Weir','321408',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59872,166,'Weir Town','321408',1,0,'2022-03-03 12:51:15','2022-03-03 12:51:15'),(59873,168,'17 K.Y.D.','334023',1,0,'2022-03-03 12:51:17','2022-03-03 12:51:17'),(59874,168,'2 K.L.D.','334023',1,0,'2022-03-03 12:51:17','2022-03-03 12:51:17'),(59875,168,'61 Head','334023',1,0,'2022-03-03 12:51:17','2022-03-03 12:51:17'),(59876,168,'Aadsar','331801',1,0,'2022-03-03 12:51:17','2022-03-03 12:51:17'),(59877,168,'Akasar','334001',1,0,'2022-03-03 12:51:17','2022-03-03 12:51:17'),(59878,168,'Amarpura','334001',1,0,'2022-03-03 12:51:17','2022-03-03 12:51:17'),(59879,168,'Ambasar','334402',1,0,'2022-03-03 12:51:17','2022-03-03 12:51:17'),(59880,168,'Ankhisar','334802',1,0,'2022-03-03 12:51:17','2022-03-03 12:51:17'),(59881,168,'Arjansar','334604',1,0,'2022-03-03 12:51:17','2022-03-03 12:51:17'),(59882,168,'Bachasar','334001',1,0,'2022-03-03 12:51:17','2022-03-03 12:51:17'),(59883,168,'Badhnu','334202',1,0,'2022-03-03 12:51:17','2022-03-03 12:51:17'),(59884,168,'Bagadsar','334305',1,0,'2022-03-03 12:51:17','2022-03-03 12:51:17'),(59885,168,'Bainisar','331811',1,0,'2022-03-03 12:51:17','2022-03-03 12:51:17'),(59886,168,'Bajju','334305',1,0,'2022-03-03 12:51:17','2022-03-03 12:51:17'),(59887,168,'Baladesar','334604',1,0,'2022-03-03 12:51:17','2022-03-03 12:51:17'),(59888,168,'Bamanwali','334601',1,0,'2022-03-03 12:51:17','2022-03-03 12:51:17'),(59889,168,'Bambloo','334022',1,0,'2022-03-03 12:51:17','2022-03-03 12:51:17'),(59890,168,'Bana','331803',1,0,'2022-03-03 12:51:17','2022-03-03 12:51:17'),(59891,168,'Bandhra','334803',1,0,'2022-03-03 12:51:17','2022-03-03 12:51:17'),(59892,168,'Bangalanagar','334004',1,0,'2022-03-03 12:51:17','2022-03-03 12:51:17'),(59893,168,'Bapeu','331803',1,0,'2022-03-03 12:51:17','2022-03-03 12:51:17'),(59894,168,'Barjangsar','331803',1,0,'2022-03-03 12:51:17','2022-03-03 12:51:17'),(59895,168,'Barsalpur','334305',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59896,168,'Barsingsar','334402',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59897,168,'Beejhansar','331803',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59898,168,'Beekasar','334803',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59899,168,'Belasar','334202',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59900,168,'Berasar','334802',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59901,168,'Bhalda','334803',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59902,168,'Bhaluri','334305',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59903,168,'Bhamatsar','334801',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59904,168,'Bhanekagaon','334303',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59905,168,'Bheloo','334302',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59906,168,'Bhikhnera','334603',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59907,168,'Bhinasar','334403',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59908,168,'Bholasar Budhan','334001',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59909,168,'Bichhwal Ind.Area','334006',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59910,168,'Bigga','331803',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59911,168,'Biggabas Ramsara','331803',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59912,168,'Bijeri','334305',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59913,168,'Bikampur','334305',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59914,168,'Bikaner City','334001',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59915,168,'Bikaner H.O','334001',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59916,168,'Bikaner Kutchery','334001',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59917,168,'Bithnok','334302',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59918,168,'Chak 8 Kyd','334023',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59919,168,'Chani','334302',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59920,168,'Charkra','334803',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59921,168,'Chhatararh','334021',1,0,'2022-03-03 12:51:18','2022-03-03 12:51:18'),(59922,168,'Chitana','334803',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59923,168,'D.S.Office','334001',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59924,168,'Dandi','334021',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59925,168,'Dantaur','334023',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59926,168,'Dasori','334302',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59927,168,'Dawa','334803',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59928,168,'Delitalai','334023',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59929,168,'Delwan','331803',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59930,168,'Derajsar','331811',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59931,168,'Desalsar','334803',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59932,168,'Deshnoke','334801',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59933,168,'Dhaneru','331803',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59934,168,'Dharnok','334804',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59935,168,'Dheerdesar Chotiyan','331803',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59936,168,'Dheerera R.S.','334601',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59937,168,'Dheerera Village','334601',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59938,168,'Dhingsari','334804',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59939,168,'Dhoopaliya','334802',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59940,168,'Diyatra','334303',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59941,168,'Dulchasar','331811',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59942,168,'Dulmera','334603',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59943,168,'Dungar College','334001',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59944,168,'Dusarna','331811',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59945,168,'Gadhwala','334001',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59946,168,'Gajner Palace','334001',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59947,168,'Gajroopdesar','334201',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59948,168,'Gajsukhdesar','334802',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59949,168,'Gangashahar','334401',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59950,168,'Garabdesar','334602',1,0,'2022-03-03 12:51:19','2022-03-03 12:51:19'),(59951,168,'Gariyala','334303',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59952,168,'Gersar','334022',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59953,168,'Ghatoo','334801',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59954,168,'Girajsar','334303',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59955,168,'Godoo','334305',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59956,168,'Gogariyawala','334305',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59957,168,'Gondusar','334802',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59958,168,'Grandhi','334303',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59959,168,'Gura','334302',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59960,168,'Gusainsar','334001',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59961,168,'Gusainsar','331803',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59962,168,'Hadan','334302',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59963,168,'Hadlan Bhatiyan','334302',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59964,168,'Hansasar','334803',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59965,168,'Hansera','334603',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59966,168,'Himatsar','334802',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59967,168,'Hiyadesar','334803',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59968,168,'Indpalsar','331803',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59969,168,'Jaimalsar','334001',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59970,168,'Jaisalsar','331803',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59971,168,'Jaisingdesar','334803',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59972,168,'Jaitpur','334604',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59973,168,'Jalabsar','331801',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59974,168,'Jalwali','334001',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59975,168,'Jamsar','334601',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59976,168,'Jangloo','334803',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59977,168,'Jasrasar','334802',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59978,168,'Jassusar Gate','334001',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59979,168,'Jesalsar','334802',1,0,'2022-03-03 12:51:20','2022-03-03 12:51:20'),(59980,168,'Jetasar','331803',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(59981,168,'Jhadeli','334802',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(59982,168,'Jhajhoo','334302',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(59983,168,'Jhanjheu','331811',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(59984,168,'Kakoo','334803',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(59985,168,'Kakra','334802',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(59986,168,'Kalasar','334001',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(59987,168,'Kalu','334602',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(59988,168,'Kalyansar','331803',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(59989,168,'Kanasar','334001',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(59990,168,'Kankarwala','334603',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(59991,168,'Kapoorisar','334603',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(59992,168,'Karamwala','334023',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(59993,168,'Karmisar','334001',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(59994,168,'Karnisar Bhatiyan','334023',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(59995,168,'Kawani','334001',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(59996,168,'Keetasar','331803',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(59997,168,'Kelan','334001',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(59998,168,'Kesardesarjatan','334201',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(59999,168,'Keu','331803',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(60000,168,'Khajuwala','334023',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(60001,168,'Khara','334601',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(60002,168,'Kharbara','334021',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(60003,168,'Kharda','334602',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(60004,168,'Khari Charnan','334001',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(60005,168,'Khindasar','334302',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(60006,168,'Khinyera','334603',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(60007,168,'Khokhrana','334603',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(60008,168,'Kisnasar','334804',1,0,'2022-03-03 12:51:21','2022-03-03 12:51:21'),(60009,168,'Kolasar','334001',1,0,'2022-03-03 12:51:22','2022-03-03 12:51:22'),(60010,168,'Koo Dsoo','334804',1,0,'2022-03-03 12:51:22','2022-03-03 12:51:22'),(60011,168,'Kotegate','334001',1,0,'2022-03-03 12:51:22','2022-03-03 12:51:22'),(60012,168,'Kotri','334302',1,0,'2022-03-03 12:51:22','2022-03-03 12:51:22'),(60013,168,'Kuchor Aguni','334202',1,0,'2022-03-03 12:51:22','2022-03-03 12:51:22'),(60014,168,'Kuchor Athuni','334202',1,0,'2022-03-03 12:51:22','2022-03-03 12:51:22'),(60015,168,'Kujti','334602',1,0,'2022-03-03 12:51:22','2022-03-03 12:51:22'),(60016,168,'Kumbhasariya','334804',1,0,'2022-03-03 12:51:22','2022-03-03 12:51:22'),(60017,168,'Kunpalsar','331803',1,0,'2022-03-03 12:51:22','2022-03-03 12:51:22'),(60018,168,'Kuntasar','331803',1,0,'2022-03-03 12:51:22','2022-03-03 12:51:22'),(60019,168,'Lakhasar','331811',1,0,'2022-03-03 12:51:22','2022-03-03 12:51:22'),(60020,168,'Lakhusar','334001',1,0,'2022-03-03 12:51:22','2022-03-03 12:51:22'),(60021,168,'Lalamdesar Bara','334802',1,0,'2022-03-03 12:51:22','2022-03-03 12:51:22'),(60022,168,'Lalgarh Road','334001',1,0,'2022-03-03 12:51:22','2022-03-03 12:51:22'),(60023,168,'Lalkar','334001',1,0,'2022-03-03 12:51:22','2022-03-03 12:51:22'),(60024,168,'Lalmdesar','334402',1,0,'2022-03-03 12:51:22','2022-03-03 12:51:22'),(60025,168,'Likhmadesar','331803',1,0,'2022-03-03 12:51:22','2022-03-03 12:51:22'),(60026,168,'Likhmisar','331811',1,0,'2022-03-03 12:51:22','2022-03-03 12:51:22'),(60027,168,'Loonkhan','334021',1,0,'2022-03-03 12:51:22','2022-03-03 12:51:22'),(60028,168,'Lunkaransar','334603',1,0,'2022-03-03 12:51:22','2022-03-03 12:51:22'),(60029,168,'M.G.Road','334001',1,0,'2022-03-03 12:51:22','2022-03-03 12:51:22'),(60030,168,'Madh','334302',1,0,'2022-03-03 12:51:22','2022-03-03 12:51:22'),(60031,168,'Mahadevwali','334021',1,0,'2022-03-03 12:51:22','2022-03-03 12:51:22'),(60032,168,'Mahajan','334604',1,0,'2022-03-03 12:51:22','2022-03-03 12:51:22'),(60033,168,'Mainsar','334802',1,0,'2022-03-03 12:51:22','2022-03-03 12:51:22'),(60034,168,'Makrasar','334001',1,0,'2022-03-03 12:51:22','2022-03-03 12:51:22'),(60035,168,'Malasar','334601',1,0,'2022-03-03 12:51:23','2022-03-03 12:51:23'),(60036,168,'Malkisar','334604',1,0,'2022-03-03 12:51:23','2022-03-03 12:51:23'),(60037,168,'Manakarasar','331811',1,0,'2022-03-03 12:51:23','2022-03-03 12:51:23'),(60038,168,'Mankasar','334305',1,0,'2022-03-03 12:51:23','2022-03-03 12:51:23'),(60039,168,'Mansoori','334802',1,0,'2022-03-03 12:51:23','2022-03-03 12:51:23'),(60040,168,'Migsariya','331803',1,0,'2022-03-03 12:51:23','2022-03-03 12:51:23'),(60041,168,'Mithdiya','334604',1,0,'2022-03-03 12:51:23','2022-03-03 12:51:23'),(60042,168,'Mithriya','334305',1,0,'2022-03-03 12:51:23','2022-03-03 12:51:23'),(60043,168,'Mohta Chowk','334001',1,0,'2022-03-03 12:51:23','2022-03-03 12:51:23'),(60044,168,'Moondar','334802',1,0,'2022-03-03 12:51:23','2022-03-03 12:51:23'),(60045,168,'Moondsar','334202',1,0,'2022-03-03 12:51:23','2022-03-03 12:51:23'),(60046,168,'Morkhana Athuna','334801',1,0,'2022-03-03 12:51:23','2022-03-03 12:51:23'),(60047,168,'Motigarh','334021',1,0,'2022-03-03 12:51:23','2022-03-03 12:51:23'),(60048,168,'Nagrasar','334303',1,0,'2022-03-03 12:51:23','2022-03-03 12:51:23'),(60049,168,'Nal Bari','334001',1,0,'2022-03-03 12:51:23','2022-03-03 12:51:23'),(60050,168,'Napasar','334201',1,0,'2022-03-03 12:51:23','2022-03-03 12:51:23'),(60051,168,'Nathusar','334804',1,0,'2022-03-03 12:51:23','2022-03-03 12:51:23'),(60052,168,'Nathwana','334603',1,0,'2022-03-03 12:51:23','2022-03-03 12:51:23'),(60053,168,'Nokha','334803',1,0,'2022-03-03 12:51:23','2022-03-03 12:51:23'),(60054,168,'Nokha Villege','334803',1,0,'2022-03-03 12:51:23','2022-03-03 12:51:23'),(60055,168,'Nokhara','334303',1,0,'2022-03-03 12:51:23','2022-03-03 12:51:23'),(60056,168,'Norangdesar','334001',1,0,'2022-03-03 12:51:23','2022-03-03 12:51:23'),(60057,168,'Pabubari','334001',1,0,'2022-03-03 12:51:23','2022-03-03 12:51:23'),(60058,168,'Palana','334402',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60059,168,'Panchoo','334804',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60060,168,'Parwa','334801',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60061,168,'Pawanpuri (Bikaner)','334003',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60062,168,'Phulasar Khurd','334305',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60063,168,'Pugal','334808',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60064,168,'Pundalsar','331803',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60065,168,'Punrasar','331811',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60066,168,'Railway Workshop','334004',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60067,168,'Raisar','334803',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60068,168,'Raj.Krishi Vishwavidhyalaya','334006',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60069,168,'Rajasar Bhatiyan','334001',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60070,168,'Rajasar Karnisar','334603',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60071,168,'Rajedoo','331803',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60072,168,'Rambag','334604',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60073,168,'Ramsar','334201',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60074,168,'Raner','334021',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60075,168,'Rani Bazar','334001',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60076,168,'Ranjeetpura','334305',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60077,168,'Rasisar','334801',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60078,168,'Rawansar','334602',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60079,168,'Rcp Colony','334004',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60080,168,'Ridmalsar','334022',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60081,168,'Riri','331803',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60082,168,'Rojan','334603',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60083,168,'Rora','334803',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60084,168,'Runiya Bara Bas','334022',1,0,'2022-03-03 12:51:24','2022-03-03 12:51:24'),(60085,168,'Sadhasar','334802',1,0,'2022-03-03 12:51:25','2022-03-03 12:51:25'),(60086,168,'Sadhoona','334803',1,0,'2022-03-03 12:51:25','2022-03-03 12:51:25'),(60087,168,'Sadul Colony','334001',1,0,'2022-03-03 12:51:25','2022-03-03 12:51:25'),(60088,168,'Sahjrasar','334602',1,0,'2022-03-03 12:51:25','2022-03-03 12:51:25'),(60089,168,'Saisar','334804',1,0,'2022-03-03 12:51:25','2022-03-03 12:51:25'),(60090,168,'Saloondiya','334803',1,0,'2022-03-03 12:51:25','2022-03-03 12:51:25'),(60091,168,'Samandsar','331811',1,0,'2022-03-03 12:51:25','2022-03-03 12:51:25'),(60092,168,'Sanwatsar','331811',1,0,'2022-03-03 12:51:25','2022-03-03 12:51:25'),(60093,168,'Saroopdesar','334402',1,0,'2022-03-03 12:51:25','2022-03-03 12:51:25'),(60094,168,'Sarunda','334803',1,0,'2022-03-03 12:51:25','2022-03-03 12:51:25'),(60095,168,'Satasar','334021',1,0,'2022-03-03 12:51:25','2022-03-03 12:51:25'),(60096,168,'Seeniwala','334802',1,0,'2022-03-03 12:51:25','2022-03-03 12:51:25'),(60097,168,'Serera','334022',1,0,'2022-03-03 12:51:25','2022-03-03 12:51:25'),(60098,168,'Shekhsar','334603',1,0,'2022-03-03 12:51:25','2022-03-03 12:51:25'),(60099,168,'Sherpura','334604',1,0,'2022-03-03 12:51:25','2022-03-03 12:51:25'),(60100,168,'Sheruna','331811',1,0,'2022-03-03 12:51:25','2022-03-03 12:51:25'),(60101,168,'Shiv Bari','334001',1,0,'2022-03-03 12:51:25','2022-03-03 12:51:25'),(60102,168,'Shri Dungargarh','331803',1,0,'2022-03-03 12:51:25','2022-03-03 12:51:25'),(60103,168,'Sinjguru','334801',1,0,'2022-03-03 12:51:25','2022-03-03 12:51:25'),(60104,168,'Sinthal','334202',1,0,'2022-03-03 12:51:25','2022-03-03 12:51:25'),(60105,168,'Sitla Gate','334001',1,0,'2022-03-03 12:51:25','2022-03-03 12:51:25'),(60106,168,'Siyana Bhatiyana','334803',1,0,'2022-03-03 12:51:25','2022-03-03 12:51:25'),(60107,168,'Siyasar Panchkosa','334023',1,0,'2022-03-03 12:51:25','2022-03-03 12:51:25'),(60108,168,'Siyasarchogan','334023',1,0,'2022-03-03 12:51:25','2022-03-03 12:51:25'),(60109,168,'Sodhwali','334601',1,0,'2022-03-03 12:51:25','2022-03-03 12:51:25'),(60110,168,'Somalsar','334803',1,0,'2022-03-03 12:51:25','2022-03-03 12:51:25'),(60111,168,'Soniyasar','331803',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60112,168,'Sowa','334201',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60113,168,'Sri Kolayat Ji','334302',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60114,168,'Station Road (Bikaner)','334001',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60115,168,'Sui','334603',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60116,168,'Sujandeser','334001',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60117,168,'Surdhana Chauhanan','334001',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60118,168,'Surjansar','331801',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60119,168,'Surjara','334001',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60120,168,'Surnana','334603',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60121,168,'Surpura','334801',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60122,168,'Takhatpura','334021',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60123,168,'Tejrasar','334202',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60124,168,'Thakariyasar','331803',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60125,168,'Thawariya','334802',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60126,168,'Toliyasar','331803',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60127,168,'Udairamsar','334402',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60128,168,'Udasar','334804',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60129,168,'Udasar','334022',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60130,168,'Udrasar','331801',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60131,168,'Udsar','334802',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60132,168,'Upni','331803',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60133,168,'Utmamdesar','334802',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60134,169,'Abar','323024',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60135,169,'Ajanda','323603',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60136,169,'Ajeta','323803',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60137,169,'Akoda','323001',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60138,169,'Alod','323024',1,0,'2022-03-03 12:51:26','2022-03-03 12:51:26'),(60139,169,'Alphanagar','323021',1,0,'2022-03-03 12:51:27','2022-03-03 12:51:27'),(60140,169,'Amli','323022',1,0,'2022-03-03 12:51:27','2022-03-03 12:51:27'),(60141,169,'Anghora','323614',1,0,'2022-03-03 12:51:27','2022-03-03 12:51:27'),(60142,169,'Antarda','323616',1,0,'2022-03-03 12:51:27','2022-03-03 12:51:27'),(60143,169,'Anthada','323021',1,0,'2022-03-03 12:51:27','2022-03-03 12:51:27'),(60144,169,'Arnetha','323301',1,0,'2022-03-03 12:51:27','2022-03-03 12:51:27'),(60145,169,'Babai','323613',1,0,'2022-03-03 12:51:27','2022-03-03 12:51:27'),(60146,169,'Bachola','323801',1,0,'2022-03-03 12:51:27','2022-03-03 12:51:27'),(60147,169,'Bada Kheda','323603',1,0,'2022-03-03 12:51:27','2022-03-03 12:51:27'),(60148,169,'Badodiya','323001',1,0,'2022-03-03 12:51:27','2022-03-03 12:51:27'),(60149,169,'Bajar','323021',1,0,'2022-03-03 12:51:27','2022-03-03 12:51:27'),(60150,169,'Balapura','323801',1,0,'2022-03-03 12:51:27','2022-03-03 12:51:27'),(60151,169,'Balban','323614',1,0,'2022-03-03 12:51:27','2022-03-03 12:51:27'),(60152,169,'Balchand Para Bundi','323001',1,0,'2022-03-03 12:51:27','2022-03-03 12:51:27'),(60153,169,'Balkasa','323301',1,0,'2022-03-03 12:51:27','2022-03-03 12:51:27'),(60154,169,'Ballop','323021',1,0,'2022-03-03 12:51:27','2022-03-03 12:51:27'),(60155,169,'Bamangaon','323801',1,0,'2022-03-03 12:51:27','2022-03-03 12:51:27'),(60156,169,'Bamori','323803',1,0,'2022-03-03 12:51:27','2022-03-03 12:51:27'),(60157,169,'Bansi','323802',1,0,'2022-03-03 12:51:27','2022-03-03 12:51:27'),(60158,169,'Baranaya Gaon','323024',1,0,'2022-03-03 12:51:27','2022-03-03 12:51:27'),(60159,169,'Barundhan','323021',1,0,'2022-03-03 12:51:27','2022-03-03 12:51:27'),(60160,169,'Basni','323025',1,0,'2022-03-03 12:51:27','2022-03-03 12:51:27'),(60161,169,'Basoli','323024',1,0,'2022-03-03 12:51:27','2022-03-03 12:51:27'),(60162,169,'Baswada','323603',1,0,'2022-03-03 12:51:27','2022-03-03 12:51:27'),(60163,169,'Bhajneri','323802',1,0,'2022-03-03 12:51:27','2022-03-03 12:51:27'),(60164,169,'Bhawanipura','323024',1,0,'2022-03-03 12:51:27','2022-03-03 12:51:27'),(60165,169,'Bherupura Antri','323001',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60166,169,'Bherupura Ojhha','323803',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60167,169,'Bhiya','323602',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60168,169,'Borda','323001',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60169,169,'Borda Kachhiyan','323803',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60170,169,'Borkhandi','323001',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60171,169,'Budhpura','323022',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60172,169,'Bundi H.O','323001',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60173,169,'Chainpuria','323801',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60174,169,'Chanda Khurd','323614',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60175,169,'Chardana','323301',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60176,169,'Chatarganj','323023',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60177,169,'Chatarpura','323001',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60178,169,'Chetan','323024',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60179,169,'Chitawa','323602',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60180,169,'Dabeta','323802',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60181,169,'Dabi','323022',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60182,169,'Dablana','323024',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60183,169,'Daulatpura','323614',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60184,169,'Dehit','323021',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60185,169,'Dei Kheda','323603',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60186,169,'Dei','323802',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60187,169,'Dhagaria','323603',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60188,169,'Dhanesar','323022',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60189,169,'Dhanugaon','323801',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60190,169,'Dhowara','323024',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60191,169,'Dokun','323802',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60192,169,'Dolara','323001',1,0,'2022-03-03 12:51:28','2022-03-03 12:51:28'),(60193,169,'Dora','323021',1,0,'2022-03-03 12:51:29','2022-03-03 12:51:29'),(60194,169,'Dugari','323802',1,0,'2022-03-03 12:51:29','2022-03-03 12:51:29'),(60195,169,'Gadarda','323022',1,0,'2022-03-03 12:51:29','2022-03-03 12:51:29'),(60196,169,'Gamach','323602',1,0,'2022-03-03 12:51:29','2022-03-03 12:51:29'),(60197,169,'Gambhira','323801',1,0,'2022-03-03 12:51:29','2022-03-03 12:51:29'),(60198,169,'Gendoli','323803',1,0,'2022-03-03 12:51:29','2022-03-03 12:51:29'),(60199,169,'Ghat Ka Barana','323603',1,0,'2022-03-03 12:51:29','2022-03-03 12:51:29'),(60200,169,'Gothra','323024',1,0,'2022-03-03 12:51:29','2022-03-03 12:51:29'),(60201,169,'Guda Deo Ji','323802',1,0,'2022-03-03 12:51:29','2022-03-03 12:51:29'),(60202,169,'Guda Gokulpura','323025',1,0,'2022-03-03 12:51:29','2022-03-03 12:51:29'),(60203,169,'Guda Turkadi','323024',1,0,'2022-03-03 12:51:29','2022-03-03 12:51:29'),(60204,169,'Gudasadawartia','323802',1,0,'2022-03-03 12:51:29','2022-03-03 12:51:29'),(60205,169,'Gudha Nathawatan','323001',1,0,'2022-03-03 12:51:29','2022-03-03 12:51:29'),(60206,169,'Gumanpura','323021',1,0,'2022-03-03 12:51:29','2022-03-03 12:51:29'),(60207,169,'Hindoli','323023',1,0,'2022-03-03 12:51:29','2022-03-03 12:51:29'),(60208,169,'Hingonia','323301',1,0,'2022-03-03 12:51:29','2022-03-03 12:51:29'),(60209,169,'Indergarh (Bundi)','323613',1,0,'2022-03-03 12:51:29','2022-03-03 12:51:29'),(60210,169,'Jaithal','323301',1,0,'2022-03-03 12:51:29','2022-03-03 12:51:29'),(60211,169,'Jajawar','323801',1,0,'2022-03-03 12:51:29','2022-03-03 12:51:29'),(60212,169,'Jaloda','323301',1,0,'2022-03-03 12:51:29','2022-03-03 12:51:29'),(60213,169,'Jamitpura','323021',1,0,'2022-03-03 12:51:29','2022-03-03 12:51:29'),(60214,169,'Jarkhoda','323802',1,0,'2022-03-03 12:51:29','2022-03-03 12:51:29'),(60215,169,'Jawharsagar Dam','323302',1,0,'2022-03-03 12:51:29','2022-03-03 12:51:29'),(60216,169,'Jetpur','323803',1,0,'2022-03-03 12:51:29','2022-03-03 12:51:29'),(60217,169,'Jhakhmund','323021',1,0,'2022-03-03 12:51:29','2022-03-03 12:51:29'),(60218,169,'Jhali Ji Ka Barana','323803',1,0,'2022-03-03 12:51:30','2022-03-03 12:51:30'),(60219,169,'Kachola','323025',1,0,'2022-03-03 12:51:30','2022-03-03 12:51:30'),(60220,169,'Kaithuda','323616',1,0,'2022-03-03 12:51:30','2022-03-03 12:51:30'),(60221,169,'Kalpuria','323022',1,0,'2022-03-03 12:51:30','2022-03-03 12:51:30'),(60222,169,'Kapren','323301',1,0,'2022-03-03 12:51:30','2022-03-03 12:51:30'),(60223,169,'Karwala','323602',1,0,'2022-03-03 12:51:30','2022-03-03 12:51:30'),(60224,169,'Karwala Ki Jhopri','323301',1,0,'2022-03-03 12:51:30','2022-03-03 12:51:30'),(60225,169,'Karwar','323616',1,0,'2022-03-03 12:51:30','2022-03-03 12:51:30'),(60226,169,'Kesoraipatan','323601',1,0,'2022-03-03 12:51:30','2022-03-03 12:51:30'),(60227,169,'Kesoraipatan Sugar Factoy','323602',1,0,'2022-03-03 12:51:30','2022-03-03 12:51:30'),(60228,169,'Khadipur','323022',1,0,'2022-03-03 12:51:30','2022-03-03 12:51:30'),(60229,169,'Khajoori','323616',1,0,'2022-03-03 12:51:30','2022-03-03 12:51:30'),(60230,169,'Khanpura','323801',1,0,'2022-03-03 12:51:30','2022-03-03 12:51:30'),(60231,169,'Khatkar','323803',1,0,'2022-03-03 12:51:30','2022-03-03 12:51:30'),(60232,169,'Khiniya','323001',1,0,'2022-03-03 12:51:30','2022-03-03 12:51:30'),(60233,169,'Khyawda','323803',1,0,'2022-03-03 12:51:30','2022-03-03 12:51:30'),(60234,169,'Laban','323603',1,0,'2022-03-03 12:51:30','2022-03-03 12:51:30'),(60235,169,'Ladpura','323021',1,0,'2022-03-03 12:51:30','2022-03-03 12:51:30'),(60236,169,'Lakheri Gaon','323615',1,0,'2022-03-03 12:51:30','2022-03-03 12:51:30'),(60237,169,'Lakheri','323603',1,0,'2022-03-03 12:51:30','2022-03-03 12:51:30'),(60238,169,'Lalpura','323001',1,0,'2022-03-03 12:51:31','2022-03-03 12:51:31'),(60239,169,'Lambakho','323022',1,0,'2022-03-03 12:51:31','2022-03-03 12:51:31'),(60240,169,'Laxmipura','323021',1,0,'2022-03-03 12:51:31','2022-03-03 12:51:31'),(60241,169,'Leeleda','323021',1,0,'2022-03-03 12:51:31','2022-03-03 12:51:31'),(60242,169,'Lesarda','323602',1,0,'2022-03-03 12:51:31','2022-03-03 12:51:31'),(60243,169,'Loicha','323022',1,0,'2022-03-03 12:51:31','2022-03-03 12:51:31'),(60244,169,'Luharpura','323803',1,0,'2022-03-03 12:51:31','2022-03-03 12:51:31'),(60245,169,'Maiza','323602',1,0,'2022-03-03 12:51:31','2022-03-03 12:51:31'),(60246,169,'Makhida','323603',1,0,'2022-03-03 12:51:31','2022-03-03 12:51:31'),(60247,169,'Mangal','323001',1,0,'2022-03-03 12:51:31','2022-03-03 12:51:31'),(60248,169,'Mani','323616',1,0,'2022-03-03 12:51:31','2022-03-03 12:51:31'),(60249,169,'Matunda','323001',1,0,'2022-03-03 12:51:31','2022-03-03 12:51:31'),(60250,169,'Mendi','323024',1,0,'2022-03-03 12:51:31','2022-03-03 12:51:31'),(60251,169,'Mohanpura','323613',1,0,'2022-03-03 12:51:31','2022-03-03 12:51:31'),(60252,169,'Morsan','323802',1,0,'2022-03-03 12:51:31','2022-03-03 12:51:31'),(60253,169,'Nainwan','323801',1,0,'2022-03-03 12:51:31','2022-03-03 12:51:31'),(60254,169,'Namana','323022',1,0,'2022-03-03 12:51:31','2022-03-03 12:51:31'),(60255,169,'Nawalpura','323614',1,0,'2022-03-03 12:51:31','2022-03-03 12:51:31'),(60256,169,'Nayagaon','323803',1,0,'2022-03-03 12:51:31','2022-03-03 12:51:31'),(60257,169,'Neem Ka Kheda','323001',1,0,'2022-03-03 12:51:31','2022-03-03 12:51:31'),(60258,169,'Neem Ka Khera','323616',1,0,'2022-03-03 12:51:31','2022-03-03 12:51:31'),(60259,169,'Negharh','323024',1,0,'2022-03-03 12:51:31','2022-03-03 12:51:31'),(60260,169,'New Colony Bundi','323001',1,0,'2022-03-03 12:51:31','2022-03-03 12:51:31'),(60261,169,'Notada','323603',1,0,'2022-03-03 12:51:31','2022-03-03 12:51:31'),(60262,169,'Notada','323021',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60263,169,'Owan','323024',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60264,169,'Pagaran','323025',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60265,169,'Papdi','323603',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60266,169,'Pech Ki Baori','323025',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60267,169,'Peepliya','323803',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60268,169,'Phalenda','323025',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60269,169,'Pholai','323803',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60270,169,'Phuleta','323801',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60271,169,'Radi','323602',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60272,169,'Raithal','323803',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60273,169,'Rajalawata','323801',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60274,169,'Rajwas','323803',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60275,169,'Ramchandra Ji Ka Kheda','323024',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60276,169,'Ramganj','323001',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60277,169,'Ramnagar','323001',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60278,169,'Ranipura','323024',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60279,169,'Rebarpura','323603',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60280,169,'Rehana','323803',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60281,169,'Renthoda','323616',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60282,169,'Ronija','323024',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60283,169,'Roteda','323301',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60284,169,'Sadera','323802',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60285,169,'Sahan','323802',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60286,169,'Sahaspuriya','323023',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60287,169,'Sakhawda','323603',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60288,169,'Samidhi','323801',1,0,'2022-03-03 12:51:32','2022-03-03 12:51:32'),(60289,169,'Sanwatgarh','323024',1,0,'2022-03-03 12:51:33','2022-03-03 12:51:33'),(60290,169,'Sarsala','323602',1,0,'2022-03-03 12:51:33','2022-03-03 12:51:33'),(60291,169,'Sathur','323024',1,0,'2022-03-03 12:51:33','2022-03-03 12:51:33'),(60292,169,'Silore','323001',1,0,'2022-03-03 12:51:33','2022-03-03 12:51:33'),(60293,169,'Sisola','323801',1,0,'2022-03-03 12:51:33','2022-03-03 12:51:33'),(60294,169,'Songar','323602',1,0,'2022-03-03 12:51:33','2022-03-03 12:51:33'),(60295,169,'Soran','323024',1,0,'2022-03-03 12:51:33','2022-03-03 12:51:33'),(60296,169,'Sumerganj Mandi','323614',1,0,'2022-03-03 12:51:33','2022-03-03 12:51:33'),(60297,169,'Sunwasa','323021',1,0,'2022-03-03 12:51:33','2022-03-03 12:51:33'),(60298,169,'Suwania','323801',1,0,'2022-03-03 12:51:33','2022-03-03 12:51:33'),(60299,169,'Talab Gaon','323001',1,0,'2022-03-03 12:51:33','2022-03-03 12:51:33'),(60300,169,'Talera (Bundi)','323021',1,0,'2022-03-03 12:51:33','2022-03-03 12:51:33'),(60301,169,'Talwas','323616',1,0,'2022-03-03 12:51:33','2022-03-03 12:51:33'),(60302,169,'Thana','323025',1,0,'2022-03-03 12:51:33','2022-03-03 12:51:33'),(60303,169,'Thikarda','323001',1,0,'2022-03-03 12:51:33','2022-03-03 12:51:33'),(60304,169,'Tirath','323602',1,0,'2022-03-03 12:51:33','2022-03-03 12:51:33'),(60305,169,'Tonkra','323025',1,0,'2022-03-03 12:51:33','2022-03-03 12:51:33'),(60306,169,'Umar','323025',1,0,'2022-03-03 12:51:33','2022-03-03 12:51:33'),(60307,169,'Utharana','323603',1,0,'2022-03-03 12:51:33','2022-03-03 12:51:33'),(60308,169,'Vijaygarh','323025',1,0,'2022-03-03 12:51:33','2022-03-03 12:51:33'),(60309,170,'Achalawada','312615',1,0,'2022-03-03 12:51:33','2022-03-03 12:51:33'),(60310,170,'Achalpur','312605',1,0,'2022-03-03 12:51:33','2022-03-03 12:51:33'),(60311,170,'Achnera','312615',1,0,'2022-03-03 12:51:33','2022-03-03 12:51:33'),(60312,170,'Adana','312203',1,0,'2022-03-03 12:51:33','2022-03-03 12:51:33'),(60313,170,'Adityapuram','312622',1,0,'2022-03-03 12:51:34','2022-03-03 12:51:34'),(60314,170,'Akhepur','312605',1,0,'2022-03-03 12:51:34','2022-03-03 12:51:34'),(60315,170,'Akiya','312001',1,0,'2022-03-03 12:51:34','2022-03-03 12:51:34'),(60316,170,'Akola Kalan','312027',1,0,'2022-03-03 12:51:34','2022-03-03 12:51:34'),(60317,170,'Akola (Chittorgarh)','312205',1,0,'2022-03-03 12:51:34','2022-03-03 12:51:34'),(60318,170,'Alod','312404',1,0,'2022-03-03 12:51:34','2022-03-03 12:51:34'),(60319,170,'Amarpura','312022',1,0,'2022-03-03 12:51:34','2022-03-03 12:51:34'),(60320,170,'Ambawali','312604',1,0,'2022-03-03 12:51:34','2022-03-03 12:51:34'),(60321,170,'Ambirama','312619',1,0,'2022-03-03 12:51:34','2022-03-03 12:51:34'),(60322,170,'Amlawad','312605',1,0,'2022-03-03 12:51:34','2022-03-03 12:51:34'),(60323,170,'Angona','312605',1,0,'2022-03-03 12:51:34','2022-03-03 12:51:34'),(60324,170,'Anoppura','312202',1,0,'2022-03-03 12:51:34','2022-03-03 12:51:34'),(60325,170,'Anoppura','312605',1,0,'2022-03-03 12:51:34','2022-03-03 12:51:34'),(60326,170,'Anushakti','323303',1,0,'2022-03-03 12:51:34','2022-03-03 12:51:34'),(60327,170,'Anwalhera','312022',1,0,'2022-03-03 12:51:34','2022-03-03 12:51:34'),(60328,170,'Anwleshwar','312605',1,0,'2022-03-03 12:51:34','2022-03-03 12:51:34'),(60329,170,'Arned','312402',1,0,'2022-03-03 12:51:34','2022-03-03 12:51:34'),(60330,170,'Arni','312203',1,0,'2022-03-03 12:51:34','2022-03-03 12:51:34'),(60331,170,'Arnia Joshi','312620',1,0,'2022-03-03 12:51:34','2022-03-03 12:51:34'),(60332,170,'Arniapanth','312612',1,0,'2022-03-03 12:51:34','2022-03-03 12:51:34'),(60333,170,'Arnod','312615',1,0,'2022-03-03 12:51:34','2022-03-03 12:51:34'),(60334,170,'Arnoda','312620',1,0,'2022-03-03 12:51:34','2022-03-03 12:51:34'),(60335,170,'Asawara','312602',1,0,'2022-03-03 12:51:34','2022-03-03 12:51:34'),(60336,170,'Asawata','312605',1,0,'2022-03-03 12:51:34','2022-03-03 12:51:34'),(60337,170,'Babarana','312204',1,0,'2022-03-03 12:51:34','2022-03-03 12:51:34'),(60338,170,'Badolighata','312601',1,0,'2022-03-03 12:51:35','2022-03-03 12:51:35'),(60339,170,'Badolimadhosingh','312601',1,0,'2022-03-03 12:51:35','2022-03-03 12:51:35'),(60340,170,'Badoliya','323307',1,0,'2022-03-03 12:51:35','2022-03-03 12:51:35'),(60341,170,'Badwai','312402',1,0,'2022-03-03 12:51:35','2022-03-03 12:51:35'),(60342,170,'Badwal','312401',1,0,'2022-03-03 12:51:35','2022-03-03 12:51:35'),(60343,170,'Badwaskalan','312615',1,0,'2022-03-03 12:51:35','2022-03-03 12:51:35'),(60344,170,'Bagund','312024',1,0,'2022-03-03 12:51:35','2022-03-03 12:51:35'),(60345,170,'Bajranggarh','312605',1,0,'2022-03-03 12:51:35','2022-03-03 12:51:35'),(60346,170,'Balarada','312202',1,0,'2022-03-03 12:51:35','2022-03-03 12:51:35'),(60347,170,'Balkundikalan','312023',1,0,'2022-03-03 12:51:35','2022-03-03 12:51:35'),(60348,170,'Bambori','312614',1,0,'2022-03-03 12:51:35','2022-03-03 12:51:35'),(60349,170,'Banakiyakalan','312207',1,0,'2022-03-03 12:51:35','2022-03-03 12:51:35'),(60350,170,'Bangreda','312601',1,0,'2022-03-03 12:51:35','2022-03-03 12:51:35'),(60351,170,'Bangreda Ghata','312601',1,0,'2022-03-03 12:51:35','2022-03-03 12:51:35'),(60352,170,'Bansen','312001',1,0,'2022-03-03 12:51:35','2022-03-03 12:51:35'),(60353,170,'Bansi (Chittorgarh)','312401',1,0,'2022-03-03 12:51:35','2022-03-03 12:51:35'),(60354,170,'Banslai','312619',1,0,'2022-03-03 12:51:35','2022-03-03 12:51:35'),(60355,170,'Baori Khera','312616',1,0,'2022-03-03 12:51:35','2022-03-03 12:51:35'),(60356,170,'Barawarda','312616',1,0,'2022-03-03 12:51:35','2022-03-03 12:51:35'),(60357,170,'Bardia','312619',1,0,'2022-03-03 12:51:35','2022-03-03 12:51:35'),(60358,170,'Bardia','312623',1,0,'2022-03-03 12:51:35','2022-03-03 12:51:35'),(60359,170,'Bari','312601',1,0,'2022-03-03 12:51:35','2022-03-03 12:51:35'),(60360,170,'Barilank','312605',1,0,'2022-03-03 12:51:36','2022-03-03 12:51:36'),(60361,170,'Barisadari','312403',1,0,'2022-03-03 12:51:36','2022-03-03 12:51:36'),(60362,170,'Barisagthali','312619',1,0,'2022-03-03 12:51:36','2022-03-03 12:51:36'),(60363,170,'Barodia','312021',1,0,'2022-03-03 12:51:36','2022-03-03 12:51:36'),(60364,170,'Barodia','323307',1,0,'2022-03-03 12:51:36','2022-03-03 12:51:36'),(60365,170,'Barotha','312605',1,0,'2022-03-03 12:51:36','2022-03-03 12:51:36'),(60366,170,'Baru','312207',1,0,'2022-03-03 12:51:36','2022-03-03 12:51:36'),(60367,170,'Basad','312605',1,0,'2022-03-03 12:51:36','2022-03-03 12:51:36'),(60368,170,'Basera','312605',1,0,'2022-03-03 12:51:36','2022-03-03 12:51:36'),(60369,170,'Basera','312601',1,0,'2022-03-03 12:51:36','2022-03-03 12:51:36'),(60370,170,'Bassi (Chittorgarh)','312022',1,0,'2022-03-03 12:51:36','2022-03-03 12:51:36'),(60371,170,'Bavlas','312901',1,0,'2022-03-03 12:51:36','2022-03-03 12:51:36'),(60372,170,'Bedma','312615',1,0,'2022-03-03 12:51:36','2022-03-03 12:51:36'),(60373,170,'Begun','312023',1,0,'2022-03-03 12:51:36','2022-03-03 12:51:36'),(60374,170,'Bhabhanagar','323307',1,0,'2022-03-03 12:51:36','2022-03-03 12:51:36'),(60375,170,'Bhadesar','312602',1,0,'2022-03-03 12:51:36','2022-03-03 12:51:36'),(60376,170,'Bhadsaura','312024',1,0,'2022-03-03 12:51:36','2022-03-03 12:51:36'),(60377,170,'Bhagwanpura','312614',1,0,'2022-03-03 12:51:36','2022-03-03 12:51:36'),(60378,170,'Bhalotan Ki Kheri','312206',1,0,'2022-03-03 12:51:36','2022-03-03 12:51:36'),(60379,170,'Bhalundi','312602',1,0,'2022-03-03 12:51:36','2022-03-03 12:51:36'),(60380,170,'Bhanuja','312603',1,0,'2022-03-03 12:51:36','2022-03-03 12:51:36'),(60381,170,'Bhatoli Bagrian','312027',1,0,'2022-03-03 12:51:36','2022-03-03 12:51:36'),(60382,170,'Bhatoli Brahmnan','312403',1,0,'2022-03-03 12:51:36','2022-03-03 12:51:36'),(60383,170,'Bhatton Ka Bamniya','312202',1,0,'2022-03-03 12:51:36','2022-03-03 12:51:36'),(60384,170,'Bhawaliya','312620',1,0,'2022-03-03 12:51:36','2022-03-03 12:51:36'),(60385,170,'Bhenshroadgarh','323304',1,0,'2022-03-03 12:51:36','2022-03-03 12:51:36'),(60386,170,'Bhimgarh','312203',1,0,'2022-03-03 12:51:37','2022-03-03 12:51:37'),(60387,170,'Bhoopal  Nagar','312204',1,0,'2022-03-03 12:51:37','2022-03-03 12:51:37'),(60388,170,'Bhoopal sagar','312204',1,0,'2022-03-03 12:51:37','2022-03-03 12:51:37'),(60389,170,'Bhuwasia','312623',1,0,'2022-03-03 12:51:37','2022-03-03 12:51:37'),(60390,170,'Bichhor','312022',1,0,'2022-03-03 12:51:37','2022-03-03 12:51:37'),(60391,170,'Bijaipur','312022',1,0,'2022-03-03 12:51:37','2022-03-03 12:51:37'),(60392,170,'Bilesari','312605',1,0,'2022-03-03 12:51:37','2022-03-03 12:51:37'),(60393,170,'Biloda','312402',1,0,'2022-03-03 12:51:37','2022-03-03 12:51:37'),(60394,170,'Binayaka','312404',1,0,'2022-03-03 12:51:37','2022-03-03 12:51:37'),(60395,170,'Binota','312614',1,0,'2022-03-03 12:51:37','2022-03-03 12:51:37'),(60396,170,'Bohera','312404',1,0,'2022-03-03 12:51:37','2022-03-03 12:51:37'),(60397,170,'Bolon Ka Sanwata','312901',1,0,'2022-03-03 12:51:37','2022-03-03 12:51:37'),(60398,170,'Bood','312901',1,0,'2022-03-03 12:51:37','2022-03-03 12:51:37'),(60399,170,'Borav','323304',1,0,'2022-03-03 12:51:37','2022-03-03 12:51:37'),(60400,170,'Borda','312901',1,0,'2022-03-03 12:51:37','2022-03-03 12:51:37'),(60401,170,'Bori','312619',1,0,'2022-03-03 12:51:37','2022-03-03 12:51:37'),(60402,170,'Bori','312616',1,0,'2022-03-03 12:51:37','2022-03-03 12:51:37'),(60403,170,'Cement Factory','312021',1,0,'2022-03-03 12:51:37','2022-03-03 12:51:37'),(60404,170,'Chakunda','312619',1,0,'2022-03-03 12:51:37','2022-03-03 12:51:37'),(60405,170,'Chakunda','312205',1,0,'2022-03-03 12:51:37','2022-03-03 12:51:37'),(60406,170,'Chandera','312619',1,0,'2022-03-03 12:51:37','2022-03-03 12:51:37'),(60407,170,'Chanderia','312021',1,0,'2022-03-03 12:51:37','2022-03-03 12:51:37'),(60408,170,'Chechi ','312023',1,0,'2022-03-03 12:51:37','2022-03-03 12:51:37'),(60409,170,'Chhoti Sadari','312604',1,0,'2022-03-03 12:51:37','2022-03-03 12:51:37'),(60410,170,'Chikarada','312027',1,0,'2022-03-03 12:51:38','2022-03-03 12:51:38'),(60411,170,'Chiklad','312605',1,0,'2022-03-03 12:51:38','2022-03-03 12:51:38'),(60412,170,'Chiksi','312613',1,0,'2022-03-03 12:51:38','2022-03-03 12:51:38'),(60413,170,'Chittorgarh Fort','312001',1,0,'2022-03-03 12:51:38','2022-03-03 12:51:38'),(60414,170,'Chittorgarh H.O','312001',1,0,'2022-03-03 12:51:38','2022-03-03 12:51:38'),(60415,170,'Chogawadi','312901',1,0,'2022-03-03 12:51:38','2022-03-03 12:51:38'),(60416,170,'Chorwadi','312205',1,0,'2022-03-03 12:51:38','2022-03-03 12:51:38'),(60417,170,'Chupna','312615',1,0,'2022-03-03 12:51:38','2022-03-03 12:51:38'),(60418,170,'Collectorate  Chittorgarh','312001',1,0,'2022-03-03 12:51:38','2022-03-03 12:51:38'),(60419,170,'Dabda','312605',1,0,'2022-03-03 12:51:38','2022-03-03 12:51:38'),(60420,170,'Dalla (Kishanpura)','312601',1,0,'2022-03-03 12:51:38','2022-03-03 12:51:38'),(60421,170,'Dalot','312619',1,0,'2022-03-03 12:51:38','2022-03-03 12:51:38'),(60422,170,'Damakhera','312202',1,0,'2022-03-03 12:51:38','2022-03-03 12:51:38'),(60423,170,'Daulatpura','312023',1,0,'2022-03-03 12:51:38','2022-03-03 12:51:38'),(60424,170,'Delwas','312404',1,0,'2022-03-03 12:51:38','2022-03-03 12:51:38'),(60425,170,'Deopura','312023',1,0,'2022-03-03 12:51:38','2022-03-03 12:51:38'),(60426,170,'Deori','312001',1,0,'2022-03-03 12:51:38','2022-03-03 12:51:38'),(60427,170,'Devgarh','312605',1,0,'2022-03-03 12:51:38','2022-03-03 12:51:38'),(60428,170,'Dewad','312605',1,0,'2022-03-03 12:51:38','2022-03-03 12:51:38'),(60429,170,'Dhamana','312202',1,0,'2022-03-03 12:51:38','2022-03-03 12:51:38'),(60430,170,'Dhamancha','312023',1,0,'2022-03-03 12:51:38','2022-03-03 12:51:38'),(60431,170,'Dhamotar ','312616',1,0,'2022-03-03 12:51:38','2022-03-03 12:51:38'),(60432,170,'Dhanet','312027',1,0,'2022-03-03 12:51:38','2022-03-03 12:51:38'),(60433,170,'Dhanet Kalan','312201',1,0,'2022-03-03 12:51:38','2022-03-03 12:51:38'),(60434,170,'Dhaula pani','312604',1,0,'2022-03-03 12:51:39','2022-03-03 12:51:39'),(60435,170,'Dheerji Ka Khera','312602',1,0,'2022-03-03 12:51:39','2022-03-03 12:51:39'),(60436,170,'Dhiknia','312616',1,0,'2022-03-03 12:51:39','2022-03-03 12:51:39'),(60437,170,'Dindoli','312203',1,0,'2022-03-03 12:51:39','2022-03-03 12:51:39'),(60438,170,'Doongla','312402',1,0,'2022-03-03 12:51:39','2022-03-03 12:51:39'),(60439,170,'Dorai','312023',1,0,'2022-03-03 12:51:39','2022-03-03 12:51:39'),(60440,170,'Doria','312601',1,0,'2022-03-03 12:51:39','2022-03-03 12:51:39'),(60441,170,'Dowani','312202',1,0,'2022-03-03 12:51:39','2022-03-03 12:51:39'),(60442,170,'Dudhli Tanda','312616',1,0,'2022-03-03 12:51:39','2022-03-03 12:51:39'),(60443,170,'Dugar','312022',1,0,'2022-03-03 12:51:39','2022-03-03 12:51:39'),(60444,170,'Eklingpura','323307',1,0,'2022-03-03 12:51:39','2022-03-03 12:51:39'),(60445,170,'Fathegarh','312615',1,0,'2022-03-03 12:51:39','2022-03-03 12:51:39'),(60446,170,'Gadola','312601',1,0,'2022-03-03 12:51:39','2022-03-03 12:51:39'),(60447,170,'Gadola','312623',1,0,'2022-03-03 12:51:39','2022-03-03 12:51:39'),(60448,170,'Gagrol','312604',1,0,'2022-03-03 12:51:39','2022-03-03 12:51:39'),(60449,170,'Gandher','312605',1,0,'2022-03-03 12:51:39','2022-03-03 12:51:39'),(60450,170,'Ganeshpura','312604',1,0,'2022-03-03 12:51:39','2022-03-03 12:51:39'),(60451,170,'Gangrar','312901',1,0,'2022-03-03 12:51:39','2022-03-03 12:51:39'),(60452,170,'Gardana','312603',1,0,'2022-03-03 12:51:39','2022-03-03 12:51:39'),(60453,170,'Ghatiawali','312612',1,0,'2022-03-03 12:51:39','2022-03-03 12:51:39'),(60454,170,'Gilund','312612',1,0,'2022-03-03 12:51:39','2022-03-03 12:51:39'),(60455,170,'Gomana','312604',1,0,'2022-03-03 12:51:39','2022-03-03 12:51:39'),(60456,170,'Gopalpura','323304',1,0,'2022-03-03 12:51:39','2022-03-03 12:51:39'),(60457,170,'Gopalpura','312022',1,0,'2022-03-03 12:51:39','2022-03-03 12:51:39'),(60458,170,'Gosunda','312201',1,0,'2022-03-03 12:51:39','2022-03-03 12:51:39'),(60459,170,'Gotarsi','312605',1,0,'2022-03-03 12:51:40','2022-03-03 12:51:40'),(60460,170,'Gulana','312023',1,0,'2022-03-03 12:51:40','2022-03-03 12:51:40'),(60461,170,'Gundli','312205',1,0,'2022-03-03 12:51:40','2022-03-03 12:51:40'),(60462,170,'Gyaspur','312605',1,0,'2022-03-03 12:51:40','2022-03-03 12:51:40'),(60463,170,'Harnathpur','312203',1,0,'2022-03-03 12:51:40','2022-03-03 12:51:40'),(60464,170,'Hathiyana','312202',1,0,'2022-03-03 12:51:40','2022-03-03 12:51:40'),(60465,170,'Hinglat','312615',1,0,'2022-03-03 12:51:40','2022-03-03 12:51:40'),(60466,170,'Hingoria','312207',1,0,'2022-03-03 12:51:40','2022-03-03 12:51:40'),(60467,170,'Idra','312024',1,0,'2022-03-03 12:51:40','2022-03-03 12:51:40'),(60468,170,'Jadana','312203',1,0,'2022-03-03 12:51:40','2022-03-03 12:51:40'),(60469,170,'Jainagar','312023',1,0,'2022-03-03 12:51:40','2022-03-03 12:51:40'),(60470,170,'Jajli','312615',1,0,'2022-03-03 12:51:40','2022-03-03 12:51:40'),(60471,170,'Jalampura','312612',1,0,'2022-03-03 12:51:40','2022-03-03 12:51:40'),(60472,170,'Jaliya','312601',1,0,'2022-03-03 12:51:40','2022-03-03 12:51:40'),(60473,170,'Jalkheda','323307',1,0,'2022-03-03 12:51:40','2022-03-03 12:51:40'),(60474,170,'Jaloda Jagir','312614',1,0,'2022-03-03 12:51:40','2022-03-03 12:51:40'),(60475,170,'Jalodia','312604',1,0,'2022-03-03 12:51:40','2022-03-03 12:51:40'),(60476,170,'Jarkhana','312403',1,0,'2022-03-03 12:51:40','2022-03-03 12:51:40'),(60477,170,'Jashma','312202',1,0,'2022-03-03 12:51:40','2022-03-03 12:51:40'),(60478,170,'Jawada  1','312023',1,0,'2022-03-03 12:51:40','2022-03-03 12:51:40'),(60479,170,'Jawada  II','312601',1,0,'2022-03-03 12:51:41','2022-03-03 12:51:41'),(60480,170,'Jawasia','312901',1,0,'2022-03-03 12:51:41','2022-03-03 12:51:41'),(60481,170,'Jeerawata','312619',1,0,'2022-03-03 12:51:41','2022-03-03 12:51:41'),(60482,170,'Jhansri','312605',1,0,'2022-03-03 12:51:41','2022-03-03 12:51:41'),(60483,170,'Jitiya','312207',1,0,'2022-03-03 12:51:41','2022-03-03 12:51:41'),(60484,170,'Jojron Ka Kheda','312901',1,0,'2022-03-03 12:51:41','2022-03-03 12:51:41'),(60485,170,'Jolar','312605',1,0,'2022-03-03 12:51:41','2022-03-03 12:51:41'),(60486,170,'Kachotiya','312605',1,0,'2022-03-03 12:51:41','2022-03-03 12:51:41'),(60487,170,'Kailash  Nagar','312617',1,0,'2022-03-03 12:51:41','2022-03-03 12:51:41'),(60488,170,'Kalyanpura','312605',1,0,'2022-03-03 12:51:41','2022-03-03 12:51:41'),(60489,170,'Kanad','312615',1,0,'2022-03-03 12:51:41','2022-03-03 12:51:41'),(60490,170,'Kanakhera','312204',1,0,'2022-03-03 12:51:41','2022-03-03 12:51:41'),(60491,170,'Kanera','312606',1,0,'2022-03-03 12:51:41','2022-03-03 12:51:41'),(60492,170,'Kangarh','312619',1,0,'2022-03-03 12:51:41','2022-03-03 12:51:41'),(60493,170,'Kankarwa','312204',1,0,'2022-03-03 12:51:41','2022-03-03 12:51:41'),(60494,170,'Kannoj','312613',1,0,'2022-03-03 12:51:41','2022-03-03 12:51:41'),(60495,170,'Kanora','312623',1,0,'2022-03-03 12:51:41','2022-03-03 12:51:41'),(60496,170,'Kanthariya Chobe Ji Ka','312201',1,0,'2022-03-03 12:51:41','2022-03-03 12:51:41'),(60497,170,'Kanti','312901',1,0,'2022-03-03 12:51:41','2022-03-03 12:51:41'),(60498,170,'Kapasan  Town','312202',1,0,'2022-03-03 12:51:41','2022-03-03 12:51:41'),(60499,170,'Kapasan','312202',1,0,'2022-03-03 12:51:41','2022-03-03 12:51:41'),(60500,170,'Karjali','312205',1,0,'2022-03-03 12:51:41','2022-03-03 12:51:41'),(60501,170,'Karju','312403',1,0,'2022-03-03 12:51:41','2022-03-03 12:51:41'),(60502,170,'Karsana','312404',1,0,'2022-03-03 12:51:41','2022-03-03 12:51:41'),(60503,170,'Karunda','312620',1,0,'2022-03-03 12:51:42','2022-03-03 12:51:42'),(60504,170,'Karunda','312604',1,0,'2022-03-03 12:51:42','2022-03-03 12:51:42'),(60505,170,'Kashmore','312201',1,0,'2022-03-03 12:51:42','2022-03-03 12:51:42'),(60506,170,'Katunda','312023',1,0,'2022-03-03 12:51:42','2022-03-03 12:51:42'),(60507,170,'Keli','312601',1,0,'2022-03-03 12:51:42','2022-03-03 12:51:42'),(60508,170,'Kerwas','312605',1,0,'2022-03-03 12:51:42','2022-03-03 12:51:42'),(60509,170,'Kesharpura','312623',1,0,'2022-03-03 12:51:42','2022-03-03 12:51:42'),(60510,170,'Kesunda','312604',1,0,'2022-03-03 12:51:42','2022-03-03 12:51:42'),(60511,170,'Kewalpura','312401',1,0,'2022-03-03 12:51:42','2022-03-03 12:51:42'),(60512,170,'Khardeola','312403',1,0,'2022-03-03 12:51:42','2022-03-03 12:51:42'),(60513,170,'Kharkhanda','312901',1,0,'2022-03-03 12:51:42','2022-03-03 12:51:42'),(60514,170,'Khatikhera','323307',1,0,'2022-03-03 12:51:42','2022-03-03 12:51:42'),(60515,170,'Kheda','312623',1,0,'2022-03-03 12:51:42','2022-03-03 12:51:42'),(60516,170,'Kheranarsingh Mata','312616',1,0,'2022-03-03 12:51:42','2022-03-03 12:51:42'),(60517,170,'Kheri','312022',1,0,'2022-03-03 12:51:42','2022-03-03 12:51:42'),(60518,170,'Khermalia','312603',1,0,'2022-03-03 12:51:42','2022-03-03 12:51:42'),(60519,170,'Kherot','312605',1,0,'2022-03-03 12:51:42','2022-03-03 12:51:42'),(60520,170,'Kherpura','312022',1,0,'2022-03-03 12:51:42','2022-03-03 12:51:42'),(60521,170,'Khodip','312614',1,0,'2022-03-03 12:51:42','2022-03-03 12:51:42'),(60522,170,'Khoria','312623',1,0,'2022-03-03 12:51:42','2022-03-03 12:51:42'),(60523,170,'Kiratpura','312403',1,0,'2022-03-03 12:51:42','2022-03-03 12:51:42'),(60524,170,'Kotri','312615',1,0,'2022-03-03 12:51:42','2022-03-03 12:51:42'),(60525,170,'Kotri Kalan','312601',1,0,'2022-03-03 12:51:42','2022-03-03 12:51:42'),(60526,170,'Kotwal','312605',1,0,'2022-03-03 12:51:42','2022-03-03 12:51:42'),(60527,170,'Kulthana','312605',1,0,'2022-03-03 12:51:42','2022-03-03 12:51:42'),(60528,170,'Kuni','312605',1,0,'2022-03-03 12:51:43','2022-03-03 12:51:43'),(60529,170,'Kunthana','312024',1,0,'2022-03-03 12:51:43','2022-03-03 12:51:43'),(60530,170,'Kunwalia','312901',1,0,'2022-03-03 12:51:43','2022-03-03 12:51:43'),(60531,170,'Kutchery Partabgarh','312605',1,0,'2022-03-03 12:51:43','2022-03-03 12:51:43'),(60532,170,'Lalgarh','312615',1,0,'2022-03-03 12:51:43','2022-03-03 12:51:43'),(60533,170,'Langach','312207',1,0,'2022-03-03 12:51:43','2022-03-03 12:51:43'),(60534,170,'Lasadiaya Kalan','312206',1,0,'2022-03-03 12:51:43','2022-03-03 12:51:43'),(60535,170,'Lasdawn','312601',1,0,'2022-03-03 12:51:43','2022-03-03 12:51:43'),(60536,170,'Laxmipura','312403',1,0,'2022-03-03 12:51:43','2022-03-03 12:51:43'),(60537,170,'Leswa','312024',1,0,'2022-03-03 12:51:43','2022-03-03 12:51:43'),(60538,170,'Lothiyana','312024',1,0,'2022-03-03 12:51:43','2022-03-03 12:51:43'),(60539,170,'Luharia','312605',1,0,'2022-03-03 12:51:43','2022-03-03 12:51:43'),(60540,170,'Madhura Talab','312616',1,0,'2022-03-03 12:51:43','2022-03-03 12:51:43'),(60541,170,'Magroda','312623',1,0,'2022-03-03 12:51:43','2022-03-03 12:51:43'),(60542,170,'Maharaaj Ki Netawal','312207',1,0,'2022-03-03 12:51:43','2022-03-03 12:51:43'),(60543,170,'Mahuda','312401',1,0,'2022-03-03 12:51:43','2022-03-03 12:51:43'),(60544,170,'Mandawara','312605',1,0,'2022-03-03 12:51:43','2022-03-03 12:51:43'),(60545,170,'Mandawari','312023',1,0,'2022-03-03 12:51:43','2022-03-03 12:51:43'),(60546,170,'Mandesara','323306',1,0,'2022-03-03 12:51:43','2022-03-03 12:51:43'),(60547,170,'Mandfia','312027',1,0,'2022-03-03 12:51:43','2022-03-03 12:51:43'),(60548,170,'Mandfiya','312901',1,0,'2022-03-03 12:51:43','2022-03-03 12:51:43'),(60549,170,'Mandkalan','312605',1,0,'2022-03-03 12:51:43','2022-03-03 12:51:43'),(60550,170,'Mandla Charan','312614',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60551,170,'Mangalwar','312024',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60552,170,'Mangrol (Chittorgarh)','312620',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60553,170,'Manohar Garh','312605',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60554,170,'Manpura Jagir','312403',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60555,170,'Marjivi','312601',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60556,170,'Marmi','312203',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60557,170,'Meghniwas','323304',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60558,170,'Melana','312601',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60559,170,'Meriyakhedi','312616',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60560,170,'Mishron Ki Pipli','312201',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60561,170,'Mohana','323307',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60562,170,'Moheda','312615',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60563,170,'Morwan','312024',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60564,170,'Mota Dhamaniya','312605',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60565,170,'Motikhedi','312605',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60566,170,'Motipura','312022',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60567,170,'Mowai','312615',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60568,170,'Munjwa','312403',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60569,170,'Murla','312205',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60570,170,'Muroli','312203',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60571,170,'Nadakhera','312027',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60572,170,'Nagawali','312024',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60573,170,'Nagdi','312615',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60574,170,'Nagri','312022',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60575,170,'Nahargarh','312613',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60576,170,'Nakor','312605',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60577,170,'Nandwai','312023',1,0,'2022-03-03 12:51:44','2022-03-03 12:51:44'),(60578,170,'Nannana','312614',1,0,'2022-03-03 12:51:45','2022-03-03 12:51:45'),(60579,170,'Napania','312024',1,0,'2022-03-03 12:51:45','2022-03-03 12:51:45'),(60580,170,'Napawali','312603',1,0,'2022-03-03 12:51:45','2022-03-03 12:51:45'),(60581,170,'Narani','312604',1,0,'2022-03-03 12:51:45','2022-03-03 12:51:45'),(60582,170,'Narayankheda','312616',1,0,'2022-03-03 12:51:45','2022-03-03 12:51:45'),(60583,170,'Narela','312207',1,0,'2022-03-03 12:51:45','2022-03-03 12:51:45'),(60584,170,'Naugama','312615',1,0,'2022-03-03 12:51:45','2022-03-03 12:51:45'),(60585,170,'Netawal garh pachhali','312001',1,0,'2022-03-03 12:51:45','2022-03-03 12:51:45'),(60586,170,'Nevaria','312206',1,0,'2022-03-03 12:51:45','2022-03-03 12:51:45'),(60587,170,'Nikumbh','312603',1,0,'2022-03-03 12:51:45','2022-03-03 12:51:45'),(60588,170,'Nilod','312205',1,0,'2022-03-03 12:51:45','2022-03-03 12:51:45'),(60589,170,'Nimbahera','312202',1,0,'2022-03-03 12:51:45','2022-03-03 12:51:45'),(60590,170,'Nimbahera','312601',1,0,'2022-03-03 12:51:45','2022-03-03 12:51:45'),(60591,170,'Ninor','312619',1,0,'2022-03-03 12:51:45','2022-03-03 12:51:45'),(60592,170,'Ochhari','312001',1,0,'2022-03-03 12:51:45','2022-03-03 12:51:45'),(60593,170,'Odund','312201',1,0,'2022-03-03 12:51:45','2022-03-03 12:51:45'),(60594,170,'Pachunda','312023',1,0,'2022-03-03 12:51:45','2022-03-03 12:51:45'),(60595,170,'Pahuna','312206',1,0,'2022-03-03 12:51:45','2022-03-03 12:51:45'),(60596,170,'Pal','312022',1,0,'2022-03-03 12:51:45','2022-03-03 12:51:45'),(60597,170,'Pal','312605',1,0,'2022-03-03 12:51:45','2022-03-03 12:51:45'),(60598,170,'Palasia','312204',1,0,'2022-03-03 12:51:45','2022-03-03 12:51:45'),(60599,170,'Palka','312022',1,0,'2022-03-03 12:51:45','2022-03-03 12:51:45'),(60600,170,'Palod','312402',1,0,'2022-03-03 12:51:45','2022-03-03 12:51:45'),(60601,170,'Pandawa','312605',1,0,'2022-03-03 12:51:45','2022-03-03 12:51:45'),(60602,170,'Pandoli S T','312202',1,0,'2022-03-03 12:51:45','2022-03-03 12:51:45'),(60603,170,'Pandolimataji Ki','312201',1,0,'2022-03-03 12:51:45','2022-03-03 12:51:45'),(60604,170,'Panmodi','312623',1,0,'2022-03-03 12:51:46','2022-03-03 12:51:46'),(60605,170,'Pari','312204',1,0,'2022-03-03 12:51:46','2022-03-03 12:51:46'),(60606,170,'Parliya','312605',1,0,'2022-03-03 12:51:46','2022-03-03 12:51:46'),(60607,170,'Parsoli','312022',1,0,'2022-03-03 12:51:46','2022-03-03 12:51:46'),(60608,170,'Parsoli','312403',1,0,'2022-03-03 12:51:46','2022-03-03 12:51:46'),(60609,170,'Pateliya','312605',1,0,'2022-03-03 12:51:46','2022-03-03 12:51:46'),(60610,170,'Patoliya','312205',1,0,'2022-03-03 12:51:46','2022-03-03 12:51:46'),(60611,170,'Peelikheda','312604',1,0,'2022-03-03 12:51:46','2022-03-03 12:51:46'),(60612,170,'Peend','312603',1,0,'2022-03-03 12:51:46','2022-03-03 12:51:46'),(60613,170,'Phalasiya','312204',1,0,'2022-03-03 12:51:46','2022-03-03 12:51:46'),(60614,170,'Phalodara','312404',1,0,'2022-03-03 12:51:46','2022-03-03 12:51:46'),(60615,170,'Phalwa','312601',1,0,'2022-03-03 12:51:46','2022-03-03 12:51:46'),(60616,170,'Piloo','312623',1,0,'2022-03-03 12:51:46','2022-03-03 12:51:46'),(60617,170,'Pipalwas','312001',1,0,'2022-03-03 12:51:46','2022-03-03 12:51:46'),(60618,170,'Pirana','312402',1,0,'2022-03-03 12:51:46','2022-03-03 12:51:46'),(60619,170,'Pithalwadikalan','312604',1,0,'2022-03-03 12:51:46','2022-03-03 12:51:46'),(60620,170,'Potlajagir','312602',1,0,'2022-03-03 12:51:46','2022-03-03 12:51:46'),(60621,170,'Pratap garh (Chittorgarh)','312605',1,0,'2022-03-03 12:51:46','2022-03-03 12:51:46'),(60622,170,'Punawali','312603',1,0,'2022-03-03 12:51:46','2022-03-03 12:51:46'),(60623,170,'Putholi','312021',1,0,'2022-03-03 12:51:46','2022-03-03 12:51:46'),(60624,170,'Raghunathpura','312901',1,0,'2022-03-03 12:51:46','2022-03-03 12:51:46'),(60625,170,'Raipur','312619',1,0,'2022-03-03 12:51:46','2022-03-03 12:51:46'),(60626,170,'Raipurjangal','312619',1,0,'2022-03-03 12:51:46','2022-03-03 12:51:46'),(60627,170,'Raita','312023',1,0,'2022-03-03 12:51:46','2022-03-03 12:51:46'),(60628,170,'Rajgarh','312022',1,0,'2022-03-03 12:51:46','2022-03-03 12:51:46'),(60629,170,'Rajpura','323306',1,0,'2022-03-03 12:51:46','2022-03-03 12:51:46'),(60630,170,'Rampuria','312605',1,0,'2022-03-03 12:51:47','2022-03-03 12:51:47'),(60631,170,'Ranasanga  Bazar  Chittorgarh','312001',1,0,'2022-03-03 12:51:47','2022-03-03 12:51:47'),(60632,170,'Ranikhera','312601',1,0,'2022-03-03 12:51:47','2022-03-03 12:51:47'),(60633,170,'Rashmi','312203',1,0,'2022-03-03 12:51:47','2022-03-03 12:51:47'),(60634,170,'Ratanpuria','312605',1,0,'2022-03-03 12:51:47','2022-03-03 12:51:47'),(60635,170,'Rathajana','312623',1,0,'2022-03-03 12:51:47','2022-03-03 12:51:47'),(60636,170,'Ratichandjikakhera','312403',1,0,'2022-03-03 12:51:47','2022-03-03 12:51:47'),(60637,170,'Rawarda','312023',1,0,'2022-03-03 12:51:47','2022-03-03 12:51:47'),(60638,170,'Rawatbhatta  Bazar','323305',1,0,'2022-03-03 12:51:47','2022-03-03 12:51:47'),(60639,170,'Rawatpura','312402',1,0,'2022-03-03 12:51:47','2022-03-03 12:51:47'),(60640,170,'Rewara','312206',1,0,'2022-03-03 12:51:47','2022-03-03 12:51:47'),(60641,170,'Rewlia Khurd','312201',1,0,'2022-03-03 12:51:47','2022-03-03 12:51:47'),(60642,170,'Richawara','312605',1,0,'2022-03-03 12:51:47','2022-03-03 12:51:47'),(60643,170,'Rolahera','312021',1,0,'2022-03-03 12:51:47','2022-03-03 12:51:47'),(60644,170,'Rolia','312202',1,0,'2022-03-03 12:51:47','2022-03-03 12:51:47'),(60645,170,'Rood','312901',1,0,'2022-03-03 12:51:47','2022-03-03 12:51:47'),(60646,170,'Sadalkhera','312603',1,0,'2022-03-03 12:51:47','2022-03-03 12:51:47'),(60647,170,'Sadas','312901',1,0,'2022-03-03 12:51:47','2022-03-03 12:51:47'),(60648,170,'Sadi','312022',1,0,'2022-03-03 12:51:47','2022-03-03 12:51:47'),(60649,170,'Sadi','312901',1,0,'2022-03-03 12:51:47','2022-03-03 12:51:47'),(60650,170,'Sadi','312023',1,0,'2022-03-03 12:51:47','2022-03-03 12:51:47'),(60651,170,'Sagathali Thana','312615',1,0,'2022-03-03 12:51:47','2022-03-03 12:51:47'),(60652,170,'Sainik School','312021',1,0,'2022-03-03 12:51:47','2022-03-03 12:51:47'),(60653,170,'Sakriya','312623',1,0,'2022-03-03 12:51:47','2022-03-03 12:51:47'),(60654,170,'Salamgarh','312619',1,0,'2022-03-03 12:51:48','2022-03-03 12:51:48'),(60655,170,'Samari','312612',1,0,'2022-03-03 12:51:48','2022-03-03 12:51:48'),(60656,170,'Samaria Khurd','312023',1,0,'2022-03-03 12:51:48','2022-03-03 12:51:48'),(60657,170,'Sangesara','312024',1,0,'2022-03-03 12:51:48','2022-03-03 12:51:48'),(60658,170,'Sangria','312404',1,0,'2022-03-03 12:51:48','2022-03-03 12:51:48'),(60659,170,'Sankhali','312203',1,0,'2022-03-03 12:51:48','2022-03-03 12:51:48'),(60660,170,'Sarsi','312601',1,0,'2022-03-03 12:51:48','2022-03-03 12:51:48'),(60661,170,'Satkhanda','312612',1,0,'2022-03-03 12:51:48','2022-03-03 12:51:48'),(60662,170,'Satola','312403',1,0,'2022-03-03 12:51:48','2022-03-03 12:51:48'),(60663,170,'Satpura','312201',1,0,'2022-03-03 12:51:48','2022-03-03 12:51:48'),(60664,170,'Sawa','312613',1,0,'2022-03-03 12:51:48','2022-03-03 12:51:48'),(60665,170,'Sehnwa','312001',1,0,'2022-03-03 12:51:48','2022-03-03 12:51:48'),(60666,170,'Selarpura Kalan','312605',1,0,'2022-03-03 12:51:48','2022-03-03 12:51:48'),(60667,170,'Semalpura','312001',1,0,'2022-03-03 12:51:48','2022-03-03 12:51:48'),(60668,170,'Semarthali','312604',1,0,'2022-03-03 12:51:48','2022-03-03 12:51:48'),(60669,170,'Semlia','312001',1,0,'2022-03-03 12:51:48','2022-03-03 12:51:48'),(60670,170,'Semlia Peela Khera','312402',1,0,'2022-03-03 12:51:48','2022-03-03 12:51:48'),(60671,170,'Semnop','312623',1,0,'2022-03-03 12:51:48','2022-03-03 12:51:48'),(60672,170,'Senthi','312025',1,0,'2022-03-03 12:51:48','2022-03-03 12:51:48'),(60673,170,'Sewna','312619',1,0,'2022-03-03 12:51:48','2022-03-03 12:51:48'),(60674,170,'Shabhupura','312612',1,0,'2022-03-03 12:51:48','2022-03-03 12:51:48'),(60675,170,'Sidhpura','312616',1,0,'2022-03-03 12:51:48','2022-03-03 12:51:48'),(60676,170,'Sihana','312206',1,0,'2022-03-03 12:51:48','2022-03-03 12:51:48'),(60677,170,'Singhpur (Chittorgarh)','312207',1,0,'2022-03-03 12:51:48','2022-03-03 12:51:48'),(60678,170,'Siyakhedi','312604',1,0,'2022-03-03 12:51:49','2022-03-03 12:51:49'),(60679,170,'Sonagar','312022',1,0,'2022-03-03 12:51:49','2022-03-03 12:51:49'),(60680,170,'Soniyana','312901',1,0,'2022-03-03 12:51:49','2022-03-03 12:51:49'),(60681,170,'Sripura','323304',1,0,'2022-03-03 12:51:49','2022-03-03 12:51:49'),(60682,170,'Subi','312604',1,0,'2022-03-03 12:51:49','2022-03-03 12:51:49'),(60683,170,'Sudri','312901',1,0,'2022-03-03 12:51:49','2022-03-03 12:51:49'),(60684,170,'Suhagpura','312605',1,0,'2022-03-03 12:51:49','2022-03-03 12:51:49'),(60685,170,'Sukhwara','312613',1,0,'2022-03-03 12:51:49','2022-03-03 12:51:49'),(60686,170,'Surpur','312201',1,0,'2022-03-03 12:51:49','2022-03-03 12:51:49'),(60687,170,'Suwania','312901',1,0,'2022-03-03 12:51:49','2022-03-03 12:51:49'),(60688,170,'Swaroopganj','312604',1,0,'2022-03-03 12:51:49','2022-03-03 12:51:49'),(60689,170,'Tambolia','323304',1,0,'2022-03-03 12:51:49','2022-03-03 12:51:49'),(60690,170,'Tana','312205',1,0,'2022-03-03 12:51:49','2022-03-03 12:51:49'),(60691,170,'Teela','312616',1,0,'2022-03-03 12:51:49','2022-03-03 12:51:49'),(60692,170,'Thada','312623',1,0,'2022-03-03 12:51:49','2022-03-03 12:51:49'),(60693,170,'Thukrai','312023',1,0,'2022-03-03 12:51:49','2022-03-03 12:51:49'),(60694,170,'Tumbadia','312901',1,0,'2022-03-03 12:51:49','2022-03-03 12:51:49'),(60695,170,'Tumbadia','312207',1,0,'2022-03-03 12:51:49','2022-03-03 12:51:49'),(60696,170,'Uchnarkhurd','312202',1,0,'2022-03-03 12:51:49','2022-03-03 12:51:49'),(60697,170,'Udpura','312620',1,0,'2022-03-03 12:51:49','2022-03-03 12:51:49'),(60698,170,'Umand','312205',1,0,'2022-03-03 12:51:49','2022-03-03 12:51:49'),(60699,170,'Undwa','312901',1,0,'2022-03-03 12:51:49','2022-03-03 12:51:49'),(60700,170,'Unkliya','312620',1,0,'2022-03-03 12:51:49','2022-03-03 12:51:49'),(60701,170,'Untakheda','312616',1,0,'2022-03-03 12:51:49','2022-03-03 12:51:49'),(60702,170,'Unthel','312619',1,0,'2022-03-03 12:51:49','2022-03-03 12:51:49'),(60703,170,'Upreda','312203',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60704,170,'Usrol','312204',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60705,170,'Varmandal','312605',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60706,170,'Veerawali','312615',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60707,170,'Veerpur','312605',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60708,170,'Vikram Nagar','323306',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60709,170,'Jawahar Nagar','326501',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60710,171,'Badela','331803',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60711,171,'Jakhasar','331803',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60712,171,'Jodhasar','331811',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60713,171,'Kalubas','331803',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60714,171,'Momasar','331801',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60715,171,'Sudsar','331811',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60716,171,'Abadsar','331802',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60717,171,'Absar','331505',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60718,171,'Adsisar','331403',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60719,171,'Ajeetsar','331504',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60720,171,'Allayala','331304',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60721,171,'Alsar','331802',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60722,171,'Amarsar','331517',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60723,171,'Anandsinghpura','331304',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60724,171,'Asalkheri','331001',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60725,171,'Asalsar','331504',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60726,171,'Aspalsar Bara','331403',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60727,171,'B.S.Road Churu','331001',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60728,171,'Bachharara Bara','331022',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60729,171,'Badabar','331507',1,0,'2022-03-03 12:51:50','2022-03-03 12:51:50'),(60730,171,'Badsar','331518',1,0,'2022-03-03 12:51:51','2022-03-03 12:51:51'),(60731,171,'Bagsara','331518',1,0,'2022-03-03 12:51:51','2022-03-03 12:51:51'),(60732,171,'Baijwa','331303',1,0,'2022-03-03 12:51:51','2022-03-03 12:51:51'),(60733,171,'Baila','331403',1,0,'2022-03-03 12:51:51','2022-03-03 12:51:51'),(60734,171,'Bain','331304',1,0,'2022-03-03 12:51:51','2022-03-03 12:51:51'),(60735,171,'Bairasar','331517',1,0,'2022-03-03 12:51:51','2022-03-03 12:51:51'),(60736,171,'Bairasar Chhota','331023',1,0,'2022-03-03 12:51:51','2022-03-03 12:51:51'),(60737,171,'Balera','331503',1,0,'2022-03-03 12:51:51','2022-03-03 12:51:51'),(60738,171,'Bamania','331506',1,0,'2022-03-03 12:51:51','2022-03-03 12:51:51'),(60739,171,'Bamboo','331517',1,0,'2022-03-03 12:51:51','2022-03-03 12:51:51'),(60740,171,'Banara','331304',1,0,'2022-03-03 12:51:51','2022-03-03 12:51:51'),(60741,171,'Bandhnau','331403',1,0,'2022-03-03 12:51:51','2022-03-03 12:51:51'),(60742,171,'Bandwa','331802',1,0,'2022-03-03 12:51:51','2022-03-03 12:51:51'),(60743,171,'Barjangsar','331411',1,0,'2022-03-03 12:51:51','2022-03-03 12:51:51'),(60744,171,'Bewar','331301',1,0,'2022-03-03 12:51:51','2022-03-03 12:51:51'),(60745,171,'Bhadasar','331403',1,0,'2022-03-03 12:51:51','2022-03-03 12:51:51'),(60746,171,'Bhagela','331023',1,0,'2022-03-03 12:51:51','2022-03-03 12:51:51'),(60747,171,'Bhainsali','331301',1,0,'2022-03-03 12:51:51','2022-03-03 12:51:51'),(60748,171,'Bhalau Tal','331304',1,0,'2022-03-03 12:51:51','2022-03-03 12:51:51'),(60749,171,'Bhaleri','331304',1,0,'2022-03-03 12:51:51','2022-03-03 12:51:51'),(60750,171,'Bhamasi','331001',1,0,'2022-03-03 12:51:51','2022-03-03 12:51:51'),(60751,171,'Bhamreed','331305',1,0,'2022-03-03 12:51:52','2022-03-03 12:51:52'),(60752,171,'Bhanin','331304',1,0,'2022-03-03 12:51:52','2022-03-03 12:51:52'),(60753,171,'Bhanipura','331411',1,0,'2022-03-03 12:51:52','2022-03-03 12:51:52'),(60754,171,'Bhanuda','331022',1,0,'2022-03-03 12:51:52','2022-03-03 12:51:52'),(60755,171,'Bharang','331302',1,0,'2022-03-03 12:51:52','2022-03-03 12:51:52'),(60756,171,'Bharpalsar','331802',1,0,'2022-03-03 12:51:52','2022-03-03 12:51:52'),(60757,171,'Bhasina','331518',1,0,'2022-03-03 12:51:52','2022-03-03 12:51:52'),(60758,171,'Bhawandesar','331802',1,0,'2022-03-03 12:51:52','2022-03-03 12:51:52'),(60759,171,'Bhimsana','331701',1,0,'2022-03-03 12:51:52','2022-03-03 12:51:52'),(60760,171,'Bhimsar','331506',1,0,'2022-03-03 12:51:52','2022-03-03 12:51:52'),(60761,171,'Bhojan','331301',1,0,'2022-03-03 12:51:52','2022-03-03 12:51:52'),(60762,171,'Bhojasar','331411',1,0,'2022-03-03 12:51:52','2022-03-03 12:51:52'),(60763,171,'Bhojasar','331505',1,0,'2022-03-03 12:51:52','2022-03-03 12:51:52'),(60764,171,'Bhojasar Upadhiyan','331403',1,0,'2022-03-03 12:51:52','2022-03-03 12:51:52'),(60765,171,'Bhuchawas','331304',1,0,'2022-03-03 12:51:52','2022-03-03 12:51:52'),(60766,171,'Bhukhredi','331022',1,0,'2022-03-03 12:51:52','2022-03-03 12:51:52'),(60767,171,'Bhuwari','331023',1,0,'2022-03-03 12:51:52','2022-03-03 12:51:52'),(60768,171,'Bidasar','331501',1,0,'2022-03-03 12:51:52','2022-03-03 12:51:52'),(60769,171,'Bikamsara','331403',1,0,'2022-03-03 12:51:52','2022-03-03 12:51:52'),(60770,171,'Billu Bass Rampura','331403',1,0,'2022-03-03 12:51:52','2022-03-03 12:51:52'),(60771,171,'Binadesar','331802',1,0,'2022-03-03 12:51:52','2022-03-03 12:51:52'),(60772,171,'Binasar','331031',1,0,'2022-03-03 12:51:52','2022-03-03 12:51:52'),(60773,171,'Binjawas','331305',1,0,'2022-03-03 12:51:52','2022-03-03 12:51:52'),(60774,171,'Birami Khalsa','331701',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60775,171,'Biramsar','331022',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60776,171,'Biran','331301',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60777,171,'Bobasar Bidawtan','331507',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60778,171,'Boghera','331403',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60779,171,'Bukalsar Bara','331411',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60780,171,'Bungi','331023',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60781,171,'Buntia','331001',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60782,171,'Chainpura Chhota','331023',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60783,171,'Chalkoi Banirotan','331304',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60784,171,'Chand Gothi','331305',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60785,171,'Changoi','331304',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60786,171,'Charanwasi','331022',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60787,171,'Charia','331506',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60788,171,'Charla','331517',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60789,171,'Charwas','331503',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60790,171,'Chhapar','331502',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60791,171,'Chubakia Tal','331023',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60792,171,'Churu City','331001',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60793,171,'Churu Collectorate','331001',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60794,171,'Churu H.O','331001',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60795,171,'Dadrewa','331023',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60796,171,'Dandu','331001',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60797,171,'Dariba','331501',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60798,171,'Daudsar','331022',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60799,171,'Deepsar','331022',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60800,171,'Depalsar','331021',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60801,171,'Derajsar','331402',1,0,'2022-03-03 12:51:53','2022-03-03 12:51:53'),(60802,171,'Devipura','331023',1,0,'2022-03-03 12:51:54','2022-03-03 12:51:54'),(60803,171,'Dewani','331502',1,0,'2022-03-03 12:51:54','2022-03-03 12:51:54'),(60804,171,'Dhadhar','331001',1,0,'2022-03-03 12:51:54','2022-03-03 12:51:54'),(60805,171,'Dhadharia Charnan','331001',1,0,'2022-03-03 12:51:54','2022-03-03 12:51:54'),(60806,171,'Dhana Bhakran','331304',1,0,'2022-03-03 12:51:54','2022-03-03 12:51:54'),(60807,171,'Dhandheru Bhamuwan','331802',1,0,'2022-03-03 12:51:54','2022-03-03 12:51:54'),(60808,171,'Dhani Asha','331304',1,0,'2022-03-03 12:51:54','2022-03-03 12:51:54'),(60809,171,'Dhani Bari','331701',1,0,'2022-03-03 12:51:54','2022-03-03 12:51:54'),(60810,171,'Dhani D.S.Pura','331021',1,0,'2022-03-03 12:51:54','2022-03-03 12:51:54'),(60811,171,'Dhani Kumharan','331304',1,0,'2022-03-03 12:51:54','2022-03-03 12:51:54'),(60812,171,'Dhani Mozi','331023',1,0,'2022-03-03 12:51:54','2022-03-03 12:51:54'),(60813,171,'Dhani Pachera','331403',1,0,'2022-03-03 12:51:54','2022-03-03 12:51:54'),(60814,171,'Dhanoti Chhoti','331701',1,0,'2022-03-03 12:51:54','2022-03-03 12:51:54'),(60815,171,'Dhanoti Kalan','331701',1,0,'2022-03-03 12:51:54','2022-03-03 12:51:54'),(60816,171,'Dhatri','331505',1,0,'2022-03-03 12:51:54','2022-03-03 12:51:54'),(60817,171,'Dhigarla','331023',1,0,'2022-03-03 12:51:54','2022-03-03 12:51:54'),(60818,171,'Dhingi','331023',1,0,'2022-03-03 12:51:54','2022-03-03 12:51:54'),(60819,171,'Dhirasar','331001',1,0,'2022-03-03 12:51:54','2022-03-03 12:51:54'),(60820,171,'Dhirwas','331302',1,0,'2022-03-03 12:51:54','2022-03-03 12:51:54'),(60821,171,'Dokwa','331023',1,0,'2022-03-03 12:51:54','2022-03-03 12:51:54'),(60822,171,'Dudhwakha R.S.','331029',1,0,'2022-03-03 12:51:54','2022-03-03 12:51:54'),(60823,171,'Dudhwakhara','331029',1,0,'2022-03-03 12:51:54','2022-03-03 12:51:54'),(60824,171,'Dulrasar','331022',1,0,'2022-03-03 12:51:54','2022-03-03 12:51:54'),(60825,171,'Dunkar','331501',1,0,'2022-03-03 12:51:54','2022-03-03 12:51:54'),(60826,171,'E.G.Ratangarh','331022',1,0,'2022-03-03 12:51:55','2022-03-03 12:51:55'),(60827,171,'G.G.Sujangarh','331507',1,0,'2022-03-03 12:51:55','2022-03-03 12:51:55'),(60828,171,'Gajusar','331403',1,0,'2022-03-03 12:51:55','2022-03-03 12:51:55'),(60829,171,'Gajuwas','331304',1,0,'2022-03-03 12:51:55','2022-03-03 12:51:55'),(60830,171,'Galar','331701',1,0,'2022-03-03 12:51:55','2022-03-03 12:51:55'),(60831,171,'Ghanau','331023',1,0,'2022-03-03 12:51:55','2022-03-03 12:51:55'),(60832,171,'Ghanghu','331001',1,0,'2022-03-03 12:51:55','2022-03-03 12:51:55'),(60833,171,'Ghantaghar Churu','331001',1,0,'2022-03-03 12:51:55','2022-03-03 12:51:55'),(60834,171,'Ghantel','331001',1,0,'2022-03-03 12:51:55','2022-03-03 12:51:55'),(60835,171,'Ginari Patta Lohasana','331001',1,0,'2022-03-03 12:51:55','2022-03-03 12:51:55'),(60836,171,'Girwarsar','331517',1,0,'2022-03-03 12:51:55','2022-03-03 12:51:55'),(60837,171,'Gogasar','331504',1,0,'2022-03-03 12:51:55','2022-03-03 12:51:55'),(60838,171,'Golsar','331022',1,0,'2022-03-03 12:51:55','2022-03-03 12:51:55'),(60839,171,'Gopalpura','331503',1,0,'2022-03-03 12:51:55','2022-03-03 12:51:55'),(60840,171,'Gopalpuria','331022',1,0,'2022-03-03 12:51:55','2022-03-03 12:51:55'),(60841,171,'Gorisar','331022',1,0,'2022-03-03 12:51:55','2022-03-03 12:51:55'),(60842,171,'Gothya Bari','331023',1,0,'2022-03-03 12:51:55','2022-03-03 12:51:55'),(60843,171,'Guleria','331507',1,0,'2022-03-03 12:51:55','2022-03-03 12:51:55'),(60844,171,'Gulpura','331023',1,0,'2022-03-03 12:51:55','2022-03-03 12:51:55'),(60845,171,'Gvm Sardarshahr','331403',1,0,'2022-03-03 12:51:55','2022-03-03 12:51:55'),(60846,171,'Gwalisar','331023',1,0,'2022-03-03 12:51:55','2022-03-03 12:51:55'),(60847,171,'Hady R.S.','331023',1,0,'2022-03-03 12:51:55','2022-03-03 12:51:55'),(60848,171,'Hadyal Village','331029',1,0,'2022-03-03 12:51:55','2022-03-03 12:51:55'),(60849,171,'Hamirwas','331305',1,0,'2022-03-03 12:51:56','2022-03-03 12:51:56'),(60850,171,'Hamusar','331022',1,0,'2022-03-03 12:51:56','2022-03-03 12:51:56'),(60851,171,'Hansiyawas','331023',1,0,'2022-03-03 12:51:56','2022-03-03 12:51:56'),(60852,171,'Harasar','331505',1,0,'2022-03-03 12:51:56','2022-03-03 12:51:56'),(60853,171,'Harpalu Tal','331305',1,0,'2022-03-03 12:51:56','2022-03-03 12:51:56'),(60854,171,'Hudera','331022',1,0,'2022-03-03 12:51:56','2022-03-03 12:51:56'),(60855,171,'Inderpura','331029',1,0,'2022-03-03 12:51:56','2022-03-03 12:51:56'),(60856,171,'Inyara','331517',1,0,'2022-03-03 12:51:56','2022-03-03 12:51:56'),(60857,171,'Jaisinghsar','331402',1,0,'2022-03-03 12:51:56','2022-03-03 12:51:56'),(60858,171,'Jaitasar','331411',1,0,'2022-03-03 12:51:56','2022-03-03 12:51:56'),(60859,171,'Jaitputa','331023',1,0,'2022-03-03 12:51:56','2022-03-03 12:51:56'),(60860,171,'Jaitsisar','331411',1,0,'2022-03-03 12:51:56','2022-03-03 12:51:56'),(60861,171,'Jaleu','331022',1,0,'2022-03-03 12:51:56','2022-03-03 12:51:56'),(60862,171,'Janau Khari','331303',1,0,'2022-03-03 12:51:56','2022-03-03 12:51:56'),(60863,171,'Jandwa','331022',1,0,'2022-03-03 12:51:56','2022-03-03 12:51:56'),(60864,171,'Jasasar','331001',1,0,'2022-03-03 12:51:56','2022-03-03 12:51:56'),(60865,171,'Jasrasar','331001',1,0,'2022-03-03 12:51:56','2022-03-03 12:51:56'),(60866,171,'Jaswantpura','331303',1,0,'2022-03-03 12:51:56','2022-03-03 12:51:56'),(60867,171,'Jeeli','331518',1,0,'2022-03-03 12:51:56','2022-03-03 12:51:56'),(60868,171,'Jegania','331802',1,0,'2022-03-03 12:51:56','2022-03-03 12:51:56'),(60869,171,'Jetasar','331802',1,0,'2022-03-03 12:51:56','2022-03-03 12:51:56'),(60870,171,'Jharia','331001',1,0,'2022-03-03 12:51:56','2022-03-03 12:51:56'),(60871,171,'Jharsar Chhota','331023',1,0,'2022-03-03 12:51:56','2022-03-03 12:51:56'),(60872,171,'Jharsar Kandhlan','331304',1,0,'2022-03-03 12:51:56','2022-03-03 12:51:56'),(60873,171,'Jigsana Tal','331304',1,0,'2022-03-03 12:51:56','2022-03-03 12:51:56'),(60874,171,'Jindrasar','331507',1,0,'2022-03-03 12:51:57','2022-03-03 12:51:57'),(60875,171,'Jogalsar','331518',1,0,'2022-03-03 12:51:57','2022-03-03 12:51:57'),(60876,171,'Joglia','331802',1,0,'2022-03-03 12:51:57','2022-03-03 12:51:57'),(60877,171,'Jori','331304',1,0,'2022-03-03 12:51:57','2022-03-03 12:51:57'),(60878,171,'Jothran','331304',1,0,'2022-03-03 12:51:57','2022-03-03 12:51:57'),(60879,171,'Kaklasar','331402',1,0,'2022-03-03 12:51:57','2022-03-03 12:51:57'),(60880,171,'Kalana Tal','331303',1,0,'2022-03-03 12:51:57','2022-03-03 12:51:57'),(60881,171,'Kalari','331301',1,0,'2022-03-03 12:51:57','2022-03-03 12:51:57'),(60882,171,'Kalwas','331304',1,0,'2022-03-03 12:51:57','2022-03-03 12:51:57'),(60883,171,'Kalwasia','331411',1,0,'2022-03-03 12:51:57','2022-03-03 12:51:57'),(60884,171,'Kalyanpura','331403',1,0,'2022-03-03 12:51:57','2022-03-03 12:51:57'),(60885,171,'Kalyansar','331518',1,0,'2022-03-03 12:51:57','2022-03-03 12:51:57'),(60886,171,'Kangar','331504',1,0,'2022-03-03 12:51:57','2022-03-03 12:51:57'),(60887,171,'Kanjan','331701',1,0,'2022-03-03 12:51:57','2022-03-03 12:51:57'),(60888,171,'Kanuta','331507',1,0,'2022-03-03 12:51:57','2022-03-03 12:51:57'),(60889,171,'Kanwari','331506',1,0,'2022-03-03 12:51:57','2022-03-03 12:51:57'),(60890,171,'Karansar','331403',1,0,'2022-03-03 12:51:57','2022-03-03 12:51:57'),(60891,171,'Karwasar','331001',1,0,'2022-03-03 12:51:57','2022-03-03 12:51:57'),(60892,171,'Katar Chhoti','331517',1,0,'2022-03-03 12:51:57','2022-03-03 12:51:57'),(60893,171,'Khairubari','331301',1,0,'2022-03-03 12:51:57','2022-03-03 12:51:57'),(60894,171,'Khandwa','331001',1,0,'2022-03-03 12:51:57','2022-03-03 12:51:57'),(60895,171,'Khansoli','331001',1,0,'2022-03-03 12:51:57','2022-03-03 12:51:57'),(60896,171,'Kharia Kaniram','331506',1,0,'2022-03-03 12:51:57','2022-03-03 12:51:57'),(60897,171,'Khejara','331403',1,0,'2022-03-03 12:51:57','2022-03-03 12:51:57'),(60898,171,'Khinchiwala','331506',1,0,'2022-03-03 12:51:57','2022-03-03 12:51:57'),(60899,171,'Khinwasar','331001',1,0,'2022-03-03 12:51:57','2022-03-03 12:51:57'),(60900,171,'Khotari','331022',1,0,'2022-03-03 12:51:58','2022-03-03 12:51:58'),(60901,171,'Khudera Charnan','331022',1,0,'2022-03-03 12:51:58','2022-03-03 12:51:58'),(60902,171,'Khuri','331506',1,0,'2022-03-03 12:51:58','2022-03-03 12:51:58'),(60903,171,'Kohina','331304',1,0,'2022-03-03 12:51:58','2022-03-03 12:51:58'),(60904,171,'Kolasar','331507',1,0,'2022-03-03 12:51:58','2022-03-03 12:51:58'),(60905,171,'Kotwad Tal','331304',1,0,'2022-03-03 12:51:58','2022-03-03 12:51:58'),(60906,171,'Kusumdesar','331022',1,0,'2022-03-03 12:51:58','2022-03-03 12:51:58'),(60907,171,'Lachharsar','331802',1,0,'2022-03-03 12:51:58','2022-03-03 12:51:58'),(60908,171,'Ladhasar','331022',1,0,'2022-03-03 12:51:58','2022-03-03 12:51:58'),(60909,171,'Ladria','331029',1,0,'2022-03-03 12:51:58','2022-03-03 12:51:58'),(60910,171,'Lakhau','331001',1,0,'2022-03-03 12:51:58','2022-03-03 12:51:58'),(60911,171,'Lakhlan','331023',1,0,'2022-03-03 12:51:58','2022-03-03 12:51:58'),(60912,171,'Lalgarh (Churu)','331518',1,0,'2022-03-03 12:51:58','2022-03-03 12:51:58'),(60913,171,'Lambor Bari','331023',1,0,'2022-03-03 12:51:58','2022-03-03 12:51:58'),(60914,171,'Laseri','331023',1,0,'2022-03-03 12:51:58','2022-03-03 12:51:58'),(60915,171,'Lilaki','331023',1,0,'2022-03-03 12:51:58','2022-03-03 12:51:58'),(60916,171,'Lilawati','331303',1,0,'2022-03-03 12:51:58','2022-03-03 12:51:58'),(60917,171,'Lodsar','331507',1,0,'2022-03-03 12:51:58','2022-03-03 12:51:58'),(60918,171,'Loha','331022',1,0,'2022-03-03 12:51:58','2022-03-03 12:51:58'),(60919,171,'Lohsana Bara','331029',1,0,'2022-03-03 12:51:58','2022-03-03 12:51:58'),(60920,171,'Lohsana Chhota','331029',1,0,'2022-03-03 12:51:58','2022-03-03 12:51:58'),(60921,171,'Loonasar','331802',1,0,'2022-03-03 12:51:58','2022-03-03 12:51:58'),(60922,171,'Luhara','331517',1,0,'2022-03-03 12:51:58','2022-03-03 12:51:58'),(60923,171,'Lunchh','331022',1,0,'2022-03-03 12:51:58','2022-03-03 12:51:58'),(60924,171,'Magrasar','331507',1,0,'2022-03-03 12:51:59','2022-03-03 12:51:59'),(60925,171,'Mahalana Utarada','331023',1,0,'2022-03-03 12:51:59','2022-03-03 12:51:59'),(60926,171,'Mainasar','331506',1,0,'2022-03-03 12:51:59','2022-03-03 12:51:59'),(60927,171,'Malkasar','331411',1,0,'2022-03-03 12:51:59','2022-03-03 12:51:59'),(60928,171,'Malsar','331411',1,0,'2022-03-03 12:51:59','2022-03-03 12:51:59'),(60929,171,'Malsisar','331507',1,0,'2022-03-03 12:51:59','2022-03-03 12:51:59'),(60930,171,'Malwas','331701',1,0,'2022-03-03 12:51:59','2022-03-03 12:51:59'),(60931,171,'Meghsar','331302',1,0,'2022-03-03 12:51:59','2022-03-03 12:51:59'),(60932,171,'Meghsar','331021',1,0,'2022-03-03 12:51:59','2022-03-03 12:51:59'),(60933,171,'Mehari Rajviyan','331403',1,0,'2022-03-03 12:51:59','2022-03-03 12:51:59'),(60934,171,'Mehrasar Chachera','331403',1,0,'2022-03-03 12:51:59','2022-03-03 12:51:59'),(60935,171,'Mehrasar Uppadhiyan','331302',1,0,'2022-03-03 12:51:59','2022-03-03 12:51:59'),(60936,171,'Melusar','331022',1,0,'2022-03-03 12:51:59','2022-03-03 12:51:59'),(60937,171,'Melusar','331304',1,0,'2022-03-03 12:51:59','2022-03-03 12:51:59'),(60938,171,'Modawasi','331023',1,0,'2022-03-03 12:51:59','2022-03-03 12:51:59'),(60939,171,'Molisar','331031',1,0,'2022-03-03 12:51:59','2022-03-03 12:51:59'),(60940,171,'Morthal','331029',1,0,'2022-03-03 12:51:59','2022-03-03 12:51:59'),(60941,171,'Moti Chowk Sardarshahr','331403',1,0,'2022-03-03 12:51:59','2022-03-03 12:51:59'),(60942,171,'Mundi Tal','331023',1,0,'2022-03-03 12:51:59','2022-03-03 12:51:59'),(60943,171,'Mundra','331518',1,0,'2022-03-03 12:51:59','2022-03-03 12:51:59'),(60944,171,'Murdakia','331506',1,0,'2022-03-03 12:51:59','2022-03-03 12:51:59'),(60945,171,'Nakrasar','331001',1,0,'2022-03-03 12:51:59','2022-03-03 12:51:59'),(60946,171,'Narwa R.S.','331023',1,0,'2022-03-03 12:51:59','2022-03-03 12:51:59'),(60947,171,'Narwasi Village','331023',1,0,'2022-03-03 12:52:00','2022-03-03 12:52:00'),(60948,171,'Nawan','331301',1,0,'2022-03-03 12:52:00','2022-03-03 12:52:00'),(60949,171,'Naya Bass Sujangarh','331507',1,0,'2022-03-03 12:52:00','2022-03-03 12:52:00'),(60950,171,'Neema','331305',1,0,'2022-03-03 12:52:00','2022-03-03 12:52:00'),(60951,171,'Nesal','331303',1,0,'2022-03-03 12:52:00','2022-03-03 12:52:00'),(60952,171,'Nethwa','331304',1,0,'2022-03-03 12:52:00','2022-03-03 12:52:00'),(60953,171,'Noowan','331022',1,0,'2022-03-03 12:52:00','2022-03-03 12:52:00'),(60954,171,'Norangpura','331303',1,0,'2022-03-03 12:52:00','2022-03-03 12:52:00'),(60955,171,'Norangsar','331506',1,0,'2022-03-03 12:52:00','2022-03-03 12:52:00'),(60956,171,'Nosaria','331022',1,0,'2022-03-03 12:52:00','2022-03-03 12:52:00'),(60957,171,'Nuhand','331305',1,0,'2022-03-03 12:52:00','2022-03-03 12:52:00'),(60958,171,'Nyama','331506',1,0,'2022-03-03 12:52:00','2022-03-03 12:52:00'),(60959,171,'Nyangal Bari','331023',1,0,'2022-03-03 12:52:00','2022-03-03 12:52:00'),(60960,171,'Nyangal Chhoti','331023',1,0,'2022-03-03 12:52:00','2022-03-03 12:52:00'),(60961,171,'Pabusar','331022',1,0,'2022-03-03 12:52:00','2022-03-03 12:52:00'),(60962,171,'Paharsar','331023',1,0,'2022-03-03 12:52:00','2022-03-03 12:52:00'),(60963,171,'Pandreu Tal','331304',1,0,'2022-03-03 12:52:00','2022-03-03 12:52:00'),(60964,171,'Pandreu Tibba','331304',1,0,'2022-03-03 12:52:00','2022-03-03 12:52:00'),(60965,171,'Parawa','331518',1,0,'2022-03-03 12:52:00','2022-03-03 12:52:00'),(60966,171,'Parewara','331517',1,0,'2022-03-03 12:52:00','2022-03-03 12:52:00'),(60967,171,'Parihara (Churu)','331505',1,0,'2022-03-03 12:52:00','2022-03-03 12:52:00'),(60968,171,'Parsneu','331802',1,0,'2022-03-03 12:52:01','2022-03-03 12:52:01'),(60969,171,'Patel Chowk Sadulpur','331023',1,0,'2022-03-03 12:52:01','2022-03-03 12:52:01'),(60970,171,'Patlisar Bara','331403',1,0,'2022-03-03 12:52:01','2022-03-03 12:52:01'),(60971,171,'Payali','331022',1,0,'2022-03-03 12:52:01','2022-03-03 12:52:01'),(60972,171,'Phogan','331402',1,0,'2022-03-03 12:52:01','2022-03-03 12:52:01'),(60973,171,'Pichkai Tal','331403',1,0,'2022-03-03 12:52:01','2022-03-03 12:52:01'),(60974,171,'Pithisar','331001',1,0,'2022-03-03 12:52:01','2022-03-03 12:52:01'),(60975,171,'Power House Ratangarh','331022',1,0,'2022-03-03 12:52:01','2022-03-03 12:52:01'),(60976,171,'Pulasar','331402',1,0,'2022-03-03 12:52:01','2022-03-03 12:52:01'),(60977,171,'Punras','331304',1,0,'2022-03-03 12:52:01','2022-03-03 12:52:01'),(60978,171,'Punsisar','331302',1,0,'2022-03-03 12:52:01','2022-03-03 12:52:01'),(60979,171,'Ragha Chhoti','331023',1,0,'2022-03-03 12:52:01','2022-03-03 12:52:01'),(60980,171,'Raipuria','331031',1,0,'2022-03-03 12:52:01','2022-03-03 12:52:01'),(60981,171,'Raiyatunda','331302',1,0,'2022-03-03 12:52:01','2022-03-03 12:52:01'),(60982,171,'Rajaldesar Bazar','331802',1,0,'2022-03-03 12:52:01','2022-03-03 12:52:01'),(60983,171,'Rajaldesar','331802',1,0,'2022-03-03 12:52:01','2022-03-03 12:52:01'),(60984,171,'Rajas','331304',1,0,'2022-03-03 12:52:01','2022-03-03 12:52:01'),(60985,171,'Rajasar Bikan','331403',1,0,'2022-03-03 12:52:01','2022-03-03 12:52:01'),(60986,171,'Rajiasar','331505',1,0,'2022-03-03 12:52:01','2022-03-03 12:52:01'),(60987,171,'Rajpura','331029',1,0,'2022-03-03 12:52:01','2022-03-03 12:52:01'),(60988,171,'Rampura Bass','331001',1,0,'2022-03-03 12:52:01','2022-03-03 12:52:01'),(60989,171,'Rampura Beri','331301',1,0,'2022-03-03 12:52:01','2022-03-03 12:52:01'),(60990,171,'Ramsara','331001',1,0,'2022-03-03 12:52:02','2022-03-03 12:52:02'),(60991,171,'Ramsara Tal','331701',1,0,'2022-03-03 12:52:02','2022-03-03 12:52:02'),(60992,171,'Ramsisar','331403',1,0,'2022-03-03 12:52:02','2022-03-03 12:52:02'),(60993,171,'Ranasar Bikan','331504',1,0,'2022-03-03 12:52:02','2022-03-03 12:52:02'),(60994,171,'Rangaisar','331403',1,0,'2022-03-03 12:52:02','2022-03-03 12:52:02'),(60995,171,'Ransar','331001',1,0,'2022-03-03 12:52:02','2022-03-03 12:52:02'),(60996,171,'Ransisar','331411',1,0,'2022-03-03 12:52:02','2022-03-03 12:52:02'),(60997,171,'Ratan Nagar','331021',1,0,'2022-03-03 12:52:02','2022-03-03 12:52:02'),(60998,171,'Ratangar RS','331022',1,0,'2022-03-03 12:52:02','2022-03-03 12:52:02'),(60999,171,'Ratangarh H.O','331022',1,0,'2022-03-03 12:52:02','2022-03-03 12:52:02'),(61000,171,'Ratansara','331022',1,0,'2022-03-03 12:52:02','2022-03-03 12:52:02'),(61001,171,'Ratnadesar','331505',1,0,'2022-03-03 12:52:02','2022-03-03 12:52:02'),(61002,171,'Ratusar','331403',1,0,'2022-03-03 12:52:02','2022-03-03 12:52:02'),(61003,171,'Rawantsar Kunjla','331303',1,0,'2022-03-03 12:52:02','2022-03-03 12:52:02'),(61004,171,'Reda','331517',1,0,'2022-03-03 12:52:02','2022-03-03 12:52:02'),(61005,171,'Redi Bhurawas','331304',1,0,'2022-03-03 12:52:02','2022-03-03 12:52:02'),(61006,171,'Roopalisar','331022',1,0,'2022-03-03 12:52:02','2022-03-03 12:52:02'),(61007,171,'Sabji Mandi Sardarshahar','331403',1,0,'2022-03-03 12:52:02','2022-03-03 12:52:02'),(61008,171,'Sadasar','331411',1,0,'2022-03-03 12:52:02','2022-03-03 12:52:02'),(61009,171,'Sadu Bari','331517',1,0,'2022-03-03 12:52:02','2022-03-03 12:52:02'),(61010,171,'Sadulpur City','331023',1,0,'2022-03-03 12:52:02','2022-03-03 12:52:02'),(61011,171,'Sadulpur','331023',1,0,'2022-03-03 12:52:02','2022-03-03 12:52:02'),(61012,171,'Sahanali Bari','331022',1,0,'2022-03-03 12:52:02','2022-03-03 12:52:02'),(61013,171,'Sahjusar','331001',1,0,'2022-03-03 12:52:02','2022-03-03 12:52:02'),(61014,171,'Sahwa','331302',1,0,'2022-03-03 12:52:03','2022-03-03 12:52:03'),(61015,171,'Salasar','331506',1,0,'2022-03-03 12:52:03','2022-03-03 12:52:03'),(61016,171,'Sandan','331506',1,0,'2022-03-03 12:52:03','2022-03-03 12:52:03'),(61017,171,'Sandwa','331517',1,0,'2022-03-03 12:52:03','2022-03-03 12:52:03'),(61018,171,'Sangasar','331022',1,0,'2022-03-03 12:52:03','2022-03-03 12:52:03'),(61019,171,'Sankhan Tal','331303',1,0,'2022-03-03 12:52:03','2022-03-03 12:52:03'),(61020,171,'Sankhu Fort','331303',1,0,'2022-03-03 12:52:03','2022-03-03 12:52:03'),(61021,171,'Sarayan','331304',1,0,'2022-03-03 12:52:03','2022-03-03 12:52:03'),(61022,171,'Sardarpura','331305',1,0,'2022-03-03 12:52:03','2022-03-03 12:52:03'),(61023,171,'Sardarshahar','331403',1,0,'2022-03-03 12:52:03','2022-03-03 12:52:03'),(61024,171,'Sarothia','331518',1,0,'2022-03-03 12:52:03','2022-03-03 12:52:03'),(61025,171,'Sarsar','331402',1,0,'2022-03-03 12:52:03','2022-03-03 12:52:03'),(61026,171,'Satra','331031',1,0,'2022-03-03 12:52:03','2022-03-03 12:52:03'),(61027,171,'Satyun','331029',1,0,'2022-03-03 12:52:03','2022-03-03 12:52:03'),(61028,171,'Sawai Bari','331403',1,0,'2022-03-03 12:52:03','2022-03-03 12:52:03'),(61029,171,'Sehla','331022',1,0,'2022-03-03 12:52:03','2022-03-03 12:52:03'),(61030,171,'Seowa','331304',1,0,'2022-03-03 12:52:03','2022-03-03 12:52:03'),(61031,171,'Shobhasar','331506',1,0,'2022-03-03 12:52:03','2022-03-03 12:52:03'),(61032,171,'Sidhmukh','331701',1,0,'2022-03-03 12:52:03','2022-03-03 12:52:03'),(61033,171,'Simla','331403',1,0,'2022-03-03 12:52:03','2022-03-03 12:52:03'),(61034,171,'Simsia','331802',1,0,'2022-03-03 12:52:03','2022-03-03 12:52:03'),(61035,171,'Sirsala','331029',1,0,'2022-03-03 12:52:03','2022-03-03 12:52:03'),(61036,171,'Sirsali','331029',1,0,'2022-03-03 12:52:03','2022-03-03 12:52:03'),(61037,171,'Sitsar','331506',1,0,'2022-03-03 12:52:03','2022-03-03 12:52:03'),(61038,171,'Somasi','331001',1,0,'2022-03-03 12:52:04','2022-03-03 12:52:04'),(61039,171,'Somasisar','331302',1,0,'2022-03-03 12:52:04','2022-03-03 12:52:04'),(61040,171,'Sonpalsar','331403',1,0,'2022-03-03 12:52:04','2022-03-03 12:52:04'),(61041,171,'Station Road Churu','331001',1,0,'2022-03-03 12:52:04','2022-03-03 12:52:04'),(61042,171,'Sujangarh RS','331507',1,0,'2022-03-03 12:52:04','2022-03-03 12:52:04'),(61043,171,'Sujangarh','331507',1,0,'2022-03-03 12:52:04','2022-03-03 12:52:04'),(61044,171,'Sulkhania','331303',1,0,'2022-03-03 12:52:04','2022-03-03 12:52:04'),(61045,171,'Suratpura','331023',1,0,'2022-03-03 12:52:04','2022-03-03 12:52:04'),(61046,171,'Taranagar Bazar','331304',1,0,'2022-03-03 12:52:04','2022-03-03 12:52:04'),(61047,171,'Taranagar','331304',1,0,'2022-03-03 12:52:04','2022-03-03 12:52:04'),(61048,171,'Tehandesar','331517',1,0,'2022-03-03 12:52:04','2022-03-03 12:52:04'),(61049,171,'Thanmathoi','331023',1,0,'2022-03-03 12:52:04','2022-03-03 12:52:04'),(61050,171,'Thathawata','331022',1,0,'2022-03-03 12:52:04','2022-03-03 12:52:04'),(61051,171,'Thirpali Bari','331305',1,0,'2022-03-03 12:52:04','2022-03-03 12:52:04'),(61052,171,'Tidiasar','331022',1,0,'2022-03-03 12:52:04','2022-03-03 12:52:04'),(61053,171,'Togawas','331304',1,0,'2022-03-03 12:52:04','2022-03-03 12:52:04'),(61054,171,'Tolasar','331411',1,0,'2022-03-03 12:52:04','2022-03-03 12:52:04'),(61055,171,'Udasar Bidawtan','331402',1,0,'2022-03-03 12:52:04','2022-03-03 12:52:04'),(61056,171,'Udsar','331403',1,0,'2022-03-03 12:52:04','2022-03-03 12:52:04'),(61057,171,'Udwala','331517',1,0,'2022-03-03 12:52:04','2022-03-03 12:52:04'),(61058,171,'Untawalia','331021',1,0,'2022-03-03 12:52:04','2022-03-03 12:52:04'),(61059,171,'Utalad','331517',1,0,'2022-03-03 12:52:04','2022-03-03 12:52:04'),(61060,172,'Abhaneri','303326',1,0,'2022-03-03 12:52:05','2022-03-03 12:52:05'),(61061,172,'Achalpura','303502',1,0,'2022-03-03 12:52:05','2022-03-03 12:52:05'),(61062,172,'Aliapara','303315',1,0,'2022-03-03 12:52:05','2022-03-03 12:52:05'),(61063,172,'Alipur','303315',1,0,'2022-03-03 12:52:05','2022-03-03 12:52:05'),(61064,172,'Alooda','303303',1,0,'2022-03-03 12:52:05','2022-03-03 12:52:05'),(61065,172,'Amrabad','303510',1,0,'2022-03-03 12:52:05','2022-03-03 12:52:05'),(61066,172,'Ananantwada','303313',1,0,'2022-03-03 12:52:05','2022-03-03 12:52:05'),(61067,172,'Ancheri','303323',1,0,'2022-03-03 12:52:05','2022-03-03 12:52:05'),(61068,172,'Arniya','303313',1,0,'2022-03-03 12:52:05','2022-03-03 12:52:05'),(61069,172,'Aund Meena','322240',1,0,'2022-03-03 12:52:05','2022-03-03 12:52:05'),(61070,172,'Bada Bujurg','322240',1,0,'2022-03-03 12:52:05','2022-03-03 12:52:05'),(61071,172,'Bada Gaon','322240',1,0,'2022-03-03 12:52:05','2022-03-03 12:52:05'),(61072,172,'Bada Gaon','303303',1,0,'2022-03-03 12:52:05','2022-03-03 12:52:05'),(61073,172,'Badial Kalan','303313',1,0,'2022-03-03 12:52:05','2022-03-03 12:52:05'),(61074,172,'Badiyal Khurd','303313',1,0,'2022-03-03 12:52:05','2022-03-03 12:52:05'),(61075,172,'Badoli','303325',1,0,'2022-03-03 12:52:05','2022-03-03 12:52:05'),(61076,172,'Bagdi','303503',1,0,'2022-03-03 12:52:05','2022-03-03 12:52:05'),(61077,172,'Bahnwata-bhanwati','303325',1,0,'2022-03-03 12:52:05','2022-03-03 12:52:05'),(61078,172,'Balahedi','321608',1,0,'2022-03-03 12:52:05','2022-03-03 12:52:05'),(61079,172,'Balahera','303315',1,0,'2022-03-03 12:52:05','2022-03-03 12:52:05'),(61080,172,'Banawar','321609',1,0,'2022-03-03 12:52:05','2022-03-03 12:52:05'),(61081,172,'Bandikui Jagir','303313',1,0,'2022-03-03 12:52:05','2022-03-03 12:52:05'),(61082,172,'Bandikui Mandi','303313',1,0,'2022-03-03 12:52:05','2022-03-03 12:52:05'),(61083,172,'Bandikui','303313',1,0,'2022-03-03 12:52:05','2022-03-03 12:52:05'),(61084,172,'Bane Ka Barkhera','303304',1,0,'2022-03-03 12:52:05','2022-03-03 12:52:05'),(61085,172,'Baniyana','303303',1,0,'2022-03-03 12:52:06','2022-03-03 12:52:06'),(61086,172,'Banskho','303305',1,0,'2022-03-03 12:52:06','2022-03-03 12:52:06'),(61087,172,'Bapi','303507',1,0,'2022-03-03 12:52:06','2022-03-03 12:52:06'),(61088,172,'Barkhera','321613',1,0,'2022-03-03 12:52:06','2022-03-03 12:52:06'),(61089,172,'Baswa (Dausa)','303327',1,0,'2022-03-03 12:52:06','2022-03-03 12:52:06'),(61090,172,'Bawanpara','303326',1,0,'2022-03-03 12:52:06','2022-03-03 12:52:06'),(61091,172,'Beechha','303510',1,0,'2022-03-03 12:52:06','2022-03-03 12:52:06'),(61092,172,'Behrawanda','303501',1,0,'2022-03-03 12:52:06','2022-03-03 12:52:06'),(61093,172,'Bejupada','303315',1,0,'2022-03-03 12:52:06','2022-03-03 12:52:06'),(61094,172,'Bewai','303315',1,0,'2022-03-03 12:52:06','2022-03-03 12:52:06'),(61095,172,'Bhandana','303303',1,0,'2022-03-03 12:52:06','2022-03-03 12:52:06'),(61096,172,'Bhandarej','303501',1,0,'2022-03-03 12:52:06','2022-03-03 12:52:06'),(61097,172,'Bhandari','303326',1,0,'2022-03-03 12:52:06','2022-03-03 12:52:06'),(61098,172,'Bhandeda','303313',1,0,'2022-03-03 12:52:06','2022-03-03 12:52:06'),(61099,172,'Bhankari','303303',1,0,'2022-03-03 12:52:06','2022-03-03 12:52:06'),(61100,172,'Bhateri','303004',1,0,'2022-03-03 12:52:06','2022-03-03 12:52:06'),(61101,172,'Bhurla','303004',1,0,'2022-03-03 12:52:06','2022-03-03 12:52:06'),(61102,172,'Bidarkhan','303510',1,0,'2022-03-03 12:52:06','2022-03-03 12:52:06'),(61103,172,'Bilona','303503',1,0,'2022-03-03 12:52:06','2022-03-03 12:52:06'),(61104,172,'Binori','303504',1,0,'2022-03-03 12:52:06','2022-03-03 12:52:06'),(61105,172,'Bishanpura','303507',1,0,'2022-03-03 12:52:06','2022-03-03 12:52:06'),(61106,172,'Boroda','303507',1,0,'2022-03-03 12:52:06','2022-03-03 12:52:06'),(61107,172,'Brahman Bairada','303326',1,0,'2022-03-03 12:52:06','2022-03-03 12:52:06'),(61108,172,'Chandera','303323',1,0,'2022-03-03 12:52:06','2022-03-03 12:52:06'),(61109,172,'Chandera','303509',1,0,'2022-03-03 12:52:07','2022-03-03 12:52:07'),(61110,172,'Chandrana','303303',1,0,'2022-03-03 12:52:07','2022-03-03 12:52:07'),(61111,172,'Chandsen','303503',1,0,'2022-03-03 12:52:07','2022-03-03 12:52:07'),(61112,172,'Chawandeda','303303',1,0,'2022-03-03 12:52:07','2022-03-03 12:52:07'),(61113,172,'Chharda','303505',1,0,'2022-03-03 12:52:07','2022-03-03 12:52:07'),(61114,172,'Chhokarwada','303326',1,0,'2022-03-03 12:52:07','2022-03-03 12:52:07'),(61115,172,'Chondiawas','303503',1,0,'2022-03-03 12:52:07','2022-03-03 12:52:07'),(61116,172,'Churiawas','303505',1,0,'2022-03-03 12:52:07','2022-03-03 12:52:07'),(61117,172,'Collectorate Dausa','303303',1,0,'2022-03-03 12:52:07','2022-03-03 12:52:07'),(61118,172,'Daulatpura','303503',1,0,'2022-03-03 12:52:07','2022-03-03 12:52:07'),(61119,172,'Dausa H.O','303303',1,0,'2022-03-03 12:52:07','2022-03-03 12:52:07'),(61120,172,'Dausa Mandi','303303',1,0,'2022-03-03 12:52:07','2022-03-03 12:52:07'),(61121,172,'Dausa Town','303303',1,0,'2022-03-03 12:52:07','2022-03-03 12:52:07'),(61122,172,'Delari','303313',1,0,'2022-03-03 12:52:07','2022-03-03 12:52:07'),(61123,172,'Denda Basedi','303502',1,0,'2022-03-03 12:52:07','2022-03-03 12:52:07'),(61124,172,'Deoli','303503',1,0,'2022-03-03 12:52:07','2022-03-03 12:52:07'),(61125,172,'Dhanawad','303304',1,0,'2022-03-03 12:52:07','2022-03-03 12:52:07'),(61126,172,'Dhand','322240',1,0,'2022-03-03 12:52:07','2022-03-03 12:52:07'),(61127,172,'Dhigaria Bhim','303315',1,0,'2022-03-03 12:52:07','2022-03-03 12:52:07'),(61128,172,'Dhigariya','303004',1,0,'2022-03-03 12:52:07','2022-03-03 12:52:07'),(61129,172,'Dholkhera','321613',1,0,'2022-03-03 12:52:07','2022-03-03 12:52:07'),(61130,172,'Didwana','303511',1,0,'2022-03-03 12:52:07','2022-03-03 12:52:07'),(61131,172,'Digo','303511',1,0,'2022-03-03 12:52:07','2022-03-03 12:52:07'),(61132,172,'Dob','303505',1,0,'2022-03-03 12:52:07','2022-03-03 12:52:07'),(61133,172,'Dolika','303304',1,0,'2022-03-03 12:52:07','2022-03-03 12:52:07'),(61134,172,'Dubbi','303304',1,0,'2022-03-03 12:52:07','2022-03-03 12:52:07'),(61135,172,'Dugrawata','303004',1,0,'2022-03-03 12:52:08','2022-03-03 12:52:08'),(61136,172,'Dungarpur','303511',1,0,'2022-03-03 12:52:08','2022-03-03 12:52:08'),(61137,172,'Farrashpura','303501',1,0,'2022-03-03 12:52:08','2022-03-03 12:52:08'),(61138,172,'Gadarwada Gujran','303325',1,0,'2022-03-03 12:52:08','2022-03-03 12:52:08'),(61139,172,'Gagwana','321608',1,0,'2022-03-03 12:52:08','2022-03-03 12:52:08'),(61140,172,'Gahnoli','321612',1,0,'2022-03-03 12:52:08','2022-03-03 12:52:08'),(61141,172,'Gandarawa','303501',1,0,'2022-03-03 12:52:08','2022-03-03 12:52:08'),(61142,172,'Gangadwadi','303502',1,0,'2022-03-03 12:52:08','2022-03-03 12:52:08'),(61143,172,'Gangliawas','303510',1,0,'2022-03-03 12:52:08','2022-03-03 12:52:08'),(61144,172,'Garh Himmat Singh','321609',1,0,'2022-03-03 12:52:08','2022-03-03 12:52:08'),(61145,172,'Gazipura','321612',1,0,'2022-03-03 12:52:08','2022-03-03 12:52:08'),(61146,172,'Geejgarh','303502',1,0,'2022-03-03 12:52:08','2022-03-03 12:52:08'),(61147,172,'Gerota','303502',1,0,'2022-03-03 12:52:08','2022-03-03 12:52:08'),(61148,172,'Ghumna','303502',1,0,'2022-03-03 12:52:08','2022-03-03 12:52:08'),(61149,172,'Golada','303315',1,0,'2022-03-03 12:52:08','2022-03-03 12:52:08'),(61150,172,'Gothra','303501',1,0,'2022-03-03 12:52:08','2022-03-03 12:52:08'),(61151,172,'Gudha Ashikpura','303315',1,0,'2022-03-03 12:52:08','2022-03-03 12:52:08'),(61152,172,'Gudha Katla','303323',1,0,'2022-03-03 12:52:08','2022-03-03 12:52:08'),(61153,172,'Gudhliya','303325',1,0,'2022-03-03 12:52:08','2022-03-03 12:52:08'),(61154,172,'Gullana','303327',1,0,'2022-03-03 12:52:08','2022-03-03 12:52:08'),(61155,172,'Gumanpura','303501',1,0,'2022-03-03 12:52:08','2022-03-03 12:52:08'),(61156,172,'Haildena','321609',1,0,'2022-03-03 12:52:08','2022-03-03 12:52:08'),(61157,172,'Hansmahal','303305',1,0,'2022-03-03 12:52:08','2022-03-03 12:52:08'),(61158,172,'Hapawas','303506',1,0,'2022-03-03 12:52:08','2022-03-03 12:52:08'),(61159,172,'Heengwa','303508',1,0,'2022-03-03 12:52:09','2022-03-03 12:52:09'),(61160,172,'Hemlyawala','303302',1,0,'2022-03-03 12:52:09','2022-03-03 12:52:09'),(61161,172,'Hingota','303315',1,0,'2022-03-03 12:52:09','2022-03-03 12:52:09'),(61162,172,'Hingotia','303303',1,0,'2022-03-03 12:52:09','2022-03-03 12:52:09'),(61163,172,'Hodayali','303503',1,0,'2022-03-03 12:52:09','2022-03-03 12:52:09'),(61164,172,'Hurla','321608',1,0,'2022-03-03 12:52:09','2022-03-03 12:52:09'),(61165,172,'Indawa','303511',1,0,'2022-03-03 12:52:09','2022-03-03 12:52:09'),(61166,172,'Jasota','303303',1,0,'2022-03-03 12:52:09','2022-03-03 12:52:09'),(61167,172,'Jatwara','321609',1,0,'2022-03-03 12:52:09','2022-03-03 12:52:09'),(61168,172,'Jaun','303506',1,0,'2022-03-03 12:52:09','2022-03-03 12:52:09'),(61169,172,'Jhajhirampura','303327',1,0,'2022-03-03 12:52:09','2022-03-03 12:52:09'),(61170,172,'Jhanpdawas','303501',1,0,'2022-03-03 12:52:09','2022-03-03 12:52:09'),(61171,172,'Jhapada','303503',1,0,'2022-03-03 12:52:09','2022-03-03 12:52:09'),(61172,172,'Jirota Khurd','303303',1,0,'2022-03-03 12:52:09','2022-03-03 12:52:09'),(61173,172,'Jopada','303501',1,0,'2022-03-03 12:52:09','2022-03-03 12:52:09'),(61174,172,'Kableshwar','303507',1,0,'2022-03-03 12:52:09','2022-03-03 12:52:09'),(61175,172,'Kalakho Ambadi','303501',1,0,'2022-03-03 12:52:09','2022-03-03 12:52:09'),(61176,172,'Kalakho Sadak','303304',1,0,'2022-03-03 12:52:09','2022-03-03 12:52:09'),(61177,172,'Kali Pahadi','303325',1,0,'2022-03-03 12:52:09','2022-03-03 12:52:09'),(61178,172,'Kallawas','303505',1,0,'2022-03-03 12:52:09','2022-03-03 12:52:09'),(61179,172,'Kalota','303325',1,0,'2022-03-03 12:52:09','2022-03-03 12:52:09'),(61180,172,'Kaluwas','303505',1,0,'2022-03-03 12:52:09','2022-03-03 12:52:09'),(61181,172,'Kalwan','303508',1,0,'2022-03-03 12:52:09','2022-03-03 12:52:09'),(61182,172,'Kankariya','303503',1,0,'2022-03-03 12:52:09','2022-03-03 12:52:09'),(61183,172,'Karnawar','303327',1,0,'2022-03-03 12:52:10','2022-03-03 12:52:10'),(61184,172,'Karodi','303509',1,0,'2022-03-03 12:52:10','2022-03-03 12:52:10'),(61185,172,'Kelai','303304',1,0,'2022-03-03 12:52:10','2022-03-03 12:52:10'),(61186,172,'Khanwas','303004',1,0,'2022-03-03 12:52:10','2022-03-03 12:52:10'),(61187,172,'Khatumbar','303511',1,0,'2022-03-03 12:52:10','2022-03-03 12:52:10'),(61188,172,'Khatwa','303503',1,0,'2022-03-03 12:52:10','2022-03-03 12:52:10'),(61189,172,'Khawaraoji','303506',1,0,'2022-03-03 12:52:10','2022-03-03 12:52:10'),(61190,172,'Kherla Khurd','303504',1,0,'2022-03-03 12:52:10','2022-03-03 12:52:10'),(61191,172,'Kherla','322240',1,0,'2022-03-03 12:52:10','2022-03-03 12:52:10'),(61192,172,'Kherwal','303303',1,0,'2022-03-03 12:52:10','2022-03-03 12:52:10'),(61193,172,'Khonchpuri','321608',1,0,'2022-03-03 12:52:10','2022-03-03 12:52:10'),(61194,172,'Khuntla','303326',1,0,'2022-03-03 12:52:10','2022-03-03 12:52:10'),(61195,172,'Khuri Kalan','303507',1,0,'2022-03-03 12:52:10','2022-03-03 12:52:10'),(61196,172,'Khurra','303504',1,0,'2022-03-03 12:52:10','2022-03-03 12:52:10'),(61197,172,'Kishorpura','303504',1,0,'2022-03-03 12:52:10','2022-03-03 12:52:10'),(61198,172,'Kolana','303313',1,0,'2022-03-03 12:52:10','2022-03-03 12:52:10'),(61199,172,'Koliwara','303505',1,0,'2022-03-03 12:52:10','2022-03-03 12:52:10'),(61200,172,'Kolwa Gram','303325',1,0,'2022-03-03 12:52:10','2022-03-03 12:52:10'),(61201,172,'Koondla','322240',1,0,'2022-03-03 12:52:10','2022-03-03 12:52:10'),(61202,172,'Kot','321609',1,0,'2022-03-03 12:52:10','2022-03-03 12:52:10'),(61203,172,'Kundal (Dausa)','303325',1,0,'2022-03-03 12:52:10','2022-03-03 12:52:10'),(61204,172,'Kundera Doongar','303508',1,0,'2022-03-03 12:52:11','2022-03-03 12:52:11'),(61205,172,'Kuti Mariyada','303326',1,0,'2022-03-03 12:52:11','2022-03-03 12:52:11'),(61206,172,'Ladi Ka Bas','303303',1,0,'2022-03-03 12:52:11','2022-03-03 12:52:11'),(61207,172,'Lalpura','303503',1,0,'2022-03-03 12:52:11','2022-03-03 12:52:11'),(61208,172,'Lalsot','303503',1,0,'2022-03-03 12:52:11','2022-03-03 12:52:11'),(61209,172,'Lanka','303501',1,0,'2022-03-03 12:52:11','2022-03-03 12:52:11'),(61210,172,'Lawain','303004',1,0,'2022-03-03 12:52:11','2022-03-03 12:52:11'),(61211,172,'Liloj','303313',1,0,'2022-03-03 12:52:11','2022-03-03 12:52:11'),(61212,172,'Lotwara','303509',1,0,'2022-03-03 12:52:11','2022-03-03 12:52:11'),(61213,172,'Mahariya','303504',1,0,'2022-03-03 12:52:11','2022-03-03 12:52:11'),(61214,172,'Mahesara Kalan','303303',1,0,'2022-03-03 12:52:11','2022-03-03 12:52:11'),(61215,172,'Maheshara Khurd','303303',1,0,'2022-03-03 12:52:11','2022-03-03 12:52:11'),(61216,172,'Mahukhera','303315',1,0,'2022-03-03 12:52:11','2022-03-03 12:52:11'),(61217,172,'Mahwa Road','321609',1,0,'2022-03-03 12:52:11','2022-03-03 12:52:11'),(61218,172,'Mahwa','321608',1,0,'2022-03-03 12:52:11','2022-03-03 12:52:11'),(61219,172,'Malarna','303303',1,0,'2022-03-03 12:52:11','2022-03-03 12:52:11'),(61220,172,'Malwas','303505',1,0,'2022-03-03 12:52:11','2022-03-03 12:52:11'),(61221,172,'Mandawar Singh','321609',1,0,'2022-03-03 12:52:11','2022-03-03 12:52:11'),(61222,172,'Mandawari','303504',1,0,'2022-03-03 12:52:11','2022-03-03 12:52:11'),(61223,172,'Manpur (Dausa)','303509',1,0,'2022-03-03 12:52:11','2022-03-03 12:52:11'),(61224,172,'Manpura','303505',1,0,'2022-03-03 12:52:11','2022-03-03 12:52:11'),(61225,172,'Mirjapura','303503',1,0,'2022-03-03 12:52:11','2022-03-03 12:52:11'),(61226,172,'Mochingpura','303501',1,0,'2022-03-03 12:52:11','2022-03-03 12:52:11'),(61227,172,'Muhi','303323',1,0,'2022-03-03 12:52:11','2022-03-03 12:52:11'),(61228,172,'Mundghisya','303313',1,0,'2022-03-03 12:52:11','2022-03-03 12:52:11'),(61229,172,'Mundghisya','303506',1,0,'2022-03-03 12:52:11','2022-03-03 12:52:11'),(61230,172,'Nahira','322240',1,0,'2022-03-03 12:52:12','2022-03-03 12:52:12'),(61231,172,'Namner','303508',1,0,'2022-03-03 12:52:12','2022-03-03 12:52:12'),(61232,172,'Nandera','303313',1,0,'2022-03-03 12:52:12','2022-03-03 12:52:12'),(61233,172,'Nandri','303509',1,0,'2022-03-03 12:52:12','2022-03-03 12:52:12'),(61234,172,'Nangal Bairsi','303303',1,0,'2022-03-03 12:52:12','2022-03-03 12:52:12'),(61235,172,'Nangal Rajawatan','303505',1,0,'2022-03-03 12:52:12','2022-03-03 12:52:12'),(61236,172,'Neemla','303507',1,0,'2022-03-03 12:52:12','2022-03-03 12:52:12'),(61237,172,'Nihalpura','303315',1,0,'2022-03-03 12:52:12','2022-03-03 12:52:12'),(61238,172,'Nirjharna','303503',1,0,'2022-03-03 12:52:12','2022-03-03 12:52:12'),(61239,172,'Nizampura','303511',1,0,'2022-03-03 12:52:12','2022-03-03 12:52:12'),(61240,172,'Norangwada','321608',1,0,'2022-03-03 12:52:12','2022-03-03 12:52:12'),(61241,172,'Pakhar','321613',1,0,'2022-03-03 12:52:12','2022-03-03 12:52:12'),(61242,172,'Palanheda','321612',1,0,'2022-03-03 12:52:12','2022-03-03 12:52:12'),(61243,172,'Pali','321608',1,0,'2022-03-03 12:52:12','2022-03-03 12:52:12'),(61244,172,'Palunda','303505',1,0,'2022-03-03 12:52:12','2022-03-03 12:52:12'),(61245,172,'Pancholi','303509',1,0,'2022-03-03 12:52:12','2022-03-03 12:52:12'),(61246,172,'Panditpura','303313',1,0,'2022-03-03 12:52:12','2022-03-03 12:52:12'),(61247,172,'Paota (Dausa)','321612',1,0,'2022-03-03 12:52:12','2022-03-03 12:52:12'),(61248,172,'Paparda','303506',1,0,'2022-03-03 12:52:12','2022-03-03 12:52:12'),(61249,172,'Patan','303004',1,0,'2022-03-03 12:52:12','2022-03-03 12:52:12'),(61250,172,'Peechupada Khurd','303313',1,0,'2022-03-03 12:52:12','2022-03-03 12:52:12'),(61251,172,'Peechupara Kalan','303326',1,0,'2022-03-03 12:52:12','2022-03-03 12:52:12'),(61252,172,'Peelwa Kalan','303304',1,0,'2022-03-03 12:52:12','2022-03-03 12:52:12'),(61253,172,'Peepalki','303509',1,0,'2022-03-03 12:52:12','2022-03-03 12:52:12'),(61254,172,'Pratappura','303313',1,0,'2022-03-03 12:52:13','2022-03-03 12:52:13'),(61255,172,'Pundarpada','303509',1,0,'2022-03-03 12:52:13','2022-03-03 12:52:13'),(61256,172,'Rahuwas','303505',1,0,'2022-03-03 12:52:13','2022-03-03 12:52:13'),(61257,172,'Rajoli','303511',1,0,'2022-03-03 12:52:13','2022-03-03 12:52:13'),(61258,172,'Rajwas','303004',1,0,'2022-03-03 12:52:13','2022-03-03 12:52:13'),(61259,172,'Ralawata','303501',1,0,'2022-03-03 12:52:13','2022-03-03 12:52:13'),(61260,172,'Ralawata','303313',1,0,'2022-03-03 12:52:13','2022-03-03 12:52:13'),(61261,172,'Ramgarh','321608',1,0,'2022-03-03 12:52:13','2022-03-03 12:52:13'),(61262,172,'Ramgarh Pachwara','303510',1,0,'2022-03-03 12:52:13','2022-03-03 12:52:13'),(61263,172,'Ranoli','303501',1,0,'2022-03-03 12:52:13','2022-03-03 12:52:13'),(61264,172,'Rasidpur','321613',1,0,'2022-03-03 12:52:13','2022-03-03 12:52:13'),(61265,172,'Reendali','321609',1,0,'2022-03-03 12:52:13','2022-03-03 12:52:13'),(61266,172,'Reta','303304',1,0,'2022-03-03 12:52:13','2022-03-03 12:52:13'),(61267,172,'Rontehdiya','321608',1,0,'2022-03-03 12:52:13','2022-03-03 12:52:13'),(61268,172,'Sainthal','303507',1,0,'2022-03-03 12:52:13','2022-03-03 12:52:13'),(61269,172,'Salampura','321608',1,0,'2022-03-03 12:52:13','2022-03-03 12:52:13'),(61270,172,'Salempura','303511',1,0,'2022-03-03 12:52:13','2022-03-03 12:52:13'),(61271,172,'Salempura Chowki','322240',1,0,'2022-03-03 12:52:13','2022-03-03 12:52:13'),(61272,172,'Samleti','321608',1,0,'2022-03-03 12:52:13','2022-03-03 12:52:13'),(61273,172,'Santha','321612',1,0,'2022-03-03 12:52:14','2022-03-03 12:52:14'),(61274,172,'Sanwasa','303503',1,0,'2022-03-03 12:52:14','2022-03-03 12:52:14'),(61275,172,'Shabdawali','303327',1,0,'2022-03-03 12:52:14','2022-03-03 12:52:14'),(61276,172,'Shalawas Kalan','303313',1,0,'2022-03-03 12:52:14','2022-03-03 12:52:14'),(61277,172,'Shekhpura','303501',1,0,'2022-03-03 12:52:14','2022-03-03 12:52:14'),(61278,172,'Shivsinghpura','303503',1,0,'2022-03-03 12:52:14','2022-03-03 12:52:14'),(61279,172,'Shyalawas Kalan','303506',1,0,'2022-03-03 12:52:14','2022-03-03 12:52:14'),(61280,172,'Shyalawas Khurd','303313',1,0,'2022-03-03 12:52:14','2022-03-03 12:52:14'),(61281,172,'Shyampura Kalan','303510',1,0,'2022-03-03 12:52:14','2022-03-03 12:52:14'),(61282,172,'Sikandra (Dausa)','303326',1,0,'2022-03-03 12:52:14','2022-03-03 12:52:14'),(61283,172,'Sikrai','303508',1,0,'2022-03-03 12:52:14','2022-03-03 12:52:14'),(61284,172,'Sindoli','303325',1,0,'2022-03-03 12:52:14','2022-03-03 12:52:14'),(61285,172,'Srimaa','303503',1,0,'2022-03-03 12:52:14','2022-03-03 12:52:14'),(61286,172,'Sudharanpada','303315',1,0,'2022-03-03 12:52:14','2022-03-03 12:52:14'),(61287,172,'Sumel','303503',1,0,'2022-03-03 12:52:14','2022-03-03 12:52:14'),(61288,172,'Surajpura','303303',1,0,'2022-03-03 12:52:14','2022-03-03 12:52:14'),(61289,172,'Suratpura','303504',1,0,'2022-03-03 12:52:14','2022-03-03 12:52:14'),(61290,172,'Talab Gaon','303503',1,0,'2022-03-03 12:52:14','2022-03-03 12:52:14'),(61291,172,'Talchidi','322240',1,0,'2022-03-03 12:52:14','2022-03-03 12:52:14'),(61292,172,'Thikriya','303509',1,0,'2022-03-03 12:52:14','2022-03-03 12:52:14'),(61293,172,'Thumdi','303506',1,0,'2022-03-03 12:52:14','2022-03-03 12:52:14'),(61294,172,'Thuni Dhirajpura','303503',1,0,'2022-03-03 12:52:14','2022-03-03 12:52:14'),(61295,172,'Titarwada Kalan','303325',1,0,'2022-03-03 12:52:15','2022-03-03 12:52:15'),(61296,172,'Toda Thekla','303504',1,0,'2022-03-03 12:52:15','2022-03-03 12:52:15'),(61297,172,'Torda','303501',1,0,'2022-03-03 12:52:15','2022-03-03 12:52:15'),(61298,172,'Tudiyana','321608',1,0,'2022-03-03 12:52:15','2022-03-03 12:52:15'),(61299,172,'Udawala','303507',1,0,'2022-03-03 12:52:15','2022-03-03 12:52:15'),(61300,172,'Unbadagaon','303313',1,0,'2022-03-03 12:52:15','2022-03-03 12:52:15'),(61301,172,'Unkroond','321613',1,0,'2022-03-03 12:52:15','2022-03-03 12:52:15'),(61302,172,'Vishala','321608',1,0,'2022-03-03 12:52:15','2022-03-03 12:52:15'),(61303,173,'Afjalpur','328041',1,0,'2022-03-03 12:52:15','2022-03-03 12:52:15'),(61304,173,'Aligarh','328021',1,0,'2022-03-03 12:52:15','2022-03-03 12:52:15'),(61305,173,'Ambarpur','328025',1,0,'2022-03-03 12:52:15','2022-03-03 12:52:15'),(61306,173,'Angai','328031',1,0,'2022-03-03 12:52:15','2022-03-03 12:52:15'),(61307,173,'Atarsuma','328022',1,0,'2022-03-03 12:52:15','2022-03-03 12:52:15'),(61308,173,'Badretha','328041',1,0,'2022-03-03 12:52:15','2022-03-03 12:52:15'),(61309,173,'Bagcholi Khar','328024',1,0,'2022-03-03 12:52:15','2022-03-03 12:52:15'),(61310,173,'Bagthar','328022',1,0,'2022-03-03 12:52:15','2022-03-03 12:52:15'),(61311,173,'Bahadurpur','328021',1,0,'2022-03-03 12:52:15','2022-03-03 12:52:15'),(61312,173,'Bajna','328025',1,0,'2022-03-03 12:52:15','2022-03-03 12:52:15'),(61313,173,'Barai','328022',1,0,'2022-03-03 12:52:15','2022-03-03 12:52:15'),(61314,173,'Barauli (Dholpur)','328031',1,0,'2022-03-03 12:52:15','2022-03-03 12:52:15'),(61315,173,'Barehmori','328001',1,0,'2022-03-03 12:52:15','2022-03-03 12:52:15'),(61316,173,'Baretha','328024',1,0,'2022-03-03 12:52:15','2022-03-03 12:52:15'),(61317,173,'Bari Rs','328021',1,0,'2022-03-03 12:52:15','2022-03-03 12:52:15'),(61318,173,'Bari','328021',1,0,'2022-03-03 12:52:15','2022-03-03 12:52:15'),(61319,173,'Barsala','328025',1,0,'2022-03-03 12:52:15','2022-03-03 12:52:15'),(61320,173,'Basai Ghiyaram','328025',1,0,'2022-03-03 12:52:16','2022-03-03 12:52:16'),(61321,173,'Basai Kare','328029',1,0,'2022-03-03 12:52:16','2022-03-03 12:52:16'),(61322,173,'Basai Nabab','328023',1,0,'2022-03-03 12:52:16','2022-03-03 12:52:16'),(61323,173,'Basai Samanta','328030',1,0,'2022-03-03 12:52:16','2022-03-03 12:52:16'),(61324,173,'Basainadang','328028',1,0,'2022-03-03 12:52:16','2022-03-03 12:52:16'),(61325,173,'Basaineem','328001',1,0,'2022-03-03 12:52:16','2022-03-03 12:52:16'),(61326,173,'Baseri','328022',1,0,'2022-03-03 12:52:16','2022-03-03 12:52:16'),(61327,173,'Bazariya Dholpur','328001',1,0,'2022-03-03 12:52:16','2022-03-03 12:52:16'),(61328,173,'Bharli','328022',1,0,'2022-03-03 12:52:16','2022-03-03 12:52:16'),(61329,173,'Bhesena','328001',1,0,'2022-03-03 12:52:16','2022-03-03 12:52:16'),(61330,173,'Bichhia','328001',1,0,'2022-03-03 12:52:16','2022-03-03 12:52:16'),(61331,173,'Bijholi','328026',1,0,'2022-03-03 12:52:16','2022-03-03 12:52:16'),(61332,173,'Bijoli','328021',1,0,'2022-03-03 12:52:16','2022-03-03 12:52:16'),(61333,173,'Biloni','328026',1,0,'2022-03-03 12:52:16','2022-03-03 12:52:16'),(61334,173,'Biloni','328030',1,0,'2022-03-03 12:52:16','2022-03-03 12:52:16'),(61335,173,'Bintipura','328024',1,0,'2022-03-03 12:52:16','2022-03-03 12:52:16'),(61336,173,'Boreilly','328027',1,0,'2022-03-03 12:52:16','2022-03-03 12:52:16'),(61337,173,'Bothpura','328024',1,0,'2022-03-03 12:52:16','2022-03-03 12:52:16'),(61338,173,'Chandpura','328026',1,0,'2022-03-03 12:52:16','2022-03-03 12:52:16'),(61339,173,'Chandrawali','328026',1,0,'2022-03-03 12:52:16','2022-03-03 12:52:16'),(61340,173,'Chilachond','328031',1,0,'2022-03-03 12:52:16','2022-03-03 12:52:16'),(61341,173,'Chilpura','328029',1,0,'2022-03-03 12:52:16','2022-03-03 12:52:16'),(61342,173,'Chitora','328027',1,0,'2022-03-03 12:52:16','2022-03-03 12:52:16'),(61343,173,'Civil Court Dholpur','328001',1,0,'2022-03-03 12:52:16','2022-03-03 12:52:16'),(61344,173,'Daupura','328022',1,0,'2022-03-03 12:52:16','2022-03-03 12:52:16'),(61345,173,'Dev Khera','328025',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61346,173,'Dhanora','328021',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61347,173,'Dhimari','328021',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61348,173,'Dholpur H.O','328001',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61349,173,'Dhondi Ka Pura','328025',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61350,173,'Dhorr','328022',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61351,173,'Domai','328026',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61352,173,'Donari','328023',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61353,173,'Dubati','328024',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61354,173,'Dubra','328001',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61355,173,'Ekta','328022',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61356,173,'Faraspura','328029',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61357,173,'Gadhi Sukkha','328041',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61358,173,'Gajpura','328021',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61359,173,'Ganhedi','328025',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61360,173,'Gari Chatola','328030',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61361,173,'Gari Zafar','328025',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61362,173,'Golari','328026',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61363,173,'Gunpur','328029',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61364,173,'Harjupura','328022',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61365,173,'Hathbai','328025',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61366,173,'Hinota','328024',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61367,173,'Jalalpur','328024',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61368,173,'Japawali','328041',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61369,173,'Jarga','328022',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61370,173,'Jasupura','328024',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61371,173,'Jatoli','328001',1,0,'2022-03-03 12:52:17','2022-03-03 12:52:17'),(61372,173,'Jetpur','328029',1,0,'2022-03-03 12:52:18','2022-03-03 12:52:18'),(61373,173,'Jhiri','328026',1,0,'2022-03-03 12:52:18','2022-03-03 12:52:18'),(61374,173,'Jirauli','328001',1,0,'2022-03-03 12:52:18','2022-03-03 12:52:18'),(61375,173,'Kanasil','328027',1,0,'2022-03-03 12:52:18','2022-03-03 12:52:18'),(61376,173,'Kanchanpur (Dholpur)','328041',1,0,'2022-03-03 12:52:18','2022-03-03 12:52:18'),(61377,173,'Kansotikhera','328021',1,0,'2022-03-03 12:52:18','2022-03-03 12:52:18'),(61378,173,'Karkakherli','328029',1,0,'2022-03-03 12:52:18','2022-03-03 12:52:18'),(61379,173,'Kasimpur','328001',1,0,'2022-03-03 12:52:18','2022-03-03 12:52:18'),(61380,173,'Kathoomari','328029',1,0,'2022-03-03 12:52:18','2022-03-03 12:52:18'),(61381,173,'Kenthari','328027',1,0,'2022-03-03 12:52:18','2022-03-03 12:52:18'),(61382,173,'Keshar Bagh','328028',1,0,'2022-03-03 12:52:18','2022-03-03 12:52:18'),(61383,173,'Khanpur Meena','328021',1,0,'2022-03-03 12:52:18','2022-03-03 12:52:18'),(61384,173,'Khanpura','328025',1,0,'2022-03-03 12:52:18','2022-03-03 12:52:18'),(61385,173,'Kharagpur','328023',1,0,'2022-03-03 12:52:18','2022-03-03 12:52:18'),(61386,173,'Kharauli','328026',1,0,'2022-03-03 12:52:18','2022-03-03 12:52:18'),(61387,173,'Kherli','328024',1,0,'2022-03-03 12:52:18','2022-03-03 12:52:18'),(61388,173,'Khidora','328022',1,0,'2022-03-03 12:52:18','2022-03-03 12:52:18'),(61389,173,'Khori Ibrahimpur','328022',1,0,'2022-03-03 12:52:18','2022-03-03 12:52:18'),(61390,173,'Khudila','328025',1,0,'2022-03-03 12:52:18','2022-03-03 12:52:18'),(61391,173,'Kolari','328023',1,0,'2022-03-03 12:52:18','2022-03-03 12:52:18'),(61392,173,'Kolua','328030',1,0,'2022-03-03 12:52:18','2022-03-03 12:52:18'),(61393,173,'Kotpura','328024',1,0,'2022-03-03 12:52:18','2022-03-03 12:52:18'),(61394,173,'Kotra','328028',1,0,'2022-03-03 12:52:18','2022-03-03 12:52:18'),(61395,173,'Kunkuta','328027',1,0,'2022-03-03 12:52:19','2022-03-03 12:52:19'),(61396,173,'Kurenda','328023',1,0,'2022-03-03 12:52:19','2022-03-03 12:52:19'),(61397,173,'Kurenda','328041',1,0,'2022-03-03 12:52:19','2022-03-03 12:52:19'),(61398,173,'Lajjakigarhi','328027',1,0,'2022-03-03 12:52:19','2022-03-03 12:52:19'),(61399,173,'Lakhepura','328041',1,0,'2022-03-03 12:52:19','2022-03-03 12:52:19'),(61400,173,'Lalpur Rehsena','328029',1,0,'2022-03-03 12:52:19','2022-03-03 12:52:19'),(61401,173,'Lilothi Jhala','328031',1,0,'2022-03-03 12:52:19','2022-03-03 12:52:19'),(61402,173,'Machhariya','328025',1,0,'2022-03-03 12:52:19','2022-03-03 12:52:19'),(61403,173,'Madanpur','328026',1,0,'2022-03-03 12:52:19','2022-03-03 12:52:19'),(61404,173,'Madha Kankoli','328027',1,0,'2022-03-03 12:52:19','2022-03-03 12:52:19'),(61405,173,'Madhabhau','328029',1,0,'2022-03-03 12:52:19','2022-03-03 12:52:19'),(61406,173,'Madhasil','328026',1,0,'2022-03-03 12:52:19','2022-03-03 12:52:19'),(61407,173,'Mahmadpur','328001',1,0,'2022-03-03 12:52:19','2022-03-03 12:52:19'),(61408,173,'Mahu Gulawali','328022',1,0,'2022-03-03 12:52:19','2022-03-03 12:52:19'),(61409,173,'Mahua Kheda','328041',1,0,'2022-03-03 12:52:19','2022-03-03 12:52:19'),(61410,173,'Maloni Khurd','328030',1,0,'2022-03-03 12:52:19','2022-03-03 12:52:19'),(61411,173,'Maloni Panwar','328023',1,0,'2022-03-03 12:52:19','2022-03-03 12:52:19'),(61412,173,'Mamodhan','328022',1,0,'2022-03-03 12:52:19','2022-03-03 12:52:19'),(61413,173,'Mangrol','328024',1,0,'2022-03-03 12:52:19','2022-03-03 12:52:19'),(61414,173,'Maniya','328024',1,0,'2022-03-03 12:52:19','2022-03-03 12:52:19'),(61415,173,'Manpur','328030',1,0,'2022-03-03 12:52:19','2022-03-03 12:52:19'),(61416,173,'Marena','328029',1,0,'2022-03-03 12:52:19','2022-03-03 12:52:19'),(61417,173,'Marholi','328041',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61418,173,'Matsura','328021',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61419,173,'Mauja Ka Nagla','328024',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61420,173,'Mehandpur','328029',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61421,173,'Mithawali','328025',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61422,173,'Moroli','328001',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61423,173,'Mudik','328022',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61424,173,'Nadanpur','328022',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61425,173,'Nadoli','328025',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61426,173,'Nagala Bidhora','328041',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61427,173,'Nagar','328028',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61428,173,'Nagar','328025',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61429,173,'Nagla Dulhe Khan','328041',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61430,173,'Nahila','328025',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61431,173,'Naksoda','328021',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61432,173,'Neem Khera','328027',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61433,173,'New Bus Stand Dholpur','328001',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61434,173,'Nidhara','328023',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61435,173,'Nidhara','328021',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61436,173,'Norha','328041',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61437,173,'Nunhera','328027',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61438,173,'Odi','328001',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61439,173,'Padampura','328026',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61440,173,'Pahari','328029',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61441,173,'Pakkapura','328029',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61442,173,'Panch Gaon','328030',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61443,173,'Piphera','328023',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61444,173,'Pipraua','328023',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61445,173,'Pipron','328022',1,0,'2022-03-03 12:52:20','2022-03-03 12:52:20'),(61446,173,'Poonthpura','328022',1,0,'2022-03-03 12:52:21','2022-03-03 12:52:21'),(61447,173,'Purani Chhawani','328030',1,0,'2022-03-03 12:52:21','2022-03-03 12:52:21'),(61448,173,'Pureni','328030',1,0,'2022-03-03 12:52:21','2022-03-03 12:52:21'),(61449,173,'Rahrai','328031',1,0,'2022-03-03 12:52:21','2022-03-03 12:52:21'),(61450,173,'Rajakhera','328025',1,0,'2022-03-03 12:52:21','2022-03-03 12:52:21'),(61451,173,'Rajaura Kalan','328027',1,0,'2022-03-03 12:52:21','2022-03-03 12:52:21'),(61452,173,'Rajaura Khurd','328027',1,0,'2022-03-03 12:52:21','2022-03-03 12:52:21'),(61453,173,'Ratanpur','328022',1,0,'2022-03-03 12:52:21','2022-03-03 12:52:21'),(61454,173,'Rupaspur','328021',1,0,'2022-03-03 12:52:21','2022-03-03 12:52:21'),(61455,173,'Sabji Mandi Dholpur','328001',1,0,'2022-03-03 12:52:21','2022-03-03 12:52:21'),(61456,173,'Sadikpur','328001',1,0,'2022-03-03 12:52:21','2022-03-03 12:52:21'),(61457,173,'Sahapura','328024',1,0,'2022-03-03 12:52:21','2022-03-03 12:52:21'),(61458,173,'Sahedi','328021',1,0,'2022-03-03 12:52:21','2022-03-03 12:52:21'),(61459,173,'Sahrauli','328027',1,0,'2022-03-03 12:52:21','2022-03-03 12:52:21'),(61460,173,'Saipau','328027',1,0,'2022-03-03 12:52:21','2022-03-03 12:52:21'),(61461,173,'Sakhwara','328023',1,0,'2022-03-03 12:52:21','2022-03-03 12:52:21'),(61462,173,'Salemabad','328021',1,0,'2022-03-03 12:52:21','2022-03-03 12:52:21'),(61463,173,'Salempur','328022',1,0,'2022-03-03 12:52:21','2022-03-03 12:52:21'),(61464,173,'Samliyapura','328025',1,0,'2022-03-03 12:52:21','2022-03-03 12:52:21'),(61465,173,'Samona','328025',1,0,'2022-03-03 12:52:21','2022-03-03 12:52:21'),(61466,173,'Samor (Marena)','328029',1,0,'2022-03-03 12:52:21','2022-03-03 12:52:21'),(61467,173,'Sandey','328001',1,0,'2022-03-03 12:52:21','2022-03-03 12:52:21'),(61468,173,'Sanora','328031',1,0,'2022-03-03 12:52:21','2022-03-03 12:52:21'),(61469,173,'Sarani Khera','328030',1,0,'2022-03-03 12:52:21','2022-03-03 12:52:21'),(61470,173,'Sarmathura','328026',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61471,173,'Sikroda','328025',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61472,173,'Silawat','328025',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61473,173,'Singhawali','328025',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61474,173,'Singorai','328021',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61475,173,'Siyasat Nagar','328023',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61476,173,'Sohan','328041',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61477,173,'Sone Ka Gurja','328021',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61478,173,'Tagawali','328001',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61479,173,'Tajpur','328022',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61480,173,'Tanda','328024',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61481,173,'Tasimo','328027',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61482,173,'Tehri','328030',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61483,173,'Tontari','328021',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61484,173,'Tor','328001',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61485,173,'Udaibhan Ganj Dholpur','328001',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61486,173,'Umreh','328021',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61487,173,'Varipura','328028',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61488,173,'Viparpur','328024',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61489,173,'Virondha','328024',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61490,173,'Visnoda','328028',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61491,174,'Akhaipur','314024',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61492,174,'Amaritia','314021',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61493,174,'Ambada','314027',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61494,174,'Ambada','314030',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61495,174,'Amzara','314801',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61496,174,'Antri (Dungarpur)','314037',1,0,'2022-03-03 12:52:22','2022-03-03 12:52:22'),(61497,174,'Ara','314025',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61498,174,'Asela','314036',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61499,174,'Aspur','314021',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61500,174,'Baba Ki Bar','314035',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61501,174,'Badgama','314030',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61502,174,'Badi Likhi','314403',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61503,174,'Bageri','314031',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61504,174,'Balota','314037',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61505,174,'Balwara','314804',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61506,174,'Bandela','314406',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61507,174,'Bankora','314023',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61508,174,'Bankra','314406',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61509,174,'Bansia','314402',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61510,174,'Bara','314011',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61511,174,'Barbudnia','314401',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61512,174,'Baroda','314038',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61513,174,'Barothi','314801',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61514,174,'Barsinghpur','314025',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61515,174,'Bawadi','314030',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61516,174,'Beejawara','314029',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61517,174,'Bera','314404',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61518,174,'Bhachdhia','314406',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61519,174,'Bhakhrad','314022',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61520,174,'Bhamai','314035',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61521,174,'Bharga','314022',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61522,174,'Bhasore','314023',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61523,174,'Bhesara Bara','314035',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61524,174,'Bhiluda','314031',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61525,174,'Bhinda','314404',1,0,'2022-03-03 12:52:23','2022-03-03 12:52:23'),(61526,174,'Bhiyana','314804',1,0,'2022-03-03 12:52:24','2022-03-03 12:52:24'),(61527,174,'Bhiyodi','314038',1,0,'2022-03-03 12:52:24','2022-03-03 12:52:24'),(61528,174,'Bhojato Ka Oda','314034',1,0,'2022-03-03 12:52:24','2022-03-03 12:52:24'),(61529,174,'Bichhiwara','314801',1,0,'2022-03-03 12:52:24','2022-03-03 12:52:24'),(61530,174,'Biladi','314001',1,0,'2022-03-03 12:52:24','2022-03-03 12:52:24'),(61531,174,'Bilia Badgama','314037',1,0,'2022-03-03 12:52:24','2022-03-03 12:52:24'),(61532,174,'Biloora','314022',1,0,'2022-03-03 12:52:24','2022-03-03 12:52:24'),(61533,174,'Bodamali','314402',1,0,'2022-03-03 12:52:24','2022-03-03 12:52:24'),(61534,174,'Bodigama Kalan','314038',1,0,'2022-03-03 12:52:24','2022-03-03 12:52:24'),(61535,174,'Bokhla','314011',1,0,'2022-03-03 12:52:24','2022-03-03 12:52:24'),(61536,174,'Bori','314804',1,0,'2022-03-03 12:52:24','2022-03-03 12:52:24'),(61537,174,'Borigama Chhota','314038',1,0,'2022-03-03 12:52:24','2022-03-03 12:52:24'),(61538,174,'Chadoli','314027',1,0,'2022-03-03 12:52:24','2022-03-03 12:52:24'),(61539,174,'Charwara','314403',1,0,'2022-03-03 12:52:24','2022-03-03 12:52:24'),(61540,174,'Chhapi','314801',1,0,'2022-03-03 12:52:24','2022-03-03 12:52:24'),(61541,174,'Chikhli (Dungarpur)','314030',1,0,'2022-03-03 12:52:24','2022-03-03 12:52:24'),(61542,174,'Chitri','314035',1,0,'2022-03-03 12:52:24','2022-03-03 12:52:24'),(61543,174,'Chouki','314037',1,0,'2022-03-03 12:52:24','2022-03-03 12:52:24'),(61544,174,'Chundawada','314801',1,0,'2022-03-03 12:52:24','2022-03-03 12:52:24'),(61545,174,'Daiyana','314027',1,0,'2022-03-03 12:52:24','2022-03-03 12:52:24'),(61546,174,'Damdi','314036',1,0,'2022-03-03 12:52:24','2022-03-03 12:52:24'),(61547,174,'Dariyati','314406',1,0,'2022-03-03 12:52:24','2022-03-03 12:52:24'),(61548,174,'Decha','314401',1,0,'2022-03-03 12:52:24','2022-03-03 12:52:24'),(61549,174,'Deosomnath','314034',1,0,'2022-03-03 12:52:24','2022-03-03 12:52:24'),(61550,174,'Devla','314034',1,0,'2022-03-03 12:52:24','2022-03-03 12:52:24'),(61551,174,'Devpur','314022',1,0,'2022-03-03 12:52:25','2022-03-03 12:52:25'),(61552,174,'Dewal','314011',1,0,'2022-03-03 12:52:25','2022-03-03 12:52:25'),(61553,174,'Dhambola','314402',1,0,'2022-03-03 12:52:25','2022-03-03 12:52:25'),(61554,174,'Dhamod','314801',1,0,'2022-03-03 12:52:25','2022-03-03 12:52:25'),(61555,174,'Dhangaon','314030',1,0,'2022-03-03 12:52:25','2022-03-03 12:52:25'),(61556,174,'Dhatana','314034',1,0,'2022-03-03 12:52:25','2022-03-03 12:52:25'),(61557,174,'Dhavri','314036',1,0,'2022-03-03 12:52:25','2022-03-03 12:52:25'),(61558,174,'Dhodhra','314406',1,0,'2022-03-03 12:52:25','2022-03-03 12:52:25'),(61559,174,'Dhoondhariya','314406',1,0,'2022-03-03 12:52:25','2022-03-03 12:52:25'),(61560,174,'Diwda Bada','314031',1,0,'2022-03-03 12:52:25','2022-03-03 12:52:25'),(61561,174,'Diwda Chhota','314027',1,0,'2022-03-03 12:52:25','2022-03-03 12:52:25'),(61562,174,'Dojapal','314037',1,0,'2022-03-03 12:52:25','2022-03-03 12:52:25'),(61563,174,'Dolpur','314022',1,0,'2022-03-03 12:52:25','2022-03-03 12:52:25'),(61564,174,'Dookan','314406',1,0,'2022-03-03 12:52:25','2022-03-03 12:52:25'),(61565,174,'Doongar','314030',1,0,'2022-03-03 12:52:25','2022-03-03 12:52:25'),(61566,174,'Dowda','314036',1,0,'2022-03-03 12:52:25','2022-03-03 12:52:25'),(61567,174,'Duchiya Bada','314032',1,0,'2022-03-03 12:52:25','2022-03-03 12:52:25'),(61568,174,'Dungarpur Gapsagar','314001',1,0,'2022-03-03 12:52:25','2022-03-03 12:52:25'),(61569,174,'Dungarpur H.O','314001',1,0,'2022-03-03 12:52:25','2022-03-03 12:52:25'),(61570,174,'Dungarsaran','314030',1,0,'2022-03-03 12:52:25','2022-03-03 12:52:25'),(61571,174,'Falonj','314034',1,0,'2022-03-03 12:52:25','2022-03-03 12:52:25'),(61572,174,'Gada Jasrajpur','314035',1,0,'2022-03-03 12:52:25','2022-03-03 12:52:25'),(61573,174,'Gada Jhumji','314032',1,0,'2022-03-03 12:52:25','2022-03-03 12:52:25'),(61574,174,'Gada Kumaria','314023',1,0,'2022-03-03 12:52:25','2022-03-03 12:52:25'),(61575,174,'Gada Moriya','314036',1,0,'2022-03-03 12:52:25','2022-03-03 12:52:25'),(61576,174,'Gada Wasan','314032',1,0,'2022-03-03 12:52:25','2022-03-03 12:52:25'),(61577,174,'Galander','314001',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61578,174,'Galiakot','314026',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61579,174,'Galiana','314023',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61580,174,'Gamdi Ahada','314001',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61581,174,'Gamdi','314022',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61582,174,'Gamdi Deval','314011',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61583,174,'Gamdi Devki','314024',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61584,174,'Gamdi Pal','314011',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61585,174,'Ganda Brahamania','314025',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61586,174,'Gandhwa','314402',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61587,174,'Ganeshpur','314034',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61588,174,'Gara Bejaniya','314029',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61589,174,'Gara Gokal','314403',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61590,174,'Gara Mertiya','314030',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61591,174,'Gardhuna','314011',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61592,174,'Gariyata','314030',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61593,174,'Garmala','314804',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61594,174,'Genji','314404',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61595,174,'Ger','314801',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61596,174,'Ghata','314404',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61597,174,'Ghata Ka Gaon','314027',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61598,174,'Ghotad','314027',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61599,174,'Ghotada','314038',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61600,174,'Ghugra','314804',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61601,174,'Ghuver','314402',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61602,174,'Gol','314021',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61603,174,'Gowadi','314025',1,0,'2022-03-03 12:52:26','2022-03-03 12:52:26'),(61604,174,'Gumanpura','314011',1,0,'2022-03-03 12:52:27','2022-03-03 12:52:27'),(61605,174,'Gundlara','314030',1,0,'2022-03-03 12:52:27','2022-03-03 12:52:27'),(61606,174,'Hadmala','314027',1,0,'2022-03-03 12:52:27','2022-03-03 12:52:27'),(61607,174,'Hathai','314034',1,0,'2022-03-03 12:52:27','2022-03-03 12:52:27'),(61608,174,'Hirata','314037',1,0,'2022-03-03 12:52:27','2022-03-03 12:52:27'),(61609,174,'Indora','314034',1,0,'2022-03-03 12:52:27','2022-03-03 12:52:27'),(61610,174,'Jalap','314403',1,0,'2022-03-03 12:52:27','2022-03-03 12:52:27'),(61611,174,'Jalukuwa','314001',1,0,'2022-03-03 12:52:27','2022-03-03 12:52:27'),(61612,174,'Jasela','314030',1,0,'2022-03-03 12:52:27','2022-03-03 12:52:27'),(61613,174,'Jashpur Jabka','314023',1,0,'2022-03-03 12:52:27','2022-03-03 12:52:27'),(61614,174,'Jethana','314031',1,0,'2022-03-03 12:52:27','2022-03-03 12:52:27'),(61615,174,'Jhalai','314403',1,0,'2022-03-03 12:52:27','2022-03-03 12:52:27'),(61616,174,'Jharani','314406',1,0,'2022-03-03 12:52:27','2022-03-03 12:52:27'),(61617,174,'Jhariyana','314038',1,0,'2022-03-03 12:52:27','2022-03-03 12:52:27'),(61618,174,'Jhontri','314404',1,0,'2022-03-03 12:52:27','2022-03-03 12:52:27'),(61619,174,'Jhosawa','314035',1,0,'2022-03-03 12:52:27','2022-03-03 12:52:27'),(61620,174,'Jogiwara','314022',1,0,'2022-03-03 12:52:27','2022-03-03 12:52:27'),(61621,174,'Jogpur','314035',1,0,'2022-03-03 12:52:27','2022-03-03 12:52:27'),(61622,174,'Jorawarpur','314406',1,0,'2022-03-03 12:52:27','2022-03-03 12:52:27'),(61623,174,'Kabja','314038',1,0,'2022-03-03 12:52:27','2022-03-03 12:52:27'),(61624,174,'Kahela','314029',1,0,'2022-03-03 12:52:27','2022-03-03 12:52:27'),(61625,174,'Kanba','314804',1,0,'2022-03-03 12:52:27','2022-03-03 12:52:27'),(61626,174,'Kanhari','314037',1,0,'2022-03-03 12:52:27','2022-03-03 12:52:27'),(61627,174,'Kanthari','314034',1,0,'2022-03-03 12:52:27','2022-03-03 12:52:27'),(61628,174,'Karada','314024',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61629,174,'Karawada','314402',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61630,174,'Kareliya','314034',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61631,174,'Kariyana','314032',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61632,174,'Karoli','314804',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61633,174,'Kasariya','314035',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61634,174,'Katisor','314038',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61635,174,'Khadagda','314027',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61636,174,'Khadlai','314032',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61637,174,'Khajuri','314801',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61638,174,'Khalil','314023',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61639,174,'Khampur','314034',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61640,174,'Khanan','314022',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61641,174,'Kheda Kachawasa','314036',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61642,174,'Kheda Samor','314034',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61643,174,'Kherasa','314030',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61644,174,'Kherwara','314801',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61645,174,'Kherwara Chela','314001',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61646,174,'Kherwara Sulai','314036',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61647,174,'Khudarda','314021',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61648,174,'Kochri','314030',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61649,174,'Kokapur','314023',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61650,174,'Kolkhanda','314028',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61651,174,'Kuwan','314030',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61652,174,'Lalpani','314038',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61653,174,'Leemri','314027',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61654,174,'Likhatiya ','314035',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61655,174,'Lilwasa','314023',1,0,'2022-03-03 12:52:28','2022-03-03 12:52:28'),(61656,174,'Lodawal','314022',1,0,'2022-03-03 12:52:29','2022-03-03 12:52:29'),(61657,174,'Mada','314001',1,0,'2022-03-03 12:52:29','2022-03-03 12:52:29'),(61658,174,'Mahudipal','314404',1,0,'2022-03-03 12:52:29','2022-03-03 12:52:29'),(61659,174,'Mal','314038',1,0,'2022-03-03 12:52:29','2022-03-03 12:52:29'),(61660,174,'Malakholda','314406',1,0,'2022-03-03 12:52:29','2022-03-03 12:52:29'),(61661,174,'Malmatha','314801',1,0,'2022-03-03 12:52:29','2022-03-03 12:52:29'),(61662,174,'Mandav','314028',1,0,'2022-03-03 12:52:29','2022-03-03 12:52:29'),(61663,174,'Mandli','314403',1,0,'2022-03-03 12:52:29','2022-03-03 12:52:29'),(61664,174,'Mando Ki Pal','314028',1,0,'2022-03-03 12:52:29','2022-03-03 12:52:29'),(61665,174,'Mandwa','314001',1,0,'2022-03-03 12:52:29','2022-03-03 12:52:29'),(61666,174,'Mathugamda','314001',1,0,'2022-03-03 12:52:29','2022-03-03 12:52:29'),(61667,174,'Metali','314001',1,0,'2022-03-03 12:52:29','2022-03-03 12:52:29'),(61668,174,'Mewada','314001',1,0,'2022-03-03 12:52:29','2022-03-03 12:52:29'),(61669,174,'Mewara','314027',1,0,'2022-03-03 12:52:29','2022-03-03 12:52:29'),(61670,174,'Miyala','314022',1,0,'2022-03-03 12:52:29','2022-03-03 12:52:29'),(61671,174,'Modar','314801',1,0,'2022-03-03 12:52:29','2022-03-03 12:52:29'),(61672,174,'Mowai','314023',1,0,'2022-03-03 12:52:29','2022-03-03 12:52:29'),(61673,174,'Munged','314022',1,0,'2022-03-03 12:52:29','2022-03-03 12:52:29'),(61674,174,'Nagria Panchola','314402',1,0,'2022-03-03 12:52:29','2022-03-03 12:52:29'),(61675,174,'Nalwarda','314037',1,0,'2022-03-03 12:52:29','2022-03-03 12:52:29'),(61676,174,'Nandia','314030',1,0,'2022-03-03 12:52:29','2022-03-03 12:52:29'),(61677,174,'Nandli','314022',1,0,'2022-03-03 12:52:29','2022-03-03 12:52:29'),(61678,174,'Nandod','314029',1,0,'2022-03-03 12:52:29','2022-03-03 12:52:29'),(61679,174,'Naraniya','314036',1,0,'2022-03-03 12:52:30','2022-03-03 12:52:30'),(61680,174,'Navalshyam','314804',1,0,'2022-03-03 12:52:30','2022-03-03 12:52:30'),(61681,174,'Nithauva','314022',1,0,'2022-03-03 12:52:30','2022-03-03 12:52:30'),(61682,174,'Nokhna','314029',1,0,'2022-03-03 12:52:30','2022-03-03 12:52:30'),(61683,174,'Nougama','314029',1,0,'2022-03-03 12:52:30','2022-03-03 12:52:30'),(61684,174,'Oad','314024',1,0,'2022-03-03 12:52:30','2022-03-03 12:52:30'),(61685,174,'Obri','314401',1,0,'2022-03-03 12:52:30','2022-03-03 12:52:30'),(61686,174,'Odabada','314804',1,0,'2022-03-03 12:52:30','2022-03-03 12:52:30'),(61687,174,'Odwariya','314034',1,0,'2022-03-03 12:52:30','2022-03-03 12:52:30'),(61688,174,'Pachalasa Bada','314038',1,0,'2022-03-03 12:52:30','2022-03-03 12:52:30'),(61689,174,'Pachlasa Chhota','314038',1,0,'2022-03-03 12:52:30','2022-03-03 12:52:30'),(61690,174,'Padardi Badi','314032',1,0,'2022-03-03 12:52:30','2022-03-03 12:52:30'),(61691,174,'Padra','314024',1,0,'2022-03-03 12:52:30','2022-03-03 12:52:30'),(61692,174,'Padwa (Dungarpur)','314024',1,0,'2022-03-03 12:52:30','2022-03-03 12:52:30'),(61693,174,'Pagara','314036',1,0,'2022-03-03 12:52:30','2022-03-03 12:52:30'),(61694,174,'Pagara','314404',1,0,'2022-03-03 12:52:30','2022-03-03 12:52:30'),(61695,174,'Pal Mathugamda','314001',1,0,'2022-03-03 12:52:30','2022-03-03 12:52:30'),(61696,174,'Pal Nithauwa','314022',1,0,'2022-03-03 12:52:30','2022-03-03 12:52:30'),(61697,174,'Paldeval','314011',1,0,'2022-03-03 12:52:30','2022-03-03 12:52:30'),(61698,174,'Paldhara','314036',1,0,'2022-03-03 12:52:30','2022-03-03 12:52:30'),(61699,174,'Palisoda','314801',1,0,'2022-03-03 12:52:30','2022-03-03 12:52:30'),(61700,174,'Palmavit','314025',1,0,'2022-03-03 12:52:30','2022-03-03 12:52:30'),(61701,174,'Palpadar','314801',1,0,'2022-03-03 12:52:30','2022-03-03 12:52:30'),(61702,174,'Panch Kundli','314030',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61703,174,'Parda Itiwar','314021',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61704,174,'Parda Mataji','314035',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61705,174,'Parda Thoor','314034',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61706,174,'Parlamahtonka','314401',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61707,174,'Peeth','314406',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61708,174,'Pepal Gunj','314401',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61709,174,'Phaota','314401',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61710,174,'Pindawal','314022',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61711,174,'Piplada','314001',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61712,174,'Pohri Khatu','314402',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61713,174,'Pohri Patelan','314402',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61714,174,'Pokhrun','314404',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61715,174,'Punali','314028',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61716,174,'Punawada','314406',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61717,174,'Punjpur','314038',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61718,174,'Ragunathpura','314034',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61719,174,'Raiki','314021',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61720,174,'Rainta','314404',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61721,174,'Raj. Sintex DPR','314001',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61722,174,'Rajpur','314406',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61723,174,'Ramgarh (Dungarpur)','314034',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61724,174,'Rampur Mewada','314001',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61725,174,'Rampur Sati','314011',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61726,174,'Ramsore','314030',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61727,174,'Rasta','314403',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61728,174,'Ratanpur','314801',1,0,'2022-03-03 12:52:31','2022-03-03 12:52:31'),(61729,174,'Rathari','314030',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61730,174,'Ratriya','314035',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61731,174,'Rinchha','314022',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61732,174,'Rohanwara','314001',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61733,174,'Sabla','314022',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61734,174,'Sabli','314804',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61735,174,'Sadaria','314403',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61736,174,'Sagot','314022',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61737,174,'Sagwara Bazar','314025',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61738,174,'Sagwara','314025',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61739,174,'Sakani','314034',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61740,174,'Sakarsi','314403',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61741,174,'Salaj','314037',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61742,174,'Saleda','314030',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61743,174,'Salonj','314022',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61744,174,'Sanchia','314804',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61745,174,'Sansarpu','314404',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61746,174,'Saroda','314032',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61747,174,'Sarthuna','314403',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61748,174,'Savgarh','314034',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61749,174,'Seethal','314403',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61750,174,'Semalia Pandya','314031',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61751,174,'Semaliya','314032',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61752,174,'Semlia Ghata','314027',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61753,174,'Sendola','314030',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61754,174,'Shishod','314011',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61755,174,'Silohi','314026',1,0,'2022-03-03 12:52:32','2022-03-03 12:52:32'),(61756,174,'Simalwara','314403',1,0,'2022-03-03 12:52:33','2022-03-03 12:52:33'),(61757,174,'Somkamla Amba','314021',1,0,'2022-03-03 12:52:33','2022-03-03 12:52:33'),(61758,174,'Sundarpur','314001',1,0,'2022-03-03 12:52:33','2022-03-03 12:52:33'),(61759,174,'Suraj Gaon','314027',1,0,'2022-03-03 12:52:33','2022-03-03 12:52:33'),(61760,174,'Surata','314037',1,0,'2022-03-03 12:52:33','2022-03-03 12:52:33'),(61761,174,'Surpur','314001',1,0,'2022-03-03 12:52:33','2022-03-03 12:52:33'),(61762,174,'Tadi Obri','314011',1,0,'2022-03-03 12:52:33','2022-03-03 12:52:33'),(61763,174,'Talaiya','314801',1,0,'2022-03-03 12:52:33','2022-03-03 12:52:33'),(61764,174,'Talora','314022',1,0,'2022-03-03 12:52:33','2022-03-03 12:52:33'),(61765,174,'Tamboliya','314030',1,0,'2022-03-03 12:52:33','2022-03-03 12:52:33'),(61766,174,'Tamtiya','314029',1,0,'2022-03-03 12:52:33','2022-03-03 12:52:33'),(61767,174,'Teejwar','314001',1,0,'2022-03-03 12:52:33','2022-03-03 12:52:33'),(61768,174,'Thakarda','314029',1,0,'2022-03-03 12:52:33','2022-03-03 12:52:33'),(61769,174,'Thana','314804',1,0,'2022-03-03 12:52:33','2022-03-03 12:52:33'),(61770,174,'Thoorkipal','314034',1,0,'2022-03-03 12:52:33','2022-03-03 12:52:33'),(61771,174,'Tokwasa','314021',1,0,'2022-03-03 12:52:33','2022-03-03 12:52:33'),(61772,174,'Ubli','314035',1,0,'2022-03-03 12:52:33','2022-03-03 12:52:33'),(61773,174,'Underda','314036',1,0,'2022-03-03 12:52:33','2022-03-03 12:52:33'),(61774,174,'Upergaon','314036',1,0,'2022-03-03 12:52:33','2022-03-03 12:52:33'),(61775,174,'Vagdari','314011',1,0,'2022-03-03 12:52:33','2022-03-03 12:52:33'),(61776,174,'Valai','314022',1,0,'2022-03-03 12:52:33','2022-03-03 12:52:33'),(61777,174,'Vamasa','314032',1,0,'2022-03-03 12:52:33','2022-03-03 12:52:33'),(61778,174,'Vandarved','314031',1,0,'2022-03-03 12:52:33','2022-03-03 12:52:33'),(61779,174,'Varda','314029',1,0,'2022-03-03 12:52:33','2022-03-03 12:52:33'),(61780,174,'Vassi','314036',1,0,'2022-03-03 12:52:33','2022-03-03 12:52:33'),(61781,174,'Vasunder Chhoti','314038',1,0,'2022-03-03 12:52:34','2022-03-03 12:52:34'),(61782,174,'Vedsa','314402',1,0,'2022-03-03 12:52:34','2022-03-03 12:52:34'),(61783,174,'Veerpur','314001',1,0,'2022-03-03 12:52:34','2022-03-03 12:52:34'),(61784,174,'Venja','314404',1,0,'2022-03-03 12:52:34','2022-03-03 12:52:34'),(61785,174,'Vikasnagar (Dungarpur)','314404',1,0,'2022-03-03 12:52:34','2022-03-03 12:52:34'),(61786,174,'Virat','314401',1,0,'2022-03-03 12:52:34','2022-03-03 12:52:34'),(61787,174,'Wer','314001',1,0,'2022-03-03 12:52:34','2022-03-03 12:52:34'),(61788,175,'1 Ps','335061',1,0,'2022-03-03 12:52:34','2022-03-03 12:52:34'),(61789,175,'1 Sm','335707',1,0,'2022-03-03 12:52:34','2022-03-03 12:52:34'),(61790,175,'10 Kd','335707',1,0,'2022-03-03 12:52:34','2022-03-03 12:52:34'),(61791,175,'10 Z','335038',1,0,'2022-03-03 12:52:34','2022-03-03 12:52:34'),(61792,175,'10TK','335039',1,0,'2022-03-03 12:52:34','2022-03-03 12:52:34'),(61793,175,'11 Z','335038',1,0,'2022-03-03 12:52:34','2022-03-03 12:52:34'),(61794,175,'11ps','335051',1,0,'2022-03-03 12:52:34','2022-03-03 12:52:34'),(61795,175,'12 Gb','335704',1,0,'2022-03-03 12:52:34','2022-03-03 12:52:34'),(61796,175,'12 H','335711',1,0,'2022-03-03 12:52:34','2022-03-03 12:52:34'),(61797,175,'12 Knd','335707',1,0,'2022-03-03 12:52:34','2022-03-03 12:52:34'),(61798,175,'12 MLD','335707',1,0,'2022-03-03 12:52:34','2022-03-03 12:52:34'),(61799,175,'12z','335001',1,0,'2022-03-03 12:52:34','2022-03-03 12:52:34'),(61800,175,'13 Dol','335707',1,0,'2022-03-03 12:52:34','2022-03-03 12:52:34'),(61801,175,'13 M D','335711',1,0,'2022-03-03 12:52:34','2022-03-03 12:52:34'),(61802,175,'13ff','335040',1,0,'2022-03-03 12:52:34','2022-03-03 12:52:34'),(61803,175,'14 S Majhiwala','335073',1,0,'2022-03-03 12:52:34','2022-03-03 12:52:34'),(61804,175,'14ff','335040',1,0,'2022-03-03 12:52:35','2022-03-03 12:52:35'),(61805,175,'15 Ff','335024',1,0,'2022-03-03 12:52:35','2022-03-03 12:52:35'),(61806,175,'15 \'o\'','335073',1,0,'2022-03-03 12:52:35','2022-03-03 12:52:35'),(61807,175,'15 Z','335001',1,0,'2022-03-03 12:52:35','2022-03-03 12:52:35'),(61808,175,'15blda','335703',1,0,'2022-03-03 12:52:35','2022-03-03 12:52:35'),(61809,175,'15lm','335703',1,0,'2022-03-03 12:52:35','2022-03-03 12:52:35'),(61810,175,'16BB','335041',1,0,'2022-03-03 12:52:35','2022-03-03 12:52:35'),(61811,175,'16ps','335039',1,0,'2022-03-03 12:52:35','2022-03-03 12:52:35'),(61812,175,'17 Gb','335704',1,0,'2022-03-03 12:52:35','2022-03-03 12:52:35'),(61813,175,'19 F','335027',1,0,'2022-03-03 12:52:35','2022-03-03 12:52:35'),(61814,175,'19 Gb','335704',1,0,'2022-03-03 12:52:35','2022-03-03 12:52:35'),(61815,175,'19 Rb','335024',1,0,'2022-03-03 12:52:35','2022-03-03 12:52:35'),(61816,175,'19 Z','335038',1,0,'2022-03-03 12:52:35','2022-03-03 12:52:35'),(61817,175,'19ps','335039',1,0,'2022-03-03 12:52:35','2022-03-03 12:52:35'),(61818,175,'1lsm9(Bada Colony)','335701',1,0,'2022-03-03 12:52:35','2022-03-03 12:52:35'),(61819,175,'2 Ffa','335024',1,0,'2022-03-03 12:52:35','2022-03-03 12:52:35'),(61820,175,'2 Gmb','335707',1,0,'2022-03-03 12:52:35','2022-03-03 12:52:35'),(61821,175,'2 K M','335711',1,0,'2022-03-03 12:52:35','2022-03-03 12:52:35'),(61822,175,'2 Kld','335707',1,0,'2022-03-03 12:52:35','2022-03-03 12:52:35'),(61823,175,'2 Kma','335707',1,0,'2022-03-03 12:52:35','2022-03-03 12:52:35'),(61824,175,'2 V','335027',1,0,'2022-03-03 12:52:35','2022-03-03 12:52:35'),(61825,175,'22 Rjd','335707',1,0,'2022-03-03 12:52:35','2022-03-03 12:52:35'),(61826,175,'22ps','335051',1,0,'2022-03-03 12:52:35','2022-03-03 12:52:35'),(61827,175,'23 Z','335038',1,0,'2022-03-03 12:52:35','2022-03-03 12:52:35'),(61828,175,'23bb','335041',1,0,'2022-03-03 12:52:36','2022-03-03 12:52:36'),(61829,175,'25 Gb','335704',1,0,'2022-03-03 12:52:36','2022-03-03 12:52:36'),(61830,175,'29bb','335041',1,0,'2022-03-03 12:52:36','2022-03-03 12:52:36'),(61831,175,'2a','335703',1,0,'2022-03-03 12:52:36','2022-03-03 12:52:36'),(61832,175,'2rb','335041',1,0,'2022-03-03 12:52:36','2022-03-03 12:52:36'),(61833,175,'3 C Chotti','335038',1,0,'2022-03-03 12:52:36','2022-03-03 12:52:36'),(61834,175,'3 F D M','335705',1,0,'2022-03-03 12:52:36','2022-03-03 12:52:36'),(61835,175,'3 \'o\'','335073',1,0,'2022-03-03 12:52:36','2022-03-03 12:52:36'),(61836,175,'3 Y','335001',1,0,'2022-03-03 12:52:36','2022-03-03 12:52:36'),(61837,175,'31ml','335039',1,0,'2022-03-03 12:52:36','2022-03-03 12:52:36'),(61838,175,'32 Bb','335024',1,0,'2022-03-03 12:52:36','2022-03-03 12:52:36'),(61839,175,'35 Bb','335024',1,0,'2022-03-03 12:52:36','2022-03-03 12:52:36'),(61840,175,'39 Ps','335021',1,0,'2022-03-03 12:52:36','2022-03-03 12:52:36'),(61841,175,'3mk','335039',1,0,'2022-03-03 12:52:36','2022-03-03 12:52:36'),(61842,175,'3nd','335703',1,0,'2022-03-03 12:52:36','2022-03-03 12:52:36'),(61843,175,'4 Bld','335704',1,0,'2022-03-03 12:52:36','2022-03-03 12:52:36'),(61844,175,'4 Jj','335024',1,0,'2022-03-03 12:52:36','2022-03-03 12:52:36'),(61845,175,'40 Gb','335704',1,0,'2022-03-03 12:52:36','2022-03-03 12:52:36'),(61846,175,'40ff','335040',1,0,'2022-03-03 12:52:36','2022-03-03 12:52:36'),(61847,175,'41 Ps','335021',1,0,'2022-03-03 12:52:36','2022-03-03 12:52:36'),(61848,175,'41RB','335041',1,0,'2022-03-03 12:52:36','2022-03-03 12:52:36'),(61849,175,'42 Gb','335704',1,0,'2022-03-03 12:52:36','2022-03-03 12:52:36'),(61850,175,'42 H','335073',1,0,'2022-03-03 12:52:36','2022-03-03 12:52:36'),(61851,175,'47 F','335073',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61852,175,'48gba','335703',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61853,175,'4kpd','335707',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61854,175,'4nn','335041',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61855,175,'5 As','335704',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61856,175,'5 Psd','335707',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61857,175,'50gg','335040',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61858,175,'51gb','335703',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61859,175,'54 Lnp','335061',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61860,175,'56 F','335024',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61861,175,'5eeea','335041',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61862,175,'5nn','335041',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61863,175,'5tk','335039',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61864,175,'6 D D','335711',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61865,175,'6 Gb','335702',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61866,175,'6 \'o\'','335073',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61867,175,'61 F','335073',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61868,175,'61gb','335703',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61869,175,'65gb','335703',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61870,175,'67rb','335051',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61871,175,'68np','335051',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61872,175,'69 Lnp','335061',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61873,175,'6cc','335041',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61874,175,'6tk','335039',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61875,175,'7 Gd','335707',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61876,175,'7 Knd','335707',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61877,175,'7 Lc','335702',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61878,175,'7 Mld','335707',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61879,175,'70gb','335703',1,0,'2022-03-03 12:52:37','2022-03-03 12:52:37'),(61880,175,'71rb','335051',1,0,'2022-03-03 12:52:38','2022-03-03 12:52:38'),(61881,175,'72gb','335703',1,0,'2022-03-03 12:52:38','2022-03-03 12:52:38'),(61882,175,'74gb','335703',1,0,'2022-03-03 12:52:38','2022-03-03 12:52:38'),(61883,175,'78 Gb','335701',1,0,'2022-03-03 12:52:38','2022-03-03 12:52:38'),(61884,175,'8 Spd','335804',1,0,'2022-03-03 12:52:38','2022-03-03 12:52:38'),(61885,175,'8nn','335041',1,0,'2022-03-03 12:52:38','2022-03-03 12:52:38'),(61886,175,'9 Ml','335025',1,0,'2022-03-03 12:52:38','2022-03-03 12:52:38'),(61887,175,'90 Gb','335701',1,0,'2022-03-03 12:52:38','2022-03-03 12:52:38'),(61888,175,'9lm','335703',1,0,'2022-03-03 12:52:38','2022-03-03 12:52:38'),(61889,175,'9ps','335051',1,0,'2022-03-03 12:52:38','2022-03-03 12:52:38'),(61890,175,'Alipura','335062',1,0,'2022-03-03 12:52:38','2022-03-03 12:52:38'),(61891,175,'Anupagarh','335701',1,0,'2022-03-03 12:52:38','2022-03-03 12:52:38'),(61892,175,'Arayan','335027',1,0,'2022-03-03 12:52:38','2022-03-03 12:52:38'),(61893,175,'Badopal','335804',1,0,'2022-03-03 12:52:38','2022-03-03 12:52:38'),(61894,175,'Badopal','335073',1,0,'2022-03-03 12:52:38','2022-03-03 12:52:38'),(61895,175,'Bagicha','335051',1,0,'2022-03-03 12:52:38','2022-03-03 12:52:38'),(61896,175,'Bajuwala','335051',1,0,'2022-03-03 12:52:38','2022-03-03 12:52:38'),(61897,175,'Bakhtana','335038',1,0,'2022-03-03 12:52:38','2022-03-03 12:52:38'),(61898,175,'Bakhtanwali','335025',1,0,'2022-03-03 12:52:38','2022-03-03 12:52:38'),(61899,175,'Banda','335701',1,0,'2022-03-03 12:52:38','2022-03-03 12:52:38'),(61900,175,'Banwali','335062',1,0,'2022-03-03 12:52:38','2022-03-03 12:52:38'),(61901,175,'Baringa','335073',1,0,'2022-03-03 12:52:38','2022-03-03 12:52:38'),(61902,175,'Bhadwanwala','335051',1,0,'2022-03-03 12:52:38','2022-03-03 12:52:38'),(61903,175,'Bhagwansar','335804',1,0,'2022-03-03 12:52:38','2022-03-03 12:52:38'),(61904,175,'Bhatiwala','335701',1,0,'2022-03-03 12:52:38','2022-03-03 12:52:38'),(61905,175,'Bhompura','335051',1,0,'2022-03-03 12:52:39','2022-03-03 12:52:39'),(61906,175,'Bhopalpura','335704',1,0,'2022-03-03 12:52:39','2022-03-03 12:52:39'),(61907,175,'Binjbaila','335041',1,0,'2022-03-03 12:52:39','2022-03-03 12:52:39'),(61908,175,'Birdhwal R.S.(Suratgarh)','335804',1,0,'2022-03-03 12:52:39','2022-03-03 12:52:39'),(61909,175,'Birdwal Head','335804',1,0,'2022-03-03 12:52:39','2022-03-03 12:52:39'),(61910,175,'Birmana','335704',1,0,'2022-03-03 12:52:39','2022-03-03 12:52:39'),(61911,175,'Bishanpura','335021',1,0,'2022-03-03 12:52:39','2022-03-03 12:52:39'),(61912,175,'Block Area','335001',1,0,'2022-03-03 12:52:39','2022-03-03 12:52:39'),(61913,175,'Budharwali','335062',1,0,'2022-03-03 12:52:39','2022-03-03 12:52:39'),(61914,175,'Bugia','335702',1,0,'2022-03-03 12:52:39','2022-03-03 12:52:39'),(61915,175,'Burjwala','335073',1,0,'2022-03-03 12:52:39','2022-03-03 12:52:39'),(61916,175,'Chak 11 G Choti','335022',1,0,'2022-03-03 12:52:39','2022-03-03 12:52:39'),(61917,175,'Chak 13 Lnp','335002',1,0,'2022-03-03 12:52:39','2022-03-03 12:52:39'),(61918,175,'Chak 2 X','335023',1,0,'2022-03-03 12:52:39','2022-03-03 12:52:39'),(61919,175,'Chak 20 GG','335001',1,0,'2022-03-03 12:52:39','2022-03-03 12:52:39'),(61920,175,'Chak 22 A','335701',1,0,'2022-03-03 12:52:39','2022-03-03 12:52:39'),(61921,175,'Chak 24 H','335023',1,0,'2022-03-03 12:52:39','2022-03-03 12:52:39'),(61922,175,'Chak 27 A','335701',1,0,'2022-03-03 12:52:39','2022-03-03 12:52:39'),(61923,175,'Chak 27 Gg','335022',1,0,'2022-03-03 12:52:39','2022-03-03 12:52:39'),(61924,175,'Chak 28 H','335023',1,0,'2022-03-03 12:52:39','2022-03-03 12:52:39'),(61925,175,'Chak 2ll','335002',1,0,'2022-03-03 12:52:39','2022-03-03 12:52:39'),(61926,175,'Chak 30 H','335023',1,0,'2022-03-03 12:52:39','2022-03-03 12:52:39'),(61927,175,'Chak 3h Choti','335022',1,0,'2022-03-03 12:52:39','2022-03-03 12:52:39'),(61928,175,'Chak 4 G Choti','335022',1,0,'2022-03-03 12:52:39','2022-03-03 12:52:39'),(61929,175,'Chak 4bb','335022',1,0,'2022-03-03 12:52:40','2022-03-03 12:52:40'),(61930,175,'Chak 5 E Chhoti','335001',1,0,'2022-03-03 12:52:40','2022-03-03 12:52:40'),(61931,175,'Chak 5 Kk','335022',1,0,'2022-03-03 12:52:40','2022-03-03 12:52:40'),(61932,175,'Chak 5 Ll','335001',1,0,'2022-03-03 12:52:40','2022-03-03 12:52:40'),(61933,175,'Chak 6 G Choti','335022',1,0,'2022-03-03 12:52:40','2022-03-03 12:52:40'),(61934,175,'Chak 75 NP','335021',1,0,'2022-03-03 12:52:40','2022-03-03 12:52:40'),(61935,175,'Chak 86 Gb','335701',1,0,'2022-03-03 12:52:40','2022-03-03 12:52:40'),(61936,175,'Chak KK','335022',1,0,'2022-03-03 12:52:40','2022-03-03 12:52:40'),(61937,175,'Chak15 A','335701',1,0,'2022-03-03 12:52:40','2022-03-03 12:52:40'),(61938,175,'Chakbhagsar','335001',1,0,'2022-03-03 12:52:40','2022-03-03 12:52:40'),(61939,175,'Chhapanwali','335062',1,0,'2022-03-03 12:52:40','2022-03-03 12:52:40'),(61940,175,'Chunawadh','335022',1,0,'2022-03-03 12:52:40','2022-03-03 12:52:40'),(61941,175,'Dabla','335039',1,0,'2022-03-03 12:52:40','2022-03-03 12:52:40'),(61942,175,'Dalianwali','335062',1,0,'2022-03-03 12:52:40','2022-03-03 12:52:40'),(61943,175,'Dalpatsinghpur','335023',1,0,'2022-03-03 12:52:40','2022-03-03 12:52:40'),(61944,175,'Danewala','335073',1,0,'2022-03-03 12:52:40','2022-03-03 12:52:40'),(61945,175,'Daulatpura','335065',1,0,'2022-03-03 12:52:40','2022-03-03 12:52:40'),(61946,175,'Daulatpura','335038',1,0,'2022-03-03 12:52:40','2022-03-03 12:52:40'),(61947,175,'Deidaspura','335804',1,0,'2022-03-03 12:52:40','2022-03-03 12:52:40'),(61948,175,'Delwan','335041',1,0,'2022-03-03 12:52:40','2022-03-03 12:52:40'),(61949,175,'Dhanoor','335023',1,0,'2022-03-03 12:52:40','2022-03-03 12:52:40'),(61950,175,'Dharinganwali','335040',1,0,'2022-03-03 12:52:40','2022-03-03 12:52:40'),(61951,175,'Dharmsinghwala','335002',1,0,'2022-03-03 12:52:40','2022-03-03 12:52:40'),(61952,175,'Dhingawali','335022',1,0,'2022-03-03 12:52:40','2022-03-03 12:52:40'),(61953,175,'Dullapur Kerri','335901',1,0,'2022-03-03 12:52:40','2022-03-03 12:52:40'),(61954,175,'Fakirwali','335041',1,0,'2022-03-03 12:52:41','2022-03-03 12:52:41'),(61955,175,'Fakirwali Kothi','335061',1,0,'2022-03-03 12:52:41','2022-03-03 12:52:41'),(61956,175,'Farm Colony Suratgarh','335804',1,0,'2022-03-03 12:52:41','2022-03-03 12:52:41'),(61957,175,'Fatehpura','335065',1,0,'2022-03-03 12:52:41','2022-03-03 12:52:41'),(61958,175,'Fathui','335001',1,0,'2022-03-03 12:52:41','2022-03-03 12:52:41'),(61959,175,'Fozuwala','335051',1,0,'2022-03-03 12:52:41','2022-03-03 12:52:41'),(61960,175,'Gadderkhera','335062',1,0,'2022-03-03 12:52:41','2022-03-03 12:52:41'),(61961,175,'Gajsinghpur','335024',1,0,'2022-03-03 12:52:41','2022-03-03 12:52:41'),(61962,175,'Ganeshgarh','335025',1,0,'2022-03-03 12:52:41','2022-03-03 12:52:41'),(61963,175,'Ganguwala','335051',1,0,'2022-03-03 12:52:41','2022-03-03 12:52:41'),(61964,175,'Ghamandia','335804',1,0,'2022-03-03 12:52:41','2022-03-03 12:52:41'),(61965,175,'Ghamoorwali','335041',1,0,'2022-03-03 12:52:41','2022-03-03 12:52:41'),(61966,175,'Gharsana','335707',1,0,'2022-03-03 12:52:41','2022-03-03 12:52:41'),(61967,175,'Gomanwali','335703',1,0,'2022-03-03 12:52:41','2022-03-03 12:52:41'),(61968,175,'Goushala Road','335001',1,0,'2022-03-03 12:52:41','2022-03-03 12:52:41'),(61969,175,'Govindpura','335002',1,0,'2022-03-03 12:52:41','2022-03-03 12:52:41'),(61970,175,'Govindsar','335804',1,0,'2022-03-03 12:52:41','2022-03-03 12:52:41'),(61971,175,'Gudhuwala','335022',1,0,'2022-03-03 12:52:41','2022-03-03 12:52:41'),(61972,175,'Gudli','335704',1,0,'2022-03-03 12:52:41','2022-03-03 12:52:41'),(61973,175,'Gulabewala','335027',1,0,'2022-03-03 12:52:41','2022-03-03 12:52:41'),(61974,175,'Gurusar','335027',1,0,'2022-03-03 12:52:41','2022-03-03 12:52:41'),(61975,175,'Hakamabada','335062',1,0,'2022-03-03 12:52:41','2022-03-03 12:52:41'),(61976,175,'Harkhewala','335061',1,0,'2022-03-03 12:52:41','2022-03-03 12:52:41'),(61977,175,'Hindor','335804',1,0,'2022-03-03 12:52:41','2022-03-03 12:52:41'),(61978,175,'Hindumalkote','335901',1,0,'2022-03-03 12:52:41','2022-03-03 12:52:41'),(61979,175,'Indergarh','335062',1,0,'2022-03-03 12:52:42','2022-03-03 12:52:42'),(61980,175,'Jalloki','335041',1,0,'2022-03-03 12:52:42','2022-03-03 12:52:42'),(61981,175,'Jankidaswala','335702',1,0,'2022-03-03 12:52:42','2022-03-03 12:52:42'),(61982,175,'Jetsar Farm','335702',1,0,'2022-03-03 12:52:42','2022-03-03 12:52:42'),(61983,175,'Jetsar','335702',1,0,'2022-03-03 12:52:42','2022-03-03 12:52:42'),(61984,175,'Jhotanwali','335039',1,0,'2022-03-03 12:52:42','2022-03-03 12:52:42'),(61985,175,'Jodhewala','335022',1,0,'2022-03-03 12:52:42','2022-03-03 12:52:42'),(61986,175,'Jorkian','335041',1,0,'2022-03-03 12:52:42','2022-03-03 12:52:42'),(61987,175,'Kalian','335001',1,0,'2022-03-03 12:52:42','2022-03-03 12:52:42'),(61988,175,'Kalyankote','335704',1,0,'2022-03-03 12:52:42','2022-03-03 12:52:42'),(61989,175,'Kaminpura','335027',1,0,'2022-03-03 12:52:42','2022-03-03 12:52:42'),(61990,175,'Kamrania','335701',1,0,'2022-03-03 12:52:42','2022-03-03 12:52:42'),(61991,175,'Karadwala','335062',1,0,'2022-03-03 12:52:42','2022-03-03 12:52:42'),(61992,175,'Karadwali','335051',1,0,'2022-03-03 12:52:42','2022-03-03 12:52:42'),(61993,175,'Kesrisinghpur','335027',1,0,'2022-03-03 12:52:42','2022-03-03 12:52:42'),(61994,175,'Khakhan','335901',1,0,'2022-03-03 12:52:42','2022-03-03 12:52:42'),(61995,175,'Khanuwali','335707',1,0,'2022-03-03 12:52:42','2022-03-03 12:52:42'),(61996,175,'Kharlan','335040',1,0,'2022-03-03 12:52:42','2022-03-03 12:52:42'),(61997,175,'Khatan','335021',1,0,'2022-03-03 12:52:42','2022-03-03 12:52:42'),(61998,175,'Khatlabana','335001',1,0,'2022-03-03 12:52:42','2022-03-03 12:52:42'),(61999,175,'Khatsajwar','335062',1,0,'2022-03-03 12:52:42','2022-03-03 12:52:42'),(62000,175,'Khayaliwala','335002',1,0,'2022-03-03 12:52:42','2022-03-03 12:52:42'),(62001,175,'Khober','335707',1,0,'2022-03-03 12:52:42','2022-03-03 12:52:42'),(62002,175,'Khokharanwali','335701',1,0,'2022-03-03 12:52:42','2022-03-03 12:52:42'),(62003,175,'Khyaliwala','335024',1,0,'2022-03-03 12:52:42','2022-03-03 12:52:42'),(62004,175,'Kikarwali','335051',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62005,175,'Kishanpura Utrada','335062',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62006,175,'Kotha','335901',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62007,175,'Kundlawala','335002',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62008,175,'Kupli','335703',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62009,175,'Ladhuwala','335025',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62010,175,'Lakhahakam','335021',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62011,175,'Lalgarh Jatan','335037',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62012,175,'Likhmewala','335051',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62013,175,'Lilanwali','335065',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62014,175,'Maderan','335001',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62015,175,'Mahaksar','335804',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62016,175,'Mahiyanwali','335002',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62017,175,'Majhiwala','335073',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62018,175,'Maler','335804',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62019,175,'Malerkhera','335065',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62020,175,'Malkana Kalan','335027',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62021,175,'Malkana Khurd','335027',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62022,175,'Manaksar','335065',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62023,175,'Manaktheri','335804',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62024,175,'Mandi Gharsana','335711',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62025,175,'Mandi Sriganganagar','335001',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62026,175,'Manniwali','335062',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62027,175,'Matili Rathan','335038',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62028,175,'Mirzewala','335038',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62029,175,'Mohannagar','335051',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62030,175,'Mohanpura','335001',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62031,175,'Mohlan','335027',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62032,175,'Mokalsar','335804',1,0,'2022-03-03 12:52:43','2022-03-03 12:52:43'),(62033,175,'Mokamwala','335051',1,0,'2022-03-03 12:52:44','2022-03-03 12:52:44'),(62034,175,'Morjand Khari','335037',1,0,'2022-03-03 12:52:44','2022-03-03 12:52:44'),(62035,175,'Motasarkhuni','335024',1,0,'2022-03-03 12:52:44','2022-03-03 12:52:44'),(62036,175,'Mukalawa','335039',1,0,'2022-03-03 12:52:44','2022-03-03 12:52:44'),(62037,175,'Mukan Pabusar','335073',1,0,'2022-03-03 12:52:44','2022-03-03 12:52:44'),(62038,175,'Mukarjee Nagar','335001',1,0,'2022-03-03 12:52:44','2022-03-03 12:52:44'),(62039,175,'Naggi','335073',1,0,'2022-03-03 12:52:44','2022-03-03 12:52:44'),(62040,175,'Nagrana','335065',1,0,'2022-03-03 12:52:44','2022-03-03 12:52:44'),(62041,175,'Nahranwali','335703',1,0,'2022-03-03 12:52:44','2022-03-03 12:52:44'),(62042,175,'Nanuwala','335051',1,0,'2022-03-03 12:52:44','2022-03-03 12:52:44'),(62043,175,'Narsinghpura','335025',1,0,'2022-03-03 12:52:44','2022-03-03 12:52:44'),(62044,175,'Narwana','335804',1,0,'2022-03-03 12:52:44','2022-03-03 12:52:44'),(62045,175,'Natewala','335002',1,0,'2022-03-03 12:52:44','2022-03-03 12:52:44'),(62046,175,'Nathwala','335002',1,0,'2022-03-03 12:52:44','2022-03-03 12:52:44'),(62047,175,'Nizampura','335040',1,0,'2022-03-03 12:52:44','2022-03-03 12:52:44'),(62048,175,'Noorpura','335062',1,0,'2022-03-03 12:52:44','2022-03-03 12:52:44'),(62049,175,'Orki','335901',1,0,'2022-03-03 12:52:44','2022-03-03 12:52:44'),(62050,175,'Padampur','335041',1,0,'2022-03-03 12:52:44','2022-03-03 12:52:44'),(62051,175,'Padampura','335804',1,0,'2022-03-03 12:52:44','2022-03-03 12:52:44'),(62052,175,'Pakki','335901',1,0,'2022-03-03 12:52:44','2022-03-03 12:52:44'),(62053,175,'Panniwali','335037',1,0,'2022-03-03 12:52:44','2022-03-03 12:52:44'),(62054,175,'Patroda','335711',1,0,'2022-03-03 12:52:44','2022-03-03 12:52:44'),(62055,175,'Pharsewala','335061',1,0,'2022-03-03 12:52:44','2022-03-03 12:52:44'),(62056,175,'Phusewala','335038',1,0,'2022-03-03 12:52:44','2022-03-03 12:52:44'),(62057,175,'Purani Abadi','335001',1,0,'2022-03-03 12:52:44','2022-03-03 12:52:44'),(62058,175,'Radewala','335073',1,0,'2022-03-03 12:52:45','2022-03-03 12:52:45'),(62059,175,'Raghunathgarh','335702',1,0,'2022-03-03 12:52:45','2022-03-03 12:52:45'),(62060,175,'Raghunathpura','335704',1,0,'2022-03-03 12:52:45','2022-03-03 12:52:45'),(62061,175,'Raisinghnagar','335051',1,0,'2022-03-03 12:52:45','2022-03-03 12:52:45'),(62062,175,'Rajiasar','335804',1,0,'2022-03-03 12:52:45','2022-03-03 12:52:45'),(62063,175,'Rajpura','335024',1,0,'2022-03-03 12:52:45','2022-03-03 12:52:45'),(62064,175,'Rajpura Pipran','335804',1,0,'2022-03-03 12:52:45','2022-03-03 12:52:45'),(62065,175,'Rampura','335804',1,0,'2022-03-03 12:52:45','2022-03-03 12:52:45'),(62066,175,'Rampura Neola','335804',1,0,'2022-03-03 12:52:45','2022-03-03 12:52:45'),(62067,175,'Ramsara Jakhran','335804',1,0,'2022-03-03 12:52:45','2022-03-03 12:52:45'),(62068,175,'Ramsinghpur','335703',1,0,'2022-03-03 12:52:45','2022-03-03 12:52:45'),(62069,175,'Rasuwala','335062',1,0,'2022-03-03 12:52:45','2022-03-03 12:52:45'),(62070,175,'Ratanpura','335061',1,0,'2022-03-03 12:52:45','2022-03-03 12:52:45'),(62071,175,'Rattewale','335022',1,0,'2022-03-03 12:52:45','2022-03-03 12:52:45'),(62072,175,'Rawla','335707',1,0,'2022-03-03 12:52:45','2022-03-03 12:52:45'),(62073,175,'Rayanwali','335804',1,0,'2022-03-03 12:52:45','2022-03-03 12:52:45'),(62074,175,'Ridmalsar','335061',1,0,'2022-03-03 12:52:45','2022-03-03 12:52:45'),(62075,175,'Rohiranwali Rathan','335001',1,0,'2022-03-03 12:52:45','2022-03-03 12:52:45'),(62076,175,'Rohirawali Suthran','335001',1,0,'2022-03-03 12:52:45','2022-03-03 12:52:45'),(62077,175,'Rojari','335707',1,0,'2022-03-03 12:52:45','2022-03-03 12:52:45'),(62078,175,'Roopnagar','335073',1,0,'2022-03-03 12:52:45','2022-03-03 12:52:45'),(62079,175,'Sadhuwali','335001',1,0,'2022-03-03 12:52:45','2022-03-03 12:52:45'),(62080,175,'Sadulshahar','335062',1,0,'2022-03-03 12:52:45','2022-03-03 12:52:45'),(62081,175,'Sagarwala','335022',1,0,'2022-03-03 12:52:46','2022-03-03 12:52:46'),(62082,175,'Sahibsinghwala','335038',1,0,'2022-03-03 12:52:46','2022-03-03 12:52:46'),(62083,175,'Sahuwala','335001',1,0,'2022-03-03 12:52:46','2022-03-03 12:52:46'),(62084,175,'Sameja(15 PTD)','335021',1,0,'2022-03-03 12:52:46','2022-03-03 12:52:46'),(62085,175,'Sangetpura','335038',1,0,'2022-03-03 12:52:46','2022-03-03 12:52:46'),(62086,175,'Sangrana','335024',1,0,'2022-03-03 12:52:46','2022-03-03 12:52:46'),(62087,175,'Sanwatsar','335041',1,0,'2022-03-03 12:52:46','2022-03-03 12:52:46'),(62088,175,'Sanwatsar','335021',1,0,'2022-03-03 12:52:46','2022-03-03 12:52:46'),(62089,175,'Sardargarh','335705',1,0,'2022-03-03 12:52:46','2022-03-03 12:52:46'),(62090,175,'Sardarpura Bika','335804',1,0,'2022-03-03 12:52:46','2022-03-03 12:52:46'),(62091,175,'Sardpura Jiwan','335037',1,0,'2022-03-03 12:52:46','2022-03-03 12:52:46'),(62092,175,'Sarupsar','335702',1,0,'2022-03-03 12:52:46','2022-03-03 12:52:46'),(62093,175,'Satrana','335711',1,0,'2022-03-03 12:52:46','2022-03-03 12:52:46'),(62094,175,'Satzanda','335051',1,0,'2022-03-03 12:52:46','2022-03-03 12:52:46'),(62095,175,'Shyamgarh','335051',1,0,'2022-03-03 12:52:46','2022-03-03 12:52:46'),(62096,175,'Sihaganwali','335002',1,0,'2022-03-03 12:52:46','2022-03-03 12:52:46'),(62097,175,'Somasar','335804',1,0,'2022-03-03 12:52:46','2022-03-03 12:52:46'),(62098,175,'Sribijaynagar','335704',1,0,'2022-03-03 12:52:46','2022-03-03 12:52:46'),(62099,175,'Sriganganagar H.O','335001',1,0,'2022-03-03 12:52:46','2022-03-03 12:52:46'),(62100,175,'Sriganganagar Rs','335001',1,0,'2022-03-03 12:52:46','2022-03-03 12:52:46'),(62101,175,'Srikaranpur','335073',1,0,'2022-03-03 12:52:46','2022-03-03 12:52:46'),(62102,175,'Srinagar','335040',1,0,'2022-03-03 12:52:46','2022-03-03 12:52:46'),(62103,175,'STPS Suratgarh','335805',1,0,'2022-03-03 12:52:46','2022-03-03 12:52:46'),(62104,175,'Sujawalpur','335901',1,0,'2022-03-03 12:52:46','2022-03-03 12:52:46'),(62105,175,'Sukhchainpura','335051',1,0,'2022-03-03 12:52:46','2022-03-03 12:52:46'),(62106,175,'Suratgarh City','335804',1,0,'2022-03-03 12:52:47','2022-03-03 12:52:47'),(62107,175,'Suratgarh','335804',1,0,'2022-03-03 12:52:47','2022-03-03 12:52:47'),(62108,175,'Tamkot','335041',1,0,'2022-03-03 12:52:47','2022-03-03 12:52:47'),(62109,175,'Tatarsar','335022',1,0,'2022-03-03 12:52:47','2022-03-03 12:52:47'),(62110,175,'Tejewala','335073',1,0,'2022-03-03 12:52:47','2022-03-03 12:52:47'),(62111,175,'Thakri','335051',1,0,'2022-03-03 12:52:47','2022-03-03 12:52:47'),(62112,175,'Thandewala','335024',1,0,'2022-03-03 12:52:47','2022-03-03 12:52:47'),(62113,175,'Thandi','335051',1,0,'2022-03-03 12:52:47','2022-03-03 12:52:47'),(62114,175,'Thethar','335804',1,0,'2022-03-03 12:52:47','2022-03-03 12:52:47'),(62115,175,'Thukrana','335804',1,0,'2022-03-03 12:52:47','2022-03-03 12:52:47'),(62116,175,'Udsar','335039',1,0,'2022-03-03 12:52:47','2022-03-03 12:52:47'),(62117,175,'Udyog Vihar','335002',1,0,'2022-03-03 12:52:47','2022-03-03 12:52:47'),(62118,175,'Vilochia','335704',1,0,'2022-03-03 12:52:47','2022-03-03 12:52:47'),(62119,175,'Zorawarpura','335024',1,0,'2022-03-03 12:52:47','2022-03-03 12:52:47'),(62120,176,'15 Kwd','335524',1,0,'2022-03-03 12:52:47','2022-03-03 12:52:47'),(62121,176,'23 Ff','335024',1,0,'2022-03-03 12:52:47','2022-03-03 12:52:47'),(62122,176,'26 J.R.K.','335802',1,0,'2022-03-03 12:52:47','2022-03-03 12:52:47'),(62123,176,'4 Cym','335524',1,0,'2022-03-03 12:52:47','2022-03-03 12:52:47'),(62124,176,'4 Dwm','335524',1,0,'2022-03-03 12:52:47','2022-03-03 12:52:47'),(62125,176,'6UTS','335512',1,0,'2022-03-03 12:52:47','2022-03-03 12:52:47'),(62126,176,'Ahmedpura','335803',1,0,'2022-03-03 12:52:47','2022-03-03 12:52:47'),(62127,176,'Ajitpura','335501',1,0,'2022-03-03 12:52:47','2022-03-03 12:52:47'),(62128,176,'Amarpura Jalukhat','335063',1,0,'2022-03-03 12:52:47','2022-03-03 12:52:47'),(62129,176,'Amarpura Rathan','335803',1,0,'2022-03-03 12:52:47','2022-03-03 12:52:47'),(62130,176,'Amarpura Theri','335513',1,0,'2022-03-03 12:52:47','2022-03-03 12:52:47'),(62131,176,'Amarsinghwala','335802',1,0,'2022-03-03 12:52:48','2022-03-03 12:52:48'),(62132,176,'Anupshahar','335501',1,0,'2022-03-03 12:52:48','2022-03-03 12:52:48'),(62133,176,'Aradhki','335523',1,0,'2022-03-03 12:52:48','2022-03-03 12:52:48'),(62134,176,'Asan','335503',1,0,'2022-03-03 12:52:48','2022-03-03 12:52:48'),(62135,176,'Ayalki','335802',1,0,'2022-03-03 12:52:48','2022-03-03 12:52:48'),(62136,176,'Badbiran','335504',1,0,'2022-03-03 12:52:48','2022-03-03 12:52:48'),(62137,176,'Bahlolnagar','335801',1,0,'2022-03-03 12:52:48','2022-03-03 12:52:48'),(62138,176,'Baramsar','335524',1,0,'2022-03-03 12:52:48','2022-03-03 12:52:48'),(62139,176,'Barwali','335504',1,0,'2022-03-03 12:52:48','2022-03-03 12:52:48'),(62140,176,'Bashir','335063',1,0,'2022-03-03 12:52:48','2022-03-03 12:52:48'),(62141,176,'Bhadi','335501',1,0,'2022-03-03 12:52:48','2022-03-03 12:52:48'),(62142,176,'Bhadra','335501',1,0,'2022-03-03 12:52:48','2022-03-03 12:52:48'),(62143,176,'Bhagatpura','335063',1,0,'2022-03-03 12:52:48','2022-03-03 12:52:48'),(62144,176,'Bhagwan','335501',1,0,'2022-03-03 12:52:48','2022-03-03 12:52:48'),(62145,176,'Bhakranwali','335063',1,0,'2022-03-03 12:52:48','2022-03-03 12:52:48'),(62146,176,'Bhanai','335501',1,0,'2022-03-03 12:52:48','2022-03-03 12:52:48'),(62147,176,'Bhangarh','335501',1,0,'2022-03-03 12:52:48','2022-03-03 12:52:48'),(62148,176,'Bharwana','335504',1,0,'2022-03-03 12:52:48','2022-03-03 12:52:48'),(62149,176,'Bherunsari','335524',1,0,'2022-03-03 12:52:48','2022-03-03 12:52:48'),(62150,176,'Bhirani','335503',1,0,'2022-03-03 12:52:48','2022-03-03 12:52:48'),(62151,176,'Bhojasar','335501',1,0,'2022-03-03 12:52:48','2022-03-03 12:52:48'),(62152,176,'Bhompura','335524',1,0,'2022-03-03 12:52:48','2022-03-03 12:52:48'),(62153,176,'Bhukarka','335523',1,0,'2022-03-03 12:52:48','2022-03-03 12:52:48'),(62154,176,'Biran','335511',1,0,'2022-03-03 12:52:48','2022-03-03 12:52:48'),(62155,176,'Birkali','335523',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62156,176,'Bisrasar','335524',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62157,176,'Bojhla','335502',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62158,176,'Bolanwali','335063',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62159,176,'Chahiyan','335524',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62160,176,'Chahuwali','335524',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62161,176,'Chak 2 Ksp','335526',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62162,176,'Chak 34 Stg','335803',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62163,176,'Chak 4 Ksp','335526',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62164,176,'Chak Sardarpura','335523',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62165,176,'Channibari','335511',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62166,176,'Chohilanwali','335803',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62167,176,'Civil Line Hanumangarh3','335512',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62168,176,'Dabli Rathan','335801',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62169,176,'Dablibaspema','335802',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62170,176,'Dablikalan','335524',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62171,176,'Dabri','335503',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62172,176,'Daidas','335523',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62173,176,'Dalpatpura','335523',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62174,176,'Daniyasar','335524',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62175,176,'Deengarh','335063',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62176,176,'Deeplana','335504',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62177,176,'Dhaba','335803',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62178,176,'Dhaba','335063',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62179,176,'Dhandhela','335523',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62180,176,'Dhani Lakhan','335523',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62181,176,'Dhannasar','335524',1,0,'2022-03-03 12:52:49','2022-03-03 12:52:49'),(62182,176,'Dhansia','335523',1,0,'2022-03-03 12:52:50','2022-03-03 12:52:50'),(62183,176,'Dhilki','335504',1,0,'2022-03-03 12:52:50','2022-03-03 12:52:50'),(62184,176,'Dholipal','335064',1,0,'2022-03-03 12:52:50','2022-03-03 12:52:50'),(62185,176,'Dobi','335501',1,0,'2022-03-03 12:52:50','2022-03-03 12:52:50'),(62186,176,'Dulmana','335803',1,0,'2022-03-03 12:52:50','2022-03-03 12:52:50'),(62187,176,'Dungarana','335502',1,0,'2022-03-03 12:52:50','2022-03-03 12:52:50'),(62188,176,'Durjana','335523',1,0,'2022-03-03 12:52:50','2022-03-03 12:52:50'),(62189,176,'Farlika','335504',1,0,'2022-03-03 12:52:50','2022-03-03 12:52:50'),(62190,176,'Fatehgarh','335801',1,0,'2022-03-03 12:52:50','2022-03-03 12:52:50'),(62191,176,'Gadhra','335503',1,0,'2022-03-03 12:52:50','2022-03-03 12:52:50'),(62192,176,'Gandheli','335523',1,0,'2022-03-03 12:52:50','2022-03-03 12:52:50'),(62193,176,'Gandhi Bari','335501',1,0,'2022-03-03 12:52:50','2022-03-03 12:52:50'),(62194,176,'Garhichhani','335511',1,0,'2022-03-03 12:52:50','2022-03-03 12:52:50'),(62195,176,'Gheu','335502',1,0,'2022-03-03 12:52:50','2022-03-03 12:52:50'),(62196,176,'Gilwala','335063',1,0,'2022-03-03 12:52:50','2022-03-03 12:52:50'),(62197,176,'Gogameri','335504',1,0,'2022-03-03 12:52:50','2022-03-03 12:52:50'),(62198,176,'Goluwala','335802',1,0,'2022-03-03 12:52:50','2022-03-03 12:52:50'),(62199,176,'Gorkhana','335523',1,0,'2022-03-03 12:52:50','2022-03-03 12:52:50'),(62200,176,'Gudia','335523',1,0,'2022-03-03 12:52:50','2022-03-03 12:52:50'),(62201,176,'Gudia','335063',1,0,'2022-03-03 12:52:50','2022-03-03 12:52:50'),(62202,176,'Gurusar Modia','335802',1,0,'2022-03-03 12:52:50','2022-03-03 12:52:50'),(62203,176,'Hanumangarh Jn. Court','335512',1,0,'2022-03-03 12:52:50','2022-03-03 12:52:50'),(62204,176,'Hanumangarh Jn. H.O','335512',1,0,'2022-03-03 12:52:50','2022-03-03 12:52:50'),(62205,176,'Hanumangarh Town Bazar','335513',1,0,'2022-03-03 12:52:50','2022-03-03 12:52:50'),(62206,176,'Hanumangarh Town','335513',1,0,'2022-03-03 12:52:51','2022-03-03 12:52:51'),(62207,176,'Hardaswali','335524',1,0,'2022-03-03 12:52:51','2022-03-03 12:52:51'),(62208,176,'Hardayalpura','335802',1,0,'2022-03-03 12:52:51','2022-03-03 12:52:51'),(62209,176,'Haripura','335063',1,0,'2022-03-03 12:52:51','2022-03-03 12:52:51'),(62210,176,'Hirnawali','335064',1,0,'2022-03-03 12:52:51','2022-03-03 12:52:51'),(62211,176,'Inderpura','335064',1,0,'2022-03-03 12:52:51','2022-03-03 12:52:51'),(62212,176,'Jabrasar','335523',1,0,'2022-03-03 12:52:51','2022-03-03 12:52:51'),(62213,176,'Jakharanwali','335803',1,0,'2022-03-03 12:52:51','2022-03-03 12:52:51'),(62214,176,'Jandwali','335512',1,0,'2022-03-03 12:52:51','2022-03-03 12:52:51'),(62215,176,'Jandwali Sikhan','335063',1,0,'2022-03-03 12:52:51','2022-03-03 12:52:51'),(62216,176,'Jasana','335523',1,0,'2022-03-03 12:52:51','2022-03-03 12:52:51'),(62217,176,'Jawalasinghwala','335512',1,0,'2022-03-03 12:52:51','2022-03-03 12:52:51'),(62218,176,'Jhamber','335513',1,0,'2022-03-03 12:52:51','2022-03-03 12:52:51'),(62219,176,'Jhansal','335511',1,0,'2022-03-03 12:52:51','2022-03-03 12:52:51'),(62220,176,'Jhedasar','335523',1,0,'2022-03-03 12:52:51','2022-03-03 12:52:51'),(62221,176,'Jogiwala','335503',1,0,'2022-03-03 12:52:51','2022-03-03 12:52:51'),(62222,176,'Jorawarpura','335524',1,0,'2022-03-03 12:52:51','2022-03-03 12:52:51'),(62223,176,'Jorkia','335512',1,0,'2022-03-03 12:52:51','2022-03-03 12:52:51'),(62224,176,'Kalana','335502',1,0,'2022-03-03 12:52:51','2022-03-03 12:52:51'),(62225,176,'Kalibanga','335803',1,0,'2022-03-03 12:52:51','2022-03-03 12:52:51'),(62226,176,'Kalwasia','335064',1,0,'2022-03-03 12:52:51','2022-03-03 12:52:51'),(62227,176,'Kamana','335801',1,0,'2022-03-03 12:52:51','2022-03-03 12:52:51'),(62228,176,'Kamrani','335513',1,0,'2022-03-03 12:52:51','2022-03-03 12:52:51'),(62229,176,'Kanau','335502',1,0,'2022-03-03 12:52:51','2022-03-03 12:52:51'),(62230,176,'Kanwani','335524',1,0,'2022-03-03 12:52:51','2022-03-03 12:52:51'),(62231,176,'Karanisar Sahjipura','335801',1,0,'2022-03-03 12:52:51','2022-03-03 12:52:51'),(62232,176,'Karanpura','335501',1,0,'2022-03-03 12:52:52','2022-03-03 12:52:52'),(62233,176,'Kewalwali Dhani','335802',1,0,'2022-03-03 12:52:52','2022-03-03 12:52:52'),(62234,176,'Khachwana','335504',1,0,'2022-03-03 12:52:52','2022-03-03 12:52:52'),(62235,176,'Kharakhera','335063',1,0,'2022-03-03 12:52:52','2022-03-03 12:52:52'),(62236,176,'Kheruwala','335064',1,0,'2022-03-03 12:52:52','2022-03-03 12:52:52'),(62237,176,'Khinania','335523',1,0,'2022-03-03 12:52:52','2022-03-03 12:52:52'),(62238,176,'Khoda','335524',1,0,'2022-03-03 12:52:52','2022-03-03 12:52:52'),(62239,176,'Khotanwali','335802',1,0,'2022-03-03 12:52:52','2022-03-03 12:52:52'),(62240,176,'Khuiuyan','335523',1,0,'2022-03-03 12:52:52','2022-03-03 12:52:52'),(62241,176,'Kikarawali','335063',1,0,'2022-03-03 12:52:52','2022-03-03 12:52:52'),(62242,176,'Kiradabara','335502',1,0,'2022-03-03 12:52:52','2022-03-03 12:52:52'),(62243,176,'Kishanpura Dikhnada','335513',1,0,'2022-03-03 12:52:52','2022-03-03 12:52:52'),(62244,176,'Kohlan','335513',1,0,'2022-03-03 12:52:52','2022-03-03 12:52:52'),(62245,176,'Kulchander','335063',1,0,'2022-03-03 12:52:52','2022-03-03 12:52:52'),(62246,176,'Kunji','335502',1,0,'2022-03-03 12:52:52','2022-03-03 12:52:52'),(62247,176,'Lakhasar','335803',1,0,'2022-03-03 12:52:52','2022-03-03 12:52:52'),(62248,176,'Lakhuwali Head','335524',1,0,'2022-03-03 12:52:52','2022-03-03 12:52:52'),(62249,176,'Lalana','335504',1,0,'2022-03-03 12:52:52','2022-03-03 12:52:52'),(62250,176,'Lalania','335523',1,0,'2022-03-03 12:52:52','2022-03-03 12:52:52'),(62251,176,'Likhmisar','335803',1,0,'2022-03-03 12:52:52','2022-03-03 12:52:52'),(62252,176,'Longwala','335803',1,0,'2022-03-03 12:52:52','2022-03-03 12:52:52'),(62253,176,'Madhunagar','335524',1,0,'2022-03-03 12:52:52','2022-03-03 12:52:52'),(62254,176,'Mahela','335524',1,0,'2022-03-03 12:52:52','2022-03-03 12:52:52'),(62255,176,'Mahrana','335511',1,0,'2022-03-03 12:52:52','2022-03-03 12:52:52'),(62256,176,'Mainawali','335524',1,0,'2022-03-03 12:52:52','2022-03-03 12:52:52'),(62257,176,'Makkasar','335512',1,0,'2022-03-03 12:52:53','2022-03-03 12:52:53'),(62258,176,'Malkhera','335511',1,0,'2022-03-03 12:52:53','2022-03-03 12:52:53'),(62259,176,'Malsisar','335502',1,0,'2022-03-03 12:52:53','2022-03-03 12:52:53'),(62260,176,'Malwani','335523',1,0,'2022-03-03 12:52:53','2022-03-03 12:52:53'),(62261,176,'Mandarpura','335523',1,0,'2022-03-03 12:52:53','2022-03-03 12:52:53'),(62262,176,'Manuka','335064',1,0,'2022-03-03 12:52:53','2022-03-03 12:52:53'),(62263,176,'Masani','335526',1,0,'2022-03-03 12:52:53','2022-03-03 12:52:53'),(62264,176,'Masitanwali','335526',1,0,'2022-03-03 12:52:53','2022-03-03 12:52:53'),(62265,176,'Meghana','335523',1,0,'2022-03-03 12:52:53','2022-03-03 12:52:53'),(62266,176,'Meharwala','335526',1,0,'2022-03-03 12:52:53','2022-03-03 12:52:53'),(62267,176,'Mirzewali Mer','335524',1,0,'2022-03-03 12:52:53','2022-03-03 12:52:53'),(62268,176,'Mohanmagaria','335524',1,0,'2022-03-03 12:52:53','2022-03-03 12:52:53'),(62269,176,'Morjand Sikhan','335063',1,0,'2022-03-03 12:52:53','2022-03-03 12:52:53'),(62270,176,'Moter','335524',1,0,'2022-03-03 12:52:53','2022-03-03 12:52:53'),(62271,176,'Munda','335526',1,0,'2022-03-03 12:52:53','2022-03-03 12:52:53'),(62272,176,'Mundriabara','335502',1,0,'2022-03-03 12:52:53','2022-03-03 12:52:53'),(62273,176,'Munsari','335504',1,0,'2022-03-03 12:52:53','2022-03-03 12:52:53'),(62274,176,'Munsari','335523',1,0,'2022-03-03 12:52:53','2022-03-03 12:52:53'),(62275,176,'Nai Abdi Manumangarh Town','335513',1,0,'2022-03-03 12:52:53','2022-03-03 12:52:53'),(62276,176,'Naiwala','335063',1,0,'2022-03-03 12:52:53','2022-03-03 12:52:53'),(62277,176,'Naiyasar','335524',1,0,'2022-03-03 12:52:53','2022-03-03 12:52:53'),(62278,176,'Nanau','335523',1,0,'2022-03-03 12:52:53','2022-03-03 12:52:53'),(62279,176,'Narayangarh','335064',1,0,'2022-03-03 12:52:53','2022-03-03 12:52:53'),(62280,176,'Nathwana','335063',1,0,'2022-03-03 12:52:54','2022-03-03 12:52:54'),(62281,176,'Nathwania','335504',1,0,'2022-03-03 12:52:54','2022-03-03 12:52:54'),(62282,176,'Naulakhi','335523',1,0,'2022-03-03 12:52:54','2022-03-03 12:52:54'),(62283,176,'Naurangdesar','335524',1,0,'2022-03-03 12:52:54','2022-03-03 12:52:54'),(62284,176,'Nawan','335512',1,0,'2022-03-03 12:52:54','2022-03-03 12:52:54'),(62285,176,'Neemla','335523',1,0,'2022-03-03 12:52:54','2022-03-03 12:52:54'),(62286,176,'Nethrana','335504',1,0,'2022-03-03 12:52:54','2022-03-03 12:52:54'),(62287,176,'Ninan','335511',1,0,'2022-03-03 12:52:54','2022-03-03 12:52:54'),(62288,176,'Nohar Bazar','335523',1,0,'2022-03-03 12:52:54','2022-03-03 12:52:54'),(62289,176,'Nohar','335523',1,0,'2022-03-03 12:52:54','2022-03-03 12:52:54'),(62290,176,'Nukera','335063',1,0,'2022-03-03 12:52:54','2022-03-03 12:52:54'),(62291,176,'Padampura','335523',1,0,'2022-03-03 12:52:54','2022-03-03 12:52:54'),(62292,176,'Pakka Bhadwan','335802',1,0,'2022-03-03 12:52:54','2022-03-03 12:52:54'),(62293,176,'Pakka Saharana','335512',1,0,'2022-03-03 12:52:54','2022-03-03 12:52:54'),(62294,176,'Pakki Dabli','335526',1,0,'2022-03-03 12:52:54','2022-03-03 12:52:54'),(62295,176,'Pallu','335524',1,0,'2022-03-03 12:52:54','2022-03-03 12:52:54'),(62296,176,'Panditanwali','335803',1,0,'2022-03-03 12:52:54','2022-03-03 12:52:54'),(62297,176,'Pandusar','335523',1,0,'2022-03-03 12:52:54','2022-03-03 12:52:54'),(62298,176,'Panniwali','335526',1,0,'2022-03-03 12:52:54','2022-03-03 12:52:54'),(62299,176,'Peerkamadia','335526',1,0,'2022-03-03 12:52:54','2022-03-03 12:52:54'),(62300,176,'Phephana','335523',1,0,'2022-03-03 12:52:54','2022-03-03 12:52:54'),(62301,176,'Pilibanga Village','335803',1,0,'2022-03-03 12:52:54','2022-03-03 12:52:54'),(62302,176,'Pilibangan','335803',1,0,'2022-03-03 12:52:54','2022-03-03 12:52:54'),(62303,176,'Poharka','335524',1,0,'2022-03-03 12:52:54','2022-03-03 12:52:54'),(62304,176,'Prempura','335803',1,0,'2022-03-03 12:52:54','2022-03-03 12:52:54'),(62305,176,'Purabsar','335524',1,0,'2022-03-03 12:52:55','2022-03-03 12:52:55'),(62306,176,'Ramgadhia','335511',1,0,'2022-03-03 12:52:55','2022-03-03 12:52:55'),(62307,176,'Ramgarh','335504',1,0,'2022-03-03 12:52:55','2022-03-03 12:52:55'),(62308,176,'Rampura Mala','335063',1,0,'2022-03-03 12:52:55','2022-03-03 12:52:55'),(62309,176,'Rampura Matoria','335524',1,0,'2022-03-03 12:52:55','2022-03-03 12:52:55'),(62310,176,'Rampura Ramsara','335526',1,0,'2022-03-03 12:52:55','2022-03-03 12:52:55'),(62311,176,'Ramsara Narain','335513',1,0,'2022-03-03 12:52:55','2022-03-03 12:52:55'),(62312,176,'Raslana','335502',1,0,'2022-03-03 12:52:55','2022-03-03 12:52:55'),(62313,176,'Ratanpura','335523',1,0,'2022-03-03 12:52:55','2022-03-03 12:52:55'),(62314,176,'Ratanpura','335063',1,0,'2022-03-03 12:52:55','2022-03-03 12:52:55'),(62315,176,'Rathikhara','335526',1,0,'2022-03-03 12:52:55','2022-03-03 12:52:55'),(62316,176,'Rawatsar (Hanumangarh)','335524',1,0,'2022-03-03 12:52:55','2022-03-03 12:52:55'),(62317,176,'Rorawali','335512',1,0,'2022-03-03 12:52:55','2022-03-03 12:52:55'),(62318,176,'Sabuana','335063',1,0,'2022-03-03 12:52:55','2022-03-03 12:52:55'),(62319,176,'Sagra','335503',1,0,'2022-03-03 12:52:55','2022-03-03 12:52:55'),(62320,176,'Sahuwala','335511',1,0,'2022-03-03 12:52:55','2022-03-03 12:52:55'),(62321,176,'Saliwala','335063',1,0,'2022-03-03 12:52:55','2022-03-03 12:52:55'),(62322,176,'Salochanwala','335803',1,0,'2022-03-03 12:52:55','2022-03-03 12:52:55'),(62323,176,'Sangaria Rs','335063',1,0,'2022-03-03 12:52:55','2022-03-03 12:52:55'),(62324,176,'Sangaria (Hanumangarh)','335063',1,0,'2022-03-03 12:52:55','2022-03-03 12:52:55'),(62325,176,'Sanger','335803',1,0,'2022-03-03 12:52:55','2022-03-03 12:52:55'),(62326,176,'Santpura','335063',1,0,'2022-03-03 12:52:55','2022-03-03 12:52:55'),(62327,176,'Sardargarhia','335504',1,0,'2022-03-03 12:52:55','2022-03-03 12:52:55'),(62328,176,'Satipura','335512',1,0,'2022-03-03 12:52:55','2022-03-03 12:52:55'),(62329,176,'Shahpini','335063',1,0,'2022-03-03 12:52:55','2022-03-03 12:52:55'),(62330,176,'Sherda','335503',1,0,'2022-03-03 12:52:56','2022-03-03 12:52:56'),(62331,176,'Sherekan','335513',1,0,'2022-03-03 12:52:56','2022-03-03 12:52:56'),(62332,176,'Sherpura','335511',1,0,'2022-03-03 12:52:56','2022-03-03 12:52:56'),(62333,176,'Shivdanpura','335503',1,0,'2022-03-03 12:52:56','2022-03-03 12:52:56'),(62334,176,'Silwala Kalan','335525',1,0,'2022-03-03 12:52:56','2022-03-03 12:52:56'),(62335,176,'Silwala Khurd','335526',1,0,'2022-03-03 12:52:56','2022-03-03 12:52:56'),(62336,176,'Sirangsar','335523',1,0,'2022-03-03 12:52:56','2022-03-03 12:52:56'),(62337,176,'Sonari','335523',1,0,'2022-03-03 12:52:56','2022-03-03 12:52:56'),(62338,176,'Soorpura','335523',1,0,'2022-03-03 12:52:56','2022-03-03 12:52:56'),(62339,176,'Suratpura','335503',1,0,'2022-03-03 12:52:56','2022-03-03 12:52:56'),(62340,176,'Surewala','335526',1,0,'2022-03-03 12:52:56','2022-03-03 12:52:56'),(62341,176,'Surewali','335802',1,0,'2022-03-03 12:52:56','2022-03-03 12:52:56'),(62342,176,'Talwara Jheel','335525',1,0,'2022-03-03 12:52:56','2022-03-03 12:52:56'),(62343,176,'Thalarka','335524',1,0,'2022-03-03 12:52:56','2022-03-03 12:52:56'),(62344,176,'Thirana','335523',1,0,'2022-03-03 12:52:56','2022-03-03 12:52:56'),(62345,176,'Tibbi','335526',1,0,'2022-03-03 12:52:56','2022-03-03 12:52:56'),(62346,176,'Tidyasar','335523',1,0,'2022-03-03 12:52:56','2022-03-03 12:52:56'),(62347,176,'Toparia','335523',1,0,'2022-03-03 12:52:56','2022-03-03 12:52:56'),(62348,176,'Ujjalwas','335504',1,0,'2022-03-03 12:52:56','2022-03-03 12:52:56'),(62349,176,'Utradabas','335501',1,0,'2022-03-03 12:52:56','2022-03-03 12:52:56'),(62350,176,'Vidyapeeth','335063',1,0,'2022-03-03 12:52:56','2022-03-03 12:52:56'),(62351,177,'Airport Sanganer','302029',1,0,'2022-03-03 12:52:56','2022-03-03 12:52:56'),(62352,177,'Ajmer Road','302006',1,0,'2022-03-03 12:52:56','2022-03-03 12:52:56'),(62353,177,'Akhepura','302013',1,0,'2022-03-03 12:52:56','2022-03-03 12:52:56'),(62354,177,'Amba Bari','302039',1,0,'2022-03-03 12:52:56','2022-03-03 12:52:56'),(62355,177,'Amer Clark Hotel','302018',1,0,'2022-03-03 12:52:57','2022-03-03 12:52:57'),(62356,177,'Amer Road','302002',1,0,'2022-03-03 12:52:57','2022-03-03 12:52:57'),(62357,177,'Amer','302028',1,0,'2022-03-03 12:52:57','2022-03-03 12:52:57'),(62358,177,'Arjun Lal Sethi Nagar','302004',1,0,'2022-03-03 12:52:57','2022-03-03 12:52:57'),(62359,177,'Ashok Nagar (Jaipur)','302001',1,0,'2022-03-03 12:52:57','2022-03-03 12:52:57'),(62360,177,'Bajaj Nagar','302015',1,0,'2022-03-03 12:52:57','2022-03-03 12:52:57'),(62361,177,'Bani Park','302016',1,0,'2022-03-03 12:52:57','2022-03-03 12:52:57'),(62362,177,'Bapu Nagar','302015',1,0,'2022-03-03 12:52:57','2022-03-03 12:52:57'),(62363,177,'Barkat Nagar','302015',1,0,'2022-03-03 12:52:57','2022-03-03 12:52:57'),(62364,177,'Basna','302028',1,0,'2022-03-03 12:52:57','2022-03-03 12:52:57'),(62365,177,'Bhambhoria','302026',1,0,'2022-03-03 12:52:57','2022-03-03 12:52:57'),(62366,177,'Bhankrota','302026',1,0,'2022-03-03 12:52:57','2022-03-03 12:52:57'),(62367,177,'Bhanpur Kalan','302028',1,0,'2022-03-03 12:52:57','2022-03-03 12:52:57'),(62368,177,'Bhura Tiba','302001',1,0,'2022-03-03 12:52:57','2022-03-03 12:52:57'),(62369,177,'Bilod','302028',1,0,'2022-03-03 12:52:57','2022-03-03 12:52:57'),(62370,177,'Bilwa','302022',1,0,'2022-03-03 12:52:57','2022-03-03 12:52:57'),(62371,177,'Bindayaka','302012',1,0,'2022-03-03 12:52:57','2022-03-03 12:52:57'),(62372,177,'C.P.M.G','302001',1,0,'2022-03-03 12:52:57','2022-03-03 12:52:57'),(62373,177,'Chandpole Bazar','302001',1,0,'2022-03-03 12:52:57','2022-03-03 12:52:57'),(62374,177,'Collectorate (Jaipur)','302016',1,0,'2022-03-03 12:52:57','2022-03-03 12:52:57'),(62375,177,'Crpf Campus  Lalwas','302027',1,0,'2022-03-03 12:52:57','2022-03-03 12:52:57'),(62376,177,'Dehar Ka Balaji','302039',1,0,'2022-03-03 12:52:57','2022-03-03 12:52:57'),(62377,177,'Dhand','302028',1,0,'2022-03-03 12:52:57','2022-03-03 12:52:57'),(62378,177,'Dhankya','302012',1,0,'2022-03-03 12:52:57','2022-03-03 12:52:57'),(62379,177,'Durgapura','302018',1,0,'2022-03-03 12:52:57','2022-03-03 12:52:57'),(62380,177,'Dwarikapuri','302016',1,0,'2022-03-03 12:52:57','2022-03-03 12:52:57'),(62381,177,'Gandhi Nagar (Jaipur)','302015',1,0,'2022-03-03 12:52:58','2022-03-03 12:52:58'),(62382,177,'Govind Nagar (Jaipur)','302002',1,0,'2022-03-03 12:52:58','2022-03-03 12:52:58'),(62383,177,'Haldiyon Ka Rasta','302003',1,0,'2022-03-03 12:52:58','2022-03-03 12:52:58'),(62384,177,'Harmada','302013',1,0,'2022-03-03 12:52:58','2022-03-03 12:52:58'),(62385,177,'Hathoj','302012',1,0,'2022-03-03 12:52:58','2022-03-03 12:52:58'),(62386,177,'Heerapura','302021',1,0,'2022-03-03 12:52:58','2022-03-03 12:52:58'),(62387,177,'High Court (Jaipur)','302005',1,0,'2022-03-03 12:52:58','2022-03-03 12:52:58'),(62388,177,'Indergarh','302027',1,0,'2022-03-03 12:52:58','2022-03-03 12:52:58'),(62389,177,'Indra Bazar','302001',1,0,'2022-03-03 12:52:58','2022-03-03 12:52:58'),(62390,177,'Industrial Area Jhotwara','302012',1,0,'2022-03-03 12:52:58','2022-03-03 12:52:58'),(62391,177,'Industrial Estate (Jaipur)','302006',1,0,'2022-03-03 12:52:58','2022-03-03 12:52:58'),(62392,177,'Jagatpura','302017',1,0,'2022-03-03 12:52:58','2022-03-03 12:52:58'),(62393,177,'Jaipur City','302003',1,0,'2022-03-03 12:52:58','2022-03-03 12:52:58'),(62394,177,'Jaipur G.P.O.','302001',1,0,'2022-03-03 12:52:58','2022-03-03 12:52:58'),(62395,177,'Jaipur R.S.','302006',1,0,'2022-03-03 12:52:58','2022-03-03 12:52:58'),(62396,177,'Jaisinghpura Bas','302026',1,0,'2022-03-03 12:52:58','2022-03-03 12:52:58'),(62397,177,'Jaisinghpura Khore','302036',1,0,'2022-03-03 12:52:58','2022-03-03 12:52:58'),(62398,177,'Jamdoli','302031',1,0,'2022-03-03 12:52:58','2022-03-03 12:52:58'),(62399,177,'Janta Colony','302004',1,0,'2022-03-03 12:52:58','2022-03-03 12:52:58'),(62400,177,'Jawahar Nagar H.O','302004',1,0,'2022-03-03 12:52:58','2022-03-03 12:52:58'),(62401,177,'Jhalana Doongri','302004',1,0,'2022-03-03 12:52:58','2022-03-03 12:52:58'),(62402,177,'Jhotwara','302012',1,0,'2022-03-03 12:52:58','2022-03-03 12:52:58'),(62403,177,'Khatipura Road','302006',1,0,'2022-03-03 12:52:58','2022-03-03 12:52:58'),(62404,177,'Khatipura','302012',1,0,'2022-03-03 12:52:58','2022-03-03 12:52:58'),(62405,177,'Khora Bisal','302012',1,0,'2022-03-03 12:52:58','2022-03-03 12:52:58'),(62406,177,'Khora Meena','302028',1,0,'2022-03-03 12:52:59','2022-03-03 12:52:59'),(62407,177,'Kishanpole Bazar','302002',1,0,'2022-03-03 12:52:59','2022-03-03 12:52:59'),(62408,177,'Kishanpura','302012',1,0,'2022-03-03 12:52:59','2022-03-03 12:52:59'),(62409,177,'Kookas','302028',1,0,'2022-03-03 12:52:59','2022-03-03 12:52:59'),(62410,177,'Krishi Upaj Mandi','302003',1,0,'2022-03-03 12:52:59','2022-03-03 12:52:59'),(62411,177,'Krishna Mandir','302004',1,0,'2022-03-03 12:52:59','2022-03-03 12:52:59'),(62412,177,'Lakhana','302029',1,0,'2022-03-03 12:52:59','2022-03-03 12:52:59'),(62413,177,'Langareeyawas','302027',1,0,'2022-03-03 12:52:59','2022-03-03 12:52:59'),(62414,177,'Legislative Assembly','302005',1,0,'2022-03-03 12:52:59','2022-03-03 12:52:59'),(62415,177,'Luniawas','302031',1,0,'2022-03-03 12:52:59','2022-03-03 12:52:59'),(62416,177,'M.I.Road','302001',1,0,'2022-03-03 12:52:59','2022-03-03 12:52:59'),(62417,177,'Mahapura','302026',1,0,'2022-03-03 12:52:59','2022-03-03 12:52:59'),(62418,177,'Mahapura','302029',1,0,'2022-03-03 12:52:59','2022-03-03 12:52:59'),(62419,177,'Mahindra World City (Jaipur)','302037',1,0,'2022-03-03 12:52:59','2022-03-03 12:52:59'),(62420,177,'Malviya Nagar (Jaipur)','302017',1,0,'2022-03-03 12:52:59','2022-03-03 12:52:59'),(62421,177,'Malviya Nagar Sector 11','12',1,0,'2022-03-03 12:52:59','2022-03-03 12:52:59'),(62422,177,'Mansarovar','302020',1,0,'2022-03-03 12:52:59','2022-03-03 12:52:59'),(62423,177,'Meena Wala','302012',1,0,'2022-03-03 12:52:59','2022-03-03 12:52:59'),(62424,177,'Moti Doongari Road','302004',1,0,'2022-03-03 12:52:59','2022-03-03 12:52:59'),(62425,177,'Mrec Jaipur','302017',1,0,'2022-03-03 12:52:59','2022-03-03 12:52:59'),(62426,177,'Muhana','302029',1,0,'2022-03-03 12:52:59','2022-03-03 12:52:59'),(62427,177,'Mukandpura','302026',1,0,'2022-03-03 12:52:59','2022-03-03 12:52:59'),(62428,177,'Mundia Rampura','302012',1,0,'2022-03-03 12:52:59','2022-03-03 12:52:59'),(62429,177,'Murlipura','302039',1,0,'2022-03-03 12:52:59','2022-03-03 12:52:59'),(62430,177,'N.C.R.Building','302005',1,0,'2022-03-03 12:52:59','2022-03-03 12:52:59'),(62431,177,'Nangal Jaisabohara','302040',1,0,'2022-03-03 12:53:00','2022-03-03 12:53:00'),(62432,177,'Nangal Purohitan','302013',1,0,'2022-03-03 12:53:00','2022-03-03 12:53:00'),(62433,177,'Nangal Soosawatan','302028',1,0,'2022-03-03 12:53:00','2022-03-03 12:53:00'),(62434,177,'Natata','302028',1,0,'2022-03-03 12:53:00','2022-03-03 12:53:00'),(62435,177,'Neemera','302012',1,0,'2022-03-03 12:53:00','2022-03-03 12:53:00'),(62436,177,'Neendar','302013',1,0,'2022-03-03 12:53:00','2022-03-03 12:53:00'),(62437,177,'Neendar Banar','302012',1,0,'2022-03-03 12:53:00','2022-03-03 12:53:00'),(62438,177,'Neota','302029',1,0,'2022-03-03 12:53:00','2022-03-03 12:53:00'),(62439,177,'Niwaroo','302012',1,0,'2022-03-03 12:53:00','2022-03-03 12:53:00'),(62440,177,'P.W.D.Office','302006',1,0,'2022-03-03 12:53:00','2022-03-03 12:53:00'),(62441,177,'Panchyawala','302034',1,0,'2022-03-03 12:53:00','2022-03-03 12:53:00'),(62442,177,'Pratap Nagar Housing Board','302033',1,0,'2022-03-03 12:53:00','2022-03-03 12:53:00'),(62443,177,'Pratap Nagar Sector 11','302033',1,0,'2022-03-03 12:53:00','2022-03-03 12:53:00'),(62444,177,'Purani Basti (Jaipur)','302001',1,0,'2022-03-03 12:53:00','2022-03-03 12:53:00'),(62445,177,'Rahori','302027',1,0,'2022-03-03 12:53:00','2022-03-03 12:53:00'),(62446,177,'Raj Bhawan (Jaipur)','302006',1,0,'2022-03-03 12:53:00','2022-03-03 12:53:00'),(62447,177,'Raja Park Colony','302004',1,0,'2022-03-03 12:53:00','2022-03-03 12:53:00'),(62448,177,'Rajasthan Secretariate','302005',1,0,'2022-03-03 12:53:00','2022-03-03 12:53:00'),(62449,177,'Rajasthan State Hotel','302001',1,0,'2022-03-03 12:53:00','2022-03-03 12:53:00'),(62450,177,'Rajasthan University','302004',1,0,'2022-03-03 12:53:00','2022-03-03 12:53:00'),(62451,177,'Ramganj Bazar','302003',1,0,'2022-03-03 12:53:00','2022-03-03 12:53:00'),(62452,177,'Rampura Roopa','302015',1,0,'2022-03-03 12:53:00','2022-03-03 12:53:00'),(62453,177,'Road No-5 Vkia','302013',1,0,'2022-03-03 12:53:00','2022-03-03 12:53:00'),(62454,177,'Rojda','302012',1,0,'2022-03-03 12:53:00','2022-03-03 12:53:00'),(62455,177,'Roop Was','302027',1,0,'2022-03-03 12:53:00','2022-03-03 12:53:00'),(62456,177,'S.D.M.Hospitial','302015',1,0,'2022-03-03 12:53:00','2022-03-03 12:53:00'),(62457,177,'S.F.S.Mansarovar','302020',1,0,'2022-03-03 12:53:01','2022-03-03 12:53:01'),(62458,177,'S.M.S.Hospital','302004',1,0,'2022-03-03 12:53:01','2022-03-03 12:53:01'),(62459,177,'Saipura','302027',1,0,'2022-03-03 12:53:01','2022-03-03 12:53:01'),(62460,177,'Saiwar','302027',1,0,'2022-03-03 12:53:01','2022-03-03 12:53:01'),(62461,177,'Sanganer Bazar','302029',1,0,'2022-03-03 12:53:01','2022-03-03 12:53:01'),(62462,177,'Saraswati Nagar','302017',1,0,'2022-03-03 12:53:01','2022-03-03 12:53:01'),(62463,177,'Shastri Nagar H.O','302016',1,0,'2022-03-03 12:53:01','2022-03-03 12:53:01'),(62464,177,'Shri Ram Ki Nangal','302022',1,0,'2022-03-03 12:53:01','2022-03-03 12:53:01'),(62465,177,'Shyam Nagar (Jaipur)','302019',1,0,'2022-03-03 12:53:01','2022-03-03 12:53:01'),(62466,177,'Sindhi Colony','302016',1,0,'2022-03-03 12:53:01','2022-03-03 12:53:01'),(62467,177,'Sinwar','302012',1,0,'2022-03-03 12:53:01','2022-03-03 12:53:01'),(62468,177,'Sirsi','302012',1,0,'2022-03-03 12:53:01','2022-03-03 12:53:01'),(62469,177,'Sitapura Industrial Area','302022',1,0,'2022-03-03 12:53:01','2022-03-03 12:53:01'),(62470,177,'Station Road (Jaipur)','302006',1,0,'2022-03-03 12:53:01','2022-03-03 12:53:01'),(62471,177,'Sumel','302031',1,0,'2022-03-03 12:53:01','2022-03-03 12:53:01'),(62472,177,'Thikariya','302026',1,0,'2022-03-03 12:53:01','2022-03-03 12:53:01'),(62473,177,'Tilak Nagar (Jaipur)','302004',1,0,'2022-03-03 12:53:01','2022-03-03 12:53:01'),(62474,177,'Toda Meena','302028',1,0,'2022-03-03 12:53:01','2022-03-03 12:53:01'),(62475,177,'Tripolia Bazar','302002',1,0,'2022-03-03 12:53:01','2022-03-03 12:53:01'),(62476,177,'Vaishali Nagar','302021',1,0,'2022-03-03 12:53:01','2022-03-03 12:53:01'),(62477,177,'Vidhyadhar Nagar','302039',1,0,'2022-03-03 12:53:01','2022-03-03 12:53:01'),(62478,177,'Vidyut Bhawan','302005',1,0,'2022-03-03 12:53:01','2022-03-03 12:53:01'),(62479,177,'Vishwakarma Industrial Area','302013',1,0,'2022-03-03 12:53:01','2022-03-03 12:53:01'),(62480,177,'A C Jobner','303329',1,0,'2022-03-03 12:53:01','2022-03-03 12:53:01'),(62481,177,'Achalpura','303908',1,0,'2022-03-03 12:53:01','2022-03-03 12:53:01'),(62482,177,'Achrol','303002',1,0,'2022-03-03 12:53:02','2022-03-03 12:53:02'),(62483,177,'Ajairajpura','303007',1,0,'2022-03-03 12:53:02','2022-03-03 12:53:02'),(62484,177,'Akoda','303338',1,0,'2022-03-03 12:53:02','2022-03-03 12:53:02'),(62485,177,'Akodiya','303901',1,0,'2022-03-03 12:53:02','2022-03-03 12:53:02'),(62486,177,'Alisar','303801',1,0,'2022-03-03 12:53:02','2022-03-03 12:53:02'),(62487,177,'Amarpura','303804',1,0,'2022-03-03 12:53:02','2022-03-03 12:53:02'),(62488,177,'Amarsar','303601',1,0,'2022-03-03 12:53:02','2022-03-03 12:53:02'),(62489,177,'Amloda','303120',1,0,'2022-03-03 12:53:02','2022-03-03 12:53:02'),(62490,177,'Anantpura','303712',1,0,'2022-03-03 12:53:02','2022-03-03 12:53:02'),(62491,177,'Anantpura','303704',1,0,'2022-03-03 12:53:02','2022-03-03 12:53:02'),(62492,177,'Anantpura','303302',1,0,'2022-03-03 12:53:02','2022-03-03 12:53:02'),(62493,177,'Andhi','303001',1,0,'2022-03-03 12:53:02','2022-03-03 12:53:02'),(62494,177,'Antela','303119',1,0,'2022-03-03 12:53:02','2022-03-03 12:53:02'),(62495,177,'Arp Dhelana','303908',1,0,'2022-03-03 12:53:02','2022-03-03 12:53:02'),(62496,177,'Asalpur','303604',1,0,'2022-03-03 12:53:02','2022-03-03 12:53:02'),(62497,177,'Astikalan','303602',1,0,'2022-03-03 12:53:02','2022-03-03 12:53:02'),(62498,177,'Awania','303007',1,0,'2022-03-03 12:53:02','2022-03-03 12:53:02'),(62499,177,'Badapadampura','303903',1,0,'2022-03-03 12:53:02','2022-03-03 12:53:02'),(62500,177,'Badhal','303602',1,0,'2022-03-03 12:53:02','2022-03-03 12:53:02'),(62501,177,'Badi Jori','303103',1,0,'2022-03-03 12:53:02','2022-03-03 12:53:02'),(62502,177,'Badodia','303103',1,0,'2022-03-03 12:53:02','2022-03-03 12:53:02'),(62503,177,'Badwa','303305',1,0,'2022-03-03 12:53:02','2022-03-03 12:53:02'),(62504,177,'Bagawas Ahiran','303119',1,0,'2022-03-03 12:53:03','2022-03-03 12:53:03'),(62505,177,'Bagawas','303603',1,0,'2022-03-03 12:53:03','2022-03-03 12:53:03'),(62506,177,'Bagawas Choriyasi','303119',1,0,'2022-03-03 12:53:03','2022-03-03 12:53:03'),(62507,177,'Bagru','303007',1,0,'2022-03-03 12:53:03','2022-03-03 12:53:03'),(62508,177,'Bagwara','303805',1,0,'2022-03-03 12:53:03','2022-03-03 12:53:03'),(62509,177,'Bajrangpura','303119',1,0,'2022-03-03 12:53:03','2022-03-03 12:53:03'),(62510,177,'Banar','303105',1,0,'2022-03-03 12:53:03','2022-03-03 12:53:03'),(62511,177,'Bandha Jamwaramgarh','303109',1,0,'2022-03-03 12:53:03','2022-03-03 12:53:03'),(62512,177,'Banethi','303105',1,0,'2022-03-03 12:53:03','2022-03-03 12:53:03'),(62513,177,'Bansa','303806',1,0,'2022-03-03 12:53:03','2022-03-03 12:53:03'),(62514,177,'Barnagar','303106',1,0,'2022-03-03 12:53:03','2022-03-03 12:53:03'),(62515,177,'Barodiya','303908',1,0,'2022-03-03 12:53:03','2022-03-03 12:53:03'),(62516,177,'Bas Badwa','303302',1,0,'2022-03-03 12:53:03','2022-03-03 12:53:03'),(62517,177,'Baseri Khurd','303603',1,0,'2022-03-03 12:53:03','2022-03-03 12:53:03'),(62518,177,'Bassi Naga','303706',1,0,'2022-03-03 12:53:03','2022-03-03 12:53:03'),(62519,177,'Bassi (Jaipur)','303301',1,0,'2022-03-03 12:53:03','2022-03-03 12:53:03'),(62520,177,'Beelwadi','303102',1,0,'2022-03-03 12:53:03','2022-03-03 12:53:03'),(62521,177,'Begas','303007',1,0,'2022-03-03 12:53:03','2022-03-03 12:53:03'),(62522,177,'Behlod','303120',1,0,'2022-03-03 12:53:03','2022-03-03 12:53:03'),(62523,177,'Benada','303301',1,0,'2022-03-03 12:53:03','2022-03-03 12:53:03'),(62524,177,'Beri','303105',1,0,'2022-03-03 12:53:03','2022-03-03 12:53:03'),(62525,177,'Bhabroo','303119',1,0,'2022-03-03 12:53:03','2022-03-03 12:53:03'),(62526,177,'Bhadwa','303328',1,0,'2022-03-03 12:53:03','2022-03-03 12:53:03'),(62527,177,'Bhainsawa','303603',1,0,'2022-03-03 12:53:03','2022-03-03 12:53:03'),(62528,177,'Bhainslana','303107',1,0,'2022-03-03 12:53:03','2022-03-03 12:53:03'),(62529,177,'Bhaislana','303328',1,0,'2022-03-03 12:53:04','2022-03-03 12:53:04'),(62530,177,'Bhalloji','303110',1,0,'2022-03-03 12:53:04','2022-03-03 12:53:04'),(62531,177,'Bhamod','303003',1,0,'2022-03-03 12:53:04','2022-03-03 12:53:04'),(62532,177,'Bhamori','303706',1,0,'2022-03-03 12:53:04','2022-03-03 12:53:04'),(62533,177,'Bhankari','303110',1,0,'2022-03-03 12:53:04','2022-03-03 12:53:04'),(62534,177,'Bhankrota','303006',1,0,'2022-03-03 12:53:04','2022-03-03 12:53:04'),(62535,177,'Bhato Ki Gali','303701',1,0,'2022-03-03 12:53:04','2022-03-03 12:53:04'),(62536,177,'Bhawani','303001',1,0,'2022-03-03 12:53:04','2022-03-03 12:53:04'),(62537,177,'Bhojpura','303328',1,0,'2022-03-03 12:53:04','2022-03-03 12:53:04'),(62538,177,'Bhonawas','303106',1,0,'2022-03-03 12:53:04','2022-03-03 12:53:04'),(62539,177,'Bhopawa','303807',1,0,'2022-03-03 12:53:04','2022-03-03 12:53:04'),(62540,177,'Bhuri Baraja','303107',1,0,'2022-03-03 12:53:04','2022-03-03 12:53:04'),(62541,177,'Bhurthal','303704',1,0,'2022-03-03 12:53:04','2022-03-03 12:53:04'),(62542,177,'Bhutera','303712',1,0,'2022-03-03 12:53:04','2022-03-03 12:53:04'),(62543,177,'Bichi','303006',1,0,'2022-03-03 12:53:04','2022-03-03 12:53:04'),(62544,177,'Bichoon','303604',1,0,'2022-03-03 12:53:04','2022-03-03 12:53:04'),(62545,177,'Bidara','303103',1,0,'2022-03-03 12:53:04','2022-03-03 12:53:04'),(62546,177,'Bilanderpur','303803',1,0,'2022-03-03 12:53:04','2022-03-03 12:53:04'),(62547,177,'Bilochi','303805',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62548,177,'Birsana','303001',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62549,177,'Bishangarh','303104',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62550,177,'Bobadi','303120',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62551,177,'Bobas','303338',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62552,177,'Booj','303109',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62553,177,'Boraj','303338',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62554,177,'Buchara','303106',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62555,177,'Burthal','303012',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62556,177,'Chainpura','303348',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62557,177,'Chaksu','303901',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62558,177,'Chakwada','303005',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62559,177,'Chandamakalan','303006',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62560,177,'Chandlai','303903',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62561,177,'Chandwaji','303104',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62562,177,'Chanwandia','303301',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62563,177,'Charanwas','303804',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62564,177,'Chatarpura','303701',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62565,177,'Chaturbhuj','303108',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62566,177,'Cheethwari','303805',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62567,177,'Chetawala','303704',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62568,177,'Chhandel Kalan','303901',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62569,177,'Chhapra Kalan (Shahpura)','303103',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62570,177,'Chhapra Khurd','303103',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62571,177,'Chhardera','303105',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62572,177,'Chharsa','303120',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62573,177,'Chhitoli','303102',1,0,'2022-03-03 12:53:05','2022-03-03 12:53:05'),(62574,177,'Chimanpura','303103',1,0,'2022-03-03 12:53:06','2022-03-03 12:53:06'),(62575,177,'Chimanpura','303105',1,0,'2022-03-03 12:53:06','2022-03-03 12:53:06'),(62576,177,'Chinoi','303801',1,0,'2022-03-03 12:53:06','2022-03-03 12:53:06'),(62577,177,'Chitanu Kalan','303104',1,0,'2022-03-03 12:53:06','2022-03-03 12:53:06'),(62578,177,'Chittora','303904',1,0,'2022-03-03 12:53:06','2022-03-03 12:53:06'),(62579,177,'Chittora Renwal','303904',1,0,'2022-03-03 12:53:06','2022-03-03 12:53:06'),(62580,177,'Chomu','303702',1,0,'2022-03-03 12:53:06','2022-03-03 12:53:06'),(62581,177,'Chonp','303805',1,0,'2022-03-03 12:53:06','2022-03-03 12:53:06'),(62582,177,'Choru','303005',1,0,'2022-03-03 12:53:06','2022-03-03 12:53:06'),(62583,177,'Dabach','303006',1,0,'2022-03-03 12:53:06','2022-03-03 12:53:06'),(62584,177,'Dabla Kalan','303904',1,0,'2022-03-03 12:53:06','2022-03-03 12:53:06'),(62585,177,'Dadiya','303905',1,0,'2022-03-03 12:53:06','2022-03-03 12:53:06'),(62586,177,'Danau Kalan','303302',1,0,'2022-03-03 12:53:06','2022-03-03 12:53:06'),(62587,177,'Dangaarwara','303001',1,0,'2022-03-03 12:53:06','2022-03-03 12:53:06'),(62588,177,'Dantala Meena','303120',1,0,'2022-03-03 12:53:06','2022-03-03 12:53:06'),(62589,177,'Dantil','303001',1,0,'2022-03-03 12:53:06','2022-03-03 12:53:06'),(62590,177,'Dantil','303107',1,0,'2022-03-03 12:53:06','2022-03-03 12:53:06'),(62591,177,'Dantli','303012',1,0,'2022-03-03 12:53:06','2022-03-03 12:53:06'),(62592,177,'Dantri','303008',1,0,'2022-03-03 12:53:06','2022-03-03 12:53:06'),(62593,177,'Daulatpura','303805',1,0,'2022-03-03 12:53:06','2022-03-03 12:53:06'),(62594,177,'Dehmi Kalan','303007',1,0,'2022-03-03 12:53:06','2022-03-03 12:53:06'),(62595,177,'Deogaon','303301',1,0,'2022-03-03 12:53:06','2022-03-03 12:53:06'),(62596,177,'Deogudha','303701',1,0,'2022-03-03 12:53:06','2022-03-03 12:53:06'),(62597,177,'Deota','303105',1,0,'2022-03-03 12:53:06','2022-03-03 12:53:06'),(62598,177,'Dev Ka Harwada','303104',1,0,'2022-03-03 12:53:07','2022-03-03 12:53:07'),(62599,177,'Deva Ka Bas','303602',1,0,'2022-03-03 12:53:07','2022-03-03 12:53:07'),(62600,177,'Devan','303103',1,0,'2022-03-03 12:53:07','2022-03-03 12:53:07'),(62601,177,'Devipura','303103',1,0,'2022-03-03 12:53:07','2022-03-03 12:53:07'),(62602,177,'Dhamana','303009',1,0,'2022-03-03 12:53:07','2022-03-03 12:53:07'),(62603,177,'Dhandholi','303008',1,0,'2022-03-03 12:53:07','2022-03-03 12:53:07'),(62604,177,'Dhani Boraj','303328',1,0,'2022-03-03 12:53:07','2022-03-03 12:53:07'),(62605,177,'Dhanota','303804',1,0,'2022-03-03 12:53:07','2022-03-03 12:53:07'),(62606,177,'Dharampura','303305',1,0,'2022-03-03 12:53:07','2022-03-03 12:53:07'),(62607,177,'Dheendha','303328',1,0,'2022-03-03 12:53:07','2022-03-03 12:53:07'),(62608,177,'Dhoblai','303712',1,0,'2022-03-03 12:53:07','2022-03-03 12:53:07'),(62609,177,'Dhodsar','303712',1,0,'2022-03-03 12:53:07','2022-03-03 12:53:07'),(62610,177,'Dhola','303120',1,0,'2022-03-03 12:53:07','2022-03-03 12:53:07'),(62611,177,'Dhola Ka Bas','303801',1,0,'2022-03-03 12:53:07','2022-03-03 12:53:07'),(62612,177,'Dholi','303806',1,0,'2022-03-03 12:53:07','2022-03-03 12:53:07'),(62613,177,'Dhula','303305',1,0,'2022-03-03 12:53:07','2022-03-03 12:53:07'),(62614,177,'Didawata','303006',1,0,'2022-03-03 12:53:07','2022-03-03 12:53:07'),(62615,177,'Doodhali','303301',1,0,'2022-03-03 12:53:07','2022-03-03 12:53:07'),(62616,177,'Doongri Khurd','303603',1,0,'2022-03-03 12:53:07','2022-03-03 12:53:07'),(62617,177,'Doongrikalan','303603',1,0,'2022-03-03 12:53:07','2022-03-03 12:53:07'),(62618,177,'Dosara','303006',1,0,'2022-03-03 12:53:07','2022-03-03 12:53:07'),(62619,177,'Dudu','303008',1,0,'2022-03-03 12:53:07','2022-03-03 12:53:07'),(62620,177,'Durjania Was','303706',1,0,'2022-03-03 12:53:07','2022-03-03 12:53:07'),(62621,177,'Dwarikapura','303107',1,0,'2022-03-03 12:53:07','2022-03-03 12:53:07'),(62622,177,'Etwa Bhopji','303804',1,0,'2022-03-03 12:53:07','2022-03-03 12:53:07'),(62623,177,'Faliawas','303012',1,0,'2022-03-03 12:53:08','2022-03-03 12:53:08'),(62624,177,'Fatehpura Khurd','303106',1,0,'2022-03-03 12:53:08','2022-03-03 12:53:08'),(62625,177,'Footalo','303001',1,0,'2022-03-03 12:53:08','2022-03-03 12:53:08'),(62626,177,'Gadota','303007',1,0,'2022-03-03 12:53:08','2022-03-03 12:53:08'),(62627,177,'Gagardoo','303008',1,0,'2022-03-03 12:53:08','2022-03-03 12:53:08'),(62628,177,'Gangoti Kalan','303009',1,0,'2022-03-03 12:53:08','2022-03-03 12:53:08'),(62629,177,'Garh','303302',1,0,'2022-03-03 12:53:08','2022-03-03 12:53:08'),(62630,177,'Garwasi','303901',1,0,'2022-03-03 12:53:08','2022-03-03 12:53:08'),(62631,177,'Gathwadi','303120',1,0,'2022-03-03 12:53:08','2022-03-03 12:53:08'),(62632,177,'Gehlota','303008',1,0,'2022-03-03 12:53:08','2022-03-03 12:53:08'),(62633,177,'Ghasipura','303103',1,0,'2022-03-03 12:53:08','2022-03-03 12:53:08'),(62634,177,'Ghatiyali','303005',1,0,'2022-03-03 12:53:08','2022-03-03 12:53:08'),(62635,177,'Gidhani','303348',1,0,'2022-03-03 12:53:08','2022-03-03 12:53:08'),(62636,177,'Gohandi','303904',1,0,'2022-03-03 12:53:08','2022-03-03 12:53:08'),(62637,177,'Goner','303905',1,0,'2022-03-03 12:53:08','2022-03-03 12:53:08'),(62638,177,'Gonera','303108',1,0,'2022-03-03 12:53:08','2022-03-03 12:53:08'),(62639,177,'Gopalpura','303006',1,0,'2022-03-03 12:53:08','2022-03-03 12:53:08'),(62640,177,'Gopalpura','303108',1,0,'2022-03-03 12:53:08','2022-03-03 12:53:08'),(62641,177,'Goverdhanpura','303108',1,0,'2022-03-03 12:53:08','2022-03-03 12:53:08'),(62642,177,'Govindgarh (Jaipur)','303712',1,0,'2022-03-03 12:53:08','2022-03-03 12:53:08'),(62643,177,'Govindpura Baseri','303803',1,0,'2022-03-03 12:53:08','2022-03-03 12:53:08'),(62644,177,'Gudha Bersal','303338',1,0,'2022-03-03 12:53:08','2022-03-03 12:53:08'),(62645,177,'Gudhaliya','303602',1,0,'2022-03-03 12:53:09','2022-03-03 12:53:09'),(62646,177,'Gulab Bari','303806',1,0,'2022-03-03 12:53:09','2022-03-03 12:53:09'),(62647,177,'Habaspura','303604',1,0,'2022-03-03 12:53:09','2022-03-03 12:53:09'),(62648,177,'Hadota','303702',1,0,'2022-03-03 12:53:09','2022-03-03 12:53:09'),(62649,177,'Hanutia','303601',1,0,'2022-03-03 12:53:09','2022-03-03 12:53:09'),(62650,177,'Hanutpura','303601',1,0,'2022-03-03 12:53:09','2022-03-03 12:53:09'),(62651,177,'Harsoli','303008',1,0,'2022-03-03 12:53:09','2022-03-03 12:53:09'),(62652,177,'Harsoli','303603',1,0,'2022-03-03 12:53:09','2022-03-03 12:53:09'),(62653,177,'Harsulia','303904',1,0,'2022-03-03 12:53:09','2022-03-03 12:53:09'),(62654,177,'Hasteda','303712',1,0,'2022-03-03 12:53:09','2022-03-03 12:53:09'),(62655,177,'Hathnoda','303807',1,0,'2022-03-03 12:53:09','2022-03-03 12:53:09'),(62656,177,'Heerapura','303904',1,0,'2022-03-03 12:53:09','2022-03-03 12:53:09'),(62657,177,'Hingonia','303328',1,0,'2022-03-03 12:53:09','2022-03-03 12:53:09'),(62658,177,'Hirnoda','303338',1,0,'2022-03-03 12:53:09','2022-03-03 12:53:09'),(62659,177,'Itawa','303602',1,0,'2022-03-03 12:53:09','2022-03-03 12:53:09'),(62660,177,'Jagatpura','303806',1,0,'2022-03-03 12:53:09','2022-03-03 12:53:09'),(62661,177,'Jahota','303701',1,0,'2022-03-03 12:53:09','2022-03-03 12:53:09'),(62662,177,'Jaichandpura','303120',1,0,'2022-03-03 12:53:09','2022-03-03 12:53:09'),(62663,177,'Jairampura','303701',1,0,'2022-03-03 12:53:09','2022-03-03 12:53:09'),(62664,177,'Jaisinghpura','303106',1,0,'2022-03-03 12:53:09','2022-03-03 12:53:09'),(62665,177,'Jaisinghpura','303801',1,0,'2022-03-03 12:53:09','2022-03-03 12:53:09'),(62666,177,'Jaisinghpura','303108',1,0,'2022-03-03 12:53:09','2022-03-03 12:53:09'),(62667,177,'Jaitpura I A','303704',1,0,'2022-03-03 12:53:10','2022-03-03 12:53:10'),(62668,177,'Jaitpura Khinchi','303002',1,0,'2022-03-03 12:53:10','2022-03-03 12:53:10'),(62669,177,'Jaje Kalan','303103',1,0,'2022-03-03 12:53:10','2022-03-03 12:53:10'),(62670,177,'Jalsu','303701',1,0,'2022-03-03 12:53:10','2022-03-03 12:53:10'),(62671,177,'Jamwaramgarh','303109',1,0,'2022-03-03 12:53:10','2022-03-03 12:53:10'),(62672,177,'Jatanwali','303806',1,0,'2022-03-03 12:53:10','2022-03-03 12:53:10'),(62673,177,'Jatwara','303305',1,0,'2022-03-03 12:53:10','2022-03-03 12:53:10'),(62674,177,'Jawanpura','303119',1,0,'2022-03-03 12:53:10','2022-03-03 12:53:10'),(62675,177,'Jeetawal','303012',1,0,'2022-03-03 12:53:10','2022-03-03 12:53:10'),(62676,177,'Jhag','303009',1,0,'2022-03-03 12:53:10','2022-03-03 12:53:10'),(62677,177,'Jhajwar','303305',1,0,'2022-03-03 12:53:10','2022-03-03 12:53:10'),(62678,177,'Jhapda Kalan','303908',1,0,'2022-03-03 12:53:10','2022-03-03 12:53:10'),(62679,177,'Jhar','303305',1,0,'2022-03-03 12:53:10','2022-03-03 12:53:10'),(62680,177,'Jhardla','303006',1,0,'2022-03-03 12:53:10','2022-03-03 12:53:10'),(62681,177,'Jobner','303328',1,0,'2022-03-03 12:53:10','2022-03-03 12:53:10'),(62682,177,'Jodhpura','303107',1,0,'2022-03-03 12:53:10','2022-03-03 12:53:10'),(62683,177,'Jodhula','303003',1,0,'2022-03-03 12:53:10','2022-03-03 12:53:10'),(62684,177,'Jorpura','303328',1,0,'2022-03-03 12:53:10','2022-03-03 12:53:10'),(62685,177,'Jorpura Sundariawas','303328',1,0,'2022-03-03 12:53:10','2022-03-03 12:53:10'),(62686,177,'Kacholiya','303301',1,0,'2022-03-03 12:53:10','2022-03-03 12:53:10'),(62687,177,'Kachroda','303338',1,0,'2022-03-03 12:53:10','2022-03-03 12:53:10'),(62688,177,'Kadera','303901',1,0,'2022-03-03 12:53:10','2022-03-03 12:53:10'),(62689,177,'Kaladera','303801',1,0,'2022-03-03 12:53:10','2022-03-03 12:53:10'),(62690,177,'Kalakh','303328',1,0,'2022-03-03 12:53:10','2022-03-03 12:53:10'),(62691,177,'Kali Pahadi','303002',1,0,'2022-03-03 12:53:11','2022-03-03 12:53:11'),(62692,177,'Kalwad','303706',1,0,'2022-03-03 12:53:11','2022-03-03 12:53:11'),(62693,177,'Kalyanpura','303503',1,0,'2022-03-03 12:53:11','2022-03-03 12:53:11'),(62694,177,'Kalyanpura','303108',1,0,'2022-03-03 12:53:11','2022-03-03 12:53:11'),(62695,177,'Kalyanpura Kalan','303105',1,0,'2022-03-03 12:53:11','2022-03-03 12:53:11'),(62696,177,'Kanarpura','303801',1,0,'2022-03-03 12:53:11','2022-03-03 12:53:11'),(62697,177,'Kanipura','303701',1,0,'2022-03-03 12:53:11','2022-03-03 12:53:11'),(62698,177,'Kanota','303012',1,0,'2022-03-03 12:53:11','2022-03-03 12:53:11'),(62699,177,'Kansel','303009',1,0,'2022-03-03 12:53:11','2022-03-03 12:53:11'),(62700,177,'Kansli','303108',1,0,'2022-03-03 12:53:11','2022-03-03 12:53:11'),(62701,177,'Kant','303103',1,0,'2022-03-03 12:53:11','2022-03-03 12:53:11'),(62702,177,'Kant','303002',1,0,'2022-03-03 12:53:11','2022-03-03 12:53:11'),(62703,177,'Kanwarpura','303120',1,0,'2022-03-03 12:53:11','2022-03-03 12:53:11'),(62704,177,'Karangarh','303302',1,0,'2022-03-03 12:53:11','2022-03-03 12:53:11'),(62705,177,'Karansar','303603',1,0,'2022-03-03 12:53:11','2022-03-03 12:53:11'),(62706,177,'Kareda Khurd','303901',1,0,'2022-03-03 12:53:11','2022-03-03 12:53:11'),(62707,177,'Kariri','303803',1,0,'2022-03-03 12:53:11','2022-03-03 12:53:11'),(62708,177,'Karoli','303110',1,0,'2022-03-03 12:53:11','2022-03-03 12:53:11'),(62709,177,'Kashipura','303908',1,0,'2022-03-03 12:53:11','2022-03-03 12:53:11'),(62710,177,'Kazipura','303604',1,0,'2022-03-03 12:53:11','2022-03-03 12:53:11'),(62711,177,'Keshwana','303108',1,0,'2022-03-03 12:53:11','2022-03-03 12:53:11'),(62712,177,'Khadi Bagh','303702',1,0,'2022-03-03 12:53:11','2022-03-03 12:53:11'),(62713,177,'Khajalpura','303903',1,0,'2022-03-03 12:53:11','2022-03-03 12:53:11'),(62714,177,'Khandel','303604',1,0,'2022-03-03 12:53:11','2022-03-03 12:53:11'),(62715,177,'Kharab','303105',1,0,'2022-03-03 12:53:11','2022-03-03 12:53:11'),(62716,177,'Kharkara','303109',1,0,'2022-03-03 12:53:12','2022-03-03 12:53:12'),(62717,177,'Khatipura','303301',1,0,'2022-03-03 12:53:12','2022-03-03 12:53:12'),(62718,177,'Khawa','303109',1,0,'2022-03-03 12:53:12','2022-03-03 12:53:12'),(62719,177,'Khedi Milk','303603',1,0,'2022-03-03 12:53:12','2022-03-03 12:53:12'),(62720,177,'Khejroli','303803',1,0,'2022-03-03 12:53:12','2022-03-03 12:53:12'),(62721,177,'Khelana','303106',1,0,'2022-03-03 12:53:12','2022-03-03 12:53:12'),(62722,177,'Khera Raniwas','303908',1,0,'2022-03-03 12:53:12','2022-03-03 12:53:12'),(62723,177,'Khijuria Brahmin','303903',1,0,'2022-03-03 12:53:12','2022-03-03 12:53:12'),(62724,177,'Khora Lad Khani','303120',1,0,'2022-03-03 12:53:12','2022-03-03 12:53:12'),(62725,177,'Khore Shyamdas','303704',1,0,'2022-03-03 12:53:12','2022-03-03 12:53:12'),(62726,177,'Khori','303103',1,0,'2022-03-03 12:53:12','2022-03-03 12:53:12'),(62727,177,'Khudiyala','303008',1,0,'2022-03-03 12:53:12','2022-03-03 12:53:12'),(62728,177,'Kishangarh Renwal','303603',1,0,'2022-03-03 12:53:12','2022-03-03 12:53:12'),(62729,177,'Kishanpura','303602',1,0,'2022-03-03 12:53:12','2022-03-03 12:53:12'),(62730,177,'Kishorpura','303005',1,0,'2022-03-03 12:53:12','2022-03-03 12:53:12'),(62731,177,'Kodi','303328',1,0,'2022-03-03 12:53:12','2022-03-03 12:53:12'),(62732,177,'Korsina','303604',1,0,'2022-03-03 12:53:12','2022-03-03 12:53:12'),(62733,177,'Kothoon','303901',1,0,'2022-03-03 12:53:12','2022-03-03 12:53:12'),(62734,177,'Kotkhawada','303908',1,0,'2022-03-03 12:53:12','2022-03-03 12:53:12'),(62735,177,'Kotputli','303108',1,0,'2022-03-03 12:53:12','2022-03-03 12:53:12'),(62736,177,'Kudli','303005',1,0,'2022-03-03 12:53:12','2022-03-03 12:53:12'),(62737,177,'Kujota','303108',1,0,'2022-03-03 12:53:12','2022-03-03 12:53:12'),(62738,177,'Kumariawas','303903',1,0,'2022-03-03 12:53:12','2022-03-03 12:53:12'),(62739,177,'Kunthada Khurd','303012',1,0,'2022-03-03 12:53:13','2022-03-03 12:53:13'),(62740,177,'Kuthada','303102',1,0,'2022-03-03 12:53:13','2022-03-03 12:53:13'),(62741,177,'Labana','303002',1,0,'2022-03-03 12:53:13','2022-03-03 12:53:13'),(62742,177,'Ladana','303005',1,0,'2022-03-03 12:53:13','2022-03-03 12:53:13'),(62743,177,'Ladera','303008',1,0,'2022-03-03 12:53:13','2022-03-03 12:53:13'),(62744,177,'Lakher','303104',1,0,'2022-03-03 12:53:13','2022-03-03 12:53:13'),(62745,177,'Lalasar','303603',1,0,'2022-03-03 12:53:13','2022-03-03 12:53:13'),(62746,177,'Lalgarh','303301',1,0,'2022-03-03 12:53:13','2022-03-03 12:53:13'),(62747,177,'Lalwas','303109',1,0,'2022-03-03 12:53:13','2022-03-03 12:53:13'),(62748,177,'Lasadiya','303005',1,0,'2022-03-03 12:53:13','2022-03-03 12:53:13'),(62749,177,'Let Ka Bas','303103',1,0,'2022-03-03 12:53:13','2022-03-03 12:53:13'),(62750,177,'Loharwada','303807',1,0,'2022-03-03 12:53:13','2022-03-03 12:53:13'),(62751,177,'Luhakna Khurd','303119',1,0,'2022-03-03 12:53:13','2022-03-03 12:53:13'),(62752,177,'Luniawas','303602',1,0,'2022-03-03 12:53:13','2022-03-03 12:53:13'),(62753,177,'Machwa','303706',1,0,'2022-03-03 12:53:13','2022-03-03 12:53:13'),(62754,177,'Madhorajpura','303006',1,0,'2022-03-03 12:53:13','2022-03-03 12:53:13'),(62755,177,'Mahadeopura','303302',1,0,'2022-03-03 12:53:13','2022-03-03 12:53:13'),(62756,177,'Mahangi','303109',1,0,'2022-03-03 12:53:13','2022-03-03 12:53:13'),(62757,177,'Mahar Kalan','303806',1,0,'2022-03-03 12:53:13','2022-03-03 12:53:13'),(62758,177,'Mahar Khurd','303806',1,0,'2022-03-03 12:53:13','2022-03-03 12:53:13'),(62759,177,'Mahlan','303007',1,0,'2022-03-03 12:53:13','2022-03-03 12:53:13'),(62760,177,'Malikpur','303712',1,0,'2022-03-03 12:53:13','2022-03-03 12:53:13'),(62761,177,'Malpuria','303901',1,0,'2022-03-03 12:53:13','2022-03-03 12:53:13'),(62762,177,'Malyawas','303338',1,0,'2022-03-03 12:53:13','2022-03-03 12:53:13'),(62763,177,'Mamana','303348',1,0,'2022-03-03 12:53:14','2022-03-03 12:53:14'),(62764,177,'Manda Bhim Singh','303604',1,0,'2022-03-03 12:53:14','2022-03-03 12:53:14'),(62765,177,'Manda Bhinda','303712',1,0,'2022-03-03 12:53:14','2022-03-03 12:53:14'),(62766,177,'Mandawari','303005',1,0,'2022-03-03 12:53:14','2022-03-03 12:53:14'),(62767,177,'Mandha','303110',1,0,'2022-03-03 12:53:14','2022-03-03 12:53:14'),(62768,177,'Mandi','303005',1,0,'2022-03-03 12:53:14','2022-03-03 12:53:14'),(62769,177,'Mandlia Meda','303901',1,0,'2022-03-03 12:53:14','2022-03-03 12:53:14'),(62770,177,'Mandore','303009',1,0,'2022-03-03 12:53:14','2022-03-03 12:53:14'),(62771,177,'Manoharpur (Jaipur)','303104',1,0,'2022-03-03 12:53:14','2022-03-03 12:53:14'),(62772,177,'Manoharpura','303301',1,0,'2022-03-03 12:53:14','2022-03-03 12:53:14'),(62773,177,'Manota','303109',1,0,'2022-03-03 12:53:14','2022-03-03 12:53:14'),(62774,177,'Manpura Machedi','303805',1,0,'2022-03-03 12:53:14','2022-03-03 12:53:14'),(62775,177,'Mansar Khedi','303301',1,0,'2022-03-03 12:53:14','2022-03-03 12:53:14'),(62776,177,'Markhi','303601',1,0,'2022-03-03 12:53:14','2022-03-03 12:53:14'),(62777,177,'Marwa','303348',1,0,'2022-03-03 12:53:14','2022-03-03 12:53:14'),(62778,177,'Mathasula','303109',1,0,'2022-03-03 12:53:14','2022-03-03 12:53:14'),(62779,177,'Med','303003',1,0,'2022-03-03 12:53:14','2022-03-03 12:53:14'),(62780,177,'Mehandwas','303005',1,0,'2022-03-03 12:53:14','2022-03-03 12:53:14'),(62781,177,'Mohabatpura','303904',1,0,'2022-03-03 12:53:14','2022-03-03 12:53:14'),(62782,177,'Mohanpura','303301',1,0,'2022-03-03 12:53:14','2022-03-03 12:53:14'),(62783,177,'Mohanpura','303905',1,0,'2022-03-03 12:53:15','2022-03-03 12:53:15'),(62784,177,'Mohanpura','303108',1,0,'2022-03-03 12:53:15','2022-03-03 12:53:15'),(62785,177,'Mokhampura','303604',1,0,'2022-03-03 12:53:15','2022-03-03 12:53:15'),(62786,177,'Molaheda','303108',1,0,'2022-03-03 12:53:15','2022-03-03 12:53:15'),(62787,177,'Mordha','303108',1,0,'2022-03-03 12:53:15','2022-03-03 12:53:15'),(62788,177,'Morija','303805',1,0,'2022-03-03 12:53:15','2022-03-03 12:53:15'),(62789,177,'Mozmabad','303009',1,0,'2022-03-03 12:53:15','2022-03-03 12:53:15'),(62790,177,'Mundiagaarh','303603',1,0,'2022-03-03 12:53:15','2022-03-03 12:53:15'),(62791,177,'Mundota','303706',1,0,'2022-03-03 12:53:15','2022-03-03 12:53:15'),(62792,177,'Mundoti','303328',1,0,'2022-03-03 12:53:15','2022-03-03 12:53:15'),(62793,177,'Murlipura','303328',1,0,'2022-03-03 12:53:15','2022-03-03 12:53:15'),(62794,177,'Nabhawala','303507',1,0,'2022-03-03 12:53:15','2022-03-03 12:53:15'),(62795,177,'Nanan','303008',1,0,'2022-03-03 12:53:15','2022-03-03 12:53:15'),(62796,177,'Nangal Bharda','303807',1,0,'2022-03-03 12:53:15','2022-03-03 12:53:15'),(62797,177,'Nangal Govind','303602',1,0,'2022-03-03 12:53:15','2022-03-03 12:53:15'),(62798,177,'Nangal Koju','303804',1,0,'2022-03-03 12:53:15','2022-03-03 12:53:15'),(62799,177,'Nangal Ladi','303701',1,0,'2022-03-03 12:53:15','2022-03-03 12:53:15'),(62800,177,'Nangal Panditpura','303108',1,0,'2022-03-03 12:53:15','2022-03-03 12:53:15'),(62801,177,'Nangal Turkan','303712',1,0,'2022-03-03 12:53:15','2022-03-03 12:53:15'),(62802,177,'Naraina','303348',1,0,'2022-03-03 12:53:15','2022-03-03 12:53:15'),(62803,177,'Nareda','303105',1,0,'2022-03-03 12:53:15','2022-03-03 12:53:15'),(62804,177,'Narera','303005',1,0,'2022-03-03 12:53:15','2022-03-03 12:53:15'),(62805,177,'Nathawala','303103',1,0,'2022-03-03 12:53:15','2022-03-03 12:53:15'),(62806,177,'Naupura','303801',1,0,'2022-03-03 12:53:15','2022-03-03 12:53:15'),(62807,177,'Naurangpura','303003',1,0,'2022-03-03 12:53:15','2022-03-03 12:53:15'),(62808,177,'Nawalpura','303104',1,0,'2022-03-03 12:53:16','2022-03-03 12:53:16'),(62809,177,'Naya Bas','303806',1,0,'2022-03-03 12:53:16','2022-03-03 12:53:16'),(62810,177,'Nayan','303601',1,0,'2022-03-03 12:53:16','2022-03-03 12:53:16'),(62811,177,'Nayla','303012',1,0,'2022-03-03 12:53:16','2022-03-03 12:53:16'),(62812,177,'Newar','303305',1,0,'2022-03-03 12:53:16','2022-03-03 12:53:16'),(62813,177,'Nimera','303005',1,0,'2022-03-03 12:53:16','2022-03-03 12:53:16'),(62814,177,'Nimodiya','303901',1,0,'2022-03-03 12:53:16','2022-03-03 12:53:16'),(62815,177,'NIMS University','303121',1,0,'2022-03-03 12:53:16','2022-03-03 12:53:16'),(62816,177,'Nithara','303103',1,0,'2022-03-03 12:53:16','2022-03-03 12:53:16'),(62817,177,'Niwana','303804',1,0,'2022-03-03 12:53:16','2022-03-03 12:53:16'),(62818,177,'Pachala','303005',1,0,'2022-03-03 12:53:16','2022-03-03 12:53:16'),(62819,177,'Pachar','303706',1,0,'2022-03-03 12:53:16','2022-03-03 12:53:16'),(62820,177,'Padasoli','303305',1,0,'2022-03-03 12:53:16','2022-03-03 12:53:16'),(62821,177,'Padasoli','303008',1,0,'2022-03-03 12:53:16','2022-03-03 12:53:16'),(62822,177,'Pahandia','303904',1,0,'2022-03-03 12:53:16','2022-03-03 12:53:16'),(62823,177,'Palawalan Jatan','303301',1,0,'2022-03-03 12:53:16','2022-03-03 12:53:16'),(62824,177,'Paldi','303003',1,0,'2022-03-03 12:53:16','2022-03-03 12:53:16'),(62825,177,'Panchudala','303110',1,0,'2022-03-03 12:53:16','2022-03-03 12:53:16'),(62826,177,'Panditpura','303106',1,0,'2022-03-03 12:53:16','2022-03-03 12:53:16'),(62827,177,'Paniyala','303108',1,0,'2022-03-03 12:53:16','2022-03-03 12:53:16'),(62828,177,'Panwalia','303904',1,0,'2022-03-03 12:53:16','2022-03-03 12:53:16'),(62829,177,'Paota(Jaipur)','303106',1,0,'2022-03-03 12:53:16','2022-03-03 12:53:16'),(62830,177,'Papad','303012',1,0,'2022-03-03 12:53:16','2022-03-03 12:53:16'),(62831,177,'Parwan','303005',1,0,'2022-03-03 12:53:17','2022-03-03 12:53:17'),(62832,177,'Pathredi','303107',1,0,'2022-03-03 12:53:17','2022-03-03 12:53:17'),(62833,177,'Pawana','303108',1,0,'2022-03-03 12:53:17','2022-03-03 12:53:17'),(62834,177,'Peepla','303904',1,0,'2022-03-03 12:53:17','2022-03-03 12:53:17'),(62835,177,'Phagi','303005',1,0,'2022-03-03 12:53:17','2022-03-03 12:53:17'),(62836,177,'Phulera Bazar','303338',1,0,'2022-03-03 12:53:17','2022-03-03 12:53:17'),(62837,177,'Phulera','303338',1,0,'2022-03-03 12:53:17','2022-03-03 12:53:17'),(62838,177,'Pragpura','303107',1,0,'2022-03-03 12:53:17','2022-03-03 12:53:17'),(62839,177,'Pratapura','303801',1,0,'2022-03-03 12:53:17','2022-03-03 12:53:17'),(62840,177,'Punana','303701',1,0,'2022-03-03 12:53:17','2022-03-03 12:53:17'),(62841,177,'Purshottampura','303105',1,0,'2022-03-03 12:53:17','2022-03-03 12:53:17'),(62842,177,'Radahkishanpura','303701',1,0,'2022-03-03 12:53:17','2022-03-03 12:53:17'),(62843,177,'Radawas','303601',1,0,'2022-03-03 12:53:17','2022-03-03 12:53:17'),(62844,177,'Radoli','303908',1,0,'2022-03-03 12:53:17','2022-03-03 12:53:17'),(62845,177,'Raghunathpura','303701',1,0,'2022-03-03 12:53:17','2022-03-03 12:53:17'),(62846,177,'Raghunathpura','303107',1,0,'2022-03-03 12:53:17','2022-03-03 12:53:17'),(62847,177,'Raikaranpura','303105',1,0,'2022-03-03 12:53:17','2022-03-03 12:53:17'),(62848,177,'Raipur','303001',1,0,'2022-03-03 12:53:17','2022-03-03 12:53:17'),(62849,177,'Raisar','303109',1,0,'2022-03-03 12:53:17','2022-03-03 12:53:17'),(62850,177,'Raithal','303801',1,0,'2022-03-03 12:53:17','2022-03-03 12:53:17'),(62851,177,'Rajnauta','303110',1,0,'2022-03-03 12:53:17','2022-03-03 12:53:17'),(62852,177,'Rajpura','303305',1,0,'2022-03-03 12:53:17','2022-03-03 12:53:17'),(62853,177,'Rajpurawas Tala','303002',1,0,'2022-03-03 12:53:17','2022-03-03 12:53:17'),(62854,177,'Rambura Dabari','303704',1,0,'2022-03-03 12:53:17','2022-03-03 12:53:17'),(62855,177,'Ramjipura','303603',1,0,'2022-03-03 12:53:17','2022-03-03 12:53:17'),(62856,177,'Ramnagar','303908',1,0,'2022-03-03 12:53:18','2022-03-03 12:53:18'),(62857,177,'Rampura','303103',1,0,'2022-03-03 12:53:18','2022-03-03 12:53:18'),(62858,177,'Rampura','303106',1,0,'2022-03-03 12:53:18','2022-03-03 12:53:18'),(62859,177,'Rampura Unti','303007',1,0,'2022-03-03 12:53:18','2022-03-03 12:53:18'),(62860,177,'Ramsinghpura','303108',1,0,'2022-03-03 12:53:18','2022-03-03 12:53:18'),(62861,177,'Raopura','303804',1,0,'2022-03-03 12:53:18','2022-03-03 12:53:18'),(62862,177,'Rasili','303008',1,0,'2022-03-03 12:53:18','2022-03-03 12:53:18'),(62863,177,'Rehlana','303008',1,0,'2022-03-03 12:53:18','2022-03-03 12:53:18'),(62864,177,'Renwal','303603',1,0,'2022-03-03 12:53:18','2022-03-03 12:53:18'),(62865,177,'Rojdi','303338',1,0,'2022-03-03 12:53:18','2022-03-03 12:53:18'),(62866,177,'Roopa Hedi Kalan','303908',1,0,'2022-03-03 12:53:18','2022-03-03 12:53:18'),(62867,177,'Roopahedi Khurd','303908',1,0,'2022-03-03 12:53:18','2022-03-03 12:53:18'),(62868,177,'Rundal','303805',1,0,'2022-03-03 12:53:18','2022-03-03 12:53:18'),(62869,177,'Saiwad','303103',1,0,'2022-03-03 12:53:18','2022-03-03 12:53:18'),(62870,177,'Sakhoon','303008',1,0,'2022-03-03 12:53:18','2022-03-03 12:53:18'),(62871,177,'Sali','303008',1,0,'2022-03-03 12:53:18','2022-03-03 12:53:18'),(62872,177,'Salt Colony','303604',1,0,'2022-03-03 12:53:18','2022-03-03 12:53:18'),(62873,177,'Sambhar Lake H.O','303604',1,0,'2022-03-03 12:53:18','2022-03-03 12:53:18'),(62874,177,'Sambharia','303903',1,0,'2022-03-03 12:53:18','2022-03-03 12:53:18'),(62875,177,'Samod','303806',1,0,'2022-03-03 12:53:18','2022-03-03 12:53:18'),(62876,177,'Samred Kalan','303109',1,0,'2022-03-03 12:53:18','2022-03-03 12:53:18'),(62877,177,'Sandarsar','303801',1,0,'2022-03-03 12:53:18','2022-03-03 12:53:18'),(62878,177,'Sangteda','303108',1,0,'2022-03-03 12:53:18','2022-03-03 12:53:18'),(62879,177,'Sankotra','303001',1,0,'2022-03-03 12:53:19','2022-03-03 12:53:19'),(62880,177,'Sanwali','303009',1,0,'2022-03-03 12:53:19','2022-03-03 12:53:19'),(62881,177,'Sanwalia','303901',1,0,'2022-03-03 12:53:19','2022-03-03 12:53:19'),(62882,177,'Sanwarda','303348',1,0,'2022-03-03 12:53:19','2022-03-03 12:53:19'),(62883,177,'Sarund','303105',1,0,'2022-03-03 12:53:19','2022-03-03 12:53:19'),(62884,177,'Sawai Madhosinghpura','303901',1,0,'2022-03-03 12:53:19','2022-03-03 12:53:19'),(62885,177,'Sewa','303008',1,0,'2022-03-03 12:53:19','2022-03-03 12:53:19'),(62886,177,'Sewapura','303805',1,0,'2022-03-03 12:53:19','2022-03-03 12:53:19'),(62887,177,'Shaakar Khawda','303901',1,0,'2022-03-03 12:53:19','2022-03-03 12:53:19'),(62888,177,'Shahpura H.O','303103',1,0,'2022-03-03 12:53:19','2022-03-03 12:53:19'),(62889,177,'Shardulpura','303338',1,0,'2022-03-03 12:53:19','2022-03-03 12:53:19'),(62890,177,'Shivdaspura','303903',1,0,'2022-03-03 12:53:19','2022-03-03 12:53:19'),(62891,177,'Shivsinghpura','303806',1,0,'2022-03-03 12:53:19','2022-03-03 12:53:19'),(62892,177,'Silki Doongari','303901',1,0,'2022-03-03 12:53:19','2022-03-03 12:53:19'),(62893,177,'Singot Kalan','303803',1,0,'2022-03-03 12:53:19','2022-03-03 12:53:19'),(62894,177,'Singot Khurd','303803',1,0,'2022-03-03 12:53:19','2022-03-03 12:53:19'),(62895,177,'Sinodia','303008',1,0,'2022-03-03 12:53:19','2022-03-03 12:53:19'),(62896,177,'Sinodiya','303328',1,0,'2022-03-03 12:53:19','2022-03-03 12:53:19'),(62897,177,'Sirohi','303104',1,0,'2022-03-03 12:53:19','2022-03-03 12:53:19'),(62898,177,'Sirohi Kalan','303008',1,0,'2022-03-03 12:53:19','2022-03-03 12:53:19'),(62899,177,'Sirsali','303702',1,0,'2022-03-03 12:53:19','2022-03-03 12:53:19'),(62900,177,'Sothana','303102',1,0,'2022-03-03 12:53:19','2022-03-03 12:53:19'),(62901,177,'Srirampura','303348',1,0,'2022-03-03 12:53:19','2022-03-03 12:53:19'),(62902,177,'Suderpura Dhadha','303107',1,0,'2022-03-03 12:53:19','2022-03-03 12:53:19'),(62903,177,'Sujatnagar','303107',1,0,'2022-03-03 12:53:19','2022-03-03 12:53:19'),(62904,177,'Suklawas','303105',1,0,'2022-03-03 12:53:19','2022-03-03 12:53:19'),(62905,177,'Sunderpura','303108',1,0,'2022-03-03 12:53:20','2022-03-03 12:53:20'),(62906,177,'Surana','303120',1,0,'2022-03-03 12:53:20','2022-03-03 12:53:20'),(62907,177,'Surmalikpur','303603',1,0,'2022-03-03 12:53:20','2022-03-03 12:53:20'),(62908,177,'Tala','303120',1,0,'2022-03-03 12:53:20','2022-03-03 12:53:20'),(62909,177,'Talba Bihajar','303003',1,0,'2022-03-03 12:53:20','2022-03-03 12:53:20'),(62910,177,'Tamariya','303901',1,0,'2022-03-03 12:53:20','2022-03-03 12:53:20'),(62911,177,'Tankarda','303702',1,0,'2022-03-03 12:53:20','2022-03-03 12:53:20'),(62912,177,'Taskola','303106',1,0,'2022-03-03 12:53:20','2022-03-03 12:53:20'),(62913,177,'Teetaria','303903',1,0,'2022-03-03 12:53:20','2022-03-03 12:53:20'),(62914,177,'Teja Ka Bas','303338',1,0,'2022-03-03 12:53:20','2022-03-03 12:53:20'),(62915,177,'Teori','303003',1,0,'2022-03-03 12:53:20','2022-03-03 12:53:20'),(62916,177,'Thali','303901',1,0,'2022-03-03 12:53:20','2022-03-03 12:53:20'),(62917,177,'Thali','303001',1,0,'2022-03-03 12:53:20','2022-03-03 12:53:20'),(62918,177,'Theekariya Gujran','303908',1,0,'2022-03-03 12:53:20','2022-03-03 12:53:20'),(62919,177,'Theekariya Meena','303908',1,0,'2022-03-03 12:53:20','2022-03-03 12:53:20'),(62920,177,'Thikariya','303106',1,0,'2022-03-03 12:53:20','2022-03-03 12:53:20'),(62921,177,'Tholai','303001',1,0,'2022-03-03 12:53:20','2022-03-03 12:53:20'),(62922,177,'Thoomli Ka Bas','303901',1,0,'2022-03-03 12:53:20','2022-03-03 12:53:20'),(62923,177,'Tigaria','303804',1,0,'2022-03-03 12:53:20','2022-03-03 12:53:20'),(62924,177,'Toda Bhata','303301',1,0,'2022-03-03 12:53:20','2022-03-03 12:53:20'),(62925,177,'Toonga','303302',1,0,'2022-03-03 12:53:20','2022-03-03 12:53:20'),(62926,177,'Toontoli','303903',1,0,'2022-03-03 12:53:21','2022-03-03 12:53:21'),(62927,177,'Torda Kalan','303106',1,0,'2022-03-03 12:53:21','2022-03-03 12:53:21'),(62928,177,'Tripolia Chomu','303702',1,0,'2022-03-03 12:53:21','2022-03-03 12:53:21'),(62929,177,'Turkyawas','303602',1,0,'2022-03-03 12:53:21','2022-03-03 12:53:21'),(62930,177,'Tyod','303604',1,0,'2022-03-03 12:53:21','2022-03-03 12:53:21'),(62931,177,'Udaipuria','303509',1,0,'2022-03-03 12:53:21','2022-03-03 12:53:21'),(62932,177,'Udaipuria','303807',1,0,'2022-03-03 12:53:21','2022-03-03 12:53:21'),(62933,177,'Ugariwas','303338',1,0,'2022-03-03 12:53:21','2022-03-03 12:53:21'),(62934,177,'Vedaant Gyan Valley','303122',1,0,'2022-03-03 12:53:21','2022-03-03 12:53:21'),(62935,177,'Veelpur','303104',1,0,'2022-03-03 12:53:21','2022-03-03 12:53:21'),(62936,177,'Vidhani','303905',1,0,'2022-03-03 12:53:21','2022-03-03 12:53:21'),(62937,177,'Virat Nagar','303102',1,0,'2022-03-03 12:53:21','2022-03-03 12:53:21'),(62938,177,'Watika','303905',1,0,'2022-03-03 12:53:21','2022-03-03 12:53:21'),(62939,177,'Yaarlipura','303903',1,0,'2022-03-03 12:53:21','2022-03-03 12:53:21'),(62940,178,'Adabala','345001',1,0,'2022-03-03 12:53:21','2022-03-03 12:53:21'),(62941,178,'Ajasar','345023',1,0,'2022-03-03 12:53:21','2022-03-03 12:53:21'),(62942,178,'Amarsalagar','345001',1,0,'2022-03-03 12:53:21','2022-03-03 12:53:21'),(62943,178,'Askandra','345028',1,0,'2022-03-03 12:53:21','2022-03-03 12:53:21'),(62944,178,'Away','345028',1,0,'2022-03-03 12:53:21','2022-03-03 12:53:21'),(62945,178,'Badoda Gaon','345001',1,0,'2022-03-03 12:53:21','2022-03-03 12:53:21'),(62946,178,'Baghthal','345021',1,0,'2022-03-03 12:53:21','2022-03-03 12:53:21'),(62947,178,'Bahala','345028',1,0,'2022-03-03 12:53:21','2022-03-03 12:53:21'),(62948,178,'Baiya','345027',1,0,'2022-03-03 12:53:22','2022-03-03 12:53:22'),(62949,178,'Balu Singh Ki Dhani','345024',1,0,'2022-03-03 12:53:22','2022-03-03 12:53:22'),(62950,178,'Bamnu','345021',1,0,'2022-03-03 12:53:22','2022-03-03 12:53:22'),(62951,178,'Bandha','345001',1,0,'2022-03-03 12:53:22','2022-03-03 12:53:22'),(62952,178,'Bandhewa','345025',1,0,'2022-03-03 12:53:22','2022-03-03 12:53:22'),(62953,178,'Baramsar','345001',1,0,'2022-03-03 12:53:22','2022-03-03 12:53:22'),(62954,178,'Barath Ka Gaon','345021',1,0,'2022-03-03 12:53:22','2022-03-03 12:53:22'),(62955,178,'Bardana','345023',1,0,'2022-03-03 12:53:22','2022-03-03 12:53:22'),(62956,178,'Bericiyala','345034',1,0,'2022-03-03 12:53:22','2022-03-03 12:53:22'),(62957,178,'Bhadariya','345031',1,0,'2022-03-03 12:53:22','2022-03-03 12:53:22'),(62958,178,'Bhadasar','345001',1,0,'2022-03-03 12:53:22','2022-03-03 12:53:22'),(62959,178,'Bhadli','345027',1,0,'2022-03-03 12:53:22','2022-03-03 12:53:22'),(62960,178,'Bhagu Ka Gaon','345001',1,0,'2022-03-03 12:53:22','2022-03-03 12:53:22'),(62961,178,'Bhaniyana','345024',1,0,'2022-03-03 12:53:22','2022-03-03 12:53:22'),(62962,178,'Bharewala','345028',1,0,'2022-03-03 12:53:22','2022-03-03 12:53:22'),(62963,178,'Bhensara','345026',1,0,'2022-03-03 12:53:22','2022-03-03 12:53:22'),(62964,178,'Bhikodai','345025',1,0,'2022-03-03 12:53:22','2022-03-03 12:53:22'),(62965,178,'Bhoo','345001',1,0,'2022-03-03 12:53:22','2022-03-03 12:53:22'),(62966,178,'Bida','345001',1,0,'2022-03-03 12:53:22','2022-03-03 12:53:22'),(62967,178,'Bodana','342310',1,0,'2022-03-03 12:53:22','2022-03-03 12:53:22'),(62968,178,'Bonada','345026',1,0,'2022-03-03 12:53:22','2022-03-03 12:53:22'),(62969,178,'Burkiya','345021',1,0,'2022-03-03 12:53:22','2022-03-03 12:53:22'),(62970,178,'Chacha','345031',1,0,'2022-03-03 12:53:22','2022-03-03 12:53:22'),(62971,178,'Chandan','345031',1,0,'2022-03-03 12:53:22','2022-03-03 12:53:22'),(62972,178,'Chandsama','345021',1,0,'2022-03-03 12:53:22','2022-03-03 12:53:22'),(62973,178,'Chayan','345023',1,0,'2022-03-03 12:53:22','2022-03-03 12:53:22'),(62974,178,'Chelak','345001',1,0,'2022-03-03 12:53:23','2022-03-03 12:53:23'),(62975,178,'Chhatrel','345001',1,0,'2022-03-03 12:53:23','2022-03-03 12:53:23'),(62976,178,'Chinu','345028',1,0,'2022-03-03 12:53:23','2022-03-03 12:53:23'),(62977,178,'Chowk','345021',1,0,'2022-03-03 12:53:23','2022-03-03 12:53:23'),(62978,178,'Dabla','345001',1,0,'2022-03-03 12:53:23','2022-03-03 12:53:23'),(62979,178,'Dadhu','345021',1,0,'2022-03-03 12:53:23','2022-03-03 12:53:23'),(62980,178,'Damodara','345001',1,0,'2022-03-03 12:53:23','2022-03-03 12:53:23'),(62981,178,'Dangara','345001',1,0,'2022-03-03 12:53:23','2022-03-03 12:53:23'),(62982,178,'Dantal','345025',1,0,'2022-03-03 12:53:23','2022-03-03 12:53:23'),(62983,178,'Dedha','345001',1,0,'2022-03-03 12:53:23','2022-03-03 12:53:23'),(62984,178,'Delasar','345031',1,0,'2022-03-03 12:53:23','2022-03-03 12:53:23'),(62985,178,'Deora','345001',1,0,'2022-03-03 12:53:23','2022-03-03 12:53:23'),(62986,178,'Devikot','345027',1,0,'2022-03-03 12:53:23','2022-03-03 12:53:23'),(62987,178,'Dewa','345001',1,0,'2022-03-03 12:53:23','2022-03-03 12:53:23'),(62988,178,'Dhaisar','345001',1,0,'2022-03-03 12:53:23','2022-03-03 12:53:23'),(62989,178,'Dholiya','345031',1,0,'2022-03-03 12:53:23','2022-03-03 12:53:23'),(62990,178,'Didhu','345028',1,0,'2022-03-03 12:53:23','2022-03-03 12:53:23'),(62991,178,'Ekah','345023',1,0,'2022-03-03 12:53:23','2022-03-03 12:53:23'),(62992,178,'Fatehgarh','345027',1,0,'2022-03-03 12:53:23','2022-03-03 12:53:23'),(62993,178,'Gandhi Colony Jaisalmer','345001',1,0,'2022-03-03 12:53:23','2022-03-03 12:53:23'),(62994,178,'Gomat','345021',1,0,'2022-03-03 12:53:23','2022-03-03 12:53:23'),(62995,178,'Hamira','345033',1,0,'2022-03-03 12:53:23','2022-03-03 12:53:23'),(62996,178,'Jaimla','345024',1,0,'2022-03-03 12:53:23','2022-03-03 12:53:23'),(62997,178,'Jaisalmer Bsf','345001',1,0,'2022-03-03 12:53:23','2022-03-03 12:53:23'),(62998,178,'Jaisalmer Collectorate','345001',1,0,'2022-03-03 12:53:23','2022-03-03 12:53:23'),(62999,178,'Jaisalmer Gopa Chowk','345001',1,0,'2022-03-03 12:53:24','2022-03-03 12:53:24'),(63000,178,'Jaisalmer H.O','345001',1,0,'2022-03-03 12:53:24','2022-03-03 12:53:24'),(63001,178,'Jaisalmer Ignp Colony','345001',1,0,'2022-03-03 12:53:24','2022-03-03 12:53:24'),(63002,178,'Jhabra','345021',1,0,'2022-03-03 12:53:24','2022-03-03 12:53:24'),(63003,178,'Jhalaria','345021',1,0,'2022-03-03 12:53:24','2022-03-03 12:53:24'),(63004,178,'Jhinjhinyali','345027',1,0,'2022-03-03 12:53:24','2022-03-03 12:53:24'),(63005,178,'Kanod Rawaliya','345033',1,0,'2022-03-03 12:53:24','2022-03-03 12:53:24'),(63006,178,'Kanoi','345001',1,0,'2022-03-03 12:53:24','2022-03-03 12:53:24'),(63007,178,'Kapuriya','345027',1,0,'2022-03-03 12:53:24','2022-03-03 12:53:24'),(63008,178,'Karda','345034',1,0,'2022-03-03 12:53:24','2022-03-03 12:53:24'),(63009,178,'Kathori','345001',1,0,'2022-03-03 12:53:24','2022-03-03 12:53:24'),(63010,178,'Keeta','345001',1,0,'2022-03-03 12:53:24','2022-03-03 12:53:24'),(63011,178,'Kelawa','345021',1,0,'2022-03-03 12:53:24','2022-03-03 12:53:24'),(63012,178,'Khara','345023',1,0,'2022-03-03 12:53:24','2022-03-03 12:53:24'),(63013,178,'Khetolai','345031',1,0,'2022-03-03 12:53:24','2022-03-03 12:53:24'),(63014,178,'Khinya','345001',1,0,'2022-03-03 12:53:24','2022-03-03 12:53:24'),(63015,178,'Khoohri','345034',1,0,'2022-03-03 12:53:24','2022-03-03 12:53:24'),(63016,178,'Khuiyala','345001',1,0,'2022-03-03 12:53:24','2022-03-03 12:53:24'),(63017,178,'Koda','345027',1,0,'2022-03-03 12:53:24','2022-03-03 12:53:24'),(63018,178,'Kotri','345034',1,0,'2022-03-03 12:53:24','2022-03-03 12:53:24'),(63019,178,'Kunda','345027',1,0,'2022-03-03 12:53:24','2022-03-03 12:53:24'),(63020,178,'Lakha','345027',1,0,'2022-03-03 12:53:24','2022-03-03 12:53:24'),(63021,178,'Lanela','345001',1,0,'2022-03-03 12:53:24','2022-03-03 12:53:24'),(63022,178,'Lathi (Jaisalmer)','345031',1,0,'2022-03-03 12:53:24','2022-03-03 12:53:24'),(63023,178,'Lawan','345021',1,0,'2022-03-03 12:53:25','2022-03-03 12:53:25'),(63024,178,'Loharki','345023',1,0,'2022-03-03 12:53:25','2022-03-03 12:53:25'),(63025,178,'Lohawat','342302',1,0,'2022-03-03 12:53:25','2022-03-03 12:53:25'),(63026,178,'Loona Kallan','345026',1,0,'2022-03-03 12:53:25','2022-03-03 12:53:25'),(63027,178,'Loona Khurd','345026',1,0,'2022-03-03 12:53:25','2022-03-03 12:53:25'),(63028,178,'Lunar','345034',1,0,'2022-03-03 12:53:25','2022-03-03 12:53:25'),(63029,178,'Madasar','345028',1,0,'2022-03-03 12:53:25','2022-03-03 12:53:25'),(63030,178,'Madwa','345024',1,0,'2022-03-03 12:53:25','2022-03-03 12:53:25'),(63031,178,'Mandla','345021',1,0,'2022-03-03 12:53:25','2022-03-03 12:53:25'),(63032,178,'Modardi','345021',1,0,'2022-03-03 12:53:25','2022-03-03 12:53:25'),(63033,178,'Modha','345027',1,0,'2022-03-03 12:53:25','2022-03-03 12:53:25'),(63034,178,'Mohangarh (Jaisalmer)','345033',1,0,'2022-03-03 12:53:25','2022-03-03 12:53:25'),(63035,178,'Mokhala','345001',1,0,'2022-03-03 12:53:25','2022-03-03 12:53:25'),(63036,178,'Mulana','345001',1,0,'2022-03-03 12:53:25','2022-03-03 12:53:25'),(63037,178,'Myazhar','345034',1,0,'2022-03-03 12:53:25','2022-03-03 12:53:25'),(63038,178,'Nachana','345028',1,0,'2022-03-03 12:53:25','2022-03-03 12:53:25'),(63039,178,'Narsinghaon Ki Dhani','345001',1,0,'2022-03-03 12:53:25','2022-03-03 12:53:25'),(63040,178,'Nathusar','345021',1,0,'2022-03-03 12:53:25','2022-03-03 12:53:25'),(63041,178,'Nedai','345001',1,0,'2022-03-03 12:53:25','2022-03-03 12:53:25'),(63042,178,'Nedan','345026',1,0,'2022-03-03 12:53:25','2022-03-03 12:53:25'),(63043,178,'Nokh','342310',1,0,'2022-03-03 12:53:25','2022-03-03 12:53:25'),(63044,178,'Odhania','345031',1,0,'2022-03-03 12:53:25','2022-03-03 12:53:25'),(63045,178,'Ola','345026',1,0,'2022-03-03 12:53:25','2022-03-03 12:53:25'),(63046,178,'Padampura','345025',1,0,'2022-03-03 12:53:25','2022-03-03 12:53:25'),(63047,178,'Padroda','345021',1,0,'2022-03-03 12:53:25','2022-03-03 12:53:25'),(63048,178,'Pancheka Talab','345028',1,0,'2022-03-03 12:53:25','2022-03-03 12:53:25'),(63049,178,'Pannasar','345024',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63050,178,'Parewar','345001',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63051,178,'Phalsund','345025',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63052,178,'Phulasar','345025',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63053,178,'Phulia','345034',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63054,178,'Pithala','345034',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63055,178,'Pochina','345034',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63056,178,'Pokaran','345021',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63057,178,'Raghwa','345022',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63058,178,'Rajgarh','345026',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63059,178,'Rajmathai','345025',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63060,178,'Rama','345027',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63061,178,'Ramdeora','345023',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63062,178,'Ramgarh (Jaisalmer)','345022',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63063,178,'Randha','345027',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63064,178,'Rasla','345001',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63065,178,'Ratariya','345021',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63066,178,'Rewari','345027',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63067,178,'Roopsi','345001',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63068,178,'Sam','345001',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63069,178,'Sanawara','345026',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63070,178,'Sangad','345027',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63071,178,'Sankra (Jaisalmer)','345026',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63072,178,'Sanwara Gaon','342310',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63073,178,'Satto','345034',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63074,178,'Satyaya','345028',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63075,178,'Seerhar','345027',1,0,'2022-03-03 12:53:26','2022-03-03 12:53:26'),(63076,178,'Seuwa','345022',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63077,178,'Sodakore','345031',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63078,178,'Sohanpura','345025',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63079,178,'Sonu','345001',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63080,178,'Sultana','345001',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63081,178,'Swami Ki Dhani','345025',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63082,178,'Tadana','345028',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63083,178,'Tanot','345022',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63084,178,'Tawriwala','345028',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63085,178,'Tejmalta','345027',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63086,178,'Tejrawa','345027',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63087,178,'Ujlan','345021',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63088,178,'Utwaliya','345021',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63089,179,'Achalpur','343041',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63090,179,'Agawari','307030',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63091,179,'Ahore','307029',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63092,179,'Aipura','307029',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63093,179,'Ajodar','343040',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63094,179,'Akhrad','343039',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63095,179,'Akoli','343025',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63096,179,'Akoli','343041',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63097,179,'Alasan','343001',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63098,179,'Alri','343049',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63099,179,'Amli','343027',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63100,179,'Anwloj','343042',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63101,179,'Arnay','343041',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63102,179,'Asana','343022',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63103,179,'Babtra','343022',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63104,179,'Badanwari','307029',1,0,'2022-03-03 12:53:27','2022-03-03 12:53:27'),(63105,179,'Bagoda','343032',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63106,179,'Bagra','343025',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63107,179,'Bakra','343025',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63108,179,'Bakra Road','343025',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63109,179,'Bala','307029',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63110,179,'Balera','343041',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63111,179,'Balwara','343042',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63112,179,'Bankli','307029',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63113,179,'Baori','307029',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63114,179,'Basda Dhanji','343028',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63115,179,'Bawarla','343041',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63116,179,'Bedana','307030',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63117,179,'Berath','343025',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63118,179,'Bhadrajun','307029',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63119,179,'Bhadruna','343041',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63120,179,'Bhadvi','343029',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63121,179,'Bhadwal','343041',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63122,179,'Bhagal Bhim','343029',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63123,179,'Bhagal Sefta','343029',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63124,179,'Bhagli Sindhlan','343001',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63125,179,'Bhalni','343029',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63126,179,'Bharudi','343029',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63127,179,'Bhawatra','343041',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63128,179,'Bhawrani','343042',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63129,179,'Bhenswara','307029',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63130,179,'Bhetala','343024',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63131,179,'Bhimguda','343027',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63132,179,'Bhinmal','343029',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63133,179,'Bhinmal Sadar Bazar','343029',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63134,179,'Bhorda','307029',1,0,'2022-03-03 12:53:28','2022-03-03 12:53:28'),(63135,179,'Bhuti','307030',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63136,179,'Bibalsar','343025',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63137,179,'Bichhawadi','343041',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63138,179,'Bilar','343049',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63139,179,'Binjrol','343040',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63140,179,'Birol','343041',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63141,179,'Bishangarh','343042',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63142,179,'Bithura','307030',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63143,179,'Boogaon','307803',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63144,179,'Borta','343029',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63145,179,'Chandana','343024',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63146,179,'Chandrai','307030',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63147,179,'Chandur','307803',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63148,179,'Charli','307029',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63149,179,'Chatwara','343029',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63150,179,'Chawarcha','343001',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63151,179,'Chenpura','343032',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63152,179,'Chirpatia','343049',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63153,179,'Chitalwana','343041',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63154,179,'Chitrodi','343049',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63155,179,'Chora','343041',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63156,179,'Chorau','343022',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63157,179,'Chunda','307029',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63158,179,'Chura','343025',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63159,179,'Dabal','343041',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63160,179,'Dadal','343032',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63161,179,'Dakatra','343025',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63162,179,'Dangra','343021',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63163,179,'Dantlawas','307515',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63164,179,'Dantwara','343040',1,0,'2022-03-03 12:53:29','2022-03-03 12:53:29'),(63165,179,'Daspan','343029',1,0,'2022-03-03 12:53:30','2022-03-03 12:53:30'),(63166,179,'Dawal','343027',1,0,'2022-03-03 12:53:30','2022-03-03 12:53:30'),(63167,179,'Dayalpura','307030',1,0,'2022-03-03 12:53:30','2022-03-03 12:53:30'),(63168,179,'Debawas','343042',1,0,'2022-03-03 12:53:30','2022-03-03 12:53:30'),(63169,179,'Degaon','343025',1,0,'2022-03-03 12:53:30','2022-03-03 12:53:30'),(63170,179,'Deoki','307029',1,0,'2022-03-03 12:53:30','2022-03-03 12:53:30'),(63171,179,'Deora','343040',1,0,'2022-03-03 12:53:30','2022-03-03 12:53:30'),(63172,179,'Detakalan','343032',1,0,'2022-03-03 12:53:30','2022-03-03 12:53:30'),(63173,179,'Dhamana','343041',1,0,'2022-03-03 12:53:30','2022-03-03 12:53:30'),(63174,179,'Dhamseen','343048',1,0,'2022-03-03 12:53:30','2022-03-03 12:53:30'),(63175,179,'Dhanol','343040',1,0,'2022-03-03 12:53:30','2022-03-03 12:53:30'),(63176,179,'Dhansa','343023',1,0,'2022-03-03 12:53:30','2022-03-03 12:53:30'),(63177,179,'Dhumbadia','343030',1,0,'2022-03-03 12:53:30','2022-03-03 12:53:30'),(63178,179,'Dodiyali','307030',1,0,'2022-03-03 12:53:30','2022-03-03 12:53:30'),(63179,179,'Doodsi','343025',1,0,'2022-03-03 12:53:30','2022-03-03 12:53:30'),(63180,179,'Dorda','307515',1,0,'2022-03-03 12:53:30','2022-03-03 12:53:30'),(63181,179,'Dungarwas','343030',1,0,'2022-03-03 12:53:30','2022-03-03 12:53:30'),(63182,179,'Dungri','343041',1,0,'2022-03-03 12:53:30','2022-03-03 12:53:30'),(63183,179,'Dungri','343040',1,0,'2022-03-03 12:53:30','2022-03-03 12:53:30'),(63184,179,'Duthwa','343041',1,0,'2022-03-03 12:53:30','2022-03-03 12:53:30'),(63185,179,'Elana','343021',1,0,'2022-03-03 12:53:30','2022-03-03 12:53:30'),(63186,179,'Fagotra','343029',1,0,'2022-03-03 12:53:30','2022-03-03 12:53:30'),(63187,179,'Gajapura','307515',1,0,'2022-03-03 12:53:30','2022-03-03 12:53:30'),(63188,179,'Gazipura','343029',1,0,'2022-03-03 12:53:30','2022-03-03 12:53:30'),(63189,179,'Ghana','307029',1,0,'2022-03-03 12:53:30','2022-03-03 12:53:30'),(63190,179,'Godan','307029',1,0,'2022-03-03 12:53:30','2022-03-03 12:53:30'),(63191,179,'Golana','307515',1,0,'2022-03-03 12:53:31','2022-03-03 12:53:31'),(63192,179,'Golasan','343041',1,0,'2022-03-03 12:53:31','2022-03-03 12:53:31'),(63193,179,'Gong','343040',1,0,'2022-03-03 12:53:31','2022-03-03 12:53:31'),(63194,179,'Govindla','307029',1,0,'2022-03-03 12:53:31','2022-03-03 12:53:31'),(63195,179,'Gudabalotan','307030',1,0,'2022-03-03 12:53:31','2022-03-03 12:53:31'),(63196,179,'Gundau','343040',1,0,'2022-03-03 12:53:31','2022-03-03 12:53:31'),(63197,179,'Hadecha','343027',1,0,'2022-03-03 12:53:31','2022-03-03 12:53:31'),(63198,179,'Hadetar','343041',1,0,'2022-03-03 12:53:31','2022-03-03 12:53:31'),(63199,179,'Hariyali','343041',1,0,'2022-03-03 12:53:31','2022-03-03 12:53:31'),(63200,179,'Harji','343001',1,0,'2022-03-03 12:53:31','2022-03-03 12:53:31'),(63201,179,'Hemguda','343040',1,0,'2022-03-03 12:53:31','2022-03-03 12:53:31'),(63202,179,'Hotigaon','343041',1,0,'2022-03-03 12:53:31','2022-03-03 12:53:31'),(63203,179,'I.A.Jalore','343002',1,0,'2022-03-03 12:53:31','2022-03-03 12:53:31'),(63204,179,'Itada','343040',1,0,'2022-03-03 12:53:31','2022-03-03 12:53:31'),(63205,179,'Jaisawas','343032',1,0,'2022-03-03 12:53:31','2022-03-03 12:53:31'),(63206,179,'Jaitu','343030',1,0,'2022-03-03 12:53:31','2022-03-03 12:53:31'),(63207,179,'Jakhal','343041',1,0,'2022-03-03 12:53:31','2022-03-03 12:53:31'),(63208,179,'Jalore Coll.','343001',1,0,'2022-03-03 12:53:31','2022-03-03 12:53:31'),(63209,179,'Jalore H.O','343001',1,0,'2022-03-03 12:53:31','2022-03-03 12:53:31'),(63210,179,'Jalore V.D.C.','343001',1,0,'2022-03-03 12:53:31','2022-03-03 12:53:31'),(63211,179,'Janvi','343027',1,0,'2022-03-03 12:53:31','2022-03-03 12:53:31'),(63212,179,'Jaswantpura','307515',1,0,'2022-03-03 12:53:31','2022-03-03 12:53:31'),(63213,179,'Jeewana','343022',1,0,'2022-03-03 12:53:31','2022-03-03 12:53:31'),(63214,179,'Jeran','343030',1,0,'2022-03-03 12:53:31','2022-03-03 12:53:31'),(63215,179,'Jhab','343040',1,0,'2022-03-03 12:53:32','2022-03-03 12:53:32'),(63216,179,'Jhakhari','343040',1,0,'2022-03-03 12:53:32','2022-03-03 12:53:32'),(63217,179,'Jodwara','343029',1,0,'2022-03-03 12:53:32','2022-03-03 12:53:32'),(63218,179,'Joojani','343030',1,0,'2022-03-03 12:53:32','2022-03-03 12:53:32'),(63219,179,'Kagmala','343049',1,0,'2022-03-03 12:53:32','2022-03-03 12:53:32'),(63220,179,'Kalapura','307515',1,0,'2022-03-03 12:53:32','2022-03-03 12:53:32'),(63221,179,'Kaleti','343030',1,0,'2022-03-03 12:53:32','2022-03-03 12:53:32'),(63222,179,'Kamba','307029',1,0,'2022-03-03 12:53:32','2022-03-03 12:53:32'),(63223,179,'Kardan','343040',1,0,'2022-03-03 12:53:32','2022-03-03 12:53:32'),(63224,179,'Karola','343041',1,0,'2022-03-03 12:53:32','2022-03-03 12:53:32'),(63225,179,'Karwada','343040',1,0,'2022-03-03 12:53:32','2022-03-03 12:53:32'),(63226,179,'Kawarada','307030',1,0,'2022-03-03 12:53:32','2022-03-03 12:53:32'),(63227,179,'Kawatra','343030',1,0,'2022-03-03 12:53:32','2022-03-03 12:53:32'),(63228,179,'Kawlan','307030',1,0,'2022-03-03 12:53:32','2022-03-03 12:53:32'),(63229,179,'Keriya','343041',1,0,'2022-03-03 12:53:32','2022-03-03 12:53:32'),(63230,179,'Keshwana','343001',1,0,'2022-03-03 12:53:32','2022-03-03 12:53:32'),(63231,179,'Khanpur','343029',1,0,'2022-03-03 12:53:32','2022-03-03 12:53:32'),(63232,179,'Khara','343041',1,0,'2022-03-03 12:53:32','2022-03-03 12:53:32'),(63233,179,'Khejariyali','343027',1,0,'2022-03-03 12:53:32','2022-03-03 12:53:32'),(63234,179,'Kishangarh','307029',1,0,'2022-03-03 12:53:32','2022-03-03 12:53:32'),(63235,179,'Komta','343030',1,0,'2022-03-03 12:53:32','2022-03-03 12:53:32'),(63236,179,'Kora','343029',1,0,'2022-03-03 12:53:32','2022-03-03 12:53:32'),(63237,179,'Kori','343049',1,0,'2022-03-03 12:53:32','2022-03-03 12:53:32'),(63238,179,'Koridhawecha','343032',1,0,'2022-03-03 12:53:32','2022-03-03 12:53:32'),(63239,179,'Korka','343040',1,0,'2022-03-03 12:53:32','2022-03-03 12:53:32'),(63240,179,'Kotkastan','343029',1,0,'2022-03-03 12:53:32','2022-03-03 12:53:32'),(63241,179,'Kuda','343040',1,0,'2022-03-03 12:53:33','2022-03-03 12:53:33'),(63242,179,'Kuka','343029',1,0,'2022-03-03 12:53:33','2022-03-03 12:53:33'),(63243,179,'Ledarmer','343029',1,0,'2022-03-03 12:53:33','2022-03-03 12:53:33'),(63244,179,'Leta','343001',1,0,'2022-03-03 12:53:33','2022-03-03 12:53:33'),(63245,179,'Loonawas','343030',1,0,'2022-03-03 12:53:33','2022-03-03 12:53:33'),(63246,179,'Luniyasar','343041',1,0,'2022-03-03 12:53:33','2022-03-03 12:53:33'),(63247,179,'Madgaon','343025',1,0,'2022-03-03 12:53:33','2022-03-03 12:53:33'),(63248,179,'Malwara','343039',1,0,'2022-03-03 12:53:33','2022-03-03 12:53:33'),(63249,179,'Mandhar','343029',1,0,'2022-03-03 12:53:33','2022-03-03 12:53:33'),(63250,179,'Mandoli Nagar','307803',1,0,'2022-03-03 12:53:33','2022-03-03 12:53:33'),(63251,179,'Mandwala','343042',1,0,'2022-03-03 12:53:33','2022-03-03 12:53:33'),(63252,179,'Meda','343040',1,0,'2022-03-03 12:53:33','2022-03-03 12:53:33'),(63253,179,'Meda Uparla','343001',1,0,'2022-03-03 12:53:33','2022-03-03 12:53:33'),(63254,179,'Meghalwa','343022',1,0,'2022-03-03 12:53:33','2022-03-03 12:53:33'),(63255,179,'Modran','343028',1,0,'2022-03-03 12:53:33','2022-03-03 12:53:33'),(63256,179,'Morseem','343032',1,0,'2022-03-03 12:53:33','2022-03-03 12:53:33'),(63257,179,'Mudtrasili','307803',1,0,'2022-03-03 12:53:33','2022-03-03 12:53:33'),(63258,179,'Munthala Kaba','343029',1,0,'2022-03-03 12:53:33','2022-03-03 12:53:33'),(63259,179,'Nandia','343032',1,0,'2022-03-03 12:53:33','2022-03-03 12:53:33'),(63260,179,'Narnawas','343025',1,0,'2022-03-03 12:53:33','2022-03-03 12:53:33'),(63261,179,'Narsana','343030',1,0,'2022-03-03 12:53:33','2022-03-03 12:53:33'),(63262,179,'Narta','343029',1,0,'2022-03-03 12:53:33','2022-03-03 12:53:33'),(63263,179,'Nasoli','343029',1,0,'2022-03-03 12:53:33','2022-03-03 12:53:33'),(63264,179,'Neelkanth','307029',1,0,'2022-03-03 12:53:33','2022-03-03 12:53:33'),(63265,179,'Nenol','343041',1,0,'2022-03-03 12:53:33','2022-03-03 12:53:33'),(63266,179,'Nimbawas','343029',1,0,'2022-03-03 12:53:33','2022-03-03 12:53:33'),(63267,179,'Nimbla','307029',1,0,'2022-03-03 12:53:34','2022-03-03 12:53:34'),(63268,179,'Nimblana','343021',1,0,'2022-03-03 12:53:34','2022-03-03 12:53:34'),(63269,179,'Noon','343025',1,0,'2022-03-03 12:53:34','2022-03-03 12:53:34'),(63270,179,'Norwa','307029',1,0,'2022-03-03 12:53:34','2022-03-03 12:53:34'),(63271,179,'Nosra','307029',1,0,'2022-03-03 12:53:34','2022-03-03 12:53:34'),(63272,179,'Odwara','343042',1,0,'2022-03-03 12:53:34','2022-03-03 12:53:34'),(63273,179,'Othwala','343021',1,0,'2022-03-03 12:53:34','2022-03-03 12:53:34'),(63274,179,'Padarli','307030',1,0,'2022-03-03 12:53:34','2022-03-03 12:53:34'),(63275,179,'Palasia','307030',1,0,'2022-03-03 12:53:34','2022-03-03 12:53:34'),(63276,179,'Pamana','343040',1,0,'2022-03-03 12:53:34','2022-03-03 12:53:34'),(63277,179,'Panchala','343041',1,0,'2022-03-03 12:53:34','2022-03-03 12:53:34'),(63278,179,'Panchota','307030',1,0,'2022-03-03 12:53:34','2022-03-03 12:53:34'),(63279,179,'Panseri','343049',1,0,'2022-03-03 12:53:34','2022-03-03 12:53:34'),(63280,179,'Pantheri','343023',1,0,'2022-03-03 12:53:34','2022-03-03 12:53:34'),(63281,179,'Paoli','343029',1,0,'2022-03-03 12:53:34','2022-03-03 12:53:34'),(63282,179,'Paota','307030',1,0,'2022-03-03 12:53:34','2022-03-03 12:53:34'),(63283,179,'Parawa','343041',1,0,'2022-03-03 12:53:34','2022-03-03 12:53:34'),(63284,179,'Posana','343022',1,0,'2022-03-03 12:53:34','2022-03-03 12:53:34'),(63285,179,'Punakkalan','307803',1,0,'2022-03-03 12:53:34','2022-03-03 12:53:34'),(63286,179,'Punasa','343029',1,0,'2022-03-03 12:53:34','2022-03-03 12:53:34'),(63287,179,'Pur','343041',1,0,'2022-03-03 12:53:34','2022-03-03 12:53:34'),(63288,179,'Puran','343039',1,0,'2022-03-03 12:53:34','2022-03-03 12:53:34'),(63289,179,'Rah','343030',1,0,'2022-03-03 12:53:34','2022-03-03 12:53:34'),(63290,179,'Raipuria','343024',1,0,'2022-03-03 12:53:34','2022-03-03 12:53:34'),(63291,179,'Raithal','343042',1,0,'2022-03-03 12:53:34','2022-03-03 12:53:34'),(63292,179,'Rajikawas','307515',1,0,'2022-03-03 12:53:35','2022-03-03 12:53:35'),(63293,179,'Rama','307029',1,0,'2022-03-03 12:53:35','2022-03-03 12:53:35'),(63294,179,'Ramseen','307803',1,0,'2022-03-03 12:53:35','2022-03-03 12:53:35'),(63295,179,'Rangala','343032',1,0,'2022-03-03 12:53:35','2022-03-03 12:53:35'),(63296,179,'Raniwara Khurd','343040',1,0,'2022-03-03 12:53:35','2022-03-03 12:53:35'),(63297,179,'Raniwara','343040',1,0,'2022-03-03 12:53:35','2022-03-03 12:53:35'),(63298,179,'Ranodar','343041',1,0,'2022-03-03 12:53:35','2022-03-03 12:53:35'),(63299,179,'Raota','343032',1,0,'2022-03-03 12:53:35','2022-03-03 12:53:35'),(63300,179,'Ratanpur','343040',1,0,'2022-03-03 12:53:35','2022-03-03 12:53:35'),(63301,179,'Rewatra','343001',1,0,'2022-03-03 12:53:35','2022-03-03 12:53:35'),(63302,179,'Rodla','307030',1,0,'2022-03-03 12:53:35','2022-03-03 12:53:35'),(63303,179,'Ropsi','343049',1,0,'2022-03-03 12:53:35','2022-03-03 12:53:35'),(63304,179,'Safada','343001',1,0,'2022-03-03 12:53:35','2022-03-03 12:53:35'),(63305,179,'Samtipura','343001',1,0,'2022-03-03 12:53:35','2022-03-03 12:53:35'),(63306,179,'Samuja','307029',1,0,'2022-03-03 12:53:35','2022-03-03 12:53:35'),(63307,179,'Sanchore','343041',1,0,'2022-03-03 12:53:35','2022-03-03 12:53:35'),(63308,179,'Sandhara','307803',1,0,'2022-03-03 12:53:35','2022-03-03 12:53:35'),(63309,179,'Sangana','343022',1,0,'2022-03-03 12:53:35','2022-03-03 12:53:35'),(63310,179,'Sankad','343040',1,0,'2022-03-03 12:53:35','2022-03-03 12:53:35'),(63311,179,'Sankarna','343001',1,0,'2022-03-03 12:53:35','2022-03-03 12:53:35'),(63312,179,'Sankhwali','307029',1,0,'2022-03-03 12:53:35','2022-03-03 12:53:35'),(63313,179,'Santhu','343025',1,0,'2022-03-03 12:53:35','2022-03-03 12:53:35'),(63314,179,'Sanwara','307029',1,0,'2022-03-03 12:53:35','2022-03-03 12:53:35'),(63315,179,'Sarana','343042',1,0,'2022-03-03 12:53:35','2022-03-03 12:53:35'),(63316,179,'Sarat','343025',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63317,179,'Sarnau','343040',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63318,179,'Sarwana','343041',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63319,179,'Savidhar','343049',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63320,179,'Sawna','343024',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63321,179,'Sayla (Jalor)','343022',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63322,179,'Serna','343028',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63323,179,'Sewara','343041',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63324,179,'Sewara','343040',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63325,179,'Sewari','343030',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63326,179,'Siana','343024',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63327,179,'Sikwara','307803',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63328,179,'Silasan','343049',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63329,179,'Sirana','343022',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63330,179,'Somta','307803',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63331,179,'Soonthri','343027',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63332,179,'Sugalia Jodha','307029',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63333,179,'Surachand','343027',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63334,179,'Surajwara','343039',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63335,179,'Surana','343032',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63336,179,'Surawa','343041',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63337,179,'Taliyana','343022',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63338,179,'Tawab','343029',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63339,179,'Thalwad','343023',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63340,179,'Thawla','343001',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63341,179,'Thobau','343029',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63342,179,'Thoor','307803',1,0,'2022-03-03 12:53:36','2022-03-03 12:53:36'),(63343,179,'Tikhi','343042',1,0,'2022-03-03 12:53:37','2022-03-03 12:53:37'),(63344,179,'Tiloda','343032',1,0,'2022-03-03 12:53:37','2022-03-03 12:53:37'),(63345,179,'Umedpur','307030',1,0,'2022-03-03 12:53:37','2022-03-03 12:53:37'),(63346,179,'Ummedabad','343021',1,0,'2022-03-03 12:53:37','2022-03-03 12:53:37'),(63347,179,'Unn','343001',1,0,'2022-03-03 12:53:37','2022-03-03 12:53:37'),(63348,179,'Unri','343023',1,0,'2022-03-03 12:53:37','2022-03-03 12:53:37'),(63349,179,'Vadgaon (Jalor)','343048',1,0,'2022-03-03 12:53:37','2022-03-03 12:53:37'),(63350,179,'Valdara','307030',1,0,'2022-03-03 12:53:37','2022-03-03 12:53:37'),(63351,179,'Vali','343030',1,0,'2022-03-03 12:53:37','2022-03-03 12:53:37'),(63352,179,'Vandhar','343029',1,0,'2022-03-03 12:53:37','2022-03-03 12:53:37'),(63353,179,'Vedia','307029',1,0,'2022-03-03 12:53:37','2022-03-03 12:53:37'),(63354,179,'Veerana','343001',1,0,'2022-03-03 12:53:37','2022-03-03 12:53:37'),(63355,179,'Veerawa','343041',1,0,'2022-03-03 12:53:37','2022-03-03 12:53:37'),(63356,180,'Agaria','326022',1,0,'2022-03-03 12:53:37','2022-03-03 12:53:37'),(63357,180,'Akawad Khurd','326035',1,0,'2022-03-03 12:53:37','2022-03-03 12:53:37'),(63358,180,'Aklera','326033',1,0,'2022-03-03 12:53:37','2022-03-03 12:53:37'),(63359,180,'Akodiya','326038',1,0,'2022-03-03 12:53:37','2022-03-03 12:53:37'),(63360,180,'Ametha','326033',1,0,'2022-03-03 12:53:37','2022-03-03 12:53:37'),(63361,180,'Anwalheda','326037',1,0,'2022-03-03 12:53:37','2022-03-03 12:53:37'),(63362,180,'Anwali Kalan','326502',1,0,'2022-03-03 12:53:37','2022-03-03 12:53:37'),(63363,180,'Asalpura','326039',1,0,'2022-03-03 12:53:37','2022-03-03 12:53:37'),(63364,180,'Asnawar','326021',1,0,'2022-03-03 12:53:37','2022-03-03 12:53:37'),(63365,180,'Awar','326512',1,0,'2022-03-03 12:53:37','2022-03-03 12:53:37'),(63366,180,'Baday','326022',1,0,'2022-03-03 12:53:38','2022-03-03 12:53:38'),(63367,180,'Badbad','326023',1,0,'2022-03-03 12:53:38','2022-03-03 12:53:38'),(63368,180,'Badwad','326033',1,0,'2022-03-03 12:53:38','2022-03-03 12:53:38'),(63369,180,'Bagher','326001',1,0,'2022-03-03 12:53:38','2022-03-03 12:53:38'),(63370,180,'Bahalta','326039',1,0,'2022-03-03 12:53:38','2022-03-03 12:53:38'),(63371,180,'Baira Garh','326033',1,0,'2022-03-03 12:53:38','2022-03-03 12:53:38'),(63372,180,'Bakani','326022',1,0,'2022-03-03 12:53:38','2022-03-03 12:53:38'),(63373,180,'Baneth','326037',1,0,'2022-03-03 12:53:38','2022-03-03 12:53:38'),(63374,180,'Bani','326512',1,0,'2022-03-03 12:53:38','2022-03-03 12:53:38'),(63375,180,'Banore','326036',1,0,'2022-03-03 12:53:38','2022-03-03 12:53:38'),(63376,180,'Banskheda','326037',1,0,'2022-03-03 12:53:38','2022-03-03 12:53:38'),(63377,180,'Banskhedi','326037',1,0,'2022-03-03 12:53:38','2022-03-03 12:53:38'),(63378,180,'Banskhedi Lodhan','326039',1,0,'2022-03-03 12:53:38','2022-03-03 12:53:38'),(63379,180,'Bardia Veer Ji','326515',1,0,'2022-03-03 12:53:38','2022-03-03 12:53:38'),(63380,180,'Bareda','326035',1,0,'2022-03-03 12:53:38','2022-03-03 12:53:38'),(63381,180,'Barodia','326021',1,0,'2022-03-03 12:53:38','2022-03-03 12:53:38'),(63382,180,'Berla','326515',1,0,'2022-03-03 12:53:38','2022-03-03 12:53:38'),(63383,180,'Bhagwanpura','326038',1,0,'2022-03-03 12:53:38','2022-03-03 12:53:38'),(63384,180,'Bhanwarsa','326023',1,0,'2022-03-03 12:53:38','2022-03-03 12:53:38'),(63385,180,'Bhawanimandi','326502',1,0,'2022-03-03 12:53:38','2022-03-03 12:53:38'),(63386,180,'Bhilwari','326501',1,0,'2022-03-03 12:53:38','2022-03-03 12:53:38'),(63387,180,'Bhimsagar Dam','326001',1,0,'2022-03-03 12:53:38','2022-03-03 12:53:38'),(63388,180,'Binda Kheda','326039',1,0,'2022-03-03 12:53:38','2022-03-03 12:53:38'),(63389,180,'Bisthunia','326512',1,0,'2022-03-03 12:53:38','2022-03-03 12:53:38'),(63390,180,'Bolia Bujurg','326513',1,0,'2022-03-03 12:53:39','2022-03-03 12:53:39'),(63391,180,'Borband','326039',1,0,'2022-03-03 12:53:39','2022-03-03 12:53:39'),(63392,180,'Borda Mau','326001',1,0,'2022-03-03 12:53:39','2022-03-03 12:53:39'),(63393,180,'Borkhedi Gujran','326039',1,0,'2022-03-03 12:53:39','2022-03-03 12:53:39'),(63394,180,'Chachhlao','326513',1,0,'2022-03-03 12:53:39','2022-03-03 12:53:39'),(63395,180,'Chandipur','326037',1,0,'2022-03-03 12:53:39','2022-03-03 12:53:39'),(63396,180,'Chandpura Bheelan','326037',1,0,'2022-03-03 12:53:39','2022-03-03 12:53:39'),(63397,180,'Chanpa Khurd','326035',1,0,'2022-03-03 12:53:39','2022-03-03 12:53:39'),(63398,180,'Chara','326515',1,0,'2022-03-03 12:53:39','2022-03-03 12:53:39'),(63399,180,'Chaumahla','326515',1,0,'2022-03-03 12:53:39','2022-03-03 12:53:39'),(63400,180,'Churalia','326033',1,0,'2022-03-03 12:53:39','2022-03-03 12:53:39'),(63401,180,'Collectorate Jhalawar','326001',1,0,'2022-03-03 12:53:39','2022-03-03 12:53:39'),(63402,180,'Dabla Bhoj','326034',1,0,'2022-03-03 12:53:39','2022-03-03 12:53:39'),(63403,180,'Dabla Kheenchi','326513',1,0,'2022-03-03 12:53:39','2022-03-03 12:53:39'),(63404,180,'Dag','326514',1,0,'2022-03-03 12:53:39','2022-03-03 12:53:39'),(63405,180,'Dahikheda','326038',1,0,'2022-03-03 12:53:39','2022-03-03 12:53:39'),(63406,180,'Dangipura','326037',1,0,'2022-03-03 12:53:39','2022-03-03 12:53:39'),(63407,180,'Danta','326034',1,0,'2022-03-03 12:53:39','2022-03-03 12:53:39'),(63408,180,'Deori','326023',1,0,'2022-03-03 12:53:39','2022-03-03 12:53:39'),(63409,180,'Deori Kalan','326033',1,0,'2022-03-03 12:53:39','2022-03-03 12:53:39'),(63410,180,'Dev Nagar','326022',1,0,'2022-03-03 12:53:39','2022-03-03 12:53:39'),(63411,180,'Devgarh','326512',1,0,'2022-03-03 12:53:39','2022-03-03 12:53:39'),(63412,180,'Devgarh','326514',1,0,'2022-03-03 12:53:39','2022-03-03 12:53:39'),(63413,180,'Dewal Kheda','326036',1,0,'2022-03-03 12:53:39','2022-03-03 12:53:39'),(63414,180,'Dhanoda','326035',1,0,'2022-03-03 12:53:39','2022-03-03 12:53:39'),(63415,180,'Dharonia','326034',1,0,'2022-03-03 12:53:40','2022-03-03 12:53:40'),(63416,180,'Dhaturia','326514',1,0,'2022-03-03 12:53:40','2022-03-03 12:53:40'),(63417,180,'Ditya Khedi','326036',1,0,'2022-03-03 12:53:40','2022-03-03 12:53:40'),(63418,180,'Dobra','326514',1,0,'2022-03-03 12:53:40','2022-03-03 12:53:40'),(63419,180,'Dobra','326038',1,0,'2022-03-03 12:53:40','2022-03-03 12:53:40'),(63420,180,'Dodi','326514',1,0,'2022-03-03 12:53:40','2022-03-03 12:53:40'),(63421,180,'Dola','326513',1,0,'2022-03-03 12:53:40','2022-03-03 12:53:40'),(63422,180,'Dubalia','326513',1,0,'2022-03-03 12:53:40','2022-03-03 12:53:40'),(63423,180,'Dudhalia','326514',1,0,'2022-03-03 12:53:40','2022-03-03 12:53:40'),(63424,180,'Dunda','326023',1,0,'2022-03-03 12:53:40','2022-03-03 12:53:40'),(63425,180,'Dungargaon','326021',1,0,'2022-03-03 12:53:40','2022-03-03 12:53:40'),(63426,180,'Duragpura','326001',1,0,'2022-03-03 12:53:40','2022-03-03 12:53:40'),(63427,180,'Fateh Garh','326036',1,0,'2022-03-03 12:53:40','2022-03-03 12:53:40'),(63428,180,'Gadarwada Noorji','326038',1,0,'2022-03-03 12:53:40','2022-03-03 12:53:40'),(63429,180,'Gadia','326501',1,0,'2022-03-03 12:53:40','2022-03-03 12:53:40'),(63430,180,'Gadia','326513',1,0,'2022-03-03 12:53:40','2022-03-03 12:53:40'),(63431,180,'Gagron','326001',1,0,'2022-03-03 12:53:40','2022-03-03 12:53:40'),(63432,180,'Ganeshpura','326502',1,0,'2022-03-03 12:53:40','2022-03-03 12:53:40'),(63433,180,'Gangdhar','326516',1,0,'2022-03-03 12:53:40','2022-03-03 12:53:40'),(63434,180,'Garbolia','326037',1,0,'2022-03-03 12:53:40','2022-03-03 12:53:40'),(63435,180,'Garwada','326022',1,0,'2022-03-03 12:53:40','2022-03-03 12:53:40'),(63436,180,'Gehu Khedi','326033',1,0,'2022-03-03 12:53:40','2022-03-03 12:53:40'),(63437,180,'Ghatod','326502',1,0,'2022-03-03 12:53:40','2022-03-03 12:53:40'),(63438,180,'Ghatoli','326039',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63439,180,'Golana','326038',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63440,180,'Gopalpura','326039',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63441,180,'Gordhanpura','326001',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63442,180,'Govindpura','326023',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63443,180,'Govindpura','326034',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63444,180,'Gulkhedi','326039',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63445,180,'Gundi','326501',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63446,180,'Guradia Jhala','326516',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63447,180,'Guradia Joga','326512',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63448,180,'Guradia Kalan','326512',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63449,180,'Guradia Khurd','326512',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63450,180,'Guradia Mana','326502',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63451,180,'Guradkheda','326023',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63452,180,'Gurah','326512',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63453,180,'Gurukul','326022',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63454,180,'Harigarh','326001',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63455,180,'Harnawda','326514',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63456,180,'Harnawda Gaja','326034',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63457,180,'Hemda','326513',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63458,180,'Himmat Garh','326036',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63459,180,'Iktasa','326021',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63460,180,'Jagdishpura','326514',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63461,180,'Jamuniya','326514',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63462,180,'Jarga','326038',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63463,180,'Jawar','326037',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63464,180,'Jhalara Patan City','326023',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63465,180,'Jhalawar H.O','326001',1,0,'2022-03-03 12:53:41','2022-03-03 12:53:41'),(63466,180,'Jhumki','326036',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63467,180,'Jolpa','326038',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63468,180,'Junakheda','326021',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63469,180,'Kachnara','326516',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63470,180,'Kali Talai','326036',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63471,180,'Kalmandi Kalan','326023',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63472,180,'Kam Khera','326033',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63473,180,'Kanwara','326501',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63474,180,'Kanwarpura','326038',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63475,180,'Karal Gaon','326022',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63476,180,'Karanwas','326035',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63477,180,'Karawan','326512',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63478,180,'Karodia','326513',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63479,180,'Kayasara','326514',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63480,180,'Keetia','326515',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63481,180,'Kelu Kheri','326516',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63482,180,'Khairana','326034',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63483,180,'Khandli','326038',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63484,180,'Khanpur (Jhalawar)','326038',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63485,180,'Khanpuria','326023',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63486,180,'Kharpakalan','326034',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63487,180,'Khatkakhedi','326037',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63488,180,'Kherkheda','326037',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63489,180,'Khod','326501',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63490,180,'Kohri Jhar','326039',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63491,180,'Kolukheri Kalan','326037',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63492,180,'Kolukheri Maliyan','326037',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63493,180,'Kotri','326034',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63494,180,'Kumthia','326515',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63495,180,'Kundi Kheda','326502',1,0,'2022-03-03 12:53:42','2022-03-03 12:53:42'),(63496,180,'Kundla','326515',1,0,'2022-03-03 12:53:43','2022-03-03 12:53:43'),(63497,180,'Kushalpura','326022',1,0,'2022-03-03 12:53:43','2022-03-03 12:53:43'),(63498,180,'Kutki','326036',1,0,'2022-03-03 12:53:43','2022-03-03 12:53:43'),(63499,180,'Laiphal','326001',1,0,'2022-03-03 12:53:43','2022-03-03 12:53:43'),(63500,180,'Lasudia Shaha','326033',1,0,'2022-03-03 12:53:43','2022-03-03 12:53:43'),(63501,180,'Lawasal','326021',1,0,'2022-03-03 12:53:43','2022-03-03 12:53:43'),(63502,180,'Leemi','326038',1,0,'2022-03-03 12:53:43','2022-03-03 12:53:43'),(63503,180,'Lhas','326033',1,0,'2022-03-03 12:53:43','2022-03-03 12:53:43'),(63504,180,'Luharia','326514',1,0,'2022-03-03 12:53:43','2022-03-03 12:53:43'),(63505,180,'Magsi','326515',1,0,'2022-03-03 12:53:43','2022-03-03 12:53:43'),(63506,180,'Maharajpura','326037',1,0,'2022-03-03 12:53:43','2022-03-03 12:53:43'),(63507,180,'Maithun','326033',1,0,'2022-03-03 12:53:43','2022-03-03 12:53:43'),(63508,180,'Malanwas','326035',1,0,'2022-03-03 12:53:43','2022-03-03 12:53:43'),(63509,180,'Mandawar','326001',1,0,'2022-03-03 12:53:43','2022-03-03 12:53:43'),(63510,180,'Mandirpur','326514',1,0,'2022-03-03 12:53:43','2022-03-03 12:53:43'),(63511,180,'Mangispur','326513',1,0,'2022-03-03 12:53:43','2022-03-03 12:53:43'),(63512,180,'Manohar Thana','326037',1,0,'2022-03-03 12:53:43','2022-03-03 12:53:43'),(63513,180,'Manpasar','326037',1,0,'2022-03-03 12:53:43','2022-03-03 12:53:43'),(63514,180,'Maraitha','326038',1,0,'2022-03-03 12:53:43','2022-03-03 12:53:43'),(63515,180,'Maralwada','326512',1,0,'2022-03-03 12:53:43','2022-03-03 12:53:43'),(63516,180,'Mathania','326036',1,0,'2022-03-03 12:53:43','2022-03-03 12:53:43'),(63517,180,'Mishroli','326033',1,0,'2022-03-03 12:53:43','2022-03-03 12:53:43'),(63518,180,'Mishroli','326512',1,0,'2022-03-03 12:53:43','2022-03-03 12:53:43'),(63519,180,'Modi','326022',1,0,'2022-03-03 12:53:43','2022-03-03 12:53:43'),(63520,180,'Mogra','326502',1,0,'2022-03-03 12:53:43','2022-03-03 12:53:43'),(63521,180,'Morak','326517',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63522,180,'Mundla','326001',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63523,180,'Naharghatta','326512',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63524,180,'Nandpur','326514',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63525,180,'Nanore','326022',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63526,180,'Narayan Kheda','326502',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63527,180,'Nasirabad','326023',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63528,180,'Naulai','326034',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63529,180,'Odiya Khedi','326034',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63530,180,'Osav','326513',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63531,180,'Pach Pahar','326512',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63532,180,'Pachola ','326039',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63533,180,'Pagaria','326512',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63534,180,'Pakhrana','326038',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63535,180,'Panwar','326038',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63536,180,'Panwasa','326021',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63537,180,'Parapeeli','326515',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63538,180,'Parlia','326515',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63539,180,'Parlia Kulmi','326023',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63540,180,'Pindola','326037',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63541,180,'Piplaj','326038',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63542,180,'Piplia','326501',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63543,180,'Piplia Khurd','326514',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63544,180,'Piplod','326036',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63545,180,'Pirawa','326034',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63546,180,'Raipur (Jhalawar)','326036',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63547,180,'Rajhana','326516',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63548,180,'Rajpura','326501',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63549,180,'Ramai Dalpat','326034',1,0,'2022-03-03 12:53:44','2022-03-03 12:53:44'),(63550,180,'Rampura','326516',1,0,'2022-03-03 12:53:45','2022-03-03 12:53:45'),(63551,180,'Rampuria','326034',1,0,'2022-03-03 12:53:45','2022-03-03 12:53:45'),(63552,180,'Ranaira','326515',1,0,'2022-03-03 12:53:45','2022-03-03 12:53:45'),(63553,180,'Ranwasia','326037',1,0,'2022-03-03 12:53:45','2022-03-03 12:53:45'),(63554,180,'Ratlai','326023',1,0,'2022-03-03 12:53:45','2022-03-03 12:53:45'),(63555,180,'Rawangurari','326515',1,0,'2022-03-03 12:53:45','2022-03-03 12:53:45'),(63556,180,'Richhawan','326023',1,0,'2022-03-03 12:53:45','2022-03-03 12:53:45'),(63557,180,'Rijhone','326023',1,0,'2022-03-03 12:53:45','2022-03-03 12:53:45'),(63558,180,'Rundlao','326023',1,0,'2022-03-03 12:53:45','2022-03-03 12:53:45'),(63559,180,'Ruparel','326021',1,0,'2022-03-03 12:53:45','2022-03-03 12:53:45'),(63560,180,'Salawad','326023',1,0,'2022-03-03 12:53:45','2022-03-03 12:53:45'),(63561,180,'Salotia','326513',1,0,'2022-03-03 12:53:45','2022-03-03 12:53:45'),(63562,180,'Salri','326036',1,0,'2022-03-03 12:53:45','2022-03-03 12:53:45'),(63563,180,'Samrai','326501',1,0,'2022-03-03 12:53:45','2022-03-03 12:53:45'),(63564,180,'Samrol','326037',1,0,'2022-03-03 12:53:45','2022-03-03 12:53:45'),(63565,180,'Sangria','326513',1,0,'2022-03-03 12:53:45','2022-03-03 12:53:45'),(63566,180,'Sarda','326039',1,0,'2022-03-03 12:53:45','2022-03-03 12:53:45'),(63567,180,'Saredi','326033',1,0,'2022-03-03 12:53:45','2022-03-03 12:53:45'),(63568,180,'Sarkhandia','326039',1,0,'2022-03-03 12:53:45','2022-03-03 12:53:45'),(63569,180,'Sarod','326512',1,0,'2022-03-03 12:53:45','2022-03-03 12:53:45'),(63570,180,'Sarola','326035',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63571,180,'Saroniya','326034',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63572,180,'Sarwad','326516',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63573,180,'Semli Khan','326036',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63574,180,'Semlia','326513',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63575,180,'Semlihat','326037',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63576,180,'Sherpur','326034',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63577,180,'Shrichhattarpur','326501',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63578,180,'Silahgarh','326512',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63579,180,'Singhpur','326512',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63580,180,'Sirpoi','326513',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63581,180,'Sojpur','326038',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63582,180,'Sorti','326037',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63583,180,'Soyala','326036',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63584,180,'Sulia','326502',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63585,180,'Sumar','326038',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63586,180,'Sunari','326516',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63587,180,'Sunel','326513',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63588,180,'Sunwas','326036',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63589,180,'Talawali','326515',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63590,180,'Taraj','326035',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63591,180,'Thanawad','326033',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63592,180,'Thedol','326033',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63593,180,'Thiakria','326037',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63594,180,'Thobariya Khurd','326022',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63595,180,'Tisai','326514',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63596,180,'Titarwasa ','326023',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63597,180,'Todri Jagannath','326037',1,0,'2022-03-03 12:53:46','2022-03-03 12:53:46'),(63598,180,'Todrimeeran','326037',1,0,'2022-03-03 12:53:47','2022-03-03 12:53:47'),(63599,180,'Turkadia','326033',1,0,'2022-03-03 12:53:47','2022-03-03 12:53:47'),(63600,180,'Umaria','326039',1,0,'2022-03-03 12:53:47','2022-03-03 12:53:47'),(63601,180,'Unhel','326513',1,0,'2022-03-03 12:53:47','2022-03-03 12:53:47'),(63602,180,'Unhel Nagdev','326515',1,0,'2022-03-03 12:53:47','2022-03-03 12:53:47'),(63603,181,'Abusar','333001',1,0,'2022-03-03 12:53:47','2022-03-03 12:53:47'),(63604,181,'Adarsh Nagar','333023',1,0,'2022-03-03 12:53:47','2022-03-03 12:53:47'),(63605,181,'Aduka','333026',1,0,'2022-03-03 12:53:47','2022-03-03 12:53:47'),(63606,181,'Agawana Khurd','333029',1,0,'2022-03-03 12:53:47','2022-03-03 12:53:47'),(63607,181,'Ajari Bari','333021',1,0,'2022-03-03 12:53:47','2022-03-03 12:53:47'),(63608,181,'Alipur','333023',1,0,'2022-03-03 12:53:47','2022-03-03 12:53:47'),(63609,181,'Alsisar','331025',1,0,'2022-03-03 12:53:47','2022-03-03 12:53:47'),(63610,181,'Ardawata','333027',1,0,'2022-03-03 12:53:47','2022-03-03 12:53:47'),(63611,181,'Asalwas','333033',1,0,'2022-03-03 12:53:47','2022-03-03 12:53:47'),(63612,181,'Babai (Jhujhunu)','333501',1,0,'2022-03-03 12:53:47','2022-03-03 12:53:47'),(63613,181,'Badalwas','333503',1,0,'2022-03-03 12:53:47','2022-03-03 12:53:47'),(63614,181,'Badangarh','333035',1,0,'2022-03-03 12:53:47','2022-03-03 12:53:47'),(63615,181,'Badbar','333502',1,0,'2022-03-03 12:53:47','2022-03-03 12:53:47'),(63616,181,'Badet','331026',1,0,'2022-03-03 12:53:47','2022-03-03 12:53:47'),(63617,181,'Badsari Ka Bas','333026',1,0,'2022-03-03 12:53:47','2022-03-03 12:53:47'),(63618,181,'Bagar','333023',1,0,'2022-03-03 12:53:47','2022-03-03 12:53:47'),(63619,181,'Bagoli','333801',1,0,'2022-03-03 12:53:47','2022-03-03 12:53:47'),(63620,181,'Bagor','333503',1,0,'2022-03-03 12:53:47','2022-03-03 12:53:47'),(63621,181,'Bagora','333307',1,0,'2022-03-03 12:53:48','2022-03-03 12:53:48'),(63622,181,'Bahadurwas','333704',1,0,'2022-03-03 12:53:48','2022-03-03 12:53:48'),(63623,181,'Bajala','333025',1,0,'2022-03-03 12:53:48','2022-03-03 12:53:48'),(63624,181,'Bajawa','333025',1,0,'2022-03-03 12:53:48','2022-03-03 12:53:48'),(63625,181,'Bajawa','333021',1,0,'2022-03-03 12:53:48','2022-03-03 12:53:48'),(63626,181,'Bajisar','333704',1,0,'2022-03-03 12:53:48','2022-03-03 12:53:48'),(63627,181,'Bakara','333001',1,0,'2022-03-03 12:53:48','2022-03-03 12:53:48'),(63628,181,'Bakhatawarpura','333023',1,0,'2022-03-03 12:53:48','2022-03-03 12:53:48'),(63629,181,'Balaria','333705',1,0,'2022-03-03 12:53:48','2022-03-03 12:53:48'),(63630,181,'Balonda','333033',1,0,'2022-03-03 12:53:48','2022-03-03 12:53:48'),(63631,181,'Bamanwas','333026',1,0,'2022-03-03 12:53:48','2022-03-03 12:53:48'),(63632,181,'Bamlas','333022',1,0,'2022-03-03 12:53:48','2022-03-03 12:53:48'),(63633,181,'Bangothari','333031',1,0,'2022-03-03 12:53:48','2022-03-03 12:53:48'),(63634,181,'Bansiyal','333503',1,0,'2022-03-03 12:53:48','2022-03-03 12:53:48'),(63635,181,'Bar Ki Dhani','333022',1,0,'2022-03-03 12:53:48','2022-03-03 12:53:48'),(63636,181,'Baragaon (Jhunjhunu)S.O','333021',1,0,'2022-03-03 12:53:48','2022-03-03 12:53:48'),(63637,181,'Barau','333026',1,0,'2022-03-03 12:53:48','2022-03-03 12:53:48'),(63638,181,'Barwa','333304',1,0,'2022-03-03 12:53:48','2022-03-03 12:53:48'),(63639,181,'Barwasi','333042',1,0,'2022-03-03 12:53:48','2022-03-03 12:53:48'),(63640,181,'Bas Ghasiram','331025',1,0,'2022-03-03 12:53:48','2022-03-03 12:53:48'),(63641,181,'Basawa','333304',1,0,'2022-03-03 12:53:48','2022-03-03 12:53:48'),(63642,181,'Basawata Khurd','333516',1,0,'2022-03-03 12:53:48','2022-03-03 12:53:48'),(63643,181,'Bay','333042',1,0,'2022-03-03 12:53:48','2022-03-03 12:53:48'),(63644,181,'Beelawa','333503',1,0,'2022-03-03 12:53:49','2022-03-03 12:53:49'),(63645,181,'Beri','333031',1,0,'2022-03-03 12:53:49','2022-03-03 12:53:49'),(63646,181,'Berla','333033',1,0,'2022-03-03 12:53:49','2022-03-03 12:53:49'),(63647,181,'Bhagera','333305',1,0,'2022-03-03 12:53:49','2022-03-03 12:53:49'),(63648,181,'Bhaloth','333515',1,0,'2022-03-03 12:53:49','2022-03-03 12:53:49'),(63649,181,'Bharu','333041',1,0,'2022-03-03 12:53:49','2022-03-03 12:53:49'),(63650,181,'Bharunda Kalan','333024',1,0,'2022-03-03 12:53:49','2022-03-03 12:53:49'),(63651,181,'Bharunda Khurd','333024',1,0,'2022-03-03 12:53:49','2022-03-03 12:53:49'),(63652,181,'Bhatiwar','333026',1,0,'2022-03-03 12:53:49','2022-03-03 12:53:49'),(63653,181,'Bhawathari','333029',1,0,'2022-03-03 12:53:49','2022-03-03 12:53:49'),(63654,181,'Bhikhansar','331030',1,0,'2022-03-03 12:53:49','2022-03-03 12:53:49'),(63655,181,'Bhimsar','333001',1,0,'2022-03-03 12:53:49','2022-03-03 12:53:49'),(63656,181,'Bhirr','333515',1,0,'2022-03-03 12:53:49','2022-03-03 12:53:49'),(63657,181,'Bhobia','333030',1,0,'2022-03-03 12:53:49','2022-03-03 12:53:49'),(63658,181,'Bhojasar','333041',1,0,'2022-03-03 12:53:49','2022-03-03 12:53:49'),(63659,181,'Bhojnagar','333308',1,0,'2022-03-03 12:53:49','2022-03-03 12:53:49'),(63660,181,'Bhorki','333032',1,0,'2022-03-03 12:53:49','2022-03-03 12:53:49'),(63661,181,'Bhudanpura','333033',1,0,'2022-03-03 12:53:49','2022-03-03 12:53:49'),(63662,181,'Bhukana','333026',1,0,'2022-03-03 12:53:49','2022-03-03 12:53:49'),(63663,181,'Bhurasar','333001',1,0,'2022-03-03 12:53:49','2022-03-03 12:53:49'),(63664,181,'Bhuriwas','333034',1,0,'2022-03-03 12:53:49','2022-03-03 12:53:49'),(63665,181,'Bibasar','333041',1,0,'2022-03-03 12:53:49','2022-03-03 12:53:49'),(63666,181,'Bidasar','331027',1,0,'2022-03-03 12:53:49','2022-03-03 12:53:49'),(63667,181,'Bigodana','333026',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63668,181,'Binjusar','333021',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63669,181,'Birmi','331027',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63670,181,'Birol','333304',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63671,181,'Bishanpura','333021',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63672,181,'Bissau','331027',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63673,181,'Budana','333023',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63674,181,'Budania','333025',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63675,181,'Budhaka Bas','331026',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63676,181,'Bugala','333305',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63677,181,'Buhana','333502',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63678,181,'C.R. Mukundgarh','333705',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63679,181,'Ceeri Pilani','333031',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63680,181,'Chanana','333026',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63681,181,'Chandawa','331027',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63682,181,'Chanderapura','333704',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63683,181,'Chanwara','333053',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63684,181,'Charawas','333026',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63685,181,'Chelasi','333042',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63686,181,'Chhapara','333031',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63687,181,'Chhapoli','333302',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63688,181,'Chhau','333305',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63689,181,'Chhawasari','333012',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63690,181,'Chinchroli','333501',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63691,181,'Chirana','333303',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63692,181,'Chirani','333503',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63693,181,'Chirawa H.O','333026',1,0,'2022-03-03 12:53:50','2022-03-03 12:53:50'),(63694,181,'Chirawa Town','333026',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63695,181,'Chittausa','333516',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63696,181,'Chobdaranki Dhani','333042',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63697,181,'Churella','333001',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63698,181,'Churiajitgarh','333701',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63699,181,'Churina','333515',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63700,181,'Dabri','333025',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63701,181,'Dabri Baloda','333707',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63702,181,'Dada Fatehpura','333503',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63703,181,'Dahani Risiyan','333022',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63704,181,'Dalelpura','332716',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63705,181,'Dalota','332746',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63706,181,'Deepura','333053',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63707,181,'Delsar Kaklan','333707',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63708,181,'Deogaon','333707',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63709,181,'Deolawas','333515',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63710,181,'Deorasar','333021',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63711,181,'Deoroad','333035',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63712,181,'Derwala','333041',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63713,181,'Desusar','333023',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63714,181,'Dhadhot Kalan','333516',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63715,181,'Dhakamandi','333034',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63716,181,'Dhamora','333308',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63717,181,'Dhana','333504',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63718,181,'Dhandhar Ka Bas','333031',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63719,181,'Dhani Badan','333514',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63720,181,'Dhania','333042',1,0,'2022-03-03 12:53:51','2022-03-03 12:53:51'),(63721,181,'Dhanuri','333011',1,0,'2022-03-03 12:53:52','2022-03-03 12:53:52'),(63722,181,'Dhigal','333041',1,0,'2022-03-03 12:53:52','2022-03-03 12:53:52'),(63723,181,'Dhilsar','331027',1,0,'2022-03-03 12:53:52','2022-03-03 12:53:52'),(63724,181,'Dhindawa Aguna','333030',1,0,'2022-03-03 12:53:52','2022-03-03 12:53:52'),(63725,181,'Dhingaria','333033',1,0,'2022-03-03 12:53:52','2022-03-03 12:53:52'),(63726,181,'Dholekhera','333307',1,0,'2022-03-03 12:53:52','2022-03-03 12:53:52'),(63727,181,'Dhosi','332746',1,0,'2022-03-03 12:53:52','2022-03-03 12:53:52'),(63728,181,'Dhulwa','333033',1,0,'2022-03-03 12:53:52','2022-03-03 12:53:52'),(63729,181,'Diloi South','331027',1,0,'2022-03-03 12:53:52','2022-03-03 12:53:52'),(63730,181,'Dobara','333031',1,0,'2022-03-03 12:53:52','2022-03-03 12:53:52'),(63731,181,'Doodawa','333031',1,0,'2022-03-03 12:53:52','2022-03-03 12:53:52'),(63732,181,'Doodwa','332746',1,0,'2022-03-03 12:53:52','2022-03-03 12:53:52'),(63733,181,'Doomra','333707',1,0,'2022-03-03 12:53:52','2022-03-03 12:53:52'),(63734,181,'Dulaniya','333031',1,0,'2022-03-03 12:53:52','2022-03-03 12:53:52'),(63735,181,'Dulchas','331027',1,0,'2022-03-03 12:53:52','2022-03-03 12:53:52'),(63736,181,'Dumoli Khurd','333516',1,0,'2022-03-03 12:53:52','2022-03-03 12:53:52'),(63737,181,'Dundlod RS','333705',1,0,'2022-03-03 12:53:52','2022-03-03 12:53:52'),(63738,181,'Dundlod','333702',1,0,'2022-03-03 12:53:52','2022-03-03 12:53:52'),(63739,181,'Durana','333041',1,0,'2022-03-03 12:53:52','2022-03-03 12:53:52'),(63740,181,'Duriya','333022',1,0,'2022-03-03 12:53:52','2022-03-03 12:53:52'),(63741,181,'Footla Bazar','333001',1,0,'2022-03-03 12:53:52','2022-03-03 12:53:52'),(63742,181,'Gadakhera','333026',1,0,'2022-03-03 12:53:52','2022-03-03 12:53:52'),(63743,181,'Gadala Kalkan','333053',1,0,'2022-03-03 12:53:52','2022-03-03 12:53:52'),(63744,181,'Gadli','333033',1,0,'2022-03-03 12:53:52','2022-03-03 12:53:52'),(63745,181,'Gadrata','333501',1,0,'2022-03-03 12:53:52','2022-03-03 12:53:52'),(63746,181,'Gandhi Chowk Jhunjhunu','333001',1,0,'2022-03-03 12:53:53','2022-03-03 12:53:53'),(63747,181,'Gangiasar','331027',1,0,'2022-03-03 12:53:53','2022-03-03 12:53:53'),(63748,181,'Gharadana Khurd','333514',1,0,'2022-03-03 12:53:53','2022-03-03 12:53:53'),(63749,181,'Ghardana Kalan','333516',1,0,'2022-03-03 12:53:53','2022-03-03 12:53:53'),(63750,181,'Ghasera','333034',1,0,'2022-03-03 12:53:53','2022-03-03 12:53:53'),(63751,181,'Ghoriwara Kalan','333705',1,0,'2022-03-03 12:53:53','2022-03-03 12:53:53'),(63752,181,'Ghoriwara Khurd','333705',1,0,'2022-03-03 12:53:53','2022-03-03 12:53:53'),(63753,181,'Gidania','333027',1,0,'2022-03-03 12:53:53','2022-03-03 12:53:53'),(63754,181,'Gilonki  Dhani','333032',1,0,'2022-03-03 12:53:53','2022-03-03 12:53:53'),(63755,181,'Girawadi','333302',1,0,'2022-03-03 12:53:53','2022-03-03 12:53:53'),(63756,181,'Girdharpura Shahpura','333307',1,0,'2022-03-03 12:53:53','2022-03-03 12:53:53'),(63757,181,'Gorir','332746',1,0,'2022-03-03 12:53:53','2022-03-03 12:53:53'),(63758,181,'Goth','333516',1,0,'2022-03-03 12:53:53','2022-03-03 12:53:53'),(63759,181,'Gothara','333304',1,0,'2022-03-03 12:53:53','2022-03-03 12:53:53'),(63760,181,'Gowala','333028',1,0,'2022-03-03 12:53:53','2022-03-03 12:53:53'),(63761,181,'Gudhagorjika','333022',1,0,'2022-03-03 12:53:53','2022-03-03 12:53:53'),(63762,181,'Gujarwas','333516',1,0,'2022-03-03 12:53:53','2022-03-03 12:53:53'),(63763,181,'Gunti','333515',1,0,'2022-03-03 12:53:53','2022-03-03 12:53:53'),(63764,181,'Gura','333053',1,0,'2022-03-03 12:53:53','2022-03-03 12:53:53'),(63765,181,'Haminpur','333031',1,0,'2022-03-03 12:53:53','2022-03-03 12:53:53'),(63766,181,'Hamiri','333001',1,0,'2022-03-03 12:53:53','2022-03-03 12:53:53'),(63767,181,'Hansasar','333001',1,0,'2022-03-03 12:53:53','2022-03-03 12:53:53'),(63768,181,'Hansasari','333011',1,0,'2022-03-03 12:53:53','2022-03-03 12:53:53'),(63769,181,'Hanumanpura','333704',1,0,'2022-03-03 12:53:53','2022-03-03 12:53:53'),(63770,181,'Hardia','332716',1,0,'2022-03-03 12:53:53','2022-03-03 12:53:53'),(63771,181,'Haripura','331025',1,0,'2022-03-03 12:53:54','2022-03-03 12:53:54'),(63772,181,'Hasalsar','333021',1,0,'2022-03-03 12:53:54','2022-03-03 12:53:54'),(63773,181,'Heerawaa','333027',1,0,'2022-03-03 12:53:54','2022-03-03 12:53:54'),(63774,181,'Hetamsar','333041',1,0,'2022-03-03 12:53:54','2022-03-03 12:53:54'),(63775,181,'Hukampura','333012',1,0,'2022-03-03 12:53:54','2022-03-03 12:53:54'),(63776,181,'Indali','333001',1,0,'2022-03-03 12:53:54','2022-03-03 12:53:54'),(63777,181,'Inderpura','333307',1,0,'2022-03-03 12:53:54','2022-03-03 12:53:54'),(63778,181,'Islampur (Jhujhunu)','333024',1,0,'2022-03-03 12:53:54','2022-03-03 12:53:54'),(63779,181,'Jabasar','331026',1,0,'2022-03-03 12:53:54','2022-03-03 12:53:54'),(63780,181,'Jahaz','333302',1,0,'2022-03-03 12:53:54','2022-03-03 12:53:54'),(63781,181,'Jaipahari','333023',1,0,'2022-03-03 12:53:54','2022-03-03 12:53:54'),(63782,181,'Jaitpura','333034',1,0,'2022-03-03 12:53:54','2022-03-03 12:53:54'),(63783,181,'Jaitpura','333022',1,0,'2022-03-03 12:53:54','2022-03-03 12:53:54'),(63784,181,'Jakhal','333305',1,0,'2022-03-03 12:53:54','2022-03-03 12:53:54'),(63785,181,'Jakhod','333033',1,0,'2022-03-03 12:53:54','2022-03-03 12:53:54'),(63786,181,'Jakhora','333025',1,0,'2022-03-03 12:53:54','2022-03-03 12:53:54'),(63787,181,'Jasrapur','333514',1,0,'2022-03-03 12:53:54','2022-03-03 12:53:54'),(63788,181,'Jeeni','333030',1,0,'2022-03-03 12:53:54','2022-03-03 12:53:54'),(63789,181,'Jejusar','333707',1,0,'2022-03-03 12:53:54','2022-03-03 12:53:54'),(63790,181,'Jhajhar','333304',1,0,'2022-03-03 12:53:54','2022-03-03 12:53:54'),(63791,181,'Jhanjha','333502',1,0,'2022-03-03 12:53:54','2022-03-03 12:53:54'),(63792,181,'Jharoda','333034',1,0,'2022-03-03 12:53:54','2022-03-03 12:53:54'),(63793,181,'Jherli','333031',1,0,'2022-03-03 12:53:54','2022-03-03 12:53:54'),(63794,181,'Jhunjhunu Bazar','333001',1,0,'2022-03-03 12:53:54','2022-03-03 12:53:54'),(63795,181,'Jhunjhunu City','333001',1,0,'2022-03-03 12:53:55','2022-03-03 12:53:55'),(63796,181,'Jhunjhunu Court','333001',1,0,'2022-03-03 12:53:55','2022-03-03 12:53:55'),(63797,181,'Jhunjhunu H.O','333001',1,0,'2022-03-03 12:53:55','2022-03-03 12:53:55'),(63798,181,'Jodha Ka Bas','333027',1,0,'2022-03-03 12:53:55','2022-03-03 12:53:55'),(63799,181,'Jodhpura','333801',1,0,'2022-03-03 12:53:55','2022-03-03 12:53:55'),(63800,181,'K.K. Dhani','331027',1,0,'2022-03-03 12:53:55','2022-03-03 12:53:55'),(63801,181,'Kairu','333707',1,0,'2022-03-03 12:53:55','2022-03-03 12:53:55'),(63802,181,'Kajala','333034',1,0,'2022-03-03 12:53:55','2022-03-03 12:53:55'),(63803,181,'Kajara','333030',1,0,'2022-03-03 12:53:55','2022-03-03 12:53:55'),(63804,181,'Kaji','333031',1,0,'2022-03-03 12:53:55','2022-03-03 12:53:55'),(63805,181,'Kakarana','333053',1,0,'2022-03-03 12:53:55','2022-03-03 12:53:55'),(63806,181,'Kakoda','333029',1,0,'2022-03-03 12:53:55','2022-03-03 12:53:55'),(63807,181,'Kakreu Kalan','331028',1,0,'2022-03-03 12:53:55','2022-03-03 12:53:55'),(63808,181,'Kalakhari','333502',1,0,'2022-03-03 12:53:55','2022-03-03 12:53:55'),(63809,181,'Kali Pahari','333024',1,0,'2022-03-03 12:53:55','2022-03-03 12:53:55'),(63810,181,'Kaliasar','331026',1,0,'2022-03-03 12:53:55','2022-03-03 12:53:55'),(63811,181,'Kalota','333501',1,0,'2022-03-03 12:53:55','2022-03-03 12:53:55'),(63812,181,'Kankaria','333053',1,0,'2022-03-03 12:53:55','2022-03-03 12:53:55'),(63813,181,'Kant','331025',1,0,'2022-03-03 12:53:55','2022-03-03 12:53:55'),(63814,181,'Kari','333305',1,0,'2022-03-03 12:53:55','2022-03-03 12:53:55'),(63815,181,'Kasani','333029',1,0,'2022-03-03 12:53:55','2022-03-03 12:53:55'),(63816,181,'Kaseru','333705',1,0,'2022-03-03 12:53:55','2022-03-03 12:53:55'),(63817,181,'Kasimpura','333023',1,0,'2022-03-03 12:53:55','2022-03-03 12:53:55'),(63818,181,'Kcpt Khetri Nagar','333504',1,0,'2022-03-03 12:53:55','2022-03-03 12:53:55'),(63819,181,'Ked','333012',1,0,'2022-03-03 12:53:55','2022-03-03 12:53:55'),(63820,181,'Keharpura','333028',1,0,'2022-03-03 12:53:56','2022-03-03 12:53:56'),(63821,181,'Khadot','333027',1,0,'2022-03-03 12:53:56','2022-03-03 12:53:56'),(63822,181,'Khajpur Naya','333024',1,0,'2022-03-03 12:53:56','2022-03-03 12:53:56'),(63823,181,'Khalasi','333704',1,0,'2022-03-03 12:53:56','2022-03-03 12:53:56'),(63824,181,'Khandawa','333502',1,0,'2022-03-03 12:53:56','2022-03-03 12:53:56'),(63825,181,'Khanpur','333516',1,0,'2022-03-03 12:53:56','2022-03-03 12:53:56'),(63826,181,'Kharkhara','333514',1,0,'2022-03-03 12:53:56','2022-03-03 12:53:56'),(63827,181,'Kharkhari','333011',1,0,'2022-03-03 12:53:56','2022-03-03 12:53:56'),(63828,181,'Khatehpura','333001',1,0,'2022-03-03 12:53:56','2022-03-03 12:53:56'),(63829,181,'Khatkar','333012',1,0,'2022-03-03 12:53:56','2022-03-03 12:53:56'),(63830,181,'Kherala','333035',1,0,'2022-03-03 12:53:56','2022-03-03 12:53:56'),(63831,181,'Khetri Bazar','333503',1,0,'2022-03-03 12:53:56','2022-03-03 12:53:56'),(63832,181,'Khetri Nagar','333504',1,0,'2022-03-03 12:53:56','2022-03-03 12:53:56'),(63833,181,'Khetri (Jhujhunu)','333503',1,0,'2022-03-03 12:53:56','2022-03-03 12:53:56'),(63834,181,'Khinwasar','333012',1,0,'2022-03-03 12:53:56','2022-03-03 12:53:56'),(63835,181,'Khirod','333042',1,0,'2022-03-03 12:53:56','2022-03-03 12:53:56'),(63836,181,'Khoh','333053',1,0,'2022-03-03 12:53:56','2022-03-03 12:53:56'),(63837,181,'Khudana','333023',1,0,'2022-03-03 12:53:56','2022-03-03 12:53:56'),(63838,181,'Khudania','333031',1,0,'2022-03-03 12:53:56','2022-03-03 12:53:56'),(63839,181,'Khyali','331026',1,0,'2022-03-03 12:53:56','2022-03-03 12:53:56'),(63840,181,'Kidwana','333026',1,0,'2022-03-03 12:53:56','2022-03-03 12:53:56'),(63841,181,'Kishanpura','333036',1,0,'2022-03-03 12:53:56','2022-03-03 12:53:56'),(63842,181,'Kishorepura','333053',1,0,'2022-03-03 12:53:56','2022-03-03 12:53:56'),(63843,181,'Kishorpura','333028',1,0,'2022-03-03 12:53:56','2022-03-03 12:53:56'),(63844,181,'Kithana','333028',1,0,'2022-03-03 12:53:56','2022-03-03 12:53:56'),(63845,181,'Kodesar','331027',1,0,'2022-03-03 12:53:56','2022-03-03 12:53:56'),(63846,181,'Kolihan Nagar','333503',1,0,'2022-03-03 12:53:57','2022-03-03 12:53:57'),(63847,181,'Kolinda','333001',1,0,'2022-03-03 12:53:57','2022-03-03 12:53:57'),(63848,181,'Kolsia','333042',1,0,'2022-03-03 12:53:57','2022-03-03 12:53:57'),(63849,181,'Kot','333307',1,0,'2022-03-03 12:53:57','2022-03-03 12:53:57'),(63850,181,'Kuharu','333704',1,0,'2022-03-03 12:53:57','2022-03-03 12:53:57'),(63851,181,'Kuharwas','333034',1,0,'2022-03-03 12:53:57','2022-03-03 12:53:57'),(63852,181,'Kukloth Kalan','333033',1,0,'2022-03-03 12:53:57','2022-03-03 12:53:57'),(63853,181,'Kuloth Chhoti','333033',1,0,'2022-03-03 12:53:57','2022-03-03 12:53:57'),(63854,181,'Kumawas','333707',1,0,'2022-03-03 12:53:57','2022-03-03 12:53:57'),(63855,181,'Kyamsar','333028',1,0,'2022-03-03 12:53:57','2022-03-03 12:53:57'),(63856,181,'Ladunda','333031',1,0,'2022-03-03 12:53:57','2022-03-03 12:53:57'),(63857,181,'Ladusar','333011',1,0,'2022-03-03 12:53:57','2022-03-03 12:53:57'),(63858,181,'Lalamandi','333034',1,0,'2022-03-03 12:53:57','2022-03-03 12:53:57'),(63859,181,'Lalpur','333023',1,0,'2022-03-03 12:53:57','2022-03-03 12:53:57'),(63860,181,'Lamba','333023',1,0,'2022-03-03 12:53:57','2022-03-03 12:53:57'),(63861,181,'Lamba Gothra','333026',1,0,'2022-03-03 12:53:57','2022-03-03 12:53:57'),(63862,181,'Lambi Ahir','333502',1,0,'2022-03-03 12:53:57','2022-03-03 12:53:57'),(63863,181,'Likhawa','333031',1,0,'2022-03-03 12:53:57','2022-03-03 12:53:57'),(63864,181,'Lohargal','333303',1,0,'2022-03-03 12:53:57','2022-03-03 12:53:57'),(63865,181,'Loona','333011',1,0,'2022-03-03 12:53:57','2022-03-03 12:53:57'),(63866,181,'Lootu','333001',1,0,'2022-03-03 12:53:57','2022-03-03 12:53:57'),(63867,181,'Lotia','333029',1,0,'2022-03-03 12:53:57','2022-03-03 12:53:57'),(63868,181,'Loyal','333514',1,0,'2022-03-03 12:53:58','2022-03-03 12:53:58'),(63869,181,'Lumawas','333704',1,0,'2022-03-03 12:53:58','2022-03-03 12:53:58');
INSERT INTO `cities` VALUES (63870,181,'Madhogarh','333501',1,0,'2022-03-03 12:53:58','2022-03-03 12:53:58'),(63871,181,'Mahansar','331030',1,0,'2022-03-03 12:53:58','2022-03-03 12:53:58'),(63872,181,'Mahapalwas','333033',1,0,'2022-03-03 12:53:58','2022-03-03 12:53:58'),(63873,181,'Maharadasi','333704',1,0,'2022-03-03 12:53:58','2022-03-03 12:53:58'),(63874,181,'Maharampur','333028',1,0,'2022-03-03 12:53:58','2022-03-03 12:53:58'),(63875,181,'Mainana','333502',1,0,'2022-03-03 12:53:58','2022-03-03 12:53:58'),(63876,181,'Mainas','333707',1,0,'2022-03-03 12:53:58','2022-03-03 12:53:58'),(63877,181,'Mainpura','333053',1,0,'2022-03-03 12:53:58','2022-03-03 12:53:58'),(63878,181,'Majhau','333305',1,0,'2022-03-03 12:53:58','2022-03-03 12:53:58'),(63879,181,'Makro','333504',1,0,'2022-03-03 12:53:58','2022-03-03 12:53:58'),(63880,181,'Malsar','333021',1,0,'2022-03-03 12:53:58','2022-03-03 12:53:58'),(63881,181,'Malsisar','331028',1,0,'2022-03-03 12:53:58','2022-03-03 12:53:58'),(63882,181,'Manaksas','333801',1,0,'2022-03-03 12:53:58','2022-03-03 12:53:58'),(63883,181,'Mandasi','333705',1,0,'2022-03-03 12:53:58','2022-03-03 12:53:58'),(63884,181,'Mandawa Bazar','333704',1,0,'2022-03-03 12:53:58','2022-03-03 12:53:58'),(63885,181,'Mandawa','333704',1,0,'2022-03-03 12:53:58','2022-03-03 12:53:58'),(63886,181,'Mandawara','333302',1,0,'2022-03-03 12:53:58','2022-03-03 12:53:58'),(63887,181,'Mandrella','333025',1,0,'2022-03-03 12:53:58','2022-03-03 12:53:58'),(63888,181,'Mandri','332746',1,0,'2022-03-03 12:53:58','2022-03-03 12:53:58'),(63889,181,'Manota Jatan','333514',1,0,'2022-03-03 12:53:58','2022-03-03 12:53:58'),(63890,181,'Manota Kalan','333504',1,0,'2022-03-03 12:53:58','2022-03-03 12:53:58'),(63891,181,'Mauta','333302',1,0,'2022-03-03 12:53:58','2022-03-03 12:53:58'),(63892,181,'Mehara Jatuwas','333036',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63893,181,'Mohanpura','333024',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63894,181,'Moi Purani','333516',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63895,181,'Mojas','333704',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63896,181,'Monwari','333042',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63897,181,'Morwa','333031',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63898,181,'Mukundgarh','333705',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63899,181,'Muradpur','333516',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63900,181,'Nalawa','333025',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63901,181,'Nalpur','333503',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63902,181,'Nand','333001',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63903,181,'Nangal','333307',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63904,181,'Nangali Gujarwas','333036',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63905,181,'Nangli Gujran','333026',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63906,181,'Nangli Saledi Singh','333026',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63907,181,'Nansagate Nawalgarh','333042',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63908,181,'Narhar','333035',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63909,181,'Narnod Maligaon','333023',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63910,181,'Narsinghanni','333705',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63911,181,'Nawalari','333042',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63912,181,'Nawalgarh','333042',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63913,181,'Naya Parasrampura','333308',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63914,181,'Nayasar','333001',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63915,181,'Newari','333053',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63916,181,'Nihaloth','333515',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63917,181,'Niradhana','331028',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63918,181,'Niwai','333305',1,0,'2022-03-03 12:53:59','2022-03-03 12:53:59'),(63919,181,'Norangpura','332716',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63920,181,'Nua','333041',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63921,181,'Nuhania','333034',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63922,181,'Nunia Gothra','333026',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63923,181,'Ojtu','333026',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63924,181,'Pabana','333705',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63925,181,'Pacheri Badi','333515',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63926,181,'Pacheri Chhoti','333515',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63927,181,'Pachlangi','333801',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63928,181,'Padampura','333028',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63929,181,'Padewa','332716',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63930,181,'Pakori Dhani','333023',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63931,181,'Palota','333502',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63932,181,'Pantharia','333031',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63933,181,'Panthroli','333515',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63934,181,'Papara','333801',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63935,181,'Papurana','333503',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63936,181,'Parasrampura','333308',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63937,181,'Paratappura','333001',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63938,181,'Patoda','331027',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63939,181,'Patusari','333001',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63940,181,'Peepli','333031',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63941,181,'Pharat','333030',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63942,181,'Phooskhani','333701',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63943,181,'Pichanawa','333026',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63944,181,'Pilani','333031',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63945,181,'Pilod','333029',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63946,181,'Pithusar','331028',1,0,'2022-03-03 12:54:00','2022-03-03 12:54:00'),(63947,181,'Ponkh','333053',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63948,181,'Posana','333022',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63949,181,'Puhania','333516',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63950,181,'Punio Ka Bas3','331027',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63951,181,'Purohitonki Dhani','333001',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63952,181,'Raghunathpura','333022',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63953,181,'Raghunathpura','333029',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63954,181,'Raipur Ahiran','333515',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63955,181,'Raipur Jatan','333516',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63956,181,'Ram Rikh Ki Dhani','333026',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63957,181,'Rampura','331025',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63958,181,'Rampura','333036',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63959,181,'Ranasar','333707',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63960,181,'Ranwa','332746',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63961,181,'Rasoolpur','333026',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63962,181,'Saga','333502',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63963,181,'Sagawa','333034',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63964,181,'Sahad','333502',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63965,181,'Samsapur','333001',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63966,181,'Santore','333515',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63967,181,'Sanwlod','333502',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63968,181,'Saraisurpura','333801',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63969,181,'Sari','333027',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63970,181,'Sefragunwar','332716',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63971,181,'Sehi Kalan','333026',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63972,181,'Shahpura','333516',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63973,181,'Shekhasar','333001',1,0,'2022-03-03 12:54:01','2022-03-03 12:54:01'),(63974,181,'Shimala','332746',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(63975,181,'Shinshiya','333001',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(63976,181,'Signore','333032',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(63977,181,'Sigra','333704',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(63978,181,'Sihor','333036',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(63979,181,'Singhana','333516',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(63980,181,'Siriyasar Kaklan','333041',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(63981,181,'Sirsala','333502',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(63982,181,'Sithal','333021',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(63983,181,'Sohali','333515',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(63984,181,'Solana','333028',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(63985,181,'Sonasar','333011',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(63986,181,'Sotwara','333707',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(63987,181,'Sujdola','333031',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(63988,181,'Sultana Ahiran','333502',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(63989,181,'Sultana','333028',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(63990,181,'Surajgarh Bazar','333029',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(63991,181,'Surajgarh','333029',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(63992,181,'Swami Sehi','333026',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(63993,181,'Tain','331027',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(63994,181,'Tamkore','331026',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(63995,181,'Tatija','333504',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(63996,181,'Teelawali','333514',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(63997,181,'Thali','333516',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(63998,181,'Thathwari','332746',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(63999,181,'Thincholi','333028',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(64000,181,'Tibabasai','333036',1,0,'2022-03-03 12:54:02','2022-03-03 12:54:02'),(64001,181,'Tihara','333503',1,0,'2022-03-03 12:54:03','2022-03-03 12:54:03'),(64002,181,'Titanwar','333012',1,0,'2022-03-03 12:54:03','2022-03-03 12:54:03'),(64003,181,'Todpura','333303',1,0,'2022-03-03 12:54:03','2022-03-03 12:54:03'),(64004,181,'Togara Kalan','333707',1,0,'2022-03-03 12:54:03','2022-03-03 12:54:03'),(64005,181,'Togara Khurd','333707',1,0,'2022-03-03 12:54:03','2022-03-03 12:54:03'),(64006,181,'Toliasar','333704',1,0,'2022-03-03 12:54:03','2022-03-03 12:54:03'),(64007,181,'Tonk Chhhilri','333303',1,0,'2022-03-03 12:54:03','2022-03-03 12:54:03'),(64008,181,'Tyonda','333503',1,0,'2022-03-03 12:54:03','2022-03-03 12:54:03'),(64009,181,'Udaipurwati','333307',1,0,'2022-03-03 12:54:03','2022-03-03 12:54:03'),(64010,181,'Udamandi','333034',1,0,'2022-03-03 12:54:03','2022-03-03 12:54:03'),(64011,181,'Udas','333001',1,0,'2022-03-03 12:54:03','2022-03-03 12:54:03'),(64012,181,'Ureeka','333033',1,0,'2022-03-03 12:54:03','2022-03-03 12:54:03'),(64013,181,'V.V. Pilani','333031',1,0,'2022-03-03 12:54:03','2022-03-03 12:54:03'),(64014,181,'Wahidpura','333704',1,0,'2022-03-03 12:54:03','2022-03-03 12:54:03'),(64015,182,'Aau','342311',1,0,'2022-03-03 12:54:03','2022-03-03 12:54:03'),(64016,182,'Agolai','342001',1,0,'2022-03-03 12:54:03','2022-03-03 12:54:03'),(64017,182,'Amla','342308',1,0,'2022-03-03 12:54:03','2022-03-03 12:54:03'),(64018,182,'Anvana','342037',1,0,'2022-03-03 12:54:03','2022-03-03 12:54:03'),(64019,182,'Artiyan Kallan','342606',1,0,'2022-03-03 12:54:03','2022-03-03 12:54:03'),(64020,182,'Asarlai','342025',1,0,'2022-03-03 12:54:03','2022-03-03 12:54:03'),(64021,182,'Asop','342901',1,0,'2022-03-03 12:54:03','2022-03-03 12:54:03'),(64022,182,'Badliya','342014',1,0,'2022-03-03 12:54:03','2022-03-03 12:54:03'),(64023,182,'Badu','342311',1,0,'2022-03-03 12:54:03','2022-03-03 12:54:03'),(64024,182,'Bagoria','342603',1,0,'2022-03-03 12:54:03','2022-03-03 12:54:03'),(64025,182,'Bala','342605',1,0,'2022-03-03 12:54:04','2022-03-03 12:54:04'),(64026,182,'Balarwa','342306',1,0,'2022-03-03 12:54:04','2022-03-03 12:54:04'),(64027,182,'Balesar Durgawatan','342023',1,0,'2022-03-03 12:54:04','2022-03-03 12:54:04'),(64028,182,'Balesar','342023',1,0,'2022-03-03 12:54:04','2022-03-03 12:54:04'),(64029,182,'Bambore Darjiyan','342001',1,0,'2022-03-03 12:54:04','2022-03-03 12:54:04'),(64030,182,'Banaka Bas','342306',1,0,'2022-03-03 12:54:04','2022-03-03 12:54:04'),(64031,182,'Banar','342027',1,0,'2022-03-03 12:54:04','2022-03-03 12:54:04'),(64032,182,'Banwarla','342027',1,0,'2022-03-03 12:54:04','2022-03-03 12:54:04'),(64033,182,'Bap','342307',1,0,'2022-03-03 12:54:04','2022-03-03 12:54:04'),(64034,182,'Bapini','342311',1,0,'2022-03-03 12:54:04','2022-03-03 12:54:04'),(64035,182,'Baran Khurd','342303',1,0,'2022-03-03 12:54:04','2022-03-03 12:54:04'),(64036,182,'Bari Baori','342301',1,0,'2022-03-03 12:54:04','2022-03-03 12:54:04'),(64037,182,'Bari Sidh','342307',1,0,'2022-03-03 12:54:04','2022-03-03 12:54:04'),(64038,182,'Barjasar','342308',1,0,'2022-03-03 12:54:04','2022-03-03 12:54:04'),(64039,182,'Barla Basni','342306',1,0,'2022-03-03 12:54:04','2022-03-03 12:54:04'),(64040,182,'Barli','342001',1,0,'2022-03-03 12:54:04','2022-03-03 12:54:04'),(64041,182,'Barna','342602',1,0,'2022-03-03 12:54:04','2022-03-03 12:54:04'),(64042,182,'Barnau','342309',1,0,'2022-03-03 12:54:04','2022-03-03 12:54:04'),(64043,182,'Barni Khurd','342901',1,0,'2022-03-03 12:54:04','2022-03-03 12:54:04'),(64044,182,'Barsallu Kallan','342312',1,0,'2022-03-03 12:54:04','2022-03-03 12:54:04'),(64045,182,'Baru','342301',1,0,'2022-03-03 12:54:04','2022-03-03 12:54:04'),(64046,182,'Basni Harisingh','342901',1,0,'2022-03-03 12:54:04','2022-03-03 12:54:04'),(64047,182,'Bastawa','342023',1,0,'2022-03-03 12:54:04','2022-03-03 12:54:04'),(64048,182,'Bavarli','342001',1,0,'2022-03-03 12:54:04','2022-03-03 12:54:04'),(64049,182,'Belwa','342023',1,0,'2022-03-03 12:54:05','2022-03-03 12:54:05'),(64050,182,'Belwa Bagawatan','342023',1,0,'2022-03-03 12:54:05','2022-03-03 12:54:05'),(64051,182,'Belwa Ranajee','342023',1,0,'2022-03-03 12:54:05','2022-03-03 12:54:05'),(64052,182,'Bengti Kallan','342301',1,0,'2022-03-03 12:54:05','2022-03-03 12:54:05'),(64053,182,'Bengti Khurd','342301',1,0,'2022-03-03 12:54:05','2022-03-03 12:54:05'),(64054,182,'Berdon Ka Bass','342306',1,0,'2022-03-03 12:54:05','2022-03-03 12:54:05'),(64055,182,'Beru','342024',1,0,'2022-03-03 12:54:05','2022-03-03 12:54:05'),(64056,182,'Bethwasia','342303',1,0,'2022-03-03 12:54:05','2022-03-03 12:54:05'),(64057,182,'Bhacharna','342801',1,0,'2022-03-03 12:54:05','2022-03-03 12:54:05'),(64058,182,'Bhagasani','342601',1,0,'2022-03-03 12:54:05','2022-03-03 12:54:05'),(64059,182,'Bhalasariya','342306',1,0,'2022-03-03 12:54:05','2022-03-03 12:54:05'),(64060,182,'Bhaloo Kallan','342025',1,0,'2022-03-03 12:54:05','2022-03-03 12:54:05'),(64061,182,'Bhalu Rajwan','342025',1,0,'2022-03-03 12:54:05','2022-03-03 12:54:05'),(64062,182,'Bhana Nagra','342605',1,0,'2022-03-03 12:54:05','2022-03-03 12:54:05'),(64063,182,'Bhandu Charni','342023',1,0,'2022-03-03 12:54:05','2022-03-03 12:54:05'),(64064,182,'Bhandu Jati','342023',1,0,'2022-03-03 12:54:05','2022-03-03 12:54:05'),(64065,182,'Bhandukalla','342014',1,0,'2022-03-03 12:54:05','2022-03-03 12:54:05'),(64066,182,'Bhatinda','342027',1,0,'2022-03-03 12:54:05','2022-03-03 12:54:05'),(64067,182,'Bhavi','342605',1,0,'2022-03-03 12:54:05','2022-03-03 12:54:05'),(64068,182,'Bhawad','342037',1,0,'2022-03-03 12:54:05','2022-03-03 12:54:05'),(64069,182,'Bhenser Chawandiali','342305',1,0,'2022-03-03 12:54:05','2022-03-03 12:54:05'),(64070,182,'Bher','342309',1,0,'2022-03-03 12:54:05','2022-03-03 12:54:05'),(64071,182,'Bhikamkore','342303',1,0,'2022-03-03 12:54:06','2022-03-03 12:54:06'),(64072,182,'Bhiyasar','342311',1,0,'2022-03-03 12:54:06','2022-03-03 12:54:06'),(64073,182,'Bhojakore','342309',1,0,'2022-03-03 12:54:06','2022-03-03 12:54:06'),(64074,182,'Bhojasar','342311',1,0,'2022-03-03 12:54:06','2022-03-03 12:54:06'),(64075,182,'Bhomsagar','342022',1,0,'2022-03-03 12:54:06','2022-03-03 12:54:06'),(64076,182,'Bhopalgarh','342603',1,0,'2022-03-03 12:54:06','2022-03-03 12:54:06'),(64077,182,'Bhundana','342606',1,0,'2022-03-03 12:54:06','2022-03-03 12:54:06'),(64078,182,'Bhungra','342022',1,0,'2022-03-03 12:54:06','2022-03-03 12:54:06'),(64079,182,'Bilara','342602',1,0,'2022-03-03 12:54:06','2022-03-03 12:54:06'),(64080,182,'Binawas','342027',1,0,'2022-03-03 12:54:06','2022-03-03 12:54:06'),(64081,182,'Binjwaria','342306',1,0,'2022-03-03 12:54:06','2022-03-03 12:54:06'),(64082,182,'Birai','342603',1,0,'2022-03-03 12:54:06','2022-03-03 12:54:06'),(64083,182,'Birai','342306',1,0,'2022-03-03 12:54:06','2022-03-03 12:54:06'),(64084,182,'Birami','342027',1,0,'2022-03-03 12:54:06','2022-03-03 12:54:06'),(64085,182,'Birani','342603',1,0,'2022-03-03 12:54:06','2022-03-03 12:54:06'),(64086,182,'Bisalpur','342027',1,0,'2022-03-03 12:54:06','2022-03-03 12:54:06'),(64087,182,'Bithdi','342301',1,0,'2022-03-03 12:54:06','2022-03-03 12:54:06'),(64088,182,'Boranada','342012',1,0,'2022-03-03 12:54:06','2022-03-03 12:54:06'),(64089,182,'Borunda','342604',1,0,'2022-03-03 12:54:06','2022-03-03 12:54:06'),(64090,182,'Borvi Khurd','342606',1,0,'2022-03-03 12:54:06','2022-03-03 12:54:06'),(64091,182,'Boyal','342605',1,0,'2022-03-03 12:54:06','2022-03-03 12:54:06'),(64092,182,'Buchakallan','342601',1,0,'2022-03-03 12:54:06','2022-03-03 12:54:06'),(64093,182,'Bucheti','342606',1,0,'2022-03-03 12:54:06','2022-03-03 12:54:06'),(64094,182,'Bugri','342312',1,0,'2022-03-03 12:54:06','2022-03-03 12:54:06'),(64095,182,'Burkiya','342606',1,0,'2022-03-03 12:54:06','2022-03-03 12:54:06'),(64096,182,'Chaba','342022',1,0,'2022-03-03 12:54:06','2022-03-03 12:54:06'),(64097,182,'Chadi','342312',1,0,'2022-03-03 12:54:07','2022-03-03 12:54:07'),(64098,182,'Chakhoo','342307',1,0,'2022-03-03 12:54:07','2022-03-03 12:54:07'),(64099,182,'Chali','342014',1,0,'2022-03-03 12:54:07','2022-03-03 12:54:07'),(64100,182,'Champasar','342312',1,0,'2022-03-03 12:54:07','2022-03-03 12:54:07'),(64101,182,'Chamu','342306',1,0,'2022-03-03 12:54:07','2022-03-03 12:54:07'),(64102,182,'Chandarakh','342303',1,0,'2022-03-03 12:54:07','2022-03-03 12:54:07'),(64103,182,'Chandelao','342027',1,0,'2022-03-03 12:54:07','2022-03-03 12:54:07'),(64104,182,'Chatogarh','345001',1,0,'2022-03-03 12:54:07','2022-03-03 12:54:07'),(64105,182,'Chawanda','342024',1,0,'2022-03-03 12:54:07','2022-03-03 12:54:07'),(64106,182,'Cheemana','342311',1,0,'2022-03-03 12:54:07','2022-03-03 12:54:07'),(64107,182,'Cherai','342306',1,0,'2022-03-03 12:54:07','2022-03-03 12:54:07'),(64108,182,'Chilla','342301',1,0,'2022-03-03 12:54:07','2022-03-03 12:54:07'),(64109,182,'Chincharli','342014',1,0,'2022-03-03 12:54:07','2022-03-03 12:54:07'),(64110,182,'Chirdani','342601',1,0,'2022-03-03 12:54:07','2022-03-03 12:54:07'),(64111,182,'Chodhan','342601',1,0,'2022-03-03 12:54:07','2022-03-03 12:54:07'),(64112,182,'Chokari Kallan','342601',1,0,'2022-03-03 12:54:07','2022-03-03 12:54:07'),(64113,182,'Chokhan','342001',1,0,'2022-03-03 12:54:07','2022-03-03 12:54:07'),(64114,182,'Chordiyan','342025',1,0,'2022-03-03 12:54:07','2022-03-03 12:54:07'),(64115,182,'Chuturpura','342022',1,0,'2022-03-03 12:54:07','2022-03-03 12:54:07'),(64116,182,'Dabri','342303',1,0,'2022-03-03 12:54:07','2022-03-03 12:54:07'),(64117,182,'Dadmi','342901',1,0,'2022-03-03 12:54:07','2022-03-03 12:54:07'),(64118,182,'Daikara','342027',1,0,'2022-03-03 12:54:07','2022-03-03 12:54:07'),(64119,182,'Daipara Khichiyan','342014',1,0,'2022-03-03 12:54:08','2022-03-03 12:54:08'),(64120,182,'Dangiawas','342027',1,0,'2022-03-03 12:54:08','2022-03-03 12:54:08'),(64121,182,'Dantiwara','342027',1,0,'2022-03-03 12:54:08','2022-03-03 12:54:08'),(64122,182,'Danwra','342037',1,0,'2022-03-03 12:54:08','2022-03-03 12:54:08'),(64123,182,'Dayakore','342309',1,0,'2022-03-03 12:54:08','2022-03-03 12:54:08'),(64124,182,'Dechu','342314',1,0,'2022-03-03 12:54:08','2022-03-03 12:54:08'),(64125,182,'Deda','342025',1,0,'2022-03-03 12:54:08','2022-03-03 12:54:08'),(64126,182,'Deda Hapan','342025',1,0,'2022-03-03 12:54:08','2022-03-03 12:54:08'),(64127,182,'Denok','342308',1,0,'2022-03-03 12:54:08','2022-03-03 12:54:08'),(64128,182,'Deriya','342306',1,0,'2022-03-03 12:54:08','2022-03-03 12:54:08'),(64129,182,'Dev rajgarh','342022',1,0,'2022-03-03 12:54:08','2022-03-03 12:54:08'),(64130,182,'Devania','342306',1,0,'2022-03-03 12:54:08','2022-03-03 12:54:08'),(64131,182,'Devatara','342606',1,0,'2022-03-03 12:54:08','2022-03-03 12:54:08'),(64132,182,'Dewatu','342025',1,0,'2022-03-03 12:54:08','2022-03-03 12:54:08'),(64133,182,'Dhanari Kallan','342037',1,0,'2022-03-03 12:54:08','2022-03-03 12:54:08'),(64134,182,'Dhandhaniya','342001',1,0,'2022-03-03 12:54:08','2022-03-03 12:54:08'),(64135,182,'Dhandhaniya Bhayalan','342001',1,0,'2022-03-03 12:54:08','2022-03-03 12:54:08'),(64136,182,'Dhandiya','342802',1,0,'2022-03-03 12:54:08','2022-03-03 12:54:08'),(64137,182,'Dhasania','342021',1,0,'2022-03-03 12:54:08','2022-03-03 12:54:08'),(64138,182,'Dhawa','342014',1,0,'2022-03-03 12:54:08','2022-03-03 12:54:08'),(64139,182,'Dheerpura','342025',1,0,'2022-03-03 12:54:08','2022-03-03 12:54:08'),(64140,182,'Dhelana','342302',1,0,'2022-03-03 12:54:08','2022-03-03 12:54:08'),(64141,182,'Dholasar','342308',1,0,'2022-03-03 12:54:08','2022-03-03 12:54:08'),(64142,182,'Dhoru','342606',1,0,'2022-03-03 12:54:08','2022-03-03 12:54:08'),(64143,182,'Doli','342014',1,0,'2022-03-03 12:54:08','2022-03-03 12:54:08'),(64144,182,'Dunara','342801',1,0,'2022-03-03 12:54:08','2022-03-03 12:54:08'),(64145,182,'Feench','342801',1,0,'2022-03-03 12:54:09','2022-03-03 12:54:09'),(64146,182,'Fitkasani','342015',1,0,'2022-03-03 12:54:09','2022-03-03 12:54:09'),(64147,182,'Gajsinghpura','342901',1,0,'2022-03-03 12:54:09','2022-03-03 12:54:09'),(64148,182,'Gangani','342027',1,0,'2022-03-03 12:54:09','2022-03-03 12:54:09'),(64149,182,'Garasni','342901',1,0,'2022-03-03 12:54:09','2022-03-03 12:54:09'),(64150,182,'Garha','342022',1,0,'2022-03-03 12:54:09','2022-03-03 12:54:09'),(64151,182,'Ghanamagra','342605',1,0,'2022-03-03 12:54:09','2022-03-03 12:54:09'),(64152,182,'Ghantiyala','342024',1,0,'2022-03-03 12:54:09','2022-03-03 12:54:09'),(64153,182,'Ghantiyali','342311',1,0,'2022-03-03 12:54:09','2022-03-03 12:54:09'),(64154,182,'Gheora','342306',1,0,'2022-03-03 12:54:09','2022-03-03 12:54:09'),(64155,182,'Gilakore','342309',1,0,'2022-03-03 12:54:09','2022-03-03 12:54:09'),(64156,182,'Gingala','342312',1,0,'2022-03-03 12:54:09','2022-03-03 12:54:09'),(64157,182,'Gopalsar','342023',1,0,'2022-03-03 12:54:09','2022-03-03 12:54:09'),(64158,182,'Guda Vishnoiyan','342802',1,0,'2022-03-03 12:54:09','2022-03-03 12:54:09'),(64159,182,'Hariada','342605',1,0,'2022-03-03 12:54:09','2022-03-03 12:54:09'),(64160,182,'Hariyadhana','342601',1,0,'2022-03-03 12:54:09','2022-03-03 12:54:09'),(64161,182,'Hatundi','342312',1,0,'2022-03-03 12:54:09','2022-03-03 12:54:09'),(64162,182,'Himmatpura','342022',1,0,'2022-03-03 12:54:09','2022-03-03 12:54:09'),(64163,182,'Hindalgore','342301',1,0,'2022-03-03 12:54:09','2022-03-03 12:54:09'),(64164,182,'Hiradesar','342603',1,0,'2022-03-03 12:54:09','2022-03-03 12:54:09'),(64165,182,'Hopardi','342301',1,0,'2022-03-03 12:54:09','2022-03-03 12:54:09'),(64166,182,'Hungaon Kallan','342605',1,0,'2022-03-03 12:54:09','2022-03-03 12:54:09'),(64167,182,'Indroka','342306',1,0,'2022-03-03 12:54:09','2022-03-03 12:54:09'),(64168,182,'Ishru','342311',1,0,'2022-03-03 12:54:09','2022-03-03 12:54:09'),(64169,182,'Jaisla','342311',1,0,'2022-03-03 12:54:09','2022-03-03 12:54:09'),(64170,182,'Jaitsar','342021',1,0,'2022-03-03 12:54:10','2022-03-03 12:54:10'),(64171,182,'Jajeli Daikara','342027',1,0,'2022-03-03 12:54:10','2022-03-03 12:54:10'),(64172,182,'Jajiwal Kallan','342027',1,0,'2022-03-03 12:54:10','2022-03-03 12:54:10'),(64173,182,'Jakhan','342312',1,0,'2022-03-03 12:54:10','2022-03-03 12:54:10'),(64174,182,'Jaleli Fozdara','342027',1,0,'2022-03-03 12:54:10','2022-03-03 12:54:10'),(64175,182,'Jalora','342301',1,0,'2022-03-03 12:54:10','2022-03-03 12:54:10'),(64176,182,'Jalori Gate','342003',1,0,'2022-03-03 12:54:10','2022-03-03 12:54:10'),(64177,182,'Jamba','342301',1,0,'2022-03-03 12:54:10','2022-03-03 12:54:10'),(64178,182,'Jammeshwar Nagar','342302',1,0,'2022-03-03 12:54:10','2022-03-03 12:54:10'),(64179,182,'Janadesar','342014',1,0,'2022-03-03 12:54:10','2022-03-03 12:54:10'),(64180,182,'Jelu Gagari','342306',1,0,'2022-03-03 12:54:10','2022-03-03 12:54:10'),(64181,182,'Jethania','342021',1,0,'2022-03-03 12:54:10','2022-03-03 12:54:10'),(64182,182,'Jetiwas','342602',1,0,'2022-03-03 12:54:10','2022-03-03 12:54:10'),(64183,182,'Jhak','342602',1,0,'2022-03-03 12:54:10','2022-03-03 12:54:10'),(64184,182,'Jhalamand','342013',1,0,'2022-03-03 12:54:10','2022-03-03 12:54:10'),(64185,182,'Jhanwar','342014',1,0,'2022-03-03 12:54:10','2022-03-03 12:54:10'),(64186,182,'Jhinjhinyala','342023',1,0,'2022-03-03 12:54:10','2022-03-03 12:54:10'),(64187,182,'Jodhpur Aerodrame','342011',1,0,'2022-03-03 12:54:10','2022-03-03 12:54:10'),(64188,182,'Jodhpur Agency','342011',1,0,'2022-03-03 12:54:10','2022-03-03 12:54:10'),(64189,182,'Jodhpur Bhagat Ki Kothi','342001',1,0,'2022-03-03 12:54:10','2022-03-03 12:54:10'),(64190,182,'Jodhpur BSF Trg Centre','342026',1,0,'2022-03-03 12:54:10','2022-03-03 12:54:10'),(64191,182,'Jodhpur Chopasni Road','342003',1,0,'2022-03-03 12:54:10','2022-03-03 12:54:10'),(64192,182,'Jodhpur City','342001',1,0,'2022-03-03 12:54:10','2022-03-03 12:54:10'),(64193,182,'Jodhpur Cloth Market','342001',1,0,'2022-03-03 12:54:11','2022-03-03 12:54:11'),(64194,182,'Jodhpur Girdikot','342001',1,0,'2022-03-03 12:54:11','2022-03-03 12:54:11'),(64195,182,'Jodhpur H.O','342001',1,0,'2022-03-03 12:54:11','2022-03-03 12:54:11'),(64196,182,'Jodhpur K.U.M. Bhagat Ki Kothi','342005',1,0,'2022-03-03 12:54:11','2022-03-03 12:54:11'),(64197,182,'Jodhpur K.U.M. Mandore Road','342007',1,0,'2022-03-03 12:54:11','2022-03-03 12:54:11'),(64198,182,'Jodhpur Kachery','342006',1,0,'2022-03-03 12:54:11','2022-03-03 12:54:11'),(64199,182,'Jodhpur Laxmi Nagar','342006',1,0,'2022-03-03 12:54:11','2022-03-03 12:54:11'),(64200,182,'Jodhpur Mahamandir','342006',1,0,'2022-03-03 12:54:11','2022-03-03 12:54:11'),(64201,182,'Jodhpur Marudhar Ind  Area','342005',1,0,'2022-03-03 12:54:11','2022-03-03 12:54:11'),(64202,182,'Jodhpur Rasala Road','342006',1,0,'2022-03-03 12:54:11','2022-03-03 12:54:11'),(64203,182,'Jodhpur Residency Road','342011',1,0,'2022-03-03 12:54:11','2022-03-03 12:54:11'),(64204,182,'Jodhpur Shastri Nagar','342003',1,0,'2022-03-03 12:54:11','2022-03-03 12:54:11'),(64205,182,'Jodhpur Umaid Bhawan','342006',1,0,'2022-03-03 12:54:11','2022-03-03 12:54:11'),(64206,182,'Jodhpur University Campus','342001',1,0,'2022-03-03 12:54:11','2022-03-03 12:54:11'),(64207,182,'Joliyali','342001',1,0,'2022-03-03 12:54:11','2022-03-03 12:54:11'),(64208,182,'Jud','342305',1,0,'2022-03-03 12:54:11','2022-03-03 12:54:11'),(64209,182,'Judia','342023',1,0,'2022-03-03 12:54:12','2022-03-03 12:54:12'),(64210,182,'Kabutaron Ka Chowk','342001',1,0,'2022-03-03 12:54:12','2022-03-03 12:54:12'),(64211,182,'Kajnau Kallan','342037',1,0,'2022-03-03 12:54:12','2022-03-03 12:54:12'),(64212,182,'Kakani','342802',1,0,'2022-03-03 12:54:12','2022-03-03 12:54:12'),(64213,182,'Kakelao','342027',1,0,'2022-03-03 12:54:12','2022-03-03 12:54:12'),(64214,182,'Kalau','342021',1,0,'2022-03-03 12:54:12','2022-03-03 12:54:12'),(64215,182,'Kali Beri','342024',1,0,'2022-03-03 12:54:12','2022-03-03 12:54:12'),(64216,182,'Kanasar','342307',1,0,'2022-03-03 12:54:12','2022-03-03 12:54:12'),(64217,182,'Kanodia','342314',1,0,'2022-03-03 12:54:12','2022-03-03 12:54:12'),(64218,182,'Kansingh Ki Sidh','342307',1,0,'2022-03-03 12:54:12','2022-03-03 12:54:12'),(64219,182,'Kapooria','342312',1,0,'2022-03-03 12:54:12','2022-03-03 12:54:12'),(64220,182,'Kaprda','342605',1,0,'2022-03-03 12:54:12','2022-03-03 12:54:12'),(64221,182,'Karwar','342037',1,0,'2022-03-03 12:54:12','2022-03-03 12:54:12'),(64222,182,'Kasti','342037',1,0,'2022-03-03 12:54:12','2022-03-03 12:54:12'),(64223,182,'Kelansar','342311',1,0,'2022-03-03 12:54:12','2022-03-03 12:54:12'),(64224,182,'Kelva Kallan','342037',1,0,'2022-03-03 12:54:12','2022-03-03 12:54:12'),(64225,182,'Keru','342024',1,0,'2022-03-03 12:54:12','2022-03-03 12:54:12'),(64226,182,'Ketu Hema','342025',1,0,'2022-03-03 12:54:12','2022-03-03 12:54:12'),(64227,182,'Ketu Kallan','342025',1,0,'2022-03-03 12:54:12','2022-03-03 12:54:12'),(64228,182,'Khabra Khurd','342303',1,0,'2022-03-03 12:54:12','2022-03-03 12:54:12'),(64229,182,'Khangta','342606',1,0,'2022-03-03 12:54:12','2022-03-03 12:54:12'),(64230,182,'Khara Bera Bheemawatan','342802',1,0,'2022-03-03 12:54:12','2022-03-03 12:54:12'),(64231,182,'Khara Bera Purohitan','342802',1,0,'2022-03-03 12:54:12','2022-03-03 12:54:12'),(64232,182,'Kharda Mewasa','342305',1,0,'2022-03-03 12:54:12','2022-03-03 12:54:12'),(64233,182,'Kharda Randheer','342015',1,0,'2022-03-03 12:54:12','2022-03-03 12:54:12'),(64234,182,'Kharia Khangar','342606',1,0,'2022-03-03 12:54:13','2022-03-03 12:54:13'),(64235,182,'Kharia Mithapur','342602',1,0,'2022-03-03 12:54:13','2022-03-03 12:54:13'),(64236,182,'Khatiyasani','342027',1,0,'2022-03-03 12:54:13','2022-03-03 12:54:13'),(64237,182,'Khawaspura','342601',1,0,'2022-03-03 12:54:13','2022-03-03 12:54:13'),(64238,182,'Khejarla','342601',1,0,'2022-03-03 12:54:13','2022-03-03 12:54:13'),(64239,182,'Khejarli Kallan','342802',1,0,'2022-03-03 12:54:13','2022-03-03 12:54:13'),(64240,182,'Kherapa','342037',1,0,'2022-03-03 12:54:13','2022-03-03 12:54:13'),(64241,182,'Kheri Salwa','342606',1,0,'2022-03-03 12:54:13','2022-03-03 12:54:13'),(64242,182,'Khetasar','342303',1,0,'2022-03-03 12:54:13','2022-03-03 12:54:13'),(64243,182,'Khetasar','342301',1,0,'2022-03-03 12:54:13','2022-03-03 12:54:13'),(64244,182,'Khichan','342308',1,0,'2022-03-03 12:54:13','2022-03-03 12:54:13'),(64245,182,'Khidrat','342307',1,0,'2022-03-03 12:54:13','2022-03-03 12:54:13'),(64246,182,'Khindakore','342312',1,0,'2022-03-03 12:54:13','2022-03-03 12:54:13'),(64247,182,'Khiny Asariya','342025',1,0,'2022-03-03 12:54:13','2022-03-03 12:54:13'),(64248,182,'Khirja Ashan','342028',1,0,'2022-03-03 12:54:13','2022-03-03 12:54:13'),(64249,182,'Khirja Khas','342028',1,0,'2022-03-03 12:54:13','2022-03-03 12:54:13'),(64250,182,'Khirja Tibna','342028',1,0,'2022-03-03 12:54:13','2022-03-03 12:54:13'),(64251,182,'Khudala','342014',1,0,'2022-03-03 12:54:13','2022-03-03 12:54:13'),(64252,182,'Khudiyala','342306',1,0,'2022-03-03 12:54:13','2022-03-03 12:54:13'),(64253,182,'Kinjari','342312',1,0,'2022-03-03 12:54:13','2022-03-03 12:54:13'),(64254,182,'Kolu Pabuji','342314',1,0,'2022-03-03 12:54:13','2022-03-03 12:54:13'),(64255,182,'Kolu Rathoran','342314',1,0,'2022-03-03 12:54:13','2022-03-03 12:54:13'),(64256,182,'Kood','342606',1,0,'2022-03-03 12:54:13','2022-03-03 12:54:13'),(64257,182,'Kosana','342601',1,0,'2022-03-03 12:54:13','2022-03-03 12:54:13'),(64258,182,'Kudi','342606',1,0,'2022-03-03 12:54:14','2022-03-03 12:54:14'),(64259,182,'Kui Inda','342023',1,0,'2022-03-03 12:54:14','2022-03-03 12:54:14'),(64260,182,'Kuri Bhagtasni Housing Board','342005',1,0,'2022-03-03 12:54:14','2022-03-03 12:54:14'),(64261,182,'Kushlawa','342314',1,0,'2022-03-03 12:54:14','2022-03-03 12:54:14'),(64262,182,'Lamba','342605',1,0,'2022-03-03 12:54:14','2022-03-03 12:54:14'),(64263,182,'Lavera Baori','342037',1,0,'2022-03-03 12:54:14','2022-03-03 12:54:14'),(64264,182,'Lavera Kallan','342037',1,0,'2022-03-03 12:54:14','2022-03-03 12:54:14'),(64265,182,'Lavera Khurd','342037',1,0,'2022-03-03 12:54:14','2022-03-03 12:54:14'),(64266,182,'Lawaran','342025',1,0,'2022-03-03 12:54:14','2022-03-03 12:54:14'),(64267,182,'Laxman Nagar','342312',1,0,'2022-03-03 12:54:14','2022-03-03 12:54:14'),(64268,182,'Lodi Daijran','342001',1,0,'2022-03-03 12:54:14','2022-03-03 12:54:14'),(64269,182,'Lohawat Jatabas','342302',1,0,'2022-03-03 12:54:14','2022-03-03 12:54:14'),(64270,182,'Loona','342307',1,0,'2022-03-03 12:54:14','2022-03-03 12:54:14'),(64271,182,'Loonawas Kallan','342014',1,0,'2022-03-03 12:54:14','2022-03-03 12:54:14'),(64272,182,'Loonawas Khara','342014',1,0,'2022-03-03 12:54:14','2022-03-03 12:54:14'),(64273,182,'Lordi Panditji','342037',1,0,'2022-03-03 12:54:14','2022-03-03 12:54:14'),(64274,182,'Lordiyan','342301',1,0,'2022-03-03 12:54:14','2022-03-03 12:54:14'),(64275,182,'Lorta Achalawatan','342309',1,0,'2022-03-03 12:54:14','2022-03-03 12:54:14'),(64276,182,'Luni','342802',1,0,'2022-03-03 12:54:14','2022-03-03 12:54:14'),(64277,182,'Madaliya','342601',1,0,'2022-03-03 12:54:14','2022-03-03 12:54:14'),(64278,182,'Mageria','342901',1,0,'2022-03-03 12:54:14','2022-03-03 12:54:14'),(64279,182,'Mailana','342603',1,0,'2022-03-03 12:54:14','2022-03-03 12:54:14'),(64280,182,'Malamsingh Ki Sidh','342307',1,0,'2022-03-03 12:54:14','2022-03-03 12:54:14'),(64281,182,'Malar','342301',1,0,'2022-03-03 12:54:14','2022-03-03 12:54:14'),(64282,182,'Malar','342606',1,0,'2022-03-03 12:54:14','2022-03-03 12:54:14'),(64283,182,'Malkosni','342605',1,0,'2022-03-03 12:54:15','2022-03-03 12:54:15'),(64284,182,'Malunga','342024',1,0,'2022-03-03 12:54:15','2022-03-03 12:54:15'),(64285,182,'Manaklao','342305',1,0,'2022-03-03 12:54:15','2022-03-03 12:54:15'),(64286,182,'Mandial Kallan','342306',1,0,'2022-03-03 12:54:15','2022-03-03 12:54:15'),(64287,182,'Mandore','342304',1,0,'2022-03-03 12:54:15','2022-03-03 12:54:15'),(64288,182,'Mathania','342305',1,0,'2022-03-03 12:54:15','2022-03-03 12:54:15'),(64289,182,'Mattoda','342311',1,0,'2022-03-03 12:54:15','2022-03-03 12:54:15'),(64290,182,'Modi Joshiyan','342027',1,0,'2022-03-03 12:54:15','2022-03-03 12:54:15'),(64291,182,'Mogra Kallan','342802',1,0,'2022-03-03 12:54:15','2022-03-03 12:54:15'),(64292,182,'Mohri','342301',1,0,'2022-03-03 12:54:15','2022-03-03 12:54:15'),(64293,182,'Mokheri','342301',1,0,'2022-03-03 12:54:15','2022-03-03 12:54:15'),(64294,182,'Moriya Munjasar','342308',1,0,'2022-03-03 12:54:15','2022-03-03 12:54:15'),(64295,182,'Motai','342301',1,0,'2022-03-03 12:54:15','2022-03-03 12:54:15'),(64296,182,'Nadsar','342603',1,0,'2022-03-03 12:54:15','2022-03-03 12:54:15'),(64297,182,'Nanan','342601',1,0,'2022-03-03 12:54:15','2022-03-03 12:54:15'),(64298,182,'Nandanwan','342008',1,0,'2022-03-03 12:54:15','2022-03-03 12:54:15'),(64299,182,'Nandia Kallan','342037',1,0,'2022-03-03 12:54:15','2022-03-03 12:54:15'),(64300,182,'Nandiya Khurd','342037',1,0,'2022-03-03 12:54:15','2022-03-03 12:54:15'),(64301,182,'Nandiya Prabhawati','342606',1,0,'2022-03-03 12:54:15','2022-03-03 12:54:15'),(64302,182,'Nandra Kallan','342015',1,0,'2022-03-03 12:54:15','2022-03-03 12:54:15'),(64303,182,'Nandri','342015',1,0,'2022-03-03 12:54:15','2022-03-03 12:54:15'),(64304,182,'Narnadi','342014',1,0,'2022-03-03 12:54:15','2022-03-03 12:54:15'),(64305,182,'Narwa','342306',1,0,'2022-03-03 12:54:15','2022-03-03 12:54:15'),(64306,182,'Nathrau','342309',1,0,'2022-03-03 12:54:15','2022-03-03 12:54:15'),(64307,182,'Neneu','342301',1,0,'2022-03-03 12:54:15','2022-03-03 12:54:15'),(64308,182,'Neora','342303',1,0,'2022-03-03 12:54:15','2022-03-03 12:54:15'),(64309,182,'Netra','342037',1,0,'2022-03-03 12:54:16','2022-03-03 12:54:16'),(64310,182,'Nimba Ka Gaon','342023',1,0,'2022-03-03 12:54:16','2022-03-03 12:54:16'),(64311,182,'Nimbo Ka Talab','342311',1,0,'2022-03-03 12:54:16','2022-03-03 12:54:16'),(64312,182,'Nokhra Bhatiyan','342311',1,0,'2022-03-03 12:54:16','2022-03-03 12:54:16'),(64313,182,'Noore Ki Bhuj','342307',1,0,'2022-03-03 12:54:16','2022-03-03 12:54:16'),(64314,182,'Nosar','342303',1,0,'2022-03-03 12:54:16','2022-03-03 12:54:16'),(64315,182,'Olvi','342605',1,0,'2022-03-03 12:54:16','2022-03-03 12:54:16'),(64316,182,'Osian','342303',1,0,'2022-03-03 12:54:16','2022-03-03 12:54:16'),(64317,182,'Pabusar','342021',1,0,'2022-03-03 12:54:16','2022-03-03 12:54:16'),(64318,182,'Padasala','342303',1,0,'2022-03-03 12:54:16','2022-03-03 12:54:16'),(64319,182,'Padasla Kallan','342605',1,0,'2022-03-03 12:54:16','2022-03-03 12:54:16'),(64320,182,'Padiyal','342308',1,0,'2022-03-03 12:54:16','2022-03-03 12:54:16'),(64321,182,'Pal','342014',1,0,'2022-03-03 12:54:16','2022-03-03 12:54:16'),(64322,182,'Palasni','342027',1,0,'2022-03-03 12:54:16','2022-03-03 12:54:16'),(64323,182,'Paldi Ranawatan','342901',1,0,'2022-03-03 12:54:16','2022-03-03 12:54:16'),(64324,182,'Palina','342308',1,0,'2022-03-03 12:54:16','2022-03-03 12:54:16'),(64325,182,'Palli','342302',1,0,'2022-03-03 12:54:16','2022-03-03 12:54:16'),(64326,182,'Palri Sidhan','342606',1,0,'2022-03-03 12:54:16','2022-03-03 12:54:16'),(64327,182,'Panchala Khurd','342306',1,0,'2022-03-03 12:54:16','2022-03-03 12:54:16'),(64328,182,'Paschimi Dhani','342302',1,0,'2022-03-03 12:54:16','2022-03-03 12:54:16'),(64329,182,'Patel Nagar','342604',1,0,'2022-03-03 12:54:16','2022-03-03 12:54:16'),(64330,182,'Peelwa','342309',1,0,'2022-03-03 12:54:16','2022-03-03 12:54:16'),(64331,182,'Peethawas','342027',1,0,'2022-03-03 12:54:16','2022-03-03 12:54:16'),(64332,182,'Phalodi Naya Bazar','342301',1,0,'2022-03-03 12:54:16','2022-03-03 12:54:16'),(64333,182,'Phalodi','342301',1,0,'2022-03-03 12:54:16','2022-03-03 12:54:16'),(64334,182,'Phalodi Sadar Bazar','342301',1,0,'2022-03-03 12:54:17','2022-03-03 12:54:17'),(64335,182,'Pichiyak','342602',1,0,'2022-03-03 12:54:17','2022-03-03 12:54:17'),(64336,182,'Pipar Chopra Bazar','342601',1,0,'2022-03-03 12:54:17','2022-03-03 12:54:17'),(64337,182,'Pipar Road','342606',1,0,'2022-03-03 12:54:17','2022-03-03 12:54:17'),(64338,182,'Pipar','342601',1,0,'2022-03-03 12:54:17','2022-03-03 12:54:17'),(64339,182,'Piparli','342801',1,0,'2022-03-03 12:54:17','2022-03-03 12:54:17'),(64340,182,'Pokaran City','345021',1,0,'2022-03-03 12:54:17','2022-03-03 12:54:17'),(64341,182,'Poonam Nagar','345001',1,0,'2022-03-03 12:54:17','2022-03-03 12:54:17'),(64342,182,'Poonasar','342312',1,0,'2022-03-03 12:54:17','2022-03-03 12:54:17'),(64343,182,'Popawas','342024',1,0,'2022-03-03 12:54:17','2022-03-03 12:54:17'),(64344,182,'Pratap Nagar (Jodhpur)','342003',1,0,'2022-03-03 12:54:17','2022-03-03 12:54:17'),(64345,182,'Punjla','342304',1,0,'2022-03-03 12:54:17','2022-03-03 12:54:17'),(64346,182,'Radod','342901',1,0,'2022-03-03 12:54:17','2022-03-03 12:54:17'),(64347,182,'Railway Office','342001',1,0,'2022-03-03 12:54:17','2022-03-03 12:54:17'),(64348,182,'Raimalwara','342312',1,0,'2022-03-03 12:54:17','2022-03-03 12:54:17'),(64349,182,'Raisar','342022',1,0,'2022-03-03 12:54:17','2022-03-03 12:54:17'),(64350,182,'Rajasthan High Court NB','342013',1,0,'2022-03-03 12:54:17','2022-03-03 12:54:17'),(64351,182,'Rajlani','342901',1,0,'2022-03-03 12:54:17','2022-03-03 12:54:17'),(64352,182,'Rajshri Nagar','342606',1,0,'2022-03-03 12:54:17','2022-03-03 12:54:17'),(64353,182,'Ramaniyana','342601',1,0,'2022-03-03 12:54:17','2022-03-03 12:54:17'),(64354,182,'Ramasni','342605',1,0,'2022-03-03 12:54:17','2022-03-03 12:54:17'),(64355,182,'Ramdawas Kallan','342606',1,0,'2022-03-03 12:54:17','2022-03-03 12:54:17'),(64356,182,'Rampura Bhatiyan','342305',1,0,'2022-03-03 12:54:17','2022-03-03 12:54:17'),(64357,182,'Raneri','342301',1,0,'2022-03-03 12:54:17','2022-03-03 12:54:17'),(64358,182,'Ransi Gaon','342601',1,0,'2022-03-03 12:54:18','2022-03-03 12:54:18'),(64359,182,'Ratanada','342011',1,0,'2022-03-03 12:54:18','2022-03-03 12:54:18'),(64360,182,'Ratkuria','342606',1,0,'2022-03-03 12:54:18','2022-03-03 12:54:18'),(64361,182,'Rawar','342605',1,0,'2022-03-03 12:54:18','2022-03-03 12:54:18'),(64362,182,'Ridmalsar','342312',1,0,'2022-03-03 12:54:18','2022-03-03 12:54:18'),(64363,182,'Riyan','342601',1,0,'2022-03-03 12:54:18','2022-03-03 12:54:18'),(64364,182,'Rohicha Kallan','342801',1,0,'2022-03-03 12:54:18','2022-03-03 12:54:18'),(64365,182,'Rohicha Khurd','342801',1,0,'2022-03-03 12:54:18','2022-03-03 12:54:18'),(64366,182,'Rohina','342312',1,0,'2022-03-03 12:54:18','2022-03-03 12:54:18'),(64367,182,'Sagrau','342314',1,0,'2022-03-03 12:54:18','2022-03-03 12:54:18'),(64368,182,'Sai','342022',1,0,'2022-03-03 12:54:18','2022-03-03 12:54:18'),(64369,182,'Salawas','342013',1,0,'2022-03-03 12:54:18','2022-03-03 12:54:18'),(64370,182,'Salkha','345001',1,0,'2022-03-03 12:54:18','2022-03-03 12:54:18'),(64371,182,'Salori','342024',1,0,'2022-03-03 12:54:18','2022-03-03 12:54:18'),(64372,182,'Salwa Kallan','342027',1,0,'2022-03-03 12:54:18','2022-03-03 12:54:18'),(64373,182,'Sambhariya','342601',1,0,'2022-03-03 12:54:18','2022-03-03 12:54:18'),(64374,182,'Samrau','342302',1,0,'2022-03-03 12:54:18','2022-03-03 12:54:18'),(64375,182,'Sangaria (Jodhpur)','342013',1,0,'2022-03-03 12:54:18','2022-03-03 12:54:18'),(64376,182,'Sanurij','342314',1,0,'2022-03-03 12:54:18','2022-03-03 12:54:18'),(64377,182,'Sar','342801',1,0,'2022-03-03 12:54:18','2022-03-03 12:54:18'),(64378,182,'Saran Nagar','342015',1,0,'2022-03-03 12:54:18','2022-03-03 12:54:18'),(64379,182,'Sarecha','342801',1,0,'2022-03-03 12:54:18','2022-03-03 12:54:18'),(64380,182,'Sathin','342601',1,0,'2022-03-03 12:54:18','2022-03-03 12:54:18'),(64381,182,'Satlana','342802',1,0,'2022-03-03 12:54:18','2022-03-03 12:54:18'),(64382,182,'Sawant Kuan Khurd','342037',1,0,'2022-03-03 12:54:18','2022-03-03 12:54:18'),(64383,182,'Setrawa','342025',1,0,'2022-03-03 12:54:19','2022-03-03 12:54:19'),(64384,182,'Sewania','342604',1,0,'2022-03-03 12:54:19','2022-03-03 12:54:19'),(64385,182,'Sewki Kallan','342606',1,0,'2022-03-03 12:54:19','2022-03-03 12:54:19'),(64386,182,'Shaitan Singh Nagar','342308',1,0,'2022-03-03 12:54:19','2022-03-03 12:54:19'),(64387,182,'Shekhala','342025',1,0,'2022-03-03 12:54:19','2022-03-03 12:54:19'),(64388,182,'Shekhasar','342301',1,0,'2022-03-03 12:54:19','2022-03-03 12:54:19'),(64389,182,'Shergarh (Jodhpur)','342022',1,0,'2022-03-03 12:54:19','2022-03-03 12:54:19'),(64390,182,'Sikarpura','342802',1,0,'2022-03-03 12:54:19','2022-03-03 12:54:19'),(64391,182,'Silari','342605',1,0,'2022-03-03 12:54:19','2022-03-03 12:54:19'),(64392,182,'Sinali','342014',1,0,'2022-03-03 12:54:19','2022-03-03 12:54:19'),(64393,182,'Sindhipura','342601',1,0,'2022-03-03 12:54:19','2022-03-03 12:54:19'),(64394,182,'Singhda','342301',1,0,'2022-03-03 12:54:19','2022-03-03 12:54:19'),(64395,182,'Sirmandi','342303',1,0,'2022-03-03 12:54:19','2022-03-03 12:54:19'),(64396,182,'Siwanchi Gate','342001',1,0,'2022-03-03 12:54:19','2022-03-03 12:54:19'),(64397,182,'Siyada','342028',1,0,'2022-03-03 12:54:19','2022-03-03 12:54:19'),(64398,182,'Siyara','342601',1,0,'2022-03-03 12:54:19','2022-03-03 12:54:19'),(64399,182,'Sointra','342022',1,0,'2022-03-03 12:54:19','2022-03-03 12:54:19'),(64400,182,'Solankiya Tala','342025',1,0,'2022-03-03 12:54:19','2022-03-03 12:54:19'),(64401,182,'Somesar','342021',1,0,'2022-03-03 12:54:19','2022-03-03 12:54:19'),(64402,182,'Soorsagar','342024',1,0,'2022-03-03 12:54:19','2022-03-03 12:54:19'),(64403,182,'Soyla','342037',1,0,'2022-03-03 12:54:19','2022-03-03 12:54:19'),(64404,182,'Subdand','342014',1,0,'2022-03-03 12:54:19','2022-03-03 12:54:19'),(64405,182,'Subhash Nagar Jodhpur','342008',1,0,'2022-03-03 12:54:19','2022-03-03 12:54:19'),(64406,182,'Surani','342001',1,0,'2022-03-03 12:54:20','2022-03-03 12:54:20'),(64407,182,'Surpura','342304',1,0,'2022-03-03 12:54:20','2022-03-03 12:54:20'),(64408,182,'Surpura Khurd','342603',1,0,'2022-03-03 12:54:20','2022-03-03 12:54:20'),(64409,182,'Suwalia','342022',1,0,'2022-03-03 12:54:20','2022-03-03 12:54:20'),(64410,182,'Suwap','342311',1,0,'2022-03-03 12:54:20','2022-03-03 12:54:20'),(64411,182,'Tapoo','342312',1,0,'2022-03-03 12:54:20','2022-03-03 12:54:20'),(64412,182,'Tejpala','345001',1,0,'2022-03-03 12:54:20','2022-03-03 12:54:20'),(64413,182,'Tekra','342301',1,0,'2022-03-03 12:54:20','2022-03-03 12:54:20'),(64414,182,'Tena','342028',1,0,'2022-03-03 12:54:20','2022-03-03 12:54:20'),(64415,182,'Teori','342306',1,0,'2022-03-03 12:54:20','2022-03-03 12:54:20'),(64416,182,'Tepu','342301',1,0,'2022-03-03 12:54:20','2022-03-03 12:54:20'),(64417,182,'Thadia','342314',1,0,'2022-03-03 12:54:20','2022-03-03 12:54:20'),(64418,182,'Thob','342303',1,0,'2022-03-03 12:54:20','2022-03-03 12:54:20'),(64419,182,'Tilwasni','342605',1,0,'2022-03-03 12:54:20','2022-03-03 12:54:20'),(64420,182,'Udaliyawas','342602',1,0,'2022-03-03 12:54:20','2022-03-03 12:54:20'),(64421,182,'Udat','342307',1,0,'2022-03-03 12:54:20','2022-03-03 12:54:20'),(64422,182,'Umed Nagar','342305',1,0,'2022-03-03 12:54:20','2022-03-03 12:54:20'),(64423,182,'Ustran','342603',1,0,'2022-03-03 12:54:20','2022-03-03 12:54:20'),(64424,182,'Utamber','342306',1,0,'2022-03-03 12:54:20','2022-03-03 12:54:20'),(64425,183,'Ajijpur','321611',1,0,'2022-03-03 12:54:20','2022-03-03 12:54:20'),(64426,183,'Amargarh Dang','322218',1,0,'2022-03-03 12:54:20','2022-03-03 12:54:20'),(64427,183,'Amarwad','322218',1,0,'2022-03-03 12:54:20','2022-03-03 12:54:20'),(64428,183,'Aound','322251',1,0,'2022-03-03 12:54:20','2022-03-03 12:54:20'),(64429,183,'Ata','322241',1,0,'2022-03-03 12:54:20','2022-03-03 12:54:20'),(64430,183,'Ateiwa','322243',1,0,'2022-03-03 12:54:21','2022-03-03 12:54:21'),(64431,183,'Badagaon','322216',1,0,'2022-03-03 12:54:21','2022-03-03 12:54:21'),(64432,183,'Badasawata','322204',1,0,'2022-03-03 12:54:21','2022-03-03 12:54:21'),(64433,183,'Badleta Khurd','322238',1,0,'2022-03-03 12:54:21','2022-03-03 12:54:21'),(64434,183,'Bagida','322218',1,0,'2022-03-03 12:54:21','2022-03-03 12:54:21'),(64435,183,'Bagor','322204',1,0,'2022-03-03 12:54:21','2022-03-03 12:54:21'),(64436,183,'Bahadurpur','322249',1,0,'2022-03-03 12:54:21','2022-03-03 12:54:21'),(64437,183,'Bajna','322218',1,0,'2022-03-03 12:54:21','2022-03-03 12:54:21'),(64438,183,'Balghat','322238',1,0,'2022-03-03 12:54:21','2022-03-03 12:54:21'),(64439,183,'Baloti','322202',1,0,'2022-03-03 12:54:21','2022-03-03 12:54:21'),(64440,183,'Banki PSSK','322230',1,0,'2022-03-03 12:54:21','2022-03-03 12:54:21'),(64441,183,'Bardala','322215',1,0,'2022-03-03 12:54:21','2022-03-03 12:54:21'),(64442,183,'Bargama','322230',1,0,'2022-03-03 12:54:21','2022-03-03 12:54:21'),(64443,183,'Bariya','322255',1,0,'2022-03-03 12:54:21','2022-03-03 12:54:21'),(64444,183,'Barkheda','322241',1,0,'2022-03-03 12:54:21','2022-03-03 12:54:21'),(64445,183,'Baroda Gajrajpal','322203',1,0,'2022-03-03 12:54:21','2022-03-03 12:54:21'),(64446,183,'Bhaisa','321611',1,0,'2022-03-03 12:54:21','2022-03-03 12:54:21'),(64447,183,'Bhajeda','321610',1,0,'2022-03-03 12:54:21','2022-03-03 12:54:21'),(64448,183,'Bhanakpura','321610',1,0,'2022-03-03 12:54:21','2022-03-03 12:54:21'),(64449,183,'Bhandari Anduruni','322238',1,0,'2022-03-03 12:54:21','2022-03-03 12:54:21'),(64450,183,'Bhankari','322249',1,0,'2022-03-03 12:54:21','2022-03-03 12:54:21'),(64451,183,'Bhartun','322255',1,0,'2022-03-03 12:54:21','2022-03-03 12:54:21'),(64452,183,'Bhawali','322242',1,0,'2022-03-03 12:54:21','2022-03-03 12:54:21'),(64453,183,'Bhilapada','322216',1,0,'2022-03-03 12:54:21','2022-03-03 12:54:21'),(64454,183,'Bhopar','322230',1,0,'2022-03-03 12:54:21','2022-03-03 12:54:21'),(64455,183,'Bhukrawali','322252',1,0,'2022-03-03 12:54:21','2022-03-03 12:54:21'),(64456,183,'Bijalpur','322255',1,0,'2022-03-03 12:54:22','2022-03-03 12:54:22'),(64457,183,'Bonl','321611',1,0,'2022-03-03 12:54:22','2022-03-03 12:54:22'),(64458,183,'Bugdar','322249',1,0,'2022-03-03 12:54:22','2022-03-03 12:54:22'),(64459,183,'Bukna','322218',1,0,'2022-03-03 12:54:22','2022-03-03 12:54:22'),(64460,183,'Chainpur','322241',1,0,'2022-03-03 12:54:22','2022-03-03 12:54:22'),(64461,183,'Chainpura','322213',1,0,'2022-03-03 12:54:22','2022-03-03 12:54:22'),(64462,183,'Chandangaon','322220',1,0,'2022-03-03 12:54:22','2022-03-03 12:54:22'),(64463,183,'Chandelipura','322251',1,0,'2022-03-03 12:54:22','2022-03-03 12:54:22'),(64464,183,'Chauragon','322203',1,0,'2022-03-03 12:54:22','2022-03-03 12:54:22'),(64465,183,'Chhabar','322242',1,0,'2022-03-03 12:54:22','2022-03-03 12:54:22'),(64466,183,'Chinayata PSSK','322236',1,0,'2022-03-03 12:54:22','2022-03-03 12:54:22'),(64467,183,'Chirawada','322212',1,0,'2022-03-03 12:54:22','2022-03-03 12:54:22'),(64468,183,'Court Karauli','322241',1,0,'2022-03-03 12:54:22','2022-03-03 12:54:22'),(64469,183,'Dabra','322255',1,0,'2022-03-03 12:54:22','2022-03-03 12:54:22'),(64470,183,'Dadanpur','321611',1,0,'2022-03-03 12:54:22','2022-03-03 12:54:22'),(64471,183,'Daharia','322215',1,0,'2022-03-03 12:54:22','2022-03-03 12:54:22'),(64472,183,'Dahra','322230',1,0,'2022-03-03 12:54:22','2022-03-03 12:54:22'),(64473,183,'Dalpura','322215',1,0,'2022-03-03 12:54:22','2022-03-03 12:54:22'),(64474,183,'Danalpur','322220',1,0,'2022-03-03 12:54:22','2022-03-03 12:54:22'),(64475,183,'Daulatpura','322218',1,0,'2022-03-03 12:54:22','2022-03-03 12:54:22'),(64476,183,'Devlane','322254',1,0,'2022-03-03 12:54:22','2022-03-03 12:54:22'),(64477,183,'Dhanda','322252',1,0,'2022-03-03 12:54:22','2022-03-03 12:54:22'),(64478,183,'Dhawan','322213',1,0,'2022-03-03 12:54:23','2022-03-03 12:54:23'),(64479,183,'Dhindora','322236',1,0,'2022-03-03 12:54:23','2022-03-03 12:54:23'),(64480,183,'Dholeta','322213',1,0,'2022-03-03 12:54:23','2022-03-03 12:54:23'),(64481,183,'Dhoreta','322251',1,0,'2022-03-03 12:54:23','2022-03-03 12:54:23'),(64482,183,'Dorawali','321611',1,0,'2022-03-03 12:54:23','2022-03-03 12:54:23'),(64483,183,'Dukawali','322236',1,0,'2022-03-03 12:54:23','2022-03-03 12:54:23'),(64484,183,'Eaket','322203',1,0,'2022-03-03 12:54:23','2022-03-03 12:54:23'),(64485,183,'Fatehpur','322033',1,0,'2022-03-03 12:54:23','2022-03-03 12:54:23'),(64486,183,'Fatehpur','322241',1,0,'2022-03-03 12:54:23','2022-03-03 12:54:23'),(64487,183,'Gadholi','322241',1,0,'2022-03-03 12:54:23','2022-03-03 12:54:23'),(64488,183,'Gairai','322255',1,0,'2022-03-03 12:54:23','2022-03-03 12:54:23'),(64489,183,'Garhkheda','322215',1,0,'2022-03-03 12:54:23','2022-03-03 12:54:23'),(64490,183,'Garhmoran','322212',1,0,'2022-03-03 12:54:23','2022-03-03 12:54:23'),(64491,183,'Gavda Meena','322234',1,0,'2022-03-03 12:54:23','2022-03-03 12:54:23'),(64492,183,'Ghatabalaji','321610',1,0,'2022-03-03 12:54:23','2022-03-03 12:54:23'),(64493,183,'Ghonsla','322254',1,0,'2022-03-03 12:54:23','2022-03-03 12:54:23'),(64494,183,'Gorda','321611',1,0,'2022-03-03 12:54:23','2022-03-03 12:54:23'),(64495,183,'Gothra','322218',1,0,'2022-03-03 12:54:23','2022-03-03 12:54:23'),(64496,183,'Gubreda','322242',1,0,'2022-03-03 12:54:23','2022-03-03 12:54:23'),(64497,183,'Gudhachandraji','322213',1,0,'2022-03-03 12:54:23','2022-03-03 12:54:23'),(64498,183,'Gudla','322241',1,0,'2022-03-03 12:54:23','2022-03-03 12:54:23'),(64499,183,'Gunesera','322241',1,0,'2022-03-03 12:54:23','2022-03-03 12:54:23'),(64500,183,'Gurda','322242',1,0,'2022-03-03 12:54:23','2022-03-03 12:54:23'),(64501,183,'Hadoti','322033',1,0,'2022-03-03 12:54:23','2022-03-03 12:54:23'),(64502,183,'Harnagar','322249',1,0,'2022-03-03 12:54:23','2022-03-03 12:54:23'),(64503,183,'Hindaun City','322230',1,0,'2022-03-03 12:54:23','2022-03-03 12:54:23'),(64504,183,'Hindaun H.O','322230',1,0,'2022-03-03 12:54:24','2022-03-03 12:54:24'),(64505,183,'Hindaun Mandi','322230',1,0,'2022-03-03 12:54:24','2022-03-03 12:54:24'),(64506,183,'Hukmikheda','322236',1,0,'2022-03-03 12:54:24','2022-03-03 12:54:24'),(64507,183,'Inayati','322218',1,0,'2022-03-03 12:54:24','2022-03-03 12:54:24'),(64508,183,'Irenia','322234',1,0,'2022-03-03 12:54:24','2022-03-03 12:54:24'),(64509,183,'Jagar','322236',1,0,'2022-03-03 12:54:24','2022-03-03 12:54:24'),(64510,183,'Jagdishpura','322254',1,0,'2022-03-03 12:54:24','2022-03-03 12:54:24'),(64511,183,'Jahangirpur','322255',1,0,'2022-03-03 12:54:24','2022-03-03 12:54:24'),(64512,183,'Jahira','322213',1,0,'2022-03-03 12:54:24','2022-03-03 12:54:24'),(64513,183,'Jakhoda','322218',1,0,'2022-03-03 12:54:24','2022-03-03 12:54:24'),(64514,183,'Jamura','322242',1,0,'2022-03-03 12:54:24','2022-03-03 12:54:24'),(64515,183,'Jatnagla','322236',1,0,'2022-03-03 12:54:24','2022-03-03 12:54:24'),(64516,183,'Jatwada','322252',1,0,'2022-03-03 12:54:24','2022-03-03 12:54:24'),(64517,183,'Jhadisa','321611',1,0,'2022-03-03 12:54:24','2022-03-03 12:54:24'),(64518,183,'Jhareda','322230',1,0,'2022-03-03 12:54:24','2022-03-03 12:54:24'),(64519,183,'Jirna','322215',1,0,'2022-03-03 12:54:24','2022-03-03 12:54:24'),(64520,183,'Jirota','322203',1,0,'2022-03-03 12:54:24','2022-03-03 12:54:24'),(64521,183,'Jitkipur','322215',1,0,'2022-03-03 12:54:24','2022-03-03 12:54:24'),(64522,183,'Jiwatkheda','322203',1,0,'2022-03-03 12:54:24','2022-03-03 12:54:24'),(64523,183,'Jodli','322203',1,0,'2022-03-03 12:54:24','2022-03-03 12:54:24'),(64524,183,'Jonl','321611',1,0,'2022-03-03 12:54:24','2022-03-03 12:54:24'),(64525,183,'Kachroda','322255',1,0,'2022-03-03 12:54:24','2022-03-03 12:54:24'),(64526,183,'Kailadevi','322243',1,0,'2022-03-03 12:54:24','2022-03-03 12:54:24'),(64527,183,'Kalyani','322243',1,0,'2022-03-03 12:54:24','2022-03-03 12:54:24'),(64528,183,'Kalyanpura','322218',1,0,'2022-03-03 12:54:24','2022-03-03 12:54:24'),(64529,183,'Kamalpura','322213',1,0,'2022-03-03 12:54:25','2022-03-03 12:54:25'),(64530,183,'Kanchanpura','322242',1,0,'2022-03-03 12:54:25','2022-03-03 12:54:25'),(64531,183,'Kanchroli','322230',1,0,'2022-03-03 12:54:25','2022-03-03 12:54:25'),(64532,183,'Kanjoli','322230',1,0,'2022-03-03 12:54:25','2022-03-03 12:54:25'),(64533,183,'Karanpur','322243',1,0,'2022-03-03 12:54:25','2022-03-03 12:54:25'),(64534,183,'Karauli','322241',1,0,'2022-03-03 12:54:25','2022-03-03 12:54:25'),(64535,183,'Kariri','321611',1,0,'2022-03-03 12:54:25','2022-03-03 12:54:25'),(64536,183,'Karsai','322243',1,0,'2022-03-03 12:54:25','2022-03-03 12:54:25'),(64537,183,'Karsoli','322230',1,0,'2022-03-03 12:54:25','2022-03-03 12:54:25'),(64538,183,'Kased','322251',1,0,'2022-03-03 12:54:25','2022-03-03 12:54:25'),(64539,183,'Kashipura','322255',1,0,'2022-03-03 12:54:25','2022-03-03 12:54:25'),(64540,183,'Katara Ajij','322230',1,0,'2022-03-03 12:54:25','2022-03-03 12:54:25'),(64541,183,'Katkad','322234',1,0,'2022-03-03 12:54:25','2022-03-03 12:54:25'),(64542,183,'Kema','322215',1,0,'2022-03-03 12:54:25','2022-03-03 12:54:25'),(64543,183,'Kemla','322220',1,0,'2022-03-03 12:54:25','2022-03-03 12:54:25'),(64544,183,'Kemri (Karauli)','322216',1,0,'2022-03-03 12:54:25','2022-03-03 12:54:25'),(64545,183,'Khareta','322230',1,0,'2022-03-03 12:54:25','2022-03-03 12:54:25'),(64546,183,'Kheda Malupada','322213',1,0,'2022-03-03 12:54:25','2022-03-03 12:54:25'),(64547,183,'Kheda','322234',1,0,'2022-03-03 12:54:25','2022-03-03 12:54:25'),(64548,183,'Khedi','321611',1,0,'2022-03-03 12:54:25','2022-03-03 12:54:25'),(64549,183,'Khedia','322242',1,0,'2022-03-03 12:54:25','2022-03-03 12:54:25'),(64550,183,'Khedihewat','322236',1,0,'2022-03-03 12:54:25','2022-03-03 12:54:25'),(64551,183,'Kherla','322202',1,0,'2022-03-03 12:54:25','2022-03-03 12:54:25'),(64552,183,'Kherli Gurjar','322254',1,0,'2022-03-03 12:54:25','2022-03-03 12:54:25'),(64553,183,'Khidarpur','322203',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64554,183,'Khohra','321611',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64555,183,'Khohri','322243',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64556,183,'Khoobnagar','322249',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64557,183,'Khudawal','322238',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64558,183,'Khunda','322242',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64559,183,'Kishorpura','322218',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64560,183,'Kondar','322241',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64561,183,'Kota','322243',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64562,183,'Kotri','322234',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64563,183,'Kunjela','322204',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64564,183,'Kurgaon','322255',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64565,183,'Kyarda Khurd','322230',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64566,183,'Lahchoda','322230',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64567,183,'Langra','322249',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64568,183,'Lapawali','322230',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64569,183,'Lawad','322204',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64570,183,'Ledia','322255',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64571,183,'Lohara','322243',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64572,183,'Luloj','322218',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64573,183,'Machadi','321611',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64574,183,'Maheswa','322220',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64575,183,'Maholi','322243',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64576,183,'Makanpur','322255',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64577,183,'Manchi','322241',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64578,183,'Mandakheda','322241',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64579,183,'Mandawara','322230',1,0,'2022-03-03 12:54:26','2022-03-03 12:54:26'),(64580,183,'Mandawra','322255',1,0,'2022-03-03 12:54:27','2022-03-03 12:54:27'),(64581,183,'Manderu','321611',1,0,'2022-03-03 12:54:27','2022-03-03 12:54:27'),(64582,183,'Mandrail','322251',1,0,'2022-03-03 12:54:27','2022-03-03 12:54:27'),(64583,183,'Mannauj','321611',1,0,'2022-03-03 12:54:27','2022-03-03 12:54:27'),(64584,183,'Marmada','322243',1,0,'2022-03-03 12:54:27','2022-03-03 12:54:27'),(64585,183,'Masalpur','322242',1,0,'2022-03-03 12:54:27','2022-03-03 12:54:27'),(64586,183,'Masawata','322203',1,0,'2022-03-03 12:54:27','2022-03-03 12:54:27'),(64587,183,'Matasula','321611',1,0,'2022-03-03 12:54:27','2022-03-03 12:54:27'),(64588,183,'Mehmedpur','322255',1,0,'2022-03-03 12:54:27','2022-03-03 12:54:27'),(64589,183,'Mirzapur','321611',1,0,'2022-03-03 12:54:27','2022-03-03 12:54:27'),(64590,183,'Mohammedpur','322254',1,0,'2022-03-03 12:54:27','2022-03-03 12:54:27'),(64591,183,'Mohanpura','322216',1,0,'2022-03-03 12:54:27','2022-03-03 12:54:27'),(64592,183,'Mongepura','322251',1,0,'2022-03-03 12:54:27','2022-03-03 12:54:27'),(64593,183,'Morda','322238',1,0,'2022-03-03 12:54:27','2022-03-03 12:54:27'),(64594,183,'Mundia','322254',1,0,'2022-03-03 12:54:27','2022-03-03 12:54:27'),(64595,183,'Muthiyapur','322234',1,0,'2022-03-03 12:54:27','2022-03-03 12:54:27'),(64596,183,'Nadoti','322215',1,0,'2022-03-03 12:54:27','2022-03-03 12:54:27'),(64597,183,'Nagala Meena','322230',1,0,'2022-03-03 12:54:27','2022-03-03 12:54:27'),(64598,183,'Nangal Lat','321611',1,0,'2022-03-03 12:54:27','2022-03-03 12:54:27'),(64599,183,'Nangal Pahadi','322238',1,0,'2022-03-03 12:54:27','2022-03-03 12:54:27'),(64600,183,'Nanpur','322243',1,0,'2022-03-03 12:54:27','2022-03-03 12:54:27'),(64601,183,'Narauli Dang','322203',1,0,'2022-03-03 12:54:27','2022-03-03 12:54:27'),(64602,183,'Narayana','322242',1,0,'2022-03-03 12:54:27','2022-03-03 12:54:27'),(64603,183,'Nibhera','322243',1,0,'2022-03-03 12:54:28','2022-03-03 12:54:28'),(64604,183,'Nimoda R S','322202',1,0,'2022-03-03 12:54:28','2022-03-03 12:54:28'),(64605,183,'Ninder','322251',1,0,'2022-03-03 12:54:28','2022-03-03 12:54:28'),(64606,183,'Nisura','322220',1,0,'2022-03-03 12:54:28','2022-03-03 12:54:28'),(64607,183,'Padampura','321611',1,0,'2022-03-03 12:54:28','2022-03-03 12:54:28'),(64608,183,'Pahadi','322238',1,0,'2022-03-03 12:54:28','2022-03-03 12:54:28'),(64609,183,'Pahadiyanagar','322220',1,0,'2022-03-03 12:54:28','2022-03-03 12:54:28'),(64610,183,'Pal','322213',1,0,'2022-03-03 12:54:28','2022-03-03 12:54:28'),(64611,183,'Palanpur','322234',1,0,'2022-03-03 12:54:28','2022-03-03 12:54:28'),(64612,183,'Pali','322236',1,0,'2022-03-03 12:54:28','2022-03-03 12:54:28'),(64613,183,'Pancholi','322251',1,0,'2022-03-03 12:54:28','2022-03-03 12:54:28'),(64614,183,'Parita','322219',1,0,'2022-03-03 12:54:28','2022-03-03 12:54:28'),(64615,183,'Parla Khalsa','321610',1,0,'2022-03-03 12:54:28','2022-03-03 12:54:28'),(64616,183,'Patoli','321610',1,0,'2022-03-03 12:54:28','2022-03-03 12:54:28'),(64617,183,'Phoota Kot Karauli','322241',1,0,'2022-03-03 12:54:28','2022-03-03 12:54:28'),(64618,183,'Phulwara','322230',1,0,'2022-03-03 12:54:28','2022-03-03 12:54:28'),(64619,183,'Pipalpura','322241',1,0,'2022-03-03 12:54:28','2022-03-03 12:54:28'),(64620,183,'Raghuvanshi','322241',1,0,'2022-03-03 12:54:28','2022-03-03 12:54:28'),(64621,183,'Rajaheda','322213',1,0,'2022-03-03 12:54:28','2022-03-03 12:54:28'),(64622,183,'Rajor','322243',1,0,'2022-03-03 12:54:28','2022-03-03 12:54:28'),(64623,183,'Rajpura','322213',1,0,'2022-03-03 12:54:28','2022-03-03 12:54:28'),(64624,183,'Rampur Dhabai','322243',1,0,'2022-03-03 12:54:28','2022-03-03 12:54:28'),(64625,183,'Ramthara','322218',1,0,'2022-03-03 12:54:28','2022-03-03 12:54:28'),(64626,183,'Ranipura','322251',1,0,'2022-03-03 12:54:28','2022-03-03 12:54:28'),(64627,183,'Ranoli','322220',1,0,'2022-03-03 12:54:28','2022-03-03 12:54:28'),(64628,183,'Ratiyapura','322242',1,0,'2022-03-03 12:54:29','2022-03-03 12:54:29'),(64629,183,'Raysana','322215',1,0,'2022-03-03 12:54:29','2022-03-03 12:54:29'),(64630,183,'Rodhai','322251',1,0,'2022-03-03 12:54:29','2022-03-03 12:54:29'),(64631,183,'Rondkala','322241',1,0,'2022-03-03 12:54:29','2022-03-03 12:54:29'),(64632,183,'Ronsi','322220',1,0,'2022-03-03 12:54:29','2022-03-03 12:54:29'),(64633,183,'Rundh Ka Pura','322242',1,0,'2022-03-03 12:54:29','2022-03-03 12:54:29'),(64634,183,'Saingarpura','322219',1,0,'2022-03-03 12:54:29','2022-03-03 12:54:29'),(64635,183,'Saiypur','322241',1,0,'2022-03-03 12:54:29','2022-03-03 12:54:29'),(64636,183,'Salavad','322215',1,0,'2022-03-03 12:54:29','2022-03-03 12:54:29'),(64637,183,'Salempur','322230',1,0,'2022-03-03 12:54:29','2022-03-03 12:54:29'),(64638,183,'Samerda','322255',1,0,'2022-03-03 12:54:29','2022-03-03 12:54:29'),(64639,183,'Sanet','322234',1,0,'2022-03-03 12:54:29','2022-03-03 12:54:29'),(64640,183,'Sankarwada','321610',1,0,'2022-03-03 12:54:29','2022-03-03 12:54:29'),(64641,183,'Sapotara','322218',1,0,'2022-03-03 12:54:29','2022-03-03 12:54:29'),(64642,183,'Sasedi','322249',1,0,'2022-03-03 12:54:29','2022-03-03 12:54:29'),(64643,183,'Shahar','322204',1,0,'2022-03-03 12:54:29','2022-03-03 12:54:29'),(64644,183,'Shahrakhar','321611',1,0,'2022-03-03 12:54:29','2022-03-03 12:54:29'),(64645,183,'Shaikhpura','322255',1,0,'2022-03-03 12:54:29','2022-03-03 12:54:29'),(64646,183,'Shantiveer Nagar','322220',1,0,'2022-03-03 12:54:29','2022-03-03 12:54:29'),(64647,183,'Shekhpura','322220',1,0,'2022-03-03 12:54:29','2022-03-03 12:54:29'),(64648,183,'Sherpur','322236',1,0,'2022-03-03 12:54:29','2022-03-03 12:54:29'),(64649,183,'Shri Mahaveerji R S','322234',1,0,'2022-03-03 12:54:29','2022-03-03 12:54:29'),(64650,183,'Shrimahaveerji','322220',1,0,'2022-03-03 12:54:29','2022-03-03 12:54:29'),(64651,183,'Sikroda Meena','322230',1,0,'2022-03-03 12:54:29','2022-03-03 12:54:29'),(64652,183,'Siloti','322242',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64653,183,'Singhania','322230',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64654,183,'Somla','322252',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64655,183,'Sop','322204',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64656,183,'Station Road Hindaun','322230',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64657,183,'Sunderpura','322241',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64658,183,'Suroth','322252',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64659,183,'Talawada','322213',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64660,183,'Tali','322252',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64661,183,'Tesgaon','322216',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64662,183,'Thigharia','322254',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64663,183,'Timawa','322213',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64664,183,'Toda','322243',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64665,183,'Todabhim','321611',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64666,183,'Todupura','322234',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64667,183,'Tulsipura','322241',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64668,183,'Urden','322238',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64669,183,'Vajeda','322234',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64670,183,'Vajna Kalan','322230',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64671,183,'Vapoti','322218',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64672,183,'Vijaypura','322236',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64673,184,'Aamli','325001',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64674,184,'Aditya Nagar','326520',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64675,184,'Alod','326518',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64676,184,'Amarpura','325204',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64677,184,'Anwan','325602',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64678,184,'Aralia Jagir','325001',1,0,'2022-03-03 12:54:30','2022-03-03 12:54:30'),(64679,184,'Arand Kheda','325001',1,0,'2022-03-03 12:54:31','2022-03-03 12:54:31'),(64680,184,'Arjunpura','324002',1,0,'2022-03-03 12:54:31','2022-03-03 12:54:31'),(64681,184,'Ayana','325214',1,0,'2022-03-03 12:54:31','2022-03-03 12:54:31'),(64682,184,'Ayani','325214',1,0,'2022-03-03 12:54:31','2022-03-03 12:54:31'),(64683,184,'Bagli','325009',1,0,'2022-03-03 12:54:31','2022-03-03 12:54:31'),(64684,184,'Baluheda','325602',1,0,'2022-03-03 12:54:31','2022-03-03 12:54:31'),(64685,184,'Balupa','325009',1,0,'2022-03-03 12:54:31','2022-03-03 12:54:31'),(64686,184,'Bambolia Kalan','325004',1,0,'2022-03-03 12:54:31','2022-03-03 12:54:31'),(64687,184,'Bambori','325208',1,0,'2022-03-03 12:54:31','2022-03-03 12:54:31'),(64688,184,'Banethia','325204',1,0,'2022-03-03 12:54:31','2022-03-03 12:54:31'),(64689,184,'Baniani','325001',1,0,'2022-03-03 12:54:31','2022-03-03 12:54:31'),(64690,184,'Bansya hedi','325602',1,0,'2022-03-03 12:54:31','2022-03-03 12:54:31'),(64691,184,'Bapawar','325207',1,0,'2022-03-03 12:54:31','2022-03-03 12:54:31'),(64692,184,'Barod','325204',1,0,'2022-03-03 12:54:31','2022-03-03 12:54:31'),(64693,184,'Barodia Kalan','326520',1,0,'2022-03-03 12:54:31','2022-03-03 12:54:31'),(64694,184,'Bhanda Heda','325203',1,0,'2022-03-03 12:54:31','2022-03-03 12:54:31'),(64695,184,'Bhanwaria','325003',1,0,'2022-03-03 12:54:31','2022-03-03 12:54:31'),(64696,184,'Bhaura','325208',1,0,'2022-03-03 12:54:31','2022-03-03 12:54:31'),(64697,184,'Binayaka','325004',1,0,'2022-03-03 12:54:31','2022-03-03 12:54:31'),(64698,184,'Borabas','324001',1,0,'2022-03-03 12:54:31','2022-03-03 12:54:31'),(64699,184,'Borda','325009',1,0,'2022-03-03 12:54:31','2022-03-03 12:54:31'),(64700,184,'Borina Kalan','325601',1,0,'2022-03-03 12:54:31','2022-03-03 12:54:31'),(64701,184,'Borkheda','324001',1,0,'2022-03-03 12:54:31','2022-03-03 12:54:31'),(64702,184,'Budh Khan','326520',1,0,'2022-03-03 12:54:31','2022-03-03 12:54:31'),(64703,184,'Budha Deet','325204',1,0,'2022-03-03 12:54:31','2022-03-03 12:54:31'),(64704,184,'Cable Nagar','325003',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64705,184,'Chechat','326518',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64706,184,'Chhapol','325009',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64707,184,'Chhawni Ram Chandra Pura','324007',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64708,184,'Choma Malian','325203',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64709,184,'Dadabari Kota','324009',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64710,184,'Darrah','325602',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64711,184,'Deoli','326518',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64712,184,'Deoli','325001',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64713,184,'Deoli Khurd','326519',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64714,184,'Dhaba','325203',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64715,184,'Dhakadkhedi','325001',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64716,184,'Dhani Kasar','325003',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64717,184,'Dhanwa','325204',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64718,184,'Dhipari','325009',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64719,184,'Dhoti','325001',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64720,184,'Dhulet','325602',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64721,184,'Digod','325601',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64722,184,'Digod','325201',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64723,184,'Dolya','324001',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64724,184,'Dungarja','325201',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64725,184,'Durjanpura','325214',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64726,184,'Engineering College Kota','324010',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64727,184,'Gadepan','325208',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64728,184,'Gainta','325004',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64729,184,'Gandiphali','325001',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64730,184,'Ganeshganj','325004',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64731,184,'Ghatoli','326518',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64732,184,'Girdharpura','324008',1,0,'2022-03-03 12:54:32','2022-03-03 12:54:32'),(64733,184,'Golana','325001',1,0,'2022-03-03 12:54:33','2022-03-03 12:54:33'),(64734,184,'Golya Hedi','325203',1,0,'2022-03-03 12:54:33','2022-03-03 12:54:33'),(64735,184,'Gopalpura','325003',1,0,'2022-03-03 12:54:33','2022-03-03 12:54:33'),(64736,184,'Goyanda','326529',1,0,'2022-03-03 12:54:33','2022-03-03 12:54:33'),(64737,184,'Gumanpura Kota','324007',1,0,'2022-03-03 12:54:33','2022-03-03 12:54:33'),(64738,184,'Haripura','325203',1,0,'2022-03-03 12:54:33','2022-03-03 12:54:33'),(64739,184,'Hatiya Kheri','326518',1,0,'2022-03-03 12:54:33','2022-03-03 12:54:33'),(64740,184,'Hingi','325601',1,0,'2022-03-03 12:54:33','2022-03-03 12:54:33'),(64741,184,'Hingonia','325602',1,0,'2022-03-03 12:54:33','2022-03-03 12:54:33'),(64742,184,'Industerial Estate Kota','324003',1,0,'2022-03-03 12:54:33','2022-03-03 12:54:33'),(64743,184,'Itawa','325004',1,0,'2022-03-03 12:54:33','2022-03-03 12:54:33'),(64744,184,'Jakhora','325001',1,0,'2022-03-03 12:54:33','2022-03-03 12:54:33'),(64745,184,'Jaloda Khatian','325214',1,0,'2022-03-03 12:54:33','2022-03-03 12:54:33'),(64746,184,'Jatwada','325009',1,0,'2022-03-03 12:54:33','2022-03-03 12:54:33'),(64747,184,'Jhargaon','325204',1,0,'2022-03-03 12:54:33','2022-03-03 12:54:33'),(64748,184,'Jorawarpura','325009',1,0,'2022-03-03 12:54:33','2022-03-03 12:54:33'),(64749,184,'Julmi','326519',1,0,'2022-03-03 12:54:33','2022-03-03 12:54:33'),(64750,184,'Kaithun','325001',1,0,'2022-03-03 12:54:33','2022-03-03 12:54:33'),(64751,184,'Kaithuni Pole Kota','324006',1,0,'2022-03-03 12:54:33','2022-03-03 12:54:33'),(64752,184,'Kakrawada','325009',1,0,'2022-03-03 12:54:33','2022-03-03 12:54:33'),(64753,184,'Kamalpura','326517',1,0,'2022-03-03 12:54:33','2022-03-03 12:54:33'),(64754,184,'Kamolar','325601',1,0,'2022-03-03 12:54:33','2022-03-03 12:54:33'),(64755,184,'Kanwas','325602',1,0,'2022-03-03 12:54:33','2022-03-03 12:54:33'),(64756,184,'Karwad','325004',1,0,'2022-03-03 12:54:33','2022-03-03 12:54:33'),(64757,184,'Khairabad (Kota)','326529',1,0,'2022-03-03 12:54:33','2022-03-03 12:54:33'),(64758,184,'Khajuri','325001',1,0,'2022-03-03 12:54:34','2022-03-03 12:54:34'),(64759,184,'Khajurna.','325001',1,0,'2022-03-03 12:54:34','2022-03-03 12:54:34'),(64760,184,'Khandgaon','325001',1,0,'2022-03-03 12:54:34','2022-03-03 12:54:34'),(64761,184,'Kharula','325204',1,0,'2022-03-03 12:54:34','2022-03-03 12:54:34'),(64762,184,'Khatoli','325009',1,0,'2022-03-03 12:54:34','2022-03-03 12:54:34'),(64763,184,'Khedia','325207',1,0,'2022-03-03 12:54:34','2022-03-03 12:54:34'),(64764,184,'Kheemuch','326517',1,0,'2022-03-03 12:54:34','2022-03-03 12:54:34'),(64765,184,'Kherdarasoolpur','325001',1,0,'2022-03-03 12:54:34','2022-03-03 12:54:34'),(64766,184,'Kherli','326518',1,0,'2022-03-03 12:54:34','2022-03-03 12:54:34'),(64767,184,'Kherli Tanwaran','325204',1,0,'2022-03-03 12:54:34','2022-03-03 12:54:34'),(64768,184,'Khurad','325001',1,0,'2022-03-03 12:54:34','2022-03-03 12:54:34'),(64769,184,'Khyawada','325004',1,0,'2022-03-03 12:54:34','2022-03-03 12:54:34'),(64770,184,'Kishan Pura Takiya','324002',1,0,'2022-03-03 12:54:34','2022-03-03 12:54:34'),(64771,184,'Kishanpura','325601',1,0,'2022-03-03 12:54:34','2022-03-03 12:54:34'),(64772,184,'Kishorepura','325204',1,0,'2022-03-03 12:54:34','2022-03-03 12:54:34'),(64773,184,'Kota City','324006',1,0,'2022-03-03 12:54:34','2022-03-03 12:54:34'),(64774,184,'Kota H.O','324001',1,0,'2022-03-03 12:54:34','2022-03-03 12:54:34'),(64775,184,'Kota Jn.','324002',1,0,'2022-03-03 12:54:34','2022-03-03 12:54:34'),(64776,184,'Kota Kutchery','324001',1,0,'2022-03-03 12:54:34','2022-03-03 12:54:34'),(64777,184,'Kotradeep Singh','325204',1,0,'2022-03-03 12:54:34','2022-03-03 12:54:34'),(64778,184,'Kotsuan','325201',1,0,'2022-03-03 12:54:34','2022-03-03 12:54:34'),(64779,184,'Kudaila','326519',1,0,'2022-03-03 12:54:34','2022-03-03 12:54:34'),(64780,184,'Kukra Khurd','326517',1,0,'2022-03-03 12:54:34','2022-03-03 12:54:34'),(64781,184,'Kumbhkot','326519',1,0,'2022-03-03 12:54:34','2022-03-03 12:54:34'),(64782,184,'Kundanpur','325601',1,0,'2022-03-03 12:54:34','2022-03-03 12:54:34'),(64783,184,'Kuradia','325601',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64784,184,'Labaniya','325207',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64785,184,'Lakh Sanija','325204',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64786,184,'Laturi','325207',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64787,184,'Laxmi Pura','325214',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64788,184,'Luhawad','325214',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64789,184,'Mahaveer Nagar Kota','324005',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64790,184,'Mamore','325602',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64791,184,'Manasgaon','325201',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64792,184,'Mandana','325003',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64793,184,'Mandanpura','325204',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64794,184,'Mandap','325601',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64795,184,'Mandawara','325204',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64796,184,'Mandeeta','325202',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64797,184,'Mandlya','325003',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64798,184,'Mawasa','325001',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64799,184,'Miyana','325009',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64800,184,'Moi Kalan','325207',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64801,184,'Morak Gaon','326520',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64802,184,'Morpa','325204',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64803,184,'Nanta','324008',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64804,184,'Nautara','325204',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64805,184,'Naya Nohra','324001',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64806,184,'Nayapura Kota','324001',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64807,184,'New Grain Mandi Kota H.O','324007',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64808,184,'New Railway Colony Kota','324002',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64809,184,'Nimoda','325201',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64810,184,'Nimola','325009',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64811,184,'Nonera','325004',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64812,184,'P.I.P. Kota','324005',1,0,'2022-03-03 12:54:35','2022-03-03 12:54:35'),(64813,184,'Parlia','325201',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64814,184,'Pipa Khedi','326519',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64815,184,'Piplda','325004',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64816,184,'Polai Kalan','325203',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64817,184,'Pushod','325004',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64818,184,'Rajopa','325004',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64819,184,'Ram Ganj Mandi','326519',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64820,184,'Ranodia','325004',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64821,184,'Ranpur','325003',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64822,184,'Rel','325203',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64823,184,'Richhadia','326529',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64824,184,'Rolana','325601',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64825,184,'Ruddha Kheda','326518',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64826,184,'Salawad Khurd','326530',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64827,184,'Sangod','325601',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64828,184,'Sarota','325208',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64829,184,'Satal Khedi','326519',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64830,184,'Sawan Bhadon','325602',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64831,184,'Shahnawda','325004',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64832,184,'Shyampura','325601',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64833,184,'Simlia','325203',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64834,184,'Small Industrial Area Kota','324007',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64835,184,'Sogaria','324002',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64836,184,'Subhash Marg Kota','324001',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64837,184,'Subzi Mandi Kota','324006',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64838,184,'Suhana','325203',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64839,184,'Suket','326530',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64840,184,'Sultanpur (Kota)','325204',1,0,'2022-03-03 12:54:36','2022-03-03 12:54:36'),(64841,184,'Takarwada','325204',1,0,'2022-03-03 12:54:37','2022-03-03 12:54:37'),(64842,184,'Talab','325009',1,0,'2022-03-03 12:54:37','2022-03-03 12:54:37'),(64843,184,'Talwandi Kota','324005',1,0,'2022-03-03 12:54:37','2022-03-03 12:54:37'),(64844,184,'Tathed','325201',1,0,'2022-03-03 12:54:37','2022-03-03 12:54:37'),(64845,184,'Thermal Colony Kota','324008',1,0,'2022-03-03 12:54:37','2022-03-03 12:54:37'),(64846,184,'Toran','325204',1,0,'2022-03-03 12:54:37','2022-03-03 12:54:37'),(64847,184,'Udyog Puri Kota','324004',1,0,'2022-03-03 12:54:37','2022-03-03 12:54:37'),(64848,184,'Ukalda','325203',1,0,'2022-03-03 12:54:37','2022-03-03 12:54:37'),(64849,184,'Ummedpura','325204',1,0,'2022-03-03 12:54:37','2022-03-03 12:54:37'),(64850,184,'Ummedpura','325003',1,0,'2022-03-03 12:54:37','2022-03-03 12:54:37'),(64851,184,'Undwa','326519',1,0,'2022-03-03 12:54:37','2022-03-03 12:54:37'),(64852,184,'Vigyan Nagar Kota','324005',1,0,'2022-03-03 12:54:37','2022-03-03 12:54:37'),(64853,184,'Vinod Khurd','325601',1,0,'2022-03-03 12:54:37','2022-03-03 12:54:37'),(64854,184,'Wagon Repair Colony Kota','324002',1,0,'2022-03-03 12:54:37','2022-03-03 12:54:37'),(64855,185,'Achina','341025',1,0,'2022-03-03 12:54:37','2022-03-03 12:54:37'),(64856,185,'Agoonta','341305',1,0,'2022-03-03 12:54:37','2022-03-03 12:54:37'),(64857,185,'Ajawa','341303',1,0,'2022-03-03 12:54:37','2022-03-03 12:54:37'),(64858,185,'Akala Hamiran','341025',1,0,'2022-03-03 12:54:37','2022-03-03 12:54:37'),(64859,185,'Akeli \'a\'','341510',1,0,'2022-03-03 12:54:37','2022-03-03 12:54:37'),(64860,185,'Akeli \'b\'','341024',1,0,'2022-03-03 12:54:37','2022-03-03 12:54:37'),(64861,185,'Akoda','341506',1,0,'2022-03-03 12:54:37','2022-03-03 12:54:37'),(64862,185,'Akora','341022',1,0,'2022-03-03 12:54:37','2022-03-03 12:54:37'),(64863,185,'Alai','341001',1,0,'2022-03-03 12:54:37','2022-03-03 12:54:37'),(64864,185,'Alaniyawas','341513',1,0,'2022-03-03 12:54:37','2022-03-03 12:54:37'),(64865,185,'Alatawa','341504',1,0,'2022-03-03 12:54:38','2022-03-03 12:54:38'),(64866,185,'Ambapa','341303',1,0,'2022-03-03 12:54:38','2022-03-03 12:54:38'),(64867,185,'Anandpura','341508',1,0,'2022-03-03 12:54:38','2022-03-03 12:54:38'),(64868,185,'Antroli Khurd','341514',1,0,'2022-03-03 12:54:38','2022-03-03 12:54:38'),(64869,185,'Anwaliyasar','341001',1,0,'2022-03-03 12:54:38','2022-03-03 12:54:38'),(64870,185,'Araksar','341519',1,0,'2022-03-03 12:54:38','2022-03-03 12:54:38'),(64871,185,'Arniyala','341510',1,0,'2022-03-03 12:54:38','2022-03-03 12:54:38'),(64872,185,'Arwar','341024',1,0,'2022-03-03 12:54:38','2022-03-03 12:54:38'),(64873,185,'Asarwa','341319',1,0,'2022-03-03 12:54:38','2022-03-03 12:54:38'),(64874,185,'Asawari','342902',1,0,'2022-03-03 12:54:38','2022-03-03 12:54:38'),(64875,185,'Asotapura','341306',1,0,'2022-03-03 12:54:38','2022-03-03 12:54:38'),(64876,185,'Bachhwari','341024',1,0,'2022-03-03 12:54:38','2022-03-03 12:54:38'),(64877,185,'Badabara','341302',1,0,'2022-03-03 12:54:38','2022-03-03 12:54:38'),(64878,185,'Badayali','341518',1,0,'2022-03-03 12:54:38','2022-03-03 12:54:38'),(64879,185,'Badighati','341031',1,0,'2022-03-03 12:54:38','2022-03-03 12:54:38'),(64880,185,'Badu (Nagaur)','341501',1,0,'2022-03-03 12:54:38','2022-03-03 12:54:38'),(64881,185,'Baggar','341510',1,0,'2022-03-03 12:54:38','2022-03-03 12:54:38'),(64882,185,'Bagot','341512',1,0,'2022-03-03 12:54:38','2022-03-03 12:54:38'),(64883,185,'Bairathal','341025',1,0,'2022-03-03 12:54:38','2022-03-03 12:54:38'),(64884,185,'Bajoli','341503',1,0,'2022-03-03 12:54:38','2022-03-03 12:54:38'),(64885,185,'Bajwas','341503',1,0,'2022-03-03 12:54:38','2022-03-03 12:54:38'),(64886,185,'Bakalia','341306',1,0,'2022-03-03 12:54:38','2022-03-03 12:54:38'),(64887,185,'Balaya','341001',1,0,'2022-03-03 12:54:38','2022-03-03 12:54:38'),(64888,185,'Baldu','341316',1,0,'2022-03-03 12:54:38','2022-03-03 12:54:38'),(64889,185,'Balsamand','341304',1,0,'2022-03-03 12:54:38','2022-03-03 12:54:38'),(64890,185,'Bamana','341503',1,0,'2022-03-03 12:54:38','2022-03-03 12:54:38'),(64891,185,'Bansa','341506',1,0,'2022-03-03 12:54:39','2022-03-03 12:54:39'),(64892,185,'Bansed','341512',1,0,'2022-03-03 12:54:39','2022-03-03 12:54:39'),(64893,185,'Bansiwala Temple','341001',1,0,'2022-03-03 12:54:39','2022-03-03 12:54:39'),(64894,185,'Banthri','341305',1,0,'2022-03-03 12:54:39','2022-03-03 12:54:39'),(64895,185,'Banwal','341512',1,0,'2022-03-03 12:54:39','2022-03-03 12:54:39'),(64896,185,'Banwaligudha','341533',1,0,'2022-03-03 12:54:39','2022-03-03 12:54:39'),(64897,185,'Banwarala','341514',1,0,'2022-03-03 12:54:39','2022-03-03 12:54:39'),(64898,185,'Barana','341503',1,0,'2022-03-03 12:54:39','2022-03-03 12:54:39'),(64899,185,'Barangana','341303',1,0,'2022-03-03 12:54:39','2022-03-03 12:54:39'),(64900,185,'Barangaon','341021',1,0,'2022-03-03 12:54:39','2022-03-03 12:54:39'),(64901,185,'Bardawa','341551',1,0,'2022-03-03 12:54:39','2022-03-03 12:54:39'),(64902,185,'Bargaon','341510',1,0,'2022-03-03 12:54:39','2022-03-03 12:54:39'),(64903,185,'Bari Khatu','341301',1,0,'2022-03-03 12:54:39','2022-03-03 12:54:39'),(64904,185,'Barichhapri','341303',1,0,'2022-03-03 12:54:39','2022-03-03 12:54:39'),(64905,185,'Barikallan','341551',1,0,'2022-03-03 12:54:39','2022-03-03 12:54:39'),(64906,185,'Barnel','341023',1,0,'2022-03-03 12:54:39','2022-03-03 12:54:39'),(64907,185,'Barnel','341504',1,0,'2022-03-03 12:54:39','2022-03-03 12:54:39'),(64908,185,'Barwala','341505',1,0,'2022-03-03 12:54:39','2022-03-03 12:54:39'),(64909,185,'Barwali','341505',1,0,'2022-03-03 12:54:39','2022-03-03 12:54:39'),(64910,185,'Basni','341021',1,0,'2022-03-03 12:54:39','2022-03-03 12:54:39'),(64911,185,'Basni Sejan','342902',1,0,'2022-03-03 12:54:39','2022-03-03 12:54:39'),(64912,185,'Bassi','341512',1,0,'2022-03-03 12:54:40','2022-03-03 12:54:40'),(64913,185,'Beetan','341510',1,0,'2022-03-03 12:54:40','2022-03-03 12:54:40'),(64914,185,'Begsar','341506',1,0,'2022-03-03 12:54:40','2022-03-03 12:54:40'),(64915,185,'Berichhoti','341551',1,0,'2022-03-03 12:54:40','2022-03-03 12:54:40'),(64916,185,'Berwa','341506',1,0,'2022-03-03 12:54:40','2022-03-03 12:54:40'),(64917,185,'Besroli','341520',1,0,'2022-03-03 12:54:40','2022-03-03 12:54:40'),(64918,185,'Bhadana','341026',1,0,'2022-03-03 12:54:40','2022-03-03 12:54:40'),(64919,185,'Bhadana','341001',1,0,'2022-03-03 12:54:40','2022-03-03 12:54:40'),(64920,185,'Bhadasar','341516',1,0,'2022-03-03 12:54:40','2022-03-03 12:54:40'),(64921,185,'Bhadasiya','341512',1,0,'2022-03-03 12:54:40','2022-03-03 12:54:40'),(64922,185,'Bhadawa','341501',1,0,'2022-03-03 12:54:40','2022-03-03 12:54:40'),(64923,185,'Bhadlia','341517',1,0,'2022-03-03 12:54:40','2022-03-03 12:54:40'),(64924,185,'Bhadora','341028',1,0,'2022-03-03 12:54:40','2022-03-03 12:54:40'),(64925,185,'Bhadwasi','341001',1,0,'2022-03-03 12:54:40','2022-03-03 12:54:40'),(64926,185,'Bhagwanpura','341509',1,0,'2022-03-03 12:54:40','2022-03-03 12:54:40'),(64927,185,'Bhakhari','341512',1,0,'2022-03-03 12:54:40','2022-03-03 12:54:40'),(64928,185,'Bhakrod','341001',1,0,'2022-03-03 12:54:40','2022-03-03 12:54:40'),(64929,185,'Bhanwal','341518',1,0,'2022-03-03 12:54:40','2022-03-03 12:54:40'),(64930,185,'Bhanwanda','341025',1,0,'2022-03-03 12:54:40','2022-03-03 12:54:40'),(64931,185,'Bhanwata','341508',1,0,'2022-03-03 12:54:40','2022-03-03 12:54:40'),(64932,185,'Bhaola','341024',1,0,'2022-03-03 12:54:40','2022-03-03 12:54:40'),(64933,185,'Bharnai','341505',1,0,'2022-03-03 12:54:40','2022-03-03 12:54:40'),(64934,185,'Bharnawa','341316',1,0,'2022-03-03 12:54:40','2022-03-03 12:54:40'),(64935,185,'Bhatnokha','341028',1,0,'2022-03-03 12:54:40','2022-03-03 12:54:40'),(64936,185,'Bher','341001',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64937,185,'Bherunda','341031',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64938,185,'Bhikarniyakallan','341031',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64939,185,'Bhinchawa','341502',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64940,185,'Bhinchawa','341302',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64941,185,'Bhiyankallan','341504',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64942,185,'Bhooni','341508',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64943,185,'Bhundel','341001',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64944,185,'Bhuriyasani','341510',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64945,185,'Bidiad','341542',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64946,185,'Bijathal','341513',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64947,185,'Billoo','341542',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64948,185,'Binthwaliya','341503',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64949,185,'Birloka','341025',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64950,185,'Boodhi','341021',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64951,185,'Borawar','341502',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64952,185,'Borwa','341024',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64953,185,'Bugarda','341027',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64954,185,'Burdi','341022',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64955,185,'Bursu','341505',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64956,185,'Butati','341514',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64957,185,'Chandaroon','341503',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64958,185,'Chandi','341319',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64959,185,'Chandrai','341316',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64960,185,'Charanwas','341508',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64961,185,'Chau','341001',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64962,185,'Chawandia','341516',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64963,185,'Chawandiya','341001',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64964,185,'Chawandiyakallan','341510',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64965,185,'Chenar','341001',1,0,'2022-03-03 12:54:41','2022-03-03 12:54:41'),(64966,185,'Chhajoli','341023',1,0,'2022-03-03 12:54:42','2022-03-03 12:54:42'),(64967,185,'Chhapara','341303',1,0,'2022-03-03 12:54:42','2022-03-03 12:54:42'),(64968,185,'Chhapara','341022',1,0,'2022-03-03 12:54:42','2022-03-03 12:54:42'),(64969,185,'Chhapri','341511',1,0,'2022-03-03 12:54:42','2022-03-03 12:54:42'),(64970,185,'Chhawata Khurd','341024',1,0,'2022-03-03 12:54:42','2022-03-03 12:54:42'),(64971,185,'Chholukhan','341303',1,0,'2022-03-03 12:54:42','2022-03-03 12:54:42'),(64972,185,'Chhotichhapri','341303',1,0,'2022-03-03 12:54:42','2022-03-03 12:54:42'),(64973,185,'Chhotikhatu','341302',1,0,'2022-03-03 12:54:42','2022-03-03 12:54:42'),(64974,185,'Chiloo','341029',1,0,'2022-03-03 12:54:42','2022-03-03 12:54:42'),(64975,185,'Chindaliya','341319',1,0,'2022-03-03 12:54:42','2022-03-03 12:54:42'),(64976,185,'Chitai','341512',1,0,'2022-03-03 12:54:42','2022-03-03 12:54:42'),(64977,185,'Chitawa','341519',1,0,'2022-03-03 12:54:42','2022-03-03 12:54:42'),(64978,185,'Choliyas','341514',1,0,'2022-03-03 12:54:42','2022-03-03 12:54:42'),(64979,185,'Chosala','341509',1,0,'2022-03-03 12:54:42','2022-03-03 12:54:42'),(64980,185,'Chosali','341503',1,0,'2022-03-03 12:54:42','2022-03-03 12:54:42'),(64981,185,'Chundiya','341510',1,0,'2022-03-03 12:54:42','2022-03-03 12:54:42'),(64982,185,'Chuntisara','341001',1,0,'2022-03-03 12:54:42','2022-03-03 12:54:42'),(64983,185,'Chuwa','341301',1,0,'2022-03-03 12:54:42','2022-03-03 12:54:42'),(64984,185,'D.M.Didwana','341303',1,0,'2022-03-03 12:54:42','2022-03-03 12:54:42'),(64985,185,'Dabara','341506',1,0,'2022-03-03 12:54:42','2022-03-03 12:54:42'),(64986,185,'Dabari','341304',1,0,'2022-03-03 12:54:42','2022-03-03 12:54:42'),(64987,185,'Dabariya','341502',1,0,'2022-03-03 12:54:42','2022-03-03 12:54:42'),(64988,185,'Dalelpura','341508',1,0,'2022-03-03 12:54:42','2022-03-03 12:54:42'),(64989,185,'Damboi Khurd','341504',1,0,'2022-03-03 12:54:42','2022-03-03 12:54:42'),(64990,185,'Dangawas','341510',1,0,'2022-03-03 12:54:42','2022-03-03 12:54:42'),(64991,185,'Daru','341001',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(64992,185,'Datani','341511',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(64993,185,'Datina','341001',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(64994,185,'Daudsar','341516',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(64995,185,'Daulatpura','341303',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(64996,185,'Daulatpura','341519',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(64997,185,'Dayalpura','341303',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(64998,185,'Degana','341503',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(64999,185,'Degana Village','341503',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(65000,185,'Deh','341022',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(65001,185,'Dehari','341030',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(65002,185,'Deolikallan','341507',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(65003,185,'Deu','341001',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(65004,185,'Dhadhariyakallan','341028',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(65005,185,'Dhadhota','341512',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(65006,185,'Dhadhwara','341511',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(65007,185,'Dhananwa','341319',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(65008,185,'Dhanapa','342902',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(65009,185,'Dhandhalas','341510',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(65010,185,'Dhandholi','341520',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(65011,185,'Dhaneriya','341510',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(65012,185,'Dhanipura','341031',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(65013,185,'Dhankoli','341516',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(65014,185,'Dhawa','341511',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(65015,185,'Dhingasari','341317',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(65016,185,'Dholia','341304',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(65017,185,'Dhurila','341317',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(65018,185,'Dhyawa','341303',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(65019,185,'Didiyakallan','341027',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(65020,185,'Didwana H.O','341303',1,0,'2022-03-03 12:54:43','2022-03-03 12:54:43'),(65021,185,'Dikawa','341506',1,0,'2022-03-03 12:54:44','2022-03-03 12:54:44'),(65022,185,'Dildhani','341505',1,0,'2022-03-03 12:54:44','2022-03-03 12:54:44'),(65023,185,'Dindarpura','341551',1,0,'2022-03-03 12:54:44','2022-03-03 12:54:44'),(65024,185,'Diyawari','342902',1,0,'2022-03-03 12:54:44','2022-03-03 12:54:44'),(65025,185,'Dobarikallan','341504',1,0,'2022-03-03 12:54:44','2022-03-03 12:54:44'),(65026,185,'Dobariya','341504',1,0,'2022-03-03 12:54:44','2022-03-03 12:54:44'),(65027,185,'Dodiyana','341031',1,0,'2022-03-03 12:54:44','2022-03-03 12:54:44'),(65028,185,'Dotina','341503',1,0,'2022-03-03 12:54:44','2022-03-03 12:54:44'),(65029,185,'Dudoli','341316',1,0,'2022-03-03 12:54:44','2022-03-03 12:54:44'),(65030,185,'Dugastau','341023',1,0,'2022-03-03 12:54:44','2022-03-03 12:54:44'),(65031,185,'Dugoli','341023',1,0,'2022-03-03 12:54:44','2022-03-03 12:54:44'),(65032,185,'Dugorachala','341503',1,0,'2022-03-03 12:54:44','2022-03-03 12:54:44'),(65033,185,'Dujar','341306',1,0,'2022-03-03 12:54:44','2022-03-03 12:54:44'),(65034,185,'Firwasi','341303',1,0,'2022-03-03 12:54:44','2022-03-03 12:54:44'),(65035,185,'Gachhipura','341504',1,0,'2022-03-03 12:54:44','2022-03-03 12:54:44'),(65036,185,'Gagrana','341510',1,0,'2022-03-03 12:54:44','2022-03-03 12:54:44'),(65037,185,'Gagwana','341027',1,0,'2022-03-03 12:54:44','2022-03-03 12:54:44'),(65038,185,'Gajoo','341024',1,0,'2022-03-03 12:54:44','2022-03-03 12:54:44'),(65039,185,'Ganeshpura','341551',1,0,'2022-03-03 12:54:44','2022-03-03 12:54:44'),(65040,185,'Gangawa','341512',1,0,'2022-03-03 12:54:44','2022-03-03 12:54:44'),(65041,185,'Ganthilasar','341001',1,0,'2022-03-03 12:54:44','2022-03-03 12:54:44'),(65042,185,'Ganthiya','341510',1,0,'2022-03-03 12:54:44','2022-03-03 12:54:44'),(65043,185,'Gaondi','341319',1,0,'2022-03-03 12:54:44','2022-03-03 12:54:44'),(65044,185,'Gawalu','341028',1,0,'2022-03-03 12:54:44','2022-03-03 12:54:44'),(65045,185,'Gawardi','341510',1,0,'2022-03-03 12:54:44','2022-03-03 12:54:44'),(65046,185,'Gedakallan','341520',1,0,'2022-03-03 12:54:44','2022-03-03 12:54:44'),(65047,185,'Gelasar','341517',1,0,'2022-03-03 12:54:45','2022-03-03 12:54:45'),(65048,185,'Geloli','341024',1,0,'2022-03-03 12:54:45','2022-03-03 12:54:45'),(65049,185,'Genana','341317',1,0,'2022-03-03 12:54:45','2022-03-03 12:54:45'),(65050,185,'Ghatwa','341512',1,0,'2022-03-03 12:54:45','2022-03-03 12:54:45'),(65051,185,'Gingaliya','341520',1,0,'2022-03-03 12:54:45','2022-03-03 12:54:45'),(65052,185,'Girroda Mitha','341303',1,0,'2022-03-03 12:54:45','2022-03-03 12:54:45'),(65053,185,'Gogelao','341001',1,0,'2022-03-03 12:54:45','2022-03-03 12:54:45'),(65054,185,'Gorau','341316',1,0,'2022-03-03 12:54:45','2022-03-03 12:54:45'),(65055,185,'Gotan','342902',1,0,'2022-03-03 12:54:45','2022-03-03 12:54:45'),(65056,185,'Gothara','341024',1,0,'2022-03-03 12:54:45','2022-03-03 12:54:45'),(65057,185,'Govindi','341509',1,0,'2022-03-03 12:54:45','2022-03-03 12:54:45'),(65058,185,'Gowankallan','341028',1,0,'2022-03-03 12:54:45','2022-03-03 12:54:45'),(65059,185,'Gudha Jodhan','341023',1,0,'2022-03-03 12:54:45','2022-03-03 12:54:45'),(65060,185,'Gudhabhagwandas','341001',1,0,'2022-03-03 12:54:45','2022-03-03 12:54:45'),(65061,185,'Gudhasalt','341509',1,0,'2022-03-03 12:54:45','2022-03-03 12:54:45'),(65062,185,'Gugaryali','341023',1,0,'2022-03-03 12:54:45','2022-03-03 12:54:45'),(65063,185,'Gular','341501',1,0,'2022-03-03 12:54:45','2022-03-03 12:54:45'),(65064,185,'Gunawati','341505',1,0,'2022-03-03 12:54:45','2022-03-03 12:54:45'),(65065,185,'Hariyajun','341508',1,0,'2022-03-03 12:54:45','2022-03-03 12:54:45'),(65066,185,'Harnawa','341501',1,0,'2022-03-03 12:54:45','2022-03-03 12:54:45'),(65067,185,'Harsolav','342902',1,0,'2022-03-03 12:54:45','2022-03-03 12:54:45'),(65068,185,'Harsore','341515',1,0,'2022-03-03 12:54:45','2022-03-03 12:54:45'),(65069,185,'Heerani','341508',1,0,'2022-03-03 12:54:45','2022-03-03 12:54:45'),(65070,185,'Hudas','341316',1,0,'2022-03-03 12:54:45','2022-03-03 12:54:45'),(65071,185,'Hudeel','341509',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65072,185,'Hudia','341502',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65073,185,'I.A.Bidiad','341542',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65074,185,'I.A.Nawacity','341509',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65075,185,'Idwa','341503',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65076,185,'Inana','341026',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65077,185,'Indawar','341510',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65078,185,'Indokha','341508',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65079,185,'Indokha','341319',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65080,185,'Itawalakha','341504',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65081,185,'Jabdinagar','341509',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65082,185,'Jael','341023',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65083,185,'Jakhali','341502',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65084,185,'Jakhara','341301',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65085,185,'Jal R.S.','341514',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65086,185,'Jalaniyasar','341001',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65087,185,'Jalsu Nanak','341514',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65088,185,'Jalsukallan','341514',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65089,185,'Janana','341028',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65090,185,'Janewa','341001',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65091,185,'Janjila','341501',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65092,185,'Jaola','341503',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65093,185,'Jaroda','341511',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65094,185,'Jasnagar','341518',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65095,185,'Jaswantabad','341518',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65096,185,'Jaswantgarh','341304',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65097,185,'Jaswantpura','341504',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65098,185,'Jatawas','341513',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65099,185,'Jhalara','341512',1,0,'2022-03-03 12:54:46','2022-03-03 12:54:46'),(65100,185,'Jhareli','341022',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65101,185,'Jharisara','341001',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65102,185,'Jharod','341506',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65103,185,'Jhintiya','341513',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65104,185,'Jhujhanda','341026',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65105,185,'Jijoth','341519',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65106,185,'Jiliya','341508',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65107,185,'Jiwadiya','341502',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65108,185,'Jochina','341023',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65109,185,'Jodhiyasi','341001',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65110,185,'Jogimagara','341511',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65111,185,'Jusari','341505',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65112,185,'Jusariya','341502',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65113,185,'Kalri','341001',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65114,185,'Kalru','341510',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65115,185,'Kalwa','341502',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65116,185,'Kalwani','341303',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65117,185,'Kameria','341022',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65118,185,'Kankariya','341508',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65119,185,'Kantiya','341025',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65120,185,'Kanwariyat','341510',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65121,185,'Karlu','341026',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65122,185,'Karnu','341001',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65123,185,'Kasari','341301',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65124,185,'Kasnau','341024',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65125,185,'Kasumbi','341304',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65126,185,'Kathoti','341023',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65127,185,'Katyasani','341510',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65128,185,'Kerap','341305',1,0,'2022-03-03 12:54:47','2022-03-03 12:54:47'),(65129,185,'Khajwana','341028',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65130,185,'Khakharki','341512',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65131,185,'Khakharki','341510',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65132,185,'Khakholi','341506',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65133,185,'Khamiyad','341317',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65134,185,'Khanpur\'','341512',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65135,185,'Khanwar','341027',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65136,185,'Khardiya','341509',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65137,185,'Khardiya','341504',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65138,185,'Kharesh','341318',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65139,185,'Kharikaramsota','341001',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65140,185,'Khariya','341551',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65141,185,'Kharnal','341001',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65142,185,'Kharwaliya','341319',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65143,185,'Khatiyabasani','341303',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65144,185,'Khatora','341025',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65145,185,'Kheduli','341511',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65146,185,'Kherileela','341504',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65147,185,'Kheriseela','341504',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65148,185,'Kherwa','341503',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65149,185,'Khinwaj','341303',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65150,185,'Khinwsar','341025',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65151,185,'Khinyala','341023',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65152,185,'Khinyas','341514',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65153,185,'Khojas','341318',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65154,185,'Khokhar','341512',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65155,185,'Khorandi','341509',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65156,185,'Khunkhuna','341318',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65157,185,'Khurikallan','341503',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65158,185,'Kinsariya','341512',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65159,185,'Kiro R.S.','341301',1,0,'2022-03-03 12:54:48','2022-03-03 12:54:48'),(65160,185,'Kitalsar','341503',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65161,185,'Kod','341513',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65162,185,'Koliya','341305',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65163,185,'Kuchamancity','341508',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65164,185,'Kuchera (Nagaur)','341024',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65165,185,'Kuchipala','341504',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65166,185,'Kukanwali','341519',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65167,185,'Kukrod','341505',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65168,185,'Kum Merta','341510',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65169,185,'Kumari','341021',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65170,185,'Kundari','341503',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65171,185,'Kupras','341511',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65172,185,'Kurchi','341025',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65173,185,'Kurdada','341503',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65174,185,'Kurdayan','341510',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65175,185,'Kyamsar','341551',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65176,185,'Lachhari','341303',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65177,185,'Ladariya','341517',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65178,185,'Ladawa','341518',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65179,185,'Ladnun Lsg','341306',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65180,185,'Ladnuncity','341306',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65181,185,'Ladoli','341520',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65182,185,'Ladpura','341513',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65183,185,'Lalana Khurd','341501',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65184,185,'Lalas','341509',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65185,185,'Lalsari','341303',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65186,185,'Lambajatan','341510',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65187,185,'Lampolai','341510',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65188,185,'Langod','341503',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65189,185,'Ledi','341304',1,0,'2022-03-03 12:54:49','2022-03-03 12:54:49'),(65190,185,'Lichana','341533',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65191,185,'Liliya','341518',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65192,185,'Loroli','341502',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65193,185,'Lunsara','341024',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65194,185,'Lunwa','341509',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65195,185,'Madpura','341025',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65196,185,'Makrana H.O','341505',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65197,185,'Makrana Rs','341505',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65198,185,'Makrana S.B.','341505',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65199,185,'Malgaon','341316',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65200,185,'Mamroda','341305',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65201,185,'Mamroli','341520',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65202,185,'Manakpura','341025',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65203,185,'Manana','341502',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65204,185,'Mandaljodhan','341503',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65205,185,'Mandukara','341319',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65206,185,'Manglana','341505',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65207,185,'Manglod','341027',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65208,185,'Manjhi','341301',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65209,185,'Maroth','341507',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65210,185,'Marwar Mundwa','341026',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65211,185,'Marwarbalia','341303',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65212,185,'Maulasar','341506',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65213,185,'Mawa','341303',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65214,185,'Mayapur','341512',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65215,185,'Medas','341518',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65216,185,'Merta City','341510',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65217,185,'Merta Road','341511',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65218,185,'Merta','341510',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65219,185,'Merwas','341030',1,0,'2022-03-03 12:54:50','2022-03-03 12:54:50'),(65220,185,'Mewara','341031',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65221,185,'Midiyan','341503',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65222,185,'Mindha','341509',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65223,185,'Mithariya','341503',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65224,185,'Mithri','341303',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65225,185,'Mithri','341533',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65226,185,'Modiawat','341551',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65227,185,'Modicharana','341502',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65228,185,'Mokala','341510',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65229,185,'Morer','341542',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65230,185,'Mori','341028',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65231,185,'Moriallan','341515',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65232,185,'Morikhurd','341503',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65233,185,'Morra','341510',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65234,185,'Motipura','341519',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65235,185,'Mugadara','341510',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65236,185,'Mundghasoi','341509',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65237,185,'Mundiyar','341028',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65238,185,'Muwana','341508',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65239,185,'Nagari','341025',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65240,185,'Nagaur H.O','341001',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65241,185,'Nagaurcity','341001',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65242,185,'Nagwara','341519',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65243,185,'Nalot','341519',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65244,185,'Nandoli Mertiyan','341520',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65245,185,'Nandolichandawatan','341517',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65246,185,'Narainpura','341508',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65247,185,'Narwakallan','341025',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65248,185,'Nathawara','341031',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65249,185,'Nawacity Lsg','341509',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65250,185,'Nawad','341319',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65251,185,'Neniya','341512',1,0,'2022-03-03 12:54:51','2022-03-03 12:54:51'),(65252,185,'Netariya','341510',1,0,'2022-03-03 12:54:52','2022-03-03 12:54:52'),(65253,185,'Netiyas','341503',1,0,'2022-03-03 12:54:52','2022-03-03 12:54:52'),(65254,185,'Nimbijodhan','341316',1,0,'2022-03-03 12:54:52','2022-03-03 12:54:52'),(65255,185,'Nimbikhurd','341303',1,0,'2022-03-03 12:54:52','2022-03-03 12:54:52'),(65256,185,'Nimbola Bishwa','341031',1,0,'2022-03-03 12:54:52','2022-03-03 12:54:52'),(65257,185,'Nimbolakallan','341514',1,0,'2022-03-03 12:54:52','2022-03-03 12:54:52'),(65258,185,'Nimbri','341501',1,0,'2022-03-03 12:54:52','2022-03-03 12:54:52'),(65259,185,'Nimbrichandawatan','341024',1,0,'2022-03-03 12:54:52','2022-03-03 12:54:52'),(65260,185,'Nimbrikallan','341503',1,0,'2022-03-03 12:54:52','2022-03-03 12:54:52'),(65261,185,'Nimod','341506',1,0,'2022-03-03 12:54:52','2022-03-03 12:54:52'),(65262,185,'Nokhachandawatan','342902',1,0,'2022-03-03 12:54:52','2022-03-03 12:54:52'),(65263,185,'Nundara','341504',1,0,'2022-03-03 12:54:52','2022-03-03 12:54:52'),(65264,185,'Nuwa','341551',1,0,'2022-03-03 12:54:52','2022-03-03 12:54:52'),(65265,185,'Odit','341316',1,0,'2022-03-03 12:54:52','2022-03-03 12:54:52'),(65266,185,'Oladan','341511',1,0,'2022-03-03 12:54:52','2022-03-03 12:54:52'),(65267,185,'Pabusar','341001',1,0,'2022-03-03 12:54:52','2022-03-03 12:54:52'),(65268,185,'Padukallan','341031',1,0,'2022-03-03 12:54:52','2022-03-03 12:54:52'),(65269,185,'Padukhurd','341031',1,0,'2022-03-03 12:54:52','2022-03-03 12:54:52'),(65270,185,'Pahelipatti Ladnun','341306',1,0,'2022-03-03 12:54:52','2022-03-03 12:54:52'),(65271,185,'Palara','341508',1,0,'2022-03-03 12:54:52','2022-03-03 12:54:52'),(65272,185,'Paliyas','341503',1,0,'2022-03-03 12:54:52','2022-03-03 12:54:52'),(65273,185,'Palot','341305',1,0,'2022-03-03 12:54:52','2022-03-03 12:54:52'),(65274,185,'Palrijodhan','341028',1,0,'2022-03-03 12:54:52','2022-03-03 12:54:52'),(65275,185,'Palrikallan','341503',1,0,'2022-03-03 12:54:52','2022-03-03 12:54:52'),(65276,185,'Palrinawa','341533',1,0,'2022-03-03 12:54:53','2022-03-03 12:54:53'),(65277,185,'Panchlasidha','341025',1,0,'2022-03-03 12:54:53','2022-03-03 12:54:53'),(65278,185,'Panchori','341001',1,0,'2022-03-03 12:54:53','2022-03-03 12:54:53'),(65279,185,'Panchota','341509',1,0,'2022-03-03 12:54:53','2022-03-03 12:54:53'),(65280,185,'Panchwa','341508',1,0,'2022-03-03 12:54:53','2022-03-03 12:54:53'),(65281,185,'Parbatsar','341512',1,0,'2022-03-03 12:54:53','2022-03-03 12:54:53'),(65282,185,'Parewari','341516',1,0,'2022-03-03 12:54:53','2022-03-03 12:54:53'),(65283,185,'Pawa','341302',1,0,'2022-03-03 12:54:53','2022-03-03 12:54:53'),(65284,185,'Payali','341551',1,0,'2022-03-03 12:54:53','2022-03-03 12:54:53'),(65285,185,'Peeh','341503',1,0,'2022-03-03 12:54:53','2022-03-03 12:54:53'),(65286,185,'Peelwa','341503',1,0,'2022-03-03 12:54:53','2022-03-03 12:54:53'),(65287,185,'Peeplad','341512',1,0,'2022-03-03 12:54:53','2022-03-03 12:54:53'),(65288,185,'Pharrod','341030',1,0,'2022-03-03 12:54:53','2022-03-03 12:54:53'),(65289,185,'Phirod','341001',1,0,'2022-03-03 12:54:53','2022-03-03 12:54:53'),(65290,185,'Phogari','341303',1,0,'2022-03-03 12:54:53','2022-03-03 12:54:53'),(65291,185,'Pipasar','341029',1,0,'2022-03-03 12:54:53','2022-03-03 12:54:53'),(65292,185,'Pirwa','341318',1,0,'2022-03-03 12:54:53','2022-03-03 12:54:53'),(65293,185,'Poonlota','341503',1,0,'2022-03-03 12:54:53','2022-03-03 12:54:53'),(65294,185,'Prempura','341519',1,0,'2022-03-03 12:54:53','2022-03-03 12:54:53'),(65295,185,'Punas','341514',1,0,'2022-03-03 12:54:53','2022-03-03 12:54:53'),(65296,185,'Pundlu','341510',1,0,'2022-03-03 12:54:53','2022-03-03 12:54:53'),(65297,185,'Rabariyad','341512',1,0,'2022-03-03 12:54:53','2022-03-03 12:54:53'),(65298,185,'Rahugate Ladnun','341306',1,0,'2022-03-03 12:54:53','2022-03-03 12:54:53'),(65299,185,'Raidhana','341303',1,0,'2022-03-03 12:54:54','2022-03-03 12:54:54'),(65300,185,'Raidhanu','341021',1,0,'2022-03-03 12:54:54','2022-03-03 12:54:54'),(65301,185,'Rajaliya','341508',1,0,'2022-03-03 12:54:54','2022-03-03 12:54:54'),(65302,185,'Rajapura','341301',1,0,'2022-03-03 12:54:54','2022-03-03 12:54:54'),(65303,185,'Rajlota','341503',1,0,'2022-03-03 12:54:54','2022-03-03 12:54:54'),(65304,185,'Rajod','341514',1,0,'2022-03-03 12:54:54','2022-03-03 12:54:54'),(65305,185,'Rajod','341023',1,0,'2022-03-03 12:54:54','2022-03-03 12:54:54'),(65306,185,'Ramsabas','341303',1,0,'2022-03-03 12:54:54','2022-03-03 12:54:54'),(65307,185,'Ramsari','341503',1,0,'2022-03-03 12:54:54','2022-03-03 12:54:54'),(65308,185,'Ramsia','341504',1,0,'2022-03-03 12:54:54','2022-03-03 12:54:54'),(65309,185,'Ranigaon','341302',1,0,'2022-03-03 12:54:54','2022-03-03 12:54:54'),(65310,185,'Ransisar','341305',1,0,'2022-03-03 12:54:54','2022-03-03 12:54:54'),(65311,185,'Rasal','341508',1,0,'2022-03-03 12:54:54','2022-03-03 12:54:54'),(65312,185,'Rasaliyawas','341510',1,0,'2022-03-03 12:54:54','2022-03-03 12:54:54'),(65313,185,'Rasidpura','341517',1,0,'2022-03-03 12:54:54','2022-03-03 12:54:54'),(65314,185,'Ratanga','341027',1,0,'2022-03-03 12:54:54','2022-03-03 12:54:54'),(65315,185,'Ratau','341317',1,0,'2022-03-03 12:54:54','2022-03-03 12:54:54'),(65316,185,'Ratrana','341031',1,0,'2022-03-03 12:54:54','2022-03-03 12:54:54'),(65317,185,'Reengan','341303',1,0,'2022-03-03 12:54:54','2022-03-03 12:54:54'),(65318,185,'Ren','341514',1,0,'2022-03-03 12:54:54','2022-03-03 12:54:54'),(65319,185,'Rid','341503',1,0,'2022-03-03 12:54:54','2022-03-03 12:54:54'),(65320,185,'Riyan','341513',1,0,'2022-03-03 12:54:54','2022-03-03 12:54:54'),(65321,185,'Rodu','341304',1,0,'2022-03-03 12:54:54','2022-03-03 12:54:54'),(65322,185,'Rohina','341030',1,0,'2022-03-03 12:54:54','2022-03-03 12:54:54'),(65323,185,'Rohindi','341512',1,0,'2022-03-03 12:54:54','2022-03-03 12:54:54'),(65324,185,'Rohini','341001',1,0,'2022-03-03 12:54:55','2022-03-03 12:54:55'),(65325,185,'Rohisa','341513',1,0,'2022-03-03 12:54:55','2022-03-03 12:54:55'),(65326,185,'Rol','341027',1,0,'2022-03-03 12:54:55','2022-03-03 12:54:55'),(65327,185,'Roon','341028',1,0,'2022-03-03 12:54:55','2022-03-03 12:54:55'),(65328,185,'Rooppura','341508',1,0,'2022-03-03 12:54:55','2022-03-03 12:54:55'),(65329,185,'Rotoo','341023',1,0,'2022-03-03 12:54:55','2022-03-03 12:54:55'),(65330,185,'S.Padampura','341508',1,0,'2022-03-03 12:54:55','2022-03-03 12:54:55'),(65331,185,'S.R. Kuchamancity','341508',1,0,'2022-03-03 12:54:55','2022-03-03 12:54:55'),(65332,185,'Sabalpura','341520',1,0,'2022-03-03 12:54:55','2022-03-03 12:54:55'),(65333,185,'Sabalpura','341508',1,0,'2022-03-03 12:54:55','2022-03-03 12:54:55'),(65334,185,'Sadokan','341001',1,0,'2022-03-03 12:54:55','2022-03-03 12:54:55'),(65335,185,'Saferkallan','341502',1,0,'2022-03-03 12:54:55','2022-03-03 12:54:55'),(65336,185,'Sagoobari','341305',1,0,'2022-03-03 12:54:55','2022-03-03 12:54:55'),(65337,185,'Sandila','341030',1,0,'2022-03-03 12:54:55','2022-03-03 12:54:55'),(65338,185,'Sania','341318',1,0,'2022-03-03 12:54:55','2022-03-03 12:54:55'),(65339,185,'Sanju','341503',1,0,'2022-03-03 12:54:55','2022-03-03 12:54:55'),(65340,185,'Sankhawas','341028',1,0,'2022-03-03 12:54:55','2022-03-03 12:54:55'),(65341,185,'Sanwarad','341303',1,0,'2022-03-03 12:54:55','2022-03-03 12:54:55'),(65342,185,'Sardarpura Khurd','341551',1,0,'2022-03-03 12:54:55','2022-03-03 12:54:55'),(65343,185,'Sardi','341303',1,0,'2022-03-03 12:54:55','2022-03-03 12:54:55'),(65344,185,'Sarnawara','341504',1,0,'2022-03-03 12:54:55','2022-03-03 12:54:55'),(65345,185,'Sathana','341031',1,0,'2022-03-03 12:54:55','2022-03-03 12:54:55'),(65346,185,'Satheran','341001',1,0,'2022-03-03 12:54:55','2022-03-03 12:54:55'),(65347,185,'Satlas','341510',1,0,'2022-03-03 12:54:55','2022-03-03 12:54:55'),(65348,185,'Senani','342902',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65349,185,'Sensara','341513',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65350,185,'Serani Ki Dhani','341302',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65351,185,'Sewa','341303',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65352,185,'Sewari','341029',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65353,185,'Sheelgaon','341028',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65354,185,'Shimbhupura','341507',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65355,185,'Shiv','341519',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65356,185,'Shyamgarh','341507',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65357,185,'Shyamsar','341001',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65358,185,'Silanwad','341023',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65359,185,'Singar','341001',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65360,185,'Singhana','341303',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65361,185,'Singrawatkallan','341303',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65362,185,'Sinod','341001',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65363,185,'Sinwa','341317',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65364,185,'Sirasana','341514',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65365,185,'Sirsu','341501',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65366,185,'Somana','341022',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65367,185,'Soneli','341022',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65368,185,'Sribalaji','341029',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65369,185,'Station Road Didwana','341303',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65370,185,'Sudarasan','341551',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65371,185,'Sudwar','341031',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65372,185,'Sukhwasi','341001',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65373,185,'Sunari','341306',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65374,185,'Supaka','341303',1,0,'2022-03-03 12:54:56','2022-03-03 12:54:56'),(65375,185,'Surjaniyawas','341027',1,0,'2022-03-03 12:54:57','2022-03-03 12:54:57'),(65376,185,'Surpalia','341022',1,0,'2022-03-03 12:54:57','2022-03-03 12:54:57'),(65377,185,'Tadas','341025',1,0,'2022-03-03 12:54:57','2022-03-03 12:54:57'),(65378,185,'Talanpur','342902',1,0,'2022-03-03 12:54:57','2022-03-03 12:54:57'),(65379,185,'Tankala','341001',1,0,'2022-03-03 12:54:57','2022-03-03 12:54:57'),(65380,185,'Tantwas','341001',1,0,'2022-03-03 12:54:57','2022-03-03 12:54:57'),(65381,185,'Tanwara','341304',1,0,'2022-03-03 12:54:57','2022-03-03 12:54:57'),(65382,185,'Tanwara','341022',1,0,'2022-03-03 12:54:57','2022-03-03 12:54:57'),(65383,185,'Taparwara','341512',1,0,'2022-03-03 12:54:57','2022-03-03 12:54:57'),(65384,185,'Tarnau','341030',1,0,'2022-03-03 12:54:57','2022-03-03 12:54:57'),(65385,185,'Tausar','341001',1,0,'2022-03-03 12:54:57','2022-03-03 12:54:57'),(65386,185,'Tehla','341031',1,0,'2022-03-03 12:54:57','2022-03-03 12:54:57'),(65387,185,'Thakriyas','341316',1,0,'2022-03-03 12:54:57','2022-03-03 12:54:57'),(65388,185,'Thanwala','305026',1,0,'2022-03-03 12:54:57','2022-03-03 12:54:57'),(65389,185,'Thata','341515',1,0,'2022-03-03 12:54:57','2022-03-03 12:54:57'),(65390,185,'Thebari','341319',1,0,'2022-03-03 12:54:57','2022-03-03 12:54:57'),(65391,185,'Thikariya Khurd','341509',1,0,'2022-03-03 12:54:57','2022-03-03 12:54:57'),(65392,185,'Thirod','341026',1,0,'2022-03-03 12:54:57','2022-03-03 12:54:57'),(65393,185,'Tilanesh','341503',1,0,'2022-03-03 12:54:57','2022-03-03 12:54:57'),(65394,185,'Todas','341509',1,0,'2022-03-03 12:54:57','2022-03-03 12:54:57'),(65395,185,'Toonkaliyan','342902',1,0,'2022-03-03 12:54:57','2022-03-03 12:54:57'),(65396,185,'Toshina','341319',1,0,'2022-03-03 12:54:57','2022-03-03 12:54:57'),(65397,185,'Ubasi','341030',1,0,'2022-03-03 12:54:58','2022-03-03 12:54:58'),(65398,185,'Unthwaliya','341001',1,0,'2022-03-03 12:54:58','2022-03-03 12:54:58'),(65399,186,'Agewa','306302',1,0,'2022-03-03 12:54:58','2022-03-03 12:54:58'),(65400,186,'Alawas','306103',1,0,'2022-03-03 12:54:58','2022-03-03 12:54:58'),(65401,186,'Amaliya','306504',1,0,'2022-03-03 12:54:58','2022-03-03 12:54:58'),(65402,186,'Amarpura','306102',1,0,'2022-03-03 12:54:58','2022-03-03 12:54:58'),(65403,186,'Ana','306703',1,0,'2022-03-03 12:54:58','2022-03-03 12:54:58'),(65404,186,'Anandpur Kalu','306301',1,0,'2022-03-03 12:54:58','2022-03-03 12:54:58'),(65405,186,'Anoppura','306602',1,0,'2022-03-03 12:54:58','2022-03-03 12:54:58'),(65406,186,'Asarlai','306303',1,0,'2022-03-03 12:54:58','2022-03-03 12:54:58'),(65407,186,'Atabara','306104',1,0,'2022-03-03 12:54:58','2022-03-03 12:54:58'),(65408,186,'Auwa R.S.','306001',1,0,'2022-03-03 12:54:58','2022-03-03 12:54:58'),(65409,186,'Auwa','306021',1,0,'2022-03-03 12:54:58','2022-03-03 12:54:58'),(65410,186,'B.M.G. Hospital Ramnagar','306902',1,0,'2022-03-03 12:54:58','2022-03-03 12:54:58'),(65411,186,'Babagaon','306708',1,0,'2022-03-03 12:54:58','2022-03-03 12:54:58'),(65412,186,'Babhan','306103',1,0,'2022-03-03 12:54:58','2022-03-03 12:54:58'),(65413,186,'Babra (Pali)','306101',1,0,'2022-03-03 12:54:58','2022-03-03 12:54:58'),(65414,186,'Bagiara','306305',1,0,'2022-03-03 12:54:58','2022-03-03 12:54:58'),(65415,186,'Bagol','306502',1,0,'2022-03-03 12:54:58','2022-03-03 12:54:58'),(65416,186,'Bagri Kalaliya','306105',1,0,'2022-03-03 12:54:58','2022-03-03 12:54:58'),(65417,186,'Bagri Nagar','306114',1,0,'2022-03-03 12:54:58','2022-03-03 12:54:58'),(65418,186,'Balada','306709',1,0,'2022-03-03 12:54:58','2022-03-03 12:54:58'),(65419,186,'Balana','306912',1,0,'2022-03-03 12:54:58','2022-03-03 12:54:58'),(65420,186,'Bali','306701',1,0,'2022-03-03 12:54:58','2022-03-03 12:54:58'),(65421,186,'Balrai','306422',1,0,'2022-03-03 12:54:59','2022-03-03 12:54:59'),(65422,186,'Balunda','306308',1,0,'2022-03-03 12:54:59','2022-03-03 12:54:59'),(65423,186,'Balupura','306901',1,0,'2022-03-03 12:54:59','2022-03-03 12:54:59'),(65424,186,'Bamnera','306901',1,0,'2022-03-03 12:54:59','2022-03-03 12:54:59'),(65425,186,'Banjakuri','306308',1,0,'2022-03-03 12:54:59','2022-03-03 12:54:59'),(65426,186,'Bankli','306901',1,0,'2022-03-03 12:54:59','2022-03-03 12:54:59'),(65427,186,'Bansiya','306307',1,0,'2022-03-03 12:54:59','2022-03-03 12:54:59'),(65428,186,'Banta R.S.','306503',1,0,'2022-03-03 12:54:59','2022-03-03 12:54:59'),(65429,186,'Banta Town','306503',1,0,'2022-03-03 12:54:59','2022-03-03 12:54:59'),(65430,186,'Bar','306105',1,0,'2022-03-03 12:54:59','2022-03-03 12:54:59'),(65431,186,'Barod','306702',1,0,'2022-03-03 12:54:59','2022-03-03 12:54:59'),(65432,186,'Barsa','306001',1,0,'2022-03-03 12:54:59','2022-03-03 12:54:59'),(65433,186,'Barwa','306706',1,0,'2022-03-03 12:54:59','2022-03-03 12:54:59'),(65434,186,'Basant','306708',1,0,'2022-03-03 12:54:59','2022-03-03 12:54:59'),(65435,186,'Basna','306306',1,0,'2022-03-03 12:54:59','2022-03-03 12:54:59'),(65436,186,'Basni Jojawar','306022',1,0,'2022-03-03 12:54:59','2022-03-03 12:54:59'),(65437,186,'Bayad','306421',1,0,'2022-03-03 12:54:59','2022-03-03 12:54:59'),(65438,186,'Beejapur','306707',1,0,'2022-03-03 12:54:59','2022-03-03 12:54:59'),(65439,186,'Beelawas','306104',1,0,'2022-03-03 12:54:59','2022-03-03 12:54:59'),(65440,186,'Beerami','306115',1,0,'2022-03-03 12:54:59','2022-03-03 12:54:59'),(65441,186,'Beethora','306602',1,0,'2022-03-03 12:54:59','2022-03-03 12:54:59'),(65442,186,'Beethu','306421',1,0,'2022-03-03 12:54:59','2022-03-03 12:54:59'),(65443,186,'Ber - Kalan','306302',1,0,'2022-03-03 12:54:59','2022-03-03 12:54:59'),(65444,186,'Bera','306126',1,0,'2022-03-03 12:54:59','2022-03-03 12:54:59'),(65445,186,'Bhadarlau','306503',1,0,'2022-03-03 12:54:59','2022-03-03 12:54:59'),(65446,186,'Bhagora','306022',1,0,'2022-03-03 12:55:00','2022-03-03 12:55:00'),(65447,186,'Bhaisana','306103',1,0,'2022-03-03 12:55:00','2022-03-03 12:55:00'),(65448,186,'Bhakriwala','306401',1,0,'2022-03-03 12:55:00','2022-03-03 12:55:00'),(65449,186,'Bhandar','306504',1,0,'2022-03-03 12:55:00','2022-03-03 12:55:00'),(65450,186,'Bhangesar','306401',1,0,'2022-03-03 12:55:00','2022-03-03 12:55:00'),(65451,186,'Bhanwari','306401',1,0,'2022-03-03 12:55:00','2022-03-03 12:55:00'),(65452,186,'Bharunda','306901',1,0,'2022-03-03 12:55:00','2022-03-03 12:55:00'),(65453,186,'Bhatund','306707',1,0,'2022-03-03 12:55:00','2022-03-03 12:55:00'),(65454,186,'Bheemaliya','306503',1,0,'2022-03-03 12:55:00','2022-03-03 12:55:00'),(65455,186,'Bheemana','306504',1,0,'2022-03-03 12:55:00','2022-03-03 12:55:00'),(65456,186,'Bheetwara','306705',1,0,'2022-03-03 12:55:00','2022-03-03 12:55:00'),(65457,186,'Bhoombaliya','306301',1,0,'2022-03-03 12:55:00','2022-03-03 12:55:00'),(65458,186,'Bijowa','306601',1,0,'2022-03-03 12:55:00','2022-03-03 12:55:00'),(65459,186,'Birantiya Kalan','306105',1,0,'2022-03-03 12:55:00','2022-03-03 12:55:00'),(65460,186,'Birantiya Khurd','306105',1,0,'2022-03-03 12:55:00','2022-03-03 12:55:00'),(65461,186,'Birol','306302',1,0,'2022-03-03 12:55:00','2022-03-03 12:55:00'),(65462,186,'Bisalpur','306126',1,0,'2022-03-03 12:55:00','2022-03-03 12:55:00'),(65463,186,'Bithora Kalan','306001',1,0,'2022-03-03 12:55:00','2022-03-03 12:55:00'),(65464,186,'Bomadara','306401',1,0,'2022-03-03 12:55:00','2022-03-03 12:55:00'),(65465,186,'Boosi','306503',1,0,'2022-03-03 12:55:00','2022-03-03 12:55:00'),(65466,186,'Bootiwas','306102',1,0,'2022-03-03 12:55:00','2022-03-03 12:55:00'),(65467,186,'Bopari','306023',1,0,'2022-03-03 12:55:00','2022-03-03 12:55:00'),(65468,186,'Borimada','306023',1,0,'2022-03-03 12:55:00','2022-03-03 12:55:00'),(65469,186,'Bornadi','306103',1,0,'2022-03-03 12:55:01','2022-03-03 12:55:01'),(65470,186,'Boya','306701',1,0,'2022-03-03 12:55:01','2022-03-03 12:55:01'),(65471,186,'Chadwas','306104',1,0,'2022-03-03 12:55:01','2022-03-03 12:55:01'),(65472,186,'Chamunderi','306504',1,0,'2022-03-03 12:55:01','2022-03-03 12:55:01'),(65473,186,'Chanchori','306115',1,0,'2022-03-03 12:55:01','2022-03-03 12:55:01'),(65474,186,'Chandawal','306306',1,0,'2022-03-03 12:55:01','2022-03-03 12:55:01'),(65475,186,'Chanddawal R.S.','306306',1,0,'2022-03-03 12:55:01','2022-03-03 12:55:01'),(65476,186,'Chang','306102',1,0,'2022-03-03 12:55:01','2022-03-03 12:55:01'),(65477,186,'Chanod','306602',1,0,'2022-03-03 12:55:01','2022-03-03 12:55:01'),(65478,186,'Chawandiya','306305',1,0,'2022-03-03 12:55:01','2022-03-03 12:55:01'),(65479,186,'Chawariya','306001',1,0,'2022-03-03 12:55:01','2022-03-03 12:55:01'),(65480,186,'Chelawas','306001',1,0,'2022-03-03 12:55:01','2022-03-03 12:55:01'),(65481,186,'Chenda','306421',1,0,'2022-03-03 12:55:01','2022-03-03 12:55:01'),(65482,186,'Chirpatiya','306023',1,0,'2022-03-03 12:55:01','2022-03-03 12:55:01'),(65483,186,'Chittar','306102',1,0,'2022-03-03 12:55:01','2022-03-03 12:55:01'),(65484,186,'Chokariya','306023',1,0,'2022-03-03 12:55:01','2022-03-03 12:55:01'),(65485,186,'Chopra','306104',1,0,'2022-03-03 12:55:01','2022-03-03 12:55:01'),(65486,186,'Chotila','306421',1,0,'2022-03-03 12:55:01','2022-03-03 12:55:01'),(65487,186,'Dadai','306601',1,0,'2022-03-03 12:55:01','2022-03-03 12:55:01'),(65488,186,'Dantiwara','306701',1,0,'2022-03-03 12:55:01','2022-03-03 12:55:01'),(65489,186,'Dari','306401',1,0,'2022-03-03 12:55:01','2022-03-03 12:55:01'),(65490,186,'Dayalana','306502',1,0,'2022-03-03 12:55:02','2022-03-03 12:55:02'),(65491,186,'Dayalpura','306401',1,0,'2022-03-03 12:55:02','2022-03-03 12:55:02'),(65492,186,'Deegai','306422',1,0,'2022-03-03 12:55:02','2022-03-03 12:55:02'),(65493,186,'Deepwas','306304',1,0,'2022-03-03 12:55:02','2022-03-03 12:55:02'),(65494,186,'Denda','306422',1,0,'2022-03-03 12:55:02','2022-03-03 12:55:02'),(65495,186,'Deoli Auwa','306021',1,0,'2022-03-03 12:55:02','2022-03-03 12:55:02'),(65496,186,'Deoli Hulla','306114',1,0,'2022-03-03 12:55:02','2022-03-03 12:55:02'),(65497,186,'Deoli Kalan','306306',1,0,'2022-03-03 12:55:02','2022-03-03 12:55:02'),(65498,186,'Deoli Pabuji','306603',1,0,'2022-03-03 12:55:02','2022-03-03 12:55:02'),(65499,186,'Deoria','306302',1,0,'2022-03-03 12:55:02','2022-03-03 12:55:02'),(65500,186,'Deotra','306116',1,0,'2022-03-03 12:55:02','2022-03-03 12:55:02'),(65501,186,'Desuri','306703',1,0,'2022-03-03 12:55:02','2022-03-03 12:55:02'),(65502,186,'Dhabar Kalan','306421',1,0,'2022-03-03 12:55:02','2022-03-03 12:55:02'),(65503,186,'Dhakri','306104',1,0,'2022-03-03 12:55:02','2022-03-03 12:55:02'),(65504,186,'Dhalop','306603',1,0,'2022-03-03 12:55:02','2022-03-03 12:55:02'),(65505,186,'Dhamli','306501',1,0,'2022-03-03 12:55:02','2022-03-03 12:55:02'),(65506,186,'Dhana','306115',1,0,'2022-03-03 12:55:02','2022-03-03 12:55:02'),(65507,186,'Dhaneriya','306101',1,0,'2022-03-03 12:55:02','2022-03-03 12:55:02'),(65508,186,'Dhani','306116',1,0,'2022-03-03 12:55:02','2022-03-03 12:55:02'),(65509,186,'Dhanla','306022',1,0,'2022-03-03 12:55:02','2022-03-03 12:55:02'),(65510,186,'Dhareshwar','306001',1,0,'2022-03-03 12:55:02','2022-03-03 12:55:02'),(65511,186,'Dhariya','306119',1,0,'2022-03-03 12:55:02','2022-03-03 12:55:02'),(65512,186,'Dhinawas','306104',1,0,'2022-03-03 12:55:02','2022-03-03 12:55:02'),(65513,186,'Dhola','306422',1,0,'2022-03-03 12:55:03','2022-03-03 12:55:03'),(65514,186,'Dhundhla','306103',1,0,'2022-03-03 12:55:03','2022-03-03 12:55:03'),(65515,186,'Digarna','306308',1,0,'2022-03-03 12:55:03','2022-03-03 12:55:03'),(65516,186,'Diwandi','306421',1,0,'2022-03-03 12:55:03','2022-03-03 12:55:03'),(65517,186,'Dlf Rabriyawas','306709',1,0,'2022-03-03 12:55:03','2022-03-03 12:55:03'),(65518,186,'Dudapura','306704',1,0,'2022-03-03 12:55:03','2022-03-03 12:55:03'),(65519,186,'Dudiya','306421',1,0,'2022-03-03 12:55:03','2022-03-03 12:55:03'),(65520,186,'Dudni','306126',1,0,'2022-03-03 12:55:03','2022-03-03 12:55:03'),(65521,186,'Dujana','306708',1,0,'2022-03-03 12:55:03','2022-03-03 12:55:03'),(65522,186,'Dutariya','306503',1,0,'2022-03-03 12:55:03','2022-03-03 12:55:03'),(65523,186,'Falka - Kalan','306301',1,0,'2022-03-03 12:55:03','2022-03-03 12:55:03'),(65524,186,'Falna  I. E.','306116',1,0,'2022-03-03 12:55:03','2022-03-03 12:55:03'),(65525,186,'Falna','306116',1,0,'2022-03-03 12:55:03','2022-03-03 12:55:03'),(65526,186,'Falna Village','306116',1,0,'2022-03-03 12:55:03','2022-03-03 12:55:03'),(65527,186,'Fattapura','306902',1,0,'2022-03-03 12:55:03','2022-03-03 12:55:03'),(65528,186,'Gadhana','306023',1,0,'2022-03-03 12:55:03','2022-03-03 12:55:03'),(65529,186,'Gadwara','306421',1,0,'2022-03-03 12:55:03','2022-03-03 12:55:03'),(65530,186,'Gajnai','306114',1,0,'2022-03-03 12:55:03','2022-03-03 12:55:03'),(65531,186,'Gajnipura','306502',1,0,'2022-03-03 12:55:03','2022-03-03 12:55:03'),(65532,186,'Garniya','306302',1,0,'2022-03-03 12:55:03','2022-03-03 12:55:03'),(65533,186,'Gelawas','306421',1,0,'2022-03-03 12:55:03','2022-03-03 12:55:03'),(65534,186,'Ghanerao','306704',1,0,'2022-03-03 12:55:03','2022-03-03 12:55:03'),(65535,186,'Ghenri','306502',1,0,'2022-03-03 12:55:03','2022-03-03 12:55:03'),(65536,186,'Ghorawar','306709',1,0,'2022-03-03 12:55:03','2022-03-03 12:55:03'),(65537,186,'Giradra','306401',1,0,'2022-03-03 12:55:03','2022-03-03 12:55:03'),(65538,186,'Giri','306102',1,0,'2022-03-03 12:55:03','2022-03-03 12:55:03'),(65539,186,'Gogra','306912',1,0,'2022-03-03 12:55:04','2022-03-03 12:55:04'),(65540,186,'Goriya','306707',1,0,'2022-03-03 12:55:04','2022-03-03 12:55:04'),(65541,186,'Guda Binja','306114',1,0,'2022-03-03 12:55:04','2022-03-03 12:55:04'),(65542,186,'Guda Endla','306422',1,0,'2022-03-03 12:55:04','2022-03-03 12:55:04'),(65543,186,'Guda Kalan','306103',1,0,'2022-03-03 12:55:04','2022-03-03 12:55:04'),(65544,186,'Guda Kesarsingh','306021',1,0,'2022-03-03 12:55:04','2022-03-03 12:55:04'),(65545,186,'Guda Ramsingh','306021',1,0,'2022-03-03 12:55:04','2022-03-03 12:55:04'),(65546,186,'Guda Soorsingh','306023',1,0,'2022-03-03 12:55:04','2022-03-03 12:55:04'),(65547,186,'Gudalass','306705',1,0,'2022-03-03 12:55:04','2022-03-03 12:55:04'),(65548,186,'Guda-shama','306103',1,0,'2022-03-03 12:55:04','2022-03-03 12:55:04'),(65549,186,'Gundoj','306422',1,0,'2022-03-03 12:55:04','2022-03-03 12:55:04'),(65550,186,'Guriya','306307',1,0,'2022-03-03 12:55:04','2022-03-03 12:55:04'),(65551,186,'Hajiwas','306105',1,0,'2022-03-03 12:55:04','2022-03-03 12:55:04'),(65552,186,'Haripur','306304',1,0,'2022-03-03 12:55:04','2022-03-03 12:55:04'),(65553,186,'Hariyamali','306103',1,0,'2022-03-03 12:55:04','2022-03-03 12:55:04'),(65554,186,'Hemaliyawas Kalan','306001',1,0,'2022-03-03 12:55:04','2022-03-03 12:55:04'),(65555,186,'Hemaliyawas Khurd','306001',1,0,'2022-03-03 12:55:04','2022-03-03 12:55:04'),(65556,186,'Hemawas','306401',1,0,'2022-03-03 12:55:04','2022-03-03 12:55:04'),(65557,186,'Hingawas','306104',1,0,'2022-03-03 12:55:04','2022-03-03 12:55:04'),(65558,186,'Hingola Khurd','306501',1,0,'2022-03-03 12:55:04','2022-03-03 12:55:04'),(65559,186,'Inderwara','306503',1,0,'2022-03-03 12:55:04','2022-03-03 12:55:04'),(65560,186,'Isali','306021',1,0,'2022-03-03 12:55:04','2022-03-03 12:55:04'),(65561,186,'Itendra Charnan','306115',1,0,'2022-03-03 12:55:04','2022-03-03 12:55:04'),(65562,186,'Itendra Mertiyan','306119',1,0,'2022-03-03 12:55:04','2022-03-03 12:55:04'),(65563,186,'Jadan','306401',1,0,'2022-03-03 12:55:04','2022-03-03 12:55:04'),(65564,186,'Jaitaran','306302',1,0,'2022-03-03 12:55:04','2022-03-03 12:55:04'),(65565,186,'Januda','306021',1,0,'2022-03-03 12:55:05','2022-03-03 12:55:05'),(65566,186,'Jawai  Bandh','306126',1,0,'2022-03-03 12:55:05','2022-03-03 12:55:05'),(65567,186,'Jawali','306119',1,0,'2022-03-03 12:55:05','2022-03-03 12:55:05'),(65568,186,'Jeejardi','306103',1,0,'2022-03-03 12:55:05','2022-03-03 12:55:05'),(65569,186,'Jeewand Kalan','306603',1,0,'2022-03-03 12:55:05','2022-03-03 12:55:05'),(65570,186,'Jheetra','306401',1,0,'2022-03-03 12:55:05','2022-03-03 12:55:05'),(65571,186,'Jhoontha','306304',1,0,'2022-03-03 12:55:05','2022-03-03 12:55:05'),(65572,186,'Jhujanda','306302',1,0,'2022-03-03 12:55:05','2022-03-03 12:55:05'),(65573,186,'Jojawar','306022',1,0,'2022-03-03 12:55:05','2022-03-03 12:55:05'),(65574,186,'Kakaradi','306126',1,0,'2022-03-03 12:55:05','2022-03-03 12:55:05'),(65575,186,'Kalab-kalan','306304',1,0,'2022-03-03 12:55:05','2022-03-03 12:55:05'),(65576,186,'Kalali','306421',1,0,'2022-03-03 12:55:05','2022-03-03 12:55:05'),(65577,186,'Kalaliya','306105',1,0,'2022-03-03 12:55:05','2022-03-03 12:55:05'),(65578,186,'Kanpura','306902',1,0,'2022-03-03 12:55:05','2022-03-03 12:55:05'),(65579,186,'Kantaliya','306103',1,0,'2022-03-03 12:55:05','2022-03-03 12:55:05'),(65580,186,'Kanuja','306102',1,0,'2022-03-03 12:55:05','2022-03-03 12:55:05'),(65581,186,'Kanwaliya  Kalan','306301',1,0,'2022-03-03 12:55:05','2022-03-03 12:55:05'),(65582,186,'Karadi','306001',1,0,'2022-03-03 12:55:05','2022-03-03 12:55:05'),(65583,186,'Karmawas Maliyan','306305',1,0,'2022-03-03 12:55:05','2022-03-03 12:55:05'),(65584,186,'Karmawas Patta','306307',1,0,'2022-03-03 12:55:05','2022-03-03 12:55:05'),(65585,186,'Keerwa','306422',1,0,'2022-03-03 12:55:05','2022-03-03 12:55:05'),(65586,186,'Kekindra','306301',1,0,'2022-03-03 12:55:05','2022-03-03 12:55:05'),(65587,186,'Kelwad','306114',1,0,'2022-03-03 12:55:05','2022-03-03 12:55:05'),(65588,186,'Kerla','306401',1,0,'2022-03-03 12:55:05','2022-03-03 12:55:05'),(65589,186,'Kerli','306502',1,0,'2022-03-03 12:55:06','2022-03-03 12:55:06'),(65590,186,'Kesooli','306603',1,0,'2022-03-03 12:55:06','2022-03-03 12:55:06'),(65591,186,'Khairwa','306501',1,0,'2022-03-03 12:55:06','2022-03-03 12:55:06'),(65592,186,'Khandi','306421',1,0,'2022-03-03 12:55:06','2022-03-03 12:55:06'),(65593,186,'Kharachi','306001',1,0,'2022-03-03 12:55:06','2022-03-03 12:55:06'),(65594,186,'Kharadi','306308',1,0,'2022-03-03 12:55:06','2022-03-03 12:55:06'),(65595,186,'Kharda','306603',1,0,'2022-03-03 12:55:06','2022-03-03 12:55:06'),(65596,186,'Kharda','306421',1,0,'2022-03-03 12:55:06','2022-03-03 12:55:06'),(65597,186,'Khardi','306001',1,0,'2022-03-03 12:55:06','2022-03-03 12:55:06'),(65598,186,'Khariya-neev','306104',1,0,'2022-03-03 12:55:06','2022-03-03 12:55:06'),(65599,186,'Khariya-soda','306001',1,0,'2022-03-03 12:55:06','2022-03-03 12:55:06'),(65600,186,'Khatukara','306119',1,0,'2022-03-03 12:55:06','2022-03-03 12:55:06'),(65601,186,'Kheemara','306708',1,0,'2022-03-03 12:55:06','2022-03-03 12:55:06'),(65602,186,'Kheemel','306115',1,0,'2022-03-03 12:55:06','2022-03-03 12:55:06'),(65603,186,'Khinawari','306302',1,0,'2022-03-03 12:55:06','2022-03-03 12:55:06'),(65604,186,'Khinwara','306502',1,0,'2022-03-03 12:55:06','2022-03-03 12:55:06'),(65605,186,'Khiwandi','306901',1,0,'2022-03-03 12:55:06','2022-03-03 12:55:06'),(65606,186,'Khod','306119',1,0,'2022-03-03 12:55:06','2022-03-03 12:55:06'),(65607,186,'Khodiya','306114',1,0,'2022-03-03 12:55:06','2022-03-03 12:55:06'),(65608,186,'Khokhra','306306',1,0,'2022-03-03 12:55:06','2022-03-03 12:55:06'),(65609,186,'Kirana','306105',1,0,'2022-03-03 12:55:06','2022-03-03 12:55:06'),(65610,186,'Kishanpura','306603',1,0,'2022-03-03 12:55:06','2022-03-03 12:55:06'),(65611,186,'Koliwara','306902',1,0,'2022-03-03 12:55:07','2022-03-03 12:55:07'),(65612,186,'Koorna','306422',1,0,'2022-03-03 12:55:07','2022-03-03 12:55:07'),(65613,186,'Korta','306901',1,0,'2022-03-03 12:55:07','2022-03-03 12:55:07'),(65614,186,'Koselao','306708',1,0,'2022-03-03 12:55:07','2022-03-03 12:55:07'),(65615,186,'Kot- Baliyan','306701',1,0,'2022-03-03 12:55:07','2022-03-03 12:55:07'),(65616,186,'Kot- Solankiyan','306022',1,0,'2022-03-03 12:55:07','2022-03-03 12:55:07'),(65617,186,'Kothar','306504',1,0,'2022-03-03 12:55:07','2022-03-03 12:55:07'),(65618,186,'Kotri','306603',1,0,'2022-03-03 12:55:07','2022-03-03 12:55:07'),(65619,186,'Koyalbao','306504',1,0,'2022-03-03 12:55:07','2022-03-03 12:55:07'),(65620,186,'Kulthana','306421',1,0,'2022-03-03 12:55:07','2022-03-03 12:55:07'),(65621,186,'Kumatiya','306504',1,0,'2022-03-03 12:55:07','2022-03-03 12:55:07'),(65622,186,'Kurki','306101',1,0,'2022-03-03 12:55:07','2022-03-03 12:55:07'),(65623,186,'Kushalpura','306305',1,0,'2022-03-03 12:55:07','2022-03-03 12:55:07'),(65624,186,'Lalrai','306705',1,0,'2022-03-03 12:55:07','2022-03-03 12:55:07'),(65625,186,'Lambiya','306301',1,0,'2022-03-03 12:55:07','2022-03-03 12:55:07'),(65626,186,'Lambiya','306501',1,0,'2022-03-03 12:55:07','2022-03-03 12:55:07'),(65627,186,'Lapod','306115',1,0,'2022-03-03 12:55:07','2022-03-03 12:55:07'),(65628,186,'Latara','306705',1,0,'2022-03-03 12:55:07','2022-03-03 12:55:07'),(65629,186,'Leelamba','306305',1,0,'2022-03-03 12:55:07','2022-03-03 12:55:07'),(65630,186,'Lototi','306302',1,0,'2022-03-03 12:55:07','2022-03-03 12:55:07'),(65631,186,'Lunawa','306706',1,0,'2022-03-03 12:55:07','2022-03-03 12:55:07'),(65632,186,'Mada','306702',1,0,'2022-03-03 12:55:07','2022-03-03 12:55:07'),(65633,186,'Magartalab','306502',1,0,'2022-03-03 12:55:07','2022-03-03 12:55:07'),(65634,186,'Malnoo','306504',1,0,'2022-03-03 12:55:07','2022-03-03 12:55:07'),(65635,186,'Malsabaori','306023',1,0,'2022-03-03 12:55:07','2022-03-03 12:55:07'),(65636,186,'Manda','306103',1,0,'2022-03-03 12:55:08','2022-03-03 12:55:08'),(65637,186,'Mandal','306115',1,0,'2022-03-03 12:55:08','2022-03-03 12:55:08'),(65638,186,'Mandawas','306421',1,0,'2022-03-03 12:55:08','2022-03-03 12:55:08'),(65639,186,'Mandigarh','306702',1,0,'2022-03-03 12:55:08','2022-03-03 12:55:08'),(65640,186,'Mandiya','306401',1,0,'2022-03-03 12:55:08','2022-03-03 12:55:08'),(65641,186,'Mandla','306104',1,0,'2022-03-03 12:55:08','2022-03-03 12:55:08'),(65642,186,'Manihari','306401',1,0,'2022-03-03 12:55:08','2022-03-03 12:55:08'),(65643,186,'Marwar Jn. H.O','306001',1,0,'2022-03-03 12:55:08','2022-03-03 12:55:08'),(65644,186,'Meo','306104',1,0,'2022-03-03 12:55:08','2022-03-03 12:55:08'),(65645,186,'Mesiya','306105',1,0,'2022-03-03 12:55:08','2022-03-03 12:55:08'),(65646,186,'Mirgesar','306706',1,0,'2022-03-03 12:55:08','2022-03-03 12:55:08'),(65647,186,'Mohra - Kalan','306307',1,0,'2022-03-03 12:55:08','2022-03-03 12:55:08'),(65648,186,'Mohrai','306303',1,0,'2022-03-03 12:55:08','2022-03-03 12:55:08'),(65649,186,'Mokampura','306115',1,0,'2022-03-03 12:55:08','2022-03-03 12:55:08'),(65650,186,'Mori Bera','306126',1,0,'2022-03-03 12:55:08','2022-03-03 12:55:08'),(65651,186,'Morkha','306705',1,0,'2022-03-03 12:55:08','2022-03-03 12:55:08'),(65652,186,'Mundara','306705',1,0,'2022-03-03 12:55:08','2022-03-03 12:55:08'),(65653,186,'Murdawa','306306',1,0,'2022-03-03 12:55:08','2022-03-03 12:55:08'),(65654,186,'Musaliya','306103',1,0,'2022-03-03 12:55:08','2022-03-03 12:55:08'),(65655,186,'Nadana-bhatan','306119',1,0,'2022-03-03 12:55:08','2022-03-03 12:55:08'),(65656,186,'Nadol','306603',1,0,'2022-03-03 12:55:08','2022-03-03 12:55:08'),(65657,186,'Nana','306504',1,0,'2022-03-03 12:55:08','2022-03-03 12:55:08'),(65658,186,'Nanana','306102',1,0,'2022-03-03 12:55:08','2022-03-03 12:55:08'),(65659,186,'Narlai','306703',1,0,'2022-03-03 12:55:08','2022-03-03 12:55:08'),(65660,186,'Neembara','306503',1,0,'2022-03-03 12:55:09','2022-03-03 12:55:09'),(65661,186,'Neembli- Manda','306103',1,0,'2022-03-03 12:55:09','2022-03-03 12:55:09'),(65662,186,'Neembli-uran','306401',1,0,'2022-03-03 12:55:09','2022-03-03 12:55:09'),(65663,186,'Neepal','306603',1,0,'2022-03-03 12:55:09','2022-03-03 12:55:09'),(65664,186,'Netra','306902',1,0,'2022-03-03 12:55:09','2022-03-03 12:55:09'),(65665,186,'Nimaj','306303',1,0,'2022-03-03 12:55:09','2022-03-03 12:55:09'),(65666,186,'Nimbera- Kalan','306305',1,0,'2022-03-03 12:55:09','2022-03-03 12:55:09'),(65667,186,'Nimbol','306308',1,0,'2022-03-03 12:55:09','2022-03-03 12:55:09'),(65668,186,'Novi','306901',1,0,'2022-03-03 12:55:09','2022-03-03 12:55:09'),(65669,186,'Pachanpura','306304',1,0,'2022-03-03 12:55:09','2022-03-03 12:55:09'),(65670,186,'Pachunda - Kalan','306114',1,0,'2022-03-03 12:55:09','2022-03-03 12:55:09'),(65671,186,'Padarla','306707',1,0,'2022-03-03 12:55:09','2022-03-03 12:55:09'),(65672,186,'Pali  Housing Board','306401',1,0,'2022-03-03 12:55:09','2022-03-03 12:55:09'),(65673,186,'Pali City','306401',1,0,'2022-03-03 12:55:09','2022-03-03 12:55:09'),(65674,186,'Pali Industrial Estate','306401',1,0,'2022-03-03 12:55:09','2022-03-03 12:55:09'),(65675,186,'Pali Kutchery','306401',1,0,'2022-03-03 12:55:09','2022-03-03 12:55:09'),(65676,186,'Pali M.R.I.A','306401',1,0,'2022-03-03 12:55:09','2022-03-03 12:55:09'),(65677,186,'Pali Marwar H.O','306401',1,0,'2022-03-03 12:55:09','2022-03-03 12:55:09'),(65678,186,'Pali Railway Station','306401',1,0,'2022-03-03 12:55:09','2022-03-03 12:55:09'),(65679,186,'Pali Suraj Pole','306401',1,0,'2022-03-03 12:55:09','2022-03-03 12:55:09'),(65680,186,'Pali Veer Durgadas  Nagar','306401',1,0,'2022-03-03 12:55:09','2022-03-03 12:55:09'),(65681,186,'Palri-jod','306902',1,0,'2022-03-03 12:55:09','2022-03-03 12:55:09'),(65682,186,'Panchalwara','306705',1,0,'2022-03-03 12:55:09','2022-03-03 12:55:09'),(65683,186,'Panchetiya','306503',1,0,'2022-03-03 12:55:09','2022-03-03 12:55:09'),(65684,186,'Panota','306022',1,0,'2022-03-03 12:55:10','2022-03-03 12:55:10'),(65685,186,'Patwa','306302',1,0,'2022-03-03 12:55:10','2022-03-03 12:55:10'),(65686,186,'Pawa','306708',1,0,'2022-03-03 12:55:10','2022-03-03 12:55:10'),(65687,186,'Perwa','306126',1,0,'2022-03-03 12:55:10','2022-03-03 12:55:10'),(65688,186,'Phoolmal','306302',1,0,'2022-03-03 12:55:10','2022-03-03 12:55:10'),(65689,186,'Phulad','306023',1,0,'2022-03-03 12:55:10','2022-03-03 12:55:10'),(65690,186,'Pilowani','306502',1,0,'2022-03-03 12:55:10','2022-03-03 12:55:10'),(65691,186,'Piplad','306114',1,0,'2022-03-03 12:55:10','2022-03-03 12:55:10'),(65692,186,'Pipliya Kalan','306307',1,0,'2022-03-03 12:55:10','2022-03-03 12:55:10'),(65693,186,'Pomawa','306902',1,0,'2022-03-03 12:55:10','2022-03-03 12:55:10'),(65694,186,'Pratap - Garh','306101',1,0,'2022-03-03 12:55:10','2022-03-03 12:55:10'),(65695,186,'Prithviraj Ka Gurha','306603',1,0,'2022-03-03 12:55:10','2022-03-03 12:55:10'),(65696,186,'Rabriyawas','306709',1,0,'2022-03-03 12:55:10','2022-03-03 12:55:10'),(65697,186,'Radawas','306023',1,0,'2022-03-03 12:55:10','2022-03-03 12:55:10'),(65698,186,'Raipur  Marwar','306304',1,0,'2022-03-03 12:55:10','2022-03-03 12:55:10'),(65699,186,'Raipuriya','306502',1,0,'2022-03-03 12:55:10','2022-03-03 12:55:10'),(65700,186,'Raira Kalan','306307',1,0,'2022-03-03 12:55:10','2022-03-03 12:55:10'),(65701,186,'Rajadand','306302',1,0,'2022-03-03 12:55:10','2022-03-03 12:55:10'),(65702,186,'Rajola - Kalan','306104',1,0,'2022-03-03 12:55:10','2022-03-03 12:55:10'),(65703,186,'Rajola - Khurd','306103',1,0,'2022-03-03 12:55:10','2022-03-03 12:55:10'),(65704,186,'Ramasani - Bala','306104',1,0,'2022-03-03 12:55:10','2022-03-03 12:55:10'),(65705,186,'Ramawas','306302',1,0,'2022-03-03 12:55:10','2022-03-03 12:55:10'),(65706,186,'Rampura - Kalan','306306',1,0,'2022-03-03 12:55:10','2022-03-03 12:55:10'),(65707,186,'Rana','306401',1,0,'2022-03-03 12:55:11','2022-03-03 12:55:11'),(65708,186,'Ranakpur','306702',1,0,'2022-03-03 12:55:11','2022-03-03 12:55:11'),(65709,186,'Ranawas','306023',1,0,'2022-03-03 12:55:11','2022-03-03 12:55:11'),(65710,186,'Rani Gaon','306115',1,0,'2022-03-03 12:55:11','2022-03-03 12:55:11'),(65711,186,'Rani (Pali)','306115',1,0,'2022-03-03 12:55:11','2022-03-03 12:55:11'),(65712,186,'Rani Sadar Bazar','306115',1,0,'2022-03-03 12:55:11','2022-03-03 12:55:11'),(65713,186,'Raniwal','306302',1,0,'2022-03-03 12:55:11','2022-03-03 12:55:11'),(65714,186,'Ras','306101',1,0,'2022-03-03 12:55:11','2022-03-03 12:55:11'),(65715,186,'Ratadiya','306102',1,0,'2022-03-03 12:55:11','2022-03-03 12:55:11'),(65716,186,'Relra','306102',1,0,'2022-03-03 12:55:11','2022-03-03 12:55:11'),(65717,186,'Rendri','306103',1,0,'2022-03-03 12:55:11','2022-03-03 12:55:11'),(65718,186,'Reprawas','306104',1,0,'2022-03-03 12:55:11','2022-03-03 12:55:11'),(65719,186,'Rohat R.S.','306421',1,0,'2022-03-03 12:55:11','2022-03-03 12:55:11'),(65720,186,'Rohat (Pali)','306421',1,0,'2022-03-03 12:55:11','2022-03-03 12:55:11'),(65721,186,'Roopawas','306104',1,0,'2022-03-03 12:55:11','2022-03-03 12:55:11'),(65722,186,'Rupawas','306401',1,0,'2022-03-03 12:55:11','2022-03-03 12:55:11'),(65723,186,'Sabalpura','306307',1,0,'2022-03-03 12:55:11','2022-03-03 12:55:11'),(65724,186,'Sadri','306702',1,0,'2022-03-03 12:55:11','2022-03-03 12:55:11'),(65725,186,'Saleriya','306119',1,0,'2022-03-03 12:55:11','2022-03-03 12:55:11'),(65726,186,'Sanderao','306708',1,0,'2022-03-03 12:55:11','2022-03-03 12:55:11'),(65727,186,'Sandiya','306306',1,0,'2022-03-03 12:55:11','2022-03-03 12:55:11'),(65728,186,'Sangawas','306303',1,0,'2022-03-03 12:55:11','2022-03-03 12:55:11'),(65729,186,'Sansari','306022',1,0,'2022-03-03 12:55:11','2022-03-03 12:55:11'),(65730,186,'Sanwalta','306603',1,0,'2022-03-03 12:55:11','2022-03-03 12:55:11'),(65731,186,'Sapooni','306501',1,0,'2022-03-03 12:55:11','2022-03-03 12:55:11'),(65732,186,'Saran','306023',1,0,'2022-03-03 12:55:12','2022-03-03 12:55:12'),(65733,186,'Sardar-samand','306401',1,0,'2022-03-03 12:55:12','2022-03-03 12:55:12'),(65734,186,'Sawrad','306103',1,0,'2022-03-03 12:55:12','2022-03-03 12:55:12'),(65735,186,'Seeriyari','306023',1,0,'2022-03-03 12:55:12','2022-03-03 12:55:12'),(65736,186,'Seesarwada','306103',1,0,'2022-03-03 12:55:12','2022-03-03 12:55:12'),(65737,186,'Sehwaj','306103',1,0,'2022-03-03 12:55:12','2022-03-03 12:55:12'),(65738,186,'Sela','306701',1,0,'2022-03-03 12:55:12','2022-03-03 12:55:12'),(65739,186,'Sena','306707',1,0,'2022-03-03 12:55:12','2022-03-03 12:55:12'),(65740,186,'Sendra','306102',1,0,'2022-03-03 12:55:12','2022-03-03 12:55:12'),(65741,186,'Sesli','306706',1,0,'2022-03-03 12:55:12','2022-03-03 12:55:12'),(65742,186,'Sewari','306707',1,0,'2022-03-03 12:55:12','2022-03-03 12:55:12'),(65743,186,'Sewariya','306101',1,0,'2022-03-03 12:55:12','2022-03-03 12:55:12'),(65744,186,'Shekhawas','306103',1,0,'2022-03-03 12:55:12','2022-03-03 12:55:12'),(65745,186,'Sheotalao','306705',1,0,'2022-03-03 12:55:12','2022-03-03 12:55:12'),(65746,186,'Shivpura','306104',1,0,'2022-03-03 12:55:12','2022-03-03 12:55:12'),(65747,186,'Sindharli','306702',1,0,'2022-03-03 12:55:12','2022-03-03 12:55:12'),(65748,186,'Sindru','306708',1,0,'2022-03-03 12:55:12','2022-03-03 12:55:12'),(65749,186,'Sinla','306308',1,0,'2022-03-03 12:55:12','2022-03-03 12:55:12'),(65750,186,'Sinla','306001',1,0,'2022-03-03 12:55:12','2022-03-03 12:55:12'),(65751,186,'Siwas','306502',1,0,'2022-03-03 12:55:12','2022-03-03 12:55:12'),(65752,186,'Siyat','306103',1,0,'2022-03-03 12:55:12','2022-03-03 12:55:12'),(65753,186,'Sodawas','306503',1,0,'2022-03-03 12:55:12','2022-03-03 12:55:12'),(65754,186,'Sojat  Road','306103',1,0,'2022-03-03 12:55:13','2022-03-03 12:55:13'),(65755,186,'Sojat Bazar','306104',1,0,'2022-03-03 12:55:13','2022-03-03 12:55:13'),(65756,186,'Sojat','306104',1,0,'2022-03-03 12:55:13','2022-03-03 12:55:13'),(65757,186,'Somesar','306503',1,0,'2022-03-03 12:55:13','2022-03-03 12:55:13'),(65758,186,'Sonai Manji','306401',1,0,'2022-03-03 12:55:13','2022-03-03 12:55:13'),(65759,186,'Sumel','306101',1,0,'2022-03-03 12:55:13','2022-03-03 12:55:13'),(65760,186,'Sumer','306703',1,0,'2022-03-03 12:55:13','2022-03-03 12:55:13'),(65761,186,'Sumerpur Krishi Upaj Mandi','306902',1,0,'2022-03-03 12:55:13','2022-03-03 12:55:13'),(65762,186,'Sumerpur','306902',1,0,'2022-03-03 12:55:13','2022-03-03 12:55:13'),(65763,186,'Surayta','306104',1,0,'2022-03-03 12:55:13','2022-03-03 12:55:13'),(65764,186,'Tagatgarh','306912',1,0,'2022-03-03 12:55:13','2022-03-03 12:55:13'),(65765,186,'Talkiya','306302',1,0,'2022-03-03 12:55:13','2022-03-03 12:55:13'),(65766,186,'Tewali','306503',1,0,'2022-03-03 12:55:13','2022-03-03 12:55:13'),(65767,186,'Thakurla','306503',1,0,'2022-03-03 12:55:13','2022-03-03 12:55:13'),(65768,186,'Thakurwas','306023',1,0,'2022-03-03 12:55:13','2022-03-03 12:55:13'),(65769,186,'Toonkra','306102',1,0,'2022-03-03 12:55:13','2022-03-03 12:55:13'),(65770,186,'Varkana','306601',1,0,'2022-03-03 12:55:13','2022-03-03 12:55:13'),(65771,186,'Vidhyawari','306115',1,0,'2022-03-03 12:55:13','2022-03-03 12:55:13'),(65772,186,'Wandar','306502',1,0,'2022-03-03 12:55:13','2022-03-03 12:55:13'),(65773,187,'Biliyawas','305922',1,0,'2022-03-03 12:55:13','2022-03-03 12:55:13'),(65774,187,'Dunger Khera','305922',1,0,'2022-03-03 12:55:13','2022-03-03 12:55:13'),(65775,187,'Laget Khera','305925',1,0,'2022-03-03 12:55:13','2022-03-03 12:55:13'),(65776,187,'Saroth','305922',1,0,'2022-03-03 12:55:13','2022-03-03 12:55:13'),(65777,187,'Aagaria','313332',1,0,'2022-03-03 12:55:13','2022-03-03 12:55:13'),(65778,187,'Aidana','313334',1,0,'2022-03-03 12:55:13','2022-03-03 12:55:13'),(65779,187,'Ajitgarh','305921',1,0,'2022-03-03 12:55:13','2022-03-03 12:55:13'),(65780,187,'Akodara','313323',1,0,'2022-03-03 12:55:14','2022-03-03 12:55:14'),(65781,187,'Anjana','313331',1,0,'2022-03-03 12:55:14','2022-03-03 12:55:14'),(65782,187,'Antalia','313334',1,0,'2022-03-03 12:55:14','2022-03-03 12:55:14'),(65783,187,'Antri','313325',1,0,'2022-03-03 12:55:14','2022-03-03 12:55:14'),(65784,187,'Atma','313334',1,0,'2022-03-03 12:55:14','2022-03-03 12:55:14'),(65785,187,'B K Kalwana','313704',1,0,'2022-03-03 12:55:14','2022-03-03 12:55:14'),(65786,187,'Badrada','313324',1,0,'2022-03-03 12:55:14','2022-03-03 12:55:14'),(65787,187,'Bagana','313331',1,0,'2022-03-03 12:55:14','2022-03-03 12:55:14'),(65788,187,'Baggad','313341',1,0,'2022-03-03 12:55:14','2022-03-03 12:55:14'),(65789,187,'Bagol','313301',1,0,'2022-03-03 12:55:14','2022-03-03 12:55:14'),(65790,187,'Balicha','313322',1,0,'2022-03-03 12:55:14','2022-03-03 12:55:14'),(65791,187,'Balli Ijassa Kheda','305921',1,0,'2022-03-03 12:55:14','2022-03-03 12:55:14'),(65792,187,'Bamanhera','313323',1,0,'2022-03-03 12:55:14','2022-03-03 12:55:14'),(65793,187,'Bamnia Kalan','313329',1,0,'2022-03-03 12:55:14','2022-03-03 12:55:14'),(65794,187,'Banerian','313329',1,0,'2022-03-03 12:55:14','2022-03-03 12:55:14'),(65795,187,'Bankora','313325',1,0,'2022-03-03 12:55:14','2022-03-03 12:55:14'),(65796,187,'Bansa','313333',1,0,'2022-03-03 12:55:14','2022-03-03 12:55:14'),(65797,187,'Baradara','313325',1,0,'2022-03-03 12:55:14','2022-03-03 12:55:14'),(65798,187,'Barar','313341',1,0,'2022-03-03 12:55:14','2022-03-03 12:55:14'),(65799,187,'Barjal','313331',1,0,'2022-03-03 12:55:14','2022-03-03 12:55:14'),(65800,187,'Bhada Bhanuja','313321',1,0,'2022-03-03 12:55:14','2022-03-03 12:55:14'),(65801,187,'Bhana','313324',1,0,'2022-03-03 12:55:14','2022-03-03 12:55:14'),(65802,187,'Bhanpura','313704',1,0,'2022-03-03 12:55:14','2022-03-03 12:55:14'),(65803,187,'Bhatoli','313342',1,0,'2022-03-03 12:55:15','2022-03-03 12:55:15'),(65804,187,'Bhawa','313324',1,0,'2022-03-03 12:55:15','2022-03-03 12:55:15'),(65805,187,'Bhensa Kamed','313321',1,0,'2022-03-03 12:55:15','2022-03-03 12:55:15'),(65806,187,'Bhim','305921',1,0,'2022-03-03 12:55:15','2022-03-03 12:55:15'),(65807,187,'Bijnol','313323',1,0,'2022-03-03 12:55:15','2022-03-03 12:55:15'),(65808,187,'Bikawas','313332',1,0,'2022-03-03 12:55:15','2022-03-03 12:55:15'),(65809,187,'Bilota','313202',1,0,'2022-03-03 12:55:15','2022-03-03 12:55:15'),(65810,187,'Binol','313327',1,0,'2022-03-03 12:55:15','2022-03-03 12:55:15'),(65811,187,'Bokhada','313704',1,0,'2022-03-03 12:55:15','2022-03-03 12:55:15'),(65812,187,'Boraj','313324',1,0,'2022-03-03 12:55:15','2022-03-03 12:55:15'),(65813,187,'Charana','313211',1,0,'2022-03-03 12:55:15','2022-03-03 12:55:15'),(65814,187,'Charbhuja Road','313332',1,0,'2022-03-03 12:55:15','2022-03-03 12:55:15'),(65815,187,'Charbhuja','313333',1,0,'2022-03-03 12:55:15','2022-03-03 12:55:15'),(65816,187,'Chhaplian','313331',1,0,'2022-03-03 12:55:15','2022-03-03 12:55:15'),(65817,187,'Chirwa','313202',1,0,'2022-03-03 12:55:15','2022-03-03 12:55:15'),(65818,187,'Chowkdi','313329',1,0,'2022-03-03 12:55:15','2022-03-03 12:55:15'),(65819,187,'Dansaria','305921',1,0,'2022-03-03 12:55:15','2022-03-03 12:55:15'),(65820,187,'Dariba','313211',1,0,'2022-03-03 12:55:15','2022-03-03 12:55:15'),(65821,187,'Daver','313331',1,0,'2022-03-03 12:55:15','2022-03-03 12:55:15'),(65822,187,'Delwara','313202',1,0,'2022-03-03 12:55:15','2022-03-03 12:55:15'),(65823,187,'Deogarh (Rajsamand)','313331',1,0,'2022-03-03 12:55:15','2022-03-03 12:55:15'),(65824,187,'Dhaneen','313334',1,0,'2022-03-03 12:55:15','2022-03-03 12:55:15'),(65825,187,'Dhaneria','313206',1,0,'2022-03-03 12:55:15','2022-03-03 12:55:15'),(65826,187,'Dhanyla','313334',1,0,'2022-03-03 12:55:15','2022-03-03 12:55:15'),(65827,187,'Dhayla','313301',1,0,'2022-03-03 12:55:15','2022-03-03 12:55:15'),(65828,187,'Dhoinda','313342',1,0,'2022-03-03 12:55:16','2022-03-03 12:55:16'),(65829,187,'Diyan','313704',1,0,'2022-03-03 12:55:16','2022-03-03 12:55:16'),(65830,187,'Dowra','313330',1,0,'2022-03-03 12:55:16','2022-03-03 12:55:16'),(65831,187,'Emdi','313342',1,0,'2022-03-03 12:55:16','2022-03-03 12:55:16'),(65832,187,'Galwa','313327',1,0,'2022-03-03 12:55:16','2022-03-03 12:55:16'),(65833,187,'Ganawal','313704',1,0,'2022-03-03 12:55:16','2022-03-03 12:55:16'),(65834,187,'Gawaardi','313211',1,0,'2022-03-03 12:55:16','2022-03-03 12:55:16'),(65835,187,'Ghata','313324',1,0,'2022-03-03 12:55:16','2022-03-03 12:55:16'),(65836,187,'Gilund','313207',1,0,'2022-03-03 12:55:16','2022-03-03 12:55:16'),(65837,187,'Goanguda','313321',1,0,'2022-03-03 12:55:16','2022-03-03 12:55:16'),(65838,187,'Godhaji Ja Gaon','305921',1,0,'2022-03-03 12:55:16','2022-03-03 12:55:16'),(65839,187,'Gogathala','313328',1,0,'2022-03-03 12:55:16','2022-03-03 12:55:16'),(65840,187,'Gosundi','313332',1,0,'2022-03-03 12:55:16','2022-03-03 12:55:16'),(65841,187,'Goval','313332',1,0,'2022-03-03 12:55:16','2022-03-03 12:55:16'),(65842,187,'Gunjol','313301',1,0,'2022-03-03 12:55:16','2022-03-03 12:55:16'),(65843,187,'Hamelon Ki Bar','313341',1,0,'2022-03-03 12:55:16','2022-03-03 12:55:16'),(65844,187,'Isharmand','313331',1,0,'2022-03-03 12:55:16','2022-03-03 12:55:16'),(65845,187,'Janawad','313333',1,0,'2022-03-03 12:55:16','2022-03-03 12:55:16'),(65846,187,'Jeeran','313332',1,0,'2022-03-03 12:55:16','2022-03-03 12:55:16'),(65847,187,'Jemli','313704',1,0,'2022-03-03 12:55:16','2022-03-03 12:55:16'),(65848,187,'Jetpura','313327',1,0,'2022-03-03 12:55:16','2022-03-03 12:55:16'),(65849,187,'Jewana','313206',1,0,'2022-03-03 12:55:16','2022-03-03 12:55:16'),(65850,187,'Jhalon Ki Madar','313321',1,0,'2022-03-03 12:55:16','2022-03-03 12:55:16'),(65851,187,'Jhanjhar','313334',1,0,'2022-03-03 12:55:16','2022-03-03 12:55:16'),(65852,187,'Jhilwara','313333',1,0,'2022-03-03 12:55:16','2022-03-03 12:55:16'),(65853,187,'Jhor','313327',1,0,'2022-03-03 12:55:17','2022-03-03 12:55:17'),(65854,187,'Jilola','313330',1,0,'2022-03-03 12:55:17','2022-03-03 12:55:17'),(65855,187,'Jitawas','313328',1,0,'2022-03-03 12:55:17','2022-03-03 12:55:17'),(65856,187,'Junda','313328',1,0,'2022-03-03 12:55:17','2022-03-03 12:55:17'),(65857,187,'Kabra','313211',1,0,'2022-03-03 12:55:17','2022-03-03 12:55:17'),(65858,187,'Kachhabali','313341',1,0,'2022-03-03 12:55:17','2022-03-03 12:55:17'),(65859,187,'Kadia','313325',1,0,'2022-03-03 12:55:17','2022-03-03 12:55:17'),(65860,187,'Kadmal','313322',1,0,'2022-03-03 12:55:17','2022-03-03 12:55:17'),(65861,187,'Kailashpuri','313202',1,0,'2022-03-03 12:55:17','2022-03-03 12:55:17'),(65862,187,'Kakrod','313331',1,0,'2022-03-03 12:55:17','2022-03-03 12:55:17'),(65863,187,'Kaladeh','305921',1,0,'2022-03-03 12:55:17','2022-03-03 12:55:17'),(65864,187,'Kalaguman','313333',1,0,'2022-03-03 12:55:17','2022-03-03 12:55:17'),(65865,187,'Kalesaria','313331',1,0,'2022-03-03 12:55:17','2022-03-03 12:55:17'),(65866,187,'Kalinjar','313324',1,0,'2022-03-03 12:55:17','2022-03-03 12:55:17'),(65867,187,'Kaliwas','313202',1,0,'2022-03-03 12:55:17','2022-03-03 12:55:17'),(65868,187,'Kamol','313704',1,0,'2022-03-03 12:55:17','2022-03-03 12:55:17'),(65869,187,'Kankroli H.O','313324',1,0,'2022-03-03 12:55:17','2022-03-03 12:55:17'),(65870,187,'Kankrwa','313325',1,0,'2022-03-03 12:55:17','2022-03-03 12:55:17'),(65871,187,'Kanooja','313325',1,0,'2022-03-03 12:55:17','2022-03-03 12:55:17'),(65872,187,'Karoli','313301',1,0,'2022-03-03 12:55:17','2022-03-03 12:55:17'),(65873,187,'Kelwa (Rajsamand)','313334',1,0,'2022-03-03 12:55:18','2022-03-03 12:55:18'),(65874,187,'Kelwara','313325',1,0,'2022-03-03 12:55:18','2022-03-03 12:55:18'),(65875,187,'Kesar','313325',1,0,'2022-03-03 12:55:18','2022-03-03 12:55:18'),(65876,187,'Kessuli','313301',1,0,'2022-03-03 12:55:18','2022-03-03 12:55:18'),(65877,187,'Khad Bamnia','313207',1,0,'2022-03-03 12:55:18','2022-03-03 12:55:18'),(65878,187,'Khakharmala','313332',1,0,'2022-03-03 12:55:18','2022-03-03 12:55:18'),(65879,187,'Khamlighat','313331',1,0,'2022-03-03 12:55:18','2022-03-03 12:55:18'),(65880,187,'Khamnore','313322',1,0,'2022-03-03 12:55:18','2022-03-03 12:55:18'),(65881,187,'Khandel','313328',1,0,'2022-03-03 12:55:18','2022-03-03 12:55:18'),(65882,187,'Kharnota','313333',1,0,'2022-03-03 12:55:18','2022-03-03 12:55:18'),(65883,187,'Khartana','313206',1,0,'2022-03-03 12:55:18','2022-03-03 12:55:18'),(65884,187,'Khatmala','313334',1,0,'2022-03-03 12:55:18','2022-03-03 12:55:18'),(65885,187,'Kkundia','313207',1,0,'2022-03-03 12:55:18','2022-03-03 12:55:18'),(65886,187,'Koaria','313327',1,0,'2022-03-03 12:55:18','2022-03-03 12:55:18'),(65887,187,'Koshiwara','313321',1,0,'2022-03-03 12:55:18','2022-03-03 12:55:18'),(65888,187,'Kotharia (Rajsamand)','313323',1,0,'2022-03-03 12:55:18','2022-03-03 12:55:18'),(65889,187,'Kotri','313211',1,0,'2022-03-03 12:55:18','2022-03-03 12:55:18'),(65890,187,'Koyal','313324',1,0,'2022-03-03 12:55:18','2022-03-03 12:55:18'),(65891,187,'Kuanthal','313332',1,0,'2022-03-03 12:55:18','2022-03-03 12:55:18'),(65892,187,'Kukar Khera','305921',1,0,'2022-03-03 12:55:18','2022-03-03 12:55:18'),(65893,187,'Kukra','305921',1,0,'2022-03-03 12:55:18','2022-03-03 12:55:18'),(65894,187,'Kuncholi','313325',1,0,'2022-03-03 12:55:18','2022-03-03 12:55:18'),(65895,187,'Kundwa','313331',1,0,'2022-03-03 12:55:18','2022-03-03 12:55:18'),(65896,187,'Kunthwa','313301',1,0,'2022-03-03 12:55:19','2022-03-03 12:55:19'),(65897,187,'Kuraj','313328',1,0,'2022-03-03 12:55:19','2022-03-03 12:55:19'),(65898,187,'Lakha Guda','313341',1,0,'2022-03-03 12:55:19','2022-03-03 12:55:19'),(65899,187,'Lal Madri','313301',1,0,'2022-03-03 12:55:19','2022-03-03 12:55:19'),(65900,187,'Lambodi','313333',1,0,'2022-03-03 12:55:19','2022-03-03 12:55:19'),(65901,187,'Lapsia','313328',1,0,'2022-03-03 12:55:19','2022-03-03 12:55:19'),(65902,187,'Lasani','313331',1,0,'2022-03-03 12:55:19','2022-03-03 12:55:19'),(65903,187,'Lawa Sardargarh','313330',1,0,'2022-03-03 12:55:19','2022-03-03 12:55:19'),(65904,187,'Liki','313332',1,0,'2022-03-03 12:55:19','2022-03-03 12:55:19'),(65905,187,'Lodiyana','313330',1,0,'2022-03-03 12:55:19','2022-03-03 12:55:19'),(65906,187,'Machind','313321',1,0,'2022-03-03 12:55:19','2022-03-03 12:55:19'),(65907,187,'Mad','313332',1,0,'2022-03-03 12:55:19','2022-03-03 12:55:19'),(65908,187,'Madaria','313331',1,0,'2022-03-03 12:55:19','2022-03-03 12:55:19'),(65909,187,'Mahalon Ki Pipli','313324',1,0,'2022-03-03 12:55:19','2022-03-03 12:55:19'),(65910,187,'Maja','313323',1,0,'2022-03-03 12:55:19','2022-03-03 12:55:19'),(65911,187,'Majera','313325',1,0,'2022-03-03 12:55:19','2022-03-03 12:55:19'),(65912,187,'Manakwas','313202',1,0,'2022-03-03 12:55:19','2022-03-03 12:55:19'),(65913,187,'Manawaton Ka Guda','313333',1,0,'2022-03-03 12:55:19','2022-03-03 12:55:19'),(65914,187,'Mandawar','313341',1,0,'2022-03-03 12:55:19','2022-03-03 12:55:19'),(65915,187,'Mandiyana','313301',1,0,'2022-03-03 12:55:19','2022-03-03 12:55:19'),(65916,187,'Masatiyon Ki Madri','313324',1,0,'2022-03-03 12:55:19','2022-03-03 12:55:19'),(65917,187,'Merda Khalsa','313334',1,0,'2022-03-03 12:55:19','2022-03-03 12:55:19'),(65918,187,'Miyala','313341',1,0,'2022-03-03 12:55:19','2022-03-03 12:55:19'),(65919,187,'Mohi','313324',1,0,'2022-03-03 12:55:19','2022-03-03 12:55:19'),(65920,187,'Molela','313322',1,0,'2022-03-03 12:55:20','2022-03-03 12:55:20'),(65921,187,'Morath','313206',1,0,'2022-03-03 12:55:20','2022-03-03 12:55:20'),(65922,187,'Morcha','313321',1,0,'2022-03-03 12:55:20','2022-03-03 12:55:20'),(65923,187,'Mundol','313324',1,0,'2022-03-03 12:55:20','2022-03-03 12:55:20'),(65924,187,'Namana','313323',1,0,'2022-03-03 12:55:20','2022-03-03 12:55:20'),(65925,187,'Nanana','313332',1,0,'2022-03-03 12:55:20','2022-03-03 12:55:20'),(65926,187,'Naogama','313342',1,0,'2022-03-03 12:55:20','2022-03-03 12:55:20'),(65927,187,'Narana','313332',1,0,'2022-03-03 12:55:20','2022-03-03 12:55:20'),(65928,187,'Nardaska Guda','313331',1,0,'2022-03-03 12:55:20','2022-03-03 12:55:20'),(65929,187,'Nathdwara Chaupati','313301',1,0,'2022-03-03 12:55:20','2022-03-03 12:55:20'),(65930,187,'Nathdwara','313301',1,0,'2022-03-03 12:55:20','2022-03-03 12:55:20'),(65931,187,'Negadia','313202',1,0,'2022-03-03 12:55:20','2022-03-03 12:55:20'),(65932,187,'Oda','313325',1,0,'2022-03-03 12:55:20','2022-03-03 12:55:20'),(65933,187,'Odan','313301',1,0,'2022-03-03 12:55:20','2022-03-03 12:55:20'),(65934,187,'Olanakhera','313330',1,0,'2022-03-03 12:55:20','2022-03-03 12:55:20'),(65935,187,'Pachhamata','313207',1,0,'2022-03-03 12:55:20','2022-03-03 12:55:20'),(65936,187,'Padasali','313334',1,0,'2022-03-03 12:55:20','2022-03-03 12:55:20'),(65937,187,'Padrada','313704',1,0,'2022-03-03 12:55:20','2022-03-03 12:55:20'),(65938,187,'Pakhand','313323',1,0,'2022-03-03 12:55:20','2022-03-03 12:55:20'),(65939,187,'Palasma','313704',1,0,'2022-03-03 12:55:20','2022-03-03 12:55:20'),(65940,187,'Panotia','313207',1,0,'2022-03-03 12:55:20','2022-03-03 12:55:20'),(65941,187,'Panotia','313330',1,0,'2022-03-03 12:55:20','2022-03-03 12:55:20'),(65942,187,'Pardi','313331',1,0,'2022-03-03 12:55:20','2022-03-03 12:55:20'),(65943,187,'Pasund','313324',1,0,'2022-03-03 12:55:20','2022-03-03 12:55:20'),(65944,187,'Pharara','313324',1,0,'2022-03-03 12:55:21','2022-03-03 12:55:21'),(65945,187,'Phiyawadi','313327',1,0,'2022-03-03 12:55:21','2022-03-03 12:55:21'),(65946,187,'Piparda','313324',1,0,'2022-03-03 12:55:21','2022-03-03 12:55:21'),(65947,187,'Piplantri','313324',1,0,'2022-03-03 12:55:21','2022-03-03 12:55:21'),(65948,187,'Pipli Ahiran','313327',1,0,'2022-03-03 12:55:21','2022-03-03 12:55:21'),(65949,187,'Pipli','313331',1,0,'2022-03-03 12:55:21','2022-03-03 12:55:21'),(65950,187,'Pipli','313321',1,0,'2022-03-03 12:55:21','2022-03-03 12:55:21'),(65951,187,'Pipli Dadiyan','313329',1,0,'2022-03-03 12:55:21','2022-03-03 12:55:21'),(65952,187,'Punawali','313704',1,0,'2022-03-03 12:55:21','2022-03-03 12:55:21'),(65953,187,'Punawali','313324',1,0,'2022-03-03 12:55:21','2022-03-03 12:55:21'),(65954,187,'Railmagra','313329',1,0,'2022-03-03 12:55:21','2022-03-03 12:55:21'),(65955,187,'Rajiawas','313342',1,0,'2022-03-03 12:55:21','2022-03-03 12:55:21'),(65956,187,'Rajpura','313211',1,0,'2022-03-03 12:55:21','2022-03-03 12:55:21'),(65957,187,'Rajsamand','313324',1,0,'2022-03-03 12:55:21','2022-03-03 12:55:21'),(65958,187,'Rama','313202',1,0,'2022-03-03 12:55:21','2022-03-03 12:55:21'),(65959,187,'Ranchhedi','313331',1,0,'2022-03-03 12:55:21','2022-03-03 12:55:21'),(65960,187,'Rinchhed','313332',1,0,'2022-03-03 12:55:21','2022-03-03 12:55:21'),(65961,187,'Roachh','313704',1,0,'2022-03-03 12:55:21','2022-03-03 12:55:21'),(65962,187,'Sadri','313329',1,0,'2022-03-03 12:55:21','2022-03-03 12:55:21'),(65963,187,'Sakrawas','313329',1,0,'2022-03-03 12:55:21','2022-03-03 12:55:21'),(65964,187,'Sakroda','313324',1,0,'2022-03-03 12:55:21','2022-03-03 12:55:21'),(65965,187,'Sakroda','313330',1,0,'2022-03-03 12:55:21','2022-03-03 12:55:21'),(65966,187,'Saloda','313322',1,0,'2022-03-03 12:55:21','2022-03-03 12:55:21'),(65967,187,'Salore','313301',1,0,'2022-03-03 12:55:21','2022-03-03 12:55:21'),(65968,187,'Sameecha','313321',1,0,'2022-03-03 12:55:21','2022-03-03 12:55:21'),(65969,187,'Samliya','305921',1,0,'2022-03-03 12:55:21','2022-03-03 12:55:21'),(65970,187,'Sanghat Kalan','313324',1,0,'2022-03-03 12:55:22','2022-03-03 12:55:22'),(65971,187,'Sansera','313329',1,0,'2022-03-03 12:55:22','2022-03-03 12:55:22'),(65972,187,'Sapol','313334',1,0,'2022-03-03 12:55:22','2022-03-03 12:55:22'),(65973,187,'Sathia','313333',1,0,'2022-03-03 12:55:22','2022-03-03 12:55:22'),(65974,187,'Savadari','313331',1,0,'2022-03-03 12:55:22','2022-03-03 12:55:22'),(65975,187,'Sayon Ka Khera','313324',1,0,'2022-03-03 12:55:22','2022-03-03 12:55:22'),(65976,187,'Selaguda','313332',1,0,'2022-03-03 12:55:22','2022-03-03 12:55:22'),(65977,187,'Sema','313322',1,0,'2022-03-03 12:55:22','2022-03-03 12:55:22'),(65978,187,'Semad','313704',1,0,'2022-03-03 12:55:22','2022-03-03 12:55:22'),(65979,187,'Semal','313322',1,0,'2022-03-03 12:55:22','2022-03-03 12:55:22'),(65980,187,'Sevantri','313333',1,0,'2022-03-03 12:55:22','2022-03-03 12:55:22'),(65981,187,'Shishoda','313301',1,0,'2022-03-03 12:55:22','2022-03-03 12:55:22'),(65982,187,'Shishvi','313202',1,0,'2022-03-03 12:55:22','2022-03-03 12:55:22'),(65983,187,'Singhara','313704',1,0,'2022-03-03 12:55:22','2022-03-03 12:55:22'),(65984,187,'Siyana','313334',1,0,'2022-03-03 12:55:22','2022-03-03 12:55:22'),(65985,187,'Suavaton Ka Guda','313704',1,0,'2022-03-03 12:55:22','2022-03-03 12:55:22'),(65986,187,'Sundarcha','313324',1,0,'2022-03-03 12:55:22','2022-03-03 12:55:22'),(65987,187,'Sunkhar','313333',1,0,'2022-03-03 12:55:22','2022-03-03 12:55:22'),(65988,187,'T F Kankroli','313342',1,0,'2022-03-03 12:55:22','2022-03-03 12:55:22'),(65989,187,'Tal','313331',1,0,'2022-03-03 12:55:22','2022-03-03 12:55:22'),(65990,187,'Taladari','313325',1,0,'2022-03-03 12:55:22','2022-03-03 12:55:22'),(65991,187,'Tansol','313334',1,0,'2022-03-03 12:55:22','2022-03-03 12:55:22'),(65992,187,'Tantol','313301',1,0,'2022-03-03 12:55:22','2022-03-03 12:55:22'),(65993,187,'Tarpal','313704',1,0,'2022-03-03 12:55:22','2022-03-03 12:55:22'),(65994,187,'Thikarwas','313341',1,0,'2022-03-03 12:55:23','2022-03-03 12:55:23'),(65995,187,'Thurawad','313333',1,0,'2022-03-03 12:55:23','2022-03-03 12:55:23'),(65996,187,'Tikar','313332',1,0,'2022-03-03 12:55:23','2022-03-03 12:55:23'),(65997,187,'Todawara Gujran','313333',1,0,'2022-03-03 12:55:23','2022-03-03 12:55:23'),(65998,187,'Togi','305921',1,0,'2022-03-03 12:55:23','2022-03-03 12:55:23'),(65999,187,'Tunkra','313334',1,0,'2022-03-03 12:55:23','2022-03-03 12:55:23'),(66000,187,'Umarwas','313333',1,0,'2022-03-03 12:55:23','2022-03-03 12:55:23'),(66001,187,'Unwas','313322',1,0,'2022-03-03 12:55:23','2022-03-03 12:55:23'),(66002,187,'Usar','313321',1,0,'2022-03-03 12:55:23','2022-03-03 12:55:23'),(66003,187,'Vati','313322',1,0,'2022-03-03 12:55:23','2022-03-03 12:55:23'),(66004,188,'Adalwada Kalan','322701',1,0,'2022-03-03 12:55:23','2022-03-03 12:55:23'),(66005,188,'Adarsh Nagar (Sawai Madhopur)','322001',1,0,'2022-03-03 12:55:23','2022-03-03 12:55:23'),(66006,188,'Ahmadpur','322201',1,0,'2022-03-03 12:55:23','2022-03-03 12:55:23'),(66007,188,'Ajnoti','322027',1,0,'2022-03-03 12:55:23','2022-03-03 12:55:23'),(66008,188,'Akhaigarh','322025',1,0,'2022-03-03 12:55:23','2022-03-03 12:55:23'),(66009,188,'Alanpur','322021',1,0,'2022-03-03 12:55:23','2022-03-03 12:55:23'),(66010,188,'Alapur','322001',1,0,'2022-03-03 12:55:23','2022-03-03 12:55:23'),(66011,188,'Amargarh Chaur','322201',1,0,'2022-03-03 12:55:23','2022-03-03 12:55:23'),(66012,188,'Amavragarh','322212',1,0,'2022-03-03 12:55:23','2022-03-03 12:55:23'),(66013,188,'Ancher','322703',1,0,'2022-03-03 12:55:23','2022-03-03 12:55:23'),(66014,188,'Aniyala','322025',1,0,'2022-03-03 12:55:23','2022-03-03 12:55:23'),(66015,188,'Aruda PSSK','322218',1,0,'2022-03-03 12:55:23','2022-03-03 12:55:23'),(66016,188,'Atunkalan','322001',1,0,'2022-03-03 12:55:23','2022-03-03 12:55:23'),(66017,188,'Aulwada','322034',1,0,'2022-03-03 12:55:23','2022-03-03 12:55:23'),(66018,188,'Badagaon Didayach','322702',1,0,'2022-03-03 12:55:24','2022-03-03 12:55:24'),(66019,188,'Badhkalan','322201',1,0,'2022-03-03 12:55:24','2022-03-03 12:55:24'),(66020,188,'Badila','322211',1,0,'2022-03-03 12:55:24','2022-03-03 12:55:24'),(66021,188,'Badolas','322034',1,0,'2022-03-03 12:55:24','2022-03-03 12:55:24'),(66022,188,'Badwas','322025',1,0,'2022-03-03 12:55:24','2022-03-03 12:55:24'),(66023,188,'Bagdoli','322023',1,0,'2022-03-03 12:55:24','2022-03-03 12:55:24'),(66024,188,'Bagina','322702',1,0,'2022-03-03 12:55:24','2022-03-03 12:55:24'),(66025,188,'Baglai','322205',1,0,'2022-03-03 12:55:24','2022-03-03 12:55:24'),(66026,188,'Baharnwanda Khurd','322001',1,0,'2022-03-03 12:55:24','2022-03-03 12:55:24'),(66027,188,'Bairada','322214',1,0,'2022-03-03 12:55:24','2022-03-03 12:55:24'),(66028,188,'Balaria','322702',1,0,'2022-03-03 12:55:24','2022-03-03 12:55:24'),(66029,188,'Baler','322025',1,0,'2022-03-03 12:55:24','2022-03-03 12:55:24'),(66030,188,'Baman Baroda','322201',1,0,'2022-03-03 12:55:24','2022-03-03 12:55:24'),(66031,188,'Bamanwas','322211',1,0,'2022-03-03 12:55:24','2022-03-03 12:55:24'),(66032,188,'Bapui','322023',1,0,'2022-03-03 12:55:24','2022-03-03 12:55:24'),(66033,188,'Bara Gao Sarwar','322023',1,0,'2022-03-03 12:55:24','2022-03-03 12:55:24'),(66034,188,'Barnala','322214',1,0,'2022-03-03 12:55:24','2022-03-03 12:55:24'),(66035,188,'Barnawada','322025',1,0,'2022-03-03 12:55:24','2022-03-03 12:55:24'),(66036,188,'Barod','322025',1,0,'2022-03-03 12:55:24','2022-03-03 12:55:24'),(66037,188,'Baroli','322219',1,0,'2022-03-03 12:55:24','2022-03-03 12:55:24'),(66038,188,'Batoda','322214',1,0,'2022-03-03 12:55:24','2022-03-03 12:55:24'),(66039,188,'Behted','322028',1,0,'2022-03-03 12:55:24','2022-03-03 12:55:24'),(66040,188,'Bhadlav','322029',1,0,'2022-03-03 12:55:25','2022-03-03 12:55:25'),(66041,188,'Bhadoti','322024',1,0,'2022-03-03 12:55:25','2022-03-03 12:55:25'),(66042,188,'Bhagwatgarh','322701',1,0,'2022-03-03 12:55:25','2022-03-03 12:55:25'),(66043,188,'Bhahraonda Kalan','322025',1,0,'2022-03-03 12:55:25','2022-03-03 12:55:25'),(66044,188,'Bhanwar','322214',1,0,'2022-03-03 12:55:25','2022-03-03 12:55:25'),(66045,188,'Bhanwara','322212',1,0,'2022-03-03 12:55:25','2022-03-03 12:55:25'),(66046,188,'Bhedola','322702',1,0,'2022-03-03 12:55:25','2022-03-03 12:55:25'),(66047,188,'Bhooka','322028',1,0,'2022-03-03 12:55:25','2022-03-03 12:55:25'),(66048,188,'Bhoori Pahari','322033',1,0,'2022-03-03 12:55:25','2022-03-03 12:55:25'),(66049,188,'Bichhi Doona','322033',1,0,'2022-03-03 12:55:25','2022-03-03 12:55:25'),(66050,188,'Bichhoch','322214',1,0,'2022-03-03 12:55:25','2022-03-03 12:55:25'),(66051,188,'Bichpuri','322212',1,0,'2022-03-03 12:55:25','2022-03-03 12:55:25'),(66052,188,'Bichpuri Gujran','322025',1,0,'2022-03-03 12:55:25','2022-03-03 12:55:25'),(66053,188,'Binega','322219',1,0,'2022-03-03 12:55:25','2022-03-03 12:55:25'),(66054,188,'Binjari','322214',1,0,'2022-03-03 12:55:25','2022-03-03 12:55:25'),(66055,188,'Binjari','322702',1,0,'2022-03-03 12:55:25','2022-03-03 12:55:25'),(66056,188,'Bonli','322023',1,0,'2022-03-03 12:55:25','2022-03-03 12:55:25'),(66057,188,'Borda','322023',1,0,'2022-03-03 12:55:25','2022-03-03 12:55:25'),(66058,188,'Bucholai','322201',1,0,'2022-03-03 12:55:25','2022-03-03 12:55:25'),(66059,188,'Chakeri','322034',1,0,'2022-03-03 12:55:25','2022-03-03 12:55:25'),(66060,188,'Chandanholi','322214',1,0,'2022-03-03 12:55:25','2022-03-03 12:55:25'),(66061,188,'Chauth Ka Barwara','322702',1,0,'2022-03-03 12:55:25','2022-03-03 12:55:25'),(66062,188,'Chhan','322001',1,0,'2022-03-03 12:55:25','2022-03-03 12:55:25'),(66063,188,'Chharoda','322029',1,0,'2022-03-03 12:55:25','2022-03-03 12:55:25'),(66064,188,'Chhawa','322202',1,0,'2022-03-03 12:55:26','2022-03-03 12:55:26'),(66065,188,'Chitara','322026',1,0,'2022-03-03 12:55:26','2022-03-03 12:55:26'),(66066,188,'Choti Udai','322205',1,0,'2022-03-03 12:55:26','2022-03-03 12:55:26'),(66067,188,'Chuli','322202',1,0,'2022-03-03 12:55:26','2022-03-03 12:55:26'),(66068,188,'Dabar','322214',1,0,'2022-03-03 12:55:26','2022-03-03 12:55:26'),(66069,188,'Dakwa','322001',1,0,'2022-03-03 12:55:26','2022-03-03 12:55:26'),(66070,188,'Dangarwada','322026',1,0,'2022-03-03 12:55:26','2022-03-03 12:55:26'),(66071,188,'Datasuti P T','322215',1,0,'2022-03-03 12:55:26','2022-03-03 12:55:26'),(66072,188,'Datooli','322030',1,0,'2022-03-03 12:55:26','2022-03-03 12:55:26'),(66073,188,'Daulatpura','322001',1,0,'2022-03-03 12:55:26','2022-03-03 12:55:26'),(66074,188,'Dhamun Khurd','322001',1,0,'2022-03-03 12:55:26','2022-03-03 12:55:26'),(66075,188,'Dhanoli','322027',1,0,'2022-03-03 12:55:26','2022-03-03 12:55:26'),(66076,188,'Didwadi','322024',1,0,'2022-03-03 12:55:26','2022-03-03 12:55:26'),(66077,188,'Doongri','322033',1,0,'2022-03-03 12:55:26','2022-03-03 12:55:26'),(66078,188,'Dubbi','322027',1,0,'2022-03-03 12:55:26','2022-03-03 12:55:26'),(66079,188,'Dumoda','322026',1,0,'2022-03-03 12:55:26','2022-03-03 12:55:26'),(66080,188,'Dungarwada','322211',1,0,'2022-03-03 12:55:26','2022-03-03 12:55:26'),(66081,188,'Endwa','322029',1,0,'2022-03-03 12:55:26','2022-03-03 12:55:26'),(66082,188,'Falsawata','322028',1,0,'2022-03-03 12:55:26','2022-03-03 12:55:26'),(66083,188,'Galad Kalan','322030',1,0,'2022-03-03 12:55:26','2022-03-03 12:55:26'),(66084,188,'Gambhira','322024',1,0,'2022-03-03 12:55:26','2022-03-03 12:55:26'),(66085,188,'Gandawar','322025',1,0,'2022-03-03 12:55:26','2022-03-03 12:55:26'),(66086,188,'Gangapur Bazar','322201',1,0,'2022-03-03 12:55:26','2022-03-03 12:55:26'),(66087,188,'Gangapur H.O','322201',1,0,'2022-03-03 12:55:26','2022-03-03 12:55:26'),(66088,188,'Ghimeera','322001',1,0,'2022-03-03 12:55:26','2022-03-03 12:55:26'),(66089,188,'Goth Bihari','322025',1,0,'2022-03-03 12:55:26','2022-03-03 12:55:26'),(66090,188,'Gothra','322025',1,0,'2022-03-03 12:55:27','2022-03-03 12:55:27'),(66091,188,'Gotod','322030',1,0,'2022-03-03 12:55:27','2022-03-03 12:55:27'),(66092,188,'Gungorad','322023',1,0,'2022-03-03 12:55:27','2022-03-03 12:55:27'),(66093,188,'Hathdoli','322024',1,0,'2022-03-03 12:55:27','2022-03-03 12:55:27'),(66094,188,'Hindupura','322024',1,0,'2022-03-03 12:55:27','2022-03-03 12:55:27'),(66095,188,'Isharda','322703',1,0,'2022-03-03 12:55:27','2022-03-03 12:55:27'),(66096,188,'Jadawata','322027',1,0,'2022-03-03 12:55:27','2022-03-03 12:55:27'),(66097,188,'Jahra','322211',1,0,'2022-03-03 12:55:27','2022-03-03 12:55:27'),(66098,188,'Jastana','322030',1,0,'2022-03-03 12:55:27','2022-03-03 12:55:27'),(66099,188,'Jatwara Kalan','322701',1,0,'2022-03-03 12:55:27','2022-03-03 12:55:27'),(66100,188,'Jhanun','322023',1,0,'2022-03-03 12:55:27','2022-03-03 12:55:27'),(66101,188,'Jhopra','322701',1,0,'2022-03-03 12:55:27','2022-03-03 12:55:27'),(66102,188,'Jinapur','322001',1,0,'2022-03-03 12:55:27','2022-03-03 12:55:27'),(66103,188,'Jiwad','322214',1,0,'2022-03-03 12:55:27','2022-03-03 12:55:27'),(66104,188,'Jiwali','322219',1,0,'2022-03-03 12:55:27','2022-03-03 12:55:27'),(66105,188,'Jolanda','322024',1,0,'2022-03-03 12:55:27','2022-03-03 12:55:27'),(66106,188,'Jonla','322701',1,0,'2022-03-03 12:55:27','2022-03-03 12:55:27'),(66107,188,'Kakrala','322211',1,0,'2022-03-03 12:55:27','2022-03-03 12:55:27'),(66108,188,'Karmoda','322027',1,0,'2022-03-03 12:55:27','2022-03-03 12:55:27'),(66109,188,'Khandar','322025',1,0,'2022-03-03 12:55:27','2022-03-03 12:55:27'),(66110,188,'Khandeep','322205',1,0,'2022-03-03 12:55:27','2022-03-03 12:55:27'),(66111,188,'Khandeola','322001',1,0,'2022-03-03 12:55:28','2022-03-03 12:55:28'),(66112,188,'Khanpur Baroda','322202',1,0,'2022-03-03 12:55:28','2022-03-03 12:55:28'),(66113,188,'Khatupura','322001',1,0,'2022-03-03 12:55:28','2022-03-03 12:55:28'),(66114,188,'Kherli','322214',1,0,'2022-03-03 12:55:28','2022-03-03 12:55:28'),(66115,188,'Khijuri','322001',1,0,'2022-03-03 12:55:28','2022-03-03 12:55:28'),(66116,188,'Khirni','322024',1,0,'2022-03-03 12:55:28','2022-03-03 12:55:28'),(66117,188,'Khoontala','322201',1,0,'2022-03-03 12:55:28','2022-03-03 12:55:28'),(66118,188,'Kodyai','322030',1,0,'2022-03-03 12:55:28','2022-03-03 12:55:28'),(66119,188,'Kolada','322023',1,0,'2022-03-03 12:55:28','2022-03-03 12:55:28'),(66120,188,'Kosra Chhareta Tod','322025',1,0,'2022-03-03 12:55:28','2022-03-03 12:55:28'),(66121,188,'Koyla','322201',1,0,'2022-03-03 12:55:28','2022-03-03 12:55:28'),(66122,188,'Krishi Upaj Mandi Gangapur','322201',1,0,'2022-03-03 12:55:28','2022-03-03 12:55:28'),(66123,188,'Kundera','322029',1,0,'2022-03-03 12:55:28','2022-03-03 12:55:28'),(66124,188,'Kuredi','322025',1,0,'2022-03-03 12:55:28','2022-03-03 12:55:28'),(66125,188,'Kushalpura','322023',1,0,'2022-03-03 12:55:28','2022-03-03 12:55:28'),(66126,188,'Kustala','322001',1,0,'2022-03-03 12:55:28','2022-03-03 12:55:28'),(66127,188,'Kyarda Kalan','322025',1,0,'2022-03-03 12:55:28','2022-03-03 12:55:28'),(66128,188,'Lahsoda','322026',1,0,'2022-03-03 12:55:28','2022-03-03 12:55:28'),(66129,188,'Lakhanpur','322023',1,0,'2022-03-03 12:55:28','2022-03-03 12:55:28'),(66130,188,'Lalpur Umri','322201',1,0,'2022-03-03 12:55:29','2022-03-03 12:55:29'),(66131,188,'Liwali','322211',1,0,'2022-03-03 12:55:29','2022-03-03 12:55:29'),(66132,188,'Lorwara','322701',1,0,'2022-03-03 12:55:29','2022-03-03 12:55:29'),(66133,188,'Mahanandpur','322205',1,0,'2022-03-03 12:55:29','2022-03-03 12:55:29'),(66134,188,'Mahapura','322704',1,0,'2022-03-03 12:55:29','2022-03-03 12:55:29'),(66135,188,'Maharajpura','322243',1,0,'2022-03-03 12:55:29','2022-03-03 12:55:29'),(66136,188,'Mahukala','322202',1,0,'2022-03-03 12:55:29','2022-03-03 12:55:29'),(66137,188,'Mai Kalan','322001',1,0,'2022-03-03 12:55:29','2022-03-03 12:55:29'),(66138,188,'Mainpura','322027',1,0,'2022-03-03 12:55:29','2022-03-03 12:55:29'),(66139,188,'Makholi','322034',1,0,'2022-03-03 12:55:29','2022-03-03 12:55:29'),(66140,188,'Maksudanpura','322033',1,0,'2022-03-03 12:55:29','2022-03-03 12:55:29'),(66141,188,'Malarna R S','322033',1,0,'2022-03-03 12:55:29','2022-03-03 12:55:29'),(66142,188,'Malrna Chaur','322030',1,0,'2022-03-03 12:55:29','2022-03-03 12:55:29'),(66143,188,'Malrna Doongar','322028',1,0,'2022-03-03 12:55:29','2022-03-03 12:55:29'),(66144,188,'Mamdoli','322024',1,0,'2022-03-03 12:55:29','2022-03-03 12:55:29'),(66145,188,'Mandal','322204',1,0,'2022-03-03 12:55:29','2022-03-03 12:55:29'),(66146,188,'Medi','322219',1,0,'2022-03-03 12:55:29','2022-03-03 12:55:29'),(66147,188,'Meena Baroda','322219',1,0,'2022-03-03 12:55:29','2022-03-03 12:55:29'),(66148,188,'Meena Koleta','322211',1,0,'2022-03-03 12:55:29','2022-03-03 12:55:29'),(66149,188,'Mehrawar','322214',1,0,'2022-03-03 12:55:29','2022-03-03 12:55:29'),(66150,188,'Mitrapura','322023',1,0,'2022-03-03 12:55:29','2022-03-03 12:55:29'),(66151,188,'Mohcha','322205',1,0,'2022-03-03 12:55:29','2022-03-03 12:55:29'),(66152,188,'Moran','322023',1,0,'2022-03-03 12:55:29','2022-03-03 12:55:29'),(66153,188,'Morpa','322028',1,0,'2022-03-03 12:55:29','2022-03-03 12:55:29'),(66154,188,'Mui','322001',1,0,'2022-03-03 12:55:29','2022-03-03 12:55:29'),(66155,188,'Narauli Chaur','322214',1,0,'2022-03-03 12:55:30','2022-03-03 12:55:30'),(66156,188,'Narayanpur Tatwara','322203',1,0,'2022-03-03 12:55:30','2022-03-03 12:55:30'),(66157,188,'Naypur','322025',1,0,'2022-03-03 12:55:30','2022-03-03 12:55:30'),(66158,188,'New Mandi Gangapur','322201',1,0,'2022-03-03 12:55:30','2022-03-03 12:55:30'),(66159,188,'Nimod','322023',1,0,'2022-03-03 12:55:30','2022-03-03 12:55:30'),(66160,188,'Nimod','322030',1,0,'2022-03-03 12:55:30','2022-03-03 12:55:30'),(66161,188,'Nindarda','322027',1,0,'2022-03-03 12:55:30','2022-03-03 12:55:30'),(66162,188,'Nogaon','322201',1,0,'2022-03-03 12:55:30','2022-03-03 12:55:30'),(66163,188,'Padana','322034',1,0,'2022-03-03 12:55:30','2022-03-03 12:55:30'),(66164,188,'Padri','322025',1,0,'2022-03-03 12:55:30','2022-03-03 12:55:30'),(66165,188,'Palasod','322214',1,0,'2022-03-03 12:55:30','2022-03-03 12:55:30'),(66166,188,'Pancholas','322001',1,0,'2022-03-03 12:55:30','2022-03-03 12:55:30'),(66167,188,'Panwdera','322702',1,0,'2022-03-03 12:55:30','2022-03-03 12:55:30'),(66168,188,'Pawata Gaddi','322219',1,0,'2022-03-03 12:55:30','2022-03-03 12:55:30'),(66169,188,'Phalodi','322026',1,0,'2022-03-03 12:55:30','2022-03-03 12:55:30'),(66170,188,'Phalodi Quarry','322026',1,0,'2022-03-03 12:55:30','2022-03-03 12:55:30'),(66171,188,'Phoolwada Popat','322219',1,0,'2022-03-03 12:55:30','2022-03-03 12:55:30'),(66172,188,'Phulwada','322214',1,0,'2022-03-03 12:55:30','2022-03-03 12:55:30'),(66173,188,'Piloda','322205',1,0,'2022-03-03 12:55:30','2022-03-03 12:55:30'),(66174,188,'Pipalda','322030',1,0,'2022-03-03 12:55:30','2022-03-03 12:55:30'),(66175,188,'Pipalwada','322023',1,0,'2022-03-03 12:55:30','2022-03-03 12:55:30'),(66176,188,'Piplai','322214',1,0,'2022-03-03 12:55:30','2022-03-03 12:55:30'),(66177,188,'Radhopura','322211',1,0,'2022-03-03 12:55:31','2022-03-03 12:55:31'),(66178,188,'Railway Colony Gangapur','322201',1,0,'2022-03-03 12:55:31','2022-03-03 12:55:31'),(66179,188,'Raipur','322219',1,0,'2022-03-03 12:55:31','2022-03-03 12:55:31'),(66180,188,'Rajmana','322702',1,0,'2022-03-03 12:55:31','2022-03-03 12:55:31'),(66181,188,'Ramdi','322027',1,0,'2022-03-03 12:55:31','2022-03-03 12:55:31'),(66182,188,'Rampura PSSK','322026',1,0,'2022-03-03 12:55:31','2022-03-03 12:55:31'),(66183,188,'Ranila','322211',1,0,'2022-03-03 12:55:31','2022-03-03 12:55:31'),(66184,188,'Rathod','322023',1,0,'2022-03-03 12:55:31','2022-03-03 12:55:31'),(66185,188,'Rawal','322029',1,0,'2022-03-03 12:55:31','2022-03-03 12:55:31'),(66186,188,'Rawanjana Chaur','322001',1,0,'2022-03-03 12:55:31','2022-03-03 12:55:31'),(66187,188,'Rawanjana Doongar','322001',1,0,'2022-03-03 12:55:31','2022-03-03 12:55:31'),(66188,188,'Redawat','322025',1,0,'2022-03-03 12:55:31','2022-03-03 12:55:31'),(66189,188,'Rendayal Gurjar','322220',1,0,'2022-03-03 12:55:31','2022-03-03 12:55:31'),(66190,188,'Riwali','322212',1,0,'2022-03-03 12:55:31','2022-03-03 12:55:31'),(66191,188,'Salempur','322202',1,0,'2022-03-03 12:55:31','2022-03-03 12:55:31'),(66192,188,'Sancholi','322214',1,0,'2022-03-03 12:55:31','2022-03-03 12:55:31'),(66193,188,'Sankara','322202',1,0,'2022-03-03 12:55:31','2022-03-03 12:55:31'),(66194,188,'Sarsop','322703',1,0,'2022-03-03 12:55:31','2022-03-03 12:55:31'),(66195,188,'Sawaimadhopur Bazar','322021',1,0,'2022-03-03 12:55:31','2022-03-03 12:55:31'),(66196,188,'Sawaimadhopur H.O','322001',1,0,'2022-03-03 12:55:31','2022-03-03 12:55:31'),(66197,188,'Sawaimadhopur Town','322021',1,0,'2022-03-03 12:55:31','2022-03-03 12:55:31'),(66198,188,'Selu','322034',1,0,'2022-03-03 12:55:31','2022-03-03 12:55:31'),(66199,188,'Seva','322219',1,0,'2022-03-03 12:55:31','2022-03-03 12:55:31'),(66200,188,'Shafipura','322211',1,0,'2022-03-03 12:55:31','2022-03-03 12:55:31'),(66201,188,'Shayampura','322029',1,0,'2022-03-03 12:55:31','2022-03-03 12:55:31'),(66202,188,'Sherpur Khilchipur','322001',1,0,'2022-03-03 12:55:32','2022-03-03 12:55:32'),(66203,188,'Sherpur PSSK','322001',1,0,'2022-03-03 12:55:32','2022-03-03 12:55:32'),(66204,188,'Shesha','322024',1,0,'2022-03-03 12:55:32','2022-03-03 12:55:32'),(66205,188,'Shiwar','322704',1,0,'2022-03-03 12:55:32','2022-03-03 12:55:32'),(66206,188,'Shyaroli','322219',1,0,'2022-03-03 12:55:32','2022-03-03 12:55:32'),(66207,188,'Singor Kalan','322025',1,0,'2022-03-03 12:55:32','2022-03-03 12:55:32'),(66208,188,'Sitod','322214',1,0,'2022-03-03 12:55:32','2022-03-03 12:55:32'),(66209,188,'Soorwal','322027',1,0,'2022-03-03 12:55:32','2022-03-03 12:55:32'),(66210,188,'Sukar','322212',1,0,'2022-03-03 12:55:32','2022-03-03 12:55:32'),(66211,188,'Sumel','322201',1,0,'2022-03-03 12:55:32','2022-03-03 12:55:32'),(66212,188,'Sunari','322027',1,0,'2022-03-03 12:55:32','2022-03-03 12:55:32'),(66213,188,'Sundery','322214',1,0,'2022-03-03 12:55:32','2022-03-03 12:55:32'),(66214,188,'Talawada','322201',1,0,'2022-03-03 12:55:32','2022-03-03 12:55:32'),(66215,188,'Talwada','322025',1,0,'2022-03-03 12:55:32','2022-03-03 12:55:32'),(66216,188,'Tapur','322703',1,0,'2022-03-03 12:55:32','2022-03-03 12:55:32'),(66217,188,'Taranpur','322030',1,0,'2022-03-03 12:55:32','2022-03-03 12:55:32'),(66218,188,'Toksi','322202',1,0,'2022-03-03 12:55:32','2022-03-03 12:55:32'),(66219,188,'Tundila','322211',1,0,'2022-03-03 12:55:32','2022-03-03 12:55:32'),(66220,188,'Udaikalan','322201',1,0,'2022-03-03 12:55:32','2022-03-03 12:55:32'),(66221,188,'Udgaon','322023',1,0,'2022-03-03 12:55:32','2022-03-03 12:55:32'),(66222,188,'Wazirpur','322219',1,0,'2022-03-03 12:55:32','2022-03-03 12:55:32'),(66223,189,'Abhaipura','332402',1,0,'2022-03-03 12:55:32','2022-03-03 12:55:32'),(66224,189,'Abhawas','332602',1,0,'2022-03-03 12:55:32','2022-03-03 12:55:32'),(66225,189,'Ajabpura','332402',1,0,'2022-03-03 12:55:32','2022-03-03 12:55:32'),(66226,189,'Ajitgarh Amarsar','332701',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66227,189,'Ajmeri','332701',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66228,189,'Akwa','332315',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66229,189,'Alkhpura Bogan','332312',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66230,189,'Almas','332303',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66231,189,'Aloda','332602',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66232,189,'Anokhu','332002',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66233,189,'Antri','332021',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66234,189,'Arnia','332603',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66235,189,'Aspura','332701',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66236,189,'Athbigha','332709',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66237,189,'Athwas','332401',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66238,189,'Badalwas','332023',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66239,189,'Badhadhar','332315',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66240,189,'Badusar','332317',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66241,189,'Bagri','332311',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66242,189,'Bagriawas','332715',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66243,189,'Bagroda','332303',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66244,189,'Bairas','332311',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66245,189,'Bajaj Road-Sikar','332001',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66246,189,'Bajajgram','332021',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66247,189,'Bajiawas','332601',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66248,189,'Bajore','332403',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66249,189,'Balaran','332401',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66250,189,'Ballupura','332718',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66251,189,'Balod Bhakaran','332305',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66252,189,'Balod Chhoti','332305',1,0,'2022-03-03 12:55:33','2022-03-03 12:55:33'),(66253,189,'Bamanwas','332709',1,0,'2022-03-03 12:55:34','2022-03-03 12:55:34'),(66254,189,'Banathala','332601',1,0,'2022-03-03 12:55:34','2022-03-03 12:55:34'),(66255,189,'Banthod','332301',1,0,'2022-03-03 12:55:34','2022-03-03 12:55:34'),(66256,189,'Banura','332023',1,0,'2022-03-03 12:55:34','2022-03-03 12:55:34'),(66257,189,'Baori','332411',1,0,'2022-03-03 12:55:34','2022-03-03 12:55:34'),(66258,189,'Baral','332405',1,0,'2022-03-03 12:55:34','2022-03-03 12:55:34'),(66259,189,'Bari','332301',1,0,'2022-03-03 12:55:34','2022-03-03 12:55:34'),(66260,189,'Barsinghpura','332709',1,0,'2022-03-03 12:55:34','2022-03-03 12:55:34'),(66261,189,'Barsinghpura','332402',1,0,'2022-03-03 12:55:34','2022-03-03 12:55:34'),(66262,189,'Basri','332708',1,0,'2022-03-03 12:55:34','2022-03-03 12:55:34'),(66263,189,'Basri Khurd','332708',1,0,'2022-03-03 12:55:34','2022-03-03 12:55:34'),(66264,189,'Bassi','332715',1,0,'2022-03-03 12:55:34','2022-03-03 12:55:34'),(66265,189,'Bathot','332312',1,0,'2022-03-03 12:55:34','2022-03-03 12:55:34'),(66266,189,'Batranau','332311',1,0,'2022-03-03 12:55:34','2022-03-03 12:55:34'),(66267,189,'Baya','332601',1,0,'2022-03-03 12:55:34','2022-03-03 12:55:34'),(66268,189,'Beedasar','332316',1,0,'2022-03-03 12:55:34','2022-03-03 12:55:34'),(66269,189,'Beedsar','332316',1,0,'2022-03-03 12:55:34','2022-03-03 12:55:34'),(66270,189,'Beri','332031',1,0,'2022-03-03 12:55:34','2022-03-03 12:55:34'),(66271,189,'Beswa','332303',1,0,'2022-03-03 12:55:34','2022-03-03 12:55:34'),(66272,189,'Bhadwari','332708',1,0,'2022-03-03 12:55:34','2022-03-03 12:55:34'),(66273,189,'Bhadwasi','332024',1,0,'2022-03-03 12:55:34','2022-03-03 12:55:34'),(66274,189,'Bhagasara','332303',1,0,'2022-03-03 12:55:34','2022-03-03 12:55:34'),(66275,189,'Bhagatpura','332023',1,0,'2022-03-03 12:55:34','2022-03-03 12:55:34'),(66276,189,'Bhagoth','332714',1,0,'2022-03-03 12:55:34','2022-03-03 12:55:34'),(66277,189,'Bhagwanpura','332714',1,0,'2022-03-03 12:55:35','2022-03-03 12:55:35'),(66278,189,'Bhaironpura','332001',1,0,'2022-03-03 12:55:35','2022-03-03 12:55:35'),(66279,189,'Bharija','332742',1,0,'2022-03-03 12:55:35','2022-03-03 12:55:35'),(66280,189,'Bharni','332715',1,0,'2022-03-03 12:55:35','2022-03-03 12:55:35'),(66281,189,'Bheenchari','332303',1,0,'2022-03-03 12:55:35','2022-03-03 12:55:35'),(66282,189,'Bhilunda','332028',1,0,'2022-03-03 12:55:35','2022-03-03 12:55:35'),(66283,189,'Bhima','332025',1,0,'2022-03-03 12:55:35','2022-03-03 12:55:35'),(66284,189,'Bhirana','332025',1,0,'2022-03-03 12:55:35','2022-03-03 12:55:35'),(66285,189,'Bhojasar','332312',1,0,'2022-03-03 12:55:35','2022-03-03 12:55:35'),(66286,189,'Bhojpur','332709',1,0,'2022-03-03 12:55:35','2022-03-03 12:55:35'),(66287,189,'Bhooma Bada','332318',1,0,'2022-03-03 12:55:35','2022-03-03 12:55:35'),(66288,189,'Bhopatpura','332404',1,0,'2022-03-03 12:55:35','2022-03-03 12:55:35'),(66289,189,'Bhudoli','332713',1,0,'2022-03-03 12:55:35','2022-03-03 12:55:35'),(66290,189,'Bhurdonkabas','332703',1,0,'2022-03-03 12:55:35','2022-03-03 12:55:35'),(66291,189,'Bhuwala','332042',1,0,'2022-03-03 12:55:35','2022-03-03 12:55:35'),(66292,189,'Bibipur','332317',1,0,'2022-03-03 12:55:35','2022-03-03 12:55:35'),(66293,189,'Bidoli','332023',1,0,'2022-03-03 12:55:35','2022-03-03 12:55:35'),(66294,189,'Bihar','332718',1,0,'2022-03-03 12:55:35','2022-03-03 12:55:35'),(66295,189,'Biharipur','332718',1,0,'2022-03-03 12:55:35','2022-03-03 12:55:35'),(66296,189,'Binjasi','332028',1,0,'2022-03-03 12:55:35','2022-03-03 12:55:35'),(66297,189,'Birania','332301',1,0,'2022-03-03 12:55:35','2022-03-03 12:55:35'),(66298,189,'Birodi Chotti','332316',1,0,'2022-03-03 12:55:35','2022-03-03 12:55:35'),(66299,189,'Birodibadi','332316',1,0,'2022-03-03 12:55:35','2022-03-03 12:55:35'),(66300,189,'Bochi','332029',1,0,'2022-03-03 12:55:35','2022-03-03 12:55:35'),(66301,189,'Bosana','332025',1,0,'2022-03-03 12:55:35','2022-03-03 12:55:35'),(66302,189,'Chachiwad','332311',1,0,'2022-03-03 12:55:36','2022-03-03 12:55:36'),(66303,189,'Chainpura','332027',1,0,'2022-03-03 12:55:36','2022-03-03 12:55:36'),(66304,189,'Chakgopinathpura','332710',1,0,'2022-03-03 12:55:36','2022-03-03 12:55:36'),(66305,189,'Chala','332706',1,0,'2022-03-03 12:55:36','2022-03-03 12:55:36'),(66306,189,'Chandpura','332021',1,0,'2022-03-03 12:55:36','2022-03-03 12:55:36'),(66307,189,'Charanwas','332601',1,0,'2022-03-03 12:55:36','2022-03-03 12:55:36'),(66308,189,'Chhajakinangal','332718',1,0,'2022-03-03 12:55:36','2022-03-03 12:55:36'),(66309,189,'Chiplata','332705',1,0,'2022-03-03 12:55:36','2022-03-03 12:55:36'),(66310,189,'Chirasara','332025',1,0,'2022-03-03 12:55:36','2022-03-03 12:55:36'),(66311,189,'Chomupurohitan','332602',1,0,'2022-03-03 12:55:36','2022-03-03 12:55:36'),(66312,189,'Chowkri','332706',1,0,'2022-03-03 12:55:36','2022-03-03 12:55:36'),(66313,189,'Churi Miyon','332401',1,0,'2022-03-03 12:55:36','2022-03-03 12:55:36'),(66314,189,'Chuwas','332301',1,0,'2022-03-03 12:55:36','2022-03-03 12:55:36'),(66315,189,'Dabla','332718',1,0,'2022-03-03 12:55:36','2022-03-03 12:55:36'),(66316,189,'Dabri','332305',1,0,'2022-03-03 12:55:36','2022-03-03 12:55:36'),(66317,189,'Dadia','332024',1,0,'2022-03-03 12:55:36','2022-03-03 12:55:36'),(66318,189,'Dadia Rampura','332404',1,0,'2022-03-03 12:55:36','2022-03-03 12:55:36'),(66319,189,'Dalpatpura','332718',1,0,'2022-03-03 12:55:36','2022-03-03 12:55:36'),(66320,189,'Dansroli','332742',1,0,'2022-03-03 12:55:36','2022-03-03 12:55:36'),(66321,189,'Danta Ramgarh','332703',1,0,'2022-03-03 12:55:36','2022-03-03 12:55:36'),(66322,189,'Danta','332702',1,0,'2022-03-03 12:55:36','2022-03-03 12:55:36'),(66323,189,'Dantru','332311',1,0,'2022-03-03 12:55:36','2022-03-03 12:55:36'),(66324,189,'Dariba','332705',1,0,'2022-03-03 12:55:36','2022-03-03 12:55:36'),(66325,189,'Dayalkinangal','332711',1,0,'2022-03-03 12:55:36','2022-03-03 12:55:36'),(66326,189,'Dayara','332709',1,0,'2022-03-03 12:55:36','2022-03-03 12:55:36'),(66327,189,'Deenwa','332311',1,0,'2022-03-03 12:55:36','2022-03-03 12:55:36'),(66328,189,'Deepawas','332705',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66329,189,'Deogarh','332021',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66330,189,'Deorala','332701',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66331,189,'Devipura','332001',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66332,189,'Dewas','332301',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66333,189,'Dhabawali','332715',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66334,189,'Dhakas','331024',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66335,189,'Dhaliawas','332715',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66336,189,'Dhanani','332318',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66337,189,'Dhandhan','332302',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66338,189,'Dhani Guman Singh','332709',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66339,189,'Dhani Jorawarsingh','332708',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66340,189,'Dher Ka Bas','332028',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66341,189,'Dhingpur','332601',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66342,189,'Dhod','332002',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66343,189,'Dholasari','332703',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66344,189,'Dinarpura','332024',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66345,189,'Dinwa','332303',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66346,189,'Disnau','332401',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66347,189,'Dokan','332718',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66348,189,'Doodwa','332316',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66349,189,'Dookia','332402',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66350,189,'Doongakinangal','332718',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66351,189,'Dudhwa','332406',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66352,189,'Dudhwalonkabas','332709',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66353,189,'Dugoli','332042',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66354,189,'Dujod','332021',1,0,'2022-03-03 12:55:37','2022-03-03 12:55:37'),(66355,189,'Fadanpura','332301',1,0,'2022-03-03 12:55:38','2022-03-03 12:55:38'),(66356,189,'Fatehpur Bazar','332301',1,0,'2022-03-03 12:55:38','2022-03-03 12:55:38'),(66357,189,'Fatehpur Shekhawati','332301',1,0,'2022-03-03 12:55:38','2022-03-03 12:55:38'),(66358,189,'Fatehpura','332721',1,0,'2022-03-03 12:55:38','2022-03-03 12:55:38'),(66359,189,'Fatehpura','332028',1,0,'2022-03-03 12:55:38','2022-03-03 12:55:38'),(66360,189,'Fatehpuri Gate','332001',1,0,'2022-03-03 12:55:38','2022-03-03 12:55:38'),(66361,189,'Footala','332712',1,0,'2022-03-03 12:55:38','2022-03-03 12:55:38'),(66362,189,'Gandhinagar (Sikar)','332001',1,0,'2022-03-03 12:55:38','2022-03-03 12:55:38'),(66363,189,'Ganeri','332029',1,0,'2022-03-03 12:55:38','2022-03-03 12:55:38'),(66364,189,'Ganeshwar','332705',1,0,'2022-03-03 12:55:38','2022-03-03 12:55:38'),(66365,189,'Gangiasar','332301',1,0,'2022-03-03 12:55:38','2022-03-03 12:55:38'),(66366,189,'Ganora','332602',1,0,'2022-03-03 12:55:38','2022-03-03 12:55:38'),(66367,189,'Ganwari','332705',1,0,'2022-03-03 12:55:38','2022-03-03 12:55:38'),(66368,189,'Garh Bhopji','332719',1,0,'2022-03-03 12:55:38','2022-03-03 12:55:38'),(66369,189,'Garh Taknet','332701',1,0,'2022-03-03 12:55:38','2022-03-03 12:55:38'),(66370,189,'Garinda','332301',1,0,'2022-03-03 12:55:38','2022-03-03 12:55:38'),(66371,189,'Garoda','332312',1,0,'2022-03-03 12:55:38','2022-03-03 12:55:38'),(66372,189,'Gassu','332315',1,0,'2022-03-03 12:55:38','2022-03-03 12:55:38'),(66373,189,'Ghana','332312',1,0,'2022-03-03 12:55:38','2022-03-03 12:55:38'),(66374,189,'Ghasipura','332718',1,0,'2022-03-03 12:55:38','2022-03-03 12:55:38'),(66375,189,'Ghirnia Bada','332026',1,0,'2022-03-03 12:55:38','2022-03-03 12:55:38'),(66376,189,'Godawas','332713',1,0,'2022-03-03 12:55:38','2022-03-03 12:55:38'),(66377,189,'Godia Bada','332301',1,0,'2022-03-03 12:55:38','2022-03-03 12:55:38'),(66378,189,'Gokulkabas','332709',1,0,'2022-03-03 12:55:38','2022-03-03 12:55:38'),(66379,189,'Gokulpura','332021',1,0,'2022-03-03 12:55:39','2022-03-03 12:55:39'),(66380,189,'Gordhanpura','332402',1,0,'2022-03-03 12:55:39','2022-03-03 12:55:39'),(66381,189,'Goriyan','332403',1,0,'2022-03-03 12:55:39','2022-03-03 12:55:39'),(66382,189,'Goriyan','332722',1,0,'2022-03-03 12:55:39','2022-03-03 12:55:39'),(66383,189,'Gothra Bhukaran','332031',1,0,'2022-03-03 12:55:39','2022-03-03 12:55:39'),(66384,189,'Gothra Taglan','332023',1,0,'2022-03-03 12:55:39','2022-03-03 12:55:39'),(66385,189,'Govati','332402',1,0,'2022-03-03 12:55:39','2022-03-03 12:55:39'),(66386,189,'Govindpura','332714',1,0,'2022-03-03 12:55:39','2022-03-03 12:55:39'),(66387,189,'Govindpura','332402',1,0,'2022-03-03 12:55:39','2022-03-03 12:55:39'),(66388,189,'Gudha','332603',1,0,'2022-03-03 12:55:39','2022-03-03 12:55:39'),(66389,189,'Gudha Chhota','332402',1,0,'2022-03-03 12:55:39','2022-03-03 12:55:39'),(66390,189,'Guhala','332706',1,0,'2022-03-03 12:55:39','2022-03-03 12:55:39'),(66391,189,'Gunatoo','332028',1,0,'2022-03-03 12:55:39','2022-03-03 12:55:39'),(66392,189,'Gungara','332027',1,0,'2022-03-03 12:55:39','2022-03-03 12:55:39'),(66393,189,'Gurara','332721',1,0,'2022-03-03 12:55:39','2022-03-03 12:55:39'),(66394,189,'Hamirpura','332311',1,0,'2022-03-03 12:55:39','2022-03-03 12:55:39'),(66395,189,'Hansapur','332715',1,0,'2022-03-03 12:55:39','2022-03-03 12:55:39'),(66396,189,'Hapas','332312',1,0,'2022-03-03 12:55:39','2022-03-03 12:55:39'),(66397,189,'Hardaskabas','332707',1,0,'2022-03-03 12:55:39','2022-03-03 12:55:39'),(66398,189,'Hardayalpura','332027',1,0,'2022-03-03 12:55:39','2022-03-03 12:55:39'),(66399,189,'Haripura','332707',1,0,'2022-03-03 12:55:39','2022-03-03 12:55:39'),(66400,189,'Harjanpura','332708',1,0,'2022-03-03 12:55:39','2022-03-03 12:55:39'),(66401,189,'Harsawa','332301',1,0,'2022-03-03 12:55:39','2022-03-03 12:55:39'),(66402,189,'Harsh','332021',1,0,'2022-03-03 12:55:39','2022-03-03 12:55:39'),(66403,189,'Hasampur','332718',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66404,189,'Hathideh','332707',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66405,189,'Hirna','332303',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66406,189,'Hod','332709',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66407,189,'Holikabas','332715',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66408,189,'Hospital Road (Sikar)','332001',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66409,189,'Hudera','332304',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66410,189,'Jachas','332023',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66411,189,'Jairampura','332715',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66412,189,'Jajod (Lachhmangarh)','332318',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66413,189,'Jajod (Srimadhopur)','332722',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66414,189,'Jalalsar','332301',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66415,189,'Jalund','332601',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66416,189,'Jana','332025',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66417,189,'Jankipura','332722',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66418,189,'Jasrasar','332315',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66419,189,'Jassika Kabas','332714',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66420,189,'Jeenmata','332406',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66421,189,'Jeenwas','332406',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66422,189,'Jetusar','332404',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66423,189,'Jharli','332707',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66424,189,'Jheegar Chhoti','332024',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66425,189,'Jillo','332711',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66426,189,'Jugalpura','332708',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66427,189,'Jugrajpura','332701',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66428,189,'Juliasar','332318',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66429,189,'Jurathara','332402',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66430,189,'Kachhwa','332026',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66431,189,'Kalyanpura','332719',1,0,'2022-03-03 12:55:40','2022-03-03 12:55:40'),(66432,189,'Kanchanpur','332715',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66433,189,'Kankra','332742',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66434,189,'Kantia','332601',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66435,189,'Kanwarpura','332001',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66436,189,'Kanwat R.S.','332708',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66437,189,'Kanwat Town','332708',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66438,189,'Karad','332710',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66439,189,'Karanga Bada','332301',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66440,189,'Kardka','332719',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66441,189,'Kasarda','332722',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66442,189,'Kashikabas','332021',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66443,189,'Kasli','332002',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66444,189,'Kaswali','332401',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66445,189,'Katrathal','332024',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66446,189,'Kayamsar','331024',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66447,189,'Kerpura','332709',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66448,189,'Khachariawas','332710',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66449,189,'Khadra','332713',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66450,189,'Khakholi','332041',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66451,189,'Khandela','332709',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66452,189,'Khandelsar','332403',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66453,189,'Khanri','332025',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66454,189,'Khatundra','332709',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66455,189,'Khatushyamjika','332602',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66456,189,'Kheerwa','332316',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66457,189,'Kheri Radan','332401',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66458,189,'Khinwasar','332316',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66459,189,'Khiroti','332705',1,0,'2022-03-03 12:55:41','2022-03-03 12:55:41'),(66460,189,'Khoor','332023',1,0,'2022-03-03 12:55:42','2022-03-03 12:55:42'),(66461,189,'Khora','332601',1,0,'2022-03-03 12:55:42','2022-03-03 12:55:42'),(66462,189,'Khotiya','331024',1,0,'2022-03-03 12:55:42','2022-03-03 12:55:42'),(66463,189,'Khuri Badi','332315',1,0,'2022-03-03 12:55:42','2022-03-03 12:55:42'),(66464,189,'Kirdoli','332041',1,0,'2022-03-03 12:55:42','2022-03-03 12:55:42'),(66465,189,'Kishorepura','332701',1,0,'2022-03-03 12:55:42','2022-03-03 12:55:42'),(66466,189,'Kochhore','332406',1,0,'2022-03-03 12:55:42','2022-03-03 12:55:42'),(66467,189,'Kolida','332031',1,0,'2022-03-03 12:55:42','2022-03-03 12:55:42'),(66468,189,'Koodan','332031',1,0,'2022-03-03 12:55:42','2022-03-03 12:55:42'),(66469,189,'Koolie','332710',1,0,'2022-03-03 12:55:42','2022-03-03 12:55:42'),(66470,189,'Kothyari','332026',1,0,'2022-03-03 12:55:42','2022-03-03 12:55:42'),(66471,189,'Kotra','332713',1,0,'2022-03-03 12:55:42','2022-03-03 12:55:42'),(66472,189,'Kotri','332715',1,0,'2022-03-03 12:55:42','2022-03-03 12:55:42'),(66473,189,'Kotri','332709',1,0,'2022-03-03 12:55:42','2022-03-03 12:55:42'),(66474,189,'Kotri Dhayalan','332404',1,0,'2022-03-03 12:55:42','2022-03-03 12:55:42'),(66475,189,'Kudli','332024',1,0,'2022-03-03 12:55:42','2022-03-03 12:55:42'),(66476,189,'Kumas','332311',1,0,'2022-03-03 12:55:42','2022-03-03 12:55:42'),(66477,189,'Kumas','332026',1,0,'2022-03-03 12:55:42','2022-03-03 12:55:42'),(66478,189,'Kushalpura','332027',1,0,'2022-03-03 12:55:42','2022-03-03 12:55:42'),(66479,189,'Lachhmangarh Bazar','332311',1,0,'2022-03-03 12:55:42','2022-03-03 12:55:42'),(66480,189,'Lachhmangarh','332311',1,0,'2022-03-03 12:55:42','2022-03-03 12:55:42'),(66481,189,'Ladhana','332402',1,0,'2022-03-03 12:55:42','2022-03-03 12:55:42'),(66482,189,'Ladikabas','332705',1,0,'2022-03-03 12:55:42','2022-03-03 12:55:42'),(66483,189,'Ladpur','332601',1,0,'2022-03-03 12:55:42','2022-03-03 12:55:42'),(66484,189,'Ladpur','332411',1,0,'2022-03-03 12:55:42','2022-03-03 12:55:42'),(66485,189,'Lakhani','332404',1,0,'2022-03-03 12:55:43','2022-03-03 12:55:43'),(66486,189,'Lalasi','332315',1,0,'2022-03-03 12:55:43','2022-03-03 12:55:43'),(66487,189,'Lamiya','332602',1,0,'2022-03-03 12:55:43','2022-03-03 12:55:43'),(66488,189,'Lampuwa','332404',1,0,'2022-03-03 12:55:43','2022-03-03 12:55:43'),(66489,189,'Likhma Ka Bas','332601',1,0,'2022-03-03 12:55:43','2022-03-03 12:55:43'),(66490,189,'Lisariya','332712',1,0,'2022-03-03 12:55:43','2022-03-03 12:55:43'),(66491,189,'Lorwara','332708',1,0,'2022-03-03 12:55:43','2022-03-03 12:55:43'),(66492,189,'Losal Bazar','332025',1,0,'2022-03-03 12:55:43','2022-03-03 12:55:43'),(66493,189,'Losal Chhoti','332025',1,0,'2022-03-03 12:55:43','2022-03-03 12:55:43'),(66494,189,'Losal','332025',1,0,'2022-03-03 12:55:43','2022-03-03 12:55:43'),(66495,189,'Madhopura','332401',1,0,'2022-03-03 12:55:43','2022-03-03 12:55:43'),(66496,189,'Mahawa','332713',1,0,'2022-03-03 12:55:43','2022-03-03 12:55:43'),(66497,189,'Mahroli','332603',1,0,'2022-03-03 12:55:43','2022-03-03 12:55:43'),(66498,189,'Makri','332711',1,0,'2022-03-03 12:55:43','2022-03-03 12:55:43'),(66499,189,'Malikpur','332411',1,0,'2022-03-03 12:55:43','2022-03-03 12:55:43'),(66500,189,'Mandawara','332021',1,0,'2022-03-03 12:55:43','2022-03-03 12:55:43'),(66501,189,'Mandela Bada','332301',1,0,'2022-03-03 12:55:43','2022-03-03 12:55:43'),(66502,189,'Mandela Chhota','332301',1,0,'2022-03-03 12:55:43','2022-03-03 12:55:43'),(66503,189,'Mandha Madni','332402',1,0,'2022-03-03 12:55:43','2022-03-03 12:55:43'),(66504,189,'Mandha Surera','332742',1,0,'2022-03-03 12:55:43','2022-03-03 12:55:43'),(66505,189,'Mandholi','332713',1,0,'2022-03-03 12:55:43','2022-03-03 12:55:43'),(66506,189,'Mandota','332023',1,0,'2022-03-03 12:55:43','2022-03-03 12:55:43'),(66507,189,'Mandusiya','332701',1,0,'2022-03-03 12:55:43','2022-03-03 12:55:43'),(66508,189,'Mangloona','332318',1,0,'2022-03-03 12:55:44','2022-03-03 12:55:44'),(66509,189,'Maonda Kalan','332711',1,0,'2022-03-03 12:55:44','2022-03-03 12:55:44'),(66510,189,'Maonda Khurd','332711',1,0,'2022-03-03 12:55:44','2022-03-03 12:55:44'),(66511,189,'Maonda RS','332711',1,0,'2022-03-03 12:55:44','2022-03-03 12:55:44'),(66512,189,'Mau','332715',1,0,'2022-03-03 12:55:44','2022-03-03 12:55:44'),(66513,189,'Meirajanpura','332703',1,0,'2022-03-03 12:55:44','2022-03-03 12:55:44'),(66514,189,'Miran','332312',1,0,'2022-03-03 12:55:44','2022-03-03 12:55:44'),(66515,189,'Mochiwara','332001',1,0,'2022-03-03 12:55:44','2022-03-03 12:55:44'),(66516,189,'Mohanpura','332406',1,0,'2022-03-03 12:55:44','2022-03-03 12:55:44'),(66517,189,'Mokalwas','332705',1,0,'2022-03-03 12:55:44','2022-03-03 12:55:44'),(66518,189,'Molyasi','332041',1,0,'2022-03-03 12:55:44','2022-03-03 12:55:44'),(66519,189,'Mordunga','332030',1,0,'2022-03-03 12:55:44','2022-03-03 12:55:44'),(66520,189,'Mota Ki Dhani','332601',1,0,'2022-03-03 12:55:44','2022-03-03 12:55:44'),(66521,189,'Motlawas','332702',1,0,'2022-03-03 12:55:44','2022-03-03 12:55:44'),(66522,189,'Mundawara','332023',1,0,'2022-03-03 12:55:44','2022-03-03 12:55:44'),(66523,189,'Mundiawas','332702',1,0,'2022-03-03 12:55:44','2022-03-03 12:55:44'),(66524,189,'Mundru','332712',1,0,'2022-03-03 12:55:44','2022-03-03 12:55:44'),(66525,189,'N.P.Khandela','332709',1,0,'2022-03-03 12:55:44','2022-03-03 12:55:44'),(66526,189,'Nabipura','332303',1,0,'2022-03-03 12:55:44','2022-03-03 12:55:44'),(66527,189,'Nagwa','332002',1,0,'2022-03-03 12:55:44','2022-03-03 12:55:44'),(66528,189,'Nangal Bhim','332715',1,0,'2022-03-03 12:55:44','2022-03-03 12:55:44'),(66529,189,'Nangal Nathusar','332712',1,0,'2022-03-03 12:55:44','2022-03-03 12:55:44'),(66530,189,'Napawali','332713',1,0,'2022-03-03 12:55:44','2022-03-03 12:55:44'),(66531,189,'Narodara','332311',1,0,'2022-03-03 12:55:44','2022-03-03 12:55:44'),(66532,189,'Narsas','332318',1,0,'2022-03-03 12:55:44','2022-03-03 12:55:44'),(66533,189,'Narsinghpuri','332706',1,0,'2022-03-03 12:55:45','2022-03-03 12:55:45'),(66534,189,'Nathakinangal','332711',1,0,'2022-03-03 12:55:45','2022-03-03 12:55:45'),(66535,189,'Nathawatpura','332001',1,0,'2022-03-03 12:55:45','2022-03-03 12:55:45'),(66536,189,'Nathusar','332712',1,0,'2022-03-03 12:55:45','2022-03-03 12:55:45'),(66537,189,'Nayabas','332713',1,0,'2022-03-03 12:55:45','2022-03-03 12:55:45'),(66538,189,'Nayabas','332301',1,0,'2022-03-03 12:55:45','2022-03-03 12:55:45'),(66539,189,'Nayama Bazar- Lachhmangarh','332311',1,0,'2022-03-03 12:55:45','2022-03-03 12:55:45'),(66540,189,'Nechhwa','332026',1,0,'2022-03-03 12:55:45','2022-03-03 12:55:45'),(66541,189,'Neemakidhani','331024',1,0,'2022-03-03 12:55:45','2022-03-03 12:55:45'),(66542,189,'Neemawas','332702',1,0,'2022-03-03 12:55:45','2022-03-03 12:55:45'),(66543,189,'Neemki','332708',1,0,'2022-03-03 12:55:45','2022-03-03 12:55:45'),(66544,189,'Netarwas','332002',1,0,'2022-03-03 12:55:45','2022-03-03 12:55:45'),(66545,189,'Nethwa','331024',1,0,'2022-03-03 12:55:45','2022-03-03 12:55:45'),(66546,189,'Nimera','332722',1,0,'2022-03-03 12:55:45','2022-03-03 12:55:45'),(66547,189,'Nimera','332406',1,0,'2022-03-03 12:55:45','2022-03-03 12:55:45'),(66548,189,'Nimkathana','332713',1,0,'2022-03-03 12:55:45','2022-03-03 12:55:45'),(66549,189,'Nimkathana Town','332713',1,0,'2022-03-03 12:55:45','2022-03-03 12:55:45'),(66550,189,'Nimod','332713',1,0,'2022-03-03 12:55:45','2022-03-03 12:55:45'),(66551,189,'Pachar','332710',1,0,'2022-03-03 12:55:45','2022-03-03 12:55:45'),(66552,189,'Palas','332302',1,0,'2022-03-03 12:55:45','2022-03-03 12:55:45'),(66553,189,'Palasara','332405',1,0,'2022-03-03 12:55:45','2022-03-03 12:55:45'),(66554,189,'Palri','332031',1,0,'2022-03-03 12:55:45','2022-03-03 12:55:45'),(66555,189,'Palsana (Sikar)','332402',1,0,'2022-03-03 12:55:45','2022-03-03 12:55:45'),(66556,189,'Palthana','332315',1,0,'2022-03-03 12:55:45','2022-03-03 12:55:45'),(66557,189,'Palwas','332042',1,0,'2022-03-03 12:55:46','2022-03-03 12:55:46'),(66558,189,'Paniharwas','332709',1,0,'2022-03-03 12:55:46','2022-03-03 12:55:46'),(66559,189,'Panlawa','332316',1,0,'2022-03-03 12:55:46','2022-03-03 12:55:46'),(66560,189,'Pardoli Badi','332041',1,0,'2022-03-03 12:55:46','2022-03-03 12:55:46'),(66561,189,'Patan (Sikar)','332718',1,0,'2022-03-03 12:55:46','2022-03-03 12:55:46'),(66562,189,'Patoda (Sikar)','332312',1,0,'2022-03-03 12:55:46','2022-03-03 12:55:46'),(66563,189,'Patwari Ka Bas','332715',1,0,'2022-03-03 12:55:46','2022-03-03 12:55:46'),(66564,189,'Pewa','332002',1,0,'2022-03-03 12:55:46','2022-03-03 12:55:46'),(66565,189,'Phagalwa','332041',1,0,'2022-03-03 12:55:46','2022-03-03 12:55:46'),(66566,189,'Piprali','332027',1,0,'2022-03-03 12:55:46','2022-03-03 12:55:46'),(66567,189,'Pithalpur','332701',1,0,'2022-03-03 12:55:46','2022-03-03 12:55:46'),(66568,189,'Posani','332031',1,0,'2022-03-03 12:55:46','2022-03-03 12:55:46'),(66569,189,'Pritampuri','332708',1,0,'2022-03-03 12:55:46','2022-03-03 12:55:46'),(66570,189,'Prithvipura','332715',1,0,'2022-03-03 12:55:46','2022-03-03 12:55:46'),(66571,189,'Prithvipura','332402',1,0,'2022-03-03 12:55:46','2022-03-03 12:55:46'),(66572,189,'Puran Badi','332021',1,0,'2022-03-03 12:55:46','2022-03-03 12:55:46'),(66573,189,'Puranabas','332713',1,0,'2022-03-03 12:55:46','2022-03-03 12:55:46'),(66574,189,'Purohitkabas','332027',1,0,'2022-03-03 12:55:46','2022-03-03 12:55:46'),(66575,189,'Raghunathgarh','332027',1,0,'2022-03-03 12:55:46','2022-03-03 12:55:46'),(66576,189,'Rahnawa','332401',1,0,'2022-03-03 12:55:46','2022-03-03 12:55:46'),(66577,189,'Raipur','332718',1,0,'2022-03-03 12:55:46','2022-03-03 12:55:46'),(66578,189,'Raipur Jagir','332701',1,0,'2022-03-03 12:55:46','2022-03-03 12:55:46'),(66579,189,'Raipura','332403',1,0,'2022-03-03 12:55:46','2022-03-03 12:55:46'),(66580,189,'Rajas','332317',1,0,'2022-03-03 12:55:46','2022-03-03 12:55:46'),(66581,189,'Rajpura','332718',1,0,'2022-03-03 12:55:46','2022-03-03 12:55:46'),(66582,189,'Rajpura','332401',1,0,'2022-03-03 12:55:47','2022-03-03 12:55:47'),(66583,189,'Rajpura','332721',1,0,'2022-03-03 12:55:47','2022-03-03 12:55:47'),(66584,189,'Rajpura','332023',1,0,'2022-03-03 12:55:47','2022-03-03 12:55:47'),(66585,189,'Rajpura Nosal','332742',1,0,'2022-03-03 12:55:47','2022-03-03 12:55:47'),(66586,189,'Ralawata','332715',1,0,'2022-03-03 12:55:47','2022-03-03 12:55:47'),(66587,189,'Ralwata','332406',1,0,'2022-03-03 12:55:47','2022-03-03 12:55:47'),(66588,189,'Ramgarh Bazar','331024',1,0,'2022-03-03 12:55:47','2022-03-03 12:55:47'),(66589,189,'Ramgarh Shekhawati','331024',1,0,'2022-03-03 12:55:47','2022-03-03 12:55:47'),(66590,189,'Rampura','332719',1,0,'2022-03-03 12:55:47','2022-03-03 12:55:47'),(66591,189,'Rampura','332709',1,0,'2022-03-03 12:55:47','2022-03-03 12:55:47'),(66592,189,'Rampura','332718',1,0,'2022-03-03 12:55:47','2022-03-03 12:55:47'),(66593,189,'Ramshisar','332302',1,0,'2022-03-03 12:55:47','2022-03-03 12:55:47'),(66594,189,'Ramsinghkidhani','332718',1,0,'2022-03-03 12:55:47','2022-03-03 12:55:47'),(66595,189,'Ranoli (Sikar)','332403',1,0,'2022-03-03 12:55:47','2022-03-03 12:55:47'),(66596,189,'Rashidpura','332315',1,0,'2022-03-03 12:55:47','2022-03-03 12:55:47'),(66597,189,'Ratanpura','332712',1,0,'2022-03-03 12:55:47','2022-03-03 12:55:47'),(66598,189,'Reta','332406',1,0,'2022-03-03 12:55:47','2022-03-03 12:55:47'),(66599,189,'Rewasa','332403',1,0,'2022-03-03 12:55:47','2022-03-03 12:55:47'),(66600,189,'Ringas','332404',1,0,'2022-03-03 12:55:47','2022-03-03 12:55:47'),(66601,189,'Ringas Town','332404',1,0,'2022-03-03 12:55:47','2022-03-03 12:55:47'),(66602,189,'Rolsabsar','332304',1,0,'2022-03-03 12:55:47','2022-03-03 12:55:47'),(66603,189,'Roopgarh','332406',1,0,'2022-03-03 12:55:47','2022-03-03 12:55:47'),(66604,189,'Rooppura','332719',1,0,'2022-03-03 12:55:47','2022-03-03 12:55:47'),(66605,189,'Roru Badi','332317',1,0,'2022-03-03 12:55:47','2022-03-03 12:55:47'),(66606,189,'Rosawa','332304',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66607,189,'Royal','332709',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66608,189,'Rulana','332601',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66609,189,'Rulyana Mali','332041',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66610,189,'Rulyani','332028',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66611,189,'Sabalpura','332001',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66612,189,'Sadinsar','332305',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66613,189,'Sahnusar','331024',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66614,189,'Sakraimata','332721',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66615,189,'Saledipura','332709',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66616,189,'Samer','332602',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66617,189,'Sami','332023',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66618,189,'Samrathpura','332708',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66619,189,'Sangarwa','332405',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66620,189,'Sangliya','332025',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66621,189,'Sankhu','332401',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66622,189,'Sanwaloda Dhayalan','332315',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66623,189,'Sanwalpura Shekhawatan','332707',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66624,189,'Sanwalpura Tanwaran','332707',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66625,189,'Sanwloda Ladkhani','332315',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66626,189,'Sanwloda Purohitan','332315',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66627,189,'Sargoth','332404',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66628,189,'Sarwari','332030',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66629,189,'Sawaipura','332722',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66630,189,'Seepur','332701',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66631,189,'Sekhisar','332304',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66632,189,'Sesam','332023',1,0,'2022-03-03 12:55:48','2022-03-03 12:55:48'),(66633,189,'Sewa','332041',1,0,'2022-03-03 12:55:49','2022-03-03 12:55:49'),(66634,189,'Sewad Badi','332041',1,0,'2022-03-03 12:55:49','2022-03-03 12:55:49'),(66635,189,'Shahpura','332028',1,0,'2022-03-03 12:55:49','2022-03-03 12:55:49'),(66636,189,'Shahpura','332411',1,0,'2022-03-03 12:55:49','2022-03-03 12:55:49'),(66637,189,'Sherpura Sujas','332403',1,0,'2022-03-03 12:55:49','2022-03-03 12:55:49'),(66638,189,'Shishu','332405',1,0,'2022-03-03 12:55:49','2022-03-03 12:55:49'),(66639,189,'Shola','332722',1,0,'2022-03-03 12:55:49','2022-03-03 12:55:49'),(66640,189,'Shyamgarh','332721',1,0,'2022-03-03 12:55:49','2022-03-03 12:55:49'),(66641,189,'Shyampura','332710',1,0,'2022-03-03 12:55:49','2022-03-03 12:55:49'),(66642,189,'Shyampura','332403',1,0,'2022-03-03 12:55:49','2022-03-03 12:55:49'),(66643,189,'Shyampura','332041',1,0,'2022-03-03 12:55:49','2022-03-03 12:55:49'),(66644,189,'Shyampura','332718',1,0,'2022-03-03 12:55:49','2022-03-03 12:55:49'),(66645,189,'Sihori','332719',1,0,'2022-03-03 12:55:49','2022-03-03 12:55:49'),(66646,189,'Sihot Badi','332028',1,0,'2022-03-03 12:55:49','2022-03-03 12:55:49'),(66647,189,'Sihot Chhoti','332041',1,0,'2022-03-03 12:55:49','2022-03-03 12:55:49'),(66648,189,'Sikar H.O','332001',1,0,'2022-03-03 12:55:49','2022-03-03 12:55:49'),(66649,189,'Sikaria Bazar-Fatehpur','332301',1,0,'2022-03-03 12:55:49','2022-03-03 12:55:49'),(66650,189,'Simarla Pironka','332603',1,0,'2022-03-03 12:55:49','2022-03-03 12:55:49'),(66651,189,'Simrala','332719',1,0,'2022-03-03 12:55:49','2022-03-03 12:55:49'),(66652,189,'Singhasan','332027',1,0,'2022-03-03 12:55:49','2022-03-03 12:55:49'),(66653,189,'Singodra','332311',1,0,'2022-03-03 12:55:49','2022-03-03 12:55:49'),(66654,189,'Singrawat','332030',1,0,'2022-03-03 12:55:49','2022-03-03 12:55:49'),(66655,189,'Sirohi','332714',1,0,'2022-03-03 12:55:49','2022-03-03 12:55:49'),(66656,189,'Sola','332312',1,0,'2022-03-03 12:55:49','2022-03-03 12:55:49'),(66657,189,'Srimadhopur Bazar','332715',1,0,'2022-03-03 12:55:50','2022-03-03 12:55:50'),(66658,189,'Srimadhopur H.O','332715',1,0,'2022-03-03 12:55:50','2022-03-03 12:55:50'),(66659,189,'Srimadhopur R.S.','332715',1,0,'2022-03-03 12:55:50','2022-03-03 12:55:50'),(66660,189,'Subhash Nagar','332031',1,0,'2022-03-03 12:55:50','2022-03-03 12:55:50'),(66661,189,'Sujanpura','332030',1,0,'2022-03-03 12:55:50','2022-03-03 12:55:50'),(66662,189,'Suliawas','332702',1,0,'2022-03-03 12:55:50','2022-03-03 12:55:50'),(66663,189,'Sunderpura','332402',1,0,'2022-03-03 12:55:50','2022-03-03 12:55:50'),(66664,189,'Surani','332707',1,0,'2022-03-03 12:55:50','2022-03-03 12:55:50'),(66665,189,'Surani Bazar Srimadhopur','332715',1,0,'2022-03-03 12:55:50','2022-03-03 12:55:50'),(66666,189,'Surera','332742',1,0,'2022-03-03 12:55:50','2022-03-03 12:55:50'),(66667,189,'Sutod','332029',1,0,'2022-03-03 12:55:50','2022-03-03 12:55:50'),(66668,189,'Sutot','332041',1,0,'2022-03-03 12:55:50','2022-03-03 12:55:50'),(66669,189,'Tajsar','332301',1,0,'2022-03-03 12:55:50','2022-03-03 12:55:50'),(66670,189,'Takhalsar','331024',1,0,'2022-03-03 12:55:50','2022-03-03 12:55:50'),(66671,189,'Tapiplya','332404',1,0,'2022-03-03 12:55:50','2022-03-03 12:55:50'),(66672,189,'Tarpura','332024',1,0,'2022-03-03 12:55:50','2022-03-03 12:55:50'),(66673,189,'Tasar Badi','332042',1,0,'2022-03-03 12:55:50','2022-03-03 12:55:50'),(66674,189,'Tatanwa','332042',1,0,'2022-03-03 12:55:50','2022-03-03 12:55:50'),(66675,189,'Tatera','332701',1,0,'2022-03-03 12:55:50','2022-03-03 12:55:50'),(66676,189,'Thedi','331024',1,0,'2022-03-03 12:55:50','2022-03-03 12:55:50'),(66677,189,'Thikaria','332411',1,0,'2022-03-03 12:55:50','2022-03-03 12:55:50'),(66678,189,'Thimoli','332307',1,0,'2022-03-03 12:55:50','2022-03-03 12:55:50'),(66679,189,'Thoi','332719',1,0,'2022-03-03 12:55:50','2022-03-03 12:55:50'),(66680,189,'Tihawali','332307',1,0,'2022-03-03 12:55:50','2022-03-03 12:55:50'),(66681,189,'Tihay','332307',1,0,'2022-03-03 12:55:50','2022-03-03 12:55:50'),(66682,189,'Tiroki Badi','332029',1,0,'2022-03-03 12:55:50','2022-03-03 12:55:50'),(66683,189,'Tiwari Ki Dhani','332715',1,0,'2022-03-03 12:55:51','2022-03-03 12:55:51'),(66684,189,'Tiwarikidhani','332709',1,0,'2022-03-03 12:55:51','2022-03-03 12:55:51'),(66685,189,'Toda','332705',1,0,'2022-03-03 12:55:51','2022-03-03 12:55:51'),(66686,189,'Trilokpura','332403',1,0,'2022-03-03 12:55:51','2022-03-03 12:55:51'),(66687,189,'Tunwa','332026',1,0,'2022-03-03 12:55:51','2022-03-03 12:55:51'),(66688,189,'Umara','332710',1,0,'2022-03-03 12:55:51','2022-03-03 12:55:51'),(66689,189,'Ved Ki Dhani','332405',1,0,'2022-03-03 12:55:51','2022-03-03 12:55:51'),(66690,189,'Vijaypura','332715',1,0,'2022-03-03 12:55:51','2022-03-03 12:55:51'),(66691,189,'Yalsar','332031',1,0,'2022-03-03 12:55:51','2022-03-03 12:55:51'),(66692,190,'A.I.A. Aburoad','307026',1,0,'2022-03-03 12:55:51','2022-03-03 12:55:51'),(66693,190,'Abu','307501',1,0,'2022-03-03 12:55:51','2022-03-03 12:55:51'),(66694,190,'Aburoad Bazar','307026',1,0,'2022-03-03 12:55:51','2022-03-03 12:55:51'),(66695,190,'Aburoad Diesel Shed','307026',1,0,'2022-03-03 12:55:51','2022-03-03 12:55:51'),(66696,190,'Aburoad Gandhi Nagar','307026',1,0,'2022-03-03 12:55:51','2022-03-03 12:55:51'),(66697,190,'Aburoad','307026',1,0,'2022-03-03 12:55:51','2022-03-03 12:55:51'),(66698,190,'Achpura','307510',1,0,'2022-03-03 12:55:51','2022-03-03 12:55:51'),(66699,190,'Ajari','307022',1,0,'2022-03-03 12:55:51','2022-03-03 12:55:51'),(66700,190,'Akrabhatta','307510',1,0,'2022-03-03 12:55:51','2022-03-03 12:55:51'),(66701,190,'Alpa','307028',1,0,'2022-03-03 12:55:51','2022-03-03 12:55:51'),(66702,190,'Amlari','307512',1,0,'2022-03-03 12:55:51','2022-03-03 12:55:51'),(66703,190,'Amli','307031',1,0,'2022-03-03 12:55:51','2022-03-03 12:55:51'),(66704,190,'Amthala','307510',1,0,'2022-03-03 12:55:51','2022-03-03 12:55:51'),(66705,190,'Anadra','307511',1,0,'2022-03-03 12:55:51','2022-03-03 12:55:51'),(66706,190,'Andore','307043',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66707,190,'Arathwara','307028',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66708,190,'Awal','307026',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66709,190,'Badgaon','307027',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66710,190,'Bagseen','307043',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66711,190,'Bahadurpura','307026',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66712,190,'Balda','307001',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66713,190,'Bant','307513',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66714,190,'Barloot','307801',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66715,190,'Basan','307514',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66716,190,'Basantgarh','307019',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66717,190,'Bharja','307026',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66718,190,'Bhatana','307514',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66719,190,'Bhawari','307023',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66720,190,'Bherugarh','307514',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66721,190,'Bhev','307028',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66722,190,'Bhimana R.S.','307024',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66723,190,'Bhula','307024',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66724,190,'Bhutgaon','307801',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66725,190,'Binanigram','307031',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66726,190,'Chadual','307802',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66727,190,'Chandela','307026',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66728,190,'Chandrawati','307026',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66729,190,'Channar','307026',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66730,190,'Chhibagaon','307043',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66731,190,'Chuli','307028',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66732,190,'Dabani','307511',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66733,190,'Dak','307511',1,0,'2022-03-03 12:55:52','2022-03-03 12:55:52'),(66734,190,'Dantrai','307512',1,0,'2022-03-03 12:55:53','2022-03-03 12:55:53'),(66735,190,'Dattani','307026',1,0,'2022-03-03 12:55:53','2022-03-03 12:55:53'),(66736,190,'Deldar','307801',1,0,'2022-03-03 12:55:53','2022-03-03 12:55:53'),(66737,190,'Deldar','307026',1,0,'2022-03-03 12:55:53','2022-03-03 12:55:53'),(66738,190,'Delwara','307501',1,0,'2022-03-03 12:55:53','2022-03-03 12:55:53'),(66739,190,'Derri','307026',1,0,'2022-03-03 12:55:53','2022-03-03 12:55:53'),(66740,190,'Dhan','307512',1,0,'2022-03-03 12:55:53','2022-03-03 12:55:53'),(66741,190,'Dhanari','307023',1,0,'2022-03-03 12:55:53','2022-03-03 12:55:53'),(66742,190,'Dhanta','307001',1,0,'2022-03-03 12:55:53','2022-03-03 12:55:53'),(66743,190,'Dhavli','307026',1,0,'2022-03-03 12:55:53','2022-03-03 12:55:53'),(66744,190,'Dhurbana','307027',1,0,'2022-03-03 12:55:53','2022-03-03 12:55:53'),(66745,190,'Dodua','307001',1,0,'2022-03-03 12:55:53','2022-03-03 12:55:53'),(66746,190,'Doytra','307024',1,0,'2022-03-03 12:55:53','2022-03-03 12:55:53'),(66747,190,'Ganka','307510',1,0,'2022-03-03 12:55:53','2022-03-03 12:55:53'),(66748,190,'Girwar','307026',1,0,'2022-03-03 12:55:53','2022-03-03 12:55:53'),(66749,190,'Gohili','307001',1,0,'2022-03-03 12:55:53','2022-03-03 12:55:53'),(66750,190,'Gol','307801',1,0,'2022-03-03 12:55:53','2022-03-03 12:55:53'),(66751,190,'Gulabganj','307511',1,0,'2022-03-03 12:55:53','2022-03-03 12:55:53'),(66752,190,'Haliwara','307802',1,0,'2022-03-03 12:55:53','2022-03-03 12:55:53'),(66753,190,'Hathal','307511',1,0,'2022-03-03 12:55:53','2022-03-03 12:55:53'),(66754,190,'Ishra','307023',1,0,'2022-03-03 12:55:53','2022-03-03 12:55:53'),(66755,190,'Jamburi','307026',1,0,'2022-03-03 12:55:53','2022-03-03 12:55:53'),(66756,190,'Janapur','307022',1,0,'2022-03-03 12:55:53','2022-03-03 12:55:53'),(66757,190,'Jawal','307801',1,0,'2022-03-03 12:55:53','2022-03-03 12:55:53'),(66758,190,'Jayadara','307026',1,0,'2022-03-03 12:55:53','2022-03-03 12:55:53'),(66759,190,'Jeerawal','307514',1,0,'2022-03-03 12:55:54','2022-03-03 12:55:54'),(66760,190,'Jela','307802',1,0,'2022-03-03 12:55:54','2022-03-03 12:55:54'),(66761,190,'Jetawara','307513',1,0,'2022-03-03 12:55:54','2022-03-03 12:55:54'),(66762,190,'Jetpura','307027',1,0,'2022-03-03 12:55:54','2022-03-03 12:55:54'),(66763,190,'Jhadoli','307022',1,0,'2022-03-03 12:55:54','2022-03-03 12:55:54'),(66764,190,'Jhadoliveer','307801',1,0,'2022-03-03 12:55:54','2022-03-03 12:55:54'),(66765,190,'Jkpuram','307019',1,0,'2022-03-03 12:55:54','2022-03-03 12:55:54'),(66766,190,'Jogapura','307028',1,0,'2022-03-03 12:55:54','2022-03-03 12:55:54'),(66767,190,'Jolapur','307514',1,0,'2022-03-03 12:55:54','2022-03-03 12:55:54'),(66768,190,'Joyla','307028',1,0,'2022-03-03 12:55:54','2022-03-03 12:55:54'),(66769,190,'Kachholi','307023',1,0,'2022-03-03 12:55:54','2022-03-03 12:55:54'),(66770,190,'Kalandari','307802',1,0,'2022-03-03 12:55:54','2022-03-03 12:55:54'),(66771,190,'Kermandwara','307023',1,0,'2022-03-03 12:55:54','2022-03-03 12:55:54'),(66772,190,'Kesharpura','307027',1,0,'2022-03-03 12:55:54','2022-03-03 12:55:54'),(66773,190,'Khadat','307026',1,0,'2022-03-03 12:55:54','2022-03-03 12:55:54'),(66774,190,'Khambal','307001',1,0,'2022-03-03 12:55:54','2022-03-03 12:55:54'),(66775,190,'Khandera','307028',1,0,'2022-03-03 12:55:54','2022-03-03 12:55:54'),(66776,190,'Kiverli','307510',1,0,'2022-03-03 12:55:54','2022-03-03 12:55:54'),(66777,190,'Kojra','307022',1,0,'2022-03-03 12:55:54','2022-03-03 12:55:54'),(66778,190,'Krishnaganj','307001',1,0,'2022-03-03 12:55:54','2022-03-03 12:55:54'),(66779,190,'Kyariya','307026',1,0,'2022-03-03 12:55:54','2022-03-03 12:55:54'),(66780,190,'Lass','307801',1,0,'2022-03-03 12:55:54','2022-03-03 12:55:54'),(66781,190,'Lunol','307514',1,0,'2022-03-03 12:55:54','2022-03-03 12:55:54'),(66782,190,'Madia','307802',1,0,'2022-03-03 12:55:54','2022-03-03 12:55:54'),(66783,190,'Magriwara','307514',1,0,'2022-03-03 12:55:54','2022-03-03 12:55:54'),(66784,190,'Makawal','307026',1,0,'2022-03-03 12:55:54','2022-03-03 12:55:54'),(66785,190,'Makroda','307001',1,0,'2022-03-03 12:55:55','2022-03-03 12:55:55'),(66786,190,'Malgaon','307511',1,0,'2022-03-03 12:55:55','2022-03-03 12:55:55'),(66787,190,'Mamawali','307001',1,0,'2022-03-03 12:55:55','2022-03-03 12:55:55'),(66788,190,'Manadar','307801',1,0,'2022-03-03 12:55:55','2022-03-03 12:55:55'),(66789,190,'Mandani','307801',1,0,'2022-03-03 12:55:55','2022-03-03 12:55:55'),(66790,190,'Mandar (Sirohi)','307513',1,0,'2022-03-03 12:55:55','2022-03-03 12:55:55'),(66791,190,'Mandwa','307001',1,0,'2022-03-03 12:55:55','2022-03-03 12:55:55'),(66792,190,'Mandwara','307801',1,0,'2022-03-03 12:55:55','2022-03-03 12:55:55'),(66793,190,'Mandwarakhalsa','307023',1,0,'2022-03-03 12:55:55','2022-03-03 12:55:55'),(66794,190,'Mandwaria','307801',1,0,'2022-03-03 12:55:55','2022-03-03 12:55:55'),(66795,190,'Manora','307801',1,0,'2022-03-03 12:55:55','2022-03-03 12:55:55'),(66796,190,'Marol','307514',1,0,'2022-03-03 12:55:55','2022-03-03 12:55:55'),(66797,190,'Mawal','307026',1,0,'2022-03-03 12:55:55','2022-03-03 12:55:55'),(66798,190,'Mermandwara','307802',1,0,'2022-03-03 12:55:55','2022-03-03 12:55:55'),(66799,190,'Mohabbatnagar','307802',1,0,'2022-03-03 12:55:55','2022-03-03 12:55:55'),(66800,190,'Moras','307022',1,0,'2022-03-03 12:55:55','2022-03-03 12:55:55'),(66801,190,'Morli','307043',1,0,'2022-03-03 12:55:55','2022-03-03 12:55:55'),(66802,190,'Morthala','307026',1,0,'2022-03-03 12:55:55','2022-03-03 12:55:55'),(66803,190,'Muderla','307510',1,0,'2022-03-03 12:55:55','2022-03-03 12:55:55'),(66804,190,'Mungthala','307026',1,0,'2022-03-03 12:55:55','2022-03-03 12:55:55'),(66805,190,'Nagani','307511',1,0,'2022-03-03 12:55:55','2022-03-03 12:55:55'),(66806,190,'Nandia','307022',1,0,'2022-03-03 12:55:55','2022-03-03 12:55:55'),(66807,190,'Naradara','307801',1,0,'2022-03-03 12:55:55','2022-03-03 12:55:55'),(66808,190,'Nawara','307802',1,0,'2022-03-03 12:55:55','2022-03-03 12:55:55'),(66809,190,'Nichalagarh','307026',1,0,'2022-03-03 12:55:55','2022-03-03 12:55:55'),(66810,190,'Nimbaj','307512',1,0,'2022-03-03 12:55:56','2022-03-03 12:55:56'),(66811,190,'Nitora','307023',1,0,'2022-03-03 12:55:56','2022-03-03 12:55:56'),(66812,190,'Oda','307801',1,0,'2022-03-03 12:55:56','2022-03-03 12:55:56'),(66813,190,'Ore','307026',1,0,'2022-03-03 12:55:56','2022-03-03 12:55:56'),(66814,190,'Oriya','307501',1,0,'2022-03-03 12:55:56','2022-03-03 12:55:56'),(66815,190,'Paba','307024',1,0,'2022-03-03 12:55:56','2022-03-03 12:55:56'),(66816,190,'Padar','307514',1,0,'2022-03-03 12:55:56','2022-03-03 12:55:56'),(66817,190,'Padiv','307001',1,0,'2022-03-03 12:55:56','2022-03-03 12:55:56'),(66818,190,'Palri M','307043',1,0,'2022-03-03 12:55:56','2022-03-03 12:55:56'),(66819,190,'Pamera','307511',1,0,'2022-03-03 12:55:56','2022-03-03 12:55:56'),(66820,190,'Peshua','307022',1,0,'2022-03-03 12:55:56','2022-03-03 12:55:56'),(66821,190,'Phungani','307802',1,0,'2022-03-03 12:55:56','2022-03-03 12:55:56'),(66822,190,'Pindwara','307022',1,0,'2022-03-03 12:55:56','2022-03-03 12:55:56'),(66823,190,'Pithapura','307513',1,0,'2022-03-03 12:55:56','2022-03-03 12:55:56'),(66824,190,'Posalia','307028',1,0,'2022-03-03 12:55:56','2022-03-03 12:55:56'),(66825,190,'Positra','307511',1,0,'2022-03-03 12:55:56','2022-03-03 12:55:56'),(66826,190,'Raipur','307513',1,0,'2022-03-03 12:55:56','2022-03-03 12:55:56'),(66827,190,'Rampura','307001',1,0,'2022-03-03 12:55:56','2022-03-03 12:55:56'),(66828,190,'Reodar','307514',1,0,'2022-03-03 12:55:56','2022-03-03 12:55:56'),(66829,190,'Rohida','307024',1,0,'2022-03-03 12:55:56','2022-03-03 12:55:56'),(66830,190,'Rowada','307028',1,0,'2022-03-03 12:55:56','2022-03-03 12:55:56'),(66831,190,'Sanpur','307512',1,0,'2022-03-03 12:55:56','2022-03-03 12:55:56'),(66832,190,'Santpur','307026',1,0,'2022-03-03 12:55:56','2022-03-03 12:55:56'),(66833,190,'Sanwara','307511',1,0,'2022-03-03 12:55:56','2022-03-03 12:55:56'),(66834,190,'Sanwara','307022',1,0,'2022-03-03 12:55:56','2022-03-03 12:55:56'),(66835,190,'Sartara','307802',1,0,'2022-03-03 12:55:56','2022-03-03 12:55:56'),(66836,190,'Sarupganj','307023',1,0,'2022-03-03 12:55:57','2022-03-03 12:55:57'),(66837,190,'Shantivan','307510',1,0,'2022-03-03 12:55:57','2022-03-03 12:55:57'),(66838,190,'Sheoganj (Sirohi)','307027',1,0,'2022-03-03 12:55:57','2022-03-03 12:55:57'),(66839,190,'Sildar','307802',1,0,'2022-03-03 12:55:57','2022-03-03 12:55:57'),(66840,190,'Sindrath','307001',1,0,'2022-03-03 12:55:57','2022-03-03 12:55:57'),(66841,190,'Sirodi','307511',1,0,'2022-03-03 12:55:57','2022-03-03 12:55:57'),(66842,190,'Sirohi Bhatkra','307001',1,0,'2022-03-03 12:55:57','2022-03-03 12:55:57'),(66843,190,'Sirohi H.O','307001',1,0,'2022-03-03 12:55:57','2022-03-03 12:55:57'),(66844,190,'Sirohi Sarupvilas','307001',1,0,'2022-03-03 12:55:57','2022-03-03 12:55:57'),(66845,190,'Sivera','307022',1,0,'2022-03-03 12:55:57','2022-03-03 12:55:57'),(66846,190,'Siyawa','307026',1,0,'2022-03-03 12:55:57','2022-03-03 12:55:57'),(66847,190,'Soorpagla','307026',1,0,'2022-03-03 12:55:57','2022-03-03 12:55:57'),(66848,190,'Sorda','307513',1,0,'2022-03-03 12:55:57','2022-03-03 12:55:57'),(66849,190,'Sundhaparbat','307515',1,0,'2022-03-03 12:55:57','2022-03-03 12:55:57'),(66850,190,'Tankiya','307026',1,0,'2022-03-03 12:55:57','2022-03-03 12:55:57'),(66851,190,'Tanwari','307802',1,0,'2022-03-03 12:55:57','2022-03-03 12:55:57'),(66852,190,'Tartoli','307026',1,0,'2022-03-03 12:55:57','2022-03-03 12:55:57'),(66853,190,'Telpur','307022',1,0,'2022-03-03 12:55:57','2022-03-03 12:55:57'),(66854,190,'Udd','307801',1,0,'2022-03-03 12:55:57','2022-03-03 12:55:57'),(66855,190,'Udwaria','307511',1,0,'2022-03-03 12:55:57','2022-03-03 12:55:57'),(66856,190,'Uplagarh','307026',1,0,'2022-03-03 12:55:57','2022-03-03 12:55:57'),(66857,190,'Uthman','307043',1,0,'2022-03-03 12:55:57','2022-03-03 12:55:57'),(66858,190,'Utraj','307501',1,0,'2022-03-03 12:55:57','2022-03-03 12:55:57'),(66859,190,'Valoriya','307024',1,0,'2022-03-03 12:55:57','2022-03-03 12:55:57'),(66860,190,'Van','307043',1,0,'2022-03-03 12:55:58','2022-03-03 12:55:58'),(66861,190,'Varada','307801',1,0,'2022-03-03 12:55:58','2022-03-03 12:55:58'),(66862,190,'Varli','307022',1,0,'2022-03-03 12:55:58','2022-03-03 12:55:58'),(66863,190,'Varman','307514',1,0,'2022-03-03 12:55:58','2022-03-03 12:55:58'),(66864,190,'Vasa','307024',1,0,'2022-03-03 12:55:58','2022-03-03 12:55:58'),(66865,190,'Vasda','307026',1,0,'2022-03-03 12:55:58','2022-03-03 12:55:58'),(66866,190,'Vatera','307024',1,0,'2022-03-03 12:55:58','2022-03-03 12:55:58'),(66867,190,'Vellangari','307001',1,0,'2022-03-03 12:55:58','2022-03-03 12:55:58'),(66868,190,'Verwara','307022',1,0,'2022-03-03 12:55:58','2022-03-03 12:55:58'),(66869,191,'Aligarh (Tonk)','304023',1,0,'2022-03-03 12:55:58','2022-03-03 12:55:58'),(66870,191,'Aliyari','304502',1,0,'2022-03-03 12:55:58','2022-03-03 12:55:58'),(66871,191,'Ambapura Colony Daulta','304804',1,0,'2022-03-03 12:55:58','2022-03-03 12:55:58'),(66872,191,'Amli','304023',1,0,'2022-03-03 12:55:58','2022-03-03 12:55:58'),(66873,191,'Antoli','304503',1,0,'2022-03-03 12:55:58','2022-03-03 12:55:58'),(66874,191,'Anwan','304802',1,0,'2022-03-03 12:55:58','2022-03-03 12:55:58'),(66875,191,'Arniya Kedar','304001',1,0,'2022-03-03 12:55:58','2022-03-03 12:55:58'),(66876,191,'Avikanagar','304501',1,0,'2022-03-03 12:55:58','2022-03-03 12:55:58'),(66877,191,'Awara','304502',1,0,'2022-03-03 12:55:58','2022-03-03 12:55:58'),(66878,191,'Bagari','304801',1,0,'2022-03-03 12:55:58','2022-03-03 12:55:58'),(66879,191,'Bagdawa','304801',1,0,'2022-03-03 12:55:58','2022-03-03 12:55:58'),(66880,191,'Bahad','304025',1,0,'2022-03-03 12:55:58','2022-03-03 12:55:58'),(66881,191,'Balithal','304024',1,0,'2022-03-03 12:55:58','2022-03-03 12:55:58'),(66882,191,'Balunda','304802',1,0,'2022-03-03 12:55:58','2022-03-03 12:55:58'),(66883,191,'Bambore','304001',1,0,'2022-03-03 12:55:58','2022-03-03 12:55:58'),(66884,191,'Banasthali Vidya Peeth','304022',1,0,'2022-03-03 12:55:58','2022-03-03 12:55:58'),(66885,191,'Banetha','304024',1,0,'2022-03-03 12:55:59','2022-03-03 12:55:59'),(66886,191,'Bansera','304505',1,0,'2022-03-03 12:55:59','2022-03-03 12:55:59'),(66887,191,'Banthali','304802',1,0,'2022-03-03 12:55:59','2022-03-03 12:55:59'),(66888,191,'Baori','304505',1,0,'2022-03-03 12:55:59','2022-03-03 12:55:59'),(66889,191,'Baroni','304021',1,0,'2022-03-03 12:55:59','2022-03-03 12:55:59'),(66890,191,'Barwas','304505',1,0,'2022-03-03 12:55:59','2022-03-03 12:55:59'),(66891,191,'Bassi','304505',1,0,'2022-03-03 12:55:59','2022-03-03 12:55:59'),(66892,191,'Beejwad','304507',1,0,'2022-03-03 12:55:59','2022-03-03 12:55:59'),(66893,191,'Bhanwata','304505',1,0,'2022-03-03 12:55:59','2022-03-03 12:55:59'),(66894,191,'Bharni','304001',1,0,'2022-03-03 12:55:59','2022-03-03 12:55:59'),(66895,191,'Bhartala','304025',1,0,'2022-03-03 12:55:59','2022-03-03 12:55:59'),(66896,191,'Bhasu','304505',1,0,'2022-03-03 12:55:59','2022-03-03 12:55:59'),(66897,191,'Bheepur','304504',1,0,'2022-03-03 12:55:59','2022-03-03 12:55:59'),(66898,191,'Bilota','304023',1,0,'2022-03-03 12:55:59','2022-03-03 12:55:59'),(66899,191,'Bisalpur','304505',1,0,'2022-03-03 12:55:59','2022-03-03 12:55:59'),(66900,191,'Borkhandi','304504',1,0,'2022-03-03 12:55:59','2022-03-03 12:55:59'),(66901,191,'Bosariya','304024',1,0,'2022-03-03 12:55:59','2022-03-03 12:55:59'),(66902,191,'Botunda','304804',1,0,'2022-03-03 12:55:59','2022-03-03 12:55:59'),(66903,191,'Budha Dewal','304503',1,0,'2022-03-03 12:55:59','2022-03-03 12:55:59'),(66904,191,'Chainpura','304504',1,0,'2022-03-03 12:55:59','2022-03-03 12:55:59'),(66905,191,'Chainpuria','304021',1,0,'2022-03-03 12:55:59','2022-03-03 12:55:59'),(66906,191,'Chanani','304021',1,0,'2022-03-03 12:55:59','2022-03-03 12:55:59'),(66907,191,'Chandlai','304001',1,0,'2022-03-03 12:55:59','2022-03-03 12:55:59'),(66908,191,'Chandli','304803',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66909,191,'Chandsen','304501',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66910,191,'Chandwar','304802',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66911,191,'Charnet','304802',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66912,191,'Chaturbhujpura','304022',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66913,191,'Chavandia','304504',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66914,191,'Chhan','304001',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66915,191,'Chogai','304801',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66916,191,'Choru','304023',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66917,191,'Chosla','304504',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66918,191,'Dabar Kalan','304507',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66919,191,'Dabardumba','304505',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66920,191,'Dakhiya','304001',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66921,191,'Dangarthal','304021',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66922,191,'Dardahind','304001',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66923,191,'Dardaturki','304801',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66924,191,'Datob','304502',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66925,191,'Datwas','304025',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66926,191,'Dehlod','304025',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66927,191,'Deoli','304023',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66928,191,'Deoli Bazar','304804',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66929,191,'Deoli Bhanchi','304001',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66930,191,'Deoli Gaon','304804',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66931,191,'Deoli (Tonk)','304804',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66932,191,'Deshma','304504',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66933,191,'Dewarawas','304802',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66934,191,'Dholi','304504',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66935,191,'Dhuwan','304001',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66936,191,'Diggi','304504',1,0,'2022-03-03 12:56:00','2022-03-03 12:56:00'),(66937,191,'Dodwari','304001',1,0,'2022-03-03 12:56:01','2022-03-03 12:56:01'),(66938,191,'Dungri Kalan','304502',1,0,'2022-03-03 12:56:01','2022-03-03 12:56:01'),(66939,191,'Duni (Tonk)','304802',1,0,'2022-03-03 12:56:01','2022-03-03 12:56:01'),(66940,191,'Galod','304001',1,0,'2022-03-03 12:56:01','2022-03-03 12:56:01'),(66941,191,'Ganeti','304505',1,0,'2022-03-03 12:56:01','2022-03-03 12:56:01'),(66942,191,'Ganwar','304502',1,0,'2022-03-03 12:56:01','2022-03-03 12:56:01'),(66943,191,'Gaonri','304804',1,0,'2022-03-03 12:56:01','2022-03-03 12:56:01'),(66944,191,'Geroli','304001',1,0,'2022-03-03 12:56:01','2022-03-03 12:56:01'),(66945,191,'Ghad','304802',1,0,'2022-03-03 12:56:01','2022-03-03 12:56:01'),(66946,191,'Ghas','304001',1,0,'2022-03-03 12:56:01','2022-03-03 12:56:01'),(66947,191,'Gothara','304024',1,0,'2022-03-03 12:56:01','2022-03-03 12:56:01'),(66948,191,'Govt.College Tonk','304001',1,0,'2022-03-03 12:56:01','2022-03-03 12:56:01'),(66949,191,'Gurai','304802',1,0,'2022-03-03 12:56:01','2022-03-03 12:56:01'),(66950,191,'Hamirpur','304505',1,0,'2022-03-03 12:56:01','2022-03-03 12:56:01'),(66951,191,'Harchandera','304001',1,0,'2022-03-03 12:56:01','2022-03-03 12:56:01'),(66952,191,'Hatuna','304021',1,0,'2022-03-03 12:56:01','2022-03-03 12:56:01'),(66953,191,'Hedri Pura','304023',1,0,'2022-03-03 12:56:01','2022-03-03 12:56:01'),(66954,191,'Hisampur','304507',1,0,'2022-03-03 12:56:01','2022-03-03 12:56:01'),(66955,191,'Indokia','304505',1,0,'2022-03-03 12:56:01','2022-03-03 12:56:01'),(66956,191,'Indoli','304502',1,0,'2022-03-03 12:56:01','2022-03-03 12:56:01'),(66957,191,'Jamdoli','304025',1,0,'2022-03-03 12:56:01','2022-03-03 12:56:01'),(66958,191,'Jaulan','304021',1,0,'2022-03-03 12:56:01','2022-03-03 12:56:01'),(66959,191,'Jharli','304503',1,0,'2022-03-03 12:56:01','2022-03-03 12:56:01'),(66960,191,'Jhilai','304025',1,0,'2022-03-03 12:56:02','2022-03-03 12:56:02'),(66961,191,'Jhirana','304504',1,0,'2022-03-03 12:56:02','2022-03-03 12:56:02'),(66962,191,'Jhundwa','304024',1,0,'2022-03-03 12:56:02','2022-03-03 12:56:02'),(66963,191,'Jodhpuria','304022',1,0,'2022-03-03 12:56:02','2022-03-03 12:56:02'),(66964,191,'Jugalpura','304021',1,0,'2022-03-03 12:56:02','2022-03-03 12:56:02'),(66965,191,'Jumma Masjid Tonk','304001',1,0,'2022-03-03 12:56:02','2022-03-03 12:56:02'),(66966,191,'Juniya','304802',1,0,'2022-03-03 12:56:02','2022-03-03 12:56:02'),(66967,191,'Kabra','304001',1,0,'2022-03-03 12:56:02','2022-03-03 12:56:02'),(66968,191,'Kacholia','304503',1,0,'2022-03-03 12:56:02','2022-03-03 12:56:02'),(66969,191,'Kachrawata','304024',1,0,'2022-03-03 12:56:02','2022-03-03 12:56:02'),(66970,191,'Kadila','304501',1,0,'2022-03-03 12:56:02','2022-03-03 12:56:02'),(66971,191,'Kakalwad','304505',1,0,'2022-03-03 12:56:02','2022-03-03 12:56:02'),(66972,191,'Kakor','304024',1,0,'2022-03-03 12:56:02','2022-03-03 12:56:02'),(66973,191,'Kalmanda','304501',1,0,'2022-03-03 12:56:02','2022-03-03 12:56:02'),(66974,191,'Kantoli','304502',1,0,'2022-03-03 12:56:02','2022-03-03 12:56:02'),(66975,191,'Kanwara','304802',1,0,'2022-03-03 12:56:02','2022-03-03 12:56:02'),(66976,191,'Kaseer','304804',1,0,'2022-03-03 12:56:02','2022-03-03 12:56:02'),(66977,191,'Kashipura','304801',1,0,'2022-03-03 12:56:02','2022-03-03 12:56:02'),(66978,191,'Kathmana','304801',1,0,'2022-03-03 12:56:02','2022-03-03 12:56:02'),(66979,191,'Khandewat','304021',1,0,'2022-03-03 12:56:02','2022-03-03 12:56:02'),(66980,191,'Khandwa','304021',1,0,'2022-03-03 12:56:02','2022-03-03 12:56:02'),(66981,191,'Khareda','304505',1,0,'2022-03-03 12:56:02','2022-03-03 12:56:02'),(66982,191,'Khareda Bujurg','304025',1,0,'2022-03-03 12:56:02','2022-03-03 12:56:02'),(66983,191,'Khatoli','304024',1,0,'2022-03-03 12:56:02','2022-03-03 12:56:02'),(66984,191,'Khelniya','304024',1,0,'2022-03-03 12:56:03','2022-03-03 12:56:03'),(66985,191,'Khirgi','304025',1,0,'2022-03-03 12:56:03','2022-03-03 12:56:03'),(66986,191,'Kholiya','304023',1,0,'2022-03-03 12:56:03','2022-03-03 12:56:03'),(66987,191,'Kookar','304502',1,0,'2022-03-03 12:56:03','2022-03-03 12:56:03'),(66988,191,'Kuharakalan','304502',1,0,'2022-03-03 12:56:03','2022-03-03 12:56:03'),(66989,191,'Kunder','304023',1,0,'2022-03-03 12:56:03','2022-03-03 12:56:03'),(66990,191,'Kurar','304502',1,0,'2022-03-03 12:56:03','2022-03-03 12:56:03'),(66991,191,'Lalwadi','304025',1,0,'2022-03-03 12:56:03','2022-03-03 12:56:03'),(66992,191,'Lamba','304001',1,0,'2022-03-03 12:56:03','2022-03-03 12:56:03'),(66993,191,'Lamba Hari Singh','304503',1,0,'2022-03-03 12:56:03','2022-03-03 12:56:03'),(66994,191,'Lamba Kalan','304505',1,0,'2022-03-03 12:56:03','2022-03-03 12:56:03'),(66995,191,'Lawa','304504',1,0,'2022-03-03 12:56:03','2022-03-03 12:56:03'),(66996,191,'Lawadar','304001',1,0,'2022-03-03 12:56:03','2022-03-03 12:56:03'),(66997,191,'Laxmipura','304505',1,0,'2022-03-03 12:56:03','2022-03-03 12:56:03'),(66998,191,'Loharwara','304801',1,0,'2022-03-03 12:56:03','2022-03-03 12:56:03'),(66999,191,'Luhara','304021',1,0,'2022-03-03 12:56:03','2022-03-03 12:56:03'),(67000,191,'Mahapura','304025',1,0,'2022-03-03 12:56:03','2022-03-03 12:56:03'),(67001,191,'Maleda','304507',1,0,'2022-03-03 12:56:03','2022-03-03 12:56:03'),(67002,191,'Malikpur','304504',1,0,'2022-03-03 12:56:03','2022-03-03 12:56:03'),(67003,191,'Malpura','304502',1,0,'2022-03-03 12:56:03','2022-03-03 12:56:03'),(67004,191,'Mandawar','304001',1,0,'2022-03-03 12:56:03','2022-03-03 12:56:03'),(67005,191,'Mandawara','304023',1,0,'2022-03-03 12:56:03','2022-03-03 12:56:03'),(67006,191,'Mandolai','304502',1,0,'2022-03-03 12:56:03','2022-03-03 12:56:03'),(67007,191,'Mehandwas','304001',1,0,'2022-03-03 12:56:03','2022-03-03 12:56:03'),(67008,191,'Mehrun','304502',1,0,'2022-03-03 12:56:03','2022-03-03 12:56:03'),(67009,191,'Moar','304502',1,0,'2022-03-03 12:56:03','2022-03-03 12:56:03'),(67010,191,'Mohammed Garh','304024',1,0,'2022-03-03 12:56:04','2022-03-03 12:56:04'),(67011,191,'Mohammed Pura','304023',1,0,'2022-03-03 12:56:04','2022-03-03 12:56:04'),(67012,191,'Mor Bhatiyan','304505',1,0,'2022-03-03 12:56:04','2022-03-03 12:56:04'),(67013,191,'Morla','304503',1,0,'2022-03-03 12:56:04','2022-03-03 12:56:04'),(67014,191,'Mundia','304021',1,0,'2022-03-03 12:56:04','2022-03-03 12:56:04'),(67015,191,'Mundia Kalan','304505',1,0,'2022-03-03 12:56:04','2022-03-03 12:56:04'),(67016,191,'Nagar','304502',1,0,'2022-03-03 12:56:04','2022-03-03 12:56:04'),(67017,191,'Nagarfort','304024',1,0,'2022-03-03 12:56:04','2022-03-03 12:56:04'),(67018,191,'Naner','304504',1,0,'2022-03-03 12:56:04','2022-03-03 12:56:04'),(67019,191,'Nasirda','304507',1,0,'2022-03-03 12:56:04','2022-03-03 12:56:04'),(67020,191,'Natwara','304021',1,0,'2022-03-03 12:56:04','2022-03-03 12:56:04'),(67021,191,'Nayagaon','304025',1,0,'2022-03-03 12:56:04','2022-03-03 12:56:04'),(67022,191,'Newai RS','304021',1,0,'2022-03-03 12:56:04','2022-03-03 12:56:04'),(67023,191,'Newai','304021',1,0,'2022-03-03 12:56:04','2022-03-03 12:56:04'),(67024,191,'Nimera','304504',1,0,'2022-03-03 12:56:04','2022-03-03 12:56:04'),(67025,191,'Niwaria','304803',1,0,'2022-03-03 12:56:04','2022-03-03 12:56:04'),(67026,191,'Nohata','304025',1,0,'2022-03-03 12:56:04','2022-03-03 12:56:04'),(67027,191,'Pachewar','304502',1,0,'2022-03-03 12:56:04','2022-03-03 12:56:04'),(67028,191,'Pahari','304021',1,0,'2022-03-03 12:56:04','2022-03-03 12:56:04'),(67029,191,'Palai','304022',1,0,'2022-03-03 12:56:04','2022-03-03 12:56:04'),(67030,191,'Palai','304024',1,0,'2022-03-03 12:56:04','2022-03-03 12:56:04'),(67031,191,'Palda','304001',1,0,'2022-03-03 12:56:04','2022-03-03 12:56:04'),(67032,191,'Panwalia','304502',1,0,'2022-03-03 12:56:04','2022-03-03 12:56:04'),(67033,191,'Panwar','304803',1,0,'2022-03-03 12:56:04','2022-03-03 12:56:04'),(67034,191,'Parana','304021',1,0,'2022-03-03 12:56:04','2022-03-03 12:56:04'),(67035,191,'Parli','304502',1,0,'2022-03-03 12:56:05','2022-03-03 12:56:05'),(67036,191,'Pasrotia','304001',1,0,'2022-03-03 12:56:05','2022-03-03 12:56:05'),(67037,191,'Payga','304023',1,0,'2022-03-03 12:56:05','2022-03-03 12:56:05'),(67038,191,'Pchala','304023',1,0,'2022-03-03 12:56:05','2022-03-03 12:56:05'),(67039,191,'Peeplu','304801',1,0,'2022-03-03 12:56:05','2022-03-03 12:56:05'),(67040,191,'Phuleta','304024',1,0,'2022-03-03 12:56:05','2022-03-03 12:56:05'),(67041,191,'Phyawadi','304801',1,0,'2022-03-03 12:56:05','2022-03-03 12:56:05'),(67042,191,'Polyada','304803',1,0,'2022-03-03 12:56:06','2022-03-03 12:56:06'),(67043,191,'Purani Tonk','304001',1,0,'2022-03-03 12:56:06','2022-03-03 12:56:06'),(67044,191,'Quafala Bazar Tonk','304001',1,0,'2022-03-03 12:56:06','2022-03-03 12:56:06'),(67045,191,'Raholi','304022',1,0,'2022-03-03 12:56:06','2022-03-03 12:56:06'),(67046,191,'Raj.State Tennries Ltd.','304001',1,0,'2022-03-03 12:56:06','2022-03-03 12:56:06'),(67047,191,'Rajkot','304802',1,0,'2022-03-03 12:56:06','2022-03-03 12:56:06'),(67048,191,'Rajmahal','304804',1,0,'2022-03-03 12:56:06','2022-03-03 12:56:06'),(67049,191,'Rajpura','304502',1,0,'2022-03-03 12:56:06','2022-03-03 12:56:06'),(67050,191,'Rajwas','304021',1,0,'2022-03-03 12:56:06','2022-03-03 12:56:06'),(67051,191,'Ranipura','304024',1,0,'2022-03-03 12:56:06','2022-03-03 12:56:06'),(67052,191,'Ranoli','304801',1,0,'2022-03-03 12:56:06','2022-03-03 12:56:06'),(67053,191,'Reendliya','304502',1,0,'2022-03-03 12:56:06','2022-03-03 12:56:06'),(67054,191,'Reendliya Rampura','304502',1,0,'2022-03-03 12:56:06','2022-03-03 12:56:06'),(67055,191,'Roop Pura','304024',1,0,'2022-03-03 12:56:06','2022-03-03 12:56:06'),(67056,191,'Roopwas','304024',1,0,'2022-03-03 12:56:06','2022-03-03 12:56:06'),(67057,191,'Sandera','304801',1,0,'2022-03-03 12:56:06','2022-03-03 12:56:06'),(67058,191,'Sankhana','304001',1,0,'2022-03-03 12:56:07','2022-03-03 12:56:07'),(67059,191,'Santhali','304802',1,0,'2022-03-03 12:56:07','2022-03-03 12:56:07'),(67060,191,'Sanwaria','304502',1,0,'2022-03-03 12:56:07','2022-03-03 12:56:07'),(67061,191,'Sanwatgarh','304803',1,0,'2022-03-03 12:56:07','2022-03-03 12:56:07'),(67062,191,'Satwara','304802',1,0,'2022-03-03 12:56:07','2022-03-03 12:56:07'),(67063,191,'Seedra','304021',1,0,'2022-03-03 12:56:07','2022-03-03 12:56:07'),(67064,191,'Shop','304023',1,0,'2022-03-03 12:56:07','2022-03-03 12:56:07'),(67065,191,'Sindoliya','304503',1,0,'2022-03-03 12:56:07','2022-03-03 12:56:07'),(67066,191,'Siras','304021',1,0,'2022-03-03 12:56:07','2022-03-03 12:56:07'),(67067,191,'Sirohi','304025',1,0,'2022-03-03 12:56:07','2022-03-03 12:56:07'),(67068,191,'Sitapura','304802',1,0,'2022-03-03 12:56:07','2022-03-03 12:56:07'),(67069,191,'Sitarampura','304504',1,0,'2022-03-03 12:56:07','2022-03-03 12:56:07'),(67070,191,'Soda','304504',1,0,'2022-03-03 12:56:07','2022-03-03 12:56:07'),(67071,191,'Soda Baori','304504',1,0,'2022-03-03 12:56:07','2022-03-03 12:56:07'),(67072,191,'Sohela','304021',1,0,'2022-03-03 12:56:07','2022-03-03 12:56:07'),(67073,191,'Sonwa','304001',1,0,'2022-03-03 12:56:07','2022-03-03 12:56:07'),(67074,191,'Soran','304001',1,0,'2022-03-03 12:56:08','2022-03-03 12:56:08'),(67075,191,'Sunara','304022',1,0,'2022-03-03 12:56:08','2022-03-03 12:56:08'),(67076,191,'Sunthra','304024',1,0,'2022-03-03 12:56:08','2022-03-03 12:56:08'),(67077,191,'Sureli','304024',1,0,'2022-03-03 12:56:08','2022-03-03 12:56:08'),(67078,191,'Takholi','304001',1,0,'2022-03-03 12:56:08','2022-03-03 12:56:08'),(67079,191,'Thadoli','304505',1,0,'2022-03-03 12:56:08','2022-03-03 12:56:08'),(67080,191,'Thanwala','304507',1,0,'2022-03-03 12:56:08','2022-03-03 12:56:08'),(67081,191,'Tilanju','304502',1,0,'2022-03-03 12:56:08','2022-03-03 12:56:08'),(67082,191,'Titaria','304507',1,0,'2022-03-03 12:56:08','2022-03-03 12:56:08'),(67083,191,'Titonli(Badagaon)','304025',1,0,'2022-03-03 12:56:08','2022-03-03 12:56:08'),(67084,191,'Todarai Singh','304505',1,0,'2022-03-03 12:56:08','2022-03-03 12:56:08'),(67085,191,'Tonk Raj H.O','304001',1,0,'2022-03-03 12:56:08','2022-03-03 12:56:08'),(67086,191,'Tonkrawas','304802',1,0,'2022-03-03 12:56:08','2022-03-03 12:56:08'),(67087,191,'Tordisagar','304502',1,0,'2022-03-03 12:56:08','2022-03-03 12:56:08'),(67088,191,'Uniara Khurd','304502',1,0,'2022-03-03 12:56:08','2022-03-03 12:56:08'),(67089,191,'Uniara','304024',1,0,'2022-03-03 12:56:08','2022-03-03 12:56:08'),(67090,191,'Wazirpura','304001',1,0,'2022-03-03 12:56:08','2022-03-03 12:56:08'),(67091,192,'Add','313611',1,0,'2022-03-03 12:56:08','2022-03-03 12:56:08'),(67092,192,'Adiwali','313804',1,0,'2022-03-03 12:56:08','2022-03-03 12:56:08'),(67093,192,'Adkalia','313027',1,0,'2022-03-03 12:56:08','2022-03-03 12:56:08'),(67094,192,'Adkalia','313702',1,0,'2022-03-03 12:56:08','2022-03-03 12:56:08'),(67095,192,'Adwas','313703',1,0,'2022-03-03 12:56:08','2022-03-03 12:56:08'),(67096,192,'Agad','313604',1,0,'2022-03-03 12:56:08','2022-03-03 12:56:08'),(67097,192,'Ajbara','313703',1,0,'2022-03-03 12:56:08','2022-03-03 12:56:08'),(67098,192,'Akola','313604',1,0,'2022-03-03 12:56:09','2022-03-03 12:56:09'),(67099,192,'Alsigarh','313031',1,0,'2022-03-03 12:56:09','2022-03-03 12:56:09'),(67100,192,'Amar Pura','313604',1,0,'2022-03-03 12:56:09','2022-03-03 12:56:09'),(67101,192,'Amar Pura','313602',1,0,'2022-03-03 12:56:09','2022-03-03 12:56:09'),(67102,192,'Ambassa','313701',1,0,'2022-03-03 12:56:09','2022-03-03 12:56:09'),(67103,192,'Amiwara','313701',1,0,'2022-03-03 12:56:09','2022-03-03 12:56:09'),(67104,192,'Amlia','313701',1,0,'2022-03-03 12:56:09','2022-03-03 12:56:09'),(67105,192,'Amloda','313038',1,0,'2022-03-03 12:56:09','2022-03-03 12:56:09'),(67106,192,'Anant','313611',1,0,'2022-03-03 12:56:09','2022-03-03 12:56:09'),(67107,192,'Anjani','313604',1,0,'2022-03-03 12:56:09','2022-03-03 12:56:09'),(67108,192,'Arinda','313602',1,0,'2022-03-03 12:56:09','2022-03-03 12:56:09'),(67109,192,'Arnia','313604',1,0,'2022-03-03 12:56:09','2022-03-03 12:56:09'),(67110,192,'ARS Station','313601',1,0,'2022-03-03 12:56:09','2022-03-03 12:56:09'),(67111,192,'B K Kherwara','313702',1,0,'2022-03-03 12:56:09','2022-03-03 12:56:09'),(67112,192,'Baalicha','313604',1,0,'2022-03-03 12:56:09','2022-03-03 12:56:09'),(67113,192,'Badawali','313026',1,0,'2022-03-03 12:56:09','2022-03-03 12:56:09'),(67114,192,'Badgaon','313603',1,0,'2022-03-03 12:56:09','2022-03-03 12:56:09'),(67115,192,'Badgaon','313905',1,0,'2022-03-03 12:56:09','2022-03-03 12:56:09'),(67116,192,'Badgaon','313205',1,0,'2022-03-03 12:56:09','2022-03-03 12:56:09'),(67117,192,'Badgaon','313011',1,0,'2022-03-03 12:56:09','2022-03-03 12:56:09'),(67118,192,'Badla','313803',1,0,'2022-03-03 12:56:09','2022-03-03 12:56:09'),(67119,192,'Bagdunda','313705',1,0,'2022-03-03 12:56:10','2022-03-03 12:56:10'),(67120,192,'Baggad','313602',1,0,'2022-03-03 12:56:10','2022-03-03 12:56:10'),(67121,192,'Baghpura','313031',1,0,'2022-03-03 12:56:10','2022-03-03 12:56:10'),(67122,192,'Bakhel','307025',1,0,'2022-03-03 12:56:10','2022-03-03 12:56:10'),(67123,192,'Balathal','313601',1,0,'2022-03-03 12:56:10','2022-03-03 12:56:10'),(67124,192,'Balicha','313001',1,0,'2022-03-03 12:56:10','2022-03-03 12:56:10'),(67125,192,'Balicha','313804',1,0,'2022-03-03 12:56:10','2022-03-03 12:56:10'),(67126,192,'Ballabh','313706',1,0,'2022-03-03 12:56:10','2022-03-03 12:56:10'),(67127,192,'Balua','313802',1,0,'2022-03-03 12:56:10','2022-03-03 12:56:10'),(67128,192,'Bambora','313706',1,0,'2022-03-03 12:56:10','2022-03-03 12:56:10'),(67129,192,'Bamnia','313027',1,0,'2022-03-03 12:56:10','2022-03-03 12:56:10'),(67130,192,'Bana Khurd','313902',1,0,'2022-03-03 12:56:10','2022-03-03 12:56:10'),(67131,192,'Banoda','313027',1,0,'2022-03-03 12:56:10','2022-03-03 12:56:10'),(67132,192,'Bansada','313603',1,0,'2022-03-03 12:56:10','2022-03-03 12:56:10'),(67133,192,'Barapal','313801',1,0,'2022-03-03 12:56:10','2022-03-03 12:56:10'),(67134,192,'Barda','313011',1,0,'2022-03-03 12:56:10','2022-03-03 12:56:10'),(67135,192,'Bari Tb (S)','313011',1,0,'2022-03-03 12:56:11','2022-03-03 12:56:11'),(67136,192,'Bari Undri','313031',1,0,'2022-03-03 12:56:11','2022-03-03 12:56:11'),(67137,192,'Barli','307025',1,0,'2022-03-03 12:56:11','2022-03-03 12:56:11'),(67138,192,'Baroda','313026',1,0,'2022-03-03 12:56:11','2022-03-03 12:56:11'),(67139,192,'Barodia','313602',1,0,'2022-03-03 12:56:11','2022-03-03 12:56:11'),(67140,192,'Barothi','313803',1,0,'2022-03-03 12:56:11','2022-03-03 12:56:11'),(67141,192,'Bassi','313027',1,0,'2022-03-03 12:56:11','2022-03-03 12:56:11'),(67142,192,'Bassi Junjawat','313027',1,0,'2022-03-03 12:56:11','2022-03-03 12:56:11'),(67143,192,'Batharda Kalan','313602',1,0,'2022-03-03 12:56:11','2022-03-03 12:56:11'),(67144,192,'Batharda Khurd','313602',1,0,'2022-03-03 12:56:11','2022-03-03 12:56:11'),(67145,192,'Bawalwara','313803',1,0,'2022-03-03 12:56:11','2022-03-03 12:56:11'),(67146,192,'Bayri','313803',1,0,'2022-03-03 12:56:11','2022-03-03 12:56:11'),(67147,192,'Bedawal','313027',1,0,'2022-03-03 12:56:11','2022-03-03 12:56:11'),(67148,192,'Bedla','313011',1,0,'2022-03-03 12:56:11','2022-03-03 12:56:11'),(67149,192,'Beerothi','313906',1,0,'2022-03-03 12:56:11','2022-03-03 12:56:11'),(67150,192,'Bekria','313708',1,0,'2022-03-03 12:56:11','2022-03-03 12:56:11'),(67151,192,'Bemla','313703',1,0,'2022-03-03 12:56:11','2022-03-03 12:56:11'),(67152,192,'Bhabrana','313038',1,0,'2022-03-03 12:56:11','2022-03-03 12:56:11'),(67153,192,'Bhadviguda','313705',1,0,'2022-03-03 12:56:11','2022-03-03 12:56:11'),(67154,192,'Bhalon Ka Guda','313024',1,0,'2022-03-03 12:56:11','2022-03-03 12:56:11'),(67155,192,'Bhanda','313803',1,0,'2022-03-03 12:56:11','2022-03-03 12:56:11'),(67156,192,'Bhansol Garwara','313204',1,0,'2022-03-03 12:56:12','2022-03-03 12:56:12'),(67157,192,'Bharev','313604',1,0,'2022-03-03 12:56:12','2022-03-03 12:56:12'),(67158,192,'Bharkundi','313611',1,0,'2022-03-03 12:56:12','2022-03-03 12:56:12'),(67159,192,'Bhatewaar','313601',1,0,'2022-03-03 12:56:12','2022-03-03 12:56:12'),(67160,192,'Bhensda Kalan','313024',1,0,'2022-03-03 12:56:12','2022-03-03 12:56:12'),(67161,192,'Bhimal','313203',1,0,'2022-03-03 12:56:12','2022-03-03 12:56:12'),(67162,192,'Bhinder (Udaipur)','313603',1,0,'2022-03-03 12:56:12','2022-03-03 12:56:12'),(67163,192,'Bhoiyon Ki Pancholi','313003',1,0,'2022-03-03 12:56:12','2022-03-03 12:56:12'),(67164,192,'Bhojpur','313605',1,0,'2022-03-03 12:56:12','2022-03-03 12:56:12'),(67165,192,'Bhopa Khera','313603',1,0,'2022-03-03 12:56:12','2022-03-03 12:56:12'),(67166,192,'Bhoraipal','313026',1,0,'2022-03-03 12:56:12','2022-03-03 12:56:12'),(67167,192,'Bhudar','313802',1,0,'2022-03-03 12:56:12','2022-03-03 12:56:12'),(67168,192,'Bhutala','313011',1,0,'2022-03-03 12:56:12','2022-03-03 12:56:12'),(67169,192,'Bhuwana','313001',1,0,'2022-03-03 12:56:12','2022-03-03 12:56:12'),(67170,192,'Bichhadi','313024',1,0,'2022-03-03 12:56:12','2022-03-03 12:56:12'),(67171,192,'Bichhiwara','313701',1,0,'2022-03-03 12:56:13','2022-03-03 12:56:13'),(67172,192,'Bijanwas','313201',1,0,'2022-03-03 12:56:13','2022-03-03 12:56:13'),(67173,192,'Bikarni','307025',1,0,'2022-03-03 12:56:13','2022-03-03 12:56:13'),(67174,192,'Bilakh','313802',1,0,'2022-03-03 12:56:13','2022-03-03 12:56:13'),(67175,192,'Boria','313611',1,0,'2022-03-03 12:56:13','2022-03-03 12:56:13'),(67176,192,'Boyana','313201',1,0,'2022-03-03 12:56:13','2022-03-03 12:56:13'),(67177,192,'Budel','313038',1,0,'2022-03-03 12:56:13','2022-03-03 12:56:13'),(67178,192,'Bujhra','313031',1,0,'2022-03-03 12:56:13','2022-03-03 12:56:13'),(67179,192,'Chanawada','313801',1,0,'2022-03-03 12:56:13','2022-03-03 12:56:13'),(67180,192,'Chandesara','313201',1,0,'2022-03-03 12:56:13','2022-03-03 12:56:13'),(67181,192,'Chandora','313903',1,0,'2022-03-03 12:56:13','2022-03-03 12:56:13'),(67182,192,'Changedi','313205',1,0,'2022-03-03 12:56:13','2022-03-03 12:56:13'),(67183,192,'Chansda','313015',1,0,'2022-03-03 12:56:13','2022-03-03 12:56:13'),(67184,192,'Chargadia','313603',1,0,'2022-03-03 12:56:13','2022-03-03 12:56:13'),(67185,192,'Chari','313605',1,0,'2022-03-03 12:56:13','2022-03-03 12:56:13'),(67186,192,'Chatia Khedi','313705',1,0,'2022-03-03 12:56:13','2022-03-03 12:56:13'),(67187,192,'Chatpur','313905',1,0,'2022-03-03 12:56:13','2022-03-03 12:56:13'),(67188,192,'Chawand','313904',1,0,'2022-03-03 12:56:13','2022-03-03 12:56:13'),(67189,192,'Chhali','313705',1,0,'2022-03-03 12:56:13','2022-03-03 12:56:13'),(67190,192,'Chhani (Udaipur)','313804',1,0,'2022-03-03 12:56:13','2022-03-03 12:56:13'),(67191,192,'Chiboda','313027',1,0,'2022-03-03 12:56:13','2022-03-03 12:56:13'),(67192,192,'Chorai','313903',1,0,'2022-03-03 12:56:13','2022-03-03 12:56:13'),(67193,192,'Chorbaori','313705',1,0,'2022-03-03 12:56:13','2022-03-03 12:56:13'),(67194,192,'Dabaycha','313804',1,0,'2022-03-03 12:56:13','2022-03-03 12:56:13'),(67195,192,'Dabok','313022',1,0,'2022-03-03 12:56:13','2022-03-03 12:56:13'),(67196,192,'Dagar','313026',1,0,'2022-03-03 12:56:14','2022-03-03 12:56:14'),(67197,192,'Daiya','313701',1,0,'2022-03-03 12:56:14','2022-03-03 12:56:14'),(67198,192,'Dakan Kotra','313001',1,0,'2022-03-03 12:56:14','2022-03-03 12:56:14'),(67199,192,'Dal','313027',1,0,'2022-03-03 12:56:14','2022-03-03 12:56:14'),(67200,192,'Damana','313702',1,0,'2022-03-03 12:56:14','2022-03-03 12:56:14'),(67201,192,'Dantalia','313605',1,0,'2022-03-03 12:56:14','2022-03-03 12:56:14'),(67202,192,'Dantesar','313703',1,0,'2022-03-03 12:56:14','2022-03-03 12:56:14'),(67203,192,'Daroli','313022',1,0,'2022-03-03 12:56:14','2022-03-03 12:56:14'),(67204,192,'Dayli','313902',1,0,'2022-03-03 12:56:14','2022-03-03 12:56:14'),(67205,192,'Debari','313024',1,0,'2022-03-03 12:56:14','2022-03-03 12:56:14'),(67206,192,'Deogam','313027',1,0,'2022-03-03 12:56:14','2022-03-03 12:56:14'),(67207,192,'Deolia','313604',1,0,'2022-03-03 12:56:14','2022-03-03 12:56:14'),(67208,192,'Deopura','313901',1,0,'2022-03-03 12:56:14','2022-03-03 12:56:14'),(67209,192,'Depur','313903',1,0,'2022-03-03 12:56:14','2022-03-03 12:56:14'),(67210,192,'Deri','313804',1,0,'2022-03-03 12:56:14','2022-03-03 12:56:14'),(67211,192,'Devla','313605',1,0,'2022-03-03 12:56:14','2022-03-03 12:56:14'),(67212,192,'Dewas','313702',1,0,'2022-03-03 12:56:14','2022-03-03 12:56:14'),(67213,192,'Dhamania','313601',1,0,'2022-03-03 12:56:14','2022-03-03 12:56:14'),(67214,192,'Dhamniya','313604',1,0,'2022-03-03 12:56:14','2022-03-03 12:56:14'),(67215,192,'Dhankiwara','313903',1,0,'2022-03-03 12:56:14','2022-03-03 12:56:14'),(67216,192,'Dhariawad','313605',1,0,'2022-03-03 12:56:14','2022-03-03 12:56:14'),(67217,192,'Dharod','313027',1,0,'2022-03-03 12:56:14','2022-03-03 12:56:14'),(67218,192,'Dhavdi','313706',1,0,'2022-03-03 12:56:15','2022-03-03 12:56:15'),(67219,192,'Dhedmaria','307025',1,0,'2022-03-03 12:56:15','2022-03-03 12:56:15'),(67220,192,'Dheemari','313702',1,0,'2022-03-03 12:56:15','2022-03-03 12:56:15'),(67221,192,'Dhelana','313903',1,0,'2022-03-03 12:56:15','2022-03-03 12:56:15'),(67222,192,'Dhikiya','313604',1,0,'2022-03-03 12:56:15','2022-03-03 12:56:15'),(67223,192,'Dhingri','313905',1,0,'2022-03-03 12:56:15','2022-03-03 12:56:15'),(67224,192,'Dhinkli','313001',1,0,'2022-03-03 12:56:15','2022-03-03 12:56:15'),(67225,192,'Dhinkwas','313803',1,0,'2022-03-03 12:56:15','2022-03-03 12:56:15'),(67226,192,'Dhol','313708',1,0,'2022-03-03 12:56:15','2022-03-03 12:56:15'),(67227,192,'Dholgiri Ka Khera','313038',1,0,'2022-03-03 12:56:15','2022-03-03 12:56:15'),(67228,192,'Dholi Magri','313201',1,0,'2022-03-03 12:56:15','2022-03-03 12:56:15'),(67229,192,'Dholia','313604',1,0,'2022-03-03 12:56:15','2022-03-03 12:56:15'),(67230,192,'Dhundi','313001',1,0,'2022-03-03 12:56:15','2022-03-03 12:56:15'),(67231,192,'Dhundia','313603',1,0,'2022-03-03 12:56:15','2022-03-03 12:56:15'),(67232,192,'Dodawali','313702',1,0,'2022-03-03 12:56:15','2022-03-03 12:56:15'),(67233,192,'Fatehnagar (Udaipur)','313205',1,0,'2022-03-03 12:56:16','2022-03-03 12:56:16'),(67234,192,'Fatehpur','313001',1,0,'2022-03-03 12:56:16','2022-03-03 12:56:16'),(67235,192,'Gadoli','313203',1,0,'2022-03-03 12:56:16','2022-03-03 12:56:16'),(67236,192,'Gadriawas','313605',1,0,'2022-03-03 12:56:16','2022-03-03 12:56:16'),(67237,192,'Gadwas','313605',1,0,'2022-03-03 12:56:16','2022-03-03 12:56:16'),(67238,192,'Gamda Pal','313027',1,0,'2022-03-03 12:56:16','2022-03-03 12:56:16'),(67239,192,'Garnalakotra','313802',1,0,'2022-03-03 12:56:16','2022-03-03 12:56:16'),(67240,192,'Gejvi','313906',1,0,'2022-03-03 12:56:16','2022-03-03 12:56:16'),(67241,192,'Ghasa','313201',1,0,'2022-03-03 12:56:16','2022-03-03 12:56:16'),(67242,192,'Ghated','313038',1,0,'2022-03-03 12:56:16','2022-03-03 12:56:16'),(67243,192,'Ghatod','313905',1,0,'2022-03-03 12:56:16','2022-03-03 12:56:16'),(67244,192,'Ghodi','313803',1,0,'2022-03-03 12:56:16','2022-03-03 12:56:16'),(67245,192,'Gingla','313706',1,0,'2022-03-03 12:56:16','2022-03-03 12:56:16'),(67246,192,'Godach','313011',1,0,'2022-03-03 12:56:16','2022-03-03 12:56:16'),(67247,192,'Godana','313702',1,0,'2022-03-03 12:56:17','2022-03-03 12:56:17'),(67248,192,'Godasar','313026',1,0,'2022-03-03 12:56:17','2022-03-03 12:56:17'),(67249,192,'Godawat Gorimba','313802',1,0,'2022-03-03 12:56:17','2022-03-03 12:56:17'),(67250,192,'Gogala','313702',1,0,'2022-03-03 12:56:17','2022-03-03 12:56:17'),(67251,192,'Gogrood','313708',1,0,'2022-03-03 12:56:17','2022-03-03 12:56:17'),(67252,192,'Gogunda','313705',1,0,'2022-03-03 12:56:17','2022-03-03 12:56:17'),(67253,192,'Gopalpura','313611',1,0,'2022-03-03 12:56:17','2022-03-03 12:56:17'),(67254,192,'Gorana','313702',1,0,'2022-03-03 12:56:17','2022-03-03 12:56:17'),(67255,192,'Gudel','313706',1,0,'2022-03-03 12:56:17','2022-03-03 12:56:17'),(67256,192,'Gudli','313024',1,0,'2022-03-03 12:56:17','2022-03-03 12:56:17'),(67257,192,'Gupri','313022',1,0,'2022-03-03 12:56:17','2022-03-03 12:56:17'),(67258,192,'Guran','307025',1,0,'2022-03-03 12:56:17','2022-03-03 12:56:17'),(67259,192,'Harshawara','313804',1,0,'2022-03-03 12:56:17','2022-03-03 12:56:17'),(67260,192,'Hinta','313603',1,0,'2022-03-03 12:56:17','2022-03-03 12:56:17'),(67261,192,'Idana','313706',1,0,'2022-03-03 12:56:17','2022-03-03 12:56:17'),(67262,192,'Intali','313205',1,0,'2022-03-03 12:56:17','2022-03-03 12:56:17'),(67263,192,'Intali Khera','313026',1,0,'2022-03-03 12:56:17','2022-03-03 12:56:17'),(67264,192,'Intali Pal','313026',1,0,'2022-03-03 12:56:17','2022-03-03 12:56:17'),(67265,192,'Isarwas Dangiyan','313027',1,0,'2022-03-03 12:56:17','2022-03-03 12:56:17'),(67266,192,'Iswal','313011',1,0,'2022-03-03 12:56:17','2022-03-03 12:56:17'),(67267,192,'Jagat','313703',1,0,'2022-03-03 12:56:17','2022-03-03 12:56:17'),(67268,192,'Jambuda','313027',1,0,'2022-03-03 12:56:17','2022-03-03 12:56:17'),(67269,192,'Jambuda','313903',1,0,'2022-03-03 12:56:17','2022-03-03 12:56:17'),(67270,192,'Jaswantgarh','313708',1,0,'2022-03-03 12:56:17','2022-03-03 12:56:17'),(67271,192,'Jawad','313703',1,0,'2022-03-03 12:56:17','2022-03-03 12:56:17'),(67272,192,'Jawad','313204',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67273,192,'Jawar','313901',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67274,192,'Jawas','313803',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67275,192,'Jayra','313804',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67276,192,'Jed','307025',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67277,192,'Jekra','313031',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67278,192,'Jetana','313038',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67279,192,'Jhadol (P)','313702',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67280,192,'Jhadol (S)','313905',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67281,192,'Jhadoli','313605',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67282,192,'Jhadoli','313708',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67283,192,'Jhallara','313038',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67284,192,'Jhamar Kotra','313015',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67285,192,'Jodhpur Khurd','313038',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67286,192,'Jogiwara','307025',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67287,192,'Juda','307025',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67288,192,'Kachhaba','313705',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67289,192,'Kadia','313011',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67290,192,'Kagdar','313802',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67291,192,'Kagwas','307025',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67292,192,'Kaladwas','313003',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67293,192,'Kali Bhit','313604',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67294,192,'Kalyankalan','313038',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67295,192,'Kalyanpur','313903',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67296,192,'Kanbai','313804',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67297,192,'Kanore','313604',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67298,192,'Kanpur','313003',1,0,'2022-03-03 12:56:18','2022-03-03 12:56:18'),(67299,192,'Kantora','313905',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67300,192,'Kanuwara','313802',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67301,192,'Karakalan','313038',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67302,192,'Karanpur','313601',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67303,192,'Karawada','313804',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67304,192,'Karawali','313027',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67305,192,'Karchha','313803',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67306,192,'Karda','313001',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67307,192,'Katanwara','313902',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67308,192,'Katarwas','313803',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67309,192,'Katev','313026',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67310,192,'Kathar','313001',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67311,192,'Kaya','313801',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67312,192,'Kejad','313902',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67313,192,'Keshariawad','313605',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67314,192,'Kewda Khurd','313001',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67315,192,'Khajuria','307025',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67316,192,'Khakhad','313702',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67317,192,'Khandiobri','313803',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67318,192,'Khanmeen','313803',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67319,192,'Kharka','313027',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67320,192,'Kharsan','313602',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67321,192,'Kharwa','313015',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67322,192,'Khedi','313022',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67323,192,'Khemli','313201',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67324,192,'Khempur','313203',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67325,192,'Kherad','313027',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67326,192,'Kheroda','313602',1,0,'2022-03-03 12:56:19','2022-03-03 12:56:19'),(67327,192,'Kherwara','313803',1,0,'2022-03-03 12:56:20','2022-03-03 12:56:20'),(67328,192,'Khunta','313611',1,0,'2022-03-03 12:56:20','2022-03-03 12:56:20'),(67329,192,'Kikawas','313601',1,0,'2022-03-03 12:56:20','2022-03-03 12:56:20'),(67330,192,'Kkunthwas','313603',1,0,'2022-03-03 12:56:20','2022-03-03 12:56:20'),(67331,192,'Kojawara','313802',1,0,'2022-03-03 12:56:20','2022-03-03 12:56:20'),(67332,192,'Kolar','313903',1,0,'2022-03-03 12:56:20','2022-03-03 12:56:20'),(67333,192,'Kolyari','313701',1,0,'2022-03-03 12:56:20','2022-03-03 12:56:20'),(67334,192,'Kotra (Udaipur)','307025',1,0,'2022-03-03 12:56:20','2022-03-03 12:56:20'),(67335,192,'Kun','313604',1,0,'2022-03-03 12:56:20','2022-03-03 12:56:20'),(67336,192,'Kunda','313903',1,0,'2022-03-03 12:56:20','2022-03-03 12:56:20'),(67337,192,'Kundai','313603',1,0,'2022-03-03 12:56:20','2022-03-03 12:56:20'),(67338,192,'Kuradia','313903',1,0,'2022-03-03 12:56:20','2022-03-03 12:56:20'),(67339,192,'Kurawar (Udaipur)','313703',1,0,'2022-03-03 12:56:20','2022-03-03 12:56:20'),(67340,192,'Kyari','313708',1,0,'2022-03-03 12:56:20','2022-03-03 12:56:20'),(67341,192,'Ladani','313203',1,0,'2022-03-03 12:56:20','2022-03-03 12:56:20'),(67342,192,'Lakadwas','313003',1,0,'2022-03-03 12:56:20','2022-03-03 12:56:20'),(67343,192,'Lakhawali','313011',1,0,'2022-03-03 12:56:20','2022-03-03 12:56:20'),(67344,192,'Laku Ka Lewa','313604',1,0,'2022-03-03 12:56:20','2022-03-03 12:56:20'),(67345,192,'Larathi','313803',1,0,'2022-03-03 12:56:20','2022-03-03 12:56:20'),(67346,192,'Lasadia','313604',1,0,'2022-03-03 12:56:20','2022-03-03 12:56:20'),(67347,192,'Lathuni','313701',1,0,'2022-03-03 12:56:20','2022-03-03 12:56:20'),(67348,192,'Lodia','313611',1,0,'2022-03-03 12:56:20','2022-03-03 12:56:20'),(67349,192,'Lohagarh','313605',1,0,'2022-03-03 12:56:20','2022-03-03 12:56:20'),(67350,192,'Loharcha','313708',1,0,'2022-03-03 12:56:21','2022-03-03 12:56:21'),(67351,192,'Lopada','313203',1,0,'2022-03-03 12:56:21','2022-03-03 12:56:21'),(67352,192,'Losing','313011',1,0,'2022-03-03 12:56:21','2022-03-03 12:56:21'),(67353,192,'Loyra','313011',1,0,'2022-03-03 12:56:21','2022-03-03 12:56:21'),(67354,192,'Lunda','313604',1,0,'2022-03-03 12:56:21','2022-03-03 12:56:21'),(67355,192,'Mada','313705',1,0,'2022-03-03 12:56:21','2022-03-03 12:56:21'),(67356,192,'Madar','313011',1,0,'2022-03-03 12:56:21','2022-03-03 12:56:21'),(67357,192,'Madla','313031',1,0,'2022-03-03 12:56:21','2022-03-03 12:56:21'),(67358,192,'Madri','313031',1,0,'2022-03-03 12:56:21','2022-03-03 12:56:21'),(67359,192,'Mahad','307025',1,0,'2022-03-03 12:56:21','2022-03-03 12:56:21'),(67360,192,'Mahadi','307025',1,0,'2022-03-03 12:56:21','2022-03-03 12:56:21'),(67361,192,'Mahuda','313204',1,0,'2022-03-03 12:56:21','2022-03-03 12:56:21'),(67362,192,'Mahuwara','313901',1,0,'2022-03-03 12:56:21','2022-03-03 12:56:21'),(67363,192,'Majawad','313705',1,0,'2022-03-03 12:56:21','2022-03-03 12:56:21'),(67364,192,'Majawada','313602',1,0,'2022-03-03 12:56:21','2022-03-03 12:56:21'),(67365,192,'Majawadi','313705',1,0,'2022-03-03 12:56:21','2022-03-03 12:56:21'),(67366,192,'Makradeo','313031',1,0,'2022-03-03 12:56:21','2022-03-03 12:56:21'),(67367,192,'Mallada','313026',1,0,'2022-03-03 12:56:21','2022-03-03 12:56:21'),(67368,192,'Malpur','313027',1,0,'2022-03-03 12:56:21','2022-03-03 12:56:21'),(67369,192,'Malwa Ka Chora','313708',1,0,'2022-03-03 12:56:21','2022-03-03 12:56:21'),(67370,192,'Mamer','307025',1,0,'2022-03-03 12:56:21','2022-03-03 12:56:21'),(67371,192,'Managaon','313605',1,0,'2022-03-03 12:56:21','2022-03-03 12:56:21'),(67372,192,'Mandawal','307025',1,0,'2022-03-03 12:56:21','2022-03-03 12:56:21'),(67373,192,'Mandvi','313611',1,0,'2022-03-03 12:56:21','2022-03-03 12:56:21'),(67374,192,'Mandwa','307025',1,0,'2022-03-03 12:56:22','2022-03-03 12:56:22'),(67375,192,'Manpur','313038',1,0,'2022-03-03 12:56:22','2022-03-03 12:56:22'),(67376,192,'Manpur','313701',1,0,'2022-03-03 12:56:22','2022-03-03 12:56:22'),(67377,192,'Massaron Ki Obri','313802',1,0,'2022-03-03 12:56:22','2022-03-03 12:56:22'),(67378,192,'Matasula','313038',1,0,'2022-03-03 12:56:22','2022-03-03 12:56:22'),(67379,192,'Matoon','313003',1,0,'2022-03-03 12:56:22','2022-03-03 12:56:22'),(67380,192,'Mavli Jn.','313203',1,0,'2022-03-03 12:56:22','2022-03-03 12:56:22'),(67381,192,'Mayada','313706',1,0,'2022-03-03 12:56:22','2022-03-03 12:56:22'),(67382,192,'Medi','307025',1,0,'2022-03-03 12:56:22','2022-03-03 12:56:22'),(67383,192,'Medi Dhani','313903',1,0,'2022-03-03 12:56:22','2022-03-03 12:56:22'),(67384,192,'Menar','313602',1,0,'2022-03-03 12:56:22','2022-03-03 12:56:22'),(67385,192,'Merpur','307025',1,0,'2022-03-03 12:56:22','2022-03-03 12:56:22'),(67386,192,'Merta','313022',1,0,'2022-03-03 12:56:22','2022-03-03 12:56:22'),(67387,192,'Methudi','313703',1,0,'2022-03-03 12:56:22','2022-03-03 12:56:22'),(67388,192,'Mewaron Ka Math','313708',1,0,'2022-03-03 12:56:22','2022-03-03 12:56:22'),(67389,192,'Modi','313705',1,0,'2022-03-03 12:56:22','2022-03-03 12:56:22'),(67390,192,'Modi','313602',1,0,'2022-03-03 12:56:22','2022-03-03 12:56:22'),(67391,192,'Mohd. Phalasia','313702',1,0,'2022-03-03 12:56:22','2022-03-03 12:56:22'),(67392,192,'Morila','313027',1,0,'2022-03-03 12:56:22','2022-03-03 12:56:22'),(67393,192,'Morwal','313705',1,0,'2022-03-03 12:56:22','2022-03-03 12:56:22'),(67394,192,'Motida','313603',1,0,'2022-03-03 12:56:22','2022-03-03 12:56:22'),(67395,192,'Mungana','313611',1,0,'2022-03-03 12:56:23','2022-03-03 12:56:23'),(67396,192,'Nahar Magra','313201',1,0,'2022-03-03 12:56:23','2022-03-03 12:56:23'),(67397,192,'Nai','313031',1,0,'2022-03-03 12:56:23','2022-03-03 12:56:23'),(67398,192,'Naijhar','313703',1,0,'2022-03-03 12:56:23','2022-03-03 12:56:23'),(67399,192,'Nal','313705',1,0,'2022-03-03 12:56:23','2022-03-03 12:56:23'),(67400,192,'Nalva','313605',1,0,'2022-03-03 12:56:23','2022-03-03 12:56:23'),(67401,192,'Nandeshma','313708',1,0,'2022-03-03 12:56:23','2022-03-03 12:56:23'),(67402,192,'Nandwel','313022',1,0,'2022-03-03 12:56:23','2022-03-03 12:56:23'),(67403,192,'Nathara','313902',1,0,'2022-03-03 12:56:23','2022-03-03 12:56:23'),(67404,192,'Navda','313903',1,0,'2022-03-03 12:56:23','2022-03-03 12:56:23'),(67405,192,'Nawania','313601',1,0,'2022-03-03 12:56:23','2022-03-03 12:56:23'),(67406,192,'Nayagaon','313804',1,0,'2022-03-03 12:56:23','2022-03-03 12:56:23'),(67407,192,'Nayagaon','313038',1,0,'2022-03-03 12:56:23','2022-03-03 12:56:23'),(67408,192,'Nayawas','307025',1,0,'2022-03-03 12:56:23','2022-03-03 12:56:23'),(67409,192,'Nedach','313011',1,0,'2022-03-03 12:56:23','2022-03-03 12:56:23'),(67410,192,'Nichli Sigri','313701',1,0,'2022-03-03 12:56:23','2022-03-03 12:56:23'),(67411,192,'Noli','313026',1,0,'2022-03-03 12:56:23','2022-03-03 12:56:23'),(67412,192,'Noorda','313204',1,0,'2022-03-03 12:56:23','2022-03-03 12:56:23'),(67413,192,'Obra Kalan','313705',1,0,'2022-03-03 12:56:23','2022-03-03 12:56:23'),(67414,192,'Oda','313701',1,0,'2022-03-03 12:56:23','2022-03-03 12:56:23'),(67415,192,'Ogna','313906',1,0,'2022-03-03 12:56:23','2022-03-03 12:56:23'),(67416,192,'Onarsingh Ki Bhagal','313602',1,0,'2022-03-03 12:56:23','2022-03-03 12:56:23'),(67417,192,'Orwaria','313027',1,0,'2022-03-03 12:56:23','2022-03-03 12:56:23'),(67418,192,'Padawali','313906',1,0,'2022-03-03 12:56:23','2022-03-03 12:56:23'),(67419,192,'Paderi','313802',1,0,'2022-03-03 12:56:24','2022-03-03 12:56:24'),(67420,192,'Padla','313901',1,0,'2022-03-03 12:56:24','2022-03-03 12:56:24'),(67421,192,'Paduna','313801',1,0,'2022-03-03 12:56:24','2022-03-03 12:56:24'),(67422,192,'Pahada','313605',1,0,'2022-03-03 12:56:24','2022-03-03 12:56:24'),(67423,192,'Pai','313031',1,0,'2022-03-03 12:56:24','2022-03-03 12:56:24'),(67424,192,'Pal Kharwad','313801',1,0,'2022-03-03 12:56:24','2022-03-03 12:56:24'),(67425,192,'Pal Nimboda','313902',1,0,'2022-03-03 12:56:24','2022-03-03 12:56:24'),(67426,192,'Pal Sarara','313902',1,0,'2022-03-03 12:56:24','2022-03-03 12:56:24'),(67427,192,'Palan Kalan','313204',1,0,'2022-03-03 12:56:24','2022-03-03 12:56:24'),(67428,192,'Palana Khurd','313204',1,0,'2022-03-03 12:56:24','2022-03-03 12:56:24'),(67429,192,'Palodara','313001',1,0,'2022-03-03 12:56:24','2022-03-03 12:56:24'),(67430,192,'Pandiyawara','313026',1,0,'2022-03-03 12:56:24','2022-03-03 12:56:24'),(67431,192,'Paner','313001',1,0,'2022-03-03 12:56:24','2022-03-03 12:56:24'),(67432,192,'Panund','313706',1,0,'2022-03-03 12:56:24','2022-03-03 12:56:24'),(67433,192,'Pareda','313802',1,0,'2022-03-03 12:56:25','2022-03-03 12:56:25'),(67434,192,'Parel','313605',1,0,'2022-03-03 12:56:25','2022-03-03 12:56:25'),(67435,192,'Parsad','313801',1,0,'2022-03-03 12:56:25','2022-03-03 12:56:25'),(67436,192,'Parsola','313611',1,0,'2022-03-03 12:56:25','2022-03-03 12:56:25'),(67437,192,'Patia','313804',1,0,'2022-03-03 12:56:25','2022-03-03 12:56:25'),(67438,192,'Payara','313038',1,0,'2022-03-03 12:56:25','2022-03-03 12:56:25'),(67439,192,'Phalasia','313701',1,0,'2022-03-03 12:56:25','2022-03-03 12:56:25'),(67440,192,'Phalichada','313203',1,0,'2022-03-03 12:56:25','2022-03-03 12:56:25'),(67441,192,'Phila','313706',1,0,'2022-03-03 12:56:25','2022-03-03 12:56:25'),(67442,192,'Piladhar','313001',1,0,'2022-03-03 12:56:25','2022-03-03 12:56:25'),(67443,192,'Pipalwara','313031',1,0,'2022-03-03 12:56:25','2022-03-03 12:56:25'),(67444,192,'Pipla','313708',1,0,'2022-03-03 12:56:25','2022-03-03 12:56:25'),(67445,192,'Pipli (A)','313802',1,0,'2022-03-03 12:56:25','2022-03-03 12:56:25'),(67446,192,'Pipli (B)','313802',1,0,'2022-03-03 12:56:25','2022-03-03 12:56:25'),(67447,192,'Piplia','313605',1,0,'2022-03-03 12:56:26','2022-03-03 12:56:26'),(67448,192,'Pithalpura','313604',1,0,'2022-03-03 12:56:26','2022-03-03 12:56:26'),(67449,192,'Pograkalan','313803',1,0,'2022-03-03 12:56:26','2022-03-03 12:56:26'),(67450,192,'Puria Kheri','313601',1,0,'2022-03-03 12:56:26','2022-03-03 12:56:26'),(67451,192,'Rajol','313903',1,0,'2022-03-03 12:56:26','2022-03-03 12:56:26'),(67452,192,'Rakhyawal','313201',1,0,'2022-03-03 12:56:26','2022-03-03 12:56:26'),(67453,192,'Rao Madra','313708',1,0,'2022-03-03 12:56:26','2022-03-03 12:56:26'),(67454,192,'Rathora','313026',1,0,'2022-03-03 12:56:26','2022-03-03 12:56:26'),(67455,192,'Ravlia Khurd','313705',1,0,'2022-03-03 12:56:26','2022-03-03 12:56:26'),(67456,192,'Rawalia Kalan','313705',1,0,'2022-03-03 12:56:26','2022-03-03 12:56:26'),(67457,192,'Rishabhdeo','313802',1,0,'2022-03-03 12:56:26','2022-03-03 12:56:26'),(67458,192,'Royda','313001',1,0,'2022-03-03 12:56:26','2022-03-03 12:56:26'),(67459,192,'Rundera','313601',1,0,'2022-03-03 12:56:26','2022-03-03 12:56:26'),(67460,192,'Sada','307025',1,0,'2022-03-03 12:56:26','2022-03-03 12:56:26'),(67461,192,'Sagtara','313902',1,0,'2022-03-03 12:56:26','2022-03-03 12:56:26'),(67462,192,'Sagtari','313903',1,0,'2022-03-03 12:56:26','2022-03-03 12:56:26'),(67463,192,'Sagwara','313802',1,0,'2022-03-03 12:56:26','2022-03-03 12:56:26'),(67464,192,'Saidem','313708',1,0,'2022-03-03 12:56:26','2022-03-03 12:56:26'),(67465,192,'Sakroda','313203',1,0,'2022-03-03 12:56:26','2022-03-03 12:56:26'),(67466,192,'Sakroda','313024',1,0,'2022-03-03 12:56:26','2022-03-03 12:56:26'),(67467,192,'Saleda','313603',1,0,'2022-03-03 12:56:26','2022-03-03 12:56:26'),(67468,192,'Salera Kalan','313201',1,0,'2022-03-03 12:56:26','2022-03-03 12:56:26'),(67469,192,'Sallada','313905',1,0,'2022-03-03 12:56:26','2022-03-03 12:56:26'),(67470,192,'Salumber','313027',1,0,'2022-03-03 12:56:26','2022-03-03 12:56:26'),(67471,192,'Sameeja','313906',1,0,'2022-03-03 12:56:26','2022-03-03 12:56:26'),(67472,192,'Samoda','313038',1,0,'2022-03-03 12:56:27','2022-03-03 12:56:27'),(67473,192,'Samoli','307025',1,0,'2022-03-03 12:56:27','2022-03-03 12:56:27'),(67474,192,'Sandraf','307025',1,0,'2022-03-03 12:56:27','2022-03-03 12:56:27'),(67475,192,'Sangwa','313201',1,0,'2022-03-03 12:56:27','2022-03-03 12:56:27'),(67476,192,'Sanwar (Udaipur)','313206',1,0,'2022-03-03 12:56:27','2022-03-03 12:56:27'),(67477,192,'Sapetia','313011',1,0,'2022-03-03 12:56:27','2022-03-03 12:56:27'),(67478,192,'Saradeet','313031',1,0,'2022-03-03 12:56:27','2022-03-03 12:56:27'),(67479,192,'Saradi','313027',1,0,'2022-03-03 12:56:27','2022-03-03 12:56:27'),(67480,192,'Sarangpura','313603',1,0,'2022-03-03 12:56:27','2022-03-03 12:56:27'),(67481,192,'Sarangpura','313604',1,0,'2022-03-03 12:56:27','2022-03-03 12:56:27'),(67482,192,'Sarara','313902',1,0,'2022-03-03 12:56:27','2022-03-03 12:56:27'),(67483,192,'Sarera','313804',1,0,'2022-03-03 12:56:27','2022-03-03 12:56:27'),(67484,192,'Saroli','313803',1,0,'2022-03-03 12:56:27','2022-03-03 12:56:27'),(67485,192,'Sarsia','313905',1,0,'2022-03-03 12:56:27','2022-03-03 12:56:27'),(67486,192,'Sarupal','313801',1,0,'2022-03-03 12:56:27','2022-03-03 12:56:27'),(67487,192,'Saveena','313001',1,0,'2022-03-03 12:56:27','2022-03-03 12:56:27'),(67488,192,'Sayra','313704',1,0,'2022-03-03 12:56:27','2022-03-03 12:56:27'),(67489,192,'Semal','313703',1,0,'2022-03-03 12:56:27','2022-03-03 12:56:27'),(67490,192,'Semari','313903',1,0,'2022-03-03 12:56:27','2022-03-03 12:56:27'),(67491,192,'Seria','313027',1,0,'2022-03-03 12:56:27','2022-03-03 12:56:27'),(67492,192,'Shaktawat Ka Guda','313026',1,0,'2022-03-03 12:56:27','2022-03-03 12:56:27'),(67493,192,'Shaktawato Ka Guda','313702',1,0,'2022-03-03 12:56:27','2022-03-03 12:56:27'),(67494,192,'Shayampura','313903',1,0,'2022-03-03 12:56:28','2022-03-03 12:56:28'),(67495,192,'Sheshpur','313038',1,0,'2022-03-03 12:56:28','2022-03-03 12:56:28'),(67496,192,'Shishvi','313703',1,0,'2022-03-03 12:56:28','2022-03-03 12:56:28'),(67497,192,'Shobhagpura','313011',1,0,'2022-03-03 12:56:28','2022-03-03 12:56:28'),(67498,192,'Shyampura','313905',1,0,'2022-03-03 12:56:28','2022-03-03 12:56:28'),(67499,192,'Sihad','313706',1,0,'2022-03-03 12:56:28','2022-03-03 12:56:28'),(67500,192,'Sihar','313605',1,0,'2022-03-03 12:56:28','2022-03-03 12:56:28'),(67501,192,'Sindhu','313204',1,0,'2022-03-03 12:56:28','2022-03-03 12:56:28'),(67502,192,'Singhatwara','313901',1,0,'2022-03-03 12:56:28','2022-03-03 12:56:28'),(67503,192,'Sisarma','313031',1,0,'2022-03-03 12:56:28','2022-03-03 12:56:28'),(67504,192,'Som','313701',1,0,'2022-03-03 12:56:28','2022-03-03 12:56:28'),(67505,192,'Sulai','313803',1,0,'2022-03-03 12:56:28','2022-03-03 12:56:28'),(67506,192,'Sulawas','313706',1,0,'2022-03-03 12:56:28','2022-03-03 12:56:28'),(67507,192,'Sundra','313804',1,0,'2022-03-03 12:56:28','2022-03-03 12:56:28'),(67508,192,'Surajgarh','313705',1,0,'2022-03-03 12:56:28','2022-03-03 12:56:28'),(67509,192,'Surkhand Ka Khera','313903',1,0,'2022-03-03 12:56:28','2022-03-03 12:56:28'),(67510,192,'Suveri','313803',1,0,'2022-03-03 12:56:28','2022-03-03 12:56:28'),(67511,192,'Tarawat','313601',1,0,'2022-03-03 12:56:28','2022-03-03 12:56:28'),(67512,192,'Teja Ka Was','313708',1,0,'2022-03-03 12:56:28','2022-03-03 12:56:28'),(67513,192,'Tekan','313706',1,0,'2022-03-03 12:56:28','2022-03-03 12:56:28'),(67514,192,'Thada','313027',1,0,'2022-03-03 12:56:28','2022-03-03 12:56:28'),(67515,192,'Thamla','313204',1,0,'2022-03-03 12:56:28','2022-03-03 12:56:28'),(67516,192,'Thana','313902',1,0,'2022-03-03 12:56:28','2022-03-03 12:56:28'),(67517,192,'Thana','313804',1,0,'2022-03-03 12:56:28','2022-03-03 12:56:28'),(67518,192,'Thoor','313011',1,0,'2022-03-03 12:56:28','2022-03-03 12:56:28'),(67519,192,'Tidi','313801',1,0,'2022-03-03 12:56:28','2022-03-03 12:56:28'),(67520,192,'Titardi','313001',1,0,'2022-03-03 12:56:29','2022-03-03 12:56:29'),(67521,192,'Toda','313027',1,0,'2022-03-03 12:56:29','2022-03-03 12:56:29'),(67522,192,'Tokar','313026',1,0,'2022-03-03 12:56:29','2022-03-03 12:56:29'),(67523,192,'Tothada','313611',1,0,'2022-03-03 12:56:29','2022-03-03 12:56:29'),(67524,192,'Udaipur City','313001',1,0,'2022-03-03 12:56:29','2022-03-03 12:56:29'),(67525,192,'Udaipur Fatehpura','313001',1,0,'2022-03-03 12:56:29','2022-03-03 12:56:29'),(67526,192,'Udaipur H Magri','313002',1,0,'2022-03-03 12:56:29','2022-03-03 12:56:29'),(67527,192,'Udaipur H.O','313004',1,0,'2022-03-03 12:56:29','2022-03-03 12:56:29'),(67528,192,'Udaipur Industrial Area','313003',1,0,'2022-03-03 12:56:29','2022-03-03 12:56:29'),(67529,192,'Udaipur Macchala Magra','313001',1,0,'2022-03-03 12:56:29','2022-03-03 12:56:29'),(67530,192,'Udaipur Naya Sarafa','313001',1,0,'2022-03-03 12:56:29','2022-03-03 12:56:29'),(67531,192,'Udaipur Palace Road','313001',1,0,'2022-03-03 12:56:29','2022-03-03 12:56:29'),(67532,192,'Udaipur Pratapnagar','313001',1,0,'2022-03-03 12:56:29','2022-03-03 12:56:29'),(67533,192,'Udaipur Railway Station','313001',1,0,'2022-03-03 12:56:29','2022-03-03 12:56:29'),(67534,192,'Udaipur Rani Road','313001',1,0,'2022-03-03 12:56:29','2022-03-03 12:56:29'),(67535,192,'Udaipur Shastri Circle','313001',1,0,'2022-03-03 12:56:29','2022-03-03 12:56:29'),(67536,192,'Udaipur Station Road','313001',1,0,'2022-03-03 12:56:29','2022-03-03 12:56:29'),(67537,192,'Udaipur Surajpole','313001',1,0,'2022-03-03 12:56:29','2022-03-03 12:56:29'),(67538,192,'Udaipur University Campus','313001',1,0,'2022-03-03 12:56:29','2022-03-03 12:56:29'),(67539,192,'Udaipuria Jagir','313905',1,0,'2022-03-03 12:56:29','2022-03-03 12:56:29'),(67540,192,'Ugamna Kotra','313802',1,0,'2022-03-03 12:56:29','2022-03-03 12:56:29'),(67541,192,'Umaramines','313015',1,0,'2022-03-03 12:56:29','2022-03-03 12:56:29'),(67542,192,'Upreta','313701',1,0,'2022-03-03 12:56:30','2022-03-03 12:56:30'),(67543,192,'Utharda','313706',1,0,'2022-03-03 12:56:30','2022-03-03 12:56:30'),(67544,192,'Uthnol','313204',1,0,'2022-03-03 12:56:30','2022-03-03 12:56:30'),(67545,192,'Vadiyar','313203',1,0,'2022-03-03 12:56:30','2022-03-03 12:56:30'),(67546,192,'Vallabhnagar (Udaipur)','313601',1,0,'2022-03-03 12:56:30','2022-03-03 12:56:30'),(67547,192,'Vana','313602',1,0,'2022-03-03 12:56:30','2022-03-03 12:56:30'),(67548,192,'Vasni Kalan','313205',1,0,'2022-03-03 12:56:30','2022-03-03 12:56:30'),(67549,192,'Vass','313906',1,0,'2022-03-03 12:56:30','2022-03-03 12:56:30'),(67550,192,'Veerdholia','313201',1,0,'2022-03-03 12:56:30','2022-03-03 12:56:30'),(67551,192,'Veerpura','313905',1,0,'2022-03-03 12:56:30','2022-03-03 12:56:30'),(67552,192,'Wali','313703',1,0,'2022-03-03 12:56:30','2022-03-03 12:56:30'),(67553,192,'Wanri','313204',1,0,'2022-03-03 12:56:30','2022-03-03 12:56:30'),(67554,192,'Zawar Mines','313901',1,0,'2022-03-03 12:56:30','2022-03-03 12:56:30'),(67555,192,'Zinc Smelter','313024',1,0,'2022-03-03 12:56:30','2022-03-03 12:56:30'),(67556,193,'15 Btn PAC Agra','282001',1,0,'2022-03-03 12:56:30','2022-03-03 12:56:30'),(67557,193,'509 Command','282001',1,0,'2022-03-03 12:56:30','2022-03-03 12:56:30'),(67558,193,'Achnera Mandi','283101',1,0,'2022-03-03 12:56:30','2022-03-03 12:56:30'),(67559,193,'Achnera','283101',1,0,'2022-03-03 12:56:30','2022-03-03 12:56:30'),(67560,193,'Agra Barrcks','282001',1,0,'2022-03-03 12:56:30','2022-03-03 12:56:30'),(67561,193,'Agra Chauk','282003',1,0,'2022-03-03 12:56:30','2022-03-03 12:56:30'),(67562,193,'Agra City','282003',1,0,'2022-03-03 12:56:30','2022-03-03 12:56:30'),(67563,193,'Agra Fort H.O','282003',1,0,'2022-03-03 12:56:30','2022-03-03 12:56:30'),(67564,193,'Agra H.O','282001',1,0,'2022-03-03 12:56:30','2022-03-03 12:56:30'),(67565,193,'Agra University','282004',1,0,'2022-03-03 12:56:31','2022-03-03 12:56:31'),(67566,193,'Agwar','283202',1,0,'2022-03-03 12:56:31','2022-03-03 12:56:31'),(67567,193,'Aharan','283201',1,0,'2022-03-03 12:56:31','2022-03-03 12:56:31'),(67568,193,'Akhabai','283102',1,0,'2022-03-03 12:56:31','2022-03-03 12:56:31'),(67569,193,'Akola (Agra)','283102',1,0,'2022-03-03 12:56:31','2022-03-03 12:56:31'),(67570,193,'Anwal Khera','283201',1,0,'2022-03-03 12:56:31','2022-03-03 12:56:31'),(67571,193,'Arela','283201',1,0,'2022-03-03 12:56:31','2022-03-03 12:56:31'),(67572,193,'Arhera','283110',1,0,'2022-03-03 12:56:31','2022-03-03 12:56:31'),(67573,193,'Arnota','283111',1,0,'2022-03-03 12:56:31','2022-03-03 12:56:31'),(67574,193,'Arrua Khas','283101',1,0,'2022-03-03 12:56:31','2022-03-03 12:56:31'),(67575,193,'Arsena','282007',1,0,'2022-03-03 12:56:31','2022-03-03 12:56:31'),(67576,193,'Artoni','282007',1,0,'2022-03-03 12:56:31','2022-03-03 12:56:31'),(67577,193,'Atoos','283105',1,0,'2022-03-03 12:56:31','2022-03-03 12:56:31'),(67578,193,'Aulanda','283110',1,0,'2022-03-03 12:56:31','2022-03-03 12:56:31'),(67579,193,'Avas Vikas Colony','282007',1,0,'2022-03-03 12:56:31','2022-03-03 12:56:31'),(67580,193,'Ayela','283124',1,0,'2022-03-03 12:56:31','2022-03-03 12:56:31'),(67581,193,'B.M. Khan','282002',1,0,'2022-03-03 12:56:31','2022-03-03 12:56:31'),(67582,193,'B.P Oilmill','282003',1,0,'2022-03-03 12:56:31','2022-03-03 12:56:31'),(67583,193,'B.V. Bichpuri','283105',1,0,'2022-03-03 12:56:31','2022-03-03 12:56:31'),(67584,193,'Bah','283104',1,0,'2022-03-03 12:56:31','2022-03-03 12:56:31'),(67585,193,'Baharawati','283101',1,0,'2022-03-03 12:56:31','2022-03-03 12:56:31'),(67586,193,'Bainpur','282007',1,0,'2022-03-03 12:56:31','2022-03-03 12:56:31'),(67587,193,'Balu Ganj','282001',1,0,'2022-03-03 12:56:31','2022-03-03 12:56:31'),(67588,193,'Baman','283126',1,0,'2022-03-03 12:56:32','2022-03-03 12:56:32'),(67589,193,'Bamnai Kalan','283115',1,0,'2022-03-03 12:56:32','2022-03-03 12:56:32'),(67590,193,'Bamrauli Ahir','282009',1,0,'2022-03-03 12:56:32','2022-03-03 12:56:32'),(67591,193,'Bamrauli','283104',1,0,'2022-03-03 12:56:32','2022-03-03 12:56:32'),(67592,193,'Bamrauli Katara','282006',1,0,'2022-03-03 12:56:32','2022-03-03 12:56:32'),(67593,193,'Barara','283102',1,0,'2022-03-03 12:56:32','2022-03-03 12:56:32'),(67594,193,'Barauli Ahir','283125',1,0,'2022-03-03 12:56:32','2022-03-03 12:56:32'),(67595,193,'Barauli Gujar','283111',1,0,'2022-03-03 12:56:33','2022-03-03 12:56:33'),(67596,193,'Barenda','283123',1,0,'2022-03-03 12:56:33','2022-03-03 12:56:33'),(67597,193,'Barhan','283201',1,0,'2022-03-03 12:56:33','2022-03-03 12:56:33'),(67598,193,'Barobara Khurd','283125',1,0,'2022-03-03 12:56:33','2022-03-03 12:56:33'),(67599,193,'Barwar','283119',1,0,'2022-03-03 12:56:33','2022-03-03 12:56:33'),(67600,193,'Basai Jagner','283115',1,0,'2022-03-03 12:56:33','2022-03-03 12:56:33'),(67601,193,'Baseri Chahar','283122',1,0,'2022-03-03 12:56:33','2022-03-03 12:56:33'),(67602,193,'Baseri Kazi','283110',1,0,'2022-03-03 12:56:33','2022-03-03 12:56:33'),(67603,193,'Basona','283126',1,0,'2022-03-03 12:56:33','2022-03-03 12:56:33'),(67604,193,'Basoni','283123',1,0,'2022-03-03 12:56:33','2022-03-03 12:56:33'),(67605,193,'Bateshwar','283104',1,0,'2022-03-03 12:56:33','2022-03-03 12:56:33'),(67606,193,'Behrampur','283202',1,0,'2022-03-03 12:56:33','2022-03-03 12:56:33'),(67607,193,'Beman','283122',1,0,'2022-03-03 12:56:33','2022-03-03 12:56:33'),(67608,193,'Berichahar','283102',1,0,'2022-03-03 12:56:33','2022-03-03 12:56:33'),(67609,193,'Bhadrauli','283113',1,0,'2022-03-03 12:56:33','2022-03-03 12:56:33'),(67610,193,'Bhagupur','283202',1,0,'2022-03-03 12:56:33','2022-03-03 12:56:33'),(67611,193,'Bhakar','283121',1,0,'2022-03-03 12:56:34','2022-03-03 12:56:34'),(67612,193,'Bhalokhara','283111',1,0,'2022-03-03 12:56:34','2022-03-03 12:56:34'),(67613,193,'Bhara','283115',1,0,'2022-03-03 12:56:34','2022-03-03 12:56:34'),(67614,193,'Bharkol','283110',1,0,'2022-03-03 12:56:34','2022-03-03 12:56:34'),(67615,193,'Bhilawali','283121',1,0,'2022-03-03 12:56:34','2022-03-03 12:56:34'),(67616,193,'Bhogipura','282010',1,0,'2022-03-03 12:56:34','2022-03-03 12:56:34'),(67617,193,'Biara','283101',1,0,'2022-03-03 12:56:34','2022-03-03 12:56:34'),(67618,193,'Bichola','283113',1,0,'2022-03-03 12:56:34','2022-03-03 12:56:34'),(67619,193,'Bihari','283111',1,0,'2022-03-03 12:56:34','2022-03-03 12:56:34'),(67620,193,'Bijhamai','283111',1,0,'2022-03-03 12:56:34','2022-03-03 12:56:34'),(67621,193,'Bikapur Tap Kharga','283112',1,0,'2022-03-03 12:56:34','2022-03-03 12:56:34'),(67622,193,'Billoch Pura','282002',1,0,'2022-03-03 12:56:34','2022-03-03 12:56:34'),(67623,193,'Biprawali','283123',1,0,'2022-03-03 12:56:34','2022-03-03 12:56:34'),(67624,193,'Birai','283124',1,0,'2022-03-03 12:56:34','2022-03-03 12:56:34'),(67625,193,'Birharu','283124',1,0,'2022-03-03 12:56:34','2022-03-03 12:56:34'),(67626,193,'Birthala','283112',1,0,'2022-03-03 12:56:34','2022-03-03 12:56:34'),(67627,193,'Bisalpur','283102',1,0,'2022-03-03 12:56:34','2022-03-03 12:56:34'),(67628,193,'Bitholi','283113',1,0,'2022-03-03 12:56:34','2022-03-03 12:56:34'),(67629,193,'Bodla','282007',1,0,'2022-03-03 12:56:34','2022-03-03 12:56:34'),(67630,193,'Budhana Mustkil','282006',1,0,'2022-03-03 12:56:34','2022-03-03 12:56:34'),(67631,193,'C.O.D.','282009',1,0,'2022-03-03 12:56:34','2022-03-03 12:56:34'),(67632,193,'Chamraua','283104',1,0,'2022-03-03 12:56:35','2022-03-03 12:56:35'),(67633,193,'Chamraula','283201',1,0,'2022-03-03 12:56:35','2022-03-03 12:56:35'),(67634,193,'Chaoli','283201',1,0,'2022-03-03 12:56:35','2022-03-03 12:56:35'),(67635,193,'Chauma Shahpur','283110',1,0,'2022-03-03 12:56:35','2022-03-03 12:56:35'),(67636,193,'Chaurangahar','283104',1,0,'2022-03-03 12:56:35','2022-03-03 12:56:35'),(67637,193,'Cheet','283119',1,0,'2022-03-03 12:56:35','2022-03-03 12:56:35'),(67638,193,'Chhalesar','282006',1,0,'2022-03-03 12:56:35','2022-03-03 12:56:35'),(67639,193,'Chimman Lal Road','282003',1,0,'2022-03-03 12:56:35','2022-03-03 12:56:35'),(67640,193,'Chitaura','283125',1,0,'2022-03-03 12:56:36','2022-03-03 12:56:36'),(67641,193,'Chitra Hat','283114',1,0,'2022-03-03 12:56:36','2022-03-03 12:56:36'),(67642,193,'Chokda','283201',1,0,'2022-03-03 12:56:36','2022-03-03 12:56:36'),(67643,193,'Churiyari','283110',1,0,'2022-03-03 12:56:36','2022-03-03 12:56:36'),(67644,193,'Civil Court (Agra)','282002',1,0,'2022-03-03 12:56:36','2022-03-03 12:56:36'),(67645,193,'Civil Line (Agra)','282002',1,0,'2022-03-03 12:56:36','2022-03-03 12:56:36'),(67646,193,'Collectrate','282010',1,0,'2022-03-03 12:56:36','2022-03-03 12:56:36'),(67647,193,'Dabar','283110',1,0,'2022-03-03 12:56:36','2022-03-03 12:56:36'),(67648,193,'Dahtora','282007',1,0,'2022-03-03 12:56:36','2022-03-03 12:56:36'),(67649,193,'Dankasha','283124',1,0,'2022-03-03 12:56:36','2022-03-03 12:56:36'),(67650,193,'Daoli','283105',1,0,'2022-03-03 12:56:36','2022-03-03 12:56:36'),(67651,193,'Darki','283112',1,0,'2022-03-03 12:56:36','2022-03-03 12:56:36'),(67652,193,'Dauki','283111',1,0,'2022-03-03 12:56:36','2022-03-03 12:56:36'),(67653,193,'Daultabad','283101',1,0,'2022-03-03 12:56:36','2022-03-03 12:56:36'),(67654,193,'Dayal Bagh','282005',1,0,'2022-03-03 12:56:36','2022-03-03 12:56:36'),(67655,193,'Dehgawan','283115',1,0,'2022-03-03 12:56:36','2022-03-03 12:56:36'),(67656,193,'Deoretha','283122',1,0,'2022-03-03 12:56:36','2022-03-03 12:56:36'),(67657,193,'Deori','282009',1,0,'2022-03-03 12:56:36','2022-03-03 12:56:36'),(67658,193,'Deori Road','282001',1,0,'2022-03-03 12:56:36','2022-03-03 12:56:36'),(67659,193,'Dhanaula Kalan','283125',1,0,'2022-03-03 12:56:36','2022-03-03 12:56:36'),(67660,193,'Dhandupura','282006',1,0,'2022-03-03 12:56:36','2022-03-03 12:56:36'),(67661,193,'Dhanina','283115',1,0,'2022-03-03 12:56:36','2022-03-03 12:56:36'),(67662,193,'Dhanoli','283102',1,0,'2022-03-03 12:56:37','2022-03-03 12:56:37'),(67663,193,'Dharera','283202',1,0,'2022-03-03 12:56:37','2022-03-03 12:56:37'),(67664,193,'Dhaurra','283202',1,0,'2022-03-03 12:56:37','2022-03-03 12:56:37'),(67665,193,'Dhim Shree','283125',1,0,'2022-03-03 12:56:37','2022-03-03 12:56:37'),(67666,193,'Digner','283125',1,0,'2022-03-03 12:56:37','2022-03-03 12:56:37'),(67667,193,'Digrauta','283119',1,0,'2022-03-03 12:56:37','2022-03-03 12:56:37'),(67668,193,'Doora','283110',1,0,'2022-03-03 12:56:37','2022-03-03 12:56:37'),(67669,193,'Dulhara','283110',1,0,'2022-03-03 12:56:37','2022-03-03 12:56:37'),(67670,193,'Etmadpur','283202',1,0,'2022-03-03 12:56:37','2022-03-03 12:56:37'),(67671,193,'Fatehabad Bazaar','283111',1,0,'2022-03-03 12:56:37','2022-03-03 12:56:37'),(67672,193,'Fatehabad (Agra)','283111',1,0,'2022-03-03 12:56:37','2022-03-03 12:56:37'),(67673,193,'Fatehapursikari','283110',1,0,'2022-03-03 12:56:37','2022-03-03 12:56:37'),(67674,193,'Foundry Nagar','282006',1,0,'2022-03-03 12:56:38','2022-03-03 12:56:38'),(67675,193,'G. L. Emporiaumi','282001',1,0,'2022-03-03 12:56:38','2022-03-03 12:56:38'),(67676,193,'G.G Industries','282004',1,0,'2022-03-03 12:56:38','2022-03-03 12:56:38'),(67677,193,'G.M Khan','282003',1,0,'2022-03-03 12:56:38','2022-03-03 12:56:38'),(67678,193,'Gajaura','283123',1,0,'2022-03-03 12:56:38','2022-03-03 12:56:38'),(67679,193,'Gandhi Nagar (Agra)','282003',1,0,'2022-03-03 12:56:38','2022-03-03 12:56:38'),(67680,193,'Garh Mukha','283119',1,0,'2022-03-03 12:56:38','2022-03-03 12:56:38'),(67681,193,'Garhi Lal Kalan','283125',1,0,'2022-03-03 12:56:38','2022-03-03 12:56:38'),(67682,193,'Garhwar','283114',1,0,'2022-03-03 12:56:38','2022-03-03 12:56:38'),(67683,193,'Garsani','283102',1,0,'2022-03-03 12:56:38','2022-03-03 12:56:38'),(67684,193,'Garshan','283124',1,0,'2022-03-03 12:56:38','2022-03-03 12:56:38'),(67685,193,'Gokulpura','282002',1,0,'2022-03-03 12:56:38','2022-03-03 12:56:38'),(67686,193,'Gonseli','283104',1,0,'2022-03-03 12:56:38','2022-03-03 12:56:38'),(67687,193,'Gubroth','283111',1,0,'2022-03-03 12:56:38','2022-03-03 12:56:38'),(67688,193,'Gurki Mandi','283110',1,0,'2022-03-03 12:56:38','2022-03-03 12:56:38'),(67689,193,'Gutila','283125',1,0,'2022-03-03 12:56:39','2022-03-03 12:56:39'),(67690,193,'H.N.Khera','283125',1,0,'2022-03-03 12:56:39','2022-03-03 12:56:39'),(67691,193,'Hansela','283101',1,0,'2022-03-03 12:56:39','2022-03-03 12:56:39'),(67692,193,'Hasanpur','283126',1,0,'2022-03-03 12:56:39','2022-03-03 12:56:39'),(67693,193,'Hazipur Khera','282006',1,0,'2022-03-03 12:56:39','2022-03-03 12:56:39'),(67694,193,'Hironda','283124',1,0,'2022-03-03 12:56:39','2022-03-03 12:56:39'),(67695,193,'Holipura','283113',1,0,'2022-03-03 12:56:39','2022-03-03 12:56:39'),(67696,193,'Hospital Road (Agra)','282003',1,0,'2022-03-03 12:56:39','2022-03-03 12:56:39'),(67697,193,'Hotal Clarkshiraj','282001',1,0,'2022-03-03 12:56:39','2022-03-03 12:56:39'),(67698,193,'I. A. F.','282008',1,0,'2022-03-03 12:56:39','2022-03-03 12:56:39'),(67699,193,'Idgha Colony','282001',1,0,'2022-03-03 12:56:39','2022-03-03 12:56:39'),(67700,193,'Indrapuram','282001',1,0,'2022-03-03 12:56:39','2022-03-03 12:56:39'),(67701,193,'Industrial Estate (Agra)','282006',1,0,'2022-03-03 12:56:39','2022-03-03 12:56:39'),(67702,193,'Iradat Nagar','283112',1,0,'2022-03-03 12:56:39','2022-03-03 12:56:39'),(67703,193,'Jaganpur','282005',1,0,'2022-03-03 12:56:39','2022-03-03 12:56:39'),(67704,193,'Jagdish Pura','282002',1,0,'2022-03-03 12:56:39','2022-03-03 12:56:39'),(67705,193,'Jagner','283115',1,0,'2022-03-03 12:56:39','2022-03-03 12:56:39'),(67706,193,'Jagrajpur','283111',1,0,'2022-03-03 12:56:39','2022-03-03 12:56:39'),(67707,193,'Jaingara','283122',1,0,'2022-03-03 12:56:39','2022-03-03 12:56:39'),(67708,193,'Jaitpur (Agra)','283114',1,0,'2022-03-03 12:56:39','2022-03-03 12:56:39'),(67709,193,'Jajau','283110',1,0,'2022-03-03 12:56:39','2022-03-03 12:56:39'),(67710,193,'Jajau','283124',1,0,'2022-03-03 12:56:39','2022-03-03 12:56:39'),(67711,193,'Jajauli','283110',1,0,'2022-03-03 12:56:39','2022-03-03 12:56:39'),(67712,193,'Jarar','283104',1,0,'2022-03-03 12:56:39','2022-03-03 12:56:39'),(67713,193,'Jarari','283111',1,0,'2022-03-03 12:56:39','2022-03-03 12:56:39'),(67714,193,'Jarua Katra','283102',1,0,'2022-03-03 12:56:40','2022-03-03 12:56:40'),(67715,193,'John\'s Mill','282004',1,0,'2022-03-03 12:56:40','2022-03-03 12:56:40'),(67716,193,'Johri Bazar','282003',1,0,'2022-03-03 12:56:40','2022-03-03 12:56:40'),(67717,193,'Jonai','283124',1,0,'2022-03-03 12:56:40','2022-03-03 12:56:40'),(67718,193,'K.H.Sansthan','282005',1,0,'2022-03-03 12:56:40','2022-03-03 12:56:40'),(67719,193,'Kachaura','283101',1,0,'2022-03-03 12:56:40','2022-03-03 12:56:40'),(67720,193,'Kachora Ghat','283114',1,0,'2022-03-03 12:56:40','2022-03-03 12:56:40'),(67721,193,'Kagrol','283119',1,0,'2022-03-03 12:56:40','2022-03-03 12:56:40'),(67722,193,'Kailash','282007',1,0,'2022-03-03 12:56:40','2022-03-03 12:56:40'),(67723,193,'Kakua','282009',1,0,'2022-03-03 12:56:40','2022-03-03 12:56:40'),(67724,193,'Kalal Kheria','282006',1,0,'2022-03-03 12:56:40','2022-03-03 12:56:40'),(67725,193,'Kalibari (Agra)','282003',1,0,'2022-03-03 12:56:40','2022-03-03 12:56:40'),(67726,193,'Kalwari','283105',1,0,'2022-03-03 12:56:40','2022-03-03 12:56:40'),(67727,193,'Kamala Nagar (Agra)','282004',1,0,'2022-03-03 12:56:40','2022-03-03 12:56:40'),(67728,193,'Kamtari','283104',1,0,'2022-03-03 12:56:40','2022-03-03 12:56:40'),(67729,193,'Kanjauli','283126',1,0,'2022-03-03 12:56:40','2022-03-03 12:56:40'),(67730,193,'Karahara','283105',1,0,'2022-03-03 12:56:40','2022-03-03 12:56:40'),(67731,193,'Karkoli','283123',1,0,'2022-03-03 12:56:40','2022-03-03 12:56:40'),(67732,193,'Karmyogi Enclave','282005',1,0,'2022-03-03 12:56:40','2022-03-03 12:56:40'),(67733,193,'Karodhana Kala','282009',1,0,'2022-03-03 12:56:40','2022-03-03 12:56:40'),(67734,193,'Kathwari','283101',1,0,'2022-03-03 12:56:41','2022-03-03 12:56:41'),(67735,193,'Kaulara Kalan','283111',1,0,'2022-03-03 12:56:41','2022-03-03 12:56:41'),(67736,193,'Keetham','282007',1,0,'2022-03-03 12:56:41','2022-03-03 12:56:41'),(67737,193,'Khanda','283201',1,0,'2022-03-03 12:56:41','2022-03-03 12:56:41'),(67738,193,'Khandauli','283126',1,0,'2022-03-03 12:56:41','2022-03-03 12:56:41'),(67739,193,'Khander','283111',1,0,'2022-03-03 12:56:41','2022-03-03 12:56:41'),(67740,193,'Khandri','282002',1,0,'2022-03-03 12:56:41','2022-03-03 12:56:41'),(67741,193,'Kheragarh','283121',1,0,'2022-03-03 12:56:41','2022-03-03 12:56:41'),(67742,193,'Kheria','283112',1,0,'2022-03-03 12:56:41','2022-03-03 12:56:41'),(67743,193,'Kheria','283102',1,0,'2022-03-03 12:56:41','2022-03-03 12:56:41'),(67744,193,'Khilawali','283114',1,0,'2022-03-03 12:56:41','2022-03-03 12:56:41'),(67745,193,'Kiraoli','283122',1,0,'2022-03-03 12:56:42','2022-03-03 12:56:42'),(67746,193,'Korai','283110',1,0,'2022-03-03 12:56:42','2022-03-03 12:56:42'),(67747,193,'Kukapur','283114',1,0,'2022-03-03 12:56:42','2022-03-03 12:56:42'),(67748,193,'Kukthala','283105',1,0,'2022-03-03 12:56:42','2022-03-03 12:56:42'),(67749,193,'Kukthari','283123',1,0,'2022-03-03 12:56:42','2022-03-03 12:56:42'),(67750,193,'Kundaul','283111',1,0,'2022-03-03 12:56:42','2022-03-03 12:56:42'),(67751,193,'Kurra Chittaipur','282009',1,0,'2022-03-03 12:56:42','2022-03-03 12:56:42'),(67752,193,'Kwari','283104',1,0,'2022-03-03 12:56:42','2022-03-03 12:56:42'),(67753,193,'Labour Colony (Agra)','282004',1,0,'2022-03-03 12:56:42','2022-03-03 12:56:42'),(67754,193,'Ladhu Khera','283124',1,0,'2022-03-03 12:56:42','2022-03-03 12:56:42'),(67755,193,'Lahra','283125',1,0,'2022-03-03 12:56:42','2022-03-03 12:56:42'),(67756,193,'Lajpat Kunj','282002',1,0,'2022-03-03 12:56:42','2022-03-03 12:56:42'),(67757,193,'Lakhurani','283125',1,0,'2022-03-03 12:56:42','2022-03-03 12:56:42'),(67758,193,'Lawyers Colony','282005',1,0,'2022-03-03 12:56:42','2022-03-03 12:56:42'),(67759,193,'Loha Mandi','282002',1,0,'2022-03-03 12:56:42','2022-03-03 12:56:42'),(67760,193,'Mahab','283112',1,0,'2022-03-03 12:56:42','2022-03-03 12:56:42'),(67761,193,'Maharajpur','283111',1,0,'2022-03-03 12:56:42','2022-03-03 12:56:42'),(67762,193,'Mahuar','283122',1,0,'2022-03-03 12:56:42','2022-03-03 12:56:42'),(67763,193,'Mahwatpur','283201',1,0,'2022-03-03 12:56:42','2022-03-03 12:56:42'),(67764,193,'Maloni','283104',1,0,'2022-03-03 12:56:42','2022-03-03 12:56:42'),(67765,193,'Malpura','283102',1,0,'2022-03-03 12:56:42','2022-03-03 12:56:42'),(67766,193,'Malupur','283126',1,0,'2022-03-03 12:56:42','2022-03-03 12:56:42'),(67767,193,'Malviya Kunj','282002',1,0,'2022-03-03 12:56:42','2022-03-03 12:56:42'),(67768,193,'Mandi Mirja Khan','283110',1,0,'2022-03-03 12:56:42','2022-03-03 12:56:42'),(67769,193,'Mangrol Jat','283101',1,0,'2022-03-03 12:56:42','2022-03-03 12:56:42'),(67770,193,'Manikpura','283123',1,0,'2022-03-03 12:56:42','2022-03-03 12:56:42'),(67771,193,'Mankeda','283102',1,0,'2022-03-03 12:56:43','2022-03-03 12:56:43'),(67772,193,'Mau','283114',1,0,'2022-03-03 12:56:43','2022-03-03 12:56:43'),(67773,193,'Medical College (Agra)','282002',1,0,'2022-03-03 12:56:43','2022-03-03 12:56:43'),(67774,193,'Mehdau','283110',1,0,'2022-03-03 12:56:43','2022-03-03 12:56:43'),(67775,193,'Mehra Chudhary','283111',1,0,'2022-03-03 12:56:43','2022-03-03 12:56:43'),(67776,193,'Midhakur','283105',1,0,'2022-03-03 12:56:43','2022-03-03 12:56:43'),(67777,193,'Mihawa','283112',1,0,'2022-03-03 12:56:43','2022-03-03 12:56:43'),(67778,193,'Mitaoli','283201',1,0,'2022-03-03 12:56:43','2022-03-03 12:56:43'),(67779,193,'Mukhbar','283201',1,0,'2022-03-03 12:56:43','2022-03-03 12:56:43'),(67780,193,'Murkia','283102',1,0,'2022-03-03 12:56:43','2022-03-03 12:56:43'),(67781,193,'Murthar Alipur','283201',1,0,'2022-03-03 12:56:43','2022-03-03 12:56:43'),(67782,193,'N.M.Palika','282002',1,0,'2022-03-03 12:56:43','2022-03-03 12:56:43'),(67783,193,'N.V.Colony','282004',1,0,'2022-03-03 12:56:43','2022-03-03 12:56:43'),(67784,193,'Nadeem','283124',1,0,'2022-03-03 12:56:43','2022-03-03 12:56:43'),(67785,193,'Nadgawan','283114',1,0,'2022-03-03 12:56:43','2022-03-03 12:56:43'),(67786,193,'Nagar','283110',1,0,'2022-03-03 12:56:43','2022-03-03 12:56:43'),(67787,193,'Nagar Chand','283111',1,0,'2022-03-03 12:56:44','2022-03-03 12:56:44'),(67788,193,'Nagaria','283111',1,0,'2022-03-03 12:56:44','2022-03-03 12:56:44'),(67789,193,'Nagla Bari','283201',1,0,'2022-03-03 12:56:44','2022-03-03 12:56:44'),(67790,193,'Nagla Bel','283201',1,0,'2022-03-03 12:56:44','2022-03-03 12:56:44'),(67791,193,'Nagla Dulhe Khan','283121',1,0,'2022-03-03 12:56:44','2022-03-03 12:56:44'),(67792,193,'Nagla Kali','282009',1,0,'2022-03-03 12:56:44','2022-03-03 12:56:44'),(67793,193,'Nagla Patam','283112',1,0,'2022-03-03 12:56:44','2022-03-03 12:56:44'),(67794,193,'Nagla Sabla','282006',1,0,'2022-03-03 12:56:44','2022-03-03 12:56:44'),(67795,193,'Nahchani','283122',1,0,'2022-03-03 12:56:44','2022-03-03 12:56:44'),(67796,193,'Nai Ki Mandi','282010',1,0,'2022-03-03 12:56:44','2022-03-03 12:56:44'),(67797,193,'Nainana Jat','282009',1,0,'2022-03-03 12:56:44','2022-03-03 12:56:44'),(67798,193,'Namner','282001',1,0,'2022-03-03 12:56:44','2022-03-03 12:56:44'),(67799,193,'Naraich','282006',1,0,'2022-03-03 12:56:44','2022-03-03 12:56:44'),(67800,193,'Naugawan','283114',1,0,'2022-03-03 12:56:44','2022-03-03 12:56:44'),(67801,193,'New Agra','282005',1,0,'2022-03-03 12:56:44','2022-03-03 12:56:44'),(67802,193,'Nibohara','283111',1,0,'2022-03-03 12:56:44','2022-03-03 12:56:44'),(67803,193,'Noni','283115',1,0,'2022-03-03 12:56:44','2022-03-03 12:56:44'),(67804,193,'Nunhai','282006',1,0,'2022-03-03 12:56:44','2022-03-03 12:56:44'),(67805,193,'P.R.R','282001',1,0,'2022-03-03 12:56:44','2022-03-03 12:56:44'),(67806,193,'Palia','283111',1,0,'2022-03-03 12:56:44','2022-03-03 12:56:44'),(67807,193,'Panwari','282007',1,0,'2022-03-03 12:56:44','2022-03-03 12:56:44'),(67808,193,'Parna','283114',1,0,'2022-03-03 12:56:44','2022-03-03 12:56:44'),(67809,193,'Pathauli','283105',1,0,'2022-03-03 12:56:44','2022-03-03 12:56:44'),(67810,193,'Patsal','283110',1,0,'2022-03-03 12:56:45','2022-03-03 12:56:45'),(67811,193,'Pent Khera','283126',1,0,'2022-03-03 12:56:45','2022-03-03 12:56:45'),(67812,193,'Pentikhera','283125',1,0,'2022-03-03 12:56:45','2022-03-03 12:56:45'),(67813,193,'Pharera','283113',1,0,'2022-03-03 12:56:45','2022-03-03 12:56:45'),(67814,193,'Phool Pur','283125',1,0,'2022-03-03 12:56:45','2022-03-03 12:56:45'),(67815,193,'Phulatti Bazar','282003',1,0,'2022-03-03 12:56:45','2022-03-03 12:56:45'),(67816,193,'Pidhora','283113',1,0,'2022-03-03 12:56:45','2022-03-03 12:56:45'),(67817,193,'Pinahat','283123',1,0,'2022-03-03 12:56:45','2022-03-03 12:56:45'),(67818,193,'Poiya Tarrakpur','283126',1,0,'2022-03-03 12:56:45','2022-03-03 12:56:45'),(67819,193,'Police Line','282010',1,0,'2022-03-03 12:56:45','2022-03-03 12:56:45'),(67820,193,'Prathvi Nath Fatak','282010',1,0,'2022-03-03 12:56:45','2022-03-03 12:56:45'),(67821,193,'Pura Guman Singh','283104',1,0,'2022-03-03 12:56:45','2022-03-03 12:56:45'),(67822,193,'Pura Kanhera','283113',1,0,'2022-03-03 12:56:45','2022-03-03 12:56:45'),(67823,193,'Pura Tinnet','283104',1,0,'2022-03-03 12:56:45','2022-03-03 12:56:45'),(67824,193,'Puramana','283122',1,0,'2022-03-03 12:56:45','2022-03-03 12:56:45'),(67825,193,'Puseta','283112',1,0,'2022-03-03 12:56:45','2022-03-03 12:56:45'),(67826,193,'R.B.S.College','282002',1,0,'2022-03-03 12:56:45','2022-03-03 12:56:45'),(67827,193,'Rahlai','283112',1,0,'2022-03-03 12:56:45','2022-03-03 12:56:45'),(67828,193,'Raibha','283101',1,0,'2022-03-03 12:56:45','2022-03-03 12:56:45'),(67829,193,'Raja Mandi','282002',1,0,'2022-03-03 12:56:45','2022-03-03 12:56:45'),(67830,193,'Rajora','283113',1,0,'2022-03-03 12:56:45','2022-03-03 12:56:45'),(67831,193,'Rakabganj','282001',1,0,'2022-03-03 12:56:45','2022-03-03 12:56:45'),(67832,193,'Rampur','283101',1,0,'2022-03-03 12:56:45','2022-03-03 12:56:45'),(67833,193,'Rasoolpur','283121',1,0,'2022-03-03 12:56:46','2022-03-03 12:56:46'),(67834,193,'Rasoolpur','283111',1,0,'2022-03-03 12:56:46','2022-03-03 12:56:46'),(67835,193,'Ratoti','283113',1,0,'2022-03-03 12:56:46','2022-03-03 12:56:46'),(67836,193,'Rawatpara','282003',1,0,'2022-03-03 12:56:46','2022-03-03 12:56:46'),(67837,193,'Reha','283123',1,0,'2022-03-03 12:56:46','2022-03-03 12:56:46'),(67838,193,'Rehan Kalan','282006',1,0,'2022-03-03 12:56:46','2022-03-03 12:56:46'),(67839,193,'Richhpura','283114',1,0,'2022-03-03 12:56:46','2022-03-03 12:56:46'),(67840,193,'Richoba','283115',1,0,'2022-03-03 12:56:46','2022-03-03 12:56:46'),(67841,193,'Rithori','283124',1,0,'2022-03-03 12:56:46','2022-03-03 12:56:46'),(67842,193,'Rohta','282009',1,0,'2022-03-03 12:56:46','2022-03-03 12:56:46'),(67843,193,'Rojholi','283122',1,0,'2022-03-03 12:56:46','2022-03-03 12:56:46'),(67844,193,'Rudhmuli','283104',1,0,'2022-03-03 12:56:46','2022-03-03 12:56:46'),(67845,193,'Runkata','282007',1,0,'2022-03-03 12:56:46','2022-03-03 12:56:46'),(67846,193,'Sabora','283123',1,0,'2022-03-03 12:56:46','2022-03-03 12:56:46'),(67847,193,'Sadar Bazar (Agra)','282001',1,0,'2022-03-03 12:56:46','2022-03-03 12:56:46'),(67848,193,'Sahara','283105',1,0,'2022-03-03 12:56:46','2022-03-03 12:56:46'),(67849,193,'Sahata','283105',1,0,'2022-03-03 12:56:46','2022-03-03 12:56:46'),(67850,193,'Saiyan','283124',1,0,'2022-03-03 12:56:46','2022-03-03 12:56:46'),(67851,193,'Salemabad','283122',1,0,'2022-03-03 12:56:46','2022-03-03 12:56:46'),(67852,193,'Samara','283110',1,0,'2022-03-03 12:56:46','2022-03-03 12:56:46'),(67853,193,'Samsabad','283125',1,0,'2022-03-03 12:56:46','2022-03-03 12:56:46'),(67854,193,'Sandhan','283101',1,0,'2022-03-03 12:56:46','2022-03-03 12:56:46'),(67855,193,'Sanjay Place','282002',1,0,'2022-03-03 12:56:46','2022-03-03 12:56:46'),(67856,193,'Sanjeti','283114',1,0,'2022-03-03 12:56:46','2022-03-03 12:56:46'),(67857,193,'Sarai','283126',1,0,'2022-03-03 12:56:47','2022-03-03 12:56:47'),(67858,193,'Sarai Khawaja','282001',1,0,'2022-03-03 12:56:47','2022-03-03 12:56:47'),(67859,193,'Sarendha','283119',1,0,'2022-03-03 12:56:47','2022-03-03 12:56:47'),(67860,193,'Sarendi','283119',1,0,'2022-03-03 12:56:47','2022-03-03 12:56:47'),(67861,193,'Sawain','283202',1,0,'2022-03-03 12:56:47','2022-03-03 12:56:47'),(67862,193,'Semera','283126',1,0,'2022-03-03 12:56:47','2022-03-03 12:56:47'),(67863,193,'Semri','282009',1,0,'2022-03-03 12:56:47','2022-03-03 12:56:47'),(67864,193,'Seola Jat','282001',1,0,'2022-03-03 12:56:47','2022-03-03 12:56:47'),(67865,193,'Shahaganj (Agra)','282010',1,0,'2022-03-03 12:56:47','2022-03-03 12:56:47'),(67866,193,'Shahi','283105',1,0,'2022-03-03 12:56:47','2022-03-03 12:56:47'),(67867,193,'Shahpur Brahman','283114',1,0,'2022-03-03 12:56:47','2022-03-03 12:56:47'),(67868,193,'Shahpur Toola','283125',1,0,'2022-03-03 12:56:47','2022-03-03 12:56:47'),(67869,193,'Shastripuram','282007',1,0,'2022-03-03 12:56:47','2022-03-03 12:56:47'),(67870,193,'Shiaupura','283114',1,0,'2022-03-03 12:56:47','2022-03-03 12:56:47'),(67871,193,'Shiv Nagar','283114',1,0,'2022-03-03 12:56:47','2022-03-03 12:56:47'),(67872,193,'Shoe Market','282003',1,0,'2022-03-03 12:56:47','2022-03-03 12:56:47'),(67873,193,'Shyamo','283125',1,0,'2022-03-03 12:56:47','2022-03-03 12:56:47'),(67874,193,'Sidhaoli','283104',1,0,'2022-03-03 12:56:47','2022-03-03 12:56:47'),(67875,193,'Sikandra (Agra)','282007',1,0,'2022-03-03 12:56:47','2022-03-03 12:56:47'),(67876,193,'Sikraondha','283110',1,0,'2022-03-03 12:56:47','2022-03-03 12:56:47'),(67877,193,'Sikrara','283111',1,0,'2022-03-03 12:56:47','2022-03-03 12:56:47'),(67878,193,'Siktara','283201',1,0,'2022-03-03 12:56:47','2022-03-03 12:56:47'),(67879,193,'Singaich','283115',1,0,'2022-03-03 12:56:48','2022-03-03 12:56:48'),(67880,193,'Soni Khera','283115',1,0,'2022-03-03 12:56:48','2022-03-03 12:56:48'),(67881,193,'Subji Mandi','282007',1,0,'2022-03-03 12:56:48','2022-03-03 12:56:48'),(67882,193,'Sultan Pura','282001',1,0,'2022-03-03 12:56:48','2022-03-03 12:56:48'),(67883,193,'Sunari','283105',1,0,'2022-03-03 12:56:48','2022-03-03 12:56:48'),(67884,193,'Swara','283111',1,0,'2022-03-03 12:56:48','2022-03-03 12:56:48'),(67885,193,'T.P. Nagar','282002',1,0,'2022-03-03 12:56:48','2022-03-03 12:56:48'),(67886,193,'Taj Nagari','282004',1,0,'2022-03-03 12:56:48','2022-03-03 12:56:48'),(67887,193,'Taj','282001',1,0,'2022-03-03 12:56:48','2022-03-03 12:56:48'),(67888,193,'Tajganj','282001',1,0,'2022-03-03 12:56:48','2022-03-03 12:56:48'),(67889,193,'Tanora Noorpur','283111',1,0,'2022-03-03 12:56:48','2022-03-03 12:56:48'),(67890,193,'Tarauli Gujar','283111',1,0,'2022-03-03 12:56:48','2022-03-03 12:56:48'),(67891,193,'Tasond','283123',1,0,'2022-03-03 12:56:48','2022-03-03 12:56:48'),(67892,193,'Tehra','283124',1,0,'2022-03-03 12:56:48','2022-03-03 12:56:48'),(67893,193,'Tehu','283201',1,0,'2022-03-03 12:56:48','2022-03-03 12:56:48'),(67894,193,'Thana Shankar Dwari','283125',1,0,'2022-03-03 12:56:48','2022-03-03 12:56:48'),(67895,193,'Therai','283125',1,0,'2022-03-03 12:56:48','2022-03-03 12:56:48'),(67896,193,'Tiwaha','283111',1,0,'2022-03-03 12:56:48','2022-03-03 12:56:48'),(67897,193,'Tnatpur','283115',1,0,'2022-03-03 12:56:48','2022-03-03 12:56:48'),(67898,193,'Turkia','283101',1,0,'2022-03-03 12:56:48','2022-03-03 12:56:48'),(67899,193,'Ujarai','283102',1,0,'2022-03-03 12:56:48','2022-03-03 12:56:48'),(67900,193,'Umretha','283123',1,0,'2022-03-03 12:56:48','2022-03-03 12:56:48'),(67901,193,'Uncha','283126',1,0,'2022-03-03 12:56:48','2022-03-03 12:56:48'),(67902,193,'Undera','283110',1,0,'2022-03-03 12:56:48','2022-03-03 12:56:48'),(67903,193,'Ushmanpur','283201',1,0,'2022-03-03 12:56:48','2022-03-03 12:56:48'),(67904,193,'Vayu Vihar','283105',1,0,'2022-03-03 12:56:48','2022-03-03 12:56:48'),(67905,193,'Vikrampur','283104',1,0,'2022-03-03 12:56:49','2022-03-03 12:56:49'),(67906,193,'Waha','283119',1,0,'2022-03-03 12:56:49','2022-03-03 12:56:49'),(67907,193,'Wazir Pura','282003',1,0,'2022-03-03 12:56:49','2022-03-03 12:56:49'),(67908,193,'Wazitpur','283111',1,0,'2022-03-03 12:56:49','2022-03-03 12:56:49'),(67909,193,'Yamuna Bridge','282006',1,0,'2022-03-03 12:56:49','2022-03-03 12:56:49'),(67910,193,'Yamuna Kinara','282003',1,0,'2022-03-03 12:56:49','2022-03-03 12:56:49'),(67911,193,'Kalayanpur Bhagirathpur','202124',1,0,'2022-03-03 12:56:49','2022-03-03 12:56:49'),(67912,194,'Abhaipur Behlolpur','202133',1,0,'2022-03-03 12:56:49','2022-03-03 12:56:49'),(67913,194,'Achna','202138',1,0,'2022-03-03 12:56:49','2022-03-03 12:56:49'),(67914,194,'Adaun','202002',1,0,'2022-03-03 12:56:49','2022-03-03 12:56:49'),(67915,194,'Ahmedpur','202002',1,0,'2022-03-03 12:56:49','2022-03-03 12:56:49'),(67916,194,'Ahraula','202135',1,0,'2022-03-03 12:56:49','2022-03-03 12:56:49'),(67917,194,'Aidalpur','202135',1,0,'2022-03-03 12:56:49','2022-03-03 12:56:49'),(67918,194,'Aisi','202002',1,0,'2022-03-03 12:56:49','2022-03-03 12:56:49'),(67919,194,'Akrabad','202121',1,0,'2022-03-03 12:56:49','2022-03-03 12:56:49'),(67920,194,'Akrawat','202140',1,0,'2022-03-03 12:56:49','2022-03-03 12:56:49'),(67921,194,'Alampur Fatehpur','202133',1,0,'2022-03-03 12:56:49','2022-03-03 12:56:49'),(67922,194,'Alampur Rani Barla','202129',1,0,'2022-03-03 12:56:49','2022-03-03 12:56:49'),(67923,194,'Aligarh City','202001',1,0,'2022-03-03 12:56:49','2022-03-03 12:56:49'),(67924,194,'Aligarh Dairy Farm','202122',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67925,194,'Aligarh H.O','202001',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67926,194,'Aligarh Muslim University','202002',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67927,194,'Allahdadpur Aisi','202002',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67928,194,'Ama Madapur','204215',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67929,194,'Amrauli','202122',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67930,194,'Amritpur','202132',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67931,194,'Andla','202140',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67932,194,'Arrana','202138',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67933,194,'Asroi','204213',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67934,194,'Atrauli Ro R.S.','202282',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67935,194,'Atrauli','202280',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67936,194,'Badesara','202131',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67937,194,'Badhari Bujurg','202134',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67938,194,'Badholi','202282',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67939,194,'Badon','202140',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67940,194,'Bahadurpur Kota','202122',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67941,194,'Bain Kalan','202130',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67942,194,'Bajauta','202137',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67943,194,'Balwant Nagaria','202143',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67944,194,'Bamani','202138',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67945,194,'Bamnoi','204215',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67946,194,'Bamoti','202138',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67947,194,'Bankner','202135',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67948,194,'Bannadevi','202001',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67949,194,'Baranadi','202128',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67950,194,'Baraula','202126',1,0,'2022-03-03 12:56:50','2022-03-03 12:56:50'),(67951,194,'Barauli','202126',1,0,'2022-03-03 12:56:51','2022-03-03 12:56:51'),(67952,194,'Barla','202129',1,0,'2022-03-03 12:56:51','2022-03-03 12:56:51'),(67953,194,'Barotha','202125',1,0,'2022-03-03 12:56:51','2022-03-03 12:56:51'),(67954,194,'Basai Kazi','202150',1,0,'2022-03-03 12:56:51','2022-03-03 12:56:51'),(67955,194,'Beethna','202002',1,0,'2022-03-03 12:56:51','2022-03-03 12:56:51'),(67956,194,'Beharipur','202140',1,0,'2022-03-03 12:56:51','2022-03-03 12:56:51'),(67957,194,'Bembirpur','202281',1,0,'2022-03-03 12:56:51','2022-03-03 12:56:51'),(67958,194,'Bena','202165',1,0,'2022-03-03 12:56:51','2022-03-03 12:56:51'),(67959,194,'Beswan','202145',1,0,'2022-03-03 12:56:51','2022-03-03 12:56:51'),(67960,194,'Bhadesi','202002',1,0,'2022-03-03 12:56:51','2022-03-03 12:56:51'),(67961,194,'Bhagatpur','202132',1,0,'2022-03-03 12:56:51','2022-03-03 12:56:51'),(67962,194,'Bhaiyan','202124',1,0,'2022-03-03 12:56:51','2022-03-03 12:56:51'),(67963,194,'Bhamora Kalan','202130',1,0,'2022-03-03 12:56:51','2022-03-03 12:56:51'),(67964,194,'Bhangra','202145',1,0,'2022-03-03 12:56:51','2022-03-03 12:56:51'),(67965,194,'Bhankri Ahiwasi','202002',1,0,'2022-03-03 12:56:51','2022-03-03 12:56:51'),(67966,194,'Bhankri Niranjankot','202002',1,0,'2022-03-03 12:56:51','2022-03-03 12:56:51'),(67967,194,'Bharatpur','202141',1,0,'2022-03-03 12:56:51','2022-03-03 12:56:51'),(67968,194,'Bharpur','202132',1,0,'2022-03-03 12:56:51','2022-03-03 12:56:51'),(67969,194,'Bhavigarh','202125',1,0,'2022-03-03 12:56:51','2022-03-03 12:56:51'),(67970,194,'Bhemti','202002',1,0,'2022-03-03 12:56:51','2022-03-03 12:56:51'),(67971,194,'Bhikampur','202130',1,0,'2022-03-03 12:56:51','2022-03-03 12:56:51'),(67972,194,'Bhilet Ramnagar','202129',1,0,'2022-03-03 12:56:51','2022-03-03 12:56:51'),(67973,194,'Bhimpur','202142',1,0,'2022-03-03 12:56:51','2022-03-03 12:56:51'),(67974,194,'Bhojpur Nuri','202281',1,0,'2022-03-03 12:56:51','2022-03-03 12:56:51'),(67975,194,'Bidirka','202002',1,0,'2022-03-03 12:56:52','2022-03-03 12:56:52'),(67976,194,'Bijaigarh','202170',1,0,'2022-03-03 12:56:52','2022-03-03 12:56:52'),(67977,194,'Bijauli','202131',1,0,'2022-03-03 12:56:52','2022-03-03 12:56:52'),(67978,194,'Bilona Chitsari','202134',1,0,'2022-03-03 12:56:52','2022-03-03 12:56:52'),(67979,194,'Birpura','202142',1,0,'2022-03-03 12:56:52','2022-03-03 12:56:52'),(67980,194,'Bisara','202138',1,0,'2022-03-03 12:56:52','2022-03-03 12:56:52'),(67981,194,'Bistauli','202170',1,0,'2022-03-03 12:56:52','2022-03-03 12:56:52'),(67982,194,'Bonai','202133',1,0,'2022-03-03 12:56:52','2022-03-03 12:56:52'),(67983,194,'Budha Gaon','202134',1,0,'2022-03-03 12:56:52','2022-03-03 12:56:52'),(67984,194,'Budhansi','202125',1,0,'2022-03-03 12:56:52','2022-03-03 12:56:52'),(67985,194,'Chakathal','202281',1,0,'2022-03-03 12:56:52','2022-03-03 12:56:52'),(67986,194,'Chandaiya','202139',1,0,'2022-03-03 12:56:52','2022-03-03 12:56:52'),(67987,194,'Chandaua Goverdhanapur','202131',1,0,'2022-03-03 12:56:52','2022-03-03 12:56:52'),(67988,194,'Chandaus','202132',1,0,'2022-03-03 12:56:52','2022-03-03 12:56:52'),(67989,194,'Chandpur Mirza','204215',1,0,'2022-03-03 12:56:52','2022-03-03 12:56:52'),(67990,194,'Changeri','202128',1,0,'2022-03-03 12:56:53','2022-03-03 12:56:53'),(67991,194,'Chhabilpur','202280',1,0,'2022-03-03 12:56:53','2022-03-03 12:56:53'),(67992,194,'Chhadawali','202125',1,0,'2022-03-03 12:56:53','2022-03-03 12:56:53'),(67993,194,'Chhaichhau','202124',1,0,'2022-03-03 12:56:53','2022-03-03 12:56:53'),(67994,194,'Chhalesar','202127',1,0,'2022-03-03 12:56:53','2022-03-03 12:56:53'),(67995,194,'Chharra','202130',1,0,'2022-03-03 12:56:53','2022-03-03 12:56:53'),(67996,194,'Chherat','202122',1,0,'2022-03-03 12:56:53','2022-03-03 12:56:53'),(67997,194,'Chhonk','202170',1,0,'2022-03-03 12:56:53','2022-03-03 12:56:53'),(67998,194,'Chilawati','202142',1,0,'2022-03-03 12:56:53','2022-03-03 12:56:53'),(67999,194,'Civil Court (Aligarh)','202001',1,0,'2022-03-03 12:56:53','2022-03-03 12:56:53'),(68000,194,'D S College','202001',1,0,'2022-03-03 12:56:53','2022-03-03 12:56:53'),(68001,194,'Dabha','202121',1,0,'2022-03-03 12:56:53','2022-03-03 12:56:53'),(68002,194,'Dadon','202133',1,0,'2022-03-03 12:56:53','2022-03-03 12:56:53'),(68003,194,'Daheli','202126',1,0,'2022-03-03 12:56:53','2022-03-03 12:56:53'),(68004,194,'Datawali','202129',1,0,'2022-03-03 12:56:53','2022-03-03 12:56:53'),(68005,194,'Daupur','202126',1,0,'2022-03-03 12:56:53','2022-03-03 12:56:53'),(68006,194,'Dayal Nagar','202141',1,0,'2022-03-03 12:56:53','2022-03-03 12:56:53'),(68007,194,'Debthala','202126',1,0,'2022-03-03 12:56:53','2022-03-03 12:56:53'),(68008,194,'Delhi Gate (Aligarh)','202001',1,0,'2022-03-03 12:56:53','2022-03-03 12:56:53'),(68009,194,'Deopur','202143',1,0,'2022-03-03 12:56:53','2022-03-03 12:56:53'),(68010,194,'Deorau','202143',1,0,'2022-03-03 12:56:53','2022-03-03 12:56:53'),(68011,194,'Deta Khurd','202155',1,0,'2022-03-03 12:56:53','2022-03-03 12:56:53'),(68012,194,'Dewa Hamidpur','202141',1,0,'2022-03-03 12:56:53','2022-03-03 12:56:53'),(68013,194,'Dhanipur','202002',1,0,'2022-03-03 12:56:53','2022-03-03 12:56:53'),(68014,194,'Dhansari','202130',1,0,'2022-03-03 12:56:54','2022-03-03 12:56:54'),(68015,194,'Dhantauli','202123',1,0,'2022-03-03 12:56:54','2022-03-03 12:56:54'),(68016,194,'Digsari','202123',1,0,'2022-03-03 12:56:54','2022-03-03 12:56:54'),(68017,194,'Digsi','202002',1,0,'2022-03-03 12:56:54','2022-03-03 12:56:54'),(68018,194,'Dinapur','202133',1,0,'2022-03-03 12:56:54','2022-03-03 12:56:54'),(68019,194,'Dodhpur','202001',1,0,'2022-03-03 12:56:54','2022-03-03 12:56:54'),(68020,194,'Dudhma','202131',1,0,'2022-03-03 12:56:54','2022-03-03 12:56:54'),(68021,194,'Dunai','202140',1,0,'2022-03-03 12:56:54','2022-03-03 12:56:54'),(68022,194,'Fatehgarhi','202135',1,0,'2022-03-03 12:56:54','2022-03-03 12:56:54'),(68023,194,'Form Press','202001',1,0,'2022-03-03 12:56:54','2022-03-03 12:56:54'),(68024,194,'Gabhana','202136',1,0,'2022-03-03 12:56:54','2022-03-03 12:56:54'),(68025,194,'Gadrana','202150',1,0,'2022-03-03 12:56:54','2022-03-03 12:56:54'),(68026,194,'Gandhi Eye Hospital','202001',1,0,'2022-03-03 12:56:54','2022-03-03 12:56:54'),(68027,194,'Gangiri','202134',1,0,'2022-03-03 12:56:54','2022-03-03 12:56:54'),(68028,194,'Gangrol','202170',1,0,'2022-03-03 12:56:54','2022-03-03 12:56:54'),(68029,194,'Ganiyabali','202280',1,0,'2022-03-03 12:56:54','2022-03-03 12:56:54'),(68030,194,'Gehtoli Nirmal','202131',1,0,'2022-03-03 12:56:54','2022-03-03 12:56:54'),(68031,194,'Gharbara','202165',1,0,'2022-03-03 12:56:54','2022-03-03 12:56:54'),(68032,194,'Ghazipur','202280',1,0,'2022-03-03 12:56:54','2022-03-03 12:56:54'),(68033,194,'Gidauli','202124',1,0,'2022-03-03 12:56:55','2022-03-03 12:56:55'),(68034,194,'Godha','202127',1,0,'2022-03-03 12:56:55','2022-03-03 12:56:55'),(68035,194,'Gomat','202135',1,0,'2022-03-03 12:56:55','2022-03-03 12:56:55'),(68036,194,'Gonda','202123',1,0,'2022-03-03 12:56:55','2022-03-03 12:56:55'),(68037,194,'Gopi','204215',1,0,'2022-03-03 12:56:55','2022-03-03 12:56:55'),(68038,194,'Gorai','202145',1,0,'2022-03-03 12:56:55','2022-03-03 12:56:55'),(68039,194,'Gorola','202165',1,0,'2022-03-03 12:56:55','2022-03-03 12:56:55'),(68040,194,'Govindpur Fagoi','202002',1,0,'2022-03-03 12:56:55','2022-03-03 12:56:55'),(68041,194,'Gurusena','202002',1,0,'2022-03-03 12:56:55','2022-03-03 12:56:55'),(68042,194,'Gurushikharan','202125',1,0,'2022-03-03 12:56:55','2022-03-03 12:56:55'),(68043,194,'Habibganj','202130',1,0,'2022-03-03 12:56:55','2022-03-03 12:56:55'),(68044,194,'Haranpur Kalan','202133',1,0,'2022-03-03 12:56:55','2022-03-03 12:56:55'),(68045,194,'Harautha','202124',1,0,'2022-03-03 12:56:55','2022-03-03 12:56:55'),(68046,194,'Hardoi','202133',1,0,'2022-03-03 12:56:55','2022-03-03 12:56:55'),(68047,194,'Harduaganj','202125',1,0,'2022-03-03 12:56:55','2022-03-03 12:56:55'),(68048,194,'Harnaut','202133',1,0,'2022-03-03 12:56:55','2022-03-03 12:56:55'),(68049,194,'Hasona Jagmohanpur','202129',1,0,'2022-03-03 12:56:55','2022-03-03 12:56:55'),(68050,194,'Hastpur Chandfari','202002',1,0,'2022-03-03 12:56:55','2022-03-03 12:56:55'),(68051,194,'Hetalpur','202137',1,0,'2022-03-03 12:56:55','2022-03-03 12:56:55'),(68052,194,'Hinsel','202142',1,0,'2022-03-03 12:56:55','2022-03-03 12:56:55'),(68053,194,'I T I Road','202001',1,0,'2022-03-03 12:56:55','2022-03-03 12:56:55'),(68054,194,'Iglas','202124',1,0,'2022-03-03 12:56:55','2022-03-03 12:56:55'),(68055,194,'Iglas Thana','202124',1,0,'2022-03-03 12:56:55','2022-03-03 12:56:55'),(68056,194,'Industrial Area Aligarh','202001',1,0,'2022-03-03 12:56:55','2022-03-03 12:56:55'),(68057,194,'Ismailpur','202140',1,0,'2022-03-03 12:56:56','2022-03-03 12:56:56'),(68058,194,'Izzatpur','202280',1,0,'2022-03-03 12:56:56','2022-03-03 12:56:56'),(68059,194,'J D Singh','202281',1,0,'2022-03-03 12:56:56','2022-03-03 12:56:56'),(68060,194,'Jaidpura','202165',1,0,'2022-03-03 12:56:56','2022-03-03 12:56:56'),(68061,194,'Jaiganj','202001',1,0,'2022-03-03 12:56:56','2022-03-03 12:56:56'),(68062,194,'Jalali','202128',1,0,'2022-03-03 12:56:56','2022-03-03 12:56:56'),(68063,194,'Jalalpur','202137',1,0,'2022-03-03 12:56:56','2022-03-03 12:56:56'),(68064,194,'Jalalpur','202155',1,0,'2022-03-03 12:56:56','2022-03-03 12:56:56'),(68065,194,'Jallupur Sehore','202002',1,0,'2022-03-03 12:56:56','2022-03-03 12:56:56'),(68066,194,'Jalokhari','202155',1,0,'2022-03-03 12:56:56','2022-03-03 12:56:56'),(68067,194,'Jamaun','202145',1,0,'2022-03-03 12:56:56','2022-03-03 12:56:56'),(68068,194,'Jamonka','202141',1,0,'2022-03-03 12:56:56','2022-03-03 12:56:56'),(68069,194,'Jamuna','202282',1,0,'2022-03-03 12:56:56','2022-03-03 12:56:56'),(68070,194,'Jarara','202138',1,0,'2022-03-03 12:56:56','2022-03-03 12:56:56'),(68071,194,'Jatrauli','202137',1,0,'2022-03-03 12:56:56','2022-03-03 12:56:56'),(68072,194,'Jattari','202137',1,0,'2022-03-03 12:56:57','2022-03-03 12:56:57'),(68073,194,'Jatwar','202145',1,0,'2022-03-03 12:56:57','2022-03-03 12:56:57'),(68074,194,'Jawan','202126',1,0,'2022-03-03 12:56:57','2022-03-03 12:56:57'),(68075,194,'Jhijharka','202125',1,0,'2022-03-03 12:56:57','2022-03-03 12:56:57'),(68076,194,'Jirauli','202133',1,0,'2022-03-03 12:56:57','2022-03-03 12:56:57'),(68077,194,'Jiroli Dor','202140',1,0,'2022-03-03 12:56:57','2022-03-03 12:56:57'),(68078,194,'Jiroli Hira Singh','202121',1,0,'2022-03-03 12:56:57','2022-03-03 12:56:57'),(68079,194,'Kajrauth','202124',1,0,'2022-03-03 12:56:57','2022-03-03 12:56:57'),(68080,194,'Kakethal','202281',1,0,'2022-03-03 12:56:57','2022-03-03 12:56:57'),(68081,194,'Kalai','202125',1,0,'2022-03-03 12:56:57','2022-03-03 12:56:57'),(68082,194,'Kalua Bhilet','202124',1,0,'2022-03-03 12:56:57','2022-03-03 12:56:57'),(68083,194,'Kalwa','202002',1,0,'2022-03-03 12:56:57','2022-03-03 12:56:57'),(68084,194,'Kalyanpur','202280',1,0,'2022-03-03 12:56:57','2022-03-03 12:56:57'),(68085,194,'Kamalpur','202002',1,0,'2022-03-03 12:56:57','2022-03-03 12:56:57'),(68086,194,'Kandauli','202136',1,0,'2022-03-03 12:56:57','2022-03-03 12:56:57'),(68087,194,'Kanobi','202134',1,0,'2022-03-03 12:56:57','2022-03-03 12:56:57'),(68088,194,'Kanoi','202136',1,0,'2022-03-03 12:56:57','2022-03-03 12:56:57'),(68089,194,'Karanpur','202141',1,0,'2022-03-03 12:56:57','2022-03-03 12:56:57'),(68090,194,'Karanpur','202142',1,0,'2022-03-03 12:56:57','2022-03-03 12:56:57'),(68091,194,'Kaser','202133',1,0,'2022-03-03 12:56:57','2022-03-03 12:56:57'),(68092,194,'Kaseru','202132',1,0,'2022-03-03 12:56:57','2022-03-03 12:56:57'),(68093,194,'Kasimpur','202127',1,0,'2022-03-03 12:56:57','2022-03-03 12:56:57'),(68094,194,'Kasison','202135',1,0,'2022-03-03 12:56:57','2022-03-03 12:56:57'),(68095,194,'Kathera','202170',1,0,'2022-03-03 12:56:58','2022-03-03 12:56:58'),(68096,194,'Kauriyaganj','202129',1,0,'2022-03-03 12:56:58','2022-03-03 12:56:58'),(68097,194,'Kazimabad','202282',1,0,'2022-03-03 12:56:58','2022-03-03 12:56:58'),(68098,194,'Kemthal','202123',1,0,'2022-03-03 12:56:58','2022-03-03 12:56:58'),(68099,194,'Kesopur Jafri','202002',1,0,'2022-03-03 12:56:58','2022-03-03 12:56:58'),(68100,194,'Khair Mandi','202001',1,0,'2022-03-03 12:56:58','2022-03-03 12:56:58'),(68101,194,'Khair','202138',1,0,'2022-03-03 12:56:58','2022-03-03 12:56:58'),(68102,194,'Khan Alampur','202125',1,0,'2022-03-03 12:56:58','2022-03-03 12:56:58'),(68103,194,'Khandeha','202137',1,0,'2022-03-03 12:56:58','2022-03-03 12:56:58'),(68104,194,'Khandua','202133',1,0,'2022-03-03 12:56:58','2022-03-03 12:56:58'),(68105,194,'Khera Bujurg','202127',1,0,'2022-03-03 12:56:58','2022-03-03 12:56:58'),(68106,194,'Khera Narain Singh','202121',1,0,'2022-03-03 12:56:58','2022-03-03 12:56:58'),(68107,194,'Khera Sattu','202135',1,0,'2022-03-03 12:56:58','2022-03-03 12:56:58'),(68108,194,'Khirsauli','202145',1,0,'2022-03-03 12:56:58','2022-03-03 12:56:58'),(68109,194,'Khurrampur','202121',1,0,'2022-03-03 12:56:58','2022-03-03 12:56:58'),(68110,194,'Kilpur','202141',1,0,'2022-03-03 12:56:59','2022-03-03 12:56:59'),(68111,194,'Kiratpur Nimana','202140',1,0,'2022-03-03 12:56:59','2022-03-03 12:56:59'),(68112,194,'Klyanpur','202282',1,0,'2022-03-03 12:56:59','2022-03-03 12:56:59'),(68113,194,'Komari','202139',1,0,'2022-03-03 12:56:59','2022-03-03 12:56:59'),(68114,194,'Konchhor','202002',1,0,'2022-03-03 12:56:59','2022-03-03 12:56:59'),(68115,194,'Korah Rustampur','202136',1,0,'2022-03-03 12:56:59','2022-03-03 12:56:59'),(68116,194,'Kutchery (Aligarh)','202001',1,0,'2022-03-03 12:56:59','2022-03-03 12:56:59'),(68117,194,'Kutubour Amarpur','202129',1,0,'2022-03-03 12:56:59','2022-03-03 12:56:59'),(68118,194,'Ladhaua','202121',1,0,'2022-03-03 12:56:59','2022-03-03 12:56:59'),(68119,194,'Lehra','202133',1,0,'2022-03-03 12:56:59','2022-03-03 12:56:59'),(68120,194,'Lodha','202140',1,0,'2022-03-03 12:56:59','2022-03-03 12:56:59'),(68121,194,'Lohgarh','202281',1,0,'2022-03-03 12:56:59','2022-03-03 12:56:59'),(68122,194,'Lutsan','202139',1,0,'2022-03-03 12:56:59','2022-03-03 12:56:59'),(68123,194,'Madanpur','202135',1,0,'2022-03-03 12:56:59','2022-03-03 12:56:59'),(68124,194,'Madar Darwaja','202001',1,0,'2022-03-03 12:56:59','2022-03-03 12:56:59'),(68125,194,'Madha Habibpur','202155',1,0,'2022-03-03 12:56:59','2022-03-03 12:56:59'),(68126,194,'Madhaula','202143',1,0,'2022-03-03 12:56:59','2022-03-03 12:56:59'),(68127,194,'Madholi','202280',1,0,'2022-03-03 12:56:59','2022-03-03 12:56:59'),(68128,194,'Madrak','202150',1,0,'2022-03-03 12:56:59','2022-03-03 12:56:59'),(68129,194,'Mahavir Ganj','202001',1,0,'2022-03-03 12:56:59','2022-03-03 12:56:59'),(68130,194,'Mahua','202002',1,0,'2022-03-03 12:56:59','2022-03-03 12:56:59'),(68131,194,'Maisubhasgram','202145',1,0,'2022-03-03 12:56:59','2022-03-03 12:56:59'),(68132,194,'Majhola','202134',1,0,'2022-03-03 12:56:59','2022-03-03 12:56:59'),(68133,194,'Majupur','202140',1,0,'2022-03-03 12:56:59','2022-03-03 12:56:59'),(68134,194,'Malav','202165',1,0,'2022-03-03 12:56:59','2022-03-03 12:56:59'),(68135,194,'Malikpura','202150',1,0,'2022-03-03 12:57:00','2022-03-03 12:57:00'),(68136,194,'Malviya Nagar (Aligarh)','202282',1,0,'2022-03-03 12:57:00','2022-03-03 12:57:00'),(68137,194,'Manai','202121',1,0,'2022-03-03 12:57:00','2022-03-03 12:57:00'),(68138,194,'Mandanpur','202121',1,0,'2022-03-03 12:57:00','2022-03-03 12:57:00'),(68139,194,'Mandpur','202133',1,0,'2022-03-03 12:57:00','2022-03-03 12:57:00'),(68140,194,'Manena Ummedpur','202134',1,0,'2022-03-03 12:57:00','2022-03-03 12:57:00'),(68141,194,'Mangalayatan University','202146',1,0,'2022-03-03 12:57:00','2022-03-03 12:57:00'),(68142,194,'Manik Chowk','202001',1,0,'2022-03-03 12:57:00','2022-03-03 12:57:00'),(68143,194,'Manti Basai','202123',1,0,'2022-03-03 12:57:00','2022-03-03 12:57:00'),(68144,194,'Matroi','202124',1,0,'2022-03-03 12:57:00','2022-03-03 12:57:00'),(68145,194,'Maur','202137',1,0,'2022-03-03 12:57:00','2022-03-03 12:57:00'),(68146,194,'Medical College (Aligarh)','202002',1,0,'2022-03-03 12:57:00','2022-03-03 12:57:00'),(68147,194,'Mehgora','202155',1,0,'2022-03-03 12:57:00','2022-03-03 12:57:00'),(68148,194,'Mehrawal','202002',1,0,'2022-03-03 12:57:00','2022-03-03 12:57:00'),(68149,194,'Mirpur Khas','202155',1,0,'2022-03-03 12:57:00','2022-03-03 12:57:00'),(68150,194,'Mohkampur Garia','202145',1,0,'2022-03-03 12:57:00','2022-03-03 12:57:00'),(68151,194,'Mohrena','202136',1,0,'2022-03-03 12:57:00','2022-03-03 12:57:00'),(68152,194,'Mohreni','202124',1,0,'2022-03-03 12:57:00','2022-03-03 12:57:00'),(68153,194,'Mukandpur','202002',1,0,'2022-03-03 12:57:00','2022-03-03 12:57:00'),(68154,194,'Musepur Jalal','202150',1,0,'2022-03-03 12:57:00','2022-03-03 12:57:00'),(68155,194,'N C Kasimpur','202127',1,0,'2022-03-03 12:57:00','2022-03-03 12:57:00'),(68156,194,'Nagla Birkhu','202123',1,0,'2022-03-03 12:57:00','2022-03-03 12:57:00'),(68157,194,'Nagla Devi','202002',1,0,'2022-03-03 12:57:00','2022-03-03 12:57:00'),(68158,194,'Nagla Jagdeo','202123',1,0,'2022-03-03 12:57:00','2022-03-03 12:57:00'),(68159,194,'Nagla Jhujhar','202123',1,0,'2022-03-03 12:57:01','2022-03-03 12:57:01'),(68160,194,'Nagla Padam','202132',1,0,'2022-03-03 12:57:01','2022-03-03 12:57:01'),(68161,194,'Nagla Sarua','202142',1,0,'2022-03-03 12:57:01','2022-03-03 12:57:01'),(68162,194,'Naglamandir','202002',1,0,'2022-03-03 12:57:01','2022-03-03 12:57:01'),(68163,194,'Nah','202133',1,0,'2022-03-03 12:57:01','2022-03-03 12:57:01'),(68164,194,'Nahal','202131',1,0,'2022-03-03 12:57:01','2022-03-03 12:57:01'),(68165,194,'Narainpur','202141',1,0,'2022-03-03 12:57:01','2022-03-03 12:57:01'),(68166,194,'Narona Akapur','202125',1,0,'2022-03-03 12:57:01','2022-03-03 12:57:01'),(68167,194,'Narupura','202133',1,0,'2022-03-03 12:57:01','2022-03-03 12:57:01'),(68168,194,'Naugawan','202134',1,0,'2022-03-03 12:57:01','2022-03-03 12:57:01'),(68169,194,'Naurangabad','202001',1,0,'2022-03-03 12:57:01','2022-03-03 12:57:01'),(68170,194,'Ogipur','202132',1,0,'2022-03-03 12:57:01','2022-03-03 12:57:01'),(68171,194,'Orani Dalpatpur','202280',1,0,'2022-03-03 12:57:01','2022-03-03 12:57:01'),(68172,194,'Pachawari','202123',1,0,'2022-03-03 12:57:01','2022-03-03 12:57:01'),(68173,194,'Pahari Pur','202129',1,0,'2022-03-03 12:57:01','2022-03-03 12:57:01'),(68174,194,'Pahawati','202143',1,0,'2022-03-03 12:57:01','2022-03-03 12:57:01'),(68175,194,'Paindapur','202123',1,0,'2022-03-03 12:57:01','2022-03-03 12:57:01'),(68176,194,'Pairi','202136',1,0,'2022-03-03 12:57:01','2022-03-03 12:57:01'),(68177,194,'Paitra Nawabpur','202133',1,0,'2022-03-03 12:57:01','2022-03-03 12:57:01'),(68178,194,'Pala Aisi','202002',1,0,'2022-03-03 12:57:01','2022-03-03 12:57:01'),(68179,194,'Pala Chand','202138',1,0,'2022-03-03 12:57:01','2022-03-03 12:57:01'),(68180,194,'Pala Kastali','202122',1,0,'2022-03-03 12:57:01','2022-03-03 12:57:01'),(68181,194,'Pali Mukimpur','202131',1,0,'2022-03-03 12:57:01','2022-03-03 12:57:01'),(68182,194,'Palirajapur','202150',1,0,'2022-03-03 12:57:01','2022-03-03 12:57:01'),(68183,194,'Palsera','202137',1,0,'2022-03-03 12:57:02','2022-03-03 12:57:02'),(68184,194,'Panehra','202131',1,0,'2022-03-03 12:57:02','2022-03-03 12:57:02'),(68185,194,'Panethi','202002',1,0,'2022-03-03 12:57:02','2022-03-03 12:57:02'),(68186,194,'Parki','202127',1,0,'2022-03-03 12:57:02','2022-03-03 12:57:02'),(68187,194,'Pempur','202137',1,0,'2022-03-03 12:57:02','2022-03-03 12:57:02'),(68188,194,'Phusauli','202129',1,0,'2022-03-03 12:57:02','2022-03-03 12:57:02'),(68189,194,'Pilkhana','204102',1,0,'2022-03-03 12:57:02','2022-03-03 12:57:02'),(68190,194,'Pilona','202126',1,0,'2022-03-03 12:57:02','2022-03-03 12:57:02'),(68191,194,'Pipari','202131',1,0,'2022-03-03 12:57:02','2022-03-03 12:57:02'),(68192,194,'Pipoli','202129',1,0,'2022-03-03 12:57:02','2022-03-03 12:57:02'),(68193,194,'Pisawah','202155',1,0,'2022-03-03 12:57:02','2022-03-03 12:57:02'),(68194,194,'Pothi','202136',1,0,'2022-03-03 12:57:02','2022-03-03 12:57:02'),(68195,194,'Pureni','202280',1,0,'2022-03-03 12:57:02','2022-03-03 12:57:02'),(68196,194,'Quarsi','202002',1,0,'2022-03-03 12:57:02','2022-03-03 12:57:02'),(68197,194,'Rait','202140',1,0,'2022-03-03 12:57:02','2022-03-03 12:57:02'),(68198,194,'Rajatau','202131',1,0,'2022-03-03 12:57:02','2022-03-03 12:57:02'),(68199,194,'Rajawal','202123',1,0,'2022-03-03 12:57:02','2022-03-03 12:57:02'),(68200,194,'Rajmau','202133',1,0,'2022-03-03 12:57:02','2022-03-03 12:57:02'),(68201,194,'Rajpur','202141',1,0,'2022-03-03 12:57:02','2022-03-03 12:57:02'),(68202,194,'Rajpur Khas','202133',1,0,'2022-03-03 12:57:02','2022-03-03 12:57:02'),(68203,194,'Ramghat Road','202001',1,0,'2022-03-03 12:57:02','2022-03-03 12:57:02'),(68204,194,'Ramnagar','202133',1,0,'2022-03-03 12:57:02','2022-03-03 12:57:02'),(68205,194,'Rampur Chandyana','202133',1,0,'2022-03-03 12:57:02','2022-03-03 12:57:02'),(68206,194,'Rampur Shahpur','202142',1,0,'2022-03-03 12:57:02','2022-03-03 12:57:02'),(68207,194,'Rani','202280',1,0,'2022-03-03 12:57:02','2022-03-03 12:57:02'),(68208,194,'Ranjeet Garhi','202141',1,0,'2022-03-03 12:57:03','2022-03-03 12:57:03'),(68209,194,'Rasal Ganj','202001',1,0,'2022-03-03 12:57:03','2022-03-03 12:57:03'),(68210,194,'Rehsupur','202128',1,0,'2022-03-03 12:57:03','2022-03-03 12:57:03'),(68211,194,'Resari','202141',1,0,'2022-03-03 12:57:03','2022-03-03 12:57:03'),(68212,194,'Rukhala','202134',1,0,'2022-03-03 12:57:03','2022-03-03 12:57:03'),(68213,194,'Sabalpur','202155',1,0,'2022-03-03 12:57:03','2022-03-03 12:57:03'),(68214,194,'Sadhu Ashram','202125',1,0,'2022-03-03 12:57:03','2022-03-03 12:57:03'),(68215,194,'Sahajpur','202141',1,0,'2022-03-03 12:57:03','2022-03-03 12:57:03'),(68216,194,'Sahara Khurd','202124',1,0,'2022-03-03 12:57:03','2022-03-03 12:57:03'),(68217,194,'Sahjahanpur Baijna','202133',1,0,'2022-03-03 12:57:03','2022-03-03 12:57:03'),(68218,194,'Sahnaul','202282',1,0,'2022-03-03 12:57:03','2022-03-03 12:57:03'),(68219,194,'Salarpur','202281',1,0,'2022-03-03 12:57:03','2022-03-03 12:57:03'),(68220,194,'Salempur','202124',1,0,'2022-03-03 12:57:03','2022-03-03 12:57:03'),(68221,194,'Salpur','202141',1,0,'2022-03-03 12:57:03','2022-03-03 12:57:03'),(68222,194,'Sankra','202133',1,0,'2022-03-03 12:57:03','2022-03-03 12:57:03'),(68223,194,'Sarai Khirni','202001',1,0,'2022-03-03 12:57:03','2022-03-03 12:57:03'),(68224,194,'Sarai Kutub','202001',1,0,'2022-03-03 12:57:03','2022-03-03 12:57:03'),(68225,194,'Sarai Labaria','202001',1,0,'2022-03-03 12:57:03','2022-03-03 12:57:03'),(68226,194,'Sarsol','202002',1,0,'2022-03-03 12:57:03','2022-03-03 12:57:03'),(68227,194,'Sasni Gate','202001',1,0,'2022-03-03 12:57:03','2022-03-03 12:57:03'),(68228,194,'Satha','202127',1,0,'2022-03-03 12:57:03','2022-03-03 12:57:03'),(68229,194,'Sathini','202145',1,0,'2022-03-03 12:57:03','2022-03-03 12:57:03'),(68230,194,'Sawai Raghunathpur','202138',1,0,'2022-03-03 12:57:03','2022-03-03 12:57:03'),(68231,194,'Sehri Madangarhi','202123',1,0,'2022-03-03 12:57:04','2022-03-03 12:57:04'),(68232,194,'Shadipur','202137',1,0,'2022-03-03 12:57:04','2022-03-03 12:57:04'),(68233,194,'Shahabajpur','202150',1,0,'2022-03-03 12:57:04','2022-03-03 12:57:04'),(68234,194,'Shahagarh','202129',1,0,'2022-03-03 12:57:04','2022-03-03 12:57:04'),(68235,194,'Shahpur Kutub','202002',1,0,'2022-03-03 12:57:04','2022-03-03 12:57:04'),(68236,194,'Shahpur Madrak','202150',1,0,'2022-03-03 12:57:04','2022-03-03 12:57:04'),(68237,194,'Sheikhupur','202128',1,0,'2022-03-03 12:57:04','2022-03-03 12:57:04'),(68238,194,'Shikharan','202140',1,0,'2022-03-03 12:57:04','2022-03-03 12:57:04'),(68239,194,'Shiwala','202135',1,0,'2022-03-03 12:57:04','2022-03-03 12:57:04'),(68240,194,'Siarol','202165',1,0,'2022-03-03 12:57:04','2022-03-03 12:57:04'),(68241,194,'Sikandarpur Kota','202122',1,0,'2022-03-03 12:57:04','2022-03-03 12:57:04'),(68242,194,'Sikharna','202127',1,0,'2022-03-03 12:57:04','2022-03-03 12:57:04'),(68243,194,'Sikur','202139',1,0,'2022-03-03 12:57:04','2022-03-03 12:57:04'),(68244,194,'Simardhari','202124',1,0,'2022-03-03 12:57:04','2022-03-03 12:57:04'),(68245,194,'Simrauthi','202165',1,0,'2022-03-03 12:57:04','2022-03-03 12:57:04'),(68246,194,'Siroli','202130',1,0,'2022-03-03 12:57:04','2022-03-03 12:57:04'),(68247,194,'Siya Khas','202122',1,0,'2022-03-03 12:57:04','2022-03-03 12:57:04'),(68248,194,'Somna','202143',1,0,'2022-03-03 12:57:04','2022-03-03 12:57:04'),(68249,194,'Songra','202126',1,0,'2022-03-03 12:57:04','2022-03-03 12:57:04'),(68250,194,'Subhash Road (Aligarh)','202001',1,0,'2022-03-03 12:57:04','2022-03-03 12:57:04'),(68251,194,'Sudama Ka Bas','202145',1,0,'2022-03-03 12:57:04','2022-03-03 12:57:04'),(68252,194,'Sudeshpur','202132',1,0,'2022-03-03 12:57:04','2022-03-03 12:57:04'),(68253,194,'Suhawali','202121',1,0,'2022-03-03 12:57:04','2022-03-03 12:57:04'),(68254,194,'Sujanpur','202141',1,0,'2022-03-03 12:57:04','2022-03-03 12:57:04'),(68255,194,'Sumera','202126',1,0,'2022-03-03 12:57:04','2022-03-03 12:57:04'),(68256,194,'Sunamai','202127',1,0,'2022-03-03 12:57:05','2022-03-03 12:57:05'),(68257,194,'Sunpahar','202130',1,0,'2022-03-03 12:57:05','2022-03-03 12:57:05'),(68258,194,'T R M M Aligarh','202001',1,0,'2022-03-03 12:57:05','2022-03-03 12:57:05'),(68259,194,'Takipura','202141',1,0,'2022-03-03 12:57:05','2022-03-03 12:57:05'),(68260,194,'Talesara','202123',1,0,'2022-03-03 12:57:05','2022-03-03 12:57:05'),(68261,194,'Talib Nagar','202127',1,0,'2022-03-03 12:57:05','2022-03-03 12:57:05'),(68262,194,'Tamkoli','202136',1,0,'2022-03-03 12:57:05','2022-03-03 12:57:05'),(68263,194,'Tamotia','202145',1,0,'2022-03-03 12:57:05','2022-03-03 12:57:05'),(68264,194,'Tappal','202165',1,0,'2022-03-03 12:57:05','2022-03-03 12:57:05'),(68265,194,'Tatarpur','202150',1,0,'2022-03-03 12:57:05','2022-03-03 12:57:05'),(68266,194,'Teothu','202280',1,0,'2022-03-03 12:57:05','2022-03-03 12:57:05'),(68267,194,'Tuamai','202121',1,0,'2022-03-03 12:57:05','2022-03-03 12:57:05'),(68268,194,'Udaipur','202142',1,0,'2022-03-03 12:57:05','2022-03-03 12:57:05'),(68269,194,'Ukhlana','202125',1,0,'2022-03-03 12:57:05','2022-03-03 12:57:05'),(68270,194,'Umri','202141',1,0,'2022-03-03 12:57:05','2022-03-03 12:57:05'),(68271,194,'Untasani','202165',1,0,'2022-03-03 12:57:05','2022-03-03 12:57:05'),(68272,194,'Upperkot','202001',1,0,'2022-03-03 12:57:05','2022-03-03 12:57:05'),(68273,194,'Usram','202138',1,0,'2022-03-03 12:57:05','2022-03-03 12:57:05'),(68274,194,'Utra','202129',1,0,'2022-03-03 12:57:05','2022-03-03 12:57:05'),(68275,194,'Utwara','202138',1,0,'2022-03-03 12:57:05','2022-03-03 12:57:05'),(68276,194,'Vishnupuri','202001',1,0,'2022-03-03 12:57:05','2022-03-03 12:57:05'),(68277,194,'Zafar Manzil','202133',1,0,'2022-03-03 12:57:06','2022-03-03 12:57:06'),(68278,195,'Achhola','212303',1,0,'2022-03-03 12:57:06','2022-03-03 12:57:06'),(68279,195,'Agriculture Institute','211007',1,0,'2022-03-03 12:57:06','2022-03-03 12:57:06'),(68280,195,'Ahmadganj','211003',1,0,'2022-03-03 12:57:06','2022-03-03 12:57:06'),(68281,195,'Ahmedpur Asrauli','212208',1,0,'2022-03-03 12:57:06','2022-03-03 12:57:06'),(68282,195,'Ahmedpur Pawan','212208',1,0,'2022-03-03 12:57:06','2022-03-03 12:57:06'),(68283,195,'Ajhuwa Bazar ED','212217',1,0,'2022-03-03 12:57:06','2022-03-03 12:57:06'),(68284,195,'Akorha','212301',1,0,'2022-03-03 12:57:06','2022-03-03 12:57:06'),(68285,195,'Aladadpur','229411',1,0,'2022-03-03 12:57:06','2022-03-03 12:57:06'),(68286,195,'Allahabad Chowk','211003',1,0,'2022-03-03 12:57:06','2022-03-03 12:57:06'),(68287,195,'Allahabad City','211003',1,0,'2022-03-03 12:57:06','2022-03-03 12:57:06'),(68288,195,'Allahabad Fort','211005',1,0,'2022-03-03 12:57:06','2022-03-03 12:57:06'),(68289,195,'Allahabad H.O','211001',1,0,'2022-03-03 12:57:06','2022-03-03 12:57:06'),(68290,195,'Allahabad High Court','211017',1,0,'2022-03-03 12:57:06','2022-03-03 12:57:06'),(68291,195,'Allahabad Kty. H.O','211002',1,0,'2022-03-03 12:57:06','2022-03-03 12:57:06'),(68292,195,'Allahabad New Cantt','211001',1,0,'2022-03-03 12:57:06','2022-03-03 12:57:06'),(68293,195,'Allahpur','211006',1,0,'2022-03-03 12:57:06','2022-03-03 12:57:06'),(68294,195,'Allenganj','211002',1,0,'2022-03-03 12:57:06','2022-03-03 12:57:06'),(68295,195,'Amilia Kalan','212303',1,0,'2022-03-03 12:57:06','2022-03-03 12:57:06'),(68296,195,'Amitco','211002',1,0,'2022-03-03 12:57:06','2022-03-03 12:57:06'),(68297,195,'Amora','212303',1,0,'2022-03-03 12:57:06','2022-03-03 12:57:06'),(68298,195,'Anapur','229411',1,0,'2022-03-03 12:57:06','2022-03-03 12:57:06'),(68299,195,'Andhiyaari','229413',1,0,'2022-03-03 12:57:06','2022-03-03 12:57:06'),(68300,195,'Anuwa','212401',1,0,'2022-03-03 12:57:07','2022-03-03 12:57:07'),(68301,195,'Arahkala','221508',1,0,'2022-03-03 12:57:07','2022-03-03 12:57:07'),(68302,195,'Arai','212301',1,0,'2022-03-03 12:57:07','2022-03-03 12:57:07'),(68303,195,'Arail','211008',1,0,'2022-03-03 12:57:07','2022-03-03 12:57:07'),(68304,195,'Aruvaon','212503',1,0,'2022-03-03 12:57:07','2022-03-03 12:57:07'),(68305,195,'Ashey  Pur','221508',1,0,'2022-03-03 12:57:07','2022-03-03 12:57:07'),(68306,195,'Asrawey Kalan','211012',1,0,'2022-03-03 12:57:07','2022-03-03 12:57:07'),(68307,195,'Atrampur','229412',1,0,'2022-03-03 12:57:07','2022-03-03 12:57:07'),(68308,195,'Atraura','221502',1,0,'2022-03-03 12:57:07','2022-03-03 12:57:07'),(68309,195,'Attarsuiya','211003',1,0,'2022-03-03 12:57:07','2022-03-03 12:57:07'),(68310,195,'Aunta','212303',1,0,'2022-03-03 12:57:07','2022-03-03 12:57:07'),(68311,195,'Aura','221502',1,0,'2022-03-03 12:57:07','2022-03-03 12:57:07'),(68312,195,'Ayodhya','212306',1,0,'2022-03-03 12:57:07','2022-03-03 12:57:07'),(68313,195,'Babhan Kuiyan','221507',1,0,'2022-03-03 12:57:07','2022-03-03 12:57:07'),(68314,195,'Babhani Hethar','212303',1,0,'2022-03-03 12:57:07','2022-03-03 12:57:07'),(68315,195,'Babuganj','212404',1,0,'2022-03-03 12:57:07','2022-03-03 12:57:07'),(68316,195,'Badagaon','212502',1,0,'2022-03-03 12:57:07','2022-03-03 12:57:07'),(68317,195,'Badaur','212306',1,0,'2022-03-03 12:57:07','2022-03-03 12:57:07'),(68318,195,'Badokhar','212306',1,0,'2022-03-03 12:57:07','2022-03-03 12:57:07'),(68319,195,'Bagai Khurd','212404',1,0,'2022-03-03 12:57:07','2022-03-03 12:57:07'),(68320,195,'Bagbana','212111',1,0,'2022-03-03 12:57:07','2022-03-03 12:57:07'),(68321,195,'Bahadurganj (Allahabad)','211003',1,0,'2022-03-03 12:57:08','2022-03-03 12:57:08'),(68322,195,'Bahadurgarh Arwasi','212402',1,0,'2022-03-03 12:57:08','2022-03-03 12:57:08'),(68323,195,'Baharia Bazar','212109',1,0,'2022-03-03 12:57:08','2022-03-03 12:57:08'),(68324,195,'Bahraicha','212106',1,0,'2022-03-03 12:57:08','2022-03-03 12:57:08'),(68325,195,'Bai Ka Bagh','211003',1,0,'2022-03-03 12:57:08','2022-03-03 12:57:08'),(68326,195,'Bajha Mazra Lohia Nagar','229412',1,0,'2022-03-03 12:57:08','2022-03-03 12:57:08'),(68327,195,'Bakajalalpur','212507',1,0,'2022-03-03 12:57:08','2022-03-03 12:57:08'),(68328,195,'Balapur','212111',1,0,'2022-03-03 12:57:08','2022-03-03 12:57:08'),(68329,195,'Balraj Nagar','229412',1,0,'2022-03-03 12:57:08','2022-03-03 12:57:08'),(68330,195,'Bamaila','221503',1,0,'2022-03-03 12:57:08','2022-03-03 12:57:08'),(68331,195,'Bamhrauli Uparhar','211012',1,0,'2022-03-03 12:57:08','2022-03-03 12:57:08'),(68332,195,'Bampur','212104',1,0,'2022-03-03 12:57:08','2022-03-03 12:57:08'),(68333,195,'Bamrauli Air Port','211012',1,0,'2022-03-03 12:57:09','2022-03-03 12:57:09'),(68334,195,'Bamrauli','212201',1,0,'2022-03-03 12:57:09','2022-03-03 12:57:09'),(68335,195,'Bamrauli','211012',1,0,'2022-03-03 12:57:09','2022-03-03 12:57:09'),(68336,195,'Bara','212107',1,0,'2022-03-03 12:57:09','2022-03-03 12:57:09'),(68337,195,'Barai Harakh','212503',1,0,'2022-03-03 12:57:09','2022-03-03 12:57:09'),(68338,195,'Baraon','212301',1,0,'2022-03-03 12:57:09','2022-03-03 12:57:09'),(68339,195,'Barasta Kalan','212405',1,0,'2022-03-03 12:57:09','2022-03-03 12:57:09'),(68340,195,'Baraut','221502',1,0,'2022-03-03 12:57:09','2022-03-03 12:57:09'),(68341,195,'Barethi','221505',1,0,'2022-03-03 12:57:09','2022-03-03 12:57:09'),(68342,195,'Barha','212106',1,0,'2022-03-03 12:57:09','2022-03-03 12:57:09'),(68343,195,'Barha Kalan','212303',1,0,'2022-03-03 12:57:09','2022-03-03 12:57:09'),(68344,195,'Bari','212502',1,0,'2022-03-03 12:57:09','2022-03-03 12:57:09'),(68345,195,'Basahi','212307',1,0,'2022-03-03 12:57:09','2022-03-03 12:57:09'),(68346,195,'Basahra','212302',1,0,'2022-03-03 12:57:09','2022-03-03 12:57:09'),(68347,195,'Basahra Uparhar','212108',1,0,'2022-03-03 12:57:09','2022-03-03 12:57:09'),(68348,195,'Baserhi','212213',1,0,'2022-03-03 12:57:09','2022-03-03 12:57:09'),(68349,195,'Basgit Bazar','221508',1,0,'2022-03-03 12:57:09','2022-03-03 12:57:09'),(68350,195,'Basna','212405',1,0,'2022-03-03 12:57:09','2022-03-03 12:57:09'),(68351,195,'Bedauli','212104',1,0,'2022-03-03 12:57:09','2022-03-03 12:57:09'),(68352,195,'Beerapur','221503',1,0,'2022-03-03 12:57:09','2022-03-03 12:57:09'),(68353,195,'Belamundi','212107',1,0,'2022-03-03 12:57:09','2022-03-03 12:57:09'),(68354,195,'Belhat','212302',1,0,'2022-03-03 12:57:09','2022-03-03 12:57:09'),(68355,195,'Belsara','212106',1,0,'2022-03-03 12:57:09','2022-03-03 12:57:09'),(68356,195,'Belwa','221507',1,0,'2022-03-03 12:57:10','2022-03-03 12:57:10'),(68357,195,'Bemra','212108',1,0,'2022-03-03 12:57:10','2022-03-03 12:57:10'),(68358,195,'Bendon','212301',1,0,'2022-03-03 12:57:10','2022-03-03 12:57:10'),(68359,195,'Beri','212306',1,0,'2022-03-03 12:57:10','2022-03-03 12:57:10'),(68360,195,'Bhaganpur','212303',1,0,'2022-03-03 12:57:10','2022-03-03 12:57:10'),(68361,195,'Bhageshar','212306',1,0,'2022-03-03 12:57:10','2022-03-03 12:57:10'),(68362,195,'Bhagwatipurkhutana','212503',1,0,'2022-03-03 12:57:10','2022-03-03 12:57:10'),(68363,195,'Bhagwatpur','211012',1,0,'2022-03-03 12:57:10','2022-03-03 12:57:10'),(68364,195,'Bhaiyan','212302',1,0,'2022-03-03 12:57:10','2022-03-03 12:57:10'),(68365,195,'Bhandiwar','212108',1,0,'2022-03-03 12:57:10','2022-03-03 12:57:10'),(68366,195,'Bhanjanpur','212104',1,0,'2022-03-03 12:57:10','2022-03-03 12:57:10'),(68367,195,'Bharari','212303',1,0,'2022-03-03 12:57:10','2022-03-03 12:57:10'),(68368,195,'Bharat Nagar','212106',1,0,'2022-03-03 12:57:10','2022-03-03 12:57:10'),(68369,195,'Bharatganj','212104',1,0,'2022-03-03 12:57:10','2022-03-03 12:57:10'),(68370,195,'Bhatauti','212302',1,0,'2022-03-03 12:57:11','2022-03-03 12:57:11'),(68371,195,'Bhatewra Kathar','212401',1,0,'2022-03-03 12:57:11','2022-03-03 12:57:11'),(68372,195,'Bhelsi','221502',1,0,'2022-03-03 12:57:11','2022-03-03 12:57:11'),(68373,195,'Bhita','212107',1,0,'2022-03-03 12:57:11','2022-03-03 12:57:11'),(68374,195,'Bhiti','221502',1,0,'2022-03-03 12:57:11','2022-03-03 12:57:11'),(68375,195,'Bhogwara','212405',1,0,'2022-03-03 12:57:11','2022-03-03 12:57:11'),(68376,195,'Bhopatpur','221503',1,0,'2022-03-03 12:57:11','2022-03-03 12:57:11'),(68377,195,'Bhunda','212307',1,0,'2022-03-03 12:57:11','2022-03-03 12:57:11'),(68378,195,'Bigahuna','212305',1,0,'2022-03-03 12:57:11','2022-03-03 12:57:11'),(68379,195,'Biharia','229413',1,0,'2022-03-03 12:57:11','2022-03-03 12:57:11'),(68380,195,'Bihariya','212108',1,0,'2022-03-03 12:57:11','2022-03-03 12:57:11'),(68381,195,'Bikikalan','212302',1,0,'2022-03-03 12:57:11','2022-03-03 12:57:11'),(68382,195,'Bilari','221502',1,0,'2022-03-03 12:57:11','2022-03-03 12:57:11'),(68383,195,'Birpur','212307',1,0,'2022-03-03 12:57:11','2022-03-03 12:57:11'),(68384,195,'Bisari','212306',1,0,'2022-03-03 12:57:11','2022-03-03 12:57:11'),(68385,195,'Bisauna','211012',1,0,'2022-03-03 12:57:11','2022-03-03 12:57:11'),(68386,195,'Bithauli','221502',1,0,'2022-03-03 12:57:11','2022-03-03 12:57:11'),(68387,195,'Bomapur','212109',1,0,'2022-03-03 12:57:11','2022-03-03 12:57:11'),(68388,195,'Buir','221508',1,0,'2022-03-03 12:57:11','2022-03-03 12:57:11'),(68389,195,'Buxie Khurde','211006',1,0,'2022-03-03 12:57:11','2022-03-03 12:57:11'),(68390,195,'C D A (P)','211014',1,0,'2022-03-03 12:57:11','2022-03-03 12:57:11'),(68391,195,'Cavellary Lines','211004',1,0,'2022-03-03 12:57:11','2022-03-03 12:57:11'),(68392,195,'Chaka','211008',1,0,'2022-03-03 12:57:11','2022-03-03 12:57:11'),(68393,195,'Chaka','221508',1,0,'2022-03-03 12:57:11','2022-03-03 12:57:11'),(68394,195,'Chamrupur Urf Nantaut','212402',1,0,'2022-03-03 12:57:12','2022-03-03 12:57:12'),(68395,195,'Chamu','212106',1,0,'2022-03-03 12:57:12','2022-03-03 12:57:12'),(68396,195,'Chandopara','212402',1,0,'2022-03-03 12:57:12','2022-03-03 12:57:12'),(68397,195,'Chandpur','212502',1,0,'2022-03-03 12:57:12','2022-03-03 12:57:12'),(68398,195,'Chanethu','212401',1,0,'2022-03-03 12:57:12','2022-03-03 12:57:12'),(68399,195,'Charwa','212203',1,0,'2022-03-03 12:57:12','2022-03-03 12:57:12'),(68400,195,'Chawki','212305',1,0,'2022-03-03 12:57:12','2022-03-03 12:57:12'),(68401,195,'Chhapar','212106',1,0,'2022-03-03 12:57:12','2022-03-03 12:57:12'),(68402,195,'Chhata','212507',1,0,'2022-03-03 12:57:12','2022-03-03 12:57:12'),(68403,195,'Chhatahra','212107',1,0,'2022-03-03 12:57:12','2022-03-03 12:57:12'),(68404,195,'Chhatnag','211019',1,0,'2022-03-03 12:57:12','2022-03-03 12:57:12'),(68405,195,'Chheoki','212105',1,0,'2022-03-03 12:57:12','2022-03-03 12:57:12'),(68406,195,'Chhibaiya','211019',1,0,'2022-03-03 12:57:12','2022-03-03 12:57:12'),(68407,195,'Chhiri','212107',1,0,'2022-03-03 12:57:12','2022-03-03 12:57:12'),(68408,195,'Chhitpalgarh','212507',1,0,'2022-03-03 12:57:12','2022-03-03 12:57:12'),(68409,195,'Chilla','212107',1,0,'2022-03-03 12:57:12','2022-03-03 12:57:12'),(68410,195,'Chiraon','212306',1,0,'2022-03-03 12:57:12','2022-03-03 12:57:12'),(68411,195,'Dahiyawan','212503',1,0,'2022-03-03 12:57:13','2022-03-03 12:57:13'),(68412,195,'Dandi Bazar ED','211008',1,0,'2022-03-03 12:57:13','2022-03-03 12:57:13'),(68413,195,'Dandupur','212111',1,0,'2022-03-03 12:57:13','2022-03-03 12:57:13'),(68414,195,'Daraganj','211006',1,0,'2022-03-03 12:57:13','2022-03-03 12:57:13'),(68415,195,'Daranagar (Allahabad)','212204',1,0,'2022-03-03 12:57:13','2022-03-03 12:57:13'),(68416,195,'Darashahazmal','211003',1,0,'2022-03-03 12:57:13','2022-03-03 12:57:13'),(68417,195,'Dari','212302',1,0,'2022-03-03 12:57:13','2022-03-03 12:57:13'),(68418,195,'Daswar','212104',1,0,'2022-03-03 12:57:13','2022-03-03 12:57:13'),(68419,195,'Deeha','212307',1,0,'2022-03-03 12:57:13','2022-03-03 12:57:13'),(68420,195,'Deewanganj','212402',1,0,'2022-03-03 12:57:13','2022-03-03 12:57:13'),(68421,195,'Deoghat','212306',1,0,'2022-03-03 12:57:13','2022-03-03 12:57:13'),(68422,195,'Deoli','212402',1,0,'2022-03-03 12:57:13','2022-03-03 12:57:13'),(68423,195,'Deonahri','221507',1,0,'2022-03-03 12:57:13','2022-03-03 12:57:13'),(68424,195,'Deora','212301',1,0,'2022-03-03 12:57:13','2022-03-03 12:57:13'),(68425,195,'Deys Medical Tiraha','211010',1,0,'2022-03-03 12:57:13','2022-03-03 12:57:13'),(68426,195,'Dhanaura','212301',1,0,'2022-03-03 12:57:13','2022-03-03 12:57:13'),(68427,195,'Dhanupur','221503',1,0,'2022-03-03 12:57:13','2022-03-03 12:57:13'),(68428,195,'Dhara','212107',1,0,'2022-03-03 12:57:13','2022-03-03 12:57:13'),(68429,195,'Dhobaha','221502',1,0,'2022-03-03 12:57:13','2022-03-03 12:57:13'),(68430,195,'Dhokari','221508',1,0,'2022-03-03 12:57:13','2022-03-03 12:57:13'),(68431,195,'Dhoomanganj','211011',1,0,'2022-03-03 12:57:13','2022-03-03 12:57:13'),(68432,195,'Distt.Board','211002',1,0,'2022-03-03 12:57:13','2022-03-03 12:57:13'),(68433,195,'Dohariya','212305',1,0,'2022-03-03 12:57:13','2022-03-03 12:57:13'),(68434,195,'Dohatha','212104',1,0,'2022-03-03 12:57:13','2022-03-03 12:57:13'),(68435,195,'Dubaha','212107',1,0,'2022-03-03 12:57:14','2022-03-03 12:57:14'),(68436,195,'Dubawal','221505',1,0,'2022-03-03 12:57:14','2022-03-03 12:57:14'),(68437,195,'Dubeypur','212305',1,0,'2022-03-03 12:57:14','2022-03-03 12:57:14'),(68438,195,'Dumduma','221508',1,0,'2022-03-03 12:57:14','2022-03-03 12:57:14'),(68439,195,'Fatehpur Ghat','212208',1,0,'2022-03-03 12:57:14','2022-03-03 12:57:14'),(68440,195,'G T B Nagar','211016',1,0,'2022-03-03 12:57:14','2022-03-03 12:57:14'),(68441,195,'Ganja','211012',1,0,'2022-03-03 12:57:14','2022-03-03 12:57:14'),(68442,195,'Garapur','221507',1,0,'2022-03-03 12:57:14','2022-03-03 12:57:14'),(68443,195,'Garha','212306',1,0,'2022-03-03 12:57:14','2022-03-03 12:57:14'),(68444,195,'Gauspur','212213',1,0,'2022-03-03 12:57:14','2022-03-03 12:57:14'),(68445,195,'Gauspur Katahula','211012',1,0,'2022-03-03 12:57:14','2022-03-03 12:57:14'),(68446,195,'George Town','211002',1,0,'2022-03-03 12:57:14','2022-03-03 12:57:14'),(68447,195,'Ghiya Ngr','212404',1,0,'2022-03-03 12:57:14','2022-03-03 12:57:14'),(68448,195,'Ghodedeeh','212307',1,0,'2022-03-03 12:57:14','2022-03-03 12:57:14'),(68449,195,'Ghoorpur','212111',1,0,'2022-03-03 12:57:14','2022-03-03 12:57:14'),(68450,195,'Girdkot','221502',1,0,'2022-03-03 12:57:14','2022-03-03 12:57:14'),(68451,195,'Gohari','211013',1,0,'2022-03-03 12:57:14','2022-03-03 12:57:14'),(68452,195,'Gorigon','212402',1,0,'2022-03-03 12:57:14','2022-03-03 12:57:14'),(68453,195,'Gunai Gaharpur','212302',1,0,'2022-03-03 12:57:14','2022-03-03 12:57:14'),(68454,195,'Handi T I','221503',1,0,'2022-03-03 12:57:14','2022-03-03 12:57:14'),(68455,195,'Handia Manpur','212306',1,0,'2022-03-03 12:57:14','2022-03-03 12:57:14'),(68456,195,'Handia','221503',1,0,'2022-03-03 12:57:14','2022-03-03 12:57:14'),(68457,195,'Hanumanganj (Allahabad)','221505',1,0,'2022-03-03 12:57:14','2022-03-03 12:57:14'),(68458,195,'Harduwa','212301',1,0,'2022-03-03 12:57:14','2022-03-03 12:57:14'),(68459,195,'Haripur Marron','221503',1,0,'2022-03-03 12:57:14','2022-03-03 12:57:14'),(68460,195,'Harisenganj','212507',1,0,'2022-03-03 12:57:15','2022-03-03 12:57:15'),(68461,195,'Hata','212104',1,0,'2022-03-03 12:57:15','2022-03-03 12:57:15'),(68462,195,'Hathigahan','211013',1,0,'2022-03-03 12:57:15','2022-03-03 12:57:15'),(68463,195,'Hetapatti','221507',1,0,'2022-03-03 12:57:15','2022-03-03 12:57:15'),(68464,195,'Hetapur','221505',1,0,'2022-03-03 12:57:15','2022-03-03 12:57:15'),(68465,195,'Hindi Sahitya Sammelan','211003',1,0,'2022-03-03 12:57:15','2022-03-03 12:57:15'),(68466,195,'Holagarh','212503',1,0,'2022-03-03 12:57:15','2022-03-03 12:57:15'),(68467,195,'I L C','211008',1,0,'2022-03-03 12:57:15','2022-03-03 12:57:15'),(68468,195,'I T I',' Naini',1,0,'2022-03-03 12:57:15','2022-03-03 12:57:15'),(68469,195,'Indian Press','211002',1,0,'2022-03-03 12:57:15','2022-03-03 12:57:15'),(68470,195,'Ismailganj','211013',1,0,'2022-03-03 12:57:15','2022-03-03 12:57:15'),(68471,195,'Issauta','212301',1,0,'2022-03-03 12:57:15','2022-03-03 12:57:15'),(68472,195,'Jagatpur','221505',1,0,'2022-03-03 12:57:15','2022-03-03 12:57:15'),(68473,195,'Jagdishpur','221503',1,0,'2022-03-03 12:57:15','2022-03-03 12:57:15'),(68474,195,'Jagdishpur','211013',1,0,'2022-03-03 12:57:15','2022-03-03 12:57:15'),(68475,195,'Jaguwa','221503',1,0,'2022-03-03 12:57:15','2022-03-03 12:57:15'),(68476,195,'Jalalpur Ghosi','211012',1,0,'2022-03-03 12:57:15','2022-03-03 12:57:15'),(68477,195,'Jalalpur Kasba','212402',1,0,'2022-03-03 12:57:15','2022-03-03 12:57:15'),(68478,195,'Jamunipur','221505',1,0,'2022-03-03 12:57:15','2022-03-03 12:57:15'),(68479,195,'Janghai Bazar','212401',1,0,'2022-03-03 12:57:15','2022-03-03 12:57:15'),(68480,195,'Jari Bazar','212106',1,0,'2022-03-03 12:57:15','2022-03-03 12:57:15'),(68481,195,'Jasra','212107',1,0,'2022-03-03 12:57:15','2022-03-03 12:57:15'),(68482,195,'Jaswan','221502',1,0,'2022-03-03 12:57:15','2022-03-03 12:57:15'),(68483,195,'Jawaniya','212305',1,0,'2022-03-03 12:57:15','2022-03-03 12:57:15'),(68484,195,'Jhunsi','211019',1,0,'2022-03-03 12:57:16','2022-03-03 12:57:16'),(68485,195,'K G Marg','211002',1,0,'2022-03-03 12:57:16','2022-03-03 12:57:16'),(68486,195,'K N Marg','211001',1,0,'2022-03-03 12:57:16','2022-03-03 12:57:16'),(68487,195,'Kahli','212109',1,0,'2022-03-03 12:57:16','2022-03-03 12:57:16'),(68488,195,'Kalyani Devi','211003',1,0,'2022-03-03 12:57:16','2022-03-03 12:57:16'),(68489,195,'Kamlanagar','212109',1,0,'2022-03-03 12:57:16','2022-03-03 12:57:16'),(68490,195,'Kamlanagar','211002',1,0,'2022-03-03 12:57:16','2022-03-03 12:57:16'),(68491,195,'Kanethi','212402',1,0,'2022-03-03 12:57:16','2022-03-03 12:57:16'),(68492,195,'Kanti','212107',1,0,'2022-03-03 12:57:16','2022-03-03 12:57:16'),(68493,195,'Kapasi Kalan','212306',1,0,'2022-03-03 12:57:16','2022-03-03 12:57:16'),(68494,195,'Kapraura','212106',1,0,'2022-03-03 12:57:16','2022-03-03 12:57:16'),(68495,195,'Kapsa','212402',1,0,'2022-03-03 12:57:16','2022-03-03 12:57:16'),(68496,195,'Karaundi','212502',1,0,'2022-03-03 12:57:16','2022-03-03 12:57:16'),(68497,195,'Karchha R.S.','212301',1,0,'2022-03-03 12:57:16','2022-03-03 12:57:16'),(68498,195,'Karchhana','212301',1,0,'2022-03-03 12:57:16','2022-03-03 12:57:16'),(68499,195,'Karehnda','211012',1,0,'2022-03-03 12:57:16','2022-03-03 12:57:16'),(68500,195,'Karma','212111',1,0,'2022-03-03 12:57:16','2022-03-03 12:57:16'),(68501,195,'Karnaipur','212109',1,0,'2022-03-03 12:57:16','2022-03-03 12:57:16'),(68502,195,'Karpia','212306',1,0,'2022-03-03 12:57:16','2022-03-03 12:57:16'),(68503,195,'Katahra','221503',1,0,'2022-03-03 12:57:16','2022-03-03 12:57:16'),(68504,195,'Katghar (Allahabad)','211003',1,0,'2022-03-03 12:57:16','2022-03-03 12:57:16'),(68505,195,'Kathauli','212303',1,0,'2022-03-03 12:57:16','2022-03-03 12:57:16'),(68506,195,'Katra (Allahabad)','211002',1,0,'2022-03-03 12:57:16','2022-03-03 12:57:16'),(68507,195,'Katrauli','212303',1,0,'2022-03-03 12:57:16','2022-03-03 12:57:16'),(68508,195,'Katrauli','212402',1,0,'2022-03-03 12:57:16','2022-03-03 12:57:16'),(68509,195,'Katwaroopur','221505',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68510,195,'Kaundhiyra','212106',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68511,195,'Kayastha Pathshala','211001',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68512,195,'Kesaria Road','211016',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68513,195,'Kewai Buzurg','221502',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68514,195,'Khain','212307',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68515,195,'Khajuri','212306',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68516,195,'Khakhaicha','212405',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68517,195,'Khandesara','212106',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68518,195,'Khaptiha','221508',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68519,195,'Khargapur','212502',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68520,195,'Kheoli Kalan','212306',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68521,195,'Kheraht Khurd','212106',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68522,195,'Khiri','212106',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68523,195,'Khoonta','212106',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68524,195,'Kiraon','212507',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68525,195,'Kishundaspur','212401',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68526,195,'Konhdar','212301',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68527,195,'Koraon','212306',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68528,195,'Koraur','212401',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68529,195,'Kosda Kalan','212104',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68530,195,'Kotwa','221505',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68531,195,'Krishna Nagar (Allahabad)','211003',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68532,195,'Kumhawa','212109',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68533,195,'Kurki Kalan','212302',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68534,195,'Kush Fara','212306',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68535,195,'Lakshagrih','221503',1,0,'2022-03-03 12:57:17','2022-03-03 12:57:17'),(68536,195,'Lalapur Bhatpura','212107',1,0,'2022-03-03 12:57:18','2022-03-03 12:57:18'),(68537,195,'Lalgopal Ganj','229413',1,0,'2022-03-03 12:57:18','2022-03-03 12:57:18'),(68538,195,'Leader','211001',1,0,'2022-03-03 12:57:18','2022-03-03 12:57:18'),(68539,195,'Leelapur Kala','221505',1,0,'2022-03-03 12:57:18','2022-03-03 12:57:18'),(68540,195,'Lendiyari','212106',1,0,'2022-03-03 12:57:18','2022-03-03 12:57:18'),(68541,195,'Leondi','212107',1,0,'2022-03-03 12:57:18','2022-03-03 12:57:18'),(68542,195,'Lohari','212305',1,0,'2022-03-03 12:57:18','2022-03-03 12:57:18'),(68543,195,'Lohgara','212107',1,0,'2022-03-03 12:57:18','2022-03-03 12:57:18'),(68544,195,'Lokmanpur','221502',1,0,'2022-03-03 12:57:18','2022-03-03 12:57:18'),(68545,195,'Lotarh','212303',1,0,'2022-03-03 12:57:18','2022-03-03 12:57:18'),(68546,195,'Lutar','212302',1,0,'2022-03-03 12:57:18','2022-03-03 12:57:18'),(68547,195,'M G Marg','211001',1,0,'2022-03-03 12:57:18','2022-03-03 12:57:18'),(68548,195,'M L N Engg.Coll.','211004',1,0,'2022-03-03 12:57:18','2022-03-03 12:57:18'),(68549,195,'Madar','212104',1,0,'2022-03-03 12:57:18','2022-03-03 12:57:18'),(68550,195,'Madhonagar Bigahia','211013',1,0,'2022-03-03 12:57:18','2022-03-03 12:57:18'),(68551,195,'Madra Mukundpur','212305',1,0,'2022-03-03 12:57:18','2022-03-03 12:57:18'),(68552,195,'Mahajna','221502',1,0,'2022-03-03 12:57:18','2022-03-03 12:57:18'),(68553,195,'Maharchha','212401',1,0,'2022-03-03 12:57:18','2022-03-03 12:57:18'),(68554,195,'Mahori','212307',1,0,'2022-03-03 12:57:18','2022-03-03 12:57:18'),(68555,195,'Mahuli','212306',1,0,'2022-03-03 12:57:18','2022-03-03 12:57:18'),(68556,195,'Maida','212106',1,0,'2022-03-03 12:57:18','2022-03-03 12:57:18'),(68557,195,'Mailahan','212402',1,0,'2022-03-03 12:57:18','2022-03-03 12:57:18'),(68558,195,'Majhigaown','212104',1,0,'2022-03-03 12:57:18','2022-03-03 12:57:18'),(68559,195,'Makdoompur Dhoksaha','212216',1,0,'2022-03-03 12:57:19','2022-03-03 12:57:19'),(68560,195,'Malak Harhar','211013',1,0,'2022-03-03 12:57:19','2022-03-03 12:57:19'),(68561,195,'Malaka','211001',1,0,'2022-03-03 12:57:19','2022-03-03 12:57:19'),(68562,195,'Malawan Khurd','211019',1,0,'2022-03-03 12:57:19','2022-03-03 12:57:19'),(68563,195,'Manauri AF','212212',1,0,'2022-03-03 12:57:19','2022-03-03 12:57:19'),(68564,195,'Manauri','212208',1,0,'2022-03-03 12:57:19','2022-03-03 12:57:19'),(68565,195,'Manda','212104',1,0,'2022-03-03 12:57:19','2022-03-03 12:57:19'),(68566,195,'Mandardeeh Mafi','211012',1,0,'2022-03-03 12:57:19','2022-03-03 12:57:19'),(68567,195,'Mandwa Bazar','212401',1,0,'2022-03-03 12:57:19','2022-03-03 12:57:19'),(68568,195,'Manpur','212107',1,0,'2022-03-03 12:57:19','2022-03-03 12:57:19'),(68569,195,'Mansoorabad','229411',1,0,'2022-03-03 12:57:19','2022-03-03 12:57:19'),(68570,195,'Maohar','212216',1,0,'2022-03-03 12:57:19','2022-03-03 12:57:19'),(68571,195,'Masauli','212303',1,0,'2022-03-03 12:57:19','2022-03-03 12:57:19'),(68572,195,'Masni Jagdishpur','229412',1,0,'2022-03-03 12:57:19','2022-03-03 12:57:19'),(68573,195,'Mau Aima','212507',1,0,'2022-03-03 12:57:19','2022-03-03 12:57:19'),(68574,195,'Mawaiya Hindwani','221503',1,0,'2022-03-03 12:57:19','2022-03-03 12:57:19'),(68575,195,'Mehraunda','212507',1,0,'2022-03-03 12:57:19','2022-03-03 12:57:19'),(68576,195,'Meja Road','212303',1,0,'2022-03-03 12:57:19','2022-03-03 12:57:19'),(68577,195,'Meja','212302',1,0,'2022-03-03 12:57:19','2022-03-03 12:57:19'),(68578,195,'Mendara','229411',1,0,'2022-03-03 12:57:19','2022-03-03 12:57:19'),(68579,195,'Mendewa','221507',1,0,'2022-03-03 12:57:19','2022-03-03 12:57:19'),(68580,195,'Misirpur','212306',1,0,'2022-03-03 12:57:19','2022-03-03 12:57:19'),(68581,195,'Mohabbatganj Uparhar','211007',1,0,'2022-03-03 12:57:19','2022-03-03 12:57:19'),(68582,195,'Mohd.Pur Gheempur','212507',1,0,'2022-03-03 12:57:19','2022-03-03 12:57:19'),(68583,195,'Mohdpur Taluka','212208',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68584,195,'Mohiuddinpur','212216',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68585,195,'Motiha','221508',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68586,195,'Mubarakpur','229412',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68587,195,'Mugarshan','221505',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68588,195,'Mukundpur','212503',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68589,195,'Mungari','212301',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68590,195,'Muratganj ED','212201',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68591,195,'Mutthiganj','211003',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68592,195,'Naganpur','212107',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68593,195,'Nahwai ED','212104',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68594,195,'Nai Bazar','212507',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68595,195,'Naini Pac','211008',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68596,195,'Naini (Allahabad)','211008',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68597,195,'Narainganj','212507',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68598,195,'Nari Bari ED','212106',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68599,195,'Nasratpur','212502',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68600,195,'Nathupur','212306',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68601,195,'Naudhiya Tarhar','212107',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68602,195,'Nayanwar','212107',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68603,195,'Nehru Nagar (Allahabad)','211003',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68604,195,'New Bairahana','211003',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68605,195,'Newada','212218',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68606,195,'Newadhiya','212303',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68607,195,'Newadhiya Uparhar','212108',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68608,195,'Nibaiya','212303',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68609,195,'Nibi','211008',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68610,195,'Nibi Bari','212401',1,0,'2022-03-03 12:57:20','2022-03-03 12:57:20'),(68611,195,'Nibi Kalan','211019',1,0,'2022-03-03 12:57:21','2022-03-03 12:57:21'),(68612,195,'Nindula','212401',1,0,'2022-03-03 12:57:21','2022-03-03 12:57:21'),(68613,195,'Nindura','229413',1,0,'2022-03-03 12:57:21','2022-03-03 12:57:21'),(68614,195,'Niralachowk','211006',1,0,'2022-03-03 12:57:21','2022-03-03 12:57:21'),(68615,195,'Niyayipur','212503',1,0,'2022-03-03 12:57:21','2022-03-03 12:57:21'),(68616,195,'Othgi Tarhar','212107',1,0,'2022-03-03 12:57:21','2022-03-03 12:57:21'),(68617,195,'Pachdeora','229412',1,0,'2022-03-03 12:57:21','2022-03-03 12:57:21'),(68618,195,'Pachera','212306',1,0,'2022-03-03 12:57:21','2022-03-03 12:57:21'),(68619,195,'Paintiha','212306',1,0,'2022-03-03 12:57:21','2022-03-03 12:57:21'),(68620,195,'Palpatti','212106',1,0,'2022-03-03 12:57:21','2022-03-03 12:57:21'),(68621,195,'Panasa','212307',1,0,'2022-03-03 12:57:21','2022-03-03 12:57:21'),(68622,195,'Panduwa','212107',1,0,'2022-03-03 12:57:21','2022-03-03 12:57:21'),(68623,195,'Panwar','212107',1,0,'2022-03-03 12:57:21','2022-03-03 12:57:21'),(68624,195,'Panwari','212106',1,0,'2022-03-03 12:57:21','2022-03-03 12:57:21'),(68625,195,'Paranipur','212305',1,0,'2022-03-03 12:57:21','2022-03-03 12:57:21'),(68626,195,'Parewa Narainpur','229413',1,0,'2022-03-03 12:57:21','2022-03-03 12:57:21'),(68627,195,'Pasna','212302',1,0,'2022-03-03 12:57:21','2022-03-03 12:57:21'),(68628,195,'Pathra','212301',1,0,'2022-03-03 12:57:21','2022-03-03 12:57:21'),(68629,195,'Patwa','212401',1,0,'2022-03-03 12:57:21','2022-03-03 12:57:21'),(68630,195,'Phaphamau','211013',1,0,'2022-03-03 12:57:21','2022-03-03 12:57:21'),(68631,195,'Phoolpur','212402',1,0,'2022-03-03 12:57:21','2022-03-03 12:57:21'),(68632,195,'Pindi','212301',1,0,'2022-03-03 12:57:21','2022-03-03 12:57:21'),(68633,195,'Pipalgaon','211012',1,0,'2022-03-03 12:57:21','2022-03-03 12:57:21'),(68634,195,'Pipari','212401',1,0,'2022-03-03 12:57:21','2022-03-03 12:57:21'),(68635,195,'Pipraon','212301',1,0,'2022-03-03 12:57:22','2022-03-03 12:57:22'),(68636,195,'Piyari Urf Bijlipur','229413',1,0,'2022-03-03 12:57:22','2022-03-03 12:57:22'),(68637,195,'Pratappur','212402',1,0,'2022-03-03 12:57:22','2022-03-03 12:57:22'),(68638,195,'Prayag Mahila Vidyapith','211003',1,0,'2022-03-03 12:57:22','2022-03-03 12:57:22'),(68639,195,'Prayag','211002',1,0,'2022-03-03 12:57:22','2022-03-03 12:57:22'),(68640,195,'Prem Misirpur Korali','229411',1,0,'2022-03-03 12:57:22','2022-03-03 12:57:22'),(68641,195,'Prem Nagar Chauraha','212502',1,0,'2022-03-03 12:57:22','2022-03-03 12:57:22'),(68642,195,'Prithvipur','221503',1,0,'2022-03-03 12:57:22','2022-03-03 12:57:22'),(68643,195,'Public Service Commission','211018',1,0,'2022-03-03 12:57:22','2022-03-03 12:57:22'),(68644,195,'Purabnara','212503',1,0,'2022-03-03 12:57:22','2022-03-03 12:57:22'),(68645,195,'Pure Ghasi','229411',1,0,'2022-03-03 12:57:22','2022-03-03 12:57:22'),(68646,195,'Pure Kanta','221502',1,0,'2022-03-03 12:57:22','2022-03-03 12:57:22'),(68647,195,'Purkhas','212218',1,0,'2022-03-03 12:57:22','2022-03-03 12:57:22'),(68648,195,'Purshottam Nagar','211016',1,0,'2022-03-03 12:57:22','2022-03-03 12:57:22'),(68649,195,'Purwa Khas','212111',1,0,'2022-03-03 12:57:22','2022-03-03 12:57:22'),(68650,195,'Rajapur (Allahabad)','211002',1,0,'2022-03-03 12:57:22','2022-03-03 12:57:22'),(68651,195,'Rajrooppur','211011',1,0,'2022-03-03 12:57:22','2022-03-03 12:57:22'),(68652,195,'Ramaipur','221505',1,0,'2022-03-03 12:57:22','2022-03-03 12:57:22'),(68653,195,'Ramgarh','212306',1,0,'2022-03-03 12:57:22','2022-03-03 12:57:22'),(68654,195,'Ramgarh Kothari','212402',1,0,'2022-03-03 12:57:22','2022-03-03 12:57:22'),(68655,195,'Ramnagar','212305',1,0,'2022-03-03 12:57:22','2022-03-03 12:57:22'),(68656,195,'Rampur Kalan','212306',1,0,'2022-03-03 12:57:22','2022-03-03 12:57:22'),(68657,195,'Rampur Kotwa','229413',1,0,'2022-03-03 12:57:22','2022-03-03 12:57:22'),(68658,195,'Ranipur (Allahabad)','211002',1,0,'2022-03-03 12:57:22','2022-03-03 12:57:22'),(68659,195,'Rokari','212307',1,0,'2022-03-03 12:57:23','2022-03-03 12:57:23'),(68660,195,'S N Marg','211001',1,0,'2022-03-03 12:57:23','2022-03-03 12:57:23'),(68661,195,'S R Marg','211003',1,0,'2022-03-03 12:57:23','2022-03-03 12:57:23'),(68662,195,'Sahson','221507',1,0,'2022-03-03 12:57:23','2022-03-03 12:57:23'),(68663,195,'Saidabad (Allahabad)','221508',1,0,'2022-03-03 12:57:23','2022-03-03 12:57:23'),(68664,195,'Saji','212306',1,0,'2022-03-03 12:57:23','2022-03-03 12:57:23'),(68665,195,'Sallahpur','212208',1,0,'2022-03-03 12:57:23','2022-03-03 12:57:23'),(68666,195,'Samhan','212303',1,0,'2022-03-03 12:57:23','2022-03-03 12:57:23'),(68667,195,'Sansarpur','212306',1,0,'2022-03-03 12:57:23','2022-03-03 12:57:23'),(68668,195,'Sarai Inayat','221505',1,0,'2022-03-03 12:57:23','2022-03-03 12:57:23'),(68669,195,'Sarai Madan Urf Chanti','212503',1,0,'2022-03-03 12:57:23','2022-03-03 12:57:23'),(68670,195,'Saraj Mamrej','212402',1,0,'2022-03-03 12:57:23','2022-03-03 12:57:23'),(68671,195,'Saraswatipur Urf Kaudhiyar','229412',1,0,'2022-03-03 12:57:23','2022-03-03 12:57:23'),(68672,195,'Satti Chaura','211003',1,0,'2022-03-03 12:57:23','2022-03-03 12:57:23'),(68673,195,'Sawrai Buzurg','212204',1,0,'2022-03-03 12:57:23','2022-03-03 12:57:23'),(68674,195,'Sayed Serawan','212213',1,0,'2022-03-03 12:57:23','2022-03-03 12:57:23'),(68675,195,'Serawan','229412',1,0,'2022-03-03 12:57:23','2022-03-03 12:57:23'),(68676,195,'Sewaith','211013',1,0,'2022-03-03 12:57:23','2022-03-03 12:57:23'),(68677,195,'Shahipur','221503',1,0,'2022-03-03 12:57:23','2022-03-03 12:57:23'),(68678,195,'Shaikhpur Rasoolpur','212208',1,0,'2022-03-03 12:57:23','2022-03-03 12:57:23'),(68679,195,'Shankargarh','212108',1,0,'2022-03-03 12:57:23','2022-03-03 12:57:23'),(68680,195,'Shergarh','211012',1,0,'2022-03-03 12:57:23','2022-03-03 12:57:23'),(68681,195,'Shivgarh','212502',1,0,'2022-03-03 12:57:24','2022-03-03 12:57:24'),(68682,195,'Shringverpur','229411',1,0,'2022-03-03 12:57:24','2022-03-03 12:57:24'),(68683,195,'Shukulpur','212104',1,0,'2022-03-03 12:57:24','2022-03-03 12:57:24'),(68684,195,'Shukulpur ED','212305',1,0,'2022-03-03 12:57:24','2022-03-03 12:57:24'),(68685,195,'Sikandarpur Bazha','212213',1,0,'2022-03-03 12:57:24','2022-03-03 12:57:24'),(68686,195,'Sikandra (Allahabad)','212109',1,0,'2022-03-03 12:57:24','2022-03-03 12:57:24'),(68687,195,'Sikikhurda','221508',1,0,'2022-03-03 12:57:24','2022-03-03 12:57:24'),(68688,195,'Silaundhi','212301',1,0,'2022-03-03 12:57:24','2022-03-03 12:57:24'),(68689,195,'Singra Mau','221507',1,0,'2022-03-03 12:57:24','2022-03-03 12:57:24'),(68690,195,'Sirsa Chauraha','221503',1,0,'2022-03-03 12:57:24','2022-03-03 12:57:24'),(68691,195,'Sirsa','212305',1,0,'2022-03-03 12:57:24','2022-03-03 12:57:24'),(68692,195,'Siswan','212507',1,0,'2022-03-03 12:57:24','2022-03-03 12:57:24'),(68693,195,'Siyadeeh','221503',1,0,'2022-03-03 12:57:24','2022-03-03 12:57:24'),(68694,195,'Sohbatia Bagh','211006',1,0,'2022-03-03 12:57:24','2022-03-03 12:57:24'),(68695,195,'Sonai','212301',1,0,'2022-03-03 12:57:24','2022-03-03 12:57:24'),(68696,195,'Sonversa','212104',1,0,'2022-03-03 12:57:24','2022-03-03 12:57:24'),(68697,195,'Soraon','212502',1,0,'2022-03-03 12:57:24','2022-03-03 12:57:24'),(68698,195,'Soron','212405',1,0,'2022-03-03 12:57:24','2022-03-03 12:57:24'),(68699,195,'Subedarganj','211015',1,0,'2022-03-03 12:57:24','2022-03-03 12:57:24'),(68700,195,'Subhash Ngr','211002',1,0,'2022-03-03 12:57:24','2022-03-03 12:57:24'),(68701,195,'Sujani','212106',1,0,'2022-03-03 12:57:24','2022-03-03 12:57:24'),(68702,195,'Sulem Sarai','211011',1,0,'2022-03-03 12:57:24','2022-03-03 12:57:24'),(68703,195,'T S L','211010',1,0,'2022-03-03 12:57:24','2022-03-03 12:57:24'),(68704,195,'Tagore Town','211002',1,0,'2022-03-03 12:57:24','2022-03-03 12:57:24'),(68705,195,'Tatarganj','212107',1,0,'2022-03-03 12:57:25','2022-03-03 12:57:25'),(68706,195,'Tejpur','212507',1,0,'2022-03-03 12:57:25','2022-03-03 12:57:25'),(68707,195,'Tela','221502',1,0,'2022-03-03 12:57:25','2022-03-03 12:57:25'),(68708,195,'Tigza','212302',1,0,'2022-03-03 12:57:25','2022-03-03 12:57:25'),(68709,195,'Tilakhwar','212301',1,0,'2022-03-03 12:57:25','2022-03-03 12:57:25'),(68710,195,'Tirath Raj Aushadhalaya','211003',1,0,'2022-03-03 12:57:25','2022-03-03 12:57:25'),(68711,195,'Trisentulapur','212104',1,0,'2022-03-03 12:57:25','2022-03-03 12:57:25'),(68712,195,'Triveni Marg','211003',1,0,'2022-03-03 12:57:25','2022-03-03 12:57:25'),(68713,195,'Udyog Nagar (Allahabad)','211009',1,0,'2022-03-03 12:57:25','2022-03-03 12:57:25'),(68714,195,'Ugrasen Pur','212405',1,0,'2022-03-03 12:57:25','2022-03-03 12:57:25'),(68715,195,'Ulda','229412',1,0,'2022-03-03 12:57:25','2022-03-03 12:57:25'),(68716,195,'Umari','221507',1,0,'2022-03-03 12:57:25','2022-03-03 12:57:25'),(68717,195,'Umariasari','212507',1,0,'2022-03-03 12:57:25','2022-03-03 12:57:25'),(68718,195,'Umarpur Neewan','211011',1,0,'2022-03-03 12:57:25','2022-03-03 12:57:25'),(68719,195,'Unchdeeh','212305',1,0,'2022-03-03 12:57:25','2022-03-03 12:57:25'),(68720,195,'University (Allahabad)','211002',1,0,'2022-03-03 12:57:25','2022-03-03 12:57:25'),(68721,195,'Upraura','212305',1,0,'2022-03-03 12:57:25','2022-03-03 12:57:25'),(68722,195,'Uruwa','212303',1,0,'2022-03-03 12:57:25','2022-03-03 12:57:25'),(68723,195,'Utraon','221508',1,0,'2022-03-03 12:57:25','2022-03-03 12:57:25'),(68724,195,'V N Marg','211003',1,0,'2022-03-03 12:57:25','2022-03-03 12:57:25'),(68725,195,'Zera','212303',1,0,'2022-03-03 12:57:25','2022-03-03 12:57:25'),(68726,196,'Achhati','224129',1,0,'2022-03-03 12:57:25','2022-03-03 12:57:25'),(68727,196,'Adampur Tiloni','224168',1,0,'2022-03-03 12:57:25','2022-03-03 12:57:25'),(68728,196,'Admapur','224147',1,0,'2022-03-03 12:57:25','2022-03-03 12:57:25'),(68729,196,'Aghiyari','224228',1,0,'2022-03-03 12:57:25','2022-03-03 12:57:25'),(68730,196,'Ahirauli','224157',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68731,196,'Ahirauli Govind Sahab','224139',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68732,196,'Ahirauli Ranimau','224137',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68733,196,'Ainawa','224145',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68734,196,'Ajmalpur','224139',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68735,196,'Ajmeri Badshahpur','224190',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68736,196,'Akbarpur H.O','224122',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68737,196,'Akhtara Narainpur','224147',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68738,196,'Alauddinur','224137',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68739,196,'Alaupur','224147',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68740,196,'Amadarveshpur','224181',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68741,196,'Amari','224139',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68742,196,'Amartal','224186',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68743,196,'Ambarpur','224149',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68744,196,'Anjana','224172',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68745,196,'Annapur','224181',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68746,196,'Arai','224149',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68747,196,'Aribpur','224143',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68748,196,'Aribpur Ramnagar','224181',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68749,196,'Arjunpur','224152',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68750,196,'Arsawan','224190',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68751,196,'Asgawan','224141',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68752,196,'Ashapur','224125',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68753,196,'Ashrafpur Barwa','224151',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68754,196,'Ashrafpur Majhagawan','224149',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68755,196,'Asnara','224147',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68756,196,'Asopur','224190',1,0,'2022-03-03 12:57:26','2022-03-03 12:57:26'),(68757,196,'Astikaan','224284',1,0,'2022-03-03 12:57:27','2022-03-03 12:57:27'),(68758,196,'Atraura','224234',1,0,'2022-03-03 12:57:27','2022-03-03 12:57:27'),(68759,196,'Atwari','224157',1,0,'2022-03-03 12:57:27','2022-03-03 12:57:27'),(68760,196,'Avsanpur','224145',1,0,'2022-03-03 12:57:27','2022-03-03 12:57:27'),(68761,196,'Ayodhya','224123',1,0,'2022-03-03 12:57:27','2022-03-03 12:57:27'),(68762,196,'Babuapur','224161',1,0,'2022-03-03 12:57:27','2022-03-03 12:57:27'),(68763,196,'Bahorikpur','224168',1,0,'2022-03-03 12:57:27','2022-03-03 12:57:27'),(68764,196,'Bairi Buzurg','224147',1,0,'2022-03-03 12:57:27','2022-03-03 12:57:27'),(68765,196,'Bakarganj','224161',1,0,'2022-03-03 12:57:27','2022-03-03 12:57:27'),(68766,196,'Balaiya Jagdishpur','224190',1,0,'2022-03-03 12:57:27','2022-03-03 12:57:27'),(68767,196,'Balrampur','224161',1,0,'2022-03-03 12:57:27','2022-03-03 12:57:27'),(68768,196,'Bandan Deeh','224168',1,0,'2022-03-03 12:57:27','2022-03-03 12:57:27'),(68769,196,'Bandipur','224125',1,0,'2022-03-03 12:57:27','2022-03-03 12:57:27'),(68770,196,'Bangaon','224132',1,0,'2022-03-03 12:57:27','2022-03-03 12:57:27'),(68771,196,'Bangaondihwa','224122',1,0,'2022-03-03 12:57:27','2022-03-03 12:57:27'),(68772,196,'Banghusara','224205',1,0,'2022-03-03 12:57:27','2022-03-03 12:57:27'),(68773,196,'Baniyani','224129',1,0,'2022-03-03 12:57:27','2022-03-03 12:57:27'),(68774,196,'Bankata Bujurg','224176',1,0,'2022-03-03 12:57:27','2022-03-03 12:57:27'),(68775,196,'Bankegaon','224201',1,0,'2022-03-03 12:57:27','2022-03-03 12:57:27'),(68776,196,'Baragaon Brahimpur','224230',1,0,'2022-03-03 12:57:27','2022-03-03 12:57:27'),(68777,196,'Baragaon Sheikhpur','224149',1,0,'2022-03-03 12:57:27','2022-03-03 12:57:27'),(68778,196,'Baramadpur Jariyari','224168',1,0,'2022-03-03 12:57:27','2022-03-03 12:57:27'),(68779,196,'Baramadpur Lohra','224168',1,0,'2022-03-03 12:57:27','2022-03-03 12:57:27'),(68780,196,'Baraon','224203',1,0,'2022-03-03 12:57:27','2022-03-03 12:57:27'),(68781,196,'Baraura','224227',1,0,'2022-03-03 12:57:28','2022-03-03 12:57:28'),(68782,196,'Barehta','224195',1,0,'2022-03-03 12:57:28','2022-03-03 12:57:28'),(68783,196,'Barepur','224186',1,0,'2022-03-03 12:57:28','2022-03-03 12:57:28'),(68784,196,'Bariyawan','224210',1,0,'2022-03-03 12:57:28','2022-03-03 12:57:28'),(68785,196,'Barun (Ambedkar Nagar)','224127',1,0,'2022-03-03 12:57:28','2022-03-03 12:57:28'),(68786,196,'Basantpur','224234',1,0,'2022-03-03 12:57:28','2022-03-03 12:57:28'),(68787,196,'Baskhari','224129',1,0,'2022-03-03 12:57:28','2022-03-03 12:57:28'),(68788,196,'Basohari','224152',1,0,'2022-03-03 12:57:28','2022-03-03 12:57:28'),(68789,196,'Bathua','224132',1,0,'2022-03-03 12:57:28','2022-03-03 12:57:28'),(68790,196,'Begikol','224149',1,0,'2022-03-03 12:57:28','2022-03-03 12:57:28'),(68791,196,'Bela','224231',1,0,'2022-03-03 12:57:28','2022-03-03 12:57:28'),(68792,196,'Bela Parsa','224129',1,0,'2022-03-03 12:57:28','2022-03-03 12:57:28'),(68793,196,'Belarambagh','224205',1,0,'2022-03-03 12:57:28','2022-03-03 12:57:28'),(68794,196,'Bemaval','224181',1,0,'2022-03-03 12:57:28','2022-03-03 12:57:28'),(68795,196,'Bewana','224122',1,0,'2022-03-03 12:57:28','2022-03-03 12:57:28'),(68796,196,'Bhadar','224132',1,0,'2022-03-03 12:57:28','2022-03-03 12:57:28'),(68797,196,'Bhadauli','224172',1,0,'2022-03-03 12:57:28','2022-03-03 12:57:28'),(68798,196,'Bhadohi','224159',1,0,'2022-03-03 12:57:28','2022-03-03 12:57:28'),(68799,196,'Bhaironpur Tikari','224206',1,0,'2022-03-03 12:57:28','2022-03-03 12:57:28'),(68800,196,'Bharatkund','224202',1,0,'2022-03-03 12:57:28','2022-03-03 12:57:28'),(68801,196,'Bhari Diha','224151',1,0,'2022-03-03 12:57:28','2022-03-03 12:57:28'),(68802,196,'Bharsari','224145',1,0,'2022-03-03 12:57:28','2022-03-03 12:57:28'),(68803,196,'Bhaukuwan','224149',1,0,'2022-03-03 12:57:28','2022-03-03 12:57:28'),(68804,196,'Bhaupur','224210',1,0,'2022-03-03 12:57:28','2022-03-03 12:57:28'),(68805,196,'Bhidur','224155',1,0,'2022-03-03 12:57:28','2022-03-03 12:57:28'),(68806,196,'Bhikharipur','224168',1,0,'2022-03-03 12:57:29','2022-03-03 12:57:29'),(68807,196,'Bhiti','224132',1,0,'2022-03-03 12:57:29','2022-03-03 12:57:29'),(68808,196,'Bhiyaon','224139',1,0,'2022-03-03 12:57:29','2022-03-03 12:57:29'),(68809,196,'Bhujgi','224149',1,0,'2022-03-03 12:57:29','2022-03-03 12:57:29'),(68810,196,'Bhupatipur','224122',1,0,'2022-03-03 12:57:29','2022-03-03 12:57:29'),(68811,196,'Bidhar','224181',1,0,'2022-03-03 12:57:29','2022-03-03 12:57:29'),(68812,196,'Bijli Tihayatpur','224176',1,0,'2022-03-03 12:57:29','2022-03-03 12:57:29'),(68813,196,'Bishambharpur','224139',1,0,'2022-03-03 12:57:29','2022-03-03 12:57:29'),(68814,196,'Brahimpur Kusma','224190',1,0,'2022-03-03 12:57:29','2022-03-03 12:57:29'),(68815,196,'Bsaiya Ganga Sagar','224181',1,0,'2022-03-03 12:57:29','2022-03-03 12:57:29'),(68816,196,'Bukia','224129',1,0,'2022-03-03 12:57:29','2022-03-03 12:57:29'),(68817,196,'Bus Station Akbarpur','224122',1,0,'2022-03-03 12:57:29','2022-03-03 12:57:29'),(68818,196,'Chahoraghat','224181',1,0,'2022-03-03 12:57:29','2022-03-03 12:57:29'),(68819,196,'Chak Bhadaya','224176',1,0,'2022-03-03 12:57:29','2022-03-03 12:57:29'),(68820,196,'Chakiya','224125',1,0,'2022-03-03 12:57:29','2022-03-03 12:57:29'),(68821,196,'Chanaipur','224168',1,0,'2022-03-03 12:57:29','2022-03-03 12:57:29'),(68822,196,'Chandipur Khurd','224147',1,0,'2022-03-03 12:57:29','2022-03-03 12:57:29'),(68823,196,'Chandpur','224230',1,0,'2022-03-03 12:57:29','2022-03-03 12:57:29'),(68824,196,'Chandrikaganj','224141',1,0,'2022-03-03 12:57:29','2022-03-03 12:57:29'),(68825,196,'Chapra','224231',1,0,'2022-03-03 12:57:29','2022-03-03 12:57:29'),(68826,196,'Chhajapur','224190',1,0,'2022-03-03 12:57:29','2022-03-03 12:57:29'),(68827,196,'Chiotipara','224231',1,0,'2022-03-03 12:57:29','2022-03-03 12:57:29'),(68828,196,'Chitoi','224145',1,0,'2022-03-03 12:57:29','2022-03-03 12:57:29'),(68829,196,'Dabha Samer','224133',1,0,'2022-03-03 12:57:30','2022-03-03 12:57:30'),(68830,196,'Dahema','224205',1,0,'2022-03-03 12:57:30','2022-03-03 12:57:30'),(68831,196,'Dalpatpur','224161',1,0,'2022-03-03 12:57:30','2022-03-03 12:57:30'),(68832,196,'Dandupur','224168',1,0,'2022-03-03 12:57:30','2022-03-03 12:57:30'),(68833,196,'Dargah Rasoolpur','224155',1,0,'2022-03-03 12:57:30','2022-03-03 12:57:30'),(68834,196,'Daridiha','224231',1,0,'2022-03-03 12:57:30','2022-03-03 12:57:30'),(68835,196,'Daudpur','224210',1,0,'2022-03-03 12:57:30','2022-03-03 12:57:30'),(68836,196,'Daulatabad','224149',1,0,'2022-03-03 12:57:30','2022-03-03 12:57:30'),(68837,196,'Debipur','224190',1,0,'2022-03-03 12:57:30','2022-03-03 12:57:30'),(68838,196,'Deeh Bhilon','224139',1,0,'2022-03-03 12:57:30','2022-03-03 12:57:30'),(68839,196,'Deogarh','224171',1,0,'2022-03-03 12:57:30','2022-03-03 12:57:30'),(68840,196,'Deohat','224210',1,0,'2022-03-03 12:57:30','2022-03-03 12:57:30'),(68841,196,'Deoria (Ambedkar Nagar)','224137',1,0,'2022-03-03 12:57:30','2022-03-03 12:57:30'),(68842,196,'Dharamganj','224152',1,0,'2022-03-03 12:57:30','2022-03-03 12:57:30'),(68843,196,'Dhaurua','224159',1,0,'2022-03-03 12:57:30','2022-03-03 12:57:30'),(68844,196,'Dhenkara','224143',1,0,'2022-03-03 12:57:30','2022-03-03 12:57:30'),(68845,196,'Dhiwa Daulatpur','224230',1,0,'2022-03-03 12:57:30','2022-03-03 12:57:30'),(68846,196,'Dhrampur','224135',1,0,'2022-03-03 12:57:30','2022-03-03 12:57:30'),(68847,196,'Dillisaraiya','224189',1,0,'2022-03-03 12:57:30','2022-03-03 12:57:30'),(68848,196,'Dulahoopur','224139',1,0,'2022-03-03 12:57:30','2022-03-03 12:57:30'),(68849,196,'Faridpur Kalan','224145',1,0,'2022-03-03 12:57:30','2022-03-03 12:57:30'),(68850,196,'Fatehpur','224149',1,0,'2022-03-03 12:57:30','2022-03-03 12:57:30'),(68851,196,'Fatehpur Belabagh','224157',1,0,'2022-03-03 12:57:30','2022-03-03 12:57:30'),(68852,196,'Gangauli','224172',1,0,'2022-03-03 12:57:30','2022-03-03 12:57:30'),(68853,196,'Garha','224129',1,0,'2022-03-03 12:57:30','2022-03-03 12:57:30'),(68854,196,'Gaura Mohammadpur','224155',1,0,'2022-03-03 12:57:31','2022-03-03 12:57:31'),(68855,196,'Gayaspur Samsuddinpur','224155',1,0,'2022-03-03 12:57:31','2022-03-03 12:57:31'),(68856,196,'Gharwal','224137',1,0,'2022-03-03 12:57:31','2022-03-03 12:57:31'),(68857,196,'Ghuritikar','224195',1,0,'2022-03-03 12:57:31','2022-03-03 12:57:31'),(68858,196,'Gohila','224143',1,0,'2022-03-03 12:57:31','2022-03-03 12:57:31'),(68859,196,'Gomunpur','224186',1,0,'2022-03-03 12:57:31','2022-03-03 12:57:31'),(68860,196,'Gurukul','224123',1,0,'2022-03-03 12:57:31','2022-03-03 12:57:31'),(68861,196,'Gyanpur','224171',1,0,'2022-03-03 12:57:31','2022-03-03 12:57:31'),(68862,196,'Haiderganj','224205',1,0,'2022-03-03 12:57:31','2022-03-03 12:57:31'),(68863,196,'Hajlapur','224190',1,0,'2022-03-03 12:57:31','2022-03-03 12:57:31'),(68864,196,'Hajpura','224186',1,0,'2022-03-03 12:57:31','2022-03-03 12:57:31'),(68865,196,'Hakeem Pur','224232',1,0,'2022-03-03 12:57:31','2022-03-03 12:57:31'),(68866,196,'Hanswar','224143',1,0,'2022-03-03 12:57:31','2022-03-03 12:57:31'),(68867,196,'Haridaspur','224143',1,0,'2022-03-03 12:57:31','2022-03-03 12:57:31'),(68868,196,'Hariharpur','224147',1,0,'2022-03-03 12:57:31','2022-03-03 12:57:31'),(68869,196,'Hath Pakar','224157',1,0,'2022-03-03 12:57:31','2022-03-03 12:57:31'),(68870,196,'Hiri Pakaria','224231',1,0,'2022-03-03 12:57:31','2022-03-03 12:57:31'),(68871,196,'Hisamuddinpur Pipra','224181',1,0,'2022-03-03 12:57:31','2022-03-03 12:57:31'),(68872,196,'Husainpur','224146',1,0,'2022-03-03 12:57:31','2022-03-03 12:57:31'),(68873,196,'Husainpur Girant','224190',1,0,'2022-03-03 12:57:31','2022-03-03 12:57:31'),(68874,196,'Husainpur Sudnaha','224190',1,0,'2022-03-03 12:57:31','2022-03-03 12:57:31'),(68875,196,'Iltifatganj','224145',1,0,'2022-03-03 12:57:31','2022-03-03 12:57:31'),(68876,196,'Indaipur','224129',1,0,'2022-03-03 12:57:31','2022-03-03 12:57:31'),(68877,196,'Ismailpur Tahepur','224149',1,0,'2022-03-03 12:57:31','2022-03-03 12:57:31'),(68878,196,'Itaura','224201',1,0,'2022-03-03 12:57:31','2022-03-03 12:57:31'),(68879,196,'Itauri','224159',1,0,'2022-03-03 12:57:31','2022-03-03 12:57:31'),(68880,196,'J.K.I.C.  Arwat','224161',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68881,196,'Jafarganj','224146',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68882,196,'Jagdishpur','224172',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68883,196,'Jagdishpur','224122',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68884,196,'Jahangirganj','224147',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68885,196,'Jainti','224147',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68886,196,'Jaishingmau','224195',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68887,196,'Jaitoopur','224231',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68888,196,'Jaitpur Nidhiyawan','224141',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68889,196,'Jalalpur (Ambedkar Nagar)','224149',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68890,196,'Jamaloopur','224147',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68891,196,'Jamu Kalan','224231',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68892,196,'Jamunipur','224230',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68893,196,'Janabazar','224205',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68894,196,'Janapur','224171',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68895,196,'Jeewat','224155',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68896,196,'Jogipur Dhanikpur','224147',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68897,196,'Jyoti Sadan','224133',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68898,196,'Kadipur Khas','224168',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68899,196,'Kahi','224132',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68900,196,'Kailkeshopur','224202',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68901,196,'Kakardilla','224146',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68902,196,'Kakauli','224195',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68903,196,'Kalepur Mahuwal','224159',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68904,196,'Kalhuwa Kaura','224122',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68905,196,'Kalyanpur','224147',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68906,196,'Kandai Kalan','224189',1,0,'2022-03-03 12:57:32','2022-03-03 12:57:32'),(68907,196,'Kannoopur','224149',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68908,196,'Kar Misripur','224159',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68909,196,'Karampur','224151',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68910,196,'Karnaipur','224132',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68911,196,'Kartora','224146',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68912,196,'Katariya Yaqubpur','224122',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68913,196,'Katehari','224151',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68914,196,'Katgharmusa','224186',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68915,196,'Katui','224186',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68916,196,'Kaurahi','224129',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68917,196,'Kawahianjanpur','224181',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68918,196,'Kedarnagar','224230',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68919,196,'Kela Lal Khan','224132',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68920,196,'Keotahi','224231',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68921,196,'Khajawan','224151',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68922,196,'Khajuri','224159',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68923,196,'Khalispur','224159',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68924,196,'Khamariyanghat','224147',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68925,196,'Khamipurnidhiywan','224195',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68926,196,'Khandasa','224153',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68927,196,'Khapradih','224205',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68928,196,'Kharuwaon','224137',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68929,196,'Khaspur','224190',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68930,196,'Khemapur','224157',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68931,196,'Khewar','224151',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68932,196,'Khukhutara','224145',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68933,196,'Kichhauccha','224155',1,0,'2022-03-03 12:57:33','2022-03-03 12:57:33'),(68934,196,'Kodaila','224203',1,0,'2022-03-03 12:57:34','2022-03-03 12:57:34'),(68935,196,'Koro Raghopur','224206',1,0,'2022-03-03 12:57:34','2022-03-03 12:57:34'),(68936,196,'Kotwa Mohamadpur','224122',1,0,'2022-03-03 12:57:34','2022-03-03 12:57:34'),(68937,196,'Kuchera (Ambedkar Nagar)','224158',1,0,'2022-03-03 12:57:34','2022-03-03 12:57:34'),(68938,196,'Kudia Chitauna','224168',1,0,'2022-03-03 12:57:34','2022-03-03 12:57:34'),(68939,196,'Kumarganj (Ambedkar Nagar)','224229',1,0,'2022-03-03 12:57:34','2022-03-03 12:57:34'),(68940,196,'Kumbhiya','224172',1,0,'2022-03-03 12:57:34','2022-03-03 12:57:34'),(68941,196,'Kurcha','224122',1,0,'2022-03-03 12:57:34','2022-03-03 12:57:34'),(68942,196,'Kurki Bazar','224210',1,0,'2022-03-03 12:57:34','2022-03-03 12:57:34'),(68943,196,'Lakhandih','224181',1,0,'2022-03-03 12:57:34','2022-03-03 12:57:34'),(68944,196,'Lakhanpur','224129',1,0,'2022-03-03 12:57:34','2022-03-03 12:57:34'),(68945,196,'Lakhmipur','224181',1,0,'2022-03-03 12:57:34','2022-03-03 12:57:34'),(68946,196,'Lakhnipatti','224181',1,0,'2022-03-03 12:57:34','2022-03-03 12:57:34'),(68947,196,'Lalmanpur','224176',1,0,'2022-03-03 12:57:34','2022-03-03 12:57:34'),(68948,196,'Larpur','224186',1,0,'2022-03-03 12:57:34','2022-03-03 12:57:34'),(68949,196,'Lawaiya Pratappur','224183',1,0,'2022-03-03 12:57:34','2022-03-03 12:57:34'),(68950,196,'Lodipur','224227',1,0,'2022-03-03 12:57:34','2022-03-03 12:57:34'),(68951,196,'Lohjhara','224152',1,0,'2022-03-03 12:57:34','2022-03-03 12:57:34'),(68952,196,'Lorpur','224235',1,0,'2022-03-03 12:57:34','2022-03-03 12:57:34'),(68953,196,'Machhiligaon','224186',1,0,'2022-03-03 12:57:34','2022-03-03 12:57:34'),(68954,196,'Madainiya','224147',1,0,'2022-03-03 12:57:34','2022-03-03 12:57:34'),(68955,196,'Madarbhari','224132',1,0,'2022-03-03 12:57:34','2022-03-03 12:57:34'),(68956,196,'Madarmau','224147',1,0,'2022-03-03 12:57:34','2022-03-03 12:57:34'),(68957,196,'Madhupur','224125',1,0,'2022-03-03 12:57:34','2022-03-03 12:57:34'),(68958,196,'Madna','224171',1,0,'2022-03-03 12:57:34','2022-03-03 12:57:34'),(68959,196,'Maharajganj','224227',1,0,'2022-03-03 12:57:35','2022-03-03 12:57:35'),(68960,196,'Maharuwa Gola','224231',1,0,'2022-03-03 12:57:35','2022-03-03 12:57:35'),(68961,196,'Mahawan','224206',1,0,'2022-03-03 12:57:35','2022-03-03 12:57:35'),(68962,196,'Mahmedpur','224121',1,0,'2022-03-03 12:57:35','2022-03-03 12:57:35'),(68963,196,'Mahulia','224183',1,0,'2022-03-03 12:57:35','2022-03-03 12:57:35'),(68964,196,'Mainpur','224149',1,0,'2022-03-03 12:57:35','2022-03-03 12:57:35'),(68965,196,'Majgaon','224183',1,0,'2022-03-03 12:57:35','2022-03-03 12:57:35'),(68966,196,'Majhgawan','224129',1,0,'2022-03-03 12:57:35','2022-03-03 12:57:35'),(68967,196,'Majurddinpur','224207',1,0,'2022-03-03 12:57:35','2022-03-03 12:57:35'),(68968,196,'Makhdoom Baramadpur','224159',1,0,'2022-03-03 12:57:35','2022-03-03 12:57:35'),(68969,196,'Makhdoom Nagar','224190',1,0,'2022-03-03 12:57:35','2022-03-03 12:57:35'),(68970,196,'Makhdumsarai','224227',1,0,'2022-03-03 12:57:35','2022-03-03 12:57:35'),(68971,196,'Makoiya','224129',1,0,'2022-03-03 12:57:35','2022-03-03 12:57:35'),(68972,196,'Makrahi','224143',1,0,'2022-03-03 12:57:35','2022-03-03 12:57:35'),(68973,196,'Malawan','224132',1,0,'2022-03-03 12:57:35','2022-03-03 12:57:35'),(68974,196,'Malipur','224159',1,0,'2022-03-03 12:57:35','2022-03-03 12:57:35'),(68975,196,'Manauri Samaisa','224122',1,0,'2022-03-03 12:57:35','2022-03-03 12:57:35'),(68976,196,'Mangari','224206',1,0,'2022-03-03 12:57:35','2022-03-03 12:57:35'),(68977,196,'Manikpur','224143',1,0,'2022-03-03 12:57:35','2022-03-03 12:57:35'),(68978,196,'Mansapur','224168',1,0,'2022-03-03 12:57:35','2022-03-03 12:57:35'),(68979,196,'Marahara','224139',1,0,'2022-03-03 12:57:35','2022-03-03 12:57:35'),(68980,196,'Marthua Saraiya','224151',1,0,'2022-03-03 12:57:35','2022-03-03 12:57:35'),(68981,196,'Masorha','224183',1,0,'2022-03-03 12:57:35','2022-03-03 12:57:35'),(68982,196,'Mathani','224231',1,0,'2022-03-03 12:57:35','2022-03-03 12:57:35'),(68983,196,'Mathia','224149',1,0,'2022-03-03 12:57:35','2022-03-03 12:57:35'),(68984,196,'Mathura Rasoolpur','224139',1,0,'2022-03-03 12:57:36','2022-03-03 12:57:36'),(68985,196,'Maya','224161',1,0,'2022-03-03 12:57:36','2022-03-03 12:57:36'),(68986,196,'Meerpur Sheikhpur','224168',1,0,'2022-03-03 12:57:36','2022-03-03 12:57:36'),(68987,196,'Mijhaura','224152',1,0,'2022-03-03 12:57:36','2022-03-03 12:57:36'),(68988,196,'Mirzapur','224125',1,0,'2022-03-03 12:57:36','2022-03-03 12:57:36'),(68989,196,'Mubarakganj','224189',1,0,'2022-03-03 12:57:36','2022-03-03 12:57:36'),(68990,196,'Mubarakpur','224190',1,0,'2022-03-03 12:57:36','2022-03-03 12:57:36'),(68991,196,'Mubarakpur Daiyadeeh','224122',1,0,'2022-03-03 12:57:36','2022-03-03 12:57:36'),(68992,196,'Mubarakpurpikar','224176',1,0,'2022-03-03 12:57:36','2022-03-03 12:57:36'),(68993,196,'Mujahidpur','224129',1,0,'2022-03-03 12:57:36','2022-03-03 12:57:36'),(68994,196,'Mumrejpur','224227',1,0,'2022-03-03 12:57:36','2022-03-03 12:57:36'),(68995,196,'Mundehra','224125',1,0,'2022-03-03 12:57:36','2022-03-03 12:57:36'),(68996,196,'Mundiyari','224176',1,0,'2022-03-03 12:57:36','2022-03-03 12:57:36'),(68997,196,'Musepur','224143',1,0,'2022-03-03 12:57:36','2022-03-03 12:57:36'),(68998,196,'Mustafabad','224152',1,0,'2022-03-03 12:57:36','2022-03-03 12:57:36'),(68999,196,'Nagpur','224149',1,0,'2022-03-03 12:57:36','2022-03-03 12:57:36'),(69000,196,'Naipura','224145',1,0,'2022-03-03 12:57:36','2022-03-03 12:57:36'),(69001,196,'Nandapur','224190',1,0,'2022-03-03 12:57:36','2022-03-03 12:57:36'),(69002,196,'Narharpur','224231',1,0,'2022-03-03 12:57:36','2022-03-03 12:57:36'),(69003,196,'Nariyawa','224147',1,0,'2022-03-03 12:57:36','2022-03-03 12:57:36'),(69004,196,'Narwa Pitambarpur','224147',1,0,'2022-03-03 12:57:36','2022-03-03 12:57:36'),(69005,196,'Nasirpur','224168',1,0,'2022-03-03 12:57:36','2022-03-03 12:57:36'),(69006,196,'Nathu Pur Laudhana','224149',1,0,'2022-03-03 12:57:36','2022-03-03 12:57:36'),(69007,196,'Naugaon','224235',1,0,'2022-03-03 12:57:36','2022-03-03 12:57:36'),(69008,196,'Naurahni Rampur','224143',1,0,'2022-03-03 12:57:37','2022-03-03 12:57:37'),(69009,196,'Neeba','224181',1,0,'2022-03-03 12:57:37','2022-03-03 12:57:37'),(69010,196,'Neori','224139',1,0,'2022-03-03 12:57:37','2022-03-03 12:57:37'),(69011,196,'Netwari Chaturpur','224203',1,0,'2022-03-03 12:57:37','2022-03-03 12:57:37'),(69012,196,'Nikaspur','224137',1,0,'2022-03-03 12:57:37','2022-03-03 12:57:37'),(69013,196,'Noorpur Kalan','224139',1,0,'2022-03-03 12:57:37','2022-03-03 12:57:37'),(69014,196,'Nuawan Baidara','224206',1,0,'2022-03-03 12:57:37','2022-03-03 12:57:37'),(69015,196,'Pachiyana','224205',1,0,'2022-03-03 12:57:37','2022-03-03 12:57:37'),(69016,196,'Paekauli Bazar','224149',1,0,'2022-03-03 12:57:37','2022-03-03 12:57:37'),(69017,196,'Pahitipur','224168',1,0,'2022-03-03 12:57:37','2022-03-03 12:57:37'),(69018,196,'Pakhanpurbichaila','224125',1,0,'2022-03-03 12:57:37','2022-03-03 12:57:37'),(69019,196,'Paliachalpur','224195',1,0,'2022-03-03 12:57:37','2022-03-03 12:57:37'),(69020,196,'Paras Katui','224155',1,0,'2022-03-03 12:57:37','2022-03-03 12:57:37'),(69021,196,'Pariyawan','224132',1,0,'2022-03-03 12:57:37','2022-03-03 12:57:37'),(69022,196,'Parsawan','224203',1,0,'2022-03-03 12:57:37','2022-03-03 12:57:37'),(69023,196,'Parsawan Khurd','224164',1,0,'2022-03-03 12:57:37','2022-03-03 12:57:37'),(69024,196,'Paruiya Ashram','224159',1,0,'2022-03-03 12:57:37','2022-03-03 12:57:37'),(69025,196,'Parwar Bhari','224132',1,0,'2022-03-03 12:57:37','2022-03-03 12:57:37'),(69026,196,'Pausara','224234',1,0,'2022-03-03 12:57:37','2022-03-03 12:57:37'),(69027,196,'Persanpur','224137',1,0,'2022-03-03 12:57:37','2022-03-03 12:57:37'),(69028,196,'Pethia','224149',1,0,'2022-03-03 12:57:37','2022-03-03 12:57:37'),(69029,196,'Pindoria','224139',1,0,'2022-03-03 12:57:37','2022-03-03 12:57:37'),(69030,196,'Pirthivipur','224190',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69031,196,'Pora','224201',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69032,196,'Pratappur Chamurkha','224151',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69033,196,'Punhad','224172',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69034,196,'Purebadalhi','224125',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69035,196,'Pyare Pur','224151',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69036,196,'Raithua','224202',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69037,196,'Rajapur Sraiya','224141',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69038,196,'Rajepur Kopa','224149',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69039,196,'Rajesultanpur','224176',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69040,196,'Rakba Amola','224139',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69041,196,'Ram Nagar Karri','224231',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69042,196,'Ram Nagar (Ambedkar Nagar)','224181',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69043,196,'Ramapur','224141',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69044,196,'Rambaba','224152',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69045,196,'Rambag Baragaon','224147',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69046,196,'Ramdas Patti','224157',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69047,196,'Ramnagar Chaukia','224206',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69048,196,'Rampur Bhagan','224203',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69049,196,'Rampur Jaisingh','224122',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69050,196,'Rampur Kalan','224190',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69051,196,'Rampur Mungradilla','224227',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69052,196,'Rampur Rampatti','224210',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69053,196,'Rampursakarwari','224122',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69054,196,'Raniwan','224141',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69055,196,'Rasoolpur Mundera','224143',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69056,196,'Rasulabad (Ambedkar Nagar)','224172',1,0,'2022-03-03 12:57:38','2022-03-03 12:57:38'),(69057,196,'Ratna','224125',1,0,'2022-03-03 12:57:39','2022-03-03 12:57:39'),(69058,196,'Rohiyawan','224234',1,0,'2022-03-03 12:57:39','2022-03-03 12:57:39'),(69059,196,'Rudaupur','224152',1,0,'2022-03-03 12:57:39','2022-03-03 12:57:39'),(69060,196,'Rukunpur Kasimpur','224149',1,0,'2022-03-03 12:57:39','2022-03-03 12:57:39'),(69061,196,'Rukunuddinpur','224186',1,0,'2022-03-03 12:57:39','2022-03-03 12:57:39'),(69062,196,'Sabukpur','224143',1,0,'2022-03-03 12:57:39','2022-03-03 12:57:39'),(69063,196,'Sahzadpur','224122',1,0,'2022-03-03 12:57:39','2022-03-03 12:57:39'),(69064,196,'Saidahi','224183',1,0,'2022-03-03 12:57:39','2022-03-03 12:57:39'),(69065,196,'Saidapur','224146',1,0,'2022-03-03 12:57:39','2022-03-03 12:57:39'),(69066,196,'Saidpur Bhitari','224146',1,0,'2022-03-03 12:57:39','2022-03-03 12:57:39'),(69067,196,'Saidpur Lurvadih','224143',1,0,'2022-03-03 12:57:39','2022-03-03 12:57:39'),(69068,196,'Samar Singhpur','224152',1,0,'2022-03-03 12:57:39','2022-03-03 12:57:39'),(69069,196,'Samdih','224137',1,0,'2022-03-03 12:57:39','2022-03-03 12:57:39'),(69070,196,'Sanaha','224182',1,0,'2022-03-03 12:57:39','2022-03-03 12:57:39'),(69071,196,'Sarai Sagar','224161',1,0,'2022-03-03 12:57:39','2022-03-03 12:57:39'),(69072,196,'Sarawan','224181',1,0,'2022-03-03 12:57:39','2022-03-03 12:57:39'),(69073,196,'Sarjupur','224183',1,0,'2022-03-03 12:57:39','2022-03-03 12:57:39'),(69074,196,'Saya','224152',1,0,'2022-03-03 12:57:39','2022-03-03 12:57:39'),(69075,196,'Seehmaikarirat','224122',1,0,'2022-03-03 12:57:39','2022-03-03 12:57:39'),(69076,196,'Sehra Jalalpur','224231',1,0,'2022-03-03 12:57:39','2022-03-03 12:57:39'),(69077,196,'Semari','224168',1,0,'2022-03-03 12:57:39','2022-03-03 12:57:39'),(69078,196,'Semaur','224143',1,0,'2022-03-03 12:57:39','2022-03-03 12:57:39'),(69079,196,'Semra Nasirpur','224143',1,0,'2022-03-03 12:57:39','2022-03-03 12:57:39'),(69080,196,'Setha Kalan','224159',1,0,'2022-03-03 12:57:40','2022-03-03 12:57:40'),(69081,196,'Shadipur','224230',1,0,'2022-03-03 12:57:40','2022-03-03 12:57:40'),(69082,196,'Shahpur Bangawan','224181',1,0,'2022-03-03 12:57:40','2022-03-03 12:57:40'),(69083,196,'Shajana Hamjapur','224181',1,0,'2022-03-03 12:57:40','2022-03-03 12:57:40'),(69084,196,'Sheopal','224149',1,0,'2022-03-03 12:57:40','2022-03-03 12:57:40'),(69085,196,'Sheotara','224129',1,0,'2022-03-03 12:57:40','2022-03-03 12:57:40'),(69086,196,'Sherawa Ghat','224234',1,0,'2022-03-03 12:57:40','2022-03-03 12:57:40'),(69087,196,'Shikrohar','224146',1,0,'2022-03-03 12:57:40','2022-03-03 12:57:40'),(69088,196,'Sihipur','224205',1,0,'2022-03-03 12:57:40','2022-03-03 12:57:40'),(69089,196,'Sihoriya','224172',1,0,'2022-03-03 12:57:40','2022-03-03 12:57:40'),(69090,196,'Sijhauli','224235',1,0,'2022-03-03 12:57:40','2022-03-03 12:57:40'),(69091,196,'Sikandarpur (Ambedkar Nagar)','224186',1,0,'2022-03-03 12:57:40','2022-03-03 12:57:40'),(69092,196,'Sikraura Kanchanpur','224137',1,0,'2022-03-03 12:57:40','2022-03-03 12:57:40'),(69093,196,'Singhora','224208',1,0,'2022-03-03 12:57:40','2022-03-03 12:57:40'),(69094,196,'Sirhir','224127',1,0,'2022-03-03 12:57:40','2022-03-03 12:57:40'),(69095,196,'Sirsiya Jamunipur','224176',1,0,'2022-03-03 12:57:40','2022-03-03 12:57:40'),(69096,196,'Sonaura Gaupur','224195',1,0,'2022-03-03 12:57:40','2022-03-03 12:57:40'),(69097,196,'Sonawan','224157',1,0,'2022-03-03 12:57:40','2022-03-03 12:57:40'),(69098,196,'Sonbarsa','224208',1,0,'2022-03-03 12:57:40','2022-03-03 12:57:40'),(69099,196,'Songaon','224122',1,0,'2022-03-03 12:57:40','2022-03-03 12:57:40'),(69100,196,'Srai Rasi','224171',1,0,'2022-03-03 12:57:40','2022-03-03 12:57:40'),(69101,196,'Subhakarpur','224168',1,0,'2022-03-03 12:57:40','2022-03-03 12:57:40'),(69102,196,'Sukul Bazar','224129',1,0,'2022-03-03 12:57:40','2022-03-03 12:57:40'),(69103,196,'Sulhantara','224186',1,0,'2022-03-03 12:57:40','2022-03-03 12:57:40'),(69104,196,'Sulhepur','224209',1,0,'2022-03-03 12:57:40','2022-03-03 12:57:40'),(69105,196,'Sulhepur','224203',1,0,'2022-03-03 12:57:41','2022-03-03 12:57:41'),(69106,196,'Sultangarh','224186',1,0,'2022-03-03 12:57:41','2022-03-03 12:57:41'),(69107,196,'Sultanpur Kabirpur','224129',1,0,'2022-03-03 12:57:41','2022-03-03 12:57:41'),(69108,196,'Surapur','224227',1,0,'2022-03-03 12:57:41','2022-03-03 12:57:41'),(69109,196,'Surhurpur','224159',1,0,'2022-03-03 12:57:41','2022-03-03 12:57:41'),(69110,196,'Surwari','224189',1,0,'2022-03-03 12:57:41','2022-03-03 12:57:41'),(69111,196,'Sutharpara','224181',1,0,'2022-03-03 12:57:41','2022-03-03 12:57:41'),(69112,196,'Swarg Dwar','224123',1,0,'2022-03-03 12:57:41','2022-03-03 12:57:41'),(69113,196,'Taarun Blgara','224203',1,0,'2022-03-03 12:57:41','2022-03-03 12:57:41'),(69114,196,'Tajpur','224122',1,0,'2022-03-03 12:57:41','2022-03-03 12:57:41'),(69115,196,'Tanda City','224190',1,0,'2022-03-03 12:57:41','2022-03-03 12:57:41'),(69116,196,'Tanda (Ambedkar Nagar)','224190',1,0,'2022-03-03 12:57:41','2022-03-03 12:57:41'),(69117,196,'Tanda Tehseel','224190',1,0,'2022-03-03 12:57:41','2022-03-03 12:57:41'),(69118,196,'Tandwa','224189',1,0,'2022-03-03 12:57:41','2022-03-03 12:57:41'),(69119,196,'Tandwa Bharatpur','224176',1,0,'2022-03-03 12:57:41','2022-03-03 12:57:41'),(69120,196,'Tandwa Jalal','224137',1,0,'2022-03-03 12:57:41','2022-03-03 12:57:41'),(69121,196,'Tandwa Maulai','224155',1,0,'2022-03-03 12:57:41','2022-03-03 12:57:41'),(69122,196,'Tara Khurd','224146',1,0,'2022-03-03 12:57:41','2022-03-03 12:57:41'),(69123,196,'Tarauli Mubarakpur','224143',1,0,'2022-03-03 12:57:41','2022-03-03 12:57:41'),(69124,196,'Teliagarh','224141',1,0,'2022-03-03 12:57:41','2022-03-03 12:57:41'),(69125,196,'Tendwa Paharpur','224210',1,0,'2022-03-03 12:57:41','2022-03-03 12:57:41'),(69126,196,'Tendwai Kalan','224137',1,0,'2022-03-03 12:57:41','2022-03-03 12:57:41'),(69127,196,'Teria','224205',1,0,'2022-03-03 12:57:41','2022-03-03 12:57:41'),(69128,196,'Tewaripur Sabna','224152',1,0,'2022-03-03 12:57:41','2022-03-03 12:57:41'),(69129,196,'Tighara','224149',1,0,'2022-03-03 12:57:41','2022-03-03 12:57:41'),(69130,196,'Tikari','224195',1,0,'2022-03-03 12:57:41','2022-03-03 12:57:41'),(69131,196,'Tikoria Buzurg','224147',1,0,'2022-03-03 12:57:42','2022-03-03 12:57:42'),(69132,196,'U.P.S.S. Mill','224235',1,0,'2022-03-03 12:57:42','2022-03-03 12:57:42'),(69133,196,'Udaipur','224149',1,0,'2022-03-03 12:57:42','2022-03-03 12:57:42'),(69134,196,'Udharna','224205',1,0,'2022-03-03 12:57:42','2022-03-03 12:57:42'),(69135,196,'Umari Jalal','224147',1,0,'2022-03-03 12:57:42','2022-03-03 12:57:42'),(69136,196,'Umrawan','224132',1,0,'2022-03-03 12:57:42','2022-03-03 12:57:42'),(69137,196,'Upadhyapur','224164',1,0,'2022-03-03 12:57:42','2022-03-03 12:57:42'),(69138,196,'Vidhut Nagar','224238',1,0,'2022-03-03 12:57:42','2022-03-03 12:57:42'),(69139,196,'Yadavpur','224181',1,0,'2022-03-03 12:57:42','2022-03-03 12:57:42'),(69140,196,'Yarkee','224151',1,0,'2022-03-03 12:57:42','2022-03-03 12:57:42'),(69141,196,'Zainuddinpur','224143',1,0,'2022-03-03 12:57:42','2022-03-03 12:57:42'),(69142,197,'Achhalda','206241',1,0,'2022-03-03 12:57:42','2022-03-03 12:57:42'),(69143,197,'Adhasi','206247',1,0,'2022-03-03 12:57:42','2022-03-03 12:57:42'),(69144,197,'Aghara','206244',1,0,'2022-03-03 12:57:42','2022-03-03 12:57:42'),(69145,197,'Ailly','206249',1,0,'2022-03-03 12:57:42','2022-03-03 12:57:42'),(69146,197,'Airwa Katra','206252',1,0,'2022-03-03 12:57:42','2022-03-03 12:57:42'),(69147,197,'Ajitmal','206121',1,0,'2022-03-03 12:57:42','2022-03-03 12:57:42'),(69148,197,'Alipur','206243',1,0,'2022-03-03 12:57:42','2022-03-03 12:57:42'),(69149,197,'Amaota','206121',1,0,'2022-03-03 12:57:42','2022-03-03 12:57:42'),(69150,197,'Asjana','206243',1,0,'2022-03-03 12:57:42','2022-03-03 12:57:42'),(69151,197,'Ata','206247',1,0,'2022-03-03 12:57:42','2022-03-03 12:57:42'),(69152,197,'Atsoo','206121',1,0,'2022-03-03 12:57:42','2022-03-03 12:57:42'),(69153,197,'Auraiya H.O','206122',1,0,'2022-03-03 12:57:42','2022-03-03 12:57:42'),(69154,197,'Ayana','206122',1,0,'2022-03-03 12:57:42','2022-03-03 12:57:42'),(69155,197,'Babain','206121',1,0,'2022-03-03 12:57:42','2022-03-03 12:57:42'),(69156,197,'Babarpur (Auraiya)','206121',1,0,'2022-03-03 12:57:42','2022-03-03 12:57:42'),(69157,197,'Badera','206121',1,0,'2022-03-03 12:57:43','2022-03-03 12:57:43'),(69158,197,'Badharipur','206122',1,0,'2022-03-03 12:57:43','2022-03-03 12:57:43'),(69159,197,'Badhin','206252',1,0,'2022-03-03 12:57:43','2022-03-03 12:57:43'),(69160,197,'Baghaipur','206241',1,0,'2022-03-03 12:57:43','2022-03-03 12:57:43'),(69161,197,'Bakhriya','206129',1,0,'2022-03-03 12:57:43','2022-03-03 12:57:43'),(69162,197,'Ballapur','206121',1,0,'2022-03-03 12:57:43','2022-03-03 12:57:43'),(69163,197,'Bamuripur','206122',1,0,'2022-03-03 12:57:43','2022-03-03 12:57:43'),(69164,197,'Bandhmau','206243',1,0,'2022-03-03 12:57:43','2022-03-03 12:57:43'),(69165,197,'Bansi','206241',1,0,'2022-03-03 12:57:43','2022-03-03 12:57:43'),(69166,197,'Banthara','206243',1,0,'2022-03-03 12:57:43','2022-03-03 12:57:43'),(69167,197,'Barahar','206249',1,0,'2022-03-03 12:57:43','2022-03-03 12:57:43'),(69168,197,'Barauna Kalan','206252',1,0,'2022-03-03 12:57:43','2022-03-03 12:57:43'),(69169,197,'Bela (Auraiya)','206251',1,0,'2022-03-03 12:57:43','2022-03-03 12:57:43'),(69170,197,'Belhupur','206246',1,0,'2022-03-03 12:57:43','2022-03-03 12:57:43'),(69171,197,'Bhadpur','206252',1,0,'2022-03-03 12:57:43','2022-03-03 12:57:43'),(69172,197,'Bhagya Nagar','206247',1,0,'2022-03-03 12:57:43','2022-03-03 12:57:43'),(69173,197,'Bhainsol','206241',1,0,'2022-03-03 12:57:43','2022-03-03 12:57:43'),(69174,197,'Bhaipur','206243',1,0,'2022-03-03 12:57:43','2022-03-03 12:57:43'),(69175,197,'Bhareh','206121',1,0,'2022-03-03 12:57:43','2022-03-03 12:57:43'),(69176,197,'Bharsen','206122',1,0,'2022-03-03 12:57:43','2022-03-03 12:57:43'),(69177,197,'Bhason','206129',1,0,'2022-03-03 12:57:43','2022-03-03 12:57:43'),(69178,197,'Bhaupur','206122',1,0,'2022-03-03 12:57:43','2022-03-03 12:57:43'),(69179,197,'Bhikhara','206243',1,0,'2022-03-03 12:57:43','2022-03-03 12:57:43'),(69180,197,'Bhikhepur','206129',1,0,'2022-03-03 12:57:43','2022-03-03 12:57:43'),(69181,197,'Bhurepurkalan','206121',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69182,197,'Bidhuna','206243',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69183,197,'Bijhai','206244',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69184,197,'Bilawan','206121',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69185,197,'Binpurapur','206246',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69186,197,'Birhuni','206129',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69187,197,'Burhadana','206122',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69188,197,'Chapta','206129',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69189,197,'Chhachhund','206241',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69190,197,'Chirhuli','206122',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69191,197,'Dahgaon','206246',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69192,197,'Dakhlipur','206244',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69193,197,'Dashehra','206241',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69194,197,'Daulatpur','206122',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69195,197,'Deoraon','206250',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69196,197,'Dhupkari','206244',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69197,197,'Dibiapur','206244',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69198,197,'Dibiapura Mandi','206244',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69199,197,'Dondapur','206243',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69200,197,'Fatehpur Beni','206247',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69201,197,'Gada Kasda','206121',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69202,197,'Gailly','206251',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69203,197,'Gapchariapur','206248',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69204,197,'Gauhani Kalan','206121',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69205,197,'Ghasara','206241',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69206,197,'Goora','206243',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69207,197,'Gulariha','206244',1,0,'2022-03-03 12:57:44','2022-03-03 12:57:44'),(69208,197,'Gwari','206241',1,0,'2022-03-03 12:57:45','2022-03-03 12:57:45'),(69209,197,'Haidarpur','206122',1,0,'2022-03-03 12:57:45','2022-03-03 12:57:45'),(69210,197,'Harchandpur (Auraiya)','206250',1,0,'2022-03-03 12:57:45','2022-03-03 12:57:45'),(69211,197,'Hardoo','206251',1,0,'2022-03-03 12:57:45','2022-03-03 12:57:45'),(69212,197,'Harvanspur','206248',1,0,'2022-03-03 12:57:45','2022-03-03 12:57:45'),(69213,197,'Ikaurapur','206122',1,0,'2022-03-03 12:57:45','2022-03-03 12:57:45'),(69214,197,'Indapamau','206243',1,0,'2022-03-03 12:57:45','2022-03-03 12:57:45'),(69215,197,'Itailly','206241',1,0,'2022-03-03 12:57:45','2022-03-03 12:57:45'),(69216,197,'Jaitapur','206122',1,0,'2022-03-03 12:57:45','2022-03-03 12:57:45'),(69217,197,'Jalalpur','206255',1,0,'2022-03-03 12:57:45','2022-03-03 12:57:45'),(69218,197,'Janishnagar','206121',1,0,'2022-03-03 12:57:45','2022-03-03 12:57:45'),(69219,197,'Jua','206247',1,0,'2022-03-03 12:57:45','2022-03-03 12:57:45'),(69220,197,'Juhikha','206121',1,0,'2022-03-03 12:57:45','2022-03-03 12:57:45'),(69221,197,'Kaithawa','206243',1,0,'2022-03-03 12:57:45','2022-03-03 12:57:45'),(69222,197,'Kakhaotoo','206122',1,0,'2022-03-03 12:57:45','2022-03-03 12:57:45'),(69223,197,'Kakor Buzurg','206244',1,0,'2022-03-03 12:57:45','2022-03-03 12:57:45'),(69224,197,'Kalabhoj','206249',1,0,'2022-03-03 12:57:45','2022-03-03 12:57:45'),(69225,197,'Kamara','206250',1,0,'2022-03-03 12:57:45','2022-03-03 12:57:45'),(69226,197,'Kanchausi Bazar','206246',1,0,'2022-03-03 12:57:45','2022-03-03 12:57:45'),(69227,197,'Kanhausi','206246',1,0,'2022-03-03 12:57:45','2022-03-03 12:57:45'),(69228,197,'Karampur','206129',1,0,'2022-03-03 12:57:45','2022-03-03 12:57:45'),(69229,197,'Kariawali','206121',1,0,'2022-03-03 12:57:45','2022-03-03 12:57:45'),(69230,197,'Keontra','206122',1,0,'2022-03-03 12:57:45','2022-03-03 12:57:45'),(69231,197,'Khanpur','206122',1,0,'2022-03-03 12:57:45','2022-03-03 12:57:45'),(69232,197,'Kharka','206122',1,0,'2022-03-03 12:57:46','2022-03-03 12:57:46'),(69233,197,'Khetupur','206121',1,0,'2022-03-03 12:57:46','2022-03-03 12:57:46'),(69234,197,'Kudarkot','206122',1,0,'2022-03-03 12:57:46','2022-03-03 12:57:46'),(69235,197,'Kursi','206248',1,0,'2022-03-03 12:57:46','2022-03-03 12:57:46'),(69236,197,'Lahrapur','206246',1,0,'2022-03-03 12:57:46','2022-03-03 12:57:46'),(69237,197,'Luhiapur','206122',1,0,'2022-03-03 12:57:46','2022-03-03 12:57:46'),(69238,197,'Madahadaspur','206255',1,0,'2022-03-03 12:57:46','2022-03-03 12:57:46'),(69239,197,'Madhwapur','206246',1,0,'2022-03-03 12:57:46','2022-03-03 12:57:46'),(69240,197,'Madokmeet','206248',1,0,'2022-03-03 12:57:46','2022-03-03 12:57:46'),(69241,197,'Mahmoodpur','206129',1,0,'2022-03-03 12:57:46','2022-03-03 12:57:46'),(69242,197,'Mahoo','206251',1,0,'2022-03-03 12:57:46','2022-03-03 12:57:46'),(69243,197,'Malhosi','206255',1,0,'2022-03-03 12:57:46','2022-03-03 12:57:46'),(69244,197,'Masoodpur','206249',1,0,'2022-03-03 12:57:46','2022-03-03 12:57:46'),(69245,197,'Muhammdabad','206241',1,0,'2022-03-03 12:57:46','2022-03-03 12:57:46'),(69246,197,'Muradganj','206129',1,0,'2022-03-03 12:57:46','2022-03-03 12:57:46'),(69247,197,'Murhi','206247',1,0,'2022-03-03 12:57:46','2022-03-03 12:57:46'),(69248,197,'N. T. P. C. Dibiapur','206244',1,0,'2022-03-03 12:57:46','2022-03-03 12:57:46'),(69249,197,'Nagaria','206241',1,0,'2022-03-03 12:57:46','2022-03-03 12:57:46'),(69250,197,'Narainpur','206248',1,0,'2022-03-03 12:57:46','2022-03-03 12:57:46'),(69251,197,'Narainpur (Auraiya)','206122',1,0,'2022-03-03 12:57:46','2022-03-03 12:57:46'),(69252,197,'Nauli','206244',1,0,'2022-03-03 12:57:46','2022-03-03 12:57:46'),(69253,197,'Navgawan','206246',1,0,'2022-03-03 12:57:46','2022-03-03 12:57:46'),(69254,197,'Nevilganj','206241',1,0,'2022-03-03 12:57:46','2022-03-03 12:57:46'),(69255,197,'Nigra','206129',1,0,'2022-03-03 12:57:46','2022-03-03 12:57:46'),(69256,197,'Panhar','206122',1,0,'2022-03-03 12:57:46','2022-03-03 12:57:46'),(69257,197,'Pasuwa','206249',1,0,'2022-03-03 12:57:47','2022-03-03 12:57:47'),(69258,197,'Pata R.S.','206241',1,0,'2022-03-03 12:57:47','2022-03-03 12:57:47'),(69259,197,'Patna Airwa','206252',1,0,'2022-03-03 12:57:47','2022-03-03 12:57:47'),(69260,197,'Phaphund','206247',1,0,'2022-03-03 12:57:47','2022-03-03 12:57:47'),(69261,197,'Phariha','206129',1,0,'2022-03-03 12:57:47','2022-03-03 12:57:47'),(69262,197,'Piparpur','206244',1,0,'2022-03-03 12:57:47','2022-03-03 12:57:47'),(69263,197,'Piprauli Shiv','206255',1,0,'2022-03-03 12:57:47','2022-03-03 12:57:47'),(69264,197,'Purakalan','206244',1,0,'2022-03-03 12:57:47','2022-03-03 12:57:47'),(69265,197,'Purva Jain','206248',1,0,'2022-03-03 12:57:47','2022-03-03 12:57:47'),(69266,197,'Purwa Bhikha','206248',1,0,'2022-03-03 12:57:47','2022-03-03 12:57:47'),(69267,197,'Pusauli','206243',1,0,'2022-03-03 12:57:47','2022-03-03 12:57:47'),(69268,197,'Rajaumau','206250',1,0,'2022-03-03 12:57:47','2022-03-03 12:57:47'),(69269,197,'Rathgaon','206243',1,0,'2022-03-03 12:57:47','2022-03-03 12:57:47'),(69270,197,'Roshangpur','206129',1,0,'2022-03-03 12:57:47','2022-03-03 12:57:47'),(69271,197,'Ruruganj','206249',1,0,'2022-03-03 12:57:47','2022-03-03 12:57:47'),(69272,197,'Rurukalan','206249',1,0,'2022-03-03 12:57:47','2022-03-03 12:57:47'),(69273,197,'Sahabda','206122',1,0,'2022-03-03 12:57:47','2022-03-03 12:57:47'),(69274,197,'Sahar (Auraiya)','206248',1,0,'2022-03-03 12:57:47','2022-03-03 12:57:47'),(69275,197,'Sahayal','206244',1,0,'2022-03-03 12:57:47','2022-03-03 12:57:47'),(69276,197,'Sahbad','206243',1,0,'2022-03-03 12:57:47','2022-03-03 12:57:47'),(69277,197,'Salhapur','206247',1,0,'2022-03-03 12:57:47','2022-03-03 12:57:47'),(69278,197,'Samayan','206252',1,0,'2022-03-03 12:57:47','2022-03-03 12:57:47'),(69279,197,'Sanphar','206122',1,0,'2022-03-03 12:57:47','2022-03-03 12:57:47'),(69280,197,'Sarai Sheesgram','206249',1,0,'2022-03-03 12:57:47','2022-03-03 12:57:47'),(69281,197,'Saraipukhta','206250',1,0,'2022-03-03 12:57:47','2022-03-03 12:57:47'),(69282,197,'Seengpurva Mana','206244',1,0,'2022-03-03 12:57:47','2022-03-03 12:57:47'),(69283,197,'Sehud','206244',1,0,'2022-03-03 12:57:48','2022-03-03 12:57:48'),(69284,197,'Senganpur','206121',1,0,'2022-03-03 12:57:48','2022-03-03 12:57:48'),(69285,197,'Sherpur Saraiya','206122',1,0,'2022-03-03 12:57:48','2022-03-03 12:57:48'),(69286,197,'Shivganj','206248',1,0,'2022-03-03 12:57:48','2022-03-03 12:57:48'),(69287,197,'Sikharna','206129',1,0,'2022-03-03 12:57:48','2022-03-03 12:57:48'),(69288,197,'Sohari Garhia','206121',1,0,'2022-03-03 12:57:48','2022-03-03 12:57:48'),(69289,197,'Sondhemau','206244',1,0,'2022-03-03 12:57:48','2022-03-03 12:57:48'),(69290,197,'Surendha','206252',1,0,'2022-03-03 12:57:48','2022-03-03 12:57:48'),(69291,197,'Tilak Nagar','206122',1,0,'2022-03-03 12:57:48','2022-03-03 12:57:48'),(69292,197,'Tilakpur Farm','206243',1,0,'2022-03-03 12:57:48','2022-03-03 12:57:48'),(69293,197,'Ucha','206129',1,0,'2022-03-03 12:57:48','2022-03-03 12:57:48'),(69294,197,'Umrain','206252',1,0,'2022-03-03 12:57:48','2022-03-03 12:57:48'),(69295,197,'Umri','206244',1,0,'2022-03-03 12:57:48','2022-03-03 12:57:48'),(69296,197,'Yakubpur','206255',1,0,'2022-03-03 12:57:48','2022-03-03 12:57:48'),(69297,198,'Dhamsinga','281401',1,0,'2022-03-03 12:57:48','2022-03-03 12:57:48'),(69298,198,'Abusaidpur','276205',1,0,'2022-03-03 12:57:48','2022-03-03 12:57:48'),(69299,198,'Aharaula','223221',1,0,'2022-03-03 12:57:48','2022-03-03 12:57:48'),(69300,198,'Ahirauli','276301',1,0,'2022-03-03 12:57:48','2022-03-03 12:57:48'),(69301,198,'Aira Bujurg','276126',1,0,'2022-03-03 12:57:48','2022-03-03 12:57:48'),(69302,198,'Ajagara Masharki','276122',1,0,'2022-03-03 12:57:48','2022-03-03 12:57:48'),(69303,198,'Ajaji Dewara Karkhia','276122',1,0,'2022-03-03 12:57:48','2022-03-03 12:57:48'),(69304,198,'Ajamat Garh Estate','276124',1,0,'2022-03-03 12:57:48','2022-03-03 12:57:48'),(69305,198,'Ajampur','276125',1,0,'2022-03-03 12:57:48','2022-03-03 12:57:48'),(69306,198,'Amarhar','276403',1,0,'2022-03-03 12:57:48','2022-03-03 12:57:48'),(69307,198,'Amari','276142',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69308,198,'Ambari','223222',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69309,198,'Ambarpur','223227',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69310,198,'Amilo','276404',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69311,198,'Amuwari','276138',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69312,198,'Anjam Shhid','276125',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69313,198,'Araji Amani','276139',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69314,198,'Ashona','276406',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69315,198,'Ashwania','276301',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69316,198,'Ataraith','276142',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69317,198,'Ataraulia','223223',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69318,198,'Azamgarh City','276001',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69319,198,'Azamgarh H.O','276001',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69320,198,'Azamgarh',' R.S',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69321,198,'Babu Ki Basti','276305',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69322,198,'Babu Ki Khajuri','276204',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69323,198,'Bachhawal','276204',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69324,198,'Badagaon','223227',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69325,198,'Badaharia','223227',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69326,198,'Badasara Aima','276141',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69327,198,'Badasara Khalsa','276141',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69328,198,'Badaura','276128',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69329,198,'Badaya','223223',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69330,198,'Baddo Pur','276125',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69331,198,'Bahadur Pur','276201',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69332,198,'Bahauddinpur.','276288',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69333,198,'Baijabari','276122',1,0,'2022-03-03 12:57:49','2022-03-03 12:57:49'),(69334,198,'Bairampur','276206',1,0,'2022-03-03 12:57:50','2022-03-03 12:57:50'),(69335,198,'Bakhara','223226',1,0,'2022-03-03 12:57:50','2022-03-03 12:57:50'),(69336,198,'Baksh Pur','276303',1,0,'2022-03-03 12:57:50','2022-03-03 12:57:50'),(69337,198,'Balaipur','276143',1,0,'2022-03-03 12:57:50','2022-03-03 12:57:50'),(69338,198,'Bamhaur','276406',1,0,'2022-03-03 12:57:50','2022-03-03 12:57:50'),(69339,198,'Ban Kat Jagdeesh','276142',1,0,'2022-03-03 12:57:50','2022-03-03 12:57:50'),(69340,198,'Banbirpur','276304',1,0,'2022-03-03 12:57:50','2022-03-03 12:57:50'),(69341,198,'Bangaon','276123',1,0,'2022-03-03 12:57:50','2022-03-03 12:57:50'),(69342,198,'Bankat','276125',1,0,'2022-03-03 12:57:50','2022-03-03 12:57:50'),(69343,198,'Bankatia','276136',1,0,'2022-03-03 12:57:50','2022-03-03 12:57:50'),(69344,198,'Bansgaon','223223',1,0,'2022-03-03 12:57:50','2022-03-03 12:57:50'),(69345,198,'Bansgaon (Azamgarh)','276126',1,0,'2022-03-03 12:57:50','2022-03-03 12:57:50'),(69346,198,'Barahalaganj','276129',1,0,'2022-03-03 12:57:50','2022-03-03 12:57:50'),(69347,198,'Baraipur','223221',1,0,'2022-03-03 12:57:50','2022-03-03 12:57:50'),(69348,198,'Barauna','276301',1,0,'2022-03-03 12:57:50','2022-03-03 12:57:50'),(69349,198,'Bardah','276301',1,0,'2022-03-03 12:57:50','2022-03-03 12:57:50'),(69350,198,'Bardiha','276136',1,0,'2022-03-03 12:57:50','2022-03-03 12:57:50'),(69351,198,'Bargahan','276301',1,0,'2022-03-03 12:57:50','2022-03-03 12:57:50'),(69352,198,'Barikhas','276206',1,0,'2022-03-03 12:57:50','2022-03-03 12:57:50'),(69353,198,'Barohi Fetahpur','276121',1,0,'2022-03-03 12:57:50','2022-03-03 12:57:50'),(69354,198,'Basahia','223223',1,0,'2022-03-03 12:57:50','2022-03-03 12:57:50'),(69355,198,'Base Pur Dandava','223223',1,0,'2022-03-03 12:57:50','2022-03-03 12:57:50'),(69356,198,'Basgit','276001',1,0,'2022-03-03 12:57:50','2022-03-03 12:57:50'),(69357,198,'Bazar Gosain','276127',1,0,'2022-03-03 12:57:50','2022-03-03 12:57:50'),(69358,198,'Beenapara','276305',1,0,'2022-03-03 12:57:50','2022-03-03 12:57:50'),(69359,198,'Bela Kasaila','276306',1,0,'2022-03-03 12:57:50','2022-03-03 12:57:50'),(69360,198,'Bela Klichpur','276203',1,0,'2022-03-03 12:57:51','2022-03-03 12:57:51'),(69361,198,'Bela Sultanpur','275307',1,0,'2022-03-03 12:57:51','2022-03-03 12:57:51'),(69362,198,'Belaon','276302',1,0,'2022-03-03 12:57:51','2022-03-03 12:57:51'),(69363,198,'Belauli','221602',1,0,'2022-03-03 12:57:51','2022-03-03 12:57:51'),(69364,198,'Benupur','276204',1,0,'2022-03-03 12:57:51','2022-03-03 12:57:51'),(69365,198,'Beohara','276202',1,0,'2022-03-03 12:57:51','2022-03-03 12:57:51'),(69366,198,'Berama','276138',1,0,'2022-03-03 12:57:51','2022-03-03 12:57:51'),(69367,198,'Bhadaon','223224',1,0,'2022-03-03 12:57:51','2022-03-03 12:57:51'),(69368,198,'Bhagat Pur','223223',1,0,'2022-03-03 12:57:51','2022-03-03 12:57:51'),(69369,198,'Bhagwat','276129',1,0,'2022-03-03 12:57:51','2022-03-03 12:57:51'),(69370,198,'Bhaisha','276139',1,0,'2022-03-03 12:57:51','2022-03-03 12:57:51'),(69371,198,'Bhangaha','276128',1,0,'2022-03-03 12:57:51','2022-03-03 12:57:51'),(69372,198,'Bhani Pur','276288',1,0,'2022-03-03 12:57:51','2022-03-03 12:57:51'),(69373,198,'Bharathipur','276123',1,0,'2022-03-03 12:57:51','2022-03-03 12:57:51'),(69374,198,'Bharauli','276142',1,0,'2022-03-03 12:57:51','2022-03-03 12:57:51'),(69375,198,'Bhavar Nath','276135',1,0,'2022-03-03 12:57:51','2022-03-03 12:57:51'),(69376,198,'Bhawarpur','276123',1,0,'2022-03-03 12:57:51','2022-03-03 12:57:51'),(69377,198,'Bhedaura','276141',1,0,'2022-03-03 12:57:51','2022-03-03 12:57:51'),(69378,198,'Bheera','276301',1,0,'2022-03-03 12:57:51','2022-03-03 12:57:51'),(69379,198,'Bhilampur Chhapra','276142',1,0,'2022-03-03 12:57:51','2022-03-03 12:57:51'),(69380,198,'Bhimal Patti','223221',1,0,'2022-03-03 12:57:51','2022-03-03 12:57:51'),(69381,198,'Bhimbar','276121',1,0,'2022-03-03 12:57:51','2022-03-03 12:57:51'),(69382,198,'Bhopalpur','276202',1,0,'2022-03-03 12:57:51','2022-03-03 12:57:51'),(69383,198,'Bhormau','276304',1,0,'2022-03-03 12:57:51','2022-03-03 12:57:51'),(69384,198,'Bhuidharpur','276208',1,0,'2022-03-03 12:57:51','2022-03-03 12:57:51'),(69385,198,'Bhujahi','276131',1,0,'2022-03-03 12:57:51','2022-03-03 12:57:51'),(69386,198,'Bhuvana Bujurga','276405',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69387,198,'Bibipur','276135',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69388,198,'Bibipur','276123',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69389,198,'Bilari','223221',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69390,198,'Bilaria Ganj','276121',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69391,198,'Bind Mathia','276404',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69392,198,'Bindawal','276121',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69393,198,'Bindra Bazar','276205',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69394,198,'Bisham','276205',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69395,198,'Bisunpura','276405',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69396,198,'Bithuwa','276202',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69397,198,'Bunda','223226',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69398,198,'Buxpur Mejawa','276304',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69399,198,'Chak Inami','276206',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69400,198,'Chaklal Chand','276140',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69401,198,'Chan Patti','276122',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69402,198,'Chandabhari','276206',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69403,198,'Chandai','276207',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69404,198,'Chandesar','276128',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69405,198,'Chewar Pachhim','276201',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69406,198,'Chewata','276141',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69407,198,'Chhaon','276302',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69408,198,'Chhapra Sultanpur','276124',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69409,198,'Chhattarpur Khushahal','276125',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69410,198,'Chhihi','276121',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69411,198,'Chhitauna','223221',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69412,198,'Chhittepur','223226',1,0,'2022-03-03 12:57:52','2022-03-03 12:57:52'),(69413,198,'Chirkihit','276202',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69414,198,'Chitara Mahamud Pur','223224',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69415,198,'Dama','276204',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69416,198,'Dandwal','276203',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69417,198,'Daniyalpur','223221',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69418,198,'Daulatabad','276129',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69419,198,'Dayalpur','276302',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69420,198,'Deeha','276128',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69421,198,'Deora Patti','223223',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69422,198,'Dev Gaon','276201',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69423,198,'Dewait','276204',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69424,198,'Dewal Ashram','276405',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69425,198,'Dewara Jadid','276137',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69426,198,'Dewara Jadidi','276139',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69427,198,'Dewara Khas Raja','276122',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69428,198,'Dharmdaspur Newada','276304',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69429,198,'Dharwara','276131',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69430,198,'Didarganj','223224',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69431,198,'Dighwania Kaji','276136',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69432,198,'Dighwania Majhuwa','276124',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69433,198,'Diriapur Newada','276203',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69434,198,'Dubara','276301',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69435,198,'Durbasa','276304',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69436,198,'Edilpur','223221',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69437,198,'Emalipur','276121',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69438,198,'Esmail Pir','276122',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69439,198,'Faridpur','223225',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69440,198,'Fariha','223227',1,0,'2022-03-03 12:57:53','2022-03-03 12:57:53'),(69441,198,'Firuddin Pur','223227',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69442,198,'Fulesh','223224',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69443,198,'Gaddopur','276121',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69444,198,'Gahaji','223221',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69445,198,'Gajendra Patti Bhidaura','223223',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69446,198,'Galib Pur','276288',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69447,198,'Gambhir Ban','276128',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69448,198,'Gambhirpur','276302',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69449,198,'Gandhuai','223227',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69450,198,'Garerua','276136',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69451,198,'Gaura','276204',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69452,198,'Gaura','276142',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69453,198,'Gauri','223221',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69454,198,'Gauri Narayanpur','276135',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69455,198,'Godhana','223222',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69456,198,'Gomadih','276202',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69457,198,'Gonghat','276306',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69458,198,'Gopal Pur Sadar','276128',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69459,198,'Gopalpur','276204',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69460,198,'Gopalpur Sethuli','276201',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69461,198,'Govind Pur','223223',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69462,198,'Gujar Par','276404',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69463,198,'Guwai','223224',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69464,198,'Hafiz Pur','276125',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69465,198,'Haidarabad','276139',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69466,198,'Haji Pur','276122',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69467,198,'Haraia','276127',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69468,198,'Haraura','276126',1,0,'2022-03-03 12:57:54','2022-03-03 12:57:54'),(69469,198,'Hardaspur','276204',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69470,198,'Harkhpura Khas','276139',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69471,198,'Harra Ki Chungi','276125',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69472,198,'Hira Patti','276135',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69473,198,'Hubbi Ganj','223224',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69474,198,'Huse Pur','276137',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69475,198,'Irani','276303',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69476,198,'Ishapur','223226',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69477,198,'Itaura Dori Pur','275305',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69478,198,'Jagdishpur','276124',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69479,198,'Jagdishpur','276304',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69480,198,'Jahana Ganj','276131',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69481,198,'Jairajpur','276121',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69482,198,'Jaitipur','276202',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69483,198,'Jamal Pur','276128',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69484,198,'Jamalpur','276205',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69485,198,'Jamdih','275304',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69486,198,'Jameel Pur','276139',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69487,198,'Jameen Bilari','276124',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69488,198,'Jameen Harkhori','276140',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69489,198,'Jameen Rasulpur','276127',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69490,198,'Jamuawan','276303',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69491,198,'Jeoli','276301',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69492,198,'Jigar Sandi','276129',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69493,198,'Jiyanpur','276140',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69494,198,'Jokhara','276136',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69495,198,'Jolhapur','276135',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69496,198,'Jurarampur','276139',1,0,'2022-03-03 12:57:55','2022-03-03 12:57:55'),(69497,198,'Kabiruddin Pur','276142',1,0,'2022-03-03 12:57:56','2022-03-03 12:57:56'),(69498,198,'Kakarahatta','276125',1,0,'2022-03-03 12:57:56','2022-03-03 12:57:56'),(69499,198,'Kakarahi','276142',1,0,'2022-03-03 12:57:56','2022-03-03 12:57:56'),(69500,198,'Kalafatpur','276143',1,0,'2022-03-03 12:57:56','2022-03-03 12:57:56'),(69501,198,'Kalanderpur','276302',1,0,'2022-03-03 12:57:56','2022-03-03 12:57:56'),(69502,198,'Kalicha Bad','276201',1,0,'2022-03-03 12:57:56','2022-03-03 12:57:56'),(69503,198,'Kamahariya','276123',1,0,'2022-03-03 12:57:56','2022-03-03 12:57:56'),(69504,198,'Kammar Pur','276303',1,0,'2022-03-03 12:57:56','2022-03-03 12:57:56'),(69505,198,'Kanaila','276128',1,0,'2022-03-03 12:57:56','2022-03-03 12:57:56'),(69506,198,'Kandhara Pur','276135',1,0,'2022-03-03 12:57:56','2022-03-03 12:57:56'),(69507,198,'Kanjahit','276201',1,0,'2022-03-03 12:57:56','2022-03-03 12:57:56'),(69508,198,'Karauti','276204',1,0,'2022-03-03 12:57:56','2022-03-03 12:57:56'),(69509,198,'Karisath','276131',1,0,'2022-03-03 12:57:56','2022-03-03 12:57:56'),(69510,198,'Kariya Gopal Pur','276201',1,0,'2022-03-03 12:57:56','2022-03-03 12:57:56'),(69511,198,'Karkhia Rutam Sarai','276122',1,0,'2022-03-03 12:57:56','2022-03-03 12:57:56'),(69512,198,'Karsara','276202',1,0,'2022-03-03 12:57:56','2022-03-03 12:57:56'),(69513,198,'Karui','223224',1,0,'2022-03-03 12:57:56','2022-03-03 12:57:56'),(69514,198,'Katauli Kala','276202',1,0,'2022-03-03 12:57:56','2022-03-03 12:57:56'),(69515,198,'Kaudia','276141',1,0,'2022-03-03 12:57:56','2022-03-03 12:57:56'),(69516,198,'Kaura Gahani','223224',1,0,'2022-03-03 12:57:56','2022-03-03 12:57:56'),(69517,198,'Kekai Hindola','276402',1,0,'2022-03-03 12:57:56','2022-03-03 12:57:56'),(69518,198,'Kerama','276406',1,0,'2022-03-03 12:57:56','2022-03-03 12:57:56'),(69519,198,'Keshav Pur','276142',1,0,'2022-03-03 12:57:56','2022-03-03 12:57:56'),(69520,198,'Khairuddinpur','276288',1,0,'2022-03-03 12:57:57','2022-03-03 12:57:57'),(69521,198,'Khajuri','223221',1,0,'2022-03-03 12:57:57','2022-03-03 12:57:57'),(69522,198,'Khaliasemari','276206',1,0,'2022-03-03 12:57:57','2022-03-03 12:57:57'),(69523,198,'Khalispur','276138',1,0,'2022-03-03 12:57:57','2022-03-03 12:57:57'),(69524,198,'Khan Pur Bhagatpatti','276139',1,0,'2022-03-03 12:57:57','2022-03-03 12:57:57'),(69525,198,'Khandaura','276143',1,0,'2022-03-03 12:57:57','2022-03-03 12:57:57'),(69526,198,'Khaniara','276202',1,0,'2022-03-03 12:57:57','2022-03-03 12:57:57'),(69527,198,'Khanjahan Pur','223222',1,0,'2022-03-03 12:57:57','2022-03-03 12:57:57'),(69528,198,'Khargpur','276126',1,0,'2022-03-03 12:57:57','2022-03-03 12:57:57'),(69529,198,'Kharihani','276204',1,0,'2022-03-03 12:57:57','2022-03-03 12:57:57'),(69530,198,'Khoulukhor','276131',1,0,'2022-03-03 12:57:57','2022-03-03 12:57:57'),(69531,198,'Khurasan','276304',1,0,'2022-03-03 12:57:57','2022-03-03 12:57:57'),(69532,198,'Khutauli','276304',1,0,'2022-03-03 12:57:57','2022-03-03 12:57:57'),(69533,198,'Khutia','276208',1,0,'2022-03-03 12:57:57','2022-03-03 12:57:57'),(69534,198,'Kisun Pur','276128',1,0,'2022-03-03 12:57:57','2022-03-03 12:57:57'),(69535,198,'Kisundaspur','276208',1,0,'2022-03-03 12:57:57','2022-03-03 12:57:57'),(69536,198,'Kohanda','276288',1,0,'2022-03-03 12:57:57','2022-03-03 12:57:57'),(69537,198,'Koilari','276131',1,0,'2022-03-03 12:57:57','2022-03-03 12:57:57'),(69538,198,'Koilari','276207',1,0,'2022-03-03 12:57:57','2022-03-03 12:57:57'),(69539,198,'Koilsa','276142',1,0,'2022-03-03 12:57:57','2022-03-03 12:57:57'),(69540,198,'Koiria Par','275306',1,0,'2022-03-03 12:57:57','2022-03-03 12:57:57'),(69541,198,'Kote','276125',1,0,'2022-03-03 12:57:57','2022-03-03 12:57:57'),(69542,198,'Kothwa Jalal Pur','276142',1,0,'2022-03-03 12:57:57','2022-03-03 12:57:57'),(69543,198,'Kotila.','276207',1,0,'2022-03-03 12:57:57','2022-03-03 12:57:57'),(69544,198,'Kubakhas','276203',1,0,'2022-03-03 12:57:57','2022-03-03 12:57:57'),(69545,198,'Kujiyari','223227',1,0,'2022-03-03 12:57:58','2022-03-03 12:57:58'),(69546,198,'Kurthi Zafar Pur','275305',1,0,'2022-03-03 12:57:58','2022-03-03 12:57:58'),(69547,198,'Kushmahara','223221',1,0,'2022-03-03 12:57:58','2022-03-03 12:57:58'),(69548,198,'Lahar Par','276141',1,0,'2022-03-03 12:57:58','2022-03-03 12:57:58'),(69549,198,'Lahuwan','276202',1,0,'2022-03-03 12:57:58','2022-03-03 12:57:58'),(69550,198,'Lakhnaur','221602',1,0,'2022-03-03 12:57:58','2022-03-03 12:57:58'),(69551,198,'Lal Ganj (Azamgarh)','276202',1,0,'2022-03-03 12:57:58','2022-03-03 12:57:58'),(69552,198,'Lalanpur','221603',1,0,'2022-03-03 12:57:58','2022-03-03 12:57:58'),(69553,198,'Lapsipur','276131',1,0,'2022-03-03 12:57:58','2022-03-03 12:57:58'),(69554,198,'Lasara Khurd','276303',1,0,'2022-03-03 12:57:58','2022-03-03 12:57:58'),(69555,198,'Lat Ghat','276136',1,0,'2022-03-03 12:57:58','2022-03-03 12:57:58'),(69556,198,'Lilapatti Bankatia','276124',1,0,'2022-03-03 12:57:58','2022-03-03 12:57:58'),(69557,198,'Lohara','276406',1,0,'2022-03-03 12:57:58','2022-03-03 12:57:58'),(69558,198,'Lohara','223223',1,0,'2022-03-03 12:57:58','2022-03-03 12:57:58'),(69559,198,'Loniadeeh','276304',1,0,'2022-03-03 12:57:58','2022-03-03 12:57:58'),(69560,198,'Luchui','276136',1,0,'2022-03-03 12:57:58','2022-03-03 12:57:58'),(69561,198,'Ludaipur Bholaya','275101',1,0,'2022-03-03 12:57:58','2022-03-03 12:57:58'),(69562,198,'Madharsia','276208',1,0,'2022-03-03 12:57:58','2022-03-03 12:57:58'),(69563,198,'Madia Par','223223',1,0,'2022-03-03 12:57:58','2022-03-03 12:57:58'),(69564,198,'Mahagu Pur','223223',1,0,'2022-03-03 12:57:58','2022-03-03 12:57:58'),(69565,198,'Maharaj Ganj','276137',1,0,'2022-03-03 12:57:58','2022-03-03 12:57:58'),(69566,198,'Maharaj Pur','276135',1,0,'2022-03-03 12:57:58','2022-03-03 12:57:58'),(69567,198,'Mahesh Pur','276137',1,0,'2022-03-03 12:57:59','2022-03-03 12:57:59'),(69568,198,'Maholi','276123',1,0,'2022-03-03 12:57:59','2022-03-03 12:57:59'),(69569,198,'Mahuja Newada','276301',1,0,'2022-03-03 12:57:59','2022-03-03 12:57:59'),(69570,198,'Mahul','223225',1,0,'2022-03-03 12:57:59','2022-03-03 12:57:59'),(69571,198,'Mahulia Bojhia','276138',1,0,'2022-03-03 12:57:59','2022-03-03 12:57:59'),(69572,198,'Mahuyamurarpur','276131',1,0,'2022-03-03 12:57:59','2022-03-03 12:57:59'),(69573,198,'Malgaon','223222',1,0,'2022-03-03 12:57:59','2022-03-03 12:57:59'),(69574,198,'Maltari','276138',1,0,'2022-03-03 12:57:59','2022-03-03 12:57:59'),(69575,198,'Mandanpur','276124',1,0,'2022-03-03 12:57:59','2022-03-03 12:57:59'),(69576,198,'Mande','276129',1,0,'2022-03-03 12:57:59','2022-03-03 12:57:59'),(69577,198,'Mangit Pur','276142',1,0,'2022-03-03 12:57:59','2022-03-03 12:57:59'),(69578,198,'Mangrawa','276205',1,0,'2022-03-03 12:57:59','2022-03-03 12:57:59'),(69579,198,'Maniyar Pur','276141',1,0,'2022-03-03 12:57:59','2022-03-03 12:57:59'),(69580,198,'Martin Ganj','223224',1,0,'2022-03-03 12:57:59','2022-03-03 12:57:59'),(69581,198,'Mataulipur','276206',1,0,'2022-03-03 12:57:59','2022-03-03 12:57:59'),(69582,198,'Matia','276122',1,0,'2022-03-03 12:57:59','2022-03-03 12:57:59'),(69583,198,'Maukutubpur','276127',1,0,'2022-03-03 12:57:59','2022-03-03 12:57:59'),(69584,198,'Mauri','221706',1,0,'2022-03-03 12:57:59','2022-03-03 12:57:59'),(69585,198,'Meh Mauni','276141',1,0,'2022-03-03 12:57:59','2022-03-03 12:57:59'),(69586,198,'Mehanazpur','276203',1,0,'2022-03-03 12:57:59','2022-03-03 12:57:59'),(69587,198,'Mehnagar','276204',1,0,'2022-03-03 12:57:59','2022-03-03 12:57:59'),(69588,198,'Mir Ahmedpur Sahjada','223224',1,0,'2022-03-03 12:57:59','2022-03-03 12:57:59'),(69589,198,'Mir Pur','223223',1,0,'2022-03-03 12:57:59','2022-03-03 12:57:59'),(69590,198,'Mirja Pur','276305',1,0,'2022-03-03 12:57:59','2022-03-03 12:57:59'),(69591,198,'Mittupur','276131',1,0,'2022-03-03 12:58:00','2022-03-03 12:58:00'),(69592,198,'Mittupur','276143',1,0,'2022-03-03 12:58:00','2022-03-03 12:58:00'),(69593,198,'Mohamdalla','276128',1,0,'2022-03-03 12:58:00','2022-03-03 12:58:00'),(69594,198,'Mohammad Pur Dharang','276202',1,0,'2022-03-03 12:58:00','2022-03-03 12:58:00'),(69595,198,'Mohammad Pur','276205',1,0,'2022-03-03 12:58:00','2022-03-03 12:58:00'),(69596,198,'Mohammadpur Hasanpur','276306',1,0,'2022-03-03 12:58:00','2022-03-03 12:58:00'),(69597,198,'Mohanath','276206',1,0,'2022-03-03 12:58:00','2022-03-03 12:58:00'),(69598,198,'Mohmmadpur','276138',1,0,'2022-03-03 12:58:00','2022-03-03 12:58:00'),(69599,198,'Mokhalish Pur','276141',1,0,'2022-03-03 12:58:00','2022-03-03 12:58:00'),(69600,198,'Molana Pur','276137',1,0,'2022-03-03 12:58:00','2022-03-03 12:58:00'),(69601,198,'Mubarak Pur','276404',1,0,'2022-03-03 12:58:00','2022-03-03 12:58:00'),(69602,198,'Mujaffarpur','276302',1,0,'2022-03-03 12:58:00','2022-03-03 12:58:00'),(69603,198,'Mundiyar','276304',1,0,'2022-03-03 12:58:00','2022-03-03 12:58:00'),(69604,198,'Mundwar','276304',1,0,'2022-03-03 12:58:00','2022-03-03 12:58:00'),(69605,198,'Murhar','276303',1,0,'2022-03-03 12:58:00','2022-03-03 12:58:00'),(69606,198,'Mutkallipur','276288',1,0,'2022-03-03 12:58:00','2022-03-03 12:58:00'),(69607,198,'Nagpur','276402',1,0,'2022-03-03 12:58:00','2022-03-03 12:58:00'),(69608,198,'Naharpur','223225',1,0,'2022-03-03 12:58:00','2022-03-03 12:58:00'),(69609,198,'Nai','276204',1,0,'2022-03-03 12:58:00','2022-03-03 12:58:00'),(69610,198,'Nandana','223223',1,0,'2022-03-03 12:58:00','2022-03-03 12:58:00'),(69611,198,'Nandaon','276305',1,0,'2022-03-03 12:58:00','2022-03-03 12:58:00'),(69612,198,'Naraipur','276136',1,0,'2022-03-03 12:58:00','2022-03-03 12:58:00'),(69613,198,'Nardah','276305',1,0,'2022-03-03 12:58:00','2022-03-03 12:58:00'),(69614,198,'Narhankhas','276124',1,0,'2022-03-03 12:58:00','2022-03-03 12:58:00'),(69615,198,'Narsingh Pur','276202',1,0,'2022-03-03 12:58:00','2022-03-03 12:58:00'),(69616,198,'Nasiruddinpur','276208',1,0,'2022-03-03 12:58:00','2022-03-03 12:58:00'),(69617,198,'Nathupur','221603',1,0,'2022-03-03 12:58:01','2022-03-03 12:58:01'),(69618,198,'Nauhara','223222',1,0,'2022-03-03 12:58:01','2022-03-03 12:58:01'),(69619,198,'Naurasia','276123',1,0,'2022-03-03 12:58:01','2022-03-03 12:58:01'),(69620,198,'Nauwarar Dewara Jadid','276139',1,0,'2022-03-03 12:58:01','2022-03-03 12:58:01'),(69621,198,'Nehula','276203',1,0,'2022-03-03 12:58:01','2022-03-03 12:58:01'),(69622,198,'Newada','276141',1,0,'2022-03-03 12:58:01','2022-03-03 12:58:01'),(69623,198,'Niauj','276305',1,0,'2022-03-03 12:58:01','2022-03-03 12:58:01'),(69624,198,'Nizamabad','276206',1,0,'2022-03-03 12:58:01','2022-03-03 12:58:01'),(69625,198,'Nurvey','276303',1,0,'2022-03-03 12:58:01','2022-03-03 12:58:01'),(69626,198,'Ora','276208',1,0,'2022-03-03 12:58:01','2022-03-03 12:58:01'),(69627,198,'Pach Khaura','276141',1,0,'2022-03-03 12:58:01','2022-03-03 12:58:01'),(69628,198,'Pahi','276404',1,0,'2022-03-03 12:58:01','2022-03-03 12:58:01'),(69629,198,'Pakar Deeha','223223',1,0,'2022-03-03 12:58:01','2022-03-03 12:58:01'),(69630,198,'Pakari','276123',1,0,'2022-03-03 12:58:01','2022-03-03 12:58:01'),(69631,198,'Palhana','276205',1,0,'2022-03-03 12:58:01','2022-03-03 12:58:01'),(69632,198,'Palhani','276128',1,0,'2022-03-03 12:58:01','2022-03-03 12:58:01'),(69633,198,'Palia Maphi','223222',1,0,'2022-03-03 12:58:01','2022-03-03 12:58:01'),(69634,198,'Palthi','223224',1,0,'2022-03-03 12:58:01','2022-03-03 12:58:01'),(69635,198,'Pandaha','276202',1,0,'2022-03-03 12:58:01','2022-03-03 12:58:01'),(69636,198,'Parasi','276402',1,0,'2022-03-03 12:58:01','2022-03-03 12:58:01'),(69637,198,'Patila Gaosh Pur','276121',1,0,'2022-03-03 12:58:01','2022-03-03 12:58:01'),(69638,198,'Patkhauli','276125',1,0,'2022-03-03 12:58:01','2022-03-03 12:58:01'),(69639,198,'Patwadh Kautuk','276121',1,0,'2022-03-03 12:58:01','2022-03-03 12:58:01'),(69640,198,'Pawai (Azamgarh)','276288',1,0,'2022-03-03 12:58:02','2022-03-03 12:58:02'),(69641,198,'Pawani Kala','276204',1,0,'2022-03-03 12:58:02','2022-03-03 12:58:02'),(69642,198,'Phool Pur','276304',1,0,'2022-03-03 12:58:02','2022-03-03 12:58:02'),(69643,198,'Phool Pur Town','276304',1,0,'2022-03-03 12:58:02','2022-03-03 12:58:02'),(69644,198,'Phulaieh Khajura','276126',1,0,'2022-03-03 12:58:02','2022-03-03 12:58:02'),(69645,198,'Pichari','276403',1,0,'2022-03-03 12:58:02','2022-03-03 12:58:02'),(69646,198,'Pichhaura','276301',1,0,'2022-03-03 12:58:02','2022-03-03 12:58:02'),(69647,198,'Pihar','276136',1,0,'2022-03-03 12:58:02','2022-03-03 12:58:02'),(69648,198,'Pipari','276142',1,0,'2022-03-03 12:58:02','2022-03-03 12:58:02'),(69649,198,'Punapar','276124',1,0,'2022-03-03 12:58:02','2022-03-03 12:58:02'),(69650,198,'Punargi','276131',1,0,'2022-03-03 12:58:02','2022-03-03 12:58:02'),(69651,198,'Pur Ranga','276306',1,0,'2022-03-03 12:58:02','2022-03-03 12:58:02'),(69652,198,'Pushpnagar','223226',1,0,'2022-03-03 12:58:02','2022-03-03 12:58:02'),(69653,198,'Raida','223225',1,0,'2022-03-03 12:58:02','2022-03-03 12:58:02'),(69654,198,'Rajapur Sikaraur','276305',1,0,'2022-03-03 12:58:02','2022-03-03 12:58:02'),(69655,198,'Ram Pur Katharawa','276201',1,0,'2022-03-03 12:58:02','2022-03-03 12:58:02'),(69656,198,'Rama Pur','223225',1,0,'2022-03-03 12:58:02','2022-03-03 12:58:02'),(69657,198,'Ramgarh','276127',1,0,'2022-03-03 12:58:02','2022-03-03 12:58:02'),(69658,198,'Rani Ki Sarai','276207',1,0,'2022-03-03 12:58:02','2022-03-03 12:58:02'),(69659,198,'Ranipur Razamo','276302',1,0,'2022-03-03 12:58:02','2022-03-03 12:58:02'),(69660,198,'Rasoolpur','276204',1,0,'2022-03-03 12:58:02','2022-03-03 12:58:02'),(69661,198,'Rasul Pur Pasi Pur','276141',1,0,'2022-03-03 12:58:02','2022-03-03 12:58:02'),(69662,198,'Rasulpur Nandalal','276139',1,0,'2022-03-03 12:58:02','2022-03-03 12:58:02'),(69663,198,'Rauna Par','276122',1,0,'2022-03-03 12:58:02','2022-03-03 12:58:02'),(69664,198,'Raut Mau','276406',1,0,'2022-03-03 12:58:03','2022-03-03 12:58:03'),(69665,198,'Renda','276204',1,0,'2022-03-03 12:58:03','2022-03-03 12:58:03'),(69666,198,'Rithia','276142',1,0,'2022-03-03 12:58:03','2022-03-03 12:58:03'),(69667,198,'Safipur','276202',1,0,'2022-03-03 12:58:03','2022-03-03 12:58:03'),(69668,198,'Sagari','276138',1,0,'2022-03-03 12:58:03','2022-03-03 12:58:03'),(69669,198,'Salempur','276202',1,0,'2022-03-03 12:58:03','2022-03-03 12:58:03'),(69670,198,'Samaida','276128',1,0,'2022-03-03 12:58:03','2022-03-03 12:58:03'),(69671,198,'Samsabad','223221',1,0,'2022-03-03 12:58:03','2022-03-03 12:58:03'),(69672,198,'Sanjar Pur','223227',1,0,'2022-03-03 12:58:03','2022-03-03 12:58:03'),(69673,198,'Sarai Mohan','276303',1,0,'2022-03-03 12:58:03','2022-03-03 12:58:03'),(69674,198,'Sarai Paltu','276302',1,0,'2022-03-03 12:58:03','2022-03-03 12:58:03'),(69675,198,'Saraimeer','276305',1,0,'2022-03-03 12:58:03','2022-03-03 12:58:03'),(69676,198,'Sarain','223221',1,0,'2022-03-03 12:58:03','2022-03-03 12:58:03'),(69677,198,'Sarawan','276202',1,0,'2022-03-03 12:58:03','2022-03-03 12:58:03'),(69678,198,'Sardaha','276139',1,0,'2022-03-03 12:58:03','2022-03-03 12:58:03'),(69679,198,'Sathion','276406',1,0,'2022-03-03 12:58:03','2022-03-03 12:58:03'),(69680,198,'Sema','276131',1,0,'2022-03-03 12:58:03','2022-03-03 12:58:03'),(69681,198,'Sen Pur','223223',1,0,'2022-03-03 12:58:03','2022-03-03 12:58:03'),(69682,198,'Sewata','276128',1,0,'2022-03-03 12:58:03','2022-03-03 12:58:03'),(69683,198,'Shah Garh','276406',1,0,'2022-03-03 12:58:03','2022-03-03 12:58:03'),(69684,198,'Shbili','276135',1,0,'2022-03-03 12:58:03','2022-03-03 12:58:03'),(69685,198,'Shekhupur','276121',1,0,'2022-03-03 12:58:03','2022-03-03 12:58:03'),(69686,198,'Sherpur','276129',1,0,'2022-03-03 12:58:03','2022-03-03 12:58:03'),(69687,198,'Shethawal','276207',1,0,'2022-03-03 12:58:03','2022-03-03 12:58:03'),(69688,198,'Shivpur','276139',1,0,'2022-03-03 12:58:03','2022-03-03 12:58:03'),(69689,198,'Shiwali','276206',1,0,'2022-03-03 12:58:03','2022-03-03 12:58:03'),(69690,198,'Sidhari','',1,0,'2022-03-03 12:58:04','2022-03-03 12:58:04'),(69691,198,'Sidhauna','276203',1,0,'2022-03-03 12:58:04','2022-03-03 12:58:04'),(69692,198,'Sihuka Abhirpur','276203',1,0,'2022-03-03 12:58:04','2022-03-03 12:58:04'),(69693,198,'Sikaraur Sahabari','223226',1,0,'2022-03-03 12:58:04','2022-03-03 12:58:04'),(69694,198,'Sikari Kot','276306',1,0,'2022-03-03 12:58:04','2022-03-03 12:58:04'),(69695,198,'Sikraur','276201',1,0,'2022-03-03 12:58:04','2022-03-03 12:58:04'),(69696,198,'Singhpur','276126',1,0,'2022-03-03 12:58:04','2022-03-03 12:58:04'),(69697,198,'Singhwara','276139',1,0,'2022-03-03 12:58:04','2022-03-03 12:58:04'),(69698,198,'Sirahi','276127',1,0,'2022-03-03 12:58:04','2022-03-03 12:58:04'),(69699,198,'Sirsal','276207',1,0,'2022-03-03 12:58:04','2022-03-03 12:58:04'),(69700,198,'Sodhari','276206',1,0,'2022-03-03 12:58:04','2022-03-03 12:58:04'),(69701,198,'Sohauli','276301',1,0,'2022-03-03 12:58:04','2022-03-03 12:58:04'),(69702,198,'Sonhara','276301',1,0,'2022-03-03 12:58:04','2022-03-03 12:58:04'),(69703,198,'Sri Kant Pur','276201',1,0,'2022-03-03 12:58:04','2022-03-03 12:58:04'),(69704,198,'Sukhi Pur','223221',1,0,'2022-03-03 12:58:04','2022-03-03 12:58:04'),(69705,198,'Sumhadeeh','276288',1,0,'2022-03-03 12:58:04','2022-03-03 12:58:04'),(69706,198,'Surahan','223224',1,0,'2022-03-03 12:58:04','2022-03-03 12:58:04'),(69707,198,'Suraj Pur','276306',1,0,'2022-03-03 12:58:04','2022-03-03 12:58:04'),(69708,198,'Sutarahi','276406',1,0,'2022-03-03 12:58:04','2022-03-03 12:58:04'),(69709,198,'Tahar Wajid Pur','276141',1,0,'2022-03-03 12:58:04','2022-03-03 12:58:04'),(69710,198,'Tahir Pur','276122',1,0,'2022-03-03 12:58:04','2022-03-03 12:58:04'),(69711,198,'Taktewarampur','275301',1,0,'2022-03-03 12:58:04','2022-03-03 12:58:04'),(69712,198,'Tamauli','276207',1,0,'2022-03-03 12:58:04','2022-03-03 12:58:04'),(69713,198,'Tandadeeh','276123',1,0,'2022-03-03 12:58:04','2022-03-03 12:58:04'),(69714,198,'Tandawa','276123',1,0,'2022-03-03 12:58:04','2022-03-03 12:58:04'),(69715,198,'Tarauka','276136',1,0,'2022-03-03 12:58:05','2022-03-03 12:58:05'),(69716,198,'Tarawa','276123',1,0,'2022-03-03 12:58:05','2022-03-03 12:58:05'),(69717,198,'Tegar Pur','276207',1,0,'2022-03-03 12:58:05','2022-03-03 12:58:05'),(69718,198,'Terahi','276141',1,0,'2022-03-03 12:58:05','2022-03-03 12:58:05'),(69719,198,'Thekma','276303',1,0,'2022-03-03 12:58:05','2022-03-03 12:58:05'),(69720,198,'Tika Pur','276208',1,0,'2022-03-03 12:58:05','2022-03-03 12:58:05'),(69721,198,'Tilkhara Pura Dani','276203',1,0,'2022-03-03 12:58:05','2022-03-03 12:58:05'),(69722,198,'Ubarpur','276202',1,0,'2022-03-03 12:58:05','2022-03-03 12:58:05'),(69723,198,'Uchagaon','276128',1,0,'2022-03-03 12:58:05','2022-03-03 12:58:05'),(69724,198,'Uchahuwan','276126',1,0,'2022-03-03 12:58:05','2022-03-03 12:58:05'),(69725,198,'Udiawan','276301',1,0,'2022-03-03 12:58:05','2022-03-03 12:58:05'),(69726,198,'Urdiha','276122',1,0,'2022-03-03 12:58:05','2022-03-03 12:58:05'),(69727,198,'Utarizpur','276403',1,0,'2022-03-03 12:58:05','2022-03-03 12:58:05'),(69728,198,'Vijayapar','276121',1,0,'2022-03-03 12:58:05','2022-03-03 12:58:05'),(69729,198,'Vijra Pura','275302',1,0,'2022-03-03 12:58:05','2022-03-03 12:58:05'),(69730,198,'Vinoa Puri','223221',1,0,'2022-03-03 12:58:05','2022-03-03 12:58:05'),(69731,198,'Youdhisthirpatti.','223221',1,0,'2022-03-03 12:58:05','2022-03-03 12:58:05'),(69732,198,'Zafarpur','276128',1,0,'2022-03-03 12:58:05','2022-03-03 12:58:05'),(69733,198,'Zamin Katghar','276206',1,0,'2022-03-03 12:58:05','2022-03-03 12:58:05'),(69734,199,'Agarwal Mandi','250601',1,0,'2022-03-03 12:58:05','2022-03-03 12:58:05'),(69735,199,'Ahera','250609',1,0,'2022-03-03 12:58:05','2022-03-03 12:58:05'),(69736,199,'Alwalpur','250611',1,0,'2022-03-03 12:58:05','2022-03-03 12:58:05'),(69737,199,'Aminagar Sarai','250606',1,0,'2022-03-03 12:58:05','2022-03-03 12:58:05'),(69738,199,'Asara','250623',1,0,'2022-03-03 12:58:05','2022-03-03 12:58:05'),(69739,199,'Asarfabad Thal','250623',1,0,'2022-03-03 12:58:05','2022-03-03 12:58:05'),(69740,199,'Audhapur','250611',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69741,199,'Azampur Mulsam','250622',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69742,199,'Badarkha','250617',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69743,199,'Baghpat','250609',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69744,199,'Baghpat Sugar Mill','250609',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69745,199,'Baleni','250626',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69746,199,'Bali','250601',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69747,199,'Bamnauli','250620',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69748,199,'Baoli','250621',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69749,199,'Baragaon','250101',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69750,199,'Baraut H.O','250611',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69751,199,'Barawad','250611',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69752,199,'Barka','250611',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69753,199,'Barnawa','250345',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69754,199,'Barwala','250621',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69755,199,'Basaudh','250601',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69756,199,'Basauli','250623',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69757,199,'Bassi','250101',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69758,199,'Bazidpur','250611',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69759,199,'Begmabad Garhi','250622',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69760,199,'Bhagot','250101',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69761,199,'Bharal','250622',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69762,199,'Bijrol','250620',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69763,199,'Bijwara','250345',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69764,199,'Bilochpura','250606',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69765,199,'Binauli','250345',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69766,199,'Bodha','250617',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69767,199,'Budhera','250611',1,0,'2022-03-03 12:58:06','2022-03-03 12:58:06'),(69768,199,'Budhpur','250623',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69769,199,'Budhsaini','250606',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69770,199,'Chamrawal','250615',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69771,199,'Chandyan','250345',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69772,199,'Chaubli','250611',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69773,199,'Chhaprauli','250617',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69774,199,'Daha','250622',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69775,199,'Daula','250601',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69776,199,'Dhanaura Silver Nagar','250611',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69777,199,'Dhanaura Tikri','250622',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69778,199,'Dhaulri','250626',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69779,199,'Dhikana','250611',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69780,199,'Dhikauli','250615',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69781,199,'Doghat','250622',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69782,199,'Dohja','250611',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69783,199,'Dolhca','250626',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69784,199,'Duttnagar','250626',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69785,199,'Faizpur Ninana','250619',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69786,199,'Fakharpur','250101',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69787,199,'Fatehpur Poothi','250345',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69788,199,'Fazalpur','250345',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69789,199,'Gaidbara','250622',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69790,199,'Galheta','250345',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69791,199,'Gandhi Chowk Baraut','250611',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69792,199,'Gangnauli','250625',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69793,199,'Garhi','250601',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69794,199,'Garhi Hazurabad','250606',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69795,199,'Garhi Kalanjiri','250101',1,0,'2022-03-03 12:58:07','2022-03-03 12:58:07'),(69796,199,'Gauripur','250619',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69797,199,'Ghitora','250101',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69798,199,'Gothra','250101',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69799,199,'Gunga Kheri','250621',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69800,199,'Gurana','250611',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69801,199,'Gwali Khera','250606',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69802,199,'Halalpur','250617',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69803,199,'Hewa','250617',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69804,199,'Hilwari','250611',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69805,199,'Hisauda','250615',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69806,199,'Ibrahimpur Mazra','250623',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69807,199,'Idrishpur','250622',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69808,199,'Jaunmana','250611',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69809,199,'Jhundpur','250622',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69810,199,'Jiwana','250345',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69811,199,'Jiwana','250623',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69812,199,'Johri','250345',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69813,199,'Kakor Kalan','250617',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69814,199,'Kakripur','250623',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69815,199,'Kandera','250620',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69816,199,'Kanhar','250622',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69817,199,'Kasimpur Khari','250623',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69818,199,'Khatta','250609',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69819,199,'Khatta Prahladpur','250615',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69820,199,'Khekra','250101',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69821,199,'Khera Hatana','250619',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69822,199,'Kherki','250619',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69823,199,'Khwaja Nagla','250611',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69824,199,'Kirthal','250623',1,0,'2022-03-03 12:58:08','2022-03-03 12:58:08'),(69825,199,'Kishanpur Baral','250623',1,0,'2022-03-03 12:58:09','2022-03-03 12:58:09'),(69826,199,'Kotana','250611',1,0,'2022-03-03 12:58:09','2022-03-03 12:58:09'),(69827,199,'Kurri','250617',1,0,'2022-03-03 12:58:09','2022-03-03 12:58:09'),(69828,199,'Lalyana','250615',1,0,'2022-03-03 12:58:09','2022-03-03 12:58:09'),(69829,199,'Lohadda','250611',1,0,'2022-03-03 12:58:09','2022-03-03 12:58:09'),(69830,199,'Luhari','250611',1,0,'2022-03-03 12:58:09','2022-03-03 12:58:09'),(69831,199,'Lumb','250623',1,0,'2022-03-03 12:58:09','2022-03-03 12:58:09'),(69832,199,'Malakpur','250611',1,0,'2022-03-03 12:58:09','2022-03-03 12:58:09'),(69833,199,'Mawi Kalan','250606',1,0,'2022-03-03 12:58:09','2022-03-03 12:58:09'),(69834,199,'Mitli','250601',1,0,'2022-03-03 12:58:09','2022-03-03 12:58:09'),(69835,199,'Mohd. Pur Bhoomi','250626',1,0,'2022-03-03 12:58:09','2022-03-03 12:58:09'),(69836,199,'Mozizabad Nangal','250625',1,0,'2022-03-03 12:58:09','2022-03-03 12:58:09'),(69837,199,'Mubarikpur','250101',1,0,'2022-03-03 12:58:09','2022-03-03 12:58:09'),(69838,199,'Mukri','250626',1,0,'2022-03-03 12:58:09','2022-03-03 12:58:09'),(69839,199,'Muzaffarpur Kanwara','250622',1,0,'2022-03-03 12:58:09','2022-03-03 12:58:09'),(69840,199,'Muzampur Kamala','250345',1,0,'2022-03-03 12:58:09','2022-03-03 12:58:09'),(69841,199,'Nai Mandi Baraut','250611',1,0,'2022-03-03 12:58:09','2022-03-03 12:58:09'),(69842,199,'Nangal','250617',1,0,'2022-03-03 12:58:09','2022-03-03 12:58:09'),(69843,199,'Nehru Rd. Baraut','250611',1,0,'2022-03-03 12:58:09','2022-03-03 12:58:09'),(69844,199,'Nerojpur Gujar','250601',1,0,'2022-03-03 12:58:09','2022-03-03 12:58:09'),(69845,199,'Nibali','250601',1,0,'2022-03-03 12:58:09','2022-03-03 12:58:09'),(69846,199,'Nirpura','250625',1,0,'2022-03-03 12:58:09','2022-03-03 12:58:09'),(69847,199,'Pabla Begmabad','250615',1,0,'2022-03-03 12:58:09','2022-03-03 12:58:09'),(69848,199,'Palra','250622',1,0,'2022-03-03 12:58:09','2022-03-03 12:58:09'),(69849,199,'Palri','250622',1,0,'2022-03-03 12:58:09','2022-03-03 12:58:09'),(69850,199,'Phulera','250101',1,0,'2022-03-03 12:58:09','2022-03-03 12:58:09'),(69851,199,'Pilana','250615',1,0,'2022-03-03 12:58:10','2022-03-03 12:58:10'),(69852,199,'Pusar','250622',1,0,'2022-03-03 12:58:10','2022-03-03 12:58:10'),(69853,199,'Rajpur Khampur','250611',1,0,'2022-03-03 12:58:10','2022-03-03 12:58:10'),(69854,199,'Ram Nagar','250606',1,0,'2022-03-03 12:58:10','2022-03-03 12:58:10'),(69855,199,'Ramala','250623',1,0,'2022-03-03 12:58:10','2022-03-03 12:58:10'),(69856,199,'Ranchhar','250345',1,0,'2022-03-03 12:58:10','2022-03-03 12:58:10'),(69857,199,'Rataul','250101',1,0,'2022-03-03 12:58:10','2022-03-03 12:58:10'),(69858,199,'Rathaura','250617',1,0,'2022-03-03 12:58:10','2022-03-03 12:58:10'),(69859,199,'Rly. Road Khekra','250101',1,0,'2022-03-03 12:58:10','2022-03-03 12:58:10'),(69860,199,'Sabga','250617',1,0,'2022-03-03 12:58:10','2022-03-03 12:58:10'),(69861,199,'Sadiqpur Sinoli','250611',1,0,'2022-03-03 12:58:10','2022-03-03 12:58:10'),(69862,199,'Saidbhar','250606',1,0,'2022-03-03 12:58:10','2022-03-03 12:58:10'),(69863,199,'Sankrodh','250101',1,0,'2022-03-03 12:58:10','2022-03-03 12:58:10'),(69864,199,'Sarurpur Kalan','250619',1,0,'2022-03-03 12:58:10','2022-03-03 12:58:10'),(69865,199,'Shahpur Banoli','250611',1,0,'2022-03-03 12:58:10','2022-03-03 12:58:10'),(69866,199,'Sherpur Luhari','250617',1,0,'2022-03-03 12:58:10','2022-03-03 12:58:10'),(69867,199,'Shikohpur','250611',1,0,'2022-03-03 12:58:10','2022-03-03 12:58:10'),(69868,199,'Silana','250617',1,0,'2022-03-03 12:58:10','2022-03-03 12:58:10'),(69869,199,'Singhaoli Ahir','250606',1,0,'2022-03-03 12:58:10','2022-03-03 12:58:10'),(69870,199,'Sirsalgarh','250345',1,0,'2022-03-03 12:58:10','2022-03-03 12:58:10'),(69871,199,'Sirsali','250345',1,0,'2022-03-03 12:58:10','2022-03-03 12:58:10'),(69872,199,'Sisana','250609',1,0,'2022-03-03 12:58:10','2022-03-03 12:58:10'),(69873,199,'Soop','250623',1,0,'2022-03-03 12:58:10','2022-03-03 12:58:10'),(69874,199,'Sujra','250601',1,0,'2022-03-03 12:58:10','2022-03-03 12:58:10'),(69875,199,'Sujti','250625',1,0,'2022-03-03 12:58:10','2022-03-03 12:58:10'),(69876,199,'Sunehra','250101',1,0,'2022-03-03 12:58:10','2022-03-03 12:58:10'),(69877,199,'Teodhi','250611',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69878,199,'Tera','250606',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69879,199,'Tikri','250625',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69880,199,'Titroda','250345',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69881,199,'Tugana','250617',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69882,200,'Ailiha','271870',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69883,200,'Ailo','271871',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69884,200,'Aliabulbul','271802',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69885,200,'Ambarpur','271851',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69886,200,'Amwa Molvi','271882',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69887,200,'Amwa Pokhar','271865',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69888,200,'Arai Umari','271904',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69889,200,'Argorwa','271865',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69890,200,'Aswa Mohammad Pur','271882',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69891,200,'Babaganj','271881',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69892,200,'Babhnanpurwa','271903',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69893,200,'Babkapur','271902',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69894,200,'Badholi','271904',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69895,200,'Badrauli','271903',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69896,200,'Bahrai R.S.','271802',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69897,200,'Bahraich City','271801',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69898,200,'Bahraich H.O','271801',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69899,200,'Baibahi','271830',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69900,200,'Bakaina Bazar','271851',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69901,200,'Balai Goan','271855',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69902,200,'Balbhaddrapur','271875',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69903,200,'Balchandpur','271902',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69904,200,'Baldoopurwa','271830',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69905,200,'Balha','271865',1,0,'2022-03-03 12:58:11','2022-03-03 12:58:11'),(69906,200,'Balsinghpur','271855',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69907,200,'Bamiyari','271902',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69908,200,'Banjaria','271865',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69909,200,'Banjaria','271881',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69910,200,'Bankashi','271865',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69911,200,'Bardaha','271830',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69912,200,'Barkharia','271841',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69913,200,'Barnapur','271825',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69914,200,'Basanera','271871',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69915,200,'Basantapur','271872',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69916,200,'Basantapur','271830',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69917,200,'Baundi','271902',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69918,200,'Begampur','271875',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69919,200,'Belhan','271855',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69920,200,'Belwa Padum','271870',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69921,200,'Bhabnoti Shankarpur','271825',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69922,200,'Bhaggarwa','271872',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69923,200,'Bhangha','271872',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69924,200,'Bhartha','271901',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69925,200,'Bhaukhara','271882',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69926,200,'Bhausawan','271804',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69927,200,'Bhawaniapur','271830',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69928,200,'Bhilora Basu','271902',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69929,200,'Bhopatpur','271882',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69930,200,'Bichhiya','271841',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69931,200,'Birahimpur','271903',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69932,200,'Bitania','271830',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69933,200,'Botania','271865',1,0,'2022-03-03 12:58:12','2022-03-03 12:58:12'),(69934,200,'Boundi','271830',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69935,200,'Bulbul Newaj','271882',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69936,200,'Chafaria Bazar','271841',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69937,200,'Chahalwa','271841',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69938,200,'Chakujot','271870',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69939,200,'Chamarpurwa','271865',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69940,200,'Chandanpur K. Pur','271865',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69941,200,'Charda','271881',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69942,200,'Chaukharia','271802',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69943,200,'Chhwani Bazar','271801',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69944,200,'Chilwaria','271870',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69945,200,'Chittuara','271802',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69946,200,'Chok Sahar','271851',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69947,200,'Curaipurwa','271851',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69948,200,'Dahaura','271902',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69949,200,'Dandey Kuinya','271875',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69950,200,'Dargah','271802',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69951,200,'Daulatpur','271855',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69952,200,'Devlakha','271903',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69953,200,'Devra','271881',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69954,200,'Dhannigaon','271865',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69955,200,'Dharampur','271855',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69956,200,'Dharmanpur','271875',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69957,200,'Dharmapur','271855',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69958,200,'Diha','271802',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69959,200,'Dihwa','271875',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69960,200,'Fakharpur','271902',1,0,'2022-03-03 12:58:13','2022-03-03 12:58:13'),(69961,200,'Fakirpuri','271841',1,0,'2022-03-03 12:58:14','2022-03-03 12:58:14'),(69962,200,'Farda Sumerpur','271871',1,0,'2022-03-03 12:58:14','2022-03-03 12:58:14'),(69963,200,'Fattepur','271825',1,0,'2022-03-03 12:58:14','2022-03-03 12:58:14'),(69964,200,'Gadamar Kuurd','271825',1,0,'2022-03-03 12:58:14','2022-03-03 12:58:14'),(69965,200,'Gaighat','271865',1,0,'2022-03-03 12:58:14','2022-03-03 12:58:14'),(69966,200,'Gajadharpur','271902',1,0,'2022-03-03 12:58:14','2022-03-03 12:58:14'),(69967,200,'Gandara','271903',1,0,'2022-03-03 12:58:14','2022-03-03 12:58:14'),(69968,200,'Ganga Jamuni','271821',1,0,'2022-03-03 12:58:14','2022-03-03 12:58:14'),(69969,200,'Gangapur','271855',1,0,'2022-03-03 12:58:14','2022-03-03 12:58:14'),(69970,200,'Gangwal','271821',1,0,'2022-03-03 12:58:14','2022-03-03 12:58:14'),(69971,200,'Garethi Gurudutt Singh','271851',1,0,'2022-03-03 12:58:14','2022-03-03 12:58:14'),(69972,200,'Gaurapipra','271855',1,0,'2022-03-03 12:58:14','2022-03-03 12:58:14'),(69973,200,'Girdharpur','271865',1,0,'2022-03-03 12:58:14','2022-03-03 12:58:14'),(69974,200,'Girijapuri Coloney','271841',1,0,'2022-03-03 12:58:14','2022-03-03 12:58:14'),(69975,200,'Goorh','271855',1,0,'2022-03-03 12:58:14','2022-03-03 12:58:14'),(69976,200,'Gopchandpur','271825',1,0,'2022-03-03 12:58:14','2022-03-03 12:58:14'),(69977,200,'Gopia','271855',1,0,'2022-03-03 12:58:14','2022-03-03 12:58:14'),(69978,200,'Gorahia','271903',1,0,'2022-03-03 12:58:14','2022-03-03 12:58:14'),(69979,200,'Gotutti','271875',1,0,'2022-03-03 12:58:14','2022-03-03 12:58:14'),(69980,200,'Govindpur Pandit','271865',1,0,'2022-03-03 12:58:14','2022-03-03 12:58:14'),(69981,200,'Gudari Bazar','271801',1,0,'2022-03-03 12:58:14','2022-03-03 12:58:14'),(69982,200,'Gujra','271872',1,0,'2022-03-03 12:58:14','2022-03-03 12:58:14'),(69983,200,'Gureharipur','271902',1,0,'2022-03-03 12:58:14','2022-03-03 12:58:14'),(69984,200,'Gurghutta','271865',1,0,'2022-03-03 12:58:14','2022-03-03 12:58:14'),(69985,200,'Haiveriya','271872',1,0,'2022-03-03 12:58:14','2022-03-03 12:58:14'),(69986,200,'Handa Basehri','271865',1,0,'2022-03-03 12:58:14','2022-03-03 12:58:14'),(69987,200,'Harchanda','271904',1,0,'2022-03-03 12:58:15','2022-03-03 12:58:15'),(69988,200,'Hardi','271825',1,0,'2022-03-03 12:58:15','2022-03-03 12:58:15'),(69989,200,'Hariharpur','271870',1,0,'2022-03-03 12:58:15','2022-03-03 12:58:15'),(69990,200,'Harkhapur','271855',1,0,'2022-03-03 12:58:15','2022-03-03 12:58:15'),(69991,200,'Huzoorpur','271872',1,0,'2022-03-03 12:58:15','2022-03-03 12:58:15'),(69992,200,'Ikauna','271845',1,0,'2022-03-03 12:58:15','2022-03-03 12:58:15'),(69993,200,'Imilia','271870',1,0,'2022-03-03 12:58:15','2022-03-03 12:58:15'),(69994,200,'Intaha','271882',1,0,'2022-03-03 12:58:15','2022-03-03 12:58:15'),(69995,200,'Jagtapur','271872',1,0,'2022-03-03 12:58:15','2022-03-03 12:58:15'),(69996,200,'Jaitapur','271902',1,0,'2022-03-03 12:58:15','2022-03-03 12:58:15'),(69997,200,'Jalalpur','271881',1,0,'2022-03-03 12:58:15','2022-03-03 12:58:15'),(69998,200,'Jarwal Road','271901',1,0,'2022-03-03 12:58:15','2022-03-03 12:58:15'),(69999,200,'Jarwal','271904',1,0,'2022-03-03 12:58:15','2022-03-03 12:58:15'),(70000,200,'Jataura','271901',1,0,'2022-03-03 12:58:15','2022-03-03 12:58:15'),(70001,200,'Jhingha Road','271802',1,0,'2022-03-03 12:58:15','2022-03-03 12:58:15'),(70002,200,'Jiganiamahipal','271872',1,0,'2022-03-03 12:58:15','2022-03-03 12:58:15'),(70003,200,'Kaiserganj','271903',1,0,'2022-03-03 12:58:15','2022-03-03 12:58:15'),(70004,200,'Kakraha','271855',1,0,'2022-03-03 12:58:15','2022-03-03 12:58:15'),(70005,200,'Kakri','271865',1,0,'2022-03-03 12:58:15','2022-03-03 12:58:15'),(70006,200,'Kalpipara','271802',1,0,'2022-03-03 12:58:15','2022-03-03 12:58:15'),(70007,200,'Kandila Khas','271904',1,0,'2022-03-03 12:58:15','2022-03-03 12:58:15'),(70008,200,'Kandra','271872',1,0,'2022-03-03 12:58:15','2022-03-03 12:58:15'),(70009,200,'Kapoorpur','271824',1,0,'2022-03-03 12:58:15','2022-03-03 12:58:15'),(70010,200,'Karanpur','271875',1,0,'2022-03-03 12:58:15','2022-03-03 12:58:15'),(70011,200,'Karikot','271830',1,0,'2022-03-03 12:58:15','2022-03-03 12:58:15'),(70012,200,'Kashijot','271871',1,0,'2022-03-03 12:58:15','2022-03-03 12:58:15'),(70013,200,'Katghara Kala','271870',1,0,'2022-03-03 12:58:16','2022-03-03 12:58:16'),(70014,200,'Katka Bhagatpurwa','271903',1,0,'2022-03-03 12:58:16','2022-03-03 12:58:16'),(70015,200,'Katra Bahadurpur','271802',1,0,'2022-03-03 12:58:16','2022-03-03 12:58:16'),(70016,200,'Katraniaghat','271841',1,0,'2022-03-03 12:58:16','2022-03-03 12:58:16'),(70017,200,'Kaudha','271902',1,0,'2022-03-03 12:58:16','2022-03-03 12:58:16'),(70018,200,'Kewalpur','271881',1,0,'2022-03-03 12:58:16','2022-03-03 12:58:16'),(70019,200,'Kewalpur','271851',1,0,'2022-03-03 12:58:16','2022-03-03 12:58:16'),(70020,200,'Khaira Dhaukal','271851',1,0,'2022-03-03 12:58:16','2022-03-03 12:58:16'),(70021,200,'Khaira Kala','271830',1,0,'2022-03-03 12:58:16','2022-03-03 12:58:16'),(70022,200,'Khairabazar','271902',1,0,'2022-03-03 12:58:16','2022-03-03 12:58:16'),(70023,200,'Khanpur','271872',1,0,'2022-03-03 12:58:16','2022-03-03 12:58:16'),(70024,200,'Khanpur Mallah','271821',1,0,'2022-03-03 12:58:16','2022-03-03 12:58:16'),(70025,200,'Khapurwa','271902',1,0,'2022-03-03 12:58:16','2022-03-03 12:58:16'),(70026,200,'Kharighat','271851',1,0,'2022-03-03 12:58:16','2022-03-03 12:58:16'),(70027,200,'Khariha','271821',1,0,'2022-03-03 12:58:16','2022-03-03 12:58:16'),(70028,200,'Khasha Mohd.Pur','271825',1,0,'2022-03-03 12:58:16','2022-03-03 12:58:16'),(70029,200,'Kishunpur Meetha','271851',1,0,'2022-03-03 12:58:16','2022-03-03 12:58:16'),(70030,200,'Kotwa','271865',1,0,'2022-03-03 12:58:16','2022-03-03 12:58:16'),(70031,200,'Kundasar','271903',1,0,'2022-03-03 12:58:16','2022-03-03 12:58:16'),(70032,200,'Kundaspara','271902',1,0,'2022-03-03 12:58:16','2022-03-03 12:58:16'),(70033,200,'Kundwa','271855',1,0,'2022-03-03 12:58:16','2022-03-03 12:58:16'),(70034,200,'Kursaha','271821',1,0,'2022-03-03 12:58:16','2022-03-03 12:58:16'),(70035,200,'Lakhai Kalan','271865',1,0,'2022-03-03 12:58:16','2022-03-03 12:58:16'),(70036,200,'Lakkha Baundi','271825',1,0,'2022-03-03 12:58:16','2022-03-03 12:58:16'),(70037,200,'Lakkharampur','271821',1,0,'2022-03-03 12:58:16','2022-03-03 12:58:16'),(70038,200,'Lalpur','271871',1,0,'2022-03-03 12:58:16','2022-03-03 12:58:16'),(70039,200,'Laluhi','271830',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70040,200,'Laukahi','271871',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70041,200,'Lohiya Nagar','271855',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70042,200,'Madhavpur','271902',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70043,200,'Madhavpur Nidaona','271881',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70044,200,'Madhwapur','271855',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70045,200,'Mahasi','271824',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70046,200,'Mahasi Tahsil','271824',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70047,200,'Maholi','271903',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70048,200,'Mahuri Kala','271904',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70049,200,'Maikupurwa','271851',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70050,200,'Maila Saraiya','271902',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70051,200,'Maina Newaria','271882',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70052,200,'Majhanwa Takuli','271903',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70053,200,'Majhara','271855',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70054,200,'Makanpur','271881',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70055,200,'Mangouriha','271855',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70056,200,'Manikpur','271830',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70057,200,'Mankapur Kala','271871',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70058,200,'Mansoor Nagar','271865',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70059,200,'Manwaria Diwan','271865',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70060,200,'Matehi','271855',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70061,200,'Matera Kalan','271851',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70062,200,'Matera RS','271882',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70063,200,'Maurauwa Bazar','271825',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70064,200,'Meerpur Koniya','271872',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70065,200,'Metkaha','271802',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70066,200,'Mihinpurwa','271855',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70067,200,'Mohammad Nagar','271802',1,0,'2022-03-03 12:58:17','2022-03-03 12:58:17'),(70068,200,'Moharba','271882',1,0,'2022-03-03 12:58:18','2022-03-03 12:58:18'),(70069,200,'Motipur','271855',1,0,'2022-03-03 12:58:18','2022-03-03 12:58:18'),(70070,200,'Mukeria','271851',1,0,'2022-03-03 12:58:18','2022-03-03 12:58:18'),(70071,200,'Mundki','271902',1,0,'2022-03-03 12:58:18','2022-03-03 12:58:18'),(70072,200,'Murtiha','271855',1,0,'2022-03-03 12:58:18','2022-03-03 12:58:18'),(70073,200,'Mustafabad','271904',1,0,'2022-03-03 12:58:18','2022-03-03 12:58:18'),(70074,200,'Nainiha','271855',1,0,'2022-03-03 12:58:18','2022-03-03 12:58:18'),(70075,200,'Naiwashi','271872',1,0,'2022-03-03 12:58:18','2022-03-03 12:58:18'),(70076,200,'Nandwal','271902',1,0,'2022-03-03 12:58:18','2022-03-03 12:58:18'),(70077,200,'Nanpara','271865',1,0,'2022-03-03 12:58:18','2022-03-03 12:58:18'),(70078,200,'Narounda','271872',1,0,'2022-03-03 12:58:18','2022-03-03 12:58:18'),(70079,200,'Naruttampur','271851',1,0,'2022-03-03 12:58:18','2022-03-03 12:58:18'),(70080,200,'Nasirganj','271804',1,0,'2022-03-03 12:58:18','2022-03-03 12:58:18'),(70081,200,'Naugoia','271903',1,0,'2022-03-03 12:58:18','2022-03-03 12:58:18'),(70082,200,'Nausurgumtiha','271855',1,0,'2022-03-03 12:58:18','2022-03-03 12:58:18'),(70083,200,'Nautala','271851',1,0,'2022-03-03 12:58:18','2022-03-03 12:58:18'),(70084,200,'Nawab Ganj Alia Bad','271865',1,0,'2022-03-03 12:58:18','2022-03-03 12:58:18'),(70085,200,'Newada','271830',1,0,'2022-03-03 12:58:18','2022-03-03 12:58:18'),(70086,200,'Newada','271825',1,0,'2022-03-03 12:58:18','2022-03-03 12:58:18'),(70087,200,'Nidhipurwa','271855',1,0,'2022-03-03 12:58:18','2022-03-03 12:58:18'),(70088,200,'Nisangora','271855',1,0,'2022-03-03 12:58:18','2022-03-03 12:58:18'),(70089,200,'Pachdevri','271851',1,0,'2022-03-03 12:58:18','2022-03-03 12:58:18'),(70090,200,'Pakara Deoria','271882',1,0,'2022-03-03 12:58:18','2022-03-03 12:58:18'),(70091,200,'Pandri Tara','271882',1,0,'2022-03-03 12:58:18','2022-03-03 12:58:18'),(70092,200,'Pargahawa','271865',1,0,'2022-03-03 12:58:19','2022-03-03 12:58:19'),(70093,200,'Parsendi','271903',1,0,'2022-03-03 12:58:19','2022-03-03 12:58:19'),(70094,200,'Parwani Gauri','271855',1,0,'2022-03-03 12:58:19','2022-03-03 12:58:19'),(70095,200,'Patna Ghesiyari','271875',1,0,'2022-03-03 12:58:19','2022-03-03 12:58:19'),(70096,200,'Patrahiya','271830',1,0,'2022-03-03 12:58:19','2022-03-03 12:58:19'),(70097,200,'Patupur','271872',1,0,'2022-03-03 12:58:19','2022-03-03 12:58:19'),(70098,200,'Payagpur','271871',1,0,'2022-03-03 12:58:19','2022-03-03 12:58:19'),(70099,200,'Payrepur','271903',1,0,'2022-03-03 12:58:19','2022-03-03 12:58:19'),(70100,200,'Petraha','271855',1,0,'2022-03-03 12:58:19','2022-03-03 12:58:19'),(70101,200,'Piparia Mahipal Singh','271870',1,0,'2022-03-03 12:58:19','2022-03-03 12:58:19'),(70102,200,'Pipri','271825',1,0,'2022-03-03 12:58:19','2022-03-03 12:58:19'),(70103,200,'Prahalad Gaon','271881',1,0,'2022-03-03 12:58:19','2022-03-03 12:58:19'),(70104,200,'Puraina','271821',1,0,'2022-03-03 12:58:19','2022-03-03 12:58:19'),(70105,200,'Puraina Bhawani Bux','271865',1,0,'2022-03-03 12:58:19','2022-03-03 12:58:19'),(70106,200,'Qanoongopura','271801',1,0,'2022-03-03 12:58:19','2022-03-03 12:58:19'),(70107,200,'Rahmatogaon','271865',1,0,'2022-03-03 12:58:19','2022-03-03 12:58:19'),(70108,200,'Raibojha','271865',1,0,'2022-03-03 12:58:19','2022-03-03 12:58:19'),(70109,200,'Raiganj','271830',1,0,'2022-03-03 12:58:19','2022-03-03 12:58:19'),(70110,200,'Raipur','271851',1,0,'2022-03-03 12:58:19','2022-03-03 12:58:19'),(70111,200,'Raipur','271875',1,0,'2022-03-03 12:58:19','2022-03-03 12:58:19'),(70112,200,'Raipura','271902',1,0,'2022-03-03 12:58:19','2022-03-03 12:58:19'),(70113,200,'Rajapur Kala','271865',1,0,'2022-03-03 12:58:19','2022-03-03 12:58:19'),(70114,200,'Rajapur Kalan','271851',1,0,'2022-03-03 12:58:19','2022-03-03 12:58:19'),(70115,200,'Ram Nagar Semara','271865',1,0,'2022-03-03 12:58:19','2022-03-03 12:58:19'),(70116,200,'Ramgarhi','271902',1,0,'2022-03-03 12:58:20','2022-03-03 12:58:20'),(70117,200,'Ramnagar Khajuri','271871',1,0,'2022-03-03 12:58:20','2022-03-03 12:58:20'),(70118,200,'Rampur Dhobia','271830',1,0,'2022-03-03 12:58:20','2022-03-03 12:58:20'),(70119,200,'Rampurwa','271825',1,0,'2022-03-03 12:58:20','2022-03-03 12:58:20'),(70120,200,'Rani Ganj','271904',1,0,'2022-03-03 12:58:20','2022-03-03 12:58:20'),(70121,200,'Raniapur Gobrahi','271821',1,0,'2022-03-03 12:58:20','2022-03-03 12:58:20'),(70122,200,'Rehuwa Mansoor','271824',1,0,'2022-03-03 12:58:20','2022-03-03 12:58:20'),(70123,200,'Reoli','271802',1,0,'2022-03-03 12:58:20','2022-03-03 12:58:20'),(70124,200,'Risia','271875',1,0,'2022-03-03 12:58:20','2022-03-03 12:58:20'),(70125,200,'Rupaidiha','271881',1,0,'2022-03-03 12:58:20','2022-03-03 12:58:20'),(70126,200,'Sablapur','271825',1,0,'2022-03-03 12:58:20','2022-03-03 12:58:20'),(70127,200,'Sadhuwapur','271824',1,0,'2022-03-03 12:58:20','2022-03-03 12:58:20'),(70128,200,'Sangwa','271855',1,0,'2022-03-03 12:58:20','2022-03-03 12:58:20'),(70129,200,'Saraa Kalan','271855',1,0,'2022-03-03 12:58:20','2022-03-03 12:58:20'),(70130,200,'Sarai Jagna','271902',1,0,'2022-03-03 12:58:20','2022-03-03 12:58:20'),(70131,200,'Sarra Maundri','271865',1,0,'2022-03-03 12:58:20','2022-03-03 12:58:20'),(70132,200,'Sarraiya','271865',1,0,'2022-03-03 12:58:20','2022-03-03 12:58:20'),(70133,200,'Sarsa','271870',1,0,'2022-03-03 12:58:20','2022-03-03 12:58:20'),(70134,200,'Sasia Chunamani','271825',1,0,'2022-03-03 12:58:20','2022-03-03 12:58:20'),(70135,200,'Satpediya','271870',1,0,'2022-03-03 12:58:20','2022-03-03 12:58:20'),(70136,200,'Semari Bazar','271855',1,0,'2022-03-03 12:58:20','2022-03-03 12:58:20'),(70137,200,'Semariyawan','271871',1,0,'2022-03-03 12:58:20','2022-03-03 12:58:20'),(70138,200,'Shahpur Kalan','271855',1,0,'2022-03-03 12:58:20','2022-03-03 12:58:20'),(70139,200,'Shankarpur','271875',1,0,'2022-03-03 12:58:20','2022-03-03 12:58:20'),(70140,200,'Shankarpur Laxmanpur','271851',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70141,200,'Shekhdahir','271802',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70142,200,'Shivdaha','271871',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70143,200,'Shivpur Bairagi','271821',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70144,200,'Shivpur (Bahraich)','271830',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70145,200,'Shukulpurwa','271902',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70146,200,'Sikandarpur','271824',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70147,200,'Singhpur','271872',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70148,200,'Sohariyawan','271821',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70149,200,'Soharwa','271875',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70150,200,'Sohbatia','271830',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70151,200,'Sujauli','271841',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70152,200,'Sutaouli','271903',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70153,200,'Tallab Baghel','271871',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70154,200,'Tandwabasantpur','271825',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70155,200,'Tappah Sipah','271901',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70156,200,'Tendwa Mahant','271902',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70157,200,'Tiwari Gaon','271865',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70158,200,'Turahni Rajjab','271802',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70159,200,'Umari','271903',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70160,200,'Umaria','271865',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70161,200,'Urra Bazar','271855',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70162,200,'Vairi Maheshpur','271903',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70163,200,'Vanshpurwa','271851',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70164,201,'Achalgarh','277209',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70165,201,'Agrauli','277401',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70166,201,'Akhar','277401',1,0,'2022-03-03 12:58:21','2022-03-03 12:58:21'),(70167,201,'Akhop','221715',1,0,'2022-03-03 12:58:22','2022-03-03 12:58:22'),(70168,201,'Akhtiyarpur','221713',1,0,'2022-03-03 12:58:22','2022-03-03 12:58:22'),(70169,201,'Amahara','221712',1,0,'2022-03-03 12:58:22','2022-03-03 12:58:22'),(70170,201,'Amaharpatti Uttar','221712',1,0,'2022-03-03 12:58:22','2022-03-03 12:58:22'),(70171,201,'Amaon','277501',1,0,'2022-03-03 12:58:22','2022-03-03 12:58:22'),(70172,201,'Amghat','277203',1,0,'2022-03-03 12:58:22','2022-03-03 12:58:22'),(70173,201,'Anjorpur','277502',1,0,'2022-03-03 12:58:22','2022-03-03 12:58:22'),(70174,201,'Apail','277304',1,0,'2022-03-03 12:58:22','2022-03-03 12:58:22'),(70175,201,'Asan','277302',1,0,'2022-03-03 12:58:22','2022-03-03 12:58:22'),(70176,201,'Asanwar','221701',1,0,'2022-03-03 12:58:22','2022-03-03 12:58:22'),(70177,201,'Atarsua','221712',1,0,'2022-03-03 12:58:22','2022-03-03 12:58:22'),(70178,201,'Athialapura','221712',1,0,'2022-03-03 12:58:22','2022-03-03 12:58:22'),(70179,201,'Atrauli','221711',1,0,'2022-03-03 12:58:22','2022-03-03 12:58:22'),(70180,201,'Aundi','221701',1,0,'2022-03-03 12:58:22','2022-03-03 12:58:22'),(70181,201,'Auria Kalan','221716',1,0,'2022-03-03 12:58:22','2022-03-03 12:58:22'),(70182,201,'Awayen','221715',1,0,'2022-03-03 12:58:22','2022-03-03 12:58:22'),(70183,201,'Babhanauli','221716',1,0,'2022-03-03 12:58:22','2022-03-03 12:58:22'),(70184,201,'Babubel','277402',1,0,'2022-03-03 12:58:22','2022-03-03 12:58:22'),(70185,201,'Bachhaipur','221711',1,0,'2022-03-03 12:58:22','2022-03-03 12:58:22'),(70186,201,'Bachhapar','277303',1,0,'2022-03-03 12:58:22','2022-03-03 12:58:22'),(70187,201,'Baghaunch','277402',1,0,'2022-03-03 12:58:22','2022-03-03 12:58:22'),(70188,201,'Baghuna','277501',1,0,'2022-03-03 12:58:22','2022-03-03 12:58:22'),(70189,201,'Baghuri','221717',1,0,'2022-03-03 12:58:22','2022-03-03 12:58:22'),(70190,201,'Bahadura','277207',1,0,'2022-03-03 12:58:22','2022-03-03 12:58:22'),(70191,201,'Baheri (Ballia)','277001',1,0,'2022-03-03 12:58:22','2022-03-03 12:58:22'),(70192,201,'Bahorawan','221716',1,0,'2022-03-03 12:58:22','2022-03-03 12:58:22'),(70193,201,'Bahuara','277216',1,0,'2022-03-03 12:58:23','2022-03-03 12:58:23'),(70194,201,'Bahuta Chak Upadhyay','221715',1,0,'2022-03-03 12:58:23','2022-03-03 12:58:23'),(70195,201,'Baijalpur','221712',1,0,'2022-03-03 12:58:23','2022-03-03 12:58:23'),(70196,201,'Bairia (Ballia)','277201',1,0,'2022-03-03 12:58:23','2022-03-03 12:58:23'),(70197,201,'Bakawan','277202',1,0,'2022-03-03 12:58:23','2022-03-03 12:58:23'),(70198,201,'Balesara','277121',1,0,'2022-03-03 12:58:23','2022-03-03 12:58:23'),(70199,201,'Balihar','277205',1,0,'2022-03-03 12:58:23','2022-03-03 12:58:23'),(70200,201,'Ballia City','277001',1,0,'2022-03-03 12:58:23','2022-03-03 12:58:23'),(70201,201,'Ballia H.O','277001',1,0,'2022-03-03 12:58:23','2022-03-03 12:58:23'),(70202,201,'Balupur','277303',1,0,'2022-03-03 12:58:23','2022-03-03 12:58:23'),(70203,201,'Banahra','277303',1,0,'2022-03-03 12:58:23','2022-03-03 12:58:23'),(70204,201,'Bansdih Road','277203',1,0,'2022-03-03 12:58:23','2022-03-03 12:58:23'),(70205,201,'Bansdih','277202',1,0,'2022-03-03 12:58:23','2022-03-03 12:58:23'),(70206,201,'Banspar Bahorwa','221715',1,0,'2022-03-03 12:58:23','2022-03-03 12:58:23'),(70207,201,'Bara Gaon','277302',1,0,'2022-03-03 12:58:23','2022-03-03 12:58:23'),(70208,201,'Barasari Jageer','277207',1,0,'2022-03-03 12:58:23','2022-03-03 12:58:23'),(70209,201,'Barauli','221716',1,0,'2022-03-03 12:58:23','2022-03-03 12:58:23'),(70210,201,'Barawan Ratipatti','221716',1,0,'2022-03-03 12:58:23','2022-03-03 12:58:23'),(70211,201,'Barhwalia','221713',1,0,'2022-03-03 12:58:23','2022-03-03 12:58:23'),(70212,201,'Basantpur (Ballia)','277301',1,0,'2022-03-03 12:58:23','2022-03-03 12:58:23'),(70213,201,'Basarik Pah','277001',1,0,'2022-03-03 12:58:23','2022-03-03 12:58:23'),(70214,201,'Belahari','277403',1,0,'2022-03-03 12:58:23','2022-03-03 12:58:23'),(70215,201,'Beruarbari','277304',1,0,'2022-03-03 12:58:23','2022-03-03 12:58:23'),(70216,201,'Bhagwanpur','277201',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70217,201,'Bharakhara','277304',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70218,201,'Bharauli','277501',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70219,201,'Bharsar','277401',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70220,201,'Bharthaon','221717',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70221,201,'Bhelai','221712',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70222,201,'Bhikharia','277207',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70223,201,'Bhimpura','221716',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70224,201,'Bhimpura','221711',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70225,201,'Bhojchapra','277209',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70226,201,'Bhopalpur','277209',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70227,201,'Bhriguashram','277001',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70228,201,'Bhujaini','221716',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70229,201,'Bigahi','277211',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70230,201,'Biharaharpur','221711',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70231,201,'Bilthara Bazar','221715',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70232,201,'Bilthra Road RS','221715',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70233,201,'Binaha','277211',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70234,201,'Birpura','221709',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70235,201,'Bisauli','277211',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70236,201,'Bisukia','277503',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70237,201,'Budhuan','277121',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70238,201,'Chachaya','221711',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70239,201,'Chainpur Gulaura','221715',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70240,201,'Chak Usaraila','277124',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70241,201,'Chakia','277208',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70242,201,'Chand Diar','277214',1,0,'2022-03-03 12:58:24','2022-03-03 12:58:24'),(70243,201,'Chandadih','221715',1,0,'2022-03-03 12:58:25','2022-03-03 12:58:25'),(70244,201,'Chandi','221711',1,0,'2022-03-03 12:58:25','2022-03-03 12:58:25'),(70245,201,'Chandpur','277201',1,0,'2022-03-03 12:58:25','2022-03-03 12:58:25'),(70246,201,'Chandrawar','221712',1,0,'2022-03-03 12:58:25','2022-03-03 12:58:25'),(70247,201,'Charauan','221718',1,0,'2022-03-03 12:58:25','2022-03-03 12:58:25'),(70248,201,'Charawan Barwan','277303',1,0,'2022-03-03 12:58:25','2022-03-03 12:58:25'),(70249,201,'Chaura','277502',1,0,'2022-03-03 12:58:25','2022-03-03 12:58:25'),(70250,201,'Cherueyan','277503',1,0,'2022-03-03 12:58:25','2022-03-03 12:58:25'),(70251,201,'Chetankishor','277303',1,0,'2022-03-03 12:58:25','2022-03-03 12:58:25'),(70252,201,'Chhata (Ballia)','277210',1,0,'2022-03-03 12:58:25','2022-03-03 12:58:25'),(70253,201,'Chheridih','277209',1,0,'2022-03-03 12:58:25','2022-03-03 12:58:25'),(70254,201,'Chhibbi','221701',1,0,'2022-03-03 12:58:25','2022-03-03 12:58:25'),(70255,201,'Chhotaki Seriya','277210',1,0,'2022-03-03 12:58:25','2022-03-03 12:58:25'),(70256,201,'Chilkahar','221701',1,0,'2022-03-03 12:58:25','2022-03-03 12:58:25'),(70257,201,'Chintamanpur','221712',1,0,'2022-03-03 12:58:25','2022-03-03 12:58:25'),(70258,201,'Chitbaragaon','221713',1,0,'2022-03-03 12:58:25','2022-03-03 12:58:25'),(70259,201,'Chnd Pur','277211',1,0,'2022-03-03 12:58:25','2022-03-03 12:58:25'),(70260,201,'Civillines','277001',1,0,'2022-03-03 12:58:25','2022-03-03 12:58:25'),(70261,201,'Dalchapra','277209',1,0,'2022-03-03 12:58:25','2022-03-03 12:58:25'),(70262,201,'Dallan Chhapra','277204',1,0,'2022-03-03 12:58:25','2022-03-03 12:58:25'),(70263,201,'Daulatpur','221713',1,0,'2022-03-03 12:58:25','2022-03-03 12:58:25'),(70264,201,'Dawani','277203',1,0,'2022-03-03 12:58:25','2022-03-03 12:58:25'),(70265,201,'Daya Chhapra','277205',1,0,'2022-03-03 12:58:25','2022-03-03 12:58:25'),(70266,201,'Deodih','277202',1,0,'2022-03-03 12:58:25','2022-03-03 12:58:25'),(70267,201,'Deokali','221717',1,0,'2022-03-03 12:58:25','2022-03-03 12:58:25'),(70268,201,'Deokali','277001',1,0,'2022-03-03 12:58:26','2022-03-03 12:58:26'),(70269,201,'Deoriha','221711',1,0,'2022-03-03 12:58:26','2022-03-03 12:58:26'),(70270,201,'Dhanauti','277304',1,0,'2022-03-03 12:58:26','2022-03-03 12:58:26'),(70271,201,'Dhoridih','221717',1,0,'2022-03-03 12:58:26','2022-03-03 12:58:26'),(70272,201,'Dighar','277403',1,0,'2022-03-03 12:58:26','2022-03-03 12:58:26'),(70273,201,'Dihwa','221711',1,0,'2022-03-03 12:58:26','2022-03-03 12:58:26'),(70274,201,'Dokati','277204',1,0,'2022-03-03 12:58:26','2022-03-03 12:58:26'),(70275,201,'Dubey Chhapra','277205',1,0,'2022-03-03 12:58:26','2022-03-03 12:58:26'),(70276,201,'Dubhar','277401',1,0,'2022-03-03 12:58:26','2022-03-03 12:58:26'),(70277,201,'Dudhaila Kalan','277403',1,0,'2022-03-03 12:58:26','2022-03-03 12:58:26'),(70278,201,'Duhabihra','221717',1,0,'2022-03-03 12:58:26','2022-03-03 12:58:26'),(70279,201,'Dumari','221701',1,0,'2022-03-03 12:58:26','2022-03-03 12:58:26'),(70280,201,'Dumari','277203',1,0,'2022-03-03 12:58:26','2022-03-03 12:58:26'),(70281,201,'Dumariya','277211',1,0,'2022-03-03 12:58:26','2022-03-03 12:58:26'),(70282,201,'Durjanpur','277208',1,0,'2022-03-03 12:58:26','2022-03-03 12:58:26'),(70283,201,'Ekail','221711',1,0,'2022-03-03 12:58:26','2022-03-03 12:58:26'),(70284,201,'Farsatar','221715',1,0,'2022-03-03 12:58:26','2022-03-03 12:58:26'),(70285,201,'Gaighat','277209',1,0,'2022-03-03 12:58:26','2022-03-03 12:58:26'),(70286,201,'Gangapur','277205',1,0,'2022-03-03 12:58:26','2022-03-03 12:58:26'),(70287,201,'Garhmalpur','221709',1,0,'2022-03-03 12:58:26','2022-03-03 12:58:26'),(70288,201,'Garwar','277121',1,0,'2022-03-03 12:58:26','2022-03-03 12:58:26'),(70289,201,'Gauapar','221718',1,0,'2022-03-03 12:58:26','2022-03-03 12:58:26'),(70290,201,'Gonhia Chapra','277208',1,0,'2022-03-03 12:58:26','2022-03-03 12:58:26'),(70291,201,'Gopalnagar','277208',1,0,'2022-03-03 12:58:26','2022-03-03 12:58:26'),(70292,201,'Gopalpur','221701',1,0,'2022-03-03 12:58:26','2022-03-03 12:58:26'),(70293,201,'Gosain Pur','277303',1,0,'2022-03-03 12:58:27','2022-03-03 12:58:27'),(70294,201,'Gothain','221711',1,0,'2022-03-03 12:58:27','2022-03-03 12:58:27'),(70295,201,'Govindpur','221716',1,0,'2022-03-03 12:58:27','2022-03-03 12:58:27'),(70296,201,'Hajauli','221701',1,0,'2022-03-03 12:58:27','2022-03-03 12:58:27'),(70297,201,'Haldi Rampur','221715',1,0,'2022-03-03 12:58:27','2022-03-03 12:58:27'),(70298,201,'Haldi (Ballia)','277402',1,0,'2022-03-03 12:58:27','2022-03-03 12:58:27'),(70299,201,'Halpur','277213',1,0,'2022-03-03 12:58:27','2022-03-03 12:58:27'),(70300,201,'Hanumanganj','277001',1,0,'2022-03-03 12:58:27','2022-03-03 12:58:27'),(70301,201,'Hardattpur','277202',1,0,'2022-03-03 12:58:27','2022-03-03 12:58:27'),(70302,201,'Hariahan Kalan','277209',1,0,'2022-03-03 12:58:27','2022-03-03 12:58:27'),(70303,201,'Hariharpur','277401',1,0,'2022-03-03 12:58:27','2022-03-03 12:58:27'),(70304,201,'Hathaunj','277302',1,0,'2022-03-03 12:58:27','2022-03-03 12:58:27'),(70305,201,'Husainabad','277219',1,0,'2022-03-03 12:58:27','2022-03-03 12:58:27'),(70306,201,'Ibrahima Bad','277208',1,0,'2022-03-03 12:58:27','2022-03-03 12:58:27'),(70307,201,'Ibrahimabad Uprwar','277214',1,0,'2022-03-03 12:58:27','2022-03-03 12:58:27'),(70308,201,'Ibrahimpatti','221716',1,0,'2022-03-03 12:58:27','2022-03-03 12:58:27'),(70309,201,'Indauli','221715',1,0,'2022-03-03 12:58:27','2022-03-03 12:58:27'),(70310,201,'Inds0','221711',1,0,'2022-03-03 12:58:27','2022-03-03 12:58:27'),(70311,201,'Isari Salempur','221709',1,0,'2022-03-03 12:58:27','2022-03-03 12:58:27'),(70312,201,'Isarpitha Patti','221717',1,0,'2022-03-03 12:58:27','2022-03-03 12:58:27'),(70313,201,'Jagadara','277124',1,0,'2022-03-03 12:58:27','2022-03-03 12:58:27'),(70314,201,'Jagdeva','277201',1,0,'2022-03-03 12:58:27','2022-03-03 12:58:27'),(70315,201,'Jagdishpur (Ballia)','277001',1,0,'2022-03-03 12:58:27','2022-03-03 12:58:27'),(70316,201,'Jai Prakash Nagar','277204',1,0,'2022-03-03 12:58:27','2022-03-03 12:58:27'),(70317,201,'Jajauli','221717',1,0,'2022-03-03 12:58:27','2022-03-03 12:58:27'),(70318,201,'Jajauli No-2','221716',1,0,'2022-03-03 12:58:27','2022-03-03 12:58:27'),(70319,201,'Jam','221712',1,0,'2022-03-03 12:58:28','2022-03-03 12:58:28'),(70320,201,'Jamalpur','277208',1,0,'2022-03-03 12:58:28','2022-03-03 12:58:28'),(70321,201,'Jamuaon','221718',1,0,'2022-03-03 12:58:28','2022-03-03 12:58:28'),(70322,201,'Jamui','221717',1,0,'2022-03-03 12:58:28','2022-03-03 12:58:28'),(70323,201,'Janari','277401',1,0,'2022-03-03 12:58:28','2022-03-03 12:58:28'),(70324,201,'Janaupur','277123',1,0,'2022-03-03 12:58:28','2022-03-03 12:58:28'),(70325,201,'Jawahi','277402',1,0,'2022-03-03 12:58:28','2022-03-03 12:58:28'),(70326,201,'Jawahi Dear','277402',1,0,'2022-03-03 12:58:28','2022-03-03 12:58:28'),(70327,201,'Jharkataha','277209',1,0,'2022-03-03 12:58:28','2022-03-03 12:58:28'),(70328,201,'Jigini','277121',1,0,'2022-03-03 12:58:28','2022-03-03 12:58:28'),(70329,201,'Jigirasand','277302',1,0,'2022-03-03 12:58:28','2022-03-03 12:58:28'),(70330,201,'Jiutpura','221715',1,0,'2022-03-03 12:58:28','2022-03-03 12:58:28'),(70331,201,'Kaithauli','277202',1,0,'2022-03-03 12:58:28','2022-03-03 12:58:28'),(70332,201,'Kajhari','221701',1,0,'2022-03-03 12:58:28','2022-03-03 12:58:28'),(70333,201,'Kanchanpur','277403',1,0,'2022-03-03 12:58:28','2022-03-03 12:58:28'),(70334,201,'Karammar','277304',1,0,'2022-03-03 12:58:28','2022-03-03 12:58:28'),(70335,201,'Karanchhapa','277214',1,0,'2022-03-03 12:58:28','2022-03-03 12:58:28'),(70336,201,'Karmanpur','277208',1,0,'2022-03-03 12:58:28','2022-03-03 12:58:28'),(70337,201,'Karmauta','277303',1,0,'2022-03-03 12:58:28','2022-03-03 12:58:28'),(70338,201,'Karnai','277304',1,0,'2022-03-03 12:58:28','2022-03-03 12:58:28'),(70339,201,'Karon','221713',1,0,'2022-03-03 12:58:28','2022-03-03 12:58:28'),(70340,201,'Karsi','221717',1,0,'2022-03-03 12:58:28','2022-03-03 12:58:28'),(70341,201,'Kasoundar','221716',1,0,'2022-03-03 12:58:28','2022-03-03 12:58:28'),(70342,201,'Katharia','221713',1,0,'2022-03-03 12:58:28','2022-03-03 12:58:28'),(70343,201,'Kathaura','221717',1,0,'2022-03-03 12:58:28','2022-03-03 12:58:28'),(70344,201,'Kazipur','277303',1,0,'2022-03-03 12:58:29','2022-03-03 12:58:29'),(70345,201,'Kewara','277210',1,0,'2022-03-03 12:58:29','2022-03-03 12:58:29'),(70346,201,'Khandwa','221718',1,0,'2022-03-03 12:58:29','2022-03-03 12:58:29'),(70347,201,'Khanwar','221711',1,0,'2022-03-03 12:58:29','2022-03-03 12:58:29'),(70348,201,'Kharahatar','277121',1,0,'2022-03-03 12:58:29','2022-03-03 12:58:29'),(70349,201,'Kharasara','277302',1,0,'2022-03-03 12:58:29','2022-03-03 12:58:29'),(70350,201,'Kharauni','277219',1,0,'2022-03-03 12:58:29','2022-03-03 12:58:29'),(70351,201,'Khari','221709',1,0,'2022-03-03 12:58:29','2022-03-03 12:58:29'),(70352,201,'Kharuaon','221712',1,0,'2022-03-03 12:58:29','2022-03-03 12:58:29'),(70353,201,'Khathghara','221717',1,0,'2022-03-03 12:58:29','2022-03-03 12:58:29'),(70354,201,'Khejuri','277302',1,0,'2022-03-03 12:58:29','2022-03-03 12:58:29'),(70355,201,'Kheosar','277219',1,0,'2022-03-03 12:58:29','2022-03-03 12:58:29'),(70356,201,'Khoripakar','277001',1,0,'2022-03-03 12:58:29','2022-03-03 12:58:29'),(70357,201,'Kidihirapur','221716',1,0,'2022-03-03 12:58:29','2022-03-03 12:58:29'),(70358,201,'Kirtupur','277219',1,0,'2022-03-03 12:58:29','2022-03-03 12:58:29'),(70359,201,'Kodahara Uparwar','277204',1,0,'2022-03-03 12:58:29','2022-03-03 12:58:29'),(70360,201,'Kodai','221711',1,0,'2022-03-03 12:58:29','2022-03-03 12:58:29'),(70361,201,'Kopawan','221701',1,0,'2022-03-03 12:58:29','2022-03-03 12:58:29'),(70362,201,'Korantadih','277501',1,0,'2022-03-03 12:58:29','2022-03-03 12:58:29'),(70363,201,'Koth','221717',1,0,'2022-03-03 12:58:29','2022-03-03 12:58:29'),(70364,201,'Kotwa Narayenpur','277501',1,0,'2022-03-03 12:58:29','2022-03-03 12:58:29'),(70365,201,'Kotwari','221712',1,0,'2022-03-03 12:58:29','2022-03-03 12:58:29'),(70366,201,'Kummhaila','277301',1,0,'2022-03-03 12:58:29','2022-03-03 12:58:29'),(70367,201,'Kundail','221715',1,0,'2022-03-03 12:58:29','2022-03-03 12:58:29'),(70368,201,'Kurejee','277121',1,0,'2022-03-03 12:58:29','2022-03-03 12:58:29'),(70369,201,'Kurem','221712',1,0,'2022-03-03 12:58:30','2022-03-03 12:58:30'),(70370,201,'Kusaura','277211',1,0,'2022-03-03 12:58:30','2022-03-03 12:58:30'),(70371,201,'Kusauri','277209',1,0,'2022-03-03 12:58:30','2022-03-03 12:58:30'),(70372,201,'Lahasani','221711',1,0,'2022-03-03 12:58:30','2022-03-03 12:58:30'),(70373,201,'Lalganj (Ballia)','277216',1,0,'2022-03-03 12:58:30','2022-03-03 12:58:30'),(70374,201,'Laxman Chapra','277214',1,0,'2022-03-03 12:58:30','2022-03-03 12:58:30'),(70375,201,'Lilkar','277303',1,0,'2022-03-03 12:58:30','2022-03-03 12:58:30'),(70376,201,'Madhubani','277208',1,0,'2022-03-03 12:58:30','2022-03-03 12:58:30'),(70377,201,'Maharajpur','221712',1,0,'2022-03-03 12:58:30','2022-03-03 12:58:30'),(70378,201,'Mahari','221716',1,0,'2022-03-03 12:58:30','2022-03-03 12:58:30'),(70379,201,'Mairitar','277202',1,0,'2022-03-03 12:58:30','2022-03-03 12:58:30'),(70380,201,'Majhauli','277203',1,0,'2022-03-03 12:58:30','2022-03-03 12:58:30'),(70381,201,'Majhua','277403',1,0,'2022-03-03 12:58:30','2022-03-03 12:58:30'),(70382,201,'Malapharsenpur','221711',1,0,'2022-03-03 12:58:30','2022-03-03 12:58:30'),(70383,201,'Malhaua Chorkaind','277213',1,0,'2022-03-03 12:58:30','2022-03-03 12:58:30'),(70384,201,'Maniar','277207',1,0,'2022-03-03 12:58:30','2022-03-03 12:58:30'),(70385,201,'Manikpur','277207',1,0,'2022-03-03 12:58:30','2022-03-03 12:58:30'),(70386,201,'Masoompur','277303',1,0,'2022-03-03 12:58:30','2022-03-03 12:58:30'),(70387,201,'Middha','277506',1,0,'2022-03-03 12:58:30','2022-03-03 12:58:30'),(70388,201,'Mohammadpur','221716',1,0,'2022-03-03 12:58:30','2022-03-03 12:58:30'),(70389,201,'Moonchapra','277209',1,0,'2022-03-03 12:58:30','2022-03-03 12:58:30'),(70390,201,'Mundera','221712',1,0,'2022-03-03 12:58:30','2022-03-03 12:58:30'),(70391,201,'Muradih','277209',1,0,'2022-03-03 12:58:30','2022-03-03 12:58:30'),(70392,201,'Muriyari','277207',1,0,'2022-03-03 12:58:30','2022-03-03 12:58:30'),(70393,201,'Murli Chhapra','277204',1,0,'2022-03-03 12:58:31','2022-03-03 12:58:31'),(70394,201,'Nagahar','221712',1,0,'2022-03-03 12:58:31','2022-03-03 12:58:31'),(70395,201,'Nagpur','221712',1,0,'2022-03-03 12:58:31','2022-03-03 12:58:31'),(70396,201,'Nagra (Ballia)','221711',1,0,'2022-03-03 12:58:31','2022-03-03 12:58:31'),(70397,201,'Nagwa','277401',1,0,'2022-03-03 12:58:31','2022-03-03 12:58:31'),(70398,201,'Nanaura','221711',1,0,'2022-03-03 12:58:31','2022-03-03 12:58:31'),(70399,201,'Nanhul','277303',1,0,'2022-03-03 12:58:31','2022-03-03 12:58:31'),(70400,201,'Naraon','221701',1,0,'2022-03-03 12:58:31','2022-03-03 12:58:31'),(70401,201,'Narayengarh','277208',1,0,'2022-03-03 12:58:31','2022-03-03 12:58:31'),(70402,201,'Narhi','221711',1,0,'2022-03-03 12:58:31','2022-03-03 12:58:31'),(70403,201,'Narhi','277502',1,0,'2022-03-03 12:58:31','2022-03-03 12:58:31'),(70404,201,'Nasirpurkalan','221713',1,0,'2022-03-03 12:58:31','2022-03-03 12:58:31'),(70405,201,'Nawanagar (Ballia)','221717',1,0,'2022-03-03 12:58:31','2022-03-03 12:58:31'),(70406,201,'Nawapura','221712',1,0,'2022-03-03 12:58:31','2022-03-03 12:58:31'),(70407,201,'Nikasi','221711',1,0,'2022-03-03 12:58:31','2022-03-03 12:58:31'),(70408,201,'Pachkhora','277123',1,0,'2022-03-03 12:58:31','2022-03-03 12:58:31'),(70409,201,'Pakari','277124',1,0,'2022-03-03 12:58:31','2022-03-03 12:58:31'),(70410,201,'Palia Khas','221718',1,0,'2022-03-03 12:58:31','2022-03-03 12:58:31'),(70411,201,'Pandah','277303',1,0,'2022-03-03 12:58:31','2022-03-03 12:58:31'),(70412,201,'Pandey Pur','277201',1,0,'2022-03-03 12:58:31','2022-03-03 12:58:31'),(70413,201,'Panicha','277302',1,0,'2022-03-03 12:58:32','2022-03-03 12:58:32'),(70414,201,'Parasia','221712',1,0,'2022-03-03 12:58:32','2022-03-03 12:58:32'),(70415,201,'Parasia','221711',1,0,'2022-03-03 12:58:32','2022-03-03 12:58:32'),(70416,201,'Parvatpur','277219',1,0,'2022-03-03 12:58:32','2022-03-03 12:58:32'),(70417,201,'Pasuhari','221715',1,0,'2022-03-03 12:58:32','2022-03-03 12:58:32'),(70418,201,'Patoi','221716',1,0,'2022-03-03 12:58:32','2022-03-03 12:58:32'),(70419,201,'Phehpana','277503',1,0,'2022-03-03 12:58:32','2022-03-03 12:58:32'),(70420,201,'Piparauli','221715',1,0,'2022-03-03 12:58:32','2022-03-03 12:58:32'),(70421,201,'Piprakal;a','277504',1,0,'2022-03-03 12:58:32','2022-03-03 12:58:32'),(70422,201,'Piyaraunta','277403',1,0,'2022-03-03 12:58:32','2022-03-03 12:58:32'),(70423,201,'Pradhanpur','221712',1,0,'2022-03-03 12:58:32','2022-03-03 12:58:32'),(70424,201,'Prasadpur','277124',1,0,'2022-03-03 12:58:32','2022-03-03 12:58:32'),(70425,201,'Pur (Ballia)','277124',1,0,'2022-03-03 12:58:32','2022-03-03 12:58:32'),(70426,201,'Puras','277211',1,0,'2022-03-03 12:58:32','2022-03-03 12:58:32'),(70427,201,'Rachauli','221718',1,0,'2022-03-03 12:58:32','2022-03-03 12:58:32'),(70428,201,'Raghunath Pur Piparpatti','277001',1,0,'2022-03-03 12:58:32','2022-03-03 12:58:32'),(70429,201,'Rajpur','277202',1,0,'2022-03-03 12:58:32','2022-03-03 12:58:32'),(70430,201,'Ram Nagar','277204',1,0,'2022-03-03 12:58:32','2022-03-03 12:58:32'),(70431,201,'Ramgarh','277501',1,0,'2022-03-03 12:58:32','2022-03-03 12:58:32'),(70432,201,'Rampur','277207',1,0,'2022-03-03 12:58:32','2022-03-03 12:58:32'),(70433,201,'Rampur','221712',1,0,'2022-03-03 12:58:32','2022-03-03 12:58:32'),(70434,201,'Rampur Chit','277502',1,0,'2022-03-03 12:58:32','2022-03-03 12:58:32'),(70435,201,'Rampur Kanungoa','221718',1,0,'2022-03-03 12:58:32','2022-03-03 12:58:32'),(70436,201,'Raniganj Bazar','277208',1,0,'2022-03-03 12:58:32','2022-03-03 12:58:32'),(70437,201,'Rasoolpur','221712',1,0,'2022-03-03 12:58:32','2022-03-03 12:58:32'),(70438,201,'Rasra H.O','221712',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70439,201,'Rasra Town','221712',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70440,201,'Ratsar','277123',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70441,201,'Ratsi Mehmanpur','221709',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70442,201,'Reoti','277209',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70443,201,'Repura','277401',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70444,201,'Rohuan','277211',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70445,201,'Rudrapur','277402',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70446,201,'Rudrawar','221717',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70447,201,'Rupwar Bhagwanpur','221718',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70448,201,'Sagarpali','277506',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70449,201,'Saharaspali','277001',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70450,201,'Sahatwar','277211',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70451,201,'Sahodih','277210',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70452,201,'Sakarpura','277213',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70453,201,'Salempur','277203',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70454,201,'Sanwara','221701',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70455,201,'Sanwaru Bandh','277001',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70456,201,'Saraya','277121',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70457,201,'Saraybharti','221712',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70458,201,'Sardaspur','221712',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70459,201,'Sarya Bagdaura','221709',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70460,201,'Sarya Dihu Bhagat','221715',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70461,201,'Sawan','277123',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70462,201,'Sawan Chapra','277216',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70463,201,'Semaria','277216',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70464,201,'Semaria','221716',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70465,201,'Shahidpark','277001',1,0,'2022-03-03 12:58:33','2022-03-03 12:58:33'),(70466,201,'Shahpur','277121',1,0,'2022-03-03 12:58:34','2022-03-03 12:58:34'),(70467,201,'Sher','277203',1,0,'2022-03-03 12:58:34','2022-03-03 12:58:34'),(70468,201,'Shivpur Datiwar','277301',1,0,'2022-03-03 12:58:34','2022-03-03 12:58:34'),(70469,201,'Shivpur Dier','277401',1,0,'2022-03-03 12:58:34','2022-03-03 12:58:34'),(70470,201,'Shobha Chapra','277214',1,0,'2022-03-03 12:58:34','2022-03-03 12:58:34'),(70471,201,'Sikanderpur Bus Stand','277303',1,0,'2022-03-03 12:58:34','2022-03-03 12:58:34'),(70472,201,'Sikanderpur (Ballia)','277303',1,0,'2022-03-03 12:58:34','2022-03-03 12:58:34'),(70473,201,'Sikarhata','221718',1,0,'2022-03-03 12:58:34','2022-03-03 12:58:34'),(70474,201,'Sikariyan Kalan','277123',1,0,'2022-03-03 12:58:34','2022-03-03 12:58:34'),(70475,201,'Singhpur','277503',1,0,'2022-03-03 12:58:34','2022-03-03 12:58:34'),(70476,201,'Sinhachawar','221701',1,0,'2022-03-03 12:58:34','2022-03-03 12:58:34'),(70477,201,'Sisotar','277303',1,0,'2022-03-03 12:58:34','2022-03-03 12:58:34'),(70478,201,'Siswar','221712',1,0,'2022-03-03 12:58:34','2022-03-03 12:58:34'),(70479,201,'Sisyandkala','221718',1,0,'2022-03-03 12:58:34','2022-03-03 12:58:34'),(70480,201,'Sitakund','277001',1,0,'2022-03-03 12:58:34','2022-03-03 12:58:34'),(70481,201,'Siwankala','277303',1,0,'2022-03-03 12:58:34','2022-03-03 12:58:34'),(70482,201,'Sohaon','277504',1,0,'2022-03-03 12:58:34','2022-03-03 12:58:34'),(70483,201,'Sonadih','221715',1,0,'2022-03-03 12:58:34','2022-03-03 12:58:34'),(70484,201,'Sonaki Bhat','277204',1,0,'2022-03-03 12:58:34','2022-03-03 12:58:34'),(70485,201,'Sonbarsa','277208',1,0,'2022-03-03 12:58:34','2022-03-03 12:58:34'),(70486,201,'Sonwani','277402',1,0,'2022-03-03 12:58:34','2022-03-03 12:58:34'),(70487,201,'Sri Nagar','277209',1,0,'2022-03-03 12:58:34','2022-03-03 12:58:34'),(70488,201,'Sripalpur','277216',1,0,'2022-03-03 12:58:34','2022-03-03 12:58:34'),(70489,201,'Sukhpura','277304',1,0,'2022-03-03 12:58:34','2022-03-03 12:58:34'),(70490,201,'Sultanpur','221711',1,0,'2022-03-03 12:58:35','2022-03-03 12:58:35'),(70491,201,'Sultanpur','277207',1,0,'2022-03-03 12:58:35','2022-03-03 12:58:35'),(70492,201,'Surahi','277504',1,0,'2022-03-03 12:58:35','2022-03-03 12:58:35'),(70493,201,'Suremanpur','277208',1,0,'2022-03-03 12:58:35','2022-03-03 12:58:35'),(70494,201,'Suryabhanpur','277216',1,0,'2022-03-03 12:58:35','2022-03-03 12:58:35'),(70495,201,'Suryapura','277301',1,0,'2022-03-03 12:58:35','2022-03-03 12:58:35'),(70496,201,'T.D.College','277001',1,0,'2022-03-03 12:58:35','2022-03-03 12:58:35'),(70497,201,'Tadi Bada Gaon','221711',1,0,'2022-03-03 12:58:35','2022-03-03 12:58:35'),(70498,201,'Takarsand','277001',1,0,'2022-03-03 12:58:35','2022-03-03 12:58:35'),(70499,201,'Takha','221709',1,0,'2022-03-03 12:58:35','2022-03-03 12:58:35'),(70500,201,'Telma','221718',1,0,'2022-03-03 12:58:35','2022-03-03 12:58:35'),(70501,201,'Tengarihi','277201',1,0,'2022-03-03 12:58:35','2022-03-03 12:58:35'),(70502,201,'Thamhanpura','277506',1,0,'2022-03-03 12:58:35','2022-03-03 12:58:35'),(70503,201,'Thohilpali','277124',1,0,'2022-03-03 12:58:35','2022-03-03 12:58:35'),(70504,201,'Tikadeori','221701',1,0,'2022-03-03 12:58:35','2022-03-03 12:58:35'),(70505,201,'Tikhampur','277001',1,0,'2022-03-03 12:58:35','2022-03-03 12:58:35'),(70506,201,'Triloknanda','221711',1,0,'2022-03-03 12:58:35','2022-03-03 12:58:35'),(70507,201,'Turtipar','221715',1,0,'2022-03-03 12:58:35','2022-03-03 12:58:35'),(70508,201,'Tutuwari','277501',1,0,'2022-03-03 12:58:35','2022-03-03 12:58:35'),(70509,201,'Ubhaon','221715',1,0,'2022-03-03 12:58:35','2022-03-03 12:58:35'),(70510,201,'Uchera','221701',1,0,'2022-03-03 12:58:35','2022-03-03 12:58:35'),(70511,201,'Udharan','221716',1,0,'2022-03-03 12:58:35','2022-03-03 12:58:35'),(70512,201,'Ukachhi','277124',1,0,'2022-03-03 12:58:35','2022-03-03 12:58:35'),(70513,201,'Usasa','277124',1,0,'2022-03-03 12:58:35','2022-03-03 12:58:35'),(70514,201,'Uskar','221716',1,0,'2022-03-03 12:58:36','2022-03-03 12:58:36'),(70515,201,'V.B.Narayanpur','277213',1,0,'2022-03-03 12:58:36','2022-03-03 12:58:36'),(70516,201,'Zeera Basti','277001',1,0,'2022-03-03 12:58:36','2022-03-03 12:58:36'),(70517,202,'Achkawapur','271215',1,0,'2022-03-03 12:58:36','2022-03-03 12:58:36'),(70518,202,'Adamtara','271215',1,0,'2022-03-03 12:58:36','2022-03-03 12:58:36'),(70519,202,'Alipur Bujurg','271604',1,0,'2022-03-03 12:58:36','2022-03-03 12:58:36'),(70520,202,'Amauli Dhamali','271206',1,0,'2022-03-03 12:58:36','2022-03-03 12:58:36'),(70521,202,'Amwabas','271203',1,0,'2022-03-03 12:58:36','2022-03-03 12:58:36'),(70522,202,'Badalpur','271205',1,0,'2022-03-03 12:58:36','2022-03-03 12:58:36'),(70523,202,'Badhara','271206',1,0,'2022-03-03 12:58:36','2022-03-03 12:58:36'),(70524,202,'Badhya Fareed Khan','271306',1,0,'2022-03-03 12:58:36','2022-03-03 12:58:36'),(70525,202,'Bahre Kuiya','271201',1,0,'2022-03-03 12:58:36','2022-03-03 12:58:36'),(70526,202,'Bairihwa','271206',1,0,'2022-03-03 12:58:36','2022-03-03 12:58:36'),(70527,202,'Bakaulirajpur','271210',1,0,'2022-03-03 12:58:36','2022-03-03 12:58:36'),(70528,202,'Baldev Nagar','271861',1,0,'2022-03-03 12:58:36','2022-03-03 12:58:36'),(70529,202,'Balrampur City','271201',1,0,'2022-03-03 12:58:36','2022-03-03 12:58:36'),(70530,202,'Balrampur Degree College','271201',1,0,'2022-03-03 12:58:36','2022-03-03 12:58:36'),(70531,202,'Balrampur H.O','271201',1,0,'2022-03-03 12:58:36','2022-03-03 12:58:36'),(70532,202,'Bangai','271208',1,0,'2022-03-03 12:58:36','2022-03-03 12:58:36'),(70533,202,'Banghusri','271206',1,0,'2022-03-03 12:58:36','2022-03-03 12:58:36'),(70534,202,'Bank Bazar','271604',1,0,'2022-03-03 12:58:36','2022-03-03 12:58:36'),(70535,202,'Bankatwa','271861',1,0,'2022-03-03 12:58:36','2022-03-03 12:58:36'),(70536,202,'Bardaulia','271207',1,0,'2022-03-03 12:58:36','2022-03-03 12:58:36'),(70537,202,'Bargadha Sohna','271215',1,0,'2022-03-03 12:58:36','2022-03-03 12:58:36'),(70538,202,'Bargadhi','271201',1,0,'2022-03-03 12:58:36','2022-03-03 12:58:36'),(70539,202,'Bargadwa','271215',1,0,'2022-03-03 12:58:36','2022-03-03 12:58:36'),(70540,202,'Barhara Bhitaura','271604',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70541,202,'Basant Pur Raja','271209',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70542,202,'Belha','271201',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70543,202,'Belhsa','271215',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70544,202,'Bemiha','271215',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70545,202,'Bethaniya Karihniya','271206',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70546,202,'Bhagautiganj','271201',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70547,202,'Bhagwanpur','271208',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70548,202,'Bhagwanpur Khadar','271215',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70549,202,'Bhagwanpur Kondar','271206',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70550,202,'Bhairampur','271604',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70551,202,'Bhangaha Kala','271208',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70552,202,'Bhathar','271206',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70553,202,'Bhatpurwa','271204',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70554,202,'Bhatpurwa Kala','271201',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70555,202,'Bhdhipur','271306',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70556,202,'Bheekh Pur','271201',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70557,202,'Bhelya Madanpur','271307',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70558,202,'Bhojpur Tharu','271210',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70559,202,'Birahin Pur','271201',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70560,202,'Bishunipur','271201',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70561,202,'Bishunpur Bel Bharia','271204',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70562,202,'Bishunpur Sagar','271307',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70563,202,'Bisunpur','271207',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70564,202,'Bisunpur Grant','271306',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70565,202,'Bisunpur Vishram','271206',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70566,202,'Chamrupur','271609',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70567,202,'Chandanpur','271206',1,0,'2022-03-03 12:58:37','2022-03-03 12:58:37'),(70568,202,'Chaudhary Deeh','271207',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70569,202,'Chauhattar Khurd','271210',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70570,202,'Chhitarpara','271604',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70571,202,'Dari Chaura','271607',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70572,202,'Datauli','271306',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70573,202,'Deopura','271207',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70574,202,'Deoria','271201',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70575,202,'Deoria Inayat','271307',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70576,202,'Deoria Mubarakpur','271607',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70577,202,'Deoria Rani Jot','271607',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70578,202,'Dhabauliya','271206',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70579,202,'Dhanaura','271504',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70580,202,'Dharampur','271208',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70581,202,'Dhawai','271215',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70582,202,'Dualata Bad Grant','271604',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70583,202,'Dumri','271206',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70584,202,'Entai Rampur','271604',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70585,202,'Fakirapur','271609',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70586,202,'Farenda','271201',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70587,202,'Gaindas Bujurg','271604',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70588,202,'Gainsari','271210',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70589,202,'Gajaihwa','271201',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70590,202,'Gajpur Grant','271604',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70591,202,'Ganeshpur','271203',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70592,202,'Ganeshpur','271215',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70593,202,'Godahana','271604',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70594,202,'Golahipur','271307',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70595,202,'Gudra','271208',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70596,202,'Gugauli','271205',1,0,'2022-03-03 12:58:38','2022-03-03 12:58:38'),(70597,202,'Gulriha','271205',1,0,'2022-03-03 12:58:39','2022-03-03 12:58:39'),(70598,202,'Gulriha Sandwa','271210',1,0,'2022-03-03 12:58:39','2022-03-03 12:58:39'),(70599,202,'Gumri','271609',1,0,'2022-03-03 12:58:39','2022-03-03 12:58:39'),(70600,202,'Gurchihwa','271206',1,0,'2022-03-03 12:58:39','2022-03-03 12:58:39'),(70601,202,'Hallaura','271210',1,0,'2022-03-03 12:58:39','2022-03-03 12:58:39'),(70602,202,'Hasanpur','271207',1,0,'2022-03-03 12:58:39','2022-03-03 12:58:39'),(70603,202,'Husaina Bad Grant','271604',1,0,'2022-03-03 12:58:39','2022-03-03 12:58:39'),(70604,202,'Imlia Kondar','271206',1,0,'2022-03-03 12:58:39','2022-03-03 12:58:39'),(70605,202,'Intai Abdullah','271307',1,0,'2022-03-03 12:58:39','2022-03-03 12:58:39'),(70606,202,'Intai','271604',1,0,'2022-03-03 12:58:39','2022-03-03 12:58:39'),(70607,202,'Jabdha','271201',1,0,'2022-03-03 12:58:39','2022-03-03 12:58:39'),(70608,202,'Jahandaria','271208',1,0,'2022-03-03 12:58:39','2022-03-03 12:58:39'),(70609,202,'Jaita Pur','271604',1,0,'2022-03-03 12:58:39','2022-03-03 12:58:39'),(70610,202,'Jamuni Kala','271210',1,0,'2022-03-03 12:58:39','2022-03-03 12:58:39'),(70611,202,'Jarwa','271203',1,0,'2022-03-03 12:58:39','2022-03-03 12:58:39'),(70612,202,'Jewnar','271201',1,0,'2022-03-03 12:58:39','2022-03-03 12:58:39'),(70613,202,'Kamrawan','271204',1,0,'2022-03-03 12:58:39','2022-03-03 12:58:39'),(70614,202,'Kataiyabhari','271206',1,0,'2022-03-03 12:58:39','2022-03-03 12:58:39'),(70615,202,'Katra Shankar Nagar','271201',1,0,'2022-03-03 12:58:39','2022-03-03 12:58:39'),(70616,202,'Kauwapur','271205',1,0,'2022-03-03 12:58:39','2022-03-03 12:58:39'),(70617,202,'Khajuria','271604',1,0,'2022-03-03 12:58:39','2022-03-03 12:58:39'),(70618,202,'Khamahariya','271210',1,0,'2022-03-03 12:58:39','2022-03-03 12:58:39'),(70619,202,'Kharhawa Deehwa','271307',1,0,'2022-03-03 12:58:39','2022-03-03 12:58:39'),(70620,202,'Kodri','271861',1,0,'2022-03-03 12:58:39','2022-03-03 12:58:39'),(70621,202,'Kohar Gaddi','271206',1,0,'2022-03-03 12:58:39','2022-03-03 12:58:39'),(70622,202,'Koilara','271201',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70623,202,'Kondari','271208',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70624,202,'Kotia','271306',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70625,202,'Kundwa','271215',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70626,202,'Kutti Ram Talha','271215',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70627,202,'Lai Budwa','271205',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70628,202,'Lal Nagar Sipahia','271208',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70629,202,'Laliya','271861',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70630,202,'Laukahwa','271208',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70631,202,'Laxmi Nagar','271208',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70632,202,'Lokiya Tahir','271307',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70633,202,'Maddo Chaura','271307',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70634,202,'Madha Nagar','271215',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70635,202,'Madni','271206',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70636,202,'Mahdaiya State','271609',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70637,202,'Mahrajganj (Balrampur)','271205',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70638,202,'Mahuwa','271607',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70639,202,'Majgaon','271208',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70640,202,'Majgawan','271206',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70641,202,'Malda','271215',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70642,202,'Mangra Kohal','271861',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70643,202,'Manikapur','271210',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70644,202,'Maniyaria','271607',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70645,202,'Manpur','271215',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70646,202,'Mathura Bazar','271861',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70647,202,'Mirjapur','271201',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70648,202,'Mnohrapur','271215',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70649,202,'Motipur','271207',1,0,'2022-03-03 12:58:40','2022-03-03 12:58:40'),(70650,202,'Mujehani','271205',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70651,202,'Mundila','271205',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70652,202,'Mutera','271203',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70653,202,'Naikiniya','271208',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70654,202,'Nandauri','271604',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70655,202,'Naubasta Mundila','271604',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70656,202,'Newal Garh','271203',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70657,202,'Obarideeh','271307',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70658,202,'Pachperwa','271206',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70659,202,'Pandari','271201',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70660,202,'Parasrampur','271206',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70661,202,'Parasrampur Rajahana','271206',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70662,202,'Parsona','271604',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70663,202,'Pehar','271604',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70664,202,'Pipra Bhodhar','271204',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70665,202,'Pipra Ram Chandar','271609',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70666,202,'Pipriha Jamuni','271215',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70667,202,'Pranpur','271861',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70668,202,'Purab Tola','271201',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70669,202,'Puraina','271210',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70670,202,'Puraina Wajid','271609',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70671,202,'Purani Bazar Pachperwa','271215',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70672,202,'Rajdarwa Tharu','271206',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70673,202,'Ram Nagar','271206',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70674,202,'Ramapur Grant','271307',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70675,202,'Rampur Banghusra','271607',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70676,202,'Ramwapur','271203',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70677,202,'Rani Jot','271208',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70678,202,'Raniyapur','271203',1,0,'2022-03-03 12:58:41','2022-03-03 12:58:41'),(70679,202,'Rehar Mafi','271609',1,0,'2022-03-03 12:58:42','2022-03-03 12:58:42'),(70680,202,'Rehra Bazar','271306',1,0,'2022-03-03 12:58:42','2022-03-03 12:58:42'),(70681,202,'Rehra Cahuki','271206',1,0,'2022-03-03 12:58:42','2022-03-03 12:58:42'),(70682,202,'Sadullanagar','271307',1,0,'2022-03-03 12:58:42','2022-03-03 12:58:42'),(70683,202,'Saraikhas','271306',1,0,'2022-03-03 12:58:42','2022-03-03 12:58:42'),(70684,202,'Sehrinwa','271205',1,0,'2022-03-03 12:58:42','2022-03-03 12:58:42'),(70685,202,'Shankar Nagar','271207',1,0,'2022-03-03 12:58:42','2022-03-03 12:58:42'),(70686,202,'Shankarpur Kalan','271206',1,0,'2022-03-03 12:58:42','2022-03-03 12:58:42'),(70687,202,'Shivpur Mhadev','271210',1,0,'2022-03-03 12:58:42','2022-03-03 12:58:42'),(70688,202,'Shivpura','271207',1,0,'2022-03-03 12:58:42','2022-03-03 12:58:42'),(70689,202,'Sisai Jangal','271204',1,0,'2022-03-03 12:58:42','2022-03-03 12:58:42'),(70690,202,'Sonpur','271210',1,0,'2022-03-03 12:58:42','2022-03-03 12:58:42'),(70691,202,'Sonpur','271207',1,0,'2022-03-03 12:58:42','2022-03-03 12:58:42'),(70692,202,'Sriduttganj','271607',1,0,'2022-03-03 12:58:42','2022-03-03 12:58:42'),(70693,202,'Suganagar Dumri','271206',1,0,'2022-03-03 12:58:42','2022-03-03 12:58:42'),(70694,202,'Sugganagar','271205',1,0,'2022-03-03 12:58:42','2022-03-03 12:58:42'),(70695,202,'Sukhuiya','271604',1,0,'2022-03-03 12:58:42','2022-03-03 12:58:42'),(70696,202,'Terhawa Nabad','271604',1,0,'2022-03-03 12:58:42','2022-03-03 12:58:42'),(70697,202,'Thakurapur','271210',1,0,'2022-03-03 12:58:42','2022-03-03 12:58:42'),(70698,202,'Thurwaliya','271206',1,0,'2022-03-03 12:58:42','2022-03-03 12:58:42'),(70699,202,'Tirlokpur','271215',1,0,'2022-03-03 12:58:42','2022-03-03 12:58:42'),(70700,202,'Tulsipur','271208',1,0,'2022-03-03 12:58:42','2022-03-03 12:58:42'),(70701,202,'Udaipur','271207',1,0,'2022-03-03 12:58:42','2022-03-03 12:58:42'),(70702,202,'Utraula Bazar','271604',1,0,'2022-03-03 12:58:42','2022-03-03 12:58:42'),(70703,202,'Utraula','271604',1,0,'2022-03-03 12:58:43','2022-03-03 12:58:43'),(70704,202,'Vijay Nagar','271215',1,0,'2022-03-03 12:58:43','2022-03-03 12:58:43'),(70705,202,'Visunpur Tantanwa','271206',1,0,'2022-03-03 12:58:43','2022-03-03 12:58:43'),(70706,203,'Achharaund','210001',1,0,'2022-03-03 12:58:43','2022-03-03 12:58:43'),(70707,203,'Adri','210126',1,0,'2022-03-03 12:58:43','2022-03-03 12:58:43'),(70708,203,'Ajeetpur','210001',1,0,'2022-03-03 12:58:43','2022-03-03 12:58:43'),(70709,203,'Akuna','210203',1,0,'2022-03-03 12:58:43','2022-03-03 12:58:43'),(70710,203,'Aliha','210121',1,0,'2022-03-03 12:58:43','2022-03-03 12:58:43'),(70711,203,'Alona','210001',1,0,'2022-03-03 12:58:43','2022-03-03 12:58:43'),(70712,203,'Amara','210126',1,0,'2022-03-03 12:58:43','2022-03-03 12:58:43'),(70713,203,'Amlikaur','210128',1,0,'2022-03-03 12:58:43','2022-03-03 12:58:43'),(70714,203,'Amlor','210126',1,0,'2022-03-03 12:58:43','2022-03-03 12:58:43'),(70715,203,'Anathuwa','210201',1,0,'2022-03-03 12:58:43','2022-03-03 12:58:43'),(70716,203,'Arjunah','210120',1,0,'2022-03-03 12:58:43','2022-03-03 12:58:43'),(70717,203,'Armar','210125',1,0,'2022-03-03 12:58:43','2022-03-03 12:58:43'),(70718,203,'Atarahat','210001',1,0,'2022-03-03 12:58:43','2022-03-03 12:58:43'),(70719,203,'Atarra','210201',1,0,'2022-03-03 12:58:43','2022-03-03 12:58:43'),(70720,203,'Audaha','210125',1,0,'2022-03-03 12:58:43','2022-03-03 12:58:43'),(70721,203,'Augasi','210121',1,0,'2022-03-03 12:58:43','2022-03-03 12:58:43'),(70722,203,'Baberu','210121',1,0,'2022-03-03 12:58:43','2022-03-03 12:58:43'),(70723,203,'Bachhaundha','210203',1,0,'2022-03-03 12:58:43','2022-03-03 12:58:43'),(70724,203,'Bachhaunha','210125',1,0,'2022-03-03 12:58:43','2022-03-03 12:58:43'),(70725,203,'Badagaon','210121',1,0,'2022-03-03 12:58:43','2022-03-03 12:58:43'),(70726,203,'Badausa','210202',1,0,'2022-03-03 12:58:43','2022-03-03 12:58:43'),(70727,203,'Badokhar Bujurg','210001',1,0,'2022-03-03 12:58:43','2022-03-03 12:58:43'),(70728,203,'Badokhar Khurd','210001',1,0,'2022-03-03 12:58:43','2022-03-03 12:58:43'),(70729,203,'Bagehta','210121',1,0,'2022-03-03 12:58:44','2022-03-03 12:58:44'),(70730,203,'Bagha','210203',1,0,'2022-03-03 12:58:44','2022-03-03 12:58:44'),(70731,203,'Baghelabari','210202',1,0,'2022-03-03 12:58:44','2022-03-03 12:58:44'),(70732,203,'Baheri','210129',1,0,'2022-03-03 12:58:44','2022-03-03 12:58:44'),(70733,203,'Ballan','210201',1,0,'2022-03-03 12:58:44','2022-03-03 12:58:44'),(70734,203,'Banda Aliganj','210001',1,0,'2022-03-03 12:58:44','2022-03-03 12:58:44'),(70735,203,'Banda City','210001',1,0,'2022-03-03 12:58:44','2022-03-03 12:58:44'),(70736,203,'Banda D.C.','210001',1,0,'2022-03-03 12:58:44','2022-03-03 12:58:44'),(70737,203,'Banda H.O','210001',1,0,'2022-03-03 12:58:44','2022-03-03 12:58:44'),(70738,203,'Banda Kutchery','210001',1,0,'2022-03-03 12:58:44','2022-03-03 12:58:44'),(70739,203,'Banda R.S.','210001',1,0,'2022-03-03 12:58:44','2022-03-03 12:58:44'),(70740,203,'Bansi','210001',1,0,'2022-03-03 12:58:44','2022-03-03 12:58:44'),(70741,203,'Banthari','210125',1,0,'2022-03-03 12:58:44','2022-03-03 12:58:44'),(70742,203,'Baragaon','210126',1,0,'2022-03-03 12:58:44','2022-03-03 12:58:44'),(70743,203,'Baraimanpur','210001',1,0,'2022-03-03 12:58:44','2022-03-03 12:58:44'),(70744,203,'Basahari','210001',1,0,'2022-03-03 12:58:44','2022-03-03 12:58:44'),(70745,203,'Benda','210128',1,0,'2022-03-03 12:58:44','2022-03-03 12:58:44'),(70746,203,'Beonja','210121',1,0,'2022-03-03 12:58:44','2022-03-03 12:58:44'),(70747,203,'Berraon','210125',1,0,'2022-03-03 12:58:44','2022-03-03 12:58:44'),(70748,203,'Bhabhua','210121',1,0,'2022-03-03 12:58:44','2022-03-03 12:58:44'),(70749,203,'Bhadedu','210121',1,0,'2022-03-03 12:58:44','2022-03-03 12:58:44'),(70750,203,'Bhujrakh','210128',1,0,'2022-03-03 12:58:44','2022-03-03 12:58:44'),(70751,203,'Bichhwahi','210123',1,0,'2022-03-03 12:58:44','2022-03-03 12:58:44'),(70752,203,'Bilgaon','210001',1,0,'2022-03-03 12:58:44','2022-03-03 12:58:44'),(70753,203,'Bira','210125',1,0,'2022-03-03 12:58:44','2022-03-03 12:58:44'),(70754,203,'Birauna','210129',1,0,'2022-03-03 12:58:44','2022-03-03 12:58:44'),(70755,203,'Bisanda','210203',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70756,203,'Bisandi','210203',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70757,203,'Budhauli','210125',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70758,203,'Chandwara','210126',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70759,203,'Chandwara','210129',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70760,203,'Charka','210125',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70761,203,'Chausar','210201',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70762,203,'Chhehraon','210001',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70763,203,'Chhenahra Lalpur','210001',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70764,203,'Chhoti Bazar','210001',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70765,203,'Chillatara','210123',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70766,203,'Chillolar','210203',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70767,203,'Dadhwamanpur','210202',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70768,203,'Dharikhera','210126',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70769,203,'Dighwat','210123',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70770,203,'Durendi','210001',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70771,203,'Gadaria','210126',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70772,203,'Ganaon','210201',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70773,203,'Ganchchha','210001',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70774,203,'Garchappa','210208',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70775,203,'Gauri Kalan','210126',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70776,203,'Gazipur','210126',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70777,203,'Ghauraunda','210120',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70778,203,'Girwan','210001',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70779,203,'Goeramugli','210001',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70780,203,'Goiya Kalan','210208',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70781,203,'Gokhia','210201',1,0,'2022-03-03 12:58:45','2022-03-03 12:58:45'),(70782,203,'Gugauli','210123',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70783,203,'Gumanganj','210129',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70784,203,'Gureh','210001',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70785,203,'Gurha Kalan','210129',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70786,203,'Hanna Vinaika','210209',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70787,203,'Harbamafi','210202',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70788,203,'Hardauli','210121',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70789,203,'Hastam','210120',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70790,203,'Hathaura','210001',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70791,203,'Ingua','210125',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70792,203,'Jabrapur','210202',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70793,203,'Jalalpur','210121',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70794,203,'Jamalpur','210001',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70795,203,'Jamoo','210203',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70796,203,'Jamwara','210129',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70797,203,'Jaria','210001',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70798,203,'Jaspura','210126',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70799,203,'Jauharpur','210123',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70800,203,'Jaurahi','210001',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70801,203,'Jhanjhari Ka Purwa','210126',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70802,203,'Kailnjar','210129',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70803,203,'Kairikhurd','210203',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70804,203,'Kamasin','210125',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70805,203,'Kanwara','210001',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70806,203,'Karaundi Kalan','210207',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70807,203,'Kartal','210129',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70808,203,'Katrawal','210120',1,0,'2022-03-03 12:58:46','2022-03-03 12:58:46'),(70809,203,'Khambhaura','210201',1,0,'2022-03-03 12:58:47','2022-03-03 12:58:47'),(70810,203,'Khaptiha Kalan','210001',1,0,'2022-03-03 12:58:47','2022-03-03 12:58:47'),(70811,203,'Kharauli','210125',1,0,'2022-03-03 12:58:47','2022-03-03 12:58:47'),(70812,203,'Khaunda','210128',1,0,'2022-03-03 12:58:47','2022-03-03 12:58:47'),(70813,203,'Khurand R.S.','210120',1,0,'2022-03-03 12:58:47','2022-03-03 12:58:47'),(70814,203,'Khurhand','210120',1,0,'2022-03-03 12:58:47','2022-03-03 12:58:47'),(70815,203,'Korrahi','210203',1,0,'2022-03-03 12:58:47','2022-03-03 12:58:47'),(70816,203,'Kulsari','210129',1,0,'2022-03-03 12:58:47','2022-03-03 12:58:47'),(70817,203,'Lahureta','210129',1,0,'2022-03-03 12:58:47','2022-03-03 12:58:47'),(70818,203,'Lakhanpur','210125',1,0,'2022-03-03 12:58:47','2022-03-03 12:58:47'),(70819,203,'Lama','210001',1,0,'2022-03-03 12:58:47','2022-03-03 12:58:47'),(70820,203,'Lohda','210206',1,0,'2022-03-03 12:58:47','2022-03-03 12:58:47'),(70821,203,'Lohra','210125',1,0,'2022-03-03 12:58:47','2022-03-03 12:58:47'),(70822,203,'Lucktara','210001',1,0,'2022-03-03 12:58:47','2022-03-03 12:58:47'),(70823,203,'Madauli Kalan','210126',1,0,'2022-03-03 12:58:47','2022-03-03 12:58:47'),(70824,203,'Mahokhar','210001',1,0,'2022-03-03 12:58:47','2022-03-03 12:58:47'),(70825,203,'Mahua','210120',1,0,'2022-03-03 12:58:47','2022-03-03 12:58:47'),(70826,203,'Mahui','210128',1,0,'2022-03-03 12:58:47','2022-03-03 12:58:47'),(70827,203,'Mahuta','210202',1,0,'2022-03-03 12:58:47','2022-03-03 12:58:47'),(70828,203,'Majhila','210121',1,0,'2022-03-03 12:58:47','2022-03-03 12:58:47'),(70829,203,'Majhiwan','210121',1,0,'2022-03-03 12:58:47','2022-03-03 12:58:47'),(70830,203,'Makri','210120',1,0,'2022-03-03 12:58:47','2022-03-03 12:58:47'),(70831,203,'Malehra Newada','210120',1,0,'2022-03-03 12:58:47','2022-03-03 12:58:47'),(70832,203,'Mamsi Khurd','210125',1,0,'2022-03-03 12:58:47','2022-03-03 12:58:47'),(70833,203,'Manipur','210001',1,0,'2022-03-03 12:58:47','2022-03-03 12:58:47'),(70834,203,'Marauli','210203',1,0,'2022-03-03 12:58:48','2022-03-03 12:58:48'),(70835,203,'Marjha','210126',1,0,'2022-03-03 12:58:48','2022-03-03 12:58:48'),(70836,203,'Marka','210125',1,0,'2022-03-03 12:58:48','2022-03-03 12:58:48'),(70837,203,'Masuri','210001',1,0,'2022-03-03 12:58:48','2022-03-03 12:58:48'),(70838,203,'Mataundh','210001',1,0,'2022-03-03 12:58:48','2022-03-03 12:58:48'),(70839,203,'Mau','210125',1,0,'2022-03-03 12:58:48','2022-03-03 12:58:48'),(70840,203,'Mawai','210001',1,0,'2022-03-03 12:58:48','2022-03-03 12:58:48'),(70841,203,'Mawaighat','210126',1,0,'2022-03-03 12:58:48','2022-03-03 12:58:48'),(70842,203,'Mohanpurwa','210001',1,0,'2022-03-03 12:58:48','2022-03-03 12:58:48'),(70843,203,'Mungus','210128',1,0,'2022-03-03 12:58:48','2022-03-03 12:58:48'),(70844,203,'Murwal','210121',1,0,'2022-03-03 12:58:48','2022-03-03 12:58:48'),(70845,203,'Museewan','210125',1,0,'2022-03-03 12:58:48','2022-03-03 12:58:48'),(70846,203,'Naditaura','210206',1,0,'2022-03-03 12:58:48','2022-03-03 12:58:48'),(70847,203,'Nagnedi','210120',1,0,'2022-03-03 12:58:48','2022-03-03 12:58:48'),(70848,203,'Nahri','210129',1,0,'2022-03-03 12:58:48','2022-03-03 12:58:48'),(70849,203,'Nandadeo','210126',1,0,'2022-03-03 12:58:48','2022-03-03 12:58:48'),(70850,203,'Nandin Kurmiyan','210207',1,0,'2022-03-03 12:58:48','2022-03-03 12:58:48'),(70851,203,'Naraini','210129',1,0,'2022-03-03 12:58:48','2022-03-03 12:58:48'),(70852,203,'Narauli','210126',1,0,'2022-03-03 12:58:48','2022-03-03 12:58:48'),(70853,203,'Narayanpur','210125',1,0,'2022-03-03 12:58:48','2022-03-03 12:58:48'),(70854,203,'Nari','210126',1,0,'2022-03-03 12:58:48','2022-03-03 12:58:48'),(70855,203,'Nauhai','210129',1,0,'2022-03-03 12:58:48','2022-03-03 12:58:48'),(70856,203,'Nibhaur','210121',1,0,'2022-03-03 12:58:48','2022-03-03 12:58:48'),(70857,203,'Nilathu','210121',1,0,'2022-03-03 12:58:48','2022-03-03 12:58:48'),(70858,203,'Ora','210206',1,0,'2022-03-03 12:58:48','2022-03-03 12:58:48'),(70859,203,'Oraha','210201',1,0,'2022-03-03 12:58:49','2022-03-03 12:58:49'),(70860,203,'Oran','210203',1,0,'2022-03-03 12:58:49','2022-03-03 12:58:49'),(70861,203,'P G College Attara','210201',1,0,'2022-03-03 12:58:49','2022-03-03 12:58:49'),(70862,203,'Pachhauhan','210125',1,0,'2022-03-03 12:58:49','2022-03-03 12:58:49'),(70863,203,'Pachnehi','210001',1,0,'2022-03-03 12:58:49','2022-03-03 12:58:49'),(70864,203,'Pachokhar','210201',1,0,'2022-03-03 12:58:49','2022-03-03 12:58:49'),(70865,203,'Padarathpur','210123',1,0,'2022-03-03 12:58:49','2022-03-03 12:58:49'),(70866,203,'Padmai','210129',1,0,'2022-03-03 12:58:49','2022-03-03 12:58:49'),(70867,203,'Padohra','210126',1,0,'2022-03-03 12:58:49','2022-03-03 12:58:49'),(70868,203,'Padui','210001',1,0,'2022-03-03 12:58:49','2022-03-03 12:58:49'),(70869,203,'Paigambarpur','210001',1,0,'2022-03-03 12:58:49','2022-03-03 12:58:49'),(70870,203,'Pailani','210126',1,0,'2022-03-03 12:58:49','2022-03-03 12:58:49'),(70871,203,'Palhari','210121',1,0,'2022-03-03 12:58:49','2022-03-03 12:58:49'),(70872,203,'Palra','210123',1,0,'2022-03-03 12:58:49','2022-03-03 12:58:49'),(70873,203,'Pangara','210129',1,0,'2022-03-03 12:58:49','2022-03-03 12:58:49'),(70874,203,'Pannah','210125',1,0,'2022-03-03 12:58:49','2022-03-03 12:58:49'),(70875,203,'Paprenda','210001',1,0,'2022-03-03 12:58:49','2022-03-03 12:58:49'),(70876,203,'Para','210203',1,0,'2022-03-03 12:58:49','2022-03-03 12:58:49'),(70877,203,'Paras','210121',1,0,'2022-03-03 12:58:49','2022-03-03 12:58:49'),(70878,203,'Parsahar','210129',1,0,'2022-03-03 12:58:49','2022-03-03 12:58:49'),(70879,203,'Parsauli','210125',1,0,'2022-03-03 12:58:49','2022-03-03 12:58:49'),(70880,203,'Parsaunda','210001',1,0,'2022-03-03 12:58:49','2022-03-03 12:58:49'),(70881,203,'Pathara','210202',1,0,'2022-03-03 12:58:49','2022-03-03 12:58:49'),(70882,203,'Patwan','210121',1,0,'2022-03-03 12:58:49','2022-03-03 12:58:49'),(70883,203,'Pauhar','210202',1,0,'2022-03-03 12:58:49','2022-03-03 12:58:49'),(70884,203,'Pauhar','210201',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70885,203,'Pawaiya','210121',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70886,203,'Pindaran','210121',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70887,203,'Pindkhar','210201',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70888,203,'Pipargawan','210128',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70889,203,'Piprahari','210123',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70890,203,'Piprodar','210126',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70891,203,'Piyar','210202',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70892,203,'Pongari','210129',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70893,203,'Punahur','210201',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70894,203,'Rampur','210126',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70895,203,'Ranipur','210203',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70896,203,'Rasin','210202',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70897,203,'Rauli Kalyanpur','210202',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70898,203,'Risaura','210129',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70899,203,'Sabada','210126',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70900,203,'Sadimadanpur','210123',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70901,203,'Sahewa','210120',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70902,203,'Samgara','210121',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70903,203,'Sandasani','210125',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70904,203,'Sarha','210129',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70905,203,'Sathi','210121',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70906,203,'Satnyaon','210125',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70907,203,'Saunta Syondha','210120',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70908,203,'Saya','210203',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70909,203,'Semri Basilpur','210128',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70910,203,'Sheo','210121',1,0,'2022-03-03 12:58:50','2022-03-03 12:58:50'),(70911,203,'Sikahula','210126',1,0,'2022-03-03 12:58:51','2022-03-03 12:58:51'),(70912,203,'Simauni','210121',1,0,'2022-03-03 12:58:51','2022-03-03 12:58:51'),(70913,203,'Sindhan Kalan','210126',1,0,'2022-03-03 12:58:51','2022-03-03 12:58:51'),(70914,203,'Singhpur','210203',1,0,'2022-03-03 12:58:51','2022-03-03 12:58:51'),(70915,203,'Tilausa','210125',1,0,'2022-03-03 12:58:51','2022-03-03 12:58:51'),(70916,203,'Tindura','210203',1,0,'2022-03-03 12:58:51','2022-03-03 12:58:51'),(70917,203,'Tindwara','210001',1,0,'2022-03-03 12:58:51','2022-03-03 12:58:51'),(70918,203,'Tindwari','210128',1,0,'2022-03-03 12:58:51','2022-03-03 12:58:51'),(70919,203,'Trivedi','210001',1,0,'2022-03-03 12:58:51','2022-03-03 12:58:51'),(70920,203,'Turra','210202',1,0,'2022-03-03 12:58:51','2022-03-03 12:58:51'),(70921,203,'Umarahni','210121',1,0,'2022-03-03 12:58:51','2022-03-03 12:58:51'),(70922,204,'Achhechha','225208',1,0,'2022-03-03 12:58:51','2022-03-03 12:58:51'),(70923,204,'Addra','225207',1,0,'2022-03-03 12:58:51','2022-03-03 12:58:51'),(70924,204,'Ahmadpur','225412',1,0,'2022-03-03 12:58:51','2022-03-03 12:58:51'),(70925,204,'Akhtiyarpur  Sharifabad','225122',1,0,'2022-03-03 12:58:51','2022-03-03 12:58:51'),(70926,204,'Aliabad','225401',1,0,'2022-03-03 12:58:51','2022-03-03 12:58:51'),(70927,204,'Amahia','225409',1,0,'2022-03-03 12:58:51','2022-03-03 12:58:51'),(70928,204,'Ambaur','225412',1,0,'2022-03-03 12:58:51','2022-03-03 12:58:51'),(70929,204,'Amoli Kalan','225205',1,0,'2022-03-03 12:58:51','2022-03-03 12:58:51'),(70930,204,'Ansari','225124',1,0,'2022-03-03 12:58:51','2022-03-03 12:58:51'),(70931,204,'Anwari','225302',1,0,'2022-03-03 12:58:51','2022-03-03 12:58:51'),(70932,204,'Asandra','225416',1,0,'2022-03-03 12:58:52','2022-03-03 12:58:52'),(70933,204,'Aseni','225003',1,0,'2022-03-03 12:58:52','2022-03-03 12:58:52'),(70934,204,'Ashrafpur','225409',1,0,'2022-03-03 12:58:52','2022-03-03 12:58:52'),(70935,204,'Atahara','225302',1,0,'2022-03-03 12:58:52','2022-03-03 12:58:52'),(70936,204,'Baburi Gaon','225301',1,0,'2022-03-03 12:58:52','2022-03-03 12:58:52'),(70937,204,'Baburiha','225208',1,0,'2022-03-03 12:58:52','2022-03-03 12:58:52'),(70938,204,'Baddoopur','225306',1,0,'2022-03-03 12:58:52','2022-03-03 12:58:52'),(70939,204,'Badosarai','225207',1,0,'2022-03-03 12:58:52','2022-03-03 12:58:52'),(70940,204,'Badshahnagar','225401',1,0,'2022-03-03 12:58:52','2022-03-03 12:58:52'),(70941,204,'Baghaura','225412',1,0,'2022-03-03 12:58:52','2022-03-03 12:58:52'),(70942,204,'Bahramghat','225201',1,0,'2022-03-03 12:58:52','2022-03-03 12:58:52'),(70943,204,'Bahrauli','225302',1,0,'2022-03-03 12:58:52','2022-03-03 12:58:52'),(70944,204,'Bajgahni','225306',1,0,'2022-03-03 12:58:52','2022-03-03 12:58:52'),(70945,204,'Banarki','225201',1,0,'2022-03-03 12:58:52','2022-03-03 12:58:52'),(70946,204,'Bandagi Nagar','225306',1,0,'2022-03-03 12:58:52','2022-03-03 12:58:52'),(70947,204,'Bangawan','225415',1,0,'2022-03-03 12:58:52','2022-03-03 12:58:52'),(70948,204,'Banki (Barabanki)','225001',1,0,'2022-03-03 12:58:52','2022-03-03 12:58:52'),(70949,204,'Bansa Sharif','225204',1,0,'2022-03-03 12:58:52','2022-03-03 12:58:52'),(70950,204,'Bansgaon','225415',1,0,'2022-03-03 12:58:52','2022-03-03 12:58:52'),(70951,204,'Banwa','225123',1,0,'2022-03-03 12:58:52','2022-03-03 12:58:52'),(70952,204,'Bara','225126',1,0,'2022-03-03 12:58:52','2022-03-03 12:58:52'),(70953,204,'Barabanki Bazar','225001',1,0,'2022-03-03 12:58:52','2022-03-03 12:58:52'),(70954,204,'Barabanki City','225001',1,0,'2022-03-03 12:58:52','2022-03-03 12:58:52'),(70955,204,'Barabanki Collectorate','225001',1,0,'2022-03-03 12:58:52','2022-03-03 12:58:52'),(70956,204,'Barabanki H.O','225001',1,0,'2022-03-03 12:58:52','2022-03-03 12:58:52'),(70957,204,'Barabanki Sugar Mill','225002',1,0,'2022-03-03 12:58:52','2022-03-03 12:58:52'),(70958,204,'Baragaon','225204',1,0,'2022-03-03 12:58:53','2022-03-03 12:58:53'),(70959,204,'Barail','225001',1,0,'2022-03-03 12:58:53','2022-03-03 12:58:53'),(70960,204,'Barain','225414',1,0,'2022-03-03 12:58:53','2022-03-03 12:58:53'),(70961,204,'Barauli Jata','225122',1,0,'2022-03-03 12:58:53','2022-03-03 12:58:53'),(70962,204,'Barauli Malik','225121',1,0,'2022-03-03 12:58:53','2022-03-03 12:58:53'),(70963,204,'Barhaidih Maholia','225302',1,0,'2022-03-03 12:58:53','2022-03-03 12:58:53'),(70964,204,'Basantpur','225306',1,0,'2022-03-03 12:58:53','2022-03-03 12:58:53'),(70965,204,'Basara','225305',1,0,'2022-03-03 12:58:53','2022-03-03 12:58:53'),(70966,204,'Basauli','225303',1,0,'2022-03-03 12:58:53','2022-03-03 12:58:53'),(70967,204,'Basti','225003',1,0,'2022-03-03 12:58:53','2022-03-03 12:58:53'),(70968,204,'Beejapur','225124',1,0,'2022-03-03 12:58:53','2022-03-03 12:58:53'),(70969,204,'Behta','225412',1,0,'2022-03-03 12:58:53','2022-03-03 12:58:53'),(70970,204,'Belahara','225305',1,0,'2022-03-03 12:58:53','2022-03-03 12:58:53'),(70971,204,'Belpur','225409',1,0,'2022-03-03 12:58:53','2022-03-03 12:58:53'),(70972,204,'Bhadras','225306',1,0,'2022-03-03 12:58:53','2022-03-03 12:58:53'),(70973,204,'Bhainsuriya','225205',1,0,'2022-03-03 12:58:53','2022-03-03 12:58:53'),(70974,204,'Bhanauli','225121',1,0,'2022-03-03 12:58:53','2022-03-03 12:58:53'),(70975,204,'Bhanmau','225121',1,0,'2022-03-03 12:58:53','2022-03-03 12:58:53'),(70976,204,'Bhawaniyapur Kheoli','225405',1,0,'2022-03-03 12:58:53','2022-03-03 12:58:53'),(70977,204,'Bhayara','225204',1,0,'2022-03-03 12:58:53','2022-03-03 12:58:53'),(70978,204,'Bheriya','225305',1,0,'2022-03-03 12:58:53','2022-03-03 12:58:53'),(70979,204,'Bhikhara','225124',1,0,'2022-03-03 12:58:53','2022-03-03 12:58:53'),(70980,204,'Bhikharpur','225409',1,0,'2022-03-03 12:58:53','2022-03-03 12:58:53'),(70981,204,'Bhilwal','225126',1,0,'2022-03-03 12:58:53','2022-03-03 12:58:53'),(70982,204,'Bhitauli','225201',1,0,'2022-03-03 12:58:53','2022-03-03 12:58:53'),(70983,204,'Bhitauli Kalan','225003',1,0,'2022-03-03 12:58:53','2022-03-03 12:58:53'),(70984,204,'Bhitaura Lakhan','225414',1,0,'2022-03-03 12:58:54','2022-03-03 12:58:54'),(70985,204,'Bibiapur','225119',1,0,'2022-03-03 12:58:54','2022-03-03 12:58:54'),(70986,204,'Bibipur Garh','225120',1,0,'2022-03-03 12:58:54','2022-03-03 12:58:54'),(70987,204,'Bilakhiya','225205',1,0,'2022-03-03 12:58:54','2022-03-03 12:58:54'),(70988,204,'Bindaura','225204',1,0,'2022-03-03 12:58:54','2022-03-03 12:58:54'),(70989,204,'Bindaura Dhartharia','225305',1,0,'2022-03-03 12:58:54','2022-03-03 12:58:54'),(70990,204,'Birahimabad','225121',1,0,'2022-03-03 12:58:54','2022-03-03 12:58:54'),(70991,204,'Bishunpur','225301',1,0,'2022-03-03 12:58:54','2022-03-03 12:58:54'),(70992,204,'Budhera','225208',1,0,'2022-03-03 12:58:54','2022-03-03 12:58:54'),(70993,204,'Budhwara','225204',1,0,'2022-03-03 12:58:54','2022-03-03 12:58:54'),(70994,204,'Burhwal Sugar Mill','225202',1,0,'2022-03-03 12:58:54','2022-03-03 12:58:54'),(70995,204,'Chaila','225207',1,0,'2022-03-03 12:58:54','2022-03-03 12:58:54'),(70996,204,'Chaubeesi','225124',1,0,'2022-03-03 12:58:54','2022-03-03 12:58:54'),(70997,204,'Chauri Aladadpur','225409',1,0,'2022-03-03 12:58:54','2022-03-03 12:58:54'),(70998,204,'Chheda','225305',1,0,'2022-03-03 12:58:54','2022-03-03 12:58:54'),(70999,204,'Chiraiya','225125',1,0,'2022-03-03 12:58:54','2022-03-03 12:58:54'),(71000,204,'Chirra','225401',1,0,'2022-03-03 12:58:54','2022-03-03 12:58:54'),(71001,204,'Dadera','225302',1,0,'2022-03-03 12:58:54','2022-03-03 12:58:54'),(71002,204,'Dadra','225412',1,0,'2022-03-03 12:58:54','2022-03-03 12:58:54'),(71003,204,'Dadrauli Bhawaniapur','225206',1,0,'2022-03-03 12:58:54','2022-03-03 12:58:54'),(71004,204,'Danapur Shukla','225207',1,0,'2022-03-03 12:58:54','2022-03-03 12:58:54'),(71005,204,'Dandoopur','225416',1,0,'2022-03-03 12:58:54','2022-03-03 12:58:54'),(71006,204,'Daravpur','225121',1,0,'2022-03-03 12:58:54','2022-03-03 12:58:54'),(71007,204,'Darawan','225302',1,0,'2022-03-03 12:58:54','2022-03-03 12:58:54'),(71008,204,'Darhara','225203',1,0,'2022-03-03 12:58:54','2022-03-03 12:58:54'),(71009,204,'Dariya Bad','225403',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71010,204,'Dariyabad R.S.','225404',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71011,204,'Daulatpur','225414',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71012,204,'Daulatpur','225304',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71013,204,'Dayalpur','225119',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71014,204,'Dewa Sharif','225301',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71015,204,'Dhanauli','225416',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71016,204,'Dhanauli Thakuran','225409',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71017,204,'Dhanaura','225413',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71018,204,'Dharampur','225305',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71019,204,'Dharoopur','225416',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71020,204,'Dhaurahra','225121',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71021,204,'Digsari','225409',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71022,204,'Dilauna','225409',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71023,204,'Fattapur Kalan','225401',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71024,204,'Gadia','225003',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71025,204,'Gajpatipur','225416',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71026,204,'Galhamau','225121',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71027,204,'Gandhi Aashram','225003',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71028,204,'Ganehari','225126',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71029,204,'Garhi','225126',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71030,204,'Garhi Rakhmau','225414',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71031,204,'Gariya Bazar','225302',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71032,204,'Gaura','225305',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71033,204,'Gehendwar','225122',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71034,204,'Gerawan','225125',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71035,204,'Ghar Kuiyan','225124',1,0,'2022-03-03 12:58:55','2022-03-03 12:58:55'),(71036,204,'Ghazipur','225405',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71037,204,'Gheri','225301',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71038,204,'Ghunghter','225302',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71039,204,'Gidrapur','225415',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71040,204,'Gudauli','225305',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71041,204,'Hadha','225415',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71042,204,'Haidergarh','225124',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71043,204,'Hakami','225409',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71044,204,'Hansuwapara','225306',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71045,204,'Harakh','225121',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71046,204,'Harrai','225301',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71047,204,'Hasanpur','225126',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71048,204,'Hasanpur Tanda','225305',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71049,204,'Hassaur','225415',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71050,204,'Hathaunda','225405',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71051,204,'Hazratpur','225305',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71052,204,'Hetmapur','225304',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71053,204,'Hunsepur','225405',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71054,204,'Imliha','225403',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71055,204,'Inayatpur','225119',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71056,204,'Islampur','225125',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71057,204,'Ismailpur','225301',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71058,204,'Israuli','225305',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71059,204,'Itaunja','225305',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71060,204,'Itaura','225403',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71061,204,'Jafarpur','225305',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71062,204,'Jagatpur','225305',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71063,204,'Jagsenda','225305',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71064,204,'Jahangeerabad Raj','225203',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71065,204,'Jameen Husainabad','225125',1,0,'2022-03-03 12:58:56','2022-03-03 12:58:56'),(71066,204,'Jarauli','225416',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71067,204,'Jargawan','225416',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71068,204,'Jariyari','225405',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71069,204,'Jaruwa','225301',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71070,204,'Jaurass','225126',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71071,204,'Jhanjhari','225304',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71072,204,'Jharsawan','225306',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71073,204,'Kaboolpur','225126',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71074,204,'Kaji Behta','225306',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71075,204,'Kakari','225126',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71076,204,'Kamarkha','225203',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71077,204,'Kamela','225124',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71078,204,'Kamoli','225207',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71079,204,'Kandarwal','225304',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71080,204,'Kandhaipur','225206',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71081,204,'Kandraula','225305',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71082,204,'Kanwan','225124',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71083,204,'Kasimganj','225301',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71084,204,'Katka','225205',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71085,204,'Katuri Kalan','225306',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71086,204,'Khaira Kankoo','225126',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71087,204,'Khajuri','225207',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71088,204,'Khanpur','225124',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71089,204,'Khansi Sarai','225305',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71090,204,'Khanwaha','225301',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71091,204,'Khapurwa','225305',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71092,204,'Kharsatiya','225124',1,0,'2022-03-03 12:58:57','2022-03-03 12:58:57'),(71093,204,'Kheoli','225301',1,0,'2022-03-03 12:58:58','2022-03-03 12:58:58'),(71094,204,'Kheorajpur','225416',1,0,'2022-03-03 12:58:58','2022-03-03 12:58:58'),(71095,204,'Khetasarai','225401',1,0,'2022-03-03 12:58:58','2022-03-03 12:58:58'),(71096,204,'Khijirpur','225203',1,0,'2022-03-03 12:58:58','2022-03-03 12:58:58'),(71097,204,'Khinjhana','225306',1,0,'2022-03-03 12:58:58','2022-03-03 12:58:58'),(71098,204,'Khutauli','225403',1,0,'2022-03-03 12:58:58','2022-03-03 12:58:58'),(71099,204,'Khwajapur','225126',1,0,'2022-03-03 12:58:58','2022-03-03 12:58:58'),(71100,204,'Kintoor','225207',1,0,'2022-03-03 12:58:58','2022-03-03 12:58:58'),(71101,204,'Kithaiya','225409',1,0,'2022-03-03 12:58:58','2022-03-03 12:58:58'),(71102,204,'Kithoori Daroga','225405',1,0,'2022-03-03 12:58:58','2022-03-03 12:58:58'),(71103,204,'Kola','225414',1,0,'2022-03-03 12:58:58','2022-03-03 12:58:58'),(71104,204,'Kondari','225301',1,0,'2022-03-03 12:58:58','2022-03-03 12:58:58'),(71105,204,'Kothi (Barabanki)','225119',1,0,'2022-03-03 12:58:58','2022-03-03 12:58:58'),(71106,204,'Kothri Gauriya','225415',1,0,'2022-03-03 12:58:58','2022-03-03 12:58:58'),(71107,204,'Kotwa Dham','225415',1,0,'2022-03-03 12:58:58','2022-03-03 12:58:58'),(71108,204,'Kotwa Sarak','225405',1,0,'2022-03-03 12:58:58','2022-03-03 12:58:58'),(71109,204,'Kursi','225302',1,0,'2022-03-03 12:58:58','2022-03-03 12:58:58'),(71110,204,'Kusfar','225403',1,0,'2022-03-03 12:58:58','2022-03-03 12:58:58'),(71111,204,'Kutloopur','225305',1,0,'2022-03-03 12:58:58','2022-03-03 12:58:58'),(71112,204,'Lachhbar Bajaha','225412',1,0,'2022-03-03 12:58:58','2022-03-03 12:58:58'),(71113,204,'Lahi','225124',1,0,'2022-03-03 12:58:58','2022-03-03 12:58:58'),(71114,204,'Lalpur Karauta','225304',1,0,'2022-03-03 12:58:58','2022-03-03 12:58:58'),(71115,204,'Laxmanpur','225122',1,0,'2022-03-03 12:58:58','2022-03-03 12:58:58'),(71116,204,'Lodhaura','225201',1,0,'2022-03-03 12:58:58','2022-03-03 12:58:58'),(71117,204,'Lohangpur','225124',1,0,'2022-03-03 12:58:58','2022-03-03 12:58:58'),(71118,204,'Loharpur','225412',1,0,'2022-03-03 12:58:59','2022-03-03 12:58:59'),(71119,204,'Loni Katra','225126',1,0,'2022-03-03 12:58:59','2022-03-03 12:58:59'),(71120,204,'Madanpur','225305',1,0,'2022-03-03 12:58:59','2022-03-03 12:58:59'),(71121,204,'Madhawapur','225205',1,0,'2022-03-03 12:58:59','2022-03-03 12:58:59'),(71122,204,'Madhopur','225003',1,0,'2022-03-03 12:58:59','2022-03-03 12:58:59'),(71123,204,'Magauwan','225125',1,0,'2022-03-03 12:58:59','2022-03-03 12:58:59'),(71124,204,'Mahmoodabad','225412',1,0,'2022-03-03 12:58:59','2022-03-03 12:58:59'),(71125,204,'Mahmoodpur','225305',1,0,'2022-03-03 12:58:59','2022-03-03 12:58:59'),(71126,204,'Mailaraiganj','225206',1,0,'2022-03-03 12:58:59','2022-03-03 12:58:59'),(71127,204,'Majhgawan Sharif','225305',1,0,'2022-03-03 12:58:59','2022-03-03 12:58:59'),(71128,204,'Malauli','225206',1,0,'2022-03-03 12:58:59','2022-03-03 12:58:59'),(71129,204,'Malhauli','225413',1,0,'2022-03-03 12:58:59','2022-03-03 12:58:59'),(71130,204,'Mallapur','225201',1,0,'2022-03-03 12:58:59','2022-03-03 12:58:59'),(71131,204,'Malookpur','225301',1,0,'2022-03-03 12:58:59','2022-03-03 12:58:59'),(71132,204,'Manjhela','225415',1,0,'2022-03-03 12:58:59','2022-03-03 12:58:59'),(71133,204,'Manodharpur','225126',1,0,'2022-03-03 12:58:59','2022-03-03 12:58:59'),(71134,204,'Manpur','225121',1,0,'2022-03-03 12:58:59','2022-03-03 12:58:59'),(71135,204,'Mansara','225416',1,0,'2022-03-03 12:58:59','2022-03-03 12:58:59'),(71136,204,'Markamau','225207',1,0,'2022-03-03 12:58:59','2022-03-03 12:58:59'),(71137,204,'Markhapur','225122',1,0,'2022-03-03 12:58:59','2022-03-03 12:58:59'),(71138,204,'Masauli','225204',1,0,'2022-03-03 12:58:59','2022-03-03 12:58:59'),(71139,204,'Maugorpur','225413',1,0,'2022-03-03 12:58:59','2022-03-03 12:58:59'),(71140,204,'Maulabad','225206',1,0,'2022-03-03 12:58:59','2022-03-03 12:58:59'),(71141,204,'Maulahara','225409',1,0,'2022-03-03 12:58:59','2022-03-03 12:58:59'),(71142,204,'Meruwa','225405',1,0,'2022-03-03 12:58:59','2022-03-03 12:58:59'),(71143,204,'Mithwara','225305',1,0,'2022-03-03 12:58:59','2022-03-03 12:58:59'),(71144,204,'Mittai','225301',1,0,'2022-03-03 12:59:00','2022-03-03 12:59:00'),(71145,204,'Mohabbatpur','225120',1,0,'2022-03-03 12:59:00','2022-03-03 12:59:00'),(71146,204,'Mohammad Pur Khaley','225303',1,0,'2022-03-03 12:59:00','2022-03-03 12:59:00'),(71147,204,'Mohammadpur','225126',1,0,'2022-03-03 12:59:00','2022-03-03 12:59:00'),(71148,204,'Mohsand','225302',1,0,'2022-03-03 12:59:00','2022-03-03 12:59:00'),(71149,204,'Motikpur','225416',1,0,'2022-03-03 12:59:00','2022-03-03 12:59:00'),(71150,204,'Mujeebpur','225301',1,0,'2022-03-03 12:59:00','2022-03-03 12:59:00'),(71151,204,'Munshiganj (Barabanki)','225001',1,0,'2022-03-03 12:59:00','2022-03-03 12:59:00'),(71152,204,'Muradabad','225301',1,0,'2022-03-03 12:59:00','2022-03-03 12:59:00'),(71153,204,'Mushkabad','225206',1,0,'2022-03-03 12:59:00','2022-03-03 12:59:00'),(71154,204,'Nahamau','225202',1,0,'2022-03-03 12:59:00','2022-03-03 12:59:00'),(71155,204,'Nainamau','225204',1,0,'2022-03-03 12:59:00','2022-03-03 12:59:00'),(71156,204,'Nandna Kala','225305',1,0,'2022-03-03 12:59:00','2022-03-03 12:59:00'),(71157,204,'Nanmau','225121',1,0,'2022-03-03 12:59:00','2022-03-03 12:59:00'),(71158,204,'Narain Bhari','225301',1,0,'2022-03-03 12:59:00','2022-03-03 12:59:00'),(71159,204,'Naseernagar','225204',1,0,'2022-03-03 12:59:00','2022-03-03 12:59:00'),(71160,204,'Neochhana','225413',1,0,'2022-03-03 12:59:00','2022-03-03 12:59:00'),(71161,204,'Neola Karsanda','225204',1,0,'2022-03-03 12:59:00','2022-03-03 12:59:00'),(71162,204,'Neoli','225121',1,0,'2022-03-03 12:59:00','2022-03-03 12:59:00'),(71163,204,'Neoli Danapur','225404',1,0,'2022-03-03 12:59:00','2022-03-03 12:59:00'),(71164,204,'Nindoora','225302',1,0,'2022-03-03 12:59:00','2022-03-03 12:59:00'),(71165,204,'Niyamatpur','225204',1,0,'2022-03-03 12:59:00','2022-03-03 12:59:00'),(71166,204,'Pahroopur','225404',1,0,'2022-03-03 12:59:00','2022-03-03 12:59:00'),(71167,204,'Paigamberpur','225416',1,0,'2022-03-03 12:59:00','2022-03-03 12:59:00'),(71168,204,'Palhari','225412',1,0,'2022-03-03 12:59:00','2022-03-03 12:59:00'),(71169,204,'Palia','225125',1,0,'2022-03-03 12:59:00','2022-03-03 12:59:00'),(71170,204,'Panapur','225415',1,0,'2022-03-03 12:59:01','2022-03-03 12:59:01'),(71171,204,'Pandari','225302',1,0,'2022-03-03 12:59:01','2022-03-03 12:59:01'),(71172,204,'Para Khandauli','225123',1,0,'2022-03-03 12:59:01','2022-03-03 12:59:01'),(71173,204,'Pareewan','225126',1,0,'2022-03-03 12:59:01','2022-03-03 12:59:01'),(71174,204,'Patmau','225121',1,0,'2022-03-03 12:59:01','2022-03-03 12:59:01'),(71175,204,'Patna','225301',1,0,'2022-03-03 12:59:01','2022-03-03 12:59:01'),(71176,204,'Patulki','225404',1,0,'2022-03-03 12:59:01','2022-03-03 12:59:01'),(71177,204,'Peend','225301',1,0,'2022-03-03 12:59:01','2022-03-03 12:59:01'),(71178,204,'Pokhra','225126',1,0,'2022-03-03 12:59:01','2022-03-03 12:59:01'),(71179,204,'Poore Chandraman','225416',1,0,'2022-03-03 12:59:01','2022-03-03 12:59:01'),(71180,204,'Puredalai','225401',1,0,'2022-03-03 12:59:01','2022-03-03 12:59:01'),(71181,204,'Puremanbhawan Singh','225208',1,0,'2022-03-03 12:59:01','2022-03-03 12:59:01'),(71182,204,'Pyarepur','225206',1,0,'2022-03-03 12:59:01','2022-03-03 12:59:01'),(71183,204,'Qusba Ichauli','225415',1,0,'2022-03-03 12:59:01','2022-03-03 12:59:01'),(71184,204,'Qyampur','225403',1,0,'2022-03-03 12:59:01','2022-03-03 12:59:01'),(71185,204,'Rahilamau','225306',1,0,'2022-03-03 12:59:01','2022-03-03 12:59:01'),(71186,204,'Ralbhari','225305',1,0,'2022-03-03 12:59:01','2022-03-03 12:59:01'),(71187,204,'Ram Mandai','225303',1,0,'2022-03-03 12:59:01','2022-03-03 12:59:01'),(71188,204,'Ram Sahai','225206',1,0,'2022-03-03 12:59:01','2022-03-03 12:59:01'),(71189,204,'Ram Sanehi Ghat','225409',1,0,'2022-03-03 12:59:01','2022-03-03 12:59:01'),(71190,204,'Ram Van Kuteer','225001',1,0,'2022-03-03 12:59:01','2022-03-03 12:59:01'),(71191,204,'Ramnagar Pareeva','225126',1,0,'2022-03-03 12:59:01','2022-03-03 12:59:01'),(71192,204,'Ramnagar (Barabanki)','225205',1,0,'2022-03-03 12:59:01','2022-03-03 12:59:01'),(71193,204,'Rampur Katra','225206',1,0,'2022-03-03 12:59:01','2022-03-03 12:59:01'),(71194,204,'Raniganj Bazar','225304',1,0,'2022-03-03 12:59:01','2022-03-03 12:59:01'),(71195,204,'Ranikatra','225415',1,0,'2022-03-03 12:59:02','2022-03-03 12:59:02'),(71196,204,'Ranimau Tarai','225415',1,0,'2022-03-03 12:59:02','2022-03-03 12:59:02'),(71197,204,'Rasauli','225001',1,0,'2022-03-03 12:59:02','2022-03-03 12:59:02'),(71198,204,'Rasoolpur','225301',1,0,'2022-03-03 12:59:02','2022-03-03 12:59:02'),(71199,204,'Rasoolpur','225401',1,0,'2022-03-03 12:59:02','2022-03-03 12:59:02'),(71200,204,'Rasoolpur','225302',1,0,'2022-03-03 12:59:02','2022-03-03 12:59:02'),(71201,204,'Ratauli','225124',1,0,'2022-03-03 12:59:02','2022-03-03 12:59:02'),(71202,204,'Rauli','225124',1,0,'2022-03-03 12:59:02','2022-03-03 12:59:02'),(71203,204,'Ruhera','225304',1,0,'2022-03-03 12:59:02','2022-03-03 12:59:02'),(71204,204,'Ruknuddinpur','225124',1,0,'2022-03-03 12:59:02','2022-03-03 12:59:02'),(71205,204,'Saadatganj (Barabanki)','225206',1,0,'2022-03-03 12:59:02','2022-03-03 12:59:02'),(71206,204,'Saalpur','225124',1,0,'2022-03-03 12:59:02','2022-03-03 12:59:02'),(71207,204,'Sadrapur','225306',1,0,'2022-03-03 12:59:02','2022-03-03 12:59:02'),(71208,204,'Sadruddinpur','225203',1,0,'2022-03-03 12:59:02','2022-03-03 12:59:02'),(71209,204,'Safderganj','225412',1,0,'2022-03-03 12:59:02','2022-03-03 12:59:02'),(71210,204,'Safedabad','225003',1,0,'2022-03-03 12:59:02','2022-03-03 12:59:02'),(71211,204,'Said Khanpur','225405',1,0,'2022-03-03 12:59:02','2022-03-03 12:59:02'),(71212,204,'Saidanpur','225206',1,0,'2022-03-03 12:59:02','2022-03-03 12:59:02'),(71213,204,'Saifpur','225412',1,0,'2022-03-03 12:59:02','2022-03-03 12:59:02'),(71214,204,'Salempur','225306',1,0,'2022-03-03 12:59:02','2022-03-03 12:59:02'),(71215,204,'Sanauli','225405',1,0,'2022-03-03 12:59:02','2022-03-03 12:59:02'),(71216,204,'Sarai Barai','225401',1,0,'2022-03-03 12:59:02','2022-03-03 12:59:02'),(71217,204,'Sarai Dunauli','225415',1,0,'2022-03-03 12:59:02','2022-03-03 12:59:02'),(71218,204,'Sarai Gopi','225125',1,0,'2022-03-03 12:59:02','2022-03-03 12:59:02'),(71219,204,'Sarai Kayasthan','225412',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71220,204,'Sarai Parsanda','225122',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71221,204,'Sarai Rawat','225124',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71222,204,'Sarhemau','225305',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71223,204,'Sarsa','225413',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71224,204,'Sarsaundi','225301',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71225,204,'Sarsawan','225305',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71226,204,'Satrikh','225122',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71227,204,'Semrai','225202',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71228,204,'Semrawan','225413',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71229,204,'Sethmau','225121',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71230,204,'Shafipur','225301',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71231,204,'Shahabpur','225001',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71232,204,'Shahpur','225409',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71233,204,'Shahpur Bhagauli','225306',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71234,204,'Shailie Keeratpur','225306',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71235,204,'Sharifabad','225125',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71236,204,'Shivnaam','225126',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71237,204,'Sidhaur','225413',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71238,204,'Sihali','225208',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71239,204,'Sikari Jeewal','225415',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71240,204,'Silhaur','225416',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71241,204,'Sirauli Gaus Pur','225207',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71242,204,'Sirauli Kalan','225202',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71243,204,'Sirauli Surjanpur','225305',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71244,204,'Sirkauli','225205',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71245,204,'Sirsaipur','225302',1,0,'2022-03-03 12:59:03','2022-03-03 12:59:03'),(71246,204,'Sohawan','225120',1,0,'2022-03-03 12:59:04','2022-03-03 12:59:04'),(71247,204,'Somaiya Nagar','225123',1,0,'2022-03-03 12:59:04','2022-03-03 12:59:04'),(71248,204,'Subeha','225125',1,0,'2022-03-03 12:59:04','2022-03-03 12:59:04'),(71249,204,'Sukhipur','225409',1,0,'2022-03-03 12:59:04','2022-03-03 12:59:04'),(71250,204,'Sulemabad','225302',1,0,'2022-03-03 12:59:04','2022-03-03 12:59:04'),(71251,204,'Sundhiyamau','225305',1,0,'2022-03-03 12:59:04','2022-03-03 12:59:04'),(71252,204,'Surajpur','225409',1,0,'2022-03-03 12:59:04','2022-03-03 12:59:04'),(71253,204,'Suratganj','225304',1,0,'2022-03-03 12:59:04','2022-03-03 12:59:04'),(71254,204,'Talgaon','225305',1,0,'2022-03-03 12:59:04','2022-03-03 12:59:04'),(71255,204,'Tarapur','225403',1,0,'2022-03-03 12:59:04','2022-03-03 12:59:04'),(71256,204,'Teergaon','225122',1,0,'2022-03-03 12:59:04','2022-03-03 12:59:04'),(71257,204,'Tehsil Fateh Pur','225305',1,0,'2022-03-03 12:59:04','2022-03-03 12:59:04'),(71258,204,'Tejwapur','225126',1,0,'2022-03-03 12:59:04','2022-03-03 12:59:04'),(71259,204,'Telwari','225202',1,0,'2022-03-03 12:59:04','2022-03-03 12:59:04'),(71260,204,'Telyani','225202',1,0,'2022-03-03 12:59:04','2022-03-03 12:59:04'),(71261,204,'Tera Kalan','225301',1,0,'2022-03-03 12:59:04','2022-03-03 12:59:04'),(71262,204,'Terhwa','225305',1,0,'2022-03-03 12:59:04','2022-03-03 12:59:04'),(71263,204,'Thalwara','225124',1,0,'2022-03-03 12:59:04','2022-03-03 12:59:04'),(71264,204,'Thorthia','225405',1,0,'2022-03-03 12:59:04','2022-03-03 12:59:04'),(71265,204,'Tikait Nagar','225415',1,0,'2022-03-03 12:59:04','2022-03-03 12:59:04'),(71266,204,'Tikaitganj','225302',1,0,'2022-03-03 12:59:04','2022-03-03 12:59:04'),(71267,204,'Tikariya Saidkhanpur','225416',1,0,'2022-03-03 12:59:05','2022-03-03 12:59:05'),(71268,204,'Tikra','225121',1,0,'2022-03-03 12:59:05','2022-03-03 12:59:05'),(71269,204,'Tilokpur (Barabanki)','225208',1,0,'2022-03-03 12:59:05','2022-03-03 12:59:05'),(71270,204,'Tilokpur Usmanpur','225126',1,0,'2022-03-03 12:59:05','2022-03-03 12:59:05'),(71271,204,'Tindola','225003',1,0,'2022-03-03 12:59:05','2022-03-03 12:59:05'),(71272,204,'Tiwaripur','225409',1,0,'2022-03-03 12:59:05','2022-03-03 12:59:05'),(71273,204,'Trivediganj','225126',1,0,'2022-03-03 12:59:05','2022-03-03 12:59:05'),(71274,204,'Uchita','225413',1,0,'2022-03-03 12:59:05','2022-03-03 12:59:05'),(71275,204,'Udhauli','225412',1,0,'2022-03-03 12:59:05','2022-03-03 12:59:05'),(71276,204,'Udwat Nagar','225415',1,0,'2022-03-03 12:59:05','2022-03-03 12:59:05'),(71277,204,'Ukhari','225301',1,0,'2022-03-03 12:59:05','2022-03-03 12:59:05'),(71278,204,'Umrawal Kirsia','225124',1,0,'2022-03-03 12:59:05','2022-03-03 12:59:05'),(71279,204,'Usmanpur','225120',1,0,'2022-03-03 12:59:05','2022-03-03 12:59:05'),(71280,204,'Watia','225305',1,0,'2022-03-03 12:59:05','2022-03-03 12:59:05'),(71281,204,'Yakootganj','225412',1,0,'2022-03-03 12:59:05','2022-03-03 12:59:05'),(71282,204,'Zaidpur','225414',1,0,'2022-03-03 12:59:05','2022-03-03 12:59:05'),(71283,204,'Aihar','224120',1,0,'2022-03-03 12:59:05','2022-03-03 12:59:05'),(71284,204,'Akhtiyarpur','224116',1,0,'2022-03-03 12:59:05','2022-03-03 12:59:05'),(71285,204,'Amraigaon','224118',1,0,'2022-03-03 12:59:05','2022-03-03 12:59:05'),(71286,204,'Bari','224120',1,0,'2022-03-03 12:59:05','2022-03-03 12:59:05'),(71287,204,'Bihara','224118',1,0,'2022-03-03 12:59:05','2022-03-03 12:59:05'),(71288,204,'Dewait','224118',1,0,'2022-03-03 12:59:05','2022-03-03 12:59:05'),(71289,204,'Ferozpur Makhdoomi','224120',1,0,'2022-03-03 12:59:05','2022-03-03 12:59:05'),(71290,204,'Giraunda','224119',1,0,'2022-03-03 12:59:05','2022-03-03 12:59:05'),(71291,204,'Hansrajpur','224118',1,0,'2022-03-03 12:59:05','2022-03-03 12:59:05'),(71292,204,'Hunhuna','224119',1,0,'2022-03-03 12:59:06','2022-03-03 12:59:06'),(71293,204,'Jakhauli','224119',1,0,'2022-03-03 12:59:06','2022-03-03 12:59:06'),(71294,204,'Jarail Kalan','224116',1,0,'2022-03-03 12:59:06','2022-03-03 12:59:06'),(71295,204,'Karaundi','224116',1,0,'2022-03-03 12:59:06','2022-03-03 12:59:06'),(71296,204,'Kasari','224118',1,0,'2022-03-03 12:59:06','2022-03-03 12:59:06'),(71297,204,'Khairi','224116',1,0,'2022-03-03 12:59:06','2022-03-03 12:59:06'),(71298,204,'Mathanewada','224118',1,0,'2022-03-03 12:59:06','2022-03-03 12:59:06'),(71299,204,'Narauli','224117',1,0,'2022-03-03 12:59:06','2022-03-03 12:59:06'),(71300,204,'Neora','224117',1,0,'2022-03-03 12:59:06','2022-03-03 12:59:06'),(71301,204,'Neoti','224120',1,0,'2022-03-03 12:59:06','2022-03-03 12:59:06'),(71302,204,'Pure Kamgar','224119',1,0,'2022-03-03 12:59:06','2022-03-03 12:59:06'),(71303,204,'Rampur Janak','224118',1,0,'2022-03-03 12:59:06','2022-03-03 12:59:06'),(71304,204,'Rani Mau Bhatthi','224119',1,0,'2022-03-03 12:59:06','2022-03-03 12:59:06'),(71305,204,'Rauzagaon','224116',1,0,'2022-03-03 12:59:06','2022-03-03 12:59:06'),(71306,204,'Saidpur','224118',1,0,'2022-03-03 12:59:06','2022-03-03 12:59:06'),(71307,204,'Saimsi','224118',1,0,'2022-03-03 12:59:06','2022-03-03 12:59:06'),(71308,204,'Sandawa','224117',1,0,'2022-03-03 12:59:06','2022-03-03 12:59:06'),(71309,204,'Saraitha','224116',1,0,'2022-03-03 12:59:06','2022-03-03 12:59:06'),(71310,204,'Seonrahara','224117',1,0,'2022-03-03 12:59:06','2022-03-03 12:59:06'),(71311,204,'Shahpur','224120',1,0,'2022-03-03 12:59:06','2022-03-03 12:59:06'),(71312,204,'Sherpur','224118',1,0,'2022-03-03 12:59:06','2022-03-03 12:59:06'),(71313,204,'Sithauli','224119',1,0,'2022-03-03 12:59:06','2022-03-03 12:59:06'),(71314,204,'Sunba','224118',1,0,'2022-03-03 12:59:06','2022-03-03 12:59:06'),(71315,204,'Talgaon','224118',1,0,'2022-03-03 12:59:07','2022-03-03 12:59:07'),(71316,205,'Umapur','224118',1,0,'2022-03-03 12:59:07','2022-03-03 12:59:07'),(71317,205,'Agras','243501',1,0,'2022-03-03 12:59:07','2022-03-03 12:59:07'),(71318,205,'Ahemdabad','243407',1,0,'2022-03-03 12:59:07','2022-03-03 12:59:07'),(71319,205,'Air Force Station Bareilly','243002',1,0,'2022-03-03 12:59:07','2022-03-03 12:59:07'),(71320,205,'Akha','243004',1,0,'2022-03-03 12:59:07','2022-03-03 12:59:07'),(71321,205,'Alahiya','262406',1,0,'2022-03-03 12:59:07','2022-03-03 12:59:07'),(71322,205,'Alampur Jafarabad','243401',1,0,'2022-03-03 12:59:07','2022-03-03 12:59:07'),(71323,205,'Aliganj','243302',1,0,'2022-03-03 12:59:07','2022-03-03 12:59:07'),(71324,205,'Angadpur Khamaria','243503',1,0,'2022-03-03 12:59:07','2022-03-03 12:59:07'),(71325,205,'Anurudhpur','243302',1,0,'2022-03-03 12:59:07','2022-03-03 12:59:07'),(71326,205,'Aonla Katra','243301',1,0,'2022-03-03 12:59:07','2022-03-03 12:59:07'),(71327,205,'Aonla Kila','243301',1,0,'2022-03-03 12:59:07','2022-03-03 12:59:07'),(71328,205,'Aonla','243301',1,0,'2022-03-03 12:59:07','2022-03-03 12:59:07'),(71329,205,'Atamanda','243202',1,0,'2022-03-03 12:59:07','2022-03-03 12:59:07'),(71330,205,'Atarchhedi','243302',1,0,'2022-03-03 12:59:07','2022-03-03 12:59:07'),(71331,205,'Athana','243503',1,0,'2022-03-03 12:59:07','2022-03-03 12:59:07'),(71332,205,'Attangachandpur','262406',1,0,'2022-03-03 12:59:07','2022-03-03 12:59:07'),(71333,205,'Aundh','243501',1,0,'2022-03-03 12:59:07','2022-03-03 12:59:07'),(71334,205,'B R Factory','243501',1,0,'2022-03-03 12:59:07','2022-03-03 12:59:07'),(71335,205,'Baboora','262406',1,0,'2022-03-03 12:59:07','2022-03-03 12:59:07'),(71336,205,'Baheri (Bareilly)','243201',1,0,'2022-03-03 12:59:07','2022-03-03 12:59:07'),(71337,205,'Bairamnagar','243505',1,0,'2022-03-03 12:59:07','2022-03-03 12:59:07'),(71338,205,'Balai Bhagwantpur','243302',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71339,205,'Balipur','243123',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71340,205,'Baljati','243003',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71341,205,'Balli','243505',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71342,205,'Ballia','243402',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71343,205,'Bapu Nagar','262406',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71344,205,'Baragoan','243303',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71345,205,'Baraur','243407',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71346,205,'Bareilly Cantt','243001',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71347,205,'Bareilly City','243003',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71348,205,'Bareilly College','243001',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71349,205,'Bareilly H.O','243001',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71350,205,'Bareilly Kty','243001',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71351,205,'Bareilly R.S','243001',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71352,205,'Bargawan','243506',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71353,205,'Barhepura','243407',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71354,205,'Barser Sikandarpur','243303',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71355,205,'Basantpur','243303',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71356,205,'Basudharan','243203',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71357,205,'Behroli','243504',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71358,205,'Beodhan Khurd','243303',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71359,205,'Bhadpura','262406',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71360,205,'Bhairpura','243202',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71361,205,'Bhamora','243401',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71362,205,'Bhandsar','243122',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71363,205,'Bhauwa Bazar','262406',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71364,205,'Bhikaripur','262201',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71365,205,'Bhitaura','243501',1,0,'2022-03-03 12:59:08','2022-03-03 12:59:08'),(71366,205,'Bhojipura','243202',1,0,'2022-03-03 12:59:09','2022-03-03 12:59:09'),(71367,205,'Bhura Bahadur Pur','243201',1,0,'2022-03-03 12:59:09','2022-03-03 12:59:09'),(71368,205,'Bhuta','243126',1,0,'2022-03-03 12:59:09','2022-03-03 12:59:09'),(71369,205,'Biharman Nagla','243122',1,0,'2022-03-03 12:59:09','2022-03-03 12:59:09'),(71370,205,'Bijamau','262406',1,0,'2022-03-03 12:59:09','2022-03-03 12:59:09'),(71371,205,'Bilasnagar','262406',1,0,'2022-03-03 12:59:09','2022-03-03 12:59:09'),(71372,205,'Bilwa','243202',1,0,'2022-03-03 12:59:09','2022-03-03 12:59:09'),(71373,205,'Bisharatganj','243302',1,0,'2022-03-03 12:59:09','2022-03-03 12:59:09'),(71374,205,'Bithri Chainpur','243123',1,0,'2022-03-03 12:59:09','2022-03-03 12:59:09'),(71375,205,'Bohit','243502',1,0,'2022-03-03 12:59:09','2022-03-03 12:59:09'),(71376,205,'Budhauuli','243503',1,0,'2022-03-03 12:59:09','2022-03-03 12:59:09'),(71377,205,'C.A.R.I','243122',1,0,'2022-03-03 12:59:09','2022-03-03 12:59:09'),(71378,205,'C.B. Ganj','243502',1,0,'2022-03-03 12:59:09','2022-03-03 12:59:09'),(71379,205,'Chakdah','243202',1,0,'2022-03-03 12:59:09','2022-03-03 12:59:09'),(71380,205,'Chanehti','243004',1,0,'2022-03-03 12:59:09','2022-03-03 12:59:09'),(71381,205,'Chathia','243203',1,0,'2022-03-03 12:59:09','2022-03-03 12:59:09'),(71382,205,'Chaubari','243004',1,0,'2022-03-03 12:59:09','2022-03-03 12:59:09'),(71383,205,'Chaupla','243001',1,0,'2022-03-03 12:59:09','2022-03-03 12:59:09'),(71384,205,'Dalelnagar','262406',1,0,'2022-03-03 12:59:09','2022-03-03 12:59:09'),(71385,205,'Dalpura','243503',1,0,'2022-03-03 12:59:09','2022-03-03 12:59:09'),(71386,205,'Damkhoda','243201',1,0,'2022-03-03 12:59:09','2022-03-03 12:59:09'),(71387,205,'Dandia Nagla','243201',1,0,'2022-03-03 12:59:10','2022-03-03 12:59:10'),(71388,205,'Dauli Raghuwar Dayal','243502',1,0,'2022-03-03 12:59:10','2022-03-03 12:59:10'),(71389,205,'Deochara','243401',1,0,'2022-03-03 12:59:10','2022-03-03 12:59:10'),(71390,205,'Deorania','243203',1,0,'2022-03-03 12:59:10','2022-03-03 12:59:10'),(71391,205,'Dhakni Rajpuri','243503',1,0,'2022-03-03 12:59:10','2022-03-03 12:59:10'),(71392,205,'Dhaneli','243505',1,0,'2022-03-03 12:59:10','2022-03-03 12:59:10'),(71393,205,'Dhaneta','243504',1,0,'2022-03-03 12:59:10','2022-03-03 12:59:10'),(71394,205,'Dhaura','243202',1,0,'2022-03-03 12:59:10','2022-03-03 12:59:10'),(71395,205,'Dhaurera','262406',1,0,'2022-03-03 12:59:10','2022-03-03 12:59:10'),(71396,205,'Dibna','243504',1,0,'2022-03-03 12:59:10','2022-03-03 12:59:10'),(71397,205,'Digoi','243301',1,0,'2022-03-03 12:59:10','2022-03-03 12:59:10'),(71398,205,'DOHRIYA','243126',1,0,'2022-03-03 12:59:10','2022-03-03 12:59:10'),(71399,205,'Dunda Sumali','243201',1,0,'2022-03-03 12:59:10','2022-03-03 12:59:10'),(71400,205,'Dunka','243505',1,0,'2022-03-03 12:59:10','2022-03-03 12:59:10'),(71401,205,'Faiznagar','243503',1,0,'2022-03-03 12:59:10','2022-03-03 12:59:10'),(71402,205,'Faridpur','243201',1,0,'2022-03-03 12:59:10','2022-03-03 12:59:10'),(71403,205,'Faridpur','243503',1,0,'2022-03-03 12:59:10','2022-03-03 12:59:10'),(71404,205,'Fateh Ganj (E)','243506',1,0,'2022-03-03 12:59:10','2022-03-03 12:59:10'),(71405,205,'Gaini','243302',1,0,'2022-03-03 12:59:10','2022-03-03 12:59:10'),(71406,205,'Gauntara','243502',1,0,'2022-03-03 12:59:10','2022-03-03 12:59:10'),(71407,205,'Gehluiya','243505',1,0,'2022-03-03 12:59:10','2022-03-03 12:59:10'),(71408,205,'Ghunsa','243502',1,0,'2022-03-03 12:59:10','2022-03-03 12:59:10'),(71409,205,'Girdharpur','243201',1,0,'2022-03-03 12:59:10','2022-03-03 12:59:10'),(71410,205,'Goola','243504',1,0,'2022-03-03 12:59:10','2022-03-03 12:59:10'),(71411,205,'Gotha Khandua','243301',1,0,'2022-03-03 12:59:11','2022-03-03 12:59:11'),(71412,205,'Grem','243407',1,0,'2022-03-03 12:59:11','2022-03-03 12:59:11'),(71413,205,'Gugai','243504',1,0,'2022-03-03 12:59:11','2022-03-03 12:59:11'),(71414,205,'Gulab Nagar','243003',1,0,'2022-03-03 12:59:11','2022-03-03 12:59:11'),(71415,205,'Gularia','243504',1,0,'2022-03-03 12:59:11','2022-03-03 12:59:11'),(71416,205,'Gularia Mohammad Hussain','243203',1,0,'2022-03-03 12:59:11','2022-03-03 12:59:11'),(71417,205,'Guleli','243301',1,0,'2022-03-03 12:59:11','2022-03-03 12:59:11'),(71418,205,'Gurgaon','243303',1,0,'2022-03-03 12:59:11','2022-03-03 12:59:11'),(71419,205,'Hafizganj','243407',1,0,'2022-03-03 12:59:11','2022-03-03 12:59:11'),(71420,205,'Haldi','243505',1,0,'2022-03-03 12:59:11','2022-03-03 12:59:11'),(71421,205,'Haraulia','243004',1,0,'2022-03-03 12:59:11','2022-03-03 12:59:11'),(71422,205,'Hardaspur','243303',1,0,'2022-03-03 12:59:11','2022-03-03 12:59:11'),(71423,205,'Harharpur','243407',1,0,'2022-03-03 12:59:11','2022-03-03 12:59:11'),(71424,205,'Hazipur Khazuria B','243503',1,0,'2022-03-03 12:59:11','2022-03-03 12:59:11'),(71425,205,'Himmatpur','243402',1,0,'2022-03-03 12:59:11','2022-03-03 12:59:11'),(71426,205,'Hurhuri','243504',1,0,'2022-03-03 12:59:11','2022-03-03 12:59:11'),(71427,205,'Iffcotownship','243403',1,0,'2022-03-03 12:59:11','2022-03-03 12:59:11'),(71428,205,'Itau Dhura','243201',1,0,'2022-03-03 12:59:11','2022-03-03 12:59:11'),(71429,205,'ITBP Bareilly','243004',1,0,'2022-03-03 12:59:11','2022-03-03 12:59:11'),(71430,205,'Izzat Nagar','243122',1,0,'2022-03-03 12:59:11','2022-03-03 12:59:11'),(71431,205,'Jaraul','243506',1,0,'2022-03-03 12:59:11','2022-03-03 12:59:11'),(71432,205,'Jasai Nagar','243201',1,0,'2022-03-03 12:59:11','2022-03-03 12:59:11'),(71433,205,'Jeoti Jagir','262406',1,0,'2022-03-03 12:59:11','2022-03-03 12:59:11'),(71434,205,'Jitaur','243302',1,0,'2022-03-03 12:59:11','2022-03-03 12:59:11'),(71435,205,'Jogither','243502',1,0,'2022-03-03 12:59:11','2022-03-03 12:59:11'),(71436,205,'Jokhanpur','243201',1,0,'2022-03-03 12:59:12','2022-03-03 12:59:12'),(71437,205,'Junahi','243505',1,0,'2022-03-03 12:59:12','2022-03-03 12:59:12'),(71438,205,'K.K.Niazia','243003',1,0,'2022-03-03 12:59:12','2022-03-03 12:59:12'),(71439,205,'K.S.W.Tulsi Nagar','243201',1,0,'2022-03-03 12:59:12','2022-03-03 12:59:12'),(71440,205,'Kaimua','243402',1,0,'2022-03-03 12:59:12','2022-03-03 12:59:12'),(71441,205,'Kakra Kalan','243503',1,0,'2022-03-03 12:59:12','2022-03-03 12:59:12'),(71442,205,'Kalyanpur','243302',1,0,'2022-03-03 12:59:12','2022-03-03 12:59:12'),(71443,205,'Kanakpuri','243505',1,0,'2022-03-03 12:59:12','2022-03-03 12:59:12'),(71444,205,'Kangaon','243301',1,0,'2022-03-03 12:59:12','2022-03-03 12:59:12'),(71445,205,'Kangawan Shyam','243303',1,0,'2022-03-03 12:59:12','2022-03-03 12:59:12'),(71446,205,'Kanman','243203',1,0,'2022-03-03 12:59:12','2022-03-03 12:59:12'),(71447,205,'Kareli','243004',1,0,'2022-03-03 12:59:12','2022-03-03 12:59:12'),(71448,205,'Karunapur Karoor','262203',1,0,'2022-03-03 12:59:12','2022-03-03 12:59:12'),(71449,205,'Kasumara','243301',1,0,'2022-03-03 12:59:12','2022-03-03 12:59:12'),(71450,205,'Katsari','243301',1,0,'2022-03-03 12:59:12','2022-03-03 12:59:12'),(71451,205,'Keolaria','262406',1,0,'2022-03-03 12:59:12','2022-03-03 12:59:12'),(71452,205,'Kesarpur','243303',1,0,'2022-03-03 12:59:12','2022-03-03 12:59:12'),(71453,205,'Khajuria Sriram','262406',1,0,'2022-03-03 12:59:12','2022-03-03 12:59:12'),(71454,205,'Khalilpur','243502',1,0,'2022-03-03 12:59:12','2022-03-03 12:59:12'),(71455,205,'Khanpur','243202',1,0,'2022-03-03 12:59:12','2022-03-03 12:59:12'),(71456,205,'Khateli','243503',1,0,'2022-03-03 12:59:12','2022-03-03 12:59:12'),(71457,205,'Khazuria Sampat','243123',1,0,'2022-03-03 12:59:13','2022-03-03 12:59:13'),(71458,205,'Khelam','243302',1,0,'2022-03-03 12:59:13','2022-03-03 12:59:13'),(71459,205,'Khera Ramnagar','243203',1,0,'2022-03-03 12:59:13','2022-03-03 12:59:13'),(71460,205,'Kiara','243004',1,0,'2022-03-03 12:59:13','2022-03-03 12:59:13'),(71461,205,'Kila','243003',1,0,'2022-03-03 12:59:13','2022-03-03 12:59:13'),(71462,205,'Koharapeer','243003',1,0,'2022-03-03 12:59:13','2022-03-03 12:59:13'),(71463,205,'Kuan Tanda','243503',1,0,'2022-03-03 12:59:13','2022-03-03 12:59:13'),(71464,205,'Kudha','243401',1,0,'2022-03-03 12:59:13','2022-03-03 12:59:13'),(71465,205,'Kulchha','243505',1,0,'2022-03-03 12:59:13','2022-03-03 12:59:13'),(71466,205,'Kundaria Faizulapur','243302',1,0,'2022-03-03 12:59:13','2022-03-03 12:59:13'),(71467,205,'Kunwar Pur','243003',1,0,'2022-03-03 12:59:13','2022-03-03 12:59:13'),(71468,205,'Kunwarpur Banzaria','243123',1,0,'2022-03-03 12:59:13','2022-03-03 12:59:13'),(71469,205,'Kusari','243401',1,0,'2022-03-03 12:59:13','2022-03-03 12:59:13'),(71470,205,'Labhari','243303',1,0,'2022-03-03 12:59:13','2022-03-03 12:59:13'),(71471,205,'Langura','243402',1,0,'2022-03-03 12:59:13','2022-03-03 12:59:13'),(71472,205,'Laungpur','243503',1,0,'2022-03-03 12:59:13','2022-03-03 12:59:13'),(71473,205,'Lilaur','243303',1,0,'2022-03-03 12:59:13','2022-03-03 12:59:13'),(71474,205,'Mahanagar','243006',1,0,'2022-03-03 12:59:13','2022-03-03 12:59:13'),(71475,205,'Majhgawan','243302',1,0,'2022-03-03 12:59:13','2022-03-03 12:59:13'),(71476,205,'Majhola (Bareilly)','262302',1,0,'2022-03-03 12:59:13','2022-03-03 12:59:13'),(71477,205,'Malgoan','243403',1,0,'2022-03-03 12:59:14','2022-03-03 12:59:14'),(71478,205,'Malook Pur','243003',1,0,'2022-03-03 12:59:14','2022-03-03 12:59:14'),(71479,205,'Man Pur','243201',1,0,'2022-03-03 12:59:14','2022-03-03 12:59:14'),(71480,205,'Mandanpur','243504',1,0,'2022-03-03 12:59:14','2022-03-03 12:59:14'),(71481,205,'Mandauli','243502',1,0,'2022-03-03 12:59:14','2022-03-03 12:59:14'),(71482,205,'Mandora','243302',1,0,'2022-03-03 12:59:14','2022-03-03 12:59:14'),(71483,205,'Mango Road','243001',1,0,'2022-03-03 12:59:14','2022-03-03 12:59:14'),(71484,205,'Manona','243301',1,0,'2022-03-03 12:59:14','2022-03-03 12:59:14'),(71485,205,'Marhi Sukatia','243503',1,0,'2022-03-03 12:59:14','2022-03-03 12:59:14'),(71486,205,'Marhinath Road','243001',1,0,'2022-03-03 12:59:14','2022-03-03 12:59:14'),(71487,205,'Masjid Domni','243003',1,0,'2022-03-03 12:59:14','2022-03-03 12:59:14'),(71488,205,'Mau Chandpur','243303',1,0,'2022-03-03 12:59:14','2022-03-03 12:59:14'),(71489,205,'Mawai Kazian','243505',1,0,'2022-03-03 12:59:14','2022-03-03 12:59:14'),(71490,205,'Meerapur Rafiabad','243501',1,0,'2022-03-03 12:59:14','2022-03-03 12:59:14'),(71491,205,'Meerganj (Bareilly)','243504',1,0,'2022-03-03 12:59:14','2022-03-03 12:59:14'),(71492,205,'Mehmoodpur','243301',1,0,'2022-03-03 12:59:14','2022-03-03 12:59:14'),(71493,205,'Mehmoodpur','243505',1,0,'2022-03-03 12:59:14','2022-03-03 12:59:14'),(71494,205,'Mehtarpur','243123',1,0,'2022-03-03 12:59:14','2022-03-03 12:59:14'),(71495,205,'Milak Majhera','243402',1,0,'2022-03-03 12:59:14','2022-03-03 12:59:14'),(71496,205,'Mission Hospital','243001',1,0,'2022-03-03 12:59:14','2022-03-03 12:59:14'),(71497,205,'Mohammad Ganj','243501',1,0,'2022-03-03 12:59:14','2022-03-03 12:59:14'),(71498,205,'Mohammadpur Pathra','243301',1,0,'2022-03-03 12:59:14','2022-03-03 12:59:14'),(71499,205,'Mohanpur','243123',1,0,'2022-03-03 12:59:15','2022-03-03 12:59:15'),(71500,205,'Mundia Ahamad Nagar','243122',1,0,'2022-03-03 12:59:15','2022-03-03 12:59:15'),(71501,205,'Mundia Bhikampur','243407',1,0,'2022-03-03 12:59:15','2022-03-03 12:59:15'),(71502,205,'Mundia Jagir','243203',1,0,'2022-03-03 12:59:15','2022-03-03 12:59:15'),(71503,205,'Mundia Nabi Bux','243201',1,0,'2022-03-03 12:59:15','2022-03-03 12:59:15'),(71504,205,'Mundia Teli','262406',1,0,'2022-03-03 12:59:15','2022-03-03 12:59:15'),(71505,205,'Municipal Board','243001',1,0,'2022-03-03 12:59:15','2022-03-03 12:59:15'),(71506,205,'Nadeli','243201',1,0,'2022-03-03 12:59:15','2022-03-03 12:59:15'),(71507,205,'Nagaria Kalan','243506',1,0,'2022-03-03 12:59:15','2022-03-03 12:59:15'),(71508,205,'Nagaria Sobarni','243505',1,0,'2022-03-03 12:59:15','2022-03-03 12:59:15'),(71509,205,'Nagaria Vikram','243503',1,0,'2022-03-03 12:59:15','2022-03-03 12:59:15'),(71510,205,'Nandausi','243502',1,0,'2022-03-03 12:59:15','2022-03-03 12:59:15'),(71511,205,'Narharpur Gaurikhera','262406',1,0,'2022-03-03 12:59:15','2022-03-03 12:59:15'),(71512,205,'Narkhera','243505',1,0,'2022-03-03 12:59:15','2022-03-03 12:59:15'),(71513,205,'Naugawan Bramhanan','243302',1,0,'2022-03-03 12:59:15','2022-03-03 12:59:15'),(71514,205,'Naugawan Thakuran','243402',1,0,'2022-03-03 12:59:15','2022-03-03 12:59:15'),(71515,205,'Naurangpur','243402',1,0,'2022-03-03 12:59:15','2022-03-03 12:59:15'),(71516,205,'Nawabganj (Bareilly)','262406',1,0,'2022-03-03 12:59:15','2022-03-03 12:59:15'),(71517,205,'Nawada Bilsandi','243503',1,0,'2022-03-03 12:59:15','2022-03-03 12:59:15'),(71518,205,'Nazarganj','243201',1,0,'2022-03-03 12:59:15','2022-03-03 12:59:15'),(71519,205,'Nc Lines Bareilly','243001',1,0,'2022-03-03 12:59:15','2022-03-03 12:59:15'),(71520,205,'Ner Workshop','243122',1,0,'2022-03-03 12:59:15','2022-03-03 12:59:15'),(71521,205,'Nisui','243302',1,0,'2022-03-03 12:59:15','2022-03-03 12:59:15'),(71522,205,'Noorpur','243301',1,0,'2022-03-03 12:59:16','2022-03-03 12:59:16'),(71523,205,'Nrmc','243122',1,0,'2022-03-03 12:59:16','2022-03-03 12:59:16'),(71524,205,'Old City','243005',1,0,'2022-03-03 12:59:16','2022-03-03 12:59:16'),(71525,205,'P.A.C.Dso','243123',1,0,'2022-03-03 12:59:16','2022-03-03 12:59:16'),(71526,205,'Pachdeora Kalan','243202',1,0,'2022-03-03 12:59:16','2022-03-03 12:59:16'),(71527,205,'Pachomi','243503',1,0,'2022-03-03 12:59:16','2022-03-03 12:59:16'),(71528,205,'Pachpera','243201',1,0,'2022-03-03 12:59:16','2022-03-03 12:59:16'),(71529,205,'Padarathpur','243123',1,0,'2022-03-03 12:59:16','2022-03-03 12:59:16'),(71530,205,'Paiga','243407',1,0,'2022-03-03 12:59:16','2022-03-03 12:59:16'),(71531,205,'Parasrampur','262406',1,0,'2022-03-03 12:59:16','2022-03-03 12:59:16'),(71532,205,'Phulasi','243301',1,0,'2022-03-03 12:59:16','2022-03-03 12:59:16'),(71533,205,'Pindari Ashok','243201',1,0,'2022-03-03 12:59:16','2022-03-03 12:59:16'),(71534,205,'Piperthara','243503',1,0,'2022-03-03 12:59:16','2022-03-03 12:59:16'),(71535,205,'Prem Nagar (Bareilly)','243005',1,0,'2022-03-03 12:59:16','2022-03-03 12:59:16'),(71536,205,'Qadarganj','243503',1,0,'2022-03-03 12:59:16','2022-03-03 12:59:16'),(71537,205,'R.K.University','243006',1,0,'2022-03-03 12:59:16','2022-03-03 12:59:16'),(71538,205,'Raipur Hans','243503',1,0,'2022-03-03 12:59:16','2022-03-03 12:59:16'),(71539,205,'Rajau Paraspur','243123',1,0,'2022-03-03 12:59:16','2022-03-03 12:59:16'),(71540,205,'Rajendra Nagar (Bareilly)','243122',1,0,'2022-03-03 12:59:16','2022-03-03 12:59:16'),(71541,205,'Rajupur','243401',1,0,'2022-03-03 12:59:16','2022-03-03 12:59:16'),(71542,205,'Rajupur Kalan','243302',1,0,'2022-03-03 12:59:16','2022-03-03 12:59:16'),(71543,205,'Ram Nagar (Bareilly)','243303',1,0,'2022-03-03 12:59:16','2022-03-03 12:59:16'),(71544,205,'Rampura Ratan','243503',1,0,'2022-03-03 12:59:17','2022-03-03 12:59:17'),(71545,205,'Rasoolpur','243201',1,0,'2022-03-03 12:59:17','2022-03-03 12:59:17'),(71546,205,'Rath','243201',1,0,'2022-03-03 12:59:17','2022-03-03 12:59:17'),(71547,205,'Ratna','243407',1,0,'2022-03-03 12:59:17','2022-03-03 12:59:17'),(71548,205,'Rehpura Ganimat','243203',1,0,'2022-03-03 12:59:17','2022-03-03 12:59:17'),(71549,205,'Reoti','243301',1,0,'2022-03-03 12:59:17','2022-03-03 12:59:17'),(71550,205,'Richha','243201',1,0,'2022-03-03 12:59:17','2022-03-03 12:59:17'),(71551,205,'Rithora','243122',1,0,'2022-03-03 12:59:17','2022-03-03 12:59:17'),(71552,205,'Rohili','243203',1,0,'2022-03-03 12:59:17','2022-03-03 12:59:17'),(71553,205,'Rukumpur','262406',1,0,'2022-03-03 12:59:17','2022-03-03 12:59:17'),(71554,205,'Sadar Bazar (Bareilly)','243001',1,0,'2022-03-03 12:59:17','2022-03-03 12:59:17'),(71555,205,'Sahasa','243302',1,0,'2022-03-03 12:59:17','2022-03-03 12:59:17'),(71556,205,'Sahora','243505',1,0,'2022-03-03 12:59:17','2022-03-03 12:59:17'),(71557,205,'Saidpur Hakins','243122',1,0,'2022-03-03 12:59:17','2022-03-03 12:59:17'),(71558,205,'Samaspur','243504',1,0,'2022-03-03 12:59:17','2022-03-03 12:59:17'),(71559,205,'Sarai Talfi','243004',1,0,'2022-03-03 12:59:17','2022-03-03 12:59:17'),(71560,205,'Sarau','243402',1,0,'2022-03-03 12:59:17','2022-03-03 12:59:17'),(71561,205,'Sardar Nagar Ghat','243402',1,0,'2022-03-03 12:59:17','2022-03-03 12:59:17'),(71562,205,'Sardarnagar','262406',1,0,'2022-03-03 12:59:17','2022-03-03 12:59:17'),(71563,205,'Sarkara','243503',1,0,'2022-03-03 12:59:17','2022-03-03 12:59:17'),(71564,205,'Senthal','243407',1,0,'2022-03-03 12:59:17','2022-03-03 12:59:17'),(71565,205,'Shahi','243505',1,0,'2022-03-03 12:59:17','2022-03-03 12:59:17'),(71566,205,'Shahpur Baniyan','243506',1,0,'2022-03-03 12:59:17','2022-03-03 12:59:17'),(71567,205,'Shamat Ganj','243005',1,0,'2022-03-03 12:59:17','2022-03-03 12:59:17'),(71568,205,'Sharif Nagar','243201',1,0,'2022-03-03 12:59:17','2022-03-03 12:59:17'),(71569,205,'Sheeshgarh','243505',1,0,'2022-03-03 12:59:18','2022-03-03 12:59:18'),(71570,205,'Shehdana Colony','243003',1,0,'2022-03-03 12:59:18','2022-03-03 12:59:18'),(71571,205,'Shergarh','243505',1,0,'2022-03-03 12:59:18','2022-03-03 12:59:18'),(71572,205,'Shivaji Marg (Bareilly)','243003',1,0,'2022-03-03 12:59:18','2022-03-03 12:59:18'),(71573,205,'Shivpuri','243303',1,0,'2022-03-03 12:59:18','2022-03-03 12:59:18'),(71574,205,'Shivpuri Raudhauli','243506',1,0,'2022-03-03 12:59:18','2022-03-03 12:59:18'),(71575,205,'Shubhash Market','243003',1,0,'2022-03-03 12:59:18','2022-03-03 12:59:18'),(71576,205,'Shubhash Nagar','243003',1,0,'2022-03-03 12:59:18','2022-03-03 12:59:18'),(71577,205,'Shyam Ganj','243005',1,0,'2022-03-03 12:59:18','2022-03-03 12:59:18'),(71578,205,'Siatheri','243201',1,0,'2022-03-03 12:59:18','2022-03-03 12:59:18'),(71579,205,'Simaria','243504',1,0,'2022-03-03 12:59:18','2022-03-03 12:59:18'),(71580,205,'Simra Akbar Ganj','262203',1,0,'2022-03-03 12:59:18','2022-03-03 12:59:18'),(71581,205,'Simra Bahor Nagla','243503',1,0,'2022-03-03 12:59:18','2022-03-03 12:59:18'),(71582,205,'Simra Boripur','243004',1,0,'2022-03-03 12:59:18','2022-03-03 12:59:18'),(71583,205,'SINDHAULI','243504',1,0,'2022-03-03 12:59:18','2022-03-03 12:59:18'),(71584,205,'Singha','243402',1,0,'2022-03-03 12:59:18','2022-03-03 12:59:18'),(71585,205,'Sirauli','243303',1,0,'2022-03-03 12:59:18','2022-03-03 12:59:18'),(71586,205,'Sirohi','243401',1,0,'2022-03-03 12:59:18','2022-03-03 12:59:18'),(71587,205,'Sirsa Jagir','243501',1,0,'2022-03-03 12:59:18','2022-03-03 12:59:18'),(71588,205,'Sona','243303',1,0,'2022-03-03 12:59:18','2022-03-03 12:59:18'),(71589,205,'Soraha','243501',1,0,'2022-03-03 12:59:18','2022-03-03 12:59:18'),(71590,205,'Sudanpur','243302',1,0,'2022-03-03 12:59:18','2022-03-03 12:59:18'),(71591,205,'Sundari Amsah','262406',1,0,'2022-03-03 12:59:18','2022-03-03 12:59:18'),(71592,205,'Sunha','243503',1,0,'2022-03-03 12:59:19','2022-03-03 12:59:19'),(71593,205,'Surkha','243003',1,0,'2022-03-03 12:59:19','2022-03-03 12:59:19'),(71594,205,'Surla','243202',1,0,'2022-03-03 12:59:19','2022-03-03 12:59:19'),(71595,205,'Swale Nagar','243502',1,0,'2022-03-03 12:59:19','2022-03-03 12:59:19'),(71596,205,'Tanda','243301',1,0,'2022-03-03 12:59:19','2022-03-03 12:59:19'),(71597,205,'Tara Khas','243506',1,0,'2022-03-03 12:59:19','2022-03-03 12:59:19'),(71598,205,'Tehsil Aonla','243301',1,0,'2022-03-03 12:59:19','2022-03-03 12:59:19'),(71599,205,'Teolia','243502',1,0,'2022-03-03 12:59:19','2022-03-03 12:59:19'),(71600,205,'Thiria Nizawatkhan','243123',1,0,'2022-03-03 12:59:19','2022-03-03 12:59:19'),(71601,205,'Tiliapurbo','243502',1,0,'2022-03-03 12:59:19','2022-03-03 12:59:19'),(71602,205,'Tiswa','243506',1,0,'2022-03-03 12:59:19','2022-03-03 12:59:19'),(71603,205,'Umarsia','243004',1,0,'2022-03-03 12:59:19','2022-03-03 12:59:19'),(71604,205,'Urla','243301',1,0,'2022-03-03 12:59:19','2022-03-03 12:59:19'),(71605,205,'Yaqoobganj','243201',1,0,'2022-03-03 12:59:19','2022-03-03 12:59:19'),(71606,206,'Ainpur','272163',1,0,'2022-03-03 12:59:19','2022-03-03 12:59:19'),(71607,206,'Ajgaiba Jungle','272163',1,0,'2022-03-03 12:59:19','2022-03-03 12:59:19'),(71608,206,'Amarediha','272194',1,0,'2022-03-03 12:59:19','2022-03-03 12:59:19'),(71609,206,'Amari Bazar','272155',1,0,'2022-03-03 12:59:19','2022-03-03 12:59:19'),(71610,206,'Amauna Pandey','272191',1,0,'2022-03-03 12:59:19','2022-03-03 12:59:19'),(71611,206,'Ambari','272150',1,0,'2022-03-03 12:59:19','2022-03-03 12:59:19'),(71612,206,'Amorha','272127',1,0,'2022-03-03 12:59:19','2022-03-03 12:59:19'),(71613,206,'Amrauli Sumali','272190',1,0,'2022-03-03 12:59:20','2022-03-03 12:59:20'),(71614,206,'Asnahra','272194',1,0,'2022-03-03 12:59:20','2022-03-03 12:59:20'),(71615,206,'Asnar','272153',1,0,'2022-03-03 12:59:20','2022-03-03 12:59:20'),(71616,206,'Asogwa','272153',1,0,'2022-03-03 12:59:20','2022-03-03 12:59:20'),(71617,206,'Athadama','272151',1,0,'2022-03-03 12:59:20','2022-03-03 12:59:20'),(71618,206,'Atraura','272175',1,0,'2022-03-03 12:59:20','2022-03-03 12:59:20'),(71619,206,'Audahi Kalan','272201',1,0,'2022-03-03 12:59:20','2022-03-03 12:59:20'),(71620,206,'Babhnan','272161',1,0,'2022-03-03 12:59:20','2022-03-03 12:59:20'),(71621,206,'Babhnauli','272165',1,0,'2022-03-03 12:59:20','2022-03-03 12:59:20'),(71622,206,'Baghari','272170',1,0,'2022-03-03 12:59:20','2022-03-03 12:59:20'),(71623,206,'Baghauli','272175',1,0,'2022-03-03 12:59:20','2022-03-03 12:59:20'),(71624,206,'Baghnagar','272002',1,0,'2022-03-03 12:59:20','2022-03-03 12:59:20'),(71625,206,'Bahadurpur','272302',1,0,'2022-03-03 12:59:20','2022-03-03 12:59:20'),(71626,206,'Bai Pokhar','272002',1,0,'2022-03-03 12:59:20','2022-03-03 12:59:20'),(71627,206,'Bai.Mustahkam','272301',1,0,'2022-03-03 12:59:20','2022-03-03 12:59:20'),(71628,206,'Baijnathpur','272165',1,0,'2022-03-03 12:59:20','2022-03-03 12:59:20'),(71629,206,'Bairagal','272131',1,0,'2022-03-03 12:59:20','2022-03-03 12:59:20'),(71630,206,'Bairikhala','272163',1,0,'2022-03-03 12:59:20','2022-03-03 12:59:20'),(71631,206,'Bajahara','272125',1,0,'2022-03-03 12:59:20','2022-03-03 12:59:20'),(71632,206,'Bakainia','272165',1,0,'2022-03-03 12:59:20','2022-03-03 12:59:20'),(71633,206,'Bangawa','272153',1,0,'2022-03-03 12:59:20','2022-03-03 12:59:20'),(71634,206,'Bankata','272002',1,0,'2022-03-03 12:59:20','2022-03-03 12:59:20'),(71635,206,'Bankati Bazar','272123',1,0,'2022-03-03 12:59:20','2022-03-03 12:59:20'),(71636,206,'Bankatia','272151',1,0,'2022-03-03 12:59:21','2022-03-03 12:59:21'),(71637,206,'Bankuiya','272153',1,0,'2022-03-03 12:59:21','2022-03-03 12:59:21'),(71638,206,'Banpur (Basti)','272177',1,0,'2022-03-03 12:59:21','2022-03-03 12:59:21'),(71639,206,'Bansgoan','272170',1,0,'2022-03-03 12:59:21','2022-03-03 12:59:21'),(71640,206,'Bansi H.O','272153',1,0,'2022-03-03 12:59:21','2022-03-03 12:59:21'),(71641,206,'Banskhor Kalan','272126',1,0,'2022-03-03 12:59:21','2022-03-03 12:59:21'),(71642,206,'Barahata','272131',1,0,'2022-03-03 12:59:21','2022-03-03 12:59:21'),(71643,206,'Barahpur','272155',1,0,'2022-03-03 12:59:21','2022-03-03 12:59:21'),(71644,206,'Barahpur','272163',1,0,'2022-03-03 12:59:21','2022-03-03 12:59:21'),(71645,206,'Barahuwan','272123',1,0,'2022-03-03 12:59:21','2022-03-03 12:59:21'),(71646,206,'Bardia Kunwar','272128',1,0,'2022-03-03 12:59:21','2022-03-03 12:59:21'),(71647,206,'Bargadwa  Khabhri','272153',1,0,'2022-03-03 12:59:21','2022-03-03 12:59:21'),(71648,206,'Bargadwa','272190',1,0,'2022-03-03 12:59:21','2022-03-03 12:59:21'),(71649,206,'Bargo','272175',1,0,'2022-03-03 12:59:21','2022-03-03 12:59:21'),(71650,206,'Barhni','272131',1,0,'2022-03-03 12:59:21','2022-03-03 12:59:21'),(71651,206,'Barhni','272201',1,0,'2022-03-03 12:59:21','2022-03-03 12:59:21'),(71652,206,'Barhya','272161',1,0,'2022-03-03 12:59:21','2022-03-03 12:59:21'),(71653,206,'Basantpur','272153',1,0,'2022-03-03 12:59:21','2022-03-03 12:59:21'),(71654,206,'Basti B.S.','272002',1,0,'2022-03-03 12:59:21','2022-03-03 12:59:21'),(71655,206,'Basti H.O','272001',1,0,'2022-03-03 12:59:21','2022-03-03 12:59:21'),(71656,206,'Basti Huchhary','272001',1,0,'2022-03-03 12:59:21','2022-03-03 12:59:21'),(71657,206,'Basti Sugar Factory','272002',1,0,'2022-03-03 12:59:21','2022-03-03 12:59:21'),(71658,206,'Beili','272302',1,0,'2022-03-03 12:59:21','2022-03-03 12:59:21'),(71659,206,'Belbharia Ram Gulam','272181',1,0,'2022-03-03 12:59:22','2022-03-03 12:59:22'),(71660,206,'Belghat','272163',1,0,'2022-03-03 12:59:22','2022-03-03 12:59:22'),(71661,206,'Belhara','272182',1,0,'2022-03-03 12:59:22','2022-03-03 12:59:22'),(71662,206,'Belsar','272163',1,0,'2022-03-03 12:59:22','2022-03-03 12:59:22'),(71663,206,'Belwaria Jungle','272163',1,0,'2022-03-03 12:59:22','2022-03-03 12:59:22'),(71664,206,'Bemhari','272131',1,0,'2022-03-03 12:59:22','2022-03-03 12:59:22'),(71665,206,'Bhadawal','272155',1,0,'2022-03-03 12:59:22','2022-03-03 12:59:22'),(71666,206,'Bhainsa Chaubey','272163',1,0,'2022-03-03 12:59:22','2022-03-03 12:59:22'),(71667,206,'Bhainsa Khoont','272165',1,0,'2022-03-03 12:59:22','2022-03-03 12:59:22'),(71668,206,'Bhainsaha','272130',1,0,'2022-03-03 12:59:22','2022-03-03 12:59:22'),(71669,206,'Bhangura','272301',1,0,'2022-03-03 12:59:22','2022-03-03 12:59:22'),(71670,206,'Bhanpur Babu','272194',1,0,'2022-03-03 12:59:22','2022-03-03 12:59:22'),(71671,206,'Bhanwari','272153',1,0,'2022-03-03 12:59:22','2022-03-03 12:59:22'),(71672,206,'Bharwalia','272123',1,0,'2022-03-03 12:59:22','2022-03-03 12:59:22'),(71673,206,'Bhawanipur','272124',1,0,'2022-03-03 12:59:22','2022-03-03 12:59:22'),(71674,206,'Bhelkha','272002',1,0,'2022-03-03 12:59:22','2022-03-03 12:59:22'),(71675,206,'Bhitani','272177',1,0,'2022-03-03 12:59:22','2022-03-03 12:59:22'),(71676,206,'Bhitehara','272151',1,0,'2022-03-03 12:59:22','2022-03-03 12:59:22'),(71677,206,'Bhivra','272125',1,0,'2022-03-03 12:59:22','2022-03-03 12:59:22'),(71678,206,'Bishesharganj','272128',1,0,'2022-03-03 12:59:22','2022-03-03 12:59:22'),(71679,206,'Bishunpurwa','272190',1,0,'2022-03-03 12:59:22','2022-03-03 12:59:22'),(71680,206,'Bodwal','272170',1,0,'2022-03-03 12:59:22','2022-03-03 12:59:22'),(71681,206,'Burhi Belhar','272125',1,0,'2022-03-03 12:59:22','2022-03-03 12:59:22'),(71682,206,'Captainganj (Basti)','272131',1,0,'2022-03-03 12:59:23','2022-03-03 12:59:23'),(71683,206,'Chaukwa','272190',1,0,'2022-03-03 12:59:23','2022-03-03 12:59:23'),(71684,206,'Chhagulia Bagulia','272125',1,0,'2022-03-03 12:59:23','2022-03-03 12:59:23'),(71685,206,'Chhapia Sheobaran','272002',1,0,'2022-03-03 12:59:23','2022-03-03 12:59:23'),(71686,206,'Chharahata','272151',1,0,'2022-03-03 12:59:23','2022-03-03 12:59:23'),(71687,206,'Chhardahi','272301',1,0,'2022-03-03 12:59:23','2022-03-03 12:59:23'),(71688,206,'Chilma Bazar','272301',1,0,'2022-03-03 12:59:23','2022-03-03 12:59:23'),(71689,206,'Chorkhari','272155',1,0,'2022-03-03 12:59:23','2022-03-03 12:59:23'),(71690,206,'Civil Line (Basti)','272001',1,0,'2022-03-03 12:59:23','2022-03-03 12:59:23'),(71691,206,'Dailapur','272131',1,0,'2022-03-03 12:59:23','2022-03-03 12:59:23'),(71692,206,'Dakhin Darwaza','272002',1,0,'2022-03-03 12:59:23','2022-03-03 12:59:23'),(71693,206,'Dandwakala','272126',1,0,'2022-03-03 12:59:23','2022-03-03 12:59:23'),(71694,206,'Dandwapandey','272148',1,0,'2022-03-03 12:59:23','2022-03-03 12:59:23'),(71695,206,'Danokuiya','272126',1,0,'2022-03-03 12:59:23','2022-03-03 12:59:23'),(71696,206,'Dasia','272150',1,0,'2022-03-03 12:59:23','2022-03-03 12:59:23'),(71697,206,'Deferi','272130',1,0,'2022-03-03 12:59:23','2022-03-03 12:59:23'),(71698,206,'Deisand','272123',1,0,'2022-03-03 12:59:23','2022-03-03 12:59:23'),(71699,206,'Delhwa','272301',1,0,'2022-03-03 12:59:23','2022-03-03 12:59:23'),(71700,206,'Dewapar','272302',1,0,'2022-03-03 12:59:23','2022-03-03 12:59:23'),(71701,206,'Dhaurahra','272194',1,0,'2022-03-03 12:59:23','2022-03-03 12:59:23'),(71702,206,'Dhawai','272194',1,0,'2022-03-03 12:59:23','2022-03-03 12:59:23'),(71703,206,'Dhenugawan','272129',1,0,'2022-03-03 12:59:23','2022-03-03 12:59:23'),(71704,206,'Dhirauli Babu','272127',1,0,'2022-03-03 12:59:23','2022-03-03 12:59:23'),(71705,206,'Dhosar','272194',1,0,'2022-03-03 12:59:23','2022-03-03 12:59:23'),(71706,206,'Dihukpura','272301',1,0,'2022-03-03 12:59:23','2022-03-03 12:59:23'),(71707,206,'Dingrapur','272301',1,0,'2022-03-03 12:59:23','2022-03-03 12:59:23'),(71708,206,'Diwakarpur','272181',1,0,'2022-03-03 12:59:24','2022-03-03 12:59:24'),(71709,206,'Dubauli Dubey','272131',1,0,'2022-03-03 12:59:24','2022-03-03 12:59:24'),(71710,206,'Dubaulia','272131',1,0,'2022-03-03 12:59:24','2022-03-03 12:59:24'),(71711,206,'Dudhara','272125',1,0,'2022-03-03 12:59:24','2022-03-03 12:59:24'),(71712,206,'Dudhaura','272002',1,0,'2022-03-03 12:59:24','2022-03-03 12:59:24'),(71713,206,'Ekdangi','272170',1,0,'2022-03-03 12:59:24','2022-03-03 12:59:24'),(71714,206,'Gaighat','272301',1,0,'2022-03-03 12:59:24','2022-03-03 12:59:24'),(71715,206,'Gandhinagar (Basti)','272001',1,0,'2022-03-03 12:59:24','2022-03-03 12:59:24'),(71716,206,'Ganeshpur','272002',1,0,'2022-03-03 12:59:24','2022-03-03 12:59:24'),(71717,206,'Garha','272131',1,0,'2022-03-03 12:59:24','2022-03-03 12:59:24'),(71718,206,'Gauhania','272155',1,0,'2022-03-03 12:59:24','2022-03-03 12:59:24'),(71719,206,'Gaur Rs','272163',1,0,'2022-03-03 12:59:24','2022-03-03 12:59:24'),(71720,206,'Gaura','272002',1,0,'2022-03-03 12:59:24','2022-03-03 12:59:24'),(71721,206,'Gaura Upadhyay','272124',1,0,'2022-03-03 12:59:24','2022-03-03 12:59:24'),(71722,206,'Gauspur','272301',1,0,'2022-03-03 12:59:24','2022-03-03 12:59:24'),(71723,206,'Ghorsayen','272127',1,0,'2022-03-03 12:59:24','2022-03-03 12:59:24'),(71724,206,'Gonare','272171',1,0,'2022-03-03 12:59:24','2022-03-03 12:59:24'),(71725,206,'Gopiapar','272131',1,0,'2022-03-03 12:59:24','2022-03-03 12:59:24'),(71726,206,'Gopinathpur','272130',1,0,'2022-03-03 12:59:24','2022-03-03 12:59:24'),(71727,206,'Govindpara','272131',1,0,'2022-03-03 12:59:24','2022-03-03 12:59:24'),(71728,206,'Gulariha Sirma','272170',1,0,'2022-03-03 12:59:24','2022-03-03 12:59:24'),(71729,206,'Gunakhor','272126',1,0,'2022-03-03 12:59:24','2022-03-03 12:59:24'),(71730,206,'Hanumanganj (Basti)','272150',1,0,'2022-03-03 12:59:24','2022-03-03 12:59:24'),(71731,206,'Haribanshpur','272131',1,0,'2022-03-03 12:59:25','2022-03-03 12:59:25'),(71732,206,'Harish Nagar','272130',1,0,'2022-03-03 12:59:25','2022-03-03 12:59:25'),(71733,206,'Harraiya','272155',1,0,'2022-03-03 12:59:25','2022-03-03 12:59:25'),(71734,206,'Hathiagarh','272002',1,0,'2022-03-03 12:59:25','2022-03-03 12:59:25'),(71735,206,'Hatwa','272126',1,0,'2022-03-03 12:59:25','2022-03-03 12:59:25'),(71736,206,'Hiyaroopur','272127',1,0,'2022-03-03 12:59:25','2022-03-03 12:59:25'),(71737,206,'Hundrakunwar','272181',1,0,'2022-03-03 12:59:25','2022-03-03 12:59:25'),(71738,206,'Itbahara','272163',1,0,'2022-03-03 12:59:25','2022-03-03 12:59:25'),(71739,206,'ITI (Basti)','272001',1,0,'2022-03-03 12:59:25','2022-03-03 12:59:25'),(71740,206,'Itwakungai','272181',1,0,'2022-03-03 12:59:25','2022-03-03 12:59:25'),(71741,206,'Jagdishpur','272130',1,0,'2022-03-03 12:59:25','2022-03-03 12:59:25'),(71742,206,'Jahlipur','272190',1,0,'2022-03-03 12:59:25','2022-03-03 12:59:25'),(71743,206,'Jaitapur','272127',1,0,'2022-03-03 12:59:25','2022-03-03 12:59:25'),(71744,206,'Jajupur','272127',1,0,'2022-03-03 12:59:25','2022-03-03 12:59:25'),(71745,206,'Jamadashahi','272002',1,0,'2022-03-03 12:59:25','2022-03-03 12:59:25'),(71746,206,'Jeodhara','272125',1,0,'2022-03-03 12:59:25','2022-03-03 12:59:25'),(71747,206,'Jinswa','272190',1,0,'2022-03-03 12:59:25','2022-03-03 12:59:25'),(71748,206,'Jitipur','272181',1,0,'2022-03-03 12:59:25','2022-03-03 12:59:25'),(71749,206,'Joorie','272125',1,0,'2022-03-03 12:59:25','2022-03-03 12:59:25'),(71750,206,'Kachhia','272163',1,0,'2022-03-03 12:59:25','2022-03-03 12:59:25'),(71751,206,'Kalwari (Basti)','272301',1,0,'2022-03-03 12:59:25','2022-03-03 12:59:25'),(71752,206,'Kanaila','272301',1,0,'2022-03-03 12:59:25','2022-03-03 12:59:25'),(71753,206,'Karah Pithia','272170',1,0,'2022-03-03 12:59:25','2022-03-03 12:59:25'),(71754,206,'Karahi','272002',1,0,'2022-03-03 12:59:26','2022-03-03 12:59:26'),(71755,206,'Karma Khan','272002',1,0,'2022-03-03 12:59:26','2022-03-03 12:59:26'),(71756,206,'Karmahiya','272194',1,0,'2022-03-03 12:59:26','2022-03-03 12:59:26'),(71757,206,'Kasaila','272302',1,0,'2022-03-03 12:59:26','2022-03-03 12:59:26'),(71758,206,'Kataria','272128',1,0,'2022-03-03 12:59:26','2022-03-03 12:59:26'),(71759,206,'Kathar Jungle','272302',1,0,'2022-03-03 12:59:26','2022-03-03 12:59:26'),(71760,206,'Katya','272302',1,0,'2022-03-03 12:59:26','2022-03-03 12:59:26'),(71761,206,'Kaudikol','272131',1,0,'2022-03-03 12:59:26','2022-03-03 12:59:26'),(71762,206,'Kerauna','272148',1,0,'2022-03-03 12:59:26','2022-03-03 12:59:26'),(71763,206,'Keshwapur','272155',1,0,'2022-03-03 12:59:26','2022-03-03 12:59:26'),(71764,206,'Kewarimustahkam','272301',1,0,'2022-03-03 12:59:26','2022-03-03 12:59:26'),(71765,206,'Khairati','272177',1,0,'2022-03-03 12:59:26','2022-03-03 12:59:26'),(71766,206,'Khambha','272151',1,0,'2022-03-03 12:59:26','2022-03-03 12:59:26'),(71767,206,'Kharawan Kunwsar','272130',1,0,'2022-03-03 12:59:26','2022-03-03 12:59:26'),(71768,206,'Kharka','272177',1,0,'2022-03-03 12:59:26','2022-03-03 12:59:26'),(71769,206,'Khatiyawan','272125',1,0,'2022-03-03 12:59:26','2022-03-03 12:59:26'),(71770,206,'Khesuwa','272127',1,0,'2022-03-03 12:59:26','2022-03-03 12:59:26'),(71771,206,'Khoria','272123',1,0,'2022-03-03 12:59:26','2022-03-03 12:59:26'),(71772,206,'Kodai','272131',1,0,'2022-03-03 12:59:26','2022-03-03 12:59:26'),(71773,206,'Kohra','272150',1,0,'2022-03-03 12:59:26','2022-03-03 12:59:26'),(71774,206,'Kohriyawan','272126',1,0,'2022-03-03 12:59:26','2022-03-03 12:59:26'),(71775,206,'Kondra Pandey','272002',1,0,'2022-03-03 12:59:26','2022-03-03 12:59:26'),(71776,206,'Kothwa','272124',1,0,'2022-03-03 12:59:26','2022-03-03 12:59:26'),(71777,206,'Kudraha','272301',1,0,'2022-03-03 12:59:26','2022-03-03 12:59:26'),(71778,206,'Kurda','272163',1,0,'2022-03-03 12:59:26','2022-03-03 12:59:26'),(71779,206,'Kuriyar','272170',1,0,'2022-03-03 12:59:26','2022-03-03 12:59:26'),(71780,206,'Kurthia','272153',1,0,'2022-03-03 12:59:27','2022-03-03 12:59:27'),(71781,206,'Kusaura','272301',1,0,'2022-03-03 12:59:27','2022-03-03 12:59:27'),(71782,206,'Kusuru Khurd','272125',1,0,'2022-03-03 12:59:27','2022-03-03 12:59:27'),(71783,206,'Labnapar','272002',1,0,'2022-03-03 12:59:27','2022-03-03 12:59:27'),(71784,206,'Lakhanahat','272302',1,0,'2022-03-03 12:59:27','2022-03-03 12:59:27'),(71785,206,'Lalganj (Basti)','272171',1,0,'2022-03-03 12:59:27','2022-03-03 12:59:27'),(71786,206,'Lalpur','272130',1,0,'2022-03-03 12:59:27','2022-03-03 12:59:27'),(71787,206,'Lapsi','272190',1,0,'2022-03-03 12:59:27','2022-03-03 12:59:27'),(71788,206,'Lauki Lala','272125',1,0,'2022-03-03 12:59:27','2022-03-03 12:59:27'),(71789,206,'Madwanagar','272002',1,0,'2022-03-03 12:59:27','2022-03-03 12:59:27'),(71790,206,'Mahadewa','272181',1,0,'2022-03-03 12:59:27','2022-03-03 12:59:27'),(71791,206,'Mahani','272125',1,0,'2022-03-03 12:59:27','2022-03-03 12:59:27'),(71792,206,'Mahrajganj','272155',1,0,'2022-03-03 12:59:27','2022-03-03 12:59:27'),(71793,206,'Mahripur','272302',1,0,'2022-03-03 12:59:27','2022-03-03 12:59:27'),(71794,206,'Mahson','272124',1,0,'2022-03-03 12:59:27','2022-03-03 12:59:27'),(71795,206,'Mahuswar','272148',1,0,'2022-03-03 12:59:27','2022-03-03 12:59:27'),(71796,206,'Mahuwadabar','272161',1,0,'2022-03-03 12:59:27','2022-03-03 12:59:27'),(71797,206,'Mahuwalakhanpur','272131',1,0,'2022-03-03 12:59:27','2022-03-03 12:59:27'),(71798,206,'Mahuwapar','272155',1,0,'2022-03-03 12:59:27','2022-03-03 12:59:27'),(71799,206,'Mahuwar','272151',1,0,'2022-03-03 12:59:27','2022-03-03 12:59:27'),(71800,206,'Majahuwameer','272002',1,0,'2022-03-03 12:59:27','2022-03-03 12:59:27'),(71801,206,'Majhauwa Babu','272155',1,0,'2022-03-03 12:59:27','2022-03-03 12:59:27'),(71802,206,'Majhauwa Baikunth','272150',1,0,'2022-03-03 12:59:27','2022-03-03 12:59:27'),(71803,206,'Majhauwa Khajuri','272002',1,0,'2022-03-03 12:59:27','2022-03-03 12:59:27'),(71804,206,'Majhauwa Khurd','272190',1,0,'2022-03-03 12:59:28','2022-03-03 12:59:28'),(71805,206,'Malauli Gosain','272129',1,0,'2022-03-03 12:59:28','2022-03-03 12:59:28'),(71806,206,'Manjharia Vikram','272002',1,0,'2022-03-03 12:59:28','2022-03-03 12:59:28'),(71807,206,'Manjhilgaon','272127',1,0,'2022-03-03 12:59:28','2022-03-03 12:59:28'),(71808,206,'Mansoornagar','272163',1,0,'2022-03-03 12:59:28','2022-03-03 12:59:28'),(71809,206,'Manuwa','272301',1,0,'2022-03-03 12:59:28','2022-03-03 12:59:28'),(71810,206,'Marwatia Baboo','272302',1,0,'2022-03-03 12:59:28','2022-03-03 12:59:28'),(71811,206,'Marwatia Kasaila','272002',1,0,'2022-03-03 12:59:28','2022-03-03 12:59:28'),(71812,206,'Meetanjot','272302',1,0,'2022-03-03 12:59:28','2022-03-03 12:59:28'),(71813,206,'Melan Khurd','272125',1,0,'2022-03-03 12:59:28','2022-03-03 12:59:28'),(71814,206,'Misraulia Bhaiya','272150',1,0,'2022-03-03 12:59:28','2022-03-03 12:59:28'),(71815,206,'Mudadeehabeg','272125',1,0,'2022-03-03 12:59:28','2022-03-03 12:59:28'),(71816,206,'Munderwa','272170',1,0,'2022-03-03 12:59:28','2022-03-03 12:59:28'),(71817,206,'Nagahara','272002',1,0,'2022-03-03 12:59:28','2022-03-03 12:59:28'),(71818,206,'Nagar Bazar','272302',1,0,'2022-03-03 12:59:28','2022-03-03 12:59:28'),(71819,206,'Naghara','272131',1,0,'2022-03-03 12:59:28','2022-03-03 12:59:28'),(71820,206,'Naguwa','272177',1,0,'2022-03-03 12:59:28','2022-03-03 12:59:28'),(71821,206,'Naikapar','272301',1,0,'2022-03-03 12:59:28','2022-03-03 12:59:28'),(71822,206,'Nande Kuwan','272128',1,0,'2022-03-03 12:59:28','2022-03-03 12:59:28'),(71823,206,'Nandnagar','272129',1,0,'2022-03-03 12:59:28','2022-03-03 12:59:28'),(71824,206,'Naraiyanpur','272124',1,0,'2022-03-03 12:59:28','2022-03-03 12:59:28'),(71825,206,'Nedula','272130',1,0,'2022-03-03 12:59:28','2022-03-03 12:59:28'),(71826,206,'Newari','272171',1,0,'2022-03-03 12:59:28','2022-03-03 12:59:28'),(71827,206,'Niranjanpur','272124',1,0,'2022-03-03 12:59:28','2022-03-03 12:59:28'),(71828,206,'Ojhaganj','272131',1,0,'2022-03-03 12:59:28','2022-03-03 12:59:28'),(71829,206,'Orawara','272002',1,0,'2022-03-03 12:59:29','2022-03-03 12:59:29'),(71830,206,'Orijote','272001',1,0,'2022-03-03 12:59:29','2022-03-03 12:59:29'),(71831,206,'Pachawa','272125',1,0,'2022-03-03 12:59:29','2022-03-03 12:59:29'),(71832,206,'Pachwas','272127',1,0,'2022-03-03 12:59:29','2022-03-03 12:59:29'),(71833,206,'Padari','272170',1,0,'2022-03-03 12:59:29','2022-03-03 12:59:29'),(71834,206,'Pagar','272123',1,0,'2022-03-03 12:59:29','2022-03-03 12:59:29'),(71835,206,'Paikolia','272181',1,0,'2022-03-03 12:59:29','2022-03-03 12:59:29'),(71836,206,'Pak. Bakhtawar','272131',1,0,'2022-03-03 12:59:29','2022-03-03 12:59:29'),(71837,206,'Pakari Araji','272125',1,0,'2022-03-03 12:59:29','2022-03-03 12:59:29'),(71838,206,'Pakari Dhaurahra','272002',1,0,'2022-03-03 12:59:29','2022-03-03 12:59:29'),(71839,206,'Pakri Jai','272002',1,0,'2022-03-03 12:59:29','2022-03-03 12:59:29'),(71840,206,'Pandey Bazar','272002',1,0,'2022-03-03 12:59:29','2022-03-03 12:59:29'),(71841,206,'Parasrampur','272130',1,0,'2022-03-03 12:59:29','2022-03-03 12:59:29'),(71842,206,'Parsa  Damya','272150',1,0,'2022-03-03 12:59:29','2022-03-03 12:59:29'),(71843,206,'Parsa Jhakaria','272125',1,0,'2022-03-03 12:59:29','2022-03-03 12:59:29'),(71844,206,'Parsaon','272301',1,0,'2022-03-03 12:59:29','2022-03-03 12:59:29'),(71845,206,'Pendar','272163',1,0,'2022-03-03 12:59:29','2022-03-03 12:59:29'),(71846,206,'Pikaura','272163',1,0,'2022-03-03 12:59:29','2022-03-03 12:59:29'),(71847,206,'Pipra Kazi','272163',1,0,'2022-03-03 12:59:29','2022-03-03 12:59:29'),(71848,206,'Pipragautam','272124',1,0,'2022-03-03 12:59:29','2022-03-03 12:59:29'),(71849,206,'Piraila Garib','272194',1,0,'2022-03-03 12:59:29','2022-03-03 12:59:29'),(71850,206,'Pokhara','272131',1,0,'2022-03-03 12:59:29','2022-03-03 12:59:29'),(71851,206,'Pokharni','272302',1,0,'2022-03-03 12:59:29','2022-03-03 12:59:29'),(71852,206,'Puraina Mansoor','272002',1,0,'2022-03-03 12:59:29','2022-03-03 12:59:29'),(71853,206,'Puraina Pandey','272002',1,0,'2022-03-03 12:59:30','2022-03-03 12:59:30'),(71854,206,'Purani Basti (Basti)','272002',1,0,'2022-03-03 12:59:30','2022-03-03 12:59:30'),(71855,206,'Pursia','272002',1,0,'2022-03-03 12:59:30','2022-03-03 12:59:30'),(71856,206,'Raghunathpur','272002',1,0,'2022-03-03 12:59:30','2022-03-03 12:59:30'),(71857,206,'Raghunathpur','272130',1,0,'2022-03-03 12:59:30','2022-03-03 12:59:30'),(71858,206,'Raghwapur','272181',1,0,'2022-03-03 12:59:30','2022-03-03 12:59:30'),(71859,206,'Rajpur Bairihwa','272301',1,0,'2022-03-03 12:59:30','2022-03-03 12:59:30'),(71860,206,'Ramnagar','272194',1,0,'2022-03-03 12:59:30','2022-03-03 12:59:30'),(71861,206,'Rampur','272124',1,0,'2022-03-03 12:59:30','2022-03-03 12:59:30'),(71862,206,'Rampur','272170',1,0,'2022-03-03 12:59:30','2022-03-03 12:59:30'),(71863,206,'Ranipur','272302',1,0,'2022-03-03 12:59:30','2022-03-03 12:59:30'),(71864,206,'Rasoolpur','272002',1,0,'2022-03-03 12:59:30','2022-03-03 12:59:30'),(71865,206,'Raunakala','272150',1,0,'2022-03-03 12:59:30','2022-03-03 12:59:30'),(71866,206,'Rautapar','272171',1,0,'2022-03-03 12:59:30','2022-03-03 12:59:30'),(71867,206,'Rayath','272148',1,0,'2022-03-03 12:59:30','2022-03-03 12:59:30'),(71868,206,'Roopgarh','272128',1,0,'2022-03-03 12:59:30','2022-03-03 12:59:30'),(71869,206,'Rudranagar','272151',1,0,'2022-03-03 12:59:30','2022-03-03 12:59:30'),(71870,206,'Saithawalia','272002',1,0,'2022-03-03 12:59:30','2022-03-03 12:59:30'),(71871,206,'Salempur','272130',1,0,'2022-03-03 12:59:30','2022-03-03 12:59:30'),(71872,206,'Saltauwa','272190',1,0,'2022-03-03 12:59:30','2022-03-03 12:59:30'),(71873,206,'Samaspur','272124',1,0,'2022-03-03 12:59:30','2022-03-03 12:59:30'),(71874,206,'Sanda','272170',1,0,'2022-03-03 12:59:30','2022-03-03 12:59:30'),(71875,206,'Sangath','272125',1,0,'2022-03-03 12:59:30','2022-03-03 12:59:30'),(71876,206,'Sangrampur','272127',1,0,'2022-03-03 12:59:30','2022-03-03 12:59:30'),(71877,206,'Sansarpur','272182',1,0,'2022-03-03 12:59:30','2022-03-03 12:59:30'),(71878,206,'Sardaha Sukul','272163',1,0,'2022-03-03 12:59:31','2022-03-03 12:59:31'),(71879,206,'Sarraiya Atibal','272128',1,0,'2022-03-03 12:59:31','2022-03-03 12:59:31'),(71880,206,'Sehuda Kala','272148',1,0,'2022-03-03 12:59:31','2022-03-03 12:59:31'),(71881,206,'Semara','272302',1,0,'2022-03-03 12:59:31','2022-03-03 12:59:31'),(71882,206,'Semariyawan','272126',1,0,'2022-03-03 12:59:31','2022-03-03 12:59:31'),(71883,206,'Shankarpur','272129',1,0,'2022-03-03 12:59:31','2022-03-03 12:59:31'),(71884,206,'Shivpur','272163',1,0,'2022-03-03 12:59:31','2022-03-03 12:59:31'),(71885,206,'Siarapar','272182',1,0,'2022-03-03 12:59:31','2022-03-03 12:59:31'),(71886,206,'Sihari Sardaha','272190',1,0,'2022-03-03 12:59:31','2022-03-03 12:59:31'),(71887,206,'Sikandarpur','272129',1,0,'2022-03-03 12:59:31','2022-03-03 12:59:31'),(71888,206,'Sillo','272124',1,0,'2022-03-03 12:59:31','2022-03-03 12:59:31'),(71889,206,'Sonha','272190',1,0,'2022-03-03 12:59:31','2022-03-03 12:59:31'),(71890,206,'Sonkhar','272170',1,0,'2022-03-03 12:59:31','2022-03-03 12:59:31'),(71891,206,'Sringinari','272130',1,0,'2022-03-03 12:59:31','2022-03-03 12:59:31'),(71892,206,'Subdeiyakala','272002',1,0,'2022-03-03 12:59:31','2022-03-03 12:59:31'),(71893,206,'Sudipur','272128',1,0,'2022-03-03 12:59:31','2022-03-03 12:59:31'),(71894,206,'Sukrauli','272163',1,0,'2022-03-03 12:59:31','2022-03-03 12:59:31'),(71895,206,'Sukrauli Chaudhary','272155',1,0,'2022-03-03 12:59:31','2022-03-03 12:59:31'),(71896,206,'Sumha','272125',1,0,'2022-03-03 12:59:31','2022-03-03 12:59:31'),(71897,206,'Surwarkalan','272151',1,0,'2022-03-03 12:59:31','2022-03-03 12:59:31'),(71898,206,'T B Clinic','272002',1,0,'2022-03-03 12:59:31','2022-03-03 12:59:31'),(71899,206,'Teliha Deeh','272190',1,0,'2022-03-03 12:59:31','2022-03-03 12:59:31'),(71900,206,'Thana Khas','272155',1,0,'2022-03-03 12:59:31','2022-03-03 12:59:31'),(71901,206,'Tharuapur','272129',1,0,'2022-03-03 12:59:31','2022-03-03 12:59:31'),(71902,206,'Thokwsa','272171',1,0,'2022-03-03 12:59:32','2022-03-03 12:59:32'),(71903,206,'Tilakpur','272131',1,0,'2022-03-03 12:59:32','2022-03-03 12:59:32'),(71904,206,'Tilja','272126',1,0,'2022-03-03 12:59:32','2022-03-03 12:59:32'),(71905,206,'Tinharimafi','272126',1,0,'2022-03-03 12:59:32','2022-03-03 12:59:32'),(71906,206,'Tinich','272163',1,0,'2022-03-03 12:59:32','2022-03-03 12:59:32'),(71907,206,'Turasi','272127',1,0,'2022-03-03 12:59:32','2022-03-03 12:59:32'),(71908,206,'Turkipur','272128',1,0,'2022-03-03 12:59:32','2022-03-03 12:59:32'),(71909,206,'Tusail','272194',1,0,'2022-03-03 12:59:32','2022-03-03 12:59:32'),(71910,206,'Umaria','272301',1,0,'2022-03-03 12:59:32','2022-03-03 12:59:32'),(71911,206,'Unchgaon','272170',1,0,'2022-03-03 12:59:32','2022-03-03 12:59:32'),(71912,206,'Unji','272131',1,0,'2022-03-03 12:59:32','2022-03-03 12:59:32'),(71913,206,'Ushara Shahid','272002',1,0,'2022-03-03 12:59:32','2022-03-03 12:59:32'),(71914,206,'Vedipur','272181',1,0,'2022-03-03 12:59:32','2022-03-03 12:59:32'),(71915,206,'Walterganj','272182',1,0,'2022-03-03 12:59:32','2022-03-03 12:59:32'),(71916,206,'Gaura Pandey','271305',1,0,'2022-03-03 12:59:32','2022-03-03 12:59:32'),(71917,207,'Aasfabad Chaman','246722',1,0,'2022-03-03 12:59:32','2022-03-03 12:59:32'),(71918,207,'Afzalgarh','246722',1,0,'2022-03-03 12:59:32','2022-03-03 12:59:32'),(71919,207,'Agri','246701',1,0,'2022-03-03 12:59:32','2022-03-03 12:59:32'),(71920,207,'Aheerpura','246734',1,0,'2022-03-03 12:59:32','2022-03-03 12:59:32'),(71921,207,'Ajdev Khanpur','246725',1,0,'2022-03-03 12:59:32','2022-03-03 12:59:32'),(71922,207,'Akbarabad','246764',1,0,'2022-03-03 12:59:32','2022-03-03 12:59:32'),(71923,207,'Akhera','246733',1,0,'2022-03-03 12:59:33','2022-03-03 12:59:33'),(71924,207,'Akondha','246736',1,0,'2022-03-03 12:59:33','2022-03-03 12:59:33'),(71925,207,'Alaihdajpur Khajuba','246762',1,0,'2022-03-03 12:59:33','2022-03-03 12:59:33'),(71926,207,'Alampur Ganvri','246722',1,0,'2022-03-03 12:59:33','2022-03-03 12:59:33'),(71927,207,'Alhedalpur Mubarak','246733',1,0,'2022-03-03 12:59:33','2022-03-03 12:59:33'),(71928,207,'Alladinpur  Bhogi','246762',1,0,'2022-03-03 12:59:33','2022-03-03 12:59:33'),(71929,207,'Allauddinpur','246734',1,0,'2022-03-03 12:59:33','2022-03-03 12:59:33'),(71930,207,'Allhapurmohkam','246747',1,0,'2022-03-03 12:59:33','2022-03-03 12:59:33'),(71931,207,'Amhera','246726',1,0,'2022-03-03 12:59:33','2022-03-03 12:59:33'),(71932,207,'Amkhera  Sanjarpur','246761',1,0,'2022-03-03 12:59:33','2022-03-03 12:59:33'),(71933,207,'Anwarpur Chandka','246722',1,0,'2022-03-03 12:59:33','2022-03-03 12:59:33'),(71934,207,'Asgaripur','246727',1,0,'2022-03-03 12:59:33','2022-03-03 12:59:33'),(71935,207,'Athai Sheikh','246761',1,0,'2022-03-03 12:59:33','2022-03-03 12:59:33'),(71936,207,'Aurangabad Urf Sikanderpur','246725',1,0,'2022-03-03 12:59:33','2022-03-03 12:59:33'),(71937,207,'Azampur','246734',1,0,'2022-03-03 12:59:33','2022-03-03 12:59:33'),(71938,207,'B I Estate','246701',1,0,'2022-03-03 12:59:33','2022-03-03 12:59:33'),(71939,207,'Baberpur','246729',1,0,'2022-03-03 12:59:33','2022-03-03 12:59:33'),(71940,207,'Badhapur','246724',1,0,'2022-03-03 12:59:33','2022-03-03 12:59:33'),(71941,207,'Bagarpur','246725',1,0,'2022-03-03 12:59:33','2022-03-03 12:59:33'),(71942,207,'Bagwara','246745',1,0,'2022-03-03 12:59:33','2022-03-03 12:59:33'),(71943,207,'Bahadarpur Sherfuddin','246721',1,0,'2022-03-03 12:59:33','2022-03-03 12:59:33'),(71944,207,'Bahmanshora','246725',1,0,'2022-03-03 12:59:33','2022-03-03 12:59:33'),(71945,207,'Bahupura','246731',1,0,'2022-03-03 12:59:33','2022-03-03 12:59:33'),(71946,207,'Baibalpur','246764',1,0,'2022-03-03 12:59:33','2022-03-03 12:59:33'),(71947,207,'Bairmabad  Garhi','246733',1,0,'2022-03-03 12:59:33','2022-03-03 12:59:33'),(71948,207,'Bakaina','246736',1,0,'2022-03-03 12:59:34','2022-03-03 12:59:34'),(71949,207,'Bakherpur Garhi','246701',1,0,'2022-03-03 12:59:34','2022-03-03 12:59:34'),(71950,207,'Bakhrabad  Urf Khatai','246734',1,0,'2022-03-03 12:59:34','2022-03-03 12:59:34'),(71951,207,'Bakshanpur','246761',1,0,'2022-03-03 12:59:34','2022-03-03 12:59:34'),(71952,207,'Balawali','246723',1,0,'2022-03-03 12:59:34','2022-03-03 12:59:34'),(71953,207,'Baldiya','246726',1,0,'2022-03-03 12:59:34','2022-03-03 12:59:34'),(71954,207,'Barampur','246731',1,0,'2022-03-03 12:59:34','2022-03-03 12:59:34'),(71955,207,'Barkhera','246724',1,0,'2022-03-03 12:59:34','2022-03-03 12:59:34'),(71956,207,'Barooki','246764',1,0,'2022-03-03 12:59:34','2022-03-03 12:59:34'),(71957,207,'Basantpur','246736',1,0,'2022-03-03 12:59:34','2022-03-03 12:59:34'),(71958,207,'Bashta','246736',1,0,'2022-03-03 12:59:34','2022-03-03 12:59:34'),(71959,207,'Basi Kiratapur','246731',1,0,'2022-03-03 12:59:34','2022-03-03 12:59:34'),(71960,207,'Begrajpur','246733',1,0,'2022-03-03 12:59:34','2022-03-03 12:59:34'),(71961,207,'Bhaguwala','246749',1,0,'2022-03-03 12:59:34','2022-03-03 12:59:34'),(71962,207,'Bhagwanpur','246762',1,0,'2022-03-03 12:59:34','2022-03-03 12:59:34'),(71963,207,'Bhaisa','246734',1,0,'2022-03-03 12:59:34','2022-03-03 12:59:34'),(71964,207,'Bhanauti','246747',1,0,'2022-03-03 12:59:34','2022-03-03 12:59:34'),(71965,207,'Bharaira','246701',1,0,'2022-03-03 12:59:34','2022-03-03 12:59:34'),(71966,207,'Bhatiyana Khushalpur','246761',1,0,'2022-03-03 12:59:34','2022-03-03 12:59:34'),(71967,207,'Bhatpura','246722',1,0,'2022-03-03 12:59:34','2022-03-03 12:59:34'),(71968,207,'Bheekhawala','246722',1,0,'2022-03-03 12:59:34','2022-03-03 12:59:34'),(71969,207,'Bhogli','246762',1,0,'2022-03-03 12:59:34','2022-03-03 12:59:34'),(71970,207,'Bhogpur','246735',1,0,'2022-03-03 12:59:34','2022-03-03 12:59:34'),(71971,207,'Bhojpur','246731',1,0,'2022-03-03 12:59:34','2022-03-03 12:59:34'),(71972,207,'Bijauri','246749',1,0,'2022-03-03 12:59:35','2022-03-03 12:59:35'),(71973,207,'Bijnor H.O','246701',1,0,'2022-03-03 12:59:35','2022-03-03 12:59:35'),(71974,207,'Bilai','246726',1,0,'2022-03-03 12:59:35','2022-03-03 12:59:35'),(71975,207,'Birla Farm','246722',1,0,'2022-03-03 12:59:35','2022-03-03 12:59:35'),(71976,207,'Bishanpur','246727',1,0,'2022-03-03 12:59:35','2022-03-03 12:59:35'),(71977,207,'Budgara','246721',1,0,'2022-03-03 12:59:35','2022-03-03 12:59:35'),(71978,207,'Budhanpur','246746',1,0,'2022-03-03 12:59:35','2022-03-03 12:59:35'),(71979,207,'Chanda Nagli','246726',1,0,'2022-03-03 12:59:35','2022-03-03 12:59:35'),(71980,207,'Chandanpura','246763',1,0,'2022-03-03 12:59:35','2022-03-03 12:59:35'),(71981,207,'Chandok R.S.','246721',1,0,'2022-03-03 12:59:35','2022-03-03 12:59:35'),(71982,207,'Chandpur','246725',1,0,'2022-03-03 12:59:35','2022-03-03 12:59:35'),(71983,207,'Chandpur','246725',1,0,'2022-03-03 12:59:35','2022-03-03 12:59:35'),(71984,207,'Chandpur Sugar Factory','246729',1,0,'2022-03-03 12:59:35','2022-03-03 12:59:35'),(71985,207,'Chitawar','246731',1,0,'2022-03-03 12:59:35','2022-03-03 12:59:35'),(71986,207,'Chotti Mandi Dhampur','246761',1,0,'2022-03-03 12:59:35','2022-03-03 12:59:35'),(71987,207,'Chowkpuri','246728',1,0,'2022-03-03 12:59:35','2022-03-03 12:59:35'),(71988,207,'Civil Line','246701',1,0,'2022-03-03 12:59:35','2022-03-03 12:59:35'),(71989,207,'Daranagar Ganj','246701',1,0,'2022-03-03 12:59:35','2022-03-03 12:59:35'),(71990,207,'Darbara','246725',1,0,'2022-03-03 12:59:35','2022-03-03 12:59:35'),(71991,207,'Datiyana','246725',1,0,'2022-03-03 12:59:35','2022-03-03 12:59:35'),(71992,207,'Daultabad','246746',1,0,'2022-03-03 12:59:35','2022-03-03 12:59:35'),(71993,207,'Dhakka Karamchand','246761',1,0,'2022-03-03 12:59:35','2022-03-03 12:59:35'),(71994,207,'Dhampur H.O','246761',1,0,'2022-03-03 12:59:35','2022-03-03 12:59:35'),(71995,207,'Dhampur Mandi','246761',1,0,'2022-03-03 12:59:36','2022-03-03 12:59:36'),(71996,207,'Dhampur Sugar Mill','246761',1,0,'2022-03-03 12:59:36','2022-03-03 12:59:36'),(71997,207,'Dhanaura','246728',1,0,'2022-03-03 12:59:36','2022-03-03 12:59:36'),(71998,207,'Dhansini','246763',1,0,'2022-03-03 12:59:36','2022-03-03 12:59:36'),(71999,207,'Dharm Nagri','246701',1,0,'2022-03-03 12:59:36','2022-03-03 12:59:36'),(72000,207,'Dharupur','246734',1,0,'2022-03-03 12:59:36','2022-03-03 12:59:36'),(72001,207,'Dhokalpur','246728',1,0,'2022-03-03 12:59:36','2022-03-03 12:59:36'),(72002,207,'District Board','246701',1,0,'2022-03-03 12:59:36','2022-03-03 12:59:36'),(72003,207,'Doodhli','246731',1,0,'2022-03-03 12:59:36','2022-03-03 12:59:36'),(72004,207,'Faridpur Bhogi','246701',1,0,'2022-03-03 12:59:36','2022-03-03 12:59:36'),(72005,207,'Fatehpur Kalan','246701',1,0,'2022-03-03 12:59:36','2022-03-03 12:59:36'),(72006,207,'Fazalpur','246763',1,0,'2022-03-03 12:59:36','2022-03-03 12:59:36'),(72007,207,'Fazalpur Dhaki','246729',1,0,'2022-03-03 12:59:36','2022-03-03 12:59:36'),(72008,207,'Gajraula Paimar','246763',1,0,'2022-03-03 12:59:36','2022-03-03 12:59:36'),(72009,207,'Gajraula Shiv','246701',1,0,'2022-03-03 12:59:36','2022-03-03 12:59:36'),(72010,207,'Gandhore','246725',1,0,'2022-03-03 12:59:36','2022-03-03 12:59:36'),(72011,207,'Gangu Nagla','246729',1,0,'2022-03-03 12:59:36','2022-03-03 12:59:36'),(72012,207,'Ganj Bazar Nagina','246762',1,0,'2022-03-03 12:59:36','2022-03-03 12:59:36'),(72013,207,'Ganjalpur','246721',1,0,'2022-03-03 12:59:36','2022-03-03 12:59:36'),(72014,207,'Gohawar','246734',1,0,'2022-03-03 12:59:36','2022-03-03 12:59:36'),(72015,207,'Gordhanpur','246722',1,0,'2022-03-03 12:59:36','2022-03-03 12:59:36'),(72016,207,'Guniapur','246763',1,0,'2022-03-03 12:59:37','2022-03-03 12:59:37'),(72017,207,'Habibwala','246761',1,0,'2022-03-03 12:59:37','2022-03-03 12:59:37'),(72018,207,'Hafizabad','246747',1,0,'2022-03-03 12:59:37','2022-03-03 12:59:37'),(72019,207,'Haijarpur','246762',1,0,'2022-03-03 12:59:37','2022-03-03 12:59:37'),(72020,207,'Haldaur','246726',1,0,'2022-03-03 12:59:37','2022-03-03 12:59:37'),(72021,207,'Haldua Mafi','246745',1,0,'2022-03-03 12:59:37','2022-03-03 12:59:37'),(72022,207,'Haraivli','246747',1,0,'2022-03-03 12:59:37','2022-03-03 12:59:37'),(72023,207,'Harbanspur Dharam','246762',1,0,'2022-03-03 12:59:37','2022-03-03 12:59:37'),(72024,207,'Harganpur','246762',1,0,'2022-03-03 12:59:37','2022-03-03 12:59:37'),(72025,207,'Harganpur Sajauli','246733',1,0,'2022-03-03 12:59:37','2022-03-03 12:59:37'),(72026,207,'Hassupura','246727',1,0,'2022-03-03 12:59:37','2022-03-03 12:59:37'),(72027,207,'Heempur Buzurg','246725',1,0,'2022-03-03 12:59:37','2022-03-03 12:59:37'),(72028,207,'Heempur Deepa','246725',1,0,'2022-03-03 12:59:37','2022-03-03 12:59:37'),(72029,207,'Hidayatpur','246722',1,0,'2022-03-03 12:59:37','2022-03-03 12:59:37'),(72030,207,'Hirawali','246762',1,0,'2022-03-03 12:59:37','2022-03-03 12:59:37'),(72031,207,'Hussainpur','246731',1,0,'2022-03-03 12:59:37','2022-03-03 12:59:37'),(72032,207,'I A Najibabad','246763',1,0,'2022-03-03 12:59:37','2022-03-03 12:59:37'),(72033,207,'Imliya','246725',1,0,'2022-03-03 12:59:37','2022-03-03 12:59:37'),(72034,207,'Islamabad','246762',1,0,'2022-03-03 12:59:37','2022-03-03 12:59:37'),(72035,207,'Ismailpur','246725',1,0,'2022-03-03 12:59:37','2022-03-03 12:59:37'),(72036,207,'Jahanabad Khovra','246763',1,0,'2022-03-03 12:59:37','2022-03-03 12:59:37'),(72037,207,'Jalalabad (Bijnor)','246763',1,0,'2022-03-03 12:59:37','2022-03-03 12:59:37'),(72038,207,'Jalilpur','246725',1,0,'2022-03-03 12:59:37','2022-03-03 12:59:37'),(72039,207,'Jalpur','246732',1,0,'2022-03-03 12:59:37','2022-03-03 12:59:37'),(72040,207,'Jamalpur Kirat','246735',1,0,'2022-03-03 12:59:38','2022-03-03 12:59:38'),(72041,207,'Jamanwala','246722',1,0,'2022-03-03 12:59:38','2022-03-03 12:59:38'),(72042,207,'Jatan','246701',1,0,'2022-03-03 12:59:38','2022-03-03 12:59:38'),(72043,207,'Jatpura','246747',1,0,'2022-03-03 12:59:38','2022-03-03 12:59:38'),(72044,207,'Jatpura Bonda','246749',1,0,'2022-03-03 12:59:38','2022-03-03 12:59:38'),(72045,207,'Jeetpur Paldi','246762',1,0,'2022-03-03 12:59:38','2022-03-03 12:59:38'),(72046,207,'Jhakaki','246763',1,0,'2022-03-03 12:59:38','2022-03-03 12:59:38'),(72047,207,'Jhalu','246728',1,0,'2022-03-03 12:59:38','2022-03-03 12:59:38'),(72048,207,'Jheeran','246727',1,0,'2022-03-03 12:59:38','2022-03-03 12:59:38'),(72049,207,'Jhilmila','246764',1,0,'2022-03-03 12:59:38','2022-03-03 12:59:38'),(72050,207,'Jogirampuri','246763',1,0,'2022-03-03 12:59:38','2022-03-03 12:59:38'),(72051,207,'Kadrabad','246722',1,0,'2022-03-03 12:59:38','2022-03-03 12:59:38'),(72052,207,'Kallooganj','246763',1,0,'2022-03-03 12:59:38','2022-03-03 12:59:38'),(72053,207,'Kalluwala','246722',1,0,'2022-03-03 12:59:38','2022-03-03 12:59:38'),(72054,207,'Kasampur Garhi','246722',1,0,'2022-03-03 12:59:38','2022-03-03 12:59:38'),(72055,207,'Khanpur Madho','246721',1,0,'2022-03-03 12:59:38','2022-03-03 12:59:38'),(72056,207,'Kharak Jeetpur','246701',1,0,'2022-03-03 12:59:38','2022-03-03 12:59:38'),(72057,207,'Khari','246728',1,0,'2022-03-03 12:59:38','2022-03-03 12:59:38'),(72058,207,'Khaspura','246734',1,0,'2022-03-03 12:59:38','2022-03-03 12:59:38'),(72059,207,'Khatriyan','246701',1,0,'2022-03-03 12:59:38','2022-03-03 12:59:38'),(72060,207,'Khirni Barkatpur','246723',1,0,'2022-03-03 12:59:38','2022-03-03 12:59:38'),(72061,207,'Kiratpur','246731',1,0,'2022-03-03 12:59:38','2022-03-03 12:59:38'),(72062,207,'Kishanpur Amvla','246763',1,0,'2022-03-03 12:59:38','2022-03-03 12:59:38'),(72063,207,'Kiwar','246745',1,0,'2022-03-03 12:59:39','2022-03-03 12:59:39'),(72064,207,'Kmala','246727',1,0,'2022-03-03 12:59:39','2022-03-03 12:59:39'),(72065,207,'Kolasagar','246735',1,0,'2022-03-03 12:59:39','2022-03-03 12:59:39'),(72066,207,'Kotkader','246763',1,0,'2022-03-03 12:59:39','2022-03-03 12:59:39'),(72067,207,'Kotwali (Bijnor)','246764',1,0,'2022-03-03 12:59:39','2022-03-03 12:59:39'),(72068,207,'Kumharpura Urf Ibrahimpur','246726',1,0,'2022-03-03 12:59:39','2022-03-03 12:59:39'),(72069,207,'Kumhera','246731',1,0,'2022-03-03 12:59:39','2022-03-03 12:59:39'),(72070,207,'Lakhuwala','246764',1,0,'2022-03-03 12:59:39','2022-03-03 12:59:39'),(72071,207,'Lal Dhang','246763',1,0,'2022-03-03 12:59:39','2022-03-03 12:59:39'),(72072,207,'Lodhipur Milak','246727',1,0,'2022-03-03 12:59:39','2022-03-03 12:59:39'),(72073,207,'Mahawatpur Billoch','246763',1,0,'2022-03-03 12:59:39','2022-03-03 12:59:39'),(72074,207,'Maheswari Jat','246764',1,0,'2022-03-03 12:59:39','2022-03-03 12:59:39'),(72075,207,'Maheswari Nagla','246721',1,0,'2022-03-03 12:59:39','2022-03-03 12:59:39'),(72076,207,'Mahua','246733',1,0,'2022-03-03 12:59:39','2022-03-03 12:59:39'),(72077,207,'Main Bazar Nehtaur','246733',1,0,'2022-03-03 12:59:39','2022-03-03 12:59:39'),(72078,207,'Majhera Shakroo','246762',1,0,'2022-03-03 12:59:39','2022-03-03 12:59:39'),(72079,207,'Manawwarpur  Said','246762',1,0,'2022-03-03 12:59:39','2022-03-03 12:59:39'),(72080,207,'Mandawali','246749',1,0,'2022-03-03 12:59:39','2022-03-03 12:59:39'),(72081,207,'Mandawar (Bijnor)','246721',1,0,'2022-03-03 12:59:39','2022-03-03 12:59:39'),(72082,207,'Mangolpura Roopchand','246701',1,0,'2022-03-03 12:59:39','2022-03-03 12:59:39'),(72083,207,'Maniyawala','246722',1,0,'2022-03-03 12:59:39','2022-03-03 12:59:39'),(72084,207,'Manjhola Billoch','246727',1,0,'2022-03-03 12:59:40','2022-03-03 12:59:40'),(72085,207,'Mankuaa','246761',1,0,'2022-03-03 12:59:40','2022-03-03 12:59:40'),(72086,207,'Manpurshivpuri','246761',1,0,'2022-03-03 12:59:40','2022-03-03 12:59:40'),(72087,207,'Maqsoodpur','246745',1,0,'2022-03-03 12:59:40','2022-03-03 12:59:40'),(72088,207,'Maseet','246729',1,0,'2022-03-03 12:59:40','2022-03-03 12:59:40'),(72089,207,'Maujampur Suraj','246761',1,0,'2022-03-03 12:59:40','2022-03-03 12:59:40'),(72090,207,'Mauri Kedarpur','246761',1,0,'2022-03-03 12:59:40','2022-03-03 12:59:40'),(72091,207,'Mauzampur Jaitra','246761',1,0,'2022-03-03 12:59:40','2022-03-03 12:59:40'),(72092,207,'Mauzzampur Narayan','246731',1,0,'2022-03-03 12:59:40','2022-03-03 12:59:40'),(72093,207,'Medpura Sultan','246762',1,0,'2022-03-03 12:59:40','2022-03-03 12:59:40'),(72094,207,'Mehamdabad','246726',1,0,'2022-03-03 12:59:40','2022-03-03 12:59:40'),(72095,207,'Meharlipur','246733',1,0,'2022-03-03 12:59:40','2022-03-03 12:59:40'),(72096,207,'Mehmoodpur','246745',1,0,'2022-03-03 12:59:40','2022-03-03 12:59:40'),(72097,207,'Meman Bhanera','246731',1,0,'2022-03-03 12:59:40','2022-03-03 12:59:40'),(72098,207,'Mewa Nawada','246745',1,0,'2022-03-03 12:59:40','2022-03-03 12:59:40'),(72099,207,'Milak Mukeempur','246733',1,0,'2022-03-03 12:59:40','2022-03-03 12:59:40'),(72100,207,'Milak Puranpur','246761',1,0,'2022-03-03 12:59:40','2022-03-03 12:59:40'),(72101,207,'Mirzapur','246747',1,0,'2022-03-03 12:59:40','2022-03-03 12:59:40'),(72102,207,'Mirzapur Khader','246725',1,0,'2022-03-03 12:59:40','2022-03-03 12:59:40'),(72103,207,'Mirzapur Mahesh Urf Bankpur','246764',1,0,'2022-03-03 12:59:40','2022-03-03 12:59:40'),(72104,207,'Mithi Beri','246763',1,0,'2022-03-03 12:59:40','2022-03-03 12:59:40'),(72105,207,'Mo. Pur Mandawali','246701',1,0,'2022-03-03 12:59:40','2022-03-03 12:59:40'),(72106,207,'Mohammedpur Kamil','246733',1,0,'2022-03-03 12:59:40','2022-03-03 12:59:40'),(72107,207,'Mohammedpur Rajauri','246747',1,0,'2022-03-03 12:59:41','2022-03-03 12:59:41'),(72108,207,'Mohanpur','246749',1,0,'2022-03-03 12:59:41','2022-03-03 12:59:41'),(72109,207,'Mohd.Pur Devmal','246721',1,0,'2022-03-03 12:59:41','2022-03-03 12:59:41'),(72110,207,'Mohiddinpur','246721',1,0,'2022-03-03 12:59:41','2022-03-03 12:59:41'),(72111,207,'Morna','246761',1,0,'2022-03-03 12:59:41','2022-03-03 12:59:41'),(72112,207,'Mukarabpuri','246746',1,0,'2022-03-03 12:59:41','2022-03-03 12:59:41'),(72113,207,'Murhat','246734',1,0,'2022-03-03 12:59:41','2022-03-03 12:59:41'),(72114,207,'Mustafabad','246734',1,0,'2022-03-03 12:59:41','2022-03-03 12:59:41'),(72115,207,'Nagal Jat','246726',1,0,'2022-03-03 12:59:41','2022-03-03 12:59:41'),(72116,207,'Nagal (Bijnor)','246732',1,0,'2022-03-03 12:59:41','2022-03-03 12:59:41'),(72117,207,'Nagina Bazar','246762',1,0,'2022-03-03 12:59:41','2022-03-03 12:59:41'),(72118,207,'Nagina (Bijnor)','246762',1,0,'2022-03-03 12:59:41','2022-03-03 12:59:41'),(72119,207,'Nagli Pathwari','246727',1,0,'2022-03-03 12:59:41','2022-03-03 12:59:41'),(72120,207,'Nai Basti','246701',1,0,'2022-03-03 12:59:41','2022-03-03 12:59:41'),(72121,207,'Nainpura','246762',1,0,'2022-03-03 12:59:41','2022-03-03 12:59:41'),(72122,207,'Najibabad RS','246763',1,0,'2022-03-03 12:59:41','2022-03-03 12:59:41'),(72123,207,'Najibabad','246763',1,0,'2022-03-03 12:59:41','2022-03-03 12:59:41'),(72124,207,'Najibabad Tehsil','246763',1,0,'2022-03-03 12:59:41','2022-03-03 12:59:41'),(72125,207,'Nakibpur Khajoori','246733',1,0,'2022-03-03 12:59:41','2022-03-03 12:59:41'),(72126,207,'Narayan Kheri','246733',1,0,'2022-03-03 12:59:41','2022-03-03 12:59:41'),(72127,207,'Narayanpur','246721',1,0,'2022-03-03 12:59:41','2022-03-03 12:59:41'),(72128,207,'Nasiri','246701',1,0,'2022-03-03 12:59:41','2022-03-03 12:59:41'),(72129,207,'Nasirpur Banwari','246761',1,0,'2022-03-03 12:59:41','2022-03-03 12:59:41'),(72130,207,'Nawada','246728',1,0,'2022-03-03 12:59:41','2022-03-03 12:59:41'),(72131,207,'Nawada Kesho','246746',1,0,'2022-03-03 12:59:41','2022-03-03 12:59:41'),(72132,207,'Naya Gaon','246701',1,0,'2022-03-03 12:59:42','2022-03-03 12:59:42'),(72133,207,'Nayak Nagla','246729',1,0,'2022-03-03 12:59:42','2022-03-03 12:59:42'),(72134,207,'Neendru','246761',1,0,'2022-03-03 12:59:42','2022-03-03 12:59:42'),(72135,207,'Nehtaur Bus Stand','246733',1,0,'2022-03-03 12:59:42','2022-03-03 12:59:42'),(72136,207,'Nehtaur','246733',1,0,'2022-03-03 12:59:42','2022-03-03 12:59:42'),(72137,207,'Noorpur','246734',1,0,'2022-03-03 12:59:42','2022-03-03 12:59:42'),(72138,207,'Nwadasaidpur Jalal','246747',1,0,'2022-03-03 12:59:42','2022-03-03 12:59:42'),(72139,207,'Padla','246731',1,0,'2022-03-03 12:59:42','2022-03-03 12:59:42'),(72140,207,'Padli Basera','246761',1,0,'2022-03-03 12:59:42','2022-03-03 12:59:42'),(72141,207,'Paijaniya','246726',1,0,'2022-03-03 12:59:42','2022-03-03 12:59:42'),(72142,207,'Pakhanpur','246762',1,0,'2022-03-03 12:59:42','2022-03-03 12:59:42'),(72143,207,'Palanpur','246746',1,0,'2022-03-03 12:59:42','2022-03-03 12:59:42'),(72144,207,'Pawati','246726',1,0,'2022-03-03 12:59:42','2022-03-03 12:59:42'),(72145,207,'Pheena','246734',1,0,'2022-03-03 12:59:42','2022-03-03 12:59:42'),(72146,207,'Phoolsanda','246733',1,0,'2022-03-03 12:59:42','2022-03-03 12:59:42'),(72147,207,'Pipalsana','246761',1,0,'2022-03-03 12:59:42','2022-03-03 12:59:42'),(72148,207,'Pipli Jat','246725',1,0,'2022-03-03 12:59:42','2022-03-03 12:59:42'),(72149,207,'Prithvipur','246701',1,0,'2022-03-03 12:59:42','2022-03-03 12:59:42'),(72150,207,'Puraini','246761',1,0,'2022-03-03 12:59:42','2022-03-03 12:59:42'),(72151,207,'Qaziwala','246701',1,0,'2022-03-03 12:59:42','2022-03-03 12:59:42'),(72152,207,'Rahu Nagli','246737',1,0,'2022-03-03 12:59:42','2022-03-03 12:59:42'),(72153,207,'Raipur Berisal','246721',1,0,'2022-03-03 12:59:42','2022-03-03 12:59:42'),(72154,207,'Raipur Sadat','246763',1,0,'2022-03-03 12:59:43','2022-03-03 12:59:43'),(72155,207,'Raja-ka-tajpur','246735',1,0,'2022-03-03 12:59:43','2022-03-03 12:59:43'),(72156,207,'Rajapur Sadat','246764',1,0,'2022-03-03 12:59:43','2022-03-03 12:59:43'),(72157,207,'Rajpur Nawada','246732',1,0,'2022-03-03 12:59:43','2022-03-03 12:59:43'),(72158,207,'Rampur Bidar','246733',1,0,'2022-03-03 12:59:43','2022-03-03 12:59:43'),(72159,207,'Rampur Bishna','246731',1,0,'2022-03-03 12:59:43','2022-03-03 12:59:43'),(72160,207,'Rasoolabad','246722',1,0,'2022-03-03 12:59:43','2022-03-03 12:59:43'),(72161,207,'Rasoolpur Nagla','246736',1,0,'2022-03-03 12:59:43','2022-03-03 12:59:43'),(72162,207,'Ratagarh','246734',1,0,'2022-03-03 12:59:43','2022-03-03 12:59:43'),(72163,207,'Rawana Shikarpur','246735',1,0,'2022-03-03 12:59:43','2022-03-03 12:59:43'),(72164,207,'Rawli','246721',1,0,'2022-03-03 12:59:43','2022-03-03 12:59:43'),(72165,207,'Rehar','246722',1,0,'2022-03-03 12:59:43','2022-03-03 12:59:43'),(72166,207,'Roniya','246725',1,0,'2022-03-03 12:59:43','2022-03-03 12:59:43'),(72167,207,'Rustampur Sherpali Jat','246733',1,0,'2022-03-03 12:59:43','2022-03-03 12:59:43'),(72168,207,'Sabdalpur','246735',1,0,'2022-03-03 12:59:43','2022-03-03 12:59:43'),(72169,207,'Sabdalpur Bitra','246732',1,0,'2022-03-03 12:59:43','2022-03-03 12:59:43'),(72170,207,'Sabdalpur Rehra','246701',1,0,'2022-03-03 12:59:43','2022-03-03 12:59:43'),(72171,207,'Sadafal','246746',1,0,'2022-03-03 12:59:43','2022-03-03 12:59:43'),(72172,207,'Sadaranpur','246745',1,0,'2022-03-03 12:59:43','2022-03-03 12:59:43'),(72173,207,'Saddobair','246761',1,0,'2022-03-03 12:59:43','2022-03-03 12:59:43'),(72174,207,'Sadruddin Nagar','246733',1,0,'2022-03-03 12:59:43','2022-03-03 12:59:43'),(72175,207,'Sahanpur','246749',1,0,'2022-03-03 12:59:43','2022-03-03 12:59:43'),(72176,207,'Sahaspur (Bijnor)','246745',1,0,'2022-03-03 12:59:43','2022-03-03 12:59:43'),(72177,207,'Saidabad','246701',1,0,'2022-03-03 12:59:44','2022-03-03 12:59:44'),(72178,207,'Saidpuri Mahichand','246762',1,0,'2022-03-03 12:59:44','2022-03-03 12:59:44'),(72179,207,'Saindwar','246725',1,0,'2022-03-03 12:59:44','2022-03-03 12:59:44'),(72180,207,'Sardhani','246701',1,0,'2022-03-03 12:59:44','2022-03-03 12:59:44'),(72181,207,'Sarkara Chakrajmal','246761',1,0,'2022-03-03 12:59:44','2022-03-03 12:59:44'),(72182,207,'Sarkathal Sahni','246761',1,0,'2022-03-03 12:59:44','2022-03-03 12:59:44'),(72183,207,'Sedha','246733',1,0,'2022-03-03 12:59:44','2022-03-03 12:59:44'),(72184,207,'Seohara RS','246746',1,0,'2022-03-03 12:59:44','2022-03-03 12:59:44'),(72185,207,'Seohara','246746',1,0,'2022-03-03 12:59:44','2022-03-03 12:59:44'),(72186,207,'Shadipur','246764',1,0,'2022-03-03 12:59:44','2022-03-03 12:59:44'),(72187,207,'Shadipur Milak','246734',1,0,'2022-03-03 12:59:44','2022-03-03 12:59:44'),(72188,207,'Shahnagar Kurali','246747',1,0,'2022-03-03 12:59:44','2022-03-03 12:59:44'),(72189,207,'Shahpur Kheri','246727',1,0,'2022-03-03 12:59:44','2022-03-03 12:59:44'),(72190,207,'Shahzadpur','246747',1,0,'2022-03-03 12:59:44','2022-03-03 12:59:44'),(72191,207,'Shergarh','246747',1,0,'2022-03-03 12:59:44','2022-03-03 12:59:44'),(72192,207,'Sherkot','246747',1,0,'2022-03-03 12:59:44','2022-03-03 12:59:44'),(72193,207,'Sherpur Balla','246733',1,0,'2022-03-03 12:59:44','2022-03-03 12:59:44'),(72194,207,'Sherpur Kalyan','246726',1,0,'2022-03-03 12:59:44','2022-03-03 12:59:44'),(72195,207,'Shiwala Kalan','246734',1,0,'2022-03-03 12:59:44','2022-03-03 12:59:44'),(72196,207,'Siau','246725',1,0,'2022-03-03 12:59:44','2022-03-03 12:59:44'),(72197,207,'Sikanderpur Basi','246763',1,0,'2022-03-03 12:59:44','2022-03-03 12:59:44'),(72198,207,'Sikri Buzurg','246733',1,0,'2022-03-03 12:59:44','2022-03-03 12:59:44'),(72199,207,'Simla Kalan','246721',1,0,'2022-03-03 12:59:44','2022-03-03 12:59:44'),(72200,207,'Singha','246725',1,0,'2022-03-03 12:59:44','2022-03-03 12:59:44'),(72201,207,'Sipahiwala','246746',1,0,'2022-03-03 12:59:44','2022-03-03 12:59:44'),(72202,207,'Sirwasuchand','246722',1,0,'2022-03-03 12:59:44','2022-03-03 12:59:44'),(72203,207,'Sisauna','246729',1,0,'2022-03-03 12:59:45','2022-03-03 12:59:45'),(72204,207,'Sofatpur','246732',1,0,'2022-03-03 12:59:45','2022-03-03 12:59:45'),(72205,207,'Suawala','246747',1,0,'2022-03-03 12:59:45','2022-03-03 12:59:45'),(72206,207,'Sudnipur Rawati','246725',1,0,'2022-03-03 12:59:45','2022-03-03 12:59:45'),(72207,207,'Sunpata','246764',1,0,'2022-03-03 12:59:45','2022-03-03 12:59:45'),(72208,207,'Suwheri','246701',1,0,'2022-03-03 12:59:45','2022-03-03 12:59:45'),(72209,207,'Taharpur Said','246733',1,0,'2022-03-03 12:59:45','2022-03-03 12:59:45'),(72210,207,'Tanda Maidas','246763',1,0,'2022-03-03 12:59:45','2022-03-03 12:59:45'),(72211,207,'Tanda Shahuwala','246724',1,0,'2022-03-03 12:59:45','2022-03-03 12:59:45'),(72212,207,'Tibri','246761',1,0,'2022-03-03 12:59:45','2022-03-03 12:59:45'),(72213,207,'Tisotra','246723',1,0,'2022-03-03 12:59:45','2022-03-03 12:59:45'),(72214,207,'Udaipur','246722',1,0,'2022-03-03 12:59:45','2022-03-03 12:59:45'),(72215,207,'Uledha','246701',1,0,'2022-03-03 12:59:45','2022-03-03 12:59:45'),(72216,207,'Umri','246728',1,0,'2022-03-03 12:59:45','2022-03-03 12:59:45'),(72217,207,'Umri','246761',1,0,'2022-03-03 12:59:45','2022-03-03 12:59:45'),(72218,207,'Vidur Kuti','246701',1,0,'2022-03-03 12:59:45','2022-03-03 12:59:45'),(72219,208,'Abdulla Ganj','243639',1,0,'2022-03-03 12:59:45','2022-03-03 12:59:45'),(72220,208,'Abhigaon','243631',1,0,'2022-03-03 12:59:45','2022-03-03 12:59:45'),(72221,208,'Afjalpur Chhaganpur','243638',1,0,'2022-03-03 12:59:45','2022-03-03 12:59:45'),(72222,208,'Agthra','243725',1,0,'2022-03-03 12:59:45','2022-03-03 12:59:45'),(72223,208,'Allahpur Samaspur','243723',1,0,'2022-03-03 12:59:45','2022-03-03 12:59:45'),(72224,208,'Allapur','243631',1,0,'2022-03-03 12:59:45','2022-03-03 12:59:45'),(72225,208,'Ambiapur','243633',1,0,'2022-03-03 12:59:45','2022-03-03 12:59:45'),(72226,208,'Arifpur Nawada','243601',1,0,'2022-03-03 12:59:45','2022-03-03 12:59:45'),(72227,208,'Asadpur','243722',1,0,'2022-03-03 12:59:45','2022-03-03 12:59:45'),(72228,208,'Asafpur','243632',1,0,'2022-03-03 12:59:46','2022-03-03 12:59:46'),(72229,208,'Asis Berkhin','243601',1,0,'2022-03-03 12:59:46','2022-03-03 12:59:46'),(72230,208,'Aslaur','243723',1,0,'2022-03-03 12:59:46','2022-03-03 12:59:46'),(72231,208,'Asrasi','243601',1,0,'2022-03-03 12:59:46','2022-03-03 12:59:46'),(72232,208,'Atarpura','243725',1,0,'2022-03-03 12:59:46','2022-03-03 12:59:46'),(72233,208,'Azampur Bisaria','243635',1,0,'2022-03-03 12:59:46','2022-03-03 12:59:46'),(72234,208,'Babrala','243751',1,0,'2022-03-03 12:59:46','2022-03-03 12:59:46'),(72235,208,'Baburam Market','243601',1,0,'2022-03-03 12:59:46','2022-03-03 12:59:46'),(72236,208,'Bagrain','243725',1,0,'2022-03-03 12:59:46','2022-03-03 12:59:46'),(72237,208,'Bairmai Khurd','243633',1,0,'2022-03-03 12:59:46','2022-03-03 12:59:46'),(72238,208,'Bairpur Maharaji','243722',1,0,'2022-03-03 12:59:46','2022-03-03 12:59:46'),(72239,208,'Baksar','243638',1,0,'2022-03-03 12:59:46','2022-03-03 12:59:46'),(72240,208,'Baksena','243635',1,0,'2022-03-03 12:59:46','2022-03-03 12:59:46'),(72241,208,'Bamnausi','243639',1,0,'2022-03-03 12:59:46','2022-03-03 12:59:46'),(72242,208,'Bandarai','243722',1,0,'2022-03-03 12:59:46','2022-03-03 12:59:46'),(72243,208,'Bankota','243726',1,0,'2022-03-03 12:59:46','2022-03-03 12:59:46'),(72244,208,'Bans Barolia','243633',1,0,'2022-03-03 12:59:46','2022-03-03 12:59:46'),(72245,208,'Barachirra','243601',1,0,'2022-03-03 12:59:46','2022-03-03 12:59:46'),(72246,208,'Barategdar','243726',1,0,'2022-03-03 12:59:46','2022-03-03 12:59:46'),(72247,208,'Baror Amanullapur','243726',1,0,'2022-03-03 12:59:46','2022-03-03 12:59:46'),(72248,208,'Barsua','243639',1,0,'2022-03-03 12:59:46','2022-03-03 12:59:46'),(72249,208,'Basoma','243639',1,0,'2022-03-03 12:59:46','2022-03-03 12:59:46'),(72250,208,'Baudaun Kty','243601',1,0,'2022-03-03 12:59:46','2022-03-03 12:59:46'),(72251,208,'Behta Gusain','243633',1,0,'2022-03-03 12:59:47','2022-03-03 12:59:47'),(72252,208,'Bela Dandi','243635',1,0,'2022-03-03 12:59:47','2022-03-03 12:59:47'),(72253,208,'Beoli','243726',1,0,'2022-03-03 12:59:47','2022-03-03 12:59:47'),(72254,208,'Beor','243634',1,0,'2022-03-03 12:59:47','2022-03-03 12:59:47'),(72255,208,'Beor Kasimabad','243723',1,0,'2022-03-03 12:59:47','2022-03-03 12:59:47'),(72256,208,'Bhagta Nagla','243638',1,0,'2022-03-03 12:59:47','2022-03-03 12:59:47'),(72257,208,'Bhakrauli','243751',1,0,'2022-03-03 12:59:47','2022-03-03 12:59:47'),(72258,208,'Bhamori','243638',1,0,'2022-03-03 12:59:47','2022-03-03 12:59:47'),(72259,208,'Bhanpur','243720',1,0,'2022-03-03 12:59:47','2022-03-03 12:59:47'),(72260,208,'Bharkuian','243601',1,0,'2022-03-03 12:59:47','2022-03-03 12:59:47'),(72261,208,'Bhatauli','243630',1,0,'2022-03-03 12:59:47','2022-03-03 12:59:47'),(72262,208,'Bhau Nagla','243635',1,0,'2022-03-03 12:59:47','2022-03-03 12:59:47'),(72263,208,'Bhavipur','243724',1,0,'2022-03-03 12:59:47','2022-03-03 12:59:47'),(72264,208,'Bhawanipur Khairu','243638',1,0,'2022-03-03 12:59:47','2022-03-03 12:59:47'),(72265,208,'Bhirawati','243751',1,0,'2022-03-03 12:59:47','2022-03-03 12:59:47'),(72266,208,'Bhoor Bisauli','243632',1,0,'2022-03-03 12:59:47','2022-03-03 12:59:47'),(72267,208,'Bhoora Bhadraul','243636',1,0,'2022-03-03 12:59:47','2022-03-03 12:59:47'),(72268,208,'Bhundi','243641',1,0,'2022-03-03 12:59:47','2022-03-03 12:59:47'),(72269,208,'Bhusaya','243723',1,0,'2022-03-03 12:59:47','2022-03-03 12:59:47'),(72270,208,'Bilhat','243634',1,0,'2022-03-03 12:59:47','2022-03-03 12:59:47'),(72271,208,'Bilsi','243633',1,0,'2022-03-03 12:59:47','2022-03-03 12:59:47'),(72272,208,'Binawar','243634',1,0,'2022-03-03 12:59:47','2022-03-03 12:59:47'),(72273,208,'Bisauli','243720',1,0,'2022-03-03 12:59:48','2022-03-03 12:59:48'),(72274,208,'Bondri ','243636',1,0,'2022-03-03 12:59:48','2022-03-03 12:59:48'),(72275,208,'Brahmpur (Budaun)','243601',1,0,'2022-03-03 12:59:48','2022-03-03 12:59:48'),(72276,208,'Buda R.S.','243601',1,0,'2022-03-03 12:59:48','2022-03-03 12:59:48'),(72277,208,'Budaun City','243601',1,0,'2022-03-03 12:59:48','2022-03-03 12:59:48'),(72278,208,'Budaun H.O','243601',1,0,'2022-03-03 12:59:48','2022-03-03 12:59:48'),(72279,208,'Budhawai','243601',1,0,'2022-03-03 12:59:48','2022-03-03 12:59:48'),(72280,208,'Butla Daulat','243639',1,0,'2022-03-03 12:59:48','2022-03-03 12:59:48'),(72281,208,'Chandoi','243723',1,0,'2022-03-03 12:59:48','2022-03-03 12:59:48'),(72282,208,'Chani','243724',1,0,'2022-03-03 12:59:48','2022-03-03 12:59:48'),(72283,208,'Chaudhary Sarai','243601',1,0,'2022-03-03 12:59:48','2022-03-03 12:59:48'),(72284,208,'Chhapra','243751',1,0,'2022-03-03 12:59:48','2022-03-03 12:59:48'),(72285,208,'Chhatuiya','243639',1,0,'2022-03-03 12:59:48','2022-03-03 12:59:48'),(72286,208,'Chitaura','243631',1,0,'2022-03-03 12:59:48','2022-03-03 12:59:48'),(72287,208,'Chitri','243635',1,0,'2022-03-03 12:59:48','2022-03-03 12:59:48'),(72288,208,'Civil Liens','243601',1,0,'2022-03-03 12:59:48','2022-03-03 12:59:48'),(72289,208,'Dabthara Harlal','243722',1,0,'2022-03-03 12:59:48','2022-03-03 12:59:48'),(72290,208,'Dabtori','243720',1,0,'2022-03-03 12:59:48','2022-03-03 12:59:48'),(72291,208,'Dahagawan','243638',1,0,'2022-03-03 12:59:48','2022-03-03 12:59:48'),(72292,208,'Daharpur Kalan','243635',1,0,'2022-03-03 12:59:48','2022-03-03 12:59:48'),(72293,208,'Dakarapukhta','243638',1,0,'2022-03-03 12:59:48','2022-03-03 12:59:48'),(72294,208,'Danbri','243632',1,0,'2022-03-03 12:59:48','2022-03-03 12:59:48'),(72295,208,'Danpur','243723',1,0,'2022-03-03 12:59:48','2022-03-03 12:59:48'),(72296,208,'Dataganj','243635',1,0,'2022-03-03 12:59:48','2022-03-03 12:59:48'),(72297,208,'Dehemu','243636',1,0,'2022-03-03 12:59:49','2022-03-03 12:59:49'),(72298,208,'Deorijeet','243634',1,0,'2022-03-03 12:59:49','2022-03-03 12:59:49'),(72299,208,'Dhanari','243751',1,0,'2022-03-03 12:59:49','2022-03-03 12:59:49'),(72300,208,'Dhandwara','243722',1,0,'2022-03-03 12:59:49','2022-03-03 12:59:49'),(72301,208,'Dharampur Tappa Vaish','243638',1,0,'2022-03-03 12:59:49','2022-03-03 12:59:49'),(72302,208,'Dinaura','243751',1,0,'2022-03-03 12:59:49','2022-03-03 12:59:49'),(72303,208,'Dudhauni','243633',1,0,'2022-03-03 12:59:49','2022-03-03 12:59:49'),(72304,208,'Dugraiya','243601',1,0,'2022-03-03 12:59:49','2022-03-03 12:59:49'),(72305,208,'Dupta Kalan','243751',1,0,'2022-03-03 12:59:49','2022-03-03 12:59:49'),(72306,208,'Faizganj Behta','243632',1,0,'2022-03-03 12:59:49','2022-03-03 12:59:49'),(72307,208,'Fatehpur','243601',1,0,'2022-03-03 12:59:49','2022-03-03 12:59:49'),(72308,208,'Gandah','243630',1,0,'2022-03-03 12:59:49','2022-03-03 12:59:49'),(72309,208,'Gandhrauli','243724',1,0,'2022-03-03 12:59:49','2022-03-03 12:59:49'),(72310,208,'Gangoli','243632',1,0,'2022-03-03 12:59:49','2022-03-03 12:59:49'),(72311,208,'Garhi','243639',1,0,'2022-03-03 12:59:49','2022-03-03 12:59:49'),(72312,208,'Gari Bichola','243723',1,0,'2022-03-03 12:59:49','2022-03-03 12:59:49'),(72313,208,'Garikhanpur','243723',1,0,'2022-03-03 12:59:49','2022-03-03 12:59:49'),(72314,208,'Gathona','243639',1,0,'2022-03-03 12:59:49','2022-03-03 12:59:49'),(72315,208,'Gauntara','243631',1,0,'2022-03-03 12:59:49','2022-03-03 12:59:49'),(72316,208,'Gaurami','243601',1,0,'2022-03-03 12:59:49','2022-03-03 12:59:49'),(72317,208,'Gawan','243727',1,0,'2022-03-03 12:59:49','2022-03-03 12:59:49'),(72318,208,'Ghilaur','243635',1,0,'2022-03-03 12:59:49','2022-03-03 12:59:49'),(72319,208,'Ghosali Bahan','243722',1,0,'2022-03-03 12:59:49','2022-03-03 12:59:49'),(72320,208,'Gidhaul','243601',1,0,'2022-03-03 12:59:49','2022-03-03 12:59:49'),(72321,208,'Gotha','243726',1,0,'2022-03-03 12:59:50','2022-03-03 12:59:50'),(72322,208,'Gudhani','243633',1,0,'2022-03-03 12:59:50','2022-03-03 12:59:50'),(72323,208,'Gula Barela','243631',1,0,'2022-03-03 12:59:50','2022-03-03 12:59:50'),(72324,208,'Gularia','243601',1,0,'2022-03-03 12:59:50','2022-03-03 12:59:50'),(72325,208,'Gularia','243630',1,0,'2022-03-03 12:59:50','2022-03-03 12:59:50'),(72326,208,'Gunnaur','243722',1,0,'2022-03-03 12:59:50','2022-03-03 12:59:50'),(72327,208,'Gurgaon','243601',1,0,'2022-03-03 12:59:50','2022-03-03 12:59:50'),(72328,208,'Gurhana','243637',1,0,'2022-03-03 12:59:50','2022-03-03 12:59:50'),(72329,208,'Haibatpur','243633',1,0,'2022-03-03 12:59:50','2022-03-03 12:59:50'),(72330,208,'Halwai Chawk','243601',1,0,'2022-03-03 12:59:50','2022-03-03 12:59:50'),(72331,208,'Harphari','243751',1,0,'2022-03-03 12:59:50','2022-03-03 12:59:50'),(72332,208,'Hatra','243726',1,0,'2022-03-03 12:59:50','2022-03-03 12:59:50'),(72333,208,'Hatsa','243720',1,0,'2022-03-03 12:59:50','2022-03-03 12:59:50'),(72334,208,'Hazarat Ganj','243639',1,0,'2022-03-03 12:59:50','2022-03-03 12:59:50'),(72335,208,'Hazratpur','243635',1,0,'2022-03-03 12:59:50','2022-03-03 12:59:50'),(72336,208,'Hirauni','243751',1,0,'2022-03-03 12:59:50','2022-03-03 12:59:50'),(72337,208,'Husainpur Pukhata','243636',1,0,'2022-03-03 12:59:50','2022-03-03 12:59:50'),(72338,208,'I.A. Babrala','242021',1,0,'2022-03-03 12:59:50','2022-03-03 12:59:50'),(72339,208,'Ikh Khera','243724',1,0,'2022-03-03 12:59:50','2022-03-03 12:59:50'),(72340,208,'Ikona','243751',1,0,'2022-03-03 12:59:50','2022-03-03 12:59:50'),(72341,208,'Ikri','243601',1,0,'2022-03-03 12:59:50','2022-03-03 12:59:50'),(72342,208,'Isampur Danda','243722',1,0,'2022-03-03 12:59:50','2022-03-03 12:59:50'),(72343,208,'Isapur Baheria','243639',1,0,'2022-03-03 12:59:51','2022-03-03 12:59:51'),(72344,208,'Islamnagar','243723',1,0,'2022-03-03 12:59:51','2022-03-03 12:59:51'),(72345,208,'Jagat','243601',1,0,'2022-03-03 12:59:51','2022-03-03 12:59:51'),(72346,208,'Jakheli','243601',1,0,'2022-03-03 12:59:51','2022-03-03 12:59:51'),(72347,208,'Jalalpur','243601',1,0,'2022-03-03 12:59:51','2022-03-03 12:59:51'),(72348,208,'Jamalpur','243635',1,0,'2022-03-03 12:59:51','2022-03-03 12:59:51'),(72349,208,'Jarwar','243723',1,0,'2022-03-03 12:59:51','2022-03-03 12:59:51'),(72350,208,'Jasrathpur','243720',1,0,'2022-03-03 12:59:51','2022-03-03 12:59:51'),(72351,208,'Jeora Parrwala','243636',1,0,'2022-03-03 12:59:51','2022-03-03 12:59:51'),(72352,208,'Jhuksa','243630',1,0,'2022-03-03 12:59:51','2022-03-03 12:59:51'),(72353,208,'Jijora','243727',1,0,'2022-03-03 12:59:51','2022-03-03 12:59:51'),(72354,208,'Jinaura','243726',1,0,'2022-03-03 12:59:51','2022-03-03 12:59:51'),(72355,208,'Kail','243751',1,0,'2022-03-03 12:59:51','2022-03-03 12:59:51'),(72356,208,'Kakora','243601',1,0,'2022-03-03 12:59:51','2022-03-03 12:59:51'),(72357,208,'Kakrala','243637',1,0,'2022-03-03 12:59:51','2022-03-03 12:59:51'),(72358,208,'Kama','243630',1,0,'2022-03-03 12:59:51','2022-03-03 12:59:51'),(72359,208,'Kangwagugna','243724',1,0,'2022-03-03 12:59:51','2022-03-03 12:59:51'),(72360,208,'Karanpur','243635',1,0,'2022-03-03 12:59:51','2022-03-03 12:59:51'),(72361,208,'Karanpur','243724',1,0,'2022-03-03 12:59:51','2022-03-03 12:59:51'),(72362,208,'Kariamai','243724',1,0,'2022-03-03 12:59:51','2022-03-03 12:59:51'),(72363,208,'Kariyaban','243638',1,0,'2022-03-03 12:59:51','2022-03-03 12:59:51'),(72364,208,'Karkheri','243725',1,0,'2022-03-03 12:59:51','2022-03-03 12:59:51'),(72365,208,'Kartoli','243634',1,0,'2022-03-03 12:59:51','2022-03-03 12:59:51'),(72366,208,'Kashipur','243722',1,0,'2022-03-03 12:59:51','2022-03-03 12:59:51'),(72367,208,'Katgaon','243725',1,0,'2022-03-03 12:59:51','2022-03-03 12:59:51'),(72368,208,'Katinna Berchau','243601',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72369,208,'Katiyan','243637',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72370,208,'Katra Sadatganj','243641',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72371,208,'Kendela','243601',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72372,208,'Khaill Pur','243751',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72373,208,'Khajuria','243720',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72374,208,'Khandwa','243724',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72375,208,'Khera Jalalpur','243641',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72376,208,'Khitaura','243633',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72377,208,'Khukri','243630',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72378,208,'Khurampur Bhamori','243725',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72379,208,'Kichhla','243636',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72380,208,'Kolhai','243638',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72381,208,'Kotha','243723',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72382,208,'Kudah Shahpur','243601',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72383,208,'Kumargaon','243601',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72384,208,'Kurau','243601',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72385,208,'Labhari','243635',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72386,208,'Lahara Nagla Shyam','243722',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72387,208,'Lahi Faridpur','243601',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72388,208,'Lakhanpur','243601',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72389,208,'Laxmipur','243632',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72390,208,'Lilwan','243641',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72391,208,'Madkawali','243722',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72392,208,'Mahclai','243601',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72393,208,'Mailha','243630',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72394,208,'Majhara','243635',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72395,208,'Makrandpur','243725',1,0,'2022-03-03 12:59:52','2022-03-03 12:59:52'),(72396,208,'Malpurtatera','243638',1,0,'2022-03-03 12:59:53','2022-03-03 12:59:53'),(72397,208,'Manikapur Kaur','243635',1,0,'2022-03-03 12:59:53','2022-03-03 12:59:53'),(72398,208,'Mansanagla','243631',1,0,'2022-03-03 12:59:53','2022-03-03 12:59:53'),(72399,208,'Manunagar','243632',1,0,'2022-03-03 12:59:53','2022-03-03 12:59:53'),(72400,208,'Marauri','243631',1,0,'2022-03-03 12:59:53','2022-03-03 12:59:53'),(72401,208,'Mausampur','243635',1,0,'2022-03-03 12:59:53','2022-03-03 12:59:53'),(72402,208,'Mehmoodpur','243751',1,0,'2022-03-03 12:59:53','2022-03-03 12:59:53'),(72403,208,'Mehtabpur','243630',1,0,'2022-03-03 12:59:53','2022-03-03 12:59:53'),(72404,208,'Mehua Hasanganj','242021',1,0,'2022-03-03 12:59:53','2022-03-03 12:59:53'),(72405,208,'Mewali','243724',1,0,'2022-03-03 12:59:53','2022-03-03 12:59:53'),(72406,208,'Miaoo','243631',1,0,'2022-03-03 12:59:53','2022-03-03 12:59:53'),(72407,208,'Mirzapura Sohra','243633',1,0,'2022-03-03 12:59:53','2022-03-03 12:59:53'),(72408,208,'Mithanpur','243638',1,0,'2022-03-03 12:59:53','2022-03-03 12:59:53'),(72409,208,'Mn Sulra','243601',1,0,'2022-03-03 12:59:53','2022-03-03 12:59:53'),(72410,208,'Mohamadpurmi','243720',1,0,'2022-03-03 12:59:53','2022-03-03 12:59:53'),(72411,208,'Mohammad Ganj','243637',1,0,'2022-03-03 12:59:53','2022-03-03 12:59:53'),(72412,208,'Mohkampur','243632',1,0,'2022-03-03 12:59:53','2022-03-03 12:59:53'),(72413,208,'Mongar','243601',1,0,'2022-03-03 12:59:53','2022-03-03 12:59:53'),(72414,208,'Mundia Dhure Ki','243720',1,0,'2022-03-03 12:59:53','2022-03-03 12:59:53'),(72415,208,'Musajhag','243601',1,0,'2022-03-03 12:59:53','2022-03-03 12:59:53'),(72416,208,'Musepur','243633',1,0,'2022-03-03 12:59:53','2022-03-03 12:59:53'),(72417,208,'Musta Fabad Jaretha','243638',1,0,'2022-03-03 12:59:53','2022-03-03 12:59:53'),(72418,208,'Nadail','243638',1,0,'2022-03-03 12:59:53','2022-03-03 12:59:53'),(72419,208,'Nadha','243723',1,0,'2022-03-03 12:59:54','2022-03-03 12:59:54'),(72420,208,'Nadrauli','243722',1,0,'2022-03-03 12:59:54','2022-03-03 12:59:54'),(72421,208,'Nagaria Khanu','243635',1,0,'2022-03-03 12:59:54','2022-03-03 12:59:54'),(72422,208,'Nagarjhoona','243633',1,0,'2022-03-03 12:59:54','2022-03-03 12:59:54'),(72423,208,'Nagla Ajmeri','243722',1,0,'2022-03-03 12:59:54','2022-03-03 12:59:54'),(72424,208,'Nagla Barah','243723',1,0,'2022-03-03 12:59:54','2022-03-03 12:59:54'),(72425,208,'Naithura','243633',1,0,'2022-03-03 12:59:54','2022-03-03 12:59:54'),(72426,208,'Nana Khera','243636',1,0,'2022-03-03 12:59:54','2022-03-03 12:59:54'),(72427,208,'Narsena','243638',1,0,'2022-03-03 12:59:54','2022-03-03 12:59:54'),(72428,208,'Nauli Fatuhabad','243601',1,0,'2022-03-03 12:59:54','2022-03-03 12:59:54'),(72429,208,'Nauli Harnathpur','243725',1,0,'2022-03-03 12:59:54','2022-03-03 12:59:54'),(72430,208,'Nauni','243635',1,0,'2022-03-03 12:59:54','2022-03-03 12:59:54'),(72431,208,'Naushera','243601',1,0,'2022-03-03 12:59:54','2022-03-03 12:59:54'),(72432,208,'Naviganj','243631',1,0,'2022-03-03 12:59:54','2022-03-03 12:59:54'),(72433,208,'Nawada Madhukar','243635',1,0,'2022-03-03 12:59:54','2022-03-03 12:59:54'),(72434,208,'Neora','243727',1,0,'2022-03-03 12:59:54','2022-03-03 12:59:54'),(72435,208,'Nizampur','243601',1,0,'2022-03-03 12:59:54','2022-03-03 12:59:54'),(72436,208,'Nizamuddin Purshah','243632',1,0,'2022-03-03 12:59:54','2022-03-03 12:59:54'),(72437,208,'Noorpur','243601',1,0,'2022-03-03 12:59:54','2022-03-03 12:59:54'),(72438,208,'Noorpur Pinoni','243723',1,0,'2022-03-03 12:59:54','2022-03-03 12:59:54'),(72439,208,'Paharpur','243633',1,0,'2022-03-03 12:59:54','2022-03-03 12:59:54'),(72440,208,'Palia Gujar','243635',1,0,'2022-03-03 12:59:54','2022-03-03 12:59:54'),(72441,208,'Palia Pukhta','243636',1,0,'2022-03-03 12:59:54','2022-03-03 12:59:54'),(72442,208,'Papar Hamzapur','243635',1,0,'2022-03-03 12:59:54','2022-03-03 12:59:54'),(72443,208,'Parauli','243633',1,0,'2022-03-03 12:59:54','2022-03-03 12:59:54'),(72444,208,'Parveznagar','243720',1,0,'2022-03-03 12:59:54','2022-03-03 12:59:54'),(72445,208,'Pataria','243722',1,0,'2022-03-03 12:59:55','2022-03-03 12:59:55'),(72446,208,'Patiali Sarai','243601',1,0,'2022-03-03 12:59:55','2022-03-03 12:59:55'),(72447,208,'Pepal','243725',1,0,'2022-03-03 12:59:55','2022-03-03 12:59:55'),(72448,208,'Pindol','243633',1,0,'2022-03-03 12:59:55','2022-03-03 12:59:55'),(72449,208,'Pipla','243635',1,0,'2022-03-03 12:59:55','2022-03-03 12:59:55'),(72450,208,'Pipraul Pukhta','243636',1,0,'2022-03-03 12:59:55','2022-03-03 12:59:55'),(72451,208,'Pipri Raghunathpur','243724',1,0,'2022-03-03 12:59:55','2022-03-03 12:59:55'),(72452,208,'Police Line (Budaun)','243601',1,0,'2022-03-03 12:59:55','2022-03-03 12:59:55'),(72453,208,'Prasidhpur','243635',1,0,'2022-03-03 12:59:55','2022-03-03 12:59:55'),(72454,208,'Prithvipur','243720',1,0,'2022-03-03 12:59:55','2022-03-03 12:59:55'),(72455,208,'Puraini','243635',1,0,'2022-03-03 12:59:55','2022-03-03 12:59:55'),(72456,208,'Pusawali','243722',1,0,'2022-03-03 12:59:55','2022-03-03 12:59:55'),(72457,208,'Pusgawan','243639',1,0,'2022-03-03 12:59:55','2022-03-03 12:59:55'),(72458,208,'Puthi Sarai','243634',1,0,'2022-03-03 12:59:55','2022-03-03 12:59:55'),(72459,208,'Qadarchawk','243601',1,0,'2022-03-03 12:59:55','2022-03-03 12:59:55'),(72460,208,'Qadrabad','243638',1,0,'2022-03-03 12:59:55','2022-03-03 12:59:55'),(72461,208,'Qaji Tola','243638',1,0,'2022-03-03 12:59:55','2022-03-03 12:59:55'),(72462,208,'Qazi Mohalla','243601',1,0,'2022-03-03 12:59:55','2022-03-03 12:59:55'),(72463,208,'Rahma','243634',1,0,'2022-03-03 12:59:55','2022-03-03 12:59:55'),(72464,208,'Rajpura (Budaun)','243727',1,0,'2022-03-03 12:59:55','2022-03-03 12:59:55'),(72465,208,'Rajthal','243723',1,0,'2022-03-03 12:59:55','2022-03-03 12:59:55'),(72466,208,'Ram Zanpur','243601',1,0,'2022-03-03 12:59:56','2022-03-03 12:59:56'),(72467,208,'Rasoola','243639',1,0,'2022-03-03 12:59:56','2022-03-03 12:59:56'),(72468,208,'Rasoolpur Bela','243638',1,0,'2022-03-03 12:59:56','2022-03-03 12:59:56'),(72469,208,'Rasoolpur Kalan','243638',1,0,'2022-03-03 12:59:56','2022-03-03 12:59:56'),(72470,208,'Rehariya','243725',1,0,'2022-03-03 12:59:56','2022-03-03 12:59:56'),(72471,208,'Reonai','243633',1,0,'2022-03-03 12:59:56','2022-03-03 12:59:56'),(72472,208,'Reonaiya','243636',1,0,'2022-03-03 12:59:56','2022-03-03 12:59:56'),(72473,208,'Rewara','243722',1,0,'2022-03-03 12:59:56','2022-03-03 12:59:56'),(72474,208,'Risauli','243639',1,0,'2022-03-03 12:59:56','2022-03-03 12:59:56'),(72475,208,'Rizola','243641',1,0,'2022-03-03 12:59:56','2022-03-03 12:59:56'),(72476,208,'Roop Pur','243601',1,0,'2022-03-03 12:59:56','2022-03-03 12:59:56'),(72477,208,'Rota','243726',1,0,'2022-03-03 12:59:56','2022-03-03 12:59:56'),(72478,208,'Rudauin','243724',1,0,'2022-03-03 12:59:56','2022-03-03 12:59:56'),(72479,208,'Sadullaganj','243630',1,0,'2022-03-03 12:59:56','2022-03-03 12:59:56'),(72480,208,'Sagrai','243638',1,0,'2022-03-03 12:59:56','2022-03-03 12:59:56'),(72481,208,'Sahaswan','243638',1,0,'2022-03-03 12:59:56','2022-03-03 12:59:56'),(72482,208,'Saidpur (Budaun)','243725',1,0,'2022-03-03 12:59:56','2022-03-03 12:59:56'),(72483,208,'Saijani','243635',1,0,'2022-03-03 12:59:56','2022-03-03 12:59:56'),(72484,208,'Saitua','243751',1,0,'2022-03-03 12:59:56','2022-03-03 12:59:56'),(72485,208,'Sakhanu','243601',1,0,'2022-03-03 12:59:56','2022-03-03 12:59:56'),(72486,208,'Sakri Jangle','243639',1,0,'2022-03-03 12:59:56','2022-03-03 12:59:56'),(72487,208,'Sakri Kasimpur','243601',1,0,'2022-03-03 12:59:56','2022-03-03 12:59:56'),(72488,208,'Salarpur','243601',1,0,'2022-03-03 12:59:56','2022-03-03 12:59:56'),(72489,208,'Salempur','243635',1,0,'2022-03-03 12:59:56','2022-03-03 12:59:56'),(72490,208,'Samrer','243630',1,0,'2022-03-03 12:59:57','2022-03-03 12:59:57'),(72491,208,'Samspurmalik Fatta','243638',1,0,'2022-03-03 12:59:57','2022-03-03 12:59:57'),(72492,208,'Sangrampur','243632',1,0,'2022-03-03 12:59:57','2022-03-03 12:59:57'),(72493,208,'Sanjarpur Baljeet','243639',1,0,'2022-03-03 12:59:57','2022-03-03 12:59:57'),(72494,208,'Santigarh  (Ujhani)','243639',1,0,'2022-03-03 12:59:57','2022-03-03 12:59:57'),(72495,208,'Sarah Bagholi','243633',1,0,'2022-03-03 12:59:57','2022-03-03 12:59:57'),(72496,208,'Sarah Barolia','243633',1,0,'2022-03-03 12:59:57','2022-03-03 12:59:57'),(72497,208,'Sarai Brahman','243722',1,0,'2022-03-03 12:59:57','2022-03-03 12:59:57'),(72498,208,'Sarai Piparia','243635',1,0,'2022-03-03 12:59:57','2022-03-03 12:59:57'),(72499,208,'Saraira','243724',1,0,'2022-03-03 12:59:57','2022-03-03 12:59:57'),(72500,208,'Sareli Pukhta','243641',1,0,'2022-03-03 12:59:57','2022-03-03 12:59:57'),(72501,208,'Sarup Pur','243633',1,0,'2022-03-03 12:59:57','2022-03-03 12:59:57'),(72502,208,'Sateti','243633',1,0,'2022-03-03 12:59:57','2022-03-03 12:59:57'),(72503,208,'Shahjadnagar','243639',1,0,'2022-03-03 12:59:57','2022-03-03 12:59:57'),(72504,208,'Shahjanabad','243751',1,0,'2022-03-03 12:59:57','2022-03-03 12:59:57'),(72505,208,'Shahnagar Patparaganj','243638',1,0,'2022-03-03 12:59:57','2022-03-03 12:59:57'),(72506,208,'Sheikhupur (Budaun)','243601',1,0,'2022-03-03 12:59:57','2022-03-03 12:59:57'),(72507,208,'Shyam Nagar','243601',1,0,'2022-03-03 12:59:57','2022-03-03 12:59:57'),(72508,208,'Sigthara','243725',1,0,'2022-03-03 12:59:57','2022-03-03 12:59:57'),(72509,208,'Sikandrabad','243636',1,0,'2022-03-03 12:59:57','2022-03-03 12:59:57'),(72510,208,'Sikrauri','243634',1,0,'2022-03-03 12:59:57','2022-03-03 12:59:57'),(72511,208,'Sikri','243632',1,0,'2022-03-03 12:59:57','2022-03-03 12:59:57'),(72512,208,'Silhari','243638',1,0,'2022-03-03 12:59:57','2022-03-03 12:59:57'),(72513,208,'Simarra Bhojpur','243633',1,0,'2022-03-03 12:59:57','2022-03-03 12:59:57'),(72514,208,'Singhaula Daulatsingh','243727',1,0,'2022-03-03 12:59:58','2022-03-03 12:59:58'),(72515,208,'Singhauli Kalloo','243727',1,0,'2022-03-03 12:59:58','2022-03-03 12:59:58'),(72516,208,'Singraura','243601',1,0,'2022-03-03 12:59:58','2022-03-03 12:59:58'),(72517,208,'Sirasaul','243633',1,0,'2022-03-03 12:59:58','2022-03-03 12:59:58'),(72518,208,'Sirsa Dabrai','243601',1,0,'2022-03-03 12:59:58','2022-03-03 12:59:58'),(72519,208,'Sirsa Khurd','243638',1,0,'2022-03-03 12:59:58','2022-03-03 12:59:58'),(72520,208,'Sirtaul','243633',1,0,'2022-03-03 12:59:58','2022-03-03 12:59:58'),(72521,208,'Sisaiya Gusain','243630',1,0,'2022-03-03 12:59:58','2022-03-03 12:59:58'),(72522,208,'Sisaraka','243632',1,0,'2022-03-03 12:59:58','2022-03-03 12:59:58'),(72523,208,'Sitholi','243723',1,0,'2022-03-03 12:59:58','2022-03-03 12:59:58'),(72524,208,'Sohi','243726',1,0,'2022-03-03 12:59:58','2022-03-03 12:59:58'),(72525,208,'Sotha','243601',1,0,'2022-03-03 12:59:58','2022-03-03 12:59:58'),(72526,208,'Station Road (Budaun)','243601',1,0,'2022-03-03 12:59:58','2022-03-03 12:59:58'),(72527,208,'Sujawali','243638',1,0,'2022-03-03 12:59:58','2022-03-03 12:59:58'),(72528,208,'Sukhaura','243630',1,0,'2022-03-03 12:59:58','2022-03-03 12:59:58'),(72529,208,'Sukrullapur','243638',1,0,'2022-03-03 12:59:58','2022-03-03 12:59:58'),(72530,208,'Surahi','243723',1,0,'2022-03-03 12:59:58','2022-03-03 12:59:58'),(72531,208,'Sursena','243726',1,0,'2022-03-03 12:59:58','2022-03-03 12:59:58'),(72532,208,'Tara Pathakpur','243720',1,0,'2022-03-03 12:59:58','2022-03-03 12:59:58'),(72533,208,'Tehra','243638',1,0,'2022-03-03 12:59:58','2022-03-03 12:59:58'),(72534,208,'Tigra','243638',1,0,'2022-03-03 12:59:58','2022-03-03 12:59:58'),(72535,208,'Ughaiti','243724',1,0,'2022-03-03 12:59:58','2022-03-03 12:59:58'),(72536,208,'Ujhani','243639',1,0,'2022-03-03 12:59:58','2022-03-03 12:59:58'),(72537,208,'Unola','243601',1,0,'2022-03-03 12:59:59','2022-03-03 12:59:59'),(72538,208,'Urena','243725',1,0,'2022-03-03 12:59:59','2022-03-03 12:59:59'),(72539,208,'Usawan','243631',1,0,'2022-03-03 12:59:59','2022-03-03 12:59:59'),(72540,208,'Usehat','243641',1,0,'2022-03-03 12:59:59','2022-03-03 12:59:59'),(72541,208,'Usmanpur','243638',1,0,'2022-03-03 12:59:59','2022-03-03 12:59:59'),(72542,208,'Wazirganj (Budaun)','243726',1,0,'2022-03-03 12:59:59','2022-03-03 12:59:59'),(72543,208,'Zarifnagar','243638',1,0,'2022-03-03 12:59:59','2022-03-03 12:59:59'),(72544,209,'Ag  School','203002',1,0,'2022-03-03 12:59:59','2022-03-03 12:59:59'),(72545,209,'Agaura  Hameerpur','203131',1,0,'2022-03-03 12:59:59','2022-03-03 12:59:59'),(72546,209,'Agauta','203411',1,0,'2022-03-03 12:59:59','2022-03-03 12:59:59'),(72547,209,'Ahamedpur  Chauroli','203155',1,0,'2022-03-03 12:59:59','2022-03-03 12:59:59'),(72548,209,'Ahar','203398',1,0,'2022-03-03 12:59:59','2022-03-03 12:59:59'),(72549,209,'Ahemedanagar','203411',1,0,'2022-03-03 12:59:59','2022-03-03 12:59:59'),(72550,209,'Ahmadgarh','203392',1,0,'2022-03-03 12:59:59','2022-03-03 12:59:59'),(72551,209,'Ajnara','203150',1,0,'2022-03-03 12:59:59','2022-03-03 12:59:59'),(72552,209,'Akabarpur','203001',1,0,'2022-03-03 12:59:59','2022-03-03 12:59:59'),(72553,209,'Akapur  Tiyana','203411',1,0,'2022-03-03 12:59:59','2022-03-03 12:59:59'),(72554,209,'Amargarh','203398',1,0,'2022-03-03 12:59:59','2022-03-03 12:59:59'),(72555,209,'Amarpur','203405',1,0,'2022-03-03 12:59:59','2022-03-03 12:59:59'),(72556,209,'Anchrookalan','203395',1,0,'2022-03-03 12:59:59','2022-03-03 12:59:59'),(72557,209,'Andhiyar','203391',1,0,'2022-03-03 12:59:59','2022-03-03 12:59:59'),(72558,209,'Anupshahr','203390',1,0,'2022-03-03 12:59:59','2022-03-03 12:59:59'),(72559,209,'Arniya','203131',1,0,'2022-03-03 12:59:59','2022-03-03 12:59:59'),(72560,209,'Asadpur Gher','203393',1,0,'2022-03-03 12:59:59','2022-03-03 12:59:59'),(72561,209,'Asawar','203408',1,0,'2022-03-03 13:00:00','2022-03-03 13:00:00'),(72562,209,'Asfabad Chandpura','203408',1,0,'2022-03-03 13:00:00','2022-03-03 13:00:00'),(72563,209,'Asgarpur','203132',1,0,'2022-03-03 13:00:00','2022-03-03 13:00:00'),(72564,209,'Ashwari','203150',1,0,'2022-03-03 13:00:00','2022-03-03 13:00:00'),(72565,209,'Aterna','203129',1,0,'2022-03-03 13:00:00','2022-03-03 13:00:00'),(72566,209,'Aulina','203001',1,0,'2022-03-03 13:00:00','2022-03-03 13:00:00'),(72567,209,'Auranga Bad Taherpur','203398',1,0,'2022-03-03 13:00:00','2022-03-03 13:00:00'),(72568,209,'Aurangabad Aheer','203205',1,0,'2022-03-03 13:00:00','2022-03-03 13:00:00'),(72569,209,'Aurangabad (Bulandshahr)','203401',1,0,'2022-03-03 13:00:00','2022-03-03 13:00:00'),(72570,209,'Bada Gaon','203131',1,0,'2022-03-03 13:00:00','2022-03-03 13:00:00'),(72571,209,'Baddha  Bazidpur','203412',1,0,'2022-03-03 13:00:00','2022-03-03 13:00:00'),(72572,209,'Badshahpur  Pachgain','203129',1,0,'2022-03-03 13:00:00','2022-03-03 13:00:00'),(72573,209,'Baghwala','203408',1,0,'2022-03-03 13:00:00','2022-03-03 13:00:00'),(72574,209,'Bagrai  Khurd','203131',1,0,'2022-03-03 13:00:00','2022-03-03 13:00:00'),(72575,209,'Bagsara','203390',1,0,'2022-03-03 13:00:00','2022-03-03 13:00:00'),(72576,209,'Balka','203409',1,0,'2022-03-03 13:00:00','2022-03-03 13:00:00'),(72577,209,'Banboai','203408',1,0,'2022-03-03 13:00:00','2022-03-03 13:00:00'),(72578,209,'Banel','203396',1,0,'2022-03-03 13:00:00','2022-03-03 13:00:00'),(72579,209,'Banhpur','203402',1,0,'2022-03-03 13:00:00','2022-03-03 13:00:00'),(72580,209,'Bansuri','203394',1,0,'2022-03-03 13:00:00','2022-03-03 13:00:00'),(72581,209,'Baral','203408',1,0,'2022-03-03 13:00:00','2022-03-03 13:00:00'),(72582,209,'Barhana','203403',1,0,'2022-03-03 13:00:00','2022-03-03 13:00:00'),(72583,209,'Barhpura','203398',1,0,'2022-03-03 13:00:00','2022-03-03 13:00:00'),(72584,209,'Barkatpur','203411',1,0,'2022-03-03 13:00:00','2022-03-03 13:00:00'),(72585,209,'Barouli Basdev Pur','203412',1,0,'2022-03-03 13:00:00','2022-03-03 13:00:00'),(72586,209,'Bb  Nagar','203402',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72587,209,'Behlolpur','203397',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72588,209,'Belon','203389',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72589,209,'Benipur','203402',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72590,209,'Bhadaura Kamalpur','203132',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72591,209,'Bhainsaura','203412',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72592,209,'Bhainshakhur','203411',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72593,209,'Bhaipur','203141',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72594,209,'Bhaipur','203391',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72595,209,'Bhanshrouli','203411',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72596,209,'Bharana','203205',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72597,209,'Bhargava Pharmacy','203390',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72598,209,'Bharkau','203403',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72599,209,'Bhatauna','203408',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72600,209,'Bhatwara','203131',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72601,209,'Bhikampur','203392',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72602,209,'Bhoor','203001',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72603,209,'Bhudhana','203150',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72604,209,'Bibayana','203390',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72605,209,'Bichoula','203131',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72606,209,'Bigraou','203412',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72607,209,'Bihra','203407',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72608,209,'Bihta','203402',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72609,209,'Bilsoory','203205',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72610,209,'Birouli','203409',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72611,209,'Birouly','203390',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72612,209,'Biroura','203397',1,0,'2022-03-03 13:00:01','2022-03-03 13:00:01'),(72613,209,'Bohich','203395',1,0,'2022-03-03 13:00:02','2022-03-03 13:00:02'),(72614,209,'Bugrasi','203403',1,0,'2022-03-03 13:00:02','2022-03-03 13:00:02'),(72615,209,'Buklana','203403',1,0,'2022-03-03 13:00:02','2022-03-03 13:00:02'),(72616,209,'Bulandshahr  Kutchery','203001',1,0,'2022-03-03 13:00:02','2022-03-03 13:00:02'),(72617,209,'Bulandshahr H.O','203001',1,0,'2022-03-03 13:00:02','2022-03-03 13:00:02'),(72618,209,'Bulandshahr Tehsil','203001',1,0,'2022-03-03 13:00:02','2022-03-03 13:00:02'),(72619,209,'Chandauk','203394',1,0,'2022-03-03 13:00:02','2022-03-03 13:00:02'),(72620,209,'Chanderu','203001',1,0,'2022-03-03 13:00:02','2022-03-03 13:00:02'),(72621,209,'Chandiyana','203403',1,0,'2022-03-03 13:00:02','2022-03-03 13:00:02'),(72622,209,'Chaprawat','203408',1,0,'2022-03-03 13:00:02','2022-03-03 13:00:02'),(72623,209,'Charora','203394',1,0,'2022-03-03 13:00:02','2022-03-03 13:00:02'),(72624,209,'Chehla','203392',1,0,'2022-03-03 13:00:02','2022-03-03 13:00:02'),(72625,209,'Chhatary','203397',1,0,'2022-03-03 13:00:02','2022-03-03 13:00:02'),(72626,209,'Chiroury','203399',1,0,'2022-03-03 13:00:02','2022-03-03 13:00:02'),(72627,209,'Chithera','203405',1,0,'2022-03-03 13:00:02','2022-03-03 13:00:02'),(72628,209,'Chitson','203001',1,0,'2022-03-03 13:00:02','2022-03-03 13:00:02'),(72629,209,'Chitsona Ali Pur','203402',1,0,'2022-03-03 13:00:02','2022-03-03 13:00:02'),(72630,209,'Choundhera','203392',1,0,'2022-03-03 13:00:02','2022-03-03 13:00:02'),(72631,209,'Dabar','203132',1,0,'2022-03-03 13:00:02','2022-03-03 13:00:02'),(72632,209,'Daduwa Mutafabad','203395',1,0,'2022-03-03 13:00:02','2022-03-03 13:00:02'),(72633,209,'Dangarh','203392',1,0,'2022-03-03 13:00:02','2022-03-03 13:00:02'),(72634,209,'Dankaur','203201',1,0,'2022-03-03 13:00:02','2022-03-03 13:00:02'),(72635,209,'Danpur (Bulandshahr)','203392',1,0,'2022-03-03 13:00:02','2022-03-03 13:00:02'),(72636,209,'Daoulatpurkalan','203392',1,0,'2022-03-03 13:00:02','2022-03-03 13:00:02'),(72637,209,'Darawer','203398',1,0,'2022-03-03 13:00:02','2022-03-03 13:00:02'),(72638,209,'Dariyapur','203001',1,0,'2022-03-03 13:00:03','2022-03-03 13:00:03'),(72639,209,'Darora','203394',1,0,'2022-03-03 13:00:03','2022-03-03 13:00:03'),(72640,209,'Dashhera  Kherli','203131',1,0,'2022-03-03 13:00:03','2022-03-03 13:00:03'),(72641,209,'Daurau','203393',1,0,'2022-03-03 13:00:03','2022-03-03 13:00:03'),(72642,209,'Dav   College Bulandshahr','203001',1,0,'2022-03-03 13:00:03','2022-03-03 13:00:03'),(72643,209,'Debai  Bazar','203393',1,0,'2022-03-03 13:00:03','2022-03-03 13:00:03'),(72644,209,'Debai','203393',1,0,'2022-03-03 13:00:03','2022-03-03 13:00:03'),(72645,209,'Deputy  Ganj  Bulandshahr','203001',1,0,'2022-03-03 13:00:03','2022-03-03 13:00:03'),(72646,209,'Devrala','203129',1,0,'2022-03-03 13:00:03','2022-03-03 13:00:03'),(72647,209,'Dhalana','203394',1,0,'2022-03-03 13:00:03','2022-03-03 13:00:03'),(72648,209,'Dhamera  Keerat','203001',1,0,'2022-03-03 13:00:03','2022-03-03 13:00:03'),(72649,209,'Dhamraoli','203002',1,0,'2022-03-03 13:00:03','2022-03-03 13:00:03'),(72650,209,'Dhaniya Wali','203403',1,0,'2022-03-03 13:00:03','2022-03-03 13:00:03'),(72651,209,'Dhanoura','203203',1,0,'2022-03-03 13:00:03','2022-03-03 13:00:03'),(72652,209,'Dharakpur','203399',1,0,'2022-03-03 13:00:03','2022-03-03 13:00:03'),(72653,209,'Dharmpur','203393',1,0,'2022-03-03 13:00:03','2022-03-03 13:00:03'),(72654,209,'Dharpa Chuhar Pur','203131',1,0,'2022-03-03 13:00:03','2022-03-03 13:00:03'),(72655,209,'Dhatori','203001',1,0,'2022-03-03 13:00:03','2022-03-03 13:00:03'),(72656,209,'Dighi','203396',1,0,'2022-03-03 13:00:03','2022-03-03 13:00:03'),(72657,209,'Dinoul','203131',1,0,'2022-03-03 13:00:03','2022-03-03 13:00:03'),(72658,209,'Dogawan','203393',1,0,'2022-03-03 13:00:03','2022-03-03 13:00:03'),(72659,209,'Donka','203392',1,0,'2022-03-03 13:00:03','2022-03-03 13:00:03'),(72660,209,'Doulatpur   Kala','203398',1,0,'2022-03-03 13:00:03','2022-03-03 13:00:03'),(72661,209,'Farkana  Gangagarhi','203129',1,0,'2022-03-03 13:00:04','2022-03-03 13:00:04'),(72662,209,'Fazalpur','203396',1,0,'2022-03-03 13:00:04','2022-03-03 13:00:04'),(72663,209,'Firoujpur','203141',1,0,'2022-03-03 13:00:04','2022-03-03 13:00:04'),(72664,209,'Gajipur','203205',1,0,'2022-03-03 13:00:04','2022-03-03 13:00:04'),(72665,209,'Ganga  Garh','203396',1,0,'2022-03-03 13:00:04','2022-03-03 13:00:04'),(72666,209,'Gangawaly','203129',1,0,'2022-03-03 13:00:04','2022-03-03 13:00:04'),(72667,209,'Garhiya Manpur','203408',1,0,'2022-03-03 13:00:04','2022-03-03 13:00:04'),(72668,209,'Geshupur','203205',1,0,'2022-03-03 13:00:04','2022-03-03 13:00:04'),(72669,209,'Gesupur Barwala','203403',1,0,'2022-03-03 13:00:04','2022-03-03 13:00:04'),(72670,209,'Ghungharwaly','203398',1,0,'2022-03-03 13:00:04','2022-03-03 13:00:04'),(72671,209,'Ghunghraoli Banwaripur','203001',1,0,'2022-03-03 13:00:04','2022-03-03 13:00:04'),(72672,209,'Ginora Shekh','203408',1,0,'2022-03-03 13:00:04','2022-03-03 13:00:04'),(72673,209,'Ginoura  Nagly','203405',1,0,'2022-03-03 13:00:04','2022-03-03 13:00:04'),(72674,209,'Giroura','203405',1,0,'2022-03-03 13:00:04','2022-03-03 13:00:04'),(72675,209,'Gt Road  Khurja','203131',1,0,'2022-03-03 13:00:04','2022-03-03 13:00:04'),(72676,209,'Gulaothi','203408',1,0,'2022-03-03 13:00:04','2022-03-03 13:00:04'),(72677,209,'Guraoli','203394',1,0,'2022-03-03 13:00:04','2022-03-03 13:00:04'),(72678,209,'Gurukul  Sikandrabad','203202',1,0,'2022-03-03 13:00:04','2022-03-03 13:00:04'),(72679,209,'Guthaoli','203001',1,0,'2022-03-03 13:00:04','2022-03-03 13:00:04'),(72680,209,'Gwarauly','203129',1,0,'2022-03-03 13:00:04','2022-03-03 13:00:04'),(72681,209,'Harchana','203408',1,0,'2022-03-03 13:00:05','2022-03-03 13:00:05'),(72682,209,'Hattmabad','203001',1,0,'2022-03-03 13:00:05','2022-03-03 13:00:05'),(72683,209,'Hazipur','203403',1,0,'2022-03-03 13:00:05','2022-03-03 13:00:05'),(72684,209,'Hingwara','203402',1,0,'2022-03-03 13:00:05','2022-03-03 13:00:05'),(72685,209,'Indoure  Khera','203392',1,0,'2022-03-03 13:00:05','2022-03-03 13:00:05'),(72686,209,'Industrial Estate Sikandrabad','203206',1,0,'2022-03-03 13:00:05','2022-03-03 13:00:05'),(72687,209,'Ipdc  Bulandshahr','203001',1,0,'2022-03-03 13:00:05','2022-03-03 13:00:05'),(72688,209,'Isapur','203408',1,0,'2022-03-03 13:00:05','2022-03-03 13:00:05'),(72689,209,'Ishmail Pur','203205',1,0,'2022-03-03 13:00:05','2022-03-03 13:00:05'),(72690,209,'Jadoul','203409',1,0,'2022-03-03 13:00:05','2022-03-03 13:00:05'),(72691,209,'Jahangirabad Mandi','203394',1,0,'2022-03-03 13:00:05','2022-03-03 13:00:05'),(72692,209,'Jahangirabad (Bulandshahr)','203394',1,0,'2022-03-03 13:00:05','2022-03-03 13:00:05'),(72693,209,'Jakheta','203394',1,0,'2022-03-03 13:00:05','2022-03-03 13:00:05'),(72694,209,'Jalalpur','203403',1,0,'2022-03-03 13:00:05','2022-03-03 13:00:05'),(72695,209,'Jaleel Pur','203394',1,0,'2022-03-03 13:00:05','2022-03-03 13:00:05'),(72696,209,'Jarara','203131',1,0,'2022-03-03 13:00:05','2022-03-03 13:00:05'),(72697,209,'Jargawan','203399',1,0,'2022-03-03 13:00:05','2022-03-03 13:00:05'),(72698,209,'Jatpura','203394',1,0,'2022-03-03 13:00:05','2022-03-03 13:00:05'),(72699,209,'Jauly Garh','203001',1,0,'2022-03-03 13:00:05','2022-03-03 13:00:05'),(72700,209,'Jawal','203131',1,0,'2022-03-03 13:00:06','2022-03-03 13:00:06'),(72701,209,'Jhal Khera','203002',1,0,'2022-03-03 13:00:06','2022-03-03 13:00:06'),(72702,209,'Jirouly','203390',1,0,'2022-03-03 13:00:06','2022-03-03 13:00:06'),(72703,209,'Jugsana  Kalan','203150',1,0,'2022-03-03 13:00:06','2022-03-03 13:00:06'),(72704,209,'Kahira','203001',1,0,'2022-03-03 13:00:06','2022-03-03 13:00:06'),(72705,209,'Kailawan','203395',1,0,'2022-03-03 13:00:06','2022-03-03 13:00:06'),(72706,209,'Kakrai','203394',1,0,'2022-03-03 13:00:06','2022-03-03 13:00:06'),(72707,209,'Kalena','203131',1,0,'2022-03-03 13:00:06','2022-03-03 13:00:06'),(72708,209,'Kamalpur','203405',1,0,'2022-03-03 13:00:06','2022-03-03 13:00:06'),(72709,209,'Kamona','203397',1,0,'2022-03-03 13:00:06','2022-03-03 13:00:06'),(72710,209,'Kanauna','203405',1,0,'2022-03-03 13:00:06','2022-03-03 13:00:06'),(72711,209,'Kanwra','203205',1,0,'2022-03-03 13:00:06','2022-03-03 13:00:06'),(72712,209,'Karanbash','203393',1,0,'2022-03-03 13:00:06','2022-03-03 13:00:06'),(72713,209,'Karora','203129',1,0,'2022-03-03 13:00:06','2022-03-03 13:00:06'),(72714,209,'Kaser  Kalan','203393',1,0,'2022-03-03 13:00:06','2022-03-03 13:00:06'),(72715,209,'Kaser  Khurd','203393',1,0,'2022-03-03 13:00:06','2022-03-03 13:00:06'),(72716,209,'Katiyawaly','203391',1,0,'2022-03-03 13:00:06','2022-03-03 13:00:06'),(72717,209,'Kayasthwara  Sikandrabad','203205',1,0,'2022-03-03 13:00:06','2022-03-03 13:00:06'),(72718,209,'Keeratpur','203392',1,0,'2022-03-03 13:00:06','2022-03-03 13:00:06'),(72719,209,'Kehroula','203131',1,0,'2022-03-03 13:00:06','2022-03-03 13:00:06'),(72720,209,'Khad  Mohan Nagar','203412',1,0,'2022-03-03 13:00:07','2022-03-03 13:00:07'),(72721,209,'Khadana','203394',1,0,'2022-03-03 13:00:07','2022-03-03 13:00:07'),(72722,209,'Khailiya  Kalyanpur','203391',1,0,'2022-03-03 13:00:07','2022-03-03 13:00:07'),(72723,209,'Khakhunda','203392',1,0,'2022-03-03 13:00:07','2022-03-03 13:00:07'),(72724,209,'Khalor','203394',1,0,'2022-03-03 13:00:07','2022-03-03 13:00:07'),(72725,209,'Khandoi','203398',1,0,'2022-03-03 13:00:07','2022-03-03 13:00:07'),(72726,209,'Khanoda','203394',1,0,'2022-03-03 13:00:07','2022-03-03 13:00:07'),(72727,209,'Khanpur (Bulandshahr)','203405',1,0,'2022-03-03 13:00:07','2022-03-03 13:00:07'),(72728,209,'Kharikbari','203393',1,0,'2022-03-03 13:00:07','2022-03-03 13:00:07'),(72729,209,'Khurja  Chowk','203131',1,0,'2022-03-03 13:00:07','2022-03-03 13:00:07'),(72730,209,'Khurja  Jn  RS','203132',1,0,'2022-03-03 13:00:07','2022-03-03 13:00:07'),(72731,209,'Khurja H.O','203131',1,0,'2022-03-03 13:00:07','2022-03-03 13:00:07'),(72732,209,'Khushalabad','203393',1,0,'2022-03-03 13:00:07','2022-03-03 13:00:07'),(72733,209,'Khushhalpur','203408',1,0,'2022-03-03 13:00:07','2022-03-03 13:00:07'),(72734,209,'Kirra','203131',1,0,'2022-03-03 13:00:07','2022-03-03 13:00:07'),(72735,209,'Kisola','203403',1,0,'2022-03-03 13:00:07','2022-03-03 13:00:07'),(72736,209,'Kisoli','203408',1,0,'2022-03-03 13:00:07','2022-03-03 13:00:07'),(72737,209,'Kota','203408',1,0,'2022-03-03 13:00:07','2022-03-03 13:00:07'),(72738,209,'Krishananagar','203001',1,0,'2022-03-03 13:00:08','2022-03-03 13:00:08'),(72739,209,'KSC Mill  Anupshahr','203391',1,0,'2022-03-03 13:00:08','2022-03-03 13:00:08'),(72740,209,'Kuchesar','203402',1,0,'2022-03-03 13:00:08','2022-03-03 13:00:08'),(72741,209,'Kunwarpur','203396',1,0,'2022-03-03 13:00:08','2022-03-03 13:00:08'),(72742,209,'Kurli','203408',1,0,'2022-03-03 13:00:08','2022-03-03 13:00:08'),(72743,209,'Lad Pur','203402',1,0,'2022-03-03 13:00:08','2022-03-03 13:00:08'),(72744,209,'Lakhaoti','203407',1,0,'2022-03-03 13:00:08','2022-03-03 13:00:08'),(72745,209,'Lalkuan','203001',1,0,'2022-03-03 13:00:08','2022-03-03 13:00:08'),(72746,209,'Lalner','203396',1,0,'2022-03-03 13:00:08','2022-03-03 13:00:08'),(72747,209,'Luharaly Ludhiyana','203001',1,0,'2022-03-03 13:00:08','2022-03-03 13:00:08'),(72748,209,'Madona Jafara Bad','203402',1,0,'2022-03-03 13:00:08','2022-03-03 13:00:08'),(72749,209,'Mahav','203412',1,0,'2022-03-03 13:00:08','2022-03-03 13:00:08'),(72750,209,'Mahepa','203205',1,0,'2022-03-03 13:00:08','2022-03-03 13:00:08'),(72751,209,'Maithna  Jagatpur','203409',1,0,'2022-03-03 13:00:08','2022-03-03 13:00:08'),(72752,209,'Malagarh','203001',1,0,'2022-03-03 13:00:08','2022-03-03 13:00:08'),(72753,209,'Malakpur','203390',1,0,'2022-03-03 13:00:08','2022-03-03 13:00:08'),(72754,209,'Mandi  Anupshahr','203390',1,0,'2022-03-03 13:00:08','2022-03-03 13:00:08'),(72755,209,'Manglore','203150',1,0,'2022-03-03 13:00:08','2022-03-03 13:00:08'),(72756,209,'Mankari','203403',1,0,'2022-03-03 13:00:08','2022-03-03 13:00:08'),(72757,209,'Mauwa  Khera','203398',1,0,'2022-03-03 13:00:08','2022-03-03 13:00:08'),(72758,209,'Mawai','203398',1,0,'2022-03-03 13:00:09','2022-03-03 13:00:09'),(72759,209,'Meerpur','203131',1,0,'2022-03-03 13:00:09','2022-03-03 13:00:09'),(72760,209,'Mirjapur','203001',1,0,'2022-03-03 13:00:09','2022-03-03 13:00:09'),(72761,209,'Mirzapur Niloni','203201',1,0,'2022-03-03 13:00:09','2022-03-03 13:00:09'),(72762,209,'Mohana','203408',1,0,'2022-03-03 13:00:09','2022-03-03 13:00:09'),(72763,209,'Mohersha','203398',1,0,'2022-03-03 13:00:09','2022-03-03 13:00:09'),(72764,209,'Mukeempur','203001',1,0,'2022-03-03 13:00:09','2022-03-03 13:00:09'),(72765,209,'Munda  Khera','203131',1,0,'2022-03-03 13:00:09','2022-03-03 13:00:09'),(72766,209,'Mundi  Bakapur','203407',1,0,'2022-03-03 13:00:09','2022-03-03 13:00:09'),(72767,209,'Muni','203131',1,0,'2022-03-03 13:00:09','2022-03-03 13:00:09'),(72768,209,'Muradpur','203392',1,0,'2022-03-03 13:00:09','2022-03-03 13:00:09'),(72769,209,'Nagla Mahiuddinpur','203131',1,0,'2022-03-03 13:00:09','2022-03-03 13:00:09'),(72770,209,'Nagliya  Udaibhan','203129',1,0,'2022-03-03 13:00:09','2022-03-03 13:00:09'),(72771,209,'Naithala  Hasanpur','203002',1,0,'2022-03-03 13:00:09','2022-03-03 13:00:09'),(72772,209,'NAPP','203389',1,0,'2022-03-03 13:00:09','2022-03-03 13:00:09'),(72773,209,'Narau','203397',1,0,'2022-03-03 13:00:09','2022-03-03 13:00:09'),(72774,209,'Narora','203389',1,0,'2022-03-03 13:00:09','2022-03-03 13:00:09'),(72775,209,'Narsena','203398',1,0,'2022-03-03 13:00:09','2022-03-03 13:00:09'),(72776,209,'Navi Nagar','203394',1,0,'2022-03-03 13:00:10','2022-03-03 13:00:10'),(72777,209,'Naya  Gaon','203001',1,0,'2022-03-03 13:00:10','2022-03-03 13:00:10'),(72778,209,'Nimchana','203407',1,0,'2022-03-03 13:00:10','2022-03-03 13:00:10'),(72779,209,'Nishurkha','203411',1,0,'2022-03-03 13:00:10','2022-03-03 13:00:10'),(72780,209,'Obs Gulaothi','203408',1,0,'2022-03-03 13:00:10','2022-03-03 13:00:10'),(72781,209,'Oledha','203408',1,0,'2022-03-03 13:00:10','2022-03-03 13:00:10'),(72782,209,'Pahasu','203396',1,0,'2022-03-03 13:00:10','2022-03-03 13:00:10'),(72783,209,'Pali  Partapur','203405',1,0,'2022-03-03 13:00:10','2022-03-03 13:00:10'),(72784,209,'Panni  Nagar','203001',1,0,'2022-03-03 13:00:10','2022-03-03 13:00:10'),(72785,209,'Parly','203390',1,0,'2022-03-03 13:00:10','2022-03-03 13:00:10'),(72786,209,'Partapur','203411',1,0,'2022-03-03 13:00:10','2022-03-03 13:00:10'),(72787,209,'Parwana','203407',1,0,'2022-03-03 13:00:10','2022-03-03 13:00:10'),(72788,209,'Paswasara','203401',1,0,'2022-03-03 13:00:10','2022-03-03 13:00:10'),(72789,209,'Pilkhana','203393',1,0,'2022-03-03 13:00:10','2022-03-03 13:00:10'),(72790,209,'Pindrawal','203397',1,0,'2022-03-03 13:00:10','2022-03-03 13:00:10'),(72791,209,'Pitubash','203408',1,0,'2022-03-03 13:00:10','2022-03-03 13:00:10'),(72792,209,'Pondhery','203150',1,0,'2022-03-03 13:00:10','2022-03-03 13:00:10'),(72793,209,'Poothery  Kalan','203392',1,0,'2022-03-03 13:00:10','2022-03-03 13:00:10'),(72794,209,'Prangarh','203205',1,0,'2022-03-03 13:00:10','2022-03-03 13:00:10'),(72795,209,'Raghunathpur','203405',1,0,'2022-03-03 13:00:11','2022-03-03 13:00:11'),(72796,209,'Rahim  Kot','203393',1,0,'2022-03-03 13:00:11','2022-03-03 13:00:11'),(72797,209,'Raipur Palda','203129',1,0,'2022-03-03 13:00:11','2022-03-03 13:00:11'),(72798,209,'Raj Ghat','203393',1,0,'2022-03-03 13:00:11','2022-03-03 13:00:11'),(72799,209,'Ram  Garhi','203141',1,0,'2022-03-03 13:00:11','2022-03-03 13:00:11'),(72800,209,'Ramghat (Bulandshahr)','203399',1,0,'2022-03-03 13:00:11','2022-03-03 13:00:11'),(72801,209,'Rampur  Manpur','203129',1,0,'2022-03-03 13:00:11','2022-03-03 13:00:11'),(72802,209,'Rampur','203389',1,0,'2022-03-03 13:00:11','2022-03-03 13:00:11'),(72803,209,'Rangpur','203001',1,0,'2022-03-03 13:00:11','2022-03-03 13:00:11'),(72804,209,'Raniaoli','203131',1,0,'2022-03-03 13:00:11','2022-03-03 13:00:11'),(72805,209,'Raura','203150',1,0,'2022-03-03 13:00:11','2022-03-03 13:00:11'),(72806,209,'Rehamapur Siyawali','203150',1,0,'2022-03-03 13:00:11','2022-03-03 13:00:11'),(72807,209,'Rewara','203391',1,0,'2022-03-03 13:00:11','2022-03-03 13:00:11'),(72808,209,'Ronda','203150',1,0,'2022-03-03 13:00:11','2022-03-03 13:00:11'),(72809,209,'Roop  Wash','203390',1,0,'2022-03-03 13:00:11','2022-03-03 13:00:11'),(72810,209,'Roop  Wash Pachgain','203131',1,0,'2022-03-03 13:00:11','2022-03-03 13:00:11'),(72811,209,'Runsi','203392',1,0,'2022-03-03 13:00:11','2022-03-03 13:00:11'),(72812,209,'Sabitgarh','203129',1,0,'2022-03-03 13:00:11','2022-03-03 13:00:11'),(72813,209,'Sahar','203397',1,0,'2022-03-03 13:00:12','2022-03-03 13:00:12'),(72814,209,'Saidpur (Bulandshahr)','203411',1,0,'2022-03-03 13:00:12','2022-03-03 13:00:12'),(72815,209,'Sakhani','203394',1,0,'2022-03-03 13:00:12','2022-03-03 13:00:12'),(72816,209,'Salempur','203001',1,0,'2022-03-03 13:00:12','2022-03-03 13:00:12'),(72817,209,'Samashpur','203132',1,0,'2022-03-03 13:00:12','2022-03-03 13:00:12'),(72818,209,'Sanota','203205',1,0,'2022-03-03 13:00:12','2022-03-03 13:00:12'),(72819,209,'Sarai  Chhabila','203409',1,0,'2022-03-03 13:00:12','2022-03-03 13:00:12'),(72820,209,'Sarai Ghashi','203001',1,0,'2022-03-03 13:00:12','2022-03-03 13:00:12'),(72821,209,'Sarangpur','203132',1,0,'2022-03-03 13:00:12','2022-03-03 13:00:12'),(72822,209,'Sarawa','203395',1,0,'2022-03-03 13:00:12','2022-03-03 13:00:12'),(72823,209,'Sathala','203402',1,0,'2022-03-03 13:00:12','2022-03-03 13:00:12'),(72824,209,'Satoha','203393',1,0,'2022-03-03 13:00:12','2022-03-03 13:00:12'),(72825,209,'Satwara','203392',1,0,'2022-03-03 13:00:12','2022-03-03 13:00:12'),(72826,209,'Seekri','203131',1,0,'2022-03-03 13:00:12','2022-03-03 13:00:12'),(72827,209,'Sega  Jagatpur','203407',1,0,'2022-03-03 13:00:12','2022-03-03 13:00:12'),(72828,209,'Senda  Faridpur','203131',1,0,'2022-03-03 13:00:13','2022-03-03 13:00:13'),(72829,209,'Senta','203408',1,0,'2022-03-03 13:00:13','2022-03-03 13:00:13'),(72830,209,'Shahbaz Pur','203131',1,0,'2022-03-03 13:00:13','2022-03-03 13:00:13'),(72831,209,'Shahkarinagar','203150',1,0,'2022-03-03 13:00:13','2022-03-03 13:00:13'),(72832,209,'Shahpur  Kala','203141',1,0,'2022-03-03 13:00:13','2022-03-03 13:00:13'),(72833,209,'Shekhpur   Gadwa','203407',1,0,'2022-03-03 13:00:13','2022-03-03 13:00:13'),(72834,209,'Shekhpur','203392',1,0,'2022-03-03 13:00:13','2022-03-03 13:00:13'),(72835,209,'Shera','203411',1,0,'2022-03-03 13:00:13','2022-03-03 13:00:13'),(72836,209,'Shikarpur (Bulandshahr)','203395',1,0,'2022-03-03 13:00:13','2022-03-03 13:00:13'),(72837,209,'Shikhera','203002',1,0,'2022-03-03 13:00:13','2022-03-03 13:00:13'),(72838,209,'Shikoi','203398',1,0,'2022-03-03 13:00:13','2022-03-03 13:00:13'),(72839,209,'Shiwaly','203150',1,0,'2022-03-03 13:00:13','2022-03-03 13:00:13'),(72840,209,'Sihi','203411',1,0,'2022-03-03 13:00:13','2022-03-03 13:00:13'),(72841,209,'Sikandrabad (Bulandshahr)','203205',1,0,'2022-03-03 13:00:13','2022-03-03 13:00:13'),(72842,209,'Sirora  Banger','203390',1,0,'2022-03-03 13:00:13','2022-03-03 13:00:13'),(72843,209,'Siyana','203412',1,0,'2022-03-03 13:00:13','2022-03-03 13:00:13'),(72844,209,'Soi','203396',1,0,'2022-03-03 13:00:13','2022-03-03 13:00:13'),(72845,209,'Sonda  Habibpur','203132',1,0,'2022-03-03 13:00:13','2022-03-03 13:00:13'),(72846,209,'Sonjhana  Jhaya','203405',1,0,'2022-03-03 13:00:14','2022-03-03 13:00:14'),(72847,209,'Subhash  Road  Khurja','203131',1,0,'2022-03-03 13:00:14','2022-03-03 13:00:14'),(72848,209,'Surajpur  Makhena','203390',1,0,'2022-03-03 13:00:14','2022-03-03 13:00:14'),(72849,209,'Surjawaly','203001',1,0,'2022-03-03 13:00:14','2022-03-03 13:00:14'),(72850,209,'Surjawaly','203131',1,0,'2022-03-03 13:00:14','2022-03-03 13:00:14'),(72851,209,'Tajpur','203411',1,0,'2022-03-03 13:00:14','2022-03-03 13:00:14'),(72852,209,'Talwar','203393',1,0,'2022-03-03 13:00:14','2022-03-03 13:00:14'),(72853,209,'Tauli','203394',1,0,'2022-03-03 13:00:14','2022-03-03 13:00:14'),(72854,209,'Thana  Gajraula','203398',1,0,'2022-03-03 13:00:14','2022-03-03 13:00:14'),(72855,209,'Til Begum  Pur','203206',1,0,'2022-03-03 13:00:14','2022-03-03 13:00:14'),(72856,209,'Titota Veer','203394',1,0,'2022-03-03 13:00:14','2022-03-03 13:00:14'),(72857,209,'Tyore  Buzurg','203397',1,0,'2022-03-03 13:00:14','2022-03-03 13:00:14'),(72858,209,'Uamrara','203393',1,0,'2022-03-03 13:00:14','2022-03-03 13:00:14'),(72859,209,'Uncha Gaon','203398',1,0,'2022-03-03 13:00:14','2022-03-03 13:00:14'),(72860,209,'Utrawaly','203395',1,0,'2022-03-03 13:00:14','2022-03-03 13:00:14'),(72861,209,'Utrouly','203409',1,0,'2022-03-03 13:00:14','2022-03-03 13:00:14'),(72862,209,'Vijay  Nagliya','203389',1,0,'2022-03-03 13:00:15','2022-03-03 13:00:15'),(72863,209,'Visundhara','203401',1,0,'2022-03-03 13:00:15','2022-03-03 13:00:15'),(72864,209,'Waira  Firozpur','203412',1,0,'2022-03-03 13:00:15','2022-03-03 13:00:15'),(72865,210,'Alampur','232101',1,0,'2022-03-03 13:00:15','2022-03-03 13:00:15'),(72866,210,'Alinagar','232101',1,0,'2022-03-03 13:00:15','2022-03-03 13:00:15'),(72867,210,'Amaon','232118',1,0,'2022-03-03 13:00:15','2022-03-03 13:00:15'),(72868,210,'Amara','232110',1,0,'2022-03-03 13:00:15','2022-03-03 13:00:15'),(72869,210,'Amara','232105',1,0,'2022-03-03 13:00:15','2022-03-03 13:00:15'),(72870,210,'Amilai','232109',1,0,'2022-03-03 13:00:15','2022-03-03 13:00:15'),(72871,210,'Arangi','232110',1,0,'2022-03-03 13:00:15','2022-03-03 13:00:15'),(72872,210,'Asana','232110',1,0,'2022-03-03 13:00:15','2022-03-03 13:00:15'),(72873,210,'Awajapur','232108',1,0,'2022-03-03 13:00:15','2022-03-03 13:00:15'),(72874,210,'Awati','232106',1,0,'2022-03-03 13:00:15','2022-03-03 13:00:15'),(72875,210,'Babhniyaon Raipur','232105',1,0,'2022-03-03 13:00:15','2022-03-03 13:00:15'),(72876,210,'Baburi','232102',1,0,'2022-03-03 13:00:15','2022-03-03 13:00:15'),(72877,210,'Bagahikumbhapur','232110',1,0,'2022-03-03 13:00:15','2022-03-03 13:00:15'),(72878,210,'Baghari','232106',1,0,'2022-03-03 13:00:16','2022-03-03 13:00:16'),(72879,210,'Barahan','232106',1,0,'2022-03-03 13:00:16','2022-03-03 13:00:16'),(72880,210,'Barahani','232110',1,0,'2022-03-03 13:00:16','2022-03-03 13:00:16'),(72881,210,'Barthara Kalan','232104',1,0,'2022-03-03 13:00:16','2022-03-03 13:00:16'),(72882,210,'Basila','232104',1,0,'2022-03-03 13:00:16','2022-03-03 13:00:16'),(72883,210,'Bathawar','232109',1,0,'2022-03-03 13:00:16','2022-03-03 13:00:16'),(72884,210,'Bhadauliya','232102',1,0,'2022-03-03 13:00:16','2022-03-03 13:00:16'),(72885,210,'Bhaisahi','232103',1,0,'2022-03-03 13:00:16','2022-03-03 13:00:16'),(72886,210,'Bharchha','232101',1,0,'2022-03-03 13:00:16','2022-03-03 13:00:16'),(72887,210,'Bhatiza','232110',1,0,'2022-03-03 13:00:16','2022-03-03 13:00:16'),(72888,210,'Bhatraul','232103',1,0,'2022-03-03 13:00:16','2022-03-03 13:00:16'),(72889,210,'Bhikhampur','232103',1,0,'2022-03-03 13:00:16','2022-03-03 13:00:16'),(72890,210,'Bhojapur','232108',1,0,'2022-03-03 13:00:16','2022-03-03 13:00:16'),(72891,210,'Bhorsar','232118',1,0,'2022-03-03 13:00:16','2022-03-03 13:00:16'),(72892,210,'Bhujana','232110',1,0,'2022-03-03 13:00:16','2022-03-03 13:00:16'),(72893,210,'Chakarghatta','232111',1,0,'2022-03-03 13:00:16','2022-03-03 13:00:16'),(72894,210,'Chakia','232103',1,0,'2022-03-03 13:00:16','2022-03-03 13:00:16'),(72895,210,'Chandauli','232104',1,0,'2022-03-03 13:00:16','2022-03-03 13:00:16'),(72896,210,'Chilabali','232106',1,0,'2022-03-03 13:00:17','2022-03-03 13:00:17'),(72897,210,'Dabaria','232105',1,0,'2022-03-03 13:00:17','2022-03-03 13:00:17'),(72898,210,'Dandi','232101',1,0,'2022-03-03 13:00:17','2022-03-03 13:00:17'),(72899,210,'Darahara','232108',1,0,'2022-03-03 13:00:17','2022-03-03 13:00:17'),(72900,210,'Derhgaonwa','232106',1,0,'2022-03-03 13:00:17','2022-03-03 13:00:17'),(72901,210,'Derwakalan','232101',1,0,'2022-03-03 13:00:17','2022-03-03 13:00:17'),(72902,210,'Dhanapur','232105',1,0,'2022-03-03 13:00:17','2022-03-03 13:00:17'),(72903,210,'Dhaneja','232102',1,0,'2022-03-03 13:00:17','2022-03-03 13:00:17'),(72904,210,'Dharaon','232105',1,0,'2022-03-03 13:00:17','2022-03-03 13:00:17'),(72905,210,'Dharauli','232104',1,0,'2022-03-03 13:00:17','2022-03-03 13:00:17'),(72906,210,'Dharde','232102',1,0,'2022-03-03 13:00:17','2022-03-03 13:00:17'),(72907,210,'Dighghi','232106',1,0,'2022-03-03 13:00:17','2022-03-03 13:00:17'),(72908,210,'Dighwat','232108',1,0,'2022-03-03 13:00:17','2022-03-03 13:00:17'),(72909,210,'Farsandpurmohanpur','232120',1,0,'2022-03-03 13:00:17','2022-03-03 13:00:17'),(72910,210,'Fesuda','232110',1,0,'2022-03-03 13:00:17','2022-03-03 13:00:17'),(72911,210,'Gaighat','232103',1,0,'2022-03-03 13:00:17','2022-03-03 13:00:17'),(72912,210,'Gauri','232102',1,0,'2022-03-03 13:00:17','2022-03-03 13:00:17'),(72913,210,'Gurera','232109',1,0,'2022-03-03 13:00:17','2022-03-03 13:00:17'),(72914,210,'Hetampur','232106',1,0,'2022-03-03 13:00:17','2022-03-03 13:00:17'),(72915,210,'Hingutarjagdishpur','232105',1,0,'2022-03-03 13:00:18','2022-03-03 13:00:18'),(72916,210,'Illia','232118',1,0,'2022-03-03 13:00:18','2022-03-03 13:00:18'),(72917,210,'Imilia','232110',1,0,'2022-03-03 13:00:18','2022-03-03 13:00:18'),(72918,210,'Jagdish Sarai','232104',1,0,'2022-03-03 13:00:18','2022-03-03 13:00:18'),(72919,210,'Jalalpur','232106',1,0,'2022-03-03 13:00:18','2022-03-03 13:00:18'),(72920,210,'Jamunipur','232104',1,0,'2022-03-03 13:00:18','2022-03-03 13:00:18'),(72921,210,'Janso Ki Marai','232120',1,0,'2022-03-03 13:00:18','2022-03-03 13:00:18'),(72922,210,'Jarkhor','232102',1,0,'2022-03-03 13:00:18','2022-03-03 13:00:18'),(72923,210,'Jurahardhan','221115',1,0,'2022-03-03 13:00:18','2022-03-03 13:00:18'),(72924,210,'Kadirabad','232106',1,0,'2022-03-03 13:00:18','2022-03-03 13:00:18'),(72925,210,'Kamalpur (Chandauli)','232106',1,0,'2022-03-03 13:00:18','2022-03-03 13:00:18'),(72926,210,'Kamharia','232106',1,0,'2022-03-03 13:00:18','2022-03-03 13:00:18'),(72927,210,'Kamharia','232108',1,0,'2022-03-03 13:00:18','2022-03-03 13:00:18'),(72928,210,'Kanta','232104',1,0,'2022-03-03 13:00:18','2022-03-03 13:00:18'),(72929,210,'Karnaul','232118',1,0,'2022-03-03 13:00:18','2022-03-03 13:00:18'),(72930,210,'Kawaipaharpur','232106',1,0,'2022-03-03 13:00:18','2022-03-03 13:00:18'),(72931,210,'Kawanr','232109',1,0,'2022-03-03 13:00:18','2022-03-03 13:00:18'),(72932,210,'Keraigaon','232118',1,0,'2022-03-03 13:00:18','2022-03-03 13:00:18'),(72933,210,'Keshavpur','232120',1,0,'2022-03-03 13:00:18','2022-03-03 13:00:18'),(72934,210,'Khagwal','232104',1,0,'2022-03-03 13:00:18','2022-03-03 13:00:18'),(72935,210,'Khakhara','232118',1,0,'2022-03-03 13:00:18','2022-03-03 13:00:18'),(72936,210,'Kharan','232106',1,0,'2022-03-03 13:00:19','2022-03-03 13:00:19'),(72937,210,'Kharaujha','232103',1,0,'2022-03-03 13:00:19','2022-03-03 13:00:19'),(72938,210,'Khilchi','232118',1,0,'2022-03-03 13:00:19','2022-03-03 13:00:19'),(72939,210,'Khurja','232104',1,0,'2022-03-03 13:00:19','2022-03-03 13:00:19'),(72940,210,'Kori','232120',1,0,'2022-03-03 13:00:19','2022-03-03 13:00:19'),(72941,210,'Kurahana','232101',1,0,'2022-03-03 13:00:19','2022-03-03 13:00:19'),(72942,210,'Launda','232104',1,0,'2022-03-03 13:00:19','2022-03-03 13:00:19'),(72943,210,'Laxmangarh','232107',1,0,'2022-03-03 13:00:19','2022-03-03 13:00:19'),(72944,210,'Maharkha','232120',1,0,'2022-03-03 13:00:19','2022-03-03 13:00:19'),(72945,210,'Mahesua Nai Bazar','232108',1,0,'2022-03-03 13:00:19','2022-03-03 13:00:19'),(72946,210,'Mahuwarikhas','232109',1,0,'2022-03-03 13:00:19','2022-03-03 13:00:19'),(72947,210,'Majhghain','232111',1,0,'2022-03-03 13:00:19','2022-03-03 13:00:19'),(72948,210,'Majhwarkhas','232104',1,0,'2022-03-03 13:00:19','2022-03-03 13:00:19'),(72949,210,'Maniyarpur','232108',1,0,'2022-03-03 13:00:19','2022-03-03 13:00:19'),(72950,210,'Marhi','232104',1,0,'2022-03-03 13:00:19','2022-03-03 13:00:19'),(72951,210,'Marufpur','221115',1,0,'2022-03-03 13:00:19','2022-03-03 13:00:19'),(72952,210,'Mathela','232109',1,0,'2022-03-03 13:00:19','2022-03-03 13:00:19'),(72953,210,'Mavaiya','232102',1,0,'2022-03-03 13:00:19','2022-03-03 13:00:19'),(72954,210,'Meerasarai','232106',1,0,'2022-03-03 13:00:19','2022-03-03 13:00:19'),(72955,210,'Merahan','232106',1,0,'2022-03-03 13:00:19','2022-03-03 13:00:19'),(72956,210,'Mugalsarai','232101',1,0,'2022-03-03 13:00:19','2022-03-03 13:00:19'),(72957,210,'Musakhan','232103',1,0,'2022-03-03 13:00:19','2022-03-03 13:00:19'),(72958,210,'Nadi Nidhaura','232107',1,0,'2022-03-03 13:00:19','2022-03-03 13:00:19'),(72959,210,'Naikot','232109',1,0,'2022-03-03 13:00:19','2022-03-03 13:00:19'),(72960,210,'Nairhi','232107',1,0,'2022-03-03 13:00:20','2022-03-03 13:00:20'),(72961,210,'Naraina','232108',1,0,'2022-03-03 13:00:20','2022-03-03 13:00:20'),(72962,210,'Naubatpur','232110',1,0,'2022-03-03 13:00:20','2022-03-03 13:00:20'),(72963,210,'Naugarh (Chandauli)','232111',1,0,'2022-03-03 13:00:20','2022-03-03 13:00:20'),(72964,210,'Niyamatabad','232101',1,0,'2022-03-03 13:00:20','2022-03-03 13:00:20'),(72965,210,'Noori','232106',1,0,'2022-03-03 13:00:20','2022-03-03 13:00:20'),(72966,210,'Oyarchak','232110',1,0,'2022-03-03 13:00:20','2022-03-03 13:00:20'),(72967,210,'Pachokhar','232101',1,0,'2022-03-03 13:00:20','2022-03-03 13:00:20'),(72968,210,'Pachwania','232103',1,0,'2022-03-03 13:00:20','2022-03-03 13:00:20'),(72969,210,'Papaura','232109',1,0,'2022-03-03 13:00:20','2022-03-03 13:00:20'),(72970,210,'Parasikalan','232104',1,0,'2022-03-03 13:00:20','2022-03-03 13:00:20'),(72971,210,'Patti','221115',1,0,'2022-03-03 13:00:20','2022-03-03 13:00:20'),(72972,210,'Paura','232108',1,0,'2022-03-03 13:00:20','2022-03-03 13:00:20'),(72973,210,'Pipari','232106',1,0,'2022-03-03 13:00:20','2022-03-03 13:00:20'),(72974,210,'Piparia','232103',1,0,'2022-03-03 13:00:20','2022-03-03 13:00:20'),(72975,210,'Prabhupur','232109',1,0,'2022-03-03 13:00:20','2022-03-03 13:00:20'),(72976,210,'Raiytha','232106',1,0,'2022-03-03 13:00:20','2022-03-03 13:00:20'),(72977,210,'Ramgarh (Chandauli)','232107',1,0,'2022-03-03 13:00:21','2022-03-03 13:00:21'),(72978,210,'Rampur','232110',1,0,'2022-03-03 13:00:21','2022-03-03 13:00:21'),(72979,210,'Rampurkala','232103',1,0,'2022-03-03 13:00:21','2022-03-03 13:00:21'),(72980,210,'Ranepur','232108',1,0,'2022-03-03 13:00:21','2022-03-03 13:00:21'),(72981,210,'Rewasa','232110',1,0,'2022-03-03 13:00:21','2022-03-03 13:00:21'),(72982,210,'Rupetha','232120',1,0,'2022-03-03 13:00:21','2022-03-03 13:00:21'),(72983,210,'Sadalpura','232120',1,0,'2022-03-03 13:00:21','2022-03-03 13:00:21'),(72984,210,'Sahabganj (Chandauli)','232118',1,0,'2022-03-03 13:00:21','2022-03-03 13:00:21'),(72985,210,'Sahupuri','221009',1,0,'2022-03-03 13:00:21','2022-03-03 13:00:21'),(72986,210,'Saidupur','232103',1,0,'2022-03-03 13:00:21','2022-03-03 13:00:21'),(72987,210,'Saifpur','232107',1,0,'2022-03-03 13:00:21','2022-03-03 13:00:21'),(72988,210,'Saiyadraja','232110',1,0,'2022-03-03 13:00:21','2022-03-03 13:00:21'),(72989,210,'Sakaldiha Bazar','232109',1,0,'2022-03-03 13:00:21','2022-03-03 13:00:21'),(72990,210,'Sakaldiha','232108',1,0,'2022-03-03 13:00:21','2022-03-03 13:00:21'),(72991,210,'Samudpur','221115',1,0,'2022-03-03 13:00:21','2022-03-03 13:00:21'),(72992,210,'Sanghati','232120',1,0,'2022-03-03 13:00:21','2022-03-03 13:00:21'),(72993,210,'Seruka','232110',1,0,'2022-03-03 13:00:22','2022-03-03 13:00:22'),(72994,210,'Sewari','232109',1,0,'2022-03-03 13:00:22','2022-03-03 13:00:22'),(72995,210,'Shaheedgaon','232105',1,0,'2022-03-03 13:00:22','2022-03-03 13:00:22'),(72996,210,'Shamsherpur','232111',1,0,'2022-03-03 13:00:22','2022-03-03 13:00:22'),(72997,210,'Shivpur','232102',1,0,'2022-03-03 13:00:22','2022-03-03 13:00:22'),(72998,210,'Sikanderpur','232103',1,0,'2022-03-03 13:00:22','2022-03-03 13:00:22'),(72999,210,'Sikarganj','232103',1,0,'2022-03-03 13:00:22','2022-03-03 13:00:22'),(73000,210,'Sikari','232102',1,0,'2022-03-03 13:00:22','2022-03-03 13:00:22'),(73001,210,'Sishaurakalan','232106',1,0,'2022-03-03 13:00:22','2022-03-03 13:00:22'),(73002,210,'Sogai','232110',1,0,'2022-03-03 13:00:22','2022-03-03 13:00:22'),(73003,210,'Tanda Kalan','221115',1,0,'2022-03-03 13:00:22','2022-03-03 13:00:22'),(73004,210,'Tiyara','232118',1,0,'2022-03-03 13:00:22','2022-03-03 13:00:22'),(73005,210,'Tiyari','232103',1,0,'2022-03-03 13:00:22','2022-03-03 13:00:22'),(73006,210,'Torwan','232105',1,0,'2022-03-03 13:00:22','2022-03-03 13:00:22'),(73007,210,'Utraut','232103',1,0,'2022-03-03 13:00:22','2022-03-03 13:00:22'),(73008,210,'Verdisanda','232108',1,0,'2022-03-03 13:00:22','2022-03-03 13:00:22'),(73009,210,'Vishunpura','232104',1,0,'2022-03-03 13:00:23','2022-03-03 13:00:23'),(73010,211,'Agarahunda','210205',1,0,'2022-03-03 13:00:23','2022-03-03 13:00:23'),(73011,211,'Ainchwara','210205',1,0,'2022-03-03 13:00:23','2022-03-03 13:00:23'),(73012,211,'Asoh','210206',1,0,'2022-03-03 13:00:23','2022-03-03 13:00:23'),(73013,211,'Audaha','210206',1,0,'2022-03-03 13:00:23','2022-03-03 13:00:23'),(73014,211,'Bachharan','210206',1,0,'2022-03-03 13:00:23','2022-03-03 13:00:23'),(73015,211,'Baramafi','210206',1,0,'2022-03-03 13:00:23','2022-03-03 13:00:23'),(73016,211,'Bardwara','210207',1,0,'2022-03-03 13:00:23','2022-03-03 13:00:23'),(73017,211,'Bargarh','210208',1,0,'2022-03-03 13:00:23','2022-03-03 13:00:23'),(73018,211,'Barha Kotra','210209',1,0,'2022-03-03 13:00:23','2022-03-03 13:00:23'),(73019,211,'Baria','210209',1,0,'2022-03-03 13:00:23','2022-03-03 13:00:23'),(73020,211,'Barua','210209',1,0,'2022-03-03 13:00:23','2022-03-03 13:00:23'),(73021,211,'Basila','210205',1,0,'2022-03-03 13:00:23','2022-03-03 13:00:23'),(73022,211,'Beohara','210206',1,0,'2022-03-03 13:00:23','2022-03-03 13:00:23'),(73023,211,'Bhadedu','210207',1,0,'2022-03-03 13:00:23','2022-03-03 13:00:23'),(73024,211,'Bhaisaundha','210204',1,0,'2022-03-03 13:00:23','2022-03-03 13:00:23'),(73025,211,'Bhanri','210205',1,0,'2022-03-03 13:00:23','2022-03-03 13:00:23'),(73026,211,'Bharatkoop','210205',1,0,'2022-03-03 13:00:24','2022-03-03 13:00:24'),(73027,211,'Biharwan','210207',1,0,'2022-03-03 13:00:24','2022-03-03 13:00:24'),(73028,211,'Biyawal','210209',1,0,'2022-03-03 13:00:24','2022-03-03 13:00:24'),(73029,211,'Chakla','210205',1,0,'2022-03-03 13:00:24','2022-03-03 13:00:24'),(73030,211,'Chandramara','210205',1,0,'2022-03-03 13:00:24','2022-03-03 13:00:24'),(73031,211,'Chaura','210206',1,0,'2022-03-03 13:00:24','2022-03-03 13:00:24'),(73032,211,'Chhibon','210209',1,0,'2022-03-03 13:00:24','2022-03-03 13:00:24'),(73033,211,'Chillimal','210207',1,0,'2022-03-03 13:00:24','2022-03-03 13:00:24'),(73034,211,'Chitrakot','210204',1,0,'2022-03-03 13:00:24','2022-03-03 13:00:24'),(73035,211,'Darsenda','210206',1,0,'2022-03-03 13:00:24','2022-03-03 13:00:24'),(73036,211,'Ganiwa Parsidhpur','210206',1,0,'2022-03-03 13:00:24','2022-03-03 13:00:24'),(73037,211,'Ghuretanpur','210202',1,0,'2022-03-03 13:00:24','2022-03-03 13:00:24'),(73038,211,'Hardoli','210206',1,0,'2022-03-03 13:00:24','2022-03-03 13:00:24'),(73039,211,'Hariharpur','210202',1,0,'2022-03-03 13:00:24','2022-03-03 13:00:24'),(73040,211,'Hatwa','210209',1,0,'2022-03-03 13:00:24','2022-03-03 13:00:24'),(73041,211,'Itwan','210205',1,0,'2022-03-03 13:00:24','2022-03-03 13:00:24'),(73042,211,'Itwan Dundela','210208',1,0,'2022-03-03 13:00:25','2022-03-03 13:00:25'),(73043,211,'Jankikund','210204',1,0,'2022-03-03 13:00:25','2022-03-03 13:00:25'),(73044,211,'Kalwalia','210207',1,0,'2022-03-03 13:00:25','2022-03-03 13:00:25'),(73045,211,'Kapna Itaura','210206',1,0,'2022-03-03 13:00:25','2022-03-03 13:00:25'),(73046,211,'Karwara Bujurg','210206',1,0,'2022-03-03 13:00:25','2022-03-03 13:00:25'),(73047,211,'Karwi RS','210205',1,0,'2022-03-03 13:00:25','2022-03-03 13:00:25'),(73048,211,'Karwi','210205',1,0,'2022-03-03 13:00:25','2022-03-03 13:00:25'),(73049,211,'Kaubra','210208',1,0,'2022-03-03 13:00:25','2022-03-03 13:00:25'),(73050,211,'Khandeho','210209',1,0,'2022-03-03 13:00:25','2022-03-03 13:00:25'),(73051,211,'Khaptiha','210209',1,0,'2022-03-03 13:00:25','2022-03-03 13:00:25'),(73052,211,'Khatwara','210207',1,0,'2022-03-03 13:00:25','2022-03-03 13:00:25'),(73053,211,'Khohi','210204',1,0,'2022-03-03 13:00:25','2022-03-03 13:00:25'),(73054,211,'Lauri','210209',1,0,'2022-03-03 13:00:25','2022-03-03 13:00:25'),(73055,211,'Lodhwara','210205',1,0,'2022-03-03 13:00:25','2022-03-03 13:00:25'),(73056,211,'Mamsi Buzurg','210207',1,0,'2022-03-03 13:00:25','2022-03-03 13:00:25'),(73057,211,'Mandaur','210209',1,0,'2022-03-03 13:00:25','2022-03-03 13:00:25'),(73058,211,'Manikpur (Chitrakoot)','210208',1,0,'2022-03-03 13:00:26','2022-03-03 13:00:26'),(73059,211,'Markundi','210208',1,0,'2022-03-03 13:00:26','2022-03-03 13:00:26'),(73060,211,'Mauchhibu','210209',1,0,'2022-03-03 13:00:26','2022-03-03 13:00:26'),(73061,211,'Murka','210208',1,0,'2022-03-03 13:00:26','2022-03-03 13:00:26'),(73062,211,'Nai Bazar Karwi','210205',1,0,'2022-03-03 13:00:26','2022-03-03 13:00:26'),(73063,211,'Nibi','210209',1,0,'2022-03-03 13:00:26','2022-03-03 13:00:26'),(73064,211,'Pahari Bujurg Sani','210203',1,0,'2022-03-03 13:00:26','2022-03-03 13:00:26'),(73065,211,'Pahari (Chitrakoot)','210206',1,0,'2022-03-03 13:00:26','2022-03-03 13:00:26'),(73066,211,'Pardawan','210209',1,0,'2022-03-03 13:00:26','2022-03-03 13:00:26'),(73067,211,'Parsaunja','210206',1,0,'2022-03-03 13:00:26','2022-03-03 13:00:26'),(73068,211,'Purab Patai','210209',1,0,'2022-03-03 13:00:26','2022-03-03 13:00:26'),(73069,211,'Purwa Tarauha','210205',1,0,'2022-03-03 13:00:26','2022-03-03 13:00:26'),(73070,211,'Ragauli','210205',1,0,'2022-03-03 13:00:26','2022-03-03 13:00:26'),(73071,211,'Raipura','210205',1,0,'2022-03-03 13:00:26','2022-03-03 13:00:26'),(73072,211,'Rajapur (Chitrakoot)','210207',1,0,'2022-03-03 13:00:26','2022-03-03 13:00:26'),(73073,211,'Ram Nagar','210209',1,0,'2022-03-03 13:00:26','2022-03-03 13:00:26'),(73074,211,'Ramakhurd','210205',1,0,'2022-03-03 13:00:27','2022-03-03 13:00:27'),(73075,211,'Saraiya','210208',1,0,'2022-03-03 13:00:27','2022-03-03 13:00:27'),(73076,211,'Sardhuwa','210207',1,0,'2022-03-03 13:00:27','2022-03-03 13:00:27'),(73077,211,'Semardaha','210205',1,0,'2022-03-03 13:00:27','2022-03-03 13:00:27'),(73078,211,'Semaria Charandasi','210205',1,0,'2022-03-03 13:00:27','2022-03-03 13:00:27'),(73079,211,'Semaria Jagannathpurbasi','210204',1,0,'2022-03-03 13:00:27','2022-03-03 13:00:27'),(73080,211,'Sheorampur','210205',1,0,'2022-03-03 13:00:27','2022-03-03 13:00:27'),(73081,211,'Sidhpur','210205',1,0,'2022-03-03 13:00:27','2022-03-03 13:00:27'),(73082,211,'Sigwan','210208',1,0,'2022-03-03 13:00:27','2022-03-03 13:00:27'),(73083,211,'Sirwawal','210209',1,0,'2022-03-03 13:00:27','2022-03-03 13:00:27'),(73084,211,'Titihara','210202',1,0,'2022-03-03 13:00:27','2022-03-03 13:00:27'),(73085,211,'Unchadih','210208',1,0,'2022-03-03 13:00:27','2022-03-03 13:00:27'),(73086,212,'Ahirauli','274509',1,0,'2022-03-03 13:00:27','2022-03-03 13:00:27'),(73087,212,'Ahirauli Baghel','274702',1,0,'2022-03-03 13:00:27','2022-03-03 13:00:27'),(73088,212,'Ahirauli Bazar','274402',1,0,'2022-03-03 13:00:27','2022-03-03 13:00:27'),(73089,212,'Ajana','274508',1,0,'2022-03-03 13:00:27','2022-03-03 13:00:27'),(73090,212,'Ametahi','274405',1,0,'2022-03-03 13:00:28','2022-03-03 13:00:28'),(73091,212,'Andila','274604',1,0,'2022-03-03 13:00:28','2022-03-03 13:00:28'),(73092,212,'Babhani','274001',1,0,'2022-03-03 13:00:28','2022-03-03 13:00:28'),(73093,212,'Babhnauli Pandey','274502',1,0,'2022-03-03 13:00:28','2022-03-03 13:00:28'),(73094,212,'Badhaya Buzurg','274001',1,0,'2022-03-03 13:00:28','2022-03-03 13:00:28'),(73095,212,'Bagaha','274505',1,0,'2022-03-03 13:00:28','2022-03-03 13:00:28'),(73096,212,'Baghara','274404',1,0,'2022-03-03 13:00:28','2022-03-03 13:00:28'),(73097,212,'Baghauchghat','274404',1,0,'2022-03-03 13:00:28','2022-03-03 13:00:28'),(73098,212,'Bahiari Baghel','274702',1,0,'2022-03-03 13:00:28','2022-03-03 13:00:28'),(73099,212,'Baida','274208',1,0,'2022-03-03 13:00:28','2022-03-03 13:00:28'),(73100,212,'Baidauli','274501',1,0,'2022-03-03 13:00:28','2022-03-03 13:00:28'),(73101,212,'Baikunth Pur','274501',1,0,'2022-03-03 13:00:28','2022-03-03 13:00:28'),(73102,212,'Bairauna','274001',1,0,'2022-03-03 13:00:28','2022-03-03 13:00:28'),(73103,212,'Baitalpur','274201',1,0,'2022-03-03 13:00:28','2022-03-03 13:00:28'),(73104,212,'Bajaratar Mahuawa','274408',1,0,'2022-03-03 13:00:28','2022-03-03 13:00:28'),(73105,212,'Bakhara Khas','274202',1,0,'2022-03-03 13:00:28','2022-03-03 13:00:28'),(73106,212,'Bakuchi','274509',1,0,'2022-03-03 13:00:29','2022-03-03 13:00:29'),(73107,212,'Balepur','274509',1,0,'2022-03-03 13:00:29','2022-03-03 13:00:29'),(73108,212,'Baliawan','274405',1,0,'2022-03-03 13:00:29','2022-03-03 13:00:29'),(73109,212,'Balua Afgan','274705',1,0,'2022-03-03 13:00:29','2022-03-03 13:00:29'),(73110,212,'Balua','274704',1,0,'2022-03-03 13:00:29','2022-03-03 13:00:29'),(73111,212,'Banjaria','274408',1,0,'2022-03-03 13:00:29','2022-03-03 13:00:29'),(73112,212,'Bankata Amethia','274702',1,0,'2022-03-03 13:00:29','2022-03-03 13:00:29'),(73113,212,'Bankata Misir','274506',1,0,'2022-03-03 13:00:29','2022-03-03 13:00:29'),(73114,212,'Bankata','274704',1,0,'2022-03-03 13:00:29','2022-03-03 13:00:29'),(73115,212,'Bankul','274703',1,0,'2022-03-03 13:00:29','2022-03-03 13:00:29'),(73116,212,'Bansopatti','274703',1,0,'2022-03-03 13:00:29','2022-03-03 13:00:29'),(73117,212,'Bara Dixit','274603',1,0,'2022-03-03 13:00:29','2022-03-03 13:00:29'),(73118,212,'Barakagaon','274601',1,0,'2022-03-03 13:00:29','2022-03-03 13:00:29'),(73119,212,'Baraon','274205',1,0,'2022-03-03 13:00:29','2022-03-03 13:00:29'),(73120,212,'Bardgonia','274201',1,0,'2022-03-03 13:00:29','2022-03-03 13:00:29'),(73121,212,'Bardiha Parsuram','274505',1,0,'2022-03-03 13:00:29','2022-03-03 13:00:29'),(73122,212,'Bardihadal','274204',1,0,'2022-03-03 13:00:30','2022-03-03 13:00:30'),(73123,212,'Barhaj','274601',1,0,'2022-03-03 13:00:30','2022-03-03 13:00:30'),(73124,212,'Barhara','274001',1,0,'2022-03-03 13:00:30','2022-03-03 13:00:30'),(73125,212,'Barhara','274501',1,0,'2022-03-03 13:00:30','2022-03-03 13:00:30'),(73126,212,'Bariarpur','274001',1,0,'2022-03-03 13:00:30','2022-03-03 13:00:30'),(73127,212,'Barka Gaon','274702',1,0,'2022-03-03 13:00:30','2022-03-03 13:00:30'),(73128,212,'Barnai','274201',1,0,'2022-03-03 13:00:30','2022-03-03 13:00:30'),(73129,212,'Barpar','274201',1,0,'2022-03-03 13:00:30','2022-03-03 13:00:30'),(73130,212,'Barthi','274509',1,0,'2022-03-03 13:00:30','2022-03-03 13:00:30'),(73131,212,'Batrauli','274001',1,0,'2022-03-03 13:00:30','2022-03-03 13:00:30'),(73132,212,'Batulahi','274201',1,0,'2022-03-03 13:00:30','2022-03-03 13:00:30'),(73133,212,'Baurdih','274502',1,0,'2022-03-03 13:00:30','2022-03-03 13:00:30'),(73134,212,'Baurdih','274204',1,0,'2022-03-03 13:00:30','2022-03-03 13:00:30'),(73135,212,'Baurdih Tiwari','274201',1,0,'2022-03-03 13:00:30','2022-03-03 13:00:30'),(73136,212,'Belawa Dubauli','274208',1,0,'2022-03-03 13:00:30','2022-03-03 13:00:30'),(73137,212,'Belkunda','274202',1,0,'2022-03-03 13:00:30','2022-03-03 13:00:30'),(73138,212,'Belwa','274405',1,0,'2022-03-03 13:00:30','2022-03-03 13:00:30'),(73139,212,'Belwa Baboo','274701',1,0,'2022-03-03 13:00:30','2022-03-03 13:00:30'),(73140,212,'Belwania','274001',1,0,'2022-03-03 13:00:31','2022-03-03 13:00:31'),(73141,212,'Bhagalpur','274602',1,0,'2022-03-03 13:00:31','2022-03-03 13:00:31'),(73142,212,'Bhaidava','274601',1,0,'2022-03-03 13:00:31','2022-03-03 13:00:31'),(73143,212,'Bhaluani','274182',1,0,'2022-03-03 13:00:31','2022-03-03 13:00:31'),(73144,212,'Bharahey Chaura','274701',1,0,'2022-03-03 13:00:31','2022-03-03 13:00:31'),(73145,212,'Bhathwa Tiwari','274702',1,0,'2022-03-03 13:00:31','2022-03-03 13:00:31'),(73146,212,'Bhatni','274701',1,0,'2022-03-03 13:00:31','2022-03-03 13:00:31'),(73147,212,'Bhatpar Rani','274702',1,0,'2022-03-03 13:00:31','2022-03-03 13:00:31'),(73148,212,'Bhawani Chapar','274703',1,0,'2022-03-03 13:00:31','2022-03-03 13:00:31'),(73149,212,'Bhelaur','274208',1,0,'2022-03-03 13:00:31','2022-03-03 13:00:31'),(73150,212,'Bhera Pakar','274506',1,0,'2022-03-03 13:00:31','2022-03-03 13:00:31'),(73151,212,'Bhikhampura','274405',1,0,'2022-03-03 13:00:31','2022-03-03 13:00:31'),(73152,212,'Bhingari Bazar','274702',1,0,'2022-03-03 13:00:31','2022-03-03 13:00:31'),(73153,212,'Bhopatpura','274703',1,0,'2022-03-03 13:00:31','2022-03-03 13:00:31'),(73154,212,'Bhulaipur','274603',1,0,'2022-03-03 13:00:31','2022-03-03 13:00:31'),(73155,212,'Bijapur Jhantaur','274501',1,0,'2022-03-03 13:00:31','2022-03-03 13:00:31'),(73156,212,'Bishunpura Bazar','274404',1,0,'2022-03-03 13:00:31','2022-03-03 13:00:31'),(73157,212,'Bishunpura Dewar','274603',1,0,'2022-03-03 13:00:31','2022-03-03 13:00:31'),(73158,212,'Chakara Gosai','274808',1,0,'2022-03-03 13:00:32','2022-03-03 13:00:32'),(73159,212,'Chakarawa Bahordas','274509',1,0,'2022-03-03 13:00:32','2022-03-03 13:00:32'),(73160,212,'Chakarwa','274205',1,0,'2022-03-03 13:00:32','2022-03-03 13:00:32'),(73161,212,'Chanuki','274506',1,0,'2022-03-03 13:00:32','2022-03-03 13:00:32'),(73162,212,'Chariayan Buzurg','274202',1,0,'2022-03-03 13:00:32','2022-03-03 13:00:32'),(73163,212,'Chero','274509',1,0,'2022-03-03 13:00:32','2022-03-03 13:00:32'),(73164,212,'Chhapauli','274204',1,0,'2022-03-03 13:00:32','2022-03-03 13:00:32'),(73165,212,'Chhitahi Bazar','274201',1,0,'2022-03-03 13:00:32','2022-03-03 13:00:32'),(73166,212,'Chordiha','274509',1,0,'2022-03-03 13:00:32','2022-03-03 13:00:32'),(73167,212,'Churia','274502',1,0,'2022-03-03 13:00:32','2022-03-03 13:00:32'),(73168,212,'D.B. Ashram','274505',1,0,'2022-03-03 13:00:32','2022-03-03 13:00:32'),(73169,212,'Deogaon','274202',1,0,'2022-03-03 13:00:32','2022-03-03 13:00:32'),(73170,212,'Deoria  Urf Shampur','274509',1,0,'2022-03-03 13:00:32','2022-03-03 13:00:32'),(73171,212,'Deoria Budhoo Khan','274405',1,0,'2022-03-03 13:00:32','2022-03-03 13:00:32'),(73172,212,'Deoria H.O','274001',1,0,'2022-03-03 13:00:32','2022-03-03 13:00:32'),(73173,212,'Deoria Kutchary','274001',1,0,'2022-03-03 13:00:33','2022-03-03 13:00:33'),(73174,212,'Deoria Meer','274001',1,0,'2022-03-03 13:00:33','2022-03-03 13:00:33'),(73175,212,'Deoria New Colony','274001',1,0,'2022-03-03 13:00:33','2022-03-03 13:00:33'),(73176,212,'Deoria Railway Station','274806',1,0,'2022-03-03 13:00:33','2022-03-03 13:00:33'),(73177,212,'Deoria Sadar R.S.','274001',1,0,'2022-03-03 13:00:33','2022-03-03 13:00:33'),(73178,212,'Deosia','274602',1,0,'2022-03-03 13:00:33','2022-03-03 13:00:33'),(73179,212,'Dhanauti Khurd','274001',1,0,'2022-03-03 13:00:33','2022-03-03 13:00:33'),(73180,212,'Dharmer','274505',1,0,'2022-03-03 13:00:33','2022-03-03 13:00:33'),(73181,212,'Dhaula Pandit','274604',1,0,'2022-03-03 13:00:33','2022-03-03 13:00:33'),(73182,212,'Dol Chhapra','274509',1,0,'2022-03-03 13:00:33','2022-03-03 13:00:33'),(73183,212,'Dumari','274701',1,0,'2022-03-03 13:00:33','2022-03-03 13:00:33'),(73184,212,'Dumwalia','274509',1,0,'2022-03-03 13:00:33','2022-03-03 13:00:33'),(73185,212,'Ekauna','274208',1,0,'2022-03-03 13:00:33','2022-03-03 13:00:33'),(73186,212,'Ekla Mishraulia','274204',1,0,'2022-03-03 13:00:33','2022-03-03 13:00:33'),(73187,212,'Fatehpur','274204',1,0,'2022-03-03 13:00:33','2022-03-03 13:00:33'),(73188,212,'G.I.Estate','274001',1,0,'2022-03-03 13:00:33','2022-03-03 13:00:33'),(73189,212,'Garauna','274604',1,0,'2022-03-03 13:00:33','2022-03-03 13:00:33'),(73190,212,'Garer','274001',1,0,'2022-03-03 13:00:34','2022-03-03 13:00:34'),(73191,212,'Gaura','274405',1,0,'2022-03-03 13:00:34','2022-03-03 13:00:34'),(73192,212,'Gaura Jai Nagar','274603',1,0,'2022-03-03 13:00:34','2022-03-03 13:00:34'),(73193,212,'Gauri Bazar','274202',1,0,'2022-03-03 13:00:34','2022-03-03 13:00:34'),(73194,212,'Ghanti','274705',1,0,'2022-03-03 13:00:34','2022-03-03 13:00:34'),(73195,212,'Gotha Rasoolpur','274201',1,0,'2022-03-03 13:00:34','2022-03-03 13:00:34'),(73196,212,'Govindpur','274405',1,0,'2022-03-03 13:00:34','2022-03-03 13:00:34'),(73197,212,'Hanuman Mandir','274001',1,0,'2022-03-03 13:00:34','2022-03-03 13:00:34'),(73198,212,'Hata','274703',1,0,'2022-03-03 13:00:34','2022-03-03 13:00:34'),(73199,212,'Hata Banuadih','274001',1,0,'2022-03-03 13:00:34','2022-03-03 13:00:34'),(73200,212,'Indupur','274202',1,0,'2022-03-03 13:00:34','2022-03-03 13:00:34'),(73201,212,'Inguri Bazar','274704',1,0,'2022-03-03 13:00:34','2022-03-03 13:00:34'),(73202,212,'Israuli','274602',1,0,'2022-03-03 13:00:34','2022-03-03 13:00:34'),(73203,212,'Itahua Chandauli','274509',1,0,'2022-03-03 13:00:34','2022-03-03 13:00:34'),(73204,212,'Jaitpura','274501',1,0,'2022-03-03 13:00:34','2022-03-03 13:00:34'),(73205,212,'Jamira','274205',1,0,'2022-03-03 13:00:34','2022-03-03 13:00:34'),(73206,212,'Jogam','274202',1,0,'2022-03-03 13:00:34','2022-03-03 13:00:34'),(73207,212,'Jogia Buzurg','274204',1,0,'2022-03-03 13:00:35','2022-03-03 13:00:35'),(73208,212,'Jokaha Khas','274204',1,0,'2022-03-03 13:00:35','2022-03-03 13:00:35'),(73209,212,'Kalaban','274202',1,0,'2022-03-03 13:00:35','2022-03-03 13:00:35'),(73210,212,'Kanchanpur','274408',1,0,'2022-03-03 13:00:35','2022-03-03 13:00:35'),(73211,212,'Kanhauli','274204',1,0,'2022-03-03 13:00:35','2022-03-03 13:00:35'),(73212,212,'Kaparwar','274603',1,0,'2022-03-03 13:00:35','2022-03-03 13:00:35'),(73213,212,'Karail Shukla','274603',1,0,'2022-03-03 13:00:35','2022-03-03 13:00:35'),(73214,212,'Karaundi','274501',1,0,'2022-03-03 13:00:35','2022-03-03 13:00:35'),(73215,212,'Karauta','274204',1,0,'2022-03-03 13:00:35','2022-03-03 13:00:35'),(73216,212,'Karjahan','274603',1,0,'2022-03-03 13:00:35','2022-03-03 13:00:35'),(73217,212,'Karjahan','274201',1,0,'2022-03-03 13:00:35','2022-03-03 13:00:35'),(73218,212,'Karmajeetpur','274202',1,0,'2022-03-03 13:00:35','2022-03-03 13:00:35'),(73219,212,'Karmtar Sher Khan','274182',1,0,'2022-03-03 13:00:35','2022-03-03 13:00:35'),(73220,212,'Kasili','274604',1,0,'2022-03-03 13:00:35','2022-03-03 13:00:35'),(73221,212,'Kataura','274202',1,0,'2022-03-03 13:00:35','2022-03-03 13:00:35'),(73222,212,'Katrari','274001',1,0,'2022-03-03 13:00:35','2022-03-03 13:00:35'),(73223,212,'Kauntey Nagar','274201',1,0,'2022-03-03 13:00:35','2022-03-03 13:00:35'),(73224,212,'Khaira Banua','274202',1,0,'2022-03-03 13:00:35','2022-03-03 13:00:35'),(73225,212,'Khairatia','274202',1,0,'2022-03-03 13:00:35','2022-03-03 13:00:35'),(73226,212,'Khampar','274702',1,0,'2022-03-03 13:00:35','2022-03-03 13:00:35'),(73227,212,'Khareshar','274205',1,0,'2022-03-03 13:00:35','2022-03-03 13:00:35'),(73228,212,'Kharwania','274508',1,0,'2022-03-03 13:00:36','2022-03-03 13:00:36'),(73229,212,'Khema Dei','274508',1,0,'2022-03-03 13:00:36','2022-03-03 13:00:36'),(73230,212,'Khori','274603',1,0,'2022-03-03 13:00:36','2022-03-03 13:00:36'),(73231,212,'Khukhundoo','274501',1,0,'2022-03-03 13:00:36','2022-03-03 13:00:36'),(73232,212,'Khurwasia','274703',1,0,'2022-03-03 13:00:36','2022-03-03 13:00:36'),(73233,212,'Kodara','274506',1,0,'2022-03-03 13:00:36','2022-03-03 13:00:36'),(73234,212,'Koilgarha','274204',1,0,'2022-03-03 13:00:36','2022-03-03 13:00:36'),(73235,212,'Korawa','274204',1,0,'2022-03-03 13:00:36','2022-03-03 13:00:36'),(73236,212,'Koraya','274182',1,0,'2022-03-03 13:00:36','2022-03-03 13:00:36'),(73237,212,'Kothilwa','274702',1,0,'2022-03-03 13:00:36','2022-03-03 13:00:36'),(73238,212,'Kotpur Pipra','274603',1,0,'2022-03-03 13:00:36','2022-03-03 13:00:36'),(73239,212,'Kotwa Misir','274404',1,0,'2022-03-03 13:00:36','2022-03-03 13:00:36'),(73240,212,'Kukur Ghanti','274702',1,0,'2022-03-03 13:00:36','2022-03-03 13:00:36'),(73241,212,'Kushahari','274001',1,0,'2022-03-03 13:00:36','2022-03-03 13:00:36'),(73242,212,'Labkani','274202',1,0,'2022-03-03 13:00:36','2022-03-03 13:00:36'),(73243,212,'Lahilpar','274001',1,0,'2022-03-03 13:00:36','2022-03-03 13:00:36'),(73244,212,'Langra Bazar','274182',1,0,'2022-03-03 13:00:36','2022-03-03 13:00:36'),(73245,212,'Lar Road','274505',1,0,'2022-03-03 13:00:36','2022-03-03 13:00:36'),(73246,212,'Lar','274502',1,0,'2022-03-03 13:00:36','2022-03-03 13:00:36'),(73247,212,'Laxmipur','274204',1,0,'2022-03-03 13:00:36','2022-03-03 13:00:36'),(73248,212,'Lerha','274202',1,0,'2022-03-03 13:00:36','2022-03-03 13:00:36'),(73249,212,'Madanpur (Deoria)','274205',1,0,'2022-03-03 13:00:36','2022-03-03 13:00:36'),(73250,212,'Madhawapur','274509',1,0,'2022-03-03 13:00:36','2022-03-03 13:00:36'),(73251,212,'Madrapali Bharth Rai','274405',1,0,'2022-03-03 13:00:36','2022-03-03 13:00:36'),(73252,212,'Mahen','274603',1,0,'2022-03-03 13:00:37','2022-03-03 13:00:37'),(73253,212,'Mahiganj','274204',1,0,'2022-03-03 13:00:37','2022-03-03 13:00:37'),(73254,212,'Mahuapatan','274408',1,0,'2022-03-03 13:00:37','2022-03-03 13:00:37'),(73255,212,'Mahuja','274506',1,0,'2022-03-03 13:00:37','2022-03-03 13:00:37'),(73256,212,'Majha Narain','274208',1,0,'2022-03-03 13:00:37','2022-03-03 13:00:37'),(73257,212,'Majhauli Raj','274506',1,0,'2022-03-03 13:00:37','2022-03-03 13:00:37'),(73258,212,'Majhgaon','274001',1,0,'2022-03-03 13:00:37','2022-03-03 13:00:37'),(73259,212,'Majhwalia','274501',1,0,'2022-03-03 13:00:37','2022-03-03 13:00:37'),(73260,212,'Malkauli `','274505',1,0,'2022-03-03 13:00:37','2022-03-03 13:00:37'),(73261,212,'Manga Kodar','274204',1,0,'2022-03-03 13:00:37','2022-03-03 13:00:37'),(73262,212,'Marhawa','274182',1,0,'2022-03-03 13:00:37','2022-03-03 13:00:37'),(73263,212,'Maripar','274702',1,0,'2022-03-03 13:00:37','2022-03-03 13:00:37'),(73264,212,'Markara','274601',1,0,'2022-03-03 13:00:37','2022-03-03 13:00:37'),(73265,212,'Mathia Sahu','274202',1,0,'2022-03-03 13:00:37','2022-03-03 13:00:37'),(73266,212,'Mathura Chhapar','274405',1,0,'2022-03-03 13:00:37','2022-03-03 13:00:37'),(73267,212,'Matiara Jagdish','274502',1,0,'2022-03-03 13:00:37','2022-03-03 13:00:37'),(73268,212,'Mauna Garhwa','274604',1,0,'2022-03-03 13:00:37','2022-03-03 13:00:37'),(73269,212,'Mehaharhangpur','274404',1,0,'2022-03-03 13:00:37','2022-03-03 13:00:37'),(73270,212,'Mehraunaghat','274502',1,0,'2022-03-03 13:00:37','2022-03-03 13:00:37'),(73271,212,'Mirjapur','274603',1,0,'2022-03-03 13:00:37','2022-03-03 13:00:37'),(73272,212,'Mushari','274408',1,0,'2022-03-03 13:00:37','2022-03-03 13:00:37'),(73273,212,'Nadauli','274502',1,0,'2022-03-03 13:00:37','2022-03-03 13:00:37'),(73274,212,'Nagawa Khas','274208',1,0,'2022-03-03 13:00:37','2022-03-03 13:00:37'),(73275,212,'Nai Bazar (Deoria)','274001',1,0,'2022-03-03 13:00:37','2022-03-03 13:00:37'),(73276,212,'Naini','274502',1,0,'2022-03-03 13:00:37','2022-03-03 13:00:37'),(73277,212,'Naipur','274205',1,0,'2022-03-03 13:00:37','2022-03-03 13:00:37'),(73278,212,'Nakail','274205',1,0,'2022-03-03 13:00:38','2022-03-03 13:00:38'),(73279,212,'Nandana','274601',1,0,'2022-03-03 13:00:38','2022-03-03 13:00:38'),(73280,212,'Nariaon','274602',1,0,'2022-03-03 13:00:38','2022-03-03 13:00:38'),(73281,212,'Nawapar','274601',1,0,'2022-03-03 13:00:38','2022-03-03 13:00:38'),(73282,212,'Nema','274602',1,0,'2022-03-03 13:00:38','2022-03-03 13:00:38'),(73283,212,'Nonapar','274701',1,0,'2022-03-03 13:00:38','2022-03-03 13:00:38'),(73284,212,'Noonkhar','274501',1,0,'2022-03-03 13:00:38','2022-03-03 13:00:38'),(73285,212,'Pach Lari','274208',1,0,'2022-03-03 13:00:38','2022-03-03 13:00:38'),(73286,212,'Pachrukha','274208',1,0,'2022-03-03 13:00:38','2022-03-03 13:00:38'),(73287,212,'Padari Bazar','274701',1,0,'2022-03-03 13:00:38','2022-03-03 13:00:38'),(73288,212,'Paikauli Maharaj','274001',1,0,'2022-03-03 13:00:38','2022-03-03 13:00:38'),(73289,212,'Paina','274604',1,0,'2022-03-03 13:00:38','2022-03-03 13:00:38'),(73290,212,'Pakaha','274404',1,0,'2022-03-03 13:00:38','2022-03-03 13:00:38'),(73291,212,'Pakri Baboo','274702',1,0,'2022-03-03 13:00:38','2022-03-03 13:00:38'),(73292,212,'Pandaypur','274404',1,0,'2022-03-03 13:00:38','2022-03-03 13:00:38'),(73293,212,'Panika Bazar','274505',1,0,'2022-03-03 13:00:38','2022-03-03 13:00:38'),(73294,212,'Paratappur','274703',1,0,'2022-03-03 13:00:38','2022-03-03 13:00:38'),(73295,212,'Parsia Chhitani Singh','274704',1,0,'2022-03-03 13:00:38','2022-03-03 13:00:38'),(73296,212,'Parsia Dewar','274601',1,0,'2022-03-03 13:00:38','2022-03-03 13:00:38'),(73297,212,'Parsia Jaddu','274001',1,0,'2022-03-03 13:00:38','2022-03-03 13:00:38'),(73298,212,'Parsia Mishir','274501',1,0,'2022-03-03 13:00:38','2022-03-03 13:00:38'),(73299,212,'Patherdewa','274404',1,0,'2022-03-03 13:00:38','2022-03-03 13:00:38'),(73300,212,'Patherhat','274202',1,0,'2022-03-03 13:00:38','2022-03-03 13:00:38'),(73301,212,'Payasi','274506',1,0,'2022-03-03 13:00:38','2022-03-03 13:00:38'),(73302,212,'Peokol','274701',1,0,'2022-03-03 13:00:38','2022-03-03 13:00:38'),(73303,212,'Phulwaria Lachhi','274001',1,0,'2022-03-03 13:00:38','2022-03-03 13:00:38'),(73304,212,'Pindi','274508',1,0,'2022-03-03 13:00:39','2022-03-03 13:00:39'),(73305,212,'Pipara Bithal','274705',1,0,'2022-03-03 13:00:39','2022-03-03 13:00:39'),(73306,212,'Pipara Chandrabhan','274001',1,0,'2022-03-03 13:00:39','2022-03-03 13:00:39'),(73307,212,'Pipara Dixit','274701',1,0,'2022-03-03 13:00:39','2022-03-03 13:00:39'),(73308,212,'Pipara Kachhar','274204',1,0,'2022-03-03 13:00:39','2022-03-03 13:00:39'),(73309,212,'Pipara Mishir','274505',1,0,'2022-03-03 13:00:39','2022-03-03 13:00:39'),(73310,212,'Pipara Ramdhar','274509',1,0,'2022-03-03 13:00:39','2022-03-03 13:00:39'),(73311,212,'Pipara Shukul','274501',1,0,'2022-03-03 13:00:39','2022-03-03 13:00:39'),(73312,212,'Piperpanti','274001',1,0,'2022-03-03 13:00:39','2022-03-03 13:00:39'),(73313,212,'Pipra Madan Gopal','274405',1,0,'2022-03-03 13:00:39','2022-03-03 13:00:39'),(73314,212,'Pipra Uttar Patti','274702',1,0,'2022-03-03 13:00:39','2022-03-03 13:00:39'),(73315,212,'Piprajham','274408',1,0,'2022-03-03 13:00:39','2022-03-03 13:00:39'),(73316,212,'Puraini','274701',1,0,'2022-03-03 13:00:39','2022-03-03 13:00:39'),(73317,212,'Rahimpur','274703',1,0,'2022-03-03 13:00:39','2022-03-03 13:00:39'),(73318,212,'Raibari','274705',1,0,'2022-03-03 13:00:39','2022-03-03 13:00:39'),(73319,212,'Ram Gulam Tola','274001',1,0,'2022-03-03 13:00:39','2022-03-03 13:00:39'),(73320,212,'Rampur Awasthi','274001',1,0,'2022-03-03 13:00:39','2022-03-03 13:00:39'),(73321,212,'Rampur Buzurg','274509',1,0,'2022-03-03 13:00:39','2022-03-03 13:00:39'),(73322,212,'Rampur Khori Bari','274701',1,0,'2022-03-03 13:00:39','2022-03-03 13:00:39'),(73323,212,'Rampur Mahuabari','274404',1,0,'2022-03-03 13:00:39','2022-03-03 13:00:39'),(73324,212,'Rampur (Deoria)','274405',1,0,'2022-03-03 13:00:40','2022-03-03 13:00:40'),(73325,212,'Rampurgarh','274408',1,0,'2022-03-03 13:00:40','2022-03-03 13:00:40'),(73326,212,'Ranihawa','274201',1,0,'2022-03-03 13:00:40','2022-03-03 13:00:40'),(73327,212,'Ratsia','274703',1,0,'2022-03-03 13:00:40','2022-03-03 13:00:40'),(73328,212,'Rawatpar Amethia','274502',1,0,'2022-03-03 13:00:40','2022-03-03 13:00:40'),(73329,212,'Reoli','274602',1,0,'2022-03-03 13:00:40','2022-03-03 13:00:40'),(73330,212,'Ropan Chhapara','274502',1,0,'2022-03-03 13:00:40','2022-03-03 13:00:40'),(73331,212,'Rudrapur (Deoria)','274204',1,0,'2022-03-03 13:00:40','2022-03-03 13:00:40'),(73332,212,'S.V.Marg','274001',1,0,'2022-03-03 13:00:40','2022-03-03 13:00:40'),(73333,212,'Sadhopur','274202',1,0,'2022-03-03 13:00:40','2022-03-03 13:00:40'),(73334,212,'Sajaon','274508',1,0,'2022-03-03 13:00:40','2022-03-03 13:00:40'),(73335,212,'Sakutai','274404',1,0,'2022-03-03 13:00:40','2022-03-03 13:00:40'),(73336,212,'Salaempur','274509',1,0,'2022-03-03 13:00:40','2022-03-03 13:00:40'),(73337,212,'Sallahpur','274501',1,0,'2022-03-03 13:00:40','2022-03-03 13:00:40'),(73338,212,'Samogar','274205',1,0,'2022-03-03 13:00:40','2022-03-03 13:00:40'),(73339,212,'Sant Vinoba Marg','274807',1,0,'2022-03-03 13:00:40','2022-03-03 13:00:40'),(73340,212,'Saraon','274208',1,0,'2022-03-03 13:00:40','2022-03-03 13:00:40'),(73341,212,'Sarya','274702',1,0,'2022-03-03 13:00:40','2022-03-03 13:00:40'),(73342,212,'Satraon','274604',1,0,'2022-03-03 13:00:40','2022-03-03 13:00:40'),(73343,212,'Sawarenji','274702',1,0,'2022-03-03 13:00:40','2022-03-03 13:00:40'),(73344,212,'Shahjahanpur','274408',1,0,'2022-03-03 13:00:40','2022-03-03 13:00:40'),(73345,212,'Shahpur Shukla','274404',1,0,'2022-03-03 13:00:40','2022-03-03 13:00:40'),(73346,212,'Shitalmajha','274204',1,0,'2022-03-03 13:00:40','2022-03-03 13:00:40'),(73347,212,'Sidhua','274405',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73348,212,'Sirjam Khas','274202',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73349,212,'Sirsia Gotha','274408',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73350,212,'Sirsia Khohia','274408',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73351,212,'Sisawa','274701',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73352,212,'Siswa Panday','274001',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73353,212,'Sohanpur','274704',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73354,212,'Sohasa','274202',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73355,212,'Sohnag','274509',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73356,212,'Sohnaria','274408',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73357,212,'Sonari','274601',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73358,212,'Sonughat','274001',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73359,212,'Srinagar','274509',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73360,212,'Sutawar','274502',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73361,212,'Takia','274602',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73362,212,'Tara Sara','274204',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73363,212,'Tarkulwa','274408',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73364,212,'Tekua','274182',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73365,212,'Telia Kalan','274604',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73366,212,'Thakur Deoria','274182',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73367,212,'Thengval Dubey','274509',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73368,212,'Tikampar','274702',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73369,212,'Tikar','274604',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73370,212,'Tiwai','274204',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73371,212,'Tulsi Bara','274509',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73372,212,'Udhopur','274201',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73373,213,'Abhaipura','207241',1,0,'2022-03-03 13:00:41','2022-03-03 13:00:41'),(73374,213,'Achalpur','207125',1,0,'2022-03-03 13:00:42','2022-03-03 13:00:42'),(73375,213,'Ahamdabad','207001',1,0,'2022-03-03 13:00:42','2022-03-03 13:00:42'),(73376,213,'Ahemadpur Nagla Dhanu','207001',1,0,'2022-03-03 13:00:42','2022-03-03 13:00:42'),(73377,213,'Akbarpurkot','207247',1,0,'2022-03-03 13:00:42','2022-03-03 13:00:42'),(73378,213,'Aliganj (Etah)','207247',1,0,'2022-03-03 13:00:42','2022-03-03 13:00:42'),(73379,213,'Alipur','207250',1,0,'2022-03-03 13:00:42','2022-03-03 13:00:42'),(73380,213,'Alliyapur','207244',1,0,'2022-03-03 13:00:42','2022-03-03 13:00:42'),(73381,213,'Amanpur','207241',1,0,'2022-03-03 13:00:42','2022-03-03 13:00:42'),(73382,213,'Ambarpur Rejor','207121',1,0,'2022-03-03 13:00:42','2022-03-03 13:00:42'),(73383,213,'Amirasa','207245',1,0,'2022-03-03 13:00:42','2022-03-03 13:00:42'),(73384,213,'Amraulirattanpur','207247',1,0,'2022-03-03 13:00:42','2022-03-03 13:00:42'),(73385,213,'Angadpur','207121',1,0,'2022-03-03 13:00:42','2022-03-03 13:00:42'),(73386,213,'Angriya','207247',1,0,'2022-03-03 13:00:42','2022-03-03 13:00:42'),(73387,213,'Arjunpur Nauabad','207241',1,0,'2022-03-03 13:00:42','2022-03-03 13:00:42'),(73388,213,'Aruna Nagar','207002',1,0,'2022-03-03 13:00:42','2022-03-03 13:00:42'),(73389,213,'Ashokpur','207243',1,0,'2022-03-03 13:00:42','2022-03-03 13:00:42'),(73390,213,'Aun','207246',1,0,'2022-03-03 13:00:42','2022-03-03 13:00:42'),(73391,213,'Aurangabad','207243',1,0,'2022-03-03 13:00:42','2022-03-03 13:00:42'),(73392,213,'Awagarh','207301',1,0,'2022-03-03 13:00:42','2022-03-03 13:00:42'),(73393,213,'Babsa','207001',1,0,'2022-03-03 13:00:42','2022-03-03 13:00:42'),(73394,213,'Badhawali','207302',1,0,'2022-03-03 13:00:42','2022-03-03 13:00:42'),(73395,213,'Badria','207001',1,0,'2022-03-03 13:00:42','2022-03-03 13:00:42'),(73396,213,'Bahadurpur','207401',1,0,'2022-03-03 13:00:42','2022-03-03 13:00:42'),(73397,213,'Bahdola','207243',1,0,'2022-03-03 13:00:42','2022-03-03 13:00:42'),(73398,213,'Bahora','207243',1,0,'2022-03-03 13:00:42','2022-03-03 13:00:42'),(73399,213,'Bahrojpur','207242',1,0,'2022-03-03 13:00:43','2022-03-03 13:00:43'),(73400,213,'Ballia','207243',1,0,'2022-03-03 13:00:43','2022-03-03 13:00:43'),(73401,213,'Banthal Kutukpur','207125',1,0,'2022-03-03 13:00:43','2022-03-03 13:00:43'),(73402,213,'Barabhodela','207301',1,0,'2022-03-03 13:00:43','2022-03-03 13:00:43'),(73403,213,'Barahdwari','207123',1,0,'2022-03-03 13:00:43','2022-03-03 13:00:43'),(73404,213,'Barahpur','207249',1,0,'2022-03-03 13:00:43','2022-03-03 13:00:43'),(73405,213,'Barai','207120',1,0,'2022-03-03 13:00:43','2022-03-03 13:00:43'),(73406,213,'Baraikalyanpur','207301',1,0,'2022-03-03 13:00:43','2022-03-03 13:00:43'),(73407,213,'Barauli','207001',1,0,'2022-03-03 13:00:43','2022-03-03 13:00:43'),(73408,213,'Barigawan','207120',1,0,'2022-03-03 13:00:43','2022-03-03 13:00:43'),(73409,213,'Barna','207249',1,0,'2022-03-03 13:00:43','2022-03-03 13:00:43'),(73410,213,'Baroliya','207248',1,0,'2022-03-03 13:00:43','2022-03-03 13:00:43'),(73411,213,'Bastarmau','207242',1,0,'2022-03-03 13:00:43','2022-03-03 13:00:43'),(73412,213,'Basundhara','207301',1,0,'2022-03-03 13:00:43','2022-03-03 13:00:43'),(73413,213,'Baznagar','207402',1,0,'2022-03-03 13:00:43','2022-03-03 13:00:43'),(73414,213,'Begaur','207001',1,0,'2022-03-03 13:00:43','2022-03-03 13:00:43'),(73415,213,'Behta','207123',1,0,'2022-03-03 13:00:43','2022-03-03 13:00:43'),(73416,213,'Beri','207401',1,0,'2022-03-03 13:00:43','2022-03-03 13:00:43'),(73417,213,'Berni','207302',1,0,'2022-03-03 13:00:43','2022-03-03 13:00:43'),(73418,213,'Bhadwas','207120',1,0,'2022-03-03 13:00:43','2022-03-03 13:00:43'),(73419,213,'Bhagipur','207001',1,0,'2022-03-03 13:00:43','2022-03-03 13:00:43'),(73420,213,'Bhagwala','207001',1,0,'2022-03-03 13:00:43','2022-03-03 13:00:43'),(73421,213,'Bhalol','207249',1,0,'2022-03-03 13:00:43','2022-03-03 13:00:43'),(73422,213,'Bhargain','207244',1,0,'2022-03-03 13:00:43','2022-03-03 13:00:43'),(73423,213,'Bhartoli','207121',1,0,'2022-03-03 13:00:44','2022-03-03 13:00:44'),(73424,213,'Bhaupura','207249',1,0,'2022-03-03 13:00:44','2022-03-03 13:00:44'),(73425,213,'Bhensrasi','207246',1,0,'2022-03-03 13:00:44','2022-03-03 13:00:44'),(73426,213,'Bhondela','207302',1,0,'2022-03-03 13:00:44','2022-03-03 13:00:44'),(73427,213,'Bhujpura','207246',1,0,'2022-03-03 13:00:44','2022-03-03 13:00:44'),(73428,213,'Bijauri','207001',1,0,'2022-03-03 13:00:44','2022-03-03 13:00:44'),(73429,213,'Bijora','207244',1,0,'2022-03-03 13:00:44','2022-03-03 13:00:44'),(73430,213,'Bilram','207124',1,0,'2022-03-03 13:00:44','2022-03-03 13:00:44'),(73431,213,'Bilsad','207244',1,0,'2022-03-03 13:00:44','2022-03-03 13:00:44'),(73432,213,'Borakalan','207301',1,0,'2022-03-03 13:00:44','2022-03-03 13:00:44'),(73433,213,'Brahm Sajiwan','207003',1,0,'2022-03-03 13:00:44','2022-03-03 13:00:44'),(73434,213,'Burhenabad','207125',1,0,'2022-03-03 13:00:44','2022-03-03 13:00:44'),(73435,213,'Chaprai Sikandarpur','207121',1,0,'2022-03-03 13:00:44','2022-03-03 13:00:44'),(73436,213,'Chhachena','207001',1,0,'2022-03-03 13:00:44','2022-03-03 13:00:44'),(73437,213,'Chhoti Nidhaoli','207001',1,0,'2022-03-03 13:00:44','2022-03-03 13:00:44'),(73438,213,'Chirgawan','207302',1,0,'2022-03-03 13:00:44','2022-03-03 13:00:44'),(73439,213,'Chirola','207242',1,0,'2022-03-03 13:00:44','2022-03-03 13:00:44'),(73440,213,'Collectorate Compound','207001',1,0,'2022-03-03 13:00:44','2022-03-03 13:00:44'),(73441,213,'Daheliya','207249',1,0,'2022-03-03 13:00:44','2022-03-03 13:00:44'),(73442,213,'Daheliyapooth','207247',1,0,'2022-03-03 13:00:44','2022-03-03 13:00:44'),(73443,213,'Dalshahpur','207122',1,0,'2022-03-03 13:00:44','2022-03-03 13:00:44'),(73444,213,'Datai','207001',1,0,'2022-03-03 13:00:44','2022-03-03 13:00:44'),(73445,213,'Datauli','207248',1,0,'2022-03-03 13:00:44','2022-03-03 13:00:44'),(73446,213,'Datingara','207247',1,0,'2022-03-03 13:00:44','2022-03-03 13:00:44'),(73447,213,'Devri Prahlad Pur','207001',1,0,'2022-03-03 13:00:44','2022-03-03 13:00:44'),(73448,213,'Dharoli','207249',1,0,'2022-03-03 13:00:45','2022-03-03 13:00:45'),(73449,213,'Dhiramai','207125',1,0,'2022-03-03 13:00:45','2022-03-03 13:00:45'),(73450,213,'Dholeswar','207122',1,0,'2022-03-03 13:00:45','2022-03-03 13:00:45'),(73451,213,'Dholna','207001',1,0,'2022-03-03 13:00:45','2022-03-03 13:00:45'),(73452,213,'Dhondhara','207246',1,0,'2022-03-03 13:00:45','2022-03-03 13:00:45'),(73453,213,'Dhumri','207248',1,0,'2022-03-03 13:00:45','2022-03-03 13:00:45'),(73454,213,'Etah H.O','207001',1,0,'2022-03-03 13:00:45','2022-03-03 13:00:45'),(73455,213,'Fagnaul','207248',1,0,'2022-03-03 13:00:45','2022-03-03 13:00:45'),(73456,213,'Faroli','207245',1,0,'2022-03-03 13:00:45','2022-03-03 13:00:45'),(73457,213,'Fatehpur','207246',1,0,'2022-03-03 13:00:45','2022-03-03 13:00:45'),(73458,213,'Gahaitoo','207122',1,0,'2022-03-03 13:00:45','2022-03-03 13:00:45'),(73459,213,'Gahi','207247',1,0,'2022-03-03 13:00:45','2022-03-03 13:00:45'),(73460,213,'Gahrana','207301',1,0,'2022-03-03 13:00:45','2022-03-03 13:00:45'),(73461,213,'Gandhi Market (Etah)','207001',1,0,'2022-03-03 13:00:45','2022-03-03 13:00:45'),(73462,213,'Ganehspur','207302',1,0,'2022-03-03 13:00:45','2022-03-03 13:00:45'),(73463,213,'Ganga Garh','207001',1,0,'2022-03-03 13:00:45','2022-03-03 13:00:45'),(73464,213,'Garhi','207001',1,0,'2022-03-03 13:00:45','2022-03-03 13:00:45'),(73465,213,'Garia Sheelam','207001',1,0,'2022-03-03 13:00:45','2022-03-03 13:00:45'),(73466,213,'Gariya Jagannath','207244',1,0,'2022-03-03 13:00:45','2022-03-03 13:00:45'),(73467,213,'Garka','207242',1,0,'2022-03-03 13:00:45','2022-03-03 13:00:45'),(73468,213,'Gaupura','207402',1,0,'2022-03-03 13:00:45','2022-03-03 13:00:45'),(73469,213,'Ghansinghpur','207246',1,0,'2022-03-03 13:00:45','2022-03-03 13:00:45'),(73470,213,'Girora','207001',1,0,'2022-03-03 13:00:46','2022-03-03 13:00:46'),(73471,213,'Gobra','207125',1,0,'2022-03-03 13:00:46','2022-03-03 13:00:46'),(73472,213,'Gorha','207123',1,0,'2022-03-03 13:00:46','2022-03-03 13:00:46'),(73473,213,'Goyati','207403',1,0,'2022-03-03 13:00:46','2022-03-03 13:00:46'),(73474,213,'Gudaun','207302',1,0,'2022-03-03 13:00:46','2022-03-03 13:00:46'),(73475,213,'Gunjdundwara','207242',1,0,'2022-03-03 13:00:46','2022-03-03 13:00:46'),(73476,213,'Harsena','207124',1,0,'2022-03-03 13:00:46','2022-03-03 13:00:46'),(73477,213,'Hathodaban','207243',1,0,'2022-03-03 13:00:46','2022-03-03 13:00:46'),(73478,213,'Hirondi','207001',1,0,'2022-03-03 13:00:46','2022-03-03 13:00:46'),(73479,213,'Isauli','207302',1,0,'2022-03-03 13:00:46','2022-03-03 13:00:46'),(73480,213,'Ishara Purbi','207121',1,0,'2022-03-03 13:00:46','2022-03-03 13:00:46'),(73481,213,'Jagpura','207243',1,0,'2022-03-03 13:00:46','2022-03-03 13:00:46'),(73482,213,'Jahangirpur','207245',1,0,'2022-03-03 13:00:46','2022-03-03 13:00:46'),(73483,213,'Jainpura','207302',1,0,'2022-03-03 13:00:46','2022-03-03 13:00:46'),(73484,213,'Jaithra','207249',1,0,'2022-03-03 13:00:46','2022-03-03 13:00:46'),(73485,213,'Jakhera','207124',1,0,'2022-03-03 13:00:46','2022-03-03 13:00:46'),(73486,213,'Jalalpur Santhal','207248',1,0,'2022-03-03 13:00:46','2022-03-03 13:00:46'),(73487,213,'Jalesar','207302',1,0,'2022-03-03 13:00:46','2022-03-03 13:00:46'),(73488,213,'Jalukhera','207301',1,0,'2022-03-03 13:00:46','2022-03-03 13:00:46'),(73489,213,'Jamlapur','207001',1,0,'2022-03-03 13:00:46','2022-03-03 13:00:46'),(73490,213,'Jamon','207302',1,0,'2022-03-03 13:00:46','2022-03-03 13:00:46'),(73491,213,'Jarani Kalan','207301',1,0,'2022-03-03 13:00:46','2022-03-03 13:00:46'),(73492,213,'Jasmai','207248',1,0,'2022-03-03 13:00:46','2022-03-03 13:00:46'),(73493,213,'Jasrathpur','207247',1,0,'2022-03-03 13:00:46','2022-03-03 13:00:46'),(73494,213,'Jeskhpur','207001',1,0,'2022-03-03 13:00:46','2022-03-03 13:00:46'),(73495,213,'Jhinwar','207122',1,0,'2022-03-03 13:00:47','2022-03-03 13:00:47'),(73496,213,'Jiroliya','207249',1,0,'2022-03-03 13:00:47','2022-03-03 13:00:47'),(73497,213,'Jirsimi','207001',1,0,'2022-03-03 13:00:47','2022-03-03 13:00:47'),(73498,213,'Jitauli','207120',1,0,'2022-03-03 13:00:47','2022-03-03 13:00:47'),(73499,213,'Jogamai Kalan','207120',1,0,'2022-03-03 13:00:47','2022-03-03 13:00:47'),(73500,213,'Junedpur','207247',1,0,'2022-03-03 13:00:47','2022-03-03 13:00:47'),(73501,213,'Kachhela','207245',1,0,'2022-03-03 13:00:47','2022-03-03 13:00:47'),(73502,213,'Kadarganj','207242',1,0,'2022-03-03 13:00:47','2022-03-03 13:00:47'),(73503,213,'Kadarwadi','207403',1,0,'2022-03-03 13:00:47','2022-03-03 13:00:47'),(73504,213,'Kagrool','207001',1,0,'2022-03-03 13:00:47','2022-03-03 13:00:47'),(73505,213,'Kaila','207247',1,0,'2022-03-03 13:00:47','2022-03-03 13:00:47'),(73506,213,'Kakora','207247',1,0,'2022-03-03 13:00:47','2022-03-03 13:00:47'),(73507,213,'Kakrawali','207001',1,0,'2022-03-03 13:00:47','2022-03-03 13:00:47'),(73508,213,'Kalua Teel Pur','207250',1,0,'2022-03-03 13:00:47','2022-03-03 13:00:47'),(73509,213,'Kamalpur','207246',1,0,'2022-03-03 13:00:47','2022-03-03 13:00:47'),(73510,213,'Kanar Kheraa','207401',1,0,'2022-03-03 13:00:47','2022-03-03 13:00:47'),(73511,213,'Kansuri','207001',1,0,'2022-03-03 13:00:47','2022-03-03 13:00:47'),(73512,213,'Kantore','207001',1,0,'2022-03-03 13:00:47','2022-03-03 13:00:47'),(73513,213,'Karampur','207242',1,0,'2022-03-03 13:00:47','2022-03-03 13:00:47'),(73514,213,'Karsana','207241',1,0,'2022-03-03 13:00:47','2022-03-03 13:00:47'),(73515,213,'Kartala','207001',1,0,'2022-03-03 13:00:47','2022-03-03 13:00:47'),(73516,213,'Kasela','207248',1,0,'2022-03-03 13:00:47','2022-03-03 13:00:47'),(73517,213,'Kasganj RS','207123',1,0,'2022-03-03 13:00:47','2022-03-03 13:00:47'),(73518,213,'Kasganj','207123',1,0,'2022-03-03 13:00:47','2022-03-03 13:00:47'),(73519,213,'Kashon','207001',1,0,'2022-03-03 13:00:47','2022-03-03 13:00:47'),(73520,213,'Kawar','207121',1,0,'2022-03-03 13:00:48','2022-03-03 13:00:48'),(73521,213,'Kayampur Baheria','207123',1,0,'2022-03-03 13:00:48','2022-03-03 13:00:48'),(73522,213,'Khaddua','207001',1,0,'2022-03-03 13:00:48','2022-03-03 13:00:48'),(73523,213,'Khaduya','207243',1,0,'2022-03-03 13:00:48','2022-03-03 13:00:48'),(73524,213,'Khairpur','207403',1,0,'2022-03-03 13:00:48','2022-03-03 13:00:48'),(73525,213,'Kharsulia','207250',1,0,'2022-03-03 13:00:48','2022-03-03 13:00:48'),(73526,213,'Khatout','207301',1,0,'2022-03-03 13:00:48','2022-03-03 13:00:48'),(73527,213,'Khiriya Patti','207246',1,0,'2022-03-03 13:00:48','2022-03-03 13:00:48'),(73528,213,'Khirya Nagar Shah','207249',1,0,'2022-03-03 13:00:48','2022-03-03 13:00:48'),(73529,213,'Khojpur','207245',1,0,'2022-03-03 13:00:48','2022-03-03 13:00:48'),(73530,213,'Kinawa','207001',1,0,'2022-03-03 13:00:48','2022-03-03 13:00:48'),(73531,213,'Kisarauli','207124',1,0,'2022-03-03 13:00:48','2022-03-03 13:00:48'),(73532,213,'Kudhar','207124',1,0,'2022-03-03 13:00:48','2022-03-03 13:00:48'),(73533,213,'Kumraua','207124',1,0,'2022-03-03 13:00:48','2022-03-03 13:00:48'),(73534,213,'Kutukpur Kaseri','207401',1,0,'2022-03-03 13:00:48','2022-03-03 13:00:48'),(73535,213,'Lalgarhi','207001',1,0,'2022-03-03 13:00:48','2022-03-03 13:00:48'),(73536,213,'Lodhamai','207125',1,0,'2022-03-03 13:00:48','2022-03-03 13:00:48'),(73537,213,'Lothra','207121',1,0,'2022-03-03 13:00:48','2022-03-03 13:00:48'),(73538,213,'Loya Badshapur','207001',1,0,'2022-03-03 13:00:48','2022-03-03 13:00:48'),(73539,213,'Luhari Kherra','207244',1,0,'2022-03-03 13:00:48','2022-03-03 13:00:48'),(73540,213,'Magrauli','207122',1,0,'2022-03-03 13:00:48','2022-03-03 13:00:48'),(73541,213,'Magthara','207246',1,0,'2022-03-03 13:00:48','2022-03-03 13:00:48'),(73542,213,'Mahawar','207124',1,0,'2022-03-03 13:00:48','2022-03-03 13:00:48'),(73543,213,'Mahdva','207123',1,0,'2022-03-03 13:00:48','2022-03-03 13:00:48'),(73544,213,'Mahua Khaira','207001',1,0,'2022-03-03 13:00:49','2022-03-03 13:00:49'),(73545,213,'Majhola','207244',1,0,'2022-03-03 13:00:49','2022-03-03 13:00:49'),(73546,213,'Maksud Pur','207302',1,0,'2022-03-03 13:00:49','2022-03-03 13:00:49'),(73547,213,'Malikpur','207403',1,0,'2022-03-03 13:00:49','2022-03-03 13:00:49'),(73548,213,'Malwan','207001',1,0,'2022-03-03 13:00:49','2022-03-03 13:00:49'),(73549,213,'Manora','207122',1,0,'2022-03-03 13:00:49','2022-03-03 13:00:49'),(73550,213,'Marehara','207401',1,0,'2022-03-03 13:00:49','2022-03-03 13:00:49'),(73551,213,'Margayan','207122',1,0,'2022-03-03 13:00:49','2022-03-03 13:00:49'),(73552,213,'Marthara Bhagwandas','207001',1,0,'2022-03-03 13:00:49','2022-03-03 13:00:49'),(73553,213,'Mehmood Pur Pukhata','207403',1,0,'2022-03-03 13:00:49','2022-03-03 13:00:49'),(73554,213,'Mehni Sora','207401',1,0,'2022-03-03 13:00:49','2022-03-03 13:00:49'),(73555,213,'Meidupura','207249',1,0,'2022-03-03 13:00:49','2022-03-03 13:00:49'),(73556,213,'Midhola Bujurg','207242',1,0,'2022-03-03 13:00:49','2022-03-03 13:00:49'),(73557,213,'Mihari','207123',1,0,'2022-03-03 13:00:49','2022-03-03 13:00:49'),(73558,213,'Milawali','207001',1,0,'2022-03-03 13:00:49','2022-03-03 13:00:49'),(73559,213,'Mirehachi','207125',1,0,'2022-03-03 13:00:49','2022-03-03 13:00:49'),(73560,213,'Misauli','207302',1,0,'2022-03-03 13:00:49','2022-03-03 13:00:49'),(73561,213,'Mitraul','207122',1,0,'2022-03-03 13:00:49','2022-03-03 13:00:49'),(73562,213,'Mohammadnagar Bajhera','207247',1,0,'2022-03-03 13:00:49','2022-03-03 13:00:49'),(73563,213,'Mohani Mamoorganj','207401',1,0,'2022-03-03 13:00:49','2022-03-03 13:00:49'),(73564,213,'Mohanpur','207242',1,0,'2022-03-03 13:00:49','2022-03-03 13:00:49'),(73565,213,'Mohanpura','207001',1,0,'2022-03-03 13:00:49','2022-03-03 13:00:49'),(73566,213,'Mokampur','207244',1,0,'2022-03-03 13:00:50','2022-03-03 13:00:50'),(73567,213,'Mubarik Pur Mafi','207124',1,0,'2022-03-03 13:00:50','2022-03-03 13:00:50'),(73568,213,'Muiddinpur','207120',1,0,'2022-03-03 13:00:50','2022-03-03 13:00:50'),(73569,213,'Myasur','207245',1,0,'2022-03-03 13:00:50','2022-03-03 13:00:50'),(73570,213,'Myau','207243',1,0,'2022-03-03 13:00:50','2022-03-03 13:00:50'),(73571,213,'Nadarmai','207241',1,0,'2022-03-03 13:00:50','2022-03-03 13:00:50'),(73572,213,'Nadrai','207001',1,0,'2022-03-03 13:00:50','2022-03-03 13:00:50'),(73573,213,'Nadrala','207247',1,0,'2022-03-03 13:00:50','2022-03-03 13:00:50'),(73574,213,'Nagla Anni','207302',1,0,'2022-03-03 13:00:50','2022-03-03 13:00:50'),(73575,213,'Nagla Bhimsen','207242',1,0,'2022-03-03 13:00:50','2022-03-03 13:00:50'),(73576,213,'Nagla Gajpat','207247',1,0,'2022-03-03 13:00:50','2022-03-03 13:00:50'),(73577,213,'Nagla Galu','207001',1,0,'2022-03-03 13:00:50','2022-03-03 13:00:50'),(73578,213,'Nagla Katila','207123',1,0,'2022-03-03 13:00:50','2022-03-03 13:00:50'),(73579,213,'Nagla Khilli','207001',1,0,'2022-03-03 13:00:50','2022-03-03 13:00:50'),(73580,213,'Nagla Leeladhar','207249',1,0,'2022-03-03 13:00:50','2022-03-03 13:00:50'),(73581,213,'Nagla Pawal','207001',1,0,'2022-03-03 13:00:50','2022-03-03 13:00:50'),(73582,213,'Nagla Pohpi','207244',1,0,'2022-03-03 13:00:50','2022-03-03 13:00:50'),(73583,213,'Nameni','207124',1,0,'2022-03-03 13:00:50','2022-03-03 13:00:50'),(73584,213,'Nandpur Bailamay','207121',1,0,'2022-03-03 13:00:50','2022-03-03 13:00:50'),(73585,213,'Narau','207302',1,0,'2022-03-03 13:00:50','2022-03-03 13:00:50'),(73586,213,'Nardoli','207243',1,0,'2022-03-03 13:00:50','2022-03-03 13:00:50'),(73587,213,'Narthar','207243',1,0,'2022-03-03 13:00:50','2022-03-03 13:00:50'),(73588,213,'Narura','207301',1,0,'2022-03-03 13:00:50','2022-03-03 13:00:50'),(73589,213,'Naugaon','207246',1,0,'2022-03-03 13:00:51','2022-03-03 13:00:51'),(73590,213,'Naukhera','207302',1,0,'2022-03-03 13:00:51','2022-03-03 13:00:51'),(73591,213,'Nawab Ganj','207001',1,0,'2022-03-03 13:00:51','2022-03-03 13:00:51'),(73592,213,'Naya  Bans','207125',1,0,'2022-03-03 13:00:51','2022-03-03 13:00:51'),(73593,213,'Neem Khera','207302',1,0,'2022-03-03 13:00:51','2022-03-03 13:00:51'),(73594,213,'Neoli','207402',1,0,'2022-03-03 13:00:51','2022-03-03 13:00:51'),(73595,213,'Neorai','207001',1,0,'2022-03-03 13:00:51','2022-03-03 13:00:51'),(73596,213,'Nidholi Kalan','207122',1,0,'2022-03-03 13:00:51','2022-03-03 13:00:51'),(73597,213,'Nigoh Hasanpur','207001',1,0,'2022-03-03 13:00:51','2022-03-03 13:00:51'),(73598,213,'Pachgain','207124',1,0,'2022-03-03 13:00:51','2022-03-03 13:00:51'),(73599,213,'Pamas','207001',1,0,'2022-03-03 13:00:51','2022-03-03 13:00:51'),(73600,213,'Pardanapur','207247',1,0,'2022-03-03 13:00:51','2022-03-03 13:00:51'),(73601,213,'Parson','207001',1,0,'2022-03-03 13:00:51','2022-03-03 13:00:51'),(73602,213,'Partappur','207241',1,0,'2022-03-03 13:00:51','2022-03-03 13:00:51'),(73603,213,'Pathreki','207123',1,0,'2022-03-03 13:00:51','2022-03-03 13:00:51'),(73604,213,'Patiali Gate','207001',1,0,'2022-03-03 13:00:51','2022-03-03 13:00:51'),(73605,213,'Patiali','207243',1,0,'2022-03-03 13:00:51','2022-03-03 13:00:51'),(73606,213,'Peepal Khairia','207121',1,0,'2022-03-03 13:00:51','2022-03-03 13:00:51'),(73607,213,'Phaphoto','207001',1,0,'2022-03-03 13:00:51','2022-03-03 13:00:51'),(73608,213,'Pidora','207401',1,0,'2022-03-03 13:00:51','2022-03-03 13:00:51'),(73609,213,'Pilkhatra','207302',1,0,'2022-03-03 13:00:51','2022-03-03 13:00:51'),(73610,213,'Pilkhuni','207246',1,0,'2022-03-03 13:00:51','2022-03-03 13:00:51'),(73611,213,'Pilua','207120',1,0,'2022-03-03 13:00:51','2022-03-03 13:00:51'),(73612,213,'Pinjari','207249',1,0,'2022-03-03 13:00:51','2022-03-03 13:00:51'),(73613,213,'Pipehra','207301',1,0,'2022-03-03 13:00:52','2022-03-03 13:00:52'),(73614,213,'Pithanpur','207246',1,0,'2022-03-03 13:00:52','2022-03-03 13:00:52'),(73615,213,'Piwari','207401',1,0,'2022-03-03 13:00:52','2022-03-03 13:00:52'),(73616,213,'Pondari','207301',1,0,'2022-03-03 13:00:52','2022-03-03 13:00:52'),(73617,213,'Punhera','207302',1,0,'2022-03-03 13:00:52','2022-03-03 13:00:52'),(73618,213,'Puraon','207001',1,0,'2022-03-03 13:00:52','2022-03-03 13:00:52'),(73619,213,'Raja Ka Rampur','207244',1,0,'2022-03-03 13:00:52','2022-03-03 13:00:52'),(73620,213,'Raja Rijola','207243',1,0,'2022-03-03 13:00:52','2022-03-03 13:00:52'),(73621,213,'Rajepur Kurra','207243',1,0,'2022-03-03 13:00:52','2022-03-03 13:00:52'),(73622,213,'Rajmal','207302',1,0,'2022-03-03 13:00:52','2022-03-03 13:00:52'),(73623,213,'Rajpur','207001',1,0,'2022-03-03 13:00:52','2022-03-03 13:00:52'),(73624,213,'Rajwali','207302',1,0,'2022-03-03 13:00:52','2022-03-03 13:00:52'),(73625,213,'Rarpatti','207001',1,0,'2022-03-03 13:00:52','2022-03-03 13:00:52'),(73626,213,'Rejua','207302',1,0,'2022-03-03 13:00:52','2022-03-03 13:00:52'),(73627,213,'Rekhpur','207123',1,0,'2022-03-03 13:00:52','2022-03-03 13:00:52'),(73628,213,'Rijor','207001',1,0,'2022-03-03 13:00:52','2022-03-03 13:00:52'),(73629,213,'Rohina Mirjapur','207301',1,0,'2022-03-03 13:00:52','2022-03-03 13:00:52'),(73630,213,'Roshan Nagar','207402',1,0,'2022-03-03 13:00:52','2022-03-03 13:00:52'),(73631,213,'Rupdhani','207248',1,0,'2022-03-03 13:00:52','2022-03-03 13:00:52'),(73632,213,'Rustamgarh','207001',1,0,'2022-03-03 13:00:52','2022-03-03 13:00:52'),(73633,213,'Sahadat Nagar','207249',1,0,'2022-03-03 13:00:52','2022-03-03 13:00:52'),(73634,213,'Sahawar','207245',1,0,'2022-03-03 13:00:52','2022-03-03 13:00:52'),(73635,213,'Sahori','207243',1,0,'2022-03-03 13:00:52','2022-03-03 13:00:52'),(73636,213,'Saina Kalan','207121',1,0,'2022-03-03 13:00:52','2022-03-03 13:00:52'),(73637,213,'Sakeet','207121',1,0,'2022-03-03 13:00:53','2022-03-03 13:00:53'),(73638,213,'Salai','207123',1,0,'2022-03-03 13:00:53','2022-03-03 13:00:53'),(73639,213,'Salempur Bebe','207403',1,0,'2022-03-03 13:00:53','2022-03-03 13:00:53'),(73640,213,'Salempur Pironda','207401',1,0,'2022-03-03 13:00:53','2022-03-03 13:00:53'),(73641,213,'Samaspur','207242',1,0,'2022-03-03 13:00:53','2022-03-03 13:00:53'),(73642,213,'Samaspur Dengri','207241',1,0,'2022-03-03 13:00:53','2022-03-03 13:00:53'),(73643,213,'Sanauri Khas','207243',1,0,'2022-03-03 13:00:53','2022-03-03 13:00:53'),(73644,213,'Sarai Aghat','207250',1,0,'2022-03-03 13:00:53','2022-03-03 13:00:53'),(73645,213,'Sarai Neem','207302',1,0,'2022-03-03 13:00:53','2022-03-03 13:00:53'),(73646,213,'Sarauth','207247',1,0,'2022-03-03 13:00:53','2022-03-03 13:00:53'),(73647,213,'Sarawal','207248',1,0,'2022-03-03 13:00:53','2022-03-03 13:00:53'),(73648,213,'Sarnau','207001',1,0,'2022-03-03 13:00:53','2022-03-03 13:00:53'),(73649,213,'Sarsai Narau','207241',1,0,'2022-03-03 13:00:53','2022-03-03 13:00:53'),(73650,213,'Sarutiya','207247',1,0,'2022-03-03 13:00:53','2022-03-03 13:00:53'),(73651,213,'Sarvodaya Ashram','207001',1,0,'2022-03-03 13:00:53','2022-03-03 13:00:53'),(73652,213,'Shahnagar Timarua','207302',1,0,'2022-03-03 13:00:53','2022-03-03 13:00:53'),(73653,213,'Shahpur Tehla','207244',1,0,'2022-03-03 13:00:53','2022-03-03 13:00:53'),(73654,213,'Shakrauli','207302',1,0,'2022-03-03 13:00:53','2022-03-03 13:00:53'),(73655,213,'Sheetal Pur','207001',1,0,'2022-03-03 13:00:53','2022-03-03 13:00:53'),(73656,213,'Sheorai','207125',1,0,'2022-03-03 13:00:53','2022-03-03 13:00:53'),(73657,213,'Shikhpura','207248',1,0,'2022-03-03 13:00:53','2022-03-03 13:00:53'),(73658,213,'Sikehara','207242',1,0,'2022-03-03 13:00:53','2022-03-03 13:00:53'),(73659,213,'Simrau','207302',1,0,'2022-03-03 13:00:54','2022-03-03 13:00:54'),(73660,213,'Singpur','207242',1,0,'2022-03-03 13:00:54','2022-03-03 13:00:54'),(73661,213,'Sirawali','207403',1,0,'2022-03-03 13:00:54','2022-03-03 13:00:54'),(73662,213,'Sirhpura','207246',1,0,'2022-03-03 13:00:54','2022-03-03 13:00:54'),(73663,213,'Sirsa Tippu','207125',1,0,'2022-03-03 13:00:54','2022-03-03 13:00:54'),(73664,213,'Songra','207120',1,0,'2022-03-03 13:00:54','2022-03-03 13:00:54'),(73665,213,'Sonhar','207001',1,0,'2022-03-03 13:00:54','2022-03-03 13:00:54'),(73666,213,'Soron','207403',1,0,'2022-03-03 13:00:54','2022-03-03 13:00:54'),(73667,213,'Suhagpur','207249',1,0,'2022-03-03 13:00:54','2022-03-03 13:00:54'),(73668,213,'Sujrai','207241',1,0,'2022-03-03 13:00:54','2022-03-03 13:00:54'),(73669,213,'Sultanpur','207246',1,0,'2022-03-03 13:00:54','2022-03-03 13:00:54'),(73670,213,'Sunngarhi','207242',1,0,'2022-03-03 13:00:54','2022-03-03 13:00:54'),(73671,213,'Takhawan','207302',1,0,'2022-03-03 13:00:54','2022-03-03 13:00:54'),(73672,213,'Targawan','207249',1,0,'2022-03-03 13:00:54','2022-03-03 13:00:54'),(73673,213,'Thana Darioganj','207243',1,0,'2022-03-03 13:00:54','2022-03-03 13:00:54'),(73674,213,'Tharachithara','207241',1,0,'2022-03-03 13:00:54','2022-03-03 13:00:54'),(73675,213,'Tikathar','207301',1,0,'2022-03-03 13:00:54','2022-03-03 13:00:54'),(73676,213,'Tilsai','207123',1,0,'2022-03-03 13:00:54','2022-03-03 13:00:54'),(73677,213,'Tirlokpur','207401',1,0,'2022-03-03 13:00:54','2022-03-03 13:00:54'),(73678,213,'Ubhai Asadnagar','207247',1,0,'2022-03-03 13:00:54','2022-03-03 13:00:54'),(73679,213,'Udaipura','207248',1,0,'2022-03-03 13:00:54','2022-03-03 13:00:54'),(73680,213,'Ummargarh','207302',1,0,'2022-03-03 13:00:54','2022-03-03 13:00:54'),(73681,213,'Virahampuri','207403',1,0,'2022-03-03 13:00:54','2022-03-03 13:00:54'),(73682,213,'Wazirpur','207001',1,0,'2022-03-03 13:00:54','2022-03-03 13:00:54'),(73683,213,'Yakootganj','207245',1,0,'2022-03-03 13:00:54','2022-03-03 13:00:54'),(73684,214,'Abhinaypur Pathakpur','206253',1,0,'2022-03-03 13:00:54','2022-03-03 13:00:54'),(73685,214,'Adhiyapur','206002',1,0,'2022-03-03 13:00:55','2022-03-03 13:00:55'),(73686,214,'Aheripur','206120',1,0,'2022-03-03 13:00:55','2022-03-03 13:00:55'),(73687,214,'Ajabpur','206131',1,0,'2022-03-03 13:00:55','2022-03-03 13:00:55'),(73688,214,'Anantraam Sonasi','206128',1,0,'2022-03-03 13:00:55','2022-03-03 13:00:55'),(73689,214,'Andawa','206128',1,0,'2022-03-03 13:00:55','2022-03-03 13:00:55'),(73690,214,'Ashok Nagar (Etawah)','206001',1,0,'2022-03-03 13:00:55','2022-03-03 13:00:55'),(73691,214,'Bachheri','206125',1,0,'2022-03-03 13:00:55','2022-03-03 13:00:55'),(73692,214,'Bahadurpurghar','206127',1,0,'2022-03-03 13:00:55','2022-03-03 13:00:55'),(73693,214,'Baharpura','206242',1,0,'2022-03-03 13:00:55','2022-03-03 13:00:55'),(73694,214,'Bahuri','206131',1,0,'2022-03-03 13:00:55','2022-03-03 13:00:55'),(73695,214,'Baisolighat','206126',1,0,'2022-03-03 13:00:55','2022-03-03 13:00:55'),(73696,214,'Bajaria','206001',1,0,'2022-03-03 13:00:55','2022-03-03 13:00:55'),(73697,214,'Bakauli','206123',1,0,'2022-03-03 13:00:55','2022-03-03 13:00:55'),(73698,214,'Bakewar','206124',1,0,'2022-03-03 13:00:55','2022-03-03 13:00:55'),(73699,214,'Balrai','206245',1,0,'2022-03-03 13:00:55','2022-03-03 13:00:55'),(73700,214,'Bansari','206125',1,0,'2022-03-03 13:00:55','2022-03-03 13:00:55'),(73701,214,'Baralokpur','206123',1,0,'2022-03-03 13:00:55','2022-03-03 13:00:55'),(73702,214,'Barauli Jamunapar','206131',1,0,'2022-03-03 13:00:55','2022-03-03 13:00:55'),(73703,214,'Barechha','206125',1,0,'2022-03-03 13:00:55','2022-03-03 13:00:55'),(73704,214,'Barhpura','206131',1,0,'2022-03-03 13:00:55','2022-03-03 13:00:55'),(73705,214,'Baroli Khurd','206253',1,0,'2022-03-03 13:00:56','2022-03-03 13:00:56'),(73706,214,'Basrehar','206253',1,0,'2022-03-03 13:00:56','2022-03-03 13:00:56'),(73707,214,'Bauth','206245',1,0,'2022-03-03 13:00:56','2022-03-03 13:00:56'),(73708,214,'Beena','206123',1,0,'2022-03-03 13:00:56','2022-03-03 13:00:56'),(73709,214,'Ber','206242',1,0,'2022-03-03 13:00:56','2022-03-03 13:00:56'),(73710,214,'Bhadsan','206120',1,0,'2022-03-03 13:00:56','2022-03-03 13:00:56'),(73711,214,'Bharthana','206242',1,0,'2022-03-03 13:00:56','2022-03-03 13:00:56'),(73712,214,'Bibamau','206245',1,0,'2022-03-03 13:00:56','2022-03-03 13:00:56'),(73713,214,'Bidauri','206125',1,0,'2022-03-03 13:00:56','2022-03-03 13:00:56'),(73714,214,'Bidhipura','206127',1,0,'2022-03-03 13:00:56','2022-03-03 13:00:56'),(73715,214,'Bijoli','206124',1,0,'2022-03-03 13:00:56','2022-03-03 13:00:56'),(73716,214,'Bindwa Kalan','206125',1,0,'2022-03-03 13:00:56','2022-03-03 13:00:56'),(73717,214,'Bindwa Khurd','206125',1,0,'2022-03-03 13:00:56','2022-03-03 13:00:56'),(73718,214,'Birari','206126',1,0,'2022-03-03 13:00:56','2022-03-03 13:00:56'),(73719,214,'Birondhi','206242',1,0,'2022-03-03 13:00:56','2022-03-03 13:00:56'),(73720,214,'Bithauli','206125',1,0,'2022-03-03 13:00:56','2022-03-03 13:00:56'),(73721,214,'Bojha','206120',1,0,'2022-03-03 13:00:56','2022-03-03 13:00:56'),(73722,214,'Chakar Nagar','206125',1,0,'2022-03-03 13:00:56','2022-03-03 13:00:56'),(73723,214,'Chakwa Bujurg','206253',1,0,'2022-03-03 13:00:56','2022-03-03 13:00:56'),(73724,214,'Chandanpur','206126',1,0,'2022-03-03 13:00:56','2022-03-03 13:00:56'),(73725,214,'Chandrapura','206127',1,0,'2022-03-03 13:00:56','2022-03-03 13:00:56'),(73726,214,'Chaubia','206123',1,0,'2022-03-03 13:00:56','2022-03-03 13:00:56'),(73727,214,'Chaurela','206125',1,0,'2022-03-03 13:00:56','2022-03-03 13:00:56'),(73728,214,'Chindauli','206127',1,0,'2022-03-03 13:00:57','2022-03-03 13:00:57'),(73729,214,'Chitbhawan','206003',1,0,'2022-03-03 13:00:57','2022-03-03 13:00:57'),(73730,214,'Colleger Road Bharthana','206001',1,0,'2022-03-03 13:00:57','2022-03-03 13:00:57'),(73731,214,'Dadora','206126',1,0,'2022-03-03 13:00:57','2022-03-03 13:00:57'),(73732,214,'Darbatpur','206120',1,0,'2022-03-03 13:00:57','2022-03-03 13:00:57'),(73733,214,'Dataoli','206002',1,0,'2022-03-03 13:00:57','2022-03-03 13:00:57'),(73734,214,'Dhanua','206001',1,0,'2022-03-03 13:00:57','2022-03-03 13:00:57'),(73735,214,'Dharwar','206245',1,0,'2022-03-03 13:00:57','2022-03-03 13:00:57'),(73736,214,'Distt Board  Etawah','206001',1,0,'2022-03-03 13:00:57','2022-03-03 13:00:57'),(73737,214,'Durgapura','206127',1,0,'2022-03-03 13:00:57','2022-03-03 13:00:57'),(73738,214,'Ekari','206127',1,0,'2022-03-03 13:00:57','2022-03-03 13:00:57'),(73739,214,'Ekdil','206126',1,0,'2022-03-03 13:00:57','2022-03-03 13:00:57'),(73740,214,'Eknaur','206127',1,0,'2022-03-03 13:00:57','2022-03-03 13:00:57'),(73741,214,'Etawah City','206001',1,0,'2022-03-03 13:00:57','2022-03-03 13:00:57'),(73742,214,'Etawah H.O','206001',1,0,'2022-03-03 13:00:57','2022-03-03 13:00:57'),(73743,214,'Etawah Kutchary','206001',1,0,'2022-03-03 13:00:57','2022-03-03 13:00:57'),(73744,214,'Etawah New City','206001',1,0,'2022-03-03 13:00:57','2022-03-03 13:00:57'),(73745,214,'Fatehpura','206124',1,0,'2022-03-03 13:00:57','2022-03-03 13:00:57'),(73746,214,'Garhaita','206131',1,0,'2022-03-03 13:00:57','2022-03-03 13:00:57'),(73747,214,'Garhi Ram Dhan','206245',1,0,'2022-03-03 13:00:57','2022-03-03 13:00:57'),(73748,214,'Garhwana','206242',1,0,'2022-03-03 13:00:57','2022-03-03 13:00:57'),(73749,214,'Gati','206131',1,0,'2022-03-03 13:00:58','2022-03-03 13:00:58'),(73750,214,'Gauhani','206125',1,0,'2022-03-03 13:00:58','2022-03-03 13:00:58'),(73751,214,'Ghughsina','206124',1,0,'2022-03-03 13:00:58','2022-03-03 13:00:58'),(73752,214,'Ginja','206130',1,0,'2022-03-03 13:00:58','2022-03-03 13:00:58'),(73753,214,'Girdharipura','206242',1,0,'2022-03-03 13:00:58','2022-03-03 13:00:58'),(73754,214,'Gulabpura','206124',1,0,'2022-03-03 13:00:58','2022-03-03 13:00:58'),(73755,214,'Hardoi','206253',1,0,'2022-03-03 13:00:58','2022-03-03 13:00:58'),(73756,214,'Heonra','206001',1,0,'2022-03-03 13:00:58','2022-03-03 13:00:58'),(73757,214,'I. T. I. Etawah','206002',1,0,'2022-03-03 13:00:58','2022-03-03 13:00:58'),(73758,214,'Indraukhi','206120',1,0,'2022-03-03 13:00:58','2022-03-03 13:00:58'),(73759,214,'Ingurri','206124',1,0,'2022-03-03 13:00:58','2022-03-03 13:00:58'),(73760,214,'Jagannathpur','206128',1,0,'2022-03-03 13:00:58','2022-03-03 13:00:58'),(73761,214,'Jagsora','206245',1,0,'2022-03-03 13:00:58','2022-03-03 13:00:58'),(73762,214,'Jagtauli','206125',1,0,'2022-03-03 13:00:58','2022-03-03 13:00:58'),(73763,214,'Jaitpura Par','206131',1,0,'2022-03-03 13:00:58','2022-03-03 13:00:58'),(73764,214,'Jarhauli','206131',1,0,'2022-03-03 13:00:58','2022-03-03 13:00:58'),(73765,214,'Jasohan','206245',1,0,'2022-03-03 13:00:58','2022-03-03 13:00:58'),(73766,214,'Jaswant Nagar Bazar','206245',1,0,'2022-03-03 13:00:58','2022-03-03 13:00:58'),(73767,214,'Jaswant Nagar','206245',1,0,'2022-03-03 13:00:58','2022-03-03 13:00:58'),(73768,214,'Jhabrapura','206245',1,0,'2022-03-03 13:00:58','2022-03-03 13:00:58'),(73769,214,'K. K. D. C. Etawah','206001',1,0,'2022-03-03 13:00:58','2022-03-03 13:00:58'),(73770,214,'Kadampur','206123',1,0,'2022-03-03 13:00:58','2022-03-03 13:00:58'),(73771,214,'Kaisth','206245',1,0,'2022-03-03 13:00:58','2022-03-03 13:00:58'),(73772,214,'Kakrahi','206242',1,0,'2022-03-03 13:00:59','2022-03-03 13:00:59'),(73773,214,'Kamet','206131',1,0,'2022-03-03 13:00:59','2022-03-03 13:00:59'),(73774,214,'Kandheshi Dhar','206125',1,0,'2022-03-03 13:00:59','2022-03-03 13:00:59'),(73775,214,'Kandheshi Pachar','206242',1,0,'2022-03-03 13:00:59','2022-03-03 13:00:59'),(73776,214,'Karba Bujurg','206126',1,0,'2022-03-03 13:00:59','2022-03-03 13:00:59'),(73777,214,'Karri','206123',1,0,'2022-03-03 13:00:59','2022-03-03 13:00:59'),(73778,214,'Kathua','206253',1,0,'2022-03-03 13:00:59','2022-03-03 13:00:59'),(73779,214,'Kauwa','206123',1,0,'2022-03-03 13:00:59','2022-03-03 13:00:59'),(73780,214,'Kharagpur Saraiya','206123',1,0,'2022-03-03 13:00:59','2022-03-03 13:00:59'),(73781,214,'Kharduli','206253',1,0,'2022-03-03 13:00:59','2022-03-03 13:00:59'),(73782,214,'Kharkauli','206253',1,0,'2022-03-03 13:00:59','2022-03-03 13:00:59'),(73783,214,'Kheda Helu','206253',1,0,'2022-03-03 13:00:59','2022-03-03 13:00:59'),(73784,214,'Kudrail','206242',1,0,'2022-03-03 13:00:59','2022-03-03 13:00:59'),(73785,214,'Kuiya','206130',1,0,'2022-03-03 13:00:59','2022-03-03 13:00:59'),(73786,214,'Kukaoli','206245',1,0,'2022-03-03 13:00:59','2022-03-03 13:00:59'),(73787,214,'Kumahwar','206253',1,0,'2022-03-03 13:00:59','2022-03-03 13:00:59'),(73788,214,'Kunetha','206124',1,0,'2022-03-03 13:00:59','2022-03-03 13:00:59'),(73789,214,'Kunwara','206242',1,0,'2022-03-03 13:00:59','2022-03-03 13:00:59'),(73790,214,'Kursena','206245',1,0,'2022-03-03 13:00:59','2022-03-03 13:00:59'),(73791,214,'Kushna','206242',1,0,'2022-03-03 13:00:59','2022-03-03 13:00:59'),(73792,214,'Lakhana','206127',1,0,'2022-03-03 13:00:59','2022-03-03 13:00:59'),(73793,214,'Lalpura Etawah','206001',1,0,'2022-03-03 13:00:59','2022-03-03 13:00:59'),(73794,214,'Larkhaur','206130',1,0,'2022-03-03 13:00:59','2022-03-03 13:00:59'),(73795,214,'Lavedi','206001',1,0,'2022-03-03 13:01:00','2022-03-03 13:01:00'),(73796,214,'Ludhiani','206124',1,0,'2022-03-03 13:01:00','2022-03-03 13:01:00'),(73797,214,'Malajani','206245',1,0,'2022-03-03 13:01:00','2022-03-03 13:01:00'),(73798,214,'Malhausi','206242',1,0,'2022-03-03 13:01:00','2022-03-03 13:01:00'),(73799,214,'Maman','206242',1,0,'2022-03-03 13:01:00','2022-03-03 13:01:00'),(73800,214,'Mandir Mahewa','206128',1,0,'2022-03-03 13:01:00','2022-03-03 13:01:00'),(73801,214,'Maniamau','206126',1,0,'2022-03-03 13:01:00','2022-03-03 13:01:00'),(73802,214,'Manikpur Bissu','206003',1,0,'2022-03-03 13:01:00','2022-03-03 13:01:00'),(73803,214,'Merhi Dudhi','206242',1,0,'2022-03-03 13:01:00','2022-03-03 13:01:00'),(73804,214,'Moonj','206123',1,0,'2022-03-03 13:01:00','2022-03-03 13:01:00'),(73805,214,'Mugalpur Naraini','206126',1,0,'2022-03-03 13:01:00','2022-03-03 13:01:00'),(73806,214,'Murong','206131',1,0,'2022-03-03 13:01:00','2022-03-03 13:01:00'),(73807,214,'Musaoli','206003',1,0,'2022-03-03 13:01:00','2022-03-03 13:01:00'),(73808,214,'Nagaria Yadwan','206242',1,0,'2022-03-03 13:01:00','2022-03-03 13:01:00'),(73809,214,'Nagla Ram Sunder','206245',1,0,'2022-03-03 13:01:00','2022-03-03 13:01:00'),(73810,214,'Nagla Taur','206245',1,0,'2022-03-03 13:01:00','2022-03-03 13:01:00'),(73811,214,'Nandgaon','206127',1,0,'2022-03-03 13:01:00','2022-03-03 13:01:00'),(73812,214,'Niloi','206245',1,0,'2022-03-03 13:01:00','2022-03-03 13:01:00'),(73813,214,'Niwarikalan','206120',1,0,'2022-03-03 13:01:00','2022-03-03 13:01:00'),(73814,214,'Pachhayagaon','206131',1,0,'2022-03-03 13:01:00','2022-03-03 13:01:00'),(73815,214,'Paharpura','206127',1,0,'2022-03-03 13:01:00','2022-03-03 13:01:00'),(73816,214,'Pali Khurd','206242',1,0,'2022-03-03 13:01:00','2022-03-03 13:01:00'),(73817,214,'Parasana','206123',1,0,'2022-03-03 13:01:00','2022-03-03 13:01:00'),(73818,214,'Phoolpur','206128',1,0,'2022-03-03 13:01:01','2022-03-03 13:01:01'),(73819,214,'Pilkhana','206120',1,0,'2022-03-03 13:01:01','2022-03-03 13:01:01'),(73820,214,'Pilkhar','206003',1,0,'2022-03-03 13:01:01','2022-03-03 13:01:01'),(73821,214,'Piproli Gadhia','206125',1,0,'2022-03-03 13:01:01','2022-03-03 13:01:01'),(73822,214,'Pratapner','206001',1,0,'2022-03-03 13:01:01','2022-03-03 13:01:01'),(73823,214,'Prithvipur','206126',1,0,'2022-03-03 13:01:01','2022-03-03 13:01:01'),(73824,214,'Prithvirampur','206124',1,0,'2022-03-03 13:01:01','2022-03-03 13:01:01'),(73825,214,'Punja','206123',1,0,'2022-03-03 13:01:01','2022-03-03 13:01:01'),(73826,214,'Purana Bharthana','206001',1,0,'2022-03-03 13:01:01','2022-03-03 13:01:01'),(73827,214,'Puraoli','206128',1,0,'2022-03-03 13:01:01','2022-03-03 13:01:01'),(73828,214,'Purela','206123',1,0,'2022-03-03 13:01:01','2022-03-03 13:01:01'),(73829,214,'Rahin','206253',1,0,'2022-03-03 13:01:01','2022-03-03 13:01:01'),(73830,214,'Rajpur','206125',1,0,'2022-03-03 13:01:01','2022-03-03 13:01:01'),(73831,214,'Ram Lila Road','206003',1,0,'2022-03-03 13:01:01','2022-03-03 13:01:01'),(73832,214,'Ramain','206242',1,0,'2022-03-03 13:01:01','2022-03-03 13:01:01'),(73833,214,'Ritaur','206126',1,0,'2022-03-03 13:01:01','2022-03-03 13:01:01'),(73834,214,'Sahson','206125',1,0,'2022-03-03 13:01:01','2022-03-03 13:01:01'),(73835,214,'Saifai','206130',1,0,'2022-03-03 13:01:01','2022-03-03 13:01:01'),(73836,214,'Sainfi','206242',1,0,'2022-03-03 13:01:01','2022-03-03 13:01:01'),(73837,214,'Samhon','206242',1,0,'2022-03-03 13:01:01','2022-03-03 13:01:01'),(73838,214,'Samthar','206242',1,0,'2022-03-03 13:01:01','2022-03-03 13:01:01'),(73839,214,'Santoshpur Ghat','206253',1,0,'2022-03-03 13:01:02','2022-03-03 13:01:02'),(73840,214,'Sarai Chauri','206242',1,0,'2022-03-03 13:01:02','2022-03-03 13:01:02'),(73841,214,'Sarangpura','206002',1,0,'2022-03-03 13:01:02','2022-03-03 13:01:02'),(73842,214,'Sarawa','206242',1,0,'2022-03-03 13:01:02','2022-03-03 13:01:02'),(73843,214,'Sarsai Helu','206123',1,0,'2022-03-03 13:01:02','2022-03-03 13:01:02'),(73844,214,'Sarsai Nawar','206123',1,0,'2022-03-03 13:01:02','2022-03-03 13:01:02'),(73845,214,'Satyawadi Etawah','206001',1,0,'2022-03-03 13:01:02','2022-03-03 13:01:02'),(73846,214,'Sekhupur Adhar Singh','206120',1,0,'2022-03-03 13:01:02','2022-03-03 13:01:02'),(73847,214,'Sherpur','206124',1,0,'2022-03-03 13:01:02','2022-03-03 13:01:02'),(73848,214,'Sindaus','206125',1,0,'2022-03-03 13:01:02','2022-03-03 13:01:02'),(73849,214,'Sirhaul','206245',1,0,'2022-03-03 13:01:02','2022-03-03 13:01:02'),(73850,214,'Sirsa','206253',1,0,'2022-03-03 13:01:02','2022-03-03 13:01:02'),(73851,214,'Sishat','206245',1,0,'2022-03-03 13:01:02','2022-03-03 13:01:02'),(73852,214,'Takha','206242',1,0,'2022-03-03 13:01:02','2022-03-03 13:01:02'),(73853,214,'Takrupur','206127',1,0,'2022-03-03 13:01:02','2022-03-03 13:01:02'),(73854,214,'Titawali','206125',1,0,'2022-03-03 13:01:02','2022-03-03 13:01:02'),(73855,214,'Udi','206131',1,0,'2022-03-03 13:01:02','2022-03-03 13:01:02'),(73856,214,'Ujhiani','206128',1,0,'2022-03-03 13:01:02','2022-03-03 13:01:02'),(73857,214,'Umarsenda','206242',1,0,'2022-03-03 13:01:02','2022-03-03 13:01:02'),(73858,214,'Ureng','206120',1,0,'2022-03-03 13:01:02','2022-03-03 13:01:02'),(73859,214,'Usrahar','206123',1,0,'2022-03-03 13:01:02','2022-03-03 13:01:02'),(73860,214,'Vaidpura','206002',1,0,'2022-03-03 13:01:02','2022-03-03 13:01:02'),(73861,214,'Vijaypura','206245',1,0,'2022-03-03 13:01:02','2022-03-03 13:01:02'),(73862,215,'Abboopur','224116',1,0,'2022-03-03 13:01:03','2022-03-03 13:01:03'),(73863,215,'Acharya Nagar','224001',1,0,'2022-03-03 13:01:03','2022-03-03 13:01:03'),(73864,215,'Achhora','224225',1,0,'2022-03-03 13:01:03','2022-03-03 13:01:03'),(73865,215,'Adilpur','224208',1,0,'2022-03-03 13:01:03','2022-03-03 13:01:03'),(73866,215,'Ahiran Subansh','224225',1,0,'2022-03-03 13:01:03','2022-03-03 13:01:03'),(73867,215,'Alnabhari','224161',1,0,'2022-03-03 13:01:03','2022-03-03 13:01:03'),(73868,215,'Alwalpur','224135',1,0,'2022-03-03 13:01:03','2022-03-03 13:01:03'),(73869,215,'Amaniganj','224121',1,0,'2022-03-03 13:01:03','2022-03-03 13:01:03'),(73870,215,'Amsin','224141',1,0,'2022-03-03 13:01:03','2022-03-03 13:01:03'),(73871,215,'Anjrauli','224164',1,0,'2022-03-03 13:01:03','2022-03-03 13:01:03'),(73872,215,'Ankaripur','224141',1,0,'2022-03-03 13:01:03','2022-03-03 13:01:03'),(73873,215,'Arsath','224209',1,0,'2022-03-03 13:01:03','2022-03-03 13:01:03'),(73874,215,'Arthar','224188',1,0,'2022-03-03 13:01:03','2022-03-03 13:01:03'),(73875,215,'Asrewa','224207',1,0,'2022-03-03 13:01:03','2022-03-03 13:01:03'),(73876,215,'Ayodhya RS','224123',1,0,'2022-03-03 13:01:03','2022-03-03 13:01:03'),(73877,215,'Baidarapur','224189',1,0,'2022-03-03 13:01:03','2022-03-03 13:01:03'),(73878,215,'Baihari','224161',1,0,'2022-03-03 13:01:03','2022-03-03 13:01:03'),(73879,215,'Bainti','224209',1,0,'2022-03-03 13:01:03','2022-03-03 13:01:03'),(73880,215,'Bakauli','224121',1,0,'2022-03-03 13:01:03','2022-03-03 13:01:03'),(73881,215,'Bakchuna','224153',1,0,'2022-03-03 13:01:03','2022-03-03 13:01:03'),(73882,215,'Bala Paikauli','224141',1,0,'2022-03-03 13:01:03','2022-03-03 13:01:03'),(73883,215,'Ballipur','224204',1,0,'2022-03-03 13:01:03','2022-03-03 13:01:03'),(73884,215,'Bandanpur','224141',1,0,'2022-03-03 13:01:03','2022-03-03 13:01:03'),(73885,215,'Banket','224204',1,0,'2022-03-03 13:01:04','2022-03-03 13:01:04'),(73886,215,'Banswar Kalan','224208',1,0,'2022-03-03 13:01:04','2022-03-03 13:01:04'),(73887,215,'Baragaon RS','224126',1,0,'2022-03-03 13:01:04','2022-03-03 13:01:04'),(73888,215,'Barauli','224153',1,0,'2022-03-03 13:01:04','2022-03-03 13:01:04'),(73889,215,'Barwa','224182',1,0,'2022-03-03 13:01:04','2022-03-03 13:01:04'),(73890,215,'Basantpur','224206',1,0,'2022-03-03 13:01:04','2022-03-03 13:01:04'),(73891,215,'Basawan','224228',1,0,'2022-03-03 13:01:04','2022-03-03 13:01:04'),(73892,215,'Bawan','224229',1,0,'2022-03-03 13:01:04','2022-03-03 13:01:04'),(73893,215,'Benawa','224161',1,0,'2022-03-03 13:01:04','2022-03-03 13:01:04'),(73894,215,'Beni Gaddopur','224203',1,0,'2022-03-03 13:01:04','2022-03-03 13:01:04'),(73895,215,'Benipur','224152',1,0,'2022-03-03 13:01:04','2022-03-03 13:01:04'),(73896,215,'Benipur','224209',1,0,'2022-03-03 13:01:04','2022-03-03 13:01:04'),(73897,215,'Beraspur','224161',1,0,'2022-03-03 13:01:04','2022-03-03 13:01:04'),(73898,215,'Bhakhauli','224153',1,0,'2022-03-03 13:01:04','2022-03-03 13:01:04'),(73899,215,'Bhav Nathpur','224206',1,0,'2022-03-03 13:01:04','2022-03-03 13:01:04'),(73900,215,'Bhawapur','224204',1,0,'2022-03-03 13:01:04','2022-03-03 13:01:04'),(73901,215,'Bhilsar','224116',1,0,'2022-03-03 13:01:04','2022-03-03 13:01:04'),(73902,215,'Bhimatali','224164',1,0,'2022-03-03 13:01:04','2022-03-03 13:01:04'),(73903,215,'Bhitaura','224188',1,0,'2022-03-03 13:01:04','2022-03-03 13:01:04'),(73904,215,'Bhitergaon','224209',1,0,'2022-03-03 13:01:04','2022-03-03 13:01:04'),(73905,215,'Bhoya','224161',1,0,'2022-03-03 13:01:04','2022-03-03 13:01:04'),(73906,215,'Bikapur','224204',1,0,'2022-03-03 13:01:04','2022-03-03 13:01:04'),(73907,215,'Birauli','224229',1,0,'2022-03-03 13:01:05','2022-03-03 13:01:05'),(73908,215,'Bodahari','224206',1,0,'2022-03-03 13:01:05','2022-03-03 13:01:05'),(73909,215,'Chachikpur','224141',1,0,'2022-03-03 13:01:05','2022-03-03 13:01:05'),(73910,215,'Chamela','224208',1,0,'2022-03-03 13:01:05','2022-03-03 13:01:05'),(73911,215,'Chandaura','224121',1,0,'2022-03-03 13:01:05','2022-03-03 13:01:05'),(73912,215,'Chandramau','224118',1,0,'2022-03-03 13:01:05','2022-03-03 13:01:05'),(73913,215,'Chaurebazar','224209',1,0,'2022-03-03 13:01:05','2022-03-03 13:01:05'),(73914,215,'Chirauli','224228',1,0,'2022-03-03 13:01:05','2022-03-03 13:01:05'),(73915,215,'Chirra Mohammad Pur','224001',1,0,'2022-03-03 13:01:05','2022-03-03 13:01:05'),(73916,215,'Chitaura','224164',1,0,'2022-03-03 13:01:05','2022-03-03 13:01:05'),(73917,215,'Chwardhar','224204',1,0,'2022-03-03 13:01:05','2022-03-03 13:01:05'),(73918,215,'Dadera','224135',1,0,'2022-03-03 13:01:05','2022-03-03 13:01:05'),(73919,215,'Darshan Nagar','224135',1,0,'2022-03-03 13:01:05','2022-03-03 13:01:05'),(73920,215,'Dasauli','224201',1,0,'2022-03-03 13:01:05','2022-03-03 13:01:05'),(73921,215,'Dashrathpur','224204',1,0,'2022-03-03 13:01:05','2022-03-03 13:01:05'),(73922,215,'Dehriyawan','224207',1,0,'2022-03-03 13:01:05','2022-03-03 13:01:05'),(73923,215,'Deogaon','224153',1,0,'2022-03-03 13:01:05','2022-03-03 13:01:05'),(73924,215,'Deokali','224001',1,0,'2022-03-03 13:01:05','2022-03-03 13:01:05'),(73925,215,'Deorhi','224189',1,0,'2022-03-03 13:01:05','2022-03-03 13:01:05'),(73926,215,'Dhanaicha','224164',1,0,'2022-03-03 13:01:05','2022-03-03 13:01:05'),(73927,215,'Dharamarg','224001',1,0,'2022-03-03 13:01:05','2022-03-03 13:01:05'),(73928,215,'Dharauli','224121',1,0,'2022-03-03 13:01:05','2022-03-03 13:01:05'),(73929,215,'Dharehata Dashrathpur','224204',1,0,'2022-03-03 13:01:05','2022-03-03 13:01:05'),(73930,215,'Dhema Vaish','224284',1,0,'2022-03-03 13:01:05','2022-03-03 13:01:05'),(73931,215,'Dilasiganj','224161',1,0,'2022-03-03 13:01:05','2022-03-03 13:01:05'),(73932,215,'Faizabad Cantt','224001',1,0,'2022-03-03 13:01:05','2022-03-03 13:01:05'),(73933,215,'Faizabad City','224001',1,0,'2022-03-03 13:01:06','2022-03-03 13:01:06'),(73934,215,'Faizabad H.O','224001',1,0,'2022-03-03 13:01:06','2022-03-03 13:01:06'),(73935,215,'Faizabad Kutchery','224001',1,0,'2022-03-03 13:01:06','2022-03-03 13:01:06'),(73936,215,'Faizabad RS','224001',1,0,'2022-03-03 13:01:06','2022-03-03 13:01:06'),(73937,215,'Fatehganj (Faizabad)','224001',1,0,'2022-03-03 13:01:06','2022-03-03 13:01:06'),(73938,215,'Fatehpur Kamasin','224141',1,0,'2022-03-03 13:01:06','2022-03-03 13:01:06'),(73939,215,'Gaddopur','224121',1,0,'2022-03-03 13:01:06','2022-03-03 13:01:06'),(73940,215,'Gadopur Majhwa','224001',1,0,'2022-03-03 13:01:06','2022-03-03 13:01:06'),(73941,215,'Gauhania','224121',1,0,'2022-03-03 13:01:06','2022-03-03 13:01:06'),(73942,215,'Gauhanna Qanoongo','224127',1,0,'2022-03-03 13:01:06','2022-03-03 13:01:06'),(73943,215,'Gaura','224204',1,0,'2022-03-03 13:01:06','2022-03-03 13:01:06'),(73944,215,'Gayaspur','224204',1,0,'2022-03-03 13:01:06','2022-03-03 13:01:06'),(73945,215,'Gayasuddinpur','224207',1,0,'2022-03-03 13:01:06','2022-03-03 13:01:06'),(73946,215,'Ghatauli','224164',1,0,'2022-03-03 13:01:06','2022-03-03 13:01:06'),(73947,215,'Ghorwal','224153',1,0,'2022-03-03 13:01:06','2022-03-03 13:01:06'),(73948,215,'Ghurehta','224284',1,0,'2022-03-03 13:01:06','2022-03-03 13:01:06'),(73949,215,'Gokula','224164',1,0,'2022-03-03 13:01:06','2022-03-03 13:01:06'),(73950,215,'Golaghat','224123',1,0,'2022-03-03 13:01:06','2022-03-03 13:01:06'),(73951,215,'Gondwa','224126',1,0,'2022-03-03 13:01:06','2022-03-03 13:01:06'),(73952,215,'Gopalpur','224001',1,0,'2022-03-03 13:01:06','2022-03-03 13:01:06'),(73953,215,'Goshaiganj','224141',1,0,'2022-03-03 13:01:06','2022-03-03 13:01:06'),(73954,215,'Gothwara','224127',1,0,'2022-03-03 13:01:06','2022-03-03 13:01:06'),(73955,215,'Gundhaur','224204',1,0,'2022-03-03 13:01:06','2022-03-03 13:01:06'),(73956,215,'Hajipur','224126',1,0,'2022-03-03 13:01:07','2022-03-03 13:01:07'),(73957,215,'Harakhpur','224121',1,0,'2022-03-03 13:01:07','2022-03-03 13:01:07'),(73958,215,'Hardoiya','224225',1,0,'2022-03-03 13:01:07','2022-03-03 13:01:07'),(73959,215,'Hariharpur Kayasthan','224120',1,0,'2022-03-03 13:01:07','2022-03-03 13:01:07'),(73960,215,'Haripur Jalalabad','224001',1,0,'2022-03-03 13:01:07','2022-03-03 13:01:07'),(73961,215,'Harringtonganj','224208',1,0,'2022-03-03 13:01:07','2022-03-03 13:01:07'),(73962,215,'Hathigo','224209',1,0,'2022-03-03 13:01:07','2022-03-03 13:01:07'),(73963,215,'Inayatnagar','224228',1,0,'2022-03-03 13:01:07','2022-03-03 13:01:07'),(73964,215,'Ismail Nagar Singra','224189',1,0,'2022-03-03 13:01:07','2022-03-03 13:01:07'),(73965,215,'Jaganpur','224188',1,0,'2022-03-03 13:01:07','2022-03-03 13:01:07'),(73966,215,'Jalapur Bhaggoo','224207',1,0,'2022-03-03 13:01:07','2022-03-03 13:01:07'),(73967,215,'Janjwara','224209',1,0,'2022-03-03 13:01:07','2022-03-03 13:01:07'),(73968,215,'Janpad Chikitsalaya','224001',1,0,'2022-03-03 13:01:07','2022-03-03 13:01:07'),(73969,215,'Jarhi','224161',1,0,'2022-03-03 13:01:07','2022-03-03 13:01:07'),(73970,215,'Jorium','224229',1,0,'2022-03-03 13:01:07','2022-03-03 13:01:07'),(73971,215,'Kadanpur','224228',1,0,'2022-03-03 13:01:07','2022-03-03 13:01:07'),(73972,215,'Kadipur','224127',1,0,'2022-03-03 13:01:07','2022-03-03 13:01:07'),(73973,215,'Kahuwa','224228',1,0,'2022-03-03 13:01:07','2022-03-03 13:01:07'),(73974,215,'Kalyanpur Keotani','224225',1,0,'2022-03-03 13:01:07','2022-03-03 13:01:07'),(73975,215,'Kandhari Bazar','224001',1,0,'2022-03-03 13:01:07','2022-03-03 13:01:07'),(73976,215,'Kannawan','224209',1,0,'2022-03-03 13:01:07','2022-03-03 13:01:07'),(73977,215,'Karampur Barsawan','224234',1,0,'2022-03-03 13:01:07','2022-03-03 13:01:07'),(73978,215,'Kareru','224126',1,0,'2022-03-03 13:01:07','2022-03-03 13:01:07'),(73979,215,'Katari','224206',1,0,'2022-03-03 13:01:07','2022-03-03 13:01:07'),(73980,215,'Kesharuabujurg','224195',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(73981,215,'Khajurahat','224206',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(73982,215,'Khanpur','224158',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(73983,215,'Khapraila Bazar','224204',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(73984,215,'Khirauni','224188',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(73985,215,'Kinauli','224228',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(73986,215,'Kinhupur','224158',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(73987,215,'Konchha','224207',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(73988,215,'Kondri','224201',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(73989,215,'Kot Sarai','224001',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(73990,215,'Kotdeeh','224158',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(73991,215,'Kotiya','224153',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(73992,215,'Kumbhi','224158',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(73993,215,'Kundurkha Khurd','224189',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(73994,215,'Kurawan','224158',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(73995,215,'Kurha','224204',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(73996,215,'Lakhauri','224182',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(73997,215,'Lalbagh (Faizabad)','224001',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(73998,215,'Lalpur','224234',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(73999,215,'Magalsi','224188',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(74000,215,'Mahawan','224201',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(74001,215,'Mahboobganj','224234',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(74002,215,'Maholi Uprahar','224126',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(74003,215,'Mahuwa','224121',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(74004,215,'Mahuwari','224234',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(74005,215,'Majnai','224158',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(74006,215,'Majnawa','224188',1,0,'2022-03-03 13:01:08','2022-03-03 13:01:08'),(74007,215,'Malethu Buzurg','224208',1,0,'2022-03-03 13:01:09','2022-03-03 13:01:09'),(74008,215,'Malethukanak','224204',1,0,'2022-03-03 13:01:09','2022-03-03 13:01:09'),(74009,215,'Mamudiha','224121',1,0,'2022-03-03 13:01:09','2022-03-03 13:01:09'),(74010,215,'Mandi Samiti','224001',1,0,'2022-03-03 13:01:09','2022-03-03 13:01:09'),(74011,215,'Manjanpur','224117',1,0,'2022-03-03 13:01:09','2022-03-03 13:01:09'),(74012,215,'Manjhanpur','224164',1,0,'2022-03-03 13:01:09','2022-03-03 13:01:09'),(74013,215,'Marui Ganeshpur','224164',1,0,'2022-03-03 13:01:09','2022-03-03 13:01:09'),(74014,215,'Marui Sahai Singh','224206',1,0,'2022-03-03 13:01:09','2022-03-03 13:01:09'),(74015,215,'Mau Yaduwanshpur','224001',1,0,'2022-03-03 13:01:09','2022-03-03 13:01:09'),(74016,215,'Mawai Kalan','224225',1,0,'2022-03-03 13:01:09','2022-03-03 13:01:09'),(74017,215,'Mawai','224117',1,0,'2022-03-03 13:01:09','2022-03-03 13:01:09'),(74018,215,'Meermau','224118',1,0,'2022-03-03 13:01:09','2022-03-03 13:01:09'),(74019,215,'Meerpur','224188',1,0,'2022-03-03 13:01:09','2022-03-03 13:01:09'),(74020,215,'Mehnauna','224127',1,0,'2022-03-03 13:01:09','2022-03-03 13:01:09'),(74021,215,'Mewapur','224153',1,0,'2022-03-03 13:01:09','2022-03-03 13:01:09'),(74022,215,'Mian Ganj','224208',1,0,'2022-03-03 13:01:09','2022-03-03 13:01:09'),(74023,215,'Milkipur','224164',1,0,'2022-03-03 13:01:09','2022-03-03 13:01:09'),(74024,215,'Moiyabegumganj','224188',1,0,'2022-03-03 13:01:09','2022-03-03 13:01:09'),(74025,215,'Motibagah','224001',1,0,'2022-03-03 13:01:09','2022-03-03 13:01:09'),(74026,215,'Motinagar (Faizabad)','224201',1,0,'2022-03-03 13:01:09','2022-03-03 13:01:09'),(74027,215,'Mubarakpur Umarni','224284',1,0,'2022-03-03 13:01:09','2022-03-03 13:01:09'),(74028,215,'Mumrej Nagar','224207',1,0,'2022-03-03 13:01:09','2022-03-03 13:01:09'),(74029,215,'Mumtaj Nagar','224001',1,0,'2022-03-03 13:01:09','2022-03-03 13:01:09'),(74030,215,'Naipura','224202',1,0,'2022-03-03 13:01:09','2022-03-03 13:01:09'),(74031,215,'Naka Muzzafra','224001',1,0,'2022-03-03 13:01:09','2022-03-03 13:01:09'),(74032,215,'Nandauli','224121',1,0,'2022-03-03 13:01:09','2022-03-03 13:01:09'),(74033,215,'Narain Ashram','224123',1,0,'2022-03-03 13:01:10','2022-03-03 13:01:10'),(74034,215,'Narainpur','224201',1,0,'2022-03-03 13:01:10','2022-03-03 13:01:10'),(74035,215,'Nawada','224182',1,0,'2022-03-03 13:01:10','2022-03-03 13:01:10'),(74036,215,'Nimari','224164',1,0,'2022-03-03 13:01:10','2022-03-03 13:01:10'),(74037,215,'Ninhiyawan Bazar','224209',1,0,'2022-03-03 13:01:10','2022-03-03 13:01:10'),(74038,215,'Niywan','224001',1,0,'2022-03-03 13:01:10','2022-03-03 13:01:10'),(74039,215,'Pachgawan','224205',1,0,'2022-03-03 13:01:10','2022-03-03 13:01:10'),(74040,215,'Paharpur','224118',1,0,'2022-03-03 13:01:10','2022-03-03 13:01:10'),(74041,215,'Palia Jagmohan Singh','224158',1,0,'2022-03-03 13:01:10','2022-03-03 13:01:10'),(74042,215,'Paliya Pratapshah','224225',1,0,'2022-03-03 13:01:10','2022-03-03 13:01:10'),(74043,215,'Palpur','224153',1,0,'2022-03-03 13:01:10','2022-03-03 13:01:10'),(74044,215,'Panditpur','224188',1,0,'2022-03-03 13:01:10','2022-03-03 13:01:10'),(74045,215,'Para Tajpur','224208',1,0,'2022-03-03 13:01:10','2022-03-03 13:01:10'),(74046,215,'Paraspur Sathra','224208',1,0,'2022-03-03 13:01:10','2022-03-03 13:01:10'),(74047,215,'Paroma','224209',1,0,'2022-03-03 13:01:10','2022-03-03 13:01:10'),(74048,215,'Patranga R.S.','224119',1,0,'2022-03-03 13:01:10','2022-03-03 13:01:10'),(74049,215,'Pilkhawan','224189',1,0,'2022-03-03 13:01:10','2022-03-03 13:01:10'),(74050,215,'Pirkhauli','224126',1,0,'2022-03-03 13:01:10','2022-03-03 13:01:10'),(74051,215,'Pithila','224229',1,0,'2022-03-03 13:01:10','2022-03-03 13:01:10'),(74052,215,'Pohpi','224204',1,0,'2022-03-03 13:01:10','2022-03-03 13:01:10'),(74053,215,'Purah','224171',1,0,'2022-03-03 13:01:10','2022-03-03 13:01:10'),(74054,215,'Raipatti','224121',1,0,'2022-03-03 13:01:10','2022-03-03 13:01:10'),(74055,215,'Ramkot (Faizabad)','224123',1,0,'2022-03-03 13:01:10','2022-03-03 13:01:10'),(74056,215,'Ramnagar Amawan Sufi','224121',1,0,'2022-03-03 13:01:10','2022-03-03 13:01:10'),(74057,215,'Ramnagar Colony','224001',1,0,'2022-03-03 13:01:10','2022-03-03 13:01:10'),(74058,215,'Ramnagar Dhaurahra','224126',1,0,'2022-03-03 13:01:10','2022-03-03 13:01:10'),(74059,215,'Rampur Sardha','224201',1,0,'2022-03-03 13:01:11','2022-03-03 13:01:11'),(74060,215,'Ranapur','224164',1,0,'2022-03-03 13:01:11','2022-03-03 13:01:11'),(74061,215,'Rani Bazar','224127',1,0,'2022-03-03 13:01:11','2022-03-03 13:01:11'),(74062,215,'Ranopali','224123',1,0,'2022-03-03 13:01:11','2022-03-03 13:01:11'),(74063,215,'Rasoolpur Lilha','224153',1,0,'2022-03-03 13:01:11','2022-03-03 13:01:11'),(74064,215,'Rauhari','224209',1,0,'2022-03-03 13:01:11','2022-03-03 13:01:11'),(74065,215,'Raunahi','224182',1,0,'2022-03-03 13:01:11','2022-03-03 13:01:11'),(74066,215,'Rautawan','224153',1,0,'2022-03-03 13:01:11','2022-03-03 13:01:11'),(74067,215,'Rauwa Lohangpur','224161',1,0,'2022-03-03 13:01:11','2022-03-03 13:01:11'),(74068,215,'Reona','224225',1,0,'2022-03-03 13:01:11','2022-03-03 13:01:11'),(74069,215,'Rudauli City','224120',1,0,'2022-03-03 13:01:11','2022-03-03 13:01:11'),(74070,215,'Rudauli','224120',1,0,'2022-03-03 13:01:11','2022-03-03 13:01:11'),(74071,215,'Ruroo','224204',1,0,'2022-03-03 13:01:11','2022-03-03 13:01:11'),(74072,215,'Sadar Bazar (Faizabad)','224001',1,0,'2022-03-03 13:01:11','2022-03-03 13:01:11'),(74073,215,'Sagar Pati Pandhula','224208',1,0,'2022-03-03 13:01:11','2022-03-03 13:01:11'),(74074,215,'Sahadatganj','224001',1,0,'2022-03-03 13:01:11','2022-03-03 13:01:11'),(74075,215,'Sahebganj (Faizabad)','224001',1,0,'2022-03-03 13:01:11','2022-03-03 13:01:11'),(74076,215,'Samda','224141',1,0,'2022-03-03 13:01:11','2022-03-03 13:01:11'),(74077,215,'Sanethu','224135',1,0,'2022-03-03 13:01:11','2022-03-03 13:01:11'),(74078,215,'Sarai Khargi','224207',1,0,'2022-03-03 13:01:11','2022-03-03 13:01:11'),(74079,215,'Saraibhanauli','224204',1,0,'2022-03-03 13:01:11','2022-03-03 13:01:11'),(74080,215,'Sarangpur','224126',1,0,'2022-03-03 13:01:11','2022-03-03 13:01:11'),(74081,215,'Sarauli','224121',1,0,'2022-03-03 13:01:11','2022-03-03 13:01:11'),(74082,215,'Sari','224127',1,0,'2022-03-03 13:01:11','2022-03-03 13:01:11'),(74083,215,'Sariyawan','224001',1,0,'2022-03-03 13:01:12','2022-03-03 13:01:12'),(74084,215,'Seewar','224126',1,0,'2022-03-03 13:01:12','2022-03-03 13:01:12'),(74085,215,'Seora','224158',1,0,'2022-03-03 13:01:12','2022-03-03 13:01:12'),(74086,215,'Shahganj (Faizabad)','224284',1,0,'2022-03-03 13:01:12','2022-03-03 13:01:12'),(74087,215,'Shahnawan','224135',1,0,'2022-03-03 13:01:12','2022-03-03 13:01:12'),(74088,215,'Shekhanpur','224158',1,0,'2022-03-03 13:01:12','2022-03-03 13:01:12'),(74089,215,'Sherpur Para','224204',1,0,'2022-03-03 13:01:12','2022-03-03 13:01:12'),(74090,215,'Shujaganj','224116',1,0,'2022-03-03 13:01:12','2022-03-03 13:01:12'),(74091,215,'Sidhari Bazar','224153',1,0,'2022-03-03 13:01:12','2022-03-03 13:01:12'),(74092,215,'Sidhauna','224229',1,0,'2022-03-03 13:01:12','2022-03-03 13:01:12'),(74093,215,'Sohawal RS','224188',1,0,'2022-03-03 13:01:12','2022-03-03 13:01:12'),(74094,215,'Sohawal Saloni','224204',1,0,'2022-03-03 13:01:12','2022-03-03 13:01:12'),(74095,215,'Sohkhawan','224127',1,0,'2022-03-03 13:01:12','2022-03-03 13:01:12'),(74096,215,'Sondhiyawan','224127',1,0,'2022-03-03 13:01:12','2022-03-03 13:01:12'),(74097,215,'Station Road Rudauli','224120',1,0,'2022-03-03 13:01:12','2022-03-03 13:01:12'),(74098,215,'Taksara','224284',1,0,'2022-03-03 13:01:12','2022-03-03 13:01:12'),(74099,215,'Taldholi','224121',1,0,'2022-03-03 13:01:12','2022-03-03 13:01:12'),(74100,215,'Tanda Sufi','224120',1,0,'2022-03-03 13:01:12','2022-03-03 13:01:12'),(74101,215,'Tandauli','224161',1,0,'2022-03-03 13:01:12','2022-03-03 13:01:12'),(74102,215,'Tarauli','224158',1,0,'2022-03-03 13:01:12','2022-03-03 13:01:12'),(74103,215,'Tendha Khurd','224164',1,0,'2022-03-03 13:01:12','2022-03-03 13:01:12'),(74104,215,'Terhi Bazar','224123',1,0,'2022-03-03 13:01:12','2022-03-03 13:01:12'),(74105,215,'Tharia Kalan','224209',1,0,'2022-03-03 13:01:12','2022-03-03 13:01:12'),(74106,215,'Toron Darab Ganj','224204',1,0,'2022-03-03 13:01:13','2022-03-03 13:01:13'),(74107,215,'Uchhahpali','224158',1,0,'2022-03-03 13:01:13','2022-03-03 13:01:13'),(74108,215,'Urwa Vaish','224208',1,0,'2022-03-03 13:01:13','2022-03-03 13:01:13'),(74109,215,'Utrethu','224234',1,0,'2022-03-03 13:01:13','2022-03-03 13:01:13'),(74110,215,'Water Works','224001',1,0,'2022-03-03 13:01:13','2022-03-03 13:01:13'),(74111,216,'Ahmadganj','209502',1,0,'2022-03-03 13:01:13','2022-03-03 13:01:13'),(74112,216,'Akbarpur','209721',1,0,'2022-03-03 13:01:13','2022-03-03 13:01:13'),(74113,216,'Aligarh (Farrukhabad)','209621',1,0,'2022-03-03 13:01:13','2022-03-03 13:01:13'),(74114,216,'Amlaiya Ashanand','209745',1,0,'2022-03-03 13:01:13','2022-03-03 13:01:13'),(74115,216,'Amratpur','209622',1,0,'2022-03-03 13:01:13','2022-03-03 13:01:13'),(74116,216,'Arjunpur','209652',1,0,'2022-03-03 13:01:13','2022-03-03 13:01:13'),(74117,216,'Ataipur','209502',1,0,'2022-03-03 13:01:13','2022-03-03 13:01:13'),(74118,216,'Awajpur','209625',1,0,'2022-03-03 13:01:13','2022-03-03 13:01:13'),(74119,216,'Babna','209501',1,0,'2022-03-03 13:01:13','2022-03-03 13:01:13'),(74120,216,'Bara Biku','209502',1,0,'2022-03-03 13:01:13','2022-03-03 13:01:13'),(74121,216,'Barai','209745',1,0,'2022-03-03 13:01:13','2022-03-03 13:01:13'),(74122,216,'Barakeshav','209651',1,0,'2022-03-03 13:01:13','2022-03-03 13:01:13'),(74123,216,'Baraun','209625',1,0,'2022-03-03 13:01:13','2022-03-03 13:01:13'),(74124,216,'Barhpur','209601',1,0,'2022-03-03 13:01:13','2022-03-03 13:01:13'),(74125,216,'Barjhala','209502',1,0,'2022-03-03 13:01:13','2022-03-03 13:01:13'),(74126,216,'Barkhera','209502',1,0,'2022-03-03 13:01:13','2022-03-03 13:01:13'),(74127,216,'Barkhiriya','209652',1,0,'2022-03-03 13:01:13','2022-03-03 13:01:13'),(74128,216,'Bazaria Farrukhabad','209625',1,0,'2022-03-03 13:01:13','2022-03-03 13:01:13'),(74129,216,'Bazaza Bazar','209601',1,0,'2022-03-03 13:01:13','2022-03-03 13:01:13'),(74130,216,'Behta Ballu','209502',1,0,'2022-03-03 13:01:13','2022-03-03 13:01:13'),(74131,216,'Bhainsiapur','209724',1,0,'2022-03-03 13:01:13','2022-03-03 13:01:13'),(74132,216,'Bharka','209601',1,0,'2022-03-03 13:01:14','2022-03-03 13:01:14'),(74133,216,'Bhatasa','209502',1,0,'2022-03-03 13:01:14','2022-03-03 13:01:14'),(74134,216,'Bhojpur','209749',1,0,'2022-03-03 13:01:14','2022-03-03 13:01:14'),(74135,216,'Bholeypur','209601',1,0,'2022-03-03 13:01:14','2022-03-03 13:01:14'),(74136,216,'Bhopat Patti','209602',1,0,'2022-03-03 13:01:14','2022-03-03 13:01:14'),(74137,216,'Bibiganj (Farrukhabad)','209625',1,0,'2022-03-03 13:01:14','2022-03-03 13:01:14'),(74138,216,'Bihar','209652',1,0,'2022-03-03 13:01:14','2022-03-03 13:01:14'),(74139,216,'Bilsari','209505',1,0,'2022-03-03 13:01:14','2022-03-03 13:01:14'),(74140,216,'Central Jail','209602',1,0,'2022-03-03 13:01:14','2022-03-03 13:01:14'),(74141,216,'Chapra','209622',1,0,'2022-03-03 13:01:14','2022-03-03 13:01:14'),(74142,216,'Chilsara','209745',1,0,'2022-03-03 13:01:14','2022-03-03 13:01:14'),(74143,216,'Chiyasar','209724',1,0,'2022-03-03 13:01:14','2022-03-03 13:01:14'),(74144,216,'Civil Lines','209601',1,0,'2022-03-03 13:01:14','2022-03-03 13:01:14'),(74145,216,'College Rd. Kaimganj','209502',1,0,'2022-03-03 13:01:14','2022-03-03 13:01:14'),(74146,216,'Danmandi','209739',1,0,'2022-03-03 13:01:14','2022-03-03 13:01:14'),(74147,216,'Daraura','209739',1,0,'2022-03-03 13:01:14','2022-03-03 13:01:14'),(74148,216,'Dhirpur','209743',1,0,'2022-03-03 13:01:14','2022-03-03 13:01:14'),(74149,216,'Distt. Jail (Farrukhabad)','209601',1,0,'2022-03-03 13:01:14','2022-03-03 13:01:14'),(74150,216,'Farrukhabad R. S.','209625',1,0,'2022-03-03 13:01:14','2022-03-03 13:01:14'),(74151,216,'Farrukhabad','209625',1,0,'2022-03-03 13:01:14','2022-03-03 13:01:14'),(74152,216,'Fatehgarh H.O','209601',1,0,'2022-03-03 13:01:14','2022-03-03 13:01:14'),(74153,216,'Fatehgarh R.S.','209601',1,0,'2022-03-03 13:01:14','2022-03-03 13:01:14'),(74154,216,'Gadanpur Deorajpur','209724',1,0,'2022-03-03 13:01:15','2022-03-03 13:01:15'),(74155,216,'Gadanpur Turra','209739',1,0,'2022-03-03 13:01:15','2022-03-03 13:01:15'),(74156,216,'Gaisinghpur','209602',1,0,'2022-03-03 13:01:15','2022-03-03 13:01:15'),(74157,216,'Gandhi','209621',1,0,'2022-03-03 13:01:15','2022-03-03 13:01:15'),(74158,216,'Ganga Darwaja Kmj.','209502',1,0,'2022-03-03 13:01:15','2022-03-03 13:01:15'),(74159,216,'Ghatiaghat','209601',1,0,'2022-03-03 13:01:15','2022-03-03 13:01:15'),(74160,216,'Gosarpur','209651',1,0,'2022-03-03 13:01:15','2022-03-03 13:01:15'),(74161,216,'Gutasi','209625',1,0,'2022-03-03 13:01:15','2022-03-03 13:01:15'),(74162,216,'Guthina','209652',1,0,'2022-03-03 13:01:15','2022-03-03 13:01:15'),(74163,216,'Hariharpur','209622',1,0,'2022-03-03 13:01:15','2022-03-03 13:01:15'),(74164,216,'Harsinghpur','209622',1,0,'2022-03-03 13:01:15','2022-03-03 13:01:15'),(74165,216,'Harsinghpur Goa','209504',1,0,'2022-03-03 13:01:15','2022-03-03 13:01:15'),(74166,216,'I.T.E.','209625',1,0,'2022-03-03 13:01:15','2022-03-03 13:01:15'),(74167,216,'J.N.V.Road','209601',1,0,'2022-03-03 13:01:15','2022-03-03 13:01:15'),(74168,216,'Jahanganj','209739',1,0,'2022-03-03 13:01:15','2022-03-03 13:01:15'),(74169,216,'Jainpur Maheshpur','209621',1,0,'2022-03-03 13:01:15','2022-03-03 13:01:15'),(74170,216,'Jaitpur','209602',1,0,'2022-03-03 13:01:15','2022-03-03 13:01:15'),(74171,216,'Jarari','209739',1,0,'2022-03-03 13:01:15','2022-03-03 13:01:15'),(74172,216,'Jhasi','209739',1,0,'2022-03-03 13:01:15','2022-03-03 13:01:15'),(74173,216,'Jyonta','209743',1,0,'2022-03-03 13:01:15','2022-03-03 13:01:15'),(74174,216,'K K W','209502',1,0,'2022-03-03 13:01:15','2022-03-03 13:01:15'),(74175,216,'K. P. Ghat','209625',1,0,'2022-03-03 13:01:15','2022-03-03 13:01:15'),(74176,216,'Kadhar','209724',1,0,'2022-03-03 13:01:15','2022-03-03 13:01:15'),(74177,216,'Kaimganj','209502',1,0,'2022-03-03 13:01:15','2022-03-03 13:01:15'),(74178,216,'Kamalganj','209724',1,0,'2022-03-03 13:01:15','2022-03-03 13:01:15'),(74179,216,'Kampil','209505',1,0,'2022-03-03 13:01:16','2022-03-03 13:01:16'),(74180,216,'Kanasi','209501',1,0,'2022-03-03 13:01:16','2022-03-03 13:01:16'),(74181,216,'Kandhrapur','209739',1,0,'2022-03-03 13:01:16','2022-03-03 13:01:16'),(74182,216,'Kanheypur','209743',1,0,'2022-03-03 13:01:16','2022-03-03 13:01:16'),(74183,216,'Kanjhiana','209602',1,0,'2022-03-03 13:01:16','2022-03-03 13:01:16'),(74184,216,'Kankapur','209621',1,0,'2022-03-03 13:01:16','2022-03-03 13:01:16'),(74185,216,'Karanpur Dutt','209622',1,0,'2022-03-03 13:01:16','2022-03-03 13:01:16'),(74186,216,'Katrauli Patti','209724',1,0,'2022-03-03 13:01:16','2022-03-03 13:01:16'),(74187,216,'Khalwara','209501',1,0,'2022-03-03 13:01:16','2022-03-03 13:01:16'),(74188,216,'Khandauli','209621',1,0,'2022-03-03 13:01:16','2022-03-03 13:01:16'),(74189,216,'Khimseypur','209743',1,0,'2022-03-03 13:01:16','2022-03-03 13:01:16'),(74190,216,'Khinmini','209504',1,0,'2022-03-03 13:01:16','2022-03-03 13:01:16'),(74191,216,'Khudaganj','209724',1,0,'2022-03-03 13:01:16','2022-03-03 13:01:16'),(74192,216,'Kila','209625',1,0,'2022-03-03 13:01:16','2022-03-03 13:01:16'),(74193,216,'Kisrauli','209503',1,0,'2022-03-03 13:01:16','2022-03-03 13:01:16'),(74194,216,'Kotwali Road Ftg.','209601',1,0,'2022-03-03 13:01:16','2022-03-03 13:01:16'),(74195,216,'Kuiyan Khera','209503',1,0,'2022-03-03 13:01:16','2022-03-03 13:01:16'),(74196,216,'Kumhraur','209622',1,0,'2022-03-03 13:01:16','2022-03-03 13:01:16'),(74197,216,'Kurar','209501',1,0,'2022-03-03 13:01:16','2022-03-03 13:01:16'),(74198,216,'Kutchery Fatehgarh','209601',1,0,'2022-03-03 13:01:16','2022-03-03 13:01:16'),(74199,216,'Lahra','209502',1,0,'2022-03-03 13:01:16','2022-03-03 13:01:16'),(74200,216,'Lakhanpur','209502',1,0,'2022-03-03 13:01:16','2022-03-03 13:01:16'),(74201,216,'Lal Sarai','209625',1,0,'2022-03-03 13:01:16','2022-03-03 13:01:16'),(74202,216,'Lindsayganj','209625',1,0,'2022-03-03 13:01:16','2022-03-03 13:01:16'),(74203,216,'Madanpur','209743',1,0,'2022-03-03 13:01:16','2022-03-03 13:01:16'),(74204,216,'Mahoi','209743',1,0,'2022-03-03 13:01:17','2022-03-03 13:01:17'),(74205,216,'Manjhana','209504',1,0,'2022-03-03 13:01:17','2022-03-03 13:01:17'),(74206,216,'Maseni','209601',1,0,'2022-03-03 13:01:17','2022-03-03 13:01:17'),(74207,216,'Mathia Devi','209625',1,0,'2022-03-03 13:01:17','2022-03-03 13:01:17'),(74208,216,'Mau Rashidabad','209502',1,0,'2022-03-03 13:01:17','2022-03-03 13:01:17'),(74209,216,'Maudha','209651',1,0,'2022-03-03 13:01:17','2022-03-03 13:01:17'),(74210,216,'Merapur','209652',1,0,'2022-03-03 13:01:17','2022-03-03 13:01:17'),(74211,216,'Mistni Bahbalpur','209505',1,0,'2022-03-03 13:01:17','2022-03-03 13:01:17'),(74212,216,'Mohamdabad','209651',1,0,'2022-03-03 13:01:17','2022-03-03 13:01:17'),(74213,216,'Musakhiria','209739',1,0,'2022-03-03 13:01:17','2022-03-03 13:01:17'),(74214,216,'Nadaura','209652',1,0,'2022-03-03 13:01:17','2022-03-03 13:01:17'),(74215,216,'Nagla Bagh Rathaura','209652',1,0,'2022-03-03 13:01:17','2022-03-03 13:01:17'),(74216,216,'Nagla Kel Champat','209652',1,0,'2022-03-03 13:01:17','2022-03-03 13:01:17'),(74217,216,'Nagla Nan','209745',1,0,'2022-03-03 13:01:17','2022-03-03 13:01:17'),(74218,216,'Narainamau','209502',1,0,'2022-03-03 13:01:17','2022-03-03 13:01:17'),(74219,216,'Nawabganj (Farrukhabad)','209501',1,0,'2022-03-03 13:01:17','2022-03-03 13:01:17'),(74220,216,'Neebkarori','209652',1,0,'2022-03-03 13:01:17','2022-03-03 13:01:17'),(74221,216,'Nehru Road (Farrukhabad)','209625',1,0,'2022-03-03 13:01:17','2022-03-03 13:01:17'),(74222,216,'Nitganja','209625',1,0,'2022-03-03 13:01:17','2022-03-03 13:01:17'),(74223,216,'Pachpukhra','209625',1,0,'2022-03-03 13:01:17','2022-03-03 13:01:17'),(74224,216,'Paithan','209502',1,0,'2022-03-03 13:01:17','2022-03-03 13:01:17'),(74225,216,'Pakhna','209652',1,0,'2022-03-03 13:01:17','2022-03-03 13:01:17'),(74226,216,'Panda Bagh','209625',1,0,'2022-03-03 13:01:17','2022-03-03 13:01:17'),(74227,216,'Pilkhana','209501',1,0,'2022-03-03 13:01:18','2022-03-03 13:01:18'),(74228,216,'Pipergaon','209625',1,0,'2022-03-03 13:01:18','2022-03-03 13:01:18'),(74229,216,'Pitaura','209502',1,0,'2022-03-03 13:01:18','2022-03-03 13:01:18'),(74230,216,'Pithnapur','209622',1,0,'2022-03-03 13:01:18','2022-03-03 13:01:18'),(74231,216,'Puthari','209501',1,0,'2022-03-03 13:01:18','2022-03-03 13:01:18'),(74232,216,'Raipur','209502',1,0,'2022-03-03 13:01:18','2022-03-03 13:01:18'),(74233,216,'Rajendra Nagar','209652',1,0,'2022-03-03 13:01:18','2022-03-03 13:01:18'),(74234,216,'Rajeypur Tappa Mandal','209739',1,0,'2022-03-03 13:01:18','2022-03-03 13:01:18'),(74235,216,'Rajipur','209724',1,0,'2022-03-03 13:01:18','2022-03-03 13:01:18'),(74236,216,'Rampur Majhgaon','209724',1,0,'2022-03-03 13:01:18','2022-03-03 13:01:18'),(74237,216,'Rashidabad Tiwariyan','209502',1,0,'2022-03-03 13:01:18','2022-03-03 13:01:18'),(74238,216,'Rasidpur Mai','209504',1,0,'2022-03-03 13:01:18','2022-03-03 13:01:18'),(74239,216,'Raukari','209505',1,0,'2022-03-03 13:01:18','2022-03-03 13:01:18'),(74240,216,'Rly. Road Kaimganj','209502',1,0,'2022-03-03 13:01:18','2022-03-03 13:01:18'),(74241,216,'Rohila','209651',1,0,'2022-03-03 13:01:18','2022-03-03 13:01:18'),(74242,216,'Roop Nagar','209652',1,0,'2022-03-03 13:01:18','2022-03-03 13:01:18'),(74243,216,'Roshnabad','209745',1,0,'2022-03-03 13:01:18','2022-03-03 13:01:18'),(74244,216,'RRC Fatehgarh','209601',1,0,'2022-03-03 13:01:18','2022-03-03 13:01:18'),(74245,216,'Rudain','209505',1,0,'2022-03-03 13:01:18','2022-03-03 13:01:18'),(74246,216,'Runi','209602',1,0,'2022-03-03 13:01:18','2022-03-03 13:01:18'),(74247,216,'Rutaul','209502',1,0,'2022-03-03 13:01:18','2022-03-03 13:01:18'),(74248,216,'Sabalpur','209621',1,0,'2022-03-03 13:01:19','2022-03-03 13:01:19'),(74249,216,'Sahaspur','209743',1,0,'2022-03-03 13:01:19','2022-03-03 13:01:19'),(74250,216,'Sakwai','209651',1,0,'2022-03-03 13:01:19','2022-03-03 13:01:19'),(74251,216,'Sankisa','209652',1,0,'2022-03-03 13:01:19','2022-03-03 13:01:19'),(74252,216,'Sarah','209601',1,0,'2022-03-03 13:01:19','2022-03-03 13:01:19'),(74253,216,'Shamsabad (Farrukhabad)','209503',1,0,'2022-03-03 13:01:19','2022-03-03 13:01:19'),(74254,216,'Shukrullapur','209504',1,0,'2022-03-03 13:01:19','2022-03-03 13:01:19'),(74255,216,'Sikanderpur Khas','209505',1,0,'2022-03-03 13:01:19','2022-03-03 13:01:19'),(74256,216,'Silsanda','209502',1,0,'2022-03-03 13:01:19','2022-03-03 13:01:19'),(74257,216,'Singanpur','209602',1,0,'2022-03-03 13:01:19','2022-03-03 13:01:19'),(74258,216,'Singhirampur','209724',1,0,'2022-03-03 13:01:19','2022-03-03 13:01:19'),(74259,216,'Sirauli','209651',1,0,'2022-03-03 13:01:19','2022-03-03 13:01:19'),(74260,216,'Sirmaura Banger','209501',1,0,'2022-03-03 13:01:19','2022-03-03 13:01:19'),(74261,216,'Sitauli','209749',1,0,'2022-03-03 13:01:19','2022-03-03 13:01:19'),(74262,216,'Siwara Khas','209505',1,0,'2022-03-03 13:01:19','2022-03-03 13:01:19'),(74263,216,'Tajpur','209651',1,0,'2022-03-03 13:01:19','2022-03-03 13:01:19'),(74264,216,'Ugarpur','209503',1,0,'2022-03-03 13:01:19','2022-03-03 13:01:19'),(74265,216,'Ugrapur Sultan Patti','209743',1,0,'2022-03-03 13:01:19','2022-03-03 13:01:19'),(74266,216,'Ukhra','209501',1,0,'2022-03-03 13:01:19','2022-03-03 13:01:19'),(74267,216,'Yaqutganj','209749',1,0,'2022-03-03 13:01:19','2022-03-03 13:01:19'),(74268,217,'Abhaipur','212665',1,0,'2022-03-03 13:01:19','2022-03-03 13:01:19'),(74269,217,'Aboonagar','212601',1,0,'2022-03-03 13:01:19','2022-03-03 13:01:19'),(74270,217,'Afoi','212653',1,0,'2022-03-03 13:01:19','2022-03-03 13:01:19'),(74271,217,'Ahewa','212651',1,0,'2022-03-03 13:01:20','2022-03-03 13:01:20'),(74272,217,'Ahmadpur Kusumbha','212641',1,0,'2022-03-03 13:01:20','2022-03-03 13:01:20'),(74273,217,'Ailai','212655',1,0,'2022-03-03 13:01:20','2022-03-03 13:01:20'),(74274,217,'Ainjhi','212620',1,0,'2022-03-03 13:01:20','2022-03-03 13:01:20'),(74275,217,'Ajamatpur','212661',1,0,'2022-03-03 13:01:20','2022-03-03 13:01:20'),(74276,217,'Akbarpur Churai','212652',1,0,'2022-03-03 13:01:20','2022-03-03 13:01:20'),(74277,217,'Alamganj','212635',1,0,'2022-03-03 13:01:20','2022-03-03 13:01:20'),(74278,217,'Alampur','212659',1,0,'2022-03-03 13:01:20','2022-03-03 13:01:20'),(74279,217,'Alampur Giriya','212655',1,0,'2022-03-03 13:01:20','2022-03-03 13:01:20'),(74280,217,'Allipur','212653',1,0,'2022-03-03 13:01:20','2022-03-03 13:01:20'),(74281,217,'Amaon','212655',1,0,'2022-03-03 13:01:20','2022-03-03 13:01:20'),(74282,217,'Amauli','212631',1,0,'2022-03-03 13:01:20','2022-03-03 13:01:20'),(74283,217,'Amilihapal','212650',1,0,'2022-03-03 13:01:20','2022-03-03 13:01:20'),(74284,217,'Andipur','212620',1,0,'2022-03-03 13:01:20','2022-03-03 13:01:20'),(74285,217,'Anjana Bhairaon','212658',1,0,'2022-03-03 13:01:20','2022-03-03 13:01:20'),(74286,217,'Arhaiya','212656',1,0,'2022-03-03 13:01:20','2022-03-03 13:01:20'),(74287,217,'Arhauli','212641',1,0,'2022-03-03 13:01:20','2022-03-03 13:01:20'),(74288,217,'Arhawal','212661',1,0,'2022-03-03 13:01:20','2022-03-03 13:01:20'),(74289,217,'Asani','212651',1,0,'2022-03-03 13:01:20','2022-03-03 13:01:20'),(74290,217,'Ashok Nagar Bharsawan','212664',1,0,'2022-03-03 13:01:20','2022-03-03 13:01:20'),(74291,217,'Asother','212620',1,0,'2022-03-03 13:01:20','2022-03-03 13:01:20'),(74292,217,'Aung','212665',1,0,'2022-03-03 13:01:21','2022-03-03 13:01:21'),(74293,217,'Aurai','212622',1,0,'2022-03-03 13:01:21','2022-03-03 13:01:21'),(74294,217,'Ayah','212601',1,0,'2022-03-03 13:01:21','2022-03-03 13:01:21'),(74295,217,'Bahrampur','212622',1,0,'2022-03-03 13:01:21','2022-03-03 13:01:21'),(74296,217,'Bahua','212663',1,0,'2022-03-03 13:01:21','2022-03-03 13:01:21'),(74297,217,'Baigaon','212653',1,0,'2022-03-03 13:01:21','2022-03-03 13:01:21'),(74298,217,'Bakewar Sarai','212657',1,0,'2022-03-03 13:01:21','2022-03-03 13:01:21'),(74299,217,'Bamharauli','212641',1,0,'2022-03-03 13:01:21','2022-03-03 13:01:21'),(74300,217,'Banarsi','212601',1,0,'2022-03-03 13:01:21','2022-03-03 13:01:21'),(74301,217,'Bandipur','212652',1,0,'2022-03-03 13:01:21','2022-03-03 13:01:21'),(74302,217,'Banthara','212659',1,0,'2022-03-03 13:01:21','2022-03-03 13:01:21'),(74303,217,'Bara','212657',1,0,'2022-03-03 13:01:21','2022-03-03 13:01:21'),(74304,217,'Baragaon','212663',1,0,'2022-03-03 13:01:21','2022-03-03 13:01:21'),(74305,217,'Baraipur','212656',1,0,'2022-03-03 13:01:21','2022-03-03 13:01:21'),(74306,217,'Baranpur','212601',1,0,'2022-03-03 13:01:21','2022-03-03 13:01:21'),(74307,217,'Barigawan','212657',1,0,'2022-03-03 13:01:21','2022-03-03 13:01:21'),(74308,217,'Basant Khera','212657',1,0,'2022-03-03 13:01:21','2022-03-03 13:01:21'),(74309,217,'Baswa','212655',1,0,'2022-03-03 13:01:21','2022-03-03 13:01:21'),(74310,217,'Belain','212641',1,0,'2022-03-03 13:01:21','2022-03-03 13:01:21'),(74311,217,'Beonti','212658',1,0,'2022-03-03 13:01:21','2022-03-03 13:01:21'),(74312,217,'Beragarhiwa','212601',1,0,'2022-03-03 13:01:21','2022-03-03 13:01:21'),(74313,217,'Berraon','212620',1,0,'2022-03-03 13:01:21','2022-03-03 13:01:21'),(74314,217,'Berui','212620',1,0,'2022-03-03 13:01:22','2022-03-03 13:01:22'),(74315,217,'Bhadba','212664',1,0,'2022-03-03 13:01:22','2022-03-03 13:01:22'),(74316,217,'Bhaisauli','212657',1,0,'2022-03-03 13:01:22','2022-03-03 13:01:22'),(74317,217,'Bhakharana','212655',1,0,'2022-03-03 13:01:22','2022-03-03 13:01:22'),(74318,217,'Bhitaura','212601',1,0,'2022-03-03 13:01:22','2022-03-03 13:01:22'),(74319,217,'Bijauli','212657',1,0,'2022-03-03 13:01:22','2022-03-03 13:01:22'),(74320,217,'Bijuri','212657',1,0,'2022-03-03 13:01:22','2022-03-03 13:01:22'),(74321,217,'Bilanda','212645',1,0,'2022-03-03 13:01:22','2022-03-03 13:01:22'),(74322,217,'Bilandpur','212601',1,0,'2022-03-03 13:01:22','2022-03-03 13:01:22'),(74323,217,'Bindki','212635',1,0,'2022-03-03 13:01:22','2022-03-03 13:01:22'),(74324,217,'Birnai','212631',1,0,'2022-03-03 13:01:22','2022-03-03 13:01:22'),(74325,217,'Budhramau','212621',1,0,'2022-03-03 13:01:22','2022-03-03 13:01:22'),(74326,217,'Budwan','212655',1,0,'2022-03-03 13:01:22','2022-03-03 13:01:22'),(74327,217,'Burhwan','212631',1,0,'2022-03-03 13:01:22','2022-03-03 13:01:22'),(74328,217,'Chak Korra Sadat','212622',1,0,'2022-03-03 13:01:22','2022-03-03 13:01:22'),(74329,217,'Chakas Karan','212663',1,0,'2022-03-03 13:01:22','2022-03-03 13:01:22'),(74330,217,'Chakhendi','212664',1,0,'2022-03-03 13:01:22','2022-03-03 13:01:22'),(74331,217,'Chandapur','212658',1,0,'2022-03-03 13:01:22','2022-03-03 13:01:22'),(74332,217,'Chandiyana','212601',1,0,'2022-03-03 13:01:22','2022-03-03 13:01:22'),(74333,217,'Chandpur','212631',1,0,'2022-03-03 13:01:22','2022-03-03 13:01:22'),(74334,217,'Chheolaha','212650',1,0,'2022-03-03 13:01:22','2022-03-03 13:01:22'),(74335,217,'Chhichha','212635',1,0,'2022-03-03 13:01:22','2022-03-03 13:01:22'),(74336,217,'Chhichhni','212621',1,0,'2022-03-03 13:01:22','2022-03-03 13:01:22'),(74337,217,'Chitauli','212655',1,0,'2022-03-03 13:01:22','2022-03-03 13:01:22'),(74338,217,'Chitishapur','212651',1,0,'2022-03-03 13:01:23','2022-03-03 13:01:23'),(74339,217,'Churiyani','212601',1,0,'2022-03-03 13:01:23','2022-03-03 13:01:23'),(74340,217,'Damapur','212601',1,0,'2022-03-03 13:01:23','2022-03-03 13:01:23'),(74341,217,'Dampur','212641',1,0,'2022-03-03 13:01:23','2022-03-03 13:01:23'),(74342,217,'Dapsaura','212631',1,0,'2022-03-03 13:01:23','2022-03-03 13:01:23'),(74343,217,'Datauli','212663',1,0,'2022-03-03 13:01:23','2022-03-03 13:01:23'),(74344,217,'Dawatpur','212664',1,0,'2022-03-03 13:01:23','2022-03-03 13:01:23'),(74345,217,'Dayalnagar','212631',1,0,'2022-03-03 13:01:23','2022-03-03 13:01:23'),(74346,217,'Deegh','212635',1,0,'2022-03-03 13:01:23','2022-03-03 13:01:23'),(74347,217,'Dendasai','212656',1,0,'2022-03-03 13:01:23','2022-03-03 13:01:23'),(74348,217,'Deolan','212621',1,0,'2022-03-03 13:01:23','2022-03-03 13:01:23'),(74349,217,'Deomai','212657',1,0,'2022-03-03 13:01:23','2022-03-03 13:01:23'),(74350,217,'Deori Bujurg','212657',1,0,'2022-03-03 13:01:23','2022-03-03 13:01:23'),(74351,217,'Devrar','212641',1,0,'2022-03-03 13:01:23','2022-03-03 13:01:23'),(74352,217,'Dhakauli','212601',1,0,'2022-03-03 13:01:23','2022-03-03 13:01:23'),(74353,217,'Dhamina Khurd','212631',1,0,'2022-03-03 13:01:23','2022-03-03 13:01:23'),(74354,217,'Dharmpur Saton','212622',1,0,'2022-03-03 13:01:23','2022-03-03 13:01:23'),(74355,217,'Dhata','212641',1,0,'2022-03-03 13:01:23','2022-03-03 13:01:23'),(74356,217,'Digharua','212657',1,0,'2022-03-03 13:01:23','2022-03-03 13:01:23'),(74357,217,'Dugrai','212663',1,0,'2022-03-03 13:01:23','2022-03-03 13:01:23'),(74358,217,'Ekdala','212658',1,0,'2022-03-03 13:01:23','2022-03-03 13:01:23'),(74359,217,'Erayan','212653',1,0,'2022-03-03 13:01:23','2022-03-03 13:01:23'),(74360,217,'Farshi','212651',1,0,'2022-03-03 13:01:24','2022-03-03 13:01:24'),(74361,217,'Fatehpur City','212601',1,0,'2022-03-03 13:01:24','2022-03-03 13:01:24'),(74362,217,'Fatehpur Court','212601',1,0,'2022-03-03 13:01:24','2022-03-03 13:01:24'),(74363,217,'Fatehpur H.O','212601',1,0,'2022-03-03 13:01:24','2022-03-03 13:01:24'),(74364,217,'Fatehpur Tekari','212655',1,0,'2022-03-03 13:01:24','2022-03-03 13:01:24'),(74365,217,'Fatehpur Town','212601',1,0,'2022-03-03 13:01:24','2022-03-03 13:01:24'),(74366,217,'Gambhari','212621',1,0,'2022-03-03 13:01:24','2022-03-03 13:01:24'),(74367,217,'Garha','212658',1,0,'2022-03-03 13:01:24','2022-03-03 13:01:24'),(74368,217,'Gaura','212631',1,0,'2022-03-03 13:01:24','2022-03-03 13:01:24'),(74369,217,'Gaura Bujurg','212650',1,0,'2022-03-03 13:01:24','2022-03-03 13:01:24'),(74370,217,'Gauri Aura','212631',1,0,'2022-03-03 13:01:24','2022-03-03 13:01:24'),(74371,217,'Gauri','212661',1,0,'2022-03-03 13:01:24','2022-03-03 13:01:24'),(74372,217,'Gharwasipur','212656',1,0,'2022-03-03 13:01:24','2022-03-03 13:01:24'),(74373,217,'Ghazipur (Fatehpur)','212621',1,0,'2022-03-03 13:01:24','2022-03-03 13:01:24'),(74374,217,'Ghoori Bujurg','212622',1,0,'2022-03-03 13:01:24','2022-03-03 13:01:24'),(74375,217,'Gohrari','212631',1,0,'2022-03-03 13:01:24','2022-03-03 13:01:24'),(74376,217,'Gugauli','212665',1,0,'2022-03-03 13:01:24','2022-03-03 13:01:24'),(74377,217,'Guneer','212664',1,0,'2022-03-03 13:01:24','2022-03-03 13:01:24'),(74378,217,'Hardon','212655',1,0,'2022-03-03 13:01:24','2022-03-03 13:01:24'),(74379,217,'Hariharganj','212601',1,0,'2022-03-03 13:01:24','2022-03-03 13:01:24'),(74380,217,'Hasaupur','212650',1,0,'2022-03-03 13:01:24','2022-03-03 13:01:24'),(74381,217,'Haswa','212645',1,0,'2022-03-03 13:01:24','2022-03-03 13:01:24'),(74382,217,'Hathgaon','212652',1,0,'2022-03-03 13:01:24','2022-03-03 13:01:24'),(74383,217,'Husainganj (Fatehpur)','212651',1,0,'2022-03-03 13:01:25','2022-03-03 13:01:25'),(74384,217,'Ijura Bujurg','212653',1,0,'2022-03-03 13:01:25','2022-03-03 13:01:25'),(74385,217,'Itaily','212652',1,0,'2022-03-03 13:01:25','2022-03-03 13:01:25'),(74386,217,'Jafarganj','212657',1,0,'2022-03-03 13:01:25','2022-03-03 13:01:25'),(74387,217,'Jafrabad','212635',1,0,'2022-03-03 13:01:25','2022-03-03 13:01:25'),(74388,217,'Jahangirnagar Gahura','212656',1,0,'2022-03-03 13:01:25','2022-03-03 13:01:25'),(74389,217,'Jairampur','212656',1,0,'2022-03-03 13:01:25','2022-03-03 13:01:25'),(74390,217,'Jam','212641',1,0,'2022-03-03 13:01:25','2022-03-03 13:01:25'),(74391,217,'Jamraon','212654',1,0,'2022-03-03 13:01:25','2022-03-03 13:01:25'),(74392,217,'Jarauli','212620',1,0,'2022-03-03 13:01:25','2022-03-03 13:01:25'),(74393,217,'Jonihan','212635',1,0,'2022-03-03 13:01:25','2022-03-03 13:01:25'),(74394,217,'Kalyanpur','212664',1,0,'2022-03-03 13:01:25','2022-03-03 13:01:25'),(74395,217,'Kalyanpur Kachrauli','212641',1,0,'2022-03-03 13:01:25','2022-03-03 13:01:25'),(74396,217,'Kandhi','212601',1,0,'2022-03-03 13:01:25','2022-03-03 13:01:25'),(74397,217,'Kandhiya','212620',1,0,'2022-03-03 13:01:25','2022-03-03 13:01:25'),(74398,217,'Kapil Kalan','212659',1,0,'2022-03-03 13:01:25','2022-03-03 13:01:25'),(74399,217,'Karmon','212650',1,0,'2022-03-03 13:01:25','2022-03-03 13:01:25'),(74400,217,'Kasba Sohan','212655',1,0,'2022-03-03 13:01:25','2022-03-03 13:01:25'),(74401,217,'Kaseruwa','212652',1,0,'2022-03-03 13:01:25','2022-03-03 13:01:25'),(74402,217,'Katoghan','212655',1,0,'2022-03-03 13:01:25','2022-03-03 13:01:25'),(74403,217,'Katra Kasimpur','212652',1,0,'2022-03-03 13:01:25','2022-03-03 13:01:25'),(74404,217,'Kaundar','212620',1,0,'2022-03-03 13:01:26','2022-03-03 13:01:26'),(74405,217,'Kaunh','212631',1,0,'2022-03-03 13:01:26','2022-03-03 13:01:26'),(74406,217,'Khadra','212665',1,0,'2022-03-03 13:01:26','2022-03-03 13:01:26'),(74407,217,'Khaga','212655',1,0,'2022-03-03 13:01:26','2022-03-03 13:01:26'),(74408,217,'Khaga Town','212655',1,0,'2022-03-03 13:01:26','2022-03-03 13:01:26'),(74409,217,'Khajuha','212657',1,0,'2022-03-03 13:01:26','2022-03-03 13:01:26'),(74410,217,'Khakhreru','212656',1,0,'2022-03-03 13:01:26','2022-03-03 13:01:26'),(74411,217,'Kharai','212655',1,0,'2022-03-03 13:01:26','2022-03-03 13:01:26'),(74412,217,'Kharsendwa','212641',1,0,'2022-03-03 13:01:26','2022-03-03 13:01:26'),(74413,217,'Khas Mau','212622',1,0,'2022-03-03 13:01:26','2022-03-03 13:01:26'),(74414,217,'Khesahan','212621',1,0,'2022-03-03 13:01:26','2022-03-03 13:01:26'),(74415,217,'Khotila Sijauli','212657',1,0,'2022-03-03 13:01:26','2022-03-03 13:01:26'),(74416,217,'Khuta','212635',1,0,'2022-03-03 13:01:26','2022-03-03 13:01:26'),(74417,217,'Kishandaspur','212654',1,0,'2022-03-03 13:01:26','2022-03-03 13:01:26'),(74418,217,'Kishanpur (Fatehpur)','212658',1,0,'2022-03-03 13:01:26','2022-03-03 13:01:26'),(74419,217,'Kora Jahanabad','212659',1,0,'2022-03-03 13:01:26','2022-03-03 13:01:26'),(74420,217,'Korai','212601',1,0,'2022-03-03 13:01:26','2022-03-03 13:01:26'),(74421,217,'Korra Kanak','212661',1,0,'2022-03-03 13:01:26','2022-03-03 13:01:26'),(74422,217,'Korsam','212665',1,0,'2022-03-03 13:01:26','2022-03-03 13:01:26'),(74423,217,'Kot','212656',1,0,'2022-03-03 13:01:27','2022-03-03 13:01:27'),(74424,217,'Kotiya','212664',1,0,'2022-03-03 13:01:27','2022-03-03 13:01:27'),(74425,217,'Kulli','212656',1,0,'2022-03-03 13:01:27','2022-03-03 13:01:27'),(74426,217,'Kumbhipur','212655',1,0,'2022-03-03 13:01:27','2022-03-03 13:01:27'),(74427,217,'Kusumbhi','212621',1,0,'2022-03-03 13:01:27','2022-03-03 13:01:27'),(74428,217,'Ladigaon','212663',1,0,'2022-03-03 13:01:27','2022-03-03 13:01:27'),(74429,217,'Lalauli','212661',1,0,'2022-03-03 13:01:27','2022-03-03 13:01:27'),(74430,217,'Lalpur','212635',1,0,'2022-03-03 13:01:27','2022-03-03 13:01:27'),(74431,217,'Lamehata','212621',1,0,'2022-03-03 13:01:27','2022-03-03 13:01:27'),(74432,217,'Lateefpur','212645',1,0,'2022-03-03 13:01:27','2022-03-03 13:01:27'),(74433,217,'Laugaon','212621',1,0,'2022-03-03 13:01:27','2022-03-03 13:01:27'),(74434,217,'Madokipur','212665',1,0,'2022-03-03 13:01:27','2022-03-03 13:01:27'),(74435,217,'Mahakhera','212661',1,0,'2022-03-03 13:01:27','2022-03-03 13:01:27'),(74436,217,'Mahana','212661',1,0,'2022-03-03 13:01:27','2022-03-03 13:01:27'),(74437,217,'Mahoi','212645',1,0,'2022-03-03 13:01:27','2022-03-03 13:01:27'),(74438,217,'Mahraha','212635',1,0,'2022-03-03 13:01:27','2022-03-03 13:01:27'),(74439,217,'Makarandpur','212631',1,0,'2022-03-03 13:01:27','2022-03-03 13:01:27'),(74440,217,'Malaon','212622',1,0,'2022-03-03 13:01:27','2022-03-03 13:01:27'),(74441,217,'Malookbari','212658',1,0,'2022-03-03 13:01:27','2022-03-03 13:01:27'),(74442,217,'Malwan R.S.','212664',1,0,'2022-03-03 13:01:27','2022-03-03 13:01:27'),(74443,217,'Malwan Town','212664',1,0,'2022-03-03 13:01:27','2022-03-03 13:01:27'),(74444,217,'Manawan','212620',1,0,'2022-03-03 13:01:27','2022-03-03 13:01:27'),(74445,217,'Manda Sarai','212622',1,0,'2022-03-03 13:01:27','2022-03-03 13:01:27'),(74446,217,'Mandraon','212635',1,0,'2022-03-03 13:01:27','2022-03-03 13:01:27'),(74447,217,'Mandwan','212653',1,0,'2022-03-03 13:01:27','2022-03-03 13:01:27'),(74448,217,'Mauhar','212665',1,0,'2022-03-03 13:01:28','2022-03-03 13:01:28'),(74449,217,'Maujmabad','212651',1,0,'2022-03-03 13:01:28','2022-03-03 13:01:28'),(74450,217,'Mawai','212651',1,0,'2022-03-03 13:01:28','2022-03-03 13:01:28'),(74451,217,'Mawaiya','212621',1,0,'2022-03-03 13:01:28','2022-03-03 13:01:28'),(74452,217,'Meoli','212601',1,0,'2022-03-03 13:01:28','2022-03-03 13:01:28'),(74453,217,'Mirai','212665',1,0,'2022-03-03 13:01:28','2022-03-03 13:01:28'),(74454,217,'Missi','212657',1,0,'2022-03-03 13:01:28','2022-03-03 13:01:28'),(74455,217,'Mohamdabad','212652',1,0,'2022-03-03 13:01:28','2022-03-03 13:01:28'),(74456,217,'Mohammad Pur Gaunti','212653',1,0,'2022-03-03 13:01:28','2022-03-03 13:01:28'),(74457,217,'Muraon','212622',1,0,'2022-03-03 13:01:28','2022-03-03 13:01:28'),(74458,217,'Musafa','212657',1,0,'2022-03-03 13:01:28','2022-03-03 13:01:28'),(74459,217,'Muttaur','212663',1,0,'2022-03-03 13:01:28','2022-03-03 13:01:28'),(74460,217,'Naraicha','212657',1,0,'2022-03-03 13:01:28','2022-03-03 13:01:28'),(74461,217,'Naraini','212622',1,0,'2022-03-03 13:01:28','2022-03-03 13:01:28'),(74462,217,'Narauli','212658',1,0,'2022-03-03 13:01:28','2022-03-03 13:01:28'),(74463,217,'Narsinghpur Kabraha','212641',1,0,'2022-03-03 13:01:28','2022-03-03 13:01:28'),(74464,217,'Naugaon','212654',1,0,'2022-03-03 13:01:28','2022-03-03 13:01:28'),(74465,217,'Nizamuddinpur','212650',1,0,'2022-03-03 13:01:28','2022-03-03 13:01:28'),(74466,217,'Padhara','212665',1,0,'2022-03-03 13:01:28','2022-03-03 13:01:28'),(74467,217,'Paharpur','212658',1,0,'2022-03-03 13:01:28','2022-03-03 13:01:28'),(74468,217,'Paigamberpur','212652',1,0,'2022-03-03 13:01:28','2022-03-03 13:01:28'),(74469,217,'Paina Khurd','212621',1,0,'2022-03-03 13:01:28','2022-03-03 13:01:28'),(74470,217,'Pallawan','212641',1,0,'2022-03-03 13:01:28','2022-03-03 13:01:28'),(74471,217,'Pamrauli','212621',1,0,'2022-03-03 13:01:28','2022-03-03 13:01:28'),(74472,217,'Patti','212652',1,0,'2022-03-03 13:01:29','2022-03-03 13:01:29'),(74473,217,'Pauli','212655',1,0,'2022-03-03 13:01:29','2022-03-03 13:01:29'),(74474,217,'Purain','212655',1,0,'2022-03-03 13:01:29','2022-03-03 13:01:29'),(74475,217,'Purani Bindki','212635',1,0,'2022-03-03 13:01:29','2022-03-03 13:01:29'),(74476,217,'Raipur Bhasraul','212658',1,0,'2022-03-03 13:01:29','2022-03-03 13:01:29'),(74477,217,'Raipur Muwari','212652',1,0,'2022-03-03 13:01:29','2022-03-03 13:01:29'),(74478,217,'Ram Nagar Kauhan','212620',1,0,'2022-03-03 13:01:29','2022-03-03 13:01:29'),(74479,217,'Ramwan','212601',1,0,'2022-03-03 13:01:29','2022-03-03 13:01:29'),(74480,217,'Rari','212658',1,0,'2022-03-03 13:01:29','2022-03-03 13:01:29'),(74481,217,'Rari Bujurg','212664',1,0,'2022-03-03 13:01:29','2022-03-03 13:01:29'),(74482,217,'Rewari Bujurg','212664',1,0,'2022-03-03 13:01:29','2022-03-03 13:01:29'),(74483,217,'Rithwa Awajipur','212631',1,0,'2022-03-03 13:01:29','2022-03-03 13:01:29'),(74484,217,'Rithwan Bhairwan','212620',1,0,'2022-03-03 13:01:29','2022-03-03 13:01:29'),(74485,217,'Sahjahanpur Selraha','212622',1,0,'2022-03-03 13:01:29','2022-03-03 13:01:29'),(74486,217,'Saibasi','212663',1,0,'2022-03-03 13:01:29','2022-03-03 13:01:29'),(74487,217,'Saidpur Pachmai','212656',1,0,'2022-03-03 13:01:29','2022-03-03 13:01:29'),(74488,217,'Salempur','212650',1,0,'2022-03-03 13:01:29','2022-03-03 13:01:29'),(74489,217,'Salhepur','212631',1,0,'2022-03-03 13:01:29','2022-03-03 13:01:29'),(74490,217,'Sangaon','212601',1,0,'2022-03-03 13:01:29','2022-03-03 13:01:29'),(74491,217,'Saraisaba','212652',1,0,'2022-03-03 13:01:29','2022-03-03 13:01:29'),(74492,217,'Sarauli','212658',1,0,'2022-03-03 13:01:29','2022-03-03 13:01:29'),(74493,217,'Sarkandi','212658',1,0,'2022-03-03 13:01:29','2022-03-03 13:01:29'),(74494,217,'Sarkee','212621',1,0,'2022-03-03 13:01:29','2022-03-03 13:01:29'),(74495,217,'Sawant','212622',1,0,'2022-03-03 13:01:29','2022-03-03 13:01:29'),(74496,217,'Selawan','212657',1,0,'2022-03-03 13:01:29','2022-03-03 13:01:29'),(74497,217,'Semramanapur','212652',1,0,'2022-03-03 13:01:29','2022-03-03 13:01:29'),(74498,217,'Sewramau','212621',1,0,'2022-03-03 13:01:30','2022-03-03 13:01:30'),(74499,217,'Shadipur','212665',1,0,'2022-03-03 13:01:30','2022-03-03 13:01:30'),(74500,217,'Shah','212601',1,0,'2022-03-03 13:01:30','2022-03-03 13:01:30'),(74501,217,'Shahpur','212652',1,0,'2022-03-03 13:01:30','2022-03-03 13:01:30'),(74502,217,'Shankha','212621',1,0,'2022-03-03 13:01:30','2022-03-03 13:01:30'),(74503,217,'Sheorajpur','212665',1,0,'2022-03-03 13:01:30','2022-03-03 13:01:30'),(74504,217,'Sidhaon','212663',1,0,'2022-03-03 13:01:30','2022-03-03 13:01:30'),(74505,217,'Silmi','212655',1,0,'2022-03-03 13:01:30','2022-03-03 13:01:30'),(74506,217,'Sithaura','212652',1,0,'2022-03-03 13:01:30','2022-03-03 13:01:30'),(74507,217,'Sothrapur','212656',1,0,'2022-03-03 13:01:30','2022-03-03 13:01:30'),(74508,217,'Suketi','212621',1,0,'2022-03-03 13:01:30','2022-03-03 13:01:30'),(74509,217,'Sultangarh','212657',1,0,'2022-03-03 13:01:30','2022-03-03 13:01:30'),(74510,217,'Sultanpurghosh','212653',1,0,'2022-03-03 13:01:30','2022-03-03 13:01:30'),(74511,217,'Tapani','212663',1,0,'2022-03-03 13:01:30','2022-03-03 13:01:30'),(74512,217,'Tarapur','212664',1,0,'2022-03-03 13:01:30','2022-03-03 13:01:30'),(74513,217,'Teliyani','212601',1,0,'2022-03-03 13:01:30','2022-03-03 13:01:30'),(74514,217,'Teni','212655',1,0,'2022-03-03 13:01:30','2022-03-03 13:01:30'),(74515,217,'Tesahi Bujurg','212655',1,0,'2022-03-03 13:01:30','2022-03-03 13:01:30'),(74516,217,'Thariyaon','212622',1,0,'2022-03-03 13:01:30','2022-03-03 13:01:30'),(74517,217,'Tikar','212620',1,0,'2022-03-03 13:01:30','2022-03-03 13:01:30'),(74518,217,'Tyonja','212655',1,0,'2022-03-03 13:01:30','2022-03-03 13:01:30'),(74519,217,'Ukathu','212655',1,0,'2022-03-03 13:01:30','2022-03-03 13:01:30'),(74520,217,'Umari','212601',1,0,'2022-03-03 13:01:30','2022-03-03 13:01:30'),(74521,217,'Vijaeepur','212655',1,0,'2022-03-03 13:01:30','2022-03-03 13:01:30'),(74522,217,'Yauhan','212650',1,0,'2022-03-03 13:01:30','2022-03-03 13:01:30'),(74523,218,'Kaytha','207301',1,0,'2022-03-03 13:01:31','2022-03-03 13:01:31'),(74524,218,'A G M Bhawali','283151',1,0,'2022-03-03 13:01:31','2022-03-03 13:01:31'),(74525,218,'Akalabad Hasanpur','283203',1,0,'2022-03-03 13:01:31','2022-03-03 13:01:31'),(74526,218,'Akbarpur Kutukpur','283136',1,0,'2022-03-03 13:01:31','2022-03-03 13:01:31'),(74527,218,'Alhadadpur','283203',1,0,'2022-03-03 13:01:31','2022-03-03 13:01:31'),(74528,218,'Ali Nagar Kenjra','283203',1,0,'2022-03-03 13:01:31','2022-03-03 13:01:31'),(74529,218,'Amaur Nagla Jeevan','283151',1,0,'2022-03-03 13:01:31','2022-03-03 13:01:31'),(74530,218,'Asafabad','283203',1,0,'2022-03-03 13:01:31','2022-03-03 13:01:31'),(74531,218,'Asan','283203',1,0,'2022-03-03 13:01:31','2022-03-03 13:01:31'),(74532,218,'Asua','283141',1,0,'2022-03-03 13:01:31','2022-03-03 13:01:31'),(74533,218,'Bachhagaon','283204',1,0,'2022-03-03 13:01:31','2022-03-03 13:01:31'),(74534,218,'Bachhela Bachheli','283142',1,0,'2022-03-03 13:01:31','2022-03-03 13:01:31'),(74535,218,'Baghai','283103',1,0,'2022-03-03 13:01:31','2022-03-03 13:01:31'),(74536,218,'Bahat','283136',1,0,'2022-03-03 13:01:31','2022-03-03 13:01:31'),(74537,218,'Balipur','283142',1,0,'2022-03-03 13:01:31','2022-03-03 13:01:31'),(74538,218,'Banbara','283136',1,0,'2022-03-03 13:01:31','2022-03-03 13:01:31'),(74539,218,'Bara Bazar Shikohabad','283135',1,0,'2022-03-03 13:01:31','2022-03-03 13:01:31'),(74540,218,'Bara Gaon','283130',1,0,'2022-03-03 13:01:31','2022-03-03 13:01:31'),(74541,218,'Bartara','283206',1,0,'2022-03-03 13:01:31','2022-03-03 13:01:31'),(74542,218,'Basai Mohammadpur','283203',1,0,'2022-03-03 13:01:31','2022-03-03 13:01:31'),(74543,218,'Bhadan','283142',1,0,'2022-03-03 13:01:31','2022-03-03 13:01:31'),(74544,218,'Bhadana','283152',1,0,'2022-03-03 13:01:31','2022-03-03 13:01:31'),(74545,218,'Bhagner','283152',1,0,'2022-03-03 13:01:31','2022-03-03 13:01:31'),(74546,218,'Bharaul','283203',1,0,'2022-03-03 13:01:32','2022-03-03 13:01:32'),(74547,218,'Bilhena','283203',1,0,'2022-03-03 13:01:32','2022-03-03 13:01:32'),(74548,218,'Chandwar','283203',1,0,'2022-03-03 13:01:32','2022-03-03 13:01:32'),(74549,218,'Chulhawali','283204',1,0,'2022-03-03 13:01:32','2022-03-03 13:01:32'),(74550,218,'Collectorate -firozabad','283205',1,0,'2022-03-03 13:01:32','2022-03-03 13:01:32'),(74551,218,'Dakhinara','283135',1,0,'2022-03-03 13:01:32','2022-03-03 13:01:32'),(74552,218,'Datawali','283203',1,0,'2022-03-03 13:01:32','2022-03-03 13:01:32'),(74553,218,'Dev Kherha','283204',1,0,'2022-03-03 13:01:32','2022-03-03 13:01:32'),(74554,218,'Dhatari','283135',1,0,'2022-03-03 13:01:32','2022-03-03 13:01:32'),(74555,218,'Dheerpura','283204',1,0,'2022-03-03 13:01:32','2022-03-03 13:01:32'),(74556,218,'Dodsa Mohammadpur','283206',1,0,'2022-03-03 13:01:32','2022-03-03 13:01:32'),(74557,218,'Dokeli','283203',1,0,'2022-03-03 13:01:32','2022-03-03 13:01:32'),(74558,218,'Dolupura','283203',1,0,'2022-03-03 13:01:32','2022-03-03 13:01:32'),(74559,218,'Eka','283152',1,0,'2022-03-03 13:01:32','2022-03-03 13:01:32'),(74560,218,'Farida','283152',1,0,'2022-03-03 13:01:32','2022-03-03 13:01:32'),(74561,218,'Firozabad Bazar','283203',1,0,'2022-03-03 13:01:32','2022-03-03 13:01:32'),(74562,218,'Firozabad H.O','283203',1,0,'2022-03-03 13:01:32','2022-03-03 13:01:32'),(74563,218,'Gagani','283206',1,0,'2022-03-03 13:01:32','2022-03-03 13:01:32'),(74564,218,'Garhsan','283142',1,0,'2022-03-03 13:01:32','2022-03-03 13:01:32'),(74565,218,'Gazipur','283203',1,0,'2022-03-03 13:01:32','2022-03-03 13:01:32'),(74566,218,'Ghaghau','283141',1,0,'2022-03-03 13:01:32','2022-03-03 13:01:32'),(74567,218,'Gonchh','283203',1,0,'2022-03-03 13:01:32','2022-03-03 13:01:32'),(74568,218,'Gondai','283204',1,0,'2022-03-03 13:01:32','2022-03-03 13:01:32'),(74569,218,'Gopalpur','283152',1,0,'2022-03-03 13:01:32','2022-03-03 13:01:32'),(74570,218,'Gudaun','283203',1,0,'2022-03-03 13:01:33','2022-03-03 13:01:33'),(74571,218,'Gurha','283141',1,0,'2022-03-03 13:01:33','2022-03-03 13:01:33'),(74572,218,'Gwari Nagla Singhi','283204',1,0,'2022-03-03 13:01:33','2022-03-03 13:01:33'),(74573,218,'Harha','283141',1,0,'2022-03-03 13:01:33','2022-03-03 13:01:33'),(74574,218,'Himmatpur','283204',1,0,'2022-03-03 13:01:33','2022-03-03 13:01:33'),(74575,218,'Hirangaon','283103',1,0,'2022-03-03 13:01:33','2022-03-03 13:01:33'),(74576,218,'Husainpur','283103',1,0,'2022-03-03 13:01:33','2022-03-03 13:01:33'),(74577,218,'I L C Shikohabad','283141',1,0,'2022-03-03 13:01:33','2022-03-03 13:01:33'),(74578,218,'Jajumai','283145',1,0,'2022-03-03 13:01:33','2022-03-03 13:01:33'),(74579,218,'Jakhai','283203',1,0,'2022-03-03 13:01:33','2022-03-03 13:01:33'),(74580,218,'Jalalpur','283203',1,0,'2022-03-03 13:01:33','2022-03-03 13:01:33'),(74581,218,'Jarakhi','283103',1,0,'2022-03-03 13:01:33','2022-03-03 13:01:33'),(74582,218,'Jarauli Kalan','283203',1,0,'2022-03-03 13:01:33','2022-03-03 13:01:33'),(74583,218,'Jasrana','283136',1,0,'2022-03-03 13:01:33','2022-03-03 13:01:33'),(74584,218,'Jatau','283206',1,0,'2022-03-03 13:01:33','2022-03-03 13:01:33'),(74585,218,'Jaundhary','283204',1,0,'2022-03-03 13:01:33','2022-03-03 13:01:33'),(74586,218,'Jaymai','283151',1,0,'2022-03-03 13:01:33','2022-03-03 13:01:33'),(74587,218,'Jhapara','283136',1,0,'2022-03-03 13:01:33','2022-03-03 13:01:33'),(74588,218,'Kadipur','283130',1,0,'2022-03-03 13:01:33','2022-03-03 13:01:33'),(74589,218,'Kailai','283152',1,0,'2022-03-03 13:01:33','2022-03-03 13:01:33'),(74590,218,'Kanwara','283145',1,0,'2022-03-03 13:01:33','2022-03-03 13:01:33'),(74591,218,'Karhara','283151',1,0,'2022-03-03 13:01:34','2022-03-03 13:01:34'),(74592,218,'Katana','283152',1,0,'2022-03-03 13:01:34','2022-03-03 13:01:34'),(74593,218,'Katki','283204',1,0,'2022-03-03 13:01:34','2022-03-03 13:01:34'),(74594,218,'Kaurara Bujurga','283136',1,0,'2022-03-03 13:01:34','2022-03-03 13:01:34'),(74595,218,'Kaurari Kherha','283142',1,0,'2022-03-03 13:01:34','2022-03-03 13:01:34'),(74596,218,'Keshari','283141',1,0,'2022-03-03 13:01:34','2022-03-03 13:01:34'),(74597,218,'Keshpura','283207',1,0,'2022-03-03 13:01:34','2022-03-03 13:01:34'),(74598,218,'Ketana Harsha','283145',1,0,'2022-03-03 13:01:34','2022-03-03 13:01:34'),(74599,218,'Khair Garh','283203',1,0,'2022-03-03 13:01:34','2022-03-03 13:01:34'),(74600,218,'Khairgarh','283145',1,0,'2022-03-03 13:01:34','2022-03-03 13:01:34'),(74601,218,'Kharaua','283142',1,0,'2022-03-03 13:01:34','2022-03-03 13:01:34'),(74602,218,'Kharit','283130',1,0,'2022-03-03 13:01:34','2022-03-03 13:01:34'),(74603,218,'Kheria Patikara','283130',1,0,'2022-03-03 13:01:34','2022-03-03 13:01:34'),(74604,218,'Konder','283207',1,0,'2022-03-03 13:01:34','2022-03-03 13:01:34'),(74605,218,'Kotaki','283103',1,0,'2022-03-03 13:01:34','2022-03-03 13:01:34'),(74606,218,'Kotla (Firozabad)','283206',1,0,'2022-03-03 13:01:34','2022-03-03 13:01:34'),(74607,218,'Kurri Kuppa','283103',1,0,'2022-03-03 13:01:34','2022-03-03 13:01:34'),(74608,218,'Kushiyari','283136',1,0,'2022-03-03 13:01:34','2022-03-03 13:01:34'),(74609,218,'Labour Collony  Firozabad','283203',1,0,'2022-03-03 13:01:34','2022-03-03 13:01:34'),(74610,218,'Madanpur','283151',1,0,'2022-03-03 13:01:34','2022-03-03 13:01:34'),(74611,218,'Madhoganj','283141',1,0,'2022-03-03 13:01:34','2022-03-03 13:01:34'),(74612,218,'Madhoganj','283141',1,0,'2022-03-03 13:01:34','2022-03-03 13:01:34'),(74613,218,'Mainpuri Gate  Firozabad','283203',1,0,'2022-03-03 13:01:34','2022-03-03 13:01:34'),(74614,218,'Makkhanpur','283145',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74615,218,'Mandai','283135',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74616,218,'Matsena','283203',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74617,218,'Mersena','283204',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74618,218,'Milawali','283136',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74619,218,'Mohammadi','283204',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74620,218,'Muiddinpur','283203',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74621,218,'Mustfabad','283207',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74622,218,'Nagla Bajdar','283141',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74623,218,'Nagla Beech','283204',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74624,218,'Nagla Dheer','283130',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74625,218,'Nagla Dutt','283204',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74626,218,'Nagla Gulal','283142',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74627,218,'Nagla Kanchan','283130',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74628,218,'Nagla Nahar','283152',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74629,218,'Nagla Sikander','283204',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74630,218,'Narakhi','283206',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74631,218,'Narayan Nagar','283203',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74632,218,'Nasirpur','283141',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74633,218,'Nepai','283203',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74634,218,'Oef  Firozabad','283103',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74635,218,'Okhara','283206',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74636,218,'Pachokhara','283204',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74637,218,'Pachwan','283203',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74638,218,'Paigu','283151',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74639,218,'Pamari','283204',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74640,218,'Parham','283130',1,0,'2022-03-03 13:01:35','2022-03-03 13:01:35'),(74641,218,'Pariyar','283142',1,0,'2022-03-03 13:01:36','2022-03-03 13:01:36'),(74642,218,'Patti','283136',1,0,'2022-03-03 13:01:36','2022-03-03 13:01:36'),(74643,218,'Pendat','283152',1,0,'2022-03-03 13:01:36','2022-03-03 13:01:36'),(74644,218,'Phariha','283207',1,0,'2022-03-03 13:01:36','2022-03-03 13:01:36'),(74645,218,'Pilakhatar','283207',1,0,'2022-03-03 13:01:36','2022-03-03 13:01:36'),(74646,218,'Pratappur','283145',1,0,'2022-03-03 13:01:36','2022-03-03 13:01:36'),(74647,218,'Railway Road Firozabad','283203',1,0,'2022-03-03 13:01:36','2022-03-03 13:01:36'),(74648,218,'Raipura','283203',1,0,'2022-03-03 13:01:36','2022-03-03 13:01:36'),(74649,218,'Rasoolabad','283204',1,0,'2022-03-03 13:01:36','2022-03-03 13:01:36'),(74650,218,'Ruchan  Manikpur','283142',1,0,'2022-03-03 13:01:36','2022-03-03 13:01:36'),(74651,218,'Rupaspur','283203',1,0,'2022-03-03 13:01:36','2022-03-03 13:01:36'),(74652,218,'S N H Road Firozabad','283203',1,0,'2022-03-03 13:01:36','2022-03-03 13:01:36'),(74653,218,'Salempur','283136',1,0,'2022-03-03 13:01:36','2022-03-03 13:01:36'),(74654,218,'Salempur','283204',1,0,'2022-03-03 13:01:36','2022-03-03 13:01:36'),(74655,218,'Saray Bhartara','283151',1,0,'2022-03-03 13:01:36','2022-03-03 13:01:36'),(74656,218,'Saray Murlidhar','283151',1,0,'2022-03-03 13:01:36','2022-03-03 13:01:36'),(74657,218,'Sarhamai','283203',1,0,'2022-03-03 13:01:36','2022-03-03 13:01:36'),(74658,218,'Sarhupur','283145',1,0,'2022-03-03 13:01:36','2022-03-03 13:01:36'),(74659,218,'Sekhupur  Hatwant','283145',1,0,'2022-03-03 13:01:36','2022-03-03 13:01:36'),(74660,218,'Shikohabad RS','283141',1,0,'2022-03-03 13:01:36','2022-03-03 13:01:36'),(74661,218,'Shikohabad','283135',1,0,'2022-03-03 13:01:36','2022-03-03 13:01:36'),(74662,218,'Sirsaganj','283151',1,0,'2022-03-03 13:01:36','2022-03-03 13:01:36'),(74663,218,'Sothara','283151',1,0,'2022-03-03 13:01:36','2022-03-03 13:01:36'),(74664,218,'Suraya','283152',1,0,'2022-03-03 13:01:36','2022-03-03 13:01:36'),(74665,218,'Thanumai','283135',1,0,'2022-03-03 13:01:36','2022-03-03 13:01:36'),(74666,218,'Tikari','283204',1,0,'2022-03-03 13:01:37','2022-03-03 13:01:37'),(74667,218,'Tilyani','283151',1,0,'2022-03-03 13:01:37','2022-03-03 13:01:37'),(74668,218,'Town Hall','205262',1,0,'2022-03-03 13:01:37','2022-03-03 13:01:37'),(74669,218,'Tundla Chauraha','283204',1,0,'2022-03-03 13:01:37','2022-03-03 13:01:37'),(74670,218,'Tundla','283204',1,0,'2022-03-03 13:01:37','2022-03-03 13:01:37'),(74671,218,'Ukhrend','283142',1,0,'2022-03-03 13:01:37','2022-03-03 13:01:37'),(74672,218,'Urawar--hastref','283142',1,0,'2022-03-03 13:01:37','2022-03-03 13:01:37'),(74673,218,'Uresar','283152',1,0,'2022-03-03 13:01:37','2022-03-03 13:01:37'),(74674,218,'Urmura','283135',1,0,'2022-03-03 13:01:37','2022-03-03 13:01:37'),(74675,218,'Usayani','283103',1,0,'2022-03-03 13:01:37','2022-03-03 13:01:37'),(74676,218,'Usneedha','283130',1,0,'2022-03-03 13:01:37','2022-03-03 13:01:37'),(74677,218,'Viltigarh','283145',1,0,'2022-03-03 13:01:37','2022-03-03 13:01:37'),(74678,219,'Astauly','203202',1,0,'2022-03-03 13:01:37','2022-03-03 13:01:37'),(74679,219,'Banchawaly','203203',1,0,'2022-03-03 13:01:37','2022-03-03 13:01:37'),(74680,219,'Bankapur','203155',1,0,'2022-03-03 13:01:37','2022-03-03 13:01:37'),(74681,219,'Baroda','203202',1,0,'2022-03-03 13:01:37','2022-03-03 13:01:37'),(74682,219,'Bhaipur  Brahmanan','203209',1,0,'2022-03-03 13:01:37','2022-03-03 13:01:37'),(74683,219,'Bhunna  Jattan','203141',1,0,'2022-03-03 13:01:37','2022-03-03 13:01:37'),(74684,219,'Bichat  Sujanpur','203203',1,0,'2022-03-03 13:01:37','2022-03-03 13:01:37'),(74685,219,'Biroundi Tajpur','203203',1,0,'2022-03-03 13:01:37','2022-03-03 13:01:37'),(74686,219,'Chanchaly','203155',1,0,'2022-03-03 13:01:37','2022-03-03 13:01:37'),(74687,219,'Chhapana','203141',1,0,'2022-03-03 13:01:37','2022-03-03 13:01:37'),(74688,219,'Chingrawly','203141',1,0,'2022-03-03 13:01:37','2022-03-03 13:01:37'),(74689,219,'Chiti','203202',1,0,'2022-03-03 13:01:37','2022-03-03 13:01:37'),(74690,219,'Chol R.S.','203203',1,0,'2022-03-03 13:01:38','2022-03-03 13:01:38'),(74691,219,'Dayanatpur','203135',1,0,'2022-03-03 13:01:38','2022-03-03 13:01:38'),(74692,219,'Deota','203202',1,0,'2022-03-03 13:01:38','2022-03-03 13:01:38'),(74693,219,'Dhanouri   Kalan','203201',1,0,'2022-03-03 13:01:38','2022-03-03 13:01:38'),(74694,219,'Faleda','203135',1,0,'2022-03-03 13:01:38','2022-03-03 13:01:38'),(74695,219,'Gotheny','203141',1,0,'2022-03-03 13:01:38','2022-03-03 13:01:38'),(74696,219,'Hasanpur','203141',1,0,'2022-03-03 13:01:38','2022-03-03 13:01:38'),(74697,219,'Jahangirpur','203141',1,0,'2022-03-03 13:01:38','2022-03-03 13:01:38'),(74698,219,'Jawan','203141',1,0,'2022-03-03 13:01:38','2022-03-03 13:01:38'),(74699,219,'Jewar','203135',1,0,'2022-03-03 13:01:38','2022-03-03 13:01:38'),(74700,219,'Jhajhar','203203',1,0,'2022-03-03 13:01:38','2022-03-03 13:01:38'),(74701,219,'Kakore','203203',1,0,'2022-03-03 13:01:38','2022-03-03 13:01:38'),(74702,219,'Kanigarhi','203135',1,0,'2022-03-03 13:01:38','2022-03-03 13:01:38'),(74703,219,'Karauli Banger','203209',1,0,'2022-03-03 13:01:38','2022-03-03 13:01:38'),(74704,219,'Khabra  Khanpur','203203',1,0,'2022-03-03 13:01:38','2022-03-03 13:01:38'),(74705,219,'Kishore Pur','203155',1,0,'2022-03-03 13:01:38','2022-03-03 13:01:38'),(74706,219,'Kureb','203135',1,0,'2022-03-03 13:01:38','2022-03-03 13:01:38'),(74707,219,'Lodana','203141',1,0,'2022-03-03 13:01:38','2022-03-03 13:01:38'),(74708,219,'Mahamdpur  Jadon','203203',1,0,'2022-03-03 13:01:38','2022-03-03 13:01:38'),(74709,219,'Manchad','203155',1,0,'2022-03-03 13:01:38','2022-03-03 13:01:38'),(74710,219,'Mangrouly','203135',1,0,'2022-03-03 13:01:38','2022-03-03 13:01:38'),(74711,219,'Mansoor Pur Hasanpur','203141',1,0,'2022-03-03 13:01:38','2022-03-03 13:01:38'),(74712,219,'Narmohamadpur','203141',1,0,'2022-03-03 13:01:38','2022-03-03 13:01:38'),(74713,219,'Nawada','203201',1,0,'2022-03-03 13:01:39','2022-03-03 13:01:39'),(74714,219,'Neemka','203155',1,0,'2022-03-03 13:01:39','2022-03-03 13:01:39'),(74715,219,'Parsol','203201',1,0,'2022-03-03 13:01:39','2022-03-03 13:01:39'),(74716,219,'Rabupura','203209',1,0,'2022-03-03 13:01:39','2022-03-03 13:01:39'),(74717,219,'Ranhera','203155',1,0,'2022-03-03 13:01:39','2022-03-03 13:01:39'),(74718,219,'Rashol  Rithaury','203202',1,0,'2022-03-03 13:01:39','2022-03-03 13:01:39'),(74719,219,'Ronija','203209',1,0,'2022-03-03 13:01:39','2022-03-03 13:01:39'),(74720,219,'Sabouta  Jafrabad','203135',1,0,'2022-03-03 13:01:39','2022-03-03 13:01:39'),(74721,219,'Salempur  Gujar','203202',1,0,'2022-03-03 13:01:39','2022-03-03 13:01:39'),(74722,219,'Salempur  Jat','203203',1,0,'2022-03-03 13:01:39','2022-03-03 13:01:39'),(74723,219,'Sunpera','203203',1,0,'2022-03-03 13:01:39','2022-03-03 13:01:39'),(74724,219,'Thora','203155',1,0,'2022-03-03 13:01:39','2022-03-03 13:01:39'),(74725,219,'Tirthaly','203209',1,0,'2022-03-03 13:01:39','2022-03-03 13:01:39'),(74726,219,'Wailana','203203',1,0,'2022-03-03 13:01:39','2022-03-03 13:01:39'),(74727,219,'Wair','203202',1,0,'2022-03-03 13:01:39','2022-03-03 13:01:39'),(74728,219,'Achheja','203207',1,0,'2022-03-03 13:01:39','2022-03-03 13:01:39'),(74729,219,'Alpha Greater Noida','201310',1,0,'2022-03-03 13:01:39','2022-03-03 13:01:39'),(74730,219,'Amity University','201313',1,0,'2022-03-03 13:01:39','2022-03-03 13:01:39'),(74731,219,'Bambawar','203207',1,0,'2022-03-03 13:01:39','2022-03-03 13:01:39'),(74732,219,'Baraula','201304',1,0,'2022-03-03 13:01:39','2022-03-03 13:01:39'),(74733,219,'Behhrampur','203207',1,0,'2022-03-03 13:01:39','2022-03-03 13:01:39'),(74734,219,'Bisara','201008',1,0,'2022-03-03 13:01:39','2022-03-03 13:01:39'),(74735,219,'Bisrakh','201306',1,0,'2022-03-03 13:01:39','2022-03-03 13:01:39'),(74736,219,'Chhaisa','201314',1,0,'2022-03-03 13:01:40','2022-03-03 13:01:40'),(74737,219,'Chhajarsi','201307',1,0,'2022-03-03 13:01:40','2022-03-03 13:01:40'),(74738,219,'Chhaprauli Bengar','201304',1,0,'2022-03-03 13:01:40','2022-03-03 13:01:40'),(74739,219,'Chholas','201314',1,0,'2022-03-03 13:01:40','2022-03-03 13:01:40'),(74740,219,'Chithera','201314',1,0,'2022-03-03 13:01:40','2022-03-03 13:01:40'),(74741,219,'Container Depot','201311',1,0,'2022-03-03 13:01:40','2022-03-03 13:01:40'),(74742,219,'Dadri','203207',1,0,'2022-03-03 13:01:40','2022-03-03 13:01:40'),(74743,219,'Dhoomedso','203207',1,0,'2022-03-03 13:01:40','2022-03-03 13:01:40'),(74744,219,'Dujana','203207',1,0,'2022-03-03 13:01:40','2022-03-03 13:01:40'),(74745,219,'Gautam Budh University','201312',1,0,'2022-03-03 13:01:40','2022-03-03 13:01:40'),(74746,219,'Gejha','201304',1,0,'2022-03-03 13:01:40','2022-03-03 13:01:40'),(74747,219,'Ghori','201310',1,0,'2022-03-03 13:01:40','2022-03-03 13:01:40'),(74748,219,'I.A. Surajpur','201306',1,0,'2022-03-03 13:01:40','2022-03-03 13:01:40'),(74749,219,'Jarcha','203207',1,0,'2022-03-03 13:01:40','2022-03-03 13:01:40'),(74750,219,'Kachera Versabad','203207',1,0,'2022-03-03 13:01:40','2022-03-03 13:01:40'),(74751,219,'Kalaunda','203207',1,0,'2022-03-03 13:01:40','2022-03-03 13:01:40'),(74752,219,'Kasna','201310',1,0,'2022-03-03 13:01:40','2022-03-03 13:01:40'),(74753,219,'Khandera','201314',1,0,'2022-03-03 13:01:40','2022-03-03 13:01:40'),(74754,219,'Khatana','203207',1,0,'2022-03-03 13:01:40','2022-03-03 13:01:40'),(74755,219,'Kheri Bhanauta','203207',1,0,'2022-03-03 13:01:40','2022-03-03 13:01:40'),(74756,219,'Khora Gaon','201309',1,0,'2022-03-03 13:01:40','2022-03-03 13:01:40'),(74757,219,'Knowledge Park-I','201310',1,0,'2022-03-03 13:01:40','2022-03-03 13:01:40'),(74758,219,'Kot','201314',1,0,'2022-03-03 13:01:40','2022-03-03 13:01:40'),(74759,219,'Kulesra','201306',1,0,'2022-03-03 13:01:41','2022-03-03 13:01:41'),(74760,219,'Luharli','201314',1,0,'2022-03-03 13:01:41','2022-03-03 13:01:41'),(74761,219,'Maharishi Nagar','201304',1,0,'2022-03-03 13:01:41','2022-03-03 13:01:41'),(74762,219,'Maicha','201310',1,0,'2022-03-03 13:01:41','2022-03-03 13:01:41'),(74763,219,'Nagla Charandas','201305',1,0,'2022-03-03 13:01:41','2022-03-03 13:01:41'),(74764,219,'Nepz Post Office','201305',1,0,'2022-03-03 13:01:41','2022-03-03 13:01:41'),(74765,219,'Noida H.O','201301',1,0,'2022-03-03 13:01:41','2022-03-03 13:01:41'),(74766,219,'Noida Sector 12','201301',1,0,'2022-03-03 13:01:41','2022-03-03 13:01:41'),(74767,219,'Noida Sector 16','201301',1,0,'2022-03-03 13:01:41','2022-03-03 13:01:41'),(74768,219,'Noida Sector 30','201303',1,0,'2022-03-03 13:01:41','2022-03-03 13:01:41'),(74769,219,'Noida Sector 34','201307',1,0,'2022-03-03 13:01:41','2022-03-03 13:01:41'),(74770,219,'Noida Sector 37','201303',1,0,'2022-03-03 13:01:41','2022-03-03 13:01:41'),(74771,219,'Noida Sector 45','201303',1,0,'2022-03-03 13:01:41','2022-03-03 13:01:41'),(74772,219,'Noida Sector 55','201307',1,0,'2022-03-03 13:01:41','2022-03-03 13:01:41'),(74773,219,'Noida Sector 62','201309',1,0,'2022-03-03 13:01:41','2022-03-03 13:01:41'),(74774,219,'Pali','203207',1,0,'2022-03-03 13:01:41','2022-03-03 13:01:41'),(74775,219,'Parthala Khanjarpur','201307',1,0,'2022-03-03 13:01:41','2022-03-03 13:01:41'),(74776,219,'Piyaoli','201008',1,0,'2022-03-03 13:01:41','2022-03-03 13:01:41'),(74777,219,'Sainthli','201314',1,0,'2022-03-03 13:01:41','2022-03-03 13:01:41'),(74778,219,'Sakipur','201306',1,0,'2022-03-03 13:01:41','2022-03-03 13:01:41'),(74779,219,'Salarpur Kalan','201008',1,0,'2022-03-03 13:01:41','2022-03-03 13:01:41'),(74780,219,'Sarfabad','201307',1,0,'2022-03-03 13:01:41','2022-03-03 13:01:41'),(74781,219,'Shiv Nadar University','201314',1,0,'2022-03-03 13:01:41','2022-03-03 13:01:41'),(74782,219,'Tilapta Karanwas','201306',1,0,'2022-03-03 13:01:41','2022-03-03 13:01:41'),(74783,219,'Tugalpur','201310',1,0,'2022-03-03 13:01:42','2022-03-03 13:01:42'),(74784,219,'Vedpura','203207',1,0,'2022-03-03 13:01:42','2022-03-03 13:01:42'),(74785,219,'Vidyut Nagar (Gautam Buddha Nagar)','201008',1,0,'2022-03-03 13:01:42','2022-03-03 13:01:42'),(74786,220,'Achheja','245101',1,0,'2022-03-03 13:01:42','2022-03-03 13:01:42'),(74787,220,'Adhyatmic Nagar','201015',1,0,'2022-03-03 13:01:42','2022-03-03 13:01:42'),(74788,220,'Alamnagar','245208',1,0,'2022-03-03 13:01:42','2022-03-03 13:01:42'),(74789,220,'Alipur','245201',1,0,'2022-03-03 13:01:42','2022-03-03 13:01:42'),(74790,220,'Anwarpur','245304',1,0,'2022-03-03 13:01:42','2022-03-03 13:01:42'),(74791,220,'Arya Nagar (Ghaziabad)','201009',1,0,'2022-03-03 13:01:42','2022-03-03 13:01:42'),(74792,220,'Asaura','245101',1,0,'2022-03-03 13:01:42','2022-03-03 13:01:42'),(74793,220,'Ashok Nagar (Ghaziabad)','201001',1,0,'2022-03-03 13:01:42','2022-03-03 13:01:42'),(74794,220,'Athsaini','245205',1,0,'2022-03-03 13:01:42','2022-03-03 13:01:42'),(74795,220,'Ator Nagla','201003',1,0,'2022-03-03 13:01:42','2022-03-03 13:01:42'),(74796,220,'Atrauli','245304',1,0,'2022-03-03 13:01:42','2022-03-03 13:01:42'),(74797,220,'Aurangabad Ristal','201003',1,0,'2022-03-03 13:01:42','2022-03-03 13:01:42'),(74798,220,'B.B.Nagar','201009',1,0,'2022-03-03 13:01:42','2022-03-03 13:01:42'),(74799,220,'Babugarh','245201',1,0,'2022-03-03 13:01:42','2022-03-03 13:01:42'),(74800,220,'Bachhlota','245201',1,0,'2022-03-03 13:01:42','2022-03-03 13:01:42'),(74801,220,'Badshahnpur Siroli','201102',1,0,'2022-03-03 13:01:42','2022-03-03 13:01:42'),(74802,220,'Bagarpur','245205',1,0,'2022-03-03 13:01:42','2022-03-03 13:01:42'),(74803,220,'Bahadurgarh','245208',1,0,'2022-03-03 13:01:42','2022-03-03 13:01:42'),(74804,220,'Bajhera Kalan','245101',1,0,'2022-03-03 13:01:42','2022-03-03 13:01:42'),(74805,220,'Abupur','201206',1,0,'2022-03-03 13:01:42','2022-03-03 13:01:42'),(74806,220,'Bajhera Khurd','245304',1,0,'2022-03-03 13:01:42','2022-03-03 13:01:42'),(74807,220,'Bankhanda','245201',1,0,'2022-03-03 13:01:42','2022-03-03 13:01:42'),(74808,220,'Basantpur Sainthli','201206',1,0,'2022-03-03 13:01:43','2022-03-03 13:01:43'),(74809,220,'Baxur','245207',1,0,'2022-03-03 13:01:43','2022-03-03 13:01:43'),(74810,220,'Begmabad','201204',1,0,'2022-03-03 13:01:43','2022-03-03 13:01:43'),(74811,220,'Behta Hazipur','201102',1,0,'2022-03-03 13:01:43','2022-03-03 13:01:43'),(74812,220,'Bhadola','245304',1,0,'2022-03-03 13:01:43','2022-03-03 13:01:43'),(74813,220,'Bhadoli','201206',1,0,'2022-03-03 13:01:43','2022-03-03 13:01:43'),(74814,220,'Bhadsiyana','245208',1,0,'2022-03-03 13:01:43','2022-03-03 13:01:43'),(74815,220,'Bhaina Dholpur','245205',1,0,'2022-03-03 13:01:43','2022-03-03 13:01:43'),(74816,220,'Bharat Nagar (Ghaziabad)','201010',1,0,'2022-03-03 13:01:43','2022-03-03 13:01:43'),(74817,220,'Bharna','245207',1,0,'2022-03-03 13:01:43','2022-03-03 13:01:43'),(74818,220,'Bhatiyana','245101',1,0,'2022-03-03 13:01:43','2022-03-03 13:01:43'),(74819,220,'Bhikanpur','201206',1,0,'2022-03-03 13:01:43','2022-03-03 13:01:43'),(74820,220,'Bhojpur','245304',1,0,'2022-03-03 13:01:43','2022-03-03 13:01:43'),(74821,220,'Bhopura','201005',1,0,'2022-03-03 13:01:43','2022-03-03 13:01:43'),(74822,220,'Bhup Kheri','201003',1,0,'2022-03-03 13:01:43','2022-03-03 13:01:43'),(74823,220,'Bihuni','245205',1,0,'2022-03-03 13:01:43','2022-03-03 13:01:43'),(74824,220,'Biraj Ghat','245205',1,0,'2022-03-03 13:01:43','2022-03-03 13:01:43'),(74825,220,'Chajarsi','245304',1,0,'2022-03-03 13:01:43','2022-03-03 13:01:43'),(74826,220,'Chamri','245101',1,0,'2022-03-03 13:01:43','2022-03-03 13:01:43'),(74827,220,'Chander Nagar','201011',1,0,'2022-03-03 13:01:43','2022-03-03 13:01:43'),(74828,220,'Chhajupur','245101',1,0,'2022-03-03 13:01:43','2022-03-03 13:01:43'),(74829,220,'Chhaprola','201009',1,0,'2022-03-03 13:01:43','2022-03-03 13:01:43'),(74830,220,'Chhipyana','201009',1,0,'2022-03-03 13:01:44','2022-03-03 13:01:44'),(74831,220,'Chikamberpur','201006',1,0,'2022-03-03 13:01:44','2022-03-03 13:01:44'),(74832,220,'Chirori','201102',1,0,'2022-03-03 13:01:44','2022-03-03 13:01:44'),(74833,220,'Churiyala','201201',1,0,'2022-03-03 13:01:44','2022-03-03 13:01:44'),(74834,220,'Crossing Republik','201016',1,0,'2022-03-03 13:01:44','2022-03-03 13:01:44'),(74835,220,'Dadri','245101',1,0,'2022-03-03 13:01:44','2022-03-03 13:01:44'),(74836,220,'Dahana','245101',1,0,'2022-03-03 13:01:44','2022-03-03 13:01:44'),(74837,220,'Dasna','201015',1,0,'2022-03-03 13:01:44','2022-03-03 13:01:44'),(74838,220,'Dasna Gate Ed','201009',1,0,'2022-03-03 13:01:44','2022-03-03 13:01:44'),(74839,220,'Dasna R.S.','201015',1,0,'2022-03-03 13:01:44','2022-03-03 13:01:44'),(74840,220,'Datiyana','245207',1,0,'2022-03-03 13:01:44','2022-03-03 13:01:44'),(74841,220,'Dehpa Azampur','245304',1,0,'2022-03-03 13:01:44','2022-03-03 13:01:44'),(74842,220,'Dehra','245301',1,0,'2022-03-03 13:01:44','2022-03-03 13:01:44'),(74843,220,'Dehra Rampur','245205',1,0,'2022-03-03 13:01:44','2022-03-03 13:01:44'),(74844,220,'Dhana','245207',1,0,'2022-03-03 13:01:44','2022-03-03 13:01:44'),(74845,220,'Dhanaura','245101',1,0,'2022-03-03 13:01:44','2022-03-03 13:01:44'),(74846,220,'Dhaulana','245301',1,0,'2022-03-03 13:01:44','2022-03-03 13:01:44'),(74847,220,'Didoli','201206',1,0,'2022-03-03 13:01:44','2022-03-03 13:01:44'),(74848,220,'Doohri','245304',1,0,'2022-03-03 13:01:44','2022-03-03 13:01:44'),(74849,220,'Dosa Banjarpur','201206',1,0,'2022-03-03 13:01:44','2022-03-03 13:01:44'),(74850,220,'Dotai','245205',1,0,'2022-03-03 13:01:44','2022-03-03 13:01:44'),(74851,220,'Duhai','201206',1,0,'2022-03-03 13:01:44','2022-03-03 13:01:44'),(74852,220,'Dundahera','201009',1,0,'2022-03-03 13:01:44','2022-03-03 13:01:44'),(74853,220,'Farid Nagar','245304',1,0,'2022-03-03 13:01:44','2022-03-03 13:01:44'),(74854,220,'Farrukh Nagar','201003',1,0,'2022-03-03 13:01:45','2022-03-03 13:01:45'),(74855,220,'Galand','201015',1,0,'2022-03-03 13:01:45','2022-03-03 13:01:45'),(74856,220,'Gandu Nagla','245205',1,0,'2022-03-03 13:01:45','2022-03-03 13:01:45'),(74857,220,'Garh Town','245205',1,0,'2022-03-03 13:01:45','2022-03-03 13:01:45'),(74858,220,'Garhmukhteshwer','245205',1,0,'2022-03-03 13:01:45','2022-03-03 13:01:45'),(74859,220,'Ghaziabad City','201009',1,0,'2022-03-03 13:01:45','2022-03-03 13:01:45'),(74860,220,'Ghaziabad H.O','201001',1,0,'2022-03-03 13:01:45','2022-03-03 13:01:45'),(74861,220,'Ghungrala','245101',1,0,'2022-03-03 13:01:45','2022-03-03 13:01:45'),(74862,220,'Girdharpur Tmrel','245101',1,0,'2022-03-03 13:01:45','2022-03-03 13:01:45'),(74863,220,'Gohra Alamgirpur','245101',1,0,'2022-03-03 13:01:45','2022-03-03 13:01:45'),(74864,220,'Govindpuram','201013',1,0,'2022-03-03 13:01:45','2022-03-03 13:01:45'),(74865,220,'Govindpuri','201201',1,0,'2022-03-03 13:01:45','2022-03-03 13:01:45'),(74866,220,'Gyan Lok','245101',1,0,'2022-03-03 13:01:45','2022-03-03 13:01:45'),(74867,220,'Gyaspur','201204',1,0,'2022-03-03 13:01:45','2022-03-03 13:01:45'),(74868,220,'Haidarpur','245205',1,0,'2022-03-03 13:01:45','2022-03-03 13:01:45'),(74869,220,'Hapur H.O','245101',1,0,'2022-03-03 13:01:45','2022-03-03 13:01:45'),(74870,220,'Hapur Mandi','245101',1,0,'2022-03-03 13:01:45','2022-03-03 13:01:45'),(74871,220,'Harmukhpuri','201201',1,0,'2022-03-03 13:01:45','2022-03-03 13:01:45'),(74872,220,'Harsinghpur','245101',1,0,'2022-03-03 13:01:45','2022-03-03 13:01:45'),(74873,220,'Hasanpur Bhowapur','201010',1,0,'2022-03-03 13:01:45','2022-03-03 13:01:45'),(74874,220,'Hassanpur','201015',1,0,'2022-03-03 13:01:45','2022-03-03 13:01:45'),(74875,220,'Hindan Nagar','201015',1,0,'2022-03-03 13:01:45','2022-03-03 13:01:45'),(74876,220,'Hindon Air Field','201004',1,0,'2022-03-03 13:01:45','2022-03-03 13:01:45'),(74877,220,'Hoshdarpur Garhi','245201',1,0,'2022-03-03 13:01:45','2022-03-03 13:01:45'),(74878,220,'I.E.Sahibabad','201010',1,0,'2022-03-03 13:01:46','2022-03-03 13:01:46'),(74879,220,'Iklahdi','245101',1,0,'2022-03-03 13:01:46','2022-03-03 13:01:46'),(74880,220,'Ingram Institute','201002',1,0,'2022-03-03 13:01:46','2022-03-03 13:01:46'),(74881,220,'Jakhera Rahmatpur','245205',1,0,'2022-03-03 13:01:46','2022-03-03 13:01:46'),(74882,220,'Jalalabad','201206',1,0,'2022-03-03 13:01:46','2022-03-03 13:01:46'),(74883,220,'Jalalpur Dhindar','201206',1,0,'2022-03-03 13:01:46','2022-03-03 13:01:46'),(74884,220,'Jaoli','201102',1,0,'2022-03-03 13:01:46','2022-03-03 13:01:46'),(74885,220,'Jharina','245205',1,0,'2022-03-03 13:01:46','2022-03-03 13:01:46'),(74886,220,'Jindal Nagar','201015',1,0,'2022-03-03 13:01:46','2022-03-03 13:01:46'),(74887,220,'Kaila','201009',1,0,'2022-03-03 13:01:46','2022-03-03 13:01:46'),(74888,220,'Kakra','201206',1,0,'2022-03-03 13:01:46','2022-03-03 13:01:46'),(74889,220,'Kalchina','245304',1,0,'2022-03-03 13:01:46','2022-03-03 13:01:46'),(74890,220,'Kamla Nehru Nagar','201002',1,0,'2022-03-03 13:01:46','2022-03-03 13:01:46'),(74891,220,'Kanauja','201206',1,0,'2022-03-03 13:01:46','2022-03-03 13:01:46'),(74892,220,'Kandaula','245301',1,0,'2022-03-03 13:01:46','2022-03-03 13:01:46'),(74893,220,'Kandoli','245304',1,0,'2022-03-03 13:01:46','2022-03-03 13:01:46'),(74894,220,'Kanya Kalyanpur','245201',1,0,'2022-03-03 13:01:46','2022-03-03 13:01:46'),(74895,220,'Kastala','245304',1,0,'2022-03-03 13:01:46','2022-03-03 13:01:46'),(74896,220,'Kathikhera','245101',1,0,'2022-03-03 13:01:46','2022-03-03 13:01:46'),(74897,220,'Kaushambi','201012',1,0,'2022-03-03 13:01:46','2022-03-03 13:01:46'),(74898,220,'Kavi Nagar','201002',1,0,'2022-03-03 13:01:46','2022-03-03 13:01:46'),(74899,220,'Khanjarpur','201204',1,0,'2022-03-03 13:01:46','2022-03-03 13:01:46'),(74900,220,'Kharkhari','245101',1,0,'2022-03-03 13:01:46','2022-03-03 13:01:46'),(74901,220,'Khera','245304',1,0,'2022-03-03 13:01:46','2022-03-03 13:01:46'),(74902,220,'Khiluai','245205',1,0,'2022-03-03 13:01:47','2022-03-03 13:01:47'),(74903,220,'Khimawati','201206',1,0,'2022-03-03 13:01:47','2022-03-03 13:01:47'),(74904,220,'Khindora','201204',1,0,'2022-03-03 13:01:47','2022-03-03 13:01:47'),(74905,220,'Kishan Ganj (Ghaziabad)','245101',1,0,'2022-03-03 13:01:47','2022-03-03 13:01:47'),(74906,220,'Kuchesar Chopla','245201',1,0,'2022-03-03 13:01:47','2022-03-03 13:01:47'),(74907,220,'Kumhera','201206',1,0,'2022-03-03 13:01:47','2022-03-03 13:01:47'),(74908,220,'Kushlia','201015',1,0,'2022-03-03 13:01:47','2022-03-03 13:01:47'),(74909,220,'Loni','201102',1,0,'2022-03-03 13:01:47','2022-03-03 13:01:47'),(74910,220,'Luhari','245205',1,0,'2022-03-03 13:01:47','2022-03-03 13:01:47'),(74911,220,'Madarsa Sadat','245101',1,0,'2022-03-03 13:01:47','2022-03-03 13:01:47'),(74912,220,'Mahmoodpur','245101',1,0,'2022-03-03 13:01:47','2022-03-03 13:01:47'),(74913,220,'Mahmoodpur Palwara','245208',1,0,'2022-03-03 13:01:47','2022-03-03 13:01:47'),(74914,220,'Makanpur','201014',1,0,'2022-03-03 13:01:47','2022-03-03 13:01:47'),(74915,220,'Mandola','201102',1,0,'2022-03-03 13:01:47','2022-03-03 13:01:47'),(74916,220,'Mathurawali','245101',1,0,'2022-03-03 13:01:47','2022-03-03 13:01:47'),(74917,220,'Matnaurs','245201',1,0,'2022-03-03 13:01:47','2022-03-03 13:01:47'),(74918,220,'Meerut Road','201003',1,0,'2022-03-03 13:01:47','2022-03-03 13:01:47'),(74919,220,'Model Town (Ghaziabad)','201009',1,0,'2022-03-03 13:01:47','2022-03-03 13:01:47'),(74920,220,'Modi Nagar','201204',1,0,'2022-03-03 13:01:47','2022-03-03 13:01:47'),(74921,220,'Mohan Nagar (Ghaziabad)','201007',1,0,'2022-03-03 13:01:47','2022-03-03 13:01:47'),(74922,220,'Mohd. Pur Khudaliya','245207',1,0,'2022-03-03 13:01:47','2022-03-03 13:01:47'),(74923,220,'Morta','201003',1,0,'2022-03-03 13:01:47','2022-03-03 13:01:47'),(74924,220,'Mubarikpur','245207',1,0,'2022-03-03 13:01:47','2022-03-03 13:01:47'),(74925,220,'Mukeempur','245304',1,0,'2022-03-03 13:01:47','2022-03-03 13:01:47'),(74926,220,'Murad Nagar Bazar','201206',1,0,'2022-03-03 13:01:47','2022-03-03 13:01:47'),(74927,220,'Murad Nagar (Ghaziabad)','201206',1,0,'2022-03-03 13:01:48','2022-03-03 13:01:48'),(74928,220,'Murad Nagar Town','201206',1,0,'2022-03-03 13:01:48','2022-03-03 13:01:48'),(74929,220,'Muradpur Janupura','245205',1,0,'2022-03-03 13:01:48','2022-03-03 13:01:48'),(74930,220,'Nagla Akhu','201204',1,0,'2022-03-03 13:01:48','2022-03-03 13:01:48'),(74931,220,'Nagola','245304',1,0,'2022-03-03 13:01:48','2022-03-03 13:01:48'),(74932,220,'Nahal','201015',1,0,'2022-03-03 13:01:48','2022-03-03 13:01:48'),(74933,220,'Nali Husainpur','245201',1,0,'2022-03-03 13:01:48','2022-03-03 13:01:48'),(74934,220,'Nan','245101',1,0,'2022-03-03 13:01:48','2022-03-03 13:01:48'),(74935,220,'Nanpur','245205',1,0,'2022-03-03 13:01:48','2022-03-03 13:01:48'),(74936,220,'Nasratpura ED','201009',1,0,'2022-03-03 13:01:48','2022-03-03 13:01:48'),(74937,220,'Nehru Nagar (Ghaziabad)','201001',1,0,'2022-03-03 13:01:48','2022-03-03 13:01:48'),(74938,220,'Nek Nanpur Nanai','245208',1,0,'2022-03-03 13:01:48','2022-03-03 13:01:48'),(74939,220,'Nekpur','201206',1,0,'2022-03-03 13:01:48','2022-03-03 13:01:48'),(74940,220,'New Market Pilkhauwa','245304',1,0,'2022-03-03 13:01:48','2022-03-03 13:01:48'),(74941,220,'New Raj Nagar','201002',1,0,'2022-03-03 13:01:48','2022-03-03 13:01:48'),(74942,220,'Nistoli','201003',1,0,'2022-03-03 13:01:48','2022-03-03 13:01:48'),(74943,220,'Niwari','201204',1,0,'2022-03-03 13:01:48','2022-03-03 13:01:48'),(74944,220,'Noida Sector 27','201301',1,0,'2022-03-03 13:01:48','2022-03-03 13:01:48'),(74945,220,'Noida Sector 41','201303',1,0,'2022-03-03 13:01:48','2022-03-03 13:01:48'),(74946,220,'Noorpur','201206',1,0,'2022-03-03 13:01:48','2022-03-03 13:01:48'),(74947,220,'Old Raj Nagar','201002',1,0,'2022-03-03 13:01:48','2022-03-03 13:01:48'),(74948,220,'Painga','201204',1,0,'2022-03-03 13:01:48','2022-03-03 13:01:48'),(74949,220,'Parpa','245301',1,0,'2022-03-03 13:01:48','2022-03-03 13:01:48'),(74950,220,'Pasonda','201005',1,0,'2022-03-03 13:01:48','2022-03-03 13:01:48'),(74951,220,'Patla','201204',1,0,'2022-03-03 13:01:48','2022-03-03 13:01:48'),(74952,220,'Phagota','245101',1,0,'2022-03-03 13:01:49','2022-03-03 13:01:49'),(74953,220,'Phuldehra','245207',1,0,'2022-03-03 13:01:49','2022-03-03 13:01:49'),(74954,220,'Pilkhauwa Post Office','245304',1,0,'2022-03-03 13:01:49','2022-03-03 13:01:49'),(74955,220,'Police Line Harsaon','201002',1,0,'2022-03-03 13:01:49','2022-03-03 13:01:49'),(74956,220,'Raghunathpur','245101',1,0,'2022-03-03 13:01:49','2022-03-03 13:01:49'),(74957,220,'Raispur','201002',1,0,'2022-03-03 13:01:49','2022-03-03 13:01:49'),(74958,220,'Raj Nagar Extension','201017',1,0,'2022-03-03 13:01:49','2022-03-03 13:01:49'),(74959,220,'Rajapur','201002',1,0,'2022-03-03 13:01:49','2022-03-03 13:01:49'),(74960,220,'Rajethi','245207',1,0,'2022-03-03 13:01:49','2022-03-03 13:01:49'),(74961,220,'RAKNPA','201002',1,0,'2022-03-03 13:01:49','2022-03-03 13:01:49'),(74962,220,'Rampur Puth','245101',1,0,'2022-03-03 13:01:49','2022-03-03 13:01:49'),(74963,220,'Ramte Ram Road','201001',1,0,'2022-03-03 13:01:49','2022-03-03 13:01:49'),(74964,220,'Raoli Kalan','201206',1,0,'2022-03-03 13:01:49','2022-03-03 13:01:49'),(74965,220,'Rasulpur','245201',1,0,'2022-03-03 13:01:49','2022-03-03 13:01:49'),(74966,220,'Rly Road Hapur','245101',1,0,'2022-03-03 13:01:49','2022-03-03 13:01:49'),(74967,220,'Rori','201201',1,0,'2022-03-03 13:01:49','2022-03-03 13:01:49'),(74968,220,'Roza Yakubpur','201009',1,0,'2022-03-03 13:01:49','2022-03-03 13:01:49'),(74969,220,'Sadarpur','201002',1,0,'2022-03-03 13:01:49','2022-03-03 13:01:49'),(74970,220,'Sadullapur','245205',1,0,'2022-03-03 13:01:49','2022-03-03 13:01:49'),(74971,220,'Sahibabad','201005',1,0,'2022-03-03 13:01:49','2022-03-03 13:01:49'),(74972,220,'Saidpur','201201',1,0,'2022-03-03 13:01:49','2022-03-03 13:01:49'),(74973,220,'Sakhpur','245201',1,0,'2022-03-03 13:01:49','2022-03-03 13:01:49'),(74974,220,'Salarpur','245205',1,0,'2022-03-03 13:01:49','2022-03-03 13:01:49'),(74975,220,'Samaipur','245304',1,0,'2022-03-03 13:01:49','2022-03-03 13:01:49'),(74976,220,'Samana','245301',1,0,'2022-03-03 13:01:50','2022-03-03 13:01:50'),(74977,220,'Sapnawat','245101',1,0,'2022-03-03 13:01:50','2022-03-03 13:01:50'),(74978,220,'Sara','201201',1,0,'2022-03-03 13:01:50','2022-03-03 13:01:50'),(74979,220,'Saunda','201204',1,0,'2022-03-03 13:01:50','2022-03-03 13:01:50'),(74980,220,'Shah Mohiuddinpur','245101',1,0,'2022-03-03 13:01:50','2022-03-03 13:01:50'),(74981,220,'Shahjahanpur','201204',1,0,'2022-03-03 13:01:50','2022-03-03 13:01:50'),(74982,220,'Shahpur','201206',1,0,'2022-03-03 13:01:50','2022-03-03 13:01:50'),(74983,220,'Shahpur Bamheta','201002',1,0,'2022-03-03 13:01:50','2022-03-03 13:01:50'),(74984,220,'Sharpur','245208',1,0,'2022-03-03 13:01:50','2022-03-03 13:01:50'),(74985,220,'Shastri Nagar','201002',1,0,'2022-03-03 13:01:50','2022-03-03 13:01:50'),(74986,220,'Shipra Sun City','201014',1,0,'2022-03-03 13:01:50','2022-03-03 13:01:50'),(74987,220,'Shyampur Jatt','245205',1,0,'2022-03-03 13:01:50','2022-03-03 13:01:50'),(74988,220,'Sikandarpur Kakori','245201',1,0,'2022-03-03 13:01:50','2022-03-03 13:01:50'),(74989,220,'Sikhera','245207',1,0,'2022-03-03 13:01:50','2022-03-03 13:01:50'),(74990,220,'Sikri Kalan','201204',1,0,'2022-03-03 13:01:50','2022-03-03 13:01:50'),(74991,220,'Sikri Khurd','201204',1,0,'2022-03-03 13:01:50','2022-03-03 13:01:50'),(74992,220,'Simbhaoli','245207',1,0,'2022-03-03 13:01:50','2022-03-03 13:01:50'),(74993,220,'Solana','245301',1,0,'2022-03-03 13:01:50','2022-03-03 13:01:50'),(74994,220,'Sultanpur','201206',1,0,'2022-03-03 13:01:50','2022-03-03 13:01:50'),(74995,220,'Surana','201206',1,0,'2022-03-03 13:01:50','2022-03-03 13:01:50'),(74996,220,'Talhata','201201',1,0,'2022-03-03 13:01:50','2022-03-03 13:01:50'),(74997,220,'Tatarpur','245201',1,0,'2022-03-03 13:01:50','2022-03-03 13:01:50'),(74998,220,'Teela Sahbazpur','201102',1,0,'2022-03-03 13:01:51','2022-03-03 13:01:51'),(74999,220,'Tibra','201204',1,0,'2022-03-03 13:01:51','2022-03-03 13:01:51'),(75000,220,'Tronica City','201103',1,0,'2022-03-03 13:01:51','2022-03-03 13:01:51'),(75001,220,'Tyori','245304',1,0,'2022-03-03 13:01:51','2022-03-03 13:01:51'),(75002,220,'Ubarpur','245101',1,0,'2022-03-03 13:01:51','2022-03-03 13:01:51'),(75003,220,'Udai Rampur Nagla','201015',1,0,'2022-03-03 13:01:51','2022-03-03 13:01:51'),(75004,220,'Upera','245201',1,0,'2022-03-03 13:01:51','2022-03-03 13:01:51'),(75005,220,'Vaishali','201019',1,0,'2022-03-03 13:01:51','2022-03-03 13:01:51'),(75006,220,'Vasundhra','201012',1,0,'2022-03-03 13:01:51','2022-03-03 13:01:51'),(75007,220,'Vijai Nagar (Ghaziabad)','201009',1,0,'2022-03-03 13:01:51','2022-03-03 13:01:51'),(75008,220,'Vivekanand Nagar','201002',1,0,'2022-03-03 13:01:51','2022-03-03 13:01:51'),(75009,220,'Wait','245207',1,0,'2022-03-03 13:01:51','2022-03-03 13:01:51'),(75010,221,'Abadan Bairan','233227',1,0,'2022-03-03 13:01:51','2022-03-03 13:01:51'),(75011,221,'Abhaipur','232331',1,0,'2022-03-03 13:01:51','2022-03-03 13:01:51'),(75012,221,'Abishahan','233222',1,0,'2022-03-03 13:01:51','2022-03-03 13:01:51'),(75013,221,'Akarmpur Banjaripur','233002',1,0,'2022-03-03 13:01:51','2022-03-03 13:01:51'),(75014,221,'Akbarpur','275204',1,0,'2022-03-03 13:01:51','2022-03-03 13:01:51'),(75015,221,'Alawalpur Afga','233222',1,0,'2022-03-03 13:01:51','2022-03-03 13:01:51'),(75016,221,'Alawalpur','233305',1,0,'2022-03-03 13:01:51','2022-03-03 13:01:51'),(75017,221,'Alipur Bangawan','233302',1,0,'2022-03-03 13:01:51','2022-03-03 13:01:51'),(75018,221,'Alipur Madara','275203',1,0,'2022-03-03 13:01:51','2022-03-03 13:01:51'),(75019,221,'Amaura','232333',1,0,'2022-03-03 13:01:51','2022-03-03 13:01:51'),(75020,221,'Ameda','233221',1,0,'2022-03-03 13:01:51','2022-03-03 13:01:51'),(75021,221,'Amehta','233223',1,0,'2022-03-03 13:01:51','2022-03-03 13:01:51'),(75022,221,'Amrupur','233231',1,0,'2022-03-03 13:01:51','2022-03-03 13:01:51'),(75023,221,'Anauni','233221',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75024,221,'Andharipur Sonwal','232336',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75025,221,'Andhau','233305',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75026,221,'Arakhpur','233305',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75027,221,'Asaon','232336',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75028,221,'Asawar','233225',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75029,221,'Athatha','232333',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75030,221,'Atwa Fatehpur','233002',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75031,221,'Aurihar','233221',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75032,221,'Awathahi','233227',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75033,221,'Badhupur','233300',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75034,221,'Bagend','233301',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75035,221,'Bahadurganj (Ghazipur)','275201',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75036,221,'Bahadurpur','232329',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75037,221,'Bahariabad','275204',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75038,221,'Bahediya','233223',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75039,221,'Baheri','233223',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75040,221,'Baipur Deokali','233002',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75041,221,'Bajidpur','233310',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75042,221,'Balapur','233227',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75043,221,'Banki Khurd','233229',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75044,221,'Bara (Ghazipur)','232325',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75045,221,'Barachawar','233229',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75046,221,'Baragaon','275202',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75047,221,'Barahi','233226',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75048,221,'Bareji','233301',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75049,221,'Barhat','233311',1,0,'2022-03-03 13:01:52','2022-03-03 13:01:52'),(75050,221,'Barsara','233232',1,0,'2022-03-03 13:01:53','2022-03-03 13:01:53'),(75051,221,'Baruin','232331',1,0,'2022-03-03 13:01:53','2022-03-03 13:01:53'),(75052,221,'Barwa Kalan','275204',1,0,'2022-03-03 13:01:53','2022-03-03 13:01:53'),(75053,221,'Basewa','275205',1,0,'2022-03-03 13:01:53','2022-03-03 13:01:53'),(75054,221,'Basuchak','233306',1,0,'2022-03-03 13:01:53','2022-03-03 13:01:53'),(75055,221,'Basudeopur','233222',1,0,'2022-03-03 13:01:53','2022-03-03 13:01:53'),(75056,221,'Basuka','232339',1,0,'2022-03-03 13:01:53','2022-03-03 13:01:53'),(75057,221,'Basupur','233304',1,0,'2022-03-03 13:01:53','2022-03-03 13:01:53'),(75058,221,'Baurawan','233304',1,0,'2022-03-03 13:01:53','2022-03-03 13:01:53'),(75059,221,'Bauri','233303',1,0,'2022-03-03 13:01:53','2022-03-03 13:01:53'),(75060,221,'Belhari','233221',1,0,'2022-03-03 13:01:53','2022-03-03 13:01:53'),(75061,221,'Belsari','233302',1,0,'2022-03-03 13:01:53','2022-03-03 13:01:53'),(75062,221,'Belwa Urf Rasulpur','233305',1,0,'2022-03-03 13:01:53','2022-03-03 13:01:53'),(75063,221,'Betabar Kalan','232340',1,0,'2022-03-03 13:01:53','2022-03-03 13:01:53'),(75064,221,'Bhadaura','232333',1,0,'2022-03-03 13:01:53','2022-03-03 13:01:53'),(75065,221,'Bhagirathpur','232336',1,0,'2022-03-03 13:01:53','2022-03-03 13:01:53'),(75066,221,'Bhala','233303',1,0,'2022-03-03 13:01:53','2022-03-03 13:01:53'),(75067,221,'Bhala Khurd','275204',1,0,'2022-03-03 13:01:53','2022-03-03 13:01:53'),(75068,221,'Bharauli Kalan','233228',1,0,'2022-03-03 13:01:53','2022-03-03 13:01:53'),(75069,221,'Bharsar','233300',1,0,'2022-03-03 13:01:53','2022-03-03 13:01:53'),(75070,221,'Bhataura','232327',1,0,'2022-03-03 13:01:54','2022-03-03 13:01:54'),(75071,221,'Bhawarkol','233231',1,0,'2022-03-03 13:01:54','2022-03-03 13:01:54'),(75072,221,'Bhikham Amhat','233229',1,0,'2022-03-03 13:01:54','2022-03-03 13:01:54'),(75073,221,'Bhikhichaura','232332',1,0,'2022-03-03 13:01:54','2022-03-03 13:01:54'),(75074,221,'Bhimapar','233307',1,0,'2022-03-03 13:01:54','2022-03-03 13:01:54'),(75075,221,'Bhitari','233304',1,0,'2022-03-03 13:01:54','2022-03-03 13:01:54'),(75076,221,'Bhojapur','233226',1,0,'2022-03-03 13:01:54','2022-03-03 13:01:54'),(75077,221,'Bhurkura','275203',1,0,'2022-03-03 13:01:54','2022-03-03 13:01:54'),(75078,221,'Bhuwalchak','232336',1,0,'2022-03-03 13:01:54','2022-03-03 13:01:54'),(75079,221,'Bhuwarpur','233307',1,0,'2022-03-03 13:01:54','2022-03-03 13:01:54'),(75080,221,'Bijaura','233226',1,0,'2022-03-03 13:01:54','2022-03-03 13:01:54'),(75081,221,'Bikapur','233002',1,0,'2022-03-03 13:01:54','2022-03-03 13:01:54'),(75082,221,'Bikrampur','233307',1,0,'2022-03-03 13:01:54','2022-03-03 13:01:54'),(75083,221,'Birbalpur','233226',1,0,'2022-03-03 13:01:54','2022-03-03 13:01:54'),(75084,221,'Birno','233300',1,0,'2022-03-03 13:01:54','2022-03-03 13:01:54'),(75085,221,'Birpur','233231',1,0,'2022-03-03 13:01:54','2022-03-03 13:01:54'),(75086,221,'Bogna','233226',1,0,'2022-03-03 13:01:54','2022-03-03 13:01:54'),(75087,221,'Burhanpur','275203',1,0,'2022-03-03 13:01:54','2022-03-03 13:01:54'),(75088,221,'Buzurga Gouspur','233305',1,0,'2022-03-03 13:01:54','2022-03-03 13:01:54'),(75089,221,'Chak Abdul Sattar','233002',1,0,'2022-03-03 13:01:54','2022-03-03 13:01:54'),(75090,221,'Chaktaj Katghara','233304',1,0,'2022-03-03 13:01:54','2022-03-03 13:01:54'),(75091,221,'Chandipur','233302',1,0,'2022-03-03 13:01:54','2022-03-03 13:01:54'),(75092,221,'Chaubepur','233226',1,0,'2022-03-03 13:01:54','2022-03-03 13:01:54'),(75093,221,'Chauja','275203',1,0,'2022-03-03 13:01:54','2022-03-03 13:01:54'),(75094,221,'Chaukiya','233002',1,0,'2022-03-03 13:01:55','2022-03-03 13:01:55'),(75095,221,'Chaura','233310',1,0,'2022-03-03 13:01:55','2022-03-03 13:01:55'),(75096,221,'Chaurabojh','233300',1,0,'2022-03-03 13:01:55','2022-03-03 13:01:55'),(75097,221,'Chhawani Line','233002',1,0,'2022-03-03 13:01:55','2022-03-03 13:01:55'),(75098,221,'Chilar','233311',1,0,'2022-03-03 13:01:55','2022-03-03 13:01:55'),(75099,221,'Chochakpur','233224',1,0,'2022-03-03 13:01:55','2022-03-03 13:01:55'),(75100,221,'Dadara','233221',1,0,'2022-03-03 13:01:55','2022-03-03 13:01:55'),(75101,221,'Dahendu','233222',1,0,'2022-03-03 13:01:55','2022-03-03 13:01:55'),(75102,221,'Dahra Kalan','233304',1,0,'2022-03-03 13:01:55','2022-03-03 13:01:55'),(75103,221,'Darauli','232329',1,0,'2022-03-03 13:01:55','2022-03-03 13:01:55'),(75104,221,'Darhwal','275204',1,0,'2022-03-03 13:01:55','2022-03-03 13:01:55'),(75105,221,'Daudpur','232331',1,0,'2022-03-03 13:01:55','2022-03-03 13:01:55'),(75106,221,'Daulatnagar','275204',1,0,'2022-03-03 13:01:55','2022-03-03 13:01:55'),(75107,221,'Daulatpur','233304',1,0,'2022-03-03 13:01:55','2022-03-03 13:01:55'),(75108,221,'Degree College (Ghazipur)','233001',1,0,'2022-03-03 13:01:55','2022-03-03 13:01:55'),(75109,221,'Deochandpur','233304',1,0,'2022-03-03 13:01:55','2022-03-03 13:01:55'),(75110,221,'Deokali','232339',1,0,'2022-03-03 13:01:55','2022-03-03 13:01:55'),(75111,221,'Deokali','233306',1,0,'2022-03-03 13:01:55','2022-03-03 13:01:55'),(75112,221,'Deoria','233233',1,0,'2022-03-03 13:01:55','2022-03-03 13:01:55'),(75113,221,'Deoria (Ghazipur)','232340',1,0,'2022-03-03 13:01:55','2022-03-03 13:01:55'),(75114,221,'Derhgawan','232328',1,0,'2022-03-03 13:01:55','2022-03-03 13:01:55'),(75115,221,'Dewaitha','232326',1,0,'2022-03-03 13:01:55','2022-03-03 13:01:55'),(75116,221,'Dewal','232333',1,0,'2022-03-03 13:01:56','2022-03-03 13:01:56'),(75117,221,'Dhamupur','275202',1,0,'2022-03-03 13:01:56','2022-03-03 13:01:56'),(75118,221,'Dhanaipur','233302',1,0,'2022-03-03 13:01:56','2022-03-03 13:01:56'),(75119,221,'Dhanarhi','232330',1,0,'2022-03-03 13:01:56','2022-03-03 13:01:56'),(75120,221,'Dhanauta','232329',1,0,'2022-03-03 13:01:56','2022-03-03 13:01:56'),(75121,221,'Dhanespur','233226',1,0,'2022-03-03 13:01:56','2022-03-03 13:01:56'),(75122,221,'Dharammarpur','233232',1,0,'2022-03-03 13:01:56','2022-03-03 13:01:56'),(75123,221,'Dharhni','232336',1,0,'2022-03-03 13:01:56','2022-03-03 13:01:56'),(75124,221,'Dhari Kala','233311',1,0,'2022-03-03 13:01:56','2022-03-03 13:01:56'),(75125,221,'Dharmagatpur','233300',1,0,'2022-03-03 13:01:56','2022-03-03 13:01:56'),(75126,221,'Dhelwa','233302',1,0,'2022-03-03 13:01:56','2022-03-03 13:01:56'),(75127,221,'Dhotari','233222',1,0,'2022-03-03 13:01:56','2022-03-03 13:01:56'),(75128,221,'Dhuwarjun','233304',1,0,'2022-03-03 13:01:56','2022-03-03 13:01:56'),(75129,221,'Dildarnagar Bazar','232326',1,0,'2022-03-03 13:01:56','2022-03-03 13:01:56'),(75130,221,'Dildarnagar','232326',1,0,'2022-03-03 13:01:56','2022-03-03 13:01:56'),(75131,221,'Dinapur','233232',1,0,'2022-03-03 13:01:56','2022-03-03 13:01:56'),(75132,221,'Dora','275204',1,0,'2022-03-03 13:01:56','2022-03-03 13:01:56'),(75133,221,'Dorasar','233226',1,0,'2022-03-03 13:01:56','2022-03-03 13:01:56'),(75134,221,'Dubiha','233225',1,0,'2022-03-03 13:01:56','2022-03-03 13:01:56'),(75135,221,'Dullahpur','275202',1,0,'2022-03-03 13:01:56','2022-03-03 13:01:56'),(75136,221,'Fadanpur','233002',1,0,'2022-03-03 13:01:56','2022-03-03 13:01:56'),(75137,221,'Fateullahpur','233302',1,0,'2022-03-03 13:01:56','2022-03-03 13:01:56'),(75138,221,'Gadaipur','275204',1,0,'2022-03-03 13:01:56','2022-03-03 13:01:56'),(75139,221,'Gahli Basarikpur','233226',1,0,'2022-03-03 13:01:56','2022-03-03 13:01:56'),(75140,221,'Gahmar Bazar','232327',1,0,'2022-03-03 13:01:57','2022-03-03 13:01:57'),(75141,221,'Gahmar','232327',1,0,'2022-03-03 13:01:57','2022-03-03 13:01:57'),(75142,221,'Gai','233226',1,0,'2022-03-03 13:01:57','2022-03-03 13:01:57'),(75143,221,'Gaighat','232331',1,0,'2022-03-03 13:01:57','2022-03-03 13:01:57'),(75144,221,'Gandhinagar','233225',1,0,'2022-03-03 13:01:57','2022-03-03 13:01:57'),(75145,221,'Gangauli','233222',1,0,'2022-03-03 13:01:57','2022-03-03 13:01:57'),(75146,221,'Garua Maksudpur','232332',1,0,'2022-03-03 13:01:57','2022-03-03 13:01:57'),(75147,221,'Gathia','233222',1,0,'2022-03-03 13:01:57','2022-03-03 13:01:57'),(75148,221,'Gaura','233304',1,0,'2022-03-03 13:01:57','2022-03-03 13:01:57'),(75149,221,'Gaura','232328',1,0,'2022-03-03 13:01:57','2022-03-03 13:01:57'),(75150,221,'Gauri','233223',1,0,'2022-03-03 13:01:57','2022-03-03 13:01:57'),(75151,221,'Gauspur','233227',1,0,'2022-03-03 13:01:57','2022-03-03 13:01:57'),(75152,221,'Ghariha','233226',1,0,'2022-03-03 13:01:57','2022-03-03 13:01:57'),(75153,221,'Ghazipur City','233001',1,0,'2022-03-03 13:01:57','2022-03-03 13:01:57'),(75154,221,'Ghazipur H.O','233001',1,0,'2022-03-03 13:01:57','2022-03-03 13:01:57'),(75155,221,'Ghazipur RS','233001',1,0,'2022-03-03 13:01:57','2022-03-03 13:01:57'),(75156,221,'Gobindpur','233226',1,0,'2022-03-03 13:01:57','2022-03-03 13:01:57'),(75157,221,'Gohda Bishunpura','232326',1,0,'2022-03-03 13:01:57','2022-03-03 13:01:57'),(75158,221,'Gondaur','233225',1,0,'2022-03-03 13:01:57','2022-03-03 13:01:57'),(75159,221,'Gorsara','232333',1,0,'2022-03-03 13:01:57','2022-03-03 13:01:57'),(75160,221,'Goshalpur','233228',1,0,'2022-03-03 13:01:57','2022-03-03 13:01:57'),(75161,221,'Goshandepur','233232',1,0,'2022-03-03 13:01:57','2022-03-03 13:01:57'),(75162,221,'Gumma','233305',1,0,'2022-03-03 13:01:57','2022-03-03 13:01:57'),(75163,221,'Guraini','275205',1,0,'2022-03-03 13:01:58','2022-03-03 13:01:58'),(75164,221,'Hajipur Baresar','233222',1,0,'2022-03-03 13:01:58','2022-03-03 13:01:58'),(75165,221,'Hansrajpur','233310',1,0,'2022-03-03 13:01:58','2022-03-03 13:01:58'),(75166,221,'Hardaspur Kalan','275202',1,0,'2022-03-03 13:01:58','2022-03-03 13:01:58'),(75167,221,'Harhari','233226',1,0,'2022-03-03 13:01:58','2022-03-03 13:01:58'),(75168,221,'Hartmanpur','233225',1,0,'2022-03-03 13:01:58','2022-03-03 13:01:58'),(75169,221,'Holipur','233304',1,0,'2022-03-03 13:01:58','2022-03-03 13:01:58'),(75170,221,'Hurmuzpur','275204',1,0,'2022-03-03 13:01:58','2022-03-03 13:01:58'),(75171,221,'Hussainpur','233002',1,0,'2022-03-03 13:01:58','2022-03-03 13:01:58'),(75172,221,'Indaur','233226',1,0,'2022-03-03 13:01:58','2022-03-03 13:01:58'),(75173,221,'Jahurabad','233222',1,0,'2022-03-03 13:01:58','2022-03-03 13:01:58'),(75174,221,'Jaitpura','233002',1,0,'2022-03-03 13:01:58','2022-03-03 13:01:58'),(75175,221,'Jakhania','275203',1,0,'2022-03-03 13:01:58','2022-03-03 13:01:58'),(75176,221,'Jalalabad','275202',1,0,'2022-03-03 13:01:58','2022-03-03 13:01:58'),(75177,221,'Jalalpurdhani','275203',1,0,'2022-03-03 13:01:58','2022-03-03 13:01:58'),(75178,221,'Jashdeopur','233231',1,0,'2022-03-03 13:01:58','2022-03-03 13:01:58'),(75179,221,'Jeevpur','232340',1,0,'2022-03-03 13:01:58','2022-03-03 13:01:58'),(75180,221,'Jewal','233306',1,0,'2022-03-03 13:01:58','2022-03-03 13:01:58'),(75181,221,'Jhotna','275203',1,0,'2022-03-03 13:01:58','2022-03-03 13:01:58'),(75182,221,'Joga Musahib','233233',1,0,'2022-03-03 13:01:58','2022-03-03 13:01:58'),(75183,221,'Kaithwalia','233002',1,0,'2022-03-03 13:01:58','2022-03-03 13:01:58'),(75184,221,'Kamupur','233229',1,0,'2022-03-03 13:01:58','2022-03-03 13:01:58'),(75185,221,'Kaneri','233304',1,0,'2022-03-03 13:01:58','2022-03-03 13:01:58'),(75186,221,'Kansahari','233226',1,0,'2022-03-03 13:01:58','2022-03-03 13:01:58'),(75187,221,'Kanuwan','233231',1,0,'2022-03-03 13:01:58','2022-03-03 13:01:58'),(75188,221,'Karahiya','232339',1,0,'2022-03-03 13:01:58','2022-03-03 13:01:58'),(75189,221,'Karampur','233221',1,0,'2022-03-03 13:01:59','2022-03-03 13:01:59'),(75190,221,'Karanda','233224',1,0,'2022-03-03 13:01:59','2022-03-03 13:01:59'),(75191,221,'Karimuddinpur','233225',1,0,'2022-03-03 13:01:59','2022-03-03 13:01:59'),(75192,221,'Kasimabad','233230',1,0,'2022-03-03 13:01:59','2022-03-03 13:01:59'),(75193,221,'Kataila','233305',1,0,'2022-03-03 13:01:59','2022-03-03 13:01:59'),(75194,221,'Kataria','233301',1,0,'2022-03-03 13:01:59','2022-03-03 13:01:59'),(75195,221,'Katghara','233311',1,0,'2022-03-03 13:01:59','2022-03-03 13:01:59'),(75196,221,'Kathar','233231',1,0,'2022-03-03 13:01:59','2022-03-03 13:01:59'),(75197,221,'Kelhi','233226',1,0,'2022-03-03 13:01:59','2022-03-03 13:01:59'),(75198,221,'Khairabari','233233',1,0,'2022-03-03 13:01:59','2022-03-03 13:01:59'),(75199,221,'Khajurgaon','233230',1,0,'2022-03-03 13:01:59','2022-03-03 13:01:59'),(75200,221,'Khalispur','233002',1,0,'2022-03-03 13:01:59','2022-03-03 13:01:59'),(75201,221,'Khanpur','233223',1,0,'2022-03-03 13:01:59','2022-03-03 13:01:59'),(75202,221,'Khardiha','233233',1,0,'2022-03-03 13:01:59','2022-03-03 13:01:59'),(75203,221,'Khargasipur Urf Naibazar','232331',1,0,'2022-03-03 13:01:59','2022-03-03 13:01:59'),(75204,221,'Kharwadih','275205',1,0,'2022-03-03 13:01:59','2022-03-03 13:01:59'),(75205,221,'Khetabpur','275203',1,0,'2022-03-03 13:01:59','2022-03-03 13:01:59'),(75206,221,'Khetabpur','233230',1,0,'2022-03-03 13:01:59','2022-03-03 13:01:59'),(75207,221,'Khidirganj','233307',1,0,'2022-03-03 13:01:59','2022-03-03 13:01:59'),(75208,221,'Kondari','233226',1,0,'2022-03-03 13:01:59','2022-03-03 13:01:59'),(75209,221,'Kundesar','233227',1,0,'2022-03-03 13:01:59','2022-03-03 13:01:59'),(75210,221,'Kusi','232326',1,0,'2022-03-03 13:01:59','2022-03-03 13:01:59'),(75211,221,'Kusumhi Kalan','233302',1,0,'2022-03-03 13:01:59','2022-03-03 13:01:59'),(75212,221,'Lahna','232333',1,0,'2022-03-03 13:01:59','2022-03-03 13:01:59'),(75213,221,'Lahuwar','232329',1,0,'2022-03-03 13:02:00','2022-03-03 13:02:00'),(75214,221,'Lauwadih','233233',1,0,'2022-03-03 13:02:00','2022-03-03 13:02:00'),(75215,221,'Lawa','233303',1,0,'2022-03-03 13:02:00','2022-03-03 13:02:00'),(75216,221,'Lediha','275202',1,0,'2022-03-03 13:02:00','2022-03-03 13:02:00'),(75217,221,'Lilapur','233224',1,0,'2022-03-03 13:02:00','2022-03-03 13:02:00'),(75218,221,'Loharpur','233231',1,0,'2022-03-03 13:02:00','2022-03-03 13:02:00'),(75219,221,'Machhati','233227',1,0,'2022-03-03 13:02:00','2022-03-03 13:02:00'),(75220,221,'Madanahi','233302',1,0,'2022-03-03 13:02:00','2022-03-03 13:02:00'),(75221,221,'Maharaur','233230',1,0,'2022-03-03 13:02:00','2022-03-03 13:02:00'),(75222,221,'Mahend','233228',1,0,'2022-03-03 13:02:00','2022-03-03 13:02:00'),(75223,221,'Mahespur Kalan','233222',1,0,'2022-03-03 13:02:00','2022-03-03 13:02:00'),(75224,221,'Mahna','232333',1,0,'2022-03-03 13:02:00','2022-03-03 13:02:00'),(75225,221,'Mahpur','233304',1,0,'2022-03-03 13:02:00','2022-03-03 13:02:00'),(75226,221,'Mahrajganj','233002',1,0,'2022-03-03 13:02:00','2022-03-03 13:02:00'),(75227,221,'Mahuwari','275201',1,0,'2022-03-03 13:02:00','2022-03-03 13:02:00'),(75228,221,'Mainpur','233224',1,0,'2022-03-03 13:02:00','2022-03-03 13:02:00'),(75229,221,'Makhdumpur','233307',1,0,'2022-03-03 13:02:00','2022-03-03 13:02:00'),(75230,221,'Malikpura','233310',1,0,'2022-03-03 13:02:00','2022-03-03 13:02:00'),(75231,221,'Malsa','232336',1,0,'2022-03-03 13:02:00','2022-03-03 13:02:00'),(75232,221,'Mangari','233307',1,0,'2022-03-03 13:02:00','2022-03-03 13:02:00'),(75233,221,'Manihari','275205',1,0,'2022-03-03 13:02:00','2022-03-03 13:02:00'),(75234,221,'Maniya','232333',1,0,'2022-03-03 13:02:00','2022-03-03 13:02:00'),(75235,221,'Manpur','233305',1,0,'2022-03-03 13:02:01','2022-03-03 13:02:01'),(75236,221,'Mardah','233226',1,0,'2022-03-03 13:02:01','2022-03-03 13:02:01'),(75237,221,'Markeenganj','233001',1,0,'2022-03-03 13:02:01','2022-03-03 13:02:01'),(75238,221,'Mason','233231',1,0,'2022-03-03 13:02:01','2022-03-03 13:02:01'),(75239,221,'Mata','233229',1,0,'2022-03-03 13:02:01','2022-03-03 13:02:01'),(75240,221,'Matehu','233226',1,0,'2022-03-03 13:02:01','2022-03-03 13:02:01'),(75241,221,'Maudha','233221',1,0,'2022-03-03 13:02:01','2022-03-03 13:02:01'),(75242,221,'Maudhia','275204',1,0,'2022-03-03 13:02:01','2022-03-03 13:02:01'),(75243,221,'Maura','233225',1,0,'2022-03-03 13:02:01','2022-03-03 13:02:01'),(75244,221,'Miranpur','233303',1,0,'2022-03-03 13:02:01','2022-03-03 13:02:01'),(75245,221,'Mircha','232326',1,0,'2022-03-03 13:02:01','2022-03-03 13:02:01'),(75246,221,'Mirpur','275204',1,0,'2022-03-03 13:02:01','2022-03-03 13:02:01'),(75247,221,'Mirzabad Mania','233231',1,0,'2022-03-03 13:02:01','2022-03-03 13:02:01'),(75248,221,'Mirzapur','275204',1,0,'2022-03-03 13:02:01','2022-03-03 13:02:01'),(75249,221,'Mohammadabad Yusufpur','233227',1,0,'2022-03-03 13:02:01','2022-03-03 13:02:01'),(75250,221,'Mohammadpur','232326',1,0,'2022-03-03 13:02:01','2022-03-03 13:02:01'),(75251,221,'Mubarakpur (Ghazipur)','233301',1,0,'2022-03-03 13:02:01','2022-03-03 13:02:01'),(75252,221,'Mundera','233233',1,0,'2022-03-03 13:02:01','2022-03-03 13:02:01'),(75253,221,'Muriyar','233304',1,0,'2022-03-03 13:02:01','2022-03-03 13:02:01'),(75254,221,'Murki Kalan','233227',1,0,'2022-03-03 13:02:01','2022-03-03 13:02:01'),(75255,221,'Murtazipur','233227',1,0,'2022-03-03 13:02:01','2022-03-03 13:02:01'),(75256,221,'Nagsar','232326',1,0,'2022-03-03 13:02:01','2022-03-03 13:02:01'),(75257,221,'Naisare','233302',1,0,'2022-03-03 13:02:02','2022-03-03 13:02:02'),(75258,221,'Nakhatpur','233226',1,0,'2022-03-03 13:02:02','2022-03-03 13:02:02'),(75259,221,'Nandganj','233302',1,0,'2022-03-03 13:02:02','2022-03-03 13:02:02'),(75260,221,'Narainpur','233229',1,0,'2022-03-03 13:02:02','2022-03-03 13:02:02'),(75261,221,'Nari Pachdeora','233302',1,0,'2022-03-03 13:02:02','2022-03-03 13:02:02'),(75262,221,'Narsinghpur','232331',1,0,'2022-03-03 13:02:02','2022-03-03 13:02:02'),(75263,221,'Nasirpur','232339',1,0,'2022-03-03 13:02:02','2022-03-03 13:02:02'),(75264,221,'Nauli','232333',1,0,'2022-03-03 13:02:02','2022-03-03 13:02:02'),(75265,221,'Newada','233223',1,0,'2022-03-03 13:02:02','2022-03-03 13:02:02'),(75266,221,'Nonhara','233303',1,0,'2022-03-03 13:02:02','2022-03-03 13:02:02'),(75267,221,'Noorpur','233002',1,0,'2022-03-03 13:02:02','2022-03-03 13:02:02'),(75268,221,'NSS Mill','233311',1,0,'2022-03-03 13:02:02','2022-03-03 13:02:02'),(75269,221,'Orarai','275202',1,0,'2022-03-03 13:02:02','2022-03-03 13:02:02'),(75270,221,'Orasan','275203',1,0,'2022-03-03 13:02:02','2022-03-03 13:02:02'),(75271,221,'Pachauri','232327',1,0,'2022-03-03 13:02:02','2022-03-03 13:02:02'),(75272,221,'Pachokhar','232329',1,0,'2022-03-03 13:02:02','2022-03-03 13:02:02'),(75273,221,'Padumpur','275203',1,0,'2022-03-03 13:02:02','2022-03-03 13:02:02'),(75274,221,'Pahalwanpur','233311',1,0,'2022-03-03 13:02:02','2022-03-03 13:02:02'),(75275,221,'Paharpur Kalan','233306',1,0,'2022-03-03 13:02:02','2022-03-03 13:02:02'),(75276,221,'Pahetia','233305',1,0,'2022-03-03 13:02:02','2022-03-03 13:02:02'),(75277,221,'Pakari','232328',1,0,'2022-03-03 13:02:02','2022-03-03 13:02:02'),(75278,221,'Pakhanpura','233227',1,0,'2022-03-03 13:02:02','2022-03-03 13:02:02'),(75279,221,'Pali','275201',1,0,'2022-03-03 13:02:02','2022-03-03 13:02:02'),(75280,221,'Paliwar','275204',1,0,'2022-03-03 13:02:02','2022-03-03 13:02:02'),(75281,221,'Pandepur Radhey','233300',1,0,'2022-03-03 13:02:03','2022-03-03 13:02:03'),(75282,221,'Para','233303',1,0,'2022-03-03 13:02:03','2022-03-03 13:02:03'),(75283,221,'Parasa','233301',1,0,'2022-03-03 13:02:03','2022-03-03 13:02:03'),(75284,221,'Pardhan Ki Bareji','233227',1,0,'2022-03-03 13:02:03','2022-03-03 13:02:03'),(75285,221,'Parsotia','233311',1,0,'2022-03-03 13:02:03','2022-03-03 13:02:03'),(75286,221,'Patar','233228',1,0,'2022-03-03 13:02:03','2022-03-03 13:02:03'),(75287,221,'Patepur','233225',1,0,'2022-03-03 13:02:03','2022-03-03 13:02:03'),(75288,221,'Patkaniya','232332',1,0,'2022-03-03 13:02:03','2022-03-03 13:02:03'),(75289,221,'Peernagar','233002',1,0,'2022-03-03 13:02:03','2022-03-03 13:02:03'),(75290,221,'Permeth','233002',1,0,'2022-03-03 13:02:03','2022-03-03 13:02:03'),(75291,221,'Phulli','232329',1,0,'2022-03-03 13:02:03','2022-03-03 13:02:03'),(75292,221,'Pipnar','233226',1,0,'2022-03-03 13:02:03','2022-03-03 13:02:03'),(75293,221,'Pithapur','233002',1,0,'2022-03-03 13:02:03','2022-03-03 13:02:03'),(75294,221,'Prithvipur','233226',1,0,'2022-03-03 13:02:03','2022-03-03 13:02:03'),(75295,221,'Puraina','233232',1,0,'2022-03-03 13:02:03','2022-03-03 13:02:03'),(75296,221,'Raipur','275204',1,0,'2022-03-03 13:02:03','2022-03-03 13:02:03'),(75297,221,'Rajapur','233301',1,0,'2022-03-03 13:02:03','2022-03-03 13:02:03'),(75298,221,'Rajapur Katya','233230',1,0,'2022-03-03 13:02:03','2022-03-03 13:02:03'),(75299,221,'Raksaha','232326',1,0,'2022-03-03 13:02:03','2022-03-03 13:02:03'),(75300,221,'Ramgarh','275201',1,0,'2022-03-03 13:02:03','2022-03-03 13:02:03'),(75301,221,'Rampur Balbhadra','275203',1,0,'2022-03-03 13:02:03','2022-03-03 13:02:03'),(75302,221,'Rampur Jiwan','233305',1,0,'2022-03-03 13:02:03','2022-03-03 13:02:03'),(75303,221,'Rampur Majha','233306',1,0,'2022-03-03 13:02:04','2022-03-03 13:02:04'),(75304,221,'Rampur (Ghazipur)','233223',1,0,'2022-03-03 13:02:04','2022-03-03 13:02:04'),(75305,221,'Ranipur','233300',1,0,'2022-03-03 13:02:04','2022-03-03 13:02:04'),(75306,221,'Rasulpur Kanhwara','233002',1,0,'2022-03-03 13:02:04','2022-03-03 13:02:04'),(75307,221,'Rasulpur Pacharasi','233306',1,0,'2022-03-03 13:02:04','2022-03-03 13:02:04'),(75308,221,'Rauza','233002',1,0,'2022-03-03 13:02:04','2022-03-03 13:02:04'),(75309,221,'Rehti Malipur','275202',1,0,'2022-03-03 13:02:04','2022-03-03 13:02:04'),(75310,221,'Renga','233222',1,0,'2022-03-03 13:02:04','2022-03-03 13:02:04'),(75311,221,'Reosara','233233',1,0,'2022-03-03 13:02:04','2022-03-03 13:02:04'),(75312,221,'Reotipur','232328',1,0,'2022-03-03 13:02:04','2022-03-03 13:02:04'),(75313,221,'Rohura','232331',1,0,'2022-03-03 13:02:04','2022-03-03 13:02:04'),(75314,221,'Ruhipur','233300',1,0,'2022-03-03 13:02:04','2022-03-03 13:02:04'),(75315,221,'Sabbalpur Kalan','232340',1,0,'2022-03-03 13:02:04','2022-03-03 13:02:04'),(75316,221,'Sabua','233302',1,0,'2022-03-03 13:02:04','2022-03-03 13:02:04'),(75317,221,'Sadarjahanpur','275203',1,0,'2022-03-03 13:02:04','2022-03-03 13:02:04'),(75318,221,'Sadat','275204',1,0,'2022-03-03 13:02:04','2022-03-03 13:02:04'),(75319,221,'Saheri','233302',1,0,'2022-03-03 13:02:04','2022-03-03 13:02:04'),(75320,221,'Saidabad','232340',1,0,'2022-03-03 13:02:04','2022-03-03 13:02:04'),(75321,221,'Saidpur Bazar','233304',1,0,'2022-03-03 13:02:04','2022-03-03 13:02:04'),(75322,221,'Saidpur (Ghazipur)','233304',1,0,'2022-03-03 13:02:04','2022-03-03 13:02:04'),(75323,221,'Saitapatti','233232',1,0,'2022-03-03 13:02:04','2022-03-03 13:02:04'),(75324,221,'Salamatpur','275201',1,0,'2022-03-03 13:02:04','2022-03-03 13:02:04'),(75325,221,'Salempur Baghai','275204',1,0,'2022-03-03 13:02:05','2022-03-03 13:02:05'),(75326,221,'Sammanpur','233306',1,0,'2022-03-03 13:02:05','2022-03-03 13:02:05'),(75327,221,'Sarahula','232326',1,0,'2022-03-03 13:02:05','2022-03-03 13:02:05'),(75328,221,'Sarai Gobind','233310',1,0,'2022-03-03 13:02:05','2022-03-03 13:02:05'),(75329,221,'Sarai Gokul','233002',1,0,'2022-03-03 13:02:05','2022-03-03 13:02:05'),(75330,221,'Satramganj Bazar','232333',1,0,'2022-03-03 13:02:05','2022-03-03 13:02:05'),(75331,221,'Sauna','233221',1,0,'2022-03-03 13:02:05','2022-03-03 13:02:05'),(75332,221,'Sauram','233302',1,0,'2022-03-03 13:02:05','2022-03-03 13:02:05'),(75333,221,'Sauri','275205',1,0,'2022-03-03 13:02:05','2022-03-03 13:02:05'),(75334,221,'Sayer','232327',1,0,'2022-03-03 13:02:05','2022-03-03 13:02:05'),(75335,221,'Semara','233227',1,0,'2022-03-03 13:02:05','2022-03-03 13:02:05'),(75336,221,'Semaur','233222',1,0,'2022-03-03 13:02:05','2022-03-03 13:02:05'),(75337,221,'Seorai','232333',1,0,'2022-03-03 13:02:05','2022-03-03 13:02:05'),(75338,221,'Shadiabad','275205',1,0,'2022-03-03 13:02:05','2022-03-03 13:02:05'),(75339,221,'Shahbazkuli','233227',1,0,'2022-03-03 13:02:05','2022-03-03 13:02:05'),(75340,221,'Shekhanpur','233230',1,0,'2022-03-03 13:02:05','2022-03-03 13:02:05'),(75341,221,'Sherpur Kalan','233227',1,0,'2022-03-03 13:02:05','2022-03-03 13:02:05'),(75342,221,'Shishuapar','275204',1,0,'2022-03-03 13:02:05','2022-03-03 13:02:05'),(75343,221,'Sidhaut','233230',1,0,'2022-03-03 13:02:05','2022-03-03 13:02:05'),(75344,221,'Sihori','233311',1,0,'2022-03-03 13:02:05','2022-03-03 13:02:05'),(75345,221,'Sikandarpur','233224',1,0,'2022-03-03 13:02:05','2022-03-03 13:02:05'),(75346,221,'Sikhari','275202',1,0,'2022-03-03 13:02:05','2022-03-03 13:02:05'),(75347,221,'Singarpur','233221',1,0,'2022-03-03 13:02:05','2022-03-03 13:02:05'),(75348,221,'Singera','233226',1,0,'2022-03-03 13:02:06','2022-03-03 13:02:06'),(75349,221,'Sinhani','232326',1,0,'2022-03-03 13:02:06','2022-03-03 13:02:06'),(75350,221,'Siyari','233233',1,0,'2022-03-03 13:02:06','2022-03-03 13:02:06'),(75351,221,'Sohilapur','233002',1,0,'2022-03-03 13:02:06','2022-03-03 13:02:06'),(75352,221,'Soniyapar','233221',1,0,'2022-03-03 13:02:06','2022-03-03 13:02:06'),(75353,221,'Sonwani','233228',1,0,'2022-03-03 13:02:06','2022-03-03 13:02:06'),(75354,221,'Subhashnagar (Ghazipur)','233001',1,0,'2022-03-03 13:02:06','2022-03-03 13:02:06'),(75355,221,'Suhwal','232332',1,0,'2022-03-03 13:02:06','2022-03-03 13:02:06'),(75356,221,'Sujanipur','233311',1,0,'2022-03-03 13:02:06','2022-03-03 13:02:06'),(75357,221,'Sukhdehra','233231',1,0,'2022-03-03 13:02:06','2022-03-03 13:02:06'),(75358,221,'Surhurpur','275205',1,0,'2022-03-03 13:02:06','2022-03-03 13:02:06'),(75359,221,'Tajpur Dehma','233228',1,0,'2022-03-03 13:02:06','2022-03-03 13:02:06'),(75360,221,'Tajpur Kurra','232326',1,0,'2022-03-03 13:02:06','2022-03-03 13:02:06'),(75361,221,'Tajpur Majnha','232340',1,0,'2022-03-03 13:02:06','2022-03-03 13:02:06'),(75362,221,'Talwal','233002',1,0,'2022-03-03 13:02:06','2022-03-03 13:02:06'),(75363,221,'Tamalpura','233227',1,0,'2022-03-03 13:02:06','2022-03-03 13:02:06'),(75364,221,'Tandawan','233227',1,0,'2022-03-03 13:02:06','2022-03-03 13:02:06'),(75365,221,'Taraon','233306',1,0,'2022-03-03 13:02:06','2022-03-03 13:02:06'),(75366,221,'Taraon Balua','233231',1,0,'2022-03-03 13:02:06','2022-03-03 13:02:06'),(75367,221,'Tarighat','232332',1,0,'2022-03-03 13:02:06','2022-03-03 13:02:06'),(75368,221,'Tilesara','233300',1,0,'2022-03-03 13:02:06','2022-03-03 13:02:06'),(75369,221,'Tirchhi','275202',1,0,'2022-03-03 13:02:06','2022-03-03 13:02:06'),(75370,221,'Tisaura','232340',1,0,'2022-03-03 13:02:06','2022-03-03 13:02:06'),(75371,221,'Tiwaripur','233227',1,0,'2022-03-03 13:02:06','2022-03-03 13:02:06'),(75372,221,'Tiyari','232326',1,0,'2022-03-03 13:02:07','2022-03-03 13:02:07'),(75373,221,'Tokwa','232331',1,0,'2022-03-03 13:02:07','2022-03-03 13:02:07'),(75374,221,'Turna','233306',1,0,'2022-03-03 13:02:07','2022-03-03 13:02:07'),(75375,221,'Uchauri','233307',1,0,'2022-03-03 13:02:07','2022-03-03 13:02:07'),(75376,221,'Ukraon','275204',1,0,'2022-03-03 13:02:07','2022-03-03 13:02:07'),(75377,221,'Umarganj Nariaon','232329',1,0,'2022-03-03 13:02:07','2022-03-03 13:02:07'),(75378,221,'Usia','232330',1,0,'2022-03-03 13:02:07','2022-03-03 13:02:07'),(75379,221,'Utraon','233225',1,0,'2022-03-03 13:02:07','2022-03-03 13:02:07'),(75380,221,'Utrauli','232333',1,0,'2022-03-03 13:02:07','2022-03-03 13:02:07'),(75381,221,'Yusufpur','233310',1,0,'2022-03-03 13:02:07','2022-03-03 13:02:07'),(75382,221,'Yusufpur Bazar','233227',1,0,'2022-03-03 13:02:07','2022-03-03 13:02:07'),(75383,221,'Yuvrajpur','232332',1,0,'2022-03-03 13:02:07','2022-03-03 13:02:07'),(75384,221,'Zamania Bazar','232329',1,0,'2022-03-03 13:02:07','2022-03-03 13:02:07'),(75385,221,'Zamania RS','232331',1,0,'2022-03-03 13:02:07','2022-03-03 13:02:07'),(75386,221,'Zamania','232329',1,0,'2022-03-03 13:02:07','2022-03-03 13:02:07'),(75387,221,'Zangipur','233305',1,0,'2022-03-03 13:02:07','2022-03-03 13:02:07'),(75388,222,'Achalpur','271124',1,0,'2022-03-03 13:02:07','2022-03-03 13:02:07'),(75389,222,'Achalpur Kaithawalia','271307',1,0,'2022-03-03 13:02:07','2022-03-03 13:02:07'),(75390,222,'Adampur','271401',1,0,'2022-03-03 13:02:07','2022-03-03 13:02:07'),(75391,222,'Ahiya Chet','271503',1,0,'2022-03-03 13:02:07','2022-03-03 13:02:07'),(75392,222,'Ailanpur Grant','271305',1,0,'2022-03-03 13:02:07','2022-03-03 13:02:07'),(75393,222,'Aili Parsauli','271402',1,0,'2022-03-03 13:02:07','2022-03-03 13:02:07'),(75394,222,'Akbar Pur','271309',1,0,'2022-03-03 13:02:07','2022-03-03 13:02:07'),(75395,222,'Akohari','271504',1,0,'2022-03-03 13:02:07','2022-03-03 13:02:07'),(75396,222,'Allipur Grant','271312',1,0,'2022-03-03 13:02:07','2022-03-03 13:02:07'),(75397,222,'Amdahi','271403',1,0,'2022-03-03 13:02:08','2022-03-03 13:02:08'),(75398,222,'Andhiyari','271302',1,0,'2022-03-03 13:02:08','2022-03-03 13:02:08'),(75399,222,'Ashidha','271204',1,0,'2022-03-03 13:02:08','2022-03-03 13:02:08'),(75400,222,'Ashokpur','271303',1,0,'2022-03-03 13:02:08','2022-03-03 13:02:08'),(75401,222,'Ata','271504',1,0,'2022-03-03 13:02:08','2022-03-03 13:02:08'),(75402,222,'Ayah','271202',1,0,'2022-03-03 13:02:08','2022-03-03 13:02:08'),(75403,222,'B.B..Singh','271126',1,0,'2022-03-03 13:02:08','2022-03-03 13:02:08'),(75404,222,'B.P.Bhujai','271126',1,0,'2022-03-03 13:02:08','2022-03-03 13:02:08'),(75405,222,'Babhani','271124',1,0,'2022-03-03 13:02:08','2022-03-03 13:02:08'),(75406,222,'Babhani Kanoongo','271002',1,0,'2022-03-03 13:02:08','2022-03-03 13:02:08'),(75407,222,'Babhanjot','271312',1,0,'2022-03-03 13:02:08','2022-03-03 13:02:08'),(75408,222,'Babhnan Sugar Factory','271313',1,0,'2022-03-03 13:02:08','2022-03-03 13:02:08'),(75409,222,'Badsara Ram Singh','271401',1,0,'2022-03-03 13:02:08','2022-03-03 13:02:08'),(75410,222,'Bahlol Pur','271002',1,0,'2022-03-03 13:02:08','2022-03-03 13:02:08'),(75411,222,'Bahuwan Br. Majha','271504',1,0,'2022-03-03 13:02:08','2022-03-03 13:02:08'),(75412,222,'Bairi Pur Ramnath','271302',1,0,'2022-03-03 13:02:08','2022-03-03 13:02:08'),(75413,222,'Bakharwa','271603',1,0,'2022-03-03 13:02:08','2022-03-03 13:02:08'),(75414,222,'Baksaila','271401',1,0,'2022-03-03 13:02:08','2022-03-03 13:02:08'),(75415,222,'Balli Pur','271302',1,0,'2022-03-03 13:02:08','2022-03-03 13:02:08'),(75416,222,'Balmathar','271504',1,0,'2022-03-03 13:02:08','2022-03-03 13:02:08'),(75417,222,'Balpur','271125',1,0,'2022-03-03 13:02:08','2022-03-03 13:02:08'),(75418,222,'Bamdera','271125',1,0,'2022-03-03 13:02:08','2022-03-03 13:02:08'),(75419,222,'Banau','271402',1,0,'2022-03-03 13:02:09','2022-03-03 13:02:09'),(75420,222,'Banepur','271129',1,0,'2022-03-03 13:02:09','2022-03-03 13:02:09'),(75421,222,'Bangai','271122',1,0,'2022-03-03 13:02:09','2022-03-03 13:02:09'),(75422,222,'Bangai Barwar','271602',1,0,'2022-03-03 13:02:09','2022-03-03 13:02:09'),(75423,222,'Bangaon','271503',1,0,'2022-03-03 13:02:09','2022-03-03 13:02:09'),(75424,222,'Bangaon','271403',1,0,'2022-03-03 13:02:09','2022-03-03 13:02:09'),(75425,222,'Bangaonwa','271312',1,0,'2022-03-03 13:02:09','2022-03-03 13:02:09'),(75426,222,'Banjaria','271003',1,0,'2022-03-03 13:02:09','2022-03-03 13:02:09'),(75427,222,'Bankasia','271302',1,0,'2022-03-03 13:02:09','2022-03-03 13:02:09'),(75428,222,'Bankati Suryabali Singh','271602',1,0,'2022-03-03 13:02:09','2022-03-03 13:02:09'),(75429,222,'Bankatwa Dehat','271310',1,0,'2022-03-03 13:02:09','2022-03-03 13:02:09'),(75430,222,'Bankatwa','271003',1,0,'2022-03-03 13:02:09','2022-03-03 13:02:09'),(75431,222,'Banwaria','271003',1,0,'2022-03-03 13:02:09','2022-03-03 13:02:09'),(75432,222,'Barauli','271402',1,0,'2022-03-03 13:02:09','2022-03-03 13:02:09'),(75433,222,'Bargadi Kot','271311',1,0,'2022-03-03 13:02:09','2022-03-03 13:02:09'),(75434,222,'Bargaon (Gonda)','271002',1,0,'2022-03-03 13:02:09','2022-03-03 13:02:09'),(75435,222,'Barnapur','271401',1,0,'2022-03-03 13:02:09','2022-03-03 13:02:09'),(75436,222,'Baruee Gondha','271125',1,0,'2022-03-03 13:02:09','2022-03-03 13:02:09'),(75437,222,'Bauriha','271123',1,0,'2022-03-03 13:02:09','2022-03-03 13:02:09'),(75438,222,'Beerpur Bhoj','271122',1,0,'2022-03-03 13:02:09','2022-03-03 13:02:09'),(75439,222,'Begamganj','271402',1,0,'2022-03-03 13:02:09','2022-03-03 13:02:09'),(75440,222,'Belahri Bujurg','271313',1,0,'2022-03-03 13:02:09','2022-03-03 13:02:09'),(75441,222,'Belawa Bahuta','271202',1,0,'2022-03-03 13:02:09','2022-03-03 13:02:09'),(75442,222,'Belbhari','271602',1,0,'2022-03-03 13:02:10','2022-03-03 13:02:10'),(75443,222,'Beliya','271124',1,0,'2022-03-03 13:02:10','2022-03-03 13:02:10'),(75444,222,'Belser','271401',1,0,'2022-03-03 13:02:10','2022-03-03 13:02:10'),(75445,222,'Bhabhuwa Kot','271311',1,0,'2022-03-03 13:02:10','2022-03-03 13:02:10'),(75446,222,'Bhairampur','271122',1,0,'2022-03-03 13:02:10','2022-03-03 13:02:10'),(75447,222,'Bhangaha Hussain Nagar','271204',1,0,'2022-03-03 13:02:10','2022-03-03 13:02:10'),(75448,222,'Bhartha','271503',1,0,'2022-03-03 13:02:10','2022-03-03 13:02:10'),(75449,222,'Bhauriganj','271504',1,0,'2022-03-03 13:02:10','2022-03-03 13:02:10'),(75450,222,'Bhawanipur Uppadhyay','271209',1,0,'2022-03-03 13:02:10','2022-03-03 13:02:10'),(75451,222,'Bhgahar Buland','271123',1,0,'2022-03-03 13:02:10','2022-03-03 13:02:10'),(75452,222,'Bhitaura','271302',1,0,'2022-03-03 13:02:10','2022-03-03 13:02:10'),(75453,222,'Bhopat Pur','271309',1,0,'2022-03-03 13:02:10','2022-03-03 13:02:10'),(75454,222,'Bhorha','271302',1,0,'2022-03-03 13:02:10','2022-03-03 13:02:10'),(75455,222,'Bichhudi','271122',1,0,'2022-03-03 13:02:10','2022-03-03 13:02:10'),(75456,222,'Binuhani','271202',1,0,'2022-03-03 13:02:10','2022-03-03 13:02:10'),(75457,222,'Birahmatpur','271124',1,0,'2022-03-03 13:02:10','2022-03-03 13:02:10'),(75458,222,'Bisambharpur','271602',1,0,'2022-03-03 13:02:10','2022-03-03 13:02:10'),(75459,222,'Bishunpur Bairiya','271601',1,0,'2022-03-03 13:02:10','2022-03-03 13:02:10'),(75460,222,'Bishunpur Kla','271504',1,0,'2022-03-03 13:02:10','2022-03-03 13:02:10'),(75461,222,'Bishunpur Sangam','271202',1,0,'2022-03-03 13:02:10','2022-03-03 13:02:10'),(75462,222,'Budhupurwa','271003',1,0,'2022-03-03 13:02:10','2022-03-03 13:02:10'),(75463,222,'Burha Dewar','271002',1,0,'2022-03-03 13:02:10','2022-03-03 13:02:10'),(75464,222,'Bus Station (Gonda)','271003',1,0,'2022-03-03 13:02:11','2022-03-03 13:02:11'),(75465,222,'Chandapur (Gonda)','271129',1,0,'2022-03-03 13:02:11','2022-03-03 13:02:11'),(75466,222,'Chandawatpur','271003',1,0,'2022-03-03 13:02:11','2022-03-03 13:02:11'),(75467,222,'Chandipur','271123',1,0,'2022-03-03 13:02:11','2022-03-03 13:02:11'),(75468,222,'Chandradeep Ghat','271312',1,0,'2022-03-03 13:02:11','2022-03-03 13:02:11'),(75469,222,'Changeri','271401',1,0,'2022-03-03 13:02:11','2022-03-03 13:02:11'),(75470,222,'Charsari','271504',1,0,'2022-03-03 13:02:11','2022-03-03 13:02:11'),(75471,222,'Charu','271313',1,0,'2022-03-03 13:02:11','2022-03-03 13:02:11'),(75472,222,'Chauhan Purwa','271503',1,0,'2022-03-03 13:02:11','2022-03-03 13:02:11'),(75473,222,'Chauhattar Kalan','271208',1,0,'2022-03-03 13:02:11','2022-03-03 13:02:11'),(75474,222,'Chetpur','271123',1,0,'2022-03-03 13:02:11','2022-03-03 13:02:11'),(75475,222,'Chitrauli','271311',1,0,'2022-03-03 13:02:11','2022-03-03 13:02:11'),(75476,222,'Chuwar','271313',1,0,'2022-03-03 13:02:11','2022-03-03 13:02:11'),(75477,222,'Civil Line (Gonda)','271001',1,0,'2022-03-03 13:02:11','2022-03-03 13:02:11'),(75478,222,'Colonelganj (Gonda)','271502',1,0,'2022-03-03 13:02:11','2022-03-03 13:02:11'),(75479,222,'D.Nath','271003',1,0,'2022-03-03 13:02:11','2022-03-03 13:02:11'),(75480,222,'D.P.Ghat','271309',1,0,'2022-03-03 13:02:11','2022-03-03 13:02:11'),(75481,222,'Dadua Bazar','271002',1,0,'2022-03-03 13:02:11','2022-03-03 13:02:11'),(75482,222,'Dalpatpur','271310',1,0,'2022-03-03 13:02:11','2022-03-03 13:02:11'),(75483,222,'Darjikuwa','271123',1,0,'2022-03-03 13:02:11','2022-03-03 13:02:11'),(75484,222,'Daulatpur Grant','271312',1,0,'2022-03-03 13:02:11','2022-03-03 13:02:11'),(75485,222,'Debari Kalan','271603',1,0,'2022-03-03 13:02:11','2022-03-03 13:02:11'),(75486,222,'Deheas','271504',1,0,'2022-03-03 13:02:11','2022-03-03 13:02:11'),(75487,222,'Deoria Alawal','271601',1,0,'2022-03-03 13:02:11','2022-03-03 13:02:11'),(75488,222,'Deoria','271302',1,0,'2022-03-03 13:02:11','2022-03-03 13:02:11'),(75489,222,'Deva Pasiya','271503',1,0,'2022-03-03 13:02:11','2022-03-03 13:02:11'),(75490,222,'Devtaha','271209',1,0,'2022-03-03 13:02:12','2022-03-03 13:02:12'),(75491,222,'Dewarda','271401',1,0,'2022-03-03 13:02:12','2022-03-03 13:02:12'),(75492,222,'Dhanauli','271403',1,0,'2022-03-03 13:02:12','2022-03-03 13:02:12'),(75493,222,'Dhanawa','271311',1,0,'2022-03-03 13:02:12','2022-03-03 13:02:12'),(75494,222,'Dhaneypur','271602',1,0,'2022-03-03 13:02:12','2022-03-03 13:02:12'),(75495,222,'Dhari Ghat','271312',1,0,'2022-03-03 13:02:12','2022-03-03 13:02:12'),(75496,222,'Dhaurahara','271604',1,0,'2022-03-03 13:02:12','2022-03-03 13:02:12'),(75497,222,'Dhaurahra Ghat','271309',1,0,'2022-03-03 13:02:12','2022-03-03 13:02:12'),(75498,222,'Dhobharai','271003',1,0,'2022-03-03 13:02:12','2022-03-03 13:02:12'),(75499,222,'Dhodhey Pur','271403',1,0,'2022-03-03 13:02:12','2022-03-03 13:02:12'),(75500,222,'Dhuswa','271302',1,0,'2022-03-03 13:02:12','2022-03-03 13:02:12'),(75501,222,'Didsia Kala','271401',1,0,'2022-03-03 13:02:12','2022-03-03 13:02:12'),(75502,222,'Dinkarpur','271302',1,0,'2022-03-03 13:02:12','2022-03-03 13:02:12'),(75503,222,'Dixar','271402',1,0,'2022-03-03 13:02:12','2022-03-03 13:02:12'),(75504,222,'Dubha Bazar','271503',1,0,'2022-03-03 13:02:12','2022-03-03 13:02:12'),(75505,222,'Dulhapur','271602',1,0,'2022-03-03 13:02:12','2022-03-03 13:02:12'),(75506,222,'Dumaria Deeh','271310',1,0,'2022-03-03 13:02:12','2022-03-03 13:02:12'),(75507,222,'Durgodwa','271125',1,0,'2022-03-03 13:02:12','2022-03-03 13:02:12'),(75508,222,'Durjan Pur Pandey','271123',1,0,'2022-03-03 13:02:12','2022-03-03 13:02:12'),(75509,222,'Durjanpur','271303',1,0,'2022-03-03 13:02:12','2022-03-03 13:02:12'),(75510,222,'Dutt Nagar','271602',1,0,'2022-03-03 13:02:12','2022-03-03 13:02:12'),(75511,222,'F.P. Tarhar','271003',1,0,'2022-03-03 13:02:12','2022-03-03 13:02:12'),(75512,222,'Farenda Khurda','271312',1,0,'2022-03-03 13:02:12','2022-03-03 13:02:12'),(75513,222,'Fattepur','271312',1,0,'2022-03-03 13:02:12','2022-03-03 13:02:12'),(75514,222,'Forbisganj','271003',1,0,'2022-03-03 13:02:12','2022-03-03 13:02:12'),(75515,222,'Gaighat','271305',1,0,'2022-03-03 13:02:12','2022-03-03 13:02:12'),(75516,222,'Gaj Singh J Pur','271402',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75517,222,'Garauli','271403',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75518,222,'Gauhani','271309',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75519,222,'Gaura Chawki','271312',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75520,222,'Gedsar','271309',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75521,222,'Ghacha','271309',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75522,222,'Ghunahi','271302',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75523,222,'Gilauli','271202',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75524,222,'Gobrepurwa','271311',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75525,222,'Gonda City','271003',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75526,222,'Gonda H.O','271001',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75527,222,'Gopipur','271401',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75528,222,'Govindpara','271301',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75529,222,'Gursari','271502',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75530,222,'Gurwalia','271311',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75531,222,'Hadiagad','271125',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75532,222,'Haldhar Mau','271126',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75533,222,'Haribashpur','271319',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75534,222,'Harna Tayar','271302',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75535,222,'Harsinghwa Chauhan','271302',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75536,222,'Hathiagarh','271312',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75537,222,'Hathini Bhopatpur','271305',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75538,222,'Imiliarupi','271601',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75539,222,'Imliya Gurdayal','271002',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75540,222,'Intyathok','271202',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75541,222,'Ismaila','271312',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75542,222,'Iti Mankapur','271308',1,0,'2022-03-03 13:02:13','2022-03-03 13:02:13'),(75543,222,'Jahgirwa','271311',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75544,222,'Jaiprabha Gram','271209',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75545,222,'Jamtha','271403',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75546,222,'Janki Nagar','271209',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75547,222,'Jarauli','271504',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75548,222,'Jhalidham','271204',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75549,222,'Jhauhana','271003',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75550,222,'Jhilahi','271302',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75551,222,'Jigana Bazar','271302',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75552,222,'K.C.Pur','271003',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75553,222,'Kaithola','271125',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75554,222,'Kandaru','271502',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75555,222,'Karamdeeh','271601',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75556,222,'Karda','271124',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75557,222,'Karnipur Deeh','271129',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75558,222,'Karoha Man','271302',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75559,222,'Kasipur','271310',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75560,222,'Katra Bazar (Gonda)','271503',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75561,222,'Katuwa Nala','271503',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75562,222,'Kauraha Jagdish Pur','271126',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75563,222,'Kauria','271122',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75564,222,'Keshav Nagar Grant','271312',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75565,222,'Keshav Pur Paharwa','271003',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75566,222,'Khadauwan','271319',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75567,222,'Khairam Lalwa Chak','271122',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75568,222,'Khamariaha Bujurg','271313',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75569,222,'Khargoopur','271204',1,0,'2022-03-03 13:02:14','2022-03-03 13:02:14'),(75570,222,'Khargupur','271303',1,0,'2022-03-03 13:02:15','2022-03-03 13:02:15'),(75571,222,'Kharthari','271126',1,0,'2022-03-03 13:02:15','2022-03-03 13:02:15'),(75572,222,'Kherideeh','271124',1,0,'2022-03-03 13:02:15','2022-03-03 13:02:15'),(75573,222,'Khirai Khirwa','271301',1,0,'2022-03-03 13:02:15','2022-03-03 13:02:15'),(75574,222,'Khojanpur','271403',1,0,'2022-03-03 13:02:15','2022-03-03 13:02:15'),(75575,222,'Khorasha','271123',1,0,'2022-03-03 13:02:15','2022-03-03 13:02:15'),(75576,222,'Kindhaura','271403',1,0,'2022-03-03 13:02:15','2022-03-03 13:02:15'),(75577,222,'Kisundaspur','271303',1,0,'2022-03-03 13:02:15','2022-03-03 13:02:15'),(75578,222,'Kodar','271124',1,0,'2022-03-03 13:02:15','2022-03-03 13:02:15'),(75579,222,'Kolahanpur Visen','271319',1,0,'2022-03-03 13:02:15','2022-03-03 13:02:15'),(75580,222,'Kook Nagar Grant','271312',1,0,'2022-03-03 13:02:15','2022-03-03 13:02:15'),(75581,222,'Kotha','271129',1,0,'2022-03-03 13:02:15','2022-03-03 13:02:15'),(75582,222,'Kotiya Madara','271503',1,0,'2022-03-03 13:02:15','2022-03-03 13:02:15'),(75583,222,'Kotkhas','271313',1,0,'2022-03-03 13:02:15','2022-03-03 13:02:15'),(75584,222,'Kundwa Tewaripur','271504',1,0,'2022-03-03 13:02:15','2022-03-03 13:02:15'),(75585,222,'Kunjalpur','271302',1,0,'2022-03-03 13:02:15','2022-03-03 13:02:15'),(75586,222,'Kurtha','271502',1,0,'2022-03-03 13:02:15','2022-03-03 13:02:15'),(75587,222,'Lakar Mandi','271319',1,0,'2022-03-03 13:02:15','2022-03-03 13:02:15'),(75588,222,'Lale Mau','271311',1,0,'2022-03-03 13:02:15','2022-03-03 13:02:15'),(75589,222,'Lali Purwa','271504',1,0,'2022-03-03 13:02:15','2022-03-03 13:02:15'),(75590,222,'Lamti Uprauhwa','271302',1,0,'2022-03-03 13:02:15','2022-03-03 13:02:15'),(75591,222,'Lauwa Beerpur','271303',1,0,'2022-03-03 13:02:15','2022-03-03 13:02:15'),(75592,222,'Liloi Kala','271401',1,0,'2022-03-03 13:02:15','2022-03-03 13:02:15'),(75593,222,'Machhali Gaon','271302',1,0,'2022-03-03 13:02:15','2022-03-03 13:02:15'),(75594,222,'Maddo Bazar','271312',1,0,'2022-03-03 13:02:15','2022-03-03 13:02:15'),(75595,222,'Madhaipur','271504',1,0,'2022-03-03 13:02:15','2022-03-03 13:02:15'),(75596,222,'Madhopur','271003',1,0,'2022-03-03 13:02:16','2022-03-03 13:02:16'),(75597,222,'Magura Bazar','271401',1,0,'2022-03-03 13:02:16','2022-03-03 13:02:16'),(75598,222,'Mahewa Gopal','271301',1,0,'2022-03-03 13:02:16','2022-03-03 13:02:16'),(75599,222,'Mahngoopur','271303',1,0,'2022-03-03 13:02:16','2022-03-03 13:02:16'),(75600,222,'Mahraiya Chakasar','271123',1,0,'2022-03-03 13:02:16','2022-03-03 13:02:16'),(75601,222,'Mahrajganj Grant','271313',1,0,'2022-03-03 13:02:16','2022-03-03 13:02:16'),(75602,222,'Majhara','271124',1,0,'2022-03-03 13:02:16','2022-03-03 13:02:16'),(75603,222,'Majhauwa Bujurg','271305',1,0,'2022-03-03 13:02:16','2022-03-03 13:02:16'),(75604,222,'Majhgaon','271310',1,0,'2022-03-03 13:02:16','2022-03-03 13:02:16'),(75605,222,'Malaon','271504',1,0,'2022-03-03 13:02:16','2022-03-03 13:02:16'),(75606,222,'Malari','271601',1,0,'2022-03-03 13:02:16','2022-03-03 13:02:16'),(75607,222,'Malauna','271502',1,0,'2022-03-03 13:02:16','2022-03-03 13:02:16'),(75608,222,'Mallapur','271122',1,0,'2022-03-03 13:02:16','2022-03-03 13:02:16'),(75609,222,'Mallhipur','271302',1,0,'2022-03-03 13:02:16','2022-03-03 13:02:16'),(75610,222,'Manda','271305',1,0,'2022-03-03 13:02:16','2022-03-03 13:02:16'),(75611,222,'Mandap','271313',1,0,'2022-03-03 13:02:16','2022-03-03 13:02:16'),(75612,222,'Mankapur Bazar','271302',1,0,'2022-03-03 13:02:16','2022-03-03 13:02:16'),(75613,222,'Mankapur (Gonda)','271302',1,0,'2022-03-03 13:02:16','2022-03-03 13:02:16'),(75614,222,'Marchaur','271504',1,0,'2022-03-03 13:02:16','2022-03-03 13:02:16'),(75615,222,'Maruia Bujurga','271307',1,0,'2022-03-03 13:02:16','2022-03-03 13:02:16'),(75616,222,'Mashaipur','271123',1,0,'2022-03-03 13:02:16','2022-03-03 13:02:16'),(75617,222,'Maskanwa Rs','271305',1,0,'2022-03-03 13:02:16','2022-03-03 13:02:16'),(75618,222,'Mauhar','271311',1,0,'2022-03-03 13:02:16','2022-03-03 13:02:16'),(75619,222,'Mawai','271305',1,0,'2022-03-03 13:02:16','2022-03-03 13:02:16'),(75620,222,'Mehnawan','271603',1,0,'2022-03-03 13:02:16','2022-03-03 13:02:16'),(75621,222,'Mijhaura','271504',1,0,'2022-03-03 13:02:17','2022-03-03 13:02:17'),(75622,222,'Mohammadpur','271502',1,0,'2022-03-03 13:02:17','2022-03-03 13:02:17'),(75623,222,'Mohna','271504',1,0,'2022-03-03 13:02:17','2022-03-03 13:02:17'),(75624,222,'Mokalpur','271003',1,0,'2022-03-03 13:02:17','2022-03-03 13:02:17'),(75625,222,'Motiganj (Gonda)','271301',1,0,'2022-03-03 13:02:17','2022-03-03 13:02:17'),(75626,222,'Nagdahi','271401',1,0,'2022-03-03 13:02:17','2022-03-03 13:02:17'),(75627,222,'Nagwa','271123',1,0,'2022-03-03 13:02:17','2022-03-03 13:02:17'),(75628,222,'Nahwa Parsaura','271502',1,0,'2022-03-03 13:02:17','2022-03-03 13:02:17'),(75629,222,'Naipur','271129',1,0,'2022-03-03 13:02:17','2022-03-03 13:02:17'),(75630,222,'Narayan Pur Kala','271503',1,0,'2022-03-03 13:02:17','2022-03-03 13:02:17'),(75631,222,'Narayanpuredha','271123',1,0,'2022-03-03 13:02:17','2022-03-03 13:02:17'),(75632,222,'Narharpur','271312',1,0,'2022-03-03 13:02:17','2022-03-03 13:02:17'),(75633,222,'Naubasta','271124',1,0,'2022-03-03 13:02:17','2022-03-03 13:02:17'),(75634,222,'Nawabganj S F','271304',1,0,'2022-03-03 13:02:17','2022-03-03 13:02:17'),(75635,222,'Nawabganj (Gonda)','271303',1,0,'2022-03-03 13:02:17','2022-03-03 13:02:17'),(75636,222,'Neerpur Khayala','271401',1,0,'2022-03-03 13:02:17','2022-03-03 13:02:17'),(75637,222,'Niyama','271403',1,0,'2022-03-03 13:02:17','2022-03-03 13:02:17'),(75638,222,'P A C','271001',1,0,'2022-03-03 13:02:17','2022-03-03 13:02:17'),(75639,222,'P.A. Singh','271003',1,0,'2022-03-03 13:02:17','2022-03-03 13:02:17'),(75640,222,'Pachputi Jagtapur','271302',1,0,'2022-03-03 13:02:17','2022-03-03 13:02:17'),(75641,222,'Paharapur','271502',1,0,'2022-03-03 13:02:17','2022-03-03 13:02:17'),(75642,222,'Pandey Chaura','271502',1,0,'2022-03-03 13:02:17','2022-03-03 13:02:17'),(75643,222,'Pandri Kirpal','271002',1,0,'2022-03-03 13:02:17','2022-03-03 13:02:17'),(75644,222,'Para Sarai','271202',1,0,'2022-03-03 13:02:17','2022-03-03 13:02:17'),(75645,222,'Paras','271403',1,0,'2022-03-03 13:02:17','2022-03-03 13:02:17'),(75646,222,'Paraspur','271504',1,0,'2022-03-03 13:02:18','2022-03-03 13:02:18'),(75647,222,'Parsa Mahesi','271502',1,0,'2022-03-03 13:02:18','2022-03-03 13:02:18'),(75648,222,'Parsa Tiwari','271313',1,0,'2022-03-03 13:02:18','2022-03-03 13:02:18'),(75649,222,'Parsada','271401',1,0,'2022-03-03 13:02:18','2022-03-03 13:02:18'),(75650,222,'Parsagodari','271126',1,0,'2022-03-03 13:02:18','2022-03-03 13:02:18'),(75651,222,'Parsaudaikar','271313',1,0,'2022-03-03 13:02:18','2022-03-03 13:02:18'),(75652,222,'Parsia Rani','271122',1,0,'2022-03-03 13:02:18','2022-03-03 13:02:18'),(75653,222,'Paska','271504',1,0,'2022-03-03 13:02:18','2022-03-03 13:02:18'),(75654,222,'Pathwalia','271003',1,0,'2022-03-03 13:02:18','2022-03-03 13:02:18'),(75655,222,'Pipara  Bazar','271122',1,0,'2022-03-03 13:02:18','2022-03-03 13:02:18'),(75656,222,'Pipari Majha','271503',1,0,'2022-03-03 13:02:18','2022-03-03 13:02:18'),(75657,222,'Pipri Rawat','271502',1,0,'2022-03-03 13:02:18','2022-03-03 13:02:18'),(75658,222,'Pirwartara','271204',1,0,'2022-03-03 13:02:18','2022-03-03 13:02:18'),(75659,222,'Pure Azab','271504',1,0,'2022-03-03 13:02:18','2022-03-03 13:02:18'),(75660,222,'Pure Bahori','271122',1,0,'2022-03-03 13:02:18','2022-03-03 13:02:18'),(75661,222,'Pure Basalat','271603',1,0,'2022-03-03 13:02:18','2022-03-03 13:02:18'),(75662,222,'Pure Dal','271402',1,0,'2022-03-03 13:02:18','2022-03-03 13:02:18'),(75663,222,'Pure Ghisiram','271403',1,0,'2022-03-03 13:02:18','2022-03-03 13:02:18'),(75664,222,'Pure Nidhi','271503',1,0,'2022-03-03 13:02:18','2022-03-03 13:02:18'),(75665,222,'Pure Shivdayal Ganj','271319',1,0,'2022-03-03 13:02:18','2022-03-03 13:02:18'),(75666,222,'Raghuraj Nagar','271303',1,0,'2022-03-03 13:02:18','2022-03-03 13:02:18'),(75667,222,'Rajapur','271603',1,0,'2022-03-03 13:02:18','2022-03-03 13:02:18'),(75668,222,'Rajapur','271301',1,0,'2022-03-03 13:02:18','2022-03-03 13:02:18'),(75669,222,'Rajapur','271504',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75670,222,'Rajgarh','271301',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75671,222,'Raksaria','271504',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75672,222,'Ram Adhin Purwa','271403',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75673,222,'Ram Pur Bansawan','271301',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75674,222,'Ramapur','271122',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75675,222,'Ramapur Bhagahi','271319',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75676,222,'Ramnagar Tarhar','271123',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75677,222,'Rampur Kharahta','271124',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75678,222,'Rampur Tengraha','271124',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75679,222,'Rangi','271309',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75680,222,'Ranipur','271403',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75681,222,'Ranipur','271202',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75682,222,'Retwa Gara','271603',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75683,222,'Rudragarh Nausi','271602',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75684,222,'Rupaideeh','271122',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75685,222,'S.N. Chapiya','271305',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75686,222,'Sabarpur','271313',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75687,222,'Sahjanwa','271122',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75688,222,'Sakipur','271309',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75689,222,'Sakraura','271502',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75690,222,'Sarawa','271403',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75691,222,'Sarinya','271504',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75692,222,'Sarwangpurwa','271126',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75693,222,'Selhari','271503',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75694,222,'Semra Sekhpur','271303',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75695,222,'Semri Kala','271402',1,0,'2022-03-03 13:02:19','2022-03-03 13:02:19'),(75696,222,'Shahajot','271503',1,0,'2022-03-03 13:02:20','2022-03-03 13:02:20'),(75697,222,'Shisa Mau','271502',1,0,'2022-03-03 13:02:20','2022-03-03 13:02:20'),(75698,222,'Shitalganj Grant','271305',1,0,'2022-03-03 13:02:20','2022-03-03 13:02:20'),(75699,222,'Sidhauti','271402',1,0,'2022-03-03 13:02:20','2022-03-03 13:02:20'),(75700,222,'Siha Gaon','271301',1,0,'2022-03-03 13:02:20','2022-03-03 13:02:20'),(75701,222,'Singha Chanda','271403',1,0,'2022-03-03 13:02:20','2022-03-03 13:02:20'),(75702,222,'Sisai','271401',1,0,'2022-03-03 13:02:20','2022-03-03 13:02:20'),(75703,222,'Siswaria','271301',1,0,'2022-03-03 13:02:20','2022-03-03 13:02:20'),(75704,222,'Sitarampur Grant','271312',1,0,'2022-03-03 13:02:20','2022-03-03 13:02:20'),(75705,222,'Sohila','271305',1,0,'2022-03-03 13:02:20','2022-03-03 13:02:20'),(75706,222,'Sonauli Mohammad Pur','271402',1,0,'2022-03-03 13:02:20','2022-03-03 13:02:20'),(75707,222,'Srinagar (Gonda)','271603',1,0,'2022-03-03 13:02:20','2022-03-03 13:02:20'),(75708,222,'Subhagpur','271504',1,0,'2022-03-03 13:02:20','2022-03-03 13:02:20'),(75709,222,'Sumeripur','271301',1,0,'2022-03-03 13:02:20','2022-03-03 13:02:20'),(75710,222,'Surjapur','271302',1,0,'2022-03-03 13:02:20','2022-03-03 13:02:20'),(75711,222,'Surwar Khurd','271305',1,0,'2022-03-03 13:02:20','2022-03-03 13:02:20'),(75712,222,'Susunda','271401',1,0,'2022-03-03 13:02:20','2022-03-03 13:02:20'),(75713,222,'T.Patti','271003',1,0,'2022-03-03 13:02:20','2022-03-03 13:02:20'),(75714,222,'Taj Pur','271123',1,0,'2022-03-03 13:02:20','2022-03-03 13:02:20'),(75715,222,'Taorasi','271504',1,0,'2022-03-03 13:02:20','2022-03-03 13:02:20'),(75716,222,'Tarabganj','271403',1,0,'2022-03-03 13:02:20','2022-03-03 13:02:20'),(75717,222,'Taradheeh','271403',1,0,'2022-03-03 13:02:20','2022-03-03 13:02:20'),(75718,222,'Thakurapur','271125',1,0,'2022-03-03 13:02:20','2022-03-03 13:02:20'),(75719,222,'Thathiya Mathiya','271125',1,0,'2022-03-03 13:02:20','2022-03-03 13:02:20'),(75720,222,'Tilka Deeh','271503',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75721,222,'Tirre Manorama','271202',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75722,222,'Tiwari Bazar','271403',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75723,222,'Tulsipur Majha','271303',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75724,222,'Turkadeeh','271301',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75725,222,'Ujjaini Kalan','271603',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75726,222,'Umedpur','271123',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75727,222,'Umrapur Chauhan','271401',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75728,222,'Urdi','271503',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75729,222,'Ursaina','271122',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75730,222,'Usrair','271502',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75731,222,'Utraula','271504',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75732,222,'Utraula Road','271003',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75733,222,'Vishnoharpur','271303',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75734,222,'Wazeerganj','271124',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75735,223,'A.P.Station','273002',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75736,223,'Ahirauli Bujurg','273213',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75737,223,'Alawalpur','273213',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75738,223,'Alinagar','273001',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75739,223,'Allahadadpur','273001',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75740,223,'Amhia','273202',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75741,223,'Amtaura','273212',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75742,223,'Arogyamandir','273003',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75743,223,'Arwagadish','273407',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75744,223,'Ashauji Bazar','273213',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75745,223,'Ashok Nagar (Gorakhpur)','273004',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75746,223,'Awadhpur','273202',1,0,'2022-03-03 13:02:21','2022-03-03 13:02:21'),(75747,223,'B.R.D Medical College','273013',1,0,'2022-03-03 13:02:22','2022-03-03 13:02:22'),(75748,223,'Babhnauli','273404',1,0,'2022-03-03 13:02:22','2022-03-03 13:02:22'),(75749,223,'Badago','273213',1,0,'2022-03-03 13:02:22','2022-03-03 13:02:22'),(75750,223,'Badhara Baraipar','273306',1,0,'2022-03-03 13:02:22','2022-03-03 13:02:22'),(75751,223,'Baghar','273201',1,0,'2022-03-03 13:02:22','2022-03-03 13:02:22'),(75752,223,'Baghrain','273403',1,0,'2022-03-03 13:02:22','2022-03-03 13:02:22'),(75753,223,'Bahrampur','273016',1,0,'2022-03-03 13:02:22','2022-03-03 13:02:22'),(75754,223,'Baidabazar','273158',1,0,'2022-03-03 13:02:22','2022-03-03 13:02:22'),(75755,223,'Baksuri','273413',1,0,'2022-03-03 13:02:22','2022-03-03 13:02:22'),(75756,223,'Balapar','273007',1,0,'2022-03-03 13:02:22','2022-03-03 13:02:22'),(75757,223,'Baluwa','273158',1,0,'2022-03-03 13:02:22','2022-03-03 13:02:22'),(75758,223,'Balwa Dakhli','273402',1,0,'2022-03-03 13:02:22','2022-03-03 13:02:22'),(75759,223,'Ban','273165',1,0,'2022-03-03 13:02:22','2022-03-03 13:02:22'),(75760,223,'Bank Road (Gorakhpur)','273001',1,0,'2022-03-03 13:02:22','2022-03-03 13:02:22'),(75761,223,'Bansgaon (Gorakhpur)','273403',1,0,'2022-03-03 13:02:22','2022-03-03 13:02:22'),(75762,223,'Baraipar','273412',1,0,'2022-03-03 13:02:22','2022-03-03 13:02:22'),(75763,223,'Baraipur','273002',1,0,'2022-03-03 13:02:22','2022-03-03 13:02:22'),(75764,223,'Baraipurwa','273406',1,0,'2022-03-03 13:02:22','2022-03-03 13:02:22'),(75765,223,'Baranagar','273409',1,0,'2022-03-03 13:02:22','2022-03-03 13:02:22'),(75766,223,'Baraw','273213',1,0,'2022-03-03 13:02:22','2022-03-03 13:02:22'),(75767,223,'Barayapar','273211',1,0,'2022-03-03 13:02:22','2022-03-03 13:02:22'),(75768,223,'Bargahan','273212',1,0,'2022-03-03 13:02:22','2022-03-03 13:02:22'),(75769,223,'Bargahpur','273157',1,0,'2022-03-03 13:02:22','2022-03-03 13:02:22'),(75770,223,'Bargo','273016',1,0,'2022-03-03 13:02:22','2022-03-03 13:02:22'),(75771,223,'Barhalganj','273402',1,0,'2022-03-03 13:02:23','2022-03-03 13:02:23'),(75772,223,'Barhi (Gorakhpur)','273405',1,0,'2022-03-03 13:02:23','2022-03-03 13:02:23'),(75773,223,'Barhyachowk','273165',1,0,'2022-03-03 13:02:23','2022-03-03 13:02:23'),(75774,223,'Baria Khas','273402',1,0,'2022-03-03 13:02:23','2022-03-03 13:02:23'),(75775,223,'Bariepar','273209',1,0,'2022-03-03 13:02:23','2022-03-03 13:02:23'),(75776,223,'Barigaon','273211',1,0,'2022-03-03 13:02:23','2022-03-03 13:02:23'),(75777,223,'Baripur','273213',1,0,'2022-03-03 13:02:23','2022-03-03 13:02:23'),(75778,223,'Barni Gopalpur','273406',1,0,'2022-03-03 13:02:23','2022-03-03 13:02:23'),(75779,223,'Barpar','273402',1,0,'2022-03-03 13:02:23','2022-03-03 13:02:23'),(75780,223,'Barpar Mafi','273409',1,0,'2022-03-03 13:02:23','2022-03-03 13:02:23'),(75781,223,'Basahi','273404',1,0,'2022-03-03 13:02:23','2022-03-03 13:02:23'),(75782,223,'Basantpur','273158',1,0,'2022-03-03 13:02:23','2022-03-03 13:02:23'),(75783,223,'Basdila','273202',1,0,'2022-03-03 13:02:23','2022-03-03 13:02:23'),(75784,223,'Basharatpur','273004',1,0,'2022-03-03 13:02:23','2022-03-03 13:02:23'),(75785,223,'Bashwanpur','273413',1,0,'2022-03-03 13:02:23','2022-03-03 13:02:23'),(75786,223,'Basiakhor','273212',1,0,'2022-03-03 13:02:23','2022-03-03 13:02:23'),(75787,223,'Bautha','273405',1,0,'2022-03-03 13:02:23','2022-03-03 13:02:23'),(75788,223,'Bela Khurd','273407',1,0,'2022-03-03 13:02:23','2022-03-03 13:02:23'),(75789,223,'Belabirbhan','273411',1,0,'2022-03-03 13:02:23','2022-03-03 13:02:23'),(75790,223,'Belakanta','273152',1,0,'2022-03-03 13:02:23','2022-03-03 13:02:23'),(75791,223,'Belghat','273404',1,0,'2022-03-03 13:02:23','2022-03-03 13:02:23'),(75792,223,'Belipar','273413',1,0,'2022-03-03 13:02:23','2022-03-03 13:02:23'),(75793,223,'Belkur','273411',1,0,'2022-03-03 13:02:23','2022-03-03 13:02:23'),(75794,223,'Belwa Babu','273202',1,0,'2022-03-03 13:02:24','2022-03-03 13:02:24'),(75795,223,'Betia Hata','273001',1,0,'2022-03-03 13:02:24','2022-03-03 13:02:24'),(75796,223,'Bhagawanpur','273401',1,0,'2022-03-03 13:02:24','2022-03-03 13:02:24'),(75797,223,'Bhaghagarha','273401',1,0,'2022-03-03 13:02:24','2022-03-03 13:02:24'),(75798,223,'Bhaisa Bazar','273212',1,0,'2022-03-03 13:02:24','2022-03-03 13:02:24'),(75799,223,'Bhaisaha','273202',1,0,'2022-03-03 13:02:24','2022-03-03 13:02:24'),(75800,223,'Bharohiya','273212',1,0,'2022-03-03 13:02:24','2022-03-03 13:02:24'),(75801,223,'Bharpahi','273209',1,0,'2022-03-03 13:02:24','2022-03-03 13:02:24'),(75802,223,'Bharroh','273408',1,0,'2022-03-03 13:02:24','2022-03-03 13:02:24'),(75803,223,'Bharshad','273209',1,0,'2022-03-03 13:02:24','2022-03-03 13:02:24'),(75804,223,'Bhashla','273209',1,0,'2022-03-03 13:02:24','2022-03-03 13:02:24'),(75805,223,'Bhatauli','273406',1,0,'2022-03-03 13:02:24','2022-03-03 13:02:24'),(75806,223,'Bhathat','273306',1,0,'2022-03-03 13:02:24','2022-03-03 13:02:24'),(75807,223,'Bhatpar','273402',1,0,'2022-03-03 13:02:24','2022-03-03 13:02:24'),(75808,223,'Bhaurabari','273158',1,0,'2022-03-03 13:02:24','2022-03-03 13:02:24'),(75809,223,'Bhauwapar Bazar','273202',1,0,'2022-03-03 13:02:24','2022-03-03 13:02:24'),(75810,223,'Bheunsa','273211',1,0,'2022-03-03 13:02:24','2022-03-03 13:02:24'),(75811,223,'Bhita','273403',1,0,'2022-03-03 13:02:24','2022-03-03 13:02:24'),(75812,223,'Bhiti','273401',1,0,'2022-03-03 13:02:24','2022-03-03 13:02:24'),(75813,223,'Bhiti','273412',1,0,'2022-03-03 13:02:24','2022-03-03 13:02:24'),(75814,223,'Bhitirawat','273209',1,0,'2022-03-03 13:02:24','2022-03-03 13:02:24'),(75815,223,'Bhowapar','273401',1,0,'2022-03-03 13:02:24','2022-03-03 13:02:24'),(75816,223,'Bhrauli','273402',1,0,'2022-03-03 13:02:25','2022-03-03 13:02:25'),(75817,223,'Bhuswal','273403',1,0,'2022-03-03 13:02:25','2022-03-03 13:02:25'),(75818,223,'Bigahi','273212',1,0,'2022-03-03 13:02:25','2022-03-03 13:02:25'),(75819,223,'Bihari Bujurg','273212',1,0,'2022-03-03 13:02:25','2022-03-03 13:02:25'),(75820,223,'Bilandpur','273001',1,0,'2022-03-03 13:02:25','2022-03-03 13:02:25'),(75821,223,'Bimuti','273402',1,0,'2022-03-03 13:02:25','2022-03-03 13:02:25'),(75822,223,'Biraikhurd','273407',1,0,'2022-03-03 13:02:25','2022-03-03 13:02:25'),(75823,223,'Bisaunpur','273403',1,0,'2022-03-03 13:02:25','2022-03-03 13:02:25'),(75824,223,'Bishunpur Raja','273409',1,0,'2022-03-03 13:02:25','2022-03-03 13:02:25'),(75825,223,'Bishunpura','273405',1,0,'2022-03-03 13:02:25','2022-03-03 13:02:25'),(75826,223,'Bishwnathpur','273201',1,0,'2022-03-03 13:02:25','2022-03-03 13:02:25'),(75827,223,'Boopgarh','273413',1,0,'2022-03-03 13:02:25','2022-03-03 13:02:25'),(75828,223,'Brahmasari','273213',1,0,'2022-03-03 13:02:25','2022-03-03 13:02:25'),(75829,223,'Brahmpur (Gorakhpur)','273203',1,0,'2022-03-03 13:02:25','2022-03-03 13:02:25'),(75830,223,'Buxipur','273001',1,0,'2022-03-03 13:02:25','2022-03-03 13:02:25'),(75831,223,'Campierganj','273158',1,0,'2022-03-03 13:02:25','2022-03-03 13:02:25'),(75832,223,'Chadrawn','273209',1,0,'2022-03-03 13:02:25','2022-03-03 13:02:25'),(75833,223,'Chargaon','273013',1,0,'2022-03-03 13:02:25','2022-03-03 13:02:25'),(75834,223,'Chauri Chaura','273201',1,0,'2022-03-03 13:02:25','2022-03-03 13:02:25'),(75835,223,'Chawaria Buzurg','273413',1,0,'2022-03-03 13:02:25','2022-03-03 13:02:25'),(75836,223,'Cheriya','273401',1,0,'2022-03-03 13:02:25','2022-03-03 13:02:25'),(75837,223,'Chhapiya','273016',1,0,'2022-03-03 13:02:25','2022-03-03 13:02:25'),(75838,223,'Chhapra','273412',1,0,'2022-03-03 13:02:26','2022-03-03 13:02:26'),(75839,223,'Chhatai','273212',1,0,'2022-03-03 13:02:26','2022-03-03 13:02:26'),(75840,223,'Chilwa','273408',1,0,'2022-03-03 13:02:26','2022-03-03 13:02:26'),(75841,223,'Chiuthan','273306',1,0,'2022-03-03 13:02:26','2022-03-03 13:02:26'),(75842,223,'Civil Court (Gorakhpur)','273001',1,0,'2022-03-03 13:02:26','2022-03-03 13:02:26'),(75843,223,'Collectrate Compound Maharajganj','273303',1,0,'2022-03-03 13:02:26','2022-03-03 13:02:26'),(75844,223,'Dadri','273412',1,0,'2022-03-03 13:02:26','2022-03-03 13:02:26'),(75845,223,'Dandi','273413',1,0,'2022-03-03 13:02:26','2022-03-03 13:02:26'),(75846,223,'Daudpur','273001',1,0,'2022-03-03 13:02:26','2022-03-03 13:02:26'),(75847,223,'Davarpar','273016',1,0,'2022-03-03 13:02:26','2022-03-03 13:02:26'),(75848,223,'Davipur','273158',1,0,'2022-03-03 13:02:26','2022-03-03 13:02:26'),(75849,223,'Deepgarh','273408',1,0,'2022-03-03 13:02:26','2022-03-03 13:02:26'),(75850,223,'Deharatikar','273213',1,0,'2022-03-03 13:02:26','2022-03-03 13:02:26'),(75851,223,'Deidiha','273409',1,0,'2022-03-03 13:02:26','2022-03-03 13:02:26'),(75852,223,'Derwa','273402',1,0,'2022-03-03 13:02:26','2022-03-03 13:02:26'),(75853,223,'Dewalapar','273408',1,0,'2022-03-03 13:02:26','2022-03-03 13:02:26'),(75854,223,'Dewrartula','273212',1,0,'2022-03-03 13:02:26','2022-03-03 13:02:26'),(75855,223,'Dhakhwa Bazar','273211',1,0,'2022-03-03 13:02:26','2022-03-03 13:02:26'),(75856,223,'Dhanaha Naik','273301',1,0,'2022-03-03 13:02:26','2022-03-03 13:02:26'),(75857,223,'Dhanwda Buzurg','273413',1,0,'2022-03-03 13:02:26','2022-03-03 13:02:26'),(75858,223,'Dharamshala','273001',1,0,'2022-03-03 13:02:26','2022-03-03 13:02:26'),(75859,223,'Dharsi','273411',1,0,'2022-03-03 13:02:26','2022-03-03 13:02:26'),(75860,223,'Dhobouli','273212',1,0,'2022-03-03 13:02:26','2022-03-03 13:02:26'),(75861,223,'Dhrampur','273158',1,0,'2022-03-03 13:02:26','2022-03-03 13:02:26'),(75862,223,'Dhudhara','273407',1,0,'2022-03-03 13:02:26','2022-03-03 13:02:26'),(75863,223,'Dhuriapar','273209',1,0,'2022-03-03 13:02:27','2022-03-03 13:02:27'),(75864,223,'Dhuripar','273407',1,0,'2022-03-03 13:02:27','2022-03-03 13:02:27'),(75865,223,'Dhuriyapar Chini mil','273409',1,0,'2022-03-03 13:02:27','2022-03-03 13:02:27'),(75866,223,'Dihghat','273405',1,0,'2022-03-03 13:02:27','2022-03-03 13:02:27'),(75867,223,'Dohariya Bazar','273015',1,0,'2022-03-03 13:02:27','2022-03-03 13:02:27'),(75868,223,'Domara','273165',1,0,'2022-03-03 13:02:27','2022-03-03 13:02:27'),(75869,223,'Dubauli','273413',1,0,'2022-03-03 13:02:27','2022-03-03 13:02:27'),(75870,223,'Dumarinivas','273209',1,0,'2022-03-03 13:02:27','2022-03-03 13:02:27'),(75871,223,'Dumraila','273405',1,0,'2022-03-03 13:02:27','2022-03-03 13:02:27'),(75872,223,'Dumri Khas','273202',1,0,'2022-03-03 13:02:27','2022-03-03 13:02:27'),(75873,223,'Fardahani','273165',1,0,'2022-03-03 13:02:27','2022-03-03 13:02:27'),(75874,223,'Farsand','273402',1,0,'2022-03-03 13:02:27','2022-03-03 13:02:27'),(75875,223,'Fertilizer Factory','273007',1,0,'2022-03-03 13:02:27','2022-03-03 13:02:27'),(75876,223,'Gadar','273212',1,0,'2022-03-03 13:02:27','2022-03-03 13:02:27'),(75877,223,'Gagaha','273411',1,0,'2022-03-03 13:02:27','2022-03-03 13:02:27'),(75878,223,'Gahanshad','273209',1,0,'2022-03-03 13:02:27','2022-03-03 13:02:27'),(75879,223,'Gahira','273202',1,0,'2022-03-03 13:02:27','2022-03-03 13:02:27'),(75880,223,'Gaighat','273404',1,0,'2022-03-03 13:02:27','2022-03-03 13:02:27'),(75881,223,'Gajpur','273413',1,0,'2022-03-03 13:02:27','2022-03-03 13:02:27'),(75882,223,'Gajpur','273407',1,0,'2022-03-03 13:02:27','2022-03-03 13:02:27'),(75883,223,'Gangapar','273412',1,0,'2022-03-03 13:02:27','2022-03-03 13:02:27'),(75884,223,'Gangibazar','273165',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75885,223,'Gaunar','273201',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75886,223,'Gaurkhas','273407',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75887,223,'Gaursaira','273406',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75888,223,'Ghaghsara','273209',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75889,223,'Ghorsaon','273411',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75890,223,'Gigani Bujurg','273407',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75891,223,'Girdharpur','273413',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75892,223,'Gita Press','273005',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75893,223,'Gita Vatika','273006',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75894,223,'Gola (Gorakhpur)','273408',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75895,223,'Golghar','273001',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75896,223,'Gopalpur','273002',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75897,223,'Gopalpur','273408',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75898,223,'Gorakhnath Mandir','273015',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75899,223,'Gorakhpur H.O','273001',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75900,223,'Gorakhpur Kutchery','273001',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75901,223,'Gorakhpur University','273009',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75902,223,'GR Railway Station','273012',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75903,223,'Gulharia','273013',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75904,223,'Gulhariya','273158',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75905,223,'Haraiya','273203',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75906,223,'Hardi Chak','273406',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75907,223,'Hariharpur','273212',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75908,223,'Harpur','273409',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75909,223,'Harpur Budhat','273209',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75910,223,'Hata Buzurg','273403',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75911,223,'Hemdhapur','273152',1,0,'2022-03-03 13:02:28','2022-03-03 13:02:28'),(75912,223,'Ilahibagh','273001',1,0,'2022-03-03 13:02:29','2022-03-03 13:02:29'),(75913,223,'Israuli','273211',1,0,'2022-03-03 13:02:29','2022-03-03 13:02:29'),(75914,223,'Jadishpur Bhaluwan','273411',1,0,'2022-03-03 13:02:29','2022-03-03 13:02:29'),(75915,223,'Jafra Bazar','273001',1,0,'2022-03-03 13:02:29','2022-03-03 13:02:29'),(75916,223,'Jagatabela','273015',1,0,'2022-03-03 13:02:29','2022-03-03 13:02:29'),(75917,223,'Jagdishpur','273002',1,0,'2022-03-03 13:02:29','2022-03-03 13:02:29'),(75918,223,'Jainpur','273306',1,0,'2022-03-03 13:02:29','2022-03-03 13:02:29'),(75919,223,'Jaitpur','273212',1,0,'2022-03-03 13:02:29','2022-03-03 13:02:29'),(75920,223,'Jakahi','273212',1,0,'2022-03-03 13:02:29','2022-03-03 13:02:29'),(75921,223,'Jangle Agahi','273165',1,0,'2022-03-03 13:02:29','2022-03-03 13:02:29'),(75922,223,'Jangle Beni Madho','273007',1,0,'2022-03-03 13:02:29','2022-03-03 13:02:29'),(75923,223,'Jangle Dhushar','273014',1,0,'2022-03-03 13:02:29','2022-03-03 13:02:29'),(75924,223,'Jangle Laxmipur','273014',1,0,'2022-03-03 13:02:29','2022-03-03 13:02:29'),(75925,223,'Jangle Salikram','273014',1,0,'2022-03-03 13:02:29','2022-03-03 13:02:29'),(75926,223,'Jangle Tulshiram','273014',1,0,'2022-03-03 13:02:29','2022-03-03 13:02:29'),(75927,223,'Janipur','273413',1,0,'2022-03-03 13:02:29','2022-03-03 13:02:29'),(75928,223,'Jatepur North','273015',1,0,'2022-03-03 13:02:29','2022-03-03 13:02:29'),(75929,223,'Jhangha','273202',1,0,'2022-03-03 13:02:29','2022-03-03 13:02:29'),(75930,223,'Jharkata','273409',1,0,'2022-03-03 13:02:29','2022-03-03 13:02:29'),(75931,223,'Jhudiya','273212',1,0,'2022-03-03 13:02:29','2022-03-03 13:02:29'),(75932,223,'Jhungia Bazar','273013',1,0,'2022-03-03 13:02:29','2022-03-03 13:02:29'),(75933,223,'Jigina Bhion','273403',1,0,'2022-03-03 13:02:29','2022-03-03 13:02:29'),(75934,223,'Jingle Ayodhayay Prasad','273013',1,0,'2022-03-03 13:02:29','2022-03-03 13:02:29'),(75935,223,'Jungle Aurahi','273013',1,0,'2022-03-03 13:02:29','2022-03-03 13:02:29'),(75936,223,'Jungle Chauri','273010',1,0,'2022-03-03 13:02:30','2022-03-03 13:02:30'),(75937,223,'Jungle Dumri No-1','273306',1,0,'2022-03-03 13:02:30','2022-03-03 13:02:30'),(75938,223,'Jungle Gauri','273202',1,0,'2022-03-03 13:02:30','2022-03-03 13:02:30'),(75939,223,'Jungle Kauria','273007',1,0,'2022-03-03 13:02:30','2022-03-03 13:02:30'),(75940,223,'Jungle Ramgarh','273002',1,0,'2022-03-03 13:02:30','2022-03-03 13:02:30'),(75941,223,'Jungle Rani Sohas','273401',1,0,'2022-03-03 13:02:30','2022-03-03 13:02:30'),(75942,223,'Jungle Rasoolpur','273203',1,0,'2022-03-03 13:02:30','2022-03-03 13:02:30'),(75943,223,'Junjle Dumri No-2','273306',1,0,'2022-03-03 13:02:30','2022-03-03 13:02:30'),(75944,223,'Kakarakhore','273401',1,0,'2022-03-03 13:02:30','2022-03-03 13:02:30'),(75945,223,'Kakrahi','273408',1,0,'2022-03-03 13:02:30','2022-03-03 13:02:30'),(75946,223,'Kalyanpur','273165',1,0,'2022-03-03 13:02:30','2022-03-03 13:02:30'),(75947,223,'Kamasinkhurd','273158',1,0,'2022-03-03 13:02:30','2022-03-03 13:02:30'),(75948,223,'Kanaicha','273413',1,0,'2022-03-03 13:02:30','2022-03-03 13:02:30'),(75949,223,'Kanail','273413',1,0,'2022-03-03 13:02:30','2022-03-03 13:02:30'),(75950,223,'Kanapar','273403',1,0,'2022-03-03 13:02:30','2022-03-03 13:02:30'),(75951,223,'Kanapar','273165',1,0,'2022-03-03 13:02:30','2022-03-03 13:02:30'),(75952,223,'Karamdeva','273211',1,0,'2022-03-03 13:02:30','2022-03-03 13:02:30'),(75953,223,'Karanjahi','273413',1,0,'2022-03-03 13:02:30','2022-03-03 13:02:30'),(75954,223,'Karanpura','273212',1,0,'2022-03-03 13:02:30','2022-03-03 13:02:30'),(75955,223,'Karwal Majhgawa','273411',1,0,'2022-03-03 13:02:30','2022-03-03 13:02:30'),(75956,223,'Kataharimahurasar','273165',1,0,'2022-03-03 13:02:30','2022-03-03 13:02:30'),(75957,223,'Katai Tikar','273212',1,0,'2022-03-03 13:02:30','2022-03-03 13:02:30'),(75958,223,'Kauriram','273413',1,0,'2022-03-03 13:02:30','2022-03-03 13:02:30'),(75959,223,'Kazipur Kalan','273001',1,0,'2022-03-03 13:02:31','2022-03-03 13:02:31'),(75960,223,'Keshawapar','273407',1,0,'2022-03-03 13:02:31','2022-03-03 13:02:31'),(75961,223,'Khajani Tehsil','273212',1,0,'2022-03-03 13:02:31','2022-03-03 13:02:31'),(75962,223,'Khajni','273212',1,0,'2022-03-03 13:02:31','2022-03-03 13:02:31'),(75963,223,'Khajurgawan','273158',1,0,'2022-03-03 13:02:31','2022-03-03 13:02:31'),(75964,223,'Khajuri','273212',1,0,'2022-03-03 13:02:31','2022-03-03 13:02:31'),(75965,223,'Khajuri Baboo','273411',1,0,'2022-03-03 13:02:31','2022-03-03 13:02:31'),(75966,223,'Khakhaichkhor','273412',1,0,'2022-03-03 13:02:31','2022-03-03 13:02:31'),(75967,223,'Khandaesari','273402',1,0,'2022-03-03 13:02:31','2022-03-03 13:02:31'),(75968,223,'Khesrari','273163',1,0,'2022-03-03 13:02:31','2022-03-03 13:02:31'),(75969,223,'Khirkitadubey','273412',1,0,'2022-03-03 13:02:31','2022-03-03 13:02:31'),(75970,223,'Khorabar','273010',1,0,'2022-03-03 13:02:31','2022-03-03 13:02:31'),(75971,223,'Khortha','273401',1,0,'2022-03-03 13:02:31','2022-03-03 13:02:31'),(75972,223,'Khutahan Khas','273306',1,0,'2022-03-03 13:02:31','2022-03-03 13:02:31'),(75973,223,'Kodari','273209',1,0,'2022-03-03 13:02:31','2022-03-03 13:02:31'),(75974,223,'Kodarpandey','273412',1,0,'2022-03-03 13:02:31','2022-03-03 13:02:31'),(75975,223,'Kodri','273408',1,0,'2022-03-03 13:02:31','2022-03-03 13:02:31'),(75976,223,'Kohra Buzurg','273408',1,0,'2022-03-03 13:02:31','2022-03-03 13:02:31'),(75977,223,'Kotha','273411',1,0,'2022-03-03 13:02:31','2022-03-03 13:02:31'),(75978,223,'Kotwa','273407',1,0,'2022-03-03 13:02:31','2022-03-03 13:02:31'),(75979,223,'Kunraghat H.O','273008',1,0,'2022-03-03 13:02:31','2022-03-03 13:02:31'),(75980,223,'Kunwar','273158',1,0,'2022-03-03 13:02:31','2022-03-03 13:02:31'),(75981,223,'Kuri Bazar','273404',1,0,'2022-03-03 13:02:31','2022-03-03 13:02:31'),(75982,223,'Kusmaul','273401',1,0,'2022-03-03 13:02:32','2022-03-03 13:02:32'),(75983,223,'Kusumhi Bazar','273002',1,0,'2022-03-03 13:02:32','2022-03-03 13:02:32'),(75984,223,'Labour Camp','273001',1,0,'2022-03-03 13:02:32','2022-03-03 13:02:32'),(75985,223,'Lachchipur','273007',1,0,'2022-03-03 13:02:32','2022-03-03 13:02:32'),(75986,223,'Lahsari','273016',1,0,'2022-03-03 13:02:32','2022-03-03 13:02:32'),(75987,223,'Lakhanapaar','273209',1,0,'2022-03-03 13:02:32','2022-03-03 13:02:32'),(75988,223,'Lakhuapakar','273404',1,0,'2022-03-03 13:02:32','2022-03-03 13:02:32'),(75989,223,'Lalpur Tikar','273016',1,0,'2022-03-03 13:02:32','2022-03-03 13:02:32'),(75990,223,'Lehrabazar','273157',1,0,'2022-03-03 13:02:32','2022-03-03 13:02:32'),(75991,223,'Loco  Workshop LSG','273012',1,0,'2022-03-03 13:02:32','2022-03-03 13:02:32'),(75992,223,'Loharpurwa','273158',1,0,'2022-03-03 13:02:32','2022-03-03 13:02:32'),(75993,223,'Luhsi','273152',1,0,'2022-03-03 13:02:32','2022-03-03 13:02:32'),(75994,223,'M.M.M.E.College','273010',1,0,'2022-03-03 13:02:32','2022-03-03 13:02:32'),(75995,223,'Madanpura','273212',1,0,'2022-03-03 13:02:32','2022-03-03 13:02:32'),(75996,223,'Madhonagar','273158',1,0,'2022-03-03 13:02:32','2022-03-03 13:02:32'),(75997,223,'Madria','273402',1,0,'2022-03-03 13:02:32','2022-03-03 13:02:32'),(75998,223,'Mahaita','273209',1,0,'2022-03-03 13:02:32','2022-03-03 13:02:32'),(75999,223,'Mahawan Khore','273165',1,0,'2022-03-03 13:02:32','2022-03-03 13:02:32'),(76000,223,'Mahuarkol','273413',1,0,'2022-03-03 13:02:32','2022-03-03 13:02:32'),(76001,223,'Mahubujurg','273407',1,0,'2022-03-03 13:02:32','2022-03-03 13:02:32'),(76002,223,'Mahuja','273413',1,0,'2022-03-03 13:02:32','2022-03-03 13:02:32'),(76003,223,'Mahupar','273402',1,0,'2022-03-03 13:02:32','2022-03-03 13:02:32'),(76004,223,'Mahuraon','273212',1,0,'2022-03-03 13:02:33','2022-03-03 13:02:33'),(76005,223,'Mahuwashukul','273158',1,0,'2022-03-03 13:02:33','2022-03-03 13:02:33'),(76006,223,'Maina Bhagar','273007',1,0,'2022-03-03 13:02:33','2022-03-03 13:02:33'),(76007,223,'Majhauna','273165',1,0,'2022-03-03 13:02:33','2022-03-03 13:02:33'),(76008,223,'Makhanaha','273165',1,0,'2022-03-03 13:02:33','2022-03-03 13:02:33'),(76009,223,'Malahanpar','273403',1,0,'2022-03-03 13:02:33','2022-03-03 13:02:33'),(76010,223,'Malaon','273413',1,0,'2022-03-03 13:02:33','2022-03-03 13:02:33'),(76011,223,'Maniram','273007',1,0,'2022-03-03 13:02:33','2022-03-03 13:02:33'),(76012,223,'Manjharia','273015',1,0,'2022-03-03 13:02:33','2022-03-03 13:02:33'),(76013,223,'Mannipursahdauli','273408',1,0,'2022-03-03 13:02:33','2022-03-03 13:02:33'),(76014,223,'Mansorganj Khurd','273165',1,0,'2022-03-03 13:02:33','2022-03-03 13:02:33'),(76015,223,'Marwatiya','273407',1,0,'2022-03-03 13:02:33','2022-03-03 13:02:33'),(76016,223,'Mathia','273412',1,0,'2022-03-03 13:02:33','2022-03-03 13:02:33'),(76017,223,'Maulaganj','273158',1,0,'2022-03-03 13:02:33','2022-03-03 13:02:33'),(76018,223,'Mehia','273201',1,0,'2022-03-03 13:02:33','2022-03-03 13:02:33'),(76019,223,'Minwa','273209',1,0,'2022-03-03 13:02:33','2022-03-03 13:02:33'),(76020,223,'Mirpur','273007',1,0,'2022-03-03 13:02:33','2022-03-03 13:02:33'),(76021,223,'Mirzapur Bazar','273016',1,0,'2022-03-03 13:02:33','2022-03-03 13:02:33'),(76022,223,'Mishraula','273401',1,0,'2022-03-03 13:02:33','2022-03-03 13:02:33'),(76023,223,'Mithbel','273203',1,0,'2022-03-03 13:02:33','2022-03-03 13:02:33'),(76024,223,'Mohaddipur (Gorakhpur)','273008',1,0,'2022-03-03 13:02:33','2022-03-03 13:02:33'),(76025,223,'Mohaljalkar','273412',1,0,'2022-03-03 13:02:33','2022-03-03 13:02:33'),(76026,223,'Mokarimpur','273404',1,0,'2022-03-03 13:02:34','2022-03-03 13:02:34'),(76027,223,'Mundera Bazar','273201',1,0,'2022-03-03 13:02:34','2022-03-03 13:02:34'),(76028,223,'Munderathakurai','273413',1,0,'2022-03-03 13:02:34','2022-03-03 13:02:34'),(76029,223,'Murarpur','273409',1,0,'2022-03-03 13:02:34','2022-03-03 13:02:34'),(76030,223,'Murdewa','273211',1,0,'2022-03-03 13:02:34','2022-03-03 13:02:34'),(76031,223,'Naiyapar Khurd','273152',1,0,'2022-03-03 13:02:34','2022-03-03 13:02:34'),(76032,223,'Narakataha Bazar','273165',1,0,'2022-03-03 13:02:34','2022-03-03 13:02:34'),(76033,223,'Natwa Jungle','273306',1,0,'2022-03-03 13:02:34','2022-03-03 13:02:34'),(76034,223,'Nausar','273016',1,0,'2022-03-03 13:02:34','2022-03-03 13:02:34'),(76035,223,'Nauwa Awal','273016',1,0,'2022-03-03 13:02:34','2022-03-03 13:02:34'),(76036,223,'Nauwabari','273203',1,0,'2022-03-03 13:02:34','2022-03-03 13:02:34'),(76037,223,'Nawapar','273165',1,0,'2022-03-03 13:02:34','2022-03-03 13:02:34'),(76038,223,'Netwar Bazar','273158',1,0,'2022-03-03 13:02:34','2022-03-03 13:02:34'),(76039,223,'Newada','273412',1,0,'2022-03-03 13:02:34','2022-03-03 13:02:34'),(76040,223,'Newaijpar','273402',1,0,'2022-03-03 13:02:34','2022-03-03 13:02:34'),(76041,223,'Newas','273407',1,0,'2022-03-03 13:02:34','2022-03-03 13:02:34'),(76042,223,'Nibidubey','273402',1,0,'2022-03-03 13:02:34','2022-03-03 13:02:34'),(76043,223,'Niwas','273209',1,0,'2022-03-03 13:02:34','2022-03-03 13:02:34'),(76044,223,'Nuaon','273408',1,0,'2022-03-03 13:02:34','2022-03-03 13:02:34'),(76045,223,'Pac Camp','273014',1,0,'2022-03-03 13:02:34','2022-03-03 13:02:34'),(76046,223,'Pachauri','273212',1,0,'2022-03-03 13:02:34','2022-03-03 13:02:34'),(76047,223,'Pachperwa','273407',1,0,'2022-03-03 13:02:34','2022-03-03 13:02:34'),(76048,223,'Pagar','273212',1,0,'2022-03-03 13:02:34','2022-03-03 13:02:34'),(76049,223,'Pakdidubey','273413',1,0,'2022-03-03 13:02:34','2022-03-03 13:02:34'),(76050,223,'Pali','273209',1,0,'2022-03-03 13:02:35','2022-03-03 13:02:35'),(76051,223,'Pali','273403',1,0,'2022-03-03 13:02:35','2022-03-03 13:02:35'),(76052,223,'Pandeypura','273407',1,0,'2022-03-03 13:02:35','2022-03-03 13:02:35'),(76053,223,'Pandeypura','273403',1,0,'2022-03-03 13:02:35','2022-03-03 13:02:35'),(76054,223,'Parasurampur','273152',1,0,'2022-03-03 13:02:35','2022-03-03 13:02:35'),(76055,223,'Parmeshwar Pur','273007',1,0,'2022-03-03 13:02:35','2022-03-03 13:02:35'),(76056,223,'Parmeswarpur','273209',1,0,'2022-03-03 13:02:35','2022-03-03 13:02:35'),(76057,223,'Parsauni','273201',1,0,'2022-03-03 13:02:35','2022-03-03 13:02:35'),(76058,223,'Parsia','273402',1,0,'2022-03-03 13:02:35','2022-03-03 13:02:35'),(76059,223,'Patakhuli','273213',1,0,'2022-03-03 13:02:35','2022-03-03 13:02:35'),(76060,223,'Patauha','273408',1,0,'2022-03-03 13:02:35','2022-03-03 13:02:35'),(76061,223,'Patna','273402',1,0,'2022-03-03 13:02:35','2022-03-03 13:02:35'),(76062,223,'Patra Bazar','273152',1,0,'2022-03-03 13:02:35','2022-03-03 13:02:35'),(76063,223,'Pepeeganj','273165',1,0,'2022-03-03 13:02:35','2022-03-03 13:02:35'),(76064,223,'Pholwaria','273201',1,0,'2022-03-03 13:02:35','2022-03-03 13:02:35'),(76065,223,'Phothwa Inar','273202',1,0,'2022-03-03 13:02:35','2022-03-03 13:02:35'),(76066,223,'Pichaura','273401',1,0,'2022-03-03 13:02:35','2022-03-03 13:02:35'),(76067,223,'Piparpati','273306',1,0,'2022-03-03 13:02:35','2022-03-03 13:02:35'),(76068,223,'Piparshandi','273404',1,0,'2022-03-03 13:02:35','2022-03-03 13:02:35'),(76069,223,'Pipraich','273152',1,0,'2022-03-03 13:02:35','2022-03-03 13:02:35'),(76070,223,'Piprouli','273212',1,0,'2022-03-03 13:02:35','2022-03-03 13:02:35'),(76071,223,'Pirahani','273402',1,0,'2022-03-03 13:02:35','2022-03-03 13:02:35'),(76072,223,'Purwa Bazar','273407',1,0,'2022-03-03 13:02:36','2022-03-03 13:02:36'),(76073,223,'Raiganj','273010',1,0,'2022-03-03 13:02:36','2022-03-03 13:02:36'),(76074,223,'Railway Colony (Gorakhpur)','273012',1,0,'2022-03-03 13:02:36','2022-03-03 13:02:36'),(76075,223,'Rajabari','273165',1,0,'2022-03-03 13:02:36','2022-03-03 13:02:36'),(76076,223,'Rajahi Camp','273002',1,0,'2022-03-03 13:02:36','2022-03-03 13:02:36'),(76077,223,'Rajdhani','273202',1,0,'2022-03-03 13:02:36','2022-03-03 13:02:36'),(76078,223,'Rajgharh','273411',1,0,'2022-03-03 13:02:36','2022-03-03 13:02:36'),(76079,223,'Rajghat','273005',1,0,'2022-03-03 13:02:36','2022-03-03 13:02:36'),(76080,223,'Rajpur','273158',1,0,'2022-03-03 13:02:36','2022-03-03 13:02:36'),(76081,223,'Rajuarakhurd','273158',1,0,'2022-03-03 13:02:36','2022-03-03 13:02:36'),(76082,223,'Rakhat','273411',1,0,'2022-03-03 13:02:36','2022-03-03 13:02:36'),(76083,223,'Rakhore','273165',1,0,'2022-03-03 13:02:36','2022-03-03 13:02:36'),(76084,223,'Ramchaura','273158',1,0,'2022-03-03 13:02:36','2022-03-03 13:02:36'),(76085,223,'Rampur','273016',1,0,'2022-03-03 13:02:36','2022-03-03 13:02:36'),(76086,223,'Rampur Bhaghaura','273412',1,0,'2022-03-03 13:02:36','2022-03-03 13:02:36'),(76087,223,'Rampur Pandey','273212',1,0,'2022-03-03 13:02:36','2022-03-03 13:02:36'),(76088,223,'Rampur Rakba','273201',1,0,'2022-03-03 13:02:36','2022-03-03 13:02:36'),(76089,223,'Rampurgopalpur','273007',1,0,'2022-03-03 13:02:36','2022-03-03 13:02:36'),(76090,223,'Randauli','273209',1,0,'2022-03-03 13:02:36','2022-03-03 13:02:36'),(76091,223,'Raujadaragah','273407',1,0,'2022-03-03 13:02:36','2022-03-03 13:02:36'),(76092,223,'Rautapur','273209',1,0,'2022-03-03 13:02:36','2022-03-03 13:02:36'),(76093,223,'Rawatganj','273165',1,0,'2022-03-03 13:02:36','2022-03-03 13:02:36'),(76094,223,'Riaon','273412',1,0,'2022-03-03 13:02:36','2022-03-03 13:02:36'),(76095,223,'Rigouli','273158',1,0,'2022-03-03 13:02:37','2022-03-03 13:02:37'),(76096,223,'Rithuwakhor','273209',1,0,'2022-03-03 13:02:37','2022-03-03 13:02:37'),(76097,223,'Rohari','273407',1,0,'2022-03-03 13:02:37','2022-03-03 13:02:37'),(76098,223,'Ropnari','273406',1,0,'2022-03-03 13:02:37','2022-03-03 13:02:37'),(76099,223,'S Athwa Purvi','273201',1,0,'2022-03-03 13:02:37','2022-03-03 13:02:37'),(76100,223,'Sadhna','273405',1,0,'2022-03-03 13:02:37','2022-03-03 13:02:37'),(76101,223,'Sahajanwa','273209',1,0,'2022-03-03 13:02:37','2022-03-03 13:02:37'),(76102,223,'Sahupar','273403',1,0,'2022-03-03 13:02:37','2022-03-03 13:02:37'),(76103,223,'Sahuwakol','273412',1,0,'2022-03-03 13:02:37','2022-03-03 13:02:37'),(76104,223,'Salarpur','273411',1,0,'2022-03-03 13:02:37','2022-03-03 13:02:37'),(76105,223,'Samayathanbhiti','273408',1,0,'2022-03-03 13:02:37','2022-03-03 13:02:37'),(76106,223,'Samdar Khurd','273306',1,0,'2022-03-03 13:02:37','2022-03-03 13:02:37'),(76107,223,'Saraya Tiwari','273406',1,0,'2022-03-03 13:02:37','2022-03-03 13:02:37'),(76108,223,'Sardar Nagar','273202',1,0,'2022-03-03 13:02:37','2022-03-03 13:02:37'),(76109,223,'Sarhari','273165',1,0,'2022-03-03 13:02:37','2022-03-03 13:02:37'),(76110,223,'Semar Dadi','273212',1,0,'2022-03-03 13:02:37','2022-03-03 13:02:37'),(76111,223,'Semra Khurd','273412',1,0,'2022-03-03 13:02:37','2022-03-03 13:02:37'),(76112,223,'Shahpur','273407',1,0,'2022-03-03 13:02:37','2022-03-03 13:02:37'),(76113,223,'Shankarpur','273404',1,0,'2022-03-03 13:02:37','2022-03-03 13:02:37'),(76114,223,'Shingaha','273413',1,0,'2022-03-03 13:02:37','2022-03-03 13:02:37'),(76115,223,'Shivpur (Gorakhpur)','273412',1,0,'2022-03-03 13:02:37','2022-03-03 13:02:37'),(76116,223,'Shivpurinewcolony','273016',1,0,'2022-03-03 13:02:37','2022-03-03 13:02:37'),(76117,223,'Siddharth Enclave','273017',1,0,'2022-03-03 13:02:37','2022-03-03 13:02:37'),(76118,223,'Sidhagaur','273402',1,0,'2022-03-03 13:02:37','2022-03-03 13:02:37'),(76119,223,'Sidhauli','273209',1,0,'2022-03-03 13:02:37','2022-03-03 13:02:37'),(76120,223,'Sidhawana','273407',1,0,'2022-03-03 13:02:38','2022-03-03 13:02:38'),(76121,223,'Sihaijpar','273412',1,0,'2022-03-03 13:02:38','2022-03-03 13:02:38'),(76122,223,'Sihoria','273002',1,0,'2022-03-03 13:02:38','2022-03-03 13:02:38'),(76123,223,'Sihorwa','273007',1,0,'2022-03-03 13:02:38','2022-03-03 13:02:38'),(76124,223,'Sikriganj','273213',1,0,'2022-03-03 13:02:38','2022-03-03 13:02:38'),(76125,223,'Siswa Babu','273404',1,0,'2022-03-03 13:02:38','2022-03-03 13:02:38'),(76126,223,'Siswa Bazar','273163',1,0,'2022-03-03 13:02:38','2022-03-03 13:02:38'),(76127,223,'Siswa Urf Siuwa','273403',1,0,'2022-03-03 13:02:38','2022-03-03 13:02:38'),(76128,223,'Sogaura','273413',1,0,'2022-03-03 13:02:38','2022-03-03 13:02:38'),(76129,223,'Sonbarsa','273201',1,0,'2022-03-03 13:02:38','2022-03-03 13:02:38'),(76130,223,'Sonbarsa Babu','273212',1,0,'2022-03-03 13:02:38','2022-03-03 13:02:38'),(76131,223,'Sonbarsa Bazar','273002',1,0,'2022-03-03 13:02:38','2022-03-03 13:02:38'),(76132,223,'Sonoura Bujurg','273158',1,0,'2022-03-03 13:02:38','2022-03-03 13:02:38'),(76133,223,'Sukahlpuri','273402',1,0,'2022-03-03 13:02:38','2022-03-03 13:02:38'),(76134,223,'Sukrauli','273213',1,0,'2022-03-03 13:02:38','2022-03-03 13:02:38'),(76135,223,'Sumergarh','273306',1,0,'2022-03-03 13:02:38','2022-03-03 13:02:38'),(76136,223,'Suras','273158',1,0,'2022-03-03 13:02:38','2022-03-03 13:02:38'),(76137,223,'Tanda','273402',1,0,'2022-03-03 13:02:38','2022-03-03 13:02:38'),(76138,223,'Tarayapar','273409',1,0,'2022-03-03 13:02:38','2022-03-03 13:02:38'),(76139,223,'Tenuwa','273212',1,0,'2022-03-03 13:02:38','2022-03-03 13:02:38'),(76140,223,'Thakurnagar','273158',1,0,'2022-03-03 13:02:38','2022-03-03 13:02:38'),(76141,223,'Thawaipar','273165',1,0,'2022-03-03 13:02:38','2022-03-03 13:02:38'),(76142,223,'Thunni Mahadev Chak','273413',1,0,'2022-03-03 13:02:39','2022-03-03 13:02:39'),(76143,223,'Tiar','273413',1,0,'2022-03-03 13:02:39','2022-03-03 13:02:39'),(76144,223,'Tighara','273165',1,0,'2022-03-03 13:02:39','2022-03-03 13:02:39'),(76145,223,'Tigharakhairwa','273413',1,0,'2022-03-03 13:02:39','2022-03-03 13:02:39'),(76146,223,'Tiha Mohammadpur','273402',1,0,'2022-03-03 13:02:39','2022-03-03 13:02:39'),(76147,223,'Tikaria','273165',1,0,'2022-03-03 13:02:39','2022-03-03 13:02:39'),(76148,223,'Trilokpur','273213',1,0,'2022-03-03 13:02:39','2022-03-03 13:02:39'),(76149,223,'Turkmanpur','273005',1,0,'2022-03-03 13:02:39','2022-03-03 13:02:39'),(76150,223,'Turkwalia','273165',1,0,'2022-03-03 13:02:39','2022-03-03 13:02:39'),(76151,223,'Uchagaon','273409',1,0,'2022-03-03 13:02:39','2022-03-03 13:02:39'),(76152,223,'Ujjarpar','273412',1,0,'2022-03-03 13:02:39','2022-03-03 13:02:39'),(76153,223,'Unaula','273152',1,0,'2022-03-03 13:02:39','2022-03-03 13:02:39'),(76154,223,'Unwal','273406',1,0,'2022-03-03 13:02:39','2022-03-03 13:02:39'),(76155,223,'Urdu Bazar','273005',1,0,'2022-03-03 13:02:39','2022-03-03 13:02:39'),(76156,223,'Uruwa Bazar','273407',1,0,'2022-03-03 13:02:39','2022-03-03 13:02:39'),(76157,224,'Amgaon','210430',1,0,'2022-03-03 13:02:39','2022-03-03 13:02:39'),(76158,224,'Amood','210432',1,0,'2022-03-03 13:02:39','2022-03-03 13:02:39'),(76159,224,'Anghaura','210421',1,0,'2022-03-03 13:02:39','2022-03-03 13:02:39'),(76160,224,'Artara','210507',1,0,'2022-03-03 13:02:39','2022-03-03 13:02:39'),(76161,224,'Atariyan','210502',1,0,'2022-03-03 13:02:39','2022-03-03 13:02:39'),(76162,224,'Atrauli','210422',1,0,'2022-03-03 13:02:39','2022-03-03 13:02:39'),(76163,224,'Aunta','210431',1,0,'2022-03-03 13:02:40','2022-03-03 13:02:40'),(76164,224,'Bajehta','210501',1,0,'2022-03-03 13:02:40','2022-03-03 13:02:40'),(76165,224,'Bandhur Khurd','210501',1,0,'2022-03-03 13:02:40','2022-03-03 13:02:40'),(76166,224,'Banki','210502',1,0,'2022-03-03 13:02:40','2022-03-03 13:02:40'),(76167,224,'Barauli Kharka','210430',1,0,'2022-03-03 13:02:40','2022-03-03 13:02:40'),(76168,224,'Baruwa Sumerpur','210502',1,0,'2022-03-03 13:02:40','2022-03-03 13:02:40'),(76169,224,'Barwa','210341',1,0,'2022-03-03 13:02:40','2022-03-03 13:02:40'),(76170,224,'Basela','210431',1,0,'2022-03-03 13:02:40','2022-03-03 13:02:40'),(76171,224,'Baswari','210506',1,0,'2022-03-03 13:02:40','2022-03-03 13:02:40'),(76172,224,'Bewar (Hamirpur)','210501',1,0,'2022-03-03 13:02:40','2022-03-03 13:02:40'),(76173,224,'Bhainsai','210431',1,0,'2022-03-03 13:02:40','2022-03-03 13:02:40'),(76174,224,'Bhaismari','210507',1,0,'2022-03-03 13:02:40','2022-03-03 13:02:40'),(76175,224,'Bhamai','210507',1,0,'2022-03-03 13:02:40','2022-03-03 13:02:40'),(76176,224,'Bhauli','210505',1,0,'2022-03-03 13:02:40','2022-03-03 13:02:40'),(76177,224,'Bhulsi','210507',1,0,'2022-03-03 13:02:40','2022-03-03 13:02:40'),(76178,224,'Bibuni Kalan','210506',1,0,'2022-03-03 13:02:40','2022-03-03 13:02:40'),(76179,224,'Bidokhar','210341',1,0,'2022-03-03 13:02:40','2022-03-03 13:02:40'),(76180,224,'Bigahna','210507',1,0,'2022-03-03 13:02:40','2022-03-03 13:02:40'),(76181,224,'Biharka','210507',1,0,'2022-03-03 13:02:40','2022-03-03 13:02:40'),(76182,224,'Bilauta','210505',1,0,'2022-03-03 13:02:40','2022-03-03 13:02:40'),(76183,224,'Bilgaon','210432',1,0,'2022-03-03 13:02:40','2022-03-03 13:02:40'),(76184,224,'Bira','210422',1,0,'2022-03-03 13:02:40','2022-03-03 13:02:40'),(76185,224,'Birkhera','210502',1,0,'2022-03-03 13:02:41','2022-03-03 13:02:41'),(76186,224,'Budero','210429',1,0,'2022-03-03 13:02:41','2022-03-03 13:02:41'),(76187,224,'Chandpura','210502',1,0,'2022-03-03 13:02:41','2022-03-03 13:02:41'),(76188,224,'Chhandaut','210422',1,0,'2022-03-03 13:02:41','2022-03-03 13:02:41'),(76189,224,'Chhani Buzurg','210501',1,0,'2022-03-03 13:02:41','2022-03-03 13:02:41'),(76190,224,'Chhiboli','210432',1,0,'2022-03-03 13:02:41','2022-03-03 13:02:41'),(76191,224,'Chhirka','210504',1,0,'2022-03-03 13:02:41','2022-03-03 13:02:41'),(76192,224,'Chichara','210504',1,0,'2022-03-03 13:02:41','2022-03-03 13:02:41'),(76193,224,'Chikahra','210427',1,0,'2022-03-03 13:02:41','2022-03-03 13:02:41'),(76194,224,'Chikasi','210430',1,0,'2022-03-03 13:02:41','2022-03-03 13:02:41'),(76195,224,'Chilli','210431',1,0,'2022-03-03 13:02:41','2022-03-03 13:02:41'),(76196,224,'Chilli','210506',1,0,'2022-03-03 13:02:41','2022-03-03 13:02:41'),(76197,224,'Deogaon','210341',1,0,'2022-03-03 13:02:41','2022-03-03 13:02:41'),(76198,224,'Dhagwan','210428',1,0,'2022-03-03 13:02:41','2022-03-03 13:02:41'),(76199,224,'Dhamna','210431',1,0,'2022-03-03 13:02:41','2022-03-03 13:02:41'),(76200,224,'Dhanauri','210431',1,0,'2022-03-03 13:02:41','2022-03-03 13:02:41'),(76201,224,'Dhauhal Buzurg','210432',1,0,'2022-03-03 13:02:41','2022-03-03 13:02:41'),(76202,224,'Gahrauli','210506',1,0,'2022-03-03 13:02:41','2022-03-03 13:02:41'),(76203,224,'Garha','210424',1,0,'2022-03-03 13:02:41','2022-03-03 13:02:41'),(76204,224,'Garha','210507',1,0,'2022-03-03 13:02:41','2022-03-03 13:02:41'),(76205,224,'Gohand','210430',1,0,'2022-03-03 13:02:41','2022-03-03 13:02:41'),(76206,224,'Gundela','210506',1,0,'2022-03-03 13:02:41','2022-03-03 13:02:41'),(76207,224,'Gusiyari','210504',1,0,'2022-03-03 13:02:41','2022-03-03 13:02:41'),(76208,224,'Hamirpur DB','210301',1,0,'2022-03-03 13:02:41','2022-03-03 13:02:41'),(76209,224,'Hamirpur H.O','210301',1,0,'2022-03-03 13:02:41','2022-03-03 13:02:41'),(76210,224,'Ichauli','210507',1,0,'2022-03-03 13:02:42','2022-03-03 13:02:42'),(76211,224,'Imiliya','210506',1,0,'2022-03-03 13:02:42','2022-03-03 13:02:42'),(76212,224,'Inderpura','210432',1,0,'2022-03-03 13:02:42','2022-03-03 13:02:42'),(76213,224,'Ingohta','210341',1,0,'2022-03-03 13:02:42','2022-03-03 13:02:42'),(76214,224,'Islampur','210422',1,0,'2022-03-03 13:02:42','2022-03-03 13:02:42'),(76215,224,'Itailiya','210422',1,0,'2022-03-03 13:02:42','2022-03-03 13:02:42'),(76216,224,'Itaura','210431',1,0,'2022-03-03 13:02:42','2022-03-03 13:02:42'),(76217,224,'Jakeri','210431',1,0,'2022-03-03 13:02:42','2022-03-03 13:02:42'),(76218,224,'Jalalpur','210432',1,0,'2022-03-03 13:02:42','2022-03-03 13:02:42'),(76219,224,'Jarakhar','210428',1,0,'2022-03-03 13:02:42','2022-03-03 13:02:42'),(76220,224,'Jaria (Hamirpur)','210422',1,0,'2022-03-03 13:02:42','2022-03-03 13:02:42'),(76221,224,'Jhalokhar','210505',1,0,'2022-03-03 13:02:42','2022-03-03 13:02:42'),(76222,224,'Jigni','210430',1,0,'2022-03-03 13:02:42','2022-03-03 13:02:42'),(76223,224,'Kachhewan Kalan','210430',1,0,'2022-03-03 13:02:42','2022-03-03 13:02:42'),(76224,224,'Kahra','210504',1,0,'2022-03-03 13:02:42','2022-03-03 13:02:42'),(76225,224,'Kaitha','210431',1,0,'2022-03-03 13:02:42','2022-03-03 13:02:42'),(76226,224,'Kaithi','210507',1,0,'2022-03-03 13:02:42','2022-03-03 13:02:42'),(76227,224,'Kalaulitir','210301',1,0,'2022-03-03 13:02:42','2022-03-03 13:02:42'),(76228,224,'Kamharia','210507',1,0,'2022-03-03 13:02:42','2022-03-03 13:02:42'),(76229,224,'Kandaur','210505',1,0,'2022-03-03 13:02:42','2022-03-03 13:02:42'),(76230,224,'Karahiya','210504',1,0,'2022-03-03 13:02:42','2022-03-03 13:02:42'),(76231,224,'Kargawan','210430',1,0,'2022-03-03 13:02:42','2022-03-03 13:02:42'),(76232,224,'Khandeh','210507',1,0,'2022-03-03 13:02:42','2022-03-03 13:02:42'),(76233,224,'Kharaunj','210505',1,0,'2022-03-03 13:02:42','2022-03-03 13:02:42'),(76234,224,'Khera Silazit','210422',1,0,'2022-03-03 13:02:43','2022-03-03 13:02:43'),(76235,224,'Khiruhi','210504',1,0,'2022-03-03 13:02:43','2022-03-03 13:02:43'),(76236,224,'Kishwahi','210507',1,0,'2022-03-03 13:02:43','2022-03-03 13:02:43'),(76237,224,'Kot Bazar Rath','210431',1,0,'2022-03-03 13:02:43','2022-03-03 13:02:43'),(76238,224,'Kuchhechha','210301',1,0,'2022-03-03 13:02:43','2022-03-03 13:02:43'),(76239,224,'Kundaura','210502',1,0,'2022-03-03 13:02:43','2022-03-03 13:02:43'),(76240,224,'Kunetha','210507',1,0,'2022-03-03 13:02:43','2022-03-03 13:02:43'),(76241,224,'Kurara','210505',1,0,'2022-03-03 13:02:43','2022-03-03 13:02:43'),(76242,224,'Kusmara','210505',1,0,'2022-03-03 13:02:43','2022-03-03 13:02:43'),(76243,224,'Kuwan','210425',1,0,'2022-03-03 13:02:43','2022-03-03 13:02:43'),(76244,224,'Lodipur Newada','210501',1,0,'2022-03-03 13:02:43','2022-03-03 13:02:43'),(76245,224,'Magrauth','210430',1,0,'2022-03-03 13:02:43','2022-03-03 13:02:43'),(76246,224,'Mahera','210501',1,0,'2022-03-03 13:02:43','2022-03-03 13:02:43'),(76247,224,'Majhagawan','210428',1,0,'2022-03-03 13:02:43','2022-03-03 13:02:43'),(76248,224,'Makraon','210507',1,0,'2022-03-03 13:02:43','2022-03-03 13:02:43'),(76249,224,'Malehta','210428',1,0,'2022-03-03 13:02:43','2022-03-03 13:02:43'),(76250,224,'Manjhoopur','210301',1,0,'2022-03-03 13:02:43','2022-03-03 13:02:43'),(76251,224,'Manna','210432',1,0,'2022-03-03 13:02:43','2022-03-03 13:02:43'),(76252,224,'Masgaon','210506',1,0,'2022-03-03 13:02:43','2022-03-03 13:02:43'),(76253,224,'Mawai Khurd','210504',1,0,'2022-03-03 13:02:43','2022-03-03 13:02:43'),(76254,224,'Mawaijar','210341',1,0,'2022-03-03 13:02:43','2022-03-03 13:02:43'),(76255,224,'Mehuna Mundera','210507',1,0,'2022-03-03 13:02:43','2022-03-03 13:02:43'),(76256,224,'Misripur','210505',1,0,'2022-03-03 13:02:44','2022-03-03 13:02:44'),(76257,224,'Muskara','210506',1,0,'2022-03-03 13:02:44','2022-03-03 13:02:44'),(76258,224,'Nadehra','210502',1,0,'2022-03-03 13:02:44','2022-03-03 13:02:44'),(76259,224,'Nakra','210431',1,0,'2022-03-03 13:02:44','2022-03-03 13:02:44'),(76260,224,'Naraich','210507',1,0,'2022-03-03 13:02:44','2022-03-03 13:02:44'),(76261,224,'Nauranga','210428',1,0,'2022-03-03 13:02:44','2022-03-03 13:02:44'),(76262,224,'Neoli Bansa','210432',1,0,'2022-03-03 13:02:44','2022-03-03 13:02:44'),(76263,224,'Neoria','210506',1,0,'2022-03-03 13:02:44','2022-03-03 13:02:44'),(76264,224,'Odera','210431',1,0,'2022-03-03 13:02:44','2022-03-03 13:02:44'),(76265,224,'Pachkhura','210502',1,0,'2022-03-03 13:02:44','2022-03-03 13:02:44'),(76266,224,'Padhori','210507',1,0,'2022-03-03 13:02:44','2022-03-03 13:02:44'),(76267,224,'Pahari Bhitari','210506',1,0,'2022-03-03 13:02:44','2022-03-03 13:02:44'),(76268,224,'Pandhari','210502',1,0,'2022-03-03 13:02:44','2022-03-03 13:02:44'),(76269,224,'Para','210505',1,0,'2022-03-03 13:02:44','2022-03-03 13:02:44'),(76270,224,'Parchhat','210507',1,0,'2022-03-03 13:02:44','2022-03-03 13:02:44'),(76271,224,'Patanpur','210341',1,0,'2022-03-03 13:02:44','2022-03-03 13:02:44'),(76272,224,'Patara','210505',1,0,'2022-03-03 13:02:44','2022-03-03 13:02:44'),(76273,224,'Pauthia Bujurg','210301',1,0,'2022-03-03 13:02:44','2022-03-03 13:02:44'),(76274,224,'Piteora','210341',1,0,'2022-03-03 13:02:44','2022-03-03 13:02:44'),(76275,224,'Puraini','210432',1,0,'2022-03-03 13:02:44','2022-03-03 13:02:44'),(76276,224,'Ragaul','210507',1,0,'2022-03-03 13:02:44','2022-03-03 13:02:44'),(76277,224,'Ragaul Tahsil','210507',1,0,'2022-03-03 13:02:44','2022-03-03 13:02:44'),(76278,224,'Rahank','210430',1,0,'2022-03-03 13:02:44','2022-03-03 13:02:44'),(76279,224,'Rath','210431',1,0,'2022-03-03 13:02:45','2022-03-03 13:02:45'),(76280,224,'Rawatpura','210430',1,0,'2022-03-03 13:02:45','2022-03-03 13:02:45'),(76281,224,'Ruripara','210501',1,0,'2022-03-03 13:02:45','2022-03-03 13:02:45'),(76282,224,'Sarila State','210432',1,0,'2022-03-03 13:02:45','2022-03-03 13:02:45'),(76283,224,'Sarsai','210431',1,0,'2022-03-03 13:02:45','2022-03-03 13:02:45'),(76284,224,'Sayar','210501',1,0,'2022-03-03 13:02:45','2022-03-03 13:02:45'),(76285,224,'Shekaupur','210505',1,0,'2022-03-03 13:02:45','2022-03-03 13:02:45'),(76286,224,'Sisolar','210507',1,0,'2022-03-03 13:02:45','2022-03-03 13:02:45'),(76287,224,'Sukaura','210424',1,0,'2022-03-03 13:02:45','2022-03-03 13:02:45'),(76288,224,'Surauli Bzg.','210502',1,0,'2022-03-03 13:02:45','2022-03-03 13:02:45'),(76289,224,'Surha','210425',1,0,'2022-03-03 13:02:45','2022-03-03 13:02:45'),(76290,224,'Swasa Bujurg','210501',1,0,'2022-03-03 13:02:45','2022-03-03 13:02:45'),(76291,224,'Terha','210502',1,0,'2022-03-03 13:02:45','2022-03-03 13:02:45'),(76292,224,'Tikrauli','210301',1,0,'2022-03-03 13:02:45','2022-03-03 13:02:45'),(76293,224,'Tolarawat','210428',1,0,'2022-03-03 13:02:45','2022-03-03 13:02:45'),(76294,224,'Turra','210431',1,0,'2022-03-03 13:02:45','2022-03-03 13:02:45'),(76295,224,'Ujnedi','210301',1,0,'2022-03-03 13:02:45','2022-03-03 13:02:45'),(76296,224,'Umari','210501',1,0,'2022-03-03 13:02:45','2022-03-03 13:02:45'),(76297,224,'Umariya','210431',1,0,'2022-03-03 13:02:45','2022-03-03 13:02:45'),(76298,224,'Urdana','210507',1,0,'2022-03-03 13:02:45','2022-03-03 13:02:45'),(76299,224,'Zitkiri','210422',1,0,'2022-03-03 13:02:45','2022-03-03 13:02:45'),(76300,225,'Aamtara','241123',1,0,'2022-03-03 13:02:45','2022-03-03 13:02:45'),(76301,225,'Abdulla Nagar','241407',1,0,'2022-03-03 13:02:45','2022-03-03 13:02:45'),(76302,225,'Adampur','241403',1,0,'2022-03-03 13:02:45','2022-03-03 13:02:45'),(76303,225,'Aihrori','241121',1,0,'2022-03-03 13:02:45','2022-03-03 13:02:45'),(76304,225,'Ajamatpur','241202',1,0,'2022-03-03 13:02:45','2022-03-03 13:02:45'),(76305,225,'Akhbelpur Malwa','241403',1,0,'2022-03-03 13:02:46','2022-03-03 13:02:46'),(76306,225,'Alam Nagar','241407',1,0,'2022-03-03 13:02:46','2022-03-03 13:02:46'),(76307,225,'Aliganj Nankheria','241123',1,0,'2022-03-03 13:02:46','2022-03-03 13:02:46'),(76308,225,'Allipur','241125',1,0,'2022-03-03 13:02:46','2022-03-03 13:02:46'),(76309,225,'Amirta','241123',1,0,'2022-03-03 13:02:46','2022-03-03 13:02:46'),(76310,225,'Anangpur','241123',1,0,'2022-03-03 13:02:46','2022-03-03 13:02:46'),(76311,225,'Andharra','241301',1,0,'2022-03-03 13:02:46','2022-03-03 13:02:46'),(76312,225,'Anjhi Gaon','241124',1,0,'2022-03-03 13:02:46','2022-03-03 13:02:46'),(76313,225,'Anjhi R S','241124',1,0,'2022-03-03 13:02:46','2022-03-03 13:02:46'),(76314,225,'Arjunpur','241402',1,0,'2022-03-03 13:02:46','2022-03-03 13:02:46'),(76315,225,'Arwal','241402',1,0,'2022-03-03 13:02:46','2022-03-03 13:02:46'),(76316,225,'Ashi Azampur','241305',1,0,'2022-03-03 13:02:46','2022-03-03 13:02:46'),(76317,225,'Atia Sahpur','241204',1,0,'2022-03-03 13:02:46','2022-03-03 13:02:46'),(76318,225,'Atrauli','241204',1,0,'2022-03-03 13:02:46','2022-03-03 13:02:46'),(76319,225,'Atsaliya','241203',1,0,'2022-03-03 13:02:46','2022-03-03 13:02:46'),(76320,225,'Atwa Ali Mardanpur','241126',1,0,'2022-03-03 13:02:46','2022-03-03 13:02:46'),(76321,225,'Atwa Bhasen','241204',1,0,'2022-03-03 13:02:46','2022-03-03 13:02:46'),(76322,225,'Atwa Kataiya','241121',1,0,'2022-03-03 13:02:46','2022-03-03 13:02:46'),(76323,225,'Babarpur','241123',1,0,'2022-03-03 13:02:46','2022-03-03 13:02:46'),(76324,225,'Babatmau','241303',1,0,'2022-03-03 13:02:46','2022-03-03 13:02:46'),(76325,225,'Babnapur','241001',1,0,'2022-03-03 13:02:46','2022-03-03 13:02:46'),(76326,225,'Baghauli','241122',1,0,'2022-03-03 13:02:46','2022-03-03 13:02:46'),(76327,225,'Baghrai','241403',1,0,'2022-03-03 13:02:47','2022-03-03 13:02:47'),(76328,225,'Bahar','241001',1,0,'2022-03-03 13:02:47','2022-03-03 13:02:47'),(76329,225,'Bahera Rasoolpur','241125',1,0,'2022-03-03 13:02:47','2022-03-03 13:02:47'),(76330,225,'Bahlolpur','241201',1,0,'2022-03-03 13:02:47','2022-03-03 13:02:47'),(76331,225,'Bahorwa','241404',1,0,'2022-03-03 13:02:47','2022-03-03 13:02:47'),(76332,225,'Bahuti','241203',1,0,'2022-03-03 13:02:47','2022-03-03 13:02:47'),(76333,225,'Baijupur','241123',1,0,'2022-03-03 13:02:47','2022-03-03 13:02:47'),(76334,225,'Bakhaura','241303',1,0,'2022-03-03 13:02:47','2022-03-03 13:02:47'),(76335,225,'Balamau Village','241126',1,0,'2022-03-03 13:02:47','2022-03-03 13:02:47'),(76336,225,'Bamhna Khera','241122',1,0,'2022-03-03 13:02:47','2022-03-03 13:02:47'),(76337,225,'Bamtapur','241401',1,0,'2022-03-03 13:02:47','2022-03-03 13:02:47'),(76338,225,'Bandaraha','241407',1,0,'2022-03-03 13:02:47','2022-03-03 13:02:47'),(76339,225,'Bani','241202',1,0,'2022-03-03 13:02:47','2022-03-03 13:02:47'),(76340,225,'Banjariya','241406',1,0,'2022-03-03 13:02:47','2022-03-03 13:02:47'),(76341,225,'Bansa','241303',1,0,'2022-03-03 13:02:47','2022-03-03 13:02:47'),(76342,225,'Bara Gaon','241201',1,0,'2022-03-03 13:02:47','2022-03-03 13:02:47'),(76343,225,'Barahuwan','241303',1,0,'2022-03-03 13:02:47','2022-03-03 13:02:47'),(76344,225,'Baran','241402',1,0,'2022-03-03 13:02:47','2022-03-03 13:02:47'),(76345,225,'Barauna','241303',1,0,'2022-03-03 13:02:47','2022-03-03 13:02:47'),(76346,225,'Barkherwa','241121',1,0,'2022-03-03 13:02:47','2022-03-03 13:02:47'),(76347,225,'Barnai Chatarkha','241402',1,0,'2022-03-03 13:02:47','2022-03-03 13:02:47'),(76348,225,'Barsohiya','241402',1,0,'2022-03-03 13:02:47','2022-03-03 13:02:47'),(76349,225,'Baruwara','241123',1,0,'2022-03-03 13:02:47','2022-03-03 13:02:47'),(76350,225,'Barwa Sarsand','241126',1,0,'2022-03-03 13:02:47','2022-03-03 13:02:47'),(76351,225,'Barwan (Hardoi)','241401',1,0,'2022-03-03 13:02:48','2022-03-03 13:02:48'),(76352,225,'Basit Nagar','241124',1,0,'2022-03-03 13:02:48','2022-03-03 13:02:48'),(76353,225,'Bawan','241001',1,0,'2022-03-03 13:02:48','2022-03-03 13:02:48'),(76354,225,'Behander','241201',1,0,'2022-03-03 13:02:48','2022-03-03 13:02:48'),(76355,225,'Behendar Khurd','241201',1,0,'2022-03-03 13:02:48','2022-03-03 13:02:48'),(76356,225,'Behsar','241305',1,0,'2022-03-03 13:02:48','2022-03-03 13:02:48'),(76357,225,'Behta Gokul','241125',1,0,'2022-03-03 13:02:48','2022-03-03 13:02:48'),(76358,225,'Behta Rampura','241402',1,0,'2022-03-03 13:02:48','2022-03-03 13:02:48'),(76359,225,'Beniganj','241304',1,0,'2022-03-03 13:02:48','2022-03-03 13:02:48'),(76360,225,'Beruwa','241304',1,0,'2022-03-03 13:02:48','2022-03-03 13:02:48'),(76361,225,'Bhadaicha','241001',1,0,'2022-03-03 13:02:48','2022-03-03 13:02:48'),(76362,225,'Bhadeora','241405',1,0,'2022-03-03 13:02:48','2022-03-03 13:02:48'),(76363,225,'Bhagwant Nagar','241303',1,0,'2022-03-03 13:02:48','2022-03-03 13:02:48'),(76364,225,'Bhailamau','241401',1,0,'2022-03-03 13:02:48','2022-03-03 13:02:48'),(76365,225,'Bhainsari','241404',1,0,'2022-03-03 13:02:48','2022-03-03 13:02:48'),(76366,225,'Bharakhani','241123',1,0,'2022-03-03 13:02:48','2022-03-03 13:02:48'),(76367,225,'Bharawan','241202',1,0,'2022-03-03 13:02:48','2022-03-03 13:02:48'),(76368,225,'Bharayal','241121',1,0,'2022-03-03 13:02:48','2022-03-03 13:02:48'),(76369,225,'Bhatoli','241201',1,0,'2022-03-03 13:02:48','2022-03-03 13:02:48'),(76370,225,'Bhatpur','241202',1,0,'2022-03-03 13:02:48','2022-03-03 13:02:48'),(76371,225,'Bhikpur Aima','241304',1,0,'2022-03-03 13:02:48','2022-03-03 13:02:48'),(76372,225,'Bhitha Maha Singh','241121',1,0,'2022-03-03 13:02:48','2022-03-03 13:02:48'),(76373,225,'Bhithadan','241122',1,0,'2022-03-03 13:02:48','2022-03-03 13:02:48'),(76374,225,'Bhithai','241303',1,0,'2022-03-03 13:02:49','2022-03-03 13:02:49'),(76375,225,'Bhogiyapur','241407',1,0,'2022-03-03 13:02:49','2022-03-03 13:02:49'),(76376,225,'Bijgawan','241125',1,0,'2022-03-03 13:02:49','2022-03-03 13:02:49'),(76377,225,'Bijgawan','241406',1,0,'2022-03-03 13:02:49','2022-03-03 13:02:49'),(76378,225,'Bilgram B.S.','241301',1,0,'2022-03-03 13:02:49','2022-03-03 13:02:49'),(76379,225,'Bilgram','241301',1,0,'2022-03-03 13:02:49','2022-03-03 13:02:49'),(76380,225,'Bilsari','241123',1,0,'2022-03-03 13:02:49','2022-03-03 13:02:49'),(76381,225,'Birauli','241201',1,0,'2022-03-03 13:02:49','2022-03-03 13:02:49'),(76382,225,'Bootamau','241401',1,0,'2022-03-03 13:02:49','2022-03-03 13:02:49'),(76383,225,'Burhagaon','241406',1,0,'2022-03-03 13:02:49','2022-03-03 13:02:49'),(76384,225,'Chacharapur','241403',1,0,'2022-03-03 13:02:49','2022-03-03 13:02:49'),(76385,225,'Chaina','241407',1,0,'2022-03-03 13:02:49','2022-03-03 13:02:49'),(76386,225,'Chanadapur','241402',1,0,'2022-03-03 13:02:49','2022-03-03 13:02:49'),(76387,225,'Chandeli','241405',1,0,'2022-03-03 13:02:49','2022-03-03 13:02:49'),(76388,225,'Chathia','241304',1,0,'2022-03-03 13:02:49','2022-03-03 13:02:49'),(76389,225,'Chathia Dhanwar','241125',1,0,'2022-03-03 13:02:49','2022-03-03 13:02:49'),(76390,225,'Chhanoiya','241204',1,0,'2022-03-03 13:02:49','2022-03-03 13:02:49'),(76391,225,'Chhatia Rampur','241202',1,0,'2022-03-03 13:02:49','2022-03-03 13:02:49'),(76392,225,'Chhawan','241202',1,0,'2022-03-03 13:02:49','2022-03-03 13:02:49'),(76393,225,'Chhibaramau','241301',1,0,'2022-03-03 13:02:49','2022-03-03 13:02:49'),(76394,225,'Civil Lines (Hardoi)','241001',1,0,'2022-03-03 13:02:49','2022-03-03 13:02:49'),(76395,225,'Dabha','241301',1,0,'2022-03-03 13:02:50','2022-03-03 13:02:50'),(76396,225,'Daheliya','241402',1,0,'2022-03-03 13:02:50','2022-03-03 13:02:50'),(76397,225,'Daheliya Rampur','241407',1,0,'2022-03-03 13:02:50','2022-03-03 13:02:50'),(76398,225,'Dahigawan','241301',1,0,'2022-03-03 13:02:50','2022-03-03 13:02:50'),(76399,225,'Dalelnagar','241204',1,0,'2022-03-03 13:02:50','2022-03-03 13:02:50'),(76400,225,'Daru Kuinwa','241303',1,0,'2022-03-03 13:02:50','2022-03-03 13:02:50'),(76401,225,'Daultpur','241123',1,0,'2022-03-03 13:02:50','2022-03-03 13:02:50'),(76402,225,'Deoria','241404',1,0,'2022-03-03 13:02:50','2022-03-03 13:02:50'),(76403,225,'Dewari','241201',1,0,'2022-03-03 13:02:50','2022-03-03 13:02:50'),(76404,225,'Dhani Nagla','241123',1,0,'2022-03-03 13:02:50','2022-03-03 13:02:50'),(76405,225,'Dhiar Maholiya','241001',1,0,'2022-03-03 13:02:50','2022-03-03 13:02:50'),(76406,225,'Dhikunni','241203',1,0,'2022-03-03 13:02:50','2022-03-03 13:02:50'),(76407,225,'Durgaganj','241301',1,0,'2022-03-03 13:02:50','2022-03-03 13:02:50'),(76408,225,'Eja','241001',1,0,'2022-03-03 13:02:50','2022-03-03 13:02:50'),(76409,225,'Erka Bherka','241203',1,0,'2022-03-03 13:02:50','2022-03-03 13:02:50'),(76410,225,'Faridapur','241122',1,0,'2022-03-03 13:02:50','2022-03-03 13:02:50'),(76411,225,'Fatehpur Gayand','241124',1,0,'2022-03-03 13:02:50','2022-03-03 13:02:50'),(76412,225,'Fatehpur Gazi','241124',1,0,'2022-03-03 13:02:50','2022-03-03 13:02:50'),(76413,225,'Gadeora','241121',1,0,'2022-03-03 13:02:50','2022-03-03 13:02:50'),(76414,225,'Gajoo','241126',1,0,'2022-03-03 13:02:50','2022-03-03 13:02:50'),(76415,225,'Gauntra','241302',1,0,'2022-03-03 13:02:50','2022-03-03 13:02:50'),(76416,225,'Gaura','241302',1,0,'2022-03-03 13:02:51','2022-03-03 13:02:51'),(76417,225,'Gauri Dayampur','241201',1,0,'2022-03-03 13:02:51','2022-03-03 13:02:51'),(76418,225,'Gaus Ganj','241305',1,0,'2022-03-03 13:02:51','2022-03-03 13:02:51'),(76419,225,'Gondarao','241304',1,0,'2022-03-03 13:02:51','2022-03-03 13:02:51'),(76420,225,'Goni Gondwa','241203',1,0,'2022-03-03 13:02:51','2022-03-03 13:02:51'),(76421,225,'Gopamau','241404',1,0,'2022-03-03 13:02:51','2022-03-03 13:02:51'),(76422,225,'Goswa','241303',1,0,'2022-03-03 13:02:51','2022-03-03 13:02:51'),(76423,225,'Hans Barauli','241304',1,0,'2022-03-03 13:02:51','2022-03-03 13:02:51'),(76424,225,'Hardoi Bazar','241001',1,0,'2022-03-03 13:02:51','2022-03-03 13:02:51'),(76425,225,'Hardoi H.O','241001',1,0,'2022-03-03 13:02:51','2022-03-03 13:02:51'),(76426,225,'Hardoi Kutchery','241001',1,0,'2022-03-03 13:02:51','2022-03-03 13:02:51'),(76427,225,'Hardoi R. S.','241001',1,0,'2022-03-03 13:02:51','2022-03-03 13:02:51'),(76428,225,'Hardoi Sugar Mills','241001',1,0,'2022-03-03 13:02:51','2022-03-03 13:02:51'),(76429,225,'Harha Malikapur','241123',1,0,'2022-03-03 13:02:51','2022-03-03 13:02:51'),(76430,225,'Hariharpur','241404',1,0,'2022-03-03 13:02:51','2022-03-03 13:02:51'),(76431,225,'Hariyawan','241405',1,0,'2022-03-03 13:02:51','2022-03-03 13:02:51'),(76432,225,'Harpalpur (Hardoi)','241402',1,0,'2022-03-03 13:02:51','2022-03-03 13:02:51'),(76433,225,'Harrai','241404',1,0,'2022-03-03 13:02:51','2022-03-03 13:02:51'),(76434,225,'Harrai','241124',1,0,'2022-03-03 13:02:51','2022-03-03 13:02:51'),(76435,225,'Harraiya','241304',1,0,'2022-03-03 13:02:51','2022-03-03 13:02:51'),(76436,225,'Hathaura Raj','241126',1,0,'2022-03-03 13:02:51','2022-03-03 13:02:51'),(76437,225,'Hazipur','241202',1,0,'2022-03-03 13:02:51','2022-03-03 13:02:51'),(76438,225,'Hiya','241201',1,0,'2022-03-03 13:02:51','2022-03-03 13:02:51'),(76439,225,'Ishwarpur Sain','241303',1,0,'2022-03-03 13:02:51','2022-03-03 13:02:51'),(76440,225,'Itara','241406',1,0,'2022-03-03 13:02:51','2022-03-03 13:02:51'),(76441,225,'Jahani Khera','241407',1,0,'2022-03-03 13:02:52','2022-03-03 13:02:52'),(76442,225,'Jahidpur','241201',1,0,'2022-03-03 13:02:52','2022-03-03 13:02:52'),(76443,225,'Jairajpur','241304',1,0,'2022-03-03 13:02:52','2022-03-03 13:02:52'),(76444,225,'Jamura','241124',1,0,'2022-03-03 13:02:52','2022-03-03 13:02:52'),(76445,225,'Jangaon','241203',1,0,'2022-03-03 13:02:52','2022-03-03 13:02:52'),(76446,225,'Jarauli Newada','241403',1,0,'2022-03-03 13:02:52','2022-03-03 13:02:52'),(76447,225,'Jarauwa','241304',1,0,'2022-03-03 13:02:52','2022-03-03 13:02:52'),(76448,225,'Jareli','241406',1,0,'2022-03-03 13:02:52','2022-03-03 13:02:52'),(76449,225,'Jareuli Sherpur','241301',1,0,'2022-03-03 13:02:52','2022-03-03 13:02:52'),(76450,225,'Jarha','241201',1,0,'2022-03-03 13:02:52','2022-03-03 13:02:52'),(76451,225,'Jeora','241123',1,0,'2022-03-03 13:02:52','2022-03-03 13:02:52'),(76452,225,'Kachhauna','241126',1,0,'2022-03-03 13:02:52','2022-03-03 13:02:52'),(76453,225,'Kaimau','241122',1,0,'2022-03-03 13:02:52','2022-03-03 13:02:52'),(76454,225,'Kaimi','241125',1,0,'2022-03-03 13:02:52','2022-03-03 13:02:52'),(76455,225,'Kakarghata','241124',1,0,'2022-03-03 13:02:52','2022-03-03 13:02:52'),(76456,225,'Kakendi','241001',1,0,'2022-03-03 13:02:52','2022-03-03 13:02:52'),(76457,225,'Kalauli','241126',1,0,'2022-03-03 13:02:52','2022-03-03 13:02:52'),(76458,225,'Kalika','241121',1,0,'2022-03-03 13:02:52','2022-03-03 13:02:52'),(76459,225,'Kalyanmal','241304',1,0,'2022-03-03 13:02:52','2022-03-03 13:02:52'),(76460,225,'Kamalpur','241123',1,0,'2022-03-03 13:02:52','2022-03-03 13:02:52'),(76461,225,'Karim Nagar','241406',1,0,'2022-03-03 13:02:52','2022-03-03 13:02:52'),(76462,225,'Karim Nagar Sunauwa','241304',1,0,'2022-03-03 13:02:53','2022-03-03 13:02:53'),(76463,225,'Kashipur Baheria','241203',1,0,'2022-03-03 13:02:53','2022-03-03 13:02:53'),(76464,225,'Kaudha','241001',1,0,'2022-03-03 13:02:53','2022-03-03 13:02:53'),(76465,225,'Kaudiya','241202',1,0,'2022-03-03 13:02:53','2022-03-03 13:02:53'),(76466,225,'Khajohana','241305',1,0,'2022-03-03 13:02:53','2022-03-03 13:02:53'),(76467,225,'Khajurahara','241001',1,0,'2022-03-03 13:02:53','2022-03-03 13:02:53'),(76468,225,'Khanigaon Khurd','241401',1,0,'2022-03-03 13:02:53','2022-03-03 13:02:53'),(76469,225,'Khasaura','241402',1,0,'2022-03-03 13:02:53','2022-03-03 13:02:53'),(76470,225,'Khateli','241406',1,0,'2022-03-03 13:02:53','2022-03-03 13:02:53'),(76471,225,'Khitauli','241123',1,0,'2022-03-03 13:02:53','2022-03-03 13:02:53'),(76472,225,'Khurda Madarpur','241305',1,0,'2022-03-03 13:02:53','2022-03-03 13:02:53'),(76473,225,'Kodra Saraiya','241124',1,0,'2022-03-03 13:02:53','2022-03-03 13:02:53'),(76474,225,'Kothawan','241304',1,0,'2022-03-03 13:02:53','2022-03-03 13:02:53'),(76475,225,'Kotkalan','241406',1,0,'2022-03-03 13:02:53','2022-03-03 13:02:53'),(76476,225,'Kuchila','241403',1,0,'2022-03-03 13:02:53','2022-03-03 13:02:53'),(76477,225,'Kudauni','241201',1,0,'2022-03-03 13:02:53','2022-03-03 13:02:53'),(76478,225,'Kundi','241124',1,0,'2022-03-03 13:02:53','2022-03-03 13:02:53'),(76479,225,'Kuniya','241304',1,0,'2022-03-03 13:02:53','2022-03-03 13:02:53'),(76480,225,'Kunwarpur Basith','241407',1,0,'2022-03-03 13:02:53','2022-03-03 13:02:53'),(76481,225,'Kurria','241001',1,0,'2022-03-03 13:02:53','2022-03-03 13:02:53'),(76482,225,'Kursath','241126',1,0,'2022-03-03 13:02:53','2022-03-03 13:02:53'),(76483,225,'Kurseli','241405',1,0,'2022-03-03 13:02:53','2022-03-03 13:02:53'),(76484,225,'Kusuma','241406',1,0,'2022-03-03 13:02:53','2022-03-03 13:02:53'),(76485,225,'Kutuwapur','241001',1,0,'2022-03-03 13:02:53','2022-03-03 13:02:53'),(76486,225,'Lakhmapur','241123',1,0,'2022-03-03 13:02:53','2022-03-03 13:02:53'),(76487,225,'Lalpalpur','241001',1,0,'2022-03-03 13:02:54','2022-03-03 13:02:54'),(76488,225,'Lamkan','241402',1,0,'2022-03-03 13:02:54','2022-03-03 13:02:54'),(76489,225,'Lilwal','241404',1,0,'2022-03-03 13:02:54','2022-03-03 13:02:54'),(76490,225,'Lonar','241401',1,0,'2022-03-03 13:02:54','2022-03-03 13:02:54'),(76491,225,'Lonhra','241126',1,0,'2022-03-03 13:02:54','2022-03-03 13:02:54'),(76492,225,'Loomamau','241204',1,0,'2022-03-03 13:02:54','2022-03-03 13:02:54'),(76493,225,'Madar','241201',1,0,'2022-03-03 13:02:54','2022-03-03 13:02:54'),(76494,225,'Madara','241001',1,0,'2022-03-03 13:02:54','2022-03-03 13:02:54'),(76495,225,'Madhoganj (Hardoi)','241302',1,0,'2022-03-03 13:02:54','2022-03-03 13:02:54'),(76496,225,'Mahitha','241202',1,0,'2022-03-03 13:02:54','2022-03-03 13:02:54'),(76497,225,'Mahmoodpur Saraiya','241407',1,0,'2022-03-03 13:02:54','2022-03-03 13:02:54'),(76498,225,'Maholiya Shivpar','241001',1,0,'2022-03-03 13:02:54','2022-03-03 13:02:54'),(76499,225,'Mahri','241122',1,0,'2022-03-03 13:02:54','2022-03-03 13:02:54'),(76500,225,'Maikpur','241123',1,0,'2022-03-03 13:02:54','2022-03-03 13:02:54'),(76501,225,'Majhigawan','241203',1,0,'2022-03-03 13:02:54','2022-03-03 13:02:54'),(76502,225,'Majhigawan','241304',1,0,'2022-03-03 13:02:54','2022-03-03 13:02:54'),(76503,225,'Majhigawan','241202',1,0,'2022-03-03 13:02:54','2022-03-03 13:02:54'),(76504,225,'Majhigawan Gadeora','241203',1,0,'2022-03-03 13:02:54','2022-03-03 13:02:54'),(76505,225,'Majhila','241125',1,0,'2022-03-03 13:02:54','2022-03-03 13:02:54'),(76506,225,'Majhiya','241406',1,0,'2022-03-03 13:02:54','2022-03-03 13:02:54'),(76507,225,'Malaiya','241204',1,0,'2022-03-03 13:02:54','2022-03-03 13:02:54'),(76508,225,'Malautha','241402',1,0,'2022-03-03 13:02:54','2022-03-03 13:02:54'),(76509,225,'Malehra','241204',1,0,'2022-03-03 13:02:54','2022-03-03 13:02:54'),(76510,225,'Malihamau','241001',1,0,'2022-03-03 13:02:54','2022-03-03 13:02:54'),(76511,225,'Mallawan','241303',1,0,'2022-03-03 13:02:55','2022-03-03 13:02:55'),(76512,225,'Mangolapur','241121',1,0,'2022-03-03 13:02:55','2022-03-03 13:02:55'),(76513,225,'Manikapur','241407',1,0,'2022-03-03 13:02:55','2022-03-03 13:02:55'),(76514,225,'Manpur','241125',1,0,'2022-03-03 13:02:55','2022-03-03 13:02:55'),(76515,225,'Mansoor Nagar','241405',1,0,'2022-03-03 13:02:55','2022-03-03 13:02:55'),(76516,225,'Mansoorpur','241403',1,0,'2022-03-03 13:02:55','2022-03-03 13:02:55'),(76517,225,'Masit','241122',1,0,'2022-03-03 13:02:55','2022-03-03 13:02:55'),(76518,225,'Matiyamau','241303',1,0,'2022-03-03 13:02:55','2022-03-03 13:02:55'),(76519,225,'Mawaiya','241125',1,0,'2022-03-03 13:02:55','2022-03-03 13:02:55'),(76520,225,'Meer Nagar Ajigawan','241204',1,0,'2022-03-03 13:02:55','2022-03-03 13:02:55'),(76521,225,'Meoni','241122',1,0,'2022-03-03 13:02:55','2022-03-03 13:02:55'),(76522,225,'Mohammadpur Belwaran','241203',1,0,'2022-03-03 13:02:55','2022-03-03 13:02:55'),(76523,225,'Munder','241123',1,0,'2022-03-03 13:02:55','2022-03-03 13:02:55'),(76524,225,'Munney Miyan Ka Chauraha','241001',1,0,'2022-03-03 13:02:55','2022-03-03 13:02:55'),(76525,225,'Nabi Purwa','241001',1,0,'2022-03-03 13:02:55','2022-03-03 13:02:55'),(76526,225,'Nagla Lothu','241124',1,0,'2022-03-03 13:02:55','2022-03-03 13:02:55'),(76527,225,'Nagwa','241304',1,0,'2022-03-03 13:02:55','2022-03-03 13:02:55'),(76528,225,'Nai Basti (Hardoi)','241001',1,0,'2022-03-03 13:02:55','2022-03-03 13:02:55'),(76529,225,'Naseoli Gopal','241401',1,0,'2022-03-03 13:02:55','2022-03-03 13:02:55'),(76530,225,'Naya Gaon Mubarakpur','241001',1,0,'2022-03-03 13:02:55','2022-03-03 13:02:55'),(76531,225,'Nayagaon','241305',1,0,'2022-03-03 13:02:55','2022-03-03 13:02:55'),(76532,225,'Neer','241001',1,0,'2022-03-03 13:02:55','2022-03-03 13:02:55'),(76533,225,'Noorpur  Hathaura','241301',1,0,'2022-03-03 13:02:55','2022-03-03 13:02:55'),(76534,225,'Odra','241001',1,0,'2022-03-03 13:02:56','2022-03-03 13:02:56'),(76535,225,'Odra Pachlai','241302',1,0,'2022-03-03 13:02:56','2022-03-03 13:02:56'),(76536,225,'Pachdeora','241123',1,0,'2022-03-03 13:02:56','2022-03-03 13:02:56'),(76537,225,'Pachkohara','241122',1,0,'2022-03-03 13:02:56','2022-03-03 13:02:56'),(76538,225,'Pahuntera','241302',1,0,'2022-03-03 13:02:56','2022-03-03 13:02:56'),(76539,225,'Pali (Hardoi)','241123',1,0,'2022-03-03 13:02:56','2022-03-03 13:02:56'),(76540,225,'Palia','241402',1,0,'2022-03-03 13:02:56','2022-03-03 13:02:56'),(76541,225,'Pandarawa Kot','241406',1,0,'2022-03-03 13:02:56','2022-03-03 13:02:56'),(76542,225,'Para','241406',1,0,'2022-03-03 13:02:56','2022-03-03 13:02:56'),(76543,225,'Parcha Rasoolpur','241302',1,0,'2022-03-03 13:02:56','2022-03-03 13:02:56'),(76544,225,'Pareli','241124',1,0,'2022-03-03 13:02:56','2022-03-03 13:02:56'),(76545,225,'Parsola','241301',1,0,'2022-03-03 13:02:56','2022-03-03 13:02:56'),(76546,225,'Pasner','241301',1,0,'2022-03-03 13:02:56','2022-03-03 13:02:56'),(76547,225,'Pawayan','241202',1,0,'2022-03-03 13:02:56','2022-03-03 13:02:56'),(76548,225,'Phulai','241303',1,0,'2022-03-03 13:02:56','2022-03-03 13:02:56'),(76549,225,'Pihani','241406',1,0,'2022-03-03 13:02:56','2022-03-03 13:02:56'),(76550,225,'Pila Mahuwa','241405',1,0,'2022-03-03 13:02:56','2022-03-03 13:02:56'),(76551,225,'Pithanapur Nagariya','241402',1,0,'2022-03-03 13:02:56','2022-03-03 13:02:56'),(76552,225,'Poora Bahadur','241001',1,0,'2022-03-03 13:02:56','2022-03-03 13:02:56'),(76553,225,'Purwawan','241303',1,0,'2022-03-03 13:02:56','2022-03-03 13:02:56'),(76554,225,'Rabha','241407',1,0,'2022-03-03 13:02:56','2022-03-03 13:02:56'),(76555,225,'Raghopur','241303',1,0,'2022-03-03 13:02:56','2022-03-03 13:02:56'),(76556,225,'Raingai','241407',1,0,'2022-03-03 13:02:56','2022-03-03 13:02:56'),(76557,225,'Rainso','241204',1,0,'2022-03-03 13:02:56','2022-03-03 13:02:56'),(76558,225,'Raipur','241304',1,0,'2022-03-03 13:02:57','2022-03-03 13:02:57'),(76559,225,'Rara','241001',1,0,'2022-03-03 13:02:57','2022-03-03 13:02:57'),(76560,225,'Rasoolpur','241407',1,0,'2022-03-03 13:02:57','2022-03-03 13:02:57'),(76561,225,'Saadat Nagar','241407',1,0,'2022-03-03 13:02:57','2022-03-03 13:02:57'),(76562,225,'Saank','241204',1,0,'2022-03-03 13:02:57','2022-03-03 13:02:57'),(76563,225,'Sadai Behta','241001',1,0,'2022-03-03 13:02:57','2022-03-03 13:02:57'),(76564,225,'Sadarpur','241302',1,0,'2022-03-03 13:02:57','2022-03-03 13:02:57'),(76565,225,'Sadila','241404',1,0,'2022-03-03 13:02:57','2022-03-03 13:02:57'),(76566,225,'Sahijana','241407',1,0,'2022-03-03 13:02:57','2022-03-03 13:02:57'),(76567,225,'Sahjanpur','241123',1,0,'2022-03-03 13:02:57','2022-03-03 13:02:57'),(76568,225,'Sahpur Nau','241401',1,0,'2022-03-03 13:02:57','2022-03-03 13:02:57'),(76569,225,'Saitiyapur','241001',1,0,'2022-03-03 13:02:57','2022-03-03 13:02:57'),(76570,225,'Sakaha','241125',1,0,'2022-03-03 13:02:57','2022-03-03 13:02:57'),(76571,225,'Sakara','241001',1,0,'2022-03-03 13:02:57','2022-03-03 13:02:57'),(76572,225,'Sakatpur','241001',1,0,'2022-03-03 13:02:57','2022-03-03 13:02:57'),(76573,225,'Samspur','241126',1,0,'2022-03-03 13:02:57','2022-03-03 13:02:57'),(76574,225,'Sandi','241403',1,0,'2022-03-03 13:02:57','2022-03-03 13:02:57'),(76575,225,'Sandila I. Estate','241127',1,0,'2022-03-03 13:02:57','2022-03-03 13:02:57'),(76576,225,'Sandila','241204',1,0,'2022-03-03 13:02:57','2022-03-03 13:02:57'),(76577,225,'Sandila Town','241204',1,0,'2022-03-03 13:02:57','2022-03-03 13:02:57'),(76578,225,'Sarai Raghav','241123',1,0,'2022-03-03 13:02:57','2022-03-03 13:02:57'),(76579,225,'Sarhiapur','241403',1,0,'2022-03-03 13:02:57','2022-03-03 13:02:57'),(76580,225,'Sarsawan','241124',1,0,'2022-03-03 13:02:57','2022-03-03 13:02:57'),(76581,225,'Sarva','241203',1,0,'2022-03-03 13:02:57','2022-03-03 13:02:57'),(76582,225,'Sarve','241204',1,0,'2022-03-03 13:02:57','2022-03-03 13:02:57'),(76583,225,'Satautha','241402',1,0,'2022-03-03 13:02:58','2022-03-03 13:02:58'),(76584,225,'Sathara','241001',1,0,'2022-03-03 13:02:58','2022-03-03 13:02:58'),(76585,225,'Sautera','241302',1,0,'2022-03-03 13:02:58','2022-03-03 13:02:58'),(76586,225,'Sawaijpur','241123',1,0,'2022-03-03 13:02:58','2022-03-03 13:02:58'),(76587,225,'Selapur','241302',1,0,'2022-03-03 13:02:58','2022-03-03 13:02:58'),(76588,225,'Semaria','241402',1,0,'2022-03-03 13:02:58','2022-03-03 13:02:58'),(76589,225,'Shahabad B.S.','241124',1,0,'2022-03-03 13:02:58','2022-03-03 13:02:58'),(76590,225,'Shahabad (Hardoi)','241124',1,0,'2022-03-03 13:02:58','2022-03-03 13:02:58'),(76591,225,'Shahbda','241302',1,0,'2022-03-03 13:02:58','2022-03-03 13:02:58'),(76592,225,'Shahpur Basudeo','241302',1,0,'2022-03-03 13:02:58','2022-03-03 13:02:58'),(76593,225,'Shahpur Ganga','241303',1,0,'2022-03-03 13:02:58','2022-03-03 13:02:58'),(76594,225,'Shahpur Pawar','241303',1,0,'2022-03-03 13:02:58','2022-03-03 13:02:58'),(76595,225,'Sharma Fatehpur','241125',1,0,'2022-03-03 13:02:58','2022-03-03 13:02:58'),(76596,225,'Shuklapur Bhagat','241302',1,0,'2022-03-03 13:02:58','2022-03-03 13:02:58'),(76597,225,'Sikandarpu Narkatara','241124',1,0,'2022-03-03 13:02:58','2022-03-03 13:02:58'),(76598,225,'Sikarohari','241001',1,0,'2022-03-03 13:02:58','2022-03-03 13:02:58'),(76599,225,'Sikrori','241203',1,0,'2022-03-03 13:02:58','2022-03-03 13:02:58'),(76600,225,'Simariya','241401',1,0,'2022-03-03 13:02:58','2022-03-03 13:02:58'),(76601,225,'Singulapur','241124',1,0,'2022-03-03 13:02:58','2022-03-03 13:02:58'),(76602,225,'Siroman Nagar','241124',1,0,'2022-03-03 13:02:58','2022-03-03 13:02:58'),(76603,225,'Sirsa','241406',1,0,'2022-03-03 13:02:58','2022-03-03 13:02:58');
INSERT INTO `cities` VALUES (76604,225,'Srimau','241403',1,0,'2022-03-03 13:02:59','2022-03-03 13:02:59'),(76605,225,'Subhan Khera','241305',1,0,'2022-03-03 13:02:59','2022-03-03 13:02:59'),(76606,225,'Sugwan','241301',1,0,'2022-03-03 13:02:59','2022-03-03 13:02:59'),(76607,225,'Sursa','241001',1,0,'2022-03-03 13:02:59','2022-03-03 13:02:59'),(76608,225,'Tadiyawan','241404',1,0,'2022-03-03 13:02:59','2022-03-03 13:02:59'),(76609,225,'Tatyora','241001',1,0,'2022-03-03 13:02:59','2022-03-03 13:02:59'),(76610,225,'Teni','241404',1,0,'2022-03-03 13:02:59','2022-03-03 13:02:59'),(76611,225,'Teriya','241204',1,0,'2022-03-03 13:02:59','2022-03-03 13:02:59'),(76612,225,'Terwa Dahigawan','241305',1,0,'2022-03-03 13:02:59','2022-03-03 13:02:59'),(76613,225,'Thamarawa','241404',1,0,'2022-03-03 13:02:59','2022-03-03 13:02:59'),(76614,225,'Thok Bandho','241121',1,0,'2022-03-03 13:02:59','2022-03-03 13:02:59'),(76615,225,'Tikar','241402',1,0,'2022-03-03 13:02:59','2022-03-03 13:02:59'),(76616,225,'Tikari','241304',1,0,'2022-03-03 13:02:59','2022-03-03 13:02:59'),(76617,225,'Tikra Khurd','241203',1,0,'2022-03-03 13:02:59','2022-03-03 13:02:59'),(76618,225,'Todarpur Gaon','241125',1,0,'2022-03-03 13:02:59','2022-03-03 13:02:59'),(76619,225,'Todarpur R S','241125',1,0,'2022-03-03 13:02:59','2022-03-03 13:02:59'),(76620,225,'Tolwa Aat Danpur','241125',1,0,'2022-03-03 13:02:59','2022-03-03 13:02:59'),(76621,225,'Tumurkee','241124',1,0,'2022-03-03 13:02:59','2022-03-03 13:02:59'),(76622,225,'Tundwal','241301',1,0,'2022-03-03 13:02:59','2022-03-03 13:02:59'),(76623,225,'Turtipur','241001',1,0,'2022-03-03 13:02:59','2022-03-03 13:02:59'),(76624,225,'Uchawal','241405',1,0,'2022-03-03 13:02:59','2022-03-03 13:02:59'),(76625,225,'Udharanpur','241124',1,0,'2022-03-03 13:02:59','2022-03-03 13:02:59'),(76626,225,'Ugpur','241304',1,0,'2022-03-03 13:02:59','2022-03-03 13:02:59'),(76627,225,'Umrari','241304',1,0,'2022-03-03 13:02:59','2022-03-03 13:02:59'),(76628,225,'Umrauli','241125',1,0,'2022-03-03 13:03:00','2022-03-03 13:03:00'),(76629,225,'Uncha Gaon','241402',1,0,'2022-03-03 13:03:00','2022-03-03 13:03:00'),(76630,225,'Uncha Thok','241001',1,0,'2022-03-03 13:03:00','2022-03-03 13:03:00'),(76631,225,'Vanshi Nagar','241001',1,0,'2022-03-03 13:03:00','2022-03-03 13:03:00'),(76632,225,'Victoriyaganj','241122',1,0,'2022-03-03 13:03:00','2022-03-03 13:03:00'),(76633,225,'White Ganj','241001',1,0,'2022-03-03 13:03:00','2022-03-03 13:03:00'),(76634,226,'Ahabaranpur','204101',1,0,'2022-03-03 13:03:00','2022-03-03 13:03:00'),(76635,226,'Ahen','204101',1,0,'2022-03-03 13:03:00','2022-03-03 13:03:00'),(76636,226,'Akhaipur','204102',1,0,'2022-03-03 13:03:00','2022-03-03 13:03:00'),(76637,226,'Allehpur','204101',1,0,'2022-03-03 13:03:00','2022-03-03 13:03:00'),(76638,226,'Arjunpur','204101',1,0,'2022-03-03 13:03:00','2022-03-03 13:03:00'),(76639,226,'Arnot','204215',1,0,'2022-03-03 13:03:00','2022-03-03 13:03:00'),(76640,226,'Baghraya','204102',1,0,'2022-03-03 13:03:00','2022-03-03 13:03:00'),(76641,226,'Band Abdulhamipur','204212',1,0,'2022-03-03 13:03:00','2022-03-03 13:03:00'),(76642,226,'Bapandai','204212',1,0,'2022-03-03 13:03:00','2022-03-03 13:03:00'),(76643,226,'Barai Shahpur','204215',1,0,'2022-03-03 13:03:00','2022-03-03 13:03:00'),(76644,226,'Bardwari','204213',1,0,'2022-03-03 13:03:00','2022-03-03 13:03:00'),(76645,226,'Barsauli','204214',1,0,'2022-03-03 13:03:00','2022-03-03 13:03:00'),(76646,226,'Basai Babas','204215',1,0,'2022-03-03 13:03:00','2022-03-03 13:03:00'),(76647,226,'Basgoi','204214',1,0,'2022-03-03 13:03:00','2022-03-03 13:03:00'),(76648,226,'Basgoi','204216',1,0,'2022-03-03 13:03:00','2022-03-03 13:03:00'),(76649,226,'Bastoi','204215',1,0,'2022-03-03 13:03:00','2022-03-03 13:03:00'),(76650,226,'Bazidpur','204215',1,0,'2022-03-03 13:03:00','2022-03-03 13:03:00'),(76651,226,'Bhatikara','204211',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76652,226,'Bhenkuri','204214',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76653,226,'Bhuraka','204214',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76654,226,'Bisana','204101',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76655,226,'Bonai','204212',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76656,226,'Bwarwana','204212',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76657,226,'Chhonda','204216',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76658,226,'Dandesari','204211',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76659,226,'Dariyapur','204102',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76660,226,'Dedamai','202002',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76661,226,'Dhatroi','204102',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76662,226,'Dwarikapur','204216',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76663,226,'G C Sasni','204216',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76664,226,'Gadola','204212',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76665,226,'Gangapur','204212',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76666,226,'Gangcholi','204101',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76667,226,'Ganthri Shahpur','204211',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76668,226,'Garhi Balna','204101',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76669,226,'Garhi Hirasingh','204211',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76670,226,'Ginoli Kishanpur','204215',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76671,226,'Guarau Kalan','204212',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76672,226,'Gudmai Misripur','204215',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76673,226,'Hasayan','204212',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76674,226,'Hathras City','204101',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76675,226,'Hathras Jn RS','204102',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76676,226,'Hathras','204101',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76677,226,'Hatisa Bhagwantpur','204101',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76678,226,'I A Hathras','204101',1,0,'2022-03-03 13:03:01','2022-03-03 13:03:01'),(76679,226,'Jansoi','204214',1,0,'2022-03-03 13:03:02','2022-03-03 13:03:02'),(76680,226,'Jatoi','204213',1,0,'2022-03-03 13:03:02','2022-03-03 13:03:02'),(76681,226,'Jawar','204213',1,0,'2022-03-03 13:03:02','2022-03-03 13:03:02'),(76682,226,'Jiroli','204216',1,0,'2022-03-03 13:03:02','2022-03-03 13:03:02'),(76683,226,'Jiroli Kalan','204215',1,0,'2022-03-03 13:03:02','2022-03-03 13:03:02'),(76684,226,'Jogia','204101',1,0,'2022-03-03 13:03:02','2022-03-03 13:03:02'),(76685,226,'K G W Sasni','202139',1,0,'2022-03-03 13:03:02','2022-03-03 13:03:02'),(76686,226,'Kachaura','204211',1,0,'2022-03-03 13:03:02','2022-03-03 13:03:02'),(76687,226,'Kailora','204102',1,0,'2022-03-03 13:03:02','2022-03-03 13:03:02'),(76688,226,'Kanau','204212',1,0,'2022-03-03 13:03:02','2022-03-03 13:03:02'),(76689,226,'Kanya Gurukul','204216',1,0,'2022-03-03 13:03:02','2022-03-03 13:03:02'),(76690,226,'Kapasiya','204215',1,0,'2022-03-03 13:03:02','2022-03-03 13:03:02'),(76691,226,'Karas','204101',1,0,'2022-03-03 13:03:02','2022-03-03 13:03:02'),(76692,226,'Koka','204101',1,0,'2022-03-03 13:03:02','2022-03-03 13:03:02'),(76693,226,'Kota','204213',1,0,'2022-03-03 13:03:02','2022-03-03 13:03:02'),(76694,226,'Kunwarpur','204101',1,0,'2022-03-03 13:03:02','2022-03-03 13:03:02'),(76695,226,'L C Hathras','204101',1,0,'2022-03-03 13:03:02','2022-03-03 13:03:02'),(76696,226,'Ladpur','204101',1,0,'2022-03-03 13:03:02','2022-03-03 13:03:02'),(76697,226,'Lakhnu','204101',1,0,'2022-03-03 13:03:02','2022-03-03 13:03:02'),(76698,226,'Luheta Khurd','204101',1,0,'2022-03-03 13:03:02','2022-03-03 13:03:02'),(76699,226,'M M Hathras','204101',1,0,'2022-03-03 13:03:02','2022-03-03 13:03:02'),(76700,226,'Maho','204212',1,0,'2022-03-03 13:03:02','2022-03-03 13:03:02'),(76701,226,'Mau Chirayal','204215',1,0,'2022-03-03 13:03:03','2022-03-03 13:03:03'),(76702,226,'Meetai','204101',1,0,'2022-03-03 13:03:03','2022-03-03 13:03:03'),(76703,226,'Mendamai','204214',1,0,'2022-03-03 13:03:03','2022-03-03 13:03:03'),(76704,226,'Mendu','202121',1,0,'2022-03-03 13:03:03','2022-03-03 13:03:03'),(76705,226,'Mohariya','204216',1,0,'2022-03-03 13:03:03','2022-03-03 13:03:03'),(76706,226,'Mursan','204213',1,0,'2022-03-03 13:03:03','2022-03-03 13:03:03'),(76707,226,'Nagaria Patti','204214',1,0,'2022-03-03 13:03:03','2022-03-03 13:03:03'),(76708,226,'Nagla Danda','204212',1,0,'2022-03-03 13:03:03','2022-03-03 13:03:03'),(76709,226,'Nagla Veer Sahai','204214',1,0,'2022-03-03 13:03:03','2022-03-03 13:03:03'),(76710,226,'Naj Mandi S Rao','204215',1,0,'2022-03-03 13:03:03','2022-03-03 13:03:03'),(76711,226,'Nayaganj Hathras','204101',1,0,'2022-03-03 13:03:03','2022-03-03 13:03:03'),(76712,226,'Northa Isepur','204211',1,0,'2022-03-03 13:03:03','2022-03-03 13:03:03'),(76713,226,'Pachaun','204211',1,0,'2022-03-03 13:03:03','2022-03-03 13:03:03'),(76714,226,'Parhil','204216',1,0,'2022-03-03 13:03:03','2022-03-03 13:03:03'),(76715,226,'Parsara','204101',1,0,'2022-03-03 13:03:03','2022-03-03 13:03:03'),(76716,226,'Pata Khas','204213',1,0,'2022-03-03 13:03:03','2022-03-03 13:03:03'),(76717,226,'Pateni','204213',1,0,'2022-03-03 13:03:03','2022-03-03 13:03:03'),(76718,226,'Penth Gaon','204213',1,0,'2022-03-03 13:03:03','2022-03-03 13:03:03'),(76719,226,'Pipalgaon','204211',1,0,'2022-03-03 13:03:03','2022-03-03 13:03:03'),(76720,226,'Pora','204214',1,0,'2022-03-03 13:03:03','2022-03-03 13:03:03'),(76721,226,'Punner','204102',1,0,'2022-03-03 13:03:03','2022-03-03 13:03:03'),(76722,226,'Purdilpur','204214',1,0,'2022-03-03 13:03:03','2022-03-03 13:03:03'),(76723,226,'Ratanpur Hussainpur','204215',1,0,'2022-03-03 13:03:04','2022-03-03 13:03:04'),(76724,226,'Rati Ka Nagla','204212',1,0,'2022-03-03 13:03:04','2022-03-03 13:03:04'),(76725,226,'Rudayan','204216',1,0,'2022-03-03 13:03:04','2022-03-03 13:03:04'),(76726,226,'Ruheri','204101',1,0,'2022-03-03 13:03:04','2022-03-03 13:03:04'),(76727,226,'Salempur','204102',1,0,'2022-03-03 13:03:04','2022-03-03 13:03:04'),(76728,226,'Sasni','204216',1,0,'2022-03-03 13:03:04','2022-03-03 13:03:04'),(76729,226,'Shankerpur','204212',1,0,'2022-03-03 13:03:04','2022-03-03 13:03:04'),(76730,226,'Sikandra Rao','204215',1,0,'2022-03-03 13:03:04','2022-03-03 13:03:04'),(76731,226,'Siktara','204212',1,0,'2022-03-03 13:03:04','2022-03-03 13:03:04'),(76732,226,'Sokhana','204101',1,0,'2022-03-03 13:03:04','2022-03-03 13:03:04'),(76733,226,'Srinagar','204212',1,0,'2022-03-03 13:03:04','2022-03-03 13:03:04'),(76734,226,'Sujawalpur','204211',1,0,'2022-03-03 13:03:04','2022-03-03 13:03:04'),(76735,226,'Susayat Kalan','204216',1,0,'2022-03-03 13:03:04','2022-03-03 13:03:04'),(76736,226,'Tati Dadia','204215',1,0,'2022-03-03 13:03:04','2022-03-03 13:03:04'),(76737,226,'Tehra','204101',1,0,'2022-03-03 13:03:04','2022-03-03 13:03:04'),(76738,226,'Thulai','204102',1,0,'2022-03-03 13:03:04','2022-03-03 13:03:04'),(76739,226,'Tikari Kalan','204211',1,0,'2022-03-03 13:03:04','2022-03-03 13:03:04'),(76740,226,'Tilothi','204216',1,0,'2022-03-03 13:03:04','2022-03-03 13:03:04'),(76741,226,'Tochhigarh','204101',1,0,'2022-03-03 13:03:04','2022-03-03 13:03:04'),(76742,226,'Tuksan','204101',1,0,'2022-03-03 13:03:04','2022-03-03 13:03:04'),(76743,226,'Veernagar','204101',1,0,'2022-03-03 13:03:04','2022-03-03 13:03:04'),(76744,226,'Arti','281307',1,0,'2022-03-03 13:03:04','2022-03-03 13:03:04'),(76745,226,'Basamaroo','281306',1,0,'2022-03-03 13:03:04','2022-03-03 13:03:04'),(76746,226,'Bedai','281306',1,0,'2022-03-03 13:03:04','2022-03-03 13:03:04'),(76747,226,'Dhadau','281307',1,0,'2022-03-03 13:03:04','2022-03-03 13:03:04'),(76748,226,'Edalpur','281306',1,0,'2022-03-03 13:03:05','2022-03-03 13:03:05'),(76749,226,'Gutehara','281307',1,0,'2022-03-03 13:03:05','2022-03-03 13:03:05'),(76750,226,'Hasanpurbaru','281307',1,0,'2022-03-03 13:03:05','2022-03-03 13:03:05'),(76751,226,'Jalesar R.S.','281104',1,0,'2022-03-03 13:03:05','2022-03-03 13:03:05'),(76752,226,'Jarau','281306',1,0,'2022-03-03 13:03:05','2022-03-03 13:03:05'),(76753,226,'Jugasana','281308',1,0,'2022-03-03 13:03:05','2022-03-03 13:03:05'),(76754,226,'Karkauli','281306',1,0,'2022-03-03 13:03:05','2022-03-03 13:03:05'),(76755,226,'Karsaura','281308',1,0,'2022-03-03 13:03:05','2022-03-03 13:03:05'),(76756,226,'Khajauthi','281306',1,0,'2022-03-03 13:03:05','2022-03-03 13:03:05'),(76757,226,'Khonda','281307',1,0,'2022-03-03 13:03:05','2022-03-03 13:03:05'),(76758,226,'Kursanda','281001',1,0,'2022-03-03 13:03:05','2022-03-03 13:03:05'),(76759,226,'Madakabhoj','281307',1,0,'2022-03-03 13:03:05','2022-03-03 13:03:05'),(76760,226,'Mahrara','281104',1,0,'2022-03-03 13:03:05','2022-03-03 13:03:05'),(76761,226,'Naglaberu','281307',1,0,'2022-03-03 13:03:05','2022-03-03 13:03:05'),(76762,226,'Nasirpur','281308',1,0,'2022-03-03 13:03:05','2022-03-03 13:03:05'),(76763,226,'Naugaon','281306',1,0,'2022-03-03 13:03:05','2022-03-03 13:03:05'),(76764,226,'Rasgaon','281104',1,0,'2022-03-03 13:03:05','2022-03-03 13:03:05'),(76765,226,'Sadabad','281306',1,0,'2022-03-03 13:03:05','2022-03-03 13:03:05'),(76766,226,'Sahpau','281307',1,0,'2022-03-03 13:03:05','2022-03-03 13:03:05'),(76767,226,'Salempur','281306',1,0,'2022-03-03 13:03:05','2022-03-03 13:03:05'),(76768,226,'Samadpur','281306',1,0,'2022-03-03 13:03:05','2022-03-03 13:03:05'),(76769,226,'Sikhra','281307',1,0,'2022-03-03 13:03:05','2022-03-03 13:03:05'),(76770,226,'Unchagaon','281104',1,0,'2022-03-03 13:03:05','2022-03-03 13:03:05'),(76771,227,'Abhedepur','285130',1,0,'2022-03-03 13:03:05','2022-03-03 13:03:05'),(76772,227,'Aeir','285001',1,0,'2022-03-03 13:03:05','2022-03-03 13:03:05'),(76773,227,'Aindha','285223',1,0,'2022-03-03 13:03:06','2022-03-03 13:03:06'),(76774,227,'Ait','285201',1,0,'2022-03-03 13:03:06','2022-03-03 13:03:06'),(76775,227,'Ajeetapur','285129',1,0,'2022-03-03 13:03:06','2022-03-03 13:03:06'),(76776,227,'Aknewa','285205',1,0,'2022-03-03 13:03:06','2022-03-03 13:03:06'),(76777,227,'Akorhi','285201',1,0,'2022-03-03 13:03:06','2022-03-03 13:03:06'),(76778,227,'Akorhi Dubey','285123',1,0,'2022-03-03 13:03:06','2022-03-03 13:03:06'),(76779,227,'Alipur','285203',1,0,'2022-03-03 13:03:06','2022-03-03 13:03:06'),(76780,227,'Amkhera','285123',1,0,'2022-03-03 13:03:06','2022-03-03 13:03:06'),(76781,227,'Anda','285205',1,0,'2022-03-03 13:03:06','2022-03-03 13:03:06'),(76782,227,'Ata','285202',1,0,'2022-03-03 13:03:06','2022-03-03 13:03:06'),(76783,227,'Atagaon','285121',1,0,'2022-03-03 13:03:06','2022-03-03 13:03:06'),(76784,227,'Atarehati','285121',1,0,'2022-03-03 13:03:06','2022-03-03 13:03:06'),(76785,227,'Atariya','285123',1,0,'2022-03-03 13:03:06','2022-03-03 13:03:06'),(76786,227,'Atra Kalan','285123',1,0,'2022-03-03 13:03:06','2022-03-03 13:03:06'),(76787,227,'Aurekhi','285123',1,0,'2022-03-03 13:03:06','2022-03-03 13:03:06'),(76788,227,'Babai','285123',1,0,'2022-03-03 13:03:06','2022-03-03 13:03:06'),(76789,227,'Babina','285203',1,0,'2022-03-03 13:03:06','2022-03-03 13:03:06'),(76790,227,'Bagi','285203',1,0,'2022-03-03 13:03:06','2022-03-03 13:03:06'),(76791,227,'Bahadurpur','285124',1,0,'2022-03-03 13:03:06','2022-03-03 13:03:06'),(76792,227,'Bairai','285204',1,0,'2022-03-03 13:03:06','2022-03-03 13:03:06'),(76793,227,'Bandhauli','285122',1,0,'2022-03-03 13:03:06','2022-03-03 13:03:06'),(76794,227,'Bangra','285121',1,0,'2022-03-03 13:03:06','2022-03-03 13:03:06'),(76795,227,'Baoni Estate','285203',1,0,'2022-03-03 13:03:06','2022-03-03 13:03:06'),(76796,227,'Baragaon','285001',1,0,'2022-03-03 13:03:07','2022-03-03 13:03:07'),(76797,227,'Barkhera','285203',1,0,'2022-03-03 13:03:07','2022-03-03 13:03:07'),(76798,227,'Baroda Kalan','285205',1,0,'2022-03-03 13:03:07','2022-03-03 13:03:07'),(76799,227,'Barsar','285223',1,0,'2022-03-03 13:03:07','2022-03-03 13:03:07'),(76800,227,'Baseeth','285206',1,0,'2022-03-03 13:03:07','2022-03-03 13:03:07'),(76801,227,'Basob','285201',1,0,'2022-03-03 13:03:07','2022-03-03 13:03:07'),(76802,227,'Beerpura','285001',1,0,'2022-03-03 13:03:07','2022-03-03 13:03:07'),(76803,227,'Beri','285203',1,0,'2022-03-03 13:03:07','2022-03-03 13:03:07'),(76804,227,'Bhadari','285205',1,0,'2022-03-03 13:03:07','2022-03-03 13:03:07'),(76805,227,'Bhadeikh','285125',1,0,'2022-03-03 13:03:07','2022-03-03 13:03:07'),(76806,227,'Bhadreikhi','285202',1,0,'2022-03-03 13:03:07','2022-03-03 13:03:07'),(76807,227,'Bhaoupura','285128',1,0,'2022-03-03 13:03:07','2022-03-03 13:03:07'),(76808,227,'Bharsoonda','285201',1,0,'2022-03-03 13:03:07','2022-03-03 13:03:07'),(76809,227,'Bhend','285205',1,0,'2022-03-03 13:03:07','2022-03-03 13:03:07'),(76810,227,'Bhendi','285203',1,0,'2022-03-03 13:03:07','2022-03-03 13:03:07'),(76811,227,'Bichauli','285130',1,0,'2022-03-03 13:03:07','2022-03-03 13:03:07'),(76812,227,'Bilayan','285201',1,0,'2022-03-03 13:03:07','2022-03-03 13:03:07'),(76813,227,'Bilond','285124',1,0,'2022-03-03 13:03:07','2022-03-03 13:03:07'),(76814,227,'Binaura','285223',1,0,'2022-03-03 13:03:07','2022-03-03 13:03:07'),(76815,227,'Binaura','285123',1,0,'2022-03-03 13:03:07','2022-03-03 13:03:07'),(76816,227,'Birasni','285201',1,0,'2022-03-03 13:03:07','2022-03-03 13:03:07'),(76817,227,'Birguwan Buzurg','285201',1,0,'2022-03-03 13:03:07','2022-03-03 13:03:07'),(76818,227,'Birguwan Khurd','285201',1,0,'2022-03-03 13:03:07','2022-03-03 13:03:07'),(76819,227,'Chaki','285123',1,0,'2022-03-03 13:03:07','2022-03-03 13:03:07'),(76820,227,'Chamari','285202',1,0,'2022-03-03 13:03:08','2022-03-03 13:03:08'),(76821,227,'Chamend','285205',1,0,'2022-03-03 13:03:08','2022-03-03 13:03:08'),(76822,227,'Chandurra','285201',1,0,'2022-03-03 13:03:08','2022-03-03 13:03:08'),(76823,227,'Chatela','285203',1,0,'2022-03-03 13:03:08','2022-03-03 13:03:08'),(76824,227,'Chhani','285205',1,0,'2022-03-03 13:03:08','2022-03-03 13:03:08'),(76825,227,'Chhiriya Salempur','285123',1,0,'2022-03-03 13:03:08','2022-03-03 13:03:08'),(76826,227,'Chhonk','285202',1,0,'2022-03-03 13:03:08','2022-03-03 13:03:08'),(76827,227,'Chilli','285001',1,0,'2022-03-03 13:03:08','2022-03-03 13:03:08'),(76828,227,'Chitaura','285126',1,0,'2022-03-03 13:03:08','2022-03-03 13:03:08'),(76829,227,'Churkhi','285001',1,0,'2022-03-03 13:03:08','2022-03-03 13:03:08'),(76830,227,'Dakore','285122',1,0,'2022-03-03 13:03:08','2022-03-03 13:03:08'),(76831,227,'Damras','285130',1,0,'2022-03-03 13:03:08','2022-03-03 13:03:08'),(76832,227,'Daulatpur','285125',1,0,'2022-03-03 13:03:08','2022-03-03 13:03:08'),(76833,227,'Deogaon','285205',1,0,'2022-03-03 13:03:08','2022-03-03 13:03:08'),(76834,227,'Dhagwan Kalan','285201',1,0,'2022-03-03 13:03:08','2022-03-03 13:03:08'),(76835,227,'Dhamna','285126',1,0,'2022-03-03 13:03:08','2022-03-03 13:03:08'),(76836,227,'Dhanaura','285001',1,0,'2022-03-03 13:03:08','2022-03-03 13:03:08'),(76837,227,'Dhantauli','285001',1,0,'2022-03-03 13:03:08','2022-03-03 13:03:08'),(76838,227,'Dhoota','285124',1,0,'2022-03-03 13:03:08','2022-03-03 13:03:08'),(76839,227,'Dhurat','285201',1,0,'2022-03-03 13:03:08','2022-03-03 13:03:08'),(76840,227,'Diraoti','285205',1,0,'2022-03-03 13:03:08','2022-03-03 13:03:08'),(76841,227,'Dvc Road Orai','285001',1,0,'2022-03-03 13:03:08','2022-03-03 13:03:08'),(76842,227,'Eekon','285130',1,0,'2022-03-03 13:03:08','2022-03-03 13:03:08'),(76843,227,'Eeton','285129',1,0,'2022-03-03 13:03:08','2022-03-03 13:03:08'),(76844,227,'Gadhela','285123',1,0,'2022-03-03 13:03:08','2022-03-03 13:03:08'),(76845,227,'Gaindoli','285206',1,0,'2022-03-03 13:03:08','2022-03-03 13:03:08'),(76846,227,'Garhar','285001',1,0,'2022-03-03 13:03:09','2022-03-03 13:03:09'),(76847,227,'Garherna','285121',1,0,'2022-03-03 13:03:09','2022-03-03 13:03:09'),(76848,227,'Garhgawan','285123',1,0,'2022-03-03 13:03:09','2022-03-03 13:03:09'),(76849,227,'Garrehi','285203',1,0,'2022-03-03 13:03:09','2022-03-03 13:03:09'),(76850,227,'Ghillaur','285206',1,0,'2022-03-03 13:03:09','2022-03-03 13:03:09'),(76851,227,'Gohan','285001',1,0,'2022-03-03 13:03:09','2022-03-03 13:03:09'),(76852,227,'Gopalpura','285121',1,0,'2022-03-03 13:03:09','2022-03-03 13:03:09'),(76853,227,'Gora Bhoopka','285128',1,0,'2022-03-03 13:03:09','2022-03-03 13:03:09'),(76854,227,'Gora Rathor','285125',1,0,'2022-03-03 13:03:09','2022-03-03 13:03:09'),(76855,227,'Gulaoli','285204',1,0,'2022-03-03 13:03:09','2022-03-03 13:03:09'),(76856,227,'Guraoti','285205',1,0,'2022-03-03 13:03:09','2022-03-03 13:03:09'),(76857,227,'Gurha','285122',1,0,'2022-03-03 13:03:09','2022-03-03 13:03:09'),(76858,227,'Hadrukh','285128',1,0,'2022-03-03 13:03:09','2022-03-03 13:03:09'),(76859,227,'Harauli','285126',1,0,'2022-03-03 13:03:09','2022-03-03 13:03:09'),(76860,227,'Harchandpur','285203',1,0,'2022-03-03 13:03:09','2022-03-03 13:03:09'),(76861,227,'Hardoi Guzar','285001',1,0,'2022-03-03 13:03:09','2022-03-03 13:03:09'),(76862,227,'Hatheri','285123',1,0,'2022-03-03 13:03:09','2022-03-03 13:03:09'),(76863,227,'Imiliya','285001',1,0,'2022-03-03 13:03:09','2022-03-03 13:03:09'),(76864,227,'Imiliya Buzurg','285202',1,0,'2022-03-03 13:03:09','2022-03-03 13:03:09'),(76865,227,'Ingui','285121',1,0,'2022-03-03 13:03:09','2022-03-03 13:03:09'),(76866,227,'Itahiya','285123',1,0,'2022-03-03 13:03:09','2022-03-03 13:03:09'),(76867,227,'Itaura','285001',1,0,'2022-03-03 13:03:09','2022-03-03 13:03:09'),(76868,227,'Jagammanpur','285124',1,0,'2022-03-03 13:03:10','2022-03-03 13:03:10'),(76869,227,'Jaganpura','285205',1,0,'2022-03-03 13:03:10','2022-03-03 13:03:10'),(76870,227,'Jagnewa','285123',1,0,'2022-03-03 13:03:10','2022-03-03 13:03:10'),(76871,227,'Jaigha','285124',1,0,'2022-03-03 13:03:10','2022-03-03 13:03:10'),(76872,227,'Jaisari Kalan','285122',1,0,'2022-03-03 13:03:10','2022-03-03 13:03:10'),(76873,227,'Jaitpura','285205',1,0,'2022-03-03 13:03:10','2022-03-03 13:03:10'),(76874,227,'Jakha','285130',1,0,'2022-03-03 13:03:10','2022-03-03 13:03:10'),(76875,227,'Jakhauli','285201',1,0,'2022-03-03 13:03:10','2022-03-03 13:03:10'),(76876,227,'Jalaun','285123',1,0,'2022-03-03 13:03:10','2022-03-03 13:03:10'),(76877,227,'Jalaun Town','285123',1,0,'2022-03-03 13:03:10','2022-03-03 13:03:10'),(76878,227,'Jamrohi Khurd','285201',1,0,'2022-03-03 13:03:10','2022-03-03 13:03:10'),(76879,227,'Jugrajpura','285121',1,0,'2022-03-03 13:03:10','2022-03-03 13:03:10'),(76880,227,'Kailiya','285001',1,0,'2022-03-03 13:03:10','2022-03-03 13:03:10'),(76881,227,'Kailor','285126',1,0,'2022-03-03 13:03:10','2022-03-03 13:03:10'),(76882,227,'Kainth','285205',1,0,'2022-03-03 13:03:10','2022-03-03 13:03:10'),(76883,227,'Kakrau','285203',1,0,'2022-03-03 13:03:10','2022-03-03 13:03:10'),(76884,227,'Kalpi R.S.','285204',1,0,'2022-03-03 13:03:10','2022-03-03 13:03:10'),(76885,227,'Kalpi','285204',1,0,'2022-03-03 13:03:10','2022-03-03 13:03:10'),(76886,227,'Kanasi','285205',1,0,'2022-03-03 13:03:10','2022-03-03 13:03:10'),(76887,227,'Karamchandpur','285202',1,0,'2022-03-03 13:03:10','2022-03-03 13:03:10'),(76888,227,'Karmer','285001',1,0,'2022-03-03 13:03:10','2022-03-03 13:03:10'),(76889,227,'Kartalapur','285128',1,0,'2022-03-03 13:03:10','2022-03-03 13:03:10'),(76890,227,'Kashirampur','285204',1,0,'2022-03-03 13:03:10','2022-03-03 13:03:10'),(76891,227,'Keolari','285123',1,0,'2022-03-03 13:03:10','2022-03-03 13:03:10'),(76892,227,'Khairi','285205',1,0,'2022-03-03 13:03:10','2022-03-03 13:03:10'),(76893,227,'Khaksis','285123',1,0,'2022-03-03 13:03:10','2022-03-03 13:03:10'),(76894,227,'Khanua','285205',1,0,'2022-03-03 13:03:11','2022-03-03 13:03:11'),(76895,227,'Kharka','285001',1,0,'2022-03-03 13:03:11','2022-03-03 13:03:11'),(76896,227,'Kharoosa','285001',1,0,'2022-03-03 13:03:11','2022-03-03 13:03:11'),(76897,227,'Kharra','285001',1,0,'2022-03-03 13:03:11','2022-03-03 13:03:11'),(76898,227,'Khutaila','285205',1,0,'2022-03-03 13:03:11','2022-03-03 13:03:11'),(76899,227,'Kishunpura','285205',1,0,'2022-03-03 13:03:11','2022-03-03 13:03:11'),(76900,227,'Konch Bazariya','285205',1,0,'2022-03-03 13:03:11','2022-03-03 13:03:11'),(76901,227,'Konch (Jalaun)','285205',1,0,'2022-03-03 13:03:11','2022-03-03 13:03:11'),(76902,227,'Kotra (Jalaun)','285223',1,0,'2022-03-03 13:03:11','2022-03-03 13:03:11'),(76903,227,'Kudaari','285121',1,0,'2022-03-03 13:03:11','2022-03-03 13:03:11'),(76904,227,'Kukargaon','285001',1,0,'2022-03-03 13:03:11','2022-03-03 13:03:11'),(76905,227,'Kurahna Alamgir','285202',1,0,'2022-03-03 13:03:11','2022-03-03 13:03:11'),(76906,227,'Kurkuru','285223',1,0,'2022-03-03 13:03:11','2022-03-03 13:03:11'),(76907,227,'Kursenda','285126',1,0,'2022-03-03 13:03:11','2022-03-03 13:03:11'),(76908,227,'Kusmara','285123',1,0,'2022-03-03 13:03:11','2022-03-03 13:03:11'),(76909,227,'Kusmiliya','285122',1,0,'2022-03-03 13:03:11','2022-03-03 13:03:11'),(76910,227,'Kuthond','285125',1,0,'2022-03-03 13:03:11','2022-03-03 13:03:11'),(76911,227,'Kuthonda','285121',1,0,'2022-03-03 13:03:11','2022-03-03 13:03:11'),(76912,227,'Kuthonda Buzurg','285123',1,0,'2022-03-03 13:03:11','2022-03-03 13:03:11'),(76913,227,'Lahchura','285123',1,0,'2022-03-03 13:03:11','2022-03-03 13:03:11'),(76914,227,'Lamsar','285203',1,0,'2022-03-03 13:03:11','2022-03-03 13:03:11'),(76915,227,'Lidaupur','285124',1,0,'2022-03-03 13:03:11','2022-03-03 13:03:11'),(76916,227,'Lohai','285125',1,0,'2022-03-03 13:03:12','2022-03-03 13:03:12'),(76917,227,'Madaripur','285130',1,0,'2022-03-03 13:03:12','2022-03-03 13:03:12'),(76918,227,'Madhogarh (Jalaun)','285126',1,0,'2022-03-03 13:03:12','2022-03-03 13:03:12'),(76919,227,'Madora','285128',1,0,'2022-03-03 13:03:12','2022-03-03 13:03:12'),(76920,227,'Madori','285128',1,0,'2022-03-03 13:03:12','2022-03-03 13:03:12'),(76921,227,'Magraul','285204',1,0,'2022-03-03 13:03:12','2022-03-03 13:03:12'),(76922,227,'Mahewa','284204',1,0,'2022-03-03 13:03:12','2022-03-03 13:03:12'),(76923,227,'Mai','285124',1,0,'2022-03-03 13:03:12','2022-03-03 13:03:12'),(76924,227,'Mainupur','285204',1,0,'2022-03-03 13:03:12','2022-03-03 13:03:12'),(76925,227,'Majeeth','285129',1,0,'2022-03-03 13:03:12','2022-03-03 13:03:12'),(76926,227,'Mandri','285001',1,0,'2022-03-03 13:03:12','2022-03-03 13:03:12'),(76927,227,'Manpura','285121',1,0,'2022-03-03 13:03:12','2022-03-03 13:03:12'),(76928,227,'Margayan','285203',1,0,'2022-03-03 13:03:12','2022-03-03 13:03:12'),(76929,227,'Masgaon','285202',1,0,'2022-03-03 13:03:12','2022-03-03 13:03:12'),(76930,227,'Matra','285203',1,0,'2022-03-03 13:03:12','2022-03-03 13:03:12'),(76931,227,'Mawai Ahir','285203',1,0,'2022-03-03 13:03:12','2022-03-03 13:03:12'),(76932,227,'Mijhauna','285121',1,0,'2022-03-03 13:03:12','2022-03-03 13:03:12'),(76933,227,'Mohammedabad','285122',1,0,'2022-03-03 13:03:12','2022-03-03 13:03:12'),(76934,227,'Mohana','285122',1,0,'2022-03-03 13:03:12','2022-03-03 13:03:12'),(76935,227,'Musmariya','285123',1,0,'2022-03-03 13:03:12','2022-03-03 13:03:12'),(76936,227,'Nadai','285123',1,0,'2022-03-03 13:03:12','2022-03-03 13:03:12'),(76937,227,'Nadigaon','285206',1,0,'2022-03-03 13:03:12','2022-03-03 13:03:12'),(76938,227,'Nahili','285125',1,0,'2022-03-03 13:03:13','2022-03-03 13:03:13'),(76939,227,'Naoli','285121',1,0,'2022-03-03 13:03:13','2022-03-03 13:03:13'),(76940,227,'Naraul','285127',1,0,'2022-03-03 13:03:13','2022-03-03 13:03:13'),(76941,227,'Navin Mandi Konch','285205',1,0,'2022-03-03 13:03:13','2022-03-03 13:03:13'),(76942,227,'Nawar','285129',1,0,'2022-03-03 13:03:13','2022-03-03 13:03:13'),(76943,227,'Nibahna','285204',1,0,'2022-03-03 13:03:13','2022-03-03 13:03:13'),(76944,227,'Ninaoli','285127',1,0,'2022-03-03 13:03:13','2022-03-03 13:03:13'),(76945,227,'Nipaniya','285130',1,0,'2022-03-03 13:03:13','2022-03-03 13:03:13'),(76946,227,'Nunsai','285001',1,0,'2022-03-03 13:03:13','2022-03-03 13:03:13'),(76947,227,'Orai H.O','285001',1,0,'2022-03-03 13:03:13','2022-03-03 13:03:13'),(76948,227,'Orai Kutchery','285001',1,0,'2022-03-03 13:03:13','2022-03-03 13:03:13'),(76949,227,'Orai Railway Station','285001',1,0,'2022-03-03 13:03:13','2022-03-03 13:03:13'),(76950,227,'Orai Town','285001',1,0,'2022-03-03 13:03:13','2022-03-03 13:03:13'),(76951,227,'Pachipuri','285205',1,0,'2022-03-03 13:03:13','2022-03-03 13:03:13'),(76952,227,'Pachokhara','285127',1,0,'2022-03-03 13:03:13','2022-03-03 13:03:13'),(76953,227,'Pahargaon','284306',1,0,'2022-03-03 13:03:13','2022-03-03 13:03:13'),(76954,227,'Paniyara','285205',1,0,'2022-03-03 13:03:13','2022-03-03 13:03:13'),(76955,227,'Parasan','285202',1,0,'2022-03-03 13:03:13','2022-03-03 13:03:13'),(76956,227,'Parawar','285121',1,0,'2022-03-03 13:03:13','2022-03-03 13:03:13'),(76957,227,'Parwatpura','285123',1,0,'2022-03-03 13:03:13','2022-03-03 13:03:13'),(76958,227,'Patrahi','285124',1,0,'2022-03-03 13:03:13','2022-03-03 13:03:13'),(76959,227,'Pindari','285201',1,0,'2022-03-03 13:03:13','2022-03-03 13:03:13'),(76960,227,'Piprayan','285202',1,0,'2022-03-03 13:03:13','2022-03-03 13:03:13'),(76961,227,'Pipri Athgaiyan','285130',1,0,'2022-03-03 13:03:13','2022-03-03 13:03:13'),(76962,227,'Pipri Gaharwar','285125',1,0,'2022-03-03 13:03:13','2022-03-03 13:03:13'),(76963,227,'Pirona','285201',1,0,'2022-03-03 13:03:13','2022-03-03 13:03:13'),(76964,227,'Pratap-pura','285123',1,0,'2022-03-03 13:03:14','2022-03-03 13:03:14'),(76965,227,'Rahiya','285001',1,0,'2022-03-03 13:03:14','2022-03-03 13:03:14'),(76966,227,'Ramhetpura','285126',1,0,'2022-03-03 13:03:14','2022-03-03 13:03:14'),(76967,227,'Rampura','284203',1,0,'2022-03-03 13:03:14','2022-03-03 13:03:14'),(76968,227,'Rampura (Jalaun)','285127',1,0,'2022-03-03 13:03:14','2022-03-03 13:03:14'),(76969,227,'Rath Road Orai','285001',1,0,'2022-03-03 13:03:14','2022-03-03 13:03:14'),(76970,227,'Rendhar','285121',1,0,'2022-03-03 13:03:14','2022-03-03 13:03:14'),(76971,227,'Rirua','285202',1,0,'2022-03-03 13:03:14','2022-03-03 13:03:14'),(76972,227,'Romai Mustkil','285125',1,0,'2022-03-03 13:03:14','2022-03-03 13:03:14'),(76973,227,'Roora Addu','285001',1,0,'2022-03-03 13:03:14','2022-03-03 13:03:14'),(76974,227,'Roora Jaitia','285125',1,0,'2022-03-03 13:03:14','2022-03-03 13:03:14'),(76975,227,'Rudrapura','285127',1,0,'2022-03-03 13:03:14','2022-03-03 13:03:14'),(76976,227,'Rura Sirsa','285121',1,0,'2022-03-03 13:03:14','2022-03-03 13:03:14'),(76977,227,'Sadupura','285205',1,0,'2022-03-03 13:03:14','2022-03-03 13:03:14'),(76978,227,'Sahav','285123',1,0,'2022-03-03 13:03:14','2022-03-03 13:03:14'),(76979,227,'Said Nagar','285223',1,0,'2022-03-03 13:03:14','2022-03-03 13:03:14'),(76980,227,'Sajera','285206',1,0,'2022-03-03 13:03:14','2022-03-03 13:03:14'),(76981,227,'Salabad','285123',1,0,'2022-03-03 13:03:14','2022-03-03 13:03:14'),(76982,227,'Salaiyya Buzurg','285205',1,0,'2022-03-03 13:03:14','2022-03-03 13:03:14'),(76983,227,'Sami','285205',1,0,'2022-03-03 13:03:14','2022-03-03 13:03:14'),(76984,227,'Sandhi','285202',1,0,'2022-03-03 13:03:14','2022-03-03 13:03:14'),(76985,227,'Sarawan','285123',1,0,'2022-03-03 13:03:14','2022-03-03 13:03:14'),(76986,227,'Sarr','285121',1,0,'2022-03-03 13:03:14','2022-03-03 13:03:14'),(76987,227,'Sarsai','285123',1,0,'2022-03-03 13:03:14','2022-03-03 13:03:14'),(76988,227,'Sarsela','285202',1,0,'2022-03-03 13:03:14','2022-03-03 13:03:14'),(76989,227,'Satoh','285201',1,0,'2022-03-03 13:03:15','2022-03-03 13:03:15'),(76990,227,'Shahjadpura','285001',1,0,'2022-03-03 13:03:15','2022-03-03 13:03:15'),(76991,227,'Shahjahanpur','285202',1,0,'2022-03-03 13:03:15','2022-03-03 13:03:15'),(76992,227,'Shankarpur','285125',1,0,'2022-03-03 13:03:15','2022-03-03 13:03:15'),(76993,227,'Sheikhpur Ahir','285125',1,0,'2022-03-03 13:03:15','2022-03-03 13:03:15'),(76994,227,'Sheikhpur Buzurg','285128',1,0,'2022-03-03 13:03:15','2022-03-03 13:03:15'),(76995,227,'Sidhpura','285127',1,0,'2022-03-03 13:03:15','2022-03-03 13:03:15'),(76996,227,'Sihari','285126',1,0,'2022-03-03 13:03:15','2022-03-03 13:03:15'),(76997,227,'Sihari Daoodpur','285001',1,0,'2022-03-03 13:03:15','2022-03-03 13:03:15'),(76998,227,'Sikri Raja','285123',1,0,'2022-03-03 13:03:15','2022-03-03 13:03:15'),(76999,227,'Sikri Vyas','285223',1,0,'2022-03-03 13:03:15','2022-03-03 13:03:15'),(77000,227,'Simhara Kasimpur','285130',1,0,'2022-03-03 13:03:15','2022-03-03 13:03:15'),(77001,227,'Simiriya','284303',1,0,'2022-03-03 13:03:15','2022-03-03 13:03:15'),(77002,227,'Sirsa Dogarhi','285121',1,0,'2022-03-03 13:03:15','2022-03-03 13:03:15'),(77003,227,'Sirsa Kalar','285130',1,0,'2022-03-03 13:03:15','2022-03-03 13:03:15'),(77004,227,'Somai','285201',1,0,'2022-03-03 13:03:15','2022-03-03 13:03:15'),(77005,227,'Sunaya','285205',1,0,'2022-03-03 13:03:15','2022-03-03 13:03:15'),(77006,227,'Teehar','285127',1,0,'2022-03-03 13:03:15','2022-03-03 13:03:15'),(77007,227,'Tikri','285125',1,0,'2022-03-03 13:03:15','2022-03-03 13:03:15'),(77008,227,'Timron','285001',1,0,'2022-03-03 13:03:15','2022-03-03 13:03:15'),(77009,227,'Titra Khalilpur','285205',1,0,'2022-03-03 13:03:15','2022-03-03 13:03:15'),(77010,227,'Toomra','285205',1,0,'2022-03-03 13:03:15','2022-03-03 13:03:15'),(77011,227,'Udanpur','285203',1,0,'2022-03-03 13:03:15','2022-03-03 13:03:15'),(77012,227,'Umri (Jalaun)','285129',1,0,'2022-03-03 13:03:15','2022-03-03 13:03:15'),(77013,227,'Uncha','285127',1,0,'2022-03-03 13:03:15','2022-03-03 13:03:15'),(77014,227,'Urgaon','285123',1,0,'2022-03-03 13:03:16','2022-03-03 13:03:16'),(77015,227,'Usargaon','285202',1,0,'2022-03-03 13:03:16','2022-03-03 13:03:16'),(77016,227,'Waoli','285125',1,0,'2022-03-03 13:03:16','2022-03-03 13:03:16'),(77017,228,'Aara','222133',1,0,'2022-03-03 13:03:16','2022-03-03 13:03:16'),(77018,228,'Adhanpur','223102',1,0,'2022-03-03 13:03:16','2022-03-03 13:03:16'),(77019,228,'Adiar','222203',1,0,'2022-03-03 13:03:16','2022-03-03 13:03:16'),(77020,228,'Agraura','222141',1,0,'2022-03-03 13:03:16','2022-03-03 13:03:16'),(77021,228,'Ahmadpur','222180',1,0,'2022-03-03 13:03:16','2022-03-03 13:03:16'),(77022,228,'Ajoshi','222161',1,0,'2022-03-03 13:03:16','2022-03-03 13:03:16'),(77023,228,'Alaiya','222201',1,0,'2022-03-03 13:03:16','2022-03-03 13:03:16'),(77024,228,'Alamganj','222162',1,0,'2022-03-03 13:03:16','2022-03-03 13:03:16'),(77025,228,'Amahit','222142',1,0,'2022-03-03 13:03:16','2022-03-03 13:03:16'),(77026,228,'Amai','222165',1,0,'2022-03-03 13:03:16','2022-03-03 13:03:16'),(77027,228,'Amara','222170',1,0,'2022-03-03 13:03:16','2022-03-03 13:03:16'),(77028,228,'Anguli','223104',1,0,'2022-03-03 13:03:16','2022-03-03 13:03:16'),(77029,228,'Arand','222139',1,0,'2022-03-03 13:03:16','2022-03-03 13:03:16'),(77030,228,'Argupur Kala','222101',1,0,'2022-03-03 13:03:16','2022-03-03 13:03:16'),(77031,228,'Asaropur','222145',1,0,'2022-03-03 13:03:16','2022-03-03 13:03:16'),(77032,228,'Asbaranpur','222136',1,0,'2022-03-03 13:03:16','2022-03-03 13:03:16'),(77033,228,'Ashapur','222203',1,0,'2022-03-03 13:03:16','2022-03-03 13:03:16'),(77034,228,'Ashawan','222203',1,0,'2022-03-03 13:03:16','2022-03-03 13:03:16'),(77035,228,'Aura','222137',1,0,'2022-03-03 13:03:17','2022-03-03 13:03:17'),(77036,228,'Aurahi','222003',1,0,'2022-03-03 13:03:17','2022-03-03 13:03:17'),(77037,228,'Auraila','222105',1,0,'2022-03-03 13:03:17','2022-03-03 13:03:17'),(77038,228,'Ayurved Vishwavidyalay','222139',1,0,'2022-03-03 13:03:17','2022-03-03 13:03:17'),(77039,228,'Babhaniyaw','222165',1,0,'2022-03-03 13:03:17','2022-03-03 13:03:17'),(77040,228,'Badalapur Khurd','222141',1,0,'2022-03-03 13:03:17','2022-03-03 13:03:17'),(77041,228,'Baderi','222127',1,0,'2022-03-03 13:03:17','2022-03-03 13:03:17'),(77042,228,'Badkhin','222203',1,0,'2022-03-03 13:03:17','2022-03-03 13:03:17'),(77043,228,'Badlapur','222125',1,0,'2022-03-03 13:03:17','2022-03-03 13:03:17'),(77044,228,'Baghendra','222133',1,0,'2022-03-03 13:03:17','2022-03-03 13:03:17'),(77045,228,'Baharipur','222175',1,0,'2022-03-03 13:03:17','2022-03-03 13:03:17'),(77046,228,'Bakarabad','222136',1,0,'2022-03-03 13:03:17','2022-03-03 13:03:17'),(77047,228,'Bakuchi','223101',1,0,'2022-03-03 13:03:17','2022-03-03 13:03:17'),(77048,228,'Balrampur','222129',1,0,'2022-03-03 13:03:17','2022-03-03 13:03:17'),(77049,228,'Balwarganj','222201',1,0,'2022-03-03 13:03:17','2022-03-03 13:03:17'),(77050,228,'Bami','222143',1,0,'2022-03-03 13:03:17','2022-03-03 13:03:17'),(77051,228,'Baneora','222128',1,0,'2022-03-03 13:03:17','2022-03-03 13:03:17'),(77052,228,'Bangaondih','222101',1,0,'2022-03-03 13:03:17','2022-03-03 13:03:17'),(77053,228,'Bangaonpatti','222125',1,0,'2022-03-03 13:03:17','2022-03-03 13:03:17'),(77054,228,'Banidih','222203',1,0,'2022-03-03 13:03:17','2022-03-03 13:03:17'),(77055,228,'Barain','222181',1,0,'2022-03-03 13:03:17','2022-03-03 13:03:17'),(77056,228,'Baraipar','222144',1,0,'2022-03-03 13:03:17','2022-03-03 13:03:17'),(77057,228,'Barawan','222143',1,0,'2022-03-03 13:03:17','2022-03-03 13:03:17'),(77058,228,'Barhata','222144',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77059,228,'Barigaon Newada','222161',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77060,228,'Barigaondih','222165',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77061,228,'Barji','222145',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77062,228,'Barpur','222109',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77063,228,'Barsathi','222162',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77064,228,'Basaratpur','222003',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77065,228,'Basauli','223102',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77066,228,'Batnahit','222202',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77067,228,'Bazar Arasia','223103',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77068,228,'Bazar Neorhia','222128',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77069,228,'Beerampur','222170',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77070,228,'Behra','222181',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77071,228,'Belaon','222170',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77072,228,'Belasin','222143',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77073,228,'Belaunakala','222162',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77074,228,'Belawa Bazar','222161',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77075,228,'Belawan','222109',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77076,228,'Belgahan','222161',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77077,228,'Belhari','222142',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77078,228,'Belwai','222101',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77079,228,'Belwar','222201',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77080,228,'Bhadeora','222133',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77081,228,'Bhagasa','223102',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77082,228,'Bhagmalpur','223104',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77083,228,'Bhaisa','222129',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77084,228,'Bhakura','222003',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77085,228,'Bhannaur','222162',1,0,'2022-03-03 13:03:18','2022-03-03 13:03:18'),(77086,228,'Bhanpur','222203',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77087,228,'Bharathipur','222203',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77088,228,'Bhatauli','222145',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77089,228,'Bhathar','222165',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77090,228,'Bhaupur','222136',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77091,228,'Bhawaniganj','222128',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77092,228,'Bhelara','222101',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77093,228,'Bhiduna','222165',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77094,228,'Bhikhpur','222202',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77095,228,'Bhikhpur Kala','222143',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77096,228,'Bhilampur','222201',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77097,228,'Bhiura','222203',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77098,228,'Bibipur','222180',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77099,228,'Bidauri','222136',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77100,228,'Birbhanpur','222109',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77101,228,'Biri','222129',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77102,228,'Bishunpur','223103',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77103,228,'Bishunpur Majhwara','222136',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77104,228,'Bodari','222149',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77105,228,'Brahmanpur','222148',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77106,228,'Brahmanpur','222142',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77107,228,'Budhhipur','222128',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77108,228,'Bujurga','222161',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77109,228,'Buxa','222109',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77110,228,'Chakara','222149',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77111,228,'Chandepur','222129',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77112,228,'Chandwak','222129',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77113,228,'Chhangapur','222137',1,0,'2022-03-03 13:03:19','2022-03-03 13:03:19'),(77114,228,'Chhatai Kala','223101',1,0,'2022-03-03 13:03:20','2022-03-03 13:03:20'),(77115,228,'Chitako','222129',1,0,'2022-03-03 13:03:20','2022-03-03 13:03:20'),(77116,228,'Chorari','222161',1,0,'2022-03-03 13:03:20','2022-03-03 13:03:20'),(77117,228,'Chorsand','222133',1,0,'2022-03-03 13:03:20','2022-03-03 13:03:20'),(77118,228,'Civil Court (Jaunpur)','222002',1,0,'2022-03-03 13:03:20','2022-03-03 13:03:20'),(77119,228,'Collectrate Compound','222002',1,0,'2022-03-03 13:03:20','2022-03-03 13:03:20'),(77120,228,'College Colony','222002',1,0,'2022-03-03 13:03:20','2022-03-03 13:03:20'),(77121,228,'Dakkhinpatti Ranno','222109',1,0,'2022-03-03 13:03:20','2022-03-03 13:03:20'),(77122,228,'Damarua','222135',1,0,'2022-03-03 13:03:20','2022-03-03 13:03:20'),(77123,228,'Damodara','222137',1,0,'2022-03-03 13:03:20','2022-03-03 13:03:20'),(77124,228,'Dan','222202',1,0,'2022-03-03 13:03:20','2022-03-03 13:03:20'),(77125,228,'Dariaoganj','222109',1,0,'2022-03-03 13:03:20','2022-03-03 13:03:20'),(77126,228,'Daudi','222161',1,0,'2022-03-03 13:03:20','2022-03-03 13:03:20'),(77127,228,'Deduana','222142',1,0,'2022-03-03 13:03:20','2022-03-03 13:03:20'),(77128,228,'Dehari','223103',1,0,'2022-03-03 13:03:20','2022-03-03 13:03:20'),(77129,228,'Dehari','222142',1,0,'2022-03-03 13:03:20','2022-03-03 13:03:20'),(77130,228,'Deokali','222142',1,0,'2022-03-03 13:03:20','2022-03-03 13:03:20'),(77131,228,'Dewapar','222136',1,0,'2022-03-03 13:03:20','2022-03-03 13:03:20'),(77132,228,'Dhanethu','222128',1,0,'2022-03-03 13:03:20','2022-03-03 13:03:20'),(77133,228,'Dharaon','222136',1,0,'2022-03-03 13:03:20','2022-03-03 13:03:20'),(77134,228,'Dharmapur','222002',1,0,'2022-03-03 13:03:20','2022-03-03 13:03:20'),(77135,228,'Dhema','222125',1,0,'2022-03-03 13:03:20','2022-03-03 13:03:20'),(77136,228,'Dhirajpur','222132',1,0,'2022-03-03 13:03:20','2022-03-03 13:03:20'),(77137,228,'Dihiya','223104',1,0,'2022-03-03 13:03:20','2022-03-03 13:03:20'),(77138,228,'Dilla Ka Pura','222142',1,0,'2022-03-03 13:03:20','2022-03-03 13:03:20'),(77139,228,'Dubepur','222136',1,0,'2022-03-03 13:03:20','2022-03-03 13:03:20'),(77140,228,'Dukhaipur Sambalshah','223105',1,0,'2022-03-03 13:03:21','2022-03-03 13:03:21'),(77141,228,'Fatehganj (Jaunpur)','222132',1,0,'2022-03-03 13:03:21','2022-03-03 13:03:21'),(77142,228,'Gaddopur','222125',1,0,'2022-03-03 13:03:21','2022-03-03 13:03:21'),(77143,228,'Gaddopur','222170',1,0,'2022-03-03 13:03:21','2022-03-03 13:03:21'),(77144,228,'Gairwah','223103',1,0,'2022-03-03 13:03:21','2022-03-03 13:03:21'),(77145,228,'Gajendrapur','223104',1,0,'2022-03-03 13:03:21','2022-03-03 13:03:21'),(77146,228,'Gandhauna','222203',1,0,'2022-03-03 13:03:21','2022-03-03 13:03:21'),(77147,228,'Gangauli','223105',1,0,'2022-03-03 13:03:21','2022-03-03 13:03:21'),(77148,228,'Garaila','222003',1,0,'2022-03-03 13:03:21','2022-03-03 13:03:21'),(77149,228,'Gareriha','222145',1,0,'2022-03-03 13:03:21','2022-03-03 13:03:21'),(77150,228,'Garhabaghrai','222109',1,0,'2022-03-03 13:03:21','2022-03-03 13:03:21'),(77151,228,'Gariaon','222204',1,0,'2022-03-03 13:03:21','2022-03-03 13:03:21'),(77152,228,'Gaurabadshahpur','222133',1,0,'2022-03-03 13:03:21','2022-03-03 13:03:21'),(77153,228,'Gaurapatti','222162',1,0,'2022-03-03 13:03:21','2022-03-03 13:03:21'),(77154,228,'Gauspur','223104',1,0,'2022-03-03 13:03:21','2022-03-03 13:03:21'),(77155,228,'Ghagharia','222143',1,0,'2022-03-03 13:03:21','2022-03-03 13:03:21'),(77156,228,'Ghanshyampur (Jaunpur)','223104',1,0,'2022-03-03 13:03:21','2022-03-03 13:03:21'),(77157,228,'Ghuripur','222201',1,0,'2022-03-03 13:03:21','2022-03-03 13:03:21'),(77158,228,'Gobara','222129',1,0,'2022-03-03 13:03:21','2022-03-03 13:03:21'),(77159,228,'Gokha','222127',1,0,'2022-03-03 13:03:21','2022-03-03 13:03:21'),(77160,228,'Gonapur','222144',1,0,'2022-03-03 13:03:21','2022-03-03 13:03:21'),(77161,228,'Gonauli','222175',1,0,'2022-03-03 13:03:21','2022-03-03 13:03:21'),(77162,228,'Gopalapur','222137',1,0,'2022-03-03 13:03:21','2022-03-03 13:03:21'),(77163,228,'Gopalapur','223104',1,0,'2022-03-03 13:03:21','2022-03-03 13:03:21'),(77164,228,'Gopipur','222138',1,0,'2022-03-03 13:03:21','2022-03-03 13:03:21'),(77165,228,'Gothaon','222162',1,0,'2022-03-03 13:03:22','2022-03-03 13:03:22'),(77166,228,'Gulalpur','222139',1,0,'2022-03-03 13:03:22','2022-03-03 13:03:22'),(77167,228,'Gulzarganj','222135',1,0,'2022-03-03 13:03:22','2022-03-03 13:03:22'),(77168,228,'Guraini','222139',1,0,'2022-03-03 13:03:22','2022-03-03 13:03:22'),(77169,228,'Gurbari','223103',1,0,'2022-03-03 13:03:22','2022-03-03 13:03:22'),(77170,228,'Gutwan','222136',1,0,'2022-03-03 13:03:22','2022-03-03 13:03:22'),(77171,228,'Harbaspur','222002',1,0,'2022-03-03 13:03:22','2022-03-03 13:03:22'),(77172,228,'Hariharpur','222203',1,0,'2022-03-03 13:03:22','2022-03-03 13:03:22'),(77173,228,'Hariharpur','222129',1,0,'2022-03-03 13:03:22','2022-03-03 13:03:22'),(77174,228,'Haripur','222146',1,0,'2022-03-03 13:03:22','2022-03-03 13:03:22'),(77175,228,'Harpur','222101',1,0,'2022-03-03 13:03:22','2022-03-03 13:03:22'),(77176,228,'Hauz','222180',1,0,'2022-03-03 13:03:22','2022-03-03 13:03:22'),(77177,228,'Hindi Baghaila','222003',1,0,'2022-03-03 13:03:22','2022-03-03 13:03:22'),(77178,228,'Hisampur','222129',1,0,'2022-03-03 13:03:22','2022-03-03 13:03:22'),(77179,228,'I.T.I.Siddikpur','222003',1,0,'2022-03-03 13:03:22','2022-03-03 13:03:22'),(77180,228,'Imalo','222180',1,0,'2022-03-03 13:03:22','2022-03-03 13:03:22'),(77181,228,'Ishapur','223102',1,0,'2022-03-03 13:03:22','2022-03-03 13:03:22'),(77182,228,'Itaha','222144',1,0,'2022-03-03 13:03:22','2022-03-03 13:03:22'),(77183,228,'Itaye','222161',1,0,'2022-03-03 13:03:22','2022-03-03 13:03:22'),(77184,228,'Jagarnathpur','222161',1,0,'2022-03-03 13:03:22','2022-03-03 13:03:22'),(77185,228,'Jagdishpur','222002',1,0,'2022-03-03 13:03:22','2022-03-03 13:03:22'),(77186,228,'Jaigahan','222139',1,0,'2022-03-03 13:03:22','2022-03-03 13:03:22'),(77187,228,'Jaigopalganj','222142',1,0,'2022-03-03 13:03:22','2022-03-03 13:03:22'),(77188,228,'Jalalpur (Jaunpur)','222136',1,0,'2022-03-03 13:03:23','2022-03-03 13:03:23'),(77189,228,'Jamalapur','222137',1,0,'2022-03-03 13:03:23','2022-03-03 13:03:23'),(77190,228,'Jamaupatti','222125',1,0,'2022-03-03 13:03:23','2022-03-03 13:03:23'),(77191,228,'Jamdahan','222139',1,0,'2022-03-03 13:03:23','2022-03-03 13:03:23'),(77192,228,'Jamua','222127',1,0,'2022-03-03 13:03:23','2022-03-03 13:03:23'),(77193,228,'Jamuhai','222003',1,0,'2022-03-03 13:03:23','2022-03-03 13:03:23'),(77194,228,'Jamunia','223103',1,0,'2022-03-03 13:03:23','2022-03-03 13:03:23'),(77195,228,'Jangipur Khurd','222003',1,0,'2022-03-03 13:03:23','2022-03-03 13:03:23'),(77196,228,'Japtapur','222139',1,0,'2022-03-03 13:03:23','2022-03-03 13:03:23'),(77197,228,'Jaunpur H.O','222001',1,0,'2022-03-03 13:03:23','2022-03-03 13:03:23'),(77198,228,'Jaunpur Kty.','222002',1,0,'2022-03-03 13:03:23','2022-03-03 13:03:23'),(77199,228,'Jiaramau','222161',1,0,'2022-03-03 13:03:23','2022-03-03 13:03:23'),(77200,228,'Kabulpur','222180',1,0,'2022-03-03 13:03:23','2022-03-03 13:03:23'),(77201,228,'Kachhawan','222149',1,0,'2022-03-03 13:03:23','2022-03-03 13:03:23'),(77202,228,'Kailawar','222105',1,0,'2022-03-03 13:03:23','2022-03-03 13:03:23'),(77203,228,'Kajgaon (Jaunpur)','222138',1,0,'2022-03-03 13:03:23','2022-03-03 13:03:23'),(77204,228,'Kalan','222101',1,0,'2022-03-03 13:03:23','2022-03-03 13:03:23'),(77205,228,'Kalapur','222139',1,0,'2022-03-03 13:03:23','2022-03-03 13:03:23'),(77206,228,'Kalichabad','222002',1,0,'2022-03-03 13:03:23','2022-03-03 13:03:23'),(77207,228,'Kammarpur','223105',1,0,'2022-03-03 13:03:23','2022-03-03 13:03:23'),(77208,228,'Kandhikala','222141',1,0,'2022-03-03 13:03:23','2022-03-03 13:03:23'),(77209,228,'Kanhabanshipur','222127',1,0,'2022-03-03 13:03:23','2022-03-03 13:03:23'),(77210,228,'Kanja','222003',1,0,'2022-03-03 13:03:23','2022-03-03 13:03:23'),(77211,228,'Kanuani','222146',1,0,'2022-03-03 13:03:23','2022-03-03 13:03:23'),(77212,228,'Karaura','222143',1,0,'2022-03-03 13:03:23','2022-03-03 13:03:23'),(77213,228,'Karobankat','222165',1,0,'2022-03-03 13:03:24','2022-03-03 13:03:24'),(77214,228,'Kaserawa','222165',1,0,'2022-03-03 13:03:24','2022-03-03 13:03:24'),(77215,228,'Katahit','222144',1,0,'2022-03-03 13:03:24','2022-03-03 13:03:24'),(77216,228,'Katwar','222165',1,0,'2022-03-03 13:03:24','2022-03-03 13:03:24'),(77217,228,'Kerakat','222142',1,0,'2022-03-03 13:03:24','2022-03-03 13:03:24'),(77218,228,'Khajurahat','222143',1,0,'2022-03-03 13:03:24','2022-03-03 13:03:24'),(77219,228,'Khajurahawa','222161',1,0,'2022-03-03 13:03:24','2022-03-03 13:03:24'),(77220,228,'Khalilpur','222003',1,0,'2022-03-03 13:03:24','2022-03-03 13:03:24'),(77221,228,'Khalishpur','222141',1,0,'2022-03-03 13:03:24','2022-03-03 13:03:24'),(77222,228,'Khapraha]','222131',1,0,'2022-03-03 13:03:24','2022-03-03 13:03:24'),(77223,228,'Kheosipur','222146',1,0,'2022-03-03 13:03:24','2022-03-03 13:03:24'),(77224,228,'Khetapur','222128',1,0,'2022-03-03 13:03:24','2022-03-03 13:03:24'),(77225,228,'Khetasarai','222139',1,0,'2022-03-03 13:03:24','2022-03-03 13:03:24'),(77226,228,'Khodauli','222139',1,0,'2022-03-03 13:03:24','2022-03-03 13:03:24'),(77227,228,'Khujhidih','222201',1,0,'2022-03-03 13:03:24','2022-03-03 13:03:24'),(77228,228,'Khunsapur','222141',1,0,'2022-03-03 13:03:24','2022-03-03 13:03:24'),(77229,228,'Khuthan','223104',1,0,'2022-03-03 13:03:24','2022-03-03 13:03:24'),(77230,228,'Kilai','222175',1,0,'2022-03-03 13:03:24','2022-03-03 13:03:24'),(77231,228,'Kilhapur','222204',1,0,'2022-03-03 13:03:24','2022-03-03 13:03:24'),(77232,228,'Kirtapur','222002',1,0,'2022-03-03 13:03:24','2022-03-03 13:03:24'),(77233,228,'Kishunpur','222161',1,0,'2022-03-03 13:03:24','2022-03-03 13:03:24'),(77234,228,'Kohara Sultanpur','222132',1,0,'2022-03-03 13:03:24','2022-03-03 13:03:24'),(77235,228,'Koilari','222148',1,0,'2022-03-03 13:03:25','2022-03-03 13:03:25'),(77236,228,'Kolhua','222145',1,0,'2022-03-03 13:03:25','2022-03-03 13:03:25'),(77237,228,'Kotwa','222143',1,0,'2022-03-03 13:03:25','2022-03-03 13:03:25'),(77238,228,'Kudda','222170',1,0,'2022-03-03 13:03:25','2022-03-03 13:03:25'),(77239,228,'Kuddupur','222105',1,0,'2022-03-03 13:03:25','2022-03-03 13:03:25'),(77240,228,'Kuhi Kalan','222125',1,0,'2022-03-03 13:03:25','2022-03-03 13:03:25'),(77241,228,'Kukuhan','222133',1,0,'2022-03-03 13:03:25','2022-03-03 13:03:25'),(77242,228,'Kumarpatti','222175',1,0,'2022-03-03 13:03:25','2022-03-03 13:03:25'),(77243,228,'Kumbhapur','222137',1,0,'2022-03-03 13:03:25','2022-03-03 13:03:25'),(77244,228,'Kunwarpur','222202',1,0,'2022-03-03 13:03:25','2022-03-03 13:03:25'),(77245,228,'Kusa','222162',1,0,'2022-03-03 13:03:25','2022-03-03 13:03:25'),(77246,228,'Kusaila','222142',1,0,'2022-03-03 13:03:25','2022-03-03 13:03:25'),(77247,228,'Kusarana','222149',1,0,'2022-03-03 13:03:25','2022-03-03 13:03:25'),(77248,228,'Kushmaul','222201',1,0,'2022-03-03 13:03:25','2022-03-03 13:03:25'),(77249,228,'Kusia','222136',1,0,'2022-03-03 13:03:25','2022-03-03 13:03:25'),(77250,228,'Kutir Chakkey','222146',1,0,'2022-03-03 13:03:25','2022-03-03 13:03:25'),(77251,228,'Kuttupur','222161',1,0,'2022-03-03 13:03:25','2022-03-03 13:03:25'),(77252,228,'Kuwarda','222132',1,0,'2022-03-03 13:03:25','2022-03-03 13:03:25'),(77253,228,'Lagdharpur','222128',1,0,'2022-03-03 13:03:25','2022-03-03 13:03:25'),(77254,228,'Lahangpur','222136',1,0,'2022-03-03 13:03:25','2022-03-03 13:03:25'),(77255,228,'Lalpur','222136',1,0,'2022-03-03 13:03:25','2022-03-03 13:03:25'),(77256,228,'Lapari','222139',1,0,'2022-03-03 13:03:25','2022-03-03 13:03:25'),(77257,228,'Latifpur','222101',1,0,'2022-03-03 13:03:25','2022-03-03 13:03:25'),(77258,228,'Leduka','222109',1,0,'2022-03-03 13:03:26','2022-03-03 13:03:26'),(77259,228,'Leorua','222148',1,0,'2022-03-03 13:03:26','2022-03-03 13:03:26'),(77260,228,'Lohinda','222145',1,0,'2022-03-03 13:03:26','2022-03-03 13:03:26'),(77261,228,'Machhali Shahar','222143',1,0,'2022-03-03 13:03:26','2022-03-03 13:03:26'),(77262,228,'Madarpur','222105',1,0,'2022-03-03 13:03:26','2022-03-03 13:03:26'),(77263,228,'Madhi','222129',1,0,'2022-03-03 13:03:26','2022-03-03 13:03:26'),(77264,228,'Madhupur','222202',1,0,'2022-03-03 13:03:26','2022-03-03 13:03:26'),(77265,228,'Maharupur','222180',1,0,'2022-03-03 13:03:26','2022-03-03 13:03:26'),(77266,228,'Mahraj Ganj','222145',1,0,'2022-03-03 13:03:26','2022-03-03 13:03:26'),(77267,228,'Mahuari','222165',1,0,'2022-03-03 13:03:26','2022-03-03 13:03:26'),(77268,228,'Mai','222146',1,0,'2022-03-03 13:03:26','2022-03-03 13:03:26'),(77269,228,'Mainpur','222161',1,0,'2022-03-03 13:03:26','2022-03-03 13:03:26'),(77270,228,'Majhgawan','222146',1,0,'2022-03-03 13:03:26','2022-03-03 13:03:26'),(77271,228,'Malai','222162',1,0,'2022-03-03 13:03:26','2022-03-03 13:03:26'),(77272,228,'Malhani','222003',1,0,'2022-03-03 13:03:26','2022-03-03 13:03:26'),(77273,228,'Manapur','222162',1,0,'2022-03-03 13:03:26','2022-03-03 13:03:26'),(77274,228,'Mangara','222162',1,0,'2022-03-03 13:03:26','2022-03-03 13:03:26'),(77275,228,'Manikala','223104',1,0,'2022-03-03 13:03:26','2022-03-03 13:03:26'),(77276,228,'Manikapur','222165',1,0,'2022-03-03 13:03:26','2022-03-03 13:03:26'),(77277,228,'Marhat','223104',1,0,'2022-03-03 13:03:26','2022-03-03 13:03:26'),(77278,228,'Mariahun Bazar','222161',1,0,'2022-03-03 13:03:26','2022-03-03 13:03:26'),(77279,228,'Mariahun','222161',1,0,'2022-03-03 13:03:26','2022-03-03 13:03:26'),(77280,228,'Marikpur','222203',1,0,'2022-03-03 13:03:27','2022-03-03 13:03:27'),(77281,228,'Masida','222132',1,0,'2022-03-03 13:03:27','2022-03-03 13:03:27'),(77282,228,'Mathura','222143',1,0,'2022-03-03 13:03:27','2022-03-03 13:03:27'),(77283,228,'Medha','222125',1,0,'2022-03-03 13:03:27','2022-03-03 13:03:27'),(77284,228,'Meerapur Kewal','222125',1,0,'2022-03-03 13:03:27','2022-03-03 13:03:27'),(77285,228,'Meerganj (Jaunpur)','222165',1,0,'2022-03-03 13:03:27','2022-03-03 13:03:27'),(77286,228,'Mehandi','222135',1,0,'2022-03-03 13:03:27','2022-03-03 13:03:27'),(77287,228,'Mirsahdpur','222125',1,0,'2022-03-03 13:03:27','2022-03-03 13:03:27'),(77288,228,'Mitawa','222145',1,0,'2022-03-03 13:03:27','2022-03-03 13:03:27'),(77289,228,'Mithepar','222161',1,0,'2022-03-03 13:03:27','2022-03-03 13:03:27'),(77290,228,'Mokalpur','222161',1,0,'2022-03-03 13:03:27','2022-03-03 13:03:27'),(77291,228,'Muftiganj','222170',1,0,'2022-03-03 13:03:27','2022-03-03 13:03:27'),(77292,228,'Mujar','222127',1,0,'2022-03-03 13:03:27','2022-03-03 13:03:27'),(77293,228,'Mungra Badshahpur','222202',1,0,'2022-03-03 13:03:27','2022-03-03 13:03:27'),(77294,228,'Muradganj','222002',1,0,'2022-03-03 13:03:27','2022-03-03 13:03:27'),(77295,228,'Muradpur','222125',1,0,'2022-03-03 13:03:27','2022-03-03 13:03:27'),(77296,228,'Murara','222170',1,0,'2022-03-03 13:03:27','2022-03-03 13:03:27'),(77297,228,'Murki','222142',1,0,'2022-03-03 13:03:27','2022-03-03 13:03:27'),(77298,228,'Mustafabad','222143',1,0,'2022-03-03 13:03:27','2022-03-03 13:03:27'),(77299,228,'Nahora','222136',1,0,'2022-03-03 13:03:27','2022-03-03 13:03:27'),(77300,228,'Nakahara','222175',1,0,'2022-03-03 13:03:27','2022-03-03 13:03:27'),(77301,228,'Narauli','223104',1,0,'2022-03-03 13:03:27','2022-03-03 13:03:27'),(77302,228,'Narhan','222142',1,0,'2022-03-03 13:03:27','2022-03-03 13:03:27'),(77303,228,'Naupedwa','222109',1,0,'2022-03-03 13:03:28','2022-03-03 13:03:28'),(77304,228,'Nayansand','222133',1,0,'2022-03-03 13:03:28','2022-03-03 13:03:28'),(77305,228,'NDC Jamuhai','222003',1,0,'2022-03-03 13:03:28','2022-03-03 13:03:28'),(77306,228,'Neoraha','222201',1,0,'2022-03-03 13:03:28','2022-03-03 13:03:28'),(77307,228,'Newada','222136',1,0,'2022-03-03 13:03:28','2022-03-03 13:03:28'),(77308,228,'Newada Mukhalispur','222125',1,0,'2022-03-03 13:03:28','2022-03-03 13:03:28'),(77309,228,'Nibhapur','222204',1,0,'2022-03-03 13:03:28','2022-03-03 13:03:28'),(77310,228,'Nigoh','222162',1,0,'2022-03-03 13:03:28','2022-03-03 13:03:28'),(77311,228,'Nizamuddinpur','222127',1,0,'2022-03-03 13:03:28','2022-03-03 13:03:28'),(77312,228,'Nonari','222128',1,0,'2022-03-03 13:03:28','2022-03-03 13:03:28'),(77313,228,'Oina','222146',1,0,'2022-03-03 13:03:28','2022-03-03 13:03:28'),(77314,228,'Pachawal','222203',1,0,'2022-03-03 13:03:28','2022-03-03 13:03:28'),(77315,228,'Pahetiapur','222175',1,0,'2022-03-03 13:03:28','2022-03-03 13:03:28'),(77316,228,'Paltupur','222162',1,0,'2022-03-03 13:03:28','2022-03-03 13:03:28'),(77317,228,'Panauli','223104',1,0,'2022-03-03 13:03:28','2022-03-03 13:03:28'),(77318,228,'Parakamal','222139',1,0,'2022-03-03 13:03:28','2022-03-03 13:03:28'),(77319,228,'Pariyat','222162',1,0,'2022-03-03 13:03:28','2022-03-03 13:03:28'),(77320,228,'Pariyawan','222138',1,0,'2022-03-03 13:03:28','2022-03-03 13:03:28'),(77321,228,'Pasewa','222142',1,0,'2022-03-03 13:03:28','2022-03-03 13:03:28'),(77322,228,'Pasiahi Khurd','222136',1,0,'2022-03-03 13:03:28','2022-03-03 13:03:28'),(77323,228,'Pataila','223102',1,0,'2022-03-03 13:03:28','2022-03-03 13:03:28'),(77324,228,'Pathana','222003',1,0,'2022-03-03 13:03:28','2022-03-03 13:03:28'),(77325,228,'Patrahi','222129',1,0,'2022-03-03 13:03:28','2022-03-03 13:03:28'),(77326,228,'Patti Chakesar','223103',1,0,'2022-03-03 13:03:28','2022-03-03 13:03:28'),(77327,228,'Patti Narendra','223102',1,0,'2022-03-03 13:03:28','2022-03-03 13:03:28'),(77328,228,'Pawara','222202',1,0,'2022-03-03 13:03:29','2022-03-03 13:03:29'),(77329,228,'Pesara','222142',1,0,'2022-03-03 13:03:29','2022-03-03 13:03:29'),(77330,228,'Pilikhini','222133',1,0,'2022-03-03 13:03:29','2022-03-03 13:03:29'),(77331,228,'Pilkathua','222162',1,0,'2022-03-03 13:03:29','2022-03-03 13:03:29'),(77332,228,'Pilkichha','223104',1,0,'2022-03-03 13:03:29','2022-03-03 13:03:29'),(77333,228,'Pokhara','222149',1,0,'2022-03-03 13:03:29','2022-03-03 13:03:29'),(77334,228,'Poly','222105',1,0,'2022-03-03 13:03:29','2022-03-03 13:03:29'),(77335,228,'Potaria','222139',1,0,'2022-03-03 13:03:29','2022-03-03 13:03:29'),(77336,228,'Premapur','222002',1,0,'2022-03-03 13:03:29','2022-03-03 13:03:29'),(77337,228,'Premkapura','222201',1,0,'2022-03-03 13:03:29','2022-03-03 13:03:29'),(77338,228,'Prithvipur','222203',1,0,'2022-03-03 13:03:29','2022-03-03 13:03:29'),(77339,228,'Pukhta Sarai','222002',1,0,'2022-03-03 13:03:29','2022-03-03 13:03:29'),(77340,228,'Purani Bazar','222002',1,0,'2022-03-03 13:03:29','2022-03-03 13:03:29'),(77341,228,'Purev','222136',1,0,'2022-03-03 13:03:29','2022-03-03 13:03:29'),(77342,228,'Purvanchal Vishwa Vidyalaya','222003',1,0,'2022-03-03 13:03:29','2022-03-03 13:03:29'),(77343,228,'Pyareypur Bijhawat','222125',1,0,'2022-03-03 13:03:29','2022-03-03 13:03:29'),(77344,228,'Raipur','222202',1,0,'2022-03-03 13:03:29','2022-03-03 13:03:29'),(77345,228,'Raj College','222001',1,0,'2022-03-03 13:03:29','2022-03-03 13:03:29'),(77346,228,'Rajabazar','222125',1,0,'2022-03-03 13:03:29','2022-03-03 13:03:29'),(77347,228,'Rajapur','222145',1,0,'2022-03-03 13:03:29','2022-03-03 13:03:29'),(77348,228,'Rajepur','222136',1,0,'2022-03-03 13:03:29','2022-03-03 13:03:29'),(77349,228,'Rajjupur','222202',1,0,'2022-03-03 13:03:29','2022-03-03 13:03:29'),(77350,228,'Ramdayalganj','222105',1,0,'2022-03-03 13:03:29','2022-03-03 13:03:29'),(77351,228,'Ramnagar','223105',1,0,'2022-03-03 13:03:30','2022-03-03 13:03:30'),(77352,228,'Ramnagar','222202',1,0,'2022-03-03 13:03:30','2022-03-03 13:03:30'),(77353,228,'Ramnagar Vidhmauwa','222161',1,0,'2022-03-03 13:03:30','2022-03-03 13:03:30'),(77354,228,'Rampur Baijapur','222003',1,0,'2022-03-03 13:03:30','2022-03-03 13:03:30'),(77355,228,'Rampur Kundaha','222201',1,0,'2022-03-03 13:03:30','2022-03-03 13:03:30'),(77356,228,'Rampur Naddi','222105',1,0,'2022-03-03 13:03:30','2022-03-03 13:03:30'),(77357,228,'Rampur (Jaunpur)','222203',1,0,'2022-03-03 13:03:30','2022-03-03 13:03:30'),(77358,228,'Ranimau','222139',1,0,'2022-03-03 13:03:30','2022-03-03 13:03:30'),(77359,228,'Ranipur','223104',1,0,'2022-03-03 13:03:30','2022-03-03 13:03:30'),(77360,228,'Rasmandal','222001',1,0,'2022-03-03 13:03:30','2022-03-03 13:03:30'),(77361,228,'Rasulpur','223102',1,0,'2022-03-03 13:03:30','2022-03-03 13:03:30'),(77362,228,'Ratnupur','222181',1,0,'2022-03-03 13:03:30','2022-03-03 13:03:30'),(77363,228,'Rithi','222131',1,0,'2022-03-03 13:03:30','2022-03-03 13:03:30'),(77364,228,'Rupaipur','222101',1,0,'2022-03-03 13:03:30','2022-03-03 13:03:30'),(77365,228,'Sabarhad','223101',1,0,'2022-03-03 13:03:30','2022-03-03 13:03:30'),(77366,228,'Sadanpur','222109',1,0,'2022-03-03 13:03:30','2022-03-03 13:03:30'),(77367,228,'Saderi','222109',1,0,'2022-03-03 13:03:30','2022-03-03 13:03:30'),(77368,228,'Saidpur Garaur','222003',1,0,'2022-03-03 13:03:30','2022-03-03 13:03:30'),(77369,228,'Samadhganj','222135',1,0,'2022-03-03 13:03:30','2022-03-03 13:03:30'),(77370,228,'Samodhpur','223102',1,0,'2022-03-03 13:03:30','2022-03-03 13:03:30'),(77371,228,'Sarai Durgadas','222125',1,0,'2022-03-03 13:03:30','2022-03-03 13:03:30'),(77372,228,'Saraibhogi','222201',1,0,'2022-03-03 13:03:30','2022-03-03 13:03:30'),(77373,228,'Saraibika','222202',1,0,'2022-03-03 13:03:30','2022-03-03 13:03:30'),(77374,228,'Saraiharakhu','222141',1,0,'2022-03-03 13:03:31','2022-03-03 13:03:31'),(77375,228,'Saraikhwaja','222003',1,0,'2022-03-03 13:03:31','2022-03-03 13:03:31'),(77376,228,'Saraimohiddin','223103',1,0,'2022-03-03 13:03:31','2022-03-03 13:03:31'),(77377,228,'Sarauni','222142',1,0,'2022-03-03 13:03:31','2022-03-03 13:03:31'),(77378,228,'Sarijahangirpatti','223105',1,0,'2022-03-03 13:03:31','2022-03-03 13:03:31'),(77379,228,'Sarpataha','223105',1,0,'2022-03-03 13:03:31','2022-03-03 13:03:31'),(77380,228,'Sarsara','222162',1,0,'2022-03-03 13:03:31','2022-03-03 13:03:31'),(77381,228,'Sauraia','223104',1,0,'2022-03-03 13:03:31','2022-03-03 13:03:31'),(77382,228,'Sehmalpur','222136',1,0,'2022-03-03 13:03:31','2022-03-03 13:03:31'),(77383,228,'Senapur','222148',1,0,'2022-03-03 13:03:31','2022-03-03 13:03:31'),(77384,228,'Seur','222161',1,0,'2022-03-03 13:03:31','2022-03-03 13:03:31'),(77385,228,'Sgrd College Dobhi','222149',1,0,'2022-03-03 13:03:31','2022-03-03 13:03:31'),(77386,228,'Shahganj (Jaunpur)','223101',1,0,'2022-03-03 13:03:31','2022-03-03 13:03:31'),(77387,228,'Shahganj Sugar Mill','223101',1,0,'2022-03-03 13:03:31','2022-03-03 13:03:31'),(77388,228,'Shahopatti','222127',1,0,'2022-03-03 13:03:31','2022-03-03 13:03:31'),(77389,228,'Shahpur','222125',1,0,'2022-03-03 13:03:31','2022-03-03 13:03:31'),(77390,228,'Shahpur','222131',1,0,'2022-03-03 13:03:31','2022-03-03 13:03:31'),(77391,228,'Shakarmandi','222001',1,0,'2022-03-03 13:03:31','2022-03-03 13:03:31'),(77392,228,'Shambhuganj','222132',1,0,'2022-03-03 13:03:31','2022-03-03 13:03:31'),(77393,228,'Shankarganj','222145',1,0,'2022-03-03 13:03:31','2022-03-03 13:03:31'),(77394,228,'Shastri Marg','222001',1,0,'2022-03-03 13:03:31','2022-03-03 13:03:31'),(77395,228,'Shekhpur Khutahani','222145',1,0,'2022-03-03 13:03:31','2022-03-03 13:03:31'),(77396,228,'Sherawan','222131',1,0,'2022-03-03 13:03:31','2022-03-03 13:03:31'),(77397,228,'Shitalganj','222161',1,0,'2022-03-03 13:03:31','2022-03-03 13:03:31'),(77398,228,'Shitla Chaukiya','222002',1,0,'2022-03-03 13:03:32','2022-03-03 13:03:32'),(77399,228,'Shivapar','222002',1,0,'2022-03-03 13:03:32','2022-03-03 13:03:32'),(77400,228,'Sieura','222135',1,0,'2022-03-03 13:03:32','2022-03-03 13:03:32'),(77401,228,'Sikrara','222131',1,0,'2022-03-03 13:03:32','2022-03-03 13:03:32'),(77402,228,'Singramau','222175',1,0,'2022-03-03 13:03:32','2022-03-03 13:03:32'),(77403,228,'Sirauli','222165',1,0,'2022-03-03 13:03:32','2022-03-03 13:03:32'),(77404,228,'Sirkina','222175',1,0,'2022-03-03 13:03:32','2022-03-03 13:03:32'),(77405,228,'Sirkoni','222136',1,0,'2022-03-03 13:03:32','2022-03-03 13:03:32'),(77406,228,'Sohani','222181',1,0,'2022-03-03 13:03:32','2022-03-03 13:03:32'),(77407,228,'Sohansa','222204',1,0,'2022-03-03 13:03:32','2022-03-03 13:03:32'),(77408,228,'Soithakalan','223105',1,0,'2022-03-03 13:03:32','2022-03-03 13:03:32'),(77409,228,'Sonahita','222144',1,0,'2022-03-03 13:03:32','2022-03-03 13:03:32'),(77410,228,'Songar','222139',1,0,'2022-03-03 13:03:32','2022-03-03 13:03:32'),(77411,228,'Sonikpur','222003',1,0,'2022-03-03 13:03:32','2022-03-03 13:03:32'),(77412,228,'Sotipur','222162',1,0,'2022-03-03 13:03:32','2022-03-03 13:03:32'),(77413,228,'Sudanipur','222161',1,0,'2022-03-03 13:03:32','2022-03-03 13:03:32'),(77414,228,'Sukhlalganj','222137',1,0,'2022-03-03 13:03:32','2022-03-03 13:03:32'),(77415,228,'Sultanpur','222201',1,0,'2022-03-03 13:03:32','2022-03-03 13:03:32'),(77416,228,'Sultanpur Ghughuri','223103',1,0,'2022-03-03 13:03:32','2022-03-03 13:03:32'),(77417,228,'Sureri','222203',1,0,'2022-03-03 13:03:32','2022-03-03 13:03:32'),(77418,228,'Suris','223101',1,0,'2022-03-03 13:03:32','2022-03-03 13:03:32'),(77419,228,'Sutahatti Bazar','222001',1,0,'2022-03-03 13:03:32','2022-03-03 13:03:32'),(77420,228,'T.D. College','222002',1,0,'2022-03-03 13:03:32','2022-03-03 13:03:32'),(77421,228,'Takha','223101',1,0,'2022-03-03 13:03:32','2022-03-03 13:03:32'),(77422,228,'Taraon','222149',1,0,'2022-03-03 13:03:33','2022-03-03 13:03:33'),(77423,228,'Tarati','222128',1,0,'2022-03-03 13:03:33','2022-03-03 13:03:33'),(77424,228,'Tejgarh','222137',1,0,'2022-03-03 13:03:33','2022-03-03 13:03:33'),(77425,228,'Tezi Bazar','222141',1,0,'2022-03-03 13:03:33','2022-03-03 13:03:33'),(77426,228,'Thakurganj','222175',1,0,'2022-03-03 13:03:33','2022-03-03 13:03:33'),(77427,228,'Thanagaddi','222181',1,0,'2022-03-03 13:03:33','2022-03-03 13:03:33'),(77428,228,'Tiara','222125',1,0,'2022-03-03 13:03:33','2022-03-03 13:03:33'),(77429,228,'Tikara','222204',1,0,'2022-03-03 13:03:33','2022-03-03 13:03:33'),(77430,228,'Tilora','222143',1,0,'2022-03-03 13:03:33','2022-03-03 13:03:33'),(77431,228,'Trilochan Badagaon','222136',1,0,'2022-03-03 13:03:33','2022-03-03 13:03:33'),(77432,228,'Udaichandpur','222181',1,0,'2022-03-03 13:03:33','2022-03-03 13:03:33'),(77433,228,'Udpur Ghelhawa','222125',1,0,'2022-03-03 13:03:33','2022-03-03 13:03:33'),(77434,228,'Ukani','222202',1,0,'2022-03-03 13:03:33','2022-03-03 13:03:33'),(77435,228,'Umari','222133',1,0,'2022-03-03 13:03:33','2022-03-03 13:03:33'),(77436,228,'Umari','222125',1,0,'2022-03-03 13:03:33','2022-03-03 13:03:33'),(77437,228,'Umarpur','222002',1,0,'2022-03-03 13:03:33','2022-03-03 13:03:33'),(77438,228,'Unchdih','222204',1,0,'2022-03-03 13:03:33','2022-03-03 13:03:33'),(77439,228,'Unchgaon','222201',1,0,'2022-03-03 13:03:33','2022-03-03 13:03:33'),(77440,228,'Unchgaon','223102',1,0,'2022-03-03 13:03:33','2022-03-03 13:03:33'),(77441,228,'Verdiha','222148',1,0,'2022-03-03 13:03:33','2022-03-03 13:03:33'),(77442,228,'Vijayeepur','222170',1,0,'2022-03-03 13:03:33','2022-03-03 13:03:33'),(77443,228,'Wazidpur','222203',1,0,'2022-03-03 13:03:33','2022-03-03 13:03:33'),(77444,228,'Zafarabad','222180',1,0,'2022-03-03 13:03:33','2022-03-03 13:03:33'),(77445,228,'Zamaitha','222180',1,0,'2022-03-03 13:03:33','2022-03-03 13:03:33'),(77446,229,'33 Bn. Pac Jhansi','284135',1,0,'2022-03-03 13:03:34','2022-03-03 13:03:34'),(77447,229,'Abbotganj','284003',1,0,'2022-03-03 13:03:34','2022-03-03 13:03:34'),(77448,229,'Ahiraura','284302',1,0,'2022-03-03 13:03:34','2022-03-03 13:03:34'),(77449,229,'Aivani','284204',1,0,'2022-03-03 13:03:34','2022-03-03 13:03:34'),(77450,229,'Akseo','284204',1,0,'2022-03-03 13:03:34','2022-03-03 13:03:34'),(77451,229,'Amanpura-war','284205',1,0,'2022-03-03 13:03:34','2022-03-03 13:03:34'),(77452,229,'Ambabai','284419',1,0,'2022-03-03 13:03:34','2022-03-03 13:03:34'),(77453,229,'Amgaon','284306',1,0,'2022-03-03 13:03:34','2022-03-03 13:03:34'),(77454,229,'Amra','284303',1,0,'2022-03-03 13:03:34','2022-03-03 13:03:34'),(77455,229,'Amrokh','284303',1,0,'2022-03-03 13:03:34','2022-03-03 13:03:34'),(77456,229,'Asta','284202',1,0,'2022-03-03 13:03:34','2022-03-03 13:03:34'),(77457,229,'Atariya','284303',1,0,'2022-03-03 13:03:34','2022-03-03 13:03:34'),(77458,229,'Aupara','284301',1,0,'2022-03-03 13:03:34','2022-03-03 13:03:34'),(77459,229,'Ayurvedic University','284003',1,0,'2022-03-03 13:03:34','2022-03-03 13:03:34'),(77460,229,'Babina Cantt.','284401',1,0,'2022-03-03 13:03:34','2022-03-03 13:03:34'),(77461,229,'Babina Town','284401',1,0,'2022-03-03 13:03:34','2022-03-03 13:03:34'),(77462,229,'Badokhari','284304',1,0,'2022-03-03 13:03:34','2022-03-03 13:03:34'),(77463,229,'Baghaira','284202',1,0,'2022-03-03 13:03:34','2022-03-03 13:03:34'),(77464,229,'Baidora','284401',1,0,'2022-03-03 13:03:34','2022-03-03 13:03:34'),(77465,229,'Bajhera','284301',1,0,'2022-03-03 13:03:34','2022-03-03 13:03:34'),(77466,229,'Bakwan','284303',1,0,'2022-03-03 13:03:34','2022-03-03 13:03:34'),(77467,229,'Bamaur','284202',1,0,'2022-03-03 13:03:34','2022-03-03 13:03:34'),(77468,229,'Bamhori','284204',1,0,'2022-03-03 13:03:34','2022-03-03 13:03:34'),(77469,229,'Bangra','284205',1,0,'2022-03-03 13:03:35','2022-03-03 13:03:35'),(77470,229,'Bangri','284202',1,0,'2022-03-03 13:03:35','2022-03-03 13:03:35'),(77471,229,'Banka Pahari','284204',1,0,'2022-03-03 13:03:35','2022-03-03 13:03:35'),(77472,229,'Bara Bazar (Jhansi)','284002',1,0,'2022-03-03 13:03:35','2022-03-03 13:03:35'),(77473,229,'Baragaon (Jhansi)','284121',1,0,'2022-03-03 13:03:35','2022-03-03 13:03:35'),(77474,229,'Baral','284301',1,0,'2022-03-03 13:03:35','2022-03-03 13:03:35'),(77475,229,'Baratakalan','284121',1,0,'2022-03-03 13:03:35','2022-03-03 13:03:35'),(77476,229,'Barauri','284204',1,0,'2022-03-03 13:03:35','2022-03-03 13:03:35'),(77477,229,'Barhwar','284206',1,0,'2022-03-03 13:03:35','2022-03-03 13:03:35'),(77478,229,'Barwasagar','284201',1,0,'2022-03-03 13:03:35','2022-03-03 13:03:35'),(77479,229,'Basobai','284303',1,0,'2022-03-03 13:03:35','2022-03-03 13:03:35'),(77480,229,'Belma Kalan','284303',1,0,'2022-03-03 13:03:35','2022-03-03 13:03:35'),(77481,229,'Berwai','284204',1,0,'2022-03-03 13:03:35','2022-03-03 13:03:35'),(77482,229,'Bhadarwara','284204',1,0,'2022-03-03 13:03:35','2022-03-03 13:03:35'),(77483,229,'Bhadarwara Khurd','284204',1,0,'2022-03-03 13:03:35','2022-03-03 13:03:35'),(77484,229,'Bhagwantpura','284127',1,0,'2022-03-03 13:03:35','2022-03-03 13:03:35'),(77485,229,'Bhandra Khilara','284204',1,0,'2022-03-03 13:03:35','2022-03-03 13:03:35'),(77486,229,'Bharosa','284303',1,0,'2022-03-03 13:03:35','2022-03-03 13:03:35'),(77487,229,'Bhasneh','284204',1,0,'2022-03-03 13:03:35','2022-03-03 13:03:35'),(77488,229,'Bhattagaon','284127',1,0,'2022-03-03 13:03:35','2022-03-03 13:03:35'),(77489,229,'BHEL (Jhansi)','284120',1,0,'2022-03-03 13:03:35','2022-03-03 13:03:35'),(77490,229,'Bheonraghat','284303',1,0,'2022-03-03 13:03:35','2022-03-03 13:03:35'),(77491,229,'Bhojala','284002',1,0,'2022-03-03 13:03:35','2022-03-03 13:03:35'),(77492,229,'Bijauli','284135',1,0,'2022-03-03 13:03:35','2022-03-03 13:03:35'),(77493,229,'Bijaura','284204',1,0,'2022-03-03 13:03:36','2022-03-03 13:03:36'),(77494,229,'Bijna','284206',1,0,'2022-03-03 13:03:36','2022-03-03 13:03:36'),(77495,229,'Bilati Karke','284302',1,0,'2022-03-03 13:03:36','2022-03-03 13:03:36'),(77496,229,'Birguwan','284121',1,0,'2022-03-03 13:03:36','2022-03-03 13:03:36'),(77497,229,'Bonda','284204',1,0,'2022-03-03 13:03:36','2022-03-03 13:03:36'),(77498,229,'Boodha','284002',1,0,'2022-03-03 13:03:36','2022-03-03 13:03:36'),(77499,229,'Bundelkhand University','284128',1,0,'2022-03-03 13:03:36','2022-03-03 13:03:36'),(77500,229,'Burhpura','284401',1,0,'2022-03-03 13:03:36','2022-03-03 13:03:36'),(77501,229,'C & W Workshop','284003',1,0,'2022-03-03 13:03:36','2022-03-03 13:03:36'),(77502,229,'Chamrauwa','284120',1,0,'2022-03-03 13:03:36','2022-03-03 13:03:36'),(77503,229,'Chanaoni','284401',1,0,'2022-03-03 13:03:36','2022-03-03 13:03:36'),(77504,229,'Chauraha Municipal Board','284001',1,0,'2022-03-03 13:03:36','2022-03-03 13:03:36'),(77505,229,'Chelra','284303',1,0,'2022-03-03 13:03:36','2022-03-03 13:03:36'),(77506,229,'Chheonta','284304',1,0,'2022-03-03 13:03:36','2022-03-03 13:03:36'),(77507,229,'Chirgaon Khurd','284304',1,0,'2022-03-03 13:03:36','2022-03-03 13:03:36'),(77508,229,'Chirgaon (Jhansi)','284301',1,0,'2022-03-03 13:03:36','2022-03-03 13:03:36'),(77509,229,'Churara','284204',1,0,'2022-03-03 13:03:36','2022-03-03 13:03:36'),(77510,229,'Dangarwaha','284419',1,0,'2022-03-03 13:03:36','2022-03-03 13:03:36'),(77511,229,'Deori Singhpura','284205',1,0,'2022-03-03 13:03:36','2022-03-03 13:03:36'),(77512,229,'Dhamna Payak','284204',1,0,'2022-03-03 13:03:36','2022-03-03 13:03:36'),(77513,229,'Dhamnakhurd','284121',1,0,'2022-03-03 13:03:36','2022-03-03 13:03:36'),(77514,229,'Dhanaura','284202',1,0,'2022-03-03 13:03:36','2022-03-03 13:03:36'),(77515,229,'Dhaurra','284204',1,0,'2022-03-03 13:03:36','2022-03-03 13:03:36'),(77516,229,'Dhawakar','284204',1,0,'2022-03-03 13:03:36','2022-03-03 13:03:36'),(77517,229,'Dhawari','284202',1,0,'2022-03-03 13:03:36','2022-03-03 13:03:36'),(77518,229,'Dhurwai','284206',1,0,'2022-03-03 13:03:37','2022-03-03 13:03:37'),(77519,229,'Dumrai','284203',1,0,'2022-03-03 13:03:37','2022-03-03 13:03:37'),(77520,229,'Erich','284302',1,0,'2022-03-03 13:03:37','2022-03-03 13:03:37'),(77521,229,'Gairaha','284205',1,0,'2022-03-03 13:03:37','2022-03-03 13:03:37'),(77522,229,'Garautha','284203',1,0,'2022-03-03 13:03:37','2022-03-03 13:03:37'),(77523,229,'Garhiagaon','284003',1,0,'2022-03-03 13:03:37','2022-03-03 13:03:37'),(77524,229,'Garhmau','284121',1,0,'2022-03-03 13:03:37','2022-03-03 13:03:37'),(77525,229,'Garhwai','284202',1,0,'2022-03-03 13:03:37','2022-03-03 13:03:37'),(77526,229,'Ghat Kotra','284204',1,0,'2022-03-03 13:03:37','2022-03-03 13:03:37'),(77527,229,'Ghat Lehchura','284204',1,0,'2022-03-03 13:03:37','2022-03-03 13:03:37'),(77528,229,'Ghisauli','284401',1,0,'2022-03-03 13:03:37','2022-03-03 13:03:37'),(77529,229,'Ghughuwa','284201',1,0,'2022-03-03 13:03:37','2022-03-03 13:03:37'),(77530,229,'Ghuraiya','284202',1,0,'2022-03-03 13:03:37','2022-03-03 13:03:37'),(77531,229,'Ghurat','284205',1,0,'2022-03-03 13:03:37','2022-03-03 13:03:37'),(77532,229,'Gokul','284202',1,0,'2022-03-03 13:03:37','2022-03-03 13:03:37'),(77533,229,'Gonti','284302',1,0,'2022-03-03 13:03:37','2022-03-03 13:03:37'),(77534,229,'Gursarai','284202',1,0,'2022-03-03 13:03:37','2022-03-03 13:03:37'),(77535,229,'Haiwatpura','284204',1,0,'2022-03-03 13:03:37','2022-03-03 13:03:37'),(77536,229,'Hasari','284135',1,0,'2022-03-03 13:03:37','2022-03-03 13:03:37'),(77537,229,'Isagarh','284002',1,0,'2022-03-03 13:03:37','2022-03-03 13:03:37'),(77538,229,'Iskil','284302',1,0,'2022-03-03 13:03:37','2022-03-03 13:03:37'),(77539,229,'Itayal','284204',1,0,'2022-03-03 13:03:37','2022-03-03 13:03:37'),(77540,229,'Jakhaura','284202',1,0,'2022-03-03 13:03:37','2022-03-03 13:03:37'),(77541,229,'Jaryai','284301',1,0,'2022-03-03 13:03:37','2022-03-03 13:03:37'),(77542,229,'Jaunra','284303',1,0,'2022-03-03 13:03:38','2022-03-03 13:03:38'),(77543,229,'Jhansi Cantt.','284001',1,0,'2022-03-03 13:03:38','2022-03-03 13:03:38'),(77544,229,'Jhansi City','284002',1,0,'2022-03-03 13:03:38','2022-03-03 13:03:38'),(77545,229,'Jhansi H.O','284001',1,0,'2022-03-03 13:03:38','2022-03-03 13:03:38'),(77546,229,'Jhansi Kutchery','284001',1,0,'2022-03-03 13:03:38','2022-03-03 13:03:38'),(77547,229,'Jhansi Railway Station','284003',1,0,'2022-03-03 13:03:38','2022-03-03 13:03:38'),(77548,229,'Jhansi Sadar Bazar','284001',1,0,'2022-03-03 13:03:38','2022-03-03 13:03:38'),(77549,229,'Jonri Buzurg','284121',1,0,'2022-03-03 13:03:38','2022-03-03 13:03:38'),(77550,229,'Kachir','284203',1,0,'2022-03-03 13:03:38','2022-03-03 13:03:38'),(77551,229,'Kachneo','284205',1,0,'2022-03-03 13:03:38','2022-03-03 13:03:38'),(77552,229,'Kakarwai','284203',1,0,'2022-03-03 13:03:38','2022-03-03 13:03:38'),(77553,229,'Kakwara','284204',1,0,'2022-03-03 13:03:38','2022-03-03 13:03:38'),(77554,229,'Karari','284003',1,0,'2022-03-03 13:03:38','2022-03-03 13:03:38'),(77555,229,'Karguwan','284301',1,0,'2022-03-03 13:03:38','2022-03-03 13:03:38'),(77556,229,'Karguwan Khurd','284202',1,0,'2022-03-03 13:03:38','2022-03-03 13:03:38'),(77557,229,'Karkos','284303',1,0,'2022-03-03 13:03:38','2022-03-03 13:03:38'),(77558,229,'Katera','284205',1,0,'2022-03-03 13:03:38','2022-03-03 13:03:38'),(77559,229,'Khadaura','284203',1,0,'2022-03-03 13:03:38','2022-03-03 13:03:38'),(77560,229,'Khailar','284120',1,0,'2022-03-03 13:03:38','2022-03-03 13:03:38'),(77561,229,'Khajraha Buzurg','284120',1,0,'2022-03-03 13:03:38','2022-03-03 13:03:38'),(77562,229,'Khajraha Khurd','284120',1,0,'2022-03-03 13:03:38','2022-03-03 13:03:38'),(77563,229,'Kharauwa','284303',1,0,'2022-03-03 13:03:38','2022-03-03 13:03:38'),(77564,229,'Khilli','284306',1,0,'2022-03-03 13:03:38','2022-03-03 13:03:38'),(77565,229,'Khisni Buzurg','284205',1,0,'2022-03-03 13:03:38','2022-03-03 13:03:38'),(77566,229,'Khushipura','284002',1,0,'2022-03-03 13:03:39','2022-03-03 13:03:39'),(77567,229,'Kochha Bhanwar','284128',1,0,'2022-03-03 13:03:39','2022-03-03 13:03:39'),(77568,229,'Kudri','284302',1,0,'2022-03-03 13:03:39','2022-03-03 13:03:39'),(77569,229,'Kudri','284202',1,0,'2022-03-03 13:03:39','2022-03-03 13:03:39'),(77570,229,'Kumhariya','284303',1,0,'2022-03-03 13:03:39','2022-03-03 13:03:39'),(77571,229,'Kumhrar','284303',1,0,'2022-03-03 13:03:39','2022-03-03 13:03:39'),(77572,229,'Kureecha','284204',1,0,'2022-03-03 13:03:39','2022-03-03 13:03:39'),(77573,229,'Kuretha','284202',1,0,'2022-03-03 13:03:39','2022-03-03 13:03:39'),(77574,229,'Labhera','284302',1,0,'2022-03-03 13:03:39','2022-03-03 13:03:39'),(77575,229,'Ladawra','284303',1,0,'2022-03-03 13:03:39','2022-03-03 13:03:39'),(77576,229,'Lahar Gird','284003',1,0,'2022-03-03 13:03:39','2022-03-03 13:03:39'),(77577,229,'Lal Kurti Bazar','284001',1,0,'2022-03-03 13:03:39','2022-03-03 13:03:39'),(77578,229,'Lawan','284303',1,0,'2022-03-03 13:03:39','2022-03-03 13:03:39'),(77579,229,'Lohagarh','285205',1,0,'2022-03-03 13:03:39','2022-03-03 13:03:39'),(77580,229,'Luhari','284205',1,0,'2022-03-03 13:03:39','2022-03-03 13:03:39'),(77581,229,'Magarpur','284205',1,0,'2022-03-03 13:03:39','2022-03-03 13:03:39'),(77582,229,'Mahewa','284204',1,0,'2022-03-03 13:03:39','2022-03-03 13:03:39'),(77583,229,'Manpura','284401',1,0,'2022-03-03 13:03:39','2022-03-03 13:03:39'),(77584,229,'Markuan','284204',1,0,'2022-03-03 13:03:39','2022-03-03 13:03:39'),(77585,229,'Mathurapura','284120',1,0,'2022-03-03 13:03:39','2022-03-03 13:03:39'),(77586,229,'Mauranipur Bus Stand','284204',1,0,'2022-03-03 13:03:39','2022-03-03 13:03:39'),(77587,229,'Mauranipur','284204',1,0,'2022-03-03 13:03:40','2022-03-03 13:03:40'),(77588,229,'Mlb Medical College','284128',1,0,'2022-03-03 13:03:40','2022-03-03 13:03:40'),(77589,229,'Moth','284303',1,0,'2022-03-03 13:03:40','2022-03-03 13:03:40'),(77590,229,'Moti Katra','284203',1,0,'2022-03-03 13:03:40','2022-03-03 13:03:40'),(77591,229,'Nagara','284123',1,0,'2022-03-03 13:03:40','2022-03-03 13:03:40'),(77592,229,'Nagra','284202',1,0,'2022-03-03 13:03:40','2022-03-03 13:03:40'),(77593,229,'Nai Basti','284002',1,0,'2022-03-03 13:03:40','2022-03-03 13:03:40'),(77594,229,'Nandkhas','284303',1,0,'2022-03-03 13:03:40','2022-03-03 13:03:40'),(77595,229,'Nari','284306',1,0,'2022-03-03 13:03:40','2022-03-03 13:03:40'),(77596,229,'Naria Bazar','284002',1,0,'2022-03-03 13:03:40','2022-03-03 13:03:40'),(77597,229,'Nauta','284202',1,0,'2022-03-03 13:03:40','2022-03-03 13:03:40'),(77598,229,'Nayakhera','284401',1,0,'2022-03-03 13:03:40','2022-03-03 13:03:40'),(77599,229,'Orchha Gate','284002',1,0,'2022-03-03 13:03:40','2022-03-03 13:03:40'),(77600,229,'Padra','284205',1,0,'2022-03-03 13:03:40','2022-03-03 13:03:40'),(77601,229,'Pahari Buzurg','284301',1,0,'2022-03-03 13:03:40','2022-03-03 13:03:40'),(77602,229,'Palar','284121',1,0,'2022-03-03 13:03:40','2022-03-03 13:03:40'),(77603,229,'Pali Pahari','284419',1,0,'2022-03-03 13:03:40','2022-03-03 13:03:40'),(77604,229,'Palra','284205',1,0,'2022-03-03 13:03:40','2022-03-03 13:03:40'),(77605,229,'Pandori','284303',1,0,'2022-03-03 13:03:40','2022-03-03 13:03:40'),(77606,229,'Pandwaha','284206',1,0,'2022-03-03 13:03:40','2022-03-03 13:03:40'),(77607,229,'Parichha Thermal Power Project','284305',1,0,'2022-03-03 13:03:40','2022-03-03 13:03:40'),(77608,229,'Pasaura','284206',1,0,'2022-03-03 13:03:40','2022-03-03 13:03:40'),(77609,229,'Patha','284405',1,0,'2022-03-03 13:03:40','2022-03-03 13:03:40'),(77610,229,'Patha','284302',1,0,'2022-03-03 13:03:41','2022-03-03 13:03:41'),(77611,229,'Patha Dhakarwara','284204',1,0,'2022-03-03 13:03:41','2022-03-03 13:03:41'),(77612,229,'Pathguwan','284205',1,0,'2022-03-03 13:03:41','2022-03-03 13:03:41'),(77613,229,'Patti Kumharra','284303',1,0,'2022-03-03 13:03:41','2022-03-03 13:03:41'),(77614,229,'Poonchh','284306',1,0,'2022-03-03 13:03:41','2022-03-03 13:03:41'),(77615,229,'Premnagar (Jhansi)','284003',1,0,'2022-03-03 13:03:41','2022-03-03 13:03:41'),(77616,229,'Pulia','284303',1,0,'2022-03-03 13:03:41','2022-03-03 13:03:41'),(77617,229,'Punaoli Kalan','284419',1,0,'2022-03-03 13:03:41','2022-03-03 13:03:41'),(77618,229,'Rajapur','284419',1,0,'2022-03-03 13:03:41','2022-03-03 13:03:41'),(77619,229,'Raksa','284419',1,0,'2022-03-03 13:03:41','2022-03-03 13:03:41'),(77620,229,'Ram Nagar','284301',1,0,'2022-03-03 13:03:41','2022-03-03 13:03:41'),(77621,229,'Rampura Kirwaha','285125',1,0,'2022-03-03 13:03:41','2022-03-03 13:03:41'),(77622,229,'Ranguwan','284121',1,0,'2022-03-03 13:03:41','2022-03-03 13:03:41'),(77623,229,'Ranipur (Jhansi)','284205',1,0,'2022-03-03 13:03:41','2022-03-03 13:03:41'),(77624,229,'Ratausa','284205',1,0,'2022-03-03 13:03:41','2022-03-03 13:03:41'),(77625,229,'Reo','284303',1,0,'2022-03-03 13:03:41','2022-03-03 13:03:41'),(77626,229,'Rewan','284204',1,0,'2022-03-03 13:03:41','2022-03-03 13:03:41'),(77627,229,'Roni Baragaon','284204',1,0,'2022-03-03 13:03:41','2022-03-03 13:03:41'),(77628,229,'Rora Bhatpura','284204',1,0,'2022-03-03 13:03:41','2022-03-03 13:03:41'),(77629,229,'Rupa Dhamna','284204',1,0,'2022-03-03 13:03:41','2022-03-03 13:03:41'),(77630,229,'Sainyargate','284002',1,0,'2022-03-03 13:03:42','2022-03-03 13:03:42'),(77631,229,'Saipura','284204',1,0,'2022-03-03 13:03:42','2022-03-03 13:03:42'),(77632,229,'Sakin','284304',1,0,'2022-03-03 13:03:42','2022-03-03 13:03:42'),(77633,229,'Sakrar','284205',1,0,'2022-03-03 13:03:42','2022-03-03 13:03:42'),(77634,229,'Samthar','284304',1,0,'2022-03-03 13:03:42','2022-03-03 13:03:42'),(77635,229,'Sarol','284121',1,0,'2022-03-03 13:03:42','2022-03-03 13:03:42'),(77636,229,'Sarsenda','284202',1,0,'2022-03-03 13:03:42','2022-03-03 13:03:42'),(77637,229,'Semri','284303',1,0,'2022-03-03 13:03:42','2022-03-03 13:03:42'),(77638,229,'Sersa','284306',1,0,'2022-03-03 13:03:42','2022-03-03 13:03:42'),(77639,229,'Sesha','284306',1,0,'2022-03-03 13:03:42','2022-03-03 13:03:42'),(77640,229,'Shahjahanpur','284303',1,0,'2022-03-03 13:03:42','2022-03-03 13:03:42'),(77641,229,'Siaoni Khurd','284205',1,0,'2022-03-03 13:03:42','2022-03-03 13:03:42'),(77642,229,'Siaori','284204',1,0,'2022-03-03 13:03:42','2022-03-03 13:03:42'),(77643,229,'Sijari Buzurg','284204',1,0,'2022-03-03 13:03:42','2022-03-03 13:03:42'),(77644,229,'Simardha','284203',1,0,'2022-03-03 13:03:42','2022-03-03 13:03:42'),(77645,229,'Simraha','284127',1,0,'2022-03-03 13:03:42','2022-03-03 13:03:42'),(77646,229,'Simthari','284301',1,0,'2022-03-03 13:03:42','2022-03-03 13:03:42'),(77647,229,'Sipri Bazar','284003',1,0,'2022-03-03 13:03:42','2022-03-03 13:03:42'),(77648,229,'Siya','284301',1,0,'2022-03-03 13:03:42','2022-03-03 13:03:42'),(77649,229,'Siya Kharka','284203',1,0,'2022-03-03 13:03:42','2022-03-03 13:03:42'),(77650,229,'Soot Bazar','284204',1,0,'2022-03-03 13:03:42','2022-03-03 13:03:42'),(77651,229,'Subhashganj','284002',1,0,'2022-03-03 13:03:42','2022-03-03 13:03:42'),(77652,229,'Sutta','284202',1,0,'2022-03-03 13:03:42','2022-03-03 13:03:42'),(77653,229,'Taindol','284201',1,0,'2022-03-03 13:03:43','2022-03-03 13:03:43'),(77654,229,'Talaud','284303',1,0,'2022-03-03 13:03:43','2022-03-03 13:03:43'),(77655,229,'Tehrauli','284202',1,0,'2022-03-03 13:03:43','2022-03-03 13:03:43'),(77656,229,'Tori','284303',1,0,'2022-03-03 13:03:43','2022-03-03 13:03:43'),(77657,229,'Tori Fatehpur','284206',1,0,'2022-03-03 13:03:43','2022-03-03 13:03:43'),(77658,229,'Ujyan','284121',1,0,'2022-03-03 13:03:43','2022-03-03 13:03:43'),(77659,229,'Uldan','284205',1,0,'2022-03-03 13:03:43','2022-03-03 13:03:43'),(77660,229,'Vijay Garh','284205',1,0,'2022-03-03 13:03:43','2022-03-03 13:03:43'),(77661,230,'Adampur','244255',1,0,'2022-03-03 13:03:43','2022-03-03 13:03:43'),(77662,230,'Ahraula Mafi','244231',1,0,'2022-03-03 13:03:43','2022-03-03 13:03:43'),(77663,230,'Akbarpur Sihali','244501',1,0,'2022-03-03 13:03:43','2022-03-03 13:03:43'),(77664,230,'Amroha Bazar','244221',1,0,'2022-03-03 13:03:43','2022-03-03 13:03:43'),(77665,230,'Amroha H.O','244221',1,0,'2022-03-03 13:03:43','2022-03-03 13:03:43'),(77666,230,'Amroha Shahi Chabutra','244221',1,0,'2022-03-03 13:03:43','2022-03-03 13:03:43'),(77667,230,'Anchora  Kamboh','244304',1,0,'2022-03-03 13:03:43','2022-03-03 13:03:43'),(77668,230,'Asmoli','244304',1,0,'2022-03-03 13:03:43','2022-03-03 13:03:43'),(77669,230,'Atrasikalan','244236',1,0,'2022-03-03 13:03:43','2022-03-03 13:03:43'),(77670,230,'Awalpur','244251',1,0,'2022-03-03 13:03:43','2022-03-03 13:03:43'),(77671,230,'Bachhraon','244225',1,0,'2022-03-03 13:03:43','2022-03-03 13:03:43'),(77672,230,'Bahadur Pur Khurd','244221',1,0,'2022-03-03 13:03:43','2022-03-03 13:03:43'),(77673,230,'Bajnaura','244242',1,0,'2022-03-03 13:03:43','2022-03-03 13:03:43'),(77674,230,'Bartaura','244255',1,0,'2022-03-03 13:03:43','2022-03-03 13:03:43'),(77675,230,'Basera Taga','244501',1,0,'2022-03-03 13:03:43','2022-03-03 13:03:43'),(77676,230,'Bhartiya Gram','244223',1,0,'2022-03-03 13:03:43','2022-03-03 13:03:43'),(77677,230,'Bibra Khurd','244501',1,0,'2022-03-03 13:03:43','2022-03-03 13:03:43'),(77678,230,'Bijaura','244235',1,0,'2022-03-03 13:03:43','2022-03-03 13:03:43'),(77679,230,'Buderna','244221',1,0,'2022-03-03 13:03:44','2022-03-03 13:03:44'),(77680,230,'Burawali','244241',1,0,'2022-03-03 13:03:44','2022-03-03 13:03:44'),(77681,230,'Chakanwala','244225',1,0,'2022-03-03 13:03:44','2022-03-03 13:03:44'),(77682,230,'Chakooni','244242',1,0,'2022-03-03 13:03:44','2022-03-03 13:03:44'),(77683,230,'Chand Nagar','244236',1,0,'2022-03-03 13:03:44','2022-03-03 13:03:44'),(77684,230,'Chhapna','244255',1,0,'2022-03-03 13:03:44','2022-03-03 13:03:44'),(77685,230,'Chuchelakalan','244231',1,0,'2022-03-03 13:03:44','2022-03-03 13:03:44'),(77686,230,'Dahpa','244242',1,0,'2022-03-03 13:03:44','2022-03-03 13:03:44'),(77687,230,'Darhyal Khadar','244255',1,0,'2022-03-03 13:03:44','2022-03-03 13:03:44'),(77688,230,'Deorhi Urf Hadipur','244102',1,0,'2022-03-03 13:03:44','2022-03-03 13:03:44'),(77689,230,'Dhakka','244242',1,0,'2022-03-03 13:03:44','2022-03-03 13:03:44'),(77690,230,'Dhanaura','244231',1,0,'2022-03-03 13:03:44','2022-03-03 13:03:44'),(77691,230,'Dhauti','244225',1,0,'2022-03-03 13:03:44','2022-03-03 13:03:44'),(77692,230,'Dhawarsi','244242',1,0,'2022-03-03 13:03:44','2022-03-03 13:03:44'),(77693,230,'Didauli','244222',1,0,'2022-03-03 13:03:44','2022-03-03 13:03:44'),(77694,230,'Dingra','244231',1,0,'2022-03-03 13:03:44','2022-03-03 13:03:44'),(77695,230,'Gajana','244221',1,0,'2022-03-03 13:03:44','2022-03-03 13:03:44'),(77696,230,'Gajasthal','244251',1,0,'2022-03-03 13:03:44','2022-03-03 13:03:44'),(77697,230,'Gajraula','244235',1,0,'2022-03-03 13:03:44','2022-03-03 13:03:44'),(77698,230,'Gangacholi','244241',1,0,'2022-03-03 13:03:44','2022-03-03 13:03:44'),(77699,230,'Gangeshwari','244255',1,0,'2022-03-03 13:03:44','2022-03-03 13:03:44'),(77700,230,'Gangwar','244241',1,0,'2022-03-03 13:03:44','2022-03-03 13:03:44'),(77701,230,'Garhi Salempur','244501',1,0,'2022-03-03 13:03:45','2022-03-03 13:03:45'),(77702,230,'Gularia','244221',1,0,'2022-03-03 13:03:45','2022-03-03 13:03:45'),(77703,230,'Hajarpur Jamania','244221',1,0,'2022-03-03 13:03:45','2022-03-03 13:03:45'),(77704,230,'Hasanpur (Jyotiba Phule Nagar)','244241',1,0,'2022-03-03 13:03:45','2022-03-03 13:03:45'),(77705,230,'Imratpur','244255',1,0,'2022-03-03 13:03:45','2022-03-03 13:03:45'),(77706,230,'Iqbalpur Urf Kamelpor','244231',1,0,'2022-03-03 13:03:45','2022-03-03 13:03:45'),(77707,230,'Jahangirpur Chakpheri','244501',1,0,'2022-03-03 13:03:45','2022-03-03 13:03:45'),(77708,230,'Jahtauli','244255',1,0,'2022-03-03 13:03:45','2022-03-03 13:03:45'),(77709,230,'Jajroo','244251',1,0,'2022-03-03 13:03:45','2022-03-03 13:03:45'),(77710,230,'Jalajpur Dhana','244221',1,0,'2022-03-03 13:03:45','2022-03-03 13:03:45'),(77711,230,'Jamna Khas','244501',1,0,'2022-03-03 13:03:45','2022-03-03 13:03:45'),(77712,230,'Joya','244222',1,0,'2022-03-03 13:03:45','2022-03-03 13:03:45'),(77713,230,'Kadral','244251',1,0,'2022-03-03 13:03:45','2022-03-03 13:03:45'),(77714,230,'Kail Bakri','244501',1,0,'2022-03-03 13:03:45','2022-03-03 13:03:45'),(77715,230,'Kailsa','244221',1,0,'2022-03-03 13:03:45','2022-03-03 13:03:45'),(77716,230,'Kankather','244235',1,0,'2022-03-03 13:03:45','2022-03-03 13:03:45'),(77717,230,'Kapsua','244231',1,0,'2022-03-03 13:03:45','2022-03-03 13:03:45'),(77718,230,'Karaundi','244236',1,0,'2022-03-03 13:03:45','2022-03-03 13:03:45'),(77719,230,'Kauralla','244231',1,0,'2022-03-03 13:03:45','2022-03-03 13:03:45'),(77720,230,'Khadgujar','244235',1,0,'2022-03-03 13:03:45','2022-03-03 13:03:45'),(77721,230,'Khajuri','244236',1,0,'2022-03-03 13:03:45','2022-03-03 13:03:45'),(77722,230,'Khera Apraula','244251',1,0,'2022-03-03 13:03:45','2022-03-03 13:03:45'),(77723,230,'Kothi Khidmatpur','244501',1,0,'2022-03-03 13:03:46','2022-03-03 13:03:46'),(77724,230,'Kundan Nagar','244245',1,0,'2022-03-03 13:03:46','2022-03-03 13:03:46'),(77725,230,'Kundarki Bhoor','244242',1,0,'2022-03-03 13:03:46','2022-03-03 13:03:46'),(77726,230,'Kuri Rawana','244501',1,0,'2022-03-03 13:03:46','2022-03-03 13:03:46'),(77727,230,'Ladanpur','244231',1,0,'2022-03-03 13:03:46','2022-03-03 13:03:46'),(77728,230,'Lakarhat','244501',1,0,'2022-03-03 13:03:46','2022-03-03 13:03:46'),(77729,230,'Lohari Bhoor','244242',1,0,'2022-03-03 13:03:46','2022-03-03 13:03:46'),(77730,230,'M. B. Hasanpur','244241',1,0,'2022-03-03 13:03:46','2022-03-03 13:03:46'),(77731,230,'Madhpur','244501',1,0,'2022-03-03 13:03:46','2022-03-03 13:03:46'),(77732,230,'Maheshra','244236',1,0,'2022-03-03 13:03:46','2022-03-03 13:03:46'),(77733,230,'Makhdoompur','244251',1,0,'2022-03-03 13:03:46','2022-03-03 13:03:46'),(77734,230,'Mangraula','244241',1,0,'2022-03-03 13:03:46','2022-03-03 13:03:46'),(77735,230,'Matlabpur Sadarpur','244501',1,0,'2022-03-03 13:03:46','2022-03-03 13:03:46'),(77736,230,'Mohd.Pur Mafi','244501',1,0,'2022-03-03 13:03:46','2022-03-03 13:03:46'),(77737,230,'Mundha Khera','244221',1,0,'2022-03-03 13:03:46','2022-03-03 13:03:46'),(77738,230,'Nagliamev','244235',1,0,'2022-03-03 13:03:46','2022-03-03 13:03:46'),(77739,230,'Nanhera Aliarpur','244221',1,0,'2022-03-03 13:03:46','2022-03-03 13:03:46'),(77740,230,'Nawgawan','244251',1,0,'2022-03-03 13:03:46','2022-03-03 13:03:46'),(77741,230,'Osa Mafi','244242',1,0,'2022-03-03 13:03:46','2022-03-03 13:03:46'),(77742,230,'Palaula','244222',1,0,'2022-03-03 13:03:46','2022-03-03 13:03:46'),(77743,230,'Papsara','244221',1,0,'2022-03-03 13:03:46','2022-03-03 13:03:46'),(77744,230,'Papsari','244231',1,0,'2022-03-03 13:03:46','2022-03-03 13:03:46'),(77745,230,'Patai Bhoor','244241',1,0,'2022-03-03 13:03:46','2022-03-03 13:03:46'),(77746,230,'Pathangi','244501',1,0,'2022-03-03 13:03:47','2022-03-03 13:03:47'),(77747,230,'Paurara','244255',1,0,'2022-03-03 13:03:47','2022-03-03 13:03:47'),(77748,230,'Phanderi','244231',1,0,'2022-03-03 13:03:47','2022-03-03 13:03:47'),(77749,230,'Pipalidaud','244241',1,0,'2022-03-03 13:03:47','2022-03-03 13:03:47'),(77750,230,'Piplikalan','244236',1,0,'2022-03-03 13:03:47','2022-03-03 13:03:47'),(77751,230,'Qazi Sarai Urf Kankar Sarai','244221',1,0,'2022-03-03 13:03:47','2022-03-03 13:03:47'),(77752,230,'Rajab Pur','244236',1,0,'2022-03-03 13:03:47','2022-03-03 13:03:47'),(77753,230,'Rehra','244255',1,0,'2022-03-03 13:03:47','2022-03-03 13:03:47'),(77754,230,'S.R. Dhanaura','244231',1,0,'2022-03-03 13:03:47','2022-03-03 13:03:47'),(77755,230,'Saghan Machharya','244222',1,0,'2022-03-03 13:03:47','2022-03-03 13:03:47'),(77756,230,'Said Nagli','244242',1,0,'2022-03-03 13:03:47','2022-03-03 13:03:47'),(77757,230,'Salempurgosai','244235',1,0,'2022-03-03 13:03:47','2022-03-03 13:03:47'),(77758,230,'Sarkara Kamal','244222',1,0,'2022-03-03 13:03:47','2022-03-03 13:03:47'),(77759,230,'Sarkari  Ajij','244222',1,0,'2022-03-03 13:03:47','2022-03-03 13:03:47'),(77760,230,'Sherpur','244225',1,0,'2022-03-03 13:03:47','2022-03-03 13:03:47'),(77761,230,'Sihalijagir','244241',1,0,'2022-03-03 13:03:47','2022-03-03 13:03:47'),(77762,230,'Sohat','244242',1,0,'2022-03-03 13:03:47','2022-03-03 13:03:47'),(77763,230,'Telipurmali','244221',1,0,'2022-03-03 13:03:47','2022-03-03 13:03:47'),(77764,230,'Tigree','244235',1,0,'2022-03-03 13:03:47','2022-03-03 13:03:47'),(77765,230,'Tohfapur Bhawanipur','244222',1,0,'2022-03-03 13:03:47','2022-03-03 13:03:47'),(77766,230,'Tomra','244225',1,0,'2022-03-03 13:03:47','2022-03-03 13:03:47'),(77767,230,'Ujhari','244242',1,0,'2022-03-03 13:03:48','2022-03-03 13:03:48'),(77768,230,'Umari Kalan','244501',1,0,'2022-03-03 13:03:48','2022-03-03 13:03:48'),(77769,230,'Umari Sabzi Pur','244102',1,0,'2022-03-03 13:03:48','2022-03-03 13:03:48'),(77770,230,'Wasipur','244231',1,0,'2022-03-03 13:03:48','2022-03-03 13:03:48'),(77771,230,'Yaqubpur','244241',1,0,'2022-03-03 13:03:48','2022-03-03 13:03:48'),(77772,231,'Agaus','209723',1,0,'2022-03-03 13:03:48','2022-03-03 13:03:48'),(77773,231,'Amolar','209731',1,0,'2022-03-03 13:03:48','2022-03-03 13:03:48'),(77774,231,'Anaugi','209733',1,0,'2022-03-03 13:03:48','2022-03-03 13:03:48'),(77775,231,'Aruha','209728',1,0,'2022-03-03 13:03:48','2022-03-03 13:03:48'),(77776,231,'Asaltabad','209720',1,0,'2022-03-03 13:03:48','2022-03-03 13:03:48'),(77777,231,'Aseha','209729',1,0,'2022-03-03 13:03:48','2022-03-03 13:03:48'),(77778,231,'Auser','209736',1,0,'2022-03-03 13:03:48','2022-03-03 13:03:48'),(77779,231,'Bahadurpur Majhgaon','209728',1,0,'2022-03-03 13:03:48','2022-03-03 13:03:48'),(77780,231,'Bahbalpur','209721',1,0,'2022-03-03 13:03:48','2022-03-03 13:03:48'),(77781,231,'Bahosi','209723',1,0,'2022-03-03 13:03:48','2022-03-03 13:03:48'),(77782,231,'Balanpur','209732',1,0,'2022-03-03 13:03:48','2022-03-03 13:03:48'),(77783,231,'Bamrauli','209731',1,0,'2022-03-03 13:03:48','2022-03-03 13:03:48'),(77784,231,'Bangawan Kharg','209728',1,0,'2022-03-03 13:03:48','2022-03-03 13:03:48'),(77785,231,'Barauli','209727',1,0,'2022-03-03 13:03:48','2022-03-03 13:03:48'),(77786,231,'Basta','209732',1,0,'2022-03-03 13:03:48','2022-03-03 13:03:48'),(77787,231,'Bazaria Chhibramau','209721',1,0,'2022-03-03 13:03:48','2022-03-03 13:03:48'),(77788,231,'Behrin','209732',1,0,'2022-03-03 13:03:48','2022-03-03 13:03:48'),(77789,231,'Behta Rampur','209728',1,0,'2022-03-03 13:03:48','2022-03-03 13:03:48'),(77790,231,'Belamau Saraiya','209723',1,0,'2022-03-03 13:03:49','2022-03-03 13:03:49'),(77791,231,'Bhadausi','209734',1,0,'2022-03-03 13:03:49','2022-03-03 13:03:49'),(77792,231,'Bhadehi','209720',1,0,'2022-03-03 13:03:49','2022-03-03 13:03:49'),(77793,231,'Bhagwantpur','209723',1,0,'2022-03-03 13:03:49','2022-03-03 13:03:49'),(77794,231,'Bhaunrajpur','209720',1,0,'2022-03-03 13:03:49','2022-03-03 13:03:49'),(77795,231,'Bhunna','209734',1,0,'2022-03-03 13:03:49','2022-03-03 13:03:49'),(77796,231,'Bibia Jalalpur','209729',1,0,'2022-03-03 13:03:49','2022-03-03 13:03:49'),(77797,231,'Binaura Rampur','209736',1,0,'2022-03-03 13:03:49','2022-03-03 13:03:49'),(77798,231,'Birpur','209747',1,0,'2022-03-03 13:03:49','2022-03-03 13:03:49'),(77799,231,'Bishungarh (Kannauj)','209720',1,0,'2022-03-03 13:03:49','2022-03-03 13:03:49'),(77800,231,'Chanderpur','209729',1,0,'2022-03-03 13:03:49','2022-03-03 13:03:49'),(77801,231,'Chapunna','209728',1,0,'2022-03-03 13:03:49','2022-03-03 13:03:49'),(77802,231,'Chhibramau','209721',1,0,'2022-03-03 13:03:49','2022-03-03 13:03:49'),(77803,231,'Chhipatti','209725',1,0,'2022-03-03 13:03:49','2022-03-03 13:03:49'),(77804,231,'Dadauna','209747',1,0,'2022-03-03 13:03:49','2022-03-03 13:03:49'),(77805,231,'Deodha','209738',1,0,'2022-03-03 13:03:49','2022-03-03 13:03:49'),(77806,231,'Dundwabuzurg','209722',1,0,'2022-03-03 13:03:49','2022-03-03 13:03:49'),(77807,231,'Fatehpur','209733',1,0,'2022-03-03 13:03:49','2022-03-03 13:03:49'),(77808,231,'Ferozpur','209738',1,0,'2022-03-03 13:03:49','2022-03-03 13:03:49'),(77809,231,'Galla Mandi CBR','209721',1,0,'2022-03-03 13:03:49','2022-03-03 13:03:49'),(77810,231,'Gangemau','209727',1,0,'2022-03-03 13:03:49','2022-03-03 13:03:49'),(77811,231,'Godhani','209727',1,0,'2022-03-03 13:03:50','2022-03-03 13:03:50'),(77812,231,'Gugrapur','209733',1,0,'2022-03-03 13:03:50','2022-03-03 13:03:50'),(77813,231,'Gulariyapur','209728',1,0,'2022-03-03 13:03:50','2022-03-03 13:03:50'),(77814,231,'Gurusahaiganj','209722',1,0,'2022-03-03 13:03:50','2022-03-03 13:03:50'),(77815,231,'Gyaspur','209728',1,0,'2022-03-03 13:03:50','2022-03-03 13:03:50'),(77816,231,'Hamirpur','209736',1,0,'2022-03-03 13:03:50','2022-03-03 13:03:50'),(77817,231,'Haraipur','209736',1,0,'2022-03-03 13:03:50','2022-03-03 13:03:50'),(77818,231,'Hari Nagar (Kannauj)','209725',1,0,'2022-03-03 13:03:50','2022-03-03 13:03:50'),(77819,231,'Hariharpur','209720',1,0,'2022-03-03 13:03:50','2022-03-03 13:03:50'),(77820,231,'Haseran','209728',1,0,'2022-03-03 13:03:50','2022-03-03 13:03:50'),(77821,231,'Hathin','209721',1,0,'2022-03-03 13:03:50','2022-03-03 13:03:50'),(77822,231,'Ibrahimpur Zagir','209727',1,0,'2022-03-03 13:03:50','2022-03-03 13:03:50'),(77823,231,'Indergarh (Kannauj)','209723',1,0,'2022-03-03 13:03:50','2022-03-03 13:03:50'),(77824,231,'Ishampur','209728',1,0,'2022-03-03 13:03:50','2022-03-03 13:03:50'),(77825,231,'Ismailpur','209722',1,0,'2022-03-03 13:03:50','2022-03-03 13:03:50'),(77826,231,'Jafrabad','209721',1,0,'2022-03-03 13:03:50','2022-03-03 13:03:50'),(77827,231,'Jalalabad (Kannauj)','209733',1,0,'2022-03-03 13:03:50','2022-03-03 13:03:50'),(77828,231,'Jalalpur Panwara','209727',1,0,'2022-03-03 13:03:50','2022-03-03 13:03:50'),(77829,231,'Jankhat','209736',1,0,'2022-03-03 13:03:50','2022-03-03 13:03:50'),(77830,231,'Jasmai','209720',1,0,'2022-03-03 13:03:50','2022-03-03 13:03:50'),(77831,231,'Jaspura Pur','209727',1,0,'2022-03-03 13:03:50','2022-03-03 13:03:50'),(77832,231,'Jeramau Alampur','209731',1,0,'2022-03-03 13:03:50','2022-03-03 13:03:50'),(77833,231,'Jewan','209733',1,0,'2022-03-03 13:03:51','2022-03-03 13:03:51'),(77834,231,'Jot','209720',1,0,'2022-03-03 13:03:51','2022-03-03 13:03:51'),(77835,231,'K. P. Banwari','209721',1,0,'2022-03-03 13:03:51','2022-03-03 13:03:51'),(77836,231,'Kaitholi','209720',1,0,'2022-03-03 13:03:51','2022-03-03 13:03:51'),(77837,231,'Kalsan','209723',1,0,'2022-03-03 13:03:51','2022-03-03 13:03:51'),(77838,231,'Kannauj','209725',1,0,'2022-03-03 13:03:51','2022-03-03 13:03:51'),(77839,231,'Kannauj Samachar','209725',1,0,'2022-03-03 13:03:51','2022-03-03 13:03:51'),(77840,231,'Kasawa','209721',1,0,'2022-03-03 13:03:51','2022-03-03 13:03:51'),(77841,231,'Khadini','209728',1,0,'2022-03-03 13:03:51','2022-03-03 13:03:51'),(77842,231,'Khairnagar','209736',1,0,'2022-03-03 13:03:51','2022-03-03 13:03:51'),(77843,231,'Khama','209734',1,0,'2022-03-03 13:03:51','2022-03-03 13:03:51'),(77844,231,'Khanpur','209738',1,0,'2022-03-03 13:03:51','2022-03-03 13:03:51'),(77845,231,'Khojipur','209721',1,0,'2022-03-03 13:03:51','2022-03-03 13:03:51'),(77846,231,'Khubariapur','209721',1,0,'2022-03-03 13:03:51','2022-03-03 13:03:51'),(77847,231,'Kiratpur','209733',1,0,'2022-03-03 13:03:51','2022-03-03 13:03:51'),(77848,231,'Kisai Jagdishpur','209728',1,0,'2022-03-03 13:03:51','2022-03-03 13:03:51'),(77849,231,'Kudhina','209738',1,0,'2022-03-03 13:03:51','2022-03-03 13:03:51'),(77850,231,'Kulhapur','209733',1,0,'2022-03-03 13:03:51','2022-03-03 13:03:51'),(77851,231,'Kushum Khor','209727',1,0,'2022-03-03 13:03:51','2022-03-03 13:03:51'),(77852,231,'Lakh','209723',1,0,'2022-03-03 13:03:51','2022-03-03 13:03:51'),(77853,231,'Lohamarh','209732',1,0,'2022-03-03 13:03:51','2022-03-03 13:03:51'),(77854,231,'Lokpur','209720',1,0,'2022-03-03 13:03:51','2022-03-03 13:03:51'),(77855,231,'Madhonagar','209731',1,0,'2022-03-03 13:03:51','2022-03-03 13:03:51'),(77856,231,'Madhpura','209723',1,0,'2022-03-03 13:03:51','2022-03-03 13:03:51'),(77857,231,'Mahteypurwa','209732',1,0,'2022-03-03 13:03:51','2022-03-03 13:03:51'),(77858,231,'Majhpurwa','209722',1,0,'2022-03-03 13:03:51','2022-03-03 13:03:51'),(77859,231,'Majhupur','209747',1,0,'2022-03-03 13:03:52','2022-03-03 13:03:52'),(77860,231,'Makrand Nagar','209726',1,0,'2022-03-03 13:03:52','2022-03-03 13:03:52'),(77861,231,'Malikapur','209727',1,0,'2022-03-03 13:03:52','2022-03-03 13:03:52'),(77862,231,'Matauli','209733',1,0,'2022-03-03 13:03:52','2022-03-03 13:03:52'),(77863,231,'Mawai Bilwari','209738',1,0,'2022-03-03 13:03:52','2022-03-03 13:03:52'),(77864,231,'Merapur Garhiya','209721',1,0,'2022-03-03 13:03:52','2022-03-03 13:03:52'),(77865,231,'Mighauli','209721',1,0,'2022-03-03 13:03:52','2022-03-03 13:03:52'),(77866,231,'Mirgawan Ki Garhi','209733',1,0,'2022-03-03 13:03:52','2022-03-03 13:03:52'),(77867,231,'Miruan Marha','209738',1,0,'2022-03-03 13:03:52','2022-03-03 13:03:52'),(77868,231,'Mitra Senpur','209727',1,0,'2022-03-03 13:03:52','2022-03-03 13:03:52'),(77869,231,'Miyaganj','209727',1,0,'2022-03-03 13:03:52','2022-03-03 13:03:52'),(77870,231,'Mohanpur Ratanpur','209722',1,0,'2022-03-03 13:03:52','2022-03-03 13:03:52'),(77871,231,'Muraiya Buzurg','209727',1,0,'2022-03-03 13:03:52','2022-03-03 13:03:52'),(77872,231,'Murra','209728',1,0,'2022-03-03 13:03:52','2022-03-03 13:03:52'),(77873,231,'Nademau','209728',1,0,'2022-03-03 13:03:52','2022-03-03 13:03:52'),(77874,231,'Nandlalpur','209721',1,0,'2022-03-03 13:03:52','2022-03-03 13:03:52'),(77875,231,'Naugai','209721',1,0,'2022-03-03 13:03:52','2022-03-03 13:03:52'),(77876,231,'Nauli','209729',1,0,'2022-03-03 13:03:52','2022-03-03 13:03:52'),(77877,231,'Nazrapur Patti','209727',1,0,'2022-03-03 13:03:52','2022-03-03 13:03:52'),(77878,231,'Nera','209727',1,0,'2022-03-03 13:03:52','2022-03-03 13:03:52'),(77879,231,'Nigoh','209721',1,0,'2022-03-03 13:03:52','2022-03-03 13:03:52'),(77880,231,'Nizampur','209728',1,0,'2022-03-03 13:03:52','2022-03-03 13:03:52'),(77881,231,'Painda Bad','209727',1,0,'2022-03-03 13:03:52','2022-03-03 13:03:52'),(77882,231,'Paraur','209747',1,0,'2022-03-03 13:03:52','2022-03-03 13:03:52'),(77883,231,'Parsaramau Majhretha','209723',1,0,'2022-03-03 13:03:53','2022-03-03 13:03:53'),(77884,231,'Patti','209734',1,0,'2022-03-03 13:03:53','2022-03-03 13:03:53'),(77885,231,'Prempur','209721',1,0,'2022-03-03 13:03:53','2022-03-03 13:03:53'),(77886,231,'Pura Rai','209723',1,0,'2022-03-03 13:03:53','2022-03-03 13:03:53'),(77887,231,'Rampur Majhila','209738',1,0,'2022-03-03 13:03:53','2022-03-03 13:03:53'),(77888,231,'Rohili','209735',1,0,'2022-03-03 13:03:53','2022-03-03 13:03:53'),(77889,231,'Rura','209734',1,0,'2022-03-03 13:03:53','2022-03-03 13:03:53'),(77890,231,'Sakatpur','209728',1,0,'2022-03-03 13:03:53','2022-03-03 13:03:53'),(77891,231,'Sakrawa','209747',1,0,'2022-03-03 13:03:53','2022-03-03 13:03:53'),(77892,231,'Salempur','209747',1,0,'2022-03-03 13:03:53','2022-03-03 13:03:53'),(77893,231,'Salempur','209731',1,0,'2022-03-03 13:03:53','2022-03-03 13:03:53'),(77894,231,'Samdhin','209722',1,0,'2022-03-03 13:03:53','2022-03-03 13:03:53'),(77895,231,'Sarai Prayag','209735',1,0,'2022-03-03 13:03:53','2022-03-03 13:03:53'),(77896,231,'Sarai Theku','209728',1,0,'2022-03-03 13:03:53','2022-03-03 13:03:53'),(77897,231,'Saraimira','209727',1,0,'2022-03-03 13:03:53','2022-03-03 13:03:53'),(77898,231,'Sarifabad','209747',1,0,'2022-03-03 13:03:53','2022-03-03 13:03:53'),(77899,231,'Sataura','209731',1,0,'2022-03-03 13:03:53','2022-03-03 13:03:53'),(77900,231,'Saunsarapur','209733',1,0,'2022-03-03 13:03:53','2022-03-03 13:03:53'),(77901,231,'Saurikh','209728',1,0,'2022-03-03 13:03:53','2022-03-03 13:03:53'),(77902,231,'Sikanderpur (Kannauj)','209729',1,0,'2022-03-03 13:03:53','2022-03-03 13:03:53'),(77903,231,'Simaria','209736',1,0,'2022-03-03 13:03:53','2022-03-03 13:03:53'),(77904,231,'Sursi','209734',1,0,'2022-03-03 13:03:53','2022-03-03 13:03:53'),(77905,231,'Tahpur','209731',1,0,'2022-03-03 13:03:53','2022-03-03 13:03:53'),(77906,231,'Talgram','209731',1,0,'2022-03-03 13:03:53','2022-03-03 13:03:53'),(77907,231,'Tera Jaket','209735',1,0,'2022-03-03 13:03:54','2022-03-03 13:03:54'),(77908,231,'Tera Rabbu','209722',1,0,'2022-03-03 13:03:54','2022-03-03 13:03:54'),(77909,231,'Teramallu','209727',1,0,'2022-03-03 13:03:54','2022-03-03 13:03:54'),(77910,231,'Thathia','209734',1,0,'2022-03-03 13:03:54','2022-03-03 13:03:54'),(77911,231,'Tidiyapur','209727',1,0,'2022-03-03 13:03:54','2022-03-03 13:03:54'),(77912,231,'Tirwa Ganj','209732',1,0,'2022-03-03 13:03:54','2022-03-03 13:03:54'),(77913,231,'Tirwa','209732',1,0,'2022-03-03 13:03:54','2022-03-03 13:03:54'),(77914,231,'Todarpur','209720',1,0,'2022-03-03 13:03:54','2022-03-03 13:03:54'),(77915,231,'Umarda','209738',1,0,'2022-03-03 13:03:54','2022-03-03 13:03:54'),(77916,231,'Umrain','209736',1,0,'2022-03-03 13:03:54','2022-03-03 13:03:54'),(77917,231,'Uncha','209722',1,0,'2022-03-03 13:03:54','2022-03-03 13:03:54'),(77918,232,'Aakeen','209202',1,0,'2022-03-03 13:03:54','2022-03-03 13:03:54'),(77919,232,'Aanupur','208001',1,0,'2022-03-03 13:03:54','2022-03-03 13:03:54'),(77920,232,'Akaru','209302',1,0,'2022-03-03 13:03:54','2022-03-03 13:03:54'),(77921,232,'Akauri','209111',1,0,'2022-03-03 13:03:54','2022-03-03 13:03:54'),(77922,232,'Akbarpur','209206',1,0,'2022-03-03 13:03:54','2022-03-03 13:03:54'),(77923,232,'Akbarpur','209101',1,0,'2022-03-03 13:03:54','2022-03-03 13:03:54'),(77924,232,'Amraaudha','209112',1,0,'2022-03-03 13:03:54','2022-03-03 13:03:54'),(77925,232,'Anaie','209202',1,0,'2022-03-03 13:03:54','2022-03-03 13:03:54'),(77926,232,'Angadpur','209301',1,0,'2022-03-03 13:03:54','2022-03-03 13:03:54'),(77927,232,'Anta','209202',1,0,'2022-03-03 13:03:54','2022-03-03 13:03:54'),(77928,232,'Anwa','209115',1,0,'2022-03-03 13:03:54','2022-03-03 13:03:54'),(77929,232,'Aonaha','209204',1,0,'2022-03-03 13:03:54','2022-03-03 13:03:54'),(77930,232,'Araul','209202',1,0,'2022-03-03 13:03:54','2022-03-03 13:03:54'),(77931,232,'Arhariyamau','209312',1,0,'2022-03-03 13:03:54','2022-03-03 13:03:54'),(77932,232,'Arsun Bangar','209125',1,0,'2022-03-03 13:03:55','2022-03-03 13:03:55'),(77933,232,'Asalatganj','209306',1,0,'2022-03-03 13:03:55','2022-03-03 13:03:55'),(77934,232,'Asdhna','209206',1,0,'2022-03-03 13:03:55','2022-03-03 13:03:55'),(77935,232,'Aslanapur','209301',1,0,'2022-03-03 13:03:55','2022-03-03 13:03:55'),(77936,232,'Asvi','209310',1,0,'2022-03-03 13:03:55','2022-03-03 13:03:55'),(77937,232,'Aurangabad','209310',1,0,'2022-03-03 13:03:55','2022-03-03 13:03:55'),(77938,232,'Aurangpur Gahdeva','209202',1,0,'2022-03-03 13:03:55','2022-03-03 13:03:55'),(77939,232,'Aurotahar Pur','209202',1,0,'2022-03-03 13:03:55','2022-03-03 13:03:55'),(77940,232,'B.B.Gaon','209209',1,0,'2022-03-03 13:03:55','2022-03-03 13:03:55'),(77941,232,'Baalai Bujurg','209301',1,0,'2022-03-03 13:03:55','2022-03-03 13:03:55'),(77942,232,'Bachhna','209202',1,0,'2022-03-03 13:03:55','2022-03-03 13:03:55'),(77943,232,'Bairi Sawai','209204',1,0,'2022-03-03 13:03:55','2022-03-03 13:03:55'),(77944,232,'Bamhrauli','209208',1,0,'2022-03-03 13:03:55','2022-03-03 13:03:55'),(77945,232,'Bamhrauli Ghat','209208',1,0,'2022-03-03 13:03:55','2022-03-03 13:03:55'),(77946,232,'Ban','209302',1,0,'2022-03-03 13:03:55','2022-03-03 13:03:55'),(77947,232,'Banipara','209303',1,0,'2022-03-03 13:03:55','2022-03-03 13:03:55'),(77948,232,'Bannapur','209204',1,0,'2022-03-03 13:03:55','2022-03-03 13:03:55'),(77949,232,'Bara','209311',1,0,'2022-03-03 13:03:55','2022-03-03 13:03:55'),(77950,232,'Bara Daulatpur','209206',1,0,'2022-03-03 13:03:55','2022-03-03 13:03:55'),(77951,232,'Baragaon Bhikhi','209301',1,0,'2022-03-03 13:03:55','2022-03-03 13:03:55'),(77952,232,'Baranda','209202',1,0,'2022-03-03 13:03:55','2022-03-03 13:03:55'),(77953,232,'Barapur','209101',1,0,'2022-03-03 13:03:55','2022-03-03 13:03:55'),(77954,232,'Baraur','209312',1,0,'2022-03-03 13:03:55','2022-03-03 13:03:55'),(77955,232,'Bari Alipur','209202',1,0,'2022-03-03 13:03:55','2022-03-03 13:03:55'),(77956,232,'Bari Mahtaen','209206',1,0,'2022-03-03 13:03:55','2022-03-03 13:03:55'),(77957,232,'Baripal','208001',1,0,'2022-03-03 13:03:56','2022-03-03 13:03:56'),(77958,232,'Barnaon','209308',1,0,'2022-03-03 13:03:56','2022-03-03 13:03:56'),(77959,232,'Barra Tharra','209204',1,0,'2022-03-03 13:03:56','2022-03-03 13:03:56'),(77960,232,'Bauhar','209209',1,0,'2022-03-03 13:03:56','2022-03-03 13:03:56'),(77961,232,'Behta Bujurg','209209',1,0,'2022-03-03 13:03:56','2022-03-03 13:03:56'),(77962,232,'Bewain','209101',1,0,'2022-03-03 13:03:56','2022-03-03 13:03:56'),(77963,232,'Bewan','209101',1,0,'2022-03-03 13:03:56','2022-03-03 13:03:56'),(77964,232,'Bhadhpur','209307',1,0,'2022-03-03 13:03:56','2022-03-03 13:03:56'),(77965,232,'Bhadras','209206',1,0,'2022-03-03 13:03:56','2022-03-03 13:03:56'),(77966,232,'Bhadwara','209206',1,0,'2022-03-03 13:03:56','2022-03-03 13:03:56'),(77967,232,'Bhaisana','209205',1,0,'2022-03-03 13:03:56','2022-03-03 13:03:56'),(77968,232,'Bhaisau','209205',1,0,'2022-03-03 13:03:56','2022-03-03 13:03:56'),(77969,232,'Bhaisayan(E.U.P-7098)','209306',1,0,'2022-03-03 13:03:56','2022-03-03 13:03:56'),(77970,232,'Bhal','209115',1,0,'2022-03-03 13:03:56','2022-03-03 13:03:56'),(77971,232,'Bhandauli','208001',1,0,'2022-03-03 13:03:56','2022-03-03 13:03:56'),(77972,232,'Bhandemau','209310',1,0,'2022-03-03 13:03:56','2022-03-03 13:03:56'),(77973,232,'Bharamau','209306',1,0,'2022-03-03 13:03:56','2022-03-03 13:03:56'),(77974,232,'Bharatpur Piyaso','209121',1,0,'2022-03-03 13:03:56','2022-03-03 13:03:56'),(77975,232,'Bhaupur','209307',1,0,'2022-03-03 13:03:56','2022-03-03 13:03:56'),(77976,232,'Bhavaiya','209204',1,0,'2022-03-03 13:03:56','2022-03-03 13:03:56'),(77977,232,'Bhiwan','209204',1,0,'2022-03-03 13:03:56','2022-03-03 13:03:56'),(77978,232,'Bhognipur','209111',1,0,'2022-03-03 13:03:56','2022-03-03 13:03:56'),(77979,232,'Bhool','209307',1,0,'2022-03-03 13:03:56','2022-03-03 13:03:56'),(77980,232,'Bhuganiyapur','209101',1,0,'2022-03-03 13:03:56','2022-03-03 13:03:56'),(77981,232,'Bibipur','208001',1,0,'2022-03-03 13:03:56','2022-03-03 13:03:56'),(77982,232,'Bijhara','209301',1,0,'2022-03-03 13:03:57','2022-03-03 13:03:57'),(77983,232,'Bilhapur','209112',1,0,'2022-03-03 13:03:57','2022-03-03 13:03:57'),(77984,232,'Bilhaur','209202',1,0,'2022-03-03 13:03:57','2022-03-03 13:03:57'),(77985,232,'Birhar','209209',1,0,'2022-03-03 13:03:57','2022-03-03 13:03:57'),(77986,232,'Birhuan','209306',1,0,'2022-03-03 13:03:57','2022-03-03 13:03:57'),(77987,232,'Boramau','209210',1,0,'2022-03-03 13:03:57','2022-03-03 13:03:57'),(77988,232,'Budhauli','209115',1,0,'2022-03-03 13:03:57','2022-03-03 13:03:57'),(77989,232,'Chanwar','209206',1,0,'2022-03-03 13:03:57','2022-03-03 13:03:57'),(77990,232,'Chhatarpur','209205',1,0,'2022-03-03 13:03:57','2022-03-03 13:03:57'),(77991,232,'Chhatrsa','209302',1,0,'2022-03-03 13:03:57','2022-03-03 13:03:57'),(77992,232,'Chitaauli','209303',1,0,'2022-03-03 13:03:57','2022-03-03 13:03:57'),(77993,232,'Chowki','209111',1,0,'2022-03-03 13:03:57','2022-03-03 13:03:57'),(77994,232,'Dalipangar','209204',1,0,'2022-03-03 13:03:57','2022-03-03 13:03:57'),(77995,232,'Damanpur','209115',1,0,'2022-03-03 13:03:57','2022-03-03 13:03:57'),(77996,232,'Debair','209112',1,0,'2022-03-03 13:03:57','2022-03-03 13:03:57'),(77997,232,'Derapur','209301',1,0,'2022-03-03 13:03:57','2022-03-03 13:03:57'),(77998,232,'Devha','209202',1,0,'2022-03-03 13:03:57','2022-03-03 13:03:57'),(77999,232,'Devrahut','209112',1,0,'2022-03-03 13:03:57','2022-03-03 13:03:57'),(78000,232,'Dhamna Bujurg','209206',1,0,'2022-03-03 13:03:57','2022-03-03 13:03:57'),(78001,232,'Dharampur','209125',1,0,'2022-03-03 13:03:57','2022-03-03 13:03:57'),(78002,232,'Dharmangadpur','209307',1,0,'2022-03-03 13:03:57','2022-03-03 13:03:57'),(78003,232,'Dharmangadpur','209206',1,0,'2022-03-03 13:03:58','2022-03-03 13:03:58'),(78004,232,'Dheli','209208',1,0,'2022-03-03 13:03:58','2022-03-03 13:03:58'),(78005,232,'Dilauliya','209302',1,0,'2022-03-03 13:03:58','2022-03-03 13:03:58'),(78006,232,'Doharapur','209115',1,0,'2022-03-03 13:03:58','2022-03-03 13:03:58'),(78007,232,'Dundwa','209210',1,0,'2022-03-03 13:03:58','2022-03-03 13:03:58'),(78008,232,'Durooli','209121',1,0,'2022-03-03 13:03:58','2022-03-03 13:03:58'),(78009,232,'Duwari','209121',1,0,'2022-03-03 13:03:58','2022-03-03 13:03:58'),(78010,232,'Gabdaha','209203',1,0,'2022-03-03 13:03:58','2022-03-03 13:03:58'),(78011,232,'Gadatha','209208',1,0,'2022-03-03 13:03:58','2022-03-03 13:03:58'),(78012,232,'Gahlo Zarbi','209303',1,0,'2022-03-03 13:03:58','2022-03-03 13:03:58'),(78013,232,'Gajna','209202',1,0,'2022-03-03 13:03:58','2022-03-03 13:03:58'),(78014,232,'Gajner','209121',1,0,'2022-03-03 13:03:58','2022-03-03 13:03:58'),(78015,232,'Galuapur','209301',1,0,'2022-03-03 13:03:58','2022-03-03 13:03:58'),(78016,232,'Gangruli','209121',1,0,'2022-03-03 13:03:58','2022-03-03 13:03:58'),(78017,232,'Gaur','209112',1,0,'2022-03-03 13:03:58','2022-03-03 13:03:58'),(78018,232,'Gauri Bhagwantpur','209203',1,0,'2022-03-03 13:03:58','2022-03-03 13:03:58'),(78019,232,'Gauri Karan','209111',1,0,'2022-03-03 13:03:58','2022-03-03 13:03:58'),(78020,232,'Gaurikaran','209115',1,0,'2022-03-03 13:03:58','2022-03-03 13:03:58'),(78021,232,'Gauriyapur','209101',1,0,'2022-03-03 13:03:58','2022-03-03 13:03:58'),(78022,232,'Ghanshyampur','209203',1,0,'2022-03-03 13:03:58','2022-03-03 13:03:58'),(78023,232,'Girdu','209312',1,0,'2022-03-03 13:03:58','2022-03-03 13:03:58'),(78024,232,'Girsi','209311',1,0,'2022-03-03 13:03:58','2022-03-03 13:03:58'),(78025,232,'Gujela','209206',1,0,'2022-03-03 13:03:58','2022-03-03 13:03:58'),(78026,232,'Gujraai','209101',1,0,'2022-03-03 13:03:58','2022-03-03 13:03:58'),(78027,232,'Gurdahi Bujurg','209125',1,0,'2022-03-03 13:03:58','2022-03-03 13:03:58'),(78028,232,'Gurugaon','209312',1,0,'2022-03-03 13:03:58','2022-03-03 13:03:58'),(78029,232,'Hansemau','209111',1,0,'2022-03-03 13:03:59','2022-03-03 13:03:59'),(78030,232,'Haramau','209111',1,0,'2022-03-03 13:03:59','2022-03-03 13:03:59'),(78031,232,'Harbansh Pur','209206',1,0,'2022-03-03 13:03:59','2022-03-03 13:03:59'),(78032,232,'Hathai','209121',1,0,'2022-03-03 13:03:59','2022-03-03 13:03:59'),(78033,232,'Hathika','208001',1,0,'2022-03-03 13:03:59','2022-03-03 13:03:59'),(78034,232,'Hyuma','209301',1,0,'2022-03-03 13:03:59','2022-03-03 13:03:59'),(78035,232,'Indrarukh','209303',1,0,'2022-03-03 13:03:59','2022-03-03 13:03:59'),(78036,232,'Injuarampur','209302',1,0,'2022-03-03 13:03:59','2022-03-03 13:03:59'),(78037,232,'Itrra','209206',1,0,'2022-03-03 13:03:59','2022-03-03 13:03:59'),(78038,232,'Jaganpur','209303',1,0,'2022-03-03 13:03:59','2022-03-03 13:03:59'),(78039,232,'Jahagirabad','209308',1,0,'2022-03-03 13:03:59','2022-03-03 13:03:59'),(78040,232,'Jainpur I A','209311',1,0,'2022-03-03 13:03:59','2022-03-03 13:03:59'),(78041,232,'Jajpur','209206',1,0,'2022-03-03 13:03:59','2022-03-03 13:03:59'),(78042,232,'Jalalpur','209312',1,0,'2022-03-03 13:03:59','2022-03-03 13:03:59'),(78043,232,'Jhindaura','209101',1,0,'2022-03-03 13:03:59','2022-03-03 13:03:59'),(78044,232,'Jhinjhak','209302',1,0,'2022-03-03 13:03:59','2022-03-03 13:03:59'),(78045,232,'Jot','209306',1,0,'2022-03-03 13:03:59','2022-03-03 13:03:59'),(78046,232,'Jsapur','209310',1,0,'2022-03-03 13:03:59','2022-03-03 13:03:59'),(78047,232,'Kachhigaon','209111',1,0,'2022-03-03 13:03:59','2022-03-03 13:03:59'),(78048,232,'Kahijari','209302',1,0,'2022-03-03 13:03:59','2022-03-03 13:03:59'),(78049,232,'Kailai','209312',1,0,'2022-03-03 13:03:59','2022-03-03 13:03:59'),(78050,232,'Kaitha','209206',1,0,'2022-03-03 13:03:59','2022-03-03 13:03:59'),(78051,232,'Kakban','209202',1,0,'2022-03-03 13:03:59','2022-03-03 13:03:59'),(78052,232,'Kakoopur','209205',1,0,'2022-03-03 13:03:59','2022-03-03 13:03:59'),(78053,232,'Kamalpur','209115',1,0,'2022-03-03 13:03:59','2022-03-03 13:03:59'),(78054,232,'Kamsaan','209202',1,0,'2022-03-03 13:04:00','2022-03-03 13:04:00'),(78055,232,'Kandhi','209115',1,0,'2022-03-03 13:04:00','2022-03-03 13:04:00'),(78056,232,'Kari Kalwari','209303',1,0,'2022-03-03 13:04:00','2022-03-03 13:04:00'),(78057,232,'Karosa','209101',1,0,'2022-03-03 13:04:00','2022-03-03 13:04:00'),(78058,232,'Karsa','209121',1,0,'2022-03-03 13:04:00','2022-03-03 13:04:00'),(78059,232,'Kashipur','209303',1,0,'2022-03-03 13:04:00','2022-03-03 13:04:00'),(78060,232,'Kasolar','209125',1,0,'2022-03-03 13:04:00','2022-03-03 13:04:00'),(78061,232,'Kathethi (E.U.P-7895)','209121',1,0,'2022-03-03 13:04:00','2022-03-03 13:04:00'),(78062,232,'Katri','209208',1,0,'2022-03-03 13:04:00','2022-03-03 13:04:00'),(78063,232,'Kausum','209121',1,0,'2022-03-03 13:04:00','2022-03-03 13:04:00'),(78064,232,'Khamhaila','209302',1,0,'2022-03-03 13:04:00','2022-03-03 13:04:00'),(78065,232,'Khanpur','209310',1,0,'2022-03-03 13:04:00','2022-03-03 13:04:00'),(78066,232,'Khawajaphool','209125',1,0,'2022-03-03 13:04:00','2022-03-03 13:04:00'),(78067,232,'Khera Kurshi','209202',1,0,'2022-03-03 13:04:00','2022-03-03 13:04:00'),(78068,232,'Kodwa','208001',1,0,'2022-03-03 13:04:00','2022-03-03 13:04:00'),(78069,232,'Kohara','209206',1,0,'2022-03-03 13:04:00','2022-03-03 13:04:00'),(78070,232,'Korea','209206',1,0,'2022-03-03 13:04:00','2022-03-03 13:04:00'),(78071,232,'Kotra Makrandpur','209206',1,0,'2022-03-03 13:04:00','2022-03-03 13:04:00'),(78072,232,'Kunjehi','209204',1,0,'2022-03-03 13:04:00','2022-03-03 13:04:00'),(78073,232,'Kuwankhera','209206',1,0,'2022-03-03 13:04:00','2022-03-03 13:04:00'),(78074,232,'Laloo','209306',1,0,'2022-03-03 13:04:00','2022-03-03 13:04:00'),(78075,232,'Lalpur','209101',1,0,'2022-03-03 13:04:00','2022-03-03 13:04:00'),(78076,232,'Lalpur R.S.','209101',1,0,'2022-03-03 13:04:00','2022-03-03 13:04:00'),(78077,232,'Lalpur Shivrajpur','208001',1,0,'2022-03-03 13:04:00','2022-03-03 13:04:00'),(78078,232,'Laxmanpur Pilakh','209302',1,0,'2022-03-03 13:04:01','2022-03-03 13:04:01'),(78079,232,'Lohari','209121',1,0,'2022-03-03 13:04:01','2022-03-03 13:04:01'),(78080,232,'Mahera','209306',1,0,'2022-03-03 13:04:01','2022-03-03 13:04:01'),(78081,232,'Mahua Mahoi','209310',1,0,'2022-03-03 13:04:01','2022-03-03 13:04:01'),(78082,232,'Mahuwa Nogaon','209306',1,0,'2022-03-03 13:04:01','2022-03-03 13:04:01'),(78083,232,'Maitha','208001',1,0,'2022-03-03 13:04:01','2022-03-03 13:04:01'),(78084,232,'Maitha R.S.','208001',1,0,'2022-03-03 13:04:01','2022-03-03 13:04:01'),(78085,232,'Makanpur','209202',1,0,'2022-03-03 13:04:01','2022-03-03 13:04:01'),(78086,232,'Makhauli','209208',1,0,'2022-03-03 13:04:01','2022-03-03 13:04:01'),(78087,232,'Makrandpur','209306',1,0,'2022-03-03 13:04:01','2022-03-03 13:04:01'),(78088,232,'Malasa','209312',1,0,'2022-03-03 13:04:01','2022-03-03 13:04:01'),(78089,232,'Maloo','209203',1,0,'2022-03-03 13:04:01','2022-03-03 13:04:01'),(78090,232,'Mancha','209112',1,0,'2022-03-03 13:04:01','2022-03-03 13:04:01'),(78091,232,'Manethu','209121',1,0,'2022-03-03 13:04:01','2022-03-03 13:04:01'),(78092,232,'Mangalpur (Kanpur Dehat)','209310',1,0,'2022-03-03 13:04:01','2022-03-03 13:04:01'),(78093,232,'Mangta','209121',1,0,'2022-03-03 13:04:01','2022-03-03 13:04:01'),(78094,232,'Manpur','209125',1,0,'2022-03-03 13:04:01','2022-03-03 13:04:01'),(78095,232,'Mariyapur','209115',1,0,'2022-03-03 13:04:01','2022-03-03 13:04:01'),(78096,232,'Mati','209101',1,0,'2022-03-03 13:04:01','2022-03-03 13:04:01'),(78097,232,'Meenapur','209312',1,0,'2022-03-03 13:04:01','2022-03-03 13:04:01'),(78098,232,'Mirgaon','209125',1,0,'2022-03-03 13:04:01','2022-03-03 13:04:01'),(78099,232,'Mohammedpur','209312',1,0,'2022-03-03 13:04:01','2022-03-03 13:04:01'),(78100,232,'Mohana (E.U.P. 7305)','209311',1,0,'2022-03-03 13:04:01','2022-03-03 13:04:01'),(78101,232,'Mojampur','209202',1,0,'2022-03-03 13:04:01','2022-03-03 13:04:01'),(78102,232,'Mokhakhurd','209101',1,0,'2022-03-03 13:04:02','2022-03-03 13:04:02'),(78103,232,'Mubarakpur','209115',1,0,'2022-03-03 13:04:02','2022-03-03 13:04:02'),(78104,232,'Musa Nagar','209208',1,0,'2022-03-03 13:04:02','2022-03-03 13:04:02'),(78105,232,'Nabipur','209311',1,0,'2022-03-03 13:04:02','2022-03-03 13:04:02'),(78106,232,'Nadoha','209210',1,0,'2022-03-03 13:04:02','2022-03-03 13:04:02'),(78107,232,'Naila','209306',1,0,'2022-03-03 13:04:02','2022-03-03 13:04:02'),(78108,232,'Nanamau','209202',1,0,'2022-03-03 13:04:02','2022-03-03 13:04:02'),(78109,232,'Nandpur','209301',1,0,'2022-03-03 13:04:02','2022-03-03 13:04:02'),(78110,232,'Narkhurd','209306',1,0,'2022-03-03 13:04:02','2022-03-03 13:04:02'),(78111,232,'Nashirapur','209202',1,0,'2022-03-03 13:04:02','2022-03-03 13:04:02'),(78112,232,'Naubasta','209307',1,0,'2022-03-03 13:04:02','2022-03-03 13:04:02'),(78113,232,'Nauranga','209206',1,0,'2022-03-03 13:04:02','2022-03-03 13:04:02'),(78114,232,'Nigoha','209204',1,0,'2022-03-03 13:04:02','2022-03-03 13:04:02'),(78115,232,'Ninama','209121',1,0,'2022-03-03 13:04:02','2022-03-03 13:04:02'),(78116,232,'Nonapur','209112',1,0,'2022-03-03 13:04:02','2022-03-03 13:04:02'),(78117,232,'Nonari','209310',1,0,'2022-03-03 13:04:02','2022-03-03 13:04:02'),(78118,232,'Oderi','209115',1,0,'2022-03-03 13:04:02','2022-03-03 13:04:02'),(78119,232,'Oriya','209204',1,0,'2022-03-03 13:04:02','2022-03-03 13:04:02'),(78120,232,'Padiya (E.U.P-5089)','209125',1,0,'2022-03-03 13:04:02','2022-03-03 13:04:02'),(78121,232,'Padri Lalpur','209308',1,0,'2022-03-03 13:04:02','2022-03-03 13:04:02'),(78122,232,'Pahewa','209209',1,0,'2022-03-03 13:04:02','2022-03-03 13:04:02'),(78123,232,'Palhnapur','209125',1,0,'2022-03-03 13:04:02','2022-03-03 13:04:02'),(78124,232,'Pama R.S.','209121',1,0,'2022-03-03 13:04:02','2022-03-03 13:04:02'),(78125,232,'Paniyamau','209112',1,0,'2022-03-03 13:04:02','2022-03-03 13:04:02'),(78126,232,'Parachand','209206',1,0,'2022-03-03 13:04:02','2022-03-03 13:04:02'),(78127,232,'Pasikhera','209209',1,0,'2022-03-03 13:04:03','2022-03-03 13:04:03'),(78128,232,'Patara (Kanpur Dehat)','209308',1,0,'2022-03-03 13:04:03','2022-03-03 13:04:03'),(78129,232,'Patra','209311',1,0,'2022-03-03 13:04:03','2022-03-03 13:04:03'),(78130,232,'Patrsa','209206',1,0,'2022-03-03 13:04:03','2022-03-03 13:04:03'),(78131,232,'Pihani Majbootnagar','209202',1,0,'2022-03-03 13:04:03','2022-03-03 13:04:03'),(78132,232,'Pindarthu','209125',1,0,'2022-03-03 13:04:03','2022-03-03 13:04:03'),(78133,232,'Pras','209206',1,0,'2022-03-03 13:04:03','2022-03-03 13:04:03'),(78134,232,'Pratappur','209307',1,0,'2022-03-03 13:04:03','2022-03-03 13:04:03'),(78135,232,'Prokha','209310',1,0,'2022-03-03 13:04:03','2022-03-03 13:04:03'),(78136,232,'Pukhrayan','209111',1,0,'2022-03-03 13:04:03','2022-03-03 13:04:03'),(78137,232,'Pur (E.U.P.3155)','209303',1,0,'2022-03-03 13:04:03','2022-03-03 13:04:03'),(78138,232,'Puraanpurwa','209306',1,0,'2022-03-03 13:04:03','2022-03-03 13:04:03'),(78139,232,'Radhan ( E.U.P.-5857)','209210',1,0,'2022-03-03 13:04:03','2022-03-03 13:04:03'),(78140,232,'Rahimpur','209202',1,0,'2022-03-03 13:04:03','2022-03-03 13:04:03'),(78141,232,'Raipalpur','209307',1,0,'2022-03-03 13:04:03','2022-03-03 13:04:03'),(78142,232,'Rajpur (Kanpur Dehat)','209115',1,0,'2022-03-03 13:04:03','2022-03-03 13:04:03'),(78143,232,'Ramau','209115',1,0,'2022-03-03 13:04:03','2022-03-03 13:04:03'),(78144,232,'Rampur','209308',1,0,'2022-03-03 13:04:03','2022-03-03 13:04:03'),(78145,232,'Rar','209206',1,0,'2022-03-03 13:04:03','2022-03-03 13:04:03'),(78146,232,'Rasatpur','209307',1,0,'2022-03-03 13:04:03','2022-03-03 13:04:03'),(78147,232,'Rasdhan','209115',1,0,'2022-03-03 13:04:03','2022-03-03 13:04:03'),(78148,232,'Rasulabad (Kanpur Dehat)','209306',1,0,'2022-03-03 13:04:03','2022-03-03 13:04:03'),(78149,232,'Rasulpur Gogumau(E.U.P-7906)','209121',1,0,'2022-03-03 13:04:03','2022-03-03 13:04:03'),(78150,232,'Ratanpur','209306',1,0,'2022-03-03 13:04:03','2022-03-03 13:04:03'),(78151,232,'Rathigaon','209101',1,0,'2022-03-03 13:04:03','2022-03-03 13:04:03'),(78152,232,'Rawaipur','209206',1,0,'2022-03-03 13:04:04','2022-03-03 13:04:04'),(78153,232,'Rawatpur Chaudhriyan','209209',1,0,'2022-03-03 13:04:04','2022-03-03 13:04:04'),(78154,232,'Reri','209301',1,0,'2022-03-03 13:04:04','2022-03-03 13:04:04'),(78155,232,'Revna','209206',1,0,'2022-03-03 13:04:04','2022-03-03 13:04:04'),(78156,232,'Roop Nagar','209206',1,0,'2022-03-03 13:04:04','2022-03-03 13:04:04'),(78157,232,'Rootapur Kalan','209203',1,0,'2022-03-03 13:04:04','2022-03-03 13:04:04'),(78158,232,'Roshanmau ( E.U.P.-6054)','209303',1,0,'2022-03-03 13:04:04','2022-03-03 13:04:04'),(78159,232,'Rura','209303',1,0,'2022-03-03 13:04:04','2022-03-03 13:04:04'),(78160,232,'Rurgaon','209115',1,0,'2022-03-03 13:04:04','2022-03-03 13:04:04'),(78161,232,'Rurwahar','209101',1,0,'2022-03-03 13:04:04','2022-03-03 13:04:04'),(78162,232,'Sabhalpur','209205',1,0,'2022-03-03 13:04:04','2022-03-03 13:04:04'),(78163,232,'Sadar Bazar Ghatampur','209206',1,0,'2022-03-03 13:04:04','2022-03-03 13:04:04'),(78164,232,'Saibasu','209210',1,0,'2022-03-03 13:04:04','2022-03-03 13:04:04'),(78165,232,'Sairua','209121',1,0,'2022-03-03 13:04:04','2022-03-03 13:04:04'),(78166,232,'Saitha','209121',1,0,'2022-03-03 13:04:04','2022-03-03 13:04:04'),(78167,232,'Sajeti','208001',1,0,'2022-03-03 13:04:04','2022-03-03 13:04:04'),(78168,232,'Sakhrez','209204',1,0,'2022-03-03 13:04:04','2022-03-03 13:04:04'),(78169,232,'Sakrawa','209204',1,0,'2022-03-03 13:04:04','2022-03-03 13:04:04'),(78170,232,'Sambhuai','208001',1,0,'2022-03-03 13:04:04','2022-03-03 13:04:04'),(78171,232,'Sandelpur','209125',1,0,'2022-03-03 13:04:04','2022-03-03 13:04:04'),(78172,232,'Saray','209111',1,0,'2022-03-03 13:04:04','2022-03-03 13:04:04'),(78173,232,'Saray Garewa','209303',1,0,'2022-03-03 13:04:04','2022-03-03 13:04:04'),(78174,232,'Sargaon Bujurg','209303',1,0,'2022-03-03 13:04:04','2022-03-03 13:04:04'),(78175,232,'Sariyapur','209101',1,0,'2022-03-03 13:04:05','2022-03-03 13:04:05'),(78176,232,'Sarwankhera','209121',1,0,'2022-03-03 13:04:05','2022-03-03 13:04:05'),(78177,232,'Satti','209115',1,0,'2022-03-03 13:04:05','2022-03-03 13:04:05'),(78178,232,'Selhoopur','209112',1,0,'2022-03-03 13:04:05','2022-03-03 13:04:05'),(78179,232,'Shahi ( E.U.P-6127)','209303',1,0,'2022-03-03 13:04:05','2022-03-03 13:04:05'),(78180,232,'Shahjahanpur','209115',1,0,'2022-03-03 13:04:05','2022-03-03 13:04:05'),(78181,232,'Shambhua','209308',1,0,'2022-03-03 13:04:05','2022-03-03 13:04:05'),(78182,232,'Shekhpur','209112',1,0,'2022-03-03 13:04:05','2022-03-03 13:04:05'),(78183,232,'Sheoli','209204',1,0,'2022-03-03 13:04:05','2022-03-03 13:04:05'),(78184,232,'Sheorajpur','209205',1,0,'2022-03-03 13:04:05','2022-03-03 13:04:05'),(78185,232,'Shisahi','209306',1,0,'2022-03-03 13:04:05','2022-03-03 13:04:05'),(78186,232,'Sikandra (Kanpur Dehat)','209125',1,0,'2022-03-03 13:04:05','2022-03-03 13:04:05'),(78187,232,'Silhara','209115',1,0,'2022-03-03 13:04:05','2022-03-03 13:04:05'),(78188,232,'Singrasipur','209208',1,0,'2022-03-03 13:04:05','2022-03-03 13:04:05'),(78189,232,'Sithmara','209302',1,0,'2022-03-03 13:04:05','2022-03-03 13:04:05'),(78190,232,'Sithrabujurg','209312',1,0,'2022-03-03 13:04:05','2022-03-03 13:04:05'),(78191,232,'Srinagar','209206',1,0,'2022-03-03 13:04:05','2022-03-03 13:04:05'),(78192,232,'Ssudhardevo (E.U.P - 9346)','209210',1,0,'2022-03-03 13:04:05','2022-03-03 13:04:05'),(78193,232,'Sujanpur(E.U.P.9348)','209306',1,0,'2022-03-03 13:04:05','2022-03-03 13:04:05'),(78194,232,'Sultanur','209121',1,0,'2022-03-03 13:04:05','2022-03-03 13:04:05'),(78195,232,'Sunderpur Gajan','209302',1,0,'2022-03-03 13:04:05','2022-03-03 13:04:05'),(78196,232,'Surar','209307',1,0,'2022-03-03 13:04:05','2022-03-03 13:04:05'),(78197,232,'Targaon','209308',1,0,'2022-03-03 13:04:05','2022-03-03 13:04:05'),(78198,232,'Tari Pathakpur','209203',1,0,'2022-03-03 13:04:05','2022-03-03 13:04:05'),(78199,232,'Tigaei','209303',1,0,'2022-03-03 13:04:05','2022-03-03 13:04:05'),(78200,232,'Tilsara','209308',1,0,'2022-03-03 13:04:05','2022-03-03 13:04:05'),(78201,232,'Titthi','209202',1,0,'2022-03-03 13:04:06','2022-03-03 13:04:06'),(78202,232,'Umarpur','209125',1,0,'2022-03-03 13:04:06','2022-03-03 13:04:06'),(78203,232,'Umri','209209',1,0,'2022-03-03 13:04:06','2022-03-03 13:04:06'),(78204,232,'Ursaan','209301',1,0,'2022-03-03 13:04:06','2022-03-03 13:04:06'),(78205,232,'Usri','209306',1,0,'2022-03-03 13:04:06','2022-03-03 13:04:06'),(78206,232,'Uttaripura','209210',1,0,'2022-03-03 13:04:06','2022-03-03 13:04:06'),(78207,232,'Uttha','209202',1,0,'2022-03-03 13:04:06','2022-03-03 13:04:06'),(78208,232,'Vaina','209115',1,0,'2022-03-03 13:04:06','2022-03-03 13:04:06'),(78209,232,'Vakori','209202',1,0,'2022-03-03 13:04:06','2022-03-03 13:04:06'),(78210,232,'Virsinghpur','209209',1,0,'2022-03-03 13:04:06','2022-03-03 13:04:06'),(78211,232,'Zalihapur','209302',1,0,'2022-03-03 13:04:06','2022-03-03 13:04:06'),(78212,232,'Zithrauli','209121',1,0,'2022-03-03 13:04:06','2022-03-03 13:04:06'),(78213,232,'Zuniya','209121',1,0,'2022-03-03 13:04:06','2022-03-03 13:04:06'),(78214,233,'Agriculture College','208002',1,0,'2022-03-03 13:04:06','2022-03-03 13:04:06'),(78215,233,'Amour','209401',1,0,'2022-03-03 13:04:06','2022-03-03 13:04:06'),(78216,233,'Anand Nagar (Kanpur Nagar)','208011',1,0,'2022-03-03 13:04:06','2022-03-03 13:04:06'),(78217,233,'Anwarganj','208003',1,0,'2022-03-03 13:04:06','2022-03-03 13:04:06'),(78218,233,'Aranjhami','209401',1,0,'2022-03-03 13:04:06','2022-03-03 13:04:06'),(78219,233,'Armapore Estate','208009',1,0,'2022-03-03 13:04:06','2022-03-03 13:04:06'),(78220,233,'Armapore','208009',1,0,'2022-03-03 13:04:06','2022-03-03 13:04:06'),(78221,233,'Arya Nagar (Kanpur Nagar)','208002',1,0,'2022-03-03 13:04:07','2022-03-03 13:04:07'),(78222,233,'Avas Vikas Yojna No. 3','208017',1,0,'2022-03-03 13:04:07','2022-03-03 13:04:07'),(78223,233,'B N Shukla & Sons','208001',1,0,'2022-03-03 13:04:07','2022-03-03 13:04:07'),(78224,233,'Baikuthpur','209217',1,0,'2022-03-03 13:04:07','2022-03-03 13:04:07'),(78225,233,'Bairi','208017',1,0,'2022-03-03 13:04:07','2022-03-03 13:04:07'),(78226,233,'Baraigarh','209401',1,0,'2022-03-03 13:04:07','2022-03-03 13:04:07'),(78227,233,'Barra','208027',1,0,'2022-03-03 13:04:07','2022-03-03 13:04:07'),(78228,233,'Barra Vishwa Bank Sector-A','208027',1,0,'2022-03-03 13:04:07','2022-03-03 13:04:07'),(78229,233,'Bausar','209401',1,0,'2022-03-03 13:04:07','2022-03-03 13:04:07'),(78230,233,'Behta Gambhirpur','209401',1,0,'2022-03-03 13:04:07','2022-03-03 13:04:07'),(78231,233,'Bhadrsa','209402',1,0,'2022-03-03 13:04:07','2022-03-03 13:04:07'),(78232,233,'Bhairampur','209305',1,0,'2022-03-03 13:04:07','2022-03-03 13:04:07'),(78233,233,'Bharu','209214',1,0,'2022-03-03 13:04:07','2022-03-03 13:04:07'),(78234,233,'Bhauti Pratappur','209305',1,0,'2022-03-03 13:04:07','2022-03-03 13:04:07'),(78235,233,'Bheoli','209402',1,0,'2022-03-03 13:04:07','2022-03-03 13:04:07'),(78236,233,'Bhimsen','209305',1,0,'2022-03-03 13:04:07','2022-03-03 13:04:07'),(78237,233,'Bidhnoo','209214',1,0,'2022-03-03 13:04:07','2022-03-03 13:04:07'),(78238,233,'Bima Vihar','208024',1,0,'2022-03-03 13:04:07','2022-03-03 13:04:07'),(78239,233,'Binour','209304',1,0,'2022-03-03 13:04:07','2022-03-03 13:04:07'),(78240,233,'Birhana Raod','208001',1,0,'2022-03-03 13:04:07','2022-03-03 13:04:07'),(78241,233,'Bisayakpur','209304',1,0,'2022-03-03 13:04:07','2022-03-03 13:04:07'),(78242,233,'Bithoor','209217',1,0,'2022-03-03 13:04:07','2022-03-03 13:04:07'),(78243,233,'Cambridge Road','208007',1,0,'2022-03-03 13:04:07','2022-03-03 13:04:07'),(78244,233,'CAT','208008',1,0,'2022-03-03 13:04:07','2022-03-03 13:04:07'),(78245,233,'Chakarpur','209305',1,0,'2022-03-03 13:04:07','2022-03-03 13:04:07'),(78246,233,'Chakeri Aerodrum','208008',1,0,'2022-03-03 13:04:08','2022-03-03 13:04:08'),(78247,233,'Chauki Jarib','208003',1,0,'2022-03-03 13:04:08','2022-03-03 13:04:08'),(78248,233,'Chaurai','209214',1,0,'2022-03-03 13:04:08','2022-03-03 13:04:08'),(78249,233,'Chhatarpur','209214',1,0,'2022-03-03 13:04:08','2022-03-03 13:04:08'),(78250,233,'COD (Kanpur Nagar)','208013',1,0,'2022-03-03 13:04:08','2022-03-03 13:04:08'),(78251,233,'Colonelganj (Kanpur Nagar)','208001',1,0,'2022-03-03 13:04:08','2022-03-03 13:04:08'),(78252,233,'Cotton Mill','208001',1,0,'2022-03-03 13:04:08','2022-03-03 13:04:08'),(78253,233,'D O Oil Mill','208012',1,0,'2022-03-03 13:04:08','2022-03-03 13:04:08'),(78254,233,'Dehli Ujagar','209214',1,0,'2022-03-03 13:04:08','2022-03-03 13:04:08'),(78255,233,'Deosarh','209214',1,0,'2022-03-03 13:04:08','2022-03-03 13:04:08'),(78256,233,'Dhankutti','208001',1,0,'2022-03-03 13:04:08','2022-03-03 13:04:08'),(78257,233,'Dmsrde','208013',1,0,'2022-03-03 13:04:08','2022-03-03 13:04:08'),(78258,233,'Elgin Mills','208001',1,0,'2022-03-03 13:04:08','2022-03-03 13:04:08'),(78259,233,'Employeement Exchange','208002',1,0,'2022-03-03 13:04:08','2022-03-03 13:04:08'),(78260,233,'Fahimabad','208001',1,0,'2022-03-03 13:04:08','2022-03-03 13:04:08'),(78261,233,'Farrashkhana','208001',1,0,'2022-03-03 13:04:08','2022-03-03 13:04:08'),(78262,233,'Fatehpur Roshnai','209304',1,0,'2022-03-03 13:04:08','2022-03-03 13:04:08'),(78263,233,'Gandhi Grame','208007',1,0,'2022-03-03 13:04:08','2022-03-03 13:04:08'),(78264,233,'Gayatri Seedh Peeth Khadeshar','209214',1,0,'2022-03-03 13:04:08','2022-03-03 13:04:08'),(78265,233,'Gazipur','209401',1,0,'2022-03-03 13:04:08','2022-03-03 13:04:08'),(78266,233,'Gopalpur','209401',1,0,'2022-03-03 13:04:08','2022-03-03 13:04:08'),(78267,233,'Govind Nagar (Kanpur Nagar)','208006',1,0,'2022-03-03 13:04:08','2022-03-03 13:04:08'),(78268,233,'Govind Nagar West','208006',1,0,'2022-03-03 13:04:08','2022-03-03 13:04:08'),(78269,233,'Gsvm Medical College','208002',1,0,'2022-03-03 13:04:08','2022-03-03 13:04:08'),(78270,233,'Gwaltoli','208001',1,0,'2022-03-03 13:04:09','2022-03-03 13:04:09'),(78271,233,'Hal Colony','208007',1,0,'2022-03-03 13:04:09','2022-03-03 13:04:09'),(78272,233,'Harchandkhera','209401',1,0,'2022-03-03 13:04:09','2022-03-03 13:04:09'),(78273,233,'Hardauli','209214',1,0,'2022-03-03 13:04:09','2022-03-03 13:04:09'),(78274,233,'Harjinder Nagar','208007',1,0,'2022-03-03 13:04:09','2022-03-03 13:04:09'),(78275,233,'Hathigaon','209402',1,0,'2022-03-03 13:04:09','2022-03-03 13:04:09'),(78276,233,'Hatia (Kanpur Nagar)','208001',1,0,'2022-03-03 13:04:09','2022-03-03 13:04:09'),(78277,233,'Hbti','208002',1,0,'2022-03-03 13:04:09','2022-03-03 13:04:09'),(78278,233,'Hns Nagar','208005',1,0,'2022-03-03 13:04:09','2022-03-03 13:04:09'),(78279,233,'Iit','208016',1,0,'2022-03-03 13:04:09','2022-03-03 13:04:09'),(78280,233,'Indira Nagar (Kanpur Nagar)','208026',1,0,'2022-03-03 13:04:09','2022-03-03 13:04:09'),(78281,233,'Industrial Estate (Kanpur Nagar','208005',1,0,'2022-03-03 13:04:09','2022-03-03 13:04:09'),(78282,233,'Itra','209217',1,0,'2022-03-03 13:04:09','2022-03-03 13:04:09'),(78283,233,'J K Puri','208010',1,0,'2022-03-03 13:04:09','2022-03-03 13:04:09'),(78284,233,'Jamu','209214',1,0,'2022-03-03 13:04:09','2022-03-03 13:04:09'),(78285,233,'Jarkala','209402',1,0,'2022-03-03 13:04:09','2022-03-03 13:04:09'),(78286,233,'Jawahar Nagar (Kanpur Nagar)','208012',1,0,'2022-03-03 13:04:09','2022-03-03 13:04:09'),(78287,233,'Jugrajpur','209304',1,0,'2022-03-03 13:04:09','2022-03-03 13:04:09'),(78288,233,'Juhi Colony','208014',1,0,'2022-03-03 13:04:09','2022-03-03 13:04:09'),(78289,233,'K M Street','208001',1,0,'2022-03-03 13:04:09','2022-03-03 13:04:09'),(78290,233,'K P University','208024',1,0,'2022-03-03 13:04:09','2022-03-03 13:04:09'),(78291,233,'Kadari Champatpur','209214',1,0,'2022-03-03 13:04:09','2022-03-03 13:04:09'),(78292,233,'Kaindha','209214',1,0,'2022-03-03 13:04:09','2022-03-03 13:04:09'),(78293,233,'Kalyanpur (Kanpur Nagar)','208017',1,0,'2022-03-03 13:04:09','2022-03-03 13:04:09'),(78294,233,'Kamlapur','209402',1,0,'2022-03-03 13:04:09','2022-03-03 13:04:09'),(78295,233,'Kanpur Cantt. H.O','208004',1,0,'2022-03-03 13:04:10','2022-03-03 13:04:10'),(78296,233,'Kanpur Court','208001',1,0,'2022-03-03 13:04:10','2022-03-03 13:04:10'),(78297,233,'Kanpur H.O','208001',1,0,'2022-03-03 13:04:10','2022-03-03 13:04:10'),(78298,233,'Kanpur West','208001',1,0,'2022-03-03 13:04:10','2022-03-03 13:04:10'),(78299,233,'Karbigvan','209402',1,0,'2022-03-03 13:04:10','2022-03-03 13:04:10'),(78300,233,'Kasigaon','208021',1,0,'2022-03-03 13:04:10','2022-03-03 13:04:10'),(78301,233,'Kathara','209214',1,0,'2022-03-03 13:04:10','2022-03-03 13:04:10'),(78302,233,'Katherua','209214',1,0,'2022-03-03 13:04:10','2022-03-03 13:04:10'),(78303,233,'Kathongar','208021',1,0,'2022-03-03 13:04:10','2022-03-03 13:04:10'),(78304,233,'Kaushalpuri','208012',1,0,'2022-03-03 13:04:10','2022-03-03 13:04:10'),(78305,233,'Keshav Puram (Kanpur Nagar)','208017',1,0,'2022-03-03 13:04:10','2022-03-03 13:04:10'),(78306,233,'Khapra Mohal','208004',1,0,'2022-03-03 13:04:10','2022-03-03 13:04:10'),(78307,233,'Kheora','208017',1,0,'2022-03-03 13:04:10','2022-03-03 13:04:10'),(78308,233,'Kidwai Nagar (Kanpur Nagar)','208011',1,0,'2022-03-03 13:04:10','2022-03-03 13:04:10'),(78309,233,'Krishna Nagar (Kanpur Nagar)','208007',1,0,'2022-03-03 13:04:10','2022-03-03 13:04:10'),(78310,233,'Kudani','209401',1,0,'2022-03-03 13:04:10','2022-03-03 13:04:10'),(78311,233,'Kulgaon','209402',1,0,'2022-03-03 13:04:10','2022-03-03 13:04:10'),(78312,233,'Maharajpur','209402',1,0,'2022-03-03 13:04:10','2022-03-03 13:04:10'),(78313,233,'Maholi','209402',1,0,'2022-03-03 13:04:10','2022-03-03 13:04:10'),(78314,233,'Mahua Gaon','209402',1,0,'2022-03-03 13:04:10','2022-03-03 13:04:10'),(78315,233,'Majhawan','209214',1,0,'2022-03-03 13:04:10','2022-03-03 13:04:10'),(78316,233,'Mandhana','209217',1,0,'2022-03-03 13:04:11','2022-03-03 13:04:11'),(78317,233,'Mardanpur','209305',1,0,'2022-03-03 13:04:11','2022-03-03 13:04:11'),(78318,233,'Meerpur Cantt','208004',1,0,'2022-03-03 13:04:11','2022-03-03 13:04:11'),(78319,233,'Motijheel (Kanpur Nagar)','208002',1,0,'2022-03-03 13:04:11','2022-03-03 13:04:11'),(78320,233,'Munshipurwa','208023',1,0,'2022-03-03 13:04:11','2022-03-03 13:04:11'),(78321,233,'N C Line','208002',1,0,'2022-03-03 13:04:11','2022-03-03 13:04:11'),(78322,233,'N H Road','208021',1,0,'2022-03-03 13:04:11','2022-03-03 13:04:11'),(78323,233,'Napier Road','208004',1,0,'2022-03-03 13:04:11','2022-03-03 13:04:11'),(78324,233,'Naramau','209217',1,0,'2022-03-03 13:04:11','2022-03-03 13:04:11'),(78325,233,'Narona Exchange','208004',1,0,'2022-03-03 13:04:11','2022-03-03 13:04:11'),(78326,233,'Narwal','209401',1,0,'2022-03-03 13:04:11','2022-03-03 13:04:11'),(78327,233,'Nasra','209401',1,0,'2022-03-03 13:04:11','2022-03-03 13:04:11'),(78328,233,'Naubasta','208021',1,0,'2022-03-03 13:04:11','2022-03-03 13:04:11'),(78329,233,'Naveen Market','208001',1,0,'2022-03-03 13:04:11','2022-03-03 13:04:11'),(78330,233,'Naveen Nagar','208025',1,0,'2022-03-03 13:04:11','2022-03-03 13:04:11'),(78331,233,'Nawabganj H.O','208002',1,0,'2022-03-03 13:04:11','2022-03-03 13:04:11'),(78332,233,'Nayaganj','208001',1,0,'2022-03-03 13:04:11','2022-03-03 13:04:11'),(78333,233,'New Pac Lines','208015',1,0,'2022-03-03 13:04:11','2022-03-03 13:04:11'),(78334,233,'Nirala Nagar','208014',1,0,'2022-03-03 13:04:11','2022-03-03 13:04:11'),(78335,233,'Nsi','208017',1,0,'2022-03-03 13:04:11','2022-03-03 13:04:11'),(78336,233,'Oe Factory','208001',1,0,'2022-03-03 13:04:11','2022-03-03 13:04:11'),(78337,233,'Pachor','209217',1,0,'2022-03-03 13:04:11','2022-03-03 13:04:11'),(78338,233,'Palhepur','209401',1,0,'2022-03-03 13:04:11','2022-03-03 13:04:11'),(78339,233,'Pali Bhogipur','209401',1,0,'2022-03-03 13:04:12','2022-03-03 13:04:12'),(78340,233,'Panki Ganga Ganj','208020',1,0,'2022-03-03 13:04:12','2022-03-03 13:04:12'),(78341,233,'Panki (Kanpur Nagar)','208020',1,0,'2022-03-03 13:04:12','2022-03-03 13:04:12'),(78342,233,'Parasadepur','209402',1,0,'2022-03-03 13:04:12','2022-03-03 13:04:12'),(78343,233,'Parsauli','209304',1,0,'2022-03-03 13:04:12','2022-03-03 13:04:12'),(78344,233,'Pem','209217',1,0,'2022-03-03 13:04:12','2022-03-03 13:04:12'),(78345,233,'Philkhana','208001',1,0,'2022-03-03 13:04:12','2022-03-03 13:04:12'),(78346,233,'Phuphuwar','209402',1,0,'2022-03-03 13:04:12','2022-03-03 13:04:12'),(78347,233,'Pipergaon','208021',1,0,'2022-03-03 13:04:12','2022-03-03 13:04:12'),(78348,233,'Prempur Badagaon','209402',1,0,'2022-03-03 13:04:12','2022-03-03 13:04:12'),(78349,233,'Purana Kanpur','208002',1,0,'2022-03-03 13:04:12','2022-03-03 13:04:12'),(78350,233,'Purwameer','209402',1,0,'2022-03-03 13:04:12','2022-03-03 13:04:12'),(78351,233,'R K Nagar (Kanpur Nagar)','208012',1,0,'2022-03-03 13:04:12','2022-03-03 13:04:12'),(78352,233,'Railganj','208004',1,0,'2022-03-03 13:04:12','2022-03-03 13:04:12'),(78353,233,'Raipur Kukhat','209304',1,0,'2022-03-03 13:04:12','2022-03-03 13:04:12'),(78354,233,'Ramaipur','209214',1,0,'2022-03-03 13:04:12','2022-03-03 13:04:12'),(78355,233,'Rambagh (Kanpur Nagar)','208012',1,0,'2022-03-03 13:04:12','2022-03-03 13:04:12'),(78356,233,'Rania','209304',1,0,'2022-03-03 13:04:12','2022-03-03 13:04:12'),(78357,233,'Rasulpur Umra','209401',1,0,'2022-03-03 13:04:12','2022-03-03 13:04:12'),(78358,233,'Ratan Lal Nagar','208022',1,0,'2022-03-03 13:04:12','2022-03-03 13:04:12'),(78359,233,'Rawatpur','208019',1,0,'2022-03-03 13:04:12','2022-03-03 13:04:12'),(78360,233,'RBI Colony','208011',1,0,'2022-03-03 13:04:13','2022-03-03 13:04:13'),(78361,233,'Rooma','209402',1,0,'2022-03-03 13:04:13','2022-03-03 13:04:13'),(78362,233,'Sachendi','209304',1,0,'2022-03-03 13:04:13','2022-03-03 13:04:13'),(78363,233,'Saketpuri','208025',1,0,'2022-03-03 13:04:13','2022-03-03 13:04:13'),(78364,233,'Salempur','209402',1,0,'2022-03-03 13:04:13','2022-03-03 13:04:13'),(78365,233,'Sanigawan','208021',1,0,'2022-03-03 13:04:13','2022-03-03 13:04:13'),(78366,233,'Sapai','209214',1,0,'2022-03-03 13:04:13','2022-03-03 13:04:13'),(78367,233,'Sarh','209401',1,0,'2022-03-03 13:04:13','2022-03-03 13:04:13'),(78368,233,'Sarsaul','209402',1,0,'2022-03-03 13:04:13','2022-03-03 13:04:13'),(78369,233,'Sarvodaya Nagar','208005',1,0,'2022-03-03 13:04:13','2022-03-03 13:04:13'),(78370,233,'Sawaijpur','209401',1,0,'2022-03-03 13:04:13','2022-03-03 13:04:13'),(78371,233,'Semarjhal','209401',1,0,'2022-03-03 13:04:13','2022-03-03 13:04:13'),(78372,233,'Senpara Paschim','209305',1,0,'2022-03-03 13:04:13','2022-03-03 13:04:13'),(78373,233,'Shivaji Nagar (Kanpur Nagar)','208005',1,0,'2022-03-03 13:04:13','2022-03-03 13:04:13'),(78374,233,'Shiwans Tanney','208010',1,0,'2022-03-03 13:04:13','2022-03-03 13:04:13'),(78375,233,'Shyam Nagar (Kanpur Nagar)','208013',1,0,'2022-03-03 13:04:13','2022-03-03 13:04:13'),(78376,233,'Sirhi Itra','209214',1,0,'2022-03-03 13:04:13','2022-03-03 13:04:13'),(78377,233,'Sisamau','208012',1,0,'2022-03-03 13:04:13','2022-03-03 13:04:13'),(78378,233,'Subhauli','209402',1,0,'2022-03-03 13:04:13','2022-03-03 13:04:13'),(78379,233,'Swarup Nagar','208002',1,0,'2022-03-03 13:04:13','2022-03-03 13:04:13'),(78380,233,'Syyed Nagar Post Office','208019',1,0,'2022-03-03 13:04:13','2022-03-03 13:04:13'),(78381,233,'T P Nagar','208023',1,0,'2022-03-03 13:04:13','2022-03-03 13:04:13'),(78382,233,'Tatya Ganj','209217',1,0,'2022-03-03 13:04:13','2022-03-03 13:04:13'),(78383,233,'Taudhakpur','208021',1,0,'2022-03-03 13:04:13','2022-03-03 13:04:13'),(78384,233,'Tikra','209217',1,0,'2022-03-03 13:04:14','2022-03-03 13:04:14'),(78385,233,'Tilsahari','209402',1,0,'2022-03-03 13:04:14','2022-03-03 13:04:14'),(78386,233,'Udaipur','209214',1,0,'2022-03-03 13:04:14','2022-03-03 13:04:14'),(78387,233,'Udyog Nagar (Kanpur Nagar)','208022',1,0,'2022-03-03 13:04:14','2022-03-03 13:04:14'),(78388,233,'Vijai Nagar (Kanpur Nagar)','208005',1,0,'2022-03-03 13:04:14','2022-03-03 13:04:14'),(78389,233,'Yashoda Nagar','208011',1,0,'2022-03-03 13:04:14','2022-03-03 13:04:14'),(78390,233,'Chaubepur','209203',1,0,'2022-03-03 13:04:14','2022-03-03 13:04:14'),(78391,233,'Ghatampur','209206',1,0,'2022-03-03 13:04:14','2022-03-03 13:04:14'),(78392,234,'Afjalpurwari','212217',1,0,'2022-03-03 13:04:14','2022-03-03 13:04:14'),(78393,234,'Afzalpur Saton','212205',1,0,'2022-03-03 13:04:14','2022-03-03 13:04:14'),(78394,234,'Alam Chand','212213',1,0,'2022-03-03 13:04:14','2022-03-03 13:04:14'),(78395,234,'Alipur Jeeta','212205',1,0,'2022-03-03 13:04:14','2022-03-03 13:04:14'),(78396,234,'Alwara','212214',1,0,'2022-03-03 13:04:14','2022-03-03 13:04:14'),(78397,234,'Amirsa','212202',1,0,'2022-03-03 13:04:14','2022-03-03 13:04:14'),(78398,234,'Andhawan','212214',1,0,'2022-03-03 13:04:14','2022-03-03 13:04:14'),(78399,234,'Anetha','212217',1,0,'2022-03-03 13:04:14','2022-03-03 13:04:14'),(78400,234,'Arkamahabirpur','212216',1,0,'2022-03-03 13:04:14','2022-03-03 13:04:14'),(78401,234,'Audhan','212218',1,0,'2022-03-03 13:04:14','2022-03-03 13:04:14'),(78402,234,'Aureni','212205',1,0,'2022-03-03 13:04:14','2022-03-03 13:04:14'),(78403,234,'Badagaon','212203',1,0,'2022-03-03 13:04:14','2022-03-03 13:04:14'),(78404,234,'Bairampur','212214',1,0,'2022-03-03 13:04:14','2022-03-03 13:04:14'),(78405,234,'Balak Mau','212201',1,0,'2022-03-03 13:04:14','2022-03-03 13:04:14'),(78406,234,'Balipur Tata','212203',1,0,'2022-03-03 13:04:14','2022-03-03 13:04:14'),(78407,234,'Bandhawa Rajwar','212207',1,0,'2022-03-03 13:04:15','2022-03-03 13:04:15'),(78408,234,'Bandhuri Rasulipur','212216',1,0,'2022-03-03 13:04:15','2022-03-03 13:04:15'),(78409,234,'Banthari','212216',1,0,'2022-03-03 13:04:15','2022-03-03 13:04:15'),(78410,234,'Barat Fariq','212217',1,0,'2022-03-03 13:04:15','2022-03-03 13:04:15'),(78411,234,'Basuhar','212216',1,0,'2022-03-03 13:04:15','2022-03-03 13:04:15'),(78412,234,'Begumsarai','211011',1,0,'2022-03-03 13:04:15','2022-03-03 13:04:15'),(78413,234,'Berauncha','212216',1,0,'2022-03-03 13:04:15','2022-03-03 13:04:15'),(78414,234,'Beruwa','212203',1,0,'2022-03-03 13:04:15','2022-03-03 13:04:15'),(78415,234,'Bhadehri','212217',1,0,'2022-03-03 13:04:15','2022-03-03 13:04:15'),(78416,234,'Bhakanda','212216',1,0,'2022-03-03 13:04:15','2022-03-03 13:04:15'),(78417,234,'Bharwari (Kaushambi)','212201',1,0,'2022-03-03 13:04:15','2022-03-03 13:04:15'),(78418,234,'Bhelkha','212207',1,0,'2022-03-03 13:04:15','2022-03-03 13:04:15'),(78419,234,'Bhikhpur Mendwara','212202',1,0,'2022-03-03 13:04:15','2022-03-03 13:04:15'),(78420,234,'Bidaom','212206',1,0,'2022-03-03 13:04:15','2022-03-03 13:04:15'),(78421,234,'Bigahra Usmanpur','212218',1,0,'2022-03-03 13:04:15','2022-03-03 13:04:15'),(78422,234,'Bisara','212201',1,0,'2022-03-03 13:04:15','2022-03-03 13:04:15'),(78423,234,'Boonda','212202',1,0,'2022-03-03 13:04:15','2022-03-03 13:04:15'),(78424,234,'Chail (Kaushambi)','212202',1,0,'2022-03-03 13:04:15','2022-03-03 13:04:15'),(78425,234,'Chalauli','212202',1,0,'2022-03-03 13:04:15','2022-03-03 13:04:15'),(78426,234,'Champaha Bazar','212214',1,0,'2022-03-03 13:04:15','2022-03-03 13:04:15'),(78427,234,'Dariyapur Majhiyawan','212201',1,0,'2022-03-03 13:04:15','2022-03-03 13:04:15'),(78428,234,'Dharampur','212216',1,0,'2022-03-03 13:04:15','2022-03-03 13:04:15'),(78429,234,'Dorma','212217',1,0,'2022-03-03 13:04:15','2022-03-03 13:04:15'),(78430,234,'Faridpur Salem','212202',1,0,'2022-03-03 13:04:15','2022-03-03 13:04:15'),(78431,234,'Ganpa','212217',1,0,'2022-03-03 13:04:16','2022-03-03 13:04:16'),(78432,234,'Gauhani Badi','212203',1,0,'2022-03-03 13:04:16','2022-03-03 13:04:16'),(78433,234,'Goraju','212214',1,0,'2022-03-03 13:04:16','2022-03-03 13:04:16'),(78434,234,'Govindpur Goriyon','212217',1,0,'2022-03-03 13:04:16','2022-03-03 13:04:16'),(78435,234,'Guwara Gayyabpur','212201',1,0,'2022-03-03 13:04:16','2022-03-03 13:04:16'),(78436,234,'Harraipur','212216',1,0,'2022-03-03 13:04:16','2022-03-03 13:04:16'),(78437,234,'Hasanpur','212216',1,0,'2022-03-03 13:04:16','2022-03-03 13:04:16'),(78438,234,'Hinauta','212207',1,0,'2022-03-03 13:04:16','2022-03-03 13:04:16'),(78439,234,'Hisambad','212216',1,0,'2022-03-03 13:04:16','2022-03-03 13:04:16'),(78440,234,'Imli Gaon','212218',1,0,'2022-03-03 13:04:16','2022-03-03 13:04:16'),(78441,234,'Inguwa (Kathgaon)','212202',1,0,'2022-03-03 13:04:16','2022-03-03 13:04:16'),(78442,234,'Jahangirabad','212204',1,0,'2022-03-03 13:04:16','2022-03-03 13:04:16'),(78443,234,'Jalalpur Sana','212202',1,0,'2022-03-03 13:04:16','2022-03-03 13:04:16'),(78444,234,'Jayantipur','212202',1,0,'2022-03-03 13:04:16','2022-03-03 13:04:16'),(78445,234,'Kadipur','212207',1,0,'2022-03-03 13:04:16','2022-03-03 13:04:16'),(78446,234,'Kaju','212203',1,0,'2022-03-03 13:04:16','2022-03-03 13:04:16'),(78447,234,'Kakorha','212201',1,0,'2022-03-03 13:04:16','2022-03-03 13:04:16'),(78448,234,'Kanaili','212216',1,0,'2022-03-03 13:04:16','2022-03-03 13:04:16'),(78449,234,'Kanwar','212217',1,0,'2022-03-03 13:04:16','2022-03-03 13:04:16'),(78450,234,'Kara','212205',1,0,'2022-03-03 13:04:16','2022-03-03 13:04:16'),(78451,234,'Karari','212206',1,0,'2022-03-03 13:04:16','2022-03-03 13:04:16'),(78452,234,'Kasenda','212202',1,0,'2022-03-03 13:04:17','2022-03-03 13:04:17'),(78453,234,'Kasia Pashchim','212201',1,0,'2022-03-03 13:04:17','2022-03-03 13:04:17'),(78454,234,'Kasia Purab','212201',1,0,'2022-03-03 13:04:17','2022-03-03 13:04:17'),(78455,234,'Katari','212214',1,0,'2022-03-03 13:04:17','2022-03-03 13:04:17'),(78456,234,'Kaushambi','212214',1,0,'2022-03-03 13:04:17','2022-03-03 13:04:17'),(78457,234,'Khandeora','212203',1,0,'2022-03-03 13:04:17','2022-03-03 13:04:17'),(78458,234,'Khonpa','212216',1,0,'2022-03-03 13:04:17','2022-03-03 13:04:17'),(78459,234,'Kokhraj','212201',1,0,'2022-03-03 13:04:17','2022-03-03 13:04:17'),(78460,234,'Korion','212205',1,0,'2022-03-03 13:04:17','2022-03-03 13:04:17'),(78461,234,'Kumbhiyawan','212207',1,0,'2022-03-03 13:04:17','2022-03-03 13:04:17'),(78462,234,'Kurron','212207',1,0,'2022-03-03 13:04:17','2022-03-03 13:04:17'),(78463,234,'Lokipur','212203',1,0,'2022-03-03 13:04:17','2022-03-03 13:04:17'),(78464,234,'Mahgaon','212213',1,0,'2022-03-03 13:04:17','2022-03-03 13:04:17'),(78465,234,'Mahila','212216',1,0,'2022-03-03 13:04:17','2022-03-03 13:04:17'),(78466,234,'Manjhanpur','212207',1,0,'2022-03-03 13:04:17','2022-03-03 13:04:17'),(78467,234,'Mawai','212207',1,0,'2022-03-03 13:04:17','2022-03-03 13:04:17'),(78468,234,'Mohabbatpur Painsa','212217',1,0,'2022-03-03 13:04:17','2022-03-03 13:04:17'),(78469,234,'Nara','212217',1,0,'2022-03-03 13:04:17','2022-03-03 13:04:17'),(78470,234,'Naugira','212207',1,0,'2022-03-03 13:04:17','2022-03-03 13:04:17'),(78471,234,'Nawawan','212204',1,0,'2022-03-03 13:04:17','2022-03-03 13:04:17'),(78472,234,'Newada','212401',1,0,'2022-03-03 13:04:17','2022-03-03 13:04:17'),(78473,234,'Newada','212507',1,0,'2022-03-03 13:04:17','2022-03-03 13:04:17'),(78474,234,'Nidura','212217',1,0,'2022-03-03 13:04:17','2022-03-03 13:04:17'),(78475,234,'Noorpur','212218',1,0,'2022-03-03 13:04:18','2022-03-03 13:04:18'),(78476,234,'Osa','212207',1,0,'2022-03-03 13:04:18','2022-03-03 13:04:18'),(78477,234,'Paras','212205',1,0,'2022-03-03 13:04:18','2022-03-03 13:04:18'),(78478,234,'Pashchim Sarira','212214',1,0,'2022-03-03 13:04:18','2022-03-03 13:04:18'),(78479,234,'Pura Mufti ED','212208',1,0,'2022-03-03 13:04:18','2022-03-03 13:04:18'),(78480,234,'Purab Sarira','212214',1,0,'2022-03-03 13:04:18','2022-03-03 13:04:18'),(78481,234,'Ramaipur','212214',1,0,'2022-03-03 13:04:18','2022-03-03 13:04:18'),(78482,234,'Rampur Dhamawan','212217',1,0,'2022-03-03 13:04:18','2022-03-03 13:04:18'),(78483,234,'Raxwara','212206',1,0,'2022-03-03 13:04:18','2022-03-03 13:04:18'),(78484,234,'Samsabad','212217',1,0,'2022-03-03 13:04:18','2022-03-03 13:04:18'),(78485,234,'Sarai Akil','212216',1,0,'2022-03-03 13:04:18','2022-03-03 13:04:18'),(78486,234,'Sarswan','212207',1,0,'2022-03-03 13:04:18','2022-03-03 13:04:18'),(78487,234,'Selraha','212217',1,0,'2022-03-03 13:04:18','2022-03-03 13:04:18'),(78488,234,'Shahjadpur ED','212204',1,0,'2022-03-03 13:04:18','2022-03-03 13:04:18'),(78489,234,'Shahpur','212207',1,0,'2022-03-03 13:04:18','2022-03-03 13:04:18'),(78490,234,'Shakha','212217',1,0,'2022-03-03 13:04:18','2022-03-03 13:04:18'),(78491,234,'Sirathu','212217',1,0,'2022-03-03 13:04:18','2022-03-03 13:04:18'),(78492,234,'Siyara Mithepur','212217',1,0,'2022-03-03 13:04:18','2022-03-03 13:04:18'),(78493,234,'Tanda','212217',1,0,'2022-03-03 13:04:18','2022-03-03 13:04:18'),(78494,234,'Ten Shah Aimabad','212207',1,0,'2022-03-03 13:04:18','2022-03-03 13:04:18'),(78495,234,'Tewa','212207',1,0,'2022-03-03 13:04:19','2022-03-03 13:04:19'),(78496,234,'Tilgodi','212202',1,0,'2022-03-03 13:04:19','2022-03-03 13:04:19'),(78497,234,'Tilhapur','212218',1,0,'2022-03-03 13:04:19','2022-03-03 13:04:19'),(78498,234,'Tulsipur','212217',1,0,'2022-03-03 13:04:19','2022-03-03 13:04:19'),(78499,234,'Udhinbuzurg','212217',1,0,'2022-03-03 13:04:19','2022-03-03 13:04:19'),(78500,234,'Vaish Kanti','212206',1,0,'2022-03-03 13:04:19','2022-03-03 13:04:19'),(78501,234,'Yugrajpur','212216',1,0,'2022-03-03 13:04:19','2022-03-03 13:04:19'),(78502,234,'Zafarpur Mahawan','212206',1,0,'2022-03-03 13:04:19','2022-03-03 13:04:19'),(78503,235,'Abgawan','262727',1,0,'2022-03-03 13:04:19','2022-03-03 13:04:19'),(78504,235,'Abhayapur','262724',1,0,'2022-03-03 13:04:19','2022-03-03 13:04:19'),(78505,235,'Adalispur','262722',1,0,'2022-03-03 13:04:19','2022-03-03 13:04:19'),(78506,235,'Adlabad','262903',1,0,'2022-03-03 13:04:19','2022-03-03 13:04:19'),(78507,235,'Aggar Khurd','261506',1,0,'2022-03-03 13:04:19','2022-03-03 13:04:19'),(78508,235,'Ahemad Nagar','262802',1,0,'2022-03-03 13:04:19','2022-03-03 13:04:19'),(78509,235,'Aira','262722',1,0,'2022-03-03 13:04:19','2022-03-03 13:04:19'),(78510,235,'Aira Estate','262722',1,0,'2022-03-03 13:04:19','2022-03-03 13:04:19'),(78511,235,'Ajehora','262804',1,0,'2022-03-03 13:04:19','2022-03-03 13:04:19'),(78512,235,'Akathi','262724',1,0,'2022-03-03 13:04:19','2022-03-03 13:04:19'),(78513,235,'Aliganj','262802',1,0,'2022-03-03 13:04:19','2022-03-03 13:04:19'),(78514,235,'Alipur','261501',1,0,'2022-03-03 13:04:19','2022-03-03 13:04:19'),(78515,235,'Alipur','262802',1,0,'2022-03-03 13:04:19','2022-03-03 13:04:19'),(78516,235,'Ambarsot','262721',1,0,'2022-03-03 13:04:19','2022-03-03 13:04:19'),(78517,235,'Ambora','262901',1,0,'2022-03-03 13:04:19','2022-03-03 13:04:19'),(78518,235,'Amethi','262723',1,0,'2022-03-03 13:04:20','2022-03-03 13:04:20'),(78519,235,'Amir Nagar','262804',1,0,'2022-03-03 13:04:20','2022-03-03 13:04:20'),(78520,235,'Ashok Nagar','262904',1,0,'2022-03-03 13:04:20','2022-03-03 13:04:20'),(78521,235,'Ataria','262902',1,0,'2022-03-03 13:04:20','2022-03-03 13:04:20'),(78522,235,'Atkohana','262728',1,0,'2022-03-03 13:04:20','2022-03-03 13:04:20'),(78523,235,'Aurongabad','261505',1,0,'2022-03-03 13:04:20','2022-03-03 13:04:20'),(78524,235,'Awadhpur','262727',1,0,'2022-03-03 13:04:20','2022-03-03 13:04:20'),(78525,235,'Azan','262802',1,0,'2022-03-03 13:04:20','2022-03-03 13:04:20'),(78526,235,'Baburi','262723',1,0,'2022-03-03 13:04:20','2022-03-03 13:04:20'),(78527,235,'Badagaon','262726',1,0,'2022-03-03 13:04:20','2022-03-03 13:04:20'),(78528,235,'Badalipur','261502',1,0,'2022-03-03 13:04:20','2022-03-03 13:04:20'),(78529,235,'Badhwari Marg','261505',1,0,'2022-03-03 13:04:20','2022-03-03 13:04:20'),(78530,235,'Baghoom','261505',1,0,'2022-03-03 13:04:20','2022-03-03 13:04:20'),(78531,235,'Bagrethi','262804',1,0,'2022-03-03 13:04:20','2022-03-03 13:04:20'),(78532,235,'Baherwa','262701',1,0,'2022-03-03 13:04:20','2022-03-03 13:04:20'),(78533,235,'Baibaha','262805',1,0,'2022-03-03 13:04:20','2022-03-03 13:04:20'),(78534,235,'Baida','262804',1,0,'2022-03-03 13:04:20','2022-03-03 13:04:20'),(78535,235,'Baikuan','261505',1,0,'2022-03-03 13:04:20','2022-03-03 13:04:20'),(78536,235,'Bajaha','262723',1,0,'2022-03-03 13:04:20','2022-03-03 13:04:20'),(78537,235,'Bajahi','262908',1,0,'2022-03-03 13:04:20','2022-03-03 13:04:20'),(78538,235,'Ballipur','262902',1,0,'2022-03-03 13:04:20','2022-03-03 13:04:20'),(78539,235,'Balmia Barkhar','262804',1,0,'2022-03-03 13:04:20','2022-03-03 13:04:20'),(78540,235,'Bamhanpur','262903',1,0,'2022-03-03 13:04:21','2022-03-03 13:04:21'),(78541,235,'Banbirpur','262906',1,0,'2022-03-03 13:04:21','2022-03-03 13:04:21'),(78542,235,'Banika','262725',1,0,'2022-03-03 13:04:21','2022-03-03 13:04:21'),(78543,235,'Banjaria','262726',1,0,'2022-03-03 13:04:21','2022-03-03 13:04:21'),(78544,235,'Bankati','262908',1,0,'2022-03-03 13:04:21','2022-03-03 13:04:21'),(78545,235,'Bankey Ganj','262801',1,0,'2022-03-03 13:04:21','2022-03-03 13:04:21'),(78546,235,'Banshi','262802',1,0,'2022-03-03 13:04:21','2022-03-03 13:04:21'),(78547,235,'Barbar','261505',1,0,'2022-03-03 13:04:21','2022-03-03 13:04:21'),(78548,235,'Barkherwa','262701',1,0,'2022-03-03 13:04:21','2022-03-03 13:04:21'),(78549,235,'Barotha','262903',1,0,'2022-03-03 13:04:21','2022-03-03 13:04:21'),(78550,235,'Basaha','262726',1,0,'2022-03-03 13:04:21','2022-03-03 13:04:21'),(78551,235,'Basahi','262904',1,0,'2022-03-03 13:04:21','2022-03-03 13:04:21'),(78552,235,'Basantapur','262723',1,0,'2022-03-03 13:04:21','2022-03-03 13:04:21'),(78553,235,'Basantapur Kallan','262902',1,0,'2022-03-03 13:04:21','2022-03-03 13:04:21'),(78554,235,'Baudhiya Kallan','262902',1,0,'2022-03-03 13:04:21','2022-03-03 13:04:21'),(78555,235,'Behjam','261501',1,0,'2022-03-03 13:04:21','2022-03-03 13:04:21'),(78556,235,'Bel','261501',1,0,'2022-03-03 13:04:21','2022-03-03 13:04:21'),(78557,235,'Bela Kallan','262902',1,0,'2022-03-03 13:04:21','2022-03-03 13:04:21'),(78558,235,'Belaparsua','262906',1,0,'2022-03-03 13:04:21','2022-03-03 13:04:21'),(78559,235,'Belhori','262805',1,0,'2022-03-03 13:04:21','2022-03-03 13:04:21'),(78560,235,'Belroyan','262906',1,0,'2022-03-03 13:04:21','2022-03-03 13:04:21'),(78561,235,'Beltua','261502',1,0,'2022-03-03 13:04:21','2022-03-03 13:04:21'),(78562,235,'Belwamoti','262722',1,0,'2022-03-03 13:04:21','2022-03-03 13:04:21'),(78563,235,'Beni Rajpur','262804',1,0,'2022-03-03 13:04:22','2022-03-03 13:04:22'),(78564,235,'Betisahdeo','261502',1,0,'2022-03-03 13:04:22','2022-03-03 13:04:22'),(78565,235,'Bhadeliya','261505',1,0,'2022-03-03 13:04:22','2022-03-03 13:04:22'),(78566,235,'Bhaithia','262802',1,0,'2022-03-03 13:04:22','2022-03-03 13:04:22'),(78567,235,'Bhallia Bujurg','262802',1,0,'2022-03-03 13:04:22','2022-03-03 13:04:22'),(78568,235,'Bhanpur','262901',1,0,'2022-03-03 13:04:22','2022-03-03 13:04:22'),(78569,235,'Bhanpuri','262904',1,0,'2022-03-03 13:04:22','2022-03-03 13:04:22'),(78570,235,'Bhatpurwa Kallan','262723',1,0,'2022-03-03 13:04:22','2022-03-03 13:04:22'),(78571,235,'Bhedhia','261502',1,0,'2022-03-03 13:04:22','2022-03-03 13:04:22'),(78572,235,'Bheekhampur','262805',1,0,'2022-03-03 13:04:22','2022-03-03 13:04:22'),(78573,235,'Bhira Ghanshi','262721',1,0,'2022-03-03 13:04:22','2022-03-03 13:04:22'),(78574,235,'Bhira (Kheri)','262901',1,0,'2022-03-03 13:04:22','2022-03-03 13:04:22'),(78575,235,'Bhoolanpur','261501',1,0,'2022-03-03 13:04:22','2022-03-03 13:04:22'),(78576,235,'Bhoora','262908',1,0,'2022-03-03 13:04:22','2022-03-03 13:04:22'),(78577,235,'Bhupatipur','262805',1,0,'2022-03-03 13:04:22','2022-03-03 13:04:22'),(78578,235,'Bijauria','262902',1,0,'2022-03-03 13:04:22','2022-03-03 13:04:22'),(78579,235,'Bijhauli','262701',1,0,'2022-03-03 13:04:22','2022-03-03 13:04:22'),(78580,235,'Bijhauli Sahaspur','262804',1,0,'2022-03-03 13:04:22','2022-03-03 13:04:22'),(78581,235,'Bijua','262901',1,0,'2022-03-03 13:04:22','2022-03-03 13:04:22'),(78582,235,'Binaura','262903',1,0,'2022-03-03 13:04:22','2022-03-03 13:04:22'),(78583,235,'Birampur','262727',1,0,'2022-03-03 13:04:22','2022-03-03 13:04:22'),(78584,235,'Bisani Khera','261505',1,0,'2022-03-03 13:04:22','2022-03-03 13:04:22'),(78585,235,'Bisenpuri','262902',1,0,'2022-03-03 13:04:23','2022-03-03 13:04:23'),(78586,235,'Bokhari','262802',1,0,'2022-03-03 13:04:23','2022-03-03 13:04:23'),(78587,235,'Borbata','262908',1,0,'2022-03-03 13:04:23','2022-03-03 13:04:23'),(78588,235,'Chakai','262726',1,0,'2022-03-03 13:04:23','2022-03-03 13:04:23'),(78589,235,'Chakmusepur','262722',1,0,'2022-03-03 13:04:23','2022-03-03 13:04:23'),(78590,235,'Chandan Chauki','262908',1,0,'2022-03-03 13:04:23','2022-03-03 13:04:23'),(78591,235,'Chandia Hajara','262904',1,0,'2022-03-03 13:04:23','2022-03-03 13:04:23'),(78592,235,'Chandrasa Kallan','261502',1,0,'2022-03-03 13:04:23','2022-03-03 13:04:23'),(78593,235,'Chhedia Pashchim','262908',1,0,'2022-03-03 13:04:23','2022-03-03 13:04:23'),(78594,235,'Chheduipattia','262902',1,0,'2022-03-03 13:04:23','2022-03-03 13:04:23'),(78595,235,'Chhitaunia','262802',1,0,'2022-03-03 13:04:23','2022-03-03 13:04:23'),(78596,235,'Dareri','262907',1,0,'2022-03-03 13:04:23','2022-03-03 13:04:23'),(78597,235,'Darpurwa','262723',1,0,'2022-03-03 13:04:23','2022-03-03 13:04:23'),(78598,235,'Daudpur','261506',1,0,'2022-03-03 13:04:23','2022-03-03 13:04:23'),(78599,235,'Daulatpur','262903',1,0,'2022-03-03 13:04:23','2022-03-03 13:04:23'),(78600,235,'Deokali','262701',1,0,'2022-03-03 13:04:23','2022-03-03 13:04:23'),(78601,235,'Dhakherwa','262907',1,0,'2022-03-03 13:04:23','2022-03-03 13:04:23'),(78602,235,'Dhakherwa Khalsa','262907',1,0,'2022-03-03 13:04:23','2022-03-03 13:04:23'),(78603,235,'Dhakherwa Nankar','262907',1,0,'2022-03-03 13:04:23','2022-03-03 13:04:23'),(78604,235,'Dhakia','262908',1,0,'2022-03-03 13:04:23','2022-03-03 13:04:23'),(78605,235,'Dharmapur','262901',1,0,'2022-03-03 13:04:23','2022-03-03 13:04:23'),(78606,235,'Dharmapur','262903',1,0,'2022-03-03 13:04:23','2022-03-03 13:04:23'),(78607,235,'Dhaurahara (Kheri)','262723',1,0,'2022-03-03 13:04:24','2022-03-03 13:04:24'),(78608,235,'Dhoyanpur','262908',1,0,'2022-03-03 13:04:24','2022-03-03 13:04:24'),(78609,235,'Dhusaru','262725',1,0,'2022-03-03 13:04:24','2022-03-03 13:04:24'),(78610,235,'Dhuskiya','262908',1,0,'2022-03-03 13:04:24','2022-03-03 13:04:24'),(78611,235,'Dubaha','262903',1,0,'2022-03-03 13:04:24','2022-03-03 13:04:24'),(78612,235,'Dudwaghat','262902',1,0,'2022-03-03 13:04:24','2022-03-03 13:04:24'),(78613,235,'Dulahi','262724',1,0,'2022-03-03 13:04:24','2022-03-03 13:04:24'),(78614,235,'Durgapur Padari','261502',1,0,'2022-03-03 13:04:24','2022-03-03 13:04:24'),(78615,235,'Fardhan','262701',1,0,'2022-03-03 13:04:24','2022-03-03 13:04:24'),(78616,235,'Farenda','262804',1,0,'2022-03-03 13:04:24','2022-03-03 13:04:24'),(78617,235,'Fatepur','261505',1,0,'2022-03-03 13:04:24','2022-03-03 13:04:24'),(78618,235,'Firozabad','261502',1,0,'2022-03-03 13:04:24','2022-03-03 13:04:24'),(78619,235,'G.T. Amethi','262724',1,0,'2022-03-03 13:04:24','2022-03-03 13:04:24'),(78620,235,'Gadania','262906',1,0,'2022-03-03 13:04:24','2022-03-03 13:04:24'),(78621,235,'Gaffar Nagar','262804',1,0,'2022-03-03 13:04:24','2022-03-03 13:04:24'),(78622,235,'Gaisapur','262722',1,0,'2022-03-03 13:04:24','2022-03-03 13:04:24'),(78623,235,'Ganeshpur','261502',1,0,'2022-03-03 13:04:24','2022-03-03 13:04:24'),(78624,235,'Ganeshpur','262701',1,0,'2022-03-03 13:04:24','2022-03-03 13:04:24'),(78625,235,'Ganga Nagar','262906',1,0,'2022-03-03 13:04:24','2022-03-03 13:04:24'),(78626,235,'Gaura','261506',1,0,'2022-03-03 13:04:24','2022-03-03 13:04:24'),(78627,235,'Gaura','261502',1,0,'2022-03-03 13:04:24','2022-03-03 13:04:24'),(78628,235,'Gauri Fanta','262902',1,0,'2022-03-03 13:04:24','2022-03-03 13:04:24'),(78629,235,'Gauria','261501',1,0,'2022-03-03 13:04:24','2022-03-03 13:04:24'),(78630,235,'Gharthania','262802',1,0,'2022-03-03 13:04:24','2022-03-03 13:04:24'),(78631,235,'Ghumara Madera','262805',1,0,'2022-03-03 13:04:24','2022-03-03 13:04:24'),(78632,235,'Ghur Ghutta Bujurg','262724',1,0,'2022-03-03 13:04:25','2022-03-03 13:04:25'),(78633,235,'Gokan','262804',1,0,'2022-03-03 13:04:25','2022-03-03 13:04:25'),(78634,235,'Gola Gokaran Nath','262802',1,0,'2022-03-03 13:04:25','2022-03-03 13:04:25'),(78635,235,'Gola Town','262802',1,0,'2022-03-03 13:04:25','2022-03-03 13:04:25'),(78636,235,'Gopalapur','261502',1,0,'2022-03-03 13:04:25','2022-03-03 13:04:25'),(78637,235,'Gopalapur','262702',1,0,'2022-03-03 13:04:25','2022-03-03 13:04:25'),(78638,235,'Grant No.-11','262802',1,0,'2022-03-03 13:04:25','2022-03-03 13:04:25'),(78639,235,'Gudaria','262723',1,0,'2022-03-03 13:04:25','2022-03-03 13:04:25'),(78640,235,'Gularia Pathor Shah','262906',1,0,'2022-03-03 13:04:25','2022-03-03 13:04:25'),(78641,235,'Gulauli','262804',1,0,'2022-03-03 13:04:25','2022-03-03 13:04:25'),(78642,235,'Haiderabad','262802',1,0,'2022-03-03 13:04:25','2022-03-03 13:04:25'),(78643,235,'Hasanpur Katauli','261502',1,0,'2022-03-03 13:04:25','2022-03-03 13:04:25'),(78644,235,'Haukana','262724',1,0,'2022-03-03 13:04:25','2022-03-03 13:04:25'),(78645,235,'Hazaratpur','262801',1,0,'2022-03-03 13:04:25','2022-03-03 13:04:25'),(78646,235,'Hindustan Farm','262801',1,0,'2022-03-03 13:04:25','2022-03-03 13:04:25'),(78647,235,'Isanagar (Kheri)','261502',1,0,'2022-03-03 13:04:25','2022-03-03 13:04:25'),(78648,235,'Itauwa','262804',1,0,'2022-03-03 13:04:25','2022-03-03 13:04:25'),(78649,235,'Jalalpur','262802',1,0,'2022-03-03 13:04:25','2022-03-03 13:04:25'),(78650,235,'Jamhaura','262907',1,0,'2022-03-03 13:04:25','2022-03-03 13:04:25'),(78651,235,'Jamunabad Form','262802',1,0,'2022-03-03 13:04:25','2022-03-03 13:04:25'),(78652,235,'Jangbahadur Ganj','261505',1,0,'2022-03-03 13:04:25','2022-03-03 13:04:25'),(78653,235,'Jatpurwa','262724',1,0,'2022-03-03 13:04:25','2022-03-03 13:04:25'),(78654,235,'Jethra','262722',1,0,'2022-03-03 13:04:25','2022-03-03 13:04:25'),(78655,235,'Jhandi Raj','262903',1,0,'2022-03-03 13:04:25','2022-03-03 13:04:25'),(78656,235,'Kabir Ganj','262904',1,0,'2022-03-03 13:04:26','2022-03-03 13:04:26'),(78657,235,'Kadia','262906',1,0,'2022-03-03 13:04:26','2022-03-03 13:04:26'),(78658,235,'Kafara','262723',1,0,'2022-03-03 13:04:26','2022-03-03 13:04:26'),(78659,235,'Kaimahara','261505',1,0,'2022-03-03 13:04:26','2022-03-03 13:04:26'),(78660,235,'Kaimahra','262701',1,0,'2022-03-03 13:04:26','2022-03-03 13:04:26'),(78661,235,'Kajaria','262908',1,0,'2022-03-03 13:04:26','2022-03-03 13:04:26'),(78662,235,'Kakaraha','261505',1,0,'2022-03-03 13:04:26','2022-03-03 13:04:26'),(78663,235,'Kalaam','262701',1,0,'2022-03-03 13:04:26','2022-03-03 13:04:26'),(78664,235,'Kaluamoti','261505',1,0,'2022-03-03 13:04:26','2022-03-03 13:04:26'),(78665,235,'Kanchanpur','262802',1,0,'2022-03-03 13:04:26','2022-03-03 13:04:26'),(78666,235,'Kaparaha','262802',1,0,'2022-03-03 13:04:26','2022-03-03 13:04:26'),(78667,235,'Karanpur','261501',1,0,'2022-03-03 13:04:26','2022-03-03 13:04:26'),(78668,235,'Kasta','261501',1,0,'2022-03-03 13:04:26','2022-03-03 13:04:26'),(78669,235,'Kathkusuma','262728',1,0,'2022-03-03 13:04:26','2022-03-03 13:04:26'),(78670,235,'Khairigarh','262905',1,0,'2022-03-03 13:04:26','2022-03-03 13:04:26'),(78671,235,'Khamaria','261505',1,0,'2022-03-03 13:04:26','2022-03-03 13:04:26'),(78672,235,'Khamaria Kallan','261502',1,0,'2022-03-03 13:04:26','2022-03-03 13:04:26'),(78673,235,'Khambhar Khera','261506',1,0,'2022-03-03 13:04:26','2022-03-03 13:04:26'),(78674,235,'Khanjan Nagar','262727',1,0,'2022-03-03 13:04:26','2022-03-03 13:04:26'),(78675,235,'Khanjanpur','262801',1,0,'2022-03-03 13:04:26','2022-03-03 13:04:26'),(78676,235,'Khanpur Gurela','262725',1,0,'2022-03-03 13:04:26','2022-03-03 13:04:26'),(78677,235,'Kharbahia','262723',1,0,'2022-03-03 13:04:26','2022-03-03 13:04:26'),(78678,235,'Khargapur','262802',1,0,'2022-03-03 13:04:26','2022-03-03 13:04:26'),(78679,235,'Khawahia No 2','262907',1,0,'2022-03-03 13:04:26','2022-03-03 13:04:26'),(78680,235,'Kheri H.O','262701',1,0,'2022-03-03 13:04:26','2022-03-03 13:04:26'),(78681,235,'Kheri Town','262702',1,0,'2022-03-03 13:04:26','2022-03-03 13:04:26'),(78682,235,'Khunti Bujurg','261505',1,0,'2022-03-03 13:04:27','2022-03-03 13:04:27'),(78683,235,'Kiriyara','262804',1,0,'2022-03-03 13:04:27','2022-03-03 13:04:27'),(78684,235,'Kothia','262726',1,0,'2022-03-03 13:04:27','2022-03-03 13:04:27'),(78685,235,'Kotwa','262805',1,0,'2022-03-03 13:04:27','2022-03-03 13:04:27'),(78686,235,'Kotwora Raj','262802',1,0,'2022-03-03 13:04:27','2022-03-03 13:04:27'),(78687,235,'Kuaudiyala Ghat','262906',1,0,'2022-03-03 13:04:27','2022-03-03 13:04:27'),(78688,235,'Kukra Town','262801',1,0,'2022-03-03 13:04:27','2022-03-03 13:04:27'),(78689,235,'Kumbhi','262804',1,0,'2022-03-03 13:04:27','2022-03-03 13:04:27'),(78690,235,'Kumhaina','262722',1,0,'2022-03-03 13:04:27','2022-03-03 13:04:27'),(78691,235,'Kusumi','261505',1,0,'2022-03-03 13:04:27','2022-03-03 13:04:27'),(78692,235,'Lagucha','262721',1,0,'2022-03-03 13:04:27','2022-03-03 13:04:27'),(78693,235,'Lahabari','262723',1,0,'2022-03-03 13:04:27','2022-03-03 13:04:27'),(78694,235,'Lakhaha','261501',1,0,'2022-03-03 13:04:27','2022-03-03 13:04:27'),(78695,235,'Lakhimpur','262701',1,0,'2022-03-03 13:04:27','2022-03-03 13:04:27'),(78696,235,'Lakhperaganj','262701',1,0,'2022-03-03 13:04:27','2022-03-03 13:04:27'),(78697,235,'Lakhun','262722',1,0,'2022-03-03 13:04:27','2022-03-03 13:04:27'),(78698,235,'Lalhaua','262727',1,0,'2022-03-03 13:04:27','2022-03-03 13:04:27'),(78699,235,'Laukahi Isanagar','261502',1,0,'2022-03-03 13:04:27','2022-03-03 13:04:27'),(78700,235,'Laukahi Mallapur','261502',1,0,'2022-03-03 13:04:27','2022-03-03 13:04:27'),(78701,235,'Lauki Khera','262804',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78702,235,'Laukiha','261506',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78703,235,'Lidhiyayi','261505',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78704,235,'Lokesor','262701',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78705,235,'Londonpur Grant','262802',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78706,235,'Ludhauri','262903',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78707,235,'Machhechha','262804',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78708,235,'Madhwapur Barola','261506',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78709,235,'Madwa','262722',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78710,235,'Magadapur','262804',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78711,235,'Mahadeo Atra','262721',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78712,235,'Mahangapur','262902',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78713,235,'Mahangukhera','262721',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78714,235,'Maharaj Nagar','262722',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78715,235,'Maharaj Nagar','262701',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78716,235,'Maheshpur','262802',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78717,235,'Mahewa Ganj','261506',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78718,235,'Maigal Ganj','261505',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78719,235,'Mailani Gram','262803',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78720,235,'Mailani','262803',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78721,235,'Majhgain','262902',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78722,235,'Maksudpur','261505',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78723,235,'Mallbehar','262724',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78724,235,'Mamari','262805',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78725,235,'Manjha','262906',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78726,235,'Manyora','262701',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78727,235,'Marocha','262902',1,0,'2022-03-03 13:04:28','2022-03-03 13:04:28'),(78728,235,'Masor Khambh','262908',1,0,'2022-03-03 13:04:29','2022-03-03 13:04:29'),(78729,235,'Matehia','262901',1,0,'2022-03-03 13:04:29','2022-03-03 13:04:29'),(78730,235,'Meerpur','262701',1,0,'2022-03-03 13:04:29','2022-03-03 13:04:29'),(78731,235,'Midania','262722',1,0,'2022-03-03 13:04:29','2022-03-03 13:04:29'),(78732,235,'Midania','262701',1,0,'2022-03-03 13:04:29','2022-03-03 13:04:29'),(78733,235,'Mitauli','262727',1,0,'2022-03-03 13:04:29','2022-03-03 13:04:29'),(78734,235,'Mohammadapur','262722',1,0,'2022-03-03 13:04:29','2022-03-03 13:04:29'),(78735,235,'Mohammadi','262804',1,0,'2022-03-03 13:04:29','2022-03-03 13:04:29'),(78736,235,'Mohammadpur Mahewa','262721',1,0,'2022-03-03 13:04:29','2022-03-03 13:04:29'),(78737,235,'Mohammadpur Nazir','261505',1,0,'2022-03-03 13:04:29','2022-03-03 13:04:29'),(78738,235,'Mohammadpur Tajpur','262804',1,0,'2022-03-03 13:04:29','2022-03-03 13:04:29'),(78739,235,'Mohammdabad','262802',1,0,'2022-03-03 13:04:29','2022-03-03 13:04:29'),(78740,235,'Mohchanapur','261502',1,0,'2022-03-03 13:04:29','2022-03-03 13:04:29'),(78741,235,'Mohiddunpur','261505',1,0,'2022-03-03 13:04:29','2022-03-03 13:04:29'),(78742,235,'Mohola','262721',1,0,'2022-03-03 13:04:29','2022-03-03 13:04:29'),(78743,235,'Morania Gandhi Nagar','262904',1,0,'2022-03-03 13:04:29','2022-03-03 13:04:29'),(78744,235,'Motipur','262905',1,0,'2022-03-03 13:04:29','2022-03-03 13:04:29'),(78745,235,'Motipur','262725',1,0,'2022-03-03 13:04:29','2022-03-03 13:04:29'),(78746,235,'Muborakpur','261505',1,0,'2022-03-03 13:04:29','2022-03-03 13:04:29'),(78747,235,'Muda Bujurg','262903',1,0,'2022-03-03 13:04:29','2022-03-03 13:04:29'),(78748,235,'Muda Ghalib','262804',1,0,'2022-03-03 13:04:29','2022-03-03 13:04:29'),(78749,235,'Muda Sawaran','262802',1,0,'2022-03-03 13:04:29','2022-03-03 13:04:29'),(78750,235,'Mudi','261502',1,0,'2022-03-03 13:04:30','2022-03-03 13:04:30'),(78751,235,'Mudia','262805',1,0,'2022-03-03 13:04:30','2022-03-03 13:04:30'),(78752,235,'Mudia Khera','262701',1,0,'2022-03-03 13:04:30','2022-03-03 13:04:30'),(78753,235,'Mudia Puja Gaon','261506',1,0,'2022-03-03 13:04:30','2022-03-03 13:04:30'),(78754,235,'Mukhalishpur','261502',1,0,'2022-03-03 13:04:30','2022-03-03 13:04:30'),(78755,235,'Mullapur','261505',1,0,'2022-03-03 13:04:30','2022-03-03 13:04:30'),(78756,235,'Murtiha','262701',1,0,'2022-03-03 13:04:30','2022-03-03 13:04:30'),(78757,235,'Naibasti','262701',1,0,'2022-03-03 13:04:30','2022-03-03 13:04:30'),(78758,235,'Nainapur','262724',1,0,'2022-03-03 13:04:30','2022-03-03 13:04:30'),(78759,235,'Nakha','262728',1,0,'2022-03-03 13:04:30','2022-03-03 13:04:30'),(78760,235,'Nakia Khera','261505',1,0,'2022-03-03 13:04:30','2022-03-03 13:04:30'),(78761,235,'Naribehar','261502',1,0,'2022-03-03 13:04:30','2022-03-03 13:04:30'),(78762,235,'Nauapur Ghat','262728',1,0,'2022-03-03 13:04:30','2022-03-03 13:04:30'),(78763,235,'Naubana','262905',1,0,'2022-03-03 13:04:30','2022-03-03 13:04:30'),(78764,235,'Naurangabad','262905',1,0,'2022-03-03 13:04:30','2022-03-03 13:04:30'),(78765,235,'Nauser Gularia','262901',1,0,'2022-03-03 13:04:30','2022-03-03 13:04:30'),(78766,235,'Nayagaon','261505',1,0,'2022-03-03 13:04:30','2022-03-03 13:04:30'),(78767,235,'Nayagaon Jat','261505',1,0,'2022-03-03 13:04:30','2022-03-03 13:04:30'),(78768,235,'Neem Cheri','262727',1,0,'2022-03-03 13:04:30','2022-03-03 13:04:30'),(78769,235,'Neemgaon','261501',1,0,'2022-03-03 13:04:30','2022-03-03 13:04:30'),(78770,235,'Nighasan','262903',1,0,'2022-03-03 13:04:30','2022-03-03 13:04:30'),(78771,235,'Nijhota','262908',1,0,'2022-03-03 13:04:30','2022-03-03 13:04:30'),(78772,235,'Nizampur-nighati','262721',1,0,'2022-03-03 13:04:30','2022-03-03 13:04:30'),(78773,235,'Odara','262727',1,0,'2022-03-03 13:04:30','2022-03-03 13:04:30'),(78774,235,'Oel (Kheri)','262725',1,0,'2022-03-03 13:04:30','2022-03-03 13:04:30'),(78775,235,'Padaria Tula','262901',1,0,'2022-03-03 13:04:31','2022-03-03 13:04:31'),(78776,235,'Pahar Nagar','262801',1,0,'2022-03-03 13:04:31','2022-03-03 13:04:31'),(78777,235,'Pahara','261501',1,0,'2022-03-03 13:04:31','2022-03-03 13:04:31'),(78778,235,'Paila','261501',1,0,'2022-03-03 13:04:31','2022-03-03 13:04:31'),(78779,235,'Pakaria','262722',1,0,'2022-03-03 13:04:31','2022-03-03 13:04:31'),(78780,235,'Palhapur','261505',1,0,'2022-03-03 13:04:31','2022-03-03 13:04:31'),(78781,235,'Pallia','262902',1,0,'2022-03-03 13:04:31','2022-03-03 13:04:31'),(78782,235,'Panai','261505',1,0,'2022-03-03 13:04:31','2022-03-03 13:04:31'),(78783,235,'Parasiya','262908',1,0,'2022-03-03 13:04:31','2022-03-03 13:04:31'),(78784,235,'Pareli','262802',1,0,'2022-03-03 13:04:31','2022-03-03 13:04:31'),(78785,235,'Parsehra','262802',1,0,'2022-03-03 13:04:31','2022-03-03 13:04:31'),(78786,235,'Parsehra Madarpur','262805',1,0,'2022-03-03 13:04:31','2022-03-03 13:04:31'),(78787,235,'Pasgawan','261505',1,0,'2022-03-03 13:04:31','2022-03-03 13:04:31'),(78788,235,'Patihan','262902',1,0,'2022-03-03 13:04:31','2022-03-03 13:04:31'),(78789,235,'Patna Baijnatpurwa','262728',1,0,'2022-03-03 13:04:31','2022-03-03 13:04:31'),(78790,235,'PhoolBehad','261506',1,0,'2022-03-03 13:04:31','2022-03-03 13:04:31'),(78791,235,'Phoolpur Gunia','262722',1,0,'2022-03-03 13:04:31','2022-03-03 13:04:31'),(78792,235,'Piparawan','262701',1,0,'2022-03-03 13:04:31','2022-03-03 13:04:31'),(78793,235,'Piparia Dhani','262804',1,0,'2022-03-03 13:04:31','2022-03-03 13:04:31'),(78794,235,'Piparia Form','262728',1,0,'2022-03-03 13:04:31','2022-03-03 13:04:31'),(78795,235,'Piparia Kaptan','262804',1,0,'2022-03-03 13:04:31','2022-03-03 13:04:31'),(78796,235,'Pipra Form','261506',1,0,'2022-03-03 13:04:31','2022-03-03 13:04:31'),(78797,235,'Pipra Goom','261506',1,0,'2022-03-03 13:04:31','2022-03-03 13:04:31'),(78798,235,'Podhua','262907',1,0,'2022-03-03 13:04:31','2022-03-03 13:04:31'),(78799,235,'Pratappur','261506',1,0,'2022-03-03 13:04:32','2022-03-03 13:04:32'),(78800,235,'Puraina','262908',1,0,'2022-03-03 13:04:32','2022-03-03 13:04:32'),(78801,235,'Rabahi','262728',1,0,'2022-03-03 13:04:32','2022-03-03 13:04:32'),(78802,235,'Raipur','261502',1,0,'2022-03-03 13:04:32','2022-03-03 13:04:32'),(78803,235,'Raipur','262906',1,0,'2022-03-03 13:04:32','2022-03-03 13:04:32'),(78804,235,'Raipur','262802',1,0,'2022-03-03 13:04:32','2022-03-03 13:04:32'),(78805,235,'Raipur Ghunshi','262805',1,0,'2022-03-03 13:04:32','2022-03-03 13:04:32'),(78806,235,'Rajgarh','262701',1,0,'2022-03-03 13:04:32','2022-03-03 13:04:32'),(78807,235,'Rakehati','262903',1,0,'2022-03-03 13:04:32','2022-03-03 13:04:32'),(78808,235,'Ram Nagar','262904',1,0,'2022-03-03 13:04:32','2022-03-03 13:04:32'),(78809,235,'Ram Nagar Bagaha','262724',1,0,'2022-03-03 13:04:32','2022-03-03 13:04:32'),(78810,235,'Ram Nagar Khurd','262802',1,0,'2022-03-03 13:04:32','2022-03-03 13:04:32'),(78811,235,'Ramia Behar','262724',1,0,'2022-03-03 13:04:32','2022-03-03 13:04:32'),(78812,235,'Ramlok Kabiraha','261502',1,0,'2022-03-03 13:04:32','2022-03-03 13:04:32'),(78813,235,'Rampur Banwari','261505',1,0,'2022-03-03 13:04:32','2022-03-03 13:04:32'),(78814,235,'Rampur Dotpur','262802',1,0,'2022-03-03 13:04:32','2022-03-03 13:04:32'),(78815,235,'Rampur Gokul','262701',1,0,'2022-03-03 13:04:32','2022-03-03 13:04:32'),(78816,235,'Rampur Grant','262802',1,0,'2022-03-03 13:04:32','2022-03-03 13:04:32'),(78817,235,'Rampur Sutehra','262805',1,0,'2022-03-03 13:04:32','2022-03-03 13:04:32'),(78818,235,'Rangila Nagar','262701',1,0,'2022-03-03 13:04:32','2022-03-03 13:04:32'),(78819,235,'Rara Bazar','262901',1,0,'2022-03-03 13:04:32','2022-03-03 13:04:32'),(78820,235,'Rasulpanah','262802',1,0,'2022-03-03 13:04:32','2022-03-03 13:04:32'),(78821,235,'Rasulpur','262722',1,0,'2022-03-03 13:04:32','2022-03-03 13:04:32'),(78822,235,'Ratasia','261501',1,0,'2022-03-03 13:04:32','2022-03-03 13:04:32'),(78823,235,'Razaganj','262701',1,0,'2022-03-03 13:04:32','2022-03-03 13:04:32'),(78824,235,'Roshan Nagar','262802',1,0,'2022-03-03 13:04:33','2022-03-03 13:04:33'),(78825,235,'Rudrapur Kallan','262721',1,0,'2022-03-03 13:04:33','2022-03-03 13:04:33'),(78826,235,'Rudrapur Salim','261502',1,0,'2022-03-03 13:04:33','2022-03-03 13:04:33'),(78827,235,'Sadhauna','262721',1,0,'2022-03-03 13:04:33','2022-03-03 13:04:33'),(78828,235,'Saidipur Harraiya','262728',1,0,'2022-03-03 13:04:33','2022-03-03 13:04:33'),(78829,235,'Sakethu','262728',1,0,'2022-03-03 13:04:33','2022-03-03 13:04:33'),(78830,235,'Samdoha','262722',1,0,'2022-03-03 13:04:33','2022-03-03 13:04:33'),(78831,235,'Samodidih','262722',1,0,'2022-03-03 13:04:33','2022-03-03 13:04:33'),(78832,235,'Sampurna Nagar','262904',1,0,'2022-03-03 13:04:33','2022-03-03 13:04:33'),(78833,235,'Sandilwa','262727',1,0,'2022-03-03 13:04:33','2022-03-03 13:04:33'),(78834,235,'Sanigawan','261501',1,0,'2022-03-03 13:04:33','2022-03-03 13:04:33'),(78835,235,'Sankata Devi','262701',1,0,'2022-03-03 13:04:33','2022-03-03 13:04:33'),(78836,235,'Sansarpur','262802',1,0,'2022-03-03 13:04:33','2022-03-03 13:04:33'),(78837,235,'Saraunia','261505',1,0,'2022-03-03 13:04:33','2022-03-03 13:04:33'),(78838,235,'Sarsawa','262728',1,0,'2022-03-03 13:04:33','2022-03-03 13:04:33'),(78839,235,'Sasiya Ganj','262804',1,0,'2022-03-03 13:04:33','2022-03-03 13:04:33'),(78840,235,'Saukhiya','262802',1,0,'2022-03-03 13:04:33','2022-03-03 13:04:33'),(78841,235,'Saunaha','262908',1,0,'2022-03-03 13:04:33','2022-03-03 13:04:33'),(78842,235,'Semra (Kheri)','262907',1,0,'2022-03-03 13:04:33','2022-03-03 13:04:33'),(78843,235,'Semrawan','262727',1,0,'2022-03-03 13:04:33','2022-03-03 13:04:33'),(78844,235,'Semri','262724',1,0,'2022-03-03 13:04:33','2022-03-03 13:04:33'),(78845,235,'Sera Bera','262902',1,0,'2022-03-03 13:04:33','2022-03-03 13:04:33'),(78846,235,'Shahpur Japir','262804',1,0,'2022-03-03 13:04:34','2022-03-03 13:04:34'),(78847,235,'Shankarpur','261501',1,0,'2022-03-03 13:04:34','2022-03-03 13:04:34'),(78848,235,'Shankarpur Raja','262804',1,0,'2022-03-03 13:04:34','2022-03-03 13:04:34'),(78849,235,'Sharda Nagar','262726',1,0,'2022-03-03 13:04:34','2022-03-03 13:04:34'),(78850,235,'Shardapuri','262904',1,0,'2022-03-03 13:04:34','2022-03-03 13:04:34'),(78851,235,'Sheopuri','261505',1,0,'2022-03-03 13:04:34','2022-03-03 13:04:34'),(78852,235,'Sheorajpur','261505',1,0,'2022-03-03 13:04:34','2022-03-03 13:04:34'),(78853,235,'Sherpur','262722',1,0,'2022-03-03 13:04:34','2022-03-03 13:04:34'),(78854,235,'Shivpuri (Kheri)','262701',1,0,'2022-03-03 13:04:34','2022-03-03 13:04:34'),(78855,235,'Sikandrabad (Kheri)','262805',1,0,'2022-03-03 13:04:34','2022-03-03 13:04:34'),(78856,235,'Sikatiha Chapkaha','261502',1,0,'2022-03-03 13:04:34','2022-03-03 13:04:34'),(78857,235,'Singaha Kallan','262905',1,0,'2022-03-03 13:04:34','2022-03-03 13:04:34'),(78858,235,'Singahi','262905',1,0,'2022-03-03 13:04:34','2022-03-03 13:04:34'),(78859,235,'Singawar','261502',1,0,'2022-03-03 13:04:34','2022-03-03 13:04:34'),(78860,235,'Sinhauna','262905',1,0,'2022-03-03 13:04:34','2022-03-03 13:04:34'),(78861,235,'Sisaiya Kallan','262723',1,0,'2022-03-03 13:04:34','2022-03-03 13:04:34'),(78862,235,'Sisaura','261506',1,0,'2022-03-03 13:04:34','2022-03-03 13:04:34'),(78863,235,'Sisaura Nasir','262804',1,0,'2022-03-03 13:04:34','2022-03-03 13:04:34'),(78864,235,'Sisaura Nikumpur','262804',1,0,'2022-03-03 13:04:34','2022-03-03 13:04:34'),(78865,235,'Sisnaur','262802',1,0,'2022-03-03 13:04:34','2022-03-03 13:04:34'),(78866,235,'Siyathu','262701',1,0,'2022-03-03 13:04:34','2022-03-03 13:04:34'),(78867,235,'Srinagar','261506',1,0,'2022-03-03 13:04:34','2022-03-03 13:04:34'),(78868,235,'Suhela','262802',1,0,'2022-03-03 13:04:34','2022-03-03 13:04:34'),(78869,235,'Sujanpur','262907',1,0,'2022-03-03 13:04:35','2022-03-03 13:04:35'),(78870,235,'Sukhbasa','261505',1,0,'2022-03-03 13:04:35','2022-03-03 13:04:35'),(78871,235,'Sunava','261505',1,0,'2022-03-03 13:04:35','2022-03-03 13:04:35'),(78872,235,'Sunda','262908',1,0,'2022-03-03 13:04:35','2022-03-03 13:04:35'),(78873,235,'Sunderwal','261506',1,0,'2022-03-03 13:04:35','2022-03-03 13:04:35'),(78874,235,'Suratnagar','262906',1,0,'2022-03-03 13:04:35','2022-03-03 13:04:35'),(78875,235,'Surma','262908',1,0,'2022-03-03 13:04:35','2022-03-03 13:04:35'),(78876,235,'Suwabojh Jungle','262803',1,0,'2022-03-03 13:04:35','2022-03-03 13:04:35'),(78877,235,'Teliyar','262907',1,0,'2022-03-03 13:04:35','2022-03-03 13:04:35'),(78878,235,'Tetarpur','261506',1,0,'2022-03-03 13:04:35','2022-03-03 13:04:35'),(78879,235,'Tharvaranpur','262803',1,0,'2022-03-03 13:04:35','2022-03-03 13:04:35'),(78880,235,'Tikar','262725',1,0,'2022-03-03 13:04:35','2022-03-03 13:04:35'),(78881,235,'Tikaula','261501',1,0,'2022-03-03 13:04:35','2022-03-03 13:04:35'),(78882,235,'Tikunia','262906',1,0,'2022-03-03 13:04:35','2022-03-03 13:04:35'),(78883,235,'Tilokpur','262902',1,0,'2022-03-03 13:04:35','2022-03-03 13:04:35'),(78884,235,'Trikaulia','262902',1,0,'2022-03-03 13:04:35','2022-03-03 13:04:35'),(78885,235,'Udaipur Mahewa','262701',1,0,'2022-03-03 13:04:35','2022-03-03 13:04:35'),(78886,235,'Usha Form','262801',1,0,'2022-03-03 13:04:35','2022-03-03 13:04:35'),(78887,235,'Veerpur','262804',1,0,'2022-03-03 13:04:35','2022-03-03 13:04:35'),(78888,235,'Vichitra Nagar','262904',1,0,'2022-03-03 13:04:36','2022-03-03 13:04:36'),(78889,235,'Virsinghpur','261502',1,0,'2022-03-03 13:04:36','2022-03-03 13:04:36'),(78890,235,'Pratappur Jungal Matera','271855',1,0,'2022-03-03 13:04:36','2022-03-03 13:04:36'),(78891,236,'Ahiraulidan','274409',1,0,'2022-03-03 13:04:36','2022-03-03 13:04:36'),(78892,236,'Ahraulibazar','274149',1,0,'2022-03-03 13:04:36','2022-03-03 13:04:36'),(78893,236,'Amawa Digar','274302',1,0,'2022-03-03 13:04:36','2022-03-03 13:04:36'),(78894,236,'Amwa Bazar','274305',1,0,'2022-03-03 13:04:36','2022-03-03 13:04:36'),(78895,236,'Arjun Dumari','274203',1,0,'2022-03-03 13:04:36','2022-03-03 13:04:36'),(78896,236,'Asana','274149',1,0,'2022-03-03 13:04:36','2022-03-03 13:04:36'),(78897,236,'Atharaha','274301',1,0,'2022-03-03 13:04:36','2022-03-03 13:04:36'),(78898,236,'Babuiya Harpur','274304',1,0,'2022-03-03 13:04:36','2022-03-03 13:04:36'),(78899,236,'Bagahi','274407',1,0,'2022-03-03 13:04:36','2022-03-03 13:04:36'),(78900,236,'Baghachaur','274409',1,0,'2022-03-03 13:04:36','2022-03-03 13:04:36'),(78901,236,'Bahadur Pur','274409',1,0,'2022-03-03 13:04:36','2022-03-03 13:04:36'),(78902,236,'Bali','274802',1,0,'2022-03-03 13:04:36','2022-03-03 13:04:36'),(78903,236,'Balkuria','274304',1,0,'2022-03-03 13:04:36','2022-03-03 13:04:36'),(78904,236,'Banbira','274401',1,0,'2022-03-03 13:04:36','2022-03-03 13:04:36'),(78905,236,'Bankata Bharpurawa','274149',1,0,'2022-03-03 13:04:36','2022-03-03 13:04:36'),(78906,236,'Bansgaon','274302',1,0,'2022-03-03 13:04:36','2022-03-03 13:04:36'),(78907,236,'Barsaina','274207',1,0,'2022-03-03 13:04:36','2022-03-03 13:04:36'),(78908,236,'Barwa Bazar','274305',1,0,'2022-03-03 13:04:36','2022-03-03 13:04:36'),(78909,236,'Barwa Patti','274302',1,0,'2022-03-03 13:04:36','2022-03-03 13:04:36'),(78910,236,'Barwa Raja Pakar','274407',1,0,'2022-03-03 13:04:36','2022-03-03 13:04:36'),(78911,236,'Barwa Ratanpur','274802',1,0,'2022-03-03 13:04:36','2022-03-03 13:04:36'),(78912,236,'Basdila Pandey','274303',1,0,'2022-03-03 13:04:37','2022-03-03 13:04:37'),(78913,236,'Batrauli Bazar','274303',1,0,'2022-03-03 13:04:37','2022-03-03 13:04:37'),(78914,236,'Baulia','274301',1,0,'2022-03-03 13:04:37','2022-03-03 13:04:37'),(78915,236,'Belwa Jungle','274304',1,0,'2022-03-03 13:04:37','2022-03-03 13:04:37'),(78916,236,'Belwa Karkhana','274401',1,0,'2022-03-03 13:04:37','2022-03-03 13:04:37'),(78917,236,'Belwaghat','274802',1,0,'2022-03-03 13:04:37','2022-03-03 13:04:37'),(78918,236,'Betia','274304',1,0,'2022-03-03 13:04:37','2022-03-03 13:04:37'),(78919,236,'Bhaisaha','274802',1,0,'2022-03-03 13:04:37','2022-03-03 13:04:37'),(78920,236,'Bhaisahi Bazar','274203',1,0,'2022-03-03 13:04:37','2022-03-03 13:04:37'),(78921,236,'Bhaluhi','274149',1,0,'2022-03-03 13:04:37','2022-03-03 13:04:37'),(78922,236,'Bharsar Khas','274301',1,0,'2022-03-03 13:04:37','2022-03-03 13:04:37'),(78923,236,'Bhatahi Khurd','274401',1,0,'2022-03-03 13:04:37','2022-03-03 13:04:37'),(78924,236,'Bhatni Buzurg','274206',1,0,'2022-03-03 13:04:37','2022-03-03 13:04:37'),(78925,236,'Bhatni Dadan','274206',1,0,'2022-03-03 13:04:37','2022-03-03 13:04:37'),(78926,236,'Bhojauli Buzurg','274802',1,0,'2022-03-03 13:04:37','2022-03-03 13:04:37'),(78927,236,'Bhuri Pakar','274203',1,0,'2022-03-03 13:04:37','2022-03-03 13:04:37'),(78928,236,'Bihar Buzurg','274401',1,0,'2022-03-03 13:04:37','2022-03-03 13:04:37'),(78929,236,'Bikram Bhisunpur','274203',1,0,'2022-03-03 13:04:37','2022-03-03 13:04:37'),(78930,236,'Bishunpura','274302',1,0,'2022-03-03 13:04:37','2022-03-03 13:04:37'),(78931,236,'Bodarwar','274149',1,0,'2022-03-03 13:04:37','2022-03-03 13:04:37'),(78932,236,'Captainganj (Kushinagar)','274301',1,0,'2022-03-03 13:04:37','2022-03-03 13:04:37'),(78933,236,'Chaf','274302',1,0,'2022-03-03 13:04:37','2022-03-03 13:04:37'),(78934,236,'Chakhani Bhumihari Patti','274306',1,0,'2022-03-03 13:04:37','2022-03-03 13:04:37'),(78935,236,'Chandarpur','274306',1,0,'2022-03-03 13:04:37','2022-03-03 13:04:37'),(78936,236,'Chandrauta','274401',1,0,'2022-03-03 13:04:37','2022-03-03 13:04:37'),(78937,236,'Chhitauni','274801',1,0,'2022-03-03 13:04:37','2022-03-03 13:04:37'),(78938,236,'Chilua','274207',1,0,'2022-03-03 13:04:38','2022-03-03 13:04:38'),(78939,236,'Chiurapali','274149',1,0,'2022-03-03 13:04:38','2022-03-03 13:04:38'),(78940,236,'Dalip Nagar','274402',1,0,'2022-03-03 13:04:38','2022-03-03 13:04:38'),(78941,236,'Dandopur','274304',1,0,'2022-03-03 13:04:38','2022-03-03 13:04:38'),(78942,236,'Dashahawa','274302',1,0,'2022-03-03 13:04:38','2022-03-03 13:04:38'),(78943,236,'Deoria Baboo','274306',1,0,'2022-03-03 13:04:38','2022-03-03 13:04:38'),(78944,236,'Deoria Pandey','274304',1,0,'2022-03-03 13:04:38','2022-03-03 13:04:38'),(78945,236,'Desahi Barwa','274206',1,0,'2022-03-03 13:04:38','2022-03-03 13:04:38'),(78946,236,'Dhadha Buzurg','274207',1,0,'2022-03-03 13:04:38','2022-03-03 13:04:38'),(78947,236,'Dharampur','274304',1,0,'2022-03-03 13:04:38','2022-03-03 13:04:38'),(78948,236,'Dharampur Parbat','274302',1,0,'2022-03-03 13:04:38','2022-03-03 13:04:38'),(78949,236,'Dharmpur','274203',1,0,'2022-03-03 13:04:38','2022-03-03 13:04:38'),(78950,236,'Dhuria Imilia','274407',1,0,'2022-03-03 13:04:38','2022-03-03 13:04:38'),(78951,236,'Dhuria Khas','274402',1,0,'2022-03-03 13:04:38','2022-03-03 13:04:38'),(78952,236,'Dudhai','274302',1,0,'2022-03-03 13:04:38','2022-03-03 13:04:38'),(78953,236,'Dumarbhar','274304',1,0,'2022-03-03 13:04:38','2022-03-03 13:04:38'),(78954,236,'Dumari Swangi Patti','274206',1,0,'2022-03-03 13:04:38','2022-03-03 13:04:38'),(78955,236,'Fardaha','274301',1,0,'2022-03-03 13:04:38','2022-03-03 13:04:38'),(78956,236,'Farendaha','274401',1,0,'2022-03-03 13:04:38','2022-03-03 13:04:38'),(78957,236,'Fazilnagar','274401',1,0,'2022-03-03 13:04:38','2022-03-03 13:04:38'),(78958,236,'Gaunaria','274301',1,0,'2022-03-03 13:04:38','2022-03-03 13:04:38'),(78959,236,'Gauri Ibrahim','274406',1,0,'2022-03-03 13:04:38','2022-03-03 13:04:38'),(78960,236,'Gauri Jagdish','274406',1,0,'2022-03-03 13:04:38','2022-03-03 13:04:38'),(78961,236,'Gauri Sriram','274302',1,0,'2022-03-03 13:04:38','2022-03-03 13:04:38'),(78962,236,'Gethihawa','274802',1,0,'2022-03-03 13:04:39','2022-03-03 13:04:39'),(78963,236,'Goraria','274303',1,0,'2022-03-03 13:04:39','2022-03-03 13:04:39'),(78964,236,'Gurwalia','274401',1,0,'2022-03-03 13:04:39','2022-03-03 13:04:39'),(78965,236,'Gurwalia','274302',1,0,'2022-03-03 13:04:39','2022-03-03 13:04:39'),(78966,236,'Harpur Mafi','274306',1,0,'2022-03-03 13:04:39','2022-03-03 13:04:39'),(78967,236,'Hata','274203',1,0,'2022-03-03 13:04:39','2022-03-03 13:04:39'),(78968,236,'Hetimpur','274206',1,0,'2022-03-03 13:04:39','2022-03-03 13:04:39'),(78969,236,'Horlapur','274303',1,0,'2022-03-03 13:04:39','2022-03-03 13:04:39'),(78970,236,'J.M.C. Sohasha Mathia','274402',1,0,'2022-03-03 13:04:39','2022-03-03 13:04:39'),(78971,236,'Jabahi Dayal','274409',1,0,'2022-03-03 13:04:39','2022-03-03 13:04:39'),(78972,236,'Jadishpur Dharmdani','274149',1,0,'2022-03-03 13:04:39','2022-03-03 13:04:39'),(78973,236,'Jataha Bazar','274304',1,0,'2022-03-03 13:04:39','2022-03-03 13:04:39'),(78974,236,'Jaura Man Rakhan','274401',1,0,'2022-03-03 13:04:39','2022-03-03 13:04:39'),(78975,236,'Jhanga','274203',1,0,'2022-03-03 13:04:39','2022-03-03 13:04:39'),(78976,236,'Jhankaul','274303',1,0,'2022-03-03 13:04:39','2022-03-03 13:04:39'),(78977,236,'Karitin','274301',1,0,'2022-03-03 13:04:39','2022-03-03 13:04:39'),(78978,236,'Karmaini Premwalia','274402',1,0,'2022-03-03 13:04:39','2022-03-03 13:04:39'),(78979,236,'Kasia','274402',1,0,'2022-03-03 13:04:39','2022-03-03 13:04:39'),(78980,236,'Katai Bharpurwa','274304',1,0,'2022-03-03 13:04:39','2022-03-03 13:04:39'),(78981,236,'Kath Kuiyan','274303',1,0,'2022-03-03 13:04:39','2022-03-03 13:04:39'),(78982,236,'Khabhara Bhar','274301',1,0,'2022-03-03 13:04:39','2022-03-03 13:04:39'),(78983,236,'Khairi','274802',1,0,'2022-03-03 13:04:39','2022-03-03 13:04:39'),(78984,236,'Khajuri Bazar','274305',1,0,'2022-03-03 13:04:39','2022-03-03 13:04:39'),(78985,236,'Khanu Chhapara','274306',1,0,'2022-03-03 13:04:39','2022-03-03 13:04:39'),(78986,236,'Khesia','274304',1,0,'2022-03-03 13:04:40','2022-03-03 13:04:40'),(78987,236,'Khutahi','274306',1,0,'2022-03-03 13:04:40','2022-03-03 13:04:40'),(78988,236,'Kinnerpatti','274304',1,0,'2022-03-03 13:04:40','2022-03-03 13:04:40'),(78989,236,'Kishundeopur','274401',1,0,'2022-03-03 13:04:40','2022-03-03 13:04:40'),(78990,236,'Kohargaddi','274802',1,0,'2022-03-03 13:04:40','2022-03-03 13:04:40'),(78991,236,'Koilasawa','274401',1,0,'2022-03-03 13:04:40','2022-03-03 13:04:40'),(78992,236,'Kotwa Bazar','274305',1,0,'2022-03-03 13:04:40','2022-03-03 13:04:40'),(78993,236,'Kubernath','274304',1,0,'2022-03-03 13:04:40','2022-03-03 13:04:40'),(78994,236,'Kundur','274149',1,0,'2022-03-03 13:04:40','2022-03-03 13:04:40'),(78995,236,'Kurmauta Manjharia','274402',1,0,'2022-03-03 13:04:40','2022-03-03 13:04:40'),(78996,236,'Kushinagar','274403',1,0,'2022-03-03 13:04:40','2022-03-03 13:04:40'),(78997,236,'Kushumhi','274305',1,0,'2022-03-03 13:04:40','2022-03-03 13:04:40'),(78998,236,'Kusumha','274306',1,0,'2022-03-03 13:04:40','2022-03-03 13:04:40'),(78999,236,'Lachhia','274401',1,0,'2022-03-03 13:04:40','2022-03-03 13:04:40'),(79000,236,'Lala Chhapara','274306',1,0,'2022-03-03 13:04:40','2022-03-03 13:04:40'),(79001,236,'Langari','274203',1,0,'2022-03-03 13:04:40','2022-03-03 13:04:40'),(79002,236,'Laxmiganj','274306',1,0,'2022-03-03 13:04:40','2022-03-03 13:04:40'),(79003,236,'Laxmipur','274303',1,0,'2022-03-03 13:04:40','2022-03-03 13:04:40'),(79004,236,'Laxmipur Baboo','274407',1,0,'2022-03-03 13:04:40','2022-03-03 13:04:40'),(79005,236,'Laxmipur Mishra','274401',1,0,'2022-03-03 13:04:40','2022-03-03 13:04:40'),(79006,236,'Lehani','274149',1,0,'2022-03-03 13:04:40','2022-03-03 13:04:40'),(79007,236,'Madanpur Bherihari','274802',1,0,'2022-03-03 13:04:40','2022-03-03 13:04:40'),(79008,236,'Madhopur Buzurg','274406',1,0,'2022-03-03 13:04:40','2022-03-03 13:04:40'),(79009,236,'Maghi Kothilwa','274304',1,0,'2022-03-03 13:04:40','2022-03-03 13:04:40'),(79010,236,'Mahuawa Buzurg','274302',1,0,'2022-03-03 13:04:41','2022-03-03 13:04:41'),(79011,236,'Mahuawa Karkhana','274402',1,0,'2022-03-03 13:04:41','2022-03-03 13:04:41'),(79012,236,'Mahuwa Buzurg','274149',1,0,'2022-03-03 13:04:41','2022-03-03 13:04:41'),(79013,236,'Mainpur','274402',1,0,'2022-03-03 13:04:41','2022-03-03 13:04:41'),(79014,236,'Malukahi','274301',1,0,'2022-03-03 13:04:41','2022-03-03 13:04:41'),(79015,236,'Mania Chhapar','274306',1,0,'2022-03-03 13:04:41','2022-03-03 13:04:41'),(79016,236,'Mansoorganj','274149',1,0,'2022-03-03 13:04:41','2022-03-03 13:04:41'),(79017,236,'Marar Bindwalia','274306',1,0,'2022-03-03 13:04:41','2022-03-03 13:04:41'),(79018,236,'Mathauli','274301',1,0,'2022-03-03 13:04:41','2022-03-03 13:04:41'),(79019,236,'Mathia Buzurg','274802',1,0,'2022-03-03 13:04:41','2022-03-03 13:04:41'),(79020,236,'Mathia Naraipur','274402',1,0,'2022-03-03 13:04:41','2022-03-03 13:04:41'),(79021,236,'Mathia Sriram','274409',1,0,'2022-03-03 13:04:41','2022-03-03 13:04:41'),(79022,236,'Morban','274305',1,0,'2022-03-03 13:04:41','2022-03-03 13:04:41'),(79023,236,'Mujdiha','274149',1,0,'2022-03-03 13:04:41','2022-03-03 13:04:41'),(79024,236,'Mundera','274301',1,0,'2022-03-03 13:04:41','2022-03-03 13:04:41'),(79025,236,'Nadawa Bishunpur','274401',1,0,'2022-03-03 13:04:41','2022-03-03 13:04:41'),(79026,236,'Nahar Chhapra','274304',1,0,'2022-03-03 13:04:41','2022-03-03 13:04:41'),(79027,236,'Naika Chhapar','274206',1,0,'2022-03-03 13:04:41','2022-03-03 13:04:41'),(79028,236,'Nakataha Misir','274401',1,0,'2022-03-03 13:04:41','2022-03-03 13:04:41'),(79029,236,'Narainpur','274203',1,0,'2022-03-03 13:04:41','2022-03-03 13:04:41'),(79030,236,'Natwalia','274402',1,0,'2022-03-03 13:04:41','2022-03-03 13:04:41'),(79031,236,'Naumunda','274207',1,0,'2022-03-03 13:04:42','2022-03-03 13:04:42'),(79032,236,'Naurangia','274305',1,0,'2022-03-03 13:04:42','2022-03-03 13:04:42'),(79033,236,'Nautan Hathia Garh','274206',1,0,'2022-03-03 13:04:42','2022-03-03 13:04:42'),(79034,236,'Nebua Raiganj','274802',1,0,'2022-03-03 13:04:42','2022-03-03 13:04:42'),(79035,236,'Pachrukhia','274303',1,0,'2022-03-03 13:04:42','2022-03-03 13:04:42'),(79036,236,'Padari','274207',1,0,'2022-03-03 13:04:42','2022-03-03 13:04:42'),(79037,236,'Padari Piperpanti','274304',1,0,'2022-03-03 13:04:42','2022-03-03 13:04:42'),(79038,236,'Padauli Padiapar','274206',1,0,'2022-03-03 13:04:42','2022-03-03 13:04:42'),(79039,236,'Padrauna Chhawani','274304',1,0,'2022-03-03 13:04:42','2022-03-03 13:04:42'),(79040,236,'Padrauna City','274304',1,0,'2022-03-03 13:04:42','2022-03-03 13:04:42'),(79041,236,'Padrauna H.O','274304',1,0,'2022-03-03 13:04:42','2022-03-03 13:04:42'),(79042,236,'Padrauna S.F','274304',1,0,'2022-03-03 13:04:42','2022-03-03 13:04:42'),(79043,236,'Pagar','274306',1,0,'2022-03-03 13:04:42','2022-03-03 13:04:42'),(79044,236,'Pagara Prsad Giri','274407',1,0,'2022-03-03 13:04:42','2022-03-03 13:04:42'),(79045,236,'Paikauli','274203',1,0,'2022-03-03 13:04:42','2022-03-03 13:04:42'),(79046,236,'Pakari','274207',1,0,'2022-03-03 13:04:42','2022-03-03 13:04:42'),(79047,236,'Pakari Buzurg','274304',1,0,'2022-03-03 13:04:42','2022-03-03 13:04:42'),(79048,236,'Pakariyar Bazar','274305',1,0,'2022-03-03 13:04:42','2022-03-03 13:04:42'),(79049,236,'Pakri Birbhadra','274206',1,0,'2022-03-03 13:04:42','2022-03-03 13:04:42'),(79050,236,'Parsauni','274304',1,0,'2022-03-03 13:04:42','2022-03-03 13:04:42'),(79051,236,'Parsauni Buzurg','274407',1,0,'2022-03-03 13:04:42','2022-03-03 13:04:42'),(79052,236,'Parsauni Khurd','274402',1,0,'2022-03-03 13:04:42','2022-03-03 13:04:42'),(79053,236,'Parwarpar','274305',1,0,'2022-03-03 13:04:42','2022-03-03 13:04:42'),(79054,236,'Patherawa','274401',1,0,'2022-03-03 13:04:42','2022-03-03 13:04:42'),(79055,236,'Pindara','274207',1,0,'2022-03-03 13:04:43','2022-03-03 13:04:43'),(79056,236,'Pipara Agarwa','274409',1,0,'2022-03-03 13:04:43','2022-03-03 13:04:43'),(79057,236,'Pipara','274203',1,0,'2022-03-03 13:04:43','2022-03-03 13:04:43'),(79058,236,'Pipara Brahaman','274301',1,0,'2022-03-03 13:04:43','2022-03-03 13:04:43'),(79059,236,'Piparaghat','274406',1,0,'2022-03-03 13:04:43','2022-03-03 13:04:43'),(79060,236,'Pipra Bazar','274305',1,0,'2022-03-03 13:04:43','2022-03-03 13:04:43'),(79061,236,'Pipra Daula Kadam','274206',1,0,'2022-03-03 13:04:43','2022-03-03 13:04:43'),(79062,236,'Pipra Jatampur','274303',1,0,'2022-03-03 13:04:43','2022-03-03 13:04:43'),(79063,236,'Pipra Kanak','274401',1,0,'2022-03-03 13:04:43','2022-03-03 13:04:43'),(79064,236,'Pipraicha','274203',1,0,'2022-03-03 13:04:43','2022-03-03 13:04:43'),(79065,236,'Puraini','274306',1,0,'2022-03-03 13:04:43','2022-03-03 13:04:43'),(79066,236,'Ragarganj','274306',1,0,'2022-03-03 13:04:43','2022-03-03 13:04:43'),(79067,236,'Raja Bazar Khadda','274802',1,0,'2022-03-03 13:04:43','2022-03-03 13:04:43'),(79068,236,'Rakaba Junglepatti','274406',1,0,'2022-03-03 13:04:43','2022-03-03 13:04:43'),(79069,236,'Rambar Buzurg','274305',1,0,'2022-03-03 13:04:43','2022-03-03 13:04:43'),(79070,236,'Ramkola','274305',1,0,'2022-03-03 13:04:43','2022-03-03 13:04:43'),(79071,236,'Rampur Bagaha','274306',1,0,'2022-03-03 13:04:43','2022-03-03 13:04:43'),(79072,236,'Rampur Barhan','274302',1,0,'2022-03-03 13:04:43','2022-03-03 13:04:43'),(79073,236,'Rampur Buzurug','274203',1,0,'2022-03-03 13:04:43','2022-03-03 13:04:43'),(79074,236,'Rampur Chaubey','274301',1,0,'2022-03-03 13:04:43','2022-03-03 13:04:43'),(79075,236,'Rampur Jungle','274801',1,0,'2022-03-03 13:04:43','2022-03-03 13:04:43'),(79076,236,'Rampur Sohrauna','274203',1,0,'2022-03-03 13:04:43','2022-03-03 13:04:43'),(79077,236,'Rohuwa Machhargawa','274149',1,0,'2022-03-03 13:04:43','2022-03-03 13:04:43'),(79078,236,'Ruari','274305',1,0,'2022-03-03 13:04:43','2022-03-03 13:04:43'),(79079,236,'Sahbajpur','274206',1,0,'2022-03-03 13:04:43','2022-03-03 13:04:43'),(79080,236,'Sakhopar','274402',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79081,236,'Sakrauli','274203',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79082,236,'Salemgarh','274409',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79083,236,'Samogar','274203',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79084,236,'Sapaha','274402',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79085,236,'Sariya Mahanth Patti','274401',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79086,236,'Sarpathi','274304',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79087,236,'Sarya','274304',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79088,236,'Sekhwania','274402',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79089,236,'Semara Hardo Patti','274401',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79090,236,'Seorahi','274406',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79091,236,'Shankar Pat Khauli','274401',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79092,236,'Sidhawey','274305',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79093,236,'Sidhua Bangar','274304',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79094,236,'Sikata','274303',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79095,236,'Singaha','274305',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79096,236,'Singari','274301',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79097,236,'Singha Patti','274304',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79098,236,'Sirsia','274203',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79099,236,'Siswa Goiti','274304',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79100,236,'Siswa Maniraj','274802',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79101,236,'Sohang','274401',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79102,236,'Sohrauna','274802',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79103,236,'Somali','274149',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79104,236,'Sukrauli','274207',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79105,236,'Sumahi Khurd','274401',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79106,236,'Tamkuhi','274407',1,0,'2022-03-03 13:04:44','2022-03-03 13:04:44'),(79107,236,'Tarya Lachhiram','274409',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79108,236,'Tarya Sujan','274409',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79109,236,'Tekuatar','274305',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79110,236,'Tirma Sahun','274302',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79111,236,'Turkdiha','274149',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79112,236,'Vedupar','274409',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79113,236,'Vijaikaf','274207',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79114,237,'Alapur','284122',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79115,237,'Arjunkhiriya','284406',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79116,237,'Asaupura','284122',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79117,237,'Baarod','284403',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79118,237,'Bachhraoni','284123',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79119,237,'Badiwar Kalan','284126',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79120,237,'Baghaura','284123',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79121,237,'Balabehat','284406',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79122,237,'Bamhori Bahadur Singh','284405',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79123,237,'Bamhori Kalan','284403',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79124,237,'Bamhori Khandel','284123',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79125,237,'Bamhori Madawra','284404',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79126,237,'Bamhori Sarr','284126',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79127,237,'Bangawan Kalan','284136',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79128,237,'Banpur (Lalitpur)','284402',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79129,237,'Bansi (Lalitpur)','284122',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79130,237,'Barh (Lalitpur)','284123',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79131,237,'Barkhiriya','284122',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79132,237,'Baroda Daang','284123',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79133,237,'Baroda Swami','284124',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79134,237,'Baroda-bijlaun','284403',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79135,237,'Basatguwan','284122',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79136,237,'Bastrawan','284122',1,0,'2022-03-03 13:04:45','2022-03-03 13:04:45'),(79137,237,'Bhailoni Lodh','284123',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79138,237,'Bhailoni Suba','284123',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79139,237,'Bhaoni','284123',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79140,237,'Bhondi','284405',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79141,237,'Bhuchera','284126',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79142,237,'Bijrautha','284126',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79143,237,'Billa','284402',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79144,237,'Birdha','284403',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79145,237,'Bomori Bansa','284406',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79146,237,'Bunt','284403',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79147,237,'Burhwar','284403',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79148,237,'Chadhraoo','284403',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79149,237,'Chhapchhaul','284405',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79150,237,'Chiglauwa','284123',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79151,237,'Chungi','284123',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79152,237,'Dailwara','284403',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79153,237,'Daoni','284403',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79154,237,'Dasrara','284123',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79155,237,'Deoran','284122',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79156,237,'Deori','284501',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79157,237,'Dhangol','284123',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79158,237,'Dhauri Sagar','284404',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79159,237,'Dhaurra','284403',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79160,237,'Dhawa','284404',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79161,237,'Dhawari','284405',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79162,237,'Didonia','284404',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79163,237,'Dongra Kalan','284406',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79164,237,'Dongra Khurd','284406',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79165,237,'Dulawan','284122',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79166,237,'Gadiya','284122',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79167,237,'Gadyana','284122',1,0,'2022-03-03 13:04:46','2022-03-03 13:04:46'),(79168,237,'Garholi Kalan','284404',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79169,237,'Gauna','284406',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79170,237,'Ghatwar','284403',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79171,237,'Ghisauli','284124',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79172,237,'Gidwaha','284404',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79173,237,'Girar','284404',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79174,237,'Gona Kushmadh','284405',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79175,237,'Gurha','284405',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79176,237,'Hasarkalan','284126',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79177,237,'Jakhaura','284124',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79178,237,'Jakhlaun','284403',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79179,237,'Jamalpur','284122',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79180,237,'Jamuniya','284403',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79181,237,'Jeeron','284403',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79182,237,'Jijyawan','284403',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79183,237,'Kachnadakala','284403',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79184,237,'Kadesarakalan','284126',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79185,237,'Kailguwan','284402',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79186,237,'Kailwara','284501',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79187,237,'Kakdari','284126',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79188,237,'Kakrauwa','284405',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79189,237,'Kalyanpura','284403',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79190,237,'Kalyanpura','284122',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79191,237,'Karitoran','284404',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79192,237,'Karmai','284122',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79193,237,'Katra Bazar Lalitpur','284403',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79194,237,'Khajuriya','284405',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79195,237,'Khandi','284126',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79196,237,'Khiriya Chhatara','284403',1,0,'2022-03-03 13:04:47','2022-03-03 13:04:47'),(79197,237,'Khiriya Latkanju','284405',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79198,237,'Khitwans','284405',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79199,237,'Kisalwans','284124',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79200,237,'Kuagaon','284402',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79201,237,'Kuantala','284403',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79202,237,'Kumheri','284405',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79203,237,'Ladhwari','284123',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79204,237,'Lagaun','284501',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79205,237,'Lake-view-camp','284125',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79206,237,'Lakhanpura','284122',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79207,237,'Lalitpur H.O','284403',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79208,237,'Lalitpur Railway Station','284403',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79209,237,'Madanwara','284122',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79210,237,'Madawra','284404',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79211,237,'Mahauli','284406',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79212,237,'Mahroni','284405',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79213,237,'Mainwara','284124',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79214,237,'Marrauli','284402',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79215,237,'Masaura Khurd','284403',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79216,237,'Matatila','284136',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79217,237,'Mirchwara','284403',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79218,237,'Miyaoon','284126',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79219,237,'Muhara','284122',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79220,237,'Naikaura','284405',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79221,237,'Nainwara','284405',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79222,237,'Nanaura','284124',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79223,237,'Narahat','284406',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79224,237,'Natthikheda','284126',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79225,237,'Nauharkalan','284124',1,0,'2022-03-03 13:04:48','2022-03-03 13:04:48'),(79226,237,'Niwai Nibaho','284403',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79227,237,'Paah','284402',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79228,237,'Padhna','284403',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79229,237,'Pali','284403',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79230,237,'Paraul','284406',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79231,237,'Paron','284123',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79232,237,'Patauwa','284403',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79233,237,'Patna','284406',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79234,237,'Pawa','284126',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79235,237,'Pipra Raipur','284124',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79236,237,'Piprai','284403',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79237,237,'Poora Kalan','284126',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79238,237,'Poora Virdha','284126',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79239,237,'Pura Kakdari','284402',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79240,237,'Rajawan','284126',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79241,237,'Rajghat Dam Project','284501',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79242,237,'Rajwara','284403',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79243,237,'Rakh Panchampur','284124',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79244,237,'Ronda','284403',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79245,237,'Sadhumar','284404',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79246,237,'Saidpur','284404',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79247,237,'Sanori','284126',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79248,237,'Sarsend','284126',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79249,237,'Satarwans','284403',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79250,237,'Saujana','284405',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79251,237,'Serwans Kalan','284126',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79252,237,'Serwans Khurd','284403',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79253,237,'Siddhisagar','284403',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79254,237,'Silawan','284405',1,0,'2022-03-03 13:04:49','2022-03-03 13:04:49'),(79255,237,'Silgan','284403',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79256,237,'Sindwaha','284405',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79257,237,'Siron Kalan','284124',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79258,237,'Siron Madawra','284404',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79259,237,'Sirsi','284124',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79260,237,'Sonrai','284404',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79261,237,'Sunwaha','284402',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79262,237,'Talbehat','284126',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79263,237,'Tera','284403',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79264,237,'Thanwara','284501',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79265,237,'Udaipura','284402',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79266,237,'Umariya','284406',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79267,238,'32 Bn PAC ','226023',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79268,238,'A N L Colony','226004',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79269,238,'A P Sabha','226001',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79270,238,'Aashiana','226012',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79271,238,'Adampur Janubi','226303',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79272,238,'Adarsh Nagar (Lucknow)','226005',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79273,238,'Ain','226005',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79274,238,'Ain','226401',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79275,238,'Aishbagh','226004',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79276,238,'Akariakalan','226203',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79277,238,'Alambagh','226005',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79278,238,'Alamnagar','226017',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79279,238,'Aliganj Extension','226024',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79280,238,'Aliganj (Lucknow)','226024',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79281,238,'Amaniganj','226203',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79282,238,'Amausi Ad','226009',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79283,238,'Amausi','226008',1,0,'2022-03-03 13:04:50','2022-03-03 13:04:50'),(79284,238,'Amberganj','226003',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79285,238,'Amethi','226501',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79286,238,'Amethia Salempur','226101',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79287,238,'Aminabad Park','226018',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79288,238,'Amraigaon','226028',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79289,238,'Anandnagar (Lucknow)','226005',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79290,238,'Anaura Kalan','226028',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79291,238,'Antagarhi','226104',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79292,238,'Arjunganj','226002',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79293,238,'Arjunpur','226203',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79294,238,'Arya Nagar (Lucknow)','226004',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79295,238,'Asti','226201',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79296,238,'Atari','226104',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79297,238,'Ateswa','226203',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79298,238,'Aurawan','226401',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79299,238,'Avas Vikas Colony (Lucknow)','226017',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79300,238,'B R A University','226025',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79301,238,'Badiyan','226104',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79302,238,'Bahargaon','226203',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79303,238,'Bahrauli','226303',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79304,238,'Bahroo','226101',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79305,238,'Bakkash','226002',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79306,238,'Bakshi Ka Talab','226201',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79307,238,'Balrampur Hospital','226018',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79308,238,'Bani','226401',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79309,238,'Banthra','226401',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79310,238,'Baragaon','226101',1,0,'2022-03-03 13:04:51','2022-03-03 13:04:51'),(79311,238,'Barauna','226002',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79312,238,'Barawan Kalan','226101',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79313,238,'Barha','226005',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79314,238,'Barwalia','226301',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79315,238,'Basha','226026',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79316,238,'Batha Sabauli','226021',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79317,238,'Baurumau','226201',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79318,238,'Bazargaron','226104',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79319,238,'Beerpur','226104',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79320,238,'Begariamau','226501',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79321,238,'Behta','226026',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79322,238,'Benti','226005',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79323,238,'Benti','226401',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79324,238,'Bhadeswa','226301',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79325,238,'Bhadrukh','226002',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79326,238,'Bhadwana','226102',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79327,238,'Bhagwantpur','226104',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79328,238,'Bharwara','226104',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79329,238,'Bhatgaon','226005',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79330,238,'Bhatgaon','226401',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79331,238,'Bhauli','226201',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79332,238,'Bhilampur','226301',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79333,238,'Bibipur','226203',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79334,238,'Bijnaur','226002',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79335,238,'Blunt Square','226004',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79336,238,'C B Lines','226002',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79337,238,'C E School','226008',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79338,238,'C&w  Work Shop','226005',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79339,238,'Canal Colony','226001',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79340,238,'Chakganjaria','226002',1,0,'2022-03-03 13:04:52','2022-03-03 13:04:52'),(79341,238,'Chandganj','226024',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79342,238,'Chandrawal','226002',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79343,238,'Charbagh','226004',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79344,238,'Chatauni','226303',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79345,238,'Chaupatiyan','226003',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79346,238,'Chinhat','226028',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79347,238,'Cimap','226015',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79348,238,'CPMG Campus','226001',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79349,238,'D M Road','226020',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79350,238,'D S Bazar','226002',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79351,238,'Daliganj','226020',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79352,238,'Darul Safa','226001',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79353,238,'Daulatpur','226103',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79354,238,'Dayalpur','226302',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79355,238,'Deoti','226301',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79356,238,'Dhendhemau','226102',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79357,238,'Diguria','226020',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79358,238,'Dilawarnagar','226102',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79359,238,'Dilkusha','226002',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79360,238,'Distt. Jail (Lucknow)','226005',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79361,238,'Dona','226101',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79362,238,'FFTC Indaurabagh','226202',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79363,238,'Gahdon','226104',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79364,238,'Ganesh Ganj (Lucknow)','226018',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79365,238,'Garhi Chunauti','226401',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79366,238,'Gaunda','226103',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79367,238,'Ghaila','226020',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79368,238,'Ghazipur (Lucknow)','226016',1,0,'2022-03-03 13:04:53','2022-03-03 13:04:53'),(79369,238,'Gohramau','226101',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79370,238,'Goila','226028',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79371,238,'Gokhley Marg','226001',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79372,238,'Golaganj','226018',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79373,238,'Gomtinagar','226010',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79374,238,'Gomtinagar Vistar','226010',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79375,238,'Gopramau','226104',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79376,238,'Gosainganj (Lucknow)','226501',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79377,238,'Guramba','226026',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79378,238,'Gurdwara','226004',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79379,238,'H C Bench','226001',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79380,238,'H E School','226006',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79381,238,'Hal (Lucknow)','226016',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79382,238,'Harauni','226401',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79383,238,'Hasanpur Keoli','226002',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79384,238,'Hasnain Market','226003',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79385,238,'Hasnapur','226501',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79386,238,'Husainabad','226003',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79387,238,'Iim Mubarakpur','226013',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79388,238,'IIT Dasauli','226026',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79389,238,'Ind.Area Sarojininagar','226008',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79390,238,'Indara','226203',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79391,238,'Indira Nagar (Lucknow)','226016',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79392,238,'Indiranagar Sec-14','226016',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79393,238,'Indiranagar Sec-18','226016',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79394,238,'Indiranagar Sec-21','226016',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79395,238,'Industria Area Chinhat','226019',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79396,238,'Industrial Area (Lucknow)','226009',1,0,'2022-03-03 13:04:54','2022-03-03 13:04:54'),(79397,238,'Int Gaon','226008',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79398,238,'Itaunja','226203',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79399,238,'Jabrauli','226301',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79400,238,'Jagdishpur','226201',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79401,238,'Jaitikhera','226301',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79402,238,'Jamkhanwa','226203',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79403,238,'Jamolia','226103',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79404,238,'Jankipuram Extension','226031',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79405,238,'Jankipuram','226021',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79406,238,'Jawahar Bhawan','226001',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79407,238,'Jindaur','226103',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79408,238,'Juggaur','226028',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79409,238,'Kahla','226102',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79410,238,'Kakori','226101',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79411,238,'Kakrabad','226102',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79412,238,'Kalli Pacchim','226301',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79413,238,'Kalyanpur (Lucknow)','226022',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79414,238,'Kamlabad Badauli','226201',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79415,238,'Kankaha','226301',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79416,238,'Karora','226303',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79417,238,'Kasimpur Biruha','226501',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79418,238,'Kasmandi Kalan','226102',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79419,238,'Kasmandi Khurd','226102',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79420,238,'Katauli','226102',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79421,238,'Kathwara','226201',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79422,238,'Kathwara','226202',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79423,238,'Keoli','226303',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79424,238,'Khalispur','226101',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79425,238,'Khantari','226203',1,0,'2022-03-03 13:04:55','2022-03-03 13:04:55'),(79426,238,'Kharika','226002',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79427,238,'Kharsara','226104',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79428,238,'Khushalganj','226101',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79429,238,'Kotwa','226201',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79430,238,'Kumharawan.','226203',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79431,238,'Kusmaura','226301',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79432,238,'L D A Colony','226012',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79433,238,'Lalbagh (Lucknow)','226001',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79434,238,'Laulai','226010',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79435,238,'Laulai','226028',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79436,238,'Locomotive W Shop','226005',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79437,238,'Lonikatra','226020',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79438,238,'Lucknow Chowk H.O','226003',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79439,238,'M N Colony','226006',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79440,238,'Madiyaon','226021',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79441,238,'Mahanagar','226006',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79442,238,'Maharishi Vidya Mandir','226020',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79443,238,'Mahigawan','226203',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79444,238,'Mahmoodnagar','226102',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79445,238,'Mahona','226203',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79446,238,'Malesemau','226010',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79447,238,'Malha','226101',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79448,238,'Malhaur','226028',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79449,238,'Malihabad','226102',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79450,238,'Mall','226104',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79451,238,'Manaknagar','226011',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79452,238,'Manasnagar','226023',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79453,238,'Mansoor Nagar','226003',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79454,238,'Mastipur','226302',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79455,238,'Mati','226002',1,0,'2022-03-03 13:04:56','2022-03-03 13:04:56'),(79456,238,'Maunda','226008',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79457,238,'Mawai Kalan','226103',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79458,238,'Mawai Khurd','226104',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79459,238,'Mawai Padiyana','226008',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79460,238,'Medical College (Lucknow)','226003',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79461,238,'Meeraknagar','226302',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79462,238,'Mehmoodpur','226501',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79463,238,'Military Hospital','226002',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79464,238,'Mill Road','226004',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79465,238,'Mohanlalganj','226301',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79466,238,'Mohari Khurd','226301',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79467,238,'Munnu Khera','226104',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79468,238,'Nabipanah','226104',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79469,238,'Nadan Mahal','226003',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79470,238,'Nadwa','226007',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79471,238,'Nagram','226303',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79472,238,'Narain Nagar','226016',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79473,238,'Narosa','226203',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79474,238,'Naubasta','226003',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79475,238,'Navinmandi','226020',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79476,238,'Naya Gaon (Lucknow)','226018',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79477,238,'Neewan','226401',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79478,238,'New Ganeshganj','226018',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79479,238,'New Hyderabad','226007',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79480,238,'Nigohan','226302',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79481,238,'Nilmatha','226002',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79482,238,'Niralanagar','226020',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79483,238,'Paharpur','226203',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79484,238,'Pandariba','226004',1,0,'2022-03-03 13:04:57','2022-03-03 13:04:57'),(79485,238,'Pateona','226104',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79486,238,'Pawanpuri (Lucknow)','226005',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79487,238,'Piparsand','226008',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79488,238,'Purseni','226301',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79489,238,'R A College','226004',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79490,238,'R B Colony','226018',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79491,238,'R G C Mill','226017',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79492,238,'R P Line','226007',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79493,238,'Raghunathpur','226104',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79494,238,'Rahim Nagar Padiana','226005',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79495,238,'Rahimabad','226103',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79496,238,'Rahimnagar Padiyana','226401',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79497,238,'Raitha','226202',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79498,238,'Raja Bazar','226003',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79499,238,'Rajajipuram','226017',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79500,238,'Rajauli','226026',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79501,238,'Rajendranagar (Lucknow)','226004',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79502,238,'Ranipara','226104',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79503,238,'Rasoolpur Saadat','226028',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79504,238,'Rasoolpur Tikaniamau','226501',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79505,238,'Rehman Khera','226101',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79506,238,'Rusena','226103',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79507,238,'Saadatganj (Lucknow)','226003',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79508,238,'Sadrauna','226008',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79509,238,'Sahijana','226103',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79510,238,'Sairpur','226201',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79511,238,'Salehnagar','226104',1,0,'2022-03-03 13:04:58','2022-03-03 13:04:58'),(79512,238,'Salempur','226501',1,0,'2022-03-03 13:04:59','2022-03-03 13:04:59'),(79513,238,'Samesi','226303',1,0,'2022-03-03 13:04:59','2022-03-03 13:04:59'),(79514,238,'Sanatan Dharam Vidya Peeth','226026',1,0,'2022-03-03 13:04:59','2022-03-03 13:04:59'),(79515,238,'Sant Market','226006',1,0,'2022-03-03 13:04:59','2022-03-03 13:04:59'),(79516,238,'Sarai Damu','226203',1,0,'2022-03-03 13:04:59','2022-03-03 13:04:59'),(79517,238,'Sarai Gudauli','226301',1,0,'2022-03-03 13:04:59','2022-03-03 13:04:59'),(79518,238,'Sarai Mali Khan','226003',1,0,'2022-03-03 13:04:59','2022-03-03 13:04:59'),(79519,238,'Saraura','226201',1,0,'2022-03-03 13:04:59','2022-03-03 13:04:59'),(79520,238,'Sarfraj','226003',1,0,'2022-03-03 13:04:59','2022-03-03 13:04:59'),(79521,238,'Sarojini Nagar','226008',1,0,'2022-03-03 13:04:59','2022-03-03 13:04:59'),(79522,238,'Sarvoday Nagar','226016',1,0,'2022-03-03 13:04:59','2022-03-03 13:04:59'),(79523,238,'Sathwara','226501',1,0,'2022-03-03 13:04:59','2022-03-03 13:04:59'),(79524,238,'Sec-B Indira Nagar','226016',1,0,'2022-03-03 13:04:59','2022-03-03 13:04:59'),(79525,238,'Sec-d Indiranagar','226016',1,0,'2022-03-03 13:04:59','2022-03-03 13:04:59'),(79526,238,'Secretariat (Lucknow)','226001',1,0,'2022-03-03 13:04:59','2022-03-03 13:04:59'),(79527,238,'Sgpgi','226014',1,0,'2022-03-03 13:04:59','2022-03-03 13:04:59'),(79528,238,'Shia Lines','226002',1,0,'2022-03-03 13:04:59','2022-03-03 13:04:59'),(79529,238,'Shivaji Marg (Lucknow)','226018',1,0,'2022-03-03 13:04:59','2022-03-03 13:04:59'),(79530,238,'Singar Nagar','226005',1,0,'2022-03-03 13:04:59','2022-03-03 13:04:59'),(79531,238,'Singhamau','226203',1,0,'2022-03-03 13:04:59','2022-03-03 13:04:59'),(79532,238,'Singhrawa','226102',1,0,'2022-03-03 13:04:59','2022-03-03 13:04:59'),(79533,238,'Sisendi','226301',1,0,'2022-03-03 13:04:59','2022-03-03 13:04:59'),(79534,238,'Sujanpura','226005',1,0,'2022-03-03 13:04:59','2022-03-03 13:04:59'),(79535,238,'Sunderbagh','226018',1,0,'2022-03-03 13:04:59','2022-03-03 13:04:59'),(79536,238,'Sushant Golf City','226030',1,0,'2022-03-03 13:04:59','2022-03-03 13:04:59'),(79537,238,'Suspen','226103',1,0,'2022-03-03 13:04:59','2022-03-03 13:04:59'),(79538,238,'T. Tib','226003',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79539,238,'Thakurganj','226003',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79540,238,'Thari','226104',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79541,238,'Thawar','226104',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79542,238,'Tirwa','226401',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79543,238,'Topkhana Bazar','226002',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79544,238,'Triveni Nagar','226020',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79545,238,'U P Governer Camp','226027',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79546,238,'Umrawal','226104',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79547,238,'Usarana','226203',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79548,238,'Utrathia','226002',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79549,238,'Utrawan','226302',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79550,238,'Victoriaganj','226003',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79551,238,'Vikas Nagar','226022',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79552,238,'Vineet Khand','226010',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79553,238,'Vishwas Khand','226010',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79554,238,'Vrinda Van Colony','226029',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79555,238,'Wazirganj (Lucknow)','226018',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79556,238,'Yahiaganj','226003',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79557,238,'Lucknow G.P.O.','226001',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79558,239,'Adda Bazar','273164',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79559,239,'Akasarawa','273164',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79560,239,'Amwabujurg','273157',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79561,239,'Anandnagar (Maharajganj)','273155',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79562,239,'Ardauna','273163',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79563,239,'Auratar','273304',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79564,239,'Badhara Mir','273207',1,0,'2022-03-03 13:05:00','2022-03-03 13:05:00'),(79565,239,'Badhra Mahant','273163',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79566,239,'Bagapar','273303',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79567,239,'Baisar','273161',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79568,239,'Baithwalia','273304',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79569,239,'Bali','273304',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79570,239,'Balua','273302',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79571,239,'Banarisihakhurd','273164',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79572,239,'Bandoh','273161',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79573,239,'Banjaria Sonbarsa','273157',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79574,239,'Bankata','273155',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79575,239,'Baratgarah','273155',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79576,239,'Bargadwa Harriya','273155',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79577,239,'Bariarpur','273163',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79578,239,'Basantpur','273151',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79579,239,'Basantpur','273162',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79580,239,'Bashia Buzurg','273301',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79581,239,'Baspar','273151',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79582,239,'Baspar Baijauli','273303',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79583,239,'Basuli  Farm','273163',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79584,239,'Bauliaraja','273303',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79585,239,'Belaharriya','273157',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79586,239,'Belouha','273161',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79587,239,'Belwa Khurd','273303',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79588,239,'Belwa Qazi','273303',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79589,239,'Belwatikar','273302',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79590,239,'Bhagawanpur','273164',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79591,239,'Bhagirathpur','273164',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79592,239,'Bhainsi','273302',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79593,239,'Bheria','273207',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79594,239,'Bhitauli Bazar','273302',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79595,239,'Biraicha','273151',1,0,'2022-03-03 13:05:01','2022-03-03 13:05:01'),(79596,239,'Bodna','273305',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79597,239,'Bribgemanganj','273157',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79598,239,'Chainpur','273163',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79599,239,'Chakdah','273164',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79600,239,'Charalaha','273164',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79601,239,'Chargha','273163',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79602,239,'Chauk','273303',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79603,239,'Chaumukha','273151',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79604,239,'Chehari','273303',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79605,239,'Dagroopur','273305',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79606,239,'Dandwarkhurd','273155',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79607,239,'Darahata','273303',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79608,239,'Devgatti','273305',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79609,239,'Dhanewa Dhanai','273303',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79610,239,'Dhani Bazar','273161',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79611,239,'Dharmauli','273301',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79612,239,'Dhuswakala','273162',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79613,239,'Dogahra','273305',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79614,239,'Doma Khas','273304',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79615,239,'Garaura','273305',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79616,239,'Gaunaria','273207',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79617,239,'Gaura Dubey','273151',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79618,239,'Germa','273163',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79619,239,'Ghughli R.S.','273151',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79620,239,'Gopala','273302',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79621,239,'Goplapur','273155',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79622,239,'Guri Badhipurwa','273163',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79623,239,'Hagana Mohammadpur','273155',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79624,239,'Harakpur','273302',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79625,239,'Harpurtiwari','273301',1,0,'2022-03-03 13:05:02','2022-03-03 13:05:02'),(79626,239,'Indrapur','273155',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79627,239,'Jaddupipra','273301',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79628,239,'Jagdaur','273207',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79629,239,'Jamie Pandit','273207',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79630,239,'Jara','273164',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79631,239,'Jhingti','273305',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79632,239,'Jhulnipur','273304',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79633,239,'Kaima','273163',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79634,239,'Kajari','273164',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79635,239,'Kamharia Buzurg','273309',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79636,239,'Kamhariakala','273303',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79637,239,'Karamahi','273163',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79638,239,'Karamahwa','273164',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79639,239,'Karialia','273164',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79640,239,'Karimnagar','273155',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79641,239,'Karmha','273303',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79642,239,'Katahari','273163',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79643,239,'Katahra','273303',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79644,239,'Keshouli','273157',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79645,239,'Khajuria','273303',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79646,239,'Khlikgarh','273162',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79647,239,'Khoria Bazar','273164',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79648,239,'Khutha Bazar','273303',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79649,239,'Koluhi','273309',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79650,239,'Kotamukund Pur','273303',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79651,239,'Kothibhar','273163',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79652,239,'Kuin Bazar','273405',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79653,239,'Lakhima','273301',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79654,239,'Lalpur','273157',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79655,239,'Laxmipur (Maharajganj)','273162',1,0,'2022-03-03 13:05:03','2022-03-03 13:05:03'),(79656,239,'Laxmipurdeurwa','273302',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79657,239,'Laxmipurektanga','273302',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79658,239,'Laxmipurkhurd','273305',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79659,239,'Laxmipurshiwala','273302',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79660,239,'Ledi','273304',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79661,239,'Lejarmahdewa','273162',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79662,239,'Lohepar','273163',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79663,239,'Lvp Nagar','273155',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79664,239,'Machhaligaon','273155',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79665,239,'Madanpura','273304',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79666,239,'Madhubani','273207',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79667,239,'Madhwalia','273163',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79668,239,'Maharajganj MDG','273303',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79669,239,'Mahdewa','273161',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79670,239,'Mahuawa','273303',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79671,239,'Mahulani','273157',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79672,239,'Manikapur','273305',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79673,239,'Marhatha','273161',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79674,239,'Mathuranagar','273155',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79675,239,'Medida','273162',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79676,239,'Mednipur','273151',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79677,239,'Meghwali Kala','273304',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79678,239,'Mishraulia','273207',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79679,239,'Mishrouliya','273157',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79680,239,'Mithaura Bazar','273207',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79681,239,'Mujahna Buzurg','273207',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79682,239,'Munderi','273151',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79683,239,'Nadua Bazar','273303',1,0,'2022-03-03 13:05:04','2022-03-03 13:05:04'),(79684,239,'Naikot','273164',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79685,239,'Narayanpur','273151',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79686,239,'Nausagra','273161',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79687,239,'Nautanwa Bazar','273164',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79688,239,'Nebuiya','273301',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79689,239,'Neta Surhurwa','273303',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79690,239,'Nichlaul','273304',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79691,239,'Nipania','273164',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79692,239,'Orwalliya','273311',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79693,239,'Pachrenawa','273207',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79694,239,'Pachrukhia','273302',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79695,239,'Pakdi Bishunpur','273151',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79696,239,'Pakdi Dixit','273302',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79697,239,'Pakdiar Bishunpur','273151',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79698,239,'Pakdinauni A','273303',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79699,239,'Panewa Panei','273303',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79700,239,'Paniyara','273310',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79701,239,'Parsa Gidahi','273302',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79702,239,'Parsamalik','273305',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79703,239,'Parsauni','273207',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79704,239,'Partawal Bazar','273301',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79705,239,'Pharendra Khurd','273155',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79706,239,'Piparpati Tiwari','273302',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79707,239,'Pipra','273305',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79708,239,'Pipra Bazar','273207',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79709,239,'Pipra Sohat','273162',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79710,239,'Pokharbhinda','273155',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79711,239,'Puranderpur','273162',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79712,239,'Puraniha','273164',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79713,239,'Purena Khandi Chauri','273302',1,0,'2022-03-03 13:05:05','2022-03-03 13:05:05'),(79714,239,'Rajdhani','273162',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79715,239,'Rajmandir Kala','273162',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79716,239,'Ramnagar','273164',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79717,239,'Ramnagar','273155',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79718,239,'Rampur Baldiha','273151',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79719,239,'Rampur Kala','273163',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79720,239,'Ratanpur','273164',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79721,239,'Rengahia','273304',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79722,239,'Rudhaulibhawshak','273303',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79723,239,'Rudrapura Sheonath','273162',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79724,239,'Sabaya','273163',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79725,239,'Sahjanwa Babu','273157',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79726,239,'Salamat Garh','273303',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79727,239,'Sarpataha','273155',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79728,239,'Sauraha','273157',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79729,239,'Sekhanli','273304',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79730,239,'Sekhuani','273305',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79731,239,'Semra Chandauli','273301',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79732,239,'Semra Maharaj','273162',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79733,239,'Senduria','273207',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79734,239,'Sewareji','273303',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79735,239,'Shahabad','273157',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79736,239,'Shaildah','273162',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79737,239,'Shewatari Bzr','273305',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79738,239,'Shikarpur','273302',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79739,239,'Shyamdeorva','273306',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79740,239,'Siakrgarh','273157',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79741,239,'Sikandrajitpur','273161',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79742,239,'Siswa Raja','273302',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79743,239,'Smardhira','273162',1,0,'2022-03-03 13:05:06','2022-03-03 13:05:06'),(79744,239,'Sohrauna Tiwari','273302',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79745,239,'Sonara','273303',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79746,239,'Sonauli','273308',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79747,239,'Sonbarsa','273207',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79748,239,'Tarkulwa Tiwari','273302',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79749,239,'Thuthibari','273305',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79750,239,'Uska','273303',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79751,240,'Ainchana','210425',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79752,240,'Ajnar','210423',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79753,240,'Akona','210423',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79754,240,'Aktaunhan','210421',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79755,240,'Ari','210423',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79756,240,'Atrarmaf','210433',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79757,240,'Baghanra','210423',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79758,240,'Bagwaha','210426',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79759,240,'Bahadurpur Kalan','210429',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79760,240,'Bamhauri Kalan','210421',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79761,240,'Bamrara','210421',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79762,240,'Basaut','210425',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79763,240,'Bendo','210429',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79764,240,'Bhandra','210433',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79765,240,'Bharwara','210429',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79766,240,'Bijaypur','210429',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79767,240,'Bila Dakhin','210424',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79768,240,'Bilbai','210427',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79769,240,'Bilkhi','210433',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79770,240,'Budhwara','210423',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79771,240,'Chandauli','210421',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79772,240,'Charkhari State','210421',1,0,'2022-03-03 13:05:07','2022-03-03 13:05:07'),(79773,240,'Chhani Kalan','210424',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79774,240,'Dharaun','210424',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79775,240,'Dulara','210429',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79776,240,'Gandhi Nagar Mahoba','210427',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79777,240,'Ganj','210424',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79778,240,'Garha','210421',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79779,240,'Gaurahari','210429',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79780,240,'Gyondi','210507',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79781,240,'Jaitpur (Mahoba)','210423',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79782,240,'Kabrai','210424',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79783,240,'Kaithi','210429',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79784,240,'Kankuwan','210429',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79785,240,'Karahra Kalan','210427',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79786,240,'Kashipur','210429',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79787,240,'Khajuriha Pahra','210424',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79788,240,'Khanna','210504',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79789,240,'Kharela','210425',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79790,240,'Kilahua','210429',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79791,240,'Kohaniya','210429',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79792,240,'Kulpahar','210426',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79793,240,'Kuwan','210425',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79794,240,'Ladpur','210426',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79795,240,'Mahewa','210424',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79796,240,'Maho R.S.','210427',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79797,240,'Mahoba','210427',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79798,240,'Mahua','210429',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79799,240,'Mahuabandh','210423',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79800,240,'Makarbai','210424',1,0,'2022-03-03 13:05:08','2022-03-03 13:05:08'),(79801,240,'Masoodpura','210429',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79802,240,'Mudhari','210426',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79803,240,'Nagradang','210423',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79804,240,'Nanaura','210433',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79805,240,'Pachara','210423',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79806,240,'Paharia','210429',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79807,240,'Pahra Kalan','210427',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79808,240,'Panwari','210429',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79809,240,'Parsaha','210424',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79810,240,'Paswara','210427',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79811,240,'Patha','210424',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79812,240,'Pawa','210433',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79813,240,'Pewai Sunaicha','210424',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79814,240,'Pewan','210504',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79815,240,'Pipramaf','210433',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79816,240,'Rainpura','210421',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79817,240,'Rewai','210421',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79818,240,'Rewai Sunaicha','210424',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79819,240,'Rewan','210504',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79820,240,'Roori Kalan','210429',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79821,240,'Saidpur','210431',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79822,240,'Salarpur','210433',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79823,240,'Satari','210426',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79824,240,'Sheohar','210424',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79825,240,'Sijahri','210427',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79826,240,'Sijwaha','210433',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79827,240,'Singhaupur Baghari','210424',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79828,240,'Sirsi Kalan','210504',1,0,'2022-03-03 13:05:09','2022-03-03 13:05:09'),(79829,240,'Sirsi Khurd','210504',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79830,240,'Srinagar (Mahoba)','210433',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79831,240,'Sugira','210426',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79832,240,'Supa','210421',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79833,240,'Syondhi','210429',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79834,240,'Teiya','210429',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79835,240,'Tikamau','210427',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79836,240,'Tikaria','210423',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79837,240,'Umari','210429',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79838,241,'Achalpur','205263',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79839,241,'Agautha','205247',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79840,241,'Aghar','205262',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79841,241,'Ahimalpur','205304',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79842,241,'Ahirwa','205001',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79843,241,'Ajitganj','205247',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79844,241,'Alipur Kherha','205001',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79845,241,'Allau','205247',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79846,241,'Alupura','205265',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79847,241,'Andani','205264',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79848,241,'Anjani','205001',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79849,241,'Aramsarai','205262',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79850,241,'Arsara','205304',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79851,241,'Atirajpur','205264',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79852,241,'Auchha','205268',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79853,241,'Auden Mandan','205001',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79854,241,'Auden Padaria','205001',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79855,241,'Aung','205262',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79856,241,'Aunha','205001',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79857,241,'Aurandh','205267',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79858,241,'Awadh Nagar','205001',1,0,'2022-03-03 13:05:10','2022-03-03 13:05:10'),(79859,241,'Azmabad Araon','205121',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79860,241,'Badshahpur','205121',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79861,241,'Baijua Khas','205121',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79862,241,'Bajhera  Bujurg','205121',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79863,241,'Bajhera','205301',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79864,241,'Balarpur','205267',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79865,241,'Bamtapur','205264',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79866,241,'Banigon','205261',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79867,241,'Baranahal','205261',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79868,241,'Basait','205303',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79869,241,'Belahar','205265',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79870,241,'Beonti Khurd','205001',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79871,241,'Bewar Bazar','205301',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79872,241,'Bewar (Mainpuri)','205301',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79873,241,'Bhaisrauli','205262',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79874,241,'Bhawat','205247',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79875,241,'Bhidaura','205264',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79876,241,'Bhongaon','205262',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79877,241,'Bichhawan','205267',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79878,241,'Chandikara','205261',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79879,241,'Chandpura','205264',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79880,241,'Chauraipur','205303',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79881,241,'Chetai','205263',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79882,241,'Chhachha','205262',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79883,241,'Chitayan','205303',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79884,241,'Civil Court (Mainpuri)','205001',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79885,241,'Dalippur Kailai','205267',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79886,241,'Dalupur','205261',1,0,'2022-03-03 13:05:11','2022-03-03 13:05:11'),(79887,241,'Darwah','205119',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79888,241,'Daulatpur','205001',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79889,241,'Dharau','205001',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79890,241,'Dharmangadpur','205247',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79891,241,'Dihuli','205261',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79892,241,'Elabans','205304',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79893,241,'Farenzi','205303',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79894,241,'Galla Mandi Kurawali','205265',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79895,241,'Gangsi','205119',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79896,241,'Garhia Chhinkaura','205301',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79897,241,'Garhia Govindepur','205262',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79898,241,'Ghiror','205121',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79899,241,'Ghitauli','205001',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79900,241,'Gola Bazar','205001',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79901,241,'Grhiya','205264',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79902,241,'Halpura','205119',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79903,241,'Hathpau','205247',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79904,241,'Hazipur Nera','205261',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79905,241,'Himaunpur','205262',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79906,241,'Husainpur','205301',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79907,241,'Isai Gopalpur','205263',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79908,241,'J.I.C. Nauner','205001',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79909,241,'Jabapur','205119',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79910,241,'Jagatpur B','205267',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79911,241,'Jagir','205247',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79912,241,'Jakhaua','205265',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79913,241,'Jamaura','205262',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79914,241,'Jeonti','205263',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79915,241,'Joga','205301',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79916,241,'Johari Nagar','205121',1,0,'2022-03-03 13:05:12','2022-03-03 13:05:12'),(79917,241,'Kakan','205001',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79918,241,'Kalhor','205121',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79919,241,'Kapoorpur','205001',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79920,241,'Karhal Gate Mainpuri','205001',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79921,241,'Karhal (Mainpuri)','205264',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79922,241,'Karimganj','205001',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79923,241,'Kaua Tanda','205301',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79924,241,'Kharpari','205001',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79925,241,'Kinhawar','205267',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79926,241,'Kirthua','205264',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79927,241,'Kishni','205303',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79928,241,'Kosma','205119',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79929,241,'Kuchela','205119',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79930,241,'Kumhaul','205304',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79931,241,'Kuraoli','205265',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79932,241,'Kurhi','205304',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79933,241,'Kurra','205268',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79934,241,'Kusmara','205304',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79935,241,'Kutukpur','205303',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79936,241,'Lahara','205265',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79937,241,'Lakhanmau','205261',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79938,241,'Lakhaura','205265',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79939,241,'Lalupur','205001',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79940,241,'Madhan','205263',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79941,241,'Madhukarpur','205304',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79942,241,'Madhupuri','205301',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79943,241,'Maholi Shamserganj','205303',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79944,241,'Mainpuri City','205001',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79945,241,'Mainpuri H.O','205001',1,0,'2022-03-03 13:05:13','2022-03-03 13:05:13'),(79946,241,'Mainpuri R S','205001',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79947,241,'Manauna','205263',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79948,241,'Manchhana','205001',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79949,241,'Manigaon','205304',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79950,241,'Manpur Hari','205301',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79951,241,'Maujepur Havelia','205262',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79952,241,'Mohabbatpur','205268',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79953,241,'Mota','205262',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79954,241,'Mudausi','205304',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79955,241,'Mudausi','205301',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79956,241,'Musayatpur Kheriya','205121',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79957,241,'Nabiganj','205301',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79958,241,'Nagla Dik','205264',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79959,241,'Nagla Jula','205001',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79960,241,'Nagla Painth','205301',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79961,241,'Nagla Semar','205267',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79962,241,'Naigwan -kheria','205303',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79963,241,'Nakau','205264',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79964,241,'Nanamau','205265',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79965,241,'Naugaon','205265',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79966,241,'Nauner','205001',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79967,241,'Naviganj','205001',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79968,241,'Nawa Terha','205261',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79969,241,'Naya Bazar Bhongaon','205262',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79970,241,'Ninauli','205001',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79971,241,'Pachawer','205121',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79972,241,'Pairar Shahpur','205264',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79973,241,'Paronkh','205263',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79974,241,'Paronkha','205301',1,0,'2022-03-03 13:05:14','2022-03-03 13:05:14'),(79975,241,'Patara','205268',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(79976,241,'Pundari','205247',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(79977,241,'Raja Ki Bajria','205001',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(79978,241,'Rajwana','205262',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(79979,241,'Rakari','205262',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(79980,241,'Ramnagar','205304',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(79981,241,'Ranipur','205268',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(79982,241,'Ratanpur Bara','205247',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(79983,241,'Ratheh','205303',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(79984,241,'Ratibhanpur','205001',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(79985,241,'Rui Sinaura','205262',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(79986,241,'Sagauni','205001',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(79987,241,'Sahan','205268',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(79988,241,'Sahara','205267',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(79989,241,'Sakra','205304',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(79990,241,'Salempur','205265',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(79991,241,'Saman','205001',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(79992,241,'Saman','205303',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(79993,241,'Sarakh','205261',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(79994,241,'Sauj','205268',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(79995,241,'Shahjahanpur','205121',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(79996,241,'Sharifpur','205265',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(79997,241,'Shjhajipur','205264',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(79998,241,'Sikandarpur','205001',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(79999,241,'Simarai','205267',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(80000,241,'Sonai','205265',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(80001,241,'Sugaon','205247',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(80002,241,'Sukurullapur','205261',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(80003,241,'Sultanganj (Mainpuri)','205267',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(80004,241,'Takharau','205268',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(80005,241,'Talibpur','205261',1,0,'2022-03-03 13:05:15','2022-03-03 13:05:15'),(80006,241,'Thorwa','205263',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80007,241,'Tindauli','205119',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80008,241,'Tisauli','205267',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80009,241,'Ujhaiya- Fakirpur','205263',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80010,241,'Uncha Islamabad','205304',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80011,241,'Urthan','205264',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80012,241,'Vinayakpur','205268',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80013,241,'Vinodpur','205262',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80014,241,'Zilla Parishad','205001',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80015,242,'Adooki','281006',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80016,242,'Agaryala','281404',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80017,242,'Ahamadpur','281201',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80018,242,'Airakhera','281204',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80019,242,'Ajhai Kurd','281406',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80020,242,'Akbarpur','281406',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80021,242,'Akosh','281301',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80022,242,'Anora','281308',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80023,242,'Anyour','281502',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80024,242,'Aring','281501',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80025,242,'Arrua','281202',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80026,242,'Arya Samaj Road','281001',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80027,242,'Atasbangar','281406',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80028,242,'Aurangabad','281006',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80029,242,'Awakhera','281201',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80030,242,'Bachchgaon','281123',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80031,242,'Bad','281006',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80032,242,'Badhauta','281504',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80033,242,'Bajna (Mathura)','281201',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80034,242,'Bakla','281204',1,0,'2022-03-03 13:05:16','2022-03-03 13:05:16'),(80035,242,'Baldeo','281301',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80036,242,'Baltikari','281308',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80037,242,'Bandi','281301',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80038,242,'Baramai','281302',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80039,242,'Barari','281005',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80040,242,'Barauli','281301',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80041,242,'Barauth','281201',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80042,242,'Barchawali','281403',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80043,242,'Bardhaun','281204',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80044,242,'Barsana','281405',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80045,242,'Bathain Kalan','281403',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80046,242,'Bati','281004',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80047,242,'Beri','281122',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80048,242,'Beyonhi','281308',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80049,242,'Bhadanwara','281205',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80050,242,'Bhaderua','281122',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80051,242,'Bhadraban','281202',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80052,242,'Bhagosa','281502',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80053,242,'Bhainsa','281005',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80054,242,'Bhalai','281205',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80055,242,'Bharana Kalan','281502',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80056,242,'Bharatia','281302',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80057,242,'Bharatpur Darwaza','281001',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80058,242,'Bhidoni','281205',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80059,242,'Bhooreka','281205',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80060,242,'Bisawali','281204',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80061,242,'Bisawar','281302',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80062,242,'Bishambhara','281401',1,0,'2022-03-03 13:05:17','2022-03-03 13:05:17'),(80063,242,'Brij Accadamy','281001',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80064,242,'Bukharari','281403',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80065,242,'Chandpur','281201',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80066,242,'Chaumuhan','281406',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80067,242,'Chhata Bazar (Mathura)','281001',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80068,242,'Chhata (Mathura)','281401',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80069,242,'Chhatikara','281001',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80070,242,'Chhinparai','281203',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80071,242,'Civil Court (Mathura)','281001',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80072,242,'Daghenta','281308',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80073,242,'Dahgaon','281403',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80074,242,'Dalauta','281404',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80075,242,'Dampier Nagar','281001',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80076,242,'Dangoli Banger','281202',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80077,242,'Daulatpur','281301',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80078,242,'Dautana','281401',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80079,242,'Deeg Gate','281001',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80080,242,'Deoseras','281502',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80081,242,'Dhanajeewana','281122',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80082,242,'Dhangaon','281005',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80083,242,'Edalgarhi','281201',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80084,242,'Farah','281122',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80085,242,'Fonder','281123',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80086,242,'G.B. Jatipura','281001',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80087,242,'G.N. Bazar','281121',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80088,242,'Gadhya Latipur','281122',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80089,242,'Gajoo','281206',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80090,242,'Garhumrao','281302',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80091,242,'Gayatri Tapo Bhoomi','281003',1,0,'2022-03-03 13:05:18','2022-03-03 13:05:18'),(80092,242,'Gidoh','281403',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80093,242,'Gokul','281303',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80094,242,'Goverdhan','281502',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80095,242,'Gudera','281206',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80096,242,'Gurkul','281001',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80097,242,'Harnaul','281202',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80098,242,'Hasanpur','281205',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80099,242,'Hatana','281403',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80100,242,'Hathia','281405',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80101,242,'Hayatpur','281305',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80102,242,'Jab','281403',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80103,242,'Jabra','281202',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80104,242,'Jait','281001',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80105,242,'Jarara','281205',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80106,242,'Jatwari','281404',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80107,242,'Jhanrautha','281301',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80108,242,'Jhudawai','281122',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80109,242,'Jikhangaon','281501',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80110,242,'Junsuti','281501',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80111,242,'Kadauna','281403',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80112,242,'Kamai','281405',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80113,242,'Karab','281204',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80114,242,'Karahari','281205',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80115,242,'Karnar','281403',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80116,242,'Khaira','281401',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80117,242,'Khairakothi','281205',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80118,242,'Khamani','281501',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80119,242,'Kharauth','281403',1,0,'2022-03-03 13:05:19','2022-03-03 13:05:19'),(80120,242,'Khirari','281204',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80121,242,'Khonthra','281123',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80122,242,'Kishanpur','281305',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80123,242,'Kolahar','281201',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80124,242,'Kosi Kalan','281403',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80125,242,'Kosi Khurd','281005',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80126,242,'Kotban','281403',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80127,242,'Krishna Nagar (Mathura)','281004',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80128,242,'Krishna Puri','281001',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80129,242,'Kumhan','281206',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80130,242,'Ladhpur','281401',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80131,242,'Lal Darwaza (Mathura)','281001',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80132,242,'Lalpur','281403',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80133,242,'Leela Dham','281121',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80134,242,'Lohai','281205',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80135,242,'Lohban','281204',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80136,242,'Loi Bazar','281121',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80137,242,'Madaura','281301',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80138,242,'Madem','281204',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80139,242,'Magna','281301',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80140,242,'Magorra','281001',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80141,242,'Mahaban','281305',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80142,242,'Maharana','281405',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80143,242,'Mahmadpur Parasoli','281502',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80144,242,'Maholi','281004',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80145,242,'Maholi Road','281004',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80146,242,'Mahrauli','281502',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80147,242,'Mai','281302',1,0,'2022-03-03 13:05:20','2022-03-03 13:05:20'),(80148,242,'Managarhi','281201',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80149,242,'Manav Sew Shangh','281121',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80150,242,'Maninabalu','281204',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80151,242,'Mant','281202',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80152,242,'Matholi','281201',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80153,242,'Mathura Chawk','281001',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80154,242,'Mathura City','281001',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80155,242,'Mathura H.O','281001',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80156,242,'Mathura Jn. R.S.','281001',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80157,242,'Mathura Refinery','281005',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80158,242,'Meerpur','281205',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80159,242,'Midhawali','281302',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80160,242,'Mudseras','281502',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80161,242,'Musmuna','281203',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80162,242,'Nagaura','281204',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80163,242,'Nagla Bali','281301',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80164,242,'Nainu Patti','281123',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80165,242,'Nandgaon','281403',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80166,242,'Nari','281401',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80167,242,'Nasitte','281202',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80168,242,'Naugaon','281502',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80169,242,'Naugaon','281404',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80170,242,'Nauhjhil','281203',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80171,242,'Nawali','281205',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80172,242,'Neemgaon','281204',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80173,242,'Nera','281301',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80174,242,'Ol','281122',1,0,'2022-03-03 13:05:21','2022-03-03 13:05:21'),(80175,242,'Pachawar','281308',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80176,242,'Paingaon','281401',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80177,242,'Paintha','281502',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80178,242,'Palson','281502',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80179,242,'Panigaon','281204',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80180,242,'Parasoli','281201',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80181,242,'Parkham','281122',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80182,242,'Parkhamgujar','281406',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80183,242,'Patlauni','281301',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80184,242,'Pchahara','281201',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80185,242,'Pelkhu','281504',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80186,242,'Phalen','281403',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80187,242,'Pilua','281122',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80188,242,'Pingari','281122',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80189,242,'Prem Nagar','281003',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80190,242,'R.D. Bazar','281001',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80191,242,'Radhakund','281504',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80192,242,'Raipur','281203',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80193,242,'Raipura Jat','281122',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80194,242,'Rajagarhi Khawal','281205',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80195,242,'Ral','281504',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80196,242,'Raman Rati','281121',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80197,242,'Ranhera','281404',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80198,242,'Ranwari','281401',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80199,242,'Raya','281204',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80200,242,'Refinery Nagar','281006',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80201,242,'Regimental Bazar','281001',1,0,'2022-03-03 13:05:22','2022-03-03 13:05:22'),(80202,242,'Roberts Line (Mathura)','281001',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80203,242,'Roop Nagar','281403',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80204,242,'Sadar Bazar (Mathura)','281001',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80205,242,'Sahar','281502',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80206,242,'Sahpur','281403',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80207,242,'Sakatpur','281201',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80208,242,'Sankat Mochan','281001',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80209,242,'Sarai Daud','281308',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80210,242,'Sardargarh','281204',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80211,242,'Satoha','281004',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80212,242,'Sehi','281406',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80213,242,'Senwa','281404',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80214,242,'Sersa','281005',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80215,242,'Shall','281201',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80216,242,'Shergarh (Mathura)','281404',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80217,242,'Sihora','281305',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80218,242,'Sikanderpur','281205',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80219,242,'Siriya Ki Nagaria','281204',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80220,242,'Siwal','281502',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80221,242,'Son','281123',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80222,242,'Sonai (Mathura)','281206',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80223,242,'Sonkh Khera','281308',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80224,242,'Sonkh','281123',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80225,242,'Sri Bankey Bihari Ji','281121',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80226,242,'Sri Krishna Janam Sthan','281001',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80227,242,'Sukh Sancharak','281001',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80228,242,'Surir','281205',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80229,242,'Tarauli','281406',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80230,242,'Tasinga','281302',1,0,'2022-03-03 13:05:23','2022-03-03 13:05:23'),(80231,242,'Tentigaon','281202',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80232,242,'Udhar','281204',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80233,242,'Usfar','281004',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80234,242,'Vairani','281301',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80235,242,'Veternary College','281001',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80236,242,'Vrindaban','281121',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80237,243,'Adari','275102',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80238,243,'Ahamadpur Asana','275304',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80239,243,'Ailakhaimilia','221706',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80240,243,'Ali Nagar','275305',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80241,243,'Allauddinpur','276403',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80242,243,'Amila','275301',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80243,243,'Ardauna','221705',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80244,243,'Ariyaso','275105',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80245,243,'Ataraul Pandey','221706',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80246,243,'Bada Gaon','276403',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80247,243,'Badraon','275301',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80248,243,'Badua Godam','275305',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80249,243,'Bahadurpur','221602',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80250,243,'Baktawar Ganj','275305',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80251,243,'Bandi Ghat','275306',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80252,243,'Bandikala','276403',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80253,243,'Bangali Pijara','275103',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80254,243,'Banpokhara','221603',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80255,243,'Bara','276405',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80256,243,'Bariyadih','221601',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80257,243,'Baundih','221603',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80258,243,'Belaujha','221706',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80259,243,'Bhadir','276405',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80260,243,'Bharopur','221603',1,0,'2022-03-03 13:05:24','2022-03-03 13:05:24'),(80261,243,'Bhatmila','275301',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80262,243,'Bhawaria Sath','275305',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80263,243,'Bhela Bandh','275305',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80264,243,'Bhopaura','275302',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80265,243,'Bibi Pur','276306',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80266,243,'Bojhi Bazar','275301',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80267,243,'Bramhanpur','276129',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80268,243,'Canal Head','275303',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80269,243,'Chakarka','221705',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80270,243,'Chhapara','276129',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80271,243,'Chhichore','221706',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80272,243,'Chiraia Kot','276129',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80273,243,'Dagauli','275306',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80274,243,'Dargah','276306',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80275,243,'Daulasepur','276403',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80276,243,'Dev Kali Tas','276403',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80277,243,'Dhaur Hara','276405',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80278,243,'Dholana','276405',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80279,243,'Dhrampur Bisnupur','221601',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80280,243,'Dohari  Ghat','275303',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80281,243,'Dubari','221601',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80282,243,'Duwraon','221705',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80283,243,'Faizullahpur','275305',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80284,243,'Fateh Pur Tal Naraja','275302',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80285,243,'Fatehpur','276402',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80286,243,'Fatehpur Talratoy','221603',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80287,243,'Gahana','221705',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80288,243,'Gahani','221705',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80289,243,'Gajiapur','221601',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80290,243,'Gangupur','221601',1,0,'2022-03-03 13:05:25','2022-03-03 13:05:25'),(80291,243,'Ghosi (Mau)','275304',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80292,243,'Gokulpura','276402',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80293,243,'Golauri','221706',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80294,243,'Gotha','275303',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80295,243,'Haldharpur','221705',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80296,243,'Halima Bad','276403',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80297,243,'Hamid Pur','275302',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80298,243,'Hardas Pur','275305',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80299,243,'Hathini','275305',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80300,243,'Hemai','275301',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80301,243,'Indara','275102',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80302,243,'Iraura Chaubey Pur','275302',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80303,243,'Jajaauli','221603',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80304,243,'Jamal Mirja Pur','275105',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80305,243,'Jogari','275306',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80306,243,'Kahinaur','275101',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80307,243,'Kaitholi','275101',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80308,243,'Kajha','276129',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80309,243,'Kalyanpur','275105',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80310,243,'Kamalsagar','221602',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80311,243,'Kamarawa','276129',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80312,243,'Kanjhakhurd','276403',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80313,243,'Kanso','221706',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80314,243,'Karaha','276402',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80315,243,'Karami','276129',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80316,243,'Kari Sath','275105',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80317,243,'Kasana','275305',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80318,243,'Katghar Shankar','221603',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80319,243,'Kathtaraon','221602',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80320,243,'Katirahi Bugurg','275301',1,0,'2022-03-03 13:05:26','2022-03-03 13:05:26'),(80321,243,'Khaira BaL','276403',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80322,243,'Khiriya','275103',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80323,243,'Khurhar','276403',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80324,243,'Kirath Sarai','221705',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80325,243,'Kolaura','276403',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80326,243,'Kopa Ganj','275305',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80327,243,'Kushmaur','275103',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80328,243,'Lakhani Mubarakpur','275307',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80329,243,'Lalitpur','275307',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80330,243,'Lilari Bharauli','275105',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80331,243,'Madhu Ban','221603',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80332,243,'Mahula','275303',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80333,243,'Majhwara','275307',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80334,243,'Makhmelpur','275307',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80335,243,'Makhuni','276403',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80336,243,'Manik Pur Haraura','275304',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80337,243,'Maryad Pur.','221602',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80338,243,'Mau H.O','275101',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80339,243,'Mau Town','275101',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80340,243,'Mau. R.S.','275101',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80341,243,'Maur Bojh','275105',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80342,243,'Mirjahadipura Chowk','',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80343,243,'Mirpur Rahima Par','275306',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80344,243,'Misarauli','276129',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80345,243,'Misarauli','276306',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80346,243,'Mohammad Pur Math','275305',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80347,243,'Mohammadabad Gohana Chowk','276403',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80348,243,'Mohammadabad Gohna','276403',1,0,'2022-03-03 13:05:27','2022-03-03 13:05:27'),(80349,243,'Mohammadabad Sipah','275303',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80350,243,'Molnapur','221601',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80351,243,'Moongmas','275307',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80352,243,'Mustafa Bad','221706',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80353,243,'Nai Bazar','275303',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80354,243,'Narawa Sarai','275302',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80355,243,'Nasira Bad Kala','221706',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80356,243,'Nemdand','221602',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80357,243,'Oril','223222',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80358,243,'Padari','276402',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80359,243,'Pahasa','221705',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80360,243,'Pakari Bujurg','275304',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80361,243,'Pali Garh','276403',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80362,243,'Palia','276403',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80363,243,'Panail','275303',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80364,243,'Parasia','221601',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80365,243,'Parasupur','275307',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80366,243,'Pardaha','221705',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80367,243,'Pawani','275307',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80368,243,'Pidhwal','275105',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80369,243,'Pilsui','275301',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80370,243,'Pindohari','221706',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80371,243,'Piruth Singhpur','275301',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80372,243,'Pithaupur Rasti','276126',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80373,243,'Piwatal','275301',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80374,243,'Raikwardeeh','275103',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80375,243,'Raini','276403',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80376,243,'Rajapur','276402',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80377,243,'Rampur','221602',1,0,'2022-03-03 13:05:28','2022-03-03 13:05:28'),(80378,243,'Rampur Sohand','275301',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80379,243,'Rangdih','276305',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80380,243,'Rani Puj','276129',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80381,243,'Rasepur','276129',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80382,243,'Rasoolpur','276306',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80383,243,'Ratan Pura','221706',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80384,243,'Sachui','276129',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80385,243,'Saharoj','275305',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80386,243,'Salahabad','275103',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80387,243,'Sansarava','276402',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80388,243,'Sarai Ganesh','275105',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80389,243,'Sarauda','276129',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80390,243,'Sarvan','221705',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80391,243,'Saundih','221603',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80392,243,'Semari Jamal Pur','275307',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80393,243,'Semrajpur','221706',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80394,243,'Siddha Ahilashpur','221603',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80395,243,'Singdhwal','221706',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80396,243,'Sipaibrahima Bad','221603',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80397,243,'Sulatanipur','276402',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80398,243,'Sultan Pur','275304',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80399,243,'Surahu Pur','276403',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80400,243,'Tajopur','275305',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80401,243,'Talai Pur','221705',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80402,243,'Towa','276305',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80403,243,'Umapur','221705',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80404,243,'Undaura','221603',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80405,243,'Usari Khurd','275301',1,0,'2022-03-03 13:05:29','2022-03-03 13:05:29'),(80406,243,'Walid Pur','276405',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80407,243,'Yakubpur','276402',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80408,244,'A.P. Badhla','250406',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80409,244,'Abdullapur','250001',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80410,244,'Abulane','250001',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80411,244,'Agwanpur','250406',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80412,244,'Ahmedpur','250406',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80413,244,'Ajrara','245206',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80414,244,'Akbarpur Sadat','250401',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80415,244,'Alipur','250221',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80416,244,'Alipur Morna','250401',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80417,244,'Amanullapur','250502',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80418,244,'Amarsinghpur','250406',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80419,244,'Anaj Mandi (Meerut)','250002',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80420,244,'Arnawali','250502',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80421,244,'Aseelpur','250104',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80422,244,'Assa','250401',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80423,244,'Atrara','245206',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80424,244,'B. N. Nanu','250341',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80425,244,'Baghpat Gate','250002',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80426,244,'Bahadurpur','250341',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80427,244,'Bana','250001',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80428,244,'Banker Street','250002',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80429,244,'Baparsi','250342',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80430,244,'Baram','250502',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80431,244,'Bastora','250404',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80432,244,'Begum Bagh','250001',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80433,244,'Behrampur','250501',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80434,244,'Behsuma','250404',1,0,'2022-03-03 13:05:30','2022-03-03 13:05:30'),(80435,244,'Belvedere','250001',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80436,244,'Bhadoli','245206',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80437,244,'Bhainsa','250401',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80438,244,'Bhalsona','250341',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80439,244,'Bhatipura','250001',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80440,244,'Bhola','250501',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80441,244,'Bhombori','250342',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80442,244,'Bhooni','250344',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80443,244,'Bhoor Baral','250103',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80444,244,'Bijauli','245206',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80445,244,'Boundary Road','250001',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80446,244,'Budhana Gate','250002',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80447,244,'Budhera Zahidpur','250002',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80448,244,'C.B.Sardhana','250342',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80449,244,'Chandori Khas','250502',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80450,244,'Chandsara','245206',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80451,244,'Chhabariya','250342',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80452,244,'Chhajupur','250205',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80453,244,'Chhipi Tank','250002',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80454,244,'Chhur','250342',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80455,244,'Chitwana Sherpur','250406',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80456,244,'Dabathwa','250341',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80457,244,'Dabka','250001',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80458,244,'Dadri','250223',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80459,244,'Dahadra','250501',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80460,244,'Dahar','250344',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80461,244,'Dalampur','250502',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80462,244,'Darveshpur','250401',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80463,244,'Datawali','250004',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80464,244,'Daurala Gaon','250221',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80465,244,'Daurala','250221',1,0,'2022-03-03 13:05:31','2022-03-03 13:05:31'),(80466,244,'Defence Colony (Meerut)','250001',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80467,244,'Dhanpura','250401',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80468,244,'Dhikauli','250402',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80469,244,'Digamber Jain Mandir','250404',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80470,244,'Doodhli','250404',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80471,244,'Dulhera','250110',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80472,244,'Ekla Rasulpur','250406',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80473,244,'Ekri','250341',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80474,244,'Etmadpur','250406',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80475,244,'Gadeena','250401',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80476,244,'Gagol','245206',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80477,244,'Gandhi Ashram (Meerut)','250002',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80478,244,'Ganeshpur','250404',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80479,244,'Ganganagar','250001',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80480,244,'Gesupur','250104',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80481,244,'Ghosipur','250002',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80482,244,'Gotka','250344',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80483,244,'Gurukul Dorli','250001',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80484,244,'Harra','250344',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80485,244,'Hasanpur Kadim','250004',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80486,244,'Hasanpur Kalan','250106',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80487,244,'Hastinapur','250404',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80488,244,'I. E. Partapur','250103',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80489,244,'Incholi','250001',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80490,244,'Jai','250406',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80491,244,'Jai Singhpur','250401',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80492,244,'Jangethi','250341',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80493,244,'Jani Kalan','250501',1,0,'2022-03-03 13:05:32','2022-03-03 13:05:32'),(80494,244,'Jani','250501',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80495,244,'Janjokhar','250341',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80496,244,'Jaroda','250104',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80497,244,'Jassar Sultanpur','250344',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80498,244,'Jatauli','250001',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80499,244,'Jhitkari','250342',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80500,244,'Jithauli','250004',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80501,244,'Kabari Bazar','250002',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80502,244,'Kaili','250223',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80503,244,'Kaili','245206',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80504,244,'Kaiser Ganj','250002',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80505,244,'Kaithwari','250502',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80506,244,'Kaland','250342',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80507,244,'Kalandi','250342',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80508,244,'Kalanjari','250501',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80509,244,'Kalina','250502',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80510,244,'Kalyanpur','250502',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80511,244,'Kanker Khera','250001',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80512,244,'Kanshi','250205',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80513,244,'Kapsad','250223',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80514,244,'Karnawal','250344',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80515,244,'Kaseru Khera','250001',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80516,244,'Kastla Shamshernagar','250001',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80517,244,'Kaul','250401',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80518,244,'Kaul','245206',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80519,244,'Kayastha Badha','250001',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80520,244,'Kazamabad Goon','250205',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80521,244,'Khajuri','250406',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80522,244,'Khanpur','250501',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80523,244,'Kharkhuda','245206',1,0,'2022-03-03 13:05:33','2022-03-03 13:05:33'),(80524,244,'Khaspur','245206',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80525,244,'Khera','250342',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80526,244,'Khirwa Jalalpur','250341',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80527,244,'Khiwai','250344',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80528,244,'Kina Nagar','250004',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80529,244,'Kishanpura (Meerut)','250002',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80530,244,'Kishorepur','250404',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80531,244,'Kitholi','250501',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80532,244,'Kithore','250104',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80533,244,'Krishana Nagar','250001',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80534,244,'Kulanjan','250221',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80535,244,'Kurali','250501',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80536,244,'Kushaoli','250342',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80537,244,'L. L. R. M. Med.college','250004',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80538,244,'Lalyana','250104',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80539,244,'Laskaarganj','250342',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80540,244,'Latifpur','250404',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80541,244,'Lawar','250222',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80542,244,'Lisari','250002',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80543,244,'Lisari Gate','250002',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80544,244,'Lohiya','250221',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80545,244,'M. P. Sikhera','250404',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80546,244,'Machhara','250106',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80547,244,'Mahadev','250342',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80548,244,'Mahalka','250222',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80549,244,'Mahalwala','250104',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80550,244,'Maina Poothi','250344',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80551,244,'Mainthna Inder Singh','250001',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80552,244,'Malyana','250002',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80553,244,'Mandora','250223',1,0,'2022-03-03 13:05:34','2022-03-03 13:05:34'),(80554,244,'Manpur','250406',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80555,244,'Mataur','250221',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80556,244,'Maukhas','250001',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80557,244,'Maur Khurd','250404',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80558,244,'Mawana Factory','250402',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80559,244,'Mawana Khurd','250401',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80560,244,'Mawana','250401',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80561,244,'Mawana Tehsil','250401',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80562,244,'Meerpur','250502',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80563,244,'Meerut Cantt H.O','250001',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80564,244,'Meerut City H.O','250002',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80565,244,'Meerut City R. S.','250002',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80566,244,'Meerut Kutchery','250003',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80567,244,'Meerut Tehsil','250002',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80568,244,'Meerut University','250004',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80569,244,'Meewan','250401',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80570,244,'Mel','250222',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80571,244,'MIET','250005',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80572,244,'Modipuram','250110',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80573,244,'Mohiuddinpur','250205',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80574,244,'Mulhera','250342',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80575,244,'Mundali','250001',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80576,244,'Murlipur Phool','250004',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80577,244,'Muzaffarnagar Saini','250001',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80578,244,'Muzaffarpur Bagarpur','250104',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80579,244,'Muzahidpur','250342',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80580,244,'Muzakkipur','250205',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80581,244,'Nadir Ali & Co.','250002',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80582,244,'Nagla Hareru','250401',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80583,244,'Nagli Badli','250104',1,0,'2022-03-03 13:05:35','2022-03-03 13:05:35'),(80584,244,'Naidu','250401',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80585,244,'Narangpur','250406',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80586,244,'Narangpur','250502',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80587,244,'Navinmandi','250002',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80588,244,'Nek','250501',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80589,244,'Niloha','250401',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80590,244,'P. R. C.','250001',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80591,244,'Pabli Khas','250110',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80592,244,'Panchi','245206',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80593,244,'Panchli Buzurg','250344',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80594,244,'Panchli Khurd','250002',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80595,244,'Parikshatgarh','250406',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80596,244,'Partapur','250103',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80597,244,'Paswara','250106',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80598,244,'Pathauli','250341',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80599,244,'Peepla Idrishpur','250501',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80600,244,'Phalauda','250001',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80601,244,'Phaphunda','245206',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80602,244,'Phitkari','250401',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80603,244,'Pilona','250401',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80604,244,'Pithlokar','250342',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80605,244,'Pohli','250341',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80606,244,'Poothi','250406',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80607,244,'Poothkhas','250502',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80608,244,'R.A.Bazar','250001',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80609,244,'Rachhauti','250106',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80610,244,'Radhana','250104',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80611,244,'Rahaoti','250401',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80612,244,'Rajpura','250001',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80613,244,'Ramlilaground','250002',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80614,244,'Ramnagar (Meerut)','250002',1,0,'2022-03-03 13:05:36','2022-03-03 13:05:36'),(80615,244,'Rardhana','250342',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80616,244,'Rasna','250502',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80617,244,'Rasulpur Aurangabad','250001',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80618,244,'Rasulpur Kinoni','250502',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80619,244,'Rasulpur Rohta','250502',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80620,244,'Rithani','250103',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80621,244,'Rly. Road Meerut','250002',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80622,244,'Ruhasa','250223',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80623,244,'Rukanpur Morna','250001',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80624,244,'S.G.Mandi','250002',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80625,244,'Saifpur Karamchanpur','250404',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80626,244,'Saket (Meerut)','250003',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80627,244,'Sakoti Tanda','250223',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80628,244,'Salawa','250342',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80629,244,'Samai Pur','250004',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80630,244,'Samoli Khash Pur','250221',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80631,244,'Sandhan','250401',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80632,244,'Sarawa','245206',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80633,244,'Sardhana Road','250001',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80634,244,'Sardhana','250342',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80635,244,'Sarrafa Bazar','250002',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80636,244,'Sarsawa','250221',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80637,244,'Sarurpur Khurd','250344',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80638,244,'Sarwani Arifpur','250104',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80639,244,'Sathla','250402',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80640,244,'Satwai','250502',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80641,244,'Shafibad Loti','250104',1,0,'2022-03-03 13:05:37','2022-03-03 13:05:37'),(80642,244,'Shahjahanpur','250104',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80643,244,'Shastri Nagar (Meerut)','250004',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80644,244,'Shivpuri (Meerut)','250002',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80645,244,'Sholda','250106',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80646,244,'Sikhera','250001',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80647,244,'Sisoli','250004',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80648,244,'Siwal','250501',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80649,244,'Siwaya','250110',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80650,244,'Siyal','250406',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80651,244,'Sondutt','250406',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80652,244,'Suraj Kund Road','250002',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80653,244,'Tarapur','250404',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80654,244,'Thapar Nagar','250002',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80655,244,'Tofapur','250401',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80656,244,'Uldhan','245206',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80657,244,'Victoria Park','250001',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80658,244,'W. K. Road','250002',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80659,245,'Adalhat','231302',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80660,245,'Adhwar','231301',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80661,245,'Agarsand','231305',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80662,245,'Ahraura','231301',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80663,245,'Ahungi Kala','231211',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80664,245,'Akodhi','231307',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80665,245,'Amaha Mafi','231211',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80666,245,'Amoi','231307',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80667,245,'Babura','231307',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80668,245,'Babura Kala','231211',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80669,245,'Bagahan','231306',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80670,245,'Bagahi','231304',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80671,245,'Baghaura','231210',1,0,'2022-03-03 13:05:38','2022-03-03 13:05:38'),(80672,245,'Bahuar','231302',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80673,245,'Baidand','231210',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80674,245,'Bajta','231313',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80675,245,'Balliparwa','231312',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80676,245,'Bangla Devaria','231305',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80677,245,'Baraini','231501',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80678,245,'Baraudha Belan','231211',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80679,245,'Barbasa Gaharwar','231211',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80680,245,'Bardiha Kala','231211',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80681,245,'Barkachha','231307',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80682,245,'Bedaur','231211',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80683,245,'Belahara','231309',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80684,245,'Bhainsa','231501',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80685,245,'Bhaisod Balay Pahad','231211',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80686,245,'Bharehata','231304',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80687,245,'Bharpura','231304',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80688,245,'Bhatauli','231501',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80689,245,'Bhawanipur','231304',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80690,245,'Bhudkuda','231304',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80691,245,'Bhuelikhas','231302',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80692,245,'Bidapur','231501',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80693,245,'Bihsada','231303',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80694,245,'Bijaipur (Mirzapur)','231303',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80695,245,'Bilra Patehara','231211',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80696,245,'Biraura','231303',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80697,245,'Birohi','231303',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80698,245,'Birshahpur','231501',1,0,'2022-03-03 13:05:39','2022-03-03 13:05:39'),(80699,245,'Chaturipur','231302',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80700,245,'Chhatahan','231307',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80701,245,'Chhota Mirzapur','231305',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80702,245,'Chilh','231312',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80703,245,'Chunar Cement Factory','231311',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80704,245,'Chunar Fort','231304',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80705,245,'Chunar Rly Station','231304',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80706,245,'Chunar','231304',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80707,245,'Chunar Tehsil','231304',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80708,245,'Dadwan Pakseda','231303',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80709,245,'Dargah Sharif','231304',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80710,245,'Darhiram','231304',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80711,245,'Derhauna','231302',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80712,245,'Devaria','231305',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80713,245,'Devpura','231210',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80714,245,'Dewari','231307',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80715,245,'Domanpur','231306',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80716,245,'Domari','231305',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80717,245,'Dramandganj','231211',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80718,245,'Dubarkala','231211',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80719,245,'Dugauli','231313',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80720,245,'Ekali','231301',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80721,245,'Gadauli','231501',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80722,245,'Ganesh Ganj (Mirzapur)','231001',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80723,245,'Gangpur','231304',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80724,245,'Gaura','231313',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80725,245,'Ghanshyampur','231302',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80726,245,'Ghatampur','231301',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80727,245,'Gogaon','231313',1,0,'2022-03-03 13:05:40','2022-03-03 13:05:40'),(80728,245,'Gothaura','231302',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80729,245,'Gursandi','231501',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80730,245,'Hallia','231211',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80731,245,'Hansipur','231306',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80732,245,'Hardi Gulalpur','231211',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80733,245,'Hargarh Bazar','231313',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80734,245,'Hariharpur','231305',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80735,245,'Hariharpur Bedauli','231307',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80736,245,'Hinauta','231210',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80737,245,'Hinauti','231304',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80738,245,'Hussainpur','231301',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80739,245,'Industrial Estate (Mirzapur)','231001',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80740,245,'Jaipatti Kala','231305',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80741,245,'Jalalpur','231501',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80742,245,'Jalalpur Mafi','231304',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80743,245,'Jamalpur','231302',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80744,245,'Jamua (Mirzapur)','231314',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80745,245,'Jamuhar','231304',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80746,245,'Jamui','231210',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80747,245,'Jigna RS','231313',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80748,245,'Kachhwa (Mirzapur)','231501',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80749,245,'Kakarad','231309',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80750,245,'Kalna','231303',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80751,245,'Kamalpur','231305',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80752,245,'Kamasin','231312',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80753,245,'Kandawa','231304',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80754,245,'Kanhaipur','231309',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80755,245,'Kanokhar','231211',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80756,245,'Kathinai','231304',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80757,245,'Khaira','231313',1,0,'2022-03-03 13:05:41','2022-03-03 13:05:41'),(80758,245,'Khajuraul','231305',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80759,245,'Khanjadipur','231304',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80760,245,'Khanpur','231306',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80761,245,'Kholua','231312',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80762,245,'Kolna','231304',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80763,245,'Kota Shiv Pratap Singh','231211',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80764,245,'Kotwa','231309',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80765,245,'Kubari Patehara','231309',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80766,245,'Kushhan','231303',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80767,245,'Kusumhi','231304',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80768,245,'Lahangpur','231211',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80769,245,'Lahaura','231304',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80770,245,'Laldiggi','231001',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80771,245,'Lalganj (Mirzapur)','231211',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80772,245,'Lalpur Naudiha','231210',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80773,245,'Magarahan','231306',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80774,245,'Mahamalpur','231501',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80775,245,'Mahuari Kala','231307',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80776,245,'Mahuwaria','231307',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80777,245,'Majhawan','231501',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80778,245,'Manaur','231302',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80779,245,'Marihan','231210',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80780,245,'Matwar','231211',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80781,245,'Media','231304',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80782,245,'Meoli','231501',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80783,245,'Mirzapur Chowk','231001',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80784,245,'Mirzapur City','231001',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80785,245,'Mirzapur H.O','231001',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80786,245,'Mirzapur Kutchery','231001',1,0,'2022-03-03 13:05:42','2022-03-03 13:05:42'),(80787,245,'Mohanpur Bhavrakh','231304',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80788,245,'Mowaiya','231312',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80789,245,'Mujehara','231312',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80790,245,'Musaffarganj','231307',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80791,245,'Nadaulikaraundi','231211',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80792,245,'Nadini','231303',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80793,245,'Nakahara','231307',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80794,245,'Nakati Mishrauli','231304',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80795,245,'Narainpur (Mirzapur)','231305',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80796,245,'Navgawan','231211',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80797,245,'Neorhia Ghat','231501',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80798,245,'Nibi Gaharwar','231303',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80799,245,'Nigatpur','231314',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80800,245,'Pachegada','231302',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80801,245,'Pachevara','231305',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80802,245,'Padari','231304',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80803,245,'Padaria Kala','231309',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80804,245,'Pahadi','231304',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80805,245,'Paidapur','231307',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80806,245,'Patehara Khurd','231210',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80807,245,'Patharaul','231309',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80808,245,'Pathraura','231302',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80809,245,'Patihata','231304',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80810,245,'Patulki','231211',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80811,245,'Pavari Kala','231211',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80812,245,'Pidkhir','231302',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80813,245,'Pipra','231211',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80814,245,'Purusottam Pur','231305',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80815,245,'Putlighar','231312',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80816,245,'Raipur Pokhta','231307',1,0,'2022-03-03 13:05:43','2022-03-03 13:05:43'),(80817,245,'Raipuria','231304',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80818,245,'Rajapur','231307',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80819,245,'Rajgarh','231210',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80820,245,'Rajpur Amghat','231307',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80821,245,'Ramgarh Kiriyat','231306',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80822,245,'Rampur 38','231210',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80823,245,'Rampur Atari','231309',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80824,245,'Rehi','231211',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80825,245,'Rudauli','231304',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80826,245,'Rupaudha','231305',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80827,245,'Samogara','231307',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80828,245,'Sandwa','231501',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80829,245,'Sarson Gram','231304',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80830,245,'Semara Baraho','231210',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80831,245,'Semari Khas','231501',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80832,245,'Shahpur','231305',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80833,245,'Shakteshgarh','231304',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80834,245,'Sher Pur','231305',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80835,245,'Sherwa','231302',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80836,245,'Sikhar','231306',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80837,245,'Sindhora','231304',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80838,245,'Sirsi','231309',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80839,245,'Sri Niwas Dham','231313',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80840,245,'Supantha','231303',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80841,245,'Surahan','231302',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80842,245,'Tendua Kala','231304',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80843,245,'Thiresapur','231304',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80844,245,'Tilaon','231211',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80845,245,'Tilaulikala','231210',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80846,245,'Tilthi','231312',1,0,'2022-03-03 13:05:44','2022-03-03 13:05:44'),(80847,245,'Tita','231211',1,0,'2022-03-03 13:05:45','2022-03-03 13:05:45'),(80848,245,'Usari Khamaria','231211',1,0,'2022-03-03 13:05:45','2022-03-03 13:05:45'),(80849,245,'Vindhyachal','231307',1,0,'2022-03-03 13:05:45','2022-03-03 13:05:45'),(80850,245,'Wellesly Ganj','231001',1,0,'2022-03-03 13:05:45','2022-03-03 13:05:45'),(80851,246,'24bn Pac Mbd','244001',1,0,'2022-03-03 13:05:45','2022-03-03 13:05:45'),(80852,246,'Afjalpur Darauli','244414',1,0,'2022-03-03 13:05:45','2022-03-03 13:05:45'),(80853,246,'Aghwanpur','244504',1,0,'2022-03-03 13:05:45','2022-03-03 13:05:45'),(80854,246,'Akhtiarpur Thillupura','244302',1,0,'2022-03-03 13:05:45','2022-03-03 13:05:45'),(80855,246,'Akkadilari','244104',1,0,'2022-03-03 13:05:45','2022-03-03 13:05:45'),(80856,246,'Akrauli','244411',1,0,'2022-03-03 13:05:45','2022-03-03 13:05:45'),(80857,246,'Aliabad','244401',1,0,'2022-03-03 13:05:45','2022-03-03 13:05:45'),(80858,246,'Alipur Buzurg','244414',1,0,'2022-03-03 13:05:45','2022-03-03 13:05:45'),(80859,246,'Alpur Maithara','244410',1,0,'2022-03-03 13:05:45','2022-03-03 13:05:45'),(80860,246,'Amarpur Kashi','244411',1,0,'2022-03-03 13:05:45','2022-03-03 13:05:45'),(80861,246,'Amawati Qutubpur','244303',1,0,'2022-03-03 13:05:45','2022-03-03 13:05:45'),(80862,246,'Ancholi','244414',1,0,'2022-03-03 13:05:45','2022-03-03 13:05:45'),(80863,246,'Asalatpur Jarai','244412',1,0,'2022-03-03 13:05:45','2022-03-03 13:05:45'),(80864,246,'Azamnagar Chopra','244301',1,0,'2022-03-03 13:05:45','2022-03-03 13:05:45'),(80865,246,'Bahadur Nagar','244601',1,0,'2022-03-03 13:05:45','2022-03-03 13:05:45'),(80866,246,'Baheri Brahmnan','244402',1,0,'2022-03-03 13:05:45','2022-03-03 13:05:45'),(80867,246,'Bahjoi','244410',1,0,'2022-03-03 13:05:45','2022-03-03 13:05:45'),(80868,246,'Bahoranpur Narauli','244415',1,0,'2022-03-03 13:05:45','2022-03-03 13:05:45'),(80869,246,'Bahroli Taharpur','244410',1,0,'2022-03-03 13:05:46','2022-03-03 13:05:46'),(80870,246,'Bajhawli','244414',1,0,'2022-03-03 13:05:46','2022-03-03 13:05:46'),(80871,246,'Bania Khera','244412',1,0,'2022-03-03 13:05:46','2022-03-03 13:05:46'),(80872,246,'Barahi','244301',1,0,'2022-03-03 13:05:46','2022-03-03 13:05:46'),(80873,246,'Barauli Rustampur','244412',1,0,'2022-03-03 13:05:46','2022-03-03 13:05:46'),(80874,246,'Baripur Bhamrowa','244301',1,0,'2022-03-03 13:05:46','2022-03-03 13:05:46'),(80875,246,'Beejna','244001',1,0,'2022-03-03 13:05:46','2022-03-03 13:05:46'),(80876,246,'Beerpur Than','244104',1,0,'2022-03-03 13:05:46','2022-03-03 13:05:46'),(80877,246,'Behta Khas','244412',1,0,'2022-03-03 13:05:46','2022-03-03 13:05:46'),(80878,246,'Berni','244411',1,0,'2022-03-03 13:05:46','2022-03-03 13:05:46'),(80879,246,'Bhagatpur Tanda','244402',1,0,'2022-03-03 13:05:46','2022-03-03 13:05:46'),(80880,246,'Bhaisian','244001',1,0,'2022-03-03 13:05:46','2022-03-03 13:05:46'),(80881,246,'Bharthal Madapur','244301',1,0,'2022-03-03 13:05:46','2022-03-03 13:05:46'),(80882,246,'Bhatola','244302',1,0,'2022-03-03 13:05:46','2022-03-03 13:05:46'),(80883,246,'Bhawanipur','244302',1,0,'2022-03-03 13:05:46','2022-03-03 13:05:46'),(80884,246,'Bilari','244411',1,0,'2022-03-03 13:05:46','2022-03-03 13:05:46'),(80885,246,'Braham Bazar Chandausi','244412',1,0,'2022-03-03 13:05:46','2022-03-03 13:05:46'),(80886,246,'Budh Nagar Khandwa','244412',1,0,'2022-03-03 13:05:46','2022-03-03 13:05:46'),(80887,246,'Burhanpur','244402',1,0,'2022-03-03 13:05:46','2022-03-03 13:05:46'),(80888,246,'Chamroa','244302',1,0,'2022-03-03 13:05:46','2022-03-03 13:05:46'),(80889,246,'Chandankati','244302',1,0,'2022-03-03 13:05:46','2022-03-03 13:05:46'),(80890,246,'Chandanpur Isapur','244104',1,0,'2022-03-03 13:05:46','2022-03-03 13:05:46'),(80891,246,'Chandausi Bara Bazar','244412',1,0,'2022-03-03 13:05:46','2022-03-03 13:05:46'),(80892,246,'Chandausi R.S.','244412',1,0,'2022-03-03 13:05:46','2022-03-03 13:05:46'),(80893,246,'Chandausi','244412',1,0,'2022-03-03 13:05:46','2022-03-03 13:05:46'),(80894,246,'Chandpur','244402',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80895,246,'Chandrapur Kalan','244411',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80896,246,'Chatan','244410',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80897,246,'Chaudhar Pur','244102',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80898,246,'Chhajlet','244501',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80899,246,'Chhawara','244411',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80900,246,'Chhitauni','244411',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80901,246,'Darapur','244602',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80902,246,'Datauli','244303',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80903,246,'Deepa Sarai','244302',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80904,246,'Deolari','244104',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80905,246,'Devapur Mustkam Pur','244001',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80906,246,'Devipura','244402',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80907,246,'Dhakia Jut','244401',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80908,246,'Dharampur Kalan','244411',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80909,246,'Dharampur Ratta','244411',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80910,246,'Dilari','244401',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80911,246,'Dilgaura','244302',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80912,246,'Dingarpur','244301',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80913,246,'Dugawar','244304',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80914,246,'Dulapur Urf Darapur','244304',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80915,246,'Faij Ganj Bazar','244001',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80916,246,'Faredi','244001',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80917,246,'Fareed Nagar Mustqum','244601',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80918,246,'Fatehpur Malakpur','244301',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80919,246,'Fatehpur Samsoi','244410',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80920,246,'Fatehpur Vishnoi','244504',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80921,246,'Firidpur Khushal','244410',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80922,246,'Gakharpur','244401',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80923,246,'Galshaheed','244001',1,0,'2022-03-03 13:05:47','2022-03-03 13:05:47'),(80924,246,'Gandhi Nagar (Moradabad)','244001',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80925,246,'Ganeshpur','244104',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80926,246,'Gataura','244411',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80927,246,'Gauhat','244303',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80928,246,'Godhi','244923',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80929,246,'Godhi','244001',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80930,246,'Gopiwala','244601',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80931,246,'Guarau','244415',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80932,246,'Gumsani','244102',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80933,246,'Gumthal','244412',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80934,246,'Gurer','244301',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80935,246,'Hajaratnagar Garhi','244301',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80936,246,'Harthala','244102',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80937,246,'Haryana','244413',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80938,246,'Hasanpur Katia','244001',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80939,246,'Hasanpur Manjapta','244302',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80940,246,'Hathala Colony','244001',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80941,246,'Hathipur Chandoi','244413',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80942,246,'Hatkipur Chittoo','244413',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80943,246,'Hayatnagar','244303',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80944,246,'Hiran Khera','244104',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80945,246,'Husainpur Hamir','244001',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80946,246,'Isapur Sunwari','244302',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80947,246,'Jahangirpur','244001',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80948,246,'Jalalpur','244411',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80949,246,'Janeta','244412',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80950,246,'Jarai Hayat Nagar','244410',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80951,246,'Jargaon','244411',1,0,'2022-03-03 13:05:48','2022-03-03 13:05:48'),(80952,246,'Kafiabad','244504',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80953,246,'Kaithal','244412',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80954,246,'Kalajhanda','244601',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80955,246,'Kankar Khera','244104',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80956,246,'Kanth','244501',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80957,246,'Kasanpur Gaonri','244601',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80958,246,'Kasauli','244302',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80959,246,'Katghar (Moradabad)','244001',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80960,246,'Kharsol','244411',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80961,246,'Khaspur','244102',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80962,246,'Khawajpur','244601',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80963,246,'Khawari Awwal','244411',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80964,246,'Khurgh Fetehgarh','244411',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80965,246,'Kuchawali','244504',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80966,246,'Kundarki','244413',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80967,246,'Ladawali','244504',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80968,246,'Lakhauri Jalalpur','244302',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80969,246,'Lakri Fazalpur','244001',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80970,246,'Laloowala','244402',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80971,246,'Longi Kalan','244601',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80972,246,'Macharria','244001',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80973,246,'Madala Fatehpur','244304',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80974,246,'Madhan','244102',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80975,246,'Mahmoodpur','244301',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80976,246,'Mai','244412',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80977,246,'Mainather','244301',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80978,246,'Majhola','244410',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80979,246,'Majhola Khas','244413',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80980,246,'Majhola (Moradabad)','244103',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80981,246,'Malakpursemli','244401',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80982,246,'Mandi Naj','244001',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80983,246,'Mangoopura','244411',1,0,'2022-03-03 13:05:49','2022-03-03 13:05:49'),(80984,246,'Manota','244304',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(80985,246,'Mau Ka Ther','244410',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(80986,246,'Maulagarh','244412',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(80987,246,'Mewla Kalan','244925',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(80988,246,'Mian Sarai','244302',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(80989,246,'Modha','244504',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(80990,246,'Modhpur Wabai','244414',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(80991,246,'Mohd. Ganj','244412',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(80992,246,'Mohd. Pur Tanda','244302',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(80993,246,'Mohd. Sadikpur','244414',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(80994,246,'Mohra Lakhupura','244302',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(80995,246,'Moradabad City','244001',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(80996,246,'Moradabad H.O','244001',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(80997,246,'Moradabad Kutchery','244001',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(80998,246,'Moradabad R.S.','244001',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(80999,246,'Mughal Pura','244001',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(81000,246,'Mukarrabpur','244001',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(81001,246,'Mulhata','244410',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(81002,246,'Mundha Kheri','244501',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(81003,246,'Mundha','244104',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(81004,246,'Nadhos','244410',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(81005,246,'Nagla Purvi','244412',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(81006,246,'Nai Basti (Moradabad)','244001',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(81007,246,'Nanhuwala','244601',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(81008,246,'Narainpur','244415',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(81009,246,'Narauly','244414',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(81010,246,'Nawabpura','244001',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(81011,246,'Nayamatpur','244301',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(81012,246,'Noorpur','244001',1,0,'2022-03-03 13:05:50','2022-03-03 13:05:50'),(81013,246,'Nuria Sarai','244302',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81014,246,'Obri','244102',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81015,246,'P.A.C. Moradabad','244001',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81016,246,'P.T.C. Moradabad','244001',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81017,246,'Padia Nagla','244402',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81018,246,'Painti Kalan','244102',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81019,246,'Pakbara','244102',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81020,246,'Pasiapura','244601',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81021,246,'Patai Khalsa','244102',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81022,246,'Pathakpur','244410',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81023,246,'Pawasa','244302',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81024,246,'Pipalsana','244402',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81025,246,'Pipalsana R.S.','244402',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81026,246,'Qasimpur','244301',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81027,246,'Qazipura','244504',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81028,246,'R N . Area','244001',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81029,246,'R.N. Sahaspur','244415',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81030,246,'R.P. Niyaoli','244302',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81031,246,'R.T.S. Moradabad','244001',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81032,246,'Raghowala','244601',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81033,246,'Raholi','244412',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81034,246,'Railway Colony Chandausi','244412',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81035,246,'Raipur Kalan','244410',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81036,246,'Raja Ka Sahaspur','244415',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81037,246,'Rajpur Kalan','244410',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81038,246,'Rajpur Kalan','244602',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81039,246,'Rajpur Kesaria','244001',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81040,246,'Rampur Urf Yarpur','244304',1,0,'2022-03-03 13:05:51','2022-03-03 13:05:51'),(81041,246,'Rampura','244410',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81042,246,'Ratanpura Kalan','244102',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81043,246,'Ratupura','244102',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81044,246,'Ratupura','244601',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81045,246,'Rehta Mafi','244401',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81046,246,'Rehtaul','244301',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81047,246,'Ronda','244411',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81048,246,'Rudayan','244303',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81049,246,'Ruknuddin Sarai','244302',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81050,246,'S.P.F. Mrd','244001',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81051,246,'Sadatwari','244410',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81052,246,'Sagarpur','244411',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81053,246,'Sahaspuri','244401',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81054,246,'Saidpur Gangu','244304',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81055,246,'Saifni','244411',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81056,246,'Salarpur','244302',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81057,246,'Sambhal','244302',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81058,246,'Sanai','244411',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81059,246,'Sarai Jawalapuri','244411',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81060,246,'Sarai Khajoor','244504',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81061,246,'Sarai Tarin','244303',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81062,246,'Sardar Nagar','244104',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81063,246,'Sarkara Bishnoi','244401',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81064,246,'Sarkara Khas','244104',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81065,246,'Sarthal','244414',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81066,246,'Satupura','244304',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81067,246,'Senjana','244302',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81068,246,'Shahbaj Pur Kalan','244102',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81069,246,'Sharif Nagar','244602',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81070,246,'Sheoraj  Pur','244410',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81071,246,'Sherpur','244303',1,0,'2022-03-03 13:05:52','2022-03-03 13:05:52'),(81072,246,'Sherpur Patti','244602',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81073,246,'Sidhlau Nazarpur','244402',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81074,246,'Sihali Khadar','244401',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81075,246,'Sihali Mala','244411',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81076,246,'Singhpur Sani','244302',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81077,246,'Siras Khera','244104',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81078,246,'Sirsi (Moradabad)','244301',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81079,246,'Sitapuri','244001',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81080,246,'Sonakpur','244001',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81081,246,'Sondhan Mohdpur','244303',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81082,246,'Stationroad','244001',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81083,246,'Sultanpur Dost','244001',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81084,246,'Surjan Nagar','244602',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81085,246,'Syaundara','244411',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81086,246,'Tanda Afzal','244602',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81087,246,'Tewar Khas','244413',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81088,246,'Thakurdwara','244601',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81089,246,'Thaonla','244411',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81090,246,'Tharesa Jai Singh','244414',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81091,246,'Thati','244302',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81092,246,'Town Hall (Moradabad)','244001',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81093,246,'Tumaria Kalan','244001',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81094,246,'Udmawala','244925',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81095,246,'Umedpur','244301',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81096,246,'Uncha Gaon','244001',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81097,246,'Yusufpur Naglia','244102',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81098,247,'Agarwal Paper Mill','251001',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81099,247,'Ailum','247771',1,0,'2022-03-03 13:05:53','2022-03-03 13:05:53'),(81100,247,'Alipur Aterna','251309',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81101,247,'Alipur Kheri','251301',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81102,247,'Amir Nagar','251306',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81103,247,'Anandpuri (Muzaffarnagar)','251001',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81104,247,'Antwara','251201',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81105,247,'Babri','251305',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81106,247,'Badhai Kalan','251202',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81107,247,'Badhai Khurd','251202',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81108,247,'Badheo','247776',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81109,247,'Badheri','251307',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81110,247,'Badiwala','251327',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81111,247,'Baghra (Muzaffarnagar)','251306',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81112,247,'Bagowali','251001',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81113,247,'Bahadurpur','251203',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81114,247,'Bahawari','247776',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81115,247,'Baheri','251202',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81116,247,'Bajidpur Kawali','251314',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81117,247,'Balwa','247776',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81118,247,'Balwa Kheri','247772',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81119,247,'Banat','247776',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81120,247,'Banti Khera','251305',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81121,247,'Bara Bazar Shamli','247776',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81122,247,'Barkali','251202',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81123,247,'Barkata','251309',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81124,247,'Barla','251307',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81125,247,'Baroda','251309',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81126,247,'Barsoo','251201',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81127,247,'Barwala','251001',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81128,247,'Basera','251310',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81129,247,'Beenra','247774',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81130,247,'Beghrajpur','251203',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81131,247,'Behra Assa','251314',1,0,'2022-03-03 13:05:54','2022-03-03 13:05:54'),(81132,247,'Behra Thru','251308',1,0,'2022-03-03 13:05:55','2022-03-03 13:05:55'),(81133,247,'Behupura','251316',1,0,'2022-03-03 13:05:55','2022-03-03 13:05:55'),(81134,247,'Belra','251308',1,0,'2022-03-03 13:05:55','2022-03-03 13:05:55'),(81135,247,'Bhainsi','251201',1,0,'2022-03-03 13:05:55','2022-03-03 13:05:55'),(81136,247,'Bhainswal','247776',1,0,'2022-03-03 13:05:55','2022-03-03 13:05:55'),(81137,247,'Bhaisani Islampur','247777',1,0,'2022-03-03 13:05:55','2022-03-03 13:05:55'),(81138,247,'Bhajju','251319',1,0,'2022-03-03 13:05:55','2022-03-03 13:05:55'),(81139,247,'Bhanera','247771',1,0,'2022-03-03 13:05:55','2022-03-03 13:05:55'),(81140,247,'Bhanera Jat','251319',1,0,'2022-03-03 13:05:55','2022-03-03 13:05:55'),(81141,247,'Bhanera Udda','247777',1,0,'2022-03-03 13:05:55','2022-03-03 13:05:55'),(81142,247,'Bhangela','251201',1,0,'2022-03-03 13:05:55','2022-03-03 13:05:55'),(81143,247,'Bharsi','247771',1,0,'2022-03-03 13:05:55','2022-03-03 13:05:55'),(81144,247,'Bhikki','251203',1,0,'2022-03-03 13:05:55','2022-03-03 13:05:55'),(81145,247,'Bhokarheri','251316',1,0,'2022-03-03 13:05:55','2022-03-03 13:05:55'),(81146,247,'Bhooma','251315',1,0,'2022-03-03 13:05:55','2022-03-03 13:05:55'),(81147,247,'Bhoora','247774',1,0,'2022-03-03 13:05:55','2022-03-03 13:05:55'),(81148,247,'Bhoora Khurd','251319',1,0,'2022-03-03 13:05:55','2022-03-03 13:05:55'),(81149,247,'Bhopa Road','251001',1,0,'2022-03-03 13:05:55','2022-03-03 13:05:55'),(81150,247,'Bhopa','251308',1,0,'2022-03-03 13:05:55','2022-03-03 13:05:55'),(81151,247,'Bhora Kalan','251319',1,0,'2022-03-03 13:05:55','2022-03-03 13:05:55'),(81152,247,'Bihari','251203',1,0,'2022-03-03 13:05:55','2022-03-03 13:05:55'),(81153,247,'Biral','247771',1,0,'2022-03-03 13:05:55','2022-03-03 13:05:55'),(81154,247,'Biralasi','247772',1,0,'2022-03-03 13:05:55','2022-03-03 13:05:55'),(81155,247,'Bitawada','251309',1,0,'2022-03-03 13:05:55','2022-03-03 13:05:55'),(81156,247,'Brahmpuri','251001',1,0,'2022-03-03 13:05:55','2022-03-03 13:05:55'),(81157,247,'Budha Khera','247772',1,0,'2022-03-03 13:05:56','2022-03-03 13:05:56'),(81158,247,'Budhana','251309',1,0,'2022-03-03 13:05:56','2022-03-03 13:05:56'),(81159,247,'Budina Kalan','251301',1,0,'2022-03-03 13:05:56','2022-03-03 13:05:56'),(81160,247,'Budina Khurd','251306',1,0,'2022-03-03 13:05:56','2022-03-03 13:05:56'),(81161,247,'Butrara','251305',1,0,'2022-03-03 13:05:56','2022-03-03 13:05:56'),(81162,247,'Chand Samad','251201',1,0,'2022-03-03 13:05:56','2022-03-03 13:05:56'),(81163,247,'Chand Seena','251201',1,0,'2022-03-03 13:05:56','2022-03-03 13:05:56'),(81164,247,'Chandena Mal','247772',1,0,'2022-03-03 13:05:56','2022-03-03 13:05:56'),(81165,247,'Charthawal','251311',1,0,'2022-03-03 13:05:56','2022-03-03 13:05:56'),(81166,247,'Chausana','247778',1,0,'2022-03-03 13:05:56','2022-03-03 13:05:56'),(81167,247,'Chhapar','251307',1,0,'2022-03-03 13:05:56','2022-03-03 13:05:56'),(81168,247,'Chittora','251314',1,0,'2022-03-03 13:05:56','2022-03-03 13:05:56'),(81169,247,'Chokra','251311',1,0,'2022-03-03 13:05:56','2022-03-03 13:05:56'),(81170,247,'Choonsa','251305',1,0,'2022-03-03 13:05:56','2022-03-03 13:05:56'),(81171,247,'Chorawala','251316',1,0,'2022-03-03 13:05:56','2022-03-03 13:05:56'),(81172,247,'Dabheri Rasulpur','251309',1,0,'2022-03-03 13:05:56','2022-03-03 13:05:56'),(81173,247,'Dakhori','247772',1,0,'2022-03-03 13:05:56','2022-03-03 13:05:56'),(81174,247,'Datiyana','251001',1,0,'2022-03-03 13:05:56','2022-03-03 13:05:56'),(81175,247,'Dayalpuri','251201',1,0,'2022-03-03 13:05:56','2022-03-03 13:05:56'),(81176,247,'Dedheru Kalan','251001',1,0,'2022-03-03 13:05:56','2022-03-03 13:05:56'),(81177,247,'Dhanayan','251318',1,0,'2022-03-03 13:05:56','2022-03-03 13:05:56'),(81178,247,'Dhansari','251314',1,0,'2022-03-03 13:05:56','2022-03-03 13:05:56'),(81179,247,'Dhimanpura','247776',1,0,'2022-03-03 13:05:56','2022-03-03 13:05:56'),(81180,247,'Dhindawali','251318',1,0,'2022-03-03 13:05:56','2022-03-03 13:05:56'),(81181,247,'Dinkarpur','251318',1,0,'2022-03-03 13:05:57','2022-03-03 13:05:57'),(81182,247,'Doodhli','247772',1,0,'2022-03-03 13:05:57','2022-03-03 13:05:57'),(81183,247,'Dudha Heri','251203',1,0,'2022-03-03 13:05:57','2022-03-03 13:05:57'),(81184,247,'Dullakheri','247776',1,0,'2022-03-03 13:05:57','2022-03-03 13:05:57'),(81185,247,'Dundu Khera','247775',1,0,'2022-03-03 13:05:57','2022-03-03 13:05:57'),(81186,247,'Fahimpur Khurd','251201',1,0,'2022-03-03 13:05:57','2022-03-03 13:05:57'),(81187,247,'Gadhla','251310',1,0,'2022-03-03 13:05:57','2022-03-03 13:05:57'),(81188,247,'Gagaur','247778',1,0,'2022-03-03 13:05:57','2022-03-03 13:05:57'),(81189,247,'Galibpur','251201',1,0,'2022-03-03 13:05:57','2022-03-03 13:05:57'),(81190,247,'Gandewara','247772',1,0,'2022-03-03 13:05:57','2022-03-03 13:05:57'),(81191,247,'Gandhi Colony','251001',1,0,'2022-03-03 13:05:57','2022-03-03 13:05:57'),(81192,247,'Ganga Ram Pura','251001',1,0,'2022-03-03 13:05:57','2022-03-03 13:05:57'),(81193,247,'Gangeru','247775',1,0,'2022-03-03 13:05:57','2022-03-03 13:05:57'),(81194,247,'Ganj Bazar Kandhala','247775',1,0,'2022-03-03 13:05:57','2022-03-03 13:05:57'),(81195,247,'Ganna Samiti Shamli','247776',1,0,'2022-03-03 13:05:57','2022-03-03 13:05:57'),(81196,247,'Garhi Abdulha Khan','247778',1,0,'2022-03-03 13:05:57','2022-03-03 13:05:57'),(81197,247,'Garhi Daulat','247775',1,0,'2022-03-03 13:05:57','2022-03-03 13:05:57'),(81198,247,'Garhi Hasanpur','247778',1,0,'2022-03-03 13:05:57','2022-03-03 13:05:57'),(81199,247,'Garhi Pukhta','247776',1,0,'2022-03-03 13:05:57','2022-03-03 13:05:57'),(81200,247,'Garhi Sakhawatpur','251309',1,0,'2022-03-03 13:05:57','2022-03-03 13:05:57'),(81201,247,'Ghatayan','251314',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81202,247,'Goela','251318',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81203,247,'Gogwan','247773',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81204,247,'Gogwan Jalalpur','251305',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81205,247,'Grahi Noabad','251309',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81206,247,'Harar Fatehpur','247777',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81207,247,'Hari Nagar','251327',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81208,247,'Harsauli','251001',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81209,247,'Hasanpur Luhari','247772',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81210,247,'Hassanpur','251320',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81211,247,'Hath Choya','247778',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81212,247,'Hind','247777',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81213,247,'Hiranwara','251305',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81214,247,'Hussainabad Bhanwara','251309',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81215,247,'Hussainpur Bhopara','251203',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81216,247,'Hussainpur Kalan','251309',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81217,247,'Incholi','251201',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81218,247,'Industrial Estate (Muzaffarnagar)','251003',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81219,247,'Islampur Ghasauli','247775',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81220,247,'Isso Pur Teel','247775',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81221,247,'Itawa','251309',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81222,247,'Jalalabad (Muzaffarnagar)','247772',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81223,247,'Jandheri','251314',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81224,247,'Jansath','251314',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81225,247,'Jaroda','251003',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81226,247,'Jasala','247775',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81227,247,'Jasana Urf Mastgarh','247776',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81228,247,'Jasaula','251201',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81229,247,'Jasoi','251301',1,0,'2022-03-03 13:05:58','2022-03-03 13:05:58'),(81230,247,'Jat Mujhera','251308',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81231,247,'Jaula','251309',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81232,247,'Jauli','251308',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81233,247,'Jeewana','251203',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81234,247,'Jhal Nirgajani','251308',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81235,247,'Jhinjhana','247773',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81236,247,'Kabarout','247776',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81237,247,'Kachauli','251202',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81238,247,'Kail Shikarpur','247777',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81239,247,'Kailwara Kalan','251201',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81240,247,'Kairana','247774',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81241,247,'Kairtoo','247773',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81242,247,'Kakra','251318',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81243,247,'Kakrauli','251316',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81244,247,'Kamruddin Nagar','251309',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81245,247,'Kandela','247774',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81246,247,'Kandhala','247775',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81247,247,'Karoda','247776',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81248,247,'Karoda Hathi','251305',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81249,247,'Karwara','251001',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81250,247,'Kasampur Khola','251315',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81251,247,'Kasampur Patheri','251307',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81252,247,'Kaserwa','251318',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81253,247,'Kaserwa Kalan','247776',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81254,247,'Katiya','251315',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81255,247,'Kawal','251314',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81256,247,'Kazi Khera','251306',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81257,247,'Kedi','251305',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81258,247,'Kelanpur','251327',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81259,247,'Khai-kheri','251310',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81260,247,'Khala Par','251002',1,0,'2022-03-03 13:05:59','2022-03-03 13:05:59'),(81261,247,'Khandrawali','247775',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81262,247,'Khanjapur','251201',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81263,247,'Khanpur','247777',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81264,247,'Kharar','247776',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81265,247,'Khatauli Bazar','251201',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81266,247,'Khatauli','251201',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81267,247,'Khera Mastan','247776',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81268,247,'Kheri Buchha','247774',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81269,247,'Kheri Karmu','247776',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81270,247,'Kheri Rangdhang','251201',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81271,247,'Khokani','251316',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81272,247,'Khudda','251307',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81273,247,'Khurgaon Issopur','247774',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81274,247,'Khusropur','251311',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81275,247,'Kinoni','251001',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81276,247,'Kithora','251315',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81277,247,'Kiwana','247775',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81278,247,'Kudana','247776',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81279,247,'Kujhera','251314',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81280,247,'Kukara','251001',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81281,247,'Kulheri','251311',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81282,247,'Kuralsi','251309',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81283,247,'Kurawa','251309',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81284,247,'Kurmali','251305',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81285,247,'Kurthal','251309',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81286,247,'Kutba','251318',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81287,247,'Kutchery Mzn','251001',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81288,247,'Kutesra','251311',1,0,'2022-03-03 13:06:00','2022-03-03 13:06:00'),(81289,247,'Kutubpur','251315',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81290,247,'Lachera','251003',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81291,247,'Laddhawala','251002',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81292,247,'Lank','247776',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81293,247,'Lilon','247776',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81294,247,'Lisarh','247775',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81295,247,'Loi Sarai','251309',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81296,247,'Luhari Khurd','251311',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81297,247,'Luhsana','251309',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81298,247,'Maharampur','247776',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81299,247,'Makhiyali','251001',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81300,247,'Makhmoolpur','247775',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81301,247,'Malandi','247776',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81302,247,'Maleera','251202',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81303,247,'Malpura','251308',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81304,247,'Mandi','251306',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81305,247,'Mansurpur','251203',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81306,247,'Mansurpur Village','251203',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81307,247,'Megha Kheri','251001',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81308,247,'Miranpur','251315',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81309,247,'Mohamad Pur Madan','251301',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81310,247,'Mohmand Pur Rai Singh','251309',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81311,247,'Morna','251316',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81312,247,'Mubarikpur','251318',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81313,247,'Mukandpur','251306',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81314,247,'Mundbhar','251319',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81315,247,'Mundet Khadar','247778',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81316,247,'Mussa Bilaspur','251001',1,0,'2022-03-03 13:06:01','2022-03-03 13:06:01'),(81317,247,'Muzaffar Nagar City','251002',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81318,247,'Muzaffarnagar H.O','251001',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81319,247,'Nagala Pithora','251301',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81320,247,'Nagla Bujurg','251308',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81321,247,'Nagla Madore College','251314',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81322,247,'Nagwa','251309',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81323,247,'Nai Abadi Budhana','251309',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81324,247,'Nala','247771',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81325,247,'Nasir Pur','251306',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81326,247,'Navin Mandi Sthal','251001',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81327,247,'Nawla','251201',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81328,247,'Niamu','247772',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81329,247,'Nirmana','251001',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81330,247,'Nojal','247777',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81331,247,'Nojjal','247772',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81332,247,'Pachanda Kalan','251001',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81333,247,'Palri','251318',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81334,247,'Pamnawali','251201',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81335,247,'Paoti','251311',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81336,247,'Parasauli','247775',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81337,247,'Pawati Kalan','247773',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81338,247,'Phalauda','251307',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81339,247,'Phugana','247776',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81340,247,'Phulat','251201',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81341,247,'Pindora','247778',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81342,247,'Pinna','251306',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81343,247,'Pipal Hera','251305',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81344,247,'Pipal Shah','247772',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81345,247,'Pipalhera','251201',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81346,247,'Prempuri','251002',1,0,'2022-03-03 13:06:02','2022-03-03 13:06:02'),(81347,247,'Pura','251203',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81348,247,'Purbaliyan','251203',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81349,247,'Purkazi','251327',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81350,247,'Purmafi','247773',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81351,247,'Rahakada','251308',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81352,247,'Rahamatpur Garwara','251308',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81353,247,'Rai','251307',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81354,247,'Raipur Aterna','251309',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81355,247,'Rajpur Chhajpur','247775',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81356,247,'Rajpur Kalan','251314',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81357,247,'Rampur','251001',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81358,247,'Rampuram','251001',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81359,247,'Ramraj','251320',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81360,247,'Rangana','247778',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81361,247,'Rasulpur Gujran','247775',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81362,247,'Ratheri','251001',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81363,247,'Reoli Nagla','251309',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81364,247,'Rohana Khurd','251202',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81365,247,'Rohana Mills','251202',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81366,247,'Roni Hazipur','251301',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81367,247,'Sahojani Tagan','251001',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81368,247,'Salarpur','251314',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81369,247,'Sambhal Hera','251314',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81370,247,'Sarai Rasulpur','251201',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81371,247,'Sarwat','251001',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81372,247,'Satguru Nagar','251201',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81373,247,'Satheri','251201',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81374,247,'Sawtoo','251319',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81375,247,'Shahpur (Muzaffarnagar)','251318',1,0,'2022-03-03 13:06:03','2022-03-03 13:06:03'),(81376,247,'Shamli Mandi','247776',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81377,247,'Shamli Road','251002',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81378,247,'Shamli','247776',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81379,247,'Shamli Sugar Mills','247776',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81380,247,'Sher Nagar','251001',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81381,247,'Sherpur','251327',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81382,247,'Shikarpur','251319',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81383,247,'Shoram','251318',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81384,247,'Shukartal','251316',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81385,247,'Sikkri','251308',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81386,247,'Silawar','247776',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81387,247,'Sisauli','251319',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81388,247,'Sonta','251301',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81389,247,'Sonta Rasulpur','247777',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81390,247,'South Civil  Lines','251001',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81391,247,'Sugar Mill Road Khatauli','251201',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81392,247,'Sujroo','251003',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81393,247,'Sunna','247775',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81394,247,'Tahirpur Bhabisa','247775',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81395,247,'Tana','247773',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81396,247,'Tanda Majara','251309',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81397,247,'Taoli','251001',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81398,247,'Taprana','247776',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81399,247,'Tehsil Jansath','251314',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81400,247,'Tejalhera','251310',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81401,247,'Tendhera','251316',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81402,247,'Tewra','251316',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81403,247,'Thanabhawan','247777',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81404,247,'Tissa','251308',1,0,'2022-03-03 13:06:04','2022-03-03 13:06:04'),(81405,247,'Tissang','251314',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81406,247,'Titarwara','247774',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81407,247,'Titauli','247776',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81408,247,'Titawi','251301',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81409,247,'Titoda','251201',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81410,247,'Toda','251309',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81411,247,'Toda','247778',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81412,247,'Tuglakpur','251310',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81413,247,'Udpur','247773',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81414,247,'Umarpur','251318',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81415,247,'Un (Muzaffarnagar)','247778',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81416,247,'Uncha Gaon','247774',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81417,247,'Vehlana','251003',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81418,248,'Abhaipur','262122',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81419,248,'Ahirwara','262201',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81420,248,'Amaria','262121',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81421,248,'Amkhera','262203',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81422,248,'Amra Karoor','262201',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81423,248,'Amrita','262201',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81424,248,'Azampur Barkhera','262201',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81425,248,'Bahadurpur','262203',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81426,248,'Bahanpur','262001',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81427,248,'Bakania','262202',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81428,248,'Bamrauli','262202',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81429,248,'Banskhera','262121',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81430,248,'Baratbhoj','262001',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81431,248,'Barehpura','262121',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81432,248,'Barhera','262201',1,0,'2022-03-03 13:06:05','2022-03-03 13:06:05'),(81433,248,'Barkhera Chaturaha','262201',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81434,248,'Barkhera','262203',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81435,248,'Bauni','262201',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81436,248,'Behtim','262202',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81437,248,'Bhaden Kanja','262202',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81438,248,'Bhadsara','262121',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81439,248,'Bhagwantapur','262122',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81440,248,'Bhairo Kalan','262122',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81441,248,'Bhikaripur','262001',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81442,248,'Bhopatpura','262203',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81443,248,'Bifarcation','262122',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81444,248,'Bilsanda','262202',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81445,248,'Bisalpur','262201',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81446,248,'Bithora Kalan','262001',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81447,248,'Chandia Hazara','262122',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81448,248,'Chandoi','262001',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81449,248,'Chandpura','262201',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81450,248,'Chandupur','262124',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81451,248,'CHATHIA','262121',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81452,248,'Churra','262201',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81453,248,'Dalelganj','262001',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81454,248,'Dang','262001',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81455,248,'Daulatpur','262203',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81456,248,'Deohana','262201',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81457,248,'Deoria Kalan','262201',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81458,248,'Dhakia','262201',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81459,248,'Dhuria Palia','262122',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81460,248,'Dudhia Khurd','262122',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81461,248,'Dunidam','262302',1,0,'2022-03-03 13:06:06','2022-03-03 13:06:06'),(81462,248,'Gajraula Kalan','262001',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81463,248,'Ganesh Ganj (Pilibhit)','262001',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81464,248,'Gehluiya','262001',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81465,248,'Ghajhera','262201',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81466,248,'Ghatampur','262122',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81467,248,'Ghungchai','262122',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81468,248,'Gobhia Sarai','262122',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81469,248,'Gulabtanda','262122',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81470,248,'Harrai','262202',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81471,248,'Harraipur','262121',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81472,248,'Imalia Gangi','262201',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81473,248,'Intgoan','262201',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81474,248,'Jahanabad','262001',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81475,248,'Jaitpur','262001',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81476,248,'Jallapur','262201',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81477,248,'Jamunia','262124',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81478,248,'Jatpura','262122',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81479,248,'Jeorah Kalyanpur','262203',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81480,248,'Jogither','262203',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81481,248,'Kadherchaura','262122',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81482,248,'Kali Nagar','262124',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81483,248,'Kalyanpur Khas','262001',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81484,248,'Kanakore','262001',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81485,248,'Kareli','262202',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81486,248,'Kargaina','262121',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81487,248,'Karnapur','262122',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81488,248,'Karrkhera','262201',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81489,248,'Kasganja','262122',1,0,'2022-03-03 13:06:07','2022-03-03 13:06:07'),(81490,248,'Katra Bazar (Pilibhit)','262201',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81491,248,'Kesarpur Saidpur','243123',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81492,248,'Khajuria Pachpera','262203',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81493,248,'Khakra','262001',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81494,248,'Khamaria Pull','262001',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81495,248,'Khandepur','262201',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81496,248,'Khundara','262001',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81497,248,'Kishni','262201',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81498,248,'Kumirkha','262201',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81499,248,'Lalauri Khera','262001',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81500,248,'Lalpur','262001',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81501,248,'Luhicha','262201',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81502,248,'Madhopur','262201',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81503,248,'Madhotanda','262122',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81504,248,'Madhupuri','262203',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81505,248,'Maktul','262001',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81506,248,'Mala Colony','262001',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81507,248,'MATHANA  JAPTI','262124',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81508,248,'Meerpur Bahanpur','262201',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81509,248,'Meerpur Hamirpur','262202',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81510,248,'Mohammadpur Bhanja','262201',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81511,248,'Mudia Hulas','262203',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81512,248,'Mundalia','262121',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81513,248,'Narainpur','262203',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81514,248,'Naugawan Santosh','262201',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81515,248,'Naujalia Nakatia','262122',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81516,248,'NEKPUR','243003',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81517,248,'Neoria Mobile','262305',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81518,248,'Neoria','262305',1,0,'2022-03-03 13:06:08','2022-03-03 13:06:08'),(81519,248,'Nizamdandi','262001',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81520,248,'Paharganj','262201',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81521,248,'Pandari','262305',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81522,248,'Pania Ramkishan','262203',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81523,248,'Parasi Ramkishan','262203',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81524,248,'Parewa Vaish','262121',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81525,248,'Parsia','262203',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81526,248,'Pauta Kalan','262203',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81527,248,'Pilibhit Chowk Ndedso','262001',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81528,248,'Pilibhit City','262001',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81529,248,'Pilibhit H.O','262001',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81530,248,'Pilibhit Kutchery','262001',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81531,248,'Pipalia','262121',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81532,248,'Piparia Agroo','262001',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81533,248,'Piperia Dulai','262122',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81534,248,'Piperia Mundan','262203',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81535,248,'Piperia Santosh','262124',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81536,248,'Pooranpur','262122',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81537,248,'Ram Nagar Jagatpur','262203',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81538,248,'Ramnagra Colony','262122',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81539,248,'Rampura Fakire','262122',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81540,248,'Ranth','262202',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81541,248,'Rasiayankhanpur','262201',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81542,248,'Richhaula','262001',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81543,248,'Rohania','262201',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81544,248,'Roopur Kamaloo','262001',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81545,248,'Rudrapur','262122',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81546,248,'Sabalpur','262122',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81547,248,'Sakhaula','262001',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81548,248,'Sarauri','262001',1,0,'2022-03-03 13:06:09','2022-03-03 13:06:09'),(81549,248,'Sardar Nagar','262001',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81550,248,'Sehpura','262203',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81551,248,'Shahgarh','262122',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81552,248,'Shahi','262001',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81553,248,'Sherpur','262122',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81554,248,'Shivnagar','262122',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81555,248,'SINDHAURA KHARAGPUR','262202',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81556,248,'Station Road Pilibhit','262001',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81557,248,'Suhas','262001',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81558,248,'Sunpahar','262302',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81559,248,'Tirkunia','262121',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81560,248,'Udaikaranpur','262122',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81561,249,'Abdul Wahidganj','230141',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81562,249,'Adharganj','230304',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81563,249,'Adlabad','230141',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81564,249,'Afim Kothi','230131',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81565,249,'Agai','229410',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81566,249,'Ahiyapur','230142',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81567,249,'Aimajatupur','230204',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81568,249,'Aindha','230204',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81569,249,'Ajgara','230144',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81570,249,'Ajhara','230132',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81571,249,'Alapur','229408',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81572,249,'Amapur Berra','230301',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81573,249,'Amargarh (Pratapgarh)','230124',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81574,249,'Amawan','230132',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81575,249,'Amawan','230125',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81576,249,'Ami','230139',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81577,249,'Antari','230301',1,0,'2022-03-03 13:06:10','2022-03-03 13:06:10'),(81578,249,'Antu','230501',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81579,249,'Aspur Deosara','230124',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81580,249,'Asrahi','230132',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81581,249,'Atarsand','230401',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81582,249,'Atheha','230125',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81583,249,'Baba Ka Gaon','230139',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81584,249,'Babaganj','230143',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81585,249,'Babu Patti','230304',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81586,249,'Babuganj','230126',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81587,249,'Bachhuwa','230402',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81588,249,'Badgawan','230204',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81589,249,'Bahlolpur','230131',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81590,249,'Bahuchara','230137',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81591,249,'Bahuta','230135',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81592,249,'Bainti','230204',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81593,249,'Baishpur','230402',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81594,249,'Bajha Bheet','230202',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81595,249,'Bakol','230141',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81596,249,'Balha','230132',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81597,249,'Balikaranganj','230402',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81598,249,'Bansi','230304',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81599,249,'Bansiyara','230204',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81600,249,'Barachha','230403',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81601,249,'Barahupur','230135',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81602,249,'Barai','230204',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81603,249,'Barari','230134',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81604,249,'Baron','230129',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81605,249,'Bashirpur','230127',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81606,249,'Basupur','230401',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81607,249,'Baswahi','230204',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81608,249,'Bedhan Gopalpur','230204',1,0,'2022-03-03 13:06:11','2022-03-03 13:06:11'),(81609,249,'Belarampur','230135',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81610,249,'Benimadho Nagar','230139',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81611,249,'Beshar','230135',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81612,249,'Bhadausi','230502',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81613,249,'Bhadohi','230131',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81614,249,'Bhadri','230201',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81615,249,'Bhagwanpur','230135',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81616,249,'Bhagwatganj','230402',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81617,249,'Bhanaipur','230124',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81618,249,'Bhangwa Ki Chungi','230001',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81619,249,'Bhatni','229410',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81620,249,'Bhawaniganj Kota','230143',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81621,249,'Bhawanipur','230501',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81622,249,'Bhikhapur Kanidih','230128',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81623,249,'Bhikhnapur','230404',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81624,249,'Bhojemau','230301',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81625,249,'Bhuidaha','230304',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81626,249,'Bhupiamau','230131',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81627,249,'Bichhur','230302',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81628,249,'Bihar','230201',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81629,249,'Biharganj','230502',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81630,249,'Bijahara','230142',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81631,249,'Binaika','230121',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81632,249,'Birapur','230302',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81633,249,'Bisahiya','230201',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81634,249,'Budhapur','230201',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81635,249,'Chakwarh','230129',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81636,249,'Chamrupur','230144',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81637,249,'Charaiya','230135',1,0,'2022-03-03 13:06:12','2022-03-03 13:06:12'),(81638,249,'Chhatarur','230503',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81639,249,'Chhatauna','230121',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81640,249,'Chitamanpur Patna','230128',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81641,249,'Dahi','230124',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81642,249,'Dakhwapur','230143',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81643,249,'Dalippur (Pratapgarh)','230127',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81644,249,'Dandupur Mufrid','230127',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81645,249,'Darchhut','230405',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81646,249,'Darra','230139',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81647,249,'Dawapur','230132',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81648,249,'Deeha','230201',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81649,249,'Deogarh Kamasin','230304',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81650,249,'Deokali','230405',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81651,249,'Deori','230125',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81652,249,'Derwa','230128',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81653,249,'Dhadhuwa Gajan','230136',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81654,249,'Dhandhar','230135',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81655,249,'Dhangarh','230141',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81656,249,'Dhansari','230129',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81657,249,'Dhanuha','230301',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81658,249,'Dharauli','230503',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81659,249,'Dharauli','230405',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81660,249,'Dhaurahra','230124',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81661,249,'Dhaurahra','230501',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81662,249,'Dhekahi','230502',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81663,249,'Dherehana','230002',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81664,249,'Dhindhui','230138',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81665,249,'Dhingwas','230128',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81666,249,'Diyawan','230121',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81667,249,'Donai','230134',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81668,249,'Dubeypur','230501',1,0,'2022-03-03 13:06:13','2022-03-03 13:06:13'),(81669,249,'Dulhepur','230144',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81670,249,'Durgaganj','230304',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81671,249,'Dwarikapur','230127',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81672,249,'Fatehpur','230135',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81673,249,'Gadauri','230134',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81674,249,'Gadhiyawan','230124',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81675,249,'Gajariya','230134',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81676,249,'Garapur','230302',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81677,249,'Garhi Manikpur','230202',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81678,249,'Garhi Samsabad','230202',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81679,249,'Garwara','230502',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81680,249,'Gaura Dand','230503',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81681,249,'Gaura Mafi','230121',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81682,249,'Gaura R S','230301',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81683,249,'Gobari','230502',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81684,249,'Gondey','230403',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81685,249,'Gotani','230202',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81686,249,'Gujwar','230143',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81687,249,'Hainshi Parji','230402',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81688,249,'Handaur','230136',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81689,249,'Hanumanganj','230403',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81690,249,'Harakhpur','230402',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81691,249,'Harakhpur Kotwa','230136',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81692,249,'Hariharganj','230304',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81693,249,'Hathigawan','230201',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81694,249,'Idilpur','230132',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81695,249,'Ishanpur','230142',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81696,249,'Itaura','230204',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81697,249,'Jagapur','230204',1,0,'2022-03-03 13:06:14','2022-03-03 13:06:14'),(81698,249,'Jagesharganj','230502',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81699,249,'Jahanabad','230201',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81700,249,'Jahnaipur','230131',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81701,249,'Jalesharganj','230132',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81702,249,'Jamethi','230204',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81703,249,'Jamtali','230302',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81704,249,'Jariyari','230125',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81705,249,'Jasmarha','230132',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81706,249,'Jawain','229410',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81707,249,'Jethwara','230129',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81708,249,'Jhingur','230204',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81709,249,'Jhonkwara','230202',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81710,249,'Jogipur','230142',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81711,249,'Kabirpur','230124',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81712,249,'Kadipur','230127',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81713,249,'Kahla','230301',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81714,249,'Kailidih','230306',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81715,249,'Kaithola','229410',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81716,249,'Kalakankar','229408',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81717,249,'Kalyanpur','230402',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81718,249,'Kamapatti','230141',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81719,249,'Kamolibirbhanpur','230129',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81720,249,'Kanawan','230201',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81721,249,'Kandharpur','230401',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81722,249,'Kanja Sarai Gulami','230135',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81723,249,'Kanpa','230403',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81724,249,'Kansapatti','230135',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81725,249,'Kaprahi','230132',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81726,249,'Karenti','230204',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81727,249,'Kataiya','230137',1,0,'2022-03-03 13:06:15','2022-03-03 13:06:15'),(81728,249,'Katari','230401',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81729,249,'Katehati','230503',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81730,249,'Katra Gulab Singh','230402',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81731,249,'Katra Medniganj','230131',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81732,249,'Khajuri','230132',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81733,249,'Khajuri','230503',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81734,249,'Khemipur','230204',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81735,249,'Kilahanapur','230201',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81736,249,'Kishunganj','230503',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81737,249,'Kithawar','230503',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81738,249,'Kohdaur','230401',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81739,249,'Kolbajhan','230503',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81740,249,'Kondrajit','230129',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81741,249,'Korrahi','230129',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81742,249,'Kotha Newarhiya','230503',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81743,249,'Kotwa Shukulpur','230136',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81744,249,'Kukuwar','230135',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81745,249,'Kumbhapur','230132',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81746,249,'Kumbhi Aima','230125',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81747,249,'Kunda (Pratapgarh)','230204',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81748,249,'Kushaha','230128',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81749,249,'Kushfara','230304',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81750,249,'Kushuwapur','230141',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81751,249,'Kutulitya','230129',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81752,249,'Labeda','230138',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81753,249,'Lachchhipur','230304',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81754,249,'Lakhapur','230139',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81755,249,'Lakhipur Kapsa','230138',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81756,249,'Lala Bazar','229408',1,0,'2022-03-03 13:06:16','2022-03-03 13:06:16'),(81757,249,'Lalganj (Pratapgarh)','230132',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81758,249,'Laroo','230204',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81759,249,'Lat Tara','230202',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81760,249,'Lauwar','230134',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81761,249,'Lawana Bhawaniganj','230141',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81762,249,'Laxmaneshwar Nath Dham','230204',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81763,249,'Laxmanpur (Pratapgarh)','230130',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81764,249,'Laxmikant Ganj','230139',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81765,249,'M C Ganj','230001',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81766,249,'Machheha Herdopatti','230204',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81767,249,'Madhoganj (Pratapgarh)','230403',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81768,249,'Madhupur','230403',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81769,249,'Maghi','230204',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81770,249,'Mahamdapur','230502',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81771,249,'Maheshganj','230128',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81772,249,'Mahmadpur Bhaon','230201',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81773,249,'Mahrajganj','230128',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81774,249,'Majhigawan','230402',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81775,249,'Majhilgaon','230204',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81776,249,'Malawan Chhajaipur','230129',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81777,249,'Manapur','230138',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81778,249,'Mandhata','230402',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81779,249,'Mangapur','230125',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81780,249,'Mangarh','230204',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81781,249,'Manuhar','230141',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81782,249,'Medhauli','230304',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81783,249,'Mirzapur','230304',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81784,249,'Misiddipur','230302',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81785,249,'Mohaddinagar','230201',1,0,'2022-03-03 13:06:17','2022-03-03 13:06:17'),(81786,249,'Mohanganj','230002',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81787,249,'Molnapur','230124',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81788,249,'Muraini','230125',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81789,249,'Mustafabad','230139',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81790,249,'Muzahi Bazar','230135',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81791,249,'Nanauti','230125',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81792,249,'Narainpur Kalan','230306',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81793,249,'Narharpur','230401',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81794,249,'Naubasta','230129',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81795,249,'Naudera','230306',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81796,249,'Newarhiya','230141',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81797,249,'Newari','230129',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81798,249,'Oraiyadeeh','230134',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81799,249,'Paharpur','230136',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81800,249,'Paltan Bazar','230001',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81801,249,'Pandri Mustarka','230135',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81802,249,'Pandwasi','230144',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81803,249,'Panigo','230204',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81804,249,'Para Hamidpur','230501',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81805,249,'Paranipur','230139',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81806,249,'Parasrampur','230401',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81807,249,'Parhat Khas','230124',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81808,249,'Parhwa Nasirpur','230301',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81809,249,'Pariyawan','229408',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81810,249,'Parsipur','230201',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81811,249,'Patkhauli','230135',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81812,249,'Patti (Pratapgarh)','230135',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81813,249,'Pike Nagar','230142',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81814,249,'Ping','230141',1,0,'2022-03-03 13:06:18','2022-03-03 13:06:18'),(81815,249,'Pirthiganj Bazar','230135',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81816,249,'Pratapgarh City','230002',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81817,249,'Pratapgarh H.O','230001',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81818,249,'Pratappur Chergarh','230143',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81819,249,'Premdhar Patti','230127',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81820,249,'Prithviganj','230304',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81821,249,'Prithviganj Bazar','230133',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81822,249,'Pura Dhakwa Chauraha','230121',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81823,249,'Puranpur Khajoor','230144',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81824,249,'Pure Bhagwat','230125',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81825,249,'Pure Deshav Rai','230502',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81826,249,'Pure Dhana','230134',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81827,249,'Pure Dhani','230124',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81828,249,'Pure Gajai','230128',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81829,249,'Pure Goshain','230304',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81830,249,'Pure Guru','230502',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81831,249,'Pure Madhosingh','230502',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81832,249,'Pure Narsingh Bhan','230131',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81833,249,'Pure Newal','230503',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81834,249,'Pure Noti','230126',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81835,249,'Pure Ojha','230002',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81836,249,'Pure Roopdhar Kothiyahi','230127',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81837,249,'Purmeisultanpur','230143',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81838,249,'Purwara','230132',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81839,249,'Radhauli','230202',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81840,249,'Rahatikar','230139',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81841,249,'Rahwain','230204',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81842,249,'Raibi Rajanipur','230502',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81843,249,'Raigarh','230128',1,0,'2022-03-03 13:06:19','2022-03-03 13:06:19'),(81844,249,'Railway Colony (Pratapgarh)','230001',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81845,249,'Rajapur','230125',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81846,249,'Rajapur Bindhan','230128',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81847,249,'Rajapur Rainiya','230503',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81848,249,'Rajgarh','230131',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81849,249,'Ram Nagar','230128',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81850,249,'Ramapur','230141',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81851,249,'Ramganj','230139',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81852,249,'Ramnagar','230304',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81853,249,'Ramnagar Bhojpur','230503',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81854,249,'Rampur Baoli','230132',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81855,249,'Rampur Gauri','230131',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81856,249,'Randvir','230144',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81857,249,'Raniganj (Pratapgarh)','230304',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81858,249,'Ranjitpur Chilbila','230403',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81859,249,'Ranki','230139',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81860,249,'Rehuwa Lalganj','230139',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81861,249,'Rendi Garapur','230135',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81862,249,'Rokaiyapur','230141',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81863,249,'Sadaha','230124',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81864,249,'Sadar Bazar','230403',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81865,249,'Sagra (Pratapgarh)','230136',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81866,249,'Sahabganj (Pratapgarh)','230137',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81867,249,'Sahjani','230202',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81868,249,'Saifabad','230138',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81869,249,'Saihpur Ashiq','230201',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81870,249,'Sakardaha','230201',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81871,249,'Salhipur','230403',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81872,249,'Samaspur','230201',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81873,249,'Sandwa Chandika','230503',1,0,'2022-03-03 13:06:20','2022-03-03 13:06:20'),(81874,249,'Sangipur','230139',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81875,249,'Sangramgarh','230141',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81876,249,'Sangrampur','230501',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81877,249,'Sansarpur','230304',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81878,249,'Sarai Anadeo','230144',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81879,249,'Sarai Bhimsen','230142',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81880,249,'Sarai Bhimsen','230402',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81881,249,'Sarai Chheolaha','230135',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81882,249,'Sarai Ganai','230403',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81883,249,'Sarai Indrawat','230128',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81884,249,'Sarai Madhai','230135',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81885,249,'Sarai Mahesh','230135',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81886,249,'Sarai Murar Singh','230402',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81887,249,'Sarai Nahar Rai','230402',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81888,249,'Sarai Raja','230404',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81889,249,'Sarai Rajai','230401',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81890,249,'Sarai Shankar','230401',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81891,249,'Sarkhelpur','230134',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81892,249,'Sarsi','230405',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81893,249,'Shahbari','230503',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81894,249,'Shahpur','230304',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81895,249,'Shayaad Yasinpur','229408',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81896,249,'Shitlaganj','230142',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81897,249,'Shivgarh Bindaganj','230302',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81898,249,'Shivpur','230401',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81899,249,'Silaundhi','230301',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81900,249,'Sipah Maheri','230304',1,0,'2022-03-03 13:06:21','2022-03-03 13:06:21'),(81901,249,'Siya','230201',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81902,249,'Sonpura','230121',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81903,249,'Station Road (Pratapgarh)','230001',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81904,249,'Sujauli','230204',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81905,249,'Sultanpur','230301',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81906,249,'Surajgarh','230401',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81907,249,'Surwa Mishirpur','230306',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81908,249,'Suwansa','230306',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81909,249,'Tajpur','230204',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81910,249,'Tala','230403',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81911,249,'Tejgarh','230137',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81912,249,'Teonga','230002',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81913,249,'Tikuri Dashrathpur','230201',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81914,249,'Tiwaripur','230202',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81915,249,'Udaipur','230125',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81916,249,'Umari','230501',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81917,249,'Umari Kotila','230201',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81918,249,'Umrar','230125',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81919,249,'Upadhyaypur','230502',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81920,249,'Uri Ka Dih','230402',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81921,249,'Utras','230405',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81922,249,'Vishwanathganj','230404',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81923,249,'Wari Kalan','230405',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81924,249,'Ramganj Bazar','222301',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81925,250,'25th PAC','229001',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81926,250,'Achai','229802',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81927,250,'Aharwabhawani','229135',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81928,250,'Ahiyapur','229316',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81929,250,'Ahuri','229309',1,0,'2022-03-03 13:06:22','2022-03-03 13:06:22'),(81930,250,'Aihar','229121',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81931,250,'Ajitpur','229206',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81932,250,'Akauni','229206',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81933,250,'Akbarpur Pharsi','229126',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81934,250,'Akordhia','229404',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81935,250,'Alampur','229307',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81936,250,'Alawalpur','229204',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81937,250,'Alipur','229103',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81938,250,'Amawan','229306',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81939,250,'Ambara Mathai','229204',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81940,250,'Ambara Paschim','229206',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81941,250,'Arkha','229404',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81942,250,'Asahanjagatpur','229301',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81943,250,'Ashanandpur','229001',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81944,250,'Asharasidpur','229129',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81945,250,'Ashrafpur','229307',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81946,250,'Atarhar','229210',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81947,250,'Ataura Bujurg','229121',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81948,250,'Ataura Khurd','229130',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81949,250,'Atawan','229129',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81950,250,'Azmat Ulla Ganj','229303',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81951,250,'Babanbujurg','229306',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81952,250,'Babhanpur','229305',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81953,250,'Babuganj','229401',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81954,250,'Bachrawan','229301',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81955,250,'Baghaula','229128',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81956,250,'Bahadur Nagar','229311',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81957,250,'Bahadurnagar','229306',1,0,'2022-03-03 13:06:23','2022-03-03 13:06:23'),(81958,250,'Bahai','229203',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81959,250,'Bahua','229309',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81960,250,'Bainti','229308',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81961,250,'Bairua','229216',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81962,250,'Bakuliha','229211',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81963,250,'Bala','229123',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81964,250,'Balbhadrapur','229207',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81965,250,'Banapar','229204',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81966,250,'Banbharia','229801',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81967,250,'Bannamau','229206',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81968,250,'Bannawa','229301',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81969,250,'Bara','229129',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81970,250,'Bara Deeh','229128',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81971,250,'Baragaon','229404',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81972,250,'Barara Bujurg','229207',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81973,250,'Baraundi','229205',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81974,250,'Bardar','229122',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81975,250,'Bargadaha','229303',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81976,250,'Barha','229208',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81977,250,'Barkhurdarpur','229305',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81978,250,'Barkot','229309',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81979,250,'Barraua','229125',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81980,250,'Basantpur','229802',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81981,250,'Bathuwakhas','229001',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81982,250,'Bedaru','229308',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81983,250,'Behta','229201',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81984,250,'Bela Ghusisi','229125',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81985,250,'Bela Khara','229125',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81986,250,'Belahni','229203',1,0,'2022-03-03 13:06:24','2022-03-03 13:06:24'),(81987,250,'Bemaura','229201',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(81988,250,'Beni Kama','229402',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(81989,250,'Beni Madhiganj','229216',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(81990,250,'Beoli','229127',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(81991,250,'Betaura','229302',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(81992,250,'Bhadokhar','229405',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(81993,250,'Bhadsana','229306',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(81994,250,'Bhairampur','229301',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(81995,250,'Bhaon','229402',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(81996,250,'Bharsana','229204',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(81997,250,'Bhawani Nagar','229309',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(81998,250,'Bhawanigarh','229308',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(81999,250,'Bhietrgaon','229205',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(82000,250,'Bhilampur','229401',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(82001,250,'Bhimganj','229207',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(82002,250,'Bhira Govindpur','229125',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(82003,250,'Bhojpur (Raebareli)','229202',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(82004,250,'Bhuemau','229405',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(82005,250,'Bhuwalpur','229129',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(82006,250,'Bichiya Wadi','229401',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(82007,250,'Bijemau','229201',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(82008,250,'Binnao','229307',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(82009,250,'Bishun Khera','229206',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(82010,250,'Bishundaspur','229207',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(82011,250,'Bithooli','229202',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(82012,250,'Burdhanpur','229316',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(82013,250,'Bus Station (Raebareli)','229001',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(82014,250,'Chahotar','229202',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(82015,250,'Chanda Tikar','229203',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(82016,250,'Chandapur','229306',1,0,'2022-03-03 13:06:25','2022-03-03 13:06:25'),(82017,250,'Chatoh','229307',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82018,250,'Chauhania','229303',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82019,250,'Cheolaha','229216',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82020,250,'Chetra Bujurg','229309',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82021,250,'Chichauli','229402',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82022,250,'Chilaula','229203',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82023,250,'Chilauli','229801',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82024,250,'Chiluli','229309',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82025,250,'Churua','229311',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82026,250,'Dahigawan','229308',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82027,250,'Dalmau','229203',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82028,250,'Dariba','229001',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82029,250,'Darigapur','229125',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82030,250,'Daulatpur','229404',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82031,250,'Daulatpur','229202',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82032,250,'Deaur','229001',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82033,250,'Deeh','229310',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82034,250,'Deepemau','229206',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82035,250,'Dehli','229308',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82036,250,'Deogaon','229211',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82037,250,'Deopur','229212',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82038,250,'Dhanpulpur','229212',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82039,250,'Dharai','229127',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82040,250,'Dighaura','229303',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82041,250,'Dohri','229310',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82042,250,'Dostpur','229311',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82043,250,'Drigpal Ganj','229209',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82044,250,'Dudhwan','229215',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82045,250,'Dukanaha','229205',1,0,'2022-03-03 13:06:26','2022-03-03 13:06:26'),(82046,250,'Dusauti','229306',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82047,250,'Fatehpur','229309',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82048,250,'Fgtp Unchahar','229406',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82049,250,'Fursatganj','229302',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82050,250,'Gahrauli','229202',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82051,250,'Gajpati Khera','229212',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82052,250,'Ganga Ganj','229303',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82053,250,'Gangaoli','229404',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82054,250,'Gangehra','229406',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82055,250,'Gardehri','229309',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82056,250,'Garhi Majre Pokhanni','229306',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82057,250,'Gaura (Raebareli)','229204',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82058,250,'Gegason','229216',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82059,250,'Ghurauna','229123',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82060,250,'Ghurwara','229125',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82061,250,'Gokula','229309',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82062,250,'Gonda','229204',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82063,250,'Gondwara','229310',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82064,250,'Gopali Khera','229216',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82065,250,'Gopalpur','229124',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82066,250,'Gularhia Maj.Dhuta','229401',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82067,250,'Gumawan','229308',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82068,250,'Gurbuxganj','229122',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82069,250,'Gurha','229301',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82070,250,'Hallaur (Raebareli)','229103',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82071,250,'Hamirmau','229204',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82072,250,'Harbansganj','229304',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82073,250,'Harchandpur (Raebareli)','229303',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82074,250,'Hardaspur','229316',1,0,'2022-03-03 13:06:27','2022-03-03 13:06:27'),(82075,250,'Hardoi','229123',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82076,250,'Harpur Halla','229402',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82077,250,'Hasnapur','229121',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82078,250,'Hasnapur','229201',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82079,250,'Haswa','229309',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82080,250,'Hathnasa','229212',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82081,250,'Hazipur','229130',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82082,250,'Hewtaha Nedia','229402',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82083,250,'Ibrahimpur','229212',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82084,250,'Ichauli','229301',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82085,250,'Inhauna','229801',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82086,250,'Ishwardaspur','229401',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82087,250,'Isiya','229301',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82088,250,'Ismailmau','229204',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82089,250,'Itaurabujurg','229401',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82090,250,'ITI (Raebareli)','229010',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82091,250,'J.P.Natai','229308',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82092,250,'Jagatpur','229802',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82093,250,'Jagatpur (Raebareli)','229402',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82094,250,'Jagdishpur','229310',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82095,250,'Jai Nagra','229309',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82096,250,'Jais City','229305',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82097,250,'Jais','229305',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82098,250,'Jalalpur Dhai','229204',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82099,250,'Jamori','229402',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82100,250,'Jamurawan','229103',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82101,250,'Jamurwa','229309',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82102,250,'Janai','229306',1,0,'2022-03-03 13:06:28','2022-03-03 13:06:28'),(82103,250,'Jathua Tappa','229001',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82104,250,'Jaudaha','229124',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82105,250,'Jawahar Vihar','229010',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82106,250,'Jhampur','229215',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82107,250,'Jharaha','229204',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82108,250,'Jijauli','229801',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82109,250,'Jogapur','229211',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82110,250,'Johwasarki','229303',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82111,250,'Jyona','229306',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82112,250,'K K Bajar','229124',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82113,250,'Kahjurgaon','229216',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82114,250,'Kaithagaon','229801',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82115,250,'Kalyan Pur Bainti','229207',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82116,250,'Kalyanpur Railly','229125',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82117,250,'Kamai','229309',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82118,250,'Kandrawan','229404',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82119,250,'Kanhpur','229124',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82120,250,'Kannawan','229301',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82121,250,'Kanta','229305',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82122,250,'Karkasa','229207',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82123,250,'Kasimpur','229305',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82124,250,'Kasna','229308',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82125,250,'Kasrawan','229301',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82126,250,'Kathaura','229801',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82127,250,'Kathgar','229125',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82128,250,'Kathwara','229303',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82129,250,'Katra','229204',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82130,250,'Kaziana','229401',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82131,250,'Kewalpur Baretha','229402',1,0,'2022-03-03 13:06:29','2022-03-03 13:06:29'),(82132,250,'Khagipur Sandwa','229405',1,0,'2022-03-03 13:06:30','2022-03-03 13:06:30'),(82133,250,'Khairahni Pahargarh','229401',1,0,'2022-03-03 13:06:30','2022-03-03 13:06:30'),(82134,250,'Khajuro','229301',1,0,'2022-03-03 13:06:30','2022-03-03 13:06:30'),(82135,250,'Khanaipur Karangaon','229309',1,0,'2022-03-03 13:06:30','2022-03-03 13:06:30'),(82136,250,'Khanapur Chapra','229309',1,0,'2022-03-03 13:06:30','2022-03-03 13:06:30'),(82137,250,'Khanapur Khusti','229205',1,0,'2022-03-03 13:06:30','2022-03-03 13:06:30'),(82138,250,'Khara','229135',1,0,'2022-03-03 13:06:30','2022-03-03 13:06:30'),(82139,250,'Kharwan','229802',1,0,'2022-03-03 13:06:30','2022-03-03 13:06:30'),(82140,250,'Khekharua','229126',1,0,'2022-03-03 13:06:30','2022-03-03 13:06:30'),(82141,250,'Khidirpurkaraundi','229303',1,0,'2022-03-03 13:06:30','2022-03-03 13:06:30'),(82142,250,'Khiro','229205',1,0,'2022-03-03 13:06:30','2022-03-03 13:06:30'),(82143,250,'Khurehti','229128',1,0,'2022-03-03 13:06:30','2022-03-03 13:06:30'),(82144,250,'Khurrampur','229406',1,0,'2022-03-03 13:06:30','2022-03-03 13:06:30'),(82145,250,'Kishundaspur','229401',1,0,'2022-03-03 13:06:30','2022-03-03 13:06:30'),(82146,250,'Kodra','229202',1,0,'2022-03-03 13:06:30','2022-03-03 13:06:30'),(82147,250,'Konsa','229122',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82148,250,'Korauli Budhkar','229204',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82149,250,'Korihar','229130',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82150,250,'Kotia Chitra','229401',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82151,250,'Kotra Bahadur Ganj','229404',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82152,250,'Kotwa','229801',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82153,250,'Kotwa Mohammadabad','229126',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82154,250,'Kotwarmau','229302',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82155,250,'Kubna','229306',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82156,250,'Kukha Rampur','229802',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82157,250,'Kumbhi','229308',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82158,250,'Kumraura','229206',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82159,250,'Kundanganj','229303',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82160,250,'Kundwal','229121',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82161,250,'Kunwarmau','229307',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82162,250,'Kura','229304',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82163,250,'Kurha','229305',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82164,250,'Kurricudauli','229301',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82165,250,'Kusri Sagarpur','229103',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82166,250,'Kusumbhi','229802',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82167,250,'Kusumi','229401',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82168,250,'Kusundi','229205',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82169,250,'Kutumra','229309',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82170,250,'Lachhipur','229211',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82171,250,'Lahnga','229307',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82172,250,'Lalganj (Raebareli) H.O','229206',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82173,250,'Lalganj Bazar','229206',1,0,'2022-03-03 13:06:31','2022-03-03 13:06:31'),(82174,250,'Lalumau','229206',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82175,250,'Lauli','229802',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82176,250,'Laxmiganj','229401',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82177,250,'Lodhwamau','229001',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82178,250,'Lodhwari','229310',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82179,250,'Lodipur Utrawan','229121',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82180,250,'Madhukarpur','229121',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82181,250,'Maha Khera','229206',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82182,250,'Mahia Senduria','229802',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82183,250,'Mahrajganj (Raebareli)','229306',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82184,250,'Mahraniganj','229211',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82185,250,'Majhigawan','229123',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82186,250,'Maliak Mau Aima','229010',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82187,250,'Malik Mau Chaubara','229130',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82188,250,'Malkegaon','229215',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82189,250,'Mamuni','229127',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82190,250,'Matiha','229001',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82191,250,'Matka','229127',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82192,250,'Matrampur','229127',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82193,250,'Mattepur','229309',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82194,250,'Mau','229307',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82195,250,'Maugarbi','229306',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82196,250,'Mawai','229404',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82197,250,'Mejarganj','229128',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82198,250,'Melthua','229125',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82199,250,'Merdhauna','229309',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82200,250,'Merui','229206',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82201,250,'Mirzapur Aihari','229401',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82202,250,'Mishir Khera','229122',1,0,'2022-03-03 13:06:32','2022-03-03 13:06:32'),(82203,250,'Mohammadpur Kutcharia','229405',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82204,250,'Mohanganj','229127',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82205,250,'Mohanganj','229309',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82206,250,'Mohgawa','229310',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82207,250,'Mohna','229304',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82208,250,'Mon','229306',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82209,250,'Mubarakpur','229208',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82210,250,'Munshiganj (Raebareli)','229405',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82211,250,'Murai Ka Bagh','229207',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82212,250,'Muraini','229306',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82213,250,'Murarmau','229212',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82214,250,'Murethi','229204',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82215,250,'Musapur','229216',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82216,250,'Mustafabad (Raebareli)','229404',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82217,250,'Nain','229127',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82218,250,'Nakphulaha','229001',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82219,250,'Narsawan','229207',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82220,250,'Nasirabad','229307',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82221,250,'Neem Tikar','229301',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82222,250,'Nerthua','229103',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82223,250,'Nibi','229212',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82224,250,'Nigoha','229302',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82225,250,'Nihastha','229208',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82226,250,'Nisgar','229202',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82227,250,'Odari','229304',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82228,250,'Oie','229303',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82229,250,'Ondeeh','229306',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82230,250,'Osah','229103',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82231,250,'P.R.Kaithwal','229404',1,0,'2022-03-03 13:06:33','2022-03-03 13:06:33'),(82232,250,'Pachkhara','229404',1,0,'2022-03-03 13:06:34','2022-03-03 13:06:34'),(82233,250,'Padera','229303',1,0,'2022-03-03 13:06:34','2022-03-03 13:06:34'),(82234,250,'Paharpur Kaso','229303',1,0,'2022-03-03 13:06:34','2022-03-03 13:06:34'),(82235,250,'Paho','229209',1,0,'2022-03-03 13:06:34','2022-03-03 13:06:34'),(82236,250,'Pahremau','229306',1,0,'2022-03-03 13:06:34','2022-03-03 13:06:34'),(82237,250,'Pahuri','229201',1,0,'2022-03-03 13:06:34','2022-03-03 13:06:34'),(82238,250,'Pakargaon','229309',1,0,'2022-03-03 13:06:34','2022-03-03 13:06:34'),(82239,250,'Pakhrauli','229207',1,0,'2022-03-03 13:06:34','2022-03-03 13:06:34'),(82240,250,'Paksarawan','229127',1,0,'2022-03-03 13:06:34','2022-03-03 13:06:34'),(82241,250,'Panhauna','229135',1,0,'2022-03-03 13:06:34','2022-03-03 13:06:34'),(82242,250,'Para Kala','229103',1,0,'2022-03-03 13:06:34','2022-03-03 13:06:34'),(82243,250,'Paraiya Namaksar','229305',1,0,'2022-03-03 13:06:34','2022-03-03 13:06:34'),(82244,250,'Pari','229401',1,0,'2022-03-03 13:06:34','2022-03-03 13:06:34'),(82245,250,'Parsadepur','229129',1,0,'2022-03-03 13:06:34','2022-03-03 13:06:34'),(82246,250,'Paschim Gaon','229301',1,0,'2022-03-03 13:06:34','2022-03-03 13:06:34'),(82247,250,'Pendara','229802',1,0,'2022-03-03 13:06:34','2022-03-03 13:06:34'),(82248,250,'Phoola','229309',1,0,'2022-03-03 13:06:34','2022-03-03 13:06:34'),(82249,250,'Pindauli','229311',1,0,'2022-03-03 13:06:35','2022-03-03 13:06:35'),(82250,250,'Pirhi','229302',1,0,'2022-03-03 13:06:35','2022-03-03 13:06:35'),(82251,250,'Pothai','229302',1,0,'2022-03-03 13:06:35','2022-03-03 13:06:35'),(82252,250,'Prahladpur','229404',1,0,'2022-03-03 13:06:35','2022-03-03 13:06:35'),(82253,250,'Purab Nain','229127',1,0,'2022-03-03 13:06:35','2022-03-03 13:06:35'),(82254,250,'Pure Bharo Mishir','229203',1,0,'2022-03-03 13:06:35','2022-03-03 13:06:35'),(82255,250,'Pure Jhampur','229401',1,0,'2022-03-03 13:06:36','2022-03-03 13:06:36'),(82256,250,'Pure Thakur Ram Tewari','229304',1,0,'2022-03-03 13:06:36','2022-03-03 13:06:36'),(82257,250,'Pure Wade Singh','229302',1,0,'2022-03-03 13:06:36','2022-03-03 13:06:36'),(82258,250,'Purepandey','229215',1,0,'2022-03-03 13:06:36','2022-03-03 13:06:36'),(82259,250,'Radhabalampur','229125',1,0,'2022-03-03 13:06:36','2022-03-03 13:06:36'),(82260,250,'Raebarely H.O','229001',1,0,'2022-03-03 13:06:36','2022-03-03 13:06:36'),(82261,250,'Raebarelykty','229001',1,0,'2022-03-03 13:06:36','2022-03-03 13:06:36'),(82262,250,'Raghaupur','229123',1,0,'2022-03-03 13:06:36','2022-03-03 13:06:36'),(82263,250,'Rahi','229010',1,0,'2022-03-03 13:06:36','2022-03-03 13:06:36'),(82264,250,'Rahwa','229303',1,0,'2022-03-03 13:06:36','2022-03-03 13:06:36'),(82265,250,'Rail Coach Factory Lalganj(Raebareli)','229120',1,0,'2022-03-03 13:06:36','2022-03-03 13:06:36'),(82266,250,'Raipur','229215',1,0,'2022-03-03 13:06:36','2022-03-03 13:06:36'),(82267,250,'Raja Mau','229301',1,0,'2022-03-03 13:06:36','2022-03-03 13:06:36'),(82268,250,'Rajamau','229309',1,0,'2022-03-03 13:06:36','2022-03-03 13:06:36'),(82269,250,'Ralpur','229216',1,0,'2022-03-03 13:06:36','2022-03-03 13:06:36'),(82270,250,'Ram Garh Tikaria','229402',1,0,'2022-03-03 13:06:36','2022-03-03 13:06:36'),(82271,250,'Ramgaon','229103',1,0,'2022-03-03 13:06:36','2022-03-03 13:06:36'),(82272,250,'Ramipur','229124',1,0,'2022-03-03 13:06:36','2022-03-03 13:06:36'),(82273,250,'Rampur Kala','229216',1,0,'2022-03-03 13:06:36','2022-03-03 13:06:36'),(82274,250,'Rampur Kasiha','229124',1,0,'2022-03-03 13:06:36','2022-03-03 13:06:36'),(82275,250,'Rampur Pawara','229126',1,0,'2022-03-03 13:06:36','2022-03-03 13:06:36'),(82276,250,'Ranapur Pahrauli','229205',1,0,'2022-03-03 13:06:36','2022-03-03 13:06:36'),(82277,250,'Rasehta','229316',1,0,'2022-03-03 13:06:36','2022-03-03 13:06:36'),(82278,250,'Rasoolpur','229127',1,0,'2022-03-03 13:06:36','2022-03-03 13:06:36'),(82279,250,'Rastamau','229309',1,0,'2022-03-03 13:06:36','2022-03-03 13:06:36'),(82280,250,'Rasulpur','229001',1,0,'2022-03-03 13:06:37','2022-03-03 13:06:37'),(82281,250,'Ratapur','229316',1,0,'2022-03-03 13:06:37','2022-03-03 13:06:37'),(82282,250,'Ratason','229124',1,0,'2022-03-03 13:06:37','2022-03-03 13:06:37'),(82283,250,'Rautapur','229216',1,0,'2022-03-03 13:06:37','2022-03-03 13:06:37'),(82284,250,'Rblqila','229001',1,0,'2022-03-03 13:06:37','2022-03-03 13:06:37'),(82285,250,'Reewa','229103',1,0,'2022-03-03 13:06:37','2022-03-03 13:06:37'),(82286,250,'Reoli','229401',1,0,'2022-03-03 13:06:37','2022-03-03 13:06:37'),(82287,250,'Rewhara','229127',1,0,'2022-03-03 13:06:37','2022-03-03 13:06:37'),(82288,250,'Rohania','229401',1,0,'2022-03-03 13:06:37','2022-03-03 13:06:37'),(82289,250,'Rokha','229310',1,0,'2022-03-03 13:06:38','2022-03-03 13:06:38'),(82290,250,'Rukunpur','229135',1,0,'2022-03-03 13:06:38','2022-03-03 13:06:38'),(82291,250,'Rupamau','229010',1,0,'2022-03-03 13:06:38','2022-03-03 13:06:38'),(82292,250,'Rustampur','229001',1,0,'2022-03-03 13:06:38','2022-03-03 13:06:38'),(82293,250,'Saguni','229205',1,0,'2022-03-03 13:06:38','2022-03-03 13:06:38'),(82294,250,'Sahjaura','229122',1,0,'2022-03-03 13:06:38','2022-03-03 13:06:38'),(82295,250,'Saimbasi','229309',1,0,'2022-03-03 13:06:38','2022-03-03 13:06:38'),(82296,250,'Saini','229122',1,0,'2022-03-03 13:06:38','2022-03-03 13:06:38'),(82297,250,'Salethu','229123',1,0,'2022-03-03 13:06:38','2022-03-03 13:06:38'),(82298,250,'Salon','229127',1,0,'2022-03-03 13:06:38','2022-03-03 13:06:38'),(82299,250,'Samodha','229212',1,0,'2022-03-03 13:06:38','2022-03-03 13:06:38'),(82300,250,'Samrahda','229302',1,0,'2022-03-03 13:06:38','2022-03-03 13:06:38'),(82301,250,'Sandaha','229305',1,0,'2022-03-03 13:06:38','2022-03-03 13:06:38'),(82302,250,'Sandi Nagin','229001',1,0,'2022-03-03 13:06:38','2022-03-03 13:06:38'),(82303,250,'Sanehi','229128',1,0,'2022-03-03 13:06:38','2022-03-03 13:06:38'),(82304,250,'Sarain Mahesha','229304',1,0,'2022-03-03 13:06:38','2022-03-03 13:06:38'),(82305,250,'Sarain Manik','229310',1,0,'2022-03-03 13:06:38','2022-03-03 13:06:38'),(82306,250,'Sarawan','229316',1,0,'2022-03-03 13:06:38','2022-03-03 13:06:38'),(82307,250,'Sareni','229404',1,0,'2022-03-03 13:06:39','2022-03-03 13:06:39'),(82308,250,'Sareni','229212',1,0,'2022-03-03 13:06:39','2022-03-03 13:06:39'),(82309,250,'Sarwan','229302',1,0,'2022-03-03 13:06:39','2022-03-03 13:06:39'),(82310,250,'Satanpur','229208',1,0,'2022-03-03 13:06:39','2022-03-03 13:06:39'),(82311,250,'Satanpurwa','229135',1,0,'2022-03-03 13:06:39','2022-03-03 13:06:39'),(82312,250,'Sataon','229122',1,0,'2022-03-03 13:06:39','2022-03-03 13:06:39'),(82313,250,'Satwa Khera','229212',1,0,'2022-03-03 13:06:39','2022-03-03 13:06:39'),(82314,250,'Satyanagar (Raebareli)','229001',1,0,'2022-03-03 13:06:39','2022-03-03 13:06:39'),(82315,250,'Sawaiya Hasan','229404',1,0,'2022-03-03 13:06:39','2022-03-03 13:06:39'),(82316,250,'Sehgon','229311',1,0,'2022-03-03 13:06:39','2022-03-03 13:06:39'),(82317,250,'Semarpaha','229206',1,0,'2022-03-03 13:06:39','2022-03-03 13:06:39'),(82318,250,'Semra','229128',1,0,'2022-03-03 13:06:39','2022-03-03 13:06:39'),(82319,250,'Semrauta','229126',1,0,'2022-03-03 13:06:39','2022-03-03 13:06:39'),(82320,250,'Semri','229211',1,0,'2022-03-03 13:06:39','2022-03-03 13:06:39'),(82321,250,'Seni','229122',1,0,'2022-03-03 13:06:39','2022-03-03 13:06:39'),(82322,250,'Seoli','229308',1,0,'2022-03-03 13:06:39','2022-03-03 13:06:39'),(82323,250,'Shahmau','229304',1,0,'2022-03-03 13:06:39','2022-03-03 13:06:39'),(82324,250,'Shankarganj','229309',1,0,'2022-03-03 13:06:39','2022-03-03 13:06:39'),(82325,250,'Shankarpur','229402',1,0,'2022-03-03 13:06:39','2022-03-03 13:06:39'),(82326,250,'Shanker Bazar','229125',1,0,'2022-03-03 13:06:39','2022-03-03 13:06:39'),(82327,250,'Shekhpur Samodha','229301',1,0,'2022-03-03 13:06:39','2022-03-03 13:06:39'),(82328,250,'Sheopuri','229209',1,0,'2022-03-03 13:06:39','2022-03-03 13:06:39'),(82329,250,'Sheoratanganj','229802',1,0,'2022-03-03 13:06:39','2022-03-03 13:06:39'),(82330,250,'Shivgarh','229308',1,0,'2022-03-03 13:06:39','2022-03-03 13:06:39'),(82331,250,'Sidhauna','229306',1,0,'2022-03-03 13:06:39','2022-03-03 13:06:39'),(82332,250,'Sikandarpur','229126',1,0,'2022-03-03 13:06:40','2022-03-03 13:06:40'),(82333,250,'Singhortara','229216',1,0,'2022-03-03 13:06:40','2022-03-03 13:06:40'),(82334,250,'Singhpur','229304',1,0,'2022-03-03 13:06:40','2022-03-03 13:06:40'),(82335,250,'Siwan','229126',1,0,'2022-03-03 13:06:40','2022-03-03 13:06:40'),(82336,250,'Sondasi','229203',1,0,'2022-03-03 13:06:40','2022-03-03 13:06:40'),(82337,250,'Sothi','229306',1,0,'2022-03-03 13:06:41','2022-03-03 13:06:41'),(82338,250,'Suchi','229128',1,0,'2022-03-03 13:06:41','2022-03-03 13:06:41'),(82339,250,'Sudamapur','229204',1,0,'2022-03-03 13:06:41','2022-03-03 13:06:41'),(82340,250,'Sujwaria','229307',1,0,'2022-03-03 13:06:41','2022-03-03 13:06:41'),(82341,250,'Sultanpur Janauli','229204',1,0,'2022-03-03 13:06:41','2022-03-03 13:06:41'),(82342,250,'Sultanpur Khera','229130',1,0,'2022-03-03 13:06:41','2022-03-03 13:06:41'),(82343,250,'Suttha','229204',1,0,'2022-03-03 13:06:41','2022-03-03 13:06:41'),(82344,250,'Tala','229122',1,0,'2022-03-03 13:06:41','2022-03-03 13:06:41'),(82345,250,'Tama Mau','229304',1,0,'2022-03-03 13:06:41','2022-03-03 13:06:41'),(82346,250,'Taqia Kala','229001',1,0,'2022-03-03 13:06:41','2022-03-03 13:06:41'),(82347,250,'Tejgaon','229215',1,0,'2022-03-03 13:06:41','2022-03-03 13:06:41'),(82348,250,'Tenduwa','229302',1,0,'2022-03-03 13:06:41','2022-03-03 13:06:41'),(82349,250,'Terukha','229125',1,0,'2022-03-03 13:06:41','2022-03-03 13:06:41'),(82350,250,'Tewaripur','229128',1,0,'2022-03-03 13:06:41','2022-03-03 13:06:41'),(82351,250,'Thulendi','229301',1,0,'2022-03-03 13:06:41','2022-03-03 13:06:41'),(82352,250,'Thulrai','229125',1,0,'2022-03-03 13:06:41','2022-03-03 13:06:41'),(82353,250,'Thulwasa','229306',1,0,'2022-03-03 13:06:41','2022-03-03 13:06:41'),(82354,250,'Tikar Agachipur','229402',1,0,'2022-03-03 13:06:41','2022-03-03 13:06:41'),(82355,250,'Tikari Dandu','229310',1,0,'2022-03-03 13:06:41','2022-03-03 13:06:41'),(82356,250,'Tikaria','229402',1,0,'2022-03-03 13:06:41','2022-03-03 13:06:41'),(82357,250,'Tikwamau','229122',1,0,'2022-03-03 13:06:41','2022-03-03 13:06:41'),(82358,250,'Tilenda','229301',1,0,'2022-03-03 13:06:41','2022-03-03 13:06:41'),(82359,250,'Tiloi','229309',1,0,'2022-03-03 13:06:41','2022-03-03 13:06:41'),(82360,250,'Tinera','229302',1,0,'2022-03-03 13:06:41','2022-03-03 13:06:41'),(82361,250,'Tisha Khanapur','229306',1,0,'2022-03-03 13:06:41','2022-03-03 13:06:41'),(82362,250,'Townhall','229001',1,0,'2022-03-03 13:06:42','2022-03-03 13:06:42'),(82363,250,'Uchauri','229301',1,0,'2022-03-03 13:06:42','2022-03-03 13:06:42'),(82364,250,'Udwa Hemrajpur','229304',1,0,'2022-03-03 13:06:42','2022-03-03 13:06:42'),(82365,250,'Umramau','229121',1,0,'2022-03-03 13:06:42','2022-03-03 13:06:42'),(82366,250,'Umran','229404',1,0,'2022-03-03 13:06:42','2022-03-03 13:06:42'),(82367,250,'Undwa','229401',1,0,'2022-03-03 13:06:42','2022-03-03 13:06:42'),(82368,250,'Usroo','229202',1,0,'2022-03-03 13:06:42','2022-03-03 13:06:42'),(82369,250,'Utarpara','229402',1,0,'2022-03-03 13:06:42','2022-03-03 13:06:42'),(82370,250,'Utragauri','229203',1,0,'2022-03-03 13:06:42','2022-03-03 13:06:42'),(82371,250,'Wahabganj','229305',1,0,'2022-03-03 13:06:42','2022-03-03 13:06:42'),(82372,250,'Zilaparisad','229001',1,0,'2022-03-03 13:06:42','2022-03-03 13:06:42'),(82373,251,'Aghapur','244901',1,0,'2022-03-03 13:06:42','2022-03-03 13:06:42'),(82374,251,'Ahmad Nagar Kalan','244927',1,0,'2022-03-03 13:06:42','2022-03-03 13:06:42'),(82375,251,'Ahor','244921',1,0,'2022-03-03 13:06:42','2022-03-03 13:06:42'),(82376,251,'Ajit Pur','244901',1,0,'2022-03-03 13:06:42','2022-03-03 13:06:42'),(82377,251,'Anwaria Talibabad','244921',1,0,'2022-03-03 13:06:43','2022-03-03 13:06:43'),(82378,251,'Azim Nagar','244927',1,0,'2022-03-03 13:06:43','2022-03-03 13:06:43'),(82379,251,'Babura','244701',1,0,'2022-03-03 13:06:43','2022-03-03 13:06:43'),(82380,251,'Bakania','244901',1,0,'2022-03-03 13:06:43','2022-03-03 13:06:43'),(82381,251,'Bara Gaon','244922',1,0,'2022-03-03 13:06:43','2022-03-03 13:06:43'),(82382,251,'Bara Khas','244901',1,0,'2022-03-03 13:06:43','2022-03-03 13:06:43'),(82383,251,'Begamabad','244921',1,0,'2022-03-03 13:06:43','2022-03-03 13:06:43'),(82384,251,'Benazir','244901',1,0,'2022-03-03 13:06:43','2022-03-03 13:06:43'),(82385,251,'Bhainsori','244701',1,0,'2022-03-03 13:06:43','2022-03-03 13:06:43'),(82386,251,'Bhansia Jawalapuri','244921',1,0,'2022-03-03 13:06:43','2022-03-03 13:06:43'),(82387,251,'Bhawani Nagar','244924',1,0,'2022-03-03 13:06:43','2022-03-03 13:06:43'),(82388,251,'Bhonrka','244701',1,0,'2022-03-03 13:06:43','2022-03-03 13:06:43'),(82389,251,'Bhot','244901',1,0,'2022-03-03 13:06:43','2022-03-03 13:06:43'),(82390,251,'Bhot Baqqal','244924',1,0,'2022-03-03 13:06:43','2022-03-03 13:06:43'),(82391,251,'Bilaspur (Rampur)','244921',1,0,'2022-03-03 13:06:43','2022-03-03 13:06:43'),(82392,251,'Bilaspur Chini Mill','244923',1,0,'2022-03-03 13:06:43','2022-03-03 13:06:43'),(82393,251,'C & M Store','244901',1,0,'2022-03-03 13:06:44','2022-03-03 13:06:44'),(82394,251,'C.R.P. Hq','244901',1,0,'2022-03-03 13:06:44','2022-03-03 13:06:44'),(82395,251,'Chamroa','244901',1,0,'2022-03-03 13:06:44','2022-03-03 13:06:44'),(82396,251,'Chandain','244923',1,0,'2022-03-03 13:06:44','2022-03-03 13:06:44'),(82397,251,'Chandela','244921',1,0,'2022-03-03 13:06:44','2022-03-03 13:06:44'),(82398,251,'Chikti Ramnagar','244901',1,0,'2022-03-03 13:06:44','2022-03-03 13:06:44'),(82399,251,'Civil Line Rampur','244901',1,0,'2022-03-03 13:06:44','2022-03-03 13:06:44'),(82400,251,'Daniapur','244901',1,0,'2022-03-03 13:06:44','2022-03-03 13:06:44'),(82401,251,'Daryal','244925',1,0,'2022-03-03 13:06:44','2022-03-03 13:06:44'),(82402,251,'Deorania','244927',1,0,'2022-03-03 13:06:44','2022-03-03 13:06:44'),(82403,251,'Dhakia','244922',1,0,'2022-03-03 13:06:44','2022-03-03 13:06:44'),(82404,251,'Dhamorah','244701',1,0,'2022-03-03 13:06:44','2022-03-03 13:06:44'),(82405,251,'Dhaneli Uttari','244701',1,0,'2022-03-03 13:06:44','2022-03-03 13:06:44'),(82406,251,'Dhanupura','244925',1,0,'2022-03-03 13:06:44','2022-03-03 13:06:44'),(82407,251,'Dheeraj Nagar','244925',1,0,'2022-03-03 13:06:44','2022-03-03 13:06:44'),(82408,251,'Doondawala','244924',1,0,'2022-03-03 13:06:45','2022-03-03 13:06:45'),(82409,251,'Gangapur Purvi','244701',1,0,'2022-03-03 13:06:45','2022-03-03 13:06:45'),(82410,251,'Ghrampur Narendrapur','244922',1,0,'2022-03-03 13:06:45','2022-03-03 13:06:45'),(82411,251,'Hamidabad','244921',1,0,'2022-03-03 13:06:45','2022-03-03 13:06:45'),(82412,251,'Hamirpur','244927',1,0,'2022-03-03 13:06:45','2022-03-03 13:06:45'),(82413,251,'Ialam Ganj','244901',1,0,'2022-03-03 13:06:45','2022-03-03 13:06:45'),(82414,251,'Ishanagar','244921',1,0,'2022-03-03 13:06:45','2022-03-03 13:06:45'),(82415,251,'Jiwai Kadim','244701',1,0,'2022-03-03 13:06:45','2022-03-03 13:06:45'),(82416,251,'Juthia','244901',1,0,'2022-03-03 13:06:45','2022-03-03 13:06:45'),(82417,251,'Jwala Nagar','244901',1,0,'2022-03-03 13:06:45','2022-03-03 13:06:45'),(82418,251,'Kakrawa','244901',1,0,'2022-03-03 13:06:45','2022-03-03 13:06:45'),(82419,251,'Kashipur','244927',1,0,'2022-03-03 13:06:45','2022-03-03 13:06:45'),(82420,251,'Kaushal Ganj','244923',1,0,'2022-03-03 13:06:45','2022-03-03 13:06:45'),(82421,251,'Kemri (Rampur)','244928',1,0,'2022-03-03 13:06:45','2022-03-03 13:06:45'),(82422,251,'Keorar','244701',1,0,'2022-03-03 13:06:46','2022-03-03 13:06:46'),(82423,251,'Kerenthi','244922',1,0,'2022-03-03 13:06:46','2022-03-03 13:06:46'),(82424,251,'Khamaria','244701',1,0,'2022-03-03 13:06:46','2022-03-03 13:06:46'),(82425,251,'Khandia','244921',1,0,'2022-03-03 13:06:46','2022-03-03 13:06:46'),(82426,251,'Khempur','244921',1,0,'2022-03-03 13:06:46','2022-03-03 13:06:46'),(82427,251,'Khempur','244924',1,0,'2022-03-03 13:06:46','2022-03-03 13:06:46'),(82428,251,'Khod','244927',1,0,'2022-03-03 13:06:46','2022-03-03 13:06:46'),(82429,251,'Khod Sharif','244924',1,0,'2022-03-03 13:06:46','2022-03-03 13:06:46'),(82430,251,'Khusro Bagh','244901',1,0,'2022-03-03 13:06:46','2022-03-03 13:06:46'),(82431,251,'Kira','244901',1,0,'2022-03-03 13:06:46','2022-03-03 13:06:46'),(82432,251,'Kiramcha','244701',1,0,'2022-03-03 13:06:46','2022-03-03 13:06:46'),(82433,251,'Koila','244901',1,0,'2022-03-03 13:06:46','2022-03-03 13:06:46'),(82434,251,'Koop','244701',1,0,'2022-03-03 13:06:46','2022-03-03 13:06:46'),(82435,251,'Kunwarpur','244924',1,0,'2022-03-03 13:06:46','2022-03-03 13:06:46'),(82436,251,'Lalpur Kalan','244927',1,0,'2022-03-03 13:06:46','2022-03-03 13:06:46'),(82437,251,'Lambakhera','244925',1,0,'2022-03-03 13:06:46','2022-03-03 13:06:46'),(82438,251,'Loha','244701',1,0,'2022-03-03 13:06:46','2022-03-03 13:06:46'),(82439,251,'M.B.Rampur','244901',1,0,'2022-03-03 13:06:46','2022-03-03 13:06:46'),(82440,251,'Madhauli','244901',1,0,'2022-03-03 13:06:46','2022-03-03 13:06:46'),(82441,251,'Madhukar','244922',1,0,'2022-03-03 13:06:46','2022-03-03 13:06:46'),(82442,251,'Mahu Nagar','244901',1,0,'2022-03-03 13:06:46','2022-03-03 13:06:46'),(82443,251,'Mankara','244701',1,0,'2022-03-03 13:06:46','2022-03-03 13:06:46'),(82444,251,'Manpur','244925',1,0,'2022-03-03 13:06:46','2022-03-03 13:06:46'),(82445,251,'Manpur','244924',1,0,'2022-03-03 13:06:47','2022-03-03 13:06:47'),(82446,251,'Maswasi','244924',1,0,'2022-03-03 13:06:47','2022-03-03 13:06:47'),(82447,251,'Mathuraour','244901',1,0,'2022-03-03 13:06:47','2022-03-03 13:06:47'),(82448,251,'Matkhera','244921',1,0,'2022-03-03 13:06:47','2022-03-03 13:06:47'),(82449,251,'Meerapur Meerganj','244924',1,0,'2022-03-03 13:06:47','2022-03-03 13:06:47'),(82450,251,'Meston Ganj','244901',1,0,'2022-03-03 13:06:47','2022-03-03 13:06:47'),(82451,251,'Milak Khanam','244921',1,0,'2022-03-03 13:06:47','2022-03-03 13:06:47'),(82452,251,'Milak','244701',1,0,'2022-03-03 13:06:47','2022-03-03 13:06:47'),(82453,251,'Modipur','244926',1,0,'2022-03-03 13:06:47','2022-03-03 13:06:47'),(82454,251,'Mulla Khera','244921',1,0,'2022-03-03 13:06:47','2022-03-03 13:06:47'),(82455,251,'Mursaina','244927',1,0,'2022-03-03 13:06:47','2022-03-03 13:06:47'),(82456,251,'Naglia Aqil','244927',1,0,'2022-03-03 13:06:47','2022-03-03 13:06:47'),(82457,251,'Nanka Rani','244924',1,0,'2022-03-03 13:06:47','2022-03-03 13:06:47'),(82458,251,'Nankar','244901',1,0,'2022-03-03 13:06:47','2022-03-03 13:06:47'),(82459,251,'Narkhera','244901',1,0,'2022-03-03 13:06:47','2022-03-03 13:06:47'),(82460,251,'Nawabganj','244921',1,0,'2022-03-03 13:06:47','2022-03-03 13:06:47'),(82461,251,'Nipania','244901',1,0,'2022-03-03 13:06:47','2022-03-03 13:06:47'),(82462,251,'Paigamberpur','244921',1,0,'2022-03-03 13:06:48','2022-03-03 13:06:48'),(82463,251,'Panwaria','244923',1,0,'2022-03-03 13:06:48','2022-03-03 13:06:48'),(82464,251,'Param','244701',1,0,'2022-03-03 13:06:48','2022-03-03 13:06:48'),(82465,251,'Parshupura','244701',1,0,'2022-03-03 13:06:48','2022-03-03 13:06:48'),(82466,251,'Patti Basantpur','244701',1,0,'2022-03-03 13:06:48','2022-03-03 13:06:48'),(82467,251,'Patwai','244901',1,0,'2022-03-03 13:06:48','2022-03-03 13:06:48'),(82468,251,'Piagamberpur','244924',1,0,'2022-03-03 13:06:48','2022-03-03 13:06:48'),(82469,251,'Pipali Nayak','244925',1,0,'2022-03-03 13:06:48','2022-03-03 13:06:48'),(82470,251,'Pipalia Gopal','244921',1,0,'2022-03-03 13:06:48','2022-03-03 13:06:48'),(82471,251,'Punjab Nagar','244901',1,0,'2022-03-03 13:06:48','2022-03-03 13:06:48'),(82472,251,'Purana Ganj','244901',1,0,'2022-03-03 13:06:48','2022-03-03 13:06:48'),(82473,251,'Puswara','244924',1,0,'2022-03-03 13:06:48','2022-03-03 13:06:48'),(82474,251,'Ramnagar Latifpur','244925',1,0,'2022-03-03 13:06:48','2022-03-03 13:06:48'),(82475,251,'Rampur Buzurg','244923',1,0,'2022-03-03 13:06:48','2022-03-03 13:06:48'),(82476,251,'Rampur Chowk','244901',1,0,'2022-03-03 13:06:48','2022-03-03 13:06:48'),(82477,251,'Rampur City','244901',1,0,'2022-03-03 13:06:48','2022-03-03 13:06:48'),(82478,251,'Rampur Distilliry','244901',1,0,'2022-03-03 13:06:48','2022-03-03 13:06:48'),(82479,251,'Rampur H.O','244901',1,0,'2022-03-03 13:06:48','2022-03-03 13:06:48'),(82480,251,'Rampur Secretariate','244901',1,0,'2022-03-03 13:06:48','2022-03-03 13:06:48'),(82481,251,'Rasdandia','244921',1,0,'2022-03-03 13:06:48','2022-03-03 13:06:48'),(82482,251,'Ratanpura','244921',1,0,'2022-03-03 13:06:48','2022-03-03 13:06:48'),(82483,251,'Rathonda','244701',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82484,251,'Rawana','244922',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82485,251,'Rawari Kalan','244901',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82486,251,'Rehmatganj','244924',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82487,251,'Roshan Bag Road','244901',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82488,251,'Said Nagar','244927',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82489,251,'Samodia','244924',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82490,251,'Shahabad (Rampur)','244922',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82491,251,'Silai Bara Gaon','244701',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82492,251,'Simaria','244921',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82493,251,'Singhankhera','244927',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82494,251,'Suar','244924',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82495,251,'Swarg Farm','244923',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82496,251,'Tanda','244922',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82497,251,'Tanda Badli','244925',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82498,251,'Tehsil Rampur','244901',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82499,251,'Unchagaon','244922',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82500,252,'A.Chand','247451',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82501,252,'Aghiana','247342',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82502,252,'Ahmedpur','247451',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82503,252,'Alipura','247232',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82504,252,'Ambehta','247340',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82505,252,'Ambehta Shekhan','247554',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82506,252,'Amboli','247554',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82507,252,'Anantmau','247452',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82508,252,'Anwarpur Baroli','247129',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82509,252,'B. Majbatta','247554',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82510,252,'Babail Buzurg','247120',1,0,'2022-03-03 13:06:49','2022-03-03 13:06:49'),(82511,252,'Babupur','247554',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82512,252,'Bachiti','247551',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82513,252,'Badheri Ghoghu','247001',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82514,252,'Badhi','247342',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82515,252,'Badshahi Bagh','247122',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82516,252,'Bahera','247453',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82517,252,'Bahera Sandal Singh','247120',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82518,252,'Bajoria Marg','247001',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82519,252,'Baliakheri','247001',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82520,252,'Banderjud','247662',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82521,252,'Banhera Khas','247554',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82522,252,'Bansdei','247341',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82523,252,'Bargaon (Saharanpur)','247452',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82524,252,'Bargaon','247452',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82525,252,'Bartha Kayastha','247231',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82526,252,'Bastam','247554',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82527,252,'Beenpur','247341',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82528,252,'Beera Kheri','247340',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82529,252,'Behat (Saharanpur)','247121',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82530,252,'Bhabsi','247452',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82531,252,'Bhaila Kalan','247554',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82532,252,'Bhankla','247451',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82533,252,'Bhari','247452',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82534,252,'Bhuradev','247121',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82535,252,'Budhakhera','247231',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82536,252,'Bus Stand Deoband','247554',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82537,252,'Chakrata Road','247001',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82538,252,'Chakwali','247451',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82539,252,'Chandena Koli','247554',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82540,252,'Chauradev','247669',1,0,'2022-03-03 13:06:50','2022-03-03 13:06:50'),(82541,252,'Chauri','247232',1,0,'2022-03-03 13:06:51','2022-03-03 13:06:51'),(82542,252,'Chilkana','247231',1,0,'2022-03-03 13:06:51','2022-03-03 13:06:51'),(82543,252,'Chutmalpur','247662',1,0,'2022-03-03 13:06:51','2022-03-03 13:06:51'),(82544,252,'Darul Uloom Deoband','247554',1,0,'2022-03-03 13:06:51','2022-03-03 13:06:51'),(82545,252,'Darul Uloom',' Deoband',1,0,'2022-03-03 13:06:51','2022-03-03 13:06:51'),(82546,252,'Deoband','247554',1,0,'2022-03-03 13:06:51','2022-03-03 13:06:51'),(82547,252,'Dhaiki','247340',1,0,'2022-03-03 13:06:51','2022-03-03 13:06:51'),(82548,252,'Dhakdei','247001',1,0,'2022-03-03 13:06:51','2022-03-03 13:06:51'),(82549,252,'Dhangera','247551',1,0,'2022-03-03 13:06:51','2022-03-03 13:06:51'),(82550,252,'Dhikka Kalan','247232',1,0,'2022-03-03 13:06:51','2022-03-03 13:06:51'),(82551,252,'Dhorala','247340',1,0,'2022-03-03 13:06:51','2022-03-03 13:06:51'),(82552,252,'Diwalheri','247554',1,0,'2022-03-03 13:06:51','2022-03-03 13:06:51'),(82553,252,'Dudhla','247341',1,0,'2022-03-03 13:06:51','2022-03-03 13:06:51'),(82554,252,'Faizabad','247121',1,0,'2022-03-03 13:06:51','2022-03-03 13:06:51'),(82555,252,'Gaderheri','247232',1,0,'2022-03-03 13:06:51','2022-03-03 13:06:51'),(82556,252,'Gagalheri','247669',1,0,'2022-03-03 13:06:51','2022-03-03 13:06:51'),(82557,252,'Gangdaspur','247554',1,0,'2022-03-03 13:06:51','2022-03-03 13:06:51'),(82558,252,'Gangoh','247341',1,0,'2022-03-03 13:06:51','2022-03-03 13:06:51'),(82559,252,'Gatta Mill','247001',1,0,'2022-03-03 13:06:51','2022-03-03 13:06:51'),(82560,252,'Ghaloli','247554',1,0,'2022-03-03 13:06:51','2022-03-03 13:06:51'),(82561,252,'Ghatera','247451',1,0,'2022-03-03 13:06:51','2022-03-03 13:06:51'),(82562,252,'Ghunna','247120',1,0,'2022-03-03 13:06:51','2022-03-03 13:06:51'),(82563,252,'Gopal Nagar','247001',1,0,'2022-03-03 13:06:51','2022-03-03 13:06:51'),(82564,252,'Gopali','247554',1,0,'2022-03-03 13:06:51','2022-03-03 13:06:51'),(82565,252,'Gudamb','247451',1,0,'2022-03-03 13:06:51','2022-03-03 13:06:51'),(82566,252,'Gunarsa','247554',1,0,'2022-03-03 13:06:52','2022-03-03 13:06:52'),(82567,252,'Hakikat Nagar','247001',1,0,'2022-03-03 13:06:52','2022-03-03 13:06:52'),(82568,252,'Halalpur','247001',1,0,'2022-03-03 13:06:52','2022-03-03 13:06:52'),(82569,252,'Halwana','247662',1,0,'2022-03-03 13:06:52','2022-03-03 13:06:52'),(82570,252,'Harora','247669',1,0,'2022-03-03 13:06:52','2022-03-03 13:06:52'),(82571,252,'Harpal','247001',1,0,'2022-03-03 13:06:52','2022-03-03 13:06:52'),(82572,252,'Hassanpur','247001',1,0,'2022-03-03 13:06:52','2022-03-03 13:06:52'),(82573,252,'Hassanpur','247342',1,0,'2022-03-03 13:06:52','2022-03-03 13:06:52'),(82574,252,'Hassanpur Madanpur','247662',1,0,'2022-03-03 13:06:52','2022-03-03 13:06:52'),(82575,252,'Industrial Estate Deoband','247554',1,0,'2022-03-03 13:06:52','2022-03-03 13:06:52'),(82576,252,'Islamnagar','247451',1,0,'2022-03-03 13:06:52','2022-03-03 13:06:52'),(82577,252,'Jandhera Samaspur','247451',1,0,'2022-03-03 13:06:52','2022-03-03 13:06:52'),(82578,252,'Jandheri','247452',1,0,'2022-03-03 13:06:52','2022-03-03 13:06:52'),(82579,252,'Jandkhera','247341',1,0,'2022-03-03 13:06:52','2022-03-03 13:06:52'),(82580,252,'Jandkhera','247451',1,0,'2022-03-03 13:06:52','2022-03-03 13:06:52'),(82581,252,'Jaroda Jatt','247554',1,0,'2022-03-03 13:06:52','2022-03-03 13:06:52'),(82582,252,'Jaroda Panda','247453',1,0,'2022-03-03 13:06:52','2022-03-03 13:06:52'),(82583,252,'Jasmour','247121',1,0,'2022-03-03 13:06:52','2022-03-03 13:06:52'),(82584,252,'Jatonwala','247121',1,0,'2022-03-03 13:06:52','2022-03-03 13:06:52'),(82585,252,'Jhabiran','247232',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82586,252,'Jharwan','247341',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82587,252,'Kailashpur','247001',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82588,252,'Kalsia','247120',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82589,252,'Kaluwala Jahanpur','247129',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82590,252,'Kamboh Majra','247121',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82591,252,'Kankarkui','247001',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82592,252,'Kasimpur','247121',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82593,252,'Kenduki','247554',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82594,252,'Khadlana','247341',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82595,252,'Khajnawar','247129',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82596,252,'Khajoorwala','247551',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82597,252,'Khajuri Akbarpur','247669',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82598,252,'Khalapar','247001',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82599,252,'Khalasi Line','247001',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82600,252,'Khera Afgan','247340',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82601,252,'Khera Mugal','247551',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82602,252,'Khudana','247452',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82603,252,'Khumran Pul','247001',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82604,252,'Khurrampur','247129',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82605,252,'Khushalipur','247662',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82606,252,'Kota','247551',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82607,252,'Kulsath','247554',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82608,252,'Kunda Kalan','247341',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82609,252,'Kurdi Khera','247129',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82610,252,'Kuri','247554',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82611,252,'Labour Colony','247001',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82612,252,'Lakhi Gate','247001',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82613,252,'Lakhnaur','247551',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82614,252,'Lakhnauti','247341',1,0,'2022-03-03 13:06:53','2022-03-03 13:06:53'),(82615,252,'Lashkarpur','247662',1,0,'2022-03-03 13:06:54','2022-03-03 13:06:54'),(82616,252,'Macharheri','247001',1,0,'2022-03-03 13:06:54','2022-03-03 13:06:54'),(82617,252,'Mahengi','247452',1,0,'2022-03-03 13:06:54','2022-03-03 13:06:54'),(82618,252,'Malhipur','247001',1,0,'2022-03-03 13:06:54','2022-03-03 13:06:54'),(82619,252,'Mangal Nagar','247001',1,0,'2022-03-03 13:06:54','2022-03-03 13:06:54'),(82620,252,'Mavi Kalan','247001',1,0,'2022-03-03 13:06:54','2022-03-03 13:06:54'),(82621,252,'Mazahir Uloom','247001',1,0,'2022-03-03 13:06:54','2022-03-03 13:06:54'),(82622,252,'Miragpur','247554',1,0,'2022-03-03 13:06:54','2022-03-03 13:06:54'),(82623,252,'Mirjapur Poll','247121',1,0,'2022-03-03 13:06:54','2022-03-03 13:06:54'),(82624,252,'Mission Compound','247001',1,0,'2022-03-03 13:06:54','2022-03-03 13:06:54'),(82625,252,'Mohand','247662',1,0,'2022-03-03 13:06:54','2022-03-03 13:06:54'),(82626,252,'Mohanpura','247341',1,0,'2022-03-03 13:06:54','2022-03-03 13:06:54'),(82627,252,'Mora','247453',1,0,'2022-03-03 13:06:54','2022-03-03 13:06:54'),(82628,252,'Mussail','247120',1,0,'2022-03-03 13:06:54','2022-03-03 13:06:54'),(82629,252,'Muzaffrabad','247129',1,0,'2022-03-03 13:06:54','2022-03-03 13:06:54'),(82630,252,'Nagal (Saharanpur)','247551',1,0,'2022-03-03 13:06:54','2022-03-03 13:06:54'),(82631,252,'Nagrajpur','247001',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82632,252,'Nakur','247342',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82633,252,'Nalhera Gujjar','247451',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82634,252,'Nanauta','247452',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82635,252,'Nandi Firozpur','247001',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82636,252,'Narayanpuri','247001',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82637,252,'Nasrullahgarh','247342',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82638,252,'Naya Gaon','247453',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82639,252,'Nazirpura Devli','247001',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82640,252,'Nehru Market','247001',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82641,252,'Niyamatpur','247129',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82642,252,'Pahansu','247451',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82643,252,'Paharpur','247551',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82644,252,'Pandoli','247551',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82645,252,'Paniyali Kasimpur','247551',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82646,252,'Paper Mill','247001',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82647,252,'Phandpuri','247001',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82648,252,'Pheraheri','247001',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82649,252,'Pilakhni','247232',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82650,252,'Prasar Kendra',' Rampur',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82651,252,'Ptc','247002',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82652,252,'Pundain','247001',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82653,252,'Punwarka','247120',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82654,252,'Qutubpur','247232',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82655,252,'Qutubshei','247001',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82656,252,'Raipur','247232',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82657,252,'Raipur','247121',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82658,252,'Rampur (Saharanpur)','247451',1,0,'2022-03-03 13:06:55','2022-03-03 13:06:55'),(82659,252,'Randeva','247340',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82660,252,'Randheri','247340',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82661,252,'Randol','247120',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82662,252,'Rangail','247341',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82663,252,'Rani Bazar','247001',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82664,252,'Raniyala Dayalpur','247340',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82665,252,'Rankhandi','247554',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82666,252,'Rehri Tajpur','247120',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82667,252,'Ruhalki','247121',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82668,252,'S.Hariya','247001',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82669,252,'Sabdalpur','247001',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82670,252,'Sadak Dudhli','247001',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82671,252,'Sadholi Quadeem','247121',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82672,252,'Saharanpur City','247001',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82673,252,'Saharanpur H.O','247001',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82674,252,'Saharanpur Kutchery','247001',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82675,252,'Sakhan Khurd','247554',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82676,252,'Salempur Bhukheri','247001',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82677,252,'Salhapur','247342',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82678,252,'Samaspur Naugaon','247121',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82679,252,'Sanpla Khatri','247554',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82680,252,'Sansarpur','247129',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82681,252,'Saraswati Nagar','247554',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82682,252,'Sarsawa','247232',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82683,252,'Sarsina','247554',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82684,252,'Shahjahanpur','247232',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82685,252,'Shekhpura Qudeem','247001',1,0,'2022-03-03 13:06:56','2022-03-03 13:06:56'),(82686,252,'Sherpur','247451',1,0,'2022-03-03 13:06:57','2022-03-03 13:06:57'),(82687,252,'Sherpur Khanazadpur','247662',1,0,'2022-03-03 13:06:57','2022-03-03 13:06:57'),(82688,252,'Shimlana','247453',1,0,'2022-03-03 13:06:57','2022-03-03 13:06:57'),(82689,252,'Simbhalki Gujjar','247662',1,0,'2022-03-03 13:06:57','2022-03-03 13:06:57'),(82690,252,'Sirsaka','247342',1,0,'2022-03-03 13:06:57','2022-03-03 13:06:57'),(82691,252,'Sona Arjunpur','247451',1,0,'2022-03-03 13:06:57','2022-03-03 13:06:57'),(82692,252,'Sorana','247232',1,0,'2022-03-03 13:06:57','2022-03-03 13:06:57'),(82693,252,'Sugar Mill',' Sarsawa',1,0,'2022-03-03 13:06:57','2022-03-03 13:06:57'),(82694,252,'Sunheti Kharkhari','247001',1,0,'2022-03-03 13:06:57','2022-03-03 13:06:57'),(82695,252,'Tabur','247342',1,0,'2022-03-03 13:06:57','2022-03-03 13:06:57'),(82696,252,'Talhapur','247129',1,0,'2022-03-03 13:06:57','2022-03-03 13:06:57'),(82697,252,'Talheri Buzurg','247554',1,0,'2022-03-03 13:06:57','2022-03-03 13:06:57'),(82698,252,'Tanko Sunderpur','247662',1,0,'2022-03-03 13:06:57','2022-03-03 13:06:57'),(82699,252,'Tansipur','247551',1,0,'2022-03-03 13:06:57','2022-03-03 13:06:57'),(82700,252,'Telipura','247232',1,0,'2022-03-03 13:06:57','2022-03-03 13:06:57'),(82701,252,'Thaska','247453',1,0,'2022-03-03 13:06:57','2022-03-03 13:06:57'),(82702,252,'Tikrol','247452',1,0,'2022-03-03 13:06:57','2022-03-03 13:06:57'),(82703,252,'Titron','247343',1,0,'2022-03-03 13:06:58','2022-03-03 13:06:58'),(82704,252,'Tiwaya','247001',1,0,'2022-03-03 13:06:58','2022-03-03 13:06:58'),(82705,252,'Toderpur','247231',1,0,'2022-03-03 13:06:58','2022-03-03 13:06:58'),(82706,252,'Topri','247120',1,0,'2022-03-03 13:06:58','2022-03-03 13:06:58'),(82707,252,'Umahikalan','247451',1,0,'2022-03-03 13:06:58','2022-03-03 13:06:58'),(82708,252,'Umrikalan','247451',1,0,'2022-03-03 13:06:58','2022-03-03 13:06:58'),(82709,252,'Unali','247001',1,0,'2022-03-03 13:06:58','2022-03-03 13:06:58'),(82710,252,'Veer Nagar','247001',1,0,'2022-03-03 13:06:58','2022-03-03 13:06:58'),(82711,252,'Majhaul','247665',1,0,'2022-03-03 13:06:58','2022-03-03 13:06:58'),(82712,253,'Ahra','272170',1,0,'2022-03-03 13:06:58','2022-03-03 13:06:58'),(82713,253,'Asharfa Bad','272173',1,0,'2022-03-03 13:06:58','2022-03-03 13:06:58'),(82714,253,'Ashraf Pur','272162',1,0,'2022-03-03 13:06:58','2022-03-03 13:06:58'),(82715,253,'Auradand','272165',1,0,'2022-03-03 13:06:58','2022-03-03 13:06:58'),(82716,253,'Babhni Misra','272126',1,0,'2022-03-03 13:06:58','2022-03-03 13:06:58'),(82717,253,'Bakhira','272199',1,0,'2022-03-03 13:06:58','2022-03-03 13:06:58'),(82718,253,'Banethu','272152',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82719,253,'Bania Bari','272175',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82720,253,'Barhya','272271',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82721,253,'Baridiha','272165',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82722,253,'Barparwa','272165',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82723,253,'Baur Byas','272199',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82724,253,'Belauli','272271',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82725,253,'Belduha','272164',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82726,253,'Belhar Kala','272270',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82727,253,'Belhasa','272199',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82728,253,'Bhagata','272164',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82729,253,'Bhagausa','272126',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82730,253,'Bhagwanpur','272199',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82731,253,'Bhainsahi','272176',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82732,253,'Bhainsamafi','272270',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82733,253,'Bharwal Parvata','272165',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82734,253,'Bhatauli','272271',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82735,253,'Bhataura','272270',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82736,253,'Bhitia Kala','272271',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82737,253,'Bhitiya','272126',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82738,253,'Bhujaini','272175',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82739,253,'Bhuwandand','272170',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82740,253,'Bisauwa','272271',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82741,253,'Budhakala','272170',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82742,253,'Chaikala','272170',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82743,253,'Chakdahi','272175',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82744,253,'Chandrahar','272164',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82745,253,'Changera Mangera','272170',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82746,253,'Chaparaghat','272162',1,0,'2022-03-03 13:06:59','2022-03-03 13:06:59'),(82747,253,'Chapra Magarvi','272162',1,0,'2022-03-03 13:07:00','2022-03-03 13:07:00'),(82748,253,'Chhata','272125',1,0,'2022-03-03 13:07:00','2022-03-03 13:07:00'),(82749,253,'Chhitahi','272172',1,0,'2022-03-03 13:07:00','2022-03-03 13:07:00'),(82750,253,'Chiraiha','272148',1,0,'2022-03-03 13:07:00','2022-03-03 13:07:00'),(82751,253,'Daridiha','272170',1,0,'2022-03-03 13:07:00','2022-03-03 13:07:00'),(82752,253,'Deegha','272175',1,0,'2022-03-03 13:07:00','2022-03-03 13:07:00'),(82753,253,'Deokali','272152',1,0,'2022-03-03 13:07:00','2022-03-03 13:07:00'),(82754,253,'Deokali Kala','272176',1,0,'2022-03-03 13:07:00','2022-03-03 13:07:00'),(82755,253,'Devapar','272164',1,0,'2022-03-03 13:07:00','2022-03-03 13:07:00'),(82756,253,'Devri','272165',1,0,'2022-03-03 13:07:00','2022-03-03 13:07:00'),(82757,253,'Dhamaicha','272175',1,0,'2022-03-03 13:07:00','2022-03-03 13:07:00'),(82758,253,'Dhanghata','272162',1,0,'2022-03-03 13:07:00','2022-03-03 13:07:00'),(82759,253,'Dhanjwsal','272164',1,0,'2022-03-03 13:07:00','2022-03-03 13:07:00'),(82760,253,'Dharamsinghwa','272154',1,0,'2022-03-03 13:07:00','2022-03-03 13:07:00'),(82761,253,'Dhaurepar','272176',1,0,'2022-03-03 13:07:00','2022-03-03 13:07:00'),(82762,253,'Dhobbhara','272176',1,0,'2022-03-03 13:07:01','2022-03-03 13:07:01'),(82763,253,'Dihwa','272162',1,0,'2022-03-03 13:07:01','2022-03-03 13:07:01'),(82764,253,'Ekma','272175',1,0,'2022-03-03 13:07:01','2022-03-03 13:07:01'),(82765,253,'Gagnai Rao','272271',1,0,'2022-03-03 13:07:01','2022-03-03 13:07:01'),(82766,253,'Gaighat','272176',1,0,'2022-03-03 13:07:01','2022-03-03 13:07:01'),(82767,253,'Gandhigram','272175',1,0,'2022-03-03 13:07:01','2022-03-03 13:07:01'),(82768,253,'Gangauli','272175',1,0,'2022-03-03 13:07:01','2022-03-03 13:07:01'),(82769,253,'Ganpatganj (Sant Kabir Nagar)','272176',1,0,'2022-03-03 13:07:01','2022-03-03 13:07:01'),(82770,253,'Ghatramha','272175',1,0,'2022-03-03 13:07:01','2022-03-03 13:07:01'),(82771,253,'Ghenchuwa','272199',1,0,'2022-03-03 13:07:01','2022-03-03 13:07:01'),(82772,253,'Ghorang','272165',1,0,'2022-03-03 13:07:01','2022-03-03 13:07:01'),(82773,253,'Ghurapali','272271',1,0,'2022-03-03 13:07:01','2022-03-03 13:07:01'),(82774,253,'Girdhar Pur','272173',1,0,'2022-03-03 13:07:01','2022-03-03 13:07:01'),(82775,253,'Gopalpur','272152',1,0,'2022-03-03 13:07:01','2022-03-03 13:07:01'),(82776,253,'Gorhi','272175',1,0,'2022-03-03 13:07:01','2022-03-03 13:07:01'),(82777,253,'Govind Ganj','272162',1,0,'2022-03-03 13:07:01','2022-03-03 13:07:01'),(82778,253,'Govindpur','272164',1,0,'2022-03-03 13:07:01','2022-03-03 13:07:01'),(82779,253,'Gulariha','272271',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82780,253,'Hainsar Bazar','272165',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82781,253,'Hariharpur','272164',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82782,253,'Hatwa','272125',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82783,253,'Jamohara','272271',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82784,253,'Jaswal','272271',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82785,253,'Jigina','272165',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82786,253,'Kaitholia','272148',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82787,253,'Kali Jagdishpur','272176',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82788,253,'Karma Kalan','272270',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82789,253,'Karmaini','272271',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82790,253,'Katarsoyam','272165',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82791,253,'Kauwathore','272271',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82792,253,'Khajuri','272154',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82793,253,'Khalilabad Bus Stand','272175',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82794,253,'Khalilabad','272175',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82795,253,'Koni','272175',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82796,253,'Kopia','272199',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82797,253,'Kotia Urf Sekhui','272270',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82798,253,'Kudwa','272271',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82799,253,'Kurthia','272170',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82800,253,'Lahuradeva','272175',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82801,253,'Loharsan','272270',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82802,253,'Lutuhi','272172',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82803,253,'Madhopur','272175',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82804,253,'Madhopur','272162',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82805,253,'Maghar','272173',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82806,253,'Mahobara','272176',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82807,253,'Mahuli (Sant Kabir Nagar)','272172',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82808,253,'Malauli','272165',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82809,253,'Manaitapur','272148',1,0,'2022-03-03 13:07:02','2022-03-03 13:07:02'),(82810,253,'Marpauna','272162',1,0,'2022-03-03 13:07:03','2022-03-03 13:07:03'),(82811,253,'Meerganj','272175',1,0,'2022-03-03 13:07:03','2022-03-03 13:07:03'),(82812,253,'Menhdawal','272271',1,0,'2022-03-03 13:07:03','2022-03-03 13:07:03'),(82813,253,'Menhdupar','272154',1,0,'2022-03-03 13:07:03','2022-03-03 13:07:03'),(82814,253,'Misraulia','272175',1,0,'2022-03-03 13:07:03','2022-03-03 13:07:03'),(82815,253,'Molnapur','272164',1,0,'2022-03-03 13:07:03','2022-03-03 13:07:03'),(82816,253,'Mukhlishpur','272176',1,0,'2022-03-03 13:07:03','2022-03-03 13:07:03'),(82817,253,'Mundera Shukul','272165',1,0,'2022-03-03 13:07:03','2022-03-03 13:07:03'),(82818,253,'Mushahara','272154',1,0,'2022-03-03 13:07:03','2022-03-03 13:07:03'),(82819,253,'Nandaur','272199',1,0,'2022-03-03 13:07:03','2022-03-03 13:07:03'),(82820,253,'Narayanpur','272270',1,0,'2022-03-03 13:07:03','2022-03-03 13:07:03'),(82821,253,'Naugo','272271',1,0,'2022-03-03 13:07:03','2022-03-03 13:07:03'),(82822,253,'Nukta','272176',1,0,'2022-03-03 13:07:03','2022-03-03 13:07:03'),(82823,253,'Onia','272176',1,0,'2022-03-03 13:07:03','2022-03-03 13:07:03'),(82824,253,'Pachneori','272271',1,0,'2022-03-03 13:07:03','2022-03-03 13:07:03'),(82825,253,'Pachpokhari','272125',1,0,'2022-03-03 13:07:03','2022-03-03 13:07:03'),(82826,253,'Padaria','272173',1,0,'2022-03-03 13:07:03','2022-03-03 13:07:03'),(82827,253,'Pakaria','272199',1,0,'2022-03-03 13:07:03','2022-03-03 13:07:03'),(82828,253,'Pakhuwapar','272175',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82829,253,'Pasai','272152',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82830,253,'Pauli','272162',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82831,253,'Pindia Bazar','272176',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82832,253,'Pipra Pratham','272148',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82833,253,'Popaya','272164',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82834,253,'Rajapur Sarraiya','272170',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82835,253,'Rajediha Bazar','272152',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82836,253,'Rajnauli','272165',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82837,253,'Rampur Barakoni','272162',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82838,253,'Ramwapur','272199',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82839,253,'Rasula Bad','272173',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82840,253,'Revta','272176',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82841,253,'Rosaya Bazar','272162',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82842,253,'Sai Buzurg','272199',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82843,253,'Sallepur','272170',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82844,253,'Samdaha','272175',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82845,253,'Sanichara Bazar','272162',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82846,253,'Santha','272270',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82847,253,'Santoshpur','272199',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82848,253,'Semardadi','272162',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82849,253,'Shivapar','272162',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82850,253,'Shivapar','272175',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82851,253,'Sikari','272175',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82852,253,'Siktaha','272172',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82853,253,'Sirsi','272165',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82854,253,'Siswania','272172',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82855,253,'Sitikar','272199',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82856,253,'Sugapankhi','272175',1,0,'2022-03-03 13:07:04','2022-03-03 13:07:04'),(82857,253,'Sxande Khurd','272271',1,0,'2022-03-03 13:07:05','2022-03-03 13:07:05'),(82858,253,'T.N.Deoria','272175',1,0,'2022-03-03 13:07:05','2022-03-03 13:07:05'),(82859,253,'Takiya','272162',1,0,'2022-03-03 13:07:05','2022-03-03 13:07:05'),(82860,253,'Tama','272165',1,0,'2022-03-03 13:07:05','2022-03-03 13:07:05'),(82861,253,'Tama','272175',1,0,'2022-03-03 13:07:05','2022-03-03 13:07:05'),(82862,253,'Tamakhas','272164',1,0,'2022-03-03 13:07:05','2022-03-03 13:07:05'),(82863,253,'Tanda','272165',1,0,'2022-03-03 13:07:05','2022-03-03 13:07:05'),(82864,253,'Taraini','272164',1,0,'2022-03-03 13:07:05','2022-03-03 13:07:05'),(82865,253,'Taryapar','272172',1,0,'2022-03-03 13:07:05','2022-03-03 13:07:05'),(82866,253,'Tighra','272165',1,0,'2022-03-03 13:07:05','2022-03-03 13:07:05'),(82867,253,'Tumpar','272164',1,0,'2022-03-03 13:07:05','2022-03-03 13:07:05'),(82868,253,'Umari Kalan','272175',1,0,'2022-03-03 13:07:05','2022-03-03 13:07:05'),(82869,253,'Umariya Bazar','272162',1,0,'2022-03-03 13:07:05','2022-03-03 13:07:05'),(82870,253,'Umariya Pandey','272162',1,0,'2022-03-03 13:07:05','2022-03-03 13:07:05'),(82871,253,'Unchahara Kala','272170',1,0,'2022-03-03 13:07:05','2022-03-03 13:07:05'),(82872,253,'Utrawal','272175',1,0,'2022-03-03 13:07:05','2022-03-03 13:07:05'),(82873,253,'Vishwanathpur','272164',1,0,'2022-03-03 13:07:05','2022-03-03 13:07:05'),(82874,254,'Abarana','221404',1,0,'2022-03-03 13:07:05','2022-03-03 13:07:05'),(82875,254,'Abhiya','221404',1,0,'2022-03-03 13:07:05','2022-03-03 13:07:05'),(82876,254,'Abholi','221404',1,0,'2022-03-03 13:07:05','2022-03-03 13:07:05'),(82877,254,'Achhawar','221304',1,0,'2022-03-03 13:07:05','2022-03-03 13:07:05'),(82878,254,'Ajaipur','221406',1,0,'2022-03-03 13:07:05','2022-03-03 13:07:05'),(82879,254,'Amawa Khurd','221402',1,0,'2022-03-03 13:07:05','2022-03-03 13:07:05'),(82880,254,'Amilaur','221303',1,0,'2022-03-03 13:07:05','2022-03-03 13:07:05'),(82881,254,'Amilauri','221406',1,0,'2022-03-03 13:07:05','2022-03-03 13:07:05'),(82882,254,'Asanao Bazar','221401',1,0,'2022-03-03 13:07:05','2022-03-03 13:07:05'),(82883,254,'Aurai (Sant Ravidas Nagar)','221301',1,0,'2022-03-03 13:07:06','2022-03-03 13:07:06'),(82884,254,'Babusarai','221314',1,0,'2022-03-03 13:07:06','2022-03-03 13:07:06'),(82885,254,'Bahari','221402',1,0,'2022-03-03 13:07:06','2022-03-03 13:07:06'),(82886,254,'Bairibisa','221303',1,0,'2022-03-03 13:07:06','2022-03-03 13:07:06'),(82887,254,'Baragaon','221310',1,0,'2022-03-03 13:07:06','2022-03-03 13:07:06'),(82888,254,'Baripur','221309',1,0,'2022-03-03 13:07:06','2022-03-03 13:07:06'),(82889,254,'Bauribojh','221404',1,0,'2022-03-03 13:07:06','2022-03-03 13:07:06'),(82890,254,'Bayaon','221308',1,0,'2022-03-03 13:07:06','2022-03-03 13:07:06'),(82891,254,'Berawa Paharpur','221309',1,0,'2022-03-03 13:07:06','2022-03-03 13:07:06'),(82892,254,'Bhadohi','221401',1,0,'2022-03-03 13:07:06','2022-03-03 13:07:06'),(82893,254,'Bhagawanpur Kanhari','221402',1,0,'2022-03-03 13:07:06','2022-03-03 13:07:06'),(82894,254,'Bhanda','221404',1,0,'2022-03-03 13:07:06','2022-03-03 13:07:06'),(82895,254,'Bhawanipur','221303',1,0,'2022-03-03 13:07:06','2022-03-03 13:07:06'),(82896,254,'Bhikharirampur','221404',1,0,'2022-03-03 13:07:06','2022-03-03 13:07:06'),(82897,254,'Bhori','221404',1,0,'2022-03-03 13:07:06','2022-03-03 13:07:06'),(82898,254,'Bichhiya','221308',1,0,'2022-03-03 13:07:06','2022-03-03 13:07:06'),(82899,254,'Birampur','221308',1,0,'2022-03-03 13:07:06','2022-03-03 13:07:06'),(82900,254,'Bisauli Kripalpur','221404',1,0,'2022-03-03 13:07:06','2022-03-03 13:07:06'),(82901,254,'Chakkisundas','221304',1,0,'2022-03-03 13:07:06','2022-03-03 13:07:06'),(82902,254,'Chaksundarpur','221304',1,0,'2022-03-03 13:07:06','2022-03-03 13:07:06'),(82903,254,'Chhechhuwan','221309',1,0,'2022-03-03 13:07:07','2022-03-03 13:07:07'),(82904,254,'Darawasi','221310',1,0,'2022-03-03 13:07:07','2022-03-03 13:07:07'),(82905,254,'Darunaha','221402',1,0,'2022-03-03 13:07:07','2022-03-03 13:07:07'),(82906,254,'Dasharthpur','221304',1,0,'2022-03-03 13:07:07','2022-03-03 13:07:07'),(82907,254,'Dhantulsi','221309',1,0,'2022-03-03 13:07:07','2022-03-03 13:07:07'),(82908,254,'Dhirpur','221303',1,0,'2022-03-03 13:07:07','2022-03-03 13:07:07'),(82909,254,'Digh','221309',1,0,'2022-03-03 13:07:07','2022-03-03 13:07:07'),(82910,254,'Domanpur','221402',1,0,'2022-03-03 13:07:07','2022-03-03 13:07:07'),(82911,254,'Durgaganj','221404',1,0,'2022-03-03 13:07:07','2022-03-03 13:07:07'),(82912,254,'Dwarikapur','221314',1,0,'2022-03-03 13:07:07','2022-03-03 13:07:07'),(82913,254,'Ekauni','221404',1,0,'2022-03-03 13:07:07','2022-03-03 13:07:07'),(82914,254,'Gaura','221404',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82915,254,'Ghosiya','221301',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82916,254,'Girdbaragaon','221314',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82917,254,'Gohilaon','221402',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82918,254,'Gopiganj','221303',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82919,254,'Gyanpur','221304',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82920,254,'Hridaipur','221301',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82921,254,'Ibrhimpur Uparwar','221310',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82922,254,'Ithara','221309',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82923,254,'Jagannathpur','221303',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82924,254,'Jangiganj','221310',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82925,254,'Jhauwa','221402',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82926,254,'Kador','221404',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82927,254,'Kariyaon','221406',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82928,254,'Katra Bazar','221309',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82929,254,'Koilara','221306',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82930,254,'Koirauna','221309',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82931,254,'Kukarauthi','221409',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82932,254,'Kurauna','221301',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82933,254,'Laxamanpatti','221304',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82934,254,'Loharakhas','221303',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82935,254,'Mahrajganj (Sant Ravidas Nagar)','221314',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82936,254,'Matethu','221404',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82937,254,'Mondh','221406',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82938,254,'Munsiladpur','221401',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82939,254,'Nai Bazar (Sant Ravidas Nagar)','221409',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82940,254,'Narepar Sitamarhi','221309',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82941,254,'Nathaipur','221304',1,0,'2022-03-03 13:07:08','2022-03-03 13:07:08'),(82942,254,'Ozh','221308',1,0,'2022-03-03 13:07:09','2022-03-03 13:07:09'),(82943,254,'Palhaiya','221402',1,0,'2022-03-03 13:07:09','2022-03-03 13:07:09'),(82944,254,'Pali','221304',1,0,'2022-03-03 13:07:09','2022-03-03 13:07:09'),(82945,254,'Pargaspur','221409',1,0,'2022-03-03 13:07:09','2022-03-03 13:07:09'),(82946,254,'Parsipur','221402',1,0,'2022-03-03 13:07:09','2022-03-03 13:07:09'),(82947,254,'Patti Bejaon','221404',1,0,'2022-03-03 13:07:09','2022-03-03 13:07:09'),(82948,254,'Pipargaon','221301',1,0,'2022-03-03 13:07:09','2022-03-03 13:07:09'),(82949,254,'Pipris','221401',1,0,'2022-03-03 13:07:09','2022-03-03 13:07:09'),(82950,254,'Purani Bazar','221406',1,0,'2022-03-03 13:07:09','2022-03-03 13:07:09'),(82951,254,'Puregareria','221406',1,0,'2022-03-03 13:07:09','2022-03-03 13:07:09'),(82952,254,'R.S. Dham','221303',1,0,'2022-03-03 13:07:09','2022-03-03 13:07:09'),(82953,254,'Ramampur','221304',1,0,'2022-03-03 13:07:09','2022-03-03 13:07:09'),(82954,254,'Raya','221401',1,0,'2022-03-03 13:07:09','2022-03-03 13:07:09'),(82955,254,'Rohi','221308',1,0,'2022-03-03 13:07:09','2022-03-03 13:07:09'),(82956,254,'Sagarraipur','221310',1,0,'2022-03-03 13:07:09','2022-03-03 13:07:09'),(82957,254,'Sahasepur','221306',1,0,'2022-03-03 13:07:09','2022-03-03 13:07:09'),(82958,254,'Sanda','221404',1,0,'2022-03-03 13:07:09','2022-03-03 13:07:09'),(82959,254,'Sarai Kansrai','221404',1,0,'2022-03-03 13:07:09','2022-03-03 13:07:09'),(82960,254,'Sarawatkhani','221314',1,0,'2022-03-03 13:07:09','2022-03-03 13:07:09'),(82961,254,'Saripur','221314',1,0,'2022-03-03 13:07:09','2022-03-03 13:07:09'),(82962,254,'Sarroi','221401',1,0,'2022-03-03 13:07:09','2022-03-03 13:07:09'),(82963,254,'Semradh','221310',1,0,'2022-03-03 13:07:09','2022-03-03 13:07:09'),(82964,254,'Sudhwai','221308',1,0,'2022-03-03 13:07:10','2022-03-03 13:07:10'),(82965,254,'Suriyawan','221404',1,0,'2022-03-03 13:07:10','2022-03-03 13:07:10'),(82966,254,'Suryabhanpur','221310',1,0,'2022-03-03 13:07:10','2022-03-03 13:07:10'),(82967,254,'Tilanga','221303',1,0,'2022-03-03 13:07:10','2022-03-03 13:07:10'),(82968,254,'Uchetha','221401',1,0,'2022-03-03 13:07:10','2022-03-03 13:07:10'),(82969,254,'Ugapur','221301',1,0,'2022-03-03 13:07:10','2022-03-03 13:07:10'),(82970,254,'Umarha','221314',1,0,'2022-03-03 13:07:10','2022-03-03 13:07:10'),(82971,255,'A C Factory','242001',1,0,'2022-03-03 13:07:10','2022-03-03 13:07:10'),(82972,255,'Agonasujanpur','242401',1,0,'2022-03-03 13:07:10','2022-03-03 13:07:10'),(82973,255,'Akbaria','242305',1,0,'2022-03-03 13:07:10','2022-03-03 13:07:10'),(82974,255,'Allaganj','242220',1,0,'2022-03-03 13:07:10','2022-03-03 13:07:10'),(82975,255,'Alldadpur Baihari','242221',1,0,'2022-03-03 13:07:10','2022-03-03 13:07:10'),(82976,255,'Amora','242223',1,0,'2022-03-03 13:07:10','2022-03-03 13:07:10'),(82977,255,'Anawa','242401',1,0,'2022-03-03 13:07:10','2022-03-03 13:07:10'),(82978,255,'Andkhera','242407',1,0,'2022-03-03 13:07:10','2022-03-03 13:07:10'),(82979,255,'Areli','242407',1,0,'2022-03-03 13:07:10','2022-03-03 13:07:10'),(82980,255,'Ashrafpur','242220',1,0,'2022-03-03 13:07:10','2022-03-03 13:07:10'),(82981,255,'Astoli','242127',1,0,'2022-03-03 13:07:10','2022-03-03 13:07:10'),(82982,255,'Audapur','242223',1,0,'2022-03-03 13:07:10','2022-03-03 13:07:10'),(82983,255,'Awa','242303',1,0,'2022-03-03 13:07:10','2022-03-03 13:07:10'),(82984,255,'Ayun','242401',1,0,'2022-03-03 13:07:10','2022-03-03 13:07:10'),(82985,255,'Azizganj','242226',1,0,'2022-03-03 13:07:10','2022-03-03 13:07:10'),(82986,255,'Azizpur','242407',1,0,'2022-03-03 13:07:10','2022-03-03 13:07:10'),(82987,255,'Azmatpur','242042',1,0,'2022-03-03 13:07:10','2022-03-03 13:07:10'),(82988,255,'Babakkarpur','242223',1,0,'2022-03-03 13:07:10','2022-03-03 13:07:10'),(82989,255,'Badshahnagar','242406',1,0,'2022-03-03 13:07:11','2022-03-03 13:07:11'),(82990,255,'Bahaduganj','242001',1,0,'2022-03-03 13:07:11','2022-03-03 13:07:11'),(82991,255,'Bahanderi','242407',1,0,'2022-03-03 13:07:11','2022-03-03 13:07:11'),(82992,255,'Baharia','242221',1,0,'2022-03-03 13:07:11','2022-03-03 13:07:11'),(82993,255,'Baisaribaisra','242301',1,0,'2022-03-03 13:07:11','2022-03-03 13:07:11'),(82994,255,'Bamhora','242127',1,0,'2022-03-03 13:07:11','2022-03-03 13:07:11'),(82995,255,'Banda (Shahjahanpur)','242042',1,0,'2022-03-03 13:07:11','2022-03-03 13:07:11'),(82996,255,'Bangaon','242221',1,0,'2022-03-03 13:07:11','2022-03-03 13:07:11'),(82997,255,'Bankagaon','242306',1,0,'2022-03-03 13:07:11','2022-03-03 13:07:11'),(82998,255,'Banthara','242307',1,0,'2022-03-03 13:07:11','2022-03-03 13:07:11'),(82999,255,'Banuzai','242001',1,0,'2022-03-03 13:07:11','2022-03-03 13:07:11'),(83000,255,'Baragaon','242401',1,0,'2022-03-03 13:07:11','2022-03-03 13:07:11'),(83001,255,'Barakalan','242127',1,0,'2022-03-03 13:07:11','2022-03-03 13:07:11'),(83002,255,'Barenda','242223',1,0,'2022-03-03 13:07:11','2022-03-03 13:07:11'),(83003,255,'Barkherajaipal','242301',1,0,'2022-03-03 13:07:11','2022-03-03 13:07:11'),(83004,255,'Barriprasidhpur','242303',1,0,'2022-03-03 13:07:11','2022-03-03 13:07:11'),(83005,255,'Bartara','242306',1,0,'2022-03-03 13:07:11','2022-03-03 13:07:11'),(83006,255,'Barua','242221',1,0,'2022-03-03 13:07:11','2022-03-03 13:07:11'),(83007,255,'Basulia','242001',1,0,'2022-03-03 13:07:11','2022-03-03 13:07:11'),(83008,255,'Batlaiya','242301',1,0,'2022-03-03 13:07:11','2022-03-03 13:07:11'),(83009,255,'Bauri','242301',1,0,'2022-03-03 13:07:11','2022-03-03 13:07:11'),(83010,255,'Behta Jangal','242127',1,0,'2022-03-03 13:07:11','2022-03-03 13:07:11'),(83011,255,'Behtasambad','242401',1,0,'2022-03-03 13:07:11','2022-03-03 13:07:11'),(83012,255,'Bhainsi','242223',1,0,'2022-03-03 13:07:11','2022-03-03 13:07:11'),(83013,255,'Bhambi','242042',1,0,'2022-03-03 13:07:11','2022-03-03 13:07:11'),(83014,255,'Bhanpura','242303',1,0,'2022-03-03 13:07:12','2022-03-03 13:07:12'),(83015,255,'Bharribasantpur','242407',1,0,'2022-03-03 13:07:12','2022-03-03 13:07:12'),(83016,255,'Bhatpurarasulpur','242306',1,0,'2022-03-03 13:07:12','2022-03-03 13:07:12'),(83017,255,'Bhaunti','242221',1,0,'2022-03-03 13:07:12','2022-03-03 13:07:12'),(83018,255,'Bhawalkhera','242306',1,0,'2022-03-03 13:07:12','2022-03-03 13:07:12'),(83019,255,'Bhundeli','242127',1,0,'2022-03-03 13:07:12','2022-03-03 13:07:12'),(83020,255,'Bikrampur','242127',1,0,'2022-03-03 13:07:12','2022-03-03 13:07:12'),(83021,255,'Bikrampurchakora','242407',1,0,'2022-03-03 13:07:12','2022-03-03 13:07:12'),(83022,255,'Bilandpurgaddipur','242407',1,0,'2022-03-03 13:07:12','2022-03-03 13:07:12'),(83023,255,'Bilhari','242307',1,0,'2022-03-03 13:07:12','2022-03-03 13:07:12'),(83024,255,'Bilsandibuzurg','242401',1,0,'2022-03-03 13:07:12','2022-03-03 13:07:12'),(83025,255,'Birsinghpur','242307',1,0,'2022-03-03 13:07:12','2022-03-03 13:07:12'),(83026,255,'Budhwana','242301',1,0,'2022-03-03 13:07:12','2022-03-03 13:07:12'),(83027,255,'Burhaura','242221',1,0,'2022-03-03 13:07:12','2022-03-03 13:07:12'),(83028,255,'Ch Bahadupur','242221',1,0,'2022-03-03 13:07:12','2022-03-03 13:07:12'),(83029,255,'Ch Sahabganj','242221',1,0,'2022-03-03 13:07:12','2022-03-03 13:07:12'),(83030,255,'Chak Kanahu','242001',1,0,'2022-03-03 13:07:12','2022-03-03 13:07:12'),(83031,255,'Chandapur','242406',1,0,'2022-03-03 13:07:12','2022-03-03 13:07:12'),(83032,255,'Chandeura','242407',1,0,'2022-03-03 13:07:13','2022-03-03 13:07:13'),(83033,255,'Chandpur','242123',1,0,'2022-03-03 13:07:13','2022-03-03 13:07:13'),(83034,255,'Chankhanbayi','242001',1,0,'2022-03-03 13:07:13','2022-03-03 13:07:13'),(83035,255,'Charkhaula','242305',1,0,'2022-03-03 13:07:13','2022-03-03 13:07:13'),(83036,255,'Chauhanapur','242406',1,0,'2022-03-03 13:07:13','2022-03-03 13:07:13'),(83037,255,'Chauhatia','242307',1,0,'2022-03-03 13:07:13','2022-03-03 13:07:13'),(83038,255,'Chaurabagerkhet','242127',1,0,'2022-03-03 13:07:13','2022-03-03 13:07:13'),(83039,255,'Chaurasia','242220',1,0,'2022-03-03 13:07:13','2022-03-03 13:07:13'),(83040,255,'Chhetepur','242306',1,0,'2022-03-03 13:07:13','2022-03-03 13:07:13'),(83041,255,'Chilaua','242220',1,0,'2022-03-03 13:07:13','2022-03-03 13:07:13'),(83042,255,'Conewganj','242001',1,0,'2022-03-03 13:07:13','2022-03-03 13:07:13'),(83043,255,'D Ghanshyam','242042',1,0,'2022-03-03 13:07:13','2022-03-03 13:07:13'),(83044,255,'D P J Pur','242042',1,0,'2022-03-03 13:07:13','2022-03-03 13:07:13'),(83045,255,'Dabhora','242307',1,0,'2022-03-03 13:07:13','2022-03-03 13:07:13'),(83046,255,'Dadraul','242226',1,0,'2022-03-03 13:07:13','2022-03-03 13:07:13'),(83047,255,'Dahelia','242127',1,0,'2022-03-03 13:07:13','2022-03-03 13:07:13'),(83048,255,'Dalelganj','242001',1,0,'2022-03-03 13:07:13','2022-03-03 13:07:13'),(83049,255,'Dasia','242127',1,0,'2022-03-03 13:07:13','2022-03-03 13:07:13'),(83050,255,'Deoria','242407',1,0,'2022-03-03 13:07:13','2022-03-03 13:07:13'),(83051,255,'Deoriajhala','242223',1,0,'2022-03-03 13:07:13','2022-03-03 13:07:13'),(83052,255,'Devkali','242042',1,0,'2022-03-03 13:07:13','2022-03-03 13:07:13'),(83053,255,'Dhakiaragha','242307',1,0,'2022-03-03 13:07:13','2022-03-03 13:07:13'),(83054,255,'Dhakiatiwari','242407',1,0,'2022-03-03 13:07:13','2022-03-03 13:07:13'),(83055,255,'Dhaknalahia','242405',1,0,'2022-03-03 13:07:13','2022-03-03 13:07:13'),(83056,255,'Dhaneora','242307',1,0,'2022-03-03 13:07:13','2022-03-03 13:07:13'),(83057,255,'Dhiaria','242221',1,0,'2022-03-03 13:07:13','2022-03-03 13:07:13'),(83058,255,'Dilawarpur','242223',1,0,'2022-03-03 13:07:14','2022-03-03 13:07:14'),(83059,255,'Dudwa','242042',1,0,'2022-03-03 13:07:14','2022-03-03 13:07:14'),(83060,255,'Gandhar','242223',1,0,'2022-03-03 13:07:14','2022-03-03 13:07:14'),(83061,255,'Gandharpur','242401',1,0,'2022-03-03 13:07:14','2022-03-03 13:07:14'),(83062,255,'Gangsara','242401',1,0,'2022-03-03 13:07:14','2022-03-03 13:07:14'),(83063,255,'Ganpatpur','242407',1,0,'2022-03-03 13:07:14','2022-03-03 13:07:14'),(83064,255,'Garhiarangeen','242303',1,0,'2022-03-03 13:07:14','2022-03-03 13:07:14'),(83065,255,'Garrah Road','242001',1,0,'2022-03-03 13:07:14','2022-03-03 13:07:14'),(83066,255,'Ghantaghar','242001',1,0,'2022-03-03 13:07:14','2022-03-03 13:07:14'),(83067,255,'Ghusgawan','242001',1,0,'2022-03-03 13:07:14','2022-03-03 13:07:14'),(83068,255,'Gogeypur','242303',1,0,'2022-03-03 13:07:14','2022-03-03 13:07:14'),(83069,255,'Gopalpurthatheura','242307',1,0,'2022-03-03 13:07:14','2022-03-03 13:07:14'),(83070,255,'Gora Raipur','242001',1,0,'2022-03-03 13:07:14','2022-03-03 13:07:14'),(83071,255,'Goradhanenega','242123',1,0,'2022-03-03 13:07:14','2022-03-03 13:07:14'),(83072,255,'Govindpur','242303',1,0,'2022-03-03 13:07:14','2022-03-03 13:07:14'),(83073,255,'Gularia B Singh','242042',1,0,'2022-03-03 13:07:14','2022-03-03 13:07:14'),(83074,255,'Gularia','242221',1,0,'2022-03-03 13:07:14','2022-03-03 13:07:14'),(83075,255,'Gunara','242221',1,0,'2022-03-03 13:07:14','2022-03-03 13:07:14'),(83076,255,'Gundaura Daudpur','242127',1,0,'2022-03-03 13:07:14','2022-03-03 13:07:14'),(83077,255,'Gurri','242306',1,0,'2022-03-03 13:07:14','2022-03-03 13:07:14'),(83078,255,'Gurugram','242221',1,0,'2022-03-03 13:07:15','2022-03-03 13:07:15'),(83079,255,'H Road','242001',1,0,'2022-03-03 13:07:15','2022-03-03 13:07:15'),(83080,255,'Hadaf','242001',1,0,'2022-03-03 13:07:15','2022-03-03 13:07:15'),(83081,255,'Hariharpursimra','242305',1,0,'2022-03-03 13:07:15','2022-03-03 13:07:15'),(83082,255,'Haripur','242123',1,0,'2022-03-03 13:07:15','2022-03-03 13:07:15'),(83083,255,'Hasanpur','242305',1,0,'2022-03-03 13:07:15','2022-03-03 13:07:15'),(83084,255,'Hatgaon','242407',1,0,'2022-03-03 13:07:15','2022-03-03 13:07:15'),(83085,255,'Hathel','242223',1,0,'2022-03-03 13:07:15','2022-03-03 13:07:15'),(83086,255,'Hindu Pattil','242307',1,0,'2022-03-03 13:07:15','2022-03-03 13:07:15'),(83087,255,'Indeypur','242223',1,0,'2022-03-03 13:07:15','2022-03-03 13:07:15'),(83088,255,'Jaitipur','242301',1,0,'2022-03-03 13:07:15','2022-03-03 13:07:15'),(83089,255,'Jajal Nagar','242001',1,0,'2022-03-03 13:07:15','2022-03-03 13:07:15'),(83090,255,'Jakhia','242127',1,0,'2022-03-03 13:07:15','2022-03-03 13:07:15'),(83091,255,'Jalalabad Mandi','242221',1,0,'2022-03-03 13:07:15','2022-03-03 13:07:15'),(83092,255,'Jalalabad (Shahjahanpur)','242221',1,0,'2022-03-03 13:07:15','2022-03-03 13:07:15'),(83093,255,'Jalalpur','242305',1,0,'2022-03-03 13:07:15','2022-03-03 13:07:15'),(83094,255,'Jam Daulatpur','242221',1,0,'2022-03-03 13:07:15','2022-03-03 13:07:15'),(83095,255,'Jamaur','242226',1,0,'2022-03-03 13:07:15','2022-03-03 13:07:15'),(83096,255,'Jarharharipur','242301',1,0,'2022-03-03 13:07:15','2022-03-03 13:07:15'),(83097,255,'Jearrahimpur','242220',1,0,'2022-03-03 13:07:15','2022-03-03 13:07:15'),(83098,255,'Jeorabhoor','242301',1,0,'2022-03-03 13:07:15','2022-03-03 13:07:15'),(83099,255,'Jewan','242401',1,0,'2022-03-03 13:07:15','2022-03-03 13:07:15'),(83100,255,'Jiginia','242305',1,0,'2022-03-03 13:07:15','2022-03-03 13:07:15'),(83101,255,'Jitauria','242042',1,0,'2022-03-03 13:07:15','2022-03-03 13:07:15'),(83102,255,'Jograjpur','242123',1,0,'2022-03-03 13:07:16','2022-03-03 13:07:16'),(83103,255,'Jujharpur','242401',1,0,'2022-03-03 13:07:16','2022-03-03 13:07:16'),(83104,255,'Kahelia','242406',1,0,'2022-03-03 13:07:16','2022-03-03 13:07:16'),(83105,255,'Kajriniranjanpur','242405',1,0,'2022-03-03 13:07:16','2022-03-03 13:07:16'),(83106,255,'Kakrala','242221',1,0,'2022-03-03 13:07:16','2022-03-03 13:07:16'),(83107,255,'Kakraua','242301',1,0,'2022-03-03 13:07:16','2022-03-03 13:07:16'),(83108,255,'Kaluapur','242401',1,0,'2022-03-03 13:07:16','2022-03-03 13:07:16'),(83109,255,'Kamalnainpur','242223',1,0,'2022-03-03 13:07:16','2022-03-03 13:07:16'),(83110,255,'Kamlapur','242305',1,0,'2022-03-03 13:07:16','2022-03-03 13:07:16'),(83111,255,'Kaneng','242406',1,0,'2022-03-03 13:07:16','2022-03-03 13:07:16'),(83112,255,'Kanpara','242401',1,0,'2022-03-03 13:07:16','2022-03-03 13:07:16'),(83113,255,'Kant','242223',1,0,'2022-03-03 13:07:16','2022-03-03 13:07:16'),(83114,255,'Kateli Bmaua','242221',1,0,'2022-03-03 13:07:16','2022-03-03 13:07:16'),(83115,255,'Katia Tola','242001',1,0,'2022-03-03 13:07:16','2022-03-03 13:07:16'),(83116,255,'Keeeratpur','242001',1,0,'2022-03-03 13:07:16','2022-03-03 13:07:16'),(83117,255,'Khadhar','242221',1,0,'2022-03-03 13:07:16','2022-03-03 13:07:16'),(83118,255,'Khairpurmilkipur','242307',1,0,'2022-03-03 13:07:16','2022-03-03 13:07:16'),(83119,255,'Khajuri','242127',1,0,'2022-03-03 13:07:16','2022-03-03 13:07:16'),(83120,255,'Khamaria','242303',1,0,'2022-03-03 13:07:16','2022-03-03 13:07:16'),(83121,255,'Khandepur','242405',1,0,'2022-03-03 13:07:16','2022-03-03 13:07:16'),(83122,255,'Khera Bajhera','242303',1,0,'2022-03-03 13:07:16','2022-03-03 13:07:16'),(83123,255,'Kheramajhkhera','242305',1,0,'2022-03-03 13:07:16','2022-03-03 13:07:16'),(83124,255,'Khiria Rasoolpur','242001',1,0,'2022-03-03 13:07:16','2022-03-03 13:07:16'),(83125,255,'Khiriaheer','242406',1,0,'2022-03-03 13:07:17','2022-03-03 13:07:17'),(83126,255,'Khudaganj','242305',1,0,'2022-03-03 13:07:17','2022-03-03 13:07:17'),(83127,255,'Khutar','242405',1,0,'2022-03-03 13:07:17','2022-03-03 13:07:17'),(83128,255,'Kilapur','242127',1,0,'2022-03-03 13:07:17','2022-03-03 13:07:17'),(83129,255,'Korigawan','242305',1,0,'2022-03-03 13:07:17','2022-03-03 13:07:17'),(83130,255,'Korokuiyan','242401',1,0,'2022-03-03 13:07:17','2022-03-03 13:07:17'),(83131,255,'Kotakhas','242301',1,0,'2022-03-03 13:07:17','2022-03-03 13:07:17'),(83132,255,'Kotawari','242401',1,0,'2022-03-03 13:07:17','2022-03-03 13:07:17'),(83133,255,'Krishnanagar','242001',1,0,'2022-03-03 13:07:17','2022-03-03 13:07:17'),(83134,255,'Kudaiya','242301',1,0,'2022-03-03 13:07:17','2022-03-03 13:07:17'),(83135,255,'Kundaria','242127',1,0,'2022-03-03 13:07:17','2022-03-03 13:07:17'),(83136,255,'Kunderi','242127',1,0,'2022-03-03 13:07:17','2022-03-03 13:07:17'),(83137,255,'Kundramajra','242303',1,0,'2022-03-03 13:07:17','2022-03-03 13:07:17'),(83138,255,'Kundri','242301',1,0,'2022-03-03 13:07:17','2022-03-03 13:07:17'),(83139,255,'Kurriakalan','242223',1,0,'2022-03-03 13:07:17','2022-03-03 13:07:17'),(83140,255,'Kursanda','242306',1,0,'2022-03-03 13:07:17','2022-03-03 13:07:17'),(83141,255,'Ladhaula','242407',1,0,'2022-03-03 13:07:17','2022-03-03 13:07:17'),(83142,255,'Lakhnaur','242223',1,0,'2022-03-03 13:07:17','2022-03-03 13:07:17'),(83143,255,'Lalpur','242405',1,0,'2022-03-03 13:07:17','2022-03-03 13:07:17'),(83144,255,'Laxmanpur','242127',1,0,'2022-03-03 13:07:18','2022-03-03 13:07:18'),(83145,255,'Laxmipur','242305',1,0,'2022-03-03 13:07:18','2022-03-03 13:07:18'),(83146,255,'M Ashram','242226',1,0,'2022-03-03 13:07:18','2022-03-03 13:07:18'),(83147,255,'Madnapur','242301',1,0,'2022-03-03 13:07:18','2022-03-03 13:07:18'),(83148,255,'Madroli','242301',1,0,'2022-03-03 13:07:18','2022-03-03 13:07:18'),(83149,255,'Mahasir','242001',1,0,'2022-03-03 13:07:18','2022-03-03 13:07:18'),(83150,255,'Mahuagundey','242123',1,0,'2022-03-03 13:07:18','2022-03-03 13:07:18'),(83151,255,'Mahuichathia','242401',1,0,'2022-03-03 13:07:18','2022-03-03 13:07:18'),(83152,255,'Mai Khurd Kalan','242127',1,0,'2022-03-03 13:07:18','2022-03-03 13:07:18'),(83153,255,'Majila','242305',1,0,'2022-03-03 13:07:18','2022-03-03 13:07:18'),(83154,255,'Makrandpur','242221',1,0,'2022-03-03 13:07:18','2022-03-03 13:07:18'),(83155,255,'Maksoodapur','242042',1,0,'2022-03-03 13:07:18','2022-03-03 13:07:18'),(83156,255,'Malhpur','242223',1,0,'2022-03-03 13:07:18','2022-03-03 13:07:18'),(83157,255,'Malika','242405',1,0,'2022-03-03 13:07:18','2022-03-03 13:07:18'),(83158,255,'Malupur','242221',1,0,'2022-03-03 13:07:18','2022-03-03 13:07:18'),(83159,255,'Mangtora','242221',1,0,'2022-03-03 13:07:18','2022-03-03 13:07:18'),(83160,255,'Marena','242303',1,0,'2022-03-03 13:07:18','2022-03-03 13:07:18'),(83161,255,'Maujampur','242307',1,0,'2022-03-03 13:07:18','2022-03-03 13:07:18'),(83162,255,'Miranpur Katra','242301',1,0,'2022-03-03 13:07:18','2022-03-03 13:07:18'),(83163,255,'Mirzapur','242221',1,0,'2022-03-03 13:07:18','2022-03-03 13:07:18'),(83164,255,'Mohanganj','242001',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83165,255,'Mohdpurazmabad','242223',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83166,255,'Mohiuddinpur','242042',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83167,255,'Mp Mamarazpur','242223',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83168,255,'Mudia Pamar','242001',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83169,255,'Mudiakurmiyat','242401',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83170,255,'Mudigawan','242406',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83171,255,'Muradpur','242405',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83172,255,'Murchha','242001',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83173,255,'N G Mahsulpur','242221',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83174,255,'Nabhichi','242042',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83175,255,'Nahil','242401',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83176,255,'Narotha Hansram','242405',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83177,255,'Nawadabanki','242042',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83178,255,'Nawadrudrapur','242301',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83179,255,'Nigohi','242407',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83180,255,'Niyamatpur','242001',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83181,255,'Nizampur','242307',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83182,255,'Pach Deoria','242127',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83183,255,'Padrasikandarpur','242306',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83184,255,'Paina Buzurg','242001',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83185,255,'Palharai','242221',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83186,255,'Paliapatti','242301',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83187,255,'Paraincha','242223',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83188,255,'Paraur','242127',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83189,255,'Parsonakhalilpur','242407',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83190,255,'Parthipur Kuverpur','242127',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83191,255,'Pasgawan','242406',1,0,'2022-03-03 13:07:19','2022-03-03 13:07:19'),(83192,255,'Patna Devkali','242127',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83193,255,'Pehna','242221',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83194,255,'Pilhua','242127',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83195,255,'Pingri Pingra','242001',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83196,255,'Piprolaahmadpur','242223',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83197,255,'Piproli','242307',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83198,255,'Pirthvipurdhai','242221',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83199,255,'Powayan','242401',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83200,255,'Prasadpur','242405',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83201,255,'R B Kalan','242127',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83202,255,'Raghunathpur','242220',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83203,255,'Raikhera','242226',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83204,255,'Rajanpur','242307',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83205,255,'Ramapurbarkatpur','242306',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83206,255,'Rampurbasant','242407',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83207,255,'Ranmastpur','242042',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83208,255,'Rarua','242042',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83209,255,'Rati','242307',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83210,255,'Raura','242406',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83211,255,'Rautapur','242405',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83212,255,'Rawatpur','242223',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83213,255,'Rosa RS','242306',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83214,255,'Rosa','242406',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83215,255,'Rudrapur','242307',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83216,255,'Rujwari','242307',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83217,255,'S Purkayasthan','242221',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83218,255,'Sadan Bazar','242001',1,0,'2022-03-03 13:07:20','2022-03-03 13:07:20'),(83219,255,'Safaura','242407',1,0,'2022-03-03 13:07:21','2022-03-03 13:07:21'),(83220,255,'Samdhana','242307',1,0,'2022-03-03 13:07:21','2022-03-03 13:07:21'),(83221,255,'Sandaamipur','242301',1,0,'2022-03-03 13:07:21','2022-03-03 13:07:21'),(83222,255,'Sandakhas','242407',1,0,'2022-03-03 13:07:21','2022-03-03 13:07:21'),(83223,255,'Saraura','242406',1,0,'2022-03-03 13:07:21','2022-03-03 13:07:21'),(83224,255,'Sarhi','242306',1,0,'2022-03-03 13:07:21','2022-03-03 13:07:21'),(83225,255,'Sarjupur','242303',1,0,'2022-03-03 13:07:21','2022-03-03 13:07:21'),(83226,255,'Sarsawa','242303',1,0,'2022-03-03 13:07:21','2022-03-03 13:07:21'),(83227,255,'Sarthauli','242223',1,0,'2022-03-03 13:07:21','2022-03-03 13:07:21'),(83228,255,'Satwabuzurg','242401',1,0,'2022-03-03 13:07:21','2022-03-03 13:07:21'),(83229,255,'Scri','242306',1,0,'2022-03-03 13:07:21','2022-03-03 13:07:21'),(83230,255,'Seora','242301',1,0,'2022-03-03 13:07:21','2022-03-03 13:07:21'),(83231,255,'Seramau (North)','242123',1,0,'2022-03-03 13:07:21','2022-03-03 13:07:21'),(83232,255,'Seramau(South)','242406',1,0,'2022-03-03 13:07:21','2022-03-03 13:07:21'),(83233,255,'Shahbaznagar','242001',1,0,'2022-03-03 13:07:21','2022-03-03 13:07:21'),(83234,255,'Shahganj','242306',1,0,'2022-03-03 13:07:21','2022-03-03 13:07:21'),(83235,255,'Shahjahanpur Chawk','242001',1,0,'2022-03-03 13:07:21','2022-03-03 13:07:21'),(83236,255,'Shahjahanpur City','242001',1,0,'2022-03-03 13:07:21','2022-03-03 13:07:21'),(83237,255,'Shahjahanpur H.O','242001',1,0,'2022-03-03 13:07:21','2022-03-03 13:07:21'),(83238,255,'Shahjahanpur Kutchery','242001',1,0,'2022-03-03 13:07:21','2022-03-03 13:07:21'),(83239,255,'Shahjahanpur R S','242001',1,0,'2022-03-03 13:07:21','2022-03-03 13:07:21'),(83240,255,'Shahjapur','242406',1,0,'2022-03-03 13:07:21','2022-03-03 13:07:21'),(83241,255,'Shahpur','242221',1,0,'2022-03-03 13:07:21','2022-03-03 13:07:21'),(83242,255,'Shahpurkhitaua','242301',1,0,'2022-03-03 13:07:21','2022-03-03 13:07:21'),(83243,255,'Shankerpur','242303',1,0,'2022-03-03 13:07:21','2022-03-03 13:07:21'),(83244,255,'Sikandarpurkalanan','242301',1,0,'2022-03-03 13:07:22','2022-03-03 13:07:22'),(83245,255,'Silhua','242405',1,0,'2022-03-03 13:07:22','2022-03-03 13:07:22'),(83246,255,'Simariaraipur','242303',1,0,'2022-03-03 13:07:22','2022-03-03 13:07:22'),(83247,255,'Sindhauli','242001',1,0,'2022-03-03 13:07:22','2022-03-03 13:07:22'),(83248,255,'Singhayousufpur','242221',1,0,'2022-03-03 13:07:22','2022-03-03 13:07:22'),(83249,255,'Singraha','242406',1,0,'2022-03-03 13:07:22','2022-03-03 13:07:22'),(83250,255,'Siswa','242306',1,0,'2022-03-03 13:07:22','2022-03-03 13:07:22'),(83251,255,'Sondha','242123',1,0,'2022-03-03 13:07:22','2022-03-03 13:07:22'),(83252,255,'Sootha','242305',1,0,'2022-03-03 13:07:22','2022-03-03 13:07:22'),(83253,255,'Sulamanpurpatti','242221',1,0,'2022-03-03 13:07:22','2022-03-03 13:07:22'),(83254,255,'Sultanpur','242123',1,0,'2022-03-03 13:07:22','2022-03-03 13:07:22'),(83255,255,'Sunarabuzurg','242401',1,0,'2022-03-03 13:07:22','2022-03-03 13:07:22'),(83256,255,'Tahkhurdkalan','242405',1,0,'2022-03-03 13:07:22','2022-03-03 13:07:22'),(83257,255,'Talgaon','242407',1,0,'2022-03-03 13:07:22','2022-03-03 13:07:22'),(83258,255,'Tera','242001',1,0,'2022-03-03 13:07:22','2022-03-03 13:07:22'),(83259,255,'Tikri','242001',1,0,'2022-03-03 13:07:22','2022-03-03 13:07:22'),(83260,255,'Tilhar','242307',1,0,'2022-03-03 13:07:22','2022-03-03 13:07:22'),(83261,255,'Tindua Nagaria','242042',1,0,'2022-03-03 13:07:22','2022-03-03 13:07:22'),(83262,255,'Tingri','242221',1,0,'2022-03-03 13:07:22','2022-03-03 13:07:22'),(83263,255,'Tulapua','242123',1,0,'2022-03-03 13:07:22','2022-03-03 13:07:22'),(83264,255,'Uchaunlia','242306',1,0,'2022-03-03 13:07:22','2022-03-03 13:07:22'),(83265,255,'Udaipurbhoor','242221',1,0,'2022-03-03 13:07:22','2022-03-03 13:07:22'),(83266,255,'Ukhlinawada','242301',1,0,'2022-03-03 13:07:22','2022-03-03 13:07:22'),(83267,255,'Uliapur','242306',1,0,'2022-03-03 13:07:22','2022-03-03 13:07:22'),(83268,255,'Ullia','242401',1,0,'2022-03-03 13:07:22','2022-03-03 13:07:22'),(83269,255,'Umarsar','242303',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83270,255,'Umraha','242223',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83271,255,'Unkalan','242407',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83272,255,'Usmanpur Sarfra','242127',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83273,255,'Zarinpur','242221',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83274,255,'Zindpura','242407',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83275,256,'Aggapur','271831',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83276,256,'Akbarapur Semra','271831',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83277,256,'Amrahwa','271803',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83278,256,'Amwa','271831',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83279,256,'Babhni','271840',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83280,256,'Bachkahwa','271840',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83281,256,'Badal Pur','271840',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83282,256,'Bairagijot','271831',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83283,256,'Balapur','271845',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83284,256,'Banthihwa','271831',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83285,256,'Beerpur','271840',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83286,256,'Bhagwanpur Bhaisahi','271803',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83287,256,'Bhangha','271831',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83288,256,'Bhartha Rosan Garh','271840',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83289,256,'Bhinga','271831',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83290,256,'Bhutaha','271845',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83291,256,'Bisheswarganj','271821',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83292,256,'Bishunapur','271804',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83293,256,'Bishunapur','271840',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83294,256,'Chahalwa','271831',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83295,256,'Chandarkha Bujurga','271802',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83296,256,'Chaukgoi','271802',1,0,'2022-03-03 13:07:23','2022-03-03 13:07:23'),(83297,256,'Chetia Murar','271835',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83298,256,'Deorania','271875',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83299,256,'Dhanuhi','271845',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83300,256,'Dharsawan','271835',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83301,256,'Dhauli','271871',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83302,256,'Dikuali','271804',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83303,256,'Doobkalan','271804',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83304,256,'Dudhwania','271831',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83305,256,'Ekgharwa','271831',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83306,256,'Gabbapur','271840',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83307,256,'Ganeshpur','271845',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83308,256,'Gilaula','271835',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83309,256,'Gopala Sarai','271803',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83310,256,'Gothwa','271831',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83311,256,'Gulara','271840',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83312,256,'Hardutt Nagar','271875',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83313,256,'Hariharpur Rani','271831',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83314,256,'Hasnapur','271804',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83315,256,'Hempur','271840',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83316,256,'Jabdi','271840',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83317,256,'Jaichandpur','271835',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83318,256,'Jamdan','271803',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83319,256,'Jamunaha Bhawania Pur','271865',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83320,256,'Jamunaha Heera Singh','271803',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83321,256,'Janki Nagar','271831',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83322,256,'Jogin Bharia','271831',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83323,256,'Jokhwa Bazar','271831',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83324,256,'Kalkalwa','271803',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83325,256,'Kanibojhi','271803',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83326,256,'Katha','271835',1,0,'2022-03-03 13:07:24','2022-03-03 13:07:24'),(83327,256,'Kathara Bazar','271803',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83328,256,'Katkuiya','271840',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83329,256,'Khajurar','271845',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83330,256,'Khargaura Janoob','271845',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83331,256,'Kishun Pur Chand Bhari','271831',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83332,256,'Kot Bazar','271871',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83333,256,'Kotwa','271831',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83334,256,'Laxman Nagar Bazar','271804',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83335,256,'Laxmanpur Bazar','271831',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83336,256,'Laxmanpur Kothi','271803',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83337,256,'Laxmanpur Semrahniya','271804',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83338,256,'Machhrihwa','271831',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83339,256,'Madara','271845',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83340,256,'Madhwapur','271840',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83341,256,'Maharu Murtiha','271803',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83342,256,'Mahdeiya','271805',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83343,256,'Manoharapur','271845',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83344,256,'Medikiya','271840',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83345,256,'Motipur','271840',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83346,256,'Mujehna','271831',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83347,256,'Naubasta','271831',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83348,256,'Parasrampur','271831',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83349,256,'Parsa Deharia','271831',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83350,256,'Parsia','271870',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83351,256,'Patna Khargaura','271831',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83352,256,'Patna Malhipur','271803',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83353,256,'Payagpur Bus Station','271871',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83354,256,'Pure Gokul Singh','271831',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83355,256,'Pure Prasad','271840',1,0,'2022-03-03 13:07:25','2022-03-03 13:07:25'),(83356,256,'Pure Wale','271840',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83357,256,'Puredeen Namgarh','271805',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83358,256,'Raideeh','271835',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83359,256,'Ramgarhi','271831',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83360,256,'Ramnagra','271804',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83361,256,'Rampur Painda','271835',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83362,256,'Ranipur','271840',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83363,256,'Samari Chak Pihani','271831',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83364,256,'Semgarha','271835',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83365,256,'Shahpur Bara','271835',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83366,256,'Shahpur Bargadwa','271840',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83367,256,'Shahpur Kathotia','271804',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83368,256,'Shankarpur','271840',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83369,256,'Shikari Chanda','271803',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83370,256,'Shravasti','271805',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83371,256,'Sirsia','271840',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83372,256,'Siswara','271835',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83373,256,'Sitkahana','271803',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83374,256,'Sonbarsa','271840',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83375,256,'Sonrai','271845',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83376,256,'Sonwan','271804',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83377,256,'Taal Baghaura','271840',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83378,256,'Takiya','271845',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83379,256,'Tendwa Mahanth','271845',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83380,256,'Titiharia','271840',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83381,256,'Tulsipur','271802',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83382,256,'Vijaypur Sisawan','271835',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83383,256,'Beer Pur Khairaniya','271201',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83384,257,'Agiyauna','272152',1,0,'2022-03-03 13:07:26','2022-03-03 13:07:26'),(83385,257,'Ahri','272204',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83386,257,'Ajgara','272153',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83387,257,'Alidapur','272202',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83388,257,'Antari Bazar','272205',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83389,257,'Arji','272152',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83390,257,'Badahara','272208',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83391,257,'Bagheli','272206',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83392,257,'Bairwa','272192',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83393,257,'Bairwanankar','272208',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83394,257,'Bajrabhari','272192',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83395,257,'Banauli','272154',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83396,257,'Bankeygaon','272152',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83397,257,'Barao Nansar','272153',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83398,257,'Baur Byas','272154',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83399,257,'Bayara','272195',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83400,257,'Beerpur','272189',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83401,257,'Belaukh','272152',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83402,257,'Belrai','272154',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83403,257,'Beltikar','272206',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83404,257,'Bewa Chauraha','272191',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83405,257,'Bhadehargrant','272204',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83406,257,'Bhadokhar','272192',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83407,257,'Bhandariamanik Ganj','272189',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83408,257,'Bhanpurkhas','272195',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83409,257,'Bhanwapur','272193',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83410,257,'Bharatbhari','272191',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83411,257,'Bharwatia Bzr','272189',1,0,'2022-03-03 13:07:27','2022-03-03 13:07:27'),(83412,257,'Bhawaniganj','272195',1,0,'2022-03-03 13:07:28','2022-03-03 13:07:28'),(83413,257,'Bheemapar','272207',1,0,'2022-03-03 13:07:28','2022-03-03 13:07:28'),(83414,257,'Bhelaunji','272208',1,0,'2022-03-03 13:07:28','2022-03-03 13:07:28'),(83415,257,'Bhitpara','272206',1,0,'2022-03-03 13:07:28','2022-03-03 13:07:28'),(83416,257,'Bhojwar','272192',1,0,'2022-03-03 13:07:28','2022-03-03 13:07:28'),(83417,257,'Bidra','272153',1,0,'2022-03-03 13:07:28','2022-03-03 13:07:28'),(83418,257,'Bihra','272153',1,0,'2022-03-03 13:07:28','2022-03-03 13:07:28'),(83419,257,'Bijwar Barahai','272129',1,0,'2022-03-03 13:07:28','2022-03-03 13:07:28'),(83420,257,'Bijwar Barhai','272189',1,0,'2022-03-03 13:07:28','2022-03-03 13:07:28'),(83421,257,'Birdpur No.13','272203',1,0,'2022-03-03 13:07:28','2022-03-03 13:07:28'),(83422,257,'Birdpur No.7','272202',1,0,'2022-03-03 13:07:28','2022-03-03 13:07:28'),(83423,257,'Birdpur','272202',1,0,'2022-03-03 13:07:28','2022-03-03 13:07:28'),(83424,257,'Bishunpurwa','272202',1,0,'2022-03-03 13:07:28','2022-03-03 13:07:28'),(83425,257,'Biskohar','272192',1,0,'2022-03-03 13:07:28','2022-03-03 13:07:28'),(83426,257,'Bisunpurwa','272152',1,0,'2022-03-03 13:07:28','2022-03-03 13:07:28'),(83427,257,'Bitharia','272189',1,0,'2022-03-03 13:07:28','2022-03-03 13:07:28'),(83428,257,'Bohli','272201',1,0,'2022-03-03 13:07:28','2022-03-03 13:07:28'),(83429,257,'Cchamapur','272205',1,0,'2022-03-03 13:07:28','2022-03-03 13:07:28'),(83430,257,'Chafa','272189',1,0,'2022-03-03 13:07:28','2022-03-03 13:07:28'),(83431,257,'Charthari','272152',1,0,'2022-03-03 13:07:28','2022-03-03 13:07:28'),(83432,257,'Chaukhara','272193',1,0,'2022-03-03 13:07:28','2022-03-03 13:07:28'),(83433,257,'Chauri Khurd','272148',1,0,'2022-03-03 13:07:28','2022-03-03 13:07:28'),(83434,257,'Chetia','272153',1,0,'2022-03-03 13:07:28','2022-03-03 13:07:28'),(83435,257,'Chetra','272205',1,0,'2022-03-03 13:07:28','2022-03-03 13:07:28'),(83436,257,'Chhitauni','272151',1,0,'2022-03-03 13:07:28','2022-03-03 13:07:28'),(83437,257,'Chilihia','272204',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83438,257,'Chitahi','272193',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83439,257,'Civil Line Siddharthnagar','272207',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83440,257,'Dabra','272205',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83441,257,'Daldala','272152',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83442,257,'Dandwaghat','272153',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83443,257,'Deora Bazar','272207',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83444,257,'Dhanaura Mustahkam','272205',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83445,257,'Dhangarwa','272192',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83446,257,'Dhaurahara','272189',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83447,257,'Dhebarua','272201',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83448,257,'Dhekhari','272201',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83449,257,'Dhensanankar','272207',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83450,257,'Dhobha','272189',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83451,257,'Dhobha','272192',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83452,257,'Dhusurai Bzg','272204',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83453,257,'Dindai','272151',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83454,257,'Domariaganj','272189',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83455,257,'Dulhanorth','272206',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83456,257,'Dumaria Buzurg','272154',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83457,257,'Ekdangwa','272206',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83458,257,'Fatehpur','272189',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83459,257,'Gagapur','272192',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83460,257,'Gaura Bazar','272189',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83461,257,'Gauri','272153',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83462,257,'Ghosiyari Bzr','272148',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83463,257,'Govindpur','272192',1,0,'2022-03-03 13:07:29','2022-03-03 13:07:29'),(83464,257,'Hallaur (Siddharthnagar)','272191',1,0,'2022-03-03 13:07:30','2022-03-03 13:07:30'),(83465,257,'Haribanshpur','272206',1,0,'2022-03-03 13:07:30','2022-03-03 13:07:30'),(83466,257,'Harkauli','272204',1,0,'2022-03-03 13:07:30','2022-03-03 13:07:30'),(83467,257,'Harraiya','272207',1,0,'2022-03-03 13:07:30','2022-03-03 13:07:30'),(83468,257,'Harraiya Nankar','272153',1,0,'2022-03-03 13:07:30','2022-03-03 13:07:30'),(83469,257,'Imiliha','272208',1,0,'2022-03-03 13:07:30','2022-03-03 13:07:30'),(83470,257,'Itwa','272192',1,0,'2022-03-03 13:07:30','2022-03-03 13:07:30'),(83471,257,'Janiajote','272153',1,0,'2022-03-03 13:07:30','2022-03-03 13:07:30'),(83472,257,'Jeewa','272153',1,0,'2022-03-03 13:07:30','2022-03-03 13:07:30'),(83473,257,'Jhahraon','272189',1,0,'2022-03-03 13:07:30','2022-03-03 13:07:30'),(83474,257,'Jigina Thakur','272192',1,0,'2022-03-03 13:07:30','2022-03-03 13:07:30'),(83475,257,'Jogia Udaipur','272207',1,0,'2022-03-03 13:07:30','2022-03-03 13:07:30'),(83476,257,'Kadja','272152',1,0,'2022-03-03 13:07:30','2022-03-03 13:07:30'),(83477,257,'Kakrahwa','272206',1,0,'2022-03-03 13:07:30','2022-03-03 13:07:30'),(83478,257,'Kakrapokhar','272153',1,0,'2022-03-03 13:07:30','2022-03-03 13:07:30'),(83479,257,'Kalnakhor','272154',1,0,'2022-03-03 13:07:30','2022-03-03 13:07:30'),(83480,257,'Kamsar','272193',1,0,'2022-03-03 13:07:30','2022-03-03 13:07:30'),(83481,257,'Kapiyawa','272148',1,0,'2022-03-03 13:07:30','2022-03-03 13:07:30'),(83482,257,'Karahi','272153',1,0,'2022-03-03 13:07:30','2022-03-03 13:07:30'),(83483,257,'Karahiagosain','272192',1,0,'2022-03-03 13:07:30','2022-03-03 13:07:30'),(83484,257,'Karmaini','272206',1,0,'2022-03-03 13:07:30','2022-03-03 13:07:30'),(83485,257,'Katbandh','272151',1,0,'2022-03-03 13:07:30','2022-03-03 13:07:30'),(83486,257,'Katehna','272204',1,0,'2022-03-03 13:07:30','2022-03-03 13:07:30'),(83487,257,'Kathela','272192',1,0,'2022-03-03 13:07:31','2022-03-03 13:07:31'),(83488,257,'Kathwathia Alam','272191',1,0,'2022-03-03 13:07:31','2022-03-03 13:07:31'),(83489,257,'Khadsari','272192',1,0,'2022-03-03 13:07:31','2022-03-03 13:07:31'),(83490,257,'Khaira','272153',1,0,'2022-03-03 13:07:31','2022-03-03 13:07:31'),(83491,257,'Khaira Bazar','272205',1,0,'2022-03-03 13:07:31','2022-03-03 13:07:31'),(83492,257,'Khakhara','272206',1,0,'2022-03-03 13:07:31','2022-03-03 13:07:31'),(83493,257,'Khakhara Khurd','272208',1,0,'2022-03-03 13:07:31','2022-03-03 13:07:31'),(83494,257,'Khuniyawan','272192',1,0,'2022-03-03 13:07:31','2022-03-03 13:07:31'),(83495,257,'Khurhuria','272204',1,0,'2022-03-03 13:07:31','2022-03-03 13:07:31'),(83496,257,'Kolhui','272153',1,0,'2022-03-03 13:07:31','2022-03-03 13:07:31'),(83497,257,'Kondragrant','272207',1,0,'2022-03-03 13:07:31','2022-03-03 13:07:31'),(83498,257,'Kotiagarori','272153',1,0,'2022-03-03 13:07:31','2022-03-03 13:07:31'),(83499,257,'Kudja','272154',1,0,'2022-03-03 13:07:31','2022-03-03 13:07:31'),(83500,257,'Kusumhi','272189',1,0,'2022-03-03 13:07:31','2022-03-03 13:07:31'),(83501,257,'Lahara','272152',1,0,'2022-03-03 13:07:31','2022-03-03 13:07:31'),(83502,257,'Lotan','272206',1,0,'2022-03-03 13:07:31','2022-03-03 13:07:31'),(83503,257,'Madanpur','272208',1,0,'2022-03-03 13:07:31','2022-03-03 13:07:31'),(83504,257,'Madhubani','272206',1,0,'2022-03-03 13:07:31','2022-03-03 13:07:31'),(83505,257,'Madhuharpur','272207',1,0,'2022-03-03 13:07:31','2022-03-03 13:07:31'),(83506,257,'Madhukarpur','272153',1,0,'2022-03-03 13:07:31','2022-03-03 13:07:31'),(83507,257,'Mahadeoghurhoo','272192',1,0,'2022-03-03 13:07:31','2022-03-03 13:07:31'),(83508,257,'Mahadev Buzurg','272201',1,0,'2022-03-03 13:07:32','2022-03-03 13:07:32'),(83509,257,'Mahapaliuttar','272206',1,0,'2022-03-03 13:07:32','2022-03-03 13:07:32'),(83510,257,'Maharia','272207',1,0,'2022-03-03 13:07:32','2022-03-03 13:07:32'),(83511,257,'Mahatha Bazar','272205',1,0,'2022-03-03 13:07:32','2022-03-03 13:07:32'),(83512,257,'Mahui Nankar','272154',1,0,'2022-03-03 13:07:32','2022-03-03 13:07:32'),(83513,257,'Mahulani','272207',1,0,'2022-03-03 13:07:32','2022-03-03 13:07:32'),(83514,257,'Mahuwa Bzg.','272193',1,0,'2022-03-03 13:07:32','2022-03-03 13:07:32'),(83515,257,'Mailani','272195',1,0,'2022-03-03 13:07:32','2022-03-03 13:07:32'),(83516,257,'Maina','272192',1,0,'2022-03-03 13:07:32','2022-03-03 13:07:32'),(83517,257,'Makraur','272205',1,0,'2022-03-03 13:07:32','2022-03-03 13:07:32'),(83518,257,'Malhwar','272191',1,0,'2022-03-03 13:07:32','2022-03-03 13:07:32'),(83519,257,'Malimainha','272189',1,0,'2022-03-03 13:07:32','2022-03-03 13:07:32'),(83520,257,'Manoharpur','272191',1,0,'2022-03-03 13:07:32','2022-03-03 13:07:32'),(83521,257,'Marwatia Bazar','272152',1,0,'2022-03-03 13:07:32','2022-03-03 13:07:32'),(83522,257,'Masaicha','272151',1,0,'2022-03-03 13:07:32','2022-03-03 13:07:32'),(83523,257,'Masina Khas','272151',1,0,'2022-03-03 13:07:32','2022-03-03 13:07:32'),(83524,257,'Mau','272153',1,0,'2022-03-03 13:07:32','2022-03-03 13:07:32'),(83525,257,'Mithwal Bazaar','272153',1,0,'2022-03-03 13:07:32','2022-03-03 13:07:32'),(83526,257,'Mohankola','272201',1,0,'2022-03-03 13:07:32','2022-03-03 13:07:32'),(83527,257,'Mudila Khatai','272202',1,0,'2022-03-03 13:07:32','2022-03-03 13:07:32'),(83528,257,'Mudila Nankar','272192',1,0,'2022-03-03 13:07:33','2022-03-03 13:07:33'),(83529,257,'Nagawa','272208',1,0,'2022-03-03 13:07:33','2022-03-03 13:07:33'),(83530,257,'Nakahi','272205',1,0,'2022-03-03 13:07:33','2022-03-03 13:07:33'),(83531,257,'Narkataha','272153',1,0,'2022-03-03 13:07:33','2022-03-03 13:07:33'),(83532,257,'Narkul','272202',1,0,'2022-03-03 13:07:33','2022-03-03 13:07:33'),(83533,257,'Nasirganj','272152',1,0,'2022-03-03 13:07:33','2022-03-03 13:07:33'),(83534,257,'Naugarh (Siddharthnagar)','272203',1,0,'2022-03-03 13:07:33','2022-03-03 13:07:33'),(83535,257,'Pachgawan','272202',1,0,'2022-03-03 13:07:33','2022-03-03 13:07:33'),(83536,257,'Pachhar','272153',1,0,'2022-03-03 13:07:33','2022-03-03 13:07:33'),(83537,257,'Pachmohani','272152',1,0,'2022-03-03 13:07:33','2022-03-03 13:07:33'),(83538,257,'Pakri','272205',1,0,'2022-03-03 13:07:33','2022-03-03 13:07:33'),(83539,257,'Par R.S.','272201',1,0,'2022-03-03 13:07:33','2022-03-03 13:07:33'),(83540,257,'Parsa Belhari','272202',1,0,'2022-03-03 13:07:33','2022-03-03 13:07:33'),(83541,257,'Parsa Khurd','272195',1,0,'2022-03-03 13:07:33','2022-03-03 13:07:33'),(83542,257,'Pathara Bzr','272153',1,0,'2022-03-03 13:07:33','2022-03-03 13:07:33'),(83543,257,'Patila','272192',1,0,'2022-03-03 13:07:33','2022-03-03 13:07:33'),(83544,257,'Patni Jungle','272207',1,0,'2022-03-03 13:07:33','2022-03-03 13:07:33'),(83545,257,'Penda','272189',1,0,'2022-03-03 13:07:33','2022-03-03 13:07:33'),(83546,257,'Pendari Buzurg','272154',1,0,'2022-03-03 13:07:33','2022-03-03 13:07:33'),(83547,257,'Piparsan','272202',1,0,'2022-03-03 13:07:33','2022-03-03 13:07:33'),(83548,257,'Piraila','272195',1,0,'2022-03-03 13:07:33','2022-03-03 13:07:33'),(83549,257,'Quadirabad','272189',1,0,'2022-03-03 13:07:33','2022-03-03 13:07:33'),(83550,257,'Ramnagar','272201',1,0,'2022-03-03 13:07:33','2022-03-03 13:07:33'),(83551,257,'Ramnagar','272206',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83552,257,'Ramwapur','272205',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83553,257,'Ramwapur Dubey','272153',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83554,257,'Ramwapur Jagatram','272193',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83555,257,'Ramwapur Raut','272193',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83556,257,'Rasoolpur','272189',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83557,257,'Rehra Kalan','272192',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83558,257,'Rithia Bazar','272152',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83559,257,'Rudrapur','272153',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83560,257,'Sainua','272206',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83561,257,'Sakarpar','272154',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83562,257,'Santora','272204',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83563,257,'Sawadand','272152',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83564,257,'Sehari Khas','272189',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83565,257,'Sekhui','272153',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83566,257,'Sekhuiya','272203',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83567,257,'Semari','272151',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83568,257,'Semari Khan Kot','272192',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83569,257,'Semrahna','272208',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83570,257,'Shahpur','272189',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83571,257,'Shankarpur','272195',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83572,257,'Sheopatinagar','272206',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83573,257,'Shoharatgarh','272205',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83574,257,'Sikri Bazar','272206',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83575,257,'Sikta','272193',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83576,257,'Sishania','272152',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83577,257,'Sohas Khas','272208',1,0,'2022-03-03 13:07:34','2022-03-03 13:07:34'),(83578,257,'Sohna','272193',1,0,'2022-03-03 13:07:35','2022-03-03 13:07:35'),(83579,257,'Sonkhar','272153',1,0,'2022-03-03 13:07:35','2022-03-03 13:07:35'),(83580,257,'Sugahi','272208',1,0,'2022-03-03 13:07:35','2022-03-03 13:07:35'),(83581,257,'Suhai Kanpurwa','272152',1,0,'2022-03-03 13:07:35','2022-03-03 13:07:35'),(83582,257,'Sukla Jote','272193',1,0,'2022-03-03 13:07:35','2022-03-03 13:07:35'),(83583,257,'Suparaja','272153',1,0,'2022-03-03 13:07:35','2022-03-03 13:07:35'),(83584,257,'Talpurwa','272153',1,0,'2022-03-03 13:07:35','2022-03-03 13:07:35'),(83585,257,'Tandia Bazar','272208',1,0,'2022-03-03 13:07:35','2022-03-03 13:07:35'),(83586,257,'Tandwa','272194',1,0,'2022-03-03 13:07:35','2022-03-03 13:07:35'),(83587,257,'Telgadia Bzg','272191',1,0,'2022-03-03 13:07:35','2022-03-03 13:07:35'),(83588,257,'Tenuwagrant','272192',1,0,'2022-03-03 13:07:35','2022-03-03 13:07:35'),(83589,257,'Tetari Bazar','272207',1,0,'2022-03-03 13:07:35','2022-03-03 13:07:35'),(83590,257,'Tikur','272154',1,0,'2022-03-03 13:07:35','2022-03-03 13:07:35'),(83591,257,'Tilauli','272153',1,0,'2022-03-03 13:07:35','2022-03-03 13:07:35'),(83592,257,'Tilaura','272152',1,0,'2022-03-03 13:07:35','2022-03-03 13:07:35'),(83593,257,'Trilokpur','272192',1,0,'2022-03-03 13:07:35','2022-03-03 13:07:35'),(83594,257,'Turkaulia','272189',1,0,'2022-03-03 13:07:35','2022-03-03 13:07:35'),(83595,257,'Udairajganj','272204',1,0,'2022-03-03 13:07:35','2022-03-03 13:07:35'),(83596,257,'Uska Bazar','272208',1,0,'2022-03-03 13:07:35','2022-03-03 13:07:35'),(83597,257,'Wasadargah','272195',1,0,'2022-03-03 13:07:35','2022-03-03 13:07:35'),(83598,258,'27 Bn. P.A.C.','261001',1,0,'2022-03-03 13:07:35','2022-03-03 13:07:35'),(83599,258,'Adwari','261202',1,0,'2022-03-03 13:07:35','2022-03-03 13:07:35'),(83600,258,'Ahewa','261301',1,0,'2022-03-03 13:07:35','2022-03-03 13:07:35'),(83601,258,'Ahmedabad','261201',1,0,'2022-03-03 13:07:35','2022-03-03 13:07:35'),(83602,258,'Ailiya','261001',1,0,'2022-03-03 13:07:35','2022-03-03 13:07:35'),(83603,258,'Ajaipur','261208',1,0,'2022-03-03 13:07:35','2022-03-03 13:07:35'),(83604,258,'Akbapur','261401',1,0,'2022-03-03 13:07:36','2022-03-03 13:07:36'),(83605,258,'Akbarpur','261135',1,0,'2022-03-03 13:07:36','2022-03-03 13:07:36'),(83606,258,'Akhtiyarpur','261121',1,0,'2022-03-03 13:07:36','2022-03-03 13:07:36'),(83607,258,'Akohra','261303',1,0,'2022-03-03 13:07:36','2022-03-03 13:07:36'),(83608,258,'Alamnagar','261001',1,0,'2022-03-03 13:07:36','2022-03-03 13:07:36'),(83609,258,'Amberpur','261303',1,0,'2022-03-03 13:07:36','2022-03-03 13:07:36'),(83610,258,'Amtamau','261405',1,0,'2022-03-03 13:07:36','2022-03-03 13:07:36'),(83611,258,'Angarasi','261001',1,0,'2022-03-03 13:07:36','2022-03-03 13:07:36'),(83612,258,'Angarasi Shekhwapur','261207',1,0,'2022-03-03 13:07:36','2022-03-03 13:07:36'),(83613,258,'Angaraura','261204',1,0,'2022-03-03 13:07:36','2022-03-03 13:07:36'),(83614,258,'Anshuamau','261303',1,0,'2022-03-03 13:07:36','2022-03-03 13:07:36'),(83615,258,'Ant','261401',1,0,'2022-03-03 13:07:36','2022-03-03 13:07:36'),(83616,258,'Arthapur','261401',1,0,'2022-03-03 13:07:36','2022-03-03 13:07:36'),(83617,258,'Ashrafpur','261131',1,0,'2022-03-03 13:07:36','2022-03-03 13:07:36'),(83618,258,'Atariya','261303',1,0,'2022-03-03 13:07:36','2022-03-03 13:07:36'),(83619,258,'Ataura','261204',1,0,'2022-03-03 13:07:36','2022-03-03 13:07:36'),(83620,258,'Atwa','261402',1,0,'2022-03-03 13:07:36','2022-03-03 13:07:36'),(83621,258,'Aurangabad (Sitapur)','261403',1,0,'2022-03-03 13:07:36','2022-03-03 13:07:36'),(83622,258,'Avas Vikas Colony (Sitapur)','261001',1,0,'2022-03-03 13:07:36','2022-03-03 13:07:36'),(83623,258,'Babupur','261206',1,0,'2022-03-03 13:07:36','2022-03-03 13:07:36'),(83624,258,'Bachhawal','261141',1,0,'2022-03-03 13:07:37','2022-03-03 13:07:37'),(83625,258,'Badanpur','261303',1,0,'2022-03-03 13:07:37','2022-03-03 13:07:37'),(83626,258,'Badeliya','261121',1,0,'2022-03-03 13:07:37','2022-03-03 13:07:37'),(83627,258,'Badrawan','261405',1,0,'2022-03-03 13:07:37','2022-03-03 13:07:37'),(83628,258,'Baghain','261203',1,0,'2022-03-03 13:07:37','2022-03-03 13:07:37'),(83629,258,'Bahadurganj','261204',1,0,'2022-03-03 13:07:37','2022-03-03 13:07:37'),(83630,258,'Bahadurnagar','261151',1,0,'2022-03-03 13:07:37','2022-03-03 13:07:37'),(83631,258,'Bakahuan','261201',1,0,'2022-03-03 13:07:37','2022-03-03 13:07:37'),(83632,258,'Baloia','261301',1,0,'2022-03-03 13:07:37','2022-03-03 13:07:37'),(83633,258,'Balsinghpur','261206',1,0,'2022-03-03 13:07:37','2022-03-03 13:07:37'),(83634,258,'Bambhanawan','261205',1,0,'2022-03-03 13:07:37','2022-03-03 13:07:37'),(83635,258,'Bambhaur','261206',1,0,'2022-03-03 13:07:37','2022-03-03 13:07:37'),(83636,258,'Bambhaura','261141',1,0,'2022-03-03 13:07:37','2022-03-03 13:07:37'),(83637,258,'Bambhera','261302',1,0,'2022-03-03 13:07:37','2022-03-03 13:07:37'),(83638,258,'Bambhiya','261205',1,0,'2022-03-03 13:07:37','2022-03-03 13:07:37'),(83639,258,'Baniyamau','261405',1,0,'2022-03-03 13:07:37','2022-03-03 13:07:37'),(83640,258,'Banni Kharela','261145',1,0,'2022-03-03 13:07:37','2022-03-03 13:07:37'),(83641,258,'Bansura','261204',1,0,'2022-03-03 13:07:37','2022-03-03 13:07:37'),(83642,258,'Banzariya','261001',1,0,'2022-03-03 13:07:37','2022-03-03 13:07:37'),(83643,258,'Baragaon','261141',1,0,'2022-03-03 13:07:37','2022-03-03 13:07:37'),(83644,258,'Baragaon Bhurjiha','261125',1,0,'2022-03-03 13:07:37','2022-03-03 13:07:37'),(83645,258,'Barbatapur Chitahla','261141',1,0,'2022-03-03 13:07:37','2022-03-03 13:07:37'),(83646,258,'Bargawan','261151',1,0,'2022-03-03 13:07:37','2022-03-03 13:07:37'),(83647,258,'Bari','261303',1,0,'2022-03-03 13:07:37','2022-03-03 13:07:37'),(83648,258,'Bartal','261403',1,0,'2022-03-03 13:07:37','2022-03-03 13:07:37'),(83649,258,'Basaideeh','261302',1,0,'2022-03-03 13:07:37','2022-03-03 13:07:37'),(83650,258,'Baseti','261001',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83651,258,'Basudaha','261202',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83652,258,'Baunabhari','261303',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83653,258,'Beehat Gaur','261141',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83654,258,'Beehatbeeram','261405',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83655,258,'Behra Kodehra','261135',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83656,258,'Behta Pakauri','261208',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83657,258,'Belamau Kalan','261121',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83658,258,'Belgawan','261001',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83659,258,'Belwa Baharurpur','261145',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83660,258,'Beni Sarain','261135',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83661,258,'Bhadebhar','261404',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83662,258,'Bhadfar','261135',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83663,258,'Bhadmara','261205',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83664,258,'Bhagipur','261204',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83665,258,'Bhainsaha','261202',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83666,258,'Bhakuraha','261151',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83667,258,'Bhandia','261301',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83668,258,'Bharauna','261403',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83669,258,'Bhartha','261205',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83670,258,'Bhethra Madhav','261203',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83671,258,'Bhinaini','261201',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83672,258,'Bhithauli','261302',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83673,258,'Bhithauli Chitrakoot','261402',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83674,258,'Bhithaura','261302',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83675,258,'Bhurkunda Bazar','261201',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83676,258,'Bhurkuri','261141',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83677,258,'Bhusna','261201',1,0,'2022-03-03 13:07:38','2022-03-03 13:07:38'),(83678,258,'Bilariya','261135',1,0,'2022-03-03 13:07:39','2022-03-03 13:07:39'),(83679,258,'Bilauli Bazar','261206',1,0,'2022-03-03 13:07:39','2022-03-03 13:07:39'),(83680,258,'Bilauli Nankari','261201',1,0,'2022-03-03 13:07:39','2022-03-03 13:07:39'),(83681,258,'Bisara','261141',1,0,'2022-03-03 13:07:39','2022-03-03 13:07:39'),(83682,258,'Bisenda','261145',1,0,'2022-03-03 13:07:39','2022-03-03 13:07:39'),(83683,258,'Biswan Khurd','261208',1,0,'2022-03-03 13:07:39','2022-03-03 13:07:39'),(83684,258,'Biswan','261201',1,0,'2022-03-03 13:07:39','2022-03-03 13:07:39'),(83685,258,'Bizwar','261125',1,0,'2022-03-03 13:07:39','2022-03-03 13:07:39'),(83686,258,'Bohra','261202',1,0,'2022-03-03 13:07:39','2022-03-03 13:07:39'),(83687,258,'Brahmawali','261141',1,0,'2022-03-03 13:07:39','2022-03-03 13:07:39'),(83688,258,'Brahmawali','261403',1,0,'2022-03-03 13:07:39','2022-03-03 13:07:39'),(83689,258,'Bus Stand','261001',1,0,'2022-03-03 13:07:39','2022-03-03 13:07:39'),(83690,258,'Chandpur','261203',1,0,'2022-03-03 13:07:39','2022-03-03 13:07:39'),(83691,258,'Chandpur','261403',1,0,'2022-03-03 13:07:39','2022-03-03 13:07:39'),(83692,258,'Chandraseni','261202',1,0,'2022-03-03 13:07:39','2022-03-03 13:07:39'),(83693,258,'Chathia','261141',1,0,'2022-03-03 13:07:39','2022-03-03 13:07:39'),(83694,258,'Chaturaiya','261141',1,0,'2022-03-03 13:07:39','2022-03-03 13:07:39'),(83695,258,'Chauriya','261303',1,0,'2022-03-03 13:07:39','2022-03-03 13:07:39'),(83696,258,'Chikkari Dhandhar','261204',1,0,'2022-03-03 13:07:39','2022-03-03 13:07:39'),(83697,258,'Chinhara','261001',1,0,'2022-03-03 13:07:39','2022-03-03 13:07:39'),(83698,258,'Dadeura','261404',1,0,'2022-03-03 13:07:39','2022-03-03 13:07:39'),(83699,258,'Dahawa','261301',1,0,'2022-03-03 13:07:39','2022-03-03 13:07:39'),(83700,258,'Dalpatpur','261205',1,0,'2022-03-03 13:07:39','2022-03-03 13:07:39'),(83701,258,'Daranagar','261001',1,0,'2022-03-03 13:07:39','2022-03-03 13:07:39'),(83702,258,'Dateli','261121',1,0,'2022-03-03 13:07:39','2022-03-03 13:07:39'),(83703,258,'Daulatpur Behma','261301',1,0,'2022-03-03 13:07:39','2022-03-03 13:07:39'),(83704,258,'Deokaliya','261201',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83705,258,'Dhakera','261135',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83706,258,'Dhakhinawan','261301',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83707,258,'Dharaincha Bazar','261131',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83708,258,'Dhawarpara','261303',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83709,258,'Dhenua','261205',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83710,258,'Dhondhi','261207',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83711,258,'Dhoukalganj','261201',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83712,258,'Dhourahra','261136',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83713,258,'Dhouremau','261001',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83714,258,'Dugana','261136',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83715,258,'Eye Hospital','261001',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83716,258,'Fakharpur','261151',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83717,258,'Fateh Nagar','261405',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83718,258,'Gandhauli','261303',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83719,258,'Ganga Ganj','261303',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83720,258,'Gangoopur','261403',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83721,258,'Garasa','261401',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83722,258,'Garhi Kherwa','261303',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83723,258,'Garhisenpur','261131',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83724,258,'Gauria Jhal','261207',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83725,258,'Gauria Kalan','261125',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83726,258,'Gauriya','261131',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83727,258,'Girdharpur','261141',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83728,258,'Godhana','261303',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83729,258,'Gohilari','261403',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83730,258,'Golok Kondar','261205',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83731,258,'Gonda Deoria','261204',1,0,'2022-03-03 13:07:40','2022-03-03 13:07:40'),(83732,258,'Gondaha','261204',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83733,258,'Govindapur','261208',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83734,258,'Gularipurwa','261135',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83735,258,'Gurdhapa','261121',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83736,258,'Gurepara','261135',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83737,258,'Gurera','261201',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83738,258,'Gursanda','261151',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83739,258,'Gwari','261205',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83740,258,'H.S. Mills','261121',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83741,258,'Hargaon N.D.','261121',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83742,258,'Hasnapur','261302',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83743,258,'Hasnapur','261201',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83744,258,'Hathia','261141',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83745,258,'Hathiya Gazipur','261145',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83746,258,'Hazaratpur','261208',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83747,258,'Hindaura','261303',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83748,258,'Humaunpur','261001',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83749,258,'Husainganj','261303',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83750,258,'Husainganj (Sitapur)','261125',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83751,258,'Husainpur Khani','261205',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83752,258,'Imaliya Sultanpur','261001',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83753,258,'Imiliya Manpur','261203',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83754,258,'Inayat Nagar','261141',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83755,258,'Indrauli','261001',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83756,258,'Ishwarwara','261206',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83757,258,'Islamnagar','261401',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83758,258,'Itari','261207',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83759,258,'Itauri','261205',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83760,258,'Itauwa','261136',1,0,'2022-03-03 13:07:41','2022-03-03 13:07:41'),(83761,258,'Itia','261204',1,0,'2022-03-03 13:07:42','2022-03-03 13:07:42'),(83762,258,'Jahangirabad (Sitapur)','261202',1,0,'2022-03-03 13:07:42','2022-03-03 13:07:42'),(83763,258,'Jahansapur','261141',1,0,'2022-03-03 13:07:42','2022-03-03 13:07:42'),(83764,258,'Jail Road (Sitapur)','261001',1,0,'2022-03-03 13:07:42','2022-03-03 13:07:42'),(83765,258,'Jar','261001',1,0,'2022-03-03 13:07:42','2022-03-03 13:07:42'),(83766,258,'Jatpurwa Kishoreganj','261205',1,0,'2022-03-03 13:07:42','2022-03-03 13:07:42'),(83767,258,'Jhauwa','261202',1,0,'2022-03-03 13:07:42','2022-03-03 13:07:42'),(83768,258,'Kabirpur Budhanpur','261121',1,0,'2022-03-03 13:07:42','2022-03-03 13:07:42'),(83769,258,'Kabra','261301',1,0,'2022-03-03 13:07:42','2022-03-03 13:07:42'),(83770,258,'Kachura','261141',1,0,'2022-03-03 13:07:42','2022-03-03 13:07:42'),(83771,258,'Kaimahara Kalan','261201',1,0,'2022-03-03 13:07:42','2022-03-03 13:07:42'),(83772,258,'Kaimahra','261207',1,0,'2022-03-03 13:07:42','2022-03-03 13:07:42'),(83773,258,'Kakrahi','261135',1,0,'2022-03-03 13:07:42','2022-03-03 13:07:42'),(83774,258,'Kalabahadurpur','261207',1,0,'2022-03-03 13:07:42','2022-03-03 13:07:42'),(83775,258,'Kalli','261403',1,0,'2022-03-03 13:07:42','2022-03-03 13:07:42'),(83776,258,'Kamlapur (Sitapur)','261302',1,0,'2022-03-03 13:07:42','2022-03-03 13:07:42'),(83777,258,'Kankari','261205',1,0,'2022-03-03 13:07:42','2022-03-03 13:07:42'),(83778,258,'Karseora','261135',1,0,'2022-03-03 13:07:42','2022-03-03 13:07:42'),(83779,258,'Kasimpur','261001',1,0,'2022-03-03 13:07:42','2022-03-03 13:07:42'),(83780,258,'Kasmanda','261302',1,0,'2022-03-03 13:07:42','2022-03-03 13:07:42'),(83781,258,'Kasraila Bazar','261207',1,0,'2022-03-03 13:07:42','2022-03-03 13:07:42'),(83782,258,'Kateeli','261141',1,0,'2022-03-03 13:07:42','2022-03-03 13:07:42'),(83783,258,'Katesar','261135',1,0,'2022-03-03 13:07:42','2022-03-03 13:07:42'),(83784,258,'Kathura','261208',1,0,'2022-03-03 13:07:42','2022-03-03 13:07:42'),(83785,258,'Kathwa','261303',1,0,'2022-03-03 13:07:43','2022-03-03 13:07:43'),(83786,258,'Kauwa Khera','261201',1,0,'2022-03-03 13:07:43','2022-03-03 13:07:43'),(83787,258,'Kazi Sarain','261207',1,0,'2022-03-03 13:07:43','2022-03-03 13:07:43'),(83788,258,'Keora','261204',1,0,'2022-03-03 13:07:43','2022-03-03 13:07:43'),(83789,258,'Keoti Kalan','261121',1,0,'2022-03-03 13:07:43','2022-03-03 13:07:43'),(83790,258,'Keoty Badullah','261201',1,0,'2022-03-03 13:07:43','2022-03-03 13:07:43'),(83791,258,'Keshavpur','261001',1,0,'2022-03-03 13:07:43','2022-03-03 13:07:43'),(83792,258,'Khagesiamau','261001',1,0,'2022-03-03 13:07:43','2022-03-03 13:07:43'),(83793,258,'Khairabad (Sitapur)','261131',1,0,'2022-03-03 13:07:43','2022-03-03 13:07:43'),(83794,258,'Khalgaon','261301',1,0,'2022-03-03 13:07:43','2022-03-03 13:07:43'),(83795,258,'Khanpur','261202',1,0,'2022-03-03 13:07:43','2022-03-03 13:07:43'),(83796,258,'Kharwalia','261301',1,0,'2022-03-03 13:07:43','2022-03-03 13:07:43'),(83797,258,'Kishunpur','261401',1,0,'2022-03-03 13:07:43','2022-03-03 13:07:43'),(83798,258,'Kodaura','261205',1,0,'2022-03-03 13:07:43','2022-03-03 13:07:43'),(83799,258,'Kolhuwa','261401',1,0,'2022-03-03 13:07:43','2022-03-03 13:07:43'),(83800,258,'Kondari','261205',1,0,'2022-03-03 13:07:43','2022-03-03 13:07:43'),(83801,258,'Kondaria','261303',1,0,'2022-03-03 13:07:43','2022-03-03 13:07:43'),(83802,258,'Korauna','261403',1,0,'2022-03-03 13:07:43','2022-03-03 13:07:43'),(83803,258,'Koriya Udaipur','261001',1,0,'2022-03-03 13:07:43','2022-03-03 13:07:43'),(83804,258,'Koriya Udnapur','261121',1,0,'2022-03-03 13:07:43','2022-03-03 13:07:43'),(83805,258,'Kothwal','261204',1,0,'2022-03-03 13:07:43','2022-03-03 13:07:43'),(83806,258,'Kotra','261201',1,0,'2022-03-03 13:07:43','2022-03-03 13:07:43'),(83807,258,'Kotra Deokali','261151',1,0,'2022-03-03 13:07:43','2022-03-03 13:07:43'),(83808,258,'Kuchlai','261303',1,0,'2022-03-03 13:07:44','2022-03-03 13:07:44'),(83809,258,'Kunera','261403',1,0,'2022-03-03 13:07:44','2022-03-03 13:07:44'),(83810,258,'Kursi','261303',1,0,'2022-03-03 13:07:44','2022-03-03 13:07:44'),(83811,258,'Kusaila','261141',1,0,'2022-03-03 13:07:44','2022-03-03 13:07:44'),(83812,258,'Kusepa','261136',1,0,'2022-03-03 13:07:44','2022-03-03 13:07:44'),(83813,258,'Kusuma','261121',1,0,'2022-03-03 13:07:44','2022-03-03 13:07:44'),(83814,258,'Laharpur East','261135',1,0,'2022-03-03 13:07:44','2022-03-03 13:07:44'),(83815,258,'Laharpur','261135',1,0,'2022-03-03 13:07:44','2022-03-03 13:07:44'),(83816,258,'Lakhuwabehar','261136',1,0,'2022-03-03 13:07:44','2022-03-03 13:07:44'),(83817,258,'Lalpuir','261302',1,0,'2022-03-03 13:07:44','2022-03-03 13:07:44'),(83818,258,'Lalpur','261136',1,0,'2022-03-03 13:07:44','2022-03-03 13:07:44'),(83819,258,'Lashkarpur','261201',1,0,'2022-03-03 13:07:44','2022-03-03 13:07:44'),(83820,258,'Lauli','261403',1,0,'2022-03-03 13:07:44','2022-03-03 13:07:44'),(83821,258,'Lilsi','261001',1,0,'2022-03-03 13:07:44','2022-03-03 13:07:44'),(83822,258,'Lohar Bagh','261001',1,0,'2022-03-03 13:07:44','2022-03-03 13:07:44'),(83823,258,'Lohiyanagar','261204',1,0,'2022-03-03 13:07:44','2022-03-03 13:07:44'),(83824,258,'Machharehta','261405',1,0,'2022-03-03 13:07:44','2022-03-03 13:07:44'),(83825,258,'Madhawapur','261302',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83826,258,'Madnapur','261201',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83827,258,'Magdapur','261205',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83828,258,'Maharaj Nagar','261201',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83829,258,'Mahmudabad','261203',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83830,258,'Maholi','261141',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83831,258,'Mainasi Saraiyan','261001',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83832,258,'Maithaura','261136',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83833,258,'Makanpur','261135',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83834,258,'Makhpur Jareli','261207',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83835,258,'Makhuwapur','261302',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83836,258,'Mallapur','261208',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83837,258,'Manapur','261203',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83838,258,'Manduri','261301',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83839,258,'Mangrahiya Bazar','261201',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83840,258,'Manikapur','261201',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83841,258,'Manpur (Sitapur)','261145',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83842,258,'Manwa','261303',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83843,258,'Marahmatnagar','261203',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83844,258,'Mareli','261403',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83845,258,'Maror','261136',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83846,258,'Marsanda','261136',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83847,258,'Marsanda','261145',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83848,258,'Mathan','261151',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83849,258,'Matuwa Saraiyan','261136',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83850,258,'Mazlishpur','261125',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83851,258,'Meer Nagar','261206',1,0,'2022-03-03 13:07:45','2022-03-03 13:07:45'),(83852,258,'Meeranagar','261203',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83853,258,'Mirzapur','261001',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83854,258,'Mishrikh','261401',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83855,258,'Mishrikh Tirth','261401',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83856,258,'Mohammadpur Kadim','261203',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83857,258,'Mohkampur Mandaruwa','261401',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83858,258,'Mubarakpur','261207',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83859,258,'Mubarakpur Udaipur','261125',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83860,258,'Mudia Kail','261403',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83861,258,'Mudikhera','261121',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83862,258,'Mudila','261208',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83863,258,'Mudrasan','261135',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83864,258,'Mumtajpur','261121',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83865,258,'Munderi','261145',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83866,258,'Murai Tajpur','261121',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83867,258,'Murthana','261135',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83868,258,'Musabbarpur','261151',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83869,258,'Nabinagar','261135',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83870,258,'Nai Basti (Sitapur)','261001',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83871,258,'Naimisharanya','261402',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83872,258,'Naseerpur','261202',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83873,258,'Nauwa Mahmoodpur','261125',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83874,258,'Neelgaon','261301',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83875,258,'Neorajpur','261302',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83876,258,'Neri','261141',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83877,258,'Neri Kalan','261001',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83878,258,'Nerpur','261131',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83879,258,'Newada','261121',1,0,'2022-03-03 13:07:46','2022-03-03 13:07:46'),(83880,258,'Newada Nayagaon','261135',1,0,'2022-03-03 13:07:47','2022-03-03 13:07:47'),(83881,258,'Nighuwamau','261404',1,0,'2022-03-03 13:07:47','2022-03-03 13:07:47'),(83882,258,'Nimauchi','261135',1,0,'2022-03-03 13:07:47','2022-03-03 13:07:47'),(83883,258,'Niyamatpur Labarha','261203',1,0,'2022-03-03 13:07:47','2022-03-03 13:07:47'),(83884,258,'Old Town (Sitapur)','261001',1,0,'2022-03-03 13:07:47','2022-03-03 13:07:47'),(83885,258,'Pachhimgaon','261303',1,0,'2022-03-03 13:07:47','2022-03-03 13:07:47'),(83886,258,'Padrakha','261001',1,0,'2022-03-03 13:07:47','2022-03-03 13:07:47'),(83887,258,'Padukha','261203',1,0,'2022-03-03 13:07:47','2022-03-03 13:07:47'),(83888,258,'Paharpur Maheshpur','261131',1,0,'2022-03-03 13:07:47','2022-03-03 13:07:47'),(83889,258,'Pahla','261206',1,0,'2022-03-03 13:07:47','2022-03-03 13:07:47'),(83890,258,'Pailakisha','261141',1,0,'2022-03-03 13:07:47','2022-03-03 13:07:47'),(83891,258,'Painteypur','261203',1,0,'2022-03-03 13:07:47','2022-03-03 13:07:47'),(83892,258,'Palhari','261202',1,0,'2022-03-03 13:07:47','2022-03-03 13:07:47'),(83893,258,'Panditpurwa','261205',1,0,'2022-03-03 13:07:47','2022-03-03 13:07:47'),(83894,258,'Para Ramnagra','261204',1,0,'2022-03-03 13:07:47','2022-03-03 13:07:47'),(83895,258,'Parewajal','261303',1,0,'2022-03-03 13:07:47','2022-03-03 13:07:47'),(83896,258,'Parsada','261404',1,0,'2022-03-03 13:07:47','2022-03-03 13:07:47'),(83897,258,'Parsehra','261404',1,0,'2022-03-03 13:07:47','2022-03-03 13:07:47'),(83898,258,'Parsehra Nath','261121',1,0,'2022-03-03 13:07:47','2022-03-03 13:07:47'),(83899,258,'Parsendi','261207',1,0,'2022-03-03 13:07:47','2022-03-03 13:07:47'),(83900,258,'Parwatpur','261203',1,0,'2022-03-03 13:07:47','2022-03-03 13:07:47'),(83901,258,'Patabodh','261141',1,0,'2022-03-03 13:07:47','2022-03-03 13:07:47'),(83902,258,'Phoolpur','261302',1,0,'2022-03-03 13:07:47','2022-03-03 13:07:47'),(83903,258,'Phulruwa','261401',1,0,'2022-03-03 13:07:47','2022-03-03 13:07:47'),(83904,258,'Pichhaura','261121',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83905,258,'Pisawan','261151',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83906,258,'Pokhra Kalan','261201',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83907,258,'Punjikhera','261202',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83908,258,'Purwa  Rewan','261203',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83909,258,'Purwa Dasa Pur','261145',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83910,258,'Qutubnagar','261401',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83911,258,'R.P.V.','261001',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83912,258,'Rahimabad','261131',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83913,258,'Raipur Deo Singh','261303',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83914,258,'Raipur Ganj','261135',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83915,258,'Rajapur Kalan','261206',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83916,258,'Rajapur Kalan','261205',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83917,258,'Rajepara','261405',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83918,258,'Rajepur','261121',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83919,258,'Rakhauna','261121',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83920,258,'Ralamau','261403',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83921,258,'Ramabhari','261201',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83922,258,'Ramgarh','261403',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83923,258,'Ramkot','261001',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83924,258,'Ramnagar','261135',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83925,258,'Rampur Kalan','261206',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83926,258,'Rampur Mathura','261204',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83927,258,'Ramshala','261403',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83928,258,'Ramuwapur','261208',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83929,258,'Razakarnai','261201',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83930,258,'Rehar','261208',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83931,258,'Rehuwa','261301',1,0,'2022-03-03 13:07:48','2022-03-03 13:07:48'),(83932,258,'Reosa','261205',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83933,258,'Reseura Form','261001',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83934,258,'Rewan','261202',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83935,258,'Saadat Nagar','261121',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83936,258,'Sadarpur','261201',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83937,258,'Sadhuwapur','261204',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83938,258,'Sadikapur','261141',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83939,258,'Sahabnagar','261401',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83940,258,'Saholi','261303',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83941,258,'Sahsapur','261001',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83942,258,'Saidapur','261301',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83943,258,'Sair','261301',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83944,258,'Sakaran','261136',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83945,258,'Sakrara','261404',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83946,258,'Salahpur','261141',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83947,258,'Salpur','261208',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83948,258,'Samaisa','261207',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83949,258,'Samardaha','261203',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83950,258,'Samsapur','261403',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83951,258,'Sanda','261202',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83952,258,'Sandana','261403',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83953,258,'Sarain','261303',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83954,258,'Sarain','261201',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83955,258,'Saraiyan Mahipat Singh','261206',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83956,258,'Saraiyan Raja Saheb','261206',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83957,258,'Saraiyan Sani','261145',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83958,258,'Saraura Kalan','261302',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83959,258,'Sarosa','261403',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83960,258,'Sarwa','261301',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83961,258,'Sarwa Jalalpur','261301',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83962,258,'Second Bn. P.A.C.','261001',1,0,'2022-03-03 13:07:49','2022-03-03 13:07:49'),(83963,258,'Seepatpur','261205',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83964,258,'Sejkhurd','261151',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83965,258,'Selumau','261121',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83966,258,'Semra','261205',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83967,258,'Seota','261205',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83968,258,'Shah Jalalpur','261302',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83969,258,'Shah Maholi','261125',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83970,258,'Shahpur','261135',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83971,258,'Shamshabad','261206',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83972,258,'Shankarpur','261205',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83973,258,'Sharifganj','261131',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83974,258,'Sherpur','261135',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83975,258,'Shivthana','261201',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83976,258,'Sidhauli','261303',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83977,258,'Singhnapur','261136',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83978,258,'Sirsa Khurd','261206',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83979,258,'Sitapur City','261001',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83980,258,'Sitapur H.O','261001',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83981,258,'Sitapur Kutchehry','261001',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83982,258,'Sitarasoi','261303',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83983,258,'Sonari','261125',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83984,258,'Sonawan','261208',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83985,258,'Sonsari','261136',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83986,258,'Suhetara','261131',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83987,258,'Sujaulia','261302',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83988,258,'Sujawalpur','261208',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83989,258,'Sultanapur','261206',1,0,'2022-03-03 13:07:50','2022-03-03 13:07:50'),(83990,258,'Sumrawan','261136',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(83991,258,'Supauli','261202',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(83992,258,'Suraincha','261302',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(83993,258,'Talgaon','261207',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(83994,258,'Tambour','261208',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(83995,258,'Tanda Kalan','261136',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(83996,258,'Tappa Khajuriya','261131',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(83997,258,'Tareenpur','261001',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(83998,258,'Tatroi','261403',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(83999,258,'Tendua','261145',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(84000,258,'Teola','261207',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(84001,258,'Terwa','261303',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(84002,258,'Terwa Manikapur','261204',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(84003,258,'Thangaon','261205',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(84004,258,'Thoura','261205',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(84005,258,'Tihar','261121',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(84006,258,'Tikra','261201',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(84007,258,'Tikra Teekar','261141',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(84008,258,'Ulara','261145',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(84009,258,'Umari','261121',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(84010,258,'Umari Ganeshpur','261204',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(84011,258,'Unchakhera Ajai','261301',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(84012,258,'Unchakhera Kalan','261302',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(84013,258,'Urdauli','261141',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(84014,258,'Vijay Laxmi Nagar','261001',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(84015,258,'Wazirnagar','261141',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(84016,258,'Xi Bn. P.A.C.','261001',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(84017,259,'Adalganj','231205',1,0,'2022-03-03 13:07:51','2022-03-03 13:07:51'),(84018,259,'Akchhor','231216',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84019,259,'Amilaudha','231210',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84020,259,'Amwar','231212',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84021,259,'Anpara Tps','231225',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84022,259,'Arangpani','231208',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84023,259,'Asanahar','231223',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84024,259,'Babhani','231208',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84025,259,'Bachara','231223',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84026,259,'Badgaon','231205',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84027,259,'Bagesoti','231226',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84028,259,'Bagharu','231212',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84029,259,'Bahuar','231216',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84030,259,'Bahuara','231216',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84031,259,'Bairpan','231225',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84032,259,'Bairpur','231208',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84033,259,'Banki','231213',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84034,259,'Banvasi Seva Ashram','231221',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84035,259,'Beej Pur','231223',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84036,259,'Beena Project','231220',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84037,259,'Belhatthi','231217',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84038,259,'Bharahari','231205',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84039,259,'Bichchhi','231216',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84040,259,'Billi Markundi','231219',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84041,259,'Chachikalan','231226',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84042,259,'Chapki','231223',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84043,259,'Chatarvar','231205',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84044,259,'Cherui','231206',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84045,259,'Chopan','231205',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84046,259,'Churk','231206',1,0,'2022-03-03 13:07:52','2022-03-03 13:07:52'),(84047,259,'Dalla','231207',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84048,259,'Dharnipur','231216',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84049,259,'Dharti Dand','231223',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84050,259,'Dhuma','231226',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84051,259,'Dibulgani','231225',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84052,259,'Dohari','231215',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84053,259,'Dudhi','231208',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84054,259,'Ekdari','231208',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84055,259,'Gadia','231208',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84056,259,'Ghaghara','231212',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84057,259,'Ghaghari','231223',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84058,259,'Ghiwahi','231226',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84059,259,'Ghorawal','231210',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84060,259,'Ghorpa','231226',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84061,259,'Gurma Markundi','231209',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84062,259,'Gurmura','231207',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84063,259,'Hathwani','231208',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84064,259,'Hinauta','231216',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84065,259,'Jamgaon','231215',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84066,259,'Jarhan','231223',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84067,259,'Jharo Khurd','231208',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84068,259,'Jugail','231205',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84069,259,'Kachnarwa','231226',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84070,259,'Kaithi','231216',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84071,259,'Kakarahi','231216',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84072,259,'Kakari Project','231224',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84073,259,'Kalwari Mafi','231210',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84074,259,'Kanachh','231205',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84075,259,'Kandhaura','231225',1,0,'2022-03-03 13:07:53','2022-03-03 13:07:53'),(84076,259,'Kanethi','231210',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84077,259,'Karahia','231208',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84078,259,'Kargara','231205',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84079,259,'Karma','231216',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84080,259,'Kasyakala','231216',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84081,259,'Kewal','231226',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84082,259,'Khadia Project','231222',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84083,259,'Khairahi','231216',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84084,259,'Khairpur','231216',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84085,259,'Khajura','231218',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84086,259,'Kharhara','231205',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84087,259,'Khokha Karahia','231208',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84088,259,'Kirbil','231208',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84089,259,'Kone','231226',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84090,259,'Kota','231207',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84091,259,'Kudari','231205',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84092,259,'Kudwan','231226',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84093,259,'Lilasikala','231212',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84094,259,'Lohadi','231210',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84095,259,'Maachi','231213',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84096,259,'Madhupura','231216',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84097,259,'Mahuaria','231212',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84098,259,'Mahuli','231208',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84099,259,'Majhi  Dand','231213',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84100,259,'Mokarsim','231216',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84101,259,'Mudiladeeh','231215',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84102,259,'Myorpur','231208',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84103,259,'Nadhira','231223',1,0,'2022-03-03 13:07:54','2022-03-03 13:07:54'),(84104,259,'Nai Bazar','231216',1,0,'2022-03-03 13:07:55','2022-03-03 13:07:55'),(84105,259,'Nandana','231213',1,0,'2022-03-03 13:07:55','2022-03-03 13:07:55'),(84106,259,'Narokhar','231216',1,0,'2022-03-03 13:07:55','2022-03-03 13:07:55'),(84107,259,'Naudiha  Ramgarh','231226',1,0,'2022-03-03 13:07:55','2022-03-03 13:07:55'),(84108,259,'Naudiha','231212',1,0,'2022-03-03 13:07:55','2022-03-03 13:07:55'),(84109,259,'Naudiha Mishri','231226',1,0,'2022-03-03 13:07:55','2022-03-03 13:07:55'),(84110,259,'Newari','231205',1,0,'2022-03-03 13:07:55','2022-03-03 13:07:55'),(84111,259,'Obra (Sonbhadra)','231219',1,0,'2022-03-03 13:07:55','2022-03-03 13:07:55'),(84112,259,'Obra Thermal','231219',1,0,'2022-03-03 13:07:55','2022-03-03 13:07:55'),(84113,259,'Oeni Mishra','231216',1,0,'2022-03-03 13:07:55','2022-03-03 13:07:55'),(84114,259,'Padarachh','231207',1,0,'2022-03-03 13:07:55','2022-03-03 13:07:55'),(84115,259,'Padarikala','231213',1,0,'2022-03-03 13:07:55','2022-03-03 13:07:55'),(84116,259,'Padwania','231210',1,0,'2022-03-03 13:07:55','2022-03-03 13:07:55'),(84117,259,'Pakarhat','231213',1,0,'2022-03-03 13:07:55','2022-03-03 13:07:55'),(84118,259,'Pakari','231208',1,0,'2022-03-03 13:07:55','2022-03-03 13:07:55'),(84119,259,'Panari','231219',1,0,'2022-03-03 13:07:55','2022-03-03 13:07:55'),(84120,259,'Panauli','231215',1,0,'2022-03-03 13:07:55','2022-03-03 13:07:55'),(84121,259,'Pannuganj','231213',1,0,'2022-03-03 13:07:55','2022-03-03 13:07:55'),(84122,259,'Parasi Dubey','231216',1,0,'2022-03-03 13:07:55','2022-03-03 13:07:55'),(84123,259,'Parsoi','231219',1,0,'2022-03-03 13:07:55','2022-03-03 13:07:55'),(84124,259,'Parsona','231210',1,0,'2022-03-03 13:07:55','2022-03-03 13:07:55'),(84125,259,'Pauni','231213',1,0,'2022-03-03 13:07:55','2022-03-03 13:07:55'),(84126,259,'Pindari','231223',1,0,'2022-03-03 13:07:55','2022-03-03 13:07:55'),(84127,259,'Radhore','231225',1,0,'2022-03-03 13:07:55','2022-03-03 13:07:55'),(84128,259,'Raipur','231213',1,0,'2022-03-03 13:07:56','2022-03-03 13:07:56'),(84129,259,'Rajkhad','231208',1,0,'2022-03-03 13:07:56','2022-03-03 13:07:56'),(84130,259,'Rajpur (Sonbhadra)','231215',1,0,'2022-03-03 13:07:56','2022-03-03 13:07:56'),(84131,259,'Ram Garh','231213',1,0,'2022-03-03 13:07:56','2022-03-03 13:07:56'),(84132,259,'Rampur','231213',1,0,'2022-03-03 13:07:56','2022-03-03 13:07:56'),(84133,259,'Renukoot','231217',1,0,'2022-03-03 13:07:56','2022-03-03 13:07:56'),(84134,259,'Renusagar','231218',1,0,'2022-03-03 13:07:56','2022-03-03 13:07:56'),(84135,259,'Retikala','231213',1,0,'2022-03-03 13:07:56','2022-03-03 13:07:56'),(84136,259,'Rizul','231210',1,0,'2022-03-03 13:07:56','2022-03-03 13:07:56'),(84137,259,'Robertsganj Hydle Colony','231216',1,0,'2022-03-03 13:07:56','2022-03-03 13:07:56'),(84138,259,'Robertsganj','231216',1,0,'2022-03-03 13:07:56','2022-03-03 13:07:56'),(84139,259,'Sabha Lilwahi','231210',1,0,'2022-03-03 13:07:56','2022-03-03 13:07:56'),(84140,259,'Sagobandh','231212',1,0,'2022-03-03 13:07:56','2022-03-03 13:07:56'),(84141,259,'Sahijankala','231216',1,0,'2022-03-03 13:07:56','2022-03-03 13:07:56'),(84142,259,'Salkhan','231205',1,0,'2022-03-03 13:07:56','2022-03-03 13:07:56'),(84143,259,'Sandi','231213',1,0,'2022-03-03 13:07:56','2022-03-03 13:07:56'),(84144,259,'Sarvat','231215',1,0,'2022-03-03 13:07:56','2022-03-03 13:07:56'),(84145,259,'Satbahani','231208',1,0,'2022-03-03 13:07:56','2022-03-03 13:07:56'),(84146,259,'Shahganj','231215',1,0,'2022-03-03 13:07:56','2022-03-03 13:07:56'),(84147,259,'Shaktinagar (Sonbhadra)','231222',1,0,'2022-03-03 13:07:56','2022-03-03 13:07:56'),(84148,259,'Shaktinagar Thermal Power Stat','231222',1,0,'2022-03-03 13:07:57','2022-03-03 13:07:57'),(84149,259,'Sherwan','231226',1,0,'2022-03-03 13:07:57','2022-03-03 13:07:57'),(84150,259,'Shivdwar','231210',1,0,'2022-03-03 13:07:57','2022-03-03 13:07:57'),(84151,259,'Shivpur','231213',1,0,'2022-03-03 13:07:57','2022-03-03 13:07:57'),(84152,259,'Siddhi Kala','231216',1,0,'2022-03-03 13:07:57','2022-03-03 13:07:57'),(84153,259,'Siltham','231213',1,0,'2022-03-03 13:07:57','2022-03-03 13:07:57'),(84154,259,'Sindoor','231223',1,0,'2022-03-03 13:07:57','2022-03-03 13:07:57'),(84155,259,'Sinduria','231205',1,0,'2022-03-03 13:07:57','2022-03-03 13:07:57'),(84156,259,'Sukhdevanand Ashram','231217',1,0,'2022-03-03 13:07:57','2022-03-03 13:07:57'),(84157,259,'Sukrut','231216',1,0,'2022-03-03 13:07:57','2022-03-03 13:07:57'),(84158,259,'Sundari','231212',1,0,'2022-03-03 13:07:57','2022-03-03 13:07:57'),(84159,259,'Tarawan','231216',1,0,'2022-03-03 13:07:57','2022-03-03 13:07:57'),(84160,259,'Tendu','231216',1,0,'2022-03-03 13:07:57','2022-03-03 13:07:57'),(84161,259,'Turra','231221',1,0,'2022-03-03 13:07:57','2022-03-03 13:07:57'),(84162,259,'Wyndhamganj','231226',1,0,'2022-03-03 13:07:57','2022-03-03 13:07:57'),(84163,259,'Yogichaura','231222',1,0,'2022-03-03 13:07:57','2022-03-03 13:07:57'),(84164,260,'Abhiya Kalan','228001',1,0,'2022-03-03 13:07:57','2022-03-03 13:07:57'),(84165,260,'Achalpur','227801',1,0,'2022-03-03 13:07:57','2022-03-03 13:07:57'),(84166,260,'Adhanpur','227813',1,0,'2022-03-03 13:07:57','2022-03-03 13:07:57'),(84167,260,'Agahar','227405',1,0,'2022-03-03 13:07:57','2022-03-03 13:07:57'),(84168,260,'Agai','228121',1,0,'2022-03-03 13:07:57','2022-03-03 13:07:57'),(84169,260,'Ahda','228132',1,0,'2022-03-03 13:07:57','2022-03-03 13:07:57'),(84170,260,'Ahimane','228001',1,0,'2022-03-03 13:07:57','2022-03-03 13:07:57'),(84171,260,'Aindhi','227409',1,0,'2022-03-03 13:07:57','2022-03-03 13:07:57'),(84172,260,'Ainjar','227814',1,0,'2022-03-03 13:07:57','2022-03-03 13:07:57'),(84173,260,'Akhandnagar','228171',1,0,'2022-03-03 13:07:57','2022-03-03 13:07:57'),(84174,260,'Akorhi','228151',1,0,'2022-03-03 13:07:58','2022-03-03 13:07:58'),(84175,260,'Alahdadpur','227816',1,0,'2022-03-03 13:07:58','2022-03-03 13:07:58'),(84176,260,'Aliganj Bazar','227805',1,0,'2022-03-03 13:07:58','2022-03-03 13:07:58'),(84177,260,'Alimuddinpur','228171',1,0,'2022-03-03 13:07:58','2022-03-03 13:07:58'),(84178,260,'Alipur Saravan','228171',1,0,'2022-03-03 13:07:58','2022-03-03 13:07:58'),(84179,260,'Amari','228161',1,0,'2022-03-03 13:07:58','2022-03-03 13:07:58'),(84180,260,'Amethi H.O','227405',1,0,'2022-03-03 13:07:58','2022-03-03 13:07:58'),(84181,260,'Amilia Sikara','228141',1,0,'2022-03-03 13:07:58','2022-03-03 13:07:58'),(84182,260,'Anapur','227409',1,0,'2022-03-03 13:07:58','2022-03-03 13:07:58'),(84183,260,'Angnakol','228118',1,0,'2022-03-03 13:07:58','2022-03-03 13:07:58'),(84184,260,'Angrawan','227801',1,0,'2022-03-03 13:07:58','2022-03-03 13:07:58'),(84185,260,'Anirudhpur','228171',1,0,'2022-03-03 13:07:58','2022-03-03 13:07:58'),(84186,260,'Arjunpur','227304',1,0,'2022-03-03 13:07:58','2022-03-03 13:07:58'),(84187,260,'Arjunpur','227409',1,0,'2022-03-03 13:07:58','2022-03-03 13:07:58'),(84188,260,'Asarfpur','227813',1,0,'2022-03-03 13:07:58','2022-03-03 13:07:58'),(84189,260,'Asura','227409',1,0,'2022-03-03 13:07:58','2022-03-03 13:07:58'),(84190,260,'Atarsuma','228121',1,0,'2022-03-03 13:07:58','2022-03-03 13:07:58'),(84191,260,'Ataula','227814',1,0,'2022-03-03 13:07:58','2022-03-03 13:07:58'),(84192,260,'Athaisi','228120',1,0,'2022-03-03 13:07:58','2022-03-03 13:07:58'),(84193,260,'Aurangabad','227813',1,0,'2022-03-03 13:07:58','2022-03-03 13:07:58'),(84194,260,'Ausanpur','227304',1,0,'2022-03-03 13:07:58','2022-03-03 13:07:58'),(84195,260,'Babhangawan','228151',1,0,'2022-03-03 13:07:58','2022-03-03 13:07:58'),(84196,260,'Baburi','227805',1,0,'2022-03-03 13:07:58','2022-03-03 13:07:58'),(84197,260,'Bahadurpur','228001',1,0,'2022-03-03 13:07:58','2022-03-03 13:07:58'),(84198,260,'Baharpur','227816',1,0,'2022-03-03 13:07:58','2022-03-03 13:07:58'),(84199,260,'Bahauddinpur','228133',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84200,260,'Bahlolpur','227808',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84201,260,'Bahrauli','227816',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84202,260,'Bahrauli','222302',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84203,260,'Bahurahwan','227814',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84204,260,'Baidaha','228119',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84205,260,'Baijapur','228001',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84206,260,'Bainti Kalan','222301',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84207,260,'Balbhadrapur','227801',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84208,260,'Ballipur','228125',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84209,260,'Bandhua Kalan','227808',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84210,260,'Bani','228131',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84211,260,'Banke Gaon','228145',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84212,260,'Bankepur','227808',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84213,260,'Bansi','228155',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84214,260,'Baqghauna','227814',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84215,260,'Baranpur','227812',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84216,260,'Baraulia','227801',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84217,260,'Barauna Dih','228145',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84218,260,'Baraunsa','228120',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84219,260,'Baregaon','228119',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84220,260,'Barehti','227807',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84221,260,'Bargaon','227407',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84222,260,'Bariauna','228151',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84223,260,'Barmhauli','227814',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84224,260,'Barna Tikar','227409',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84225,260,'Barsanda','227816',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84226,260,'Barsara','222302',1,0,'2022-03-03 13:07:59','2022-03-03 13:07:59'),(84227,260,'Barua','222302',1,0,'2022-03-03 13:08:00','2022-03-03 13:08:00'),(84228,260,'Barwaripur','228145',1,0,'2022-03-03 13:08:00','2022-03-03 13:08:00'),(84229,260,'Basti Dei','227409',1,0,'2022-03-03 13:08:00','2022-03-03 13:08:00'),(84230,260,'Basupur','228133',1,0,'2022-03-03 13:08:00','2022-03-03 13:08:00'),(84231,260,'Baura Jagdishpur','228142',1,0,'2022-03-03 13:08:00','2022-03-03 13:08:00'),(84232,260,'Bazar Baldirai','227806',1,0,'2022-03-03 13:08:00','2022-03-03 13:08:00'),(84233,260,'Bela Pashchim','227805',1,0,'2022-03-03 13:08:00','2022-03-03 13:08:00'),(84234,260,'Belahari','228133',1,0,'2022-03-03 13:08:00','2022-03-03 13:08:00'),(84235,260,'Belahi','222302',1,0,'2022-03-03 13:08:00','2022-03-03 13:08:00'),(84236,260,'Benipur','227405',1,0,'2022-03-03 13:08:00','2022-03-03 13:08:00'),(84237,260,'Bethara','228131',1,0,'2022-03-03 13:08:00','2022-03-03 13:08:00'),(84238,260,'Bhada','227816',1,0,'2022-03-03 13:08:00','2022-03-03 13:08:00'),(84239,260,'Bhadaiyan','222302',1,0,'2022-03-03 13:08:00','2022-03-03 13:08:00'),(84240,260,'Bhadar','227406',1,0,'2022-03-03 13:08:00','2022-03-03 13:08:00'),(84241,260,'Bhain','227816',1,0,'2022-03-03 13:08:00','2022-03-03 13:08:00'),(84242,260,'Bhakhari','227806',1,0,'2022-03-03 13:08:00','2022-03-03 13:08:00'),(84243,260,'Bhanauli','227813',1,0,'2022-03-03 13:08:00','2022-03-03 13:08:00'),(84244,260,'Bhandara','228155',1,0,'2022-03-03 13:08:00','2022-03-03 13:08:00'),(84245,260,'Bhanti','227408',1,0,'2022-03-03 13:08:00','2022-03-03 13:08:00'),(84246,260,'Bhapta','228001',1,0,'2022-03-03 13:08:00','2022-03-03 13:08:00'),(84247,260,'Bhardhipur','227304',1,0,'2022-03-03 13:08:00','2022-03-03 13:08:00'),(84248,260,'Bharkhare','227304',1,0,'2022-03-03 13:08:00','2022-03-03 13:08:00'),(84249,260,'Bhatauta Tulsi Patti','228161',1,0,'2022-03-03 13:08:01','2022-03-03 13:08:01'),(84250,260,'Bhatgawan','227801',1,0,'2022-03-03 13:08:01','2022-03-03 13:08:01'),(84251,260,'Bhawapur','227406',1,0,'2022-03-03 13:08:01','2022-03-03 13:08:01'),(84252,260,'Bhenwai','227816',1,0,'2022-03-03 13:08:01','2022-03-03 13:08:01'),(84253,260,'Bhikhipur','227807',1,0,'2022-03-03 13:08:01','2022-03-03 13:08:01'),(84254,260,'Bhikhupur','228142',1,0,'2022-03-03 13:08:01','2022-03-03 13:08:01'),(84255,260,'Bhilampur','228131',1,0,'2022-03-03 13:08:01','2022-03-03 13:08:01'),(84256,260,'Bhimi Pachchhim','227413',1,0,'2022-03-03 13:08:01','2022-03-03 13:08:01'),(84257,260,'Bhoen','227801',1,0,'2022-03-03 13:08:01','2022-03-03 13:08:01'),(84258,260,'Bhua Pathkauli','222303',1,0,'2022-03-03 13:08:01','2022-03-03 13:08:01'),(84259,260,'Bijhuri','228142',1,0,'2022-03-03 13:08:01','2022-03-03 13:08:01'),(84260,260,'Bikana','227408',1,0,'2022-03-03 13:08:01','2022-03-03 13:08:01'),(84261,260,'Bikwajitpur','228001',1,0,'2022-03-03 13:08:01','2022-03-03 13:08:01'),(84262,260,'Bingi','228121',1,0,'2022-03-03 13:08:01','2022-03-03 13:08:01'),(84263,260,'Biraipur','228141',1,0,'2022-03-03 13:08:01','2022-03-03 13:08:01'),(84264,260,'Biri Hajipur','228145',1,0,'2022-03-03 13:08:01','2022-03-03 13:08:01'),(84265,260,'Birsinghpur','228141',1,0,'2022-03-03 13:08:01','2022-03-03 13:08:01'),(84266,260,'Bisara Pashchim','227807',1,0,'2022-03-03 13:08:01','2022-03-03 13:08:01'),(84267,260,'Bisawan','227812',1,0,'2022-03-03 13:08:01','2022-03-03 13:08:01'),(84268,260,'Bisesarganj','227407',1,0,'2022-03-03 13:08:01','2022-03-03 13:08:01'),(84269,260,'Bisundaspur','227409',1,0,'2022-03-03 13:08:01','2022-03-03 13:08:01'),(84270,260,'Budhapur','222302',1,0,'2022-03-03 13:08:01','2022-03-03 13:08:01'),(84271,260,'Burhana','228145',1,0,'2022-03-03 13:08:01','2022-03-03 13:08:01'),(84272,260,'Bus Station (Sultanpur)','228001',1,0,'2022-03-03 13:08:01','2022-03-03 13:08:01'),(84273,260,'Chakchurawanpur','228151',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84274,260,'Chanauki','227813',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84275,260,'Chandaur','228121',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84276,260,'Chandheria','227413',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84277,260,'Chandipur','228151',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84278,260,'Chaukia','222302',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84279,260,'Chhapar','222303',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84280,260,'Chhatauna','228001',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84281,260,'Chhitepatti','228131',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84282,260,'Chorma','228142',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84283,260,'Civil Lines Sultanpur','228001',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84284,260,'Dadra','227813',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84285,260,'Dadupur','227815',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84286,260,'Dahiyawan','227406',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84287,260,'Dakhin Gaon','227411',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84288,260,'Damodarpur','228120',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84289,260,'Daria Amrethu','228145',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84290,260,'Darkha','227405',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84291,260,'Darpipur','227412',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84292,260,'Deara','228132',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84293,260,'Dehli Mubarakpur','228133',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84294,260,'Dehriyawan','227806',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84295,260,'Deokali','227816',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84296,260,'Deora','227814',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84297,260,'Deorajpur','228161',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84298,260,'Deraha','227413',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84299,260,'Dewarh','222303',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84300,260,'Dhajai Keshavpur','228151',1,0,'2022-03-03 13:08:02','2022-03-03 13:08:02'),(84301,260,'Dhakwa','228001',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84302,260,'Dhammaur','227408',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84303,260,'Dhanapur','227407',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84304,260,'Dhanaupur','228131',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84305,260,'Dhani Jalalpur','227409',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84306,260,'Dharai Mafi','227412',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84307,260,'Dharawan','227805',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84308,260,'Dharsauli','228141',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84309,260,'Dheka Pakhanpur','228151',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84310,260,'Dhema','228132',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84311,260,'Dhema','227816',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84312,260,'Dhundhu','228151',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84313,260,'Dih','227806',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84314,260,'Dih Dhaggupur','228125',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84315,260,'Dobhiara','227815',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84316,260,'Domadih','227809',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84317,260,'Dostpur','228131',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84318,260,'Dubepur','227815',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84319,260,'Dulari Nagar','227809',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84320,260,'Durgapur','227816',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84321,260,'Dwarikaganj','228125',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84322,260,'Faridpur','228171',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84323,260,'Fatehpur Sangat','228119',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84324,260,'Ferozpur Kala','228155',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84325,260,'Gaderi','227405',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84326,260,'Gai Mau','227809',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84327,260,'Gajanpur Duaria','227813',1,0,'2022-03-03 13:08:03','2022-03-03 13:08:03'),(84328,260,'Ganpat Sahai Degree College','228001',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84329,260,'Garabpur','222302',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84330,260,'Garayen','227304',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84331,260,'Gaura','228151',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84332,260,'Gaura Jamon','227801',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84333,260,'Gaura Katari','227801',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84334,260,'Gaura Loharia','227806',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84335,260,'Gaura Tikari','228161',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84336,260,'Gauriganj','227409',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84337,260,'Ghatampur','222302',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84338,260,'Gorabarik','228001',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84339,260,'Goriabad','227809',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84340,260,'Gosainganj (Sultanpur)','228119',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84341,260,'Gosaisinghpur','228131',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84342,260,'Guawan','227409',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84343,260,'Gunnaur','227807',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84344,260,'Guptarganj','228151',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84345,260,'H A L Korwa','227412',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84346,260,'Haji Patti','227805',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84347,260,'Haliapur','227815',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84348,260,'Hamidpur','228145',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84349,260,'Hamjapur Pathan','228145',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84350,260,'Hamzabad','228132',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84351,260,'Hanumanganj','228001',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84352,260,'Hardaspur','222302',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84353,260,'Hardoia','227807',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84354,260,'Hardon','227409',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84355,260,'Hargaon','227801',1,0,'2022-03-03 13:08:04','2022-03-03 13:08:04'),(84356,260,'Harha','227304',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84357,260,'Hari Mau','227809',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84358,260,'Haripur','228161',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84359,260,'Harkaranpur','227807',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84360,260,'Harkhumau','227811',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84361,260,'Harthua Babhanpur','228171',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84362,260,'Hasanpur (Sultanpur)','227808',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84363,260,'Hatiyawan','228131',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84364,260,'Hayatnagar','228119',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84365,260,'Hinduabad','228161',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84366,260,'Hussainganj Kala','227816',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84367,260,'Ichhuti','227815',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84368,260,'Imligaon','228131',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84369,260,'Imligaon Chupi','227813',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84370,260,'Inayatpur','228125',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84371,260,'Isauli','227813',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84372,260,'Isur','228142',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84373,260,'Jagdishpur Industrial Area','227817',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84374,260,'Jagdishpur (Sultanpur)','227809',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84375,260,'Jagesarganj','227809',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84376,260,'Jaisinghpur (Sultanpur)','228141',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84377,260,'Jajjaur','228121',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84378,260,'Jamalpur Jajrahi','228141',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84379,260,'Jamkhuri','222302',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84380,260,'Jangal Ramnagar','227405',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84381,260,'Jarai Kalan','227815',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84382,260,'Jasapara','228119',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84383,260,'Jhauara','228001',1,0,'2022-03-03 13:08:05','2022-03-03 13:08:05'),(84384,260,'Jura Patti','228151',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84385,260,'Jurupur','227808',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84386,260,'Juthipur','227409',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84387,260,'Kachha Bhitaura','228132',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84388,260,'Kadipur Khurd','228145',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84389,260,'Kadipur','228145',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84390,260,'Kaithapur','227304',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84391,260,'Kaithi Jalalpur','228131',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84392,260,'Kaithwara','228120',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84393,260,'Kakwa','227405',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84394,260,'Kalyanpur','227816',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84395,260,'Kamla Nehru Institute','228118',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84396,260,'Kampa','227806',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84397,260,'Kamrauli','227809',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84398,260,'Kamtaganj','228131',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84399,260,'Kanauli','228125',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84400,260,'Kandhaipur','227304',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84401,260,'Kanehti','227814',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84402,260,'Kankupur','227816',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84403,260,'Karaundi','227413',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84404,260,'Karaundia','228001',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84405,260,'Kareban','228142',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84406,260,'Karnaipur','227413',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84407,260,'Kasara','227413',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84408,260,'Katari','227801',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84409,260,'Katawan','228001',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84410,260,'Katghara Patti','228145',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84411,260,'Katsari','228145',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84412,260,'Kauhar','227411',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84413,260,'Kenaura','227816',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84414,260,'Khadar Basantpur','228155',1,0,'2022-03-03 13:08:06','2022-03-03 13:08:06'),(84415,260,'Khairabad (Sultanpur)','228001',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84416,260,'Khalispur Dingur','228131',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84417,260,'Khanpur','222303',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84418,260,'Kharsara','228132',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84419,260,'Khokhipur','227805',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84420,260,'Kisni','227811',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84421,260,'Kisundaspur','228145',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84422,260,'Kitiyawan','227411',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84423,260,'Kohra','227405',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84424,260,'Koiripur','222301',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84425,260,'Korari Gidhar Shah','227405',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84426,260,'Korari Hir Shah','227411',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84427,260,'Kothara Khurd','222303',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84428,260,'Kotia','227805',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84429,260,'Kotwa Lahangrai','228151',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84430,260,'Kuchhmuchh','228001',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84431,260,'Kumbhi','228131',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84432,260,'Kunda','227411',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84433,260,'Kunda Bhairavpur','228131',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84434,260,'Kurebhar','228151',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84435,260,'Kurwar','228155',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84436,260,'Lahauta','228142',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84437,260,'Lama Bankata','228132',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84438,260,'Lambhua','222302',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84439,260,'Loco Colony','228001',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84440,260,'Lohra Mau','228001',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84441,260,'Loknathpur','228131',1,0,'2022-03-03 13:08:07','2022-03-03 13:08:07'),(84442,260,'Madhavpur Chhatauna','228119',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84443,260,'Magarsan Kala','228161',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84444,260,'Maharani Pachchhim','222303',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84445,260,'Mahdeva','222302',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84446,260,'Mahemau','227816',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84447,260,'Mahmadpur','227405',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84448,260,'Mahmoodpur','228125',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84449,260,'Mahmoodpur Semri','228142',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84450,260,'Mahona','227811',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84451,260,'Mahrajganj','227808',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84452,260,'Mai Ghatkaur','227408',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84453,260,'Majhana','227805',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84454,260,'Makdoomnagar','228121',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84455,260,'Makhdoompur','227816',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84456,260,'Maksudan','222302',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84457,260,'Malhipur','222301',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84458,260,'Malikpur Nonara','228145',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84459,260,'Manapur','227411',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84460,260,'Mangara','227816',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84461,260,'Mangauli','227809',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84462,260,'Mangrauli','227816',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84463,260,'Mangrawan','228161',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84464,260,'Manipur Patna','228125',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84465,260,'Maniyarpur','227808',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84466,260,'Mardanpur','227811',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84467,260,'Mau Atwara','227816',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84468,260,'Mau','227409',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84469,260,'Mawai','227801',1,0,'2022-03-03 13:08:08','2022-03-03 13:08:08'),(84470,260,'Mayang','228121',1,0,'2022-03-03 13:08:09','2022-03-03 13:08:09'),(84471,260,'Mayas','227807',1,0,'2022-03-03 13:08:09','2022-03-03 13:08:09'),(84472,260,'Meghmau','227806',1,0,'2022-03-03 13:08:09','2022-03-03 13:08:09'),(84473,260,'Meopur','228161',1,0,'2022-03-03 13:08:09','2022-03-03 13:08:09'),(84474,260,'Miranpur','227816',1,0,'2022-03-03 13:08:09','2022-03-03 13:08:09'),(84475,260,'Mirpur Saraiya','228133',1,0,'2022-03-03 13:08:09','2022-03-03 13:08:09'),(84476,260,'Misirpur','222302',1,0,'2022-03-03 13:08:09','2022-03-03 13:08:09'),(84477,260,'Misrauli','227407',1,0,'2022-03-03 13:08:09','2022-03-03 13:08:09'),(84478,260,'Misrauli','228119',1,0,'2022-03-03 13:08:09','2022-03-03 13:08:09'),(84479,260,'Mochawa','227816',1,0,'2022-03-03 13:08:09','2022-03-03 13:08:09'),(84480,260,'Mokalpur','228171',1,0,'2022-03-03 13:08:09','2022-03-03 13:08:09'),(84481,260,'Motiganj','228125',1,0,'2022-03-03 13:08:09','2022-03-03 13:08:09'),(84482,260,'Motigarpur','228132',1,0,'2022-03-03 13:08:09','2022-03-03 13:08:09'),(84483,260,'Muhammadpur','227809',1,0,'2022-03-03 13:08:09','2022-03-03 13:08:09'),(84484,260,'Mungar','228141',1,0,'2022-03-03 13:08:09','2022-03-03 13:08:09'),(84485,260,'Murua','228121',1,0,'2022-03-03 13:08:09','2022-03-03 13:08:09'),(84486,260,'Musafirkhana','227813',1,0,'2022-03-03 13:08:09','2022-03-03 13:08:09'),(84487,260,'Musatafabad Saraiya','228145',1,0,'2022-03-03 13:08:09','2022-03-03 13:08:09'),(84488,260,'Nachana','228151',1,0,'2022-03-03 13:08:09','2022-03-03 13:08:09'),(84489,260,'Nandauli','227806',1,0,'2022-03-03 13:08:09','2022-03-03 13:08:09'),(84490,260,'Nandrai','227814',1,0,'2022-03-03 13:08:09','2022-03-03 13:08:09'),(84491,260,'Nanemau','228133',1,0,'2022-03-03 13:08:09','2022-03-03 13:08:09'),(84492,260,'Naraini','227405',1,0,'2022-03-03 13:08:09','2022-03-03 13:08:09'),(84493,260,'Narayanpur','228161',1,0,'2022-03-03 13:08:09','2022-03-03 13:08:09'),(84494,260,'Narayanpur Kalan','228131',1,0,'2022-03-03 13:08:09','2022-03-03 13:08:09'),(84495,260,'Narendapur','222302',1,0,'2022-03-03 13:08:09','2022-03-03 13:08:09'),(84496,260,'Narharpur','222302',1,0,'2022-03-03 13:08:10','2022-03-03 13:08:10'),(84497,260,'Narsara','227806',1,0,'2022-03-03 13:08:10','2022-03-03 13:08:10'),(84498,260,'Naudar','227809',1,0,'2022-03-03 13:08:10','2022-03-03 13:08:10'),(84499,260,'Naugawan Raitasi','227808',1,0,'2022-03-03 13:08:10','2022-03-03 13:08:10'),(84500,260,'Naugawan Tir','228155',1,0,'2022-03-03 13:08:10','2022-03-03 13:08:10'),(84501,260,'Nayakot Dharauli','227807',1,0,'2022-03-03 13:08:10','2022-03-03 13:08:10'),(84502,260,'Nimi','227801',1,0,'2022-03-03 13:08:10','2022-03-03 13:08:10'),(84503,260,'Numayen Merai','228141',1,0,'2022-03-03 13:08:10','2022-03-03 13:08:10'),(84504,260,'Padare','227814',1,0,'2022-03-03 13:08:10','2022-03-03 13:08:10'),(84505,260,'Padari','227405',1,0,'2022-03-03 13:08:10','2022-03-03 13:08:10'),(84506,260,'Paharganj','227405',1,0,'2022-03-03 13:08:10','2022-03-03 13:08:10'),(84507,260,'Paharpur','228161',1,0,'2022-03-03 13:08:10','2022-03-03 13:08:10'),(84508,260,'Paharpur Rai Patti','228131',1,0,'2022-03-03 13:08:10','2022-03-03 13:08:10'),(84509,260,'Paharpur Sarai Bhikham','228132',1,0,'2022-03-03 13:08:10','2022-03-03 13:08:10'),(84510,260,'Pakarpur','228161',1,0,'2022-03-03 13:08:10','2022-03-03 13:08:10'),(84511,260,'Pakhrauli','228001',1,0,'2022-03-03 13:08:10','2022-03-03 13:08:10'),(84512,260,'Palahipur','227808',1,0,'2022-03-03 13:08:10','2022-03-03 13:08:10'),(84513,260,'Pali','227811',1,0,'2022-03-03 13:08:10','2022-03-03 13:08:10'),(84514,260,'Palia','228141',1,0,'2022-03-03 13:08:10','2022-03-03 13:08:10'),(84515,260,'Palia Golpur','228131',1,0,'2022-03-03 13:08:10','2022-03-03 13:08:10'),(84516,260,'Para','227813',1,0,'2022-03-03 13:08:10','2022-03-03 13:08:10'),(84517,260,'Paras Patti','228132',1,0,'2022-03-03 13:08:10','2022-03-03 13:08:10'),(84518,260,'Parasurampur','222302',1,0,'2022-03-03 13:08:11','2022-03-03 13:08:11'),(84519,260,'Parsa Darwa','228142',1,0,'2022-03-03 13:08:11','2022-03-03 13:08:11'),(84520,260,'Parsara','228142',1,0,'2022-03-03 13:08:11','2022-03-03 13:08:11'),(84521,260,'Parsipur','228155',1,0,'2022-03-03 13:08:11','2022-03-03 13:08:11'),(84522,260,'Parvatpur','227801',1,0,'2022-03-03 13:08:11','2022-03-03 13:08:11'),(84523,260,'Parwar','228151',1,0,'2022-03-03 13:08:11','2022-03-03 13:08:11'),(84524,260,'Pashchim Duara','227412',1,0,'2022-03-03 13:08:11','2022-03-03 13:08:11'),(84525,260,'Patipur','227304',1,0,'2022-03-03 13:08:11','2022-03-03 13:08:11'),(84526,260,'Paudhan Rampur','228171',1,0,'2022-03-03 13:08:11','2022-03-03 13:08:11'),(84527,260,'Peero Saraia','227814',1,0,'2022-03-03 13:08:11','2022-03-03 13:08:11'),(84528,260,'Phatefpur','227811',1,0,'2022-03-03 13:08:11','2022-03-03 13:08:11'),(84529,260,'Pichhaura','227813',1,0,'2022-03-03 13:08:11','2022-03-03 13:08:11'),(84530,260,'Pindara','227807',1,0,'2022-03-03 13:08:11','2022-03-03 13:08:11'),(84531,260,'Pindoria','227405',1,0,'2022-03-03 13:08:11','2022-03-03 13:08:11'),(84532,260,'Pipargaon','228121',1,0,'2022-03-03 13:08:11','2022-03-03 13:08:11'),(84533,260,'Pipari','227815',1,0,'2022-03-03 13:08:11','2022-03-03 13:08:11'),(84534,260,'Piparpur','228159',1,0,'2022-03-03 13:08:11','2022-03-03 13:08:11'),(84535,260,'Pratap Pur','228125',1,0,'2022-03-03 13:08:11','2022-03-03 13:08:11'),(84536,260,'Purab Bisara','227813',1,0,'2022-03-03 13:08:11','2022-03-03 13:08:11'),(84537,260,'Purab Gaon','227815',1,0,'2022-03-03 13:08:11','2022-03-03 13:08:11'),(84538,260,'Purab Kasthuni','227805',1,0,'2022-03-03 13:08:12','2022-03-03 13:08:12'),(84539,260,'Purabgaon','227409',1,0,'2022-03-03 13:08:12','2022-03-03 13:08:12'),(84540,260,'Purushottampur','228141',1,0,'2022-03-03 13:08:12','2022-03-03 13:08:12'),(84541,260,'Rachkheta','227809',1,0,'2022-03-03 13:08:12','2022-03-03 13:08:12'),(84542,260,'Raghipur','227409',1,0,'2022-03-03 13:08:12','2022-03-03 13:08:12'),(84543,260,'Raibigo','228145',1,0,'2022-03-03 13:08:12','2022-03-03 13:08:12'),(84544,260,'Raincha','227806',1,0,'2022-03-03 13:08:12','2022-03-03 13:08:12'),(84545,260,'Raipur','222302',1,0,'2022-03-03 13:08:12','2022-03-03 13:08:12'),(84546,260,'Raja Umari','222302',1,0,'2022-03-03 13:08:12','2022-03-03 13:08:12'),(84547,260,'Rajamau','227801',1,0,'2022-03-03 13:08:12','2022-03-03 13:08:12'),(84548,260,'Rajupur','227805',1,0,'2022-03-03 13:08:12','2022-03-03 13:08:12'),(84549,260,'Rajupur Ikdala','228151',1,0,'2022-03-03 13:08:12','2022-03-03 13:08:12'),(84550,260,'Ram Bax Garh','227801',1,0,'2022-03-03 13:08:12','2022-03-03 13:08:12'),(84551,260,'Ram Nagar','227405',1,0,'2022-03-03 13:08:12','2022-03-03 13:08:12'),(84552,260,'Ramapur','227808',1,0,'2022-03-03 13:08:12','2022-03-03 13:08:12'),(84553,260,'Ramganj (Sultanpur)','228159',1,0,'2022-03-03 13:08:12','2022-03-03 13:08:12'),(84554,260,'Ramgarh','227407',1,0,'2022-03-03 13:08:12','2022-03-03 13:08:12'),(84555,260,'Ramgarh','222302',1,0,'2022-03-03 13:08:12','2022-03-03 13:08:12'),(84556,260,'Ramnagar Kot','228001',1,0,'2022-03-03 13:08:12','2022-03-03 13:08:12'),(84557,260,'Rampur','222303',1,0,'2022-03-03 13:08:12','2022-03-03 13:08:12'),(84558,260,'Raniganj (Sultanpur)','227816',1,0,'2022-03-03 13:08:12','2022-03-03 13:08:12'),(84559,260,'Ranipur','227304',1,0,'2022-03-03 13:08:13','2022-03-03 13:08:13'),(84560,260,'Rasulabad','227813',1,0,'2022-03-03 13:08:13','2022-03-03 13:08:13'),(84561,260,'Rasulpur','227809',1,0,'2022-03-03 13:08:13','2022-03-03 13:08:13'),(84562,260,'Ratapur','227406',1,0,'2022-03-03 13:08:13','2022-03-03 13:08:13'),(84563,260,'Rawania','228161',1,0,'2022-03-03 13:08:13','2022-03-03 13:08:13'),(84564,260,'Rebha','227405',1,0,'2022-03-03 13:08:13','2022-03-03 13:08:13'),(84565,260,'Resi','227801',1,0,'2022-03-03 13:08:13','2022-03-03 13:08:13'),(84566,260,'Rikhpur','222302',1,0,'2022-03-03 13:08:13','2022-03-03 13:08:13'),(84567,260,'Rohiyawan Jalalpur','228131',1,0,'2022-03-03 13:08:13','2022-03-03 13:08:13'),(84568,260,'Rudauli','227813',1,0,'2022-03-03 13:08:13','2022-03-03 13:08:13'),(84569,260,'Rupapur','228155',1,0,'2022-03-03 13:08:13','2022-03-03 13:08:13'),(84570,260,'Rupinpur','228141',1,0,'2022-03-03 13:08:13','2022-03-03 13:08:13'),(84571,260,'Sadarpur','222303',1,0,'2022-03-03 13:08:13','2022-03-03 13:08:13'),(84572,260,'Sadipur','227813',1,0,'2022-03-03 13:08:13','2022-03-03 13:08:13'),(84573,260,'Safipur','222303',1,0,'2022-03-03 13:08:13','2022-03-03 13:08:13'),(84574,260,'Saidkhanpur','228151',1,0,'2022-03-03 13:08:13','2022-03-03 13:08:13'),(84575,260,'Saifullaganj','228119',1,0,'2022-03-03 13:08:13','2022-03-03 13:08:13'),(84576,260,'Saini','227806',1,0,'2022-03-03 13:08:13','2022-03-03 13:08:13'),(84577,260,'Saintha','227409',1,0,'2022-03-03 13:08:13','2022-03-03 13:08:13'),(84578,260,'Sambhai','227801',1,0,'2022-03-03 13:08:13','2022-03-03 13:08:13'),(84579,260,'Sanaha','227408',1,0,'2022-03-03 13:08:14','2022-03-03 13:08:14'),(84580,260,'Sansarpur','227811',1,0,'2022-03-03 13:08:14','2022-03-03 13:08:14'),(84581,260,'Saraiya Mafi','227812',1,0,'2022-03-03 13:08:14','2022-03-03 13:08:14'),(84582,260,'Saresar','227809',1,0,'2022-03-03 13:08:14','2022-03-03 13:08:14'),(84583,260,'Sarkaura','228155',1,0,'2022-03-03 13:08:14','2022-03-03 13:08:14'),(84584,260,'Sarme','227801',1,0,'2022-03-03 13:08:14','2022-03-03 13:08:14'),(84585,260,'Sarsawan','228131',1,0,'2022-03-03 13:08:14','2022-03-03 13:08:14'),(84586,260,'Saruawan','227408',1,0,'2022-03-03 13:08:14','2022-03-03 13:08:14'),(84587,260,'Satanpur','228145',1,0,'2022-03-03 13:08:14','2022-03-03 13:08:14'),(84588,260,'Sathyain','227816',1,0,'2022-03-03 13:08:14','2022-03-03 13:08:14'),(84589,260,'Sawangi','227406',1,0,'2022-03-03 13:08:14','2022-03-03 13:08:14'),(84590,260,'Semri Purushottampur','227816',1,0,'2022-03-03 13:08:14','2022-03-03 13:08:14'),(84591,260,'Seora','227811',1,0,'2022-03-03 13:08:14','2022-03-03 13:08:14'),(84592,260,'Seotari','228141',1,0,'2022-03-03 13:08:14','2022-03-03 13:08:14'),(84593,260,'Seur Chamurkha','228151',1,0,'2022-03-03 13:08:14','2022-03-03 13:08:14'),(84594,260,'Sevain','227411',1,0,'2022-03-03 13:08:14','2022-03-03 13:08:14'),(84595,260,'Shahabuddinpur','228161',1,0,'2022-03-03 13:08:14','2022-03-03 13:08:14'),(84596,260,'Shahgarh (Sultanpur)','227411',1,0,'2022-03-03 13:08:14','2022-03-03 13:08:14'),(84597,260,'Shahpur','227808',1,0,'2022-03-03 13:08:14','2022-03-03 13:08:14'),(84598,260,'Shahpur Harbansh','222302',1,0,'2022-03-03 13:08:14','2022-03-03 13:08:14'),(84599,260,'Shankarpur','222302',1,0,'2022-03-03 13:08:14','2022-03-03 13:08:14'),(84600,260,'Sheshanpur','222302',1,0,'2022-03-03 13:08:14','2022-03-03 13:08:14'),(84601,260,'Shivgarh','227304',1,0,'2022-03-03 13:08:14','2022-03-03 13:08:14'),(84602,260,'Shivgarh Jalalpur','227413',1,0,'2022-03-03 13:08:14','2022-03-03 13:08:14'),(84603,260,'Shyamnagar (Sultanpur)','228001',1,0,'2022-03-03 13:08:14','2022-03-03 13:08:14'),(84604,260,'Sidhiawan','227809',1,0,'2022-03-03 13:08:14','2022-03-03 13:08:14'),(84605,260,'Sikari','227815',1,0,'2022-03-03 13:08:15','2022-03-03 13:08:15'),(84606,260,'Sindurwa','227809',1,0,'2022-03-03 13:08:15','2022-03-03 13:08:15'),(84607,260,'Singhni','227814',1,0,'2022-03-03 13:08:15','2022-03-03 13:08:15'),(84608,260,'Sohgauli','228155',1,0,'2022-03-03 13:08:15','2022-03-03 13:08:15'),(84609,260,'Sonara','228125',1,0,'2022-03-03 13:08:15','2022-03-03 13:08:15'),(84610,260,'Sonari','227816',1,0,'2022-03-03 13:08:15','2022-03-03 13:08:15'),(84611,260,'Sonawan','222301',1,0,'2022-03-03 13:08:15','2022-03-03 13:08:15'),(84612,260,'Soraon','227806',1,0,'2022-03-03 13:08:15','2022-03-03 13:08:15'),(84613,260,'Sukhi Bajgarh','227801',1,0,'2022-03-03 13:08:15','2022-03-03 13:08:15'),(84614,260,'Sukul Ka Bazar','227811',1,0,'2022-03-03 13:08:15','2022-03-03 13:08:15'),(84615,260,'Sukul Umari','222303',1,0,'2022-03-03 13:08:15','2022-03-03 13:08:15'),(84616,260,'Sukulpur','228161',1,0,'2022-03-03 13:08:15','2022-03-03 13:08:15'),(84617,260,'Sultanpur (Avadh) H.O','228001',1,0,'2022-03-03 13:08:15','2022-03-03 13:08:15'),(84618,260,'Sultanpur City','228001',1,0,'2022-03-03 13:08:15','2022-03-03 13:08:15'),(84619,260,'Surapur','228161',1,0,'2022-03-03 13:08:15','2022-03-03 13:08:15'),(84620,260,'Surhurpur','228131',1,0,'2022-03-03 13:08:15','2022-03-03 13:08:15'),(84621,260,'Suryabhan Patti','227304',1,0,'2022-03-03 13:08:15','2022-03-03 13:08:15'),(84622,260,'Tajuddinpur','228171',1,0,'2022-03-03 13:08:15','2022-03-03 13:08:15'),(84623,260,'Tamarsepur','222303',1,0,'2022-03-03 13:08:15','2022-03-03 13:08:15'),(84624,260,'Tarawa','227411',1,0,'2022-03-03 13:08:15','2022-03-03 13:08:15'),(84625,260,'Tarsara','227411',1,0,'2022-03-03 13:08:15','2022-03-03 13:08:15'),(84626,260,'Tarwa','227816',1,0,'2022-03-03 13:08:15','2022-03-03 13:08:15'),(84627,260,'Tato Muraini','222302',1,0,'2022-03-03 13:08:16','2022-03-03 13:08:16'),(84628,260,'Taudhikpur','227815',1,0,'2022-03-03 13:08:16','2022-03-03 13:08:16'),(84629,260,'Tawakkalpur Nagra','228161',1,0,'2022-03-03 13:08:16','2022-03-03 13:08:16'),(84630,260,'Teary','228119',1,0,'2022-03-03 13:08:16','2022-03-03 13:08:16'),(84631,260,'Teosi','227811',1,0,'2022-03-03 13:08:16','2022-03-03 13:08:16'),(84632,260,'Thauri','227815',1,0,'2022-03-03 13:08:16','2022-03-03 13:08:16'),(84633,260,'Thengaha','227413',1,0,'2022-03-03 13:08:16','2022-03-03 13:08:16'),(84634,260,'Tikari','227408',1,0,'2022-03-03 13:08:16','2022-03-03 13:08:16'),(84635,260,'Tikaria','227816',1,0,'2022-03-03 13:08:16','2022-03-03 13:08:16'),(84636,260,'Tikaria','227409',1,0,'2022-03-03 13:08:16','2022-03-03 13:08:16'),(84637,260,'Tikarmafi','227413',1,0,'2022-03-03 13:08:16','2022-03-03 13:08:16'),(84638,260,'Tirchhe','228155',1,0,'2022-03-03 13:08:16','2022-03-03 13:08:16'),(84639,260,'Tirhut','227806',1,0,'2022-03-03 13:08:16','2022-03-03 13:08:16'),(84640,260,'Trilokpur Newada','228161',1,0,'2022-03-03 13:08:16','2022-03-03 13:08:16'),(84641,260,'Trisuli','227816',1,0,'2022-03-03 13:08:16','2022-03-03 13:08:16'),(84642,260,'Ugharpur','228119',1,0,'2022-03-03 13:08:16','2022-03-03 13:08:16'),(84643,260,'Ugharpur Bhatpura','228132',1,0,'2022-03-03 13:08:16','2022-03-03 13:08:16'),(84644,260,'Umapur Gana Patti','227405',1,0,'2022-03-03 13:08:16','2022-03-03 13:08:16'),(84645,260,'Umara','227815',1,0,'2022-03-03 13:08:16','2022-03-03 13:08:16'),(84646,260,'Umarpur','228131',1,0,'2022-03-03 13:08:16','2022-03-03 13:08:16'),(84647,260,'Umra Dih','227801',1,0,'2022-03-03 13:08:16','2022-03-03 13:08:16'),(84648,260,'Unchgaon','227811',1,0,'2022-03-03 13:08:17','2022-03-03 13:08:17'),(84649,260,'Unchgaon','227805',1,0,'2022-03-03 13:08:17','2022-03-03 13:08:17'),(84650,260,'Unurkha','228171',1,0,'2022-03-03 13:08:17','2022-03-03 13:08:17'),(84651,260,'Usrauli','228161',1,0,'2022-03-03 13:08:17','2022-03-03 13:08:17'),(84652,260,'Uturi','228001',1,0,'2022-03-03 13:08:17','2022-03-03 13:08:17'),(84653,260,'Waini','222302',1,0,'2022-03-03 13:08:17','2022-03-03 13:08:17'),(84654,260,'Wallipur','227812',1,0,'2022-03-03 13:08:17','2022-03-03 13:08:17'),(84655,261,'Aakampur','209866',1,0,'2022-03-03 13:08:17','2022-03-03 13:08:17'),(84656,261,'Achalganj','209801',1,0,'2022-03-03 13:08:17','2022-03-03 13:08:17'),(84657,261,'Aderuwa','209801',1,0,'2022-03-03 13:08:17','2022-03-03 13:08:17'),(84658,261,'Ahesa','209821',1,0,'2022-03-03 13:08:17','2022-03-03 13:08:17'),(84659,261,'Ajgain','209831',1,0,'2022-03-03 13:08:17','2022-03-03 13:08:17'),(84660,261,'Akbarpur','209867',1,0,'2022-03-03 13:08:17','2022-03-03 13:08:17'),(84661,261,'Akohari','209821',1,0,'2022-03-03 13:08:17','2022-03-03 13:08:17'),(84662,261,'Akrampur','209862',1,0,'2022-03-03 13:08:17','2022-03-03 13:08:17'),(84663,261,'Akwabad','209867',1,0,'2022-03-03 13:08:17','2022-03-03 13:08:17'),(84664,261,'Alipur','209863',1,0,'2022-03-03 13:08:17','2022-03-03 13:08:17'),(84665,261,'Aon','209827',1,0,'2022-03-03 13:08:17','2022-03-03 13:08:17'),(84666,261,'Argoopur','209868',1,0,'2022-03-03 13:08:17','2022-03-03 13:08:17'),(84667,261,'Arjunamau','209859',1,0,'2022-03-03 13:08:17','2022-03-03 13:08:17'),(84668,261,'Asawar','209859',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84669,261,'Asawar','209870',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84670,261,'Asha Khera','209859',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84671,261,'Ashayash','209868',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84672,261,'Asoha','209859',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84673,261,'Aterdhani','209801',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84674,261,'Atesuwa','209831',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84675,261,'Atwa','209871',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84676,261,'Atwabaik','209868',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84677,261,'Auras','209870',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84678,261,'Bachhaauli','209870',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84679,261,'Badarka','209801',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84680,261,'Badhwa Kola','209870',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84681,261,'Badora','209825',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84682,261,'Baigaon','209825',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84683,261,'Ballapur','209869',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84684,261,'Band Hamirpur','209801',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84685,261,'Bandakhera','209871',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84686,261,'Bangermau','209868',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84687,261,'Banigaon','209821',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84688,261,'Banther','209862',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84689,261,'Bara (Unnao)','209863',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84690,261,'Bardaha','209867',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84691,261,'Barithana','209870',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84692,261,'Baxer','209863',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84693,261,'Behta Bhawani','209865',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84694,261,'Bether','209801',1,0,'2022-03-03 13:08:18','2022-03-03 13:08:18'),(84695,261,'Bhadohi','209801',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84696,261,'Bhadsar Nausahra','209871',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84697,261,'Bhagwant Nagar','209864',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84698,261,'Bhamna','209871',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84699,261,'Bhatnag','209825',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84700,261,'Bhauli','209801',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84701,261,'Bhikharipur Patsiya','209868',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84702,261,'Bhopatpur','209825',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84703,261,'Bhusandi','209821',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84704,261,'Bichhiya','209825',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84705,261,'Bighapur','209865',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84706,261,'Bihar','209866',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84707,261,'Birsinghpur','209870',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84708,261,'Bisen Mau','209865',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84709,261,'Byohani','209841',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84710,261,'Chainpur','209866',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84711,261,'Chamiyani','209827',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84712,261,'Chamrauli','209801',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84713,261,'Chanden Pur','209863',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84714,261,'Chandpur Jhalaei','209801',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84715,261,'Chauper','209859',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84716,261,'Chetra','209825',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84717,261,'Chharihara','209841',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84718,261,'Collectorate Unnao','209801',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84719,261,'Csa Colony','209801',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84720,261,'Dabauli','209871',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84721,261,'Daldalha','209871',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84722,261,'Darauli','209871',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84723,261,'Darehata','209859',1,0,'2022-03-03 13:08:19','2022-03-03 13:08:19'),(84724,261,'Deeh','209801',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84725,261,'Dela','209825',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84726,261,'Devgaon','209871',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84727,261,'Devmay','209821',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84728,261,'Devra Kalan','209861',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84729,261,'Dhani Khera','209867',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84730,261,'Dhanikhera','209863',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84731,261,'Dhankoli','209863',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84732,261,'Dhannapur','209825',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84733,261,'Dhaura','209881',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84734,261,'Dipwal','209801',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84735,261,'Dodiya Khera','209863',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84736,261,'Drehata','209821',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84737,261,'Dubeypur','209827',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84738,261,'Dundpur Jhthra','209863',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84739,261,'Faridpur Katter','209868',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84740,261,'Fatehpur Chaurasi','209871',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84741,261,'Ganga Ghat','209861',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84742,261,'Gangadas Pur','209871',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84743,261,'Ganj Jalalabad','209869',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84744,261,'Ganj Moradabad','209869',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84745,261,'Garha Kola','209865',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84746,261,'Gaura','209866',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84747,261,'Gauraiya Kalan','209801',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84748,261,'Ghatampur','209865',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84749,261,'Gulauli','209821',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84750,261,'Gulriha','209821',1,0,'2022-03-03 13:08:20','2022-03-03 13:08:20'),(84751,261,'Hafizabad','209868',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84752,261,'Haraha','209801',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84753,261,'Hariyapur','209869',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84754,261,'Hasanganj','209841',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84755,261,'Hedrabad','209870',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84756,261,'Indemau','209867',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84757,261,'Itauli','209801',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84758,261,'Jagatnagar','209868',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84759,261,'Jagatpur','209863',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84760,261,'Jaitipur','209801',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84761,261,'Jajamau','209871',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84762,261,'Jamuka','209801',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84763,261,'Jawaher Nager','209801',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84764,261,'Jogo Kot','209868',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84765,261,'Kakehrwa','209863',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84766,261,'Kalwari','209869',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84767,261,'Kanchanpur','209821',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84768,261,'Kanjaura','209862',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84769,261,'Kanjaura','209871',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84770,261,'Kanta Guljarpur','209801',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84771,261,'Kantha','209859',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84772,261,'Kardaha','209821',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84773,261,'Karowan','209801',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84774,261,'Katehru','209859',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84775,261,'Kesar Ganj','209801',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84776,261,'Khambhauli','209868',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84777,261,'Kharoli','209865',1,0,'2022-03-03 13:08:21','2022-03-03 13:08:21'),(84778,261,'Kodara Sandana','209801',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84779,261,'Kodra','209870',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84780,261,'Korari Kalan','209801',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84781,261,'Korari Khurd','209871',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84782,261,'Kulaha Bagha','209865',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84783,261,'Kumbhi','209101',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84784,261,'Kundenpur','209866',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84785,261,'Kursath','209801',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84786,261,'Kusumbhi','209859',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84787,261,'Laglesra','209870',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84788,261,'Lawani Kalan','209871',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84789,261,'Lohana','209821',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84790,261,'Lowa Singhan Khera','209821',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84791,261,'Madarpur Narainpur','209825',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84792,261,'Magarwara','209862',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84793,261,'Magraiyar','209827',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84794,261,'Mahesh Khera','209864',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84795,261,'Majhgawa','209825',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84796,261,'Majhgawa','209863',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84797,261,'Majhgawan Sevak','209867',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84798,261,'Makhi','209801',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84799,261,'Malona','209866',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84800,261,'Manjra Bhikhna','209801',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84801,261,'Manjra Piper Khera','209861',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84802,261,'Mankapur','209866',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84803,261,'Marhapur','209868',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84804,261,'Maswasi','209862',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84805,261,'Maula Bankipur','209841',1,0,'2022-03-03 13:08:22','2022-03-03 13:08:22'),(84806,261,'Maurawan','209821',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84807,261,'Mawai','209821',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84808,261,'Mawai Dhamiyan','209870',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84809,261,'Mehramau','209827',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84810,261,'Mirrikalan','209859',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84811,261,'Mirzapur Ajgaon','209870',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84812,261,'Mirzapur','209870',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84813,261,'Mirzapur Sumbhari','209825',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84814,261,'Miyanganj','209870',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84815,261,'Mohan','209881',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84816,261,'Mohmmedpur','209825',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84817,261,'Mouddinpur','209821',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84818,261,'Mraunda Majhwara','209871',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84819,261,'Muktemau','209821',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84820,261,'Munda','209871',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84821,261,'Mundha','209871',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84822,261,'Mustafabad','209870',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84823,261,'Mustafabad Pakhrora','209871',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84824,261,'Narain Das Khera','209863',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84825,261,'Nathikhera','209825',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84826,261,'Nawabganj (Unnao)','209859',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84827,261,'Nawai','209801',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84828,261,'Nevalganj','209881',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84829,261,'Nevarna','209825',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84830,261,'Nibai','209801',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84831,261,'Orhar','209825',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84832,261,'Osaina','209801',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84833,261,'Osiya','209865',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84834,261,'Osiya','209871',1,0,'2022-03-03 13:08:23','2022-03-03 13:08:23'),(84835,261,'Padri Kalan','209825',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84836,261,'Padri Khurd','209825',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84837,261,'Pakrakhurd','209866',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84838,261,'Pali','209865',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84839,261,'Panai Kalan','209864',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84840,261,'Panhan','209867',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84841,261,'Pansariya (E.U.P.9189)','209801',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84842,261,'Para','209821',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84843,261,'Parenda','209801',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84844,261,'Pariyar','209871',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84845,261,'Parsanda','209867',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84846,261,'Pasakhera','209827',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84847,261,'Patan (Unnao)','209867',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84848,261,'Patari','209801',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84849,261,'Patiyara','209801',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84850,261,'Pidna','209801',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84851,261,'Pokhri','209866',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84852,261,'Poora N Pansari','209801',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84853,261,'Purthiyawa','209870',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84854,261,'Purwa','209825',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84855,261,'Qila','209801',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84856,261,'Raghurampur','209869',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84857,261,'Rahat Ganj','209871',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84858,261,'Rainapur','209801',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84859,261,'Raipur Garhi (M)','209801',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84860,261,'Raithana','209865',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84861,261,'Rajepur','209868',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84862,261,'Rampur','209863',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84863,261,'Rampur Gaderuwa','209870',1,0,'2022-03-03 13:08:24','2022-03-03 13:08:24'),(84864,261,'Ranipur','209801',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84865,261,'Rasulabad (Unnao)','209870',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84866,261,'Rasupur Bankiya','209881',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84867,261,'Raukarna','209801',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84868,261,'Rawal Kalan','209801',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84869,261,'Rithnai','209801',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84870,261,'Rujhai','209865',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84871,261,'Rupau','209801',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84872,261,'Ruri Sadikpur','209868',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84873,261,'S.N.C.','209801',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84874,261,'Safipur','209871',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84875,261,'Sagoli','209821',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84876,261,'Sagwar','209863',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84877,261,'Sahjani','209862',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84878,261,'Sahrawa','209859',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84879,261,'Sainta','209801',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84880,261,'Saipur Sagaura','209868',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84881,261,'Samadha','209821',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84882,261,'Samadpur Hardas','209881',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84883,261,'Sandana','209821',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84884,261,'Sarai Sakhan','209871',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84885,261,'Saray Malkaadim','209870',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84886,261,'Sarosi','209801',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84887,261,'Sarwan','209821',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84888,261,'Sawaen','209864',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84889,261,'Shadipur','209801',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84890,261,'Shahpur Tonda','209881',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84891,261,'Shankerpur Sarai','209861',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84892,261,'Shekh Pur Nari','209862',1,0,'2022-03-03 13:08:25','2022-03-03 13:08:25'),(84893,261,'Shukla Khera','209867',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84894,261,'Sijni','209867',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84895,261,'Sikandarpur Karan','209801',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84896,261,'Sikandarpur Sihura','209801',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84897,261,'Singrosi','209801',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84898,261,'Sohramau','209859',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84899,261,'Sonic','209801',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84900,261,'Sorauli Khanpur','209870',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84901,261,'Sumerpur','209866',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84902,261,'Sursaini','209868',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84903,261,'Targaon','209825',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84904,261,'Taura','209825',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84905,261,'Terha','209863',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84906,261,'Thana','209801',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84907,261,'Tikra','209801',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84908,261,'Tisra','209821',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84909,261,'Tiyar','209870',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84910,261,'Tripurarpur','209825',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84911,261,'Udshah','209870',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84912,261,'Udtar','209871',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84913,261,'Ugoo','209801',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84914,261,'Unchgaon Sani','209827',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84915,261,'Unnao H.O','209801',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84916,261,'Unnwa','209871',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84917,261,'Utmaanpur','209868',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84918,261,'Vamhna','209871',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84919,261,'Vazidpur','209867',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84920,261,'Vyoli Islamabad','209869',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84921,261,'Wazidpur','209871',1,0,'2022-03-03 13:08:26','2022-03-03 13:08:26'),(84922,261,'Yakoor','209801',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84923,261,'Zamipur','209866',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84924,261,'Zamuniya Kachh','209871',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84925,261,'Zargaon','209825',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84926,262,'Adsand','232110',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84927,262,'Ajgara','221101',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84928,262,'Akorha','232102',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84929,262,'Aktha','221007',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84930,262,'Amarpatti','221101',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84931,262,'Amauli','221104',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84932,262,'Ambba','221104',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84933,262,'Amdaha','232111',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84934,262,'Amilia','232118',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84935,262,'Arkaura','232106',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84936,262,'Ashapur','221007',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84937,262,'Assi','221005',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84938,262,'Babiaon','221101',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84939,262,'Bachhaon','221011',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84940,262,'Ballipur','232107',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84941,262,'Balua','232109',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84942,262,'Barain','221112',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84943,262,'Baraura','232118',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84944,262,'Bariyasanpur','221112',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84945,262,'Barthara Khurd','221104',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84946,262,'Bartharakalan','221104',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84947,262,'Basant Nagar','221110',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84948,262,'Bathauli','221101',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84949,262,'Bela','221101',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84950,262,'Bengalitola','221001',1,0,'2022-03-03 13:08:27','2022-03-03 13:08:27'),(84951,262,'Bentairi','232103',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84952,262,'Bhabhaura','232103',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84953,262,'Bhadawan','221101',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84954,262,'Bhagwanpur','221005',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84955,262,'Bhu - H','221005',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84956,262,'Bisauri','232104',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84957,262,'Bisauri','232109',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84958,262,'Bunker Market','221001',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84959,262,'Chahania','232109',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84960,262,'Chandasi','232101',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84961,262,'Chandrawati','221116',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84962,262,'Chaubepurkhurd','221101',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84963,262,'Chaubeypur','221104',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84964,262,'Chaukhamba','221001',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84965,262,'Chetganj','221001',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84966,262,'Chhapara','221115',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84967,262,'Chhitauni','221104',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84968,262,'Chiraigaon','232110',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84969,262,'Chiraigaon','221112',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84970,262,'Cholapur','221101',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84971,262,'Dafi','221011',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84972,262,'Danganj Bazar','221101',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84973,262,'Daranagar (Varanasi)','221001',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84974,262,'Dasaswmedh','221001',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84975,262,'Dhaurahara (VaranaB.O','221104',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84976,262,'Dheena','232106',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84977,262,'Dhunnoo','232118',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84978,262,'Dul;hipur','232101',1,0,'2022-03-03 13:08:28','2022-03-03 13:08:28'),(84979,262,'Durgakund','221005',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(84980,262,'Gaighat','221001',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(84981,262,'Garwasi Toal','221005',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(84982,262,'Ghosawa','232110',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(84983,262,'Gobraha','221104',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(84984,262,'Gosaipurmohawn','221101',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(84985,262,'Hanuman Phathak','221001',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(84986,262,'Hanumanghat','221001',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(84987,262,'Hanumanpur','232101',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(84988,262,'Hariadih','221104',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(84989,262,'Hathiyarkalan','221101',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(84990,262,'Hindu Vishwa Vidhyalaya','221005',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(84991,262,'Iswargangi','221001',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(84992,262,'Jagdishpur','221101',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(84993,262,'Jaitpura','221001',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(84994,262,'Jalhupur','221104',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(84995,262,'Jalilpur','232101',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(84996,262,'Jeori','232110',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(84997,262,'Kabirchaura','221001',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(84998,262,'Kaithaur','221101',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(84999,262,'Kaithi','221116',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(85000,262,'Kamauli','221112',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(85001,262,'Kashi Viswnath Mandir','221001',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(85002,262,'Kasi Rs','221001',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(85003,262,'Katari','221101',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(85004,262,'Kateshar','221008',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(85005,262,'Katwamafi','232118',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(85006,262,'Kavarua','232108',1,0,'2022-03-03 13:08:29','2022-03-03 13:08:29'),(85007,262,'Kedarghat','221001',1,0,'2022-03-03 13:08:30','2022-03-03 13:08:30'),(85008,262,'Kharkhara','232109',1,0,'2022-03-03 13:08:30','2022-03-03 13:08:30'),(85009,262,'Khetalpur','221104',1,0,'2022-03-03 13:08:30','2022-03-03 13:08:30'),(85010,262,'Kohashi','221101',1,0,'2022-03-03 13:08:30','2022-03-03 13:08:30'),(85011,262,'Konia','221007',1,0,'2022-03-03 13:08:30','2022-03-03 13:08:30'),(85012,262,'Kurahuwan','221011',1,0,'2022-03-03 13:08:30','2022-03-03 13:08:30'),(85013,262,'Kusth Ashram','221008',1,0,'2022-03-03 13:08:30','2022-03-03 13:08:30'),(85014,262,'Lakhanpur','221101',1,0,'2022-03-03 13:08:30','2022-03-03 13:08:30'),(85015,262,'Lamahi','221007',1,0,'2022-03-03 13:08:30','2022-03-03 13:08:30'),(85016,262,'Lanka (Varanasi)','221005',1,0,'2022-03-03 13:08:30','2022-03-03 13:08:30'),(85017,262,'Laskarpur','221101',1,0,'2022-03-03 13:08:30','2022-03-03 13:08:30'),(85018,262,'Luthakalan','221104',1,0,'2022-03-03 13:08:30','2022-03-03 13:08:30'),(85019,262,'Madanpura','221001',1,0,'2022-03-03 13:08:30','2022-03-03 13:08:30'),(85020,262,'Mahamandal','221001',1,0,'2022-03-03 13:08:30','2022-03-03 13:08:30'),(85021,262,'Mahuwarkalan','221115',1,0,'2022-03-03 13:08:30','2022-03-03 13:08:30'),(85022,262,'Malviya Nagar (Varanasi)','221005',1,0,'2022-03-03 13:08:30','2022-03-03 13:08:30'),(85023,262,'Moonari','221104',1,0,'2022-03-03 13:08:30','2022-03-03 13:08:30'),(85024,262,'Mustafabad','221104',1,0,'2022-03-03 13:08:30','2022-03-03 13:08:30'),(85025,262,'Naipurakhurd','221011',1,0,'2022-03-03 13:08:30','2022-03-03 13:08:30'),(85026,262,'Narainpur','221104',1,0,'2022-03-03 13:08:30','2022-03-03 13:08:30'),(85027,262,'Niyar','221101',1,0,'2022-03-03 13:08:30','2022-03-03 13:08:30'),(85028,262,'Pachraon','221104',1,0,'2022-03-03 13:08:30','2022-03-03 13:08:30'),(85029,262,'Pahariya Mandi','221007',1,0,'2022-03-03 13:08:30','2022-03-03 13:08:30'),(85030,262,'Pasahi','232102',1,0,'2022-03-03 13:08:30','2022-03-03 13:08:30'),(85031,262,'Patelnagar','232101',1,0,'2022-03-03 13:08:30','2022-03-03 13:08:30'),(85032,262,'Piyari','221104',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85033,262,'Railway Colony Mugalsarai','232101',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85034,262,'Rajapur','221101',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85035,262,'Rajwari','221116',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85036,262,'Ram Nagar Pac','221008',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85037,262,'Ramapura','221001',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85038,262,'Ramchandipur','221104',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85039,262,'Ramna','221011',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85040,262,'Ramnagar (Varanasi)','221008',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85041,262,'Rani Bhawani Katra','221001',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85042,262,'Rasoolgarh','221007',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85043,262,'Sakrari','232105',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85044,262,'Saraimohana','221112',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85045,262,'Saraiya No.-1','221101',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85046,262,'Sarnath','221007',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85047,262,'Sarva Seva Sangh','221001',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85048,262,'Sathwa','221007',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85049,262,'Seergoverdhan','221011',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85050,262,'Shankerpur','221112',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85051,262,'Shivala','221001',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85052,262,'Shivdasa','221104',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85053,262,'Singhpur','221101',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85054,262,'Srikanthpur','221116',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85055,262,'Sultanipur','221101',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85056,262,'Sultanpur','221007',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85057,262,'Sunderpur','221005',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85058,262,'Susuwahi','221011',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85059,262,'Tapowanashram','221007',1,0,'2022-03-03 13:08:31','2022-03-03 13:08:31'),(85060,262,'Targaonajgara','221115',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85061,262,'Tekuri','221116',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85062,262,'Tewar','221101',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85063,262,'Tikari','221011',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85064,262,'Tiwaripur','221104',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85065,262,'Tulsiashram Nonar','232108',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85066,262,'Udaipur','221101',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85067,262,'Ukathi','221104',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85068,262,'Umrahan','221112',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85069,262,'Varanasi City','221001',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85070,262,'Varanasi H.O','221001',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85071,262,'Vijay Sirohi Nagar','221001',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85072,262,'39 Gtd','221002',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85073,262,'Akorha','221201',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85074,262,'Anai','221201',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85075,262,'Ardely Bazar','221002',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85076,262,'Aurangabad (Varanasi)','221010',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85077,262,'Ayar','221202',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85078,262,'Babatpur Ad','221006',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85079,262,'Babhaniaon','221311',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85080,262,'Balua Gajapur','221201',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85081,262,'Banakat','221403',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85082,262,'Baragaon (Varanasi)','221204',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85083,262,'Barahi Newada','221207',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85084,262,'Barawa Bazar','221402',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85085,262,'Barki','221403',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85086,262,'Basani','221204',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85087,262,'Basantpur','221405',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85088,262,'Bazardiha','221106',1,0,'2022-03-03 13:08:32','2022-03-03 13:08:32'),(85089,262,'Belpco','221010',1,0,'2022-03-03 13:08:33','2022-03-03 13:08:33'),(85090,262,'Belwan','221206',1,0,'2022-03-03 13:08:33','2022-03-03 13:08:33'),(85091,262,'Benipur Kundariya','221307',1,0,'2022-03-03 13:08:33','2022-03-03 13:08:33'),(85092,262,'Bhelupura','221010',1,0,'2022-03-03 13:08:33','2022-03-03 13:08:33'),(85093,262,'Bhikhampur','221403',1,0,'2022-03-03 13:08:33','2022-03-03 13:08:33'),(85094,262,'Bhitkuri','221403',1,0,'2022-03-03 13:08:33','2022-03-03 13:08:33'),(85095,262,'Bhonda','221201',1,0,'2022-03-03 13:08:33','2022-03-03 13:08:33'),(85096,262,'Bhopapur','221202',1,0,'2022-03-03 13:08:33','2022-03-03 13:08:33'),(85097,262,'Bhulanpur Pac','221108',1,0,'2022-03-03 13:08:33','2022-03-03 13:08:33'),(85098,262,'Birapatti','221105',1,0,'2022-03-03 13:08:33','2022-03-03 13:08:33'),(85099,262,'Birbhanpur','221311',1,0,'2022-03-03 13:08:33','2022-03-03 13:08:33'),(85100,262,'Chamaon','221003',1,0,'2022-03-03 13:08:33','2022-03-03 13:08:33'),(85101,262,'Chiurapur','221204',1,0,'2022-03-03 13:08:33','2022-03-03 13:08:33'),(85102,262,'Christ Nagar','221003',1,0,'2022-03-03 13:08:33','2022-03-03 13:08:33'),(85103,262,'Clark Hotel','221002',1,0,'2022-03-03 13:08:33','2022-03-03 13:08:33'),(85104,262,'D.L.W.','221004',1,0,'2022-03-03 13:08:33','2022-03-03 13:08:33'),(85105,262,'Dabethuwa','221207',1,0,'2022-03-03 13:08:33','2022-03-03 13:08:33'),(85106,262,'Daipur','221405',1,0,'2022-03-03 13:08:33','2022-03-03 13:08:33'),(85107,262,'Danupur','221201',1,0,'2022-03-03 13:08:33','2022-03-03 13:08:33'),(85108,262,'Deochandpur','221204',1,0,'2022-03-03 13:08:33','2022-03-03 13:08:33'),(85109,262,'Dhandhorpur','221305',1,0,'2022-03-03 13:08:33','2022-03-03 13:08:33'),(85110,262,'Domaila','221313',1,0,'2022-03-03 13:08:33','2022-03-03 13:08:33'),(85111,262,'Drmo','221002',1,0,'2022-03-03 13:08:33','2022-03-03 13:08:33'),(85112,262,'Gangapur (Varanasi)','221302',1,0,'2022-03-03 13:08:33','2022-03-03 13:08:33'),(85113,262,'Garkhara','221208',1,0,'2022-03-03 13:08:33','2022-03-03 13:08:33'),(85114,262,'Garthama','221208',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85115,262,'Gdk','221010',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85116,262,'Ghamahapur','221105',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85117,262,'Gorai','221307',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85118,262,'H.P.S.','221010',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85119,262,'Harhua','221105',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85120,262,'Hariharpur','221405',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85121,262,'Harshosh','221302',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85122,262,'Hasanpur Biraon','221201',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85123,262,'Hathi Bazar','221405',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85124,262,'Hiramanpur','221208',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85125,262,'Industrial Estate (Varanasi)','221106',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85126,262,'Jagatpur','221302',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85127,262,'Jagdishpur','221202',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85128,262,'Jakhini','221305',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85129,262,'Jamalpur','221105',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85130,262,'Jansa Bazar','221405',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85131,262,'Jawahar Nagar (Varanasi)','221002',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85132,262,'Jayapur','221305',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85133,262,'Jhanjhaur','221206',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85134,262,'Kachhwa Road','221313',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85135,262,'Kaithauli','221006',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85136,262,'Kajisarai','221105',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85137,262,'Kalikabara','221403',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85138,262,'Kamachha','221010',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85139,262,'Kanakpur','221206',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85140,262,'Kandawa','221106',1,0,'2022-03-03 13:08:34','2022-03-03 13:08:34'),(85141,262,'Kaniyar','221204',1,0,'2022-03-03 13:08:35','2022-03-03 13:08:35'),(85142,262,'Kapsethi','221403',1,0,'2022-03-03 13:08:35','2022-03-03 13:08:35'),(85143,262,'Kardhana','221307',1,0,'2022-03-03 13:08:35','2022-03-03 13:08:35'),(85144,262,'Karkhiaon','221206',1,0,'2022-03-03 13:08:35','2022-03-03 13:08:35'),(85145,262,'Kashi Vidhya Pith','221002',1,0,'2022-03-03 13:08:35','2022-03-03 13:08:35'),(85146,262,'Kashipur','221311',1,0,'2022-03-03 13:08:35','2022-03-03 13:08:35'),(85147,262,'Kathiraon','221207',1,0,'2022-03-03 13:08:35','2022-03-03 13:08:35'),(85148,262,'Katra Bazar (Varanasi)','221401',1,0,'2022-03-03 13:08:35','2022-03-03 13:08:35'),(85149,262,'Katuna','221208',1,0,'2022-03-03 13:08:35','2022-03-03 13:08:35'),(85150,262,'Khajuri (Varanasi)','221002',1,0,'2022-03-03 13:08:35','2022-03-03 13:08:35'),(85151,262,'Khalispur','221206',1,0,'2022-03-03 13:08:35','2022-03-03 13:08:35'),(85152,262,'Khamaria (Varanasi)','221306',1,0,'2022-03-03 13:08:35','2022-03-03 13:08:35'),(85153,262,'Kharawan','221201',1,0,'2022-03-03 13:08:35','2022-03-03 13:08:35'),(85154,262,'Khataura','221204',1,0,'2022-03-03 13:08:35','2022-03-03 13:08:35'),(85155,262,'Khewali','221405',1,0,'2022-03-03 13:08:35','2022-03-03 13:08:35'),(85156,262,'Khochawan','221313',1,0,'2022-03-03 13:08:35','2022-03-03 13:08:35'),(85157,262,'Khojwa Bazar','221010',1,0,'2022-03-03 13:08:35','2022-03-03 13:08:35'),(85158,262,'Koruta Bazar','221107',1,0,'2022-03-03 13:08:35','2022-03-03 13:08:35'),(85159,262,'Kotwa Koraut','221105',1,0,'2022-03-03 13:08:35','2022-03-03 13:08:35'),(85160,262,'Kuar','221204',1,0,'2022-03-03 13:08:35','2022-03-03 13:08:35'),(85161,262,'Kundi','221204',1,0,'2022-03-03 13:08:35','2022-03-03 13:08:35'),(85162,262,'Kuru','221201',1,0,'2022-03-03 13:08:36','2022-03-03 13:08:36'),(85163,262,'Lahartara','221106',1,0,'2022-03-03 13:08:36','2022-03-03 13:08:36'),(85164,262,'Lohta','221107',1,0,'2022-03-03 13:08:36','2022-03-03 13:08:36'),(85165,262,'Luxa','221010',1,0,'2022-03-03 13:08:36','2022-03-03 13:08:36'),(85166,262,'Madhumakhiya','221201',1,0,'2022-03-03 13:08:36','2022-03-03 13:08:36'),(85167,262,'Mahgaon','221311',1,0,'2022-03-03 13:08:36','2022-03-03 13:08:36'),(85168,262,'Mahmoorganj','221010',1,0,'2022-03-03 13:08:36','2022-03-03 13:08:36'),(85169,262,'Manduadih','221103',1,0,'2022-03-03 13:08:36','2022-03-03 13:08:36'),(85170,262,'Mangalpur','221107',1,0,'2022-03-03 13:08:36','2022-03-03 13:08:36'),(85171,262,'Mangari','221202',1,0,'2022-03-03 13:08:36','2022-03-03 13:08:36'),(85172,262,'Mankaiya','221307',1,0,'2022-03-03 13:08:36','2022-03-03 13:08:36'),(85173,262,'Marui','221208',1,0,'2022-03-03 13:08:36','2022-03-03 13:08:36'),(85174,262,'Marui','221305',1,0,'2022-03-03 13:08:36','2022-03-03 13:08:36'),(85175,262,'Mata Kund','221010',1,0,'2022-03-03 13:08:36','2022-03-03 13:08:36'),(85176,262,'Mehandiganj','221311',1,0,'2022-03-03 13:08:36','2022-03-03 13:08:36'),(85177,262,'Mirzamurad','221307',1,0,'2022-03-03 13:08:36','2022-03-03 13:08:36'),(85178,262,'Murdaha Bazar','221202',1,0,'2022-03-03 13:08:36','2022-03-03 13:08:36'),(85179,262,'Nagar Maha Palika','221010',1,0,'2022-03-03 13:08:36','2022-03-03 13:08:36'),(85180,262,'Nahiyan','221202',1,0,'2022-03-03 13:08:36','2022-03-03 13:08:36'),(85181,262,'Nayepur Chaumuhani','221207',1,0,'2022-03-03 13:08:36','2022-03-03 13:08:36'),(85182,262,'Odar','221202',1,0,'2022-03-03 13:08:36','2022-03-03 13:08:36'),(85183,262,'Pakhawaiya','221306',1,0,'2022-03-03 13:08:37','2022-03-03 13:08:37'),(85184,262,'Palahipatti','221208',1,0,'2022-03-03 13:08:37','2022-03-03 13:08:37'),(85185,262,'Paniyara','221305',1,0,'2022-03-03 13:08:37','2022-03-03 13:08:37'),(85186,262,'Parsara','221206',1,0,'2022-03-03 13:08:37','2022-03-03 13:08:37'),(85187,262,'Phoolpur','221206',1,0,'2022-03-03 13:08:37','2022-03-03 13:08:37'),(85188,262,'Phulawaria','221106',1,0,'2022-03-03 13:08:37','2022-03-03 13:08:37'),(85189,262,'Pindarai','221206',1,0,'2022-03-03 13:08:37','2022-03-03 13:08:37'),(85190,262,'Pindra','221206',1,0,'2022-03-03 13:08:37','2022-03-03 13:08:37'),(85191,262,'Pisaur','221003',1,0,'2022-03-03 13:08:37','2022-03-03 13:08:37'),(85192,262,'Puarikalan','221202',1,0,'2022-03-03 13:08:37','2022-03-03 13:08:37'),(85193,262,'Pure Raghunathpur','221006',1,0,'2022-03-03 13:08:37','2022-03-03 13:08:37'),(85194,262,'Raghupur','221403',1,0,'2022-03-03 13:08:37','2022-03-03 13:08:37'),(85195,262,'Raisipur','221405',1,0,'2022-03-03 13:08:37','2022-03-03 13:08:37'),(85196,262,'Rajatalab','221311',1,0,'2022-03-03 13:08:37','2022-03-03 13:08:37'),(85197,262,'Rajpur','221202',1,0,'2022-03-03 13:08:37','2022-03-03 13:08:37'),(85198,262,'Ramapur Hathiwar','221204',1,0,'2022-03-03 13:08:37','2022-03-03 13:08:37'),(85199,262,'Ramdih','221403',1,0,'2022-03-03 13:08:37','2022-03-03 13:08:37'),(85200,262,'Rameswar','221405',1,0,'2022-03-03 13:08:37','2022-03-03 13:08:37'),(85201,262,'Rasoolpur','221204',1,0,'2022-03-03 13:08:37','2022-03-03 13:08:37'),(85202,262,'Rohana','221108',1,0,'2022-03-03 13:08:37','2022-03-03 13:08:37'),(85203,262,'Rupchandpur','221208',1,0,'2022-03-03 13:08:37','2022-03-03 13:08:37'),(85204,262,'S.V.V.','221002',1,0,'2022-03-03 13:08:37','2022-03-03 13:08:37'),(85205,262,'Sadopur','221304',1,0,'2022-03-03 13:08:37','2022-03-03 13:08:37'),(85206,262,'Sajoi','221302',1,0,'2022-03-03 13:08:38','2022-03-03 13:08:38'),(85207,262,'Sakalpur','221403',1,0,'2022-03-03 13:08:38','2022-03-03 13:08:38'),(85208,262,'Sarairajputani','221304',1,0,'2022-03-03 13:08:38','2022-03-03 13:08:38'),(85209,262,'Sarauni','221302',1,0,'2022-03-03 13:08:38','2022-03-03 13:08:38'),(85210,262,'Sarsawan','221003',1,0,'2022-03-03 13:08:38','2022-03-03 13:08:38'),(85211,262,'Sehamalpur','221208',1,0,'2022-03-03 13:08:38','2022-03-03 13:08:38'),(85212,262,'Sewapuri','221403',1,0,'2022-03-03 13:08:38','2022-03-03 13:08:38'),(85213,262,'Shahanshahpur','221305',1,0,'2022-03-03 13:08:38','2022-03-03 13:08:38'),(85214,262,'Shivrampur','221202',1,0,'2022-03-03 13:08:38','2022-03-03 13:08:38'),(85215,262,'Sigra','221010',1,0,'2022-03-03 13:08:38','2022-03-03 13:08:38'),(85216,262,'Sikhari Barki','221403',1,0,'2022-03-03 13:08:38','2022-03-03 13:08:38'),(85217,262,'Sindhora','221208',1,0,'2022-03-03 13:08:38','2022-03-03 13:08:38'),(85218,262,'Sisawan','221201',1,0,'2022-03-03 13:08:38','2022-03-03 13:08:38'),(85219,262,'Surahi','221206',1,0,'2022-03-03 13:08:38','2022-03-03 13:08:38'),(85220,262,'Tari','221207',1,0,'2022-03-03 13:08:38','2022-03-03 13:08:38'),(85221,262,'Telibagh','221002',1,0,'2022-03-03 13:08:38','2022-03-03 13:08:38'),(85222,262,'Thaney Rampur','221207',1,0,'2022-03-03 13:08:38','2022-03-03 13:08:38'),(85223,262,'Thathara','221313',1,0,'2022-03-03 13:08:38','2022-03-03 13:08:38'),(85224,262,'U.P. Collage','221002',1,0,'2022-03-03 13:08:38','2022-03-03 13:08:38'),(85225,262,'Varanasi Cantt H.O','221002',1,0,'2022-03-03 13:08:38','2022-03-03 13:08:38'),(85226,262,'Vsi Kutchhery','221002',1,0,'2022-03-03 13:08:38','2022-03-03 13:08:38'),(85227,262,'Vsi Shivpur','221003',1,0,'2022-03-03 13:08:38','2022-03-03 13:08:38'),(85228,262,'West Colony','221004',1,0,'2022-03-03 13:08:39','2022-03-03 13:08:39'),(85229,263,'A Narayanapuram','515004',1,0,'2022-03-03 13:08:39','2022-03-03 13:08:39'),(85230,263,'Akuledu','515731',1,0,'2022-03-03 13:08:39','2022-03-03 13:08:39'),(85231,263,'Alamuru','515002',1,0,'2022-03-03 13:08:39','2022-03-03 13:08:39'),(85232,263,'Allapuram','515766',1,0,'2022-03-03 13:08:39','2022-03-03 13:08:39'),(85233,263,'Aluru','515415',1,0,'2022-03-03 13:08:39','2022-03-03 13:08:39'),(85234,263,'Amidyaya','515822',1,0,'2022-03-03 13:08:39','2022-03-03 13:08:39'),(85235,263,'Ammaladinne','515445',1,0,'2022-03-03 13:08:39','2022-03-03 13:08:39'),(85236,263,'Anantapur Collectorate','515001',1,0,'2022-03-03 13:08:39','2022-03-03 13:08:39'),(85237,263,'Anantapur Engg College','515002',1,0,'2022-03-03 13:08:39','2022-03-03 13:08:39'),(85238,263,'Anantapur H.O','515001',1,0,'2022-03-03 13:08:39','2022-03-03 13:08:39'),(85239,263,'Ankampalli','515741',1,0,'2022-03-03 13:08:39','2022-03-03 13:08:39'),(85240,263,'Anumpalli','515775',1,0,'2022-03-03 13:08:39','2022-03-03 13:08:39'),(85241,263,'Appecharla','515455',1,0,'2022-03-03 13:08:39','2022-03-03 13:08:39'),(85242,263,'Appilepalli','515766',1,0,'2022-03-03 13:08:39','2022-03-03 13:08:39'),(85243,263,'Arakatavemula','515445',1,0,'2022-03-03 13:08:39','2022-03-03 13:08:39'),(85244,263,'Araveedu','515465',1,0,'2022-03-03 13:08:39','2022-03-03 13:08:39'),(85245,263,'Aravindanagar','515001',1,0,'2022-03-03 13:08:39','2022-03-03 13:08:39'),(85246,263,'Atmakur(ATP)','515751',1,0,'2022-03-03 13:08:39','2022-03-03 13:08:39'),(85247,263,'Avuladatla','515867',1,0,'2022-03-03 13:08:39','2022-03-03 13:08:39'),(85248,263,'Avulanna','515741',1,0,'2022-03-03 13:08:39','2022-03-03 13:08:39'),(85249,263,'Aydukallu','515763',1,0,'2022-03-03 13:08:40','2022-03-03 13:08:40'),(85250,263,'Ayyagarlapalli','515767',1,0,'2022-03-03 13:08:40','2022-03-03 13:08:40'),(85251,263,'Ayyavaripalli','515775',1,0,'2022-03-03 13:08:40','2022-03-03 13:08:40'),(85252,263,'Ayyavaripalli','515722',1,0,'2022-03-03 13:08:40','2022-03-03 13:08:40'),(85253,263,'B.N.Halli','515867',1,0,'2022-03-03 13:08:40','2022-03-03 13:08:40'),(85254,263,'B.T.Project','515863',1,0,'2022-03-03 13:08:40','2022-03-03 13:08:40'),(85255,263,'Bandameedapalli','515722',1,0,'2022-03-03 13:08:40','2022-03-03 13:08:40'),(85256,263,'Bandlapalli','515425',1,0,'2022-03-03 13:08:40','2022-03-03 13:08:40'),(85257,263,'Basapuram','515766',1,0,'2022-03-03 13:08:40','2022-03-03 13:08:40'),(85258,263,'Basinepalli','515402',1,0,'2022-03-03 13:08:40','2022-03-03 13:08:40'),(85259,263,'Bavarampalli','515761',1,0,'2022-03-03 13:08:40','2022-03-03 13:08:40'),(85260,263,'Belguppa','515741',1,0,'2022-03-03 13:08:40','2022-03-03 13:08:40'),(85261,263,'Belodu','515867',1,0,'2022-03-03 13:08:40','2022-03-03 13:08:40'),(85262,263,'Bestharapalli','515766',1,0,'2022-03-03 13:08:40','2022-03-03 13:08:40'),(85263,263,'Bethapalli','515402',1,0,'2022-03-03 13:08:40','2022-03-03 13:08:40'),(85264,263,'Bhattuvanipalli','515787',1,0,'2022-03-03 13:08:40','2022-03-03 13:08:40'),(85265,263,'Bhogasamudram','515415',1,0,'2022-03-03 13:08:40','2022-03-03 13:08:40'),(85266,263,'Bhogasamudram Project','515413',1,0,'2022-03-03 13:08:40','2022-03-03 13:08:40'),(85267,263,'Bhupasamudram','515867',1,0,'2022-03-03 13:08:40','2022-03-03 13:08:40'),(85268,263,'Bhyrasamudram','515767',1,0,'2022-03-03 13:08:40','2022-03-03 13:08:40'),(85269,263,'Bollanaguddem','515870',1,0,'2022-03-03 13:08:40','2022-03-03 13:08:40'),(85270,263,'Bommaganipalli','515763',1,0,'2022-03-03 13:08:40','2022-03-03 13:08:40'),(85271,263,'Bommakkapalli','515867',1,0,'2022-03-03 13:08:40','2022-03-03 13:08:40'),(85272,263,'Bommanahal','515871',1,0,'2022-03-03 13:08:40','2022-03-03 13:08:40'),(85273,263,'Bondaladinne','515411',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85274,263,'Bondalawada','515425',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85275,263,'Brahma Samudram','515767',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85276,263,'Brahmanapalli','515408',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85277,263,'Brahmanapalli','515401',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85278,263,'Brahmasamudram','515871',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85279,263,'Bramhanayaleru','515002',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85280,263,'Budagavi','515812',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85281,263,'Budimepalli','515763',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85282,263,'Bukkacherla','515002',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85283,263,'Bukkarayasamudram','515701',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85284,263,'C Bandameedapalli','515701',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85285,263,'Chabala','515812',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85286,263,'Chadam','515865',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85287,263,'Chalivemula','515414',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85288,263,'Challavaripalli','515411',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85289,263,'Chamaluru','515425',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85290,263,'Chandana','515455',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85291,263,'Chapiri','515761',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85292,263,'Chayapuram','515842',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85293,263,'Cheekalagurki','515812',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85294,263,'Cheemalavagupalli','515408',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85295,263,'Cheliminahalli','515767',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85296,263,'Chennampalli','515425',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85297,263,'Cherlopalli','515766',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85298,263,'Cherlopalli','515414',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85299,263,'Chikkepalli','515445',1,0,'2022-03-03 13:08:41','2022-03-03 13:08:41'),(85300,263,'Chilamakuru','515465',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85301,263,'Chinnampalli','515761',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85302,263,'Chinnamusturu','515812',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85303,263,'Chinnapolamada','515411',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85304,263,'Chinnavadugur','515405',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85305,263,'Chintakayamanda','515465',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85306,263,'Chintakunta','515414',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85307,263,'Chintalacheruvu','515455',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85308,263,'Chintalayalapalli','515408',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85309,263,'Chintarlapalli','515767',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85310,263,'Chitrachedu','515611',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85311,263,'Chittur','515611',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85312,263,'Chiyyedu','515721',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85313,263,'Cholasamudram','515711',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85314,263,'Chukkalur','515415',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85315,263,'Danduvaripalli','515701',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85316,263,'Darga Kondaopuram','515865',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85317,263,'Dasampalli','515765',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85318,263,'Devagiri','515871',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85319,263,'Devarapalli','515775',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85320,263,'Dharmapuri','515812',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85321,263,'Diguvapalli','515414',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85322,263,'Dimmagudi','515405',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85323,263,'Dodagatta','515761',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85324,263,'Donekal','515842',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85325,263,'Dosaludiki','515803',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85326,263,'Duddekunta','515741',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85327,263,'Duggumarri','515425',1,0,'2022-03-03 13:08:42','2022-03-03 13:08:42'),(85328,263,'Durdakunta','515787',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85329,263,'Eddulapalli','515775',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85330,263,'Edurur','515405',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85331,263,'G.Kottala','515775',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85332,263,'Gadehothur','515832',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85333,263,'Gadekal','515842',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85334,263,'Gajarampalli','515775',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85335,263,'Gandhibazar (Ananthapur)','515005',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85336,263,'Gandlaparthi','515722',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85337,263,'Ganganapalli','515425',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85338,263,'Gangavaram','515761',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85339,263,'Ganigera','515871',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85340,263,'Garladinne','515731',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85341,263,'Garudachedu','515871',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85342,263,'Garuguchintalapallo','515414',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85343,263,'Georgepet','515004',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85344,263,'Godasalapalli','515871',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85345,263,'Goddumarri','515465',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85346,263,'Golla','515761',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85347,263,'Gollaladoddi','515401',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85348,263,'Gollapalli','515865',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85349,263,'Gollapalli','515425',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85350,263,'Gonabhavi','515863',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85351,263,'Gonchireddypalli','515763',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85352,263,'Gondireddypalli','515722',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85353,263,'Gonehal','515871',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85354,263,'Gooty Bazaar','515401',1,0,'2022-03-03 13:08:43','2022-03-03 13:08:43'),(85355,263,'Gooty R.S.','515402',1,0,'2022-03-03 13:08:44','2022-03-03 13:08:44'),(85356,263,'Gooty','515401',1,0,'2022-03-03 13:08:44','2022-03-03 13:08:44'),(85357,263,'Gootyanantapur','515401',1,0,'2022-03-03 13:08:44','2022-03-03 13:08:44'),(85358,263,'Goridindla','515751',1,0,'2022-03-03 13:08:44','2022-03-03 13:08:44'),(85359,263,'Gotkuru','515711',1,0,'2022-03-03 13:08:44','2022-03-03 13:08:44'),(85360,263,'Govindawada','515812',1,0,'2022-03-03 13:08:44','2022-03-03 13:08:44'),(85361,263,'Gramadatla','515865',1,0,'2022-03-03 13:08:44','2022-03-03 13:08:44'),(85362,263,'Gubanapalli','515763',1,0,'2022-03-03 13:08:44','2022-03-03 13:08:44'),(85363,263,'Guddalapalli','515731',1,0,'2022-03-03 13:08:44','2022-03-03 13:08:44'),(85364,263,'Gudipadu','515408',1,0,'2022-03-03 13:08:44','2022-03-03 13:08:44'),(85365,263,'Gugudu','515425',1,0,'2022-03-03 13:08:44','2022-03-03 13:08:44'),(85366,263,'Gulapalyam','515842',1,0,'2022-03-03 13:08:44','2022-03-03 13:08:44'),(85367,263,'Gummaghatta','515863',1,0,'2022-03-03 13:08:44','2022-03-03 13:08:44'),(85368,263,'Gundiganipalli','515863',1,0,'2022-03-03 13:08:44','2022-03-03 13:08:44'),(85369,263,'Guntakal H.O','515801',1,0,'2022-03-03 13:08:44','2022-03-03 13:08:44'),(85370,263,'Guntakal Market','515801',1,0,'2022-03-03 13:08:44','2022-03-03 13:08:44'),(85371,263,'H Sodanapalli','515425',1,0,'2022-03-03 13:08:44','2022-03-03 13:08:44'),(85372,263,'Hampapuram','515722',1,0,'2022-03-03 13:08:44','2022-03-03 13:08:44'),(85373,263,'Hanakanahal','515741',1,0,'2022-03-03 13:08:44','2022-03-03 13:08:44'),(85374,263,'Hanchanahal','515842',1,0,'2022-03-03 13:08:44','2022-03-03 13:08:44'),(85375,263,'Handepalli','515765',1,0,'2022-03-03 13:08:44','2022-03-03 13:08:44'),(85376,263,'Hanumesh Nagar','515801',1,0,'2022-03-03 13:08:44','2022-03-03 13:08:44'),(85377,263,'Havaligi','515870',1,0,'2022-03-03 13:08:44','2022-03-03 13:08:44'),(85378,263,'Herial','515872',1,0,'2022-03-03 13:08:44','2022-03-03 13:08:44'),(85379,263,'Honnur','515812',1,0,'2022-03-03 13:08:44','2022-03-03 13:08:44'),(85380,263,'Igaduru','515415',1,0,'2022-03-03 13:08:45','2022-03-03 13:08:45'),(85381,263,'Illuru','515611',1,0,'2022-03-03 13:08:45','2022-03-03 13:08:45'),(85382,263,'Ipperu','515711',1,0,'2022-03-03 13:08:45','2022-03-03 13:08:45'),(85383,263,'Isurallapalli','515401',1,0,'2022-03-03 13:08:45','2022-03-03 13:08:45'),(85384,263,'Jakkalacheruvu','515401',1,0,'2022-03-03 13:08:45','2022-03-03 13:08:45'),(85385,263,'Jallipalli','515711',1,0,'2022-03-03 13:08:45','2022-03-03 13:08:45'),(85386,263,'Jambugumpala','515766',1,0,'2022-03-03 13:08:45','2022-03-03 13:08:45'),(85387,263,'Jambuladinne','515731',1,0,'2022-03-03 13:08:45','2022-03-03 13:08:45'),(85388,263,'Janardhanapalli','515812',1,0,'2022-03-03 13:08:45','2022-03-03 13:08:45'),(85389,263,'Jangampalli','515465',1,0,'2022-03-03 13:08:45','2022-03-03 13:08:45'),(85390,263,'Janthaluru','515701',1,0,'2022-03-03 13:08:45','2022-03-03 13:08:45'),(85391,263,'Jayalakshmipuram (Ananthapur)','515722',1,0,'2022-03-03 13:08:45','2022-03-03 13:08:45'),(85392,263,'Julakalva','515425',1,0,'2022-03-03 13:08:45','2022-03-03 13:08:45'),(85393,263,'Junjurampalli','515867',1,0,'2022-03-03 13:08:45','2022-03-03 13:08:45'),(85394,263,'Juturu','515411',1,0,'2022-03-03 13:08:45','2022-03-03 13:08:45'),(85395,263,'K Garudapuram','515761',1,0,'2022-03-03 13:08:45','2022-03-03 13:08:45'),(85396,263,'K.K.Agraharam','515701',1,0,'2022-03-03 13:08:45','2022-03-03 13:08:45'),(85397,263,'Kadadarabenchi','515842',1,0,'2022-03-03 13:08:45','2022-03-03 13:08:45'),(85398,263,'Kadadarakunta','515711',1,0,'2022-03-03 13:08:45','2022-03-03 13:08:45'),(85399,263,'Kadalur','515865',1,0,'2022-03-03 13:08:45','2022-03-03 13:08:45'),(85400,263,'Kadarampalli','515766',1,0,'2022-03-03 13:08:45','2022-03-03 13:08:45'),(85401,263,'Kadavakallu','515445',1,0,'2022-03-03 13:08:45','2022-03-03 13:08:45'),(85402,263,'Kadiridevarapalli','515765',1,0,'2022-03-03 13:08:45','2022-03-03 13:08:45'),(85403,263,'Kakkalapalli Colony','515004',1,0,'2022-03-03 13:08:45','2022-03-03 13:08:45'),(85404,263,'Kakkalpalli','515002',1,0,'2022-03-03 13:08:46','2022-03-03 13:08:46'),(85405,263,'Kalagalla','515711',1,0,'2022-03-03 13:08:46','2022-03-03 13:08:46'),(85406,263,'Kalapuram','515775',1,0,'2022-03-03 13:08:46','2022-03-03 13:08:46'),(85407,263,'Kalekurthy','515871',1,0,'2022-03-03 13:08:46','2022-03-03 13:08:46'),(85408,263,'Kallumadi','515611',1,0,'2022-03-03 13:08:46','2022-03-03 13:08:46'),(85409,263,'Kallur R.S.','515774',1,0,'2022-03-03 13:08:46','2022-03-03 13:08:46'),(85410,263,'Kalluru','515465',1,0,'2022-03-03 13:08:46','2022-03-03 13:08:46'),(85411,263,'Kalugodu','515863',1,0,'2022-03-03 13:08:46','2022-03-03 13:08:46'),(85412,263,'Kalvapalli','515761',1,0,'2022-03-03 13:08:46','2022-03-03 13:08:46'),(85413,263,'Kalyam','515865',1,0,'2022-03-03 13:08:46','2022-03-03 13:08:46'),(85414,263,'Kalyandurg Bazar','515761',1,0,'2022-03-03 13:08:46','2022-03-03 13:08:46'),(85415,263,'Kalyandurg','515761',1,0,'2022-03-03 13:08:46','2022-03-03 13:08:46'),(85416,263,'Kamalanagar (Ananthapur)','515001',1,0,'2022-03-03 13:08:46','2022-03-03 13:08:46'),(85417,263,'Kamalapadu','515408',1,0,'2022-03-03 13:08:46','2022-03-03 13:08:46'),(85418,263,'Kamalapadu','515832',1,0,'2022-03-03 13:08:46','2022-03-03 13:08:46'),(85419,263,'Kamarupalli','515751',1,0,'2022-03-03 13:08:46','2022-03-03 13:08:46'),(85420,263,'Kambadur','515765',1,0,'2022-03-03 13:08:46','2022-03-03 13:08:46'),(85421,263,'Kammuru','515711',1,0,'2022-03-03 13:08:46','2022-03-03 13:08:46'),(85422,263,'Kanakuru','515767',1,0,'2022-03-03 13:08:46','2022-03-03 13:08:46'),(85423,263,'Kanampalli','515731',1,0,'2022-03-03 13:08:46','2022-03-03 13:08:46'),(85424,263,'Kandukur','515721',1,0,'2022-03-03 13:08:46','2022-03-03 13:08:46'),(85425,263,'Kanekal','515871',1,0,'2022-03-03 13:08:46','2022-03-03 13:08:46'),(85426,263,'Kannepalli','515763',1,0,'2022-03-03 13:08:47','2022-03-03 13:08:47'),(85427,263,'Karakamukkala','515870',1,0,'2022-03-03 13:08:47','2022-03-03 13:08:47'),(85428,263,'Karidikonda','515402',1,0,'2022-03-03 13:08:47','2022-03-03 13:08:47'),(85429,263,'Karthanaparthi','515787',1,0,'2022-03-03 13:08:47','2022-03-03 13:08:47'),(85430,263,'Karutlapalli','515711',1,0,'2022-03-03 13:08:47','2022-03-03 13:08:47'),(85431,263,'Kasapuram','515803',1,0,'2022-03-03 13:08:47','2022-03-03 13:08:47'),(85432,263,'Katakindapalli','515832',1,0,'2022-03-03 13:08:47','2022-03-03 13:08:47'),(85433,263,'Katrimala','515775',1,0,'2022-03-03 13:08:47','2022-03-03 13:08:47'),(85434,263,'Kaverisamudram','515415',1,0,'2022-03-03 13:08:47','2022-03-03 13:08:47'),(85435,263,'Kenchanapalli','515867',1,0,'2022-03-03 13:08:47','2022-03-03 13:08:47'),(85436,263,'Kesavapuram','515774',1,0,'2022-03-03 13:08:47','2022-03-03 13:08:47'),(85437,263,'Kesepalli','515425',1,0,'2022-03-03 13:08:47','2022-03-03 13:08:47'),(85438,263,'Khaderpeta','515775',1,0,'2022-03-03 13:08:47','2022-03-03 13:08:47'),(85439,263,'Khairevu','515767',1,0,'2022-03-03 13:08:47','2022-03-03 13:08:47'),(85440,263,'Kodihalli West','515863',1,0,'2022-03-03 13:08:47','2022-03-03 13:08:47'),(85441,263,'Kodipalli East','515787',1,0,'2022-03-03 13:08:47','2022-03-03 13:08:47'),(85442,263,'Kojjepalli','515401',1,0,'2022-03-03 13:08:47','2022-03-03 13:08:47'),(85443,263,'Kolaganahalli','515871',1,0,'2022-03-03 13:08:47','2022-03-03 13:08:47'),(85444,263,'Komatikuntla','515414',1,0,'2022-03-03 13:08:47','2022-03-03 13:08:47'),(85445,263,'Konakondla','515842',1,0,'2022-03-03 13:08:47','2022-03-03 13:08:47'),(85446,263,'Konapuram','515761',1,0,'2022-03-03 13:08:48','2022-03-03 13:08:48'),(85447,263,'Konauppalapadu','515408',1,0,'2022-03-03 13:08:48','2022-03-03 13:08:48'),(85448,263,'Konganapalli','515401',1,0,'2022-03-03 13:08:48','2022-03-03 13:08:48'),(85449,263,'Koppalakonda','515774',1,0,'2022-03-03 13:08:48','2022-03-03 13:08:48'),(85450,263,'Korrakodu','515711',1,0,'2022-03-03 13:08:48','2022-03-03 13:08:48'),(85451,263,'Korrapadu','515701',1,0,'2022-03-03 13:08:48','2022-03-03 13:08:48'),(85452,263,'Kotanka','515731',1,0,'2022-03-03 13:08:48','2022-03-03 13:08:48'),(85453,263,'Kothakota','515870',1,0,'2022-03-03 13:08:48','2022-03-03 13:08:48'),(85454,263,'Kothapalli','515751',1,0,'2022-03-03 13:08:48','2022-03-03 13:08:48'),(85455,263,'Kothapalli','515731',1,0,'2022-03-03 13:08:48','2022-03-03 13:08:48'),(85456,263,'Kothapeta(Gooty)','515401',1,0,'2022-03-03 13:08:48','2022-03-03 13:08:48'),(85457,263,'Kothapeta(Uravakonda)','515812',1,0,'2022-03-03 13:08:48','2022-03-03 13:08:48'),(85458,263,'Kottala','515803',1,0,'2022-03-03 13:08:48','2022-03-03 13:08:48'),(85459,263,'Kottalapalli','515870',1,0,'2022-03-03 13:08:48','2022-03-03 13:08:48'),(85460,263,'Krishtipadu','515455',1,0,'2022-03-03 13:08:48','2022-03-03 13:08:48'),(85461,263,'Kuchivaripalli','515465',1,0,'2022-03-03 13:08:48','2022-03-03 13:08:48'),(85462,263,'Kuderu (Ananthapur)','515711',1,0,'2022-03-03 13:08:48','2022-03-03 13:08:48'),(85463,263,'Kudlur','515871',1,0,'2022-03-03 13:08:48','2022-03-03 13:08:48'),(85464,263,'Kummanamala','515414',1,0,'2022-03-03 13:08:48','2022-03-03 13:08:48'),(85465,263,'Kundurpi','515766',1,0,'2022-03-03 13:08:48','2022-03-03 13:08:48'),(85466,263,'Kurabanahalli','515761',1,0,'2022-03-03 13:08:49','2022-03-03 13:08:49'),(85467,263,'Kuraganipalli','515425',1,0,'2022-03-03 13:08:49','2022-03-03 13:08:49'),(85468,263,'Kurugunta','515751',1,0,'2022-03-03 13:08:49','2022-03-03 13:08:49'),(85469,263,'Kuruvalli','515871',1,0,'2022-03-03 13:08:49','2022-03-03 13:08:49'),(85470,263,'Lachumpalli','515405',1,0,'2022-03-03 13:08:49','2022-03-03 13:08:49'),(85471,263,'Lakshmampalli','515766',1,0,'2022-03-03 13:08:49','2022-03-03 13:08:49'),(85472,263,'Lakshmampalli','515465',1,0,'2022-03-03 13:08:49','2022-03-03 13:08:49'),(85473,263,'Lakshmi Bazar','515865',1,0,'2022-03-03 13:08:49','2022-03-03 13:08:49'),(85474,263,'Lakshumpalli','515455',1,0,'2022-03-03 13:08:49','2022-03-03 13:08:49'),(85475,263,'Lathavaram','515812',1,0,'2022-03-03 13:08:49','2022-03-03 13:08:49'),(85476,263,'Lingareddipalli','515465',1,0,'2022-03-03 13:08:49','2022-03-03 13:08:49'),(85477,263,'M.P.R.Site','515731',1,0,'2022-03-03 13:08:49','2022-03-03 13:08:49'),(85478,263,'Maddipalli','515414',1,0,'2022-03-03 13:08:49','2022-03-03 13:08:49'),(85479,263,'Madigubba','515751',1,0,'2022-03-03 13:08:49','2022-03-03 13:08:49'),(85480,263,'Madugupalli','515425',1,0,'2022-03-03 13:08:49','2022-03-03 13:08:49'),(85481,263,'Malayanuru','515766',1,0,'2022-03-03 13:08:49','2022-03-03 13:08:49'),(85482,263,'Mallapuram','515812',1,0,'2022-03-03 13:08:49','2022-03-03 13:08:49'),(85483,263,'Mallenipalli','515405',1,0,'2022-03-03 13:08:49','2022-03-03 13:08:49'),(85484,263,'Malyam','515871',1,0,'2022-03-03 13:08:49','2022-03-03 13:08:49'),(85485,263,'Mamadur','515405',1,0,'2022-03-03 13:08:49','2022-03-03 13:08:49'),(85486,263,'Mamaduru','515767',1,0,'2022-03-03 13:08:49','2022-03-03 13:08:49'),(85487,263,'Manirevu','515751',1,0,'2022-03-03 13:08:49','2022-03-03 13:08:49'),(85488,263,'Mannila','515721',1,0,'2022-03-03 13:08:50','2022-03-03 13:08:50'),(85489,263,'Marrimakulapalli','515765',1,0,'2022-03-03 13:08:50','2022-03-03 13:08:50'),(85490,263,'Marthadu','515731',1,0,'2022-03-03 13:08:50','2022-03-03 13:08:50'),(85491,263,'Marutla','515711',1,0,'2022-03-03 13:08:50','2022-03-03 13:08:50'),(85492,263,'Medikurthi','515465',1,0,'2022-03-03 13:08:50','2022-03-03 13:08:50'),(85493,263,'Miduthur','515405',1,0,'2022-03-03 13:08:50','2022-03-03 13:08:50'),(85494,263,'Modinabad','515801',1,0,'2022-03-03 13:08:50','2022-03-03 13:08:50'),(85495,263,'Mopidi','515812',1,0,'2022-03-03 13:08:50','2022-03-03 13:08:50'),(85496,263,'Motilal Street','515004',1,0,'2022-03-03 13:08:50','2022-03-03 13:08:50'),(85497,263,'Muchukota','515445',1,0,'2022-03-03 13:08:50','2022-03-03 13:08:50'),(85498,263,'Muddalapuram','515711',1,0,'2022-03-03 13:08:50','2022-03-03 13:08:50'),(85499,263,'Muddinayanipalli','515787',1,0,'2022-03-03 13:08:50','2022-03-03 13:08:50'),(85500,263,'Mudigal','515761',1,0,'2022-03-03 13:08:50','2022-03-03 13:08:50'),(85501,263,'Mulakaledu','515767',1,0,'2022-03-03 13:08:50','2022-03-03 13:08:50'),(85502,263,'Mulakanur','515765',1,0,'2022-03-03 13:08:50','2022-03-03 13:08:50'),(85503,263,'Muntimadugu','515774',1,0,'2022-03-03 13:08:50','2022-03-03 13:08:50'),(85504,263,'Muppalakunta','515763',1,0,'2022-03-03 13:08:50','2022-03-03 13:08:50'),(85505,263,'Muradi','515865',1,0,'2022-03-03 13:08:50','2022-03-03 13:08:50'),(85506,263,'Muradi Hanumapuram','515865',1,0,'2022-03-03 13:08:50','2022-03-03 13:08:50'),(85507,263,'Muttala','515751',1,0,'2022-03-03 13:08:50','2022-03-03 13:08:50'),(85508,263,'N.Hanumapuram','515822',1,0,'2022-03-03 13:08:51','2022-03-03 13:08:51'),(85509,263,'N.Narsapuram','515803',1,0,'2022-03-03 13:08:51','2022-03-03 13:08:51'),(85510,263,'N.Thimmapuram','515842',1,0,'2022-03-03 13:08:51','2022-03-03 13:08:51'),(85511,263,'Nadimidoddi','515425',1,0,'2022-03-03 13:08:51','2022-03-03 13:08:51'),(85512,263,'Nagalapuram','515871',1,0,'2022-03-03 13:08:51','2022-03-03 13:08:51'),(85513,263,'Nagarur','515455',1,0,'2022-03-03 13:08:51','2022-03-03 13:08:51'),(85514,263,'Nagasamudram','515401',1,0,'2022-03-03 13:08:51','2022-03-03 13:08:51'),(85515,263,'Nakkalapalli','515741',1,0,'2022-03-03 13:08:51','2022-03-03 13:08:51'),(85516,263,'Nakkanadoddi','515803',1,0,'2022-03-03 13:08:51','2022-03-03 13:08:51'),(85517,263,'Narapla','515425',1,0,'2022-03-03 13:08:51','2022-03-03 13:08:51'),(85518,263,'Narasanenikunta','515004',1,0,'2022-03-03 13:08:51','2022-03-03 13:08:51'),(85519,263,'Narasapuram','515408',1,0,'2022-03-03 13:08:51','2022-03-03 13:08:51'),(85520,263,'Narasapuram','515763',1,0,'2022-03-03 13:08:51','2022-03-03 13:08:51'),(85521,263,'Narasapuram East','515435',1,0,'2022-03-03 13:08:51','2022-03-03 13:08:51'),(85522,263,'Narasapuram West','515435',1,0,'2022-03-03 13:08:51','2022-03-03 13:08:51'),(85523,263,'Narayanapuram','515761',1,0,'2022-03-03 13:08:51','2022-03-03 13:08:51'),(85524,263,'Narinjagundlapalli','515741',1,0,'2022-03-03 13:08:51','2022-03-03 13:08:51'),(85525,263,'Nelagonda','515842',1,0,'2022-03-03 13:08:51','2022-03-03 13:08:51'),(85526,263,'Nemakallu','515871',1,0,'2022-03-03 13:08:51','2022-03-03 13:08:51'),(85527,263,'Netrapalli','515867',1,0,'2022-03-03 13:08:51','2022-03-03 13:08:51'),(85528,263,'Nimbagallu','515822',1,0,'2022-03-03 13:08:51','2022-03-03 13:08:51'),(85529,263,'Nitturu','515408',1,0,'2022-03-03 13:08:52','2022-03-03 13:08:52'),(85530,263,'Nizava.Lli','515766',1,0,'2022-03-03 13:08:52','2022-03-03 13:08:52'),(85531,263,'Nuthimadugu','515787',1,0,'2022-03-03 13:08:52','2022-03-03 13:08:52'),(85532,263,'Obulapuram','515414',1,0,'2022-03-03 13:08:52','2022-03-03 13:08:52'),(85533,263,'Obulapuram','515865',1,0,'2022-03-03 13:08:52','2022-03-03 13:08:52'),(85534,263,'Oddupalli','515751',1,0,'2022-03-03 13:08:52','2022-03-03 13:08:52'),(85535,263,'Old Guntakal','515803',1,0,'2022-03-03 13:08:52','2022-03-03 13:08:52'),(85536,263,'Old Town (Ananthapur)','515005',1,0,'2022-03-03 13:08:52','2022-03-03 13:08:52'),(85537,263,'Ontimiddi','515761',1,0,'2022-03-03 13:08:52','2022-03-03 13:08:52'),(85538,263,'P Narayana Puram','515751',1,0,'2022-03-03 13:08:52','2022-03-03 13:08:52'),(85539,263,'P Siddarampuram','515751',1,0,'2022-03-03 13:08:52','2022-03-03 13:08:52'),(85540,263,'P Yaleru','515751',1,0,'2022-03-03 13:08:52','2022-03-03 13:08:52'),(85541,263,'P.C.Peapully','515832',1,0,'2022-03-03 13:08:52','2022-03-03 13:08:52'),(85542,263,'Pabr Sam Site','515711',1,0,'2022-03-03 13:08:52','2022-03-03 13:08:52'),(85543,263,'Palacherla','515722',1,0,'2022-03-03 13:08:52','2022-03-03 13:08:52'),(85544,263,'Palavoyi','515761',1,0,'2022-03-03 13:08:52','2022-03-03 13:08:52'),(85545,263,'Pallepalli','515865',1,0,'2022-03-03 13:08:52','2022-03-03 13:08:52'),(85546,263,'Palluru','515765',1,0,'2022-03-03 13:08:52','2022-03-03 13:08:52'),(85547,263,'Palthur','515870',1,0,'2022-03-03 13:08:52','2022-03-03 13:08:52'),(85548,263,'Palyam','515775',1,0,'2022-03-03 13:08:52','2022-03-03 13:08:52'),(85549,263,'Pamidi','515775',1,0,'2022-03-03 13:08:52','2022-03-03 13:08:52'),(85550,263,'Pandikunta','515832',1,0,'2022-03-03 13:08:52','2022-03-03 13:08:52'),(85551,263,'Papampalli','515761',1,0,'2022-03-03 13:08:53','2022-03-03 13:08:53'),(85552,263,'Pappuru','515425',1,0,'2022-03-03 13:08:53','2022-03-03 13:08:53'),(85553,263,'Parlachedu','515767',1,0,'2022-03-03 13:08:53','2022-03-03 13:08:53'),(85554,263,'Parsannayapalli','515002',1,0,'2022-03-03 13:08:53','2022-03-03 13:08:53'),(85555,263,'Pasalur','515408',1,0,'2022-03-03 13:08:53','2022-03-03 13:08:53'),(85556,263,'Patel Road','515001',1,0,'2022-03-03 13:08:53','2022-03-03 13:08:53'),(85557,263,'Pathakothacheruvu','515401',1,0,'2022-03-03 13:08:53','2022-03-03 13:08:53'),(85558,263,'Pedda Kowkuntla','515822',1,0,'2022-03-03 13:08:53','2022-03-03 13:08:53'),(85559,263,'Pedda Vadagur','515405',1,0,'2022-03-03 13:08:53','2022-03-03 13:08:53'),(85560,263,'Peddapappuru','515445',1,0,'2022-03-03 13:08:53','2022-03-03 13:08:53'),(85561,263,'Peddapolamada','515411',1,0,'2022-03-03 13:08:53','2022-03-03 13:08:53'),(85562,263,'Peddayakkalur','515408',1,0,'2022-03-03 13:08:53','2022-03-03 13:08:53'),(85563,263,'Pedoddi','515401',1,0,'2022-03-03 13:08:53','2022-03-03 13:08:53'),(85564,263,'Penakacherla','515731',1,0,'2022-03-03 13:08:53','2022-03-03 13:08:53'),(85565,263,'Peravali','515701',1,0,'2022-03-03 13:08:53','2022-03-03 13:08:53'),(85566,263,'Pillalapalli','515763',1,0,'2022-03-03 13:08:53','2022-03-03 13:08:53'),(85567,263,'Podaralla','515731',1,0,'2022-03-03 13:08:53','2022-03-03 13:08:53'),(85568,263,'Polepalli','515863',1,0,'2022-03-03 13:08:53','2022-03-03 13:08:53'),(85569,263,'Poliki','515842',1,0,'2022-03-03 13:08:53','2022-03-03 13:08:53'),(85570,263,'Pottipadu','515832',1,0,'2022-03-03 13:08:53','2022-03-03 13:08:53'),(85571,263,'Pulakunta','515865',1,0,'2022-03-03 13:08:53','2022-03-03 13:08:53'),(85572,263,'Pulakurthy','515865',1,0,'2022-03-03 13:08:53','2022-03-03 13:08:53'),(85573,263,'Pulicherla','515865',1,0,'2022-03-03 13:08:54','2022-03-03 13:08:54'),(85574,263,'Pulukunta','515721',1,0,'2022-03-03 13:08:54','2022-03-03 13:08:54'),(85575,263,'Puppala','515455',1,0,'2022-03-03 13:08:54','2022-03-03 13:08:54'),(85576,263,'Putlur','515414',1,0,'2022-03-03 13:08:54','2022-03-03 13:08:54'),(85577,263,'R.B.Vanka','515865',1,0,'2022-03-03 13:08:54','2022-03-03 13:08:54'),(85578,263,'R.Kothapalli','515865',1,0,'2022-03-03 13:08:54','2022-03-03 13:08:54'),(85579,263,'Rachanapalli','515004',1,0,'2022-03-03 13:08:54','2022-03-03 13:08:54'),(85580,263,'Rachepalli','515611',1,0,'2022-03-03 13:08:54','2022-03-03 13:08:54'),(85581,263,'Ragulapadu','515832',1,0,'2022-03-03 13:08:54','2022-03-03 13:08:54'),(85582,263,'Railway Colony (Ananthapur)','515801',1,0,'2022-03-03 13:08:54','2022-03-03 13:08:54'),(85583,263,'Rajaji Street','515005',1,0,'2022-03-03 13:08:54','2022-03-03 13:08:54'),(85584,263,'Rajapuram','515401',1,0,'2022-03-03 13:08:54','2022-03-03 13:08:54'),(85585,263,'Rajendra Nagar (Ananthapur)','515801',1,0,'2022-03-03 13:08:54','2022-03-03 13:08:54'),(85586,263,'Rajiv Colony','515004',1,0,'2022-03-03 13:08:54','2022-03-03 13:08:54'),(85587,263,'Raketla','515822',1,0,'2022-03-03 13:08:54','2022-03-03 13:08:54'),(85588,263,'Ramachandra Nagar','515001',1,0,'2022-03-03 13:08:54','2022-03-03 13:08:54'),(85589,263,'Ramapuram','515787',1,0,'2022-03-03 13:08:54','2022-03-03 13:08:54'),(85590,263,'Ramarajupalli','515405',1,0,'2022-03-03 13:08:54','2022-03-03 13:08:54'),(85591,263,'Ramasagaram','515741',1,0,'2022-03-03 13:08:54','2022-03-03 13:08:54'),(85592,263,'Ramnagar (Ananthapur)','515004',1,0,'2022-03-03 13:08:54','2022-03-03 13:08:54'),(85593,263,'Rangachedu','515867',1,0,'2022-03-03 13:08:54','2022-03-03 13:08:54'),(85594,263,'Raptadu','515722',1,0,'2022-03-03 13:08:54','2022-03-03 13:08:54'),(85595,263,'Ravuludiki','515455',1,0,'2022-03-03 13:08:54','2022-03-03 13:08:54'),(85596,263,'Rayadurg  Bazar','515865',1,0,'2022-03-03 13:08:54','2022-03-03 13:08:54'),(85597,263,'Rayadurg Fort','515865',1,0,'2022-03-03 13:08:54','2022-03-03 13:08:54'),(85598,263,'Rayadurg','515865',1,0,'2022-03-03 13:08:54','2022-03-03 13:08:54'),(85599,263,'Rayalacheruvu','515455',1,0,'2022-03-03 13:08:55','2022-03-03 13:08:55'),(85600,263,'Rayalappadoddi','515763',1,0,'2022-03-03 13:08:55','2022-03-03 13:08:55'),(85601,263,'Rayampalli','515812',1,0,'2022-03-03 13:08:55','2022-03-03 13:08:55'),(85602,263,'Reddipalli','515701',1,0,'2022-03-03 13:08:55','2022-03-03 13:08:55'),(85603,263,'Reddivaripalem','515411',1,0,'2022-03-03 13:08:55','2022-03-03 13:08:55'),(85604,263,'Renimakulapalli','515812',1,0,'2022-03-03 13:08:55','2022-03-03 13:08:55'),(85605,263,'Rotarypuram','515701',1,0,'2022-03-03 13:08:55','2022-03-03 13:08:55'),(85606,263,'Rudrampeta','515004',1,0,'2022-03-03 13:08:55','2022-03-03 13:08:55'),(85607,263,'Sainagar','515001',1,0,'2022-03-03 13:08:55','2022-03-03 13:08:55'),(85608,263,'Sajjaladinne','515415',1,0,'2022-03-03 13:08:55','2022-03-03 13:08:55'),(85609,263,'Salakamcheruvu','515435',1,0,'2022-03-03 13:08:55','2022-03-03 13:08:55'),(85610,263,'Sanapa','515751',1,0,'2022-03-03 13:08:55','2022-03-03 13:08:55'),(85611,263,'Satyanandanagar','515001',1,0,'2022-03-03 13:08:55','2022-03-03 13:08:55'),(85612,263,'Seeripi','515741',1,0,'2022-03-03 13:08:55','2022-03-03 13:08:55'),(85613,263,'Senagalaguduru','515411',1,0,'2022-03-03 13:08:55','2022-03-03 13:08:55'),(85614,263,'Shaikshanipalli','515812',1,0,'2022-03-03 13:08:55','2022-03-03 13:08:55'),(85615,263,'Shettur','515767',1,0,'2022-03-03 13:08:55','2022-03-03 13:08:55'),(85616,263,'Siddarampuram','515701',1,0,'2022-03-03 13:08:55','2022-03-03 13:08:55'),(85617,263,'Singanahalli','515871',1,0,'2022-03-03 13:08:55','2022-03-03 13:08:55'),(85618,263,'Singanamala','515435',1,0,'2022-03-03 13:08:55','2022-03-03 13:08:55'),(85619,263,'Singavaram','515465',1,0,'2022-03-03 13:08:55','2022-03-03 13:08:55'),(85620,263,'Sollapuram','515822',1,0,'2022-03-03 13:08:56','2022-03-03 13:08:56'),(85621,263,'Somaladoddi','515004',1,0,'2022-03-03 13:08:56','2022-03-03 13:08:56'),(85622,263,'Somalapuram','515865',1,0,'2022-03-03 13:08:56','2022-03-03 13:08:56'),(85623,263,'Sreedharghatta','515871',1,0,'2022-03-03 13:08:56','2022-03-03 13:08:56'),(85624,263,'Sri Venkateswara Puram','515003',1,0,'2022-03-03 13:08:56','2022-03-03 13:08:56'),(85625,263,'Srirangapuram','515741',1,0,'2022-03-03 13:08:56','2022-03-03 13:08:56'),(85626,263,'T.Veerapuram','515865',1,0,'2022-03-03 13:08:56','2022-03-03 13:08:56'),(85627,263,'Tadpatri Bazar','515411',1,0,'2022-03-03 13:08:56','2022-03-03 13:08:56'),(85628,263,'Tadpatri Bus Stand','515411',1,0,'2022-03-03 13:08:56','2022-03-03 13:08:56'),(85629,263,'Tadpatri Extension','515411',1,0,'2022-03-03 13:08:56','2022-03-03 13:08:56'),(85630,263,'Tadpatri','515411',1,0,'2022-03-03 13:08:56','2022-03-03 13:08:56'),(85631,263,'Takkalapalli','515414',1,0,'2022-03-03 13:08:56','2022-03-03 13:08:56'),(85632,263,'Tallakera','515863',1,0,'2022-03-03 13:08:56','2022-03-03 13:08:56'),(85633,263,'Talupuru','515751',1,0,'2022-03-03 13:08:56','2022-03-03 13:08:56'),(85634,263,'Tapovanagar','515004',1,0,'2022-03-03 13:08:56','2022-03-03 13:08:56'),(85635,263,'Tarimala','515611',1,0,'2022-03-03 13:08:56','2022-03-03 13:08:56'),(85636,263,'Taticherla','515731',1,0,'2022-03-03 13:08:56','2022-03-03 13:08:56'),(85637,263,'Tatrakallu','515832',1,0,'2022-03-03 13:08:56','2022-03-03 13:08:56'),(85638,263,'Teliki','515405',1,0,'2022-03-03 13:08:56','2022-03-03 13:08:56'),(85639,263,'Tenagal','515765',1,0,'2022-03-03 13:08:57','2022-03-03 13:08:57'),(85640,263,'Thabjula','515445',1,0,'2022-03-03 13:08:57','2022-03-03 13:08:57'),(85641,263,'Thagguparthi','515741',1,0,'2022-03-03 13:08:57','2022-03-03 13:08:57'),(85642,263,'Theetakallu','515763',1,0,'2022-03-03 13:08:57','2022-03-03 13:08:57'),(85643,263,'Therannapalli','515414',1,0,'2022-03-03 13:08:57','2022-03-03 13:08:57'),(85644,263,'Thimmampalli','515465',1,0,'2022-03-03 13:08:57','2022-03-03 13:08:57'),(85645,263,'Thimmampeta','515731',1,0,'2022-03-03 13:08:57','2022-03-03 13:08:57'),(85646,263,'Thimmapuram','515765',1,0,'2022-03-03 13:08:57','2022-03-03 13:08:57'),(85647,263,'Thimmapuram','515803',1,0,'2022-03-03 13:08:57','2022-03-03 13:08:57'),(85648,263,'Thimmasamudram','515787',1,0,'2022-03-03 13:08:57','2022-03-03 13:08:57'),(85649,263,'Thippanapalli','515767',1,0,'2022-03-03 13:08:57','2022-03-03 13:08:57'),(85650,263,'Thondapadu','515401',1,0,'2022-03-03 13:08:57','2022-03-03 13:08:57'),(85651,263,'Thopudurthi','515722',1,0,'2022-03-03 13:08:57','2022-03-03 13:08:57'),(85652,263,'Thumukunta','515766',1,0,'2022-03-03 13:08:57','2022-03-03 13:08:57'),(85653,263,'Thutrallapalli','515455',1,0,'2022-03-03 13:08:57','2022-03-03 13:08:57'),(85654,263,'Timmanacharla','515801',1,0,'2022-03-03 13:08:57','2022-03-03 13:08:57'),(85655,263,'Uddihal','515871',1,0,'2022-03-03 13:08:57','2022-03-03 13:08:57'),(85656,263,'Udegolam','515867',1,0,'2022-03-03 13:08:57','2022-03-03 13:08:57'),(85657,263,'Udiripikonda','515711',1,0,'2022-03-03 13:08:57','2022-03-03 13:08:57'),(85658,263,'Ullikallu','515611',1,0,'2022-03-03 13:08:57','2022-03-03 13:08:57'),(85659,263,'Undabanda','515812',1,0,'2022-03-03 13:08:57','2022-03-03 13:08:57'),(85660,263,'Unthakallu','515871',1,0,'2022-03-03 13:08:57','2022-03-03 13:08:57'),(85661,263,'Upparapalli','515002',1,0,'2022-03-03 13:08:57','2022-03-03 13:08:57'),(85662,263,'Uravakonda (Bus Stand)','515812',1,0,'2022-03-03 13:08:57','2022-03-03 13:08:57'),(85663,263,'Uravakonda','515812',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85664,263,'Urichintala','515415',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85665,263,'Vaddepalem','515766',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85666,263,'Vadiampeta','515731',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85667,263,'Vajrakarur','515832',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85668,263,'Vanganuru','515411',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85669,263,'Vankarajukalva','515775',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85670,263,'Veerapuram','515865',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85671,263,'Vekigonda','515812',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85672,263,'Velamakur','515415',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85673,263,'Velpumadugu','515870',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85674,263,'Vemulapadu','515408',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85675,263,'Venkatampalli','515832',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85676,263,'Venkatampalli','515425',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85677,263,'Venkatapuram','515701',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85678,263,'Venkatareddipalli','515415',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85679,263,'Vennupusalapalli','515465',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85680,263,'Vepalaparthy','515863',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85681,263,'Veparalla','515867',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85682,263,'Vidapanakal','515870',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85683,263,'Virupapalli','515761',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85684,263,'Vitlampalli','515763',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85685,263,'Vontareddipalli','515765',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85686,263,'Y Rama Puram','515741',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85687,263,'Y.T.Cheruvu','515401',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85688,263,'Yadiki','515408',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85689,263,'Yatakal','515761',1,0,'2022-03-03 13:08:58','2022-03-03 13:08:58'),(85690,263,'Yelagalavanka','515763',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85691,263,'Yellanur','515465',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85692,263,'Yellutla','515425',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85693,263,'Yenumulachennampalli','515787',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85694,263,'Yenumuladoddi','515765',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85695,263,'Yerragudi','515741',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85696,263,'Yerragunta','515871',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85697,263,'Yerragunta','515722',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85698,263,'Yerraguntapalli','515411',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85699,263,'Yerraguntla','515731',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85700,263,'Yerrampalli','515761',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85701,263,'Achampalle','515621',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85702,263,'Adadakulapalli','515124',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85703,263,'Agali (Ananthapur)','515311',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85704,263,'Agraharam','515281',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85705,263,'Agraharam','515154',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85706,263,'Aladahalli','515281',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85707,263,'Amadagur','515556',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85708,263,'Amagondapalem','515144',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85709,263,'Amarapuram','515281',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85710,263,'Amidalagondi','515301',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85711,263,'Amidalakunta','515651',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85712,263,'Apprascheruvu','515661',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85713,263,'Aswartharayaniroppam','515301',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85714,263,'Atmakur','515631',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85715,263,'Badannapalli','515672',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85716,263,'Badavandlapalli','515501',1,0,'2022-03-03 13:08:59','2022-03-03 13:08:59'),(85717,263,'Badenaikthanda','515134',1,0,'2022-03-03 13:09:00','2022-03-03 13:09:00'),(85718,263,'Balasamudram','515571',1,0,'2022-03-03 13:09:00','2022-03-03 13:09:00'),(85719,263,'Bandlapalli','515110',1,0,'2022-03-03 13:09:00','2022-03-03 13:09:00'),(85720,263,'Basampalli','515651',1,0,'2022-03-03 13:09:00','2022-03-03 13:09:00'),(85721,263,'Basavanahalli','515305',1,0,'2022-03-03 13:09:00','2022-03-03 13:09:00'),(85722,263,'Bathalapalli','515661',1,0,'2022-03-03 13:09:00','2022-03-03 13:09:00'),(85723,263,'Beechaganipalli','515261',1,0,'2022-03-03 13:09:00','2022-03-03 13:09:00'),(85724,263,'Beedupalli','515134',1,0,'2022-03-03 13:09:00','2022-03-03 13:09:00'),(85725,263,'Bevinahalli','515211',1,0,'2022-03-03 13:09:00','2022-03-03 13:09:00'),(85726,263,'Bhadrapuram','515641',1,0,'2022-03-03 13:09:00','2022-03-03 13:09:00'),(85727,263,'Bhanukota','515621',1,0,'2022-03-03 13:09:00','2022-03-03 13:09:00'),(85728,263,'Bhupasamudram','515341',1,0,'2022-03-03 13:09:00','2022-03-03 13:09:00'),(85729,263,'Birepalli','515212',1,0,'2022-03-03 13:09:00','2022-03-03 13:09:00'),(85730,263,'Bisalamanepalli','515331',1,0,'2022-03-03 13:09:00','2022-03-03 13:09:00'),(85731,263,'BIT College BO','515202',1,0,'2022-03-03 13:09:00','2022-03-03 13:09:00'),(85732,263,'Bommagondanahalli','515271',1,0,'2022-03-03 13:09:00','2022-03-03 13:09:00'),(85733,263,'Bommireddipalli','515591',1,0,'2022-03-03 13:09:00','2022-03-03 13:09:00'),(85734,263,'Bonthalapalle','515531',1,0,'2022-03-03 13:09:00','2022-03-03 13:09:00'),(85735,263,'Bonthalapalle','515571',1,0,'2022-03-03 13:09:00','2022-03-03 13:09:00'),(85736,263,'Brahmanapalle','515134',1,0,'2022-03-03 13:09:00','2022-03-03 13:09:00'),(85737,263,'Brahmasamudram','515124',1,0,'2022-03-03 13:09:00','2022-03-03 13:09:00'),(85738,263,'Buchayyagaripalli','515144',1,0,'2022-03-03 13:09:00','2022-03-03 13:09:00'),(85739,263,'Bucherla','515123',1,0,'2022-03-03 13:09:00','2022-03-03 13:09:00'),(85740,263,'Budanampalle','515511',1,0,'2022-03-03 13:09:00','2022-03-03 13:09:00'),(85741,263,'Budidagaddapalli','515241',1,0,'2022-03-03 13:09:00','2022-03-03 13:09:00'),(85742,263,'Budili','515241',1,0,'2022-03-03 13:09:00','2022-03-03 13:09:00'),(85743,263,'Budilisettipalli','515241',1,0,'2022-03-03 13:09:01','2022-03-03 13:09:01'),(85744,263,'Bukkapatnam','515144',1,0,'2022-03-03 13:09:01','2022-03-03 13:09:01'),(85745,263,'Bullasamudram','515303',1,0,'2022-03-03 13:09:01','2022-03-03 13:09:01'),(85746,263,'Bussaiahgaripalli','515241',1,0,'2022-03-03 13:09:01','2022-03-03 13:09:01'),(85747,263,'Byagarlapalli','515301',1,0,'2022-03-03 13:09:01','2022-03-03 13:09:01'),(85748,263,'Byrapuram','515110',1,0,'2022-03-03 13:09:01','2022-03-03 13:09:01'),(85749,263,'Chagaleru','515601',1,0,'2022-03-03 13:09:01','2022-03-03 13:09:01'),(85750,263,'Chakarlapalli','515122',1,0,'2022-03-03 13:09:01','2022-03-03 13:09:01'),(85751,263,'Chalakur','515122',1,0,'2022-03-03 13:09:01','2022-03-03 13:09:01'),(85752,263,'Chalivendla','515331',1,0,'2022-03-03 13:09:01','2022-03-03 13:09:01'),(85753,263,'Challapalli','515122',1,0,'2022-03-03 13:09:01','2022-03-03 13:09:01'),(85754,263,'Chandakacherla','515301',1,0,'2022-03-03 13:09:01','2022-03-03 13:09:01'),(85755,263,'Cheekatimanipalli','515571',1,0,'2022-03-03 13:09:01','2022-03-03 13:09:01'),(85756,263,'Cheepuleti','515303',1,0,'2022-03-03 13:09:01','2022-03-03 13:09:01'),(85757,263,'Chennamanayani Kota','515641',1,0,'2022-03-03 13:09:01','2022-03-03 13:09:01'),(85758,263,'Chennampalli','515621',1,0,'2022-03-03 13:09:01','2022-03-03 13:09:01'),(85759,263,'Chennarajupalli','515110',1,0,'2022-03-03 13:09:01','2022-03-03 13:09:01'),(85760,263,'Chennekothapalli','515101',1,0,'2022-03-03 13:09:01','2022-03-03 13:09:01'),(85761,263,'Cherlokodigepalli','515303',1,0,'2022-03-03 13:09:01','2022-03-03 13:09:01'),(85762,263,'Cherukuru','515124',1,0,'2022-03-03 13:09:01','2022-03-03 13:09:01'),(85763,263,'Chigicherla','515672',1,0,'2022-03-03 13:09:01','2022-03-03 13:09:01'),(85764,263,'Chikirevulapalli','515556',1,0,'2022-03-03 13:09:01','2022-03-03 13:09:01'),(85765,263,'Chikkachoragiri','515271',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85766,263,'Chilamathur','515341',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85767,263,'Chillakondayapalli','515631',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85768,263,'Chillavaripalle','515631',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85769,263,'Chinnachigullarevu','515631',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85770,263,'Chinnaganapalle','515556',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85771,263,'Chinnamanthur','515124',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85772,263,'Chinnaramannagaripalli','515571',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85773,263,'Chinnarayanipalli','515501',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85774,263,'Chippalamadugu','515541',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85775,263,'Chitnaduku','515281',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85776,263,'Cholasamudram','515331',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85777,263,'Cholemarri','515124',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85778,263,'Chowluru','515211',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85779,263,'Chowtakuntapalli','515501',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85780,263,'Chowtivaripalle','515551',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85781,263,'Clock Tower Kadiri','515591',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85782,263,'D.Cherlopalli','515672',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85783,263,'Dabburivaripalli','515531',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85784,263,'Dadalur','515641',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85785,263,'Dadithota','515631',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85786,263,'Dampetla','515672',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85787,263,'Darsimala','515672',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85788,263,'Dasappapalyam','515291',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85789,263,'Demakethapalli','515331',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85790,263,'Dhaniyancheruvu','515521',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85791,263,'Dharmavaram Bazar','515671',1,0,'2022-03-03 13:09:02','2022-03-03 13:09:02'),(85792,263,'Dharmavaram H.O','515671',1,0,'2022-03-03 13:09:03','2022-03-03 13:09:03'),(85793,263,'Dharmavaram R.S','515672',1,0,'2022-03-03 13:09:03','2022-03-03 13:09:03'),(85794,263,'Diguvathotlipalli','515571',1,0,'2022-03-03 13:09:03','2022-03-03 13:09:03'),(85795,263,'Dodaghatta','515123',1,0,'2022-03-03 13:09:03','2022-03-03 13:09:03'),(85796,263,'Dodderi','515321',1,0,'2022-03-03 13:09:03','2022-03-03 13:09:03'),(85797,263,'Dokkalahalli','515321',1,0,'2022-03-03 13:09:03','2022-03-03 13:09:03'),(85798,263,'Donnikota','515531',1,0,'2022-03-03 13:09:03','2022-03-03 13:09:03'),(85799,263,'Dorigallu','515511',1,0,'2022-03-03 13:09:03','2022-03-03 13:09:03'),(85800,263,'Duddebanda','515164',1,0,'2022-03-03 13:09:03','2022-03-03 13:09:03'),(85801,263,'East Nadimpalle','515581',1,0,'2022-03-03 13:09:03','2022-03-03 13:09:03'),(85802,263,'Eddulavaripalli','515531',1,0,'2022-03-03 13:09:03','2022-03-03 13:09:03'),(85803,263,'Edulaballapuram','515122',1,0,'2022-03-03 13:09:03','2022-03-03 13:09:03'),(85804,263,'Eguvagangireddipalli','515531',1,0,'2022-03-03 13:09:03','2022-03-03 13:09:03'),(85805,263,'Elakuntla','515641',1,0,'2022-03-03 13:09:03','2022-03-03 13:09:03'),(85806,263,'Elukuntla','515159',1,0,'2022-03-03 13:09:03','2022-03-03 13:09:03'),(85807,263,'Enumulavaripalli','515501',1,0,'2022-03-03 13:09:03','2022-03-03 13:09:03'),(85808,263,'Erradoddi','515541',1,0,'2022-03-03 13:09:03','2022-03-03 13:09:03'),(85809,263,'Errakuntapalle','515571',1,0,'2022-03-03 13:09:03','2022-03-03 13:09:03'),(85810,263,'Ethodu','515571',1,0,'2022-03-03 13:09:03','2022-03-03 13:09:03'),(85811,263,'Galibipalli','515331',1,0,'2022-03-03 13:09:03','2022-03-03 13:09:03'),(85812,263,'Gandhodivandlapalli','515571',1,0,'2022-03-03 13:09:03','2022-03-03 13:09:03'),(85813,263,'Gandlapenta','515521',1,0,'2022-03-03 13:09:03','2022-03-03 13:09:03'),(85814,263,'Gandlavandlapalli','515511',1,0,'2022-03-03 13:09:03','2022-03-03 13:09:03'),(85815,263,'Gangampalli','515231',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85816,263,'Ganginepalli','515144',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85817,263,'Gangivaripalli','515581',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85818,263,'Gangulavaipalem','515291',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85819,263,'Gantimarri','515101',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85820,263,'Garimakulapalli','515621',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85821,263,'Garisalapalli','515631',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85822,263,'Gasikavaripalli','515154',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85823,263,'Ghntapuram','515661',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85824,263,'Gollapalli','515212',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85825,263,'Gollapuram','515211',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85826,263,'Gonimekalapalli','515123',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85827,263,'Gonipeta','515110',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85828,263,'Gopepalli','515501',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85829,263,'Gorantla','515231',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85830,263,'Gotluru','515672',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85831,263,'Govindapuram','515291',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85832,263,'Gowdanahalli','515301',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85833,263,'Gowkanapalle','515581',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85834,263,'Gownipalli','515561',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85835,263,'Gownivaripalli','515231',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85836,263,'Gowrajupalle','515123',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85837,263,'Gowrapuram','515561',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85838,263,'Guddadahalli','515271',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85839,263,'Guddampalle','515291',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85840,263,'Gudduguriki','515291',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85841,263,'Gudibanda (Ananthapur)','515271',1,0,'2022-03-03 13:09:04','2022-03-03 13:09:04'),(85842,263,'Gudipalli','515122',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85843,263,'Gummaiahgaripalli','515231',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85844,263,'Gunemorubagal','515286',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85845,263,'Gunipalli','515154',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85846,263,'Gunjepalli','515159',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85847,263,'Gurrambailu','515571',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85848,263,'Gurrapukonda','515305',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85849,263,'Gutibailu','515521',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85850,263,'Guttur','515164',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85851,263,'Guvvalaguttapalli','515231',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85852,263,'Halkur','515281',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85853,263,'Hallikera','515311',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85854,263,'Hallikera Devarahalli','515311',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85855,263,'Haludi','515311',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85856,263,'Hanumpalli','515164',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85857,263,'Haresamudram','515301',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85858,263,'Hemavathi','515286',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85859,263,'Hindupur Extns','515201',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85860,263,'Hindupur Fort','515202',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85861,263,'Hindupur H.O','515201',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85862,263,'Hindupur Sevamandir','515212',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85863,263,'Hirethurpi','515305',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85864,263,'Honnampalli','515261',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85865,263,'Hottebetta','515291',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85866,263,'Hottethimmanahalli','515271',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85867,263,'Hulikunta','515321',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85868,263,'Inagalur','515311',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85869,263,'Inagaluru','515591',1,0,'2022-03-03 13:09:05','2022-03-03 13:09:05'),(85870,263,'Jagarajupalli','515133',1,0,'2022-03-03 13:09:06','2022-03-03 13:09:06'),(85871,263,'Jakkasamudram','515231',1,0,'2022-03-03 13:09:06','2022-03-03 13:09:06'),(85872,263,'Jambalabanda','515305',1,0,'2022-03-03 13:09:06','2022-03-03 13:09:06'),(85873,263,'Javukulakothapalle','515561',1,0,'2022-03-03 13:09:06','2022-03-03 13:09:06'),(85874,263,'Jeenulakunta','515521',1,0,'2022-03-03 13:09:06','2022-03-03 13:09:06'),(85875,263,'Jonnalakothapalli','515159',1,0,'2022-03-03 13:09:06','2022-03-03 13:09:06'),(85876,263,'K.Brahmanapalli','515591',1,0,'2022-03-03 13:09:06','2022-03-03 13:09:06'),(85877,263,'K.Mallireddipalle','515571',1,0,'2022-03-03 13:09:06','2022-03-03 13:09:06'),(85878,263,'Kadiri Chowk','515591',1,0,'2022-03-03 13:09:06','2022-03-03 13:09:06'),(85879,263,'Kadiri Kuntlapalli','515541',1,0,'2022-03-03 13:09:06','2022-03-03 13:09:06'),(85880,263,'Kadiri','515591',1,0,'2022-03-03 13:09:06','2022-03-03 13:09:06'),(85881,263,'Kadiripulikunta','515551',1,0,'2022-03-03 13:09:06','2022-03-03 13:09:06'),(85882,263,'Kaganapalli','515241',1,0,'2022-03-03 13:09:06','2022-03-03 13:09:06'),(85883,263,'Kaggallu','515202',1,0,'2022-03-03 13:09:06','2022-03-03 13:09:06'),(85884,263,'Kaki','515321',1,0,'2022-03-03 13:09:06','2022-03-03 13:09:06'),(85885,263,'Kalasamudram','515501',1,0,'2022-03-03 13:09:06','2022-03-03 13:09:06'),(85886,263,'Kalipi','515124',1,0,'2022-03-03 13:09:06','2022-03-03 13:09:06'),(85887,263,'Kallagiri','515241',1,0,'2022-03-03 13:09:06','2022-03-03 13:09:06'),(85888,263,'Kallumarri','515303',1,0,'2022-03-03 13:09:06','2022-03-03 13:09:06'),(85889,263,'Kalluru','515331',1,0,'2022-03-03 13:09:06','2022-03-03 13:09:06'),(85890,263,'Kamatampalle','515521',1,0,'2022-03-03 13:09:06','2022-03-03 13:09:06'),(85891,263,'Kammavaripalli','515231',1,0,'2022-03-03 13:09:06','2022-03-03 13:09:06'),(85892,263,'Kanaganapalli','515641',1,0,'2022-03-03 13:09:06','2022-03-03 13:09:06'),(85893,263,'Kancharavandlapalli','515556',1,0,'2022-03-03 13:09:06','2022-03-03 13:09:06'),(85894,263,'Kanchisamudram','515331',1,0,'2022-03-03 13:09:06','2022-03-03 13:09:06'),(85895,263,'Kanisettipalli','515341',1,0,'2022-03-03 13:09:07','2022-03-03 13:09:07'),(85896,263,'Kanisettipalli','515144',1,0,'2022-03-03 13:09:07','2022-03-03 13:09:07'),(85897,263,'Kanumukkala','515651',1,0,'2022-03-03 13:09:07','2022-03-03 13:09:07'),(85898,263,'Kappalabanda','515133',1,0,'2022-03-03 13:09:07','2022-03-03 13:09:07'),(85899,263,'Karavulapalli','515231',1,0,'2022-03-03 13:09:07','2022-03-03 13:09:07'),(85900,263,'Karidasanahalli','515311',1,0,'2022-03-03 13:09:07','2022-03-03 13:09:07'),(85901,263,'Karikera','515305',1,0,'2022-03-03 13:09:07','2022-03-03 13:09:07'),(85902,263,'Kassamudram','515556',1,0,'2022-03-03 13:09:07','2022-03-03 13:09:07'),(85903,263,'Katakamvaripalli','515521',1,0,'2022-03-03 13:09:07','2022-03-03 13:09:07'),(85904,263,'Katarupalle','515521',1,0,'2022-03-03 13:09:07','2022-03-03 13:09:07'),(85905,263,'Kenkara','515286',1,0,'2022-03-03 13:09:07','2022-03-03 13:09:07'),(85906,263,'Kesapuram','515144',1,0,'2022-03-03 13:09:07','2022-03-03 13:09:07'),(85907,263,'Kirikera','515211',1,0,'2022-03-03 13:09:07','2022-03-03 13:09:07'),(85908,263,'Kodapaganipalli','515144',1,0,'2022-03-03 13:09:07','2022-03-03 13:09:07'),(85909,263,'Kodavandlapalle','515511',1,0,'2022-03-03 13:09:07','2022-03-03 13:09:07'),(85910,263,'Kodihalli','515311',1,0,'2022-03-03 13:09:07','2022-03-03 13:09:07'),(85911,263,'Kodihalli','515202',1,0,'2022-03-03 13:09:07','2022-03-03 13:09:07'),(85912,263,'Kodikonda','515601',1,0,'2022-03-03 13:09:07','2022-03-03 13:09:07'),(85913,263,'Kodur','515601',1,0,'2022-03-03 13:09:07','2022-03-03 13:09:07'),(85914,263,'Kogira','515123',1,0,'2022-03-03 13:09:07','2022-03-03 13:09:07'),(85915,263,'Kokkanti','515571',1,0,'2022-03-03 13:09:07','2022-03-03 13:09:07'),(85916,263,'Konapuram','515110',1,0,'2022-03-03 13:09:07','2022-03-03 13:09:07'),(85917,263,'Kondaguttapalli','515541',1,0,'2022-03-03 13:09:07','2022-03-03 13:09:07'),(85918,263,'Kondakamarla','515531',1,0,'2022-03-03 13:09:07','2022-03-03 13:09:07'),(85919,263,'Kondamanayanipalem','515541',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85920,263,'Kondapuram','515110',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85921,263,'Kondapuram','515231',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85922,263,'Kondapuram','515621',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85923,263,'Kondavenukapalli','515571',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85924,263,'Kondur','515331',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85925,263,'Konetinayanipalem','515621',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85926,263,'Konkallu','515271',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85927,263,'Korthikota','515571',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85928,263,'Kotapalli','515571',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85929,263,'Kothacheruvu','515133',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85930,263,'Kothagundumala','515291',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85931,263,'Kothakota','515154',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85932,263,'Kotipi','515211',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85933,263,'Kotlapalli','515110',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85934,263,'Kotnur','515212',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85935,263,'Kovvurivandlapalle','515581',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85936,263,'Kowlepalli','515591',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85937,263,'Krishnapuram (Ananthapur)','515159',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85938,263,'Kumbaranagenahalli','515305',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85939,263,'Kuntimaddi','515101',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85940,263,'Kunukuntla','515631',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85941,263,'Kunuthuru','515672',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85942,263,'Kurakulapalli','515621',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85943,263,'Kurlyreddivaripalli','515581',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85944,263,'Kurubavandlapalli','515164',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85945,263,'Kurumala','515531',1,0,'2022-03-03 13:09:08','2022-03-03 13:09:08'),(85946,263,'Kurumamidi','515521',1,0,'2022-03-03 13:09:09','2022-03-03 13:09:09'),(85947,263,'Kutagulla','515541',1,0,'2022-03-03 13:09:09','2022-03-03 13:09:09'),(85948,263,'Kutalacheruvupalli','515501',1,0,'2022-03-03 13:09:09','2022-03-03 13:09:09'),(85949,263,'Lakkasamudram','515541',1,0,'2022-03-03 13:09:09','2022-03-03 13:09:09'),(85950,263,'Lalepalli','515341',1,0,'2022-03-03 13:09:09','2022-03-03 13:09:09'),(85951,263,'Lepakshi','515331',1,0,'2022-03-03 13:09:09','2022-03-03 13:09:09'),(85952,263,'Locherla','515133',1,0,'2022-03-03 13:09:09','2022-03-03 13:09:09'),(85953,263,'M.Rayapuram','515271',1,0,'2022-03-03 13:09:09','2022-03-03 13:09:09'),(85954,263,'Madakasira','515301',1,0,'2022-03-03 13:09:09','2022-03-03 13:09:09'),(85955,263,'Maddalacheruvu','515621',1,0,'2022-03-03 13:09:09','2022-03-03 13:09:09'),(85956,263,'Maddanakunta','515281',1,0,'2022-03-03 13:09:09','2022-03-03 13:09:09'),(85957,263,'Madhudi','515311',1,0,'2022-03-03 13:09:09','2022-03-03 13:09:09'),(85958,263,'Malakavemula','515501',1,0,'2022-03-03 13:09:09','2022-03-03 13:09:09'),(85959,263,'Malamidipalli','515521',1,0,'2022-03-03 13:09:09','2022-03-03 13:09:09'),(85960,263,'Mallakalva','515672',1,0,'2022-03-03 13:09:09','2022-03-03 13:09:09'),(85961,263,'Mallepalli','515541',1,0,'2022-03-03 13:09:09','2022-03-03 13:09:09'),(85962,263,'Mallepalli','515241',1,0,'2022-03-03 13:09:09','2022-03-03 13:09:09'),(85963,263,'Malugur','515212',1,0,'2022-03-03 13:09:09','2022-03-03 13:09:09'),(85964,263,'Malyavantham','515661',1,0,'2022-03-03 13:09:09','2022-03-03 13:09:09'),(85965,263,'Mamidimakulapalli','515331',1,0,'2022-03-03 13:09:09','2022-03-03 13:09:09'),(85966,263,'Mandalahalli','515271',1,0,'2022-03-03 13:09:09','2022-03-03 13:09:09'),(85967,263,'Mandalapalle','515231',1,0,'2022-03-03 13:09:09','2022-03-03 13:09:09'),(85968,263,'Mandli','515124',1,0,'2022-03-03 13:09:09','2022-03-03 13:09:09'),(85969,263,'Manepalli','515331',1,0,'2022-03-03 13:09:09','2022-03-03 13:09:09'),(85970,263,'Manesamudram','515212',1,0,'2022-03-03 13:09:09','2022-03-03 13:09:09'),(85971,263,'Mangalamadaka','515154',1,0,'2022-03-03 13:09:10','2022-03-03 13:09:10'),(85972,263,'Manur','515303',1,0,'2022-03-03 13:09:10','2022-03-03 13:09:10'),(85973,263,'Marakuntapalli','515133',1,0,'2022-03-03 13:09:10','2022-03-03 13:09:10'),(85974,263,'Marala','515159',1,0,'2022-03-03 13:09:10','2022-03-03 13:09:10'),(85975,263,'Maravapalli Agraharam','515631',1,0,'2022-03-03 13:09:10','2022-03-03 13:09:10'),(85976,263,'Marrikommadinne','515521',1,0,'2022-03-03 13:09:10','2022-03-03 13:09:10'),(85977,263,'Marrimakulapalle','515631',1,0,'2022-03-03 13:09:10','2022-03-03 13:09:10'),(85978,263,'Marthadu','515511',1,0,'2022-03-03 13:09:10','2022-03-03 13:09:10'),(85979,263,'Maruru','515641',1,0,'2022-03-03 13:09:10','2022-03-03 13:09:10'),(85980,263,'Mavatur','515124',1,0,'2022-03-03 13:09:10','2022-03-03 13:09:10'),(85981,263,'Medapuram','515651',1,0,'2022-03-03 13:09:10','2022-03-03 13:09:10'),(85982,263,'Mekalacheruvu','515521',1,0,'2022-03-03 13:09:10','2022-03-03 13:09:10'),(85983,263,'Melavoy','515301',1,0,'2022-03-03 13:09:10','2022-03-03 13:09:10'),(85984,263,'Mirjapuram','515133',1,0,'2022-03-03 13:09:10','2022-03-03 13:09:10'),(85985,263,'Moda','515212',1,0,'2022-03-03 13:09:10','2022-03-03 13:09:10'),(85986,263,'Modugulakunta','515631',1,0,'2022-03-03 13:09:10','2022-03-03 13:09:10'),(85987,263,'Mohammadabad','515561',1,0,'2022-03-03 13:09:10','2022-03-03 13:09:10'),(85988,263,'Morampalle','515601',1,0,'2022-03-03 13:09:10','2022-03-03 13:09:10'),(85989,263,'Morasalapalli','515601',1,0,'2022-03-03 13:09:10','2022-03-03 13:09:10'),(85990,263,'Morubagalu','515286',1,0,'2022-03-03 13:09:10','2022-03-03 13:09:10'),(85991,263,'Mothukapalli','515212',1,0,'2022-03-03 13:09:10','2022-03-03 13:09:10'),(85992,263,'Motorchintalapalle','515621',1,0,'2022-03-03 13:09:10','2022-03-03 13:09:10'),(85993,263,'Muddireddypalli','515202',1,0,'2022-03-03 13:09:11','2022-03-03 13:09:11'),(85994,263,'Mudigubba','515511',1,0,'2022-03-03 13:09:11','2022-03-03 13:09:11'),(85995,263,'Mukthapuram','515641',1,0,'2022-03-03 13:09:11','2022-03-03 13:09:11'),(85996,263,'Mukthapuram','515159',1,0,'2022-03-03 13:09:11','2022-03-03 13:09:11'),(85997,263,'Mulakalacheruvu','515123',1,0,'2022-03-03 13:09:11','2022-03-03 13:09:11'),(85998,263,'Mundlavaripalli','515571',1,0,'2022-03-03 13:09:11','2022-03-03 13:09:11'),(85999,263,'Munimadugu','515164',1,0,'2022-03-03 13:09:11','2022-03-03 13:09:11'),(86000,263,'Mustikovela','515101',1,0,'2022-03-03 13:09:11','2022-03-03 13:09:11'),(86001,263,'Musturu','515661',1,0,'2022-03-03 13:09:11','2022-03-03 13:09:11'),(86002,263,'Muthyalacheruvu','515591',1,0,'2022-03-03 13:09:11','2022-03-03 13:09:11'),(86003,263,'Mutukuru','515271',1,0,'2022-03-03 13:09:11','2022-03-03 13:09:11'),(86004,263,'Mydugolam','515331',1,0,'2022-03-03 13:09:11','2022-03-03 13:09:11'),(86005,263,'Mylasamudram','515144',1,0,'2022-03-03 13:09:11','2022-03-03 13:09:11'),(86006,263,'N.Madapuram','515672',1,0,'2022-03-03 13:09:11','2022-03-03 13:09:11'),(86007,263,'N.P.Kunta','515521',1,0,'2022-03-03 13:09:11','2022-03-03 13:09:11'),(86008,263,'Nachenahalli','515286',1,0,'2022-03-03 13:09:11','2022-03-03 13:09:11'),(86009,263,'Nadimpalli','515122',1,0,'2022-03-03 13:09:11','2022-03-03 13:09:11'),(86010,263,'Nagalur','515124',1,0,'2022-03-03 13:09:11','2022-03-03 13:09:11'),(86011,263,'Nagasamudram','515101',1,0,'2022-03-03 13:09:11','2022-03-03 13:09:11'),(86012,263,'Naginayanicheruvu Thanda','515122',1,0,'2022-03-03 13:09:12','2022-03-03 13:09:12'),(86013,263,'Nagireddipalli','515133',1,0,'2022-03-03 13:09:12','2022-03-03 13:09:12'),(86014,263,'Nallaboyanapalle','515672',1,0,'2022-03-03 13:09:12','2022-03-03 13:09:12'),(86015,263,'Nallacherlopalli','515159',1,0,'2022-03-03 13:09:12','2022-03-03 13:09:12'),(86016,263,'Nallacheruvu','515551',1,0,'2022-03-03 13:09:12','2022-03-03 13:09:12'),(86017,263,'Nallaguttapalli','515561',1,0,'2022-03-03 13:09:12','2022-03-03 13:09:12'),(86018,263,'Nallamada','515501',1,0,'2022-03-03 13:09:12','2022-03-03 13:09:12'),(86019,263,'Nallur','515124',1,0,'2022-03-03 13:09:12','2022-03-03 13:09:12'),(86020,263,'Naranagepalli','515123',1,0,'2022-03-03 13:09:12','2022-03-03 13:09:12'),(86021,263,'Narasambudi','515311',1,0,'2022-03-03 13:09:12','2022-03-03 13:09:12'),(86022,263,'Narasampalli','515641',1,0,'2022-03-03 13:09:12','2022-03-03 13:09:12'),(86023,263,'Narasapuram','515261',1,0,'2022-03-03 13:09:12','2022-03-03 13:09:12'),(86024,263,'Narasimpalli','515661',1,0,'2022-03-03 13:09:12','2022-03-03 13:09:12'),(86025,263,'Narasimpalli Thanda','515144',1,0,'2022-03-03 13:09:12','2022-03-03 13:09:12'),(86026,263,'Narepalli','515144',1,0,'2022-03-03 13:09:12','2022-03-03 13:09:12'),(86027,263,'Nasanakota','515672',1,0,'2022-03-03 13:09:12','2022-03-03 13:09:12'),(86028,263,'Nawabkota','515531',1,0,'2022-03-03 13:09:12','2022-03-03 13:09:12'),(86029,263,'Neelakantapuram','515291',1,0,'2022-03-03 13:09:12','2022-03-03 13:09:12'),(86030,263,'Neerukuntapalle','515541',1,0,'2022-03-03 13:09:12','2022-03-03 13:09:12'),(86031,263,'Nelakota','515159',1,0,'2022-03-03 13:09:13','2022-03-03 13:09:13'),(86032,263,'Nesevandlapalli','515601',1,0,'2022-03-03 13:09:13','2022-03-03 13:09:13'),(86033,263,'Nidigallu','515661',1,0,'2022-03-03 13:09:13','2022-03-03 13:09:13'),(86034,263,'Nidimamidi','515110',1,0,'2022-03-03 13:09:13','2022-03-03 13:09:13'),(86035,263,'Nidraghatta','515286',1,0,'2022-03-03 13:09:13','2022-03-03 13:09:13'),(86036,263,'Niluvarathipalli','515561',1,0,'2022-03-03 13:09:13','2022-03-03 13:09:13'),(86037,263,'Nuthanakalva','515581',1,0,'2022-03-03 13:09:13','2022-03-03 13:09:13'),(86038,263,'Nyamaddala','515101',1,0,'2022-03-03 13:09:13','2022-03-03 13:09:13'),(86039,263,'Obula Devara Cheruvu','515561',1,0,'2022-03-03 13:09:13','2022-03-03 13:09:13'),(86040,263,'Obulapuram','515672',1,0,'2022-03-03 13:09:13','2022-03-03 13:09:13'),(86041,263,'Obulareddipalli','515581',1,0,'2022-03-03 13:09:13','2022-03-03 13:09:13'),(86042,263,'Odulapalli','515581',1,0,'2022-03-03 13:09:13','2022-03-03 13:09:13'),(86043,263,'P.Byadagere','515311',1,0,'2022-03-03 13:09:13','2022-03-03 13:09:13'),(86044,263,'P.Kothapalli','515521',1,0,'2022-03-03 13:09:13','2022-03-03 13:09:13'),(86045,263,'P.Kothapalli','515551',1,0,'2022-03-03 13:09:13','2022-03-03 13:09:13'),(86046,263,'P.Sadlapalli','515202',1,0,'2022-03-03 13:09:13','2022-03-03 13:09:13'),(86047,263,'Palasamudram','515241',1,0,'2022-03-03 13:09:13','2022-03-03 13:09:13'),(86048,263,'Pamudurthi','515154',1,0,'2022-03-03 13:09:13','2022-03-03 13:09:13'),(86049,263,'Pandiparthi','515122',1,0,'2022-03-03 13:09:13','2022-03-03 13:09:13'),(86050,263,'Pandulakunta','515541',1,0,'2022-03-03 13:09:13','2022-03-03 13:09:13'),(86051,263,'Parigi','515261',1,0,'2022-03-03 13:09:13','2022-03-03 13:09:13'),(86052,263,'Pathikuntapalli','515241',1,0,'2022-03-03 13:09:13','2022-03-03 13:09:13'),(86053,263,'Patnam','515501',1,0,'2022-03-03 13:09:13','2022-03-03 13:09:13'),(86054,263,'Pedaballi','515571',1,0,'2022-03-03 13:09:13','2022-03-03 13:09:13'),(86055,263,'Pedaballi','515231',1,0,'2022-03-03 13:09:13','2022-03-03 13:09:13'),(86056,263,'Peddachigullarevu','515631',1,0,'2022-03-03 13:09:13','2022-03-03 13:09:13'),(86057,263,'Peddakadapalavaripalli','515571',1,0,'2022-03-03 13:09:14','2022-03-03 13:09:14'),(86058,263,'Peddakotla','515631',1,0,'2022-03-03 13:09:14','2022-03-03 13:09:14'),(86059,263,'Peddamanthur','515124',1,0,'2022-03-03 13:09:14','2022-03-03 13:09:14'),(86060,263,'Peddannavaripalli','515581',1,0,'2022-03-03 13:09:14','2022-03-03 13:09:14'),(86061,263,'Peddayellampalli','515551',1,0,'2022-03-03 13:09:14','2022-03-03 13:09:14'),(86062,263,'Pemanakuntapalli Thanda','515501',1,0,'2022-03-03 13:09:14','2022-03-03 13:09:14'),(86063,263,'Penukonda Fort','515110',1,0,'2022-03-03 13:09:14','2022-03-03 13:09:14'),(86064,263,'Penukonda','515110',1,0,'2022-03-03 13:09:14','2022-03-03 13:09:14'),(86065,263,'Perur (Ananthapur)','515621',1,0,'2022-03-03 13:09:14','2022-03-03 13:09:14'),(86066,263,'Phalaram','515271',1,0,'2022-03-03 13:09:14','2022-03-03 13:09:14'),(86067,263,'Pinnadhari','515631',1,0,'2022-03-03 13:09:14','2022-03-03 13:09:14'),(86068,263,'Pitchireddikottala','515621',1,0,'2022-03-03 13:09:14','2022-03-03 13:09:14'),(86069,263,'Podarallapalli','515154',1,0,'2022-03-03 13:09:14','2022-03-03 13:09:14'),(86070,263,'Polepalli','515101',1,0,'2022-03-03 13:09:14','2022-03-03 13:09:14'),(86071,263,'Pothulakunta','515133',1,0,'2022-03-03 13:09:14','2022-03-03 13:09:14'),(86072,263,'Pothulanagepalli','515651',1,0,'2022-03-03 13:09:14','2022-03-03 13:09:14'),(86073,263,'Potlamarri','515661',1,0,'2022-03-03 13:09:14','2022-03-03 13:09:14'),(86074,263,'Prasanthigram','515134',1,0,'2022-03-03 13:09:14','2022-03-03 13:09:14'),(86075,263,'Prasanthinilayam','515134',1,0,'2022-03-03 13:09:14','2022-03-03 13:09:14'),(86076,263,'Pulagampalli','515591',1,0,'2022-03-03 13:09:14','2022-03-03 13:09:14'),(86077,263,'Pulakunta','515202',1,0,'2022-03-03 13:09:14','2022-03-03 13:09:14'),(86078,263,'Puleru','515231',1,0,'2022-03-03 13:09:14','2022-03-03 13:09:14'),(86079,263,'Puletipalli','515101',1,0,'2022-03-03 13:09:15','2022-03-03 13:09:15'),(86080,263,'Pulikintapalli','515556',1,0,'2022-03-03 13:09:15','2022-03-03 13:09:15'),(86081,263,'Puttaparthi','515134',1,0,'2022-03-03 13:09:15','2022-03-03 13:09:15'),(86082,263,'Puttaparthy Main Bazar NDTSO','515134',1,0,'2022-03-03 13:09:15','2022-03-03 13:09:15'),(86083,263,'Pyadindi','515651',1,0,'2022-03-03 13:09:15','2022-03-03 13:09:15'),(86084,263,'R.Anantapuram','515303',1,0,'2022-03-03 13:09:15','2022-03-03 13:09:15'),(86085,263,'R.Locherla','515123',1,0,'2022-03-03 13:09:15','2022-03-03 13:09:15'),(86086,263,'Rachavaraipalli','515110',1,0,'2022-03-03 13:09:15','2022-03-03 13:09:15'),(86087,263,'Rachuru','515123',1,0,'2022-03-03 13:09:15','2022-03-03 13:09:15'),(86088,263,'Ragalinganahalli','515311',1,0,'2022-03-03 13:09:15','2022-03-03 13:09:15'),(86089,263,'Ralla Anantapuram','515621',1,0,'2022-03-03 13:09:15','2022-03-03 13:09:15'),(86090,263,'Rallahalli','515305',1,0,'2022-03-03 13:09:15','2022-03-03 13:09:15'),(86091,263,'Ramagiri','515672',1,0,'2022-03-03 13:09:15','2022-03-03 13:09:15'),(86092,263,'Ramasagaram','515159',1,0,'2022-03-03 13:09:15','2022-03-03 13:09:15'),(86093,263,'Rangepalli','515122',1,0,'2022-03-03 13:09:15','2022-03-03 13:09:15'),(86094,263,'Rathnagiri','515321',1,0,'2022-03-03 13:09:15','2022-03-03 13:09:15'),(86095,263,'Ravulacheruvu','515672',1,0,'2022-03-03 13:09:15','2022-03-03 13:09:15'),(86096,263,'Reddicheruvupalli','515241',1,0,'2022-03-03 13:09:15','2022-03-03 13:09:15'),(86097,263,'Reddipalli','515501',1,0,'2022-03-03 13:09:15','2022-03-03 13:09:15'),(86098,263,'Regatipalli','515672',1,0,'2022-03-03 13:09:15','2022-03-03 13:09:15'),(86099,263,'Roddam','515123',1,0,'2022-03-03 13:09:16','2022-03-03 13:09:16'),(86100,263,'Rolla','515321',1,0,'2022-03-03 13:09:16','2022-03-03 13:09:16'),(86101,263,'S.Rayapuram','515291',1,0,'2022-03-03 13:09:16','2022-03-03 13:09:16'),(86102,263,'S.Sadlapalli','515211',1,0,'2022-03-03 13:09:16','2022-03-03 13:09:16'),(86103,263,'Sandrascherla','515641',1,0,'2022-03-03 13:09:16','2022-03-03 13:09:16'),(86104,263,'Sangala','515672',1,0,'2022-03-03 13:09:16','2022-03-03 13:09:16'),(86105,263,'Sanipalli','515124',1,0,'2022-03-03 13:09:16','2022-03-03 13:09:16'),(86106,263,'Sanjeevapuram','515661',1,0,'2022-03-03 13:09:16','2022-03-03 13:09:16'),(86107,263,'Sankarakallu','515305',1,0,'2022-03-03 13:09:16','2022-03-03 13:09:16'),(86108,263,'Sankepalle','515511',1,0,'2022-03-03 13:09:16','2022-03-03 13:09:16'),(86109,263,'Santhebidanur','515211',1,0,'2022-03-03 13:09:16','2022-03-03 13:09:16'),(86110,263,'Sasanakota','515212',1,0,'2022-03-03 13:09:16','2022-03-03 13:09:16'),(86111,263,'Settipalli','515110',1,0,'2022-03-03 13:09:16','2022-03-03 13:09:16'),(86112,263,'Siddarampuram','515154',1,0,'2022-03-03 13:09:16','2022-03-03 13:09:16'),(86113,263,'Sirekolam','515261',1,0,'2022-03-03 13:09:16','2022-03-03 13:09:16'),(86114,263,'Sirivaram','515331',1,0,'2022-03-03 13:09:16','2022-03-03 13:09:16'),(86115,263,'Sivaram','515286',1,0,'2022-03-03 13:09:16','2022-03-03 13:09:16'),(86116,263,'Somaghatta','515601',1,0,'2022-03-03 13:09:16','2022-03-03 13:09:16'),(86117,263,'Somalavandlapalle','515581',1,0,'2022-03-03 13:09:16','2022-03-03 13:09:16'),(86118,263,'Somandepalli','515122',1,0,'2022-03-03 13:09:16','2022-03-03 13:09:16'),(86119,263,'Srirangarajupalli','515212',1,0,'2022-03-03 13:09:16','2022-03-03 13:09:16'),(86120,263,'Subbaraopeta','515672',1,0,'2022-03-03 13:09:16','2022-03-03 13:09:16'),(86121,263,'Suddakuntapalli','515122',1,0,'2022-03-03 13:09:16','2022-03-03 13:09:16'),(86122,263,'Sunnampalle','515561',1,0,'2022-03-03 13:09:16','2022-03-03 13:09:16'),(86123,263,'Tadimarri','515631',1,0,'2022-03-03 13:09:16','2022-03-03 13:09:16'),(86124,263,'Talamarla','515133',1,0,'2022-03-03 13:09:17','2022-03-03 13:09:17'),(86125,263,'Tallikera','515271',1,0,'2022-03-03 13:09:17','2022-03-03 13:09:17'),(86126,263,'Tallimadugu','515672',1,0,'2022-03-03 13:09:17','2022-03-03 13:09:17'),(86127,263,'Talupula','515581',1,0,'2022-03-03 13:09:17','2022-03-03 13:09:17'),(86128,263,'Tammadehalli','515281',1,0,'2022-03-03 13:09:17','2022-03-03 13:09:17'),(86129,263,'Tanakallu','515571',1,0,'2022-03-03 13:09:17','2022-03-03 13:09:17'),(86130,263,'Tangedikunta','515561',1,0,'2022-03-03 13:09:17','2022-03-03 13:09:17'),(86131,263,'Tavalamarri','515551',1,0,'2022-03-03 13:09:17','2022-03-03 13:09:17'),(86132,263,'Tekulodu','515341',1,0,'2022-03-03 13:09:17','2022-03-03 13:09:17'),(86133,263,'Thippepalle','515561',1,0,'2022-03-03 13:09:17','2022-03-03 13:09:17'),(86134,263,'Thirumaladevarapalli','515271',1,0,'2022-03-03 13:09:17','2022-03-03 13:09:17'),(86135,263,'Thogarakunta','515641',1,0,'2022-03-03 13:09:17','2022-03-03 13:09:17'),(86136,263,'Thummala','515672',1,0,'2022-03-03 13:09:17','2022-03-03 13:09:17'),(86137,263,'Thummalakunta','515341',1,0,'2022-03-03 13:09:17','2022-03-03 13:09:17'),(86138,263,'Thummalakuntapalli','515561',1,0,'2022-03-03 13:09:17','2022-03-03 13:09:17'),(86139,263,'Thumucherla','515641',1,0,'2022-03-03 13:09:17','2022-03-03 13:09:17'),(86140,263,'Thungodu','515241',1,0,'2022-03-03 13:09:17','2022-03-03 13:09:17'),(86141,263,'Thurukalapatnam','515123',1,0,'2022-03-03 13:09:17','2022-03-03 13:09:17'),(86142,263,'Tummala','515556',1,0,'2022-03-03 13:09:17','2022-03-03 13:09:17'),(86143,263,'Ubicherla','515551',1,0,'2022-03-03 13:09:17','2022-03-03 13:09:17'),(86144,263,'Uppalapadu','515511',1,0,'2022-03-03 13:09:17','2022-03-03 13:09:17'),(86145,263,'Uppidipalli','515303',1,0,'2022-03-03 13:09:17','2022-03-03 13:09:17'),(86146,263,'Uruvoi Mallireddypalli','515551',1,0,'2022-03-03 13:09:17','2022-03-03 13:09:17'),(86147,263,'Utukuru','515261',1,0,'2022-03-03 13:09:17','2022-03-03 13:09:17'),(86148,263,'Vadigepalli','515241',1,0,'2022-03-03 13:09:18','2022-03-03 13:09:18'),(86149,263,'Valasa','515281',1,0,'2022-03-03 13:09:18','2022-03-03 13:09:18'),(86150,263,'Vanavolu','515231',1,0,'2022-03-03 13:09:18','2022-03-03 13:09:18'),(86151,263,'Vankapalle','515571',1,0,'2022-03-03 13:09:18','2022-03-03 13:09:18'),(86152,263,'Vankarakunta','515501',1,0,'2022-03-03 13:09:18','2022-03-03 13:09:18'),(86153,263,'Veerapuram','515341',1,0,'2022-03-03 13:09:18','2022-03-03 13:09:18'),(86154,263,'Veldurthi','515651',1,0,'2022-03-03 13:09:18','2022-03-03 13:09:18'),(86155,263,'Velichelamala','515581',1,0,'2022-03-03 13:09:18','2022-03-03 13:09:18'),(86156,263,'Vellamaddi','515501',1,0,'2022-03-03 13:09:18','2022-03-03 13:09:18'),(86157,263,'Vengalammacheruvu','515144',1,0,'2022-03-03 13:09:18','2022-03-03 13:09:18'),(86158,263,'Venkatagaripalli','515133',1,0,'2022-03-03 13:09:18','2022-03-03 13:09:18'),(86159,263,'Venkatagiripalem','515164',1,0,'2022-03-03 13:09:18','2022-03-03 13:09:18'),(86160,263,'Venkatampalli','515101',1,0,'2022-03-03 13:09:18','2022-03-03 13:09:18'),(86161,263,'Venkatareddipalli','515110',1,0,'2022-03-03 13:09:18','2022-03-03 13:09:18'),(86162,263,'Vepakunta','515621',1,0,'2022-03-03 13:09:18','2022-03-03 13:09:18'),(86163,263,'Vepamanipeta','515581',1,0,'2022-03-03 13:09:18','2022-03-03 13:09:18'),(86164,263,'Vittapalli','515261',1,0,'2022-03-03 13:09:18','2022-03-03 13:09:18'),(86165,263,'Yelloti','515303',1,0,'2022-03-03 13:09:18','2022-03-03 13:09:18'),(86166,263,'Yenumulapalli','515134',1,0,'2022-03-03 13:09:18','2022-03-03 13:09:18'),(86167,263,'Yerrabommanahalli','515301',1,0,'2022-03-03 13:09:18','2022-03-03 13:09:18'),(86168,263,'Yerragunta','515261',1,0,'2022-03-03 13:09:18','2022-03-03 13:09:18'),(86169,263,'Yerraguntapalle','515631',1,0,'2022-03-03 13:09:18','2022-03-03 13:09:18'),(86170,263,'Zilladakunta','515301',1,0,'2022-03-03 13:09:18','2022-03-03 13:09:18'),(86171,264,'Adavibudugur','517425',1,0,'2022-03-03 13:09:18','2022-03-03 13:09:18'),(86172,264,'Adilakshmambapuram','517403',1,0,'2022-03-03 13:09:18','2022-03-03 13:09:18'),(86173,264,'Agraharam','517280',1,0,'2022-03-03 13:09:19','2022-03-03 13:09:19'),(86174,264,'Akanambattu','517124',1,0,'2022-03-03 13:09:19','2022-03-03 13:09:19'),(86175,264,'Alapalle','517415',1,0,'2022-03-03 13:09:19','2022-03-03 13:09:19'),(86176,264,'Amudala','517421',1,0,'2022-03-03 13:09:19','2022-03-03 13:09:19'),(86177,264,'Angallu','517326',1,0,'2022-03-03 13:09:19','2022-03-03 13:09:19'),(86178,264,'Annagaripalle','517390',1,0,'2022-03-03 13:09:19','2022-03-03 13:09:19'),(86179,264,'Appa Rao Street','517326',1,0,'2022-03-03 13:09:19','2022-03-03 13:09:19'),(86180,264,'Appinapalle','517432',1,0,'2022-03-03 13:09:19','2022-03-03 13:09:19'),(86181,264,'Aradigunta','517247',1,0,'2022-03-03 13:09:19','2022-03-03 13:09:19'),(86182,264,'Arikela','517247',1,0,'2022-03-03 13:09:19','2022-03-03 13:09:19'),(86183,264,'Arimakulapalle','517167',1,0,'2022-03-03 13:09:19','2022-03-03 13:09:19'),(86184,264,'Arimanipenta','517401',1,0,'2022-03-03 13:09:19','2022-03-03 13:09:19'),(86185,264,'Arogyavaram','517326',1,0,'2022-03-03 13:09:19','2022-03-03 13:09:19'),(86186,264,'Arugonda','517129',1,0,'2022-03-03 13:09:19','2022-03-03 13:09:19'),(86187,264,'Avalkonda','517421',1,0,'2022-03-03 13:09:19','2022-03-03 13:09:19'),(86188,264,'Badikayalapalle','517370',1,0,'2022-03-03 13:09:19','2022-03-03 13:09:19'),(86189,264,'Baireddipalle','517415',1,0,'2022-03-03 13:09:19','2022-03-03 13:09:19'),(86190,264,'Bairupalle','517424',1,0,'2022-03-03 13:09:19','2022-03-03 13:09:19'),(86191,264,'Baitapalle','517124',1,0,'2022-03-03 13:09:19','2022-03-03 13:09:19'),(86192,264,'Balaganganapalle','517421',1,0,'2022-03-03 13:09:19','2022-03-03 13:09:19'),(86193,264,'Balireddigaripalle','517351',1,0,'2022-03-03 13:09:19','2022-03-03 13:09:19'),(86194,264,'Balla','517425',1,0,'2022-03-03 13:09:19','2022-03-03 13:09:19'),(86195,264,'Bandapalle','517127',1,0,'2022-03-03 13:09:19','2022-03-03 13:09:19'),(86196,264,'Bandarlapalle','517401',1,0,'2022-03-03 13:09:19','2022-03-03 13:09:19'),(86197,264,'Bandrevu','517418',1,0,'2022-03-03 13:09:19','2022-03-03 13:09:19'),(86198,264,'Bangarupalem','517416',1,0,'2022-03-03 13:09:20','2022-03-03 13:09:20'),(86199,264,'Basinikonda','517326',1,0,'2022-03-03 13:09:20','2022-03-03 13:09:20'),(86200,264,'Bayappagaripalle','517326',1,0,'2022-03-03 13:09:20','2022-03-03 13:09:20'),(86201,264,'Beerangi','517370',1,0,'2022-03-03 13:09:20','2022-03-03 13:09:20'),(86202,264,'Beerangi Kothakota','517370',1,0,'2022-03-03 13:09:20','2022-03-03 13:09:20'),(86203,264,'Belupalle','517432',1,0,'2022-03-03 13:09:20','2022-03-03 13:09:20'),(86204,264,'Bhimaganipalle','517247',1,0,'2022-03-03 13:09:20','2022-03-03 13:09:20'),(86205,264,'Bisanatham','517426',1,0,'2022-03-03 13:09:20','2022-03-03 13:09:20'),(86206,264,'Bodaguttapalle','517422',1,0,'2022-03-03 13:09:20','2022-03-03 13:09:20'),(86207,264,'Bommasamudram','517132',1,0,'2022-03-03 13:09:20','2022-03-03 13:09:20'),(86208,264,'Boochipalle','517370',1,0,'2022-03-03 13:09:20','2022-03-03 13:09:20'),(86209,264,'Booragamanda','517123',1,0,'2022-03-03 13:09:20','2022-03-03 13:09:20'),(86210,264,'Boorlapalle','517370',1,0,'2022-03-03 13:09:20','2022-03-03 13:09:20'),(86211,264,'Boyanapalle','517423',1,0,'2022-03-03 13:09:20','2022-03-03 13:09:20'),(86212,264,'Budithireddipalle','517422',1,0,'2022-03-03 13:09:20','2022-03-03 13:09:20'),(86213,264,'Burakayalakota','517351',1,0,'2022-03-03 13:09:20','2022-03-03 13:09:20'),(86214,264,'Chalamangalam','517408',1,0,'2022-03-03 13:09:20','2022-03-03 13:09:20'),(86215,264,'Chandramakulapalle','517326',1,0,'2022-03-03 13:09:20','2022-03-03 13:09:20'),(86216,264,'Chappidipalle','517432',1,0,'2022-03-03 13:09:20','2022-03-03 13:09:20'),(86217,264,'Charala','517257',1,0,'2022-03-03 13:09:20','2022-03-03 13:09:20'),(86218,264,'Chedalla','517247',1,0,'2022-03-03 13:09:20','2022-03-03 13:09:20'),(86219,264,'Cheekalabailu','517326',1,0,'2022-03-03 13:09:20','2022-03-03 13:09:20'),(86220,264,'Cheekunatham','517425',1,0,'2022-03-03 13:09:20','2022-03-03 13:09:20'),(86221,264,'Cheelapalle','517419',1,0,'2022-03-03 13:09:21','2022-03-03 13:09:21'),(86222,264,'Cheldiganipalle','517424',1,0,'2022-03-03 13:09:21','2022-03-03 13:09:21'),(86223,264,'Chembakur','517417',1,0,'2022-03-03 13:09:21','2022-03-03 13:09:21'),(86224,264,'Chennamagudipalle','517002',1,0,'2022-03-03 13:09:21','2022-03-03 13:09:21'),(86225,264,'Cherlopalle','517004',1,0,'2022-03-03 13:09:21','2022-03-03 13:09:21'),(86226,264,'Cherukuvaipalle','517123',1,0,'2022-03-03 13:09:21','2022-03-03 13:09:21'),(86227,264,'Chinnaickenpalle','517127',1,0,'2022-03-03 13:09:21','2022-03-03 13:09:21'),(86228,264,'Chinnakalikiri','517124',1,0,'2022-03-03 13:09:21','2022-03-03 13:09:21'),(86229,264,'Chinnamreddikandriga','517126',1,0,'2022-03-03 13:09:21','2022-03-03 13:09:21'),(86230,264,'Chinnatippasamudram','517319',1,0,'2022-03-03 13:09:21','2022-03-03 13:09:21'),(86231,264,'Chintamakulapalle','517424',1,0,'2022-03-03 13:09:21','2022-03-03 13:09:21'),(86232,264,'Chittapara','517132',1,0,'2022-03-03 13:09:21','2022-03-03 13:09:21'),(86233,264,'Chittoor Bazar','517001',1,0,'2022-03-03 13:09:21','2022-03-03 13:09:21'),(86234,264,'Chittoor H.O','517001',1,0,'2022-03-03 13:09:21','2022-03-03 13:09:21'),(86235,264,'Chittoor North','517004',1,0,'2022-03-03 13:09:21','2022-03-03 13:09:21'),(86236,264,'Chittoor Sugarfactory','517127',1,0,'2022-03-03 13:09:21','2022-03-03 13:09:21'),(86237,264,'Chokkandlapalle','517417',1,0,'2022-03-03 13:09:21','2022-03-03 13:09:21'),(86238,264,'Chowdepalle','517257',1,0,'2022-03-03 13:09:21','2022-03-03 13:09:21'),(86239,264,'Ctr Collectorate','517002',1,0,'2022-03-03 13:09:21','2022-03-03 13:09:21'),(86240,264,'Ctr Court Buildings','517001',1,0,'2022-03-03 13:09:21','2022-03-03 13:09:21'),(86241,264,'Ctr Market','517001',1,0,'2022-03-03 13:09:22','2022-03-03 13:09:22'),(86242,264,'Dadepallerajulur','517257',1,0,'2022-03-03 13:09:22','2022-03-03 13:09:22'),(86243,264,'Danamaiahgarivuru','517424',1,0,'2022-03-03 13:09:22','2022-03-03 13:09:22'),(86244,264,'Dandapalle','517408',1,0,'2022-03-03 13:09:22','2022-03-03 13:09:22'),(86245,264,'Dandikuppam','517425',1,0,'2022-03-03 13:09:22','2022-03-03 13:09:22'),(86246,264,'Dasarlapalle','517415',1,0,'2022-03-03 13:09:22','2022-03-03 13:09:22'),(86247,264,'Dasegowniyur','517425',1,0,'2022-03-03 13:09:22','2022-03-03 13:09:22'),(86248,264,'Deenabandupuram','517599',1,0,'2022-03-03 13:09:22','2022-03-03 13:09:22'),(86249,264,'Devalacheruvu','517351',1,0,'2022-03-03 13:09:22','2022-03-03 13:09:22'),(86250,264,'Devalampet','517167',1,0,'2022-03-03 13:09:22','2022-03-03 13:09:22'),(86251,264,'Devaragudipalle','517167',1,0,'2022-03-03 13:09:22','2022-03-03 13:09:22'),(86252,264,'Diguvamagham','517129',1,0,'2022-03-03 13:09:22','2022-03-03 13:09:22'),(86253,264,'Diguvamasapalle','517419',1,0,'2022-03-03 13:09:22','2022-03-03 13:09:22'),(86254,264,'Diguvatadakara','517131',1,0,'2022-03-03 13:09:22','2022-03-03 13:09:22'),(86255,264,'Doddipalle','517127',1,0,'2022-03-03 13:09:22','2022-03-03 13:09:22'),(86256,264,'Dravidian University','517426',1,0,'2022-03-03 13:09:22','2022-03-03 13:09:22'),(86257,264,'Eachaneri','517129',1,0,'2022-03-03 13:09:22','2022-03-03 13:09:22'),(86258,264,'Edigapalle','517326',1,0,'2022-03-03 13:09:22','2022-03-03 13:09:22'),(86259,264,'Ellamarajupalle','517125',1,0,'2022-03-03 13:09:22','2022-03-03 13:09:22'),(86260,264,'Ellampalle Kothuru','517130',1,0,'2022-03-03 13:09:22','2022-03-03 13:09:22'),(86261,264,'Erlampalle','517130',1,0,'2022-03-03 13:09:23','2022-03-03 13:09:23'),(86262,264,'Erraballe','517352',1,0,'2022-03-03 13:09:23','2022-03-03 13:09:23'),(86263,264,'Erracheruvupalle','517124',1,0,'2022-03-03 13:09:23','2022-03-03 13:09:23'),(86264,264,'Errandlapalle','517416',1,0,'2022-03-03 13:09:23','2022-03-03 13:09:23'),(86265,264,'Gaddamvaripalle','517257',1,0,'2022-03-03 13:09:23','2022-03-03 13:09:23'),(86266,264,'Gajulavaripalle','517319',1,0,'2022-03-03 13:09:23','2022-03-03 13:09:23'),(86267,264,'Gandrajupalle','517432',1,0,'2022-03-03 13:09:23','2022-03-03 13:09:23'),(86268,264,'Gangadhara Nellore','517125',1,0,'2022-03-03 13:09:23','2022-03-03 13:09:23'),(86269,264,'Gangivaripalle','517123',1,0,'2022-03-03 13:09:23','2022-03-03 13:09:23'),(86270,264,'Gattuvaripalle','517257',1,0,'2022-03-03 13:09:23','2022-03-03 13:09:23'),(86271,264,'Gazualapalle','517129',1,0,'2022-03-03 13:09:23','2022-03-03 13:09:23'),(86272,264,'Ghattu','517326',1,0,'2022-03-03 13:09:23','2022-03-03 13:09:23'),(86273,264,'Gollapalle','517129',1,0,'2022-03-03 13:09:23','2022-03-03 13:09:23'),(86274,264,'Gollapalle','517422',1,0,'2022-03-03 13:09:23','2022-03-03 13:09:23'),(86275,264,'Gollapalle','517351',1,0,'2022-03-03 13:09:23','2022-03-03 13:09:23'),(86276,264,'Gonamakulapalle','517424',1,0,'2022-03-03 13:09:23','2022-03-03 13:09:23'),(86277,264,'Gopidinne','517418',1,0,'2022-03-03 13:09:23','2022-03-03 13:09:23'),(86278,264,'Govindareddipalle','517130',1,0,'2022-03-03 13:09:23','2022-03-03 13:09:23'),(86279,264,'Gudipala','517132',1,0,'2022-03-03 13:09:23','2022-03-03 13:09:23'),(86280,264,'Gudipalle','517426',1,0,'2022-03-03 13:09:23','2022-03-03 13:09:23'),(86281,264,'Gudlanayanipalle','517425',1,0,'2022-03-03 13:09:23','2022-03-03 13:09:23'),(86282,264,'Gudupalle','517390',1,0,'2022-03-03 13:09:23','2022-03-03 13:09:23'),(86283,264,'Gudyanampalle','517126',1,0,'2022-03-03 13:09:23','2022-03-03 13:09:23'),(86284,264,'Gundagallu','517432',1,0,'2022-03-03 13:09:23','2022-03-03 13:09:23'),(86285,264,'Gundlapalle','517123',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86286,264,'Gurramkonda Vandlavuru','517429',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86287,264,'Horsely Hills','517326',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86288,264,'Ialavaripalle','517130',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86289,264,'Iral','517130',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86290,264,'Irikipenta','517257',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86291,264,'Iruvaram','517128',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86292,264,'Itikanellore','517414',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86293,264,'Jakkidona','517126',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86294,264,'Jambuvaripalle','517416',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86295,264,'Javvanapalle','517424',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86296,264,'K.G. Satram','517416',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86297,264,'Kadapanatham','517415',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86298,264,'Kadirinathunikota','517390',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86299,264,'Kagathi','517257',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86300,264,'Kajoor','517002',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86301,264,'Kalagatur','517408',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86302,264,'Kalavagunta','517127',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86303,264,'Kalavapalle','517390',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86304,264,'Kallupalle','517408',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86305,264,'Kamachinnayapalle','517126',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86306,264,'Kamathamur','517425',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86307,264,'Kammapalle','517422',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86308,264,'Kammguttapalle','517124',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86309,264,'Kanamanapalle','517426',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86310,264,'Kandriga','517422',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86311,264,'Kandukuru','517391',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86312,264,'Kangundi','517425',1,0,'2022-03-03 13:09:24','2022-03-03 13:09:24'),(86313,264,'Kanipakam','517131',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86314,264,'Kannemadugu','517418',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86315,264,'Karasanapalle','517247',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86316,264,'Karidirivaripalle','517416',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86317,264,'Karlagatta','517423',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86318,264,'Kasiralla','517422',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86319,264,'Katappagaripalle','517416',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86320,264,'Katiperi','517247',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86321,264,'Katnagallu','517391',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86322,264,'Kattakindapalle','517129',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86323,264,'Kattmanchi','517127',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86324,264,'Keelapatla','517408',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86325,264,'Keenatipalle','517422',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86326,264,'Keeramanda','517429',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86327,264,'Kolamasanapalle','517432',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86328,264,'Kondamarri','517257',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86329,264,'Konerukuppam','517423',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86330,264,'Konganapalle','517401',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86331,264,'Kongattam','517424',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86332,264,'Kosuvaripalle','517350',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86333,264,'Kotala','517418',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86334,264,'Kotalam','517422',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86335,264,'Kotevaripalle','517326',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86336,264,'Kotevuru','517326',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86337,264,'Kothakota','517247',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86338,264,'Kothapalle','517132',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86339,264,'Kothapalle','517131',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86340,264,'Kothapalle','517167',1,0,'2022-03-03 13:09:25','2022-03-03 13:09:25'),(86341,264,'Kothapeta Madanapalle','517325',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86342,264,'Kothavaripalle','517319',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86343,264,'Kothavenkatapuram','517421',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86344,264,'Kotrakona','517127',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86345,264,'Krishnadasanapalle','517425',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86346,264,'Ksheerasamudram','517167',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86347,264,'Kudurucheemanapalle','517247',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86348,264,'Kukkalapalle','517128',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86349,264,'Kuppam','517425',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86350,264,'Kurabalakota','517350',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86351,264,'Kurizala','517417',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86352,264,'Kurmai','517408',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86353,264,'L.S.Farm','517408',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86354,264,'Lakkanapalle','517415',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86355,264,'Lakshmipuram','517425',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86356,264,'Lalugardens','517002',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86357,264,'Madanapalle Bazar','517326',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86358,264,'Madanapalle H.O','517325',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86359,264,'Madanapalle Society Colony','517325',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86360,264,'Madanapalle Spinning Mills Gds','517319',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86361,264,'Maddinayanipalle','517351',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86362,264,'Madhavaram','517129',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86363,264,'Madhavaram','517128',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86364,264,'Madireddipalle','517422',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86365,264,'Madumuru','517370',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86366,264,'Magandlapalle','517247',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86367,264,'Mahadevamangalam','517125',1,0,'2022-03-03 13:09:26','2022-03-03 13:09:26'),(86368,264,'Mahasamudram','517128',1,0,'2022-03-03 13:09:27','2022-03-03 13:09:27'),(86369,264,'Malenatham','517247',1,0,'2022-03-03 13:09:27','2022-03-03 13:09:27'),(86370,264,'Malepadu','517326',1,0,'2022-03-03 13:09:27','2022-03-03 13:09:27'),(86371,264,'Mallakunta','517129',1,0,'2022-03-03 13:09:27','2022-03-03 13:09:27'),(86372,264,'Mallan R.S.','517425',1,0,'2022-03-03 13:09:27','2022-03-03 13:09:27'),(86373,264,'Mallela','517370',1,0,'2022-03-03 13:09:27','2022-03-03 13:09:27'),(86374,264,'Mamadugu','517432',1,0,'2022-03-03 13:09:27','2022-03-03 13:09:27'),(86375,264,'Managalapalle','517416',1,0,'2022-03-03 13:09:27','2022-03-03 13:09:27'),(86376,264,'Mandipetkotur','517408',1,0,'2022-03-03 13:09:27','2022-03-03 13:09:27'),(86377,264,'Mangunta','517167',1,0,'2022-03-03 13:09:27','2022-03-03 13:09:27'),(86378,264,'Mapakshi','517002',1,0,'2022-03-03 13:09:27','2022-03-03 13:09:27'),(86379,264,'Marakalakuppam','517132',1,0,'2022-03-03 13:09:27','2022-03-03 13:09:27'),(86380,264,'Maredupalle','517408',1,0,'2022-03-03 13:09:27','2022-03-03 13:09:27'),(86381,264,'Marketyard-palamaner','517408',1,0,'2022-03-03 13:09:27','2022-03-03 13:09:27'),(86382,264,'Marrimakulapalle','517247',1,0,'2022-03-03 13:09:27','2022-03-03 13:09:27'),(86383,264,'Marripalle','517167',1,0,'2022-03-03 13:09:28','2022-03-03 13:09:28'),(86384,264,'Matavalam','517599',1,0,'2022-03-03 13:09:28','2022-03-03 13:09:28'),(86385,264,'Mathyam','517129',1,0,'2022-03-03 13:09:28','2022-03-03 13:09:28'),(86386,264,'Matluvaripalle','517350',1,0,'2022-03-03 13:09:28','2022-03-03 13:09:28'),(86387,264,'Melamdoddi','517247',1,0,'2022-03-03 13:09:28','2022-03-03 13:09:28'),(86388,264,'Melmai','517408',1,0,'2022-03-03 13:09:28','2022-03-03 13:09:28'),(86389,264,'Miniki','517417',1,0,'2022-03-03 13:09:28','2022-03-03 13:09:28'),(86390,264,'Mittachintavaripalle','517247',1,0,'2022-03-03 13:09:28','2022-03-03 13:09:28'),(86391,264,'Mittapalle','517425',1,0,'2022-03-03 13:09:28','2022-03-03 13:09:28'),(86392,264,'Mittapalle','517319',1,0,'2022-03-03 13:09:28','2022-03-03 13:09:28'),(86393,264,'Mittoor','517429',1,0,'2022-03-03 13:09:28','2022-03-03 13:09:28'),(86394,264,'Mogili Venkatagiri','517429',1,0,'2022-03-03 13:09:28','2022-03-03 13:09:28'),(86395,264,'Moram','517432',1,0,'2022-03-03 13:09:28','2022-03-03 13:09:28'),(86396,264,'Mudaramdoddi','517424',1,0,'2022-03-03 13:09:28','2022-03-03 13:09:28'),(86397,264,'Muddanapalle','517401',1,0,'2022-03-03 13:09:28','2022-03-03 13:09:28'),(86398,264,'Mudigolam','517124',1,0,'2022-03-03 13:09:28','2022-03-03 13:09:28'),(86399,264,'Mudivedu','517350',1,0,'2022-03-03 13:09:28','2022-03-03 13:09:28'),(86400,264,'Mukkalathur','517125',1,0,'2022-03-03 13:09:28','2022-03-03 13:09:28'),(86401,264,'Mulakalacheruvu','517390',1,0,'2022-03-03 13:09:28','2022-03-03 13:09:28'),(86402,264,'Mulakalacheruvu R.S.','517390',1,0,'2022-03-03 13:09:28','2022-03-03 13:09:28'),(86403,264,'Murukambattu','517127',1,0,'2022-03-03 13:09:28','2022-03-03 13:09:28'),(86404,264,'Musalikunta','517418',1,0,'2022-03-03 13:09:28','2022-03-03 13:09:28'),(86405,264,'Mushtoor','517280',1,0,'2022-03-03 13:09:28','2022-03-03 13:09:28'),(86406,264,'Muthireval','517127',1,0,'2022-03-03 13:09:28','2022-03-03 13:09:28'),(86407,264,'Muthukur','517419',1,0,'2022-03-03 13:09:28','2022-03-03 13:09:28'),(86408,264,'Muthukur','517247',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86409,264,'Muthukuru','517416',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86410,264,'Nadigadda','517123',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86411,264,'Nadimpalle','517417',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86412,264,'Nadimpalle','517423',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86413,264,'Nalagampalle','517416',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86414,264,'Nallappareddiyuru','517423',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86415,264,'Nampalle','517130',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86416,264,'Nanasahebpet','517247',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86417,264,'Nandanuru','517125',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86418,264,'Nangamangalam','517132',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86419,264,'Naniyala','517401',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86420,264,'Nanjampet','517257',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86421,264,'Naragallu','517403',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86422,264,'Naraharipet','517132',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86423,264,'Narasimhapuram','517419',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86424,264,'Narasimharajapuram','517421',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86425,264,'Narasingarayanipettah','517419',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86426,264,'Narigapalle','517417',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86427,264,'Narigapalle','517002',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86428,264,'Nawabkota','517391',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86429,264,'Neerugattuvaripalle','517326',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86430,264,'Nekalachinnapalle','517257',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86431,264,'Nekkondi','517247',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86432,264,'Nelavoy','517167',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86433,264,'Nellaipalle','517167',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86434,264,'Nellapalle','517414',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86435,264,'Nellimanda','517257',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86436,264,'Nellipatla','517432',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86437,264,'Nernipalle','517424',1,0,'2022-03-03 13:09:29','2022-03-03 13:09:29'),(86438,264,'Nidigunta','517432',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86439,264,'Nimmanapalle','517280',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86440,264,'Noolakunta','517425',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86441,264,'Obireddipalle','517370',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86442,264,'Oddepalle','517126',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86443,264,'Pachalamarri','517418',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86444,264,'Pachanapalle','517419',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86445,264,'Pachigunta','517421',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86446,264,'Paipalle','517131',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86447,264,'Palakur','517124',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86448,264,'Palamakulapalle','517429',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86449,264,'Palamaner','517408',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86450,264,'Palasamudram','517599',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86451,264,'Pallecheruvu','517129',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86452,264,'Pallikuppam','517401',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86453,264,'Pallur','517132',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86454,264,'Pamuganipalle','517424',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86455,264,'Pandillapalle','517257',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86456,264,'Panjani','517408',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86457,264,'Pantrampalle','517004',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86458,264,'Papisettipalle','517132',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86459,264,'Parikidona','517257',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86460,264,'Pathapeta-palamaner','517408',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86461,264,'Pathapolu','517319',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86462,264,'Pathikonda','517432',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86463,264,'Patnam','517131',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86464,264,'Patoor','517124',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86465,264,'Patrapalle','517257',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86466,264,'Pattamvandlapalle','517391',1,0,'2022-03-03 13:09:30','2022-03-03 13:09:30'),(86467,264,'Peddabangarunatham','517425',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86468,264,'Peddachellaragunta','517415',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86469,264,'Peddakalva','517125',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86470,264,'Peddapalem','517390',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86471,264,'Peddatippasamudram','517391',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86472,264,'Peddaupparapalle','517257',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86473,264,'Peddavelagathur','517247',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86474,264,'Peddayellakunta','517257',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86475,264,'Peddur','517401',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86476,264,'Peddur','517423',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86477,264,'Peddur Reservoir','517418',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86478,264,'Penchupadu','517417',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86479,264,'Pengaragunta','517408',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86480,264,'Penumur','517126',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86481,264,'Periyambadi','517128',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86482,264,'Pitchalvandlapalle','517350',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86483,264,'Pogurupalle','517426',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86484,264,'Polakala','517130',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86485,264,'Polavaram','517124',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86486,264,'Ponnutipalem','517326',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86487,264,'Poonepallekandriga','517127',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86488,264,'Prasanth Nagar (Chittoor)','517128',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86489,264,'Pudipatla','517247',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86490,264,'Pulikallu','517126',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86491,264,'Pulikallu','517391',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86492,264,'Pullur','517130',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86493,264,'Pullur','517167',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86494,264,'Punganur Bus Stand','517247',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86495,264,'Punganur','517247',1,0,'2022-03-03 13:09:31','2022-03-03 13:09:31'),(86496,264,'Puthalapattu','517124',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86497,264,'Puthur','517131',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86498,264,'Putramaddi','517129',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86499,264,'Rachavetivaripalle','517326',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86500,264,'Ragimanipenta','517429',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86501,264,'Rajupeta','517401',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86502,264,'Rallabudugur','517423',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86503,264,'Ramakuppam','517401',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86504,264,'Ramanaidupalle','517125',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86505,264,'Ramapuram (Chittoor)','517403',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86506,264,'Ramasamudram','517417',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86507,264,'Rangasamudram','517370',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86508,264,'Rapurivaripalle','517370',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86509,264,'Readspet','517001',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86510,264,'Reddigunta','517002',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86511,264,'Reddivaripalle','517326',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86512,264,'Reddivaripalle','517123',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86513,264,'Renumakulapalle','517418',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86514,264,'Ripunjirajapuram','517167',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86515,264,'Rishivalley','517352',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86516,264,'Royalpet','517414',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86517,264,'S.S.Konda','517421',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86518,264,'Sadakuppam','517129',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86519,264,'Samireddipalle','517126',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86520,264,'Sampathikota','517370',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86521,264,'Sanganapalle','517426',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86522,264,'Santhabandapalle','517401',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86523,264,'Santhipuram','517423',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86524,264,'Sarakallu','517129',1,0,'2022-03-03 13:09:32','2022-03-03 13:09:32'),(86525,264,'Sathambakkam','517127',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86526,264,'Settipalle','517425',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86527,264,'Settivanatham','517167',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86528,264,'Siddarajurangarajukandiga','517599',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86529,264,'Simharajapuram','517599',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86530,264,'Singasamudram','517425',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86531,264,'Sivadi','517432',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86532,264,'Sivaramapuram','517425',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86533,264,'Sodam','517123',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86534,264,'Sogadaballa','517423',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86535,264,'Somala','517257',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86536,264,'Sompalem','517390',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86537,264,'Sompalle','517390',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86538,264,'Sonnarasanapalle','517426',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86539,264,'Srikaverirajapuram','517599',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86540,264,'Srirangarajapuram','517167',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86541,264,'Sugalimitta','517247',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86542,264,'Suraiahgaripalle','517257',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86543,264,'T. Savatapalle','517004',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86544,264,'T.Salimamidi','517370',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86545,264,'T.Sodam','517391',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86546,264,'T.Sowdasamudram','517390',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86547,264,'Tavalam','517280',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86548,264,'Tekumanda','517429',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86549,264,'Tenebanda','517004',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86550,264,'Tenepalle','517124',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86551,264,'Thalambedu','517419',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86552,264,'Thalupulapalle','517124',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86553,264,'Thamballapalle','517418',1,0,'2022-03-03 13:09:33','2022-03-03 13:09:33'),(86554,264,'Thambuganipalle','517416',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86555,264,'Thatiguntapalem','517123',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86556,264,'Thavanampalle','517131',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86557,264,'Theertham','517415',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86558,264,'Thettu','517352',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86559,264,'Thotakanuma','517415',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86560,264,'Thugundram','517421',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86561,264,'Thumabakuppam','517416',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86562,264,'Thumba','517416',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86563,264,'Thummanamgutta','517351',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86564,264,'Thumminda','517132',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86565,264,'Thurlapalle','517414',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86566,264,'Thurupupalle','517126',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86567,264,'Todatara','517129',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86568,264,'Ugranapalle','517126',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86569,264,'Uttarabrahmanapalle','517131',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86570,264,'Vajjireddipalle','517124',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86571,264,'Valasapalle','517326',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86572,264,'Vanadurgapurambo','517599',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86573,264,'Vanamaladinne','517247',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86574,264,'Varathur','517421',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86575,264,'Vasanadu','517425',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86576,264,'Vavilthota','517127',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86577,264,'Veerakanellore','517167',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86578,264,'Veeranamala','517401',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86579,264,'Velkur','517125',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86580,264,'Vemareddigaripalle','517418',1,0,'2022-03-03 13:09:34','2022-03-03 13:09:34'),(86581,264,'Vempalle','517326',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86582,264,'Vendugampalle','517425',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86583,264,'Vengalrajukuppam','517599',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86584,264,'Vengampalle','517129',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86585,264,'Vengamvaripale','517280',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86586,264,'Venkatagirikota','517424',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86587,264,'Venkatapuram','517125',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86588,264,'Vepanapalle','517422',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86589,264,'Vepanjeri','517125',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86590,264,'Vepurikota','517351',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86591,264,'Vizalapuram','517425',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86592,264,'Yadamari','517422',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86593,264,'Yeddulavaripalle','517418',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86594,264,'Yellampalle Santhagate','517130',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86595,264,'Yerrepalle','517130',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86596,264,'Yetavakili','517247',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86597,264,'Yetteri','517125',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86598,264,'A.P.H.B.Colony','517507',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86599,264,'Adaram','517643',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86600,264,'Adavaram','517643',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86601,264,'Adavikothuru','517592',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86602,264,'Adivikodiyambedu','517589',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86603,264,'Agaram','517591',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86604,264,'Agaram','517587',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86605,264,'Agraharam','517214',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86606,264,'Agraharam','517640',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86607,264,'Akkarampalli','517507',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86608,264,'Akkurthi','517536',1,0,'2022-03-03 13:09:35','2022-03-03 13:09:35'),(86609,264,'Alapakam','517591',1,0,'2022-03-03 13:09:36','2022-03-03 13:09:36'),(86610,264,'Alathur','517645',1,0,'2022-03-03 13:09:36','2022-03-03 13:09:36'),(86611,264,'Alimelumangapuram','517571',1,0,'2022-03-03 13:09:36','2022-03-03 13:09:36'),(86612,264,'Allamadugu','517582',1,0,'2022-03-03 13:09:36','2022-03-03 13:09:36'),(86613,264,'Ambakam','517588',1,0,'2022-03-03 13:09:36','2022-03-03 13:09:36'),(86614,264,'Amilepalle','517291',1,0,'2022-03-03 13:09:36','2022-03-03 13:09:36'),(86615,264,'Ammapalem','517641',1,0,'2022-03-03 13:09:36','2022-03-03 13:09:36'),(86616,264,'Anjimedu','517619',1,0,'2022-03-03 13:09:36','2022-03-03 13:09:36'),(86617,264,'Anjuru','517643',1,0,'2022-03-03 13:09:36','2022-03-03 13:09:36'),(86618,264,'Annur','517582',1,0,'2022-03-03 13:09:36','2022-03-03 13:09:36'),(86619,264,'Applayagunta','517551',1,0,'2022-03-03 13:09:36','2022-03-03 13:09:36'),(86620,264,'Arai','517587',1,0,'2022-03-03 13:09:36','2022-03-03 13:09:36'),(86621,264,'Aramadakalavandlapalle','517236',1,0,'2022-03-03 13:09:36','2022-03-03 13:09:36'),(86622,264,'Aranyam Kandriga','517581',1,0,'2022-03-03 13:09:36','2022-03-03 13:09:36'),(86623,264,'Aravakothur','517640',1,0,'2022-03-03 13:09:36','2022-03-03 13:09:36'),(86624,264,'Ardhamalaputheri','517642',1,0,'2022-03-03 13:09:36','2022-03-03 13:09:36'),(86625,264,'Aroor','517591',1,0,'2022-03-03 13:09:36','2022-03-03 13:09:36'),(86626,264,'Athur','517520',1,0,'2022-03-03 13:09:36','2022-03-03 13:09:36'),(86627,264,'Avilalal','517507',1,0,'2022-03-03 13:09:36','2022-03-03 13:09:36'),(86628,264,'Ayithepalle','517102',1,0,'2022-03-03 13:09:36','2022-03-03 13:09:36'),(86629,264,'Ayyavaripalle','517277',1,0,'2022-03-03 13:09:36','2022-03-03 13:09:36'),(86630,264,'Balajinagar','517504',1,0,'2022-03-03 13:09:36','2022-03-03 13:09:36'),(86631,264,'Balijapalli','517561',1,0,'2022-03-03 13:09:36','2022-03-03 13:09:36'),(86632,264,'Bandakindapalle','517214',1,0,'2022-03-03 13:09:36','2022-03-03 13:09:36'),(86633,264,'Bandarupalle','517641',1,0,'2022-03-03 13:09:36','2022-03-03 13:09:36'),(86634,264,'Batagundrevaripalle','517213',1,0,'2022-03-03 13:09:36','2022-03-03 13:09:36'),(86635,264,'Beerakuppam','517589',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86636,264,'Bhakarapet','517194',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86637,264,'Bhavani Nagar','517501',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86638,264,'Bhavanisankarapuram','517642',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86639,264,'Bhimavaram','517102',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86640,264,'Bodevandlapalle','517194',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86641,264,'Bodumallulavaripalle','517214',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86642,264,'Bokkasampalem','517641',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86643,264,'Bopparajupalle','517102',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86644,264,'Brahmanapalle','517643',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86645,264,'Brahmanapalle','517569',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86646,264,'Brahmanapattu','517551',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86647,264,'Buchinaidu Kandriga','517645',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86648,264,'Buchinaidupalle','517102',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86649,264,'Budithavedu','517237',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86650,264,'Bugga Agraharam','517590',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86651,264,'Bytikodiyambedu','517589',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86652,264,'C.Gollapalle','517505',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86653,264,'Challapalem','517641',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86654,264,'Challavaripalle','517192',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86655,264,'Chandragiri Fort','517101',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86656,264,'Chandragiri H.O','517101',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86657,264,'Chavarambakam','517591',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86658,264,'Chellur','517526',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86659,264,'Cherlopalle','517583',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86660,264,'Cherlopalle','517305',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86661,264,'Cherukuvaripalle','517113',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86662,264,'Cheruvumundarapalle','517193',1,0,'2022-03-03 13:09:37','2022-03-03 13:09:37'),(86663,264,'Chiguruvada','517507',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86664,264,'Chilamathur','517541',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86665,264,'Chindepalle','517619',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86666,264,'Chinnadoravarikandriga','517582',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86667,264,'Chinnagottigallu','517193',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86668,264,'Chinnarajukuppam','517583',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86669,264,'Chintalavaripalem','517234',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86670,264,'Chintaparthi','517277',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86671,264,'Chinthagunta','517194',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86672,264,'Chittathur','517643',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86673,264,'Chitticherla','517194',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86674,264,'Chittipiralla','517112',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86675,264,'Chiyyavaram','517536',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86676,264,'Chodavaram','517536',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86677,264,'Chuttuguntaramapuram','517561',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86678,264,'Cotton Mills','517520',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86679,264,'D.N.Choultry','517501',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86680,264,'Damalacheruvu','517152',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86681,264,'Damarapakam','517591',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86682,264,'Daminadu','517503',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86683,264,'Damodaramaharajapuram','517582',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86684,264,'Dasukuppam','517588',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86685,264,'Desireddigaripalle','517172',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86686,264,'Devalapalle','517236',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86687,264,'Diguvapalem','517291',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86688,264,'Doddipalle','517214',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86689,264,'Dornakambala','517102',1,0,'2022-03-03 13:09:38','2022-03-03 13:09:38'),(86690,264,'Dudhevaripalle','517194',1,0,'2022-03-03 13:09:39','2022-03-03 13:09:39'),(86691,264,'Durga Samudram','517561',1,0,'2022-03-03 13:09:39','2022-03-03 13:09:39'),(86692,264,'Durgaperi','517619',1,0,'2022-03-03 13:09:39','2022-03-03 13:09:39'),(86693,264,'Ekambarakuppam','517592',1,0,'2022-03-03 13:09:39','2022-03-03 13:09:39'),(86694,264,'Elakatur','517591',1,0,'2022-03-03 13:09:39','2022-03-03 13:09:39'),(86695,264,'Ellamanda','517214',1,0,'2022-03-03 13:09:39','2022-03-03 13:09:39'),(86696,264,'Empedu','517620',1,0,'2022-03-03 13:09:39','2022-03-03 13:09:39'),(86697,264,'Errakotapalle','517235',1,0,'2022-03-03 13:09:39','2022-03-03 13:09:39'),(86698,264,'Erramaraju Palle','517569',1,0,'2022-03-03 13:09:39','2022-03-03 13:09:39'),(86699,264,'G.S.T.Centre','517644',1,0,'2022-03-03 13:09:39','2022-03-03 13:09:39'),(86700,264,'Gadanki','517112',1,0,'2022-03-03 13:09:39','2022-03-03 13:09:39'),(86701,264,'Gadi','517237',1,0,'2022-03-03 13:09:39','2022-03-03 13:09:39'),(86702,264,'Gajulamandyam','517520',1,0,'2022-03-03 13:09:39','2022-03-03 13:09:39'),(86703,264,'Gajulapellur','517645',1,0,'2022-03-03 13:09:39','2022-03-03 13:09:39'),(86704,264,'Galivaripalle','517236',1,0,'2022-03-03 13:09:39','2022-03-03 13:09:39'),(86705,264,'Gandaboyanapalle','517277',1,0,'2022-03-03 13:09:39','2022-03-03 13:09:39'),(86706,264,'Gangireddipalli','517561',1,0,'2022-03-03 13:09:39','2022-03-03 13:09:39'),(86707,264,'Ganugachinta','517214',1,0,'2022-03-03 13:09:39','2022-03-03 13:09:39'),(86708,264,'Garnimitta','517213',1,0,'2022-03-03 13:09:39','2022-03-03 13:09:39'),(86709,264,'Gollapalle','517620',1,0,'2022-03-03 13:09:39','2022-03-03 13:09:39'),(86710,264,'Gorantlapalle','517213',1,0,'2022-03-03 13:09:39','2022-03-03 13:09:39'),(86711,264,'Gottipudi','517536',1,0,'2022-03-03 13:09:39','2022-03-03 13:09:39'),(86712,264,'Govardhanagiri','517589',1,0,'2022-03-03 13:09:39','2022-03-03 13:09:39'),(86713,264,'Govindapalem','517583',1,0,'2022-03-03 13:09:39','2022-03-03 13:09:39'),(86714,264,'Gudarevupalle','517214',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86715,264,'Gudimallam','517526',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86716,264,'Gundlaguttapalle','517152',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86717,264,'Gundlapalle','517152',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86718,264,'Gundluru','517235',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86719,264,'Gundrajukuppam','517592',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86720,264,'Gurramkonda','517297',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86721,264,'Guttapalem','517234',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86722,264,'Gyarampalle-kothapalle','517213',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86723,264,'Inagalur','517620',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86724,264,'Irugulam','517588',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86725,264,'Iruguvoi','517590',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86726,264,'Jagannathapuram','517586',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86727,264,'Jagannathapuram','517501',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86728,264,'Jambada','517586',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86729,264,'Jandla','517214',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86730,264,'Jangampalle','517213',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86731,264,'Jangavandlapalle','517192',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86732,264,'Jarravaripalle','517299',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86733,264,'K.M.Agraharam','517571',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86734,264,'Kaamireddivaripalle','517234',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86735,264,'Kadirirayacheruvu','517297',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86736,264,'Kadur','517541',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86737,264,'Kakavedu','517590',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86738,264,'Kalakada Doddipalle','517236',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86739,264,'Kalakada','517236',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86740,264,'Kalathur','517643',1,0,'2022-03-03 13:09:40','2022-03-03 13:09:40'),(86741,264,'Kalavagunta','517620',1,0,'2022-03-03 13:09:41','2022-03-03 13:09:41'),(86742,264,'Kalicherla','517297',1,0,'2022-03-03 13:09:41','2022-03-03 13:09:41'),(86743,264,'Kalikiri Kothapalle','517234',1,0,'2022-03-03 13:09:41','2022-03-03 13:09:41'),(86744,264,'Kalikiri','517234',1,0,'2022-03-03 13:09:41','2022-03-03 13:09:41'),(86745,264,'Kaliyambakam','517586',1,0,'2022-03-03 13:09:41','2022-03-03 13:09:41'),(86746,264,'Kallur (Chittoor)','517113',1,0,'2022-03-03 13:09:41','2022-03-03 13:09:41'),(86747,264,'Kalroadpalle','517112',1,0,'2022-03-03 13:09:41','2022-03-03 13:09:41'),(86748,264,'Kalyani Dam','517102',1,0,'2022-03-03 13:09:41','2022-03-03 13:09:41'),(86749,264,'Kamavaram Kothapet','517172',1,0,'2022-03-03 13:09:41','2022-03-03 13:09:41'),(86750,264,'Kambhamvaripalle','517213',1,0,'2022-03-03 13:09:41','2022-03-03 13:09:41'),(86751,264,'Kammapalle','517561',1,0,'2022-03-03 13:09:41','2022-03-03 13:09:41'),(86752,264,'Kanchanapalle','517643',1,0,'2022-03-03 13:09:41','2022-03-03 13:09:41'),(86753,264,'Kancharapalem','517541',1,0,'2022-03-03 13:09:41','2022-03-03 13:09:41'),(86754,264,'Kandadu','517619',1,0,'2022-03-03 13:09:41','2022-03-03 13:09:41'),(86755,264,'Kanduru','517234',1,0,'2022-03-03 13:09:41','2022-03-03 13:09:41'),(86756,264,'Kannavaram','517589',1,0,'2022-03-03 13:09:41','2022-03-03 13:09:41'),(86757,264,'Kannikapuram','517561',1,0,'2022-03-03 13:09:41','2022-03-03 13:09:41'),(86758,264,'Kanumalopalle','517297',1,0,'2022-03-03 13:09:41','2022-03-03 13:09:41'),(86759,264,'Kapilateertham Road','517501',1,0,'2022-03-03 13:09:41','2022-03-03 13:09:41'),(86760,264,'Kapugunneri','517641',1,0,'2022-03-03 13:09:41','2022-03-03 13:09:41'),(86761,264,'Karakambadi','517520',1,0,'2022-03-03 13:09:41','2022-03-03 13:09:41'),(86762,264,'Karakollu','517645',1,0,'2022-03-03 13:09:41','2022-03-03 13:09:41'),(86763,264,'Karani','517589',1,0,'2022-03-03 13:09:41','2022-03-03 13:09:41'),(86764,264,'Karipakam','517541',1,0,'2022-03-03 13:09:41','2022-03-03 13:09:41'),(86765,264,'Karvetinagar','517582',1,0,'2022-03-03 13:09:41','2022-03-03 13:09:41'),(86766,264,'Kasaram','517536',1,0,'2022-03-03 13:09:41','2022-03-03 13:09:41'),(86767,264,'Kasipentla','517112',1,0,'2022-03-03 13:09:42','2022-03-03 13:09:42'),(86768,264,'Kathirapalle','517582',1,0,'2022-03-03 13:09:42','2022-03-03 13:09:42'),(86769,264,'Kattakindavenkatapuram','517561',1,0,'2022-03-03 13:09:42','2022-03-03 13:09:42'),(86770,264,'Katur','517645',1,0,'2022-03-03 13:09:42','2022-03-03 13:09:42'),(86771,264,'Kavetigaripalle','517172',1,0,'2022-03-03 13:09:42','2022-03-03 13:09:42'),(86772,264,'Kavetipuram','517590',1,0,'2022-03-03 13:09:42','2022-03-03 13:09:42'),(86773,264,'Kemparapalem','517581',1,0,'2022-03-03 13:09:42','2022-03-03 13:09:42'),(86774,264,'Kollagunta','517582',1,0,'2022-03-03 13:09:42','2022-03-03 13:09:42'),(86775,264,'Komaragunta','517569',1,0,'2022-03-03 13:09:42','2022-03-03 13:09:42'),(86776,264,'Kona','517236',1,0,'2022-03-03 13:09:42','2022-03-03 13:09:42'),(86777,264,'Konathaneri','517642',1,0,'2022-03-03 13:09:42','2022-03-03 13:09:42'),(86778,264,'Kondreddigaripalle','517214',1,0,'2022-03-03 13:09:42','2022-03-03 13:09:42'),(86779,264,'Koppedu','517587',1,0,'2022-03-03 13:09:42','2022-03-03 13:09:42'),(86780,264,'Korlagunta','517501',1,0,'2022-03-03 13:09:42','2022-03-03 13:09:42'),(86781,264,'Kosalanagaram','517586',1,0,'2022-03-03 13:09:42','2022-03-03 13:09:42'),(86782,264,'Kotabailu','517194',1,0,'2022-03-03 13:09:42','2022-03-03 13:09:42'),(86783,264,'Kotagudibanda','517236',1,0,'2022-03-03 13:09:42','2022-03-03 13:09:42'),(86784,264,'Kotakadapalle','517194',1,0,'2022-03-03 13:09:42','2022-03-03 13:09:42'),(86785,264,'Kotakonda','517297',1,0,'2022-03-03 13:09:42','2022-03-03 13:09:42'),(86786,264,'Kotala','517102',1,0,'2022-03-03 13:09:42','2022-03-03 13:09:42'),(86787,264,'Kotamangapuram','517587',1,0,'2022-03-03 13:09:42','2022-03-03 13:09:42'),(86788,264,'Kothamarikuppam','517588',1,0,'2022-03-03 13:09:42','2022-03-03 13:09:42'),(86789,264,'Kothapalem','517520',1,0,'2022-03-03 13:09:42','2022-03-03 13:09:42'),(86790,264,'Kothapet (Srikalahasti)','517644',1,0,'2022-03-03 13:09:42','2022-03-03 13:09:42'),(86791,264,'Kothur Venkatapuram','517590',1,0,'2022-03-03 13:09:42','2022-03-03 13:09:42'),(86792,264,'Kovanur','517643',1,0,'2022-03-03 13:09:43','2022-03-03 13:09:43'),(86793,264,'Krishnapuram','517589',1,0,'2022-03-03 13:09:43','2022-03-03 13:09:43'),(86794,264,'Krishnapuram','517619',1,0,'2022-03-03 13:09:43','2022-03-03 13:09:43'),(86795,264,'Krishnapuram','517152',1,0,'2022-03-03 13:09:43','2022-03-03 13:09:43'),(86796,264,'Kshurikapuram','517586',1,0,'2022-03-03 13:09:43','2022-03-03 13:09:43'),(86797,264,'Kukkambakam','517645',1,0,'2022-03-03 13:09:43','2022-03-03 13:09:43'),(86798,264,'Kukkarajupalle','517297',1,0,'2022-03-03 13:09:43','2022-03-03 13:09:43'),(86799,264,'Kumara Venkata Bhupala Puram','517643',1,0,'2022-03-03 13:09:43','2022-03-03 13:09:43'),(86800,264,'Kumarabommarajapuram','517584',1,0,'2022-03-03 13:09:43','2022-03-03 13:09:43'),(86801,264,'Kummarapalle','517520',1,0,'2022-03-03 13:09:43','2022-03-03 13:09:43'),(86802,264,'Kuntrapakam','517561',1,0,'2022-03-03 13:09:43','2022-03-03 13:09:43'),(86803,264,'Kuppam Badur','517561',1,0,'2022-03-03 13:09:43','2022-03-03 13:09:43'),(86804,264,'Kuppamvandlapalle','517213',1,0,'2022-03-03 13:09:43','2022-03-03 13:09:43'),(86805,264,'Kuraparthi','517299',1,0,'2022-03-03 13:09:43','2022-03-03 13:09:43'),(86806,264,'Lingamanaidupalle','517541',1,0,'2022-03-03 13:09:43','2022-03-03 13:09:43'),(86807,264,'M.A.Rajulakandriga','517643',1,0,'2022-03-03 13:09:43','2022-03-03 13:09:43'),(86808,264,'Madanambedu','517588',1,0,'2022-03-03 13:09:43','2022-03-03 13:09:43'),(86809,264,'Maddiledu','517641',1,0,'2022-03-03 13:09:43','2022-03-03 13:09:43'),(86810,264,'Maddinayanipalle','517112',1,0,'2022-03-03 13:09:43','2022-03-03 13:09:43'),(86811,264,'Maddipatlavandlapalle','517213',1,0,'2022-03-03 13:09:43','2022-03-03 13:09:43'),(86812,264,'Maddulacheruvupalem','517213',1,0,'2022-03-03 13:09:44','2022-03-03 13:09:44'),(86813,264,'Madhavamala','517520',1,0,'2022-03-03 13:09:44','2022-03-03 13:09:44'),(86814,264,'Madibaka','517526',1,0,'2022-03-03 13:09:44','2022-03-03 13:09:44'),(86815,264,'Mahal (Chittoor)','517235',1,0,'2022-03-03 13:09:44','2022-03-03 13:09:44'),(86816,264,'Mallarapuvandlapalle','517213',1,0,'2022-03-03 13:09:44','2022-03-03 13:09:44'),(86817,264,'Mamanduru','517520',1,0,'2022-03-03 13:09:44','2022-03-03 13:09:44'),(86818,264,'Mambedu','517569',1,0,'2022-03-03 13:09:44','2022-03-03 13:09:44'),(86819,264,'Manchuru','517277',1,0,'2022-03-03 13:09:44','2022-03-03 13:09:44'),(86820,264,'Mangadu Kothur','517590',1,0,'2022-03-03 13:09:44','2022-03-03 13:09:44'),(86821,264,'Mangalam','517507',1,0,'2022-03-03 13:09:44','2022-03-03 13:09:44'),(86822,264,'Mangalampet','517172',1,0,'2022-03-03 13:09:44','2022-03-03 13:09:44'),(86823,264,'Mangapuram','517102',1,0,'2022-03-03 13:09:44','2022-03-03 13:09:44'),(86824,264,'Mannavaram','517620',1,0,'2022-03-03 13:09:44','2022-03-03 13:09:44'),(86825,264,'Marella','517213',1,0,'2022-03-03 13:09:44','2022-03-03 13:09:44'),(86826,264,'Marrikuntapalle','517237',1,0,'2022-03-03 13:09:44','2022-03-03 13:09:44'),(86827,264,'Marrimakulapalle','517291',1,0,'2022-03-03 13:09:44','2022-03-03 13:09:44'),(86828,264,'Marripadu','517299',1,0,'2022-03-03 13:09:44','2022-03-03 13:09:44'),(86829,264,'Matampalle Agraharam','517213',1,0,'2022-03-03 13:09:44','2022-03-03 13:09:44'),(86830,264,'Medikurthi','517237',1,0,'2022-03-03 13:09:44','2022-03-03 13:09:44'),(86831,264,'Mellacheruvu','517214',1,0,'2022-03-03 13:09:44','2022-03-03 13:09:44'),(86832,264,'Merlapaka','517619',1,0,'2022-03-03 13:09:45','2022-03-03 13:09:45'),(86833,264,'Mittakandriga','517561',1,0,'2022-03-03 13:09:45','2022-03-03 13:09:45'),(86834,264,'Modugulapalem','517619',1,0,'2022-03-03 13:09:45','2022-03-03 13:09:45'),(86835,264,'Mogarala','517152',1,0,'2022-03-03 13:09:45','2022-03-03 13:09:45'),(86836,264,'Moorevandlapalle','517234',1,0,'2022-03-03 13:09:45','2022-03-03 13:09:45'),(86837,264,'Moorevandlapalle','517213',1,0,'2022-03-03 13:09:45','2022-03-03 13:09:45'),(86838,264,'Motumallela','517192',1,0,'2022-03-03 13:09:45','2022-03-03 13:09:45'),(86839,264,'Muchivolu','517536',1,0,'2022-03-03 13:09:45','2022-03-03 13:09:45'),(86840,264,'Mudipalle','517592',1,0,'2022-03-03 13:09:45','2022-03-03 13:09:45'),(86841,264,'Mudiyamvaripalle','517235',1,0,'2022-03-03 13:09:45','2022-03-03 13:09:45'),(86842,264,'Mudupulavemula','517214',1,0,'2022-03-03 13:09:45','2022-03-03 13:09:45'),(86843,264,'Mugalamarrikothapalle','517277',1,0,'2022-03-03 13:09:45','2022-03-03 13:09:45'),(86844,264,'Munagalapalem','517526',1,0,'2022-03-03 13:09:45','2022-03-03 13:09:45'),(86845,264,'Mungilipattu','517102',1,0,'2022-03-03 13:09:45','2022-03-03 13:09:45'),(86846,264,'Muthukuvaripalle','517113',1,0,'2022-03-03 13:09:45','2022-03-03 13:09:45'),(86847,264,'Nadavalur','517561',1,0,'2022-03-03 13:09:45','2022-03-03 13:09:45'),(86848,264,'Nadimcherla','517305',1,0,'2022-03-03 13:09:45','2022-03-03 13:09:45'),(86849,264,'Nadimkandriga','517305',1,0,'2022-03-03 13:09:45','2022-03-03 13:09:45'),(86850,264,'Nagalapuram (Chittoor)','517589',1,0,'2022-03-03 13:09:45','2022-03-03 13:09:45'),(86851,264,'Nagari','517590',1,0,'2022-03-03 13:09:45','2022-03-03 13:09:45'),(86852,264,'Nagarimadugu','517277',1,0,'2022-03-03 13:09:45','2022-03-03 13:09:45'),(86853,264,'Nagaripalle','517234',1,0,'2022-03-03 13:09:46','2022-03-03 13:09:46'),(86854,264,'Nallavenganapalli','517569',1,0,'2022-03-03 13:09:46','2022-03-03 13:09:46'),(86855,264,'Nandimangalam','517583',1,0,'2022-03-03 13:09:46','2022-03-03 13:09:46'),(86856,264,'Narasingapuram (Chittoor)','517102',1,0,'2022-03-03 13:09:46','2022-03-03 13:09:46'),(86857,264,'Narayanapuram','517571',1,0,'2022-03-03 13:09:46','2022-03-03 13:09:46'),(86858,264,'Narayanavaram','517581',1,0,'2022-03-03 13:09:46','2022-03-03 13:09:46'),(86859,264,'Nawabpet','517235',1,0,'2022-03-03 13:09:46','2022-03-03 13:09:46'),(86860,264,'Nayanicheruvupalle','517237',1,0,'2022-03-03 13:09:46','2022-03-03 13:09:46'),(86861,264,'Nehru Bazar (Piler)','517214',1,0,'2022-03-03 13:09:46','2022-03-03 13:09:46'),(86862,264,'Nendragunta','517112',1,0,'2022-03-03 13:09:46','2022-03-03 13:09:46'),(86863,264,'Nennur','517561',1,0,'2022-03-03 13:09:46','2022-03-03 13:09:46'),(86864,264,'Nerabailu','517194',1,0,'2022-03-03 13:09:46','2022-03-03 13:09:46'),(86865,264,'Nesanur','517583',1,0,'2022-03-03 13:09:46','2022-03-03 13:09:46'),(86866,264,'Nethakuppam','517561',1,0,'2022-03-03 13:09:46','2022-03-03 13:09:46'),(86867,264,'Nindra','517591',1,0,'2022-03-03 13:09:46','2022-03-03 13:09:46'),(86868,264,'Nochilirajukandriga','517582',1,0,'2022-03-03 13:09:46','2022-03-03 13:09:46'),(86869,264,'Nuthanakalava','517213',1,0,'2022-03-03 13:09:46','2022-03-03 13:09:46'),(86870,264,'Obulampalle','517299',1,0,'2022-03-03 13:09:46','2022-03-03 13:09:46'),(86871,264,'Obularajukandriga','517551',1,0,'2022-03-03 13:09:46','2022-03-03 13:09:46'),(86872,264,'Obulayapalle','517536',1,0,'2022-03-03 13:09:46','2022-03-03 13:09:46'),(86873,264,'Ollur','517643',1,0,'2022-03-03 13:09:46','2022-03-03 13:09:46'),(86874,264,'Pachikapallam','517569',1,0,'2022-03-03 13:09:46','2022-03-03 13:09:46'),(86875,264,'Padi','517503',1,0,'2022-03-03 13:09:47','2022-03-03 13:09:47'),(86876,264,'Padiredu','517551',1,0,'2022-03-03 13:09:47','2022-03-03 13:09:47'),(86877,264,'Padiri','517591',1,0,'2022-03-03 13:09:47','2022-03-03 13:09:47'),(86878,264,'Pakala Bazar','517112',1,0,'2022-03-03 13:09:47','2022-03-03 13:09:47'),(86879,264,'Pakala Kothakota','517112',1,0,'2022-03-03 13:09:47','2022-03-03 13:09:47'),(86880,264,'Pakala Railway Colony','517505',1,0,'2022-03-03 13:09:47','2022-03-03 13:09:47'),(86881,264,'Pakala','517112',1,0,'2022-03-03 13:09:47','2022-03-03 13:09:47'),(86882,264,'Palamanda','517234',1,0,'2022-03-03 13:09:47','2022-03-03 13:09:47'),(86883,264,'Palamangalam','517581',1,0,'2022-03-03 13:09:47','2022-03-03 13:09:47'),(86884,264,'Palamgadda','517214',1,0,'2022-03-03 13:09:47','2022-03-03 13:09:47'),(86885,264,'Palem','517234',1,0,'2022-03-03 13:09:47','2022-03-03 13:09:47'),(86886,264,'Pallam','517620',1,0,'2022-03-03 13:09:47','2022-03-03 13:09:47'),(86887,264,'Pallamala','517645',1,0,'2022-03-03 13:09:47','2022-03-03 13:09:47'),(86888,264,'Pallavolu','517237',1,0,'2022-03-03 13:09:47','2022-03-03 13:09:47'),(86889,264,'Panagal','517640',1,0,'2022-03-03 13:09:47','2022-03-03 13:09:47'),(86890,264,'Panakam','517503',1,0,'2022-03-03 13:09:47','2022-03-03 13:09:47'),(86891,264,'Panapakam','517112',1,0,'2022-03-03 13:09:47','2022-03-03 13:09:47'),(86892,264,'Pandur','517541',1,0,'2022-03-03 13:09:47','2022-03-03 13:09:47'),(86893,264,'Panguru','517619',1,0,'2022-03-03 13:09:47','2022-03-03 13:09:47'),(86894,264,'Pannur (Chittoor)','517586',1,0,'2022-03-03 13:09:47','2022-03-03 13:09:47'),(86895,264,'Papanaidupet','517526',1,0,'2022-03-03 13:09:47','2022-03-03 13:09:47'),(86896,264,'Papepalle','517297',1,0,'2022-03-03 13:09:47','2022-03-03 13:09:47'),(86897,264,'Parameswaramangalam','517584',1,0,'2022-03-03 13:09:47','2022-03-03 13:09:47'),(86898,264,'Pasalavandlapalle','517305',1,0,'2022-03-03 13:09:47','2022-03-03 13:09:47'),(86899,264,'Pathagunta','517569',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86900,264,'Pathiputtur','517551',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86901,264,'Peddagorpadu','517112',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86902,264,'Peddagottigallu','517192',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86903,264,'Peddakannali','517642',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86904,264,'Peddakanuparthi','517642',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86905,264,'Peddamallela','517192',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86906,264,'Peddamandyam','517297',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86907,264,'Peddapalavedu','517645',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86908,264,'Peddaramapuram','517112',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86909,264,'Perumallapalle','517569',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86910,264,'Perumallapalle','517505',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86911,264,'Perur','517505',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86912,264,'Piler','517214',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86913,264,'Pillamadu','517536',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86914,264,'Pillapalem','517520',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86915,264,'Pissatur','517587',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86916,264,'Poli','517620',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86917,264,'Pothukanuma','517112',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86918,264,'Poyya','517642',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86919,264,'Pravalvanneswarapuram','517588',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86920,264,'Pudi','517642',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86921,264,'Pudi R.S.','517551',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86922,264,'Pudichennakesavapuram','517643',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86923,264,'Pudipatla','517505',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86924,264,'Pudupet','517590',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86925,264,'Pulicherla','517172',1,0,'2022-03-03 13:09:48','2022-03-03 13:09:48'),(86926,264,'Pulikundram','517589',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86927,264,'Pullareddikandriga','517641',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86928,264,'Pullleticheruvupalle','517277',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86929,264,'Puttur','517583',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86930,264,'Puttur South','517583',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86931,264,'R.K.V.Bahadurpet','517582',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86932,264,'R.S.Gardens','517507',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86933,264,'R.T.C.Bus Stand','517501',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86934,264,'Rachapalem','517583',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86935,264,'Ragigunta','517643',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86936,264,'Rajagopalapuram','517588',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86937,264,'Rajanagaram','517589',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86938,264,'Ramakrishnapuram','517571',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86939,264,'Ramapuram','517641',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86940,264,'Ramapuram','517291',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86941,264,'Rangampet','517102',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86942,264,'Ranganathapuram','517237',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86943,264,'Rangannagarigadda','517193',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86944,264,'Rasapalem','517588',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86945,264,'Ravillavarikandriga','517526',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86946,264,'Reddivaripalle','517113',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86947,264,'Reddivaripalle','517291',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86948,264,'Regallu','517234',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86949,264,'Renigunta','517520',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86950,264,'Rompicherla (Chittoor)','517192',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86951,264,'S.V.Agricultural College','517502',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86952,264,'S.V.Arts College','517502',1,0,'2022-03-03 13:09:49','2022-03-03 13:09:49'),(86953,264,'S.V.Medical College','517507',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86954,264,'S.V.Nagar','517502',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86955,264,'S.V.R.Pet','517551',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86956,264,'S.V.University','517502',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86957,264,'Sadasiva Sankarapuram','517589',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86958,264,'Sadasivapuram','517643',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86959,264,'Sakamvaripalle','517277',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86960,264,'Sanambhatla','517505',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86961,264,'Sangasamudram','517297',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86962,264,'Sankampalle','517112',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86963,264,'Santhavelur','517645',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86964,264,'Sarimadugu','517297',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86965,264,'Satravada','517592',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86966,264,'Satyanarayanapuram','517507',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86967,264,'Satyavedu','517588',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86968,264,'Seetharamapuram','517571',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86969,264,'Seshapuram','517102',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86970,264,'Settipalli','517506',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86971,264,'Settivaripalle','517291',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86972,264,'Siddavaram','517297',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86973,264,'Siddirajukandriga','517589',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86974,264,'Sirunambudur','517588',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86975,264,'Sorakayalapeta','517213',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86976,264,'Sri Bommarajapuram','517571',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86977,264,'Sri Sukabrahmasramam','517640',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86978,264,'Sriharipuram','517586',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86979,264,'Srikalahasti H.O','517644',1,0,'2022-03-03 13:09:50','2022-03-03 13:09:50'),(86980,264,'Srikalahasti North','517644',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(86981,264,'Srinivasanagar','517507',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(86982,264,'Sriramapuram','517587',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(86983,264,'Suramala','517643',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(86984,264,'Surendranagaram','517583',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(86985,264,'T.Rachapalle','517291',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(86986,264,'T.Sakirevupalle','517237',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(86987,264,'T.Sandravaripalle','517213',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(86988,264,'T.Sattevaripalle','517193',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(86989,264,'T.T.D.Press','517507',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(86990,264,'Tadukupet','517590',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(86991,264,'Talarivettu','517541',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(86992,264,'Talupula','517214',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(86993,264,'Tarigonda','517291',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(86994,264,'Terani','517592',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(86995,264,'Thandlam','517503',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(86996,264,'Thatimakulapalle','517194',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(86997,264,'Thettupalle','517194',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(86998,264,'Thimmapuram','517235',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(86999,264,'Thimmarajukandriga','517571',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(87000,264,'Thimmarajupalle','517561',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(87001,264,'Thimminaidupalem','517507',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(87002,264,'Thippireddigarialle','517193',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(87003,264,'Thirumalayapalli','517569',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(87004,264,'Thirumanyam Rajula Kandriga','517551',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(87005,264,'Thondamanadu','517641',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(87006,264,'Thondavada','517505',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(87007,264,'Thorur','517583',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(87008,264,'Thotambedu','517640',1,0,'2022-03-03 13:09:51','2022-03-03 13:09:51'),(87009,264,'Thukivakam','517520',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87010,264,'Thumbur','517581',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87011,264,'Thummalagunta','517502',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87012,264,'Thuvvapalle','517236',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87013,264,'Tiruchanoor Road','517501',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87014,264,'Tiruchanoor','517503',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87015,264,'Tirumala Kuppam','517584',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87016,264,'Tirumala North','517504',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87017,264,'Tirumala (Chittoor)','517504',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87018,264,'Tirupati Bazar','517501',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87019,264,'Tirupati East','517501',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87020,264,'Tirupati H.O','517501',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87021,264,'Tirupati North','517507',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87022,264,'Tirupati South','517501',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87023,264,'Tirupati West','517501',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87024,264,'Udamalakudithi','517582',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87025,264,'Udayamanikyam','517194',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87026,264,'Upanishadvihar','517640',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87027,264,'Urandur','517640',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87028,264,'Ustikayalapenta','517214',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87029,264,'V.P.V.Kothapalle','517113',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87030,264,'Vadamalpet','517551',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87031,264,'Vadlakunta','517214',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87032,264,'Vagalla','517213',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87033,264,'Vagavedu','517620',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87034,264,'Valligatla','517234',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87035,264,'Vallivedu','517152',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87036,264,'Varadaiahpalem','517541',1,0,'2022-03-03 13:09:52','2022-03-03 13:09:52'),(87037,264,'Vathalur','517582',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87038,264,'Vayalpad','517299',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87039,264,'Vedagirivaripalle','517152',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87040,264,'Vedullacheruvu','517520',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87041,264,'Vedurukuppam','517569',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87042,264,'Veerakaveri Rajapuram','517590',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87043,264,'Velampadu','517620',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87044,264,'Veligallu','517297',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87045,264,'Velur','517587',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87046,264,'Vemur','517503',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87047,264,'Vengalathur','517587',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87048,264,'Venkatakrishnapalem','517581',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87049,264,'Venkatapathi Rajuvaripet','517590',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87050,264,'Venuthanapalle','517112',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87051,264,'Vepagunta (Chittoor)','517584',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87052,264,'Vepulabailu','517214',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87053,264,'Veterinary Science College','517502',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87054,264,'Vijayapuram','517586',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87055,264,'Vittalam','517299',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87056,264,'Vootupalle','517234',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87057,264,'Vyasasramam','517619',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87058,264,'West Varathur','517541',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87059,264,'Yegavuru','517194',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87060,264,'Yelavedu','517620',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87061,264,'Yellutla','517305',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87062,264,'Yenugondapalem','517291',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87063,264,'Yerpedu','517619',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87064,264,'Yerravaripalem','517194',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87065,265,'Venkayakalva','515465',1,0,'2022-03-03 13:09:53','2022-03-03 13:09:53'),(87066,265,'Abbavaram','516270',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87067,265,'Abbavaramvandlapalli','516269',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87068,265,'Adapur','516150',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87069,265,'Adavikammapalli','516215',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87070,265,'Addalamarri','516259',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87071,265,'Akepadu','516150',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87072,265,'Akkalareddypalli','516193',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87073,265,'Akkireddygaripalli','516501',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87074,265,'Alankhan Palli','516003',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87075,265,'Allwyn Nagar','516150',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87076,265,'Almaspet','516001',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87077,265,'Amagampalli','516193',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87078,265,'Ananthaiah Gari Palle','516107',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87079,265,'Ananthapuram','516257',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87080,265,'Anantharajup R.S.','516105',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87081,265,'Anantharajupet','516105',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87082,265,'Anantharajupuram','516228',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87083,265,'Ananthasamudram','516107',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87084,265,'Ankanagodiganur','516228',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87085,265,'Anumpalli','516104',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87086,265,'Anumpalli','516269',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87087,265,'Appanakondayapalli','516257',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87088,265,'Appanapalli','516203',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87089,265,'Appayarajupet','516107',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87090,265,'APSP Xl Batallion','516247',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87091,265,'Araveedu','516267',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87092,265,'Atlur','516501',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87093,265,'Ayyavaripalli','516193',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87094,265,'B . Kodur','516228',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87095,265,'Badvel Bazaar','516227',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87096,265,'Badvel','516227',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87097,265,'Balathimmayyagaripalli','516259',1,0,'2022-03-03 13:09:54','2022-03-03 13:09:54'),(87098,265,'Balayapalli','516502',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87099,265,'Balireddy Palli','516105',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87100,265,'Balireddygari Palli','516269',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87101,265,'Bandlapalli','516270',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87102,265,'Barytes Factory','516101',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87103,265,'Basavapuram','516503',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87104,265,'Bayanapalli','516162',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87105,265,'Beebisahebpet','516501',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87106,265,'Beechuvaripalli','516203',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87107,265,'Besthapalli','516128',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87108,265,'Besthapalli','516129',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87109,265,'Bethayapalli','516233',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87110,265,'Bhagampalli','516130',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87111,265,'Bhumayapalli','516203',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87112,265,'Bommavaram','516110',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87113,265,'Bonamala','516214',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87114,265,'Boppapuram','516193',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87115,265,'Botlachervu','516269',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87116,265,'Botumeedipalli','516108',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87117,265,'Boyanapalli','516227',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87118,265,'Brahmana Erragudi','516257',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87119,265,'Brahmanapalli','516233',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87120,265,'Brahmanapalli','516126',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87121,265,'Brahmanapalli','516217',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87122,265,'Buddayapalli','516002',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87123,265,'Budida Gunta Palli','516257',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87124,265,'Budidagunta Rachapalli','516130',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87125,265,'Buduguntapalli','516126',1,0,'2022-03-03 13:09:55','2022-03-03 13:09:55'),(87126,265,'Buduguntapalli','516101',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87127,265,'Burujupalli-1','516267',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87128,265,'Burujupalli-2','516267',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87129,265,'Chakrapunayanipet','516128',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87130,265,'Chakrayapet','516259',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87131,265,'Cheemalacheruvupalli','516267',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87132,265,'Chemmumiapet','516003',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87133,265,'Chenduvoyi','516501',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87134,265,'Chennampalli','516502',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87135,265,'Chennamukka Palli','516269',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87136,265,'Chennarajupodu','516105',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87137,265,'Chennavaram','516193',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87138,265,'Chennupalli','516217',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87139,265,'Chennur (Cuddapah)','516162',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87140,265,'Cherlopalli','516126',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87141,265,'Cherlopalli','516501',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87142,265,'Cheruvukinda Rachapalli','516110',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87143,265,'Cheyyeru  Project','516150',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87144,265,'Chilakampalli','516259',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87145,265,'Chinna Musali Reddy Palli','516004',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87146,265,'Chinnachowk','516002',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87147,265,'Chinnakampalli','516003',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87148,265,'Chinnakesampalli','516502',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87149,265,'Chinnamachupalli','516162',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87150,265,'Chinnamandem','516214',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87151,265,'Chinnampelli','516108',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87152,265,'Chinnaorampadu','516108',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87153,265,'Chintha Komma Dinne','516003',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87154,265,'Chinthalacheruvu','516227',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87155,265,'Chinthalapalli','516193',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87156,265,'Chintharajupalli','516152',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87157,265,'Chitlur','516504',1,0,'2022-03-03 13:09:56','2022-03-03 13:09:56'),(87158,265,'Chitvel','516104',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87159,265,'Chiyyavaram','516101',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87160,265,'Cooperative Colony','516001',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87161,265,'Cuddapah Coop Sugars','516163',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87162,265,'Cuddapah H.O','516001',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87163,265,'Cuddapah Mundy Bazar','516001',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87164,265,'Cuddapah R.S','516004',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87165,265,'Dalavaipalli','516107',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87166,265,'Dammanapalli','516193',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87167,265,'Dandlapalli','516107',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87168,265,'Dappepalli','516257',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87169,265,'Degalavandlapalli','516002',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87170,265,'Devagudipalli','516214',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87171,265,'Devamachupalli','516104',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87172,265,'Devapatla','516215',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87173,265,'Diguvagottiveedu','516269',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87174,265,'Diguvanelatur','516502',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87175,265,'Dinnepadu','516504',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87176,265,'Dirasavantsa','516502',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87177,265,'Dudyala','516215',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87178,265,'Dumpalagattu','516163',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87179,265,'Edapalli','516268',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87180,265,'Eguvagottiveedu','516269',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87181,265,'Eguvanelatur','516502',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87182,265,'Eguvaramapuram','516217',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87183,265,'Ekilapalli','516257',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87184,265,'Endapalli','516269',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87185,265,'Ethirajupalli','516227',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87186,265,'Etur','516203',1,0,'2022-03-03 13:09:57','2022-03-03 13:09:57'),(87187,265,'Gadela','516108',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87188,265,'Gadikota','516268',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87189,265,'Galivaripalli','516126',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87190,265,'Galiveedu','516267',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87191,265,'Ganganapalli','516217',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87192,265,'Gangaperur','516213',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87193,265,'Gangarapupalli','516259',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87194,265,'Ganugapenta','516228',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87195,265,'Gollapalli','516213',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87196,265,'Gollapalli','516257',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87197,265,'Gopagudi Palli','516504',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87198,265,'Gopamambapuram','516107',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87199,265,'Gopanapalli','516267',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87200,265,'Gopavaram','516233',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87201,265,'Gopavaram Project Site','516233',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87202,265,'Goramchervu','516267',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87203,265,'Gorlamudiveedu','516269',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87204,265,'Govindampalli','516105',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87205,265,'Govindayapalli','516193',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87206,265,'Gudem','516227',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87207,265,'Gundlacheruvu','516267',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87208,265,'Gundlapalli','516130',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87209,265,'Gundlur','516150',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87210,265,'Gunnikuntla','516269',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87211,265,'Gunthapalli','516502',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87212,265,'Guntimadugu','516257',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87213,265,'Guriginja Kunta','516215',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87214,265,'Gurrappagaripalli','516268',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87215,265,'Gutta Kinda Racha Palli','516129',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87216,265,'Guttapalli','516215',1,0,'2022-03-03 13:09:58','2022-03-03 13:09:58'),(87217,265,'Guvvalachervu','516504',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87218,265,'Hasanapuram','516504',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87219,265,'Industrial Estate','516004',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87220,265,'Itigullapadu','516193',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87221,265,'Itimarpuram','516128',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87222,265,'Jangalapalli','516237',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87223,265,'Jangampalli','516129',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87224,265,'Jangamrajupalli','516502',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87225,265,'Jayanagar (Cuddapah)','516002',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87226,265,'Jyothi','516237',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87227,265,'K.Sunkesala','516203',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87228,265,'Kakulavaram','516270',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87229,265,'Kalasapadu','516217',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87230,265,'Kalavakunta','516505',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87231,265,'Kalibanda','516214',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87232,265,'Kalluripalli','516259',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87233,265,'Kalpanayunicheruvu','516504',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87234,265,'Kalvapalli','516228',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87235,265,'Kamalakur','516227',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87236,265,'Kamalamarri','516267',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87237,265,'Kampasamudram','516104',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87238,265,'Kanchipativandlapalli','516130',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87239,265,'Kandimallayapalli','516503',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87240,265,'Kandulavaripalli','516104',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87241,265,'Karampalli','516126',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87242,265,'Karimireddy Vandlapalli','516267',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87243,265,'Kasthurirajupalli','516257',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87244,265,'Katinayakunta','516269',1,0,'2022-03-03 13:09:59','2022-03-03 13:09:59'),(87245,265,'Katineni Erragudi','516259',1,0,'2022-03-03 13:10:00','2022-03-03 13:10:00'),(87246,265,'Kattavaripalli','516128',1,0,'2022-03-03 13:10:00','2022-03-03 13:10:00'),(87247,265,'Kesapuram','516214',1,0,'2022-03-03 13:10:00','2022-03-03 13:10:00'),(87248,265,'Khajipet','516203',1,0,'2022-03-03 13:10:00','2022-03-03 13:10:00'),(87249,265,'Kodigudlapadu','516193',1,0,'2022-03-03 13:10:00','2022-03-03 13:10:00'),(87250,265,'Kodur Rs','516101',1,0,'2022-03-03 13:10:00','2022-03-03 13:10:00'),(87251,265,'Kodur','516101',1,0,'2022-03-03 13:10:00','2022-03-03 13:10:00'),(87252,265,'Kokkarayapalli','516162',1,0,'2022-03-03 13:10:00','2022-03-03 13:10:00'),(87253,265,'Kommaluru','516203',1,0,'2022-03-03 13:10:00','2022-03-03 13:10:00'),(87254,265,'Kommanavaripalli','516107',1,0,'2022-03-03 13:10:00','2022-03-03 13:10:00'),(87255,265,'Konampet','516257',1,0,'2022-03-03 13:10:00','2022-03-03 13:10:00'),(87256,265,'Konapuram','516151',1,0,'2022-03-03 13:10:00','2022-03-03 13:10:00'),(87257,265,'Konarachapalli','516501',1,0,'2022-03-03 13:10:00','2022-03-03 13:10:00'),(87258,265,'Konarachapalli','516152',1,0,'2022-03-03 13:10:00','2022-03-03 13:10:00'),(87259,265,'Kondavandlapalli','516259',1,0,'2022-03-03 13:10:00','2022-03-03 13:10:00'),(87260,265,'Kondavandlapalli','516504',1,0,'2022-03-03 13:10:00','2022-03-03 13:10:00'),(87261,265,'Kondur','516127',1,0,'2022-03-03 13:10:00','2022-03-03 13:10:00'),(87262,265,'Konduvaripalli','516503',1,0,'2022-03-03 13:10:00','2022-03-03 13:10:00'),(87263,265,'Koneti Raju Kandrika','516101',1,0,'2022-03-03 13:10:00','2022-03-03 13:10:00'),(87264,265,'Kongalaveedu','516502',1,0,'2022-03-03 13:10:00','2022-03-03 13:10:00'),(87265,265,'Koonavaripalli','516203',1,0,'2022-03-03 13:10:00','2022-03-03 13:10:00'),(87266,265,'Kopparthi','516003',1,0,'2022-03-03 13:10:00','2022-03-03 13:10:00'),(87267,265,'Korlakunta','516108',1,0,'2022-03-03 13:10:00','2022-03-03 13:10:00'),(87268,265,'Kothaboyanapalli','516126',1,0,'2022-03-03 13:10:01','2022-03-03 13:10:01'),(87269,265,'Kothapalli','516163',1,0,'2022-03-03 13:10:01','2022-03-03 13:10:01'),(87270,265,'Kothapalli','516502',1,0,'2022-03-03 13:10:01','2022-03-03 13:10:01'),(87271,265,'Kothapet','516163',1,0,'2022-03-03 13:10:01','2022-03-03 13:10:01'),(87272,265,'Kothapet','516107',1,0,'2022-03-03 13:10:01','2022-03-03 13:10:01'),(87273,265,'Kotlur','516203',1,0,'2022-03-03 13:10:01','2022-03-03 13:10:01'),(87274,265,'Krishnapur R.S.','516003',1,0,'2022-03-03 13:10:01','2022-03-03 13:10:01'),(87275,265,'Ksrm Engg College','516003',1,0,'2022-03-03 13:10:01','2022-03-03 13:10:01'),(87276,265,'Kuchivaripalli','516126',1,0,'2022-03-03 13:10:01','2022-03-03 13:10:01'),(87277,265,'Kukkala Doddi','516101',1,0,'2022-03-03 13:10:01','2022-03-03 13:10:01'),(87278,265,'Kumarakalva','516259',1,0,'2022-03-03 13:10:01','2022-03-03 13:10:01'),(87279,265,'Kumbhagiri','516501',1,0,'2022-03-03 13:10:01','2022-03-03 13:10:01'),(87280,265,'Kumpinipuram','516151',1,0,'2022-03-03 13:10:01','2022-03-03 13:10:01'),(87281,265,'Kuppagattupalli','516259',1,0,'2022-03-03 13:10:01','2022-03-03 13:10:01'),(87282,265,'Kuppam','516259',1,0,'2022-03-03 13:10:01','2022-03-03 13:10:01'),(87283,265,'Kurnoothala','516257',1,0,'2022-03-03 13:10:01','2022-03-03 13:10:01'),(87284,265,'Lakkireddy Palli','516257',1,0,'2022-03-03 13:10:01','2022-03-03 13:10:01'),(87285,265,'Lakshmigari Palli','516101',1,0,'2022-03-03 13:10:01','2022-03-03 13:10:01'),(87286,265,'Lebaka','516151',1,0,'2022-03-03 13:10:01','2022-03-03 13:10:01'),(87287,265,'Lingampalli','516002',1,0,'2022-03-03 13:10:01','2022-03-03 13:10:01'),(87288,265,'Lingarajupalli','516126',1,0,'2022-03-03 13:10:01','2022-03-03 13:10:01'),(87289,265,'Lingareddy Palli','516003',1,0,'2022-03-03 13:10:01','2022-03-03 13:10:01'),(87290,265,'Machupalli','516002',1,0,'2022-03-03 13:10:01','2022-03-03 13:10:01'),(87291,265,'Madakalavaripalli','516233',1,0,'2022-03-03 13:10:01','2022-03-03 13:10:01'),(87292,265,'Madanagopalapuram','516126',1,0,'2022-03-03 13:10:01','2022-03-03 13:10:01'),(87293,265,'Maddirevula','516257',1,0,'2022-03-03 13:10:02','2022-03-03 13:10:02'),(87294,265,'Madhavaram','516269',1,0,'2022-03-03 13:10:02','2022-03-03 13:10:02'),(87295,265,'Madhavaram (Cuddapah)','516247',1,0,'2022-03-03 13:10:02','2022-03-03 13:10:02'),(87296,265,'Madithadu','516129',1,0,'2022-03-03 13:10:02','2022-03-03 13:10:02'),(87297,265,'Malemarpuram','516128',1,0,'2022-03-03 13:10:02','2022-03-03 13:10:02'),(87298,265,'Malinenipatnam','516501',1,0,'2022-03-03 13:10:02','2022-03-03 13:10:02'),(87299,265,'Mallepalli','516503',1,0,'2022-03-03 13:10:02','2022-03-03 13:10:02'),(87300,265,'Mallur','516214',1,0,'2022-03-03 13:10:02','2022-03-03 13:10:02'),(87301,265,'Mamillapalli','516004',1,0,'2022-03-03 13:10:02','2022-03-03 13:10:02'),(87302,265,'Mamillapalli','516217',1,0,'2022-03-03 13:10:02','2022-03-03 13:10:02'),(87303,265,'Mandapalli','516150',1,0,'2022-03-03 13:10:02','2022-03-03 13:10:02'),(87304,265,'Mandaram','516126',1,0,'2022-03-03 13:10:02','2022-03-03 13:10:02'),(87305,265,'Mangampet','516105',1,0,'2022-03-03 13:10:02','2022-03-03 13:10:02'),(87306,265,'Mannemavaripalli','516227',1,0,'2022-03-03 13:10:02','2022-03-03 13:10:02'),(87307,265,'Mannemvaripalli','516227',1,0,'2022-03-03 13:10:02','2022-03-03 13:10:02'),(87308,265,'Mannur (Cuddapah)','516126',1,0,'2022-03-03 13:10:02','2022-03-03 13:10:02'),(87309,265,'Mantapampalli','516152',1,0,'2022-03-03 13:10:02','2022-03-03 13:10:02'),(87310,265,'Maruti Nagar','516001',1,0,'2022-03-03 13:10:02','2022-03-03 13:10:02'),(87311,265,'Masapet Bazar','516270',1,0,'2022-03-03 13:10:02','2022-03-03 13:10:02'),(87312,265,'Matli','516268',1,0,'2022-03-03 13:10:02','2022-03-03 13:10:02'),(87313,265,'Mekalavaripalli','516228',1,0,'2022-03-03 13:10:02','2022-03-03 13:10:02'),(87314,265,'Miduthur','516203',1,0,'2022-03-03 13:10:02','2022-03-03 13:10:02'),(87315,265,'Mittameedipalli','516126',1,0,'2022-03-03 13:10:02','2022-03-03 13:10:02'),(87316,265,'Mohiddin Sahib Palli','516213',1,0,'2022-03-03 13:10:02','2022-03-03 13:10:02'),(87317,265,'Motakatla','516215',1,0,'2022-03-03 13:10:02','2022-03-03 13:10:02'),(87318,265,'Mudrapalli','516128',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87319,265,'Mudumala','516503',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87320,265,'Mudumpadu','516129',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87321,265,'Mukkavaripalli','516108',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87322,265,'Mulapalli','516259',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87323,265,'Mundlapalli','516162',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87324,265,'Munnelli','516193',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87325,265,'Musalreddypalli','516217',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87326,265,'Muthukur','516501',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87327,265,'Muthukuvandla Palli','516215',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87328,265,'Mylapalli','516104',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87329,265,'Nadimpalli','516152',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87330,265,'Nagapatnam','516203',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87331,265,'Nagarajupet','516001',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87332,265,'Nagaripadu','516110',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87333,265,'Nagavaram','516110',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87334,265,'Nagi Reddy Palli','516003',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87335,265,'Nakkalapalli','516128',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87336,265,'Nallaguttapalli','516504',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87337,265,'Nandalur Bazar','516150',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87338,265,'Nandalur','516150',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87339,265,'Nandipalli','516502',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87340,265,'Naramrajupalli','516150',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87341,265,'Narasapuram','516217',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87342,265,'Narasingarajapuram','516127',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87343,265,'Narayana Reddy Palli','516215',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87344,265,'Narayana(Nellore)','516126',1,0,'2022-03-03 13:10:03','2022-03-03 13:10:03'),(87345,265,'Narvakatpalli','516213',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87346,265,'Neelakantaraopet','516504',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87347,265,'Nekanapuram','516247',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87348,265,'Nersupalli','516259',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87349,265,'Nukanapalli','516108',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87350,265,'Nuliveedu','516267',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87351,265,'Obanapalli','516101',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87352,265,'Obili','516128',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87353,265,'Obulampalli','516162',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87354,265,'Obulavaripalli','516108',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87355,265,'Odiveedu','516269',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87356,265,'P. Kothapalli','516237',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87357,265,'Pabbapuram','516003',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87358,265,'Padamatikona','516214',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87359,265,'Palampalli','516003',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87360,265,'Palugurallapalli','516503',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87361,265,'Pandikunta','516267',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87362,265,'Pandillapalli','516267',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87363,265,'Patha Cuddapah','516002',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87364,265,'Patur','516150',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87365,265,'Payalakunta','516228',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87366,265,'Peddabalija Palli','516130',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87367,265,'Peddabidiki','516129',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87368,265,'Peddaorampadu','516108',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87369,265,'Peddapalle','516247',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87370,265,'Peddapalli','516130',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87371,265,'Peddarachapalli','516110',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87372,265,'Peddarajupalli','516502',1,0,'2022-03-03 13:10:04','2022-03-03 13:10:04'),(87373,265,'Peddinenikalva','516129',1,0,'2022-03-03 13:10:05','2022-03-03 13:10:05'),(87374,265,'Peddiveedu','516268',1,0,'2022-03-03 13:10:05','2022-03-03 13:10:05'),(87375,265,'Pedullapalli','516228',1,0,'2022-03-03 13:10:05','2022-03-03 13:10:05'),(87376,265,'Pemmadapalli','516269',1,0,'2022-03-03 13:10:05','2022-03-03 13:10:05'),(87377,265,'Penagalur','516127',1,0,'2022-03-03 13:10:05','2022-03-03 13:10:05'),(87378,265,'Perlakunta','516108',1,0,'2022-03-03 13:10:05','2022-03-03 13:10:05'),(87379,265,'Pincha Dam Site','516129',1,0,'2022-03-03 13:10:05','2022-03-03 13:10:05'),(87380,265,'Pittigunta','516217',1,0,'2022-03-03 13:10:05','2022-03-03 13:10:05'),(87381,265,'Poli','516126',1,0,'2022-03-03 13:10:05','2022-03-03 13:10:05'),(87382,265,'Polimerapalli','516130',1,0,'2022-03-03 13:10:05','2022-03-03 13:10:05'),(87383,265,'Polopalli','516104',1,0,'2022-03-03 13:10:05','2022-03-03 13:10:05'),(87384,265,'Porumamilla','516193',1,0,'2022-03-03 13:10:05','2022-03-03 13:10:05'),(87385,265,'Pothapi','516151',1,0,'2022-03-03 13:10:05','2022-03-03 13:10:05'),(87386,265,'Pothukurapalli','516270',1,0,'2022-03-03 13:10:05','2022-03-03 13:10:05'),(87387,265,'Pouruvengannagaripalli','516107',1,0,'2022-03-03 13:10:05','2022-03-03 13:10:05'),(87388,265,'Prabhalaveedu','516228',1,0,'2022-03-03 13:10:05','2022-03-03 13:10:05'),(87389,265,'Pujalavandlapalli','516267',1,0,'2022-03-03 13:10:05','2022-03-03 13:10:05'),(87390,265,'Pulikunta','516267',1,0,'2022-03-03 13:10:05','2022-03-03 13:10:05'),(87391,265,'Pullampet','516107',1,0,'2022-03-03 13:10:05','2022-03-03 13:10:05'),(87392,265,'Pullapathur','516150',1,0,'2022-03-03 13:10:05','2022-03-03 13:10:05'),(87393,265,'Pullaveedu','516193',1,0,'2022-03-03 13:10:05','2022-03-03 13:10:05'),(87394,265,'Pullur kottalu','516203',1,0,'2022-03-03 13:10:05','2022-03-03 13:10:05'),(87395,265,'Pundlachennupalli','516503',1,0,'2022-03-03 13:10:05','2022-03-03 13:10:05'),(87396,265,'Pushpagiri','516162',1,0,'2022-03-03 13:10:05','2022-03-03 13:10:05'),(87397,265,'Puthanavaripalli','516107',1,0,'2022-03-03 13:10:05','2022-03-03 13:10:05'),(87398,265,'Pyarampalli','516267',1,0,'2022-03-03 13:10:06','2022-03-03 13:10:06'),(87399,265,'Rachagudipalli','516213',1,0,'2022-03-03 13:10:06','2022-03-03 13:10:06'),(87400,265,'Rachapalli','516213',1,0,'2022-03-03 13:10:06','2022-03-03 13:10:06'),(87401,265,'Rachapalli','516268',1,0,'2022-03-03 13:10:06','2022-03-03 13:10:06'),(87402,265,'Rachayapet','516233',1,0,'2022-03-03 13:10:06','2022-03-03 13:10:06'),(87403,265,'Rachinnayapalli','516162',1,0,'2022-03-03 13:10:06','2022-03-03 13:10:06'),(87404,265,'Raghavarajupuram','516105',1,0,'2022-03-03 13:10:06','2022-03-03 13:10:06'),(87405,265,'Rajampet H.O','516115',1,0,'2022-03-03 13:10:06','2022-03-03 13:10:06'),(87406,265,'Rajampet Rs','516115',1,0,'2022-03-03 13:10:06','2022-03-03 13:10:06'),(87407,265,'Rajasahebpet','516505',1,0,'2022-03-03 13:10:06','2022-03-03 13:10:06'),(87408,265,'Rajukunta','516104',1,0,'2022-03-03 13:10:06','2022-03-03 13:10:06'),(87409,265,'Rajupalli','516504',1,0,'2022-03-03 13:10:06','2022-03-03 13:10:06'),(87410,265,'Rajuvaripalli','516215',1,0,'2022-03-03 13:10:06','2022-03-03 13:10:06'),(87411,265,'Ramanapalli','516162',1,0,'2022-03-03 13:10:06','2022-03-03 13:10:06'),(87412,265,'Ramanjaneyapuram','516002',1,0,'2022-03-03 13:10:06','2022-03-03 13:10:06'),(87413,265,'Ramapuram','516504',1,0,'2022-03-03 13:10:06','2022-03-03 13:10:06'),(87414,265,'Ramarajupalli','516002',1,0,'2022-03-03 13:10:06','2022-03-03 13:10:06'),(87415,265,'Ramarajupalli','516003',1,0,'2022-03-03 13:10:06','2022-03-03 13:10:06'),(87416,265,'Ramasamudram','516107',1,0,'2022-03-03 13:10:06','2022-03-03 13:10:06'),(87417,265,'Rameswaram','516193',1,0,'2022-03-03 13:10:06','2022-03-03 13:10:06'),(87418,265,'Rangasamudram','516193',1,0,'2022-03-03 13:10:06','2022-03-03 13:10:06'),(87419,265,'Ravindra Nagar','516003',1,0,'2022-03-03 13:10:07','2022-03-03 13:10:07'),(87420,265,'Ravulapalli','516203',1,0,'2022-03-03 13:10:07','2022-03-03 13:10:07'),(87421,265,'Rayachoti','516269',1,0,'2022-03-03 13:10:07','2022-03-03 13:10:07'),(87422,265,'Rayavaram (Cuddapah)','516129',1,0,'2022-03-03 13:10:07','2022-03-03 13:10:07'),(87423,265,'Reddikottala','516193',1,0,'2022-03-03 13:10:07','2022-03-03 13:10:07'),(87424,265,'Reddipalli','516107',1,0,'2022-03-03 13:10:07','2022-03-03 13:10:07'),(87425,265,'Reddivaripalli','516101',1,0,'2022-03-03 13:10:07','2022-03-03 13:10:07'),(87426,265,'Reddivaripalli','516130',1,0,'2022-03-03 13:10:07','2022-03-03 13:10:07'),(87427,265,'Reddivaripalli','516257',1,0,'2022-03-03 13:10:07','2022-03-03 13:10:07'),(87428,265,'Reddyvaripalli','516214',1,0,'2022-03-03 13:10:07','2022-03-03 13:10:07'),(87429,265,'Rekalakunta','516502',1,0,'2022-03-03 13:10:07','2022-03-03 13:10:07'),(87430,265,'Rekulakunta','516233',1,0,'2022-03-03 13:10:07','2022-03-03 13:10:07'),(87431,265,'RIMS','516002',1,0,'2022-03-03 13:10:07','2022-03-03 13:10:07'),(87432,265,'Rollamadugu','516126',1,0,'2022-03-03 13:10:07','2022-03-03 13:10:07'),(87433,265,'Rowthukunta','516215',1,0,'2022-03-03 13:10:07','2022-03-03 13:10:07'),(87434,265,'RTC Work Shop','516002',1,0,'2022-03-03 13:10:07','2022-03-03 13:10:07'),(87435,265,'S.V.U. P.G .centre','516003',1,0,'2022-03-03 13:10:07','2022-03-03 13:10:07'),(87436,265,'Sambepalli','516215',1,0,'2022-03-03 13:10:07','2022-03-03 13:10:07'),(87437,265,'Sanipaya','516130',1,0,'2022-03-03 13:10:07','2022-03-03 13:10:07'),(87438,265,'Sanjeevi Nagar','516269',1,0,'2022-03-03 13:10:07','2022-03-03 13:10:07'),(87439,265,'Sankavaram','516193',1,0,'2022-03-03 13:10:08','2022-03-03 13:10:08'),(87440,265,'Saraswatipalli','516504',1,0,'2022-03-03 13:10:08','2022-03-03 13:10:08'),(87441,265,'Savisettipalli','516193',1,0,'2022-03-03 13:10:08','2022-03-03 13:10:08'),(87442,265,'Seetharamapuram','516126',1,0,'2022-03-03 13:10:08','2022-03-03 13:10:08'),(87443,265,'Seshamanbapuram','516150',1,0,'2022-03-03 13:10:08','2022-03-03 13:10:08'),(87444,265,'Settigunta','516101',1,0,'2022-03-03 13:10:08','2022-03-03 13:10:08'),(87445,265,'Settipalli','516215',1,0,'2022-03-03 13:10:08','2022-03-03 13:10:08'),(87446,265,'Shankarapuram (Cuddapah)','516002',1,0,'2022-03-03 13:10:08','2022-03-03 13:10:08'),(87447,265,'Sibyala','516269',1,0,'2022-03-03 13:10:08','2022-03-03 13:10:08'),(87448,265,'Siddanthipuram','516203',1,0,'2022-03-03 13:10:08','2022-03-03 13:10:08'),(87449,265,'Siddavaram','516505',1,0,'2022-03-03 13:10:08','2022-03-03 13:10:08'),(87450,265,'Siddavaram','516127',1,0,'2022-03-03 13:10:08','2022-03-03 13:10:08'),(87451,265,'Siddavattam','516237',1,0,'2022-03-03 13:10:08','2022-03-03 13:10:08'),(87452,265,'Singamvaripalli','516267',1,0,'2022-03-03 13:10:08','2022-03-03 13:10:08'),(87453,265,'Singareddypalli','516127',1,0,'2022-03-03 13:10:08','2022-03-03 13:10:08'),(87454,265,'Sivalapalli','516162',1,0,'2022-03-03 13:10:08','2022-03-03 13:10:08'),(87455,265,'Somavaram','516268',1,0,'2022-03-03 13:10:08','2022-03-03 13:10:08'),(87456,265,'Somireddypalli','516503',1,0,'2022-03-03 13:10:08','2022-03-03 13:10:08'),(87457,265,'Srinivasa Nagar','516101',1,0,'2022-03-03 13:10:08','2022-03-03 13:10:08'),(87458,265,'Suddamalla','516504',1,0,'2022-03-03 13:10:08','2022-03-03 13:10:08'),(87459,265,'Sunnapuralla Palli','516001',1,0,'2022-03-03 13:10:08','2022-03-03 13:10:08'),(87460,265,'Surabhi','516259',1,0,'2022-03-03 13:10:09','2022-03-03 13:10:09'),(87461,265,'Surapurajupalli','516101',1,0,'2022-03-03 13:10:09','2022-03-03 13:10:09'),(87462,265,'T. Sadipirallavandla Palli','516215',1,0,'2022-03-03 13:10:09','2022-03-03 13:10:09'),(87463,265,'T. Sakibanda','516214',1,0,'2022-03-03 13:10:09','2022-03-03 13:10:09'),(87464,265,'T. Sandrapalli','516233',1,0,'2022-03-03 13:10:09','2022-03-03 13:10:09'),(87465,265,'T. Sundupalli','516130',1,0,'2022-03-03 13:10:09','2022-03-03 13:10:09'),(87466,265,'T.Kammapalli','516107',1,0,'2022-03-03 13:10:09','2022-03-03 13:10:09'),(87467,265,'T.Sallagarigela','516505',1,0,'2022-03-03 13:10:09','2022-03-03 13:10:09'),(87468,265,'T.Soudarivaripalli','516503',1,0,'2022-03-03 13:10:09','2022-03-03 13:10:09'),(87469,265,'Tadigotla','516003',1,0,'2022-03-03 13:10:09','2022-03-03 13:10:09'),(87470,265,'Takkolu','516002',1,0,'2022-03-03 13:10:09','2022-03-03 13:10:09'),(87471,265,'Talamudipi','516267',1,0,'2022-03-03 13:10:09','2022-03-03 13:10:09'),(87472,265,'Tallapaka','516126',1,0,'2022-03-03 13:10:09','2022-03-03 13:10:09'),(87473,265,'Tamtamvandlapalli','516267',1,0,'2022-03-03 13:10:09','2022-03-03 13:10:09'),(87474,265,'Tangatur','516151',1,0,'2022-03-03 13:10:09','2022-03-03 13:10:09'),(87475,265,'Tekurpet','516505',1,0,'2022-03-03 13:10:09','2022-03-03 13:10:09'),(87476,265,'Tellapadu','516217',1,0,'2022-03-03 13:10:09','2022-03-03 13:10:09'),(87477,265,'Thangedupalli','516502',1,0,'2022-03-03 13:10:09','2022-03-03 13:10:09'),(87478,265,'Thavaripalli','516203',1,0,'2022-03-03 13:10:09','2022-03-03 13:10:09'),(87479,265,'Thimmareddypalli','516259',1,0,'2022-03-03 13:10:10','2022-03-03 13:10:10'),(87480,265,'Thimmasamudram','516130',1,0,'2022-03-03 13:10:10','2022-03-03 13:10:10'),(87481,265,'Thimmaytagaripalli','516128',1,0,'2022-03-03 13:10:10','2022-03-03 13:10:10'),(87482,265,'Thippayyapalli','516107',1,0,'2022-03-03 13:10:10','2022-03-03 13:10:10'),(87483,265,'Thiruvengalapuram','516502',1,0,'2022-03-03 13:10:10','2022-03-03 13:10:10'),(87484,265,'Thogurupet','516150',1,0,'2022-03-03 13:10:10','2022-03-03 13:10:10'),(87485,265,'Thokalapalli','516505',1,0,'2022-03-03 13:10:10','2022-03-03 13:10:10'),(87486,265,'Thudumaladinne','516203',1,0,'2022-03-03 13:10:10','2022-03-03 13:10:10'),(87487,265,'Thummachetlapalli','516128',1,0,'2022-03-03 13:10:10','2022-03-03 13:10:10'),(87488,265,'Thumukunta','516267',1,0,'2022-03-03 13:10:10','2022-03-03 13:10:10'),(87489,265,'Tripuravaram','516203',1,0,'2022-03-03 13:10:10','2022-03-03 13:10:10'),(87490,265,'Ukkayapalle','516002',1,0,'2022-03-03 13:10:10','2022-03-03 13:10:10'),(87491,265,'Upparapalli','516162',1,0,'2022-03-03 13:10:10','2022-03-03 13:10:10'),(87492,265,'Upparapalli','516101',1,0,'2022-03-03 13:10:10','2022-03-03 13:10:10'),(87493,265,'Upparapalli','516126',1,0,'2022-03-03 13:10:10','2022-03-03 13:10:10'),(87494,265,'Uppatur','516501',1,0,'2022-03-03 13:10:10','2022-03-03 13:10:10'),(87495,265,'Utukur','516003',1,0,'2022-03-03 13:10:10','2022-03-03 13:10:10'),(87496,265,'Utukur','516126',1,0,'2022-03-03 13:10:10','2022-03-03 13:10:10'),(87497,265,'Vaddemanu','516193',1,0,'2022-03-03 13:10:10','2022-03-03 13:10:10'),(87498,265,'Vaddevandlapalli','516215',1,0,'2022-03-03 13:10:10','2022-03-03 13:10:10'),(87499,265,'Valleruvaripalli','516227',1,0,'2022-03-03 13:10:10','2022-03-03 13:10:10'),(87500,265,'Varadaiahgaripalli','516126',1,0,'2022-03-03 13:10:10','2022-03-03 13:10:10'),(87501,265,'Varikunta','516217',1,0,'2022-03-03 13:10:11','2022-03-03 13:10:11'),(87502,265,'Vathalur','516107',1,0,'2022-03-03 13:10:11','2022-03-03 13:10:11'),(87503,265,'Veeraballi','516268',1,0,'2022-03-03 13:10:11','2022-03-03 13:10:11'),(87504,265,'Velagacherla','516127',1,0,'2022-03-03 13:10:11','2022-03-03 13:10:11'),(87505,265,'Veligallu','516267',1,0,'2022-03-03 13:10:11','2022-03-03 13:10:11'),(87506,265,'Vellavari Kandrika','516101',1,0,'2022-03-03 13:10:11','2022-03-03 13:10:11'),(87507,265,'Venkata Reddy Palli','516101',1,0,'2022-03-03 13:10:11','2022-03-03 13:10:11'),(87508,265,'Venkatapathiraju Kandrika','516101',1,0,'2022-03-03 13:10:11','2022-03-03 13:10:11'),(87509,265,'Venkatarajupalli','516110',1,0,'2022-03-03 13:10:11','2022-03-03 13:10:11'),(87510,265,'Venkataramapuram','516228',1,0,'2022-03-03 13:10:11','2022-03-03 13:10:11'),(87511,265,'Venkatasettipalli','516501',1,0,'2022-03-03 13:10:11','2022-03-03 13:10:11'),(87512,265,'Venkateswara Puram','516247',1,0,'2022-03-03 13:10:11','2022-03-03 13:10:11'),(87513,265,'Venkatreddygaripalli','516270',1,0,'2022-03-03 13:10:11','2022-03-03 13:10:11'),(87514,265,'Vongimalla','516268',1,0,'2022-03-03 13:10:11','2022-03-03 13:10:11'),(87515,265,'Vontimitta','516213',1,0,'2022-03-03 13:10:11','2022-03-03 13:10:11'),(87516,265,'Vontithatipalli','516237',1,0,'2022-03-03 13:10:11','2022-03-03 13:10:11'),(87517,265,'Yerragatlavandlapalli','516214',1,0,'2022-03-03 13:10:11','2022-03-03 13:10:11'),(87518,265,'Yerraguntlakota','516105',1,0,'2022-03-03 13:10:11','2022-03-03 13:10:11'),(87519,265,'Yerramukkapalli','516004',1,0,'2022-03-03 13:10:11','2022-03-03 13:10:11'),(87520,265,'A. Obayapalle','516339',1,0,'2022-03-03 13:10:11','2022-03-03 13:10:11'),(87521,265,'Achavalli','516421',1,0,'2022-03-03 13:10:12','2022-03-03 13:10:12'),(87522,265,'Agadur','516421',1,0,'2022-03-03 13:10:12','2022-03-03 13:10:12'),(87523,265,'Agraharam','516454',1,0,'2022-03-03 13:10:12','2022-03-03 13:10:12'),(87524,265,'Akkulugaripalle','516396',1,0,'2022-03-03 13:10:12','2022-03-03 13:10:12'),(87525,265,'Alavalapadu','516350',1,0,'2022-03-03 13:10:12','2022-03-03 13:10:12'),(87526,265,'Alidena','516339',1,0,'2022-03-03 13:10:12','2022-03-03 13:10:12'),(87527,265,'Alladupalle','516356',1,0,'2022-03-03 13:10:12','2022-03-03 13:10:12'),(87528,265,'Ambakapalle','516391',1,0,'2022-03-03 13:10:12','2022-03-03 13:10:12'),(87529,265,'Ambavaram','516293',1,0,'2022-03-03 13:10:12','2022-03-03 13:10:12'),(87530,265,'Ambavaram','516434',1,0,'2022-03-03 13:10:12','2022-03-03 13:10:12'),(87531,265,'Anandashram','516172',1,0,'2022-03-03 13:10:12','2022-03-03 13:10:12'),(87532,265,'Anantapuram','516355',1,0,'2022-03-03 13:10:12','2022-03-03 13:10:12'),(87533,265,'Animela','516321',1,0,'2022-03-03 13:10:12','2022-03-03 13:10:12'),(87534,265,'Ankalammagudur','516484',1,0,'2022-03-03 13:10:12','2022-03-03 13:10:12'),(87535,265,'Ankalammapeta','516390',1,0,'2022-03-03 13:10:12','2022-03-03 13:10:12'),(87536,265,'Annaluru','516172',1,0,'2022-03-03 13:10:12','2022-03-03 13:10:12'),(87537,265,'Annapusastrulapalle','516172',1,0,'2022-03-03 13:10:12','2022-03-03 13:10:12'),(87538,265,'Annavaram','516362',1,0,'2022-03-03 13:10:12','2022-03-03 13:10:12'),(87539,265,'Apparaopalle','516289',1,0,'2022-03-03 13:10:12','2022-03-03 13:10:12'),(87540,265,'Appayapalle','516289',1,0,'2022-03-03 13:10:12','2022-03-03 13:10:12'),(87541,265,'Arakatavemula','516359',1,0,'2022-03-03 13:10:12','2022-03-03 13:10:12'),(87542,265,'Ayyavaripalli','516350',1,0,'2022-03-03 13:10:12','2022-03-03 13:10:12'),(87543,265,'B Cherlopalle','516454',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87544,265,'Bakkananagaripalle','516350',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87545,265,'Balapanagudur','516411',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87546,265,'Balapanur','516484',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87547,265,'Bayanapalle','516175',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87548,265,'Bedudur','516474',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87549,265,'Bekalabalayapalle','516312',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87550,265,'Bestavemula','516432',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87551,265,'Bhadripalle','516172',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87552,265,'Bhadripalle','516401',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87553,265,'Bhimagundam','516433',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87554,265,'Bhumayagaripalle','516349',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87555,265,'Bidinamcherla','516454',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87556,265,'Bodithippanapadu','516431',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87557,265,'Bojjayapalle','516484',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87558,265,'Bokkudupalle','516391',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87559,265,'Bonala','516484',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87560,265,'Bondalakunta','516380',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87561,265,'Brahmanapalle','516391',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87562,265,'Buchupalle','516401',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87563,265,'Bukkapatnam','516474',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87564,265,'Busireddypalle','516321',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87565,265,'C Gopalapuram','516289',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87566,265,'C Kothapalle','516293',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87567,265,'C Rajupalem','516339',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87568,265,'Chagaleru','516349',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87569,265,'Chapadu','516356',1,0,'2022-03-03 13:10:13','2022-03-03 13:10:13'),(87570,265,'Cheemalapenta','516218',1,0,'2022-03-03 13:10:14','2022-03-03 13:10:14'),(87571,265,'Chennamarajupalle','516361',1,0,'2022-03-03 13:10:14','2022-03-03 13:10:14'),(87572,265,'Chevvanagayapalle','516474',1,0,'2022-03-03 13:10:14','2022-03-03 13:10:14'),(87573,265,'Chevvaripalle','516464',1,0,'2022-03-03 13:10:14','2022-03-03 13:10:14'),(87574,265,'Chilamakur','516310',1,0,'2022-03-03 13:10:14','2022-03-03 13:10:14'),(87575,265,'Chinnacheppale','516289',1,0,'2022-03-03 13:10:14','2022-03-03 13:10:14'),(87576,265,'Chinnadudyal','516380',1,0,'2022-03-03 13:10:14','2022-03-03 13:10:14'),(87577,265,'Chinnaguruvaluru','516172',1,0,'2022-03-03 13:10:14','2022-03-03 13:10:14'),(87578,265,'Chinnakomerla','516433',1,0,'2022-03-03 13:10:14','2022-03-03 13:10:14'),(87579,265,'Chinnakundala','516396',1,0,'2022-03-03 13:10:14','2022-03-03 13:10:14'),(87580,265,'Chinnandlur','516312',1,0,'2022-03-03 13:10:14','2022-03-03 13:10:14'),(87581,265,'Chinnapasupula','516411',1,0,'2022-03-03 13:10:14','2022-03-03 13:10:14'),(87582,265,'Chinnarangapuram','516391',1,0,'2022-03-03 13:10:14','2022-03-03 13:10:14'),(87583,265,'Chinnasettipalle','516359',1,0,'2022-03-03 13:10:14','2022-03-03 13:10:14'),(87584,265,'Chinnasinganapalle','516175',1,0,'2022-03-03 13:10:14','2022-03-03 13:10:14'),(87585,265,'Chinnaventhurla','516432',1,0,'2022-03-03 13:10:14','2022-03-03 13:10:14'),(87586,265,'Chintakunta','516380',1,0,'2022-03-03 13:10:14','2022-03-03 13:10:14'),(87587,265,'Chintakunta','516172',1,0,'2022-03-03 13:10:14','2022-03-03 13:10:14'),(87588,265,'Chintalajutur','516391',1,0,'2022-03-03 13:10:14','2022-03-03 13:10:14'),(87589,265,'Chirrajupalle','516310',1,0,'2022-03-03 13:10:14','2022-03-03 13:10:14'),(87590,265,'Chiyyapadu','516356',1,0,'2022-03-03 13:10:14','2022-03-03 13:10:14'),(87591,265,'Chowdur','516361',1,0,'2022-03-03 13:10:14','2022-03-03 13:10:14'),(87592,265,'Chowtapalle','516444',1,0,'2022-03-03 13:10:14','2022-03-03 13:10:14'),(87593,265,'College Road','516360',1,0,'2022-03-03 13:10:14','2022-03-03 13:10:14'),(87594,265,'Dadireddypalle','516289',1,0,'2022-03-03 13:10:15','2022-03-03 13:10:15'),(87595,265,'Dattapuram','516474',1,0,'2022-03-03 13:10:15','2022-03-03 13:10:15'),(87596,265,'Devagudi','516434',1,0,'2022-03-03 13:10:15','2022-03-03 13:10:15'),(87597,265,'Devarajupalle','516289',1,0,'2022-03-03 13:10:15','2022-03-03 13:10:15'),(87598,265,'Dhodiyam','516432',1,0,'2022-03-03 13:10:15','2022-03-03 13:10:15'),(87599,265,'Diguvakalavatala','516434',1,0,'2022-03-03 13:10:15','2022-03-03 13:10:15'),(87600,265,'Diguvapalle','516216',1,0,'2022-03-03 13:10:15','2022-03-03 13:10:15'),(87601,265,'Diguvathuvvalapalle','516218',1,0,'2022-03-03 13:10:15','2022-03-03 13:10:15'),(87602,265,'Dommaranandyala','516431',1,0,'2022-03-03 13:10:15','2022-03-03 13:10:15'),(87603,265,'Dondlavagu','516484',1,0,'2022-03-03 13:10:15','2022-03-03 13:10:15'),(87604,265,'Dorasanipalle','516361',1,0,'2022-03-03 13:10:15','2022-03-03 13:10:15'),(87605,265,'Dudekunta','516454',1,0,'2022-03-03 13:10:15','2022-03-03 13:10:15'),(87606,265,'Duggananagaripalle','516350',1,0,'2022-03-03 13:10:15','2022-03-03 13:10:15'),(87607,265,'Duvvur (Cuddapah)','516175',1,0,'2022-03-03 13:10:15','2022-03-03 13:10:15'),(87608,265,'Ellampalle','516173',1,0,'2022-03-03 13:10:15','2022-03-03 13:10:15'),(87609,265,'Erraballe','516391',1,0,'2022-03-03 13:10:15','2022-03-03 13:10:15'),(87610,265,'Erragudi','516474',1,0,'2022-03-03 13:10:15','2022-03-03 13:10:15'),(87611,265,'Errapalle','516175',1,0,'2022-03-03 13:10:15','2022-03-03 13:10:15'),(87612,265,'Erripalle','516391',1,0,'2022-03-03 13:10:15','2022-03-03 13:10:15'),(87613,265,'Eruvapalem','516359',1,0,'2022-03-03 13:10:16','2022-03-03 13:10:16'),(87614,265,'Eturu','516474',1,0,'2022-03-03 13:10:16','2022-03-03 13:10:16'),(87615,265,'Gadegudur','516359',1,0,'2022-03-03 13:10:16','2022-03-03 13:10:16'),(87616,265,'Galivaripalle','516293',1,0,'2022-03-03 13:10:16','2022-03-03 13:10:16'),(87617,265,'Gallavandlapalle','516172',1,0,'2022-03-03 13:10:16','2022-03-03 13:10:16'),(87618,265,'Gandhi Road (Cuddapah)','516360',1,0,'2022-03-03 13:10:16','2022-03-03 13:10:16'),(87619,265,'Gandikota','516434',1,0,'2022-03-03 13:10:16','2022-03-03 13:10:16'),(87620,265,'Gandlur','516444',1,0,'2022-03-03 13:10:16','2022-03-03 13:10:16'),(87621,265,'Ganganapalle','516421',1,0,'2022-03-03 13:10:16','2022-03-03 13:10:16'),(87622,265,'Ganganapalle','516216',1,0,'2022-03-03 13:10:16','2022-03-03 13:10:16'),(87623,265,'Gangavaram','516289',1,0,'2022-03-03 13:10:16','2022-03-03 13:10:16'),(87624,265,'Gangayapalle','516293',1,0,'2022-03-03 13:10:16','2022-03-03 13:10:16'),(87625,265,'Gangireddypalle','516321',1,0,'2022-03-03 13:10:16','2022-03-03 13:10:16'),(87626,265,'Ganjikunta','516173',1,0,'2022-03-03 13:10:16','2022-03-03 13:10:16'),(87627,265,'Garlamittapalle','516339',1,0,'2022-03-03 13:10:16','2022-03-03 13:10:16'),(87628,265,'Giddankipalle','516350',1,0,'2022-03-03 13:10:16','2022-03-03 13:10:16'),(87629,265,'Gollalagudur','516391',1,0,'2022-03-03 13:10:16','2022-03-03 13:10:16'),(87630,265,'Gondipalle','516218',1,0,'2022-03-03 13:10:16','2022-03-03 13:10:16'),(87631,265,'Gondipalle','516349',1,0,'2022-03-03 13:10:16','2022-03-03 13:10:16'),(87632,265,'Gonumakulapalle','516321',1,0,'2022-03-03 13:10:16','2022-03-03 13:10:16'),(87633,265,'Gopalapuram','516216',1,0,'2022-03-03 13:10:16','2022-03-03 13:10:16'),(87634,265,'Gopavaram','516361',1,0,'2022-03-03 13:10:16','2022-03-03 13:10:16'),(87635,265,'Gopayapalle','516359',1,0,'2022-03-03 13:10:16','2022-03-03 13:10:16'),(87636,265,'Goriganur','516434',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87637,265,'Gotur','516391',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87638,265,'Gotur','516293',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87639,265,'Gudemcheruvu','516434',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87640,265,'Gudipadu','516175',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87641,265,'Gunakanapalle','516396',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87642,265,'Gundlakunta','516431',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87643,265,'Gurijala','516454',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87644,265,'Hanumanagutti','516361',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87645,265,'Himakunta','516454',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87646,265,'Holmespet','516361',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87647,265,'Idamadaka','516175',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87648,265,'Idupulapaya(IIIT)','516330',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87649,265,'Illur','516312',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87650,265,'Inagalur','516421',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87651,265,'Indukur','516339',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87652,265,'Ippatla','516391',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87653,265,'J Kothapalle','516411',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87654,265,'Jammalamadugu East','516434',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87655,265,'Jammalamadugu North','516434',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87656,265,'Jammalamadugu','516434',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87657,265,'Jandravaram','516172',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87658,265,'Jangalapalle','516411',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87659,265,'Jangamreddypalle','516464',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87660,265,'Jillella','516175',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87661,265,'K Kothapalle','516380',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87662,265,'K Sugumanchipalle','516474',1,0,'2022-03-03 13:10:17','2022-03-03 13:10:17'),(87663,265,'Kakirenipalle','516361',1,0,'2022-03-03 13:10:18','2022-03-03 13:10:18'),(87664,265,'Kalamalla','516310',1,0,'2022-03-03 13:10:18','2022-03-03 13:10:18'),(87665,265,'Kallur (Cuddapah)','516355',1,0,'2022-03-03 13:10:18','2022-03-03 13:10:18'),(87666,265,'Kallutla','516432',1,0,'2022-03-03 13:10:18','2022-03-03 13:10:18'),(87667,265,'Kamalapuram (Cuddapah)','516289',1,0,'2022-03-03 13:10:18','2022-03-03 13:10:18'),(87668,265,'Kamanur','516175',1,0,'2022-03-03 13:10:18','2022-03-03 13:10:18'),(87669,265,'Kamasamudram','516484',1,0,'2022-03-03 13:10:18','2022-03-03 13:10:18'),(87670,265,'Kamballe','516401',1,0,'2022-03-03 13:10:18','2022-03-03 13:10:18'),(87671,265,'Kammavaripalle','516216',1,0,'2022-03-03 13:10:18','2022-03-03 13:10:18'),(87672,265,'Kammavaripalle','516432',1,0,'2022-03-03 13:10:18','2022-03-03 13:10:18'),(87673,265,'Kanagudur','516175',1,0,'2022-03-03 13:10:18','2022-03-03 13:10:18'),(87674,265,'Kanamakindkottala','516349',1,0,'2022-03-03 13:10:18','2022-03-03 13:10:18'),(87675,265,'Karamalavandlapalle','516431',1,0,'2022-03-03 13:10:18','2022-03-03 13:10:18'),(87676,265,'Karnapapayapalle','516396',1,0,'2022-03-03 13:10:18','2022-03-03 13:10:18'),(87677,265,'Kasanur','516454',1,0,'2022-03-03 13:10:18','2022-03-03 13:10:18'),(87678,265,'Kathalur','516350',1,0,'2022-03-03 13:10:18','2022-03-03 13:10:18'),(87679,265,'Khadarabad','516362',1,0,'2022-03-03 13:10:18','2022-03-03 13:10:18'),(87680,265,'Khaderpalle','516356',1,0,'2022-03-03 13:10:18','2022-03-03 13:10:18'),(87681,265,'Kirthipalle','516339',1,0,'2022-03-03 13:10:18','2022-03-03 13:10:18'),(87682,265,'Kodur','516309',1,0,'2022-03-03 13:10:18','2022-03-03 13:10:18'),(87683,265,'Kodur','516474',1,0,'2022-03-03 13:10:18','2022-03-03 13:10:18'),(87684,265,'Kokatam','516289',1,0,'2022-03-03 13:10:18','2022-03-03 13:10:18'),(87685,265,'Komarunipalle','516293',1,0,'2022-03-03 13:10:18','2022-03-03 13:10:18'),(87686,265,'Kommaddi','516339',1,0,'2022-03-03 13:10:18','2022-03-03 13:10:18'),(87687,265,'Kommanuthala','516396',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87688,265,'Konavaripalle','516474',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87689,265,'Kondapuram (Cuddapah)','516444',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87690,265,'Kondasunkesula','516434',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87691,265,'Kondayapalle','516289',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87692,265,'Kondikandlapalle','516444',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87693,265,'Kondreddypalle','516421',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87694,265,'Kondur','516218',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87695,265,'Koppalu','516293',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87696,265,'Koraguntapalle','516484',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87697,265,'Korrapadu','516444',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87698,265,'Korrapadu Road','516360',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87699,265,'Korrapadu','516359',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87700,265,'Kothapalle','516362',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87701,265,'Krishna Nagar (Cuddapah)','516311',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87702,265,'Krishnamgaripalle','516421',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87703,265,'Krishnampalle','516175',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87704,265,'Krishnapuram','516172',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87705,265,'Kulur','516359',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87706,265,'Kuppalapalle','516350',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87707,265,'Kuppuruvaripalle','516289',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87708,265,'Lakshmipet','516172',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87709,265,'Lavanur','516464',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87710,265,'Lebaka','516293',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87711,265,'Letapalle','516289',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87712,265,'Lingala (Cuddapah)','516396',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87713,265,'Lingaladinne','516172',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87714,265,'Lomada','516401',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87715,265,'Lopatnuthala','516396',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87716,265,'M.Kambaladinne','516433',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87717,265,'Machanapalle','516175',1,0,'2022-03-03 13:10:19','2022-03-03 13:10:19'),(87718,265,'Machanur','516218',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87719,265,'Madirepalle','516175',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87720,265,'Madur','516484',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87721,265,'Maduru','516362',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87722,265,'Malepadu','516361',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87723,265,'Mallela','516401',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87724,265,'Mangapatnam','516444',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87725,265,'Meenapuram','516362',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87726,265,'Minnaiahgaripalle','516218',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87727,265,'Mittamanipalle','516173',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87728,265,'Mobbuchintalapalle','516349',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87729,265,'Modameedipalle','516360',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87730,265,'Moillacheruvu','516321',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87731,265,'Moillakalava','516216',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87732,265,'Moragudi','516434',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87733,265,'Muddanur','516380',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87734,265,'Murarichintala','516391',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87735,265,'Musalreddipalle','516464',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87736,265,'Muthukur','516350',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87737,265,'Mydekur','516172',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87738,265,'Mylavaram (Cuddapah)','516439',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87739,265,'N Kottalapalle','516411',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87740,265,'Nagasanipalle','516172',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87741,265,'Nagoor','516350',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87742,265,'Nagulapalle','516356',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87743,265,'Nakkaladinne','516355',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87744,265,'Nakkalapalle','516484',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87745,265,'Nallaballe','516380',1,0,'2022-03-03 13:10:20','2022-03-03 13:10:20'),(87746,265,'Nallacheruvupalle','516421',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87747,265,'Nallapureddypalle','516391',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87748,265,'Nallingayapple','516289',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87749,265,'Nandimandalam','516218',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87750,265,'Nandyalampalle','516464',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87751,265,'Nandyalampeta','516172',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87752,265,'Narjampalle','516433',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87753,265,'Nawabpeta','516433',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87754,265,'Nedarapeta','516474',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87755,265,'Neelapuram','516175',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87756,265,'Nelatur','516175',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87757,265,'Nemaladinne','516411',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87758,265,'Nidizuvvi','516310',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87759,265,'Obulareddypalle','516321',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87760,265,'Obulareddypeta','516172',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87761,265,'Onipenta','516173',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87762,265,'P Anantapuram','516444',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87763,265,'Pagidala','516359',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87764,265,'Paidikalva','516216',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87765,265,'Paidipalam','516464',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87766,265,'Palagiri','516321',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87767,265,'Pallavolu','516356',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87768,265,'Palur','516421',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87769,265,'Palur','516434',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87770,265,'Pamuluru','516350',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87771,265,'Pandillapalle','516289',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87772,265,'Papayapalle','516434',1,0,'2022-03-03 13:10:21','2022-03-03 13:10:21'),(87773,265,'Parlapadu','516359',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87774,265,'Parnapalle','516396',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87775,265,'Pathapalle','516464',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87776,265,'Pathasankatipalle','516216',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87777,265,'Payasampalle','516339',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87778,265,'Peddacheppalle','516289',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87779,265,'Peddajonnavaram','516175',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87780,265,'Peddajutur','516391',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87781,265,'Peddakundala','516396',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87782,265,'Peddamudium','516434',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87783,265,'Peddanadlur','516434',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87784,265,'Peddanapadu','516309',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87785,265,'Peddapasupula','516411',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87786,265,'Peddaputta','516293',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87787,265,'Peddarangapuram','516391',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87788,265,'Peddasettipalle','516361',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87789,265,'Pendlimarri','516216',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87790,265,'Pendluru','516349',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87791,265,'Penikalapadu','516380',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87792,265,'Podadurthy','516289',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87793,265,'Ponnampalle','516433',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87794,265,'Ponnathota','516431',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87795,265,'Potladurthi','516361',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87796,265,'Pottipadu','516464',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87797,265,'Proddatur Bazaar','516360',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87798,265,'Proddatur Fort','516360',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87799,265,'Proddatur H.O','516360',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87800,265,'Pulivendla Bus-stand','516391',1,0,'2022-03-03 13:10:22','2022-03-03 13:10:22'),(87801,265,'Pulivendla H.O','516390',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87802,265,'Pulivendlakutcherry','516391',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87803,265,'Pullareddypeta','516175',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87804,265,'Purvabommepalle','516434',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87805,265,'R Thummalapalle','516391',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87806,265,'Rachavaripalle','516216',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87807,265,'Rajulaguruvayapalle','516380',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87808,265,'Rajupalam','516359',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87809,265,'Ramachandrayapalle','516432',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87810,265,'Ramapuram','516216',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87811,265,'Ramapuram','516175',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87812,265,'Ramasainagar','516175',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87813,265,'Ramireddypalle','516321',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87814,265,'Ravulakolanu','516401',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87815,265,'Regadipalle','516474',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87816,265,'S.Uppalapadu','516431',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87817,265,'Saidapuram','516421',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87818,265,'Sambatur','516289',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87819,265,'Sankarapuram','516361',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87820,265,'Sankatithimmayapalle','516172',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87821,265,'Santhakovur','516421',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87822,265,'Seetharampuram','516356',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87823,265,'Seshareddipalle','516411',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87824,265,'Settivaripalle','516173',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87825,265,'Settivaripalle','516444',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87826,265,'Siddareddypalle','516172',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87827,265,'Simhadripuram','516454',1,0,'2022-03-03 13:10:23','2022-03-03 13:10:23'),(87828,265,'Siregepalle','516474',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87829,265,'Sivapuram','516172',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87830,265,'Somulavaripalle','516361',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87831,265,'Srinivasapuram','516216',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87832,265,'Suddapalle','516434',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87833,265,'Sunkesula','516464',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87834,265,'Sunnapurallapalle','516434',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87835,265,'T Sunkesula','516309',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87836,265,'T Thummalapalle','516401',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87837,265,'T Velamvaripalle','516350',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87838,265,'T.Obayapalle','516356',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87839,265,'T.Sallabasayapalle','516175',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87840,265,'Talamanchipatnam','516433',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87841,265,'Talapanur','516339',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87842,265,'Tallamapuram','516362',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87843,265,'Tallapalle','516350',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87844,265,'Tallaproddatur','516474',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87845,265,'Tangedupalle','516329',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87846,265,'Tanguturu','516359',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87847,265,'Tappetla','516293',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87848,265,'Thimmapuram','516464',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87849,265,'Thippireddipalle','516355',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87850,265,'Thippireddypalle','516216',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87851,265,'Thippireddypalle','516173',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87852,265,'Thirumallayapalle','516474',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87853,265,'Thollaganganapalle','516293',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87854,265,'Thummalapalle','516309',1,0,'2022-03-03 13:10:24','2022-03-03 13:10:24'),(87855,265,'Thummalur','516218',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87856,265,'Tondur','516401',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87857,265,'Torrivemmula','516433',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87858,265,'Tsadipiralla','516289',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87859,265,'U Rajupalem','516218',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87860,265,'Udavagandla','516421',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87861,265,'Ulimella','516391',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87862,265,'Uppaguntapalle','516172',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87863,265,'Uppaluru','516380',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87864,265,'Upparapalle','516362',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87865,265,'Urutur','516339',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87866,265,'V Kothapalle','516349',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87867,265,'Vaddirala','516432',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87868,265,'Vaimpalle','516329',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87869,265,'Valasapalle','516309',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87870,265,'Vallur (Cuddapah)','516293',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87871,265,'Vasudevapuram','516175',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87872,265,'Vedururu','516355',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87873,265,'Veerannagattupalle','516329',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87874,265,'Veerapunayanipalle','516321',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87875,265,'Velavali','516359',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87876,265,'Veldurthi','516339',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87877,265,'Velidandla','516396',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87878,265,'Vellatur','516216',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87879,265,'Velpucherla','516380',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87880,265,'Velpula','516349',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87881,265,'Vemula','516349',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87882,265,'Venkatapuram','516391',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87883,265,'Venkupalle','516175',1,0,'2022-03-03 13:10:25','2022-03-03 13:10:25'),(87884,265,'Veparala','516431',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87885,265,'Viswanathapuram','516173',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87886,265,'Vv Reddy Nagar','516312',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87887,265,'Y Kothapalle','516464',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87888,265,'Yamavaram','516380',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87889,265,'Yenamalachintala','516474',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87890,265,'Yerragudipadu','516289',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87891,265,'Yerraguntla (Cuddapah)','516309',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87892,265,'Yerraguntla West','516309',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87893,265,'Yerraguntlapalle','516362',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87894,265,'Yerramalapalle','516321',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87895,265,'YMR Colony','516360',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87896,266,'Donkarayi','507130',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87897,266,'Forebey Dam Camp','507130',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87898,266,'Mangampadu','507130',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87899,266,'Kondamodaly','534315',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87900,266,'Kutchuluru','534315',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87901,266,'A.Vemavaram','533577',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87902,266,'Addalapalem','533252',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87903,266,'Adurru','533247',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87904,266,'Ainapuram','533216',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87905,266,'Ainavalli','533211',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87906,266,'Ainavillilanka','533211',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87907,266,'Allavaram','533217',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87908,266,'Amalapuram Bus Complex','533201',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87909,266,'Amalapuram H.O','533201',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87910,266,'Ambajipeta','533214',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87911,266,'Anatavaram','533222',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87912,266,'Ankampalem','533236',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87913,266,'Annampalli','533216',1,0,'2022-03-03 13:10:26','2022-03-03 13:10:26'),(87914,266,'Antarvedi','533252',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87915,266,'Antarvedi Devastanam','533252',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87916,266,'Antarvedipalem','533252',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87917,266,'Appanapalli','533247',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87918,266,'Appanaramunilanka','533252',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87919,266,'Aravapalem','533248',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87920,266,'Atreyapuram','533235',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87921,266,'Avidi','533229',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87922,266,'B.Doddavaram','533247',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87923,266,'Badava','533247',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87924,266,'Balusutippa','533212',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87925,266,'Bandarlanka','533221',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87926,266,'Battucheruvu','533212',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87927,266,'Bendamurlanka','533210',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87928,266,'Bhatnavilli','533222',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87929,266,'Bheemanapalli','533222',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87930,266,'Billakurru','533228',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87931,266,'Bobbarlanka','533235',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87932,266,'Bodasakurru','533215',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87933,266,'Bojjavaripeta','533212',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87934,266,'Challapalli','533213',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87935,266,'Cheyyuru','533222',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87936,266,'Chinakothalanka','533216',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87937,266,'Chintalamori','533250',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87938,266,'Chintalapalli','533244',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87939,266,'Chirata Pudi','533229',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87940,266,'D.Gannavaram','533240',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87941,266,'Devaguptam','533217',1,0,'2022-03-03 13:10:27','2022-03-03 13:10:27'),(87942,266,'Devarapalli','533223',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87943,266,'Dontikurru','533212',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87944,266,'Eastpalem','533244',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87945,266,'G.Pedapudi','533274',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87946,266,'Gadilanka','533216',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87947,266,'Gandhi Bazar (East Godavari)','533201',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87948,266,'Gangalakurru Agraharam','533221',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87949,266,'Gangalakurru','533221',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87950,266,'Ganti','533274',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87951,266,'Geddanapalli','533212',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87952,266,'Gedillanka','533216',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87953,266,'Godi','533217',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87954,266,'Godilanka','533217',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87955,266,'Goditippa','533217',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87956,266,'Gogannamatham','533248',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87957,266,'Gollavilli','533222',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87958,266,'Gondi','533251',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87959,266,'Gopalapuram (East Godavari)','533274',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87960,266,'Gopavaram','533213',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87961,266,'Gudala','533218',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87962,266,'Gudapalli','533244',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87963,266,'Gudimellanka','533253',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87964,266,'Gudimula','533251',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87965,266,'Gunnepalli','533222',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87966,266,'Guthulavaripalem','533217',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87967,266,'I.Polavaram','533220',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87968,266,'Idarada','533247',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87969,266,'Immidivarappadu','533218',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87970,266,'Indupalli','533221',1,0,'2022-03-03 13:10:28','2022-03-03 13:10:28'),(87971,266,'Irusumanda','533254',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87972,266,'Irusumanda','533239',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87973,266,'Isukapudi','533214',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87974,266,'Ithakota','533238',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87975,266,'Jaggannapeta','533249',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87976,266,'Janupalli','533577',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87977,266,'K.Jagannadhapuram','533577',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87978,266,'K.Pedapudi','533239',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87979,266,'Kadali','533248',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87980,266,'Kamanagaruvu','533213',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87981,266,'Kamini','533216',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87982,266,'Kamujuvarilanka','533241',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87983,266,'Kandikuppa','533212',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87984,266,'Kantevaripadu','533253',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87985,266,'Karavaka','533248',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87986,266,'Kathimanda','533254',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87987,266,'Katrenikona','533212',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87988,266,'Katrenipadu','533248',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87989,266,'Kattunga','533235',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87990,266,'Kedarlanka','533223',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87991,266,'Kesanakurru','533220',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87992,266,'Kesanakurrupalem','533220',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87993,266,'Kesanapalli','533244',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87994,266,'Kesavadasupalem','533252',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87995,266,'Ketharajuupalli','533238',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87996,266,'Kodurupadu','533218',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87997,266,'Komanapalli','533216',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87998,266,'Komaragiri','533220',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(87999,266,'Komaragiripatnam','533210',1,0,'2022-03-03 13:10:29','2022-03-03 13:10:29'),(88000,266,'Komarajulanka','533238',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88001,266,'Kondukuduru','533211',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88002,266,'Koppigunta','533212',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88003,266,'Kothalanka','533216',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88004,266,'Kothapeta (East Godavari)','533223',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88005,266,'Krapa','533216',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88006,266,'Krapa Chintalapudi','533216',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88007,266,'Kunavaram','533213',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88008,266,'Kunavaram','533244',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88009,266,'L.Gannavaram','533240',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88010,266,'Lakkavaram (East Godavari)','533254',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88011,266,'Laxmi Polavaram','533236',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88012,266,'Lolla','533237',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88013,266,'Lutukurru','533247',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88014,266,'Machavaram','533214',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88015,266,'Madupalli','533228',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88016,266,'Magam','533577',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88017,266,'Magatapalli','533248',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88018,266,'Malikipuram','533253',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88019,266,'Mamidikuduru','533247',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88020,266,'Manepalli','533249',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88021,266,'Mattaparru','533244',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88022,266,'Medicherlapalem','533244',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88023,266,'Moberlypeta','533201',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88024,266,'Modekurru','533229',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88025,266,'Mogalikuduru','533249',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88026,266,'Mogallamori','533210',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88027,266,'Mokkalitippa','533212',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88028,266,'Mondepulanka','533240',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88029,266,'Moolapolam','533211',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88030,266,'Mori (East Godavari)','533250',1,0,'2022-03-03 13:10:30','2022-03-03 13:10:30'),(88031,266,'Mosalapalli','533239',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88032,266,'Mukkamala','533241',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88033,266,'Mukteswaram','533211',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88034,266,'Mulikipalli','533248',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88035,266,'Mummidivaram','533216',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88036,266,'Mummidivarappadu','533274',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88037,266,'Munganda','533214',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88038,266,'Munjavarapukottu','533214',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88039,266,'Muramalla','533220',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88040,266,'N.Kothapalli','533222',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88041,266,'Nadavapalli','533212',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88042,266,'Nadipudi','533221',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88043,266,'Nagaram (East Godavari)','533247',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88044,266,'Nagullanka','533249',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88045,266,'Nallacheruvu','533241',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88046,266,'Nandampudi','533214',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88047,266,'Narendrapuram','533229',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88048,266,'Narkedmilli','533236',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88049,266,'Nedunuru','533241',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88050,266,'New Colony (East Godavari)','533201',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88051,266,'North Gopalapuram','533274',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88052,266,'Padamatipalem','533250',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88053,266,'Palagummi','533249',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88054,266,'Palivela','533229',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88055,266,'Pallam','533212',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88056,266,'Pallamkurru','533212',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88057,266,'Pasarlapudi','533247',1,0,'2022-03-03 13:10:31','2022-03-03 13:10:31'),(88058,266,'Pasarlapudilanka','533247',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88059,266,'Pasupalli','533228',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88060,266,'Pasuvullanka','533220',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88061,266,'Pedagadavilli','533222',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88062,266,'Pedapatnam','533249',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88063,266,'Pedapatnam Lanka','533247',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88064,266,'Penumalla','533222',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88065,266,'Peravaram','533235',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88066,266,'Peruru','533218',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88067,266,'Podagatapalli','533236',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88068,266,'Podalada','533249',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88069,266,'Ponnamanda','533248',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88070,266,'Pothavaram','533214',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88071,266,'Pothukurru','533577',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88072,266,'Pulidindi','533235',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88073,266,'Pulletikurru','533239',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88074,266,'Rajavaram','533235',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88075,266,'Ramarajulanka','533253',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88076,266,'Rambagh','533252',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88077,266,'Rameswaram','533251',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88078,266,'Ravulapadu','533238',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88079,266,'Ravulapalem','533238',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88080,266,'Razole H.O','533242',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88081,266,'Rdo\'s Office Road','533201',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88082,266,'Rollapalem','533218',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88083,266,'Ryali','533236',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88084,266,'Sakhinetipalli Lanka','533251',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88085,266,'Sakhinetipalli','533251',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88086,266,'Sakhinetipallipalem','533251',1,0,'2022-03-03 13:10:32','2022-03-03 13:10:32'),(88087,266,'Sakurru','533221',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88088,266,'Samanasa','533213',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88089,266,'Samanthakurru','533217',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88090,266,'Sanapallilanka','533211',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88091,266,'Sankaraguptam','533250',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88092,266,'Sannavilli','533222',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88093,266,'Saripalli','533213',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88094,266,'Serilanka','533220',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88095,266,'Sivakodu','533244',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88096,266,'Somidevarapalem','533216',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88097,266,'Srirampuram','533251',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88098,266,'Srungavarappadu','533250',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88099,266,'Surasani Yanam','533213',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88100,266,'T.Kothapalli','533220',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88101,266,'Tandavapalli','533213',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88102,266,'Tatipaka Bazar','533249',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88103,266,'Tatipaka','533249',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88104,266,'Thanelanka','533216',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88105,266,'Tillakuppa','533220',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88106,266,'Tondavaram','533221',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88107,266,'Tottaramudi','533211',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88108,266,'Tummalapalli','533210',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88109,266,'Turupulanka','533217',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88110,266,'Uppalaguptam','533222',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88111,266,'Uppudi','533212',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88112,266,'Vadapalem','533223',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88113,266,'Vadapalli','533237',1,0,'2022-03-03 13:10:33','2022-03-03 13:10:33'),(88114,266,'Vaddiparru','533235',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88115,266,'Vadrevupalli','533249',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88116,266,'Vakkalanka','533241',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88117,266,'Vanapalli','533228',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88118,266,'Vannechintalapudi','533213',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88119,266,'Vasanthavada','533235',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88120,266,'Vedureswaram','533238',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88121,266,'Veeravallipelem','533211',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88122,266,'Vegivaripalem','533248',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88123,266,'Velavalapalli','533211',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88124,266,'Velicheru','533235',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88125,266,'Vidyanagaram','533201',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88126,266,'Vilasa','533577',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88127,266,'Vilasavilli','533213',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88128,266,'Visweswarayapuram','533254',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88129,266,'Vodalarevu','533210',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88130,266,'Vubalanka','533237',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88131,266,'Vudimudi','533274',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88132,266,'Vutchili','533235',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88133,266,'Yenugulamahal','533223',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88134,266,'Yenugupalli','533240',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88135,266,'A Kothapalli','533408',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88136,266,'A Mallavaram','533449',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88137,266,'A V Nagaram','533449',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88138,266,'Addaripeta','533401',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88139,266,'Addatigala','533428',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88140,266,'Allipudi','533407',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88141,266,'Amaravalli','533448',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88142,266,'Ammajipeta','533401',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88143,266,'Amminibada','533436',1,0,'2022-03-03 13:10:34','2022-03-03 13:10:34'),(88144,266,'Ammirekula','533436',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88145,266,'Ananthagiri','533436',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88146,266,'Annavaram Devasthanam','533406',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88147,266,'Annavaram','533406',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88148,266,'Anuru','533437',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88149,266,'Apiic','533005',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88150,266,'APSP Camp (East Godavari)','533005',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88151,266,'Aratlakatta','533016',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88152,266,'Aryavatam','533468',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88153,266,'Atchampeta','533005',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88154,266,'Atchutapuratriam','533006',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88155,266,'B Kothuru','533431',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88156,266,'Badadanampalli','533436',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88157,266,'Bandanapudi','533468',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88158,266,'Bendapudi','533406',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88159,266,'Bhadravaram','533429',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88160,266,'Bhaskarnagar','533003',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88161,266,'Bhimavaram','533428',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88162,266,'Bhimavarapukota','533407',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88163,266,'Bhogapuram','533445',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88164,266,'Billananduru','533407',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88165,266,'Boddavaram','533401',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88166,266,'Bodlanka','533428',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88167,266,'Chadalada','533433',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88168,266,'Chamagadda','533483',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88169,266,'Chamavaram','533401',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88170,266,'Chandanampalem','533450',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88171,266,'Chavitidibbalu','533483',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88172,266,'Chebrolu','533449',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88173,266,'Cheedipalem','533428',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88174,266,'Chendurti','533444',1,0,'2022-03-03 13:10:35','2022-03-03 13:10:35'),(88175,266,'Cherukumpalem','533436',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88176,266,'Chikilintha','533436',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88177,266,'Chillangi','533431',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88178,266,'Chinasankaralapudi','533432',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88179,266,'Chintaluru','533446',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88180,266,'Chintaplli','533344',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88181,266,'Chitrada','533450',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88182,266,'Chollangipeta','533461',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88183,266,'Church Square','533002',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88184,266,'Coringa','533461',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88185,266,'D Polavaram','533401',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88186,266,'D. Ramavaram ','533483',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88187,266,'Dakodu','533483',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88188,266,'Dalipadu','533483',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88189,266,'Dhanyampalem','533428',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88190,266,'Dharamavaram','533430',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88191,266,'Divili','533433',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88192,266,'Doddigunta','533291',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88193,266,'Donelapalem','533436',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88194,266,'Doramamidi','533428',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88195,266,'Durcherthi','533483',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88196,266,'Durgada','533449',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88197,266,'Engg.College','533003',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88198,266,'F K Palem','533450',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88199,266,'G Kothapalli','533446',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88200,266,'G Ragampeta','533437',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88201,266,'G.Mamidada','533344',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88202,266,'G.Moolapalem','533464',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88203,266,'Gadimoga','533463',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88204,266,'Gandhinagar(KKD)','533004',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88205,266,'Gandredu','533344',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88206,266,'Ganganapalli','533006',1,0,'2022-03-03 13:10:36','2022-03-03 13:10:36'),(88207,266,'Geddanapalli','533431',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88208,266,'Georgepeta','533464',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88209,266,'Godi-O-Kurthi','533436',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88210,266,'Gokivada','533450',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88211,266,'Gollapalem','533468',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88212,266,'Gollaprolu','533445',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88213,266,'Gondolu','533428',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88214,266,'Goneda','533437',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88215,266,'Gontuvanipalem','533429',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88216,266,'Gorinta','533433',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88217,266,'Gorripudi','533468',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88218,266,'Gorsa','533450',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88219,266,'Govt.Gen Hospital','533001',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88220,266,'Gudivada','533437',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88221,266,'Gurazanapalli','533016',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88222,266,'Gurrampalem','533435',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88223,266,'Gurthedu','533483',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88224,266,'Guthenadeevi','533464',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88225,266,'Hamsavarm','533401',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88226,266,'Hussain Puram','533434',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88227,266,'Indrapalem','533006',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88228,266,'Indugupalli','533407',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88229,266,'Injaram','533464',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88230,266,'Irripaka','533435',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88231,266,'Isukapalli','533450',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88232,266,'J Annavaram','533429',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88233,266,'J Burugupudi','533435',1,0,'2022-03-03 13:10:37','2022-03-03 13:10:37'),(88234,266,'Jaddangi','533436',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88235,266,'Jaderu','533428',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88236,266,'Jagannaickpur','533002',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88237,266,'Jagapathinagaram','533431',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88238,266,'Jaggampeta','533435',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88239,266,'Jalluru','533433',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88240,266,'K E Chinnayyapalem','533407',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88241,266,'K Mallavaram','533401',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88242,266,'K Yeeragadda','533428',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88243,266,'Kaikavolu','533006',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88244,266,'Kajuluru','533468',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88245,266,'Kakinada Bazar','533001',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88246,266,'Kakinada H.O','533001',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88247,266,'Kamatam Mallavaram','533407',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88248,266,'Kandrakota','533437',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88249,266,'Kandregula','533462',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88250,266,'Kapulapalem','533464',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88251,266,'Karakuduru','533006',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88252,266,'Karapa','533462',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88253,266,'Kathipudi','533444',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88254,266,'Katravulapalli','533437',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88255,266,'Kattamuru','533437',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88256,266,'KD-collectorate','533001',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88257,266,'Kesavapuram','533463',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88258,266,'Kimmuru','533429',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88259,266,'Kinaparthi','533428',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88260,266,'Kindra','533436',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88261,266,'Kirlampudi','533431',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88262,266,'Kirrabu','533436',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88263,266,'Kodada','533408',1,0,'2022-03-03 13:10:38','2022-03-03 13:10:38'),(88264,266,'Kodavali','533444',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88265,266,'Koduru','533406',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88266,266,'Kolanka','533464',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88267,266,'Kolanka','533450',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88268,266,'Komaragiri','533450',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88269,266,'Kommanapalli','533449',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88270,266,'Konalova','533428',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88271,266,'Kondapalli','533436',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88272,266,'Kondevaram','533450',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88273,266,'Konthangi','533446',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88274,266,'Kotananduru','533407',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88275,266,'Kothakottam','533407',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88276,266,'Kothapalli (U)','533447',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88277,266,'Kothaperumallapuram','533449',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88278,266,'Kothapeta (PTP)','533450',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88279,266,'Koturu','533435',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88280,266,'Kovvuru','533016',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88281,266,'Krishnapuram','533408',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88282,266,'Kumarapriyam','533344',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88283,266,'Kurada','533260',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88284,266,'Labbarthi','533436',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88285,266,'Lagarayi','533436',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88286,266,'Lakshminarasapuram','533450',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88287,266,'Lampakalova','533430',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88288,266,'Latchireddipalem','533406',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88289,266,'Lingaparthi','533429',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88290,266,'Lododdi','533436',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88291,266,'M S N Charties','533002',1,0,'2022-03-03 13:10:39','2022-03-03 13:10:39'),(88292,266,'Madhavapatnam','533005',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88293,266,'Mallam (East Godavari)','533433',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88294,266,'Mallepalli','533435',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88295,266,'Mallisala','533435',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88296,266,'Mandapam','533406',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88297,266,'Manjeru','533468',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88298,266,'Maredubaka','533429',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88299,266,'Marlova','533437',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88300,266,'Marripalem','533428',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88301,266,'Marripudi','533437',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88302,266,'Marriveedu','533428',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88303,266,'Matlapadu','533428',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88304,266,'Medapadu','533434',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88305,266,'Mehernagar','533003',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88306,266,'Meraka Chamavaram','533446',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88307,266,'Mohanapuram','533428',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88308,266,'Mukkullu','533431',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88309,266,'Mukundavaram','533291',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88310,266,'Mulagapudi','533446',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88311,266,'Mulapeta','533448',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88312,266,'N Naredrapatnam','533406',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88313,266,'Nadakuduru','533016',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88314,266,'Nadigatla Vari Savaram','533401',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88315,266,'Nagulapalli','533447',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88316,266,'Nandivampu','533401',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88317,266,'Narendrapatnam','533435',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88318,266,'Navara','533450',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88319,266,'Nayakampalli','533437',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88320,266,'Neelapalli','533464',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88321,266,'Nellipudi','533446',1,0,'2022-03-03 13:10:40','2022-03-03 13:10:40'),(88322,266,'Nemam','533005',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88323,266,'P Vemavaram','533434',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88324,266,'P Yerragonda','533483',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88325,266,'P.Donthamuru','533445',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88326,266,'P.E.Chinayampalem','533406',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88327,266,'P.Mallavaram','533463',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88328,266,'Pallipalem','533464',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88329,266,'Paltheru','533401',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88330,266,'Panasalapalem','533483',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88331,266,'Panasapadu','533005',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88332,266,'Pandrapolu','533428',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88333,266,'Panduru','533005',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88334,266,'Patavala','533461',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88335,266,'Pathigondi','533463',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88336,266,'Pavara','533450',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88337,266,'Pedabrahmadevam','533434',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88338,266,'Pedamallapuram','533446',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88339,266,'Pedapudi','533006',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88340,266,'Pedarayavaram','533291',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88341,266,'Pedasankarlapudi','533432',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88342,266,'Pedavadisakarra','533483',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88343,266,'Peddada','533344',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88344,266,'Peddanapalli','533431',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88345,266,'Peddapuram','533437',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88346,266,'Peddapuram Town','533437',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88347,266,'Peddapurappadu','533468',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88348,266,'Penuguduru','533016',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88349,266,'Peravaram','533429',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88350,266,'Pillanka','533464',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88351,266,'Pinjarakonda','533428',1,0,'2022-03-03 13:10:41','2022-03-03 13:10:41'),(88352,266,'Pithapuram','533450',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88353,266,'Pithapuram Town','533450',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88354,266,'Ponnada','533448',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88355,266,'Pothuluru','533430',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88356,266,'Prathipadu (East Godavari)','533432',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88357,266,'Puligogulapadu','533429',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88358,266,'Pulimeru','533433',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88359,266,'Pydi Konda','533401',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88360,266,'Pyna','533344',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88361,266,'Rachapalli','533430',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88362,266,'Rajapudi','533435',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88363,266,'Rajavaram','533407',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88364,266,'Rajavommangi','533436',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88365,266,'Rajupalem','533431',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88366,266,'Rajupalem','533344',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88367,266,'Ramanakkapeta','533447',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88368,266,'Ramanayyapeta','533005',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88369,266,'Ramanayyapeta','533429',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88370,266,'Ramaraopet','533004',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88371,266,'Ramavaram','533435',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88372,266,'Ramesampeta','533437',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88373,266,'Rangampeta','533291',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88374,266,'Raparthi','533445',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88375,266,'Ravikampadu','533406',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88376,266,'Rayabhupalapatnam','533437',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88377,266,'Rayapalli','533483',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88378,266,'Rayavaram','533445',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88379,266,'Rekhavanipalem','533401',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88380,266,'Repuru','533006',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88381,266,'Routhulapudi','533446',1,0,'2022-03-03 13:10:42','2022-03-03 13:10:42'),(88382,266,'S Annavaram','533401',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88383,266,'S Thimmapuram','533431',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88384,266,'Sahapuram','533462',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88385,266,'Samalkot Agricultural Form','533440',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88386,266,'Samalkot H.O','533440',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88387,266,'Samalkot Pen Lines','533440',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88388,266,'Samalkot R S','533440',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88389,266,'Sampara','533344',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88390,266,'Sankhavaram','533446',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88391,266,'Santhapydipala','533446',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88392,266,'Santhiashram','533446',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88393,266,'Sarabhavaram','533436',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88394,266,'Sarabhavaram','533430',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88395,266,'Sarpavaram','533005',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88396,266,'Satyanarayanapuram','533440',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88397,266,'Seela','533468',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88398,266,'Selapaka','533468',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88399,266,'Silalanka','533463',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88400,266,'Siripuram','533260',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88401,266,'Siripuram','533432',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88402,266,'Somavaram','533435',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88403,266,'Sommannapalem','533428',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88404,266,'Sriramnagar (Kakinada)','533003',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88405,266,'Srungadhara Agraharam','533406',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88406,266,'Srungavruksham','533408',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88407,266,'Subhadrampeta','533291',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88408,266,'Surampalem','533437',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88409,266,'Surapurajupegta','533407',1,0,'2022-03-03 13:10:43','2022-03-03 13:10:43'),(88410,266,'Suryaraopeta','533001',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88411,266,'Tallarevu','533463',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88412,266,'Talluru','533401',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88413,266,'Talluru','533435',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88414,266,'Tamarada','533437',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88415,266,'Tarlampudi','533468',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88416,266,'Tatiparthi','533445',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88417,266,'Tetagunta','533406',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88418,266,'Thammavaram','533005',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88419,266,'Thantikonda','533436',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88420,266,'Thimmaparam','533005',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88421,266,'Thimmapuram','533406',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88422,266,'Thimmapuram','533428',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88423,266,'Thondangi','533408',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88424,266,'Thungamadugula','533428',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88425,266,'Tirumali','533429',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88426,266,'Tuni Old Bazar','533401',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88427,266,'Tuni','533401',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88428,266,'Turangi','533016',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88429,266,'Unduru','533434',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88430,266,'Uppada','533448',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88431,266,'Uppangala','533464',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88432,266,'Urlakulapadu','533436',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88433,266,'Uttarakanchi','533430',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88434,266,'V K Rayapuram','533434',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88435,266,'Vadlamuru','533437',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88436,266,'Vakada','533462',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88437,266,'Valasapakala','533005',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88438,266,'Vanchangi','533429',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88439,266,'Vathangi','533436',1,0,'2022-03-03 13:10:44','2022-03-03 13:10:44'),(88440,266,'Vattigadda','533436',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88441,266,'Vazrakutam','533444',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88442,266,'Veeravaram','533431',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88443,266,'Veeravaram','533483',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88444,266,'Velamakothuru','533401',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88445,266,'Velangi','533260',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88446,266,'Vemavaram','533401',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88447,266,'Vemulavada','533462',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88448,266,'Vendra','533344',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88449,266,'Vetamamidi','533428',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88450,266,'Vetlapalem','533434',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88451,266,'Vijayarayudupalem','533468',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88452,266,'Virava','533450',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88453,266,'Viravada','533450',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88454,266,'Vommangi','533430',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88455,266,'Vontimamidi','533408',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88456,266,'Y .Ramavaram','533483',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88457,266,'Yanamadala','533260',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88458,266,'Yandamuru','533468',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88459,266,'Yedurulanka','533464',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88460,266,'Yeleswaram','533429',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88461,266,'Yellavaram','533428',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88462,266,'Yeluru','533432',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88463,266,'Yendapalli','533447',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88464,266,'Yendapalli','533428',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88465,266,'Yerramreddypalem','533428',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88466,266,'Yerravaram','533435',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88467,266,'Z Ragampeta','533435',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88468,266,'Z.Bhavaram','533462',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88469,266,'Addampalli','533262',1,0,'2022-03-03 13:10:45','2022-03-03 13:10:45'),(88470,266,'Akuru','533288',1,0,'2022-03-03 13:10:46','2022-03-03 13:10:46'),(88471,266,'Alamuru (East Godavari)','533233',1,0,'2022-03-03 13:10:46','2022-03-03 13:10:46'),(88472,266,'Alcot Gardens','533101',1,0,'2022-03-03 13:10:46','2022-03-03 13:10:46'),(88473,266,'Amjuru','533305',1,0,'2022-03-03 13:10:46','2022-03-03 13:10:46'),(88474,266,'Amudalabanda','533284',1,0,'2022-03-03 13:10:46','2022-03-03 13:10:46'),(88475,266,'Anaparthy','533342',1,0,'2022-03-03 13:10:46','2022-03-03 13:10:46'),(88476,266,'Angara','533307',1,0,'2022-03-03 13:10:46','2022-03-03 13:10:46'),(88477,266,'APHB Colony','533106',1,0,'2022-03-03 13:10:46','2022-03-03 13:10:46'),(88478,266,'Arikarevula','533256',1,0,'2022-03-03 13:10:46','2022-03-03 13:10:46'),(88479,266,'Arthamuru','533340',1,0,'2022-03-03 13:10:46','2022-03-03 13:10:46'),(88480,266,'Aryapuram','533104',1,0,'2022-03-03 13:10:46','2022-03-03 13:10:46'),(88481,266,'Atchutapuram','533307',1,0,'2022-03-03 13:10:46','2022-03-03 13:10:46'),(88482,266,'Atchutapuram','533289',1,0,'2022-03-03 13:10:46','2022-03-03 13:10:46'),(88483,266,'B.Velamakota','533284',1,0,'2022-03-03 13:10:46','2022-03-03 13:10:46'),(88484,266,'Baduguvanilanka','533126',1,0,'2022-03-03 13:10:46','2022-03-03 13:10:46'),(88485,266,'Balabhadrapuram','533343',1,0,'2022-03-03 13:10:46','2022-03-03 13:10:46'),(88486,266,'Balantram','533263',1,0,'2022-03-03 13:10:46','2022-03-03 13:10:46'),(88487,266,'Bandapalli','533288',1,0,'2022-03-03 13:10:46','2022-03-03 13:10:46'),(88488,266,'Beerampalli','533288',1,0,'2022-03-03 13:10:46','2022-03-03 13:10:46'),(88489,266,'Bhatlapalika','533263',1,0,'2022-03-03 13:10:46','2022-03-03 13:10:46'),(88490,266,'Bhupatipalem','533285',1,0,'2022-03-03 13:10:46','2022-03-03 13:10:46'),(88491,266,'Bikkavolu','533343',1,0,'2022-03-03 13:10:46','2022-03-03 13:10:46'),(88492,266,'Bolagonda','533288',1,0,'2022-03-03 13:10:46','2022-03-03 13:10:46'),(88493,266,'Bolleddupalem','533290',1,0,'2022-03-03 13:10:46','2022-03-03 13:10:46'),(88494,266,'Bommuru','533124',1,0,'2022-03-03 13:10:46','2022-03-03 13:10:46'),(88495,266,'Burrilanka','533126',1,0,'2022-03-03 13:10:46','2022-03-03 13:10:46'),(88496,266,'Burugupudi','533292',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88497,266,'Busigudem','533288',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88498,266,'Butchampeta','533292',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88499,266,'Chakradwarabandham','533296',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88500,266,'Chatlawada','533295',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88501,266,'Chavadikota','533295',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88502,266,'Chelluru','533261',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88503,266,'Chinabhimpalli','533286',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88504,266,'Chinakondepudi','533287',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88505,266,'Chinaramanayyapeta','533339',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88506,266,'Chintaluru','533232',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88507,266,'Chodavaram','533256',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88508,266,'Choppakonda','533339',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88509,266,'Choppella','533234',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88510,266,'D.Velamakota','533288',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88511,266,'Danavaipeta','533103',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88512,266,'Dangeru','533263',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88513,266,'Devaram','533286',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88514,266,'Devipatnam','533339',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88515,266,'Dewancheruvu','533296',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88516,266,'Dorachintalapalem','533288',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88517,266,'Doramamidi','533284',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88518,266,'Dosakayapalli','533292',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88519,266,'Dowlaiswaram','533125',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88520,266,'Draksharamam','533262',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88521,266,'Duggudurru','533263',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88522,266,'Dulla','533234',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88523,266,'Dwarapudi','533341',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88524,266,'East Gonagudem','533294',1,0,'2022-03-03 13:10:47','2022-03-03 13:10:47'),(88525,266,'Fort Gate','533101',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88526,266,'Foulkspeta','533285',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88527,266,'G.Donthamuru','533294',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88528,266,'Gadala','533102',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88529,266,'Gadarada','533289',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88530,266,'Gadelapalem','533286',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88531,266,'Gandepalli','533297',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88532,266,'Gangampalem','533286',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88533,266,'Gangavaram','533305',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88534,266,'Gangavaram','533284',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88535,266,'Geddada','533288',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88536,266,'Ginnepalli','533288',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88537,266,'Gokaram','533286',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88538,266,'Goragummi','533284',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88539,266,'Government College (East Godavari)','533105',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88540,266,'GSL Medical College','533296',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88541,266,'Gujjumamidivalasa','533295',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88542,266,'Gummalladoddi','533289',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88543,266,'Gummileru','533232',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88544,266,'Hasanbada','533262',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88545,266,'Hukumpeta','533107',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88546,266,'I.Polavaram','533288',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88547,266,'Ilakolanu','533294',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88548,266,'Indukuru','533286',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88549,266,'Indukurupeta','533286',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88550,266,'Industrial Estate (East Godavari)','533124',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88551,266,'Ippanapadu','533340',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88552,266,'Ithapudi','533262',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88553,266,'Itikayalapalli','533290',1,0,'2022-03-03 13:10:48','2022-03-03 13:10:48'),(88554,266,'Jagannadhagiri','533262',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88555,266,'Jagannaiyakulapalem','533262',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88556,266,'Jaggampalem','533285',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88557,266,'Jambupatnam','533289',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88558,266,'Jegurupadu','533126',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88559,266,'Jonnada','533233',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88560,266,'Kadiyam','533126',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88561,266,'Kadiyapulanka','533126',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88562,266,'Kalavacherala','533297',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88563,266,'Kamarajupeta','533285',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88564,266,'Kanavaram','533296',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88565,266,'Kanupuru','533289',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88566,266,'Kapavaram','533262',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88567,266,'Kapavaram','533342',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88568,266,'Kapileswarapuram (East Godavari)','533309',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88569,266,'Katavaram','533293',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88570,266,'Kateru','533105',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88571,266,'Kesavaram','533341',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88572,266,'Kolamuru','533102',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88573,266,'Komaripalem','533346',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88574,266,'Kondagunturu','533124',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88575,266,'Konkuduru','533345',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88576,266,'Konthamuru','533102',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88577,266,'Koppavaram','533346',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88578,266,'Korukonda','533289',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88579,266,'Korumilli','533309',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88580,266,'Kota','533306',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88581,266,'Kothada','533284',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88582,266,'Kothapalli (East Godavari)','533285',1,0,'2022-03-03 13:10:49','2022-03-03 13:10:49'),(88583,266,'Kothuru','533256',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88584,266,'Koti','533290',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88585,266,'Kotikesavaram','533290',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88586,266,'Kotipalli','533306',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88587,266,'Kudupuru','533263',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88588,266,'Kulla','533305',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88589,266,'Kunavaram','533289',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88590,266,'Kundada','533295',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88591,266,'Kunduru','533262',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88592,266,'Kurmapuram','533256',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88593,266,'Kutrawada','533295',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88594,266,'Kutukuluru','533264',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88595,266,'Kuyyeru','533263',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88596,266,'Lakkonda','533284',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88597,266,'Laxminarasapuram','533342',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88598,266,'Lolla','533346',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88599,266,'Machara','533309',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88600,266,'Madhavarayudupalem','533126',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88601,266,'Madhurapudi','533102',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88602,266,'Madicherla','533288',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88603,266,'Madiki','533126',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88604,266,'Mahendrawada','533342',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88605,266,'Mallavaram','533285',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88606,266,'Mandapeta Bazar','533308',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88607,266,'Mandapeta','533308',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88608,266,'Manturu','533339',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88609,266,'Maredubaka','533308',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88610,266,'Maredumilli','533295',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88611,266,'Marriwada','533288',1,0,'2022-03-03 13:10:50','2022-03-03 13:10:50'),(88612,266,'Masakapalli','533263',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88613,266,'Matsavaram','533261',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88614,266,'Mirthipadu','533293',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88615,266,'Modukuru','533232',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88616,266,'Molleru','533285',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88617,266,'Muchimilli','533256',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88618,266,'Muggulla','533287',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88619,266,'Mukkinada','533342',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88620,266,'Mulakallanka','533293',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88621,266,'Mulastanam','533233',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88622,266,'Munagala','533289',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88623,266,'Munikodali','533293',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88624,266,'Muramanda','533126',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88625,266,'Murari','533297',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88626,266,'Musurumilli','533288',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88627,266,'N.T.Rajapuram','533297',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88628,266,'Nalluru','533307',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88629,266,'Nandarada','533292',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88630,266,'Narasapuram','533285',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88631,266,'Narasapurapupeta','533256',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88632,266,'Narasimhapuram','533289',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88633,266,'Narendrapuram','533294',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88634,266,'Narsipudi','533232',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88635,266,'Nelaparthipadu','533262',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88636,266,'Nelaturu','533308',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88637,266,'Nellipudi','533285',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88638,266,'Nidigatla','533102',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88639,266,'Palacherla','533102',1,0,'2022-03-03 13:10:51','2022-03-03 13:10:51'),(88640,266,'Palathodu','533340',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88641,266,'Palem','533288',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88642,266,'Pallakadiyam','533294',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88643,266,'Pamarru (East Godavari)','533305',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88644,266,'Pamugandi','533288',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88645,266,'Panangipalli','533305',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88646,266,'Pandalapaka','533345',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88647,266,'Pasalapudi','533261',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88648,266,'Pathatungapadu','533341',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88649,266,'Pedapalla','533232',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88650,266,'Pedaparthi','533264',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88651,266,'Pekeru','533263',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88652,266,'Peketipakalu','533340',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88653,266,'Penikeru','533232',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88654,266,'Penumalla','533262',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88655,266,'Peraramachandrapuram','533342',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88656,266,'Pidathamamidi','533285',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88657,266,'Pidimgoyya','533107',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88658,266,'Pinapalla','533232',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88659,266,'Polamuru','533342',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88660,266,'Pottilanka','533126',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88661,266,'Prakasamnagar','533106',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88662,266,'Pudipalli','533339',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88663,266,'Pulagurtha','533261',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88664,266,'Pullangi','533295',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88665,266,'Punyakshetram','533107',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88666,266,'Purushottapatnam','533287',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88667,266,'Radheyapalem','533341',1,0,'2022-03-03 13:10:52','2022-03-03 13:10:52'),(88668,266,'Raghavapuram','533290',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88669,266,'Raghudevapuram','533287',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88670,266,'Rajahmundry H.O','533101',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88671,266,'Rajanagaram','533294',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88672,266,'Rajavolu','533124',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88673,266,'Ramachandrapuram','533287',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88674,266,'Ramachandrapuram H.O','533255',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88675,266,'Ramachandrapuram Old Town','533256',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88676,266,'Ramadasupeta','533102',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88677,266,'Ramakrishna Nagar','533101',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88678,266,'Ramaswamipeta','533294',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88679,266,'Ramavaram','533264',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88680,266,'Rampa','533288',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88681,266,'Rampachodavaram','533288',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88682,266,'Rampayerrampalem','533286',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88683,266,'Rangapuram','533343',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88684,266,'Rayavaram (East Godavari)','533346',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88685,266,'Rtc Bus Complex Centre','533103',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88686,266,'Sandhipudi','533232',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88687,266,'Sarabhavaram','533286',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88688,266,'Sarangadarametta','533105',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88689,266,'Satellite City','533107',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88690,266,'Satyavada','533305',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88691,266,'Seethanagaram','533234',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88692,266,'Seethapalli','533288',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88693,266,'Singampalli','533343',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88694,266,'Singarampalem','533297',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88695,266,'Sithanagaram','533287',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88696,266,'Sivala','533262',1,0,'2022-03-03 13:10:53','2022-03-03 13:10:53'),(88697,266,'Someswaram','533261',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88698,266,'Soorampalem','533285',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88699,266,'Spinning Mills Centre','533106',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88700,266,'Srikrishnapatnam','533296',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88701,266,'Sriramnagar(Rajahmundry)','533105',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88702,266,'Srirampuram','533296',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88703,266,'Srirangapatnam','533289',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88704,266,'Sundarapalli','533306',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88705,266,'Sunnampadu','533288',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88706,266,'Syamalamba Temple','533101',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88707,266,'Syamalanagar','533103',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88708,266,'Tadepalle','533288',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88709,266,'Tallapolam','533256',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88710,266,'Tamarapalli','533305',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88711,266,'Tamarapalli','533288',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88712,266,'Tantikonda','533286',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88713,266,'Tapeswaram','533340',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88714,266,'Tatapudi','533309',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88715,266,'Tatiwada','533288',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88716,266,'Teki','533307',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88717,266,'Tirumalayapalem','533286',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88718,266,'Tokada','533296',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88719,266,'Torredu','533293',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88720,266,'Trunk Road Junction','533105',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88721,266,'Tunnuru','533288',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88722,266,'Utla','533284',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88723,266,'V.Ramannapalem','533339',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88724,266,'Vadapalli','533288',1,0,'2022-03-03 13:10:54','2022-03-03 13:10:54'),(88725,266,'Vadisaleru','533294',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88726,266,'Vakatippa','533305',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88727,266,'Valluru','533308',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88728,266,'Vangalapudi','533287',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88729,266,'Vedurumudi','533307',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88730,266,'Vedurupaka','533345',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88731,266,'Vedurupaka','533289',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88732,266,'Vedurupakasavaram','533346',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88733,266,'Veerampalem','533294',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88734,266,'Veeravaram','533126',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88735,266,'Vegayampeta','533262',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88736,266,'Velagathodu','533340',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88737,266,'Velampalem','533262',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88738,266,'Vella','533256',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88739,266,'Velugubanda','533294',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88740,266,'Vemagiri','533125',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88741,266,'Vemulukonda','533288',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88742,266,'Venkatanagaram','533105',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88743,266,'Venkatayapalem','533262',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88744,266,'Venturu','533256',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88745,266,'Vetukuru','533295',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88746,266,'Visranthipuram','533102',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88747,266,'Vulapalli','533343',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88748,266,'Vullithota','533101',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88749,266,'Weavers Colony','533105',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88750,266,'Yandagandi','533305',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88751,266,'Yeditha','533234',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88752,266,'Z.Medapadu','533341',1,0,'2022-03-03 13:10:55','2022-03-03 13:10:55'),(88753,267,'A.T.Agraharam(Guntur)','522004',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88754,267,'Abbarajupalem','522237',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88755,267,'Abbineniguntapalem','522015',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88756,267,'Ainavolu','522237',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88757,267,'Amaravathi Road(Guntur)','522007',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88758,267,'Amaravathi','522020',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88759,267,'Anantavaram','522236',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88760,267,'Ananthavarappadu','522017',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88761,267,'Anaparru','522235',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88762,267,'Ankireddypalem','522005',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88763,267,'Appapuram','522112',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88764,267,'Apsp Colony(Mangalagiri)','522503',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88765,267,'Atmakuru','522302',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88766,267,'Ballukanudivari Palem','522112',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88767,267,'Bandarupalle','522018',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88768,267,'Bejathpuram','522018',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88769,267,'Bethapudi','522502',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88770,267,'Borupalem','522237',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88771,267,'Brodipet(Guntur)','522002',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88772,267,'Budampadu','522017',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88773,267,'Bus Stand(Guntur)','522001',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88774,267,'Chamallamudi','522017',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88775,267,'Chandramoulinagar','522007',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88776,267,'Chinakakani','522508',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88777,267,'Chinapalem','522305',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88778,267,'Chintapallipadu','522017',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88779,267,'Chirravuru','522303',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88780,267,'Choutra(Guntur)','522003',1,0,'2022-03-03 13:10:56','2022-03-03 13:10:56'),(88781,267,'Chowdaripeta(Guntur)','522006',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88782,267,'Chowdavaram','522019',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88783,267,'College Road(Guntur)','522001',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88784,267,'Damarapalle','522018',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88785,267,'Dharanikota','522020',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88786,267,'Didugu','522020',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88787,267,'Dondapadu','522237',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88788,267,'Donka Road(Guntur)','522002',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88789,267,'Enamadala','522019',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88790,267,'Endroy','522016',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88791,267,'Etukuru Road(Guntur)','522003',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88792,267,'Etukuru','522017',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88793,267,'Factories Ward','522003',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88794,267,'Ganikapudi','522019',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88795,267,'Garapadu','522017',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88796,267,'Garikapadu','522018',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88797,267,'Garikapadu','522112',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88798,267,'Garlapadu','522235',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88799,267,'Godavarru Agraharam','522305',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88800,267,'Gogulamudi','522015',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88801,267,'Gollamudi','522509',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88802,267,'Gorantla','522034',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88803,267,'Gorlavaripalem','522018',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88804,267,'Gottipadu','522019',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88805,267,'Govt. General Hospital','522001',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88806,267,'Gundimeda','522303',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88807,267,'Guntur Bazar','522003',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88808,267,'Guntur Collectorate','522004',1,0,'2022-03-03 13:10:57','2022-03-03 13:10:57'),(88809,267,'Guntur H.O','522002',1,0,'2022-03-03 13:10:58','2022-03-03 13:10:58'),(88810,267,'Guntur Medical College','522004',1,0,'2022-03-03 13:10:58','2022-03-03 13:10:58'),(88811,267,'Harischandrapuram','522020',1,0,'2022-03-03 13:10:58','2022-03-03 13:10:58'),(88812,267,'Industrial Estate (Guntur)','522034',1,0,'2022-03-03 13:10:58','2022-03-03 13:10:58'),(88813,267,'Ippatam','522302',1,0,'2022-03-03 13:10:58','2022-03-03 13:10:58'),(88814,267,'Jonnalagadda','522034',1,0,'2022-03-03 13:10:58','2022-03-03 13:10:58'),(88815,267,'K.C.Works','522502',1,0,'2022-03-03 13:10:58','2022-03-03 13:10:58'),(88816,267,'Kakumanu','522112',1,0,'2022-03-03 13:10:58','2022-03-03 13:10:58'),(88817,267,'Kanteru','522508',1,0,'2022-03-03 13:10:58','2022-03-03 13:10:58'),(88818,267,'Karlapudi','522016',1,0,'2022-03-03 13:10:58','2022-03-03 13:10:58'),(88819,267,'Katrapadu','522017',1,0,'2022-03-03 13:10:58','2022-03-03 13:10:58'),(88820,267,'Katrapadu','522235',1,0,'2022-03-03 13:10:58','2022-03-03 13:10:58'),(88821,267,'Kaza','522508',1,0,'2022-03-03 13:10:58','2022-03-03 13:10:58'),(88822,267,'Kolanukonda','522302',1,0,'2022-03-03 13:10:58','2022-03-03 13:10:58'),(88823,267,'Kommuru','522235',1,0,'2022-03-03 13:10:58','2022-03-03 13:10:58'),(88824,267,'Kondapaturu','522112',1,0,'2022-03-03 13:10:58','2022-03-03 13:10:58'),(88825,267,'Kondepadu','522019',1,0,'2022-03-03 13:10:58','2022-03-03 13:10:58'),(88826,267,'Kopparru','522015',1,0,'2022-03-03 13:10:58','2022-03-03 13:10:58'),(88827,267,'Koppuravuru','522508',1,0,'2022-03-03 13:10:58','2022-03-03 13:10:58'),(88828,267,'Koritepadu(Guntur)','522007',1,0,'2022-03-03 13:10:58','2022-03-03 13:10:58'),(88829,267,'Kornepadu','522017',1,0,'2022-03-03 13:10:58','2022-03-03 13:10:58'),(88830,267,'Kothapeta(Guntur)','522001',1,0,'2022-03-03 13:10:58','2022-03-03 13:10:58'),(88831,267,'Koyavaripalem','522019',1,0,'2022-03-03 13:10:58','2022-03-03 13:10:58'),(88832,267,'Krishnayapalem','522502',1,0,'2022-03-03 13:10:58','2022-03-03 13:10:58'),(88833,267,'Kunchanapalle','522501',1,0,'2022-03-03 13:10:58','2022-03-03 13:10:58'),(88834,267,'Kuragallu','522502',1,0,'2022-03-03 13:10:58','2022-03-03 13:10:58'),(88835,267,'Kurnuthala','522017',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88836,267,'L.W.Works(Guntur)','522007',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88837,267,'Lalpuram','522017',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88838,267,'Lam Ars','522034',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88839,267,'Lam','522034',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88840,267,'Latchannagudipudi','522016',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88841,267,'Layola Nagar','522005',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88842,267,'Lemalle','522016',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88843,267,'Malladi','522020',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88844,267,'Mallayapalem','522019',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88845,267,'Mandadam','522237',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88846,267,'Mandepudi','522018',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88847,267,'Mangalagiri Bazar','522503',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88848,267,'Mangalagiri Busstand','522503',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88849,267,'Mangalagiri H.O','522503',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88850,267,'Mellempudi','522303',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88851,267,'Mothadaka','522016',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88852,267,'Mukkamala','522016',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88853,267,'Municipal Office(Guntur)','522003',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88854,267,'Muthayapalem','522020',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88855,267,'Nadimpalem','522019',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88856,267,'Nagarjuna Nagar','522510',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88857,267,'Nagualapadu','522235',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88858,267,'Nallapadu','522005',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88859,267,'Namburu','522508',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88860,267,'Narukullapadu','522016',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88861,267,'Navuluru','522502',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88862,267,'Neerukonda','522502',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88863,267,'Nehru Nagar(Guntur)','522001',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88864,267,'Nekkallu','522236',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88865,267,'Nelapadu','522237',1,0,'2022-03-03 13:10:59','2022-03-03 13:10:59'),(88866,267,'Nevalikallu','522016',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88867,267,'Nidamarru','522502',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88868,267,'Nidumukkala','522016',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88869,267,'Nimmagaddavaripalem','522019',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88870,267,'Nutakki','522303',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88871,267,'Old Guntur','522001',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88872,267,'Old Mangalagiri','522503',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88873,267,'Palaparru','522235',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88874,267,'Pallapadu','522017',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88875,267,'Pamulapadu','522018',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88876,267,'Pathuru','522509',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88877,267,'Pattabhipuram(Guntur)','522006',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88878,267,'Pedakakani','522509',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88879,267,'Pedakonduru','522305',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88880,267,'Pedamadduru','522020',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88881,267,'Pedanandipadu','522235',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88882,267,'Pedapalakaluru','522009',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88883,267,'Pedapalem','522112',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88884,267,'Pedapalem','522305',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88885,267,'Pedaparimi','522236',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88886,267,'Pedavadlapudi','522302',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88887,267,'Penumaka','522501',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88888,267,'Perecherla','522009',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88889,267,'Perecherla Junction','522009',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88890,267,'Perikalapudi','522305',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88891,267,'Polakampadu Ind. Area','522501',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88892,267,'Ponnekallu','522018',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88893,267,'Pothuru','522005',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88894,267,'Prathipadu (Guntur)','522019',1,0,'2022-03-03 13:11:00','2022-03-03 13:11:00'),(88895,267,'Prathuru','522501',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88896,267,'Pusuluru','522235',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88897,267,'Railpet(Guntur)','522001',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88898,267,'Rajupalem','522235',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88899,267,'Ramayalam','522501',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88900,267,'Ravela','522018',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88901,267,'Ravipadu','522015',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88902,267,'Rayapudi','522237',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88903,267,'Reddypalem','522509',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88904,267,'Revendrapadu','522302',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88905,267,'S.K.P.Temple(Guntur)','522003',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88906,267,'S.V.N.Colony(Guntur)','522006',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88907,267,'Sakhamuru','522237',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88908,267,'Srungarapuram','522305',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88909,267,'T.B.Sanitorium','522502',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88910,267,'Tadepalle','522501',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88911,267,'Tadikonda','522236',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88912,267,'Takkellapadu','522509',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88913,267,'Tikkireddyvaripalem','522019',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88914,267,'Tobacco Colony(Guntur)','522001',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88915,267,'Trunk Road(Guntur)','522004',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88916,267,'Tulluru','522237',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88917,267,'Undavalli','522501',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88918,267,'Uppalapadu','522509',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88919,267,'Vaddamanu','522236',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88920,267,'Vaddeswaram','522302',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88921,267,'Vangipuram','522015',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88922,267,'Varagani','522235',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88923,267,'Veerlapalem','522305',1,0,'2022-03-03 13:11:01','2022-03-03 13:11:01'),(88924,267,'Velagapudi','522237',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88925,267,'Vengalayapalem','522005',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88926,267,'Venigandla','522509',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88927,267,'Venkatakrishnapuram','522509',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88928,267,'Venkatapalem','522237',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88929,267,'Venugopalanagar Colony','522004',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88930,267,'Vinjanampadu','522017',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88931,267,'Vunguturu','522016',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88932,267,'Vykuntapuram','522020',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88933,267,'Yamarru','522017',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88934,267,'Yerrabalem','522502',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88935,267,'Abburu','522402',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88936,267,'Adigoppula','522612',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88937,267,'Agnigundala','522647',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88938,267,'Ainavole','522659',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88939,267,'Alavala','522617',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88940,267,'Ambapuram','522415',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88941,267,'Ameenabad','522529',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88942,267,'Ananthavaram','522410',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88943,267,'Andugula Kothapalem','522647',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88944,267,'Andukuru','522410',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88945,267,'Angaluru','522658',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88946,267,'Annavaram','522603',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88947,267,'Annavaram','522616',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88948,267,'Annavarappadu','522617',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88949,267,'Appapuram','522611',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88950,267,'Arundalpet (NSV)','522601',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88951,267,'Atchampet','522409',1,0,'2022-03-03 13:11:02','2022-03-03 13:11:02'),(88952,267,'Atmakuru','522612',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88953,267,'Attaluru','522436',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88954,267,'Balemarru','522410',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88955,267,'Balijepalle','522412',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88956,267,'Balusupadu','522436',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88957,267,'Bandlamottu','522663',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88958,267,'Bayyavaram','522402',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88959,267,'Bellamkonda','522411',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88960,267,'Bethapudi','522549',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88961,267,'Bhatluru','522402',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88962,267,'Bhimavaram','522402',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88963,267,'Bhrugubanda','522412',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88964,267,'Bodanam','522411',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88965,267,'Bodilaveedu','522613',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88966,267,'Bollavaram','522408',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88967,267,'Bommarajupalle','522658',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88968,267,'Boppudi','522626',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88969,267,'Brahmanapalle','522647',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88970,267,'Brahmanapalle','522437',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88971,267,'Butchipapannapalem','522661',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88972,267,'Chagallu','522603',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88973,267,'Challagariga','522409',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88974,267,'Chamarru','522409',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88975,267,'Chandavaram','522549',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88976,267,'Chandrajupalem','522411',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88977,267,'Chatragaddapadu','522647',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88978,267,'Cheekateegalapalem','522647',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88979,267,'Cheemalamarri','522615',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88980,267,'Chejerla','522615',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88981,267,'Chennayapalem','522435',1,0,'2022-03-03 13:11:03','2022-03-03 13:11:03'),(88982,267,'Cherlagudipadu','522415',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(88983,267,'Cheruvukommupalem','522659',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(88984,267,'Chilakaluripet Bazar','522616',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(88985,267,'Chilakaluripet','522616',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(88986,267,'China Garlapadu','522437',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(88987,267,'Chinaagraharam','522437',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(88988,267,'Chinakancherla','522649',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(88989,267,'Chinakodamagundla','522614',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(88990,267,'Chintalacheruvu','522659',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(88991,267,'Chintapalle','522614',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(88992,267,'Chintapalle','522409',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(88993,267,'Chirumamilla','522234',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(88994,267,'Chittapuram','522658',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(88995,267,'Chityala','522411',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(88996,267,'Chityala Thanda','522411',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(88997,267,'Chowtapapayapalem','522411',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(88998,267,'Dachpalle','522414',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(88999,267,'Daida','522415',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(89000,267,'Dammalapadu','522408',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(89001,267,'Dharmavaram','522612',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(89002,267,'Dhulipalla','522412',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(89003,267,'Dodleru','522410',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(89004,267,'Domalagundam','522663',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(89005,267,'Dondapadu','522549',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(89006,267,'Dondapadu','522647',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(89007,267,'Durgi','522612',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(89008,267,'Edavalli','522616',1,0,'2022-03-03 13:11:04','2022-03-03 13:11:04'),(89009,267,'Edlapadu','522233',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89010,267,'Ellamanda','522549',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89011,267,'Emmajigudem','522411',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89012,267,'Endugumpalem','522549',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89013,267,'Enugupalem','522649',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89014,267,'Gadevaripalle','522614',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89015,267,'Gamalapadu','522414',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89016,267,'Ganapavaram','522412',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89017,267,'Ganapavaram (Guntur)','522619',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89018,267,'Gandhi Chowk (Guntur)','522403',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89019,267,'Gandiganumala','522663',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89020,267,'Gangannapalem','522611',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89021,267,'Gangavaram','522415',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89022,267,'Gannavaram','522426',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89023,267,'Garapadu','522402',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89024,267,'Garikapadu','522614',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89025,267,'Gogulapadu','522617',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89026,267,'Gogulapadu','522414',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89027,267,'Gokanakonda','522649',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89028,267,'Goli','522421',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89029,267,'Gonepudi','522611',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89030,267,'Gopalamvaripalem','522626',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89031,267,'Gorizavole','522549',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89032,267,'Gottimukkala','522415',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89033,267,'Gottipadu','522616',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89034,267,'Gottipalla','522613',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89035,267,'Govindapuram','522611',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89036,267,'Grandhasiri','522410',1,0,'2022-03-03 13:11:05','2022-03-03 13:11:05'),(89037,267,'Gudipadu','522410',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89038,267,'Gudipudi','522402',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89039,267,'Gummanampadu','522614',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89040,267,'Gundalapadu','522613',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89041,267,'Gundalapadu','522549',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89042,267,'Gundepalle','522658',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89043,267,'Gundlapalle','522615',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89044,267,'Guravayapalem','522549',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89045,267,'Gurazalla','522415',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89046,267,'Gutlapalle','522657',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89047,267,'Guttikonda','522413',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89048,267,'Hassannabad','522411',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89049,267,'Hassannayunipalem','522649',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89050,267,'Hussainnagaram','522402',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89051,267,'Ikkurru','522603',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89052,267,'Inumella','522661',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89053,267,'Inumetla','522615',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89054,267,'Ipuru','522658',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89055,267,'Irlapadu','522611',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89056,267,'Jaggapuram','522233',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89057,267,'Jaladi','522233',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89058,267,'Jalalapalem','522647',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89059,267,'Jalalapuram','522436',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89060,267,'Janapadu','522413',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89061,267,'Jangalapalle','522647',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89062,267,'Jangamaheswarapuram','522415',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89063,267,'Jettipalem','522421',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89064,267,'Jonnalagadda','522549',1,0,'2022-03-03 13:11:06','2022-03-03 13:11:06'),(89065,267,'Jupudi','522436',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89066,267,'Kakani','522603',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89067,267,'Kakirala','522612',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89068,267,'Kambhampadu','522436',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89069,267,'Kambhampadu','522660',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89070,267,'Kambhampadu','522426',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89071,267,'Kammavaripalem','522611',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89072,267,'Kanaparru','522549',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89073,267,'Kandlagunta','522613',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89074,267,'Kandlagunta','522603',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89075,267,'Kandrika','522529',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89076,267,'Kandrika','522657',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89077,267,'Kandulavaripalem','522412',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89078,267,'Kankanalapalle','522412',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89079,267,'Kanumalacheruvu','522657',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89080,267,'Kanumarlapudi','522646',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89081,267,'Karalapadu','522437',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89082,267,'Karempudi','522614',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89083,267,'Karlakunta','522615',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89084,267,'Karuchola','522233',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89085,267,'Karumanchi','522646',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89086,267,'Kasipadu','522436',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89087,267,'Kastala','522410',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89088,267,'Kattamuru','522402',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89089,267,'Kattavaripalem','522438',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89090,267,'Kattubadivaripalem','522611',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89091,267,'Kavuru','522611',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89092,267,'Kesanapalle','522414',1,0,'2022-03-03 13:11:07','2022-03-03 13:11:07'),(89093,267,'Kesanapalle','522549',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89094,267,'Kogantivaripalem','522409',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89095,267,'Kolagutla','522612',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89096,267,'Kolluru','522411',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89097,267,'Komaravallipadu','522616',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89098,267,'Komerapudi','522438',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89099,267,'Konakanchivaripalem','522617',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89100,267,'Konanki','522413',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89101,267,'Kondaveedu','522529',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89102,267,'Kondayapalem','522658',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89103,267,'Kondramutla','522647',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89104,267,'Konduru','522410',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89105,267,'Konuru','522410',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89106,267,'Koppukonda','522647',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89107,267,'Koppunuru','522426',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89108,267,'Korrapadu','522438',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89109,267,'Kotanemalipuri','522413',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89110,267,'Kotcherla','522647',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89111,267,'Kothaganesunipadu','522413',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89112,267,'Kothaluru','522646',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89113,267,'Kothapalem','522435',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89114,267,'Kothapalle','522426',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89115,267,'Kothapalle','522409',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89116,267,'Kothapalle','522615',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89117,267,'Kothapet(VKD)','522647',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89118,267,'Kothapullareddipuram','522613',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89119,267,'Kotturu','522426',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89120,267,'Krosuru','522410',1,0,'2022-03-03 13:11:08','2022-03-03 13:11:08'),(89121,267,'Kubadpuram','522413',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89122,267,'Kunduruvaripalem','522408',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89123,267,'Kunkalagunta','522615',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89124,267,'Lagadapadu','522402',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89125,267,'Lakkarajugarlapadu','522529',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89126,267,'Lankalakurapadu','522408',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89127,267,'Latchambhavi','522613',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89128,267,'Lingamguntla  Agraharam','522603',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89129,267,'Lingamguntla','522402',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89130,267,'Lingamukkapalle','522659',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89131,267,'Lingapuram','522436',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89132,267,'Lingaraopalem','522234',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89133,267,'Machavaram','522615',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89134,267,'Machavaram (Narasaraopet)','522435',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89135,267,'Machayapalem','522411',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89136,267,'Macherla (Guntur)','522426',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89137,267,'Madala','522408',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89138,267,'Maddirala','522616',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89139,267,'Madinapadu','522414',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89140,267,'Madipadu','522409',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89141,267,'Madugula','522415',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89142,267,'Manchikallu','522421',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89143,267,'Mandadi','522426',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89144,267,'Mandapadu','522401',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89145,267,'Manukondavaripalem','522616',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89146,267,'Marripalem','522614',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89147,267,'Mathukumalli','522646',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89148,267,'Medikonduru','522438',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89149,267,'Mellavagu','522614',1,0,'2022-03-03 13:11:09','2022-03-03 13:11:09'),(89150,267,'Merikapudi','522549',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89151,267,'Miriyala','522415',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89152,267,'Mittagudipadu','522421',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89153,267,'Mokkapadu','522412',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89154,267,'Morjampadu','522413',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89155,267,'Mugachintalapalem','522663',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89156,267,'Mukkellapadu','522659',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89157,267,'Mulakaluru','522660',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89158,267,'Mulakaluru','522603',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89159,267,'Munagapadu','522549',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89160,267,'Munugodu','522402',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89161,267,'Muppalla (Guntur)','522408',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89162,267,'Muppalla(VKD)','522661',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89163,267,'Mupparajuvaripalem','522660',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89164,267,'Murikipudi','522626',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89165,267,'Murthuzapuram','522659',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89166,267,'Mutukuru','522612',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89167,267,'Mutyalampadu','522414',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89168,267,'N.S.C.Colony','522601',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89169,267,'Nadendla','522234',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89170,267,'Nadigadda','522647',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89171,267,'Nadikudi','522414',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89172,267,'Nagavaram','522412',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89173,267,'Nagireddipalle','522659',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89174,267,'Nagulavaram','522649',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89175,267,'Nagulavaram','522426',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89176,267,'Naidupalem','522657',1,0,'2022-03-03 13:11:10','2022-03-03 13:11:10'),(89177,267,'Nandigama','522402',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11'),(89178,267,'Narasaraopet Bazar','522601',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11'),(89179,267,'Narasaraopet H.O','522601',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11'),(89180,267,'Narasimhapuri','522614',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11'),(89181,267,'Narasingapadu','522615',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11');
INSERT INTO `cities` VALUES (89182,267,'Narmalapadu','522612',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11'),(89183,267,'Narnepadu','522408',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11'),(89184,267,'Nekarikallu','522615',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11'),(89185,267,'Nemalipuri','522413',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11'),(89186,267,'Nirmalanagar','522647',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11'),(89187,267,'NSP Colony','522647',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11'),(89188,267,'Nudurupadu','522529',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11'),(89189,267,'Nuzendla','522660',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11'),(89190,267,'Obulesunipalle','522612',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11'),(89191,267,'Pakalapadu','522410',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11'),(89192,267,'Paladugu','522401',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11'),(89193,267,'Palapadu','522603',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11'),(89194,267,'Pallegunta','522415',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11'),(89195,267,'Paludevarlapadu','522408',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11'),(89196,267,'Paluvai','522421',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11'),(89197,267,'Pamidimarru','522549',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11'),(89198,267,'Pamidipadu Agraharam','522603',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11'),(89199,267,'Pamidipadu','522660',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11'),(89200,267,'Panditivaripalem','522413',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11'),(89201,267,'Panidem','522402',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11'),(89202,267,'Papayapalem','522411',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11'),(89203,267,'Parastyalluru','522436',1,0,'2022-03-03 13:11:11','2022-03-03 13:11:11'),(89204,267,'Pasarlapadu','522421',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89205,267,'Pasivemula','522426',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89206,267,'Pasumarru','522616',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89207,267,'Pathakothapalem','522660',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89208,267,'Patibandla','522402',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89209,267,'Patlaveedu','522612',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89210,267,'Pedagarlapadu','522437',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89211,267,'Pedakancherla','522649',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89212,267,'Pedakodamagundla','522614',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89213,267,'Pedakurapadu','522402',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89214,267,'Pedamakkena','522402',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89215,267,'Pedapalem','522410',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89216,267,'Peesapadu','522410',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89217,267,'Perikapadu Thanda','522411',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89218,267,'Perurupadu','522657',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89219,267,'Petasannegandla','522614',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89220,267,'Petlurivaripalem','522603',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89221,267,'Phirangipuram','522529',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89222,267,'Piduguralla','522413',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89223,267,'Pillutla','522413',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89224,267,'Pinnelli','522435',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89225,267,'Pitchikalapalem','522649',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89226,267,'Pittambanda','522649',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89227,267,'Polepalle','522612',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89228,267,'Pondugula','522414',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89229,267,'Ponugupadu','522549',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89230,267,'Pothavaram','522616',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89231,267,'Potluru','522646',1,0,'2022-03-03 13:11:12','2022-03-03 13:11:12'),(89232,267,'Prakashnagar','522601',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89233,267,'Pulipadu','522415',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89234,267,'Purushothapatnam','522616',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89235,267,'Puvvada','522660',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89236,267,'PWD Colony','522426',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89237,267,'Rajapeta','522626',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89238,267,'Rajupalem (Guntur)','522412',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89239,267,'Ramapuram','522414',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89240,267,'Ramireddipalem','522617',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89241,267,'Ramudipalem','522660',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89242,267,'Ravipadu (Guntur)','522603',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89243,267,'Ravulapuram','522663',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89244,267,'Ravvavaram','522660',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89245,267,'Rayavaram','522426',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89246,267,'Reddigudem','522412',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89247,267,'Reddipalem','522660',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89248,267,'Reddipalem','522603',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89249,267,'Remidicherla','522663',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89250,267,'Rentachintala','522421',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89251,267,'Rentala','522421',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89252,267,'Rentapalla','522410',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89253,267,'Rompicherla (Guntur)','522617',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89254,267,'Rudravaram','522408',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89255,267,'Rupenagunta','522603',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89256,267,'Sanampudi','522646',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89257,267,'Sandepudi','522619',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89258,267,'Sankarapuram','522614',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89259,267,'Sankurathripadu','522549',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89260,267,'Santhagudipadu','522615',1,0,'2022-03-03 13:11:13','2022-03-03 13:11:13'),(89261,267,'Sarangapalle','522414',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89262,267,'Sattenapalle H.O','522403',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89263,267,'Satuluru','522549',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89264,267,'Savalyapuram','522646',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89265,267,'Singhiskhanpet','522529',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89266,267,'Sirigiripadu','522613',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89267,267,'Siripuram (Guntur)','522401',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89268,267,'Sitarampuram Mines','522413',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89269,267,'Sivapuram','522647',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89270,267,'Solasa','522234',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89271,267,'Srinagar','522414',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89272,267,'Subbaiah Thota','522616',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89273,267,'Syamarajapuram','522612',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89274,267,'Taduvai','522409',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89275,267,'Takkellapadu','522438',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89276,267,'Talarlapalle','522660',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89277,267,'Tallacheruvu','522409',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89278,267,'Tallapalle','522426',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89279,267,'Talluru','522529',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89280,267,'Talluru','522410',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89281,267,'Tammavaram','522436',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89282,267,'Tangeda','522414',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89283,267,'Tatapudi','522626',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89284,267,'Tellabadu','522647',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89285,267,'Thimmapuram','522233',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89286,267,'Thimmareddipuram','522439',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89287,267,'Thimmayapalem','522647',1,0,'2022-03-03 13:11:14','2022-03-03 13:11:14'),(89288,267,'Tondapi','522412',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89289,267,'Tsallagundla','522615',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89290,267,'Tubadu','522234',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89291,267,'Tummalacheruvu','522437',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89292,267,'Tummercode','522421',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89293,267,'Turakapalem','522438',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89294,267,'Turkapalem','522408',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89295,267,'Turlapadu','522619',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89296,267,'Turumella','522617',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89297,267,'Udjerla','522658',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89298,267,'Unnava','522233',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89299,267,'Uppalapadu','522615',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89300,267,'Uppalapadu','522603',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89301,267,'Uppalapadu','522616',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89302,267,'Uppalapadu','522613',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89303,267,'Vaddemgunta','522657',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89304,267,'Vadlamudivaripalem','522617',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89305,267,'Vanikunta','522658',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89306,267,'Vankayalapadu','522233',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89307,267,'Vannayapalem','522411',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89308,267,'Varagani','522401',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89309,267,'Vayyakallu','522646',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89310,267,'Veerapuram','522437',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89311,267,'Velampalle','522435',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89312,267,'Velavarthipadu','522438',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89313,267,'Veldurthy','522613',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89314,267,'Vellatur','522657',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89315,267,'Velpuru','522410',1,0,'2022-03-03 13:11:15','2022-03-03 13:11:15'),(89316,267,'Velpuru','522646',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89317,267,'Veluru','522619',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89318,267,'Vemavaram','522435',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89319,267,'Vemavaram','522529',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89320,267,'Venkatayapalem','522411',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89321,267,'Vetrayuni Appapuram','522660',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89322,267,'Vijayapuri South','522439',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89323,267,'Vinukonda','522647',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89324,267,'Vipparla','522615',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89325,267,'Vipparla','522410',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89326,267,'Vipparlapalle','522603',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89327,267,'Visadala','522438',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89328,267,'Voppicherla','522614',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89329,267,'Voravakallu','522410',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89330,267,'Vupparapalem','522647',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89331,267,'Vutukuru','522410',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89332,267,'Yerraguntlapadu','522529',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89333,267,'Zammalamadaka','522426',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89334,267,'Zulakallu','522413',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89335,267,'A F Station','522102',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89336,267,'Adavuladivi','522262',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89337,267,'Alapadu','522312',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89338,267,'Allamudi','522256',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89339,267,'Allaparru','522262',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89340,267,'Allavaripalem','522259',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89341,267,'Alluru','522314',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89342,267,'Aluru','522124',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89343,267,'Amartaluru','522325',1,0,'2022-03-03 13:11:16','2022-03-03 13:11:16'),(89344,267,'Amudalapalli','522314',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89345,267,'Amudarlanka','522257',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89346,267,'Anamarlapudi','522213',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89347,267,'Anantavaram','522301',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89348,267,'Angalakudur','522211',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89349,267,'Annavaram','522301',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89350,267,'Annavarapulanka','522301',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89351,267,'Appikatla','522310',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89352,267,'Aremanda','522316',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89353,267,'Arepalle Agraharam','522309',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89354,267,'Arumbaka','522309',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89355,267,'Athota','522306',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89356,267,'Balijepalli','522261',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89357,267,'Balusulapalem','522309',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89358,267,'Bapatla Engg College','522102',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89359,267,'Bapatla H.O','522101',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89360,267,'Bavajipalem','522314',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89361,267,'Bellamvaripalem','522268',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89362,267,'Bethapudi','522265',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89363,267,'Bhattiprolu','522256',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89364,267,'Bhavanamvaripalem','522311',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89365,267,'Bhoolayapalem','522311',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89366,267,'Bodapadu','522341',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89367,267,'Boddulurupadu','522324',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89368,267,'Bodipalem','522315',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89369,267,'Brahmanakoduru','522212',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89370,267,'Buddam','522111',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89371,267,'Burripalem','522301',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89372,267,'Butumalli','522261',1,0,'2022-03-03 13:11:17','2022-03-03 13:11:17'),(89373,267,'Chadalavada','522301',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89374,267,'Champadu','522261',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89375,267,'Chandole','522311',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89376,267,'Chatragadda','522265',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89377,267,'Chavali','522261',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89378,267,'Chebrole (Guntur)','522212',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89379,267,'Cherukupalle','522309',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89380,267,'Cherukuru','522113',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89381,267,'Cheruvu','522113',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89382,267,'Chilumuru','522301',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89383,267,'Chiluvuru','522330',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89384,267,'China Ravuru Tenali','522201',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89385,267,'Chinagadelavarru','522313',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89386,267,'Chinalingayapalem','522124',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89387,267,'Chinaparimi','522313',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89388,267,'Chinapulivarru','522257',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89389,267,'Chinkapalem','522262',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89390,267,'Chintalapudi','522124',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89391,267,'Chintallanka','522324',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89392,267,'Chintayapalem','522111',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89393,267,'Chivaluru','522304',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89394,267,'Chodayapalem','522264',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89395,267,'Dandamudi','522316',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89396,267,'Dantaluru','522306',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89397,267,'Davuluru','522304',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89398,267,'Dhulipudi','522258',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89399,267,'Dindi','522262',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89400,267,'Donepudi','522324',1,0,'2022-03-03 13:11:18','2022-03-03 13:11:18'),(89401,267,'Doppalapudi','522316',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89402,267,'Duggirala','522330',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89403,267,'Edlapalli','522211',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89404,267,'Elavarru','522341',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89405,267,'Emani','522308',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89406,267,'Gajullanka','522324',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89407,267,'Ganapavaram','522111',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89408,267,'Gandhinagar (Guntur)','522201',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89409,267,'Gangadipalem','522264',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89410,267,'Godavarru','522212',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89411,267,'Gollamudipadu','522212',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89412,267,'Gopapuram','522310',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89413,267,'Govada','522325',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89414,267,'Gudavalli','522259',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89415,267,'Guddikayalanka','522265',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89416,267,'Gudibandivaripalem','522304',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89417,267,'Gudipudiagraharam','522310',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89418,267,'Gudivada','522307',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89419,267,'Gullapalli','522309',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89420,267,'Gundavaram','522212',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89421,267,'Gurunadhanagar','522262',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89422,267,'Hanumanpalem','522301',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89423,267,'Idupalli','522268',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89424,267,'Ilavaram','522259',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89425,267,'Intur','522341',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89426,267,'Ipuru','522301',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89427,267,'Isukapalle','522265',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89428,267,'Iteru','522310',1,0,'2022-03-03 13:11:19','2022-03-03 13:11:19'),(89429,267,'Ithanagar','522201',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89430,267,'Itikampadu','522315',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89431,267,'Jampani','522261',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89432,267,'Jillellamudi','522113',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89433,267,'Jupudi','522212',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89434,267,'Kaithepalle','522264',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89435,267,'Kallipalem','522262',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89436,267,'Kanagala (Guntur)','522259',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89437,267,'Kancherlapalem','522202',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89438,267,'Kankatapalem','522317',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89439,267,'Kannegantivaripalem','522265',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89440,267,'Kantamrajukonduru','522330',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89441,267,'Karankivaripalem','522268',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89442,267,'Karlapalem','522111',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89443,267,'Karumuru','522265',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89444,267,'Kasukarru','522124',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89445,267,'Katevaram','522202',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89446,267,'Kavuru','522309',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89447,267,'Kazipeta','522307',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89448,267,'Khajipalem','522329',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89449,267,'Kiskindapalem','522257',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89450,267,'Koduru-komali','522311',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89451,267,'Kolaganivaripalem','522258',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89452,267,'Kolakaluru','522307',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89453,267,'Kollipara','522304',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89454,267,'Kolluru','522324',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89455,267,'Komali','522315',1,0,'2022-03-03 13:11:20','2022-03-03 13:11:20'),(89456,267,'Kondabalavaripalem','522124',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89457,267,'Kondamudi','522341',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89458,267,'Konetipuram','522256',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89459,267,'Kopalle','522307',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89460,267,'Korutadiparru','522312',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89461,267,'Kothapalli-narikellapalli','522212',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89462,267,'Kothapeta (Guntur)','522201',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89463,267,'Kothareddypalem','522212',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89464,267,'Kovelamudi','522212',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89465,267,'Krapa','522324',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89466,267,'Kuchellapadu','522261',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89467,267,'Kuchinapudi','522262',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89468,267,'Kuchipudi','522313',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89469,267,'Kunchavaram','522306',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89470,267,'Lemellepadu','522212',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89471,267,'Lingamguntlapalem','522212',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89472,267,'Machavaram (Tenali)','522315',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89473,267,'Mamillapalli','522318',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89474,267,'Manchala','522212',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89475,267,'Manchikalapudi','522330',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89476,267,'Manduru','522313',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89477,267,'Mannava','522316',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89478,267,'Manthenavaripalem','522329',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89479,267,'Mantripalem','522262',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89480,267,'Marripudi','522310',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89481,267,'Maruproluvaripalem','522102',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89482,267,'Modukur','522318',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89483,267,'Moparru','522312',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89484,267,'Morampudi','522330',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89485,267,'Morrispeta','522202',1,0,'2022-03-03 13:11:21','2022-03-03 13:11:21'),(89486,267,'Mrutyumjayapalem','522264',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89487,267,'Mulapalem','522113',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89488,267,'Mulpuru','522313',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89489,267,'Mulukuduru','522315',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89490,267,'Munipalli','522316',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89491,267,'Munnangi','522304',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89492,267,'Murthota','522265',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89493,267,'Murukondapadu','522317',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89494,267,'Muthayapalem','522102',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89495,267,'Mutluru','522212',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89496,267,'Muttupalli Agraharam','522268',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89497,267,'Nadigaddapalem','522318',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89498,267,'Nadimpalli','522259',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89499,267,'Nagaram (Guntur)','522268',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89500,267,'Nalamothuvaripalem','522111',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89501,267,'Nalluru','522265',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89502,267,'Nallurupalem','522265',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89503,267,'Nandirajuthota','522102',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89504,267,'Nandivelugu','522306',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89505,267,'Nanduru','522315',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89506,267,'Narakoduru','522212',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89507,267,'Narasayapalem','522113',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89508,267,'Nelapadu','522202',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89509,267,'Nidubrole','522124',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89510,267,'Nidubrolu Old Town','522124',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89511,267,'Nizampatnam','522314',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89512,267,'Pallapatla','522262',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89513,267,'Pallekona','522256',1,0,'2022-03-03 13:11:22','2022-03-03 13:11:22'),(89514,267,'Pamidimarru','522258',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89515,267,'Panchalavaram','522325',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89516,267,'Pandrapadu','522124',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89517,267,'Pathareddypalem','522212',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89518,267,'Patsalatadiparru','522316',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89519,267,'Pedagadelavarru','522318',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89520,267,'Pedagollapalem','522111',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89521,267,'Pedamatlapudi','522314',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89522,267,'Pedapudi','522325',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89523,267,'Pedapulivarru','522257',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89524,267,'Pedapuluguvaripalem','522111',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89525,267,'Pedaravuru','522202',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89526,267,'Peddapalle','522329',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89527,267,'Peddavaram','522259',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89528,267,'Penugudurupadu','522211',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89529,267,'Penumarru','522256',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89530,267,'Penumudi','522265',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89531,267,'Penumuli','522330',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89532,267,'Perali','522111',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89533,267,'Peravali','522261',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89534,267,'Peravalipalem','522261',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89535,267,'Pesarlanka','522257',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89536,267,'Peteru','522265',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89537,267,'Pidaparru','522304',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89538,267,'Pinapad Tenali','522202',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89539,267,'Piratlanka','522264',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89540,267,'Pittalavanipalem','522329',1,0,'2022-03-03 13:11:23','2022-03-03 13:11:23'),(89541,267,'Ponnapalli Agraharam','522259',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89542,267,'Ponnur Bazar','522124',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89543,267,'Ponnur','522124',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89544,267,'Poondla','522310',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89545,267,'Potharlanka','522324',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89546,267,'Pothumeraka','522264',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89547,267,'Pragnam','522262',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89548,267,'Pudivada','522268',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89549,267,'Pushadapuvaripalem','522268',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89550,267,'Pyaparru','522341',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89551,267,'Railpeta - Repale','522265',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89552,267,'Railpeta Bapatla','522101',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89553,267,'Rajavole','522259',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89554,267,'Ramabhotlapalem','522309',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89555,267,'Ramnayyapalem','522113',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89556,267,'Rangaraothota','522101',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89557,267,'Ravikampadu','522324',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89558,267,'Repalle','522265',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89559,267,'Reteru','522113',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89560,267,'Sajjavaripalem','522265',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89561,267,'Sangamjagarlamudi','522213',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89562,267,'Sangupalem','522311',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89563,267,'Satyanarayanapuram (Guntur)','522202',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89564,267,'Sekuru','522213',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89565,267,'Selapadu','522213',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89566,267,'Singupalem','522264',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89567,267,'Siripudi','522329',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89568,267,'Snpagraharam','522101',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89569,267,'Srirangapuram','522212',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89570,267,'Stuvartpuram Colony','522317',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89571,267,'Stuvartpuram','522317',1,0,'2022-03-03 13:11:24','2022-03-03 13:11:24'),(89572,267,'Suddapalli','522213',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89573,267,'Surepalli','522256',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89574,267,'Tallapalem','522124',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89575,267,'Tenali Bazar','522201',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89576,267,'Tenali H.O','522201',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89577,267,'Thotapalli','522259',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89578,267,'Tsunduru','522318',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89579,267,'Tummala','522264',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89580,267,'Tummapudi','522330',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89581,267,'Tumuluru','522304',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89582,267,'Turumella','522312',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89583,267,'Vaddemukkala','522124',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89584,267,'Vaddevaripalem','522264',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89585,267,'Vadlamudi','522213',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89586,267,'Valiveru','522211',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89587,267,'Vallabhapuram','522308',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89588,267,'Vallabharaopalem','522124',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89589,267,'Valluru','522124',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89590,267,'Varahapuram Agraharam','522261',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89591,267,'Vatticheruku','522212',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89592,267,'Vejendla','522213',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89593,267,'Vellaluru','522212',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89594,267,'Vellaturu','522257',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89595,267,'Vemuru','522261',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89596,267,'Venigallavaripalem','522258',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89597,267,'Vetapalem','522212',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89598,267,'Vinayasramam','522309',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89599,267,'Visweswaram','522264',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89600,267,'Voleru','522265',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89601,267,'Vullipalem','522265',1,0,'2022-03-03 13:11:25','2022-03-03 13:11:25'),(89602,267,'Vupparapalem','522124',1,0,'2022-03-03 13:11:26','2022-03-03 13:11:26'),(89603,267,'Vuppudi','522265',1,0,'2022-03-03 13:11:26','2022-03-03 13:11:26'),(89604,267,'Wahabchowk-tenali','522201',1,0,'2022-03-03 13:11:26','2022-03-03 13:11:26'),(89605,267,'Yadavuru','522313',1,0,'2022-03-03 13:11:26','2022-03-03 13:11:26'),(89606,267,'Yazali','522111',1,0,'2022-03-03 13:11:26','2022-03-03 13:11:26'),(89607,267,'Yeletipalem','522268',1,0,'2022-03-03 13:11:26','2022-03-03 13:11:26'),(89608,267,'Yerukalapudi','522306',1,0,'2022-03-03 13:11:26','2022-03-03 13:11:26'),(89609,268,'Achavaram','521333',1,0,'2022-03-03 13:11:26','2022-03-03 13:11:26'),(89610,268,'Addada','521390',1,0,'2022-03-03 13:11:26','2022-03-03 13:11:26'),(89611,268,'Akkireddygudem','521213',1,0,'2022-03-03 13:11:26','2022-03-03 13:11:26'),(89612,268,'Alapadu R.S.','521340',1,0,'2022-03-03 13:11:26','2022-03-03 13:11:26'),(89613,268,'Alluru','521343',1,0,'2022-03-03 13:11:26','2022-03-03 13:11:26'),(89614,268,'Amudalapalli','521324',1,0,'2022-03-03 13:11:26','2022-03-03 13:11:26'),(89615,268,'Amudalapalli','521312',1,0,'2022-03-03 13:11:26','2022-03-03 13:11:26'),(89616,268,'Anamanapudi','521327',1,0,'2022-03-03 13:11:26','2022-03-03 13:11:26'),(89617,268,'Angaluru','521330',1,0,'2022-03-03 13:11:26','2022-03-03 13:11:26'),(89618,268,'Annaraopet','521215',1,0,'2022-03-03 13:11:26','2022-03-03 13:11:26'),(89619,268,'Annavaram','521202',1,0,'2022-03-03 13:11:26','2022-03-03 13:11:26'),(89620,268,'APIIIT','521202',1,0,'2022-03-03 13:11:26','2022-03-03 13:11:26'),(89621,268,'Appikatla','521261',1,0,'2022-03-03 13:11:26','2022-03-03 13:11:26'),(89622,268,'Aripirala','521106',1,0,'2022-03-03 13:11:26','2022-03-03 13:11:26'),(89623,268,'Arugolanu','521106',1,0,'2022-03-03 13:11:26','2022-03-03 13:11:26'),(89624,268,'Atapaka','521333',1,0,'2022-03-03 13:11:26','2022-03-03 13:11:26'),(89625,268,'Ayyavarirudravaram','521345',1,0,'2022-03-03 13:11:26','2022-03-03 13:11:26'),(89626,268,'Balive','521207',1,0,'2022-03-03 13:11:26','2022-03-03 13:11:26'),(89627,268,'Bantumilli','521324',1,0,'2022-03-03 13:11:26','2022-03-03 13:11:26'),(89628,268,'Bapulapadu','521105',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89629,268,'Bethavolu','521301',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89630,268,'Bhujabalapatnam','521340',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89631,268,'Bhushanagulla','521263',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89632,268,'Bhyravapatnam','521345',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89633,268,'Billanapalli','521111',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89634,268,'Bokinala','521260',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89635,268,'Bollapadu','521261',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89636,268,'Bomminampadu','521343',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89637,268,'Bommuluru','521301',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89638,268,'Bommuluru','521105',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89639,268,'Boruvancha','521202',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89640,268,'Chandrala','521330',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89641,268,'Chandrupatla','521215',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89642,268,'Chatrai','521214',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89643,268,'Chavalipadu','521333',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89644,268,'Chekkapalli','521213',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89645,268,'Cherukumilli','521324',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89646,268,'Chevuru','521329',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89647,268,'Chigurukota','521345',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89648,268,'Chinapalaparru','521325',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89649,268,'Chinaparupudi','521148',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89650,268,'Chinatummidi','521329',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89651,268,'Chinayerukapadu','521322',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89652,268,'Chinnampet','521214',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89653,268,'Chintalavalli','521207',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89654,268,'Chintapadu','521333',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89655,268,'Chittapur','521213',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89656,268,'Chorampudi','521324',1,0,'2022-03-03 13:11:27','2022-03-03 13:11:27'),(89657,268,'Chowtapalli','521323',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89658,268,'Dandiganapudi','521327',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89659,268,'Devapudi','521343',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89660,268,'Devaragunta','521111',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89661,268,'Digavalli','521213',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89662,268,'Doddipatla','521340',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89663,268,'Dondapadu','521323',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89664,268,'Dosapadu','521321',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89665,268,'Dum Dum Gardens','521201',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89666,268,'Edulamaddali','521148',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89667,268,'Elamarru','521148',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89668,268,'Ellapuram','521207',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89669,268,'Enamadala','521202',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89670,268,'Gandhi Asramam','521322',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89671,268,'Gandhinagaram (Gudivada)','521201',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89672,268,'Gannavaram','521345',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89673,268,'Garapadu','521312',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89674,268,'Gollapalli (Krishna)','521111',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89675,268,'Golvepalli (Zami)','521322',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89676,268,'Gopavaram','521207',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89677,268,'Gopavaram','521333',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89678,268,'Gudipadu','521213',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89679,268,'Gudipadu','521214',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89680,268,'Gudivada H.O','521301',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89681,268,'Gudivada Railway Station','521301',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89682,268,'Gullapudi','521213',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89683,268,'Gunnanapudi','521326',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89684,268,'Guntakoduru','521323',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89685,268,'Guraza','521325',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89686,268,'Guruvindagunta','521263',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89687,268,'Hanuman Junction','521105',1,0,'2022-03-03 13:11:28','2022-03-03 13:11:28'),(89688,268,'Hanumanthunigudem','521202',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89689,268,'Ilaparru','521321',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89690,268,'Indupalli','521311',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89691,268,'Ingilipakalanka','521326',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89692,268,'Jagannadhapuram','521301',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89693,268,'Jagannadhapuram','521215',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89694,268,'Janardhanapuram','521321',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89695,268,'Janardhanavaram','521214',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89696,268,'Jangamgudem','521111',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89697,268,'Jayapuram','521324',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89698,268,'K.P.Agraharam','521325',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89699,268,'Kaikalur','521333',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89700,268,'Kakulapadu','521106',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89701,268,'Kalagara','521214',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89702,268,'Kalidindi Centre','521344',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89703,268,'Kalidindi','521344',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89704,268,'Kallapalem','521333',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89705,268,'Kanukollu','521325',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89706,268,'Kanumolu','521106',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89707,268,'Katrenipadu','521207',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89708,268,'Koduru','521325',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89709,268,'Kolletikota','521340',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89710,268,'Komallapudi','521324',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89711,268,'Komaravolu','521322',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89712,268,'Komarru','521325',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89713,268,'Komatigunta Lock','521260',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89714,268,'Kondangi','521344',1,0,'2022-03-03 13:11:29','2022-03-03 13:11:29'),(89715,268,'Kondaparva','521213',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89716,268,'Konduru','521333',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89717,268,'Korlagunta','521207',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89718,268,'Korlamanda','521214',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89719,268,'Korlapadu','521345',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89720,268,'Korlapadu','521324',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89721,268,'Korraguntapalem','521329',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89722,268,'Korukollu','521343',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89723,268,'Kotapadu','521214',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89724,268,'Kothapalli','521111',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89725,268,'Kottada','521340',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89726,268,'Koyyagurapadu','521312',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89727,268,'Koyyuru','521105',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89728,268,'Krishnaraopalem','521214',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89729,268,'Krithivennu','521324',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89730,268,'Kudapa','521215',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89731,268,'Kudaravalli','521321',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89732,268,'Kunaparajaparva','521215',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89733,268,'Lakshminarasimhapuram','521321',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89734,268,'Lakshmipuram','521324',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89735,268,'Lankapalli Agraharam','521311',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89736,268,'Lingala','521325',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89737,268,'Lingavaram','521327',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89738,268,'Lodidalanka','521344',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89739,268,'Lopudi','521213',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89740,268,'Maddulaparva','521215',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89741,268,'Mallavalli','521111',1,0,'2022-03-03 13:11:30','2022-03-03 13:11:30'),(89742,268,'Malleswaram','521324',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89743,268,'Mandavalli','521345',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89744,268,'Manikonda','521260',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89745,268,'Matlam','521324',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89746,268,'Mattagunta','521344',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89747,268,'Medicherla','521105',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89748,268,'Mirzapuram','521111',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89749,268,'Mokasakalvapudi','521345',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89750,268,'Moparru','521321',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89751,268,'Morsapudi','521111',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89752,268,'Moturu','521323',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89753,268,'Muchinapalli','521215',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89754,268,'Mudinepalli','521325',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89755,268,'Mudunuru','521261',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89756,268,'Mukkollupadu','521207',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89757,268,'Mulaparru','521324',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89758,268,'Mulaupparagudem','521344',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89759,268,'Munipeda','521324',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89760,268,'Musunuru','521207',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89761,268,'Nandamuru','521311',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89762,268,'Nandigamalanka','521326',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89763,268,'Nandivada','521321',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89764,268,'Narasapuram','521215',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89765,268,'Neelipudi','521324',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89766,268,'Nidamarru','521324',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89767,268,'Nuzella','521330',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89768,268,'Nuzvid Bazar','521201',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89769,268,'Nuzvid H.O','521201',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89770,268,'Pallerlamudi','521105',1,0,'2022-03-03 13:11:31','2022-03-03 13:11:31'),(89771,268,'Pallevada','521340',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89772,268,'Pandraka','521324',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89773,268,'Pedagonnuru','521329',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89774,268,'Pedakamanapudi','521325',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89775,268,'Pedalanka','521344',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89776,268,'Pedalingala','521106',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89777,268,'Pedamaddali','521390',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89778,268,'Pedapalaparru','521323',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89779,268,'Pedaparupudi','521263',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89780,268,'Pedatummidi','521329',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89781,268,'Pedavirivada','521321',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89782,268,'Penchikalamarru','521340',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89783,268,'Pendurru','521324',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89784,268,'Perekegudem','521345',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89785,268,'Perikeedu Bridge','521105',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89786,268,'Peruru','521325',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89787,268,'Peyyeru','521325',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89788,268,'Polasanipalli','521111',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89789,268,'Polavaram','521214',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89790,268,'Polukonda','521327',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89791,268,'Ponukumada','521327',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89792,268,'Ponukumada','521312',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89793,268,'Pothanapalli','521214',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89794,268,'Pothumarru','521344',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89795,268,'Pothureddipalli','521207',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89796,268,'Prathipadu','521345',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89797,268,'Prodduvaka','521343',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89798,268,'Putlacheruvu','521326',1,0,'2022-03-03 13:11:32','2022-03-03 13:11:32'),(89799,268,'Puttagunta','521106',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89800,268,'Rajendranagar Colony','521301',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89801,268,'Ramanakkapet','521213',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89802,268,'Ramannagudem','521106',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89803,268,'Ramapuram','521321',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89804,268,'Ravicherla','521202',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89805,268,'Reddigudem','521215',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89806,268,'Rudrapaka','521326',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89807,268,'Sanarudravaram','521343',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89808,268,'Sankarshanapuram','521325',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89809,268,'Santhoshapuram','521344',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89810,268,'Satyanarayanapuram (Gudivada)','521301',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89811,268,'Seetanapalli','521340',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89812,268,'Serigolvepalli','521323',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89813,268,'Serikalavapudi','521330',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89814,268,'Serinarasannapalem','521105',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89815,268,'Siddantham','521330',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89816,268,'Siddharthanagar','521202',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89817,268,'Singanapudi','521345',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89818,268,'Singarayapalem','521329',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89819,268,'Sitaramapuram','521105',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89820,268,'Somavaram','521213',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89821,268,'Surepalli','521213',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89822,268,'Tadinada','521333',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89823,268,'Takkellapadu','521345',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89824,268,'Tamarakollu','521343',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89825,268,'Tamirisa','521327',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89826,268,'Tarigoppula R.S.','521260',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89827,268,'Tatakuntla','521215',1,0,'2022-03-03 13:11:33','2022-03-03 13:11:33'),(89828,268,'Tativarru','521322',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89829,268,'Telladevarapalli','521215',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89830,268,'Tenneru','521260',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89831,268,'Tippanagunta','521106',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89832,268,'Tsanubanda','521214',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89833,268,'Tukkuluru','521111',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89834,268,'Tummagudem','521213',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89835,268,'Tummalapalli','521321',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89836,268,'Unikili','521326',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89837,268,'Urivi','521329',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89838,268,'Utukuru','521329',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89839,268,'Vadali','521325',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89840,268,'Vadarlapadu','521340',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89841,268,'Vadavalli','521329',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89842,268,'Vaivaka','521329',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89843,268,'Valasapalli','521213',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89844,268,'Valivarthipadu','521327',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89845,268,'Vanapumala','521263',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89846,268,'Vanudurru','521329',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89847,268,'Varahapatnam','521333',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89848,268,'Veldipadu','521312',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89849,268,'Velinuthala','521312',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89850,268,'Velpucherla','521207',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89851,268,'Vemanda','521311',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89852,268,'Vemavarappadu','521343',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89853,268,'Vempadu','521260',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89854,268,'Venkatapuram','521344',1,0,'2022-03-03 13:11:34','2022-03-03 13:11:34'),(89855,268,'Vennanapudi','521321',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89856,268,'Ventrapragada','521263',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89857,268,'Vidyanagar (Krishna)','521201',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89858,268,'Vinjaram','521333',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89859,268,'Vinnakota','521325',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89860,268,'Vissannapet','521215',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89861,268,'Vunguturu (Krishna)','521312',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89862,268,'Akulamannadu','521366',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89863,268,'Akumarru','521149',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89864,268,'Arthamuru','521369',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89865,268,'Aswaraopalem','521122',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89866,268,'Avanigadda H.O','521121',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89867,268,'Ayyanki','521138',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89868,268,'Balaramunipet','521001',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89869,268,'Bandlaicheruvu','521122',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89870,268,'Barlapudi','521136',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89871,268,'Batchupet','521001',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89872,268,'Bhaskarapuram','521001',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89873,268,'Bhatlapenumarru','521138',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89874,268,'Bhavadevarapalli','521120',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89875,268,'Bhogireddipalli','521131',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89876,268,'Borrapothupalem','521366',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89877,268,'Brahmapuram','521366',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89878,268,'Buttaipet','521001',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89879,268,'Challapalli','521126',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89880,268,'Chennuru','521366',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89881,268,'Chevendra','521366',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89882,268,'Chilakalapudi','521002',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89883,268,'Chinakallepalli','521132',1,0,'2022-03-03 13:11:35','2022-03-03 13:11:35'),(89884,268,'Chinamuttevi','521136',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89885,268,'Chinnapuram','521003',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89886,268,'Chintaguntapalem','521003',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89887,268,'Chiruvolulanka','521125',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89888,268,'Chittiguduru','521149',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89889,268,'Chittipalem','521366',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89890,268,'Chitturu','521150',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89891,268,'Chitturupu','521132',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89892,268,'Chodavaram','521120',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89893,268,'Daggumailli','521356',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89894,268,'Daggumilli(Z)','521157',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89895,268,'Daliparru','521131',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89896,268,'Dd.Puram','521120',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89897,268,'Desaipet','521001',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89898,268,'Devarakota','521133',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89899,268,'Divigollapalem','521328',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89900,268,'Dokiparru','521332',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89901,268,'Dt.Court','521002',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89902,268,'Eddanapudi','521136',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89903,268,'Edlalanka','521122',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89904,268,'Edurumondi','521120',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89905,268,'Elakurru','521156',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89906,268,'Endakuduru','521131',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89907,268,'Etimogga','521120',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89908,268,'Ganapeswaram','521120',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89909,268,'Gandhikshetram','521122',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89910,268,'Ghantasala','521133',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89911,268,'Ghantasalapalem','521133',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89912,268,'Gilakaladindi','521003',1,0,'2022-03-03 13:11:36','2022-03-03 13:11:36'),(89913,268,'Godugupet','521001',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89914,268,'Gudapadu','521135',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89915,268,'Gudlavalleru','521356',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89916,268,'Guduru','521149',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89917,268,'Gundupalem','521003',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89918,268,'Hamsaladeevi','521328',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89919,268,'Inagudurupet','521001',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89920,268,'Inampudi','521138',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89921,268,'Jakkamcherla','521332',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89922,268,'Jayapuram','521328',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89923,268,'Jinjeru','521369',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89924,268,'Jujjuvaram','521157',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89925,268,'K.Kothapalem','521125',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89926,268,'K.P.Centre','521136',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89927,268,'K.P.Lock','521366',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89928,268,'K.P.Pur','521002',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89929,268,'Kaja','521150',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89930,268,'Kakarlamudi','521369',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89931,268,'Kammanamoulu','521120',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89932,268,'Kammavaricheruvu','521003',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89933,268,'Kanchadam','521369',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89934,268,'Kanchakoduru','521150',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89935,268,'Kankata','521149',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89936,268,'Kanuru','521002',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89937,268,'Kappaladoddi','521366',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89938,268,'Karagraharam','521002',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89939,268,'Kavipuram','521331',1,0,'2022-03-03 13:11:37','2022-03-03 13:11:37'),(89940,268,'Kavutaram','521331',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89941,268,'Kodali','521132',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89942,268,'Koduru','521328',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89943,268,'Kokanarayanapalem','521149',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89944,268,'Kokkiligadda','521125',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89945,268,'Kondiparru','521157',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89946,268,'Kongamcherla','521331',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89947,268,'Konkepudi','521366',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89948,268,'Kosuru','521150',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89949,268,'Kothapet(Divi)','521122',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89950,268,'Kummaripalem','521130',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89951,268,'Kurada','521356',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89952,268,'Kurumaddali','521157',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89953,268,'L.K.Gunta','521366',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89954,268,'Lakshmipuram (Krishna)','521131',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89955,268,'Lankapalli','521131',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89956,268,'Lellagaruvu','521366',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89957,268,'Lingareddipalem','521328',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89958,268,'Machavaram','521002',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89959,268,'Machilipatnam H.O','521001',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89960,268,'Maddipatla','521150',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89961,268,'Majeru','521131',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89962,268,'Malakapatnam','521001',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89963,268,'Mallampalli','521150',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89964,268,'Mallavolu','521162',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89965,268,'Mamidikolla','521356',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89966,268,'Mandapakala','521328',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89967,268,'Mangalapuram','521131',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89968,268,'Manginapudi','521002',1,0,'2022-03-03 13:11:38','2022-03-03 13:11:38'),(89969,268,'Mantripalem','521156',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89970,268,'Modumudi','521122',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89971,268,'Mopidevi','521125',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89972,268,'Movva','521135',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89973,268,'Mpm Fort','521003',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89974,268,'Mukkollu','521332',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89975,268,'Munjuluru','521369',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89976,268,'Mutcherla','521366',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89977,268,'Nadakuduru','521126',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89978,268,'Nadupuru','521366',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89979,268,'Nagavaram','521331',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89980,268,'Nagayalanka East','521120',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89981,268,'Nagayalanka','521120',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89982,268,'Nagayatippa','521125',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89983,268,'Nali','521120',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89984,268,'Nandamuru','521369',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89985,268,'Nandigama','521366',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89986,268,'Nangegadda','521120',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89987,268,'Nidumolu','521156',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89988,268,'Nimmakuru','521158',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89989,268,'Nimmaluru','521158',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89990,268,'P.G.Lanka','521156',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89991,268,'Pagolu','521126',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89992,268,'Palankipadu','521158',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89993,268,'Pamarru Bazar','521157',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89994,268,'Pamarru (Krishna)','521157',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89995,268,'Papanasanam','521132',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89996,268,'Parrachivara','521120',1,0,'2022-03-03 13:11:39','2022-03-03 13:11:39'),(89997,268,'Pasumarru','521157',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(89998,268,'Pedakallepalli','521130',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(89999,268,'Pedakammavaripalem','521120',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(90000,268,'Pedamuttevi','521136',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(90001,268,'Pedana','521366',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(90002,268,'Pedanabazar','521366',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(90003,268,'Pedapatnam','521002',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(90004,268,'Pedaprolu','521125',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(90005,268,'Pedasanagallu','521138',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(90006,268,'Pedayadara','521003',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(90007,268,'Penjendra','521356',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(90008,268,'Penumalli','521369',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(90009,268,'Perisepalli','521157',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(90010,268,'Pesaramilli','521332',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(90011,268,'Pittalalanka','521122',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(90012,268,'Polatitippa','521003',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(90013,268,'Polavaram(K)','521162',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(90014,268,'Pothepalli','521002',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(90015,268,'Pothireddipalem','521002',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(90016,268,'Puligadda','521122',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(90017,268,'Rajupet','521001',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(90018,268,'Ramachandrapuram(Divi)','521122',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(90019,268,'Ramannapet','521162',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(90020,268,'Rayavaram','521162',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(90021,268,'Rimmanapudi','521157',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(90022,268,'Rudravaram','521003',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(90023,268,'S.N.Gollapalem','521003',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(90024,268,'Salempalem','521328',1,0,'2022-03-03 13:11:40','2022-03-03 13:11:40'),(90025,268,'Saradanagar','521003',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90026,268,'Satulru','521369',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90027,268,'Sorlagondhi','521120',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90028,268,'Srikakulam','521132',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90029,268,'Swatantrapuram','521328',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90030,268,'T.Kothapalem','521120',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90031,268,'Tadepalli','521132',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90032,268,'Talagadadeevi','521120',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90033,268,'Tallapalem','521002',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90034,268,'Tarakaturu','521156',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90035,268,'Tummalacheruvu','521003',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90036,268,'Turakapalem','521150',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90037,268,'U.G.C.Works','521001',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90038,268,'Ullipalem','521328',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90039,268,'Undrapudi','521157',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90040,268,'Uruturu','521157',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90041,268,'V.Kothapalem','521122',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90042,268,'V.Rudravaram','521133',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90043,268,'Vadapalem','521003',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90044,268,'Vadlamannadu','521331',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90045,268,'Vakkalagadda','521126',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90046,268,'Valandapalem','521002',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90047,268,'Vekanuru','521122',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90048,268,'Velivolu','521132',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90049,268,'Vemavaram','521331',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90050,268,'Vemulamada','521135',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90051,268,'Venaktapuram','521130',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90052,268,'Venturumilli','521332',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90053,268,'Viswanadhapalli','521122',1,0,'2022-03-03 13:11:41','2022-03-03 13:11:41'),(90054,268,'Yadlavanipalem','521002',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90055,268,'Yarlagadda','521126',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90056,268,'A.C.Company','520003',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90057,268,'A.Konduru','521226',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90058,268,'A.P.H.B.Colony','520012',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90059,268,'A.P.U.H.S','520008',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90060,268,'Adavinekkalam','521212',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90061,268,'Agniparru','521250',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90062,268,'Akunuru','521245',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90063,268,'Allapuram','521101',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90064,268,'Alluru','521181',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90065,268,'Ambapuram','521109',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90066,268,'Ambapuram','520012',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90067,268,'Ambedkarnagar','521165',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90068,268,'Aminapuram','521250',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90069,268,'Ammireddigudem','521403',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90070,268,'Anigandlapadu','521190',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90071,268,'Anumanchipalli','521175',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90072,268,'Arlapadu','521403',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90073,268,'Arundalpet','520002',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90074,268,'Atkur','521286',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90075,268,'Atkuru','521229',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90076,268,'Aukiripalli','521211',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90077,268,'Autonagar','520007',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90078,268,'Azitnagar','520015',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90079,268,'Azzampudi','521101',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90080,268,'Bacon Factory','521102',1,0,'2022-03-03 13:11:42','2022-03-03 13:11:42'),(90081,268,'Bahubalendrunigudem','521101',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90082,268,'Balusupadu','521175',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90083,268,'Bandarugudem','521109',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90084,268,'Bandipalem','521178',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90085,268,'Besant Road','520011',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90086,268,'Bhadrirajupalem','521163',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90087,268,'Bhavanipuram','520012',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90088,268,'Bhimavaram','521178',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90089,268,'Bobbellapadu','521182',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90090,268,'Boddapadu','521151',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90091,268,'Buckinghampet H.O','520002',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90092,268,'Budavada','521175',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90093,268,'Budhavaram','521101',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90094,268,'Buthumillipadu','521101',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90095,268,'Chagantipadu','521163',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90096,268,'Chandapuram','521185',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90097,268,'Chandarlapadu','521182',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90098,268,'Chandrala','521230',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90099,268,'Chandramoulipuram','520010',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90100,268,'Chandrgudem','521230',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90101,268,'Chavutapalli','521227',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90102,268,'Cheemalapadu','521226',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90103,268,'Chennaraopalem','521181',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90104,268,'Cheruvu Madhavaram','521229',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90105,268,'Cheruvukommupalem','521185',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90106,268,'Chevitikallu','521180',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90107,268,'Chevutur','521229',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90108,268,'Chikkavaram','521101',1,0,'2022-03-03 13:11:43','2022-03-03 13:11:43'),(90109,268,'Chillakallu','521178',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90110,268,'Chilukuru','521456',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90111,268,'China Nandigama','521230',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90112,268,'Chinaogirala','521245',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90113,268,'Chintalanerva','521401',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90114,268,'Chintalapadu','521183',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90115,268,'Chintalapadu','521235',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90116,268,'Chiravada','521109',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90117,268,'Chittinagar','520001',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90118,268,'Chodavaram','521139',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90119,268,'Chopparametla','521211',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90120,268,'Choragudi','521250',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90121,268,'Chowtapalli','521170',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90122,268,'Civil Coursts','520002',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90123,268,'Dabbakupalli','521402',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90124,268,'Dachavaram','521181',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90125,268,'Damulur','521170',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90126,268,'Damuluru','521180',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90127,268,'Devarapalli','521163',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90128,268,'Doddadevarapadu','521170',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90129,268,'Duggiralapadu','521229',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90130,268,'Duggiralapadu','521401',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90131,268,'Durga Agraharam','520002',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90132,268,'Durgapuram','520003',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90133,268,'Edara','521211',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90134,268,'Edupugallu','521151',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90135,268,'Enikepadu','521108',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90136,268,'Erramadu','521403',1,0,'2022-03-03 13:11:44','2022-03-03 13:11:44'),(90137,268,'Eturu','521183',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90138,268,'G Konduru','521229',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90139,268,'Galigopuram','521109',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90140,268,'Gampalagudem','521403',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90141,268,'Ganapavaram','521230',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90142,268,'Gandepalli','521185',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90143,268,'Gandhinagaram (Vijayawada)','520003',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90144,268,'Gandigunta','521165',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90145,268,'Gandrai','521175',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90146,268,'Gangapadu','521227',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90147,268,'Ganginenipalem','521229',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90148,268,'Ganguru','521139',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90149,268,'Gani Atkuru','521180',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90150,268,'Gannavaram Centre','521101',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90151,268,'Gannavaram','521101',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90152,268,'Garikiparru','521165',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90153,268,'Godavarru','521151',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90154,268,'Gollamandala','521227',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90155,268,'Gollamudi','521185',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90156,268,'Gollanapalli','521101',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90157,268,'Gollapudi','521225',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90158,268,'Gopavarapugudem','521101',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90159,268,'Gopinenipalem','521190',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90160,268,'Gopuvanipalem','521256',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90161,268,'Gosala','521151',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90162,268,'Gosavedu','521403',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90163,268,'Gottumukkala','521180',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90164,268,'Gowravaram','521178',1,0,'2022-03-03 13:11:45','2022-03-03 13:11:45'),(90165,268,'Gudavalli','521104',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90166,268,'Gudem Madhavaram','521181',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90167,268,'Gudimetla','521182',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90168,268,'Gullapudi','521403',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90169,268,'Gummadidurru','521190',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90170,268,'Gunadala','520004',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90171,268,'Guntupalli','521241',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90172,268,'Gurazada','521256',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90173,268,'Guruvindapalli','521247',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90174,268,'Guttavaripalem','521183',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90175,268,'H Mutyalampadu','521229',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90176,268,'Hanumanthapuram','521246',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90177,268,'Ibrahimpatnam (Krishna)','521456',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90178,268,'Ida Kondaplli','521228',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90179,268,'Idulagudem','521211',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90180,268,'Ilaprolu','521228',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90181,268,'Iluru','521247',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90182,268,'Inapur','521247',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90183,268,'Industrial Estate (Krishna)','520007',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90184,268,'Ithavaram','521185',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90185,268,'Jaccampudi','520012',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90186,268,'Jaggaiahpet','521175',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90187,268,'Jami Annavaram','521175',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90188,268,'Jammavaram','521180',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90189,268,'Jayanthi','521170',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90190,268,'Jayanthipuram','521457',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90191,268,'Jonnalagadda','521185',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90192,268,'Jupudi','521456',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90193,268,'Juzzuru','521181',1,0,'2022-03-03 13:11:46','2022-03-03 13:11:46'),(90194,268,'Kadavakollu','521164',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90195,268,'Kakaravai','521402',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90196,268,'Kakarla','521227',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90197,268,'Kalavapamula','521164',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90198,268,'Kamakotinagar','520012',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90199,268,'Kammavaripalem','521185',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90200,268,'Kanakavalli','521165',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90201,268,'Kanasanapalli','521212',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90202,268,'Kanchala','521185',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90203,268,'Kanchikacharla','521180',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90204,268,'Kankipadu','521151',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90205,268,'Kannevidu','521190',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90206,268,'Kanumuru','521403',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90207,268,'Kanumuru','521256',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90208,268,'Kanuru','520007',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90209,268,'Kapileswarapuram (Krishna)','521246',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90210,268,'Kasarabad','521182',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90211,268,'Kattubadipalem','521228',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90212,268,'Katuru','521164',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90213,268,'Kavuluru','521228',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90214,268,'Keesara','521185',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90215,268,'Kesarapalli','521102',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90216,268,'Ketanakonda','521456',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90217,268,'Kethaveerunipadu','521185',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90218,268,'Khambampadu','521402',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90219,268,'Khambhampadu','521227',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90220,268,'Kodavatikallu','521182',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90221,268,'Kokilampadu','521235',1,0,'2022-03-03 13:11:47','2022-03-03 13:11:47'),(90222,268,'Kolavennu','521153',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90223,268,'Kommireddipalli','521235',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90224,268,'Konakanchi','521178',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90225,268,'Konathamatmakur','521170',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90226,268,'Konayapalem','521182',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90227,268,'Kondapalli','521228',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90228,268,'Konduru','521185',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90229,268,'Konduru','521227',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90230,268,'Konduru','521230',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90231,268,'Kondurupadu','521110',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90232,268,'Konijerla','521401',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90233,268,'Kontalapalli','521181',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90234,268,'Kotha Edara','521211',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90235,268,'Kothapalli','521403',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90236,268,'Kotikalapudi','521456',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90237,268,'Krishnalanka','520013',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90238,268,'Krishnanagar','520007',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90239,268,'Krishnapuram','521250',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90240,268,'Krishnavaram','521211',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90241,268,'Kuderu','521247',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90242,268,'Kumaraswamy Raja Nagar','521457',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90243,268,'Kunderu','521245',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90244,268,'Kuntamukkala','521230',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90245,268,'Lakshmana Nagar','521165',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90246,268,'Lakshminagar','520011',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90247,268,'Lakshmipuram','521235',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90248,268,'Lime Stone Town Ship','521175',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90249,268,'Lingagudem','521190',1,0,'2022-03-03 13:11:48','2022-03-03 13:11:48'),(90250,268,'Lingala','521402',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90251,268,'Lingalapadu','521185',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90252,268,'Machavaram (Krishna)','520004',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90253,268,'Machinenipalem','521402',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90254,268,'Madduru','521151',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90255,268,'Madhurapuram','521247',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90256,268,'Magallu','521185',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90257,268,'Makkapeta','521190',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90258,268,'Malkapuram','521175',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90259,268,'Mallela','521235',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90260,268,'Mangollu','521178',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90261,268,'Mantada','521256',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90262,268,'Manthena','521151',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90263,268,'Marrivada','521256',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90264,268,'Meduru','521247',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90265,268,'Moghalrajpuram','520010',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90266,268,'Moguluru','521180',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90267,268,'Morusumilli','521230',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90268,268,'Muchintala','521190',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90269,268,'Muktyala','521457',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90270,268,'Mulapadu','521456',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90271,268,'Munagacherla','521185',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90272,268,'Mundlapadu','521190',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90273,268,'Munnaluru','521180',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90274,268,'Munukulla','521235',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90275,268,'Muppalla (Krishna)','521183',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90276,268,'Mustabad (Krishna)','521107',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90277,268,'Mylavaram (Krishna)','521230',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90278,268,'Naguluru','521230',1,0,'2022-03-03 13:11:49','2022-03-03 13:11:49'),(90279,268,'Nandigama Bazar','521185',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90280,268,'Nandigama','521185',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90281,268,'Narasimharaopalem','521181',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90282,268,'Narasingapalem','521211',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90283,268,'Nawabpet','521185',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90284,268,'Nemali','521401',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90285,268,'Nepalli','521245',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90286,268,'Nidamanuru','521104',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90287,268,'Nugondapalli','521211',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90288,268,'Nunna','521212',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90289,268,'Paidurupadu','521241',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90290,268,'Pallagiri','521185',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90291,268,'Pamidimukkala','521250',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90292,268,'Pamulalanka','521163',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90293,268,'Panditnehru Bus Station','520013',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90294,268,'Paritala','521180',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90295,268,'Patamata Lanka','520015',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90296,268,'Patamata','520010',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90297,268,'Patamatalankapalli','521247',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90298,268,'Pathapadu','521212',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90299,268,'Payakapuram.','520015',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90300,268,'Peda Modugapalli','521178',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90301,268,'Pedaogirala','521245',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90302,268,'Pedapulipaka','521134',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90303,268,'Pedavutapalli','521286',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90304,268,'Peddapuram','521181',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90305,268,'Penamakuru','521165',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90306,268,'Penamaluru','521139',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90307,268,'Pendyala','521185',1,0,'2022-03-03 13:11:50','2022-03-03 13:11:50'),(90308,268,'Pentalavarigudem','521402',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90309,268,'Penuganchiprolu','521190',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90310,268,'Penugolanu','521401',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90311,268,'Penumatcha','521250',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90312,268,'Pinapaka','521228',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90313,268,'Pochampalli','521178',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90314,268,'Pokkunuru','521182',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90315,268,'Polampalli','521402',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90316,268,'Polisettipadu','521227',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90317,268,'Pondugula','521230',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90318,268,'Ponnavaram','521180',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90319,268,'Popuru','521182',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90320,268,'Poranki','521137',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90321,268,'Pottipadu','521286',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90322,268,'Proddutur','521151',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90323,268,'Pulluru','521230',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90324,268,'Punadipadu','521151',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90325,268,'Punnamathota','520010',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90326,268,'Punnavalli','521182',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90327,268,'Purnanandampet','520003',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90328,268,'Purushothapatnam','521101',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90329,268,'Putrela','521227',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90330,268,'Raghavapuram','521185',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90331,268,'Railway Wagon Work Shop','521241',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90332,268,'Rajagopalapuram','521110',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90333,268,'Ramachandrapuram','521226',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90334,268,'Ramavarappadu','521108',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90335,268,'Ramireddipalli','521185',1,0,'2022-03-03 13:11:51','2022-03-03 13:11:51'),(90336,268,'Rangannagudem','521110',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90337,268,'Rayanapadu','521241',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90338,268,'Remalle','521110',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90339,268,'Repudi','521226',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90340,268,'Rolupadu','521235',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90341,268,'Roynagar','521101',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90342,268,'Royyur','521151',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90343,268,'Rudravaram','521226',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90344,268,'Rudravaram','521185',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90345,268,'Sagguru','521211',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90346,268,'Saipuram','521256',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90347,268,'Sanagapadu','521185',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90348,268,'Satyalapadu','521401',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90349,268,'Satyanarayanapuram (Vijayawada)','520011',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90350,268,'Savaragudem','521107',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90351,268,'Seetharampuram','521211',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90352,268,'Shermohammadpet','521175',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90353,268,'Singavaram','521190',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90354,268,'Sivapuram','521190',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90355,268,'Sobhanapuram','521211',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90356,268,'Somavaram','521185',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90357,268,'Sriniketan','521235',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90358,268,'Srinivasa Nagar Colony','521175',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90359,268,'Srirangapuram','521247',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90360,268,'Subbayyagudem','521190',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90361,268,'Sunnampadu','521229',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90362,268,'Surampalli','521212',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90363,268,'Suravaram','521109',1,0,'2022-03-03 13:11:52','2022-03-03 13:11:52'),(90364,268,'Suryaraopet','520002',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90365,268,'Tadanki','521256',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90366,268,'Tadepalli','520012',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90367,268,'Tadigadapa','521134',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90368,268,'Takkellapadu','521175',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90369,268,'Talluru','521402',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90370,268,'Telaprolu','521109',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90371,268,'Tempalli','521286',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90372,268,'Thotapalli','521211',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90373,268,'Thotaravulapadu','521183',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90374,268,'Thotlavalluru','521163',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90375,268,'Tirumalagiri','521178',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90376,268,'Tiruvuru','521235',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90377,268,'Tolukodu','521230',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90378,268,'Torragudipadu','521185',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90379,268,'Tunikipadu','521401',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90380,268,'Turlapadu','521183',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90381,268,'Umamaheswarapuram','521110',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90382,268,'Uppaluru','521151',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90383,268,'Vallampatla','521227',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90384,268,'Valluripalem','521163',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90385,268,'Vamukuntla','521235',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90386,268,'Vanukuru','521151',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90387,268,'Vasanthanagar','520007',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90388,268,'Vatsavai','521402',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90389,268,'Vattigudipadu','521211',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90390,268,'Vavilala','521235',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90391,268,'Vedadri','521457',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90392,268,'Veerapanenigudem','521286',1,0,'2022-03-03 13:11:53','2022-03-03 13:11:53'),(90393,268,'Veeravalli','521110',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90394,268,'Veerullapadu','521170',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90395,268,'Veladikothapalem','521182',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90396,268,'Velagaleru','521229',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90397,268,'Veleru','521110',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90398,268,'Vellanki','521181',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90399,268,'Vellaturu','521229',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90400,268,'Velpuru','521256',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90401,268,'Velpuru','521104',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90402,268,'Velvdam','521230',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90403,268,'Vemavaram','521190',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90404,268,'Vemireddipalle','521227',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90405,268,'Vemulanarva','521402',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90406,268,'Vemulapalli','521185',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90407,268,'Venkatapuram','521190',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90408,268,'Venkatapuram','521230',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90409,268,'Venkateswarapuram','520010',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90410,268,'Vibharintapadu','521182',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90411,268,'Vijayawada Bus Stand','520002',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90412,268,'Vijayawada H.O','520001',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90413,268,'Vijayawada Municipal Offi','520001',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90414,268,'Vinagadapa','521403',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90415,268,'Virankilock','521250',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90416,268,'Vj Polytechnic','520008',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90417,268,'Vja Railway Junction','520001',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90418,268,'Vja Rly Divl Office','520001',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90419,268,'VTPS','521456',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90420,268,'Vutukuru','521401',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90421,268,'Vuyyuru East','521165',1,0,'2022-03-03 13:11:54','2022-03-03 13:11:54'),(90422,268,'Vuyyuru','521165',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90423,268,'Wnchipet','520001',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90424,268,'Yakamuru','521165',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90425,268,'Yanamalakuduru','520007',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90426,268,'Zakkulanekkalam','521102',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90427,269,'A.Gokulapadu','518467',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90428,269,'Abdullapuram','518533',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90429,269,'Adoni Arts College','518302',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90430,269,'Adoni H.O','518301',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90431,269,'Adoni-town','518301',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90432,269,'Agaveli','518225',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90433,269,'Alaganur','518405',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90434,269,'Alardinne','518465',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90435,269,'Alavala','518463',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90436,269,'Alebad','518220',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90437,269,'Alur (Kurnool)','518395',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90438,269,'Amadaguntla','518467',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90439,269,'Amakathadu','518216',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90440,269,'Aminabad','518390',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90441,269,'Anugonda','518467',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90442,269,'Arekallu','518302',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90443,269,'Arikera','518395',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90444,269,'Arlabanda','518313',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90445,269,'Ashoknagar (Kurnool)','518005',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90446,269,'Aspari','518347',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90447,269,'Atikalagundu','518347',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90448,269,'Atmakur (Kurnool)','518422',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90449,269,'B.Agraharam','518350',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90450,269,'B.Ramadurgam','518222',1,0,'2022-03-03 13:11:55','2022-03-03 13:11:55'),(90451,269,'B.Tandrapadu','518007',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90452,269,'Badinehal','518344',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90453,269,'Baichigeri','518302',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90454,269,'Bairluty','518422',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90455,269,'Balaji Nagar','518006',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90456,269,'Balapalapalli','518598',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90457,269,'Banakacherla','518533',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90458,269,'Banavanur','518350',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90459,269,'Banavasi','518323',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90460,269,'Bannuru','518401',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90461,269,'Bantanahalu','518396',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90462,269,'Bapuram','518348',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90463,269,'Bapuram','518344',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90464,269,'Basapuram','518302',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90465,269,'Basarakodu','518347',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90466,269,'Bastipadu','518218',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90467,269,'Belagal','518462',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90468,269,'Belagallu','518313',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90469,269,'Beldona','518396',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90470,269,'Bethamcherla','518599',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90471,269,'Bevinahal','518348',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90472,269,'Bhagya Nagar-kurnool','518004',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90473,269,'Bhanumukkala','518422',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90474,269,'Bhar Peta Adoni','518301',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90475,269,'Bhojanam','518533',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90476,269,'Bijina Vemula','518411',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90477,269,'Bilakalaguduru','518508',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90478,269,'Bilehalu','518395',1,0,'2022-03-03 13:11:56','2022-03-03 13:11:56'),(90479,269,'Billekallu','518347',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90480,269,'Biravolu','518412',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90481,269,'Bogolu','518222',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90482,269,'Bollavaram','518432',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90483,269,'Bollavaram','518218',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90484,269,'Bommireddipalli','518216',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90485,269,'Bondimadugula','518468',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90486,269,'Boyanacheruvupalle','518220',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90487,269,'Boyarevula','518533',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90488,269,'Brahmanadoddi','518462',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90489,269,'Brahmanakotkur','518432',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90490,269,'Bugganipalli','518206',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90491,269,'Bukkapuram','518002',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90492,269,'Burandoddi','518462',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90493,269,'Burugula','518220',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90494,269,'Buruzula','518380',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90495,269,'Byluppala','518350',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90496,269,'Cement Nagar','518206',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90497,269,'Chakkaralla','518380',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90498,269,'Chandoli','518380',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90499,269,'Chandrapalli','518221',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90500,269,'Channampalli','518390',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90501,269,'Chanugondla','518464',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90502,269,'Chatlamallapuram','518218',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90503,269,'Chatnihalli','518345',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90504,269,'Chelimilla','518442',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90505,269,'Chellelichelimala','518225',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90506,269,'Cherukucherla','518405',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90507,269,'Cherukulapadu','518216',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90508,269,'Chigali','518347',1,0,'2022-03-03 13:11:57','2022-03-03 13:11:57'),(90509,269,'Chilakaladona','518345',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90510,269,'Chinna Pendekallu','518350',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90511,269,'Chinnaharivanam','518308',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90512,269,'Chinnahothur','518395',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90513,269,'Chinnahulthi','518380',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90514,269,'Chinnahyti','518346',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90515,269,'Chinnapodilla','518221',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90516,269,'Chinnatekur','518218',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90517,269,'Chinnathumbalam','518313',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90518,269,'Chintakunta','518348',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90519,269,'Chintalapalli','518405',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90520,269,'Chippagiri','518396',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90521,269,'Chirtanakallu','518313',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90522,269,'Chityala','518222',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90523,269,'Chowtkur','518405',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90524,269,'Chudi','518333',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90525,269,'Chunchu Erragudi','518225',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90526,269,'D. Kotakonda','518350',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90527,269,'Daivamdinne','518360',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90528,269,'Damagatla','518432',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90529,269,'Devanabanda','518347',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90530,269,'Devanakonda','518465',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90531,269,'Devanur','518405',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90532,269,'Devarabanda','518221',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90533,269,'Dhanapuram','518302',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90534,269,'Dharmavaram','518222',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90535,269,'Dhone','518222',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90536,269,'Dhone-bazar','518222',1,0,'2022-03-03 13:11:58','2022-03-03 13:11:58'),(90537,269,'Dibbanakallu','518302',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90538,269,'Diguvapadu','518452',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90539,269,'Dinnedevarapadu','518002',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90540,269,'Doddanakeri','518323',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90541,269,'Doddimekala','518323',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90542,269,'Dommaladinne','518344',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90543,269,'Duddi','518313',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90544,269,'Dudekonda','518380',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90545,269,'Dudyala','518422',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90546,269,'E.Thandrapadu','518004',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90547,269,'Edduladoddi','518468',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90548,269,'Edururu','518004',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90549,269,'Ellarthi','518395',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90550,269,'Enigabala','518360',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90551,269,'Erigeri','518344',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90552,269,'Errabadu','518463',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90553,269,'Erradoddi','518467',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90554,269,'Erraguduru','518442',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90555,269,'Erramattam','518422',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90556,269,'Erukalacheruvu','518225',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90557,269,'G.D.Project','518463',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90558,269,'G.Erragudi','518390',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90559,269,'G.Hosanahalli','518302',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90560,269,'G.Pulla Reddy Eng College','518002',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90561,269,'G.Singavaram','518004',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90562,269,'Gadivemula','518508',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90563,269,'Gajjehalli','518308',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90564,269,'Ganapuram','518401',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90565,269,'Gani','518010',1,0,'2022-03-03 13:11:59','2022-03-03 13:11:59'),(90566,269,'Ganjihalli','518463',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90567,269,'Gargeyapuram','518452',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90568,269,'Garladinne','518220',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90569,269,'Gokavaram','518422',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90570,269,'Gondiparla','518004',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90571,269,'Gonegandla','518463',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90572,269,'Gorantla','518467',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90573,269,'Govardhanagiri','518216',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90574,269,'Govt Live Stock Form','518360',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90575,269,'GPRE College','518007',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90576,269,'Grandhivemula','518508',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90577,269,'Gudikal','518360',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90578,269,'Gudikambali','518333',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90579,269,'Gudipadu','518221',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90580,269,'Gudipadu','518466',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90581,269,'Gudur (Kurnool)','518466',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90582,269,'Gulyam','518348',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90583,269,'Gummanur','518396',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90584,269,'Gundlakonda','518468',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90585,269,'Gundrevula','518462',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90586,269,'Guntakandala','518533',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90587,269,'Gutupalli','518598',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90588,269,'Guvvalakunta','518422',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90589,269,'H.Khairvadi','518463',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90590,269,'H.Kottala','518598',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90591,269,'H.Muravani','518323',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90592,269,'Halaharvi','518360',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90593,269,'Halaharvi','518348',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90594,269,'Halebidu','518395',1,0,'2022-03-03 13:12:00','2022-03-03 13:12:00'),(90595,269,'Haligera','518347',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90596,269,'Halvi','518333',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90597,269,'Hampa','518385',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90598,269,'Hanavolu','518344',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90599,269,'Hardageri','518348',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90600,269,'Harivanam','518308',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90601,269,'Hattibelagallu','518395',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90602,269,'Hebbatam','518308',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90603,269,'Holalagondi','518346',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90604,269,'Honnur','518346',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90605,269,'Hosuru','518380',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90606,269,'Hussainapuram','518221',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90607,269,'Hussainapuram','518010',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90608,269,'Ibharampuram','518345',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90609,269,'Inagandla','518462',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90610,269,'Indireswaram','518422',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90611,269,'Industrial Estate','518003',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90612,269,'Ingaladahal','518308',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90613,269,'Iranbanda','518463',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90614,269,'Iskala','518422',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90615,269,'Isvi','518302',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90616,269,'Jagadurthi','518222',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90617,269,'Jakkasanikuntla','518221',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90618,269,'Jaladurgam','518220',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90619,269,'Jalakanur','518405',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90620,269,'Jampapuram','518349',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90621,269,'Jilledubudakala','518465',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90622,269,'Joharapuram','518002',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90623,269,'Joharapuram','518347',1,0,'2022-03-03 13:12:01','2022-03-03 13:12:01'),(90624,269,'Jonnagiri','518390',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90625,269,'Julekallu','518462',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90626,269,'Jummaladinne','518313',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90627,269,'Jutur','518401',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90628,269,'Jutur','518380',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90629,269,'K.Markapuram','518467',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90630,269,'K.N.Puram','518467',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90631,269,'Kadamakuntla','518221',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90632,269,'Kadimetla','518360',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90633,269,'Kadivella','518350',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90634,269,'Kadumur','518452',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90635,269,'Kaggallu','518349',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90636,269,'Kalachatla','518221',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90637,269,'Kalludevakuntla','518345',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90638,269,'Kallukunta','518323',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90639,269,'Kalluru','518003',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90640,269,'Kalugotla','518217',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90641,269,'Kalugotla','518360',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90642,269,'Kalva','518010',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90643,269,'Kamaganikuntla','518222',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90644,269,'Kamalapuram','518222',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90645,269,'Kamavaram','518302',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90646,269,'Kambadahal','518360',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90647,269,'Kambadahal','518462',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90648,269,'Kambaladinne','518360',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90649,269,'Kambalapadu','518225',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90650,269,'Kaminehal','518348',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90651,269,'Kammarchedu','518302',1,0,'2022-03-03 13:12:02','2022-03-03 13:12:02'),(90652,269,'Kanakaveedu','518343',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90653,269,'Kandanathi','518350',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90654,269,'Kandikayapalli','518206',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90655,269,'Kandukuru','518313',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90656,269,'Kapati','518323',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90657,269,'Kappatralla','518465',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90658,269,'Karivemula','518465',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90659,269,'Karivena','518422',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90660,269,'Karumanchi','518350',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90661,269,'Katarukonda','518222',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90662,269,'Katriki','518333',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90663,269,'Kavuthalam','518344',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90664,269,'Kethavaram','518452',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90665,269,'Khairuppala','518465',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90666,269,'Khajeepuram','518396',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90667,269,'KNL-camp-B','518002',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90668,269,'Knl-osmaniacollege','518001',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90669,269,'Kodumur','518464',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90670,269,'Kogilathota','518346',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90671,269,'Koilakonda','518222',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90672,269,'Kokkarchedu','518348',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90673,269,'Kollabavapuram','518432',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90674,269,'Komarole','518010',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90675,269,'Kommemarri','518220',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90676,269,'Kondapuram','518462',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90677,269,'Konganapadu','518218',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90678,269,'Konidela','518411',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90679,269,'Korrapolur','518508',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90680,269,'Kosanapalle','518216',1,0,'2022-03-03 13:12:03','2022-03-03 13:12:03'),(90681,269,'Kosigi','518313',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90682,269,'Kotakonda','518225',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90683,269,'Kotchervu','518222',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90684,269,'Kotekallu','518360',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90685,269,'Kothakota','518466',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90686,269,'Kothakota','518221',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90687,269,'Kothapalli','518422',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90688,269,'Kothur','518390',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90689,269,'Krishna Puram','518464',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90690,269,'Krishnagiri','518225',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90691,269,'Krishnapuram','518217',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90692,269,'Kulumala','518463',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90693,269,'Kulumalapalli','518599',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90694,269,'Kunkanur','518465',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90695,269,'Kuntanahal','518344',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90696,269,'Kuppagallu','518344',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90697,269,'Kurnool Bazar','518001',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90698,269,'Kurnool Dt Court','518001',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90699,269,'Kurnool H.O','518001',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90700,269,'Kurnool Kothapeta','518004',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90701,269,'Kurnool Medicalcollege','518002',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90702,269,'Kurnool-chowk','518001',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90703,269,'Kurukunda','518422',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90704,269,'Kurunur','518464',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90705,269,'Kuruvalli','518395',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90706,269,'L.Polur','518218',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90707,269,'Laddagiri','518467',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90708,269,'Lakkasagaram','518225',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90709,269,'Lakshminagaram','518216',1,0,'2022-03-03 13:12:04','2022-03-03 13:12:04'),(90710,269,'Lingadahalli','518308',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90711,269,'Lingapuram','518401',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90712,269,'Loddipalli','518002',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90713,269,'M.Agraharam','518385',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90714,269,'M.Lingapuram','518422',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90715,269,'M.Pendakallu','518217',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90716,269,'M.S.Nagar','518002',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90717,269,'Machapuram','518343',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90718,269,'Madananthapuram','518390',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90719,269,'Maddikera Agraharam','518385',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90720,269,'Maddikera','518385',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90721,269,'Maddur','518533',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90722,269,'Madhavaram (kurnool)B.O','518349',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90723,269,'Madhavaram','518533',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90724,269,'Madhire','518302',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90725,269,'Malapalli','518313',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90726,269,'Malkapuram','518222',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90727,269,'Mallapuram','518466',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90728,269,'Mallepalli','518216',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90729,269,'Mallikarjunahalli','518396',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90730,269,'Malliyala','518222',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90731,269,'Malyala','518401',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90732,269,'Mamidalapadu','518004',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90733,269,'Manchalakatta','518508',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90734,269,'Mandlem','518401',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90735,269,'Manekurthi','518302',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90736,269,'Mantralaya (Kurnool)','518345',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90737,269,'Mantriki','518323',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90738,269,'Marakattu','518395',1,0,'2022-03-03 13:12:05','2022-03-03 13:12:05'),(90739,269,'Marella','518468',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90740,269,'Marlamadiki','518346',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90741,269,'Masapeta','518452',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90742,269,'Medehal','518348',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90743,269,'Meedivemula','518002',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90744,269,'Mekadona','518323',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90745,269,'Mettupalli','518221',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90746,269,'Midthur','518405',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90747,269,'Mittakandala','518442',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90748,269,'Molagavalli','518395',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90749,269,'Mothukuru','518533',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90750,269,'Mudamalakurthi','518464',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90751,269,'Muddanageri','518395',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90752,269,'Muddavaram','518599',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90753,269,'Mudumala','518462',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90754,269,'Mugati','518360',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90755,269,'Mukkella','518468',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90756,269,'Mulagundam','518350',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90757,269,'Munagala','518466',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90758,269,'Munagalapadu','518004',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90759,269,'Musalayacheruvu','518599',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90760,269,'Musalimadugu','518422',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90761,269,'Musanahalli','518302',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90762,269,'Muthukur','518347',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90763,269,'Mutsumarri','518411',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90764,269,'N R Peta KNL','518004',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90765,269,'N.Khairavadi','518345',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90766,269,'N.Konthalapadu','518010',1,0,'2022-03-03 13:12:06','2022-03-03 13:12:06'),(90767,269,'N.Rangapuram','518221',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90768,269,'N.S.C.Farm','518401',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90769,269,'N.Venkatapuram','518216',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90770,269,'Nadichagi','518333',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90771,269,'Nagaladinne','518360',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90772,269,'Naganathanahalli','518308',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90773,269,'Nagardona','518396',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90774,269,'Nagaruru','518347',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90775,269,'Nallachelimala','518468',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90776,269,'Nallakalva','518422',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90777,269,'Nancherla','518385',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90778,269,'Nandanapalli','518452',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90779,269,'Nandavaram','518343',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90780,269,'Nandikotkur','518401',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90781,269,'Nandikotkur-bazar','518401',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90782,269,'Nandikunta','518422',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90783,269,'Narayanapauram','518533',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90784,269,'Narnur','518002',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90785,269,'Nayakallu','518218',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90786,269,'Nehru Nagar','518411',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90787,269,'Nelatalamarri','518465',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90788,269,'Nellibanda','518465',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90789,269,'Nemakallu','518396',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90790,269,'Nereducherla','518220',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90791,269,'Nerniki','518395',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90792,269,'Nidjur','518004',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90793,269,'Nitravatti','518348',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90794,269,'Om Nagar','518313',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90795,269,'P.Devalapuram','518533',1,0,'2022-03-03 13:12:07','2022-03-03 13:12:07'),(90796,269,'P.Lingala','518401',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90797,269,'P.R.Palli','518221',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90798,269,'Padidempadu','518452',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90799,269,'Pagidala','518412',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90800,269,'Pagidirai','518390',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90801,269,'Pallidoddi','518465',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90802,269,'Palukudoddi','518462',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90803,269,'Pamulapadu','518442',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90804,269,'Panchalingala','518004',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90805,269,'Pandikona','518380',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90806,269,'Parla','518467',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90807,269,'Parlapalli','518360',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90808,269,'Parumanchala','518401',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90809,269,'Pasupula','518452',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90810,269,'Pasupula','518220',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90811,269,'Pattikonda','518380',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90812,269,'Peapully','518221',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90813,269,'Peddahothur','518395',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90814,269,'Peddakadubur','518323',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90815,269,'Peddakothali','518360',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90816,269,'Peddamarriveedu','518463',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90817,269,'Peddanelatur','518463',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90818,269,'Peddapadu','518003',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90819,269,'Peddapaya','518221',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90820,269,'Peddapodilla','518221',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90821,269,'Peddathumbalam','518302',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90822,269,'Pendekallu Bus Stand','518468',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90823,269,'Pendekallu','518468',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90824,269,'Peravali','518390',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90825,269,'Pesalabanda','518323',1,0,'2022-03-03 13:12:08','2022-03-03 13:12:08'),(90826,269,'Pinnapuram','518422',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90827,269,'Polukallu','518462',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90828,269,'Pothidoddi','518221',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90829,269,'Pothugal','518225',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90830,269,'Prakash Nagar','518004',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90831,269,'Prathakota','518412',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90832,269,'Prathakota-east','518412',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90833,269,'Pudur','518432',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90834,269,'Pulakurthi','518462',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90835,269,'Pulichinta','518343',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90836,269,'Pulikonda','518380',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90837,269,'Pullagummi','518217',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90838,269,'Puricherla','518452',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90839,269,'Putchakayalamada','518380',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90840,269,'Pyalakurthi','518464',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90841,269,'R.Kanapuram','518466',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90842,269,'R.Konthalapadu','518004',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90843,269,'R.Kothapalli','518598',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90844,269,'Racherla','518220',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90845,269,'Rahimanpuram','518598',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90846,269,'Ramadurgam','518396',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90847,269,'Ramalla Kota','518217',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90848,269,'Rampalli','518468',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90849,269,'Rangapuram','518598',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90850,269,'Ratana','518380',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90851,269,'Ratsamarri','518349',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90852,269,'Regadigudur','518508',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90853,269,'Remata','518466',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90854,269,'Rollapadu','518405',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90855,269,'Roudur','518344',1,0,'2022-03-03 13:12:09','2022-03-03 13:12:09'),(90856,269,'Rtc Complex Adoni','518301',1,0,'2022-03-03 13:12:10','2022-03-03 13:12:10'),(90857,269,'Rudravaram','518452',1,0,'2022-03-03 13:12:10','2022-03-03 13:12:10'),(90858,269,'S.Boyanapalli','518217',1,0,'2022-03-03 13:12:10','2022-03-03 13:12:10'),(90859,269,'S.Erragudi','518467',1,0,'2022-03-03 13:12:10','2022-03-03 13:12:10'),(90860,269,'S.K.D.Nagar','518301',1,0,'2022-03-03 13:12:10','2022-03-03 13:12:10'),(90861,269,'S.R.P.M','518004',1,0,'2022-03-03 13:12:10','2022-03-03 13:12:10'),(90862,269,'S.S.Dam East','518102',1,0,'2022-03-03 13:12:10','2022-03-03 13:12:10'),(90863,269,'Salkapuram','518467',1,0,'2022-03-03 13:12:10','2022-03-03 13:12:10'),(90864,269,'Sammatageri','518346',1,0,'2022-03-03 13:12:10','2022-03-03 13:12:10'),(90865,269,'Sankirenipalli','518412',1,0,'2022-03-03 13:12:10','2022-03-03 13:12:10'),(90866,269,'Santhekudlur','518308',1,0,'2022-03-03 13:12:10','2022-03-03 13:12:10'),(90867,269,'SAP Camp-kNL','518003',1,0,'2022-03-03 13:12:10','2022-03-03 13:12:10'),(90868,269,'Sarparajapuram','518217',1,0,'2022-03-03 13:12:10','2022-03-03 13:12:10'),(90869,269,'Sathanikota','518401',1,0,'2022-03-03 13:12:10','2022-03-03 13:12:10'),(90870,269,'Sathanur','518349',1,0,'2022-03-03 13:12:10','2022-03-03 13:12:10'),(90871,269,'Sebhaspuram','518221',1,0,'2022-03-03 13:12:10','2022-03-03 13:12:10'),(90872,269,'Sekunala','518010',1,0,'2022-03-03 13:12:10','2022-03-03 13:12:10'),(90873,269,'Siddapuram','518348',1,0,'2022-03-03 13:12:10','2022-03-03 13:12:10'),(90874,269,'Siddapuram','518422',1,0,'2022-03-03 13:12:10','2022-03-03 13:12:10'),(90875,269,'Siddepalli','518422',1,0,'2022-03-03 13:12:10','2022-03-03 13:12:10'),(90876,269,'Sitharampuram','518599',1,0,'2022-03-03 13:12:10','2022-03-03 13:12:10'),(90877,269,'Sivapuram','518422',1,0,'2022-03-03 13:12:10','2022-03-03 13:12:10'),(90878,269,'Somayajulapalli','518010',1,0,'2022-03-03 13:12:10','2022-03-03 13:12:10'),(90879,269,'Sri Krishna Nagar','518002',1,0,'2022-03-03 13:12:10','2022-03-03 13:12:10'),(90880,269,'Srisailam','518101',1,0,'2022-03-03 13:12:10','2022-03-03 13:12:10'),(90881,269,'Stantanpuram','518006',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90882,269,'Sudepalli','518222',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90883,269,'Sugur','518349',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90884,269,'Sulekeri','518333',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90885,269,'Sunkeswari','518349',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90886,269,'T Samala Gudur','518462',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90887,269,'T.B.P.Colony','518360',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90888,269,'T.Sakibanda','518348',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90889,269,'T.Sallakudlur','518360',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90890,269,'T.Sanugondla','518468',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90891,269,'Tadakanapalli','518218',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90892,269,'Talamudipi','518508',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90893,269,'Talla Gokulapadu','518216',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90894,269,'Tangadancha','518401',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90895,269,'Tangaradona','518347',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90896,269,'Tarigopula','518401',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90897,269,'Tarturu','518401',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90898,269,'Ternekallu','518465',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90899,269,'Thatipadu','518412',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90900,269,'Thimmandoddi','518462',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90901,269,'Thippanuru','518463',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90902,269,'Tholisapuram','518004',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90903,269,'Thudicherla','518508',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90904,269,'Togarchedu','518216',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90905,269,'Tuggali','518390',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90906,269,'Tummalur','518401',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90907,269,'Tungabhadra','518349',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90908,269,'Udumulapadu','518222',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90909,269,'Ulchala','518467',1,0,'2022-03-03 13:12:11','2022-03-03 13:12:11'),(90910,269,'Ulindakonda','518218',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90911,269,'Ungaralagundla','518222',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90912,269,'Uppalapadu','518002',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90913,269,'Upparahal','518344',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90914,269,'Upparlapalli','518390',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90915,269,'Urukunda','518344',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90916,269,'Utakonda','518220',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90917,269,'Vaddeman','518432',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90918,269,'Vadlaramapuram','518422',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90919,269,'Vagarur Thimmapuram','518349',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90920,269,'Vanala','518508',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90921,269,'Vandagallu','518313',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90922,269,'Vandavagili','518308',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90923,269,'Varkur','518464',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90924,269,'Veepanagandla','518405',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90925,269,'Veldurthi','518216',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90926,269,'Velgode','518533',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90927,269,'Velpanur','518533',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90928,269,'Vempenta','518533',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90929,269,'Vengalampalli','518221',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90930,269,'Venkatagiri','518217',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90931,269,'Venkatagiri','518360',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90932,269,'Venkatagiri','518464',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90933,269,'Venkatapuram','518225',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90934,269,'Virupapuram','518346',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90935,269,'Virupapuram','518347',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90936,269,'Vorvakallu','518010',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90937,269,'Vuyyalawada','518002',1,0,'2022-03-03 13:12:12','2022-03-03 13:12:12'),(90938,269,'Yatakallu','518465',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90939,269,'Yelamakur','518465',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90940,269,'Yembai','518599',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90941,269,'Yemmiganur','518360',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90942,269,'Yemmiganur-bazar','518360',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90943,269,'Yenugumarri','518221',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90944,269,'Yeruru','518396',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90945,269,'A.Kodur','518523',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90946,269,'Abdullapuram','518123',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90947,269,'Ahobilam','518543',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90948,269,'Akkampalli','518145',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90949,269,'Akumalla','518196',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90950,269,'Alamur','518543',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90951,269,'Alamur','518112',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90952,269,'Alavakonda','518165',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90953,269,'Allagadda MDG','518543',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90954,269,'Allur','518134',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90955,269,'Ammireddinagar','518135',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90956,269,'Ankireddypalli','518123',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90957,269,'Anupur','518176',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90958,269,'Appalapuram','518124',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90959,269,'Ayalur','518502',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90960,269,'B.Kodur','518523',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90961,269,'Bachepalle','518543',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90962,269,'Balapanur','518112',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90963,269,'Balavegammanagar','518573',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90964,269,'Banaganapalle','518124',1,0,'2022-03-03 13:12:13','2022-03-03 13:12:13'),(90965,269,'Banaganapalle South','518124',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90966,269,'Bandi Atmakur','518523',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90967,269,'Bathalur','518510',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90968,269,'Beeravolu','518583',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90969,269,'Belum','518122',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90970,269,'Bhillalapuram','518502',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90971,269,'Bhimavaram','518523',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90972,269,'Bhimunipadu','518134',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90973,269,'Bhupanapadu','518112',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90974,269,'Bijanavemula','518134',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90975,269,'Biravolu','518176',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90976,269,'Bodemmanur','518155',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90977,269,'Bollavaram','518512',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90978,269,'Boyalakuntla','518583',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90979,269,'Chabolu','518502',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90980,269,'Chagalamarri','518553',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90981,269,'Chakarajuvemula','518135',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90982,269,'Chalama','518502',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90983,269,'Chandalur','518594',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90984,269,'Chanugondla','518196',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90985,269,'Chapirevula','518502',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90986,269,'Chennampalli','518122',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90987,269,'Chennur','518583',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90988,269,'Cherlopalli','518122',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90989,269,'Cheruvupalle','518176',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90990,269,'Chidukur','518511',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90991,269,'Chinnakambalur','518594',1,0,'2022-03-03 13:12:14','2022-03-03 13:12:14'),(90992,269,'Chinnavangali','518553',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(90993,269,'Chintakommudinne','518543',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(90994,269,'Chintalacheruvu','518553',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(90995,269,'Chintalayapalli','518123',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(90996,269,'Deebaguntla','518502',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(90997,269,'Dornipadu','518135',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(90998,269,'Durvesi','518511',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(90999,269,'Eernipadu','518512',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(91000,269,'Erragudidinne','518510',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(91001,269,'Erraguntla','518523',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(91002,269,'G.Jambuladinne','518543',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(91003,269,'G.Singavaram','518124',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(91004,269,'Gadigarevula','518511',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(91005,269,'Gajulapalle','518583',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(91006,269,'Galichennayapalem','518513',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(91007,269,'Gangavaram','518583',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(91008,269,'Giddalur(Kkt)','518166',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(91009,269,'Godiganur','518553',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(91010,269,'Gollagutta','518124',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(91011,269,'Gopavaram','518583',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(91012,269,'Gorivimanipalle','518123',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(91013,269,'Gospadu','518674',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(91014,269,'Gotlur','518553',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(91015,269,'Govindapalle','518502',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(91016,269,'Gulladurthi','518134',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(91017,269,'Gumparamandinne','518573',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(91018,269,'Gundampadu','518583',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(91019,269,'Gundupapala','518134',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(91020,269,'Gunjalapadu','518134',1,0,'2022-03-03 13:12:15','2022-03-03 13:12:15'),(91021,269,'Guntanala','518593',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91022,269,'Harivaram','518134',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91023,269,'Illuri Kotha Peta','518186',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91024,269,'Industrial Estate (Kurnool)','518502',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91025,269,'Injedu','518155',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91026,269,'Itekala','518123',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91027,269,'Jeenepalle','518573',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91028,269,'Jillalla','518176',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91029,269,'Jillella','518563',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91030,269,'Joladarasi','518134',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91031,269,'Julepalle','518674',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91032,269,'Kakanur','518523',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91033,269,'Kakaravada','518145',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91034,269,'Kalugotla','518134',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91035,269,'Kalugotlapalle','518553',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91036,269,'Kalvatala','518123',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91037,269,'Kamalapuri','518196',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91038,269,'Kaminenipalle','518563',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91039,269,'Kampamalla','518134',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91040,269,'Kanakadripalli','518123',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91041,269,'Kanala','518165',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91042,269,'Kanala','518593',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91043,269,'Kanthinagar','518502',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91044,269,'Karimaddula','518523',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91045,269,'Katikavanikunta','518124',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91046,269,'Kavulur','518112',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91047,269,'Koilakuntla Bus Stand','518134',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91048,269,'Koilakuntla','518134',1,0,'2022-03-03 13:12:16','2022-03-03 13:12:16'),(91049,269,'Kolimigundla','518123',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91050,269,'Kondajutur','518511',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91051,269,'Kondamanayunipalli','518122',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91052,269,'Kondapuram','518135',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91053,269,'Kondupalle','518543',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91054,269,'Konededu','518112',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91055,269,'Koratamaddi','518511',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91056,269,'Kotakandukur','518543',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91057,269,'Kotakonda','518583',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91058,269,'Kotapadu','518573',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91059,269,'Kothapalle','518502',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91060,269,'Kottala','518502',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91061,269,'Krishnagiri','518124',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91062,269,'Kristipadu','518134',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91063,269,'Kunukuntala','518122',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91064,269,'Kypa','518124',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91065,269,'Lingala','518134',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91066,269,'Lingambodu','518124',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91067,269,'Lingapuram','518513',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91068,269,'M.Chintakunta','518674',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91069,269,'M.Krishnapuram','518573',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91070,269,'M.V. Nagar','518543',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91071,269,'Maddur','518553',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91072,269,'Maddur','518593',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91073,269,'Mahadevapuram','518583',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91074,269,'Mahanandi','518502',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91075,269,'Mahanandi Cattle Farm','518502',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91076,269,'Mallavemula','518553',1,0,'2022-03-03 13:12:17','2022-03-03 13:12:17'),(91077,269,'Mandalur','518543',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91078,269,'Mangampeta','518124',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91079,269,'Maseedpuram','518502',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91080,269,'Mayalur','518155',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91081,269,'Meerapuram','518124',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91082,269,'Meerjapuram','518123',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91083,269,'Mettupalle','518122',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91084,269,'Mitnala','518593',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91085,269,'Mittapalle','518124',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91086,269,'Mittapalle','518543',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91087,269,'Mukkamalla','518165',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91088,269,'Muthalur','518543',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91089,269,'Muthyalapadu','518553',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91090,269,'N.G.O.S Colony','518502',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91091,269,'Nallagatla','518510',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91092,269,'Nandavaram','518124',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91093,269,'Nandipadu','518123',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91094,269,'Nandipalle','518502',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91095,269,'Nandivargam','518176',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91096,269,'Nandyal Bazar','518501',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91097,269,'Nandyal H.O','518501',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91098,269,'Nandyal R.S.','518502',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91099,269,'Nelampadu','518553',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91100,269,'Noone Palle','518502',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91101,269,'Nossam','518145',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91102,269,'Obulampalle','518543',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91103,269,'Owk','518122',1,0,'2022-03-03 13:12:18','2022-03-03 13:12:18'),(91104,269,'Padakandla','518543',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91105,269,'Palukur','518176',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91106,269,'Pandurangapuram','518502',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91107,269,'Panem Bus Stand','518112',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91108,269,'Panem','518112',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91109,269,'Parnapalle','518523',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91110,269,'Pasurapadu','518674',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91111,269,'Pathakandukur','518543',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91112,269,'Pathapadu','518124',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91113,269,'Peddabodanam','518543',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91114,269,'Peddachintakunta','518543',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91115,269,'Peddaemmanur','518155',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91116,269,'Peddakambalur','518594',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91117,269,'Peddakopperla','518134',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91118,269,'Peddavangali','518553',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91119,269,'Peddavanthurla','518166',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91120,269,'Perusomula','518166',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91121,269,'Pesaravai','518523',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91122,269,'Petnikota','518123',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91123,269,'Polur (Kurnool)','518511',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91124,269,'Pottipadu','518134',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91125,269,'Pulimaddi','518511',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91126,269,'Pusulur','518593',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91127,269,'R.Jammuladinne','518155',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91128,269,'R.Krishnapuram','518543',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91129,269,'R.Lingamdinne','518166',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91130,269,'R.Papampalle','518543',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91131,269,'Raithunagaram','518502',1,0,'2022-03-03 13:12:19','2022-03-03 13:12:19'),(91132,269,'Rajanagaram','518573',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91133,269,'Ramachandrapuram','518135',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91134,269,'Ramakrishnapuram','518166',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91135,269,'Ramakrishnapuram','518176',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91136,269,'Ramapuram','518122',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91137,269,'Ramapuram','518513',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91138,269,'Ramapvaram','518122',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91139,269,'Ramathirtham','518176',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91140,269,'Ramireddipalle','518166',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91141,269,'Rayamalpuram','518511',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91142,269,'Revanur','518134',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91143,269,'Rudravaram','518594',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91144,269,'Rupanagudi','518155',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91145,269,'S.Kothur','518176',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91146,269,'S.Lingam Dinne','518543',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91147,269,'S.Nagulavaram','518593',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91148,269,'Sangapatnam','518196',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91149,269,'Sanjamala','518165',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91150,269,'Sanjeeva Nagar','518501',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91151,269,'Santajutur','518513',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91152,269,'Santhiram Medical College','518502',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91153,269,'Sarvaipalle','518543',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91154,269,'Singanapalle','518196',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91155,269,'Singavaram','518513',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91156,269,'Sirvel','518563',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91157,269,'Sivavaram','518122',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91158,269,'Srinivasa Nagar','518501',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91159,269,'Srirangapuram','518583',1,0,'2022-03-03 13:12:20','2022-03-03 13:12:20'),(91160,269,'Suddamalla','518155',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91161,269,'Sugalithanda','518112',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91162,269,'Sunkesula','518196',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91163,269,'T.Lingamdinne','518594',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91164,269,'Tamballapalle','518124',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91165,269,'Tangatur','518124',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91166,269,'Tekke','518501',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91167,269,'Tellapuri','518124',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91168,269,'Thammadapalle','518512',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91169,269,'Thammarajupalle','518112',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91170,269,'Thimmanayanipeta','518166',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91171,269,'Thimmapuram','518512',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91172,269,'Thollamadugu','518123',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91173,269,'Thudumaladinne','518155',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91174,269,'Thummalapenta','518123',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91175,269,'Togarchedu','518502',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91176,269,'U.Govindinne','518135',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91177,269,'U.Kothapalle','518135',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91178,269,'Udumalpuram','518502',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91179,269,'Uppalapadu','518122',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91180,269,'Uyyalawada','518155',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91181,269,'Vaddugandla','518112',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91182,269,'Vasanthapuram','518196',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91183,269,'Veerareddypalle','518573',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91184,269,'Venkatapuram','518510',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91185,269,'Venkatapuram','518124',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91186,269,'Yagantipalle','518124',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91187,269,'Yallur','518573',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91188,269,'Yanakandla','518124',1,0,'2022-03-03 13:12:21','2022-03-03 13:12:21'),(91189,269,'Yellavathula','518583',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91190,269,'Yerragudi','518124',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91191,269,'Yerragudi','518166',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91192,269,'Yerraguntla (Kurnool)','518510',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91193,270,'Adurupalli','524342',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91194,270,'Akkagaripeta','524129',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91195,270,'Akkampeta','524405',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91196,270,'Akkampeta','524121',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91197,270,'Alimili','524131',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91198,270,'Althurthi','524345',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91199,270,'Althurupadu','524132',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91200,270,'Amancherla','524345',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91201,270,'Ammapalem','524404',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91202,270,'Ammavaripalem','524345',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91203,270,'Amuduru','524132',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91204,270,'Ananthamadugu','524407',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91205,270,'Anepudi','524123',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91206,270,'Anikepalli','524321',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91207,270,'Annamedu','524126',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91208,270,'Aravapalem','524127',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91209,270,'Armenipadu','524402',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91210,270,'Aruru','524127',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91211,270,'Athivaram','524421',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91212,270,'Ayyavaripalem','524410',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91213,270,'Baddevolu','524405',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91214,270,'Balayapalli','524404',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91215,270,'Balireddypalem','524415',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91216,270,'Ballavolu','524412',1,0,'2022-03-03 13:12:22','2022-03-03 13:12:22'),(91217,270,'Bandepalli','524405',1,0,'2022-03-03 13:12:23','2022-03-03 13:12:23'),(91218,270,'Bangarupeta','524404',1,0,'2022-03-03 13:12:23','2022-03-03 13:12:23'),(91219,270,'Bathulapalli','524309',1,0,'2022-03-03 13:12:23','2022-03-03 13:12:23'),(91220,270,'Beripeta','524126',1,0,'2022-03-03 13:12:23','2022-03-03 13:12:23'),(91221,270,'Bhatlakanupur','524402',1,0,'2022-03-03 13:12:23','2022-03-03 13:12:23'),(91222,270,'Bheemavaram','524421',1,0,'2022-03-03 13:12:23','2022-03-03 13:12:23'),(91223,270,'Bhyravaram','524421',1,0,'2022-03-03 13:12:23','2022-03-03 13:12:23'),(91224,270,'Biradavolu','524345',1,0,'2022-03-03 13:12:23','2022-03-03 13:12:23'),(91225,270,'Bojjanapalli','524414',1,0,'2022-03-03 13:12:23','2022-03-03 13:12:23'),(91226,270,'Brahmanapalli','524343',1,0,'2022-03-03 13:12:23','2022-03-03 13:12:23'),(91227,270,'Budanam','524410',1,0,'2022-03-03 13:12:23','2022-03-03 13:12:23'),(91228,270,'Buradagalikothapalem','524403',1,0,'2022-03-03 13:12:23','2022-03-03 13:12:23'),(91229,270,'Chaganam','524407',1,0,'2022-03-03 13:12:23','2022-03-03 13:12:23'),(91230,270,'Chapalapalli','524134',1,0,'2022-03-03 13:12:23','2022-03-03 13:12:23'),(91231,270,'Chatagotla','524345',1,0,'2022-03-03 13:12:23','2022-03-03 13:12:23'),(91232,270,'Chavali','524126',1,0,'2022-03-03 13:12:23','2022-03-03 13:12:23'),(91233,270,'Chejerla Kandriga','524341',1,0,'2022-03-03 13:12:23','2022-03-03 13:12:23'),(91234,270,'Chejerla','524341',1,0,'2022-03-03 13:12:23','2022-03-03 13:12:23'),(91235,270,'Chembedu','524129',1,0,'2022-03-03 13:12:23','2022-03-03 13:12:23'),(91236,270,'Chemudugunta','524320',1,0,'2022-03-03 13:12:23','2022-03-03 13:12:23'),(91237,270,'Chennur (Nellore)','524406',1,0,'2022-03-03 13:12:23','2022-03-03 13:12:23'),(91238,270,'Cherlopalli','524405',1,0,'2022-03-03 13:12:23','2022-03-03 13:12:23'),(91239,270,'Cheropalli','524408',1,0,'2022-03-03 13:12:23','2022-03-03 13:12:23'),(91240,270,'Cherukumudi','524405',1,0,'2022-03-03 13:12:23','2022-03-03 13:12:23'),(91241,270,'Chigurupadu','524421',1,0,'2022-03-03 13:12:23','2022-03-03 13:12:23'),(91242,270,'Chikavolu','524407',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91243,270,'Chilakampadu','524132',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91244,270,'Chilamanchenu','524402',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91245,270,'Chillakur','524412',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91246,270,'Chillamanur','524132',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91247,270,'Chillamur','524127',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91248,270,'Chinnagopavaram','524341',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91249,270,'Chinnapareddypalli','524132',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91250,270,'Chinnathota','524403',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91251,270,'Chintagunta','524132',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91252,270,'Chintalapalem','524343',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91253,270,'Chintalatmakur','524343',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91254,270,'Chintapudi','524129',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91255,270,'Chintavaram','524412',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91256,270,'Chipinapi','524343',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91257,270,'Chittalur','524341',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91258,270,'Chittamur','524127',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91259,270,'Chittedu','524410',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91260,270,'Chittepalli','524345',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91261,270,'Chowtapalem','524320',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91262,270,'Dachur','524342',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91263,270,'Daggavolu','524407',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91264,270,'Dakkili','524134',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91265,270,'Damanellore','524121',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91266,270,'Degapudi','524409',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91267,270,'Devaravemuru','524409',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91268,270,'Dontali','524320',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91269,270,'Doravarisatram','524123',1,0,'2022-03-03 13:12:24','2022-03-03 13:12:24'),(91270,270,'Doruvulapalem','524323',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91271,270,'Dos Colony','524121',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91272,270,'Dugarajapatnam','524403',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91273,270,'Duggunta','524409',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91274,270,'Edagali','524321',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91275,270,'Eswrawaka','524127',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91276,270,'Gilakapadu','524408',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91277,270,'Golagamudi','524321',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91278,270,'Gollakandukur','524309',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91279,270,'Gonupalli','524414',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91280,270,'Gottikadu','524131',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91281,270,'Gottirprolu','524127',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91282,270,'Graddagunta','524421',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91283,270,'Griddalur','524409',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91284,270,'Gudali','524413',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91285,270,'Gudluruvaripalem','524323',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91286,270,'Gudur Bazar','524101',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91287,270,'Gudur East','524101',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91288,270,'Gudur H.O','524101',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91289,270,'Gudurpolytechnic','524101',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91290,270,'Gulimcherla','524407',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91291,270,'Gundavolu','524414',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91292,270,'Gunupadu','524402',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91293,270,'Gurramkonda','524402',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91294,270,'Guruvindapudi','524320',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91295,270,'Hastakaveri','524131',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91296,270,'Idimepalli','524321',1,0,'2022-03-03 13:12:25','2022-03-03 13:12:25'),(91297,270,'Inukurthi','524409',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91298,270,'Ipuru','524323',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91299,270,'Irakam','524401',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91300,270,'Iskapalem','524323',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91301,270,'Jayampu','524131',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91302,270,'Jeelapatur','524129',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91303,270,'Jogipalli','524407',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91304,270,'Josephpet','524321',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91305,270,'Juvvalapalem','524126',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91306,270,'Kadagunta','524404',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91307,270,'Kadalur','524121',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91308,270,'Kadivedu','524410',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91309,270,'Kakivoya','524343',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91310,270,'Kakutur','524320',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91311,270,'Kalichedu','524409',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91312,270,'Kallur','524123',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91313,270,'Kallur','524415',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91314,270,'Kaluvoya','524343',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91315,270,'Kamakur','524131',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91316,270,'Kandaleru Dam','524408',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91317,270,'Kandali','524406',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91318,270,'Kandamur','524309',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91319,270,'Kandra','524131',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91320,270,'Kanuparthi','524345',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91321,270,'Kanupurpalli','524343',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91322,270,'Kanupuru','524320',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91323,270,'Kanururajupalem','524126',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91324,270,'Kapulur','524126',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91325,270,'Karaballavolu','524402',1,0,'2022-03-03 13:12:26','2022-03-03 13:12:26'),(91326,270,'Karijatha','524121',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91327,270,'Karikadu','524403',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91328,270,'Karur','524401',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91329,270,'Kasipuram','524415',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91330,270,'Kasumur','524320',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91331,270,'Kattuvapalli','524405',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91332,270,'Kayyur','524404',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91333,270,'Kesavaram','524410',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91334,270,'Kogili','524127',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91335,270,'Kokkupadu','524411',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91336,270,'Kolanukuduru','524405',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91337,270,'Kollapanayunipalli','524342',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91338,270,'Kommalapudi','524405',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91339,270,'Kommaneturu','524406',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91340,270,'Kondagunta','524131',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91341,270,'Kota(NL)','524411',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91342,270,'Kotambedu','524421',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91343,270,'Kotapolur','524123',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91344,270,'Kothapalem','524413',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91345,270,'Kothapatnam','524411',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91346,270,'Kotitheertham','524341',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91347,270,'Kullur','524343',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91348,270,'Kundakur','524131',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91349,270,'Kundam','524131',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91350,270,'Kuricherlapadu','524405',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91351,270,'Kurugonda','524402',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91352,270,'Lalapeta','524132',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91353,270,'Lingasamudram','524407',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91354,270,'Lingasamudram','524134',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91355,270,'Madamanur','524405',1,0,'2022-03-03 13:12:27','2022-03-03 13:12:27'),(91356,270,'Madapalli','524341',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91357,270,'Maddurupalli','524408',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91358,270,'Madhavayapalem','524134',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91359,270,'Malavyanagar','524101',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91360,270,'Mallam (Nellore)','524403',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91361,270,'Mambathi','524121',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91362,270,'Mamudur','524309',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91363,270,'Manganellore','524121',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91364,270,'Mannarpolur(Urban Area)','524121',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91365,270,'Mannur','524131',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91366,270,'Manubolu','524405',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91367,270,'Manulalpeta','524132',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91368,270,'Marlapudi','524407',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91369,270,'Marupur','524345',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91370,270,'Matumadugu','524404',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91371,270,'Menakur','524421',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91372,270,'Mettu','524413',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91373,270,'Minamanamudi','524123',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91374,270,'Mittatmakur','524409',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91375,270,'Mizur','524123',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91376,270,'Mogallur','524345',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91377,270,'Mohammadapuram','524309',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91378,270,'Molaganur','524411',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91379,270,'Molakalapudi','524127',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91380,270,'Momidi','524412',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91381,270,'Mopur','524134',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91382,270,'Muchalagunta','524126',1,0,'2022-03-03 13:12:28','2022-03-03 13:12:28'),(91383,270,'Mulapadava','524403',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91384,270,'Muttembaka','524415',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91385,270,'Nadimpalli','524404',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91386,270,'Nagulavellatur','524343',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91387,270,'Narasingaraopeta','524101',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91388,270,'Navur','524345',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91389,270,'Nawabpeta','524408',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91390,270,'Nayudupeta','524126',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91391,270,'Nedurupalli','524309',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91392,270,'Nelaballi','524126',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91393,270,'Nellatur','524406',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91394,270,'Nellipudi','524415',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91395,270,'Nidigallu','524404',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91396,270,'Nidiguntapalem','524323',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91397,270,'Nidigurthi','524403',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91398,270,'Nindali','524406',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91399,270,'Nookanapalli','524343',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91400,270,'P.R.Palem','524131',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91401,270,'Paderu','524341',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91402,270,'Palachur','524421',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91403,270,'Palemkota','524132',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91404,270,'Palicherlapadu','524320',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91405,270,'Palicherlavaripalem','524412',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91406,270,'Palugodu','524134',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91407,270,'Palur','524407',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91408,270,'Pantapalem','524323',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91409,270,'Paravolu','524132',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91410,270,'Pathapadu','524309',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91411,270,'Pedavanjivaka','524411',1,0,'2022-03-03 13:12:29','2022-03-03 13:12:29'),(91412,270,'Peddapariya','524402',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91413,270,'Pellakur','524129',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91414,270,'Pelleru','524309',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91415,270,'Penubarthi','524414',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91416,270,'Periavaram','524132',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91417,270,'Perimidi','524421',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91418,270,'Pernadu','524124',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91419,270,'Perumallapadu','524341',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91420,270,'Perumallapadu','524407',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91421,270,'Peturu','524132',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91422,270,'Phase-Ii','524124',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91423,270,'Pidur','524405',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91424,270,'Pigilam','524404',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91425,270,'Podalakur','524345',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91426,270,'Pokkandala','524407',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91427,270,'Polireddipalem','524123',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91428,270,'Pothegunta','524407',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91429,270,'Pudiparthi','524321',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91430,270,'Pudur','524126',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91431,270,'Pulicotnagar','524121',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91432,270,'Punabaka','524129',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91433,270,'Punnepalli','524421',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91434,270,'Rajupalem','524126',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91435,270,'Ramakur','524414',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91436,270,'Ramapuram','524401',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91437,270,'Rapur','524408',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91438,270,'Raviguntapalem','524403',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91439,270,'Sagutur','524402',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91440,270,'Sanayapalem','524408',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91441,270,'Siddavaram','524411',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91442,270,'Siddavaram','524408',1,0,'2022-03-03 13:12:30','2022-03-03 13:12:30'),(91443,270,'Sirasanambedu','524129',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91444,270,'Sreedhanamalli','524123',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91445,270,'Sriharikota Range','524124',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91446,270,'Sullurpeta','524121',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91447,270,'Surayapalem','524309',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91448,270,'Survepalli','524321',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91449,270,'Sydadupalli','524414',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91450,270,'Sydapuram','524407',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91451,270,'Tada','524401',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91452,270,'Talupur','524409',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91453,270,'Talvaipadu','524126',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91454,270,'Tamminapatnam','524412',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91455,270,'Tanamcherla','524408',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91456,270,'Tatiparthi','524309',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91457,270,'Tatipartipalem','524323',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91458,270,'Tegacherla','524414',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91459,270,'Telugugangaproject','524132',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91460,270,'Telugurayapuram','524343',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91461,270,'Thimmajikandriga','524421',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91462,270,'Thippavarappadu','524406',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91463,270,'Thirumur','524403',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91464,270,'Thoorpupundla','524407',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91465,270,'Thumaya','524414',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91466,270,'Thummur','524126',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91467,270,'Thurpu Kambampadu','524341',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91468,270,'Tikkavaram','524412',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91469,270,'Tikkavarapadu','524320',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91470,270,'Tinnelapudi','524413',1,0,'2022-03-03 13:12:31','2022-03-03 13:12:31'),(91471,270,'Tippaguntapalem','524412',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91472,270,'Tirumalammapalem','524323',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91473,270,'Tirumalapadu','524343',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91474,270,'Toderu','524345',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91475,270,'Togaramudi','524123',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91476,270,'Topugunta','524343',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91477,270,'Turimerla','524409',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91478,270,'Uchur','524121',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91479,270,'Udathavaripalem','524412',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91480,270,'Uggumudi','524121',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91481,270,'Ulavapalli','524341',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91482,270,'Uppalamarthy','524127',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91483,270,'Utukur','524407',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91484,270,'Vadlapudi','524405',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91485,270,'Vajjavaripalem','524131',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91486,270,'Vakadu','524415',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91487,270,'Valamedu','524415',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91488,270,'Vallamedu','524403',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91489,270,'Vallipedu','524413',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91490,270,'Vallivedu','524132',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91491,270,'Varagali','524412',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91492,270,'Vatambedu','524121',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91493,270,'Vavileru','524341',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91494,270,'Vavintaparthi','524345',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91495,270,'Vedicherla','524406',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91496,270,'Veerampalli','524405',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91497,270,'Velagalaponnur','524121',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91498,270,'Velampalli','524134',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91499,270,'Velikallu','524134',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91500,270,'Vellanti','524309',1,0,'2022-03-03 13:12:32','2022-03-03 13:12:32'),(91501,270,'Vembuluru','524134',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91502,270,'Vemulachedu','524407',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91503,270,'Venadu','524124',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91504,270,'Vendodu','524131',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91505,270,'Venkannapalem','524405',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91506,270,'Venkatachalasatram','524320',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91507,270,'Venkatagiri Bazar','524132',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91508,270,'Venkatagiri Town','524132',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91509,270,'Venkatapuram','524345',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91510,270,'Venumbaka','524123',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91511,270,'Vepinapi','524408',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91512,270,'Vidyanagar (Nellore)','524413',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91513,270,'Vindur','524406',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91514,270,'Vinnamala','524126',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91515,270,'Virubhotlapalli','524343',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91516,270,'Virur','524309',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91517,270,'Vodur','524410',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91518,270,'Vojili','524402',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91519,270,'Vojilirajupalem','524402',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91520,270,'Vunuguntapalem','524413',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91521,270,'Yachavaram','524404',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91522,270,'Yakasiri','524126',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91523,270,'Yathalur','524132',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91524,270,'Yellasiri','524127',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91525,270,'Yellore','524403',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91526,270,'Yepur','524414',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91527,270,'Yerur','524412',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91528,270,'Yetur','524345',1,0,'2022-03-03 13:12:33','2022-03-03 13:12:33'),(91529,270,'Zangalapalli','524404',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91530,270,'Zarugumalli','524411',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91531,270,'A.C.Nagar','524002',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91532,270,'Akkarajuvari Kandriga','524142',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91533,270,'Alaganipadu','524318',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91534,270,'Allampadu','524312',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91535,270,'Alliguntapalem','524203',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91536,270,'Allimadugu','524152',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91537,270,'Allipuram','524002',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91538,270,'Allur','524315',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91539,270,'Amani Chiruvella','524303',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91540,270,'Anantasagaram','524302',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91541,270,'Ananthapuram','524344',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91542,270,'Ananthapuram','524225',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91543,270,'Andhrakesari Nagar','524004',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91544,270,'Anemadugu','524203',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91545,270,'Annagaripalem','524203',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91546,270,'Annareddypalem','524306',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91547,270,'Annareddypalem','524318',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91548,270,'Annavaram','524223',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91549,270,'Anumasamudram','524304',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91550,270,'Anumasamudrampeta','524304',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91551,270,'Apparaopalem','524322',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91552,270,'Appasamudram','524222',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91553,270,'Aravedu','524307',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91554,270,'Arlapadia','524236',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91555,270,'Atmakur (NL)','524322',1,0,'2022-03-03 13:12:34','2022-03-03 13:12:34'),(91556,270,'Ayyavaripalem','524310',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91557,270,'Balajinagar','524002',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91558,270,'Balayapalli','524226',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91559,270,'Bandarupalli','524303',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91560,270,'Basavarajupalem','524307',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91561,270,'Basinenipalli','524226',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91562,270,'Batrakagallu','524315',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91563,270,'Battepadu','524322',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91564,270,'Bedusupalli','524302',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91565,270,'Bhairavaram','524228',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91566,270,'Bhaktavatsalanagar','524003',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91567,270,'Bheemavaram','524312',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91568,270,'Bijjampalle','524230',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91569,270,'Bitragunta Loco Shed','524142',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91570,270,'Bitragunta','524142',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91571,270,'Bodagudipadu','524240',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91572,270,'Bodasi Idayapalli','524310',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91573,270,'Bodduvaripalem','524319',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91574,270,'Bogavolu','524142',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91575,270,'Bommavaram','524302',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91576,270,'Botikerlapadu','524307',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91577,270,'Boyil Cheruvupalli','524307',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91578,270,'Brahmadevam','524346',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91579,270,'Brahmanakraka Agraharam','524223',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91580,270,'Brahmanakraka','524223',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91581,270,'Brahmanapalli','524230',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91582,270,'Buchi Bus Stand','524305',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91583,270,'Buchireddypalem','524305',1,0,'2022-03-03 13:12:35','2022-03-03 13:12:35'),(91584,270,'Budamgunta','524223',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91585,270,'Buja Buja Nellore','524004',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91586,270,'Chabolu','524230',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91587,270,'Chakalakonda','524221',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91588,270,'Chalamcherla','524223',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91589,270,'Chandrapadia','524228',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91590,270,'Chaparallapalli','524302',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91591,270,'Chavatabheemavaram','524304',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91592,270,'Chellayapalem','524305',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91593,270,'Chemadala','524142',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91594,270,'Chennarayunipalem','524315',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91595,270,'Chennayapalem','524203',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91596,270,'Chennuru','524240',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91597,270,'Cherlopalem','524137',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91598,270,'Cherloyadavalli','524322',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91599,270,'Chilakalamarri','524302',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91600,270,'Chilakapadu','524312',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91601,270,'Chinacherukuru','524002',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91602,270,'Chinna Annalur','524224',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91603,270,'Chinna Kaniyampadu','524227',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91604,270,'Chinna Nagampalli','524310',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91605,270,'Chinnakraka','524223',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91606,270,'Chinnamachanur','524230',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91607,270,'Chintaladevi','524239',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91608,270,'Chintareddypalem','524003',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91609,270,'Chintopu','524002',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91610,270,'Chiramana','524308',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91611,270,'Chodavaram','524239',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91612,270,'Choudaripalem','524201',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91613,270,'Chowkacherla','524316',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91614,270,'Chowtaputtedu','524240',1,0,'2022-03-03 13:12:36','2022-03-03 13:12:36'),(91615,270,'Chunchuluru','524302',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91616,270,'Dagadarthi','524240',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91617,270,'Dakkanuru','524227',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91618,270,'Damagunta','524316',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91619,270,'Damaramadugu','524137',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91620,270,'Damavaram','524152',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91621,270,'Damayapalem','524344',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91622,270,'Damncherla','524227',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91623,270,'Dampur','524318',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91624,270,'Dargamitta','524003',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91625,270,'Dasaripalli','524222',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91626,270,'Dcbc','524003',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91627,270,'Depur','524322',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91628,270,'Devarapalem','524004',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91629,270,'Devarayapalli','524303',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91630,270,'Dharmarao Cheruvupalli','524307',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91631,270,'Dubagunta','524228',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91632,270,'Dubagunta','524239',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91633,270,'Dundigam','524308',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91634,270,'Duthalur','524222',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91635,270,'Duvvur (Nellore)','524306',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91636,270,'Eduru','524311',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91637,270,'Elamanchipadu','524317',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91638,270,'Fathekhanpeta','524003',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91639,270,'Gaddamvaripalli','524226',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91640,270,'Gandavaram','524317',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91641,270,'Gandipalem','524236',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91642,270,'Gandlavedu','524307',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91643,270,'Ganeswarapuram','524221',1,0,'2022-03-03 13:12:37','2022-03-03 13:12:37'),(91644,270,'Gangapatnam','524313',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91645,270,'Gangavaram','524137',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91646,270,'Gangireddypalem','524228',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91647,270,'Gangulavaricheruvupalli','524230',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91648,270,'Ganugapenta','524239',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91649,270,'Garimenapenta','524221',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91650,270,'Gattupalli','524223',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91651,270,'Gogulapalli','524315',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91652,270,'Gopalapuram','524344',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91653,270,'Gopannapalem Kandriga','524223',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91654,270,'Gottigundala','524228',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91655,270,'Gowravaram','524142',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91656,270,'Gowravaram','524302',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91657,270,'Gudigunta','524302',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91658,270,'Gudinarava','524236',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91659,270,'Gudipadu','524234',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91660,270,'Gudipallipadu','524314',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91661,270,'Gudladona','524225',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91662,270,'Gumparlapadu','524234',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91663,270,'Gundemadakala','524228',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91664,270,'Gundlammapalem','524316',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91665,270,'Gundlapalem','524003',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91666,270,'Guvvadi','524236',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91667,270,'Hasanapuram','524308',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91668,270,'Inamadugu','524137',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91669,270,'Indukurpeta','524314',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91670,270,'Indupur','524315',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91671,270,'Irlapadu','524312',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91672,270,'Isaka Damerla','524221',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91673,270,'Isakapalem','524305',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91674,270,'Iskapalli','524315',1,0,'2022-03-03 13:12:38','2022-03-03 13:12:38'),(91675,270,'Jagdevipeta','524314',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91676,270,'Jaladanki','524223',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91677,270,'Jaladevi','524227',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91678,270,'Jammalapalem','524223',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91679,270,'Janathapeta','524201',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91680,270,'Jangaladoruvu','524308',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91681,270,'Jangamreddypalli','524227',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91682,270,'Jayapuram','524310',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91683,270,'Jirravaripalem','524224',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91684,270,'Jonnavada','524305',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91685,270,'Kakarlapadu','524234',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91686,270,'Kakolluvaripalli','524227',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91687,270,'Kakupalli','524346',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91688,270,'Kalayakagollu','524305',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91689,270,'Kaligiri','524224',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91690,270,'Kallurpalli','524003',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91691,270,'Kalvelapalem','524346',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91692,270,'Kamireddypadu','524302',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91693,270,'Kammapalem','524319',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91694,270,'Kammavaripalem','524234',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91695,270,'Kammavaripalem','524223',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91696,270,'Kampasamudram','524230',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91697,270,'Kanuparthipadu','524003',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91698,270,'Kapparallatippa','524152',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91699,270,'Karatampadu','524307',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91700,270,'Katepalli','524228',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91701,270,'Katrayapadu','524240',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91702,270,'Kattubadipalem','524305',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91703,270,'Kavali Bazar','524201',1,0,'2022-03-03 13:12:39','2022-03-03 13:12:39'),(91704,270,'Kavali Co-op Colony','524201',1,0,'2022-03-03 13:12:40','2022-03-03 13:12:40'),(91705,270,'Kavali Cutchery','524201',1,0,'2022-03-03 13:12:40','2022-03-03 13:12:40'),(91706,270,'Kavali H.O','524201',1,0,'2022-03-03 13:12:40','2022-03-03 13:12:40'),(91707,270,'Kavali Mustapuram','524234',1,0,'2022-03-03 13:12:40','2022-03-03 13:12:40'),(91708,270,'Kavali Yadavalli','524234',1,0,'2022-03-03 13:12:40','2022-03-03 13:12:40'),(91709,270,'Kethugunta','524302',1,0,'2022-03-03 13:12:40','2022-03-03 13:12:40'),(91710,270,'Khaderpur','524312',1,0,'2022-03-03 13:12:40','2022-03-03 13:12:40'),(91711,270,'Kodavaluru','524316',1,0,'2022-03-03 13:12:40','2022-03-03 13:12:40'),(91712,270,'Kodur','524002',1,0,'2022-03-03 13:12:40','2022-03-03 13:12:40'),(91713,270,'Kodurupadu','524314',1,0,'2022-03-03 13:12:40','2022-03-03 13:12:40'),(91714,270,'Kolagatla','524308',1,0,'2022-03-03 13:12:40','2022-03-03 13:12:40'),(91715,270,'Komarika','524308',1,0,'2022-03-03 13:12:40','2022-03-03 13:12:40'),(91716,270,'Komarika','524314',1,0,'2022-03-03 13:12:40','2022-03-03 13:12:40'),(91717,270,'Kommarapudi','524004',1,0,'2022-03-03 13:12:40','2022-03-03 13:12:40'),(91718,270,'Kommi','524239',1,0,'2022-03-03 13:12:40','2022-03-03 13:12:40'),(91719,270,'Kona Samudram','524307',1,0,'2022-03-03 13:12:40','2022-03-03 13:12:40'),(91720,270,'Kondameedikondur','524308',1,0,'2022-03-03 13:12:40','2022-03-03 13:12:40'),(91721,270,'Kondapuram (Nellore)','524239',1,0,'2022-03-03 13:12:40','2022-03-03 13:12:40'),(91722,270,'Kondayapalem','524236',1,0,'2022-03-03 13:12:40','2022-03-03 13:12:40'),(91723,270,'Kondayapalem','524003',1,0,'2022-03-03 13:12:40','2022-03-03 13:12:40'),(91724,270,'Kondlapudi','524004',1,0,'2022-03-03 13:12:40','2022-03-03 13:12:40'),(91725,270,'Korimerla','524308',1,0,'2022-03-03 13:12:40','2022-03-03 13:12:40'),(91726,270,'Koruturu','524313',1,0,'2022-03-03 13:12:40','2022-03-03 13:12:40'),(91727,270,'Kotha Kodur','524002',1,0,'2022-03-03 13:12:40','2022-03-03 13:12:40'),(91728,270,'Kothapalem','524002',1,0,'2022-03-03 13:12:40','2022-03-03 13:12:40'),(91729,270,'Kothapalli','524303',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91730,270,'Kothapalli','524223',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91731,270,'Kothapalli Kovurgunta','524152',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91732,270,'Kothapeta','524221',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91733,270,'Kothavangallu','524317',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91734,270,'Kottur','524004',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91735,270,'Kovur Cutchery','524137',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91736,270,'Kovur','524137',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91737,270,'Kovurpalli','524142',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91738,270,'Krakatur','524225',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91739,270,'Krishnampalli','524226',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91740,270,'Krishnapatnam','524344',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91741,270,'Krishnapuram','524230',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91742,270,'Kudithipalem','524313',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91743,270,'Kummarakondur','524225',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91744,270,'Kunkuvaripalem','524239',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91745,270,'Kuppurupadu','524308',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91746,270,'Kurrapalli','524226',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91747,270,'Lakshmanaraopalli','524322',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91748,270,'Lakshmipuram','524225',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91749,270,'Lakshmipuram','524222',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91750,270,'Lakshmipuram','524002',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91751,270,'Lebur','524314',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91752,270,'Leguntapadu','524137',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91753,270,'Lingalapadu','524240',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91754,270,'Lingamgunta','524203',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91755,270,'Lingamgunta','524302',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91756,270,'Lingaraju Agraharam','524223',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91757,270,'Macherlavaripalem','524311',1,0,'2022-03-03 13:12:41','2022-03-03 13:12:41'),(91758,270,'Madarabadara','524308',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91759,270,'Madiraja Guduru','524346',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91760,270,'Mahalakshmipuram','524002',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91761,270,'Mahimalur','524307',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91762,270,'Makthapuram','524306',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91763,270,'Mamidipudi','524346',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91764,270,'Manchalapalli','524301',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91765,270,'Mandalanaidupalli','524222',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91766,270,'Mandapam','524311',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91767,270,'Maneguntapadu','524366',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91768,270,'Mangupalli','524302',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91769,270,'Manubolupadu','524240',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91770,270,'Maramreddipalli','524310',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91771,270,'Marripadu','524306',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91772,270,'Marripadu','524312',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91773,270,'Masaipeta','524226',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91774,270,'Mikkilimpeta','524366',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91775,270,'Minagallu','524305',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91776,270,'Moddurupadu','524203',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91777,270,'Mondidinnepalem','524203',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91778,270,'Mudimurthypuram','524239',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91779,270,'Mudivarthi','524137',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91780,270,'Mudivarthipalem','524313',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91781,270,'Mulapeta','524003',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91782,270,'Mulumudi','524004',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91783,270,'Mungamuru','524142',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91784,270,'Murugalla','524322',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91785,270,'Musunur','524201',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91786,270,'Muthukur','524344',1,0,'2022-03-03 13:12:42','2022-03-03 13:12:42'),(91787,270,'Mypadu','524313',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91788,270,'Nagulapadu','524322',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91789,270,'Nagulavaram','524142',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91790,270,'Naidupalem','524319',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91791,270,'Nallagonda','524228',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91792,270,'Nandavaram','524307',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91793,270,'Nandigunta','524228',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91794,270,'Nandipadu','524230',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91795,270,'Narampeta','524307',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91796,270,'Narasapuram','524313',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91797,270,'Narasimhapuram','524221',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91798,270,'Narayanappapeta','524310',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91799,270,'Narayanareddypeta','524314',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91800,270,'Narikellapalli','524344',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91801,270,'Narrawada','524222',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91802,270,'Narukuru','524002',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91803,270,'Navalakh Gardens','524002',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91804,270,'Nawabpeta','524002',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91805,270,'Nekunampeta','524239',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91806,270,'Nellatur','524344',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91807,270,'Nellimitta Kandriga','524002',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91808,270,'Nellore Bazar','524001',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91809,270,'Nellore Ceremic Factory','524003',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91810,270,'Nellore Cutchery','524322',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91811,270,'Nellore H.O','524001',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91812,270,'Nellore Z.P','524001',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91813,270,'Nemalladinna','524310',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91814,270,'Nidi Musali','524313',1,0,'2022-03-03 13:12:43','2022-03-03 13:12:43'),(91815,270,'North Amaluru','524315',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91816,270,'North Mopur','524315',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91817,270,'Northrajupalem','524366',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91818,270,'Ntr Nagar','524002',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91819,270,'Nuvvurupadu','524322',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91820,270,'P.S.R Nagar','524003',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91821,270,'Padamatikhambampadu','524301',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91822,270,'Padamatinaidupalli','524302',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91823,270,'Padamatipalem','524306',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91824,270,'Padmanabhasatram','524316',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91825,270,'Padugupadu','524137',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91826,270,'Pallipadu','524314',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91827,270,'Panchedu','524306',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91828,270,'Pandipadu','524304',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91829,270,'Panugodu','524304',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91830,270,'Papannagaripalli','524236',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91831,270,'Papireddypalem','524311',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91832,270,'Parikota','524225',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91833,270,'Parlapalli','524318',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91834,270,'Patha Bitragunta','524142',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91835,270,'Pathadevarayapalli','524303',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91836,270,'Pathanapuram','524234',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91837,270,'Pathapalli','524301',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91838,270,'Patur','524137',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91839,270,'Peda Kandla','524307',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91840,270,'Peddabbipuram','524304',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91841,270,'Peddakondur','524225',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91842,270,'Peddaputtedu','524317',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91843,270,'Peddireddypalli','524236',1,0,'2022-03-03 13:12:44','2022-03-03 13:12:44'),(91844,270,'Pedur','524311',1,0,'2022-03-03 13:12:45','2022-03-03 13:12:45'),(91845,270,'Pegallapadu','524312',1,0,'2022-03-03 13:12:45','2022-03-03 13:12:45'),(91846,270,'Penuballi','524305',1,0,'2022-03-03 13:12:45','2022-03-03 13:12:45'),(91847,270,'Penubarthi','524346',1,0,'2022-03-03 13:12:45','2022-03-03 13:12:45'),(91848,270,'Peramana','524308',1,0,'2022-03-03 13:12:45','2022-03-03 13:12:45'),(91849,270,'Peyyalapalem','524319',1,0,'2022-03-03 13:12:45','2022-03-03 13:12:45'),(91850,270,'Pidathapoluru','524346',1,0,'2022-03-03 13:12:45','2022-03-03 13:12:45'),(91851,270,'Pogathota','524001',1,0,'2022-03-03 13:12:45','2022-03-03 13:12:45'),(91852,270,'Polampadu','524224',1,0,'2022-03-03 13:12:45','2022-03-03 13:12:45'),(91853,270,'Polytechnic (Nellore)','524005',1,0,'2022-03-03 13:12:45','2022-03-03 13:12:45'),(91854,270,'Ponguru','524302',1,0,'2022-03-03 13:12:45','2022-03-03 13:12:45'),(91855,270,'Ponnapudipeddapalem','524318',1,0,'2022-03-03 13:12:45','2022-03-03 13:12:45'),(91856,270,'Pothireddypalem','524137',1,0,'2022-03-03 13:12:45','2022-03-03 13:12:45'),(91857,270,'Potlapudi','524002',1,0,'2022-03-03 13:12:45','2022-03-03 13:12:45'),(91858,270,'Pottempadu','524346',1,0,'2022-03-03 13:12:45','2022-03-03 13:12:45'),(91859,270,'Pottepalem','524004',1,0,'2022-03-03 13:12:45','2022-03-03 13:12:45'),(91860,270,'Pullayapalli','524226',1,0,'2022-03-03 13:12:45','2022-03-03 13:12:45'),(91861,270,'Punnur','524314',1,0,'2022-03-03 13:12:45','2022-03-03 13:12:45'),(91862,270,'Purini','524315',1,0,'2022-03-03 13:12:45','2022-03-03 13:12:45'),(91863,270,'Pynapuram','524346',1,0,'2022-03-03 13:12:45','2022-03-03 13:12:45'),(91864,270,'Rachavaripalli','524222',1,0,'2022-03-03 13:12:45','2022-03-03 13:12:45'),(91865,270,'Racherlapadu','524319',1,0,'2022-03-03 13:12:45','2022-03-03 13:12:45'),(91866,270,'Rajavolu','524322',1,0,'2022-03-03 13:12:45','2022-03-03 13:12:45'),(91867,270,'Rajupalem','524224',1,0,'2022-03-03 13:12:45','2022-03-03 13:12:45'),(91868,270,'Rajuvari Chintalapalem','524223',1,0,'2022-03-03 13:12:45','2022-03-03 13:12:45'),(91869,270,'Ramalingapuram','524003',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91870,270,'Ramanaidupalli','524307',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91871,270,'Ramannapalem','524366',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91872,270,'Ramapuram','524366',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91873,270,'Ramaswamypalli','524307',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91874,270,'Ramatheertham','524318',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91875,270,'Ramavarappadu','524239',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91876,270,'Ramudupalem','524313',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91877,270,'Ranganayakulapeta','524001',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91878,270,'Rangasamudram','524240',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91879,270,'Rebala','524305',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91880,270,'Reddypalem','524305',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91881,270,'Revur','524303',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91882,270,'Rudrakota','524203',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91883,270,'Saipeta','524239',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91884,270,'Sangam','524308',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91885,270,'Seetaramapuram','524310',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91886,270,'Siddanakonduru','524225',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91887,270,'Siddipuram','524306',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91888,270,'Singapeta','524315',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91889,270,'Singareddipalli','524310',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91890,270,'Siripuram','524223',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91891,270,'Somalaregada','524222',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91892,270,'Somarajupalli','524313',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91893,270,'Somasila','524301',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91894,270,'Somasila Project','524301',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91895,270,'Somavarappadu','524223',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91896,270,'South Amaluru','524002',1,0,'2022-03-03 13:12:46','2022-03-03 13:12:46'),(91897,270,'South Mopur','524004',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91898,270,'Srikolanu','524308',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91899,270,'Stonehousepet','524002',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91900,270,'Tadakalur','524240',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91901,270,'Talamanchi','524315',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91902,270,'Tallapalem','524203',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91903,270,'Talluru','524142',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91904,270,'Tarunavoya','524308',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91905,270,'Tatakaladinne','524366',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91906,270,'Taticherlapalem','524315',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91907,270,'Tellapadu','524304',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91908,270,'Tellapadu','524228',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91909,270,'Thimmareddypalli','524227',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91910,270,'Thimmasamudram','524223',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91911,270,'Thoorpupalem','524239',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91912,270,'Thotapalli','524311',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91913,270,'Thotapalliguduru','524311',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91914,270,'Thotlacheruvupalli','524236',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91915,270,'Thummagunta','524318',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91916,270,'Thummalapenta ','524203',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91917,270,'Thurupu Yerraballi','524239',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91918,270,'Thurupuchennampalli','524227',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91919,270,'Thurupurompi Dodla','524221',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91920,270,'Tikkavaram','524312',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91921,270,'Timmanaidupeta','524230',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91922,270,'Timmayapalem','524230',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91923,270,'Trunk Road (Nellore)','524001',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91924,270,'Tsoudepalli','524236',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91925,270,'Turimerla','524317',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91926,270,'Turupur','524225',1,0,'2022-03-03 13:12:47','2022-03-03 13:12:47'),(91927,270,'Udayagiri (Nellore)','524226',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91928,270,'Ulavapalle','524152',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91929,270,'Uppalapadu','524317',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91930,270,'Upplapadu','524301',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91931,270,'Utukur','524228',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91932,270,'Utukur','524318',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91933,270,'Vallur','524344',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91934,270,'Vangallu','524306',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91935,270,'Varakavipadu','524311',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91936,270,'Varigonda','524311',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91937,270,'Varikuntapadu','524302',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91938,270,'Varikuntapadu','524227',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91939,270,'Varini','524318',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91940,270,'Vasili','524308',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91941,270,'Vavilla','524318',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91942,270,'Vavveru','524305',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91943,270,'Vedayapalem','524004',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91944,270,'Veerannakollu','524224',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91945,270,'Vegur','524137',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91946,270,'Velicherla','524315',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91947,270,'Veligandla','524239',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91948,270,'Vellupodu','524240',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91949,270,'Velpulagunta','524234',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91950,270,'Vempadu','524227',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91951,270,'Vengalarao Nagar','524004',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91952,270,'Vengannapalem','524221',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91953,270,'Venkanapuram','524316',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91954,270,'Venkannapalem','524002',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91955,270,'Venkatampeta','524230',1,0,'2022-03-03 13:12:48','2022-03-03 13:12:48'),(91956,270,'Venkataraopalli','524322',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91957,270,'Venkatesupalem','524152',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91958,270,'Vennavada','524307',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91959,270,'Venugampalli','524303',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91960,270,'Vepanapi','524224',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91961,270,'Vidavalur','524318',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91962,270,'Vinjamur','524228',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91963,270,'Virur','524236',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91964,270,'Yellapalem','524366',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91965,270,'Yepilagunta','524230',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91966,270,'Yerikollu','524228',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91967,270,'Zakkepalligudur','524142',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91968,270,'Zammavaram','524234',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91969,270,'Zuvvaladinne','524152',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91970,271,'Akaveedu','523372',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91971,271,'Akkapalem','523328',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91972,271,'Akkapalle','523372',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91973,271,'Akkapalli','523356',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91974,271,'Allinagaram','523373',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91975,271,'Ambavaram','523357',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91976,271,'Ammanigudipadu','523330',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91977,271,'Anantavaram','523315',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91978,271,'Ankireddypalle','523356',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91979,271,'Annasamudram','523326',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91980,271,'Anumalapalle','523368',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91981,271,'Anumalaveedu','523368',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91982,271,'Aravallipadu','523305',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91983,271,'Araveetikota','523372',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91984,271,'Ardhaveedu','523335',1,0,'2022-03-03 13:12:49','2022-03-03 13:12:49'),(91985,271,'Atchampeta','523335',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(91986,271,'Aurangabad','523370',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(91987,271,'Ayanamukkala','523331',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(91988,271,'Ayyavaripalle','523336',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(91989,271,'B.Cherlopalle','523320',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(91990,271,'Badapuram','523305',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(91991,271,'Badinenipalle','523373',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(91992,271,'Basinepalle','523346',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(91993,271,'Basireddypalle','523333',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(91994,271,'Besthavari  Peta','523334',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(91995,271,'Bhupathipalle','523332',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(91996,271,'Block Area','523327',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(91997,271,'Block Head Quarters','523357',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(91998,271,'Bodapadu','523315',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(91999,271,'Bogolu','523336',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(92000,271,'Bollupalle','523335',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(92001,271,'Bommilingam','523333',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(92002,271,'Bondalapadu','523332',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(92003,271,'Boyalapalle','523327',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(92004,271,'Brahmanapalle','523357',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(92005,271,'Burjupalle','523367',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(92006,271,'Chandavaram','523305',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(92007,271,'Chapalamadugu','523327',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(92008,271,'Chatlamada','523320',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(92009,271,'Chatlamitta','523320',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(92010,271,'Chinna Dornala','523331',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(92011,271,'Chinnacumbum','523333',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(92012,271,'Chinnagudipadu','523331',1,0,'2022-03-03 13:12:50','2022-03-03 13:12:50'),(92013,271,'Chinnaobanayunipalle','523370',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92014,271,'Chinnayachavaram','523333',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92015,271,'Chintakunta','523329',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92016,271,'Chintala','523331',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92017,271,'Chintalapalle','523373',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92018,271,'Chollaveedu','523372',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92019,271,'Cumbum East','523333',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92020,271,'Cumbum (Prakasam)','523333',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92021,271,'Cumbumpadu','523330',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92022,271,'Daddavada','523356',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92023,271,'Darga','523334',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92024,271,'Darimadugu','523320',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92025,271,'Devarajugattu','523320',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92026,271,'Diguvametta','523357',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92027,271,'Donakonda','523336',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92028,271,'Donakonda R.S.','523305',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92029,271,'Donakonda Rly.Colony','523305',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92030,271,'Dupadu','523330',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92031,271,'Edavalli','523356',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92032,271,'Eguvacherlopalle','523331',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92033,271,'Endrapalle','523327',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92034,271,'Errabalem','523328',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92035,271,'Erragondapalem','523327',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92036,271,'G.Ummadivaram','523326',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92037,271,'Gadikota','523367',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92038,271,'Gajjalakonda','523315',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92039,271,'Galizerugulla','523346',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92040,271,'Ganapavaram','523326',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92041,271,'Gangadevipalle','523305',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92042,271,'Gangapalem','523327',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92043,271,'Gangavaram','523328',1,0,'2022-03-03 13:12:51','2022-03-03 13:12:51'),(92044,271,'Gangupalle','523330',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92045,271,'Ganjivaripalle','523327',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92046,271,'Gannepalle','523333',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92047,271,'Ganugapenta','523315',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92048,271,'Giddalur Bazar','523357',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92049,271,'Giddalur','523357',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92050,271,'Giddalur West','523357',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92051,271,'Gobbur','523320',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92052,271,'Gollapalle','523332',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92053,271,'Gollapalle','523330',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92054,271,'Gollavidipi','523327',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92055,271,'Gopalunipalle','523373',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92056,271,'Gottipadia','523329',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92057,271,'Gowthavaram','523368',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92058,271,'Gudimetta','523356',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92059,271,'Gudipadu','523305',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92060,271,'Gurijepalle','523327',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92061,271,'Gurrapusala','523330',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92062,271,'Hanumantharayunipalli','523373',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92063,271,'Hasanapuram','523330',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92064,271,'Hazarathgudem','523333',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92065,271,'Idamakallu','523369',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92066,271,'Idupur','523320',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92067,271,'Indlacheruvu','523305',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92068,271,'Isukatripuravaram','523326',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92069,271,'J.Krishnapuram','523333',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92070,271,'J.Pullalacheruvu','523368',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92071,271,'Jammanapalle','523329',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92072,271,'Jammidornala','523331',1,0,'2022-03-03 13:12:52','2022-03-03 13:12:52'),(92073,271,'Janapalacheruvu','523346',1,0,'2022-03-03 13:12:53','2022-03-03 13:12:53'),(92074,271,'Jangamguntla','523333',1,0,'2022-03-03 13:12:53','2022-03-03 13:12:53'),(92075,271,'Kakarla','523333',1,0,'2022-03-03 13:12:53','2022-03-03 13:12:53'),(92076,271,'Kalanuthala','523329',1,0,'2022-03-03 13:12:53','2022-03-03 13:12:53'),(92077,271,'Kalavapalle','523368',1,0,'2022-03-03 13:12:53','2022-03-03 13:12:53'),(92078,271,'Kalivelapalle','523315',1,0,'2022-03-03 13:12:53','2022-03-03 13:12:53'),(92079,271,'Kalugotla','523370',1,0,'2022-03-03 13:12:53','2022-03-03 13:12:53'),(92080,271,'Kandulapuram','523333',1,0,'2022-03-03 13:12:53','2022-03-03 13:12:53'),(92081,271,'Kankanalapalle','523326',1,0,'2022-03-03 13:12:53','2022-03-03 13:12:53'),(92082,271,'Katakanipalle','523331',1,0,'2022-03-03 13:12:53','2022-03-03 13:12:53'),(92083,271,'Kethagudipi','523371',1,0,'2022-03-03 13:12:53','2022-03-03 13:12:53'),(92084,271,'Khajipuram','523346',1,0,'2022-03-03 13:12:53','2022-03-03 13:12:53'),(92085,271,'Kocherlakota','523315',1,0,'2022-03-03 13:12:53','2022-03-03 13:12:53'),(92086,271,'Komarole','523327',1,0,'2022-03-03 13:12:53','2022-03-03 13:12:53'),(92087,271,'Komarole','523373',1,0,'2022-03-03 13:12:53','2022-03-03 13:12:53'),(92088,271,'Kommanuru','523367',1,0,'2022-03-03 13:12:53','2022-03-03 13:12:53'),(92089,271,'Konapalle','523346',1,0,'2022-03-03 13:12:53','2022-03-03 13:12:53'),(92090,271,'Kongalaveedu','523357',1,0,'2022-03-03 13:12:53','2022-03-03 13:12:53'),(92091,271,'Konudupalle','523329',1,0,'2022-03-03 13:12:53','2022-03-03 13:12:53'),(92092,271,'Kothapeta','523346',1,0,'2022-03-03 13:12:53','2022-03-03 13:12:53'),(92093,271,'Krishnam Setty Palle','523357',1,0,'2022-03-03 13:12:53','2022-03-03 13:12:53'),(92094,271,'Lakshmipuram','523305',1,0,'2022-03-03 13:12:53','2022-03-03 13:12:53'),(92095,271,'Lanjakota','523370',1,0,'2022-03-03 13:12:53','2022-03-03 13:12:53'),(92096,271,'Lellapalle','523330',1,0,'2022-03-03 13:12:53','2022-03-03 13:12:53'),(92097,271,'Lingapuram','523336',1,0,'2022-03-03 13:12:53','2022-03-03 13:12:53'),(92098,271,'Lingojipalle','523370',1,0,'2022-03-03 13:12:53','2022-03-03 13:12:53'),(92099,271,'M.Pullacheruvu','523346',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92100,271,'Madarpalle','523372',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92101,271,'Maddalakatta','523320',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92102,271,'Maddalamadaka','523336',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92103,271,'Magatur','523333',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92104,271,'Makthapuram','523369',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92105,271,'Mallampeta','523315',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92106,271,'Mallapalem','523327',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92107,271,'Malyavanthunipadu','523332',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92108,271,'Manepalle','523328',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92109,271,'Mangalikunta','523371',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92110,271,'Manginapudi','523315',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92111,271,'Maratithanda','523333',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92112,271,'Markapur Bazar','523316',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92113,271,'Markapur East','523316',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92114,271,'Markapur H.O','523316',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92115,271,'Marrivemula','523328',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92116,271,'Medepi','523326',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92117,271,'Meerjampeta','523332',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92118,271,'Miriyampalle','523326',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92119,271,'Mittameedipalle','523336',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92120,271,'Mohiddin Puram','523336',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92121,271,'Mokshagundam','523334',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92122,271,'Mudivemula','523326',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92123,271,'Mundlapadu','523367',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92124,271,'Muraripalle','523327',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92125,271,'Mutukula','523328',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92126,271,'Nadigadda','523330',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92127,271,'Nagellamudipi','523371',1,0,'2022-03-03 13:12:54','2022-03-03 13:12:54'),(92128,271,'Nagulavaram','523333',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92129,271,'Naidupalem','523327',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92130,271,'Nallabothulavaripalem','523305',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92131,271,'Nallaguntla','523369',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92132,271,'Nallaguntla','523331',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92133,271,'Narasayapalem','523327',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92134,271,'Narashimapalle','523369',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92135,271,'Narasireddypalle','523372',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92136,271,'Narava','523357',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92137,271,'Narayanapalle','523335',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92138,271,'Nasarsahebpalle','523371',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92139,271,'Nekunambad','523334',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92140,271,'Nikarampalle','523329',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92141,271,'Obulakkapalli','523330',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92142,271,'Obulapuram','523367',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92143,271,'Oddualvagupalle','523356',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92144,271,'P.Venkatapuram','523346',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92145,271,'Palakaveedu','523368',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92146,271,'Pamurupalle','523373',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92147,271,'Pandillapalle','523334',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92148,271,'Papinenipalle','523335',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92149,271,'Pedda Bommalapuram','523331',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92150,271,'Pedda Dornala','523331',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92151,271,'Peddakolukula','523327',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92152,271,'Peddanallakalva','523372',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92153,271,'Peddaobanayunipalle','523370',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92154,271,'Peddaraveedu','523320',1,0,'2022-03-03 13:12:55','2022-03-03 13:12:55'),(92155,271,'Peedyachavaram','523315',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92156,271,'Pitikayagulla','523346',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92157,271,'Podilikondapalle','523357',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92158,271,'Polepalle','523305',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92159,271,'Posupalle','523373',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92160,271,'Pothalapadu','523315',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92161,271,'Pregallapadu','523320',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92162,271,'Puchakayalapalle','523329',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92163,271,'Pullala Cheruvu','523328',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92164,271,'Pusalapadu','523334',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92165,271,'R.Ummadivaram','523328',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92166,271,'Racherla','523368',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92167,271,'Rajupalem','523326',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92168,271,'Rajupalem (Prakasam)','523369',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92169,271,'Ramachandrakota','523331',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92170,271,'Ramachandrapuram','523329',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92171,271,'Ramapuram','523305',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92172,271,'Ramasamudram','523326',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92173,271,'Rangapuram','523333',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92174,271,'Ravipadu (Prakasam)','523370',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92175,271,'Rayavaram','523371',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92176,271,'Reddi Cherla','523373',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92177,271,'Rudrasamudram','523305',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92178,271,'Salakalaveedu','523370',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92179,271,'Sanikavaram','523331',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92180,271,'Sanjeevaraopeta','523367',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92181,271,'Sathakodu','523328',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92182,271,'Satyavolu','523356',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92183,271,'Seethanagulavaram','523332',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92184,271,'Singarapalle','523346',1,0,'2022-03-03 13:12:56','2022-03-03 13:12:56'),(92185,271,'Somidevipalle','523368',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92186,271,'Sunkesula','523329',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92187,271,'Tadivaripalle','523334',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92188,271,'Tarlupadu','523332',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92189,271,'Tarlupadumission Compound','523332',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92190,271,'Thamballapalle','523369',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92191,271,'Thammadapalle','523331',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92192,271,'Thangirallapalle','523320',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92193,271,'Thaticherla','523356',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92194,271,'Thimmapuram','523357',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92195,271,'Thippayapalem','523329',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92196,271,'Thummalacheruvu','523371',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92197,271,'Thummedalapadu','523305',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92198,271,'Thurimella','523372',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92199,271,'Tokapalle','523320',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92200,271,'Tripurantakam','523326',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92201,271,'Vadampalli','523330',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92202,271,'Vaddipadu','523305',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92203,271,'Veerabhadrapuram','523327',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92204,271,'Veerabhadrapuram','523336',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92205,271,'Vekatapuram','523305',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92206,271,'Velagalapaya','523333',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92207,271,'Vellampalle','523330',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92208,271,'Vemulakota','523329',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92209,271,'Venkatadripalem','523327',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92210,271,'Venkatareddypalle','523328',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92211,271,'Viswanadhapuram','523330',1,0,'2022-03-03 13:12:57','2022-03-03 13:12:57'),(92212,271,'Vuyyalawada','523367',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92213,271,'Yadavalli','523331',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92214,271,'Yellupalle','523357',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92215,271,'Yerrabalem','523336',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92216,271,'Yerramsettyvaripalle','523373',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92217,271,'A.B.V.Palem','523171',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92218,271,'Addanki Gate','523001',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92219,271,'Addanki','523201',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92220,271,'Adusumalli','523169',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92221,271,'Akkacheruvu','523240',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92222,271,'Alakurapadu','523274',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92223,271,'Alavalapadu','523304',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92224,271,'Alavalapadu','523212',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92225,271,'Alluru','523286',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92226,271,'Aluru','523182',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92227,271,'Ambavaram Kothapalli','523112',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92228,271,'Ammanabrolu','523180',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92229,271,'Ammapalem','523116',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92230,271,'Ammavaripalem','523281',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92231,271,'Anakarlapudi','523270',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92232,271,'Anamanamuru','523212',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92233,271,'Ananandapuram','523101',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92234,271,'Ananthavaram','523274',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92235,271,'Ananthavaram','523301',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92236,271,'Anikalapalli','523112',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92237,271,'Ankepalli','523240',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92238,271,'Annaboinapalli','523115',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92239,271,'Annangi','523211',1,0,'2022-03-03 13:12:58','2022-03-03 13:12:58'),(92240,271,'Annavaram','523253',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92241,271,'Arikatlavaripalem','523214',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92242,271,'Arivemula','523112',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92243,271,'Atmakur','523292',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92244,271,'Ats Palem','523304',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92245,271,'Audipudi','523170',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92246,271,'Ayyalurivaripalli','523112',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92247,271,'Ayyaparajupalem','523271',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92248,271,'Ayyavaripalli','523116',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92249,271,'Ayyavaripalli','523110',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92250,271,'B.Machavaram','523225',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92251,271,'Baddepudi','523281',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92252,271,'Badevaripalem','523113',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92253,271,'Baduguleru','523245',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92254,271,'Baitamanjuluru','523261',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92255,271,'Balijapalem','523110',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92256,271,'Ballavaram','523223',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92257,271,'Ballikurva','523301',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92258,271,'Ballipalli','523254',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92259,271,'Bandiveli Gandla','523304',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92260,271,'Bandlamudi','523226',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92261,271,'Basavannapalem','523211',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92262,271,'Batchalakurapadu','523246',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92263,271,'Bellamkondavaripalem','523252',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92264,271,'Bhagavanrajupalem','523261',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92265,271,'Bhimavaram','523292',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92266,271,'Bhimavaram','523167',1,0,'2022-03-03 13:12:59','2022-03-03 13:12:59'),(92267,271,'Bhusarapalli','523226',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92268,271,'Binginapalli','523104',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92269,271,'Bobbepalli','523301',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92270,271,'Bodanampadu','523304',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92271,271,'Bodavada','523167',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92272,271,'Bodavada','523253',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92273,271,'Bodawada','523114',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92274,271,'Boddikurapadu','523253',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92275,271,'Bodduvaripalem','523212',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92276,271,'Bollapalli','523261',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92277,271,'Bollavarappadu','523212',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92278,271,'Bommireddipalli','523254',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92279,271,'Bommnampadu','523201',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92280,271,'Boppidivaripalem','523265',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92281,271,'Bosenagar (Prakasam)','523155',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92282,271,'Botikarlapadu','523254',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92283,271,'Botlagudur','523110',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92284,271,'Botlapalem','523252',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92285,271,'Brahmananidamanuru','523183',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92286,271,'Buchannapalem','523240',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92287,271,'Budavada','523169',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92288,271,'Bukkapuram','523108',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92289,271,'Burlavaripalem','523157',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92290,271,'C.S.Puram','523112',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92291,271,'Chadalavada','523183',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92292,271,'Chagallu','523292',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92293,271,'Chakicherla','523292',1,0,'2022-03-03 13:13:00','2022-03-03 13:13:00'),(92294,271,'Chakirala','523254',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92295,271,'Chakrayapalem','523201',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92296,271,'Chalivendram','523247',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92297,271,'Challagirigala','523245',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92298,271,'Chandalur','523214',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92299,271,'Chandrapadu','523263',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92300,271,'Chavatapalem','523180',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92301,271,'Chavatapalem','523109',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92302,271,'Cheerladinne','523254',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92303,271,'Chekurapadu','523262',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92304,271,'Chennapanayunipalli','523112',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92305,271,'Chennupalli','523303',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92306,271,'Cherukur','523109',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92307,271,'Chervanuppalapadu','523180',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92308,271,'Chevuru','523291',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92309,271,'Chilamkur','523226',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92310,271,'Chilamkur','523108',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92311,271,'Chimakurty','523226',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92312,271,'Chimata','523253',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92313,271,'Chimidithapadu','523281',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92314,271,'Chimmiribanda','523260',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92315,271,'Chinaganjam','523135',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92316,271,'Chinagumpalle','523181',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92317,271,'Chinairlapadu','523254',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92318,271,'Chinakothapalli','523260',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92319,271,'Chinalatrip','523115',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92320,271,'Chinamanagundam','523246',1,0,'2022-03-03 13:13:01','2022-03-03 13:13:01'),(92321,271,'Chinanandipadu','523169',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92322,271,'Chinapavani','523115',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92323,271,'Chinaravipadu','523226',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92324,271,'Chinarikatla','523245',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92325,271,'Chinavenkannapalem','523279',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92326,271,'Chinmuppalapadu','523227',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92327,271,'Chinnipadu','523111',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92328,271,'Chintagumpalli','523117',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92329,271,'Chintalapalem','523274',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92330,271,'Chintapadu','523112',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92331,271,'Chirala Bazar','523157',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92332,271,'Chirala H.O','523155',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92333,271,'Chirrikurapadu','523271',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92334,271,'Chodavaram','523279',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92335,271,'Chundi','523116',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92336,271,'Daggubadu','523190',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92337,271,'Daivalaravuru','523212',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92338,271,'Dappalampadu','523113',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92339,271,'Darakanipadu','523281',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92340,271,'Darsi','523247',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92341,271,'Darsiagraharam','523260',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92342,271,'Darsichandalur','523304',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92343,271,'Darsiguntapeta','523112',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92344,271,'Dasarajupalli','523182',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92345,271,'Dcp(O)','523001',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92346,271,'Degaramudi','523301',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92347,271,'Desaipet','523187',1,0,'2022-03-03 13:13:02','2022-03-03 13:13:02'),(92348,271,'Devagudur','523274',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92349,271,'Devarampadu','523182',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92350,271,'Devarapalem','523253',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92351,271,'Devarapalli','523169',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92352,271,'Devavaram','523247',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92353,271,'Dharmavaram','523260',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92354,271,'Dharmavarm','523270',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92355,271,'Dhenuvakonda','523263',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92356,271,'Dirisavancha','523245',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92357,271,'Doddavaram','523263',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92358,271,'Doddavarappadu','523211',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92359,271,'Doddichintala','523227',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92360,271,'Dronadula','523190',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92361,271,'Dubagunta','523108',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92362,271,'Dubagunta','523109',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92363,271,'Duddukur','523186',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92364,271,'East Veerayapalem','523252',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92365,271,'Eastgangavaram','523264',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92366,271,'Eastkattakindapalli','523110',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92367,271,'Edaravaripalli','523227',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92368,271,'Edlurapadu','523109',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92369,271,'Edubadu','523171',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92370,271,'Edumudi','523186',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92371,271,'Egalapadu','523241',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92372,271,'Elchuru','523303',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92373,271,'Enikapadu','523225',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92374,271,'Ethamukkala','523280',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92375,271,'G.L.Puram','523226',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92376,271,'Gajulaplli','523246',1,0,'2022-03-03 13:13:03','2022-03-03 13:13:03'),(92377,271,'Gangadonakonda','523304',1,0,'2022-03-03 13:13:04','2022-03-03 13:13:04'),(92378,271,'Gangavaram','523225',1,0,'2022-03-03 13:13:04','2022-03-03 13:13:04'),(92379,271,'Gangavaram','523167',1,0,'2022-03-03 13:13:04','2022-03-03 13:13:04'),(92380,271,'Gannavaram','523224',1,0,'2022-03-03 13:13:04','2022-03-03 13:13:04'),(92381,271,'Gannavaram','523301',1,0,'2022-03-03 13:13:04','2022-03-03 13:13:04'),(92382,271,'Garimenapenta','523246',1,0,'2022-03-03 13:13:04','2022-03-03 13:13:04'),(92383,271,'Garlapadu','523263',1,0,'2022-03-03 13:13:04','2022-03-03 13:13:04'),(92384,271,'Garlapeta','523254',1,0,'2022-03-03 13:13:04','2022-03-03 13:13:04'),(92385,271,'Garnepudi','523171',1,0,'2022-03-03 13:13:04','2022-03-03 13:13:04'),(92386,271,'Gavinivaripalem','523166',1,0,'2022-03-03 13:13:04','2022-03-03 13:13:04'),(92387,271,'Gayamvaripalli','523246',1,0,'2022-03-03 13:13:04','2022-03-03 13:13:04'),(92388,271,'Ghadiyapudi','523263',1,0,'2022-03-03 13:13:04','2022-03-03 13:13:04'),(92389,271,'Goginenivari Palaem','523270',1,0,'2022-03-03 13:13:04','2022-03-03 13:13:04'),(92390,271,'Gokulam','523224',1,0,'2022-03-03 13:13:04','2022-03-03 13:13:04'),(92391,271,'Gollapalli','523240',1,0,'2022-03-03 13:13:04','2022-03-03 13:13:04'),(92392,271,'Gollaplli','523223',1,0,'2022-03-03 13:13:04','2022-03-03 13:13:04'),(92393,271,'Gollapudiagraharam','523169',1,0,'2022-03-03 13:13:04','2022-03-03 13:13:04'),(92394,271,'Gonasapudu','523181',1,0,'2022-03-03 13:13:04','2022-03-03 13:13:04'),(92395,271,'Gongotireddipalem','523271',1,0,'2022-03-03 13:13:04','2022-03-03 13:13:04'),(92396,271,'Gonugunta','523226',1,0,'2022-03-03 13:13:04','2022-03-03 13:13:04'),(92397,271,'Gopala Nagar (O)','523001',1,0,'2022-03-03 13:13:04','2022-03-03 13:13:04'),(92398,271,'Gotlagattu','523246',1,0,'2022-03-03 13:13:04','2022-03-03 13:13:04'),(92399,271,'Gudevaripalem','523111',1,0,'2022-03-03 13:13:04','2022-03-03 13:13:04'),(92400,271,'Gudipadu','523111',1,0,'2022-03-03 13:13:04','2022-03-03 13:13:04'),(92401,271,'Gudipatipalli','523228',1,0,'2022-03-03 13:13:04','2022-03-03 13:13:04'),(92402,271,'Gudluru','523281',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92403,271,'Gullapalli','523211',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92404,271,'Gummalampadu','523225',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92405,271,'Gundlasamudram','523240',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92406,271,'Guntupalli','523110',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92407,271,'Guntupalli','523301',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92408,271,'Guravajipet','523108',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92409,271,'Guravareddipalem','523211',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92410,271,'H.M.Padu','523227',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92411,271,'Hanumapuram','523183',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92412,271,'Hanumoji Palem','523167',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92413,271,'Hazipuram','523227',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92414,271,'Idara','523265',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92415,271,'Idupulapadu','523190',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92416,271,'Ilapavuluru','523263',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92417,271,'Immadicheruvu','523224',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92418,271,'Inagallu','523171',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92419,271,'Inamanamelluru','523211',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92420,271,'Inimerla','523108',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92421,271,'Inkollu','523167',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92422,271,'Ippagunta','523109',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92423,271,'Ipurupalem','523166',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92424,271,'Irsalagundam','523245',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92425,271,'J.Pangulur','523214',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92426,271,'Jagarlamudi','523169',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92427,271,'Jallapaem','523224',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92428,271,'Jallapalem','523271',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92429,271,'Jammulapalem','523274',1,0,'2022-03-03 13:13:05','2022-03-03 13:13:05'),(92430,271,'Janakavaram','523214',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92431,271,'Janardhnapuram','523271',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92432,271,'Jandrapet','523165',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92433,271,'Jarbulavaripale','523185',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92434,271,'Jarugumalli','523274',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92435,271,'Jayavaram','523274',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92436,271,'Jillellamudi','523109',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92437,271,'Jonnatali','523301',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92438,271,'K.Agraharam','523111',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92439,271,'K.Rajupalem','523292',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92440,271,'K.Thakkellapadu','523212',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92441,271,'Kadavakuduru','523181',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92442,271,'Kakarla','523253',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92443,271,'Kakuturivaripalem','523274',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92444,271,'Kalagotla','523254',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92445,271,'Kalavakur','523201',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92446,271,'Kalavalla','523113',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92447,271,'Kalikavaya','523101',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92448,271,'Kalikavayabitragunta','523101',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92449,271,'Kalluru','523304',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92450,271,'Kaluzuvvalapadu','523241',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92451,271,'Kambalapadu','523240',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92452,271,'Kamepalli','523302',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92453,271,'Kamepalli','523271',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92454,271,'Kanakanampadu','523224',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92455,271,'Kancharlavaripalem','523254',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92456,271,'Kandlagunta','523183',1,0,'2022-03-03 13:13:06','2022-03-03 13:13:06'),(92457,271,'Kandukur Cutchery','523105',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92458,271,'Kandukur H.O','523105',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92459,271,'Kandukur South','523105',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92460,271,'Kandulur','523272',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92461,271,'Kanigiri H.O','523230',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92462,271,'Kanumalla','523101',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92463,271,'Kanuparthi','523180',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92464,271,'Karamchedu','523168',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92465,271,'Karavadi','523182',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92466,271,'Karedu','523292',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92467,271,'Karumanchi','523272',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92468,271,'Kasyapuram','523201',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92469,271,'Katragunta','523246',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92470,271,'Kattakindipalli','523108',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92471,271,'Kattavarpalem','523270',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92472,271,'Kattugudipalem','523271',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92473,271,'Kellampalli','523240',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92474,271,'Kesavarappadu','523170',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92475,271,'Khambaladinne','523110',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92476,271,'Khambampadu','523201',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92477,271,'Kodandaramapuram','523117',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92478,271,'Kodavalivaripalem','523170',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92479,271,'Kodigumpala','523110',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92480,271,'Kolalapudi','523261',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92481,271,'Kollavaripalem','523169',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92482,271,'Komaranenivaripalem','523169',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92483,271,'Kommalapadu','523303',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92484,271,'Komminenivaripalem','523260',1,0,'2022-03-03 13:13:07','2022-03-03 13:13:07'),(92485,271,'Konakana Metla','523241',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92486,271,'Konanki','523260',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92487,271,'Kondaboinapalli','523112',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92488,271,'Kondamanjulur','523261',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92489,271,'Kondamudusupalem','523113',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92490,271,'Kondamuru','523261',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92491,271,'Kondasamudram','523116',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92492,271,'Kondepi','523270',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92493,271,'Kondikandukur','523101',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92494,271,'Konidena','523301',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92495,271,'Koniki','523167',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92496,271,'Konizedu','523272',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92497,271,'Kopparam','523302',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92498,271,'Kopperapadu','523303',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92499,271,'Kopperapadu','523213',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92500,271,'Kopperapalem','523302',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92501,271,'Koppole','523286',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92502,271,'Korisapadu','523212',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92503,271,'Korrapativaripalem','523264',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92504,271,'Kotalapalli','523223',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92505,271,'Kotapadu','523214',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92506,271,'Kothapalli','523247',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92507,271,'Kothapatnam','523286',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92508,271,'Kothapeta','523281',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92509,271,'Kothapeta','523157',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92510,271,'Kothayeruvaripalli','523254',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92511,271,'Kotikalapudi','523201',1,0,'2022-03-03 13:13:08','2022-03-03 13:13:08'),(92512,271,'Kovilampadu','523112',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92513,271,'Kovur Kandukur','523109',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92514,271,'Krishnapuram','523292',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92515,271,'Kuchipudi','523240',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92516,271,'Kudumalaguntla','523228',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92517,271,'Kukutlapalli','523303',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92518,271,'Kunamnenivaripalem','523226',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92519,271,'Kunchepalli','523240',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92520,271,'Kunduru','523303',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92521,271,'Kunkalamarru','523168',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92522,271,'Kunkupadu','523264',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92523,271,'Kurichedu','523304',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92524,271,'Kurnool Road (O)','523002',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92525,271,'Kurthula','523157',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92526,271,'Kutagundla','523227',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92527,271,'Lakkavaram','523264',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92528,271,'Lakshminarasapuram','523110',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92529,271,'Lawyer Pet (O)','523002',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92530,271,'Linga Samudram','523114',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92531,271,'Lingamgunta','523262',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92532,271,'Lingareddipalli','523254',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92533,271,'M L Engg. College','523101',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92534,271,'M.M.Donka (O)','523002',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92535,271,'M.M.T. Road','523212',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92536,271,'M.Nidamanur','523279',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92537,271,'Machavaram','523113',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92538,271,'Madalavaripalem','523240',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92539,271,'Madanur','523280',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92540,271,'Maddipadu','523211',1,0,'2022-03-03 13:13:09','2022-03-03 13:13:09'),(92541,271,'Maddiralapadu','523262',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92542,271,'Maddirallamuppalla','523181',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92543,271,'Maddulur','523225',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92544,271,'Madhavaram','523264',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92545,271,'Mahadevapuram','523101',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92546,271,'Mailavaram','523201',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92547,271,'Mainampadu','523225',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92548,271,'Makkenavaripalem','523201',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92549,271,'Makkenavaripalem','523303',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92550,271,'Malepadu','523109',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92551,271,'Mallavaram','523263',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92552,271,'Mallavarappadu','523272',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92553,271,'Mallayapalem','523301',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92554,271,'Manchikalapadu','523226',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92555,271,'Manduvavaripalem','523262',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92556,271,'Mangampalli','523228',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92557,271,'Mangamuru','523225',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92558,271,'Mannepalli','523264',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92559,271,'Mannetikota','523292',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92560,271,'Marella','523201',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92561,271,'Marella','523117',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92562,271,'Markondapuram','523254',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92563,271,'Marlapadu','523272',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92564,271,'Marrikuntapalli','523117',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92565,271,'Marripudi','523240',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92566,271,'Marturu','523301',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92567,271,'Medarametlapalem','523115',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92568,271,'Mgc Market(C )','523156',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92569,271,'Minnekallu','523302',1,0,'2022-03-03 13:13:10','2022-03-03 13:13:10'),(92570,271,'Mocherla','523291',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92571,271,'Modepalli','523264',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92572,271,'Mogallur','523223',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92573,271,'Mogilicherla','523114',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92574,271,'Mohammadapuram','523246',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92575,271,'Mopadu','523110',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92576,271,'Morapagunta','523223',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92577,271,'Motumala','523286',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92578,271,'Motupalli','523184',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92579,271,'Mugachinala','523270',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92580,271,'Mugachintala','523241',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92581,271,'Muktheswaram','523303',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92582,271,'Mukthinuthalapadu','523262',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92583,271,'Munagapadu','523241',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92584,271,'Mundlamur','523265',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92585,271,'Mundlapadu','523112',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92586,271,'Munnagivaripalem','523169',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92587,271,'Muppalla','523109',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92588,271,'Muppavaram','523273',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92589,271,'Muppavaram','523261',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92590,271,'Murugummi','523111',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92591,271,'Musunurukothapalli','523112',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92592,271,'Mutyalapadu','523115',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92593,271,'N.G.Padu','523183',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92594,271,'N.N.Kandrika','523271',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92595,271,'N.S.C Colony (O)','523001',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92596,271,'Naddimallapuram','523108',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92597,271,'Nagambotlavaripalem','523264',1,0,'2022-03-03 13:13:11','2022-03-03 13:13:11'),(92598,271,'Nagampalli','523246',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92599,271,'Nagandla','523190',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92600,271,'Nagarajukunta','523241',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92601,271,'Nagarajupalli','523301',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92602,271,'Nagireddipalli','523223',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92603,271,'Nagulapadu','523201',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92604,271,'Nagulapalem','523169',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92605,271,'Naidu Vari Palem','523167',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92606,271,'Naidupalem','523265',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92607,271,'Naidupet','523246',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92608,271,'Naldalpur','523113',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92609,271,'Nallagandla','523228',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92610,271,'Nallamadugula','523112',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92611,271,'Namasivayapuram','523304',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92612,271,'Nandanamarella','523245',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92613,271,'Nandanavanam','523228',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92614,271,'Nandanavanam','523101',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92615,271,'Narasamambapuram','523223',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92616,271,'Narasingole','523271',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92617,271,'Narayapalli','523228',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92618,271,'Narramarella','523108',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92619,271,'Nayudupalem','523115',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92620,271,'Nayudupalem','523304',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92621,271,'Nekunambadu','523263',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92622,271,'Nekunampuram','523113',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92623,271,'Nelaturu','523211',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92624,271,'Nennurapadu','523270',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92625,271,'Neredupalli','523111',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92626,271,'Netivaripalem','523271',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92627,271,'Nimmareddipalem','523247',1,0,'2022-03-03 13:13:12','2022-03-03 13:13:12'),(92628,271,'Nippatlapadu','523253',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92629,271,'Nuthalapadu','523169',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92630,271,'Nuzellapalli','523214',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92631,271,'Nuzellpalli','523201',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92632,271,'Oguru','523101',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92633,271,'Old Singarayakonda','523101',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92634,271,'Ongole Bazar','523001',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92635,271,'Ongole H.O','523001',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92636,271,'P.C.Palli','523117',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92637,271,'P.G.Palli','523228',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92638,271,'Pa Padu','523111',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92639,271,'Padarthi','523286',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92640,271,'Paidipadu','523271',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92641,271,'Paidipadu','523213',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92642,271,'Pakala','523101',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92643,271,'Paletipadu','523279',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92644,271,'Pallamalli','523263',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92645,271,'Pallepalem','523135',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92646,271,'Palukur','523101',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92647,271,'Paluru','523101',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92648,271,'Pamur','523108',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92649,271,'Panakalapalem','523182',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92650,271,'Pandalapadu','523109',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92651,271,'Pandillapalli','523184',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92652,271,'Panduvanagulavaram','523224',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92653,271,'Pangulur','523261',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92654,271,'Papayapalem','523157',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92655,271,'Parchur','523169',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92656,271,'Parikondapadu','523113',1,0,'2022-03-03 13:13:13','2022-03-03 13:13:13'),(92657,271,'Paritalavaripalem','523303',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92658,271,'Pasupugallu','523265',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92659,271,'Patchava','523271',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92660,271,'Pathachirala','523165',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92661,271,'Pathamagulur','523302',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92662,271,'Pathapadu','523246',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92663,271,'Pathapadu','523254',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92664,271,'Pavulur','523167',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92665,271,'Peda Pavani','523115',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92666,271,'Pedaambadipudi','523301',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92667,271,'Pedadasaripalli','523227',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92668,271,'Pedadasullapalli','523227',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92669,271,'Pedaganjam','523186',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92670,271,'Pedagogulapalli','523223',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92671,271,'Pedairlapadu','523117',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92672,271,'Pedakandlagunta','523270',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92673,271,'Pedakothapalli','523211',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92674,271,'Pedamopadu','523113',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92675,271,'Pedarajupalem','523108',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92676,271,'Pedarikatla','523245',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92677,271,'Pedavullagallu','523265',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92678,271,'Peddavaram','523304',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92679,271,'Pedjangalapalli','523260',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92680,271,'Pellur','523272',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92681,271,'Perala','523157',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92682,271,'Perareddipalli','523246',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92683,271,'Peridepi','523273',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92684,271,'Pernamitta','523225',1,0,'2022-03-03 13:13:14','2022-03-03 13:13:14'),(92685,271,'Petlur','523270',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92686,271,'Pidathalagudipadu','523225',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92687,271,'Pitchikalagudipadu','523212',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92688,271,'Podili','523240',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92689,271,'Pokur','523113',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92690,271,'Polavaram','523265',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92691,271,'Polinenicheruvu','523116',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92692,271,'Polinenipalem','523116',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92693,271,'Polireddipalem','523270',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92694,271,'Poluru','523171',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92695,271,'Ponduru','523273',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92696,271,'Ponnalore','523109',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92697,271,'Pothakamur','523252',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92698,271,'Pothavaram','523247',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92699,271,'Pothavaram','523183',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92700,271,'Pothukatla','523169',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92701,271,'Potlapadu','523304',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92702,271,'Potluru','523281',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92703,271,'Prakasam Bhavan','523001',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92704,271,'Prasad Nagar So (C )','523157',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92705,271,'Prasangulapadu','523183',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92706,271,'Pulikonda','523226',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92707,271,'Pulikuntla','523224',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92708,271,'Pulipadu','523247',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92709,271,'Punuru','523169',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92710,271,'Puretipalli','523281',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92711,271,'Purimetla','523201',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92712,271,'Pusapadu','523190',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92713,271,'R.L.Puram','523226',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92714,271,'Rachapudi','523186',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92715,271,'Rachavaripalem','523211',1,0,'2022-03-03 13:13:15','2022-03-03 13:13:15'),(92716,271,'Raghunadhapuram','523110',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92717,271,'Raja','mpalli',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92718,271,'Rajanagaram','523264',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92719,271,'Rajubangarupalem','523135',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92720,271,'Rajugaripalem','523301',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92721,271,'Rajupalem','523280',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92722,271,'Rajupalem','523301',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92723,271,'Rallapadu Project','523114',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92724,271,'Rallapalli','523224',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92725,271,'Ramachandrapuram','523247',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92726,271,'Ramagopalapuram','523224',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92727,271,'Ramakrishnapuram','523155',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92728,271,'Ramapatnam','523291',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92729,271,'Ramayyapalem','523270',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92730,271,'Ramkur','523260',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92731,271,'Ramnagar (C )','523157',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92732,271,'Ramnagar(A)','523201',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92733,271,'Ramnagar(O)','523001',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92734,271,'Ramulaveedu','523240',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92735,271,'Raparala','523180',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92736,271,'Raviguntapalli','523254',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92737,271,'Ravinuthala','523213',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92738,271,'Ravulakollu','523109',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92739,271,'Ravuri Pet','523187',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92740,271,'Ravuru','523291',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92741,271,'Regadipalli','523241',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92742,271,'Regalagaddapalem','523270',1,0,'2022-03-03 13:13:16','2022-03-03 13:13:16'),(92743,271,'Reningavaram','523261',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92744,271,'Rudravaram','523225',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92745,271,'S.Konda','523101',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92746,271,'S.L. Gudipadu','523303',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92747,271,'Sakhavaram','523113',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92748,271,'Sameeripalem','523116',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92749,271,'Sanampudi','523101',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92750,271,'Sankarapuram','523265',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92751,271,'Sankavaram','523254',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92752,271,'Sankavarappadu','523260',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92753,271,'Santha Bazar','523155',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92754,271,'Santhamagulur','523302',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92755,271,'Santhanuthalapadu','523225',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92756,271,'Santhapeta (O)','523001',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92757,271,'Santharavur','523185',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92758,271,'Savireddi Palem','523272',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92759,271,'Seetharamapuram (O)','523001',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92760,271,'Seetharampuram','523227',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92761,271,'Siddavaram','523241',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92762,271,'Singamanenipalli','523113',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92763,271,'Singanapalem','523252',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92764,271,'Singarabotlapalem','523109',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92765,271,'Sivarampuram','523264',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92766,271,'Sivarayunipeta','523253',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92767,271,'Somarajupalli','523101',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92768,271,'Subbareddipalem','523190',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92769,271,'Sudanagunta','523240',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92770,271,'Sunkaravaripalem','523201',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92771,271,'Surepalli','523303',1,0,'2022-03-03 13:13:17','2022-03-03 13:13:17'),(92772,271,'Swarna','523170',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92773,271,'Talamalla','523253',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92774,271,'Tallur (Prakasam)','523264',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92775,271,'Talluru','523111',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92776,271,'Tangedumalli','523302',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92777,271,'Tangella','523271',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92778,271,'Tangutur','523274',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92779,271,'Tanguturu Bus Stand','523274',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92780,271,'Tatakulapalem','523270',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92781,271,'Tellapadu','523263',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92782,271,'Tettu','523291',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92783,271,'Thalakondapadu','523117',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92784,271,'Thammavaram','523212',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92785,271,'Thimmana Palem','523212',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92786,271,'Thimmayapalem','523201',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92787,271,'Thotavaripalem','523166',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92788,271,'Thotavenganapalem','523252',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92789,271,'Throvagunta','523262',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92790,271,'Thummagunta','523254',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92791,271,'Thurpu Naidu Palem','523272',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92792,271,'Thurupuchavatapalem','523247',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92793,271,'Thurupupalem','523001',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92794,271,'Timidithapadu','523170',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92795,271,'Timmapalem','523109',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92796,271,'Timmarajupalem','523171',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92797,271,'Timmareddipalem','523114',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92798,271,'Timmareddypalli','523228',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92799,271,'Timmasamudram','523185',1,0,'2022-03-03 13:13:18','2022-03-03 13:13:18'),(92800,271,'Tripurasundaripuram','523253',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92801,271,'Tumadu','523279',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92802,271,'Tumativaripalem','523110',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92803,271,'Turakapalem','523264',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92804,271,'Turupukodigundlapadu','523108',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92805,271,'Tuvvapadu','523241',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92806,271,'Ulavapadu','523292',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92807,271,'Ulichi','523182',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92808,271,'Umamaheswarapuram','523265',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92809,271,'Ummanapalli','523228',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92810,271,'Uppalapadu (K)','523279',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92811,271,'Uppalapadu (P)','523253',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92812,271,'Uppalapadu','523112',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92813,271,'Uppalapadu','523201',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92814,271,'Uppaledinne','523271',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92815,271,'Uppugundur','523186',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92816,271,'Uppumagulur','523301',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92817,271,'Upputuru','523169',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92818,271,'V V Palem','523116',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92819,271,'V.R.Kota','523113',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92820,271,'Vadarevu','523157',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92821,271,'Vaddimadugu','523241',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92822,271,'Vaggampalli','523108',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92823,271,'Vaidena','523303',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92824,271,'Valaparla','523260',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92825,271,'Valicherla','523228',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92826,271,'Vallayapalem','523240',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92827,271,'Vallur (Prakasam)','523272',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92828,271,'Vangapadu','523108',1,0,'2022-03-03 13:13:19','2022-03-03 13:13:19'),(92829,271,'Vankayalapadu','523190',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92830,271,'Vaviletipadu','523274',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92831,271,'Vedullacheruvu','523224',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92832,271,'Veerannapalem','523169',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92833,271,'Veerepalli','523292',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92834,271,'Velagapudi','523274',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92835,271,'Velamuripadu','523201',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92836,271,'Veligandla','523241',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92837,271,'Veligandla','523224',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92838,271,'Vellalacheruvu','523302',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92839,271,'Vellampalli','523211',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92840,271,'Veluru','523253',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92841,271,'Vemavaram','523111',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92842,271,'Vemavaramagraharam','523301',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92843,271,'Vemparala','523201',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92844,271,'Vemula','523265',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92845,271,'Vemulapadu','523246',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92846,271,'Vemulapadu','523273',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92847,271,'Vengalayapalli','523117',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92848,271,'Vengamukka Palem','523272',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92849,271,'Venkatachalampalli','523247',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92850,271,'Venkatapuram','523201',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92851,271,'Venkatapuram','523111',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92852,271,'Venkatapuram','523247',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92853,271,'Venkatapuram','523108',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92854,271,'Venkateswarapuram','523111',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92855,271,'Venkupalem','523109',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92856,271,'Vennuru','523279',1,0,'2022-03-03 13:13:20','2022-03-03 13:13:20'),(92857,271,'Verdhinenivaripalem','523271',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92858,271,'Vetapalem','523187',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92859,271,'Vikkirallapeta','523101',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92860,271,'Vinjanampadu','523301',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92861,271,'Viswanadhapuram','523240',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92862,271,'Vittalapuram','523264',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92863,271,'Vittalnagar','523157',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92864,271,'Votlabailu','523112',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92865,271,'West Gangavaram','523304',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92866,271,'West Veerayapalem','523304',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92867,271,'Woollapalem','523104',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92868,271,'Y.Laxmipuram','523225',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92869,271,'Yadavalli','523245',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92870,271,'Yanamadala','523301',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92871,271,'Yeddanapudi','523301',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92872,271,'Yedugundlapadu','523262',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92873,271,'Yendluru','523225',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92874,271,'Yerazerla','523272',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92875,271,'Yerramvaripalem','523169',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92876,271,'Yerraobanapalem','523304',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92877,271,'Yerrapalem','523212',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92878,271,'Zammalamadaka','523201',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92879,271,'Zuvvaleru','523240',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92880,271,'Zuvvigunta','523270',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92881,272,'Adavaram','532440',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92882,272,'Aradali','532440',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92883,272,'Avalangi','532462',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92884,272,'Batuva','535125',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92885,272,'Bhasuru','532440',1,0,'2022-03-03 13:13:21','2022-03-03 13:13:21'),(92886,272,'Bitiwada','532462',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92887,272,'Boddam','532148',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92888,272,'Bukkuru','532440',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92889,272,'Chandraiahpeta','532148',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92890,272,'Chettupodilam','532148',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92891,272,'Chidimi','532460',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92892,272,'Chittapudivalasa','532460',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92893,272,'Dalemrajuvalasa','535128',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92894,272,'Devudala','532440',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92895,272,'Donubai','532460',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92896,272,'Gadagamma','532460',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92897,272,'Garraju Chipurupalle','535128',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92898,272,'Gedda Kancharam','535125',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92899,272,'Gobburu','532148',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92900,272,'Gondi','532443',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92901,272,'Gottamangalapuram','532440',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92902,272,'Gumada','532460',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92903,272,'Hussainpuram','532460',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92904,272,'Jada','532148',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92905,272,'Jamparakota','532462',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92906,272,'Kadakella','532460',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92907,272,'Kambara','532460',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92908,272,'Kathulakaviti','532460',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92909,272,'Killada','532460',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92910,272,'Kodisa','532443',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92911,272,'Komiri','532440',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92912,272,'Kondapuram','532440',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92913,272,'Kottisa','532461',1,0,'2022-03-03 13:13:22','2022-03-03 13:13:22'),(92914,272,'Kuddapalli','532443',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92915,272,'Kusimi','532443',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92916,272,'Manda','532443',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92917,272,'Mokhasarajapuram','532460',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92918,272,'Nandabalaga','532148',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92919,272,'Narsipuram','532460',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92920,272,'Navagam','532462',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92921,272,'Neelanagaram','532462',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92922,272,'Niddam','532148',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92923,272,'Palakonda','532440',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92924,272,'Pedakotipalli','532440',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92925,272,'Pedapolla','532460',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92926,272,'Pedarama','532443',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92927,272,'Pedduru','532443',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92928,272,'Pogiri','532148',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92929,272,'Potli','532462',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92930,272,'Pubbada','532460',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92931,272,'Purli','532440',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92932,272,'Rajulagumada','532461',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92933,272,'Ramachandrapuram Agraharam','532148',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92934,272,'Regidi','532440',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92935,272,'Regulapadu','532460',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92936,272,'Routhupeta','535128',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92937,272,'Rushingi','532461',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92938,272,'Samarelli','532460',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92939,272,'Sambham','532443',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92940,272,'Sangam','532462',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92941,272,'Sankili','532440',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92942,272,'Seethampeta','532443',1,0,'2022-03-03 13:13:23','2022-03-03 13:13:23'),(92943,272,'Seetharampuram Inam','532461',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92944,272,'Sigadam','532148',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92945,272,'Singupuram','532462',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92946,272,'Sivvam','532461',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92947,272,'Talagam','532461',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92948,272,'Talavaram','532462',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92949,272,'Tampatapalli','532440',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92950,272,'Tettangi','532462',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92951,272,'Titukupai','532460',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92952,272,'Tudi','532460',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92953,272,'Vanduva','532460',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92954,272,'Vangara','532461',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92955,272,'Vatapagu','532440',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92956,272,'Veeraghattam','532460',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92957,272,'Voni','532440',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92958,272,'Adapaka','532403',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92959,272,'Aguru','532127',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92960,272,'Agurukancharam','532127',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92961,272,'Aitam Engg.College','532203',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92962,272,'Ajjaram','532403',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92963,272,'Akkulapeta','532186',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92964,272,'Akkupalli','532219',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92965,272,'Akulatampara','532459',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92966,272,'Alamajipeta','532190',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92967,272,'Alikam','532186',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92968,272,'Allada','532425',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92969,272,'Allena','532445',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92970,272,'Allinagaram','532403',1,0,'2022-03-03 13:13:24','2022-03-03 13:13:24'),(92971,272,'Aludu','532426',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92972,272,'Amadalavalasa H.O','532185',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92973,272,'Amalapadu','532218',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92974,272,'Amapalam','532429',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92975,272,'Ambada','532122',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92976,272,'Ambakhandi','532123',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92977,272,'Ampolu','532404',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92978,272,'Anandapuram','532168',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92979,272,'Andhavaram','532425',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92980,272,'Annupuram','532426',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92981,272,'Anthakapalli','532127',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92982,272,'Anthrakudda','532222',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92983,272,'Arasada','532122',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92984,272,'Arasavilli','532401',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92985,272,'Arjunavalasa','532409',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92986,272,'B.S.Puram','532186',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92987,272,'Badupuram','532264',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92988,272,'Balada','532457',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92989,272,'Baleru','532455',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92990,272,'Bandaruvanipeta','532406',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92991,272,'Baruva R S','532264',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92992,272,'Baruva','532263',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92993,272,'Bathupuram','532219',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92994,272,'Battili','532456',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92995,272,'Beejiputti','532322',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92996,272,'Bejjipuram','532403',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92997,272,'Belagam','532290',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92998,272,'Belamam','532484',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(92999,272,'Belamara','532430',1,0,'2022-03-03 13:13:25','2022-03-03 13:13:25'),(93000,272,'Bendi','532220',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93001,272,'Bhadri','532427',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93002,272,'Bhagempeta','532122',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93003,272,'Bhagiradhipuram','532459',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93004,272,'Bhairi','532405',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93005,272,'Bhamini','532456',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93006,272,'Bhirlangi','532312',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93007,272,'Bhogapuram','532264',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93008,272,'Boddapadu','532222',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93009,272,'Bodduru','532127',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93010,272,'Bomminaiduvalasa','532127',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93011,272,'Bontalakoduru','532408',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93012,272,'Borivanka','532292',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93013,272,'Borubhadra','532214',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93014,272,'Borubhadra','532218',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93015,272,'Borubhadra','532195',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93016,272,'Brahmanatarla','532220',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93017,272,'Brc Puram','532284',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93018,272,'Budatavalasa','532403',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93019,272,'Budithi','532427',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93020,272,'Budumuru','532403',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93021,272,'Buragam','532212',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93022,272,'Buragam','532284',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93023,272,'Buravilli','532405',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93024,272,'Buridikancharam','532168',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93025,272,'Burja','532445',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93026,272,'Burjapadu','532312',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93027,272,'Burujuvada','532426',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93028,272,'Calingapatnam','532406',1,0,'2022-03-03 13:13:26','2022-03-03 13:13:26'),(93029,272,'Chakipalli','532203',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93030,272,'Challavanipeta','532432',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93031,272,'Challayyavalasa','532429',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93032,272,'Chapara','532216',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93033,272,'Cheemalavalasa','532186',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93034,272,'Cheepi','532242',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93035,272,'Chiguruvalasa','532190',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93036,272,'Chinabadam','532222',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93037,272,'Chinakittalapadu','532214',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93038,272,'Chinavatsavalasa','532404',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93039,272,'Chinnabagga','532455',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93040,272,'Chintada','532186',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93041,272,'Chintalabadavanja','532458',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93042,272,'Chittarupuram','532168',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93043,272,'Chittivalasa','532186',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93044,272,'Chodavaram','532425',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93045,272,'Chowkipeta','532264',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93046,272,'D. Matchilesam','532408',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93047,272,'Dabbapadu','532458',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93048,272,'Dallavalasa','532402',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93049,272,'Dandugopalapuram','532212',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93050,272,'Dandulaxmipuram','532430',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93051,272,'Danta','532195',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93052,272,'Dasariraminaiduvalasa','532127',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93053,272,'Deerghasi','532429',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93054,272,'Deppilugonapaputtuga','532312',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93055,272,'Derasam','532409',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93056,272,'Devadi','532421',1,0,'2022-03-03 13:13:27','2022-03-03 13:13:27'),(93057,272,'Devanaltada','532211',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93058,272,'Devaravalasa','532168',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93059,272,'Devunipalavalasa','532409',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93060,272,'Dhanupuram','532214',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93061,272,'Dharmalaxmipuram','532214',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93062,272,'Dharmapuram','532312',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93063,272,'Dharmapuram','532402',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93064,272,'Dharmavaram','532408',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93065,272,'Dimidijola','532203',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93066,272,'Dimilada','532212',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93067,272,'Dimili','532457',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93068,272,'Dokulapadu','532222',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93069,272,'Dola','532429',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93070,272,'Dolagovindapuram','532291',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93071,272,'Dusi Rs','532484',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93072,272,'Edupuram','532312',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93073,272,'Elamanchili','532195',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93074,272,'Etcherla','532410',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93075,272,'Fareedpeta','532410',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93076,272,'G.M.R.Nagar','532127',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93077,272,'Gadimudidam','532127',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93078,272,'Galavilli','532122',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93079,272,'Gangaram','532195',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93080,272,'Ganguvada','532243',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93081,272,'Gara','532405',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93082,272,'Garudabhadra','532222',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93083,272,'Garudakhandi','532220',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93084,272,'Ghanasara','532455',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93085,272,'Gokarnapalli','532168',1,0,'2022-03-03 13:13:28','2022-03-03 13:13:28'),(93086,272,'Gollagandi','532263',1,0,'2022-03-03 13:13:29','2022-03-03 13:13:29'),(93087,272,'Gollalavalasa','532429',1,0,'2022-03-03 13:13:29','2022-03-03 13:13:29'),(93088,272,'Gonapaputtuga','532292',1,0,'2022-03-03 13:13:29','2022-03-03 13:13:29'),(93089,272,'Gonepadu','532458',1,0,'2022-03-03 13:13:29','2022-03-03 13:13:29'),(93090,272,'Gopalapuram','532127',1,0,'2022-03-03 13:13:29','2022-03-03 13:13:29'),(93091,272,'Goppili','532221',1,0,'2022-03-03 13:13:29','2022-03-03 13:13:29'),(93092,272,'Gorlapadu','532290',1,0,'2022-03-03 13:13:29','2022-03-03 13:13:29'),(93093,272,'Gotivada','532432',1,0,'2022-03-03 13:13:29','2022-03-03 13:13:29'),(93094,272,'Govindapuram','532123',1,0,'2022-03-03 13:13:29','2022-03-03 13:13:29'),(93095,272,'Gudarurajamanipuram','532242',1,0,'2022-03-03 13:13:29','2022-03-03 13:13:29'),(93096,272,'Gudem','532484',1,0,'2022-03-03 13:13:29','2022-03-03 13:13:29'),(93097,272,'Gudem','532203',1,0,'2022-03-03 13:13:29','2022-03-03 13:13:29'),(93098,272,'Gujarathipeta','532005',1,0,'2022-03-03 13:13:29','2022-03-03 13:13:29'),(93099,272,'Gulumuru','532459',1,0,'2022-03-03 13:13:29','2022-03-03 13:13:29'),(93100,272,'Gumadam','532407',1,0,'2022-03-03 13:13:29','2022-03-03 13:13:29'),(93101,272,'Gunabhadra','532455',1,0,'2022-03-03 13:13:29','2022-03-03 13:13:29'),(93102,272,'Gurandi','532456',1,0,'2022-03-03 13:13:29','2022-03-03 13:13:29'),(93103,272,'Gurandi','532459',1,0,'2022-03-03 13:13:29','2022-03-03 13:13:29'),(93104,272,'Guravam','532127',1,0,'2022-03-03 13:13:29','2022-03-03 13:13:29'),(93105,272,'Guttavilli','532445',1,0,'2022-03-03 13:13:29','2022-03-03 13:13:29'),(93106,272,'Haddubangi','532455',1,0,'2022-03-03 13:13:29','2022-03-03 13:13:29'),(93107,272,'Haridasupuram','532218',1,0,'2022-03-03 13:13:29','2022-03-03 13:13:29'),(93108,272,'Haripuram','532312',1,0,'2022-03-03 13:13:29','2022-03-03 13:13:29'),(93109,272,'Haripuram','532243',1,0,'2022-03-03 13:13:29','2022-03-03 13:13:29'),(93110,272,'Harischandrapuram','532430',1,0,'2022-03-03 13:13:29','2022-03-03 13:13:29'),(93111,272,'Hiramandalam','532459',1,0,'2022-03-03 13:13:29','2022-03-03 13:13:29'),(93112,272,'Honjaram','532168',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93113,272,'Ichchapuram Bus Stand','532312',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93114,272,'Ichchapuram','532312',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93115,272,'Idulavalasa','532421',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93116,272,'Ippili','532401',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93117,272,'Irapadu','532459',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93118,272,'Isakalapalem','532292',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93119,272,'J.R.Puram','532407',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93120,272,'Jaduru','532421',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93121,272,'Jagannadhapuram','532430',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93122,272,'Jagathi','532322',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93123,272,'Jalantrakota','532284',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93124,272,'Jalumuru','532432',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93125,272,'Jamachakram','532426',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93126,272,'Jandapeta','532212',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93127,272,'Jarjangi','532195',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93128,272,'Javam','532445',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93129,272,'Jeerupalem','532407',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93130,272,'Jhadupalli','532216',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93131,272,'Jhadupudi','532290',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93132,272,'Jinkibhadra','532284',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93133,272,'Kadagandi','532458',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93134,272,'Kadumu','532457',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93135,272,'Kallata','532214',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93136,272,'Kamalanabhapuram','532195',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93137,272,'Kambakaya','532421',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93138,272,'Kambalarayudupeta','532218',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93139,272,'Kameswaripeta','532425',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93140,272,'Kanchili','532290',1,0,'2022-03-03 13:13:30','2022-03-03 13:13:30'),(93141,272,'Kandisa','532122',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93142,272,'Kanimetta','532402',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93143,272,'Kanitivooru','532218',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93144,272,'Kanugulavalasa','532186',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93145,272,'Kapaskudda','532322',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93146,272,'Karajada','532221',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93147,272,'Karakavalasa','532428',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93148,272,'Karapadu','532312',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93149,272,'Karavanja','532432',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93150,272,'Kasibugga (Srikakulam)','532222',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93151,272,'Kasimivalasa','532186',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93152,272,'Kavitaagraharam','532220',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93153,272,'Kaviti','532322',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93154,272,'Kedaripuram','532221',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93155,272,'Kesaripada','532291',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93156,272,'Kesavarayunipalem','532403',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93157,272,'Kesupuram','532312',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93158,272,'Khajuru','532290',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93159,272,'Khandyam','532445',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93160,272,'Killoyicolony','532242',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93161,272,'Kinthali','532402',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93162,272,'Kistupuram','532195',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93163,272,'Kittalapadu','532428',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93164,272,'Kodisa','532122',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93165,272,'Koduru','532430',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93166,272,'Koligam','532312',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93167,272,'Komaraltada','532218',1,0,'2022-03-03 13:13:31','2022-03-03 13:13:31'),(93168,272,'Komarti','532421',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93169,272,'Kommanapalli','532427',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93170,272,'Kommusariapalli','532203',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93171,272,'Kommuvalasa','532459',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93172,272,'Kondalogam','532243',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93173,272,'Kondaragolu','532459',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93174,272,'Kondavalasa','532190',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93175,272,'Kondavooru','532218',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93176,272,'Korallavalasa','532127',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93177,272,'Korama','532455',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93178,272,'Korasavada','532214',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93179,272,'Korlakota','532186',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93180,272,'Korlam','532405',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93181,272,'Kotabomma R.S.','532195',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93182,272,'Kotabommali','532195',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93183,272,'Kotapalem','532407',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93184,272,'Kothagraharam','532220',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93185,272,'Kothalingudu','532211',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93186,272,'Kothapalli','532242',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93187,272,'Kothapalli','532203',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93188,272,'Kothapeta','532005',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93189,272,'Kotturu','532455',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93190,272,'Kovvadamachilesam','532407',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93191,272,'Koyyam','532408',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93192,272,'Kuppili','532403',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93193,272,'Kurigam','532457',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93194,272,'Kurmanadhapuram','532218',1,0,'2022-03-03 13:13:32','2022-03-03 13:13:32'),(93195,272,'Kurudu','532195',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93196,272,'Kusumapuram','532292',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93197,272,'L.N.Peta','532458',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93198,272,'Labara','532213',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93199,272,'Labba','532459',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93200,272,'Labham','532445',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93201,272,'Laidam','532168',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93202,272,'Lakkivalasa','532211',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93203,272,'Lakkupuram','532445',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93204,272,'Laveru','532407',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93205,272,'Laxmidevipeta','532222',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93206,272,'Lingalavalasa','532123',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93207,272,'Lingalavalasa','532404',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93208,272,'Lingalavalasa','532203',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93209,272,'Loddaputti','532312',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93210,272,'Loharijola','532456',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93211,272,'Lolugu','532168',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93212,272,'Lukulam','532425',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93213,272,'Mabagam','532421',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93214,272,'Madapam','532421',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93215,272,'Madduvalasa','532122',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93216,272,'Makarampuram','532290',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93217,272,'Makivalasa','532421',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93218,272,'Mamidipalli','532123',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93219,272,'Mamidipalli','532264',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93220,272,'Mamidivalasa','532123',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93221,272,'Mamidivalasa','532445',1,0,'2022-03-03 13:13:33','2022-03-03 13:13:33'),(93222,272,'Mandapalli','532312',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93223,272,'Mandarada','532123',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93224,272,'Mandasa','532242',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93225,272,'Mandavakuriti','532168',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93226,272,'Manikyapuram','532292',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93227,272,'Manthina','532168',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93228,272,'Maredubaka','532127',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93229,272,'Marripadu','532455',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93230,272,'Marripadu','532211',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93231,272,'Marripadu','532215',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93232,272,'Meghavaram','532211',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93233,272,'Meliaputti','532215',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93234,272,'Metturu','532219',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93235,272,'Mirtivalasa','532168',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93236,272,'Modallavalasa','532484',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93237,272,'Mofusbandar','532401',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93238,272,'Ms Palli','532291',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93239,272,'Muchindra','532312',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93240,272,'Muddada','532005',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93241,272,'Mukhalingam','532428',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93242,272,'Mundala','532291',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93243,272,'Murapaka','532403',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93244,272,'Nadagam','532425',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93245,272,'Nadumuru','532263',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93246,272,'Nagarampalli','532222',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93247,272,'Nagarikatakam','532428',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93248,272,'Nagulavalasa','532127',1,0,'2022-03-03 13:13:34','2022-03-03 13:13:34'),(93249,272,'Naira','532186',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93250,272,'Nandigam','532203',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93251,272,'Narasannapeta Market','532421',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93252,272,'Narasannapeta','532421',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93253,272,'Narasingupalli','532203',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93254,272,'Narsipuram','532203',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93255,272,'Naupada RS','532212',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93256,272,'Naupada (Srikakulam)','532211',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93257,272,'Nayaralavalasa','532122',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93258,272,'Neelampeta','532445',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93259,272,'Neelavathi','532243',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93260,272,'Neelayyavalasa','532122',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93261,272,'Neradi','532459',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93262,272,'Nimmada','532430',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93263,272,'Nivagam','532457',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93264,272,'Nowgam','532203',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93265,272,'Opivada Venkampeta','532186',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93266,272,'P.S.Puram','532190',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93267,272,'Padali','532459',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93268,272,'Palakhandyam','532168',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93269,272,'Palasa','532221',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93270,272,'Palasapuram','532284',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93271,272,'Palavalasa','532264',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93272,272,'Pallisaradhi','532222',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93273,272,'Parampeta','532122',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93274,272,'Parapuram','532455',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93275,272,'Paraselli','532425',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93276,272,'Parasurampuram','532203',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93277,272,'Parlam','532425',1,0,'2022-03-03 13:13:35','2022-03-03 13:13:35'),(93278,272,'Pathakumkam','532168',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93279,272,'Pathapatnam','532213',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93280,272,'Patharlapalli','532407',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93281,272,'Pathatekkali','532218',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93282,272,'Pathivadapalem','532409',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93283,272,'Patrunivalasa','532401',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93284,272,'Pattupuram','532195',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93285,272,'Pedalamba','532214',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93286,272,'Pedalavunipalli','532203',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93287,272,'Pedalaxmipuram','532216',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93288,272,'Pedamuraharipuram','532218',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93289,272,'Pedanarayanapuram','532220',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93290,272,'Pedapadmapuram','532215',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93291,272,'Pedasankili','532459',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93292,272,'Pedasavalapuram','532458',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93293,272,'Pedasirlam','532122',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93294,272,'Pedasrirampuram','532290',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93295,272,'Peddabammidi','532474',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93296,272,'Peddadimili','532455',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93297,272,'Peddakojjiria','532290',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93298,272,'Peddakota','532458',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93299,272,'Peddalogidi','532213',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93300,272,'Peddamallipuram','532213',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93301,272,'Peddapadu','532401',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93302,272,'Peddaseedhi','532214',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93303,272,'Penubaka','532127',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93304,272,'Piruvada','532421',1,0,'2022-03-03 13:13:36','2022-03-03 13:13:36'),(93305,272,'Polaki','532429',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93306,272,'Polavaram','532203',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93307,272,'Poleru','532291',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93308,272,'Ponduru','532168',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93309,272,'Ponnada','532408',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93310,272,'Ponnam','532186',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93311,272,'Potrakonda','532264',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93312,272,'Priyagraharam','532430',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93313,272,'Puliputti','532455',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93314,272,'Pundi R S','532218',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93315,272,'Purushothapur (IPR)','532312',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93316,272,'Pusam','532458',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93317,272,'Pydibheemavaram','532409',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93318,272,'R.L.Puram','532213',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93319,272,'Ragolu','532484',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93320,272,'Rajam','532409',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93321,272,'Rajam','532127',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93322,272,'Rajapuram','532322',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93323,272,'Rana','532474',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93324,272,'Ranasthalam','532407',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93325,272,'Rangoi','532243',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93326,272,'Rapaka','532168',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93327,272,'Rattakanna','532312',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93328,272,'Ravivalasa','532212',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93329,272,'Regulapadu','532432',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93330,272,'Rentikota','532221',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93331,272,'Reyyipadu','532218',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93332,272,'Romadala','532214',1,0,'2022-03-03 13:13:37','2022-03-03 13:13:37'),(93333,272,'Rottavalasa','532190',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93334,272,'Runku Hanumanthapuram','532430',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93335,272,'Rushikudda','532292',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93336,272,'S.M.Puram','532402',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93337,272,'S.R.Puram','532123',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93338,272,'Sahalalaputtuga','532290',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93339,272,'Salihundam','532405',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93340,272,'Sancham','532409',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93341,272,'Sanivada','532401',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93342,272,'Santhabommali','532195',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93343,272,'Santhakaviti','532123',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93344,272,'Santhavuriti','532168',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93345,272,'Sarali','532213',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93346,272,'Sarasanapalli','532122',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93347,272,'Saravakota','532426',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93348,272,'Sarubujjili','532458',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93349,272,'Sasanam','532203',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93350,272,'Sasanam','532284',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93351,272,'Sathivada','532405',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93352,272,'Satyavaram','532421',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93353,272,'Savaraddapanasa','532426',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93354,272,'Seetarampalli','532213',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93355,272,'Seethapuram','532203',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93356,272,'Sekharapuram','532216',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93357,272,'Shalantri','532190',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93358,272,'Siddhantham','532458',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93359,272,'Silagam','532322',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93360,272,'Singidi','532456',1,0,'2022-03-03 13:13:38','2022-03-03 13:13:38'),(93361,272,'Siriakhandi','532215',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93362,272,'Siripuram','532168',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93363,272,'Sirusuvada','532455',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93364,272,'Somagandi','532455',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93365,272,'Sompeta','532284',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93366,272,'Sondipudi','532242',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93367,272,'Srikakulam Collectorate','532001',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93368,272,'Srikakulam District Court','532001',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93369,272,'Srikakulam H.O','532001',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93370,272,'Srikakulam Market','532001',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93371,272,'Srikakulam New Colony','532001',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93372,272,'Srikakulam Official Colony','532001',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93373,272,'Srikakulam Town','532001',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93374,272,'Srikakulam Zilla Parishad','532001',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93375,272,'Srikurmam','532404',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93376,272,'Suravam','532168',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93377,272,'Suvarnapuram','532243',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93378,272,'T.Lingalapadu','532195',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93379,272,'Tadivalasa','532484',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93380,272,'Talada','532123',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93381,272,'Talagam','532212',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93382,272,'Talasamudram','532429',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93383,272,'Talatampara','532292',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93384,272,'Tallabhadra','532243',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93385,272,'Tallavalasa','532407',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93386,272,'Tamavada','532403',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93387,272,'Tandemvalasa','532186',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93388,272,'Tankaladuggivalasa','532168',1,0,'2022-03-03 13:13:39','2022-03-03 13:13:39'),(93389,272,'Tarlakota','532221',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93390,272,'Tekkali H.O','532201',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93391,272,'Tekkalipatnam','532220',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93392,272,'Telikipenta','532458',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93393,272,'Temburu','532203',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93394,272,'Teppalavalasa','532407',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93395,272,'Thandyam','532168',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93396,272,'Thogaram','532484',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93397,272,'Tholapi','532402',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93398,272,'Thotada','532484',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93399,272,'Thotapalem','532005',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93400,272,'Thotavada','532445',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93401,272,'Tiddimi','532213',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93402,272,'Tilaru','532474',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93403,272,'Tilaru RS','532474',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93404,272,'Timadam','532427',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93405,272,'Togiri','532427',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93406,272,'Tonangi','532406',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93407,272,'Tulagam','532459',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93408,272,'Tulugu','532405',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93409,272,'Tungatampara','532459',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93410,272,'Tunivada','532122',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93411,272,'Turakapeta','532186',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93412,272,'Turakasasanam','532264',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93413,272,'Uddavolu','532122',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93414,272,'Umilada','532430',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93415,272,'Uppalam','532263',1,0,'2022-03-03 13:13:40','2022-03-03 13:13:40'),(93416,272,'Uppinivalasa','532186',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93417,272,'Urjam','532429',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93418,272,'Urlam','532425',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93419,272,'Vadada','532401',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93420,272,'Vajrapukotturu','532222',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93421,272,'Vanjangi','532484',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93422,272,'Varisam','532409',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93423,272,'Vasudevapatnam','532123',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93424,272,'Vasundhara','532215',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93425,272,'Vatsavalasa','532404',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93426,272,'Vavilavalasa','532123',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93427,272,'Vengala Rao Colony','532186',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93428,272,'Venkampeta','532122',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93429,272,'Venkatapuram','532220',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93430,272,'Venkatapuram','532407',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93431,272,'Venkateswara Colony','532203',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93432,272,'Venugopalapuram','532203',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93433,272,'Vommaravilli','532406',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93434,272,'Vommi','532127',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93435,272,'Vondrajola','532458',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93436,272,'Vonkuluru','532219',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93437,272,'Vungarada','532123',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93438,272,'Vunukuru','532122',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93439,272,'Walteru','532168',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93440,272,'Yalamanchili','532427',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93441,272,'Yeragam','532458',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93442,272,'Yerramukkam','532263',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93443,273,'A Koduru','531022',1,0,'2022-03-03 13:13:41','2022-03-03 13:13:41'),(93444,273,'A Kothapalle','531022',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93445,273,'A Veeranarayanam','531027',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93446,273,'Adakula','531115',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93447,273,'Addumanda','531077',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93448,273,'Adduru','531035',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93449,273,'Aduguluputtu','531040',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93450,273,'Alamanda','531030',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93451,273,'Amal College','531002',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93452,273,'Amalapuram','531117',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93453,273,'Ameena Sahebpeta','531055',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93454,273,'Ammulapalem','531002',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93455,273,'Amruthpuram.','531035',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93456,273,'Anakapalle H.O','531001',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93457,273,'Anandapuram','531022',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93458,273,'Annavaram','531118',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93459,273,'Annavaram','531111',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93460,273,'Antada','531084',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93461,273,'Anthakapalle','531035',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93462,273,'Appalrajupuram','531028',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93463,273,'Aradakota','531040',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93464,273,'Araku','531151',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93465,273,'Araku Colony','531149',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93466,273,'Araku Rs','531151',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93467,273,'Aripaka','531035',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93468,273,'Arjunagiri','531036',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93469,273,'Arle','531034',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93470,273,'Arma','531151',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93471,273,'Asakapalle','531035',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93472,273,'Atcherla','531031',1,0,'2022-03-03 13:13:42','2022-03-03 13:13:42'),(93473,273,'Atchutapuram','531011',1,0,'2022-03-03 13:13:43','2022-03-03 13:13:43'),(93474,273,'Babusala','531040',1,0,'2022-03-03 13:13:43','2022-03-03 13:13:43'),(93475,273,'Bakuru','531077',1,0,'2022-03-03 13:13:43','2022-03-03 13:13:43'),(93476,273,'Balighattam','531118',1,0,'2022-03-03 13:13:43','2022-03-03 13:13:43'),(93477,273,'Bandaveedhi','531029',1,0,'2022-03-03 13:13:43','2022-03-03 13:13:43'),(93478,273,'Bangarammapalem','531035',1,0,'2022-03-03 13:13:43','2022-03-03 13:13:43'),(93479,273,'Bangarampeta','531084',1,0,'2022-03-03 13:13:43','2022-03-03 13:13:43'),(93480,273,'Bapiraju Kothapalli','531085',1,0,'2022-03-03 13:13:43','2022-03-03 13:13:43'),(93481,273,'Basiputtu','531040',1,0,'2022-03-03 13:13:43','2022-03-03 13:13:43'),(93482,273,'Baski','531149',1,0,'2022-03-03 13:13:43','2022-03-03 13:13:43'),(93483,273,'Batlapudi','531002',1,0,'2022-03-03 13:13:43','2022-03-03 13:13:43'),(93484,273,'Bayyavaram','531031',1,0,'2022-03-03 13:13:43','2022-03-03 13:13:43'),(93485,273,'Bennabhupalapatnam','531118',1,0,'2022-03-03 13:13:43','2022-03-03 13:13:43'),(93486,273,'Bennavaram','531111',1,0,'2022-03-03 13:13:43','2022-03-03 13:13:43'),(93487,273,'Bharnikam','531021',1,0,'2022-03-03 13:13:43','2022-03-03 13:13:43'),(93488,273,'Bheemaboinapalem','531113',1,0,'2022-03-03 13:13:43','2022-03-03 13:13:43'),(93489,273,'Bhimavaram','531082',1,0,'2022-03-03 13:13:43','2022-03-03 13:13:43'),(93490,273,'Bhogapuram','531023',1,0,'2022-03-03 13:13:43','2022-03-03 13:13:43'),(93491,273,'Bodapalem','531117',1,0,'2022-03-03 13:13:43','2022-03-03 13:13:43'),(93492,273,'Bodugullam Agraharam','531081',1,0,'2022-03-03 13:13:43','2022-03-03 13:13:43'),(93493,273,'Boduvalasa','531035',1,0,'2022-03-03 13:13:43','2022-03-03 13:13:43'),(93494,273,'Bondam','531149',1,0,'2022-03-03 13:13:43','2022-03-03 13:13:43'),(93495,273,'Bonthilli','531029',1,0,'2022-03-03 13:13:43','2022-03-03 13:13:43'),(93496,273,'Bosubeda','531149',1,0,'2022-03-03 13:13:43','2022-03-03 13:13:43'),(93497,273,'Budarallu','531087',1,0,'2022-03-03 13:13:43','2022-03-03 13:13:43'),(93498,273,'Burja','531149',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93499,273,'Burugupalem','531113',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93500,273,'Butchampeta','531118',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93501,273,'Butchiyyapeta','531026',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93502,273,'Bylakinchangi','531111',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93503,273,'Ch Laxmipuram','531081',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93504,273,'Chakipalle','531036',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93505,273,'Chammachinta','531115',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93506,273,'Chandanada','531081',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93507,273,'Cheedigummala','531118',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93508,273,'Cheedikada','531028',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93509,273,'Cheedipalem','531087',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93510,273,'Cheepurupalli','531020',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93511,273,'Cherlopalem','531117',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93512,273,'Chettupalle','531118',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93513,273,'Chettupalle','531036',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93514,273,'China Appannapalem','531026',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93515,273,'Chinadoddigallu','531081',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93516,273,'Chinalabudu','531149',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93517,273,'Chinamadina','531026',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93518,273,'Chinanadipalli','531030',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93519,273,'Chinapachila','531025',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93520,273,'Chinnagummuluru','531083',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93521,273,'Chintagatla','531035',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93522,273,'Chintalapudi','531087',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93523,273,'Chintalaveedhi','531024',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93524,273,'Chintapalli','531111',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93525,273,'Chittempadu','531084',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93526,273,'Chn Agraharam','531032',1,0,'2022-03-03 13:13:44','2022-03-03 13:13:44'),(93527,273,'Chodapalle','531011',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93528,273,'Chodavaram','531036',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93529,273,'Chodyam.','531084',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93530,273,'Chompi','531149',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93531,273,'Chowdupalli','531111',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93532,273,'Chowduvada','531034',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93533,273,'Chukkapalle','531036',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93534,273,'D Gottivada','531027',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93535,273,'D L Puram','531081',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93536,273,'Dalaipalim','531020',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93537,273,'Damanapalli','531111',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93538,273,'Damunapalle','531036',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93539,273,'Darakonda','531105',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93540,273,'Darela','531040',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93541,273,'Darlapudi','531082',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93542,273,'Desapatrunipalem','531021',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93543,273,'Devapuram','531027',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93544,273,'Devarapalli','531133',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93545,273,'Devarapalli (Visakhapatnam)','531030',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93546,273,'Dharagangavaram','531115',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93547,273,'Dharapalem','531061',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93548,273,'Dharnasagaram','531118',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93549,273,'Dibbapalem','531026',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93550,273,'Dibbidi','531026',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93551,273,'Dimili','531061',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93552,273,'Dokuluru','531024',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93553,273,'Dondapudi','531114',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93554,273,'Donkada','531126',1,0,'2022-03-03 13:13:45','2022-03-03 13:13:45'),(93555,273,'Dopperla','531021',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93556,273,'Dosuru','531011',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93557,273,'Downuru','531118',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93558,273,'Duddupalem','531023',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93559,273,'Dumbriguda','531151',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93560,273,'Duppulavada','531105',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93561,273,'Dupputuru','531011',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93562,273,'E D Peta','531115',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93563,273,'Enugutuni','531055',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93564,273,'Etikoppaka','531082',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93565,273,'G J Puram','531126',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93566,273,'G Madugula','531029',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93567,273,'Gabbada','531118',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93568,273,'Gadirai','531027',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93569,273,'Gaduthuru','531029',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93570,273,'Gagaba','531151',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93571,273,'Galaganda','531077',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93572,273,'Galikonda','531133',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93573,273,'Gammili','531029',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93574,273,'Gamparai','531077',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93575,273,'Ganaparthi','531055',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93576,273,'Gandhavaram','531032',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93577,273,'Gandhinagaram (Visakhapatnam)','531001',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93578,273,'Gangavaram','531087',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93579,273,'Gannela','531149',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93580,273,'Gattam','531151',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93581,273,'Gavaravaram','531075',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93582,273,'Geddapalem','531083',1,0,'2022-03-03 13:13:46','2022-03-03 13:13:46'),(93583,273,'Giduturu','531113',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93584,273,'Godicherla','531126',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93585,273,'Gogada Kothapalle','531036',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93586,273,'Gokivada','531061',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93587,273,'Gollalapalem','531035',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93588,273,'Golugondapeta','531115',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93589,273,'Gompa','531025',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93590,273,'Gondeli','531024',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93591,273,'Gondipakalau','531118',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93592,273,'Gondupalem','531034',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93593,273,'Gopalapatnam','531127',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93594,273,'Gopalapuram','531002',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93595,273,'Gorapudi','531061',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93596,273,'Gorapur','531151',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93597,273,'Govada','531023',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93598,273,'Govindapalem','531061',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93599,273,'Gowripatnam','531036',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93600,273,'Guda','531077',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93601,273,'Gudem','531133',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93602,273,'Gudivada','531083',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93603,273,'Gudivada','531025',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93604,273,'Gullepalle','531034',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93605,273,'Gullepalli','531035',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93606,273,'Gullipadu','531126',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93607,273,'Gummadigonda','531115',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93608,273,'Gundupala','531118',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93609,273,'Gunnempudi','531025',1,0,'2022-03-03 13:13:47','2022-03-03 13:13:47'),(93610,273,'Guntagannela','531151',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93611,273,'Guntapalle','531126',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93612,273,'Guntaseema','531151',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93613,273,'Gunupudi','531115',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93614,273,'Gurajapalem','531011',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93615,273,'Gurandarapalem','531118',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93616,273,'Guttulaputtu','531077',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93617,273,'Haripuram','531061',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93618,273,'Hukumpeta','531077',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93619,273,'Idatam','531127',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93620,273,'Iradapalle','531024',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93621,273,'Iragi','531149',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93622,273,'Iti Araku','531149',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93623,273,'J P Agraharam','531118',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93624,273,'Jagannadhapuram.','531055',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93625,273,'Jaggampeta','531114',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93626,273,'Jaithavaram','531028',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93627,273,'Jalampalli','531027',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93628,273,'Jammadevipeta','531027',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93629,273,'Janguluru','531055',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93630,273,'Jannavaram','531036',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93631,273,'Jarrela','531040',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93632,273,'Jawaharlalnehru Pharmacity','531019',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93633,273,'Jerrala','531111',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93634,273,'Jilledupudi','531117',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93635,273,'Jogempeta','531084',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93636,273,'Jolaput','531040',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93637,273,'Juttada','531023',1,0,'2022-03-03 13:13:48','2022-03-03 13:13:48'),(93638,273,'K Kotapadu','531034',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93639,273,'K Mallampeta','531084',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93640,273,'K Santhaplem','531034',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93641,273,'K Yellavaram','531118',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93642,273,'Kailasapatnam','531085',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93643,273,'Kakarapadu','531087',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93644,273,'Kalapaka','531021',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93645,273,'Kalavalapalle','531061',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93646,273,'Kalayanapulova','531114',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93647,273,'Kaligotla','531075',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93648,273,'Kamayyapeta','531077',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93649,273,'Kanchugummala','531114',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93650,273,'Kandepalli','531036',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93651,273,'Kandipudi','531036',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93652,273,'Kandipudi','531127',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93653,273,'Kandivaram','531028',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93654,273,'Kandrum','531151',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93655,273,'Kannampeta','531114',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93656,273,'Kannurupalem','531031',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93657,273,'Kantaram','531084',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93658,273,'Karimukhput','531040',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93659,273,'Kasimkota','531031',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93660,273,'Kasipuram','531030',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93661,273,'Kd Peta','531084',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93662,273,'Khazeepalem','531033',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93663,273,'Kilagada','531040',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93664,273,'Killamkota','531029',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93665,273,'Kimudupalle','531077',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93666,273,'Kinaparthi','531084',1,0,'2022-03-03 13:13:49','2022-03-03 13:13:49'),(93667,273,'Kinchumanda','531151',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93668,273,'Kindangi','531024',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93669,273,'Kinthada','531034',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93670,273,'Kinthalli','531027',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93671,273,'Kithalangi','531151',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93672,273,'Kitumula','531118',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93673,273,'Kiverla','531030',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93674,273,'Kj Puram','531028',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93675,273,'Kodavatipudi','531085',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93676,273,'Koduru','531002',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93677,273,'Koduru','531113',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93678,273,'Kokkirapalle','531055',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93679,273,'Kokkirapalle','531029',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93680,273,'Kollaput','531151',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93681,273,'Komaruvolu','531114',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93682,273,'Kommangi','531111',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93683,273,'Kommika','531084',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93684,273,'Konam','531028',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93685,273,'Kondakarla','531033',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93686,273,'Kondala Agraharam','531113',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93687,273,'Kondupalem Agraharam','531026',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93688,273,'Kondupalem','531002',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93689,273,'Konkasingi','531084',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93690,273,'Konthalam','531114',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93691,273,'Konthili','531077',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93692,273,'Korra','531151',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93693,273,'Korrai','531151',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93694,273,'Korukonda','531111',1,0,'2022-03-03 13:13:50','2022-03-03 13:13:50'),(93695,273,'Koruprolu','531083',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93696,273,'Koruvada','531022',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93697,273,'Kotauratla','531085',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93698,273,'Kothaballuguda','531149',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93699,273,'Kothakota (Visakhapatnam)','531114',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93700,273,'Kothapalem','531111',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93701,273,'Kothapatnam','531114',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93702,273,'Kothapenta','531034',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93703,273,'Kothuru','531061',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93704,273,'Kotnapalle','531077',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93705,273,'Kovvuru','531114',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93706,273,'Koyyuru','531087',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93707,273,'Krishna Bazar(Narsipatnam)','531118',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93708,273,'Kuamarapura','531127',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93709,273,'Kundram','531032',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93710,273,'Kuntharla','531029',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93711,273,'Kuntsangi','531032',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93712,273,'Kusarlapudi','531118',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93713,273,'Lakkavaram (Visakhapatnam)','531075',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93714,273,'Lakkavarapukota','531133',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93715,273,'Lalamkoduru','531011',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93716,273,'Lammasingi','531118',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93717,273,'Lankelapalem','531019',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93718,273,'Laxmipura','531036',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93719,273,'Layaganda','531151',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93720,273,'Legisipalli','531024',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93721,273,'Lingapuram','531085',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93722,273,'Lingarajupalem','531060',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93723,273,'Lingeti','531029',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93724,273,'Lopudi','531026',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93725,273,'Lother','531149',1,0,'2022-03-03 13:13:51','2022-03-03 13:13:51'),(93726,273,'Lothugedda','531111',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93727,273,'Luthugedda Jn.','531111',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93728,273,'Luvvasingi','531029',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93729,273,'M B Patnam','531115',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93730,273,'M Bennavaram','531117',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93731,273,'M K Patnam','531118',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93732,273,'M Koduru','531027',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93733,273,'M Kotapadu','531028',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93734,273,'M Makavaram','531087',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93735,273,'Madagada','531149',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93736,273,'Madala','531149',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93737,273,'Madugula','531027',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93738,273,'Maduthuru','531011',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93739,273,'Makavaram','531040',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93740,273,'Makavarapalem','531113',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93741,273,'Mallam','531036',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93742,273,'Mallavaram','531113',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93743,273,'Mallunaidupalem','531035',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93744,273,'Mamidipalem','531075',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93745,273,'Mamidipalem','531032',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93746,273,'Mampa','531087',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93747,273,'Manchala','531028',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93748,273,'Mangavaram','531126',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93749,273,'Manyapuratla','531115',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93750,273,'Maredupudi','531019',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93751,273,'Marripalem','531115',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93752,273,'Marrivada','531087',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93753,273,'Marupaka','531025',1,0,'2022-03-03 13:13:52','2022-03-03 13:13:52'),(93754,273,'Maruturu','531032',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93755,273,'Mattam','531077',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93756,273,'Medicherla','531034',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93757,273,'Medivada','531025',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93758,273,'Melupaka','531055',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93759,273,'Minimuluru','531024',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93760,273,'Mondigedda','531111',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93761,273,'Muddurthi','531023',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93762,273,'Munagapaka','531033',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93763,273,'Munchingput','531040',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93764,273,'Murakada','531061',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93765,273,'Mushidipalli','531022',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93766,273,'Nadimpalem','531084',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93767,273,'Nagayyapeta','531030',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93768,273,'Nagulapalli','531002',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93769,273,'Nakkapalle','531081',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93770,273,'Namavaram','531126',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93771,273,'Narasingabilli','531055',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93772,273,'Narsingaraopeta','531019',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93773,273,'Narsipatnam H.O','531116',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93774,273,'Nathavaram','531115',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93775,273,'Nidanam Doddi','531002',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93776,273,'Nindugonda','531118',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93777,273,'Ntpc Simhadri','531020',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93778,273,'Nunaparthi','531020',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93779,273,'Nurmathi','531029',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93780,273,'Old K D Peta','531084',1,0,'2022-03-03 13:13:53','2022-03-03 13:13:53'),(93781,273,'P Kotha Gudem','531115',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93782,273,'P Kothapalle','531117',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93783,273,'P P Agraharam','531113',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93784,273,'Paderoo','531024',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93785,273,'Pakalapadu','531118',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93786,273,'Pakeersahebpeta','531036',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93787,273,'Pallapu Anandapuram','531033',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93788,273,'Pamulavaka','531117',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93789,273,'Panasaput','531040',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93790,273,'Panduru','531085',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93791,273,'Papayya Santhapalem','531032',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93792,273,'Pappusettipalem','531084',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93793,273,'Paravada','531021',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93794,273,'Parreda','531040',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93795,273,'Pathakota','531077',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93796,273,'Pathamallmpeta','531084',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93797,273,'Patipalle','531033',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93798,273,'Pattam','531151',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93799,273,'Payakarao Bonangi','531021',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93800,273,'Payakaraopeta','531126',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93801,273,'Peda Doddigallu','531081',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93802,273,'Pedabaludu','531149',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93803,273,'Pedabayalu','531040',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93804,273,'Pedagaruvu','531077',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93805,273,'Pedagogada','531036',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93806,273,'Pedaguda','531040',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93807,273,'Pedagummuluru','531083',1,0,'2022-03-03 13:13:54','2022-03-03 13:13:54'),(93808,273,'Pedajaggampeta','531115',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93809,273,'Pedakodapalli','531077',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93810,273,'Pedakota','531030',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93811,273,'Pedamakavaram','531084',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93812,273,'Pedamushidivada','531019',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93813,273,'Pedanandipalle Agraharam','531030',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93814,273,'Pedapalli','531055',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93815,273,'Pedaramabhadrapuram','531127',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93816,273,'Pedateenarla','531081',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93817,273,'Pedauppalam','531083',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93818,273,'Pedavalasa','531133',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93819,273,'Pedda Boddepalli','531118',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93820,273,'Pentakota','531127',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93821,273,'Penugollu','531055',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93822,273,'Petasudipuram','531055',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93823,273,'Pottidorapalem','531026',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93824,273,'Pudimadaka','531011',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93825,273,'Pulaparthi','531055',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93826,273,'Purushothapuram','531055',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93827,273,'Pydampeta','531034',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93828,273,'Pydipala','531113',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93829,273,'Pyrampadu','531151',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93830,273,'Rachapalli','531113',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93831,273,'Raivada','531030',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93832,273,'Raja Koduru','531061',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93833,273,'Rajam','531036',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93834,273,'Rajayyapeta','531081',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93835,273,'Rajupakalu','531118',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93836,273,'Rajupeta','531085',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93837,273,'Rama Yogi Agraharam','531022',1,0,'2022-03-03 13:13:55','2022-03-03 13:13:55'),(93838,273,'Rambilli','531061',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93839,273,'Rangaseela','531151',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93840,273,'Rangelisingi','531151',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93841,273,'Ravada','531020',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93842,273,'Ravikamatham','531025',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93843,273,'Rayapurajupeta','531023',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93844,273,'Rebaka','531002',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93845,273,'Rebaka','531126',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93846,273,'Regupalem','531055',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93847,273,'Revallu','531087',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93848,273,'Revupolavaram','531083',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93849,273,'Rintada','531133',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93850,273,'Rolugunta','531114',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93851,273,'Rongalinaidupalem','531034',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93852,273,'Rudakota','531040',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93853,273,'Rv Nagar','531133',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93854,273,'S Rayavaram','531060',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93855,273,'S.Ankada','531133',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93856,273,'Sagara','531151',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93857,273,'Sagaram','531027',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93858,273,'Salugu','531024',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93859,273,'Sampathipuram','531031',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93860,273,'Sanivaram','531118',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93861,273,'Sankaram','531027',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93862,273,'Santhari','531077',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93863,273,'Saparla','531133',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93864,273,'Sarabhannapalem','531084',1,0,'2022-03-03 13:13:56','2022-03-03 13:13:56'),(93865,273,'Sarugudu','531115',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93866,273,'Sarvasiddi','531060',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93867,273,'Satyavaram','531027',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93868,273,'Satyavaram','531127',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93869,273,'Seekari','531040',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93870,273,'Seethayyapeta','531025',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93871,273,'Sileru Project','531105',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93872,273,'Singannadorapalem','531034',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93873,273,'Singarbha','531029',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93874,273,'Siragam','531149',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93875,273,'Sirijam','531028',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93876,273,'Sobhakota','531077',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93877,273,'Somalingapalem','531055',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93878,273,'Somavaram','531055',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93879,273,'Sovva','531151',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93880,273,'Srirampuram','531127',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93881,273,'Srungavaram','531115',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93882,273,'Subbavaram','531035',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93883,273,'Sujanakota','531040',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93884,273,'Sukuru','531077',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93885,273,'Sulabham','531029',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93886,273,'Sunkapur','531085',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93887,273,'Sunkarimetta','531149',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93888,273,'T R Project','531115',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93889,273,'T S Nagaram','531032',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93890,273,'Tadigiri','531077',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93891,273,'Tajangi','531118',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93892,273,'Tallapalem','531031',1,0,'2022-03-03 13:13:57','2022-03-03 13:13:57'),(93893,273,'Tamaracherla','531114',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93894,273,'Tanthadi','531011',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93895,273,'Taruva Agraharam','531075',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93896,273,'Tatiparthi','531027',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93897,273,'Tattabanda','531025',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93898,273,'Tekkalipalem','531035',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93899,273,'Tenugupudi','531030',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93900,273,'Thadi','531019',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93901,273,'Thammingula','531111',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93902,273,'Thanam','531021',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93903,273,'Theeda','531031',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93904,273,'Thimmarajupeta','531033',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93905,273,'Thotada','531002',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93906,273,'Thotakurapalem','531025',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93907,273,'Thotaluru','531084',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93908,273,'Thummapala','531032',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93909,273,'Timmapuram','531083',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93910,273,'Tsuchikonda','531055',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93911,273,'Turakalapudi','531026',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93912,273,'Turangalapalem','531055',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93913,273,'Turuvolu','531036',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93914,273,'Tutangi','531151',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93915,273,'Tutipala','531113',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93916,273,'Uddandapuram','531126',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93917,273,'Uderoo','531032',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93918,273,'Ugginapalem','531031',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93919,273,'Upamaka Agraharam','531081',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93920,273,'V Sarabhavaram','531114',1,0,'2022-03-03 13:13:58','2022-03-03 13:13:58'),(93921,273,'Vaddadi','531026',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93922,273,'Vaddipa','531118',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93923,273,'Vadrapalem','531075',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93924,273,'Vadrapalle','531033',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93925,273,'Vajragada','531113',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93926,273,'Vakapadu','531060',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93927,273,'Vakapalle','531075',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93928,273,'Valluru','531019',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93929,273,'Vanabhangi','531040',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93930,273,'Vanabhasingi','531040',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93931,273,'Vanchula','531111',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93932,273,'Vangasara','531111',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93933,273,'Vanthala','531029',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93934,273,'Vantlamamidi','531024',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93935,273,'Vanugupalli','531024',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93936,273,'Varada','531022',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93937,273,'Varahapuram','531036',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93938,273,'Vechalam','531075',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93939,273,'Vedullapalem','531081',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93940,273,'Vedurupalle','531115',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93941,273,'Veduruparthi','531031',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93942,273,'Veeranarayanam','531028',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93943,273,'Veeravalli Agraharam','531026',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93944,273,'Vemagiri','531055',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93945,273,'Vempadu','531081',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93946,273,'Vemulapudi','531117',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93947,273,'Venkatanagaram','531127',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93948,273,'Venkatapathipalem','531020',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93949,273,'Venkatapuram','531060',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93950,273,'Venkatapuram','531085',1,0,'2022-03-03 13:13:59','2022-03-03 13:13:59'),(93951,273,'Venkupalem','531032',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93952,273,'Vennalapalem','531021',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93953,273,'Vetazangalapalem','531031',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93954,273,'Vijayaramarajupeta','531026',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93955,273,'Vommali Jagannadhapuram','531027',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93956,273,'Vommavaram','531060',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93957,273,'Y B Agraharam','531115',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93958,273,'Y G Peta','531118',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93959,273,'Yangada','531151',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93960,273,'Yellamanchili','531055',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93961,273,'Yerakannapalem','531117',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93962,273,'Yerravaram','531033',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93963,273,'Zeenabadu','531030',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93964,273,'A U Engg College','530003',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93965,273,'Aganampudi','530053',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93966,273,'Akkayyapalem','530016',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93967,273,'Amanam','531162',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93968,273,'Anandapuram (Visakhapatnam)','530052',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93969,273,'Ananthavaram','531219',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93970,273,'Andhra University','530003',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93971,273,'Annavaram','531162',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93972,273,'Arilova','530040',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93973,273,'Autonagar','530012',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93974,273,'B H P V','530012',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93975,273,'Balacheruvu','530044',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93976,273,'Bheemunipatnam','531163',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93977,273,'Boddapalem','531163',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93978,273,'Boni','531162',1,0,'2022-03-03 13:14:00','2022-03-03 13:14:00'),(93979,273,'Boyapalem','531163',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(93980,273,'Chepaluppada','531163',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(93981,273,'Chinamushidiwada','531173',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(93982,273,'Chinawaltair','530003',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(93983,273,'Chinnapuram','531219',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(93984,273,'Chintalaagaraharam','530047',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(93985,273,'Chintalapalem','531173',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(93986,273,'Chippada','531162',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(93987,273,'Chittivalasa','531162',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(93988,273,'D.C. Buildings','530002',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(93989,273,'Dabagardens','530020',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(93990,273,'Dakamarri','531162',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(93991,273,'Dayalnagar','530043',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(93992,273,'Devada','530031',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(93993,273,'Dibbapalem','530044',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(93994,273,'Durganagar','530029',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(93995,273,'Duvvada','530046',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(93996,273,'Dwarakanagar','530016',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(93997,273,'Fortward','530001',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(93998,273,'Gajuwaka','530026',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(93999,273,'Gandhavaram','531219',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(94000,273,'Gandhigram (Visakhapatnam)','530005',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(94001,273,'Gandigundam','531173',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(94002,273,'Gangavaram','530044',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(94003,273,'Gayatri Engg College','530048',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(94004,273,'Ghandhi Place','530003',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(94005,273,'Gidijala','531173',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(94006,273,'Gitam Engg. College','530045',1,0,'2022-03-03 13:14:01','2022-03-03 13:14:01'),(94007,273,'Gnanapuram','530004',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94008,273,'Gopalapatnam','530027',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94009,273,'Gorapalle','531173',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94010,273,'Gottupalli','531219',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94011,273,'Govt Dairy Farm','530040',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94012,273,'Gudilova','531173',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94013,273,'Gudivada','531162',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94014,273,'Gurrampalem','531173',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94015,273,'H B Colony','530022',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94016,273,'Industrial Estate (Visakhapatnam)','530007',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94017,273,'INS Kalinga','531163',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94018,273,'IRSD Area','530008',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94019,273,'Isakathota','530022',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94020,273,'Islampeta','530031',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94021,273,'J.V.Agraharam','531163',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94022,273,'Jaggayyapalem','530012',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94023,273,'Kancharapalem','530008',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94024,273,'Kapuluppada','531163',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94025,273,'KGH','530002',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94026,273,'Kommadi','530048',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94027,273,'Korada','531162',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94028,273,'Kothaparadesipalem','531163',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94029,273,'Kovvada','531219',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94030,273,'Kurupam Market','530001',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94031,273,'Kusuluwada','531219',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94032,273,'L B Colony','530017',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94033,273,'LIC Building','530004',1,0,'2022-03-03 13:14:02','2022-03-03 13:14:02'),(94034,273,'M.V.P.Colony','530017',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94035,273,'Maddi','531219',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94036,273,'Madhurawada','530048',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94037,273,'Maharanipeta','530002',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94038,273,'Majjivalasa','531162',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94039,273,'Malkapuram','530011',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94040,273,'Marikavalasa','530048',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94041,273,'Marripalem','530018',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94042,273,'Marripalem Vuda Colony','530009',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94043,273,'Mindi','530012',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94044,273,'Modavalasa','531162',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94045,273,'Mopada','531162',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94046,273,'Muralinagar','530007',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94047,273,'N A D','530009',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94048,273,'Nadupuru','530044',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94049,273,'Nagamayyapalem','531162',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94050,273,'Nagarajupalem','531162',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94051,273,'Narava','530027',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94052,273,'Nausenabagh','530005',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94053,273,'Naval Base','530014',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94054,273,'Naval Dock Yard','530014',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94055,273,'Nerellavalasa','531163',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94056,273,'New Colony','530016',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94057,273,'NSTL','530027',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94058,273,'P & T Colony (VM)','530013',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94059,273,'Padmanabham','531219',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94060,273,'Pakeertekya','530046',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94061,273,'Pandranki','531162',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94062,273,'Pedagadi','531173',1,0,'2022-03-03 13:14:03','2022-03-03 13:14:03'),(94063,273,'Pedagadili','530040',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94064,273,'Pedagantyada','530044',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94065,273,'Pedamadaka','530053',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94066,273,'Peddipalem','531163',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94067,273,'Pendurthy','531173',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94068,273,'Penta','531219',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94069,273,'Pithapuram Colony','530003',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94070,273,'Porlupalem','530047',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94071,273,'Pothinamallayapalem','530041',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94072,273,'Potnuru','531219',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94073,273,'Prahladapuram','530027',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94074,273,'R P Agraharam','531219',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94075,273,'R R V Puram','530029',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94076,273,'Rampuram','531173',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94077,273,'Ravada','531162',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94078,273,'Rayapalem','531163',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94079,273,'Revidi','531162',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94080,273,'Sagar Nagar','530045',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94081,273,'Salagramapuram','530024',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94082,273,'Sangivalasa','531162',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94083,273,'Saripalli','531173',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94084,273,'Sez','530049',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94085,273,'Sheelanagar','530012',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94086,273,'Simhachalam Hills','530028',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94087,273,'Simhachalam','530028',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94088,273,'Singannabanda','531162',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94089,273,'Sirlapalem','531219',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94090,273,'Sontyam','531173',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94091,273,'Sri krishnapuram','530040',1,0,'2022-03-03 13:14:04','2022-03-03 13:14:04'),(94092,273,'Sujatha Nagar','530051',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94093,273,'T.V.Agraharam','531219',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94094,273,'Tallavalasa','531162',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94095,273,'Tarluvada','530052',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94096,273,'Tatituru','531162',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94097,273,'Tunglam','530012',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94098,273,'Turners Choultry','530002',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94099,273,'Ukkunagaram','530032',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94100,273,'V. Juttada','531173',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94101,273,'Vadlapudi','530046',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94102,273,'Vedullanarava','530046',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94103,273,'Vellanki','531163',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94104,273,'Vemulavalasa','531163',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94105,273,'Venkatapuram','530029',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94106,273,'Vepagunta (Visakhapatnam)','530047',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94107,273,'Vidya Bhavan','530003',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94108,273,'Visakhapatnam Airport','530009',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94109,273,'Visakhapatnam H.O','530001',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94110,273,'Visakhapatnam Port','530035',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94111,273,'Visakhapatnam Steel Project','530031',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94112,273,'Visalakshinagar','530043',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94113,273,'Visweswarayanagar','530012',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94114,273,'VM Bus Station','530020',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94115,273,'VM Steel Projrct Town Ship','530032',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94116,273,'Waltair R S H.O','530004',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94117,273,'Yarada','530005',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94118,273,'Yellapuvanipalem','530027',1,0,'2022-03-03 13:14:05','2022-03-03 13:14:05'),(94119,273,'Yendada','530045',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94120,273,'Zinc Smelter P','530015',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94121,273,'Ainada','535005',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94122,273,'Ananthagiri','535145',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94123,273,'B G Valasa','535145',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94124,273,'Bhandevpuram','535250',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94125,273,'Bheempolu','535145',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94126,273,'Garugubilli','535273',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94127,273,'Gumma','535145',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94128,273,'Kasipatnam','535145',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94129,273,'Konapuram','535145',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94130,273,'Kondiba','535145',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94131,273,'Kothuru','535145',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94132,273,'Muliaguda','535145',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94133,273,'Pedabidda','535145',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94134,273,'Pedaraba','535273',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94135,273,'Pindrangi','535183',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94136,273,'Tangudubilli','535183',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94137,273,'Tokuru','535145',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94138,273,'Tyda','535145',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94139,273,'Valasi','535145',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94140,273,'Y S R Puram','535145',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94141,274,'A.Venkampeta','535547',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94142,274,'Addapuseela','535502',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94143,274,'Ajjada','535546',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94144,274,'Akulakatta','535124',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94145,274,'Alajangi','535573',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94146,274,'Amiti','535126',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94147,274,'Amiti','535523',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94148,274,'Ampavalli','535557',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94149,274,'Ankavaram','535525',1,0,'2022-03-03 13:14:06','2022-03-03 13:14:06'),(94150,274,'Antivalasa','535593',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94151,274,'Antivalasa','535521',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94152,274,'Appayyapeta','535546',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94153,274,'Arasada','535557',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94154,274,'Arikathota','535579',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94155,274,'Arthamuru','535101',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94156,274,'Babbidi','535521',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94157,274,'Badangi','535578',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94158,274,'Balagudaba','535502',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94159,274,'Balijipeta','535557',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94160,274,'Bandaluppi','535527',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94161,274,'Bangarampeta','535591',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94162,274,'Bangaruvalasa','535547',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94163,274,'Barli','535559',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94164,274,'Basangi','535525',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94165,274,'Bhimavaram','535578',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94166,274,'Bhupalarajapuram','535102',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94167,274,'Bhyripuram','535102',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94168,274,'Billalavalasa','535128',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94169,274,'Bobbili Bazar','535573',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94170,274,'Bobbili Govt.Hospital Road','535559',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94171,274,'Bobbili H.O','535558',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94172,274,'Bobbili R.S','535559',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94173,274,'Bommika Jagannadhapuram','535594',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94174,274,'Bondapalli','535128',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94175,274,'Budarayavalasa','535102',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94176,274,'Buddemkharja','535524',1,0,'2022-03-03 13:14:07','2022-03-03 13:14:07'),(94177,274,'Buduruwada','535527',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94178,274,'Buradavenkatapuram','535463',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94179,274,'Burja','535546',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94180,274,'Burjavalasa','535579',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94181,274,'Busayavalasa','535579',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94182,274,'Chakarapalli','535546',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94183,274,'Chappabutchampeta','535547',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94184,274,'Charayabinnidi','535524',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94185,274,'Chemudu','535547',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94186,274,'Chilakalapalli','535557',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94187,274,'Chinabantupalli','535101',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94188,274,'Chinabhogili','535546',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94189,274,'Chinageesada','535521',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94190,274,'Chinagudaba','535463',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94191,274,'Chintada','535559',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94192,274,'Chintalabelagam','535526',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94193,274,'Chipurupalle','535128',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94194,274,'Chitrakota Boddavalasa','535573',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94195,274,'Chollapadam','535521',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94196,274,'Chowdantivalasa','535579',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94197,274,'Church Road Ndt','535573',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94198,274,'Dabbagedda','535527',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94199,274,'Dalaipeta','535524',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94200,274,'Dalaivalasa','535463',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94201,274,'Dandigam','535593',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94202,274,'Dangabhadra','535594',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94203,274,'Devada','535101',1,0,'2022-03-03 13:14:08','2022-03-03 13:14:08'),(94204,274,'Devarapodilam','535125',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94205,274,'Devunikanapaka','535101',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94206,274,'Dharmalakshmipuram','535534',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94207,274,'Dibbaguddivalasa','535573',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94208,274,'Dokiseela','535527',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94209,274,'Donkala Kothapatnam','535527',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94210,274,'Donkinavalasa','535578',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94211,274,'Duddukhallu','535524',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94212,274,'Duggeru','535547',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94213,274,'Duggi','535502',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94214,274,'Dummangi','535523',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94215,274,'Dummeda','535101',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94216,274,'Duppalapudi','535579',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94217,274,'Elwinpeta','535523',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94218,274,'Gadelamarrivalasa','535102',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94219,274,'Gadelavalasa','535559',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94220,274,'Gadivalasa','535592',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94221,274,'Gajarayanavalasa','535578',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94222,274,'Gangada','535557',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94223,274,'Gangannapadu','535124',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94224,274,'Gangarevuvalasa','535521',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94225,274,'Garbham','535102',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94226,274,'Garividi','535101',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94227,274,'Garugubilli','535128',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94228,274,'Garugubilli','535463',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94229,274,'Gavarampeta','535526',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94230,274,'Geddaluppi','535546',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94231,274,'Geddapuvalasa','535101',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94232,274,'Gijaba','535525',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94233,274,'Gochekka','535527',1,0,'2022-03-03 13:14:09','2022-03-03 13:14:09'),(94234,274,'Goipaka','535521',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94235,274,'Golladi Agraharam','535578',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94236,274,'Gollala Mulagam','535125',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94237,274,'Gollapalli','535573',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94238,274,'Goluguvalasa','535126',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94239,274,'Gorjipadu','535534',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94240,274,'Gorle Seetharampuram','535559',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94241,274,'Gotivada','535524',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94242,274,'Gotnandi','535128',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94243,274,'Gottipalli','535102',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94244,274,'Gottivalasa','535463',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94245,274,'Gudivada Agraharam','535557',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94246,274,'Gujjuvai','535534',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94247,274,'Gulivinda Agraharam','535128',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94248,274,'Gumada','535521',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94249,274,'Gumma','535523',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94250,274,'Gummalakshmipuram','535523',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94251,274,'Gunanupuram','535525',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94252,274,'Guruvunaidupeta','535591',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94253,274,'Gutchimi','535546',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94254,274,'Ippalavalasa','535101',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94255,274,'Iridi','535523',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94256,274,'Iruwada','535557',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94257,274,'Itlamamidipalli','535579',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94258,274,'Jagannadhapuram','535501',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94259,274,'Jamadala','535527',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94260,274,'Janjhavathi Colony','535521',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94261,274,'Jannivalasa','535579',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94262,274,'Janumallavalasa','535559',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94263,274,'Jarna','535521',1,0,'2022-03-03 13:14:10','2022-03-03 13:14:10'),(94264,274,'Jiyyammavalsa','535594',1,0,'2022-03-03 13:14:11','2022-03-03 13:14:11'),(94265,274,'Joguladumma','535594',1,0,'2022-03-03 13:14:11','2022-03-03 13:14:11'),(94266,274,'Jumbiri','535534',1,0,'2022-03-03 13:14:11','2022-03-03 13:14:11'),(94267,274,'Kalavarai Agraharam','535559',1,0,'2022-03-03 13:14:11','2022-03-03 13:14:11'),(94268,274,'Kallikota','535521',1,0,'2022-03-03 13:14:11','2022-03-03 13:14:11'),(94269,274,'Kandulapadam','535593',1,0,'2022-03-03 13:14:11','2022-03-03 13:14:11'),(94270,274,'Kannampeta','535573',1,0,'2022-03-03 13:14:11','2022-03-03 13:14:11'),(94271,274,'Kannapudoravalasa','535526',1,0,'2022-03-03 13:14:11','2022-03-03 13:14:11'),(94272,274,'Karada','535568',1,0,'2022-03-03 13:14:11','2022-03-03 13:14:11'),(94273,274,'Karivalasa','535592',1,0,'2022-03-03 13:14:11','2022-03-03 13:14:11'),(94274,274,'Karivalasa','535523',1,0,'2022-03-03 13:14:11','2022-03-03 13:14:11'),(94275,274,'Karlam','535125',1,0,'2022-03-03 13:14:11','2022-03-03 13:14:11'),(94276,274,'Kasipatnam','535547',1,0,'2022-03-03 13:14:11','2022-03-03 13:14:11'),(94277,274,'Kaviripalli','535547',1,0,'2022-03-03 13:14:11','2022-03-03 13:14:11'),(94278,274,'Kavitibhadra','535522',1,0,'2022-03-03 13:14:11','2022-03-03 13:14:11'),(94279,274,'Kedaripuram','535523',1,0,'2022-03-03 13:14:11','2022-03-03 13:14:11'),(94280,274,'Kemiseela','535521',1,0,'2022-03-03 13:14:11','2022-03-03 13:14:11'),(94281,274,'Kesali','535592',1,0,'2022-03-03 13:14:11','2022-03-03 13:14:11'),(94282,274,'Kharasavalasa','535591',1,0,'2022-03-03 13:14:11','2022-03-03 13:14:11'),(94283,274,'Khasapeta','535546',1,0,'2022-03-03 13:14:11','2022-03-03 13:14:11'),(94284,274,'Kinjangi','535557',1,0,'2022-03-03 13:14:11','2022-03-03 13:14:11'),(94285,274,'Kitchada','535524',1,0,'2022-03-03 13:14:11','2022-03-03 13:14:11'),(94286,274,'Koduru','535578',1,0,'2022-03-03 13:14:11','2022-03-03 13:14:11'),(94287,274,'Komarada','535521',1,0,'2022-03-03 13:14:11','2022-03-03 13:14:11'),(94288,274,'Komatipalli','535559',1,0,'2022-03-03 13:14:11','2022-03-03 13:14:11'),(94289,274,'Kondabaridi','535534',1,0,'2022-03-03 13:14:11','2022-03-03 13:14:11'),(94290,274,'Kondadevupalli','535568',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94291,274,'Kondakenguva','535579',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94292,274,'Kondavada','535523',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94293,274,'Konuru','535101',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94294,274,'Koppara','535557',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94295,274,'Korapukothavalasa','535579',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94296,274,'Koratam','535126',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94297,274,'Kota Sirlam','535579',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94298,274,'Kotaseetharampuram','535559',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94299,274,'Kothapalli','535463',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94300,274,'Kothavalasa','535591',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94301,274,'Kothavalasa','535502',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94302,274,'Kotipam','535521',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94303,274,'Kottakki','535579',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94304,274,'Kottu','535521',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94305,274,'Kottuparuva','535593',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94306,274,'Kotturu','535463',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94307,274,'Koyyannapeta','535546',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94308,274,'Krishnapalli','535502',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94309,274,'Krishnarayapuram','535546',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94310,274,'Kudama','535525',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94311,274,'Kukkidi','535523',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94312,274,'Kumaram','535128',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94313,274,'Kunayavalasa','535124',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94314,274,'Kuneru','535521',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94315,274,'Kurukutti','535593',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94316,274,'Kurupam','535524',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94317,274,'Kusumuru','535124',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94318,274,'Lakhanapuram','535525',1,0,'2022-03-03 13:14:12','2022-03-03 13:14:12'),(94319,274,'Lakkaguda','535523',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94320,274,'Lakshminaiduvalasa','535521',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94321,274,'Lakshminarayanapuram','535522',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94322,274,'Lakshmipuram Agraharam','535546',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94323,274,'Lakshmipuram','535547',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94324,274,'Latchayyapeta','535573',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94325,274,'Lavidam Agraharam','535101',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94326,274,'Locherla','535126',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94327,274,'Lumbesu','535523',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94328,274,'Madalangi','535521',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94329,274,'Makkuva','535547',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94330,274,'Mallampeta','535578',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94331,274,'Mamidipalle','535593',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94332,274,'Mamidivalasa','535579',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94333,274,'Manda','535523',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94334,274,'Maripalli','535593',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94335,274,'Maripalli','535534',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94336,274,'Maripivalasa','535546',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94337,274,'Markondaputti','535547',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94338,274,'Markondaputti','535525',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94339,274,'Marupenta','535463',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94340,274,'Maruwada','535557',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94341,274,'Matumuru','535591',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94342,274,'Mavudi','535593',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94343,274,'Merakamudidam','535102',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94344,274,'Merangi','535526',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94345,274,'Mettapalli','535125',1,0,'2022-03-03 13:14:13','2022-03-03 13:14:13'),(94346,274,'Mettavalasa','535559',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94347,274,'Mirthivalasa','535559',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94348,274,'Mokhasa Duggivalasa','535128',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94349,274,'Mokhasa Lingalavalasa','535102',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94350,274,'Mondemkhallu','535534',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94351,274,'Mosuru','535591',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94352,274,'Mrutyunjayarayanagaram','535522',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94353,274,'Mudidam Ravivalasa','535124',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94354,274,'Mugada','535578',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94355,274,'Mulaga','535522',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94356,274,'Naguru','535525',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94357,274,'Naidu Valasa','535578',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94358,274,'Nandabalaga','535568',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94359,274,'Nandigam','535124',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94360,274,'Nandrukona','535523',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94361,274,'Narayanapuram','535557',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94362,274,'Narlavalasa','535591',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94363,274,'Narsipuram','535522',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94364,274,'Neelakanthapuram','535534',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94365,274,'Nelliparthi','535591',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94366,274,'Nemalam','535126',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94367,274,'Nidagallu','535546',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94368,274,'Nimmalavalasa','535125',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94369,274,'Pachalavalasa','535579',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94370,274,'Pachipenta','535592',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94371,274,'Padmapuram','535592',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94372,274,'Pakki','535559',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94373,274,'Palagara','535557',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94374,274,'Palavalasa','535125',1,0,'2022-03-03 13:14:14','2022-03-03 13:14:14'),(94375,274,'Palem','535521',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94376,274,'Paltheru','535578',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94377,274,'Panasapeddikonavalasa','535592',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94378,274,'Panchali','535591',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94379,274,'Pandiri Mamidivalasa','535593',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94380,274,'Panukuvalasa','535591',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94381,274,'Pappala Lingalavalasa','535578',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94382,274,'Paradi','535579',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94383,274,'Parajapadu','535526',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94384,274,'Parannavalasa','535591',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94385,274,'Parvatipuram Bus Stand','535502',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94386,274,'Parvatipuram H.O','535501',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94387,274,'Parvatipuram Town','535501',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94388,274,'Patha Bobbili','535573',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94389,274,'Patharega','535579',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94390,274,'Pedabantupalli','535101',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94391,274,'Pedabondapalli','535527',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94392,274,'Pedaborabanda','535591',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94393,274,'Pedabuddidi','535525',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94394,274,'Pedagottili','535534',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94395,274,'Pedakharja','535523',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94396,274,'Pedamariki','535502',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94397,274,'Pedamerangi','535526',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94398,274,'Pedankalam','535546',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94399,274,'Pedapadam','535591',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94400,274,'Pedapenki','535557',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94401,274,'Pedasakha','535521',1,0,'2022-03-03 13:14:15','2022-03-03 13:14:15'),(94402,274,'Penta','535573',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94403,274,'Penubarthi','535101',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94404,274,'Perapi','535125',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94405,274,'Philipnagar','535502',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94406,274,'Pinapenki','535568',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94407,274,'Pippalabhadra','535526',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94408,274,'Piridi','535568',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94409,274,'Podi','535523',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94410,274,'Puligummi','535527',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94411,274,'Purohitunivalasa','535591',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94412,274,'Puttajammu','535523',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94413,274,'Putturu','535527',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94414,274,'Rajeru','535124',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94415,274,'Rajupeta','535573',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94416,274,'Rajyalakshmipuram','535521',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94417,274,'Ramabhadrapuram','535594',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94418,274,'Ramabhadrapuram','535579',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94419,274,'Ramalingapuram','535125',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94420,274,'Ramavaram','535546',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94421,274,'Ramuduvalasa','535559',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94422,274,'Rangarayapuram','535573',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94423,274,'Rastakuntubai','535523',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94424,274,'Ravipalli','535463',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94425,274,'Ravivalasa','535525',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94426,274,'Rayagadajammu','535524',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94427,274,'Regidi','535524',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94428,274,'Rella','535523',1,0,'2022-03-03 13:14:16','2022-03-03 13:14:16'),(94429,274,'Rompalli','535579',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94430,274,'Salur Fort','535591',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94431,274,'Salur','535591',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94432,274,'Sambara','535593',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94433,274,'Sangamvalasa','535522',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94434,274,'Santhoshapuram','535525',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94435,274,'Sanyasirajupeta','535463',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94436,274,'Saraivalasa','535547',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94437,274,'Sariki','535593',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94438,274,'Seethanagaram','535546',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94439,274,'Seetharampuram','535502',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94440,274,'Shikarganj','535578',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94441,274,'Shreeramnagar Ind.Colony','535101',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94442,274,'Shreeramnagar','535101',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94443,274,'Sikhabadi','535594',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94444,274,'Sirlam','535527',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94445,274,'Sivada','535534',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94446,274,'Sivadavalasa','535568',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94447,274,'Sivannapeta','535524',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94448,274,'Sivaram','535128',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94449,274,'Sivarampuram','535591',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94450,274,'Sivili Peddavalasa','535593',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94451,274,'Sivvam','535463',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94452,274,'Sompuram','535579',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94453,274,'Subhadra Agraharam','535559',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94454,274,'Sudigam','535527',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94455,274,'Sunki Agraharam','535525',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94456,274,'Surampeta','535527',1,0,'2022-03-03 13:14:17','2022-03-03 13:14:17'),(94457,274,'Tadikonda','535523',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94458,274,'Taduru','535591',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94459,274,'Tallaburidi','535527',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94460,274,'Tamarakhandi','535546',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94461,274,'Tamarakhandi Jammu','535594',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94462,274,'Tarapuram','535579',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94463,274,'Therlam','535126',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94464,274,'Thodumu','535521',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94465,274,'Thonam','535593',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94466,274,'Thondrangi','535101',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94467,274,'Thotapalli','535525',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94468,274,'Thunda','535547',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94469,274,'Thurumamidi','535547',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94470,274,'Timiteru Burjavalasa','535102',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94471,274,'Tittiri','535534',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94472,274,'Tulasivalasa','535521',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94473,274,'Tumarada','535557',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94474,274,'Tumbali','535526',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94475,274,'Turakanaiduvalasa','535525',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94476,274,'Udayapuram','535534',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94477,274,'Uddavolu','535463',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94478,274,'Uttaravalli','535124',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94479,274,'Vadada','535124',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94480,274,'Valasaballeru','535534',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94481,274,'Vallarigudaba','535463',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94482,274,'Vangara','535523',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94483,274,'Vantharam','535557',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94484,274,'Vedullavalasa','535128',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94485,274,'Velagavalasa','535126',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94486,274,'Vengapuram Agraharam','535557',1,0,'2022-03-03 13:14:18','2022-03-03 13:14:18'),(94487,274,'Venkampeta','535522',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94488,274,'Venkatabhyripuram','535546',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94489,274,'Vikrampuram','535502',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94490,274,'Viswanadhapuram','535591',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94491,274,'Vobbangi','535534',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94492,274,'Voosakonda','535534',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94493,274,'Vootapalli','535102',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94494,274,'Voppangi','535523',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94495,274,'Vullibhadra','535463',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94496,274,'Yadika','535128',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94497,274,'Yegulavada','535523',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94498,274,'Zarada','535534',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94499,274,'Gollalapalem','532407',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94500,274,'Kagam','532127',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94501,274,'Marrivalasa','532127',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94502,274,'Perumali','532127',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94503,274,'Rachagumadam','532127',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94504,274,'Sathamvalasa','532127',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94505,274,'Sundarada','532122',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94506,274,'Polipalli','531162',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94507,274,'A S Peta','535281',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94508,274,'A T Agraharam','535218',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94509,274,'Akkivaram','535216',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94510,274,'Alamanda R S','535240',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94511,274,'Alamanda Sandy','535240',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94512,274,'Alladapalem','535204',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94513,274,'Alugolu','535218',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94514,274,'Alugubilli','535250',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94515,274,'Amatamravivalasa','535216',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94516,274,'Ambativalasa','535003',1,0,'2022-03-03 13:14:19','2022-03-03 13:14:19'),(94517,274,'Anandapuram','535280',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94518,274,'Andra','535273',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94519,274,'Annamurajupeta','535250',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94520,274,'Apsp Quarters','535005',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94521,274,'Athava','535161',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94522,274,'Ayyannapeta','535003',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94523,274,'B S Factory','535214',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94524,274,'B.Rajeru','535260',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94525,274,'B.Tallavalasa','535005',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94526,274,'Banadi','535281',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94527,274,'Bantupalli','535216',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94528,274,'Bhaligattam','535183',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94529,274,'Bheemali','535240',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94530,274,'Bheemasinghi','535250',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94531,274,'Bhogapuram','535216',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94532,274,'Bhudevipeta','535270',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94533,274,'Boddam','535145',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94534,274,'Bonangi','535160',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94535,274,'Bondapalli','535260',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94536,274,'Boppadam','535218',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94537,274,'Budathanapalli','535215',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94538,274,'Buradapeta','535280',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94539,274,'Chakivalasa','535216',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94540,274,'Challapeta','535581',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94541,274,'Cheepuruvalasa','535183',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94542,274,'Cheluvuru','535005',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94543,274,'Chinakada','535580',1,0,'2022-03-03 13:14:20','2022-03-03 13:14:20'),(94544,274,'Chinatada','535250',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94545,274,'Chintalapeta','535280',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94546,274,'Chintalavalasa','535005',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94547,274,'Chintapalli','535204',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94548,274,'Chodamma Agraharam','535204',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94549,274,'Chodavaram','535217',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94550,274,'Chollangipeta','535204',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94551,274,'Dabbirajupeta','535281',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94552,274,'Damarasingi','535217',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94553,274,'Dasannapeta','535002',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94554,274,'Dasulapalem','535161',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94555,274,'Datti','535580',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94556,274,'Datti Rajeru','535580',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94557,274,'Denderu','535183',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94558,274,'Denkada','535006',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94559,274,'Devada','535183',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94560,274,'Devupalli','535260',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94561,274,'Dharmapuri','535004',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94562,274,'Dharmavaram','535148',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94563,274,'Duppada','535003',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94564,274,'Dwarapudi','535003',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94565,274,'G Ch Penta','535270',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94566,274,'G T Peta','535273',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94567,274,'Gadasam','535580',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94568,274,'Gajapathinagaram','535270',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94569,274,'Gajularega','535003',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94570,274,'Gangubudi','535183',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94571,274,'Ganivada','535240',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94572,274,'Gantlam','535216',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94573,274,'Gantyada','535215',1,0,'2022-03-03 13:14:21','2022-03-03 13:14:21'),(94574,274,'Garida','535217',1,0,'2022-03-03 13:14:22','2022-03-03 13:14:22'),(94575,274,'Garikavalasa','535220',1,0,'2022-03-03 13:14:22','2022-03-03 13:14:22'),(94576,274,'Garudabilli','535260',1,0,'2022-03-03 13:14:22','2022-03-03 13:14:22'),(94577,274,'Gedalavani Palem','535240',1,0,'2022-03-03 13:14:22','2022-03-03 13:14:22'),(94578,274,'Ginjeru','535221',1,0,'2022-03-03 13:14:22','2022-03-03 13:14:22'),(94579,274,'Gobhyam','535580',1,0,'2022-03-03 13:14:22','2022-03-03 13:14:22'),(94580,274,'Godiyada','535221',1,0,'2022-03-03 13:14:22','2022-03-03 13:14:22'),(94581,274,'Gokapeta','535003',1,0,'2022-03-03 13:14:22','2022-03-03 13:14:22'),(94582,274,'Gollupalem','535270',1,0,'2022-03-03 13:14:22','2022-03-03 13:14:22'),(94583,274,'Golzam','535161',1,0,'2022-03-03 13:14:22','2022-03-03 13:14:22'),(94584,274,'Gopalapalli','535148',1,0,'2022-03-03 13:14:22','2022-03-03 13:14:22'),(94585,274,'Gotlam','535003',1,0,'2022-03-03 13:14:22','2022-03-03 13:14:22'),(94586,274,'Govindapuram','535204',1,0,'2022-03-03 13:14:22','2022-03-03 13:14:22'),(94587,274,'Gudem','535220',1,0,'2022-03-03 13:14:22','2022-03-03 13:14:22'),(94588,274,'Gudepuvalasa','535216',1,0,'2022-03-03 13:14:22','2022-03-03 13:14:22'),(94589,274,'Gudivada','535281',1,0,'2022-03-03 13:14:22','2022-03-03 13:14:22'),(94590,274,'Gujjangivalasa','535217',1,0,'2022-03-03 13:14:22','2022-03-03 13:14:22'),(94591,274,'Gummakota','535273',1,0,'2022-03-03 13:14:22','2022-03-03 13:14:22'),(94592,274,'Gumpam Agraharam','535204',1,0,'2022-03-03 13:14:22','2022-03-03 13:14:22'),(94593,274,'Gunkalam','535003',1,0,'2022-03-03 13:14:22','2022-03-03 13:14:22'),(94594,274,'Gunupur','535006',1,0,'2022-03-03 13:14:22','2022-03-03 13:14:22'),(94595,274,'Gurla','535217',1,0,'2022-03-03 13:14:22','2022-03-03 13:14:22'),(94596,274,'Gushini','535218',1,0,'2022-03-03 13:14:22','2022-03-03 13:14:22'),(94597,274,'Gutchimi','535580',1,0,'2022-03-03 13:14:22','2022-03-03 13:14:22'),(94598,274,'Industrial Estate (Vizianagaram)','535004',1,0,'2022-03-03 13:14:22','2022-03-03 13:14:22'),(94599,274,'Ingilapalli Agraharam','535580',1,0,'2022-03-03 13:14:22','2022-03-03 13:14:22'),(94600,274,'Ippalavalasa','535581',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94601,274,'J Gumadam','535221',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94602,274,'Jaddetivalasa','535250',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94603,274,'Jagaram','535250',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94604,274,'Jakkuva','535581',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94605,274,'Jami','535250',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94606,274,'Jammu','535006',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94607,274,'Jammu','535217',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94608,274,'Jarajapupeta','535217',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94609,274,'Jayathi','535581',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94610,274,'Jinnam Agrharam','535270',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94611,274,'Jonnada','535005',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94612,274,'Jonnavalasa','535004',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94613,274,'K G Budi','535145',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94614,274,'K R Peta','535183',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94615,274,'Kalagada','535240',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94616,274,'Kallempudi','535161',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94617,274,'Kallepalli','535183',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94618,274,'Kanapaka','535003',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94619,274,'Kancheru','535216',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94620,274,'Kandivalasa','535204',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94621,274,'Kanimella','535204',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94622,274,'Kanimeraka','535260',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94623,274,'Kantakapalli','535240',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94624,274,'Karatam','535003',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94625,274,'Katakapalli','535240',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94626,274,'Kella','535217',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94627,274,'Kenguva','535270',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94628,274,'Kg Pathasala','535204',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94629,274,'Khadarnagar','535002',1,0,'2022-03-03 13:14:23','2022-03-03 13:14:23'),(94630,274,'Khasapeta','535161',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94631,274,'Kirthubarthi','535221',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94632,274,'Komatipalli Agraharam','535580',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94633,274,'Kompangi','535580',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94634,274,'Konada','535213',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94635,274,'Konda.Lingalavalasa','535581',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94636,274,'Kondagandredu','535220',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94637,274,'Kondagumpam','535280',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94638,274,'Kondakarakam','535003',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94639,274,'Kondatamarapalli','535221',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94640,274,'Kondavelagada','535217',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94641,274,'Konisa','535270',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94642,274,'Kopperla','535213',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94643,274,'Korlam','535215',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94644,274,'Korukonda','535214',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94645,274,'Kotagandredu','535220',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94646,274,'Kotarupalli','535215',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94647,274,'Kothapalem','535221',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94648,274,'Kothapeta','535218',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94649,274,'Kothapeta (Vizianagaram)','535002',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94650,274,'Kothavalasa','535221',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94651,274,'Kothavalasa','535183',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94652,274,'Kottam','535148',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94653,274,'Kotyada','535240',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94654,274,'Kovvada Agraharam','535204',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94655,274,'Krishnapuram','535148',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94656,274,'Krishnapuram','535204',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94657,274,'Kumili','535204',1,0,'2022-03-03 13:14:24','2022-03-03 13:14:24'),(94658,274,'Kummapalli','535183',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94659,274,'Kuneru','535581',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94660,274,'Kuntinivalasa','535580',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94661,274,'L Kota','535161',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94662,274,'Lakkidam','535215',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94663,274,'Lankapillipalem','535204',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94664,274,'Lingalavalasa','535270',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94665,274,'Logisa','535270',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94666,274,'Longuparthi','535145',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94667,274,'M Gumudam','535270',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94668,274,'M J R Peta','535218',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94669,274,'M Kothasvalasa','535214',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94670,274,'M Kothavalasa','535270',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94671,274,'Madanapuram','535160',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94672,274,'Madhupada','535148',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94673,274,'Madhupada','535270',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94674,274,'Malayada','535218',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94675,274,'Malicherala','535005',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94676,274,'Mallipudi','535145',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94677,274,'Malliveedu','535161',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94678,274,'Mangalapalem','535183',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94679,274,'Manyapuripeta','535217',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94680,274,'Maradam','535580',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94681,274,'Marupalli','535270',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94682,274,'Melia Kancheru','535273',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94683,274,'Mentada','535273',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94684,274,'Moida','535280',1,0,'2022-03-03 13:14:25','2022-03-03 13:14:25'),(94685,274,'Mudduru','535280',1,0,'2022-03-03 13:14:26','2022-03-03 13:14:26'),(94686,274,'Mukkam','535216',1,0,'2022-03-03 13:14:26','2022-03-03 13:14:26'),(94687,274,'Munginapalli','535006',1,0,'2022-03-03 13:14:26','2022-03-03 13:14:26'),(94688,274,'Munjeru','535216',1,0,'2022-03-03 13:14:26','2022-03-03 13:14:26'),(94689,274,'Mutcherla','535270',1,0,'2022-03-03 13:14:26','2022-03-03 13:14:26'),(94690,274,'N K R Puram','535281',1,0,'2022-03-03 13:14:26','2022-03-03 13:14:26'),(94691,274,'Nadupuru','535280',1,0,'2022-03-03 13:14:26','2022-03-03 13:14:26'),(94692,274,'Nagallavalasa','535217',1,0,'2022-03-03 13:14:26','2022-03-03 13:14:26'),(94693,274,'Nallaballi','535281',1,0,'2022-03-03 13:14:26','2022-03-03 13:14:26'),(94694,274,'Nandigam','535216',1,0,'2022-03-03 13:14:26','2022-03-03 13:14:26'),(94695,274,'Narava','535215',1,0,'2022-03-03 13:14:26','2022-03-03 13:14:26'),(94696,274,'Neelavathi','535215',1,0,'2022-03-03 13:14:26','2022-03-03 13:14:26'),(94697,274,'Nelivada','535003',1,0,'2022-03-03 13:14:26','2022-03-03 13:14:26'),(94698,274,'Nellimarla','535217',1,0,'2022-03-03 13:14:26','2022-03-03 13:14:26'),(94699,274,'Nidigattu','535240',1,0,'2022-03-03 13:14:26','2022-03-03 13:14:26'),(94700,274,'Ompalli','535215',1,0,'2022-03-03 13:14:26','2022-03-03 13:14:26'),(94701,274,'P P Agraharam','535270',1,0,'2022-03-03 13:14:26','2022-03-03 13:14:26'),(94702,274,'P.S.R Puram','535215',1,0,'2022-03-03 13:14:26','2022-03-03 13:14:26'),(94703,274,'Pakirkitthali','535220',1,0,'2022-03-03 13:14:26','2022-03-03 13:14:26'),(94704,274,'Palavalasa','535220',1,0,'2022-03-03 13:14:26','2022-03-03 13:14:26'),(94705,274,'Palli Gandredu','535220',1,0,'2022-03-03 13:14:26','2022-03-03 13:14:26'),(94706,274,'Parasam','535280',1,0,'2022-03-03 13:14:26','2022-03-03 13:14:26'),(94707,274,'Pasupam','535213',1,0,'2022-03-03 13:14:26','2022-03-03 13:14:26'),(94708,274,'Pathabaggam','535270',1,0,'2022-03-03 13:14:26','2022-03-03 13:14:26'),(94709,274,'Pathavalasa','535183',1,0,'2022-03-03 13:14:26','2022-03-03 13:14:26'),(94710,274,'Pathivada','535213',1,0,'2022-03-03 13:14:26','2022-03-03 13:14:26'),(94711,274,'Pavada','535250',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94712,274,'Pedachamalapalli','535580',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94713,274,'Pedakada','535270',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94714,274,'Pedakandepalli','535145',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94715,274,'Pedamajjipalem','535221',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94716,274,'Pedamanapuram','535580',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94717,274,'Pedamedapalli','535580',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94718,274,'Pedathadivada','535006',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94719,274,'Pedavemali','535215',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94720,274,'Penasam','535215',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94721,274,'Perapuram','535204',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94722,274,'Pinathadivada','535006',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94723,274,'Pinavemali','535004',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94724,274,'Pittada','535273',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94725,274,'Poram','535580',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94726,274,'Pusapatirega','535204',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94727,274,'R B Puram','535250',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94728,274,'R G Peta','535161',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94729,274,'Rachakindam','535260',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94730,274,'Raghumanda','535005',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94731,274,'Ragolu','535218',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94732,274,'Raindram','535260',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94733,274,'Rakodu','535004',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94734,274,'Ramabhadrapuram','535160',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94735,274,'Ramathirtam','535218',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94736,274,'Ramavaram','535215',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94737,274,'Rangarayapuram','535161',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94738,274,'Regubilli','535160',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94739,274,'Relli','535183',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94740,274,'Rellivalasa','535204',1,0,'2022-03-03 13:14:27','2022-03-03 13:14:27'),(94741,274,'Revallapalem','535160',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94742,274,'Rompalli','535273',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94743,274,'S Chintalavalasa','535580',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94744,274,'S G Peta','535145',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94745,274,'S Kota','535145',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94746,274,'S R R Puram','535270',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94747,274,'S S R Peta','535217',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94748,274,'Salipeta','535273',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94749,274,'Sarika','535004',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94750,274,'Saripalli','535218',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94751,274,'Sasanapalli','535250',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94752,274,'Sativada','535218',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94753,274,'Savaravilli','535216',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94754,274,'Seethampeta','535145',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94755,274,'Seetharamapuram','535160',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94756,274,'Seetharampuram','535161',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94757,274,'Singarai','535161',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94758,274,'Singavaram','535213',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94759,274,'Siripuram','535215',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94760,274,'Sompuram Agraharam','535161',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94761,274,'Ss Korukonda','535214',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94762,274,'T B Vara','535145',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94763,274,'T Sanduluru','535161',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94764,274,'Talari','535148',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94765,274,'Tamatada','535260',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94766,274,'Tanavaram','535250',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94767,274,'Tangudubilli','535218',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94768,274,'Tatavari Kittali','535220',1,0,'2022-03-03 13:14:28','2022-03-03 13:14:28'),(94769,274,'Tatipudi','535160',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94770,274,'Tatipudi','535218',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94771,274,'Tekkali','535003',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94772,274,'Tettangi','535220',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94773,274,'Thotapalem','535003',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94774,274,'Timidi','535145',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94775,274,'Tummalapeta','535217',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94776,274,'Tummikapalli','535270',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94777,274,'Tummukapalli','535183',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94778,274,'Uddangi','535581',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94779,274,'Uttarapalli','535183',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94780,274,'V B Peta','535250',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94781,274,'V B Puram','535183',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94782,274,'V R Palem','535250',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94783,274,'Vallapuram','535217',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94784,274,'Valluru','535218',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94785,274,'Vangara','535580',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94786,274,'Vasadi','535160',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94787,274,'Vasantha','535215',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94788,274,'Vavilapadu','535281',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94789,274,'Vedullavalasa','535005',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94790,274,'Veduruvada','535221',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94791,274,'Veeluparthi','535281',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94792,274,'Veeranaraynam','535145',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94793,274,'Velduru','535213',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94794,274,'Vempadam','535204',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94795,274,'Vemulapalli','535148',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94796,274,'Vepada','535281',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94797,274,'Vijayaramapuram','535580',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94798,274,'Vindhyavasi','535580',1,0,'2022-03-03 13:14:29','2022-03-03 13:14:29'),(94799,274,'Viyyammapeta','535183',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94800,274,'Vizianagaram City','535001',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94801,274,'Vizianagaram Collectorate','535003',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94802,274,'Vizianagaram Contonment','535003',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94803,274,'Vizianagaram Court Complex','535004',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94804,274,'Vizianagaram H.O','535002',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94805,274,'Vizianagaram Market','535001',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94806,274,'Vizinigiri','535250',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94807,274,'Vzm R.S','535003',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94808,275,'A.Vemavaram','534267',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94809,275,'Abbiraju Palem','534266',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94810,275,'Adavipalem','534260',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94811,275,'Agarru','534260',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94812,275,'Agarthipalem','534260',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94813,275,'Aibhimavaram','534235',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94814,275,'Ainaparru','534320',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94815,275,'Akanivarithota','534280',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94816,275,'Akividu','534235',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94817,275,'Alamuru (West Godavari)','534126',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94818,275,'Andaluru','534240',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94819,275,'Ankoderu','534208',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94820,275,'Annavaram','534202',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94821,275,'Annavarappadu','534330',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94822,275,'Apparaopeta','534235',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94823,275,'Aratlakatta','534250',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94824,275,'Aravalli','534230',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94825,275,'Arjunudupalem','534217',1,0,'2022-03-03 13:14:30','2022-03-03 13:14:30'),(94826,275,'Arthamuru','534199',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94827,275,'Atchanta','534123',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94828,275,'Attili','534134',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94829,275,'Ayodhya Lanka','534266',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94830,275,'Ballipadu','534134',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94831,275,'Bantummili','534243',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94832,275,'Bethapudi','534207',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94833,275,'Bhaggeswaram','534267',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94834,275,'Bhatlamaguturu','534126',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94835,275,'Bhimala Puram','534266',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94836,275,'Bhimavaram Bazar','534202',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94837,275,'Bhimavaram H.O','534201',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94838,275,'Bhimavaram Railway Colony','534201',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94839,275,'Bondada','534206',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94840,275,'Brahmanacheruvu','534124',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94841,275,'Burugupalli','534266',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94842,275,'Cherukumilli','534235',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94843,275,'Cheurkuwada','534199',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94844,275,'Chilakapadu','534216',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94845,275,'Chilukuru','534199',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94846,275,'China-amiram','534204',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94847,275,'Chinagolla Palem','534281',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94848,275,'Chinakapavaram','534235',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94849,275,'Chinamallam','534269',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94850,275,'Chinamallipadu','534235',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94851,275,'Chinchinada','534268',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94852,275,'Chintaparru','534250',1,0,'2022-03-03 13:14:31','2022-03-03 13:14:31'),(94853,275,'Chittavaram','534275',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94854,275,'Chivatam','534216',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94855,275,'D.N.R.College','534202',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94856,275,'Dagguluru','534250',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94857,275,'Dammmennu','534227',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94858,275,'Darabharevu','534275',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94859,275,'Deva','534123',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94860,275,'Deyyalatippa','534239',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94861,275,'Digamarru','534260',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94862,275,'Dirusumarru','534239',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94863,275,'Doddanapudi','534237',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94864,275,'Doddipatla','534266',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94865,275,'Dongaravipalem','534330',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94866,275,'Dumpagadapa','534235',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94867,275,'Dusanapudi','534243',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94868,275,'East Vipparru','534328',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94869,275,'Eduru','534134',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94870,275,'Eletipadu','534320',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94871,275,'Ellamanchili Lanka','534268',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94872,275,'Ellamanchili','534268',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94873,275,'Enamadurru','534239',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94874,275,'Gavarlapalem','534225',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94875,275,'Gollalakoderu','534202',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94876,275,'Gollavanitippa','534239',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94877,275,'Goraganamudi','534244',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94878,275,'Goteru','534217',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94879,275,'Gummaluru','534267',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94880,275,'Gummampadu','534225',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94881,275,'Gummuluru','534235',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94882,275,'Gumparru','534266',1,0,'2022-03-03 13:14:32','2022-03-03 13:14:32'),(94883,275,'Hanumantharaopeta','534211',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94884,275,'Ilapakurru','534266',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94885,275,'Ilaparru','534326',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94886,275,'Iragavaram','534217',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94887,275,'Jagannadhapurami','534122',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94888,275,'Jakkaram','534206',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94889,275,'Jinnuru','534265',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94890,275,'Jonnalapalem','534247',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94891,275,'Juttiga','534124',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94892,275,'Juvvalapalem','534236',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94893,275,'K.Illindalaparru','534217',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94894,275,'K.Samudrapugattu','534134',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94895,275,'Kakileru','534320',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94896,275,'Kalagam Pudi','534268',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94897,275,'Kalavapudi','534236',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94898,275,'Kalipatnam','534281',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94899,275,'Kalisipudi','534199',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94900,275,'Kalla','534237',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94901,275,'Kallakuru','534237',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94902,275,'Kanchumarru','534230',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94903,275,'Kannai Kumudavalli','534328',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94904,275,'Kanteru','534126',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94905,275,'Kapavaram','534328',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94906,275,'Kapavaram','534250',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94907,275,'Karugorumilli','534269',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94908,275,'Kathavapadu','534126',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94909,275,'Kavalipuram','534222',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94910,275,'Kavitam','534338',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94911,275,'Kaza','534260',1,0,'2022-03-03 13:14:33','2022-03-03 13:14:33'),(94912,275,'Khandavalli','534330',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94913,275,'Kodamanchili','534269',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94914,275,'Koderu','534269',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94915,275,'Kolamuru','534199',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94916,275,'Kolanapalli','534237',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94917,275,'Kollaparru','534235',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94918,275,'Komarada','534208',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94919,275,'Komaravaram','534222',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94920,275,'Komarru','534134',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94921,275,'Kommara','534134',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94922,275,'Kommuchikkala','534250',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94923,275,'Kondepudi','534210',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94924,275,'Konithiwada','534240',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94925,275,'Konteru','534260',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94926,275,'Kopalle','534206',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94927,275,'Kopparru','534275',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94928,275,'Korukollu','534209',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94929,275,'Kothalaparru','534320',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94930,275,'Kothapadu','534217',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94931,275,'Kothapalli Agraharam','534328',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94932,275,'Koyyetipadu','534320',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94933,275,'Kummarapurugupalem','534280',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94934,275,'Kumudavalli','534210',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94935,275,'Kuppanapudi','534235',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94936,275,'Lajapathiroya Peta','534260',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94937,275,'Lakshmaneswaram','534275',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94938,275,'Lakshminarasimhapuram','534206',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94939,275,'Lakshminarayanapuram','534209',1,0,'2022-03-03 13:14:34','2022-03-03 13:14:34'),(94940,275,'Lankalakoderu','534250',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94941,275,'Lingaboyinacherla','534275',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94942,275,'Losari-gutlapadu','534239',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94943,275,'Madapadu','534268',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94944,275,'Madugupolavaram','534247',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94945,275,'Mahadevapatnam','534199',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94946,275,'Mallavarm','534275',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94947,275,'Malleswaram','534330',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94948,275,'Mallipudi','534124',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94949,275,'Mamuduru','534238',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94950,275,'Manchili','534134',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94951,275,'Mandapaka','534218',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94952,275,'Maruteru','534122',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94953,275,'Matla Palem','534266',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94954,275,'Matsyapuri','534207',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94955,275,'Mattaparru','534265',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94956,275,'Military Colony','534236',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94957,275,'Minavilluru','534134',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94958,275,'Miniminchilipadu','534327',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94959,275,'Mogallu','534209',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94960,275,'Mogalturu','534281',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94961,275,'Mortha','534227',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94962,275,'Moyyeru','534134',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94963,275,'Mukkamala','534330',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94964,275,'Mulaparru','534123',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94965,275,'Munamarru','534324',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94966,275,'Mupparthipadu','534134',1,0,'2022-03-03 13:14:35','2022-03-03 13:14:35'),(94967,275,'Mutyalapalli','534281',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94968,275,'Mutyalavaripalem','534330',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94969,275,'Mylavanilanka','534280',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94970,275,'N.R.P. Agraharam','534199',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94971,275,'Nadipudi','534326',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94972,275,'Narinameraka','534266',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94973,275,'Narsapur Bazar','534275',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94974,275,'Narsapur (West Godavari)','534275',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94975,275,'Nattarameswaram','534124',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94976,275,'Navuduru','534240',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94977,275,'Neggipudi','534122',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94978,275,'Nelamuru','534126',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94979,275,'Nelapogula','534240',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94980,275,'Neredumilli','534268',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94981,275,'Palakoderu','534210',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94982,275,'Palakol Bazar','534260',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94983,275,'Palakol H.O','534260',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94984,275,'Palangi','534216',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94985,275,'Pali Gds','534225',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94986,275,'Paluru','534134',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94987,275,'Pamulaparru','534199',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94988,275,'Pandithavilluru','534122',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94989,275,'Panjavemavaram','534247',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94990,275,'Pasaladeevi','534280',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94991,275,'Peda-amiram','534204',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94992,275,'Pedagaruvu','534207',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94993,275,'Pedakapavaram','534235',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94994,275,'Pedamallam','534269',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94995,275,'Pedapulleru','534199',1,0,'2022-03-03 13:14:36','2022-03-03 13:14:36'),(94996,275,'Pekeru','534320',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(94997,275,'Pemmaraju Polavaram','534338',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(94998,275,'Pennada','534243',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(94999,275,'Penugonda Bazar','534320',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(95000,275,'Penugonda','534320',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(95001,275,'Penumadam','534267',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(95002,275,'Penumanchili','534123',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(95003,275,'Penumantra','534124',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(95004,275,'Penumarru','534268',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(95005,275,'Peravali','534328',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(95006,275,'Perkipalem','534243',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(95007,275,'Perupalem','534281',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(95008,275,'Pidiparru','534218',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(95009,275,'Pittalavemavarm','534324',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(95010,275,'Podalada','534126',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(95011,275,'Poduru','534327',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(95012,275,'Polamuru','534238',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(95013,275,'Prakrutiashramam','534244',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(95014,275,'Prathalameraka','534236',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(95015,275,'Pulapalli','534260',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(95016,275,'Ramannapalem','534280',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(95017,275,'Ramannapalem','534324',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(95018,275,'Rapaka','534320',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(95019,275,'Ravipadu','534267',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(95020,275,'Rayakuduru','534247',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(95021,275,'Rayalam','534208',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(95022,275,'Relangi','534225',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(95023,275,'Roypeta','534275',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(95024,275,'Rustumbada','534275',1,0,'2022-03-03 13:14:37','2022-03-03 13:14:37'),(95025,275,'S.Illindalaparru','534225',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95026,275,'S.R.K.R .Engg.college','534204',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95027,275,'Sajjapuram','534211',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95028,275,'Saripalli','534275',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95029,275,'Satyavaram','534122',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95030,275,'Satyawada','534218',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95031,275,'Seethalm Kondepadu','534134',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95032,275,'Serepalem','534281',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95033,275,'Sidhantam','534326',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95034,275,'Sidhapuram','534235',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95035,275,'Siragala Palli','534268',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95036,275,'Sisali','534237',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95037,275,'Sitaramapuram','534280',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95038,275,'Sivadevunichikkala','534245',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95039,275,'Sivaraopeta','534202',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95040,275,'Skinnerapuram','534230',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95041,275,'Someswaralayam','534201',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95042,275,'Sreeramapuram','534202',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95043,275,'Srungavruksham','534243',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95044,275,'Surampudi','534328',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95045,275,'Taderu','534202',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95046,275,'Tadiparru','534227',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95047,275,'Tamarada','534324',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95048,275,'Tanuku Bazar','534211',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95049,275,'Tanuku H.O','534211',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95050,275,'Tanuku Old Town','534211',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95051,275,'Tetali','534218',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95052,275,'Tillapudi','534245',1,0,'2022-03-03 13:14:38','2022-03-03 13:14:38'),(95053,275,'Tirupathipuram','534134',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95054,275,'Tokalapudi','534247',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95055,275,'Tokatippa','534239',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95056,275,'Toleru','534247',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95057,275,'Tundurru','534207',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95058,275,'Turputallu','534280',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95059,275,'Ulliamparru','534265',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95060,275,'Undi','534199',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95061,275,'Unikili','534230',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95062,275,'Uppuluru','534199',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95063,275,'Vadali (West Godavari)','534324',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95064,275,'Vadangi Palem','534265',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95065,275,'Vaddiparru','534267',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95066,275,'Vadlavani Palem','534265',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95067,275,'Vadluru','534218',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95068,275,'Valluru','534269',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95069,275,'Vandram','534199',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95070,275,'Vankayalapalem','534244',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95071,275,'Varidhanam','534260',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95072,275,'Varighedu','534225',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95073,275,'Vedangi','534265',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95074,275,'Veerabhadrapuram','534222',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95075,275,'Velagaduuru','534227',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95076,275,'Velagalavariplalem','534124',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95077,275,'Velivela','534250',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95078,275,'Velpur','534222',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95079,275,'Vempa','534207',1,0,'2022-03-03 13:14:39','2022-03-03 13:14:39'),(95080,275,'Vempadu','534206',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95081,275,'Vemuladeevi','534275',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95082,275,'Vendra','534210',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95083,275,'Venkata Puram','534250',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95084,275,'Venkatramapuram','534324',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95085,275,'Venkatrayapuram','534215',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95086,275,'Viravasaram','534245',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95087,275,'Vissakoderu','534244',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95088,275,'Voduru','534126',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95089,275,'Vundrajavaram','534216',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95090,275,'Yelurupadu','534236',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95091,275,'Yenuguvanilanka','534275',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95092,275,'Yeraih Cheruvu','534217',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95093,275,'A.Gokavaram','534416',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95094,275,'A.Polavaram','534456',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95095,275,'Adamilli','534449',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95096,275,'Agadalalanka','534427',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95097,275,'Akkampeta','534455',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95098,275,'Alivery','534448',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95099,275,'Amberpeta','534401',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95100,275,'Ankalampadu','534449',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95101,275,'Ankannagudem','534003',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95102,275,'Ankannagudem','534456',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95103,275,'Antervedigudem','534448',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95104,275,'APMC','534426',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95105,275,'Appalarajugudem','534456',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95106,275,'Ashok Nagar (West Godavari)','534002',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95107,275,'Atchuthapuram','534312',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95108,275,'Balavarigudem','534460',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95109,275,'Bandivarigudem','534456',1,0,'2022-03-03 13:14:40','2022-03-03 13:14:40'),(95110,275,'Bapirajugudem','534475',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95111,275,'Bayyanagudem','534312',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95112,275,'Benerjipeta','534001',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95113,275,'Bhimadole','534425',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95114,275,'Bhogapuram','534427',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95115,275,'Bhogapuram','534007',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95116,275,'Bhogole','534462',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95117,275,'Bodigudem','534312',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95118,275,'Borrampalem','534451',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95119,275,'Buttayagudem','534448',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95120,275,'Ch.Pothepalli','534451',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95121,275,'Challachintalapudi','534425',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95122,275,'Challavarigudem','534455',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95123,275,'Chataparru','534004',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95124,275,'Chebrole (West Godavari)','534406',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95125,275,'Chettunnapadu','534427',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95126,275,'Chinanindrakolanu','534406',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95127,275,'Chinnavarigudem','534455',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95128,275,'Chintalapudi Cutchery','534460',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95129,275,'Chintalapudi','534460',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95130,275,'Chodimella','534002',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95131,275,'Darbhagudem','534456',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95132,275,'Denduluru','534432',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95133,275,'Devulapalli','534451',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95134,275,'Dharmajigudem','534462',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95135,275,'Dippakayalapadu','534312',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95136,275,'Doramamidi','534448',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95137,275,'Dorasanipadu','534426',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95138,275,'Dosapadu','534442',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95139,275,'Dwaraka Tirumala','534426',1,0,'2022-03-03 13:14:41','2022-03-03 13:14:41'),(95140,275,'East Yedavally','534426',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95141,275,'Edavally','534461',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95142,275,'Eluru Bazar','534001',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95143,275,'Eluru Bus Station','534006',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95144,275,'Eluru Collectorate','534006',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95145,275,'Eluru H.O','534001',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95146,275,'Eluru R.S','534005',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95147,275,'Epigunta','534467',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95148,275,'G.Kothapalli','534451',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95149,275,'G.Pangidigudem','534455',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95150,275,'Galayagudem','534450',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95151,275,'Ganapavaram','534455',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95152,275,'Gandhinagaram (West Godavari)','534007',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95153,275,'Gangannagudem','534450',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95154,275,'Gavaravaram','534312',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95155,275,'Gogunta','534437',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95156,275,'Gollagudem','534406',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95157,275,'Gopalapuram','534425',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95158,275,'Gopannapalem','534450',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95159,275,'Gowrisankara Puram','534455',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95160,275,'Gudipadu','534437',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95161,275,'Gudivakalanka','534004',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95162,275,'Gundugolanu So.','534427',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95163,275,'Gunnampally','534425',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95164,275,'Gurvaigudem','534455',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95165,275,'I.S.Jagannadhapuram','534451',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95166,275,'I.S.Raghavapuram','534451',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95167,275,'Industrial Estate (West Godavari)','534007',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95168,275,'Jagannadhapuram','534312',1,0,'2022-03-03 13:14:42','2022-03-03 13:14:42'),(95169,275,'Jaggavaram','534467',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95170,275,'Jalipudi','534004',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95171,275,'Janampeta','534475',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95172,275,'Jangareddigudem Bazar','534447',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95173,275,'Jangareddygudem H.O','534447',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95174,275,'Jeelakarragudem','534449',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95175,275,'Jeelugumilli','534456',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95176,275,'Jogannapalem','534452',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95177,275,'Jonnavarigudem','534455',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95178,275,'K.Gokavaram','534462',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95179,275,'Kaikaram','534416',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95180,275,'Kalaparru','534007',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95181,275,'Kalarayanagudem','534462',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95182,275,'Kallacheruvu','534452',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95183,275,'Kamaiahkunta','534311',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95184,275,'Kamaiahpalem','534456',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95185,275,'Kamavarapukota','534449',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95186,275,'Kandrikagudem','534311',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95187,275,'Kannapuram','534311',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95188,275,'Kanthampalem','534460',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95189,275,'Karicherlagudem','534312',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95190,275,'Kavvagunta','534475',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95191,275,'Kethavaram','534312',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95192,275,'Kokkiripadu','534007',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95193,275,'Komadavole','534004',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95194,275,'Kommugudem','534448',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95195,275,'Koniki','534437',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95196,275,'Kopalli','534311',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95197,275,'Koppaka','534003',1,0,'2022-03-03 13:14:43','2022-03-03 13:14:43'),(95198,275,'Koppulavarigudem','534452',1,0,'2022-03-03 13:14:44','2022-03-03 13:14:44'),(95199,275,'Korasavarigudem','534448',1,0,'2022-03-03 13:14:44','2022-03-03 13:14:44'),(95200,275,'Kotaramachandrapuram','534311',1,0,'2022-03-03 13:14:44','2022-03-03 13:14:44'),(95201,275,'Kothapally','534462',1,0,'2022-03-03 13:14:44','2022-03-03 13:14:44'),(95202,275,'Kothuru','534002',1,0,'2022-03-03 13:14:44','2022-03-03 13:14:44'),(95203,275,'Kovvali','534442',1,0,'2022-03-03 13:14:44','2022-03-03 13:14:44'),(95204,275,'Koyarajahmundry','534311',1,0,'2022-03-03 13:14:44','2022-03-03 13:14:44'),(95205,275,'Koyyalagudem','534312',1,0,'2022-03-03 13:14:44','2022-03-03 13:14:44'),(95206,275,'Krothagudem','534427',1,0,'2022-03-03 13:14:44','2022-03-03 13:14:44'),(95207,275,'Kuchimpudi','534450',1,0,'2022-03-03 13:14:44','2022-03-03 13:14:44'),(95208,275,'Kurellagudem','534401',1,0,'2022-03-03 13:14:44','2022-03-03 13:14:44'),(95209,275,'Lakkavaram (West Godavari)','534451',1,0,'2022-03-03 13:14:44','2022-03-03 13:14:44'),(95210,275,'Lingagudem','534460',1,0,'2022-03-03 13:14:44','2022-03-03 13:14:44'),(95211,275,'Lingapalem','534462',1,0,'2022-03-03 13:14:44','2022-03-03 13:14:44'),(95212,275,'M.M.Puram','534401',1,0,'2022-03-03 13:14:44','2022-03-03 13:14:44'),(95213,275,'M.Nagulapally','534425',1,0,'2022-03-03 13:14:44','2022-03-03 13:14:44'),(95214,275,'Maisammagudem','534455',1,0,'2022-03-03 13:14:44','2022-03-03 13:14:44'),(95215,275,'Makkinavarigudem','534456',1,0,'2022-03-03 13:14:44','2022-03-03 13:14:44'),(95216,275,'Malkapuram','534002',1,0,'2022-03-03 13:14:44','2022-03-03 13:14:44'),(95217,275,'Mallayagudem','534460',1,0,'2022-03-03 13:14:44','2022-03-03 13:14:44'),(95218,275,'Mangaiahpalem','534448',1,0,'2022-03-03 13:14:44','2022-03-03 13:14:44'),(95219,275,'Marlagudem','534455',1,0,'2022-03-03 13:14:44','2022-03-03 13:14:44'),(95220,275,'Mattamagudem','534462',1,0,'2022-03-03 13:14:44','2022-03-03 13:14:44'),(95221,275,'Medinaraopalem','534432',1,0,'2022-03-03 13:14:44','2022-03-03 13:14:44'),(95222,275,'Merakagudem','534311',1,0,'2022-03-03 13:14:44','2022-03-03 13:14:44'),(95223,275,'Mettagudem','534448',1,0,'2022-03-03 13:14:44','2022-03-03 13:14:44'),(95224,275,'Mulagampally','534455',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95225,275,'Munduru','534452',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95226,275,'Mupparu','534002',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95227,275,'Muppinavarigudem','534448',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95228,275,'Nadipally','534475',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95229,275,'Nagireddigudem','534461',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95230,275,'Naidugudem','534437',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95231,275,'Narasimharao Peta','534006',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95232,275,'Narayanapuram','534406',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95233,275,'Nimmalagudem','534448',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95234,275,'Old Bus Stand','534005',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95235,275,'P&t Colony (West Godavari)','534007',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95236,275,'P.Ankampalem','534456',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95237,275,'P.Kannapuram','534401',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95238,275,'P.Rajavaram','534456',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95239,275,'Pathebada','534002',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95240,275,'Pattenapalem','534455',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95241,275,'Pedakadimi','534003',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95242,275,'Pedapadu','534437',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95243,275,'Pedavegi','534450',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95244,275,'Perampeta','534455',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95245,275,'Pinakadimi','534003',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95246,275,'Polasanipally','534425',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95247,275,'Ponangi','534002',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95248,275,'Ponguturu','534312',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95249,275,'Pothunuru','534442',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95250,275,'Pothunuru','534460',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95251,275,'Power Peta','534002',1,0,'2022-03-03 13:14:45','2022-03-03 13:14:45'),(95252,275,'Pragadavaram','534461',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95253,275,'Prathikollanka','534004',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95254,275,'Puchikapadu','534456',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95255,275,'Puliramannagudem','534311',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95256,275,'Pulla','534401',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95257,275,'Punikollu','534437',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95258,275,'R.Pangidigudem','534425',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95259,275,'Racherla','534460',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95260,275,'Rachuru','534448',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95261,275,'Rachuru','534406',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95262,275,'Ragavapuram','534460',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95263,275,'Rajanagaram','534311',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95264,275,'Rajavaram','534312',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95265,275,'Raju Peta','534437',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95266,275,'Rallakunta','534426',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95267,275,'Ramachandra Rao Peta','534006',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95268,275,'Ramannagudem','534426',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95269,275,'Ramannagudem','534448',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95270,275,'Ramannapalem','534311',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95271,275,'Ramanujapuram','534312',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95272,275,'Ramasingavaram','534450',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95273,275,'Rangapuram','534462',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95274,275,'Ratsannagudem','534456',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95275,275,'Ravikampadu','534451',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95276,275,'Ravulaparru','534406',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95277,275,'Rayannapalem','534475',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95278,275,'Regulakunta','534448',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95279,275,'Sagipadu','534452',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95280,275,'Sanivarapu Peta','534003',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95281,275,'Sankuchakrapuram','534461',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95282,275,'Saripalli','534312',1,0,'2022-03-03 13:14:46','2022-03-03 13:14:46'),(95283,275,'Satyavole','534437',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95284,275,'Satynarayanapuram','534432',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95285,275,'Sb Colony','534007',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95286,275,'Seethampeta','534312',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95287,275,'Seethanagaram','534460',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95288,275,'Somavarapupadu','534450',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95289,275,'Srinivaspuram','534455',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95290,275,'Sriparru','534004',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95291,275,'Sriramvaram','534432',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95292,275,'Surappagudem','534425',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95293,275,'Swarnavarigudem','534455',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95294,275,'T.Gokavaram','534452',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95295,275,'T.Narasapuram','534467',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95296,275,'Tadicherla','534426',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95297,275,'Tadikalapudi','534452',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95298,275,'Taduvai','534455',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95299,275,'Tangellamudi','534005',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95300,275,'Tatiyakulagudem','534456',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95301,275,'Tch Rayudupalem','534462',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95302,275,'Tedlam','534461',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95303,275,'Thokalapally','534406',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95304,275,'Timmapuram','534426',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95305,275,'Tirumaladevipeta','534467',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95306,275,'Tirumalampalem','534426',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95307,275,'Tirumalapuram','534312',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95308,275,'Uppalapadu','534449',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95309,275,'Utasamudram','534460',1,0,'2022-03-03 13:14:47','2022-03-03 13:14:47'),(95310,275,'Vadddigudem','534437',1,0,'2022-03-03 13:14:48','2022-03-03 13:14:48'),(95311,275,'Vangayagudem','534002',1,0,'2022-03-03 13:14:48','2022-03-03 13:14:48'),(95312,275,'Vanguru','534002',1,0,'2022-03-03 13:14:48','2022-03-03 13:14:48'),(95313,275,'Vankavarigudem','534456',1,0,'2022-03-03 13:14:48','2022-03-03 13:14:48'),(95314,275,'Vasanthavada','534437',1,0,'2022-03-03 13:14:48','2022-03-03 13:14:48'),(95315,275,'Vedanthapuram','534312',1,0,'2022-03-03 13:14:48','2022-03-03 13:14:48'),(95316,275,'Veerammakunta','534437',1,0,'2022-03-03 13:14:48','2022-03-03 13:14:48'),(95317,275,'Veerannapalem','534455',1,0,'2022-03-03 13:14:48','2022-03-03 13:14:48'),(95318,275,'Vegavaram','534455',1,0,'2022-03-03 13:14:48','2022-03-03 13:14:48'),(95319,275,'Vegivada','534452',1,0,'2022-03-03 13:14:48','2022-03-03 13:14:48'),(95320,275,'Velagapally','534461',1,0,'2022-03-03 13:14:48','2022-03-03 13:14:48'),(95321,275,'Vempally','534452',1,0,'2022-03-03 13:14:48','2022-03-03 13:14:48'),(95322,275,'Venkata Rao Peta','534002',1,0,'2022-03-03 13:14:48','2022-03-03 13:14:48'),(95323,275,'Venkatakrishnapuram','534426',1,0,'2022-03-03 13:14:48','2022-03-03 13:14:48'),(95324,275,'Venkatapuram','534460',1,0,'2022-03-03 13:14:48','2022-03-03 13:14:48'),(95325,275,'Vidyanagar','534452',1,0,'2022-03-03 13:14:48','2022-03-03 13:14:48'),(95326,275,'Vijayarai','534475',1,0,'2022-03-03 13:14:48','2022-03-03 13:14:48'),(95327,275,'Vippalapadu','534448',1,0,'2022-03-03 13:14:48','2022-03-03 13:14:48'),(95328,275,'Westren Street','534003',1,0,'2022-03-03 13:14:48','2022-03-03 13:14:48'),(95329,275,'Yendapalli','534460',1,0,'2022-03-03 13:14:48','2022-03-03 13:14:48'),(95330,275,'Yerraguntapally','534460',1,0,'2022-03-03 13:14:48','2022-03-03 13:14:48'),(95331,275,'Yerrampally','534461',1,0,'2022-03-03 13:14:48','2022-03-03 13:14:48'),(95332,275,'Yerrampeta','534312',1,0,'2022-03-03 13:14:48','2022-03-03 13:14:48'),(95333,275,'A.Gopavaram','534197',1,0,'2022-03-03 13:14:48','2022-03-03 13:14:48'),(95334,275,'Adavikolanu','534198',1,0,'2022-03-03 13:14:48','2022-03-03 13:14:48'),(95335,275,'Ajjaram','534331',1,0,'2022-03-03 13:14:48','2022-03-03 13:14:48'),(95336,275,'Akuteegapadu','534196',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95337,275,'Allampuram','534146',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95338,275,'Ananthapallli','534111',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95339,275,'Annadevarapeta','534341',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95340,275,'Aphb Colony','534101',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95341,275,'Appannapeta','534186',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95342,275,'Apparaopeta','534145',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95343,275,'Ardhavaram','534197',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95344,275,'Aredu','534198',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95345,275,'Arikirevula','534340',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95346,275,'Arugolanu','534146',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95347,275,'Atchannapalem','534111',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95348,275,'Atlapadu','534302',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95349,275,'Avapadu','534112',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95350,275,'B.Kondepadu','534156',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95351,275,'Badampudi','534411',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95352,275,'Ballipadu','534340',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95353,275,'Bandapuram','534313',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95354,275,'Bangarampeta','534315',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95355,275,'Basivireddipeta','534301',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95356,275,'Bhimole','534341',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95357,275,'Bhuvanapalli','534198',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95358,275,'Bodapadu','534196',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95359,275,'Bodigudem','534315',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95360,275,'Bommidi','534411',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95361,275,'Brahmanagudem','534301',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95362,275,'Ch.Agraharam','534196',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95363,275,'Chagallu','534342',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95364,275,'Chanamilli','534198',1,0,'2022-03-03 13:14:49','2022-03-03 13:14:49'),(95365,275,'Chandravaram','534342',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95366,275,'Cheepurugudem','534176',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95367,275,'Chegondapalli','534315',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95368,275,'Cherukumilli','534316',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95369,275,'Chidipi','534340',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95370,275,'Chikkala','534305',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95371,275,'Chinnayagudem','534316',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95372,275,'Chintapalli Agraharam','534196',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95373,275,'Chityala','534316',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95374,275,'D.Gopavaram','534195',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95375,275,'D.Muppavaram','534302',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95376,275,'Dandagarra','534145',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95377,275,'Daravaram','534301',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95378,275,'Darisaparru','534166',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95379,275,'Devarapalli (West Godavari)','534313',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95380,275,'Dharmavaram','534340',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95381,275,'Dommeru','534342',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95382,275,'Dondapudi','534318',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95383,275,'Dubacharla','534112',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95384,275,'Duddukuru','534313',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95385,275,'Duvva','534156',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95386,275,'Gajjaram','534341',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95387,275,'Ganapavaram (West Godavari)','534198',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95388,275,'Gantavarigudem','534112',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95389,275,'Garagaparru','534186',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95390,275,'Gopalapuram (West Godavari)','534316',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95391,275,'Gopavaram','534302',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95392,275,'Gopavaram','534318',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95393,275,'Gowripatnam','534313',1,0,'2022-03-03 13:14:50','2022-03-03 13:14:50'),(95394,275,'Gowtaminagar','534350',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95395,275,'Guddigudem','534316',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95396,275,'Gundepalli','534111',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95397,275,'Gunjavaram','534318',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95398,275,'Gutala','534341',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95399,275,'Hukumpeta','534318',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95400,275,'I.Pangidi','534342',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95401,275,'Itikalakota','534315',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95402,275,'Jagannadhapuram','534145',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95403,275,'Jaggannapeta','534102',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95404,275,'Jallikakinada','534186',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95405,275,'Jeedigunta','534302',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95406,275,'Jetlapalem','534166',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95407,275,'Juvvalapalem','534102',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95408,275,'K.Agraharam','534329',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95409,275,'K.Pentapadu','534166',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95410,275,'Kadakatla','534102',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95411,275,'Kadiyedda','534102',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95412,275,'Kagupadu','534411',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95413,275,'Kakaraparru','534331',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95414,275,'Kakarlamudi','534165',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95415,275,'Kalavalapalli','534301',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95416,275,'Kaldhari','534329',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95417,275,'Kaligotla','534198',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95418,275,'Kamsalipalem','534301',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95419,275,'Kanuru','534329',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95420,275,'Kapavaram','534342',1,0,'2022-03-03 13:14:51','2022-03-03 13:14:51'),(95421,275,'Karagapadu','534318',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95422,275,'Kasipadu','534196',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95423,275,'Katakoteswaram','534305',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95424,275,'Kesavaram','534186',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95425,275,'Kommara','534196',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95426,275,'Kommugudem','534102',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95427,275,'Konala','534146',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95428,275,'Kondrukota','534315',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95429,275,'Kondruprolu','534102',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95430,275,'Korumamidi','534305',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95431,275,'Korumilli','534156',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95432,275,'Koruturu','534315',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95433,275,'Kothapalli','534198',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95434,275,'Kovvur H.O','534350',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95435,275,'Kovvur Old  Town','534350',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95436,275,'Kovvurupadu','534318',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95437,275,'Krishnampalem','534313',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95438,275,'Krishnayampalemi','534146',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95439,275,'Krovvidi','534198',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95440,275,'Kumaradevam','534340',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95441,275,'Kunchinapalli','534102',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95442,275,'Kunkala','534318',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95443,275,'Kurukuru','534305',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95444,275,'Lakshmipuram','534313',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95445,275,'Lnd Peta','534318',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95446,275,'Madduru','534302',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95447,275,'Madhavaram (West Godavari)','534145',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95448,275,'Malakapalli','534340',1,0,'2022-03-03 13:14:52','2022-03-03 13:14:52'),(95449,275,'Mallavaram','534342',1,0,'2022-03-03 13:14:53','2022-03-03 13:14:53'),(95450,275,'Mamidigondi','534315',1,0,'2022-03-03 13:14:53','2022-03-03 13:14:53'),(95451,275,'Mandalaparru','534195',1,0,'2022-03-03 13:14:53','2022-03-03 13:14:53'),(95452,275,'Marampalli','534146',1,0,'2022-03-03 13:14:53','2022-03-03 13:14:53'),(95453,275,'Marellamudi','534112',1,0,'2022-03-03 13:14:53','2022-03-03 13:14:53'),(95454,275,'Markondapadu','534301',1,0,'2022-03-03 13:14:53','2022-03-03 13:14:53'),(95455,275,'Moduggunta','534145',1,0,'2022-03-03 13:14:53','2022-03-03 13:14:53'),(95456,275,'Mounjipadu','534165',1,0,'2022-03-03 13:14:53','2022-03-03 13:14:53'),(95457,275,'Muddapuram','534146',1,0,'2022-03-03 13:14:53','2022-03-03 13:14:53'),(95458,275,'Mudunuru','534196',1,0,'2022-03-03 13:14:53','2022-03-03 13:14:53'),(95459,275,'Muggalla','534197',1,0,'2022-03-03 13:14:53','2022-03-03 13:14:53'),(95460,275,'Munipalli','534329',1,0,'2022-03-03 13:14:53','2022-03-03 13:14:53'),(95461,275,'Mypa','534186',1,0,'2022-03-03 13:14:53','2022-03-03 13:14:53'),(95462,275,'Nabipeta','534176',1,0,'2022-03-03 13:14:53','2022-03-03 13:14:53'),(95463,275,'Nachugunta','534411',1,0,'2022-03-03 13:14:53','2022-03-03 13:14:53'),(95464,275,'Nallajerla','534112',1,0,'2022-03-03 13:14:53','2022-03-03 13:14:53'),(95465,275,'Nandamuru','534146',1,0,'2022-03-03 13:14:53','2022-03-03 13:14:53'),(95466,275,'Nandigudem','534316',1,0,'2022-03-03 13:14:53','2022-03-03 13:14:53'),(95467,275,'Navabpalem','534146',1,0,'2022-03-03 13:14:53','2022-03-03 13:14:53'),(95468,275,'Nidadavole O.T.','534301',1,0,'2022-03-03 13:14:53','2022-03-03 13:14:53'),(95469,275,'Nidadavole','534301',1,0,'2022-03-03 13:14:53','2022-03-03 13:14:53'),(95470,275,'Nidamarru','534195',1,0,'2022-03-03 13:14:53','2022-03-03 13:14:53'),(95471,275,'P.N.Kolanu','534195',1,0,'2022-03-03 13:14:53','2022-03-03 13:14:53'),(95472,275,'Padala','534102',1,0,'2022-03-03 13:14:53','2022-03-03 13:14:53'),(95473,275,'Paidipaka','534315',1,0,'2022-03-03 13:14:53','2022-03-03 13:14:53'),(95474,275,'Pallantla','534313',1,0,'2022-03-03 13:14:53','2022-03-03 13:14:53'),(95475,275,'Pandalaparru','534302',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95476,275,'Panduvva','534198',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95477,275,'Parimalla','534166',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95478,275,'Pasalapudi','534156',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95479,275,'Pasivedala','534342',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95480,275,'Pattiseema','534315',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95481,275,'Peddavam','534340',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95482,275,'Pendyala','534329',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95483,275,'Penkanametta','534340',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95484,275,'Pentapadu','534166',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95485,275,'Pippara','534197',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95486,275,'Pmmarket','534101',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95487,275,'Pochavaram','534341',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95488,275,'Polavaram','534315',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95489,275,'Pothavaram','534176',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95490,275,'Pothineedipalem','534176',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95491,275,'Pragadapalli','534318',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95492,275,'Prakasaraopalem','534112',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95493,275,'Prakkilanka','534341',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95494,275,'Prattipadu','534146',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95495,275,'Pullalapadu','534112',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95496,275,'Purushottapalli','534302',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95497,275,'Racharla','534166',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95498,275,'Ramannagudem','534102',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95499,275,'Ramannapalem','534313',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95500,275,'Ramayyapeta','534315',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95501,275,'Ramnagar (West Godavari)','534301',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95502,275,'Rampalem','534318',1,0,'2022-03-03 13:14:54','2022-03-03 13:14:54'),(95503,275,'Ravimetla','534301',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95504,275,'Ravipadu','534156',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95505,275,'Rc Rao Peta','534101',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95506,275,'Reddinagampalem','534318',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95507,275,'RTC Bustand(kovvur','534350',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95508,275,'Samisragudem','534302',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95509,275,'Sangayagudem','534313',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95510,275,'Saripalli','534198',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95511,275,'Settipeta','534301',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95512,275,'Singanapalli','534315',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95513,275,'Singarajupalem','534112',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95514,275,'Singavaram','534301',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95515,275,'Sivagiri','534315',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95516,275,'Subbaraopeta','534101',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95517,275,'Surya Rao Palem','534156',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95518,275,'Sv Peta','534101',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95519,275,'Tadepalli','534102',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95520,275,'Tadepalligudem Bazar','534102',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95521,275,'Tadepalligudem H.O','534101',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95522,275,'Tadepalligudem Town','534101',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95523,275,'Tadimalla','534305',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95524,275,'Tadipudi','534341',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95525,275,'Tallapalem','534301',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95526,275,'Tallapudi','534341',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95527,275,'Tallavaram','534315',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95528,275,'Talluru','534315',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95529,275,'Teeparru','534331',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95530,275,'Tekuru','534315',1,0,'2022-03-03 13:14:55','2022-03-03 13:14:55'),(95531,275,'Telikecharla','534111',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95532,275,'Thogummi','534302',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95533,275,'Timmarajupalem','534301',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95534,275,'Tirugudumetta','534340',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95535,275,'Tutigunta','534315',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95536,275,'Tyajampudi','534305',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95537,275,'Unagatla','534342',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95538,275,'Uppakapadu','534411',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95539,275,'Usulumarru','534329',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95540,275,'V.Ch.Gudem','534316',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95541,275,'Vadalagunta','534316',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95542,275,'Vadapalli','534302',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95543,275,'Vakapalli','534196',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95544,275,'Valluru','534197',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95545,275,'Veerampalem','534102',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95546,275,'Vegeswarapuram','534340',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95547,275,'Velagapalli','534198',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95548,275,'Velivennu','534329',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95549,275,'Vellamilli','534411',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95550,275,'Vemuluru','534302',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95551,275,'Venkatramannagudem','534102',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95552,275,'Vijjeswaram','534302',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95553,275,'Vk.Reddigudem','534315',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95554,275,'Vundurru','534186',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95555,275,'Vunguturu (West Godavari)','534411',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95556,275,'West Vipparru','534165',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95557,275,'Yadavole','534316',1,0,'2022-03-03 13:14:56','2022-03-03 13:14:56'),(95558,275,'Yanalapalli','534166',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95559,275,'Yandagandi','534186',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95560,275,'Yarnagudem','534313',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95561,275,'Yenikepalli','534198',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95562,275,'Yerramalla','534411',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95563,276,'Akkaraivattam','609604',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95564,276,'Ambagarathur','609601',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95565,276,'Dharmapuram','609602',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95566,276,'Karaikal Bazaar','609602',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95567,276,'Karaikal','609602',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95568,276,'Karaikal South','609602',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95569,276,'Karaikalmedu','609605',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95570,276,'Karaikoilpathu','609605',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95571,276,'Karukkangudi','609607',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95572,276,'Kottuchery','609609',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95573,276,'Kurumbagaram','609603',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95574,276,'Madagadi','609602',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95575,276,'Melakasakudi','609603',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95576,276,'Nallambal','609601',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95577,276,'Nallathur','609603',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95578,276,'Nedungadu','609603',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95579,276,'Neravy','609604',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95580,276,'Seithur','609601',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95581,276,'Sellur','609607',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95582,276,'Surakudi','609607',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95583,276,'T.R.Pattinam South','609606',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95584,276,'Thalatheru','609605',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95585,276,'Tirumalairayanpattinam','609606',1,0,'2022-03-03 13:14:57','2022-03-03 13:14:57'),(95586,276,'Tirunallar','609607',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95587,276,'Tiruvettakudi','609609',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95588,276,'Varichikudi','609609',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95589,276,'Vizhithiyur','609607',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95590,277,'Naluthara','673310',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95591,277,'Pallur','673310',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95592,278,'Yanam','533464',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95593,278,'Pandakkal','673310',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95594,278,'Abishegapakkam','605007',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95595,278,'Ariyankuppam','605007',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95596,278,'Ariyur','605102',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95597,278,'Arumbarthapuram','605110',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95598,278,'Bahoor','607402',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95599,278,'Bommayarpalayam','605104',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95600,278,'Calapet','605014',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95601,278,'Coudapakkam','605502',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95602,278,'Courivinatham','607402',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95603,278,'Dhanvantry Nagar','605006',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95604,278,'Embalam','605106',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95605,278,'Karayamputhur','605106',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95606,278,'Karikalambakkam','605007',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95607,278,'Kariyamanikam','605106',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95608,278,'Katterikuppam','605502',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95609,278,'Kijour','605106',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95610,278,'Korkadu','605110',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95611,278,'Kottakuppam','605104',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95612,278,'Kuilapalayam','605101',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95613,278,'Lawspet','605008',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95614,278,'Maducore','605105',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95615,278,'Madugadipet','605107',1,0,'2022-03-03 13:14:58','2022-03-03 13:14:58'),(95616,278,'Manamedu','607402',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95617,278,'Manapeth','607402',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95618,278,'Mangalam','605110',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95619,278,'Mannadipattu','605501',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95620,278,'Mottoupalayam','605009',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95621,278,'Mouroungapakkam','605004',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95622,278,'Moutrepaleam','605009',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95623,278,'Mudaliarpet','605004',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95624,278,'Muthialpet','605003',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95625,278,'Nallavadu','605007',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95626,278,'Nellithoppe','605005',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95627,278,'Nettapakkam','605106',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95628,278,'Odiampet','605110',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95629,278,'Ozhugarai','605010',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95630,278,'Pillayarkuppam','607403',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95631,278,'Pondicherry H.O','605001',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95632,278,'Pondicherry University','605014',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95633,278,'Pooranankuppam','605007',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95634,278,'Puranasingupalayam','605107',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95635,278,'Reddiyarpalayam','605010',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95636,278,'Saram(Py)','605013',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95637,278,'Sedarapet','605111',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95638,278,'Seliamedu','607402',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95639,278,'Sellipet','605501',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95640,278,'Sorapattu','605501',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95641,278,'Sri Aurobindo Ashram','605002',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95642,278,'Sulthanpet','605110',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95643,278,'Suthukeni','605502',1,0,'2022-03-03 13:14:59','2022-03-03 13:14:59'),(95644,278,'Thattanchavady','605009',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95645,278,'Thengaithittu','605004',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95646,278,'Thimmanaickenpalayam','605007',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95647,278,'Thirubuvanai','605107',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95648,278,'Thiruvandarkoil','605102',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95649,278,'Thondamanatham','605502',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95650,278,'Tirukkanur','605501',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95651,278,'Vadhanur','605501',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95652,278,'Veerampattinam','605007',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95653,278,'Venkata Nagar','605011',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95654,278,'Villiyanur','605110',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95655,278,'Vimacoundinpaleam','605009',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95656,279,'Akaya','781329',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95657,279,'Ambari','781316',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95658,279,'Amdah','781325',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95659,279,'Amguri','781317',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95660,279,'Amrikhowa','781307',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95661,279,'Anandabazar','781318',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95662,279,'Anchali','781327',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95663,279,'B D Pathar','781318',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95664,279,'B Noontola','781317',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95665,279,'Baghbar','781308',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95666,279,'Baghmarabazar','781328',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95667,279,'Baghogra','781330',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95668,279,'Bagodi','781311',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95669,279,'Baharihat','781302',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95670,279,'Bajali College','781325',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95671,279,'Bakua','781327',1,0,'2022-03-03 13:15:00','2022-03-03 13:15:00'),(95672,279,'Balabitha','781313',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95673,279,'Balagaon','781319',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95674,279,'Balapet','781317',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95675,279,'Balikuri','781319',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95676,279,'Bamakhata','781325',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95677,279,'Bamunkata','781327',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95678,279,'Bamunkuchi','781326',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95679,279,'Bankubhanga','781319',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95680,279,'Baradi','781314',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95681,279,'Barbala','781316',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95682,279,'Barbang','781325',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95683,279,'Barengabari','781315',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95684,279,'Barenghati','781350',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95685,279,'Barghol','781302',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95686,279,'Barkapla','781307',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95687,279,'Barmazara','781318',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95688,279,'Barnagarcollege','781317',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95689,279,'Barpalli','781314',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95690,279,'Barpeta H.O','781301',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95691,279,'Barpeta Road','781315',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95692,279,'Baslajan','781308',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95693,279,'Batabari','781326',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95694,279,'Betbari','781327',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95695,279,'Bhairaguri','781311',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95696,279,'Bhakuamari','781325',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95697,279,'Bhalaguri','781318',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95698,279,'Bhalukadoba','781317',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95699,279,'Bhatkuchi','781314',1,0,'2022-03-03 13:15:01','2022-03-03 13:15:01'),(95700,279,'Bhella','781309',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95701,279,'Bheraldi','781309',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95702,279,'Bhetua','781325',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95703,279,'Bhogdia','781305',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95704,279,'Bhogpur','781329',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95705,279,'Bhoirarpam','781308',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95706,279,'Bhotanta','781328',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95707,279,'Bhotantasaderi','781325',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95708,279,'Bhowanipur','781352',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95709,279,'Bilashi Para Bazar','781315',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95710,279,'Bonghugi','781321',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95711,279,'Burikhamar','781311',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95712,279,'Byaskuchi','781307',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95713,279,'C Bazar','781317',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95714,279,'Chachaka','781317',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95715,279,'Chakabusi','781308',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95716,279,'Chandmama','781321',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95717,279,'Chaparbari Bazar','781352',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95718,279,'Charcharia','781319',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95719,279,'Charnabazar','781328',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95720,279,'Chenglimari','781318',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95721,279,'Dabaliapara','781316',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95722,279,'Deoldi','781321',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95723,279,'Dhakua','781309',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95724,279,'Dharmpur','781308',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95725,279,'Dpdeolsdi','781308',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95726,279,'Dubi','781325',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95727,279,'Dumuria','781367',1,0,'2022-03-03 13:15:02','2022-03-03 13:15:02'),(95728,279,'Duramari','781317',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95729,279,'Erabamundi','781311',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95730,279,'Gahia','781311',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95731,279,'Gajia','781314',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95732,279,'Galia','781352',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95733,279,'Ganakkuchi','781314',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95734,279,'Gandhipur','781327',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95735,279,'Garaimari','781314',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95736,279,'Garatari','781311',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95737,279,'Ghilajari','781316',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95738,279,'Ghugubari','781319',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95739,279,'Gobardhana','781315',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95740,279,'Gobindapur','781326',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95741,279,'Golagaon','781327',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95742,279,'Gomafulbari','781302',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95743,279,'Guagacha','781313',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95744,279,'Gunialguri','781319',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95745,279,'Habidongra Bazar','781308',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95746,279,'Hathinapur','781325',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95747,279,'Howly','781316',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95748,279,'Hudukhata','781318',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95749,279,'Ishapur','781321',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95750,279,'Jahurpam','781314',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95751,279,'Jalahghat','781327',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95752,279,'Jania','781314',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95753,279,'Jarabari','781314',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95754,279,'Jasihatipara','781316',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95755,279,'Jatradia','781305',1,0,'2022-03-03 13:15:03','2022-03-03 13:15:03'),(95756,279,'K Bari','781330',1,0,'2022-03-03 13:15:04','2022-03-03 13:15:04'),(95757,279,'Kadang','781314',1,0,'2022-03-03 13:15:04','2022-03-03 13:15:04'),(95758,279,'Kadomtola','781308',1,0,'2022-03-03 13:15:04','2022-03-03 13:15:04'),(95759,279,'Kalahbhanga','781315',1,0,'2022-03-03 13:15:04','2022-03-03 13:15:04'),(95760,279,'Kalgachia','781319',1,0,'2022-03-03 13:15:04','2022-03-03 13:15:04'),(95761,279,'Kalpani Bazar','781315',1,0,'2022-03-03 13:15:04','2022-03-03 13:15:04'),(95762,279,'Kamalabari','781307',1,0,'2022-03-03 13:15:04','2022-03-03 13:15:04'),(95763,279,'Kamalpur','781352',1,0,'2022-03-03 13:15:04','2022-03-03 13:15:04'),(95764,279,'Kamargaon','781317',1,0,'2022-03-03 13:15:04','2022-03-03 13:15:04'),(95765,279,'Kapahtolichikni','781321',1,0,'2022-03-03 13:15:04','2022-03-03 13:15:04'),(95766,279,'Karaguri','781307',1,0,'2022-03-03 13:15:04','2022-03-03 13:15:04'),(95767,279,'Kardoiguri','781318',1,0,'2022-03-03 13:15:04','2022-03-03 13:15:04'),(95768,279,'Katajhar','781315',1,0,'2022-03-03 13:15:04','2022-03-03 13:15:04'),(95769,279,'Kathalmurighat','781328',1,0,'2022-03-03 13:15:04','2022-03-03 13:15:04'),(95770,279,'Kayakuchi Bazar','781352',1,0,'2022-03-03 13:15:04','2022-03-03 13:15:04'),(95771,279,'Keotkuchi','781309',1,0,'2022-03-03 13:15:04','2022-03-03 13:15:04'),(95772,279,'Khablarvitha','781352',1,0,'2022-03-03 13:15:04','2022-03-03 13:15:04'),(95773,279,'Khairabari','781315',1,0,'2022-03-03 13:15:04','2022-03-03 13:15:04'),(95774,279,'Khangra','781305',1,0,'2022-03-03 13:15:04','2022-03-03 13:15:04'),(95775,279,'Khardhara','781309',1,0,'2022-03-03 13:15:04','2022-03-03 13:15:04'),(95776,279,'Khatslpara','781316',1,0,'2022-03-03 13:15:04','2022-03-03 13:15:04'),(95777,279,'Kohitama','781315',1,0,'2022-03-03 13:15:04','2022-03-03 13:15:04'),(95778,279,'Kokilabari Farm','781330',1,0,'2022-03-03 13:15:04','2022-03-03 13:15:04'),(95779,279,'Komardaisa','781330',1,0,'2022-03-03 13:15:04','2022-03-03 13:15:04'),(95780,279,'Kujarpith','781316',1,0,'2022-03-03 13:15:04','2022-03-03 13:15:04'),(95781,279,'Kurobaha','781352',1,0,'2022-03-03 13:15:04','2022-03-03 13:15:04'),(95782,279,'Labdanguri Gon','781315',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95783,279,'Langa','781319',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95784,279,'Lowkata','781330',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95785,279,'Mainamata','781315',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95786,279,'Mairajar','781315',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95787,279,'Makrikuchi','781305',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95788,279,'Mandia','781308',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95789,279,'Manikpur','781308',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95790,279,'Maripur Anandapur','781329',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95791,279,'Mayanbari','781321',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95792,279,'Mazgaon','781313',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95793,279,'Mespara','781313',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95794,279,'Moutupuri','781316',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95795,279,'Muguria','781325',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95796,279,'Nagaon','781309',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95797,279,'Nagaon Bazar','781311',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95798,279,'Nakuchi Pathar','781352',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95799,279,'Naligaon','781352',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95800,279,'Namsala','781307',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95801,279,'Nasatraphulbari','781307',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95802,279,'Nimua','781315',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95803,279,'Nirala','781308',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95804,279,'Nityananda','781329',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95805,279,'Niz Rampur','781319',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95806,279,'Nizbahari','781302',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95807,279,'Odalguri','781325',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95808,279,'Pahumara','781308',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95809,279,'Paka Bet Bari Pathar','781352',1,0,'2022-03-03 13:15:05','2022-03-03 13:15:05'),(95810,279,'Palhaji','781309',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95811,279,'Parakuchi','781307',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95812,279,'Patacharkuchi','781326',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95813,279,'Patbaushi','781314',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95814,279,'Pathartolichatala','781321',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95815,279,'Pathsala','781325',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95816,279,'Pubrihabari','781329',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95817,279,'Puranbhowanipur','781318',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95818,279,'R B Hat','781309',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95819,279,'Radhakuchi','781309',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95820,279,'Ramaparapam','781308',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95821,279,'Rangia Bhaithabhangahat','781311',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95822,279,'Raoli','781311',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95823,279,'Raypur','781325',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95824,279,'Rupahi','781318',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95825,279,'Salbari','781318',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95826,279,'Samuagati','781318',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95827,279,'Santinagar (Barpeta)','781314',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95828,279,'Sarthebari','781307',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95829,279,'Sarumanikpur','781329',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95830,279,'Sarupeta','781318',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95831,279,'Sarutapa','781352',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95832,279,'Satrakanara Bazar','781308',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95833,279,'Saudarvitha','781318',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95834,279,'Saupur','781319',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95835,279,'Senimari','781305',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95836,279,'Simlaguri','781313',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95837,279,'Sitoli','781308',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95838,279,'Sonabari','781321',1,0,'2022-03-03 13:15:06','2022-03-03 13:15:06'),(95839,279,'Sonafuli','781318',1,0,'2022-03-03 13:15:07','2022-03-03 13:15:07'),(95840,279,'Sonkuchi','781314',1,0,'2022-03-03 13:15:07','2022-03-03 13:15:07'),(95841,279,'Sorbhog','781317',1,0,'2022-03-03 13:15:07','2022-03-03 13:15:07'),(95842,279,'Sukmanah','781316',1,0,'2022-03-03 13:15:07','2022-03-03 13:15:07'),(95843,279,'Suliakata','781317',1,0,'2022-03-03 13:15:07','2022-03-03 13:15:07'),(95844,279,'Sundaridia','781314',1,0,'2022-03-03 13:15:07','2022-03-03 13:15:07'),(95845,279,'Tarakansdi','781321',1,0,'2022-03-03 13:15:07','2022-03-03 13:15:07'),(95846,279,'Thakurbazar','781301',1,0,'2022-03-03 13:15:07','2022-03-03 13:15:07'),(95847,279,'Tuplaipanbari','781329',1,0,'2022-03-03 13:15:07','2022-03-03 13:15:07'),(95848,280,'A.P.Mill','783388',1,0,'2022-03-03 13:15:07','2022-03-03 13:15:07'),(95849,280,'Abhayapuri','783384',1,0,'2022-03-03 13:15:07','2022-03-03 13:15:07'),(95850,280,'Adlaguri','783392',1,0,'2022-03-03 13:15:07','2022-03-03 13:15:07'),(95851,280,'Alukhunda Bazar','783391',1,0,'2022-03-03 13:15:07','2022-03-03 13:15:07'),(95852,280,'Ambari','783384',1,0,'2022-03-03 13:15:07','2022-03-03 13:15:07'),(95853,280,'Amguri Bazar','783393',1,0,'2022-03-03 13:15:07','2022-03-03 13:15:07'),(95854,280,'Amteka Bazar','783393',1,0,'2022-03-03 13:15:07','2022-03-03 13:15:07'),(95855,280,'Ananda Bazar','783390',1,0,'2022-03-03 13:15:07','2022-03-03 13:15:07'),(95856,280,'Aolaguri','783392',1,0,'2022-03-03 13:15:07','2022-03-03 13:15:07'),(95857,280,'B.Ladanguri','783393',1,0,'2022-03-03 13:15:07','2022-03-03 13:15:07'),(95858,280,'B.S.Gram','783384',1,0,'2022-03-03 13:15:07','2022-03-03 13:15:07'),(95859,280,'Bagargaon','783390',1,0,'2022-03-03 13:15:07','2022-03-03 13:15:07'),(95860,280,'Balapara','783388',1,0,'2022-03-03 13:15:07','2022-03-03 13:15:07'),(95861,280,'Ballamguri Bazar','783393',1,0,'2022-03-03 13:15:07','2022-03-03 13:15:07'),(95862,280,'Bangalijhora','783390',1,0,'2022-03-03 13:15:07','2022-03-03 13:15:07'),(95863,280,'Barigaon','783384',1,0,'2022-03-03 13:15:07','2022-03-03 13:15:07'),(95864,280,'Barjana','783382',1,0,'2022-03-03 13:15:07','2022-03-03 13:15:07'),(95865,280,'Barpara','783380',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95866,280,'Barpathar','783391',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95867,280,'Bengtal','783394',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95868,280,'Betini','783393',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95869,280,'Betnapara','783393',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95870,280,'Bhandra Bazar','783390',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95871,280,'Bholatol','783390',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95872,280,'Bhotgaon','783390',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95873,280,'Bhotguti Huramara','783383',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95874,280,'Bijni','783390',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95875,280,'Boitamari','783389',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95876,280,'Bongaigaon','783380',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95877,280,'Boro Bazar','783393',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95878,280,'Chakapara','783380',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95879,280,'Chakihali','783392',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95880,280,'Chakla','783392',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95881,280,'Chalantapara','783388',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95882,280,'Champabati Bazar','783373',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95883,280,'Chapaguri','783380',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95884,280,'Chaprakata','783380',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95885,280,'Chatianguri','783390',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95886,280,'Chatonilibari','783394',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95887,280,'Chipansila','783380',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95888,280,'Dakshin Bijni','783390',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95889,280,'Deohati','783384',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95890,280,'Dhaligaon','783385',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95891,280,'Dompara','783392',1,0,'2022-03-03 13:15:08','2022-03-03 13:15:08'),(95892,280,'Dongaigaon','783380',1,0,'2022-03-03 13:15:09','2022-03-03 13:15:09'),(95893,280,'Dongshia Para','783393',1,0,'2022-03-03 13:15:09','2022-03-03 13:15:09'),(95894,280,'Dumerguri','783384',1,0,'2022-03-03 13:15:09','2022-03-03 13:15:09'),(95895,280,'Dumuria Piradhara','783384',1,0,'2022-03-03 13:15:09','2022-03-03 13:15:09'),(95896,280,'Duttapur','783373',1,0,'2022-03-03 13:15:09','2022-03-03 13:15:09'),(95897,280,'Fagunagaon','783390',1,0,'2022-03-03 13:15:09','2022-03-03 13:15:09'),(95898,280,'Garubhasa','783373',1,0,'2022-03-03 13:15:09','2022-03-03 13:15:09'),(95899,280,'Garugaon','783383',1,0,'2022-03-03 13:15:09','2022-03-03 13:15:09'),(95900,280,'Gerukabari','783390',1,0,'2022-03-03 13:15:09','2022-03-03 13:15:09'),(95901,280,'Ghilaguri','783383',1,0,'2022-03-03 13:15:09','2022-03-03 13:15:09'),(95902,280,'Golapara','783384',1,0,'2022-03-03 13:15:09','2022-03-03 13:15:09'),(95903,280,'Goraimari','783390',1,0,'2022-03-03 13:15:09','2022-03-03 13:15:09'),(95904,280,'Hanchara','783390',1,0,'2022-03-03 13:15:09','2022-03-03 13:15:09'),(95905,280,'Hapachara','783390',1,0,'2022-03-03 13:15:09','2022-03-03 13:15:09'),(95906,280,'Jharbishpani','783390',1,0,'2022-03-03 13:15:09','2022-03-03 13:15:09'),(95907,280,'Jogighopa','783382',1,0,'2022-03-03 13:15:09','2022-03-03 13:15:09'),(95908,280,'Joypur','783393',1,0,'2022-03-03 13:15:09','2022-03-03 13:15:09'),(95909,280,'Kajalgaon','783385',1,0,'2022-03-03 13:15:09','2022-03-03 13:15:09'),(95910,280,'Kakaijana','783383',1,0,'2022-03-03 13:15:09','2022-03-03 13:15:09'),(95911,280,'Kaliagaon','783390',1,0,'2022-03-03 13:15:09','2022-03-03 13:15:09'),(95912,280,'Karigaon','783373',1,0,'2022-03-03 13:15:09','2022-03-03 13:15:09'),(95913,280,'Kashikotra','783373',1,0,'2022-03-03 13:15:09','2022-03-03 13:15:09'),(95914,280,'Kawatika','783390',1,0,'2022-03-03 13:15:09','2022-03-03 13:15:09'),(95915,280,'Kayetpara','783389',1,0,'2022-03-03 13:15:09','2022-03-03 13:15:09'),(95916,280,'Khagarpur','783383',1,0,'2022-03-03 13:15:09','2022-03-03 13:15:09'),(95917,280,'Khagrabari','783380',1,0,'2022-03-03 13:15:09','2022-03-03 13:15:09'),(95918,280,'Khungkhurajhara','783393',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95919,280,'Khwaja Dolaigaon','783380',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95920,280,'Kirtanpara','783384',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95921,280,'Koilamoila','783393',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95922,280,'Kokila','783392',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95923,280,'Koreya','783388',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95924,280,'Kushbari','783384',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95925,280,'Lalmati','783384',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95926,280,'Latibari','783384',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95927,280,'Lengtisinga','783384',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95928,280,'Madrasapara','783384',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95929,280,'Malegarh','783382',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95930,280,'Malibhita','783393',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95931,280,'Malipara','783393',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95932,280,'Manikpur (Bongaigaon)','783392',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95933,280,'Melopara','783134',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95934,280,'Monakocha','783391',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95935,280,'Mongolian Bazar','783390',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95936,280,'Mozabari','783373',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95937,280,'Mulagaon','783380',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95938,280,'Nararbhita','783384',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95939,280,'Natunpara','783380',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95940,280,'Nayagaon','783384',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95941,280,'Nayasatra','783384',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95942,280,'Nehru Bazar','783393',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95943,280,'New Bongaigaon','783381',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95944,280,'North Baitamari','783380',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95945,280,'North Bongaigaon','783380',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95946,280,'Nowagaon','783392',1,0,'2022-03-03 13:15:10','2022-03-03 13:15:10'),(95947,280,'Nowapara','783392',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95948,280,'Numberpara','783392',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95949,280,'Ouguri','783394',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95950,280,'Pachania','783382',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95951,280,'Panbari','783391',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95952,280,'Panbari Bazar','783360',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95953,280,'Patabari','783394',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95954,280,'Patiladaha','783391',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95955,280,'Popragaon','783380',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95956,280,'Rangapani','783384',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95957,280,'Salabila Bazar','783392',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95958,280,'Salmara North','783383',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95959,280,'Santoshpur','783384',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95960,280,'Sidli','783373',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95961,280,'Silbari Abdaipara','783393',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95962,280,'Silkhaguri','783390',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95963,280,'Simlaguri','783381',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95964,280,'Sonaikhola','783391',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95965,280,'Tilpukhuri','783384',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95966,280,'Topgaon','783384',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95967,280,'Tukrijhora','783394',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95968,281,'Algapur','788101',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95969,281,'Amaranagar T E','788030',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95970,281,'Ambicapur','788004',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95971,281,'Amjurghat','788119',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95972,281,'Arkutipur','788009',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95973,281,'Arunachal','788025',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95974,281,'Assam University','788011',1,0,'2022-03-03 13:15:11','2022-03-03 13:15:11'),(95975,281,'Atharotilla','788115',1,0,'2022-03-03 13:15:12','2022-03-03 13:15:12'),(95976,281,'Badripar','788009',1,0,'2022-03-03 13:15:12','2022-03-03 13:15:12'),(95977,281,'Bag O Bahar','788113',1,0,'2022-03-03 13:15:12','2022-03-03 13:15:12'),(95978,281,'Baglaghat','788026',1,0,'2022-03-03 13:15:12','2022-03-03 13:15:12'),(95979,281,'Bagpur','788101',1,0,'2022-03-03 13:15:12','2022-03-03 13:15:12'),(95980,281,'Balacherra T E','788110',1,0,'2022-03-03 13:15:12','2022-03-03 13:15:12'),(95981,281,'Baladhan T E','788107',1,0,'2022-03-03 13:15:12','2022-03-03 13:15:12'),(95982,281,'Banskandi','788101',1,0,'2022-03-03 13:15:12','2022-03-03 13:15:12'),(95983,281,'Barakhai T E','788113',1,0,'2022-03-03 13:15:12','2022-03-03 13:15:12'),(95984,281,'Bararkap','788107',1,0,'2022-03-03 13:15:12','2022-03-03 13:15:12'),(95985,281,'Barjatrapur','788110',1,0,'2022-03-03 13:15:12','2022-03-03 13:15:12'),(95986,281,'Baroitoli','788815',1,0,'2022-03-03 13:15:12','2022-03-03 13:15:12'),(95987,281,'Baromuni','788121',1,0,'2022-03-03 13:15:12','2022-03-03 13:15:12'),(95988,281,'Barthal','788113',1,0,'2022-03-03 13:15:12','2022-03-03 13:15:12'),(95989,281,'Barthal T E','788102',1,0,'2022-03-03 13:15:12','2022-03-03 13:15:12'),(95990,281,'Batertal','788015',1,0,'2022-03-03 13:15:12','2022-03-03 13:15:12'),(95991,281,'Behara Bazar','788817',1,0,'2022-03-03 13:15:12','2022-03-03 13:15:12'),(95992,281,'Behara PT IV','788817',1,0,'2022-03-03 13:15:12','2022-03-03 13:15:12'),(95993,281,'Bekirpar','788123',1,0,'2022-03-03 13:15:12','2022-03-03 13:15:12'),(95994,281,'Berabak PT II','788115',1,0,'2022-03-03 13:15:12','2022-03-03 13:15:12'),(95995,281,'Bhaga Bazar','788120',1,0,'2022-03-03 13:15:12','2022-03-03 13:15:12'),(95996,281,'Bhairabpur','788815',1,0,'2022-03-03 13:15:12','2022-03-03 13:15:12'),(95997,281,'Bhangarpar','788817',1,0,'2022-03-03 13:15:12','2022-03-03 13:15:12'),(95998,281,'Bharakhai','788010',1,0,'2022-03-03 13:15:12','2022-03-03 13:15:12'),(95999,281,'Bhuban Valley','788099',1,0,'2022-03-03 13:15:12','2022-03-03 13:15:12'),(96000,281,'Bhubandhar T E','788114',1,0,'2022-03-03 13:15:12','2022-03-03 13:15:12'),(96001,281,'Bhubaneswarnagar','788817',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96002,281,'Bidyaratanpur','788120',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96003,281,'Bilburunga','788817',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96004,281,'Binnakandi','788126',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96005,281,'Binnakandi Ghat','788126',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96006,281,'Boali Basti','788099',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96007,281,'Boaljur','788115',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96008,281,'Borkhola','788110',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96009,281,'Borodukan','788113',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96010,281,'Buribail','788025',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96011,281,'C R Avenue','788005',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96012,281,'Chaligram','788815',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96013,281,'Chandighat T E','788030',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96014,281,'Chandpur','788110',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96015,281,'Chandranathpur','788817',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96016,281,'Chandrapur','788101',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96017,281,'Channighat','788120',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96018,281,'Chekarcham','788116',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96019,281,'Chengjui Grant','788126',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96020,281,'Chhoto Dudpatil','788002',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96021,281,'Chhoto Dudpatil PT I','788002',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96022,281,'Chhotomanda','788126',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96023,281,'Chincuri T E','788007',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96024,281,'Chirukandi','788003',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96025,281,'Chotojalenga','788113',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96026,281,'Clever House','788112',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96027,281,'Cossipur','788009',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96028,281,'Dalu','788111',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96029,281,'Daluagram','788101',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96030,281,'Damcherra','788817',1,0,'2022-03-03 13:15:13','2022-03-03 13:15:13'),(96031,281,'Darmikhal','788116',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96032,281,'Dayapur','788030',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96033,281,'Dayapur T E','788030',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96034,281,'Debipur','788114',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96035,281,'Derby','788112',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96036,281,'Dewan','788102',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96037,281,'Dewanji Bazar','788001',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96038,281,'Dhakin Mohonpur','788119',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96039,281,'Dhanehari','788013',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96040,281,'Dhanipur','788120',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96041,281,'Dholai Bazar','788114',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96042,281,'Didarkush Basti','788099',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96043,281,'Digarkhal Bazar','788815',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96044,281,'Digor Srikona','788026',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96045,281,'Dilkhush T E','788106',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96046,281,'Dinanathpur','788817',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96047,281,'Diska Grant','788107',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96048,281,'Dudpatil','788003',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96049,281,'Dudpur','788025',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96050,281,'Dulalgram','788114',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96051,281,'Dumkabazar','788815',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96052,281,'Dumurghat','788031',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96053,281,'Dungripar','788101',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96054,281,'Durganagar T E','788030',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96055,281,'Fulertal','788106',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96056,281,'G C College','788004',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96057,281,'Ganganagar','788099',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96058,281,'Gangapur','788804',1,0,'2022-03-03 13:15:14','2022-03-03 13:15:14'),(96059,281,'Ganirgram','788025',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96060,281,'Ganirgram PT II','788025',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96061,281,'Ghungoor Kuarpar','788010',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96062,281,'Gojalghat','788114',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96063,281,'Gossainagar','788030',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96064,281,'Gossainpur PT I','788030',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96065,281,'Govindanagar','788119',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96066,281,'Govindapur East','788101',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96067,281,'Govindapur West','788804',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96068,281,'Gurudayalpur','788114',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96069,281,'Hailakandi H.O','788151',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96070,281,'Harinagar','788805',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96071,281,'Harinagar Bazar','788107',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96072,281,'Harinetilla','788011',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96073,281,'Haticherra Grant PT VII','788002',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96074,281,'Haticherra T E','788030',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96075,281,'Hatikhal Bazar','788116',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96076,281,'Hawaithang','788120',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96077,281,'Hayairbond','788127',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96078,281,'Hazarigram Bazar','788101',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96079,281,'Hilara Colony','788815',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96080,281,'Hmarkhawlin','788106',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96081,281,'Hospital Road (Cachar)','788005',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96082,281,'Irongmara Bazar','788011',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96083,281,'Itkhola','788002',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96084,281,'Jagadishpur','788805',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96085,281,'Jalalpur (Cachar)','788816',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96086,281,'Jamalpur','788120',1,0,'2022-03-03 13:15:15','2022-03-03 13:15:15'),(96087,281,'Jarailtala Bazar','788127',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96088,281,'Jhanjarbali','788119',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96089,281,'Jhoragul','788119',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96090,281,'Jibangram','788114',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96091,281,'Jirighat','788104',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96092,281,'Jogiabasti','788115',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96093,281,'Joypur Rajabazar','788107',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96094,281,'Joyput PT III','788107',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96095,281,'Kabuganj Bazar','788121',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96096,281,'Kachudaram','788119',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96097,281,'Kachudaram PT I','788119',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96098,281,'Kajidahar','788115',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96099,281,'Kakmara','788101',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96100,281,'Kalachandpur','788098',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96101,281,'Kalain','788815',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96102,281,'Kalaincherra','788815',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96103,281,'Kalakhal','788116',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96104,281,'Kamranga','788107',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96105,281,'Kanakpur','788006',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96106,281,'Kanakpur East','788107',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96107,281,'Kanchanpur','788007',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96108,281,'Kaptanpur','788119',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96109,281,'Kaptanpur PT 18','788119',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96110,281,'Karaikandi','788101',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96111,281,'Karkori','788815',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96112,281,'Katigorah','788805',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96113,281,'Katirail','788804',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96114,281,'Khelma PT VII','788815',1,0,'2022-03-03 13:15:16','2022-03-03 13:15:16'),(96115,281,'Krishnapur','788025',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96116,281,'Kumacherra','788107',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96117,281,'Kumbhir','788108',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96118,281,'Kumbhirgram Airport','788109',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96119,281,'Labacpar PT III','788098',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96120,281,'Laboc','788102',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96121,281,'Lailapur','788120',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96122,281,'Lakhipur (Cachar)','788103',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96123,281,'Lallong','788098',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96124,281,'Lallong T E','788102',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96125,281,'Larsing T E','788030',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96126,281,'Larsingpar','788002',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96127,281,'Lathigram','788030',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96128,281,'Lathimara','788805',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96129,281,'Leburbond','788002',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96130,281,'Leiri','788107',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96131,281,'Link Road (Cachar)','788006',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96132,281,'Loharband','788113',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96133,281,'Longlacherra','788108',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96134,281,'Machpara','788009',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96135,281,'Machughat','788003',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96136,281,'Madhura','788030',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96137,281,'Madhurbond','788001',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96138,281,'Madripar','788101',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96139,281,'Mahadebpur PT I','788114',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96140,281,'Mahadevpur','788025',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96141,281,'Mahalthal','788107',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96142,281,'Malugram','788002',1,0,'2022-03-03 13:15:17','2022-03-03 13:15:17'),(96143,281,'Mangalpur','788119',1,0,'2022-03-03 13:15:18','2022-03-03 13:15:18'),(96144,281,'Maniarkhal','788099',1,0,'2022-03-03 13:15:18','2022-03-03 13:15:18'),(96145,281,'Manipur Pti','788101',1,0,'2022-03-03 13:15:18','2022-03-03 13:15:18'),(96146,281,'Maniupr PT II','788098',1,0,'2022-03-03 13:15:18','2022-03-03 13:15:18'),(96147,281,'Marchakhal','788107',1,0,'2022-03-03 13:15:18','2022-03-03 13:15:18'),(96148,281,'Martycherra','788108',1,0,'2022-03-03 13:15:18','2022-03-03 13:15:18'),(96149,281,'Matinagar','788099',1,0,'2022-03-03 13:15:18','2022-03-03 13:15:18'),(96150,281,'Meherpur','788015',1,0,'2022-03-03 13:15:18','2022-03-03 13:15:18'),(96151,281,'Nagar T E','788030',1,0,'2022-03-03 13:15:18','2022-03-03 13:15:18'),(96152,281,'Nagdirgram','788121',1,0,'2022-03-03 13:15:18','2022-03-03 13:15:18'),(96153,281,'Naraincherra','788110',1,0,'2022-03-03 13:15:18','2022-03-03 13:15:18'),(96154,281,'Narsingpur','788115',1,0,'2022-03-03 13:15:18','2022-03-03 13:15:18'),(96155,281,'Neairgram','788013',1,0,'2022-03-03 13:15:18','2022-03-03 13:15:18'),(96156,281,'New Bag O Bahar','788113',1,0,'2022-03-03 13:15:18','2022-03-03 13:15:18'),(96157,281,'Nizjoynagar','788025',1,0,'2022-03-03 13:15:18','2022-03-03 13:15:18'),(96158,281,'Nutan Bazar','788115',1,0,'2022-03-03 13:15:18','2022-03-03 13:15:18'),(96159,281,'Nutan Dayapur','788009',1,0,'2022-03-03 13:15:18','2022-03-03 13:15:18'),(96160,281,'Nutan Ramnagar','788126',1,0,'2022-03-03 13:15:18','2022-03-03 13:15:18'),(96161,281,'Pailapool','788098',1,0,'2022-03-03 13:15:18','2022-03-03 13:15:18'),(96162,281,'Pallorbond','788101',1,0,'2022-03-03 13:15:18','2022-03-03 13:15:18'),(96163,281,'Paloi','788123',1,0,'2022-03-03 13:15:18','2022-03-03 13:15:18'),(96164,281,'Palonghat','788116',1,0,'2022-03-03 13:15:18','2022-03-03 13:15:18'),(96165,281,'Pangram','788030',1,0,'2022-03-03 13:15:18','2022-03-03 13:15:18'),(96166,281,'Panibhora','788123',1,0,'2022-03-03 13:15:18','2022-03-03 13:15:18'),(96167,281,'Pratapur','788113',1,0,'2022-03-03 13:15:18','2022-03-03 13:15:18'),(96168,281,'Punimukh','788123',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96169,281,'Purandarpur','788110',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96170,281,'Purnanagar','788816',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96171,281,'R K Mission Road','788007',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96172,281,'Rajartilla','788805',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96173,281,'Rajnagar','788026',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96174,281,'Rajyeswarpur West','788816',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96175,281,'Rakhal Khalerpar','788025',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96176,281,'Rammanikpur','788116',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96177,281,'Ramnagar Tarapur','788003',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96178,281,'Rangirkhari','788005',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96179,281,'Ronghat PT I','788817',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96180,281,'Rongpur PT II','788009',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96181,281,'Rongpur','788009',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96182,281,'Rukhni','788116',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96183,281,'Rukhni PT I','788116',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96184,281,'Rukhni T E','788116',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96185,281,'Sachinpur','788116',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96186,281,'Sadirkhal','788815',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96187,281,'Saidpur','788013',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96188,281,'Saidpur PT II','788013',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96189,281,'Saint Katharine','788099',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96190,281,'Salganga','788031',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96191,281,'Santipur','788123',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96192,281,'Saptagram','788114',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96193,281,'Saradapally','788107',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96194,281,'Sarbadaynagar','788006',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96195,281,'Satkarakandi','788013',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96196,281,'Sayedpur Amtala','788815',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96197,281,'Selurpar','788119',1,0,'2022-03-03 13:15:19','2022-03-03 13:15:19'),(96198,281,'Shyamacharanpur','788120',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96199,281,'Sibbari Road','788002',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96200,281,'Sibpur','788098',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96201,281,'Silchar Court','788001',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96202,281,'Silchar H.O','788001',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96203,281,'Silchar Medical College','788014',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96204,281,'Silchar REC','788010',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96205,281,'Silcuri','788118',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96206,281,'Sildhubi','788112',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96207,281,'Singari','788007',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96208,281,'Singerbond','788126',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96209,281,'Sonabarighat','788013',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96210,281,'Sonaimukh','788119',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96211,281,'Sonapur','788817',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96212,281,'Srikona','788026',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96213,281,'Subedar Basti','788003',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96214,281,'Subhang','788111',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96215,281,'Suktola','788114',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96216,281,'Sundari','788099',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96217,281,'Sundari PT II','788116',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96218,281,'Swastipally','788126',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96219,281,'Tarapur Khelma','788003',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96220,281,'Tarapur Part VII','788003',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96221,281,'Tarapur (Cachar)','788003',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96222,281,'Thailoo','788102',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96223,281,'Thaligram','788031',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96224,281,'Thanjanlaikai','788119',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96225,281,'Tikarburunga','788817',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96226,281,'Tolengram','788103',1,0,'2022-03-03 13:15:20','2022-03-03 13:15:20'),(96227,281,'Tulargram PT II','788119',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96228,281,'Tupkhana','788003',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96229,281,'Udarbond','788030',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96230,281,'Ujan Tarapur','788098',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96231,281,'Uttar Lalpani','788104',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96232,281,'Uttar Sonpur','788098',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96233,281,'Uttarkrishnapur','788006',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96234,281,'Vivekananda Road','788007',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96235,282,'Ajodhyapur','784524',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96236,282,'Ambagan','784510',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96237,282,'Aminpara','784514',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96238,282,'Andherighat','784148',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96239,282,'Atterikhat','784527',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96240,282,'Aulachowka','784529',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96241,282,'Bahmola','784522',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96242,282,'Bajanapathar','784145',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96243,282,'Balabari','784146',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96244,282,'Bandarguri','784509',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96245,282,'Baralakhat','784522',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96246,282,'Barampur','784144',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96247,282,'Barampur Kalaigaon','784525',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96248,282,'Barangabari','784522',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96249,282,'Barbagan','784190',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96250,282,'Barigaon No.2','784147',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96251,282,'Barigoan','784510',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96252,282,'Barkalachowka','784525',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96253,282,'Barnagram','784509',1,0,'2022-03-03 13:15:21','2022-03-03 13:15:21'),(96254,282,'Batabari','784507',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96255,282,'Batakuchi','784510',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96256,282,'Bechimari','784514',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96257,282,'Bengbari','784523',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96258,282,'Bhairabkunda','784513',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96259,282,'Bhakatpara','784190',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96260,282,'Bhalukmari','784508',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96261,282,'Bhekulikanda','784525',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96262,282,'Bherbheribill','784525',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96263,282,'Bhirgaon','784522',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96264,282,'Bholabari','784525',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96265,282,'Bholaguri','784522',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96266,282,'Bhuyankhat','784528',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96267,282,'Bogpuri','784522',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96268,282,'Bongaligaon','784113',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96269,282,'Bordolguri','784145',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96270,282,'Borjhar Bazar','784114',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96271,282,'Burargarh','784147',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96272,282,'Burha','784148',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96273,282,'Burhi Nagar','784147',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96274,282,'Byaspara','784145',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96275,282,'Chakrabasti','784116',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96276,282,'Chamatiapara','784147',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96277,282,'Chamuapara','784529',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96278,282,'Chapaichowka','784529',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96279,282,'Chengapathar','784525',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96280,282,'Chengeliajhar','784145',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96281,282,'Dafalapota','784114',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96282,282,'Dahinagaon','784529',1,0,'2022-03-03 13:15:22','2022-03-03 13:15:22'),(96283,282,'Daipam','784514',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96284,282,'Dalgaon','784116',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96285,282,'Dalong Ghat','784528',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96286,282,'Deodhani Ghat','784147',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96287,282,'Deomornoi','784147',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96288,282,'Dhansiri Bazar','784114',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96289,282,'Dhekipara','784145',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96290,282,'Dholpur','784145',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96291,282,'Dhopguri','784528',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96292,282,'Dhula','784146',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96293,282,'Dighirpar','784144',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96294,282,'Dimakuchi','784526',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96295,282,'Dipila Chowka','784144',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96296,282,'Dolakati Borobazar','784113',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96297,282,'Duni (Darrang)','784148',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96298,282,'Ekrabari','784514',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96299,282,'Galandi','784115',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96300,282,'Ganesh Kunwari','784145',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96301,282,'Garaibari','784509',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96302,282,'Garukhuti','784145',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96303,282,'Gerua Bazar','784514',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96304,282,'Ghansimali','784115',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96305,282,'Ghoghrabazar','784524',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96306,282,'Goriajhar','784523',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96307,282,'Harisinga','784510',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96308,282,'Hatigarh (Darrang)','784524',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96309,282,'Hatimara','784144',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96310,282,'Hazarikapara','784145',1,0,'2022-03-03 13:15:23','2022-03-03 13:15:23'),(96311,282,'Hengalpara','784148',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96312,282,'Hoograjuli','784507',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96313,282,'Howli Mohanpur','784529',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96314,282,'Jaljali','784529',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96315,282,'Jalukbari','784522',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96316,282,'Jamuguri','784114',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96317,282,'Jangalpara','784116',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96318,282,'Jonaramchowka','784529',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96319,282,'Kabir Ali','784525',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96320,282,'Kachubilhat','784523',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96321,282,'Kajiamati','784509',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96322,282,'Kalaigaon','784525',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96323,282,'Kalikhola','784526',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96324,282,'Kenduguri','784148',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96325,282,'Khagrabari','784527',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96326,282,'Khandajan','784145',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96327,282,'Kharupetiaghat Bazar','784115',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96328,282,'Kharupetiaghat','784115',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96329,282,'Khoirabari','784522',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96330,282,'Khowrang','784509',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96331,282,'Khuchurabari','784507',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96332,282,'Khuchurabari Habigaon','784509',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96333,282,'Kopati','784113',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96334,282,'Kuhiarkuchi','784522',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96335,282,'Kunwari Pukhuri','784115',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96336,282,'Kuruwa','784145',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96337,282,'Lakhimpur','784525',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96338,282,'Lalpul Bazar','784514',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96339,282,'Mahalia Para','784507',1,0,'2022-03-03 13:15:24','2022-03-03 13:15:24'),(96340,282,'Majorchuba','784525',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96341,282,'Malmura','784522',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96342,282,'Mangalanagar','784529',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96343,282,'Mangaldoi H.O','784125',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96344,282,'Maroi','784145',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96345,282,'Marowachowka','784145',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96346,282,'Maugaon','784528',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96347,282,'Mazbat','784507',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96348,282,'Mazkhuti','784509',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96349,282,'Mechakapukhuri','784521',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96350,282,'Minapara','784146',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96351,282,'Mohanpur','784509',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96352,282,'Mudoibari','784146',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96353,282,'Murmela','784521',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96354,282,'Muslimghopa','784145',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96355,282,'Naharbari','784147',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96356,282,'Nalkhamara','784509',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96357,282,'Narengkati','784507',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96358,282,'Nassansali','784528',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96359,282,'Nichilamari','784522',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96360,282,'Niz Kharupetia','784115',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96361,282,'No.1 Amjuli','784510',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96362,282,'No.2 Barangajuli','784527',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96363,282,'No.2 Saikia Chuburi','784114',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96364,282,'No.2 Sialmari','784116',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96365,282,'No.3 Rajagarh','784527',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96366,282,'Orang','784114',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96367,282,'Outola','784525',1,0,'2022-03-03 13:15:25','2022-03-03 13:15:25'),(96368,282,'Pachim Patla','784526',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96369,282,'Padupuri Mazgaon','784514',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96370,282,'Palahgarh','784521',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96371,282,'Panerihat','784523',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96372,282,'Panichali','784522',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96373,282,'Pathakpur','784507',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96374,282,'Pathorighat','784144',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96375,282,'Pati Darrang','784147',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96376,282,'Punia No.1','784115',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96377,282,'Purana Tangla','784528',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96378,282,'Purandia','784521',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96379,282,'Rajghat','784529',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96380,282,'Raksyasmari','784507',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96381,282,'Ramhari Chowka','784529',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96382,282,'Rangajuli','784522',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96383,282,'Rangamati','784529',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96384,282,'Ranipukhuri','784525',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96385,282,'Ratanpur','784523',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96386,282,'Rowta Chariali','784508',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96387,282,'Rowta','784508',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96388,282,'Samuakhat','784190',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96389,282,'Sanowa','784145',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96390,282,'Santipukhuri','784144',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96391,282,'Sastrapara','784510',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96392,282,'Satkhali','784145',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96393,282,'Shamtilla','784190',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96394,282,'Shikari Banglow','784528',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96395,282,'Shillongkhuti','784508',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96396,282,'Silbori','784114',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96397,282,'Sipajhal','784145',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96398,282,'Suklai','784527',1,0,'2022-03-03 13:15:26','2022-03-03 13:15:26'),(96399,282,'Tamulbari','784510',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96400,282,'Tangla','784521',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96401,282,'Teliapara','784524',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96402,282,'Tengabari','784525',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96403,282,'Tengara','784148',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96404,282,'Thakuriapara','784522',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96405,282,'Thana Udalguri','784509',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96406,282,'Udalguri','784509',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96407,283,'Akajan Bormuria','787059',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96408,283,'Aktai','787110',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96409,283,'Aradhal','787057',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96410,283,'Batgharia','787057',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96411,283,'Batuamukh','787110',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96412,283,'Bauli','787057',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96413,283,'Bengenagarah','787058',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96414,283,'Betanipam','787059',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96415,283,'Bhagwan','787059',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96416,283,'Bhebeli Gaon','787110',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96417,283,'Bishnupur','787057',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96418,283,'Borachira Gaon','787057',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96419,283,'Bordoloni','787026',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96420,283,'Borlung','787057',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96421,283,'Bulakata','787057',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96422,283,'Burisuti','787110',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96423,283,'Cementmukh','787059',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96424,283,'Dekapam','787061',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96425,283,'Demow Chariali','787059',1,0,'2022-03-03 13:15:27','2022-03-03 13:15:27'),(96426,283,'Deuribarbam','787026',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96427,283,'Dhemaji','787057',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96428,283,'Dhubabari','787058',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96429,283,'Dhunaguri Borgaya Deori Gaon','787110',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96430,283,'Dighali Debera','787058',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96431,283,'Dipa','787061',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96432,283,'Gali Borbali','787060',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96433,283,'Gandhia Tiniali','787058',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96434,283,'Goalchapori','787057',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96435,283,'Gohaingaon','787057',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96436,283,'Guttung','787057',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96437,283,'Hapotia','787058',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96438,283,'Hatigarh','787057',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96439,283,'Hollowdanga','787026',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96440,283,'Jairampur','787026',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96441,283,'Jamuguri Panchali','787057',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96442,283,'Janakalyan Chariali','787110',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96443,283,'Jiadhal','787057',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96444,283,'Jonai','787060',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96445,283,'Jorkata','787058',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96446,283,'Jugisuti','787058',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96447,283,'Kabu Chapori','787060',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96448,283,'Kachari Pathar','787058',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96449,283,'Kadamguri','787034',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96450,283,'Kaitung','787058',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96451,283,'Kalakata','787058',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96452,283,'Kaupatani','787034',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96453,283,'Kerekani Majgaon','787110',1,0,'2022-03-03 13:15:28','2022-03-03 13:15:28'),(96454,283,'Khaliamari Pamuagaon','787058',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96455,283,'Khorachukgaon','787034',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96456,283,'Khubalia','787057',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96457,283,'Kulajan Tiniali','787110',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96458,283,'Laguaborah','787053',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96459,283,'Laimekuri','787060',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96460,283,'Lakhipathar','787057',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96461,283,'Leku','787060',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96462,283,'Lotakigaon','787034',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96463,283,'Machkhowa','787058',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96464,283,'Madhuripathar','787059',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96465,283,'Majorbari Budhbaria Bazar','787059',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96466,283,'Matikhola','787057',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96467,283,'Mechaki Tongani Mirigaon','787110',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96468,283,'Mingmang','787035',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96469,283,'Missamari','787026',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96470,283,'Moridhal','787057',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96471,283,'Muktiar Chapori','787110',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96472,283,'Na Nadi Bhebeli Kahcari Gaon','787034',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96473,283,'Nagakhelia','787057',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96474,283,'Nalbari Kachari','787035',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96475,283,'Namgharia','787110',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96476,283,'Nemutengani','787058',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96477,283,'Nilakh Chariali','787110',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96478,283,'Norowathan','787058',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96479,283,'Palengi Pachali','787110',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96480,283,'Perabari','787057',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96481,283,'Pipalguri','787110',1,0,'2022-03-03 13:15:29','2022-03-03 13:15:29'),(96482,283,'Pukia','787110',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96483,283,'Raiting','787057',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96484,283,'Ramdhan Dikhari','787060',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96485,283,'Ramyapur','787110',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96486,283,'Ratanpur','787060',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96487,283,'Salmari No.2','787026',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96488,283,'Samarajan Tiniali','787026',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96489,283,'Seujiapathar','787058',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96490,283,'Silabaligaon','787059',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96491,283,'Silapathar','787059',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96492,283,'Simen Chapori','787061',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96493,283,'Sissiborgaon','787110',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96494,283,'Sissimukh','787058',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96495,283,'Somkong Pagar','787061',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96496,283,'Subahi','787057',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96497,283,'Talem','787061',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96498,283,'Zonekareng','787060',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96499,284,'Agomoni','783335',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96500,284,'Airkata Bazar','783330',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96501,284,'Aironjongla','783323',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96502,284,'Alamganj','783339',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96503,284,'Amco Road','783323',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96504,284,'Asharikandi','783331',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96505,284,'Bagribari','783349',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96506,284,'Baladoba','783334',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96507,284,'Balajan','783331',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96508,284,'Bangalipara','783348',1,0,'2022-03-03 13:15:30','2022-03-03 13:15:30'),(96509,284,'Banyaguri','783331',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96510,284,'Barkaila Serso','783330',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96511,284,'Barkanda','783348',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96512,284,'Barkona','783131',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96513,284,'Barundanga','783334',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96514,284,'Bashbari','783337',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96515,284,'Bauskata','783127',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96516,284,'Belguri','783334',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96517,284,'Bhatipetla','783334',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96518,284,'Bichandai','783334',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96519,284,'Bidyapara','783324',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96520,284,'Bidyardabri','783335',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96521,284,'Bilasipara','783348',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96522,284,'Bishkhowa','783334',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96523,284,'Boalkamari','783348',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96524,284,'Bondihana','783349',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96525,284,'Boraibari Pt- V','783339',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96526,284,'Borocharaikhola','783334',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96527,284,'Borshijhora','783339',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96528,284,'Chagalchara','783324',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96529,284,'Chagolia','783335',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96530,284,'Chapar','783371',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96531,284,'Chatoguma','783335',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96532,284,'Chirakuti Bazar','783330',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96533,284,'Chirakuti Pt-i','783348',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96534,284,'Choudhurirchar','783349',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96535,284,'Dafarpur','783334',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96536,284,'Debitola','783339',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96537,284,'Debottar Hasdaha','783334',1,0,'2022-03-03 13:15:31','2022-03-03 13:15:31'),(96538,284,'Dhanpur','783337',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96539,284,'Dhanuagaon','783135',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96540,284,'Dharmasala','783324',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96541,284,'Dhirbil','783348',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96542,284,'Dhubri Balurchar','783323',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96543,284,'Dhubri Bazar','783301',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96544,284,'Dhubri H.O','783301',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96545,284,'Dhumerghat','783330',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96546,284,'Dighaltari','783335',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96547,284,'Dimakuri','783334',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96548,284,'Duligaon','783337',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96549,284,'Fakirganj','783330',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96550,284,'Falimari  Pt-i','783325',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96551,284,'Fekamari','783135',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96552,284,'Fulerchar','783135',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96553,284,'Gashbari','783348',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96554,284,'Gauripur','783331',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96555,284,'Geramari','783339',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96556,284,'Gobardhanpara','783348',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96557,284,'Golakganj','783334',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96558,284,'Gutipara','783349',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96559,284,'Hakama','783348',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96560,284,'Hamidabad','783330',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96561,284,'Haraltari','783337',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96562,284,'Hatipota','783348',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96563,284,'Hatsingimari','783135',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96564,284,'Hazirhat','783128',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96565,284,'Howrarpar','783324',1,0,'2022-03-03 13:15:32','2022-03-03 13:15:32'),(96566,284,'Jalabila','783348',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96567,284,'Jamadarhat','783330',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96568,284,'Jamduar','783348',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96569,284,'Jhagrarpar','783325',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96570,284,'Jhapsabari','783335',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96571,284,'Jharnerchar','783339',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96572,284,'Jhaskal','783335',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96573,284,'Jhowdanga','783131',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96574,284,'Kachakhana','783334',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96575,284,'Kacharihat','783334',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96576,284,'Kadamtala Pt-IIi','783348',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96577,284,'Kaimari','783335',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96578,284,'Kajaikata','783348',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96579,284,'Kakripara','783131',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96580,284,'Kalapani','783135',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96581,284,'Kaldoba','783335',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96582,284,'Kanaimara','783135',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96583,284,'Kazigaon','783339',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96584,284,'Khalilpur','783325',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96585,284,'Khalisabhita','783330',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96586,284,'Khanabari Araiani','783349',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96587,284,'Kheluapara','783371',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96588,284,'Kherbari','783335',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96589,284,'Khopati','783339',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96590,284,'Khudimari','783331',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96591,284,'Kismat Hasdaha','783334',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96592,284,'Kokradanga','783128',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96593,284,'Lakhiganj Bazar','783345',1,0,'2022-03-03 13:15:33','2022-03-03 13:15:33'),(96594,284,'Lakhimari','783334',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96595,284,'Madartari','783330',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96596,284,'Madhusoulmari','783331',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96597,284,'Mahamayadham','783349',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96598,284,'Mahamayahat','783335',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96599,284,'Majerchar','783325',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96600,284,'Majharalga','783388',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96601,284,'Mankachar','783131',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96602,284,'Manullapara','783135',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96603,284,'Maragadadhar','783335',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96604,284,'Molandubi','783334',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96605,284,'Moterjhar','783334',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96606,284,'Muhurirchar','783128',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96607,284,'Muthakhowa','783323',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96608,284,'Nayeralga','783348',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96609,284,'Nilokhia','783128',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96610,284,'Pabarchara','783335',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96611,284,'Paglahat','783334',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96612,284,'Patamari','783324',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96613,284,'Piazbari','783128',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96614,284,'Piazbari Makrijhora','783349',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96615,284,'Pocharchar','783127',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96616,284,'Podmeralga','783339',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96617,284,'Pokalagi','783335',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96618,284,'Purandiara','783135',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96619,284,'Radhamadhabhat','783131',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96620,284,'Raijhora Bahalpur','783371',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96621,284,'Raipur','783334',1,0,'2022-03-03 13:15:34','2022-03-03 13:15:34'),(96622,284,'Rangamati','783339',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96623,284,'Ratiadaha','783334',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96624,284,'Ravatari','783127',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96625,284,'Rupsi','783331',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96626,284,'Sahebganj Naicherkuti','783331',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96627,284,'Salkocha','783348',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96628,284,'Salmara South','783127',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96629,284,'Sapatgram','783337',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96630,284,'Sarkarergaon','783127',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96631,284,'Satrasal','783335',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96632,284,'Sidalsati','783383',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96633,284,'Silairpar','783331',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96634,284,'Silgara','783348',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96635,284,'Simlabari','783371',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96636,284,'Simlabari','783330',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96637,284,'Sonahat','783334',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96638,284,'South Geramari','783331',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96639,284,'South Jhapsabari','783335',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96640,284,'Suapata','783348',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96641,284,'Sukchar (Dhubri)','783128',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96642,284,'Tiamari','783331',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96643,284,'Tilapara','783348',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96644,284,'Tistarpar','783324',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96645,284,'Tokrerchara','783334',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96646,284,'Tumni','783127',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96647,285,'Adarsha Deurigaon','785676',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96648,285,'Aghunibari','786613',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96649,285,'Alimur','786101',1,0,'2022-03-03 13:15:35','2022-03-03 13:15:35'),(96650,285,'Anandapara','786692',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96651,285,'Ashabam','786621',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96652,285,'Assam Medical College','786002',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96653,285,'Bachapathar','786101',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96654,285,'Bairagimath','786003',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96655,285,'Baji Pohumara','786613',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96656,285,'Balai Nagaon','785676',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96657,285,'Balaibari','786007',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96658,285,'Baligaon','785676',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96659,285,'Balijan North Te','786184',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96660,285,'Balimora','786610',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96661,285,'Bam Kolakhowa','786007',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96662,285,'Bamunbari','786613',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96663,285,'Bamunibill','786610',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96664,285,'Banipur','786003',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96665,285,'Barbam','786611',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96666,285,'Barbaruah','786007',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96667,285,'Barpathar','786004',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96668,285,'Barpathar Gaon','785676',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96669,285,'Behating Tiniali','786004',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96670,285,'Bhadoi Pachali','786191',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96671,285,'Bhajoni','786103',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96672,285,'Bhogamurgaon','785676',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96673,285,'Bhurburi','786003',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96674,285,'Bismile','786184',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96675,285,'Bogadat','786612',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96676,285,'Bogibil','786004',1,0,'2022-03-03 13:15:36','2022-03-03 13:15:36'),(96677,285,'Bokul','786010',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96678,285,'Bokuloni Chariali','786191',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96679,285,'Borabhayapuri','786103',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96680,285,'Borbamgaon','786610',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96681,285,'Borkhermia','786621',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96682,285,'Borpathar','786613',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96683,285,'Buri Khowang','785675',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96684,285,'Central Revenue Building','786003',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96685,285,'Chabua Air Field','786102',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96686,285,'Chabua','786184',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96687,285,'Chaharikata','785676',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96688,285,'Chaulkhowa','786004',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96689,285,'Chenibill Chungipathar','786611',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96690,285,'Chetia Gaon','786184',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96691,285,'Chiringhula','786010',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96692,285,'Chowkidingee','786003',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96693,285,'Dangopara Chariali','786611',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96694,285,'Desam','786610',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96695,285,'Deurigaon','786007',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96696,285,'Dhamalgaon','786004',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96697,285,'Dhaman','786610',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96698,285,'Dhemechi','785675',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96699,285,'Dhuapathar','786611',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96700,285,'Dibru Amguri','786610',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96701,285,'Dibrugarh H.O','786001',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96702,285,'Dibrugarh Polytechnic','786010',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96703,285,'Dibrugarh University','786004',1,0,'2022-03-03 13:15:37','2022-03-03 13:15:37'),(96704,285,'Dighalia','786101',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96705,285,'Dighaliagaon','786007',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96706,285,'Dihing Hola','786101',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96707,285,'Dihing Kinar','786610',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96708,285,'Dihingia Gaon','785675',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96709,285,'Dikari Morang Gaon','785675',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96710,285,'Dikhari Kinar Gaon','785675',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96711,285,'Dikom','786101',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96712,285,'Diksam Ouphulia','786613',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96713,285,'Dillibari','786103',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96714,285,'Dinjoy','786184',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96715,285,'Dirai Te','786611',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96716,285,'Domur Dolong','786613',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96717,285,'Duliajan','786602',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96718,285,'Erameshlow Gaon','785676',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96719,285,'Fakialgaon','786610',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96720,285,'Garbandhi Bamunpukhuri','786613',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96721,285,'Garguri','786612',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96722,285,'Garpara','786101',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96723,285,'Garpthar','786613',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96724,285,'Garudharia','786007',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96725,285,'Ghinai','786621',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96726,285,'Ghuguloni Ahumgaon','785675',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96727,285,'Gohaingaon','786007',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96728,285,'Gojpuria','786610',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96729,285,'Goroimari Gaon','785676',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96730,285,'Gozpuria','785675',1,0,'2022-03-03 13:15:38','2022-03-03 13:15:38'),(96731,285,'Graham Bazar','786001',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96732,285,'Haladhibari','785676',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96733,285,'Harabari','786012',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96734,285,'Harak Pathar','786003',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96735,285,'Hatiali Siding','786184',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96736,285,'Hatibondha','786103',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96737,285,'Hatkhula','786010',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96738,285,'Hazelbank','786101',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96739,285,'Hiloidhari','786002',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96740,285,'Itakhuli','786007',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96741,285,'Jagoloni Grant','786004',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96742,285,'Jalan Nagar','786005',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96743,285,'Jaloni Dibruduar','786602',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96744,285,'Jamirah','786004',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96745,285,'Jeypore Mobile','786614',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96746,285,'Jeypore','786614',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96747,285,'Jokai','786003',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96748,285,'Jokai Bongaon','786003',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96749,285,'Kachari Pathar','786602',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96750,285,'Kadamoni','786001',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96751,285,'Kalakhowa Chariali','786007',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96752,285,'Kamargaon','786614',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96753,285,'Kamini Tea Estate','786191',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96754,285,'Kasulugaon','786612',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96755,285,'Kathalguri','785675',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96756,285,'Kathalguri','786602',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96757,285,'Kekuri Sonowal','786613',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96758,285,'Kendriya  Vidyalaya','786602',1,0,'2022-03-03 13:15:39','2022-03-03 13:15:39'),(96759,285,'Kenduguri Te','786611',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96760,285,'Khaliamari','786001',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96761,285,'Khamti Ghat','786003',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96762,285,'Khania Gaon','786003',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96763,285,'Khowang Chariali','785676',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96764,285,'Khowang Ghat','785676',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96765,285,'Khowang','785675',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96766,285,'Koliapani','786610',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96767,285,'Kolowlowa','785676',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96768,285,'Konwar Handique Gaon','786008',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96769,285,'Konwarigaon','786610',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96770,285,'Konwaripathar','786010',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96771,285,'Kotoha','785676',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96772,285,'Krisipam Nigam','785675',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96773,285,'Kumar Gaon','786008',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96774,285,'Lachit Nagar','786611',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96775,285,'Lahoal','786010',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96776,285,'Lalmati Gaon','786007',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96777,285,'Lengeri Bazar','786613',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96778,285,'Lengrai','786103',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96779,285,'Lepetkata','786006',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96780,285,'Lezai','786007',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96781,285,'Lilapur','786602',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96782,285,'Lukumai','785675',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96783,285,'Mahkhowa','786611',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96784,285,'Mahmora Ali Kinar','786621',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96785,285,'Mahmora','786101',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96786,285,'Majbam Chariali','785675',1,0,'2022-03-03 13:15:40','2022-03-03 13:15:40'),(96787,285,'Mancotta','786003',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96788,285,'Mathawani','786610',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96789,285,'Matiakhana','786184',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96790,285,'Medela','786007',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96791,285,'Melengial Gaon','786010',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96792,285,'Moderkhat','786101',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96793,285,'Mohanaghat','786008',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96794,285,'Mohanbari Air Field','786012',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96795,285,'Na Deoghoria','786103',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96796,285,'Nachani','786613',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96797,285,'Nadua','786101',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96798,285,'Naga Ghuli Kanaigaon','786012',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96799,285,'Nagajan','786191',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96800,285,'Nagargaon','785676',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96801,285,'Nahahpara Barbil','786613',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96802,285,'Naharkatia','786610',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96803,285,'Nahazhar','785675',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96804,285,'Nakhat Sonowal Gaon','785676',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96805,285,'Naliapool','786001',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96806,285,'Namrup','786621',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96807,285,'Namrup Thermal Power Station','786622',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96808,285,'Naoholia','786191',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96809,285,'Nemupathar','786613',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96810,285,'Nigam','786621',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96811,285,'Nilmoni Te','786612',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96812,285,'Nirmaligaon','786003',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96813,285,'Niz Bhekulajan','786103',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96814,285,'Oakland','786101',1,0,'2022-03-03 13:15:41','2022-03-03 13:15:41'),(96815,285,'Ouguri','786612',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96816,285,'Ouphulia Chariali','786613',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96817,285,'Padumoni Gaon No 1','785676',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96818,285,'Pakharijania','786184',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96819,285,'Pan Dhua Tiniali','786103',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96820,285,'Panchali','786001',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96821,285,'Parbatpur','786623',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96822,285,'Pathalibam','785675',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96823,285,'Phukanarkhat','786101',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96824,285,'Pithaguti','786611',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96825,285,'Pulunga','786184',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96826,285,'Purnananda Road','786003',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96827,285,'Puthahula','786010',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96828,285,'Raja Ali','786602',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96829,285,'Raja Bheta','786008',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96830,285,'Rajgarh (Dibrugarh)','786611',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96831,285,'Rang Changi','786184',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96832,285,'Rangalipathar','786610',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96833,285,'Rangchali','785675',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96834,285,'Ratanpur','786003',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96835,285,'Ratanpur','786612',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96836,285,'Romai Te','786010',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96837,285,'Salmari','786610',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96838,285,'Santipara','786001',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96839,285,'Sarbodaya','786010',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96840,285,'Sasoni','786610',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96841,285,'Sechowapukhuri','785675',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96842,285,'Sessa','786003',1,0,'2022-03-03 13:15:42','2022-03-03 13:15:42'),(96843,285,'Sessughat','785676',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96844,285,'Silgrant','786621',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96845,285,'Silputa','785676',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96846,285,'Sisumari Barpathar','786612',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96847,285,'Sologuri','786613',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96848,285,'Tarajan','785675',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96849,285,'Tengakhat','786103',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96850,285,'Thengal','785675',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96851,285,'Tiloinagar','785675',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96852,285,'Timonagaon','786010',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96853,285,'Tingkhong Dighalia','786008',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96854,285,'Tingkhong','786612',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96855,285,'Tingrai Chariali','786602',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96856,285,'Tiniali Tea Estate','786610',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96857,285,'Tinthengia','785675',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96858,285,'Tipam','786614',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96859,285,'Tipling Bhadoi Gaon','786610',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96860,285,'Ushapur','786614',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96861,285,'Zutlibari','786191',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96862,285,'Kanjikhowa','786183',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96863,285,'Mulukgaon','786189',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96864,286,'Agia','783120',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96865,286,'Ambari','783123',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96866,286,'Ambari Bazar','783129',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96867,286,'Ambuk','783123',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96868,286,'Amjonga','783124',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96869,286,'Aolatoli','783129',1,0,'2022-03-03 13:15:43','2022-03-03 13:15:43'),(96870,286,'Athiabari','783130',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96871,286,'Badahapur','783120',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96872,286,'Bagdoba','783123',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96873,286,'Baguan','783129',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96874,286,'Bahati','783125',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96875,286,'Baida','783120',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96876,286,'Bakaitari','783125',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96877,286,'Baladmari','783121',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96878,286,'Baladmarirchar','783101',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96879,286,'Balarbhita','783129',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96880,286,'Balbala Kalapani','783120',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96881,286,'Bandarshi','783124',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96882,286,'Barbhita','783101',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96883,286,'Bardamal','783120',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96884,286,'Barjhora','783120',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96885,286,'Bashbari','783129',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96886,286,'Beserkona','783129',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96887,286,'Bhalukdubi','783101',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96888,286,'Chakla','783125',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96889,286,'Chekowary','783123',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96890,286,'Chotipara','783126',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96891,286,'Chotomatia','783126',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96892,286,'Chunari','783129',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96893,286,'Dahela','783125',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96894,286,'Dakurbhita','783101',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96895,286,'Dalgoma','783125',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96896,286,'Damra','783122',1,0,'2022-03-03 13:15:44','2022-03-03 13:15:44'),(96897,286,'Darakh','783124',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96898,286,'Dariduri','783101',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96899,286,'Darragiri','783134',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96900,286,'Depalsung','783120',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96901,286,'Dhaigaon','783126',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96902,286,'Dhamer Reserve','783129',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96903,286,'Dhanubhanga','783130',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96904,286,'Dharai','783132',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96905,286,'Dhupdhara','783123',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96906,286,'Dighali','783123',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96907,286,'Dubapara','783101',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96908,286,'Dudhnoi','783124',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96909,286,'Dwarka','783120',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96910,286,'Fetangapara','783129',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96911,286,'Gaurnagar','783132',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96912,286,'Goalpara','783101',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96913,286,'Gossaibari','783125',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96914,286,'Govindapur','783101',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96915,286,'Harimura','783126',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96916,286,'Hashdoba','783129',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96917,286,'Jaleswar','783132',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96918,286,'Joybhum','783129',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96919,286,'Joypur Bazar','783129',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96920,286,'Joyramkuchi','783129',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96921,286,'Jurigaon','783120',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96922,286,'Kachadal','783134',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96923,286,'Kahibari','783130',1,0,'2022-03-03 13:15:45','2022-03-03 13:15:45'),(96924,286,'Kalyanpur','783101',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96925,286,'Katarihara','783132',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96926,286,'Khardang','783126',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96927,286,'Kharmuza','783101',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96928,286,'Khusdhowa','783124',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96929,286,'Kothakuthi','783123',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96930,286,'Krishnai','783126',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96931,286,'Kukurkata','783126',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96932,286,'Lakhipur (Goalpara)','783129',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96933,286,'Lalabari','783126',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96934,286,'Lela','783124',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96935,286,'Maladhara','783120',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96936,286,'Manupara','783124',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96937,286,'Markula','783120',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96938,286,'Matia Bazar','783125',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96939,286,'Matia','783125',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96940,286,'Meserbhita','783129',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96941,286,'Misilkhowa','783126',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96942,286,'Mornai','783101',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96943,286,'Nidanpur','783129',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96944,286,'Nishangram','783122',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96945,286,'Panisali','783129',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96946,286,'Patpara','783130',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96947,286,'Rajapara','783133',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96948,286,'Rajmita Pantai','783129',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96949,286,'Rakhasini','783101',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96950,286,'Ramharirchar','783101',1,0,'2022-03-03 13:15:46','2022-03-03 13:15:46'),(96951,286,'Rangjuli','783130',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96952,286,'Rowkhowa','783129',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96953,286,'Salpara','783123',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96954,286,'Sesapani','783134',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96955,286,'Simlabari','783101',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96956,286,'Simlitola','783130',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96957,286,'Suarmari','783120',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96958,286,'Sutarpara','783125',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96959,286,'Takimari','783129',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96960,286,'Tiplai','783130',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96961,286,'Tisimpur','783120',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96962,286,'Tukura','783126',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96963,286,'Tulsibari','783132',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96964,286,'Upartala','783124',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96965,286,'Zira','783126',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96966,286,'Chibonga','783124',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96967,286,'Damas','783122',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96968,286,'Mallengkona','783123',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96969,286,'Manikganj','783122',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96970,286,'Mendima','783122',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96971,286,'Rajasimla','783134',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96972,286,'Shiliuk','783124',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96973,286,'Tingba','783123',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96974,287,'Adharsatra','785702',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96975,287,'Ahatguri','785614',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96976,287,'Alengmuria','785622',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96977,287,'Amgurinabhanga','785614',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96978,287,'Athabari','785625',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96979,287,'Badulipaar','785611',1,0,'2022-03-03 13:15:47','2022-03-03 13:15:47'),(96980,287,'Bahguri','785614',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(96981,287,'Balichapori','785104',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(96982,287,'Balijan Aamtenga','785612',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(96983,287,'Bamborahi','785702',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(96984,287,'Barpathar','785602',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(96985,287,'Barpatharua','785702',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(96986,287,'Bartingnaochalia','785626',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(96987,287,'Barua Gaon','785603',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(96988,287,'Baruabamungaon','785618',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(96989,287,'Batiporia','785618',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(96990,287,'Behora','785615',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(96991,287,'Bengenakhowa','785702',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(96992,287,'Betioni','785622',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(96993,287,'Bhojo','785691',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(96994,287,'Bholaguri','785611',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(96995,287,'Bilgaon','785602',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(96996,287,'Bokakhat Rajabari','785612',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(96997,287,'Bokakhat','785612',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(96998,287,'Bokalaigaon','785625',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(96999,287,'Bokial','785613',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(97000,287,'Bongalgaon','785614',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(97001,287,'Bongaon','785611',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(97002,287,'Bonkowal','785619',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(97003,287,'Borjan','785625',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(97004,287,'Borjan','785610',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(97005,287,'Borjuri','785612',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(97006,287,'Chinatoli','785622',1,0,'2022-03-03 13:15:48','2022-03-03 13:15:48'),(97007,287,'Chowdangpathar','785705',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97008,287,'Chukiapather','785601',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97009,287,'Chungajan','785601',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97010,287,'Cinakon Chariali','785615',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97011,287,'Dabidubi','785611',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97012,287,'Dahdhara','785614',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97013,287,'Dani Chapori','785614',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97014,287,'Dapathar','785602',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97015,287,'Dergaon Chariali','785614',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97016,287,'Dergaon','785614',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97017,287,'Dhansiri Muich','785612',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97018,287,'Dhekial','785622',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97019,287,'Dhodang','785615',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97020,287,'Dhodang Gaon','785618',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97021,287,'Dholaguri','785613',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97022,287,'Dhupguri','785601',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97023,287,'Diffolu T.E.','785612',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97024,287,'Dihing Than','785671',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97025,287,'Dofalada','785612',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97026,287,'Doigrung','785702',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97027,287,'Dolamara','785612',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97028,287,'Doria T.E.','785622',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97029,287,'Dubialgaon','785618',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97030,287,'Dusutimukh','785611',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97031,287,'Falangani','785702',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97032,287,'Fetagaon','785703',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97033,287,'Furkating','785610',1,0,'2022-03-03 13:15:49','2022-03-03 13:15:49'),(97034,287,'Ganakpukhuri','785622',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97035,287,'Garumora','785703',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97036,287,'Ghiladhari','785603',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97037,287,'Goalgaon Baliati','785703',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97038,287,'Golaghat H.O','785621',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97039,287,'Goriajan','785611',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97040,287,'Goriatika Barpathar','785619',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97041,287,'Habichukia','785603',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97042,287,'Halmira Te','785702',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97043,287,'Hatikhowa','785626',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97044,287,'Hatikhuli','785609',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97045,287,'Howtoly','785702',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97046,287,'Hukurakhat','785626',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97047,287,'Jamuguri','785603',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97048,287,'Joraguri','785614',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97049,287,'Kacharihat','785702',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97050,287,'Kachupathar','785619',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97051,287,'Kakachang','785612',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97052,287,'Kaliagaon','785614',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97053,287,'Kamarbandha Ali','785625',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97054,287,'Kamargaon (Golaghat)','785619',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97055,287,'Kamargaonchariali','785614',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97056,287,'Kanaighat','785699',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97057,287,'Karuabahi Satra','785615',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97058,287,'Kathalguri','785622',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97059,287,'Kaziranga','785609',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97060,287,'Kaziranga National Park','785609',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97061,287,'Khangia','785614',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97062,287,'Khotia Toli','785612',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97063,287,'Khumtai','785619',1,0,'2022-03-03 13:15:50','2022-03-03 13:15:50'),(97064,287,'Kordoiguri','785602',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97065,287,'Kuruabahi Tiniali','785615',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97066,287,'Lakhibari Tiniali','785603',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97067,287,'Lakhowjaan Tiniali','785612',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97068,287,'Letekujaan','785613',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97069,287,'Madhya Ahatguri','785614',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97070,287,'Maheema','785626',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97071,287,'Marangi','785702',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97072,287,'Marangi Chariali','785702',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97073,287,'Melamora','785702',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97074,287,'Mirigaon','785602',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97075,287,'Missamora','785618',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97076,287,'Missionpatty','785702',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97077,287,'Mohoramukh','785619',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97078,287,'Mohpara','785609',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97079,287,'Moluahabi','785622',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97080,287,'Moukhowa','785702',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97081,287,'Mudoigaon','785614',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97082,287,'Murphulani','785702',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97083,287,'Nabheta','785622',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97084,287,'Nagura Grant','785603',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97085,287,'Naharani','785618',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97086,287,'Naharjaan','785612',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97087,287,'Nahphani','785614',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97088,287,'Nakkati','785611',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97089,287,'Naladhibari','785618',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97090,287,'Namkhatoal','785626',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97091,287,'Naojan','785601',1,0,'2022-03-03 13:15:51','2022-03-03 13:15:51'),(97092,287,'Napamuakamargaon','785625',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97093,287,'Negheriting','785703',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97094,287,'Numaligarh Refinery Project','785699',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97095,287,'Numaligarh','785615',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97096,287,'Oating','785603',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97097,287,'Padumani','785702',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97098,287,'Panjan Sarupathr','785601',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97099,287,'Premhara','785602',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97100,287,'Ptc Dergaon','785703',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97101,287,'Pub Khumtai','785622',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97102,287,'Pulibar Bidyapith','785702',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97103,287,'Rahdhala','785622',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97104,287,'Rajapukhuri','785601',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97105,287,'Rangamati','785614',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97106,287,'Rongorahat','785611',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97107,287,'Salikihaat','785625',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97108,287,'Sarupathar','785601',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97109,287,'Siljuri','785612',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97110,287,'Sitalpather','785703',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97111,287,'Sockolatinga','785703',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97112,287,'Sologuri Kachari','785703',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97113,287,'Tengabari','785601',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97114,287,'Ultajaan','785702',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97115,287,'Upper Lengtha','785602',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97116,287,'Uriamghat','785601',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97117,288,'Alexanderpur','788161',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97118,288,'Algapur PT II','788150',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97119,288,'Algapur PT V','788150',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97120,288,'Amala','788164',1,0,'2022-03-03 13:15:52','2022-03-03 13:15:52'),(97121,288,'Anilgarh','788156',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97122,288,'Anipur','788734',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97123,288,'Appin','788161',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97124,288,'Aynakhal Bazar','788164',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97125,288,'Bakrihawar PT III','788801',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97126,288,'Baldabaldi','788162',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97127,288,'Baliura','788155',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97128,288,'Bansbari PT II','788152',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97129,288,'Banskhantilla','788736',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97130,288,'Bar Hailakandi','788155',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97131,288,'Barband','788164',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97132,288,'Barjalenga','788117',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97133,288,'Barsangam','788117',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97134,288,'Baruala','788734',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97135,288,'Bhairabnagar','788152',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97136,288,'Bhatirkupa','788152',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97137,288,'Bidyanagar','788734',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97138,288,'Bishnunagar East','788152',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97139,288,'Boalipar Bazar','788155',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97140,288,'Bowarghat','788164',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97141,288,'Brojapur','788155',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97142,288,'Brojendrapur','788156',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97143,288,'Burnibrease T E','788801',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97144,288,'Chamtilla','788736',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97145,288,'Chandanpur West','788152',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97146,288,'Chandipur','788150',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97147,288,'Chandrapur PT II','788163',1,0,'2022-03-03 13:15:53','2022-03-03 13:15:53'),(97148,288,'Chantilla','788736',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97149,288,'Cheragh','788737',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97150,288,'Chibitabichia','788150',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97151,288,'Chiparsangam','788801',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97152,288,'Dalgram PT II','788735',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97153,288,'Damcherra Bagan','788736',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97154,288,'Dargarband Bazar','788156',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97155,288,'Dhalibeel PT II','788734',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97156,288,'Dharirghat Grant','788165',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97157,288,'Dholai Malai','788161',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97158,288,'Dholai South','788161',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97159,288,'Dholai T E','788165',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97160,288,'Dinanathpur PT I','788161',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97161,288,'Dullabcherra Bazar','788736',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97162,288,'Dullabcherra','788736',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97163,288,'Fenairbond','788737',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97164,288,'Fulbari','788802',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97165,288,'Gamaria','788156',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97166,288,'Gangpar Dhumkar','788152',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97167,288,'Ghambhira Basti','788737',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97168,288,'Gharmura Bazar','788162',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97169,288,'Gharmura Bus Stand','788162',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97170,288,'Hailakandi Bazar','788152',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97171,288,'Hailakandi College','788152',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97172,288,'Hailakandi East','788152',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97173,288,'Harishnagar','788161',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97174,288,'Jaffirband','788160',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97175,288,'Jamira Bazar','788162',1,0,'2022-03-03 13:15:54','2022-03-03 13:15:54'),(97176,288,'Jankibazar','788801',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97177,288,'Kacharitol','788163',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97178,288,'Kalamagura','788737',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97179,288,'Kalibari Bazar','788150',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97180,288,'Kalinagar','788801',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97181,288,'Kanchanpur PT II','788152',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97182,288,'Karicherra Bazar','788165',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97183,288,'Katagaon','788160',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97184,288,'Katagaon','788168',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97185,288,'Katlacherra Bazar','788161',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97186,288,'Katlacherra','788161',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97187,288,'Kayah T E','788164',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97188,288,'Kuchila Bazar','788155',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97189,288,'Kukicherra','788165',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97190,288,'Lakhinagar T E','788164',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97191,288,'Lakhirbond PT II','788155',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97192,288,'Lakshmisahar','788152',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97193,288,'Lala Deb Block','788164',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97194,288,'Lala','788163',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97195,288,'Lalamukh','788163',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97196,288,'Lalpani','788165',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97197,288,'Leelachela','788734',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97198,288,'Madanmohan','788152',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97199,288,'Madaripar','788163',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97200,288,'Maniknagar','788164',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97201,288,'Manipur Bagan','788165',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97202,288,'Matijuri','788155',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97203,288,'Matirgram','788150',1,0,'2022-03-03 13:15:55','2022-03-03 13:15:55'),(97204,288,'Mirirgool','788168',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97205,288,'Mohanpur','788150',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97206,288,'Monacherra','788164',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97207,288,'Muktaranpur','788156',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97208,288,'Muliala','788735',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97209,288,'Narainpur','788152',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97210,288,'Narainpur North','788801',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97211,288,'Nayabeel','788117',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97212,288,'Nimaichandpur PT II','788168',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97213,288,'Nimaichandpur PT II','788160',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97214,288,'Nischintapur','788164',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97215,288,'Nitainagar','788155',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97216,288,'Nityanandapur','788168',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97217,288,'Nunapani T E','788117',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97218,288,'Olivacherra','788737',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97219,288,'Paikan','788155',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97220,288,'Panchgram','788802',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97221,288,'Pechaala','788734',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97222,288,'Polarpar','788801',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97223,288,'Purba Harinagar','788734',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97224,288,'Purba Sonapur','788155',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97225,288,'Rajyeswarpur','788163',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97226,288,'Rajyeswarpur','788168',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97227,288,'Rakhalbasti','788152',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97228,288,'Ramnathpur','788162',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97229,288,'Rangabawk','788161',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97230,288,'Rangauti','788155',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97231,288,'Rangauti PT II','788155',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97232,288,'Ratabari','788735',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97233,288,'Ratakandi','788152',1,0,'2022-03-03 13:15:56','2022-03-03 13:15:56'),(97234,288,'Ratanpur Road','788155',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97235,288,'Rongpur Boalipar','788161',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97236,288,'Rongpur North','788155',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97237,288,'Rongpur South','788163',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97238,288,'Rosekandi','788117',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97239,288,'Rupacherra Basti','788161',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97240,288,'Sahabad','788163',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97241,288,'Sahapur','788117',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97242,288,'Saidband PT II','788150',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97243,288,'Salchapra','788801',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97244,288,'Samarikona','788155',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97245,288,'Sarbanandapur','788163',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97246,288,'Sarbantilla','788117',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97247,288,'Sialtek','788802',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97248,288,'Sibbari Krishna Nagar','788734',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97249,288,'Singala','788164',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97250,288,'Singlacherra Bazar','788736',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97251,288,'South Sonapur','788737',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97252,288,'Sudarshanpur','788160',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97253,288,'Sultanicherra','788162',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97254,288,'Tantoo Maniknagar','788163',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97255,288,'Taranathpur','788117',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97256,288,'Telkatta','788161',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97257,288,'Tongibari','788735',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97258,288,'Umednagar','788163',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97259,288,'Uzankupa','788152',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97260,288,'Vernerpur','788163',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97261,288,'Vetarband','788736',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97262,288,'Vichingcha','788155',1,0,'2022-03-03 13:15:57','2022-03-03 13:15:57'),(97263,289,'Alengmora','785108',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97264,289,'Assam Agriculture University','785013',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97265,289,'Auniati Satra','785106',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97266,289,'Baghmora','785101',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97267,289,'Bahana','785101',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97268,289,'Bahana Tiniali','785101',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97269,289,'Bahoni','785633',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97270,289,'Bahphola','785108',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97271,289,'Bailunggaon','785107',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97272,289,'Bajalani Kohar','785009',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97273,289,'Balijan Te','785635',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97274,289,'Bandor Chaliha','785633',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97275,289,'Barbheta','785004',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97276,289,'Barchapori Khakanguri','785108',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97277,289,'Bargayan','785104',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97278,289,'Baruajan','785630',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97279,289,'Bejorchiga','785112',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97280,289,'Bengenati Satra','785106',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97281,289,'Bhakatiduar','785110',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97282,289,'Bhogdaimukh','785001',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97283,289,'Bhuramora','785104',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97284,289,'Birina Shayak','785632',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97285,289,'Bogargaon','785632',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97286,289,'Boloma','785112',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97287,289,'Bongalpukhuri','785014',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97288,289,'Borhaam Kathani','785006',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97289,289,'Borholla','785631',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97290,289,'Borkhelia Goon','785101',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97291,289,'Bormathauri','785112',1,0,'2022-03-03 13:15:58','2022-03-03 13:15:58'),(97292,289,'Bormukoli','785703',1,0,'2022-03-03 13:15:59','2022-03-03 13:15:59'),(97293,289,'Borpomua Lakhimi','785105',1,0,'2022-03-03 13:15:59','2022-03-03 13:15:59'),(97294,289,'Botiamari','785106',1,0,'2022-03-03 13:15:59','2022-03-03 13:15:59'),(97295,289,'Chalihagaon','785004',1,0,'2022-03-03 13:15:59','2022-03-03 13:15:59'),(97296,289,'Chamaguri Kamalabari','785110',1,0,'2022-03-03 13:15:59','2022-03-03 13:15:59'),(97297,289,'Chamahiati','785105',1,0,'2022-03-03 13:15:59','2022-03-03 13:15:59'),(97298,289,'Charaibahi','785616',1,0,'2022-03-03 13:15:59','2022-03-03 13:15:59'),(97299,289,'Charighoria','785108',1,0,'2022-03-03 13:15:59','2022-03-03 13:15:59'),(97300,289,'Charingia','785006',1,0,'2022-03-03 13:15:59','2022-03-03 13:15:59'),(97301,289,'Chengeli Gaon','785010',1,0,'2022-03-03 13:15:59','2022-03-03 13:15:59'),(97302,289,'Chenijaan','785010',1,0,'2022-03-03 13:15:59','2022-03-03 13:15:59'),(97303,289,'Chitardarchuk','785104',1,0,'2022-03-03 13:15:59','2022-03-03 13:15:59'),(97304,289,'Chowtang','785101',1,0,'2022-03-03 13:15:59','2022-03-03 13:15:59'),(97305,289,'Chukial','785632',1,0,'2022-03-03 13:15:59','2022-03-03 13:15:59'),(97306,289,'Chumaimari Missing Gaon','785102',1,0,'2022-03-03 13:15:59','2022-03-03 13:15:59'),(97307,289,'Chungi','785616',1,0,'2022-03-03 13:15:59','2022-03-03 13:15:59'),(97308,289,'Chungi Lahing','785635',1,0,'2022-03-03 13:15:59','2022-03-03 13:15:59'),(97309,289,'Cinnamara','785008',1,0,'2022-03-03 13:15:59','2022-03-03 13:15:59'),(97310,289,'Dahotia','785001',1,0,'2022-03-03 13:15:59','2022-03-03 13:15:59'),(97311,289,'Dakhin Pat Satra','785102',1,0,'2022-03-03 13:15:59','2022-03-03 13:15:59'),(97312,289,'Deogharia','785630',1,0,'2022-03-03 13:15:59','2022-03-03 13:15:59'),(97313,289,'Desoinagar','785015',1,0,'2022-03-03 13:15:59','2022-03-03 13:15:59'),(97314,289,'Dewangaon','785107',1,0,'2022-03-03 13:15:59','2022-03-03 13:15:59'),(97315,289,'Dhalajan','785616',1,0,'2022-03-03 13:15:59','2022-03-03 13:15:59'),(97316,289,'Dhalarsatra','785001',1,0,'2022-03-03 13:15:59','2022-03-03 13:15:59'),(97317,289,'Dhekiakhowa','785700',1,0,'2022-03-03 13:15:59','2022-03-03 13:15:59'),(97318,289,'Dhekorgorah','785015',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97319,289,'Dihingia','785630',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97320,289,'Doklongia','785634',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97321,289,'Dulakhoria','785112',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97322,289,'Fakalapather','785111',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97323,289,'Fechual','785635',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97324,289,'Fulbari','785630',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97325,289,'Gabharu Konwargaon','785636',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97326,289,'Garali','785001',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97327,289,'Garmursatra','785104',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97328,289,'Gatanga','785616',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97329,289,'Gayengaon','785110',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97330,289,'Gezera','785110',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97331,289,'Goalgaon','785104',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97332,289,'Gohainbari','785635',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97333,289,'Gohaingaon','785601',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97334,289,'Gojpuria','785008',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97335,289,'Gorajan','785631',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97336,289,'Gorokhiadol','785015',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97337,289,'Halowapathar','785636',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97338,289,'Hatigarh','785007',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97339,289,'Hatigarh Balichapori','785101',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97340,289,'Hazarikagaon','785104',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97341,289,'Hemlai','785636',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97342,289,'Hulalbari','785700',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97343,289,'Ikarani','785631',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97344,289,'Itakhuli','785007',1,0,'2022-03-03 13:16:00','2022-03-03 13:16:00'),(97345,289,'Jakharia','785112',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97346,289,'Jalukonibari','785630',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97347,289,'Japichijia','785636',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97348,289,'Jatakia','785666',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97349,289,'Jengraichapori','785105',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97350,289,'Jengraikumarbari','785105',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97351,289,'Jengraimukh','785105',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97352,289,'Jhanjimukh','785112',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97353,289,'Jogduar','785112',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97354,289,'Jogduar Sonari','785112',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97355,289,'Jokaibowa','785104',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97356,289,'Jorhat Engg College','785007',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97357,289,'Jorhat H.O','785001',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97358,289,'Jorhat Reserch Lab','785006',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97359,289,'Kachagoral','785010',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97360,289,'Kachamari','785616',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97361,289,'Kachukhat','785633',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97362,289,'Kakajan Duliagaon','785107',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97363,289,'Kakajan','785107',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97364,289,'Kakilamukh','785108',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97365,289,'Kakodonga Bekajan','785631',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97366,289,'Kalakhowa','785010',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97367,289,'Kamalabari','785106',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97368,289,'Kamarkhatowal','785107',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97369,289,'Karatipar','785104',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97370,289,'Karki Chuk Missing Gaon','785105',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97371,289,'Khatisona','785635',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97372,289,'Khorikotia','785633',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97373,289,'Koliani','785108',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97374,289,'Koliapani','785112',1,0,'2022-03-03 13:16:01','2022-03-03 13:16:01'),(97375,289,'Komalpur','785104',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97376,289,'Konwaripukhuri','785001',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97377,289,'Kopradhara','785700',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97378,289,'Korokatoly','785015',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97379,289,'Koronga','785008',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97380,289,'Kukurachowa','785636',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97381,289,'Kulamua Missing','785104',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97382,289,'Lahdoigarh Chariali','785700',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97383,289,'Lahinggaon','785635',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97384,289,'Lakhibari','785635',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97385,289,'Lichubari','785008',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97386,289,'Macharhat','785001',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97387,289,'Madhapur','785630',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97388,289,'Madhupur','785104',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97389,289,'Majkuri','785112',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97390,289,'Majnoi','785636',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97391,289,'Majorchapori','785104',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97392,289,'Majordeori','785105',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97393,289,'Majulibongaon','785110',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97394,289,'Malowpathar','785108',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97395,289,'Mariani','785634',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97396,289,'Melamati','785632',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97397,289,'Meleng','785634',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97398,289,'Meleng Te','785700',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97399,289,'Melenggrant','785635',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97400,289,'Miligaon Tiniali','785110',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97401,289,'Mirigaon','785631',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97402,289,'Missamora Missing Gaon','785104',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97403,289,'Mogroigaon','785635',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97404,289,'Mohimabari','785631',1,0,'2022-03-03 13:16:02','2022-03-03 13:16:02'),(97405,289,'Mokrong','785631',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97406,289,'Morangaon','785630',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97407,289,'Morituni','785106',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97408,289,'Morongial','785635',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97409,289,'Moutgaon','785101',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97410,289,'Mudoibil','785105',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97411,289,'Mudoijan Tiniali','785112',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97412,289,'Muktinagar','785631',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97413,289,'Murmuria','785704',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97414,289,'Murmuria Missing Gaon','785105',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97415,289,'Na Ali Dhekiajuli','785009',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97416,289,'Nagajanka','785634',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97417,289,'Naginijan','785635',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97418,289,'Nahatia','785108',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97419,289,'Nakachari','785635',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97420,289,'Namchungi','785616',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97421,289,'Namdeori','785108',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97422,289,'Namrupia','785634',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97423,289,'Namsisu','785636',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97424,289,'Neamatighat','785111',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97425,289,'New Bessamora','785110',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97426,289,'Ongc Jorhat','785704',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97427,289,'Ouguri Missing','785112',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97428,289,'Paanjaan Borholla','785631',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97429,289,'Parbatia','785006',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97430,289,'Phulanibari','785104',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97431,289,'Phutuki Chapori','785104',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97432,289,'Pirakota','785107',1,0,'2022-03-03 13:16:03','2022-03-03 13:16:03'),(97433,289,'Pokamura','785004',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97434,289,'Potiagaon','785106',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97435,289,'Potiagaon','785101',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97436,289,'Pub-charigaon','785010',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97437,289,'Pulibor','785006',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97438,289,'Pulikaitoni','785631',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97439,289,'Purana Titabor','785632',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97440,289,'Purani Gohaingaon','785111',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97441,289,'Raidangjuri','785631',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97442,289,'Rajabahar','785631',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97443,289,'Rajabari','785631',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97444,289,'Rajabari','785014',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97445,289,'Rajoi','785107',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97446,289,'Rangachahi Nikinikhowa','785104',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97447,289,'Ratanpur','785110',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97448,289,'Ratanpur Mirigaon','785105',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97449,289,'Rongachahi','785104',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97450,289,'Rongajan','785630',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97451,289,'Rongdoi Chariali','785101',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97452,289,'Salmora','785110',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97453,289,'Satriagaon','785616',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97454,289,'Seleng Lawjan','785636',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97455,289,'Selenghat','785636',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97456,289,'Sodial Kochari Gaon','785630',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97457,289,'Sonowal Kachari','785110',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97458,289,'Sotai','785010',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97459,289,'Sri Ram Bonomali','785105',1,0,'2022-03-03 13:16:04','2022-03-03 13:16:04'),(97460,289,'Sundarpur','785107',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97461,289,'Sycotta','785633',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97462,289,'Taburam Lahon','785104',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97463,289,'Takaruchuk','785108',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97464,289,'Tarajan','785001',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97465,289,'Tekelabari','785616',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97466,289,'Teok Rajabari','785112',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97467,289,'Teok','785112',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97468,289,'Tilikiaam','785006',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97469,289,'Tipomia','785630',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97470,289,'Titabor Mohimabari','785630',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97471,289,'Titabor','785630',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97472,289,'Titabor Tiniali','785630',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97473,289,'Totoya','785106',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97474,289,'Ujani Rajabari','785635',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97475,289,'Ujanitarani','785631',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97476,289,'Urongial','785631',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97477,289,'Uttar Dulia','785112',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97478,290,'Agchia','781128',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97479,290,'Aggumi','781137',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97480,290,'Akadi','781102',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97481,290,'Alikash','781137',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97482,290,'Alupati','781127',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97483,290,'Ambari Fatasil','781025',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97484,290,'Amerigog','781023',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97485,290,'Amgaon','781026',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97486,290,'Amingaon','781031',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97487,290,'Amranga','781014',1,0,'2022-03-03 13:16:05','2022-03-03 13:16:05'),(97488,290,'Amsinggaon E (S -85)','781027',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97489,290,'Amtala','781134',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97490,290,'Assam Engg. Institute','781003',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97491,290,'Assam Sachivalaya','781006',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97492,290,'Assam Tribune','781003',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97493,290,'Azara','781017',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97494,290,'Badlabazar','781127',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97495,290,'Baghdoba','781366',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97496,290,'Bagmarachar','781127',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97497,290,'Bagta','781102',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97498,290,'Baihata Chariali','781381',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97499,290,'Baihata','781380',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97500,290,'Bakalipara','781124',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97501,290,'Balapukhuri','781124',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97502,290,'Balikuchi','781381',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97503,290,'Bamundi','781103',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97504,290,'Bamunigaon (Kamrup)','781141',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97505,290,'Bamunimaidan','781021',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97506,290,'Bangalipara','781364',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97507,290,'Bangaon','781354',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97508,290,'Baniapara','781134',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97509,290,'Baralabari','781101',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97510,290,'Barbaka','781030',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97511,290,'Bardal','781354',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97512,290,'Bardangrikuchi','781366',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97513,290,'Bardekpar','781382',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97514,290,'Bargaon','781104',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97515,290,'Bargaon Khaliha','781135',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97516,290,'Barghuli','781354',1,0,'2022-03-03 13:16:06','2022-03-03 13:16:06'),(97517,290,'Barpalaha','781121',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97518,290,'Barpathar','781364',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97519,290,'Baruajani','781380',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97520,290,'Baruapathar','781136',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97521,290,'Basistha','781029',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97522,290,'Batahidia','781137',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97523,290,'Batarhat','781122',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97524,290,'Beltola','781028',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97525,290,'Betna','781366',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97526,290,'Bezera','781121',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97527,290,'Bhagawatipara','781132',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97528,290,'Bhalukghata','781123',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97529,290,'Bharalumukh','781009',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97530,290,'Bhattaparagaral','781017',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97531,290,'Bhauriabhita','781136',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97532,290,'Bhelkarbazar','781102',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97533,290,'Bhitarduar','781137',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97534,290,'Bhogpur','781366',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97535,290,'Bholebatabari','781364',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97536,290,'Bhomolahati','781121',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97537,290,'Bihapara','781365',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97538,290,'Bihdia','781381',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97539,290,'Bijoynagar','781122',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97540,290,'Binovanagar','781018',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97541,290,'Birpara','781123',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97542,290,'Boko Agchia','781123',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97543,290,'Boko Rajapara','781123',1,0,'2022-03-03 13:16:07','2022-03-03 13:16:07'),(97544,290,'Boko','781123',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97545,290,'Bonda','781026',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97546,290,'Bondapara','781135',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97547,290,'Bongra','781015',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97548,290,'Bongshor','781103',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97549,290,'Borakhat','781124',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97550,290,'Borduar','781120',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97551,290,'Borjhar','781124',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97552,290,'Borni','781102',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97553,290,'Boromboi','781104',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97554,290,'Chamatapathar','782402',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97555,290,'Champaknagar','781124',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97556,290,'Champaparabazar','781136',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97557,290,'Chandrapur Mills','781150',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97558,290,'Chandrapur (Kamrup)','781150',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97559,290,'Changsari','781101',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97560,290,'Chanmaguri','781380',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97561,290,'Chapania','781354',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97562,290,'Chenigaon','781366',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97563,290,'Chenikuthi','781003',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97564,290,'Chhaygaon','781124',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97565,290,'Choudhurykhat','781141',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97566,290,'Collegenagar','781031',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97567,290,'Dadara','781104',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97568,290,'Dagaon','781380',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97569,290,'Dagaon','781133',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97570,290,'Dakhala','781122',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97571,290,'Damalchos','781135',1,0,'2022-03-03 13:16:08','2022-03-03 13:16:08'),(97572,290,'Dampur','781102',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97573,290,'Darkuchi','781376',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97574,290,'Debgotanagar','781011',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97575,290,'Dehaligaon','781122',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97576,290,'Dehangarigaon','781012',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97577,290,'Dekachang','781136',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97578,290,'Deoduar','781101',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97579,290,'Deolkuchi','781354',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97580,290,'Deosunga','781364',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97581,290,'Dharapur','781014',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97582,290,'Dhengargaon','781125',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97583,290,'Dhepargaon','781354',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97584,290,'Dhirenpara','781025',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97585,290,'Dhopguri','782403',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97586,290,'Digaru','782401',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97587,290,'Dihina','781382',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97588,290,'Dispur','781005',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97589,290,'Dobok','781380',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97590,290,'Dopdar','781030',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97591,290,'Dorakahara','781101',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97592,290,'Dumunichowki','781121',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97593,290,'Durapara','781123',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97594,290,'Durungpahar','782403',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97595,290,'Fancy Bazar','781001',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97596,290,'Futuri','781122',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97597,290,'Gamarimura','781135',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97598,290,'Gandhinagar','782403',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97599,290,'Gandhmow','781103',1,0,'2022-03-03 13:16:09','2022-03-03 13:16:09'),(97600,290,'Garchuk','781035',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97601,290,'Gerua','781102',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97602,290,'Ghoramara','781124',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97603,290,'Gohalkona','781123',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97604,290,'Gopalpur','781354',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97605,290,'Gopinathnagar','781016',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97606,290,'Goreswar','781366',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97607,290,'Gosaihat','781125',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97608,290,'Gotanagar','781011',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97609,290,'Gurmow','781366',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97610,290,'Guwahati Airport','781015',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97611,290,'Guwahati G.P.O.','781001',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97612,290,'Guwahati University H.O','781014',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97613,290,'Hablaka','781102',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97614,290,'Hahara','782402',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97615,290,'Hahimbazar','781129',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97616,290,'Hajo','781102',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97617,290,'Halda','781121',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97618,290,'Halogaon','781103',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97619,290,'Hatigaon Chariali','781038',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97620,290,'Hatipara','781137',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97621,290,'Hekra','781127',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97622,290,'Helecha','781382',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97623,290,'Hengrabari','781036',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97624,290,'Hinguli','781380',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97625,290,'I I T','781039',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97626,290,'Indrapur','781032',1,0,'2022-03-03 13:16:10','2022-03-03 13:16:10'),(97627,290,'Jahirpur','781137',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97628,290,'Jalukbari','781013',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97629,290,'Jambari','781141',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97630,290,'Jamlai','781127',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97631,290,'Jamtala','781365',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97632,290,'Japia','781382',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97633,290,'Japorigog','781005',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97634,290,'Jharobari','781122',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97635,290,'Jiakur','781134',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97636,290,'Jogiparapathar','781136',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97637,290,'Kachari Solmari','781354',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97638,290,'Kachumara','781127',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97639,290,'Kahilipara','781019',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97640,290,'Kaimari','781124',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97641,290,'Kalajalchowk','781380',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97642,290,'Kalardia','781127',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97643,290,'Kalatoli','781136',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97644,290,'Kalitakuchi','781102',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97645,290,'Kalubari','781127',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97646,290,'Kamakhya','781010',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97647,290,'Kaniha','781380',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97648,290,'Karora','781381',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97649,290,'Karparbhitha','781366',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97650,290,'Kendua','781121',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97651,290,'Khanapara','781022',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97652,290,'Khapenikuchi','781102',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97653,290,'Kharguli','781004',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97654,290,'Kharikot','781380',1,0,'2022-03-03 13:16:11','2022-03-03 13:16:11'),(97655,290,'Khetri Hardia','781102',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97656,290,'Khetri (Kamrup)','782403',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97657,290,'Kholabandha','781127',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97658,290,'Khudradimu','781382',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97659,290,'Kinangaon','781123',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97660,290,'Kukurmara','781134',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97661,290,'Kulhati','781104',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97662,290,'Kulsirange','781125',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97663,290,'Kumarpara','781009',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97664,290,'Kuwarpur','781102',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97665,290,'Lachitnagar','781007',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97666,290,'Loch','781381',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97667,290,'Loharghat','781120',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97668,290,'Lower Lumpi','781129',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97669,290,'Madhukuchi','781354',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97670,290,'Madhyamkhanda','781030',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97671,290,'Mahajanpara','781366',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97672,290,'Maharipara','781364',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97673,290,'Mahimari','781137',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97674,290,'Mahtoli','781136',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97675,290,'Majirgaon','781128',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97676,290,'Malaybari','782403',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97677,290,'Malibaribazar','781136',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97678,290,'Malibaripathar','781136',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97679,290,'Mandakata','781121',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97680,290,'Mandira','781127',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97681,290,'Maniari Tiniali','781125',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97682,290,'Maranjana','781354',1,0,'2022-03-03 13:16:12','2022-03-03 13:16:12'),(97683,290,'Mataikhar','781120',1,0,'2022-03-03 13:16:13','2022-03-03 13:16:13'),(97684,290,'Mauman Ashram','781123',1,0,'2022-03-03 13:16:13','2022-03-03 13:16:13'),(97685,290,'Mirza','781125',1,0,'2022-03-03 13:16:13','2022-03-03 13:16:13'),(97686,290,'Mlg Rly Hqs','781011',1,0,'2022-03-03 13:16:13','2022-03-03 13:16:13'),(97687,290,'Nagarbera','781127',1,0,'2022-03-03 13:16:13','2022-03-03 13:16:13'),(97688,290,'Nahira','781132',1,0,'2022-03-03 13:16:13','2022-03-03 13:16:13'),(97689,290,'Naitar','781127',1,0,'2022-03-03 13:16:13','2022-03-03 13:16:13'),(97690,290,'Nalapara','781129',1,0,'2022-03-03 13:16:13','2022-03-03 13:16:13'),(97691,290,'Nampara Majarkuri','781102',1,0,'2022-03-03 13:16:13','2022-03-03 13:16:13'),(97692,290,'Narangi','781026',1,0,'2022-03-03 13:16:13','2022-03-03 13:16:13'),(97693,290,'Nartap','782402',1,0,'2022-03-03 13:16:13','2022-03-03 13:16:13'),(97694,290,'Natun Jharobari','781124',1,0,'2022-03-03 13:16:13','2022-03-03 13:16:13'),(97695,290,'Nawkata','781364',1,0,'2022-03-03 13:16:13','2022-03-03 13:16:13'),(97696,290,'Nizdemoria','782403',1,0,'2022-03-03 13:16:13','2022-03-03 13:16:13'),(97697,290,'Nizmanakuchi','781104',1,0,'2022-03-03 13:16:13','2022-03-03 13:16:13'),(97698,290,'Noonmati','781020',1,0,'2022-03-03 13:16:13','2022-03-03 13:16:13'),(97699,290,'North Guwahati','781030',1,0,'2022-03-03 13:16:13','2022-03-03 13:16:13'),(97700,290,'Odalbakra','781034',1,0,'2022-03-03 13:16:13','2022-03-03 13:16:13'),(97701,290,'Pacharia','781104',1,0,'2022-03-03 13:16:13','2022-03-03 13:16:13'),(97702,290,'Pachia','781135',1,0,'2022-03-03 13:16:13','2022-03-03 13:16:13'),(97703,290,'Pachim Dhuligaon','781124',1,0,'2022-03-03 13:16:13','2022-03-03 13:16:13'),(97704,290,'Pachim Samaria','781136',1,0,'2022-03-03 13:16:13','2022-03-03 13:16:13'),(97705,290,'Palahartari','781127',1,0,'2022-03-03 13:16:13','2022-03-03 13:16:13'),(97706,290,'Palashbari','781128',1,0,'2022-03-03 13:16:13','2022-03-03 13:16:13'),(97707,290,'Paltanbazar','781008',1,0,'2022-03-03 13:16:13','2022-03-03 13:16:13'),(97708,290,'Panbari','782401',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97709,290,'Pandu Rly Colony','781012',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97710,290,'Pandu','781012',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97711,290,'Paneri','781123',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97712,290,'Panikhaiti','781026',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97713,290,'Panikhaiti','781137',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97714,290,'Panitema','781101',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97715,290,'Panjabari','781037',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97716,290,'Patharquerry','781171',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97717,290,'Pathimari','781127',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97718,290,'Pijupara','781127',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97719,290,'Pingaleswar','781381',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97720,290,'Pitambarhat Bazali','781354',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97721,290,'Pubborka','781101',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97722,290,'Puthimari','781380',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97723,290,'Rajapara','781120',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97724,290,'Ramdia','781102',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97725,290,'Ramgaon','781364',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97726,290,'Rampur (Kamrup)','781132',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97727,290,'Rangamati','781122',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97728,290,'Rangia R.S.','781365',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97729,290,'Rangia','781354',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97730,290,'Rani (Kamrup)','781131',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97731,290,'Ratanpur','781124',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97732,290,'Rehabari','781008',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97733,290,'Rongmahal','781030',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97734,290,'Rowmari','781104',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97735,290,'Rupnagar','781032',1,0,'2022-03-03 13:16:14','2022-03-03 13:16:14'),(97736,290,'Sadilapur','781012',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97737,290,'Saledal','781121',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97738,290,'Samuka','781129',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97739,290,'Santipur','781141',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97740,290,'Sarpara','781122',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97741,290,'Satgaon','781027',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97742,290,'Satpakhali','781132',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97743,290,'Saukuchi','781034',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97744,290,'Sawkuchi','781040',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97745,290,'Sidilapara','781124',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97746,290,'Sikarhati','781125',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97747,290,'Siliguri','781103',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97748,290,'Silkijhar','781366',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97749,290,'Silpukhuri','781003',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97750,290,'Simina','781122',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97751,290,'Simlatarabari','781135',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97752,290,'Singra Rajapara','781135',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97753,290,'Singra','781135',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97754,290,'Soalkuchi','781103',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97755,290,'Sonai Kamalajari','782402',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97756,290,'Sonapur','782402',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97757,290,'Soneswar','781382',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97758,290,'Soniadi','781102',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97759,290,'Srihati','781103',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97760,290,'Suagpur','781364',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97761,290,'Sutargaon','781381',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97762,290,'Tarani','781354',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97763,290,'Tengajhar','781364',1,0,'2022-03-03 13:16:15','2022-03-03 13:16:15'),(97764,290,'Tepesia','782402',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97765,290,'Tetelia','781104',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97766,290,'Tinali','781365',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97767,290,'Titkuri','781354',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97768,290,'Tokradia','781102',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97769,290,'Topabari','781102',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97770,290,'Toparpathar','781137',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97771,290,'Topatali','782403',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97772,290,'Tukrapara','781137',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97773,290,'Tulsibari','781376',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97774,290,'Tupamari','781127',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97775,290,'Udayan Vihar','781171',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97776,290,'Udiana','781354',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97777,290,'Ukiam','781124',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97778,290,'Ulubari','781007',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97779,290,'Uparhali','781122',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97780,290,'Uzanbazar','781001',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97781,290,'Uzankuri','781102',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97782,290,'Zoo Road','781024',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97783,290,'Balisatra','781350',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97784,290,'Aradanga','781129',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97785,290,'Jirang','781131',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97786,290,'Patharkhmah','781131',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97787,290,'Pillangkata','781029',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97788,290,'Tyngher','781129',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97789,290,'Warmawsaw','781131',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97790,291,'Amguri','782410',1,0,'2022-03-03 13:16:16','2022-03-03 13:16:16'),(97791,291,'Amlakhi Bazar','782461',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97792,291,'Amonigaon','782481',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97793,291,'Amrang','782448',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97794,291,'Amtreng','782450',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97795,291,'Anjukpani','782139',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97796,291,'Baghmari','782462',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97797,291,'Baghpani','782441',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97798,291,'Baithalangsho','782450',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97799,291,'Bakalighat','782482',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97800,291,'Baligaon Tiniali','782481',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97801,291,'Balipathar','782470',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97802,291,'Bargaon','782425',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97803,291,'Barjuri','782139',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97804,291,'Barlongpher','782447',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97805,291,'Barpani','782450',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97806,291,'Bheleoghat','782441',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97807,291,'Biswanathpathar','782441',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97808,291,'Bobilgaon','782481',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97809,291,'Bogijan','782490',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97810,291,'Bokajan C F','782490',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97811,291,'Bokajan','782480',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97812,291,'Borbali','782481',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97813,291,'Borthal','782485',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97814,291,'Chakihola','782480',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97815,291,'Cherakani','782441',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97816,291,'Dakhin Dighalipar','782481',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97817,291,'Daldali','782470',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97818,291,'Danghap','782441',1,0,'2022-03-03 13:16:17','2022-03-03 13:16:17'),(97819,291,'Dayangmukh','782448',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97820,291,'Deihari','782490',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97821,291,'Deithor','782480',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97822,291,'Dentaghat','782441',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97823,291,'Deopani','782470',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97824,291,'Deorigaon','782460',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97825,291,'Dewanbasti','782462',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97826,291,'Dhansripar','782470',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97827,291,'Dilaji','782462',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97828,291,'Dillai','782480',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97829,291,'Dillai Parbat','782480',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97830,291,'Diphu Bazar','782462',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97831,291,'Diphu Govt.College','782462',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97832,291,'Diphu H.O','782460',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97833,291,'Disama','782462',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97834,291,'Disobai','782482',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97835,291,'Dokmaka','782441',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97836,291,'Donkamokam','782485',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97837,291,'Duarbamuni','782441',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97838,291,'Dwajungphang','782470',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97839,291,'Eradighalpani','782481',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97840,291,'Forest Bazar','782448',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97841,291,'Gautambasti','782480',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97842,291,'Golaibasti','782480',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97843,291,'Hamren','782486',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97844,291,'Harlongpher','782447',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97845,291,'Hidibonglong','782481',1,0,'2022-03-03 13:16:18','2022-03-03 13:16:18'),(97846,291,'Hidipi','782480',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97847,291,'Honkram','782450',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97848,291,'Honlokrok','782485',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97849,291,'Howraghat','782481',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97850,291,'Jaljuri','782485',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97851,291,'Japrajan','782470',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97852,291,'Jengkha','782448',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97853,291,'Jirikinding','782448',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97854,291,'Jongpha','782490',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97855,291,'Kachupukhuri','782482',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97856,291,'Kailajan','782480',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97857,291,'Kajesara Matikhola','782441',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97858,291,'Kalanga','782485',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97859,291,'Karagaon','782480',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97860,291,'Khanduli','782486',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97861,291,'Khatkhati','782480',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97862,291,'Khengergaon','782447',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97863,291,'Kheroni','782448',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97864,291,'Kheronigaon','782461',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97865,291,'Kuligaon','782480',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97866,291,'Laharijan','782480',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97867,291,'Langbangdingpi','782482',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97868,291,'Langcholiet','782447',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97869,291,'Langhin Manikpur','782441',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97870,291,'Langhin Tiniali','782441',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97871,291,'Langlakso','782441',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97872,291,'Longnit','782461',1,0,'2022-03-03 13:16:19','2022-03-03 13:16:19'),(97873,291,'Lorenthepi','782482',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97874,291,'Lurulangso','782462',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97875,291,'Mahendijua','782461',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97876,291,'Mailoo Bazar','782446',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97877,291,'Manja','782461',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97878,291,'Menmeji','782435',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97879,291,'Morakordoiguri','782480',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97880,291,'Nailalung','782447',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97881,291,'Neparpatty','782470',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97882,291,'Okrang','782481',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97883,291,'Padumpukhuri','782441',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97884,291,'Paharguri','782450',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97885,291,'Palakamati','782481',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97886,291,'Panditghat','782481',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97887,291,'Panjaborpathar','782450',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97888,291,'Panjuri','782441',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97889,291,'Parakhowa Bazar','782441',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97890,291,'Phanglangso','782462',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97891,291,'Phangtrengphang','782485',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97892,291,'Phulani','782441',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97893,291,'Pub Silputa','782482',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97894,291,'Rajapathar','782481',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97895,291,'Rangapahar Siding','782470',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97896,291,'Rengkimi Village','782462',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97897,291,'Rongkhelon','782462',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97898,291,'Rongkut','782481',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97899,291,'Rongplimplam','782461',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97900,291,'Samaguri Bazar','782482',1,0,'2022-03-03 13:16:20','2022-03-03 13:16:20'),(97901,291,'Samelangso','782441',1,0,'2022-03-03 13:16:21','2022-03-03 13:16:21'),(97902,291,'Sangsiga Bazar','782448',1,0,'2022-03-03 13:16:21','2022-03-03 13:16:21'),(97903,291,'Sankardev Nagar','782442',1,0,'2022-03-03 13:16:21','2022-03-03 13:16:21'),(97904,291,'Sarihajan','782480',1,0,'2022-03-03 13:16:21','2022-03-03 13:16:21'),(97905,291,'Satgaon','782485',1,0,'2022-03-03 13:16:21','2022-03-03 13:16:21'),(97906,291,'Shyampathar','782482',1,0,'2022-03-03 13:16:21','2022-03-03 13:16:21'),(97907,291,'Sildharampur','782441',1,0,'2022-03-03 13:16:21','2022-03-03 13:16:21'),(97908,291,'Silputa Tiniali','782482',1,0,'2022-03-03 13:16:21','2022-03-03 13:16:21'),(97909,291,'Tarabasa','782482',1,0,'2022-03-03 13:16:21','2022-03-03 13:16:21'),(97910,291,'Taradubi','782485',1,0,'2022-03-03 13:16:21','2022-03-03 13:16:21'),(97911,291,'Taralangso No 1','782447',1,0,'2022-03-03 13:16:21','2022-03-03 13:16:21'),(97912,291,'Tengelijan','782470',1,0,'2022-03-03 13:16:21','2022-03-03 13:16:21'),(97913,291,'Tengralangso','782450',1,0,'2022-03-03 13:16:21','2022-03-03 13:16:21'),(97914,291,'Teteliguri','782482',1,0,'2022-03-03 13:16:21','2022-03-03 13:16:21'),(97915,291,'Tikahill','782450',1,0,'2022-03-03 13:16:21','2022-03-03 13:16:21'),(97916,291,'Tumpreng','782485',1,0,'2022-03-03 13:16:21','2022-03-03 13:16:21'),(97917,291,'Udali No 1','782482',1,0,'2022-03-03 13:16:21','2022-03-03 13:16:21'),(97918,291,'Umcherra','782486',1,0,'2022-03-03 13:16:21','2022-03-03 13:16:21'),(97919,291,'Umpanai','782410',1,0,'2022-03-03 13:16:21','2022-03-03 13:16:21'),(97920,291,'Umswar','782410',1,0,'2022-03-03 13:16:21','2022-03-03 13:16:21'),(97921,291,'Uttar Borbil','782481',1,0,'2022-03-03 13:16:21','2022-03-03 13:16:21'),(97922,291,'Vitorkaliani','782490',1,0,'2022-03-03 13:16:21','2022-03-03 13:16:21'),(97923,291,'Watijor','782446',1,0,'2022-03-03 13:16:21','2022-03-03 13:16:21'),(97924,291,'Wirwar','782441',1,0,'2022-03-03 13:16:21','2022-03-03 13:16:21'),(97925,292,'Adarkona','788701',1,0,'2022-03-03 13:16:21','2022-03-03 13:16:21'),(97926,292,'Alamkhani','788722',1,0,'2022-03-03 13:16:21','2022-03-03 13:16:21'),(97927,292,'Ambarkhana','788712',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97928,292,'Anglarbazar','788806',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97929,292,'Asalkandi','788723',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97930,292,'Aylabari','788712',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97931,292,'Badarpur Bazar','788006',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97932,292,'Badarpur Bazar','788806',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97933,292,'Badarpur (Karimganj)','788806',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97934,292,'Badarpurghat','788803',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97935,292,'Bagbari','788720',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97936,292,'Baithakhal Basti','788726',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97937,292,'Balipipla Bazar','788728',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97938,292,'Banamali','788710',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97939,292,'Baraigram','788723',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97940,292,'Barkatpur','788713',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97941,292,'Baropunji','788781',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97942,292,'Basantinagar','788725',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97943,292,'Basudevnagar','788723',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97944,292,'Bazarghat (Karimganj)','788733',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97945,292,'Bazaricherra Bazar','788727',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97946,292,'Bhanga Bazaar','788701',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97947,292,'Bhurunga','788724',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97948,292,'Bishnunagar','788781',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97949,292,'Brahmansashan','788722',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97950,292,'Bubrighat','788724',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97951,292,'Chaitanyanagar','788720',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97952,292,'Chamela Bazar','788166',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97953,292,'Chandkhira','788725',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97954,292,'Char Bazar','788710',1,0,'2022-03-03 13:16:22','2022-03-03 13:16:22'),(97955,292,'Chargola Bazar','788713',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97956,292,'Chatal','788720',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97957,292,'Dasgram','788722',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97958,292,'Dharakuna','788712',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97959,292,'Duhalia','788724',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97960,292,'Durganagar','788722',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97961,292,'Duttagram','788722',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97962,292,'Eraligool','788723',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97963,292,'Fakuagram','788723',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97964,292,'Girishganj Bazar','788711',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97965,292,'Govindaganj Bazar','788733',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97966,292,'Gulcherra','788720',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97967,292,'Hasanpur','788806',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97968,292,'Hatikhira','788726',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97969,292,'Isabeel','788728',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97970,292,'Jadutilla','788720',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97971,292,'Jagannathi','788709',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97972,292,'Jalalnagar','788712',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97973,292,'Janakalyan Bazar','788720',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97974,292,'Jobainpur','788713',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97975,292,'Jurbari','788724',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97976,292,'Kadamtala','788166',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97977,292,'Kalachup','788166',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97978,292,'Kaliganj Bazar','788720',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97979,292,'Kalima','788712',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97980,292,'Kalinagar T E','788166',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97981,292,'Kalkalighat','788725',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97982,292,'Kanaibazar','788724',1,0,'2022-03-03 13:16:23','2022-03-03 13:16:23'),(97983,292,'Kanishail','788711',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(97984,292,'Karimganj Bazar','788711',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(97985,292,'Karimganj Court','788710',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(97986,292,'Karimganj H.O','788710',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(97987,292,'Karimganj Station Road','788710',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(97988,292,'Karnamadhu','788712',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(97989,292,'Katabari','788726',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(97990,292,'Kathaltoli Bazar','788725',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(97991,292,'Kayasthagram','788719',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(97992,292,'Kotamani Bazar','788728',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(97993,292,'Kurikala','788712',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(97994,292,'Lakhibazar','788709',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(97995,292,'Lalarchak','788713',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(97996,292,'Lamajuar','788701',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(97997,292,'Latu','788781',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(97998,292,'Longai Road','788710',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(97999,292,'Longaighat','788710',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(98000,292,'Lowairpoa','788726',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(98001,292,'Lowairpoa','788728',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(98002,292,'Mahakhal','788120',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(98003,292,'Mahisashan','788781',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(98004,292,'Maizgram','788712',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(98005,292,'Malua','788806',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(98006,292,'Manikbond','788728',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(98007,292,'Manikganj','788712',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(98008,292,'Maniknagar','788166',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(98009,292,'Marjatkandi','788701',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(98010,292,'Masley','788701',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(98011,292,'Medley','788725',1,0,'2022-03-03 13:16:24','2022-03-03 13:16:24'),(98012,292,'Mirzapur','788701',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98013,292,'Mullaganj Bazar','788719',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98014,292,'Nagendranagar','788733',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98015,292,'Nairgram','788713',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98016,292,'Nathupur','788711',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98017,292,'Nayagram','788709',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98018,292,'Netaji Nagar','788166',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98019,292,'Nilam Bazar','788722',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98020,292,'Panighat','788709',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98021,292,'Pathar Kandi Bazar','788724',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98022,292,'Patharkandi Anchalik','788724',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98023,292,'Patharkandi','788724',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98024,292,'Pathu','788781',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98025,292,'Promodenagar','788722',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98026,292,'Puthini','788725',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98027,292,'Rajpasa','788701',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98028,292,'Rakeshnagar','788701',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98029,292,'Ramanikrishna','788722',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98030,292,'Ramkrishnanagar','788166',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98031,292,'Ranibari','788722',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98032,292,'Sadarashi','788709',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98033,292,'Settlement Road','788712',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98034,292,'Shyamnagar','788720',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98035,292,'Siberchak','788720',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98036,292,'Silchar Road','788713',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98037,292,'Singaria Bazar','788719',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98038,292,'Solgoi','788726',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98039,292,'Srigouri','788806',1,0,'2022-03-03 13:16:25','2022-03-03 13:16:25'),(98040,292,'Sripur','788166',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98041,292,'Subashnagar','788710',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98042,292,'Sutarkandi','788712',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98043,292,'Telikhalerpar','788711',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98044,292,'Tenokhal','788724',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98045,292,'Tibhum','788725',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98046,292,'Tillabazar','788709',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98047,292,'Umarpur','788806',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98048,293,'Aflagaon','783346',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98049,293,'Aminkata','783337',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98050,293,'Anthaibari','783360',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98051,293,'Athiabari','783346',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98052,293,'Baghmari','783345',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98053,293,'Bairali','783350',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98054,293,'Ballimari','783360',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98055,293,'Banargaon','783347',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98056,293,'Barjan','783332',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98057,293,'Baruapara','783345',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98058,293,'Basugaon','783372',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98059,293,'Batabari','783347',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98060,293,'Bhalukmari','783347',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98061,293,'Bhodeaguri','783360',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98062,293,'Bhowraguri','783336',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98063,293,'Bhumka','783337',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98064,293,'Bidyapur','783372',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98065,293,'Bilaspur','783372',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98066,293,'Binnyakhata','783336',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98067,293,'Bishmuri','783370',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98068,293,'Boro Gendrabil','783370',1,0,'2022-03-03 13:16:26','2022-03-03 13:16:26'),(98069,293,'Chakma','783360',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98070,293,'Chandrapara','783370',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98071,293,'Chitila Bhubannagar','783354',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98072,293,'Choibari','783376',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98073,293,'Choraikhola','783376',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98074,293,'Dabargaon','783376',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98075,293,'Daloabari','783370',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98076,293,'Deosiri','783375',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98077,293,'Dhantala Bazar','783372',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98078,293,'Dingdinga','783333',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98079,293,'Dologaon','783372',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98080,293,'Dotma','783347',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98081,293,'Dumeriguri','783347',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98082,293,'Failaguri','783333',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98083,293,'Fakiragram','783345',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98084,293,'Fulguri','783372',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98085,293,'Futkibari','783345',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98086,293,'Gambaribil','783336',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98087,293,'Gangia','783350',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98088,293,'Garufela Bazar','783360',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98089,293,'Goladangi','783361',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98090,293,'Gossaigaon No.Ii','783360',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98091,293,'Gossaigaon','783360',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98092,293,'Gossainichina','783346',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98093,293,'Grahampur','783333',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98094,293,'Guabari','783360',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98095,293,'Hakamabil','783347',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98096,293,'Haloadal','783370',1,0,'2022-03-03 13:16:27','2022-03-03 13:16:27'),(98097,293,'Haltugaon','783370',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98098,293,'Haraputa','783361',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98099,293,'Helaguri','783345',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98100,293,'Jaleswari','783350',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98101,293,'Jambuguri','783360',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98102,293,'Jaraguri','783361',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98103,293,'Jharbari','783346',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98104,293,'Joyma','783360',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98105,293,'Joyma Bazar','783360',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98106,293,'Kachugaon','783350',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98107,293,'Kakormari','783346',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98108,293,'Kalipukhuri','783369',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98109,293,'Kamalsing','783336',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98110,293,'Kamandanga','783332',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98111,293,'Kartimari','783337',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98112,293,'Kashiabari','783360',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98113,293,'Kashipara Bhotgaon','783370',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98114,293,'Khargaon','783370',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98115,293,'Khungring','783375',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98116,293,'Koimari','783360',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98117,293,'Kokragaon','783372',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98118,293,'Kokrajhar Bagicha','783370',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98119,293,'Kokrajhar H.O','783370',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98120,293,'Lalmati Tumbagan','783332',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98121,293,'Lawdanga','783347',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98122,293,'Magurmari','783370',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98123,293,'Mainaguri','783354',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98124,293,'Majergaon','783376',1,0,'2022-03-03 13:16:28','2022-03-03 13:16:28'),(98125,293,'Maktaigaon','783360',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98126,293,'Monglajhora','783337',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98127,293,'Nayekgaon','783376',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98128,293,'Padmabil','783360',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98129,293,'Pakriguri','783346',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98130,293,'Patakata','783127',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98131,293,'Patakata','783360',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98132,293,'Patgaon','783346',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98133,293,'Petlagaon','783332',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98134,293,'Pratapkhata','783337',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98135,293,'Puthimari','783347',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98136,293,'Raimona','783350',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98137,293,'Rainadabri','783370',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98138,293,'Rajadabri','783360',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98139,293,'Ramfalbil','783346',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98140,293,'Ranchaidham','783372',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98141,293,'Rangalikhata','783370',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98142,293,'Raniganj','783345',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98143,293,'Ranipur','783375',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98144,293,'Runikhata','783375',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98145,293,'Saktiashram','783354',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98146,293,'Salakati','783369',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98147,293,'Salakati Project','783369',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98148,293,'Santipur','783375',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98149,293,'Sapkata','783360',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98150,293,'Saraibil','783350',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98151,293,'Satyapur','783360',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98152,293,'Serfanguri','783346',1,0,'2022-03-03 13:16:29','2022-03-03 13:16:29'),(98153,293,'Shantinagar (Kokrajhar)','783370',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98154,293,'Shesergaon','783345',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98155,293,'Shialmari','783346',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98156,293,'Shyamthaibari','783346',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98157,293,'Simbargaon','783370',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98158,293,'Simultapu','783361',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98159,293,'Srinagar','783332',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98160,293,'Srirampur (Kokrajhar)','783361',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98161,293,'Takampur','783350',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98162,293,'Tamarhat','783332',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98163,293,'Tetliguri','783347',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98164,293,'Tilakgaon','783372',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98165,293,'Tipkai','783337',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98166,293,'Titaguri','783370',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98167,293,'Tulsibil','783337',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98168,293,'Ultapani','783370',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98169,293,'Uzanpetla','783332',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98170,294,'2 No Bokanala','787032',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98171,294,'Adi Alengi Satra','787054',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98172,294,'Ahomoni','787052',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98173,294,'Amtola Jaintpur','787052',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98174,294,'Angerkhowa','787031',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98175,294,'Arimora Tiniali','784165',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98176,294,'Azad','787031',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98177,294,'Badati','784161',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98178,294,'Badhakhara','787032',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98179,294,'Bahadurchuk','787031',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98180,294,'Bahgora Deurigaon','784161',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98181,294,'Bahpara','787055',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98182,294,'Barbali','784163',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98183,294,'Barkhamukh','787055',1,0,'2022-03-03 13:16:30','2022-03-03 13:16:30'),(98184,294,'Batamari Tiniali','787053',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98185,294,'Begumgaon','787055',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98186,294,'Bhatowkuchi','784165',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98187,294,'Bhimpara Balijan','787032',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98188,294,'Bhogpur Chariali','787033',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98189,294,'Bholabari','787033',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98190,294,'Bihupuria','784161',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98191,294,'Bilmukh','787053',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98192,294,'Boginadi','787032',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98193,294,'Bogolijan','787031',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98194,294,'Bokulguri','787055',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98195,294,'Bongalchuk','787023',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98196,294,'Bonpuroi','784165',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98197,294,'Bor Alengi Satra','787054',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98198,294,'Bordeurigaon','784164',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98199,294,'Bordoibam','787053',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98200,294,'Borgaya Khagori','787031',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98201,294,'Borkhelia','787032',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98202,294,'Bormuriachuk','787031',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98203,294,'Borshala','787023',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98204,294,'Budhbazar','787031',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98205,294,'Chaboti','787051',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98206,294,'Charaimoria','787032',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98207,294,'Dafalakata','787052',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98208,294,'Daulatpur','787054',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98209,294,'Dejoo Te','787031',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98210,294,'Deotala','787033',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98211,294,'Deuliagaon','787053',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98212,294,'Dhakuakhana','787055',1,0,'2022-03-03 13:16:31','2022-03-03 13:16:31'),(98213,294,'Dhalpur','784165',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98214,294,'Dharmagarh Sevashram','784165',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98215,294,'Dharmapur','784160',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98216,294,'Dhenukhana','787053',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98217,294,'Dhunaguri','787054',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98218,294,'Dighalia Hiloidhari','787055',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98219,294,'Dikrong','784164',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98220,294,'Dirgha Majgaon','787032',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98221,294,'Dongibill','784161',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98222,294,'Doolahat','787023',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98223,294,'Duliapthar','784164',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98224,294,'Durpang','787033',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98225,294,'Echarikata Balijan','787052',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98226,294,'Fukhanarhat','787052',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98227,294,'Fulbari Bokanadi','787023',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98228,294,'Ga Dangar Chuk','787053',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98229,294,'Gabharu Tunijan','784160',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98230,294,'Garchiga','787052',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98231,294,'Gereki','787032',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98232,294,'Gerukamukh','787035',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98233,294,'Gharmora','787032',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98234,294,'Ghatapara','787053',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98235,294,'Ghilamara','787053',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98236,294,'Ghughuhadal','787053',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98237,294,'Ghunasuti','787032',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98238,294,'Gobindapur','787055',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98239,294,'Gogamukh','787034',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98240,294,'Goroimari','787032',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98241,294,'Gorumoria','787032',1,0,'2022-03-03 13:16:32','2022-03-03 13:16:32'),(98242,294,'Gosaibari','787033',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98243,294,'Hamarathan','784161',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98244,294,'Haribor Naharoni','784160',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98245,294,'Harmoti Merbil','784160',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98246,294,'Hatilung','787031',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98247,294,'Hindugaon','787032',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98248,294,'Islamgaon','787054',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98249,294,'Jalbhari','787055',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98250,294,'Japisajia','787031',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98251,294,'Japjup','784161',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98252,294,'Jorabari','784164',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98253,294,'Joriguri','784160',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98254,294,'Joyhing Te','787051',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98255,294,'Joysagar','787055',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98256,294,'Kachikota Mirideurigaon','784161',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98257,294,'Kachua','784165',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98258,294,'Kadam','787032',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98259,294,'Kakoi Rajgarh','787051',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98260,294,'Kalakhowa Adarsha Gaon','787023',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98261,294,'Kaligaon','787053',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98262,294,'Kamalpur','784164',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98263,294,'Kamalpur Chariali','784165',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98264,294,'Kambong Gaon','787052',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98265,294,'Kankan Chapori','787055',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98266,294,'Katri Chapori','787056',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98267,294,'Kekuri','787055',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98268,294,'Kekuri Pamuagaon','787055',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98269,294,'Kerekjuli','787033',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98270,294,'Khajuapatir','787055',1,0,'2022-03-03 13:16:33','2022-03-03 13:16:33'),(98271,294,'Khalihamari','787053',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98272,294,'Kharkati','787052',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98273,294,'Khelmati','787031',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98274,294,'Kherkatamukh','787055',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98275,294,'Khoga','787052',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98276,294,'Khonajan','787031',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98277,294,'Kinapathar','784164',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98278,294,'Konwargaon','787032',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98279,294,'Kowadonga','787031',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98280,294,'Kuhiarbari','787052',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98281,294,'Kuksabari','784165',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98282,294,'Kutubpur','787054',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98283,294,'Laholial','784161',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98284,294,'Lakhanabari','784160',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98285,294,'Laluk','784160',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98286,294,'Letekupukhuri','787033',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98287,294,'Likhakchapori','787054',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98288,294,'Lilabari A/F','787051',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98289,294,'Madhavpur','784164',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98290,294,'Madhupur','787033',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98291,294,'Mahaijan','787032',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98292,294,'Manikachuk','787055',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98293,294,'Medhisutigaon','787055',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98294,294,'Meramukh','784164',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98295,294,'Merbil','784160',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98296,294,'Moderguri','787055',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98297,294,'Mohemari','787055',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98298,294,'Moidumia','787032',1,0,'2022-03-03 13:16:34','2022-03-03 13:16:34'),(98299,294,'Moinapara','787034',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98300,294,'Moitri Ashram','787051',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98301,294,'Morichapathar','784161',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98302,294,'Mornoi Bebejia','787055',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98303,294,'Mornoikhora','787054',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98304,294,'Na Ali Mirigaon','787052',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98305,294,'Naoboicha','787023',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98306,294,'Naragaon','787052',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98307,294,'Neogaghuli','787055',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98308,294,'North Lakhimpur Bazar','787031',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98309,294,'North Lakhimpur H.O','787001',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98310,294,'Ouguri Dangdhara','787055',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98311,294,'Padmapur','784164',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98312,294,'Panbari','784164',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98313,294,'Panigaon','787052',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98314,294,'Pathalipahar','784163',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98315,294,'Pathalipam','787056',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98316,294,'Patrichuk','787055',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98317,294,'Pithguri','784163',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98318,294,'Pohumara','787031',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98319,294,'Pokadal','784161',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98320,294,'Puli Naharani','784165',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98321,294,'Purana Parghat','787053',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98322,294,'Raidongia','784164',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98323,294,'Rajabari','784161',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98324,294,'Rampur Deurigaon','787031',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98325,294,'Rangati Charali','784165',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98326,294,'Rongajan Borbil','787051',1,0,'2022-03-03 13:16:35','2022-03-03 13:16:35'),(98327,294,'Rongpuria','787032',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98328,294,'Ruptali Adarshagaon','784165',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98329,294,'Sagarpur','787023',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98330,294,'Salmora Tiniali','787052',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98331,294,'Sandowkhowa','787054',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98332,294,'Silonibari','787031',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98333,294,'Simaluguri','784165',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98334,294,'Singra','787023',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98335,294,'Sonapur','784160',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98336,294,'Sonapur','787054',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98337,294,'Sonardheki','787052',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98338,294,'Subansiri Koibarta Adarsha Gao','787056',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98339,294,'Sundia','787055',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98340,294,'Tariani Berbhanga','787032',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98341,294,'Ukhamati','787056',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98342,294,'Uttar Kulabali','787032',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98343,295,'Ahatguri','782412',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98344,295,'Alikuchi','782103',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98345,295,'Amlighat','782410',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98346,295,'Azarbari','782105',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98347,295,'Baghara','782105',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98348,295,'Bamunbori','782103',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98349,295,'Bangaldhara','782412',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98350,295,'Bangalpara','782105',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98351,295,'Baralimari','782121',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98352,295,'Barangani','782127',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98353,295,'Barbori','782127',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98354,295,'Barchala','782103',1,0,'2022-03-03 13:16:36','2022-03-03 13:16:36'),(98355,295,'Baribandha','782127',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98356,295,'Barkuloi','782411',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98357,295,'Barpak','782411',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98358,295,'Bhurbandha','782104',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98359,295,'Buraburi','782411',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98360,295,'Burgaon','782411',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98361,295,'Chabukdhara','782103',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98362,295,'Charaibahi','782106',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98363,295,'Chetwaikhaitee','782127',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98364,295,'Damal','782105',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98365,295,'Datialbori','782126',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98366,295,'Dayang Beloguri','782410',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98367,295,'Deosal','782410',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98368,295,'Dewaguri','782127',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98369,295,'Dharamtul','782412',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98370,295,'Dighalbori','782105',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98371,295,'Doloichuba','782105',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98372,295,'Doloigaon','782126',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98373,295,'Dongarbori','782410',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98374,295,'Dumkura Bazar','782127',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98375,295,'Dungarpar','782121',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98376,295,'Falihamari Pathar','782127',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98377,295,'Gagalmari','782121',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98378,295,'Gandhibori','782103',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98379,295,'Garukhuti','782103',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98380,295,'Geruagaon','782121',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98381,295,'Ghagua','782105',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98382,295,'Goroimari','782104',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98383,295,'Goroimaripathar','782126',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98384,295,'Habibarangabari','782103',1,0,'2022-03-03 13:16:37','2022-03-03 13:16:37'),(98385,295,'Hahcharagaon','782126',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98386,295,'Haloakanda','782121',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98387,295,'Hatiamukh','782411',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98388,295,'Jagi','782411',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98389,295,'Jagibhakatgaon','782411',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98390,295,'Jagiroad','782410',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98391,295,'Jalakiabari','782127',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98392,295,'Jaluguti','782104',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98393,295,'Jhargaon','782411',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98394,295,'Kachadhara Nakhanda','782104',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98395,295,'Kagajnagar','782413',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98396,295,'Kapahera','782103',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98397,295,'Karatipam','782105',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98398,295,'Katanigaon','782127',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98399,295,'Khaplangkuchi','782103',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98400,295,'Khulagaon','782411',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98401,295,'Killing Valley','782410',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98402,295,'Komoraguri','782105',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98403,295,'Kuranibori','782411',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98404,295,'Lahorighat','782127',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98405,295,'Lengeribori','782121',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98406,295,'Lochanabori','782126',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98407,295,'Manaha Kacharigaon','782411',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98408,295,'Manipur','782105',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98409,295,'Mayang Kamarpur','782411',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98410,295,'Mikirbheta','782001',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98411,295,'Moirabari','782126',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98412,295,'Morigaon','782105',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98413,295,'Nagabandha','782103',1,0,'2022-03-03 13:16:38','2022-03-03 13:16:38'),(98414,295,'Natuagaon','782105',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98415,295,'Natun Bangalbori','782411',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98416,295,'Nellie','782410',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98417,295,'Nizdandua','782104',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98418,295,'No.1 Gayangaon','782126',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98419,295,'Patidaya','782104',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98420,295,'Patrabori','782104',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98421,295,'Patsari','782410',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98422,295,'Patuakata','782104',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98423,295,'Pukarkata','782121',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98424,295,'Raja Mayang','782411',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98425,295,'Ramjanati','782103',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98426,295,'Sagunbahipathar','782126',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98427,295,'Sahariagaon','782126',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98428,295,'Salkati Pathar','782126',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98429,295,'Sandahkhaiti','782121',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98430,295,'Sapmarigaon','782104',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98431,295,'Sarubori','782105',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98432,295,'Satiantoli','782127',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98433,295,'Silchung','782412',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98434,295,'Solmari Mikirgaon','782104',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98435,295,'Sondoba','782121',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98436,295,'Sukdal Sarubori','782104',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98437,295,'Tarabori Kalsila Satra','782104',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98438,295,'Tengaguri','782127',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98439,295,'Tokonabori','782104',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98440,295,'Toptola','782121',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98441,295,'Udari','782105',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98442,295,'Umlapher','782410',1,0,'2022-03-03 13:16:39','2022-03-03 13:16:39'),(98443,296,'Aibheti','782002',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98444,296,'Akorabori','782123',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98445,296,'Alitangani','782124',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98446,296,'Ambagan','782120',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98447,296,'Ambari','782445',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98448,296,'Amguri','782136',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98449,296,'Amlakhi','782122',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98450,296,'Amolapatty','782003',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98451,296,'Amoni','782138',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98452,296,'Amsoi Bazar','782425',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98453,296,'Amtola','782435',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98454,296,'Anneria','782446',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98455,296,'Azarbari Krishna Nagar','782442',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98456,296,'Bagamukh','782120',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98457,296,'Bagari','782136',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98458,296,'Bagariguri','782103',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98459,296,'Bajbatamari','782425',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98460,296,'Bajiagaon','782140',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98461,296,'Baligaon','782144',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98462,296,'Balikatia','782122',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98463,296,'Balisatra','782122',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98464,296,'Bamuni','782102',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98465,296,'Bamunijan','782425',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98466,296,'Barangatoli','782141',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98467,296,'Barangatoli Bazar','782445',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98468,296,'Barapatia','782428',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98469,296,'Barapujia','782103',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98470,296,'Barbhagia','782138',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98471,296,'Barchila','782142',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98472,296,'Barghat','782125',1,0,'2022-03-03 13:16:40','2022-03-03 13:16:40'),(98473,296,'Barhampur','782102',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98474,296,'Barhawar','782439',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98475,296,'Barmanipur','782142',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98476,296,'Barpanigaon','782141',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98477,296,'Batadraba','782122',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98478,296,'Batamari','782122',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98479,296,'Bebejia','782142',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98480,296,'Bechamari','782123',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98481,296,'Beltola','782425',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98482,296,'Bengenaati','782137',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98483,296,'Bhalukmari','782442',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98484,296,'Bharidhua','782120',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98485,296,'Bheleoguri','782140',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98486,296,'Bhomoraguri','782143',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98487,296,'Bhomoraguri','782103',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98488,296,'Bhuragaon','782121',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98489,296,'Biharigaon','782101',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98490,296,'Bihlangani','782002',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98491,296,'Biorbheti Dhing','782123',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98492,296,'Borbheti','782122',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98493,296,'Borboha','782442',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98494,296,'Borghuli','782143',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98495,296,'Borghuli Sapmar','782120',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98496,296,'Borkola','782144',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98497,296,'Burapahar','782136',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98498,296,'Burhachaparigao','782120',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98499,296,'Chakalaghat','782142',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98500,296,'Chakitop','782140',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98501,296,'Chalapathar','782122',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98502,296,'Chalchali','782141',1,0,'2022-03-03 13:16:41','2022-03-03 13:16:41'),(98503,296,'Chamuagaon','782123',1,0,'2022-03-03 13:16:42','2022-03-03 13:16:42'),(98504,296,'Changmaji','782440',1,0,'2022-03-03 13:16:42','2022-03-03 13:16:42'),(98505,296,'Chapanalla','782135',1,0,'2022-03-03 13:16:42','2022-03-03 13:16:42'),(98506,296,'Chaparmukh','782425',1,0,'2022-03-03 13:16:42','2022-03-03 13:16:42'),(98507,296,'Charing','782439',1,0,'2022-03-03 13:16:42','2022-03-03 13:16:42'),(98508,296,'Chatabar','782103',1,0,'2022-03-03 13:16:42','2022-03-03 13:16:42'),(98509,296,'Chillangani','782002',1,0,'2022-03-03 13:16:42','2022-03-03 13:16:42'),(98510,296,'Chitalmari Beel','782124',1,0,'2022-03-03 13:16:42','2022-03-03 13:16:42'),(98511,296,'Chottahaibor','782003',1,0,'2022-03-03 13:16:42','2022-03-03 13:16:42'),(98512,296,'Choudhury Bazar','782439',1,0,'2022-03-03 13:16:42','2022-03-03 13:16:42'),(98513,296,'Daboka','782440',1,0,'2022-03-03 13:16:42','2022-03-03 13:16:42'),(98514,296,'Dagaon','782124',1,0,'2022-03-03 13:16:42','2022-03-03 13:16:42'),(98515,296,'Dakarghat','782003',1,0,'2022-03-03 13:16:42','2022-03-03 13:16:42'),(98516,296,'Dakhin Beloguri','782120',1,0,'2022-03-03 13:16:42','2022-03-03 13:16:42'),(98517,296,'Dakhin Sangchaki','782426',1,0,'2022-03-03 13:16:42','2022-03-03 13:16:42'),(98518,296,'Debasthan Bazar','782481',1,0,'2022-03-03 13:16:42','2022-03-03 13:16:42'),(98519,296,'Debnarikoli','782426',1,0,'2022-03-03 13:16:42','2022-03-03 13:16:42'),(98520,296,'Derapathar','782446',1,0,'2022-03-03 13:16:42','2022-03-03 13:16:42'),(98521,296,'Dhaniabheti','782122',1,0,'2022-03-03 13:16:42','2022-03-03 13:16:42'),(98522,296,'Dhing Bazar','782123',1,0,'2022-03-03 13:16:42','2022-03-03 13:16:42'),(98523,296,'Dhing','782123',1,0,'2022-03-03 13:16:42','2022-03-03 13:16:42'),(98524,296,'Dhupaguri','782123',1,0,'2022-03-03 13:16:42','2022-03-03 13:16:42'),(98525,296,'Dighaldori','782103',1,0,'2022-03-03 13:16:42','2022-03-03 13:16:42'),(98526,296,'Dighali','782125',1,0,'2022-03-03 13:16:42','2022-03-03 13:16:42'),(98527,296,'Dighaliati','782103',1,0,'2022-03-03 13:16:42','2022-03-03 13:16:42'),(98528,296,'Dighaljar','782439',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98529,296,'Dimaruguri','782003',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98530,296,'Dimrupar','782435',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98531,296,'Dumaihagi Dapara','782428',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98532,296,'Fakali Pathar','782124',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98533,296,'Fulaguri','782103',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98534,296,'Fultoli Bazar','782446',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98535,296,'Gakhajua','782142',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98536,296,'Garukhunda','782428',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98537,296,'Gaspara','782425',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98538,296,'Gatonga','782125',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98539,296,'Gerjaipam','782426',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98540,296,'Geruaati Bazar','782140',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98541,296,'Ghahibhatikuri','782460',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98542,296,'Ghilani','782426',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98543,296,'Golaghatiabasti','782435',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98544,296,'Gopalnagar','782435',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98545,296,'Gosaibori','782142',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98546,296,'Gosaigaon','782446',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98547,296,'Haiborgaon','782002',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98548,296,'Halowagaon','782141',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98549,296,'Hariamukh','782103',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98550,296,'Hatbor','782136',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98551,296,'Hatichung','782142',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98552,296,'Hatipara','782003',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98553,296,'Hatipukhuri','782125',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98554,296,'Hatizuzua','782122',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98555,296,'Hatlaokhowa','782120',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98556,296,'Hawaipur','782446',1,0,'2022-03-03 13:16:43','2022-03-03 13:16:43'),(98557,296,'Herapatty','782002',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98558,296,'Hindu Block','782440',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98559,296,'Hoj R.S.','782435',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98560,296,'Hojai Bazar','782435',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98561,296,'Hojai','782435',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98562,296,'Huzrangagarah','782002',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98563,296,'Itachali','782003',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98564,296,'Jajori','782142',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98565,296,'Jakhalabandha','782136',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98566,296,'Jamuguri','782142',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98567,296,'Jamunamukh','782428',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98568,296,'Jengani','782122',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98569,296,'Jogijan Bazar','782429',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98570,296,'Joynagar Madrassa','782445',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98571,296,'Jumurmur','782427',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98572,296,'Jungl Block','782428',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98573,296,'Jurapukhuri','782442',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98574,296,'Juria','782124',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98575,296,'Jurirpar','782426',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98576,296,'Kachamari Boragaon','782002',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98577,296,'Kachua','782426',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98578,296,'Kadomoni','782122',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98579,296,'Kakatigaon','782425',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98580,296,'Kakhorigaon','782141',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98581,296,'Kaki','782446',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98582,296,'Kaki Chalchali','782442',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98583,296,'Kalongpar Halowagaon','782141',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98584,296,'Kampur','782426',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98585,296,'Kanchanpur','782125',1,0,'2022-03-03 13:16:44','2022-03-03 13:16:44'),(98586,296,'Kandali','782102',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98587,296,'Kandhulimari','782123',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98588,296,'Kapashbari','782445',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98589,296,'Karayani','782439',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98590,296,'Kashari','782124',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98591,296,'Kathalguri','782135',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98592,296,'Kathiatoli','782427',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98593,296,'Kathpara Bazar','782120',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98594,296,'Kathterongaon','782136',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98595,296,'Kawaimari','782140',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98596,296,'Khaigarh','782103',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98597,296,'Kharikhana','782446',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98598,296,'Khutikatia','782002',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98599,296,'Komorakata','782435',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98600,296,'Koroiguri','782440',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98601,296,'Kumargaon','782125',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98602,296,'Kurhimari','782143',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98603,296,'Kuthori','782136',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98604,296,'Kuworitul','782137',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98605,296,'Lachit Pathar','782446',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98606,296,'Lailuri','782120',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98607,296,'Lalunggaon','782122',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98608,296,'Lamsakhang','782446',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98609,296,'Lanka (Nagaon)','782446',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98610,296,'Lankeswarigrant','782446',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98611,296,'Laopani','782425',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98612,296,'Laskarpathar','782446',1,0,'2022-03-03 13:16:45','2022-03-03 13:16:45'),(98613,296,'Leteripar Bazar','782124',1,0,'2022-03-03 13:16:46','2022-03-03 13:16:46'),(98614,296,'Lumding Bazar','782447',1,0,'2022-03-03 13:16:46','2022-03-03 13:16:46'),(98615,296,'Lumding','782447',1,0,'2022-03-03 13:16:46','2022-03-03 13:16:46'),(98616,296,'Madhupur','782003',1,0,'2022-03-03 13:16:46','2022-03-03 13:16:46'),(98617,296,'Magurmari','782140',1,0,'2022-03-03 13:16:46','2022-03-03 13:16:46'),(98618,296,'Mainapur Bazar','782446',1,0,'2022-03-03 13:16:46','2022-03-03 13:16:46'),(98619,296,'Majarati','782002',1,0,'2022-03-03 13:16:46','2022-03-03 13:16:46'),(98620,296,'Majgaon','782142',1,0,'2022-03-03 13:16:46','2022-03-03 13:16:46'),(98621,296,'Majpathori','782003',1,0,'2022-03-03 13:16:46','2022-03-03 13:16:46'),(98622,296,'Marangialgaon','782141',1,0,'2022-03-03 13:16:46','2022-03-03 13:16:46'),(98623,296,'Missa','782138',1,0,'2022-03-03 13:16:46','2022-03-03 13:16:46'),(98624,296,'Mithapukhuripar','782124',1,0,'2022-03-03 13:16:46','2022-03-03 13:16:46'),(98625,296,'Modertoli','782440',1,0,'2022-03-03 13:16:46','2022-03-03 13:16:46'),(98626,296,'Mohkhuli','782003',1,0,'2022-03-03 13:16:46','2022-03-03 13:16:46'),(98627,296,'Molankata','782103',1,0,'2022-03-03 13:16:46','2022-03-03 13:16:46'),(98628,296,'Mowamari','782140',1,0,'2022-03-03 13:16:46','2022-03-03 13:16:46'),(98629,296,'Murazar Bazar','782439',1,0,'2022-03-03 13:16:46','2022-03-03 13:16:46'),(98630,296,'Nagaon Girls  College','782001',1,0,'2022-03-03 13:16:46','2022-03-03 13:16:46'),(98631,296,'Nagaon H.O','782001',1,0,'2022-03-03 13:16:46','2022-03-03 13:16:46'),(98632,296,'Nagaon Padel','782003',1,0,'2022-03-03 13:16:46','2022-03-03 13:16:46'),(98633,296,'Nakhuti Bazar','782446',1,0,'2022-03-03 13:16:46','2022-03-03 13:16:46'),(98634,296,'Nandapur Chariali','782435',1,0,'2022-03-03 13:16:46','2022-03-03 13:16:46'),(98635,296,'Nibukali','782102',1,0,'2022-03-03 13:16:46','2022-03-03 13:16:46'),(98636,296,'Nilbagan','782445',1,0,'2022-03-03 13:16:46','2022-03-03 13:16:46'),(98637,296,'Niz-dhing','782123',1,0,'2022-03-03 13:16:46','2022-03-03 13:16:46'),(98638,296,'Niz-narikoli','782426',1,0,'2022-03-03 13:16:46','2022-03-03 13:16:46'),(98639,296,'Nonoi','782101',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98640,296,'Oper Uzaragaon','782101',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98641,296,'Padumoni','782140',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98642,296,'Padumpukhuri','782435',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98643,296,'Palasani','782003',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98644,296,'Parkup Pahar','782135',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98645,296,'Pathori','782003',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98646,296,'Patiachapari','782122',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98647,296,'Patiapam','782426',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98648,296,'Pipal Pukhuri','782446',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98649,296,'Potani Gomothagaon','782102',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98650,296,'Pub Amarakanda','782125',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98651,296,'Pub Baralimari','782124',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98652,296,'Pub Lumding Bazar','782447',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98653,296,'Pubguimari','782425',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98654,296,'Pubsalpara','782125',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98655,296,'Pubthoria','782137',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98656,296,'Purana Kaki','782442',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98657,296,'Puranigudam','782141',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98658,296,'Puthikhaiti','782125',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98659,296,'Puthimari Bazar','782426',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98660,296,'Radhanagar','782429',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98661,296,'Raha','782103',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98662,296,'Rahagaon','782103',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98663,296,'Rangagarah','782140',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98664,296,'Rantholi','782101',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98665,296,'Rengbeng','782427',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98666,296,'Rowmari','782125',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98667,296,'Rowmari Bill','782123',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98668,296,'Rupahi','782125',1,0,'2022-03-03 13:16:47','2022-03-03 13:16:47'),(98669,296,'Saidoria','782125',1,0,'2022-03-03 13:16:48','2022-03-03 13:16:48'),(98670,296,'Salana','782139',1,0,'2022-03-03 13:16:48','2022-03-03 13:16:48'),(98671,296,'Salmora','782425',1,0,'2022-03-03 13:16:48','2022-03-03 13:16:48'),(98672,296,'Samaguri','782140',1,0,'2022-03-03 13:16:48','2022-03-03 13:16:48'),(98673,296,'Samarail','782439',1,0,'2022-03-03 13:16:48','2022-03-03 13:16:48'),(98674,296,'Sambari Dagaon','782446',1,0,'2022-03-03 13:16:48','2022-03-03 13:16:48'),(98675,296,'Sankarpur','782446',1,0,'2022-03-03 13:16:48','2022-03-03 13:16:48'),(98676,296,'Saragaon','782103',1,0,'2022-03-03 13:16:48','2022-03-03 13:16:48'),(98677,296,'Sarishabari','782139',1,0,'2022-03-03 13:16:48','2022-03-03 13:16:48'),(98678,296,'Satlanga','782426',1,0,'2022-03-03 13:16:48','2022-03-03 13:16:48'),(98679,296,'Seconee Borhola','782136',1,0,'2022-03-03 13:16:48','2022-03-03 13:16:48'),(98680,296,'Senchowa','782002',1,0,'2022-03-03 13:16:48','2022-03-03 13:16:48'),(98681,296,'Sibasthan','782140',1,0,'2022-03-03 13:16:48','2022-03-03 13:16:48'),(98682,296,'Sibpur','782429',1,0,'2022-03-03 13:16:48','2022-03-03 13:16:48'),(98683,296,'Silghat','782143',1,0,'2022-03-03 13:16:48','2022-03-03 13:16:48'),(98684,296,'Siliguri','782435',1,0,'2022-03-03 13:16:48','2022-03-03 13:16:48'),(98685,296,'Silpukhuri','782123',1,0,'2022-03-03 13:16:48','2022-03-03 13:16:48'),(98686,296,'Simaluguri','782426',1,0,'2022-03-03 13:16:48','2022-03-03 13:16:48'),(98687,296,'Singari Madrassa','782124',1,0,'2022-03-03 13:16:49','2022-03-03 13:16:49'),(98688,296,'Singaribasti','782435',1,0,'2022-03-03 13:16:49','2022-03-03 13:16:49'),(98689,296,'Singia','782140',1,0,'2022-03-03 13:16:49','2022-03-03 13:16:49'),(98690,296,'Singimari','782125',1,0,'2022-03-03 13:16:49','2022-03-03 13:16:49'),(98691,296,'Solmari','782002',1,0,'2022-03-03 13:16:50','2022-03-03 13:16:50'),(98692,296,'Sologuri','782123',1,0,'2022-03-03 13:16:50','2022-03-03 13:16:50'),(98693,296,'Sonarigaon','782143',1,0,'2022-03-03 13:16:50','2022-03-03 13:16:50'),(98694,296,'Sonarigaon','782123',1,0,'2022-03-03 13:16:50','2022-03-03 13:16:50'),(98695,296,'Sutirpar','782124',1,0,'2022-03-03 13:16:50','2022-03-03 13:16:50'),(98696,296,'Tarabari','782125',1,0,'2022-03-03 13:16:50','2022-03-03 13:16:50'),(98697,296,'Teliabebejia','782124',1,0,'2022-03-03 13:16:50','2022-03-03 13:16:50'),(98698,296,'Teliachapari','782125',1,0,'2022-03-03 13:16:50','2022-03-03 13:16:50'),(98699,296,'Teliagaon','782141',1,0,'2022-03-03 13:16:50','2022-03-03 13:16:50'),(98700,296,'Telibasti','782435',1,0,'2022-03-03 13:16:50','2022-03-03 13:16:50'),(98701,296,'Teralangso','782446',1,0,'2022-03-03 13:16:50','2022-03-03 13:16:50'),(98702,296,'Tetelisara','782426',1,0,'2022-03-03 13:16:50','2022-03-03 13:16:50'),(98703,296,'Thaisupar','782446',1,0,'2022-03-03 13:16:50','2022-03-03 13:16:50'),(98704,296,'Tiniali Bazar','782446',1,0,'2022-03-03 13:16:50','2022-03-03 13:16:50'),(98705,296,'Tinsukia Juria','782124',1,0,'2022-03-03 13:16:50','2022-03-03 13:16:50'),(98706,296,'Tuktuki','782123',1,0,'2022-03-03 13:16:51','2022-03-03 13:16:51'),(98707,296,'Tulashimukh','782101',1,0,'2022-03-03 13:16:51','2022-03-03 13:16:51'),(98708,296,'Udalani Bazar','782446',1,0,'2022-03-03 13:16:51','2022-03-03 13:16:51'),(98709,296,'Udmari','782140',1,0,'2022-03-03 13:16:51','2022-03-03 13:16:51'),(98710,296,'Ulukunchi','782410',1,0,'2022-03-03 13:16:51','2022-03-03 13:16:51'),(98711,296,'Uriagaon','782003',1,0,'2022-03-03 13:16:51','2022-03-03 13:16:51'),(98712,296,'Uttar Petboha','782460',1,0,'2022-03-03 13:16:51','2022-03-03 13:16:51'),(98713,296,'Disrigaya Satra','785602',1,0,'2022-03-03 13:16:51','2022-03-03 13:16:51'),(98714,297,'Adabari','781126',1,0,'2022-03-03 13:16:51','2022-03-03 13:16:51'),(98715,297,'Adalbari','781372',1,0,'2022-03-03 13:16:51','2022-03-03 13:16:51'),(98716,297,'Ahopa','781373',1,0,'2022-03-03 13:16:51','2022-03-03 13:16:51'),(98717,297,'Allia','781369',1,0,'2022-03-03 13:16:51','2022-03-03 13:16:51'),(98718,297,'Amani','781306',1,0,'2022-03-03 13:16:51','2022-03-03 13:16:51'),(98719,297,'Amayapur','781367',1,0,'2022-03-03 13:16:51','2022-03-03 13:16:51'),(98720,297,'Amingaon Chowk','781343',1,0,'2022-03-03 13:16:51','2022-03-03 13:16:51'),(98721,297,'Angardhowa','781344',1,0,'2022-03-03 13:16:51','2022-03-03 13:16:51'),(98722,297,'Angarkata','781360',1,0,'2022-03-03 13:16:52','2022-03-03 13:16:52'),(98723,297,'Arangmow','781347',1,0,'2022-03-03 13:16:52','2022-03-03 13:16:52'),(98724,297,'Arara','781334',1,0,'2022-03-03 13:16:52','2022-03-03 13:16:52'),(98725,297,'Arikuchi','781339',1,0,'2022-03-03 13:16:52','2022-03-03 13:16:52'),(98726,297,'Assam Syntex','781355',1,0,'2022-03-03 13:16:52','2022-03-03 13:16:52'),(98727,297,'Athgharia','781347',1,0,'2022-03-03 13:16:52','2022-03-03 13:16:52'),(98728,297,'Athiabari','781377',1,0,'2022-03-03 13:16:52','2022-03-03 13:16:52'),(98729,297,'Bagalsroad Chowk','781348',1,0,'2022-03-03 13:16:52','2022-03-03 13:16:52'),(98730,297,'Baganpara','781344',1,0,'2022-03-03 13:16:52','2022-03-03 13:16:52'),(98731,297,'Bagrihati','781310',1,0,'2022-03-03 13:16:52','2022-03-03 13:16:52'),(98732,297,'Bagrikuthi','781368',1,0,'2022-03-03 13:16:52','2022-03-03 13:16:52'),(98733,297,'Bagulamari','781344',1,0,'2022-03-03 13:16:52','2022-03-03 13:16:52'),(98734,297,'Bakuajari','781340',1,0,'2022-03-03 13:16:52','2022-03-03 13:16:52'),(98735,297,'Bala','781339',1,0,'2022-03-03 13:16:52','2022-03-03 13:16:52'),(98736,297,'Bali','781378',1,0,'2022-03-03 13:16:52','2022-03-03 13:16:52'),(98737,297,'Balikaria','781341',1,0,'2022-03-03 13:16:52','2022-03-03 13:16:52'),(98738,297,'Balikuchi','781126',1,0,'2022-03-03 13:16:52','2022-03-03 13:16:52'),(98739,297,'Balilecha','781334',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98740,297,'Balitara','781349',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98741,297,'Balowa','781310',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98742,297,'Bamunbari','781312',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98743,297,'Banagram Chowk','781303',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98744,297,'Banagram','781303',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98745,297,'Banbari','781372',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98746,297,'Banekuchi','781340',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98747,297,'Bangaon (Nalbari)','781375',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98748,297,'Barajol','781369',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98749,297,'Barama','781346',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98750,297,'Baramchari','781355',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98751,297,'Barazara','781334',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98752,297,'Barbari','781351',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98753,297,'Barchakadal','781373',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98754,297,'Bardigheli','781334',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98755,297,'Barghopa','781312',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98756,297,'Baridatara','781351',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98757,297,'Barimakha','781333',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98758,297,'Barimukh','781372',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98759,297,'Barkhanajan','781337',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98760,297,'Barkhopa','781367',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98761,297,'Barkuriha','781348',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98762,297,'Barnaddi','781303',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98763,297,'Barnibari','781304',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98764,297,'Barpit','781378',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98765,297,'Barsimlaguri','781346',1,0,'2022-03-03 13:16:53','2022-03-03 13:16:53'),(98766,297,'Bartola','781138',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98767,297,'Batsar','781303',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98768,297,'Belsor','781304',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98769,297,'Bennabari','781333',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98770,297,'Bhadra','781334',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98771,297,'Bhaluki','781371',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98772,297,'Bhangnamari','781126',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98773,297,'Bhogarpar','781309',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98774,297,'Bhojkuchi','781378',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98775,297,'Bidyapur','781335',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98776,297,'Bihampur','781303',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98777,297,'Bonmaza','781304',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98778,297,'Bori','781338',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98779,297,'Budrukuchi','781348',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98780,297,'Burinagar','781341',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98781,297,'Chaibari','781343',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98782,297,'Chamata','781306',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98783,297,'Chanda','781126',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98784,297,'Chandkuchi','781334',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98785,297,'Chatama','781350',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98786,297,'Chechapani','781360',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98787,297,'Chenga','781305',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98788,297,'Chengoi','781337',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98789,297,'Chilling','781369',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98790,297,'Chinadi','781312',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98791,297,'Chowkbazar (Nalbari)','781334',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98792,297,'Dagapara','781126',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98793,297,'Dahkaunia','781346',1,0,'2022-03-03 13:16:54','2022-03-03 13:16:54'),(98794,297,'Daisingri','781329',1,0,'2022-03-03 13:16:55','2022-03-03 13:16:55'),(98795,297,'Dakhingaon','781350',1,0,'2022-03-03 13:16:55','2022-03-03 13:16:55'),(98796,297,'Dalbari','781333',1,0,'2022-03-03 13:16:55','2022-03-03 13:16:55'),(98797,297,'Dangarkuchi','781368',1,0,'2022-03-03 13:16:55','2022-03-03 13:16:55'),(98798,297,'Dangarmakha','781333',1,0,'2022-03-03 13:16:55','2022-03-03 13:16:55'),(98799,297,'Darangamela','781360',1,0,'2022-03-03 13:16:55','2022-03-03 13:16:55'),(98800,297,'Darangapara','781360',1,0,'2022-03-03 13:16:55','2022-03-03 13:16:55'),(98801,297,'Daulasal','781312',1,0,'2022-03-03 13:16:55','2022-03-03 13:16:55'),(98802,297,'Debachara','781333',1,0,'2022-03-03 13:16:55','2022-03-03 13:16:55'),(98803,297,'Deharkalakuchi','781310',1,0,'2022-03-03 13:16:55','2022-03-03 13:16:55'),(98804,297,'Dhanbil','781343',1,0,'2022-03-03 13:16:55','2022-03-03 13:16:55'),(98805,297,'Dhekipota','781368',1,0,'2022-03-03 13:16:55','2022-03-03 13:16:55'),(98806,297,'Dhuhi','781350',1,0,'2022-03-03 13:16:55','2022-03-03 13:16:55'),(98807,297,'Dighaldonga','781343',1,0,'2022-03-03 13:16:55','2022-03-03 13:16:55'),(98808,297,'Digheli','781371',1,0,'2022-03-03 13:16:55','2022-03-03 13:16:55'),(98809,297,'Dihira','781372',1,0,'2022-03-03 13:16:55','2022-03-03 13:16:55'),(98810,297,'Dirua','781304',1,0,'2022-03-03 13:16:55','2022-03-03 13:16:55'),(98811,297,'Dongpar','781368',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98812,297,'Doomni','781373',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98813,297,'Gamurimuri','781306',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98814,297,'Gandhia','781304',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98815,297,'Gandhibari','781367',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98816,297,'Garamdew','781377',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98817,297,'Gerua','781344',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98818,297,'Geruapara','781355',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98819,297,'Ghogpar','781367',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98820,297,'Ghograpar','781369',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98821,297,'Gobradal','781370',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98822,297,'Golibandha','781375',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98823,297,'Gopalbazar','781353',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98824,297,'Gopalthan','781334',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98825,297,'Guakuchi','781369',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98826,297,'Haribhanga','781378',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98827,297,'Hatinamati','781337',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98828,297,'Haziragaon','781360',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98829,297,'Helacha','781338',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98830,297,'Helana','781375',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98831,297,'Hidilatari','781138',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98832,297,'Jagra','781310',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98833,297,'Jalagaon','781373',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98834,297,'Jalkhana','781371',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98835,297,'Jalkhana','781378',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98836,297,'Janijog','781334',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98837,297,'Japadang','781343',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98838,297,'Jaysagar','781126',1,0,'2022-03-03 13:16:56','2022-03-03 13:16:56'),(98839,297,'Kachubari','781367',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98840,297,'Kachukata','781367',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98841,297,'Kachupathar','781138',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98842,297,'Kaithalkuchi','781370',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98843,297,'Kakaya','781304',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98844,297,'Kalag','781351',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98845,297,'Kalarchar','781312',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98846,297,'Kalaskuchi','781367',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98847,297,'Kalbari','781367',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98848,297,'Kalcheni','781368',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98849,297,'Kalipur','781360',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98850,297,'Kaljar','781346',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98851,297,'Kamarkuchi','781347',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98852,297,'Kamrupbarkhola','781350',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98853,297,'Kandhbari','781126',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98854,297,'Kaplabari','781138',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98855,297,'Karemura','781355',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98856,297,'Karia','781339',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98857,297,'Kataligaon','781372',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98858,297,'Kathalbari','781346',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98859,297,'Kauli','781360',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98860,297,'Kazipara','781341',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98861,297,'Kekankuchi','781138',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98862,297,'Kendukuchi','781341',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98863,297,'Khakrisal','781310',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98864,297,'Kharsitha','781370',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98865,297,'Kharua','781346',1,0,'2022-03-03 13:16:57','2022-03-03 13:16:57'),(98866,297,'Khatabari','781335',1,0,'2022-03-03 13:16:58','2022-03-03 13:16:58'),(98867,297,'Khatikuchi','781369',1,0,'2022-03-03 13:16:58','2022-03-03 13:16:58'),(98868,297,'Khgrabari','781344',1,0,'2022-03-03 13:16:58','2022-03-03 13:16:58'),(98869,297,'Kukundi','781340',1,0,'2022-03-03 13:16:58','2022-03-03 13:16:58'),(98870,297,'Kumarikata','781360',1,0,'2022-03-03 13:16:58','2022-03-03 13:16:58'),(98871,297,'Lachima','781312',1,0,'2022-03-03 13:16:58','2022-03-03 13:16:58'),(98872,297,'Lafakuxchi','781377',1,0,'2022-03-03 13:16:58','2022-03-03 13:16:58'),(98873,297,'Lahkarpara','781350',1,0,'2022-03-03 13:16:58','2022-03-03 13:16:58'),(98874,297,'Lakhopur','781338',1,0,'2022-03-03 13:16:58','2022-03-03 13:16:58'),(98875,297,'Larkuchi','781138',1,0,'2022-03-03 13:16:58','2022-03-03 13:16:58'),(98876,297,'Latibari','781368',1,0,'2022-03-03 13:16:58','2022-03-03 13:16:58'),(98877,297,'Loharkata','781126',1,0,'2022-03-03 13:16:58','2022-03-03 13:16:58'),(98878,297,'Lowpara','781126',1,0,'2022-03-03 13:16:58','2022-03-03 13:16:58'),(98879,297,'Lowtola','781126',1,0,'2022-03-03 13:16:58','2022-03-03 13:16:58'),(98880,297,'Madhapur','781346',1,0,'2022-03-03 13:16:58','2022-03-03 13:16:58'),(98881,297,'Mahina','781349',1,0,'2022-03-03 13:16:58','2022-03-03 13:16:58'),(98882,297,'Makhibaha','781374',1,0,'2022-03-03 13:16:59','2022-03-03 13:16:59'),(98883,297,'Marowa','781348',1,0,'2022-03-03 13:16:59','2022-03-03 13:16:59'),(98884,297,'Mazdia','781367',1,0,'2022-03-03 13:16:59','2022-03-03 13:16:59'),(98885,297,'Medaghat','781355',1,0,'2022-03-03 13:16:59','2022-03-03 13:16:59'),(98886,297,'Menaka','781360',1,0,'2022-03-03 13:16:59','2022-03-03 13:16:59'),(98887,297,'Meritary','781126',1,0,'2022-03-03 13:16:59','2022-03-03 13:16:59'),(98888,297,'Merkuchi','781346',1,0,'2022-03-03 13:16:59','2022-03-03 13:16:59'),(98889,297,'Milanpur','781337',1,0,'2022-03-03 13:16:59','2022-03-03 13:16:59'),(98890,297,'Motipur','781372',1,0,'2022-03-03 13:17:00','2022-03-03 13:17:00'),(98891,297,'Mugdi','781312',1,0,'2022-03-03 13:17:00','2022-03-03 13:17:00'),(98892,297,'Mugkuchi','781334',1,0,'2022-03-03 13:17:00','2022-03-03 13:17:00'),(98893,297,'Mukalmua','781126',1,0,'2022-03-03 13:17:00','2022-03-03 13:17:00'),(98894,297,'Muktapur','781344',1,0,'2022-03-03 13:17:00','2022-03-03 13:17:00'),(98895,297,'Mularkuchi','781303',1,0,'2022-03-03 13:17:00','2022-03-03 13:17:00'),(98896,297,'Murmela','781346',1,0,'2022-03-03 13:17:00','2022-03-03 13:17:00'),(98897,297,'Mussalpur','781372',1,0,'2022-03-03 13:17:00','2022-03-03 13:17:00'),(98898,297,'Nagrijuli','781368',1,0,'2022-03-03 13:17:00','2022-03-03 13:17:00'),(98899,297,'Naherbari','781349',1,0,'2022-03-03 13:17:00','2022-03-03 13:17:00'),(98900,297,'Nakhara','781371',1,0,'2022-03-03 13:17:00','2022-03-03 13:17:00'),(98901,297,'Nalbari H.O','781335',1,0,'2022-03-03 13:17:00','2022-03-03 13:17:00'),(98902,297,'Nankarbhaira','781369',1,0,'2022-03-03 13:17:00','2022-03-03 13:17:00'),(98903,297,'Narayanpur','781126',1,0,'2022-03-03 13:17:00','2022-03-03 13:17:00'),(98904,297,'Narayanpur','781372',1,0,'2022-03-03 13:17:00','2022-03-03 13:17:00'),(98905,297,'Narua','781138',1,0,'2022-03-03 13:17:00','2022-03-03 13:17:00'),(98906,297,'Nathkuchi','781355',1,0,'2022-03-03 13:17:00','2022-03-03 13:17:00'),(98907,297,'Natunhowly','781367',1,0,'2022-03-03 13:17:00','2022-03-03 13:17:00'),(98908,297,'Nayabasti','781344',1,0,'2022-03-03 13:17:00','2022-03-03 13:17:00'),(98909,297,'Nichalamari','781349',1,0,'2022-03-03 13:17:00','2022-03-03 13:17:00'),(98910,297,'Nikashi','781372',1,0,'2022-03-03 13:17:00','2022-03-03 13:17:00'),(98911,297,'Niz Bahjani','781334',1,0,'2022-03-03 13:17:00','2022-03-03 13:17:00'),(98912,297,'Niz Namati','781355',1,0,'2022-03-03 13:17:00','2022-03-03 13:17:00'),(98913,297,'Nizbangalipara','781333',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98914,297,'Nizdafeli','781367',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98915,297,'Nizdhamdhama','781349',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98916,297,'Nizpakoa','781353',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98917,297,'Nizsantipur','781349',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98918,297,'Niztapa','781338',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98919,297,'Pachim Kajia Gaon','781138',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98920,297,'Pachimchamata','781306',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98921,297,'Pachimjargaon','781367',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98922,297,'Pacim Mazdia','781305',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98923,297,'Paddapar','781367',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98924,297,'Paharpur','781360',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98925,297,'Pakhamara','781343',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98926,297,'Pakribari','781360',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98927,297,'Pamuapathar','781372',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98928,297,'Panigaon','781303',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98929,297,'Patkijuli','781360',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98930,297,'Peradhara','781312',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98931,297,'Piplibari','781338',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98932,297,'Pub Baramchari','781333',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98933,297,'Pubkalakuchi','781348',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98934,297,'Rampur','781377',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98935,297,'Rampur Dekapara','781375',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98936,297,'Rampur (Nalbari)','781312',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98937,297,'Raumaripathar','781312',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98938,297,'Rupia Bathan','781306',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98939,297,'Sandheli','781353',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98940,297,'Sanekuchi','781350',1,0,'2022-03-03 13:17:01','2022-03-03 13:17:01'),(98941,297,'Saraimari','781377',1,0,'2022-03-03 13:17:02','2022-03-03 13:17:02'),(98942,297,'Satala','781312',1,0,'2022-03-03 13:17:02','2022-03-03 13:17:02'),(98943,297,'Sathimuka','781355',1,0,'2022-03-03 13:17:02','2022-03-03 13:17:02'),(98944,297,'Saukuchi','781333',1,0,'2022-03-03 13:17:02','2022-03-03 13:17:02'),(98945,297,'Sauramari','781350',1,0,'2022-03-03 13:17:02','2022-03-03 13:17:02'),(98946,297,'Sialmari','781371',1,0,'2022-03-03 13:17:02','2022-03-03 13:17:02'),(98947,297,'Sidhinathpur','781368',1,0,'2022-03-03 13:17:02','2022-03-03 13:17:02'),(98948,297,'Solmara','781338',1,0,'2022-03-03 13:17:02','2022-03-03 13:17:02'),(98949,297,'Sondha','781337',1,0,'2022-03-03 13:17:02','2022-03-03 13:17:02'),(98950,297,'Subankhata','781372',1,0,'2022-03-03 13:17:02','2022-03-03 13:17:02'),(98951,297,'Sukurngbari','781317',1,0,'2022-03-03 13:17:02','2022-03-03 13:17:02'),(98952,297,'Suradi','781340',1,0,'2022-03-03 13:17:02','2022-03-03 13:17:02'),(98953,297,'Tambulpur','781367',1,0,'2022-03-03 13:17:02','2022-03-03 13:17:02'),(98954,297,'Terechia','781334',1,0,'2022-03-03 13:17:02','2022-03-03 13:17:02'),(98955,297,'Thamna (Nalbari)','781377',1,0,'2022-03-03 13:17:02','2022-03-03 13:17:02'),(98956,297,'Thanguri','781333',1,0,'2022-03-03 13:17:02','2022-03-03 13:17:02'),(98957,297,'Tihu','781371',1,0,'2022-03-03 13:17:02','2022-03-03 13:17:02'),(98958,297,'Tinpukhuri','781367',1,0,'2022-03-03 13:17:02','2022-03-03 13:17:02'),(98959,297,'Trbitola','781368',1,0,'2022-03-03 13:17:02','2022-03-03 13:17:02'),(98960,297,'Ulabari','781339',1,0,'2022-03-03 13:17:02','2022-03-03 13:17:02'),(98961,297,'Ulubari','781367',1,0,'2022-03-03 13:17:02','2022-03-03 13:17:02'),(98962,297,'Uttarbarsiral','781349',1,0,'2022-03-03 13:17:02','2022-03-03 13:17:02'),(98963,297,'Uttarkuchi','781372',1,0,'2022-03-03 13:17:03','2022-03-03 13:17:03'),(98964,297,'Zarkona','781367',1,0,'2022-03-03 13:17:03','2022-03-03 13:17:03'),(98965,298,'Assam Quary','788931',1,0,'2022-03-03 13:17:03','2022-03-03 13:17:03'),(98966,298,'Bagetar','788820',1,0,'2022-03-03 13:17:03','2022-03-03 13:17:03'),(98967,298,'Bandarkhal','788818',1,0,'2022-03-03 13:17:03','2022-03-03 13:17:03'),(98968,298,'Baro Mulkoi','788818',1,0,'2022-03-03 13:17:03','2022-03-03 13:17:03'),(98969,298,'Borolabang','788931',1,0,'2022-03-03 13:17:03','2022-03-03 13:17:03'),(98970,298,'Christiankempai','788819',1,0,'2022-03-03 13:17:03','2022-03-03 13:17:03'),(98971,298,'Dautohaza','788830',1,0,'2022-03-03 13:17:03','2022-03-03 13:17:03'),(98972,298,'Dehangi','788819',1,0,'2022-03-03 13:17:03','2022-03-03 13:17:03'),(98973,298,'Dezabra','788832',1,0,'2022-03-03 13:17:03','2022-03-03 13:17:03'),(98974,298,'Dibari','788819',1,0,'2022-03-03 13:17:03','2022-03-03 13:17:03'),(98975,298,'Dintharveng','788819',1,0,'2022-03-03 13:17:03','2022-03-03 13:17:03'),(98976,298,'Dittakcherra','788818',1,0,'2022-03-03 13:17:03','2022-03-03 13:17:03'),(98977,298,'Diyumbra','788931',1,0,'2022-03-03 13:17:03','2022-03-03 13:17:03'),(98978,298,'Dwarband','788113',1,0,'2022-03-03 13:17:03','2022-03-03 13:17:03'),(98979,298,'Electric Veng','788820',1,0,'2022-03-03 13:17:03','2022-03-03 13:17:03'),(98980,298,'Fengpui','788819',1,0,'2022-03-03 13:17:03','2022-03-03 13:17:03'),(98981,298,'Garampani','788931',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(98982,298,'Govindanagar','788931',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(98983,298,'Gunjung','788819',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(98984,298,'Haflo R.S.','788820',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(98985,298,'Haflong Bazar','788819',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(98986,298,'Haflong Ptc','788820',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(98987,298,'Haflong','788819',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(98988,298,'Hajang','788831',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(98989,298,'Hange','788830',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(98990,298,'Hangrum','788830',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(98991,298,'Harengajao','788818',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(98992,298,'Hatikhali','788832',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(98993,298,'Hazadisha','788831',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(98994,298,'Impui Hindu','788830',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(98995,298,'Jatinga','788818',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(98996,298,'Jatinga Tenali','788819',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(98997,298,'Kanaan','788819',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(98998,298,'Kanabasti','788819',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(98999,298,'Kaprey','788831',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(99000,298,'Kharthang','788818',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(99001,298,'Khejurbond','788831',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(99002,298,'Khognam','788830',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(99003,298,'Laisang Bagan','788830',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(99004,298,'Langting Hasin','788832',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(99005,298,'Langting','788832',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(99006,298,'Lasang','788830',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(99007,298,'Lodikachari','788108',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(99008,298,'Longkhu','788931',1,0,'2022-03-03 13:17:04','2022-03-03 13:17:04'),(99009,298,'Mahur','788830',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99010,298,'Maibong','788831',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99011,298,'Mailongdisha','788818',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99012,298,'Mandardisha','788832',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99013,298,'Manigipur','788831',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99014,298,'Michidui','788819',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99015,298,'Mouthoi','788819',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99016,298,'Mupa','788832',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99017,298,'Nablaidisha','788831',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99018,298,'Narainpur','788818',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99019,298,'Narsingwari','788819',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99020,298,'Panch Kilometer','788931',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99021,298,'Pangmoul','788830',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99022,298,'Redzol','788818',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99023,298,'Sangbar','788931',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99024,298,'Santilla','788819',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99025,298,'Saran','788830',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99026,298,'Sarkari Bagan','788820',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99027,298,'Simtuilong','788831',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99028,298,'Sonpijang','788819',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99029,298,'Topadisa','788820',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99030,298,'Tulpoi','788830',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99031,298,'Umrangshu','788931',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99032,298,'Venzaul','788830',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99033,298,'Wardendisha','788831',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99034,298,'Zion','788820',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99035,299,'Afala','785663',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99036,299,'Aideopukhuri','785690',1,0,'2022-03-03 13:17:05','2022-03-03 13:17:05'),(99037,299,'Ailamukh','785664',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99038,299,'Akhoi Phutia','785697',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99039,299,'Amguri Haloating','785681',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99040,299,'Amguri','785680',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99041,299,'Amkotia','785697',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99042,299,'Amtoll Chintamoni','785682',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99043,299,'Arjun Guri','785697',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99044,299,'Athkhel','785696',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99045,299,'Baghjan Grant','785681',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99046,299,'Baghshumout','785697',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99047,299,'Bakhor Bengena','785674',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99048,299,'Baliaghat','785667',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99049,299,'Bam Rajabari','785671',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99050,299,'Bamunpukhuri','785685',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99051,299,'Bamunpukhuri','785683',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99052,299,'Banmukh','785663',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99053,299,'Barbaruakhat','785692',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99054,299,'Barhoiting','785697',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99055,299,'Barpatra Te','785693',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99056,299,'Barua Ali','785684',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99057,299,'Barua Chali','785693',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99058,299,'Baruagaon','785692',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99059,299,'Baruanagar','785692',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99060,299,'Baruatigaon','785661',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99061,299,'Bauli Maidam','785685',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99062,299,'Baulipukhuri Sensua','785684',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99063,299,'Bekadolong','785690',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99064,299,'Bengenabari','785690',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99065,299,'Betbari','785640',1,0,'2022-03-03 13:17:06','2022-03-03 13:17:06'),(99066,299,'Betena','785663',1,0,'2022-03-03 13:17:07','2022-03-03 13:17:07'),(99067,299,'Bhadhara','785701',1,0,'2022-03-03 13:17:07','2022-03-03 13:17:07'),(99068,299,'Bhalukaguri','785691',1,0,'2022-03-03 13:17:07','2022-03-03 13:17:07'),(99069,299,'Bharali Pukhuri','785691',1,0,'2022-03-03 13:17:07','2022-03-03 13:17:07'),(99070,299,'Bharalua Tiniali SVS','785664',1,0,'2022-03-03 13:17:07','2022-03-03 13:17:07'),(99071,299,'Bhatiapar','785667',1,0,'2022-03-03 13:17:07','2022-03-03 13:17:07'),(99072,299,'Bhitarual','785682',1,0,'2022-03-03 13:17:07','2022-03-03 13:17:07'),(99073,299,'Bhogamukh','785682',1,0,'2022-03-03 13:17:07','2022-03-03 13:17:07'),(99074,299,'Bhogbari Kanugaon','785692',1,0,'2022-03-03 13:17:07','2022-03-03 13:17:07'),(99075,299,'Bhuyanhat','785680',1,0,'2022-03-03 13:17:07','2022-03-03 13:17:07'),(99076,299,'Bihubar','785687',1,0,'2022-03-03 13:17:07','2022-03-03 13:17:07'),(99077,299,'Bihubar Te','785685',1,0,'2022-03-03 13:17:07','2022-03-03 13:17:07'),(99078,299,'Bishrampur','785670',1,0,'2022-03-03 13:17:07','2022-03-03 13:17:07'),(99079,299,'Bogidole','785697',1,0,'2022-03-03 13:17:07','2022-03-03 13:17:07'),(99080,299,'Bokota Chand Bessa','785674',1,0,'2022-03-03 13:17:08','2022-03-03 13:17:08'),(99081,299,'Bonai','785683',1,0,'2022-03-03 13:17:08','2022-03-03 13:17:08'),(99082,299,'Bonomali','785689',1,0,'2022-03-03 13:17:08','2022-03-03 13:17:08'),(99083,299,'Borahibari','785680',1,0,'2022-03-03 13:17:08','2022-03-03 13:17:08'),(99084,299,'Borahigaon','785691',1,0,'2022-03-03 13:17:08','2022-03-03 13:17:08'),(99085,299,'Borbam Te','785680',1,0,'2022-03-03 13:17:08','2022-03-03 13:17:08'),(99086,299,'Borhat','785693',1,0,'2022-03-03 13:17:08','2022-03-03 13:17:08'),(99087,299,'Bortol','785685',1,0,'2022-03-03 13:17:08','2022-03-03 13:17:08'),(99088,299,'Chakalia','785673',1,0,'2022-03-03 13:17:08','2022-03-03 13:17:08'),(99089,299,'Chakimukh','785685',1,0,'2022-03-03 13:17:08','2022-03-03 13:17:08'),(99090,299,'Chalangpathar','785705',1,0,'2022-03-03 13:17:08','2022-03-03 13:17:08'),(99091,299,'Chalapather','785688',1,0,'2022-03-03 13:17:08','2022-03-03 13:17:08'),(99092,299,'Chamua Khanikar','785661',1,0,'2022-03-03 13:17:08','2022-03-03 13:17:08'),(99093,299,'Changmai','785693',1,0,'2022-03-03 13:17:08','2022-03-03 13:17:08'),(99094,299,'Charagua','785672',1,0,'2022-03-03 13:17:08','2022-03-03 13:17:08'),(99095,299,'Charaimuria','785666',1,0,'2022-03-03 13:17:09','2022-03-03 13:17:09'),(99096,299,'Charing','785661',1,0,'2022-03-03 13:17:09','2022-03-03 13:17:09'),(99097,299,'Charingia  Pukhuri','785680',1,0,'2022-03-03 13:17:09','2022-03-03 13:17:09'),(99098,299,'Charubhanga Dihingia','785674',1,0,'2022-03-03 13:17:09','2022-03-03 13:17:09'),(99099,299,'Chataichiga Kakotigaon','785680',1,0,'2022-03-03 13:17:09','2022-03-03 13:17:09'),(99100,299,'Chaulkara','785667',1,0,'2022-03-03 13:17:09','2022-03-03 13:17:09'),(99101,299,'Chenimora','785663',1,0,'2022-03-03 13:17:09','2022-03-03 13:17:09'),(99102,299,'Chepangpani','785685',1,0,'2022-03-03 13:17:09','2022-03-03 13:17:09'),(99103,299,'Cherekapar','785701',1,0,'2022-03-03 13:17:09','2022-03-03 13:17:09'),(99104,299,'Chetia Gaon','785684',1,0,'2022-03-03 13:17:09','2022-03-03 13:17:09'),(99105,299,'Chintamoni','785682',1,0,'2022-03-03 13:17:09','2022-03-03 13:17:09'),(99106,299,'Chirakhunda Chariali','785666',1,0,'2022-03-03 13:17:09','2022-03-03 13:17:09'),(99107,299,'Chotianaguri','785692',1,0,'2022-03-03 13:17:09','2022-03-03 13:17:09'),(99108,299,'Dagaon','785682',1,0,'2022-03-03 13:17:09','2022-03-03 13:17:09'),(99109,299,'Dariagaon','785107',1,0,'2022-03-03 13:17:10','2022-03-03 13:17:10'),(99110,299,'Daya Chariali','785701',1,0,'2022-03-03 13:17:10','2022-03-03 13:17:10'),(99111,299,'Deepling','785691',1,0,'2022-03-03 13:17:10','2022-03-03 13:17:10'),(99112,299,'Dehajan','785662',1,0,'2022-03-03 13:17:10','2022-03-03 13:17:10'),(99113,299,'Dekhowmukh','785664',1,0,'2022-03-03 13:17:10','2022-03-03 13:17:10'),(99114,299,'Demow','785662',1,0,'2022-03-03 13:17:10','2022-03-03 13:17:10'),(99115,299,'Demowmukh','785663',1,0,'2022-03-03 13:17:10','2022-03-03 13:17:10'),(99116,299,'Deogharia','785696',1,0,'2022-03-03 13:17:10','2022-03-03 13:17:10'),(99117,299,'Deopani  Habigaon','785693',1,0,'2022-03-03 13:17:10','2022-03-03 13:17:10'),(99118,299,'Deoraja Maidum','785680',1,0,'2022-03-03 13:17:10','2022-03-03 13:17:10'),(99119,299,'Deorihabi Chakalia','785669',1,0,'2022-03-03 13:17:10','2022-03-03 13:17:10'),(99120,299,'Deroi Habi Chak','785680',1,0,'2022-03-03 13:17:10','2022-03-03 13:17:10'),(99121,299,'Desanghat','785672',1,0,'2022-03-03 13:17:10','2022-03-03 13:17:10'),(99122,299,'Desnagpani','785689',1,0,'2022-03-03 13:17:10','2022-03-03 13:17:10'),(99123,299,'Dhai Ali','785697',1,0,'2022-03-03 13:17:10','2022-03-03 13:17:10'),(99124,299,'Dhitaipukhuri','785685',1,0,'2022-03-03 13:17:10','2022-03-03 13:17:10'),(99125,299,'Dholebagan','785686',1,0,'2022-03-03 13:17:10','2022-03-03 13:17:10'),(99126,299,'Dhopbar','785687',1,0,'2022-03-03 13:17:10','2022-03-03 13:17:10'),(99127,299,'Dhuniapathar','785692',1,0,'2022-03-03 13:17:10','2022-03-03 13:17:10'),(99128,299,'Dihing Mukh','785671',1,0,'2022-03-03 13:17:10','2022-03-03 13:17:10'),(99129,299,'Dihingia Gaon','785671',1,0,'2022-03-03 13:17:10','2022-03-03 13:17:10'),(99130,299,'Dikhow Botua','785670',1,0,'2022-03-03 13:17:10','2022-03-03 13:17:10'),(99131,299,'Dikshu','785684',1,0,'2022-03-03 13:17:10','2022-03-03 13:17:10'),(99132,299,'Dillighat','785693',1,0,'2022-03-03 13:17:10','2022-03-03 13:17:10'),(99133,299,'Disangmukh','785663',1,0,'2022-03-03 13:17:10','2022-03-03 13:17:10'),(99134,299,'Domurdullung','785673',1,0,'2022-03-03 13:17:10','2022-03-03 13:17:10'),(99135,299,'Dopdhar','785681',1,0,'2022-03-03 13:17:11','2022-03-03 13:17:11'),(99136,299,'Dubba','785673',1,0,'2022-03-03 13:17:11','2022-03-03 13:17:11'),(99137,299,'Duliagaon','785697',1,0,'2022-03-03 13:17:11','2022-03-03 13:17:11'),(99138,299,'Gargaon','785685',1,0,'2022-03-03 13:17:11','2022-03-03 13:17:11'),(99139,299,'Gaurisagar','785664',1,0,'2022-03-03 13:17:11','2022-03-03 13:17:11'),(99140,299,'Geleky','785696',1,0,'2022-03-03 13:17:11','2022-03-03 13:17:11'),(99141,299,'Ghaorajaan','785692',1,0,'2022-03-03 13:17:11','2022-03-03 13:17:11'),(99142,299,'Gohaingaon','785697',1,0,'2022-03-03 13:17:11','2022-03-03 13:17:11'),(99143,299,'Gomariguri','785705',1,0,'2022-03-03 13:17:11','2022-03-03 13:17:11'),(99144,299,'Gorbhanga','785671',1,0,'2022-03-03 13:17:11','2022-03-03 13:17:11'),(99145,299,'Gormur Miri Gaon','785687',1,0,'2022-03-03 13:17:11','2022-03-03 13:17:11'),(99146,299,'Hafaluting','785661',1,0,'2022-03-03 13:17:11','2022-03-03 13:17:11'),(99147,299,'Hahchara','785701',1,0,'2022-03-03 13:17:11','2022-03-03 13:17:11'),(99148,299,'Halouating Grant','785681',1,0,'2022-03-03 13:17:11','2022-03-03 13:17:11'),(99149,299,'Hatighuli','785664',1,0,'2022-03-03 13:17:11','2022-03-03 13:17:11'),(99150,299,'Hatipoti Grant','785696',1,0,'2022-03-03 13:17:11','2022-03-03 13:17:11'),(99151,299,'Hologuri','785673',1,0,'2022-03-03 13:17:11','2022-03-03 13:17:11'),(99152,299,'Hudupara','785685',1,0,'2022-03-03 13:17:11','2022-03-03 13:17:11'),(99153,299,'Jalukgaon','785680',1,0,'2022-03-03 13:17:11','2022-03-03 13:17:11'),(99154,299,'Jelengi Top','785682',1,0,'2022-03-03 13:17:11','2022-03-03 13:17:11'),(99155,299,'Jhanji Hah Chara','785683',1,0,'2022-03-03 13:17:11','2022-03-03 13:17:11'),(99156,299,'Jhanji Jamuguri','785683',1,0,'2022-03-03 13:17:11','2022-03-03 13:17:11'),(99157,299,'Jhanji','785683',1,0,'2022-03-03 13:17:11','2022-03-03 13:17:11'),(99158,299,'Joirapar','785697',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99159,299,'Jorabari','785683',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99160,299,'Joysagar','785665',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99161,299,'Kachamari','785705',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99162,299,'Kachumari','785670',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99163,299,'Kakotibari','785691',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99164,299,'Kalioni','785664',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99165,299,'Kaloogaon','785666',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99166,299,'Karchowa','785684',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99167,299,'Karigaon','785667',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99168,299,'Kawaimari Gohaingaon','785683',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99169,299,'Kenduguri','785697',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99170,299,'Khaloighogra','785688',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99171,299,'Khelua','785701',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99172,299,'Khemdeo Pukhuri','785666',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99173,299,'Khemon','785697',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99174,299,'Khona Khokra','785664',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99175,299,'Khonamukh','785682',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99176,299,'Khorahat','785662',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99177,299,'Koibatra Dolonigaon','785672',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99178,299,'Komorajan','785664',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99179,299,'Konwar Dihingia','785662',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99180,299,'Konwarpur','785667',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99181,299,'Korokani','785691',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99182,299,'Lahowal','785682',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99183,299,'Lakhimi Jan','785685',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99184,299,'Lakowah','785688',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99185,299,'Lakwah R.S.','785698',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99186,299,'Lalimchiga','785680',1,0,'2022-03-03 13:17:12','2022-03-03 13:17:12'),(99187,299,'Lefera','785693',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99188,299,'Ligiripukhuri','785685',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99189,299,'Longpotia','785692',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99190,299,'Mackeypure','785685',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99191,299,'Madhavnagar','785681',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99192,299,'Maduri','785685',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99193,299,'Mahmora Balijan','785691',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99194,299,'Maibella','785689',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99195,299,'Majbari','785680',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99196,299,'Merapani','785705',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99197,299,'Messagarh','785697',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99198,299,'Meteka','785697',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99199,299,'Mezenga','785685',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99200,299,'Miripather','785691',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99201,299,'Missajan','785684',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99202,299,'Mithapukhuri','785697',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99203,299,'Mogorahat','785666',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99204,299,'Mohkhuti','785669',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99205,299,'Mon Mohan Gaon','785689',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99206,299,'Morabazar','785680',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99207,299,'Moran','785669',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99208,299,'Moranchiga','785683',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99209,299,'Moranhat','785670',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99210,299,'Moranjan','785673',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99211,299,'Mori Jhanji','785682',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99212,299,'Mothurapur','785689',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99213,299,'Moudumuni','785673',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99214,299,'Moutga R.S.','785686',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99215,299,'Na Pam Baruati','785684',1,0,'2022-03-03 13:17:13','2022-03-03 13:17:13'),(99216,299,'Nagadhuli','785633',1,0,'2022-03-03 13:17:14','2022-03-03 13:17:14'),(99217,299,'Nagahat','785692',1,0,'2022-03-03 13:17:14','2022-03-03 13:17:14'),(99218,299,'Nagaon','785687',1,0,'2022-03-03 13:17:14','2022-03-03 13:17:14'),(99219,299,'Nahat','785662',1,0,'2022-03-03 13:17:14','2022-03-03 13:17:14'),(99220,299,'Nakatani','785667',1,0,'2022-03-03 13:17:14','2022-03-03 13:17:14'),(99221,299,'Nakhana','785664',1,0,'2022-03-03 13:17:14','2022-03-03 13:17:14'),(99222,299,'Namti','785685',1,0,'2022-03-03 13:17:14','2022-03-03 13:17:14'),(99223,299,'Namti Bamungaon','785684',1,0,'2022-03-03 13:17:14','2022-03-03 13:17:14'),(99224,299,'Namti Chariali','785684',1,0,'2022-03-03 13:17:14','2022-03-03 13:17:14'),(99225,299,'Namtial Gaon','785666',1,0,'2022-03-03 13:17:14','2022-03-03 13:17:14'),(99226,299,'Namtial Pathar','785684',1,0,'2022-03-03 13:17:14','2022-03-03 13:17:14'),(99227,299,'Namtial Pathar','785697',1,0,'2022-03-03 13:17:14','2022-03-03 13:17:14'),(99228,299,'Namtidoll','785684',1,0,'2022-03-03 13:17:14','2022-03-03 13:17:14'),(99229,299,'Namtola','785690',1,0,'2022-03-03 13:17:14','2022-03-03 13:17:14'),(99230,299,'Napam Bekajan','785682',1,0,'2022-03-03 13:17:14','2022-03-03 13:17:14'),(99231,299,'Napam Deopani','785684',1,0,'2022-03-03 13:17:14','2022-03-03 13:17:14'),(99232,299,'Naphuk','785689',1,0,'2022-03-03 13:17:14','2022-03-03 13:17:14'),(99233,299,'Nazira Dulakakharia','785696',1,0,'2022-03-03 13:17:14','2022-03-03 13:17:14'),(99234,299,'Nazira','785685',1,0,'2022-03-03 13:17:14','2022-03-03 13:17:14'),(99235,299,'Nemuguri','785674',1,0,'2022-03-03 13:17:14','2022-03-03 13:17:14'),(99236,299,'Nimaigarh Habi','785687',1,0,'2022-03-03 13:17:14','2022-03-03 13:17:14'),(99237,299,'Nimonagarh','785689',1,0,'2022-03-03 13:17:14','2022-03-03 13:17:14'),(99238,299,'Nitaipukhuri','785671',1,0,'2022-03-03 13:17:14','2022-03-03 13:17:14'),(99239,299,'Nogagaon','785701',1,0,'2022-03-03 13:17:14','2022-03-03 13:17:14'),(99240,299,'Nongalmora  Tiniali','785674',1,0,'2022-03-03 13:17:14','2022-03-03 13:17:14'),(99241,299,'Ongc Colony','785697',1,0,'2022-03-03 13:17:14','2022-03-03 13:17:14'),(99242,299,'Ouguri Shyam','785692',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99243,299,'Palengi','785672',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99244,299,'Panbecha','785663',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99245,299,'Panibill','785685',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99246,299,'Panichokua','785006',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99247,299,'Paruliguri','785671',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99248,299,'Pathalial','785683',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99249,299,'Patsaku','785673',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99250,299,'Photikachowa','785670',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99251,299,'Phukannagar','785640',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99252,299,'Phulpanichiga','785683',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99253,299,'Pioli Pukhuri','785685',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99254,299,'Pohuchungi Pather','785691',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99255,299,'Rahan','785692',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99256,299,'Rajapool','785685',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99257,299,'Rajmai','785672',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99258,299,'Rajmao','785685',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99259,299,'Ramaniali','785686',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99260,299,'Ramugaon','785686',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99261,299,'Rangoli','785670',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99262,299,'Ratanpur Sishupani','785705',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99263,299,'Ratomora','785670',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99264,299,'Robigaon','785683',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99265,299,'Rong Ghar Chariali','785665',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99266,299,'Ronga Bam Habi','785691',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99267,299,'Rongpurnagar','785640',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99268,299,'Rowmara','785614',1,0,'2022-03-03 13:17:15','2022-03-03 13:17:15'),(99269,299,'Rudrasagar','785665',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99270,299,'Rupahi Mukh','785664',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99271,299,'Samguri','785680',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99272,299,'Samukajan','785671',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99273,299,'Santak','785687',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99274,299,'Santipur','785667',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99275,299,'Sapekhati','785705',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99276,299,'Sapekhati','785692',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99277,299,'Saru Mothuria','785688',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99278,299,'Sepon','785673',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99279,299,'Silakuti','785698',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99280,299,'Silasaku','785686',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99281,299,'Siloni Nagar','785693',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99282,299,'Silonijan','785602',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99283,299,'Silpukhuri','785664',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99284,299,'Simaluguri','785686',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99285,299,'Singhaduar','785701',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99286,299,'Singyhbill','785696',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99287,299,'Sivasagar H.O','785640',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99288,299,'Sologuri','785666',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99289,299,'Sonari (Sibsagar)','785690',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99290,299,'Suffry','785689',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99291,299,'Sukan Pukhuri','785697',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99292,299,'Tamulibari','785616',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99293,299,'Tamulichiga','785682',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99294,299,'Telishal','785705',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99295,299,'Tengaponia','785671',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99296,299,'Tengapukhuri','785686',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99297,299,'Teok Gaon','785691',1,0,'2022-03-03 13:17:16','2022-03-03 13:17:16'),(99298,299,'Teokghat','785690',1,0,'2022-03-03 13:17:17','2022-03-03 13:17:17'),(99299,299,'Teteliguri','785683',1,0,'2022-03-03 13:17:17','2022-03-03 13:17:17'),(99300,299,'Timon','785691',1,0,'2022-03-03 13:17:17','2022-03-03 13:17:17'),(99301,299,'Tiphuk','785684',1,0,'2022-03-03 13:17:17','2022-03-03 13:17:17'),(99302,299,'Titlagarh Chariali','785693',1,0,'2022-03-03 13:17:17','2022-03-03 13:17:17'),(99303,299,'Towkok','785640',1,0,'2022-03-03 13:17:17','2022-03-03 13:17:17'),(99304,299,'Udaypur','785662',1,0,'2022-03-03 13:17:17','2022-03-03 13:17:17'),(99305,299,'Ujanikuri','785692',1,0,'2022-03-03 13:17:17','2022-03-03 13:17:17'),(99306,299,'Upper Nazira','785685',1,0,'2022-03-03 13:17:17','2022-03-03 13:17:17'),(99307,300,'Alisinga','784112',1,0,'2022-03-03 13:17:17','2022-03-03 13:17:17'),(99308,300,'Alupara','784178',1,0,'2022-03-03 13:17:17','2022-03-03 13:17:17'),(99309,300,'Ameribari','784101',1,0,'2022-03-03 13:17:17','2022-03-03 13:17:17'),(99310,300,'Amlakhi Dalani','784170',1,0,'2022-03-03 13:17:17','2022-03-03 13:17:17'),(99311,300,'Arragaon No.1','784167',1,0,'2022-03-03 13:17:17','2022-03-03 13:17:17'),(99312,300,'Aujuli Rangagora','784103',1,0,'2022-03-03 13:17:17','2022-03-03 13:17:17'),(99313,300,'Bahbari','784502',1,0,'2022-03-03 13:17:17','2022-03-03 13:17:17'),(99314,300,'Bakola','784182',1,0,'2022-03-03 13:17:17','2022-03-03 13:17:17'),(99315,300,'Bakori Doloni','784172',1,0,'2022-03-03 13:17:17','2022-03-03 13:17:17'),(99316,300,'Bakrapatta','784175',1,0,'2022-03-03 13:17:17','2022-03-03 13:17:17'),(99317,300,'Balichang','784174',1,0,'2022-03-03 13:17:17','2022-03-03 13:17:17'),(99318,300,'Balichapori','784027',1,0,'2022-03-03 13:17:18','2022-03-03 13:17:18'),(99319,300,'Balijan','784172',1,0,'2022-03-03 13:17:18','2022-03-03 13:17:18'),(99320,300,'Balijan Barua','784171',1,0,'2022-03-03 13:17:18','2022-03-03 13:17:18'),(99321,300,'Balijuri','784182',1,0,'2022-03-03 13:17:18','2022-03-03 13:17:18'),(99322,300,'Balipara','784101',1,0,'2022-03-03 13:17:18','2022-03-03 13:17:18'),(99323,300,'Balipukhuri Joradia','784117',1,0,'2022-03-03 13:17:18','2022-03-03 13:17:18'),(99324,300,'Balipukhuri Tiniali','784154',1,0,'2022-03-03 13:17:18','2022-03-03 13:17:18'),(99325,300,'Bandarmari','784153',1,0,'2022-03-03 13:17:18','2022-03-03 13:17:18'),(99326,300,'Bapubheti','784153',1,0,'2022-03-03 13:17:18','2022-03-03 13:17:18'),(99327,300,'Barangabari','784172',1,0,'2022-03-03 13:17:18','2022-03-03 13:17:18'),(99328,300,'Bargaon','784149',1,0,'2022-03-03 13:17:18','2022-03-03 13:17:18'),(99329,300,'Barika Chuburi','784154',1,0,'2022-03-03 13:17:18','2022-03-03 13:17:18'),(99330,300,'Bashbera','784506',1,0,'2022-03-03 13:17:18','2022-03-03 13:17:18'),(99331,300,'Batashipur','784111',1,0,'2022-03-03 13:17:18','2022-03-03 13:17:18'),(99332,300,'Batiamari','784179',1,0,'2022-03-03 13:17:18','2022-03-03 13:17:18'),(99333,300,'Bedeti','784179',1,0,'2022-03-03 13:17:18','2022-03-03 13:17:18'),(99334,300,'Behali','784166',1,0,'2022-03-03 13:17:18','2022-03-03 13:17:18'),(99335,300,'Besseria','784150',1,0,'2022-03-03 13:17:18','2022-03-03 13:17:18'),(99336,300,'Bhangamandir','784112',1,0,'2022-03-03 13:17:18','2022-03-03 13:17:18'),(99337,300,'Bhergaon Kochgaon','784149',1,0,'2022-03-03 13:17:18','2022-03-03 13:17:18'),(99338,300,'Bhimdanga','784167',1,0,'2022-03-03 13:17:18','2022-03-03 13:17:18'),(99339,300,'Bhojkhowa Chapori','784027',1,0,'2022-03-03 13:17:18','2022-03-03 13:17:18'),(99340,300,'Bihaguri','784153',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99341,300,'Bihmari','784179',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99342,300,'Bindukuri','784502',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99343,300,'Biskhuti','784117',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99344,300,'Biswanathghat','784177',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99345,300,'Bogipukhuri','784112',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99346,300,'Bokabil','784175',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99347,300,'Bokajan','784105',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99348,300,'Borbil Kachari','784149',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99349,300,'Bordikorai','784182',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99350,300,'Bordupsonalibari','784178',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99351,300,'Borgong','784167',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99352,300,'Borjharani','784184',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99353,300,'Borjuli Nepaligaon','784179',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99354,300,'Borjuli','784504',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99355,300,'Borpam Tiniali','784175',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99356,300,'Borsola','784117',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99357,300,'Brahmajan','784172',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99358,300,'Burigong','784176',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99359,300,'Buroi Ghat','784179',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99360,300,'Chariali','784176',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99361,300,'Chariduar','784103',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99362,300,'Chengamari','784175',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99363,300,'Chengelimara','784103',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99364,300,'Cherelia','784167',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99365,300,'Chitalmari','784110',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99366,300,'Da Besseria','784150',1,0,'2022-03-03 13:17:19','2022-03-03 13:17:19'),(99367,300,'Da Parbatia','784150',1,0,'2022-03-03 13:17:20','2022-03-03 13:17:20'),(99368,300,'Daflagarh','784171',1,0,'2022-03-03 13:17:20','2022-03-03 13:17:20'),(99369,300,'Darrang Panbari','784111',1,0,'2022-03-03 13:17:20','2022-03-03 13:17:20'),(99370,300,'Dekargaon','784501',1,0,'2022-03-03 13:17:20','2022-03-03 13:17:20'),(99371,300,'Dhankhana','784506',1,0,'2022-03-03 13:17:20','2022-03-03 13:17:20'),(99372,300,'Dhekiajuli','784110',1,0,'2022-03-03 13:17:20','2022-03-03 13:17:20'),(99373,300,'Dhendoi','784504',1,0,'2022-03-03 13:17:20','2022-03-03 13:17:20'),(99374,300,'Dholi Kuhiarbari','784174',1,0,'2022-03-03 13:17:20','2022-03-03 13:17:20'),(99375,300,'Dibru Darrang','784111',1,0,'2022-03-03 13:17:20','2022-03-03 13:17:20'),(99376,300,'Dighalijuli','784506',1,0,'2022-03-03 13:17:20','2022-03-03 13:17:20'),(99377,300,'Dipara Pukhuri','784172',1,0,'2022-03-03 13:17:20','2022-03-03 13:17:20'),(99378,300,'Diphalu Satra','784169',1,0,'2022-03-03 13:17:20','2022-03-03 13:17:20'),(99379,300,'Dipota','784150',1,0,'2022-03-03 13:17:20','2022-03-03 13:17:20'),(99380,300,'Dolabari','784027',1,0,'2022-03-03 13:17:20','2022-03-03 13:17:20'),(99381,300,'Dopdopi','784505',1,0,'2022-03-03 13:17:20','2022-03-03 13:17:20'),(99382,300,'Dubia','784178',1,0,'2022-03-03 13:17:20','2022-03-03 13:17:20'),(99383,300,'Farshipam','784110',1,0,'2022-03-03 13:17:20','2022-03-03 13:17:20'),(99384,300,'Fatasimalugaon','784117',1,0,'2022-03-03 13:17:20','2022-03-03 13:17:20'),(99385,300,'Fulaguri','784504',1,0,'2022-03-03 13:17:20','2022-03-03 13:17:20'),(99386,300,'Gabharu','784153',1,0,'2022-03-03 13:17:20','2022-03-03 13:17:20'),(99387,300,'Gamani','784103',1,0,'2022-03-03 13:17:20','2022-03-03 13:17:20'),(99388,300,'Gameri','784172',1,0,'2022-03-03 13:17:20','2022-03-03 13:17:20'),(99389,300,'Gameripal','784180',1,0,'2022-03-03 13:17:20','2022-03-03 13:17:20'),(99390,300,'Gangmouthan','784167',1,0,'2022-03-03 13:17:20','2022-03-03 13:17:20'),(99391,300,'Garpal','784175',1,0,'2022-03-03 13:17:20','2022-03-03 13:17:20'),(99392,300,'Garubandha','784506',1,0,'2022-03-03 13:17:20','2022-03-03 13:17:20'),(99393,300,'Garuduba','784149',1,0,'2022-03-03 13:17:21','2022-03-03 13:17:21'),(99394,300,'Gelapukhuri','784176',1,0,'2022-03-03 13:17:21','2022-03-03 13:17:21'),(99395,300,'Geruabari','784176',1,0,'2022-03-03 13:17:21','2022-03-03 13:17:21'),(99396,300,'Ghahigaon Chariali','784170',1,0,'2022-03-03 13:17:21','2022-03-03 13:17:21'),(99397,300,'Ghatua','784149',1,0,'2022-03-03 13:17:21','2022-03-03 13:17:21'),(99398,300,'Ghogra','784110',1,0,'2022-03-03 13:17:21','2022-03-03 13:17:21'),(99399,300,'Ghogra Basti','784168',1,0,'2022-03-03 13:17:21','2022-03-03 13:17:21'),(99400,300,'Ghoramari','784105',1,0,'2022-03-03 13:17:21','2022-03-03 13:17:21'),(99401,300,'Gingia','784184',1,0,'2022-03-03 13:17:21','2022-03-03 13:17:21'),(99402,300,'Gobinda Elengisatra','784168',1,0,'2022-03-03 13:17:21','2022-03-03 13:17:21'),(99403,300,'Godamghat','784101',1,0,'2022-03-03 13:17:21','2022-03-03 13:17:21'),(99404,300,'Gohpur','784168',1,0,'2022-03-03 13:17:21','2022-03-03 13:17:21'),(99405,300,'Gormara','784111',1,0,'2022-03-03 13:17:21','2022-03-03 13:17:21'),(99406,300,'Halem','784170',1,0,'2022-03-03 13:17:21','2022-03-03 13:17:21'),(99407,300,'Haleswar','784104',1,0,'2022-03-03 13:17:21','2022-03-03 13:17:21'),(99408,300,'Hatinga','784182',1,0,'2022-03-03 13:17:21','2022-03-03 13:17:21'),(99409,300,'Hazarapar','784001',1,0,'2022-03-03 13:17:21','2022-03-03 13:17:21'),(99410,300,'Helemguri','784172',1,0,'2022-03-03 13:17:21','2022-03-03 13:17:21'),(99411,300,'Howajair','784169',1,0,'2022-03-03 13:17:21','2022-03-03 13:17:21'),(99412,300,'Itakhola','784182',1,0,'2022-03-03 13:17:21','2022-03-03 13:17:21'),(99413,300,'Jahamari','784149',1,0,'2022-03-03 13:17:22','2022-03-03 13:17:22'),(99414,300,'Jamugurihat','784180',1,0,'2022-03-03 13:17:22','2022-03-03 13:17:22'),(99415,300,'Janata','784179',1,0,'2022-03-03 13:17:22','2022-03-03 13:17:22'),(99416,300,'Jiagabharu','784506',1,0,'2022-03-03 13:17:22','2022-03-03 13:17:22'),(99417,300,'Kacharigaon','784001',1,0,'2022-03-03 13:17:22','2022-03-03 13:17:22'),(99418,300,'Kacharison','784117',1,0,'2022-03-03 13:17:22','2022-03-03 13:17:22'),(99419,300,'Kailajuli','784505',1,0,'2022-03-03 13:17:22','2022-03-03 13:17:22'),(99420,300,'Kakila Chariali','784168',1,0,'2022-03-03 13:17:22','2022-03-03 13:17:22'),(99421,300,'Kalabari','784178',1,0,'2022-03-03 13:17:22','2022-03-03 13:17:22'),(99422,300,'Kalakuchi','784149',1,0,'2022-03-03 13:17:22','2022-03-03 13:17:22'),(99423,300,'Kaliabhomora','784027',1,0,'2022-03-03 13:17:22','2022-03-03 13:17:22'),(99424,300,'Kalmowguri','784178',1,0,'2022-03-03 13:17:22','2022-03-03 13:17:22'),(99425,300,'Kamdewal','784169',1,0,'2022-03-03 13:17:22','2022-03-03 13:17:22'),(99426,300,'Karibil Bangali','784170',1,0,'2022-03-03 13:17:22','2022-03-03 13:17:22'),(99427,300,'Karsontala','784189',1,0,'2022-03-03 13:17:22','2022-03-03 13:17:22'),(99428,300,'Kauri Pathar','784170',1,0,'2022-03-03 13:17:23','2022-03-03 13:17:23'),(99429,300,'Keherukhanda','784110',1,0,'2022-03-03 13:17:23','2022-03-03 13:17:23'),(99430,300,'Ketekibari','784154',1,0,'2022-03-03 13:17:23','2022-03-03 13:17:23'),(99431,300,'Khalihamari','784026',1,0,'2022-03-03 13:17:23','2022-03-03 13:17:23'),(99432,300,'Khanaguri','784175',1,0,'2022-03-03 13:17:23','2022-03-03 13:17:23'),(99433,300,'Kharaiguri','784169',1,0,'2022-03-03 13:17:23','2022-03-03 13:17:23'),(99434,300,'Khatargaon','784169',1,0,'2022-03-03 13:17:23','2022-03-03 13:17:23'),(99435,300,'Khelmati','784153',1,0,'2022-03-03 13:17:23','2022-03-03 13:17:23'),(99436,300,'Khelmati Bazar','784101',1,0,'2022-03-03 13:17:23','2022-03-03 13:17:23'),(99437,300,'Kunwari','784176',1,0,'2022-03-03 13:17:23','2022-03-03 13:17:23'),(99438,300,'Lahorijan','784176',1,0,'2022-03-03 13:17:23','2022-03-03 13:17:23'),(99439,300,'Lehugaon','784176',1,0,'2022-03-03 13:17:23','2022-03-03 13:17:23'),(99440,300,'Lohitmukh','784169',1,0,'2022-03-03 13:17:23','2022-03-03 13:17:23'),(99441,300,'Lokra','784102',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99442,300,'Magoni','784168',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99443,300,'Mahabhairab','784001',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99444,300,'Mail Bazar','784170',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99445,300,'Majukuchi','784178',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99446,300,'Manijharni','784502',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99447,300,'Mansiri','784105',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99448,300,'Mazrowmari','784117',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99449,300,'Mejengjuli','784111',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99450,300,'Mijikajan','784173',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99451,300,'Mikirborachuk','784178',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99452,300,'Milanpur','784168',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99453,300,'Missamari','784506',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99454,300,'Mitham Bangali','784110',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99455,300,'Monabari','784176',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99456,300,'Mukoli Gaon','784170',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99457,300,'Nagshankar','784189',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99458,300,'Naharbari','784182',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99459,300,'Nandikeswar','784180',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99460,300,'Nankey Patgaon','784101',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99461,300,'Napaam','784028',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99462,300,'Natun Baithabhonga','784105',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99463,300,'Natun Sirajuli','784110',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99464,300,'Nepalibasti','784506',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99465,300,'Nikamul Satra','784154',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99466,300,'Niz Sootea','784175',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99467,300,'No.2 Ghahigaon','784175',1,0,'2022-03-03 13:17:24','2022-03-03 13:17:24'),(99468,300,'No.3 Nalbari','784175',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99469,300,'Orientoli','784112',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99470,300,'Pabhoi','784174',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99471,300,'Palasbasti Pathar','784110',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99472,300,'Panchmile','784025',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99473,300,'Panibharal','784176',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99474,300,'Panpur','784180',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99475,300,'Pirakata No.2','784110',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99476,300,'Pithakhowa','784153',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99477,300,'Poken No.1','784168',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99478,300,'Pratapgarh','784175',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99479,300,'Pulisomoni No.1','784178',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99480,300,'Rajabari','784168',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99481,300,'Rampur Darrang','784167',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99482,300,'Rangachakua','784182',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99483,300,'Rangagora Darrang','784110',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99484,300,'Rangapara','784505',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99485,300,'Rangapukhuri','784501',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99486,300,'Rawanmukh','784169',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99487,300,'Sakomato','784176',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99488,300,'Salaikati','784174',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99489,300,'Samardalani','784175',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99490,300,'Santipur Dewrigaon','784178',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99491,300,'Shalonibari','784104',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99492,300,'Silikhabari','784149',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99493,300,'Silonigaon','784101',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99494,300,'Simaluguri','784168',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99495,300,'Singitoli','784025',1,0,'2022-03-03 13:17:25','2022-03-03 13:17:25'),(99496,300,'Singri','784110',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99497,300,'Sirajuli','784117',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99498,300,'Solaguri','784180',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99499,300,'Solal Sonari','784175',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99500,300,'Solemari No.1','784177',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99501,300,'Solmara','784501',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99502,300,'Sonaipam','784102',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99503,300,'Sonapur','784168',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99504,300,'Sonitpur','784001',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99505,300,'Sootea','784175',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99506,300,'Subansirimukh','784169',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99507,300,'Teliagaon','784149',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99508,300,'Tengabasti','784025',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99509,300,'Tetenbari','784171',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99510,300,'Tewaripal','784175',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99511,300,'Tezpur Bazar','784001',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99512,300,'Tezpur H.O','784001',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99513,300,'Tezpur Medical College','784010',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99514,300,'Thakurbari','784505',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99515,300,'Thelamara','784149',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99516,300,'Tinikhuti','784173',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99517,300,'Towbhanga','784182',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99518,300,'Ulubari','784149',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99519,300,'Upper Panbari','784110',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99520,300,'Urahiloga','784505',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99521,300,'Uriumguri','784025',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99522,300,'Uttar Amloga','784103',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99523,301,'3 No Borbil','786171',1,0,'2022-03-03 13:17:26','2022-03-03 13:17:26'),(99524,301,'Adarshgaon','786174',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99525,301,'Agbandha Bengali Gaon','786187',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99526,301,'Alubari','786181',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99527,301,'Amarpur','786157',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99528,301,'Amguri','786160',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99529,301,'Aroimuria','786154',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99530,301,'Arunodaya','786160',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99531,301,'Ashok Nagar','786170',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99532,301,'Baghbari Gaon','786189',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99533,301,'Balijan','786171',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99534,301,'Balijan T.E.','786601',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99535,301,'Barchapri','786183',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99536,301,'Barhapjan','786150',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99537,301,'Barhullung','786160',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99538,301,'Barmajan','786174',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99539,301,'Baruahola','786183',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99540,301,'Bhardhara','786183',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99541,301,'Bhimpathar','786171',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99542,301,'Bisagaon','786182',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99543,301,'Bisfootia','786601',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99544,301,'Bishnupur','786188',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99545,301,'Bogapani','786171',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99546,301,'Bogdung','786183',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99547,301,'Borali','786152',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99548,301,'Bordirak','786152',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99549,301,'Bordoloinagar','786156',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99550,301,'Bordubi Te','786151',1,0,'2022-03-03 13:17:27','2022-03-03 13:17:27'),(99551,301,'Borgaon','786170',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99552,301,'Borgolai','786181',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99553,301,'Borguri','786126',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99554,301,'Bormuchai','786152',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99555,301,'Buraburi Than','786157',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99556,301,'Chalihanagar','786146',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99557,301,'Challet','786179',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99558,301,'Chapakhowa','786157',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99559,301,'Chellenguri','786152',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99560,301,'Chikarajan','786160',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99561,301,'Dangrigaon','786156',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99562,301,'Dhekiajan','786171',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99563,301,'Dibong','786181',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99564,301,'Digboi Charali','786171',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99565,301,'Digboi','786171',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99566,301,'Dighal Tarrang','786151',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99567,301,'Dihingia Gaon','786192',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99568,301,'Dinjan','786189',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99569,301,'Dirak Maithong','786152',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99570,301,'Dohotiagaon','786151',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99571,301,'Doom Dooma','786151',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99572,301,'Durgabari','786125',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99573,301,'Gahoripam','786183',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99574,301,'Gakhirbheti','786156',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99575,301,'Gellapukhuri','786126',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99576,301,'Gobarbheti','786160',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99577,301,'Golai','786171',1,0,'2022-03-03 13:17:28','2022-03-03 13:17:28'),(99578,301,'Hahkhati','786154',1,0,'2022-03-03 13:17:29','2022-03-03 13:17:29'),(99579,301,'Hamuk Jan','786182',1,0,'2022-03-03 13:17:29','2022-03-03 13:17:29'),(99580,301,'Hansara','786190',1,0,'2022-03-03 13:17:29','2022-03-03 13:17:29'),(99581,301,'Hatighuli','786154',1,0,'2022-03-03 13:17:29','2022-03-03 13:17:29'),(99582,301,'Hijiguri','786192',1,0,'2022-03-03 13:17:29','2022-03-03 13:17:29'),(99583,301,'Hollong Gutibari','786160',1,0,'2022-03-03 13:17:29','2022-03-03 13:17:29'),(99584,301,'Hoogrijan','786601',1,0,'2022-03-03 13:17:29','2022-03-03 13:17:29'),(99585,301,'Inthemgaon','786174',1,0,'2022-03-03 13:17:29','2022-03-03 13:17:29'),(99586,301,'Islampur','786157',1,0,'2022-03-03 13:17:30','2022-03-03 13:17:30'),(99587,301,'Jagun','786188',1,0,'2022-03-03 13:17:30','2022-03-03 13:17:30'),(99588,301,'Jubilee Digboi','786173',1,0,'2022-03-03 13:17:30','2022-03-03 13:17:30'),(99589,301,'Kachari Maithong','786152',1,0,'2022-03-03 13:17:30','2022-03-03 13:17:30'),(99590,301,'Kadamoni','786145',1,0,'2022-03-03 13:17:30','2022-03-03 13:17:30'),(99591,301,'Kailash Pur','786152',1,0,'2022-03-03 13:17:30','2022-03-03 13:17:30'),(99592,301,'Kakapathar','786152',1,0,'2022-03-03 13:17:30','2022-03-03 13:17:30'),(99593,301,'Kakojan','786151',1,0,'2022-03-03 13:17:30','2022-03-03 13:17:30'),(99594,301,'Kashijan','786152',1,0,'2022-03-03 13:17:30','2022-03-03 13:17:30'),(99595,301,'Kathalguri','786174',1,0,'2022-03-03 13:17:30','2022-03-03 13:17:30'),(99596,301,'Ketetong','786181',1,0,'2022-03-03 13:17:30','2022-03-03 13:17:30'),(99597,301,'Khamti Gowali','786147',1,0,'2022-03-03 13:17:30','2022-03-03 13:17:30'),(99598,301,'Khetopathargaon','786145',1,0,'2022-03-03 13:17:30','2022-03-03 13:17:30'),(99599,301,'Koomsang','786151',1,0,'2022-03-03 13:17:30','2022-03-03 13:17:30'),(99600,301,'Kordoiguri','786156',1,0,'2022-03-03 13:17:30','2022-03-03 13:17:30'),(99601,301,'Kukurekhowa','786183',1,0,'2022-03-03 13:17:30','2022-03-03 13:17:30'),(99602,301,'Kukuremara','786158',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99603,301,'Kumchai','786182',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99604,301,'Kundil','786158',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99605,301,'Laika','786147',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99606,301,'Lainagaon','786156',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99607,301,'Laipuli','786183',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99608,301,'Lakhipather','786171',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99609,301,'Laklapathar','786188',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99610,301,'Lamagaon','786181',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99611,301,'Laupati','786156',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99612,301,'Ledo','786182',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99613,301,'Ledo Tikok','786182',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99614,301,'Lekhapani','786182',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99615,301,'Limbuguri','786147',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99616,301,'Lohari','786146',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99617,301,'Long Gaon','786182',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99618,301,'Makum Junction','786170',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99619,301,'Makum Pathar','786187',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99620,301,'Makumkilla','786187',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99621,301,'Mamorani','786170',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99622,301,'Mankhooli','786601',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99623,301,'Margherita New Colony','786181',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99624,301,'Margherita','786181',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99625,301,'Megela','786154',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99626,301,'Muliabari','786171',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99627,301,'Mullang','786182',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99628,301,'Natun Balijan','786158',1,0,'2022-03-03 13:17:31','2022-03-03 13:17:31'),(99629,301,'Navajyoti','786152',1,0,'2022-03-03 13:17:32','2022-03-03 13:17:32'),(99630,301,'Nazirating','786171',1,0,'2022-03-03 13:17:32','2022-03-03 13:17:32'),(99631,301,'Netaji Road','786151',1,0,'2022-03-03 13:17:32','2022-03-03 13:17:32'),(99632,301,'Pakharijan','786146',1,0,'2022-03-03 13:17:32','2022-03-03 13:17:32'),(99633,301,'Panitola','786183',1,0,'2022-03-03 13:17:32','2022-03-03 13:17:32'),(99634,301,'Parbotia','786125',1,0,'2022-03-03 13:17:32','2022-03-03 13:17:32'),(99635,301,'Pengri','786174',1,0,'2022-03-03 13:17:32','2022-03-03 13:17:32'),(99636,301,'Phillobari','786160',1,0,'2022-03-03 13:17:32','2022-03-03 13:17:32'),(99637,301,'Powai','786171',1,0,'2022-03-03 13:17:32','2022-03-03 13:17:32'),(99638,301,'Prakash Bazar','786125',1,0,'2022-03-03 13:17:32','2022-03-03 13:17:32'),(99639,301,'Purani Pukhuri','786174',1,0,'2022-03-03 13:17:32','2022-03-03 13:17:32'),(99640,301,'Rampur','786188',1,0,'2022-03-03 13:17:32','2022-03-03 13:17:32'),(99641,301,'Rangagora','786147',1,0,'2022-03-03 13:17:32','2022-03-03 13:17:32'),(99642,301,'Rupaisiding','786153',1,0,'2022-03-03 13:17:32','2022-03-03 13:17:32'),(99643,301,'Rupbon','786151',1,0,'2022-03-03 13:17:32','2022-03-03 13:17:32'),(99644,301,'Sadiya','786155',1,0,'2022-03-03 13:17:32','2022-03-03 13:17:32'),(99645,301,'Saikhowaghat','786154',1,0,'2022-03-03 13:17:32','2022-03-03 13:17:32'),(99646,301,'Samdang','786190',1,0,'2022-03-03 13:17:32','2022-03-03 13:17:32'),(99647,301,'Santipur','786150',1,0,'2022-03-03 13:17:32','2022-03-03 13:17:32'),(99648,301,'Santipur Bazar','786157',1,0,'2022-03-03 13:17:32','2022-03-03 13:17:32'),(99649,301,'Sarudhadum','786156',1,0,'2022-03-03 13:17:32','2022-03-03 13:17:32'),(99650,301,'Senairam Bazar','786125',1,0,'2022-03-03 13:17:32','2022-03-03 13:17:32'),(99651,301,'Sripuria Bengali Gaon','786145',1,0,'2022-03-03 13:17:32','2022-03-03 13:17:32'),(99652,301,'Sripuria','786145',1,0,'2022-03-03 13:17:32','2022-03-03 13:17:32'),(99653,301,'Sukhanpukhuri','786146',1,0,'2022-03-03 13:17:32','2022-03-03 13:17:32'),(99654,301,'Sukriting','786159',1,0,'2022-03-03 13:17:32','2022-03-03 13:17:32'),(99655,301,'Talap (Tinsukia)','786156',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99656,301,'Talpathar','786152',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99657,301,'Tinali Nowgong','786152',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99658,301,'Tingrai','786171',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99659,301,'Tinsukia H.O','786125',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99660,301,'Tipong','786179',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99661,301,'Tirap','786182',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99662,301,'Tonganabazar','786152',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99663,301,'Tonganagaon','786152',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99664,301,'Udai Pur','786182',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99665,301,'Ulup Gaon','786181',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99666,302,'Aghra','854336',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99667,302,'Amgachhi','854332',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99668,302,'Amhara','854318',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99669,302,'Araria Bairgachhi','854311',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99670,302,'Araria RS','854312',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99671,302,'Araria','854311',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99672,302,'Aurahihingua','854318',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99673,302,'B. Rampur','854318',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99674,302,'Bagdahara','854311',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99675,302,'Bagulaha','854334',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99676,302,'Baharbari','854329',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99677,302,'Balua Deorhi','854311',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99678,302,'Baluakaliaganj','854333',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99679,302,'Bangama','854312',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99680,302,'Bansbari','854311',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99681,302,'Bara Ishambara','854329',1,0,'2022-03-03 13:17:33','2022-03-03 13:17:33'),(99682,302,'Bardahahat','854333',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99683,302,'Barhara','854335',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99684,302,'Barmasia Simarbani','854333',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99685,302,'Basaity','854312',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99686,302,'Basmatia','854336',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99687,302,'Bathnaha','854316',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99688,302,'Bathraha Asha Bhag','854332',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99689,302,'Baturbari','854311',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99690,302,'Baunsi','854312',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99691,302,'Bela Basmatia','854336',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99692,302,'Belsara','854334',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99693,302,'Bhadeshwar','854316',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99694,302,'Bhagwa Deviganj','854335',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99695,302,'Bhargama','854102',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99696,302,'Bhawanipur','854336',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99697,302,'Bhirbhiri','854333',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99698,302,'Bhojpur','854333',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99699,302,'Bihari','854329',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99700,302,'Bikash Bhargama','854334',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99701,302,'Bochi','854311',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99702,302,'Chainpur','854325',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99703,302,'Chakiahat','854329',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99704,302,'Chandardai','854312',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99705,302,'Chatiuna','854312',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99706,302,'Chikanighat','854331',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99707,302,'Chirah','854311',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99708,302,'Dabhara','854311',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99709,302,'Dalmalpur','854329',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99710,302,'Dehati','854333',1,0,'2022-03-03 13:17:34','2022-03-03 13:17:34'),(99711,302,'Deorea Sonapur','854311',1,0,'2022-03-03 13:17:35','2022-03-03 13:17:35'),(99712,302,'Dharhmagtanj','854333',1,0,'2022-03-03 13:17:35','2022-03-03 13:17:35'),(99713,302,'Dholbazza','854318',1,0,'2022-03-03 13:17:35','2022-03-03 13:17:35'),(99714,302,'Dubha','854311',1,0,'2022-03-03 13:17:35','2022-03-03 13:17:35'),(99715,302,'Dumuria Bisstaria','854334',1,0,'2022-03-03 13:17:35','2022-03-03 13:17:35'),(99716,302,'Forbesganj','854318',1,0,'2022-03-03 13:17:35','2022-03-03 13:17:35'),(99717,302,'Gairki','854311',1,0,'2022-03-03 13:17:35','2022-03-03 13:17:35'),(99718,302,'Gaiyari','854311',1,0,'2022-03-03 13:17:35','2022-03-03 13:17:35'),(99719,302,'Gamharia','854333',1,0,'2022-03-03 13:17:35','2022-03-03 13:17:35'),(99720,302,'Ghurna','854336',1,0,'2022-03-03 13:17:35','2022-03-03 13:17:35'),(99721,302,'Gidwas','854312',1,0,'2022-03-03 13:17:35','2022-03-03 13:17:35'),(99722,302,'Gokhlapur','854335',1,0,'2022-03-03 13:17:35','2022-03-03 13:17:35'),(99723,302,'Gunwanti','854312',1,0,'2022-03-03 13:17:35','2022-03-03 13:17:35'),(99724,302,'Haldarhat','854331',1,0,'2022-03-03 13:17:35','2022-03-03 13:17:35'),(99725,302,'Haldia Bokra','854318',1,0,'2022-03-03 13:17:35','2022-03-03 13:17:35'),(99726,302,'Hansa','854312',1,0,'2022-03-03 13:17:35','2022-03-03 13:17:35'),(99727,302,'Haripur Dak','854318',1,0,'2022-03-03 13:17:35','2022-03-03 13:17:35'),(99728,302,'Indrapur Barhara','854334',1,0,'2022-03-03 13:17:35','2022-03-03 13:17:35'),(99729,302,'Jagta','854334',1,0,'2022-03-03 13:17:35','2022-03-03 13:17:35'),(99730,302,'Jahanpur','854329',1,0,'2022-03-03 13:17:35','2022-03-03 13:17:35'),(99731,302,'Jamua','854331',1,0,'2022-03-03 13:17:35','2022-03-03 13:17:35'),(99732,302,'Jaynagar','854334',1,0,'2022-03-03 13:17:35','2022-03-03 13:17:35'),(99733,302,'Jogbani','854328',1,0,'2022-03-03 13:17:35','2022-03-03 13:17:35'),(99734,302,'Jokihat','854329',1,0,'2022-03-03 13:17:35','2022-03-03 13:17:35'),(99735,302,'K.Baijnathpur','854334',1,0,'2022-03-03 13:17:35','2022-03-03 13:17:35'),(99736,302,'Kakan','854311',1,0,'2022-03-03 13:17:35','2022-03-03 13:17:35'),(99737,302,'Kamaldaha','854312',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99738,302,'Kankhudia','854333',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99739,302,'Kannaili','854318',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99740,302,'Karankia','854312',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99741,302,'Kessara','854329',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99742,302,'Khagra','854335',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99743,302,'Khairkhan','854318',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99744,302,'Khajurihat','854334',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99745,302,'Khawashpur','854318',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99746,302,'Koskapur','854318',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99747,302,'Kuari','854332',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99748,302,'Kujri','854333',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99749,302,'Kursakanta','854331',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99750,302,'Kurshail','854329',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99751,302,'Kushkapur','854334',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99752,302,'Kushmaha','854318',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99753,302,'Kushmaul','854318',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99754,302,'Madanpur (Araria)','854333',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99755,302,'Madhulata','854334',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99756,302,'Madhura','854335',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99757,302,'Maheshwari','854328',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99758,302,'Mahsail','854312',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99759,302,'Mahthawabazar','854334',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99760,302,'Mahullahpatti','854334',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99761,302,'Mainahat','854329',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99762,302,'Majhua','854312',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99763,302,'Majhwa','854318',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99764,302,'Manikpur','854336',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99765,302,'Maryganj','854334',1,0,'2022-03-03 13:17:36','2022-03-03 13:17:36'),(99766,302,'Masuria','854325',1,0,'2022-03-03 13:17:37','2022-03-03 13:17:37'),(99767,302,'Matiari','854329',1,0,'2022-03-03 13:17:37','2022-03-03 13:17:37'),(99768,302,'Matiyari','854318',1,0,'2022-03-03 13:17:37','2022-03-03 13:17:37'),(99769,302,'Maujaha','854334',1,0,'2022-03-03 13:17:37','2022-03-03 13:17:37'),(99770,302,'Megra Mehndipur','854331',1,0,'2022-03-03 13:17:37','2022-03-03 13:17:37'),(99771,302,'Mirdaul','854335',1,0,'2022-03-03 13:17:37','2022-03-03 13:17:37'),(99772,302,'Mirjapur Kothi','854334',1,0,'2022-03-03 13:17:37','2022-03-03 13:17:37'),(99773,302,'Mirzapur','854312',1,0,'2022-03-03 13:17:37','2022-03-03 13:17:37'),(99774,302,'Mohani','854312',1,0,'2022-03-03 13:17:37','2022-03-03 13:17:37'),(99775,302,'Mushari Idgah','854318',1,0,'2022-03-03 13:17:37','2022-03-03 13:17:37'),(99776,302,'Narpatganj','854335',1,0,'2022-03-03 13:17:37','2022-03-03 13:17:37'),(99777,302,'Nawabganj (Araria)','854336',1,0,'2022-03-03 13:17:37','2022-03-03 13:17:37'),(99778,302,'P. Chakrdaha','854318',1,0,'2022-03-03 13:17:37','2022-03-03 13:17:37'),(99779,302,'Pachira','854334',1,0,'2022-03-03 13:17:37','2022-03-03 13:17:37'),(99780,302,'Pahsara','854312',1,0,'2022-03-03 13:17:37','2022-03-03 13:17:37'),(99781,302,'Pahunsi','854332',1,0,'2022-03-03 13:17:37','2022-03-03 13:17:37'),(99782,302,'Paikpur','854334',1,0,'2022-03-03 13:17:37','2022-03-03 13:17:37'),(99783,302,'Paiktola','854325',1,0,'2022-03-03 13:17:37','2022-03-03 13:17:37'),(99784,302,'Pakri','854329',1,0,'2022-03-03 13:17:37','2022-03-03 13:17:37'),(99785,302,'Palasi','854333',1,0,'2022-03-03 13:17:37','2022-03-03 13:17:37'),(99786,302,'Panjarkatta','854318',1,0,'2022-03-03 13:17:37','2022-03-03 13:17:37'),(99787,302,'Panusi','854332',1,0,'2022-03-03 13:17:37','2022-03-03 13:17:37'),(99788,302,'Pararia','854333',1,0,'2022-03-03 13:17:37','2022-03-03 13:17:37'),(99789,302,'Parihari','854334',1,0,'2022-03-03 13:17:37','2022-03-03 13:17:37'),(99790,302,'Parmanandpur','854312',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99791,302,'Parwana','854318',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99792,302,'Pategana','854311',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99793,302,'Patharbari','854329',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99794,302,'Pipra','854318',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99795,302,'Pothia','854318',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99796,302,'R.T.Mohan','854311',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99797,302,'Raghunathpur','854334',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99798,302,'Rajganj','854335',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99799,302,'Rajokhar','854312',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99800,302,'Ramal','854318',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99801,302,'Rampur','854312',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99802,302,'Rampur','854318',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99803,302,'Rampur Mohanpur','854311',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99804,302,'S.R.Forbesganj','854318',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99805,302,'Shankarpur','854318',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99806,302,'Sheikpura','854334',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99807,302,'Sikti','854333',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99808,302,'Simarbani','854318',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99809,302,'Simraha','854318',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99810,302,'Sirsia Kalan','854334',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99811,302,'Sohagmare','854331',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99812,302,'Sonadarhat','854329',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99813,302,'Sourgaon','854318',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99814,302,'Tamganj','854318',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99815,302,'Tamghatti','854312',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99816,302,'Tarakhandah','854331',1,0,'2022-03-03 13:17:38','2022-03-03 13:17:38'),(99817,302,'Tarbi','854329',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99818,302,'Tiraskund','854318',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99819,302,'Urlaha','854333',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99820,303,'Anurahi','824115',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99821,303,'Sohasa','824127',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99822,303,'Akbarpur','804401',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99823,303,'Arwal','804401',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99824,303,'Bara Koriun','804401',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99825,303,'Bhadasi','804401',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99826,303,'Fatehpur Sanda','804402',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99827,303,'Hasanpur','804402',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99828,303,'Keyal','804419',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99829,303,'Kodra','804401',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99830,303,'Kurtha Bazar','804427',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99831,303,'Makhdumabad','804402',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99832,303,'Prasadi English','804401',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99833,304,'Agnoor','824143',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99834,304,'Akhoini Regania','824103',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99835,304,'Akoona','824203',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99836,304,'Akouni','824113',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99837,304,'Amari','824203',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99838,304,'Amba','824111',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99839,304,'Amilauna','824124',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99840,304,'Amona','824143',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99841,304,'Anchha','824143',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99842,304,'Ankora R.S.','824303',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99843,304,'Ankuri','824203',1,0,'2022-03-03 13:17:39','2022-03-03 13:17:39'),(99844,304,'Anti','824116',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99845,304,'Anukappa','824123',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99846,304,'Apiru','824120',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99847,304,'Arai','824143',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99848,304,'Aranda','824113',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99849,304,'Ararua','824202',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99850,304,'Arthua','824125',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99851,304,'Aurangabad (BH) H.O','824101',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99852,304,'Aurangabad Kutchehry','824101',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99853,304,'B. Sagarpur','824124',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99854,304,'Baghour','824120',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99855,304,'Bahuara','824202',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99856,304,'Bairia','824303',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99857,304,'Bajauli','824102',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99858,304,'Baksibigha','824125',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99859,304,'Balia','824111',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99860,304,'Baligaon','824103',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99861,304,'Baluganj','824202',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99862,304,'Bantara','824120',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99863,304,'Banua','824202',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99864,304,'Bara','824301',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99865,304,'Barabanadih','824302',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99866,304,'Barahi','824122',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99867,304,'Barauli','824124',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99868,304,'Barem','824303',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99869,304,'Barkapandu','824302',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99870,304,'Barpa','824114',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99871,304,'Barun (Aurangabad(BH))','824112',1,0,'2022-03-03 13:17:40','2022-03-03 13:17:40'),(99872,304,'Basdiha','824301',1,0,'2022-03-03 13:17:41','2022-03-03 13:17:41'),(99873,304,'Bedauli','824111',1,0,'2022-03-03 13:17:41','2022-03-03 13:17:41'),(99874,304,'Bedhani','824202',1,0,'2022-03-03 13:17:41','2022-03-03 13:17:41'),(99875,304,'Bel','824124',1,0,'2022-03-03 13:17:41','2022-03-03 13:17:41'),(99876,304,'Belabarish','824203',1,0,'2022-03-03 13:17:41','2022-03-03 13:17:41'),(99877,304,'Belain','824301',1,0,'2022-03-03 13:17:41','2022-03-03 13:17:41'),(99878,304,'Belaon','824127',1,0,'2022-03-03 13:17:41','2022-03-03 13:17:41'),(99879,304,'Belsar','824127',1,0,'2022-03-03 13:17:41','2022-03-03 13:17:41'),(99880,304,'Belsara','824202',1,0,'2022-03-03 13:17:41','2022-03-03 13:17:41'),(99881,304,'Beri','824208',1,0,'2022-03-03 13:17:41','2022-03-03 13:17:41'),(99882,304,'Beri Khiriawan','824208',1,0,'2022-03-03 13:17:41','2022-03-03 13:17:41'),(99883,304,'Bhadwa Bazar','824122',1,0,'2022-03-03 13:17:41','2022-03-03 13:17:41'),(99884,304,'Bhakharua','824113',1,0,'2022-03-03 13:17:41','2022-03-03 13:17:41'),(99885,304,'Bharub','824124',1,0,'2022-03-03 13:17:41','2022-03-03 13:17:41'),(99886,304,'Bishambharpur','824125',1,0,'2022-03-03 13:17:41','2022-03-03 13:17:41'),(99887,304,'Bisunpur Chati','824202',1,0,'2022-03-03 13:17:41','2022-03-03 13:17:41'),(99888,304,'Budhia','824203',1,0,'2022-03-03 13:17:41','2022-03-03 13:17:41'),(99889,304,'Buxar','824129',1,0,'2022-03-03 13:17:41','2022-03-03 13:17:41'),(99890,304,'C.Dhongra','824111',1,0,'2022-03-03 13:17:41','2022-03-03 13:17:41'),(99891,304,'Chainpur','824303',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99892,304,'Chanda','824113',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99893,304,'Chandragarh','824301',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99894,304,'Charam','824112',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99895,304,'Chauri','824127',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99896,304,'Chauria','824102',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99897,304,'Chechari','824124',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99898,304,'Chein','824103',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99899,304,'Chiraili','824125',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99900,304,'Choukhara','824103',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99901,304,'Chourahi','824120',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99902,304,'Dadar','824129',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99903,304,'Dadhapa','824202',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99904,304,'Darha','824203',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99905,304,'Darwan','824203',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99906,304,'Daudnagar','824143',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99907,304,'Deo','824202',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99908,304,'Deohara','824114',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99909,304,'Deshpur','824111',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99910,304,'Dewaria Kala','824121',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99911,304,'Dhadhapi','824103',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99912,304,'Dhamni','824115',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99913,304,'Dhangain','824124',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99914,304,'Dhibra','824202',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99915,304,'Dhnaoh Bigha','824143',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99916,304,'Dihara','824124',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99917,304,'Dihuri Ekauni','824129',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99918,304,'Dindil','824120',1,0,'2022-03-03 13:17:42','2022-03-03 13:17:42'),(99919,304,'Dosma','824122',1,0,'2022-03-03 13:17:43','2022-03-03 13:17:43'),(99920,304,'Dugul','824125',1,0,'2022-03-03 13:17:43','2022-03-03 13:17:43'),(99921,304,'Dumari','824202',1,0,'2022-03-03 13:17:43','2022-03-03 13:17:43'),(99922,304,'Dumari Belean','824202',1,0,'2022-03-03 13:17:43','2022-03-03 13:17:43'),(99923,304,'Dumra','824111',1,0,'2022-03-03 13:17:43','2022-03-03 13:17:43'),(99924,304,'Dumra','824120',1,0,'2022-03-03 13:17:43','2022-03-03 13:17:43'),(99925,304,'Entwan','824120',1,0,'2022-03-03 13:17:43','2022-03-03 13:17:43'),(99926,304,'Entwan','824301',1,0,'2022-03-03 13:17:43','2022-03-03 13:17:43'),(99927,304,'Erki','824202',1,0,'2022-03-03 13:17:43','2022-03-03 13:17:43'),(99928,304,'Fagu','824203',1,0,'2022-03-03 13:17:43','2022-03-03 13:17:43'),(99929,304,'Fesher','824121',1,0,'2022-03-03 13:17:43','2022-03-03 13:17:43'),(99930,304,'Fort Daudnagar','824143',1,0,'2022-03-03 13:17:43','2022-03-03 13:17:43'),(99931,304,'G. Kanap','824120',1,0,'2022-03-03 13:17:43','2022-03-03 13:17:43'),(99932,304,'G. Kharma','824102',1,0,'2022-03-03 13:17:43','2022-03-03 13:17:43'),(99933,304,'Gaini','824113',1,0,'2022-03-03 13:17:43','2022-03-03 13:17:43'),(99934,304,'Gamhari','824203',1,0,'2022-03-03 13:17:43','2022-03-03 13:17:43'),(99935,304,'Gardi','824103',1,0,'2022-03-03 13:17:43','2022-03-03 13:17:43'),(99936,304,'Ghatrain','824208',1,0,'2022-03-03 13:17:43','2022-03-03 13:17:43'),(99937,304,'Gheura','824111',1,0,'2022-03-03 13:17:43','2022-03-03 13:17:43'),(99938,304,'Ghoshta','824103',1,0,'2022-03-03 13:17:43','2022-03-03 13:17:43'),(99939,304,'Goh','824203',1,0,'2022-03-03 13:17:43','2022-03-03 13:17:43'),(99940,304,'Gordiha','824125',1,0,'2022-03-03 13:17:43','2022-03-03 13:17:43'),(99941,304,'Gorkati','824203',1,0,'2022-03-03 13:17:43','2022-03-03 13:17:43'),(99942,304,'Gosaidih','824303',1,0,'2022-03-03 13:17:43','2022-03-03 13:17:43'),(99943,304,'H Bigha','824143',1,0,'2022-03-03 13:17:44','2022-03-03 13:17:44'),(99944,304,'Hardiachak','824127',1,0,'2022-03-03 13:17:44','2022-03-03 13:17:44'),(99945,304,'Hartholi','824121',1,0,'2022-03-03 13:17:44','2022-03-03 13:17:44'),(99946,304,'Haspura','824120',1,0,'2022-03-03 13:17:44','2022-03-03 13:17:44'),(99947,304,'Hathiayara','824120',1,0,'2022-03-03 13:17:44','2022-03-03 13:17:44'),(99948,304,'Ibrahimpur','824102',1,0,'2022-03-03 13:17:44','2022-03-03 13:17:44'),(99949,304,'Indrar','824122',1,0,'2022-03-03 13:17:44','2022-03-03 13:17:44'),(99950,304,'Ithat','824102',1,0,'2022-03-03 13:17:44','2022-03-03 13:17:44'),(99951,304,'J H Tendua','824301',1,0,'2022-03-03 13:17:44','2022-03-03 13:17:44'),(99952,304,'Jagatpur','824112',1,0,'2022-03-03 13:17:44','2022-03-03 13:17:44'),(99953,304,'Jagdishpur','824112',1,0,'2022-03-03 13:17:44','2022-03-03 13:17:44'),(99954,304,'Jai Govind Nagar','824124',1,0,'2022-03-03 13:17:44','2022-03-03 13:17:44'),(99955,304,'Jaipur','824102',1,0,'2022-03-03 13:17:44','2022-03-03 13:17:44'),(99956,304,'Jaitiya','824116',1,0,'2022-03-03 13:17:44','2022-03-03 13:17:44'),(99957,304,'Jaitpur','824114',1,0,'2022-03-03 13:17:44','2022-03-03 13:17:44'),(99958,304,'Jakhim','824122',1,0,'2022-03-03 13:17:44','2022-03-03 13:17:44'),(99959,304,'Jalpura','824120',1,0,'2022-03-03 13:17:44','2022-03-03 13:17:44'),(99960,304,'Jamhor','824121',1,0,'2022-03-03 13:17:44','2022-03-03 13:17:44'),(99961,304,'Jamuaon','824143',1,0,'2022-03-03 13:17:45','2022-03-03 13:17:45'),(99962,304,'Jhari','824219',1,0,'2022-03-03 13:17:45','2022-03-03 13:17:45'),(99963,304,'Jhinguri','824115',1,0,'2022-03-03 13:17:45','2022-03-03 13:17:45'),(99964,304,'Jhomardihra','824112',1,0,'2022-03-03 13:17:45','2022-03-03 13:17:45'),(99965,304,'Jogia','824102',1,0,'2022-03-03 13:17:45','2022-03-03 13:17:45'),(99966,304,'K P Tendua','824123',1,0,'2022-03-03 13:17:45','2022-03-03 13:17:45'),(99967,304,'Kaithi','824124',1,0,'2022-03-03 13:17:45','2022-03-03 13:17:45'),(99968,304,'Kaithisiroh','824203',1,0,'2022-03-03 13:17:45','2022-03-03 13:17:45'),(99969,304,'Kaler','824127',1,0,'2022-03-03 13:17:45','2022-03-03 13:17:45'),(99970,304,'Kanbehari','824102',1,0,'2022-03-03 13:17:45','2022-03-03 13:17:45'),(99971,304,'Kandi','824301',1,0,'2022-03-03 13:17:45','2022-03-03 13:17:45'),(99972,304,'Kapasya','824103',1,0,'2022-03-03 13:17:45','2022-03-03 13:17:45'),(99973,304,'Kara','824124',1,0,'2022-03-03 13:17:45','2022-03-03 13:17:45'),(99974,304,'Karma Bhagwan','824102',1,0,'2022-03-03 13:17:45','2022-03-03 13:17:45'),(99975,304,'Karma Pandih','824129',1,0,'2022-03-03 13:17:45','2022-03-03 13:17:45'),(99976,304,'Karmalahang','824302',1,0,'2022-03-03 13:17:45','2022-03-03 13:17:45'),(99977,304,'Karsaon','824121',1,0,'2022-03-03 13:17:45','2022-03-03 13:17:45'),(99978,304,'Karsara','824122',1,0,'2022-03-03 13:17:46','2022-03-03 13:17:46'),(99979,304,'Kashipur Tetaria','824112',1,0,'2022-03-03 13:17:46','2022-03-03 13:17:46'),(99980,304,'Kashma','824125',1,0,'2022-03-03 13:17:46','2022-03-03 13:17:46'),(99981,304,'Kataiya','824202',1,0,'2022-03-03 13:17:46','2022-03-03 13:17:46'),(99982,304,'Kerap','824125',1,0,'2022-03-03 13:17:46','2022-03-03 13:17:46'),(99983,304,'Ketaki','824216',1,0,'2022-03-03 13:17:46','2022-03-03 13:17:46'),(99984,304,'Khadiha','824102',1,0,'2022-03-03 13:17:46','2022-03-03 13:17:46'),(99985,304,'Khadiha Kerka','824303',1,0,'2022-03-03 13:17:46','2022-03-03 13:17:46'),(99986,304,'Khaira Manjhouli','824103',1,0,'2022-03-03 13:17:46','2022-03-03 13:17:46'),(99987,304,'Khaira Rajpur','824123',1,0,'2022-03-03 13:17:46','2022-03-03 13:17:46'),(99988,304,'Khairadip','824113',1,0,'2022-03-03 13:17:46','2022-03-03 13:17:46'),(99989,304,'Khajauri Saraiya','824302',1,0,'2022-03-03 13:17:46','2022-03-03 13:17:46'),(99990,304,'Khudwan','824124',1,0,'2022-03-03 13:17:46','2022-03-03 13:17:46'),(99991,304,'Khutha','824120',1,0,'2022-03-03 13:17:46','2022-03-03 13:17:46'),(99992,304,'Koilwan','824115',1,0,'2022-03-03 13:17:46','2022-03-03 13:17:46'),(99993,304,'Kona','824103',1,0,'2022-03-03 13:17:46','2022-03-03 13:17:46'),(99994,304,'Kunda','824102',1,0,'2022-03-03 13:17:46','2022-03-03 13:17:46'),(99995,304,'Kurhwan','824124',1,0,'2022-03-03 13:17:46','2022-03-03 13:17:46'),(99996,304,'Kurwan','824122',1,0,'2022-03-03 13:17:46','2022-03-03 13:17:46'),(99997,304,'Kutumba','824123',1,0,'2022-03-03 13:17:46','2022-03-03 13:17:46'),(99998,304,'Lahasa','824122',1,0,'2022-03-03 13:17:46','2022-03-03 13:17:46'),(99999,304,'Latta','824122',1,0,'2022-03-03 13:17:46','2022-03-03 13:17:46'),(100000,304,'Lukka','824122',1,0,'2022-03-03 13:17:46','2022-03-03 13:17:46'),(100001,304,'M. Chaturbhuj','824125',1,0,'2022-03-03 13:17:46','2022-03-03 13:17:46'),(100002,304,'Madanpur (Aurangabad(BH))','824208',1,0,'2022-03-03 13:17:46','2022-03-03 13:17:46'),(100003,304,'Mahara','824202',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100004,304,'Mahsu','824111',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100005,304,'Mahuaon','824208',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100006,304,'Mahuaon','824303',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100007,304,'Malhara','824114',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100008,304,'Malhi Dih','824203',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100009,304,'Malwan','824124',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100010,304,'Manika','824202',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100011,304,'Manjurahi','824102',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100012,304,'Mankur Chanda','824127',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100013,304,'Matpa','824111',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100014,304,'Mehiyan','824302',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100015,304,'Mirzapur','824303',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100016,304,'Molbiganj Pothu','824122',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100017,304,'Mungia','824302',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100018,304,'Munjhar','824114',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100019,304,'Munjhara','824203',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100020,304,'Nabinagar Road','824303',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100021,304,'Nabinagar','824301',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100022,304,'Nagmatia','824208',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100023,304,'Narainpur','824124',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100024,304,'Narendra Khap','824123',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100025,304,'Naugarh','824102',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100026,304,'Naugarh','824219',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100027,304,'Naur','824303',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100028,304,'Neyamatpur','824202',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100029,304,'Nimabidhoul','824219',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100030,304,'Obra (Aurangabad(BH))','824124',1,0,'2022-03-03 13:17:47','2022-03-03 13:17:47'),(100031,304,'P. Babhandiha','824124',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100032,304,'P. Sikandarpur','824103',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100033,304,'Paharpura','824103',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100034,304,'Panchaukhar','824202',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100035,304,'Pandaria','824111',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100036,304,'Panrawan','824121',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100037,304,'Panti','824125',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100038,304,'Parta','824111',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100039,304,'Pauthu','824121',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100040,304,'Pilchhi','824113',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100041,304,'Pipra Bagahi','824123',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100042,304,'Pironta','824303',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100043,304,'Pirthoo','824208',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100044,304,'Pogar','824125',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100045,304,'Poinwan','824103',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100046,304,'Pokhrahan','824121',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100047,304,'Purdina','824112',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100048,304,'Purhara','824120',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100049,304,'R Pithanua','824112',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100050,304,'R S. Bigha','824112',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100051,304,'R. B. Nagar','824102',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100052,304,'Rafiganj','824125',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100053,304,'Rajbaria Kala','824303',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100054,304,'Rajoi','824103',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100055,304,'Rajpur','824102',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100056,304,'Ramchandra Nagar','824121',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100057,304,'Ramnagar','824124',1,0,'2022-03-03 13:17:48','2022-03-03 13:17:48'),(100058,304,'Ranidih','824125',1,0,'2022-03-03 13:17:49','2022-03-03 13:17:49'),(100059,304,'Risiap','824102',1,0,'2022-03-03 13:17:49','2022-03-03 13:17:49'),(100060,304,'Riyasat Mali','824102',1,0,'2022-03-03 13:17:49','2022-03-03 13:17:49'),(100061,304,'Riyasat Pawai','824102',1,0,'2022-03-03 13:17:49','2022-03-03 13:17:49'),(100062,304,'Rukundi Jhikatia','824129',1,0,'2022-03-03 13:17:49','2022-03-03 13:17:49'),(100063,304,'S. S. College','824102',1,0,'2022-03-03 13:17:49','2022-03-03 13:17:49'),(100064,304,'Saduri Karma','824112',1,0,'2022-03-03 13:17:49','2022-03-03 13:17:49'),(100065,304,'Sahukarma','824125',1,0,'2022-03-03 13:17:49','2022-03-03 13:17:49'),(100066,304,'Sakardiha','824203',1,0,'2022-03-03 13:17:49','2022-03-03 13:17:49'),(100067,304,'Salaiya','824208',1,0,'2022-03-03 13:17:49','2022-03-03 13:17:49'),(100068,304,'Samser Nagar','824143',1,0,'2022-03-03 13:17:49','2022-03-03 13:17:49'),(100069,304,'Sananpura','824124',1,0,'2022-03-03 13:17:49','2022-03-03 13:17:49'),(100070,304,'Sandya','824129',1,0,'2022-03-03 13:17:49','2022-03-03 13:17:49'),(100071,304,'Sansa','824143',1,0,'2022-03-03 13:17:49','2022-03-03 13:17:49'),(100072,304,'Sargawan','824202',1,0,'2022-03-03 13:17:49','2022-03-03 13:17:49'),(100073,304,'Sarsawli','824121',1,0,'2022-03-03 13:17:49','2022-03-03 13:17:49'),(100074,304,'Sartu','824302',1,0,'2022-03-03 13:17:49','2022-03-03 13:17:49'),(100075,304,'Sattar','824301',1,0,'2022-03-03 13:17:49','2022-03-03 13:17:49'),(100076,304,'Satuhai','824112',1,0,'2022-03-03 13:17:49','2022-03-03 13:17:49'),(100077,304,'Seoli Khaira','824125',1,0,'2022-03-03 13:17:49','2022-03-03 13:17:49'),(100078,304,'Shekhpura','824114',1,0,'2022-03-03 13:17:49','2022-03-03 13:17:49'),(100079,304,'Shimra','824303',1,0,'2022-03-03 13:17:49','2022-03-03 13:17:49'),(100080,304,'Shimri Dhamni','824303',1,0,'2022-03-03 13:17:49','2022-03-03 13:17:49'),(100081,304,'Sighana','824202',1,0,'2022-03-03 13:17:49','2022-03-03 13:17:49'),(100082,304,'Sihari','824115',1,0,'2022-03-03 13:17:49','2022-03-03 13:17:49'),(100083,304,'Sihuli','824125',1,0,'2022-03-03 13:17:50','2022-03-03 13:17:50'),(100084,304,'Silar','824102',1,0,'2022-03-03 13:17:50','2022-03-03 13:17:50'),(100085,304,'Silar','824202',1,0,'2022-03-03 13:17:50','2022-03-03 13:17:50'),(100086,304,'Simla','824125',1,0,'2022-03-03 13:17:50','2022-03-03 13:17:50'),(100087,304,'Singhari','824203',1,0,'2022-03-03 13:17:50','2022-03-03 13:17:50'),(100088,304,'Siris','824112',1,0,'2022-03-03 13:17:50','2022-03-03 13:17:50'),(100089,304,'Siyadih','824207',1,0,'2022-03-03 13:17:50','2022-03-03 13:17:50'),(100090,304,'Son Nagar','824112',1,0,'2022-03-03 13:17:50','2022-03-03 13:17:50'),(100091,304,'Sonhathu','824115',1,0,'2022-03-03 13:17:50','2022-03-03 13:17:50'),(100092,304,'Sonoura','824303',1,0,'2022-03-03 13:17:50','2022-03-03 13:17:50'),(100093,304,'Sori','824102',1,0,'2022-03-03 13:17:50','2022-03-03 13:17:50'),(100094,304,'Sunbarasa','824124',1,0,'2022-03-03 13:17:50','2022-03-03 13:17:50'),(100095,304,'Sunurganj','824102',1,0,'2022-03-03 13:17:50','2022-03-03 13:17:50'),(100096,304,'Tandwa (Aurangabad(BH))','824302',1,0,'2022-03-03 13:17:50','2022-03-03 13:17:50'),(100097,304,'Tara','824113',1,0,'2022-03-03 13:17:50','2022-03-03 13:17:50'),(100098,304,'Tarar','824143',1,0,'2022-03-03 13:17:50','2022-03-03 13:17:50'),(100099,304,'Tejpura','824124',1,0,'2022-03-03 13:17:50','2022-03-03 13:17:50'),(100100,304,'Teldiha','824103',1,0,'2022-03-03 13:17:50','2022-03-03 13:17:50'),(100101,304,'Temura','824122',1,0,'2022-03-03 13:17:50','2022-03-03 13:17:50'),(100102,304,'Tengra','824112',1,0,'2022-03-03 13:17:51','2022-03-03 13:17:51'),(100103,304,'Teyap','824203',1,0,'2022-03-03 13:17:51','2022-03-03 13:17:51'),(100104,304,'Turk Telpa','824203',1,0,'2022-03-03 13:17:51','2022-03-03 13:17:51'),(100105,304,'Turta','824123',1,0,'2022-03-03 13:17:51','2022-03-03 13:17:51'),(100106,304,'Udhampur','824103',1,0,'2022-03-03 13:17:51','2022-03-03 13:17:51'),(100107,304,'Umga','824208',1,0,'2022-03-03 13:17:51','2022-03-03 13:17:51'),(100108,304,'Unthoo','824121',1,0,'2022-03-03 13:17:51','2022-03-03 13:17:51'),(100109,304,'Uphara','824203',1,0,'2022-03-03 13:17:51','2022-03-03 13:17:51'),(100110,304,'War','824103',1,0,'2022-03-03 13:17:51','2022-03-03 13:17:51'),(100111,305,'Abhiyudayasharan','813101',1,0,'2022-03-03 13:17:51','2022-03-03 13:17:51'),(100112,305,'Ahiro','813110',1,0,'2022-03-03 13:17:51','2022-03-03 13:17:51'),(100113,305,'Amarpur (Banka)','813101',1,0,'2022-03-03 13:17:51','2022-03-03 13:17:51'),(100114,305,'Auria','813103',1,0,'2022-03-03 13:17:51','2022-03-03 13:17:51'),(100115,305,'Bagduma','813104',1,0,'2022-03-03 13:17:51','2022-03-03 13:17:51'),(100116,305,'Bahrna','813207',1,0,'2022-03-03 13:17:51','2022-03-03 13:17:51'),(100117,305,'Baid Pur','813221',1,0,'2022-03-03 13:17:51','2022-03-03 13:17:51'),(100118,305,'Baidachak','813101',1,0,'2022-03-03 13:17:51','2022-03-03 13:17:51'),(100119,305,'Bairoganj','813106',1,0,'2022-03-03 13:17:51','2022-03-03 13:17:51'),(100120,305,'Balia Mahra','813103',1,0,'2022-03-03 13:17:51','2022-03-03 13:17:51'),(100121,305,'Baliamehra','813102',1,0,'2022-03-03 13:17:51','2022-03-03 13:17:51'),(100122,305,'Bamdev','813107',1,0,'2022-03-03 13:17:51','2022-03-03 13:17:51'),(100123,305,'Bank','814131',1,0,'2022-03-03 13:17:51','2022-03-03 13:17:51'),(100124,305,'Banka H.O','813102',1,0,'2022-03-03 13:17:51','2022-03-03 13:17:51'),(100125,305,'Bara','813202',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100126,305,'Barabad','813211',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100127,305,'Barahat','813103',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100128,305,'Barbasaui','813106',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100129,305,'Barhara','813202',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100130,305,'Basbita','813221',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100131,305,'Basmatta','813202',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100132,305,'Bauiakura','813106',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100133,305,'Belarimilki','813211',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100134,305,'Belhar','813202',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100135,305,'Belsira','813101',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100136,305,'Bharko','813101',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100137,305,'Bhatkund','813109',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100138,305,'Bhatshila','813207',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100139,305,'Bhelwa','813221',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100140,305,'Bhelwa','813106',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100141,305,'Bhghwa','813104',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100142,305,'Bhitia','813207',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100143,305,'Bhojabadar','814131',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100144,305,'Bhorsar','814131',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100145,305,'Bhurna','813104',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100146,305,'Bijaynagar','813102',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100147,305,'Bindi','813109',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100148,305,'Bisanpur Bhurbhuri','813104',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100149,305,'Bishambharchak','813101',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100150,305,'Bishanpur','813207',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100151,305,'Bounsi','813104',1,0,'2022-03-03 13:17:52','2022-03-03 13:17:52'),(100152,305,'Chalna','813110',1,0,'2022-03-03 13:17:53','2022-03-03 13:17:53'),(100153,305,'Chandan','814131',1,0,'2022-03-03 13:17:53','2022-03-03 13:17:53'),(100154,305,'Chandedih','813109',1,0,'2022-03-03 13:17:53','2022-03-03 13:17:53'),(100155,305,'Chanjeri','813109',1,0,'2022-03-03 13:17:53','2022-03-03 13:17:53'),(100156,305,'Charkapathar','813106',1,0,'2022-03-03 13:17:53','2022-03-03 13:17:53'),(100157,305,'Chathar Dhaniar','813221',1,0,'2022-03-03 13:17:53','2022-03-03 13:17:53'),(100158,305,'Chutia','813102',1,0,'2022-03-03 13:17:53','2022-03-03 13:17:53'),(100159,305,'Chutia','813211',1,0,'2022-03-03 13:17:53','2022-03-03 13:17:53'),(100160,305,'Chvapaui','813104',1,0,'2022-03-03 13:17:53','2022-03-03 13:17:53'),(100161,305,'Dahuwa','813104',1,0,'2022-03-03 13:17:53','2022-03-03 13:17:53'),(100162,305,'Danra','813102',1,0,'2022-03-03 13:17:53','2022-03-03 13:17:53'),(100163,305,'Dhakamor','813103',1,0,'2022-03-03 13:17:53','2022-03-03 13:17:53'),(100164,305,'Dhakamore','813102',1,0,'2022-03-03 13:17:53','2022-03-03 13:17:53'),(100165,305,'Dhankuria','813207',1,0,'2022-03-03 13:17:53','2022-03-03 13:17:53'),(100166,305,'Dharia','813205',1,0,'2022-03-03 13:17:53','2022-03-03 13:17:53'),(100167,305,'Dhuibelari','813201',1,0,'2022-03-03 13:17:53','2022-03-03 13:17:53'),(100168,305,'Domohan','813102',1,0,'2022-03-03 13:17:53','2022-03-03 13:17:53'),(100169,305,'Dudhari','813102',1,0,'2022-03-03 13:17:53','2022-03-03 13:17:53'),(100170,305,'Dumarama','813101',1,0,'2022-03-03 13:17:53','2022-03-03 13:17:53'),(100171,305,'Fullidumar','813207',1,0,'2022-03-03 13:17:53','2022-03-03 13:17:53'),(100172,305,'Gidhora','813211',1,0,'2022-03-03 13:17:53','2022-03-03 13:17:53'),(100173,305,'Gokula','813104',1,0,'2022-03-03 13:17:53','2022-03-03 13:17:53'),(100174,305,'Golhatti','813104',1,0,'2022-03-03 13:17:53','2022-03-03 13:17:53'),(100175,305,'Gopalpur','813107',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100176,305,'Gorgama','813101',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100177,305,'Gorgama','813104',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100178,305,'Harchandi','813105',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100179,305,'Haripur','813102',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100180,305,'Hirambi','813109',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100181,305,'Inarabaran','814131',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100182,305,'Jagatpur','813103',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100183,305,'Jaipur','813106',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100184,305,'Jajdiha','813102',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100185,305,'Jamdaha','813102',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100186,305,'Jethorjamua','813102',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100187,305,'Jogdiha','813102',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100188,305,'Jokta Fatehpur','814131',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100189,305,'Jotha','813109',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100190,305,'Kairee','813104',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100191,305,'Kajhia','813103',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100192,305,'Kakwara','813103',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100193,305,'Kamargame','813221',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100194,305,'Kamdeodih','813106',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100195,305,'Kamdeopur','813101',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100196,305,'Kandhar','813106',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100197,305,'Kandnar','813101',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100198,305,'Karanjha','813207',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100199,305,'Kasba','813211',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100200,305,'Kathail','813101',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100201,305,'Kathoun','813107',1,0,'2022-03-03 13:17:54','2022-03-03 13:17:54'),(100202,305,'Kathrang','813105',1,0,'2022-03-03 13:17:55','2022-03-03 13:17:55'),(100203,305,'Katoria','813106',1,0,'2022-03-03 13:17:55','2022-03-03 13:17:55'),(100204,305,'Katsakrh','813106',1,0,'2022-03-03 13:17:55','2022-03-03 13:17:55'),(100205,305,'Kavisha','813211',1,0,'2022-03-03 13:17:55','2022-03-03 13:17:55'),(100206,305,'Kenduar','813101',1,0,'2022-03-03 13:17:55','2022-03-03 13:17:55'),(100207,305,'Kewar','813106',1,0,'2022-03-03 13:17:55','2022-03-03 13:17:55'),(100208,305,'KHARHARA','813103',1,0,'2022-03-03 13:17:55','2022-03-03 13:17:55'),(100209,305,'Khesar','813207',1,0,'2022-03-03 13:17:55','2022-03-03 13:17:55'),(100210,305,'Khojhi','813103',1,0,'2022-03-03 13:17:55','2022-03-03 13:17:55'),(100211,305,'Kolbuzurg','813101',1,0,'2022-03-03 13:17:55','2022-03-03 13:17:55'),(100212,305,'Kolhatha','813109',1,0,'2022-03-03 13:17:55','2022-03-03 13:17:55'),(100213,305,'Krma','813211',1,0,'2022-03-03 13:17:55','2022-03-03 13:17:55'),(100214,305,'Kumarpur','813211',1,0,'2022-03-03 13:17:55','2022-03-03 13:17:55'),(100215,305,'Kumartar','814131',1,0,'2022-03-03 13:17:55','2022-03-03 13:17:55'),(100216,305,'Kunonira','813102',1,0,'2022-03-03 13:17:55','2022-03-03 13:17:55'),(100217,305,'Kunouni','813102',1,0,'2022-03-03 13:17:55','2022-03-03 13:17:55'),(100218,305,'Kushmaha','813104',1,0,'2022-03-03 13:17:55','2022-03-03 13:17:55'),(100219,305,'Lakhnouri','813102',1,0,'2022-03-03 13:17:55','2022-03-03 13:17:55'),(100220,305,'Lakhpura','813103',1,0,'2022-03-03 13:17:55','2022-03-03 13:17:55'),(100221,305,'Laknowdih','813102',1,0,'2022-03-03 13:17:55','2022-03-03 13:17:55'),(100222,305,'Lakra','813107',1,0,'2022-03-03 13:17:55','2022-03-03 13:17:55'),(100223,305,'Laxmipur','813102',1,0,'2022-03-03 13:17:55','2022-03-03 13:17:55'),(100224,305,'Laxmipur Chiraya','813108',1,0,'2022-03-03 13:17:55','2022-03-03 13:17:55'),(100225,305,'Lilotara','813109',1,0,'2022-03-03 13:17:55','2022-03-03 13:17:55'),(100226,305,'Lohari','814131',1,0,'2022-03-03 13:17:55','2022-03-03 13:17:55'),(100227,305,'Mahadwpur','813101',1,0,'2022-03-03 13:17:55','2022-03-03 13:17:55'),(100228,305,'Maheshadih','813102',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100229,305,'Mahisota','813211',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100230,305,'Maikaita','813105',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100231,305,'Makduma','813102',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100232,305,'Malbathan','813102',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100233,305,'Mandar Vidyapith','813104',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100234,305,'Manghi','813202',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100235,305,'Maniyarpur','813104',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100236,305,'Manjhili Matihani','813202',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100237,305,'Manjhoui','813109',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100238,305,'Manjira Gouripur','813102',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100239,305,'Mathura Sahibganj','813202',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100240,305,'Medha','813102',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100241,305,'Mirsapur','813211',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100242,305,'Morma','813107',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100243,305,'Motauga','813110',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100244,305,'Narayanpur','813103',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100245,305,'Nayagaon','813201',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100246,305,'Nayagaon','813104',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100247,305,'Nimia','813207',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100248,305,'Noroun','813207',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100249,305,'Orhore','813109',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100250,305,'Pair','813110',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100251,305,'Palaria','813211',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100252,305,'Panjwara','813110',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100253,305,'Papraiba','813106',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100254,305,'Paraia Chakdih','813102',1,0,'2022-03-03 13:17:56','2022-03-03 13:17:56'),(100255,305,'Pararia','813211',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100256,305,'Pararia Chakadih','813102',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100257,305,'Pasmanandpur','813207',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100258,305,'Pathada','813101',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100259,305,'Pathara','813110',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100260,305,'Patsorikhaira','813107',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100261,305,'Pawai (BanB.O','813101',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100262,305,'Phaga','813104',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100263,305,'Pilua Jharna','813104',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100264,305,'Pira','813106',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100265,305,'Pothia','813205',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100266,305,'Punsia','813109',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100267,305,'Rajoun','813107',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100268,305,'Rajpur','813202',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100269,305,'Rajpur','813102',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100270,305,'Rajwara','813101',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100271,305,'Ramchandrapur Ithari','813102',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100272,305,'Ramchna','813221',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100273,305,'Ramjdha','813107',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100274,305,'Ranghatta','813102',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100275,305,'Ranikita','813101',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100276,305,'Rata','813207',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100277,305,'Rauja','813207',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100278,305,'Rauka','813105',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100279,305,'Rojabar','813107',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100280,305,'Rupsa','813105',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100281,305,'Sabalpur','813104',1,0,'2022-03-03 13:17:57','2022-03-03 13:17:57'),(100282,305,'Sadpur','813110',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100283,305,'Samukhia','813102',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100284,305,'Samukhia More','813102',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100285,305,'Santadih','813212',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100286,305,'Saraiya','813104',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100287,305,'Serua','813104',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100288,305,'Shambhuganj','813211',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100289,305,'Shreepathar','813109',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100290,305,'Shreepathas','813109',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100291,305,'Shyambazar','813104',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100292,305,'Sobhanpur Katoria','813101',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100293,305,'Soguni','813211',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100294,305,'Sondiha Babhangama','813103',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100295,305,'Sondiha Dharmdiha','813103',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100296,305,'Sukhia Barhet','813104',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100297,305,'Sultanpur','813101',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100298,305,'Supha','813106',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100299,305,'Surhari','813101',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100300,305,'Suyambazar','813104',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100301,305,'Telia','813103',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100302,305,'Telia Lowgain','813101',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100303,305,'Tengza','813202',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100304,305,'Tetaria','813106',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100305,305,'Tonapathar','813106',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100306,305,'Uparchakmarhia','813106',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100307,305,'Uprama','813107',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100308,305,'Vijayhat','813109',1,0,'2022-03-03 13:17:58','2022-03-03 13:17:58'),(100309,305,'Phulhara','811308',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100310,306,'Agapur','851128',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100311,306,'Ahiyapur','851111',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100312,306,'Aijani','848204',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100313,306,'Ajhaur','851131',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100314,306,'Akopur','848202',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100315,306,'Amaridih','848202',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100316,306,'Amarpur','851118',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100317,306,'Amba','851112',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100318,306,'Amjadpur Pidhauli','851133',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100319,306,'Arjuntola Baryarpur','851132',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100320,306,'B.Bazar','848201',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100321,306,'B.Deorhi','851113',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100322,306,'B.T.P.P','851116',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100323,306,'Babhangama','851131',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100324,306,'Bachhawara','851111',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100325,306,'Badalpura','851129',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100326,306,'Bagdobh','851129',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100327,306,'Bagras','848201',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100328,306,'Bakhadda','851217',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100329,306,'Balahpur','851129',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100330,306,'Ballia Bazar','851211',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100331,306,'Banduar','851131',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100332,306,'Bank','851211',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100333,306,'Banwaripur','851133',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100334,306,'Baraipura','848204',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100335,306,'Barauni Oil Refinery','851114',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100336,306,'Barauni','851112',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100337,306,'Barauni Urvark Nagar','851115',1,0,'2022-03-03 13:17:59','2022-03-03 13:17:59'),(100338,306,'Bari Ballia','851211',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100339,306,'Bariarpurtola Sirsi','848202',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100340,306,'Barkhunt','851111',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100341,306,'Baro','851118',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100342,306,'Bashi','848202',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100343,306,'Begusarai Court','851101',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100344,306,'Begusarai H.O','851101',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100345,306,'Bhagatpur','851211',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100346,306,'Bhagwanpur','851120',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100347,306,'Bhairwar','851129',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100348,306,'Bhith','851120',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100349,306,'Bhoja','848202',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100350,306,'Bihat','851135',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100351,306,'Bikrampur','851132',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100352,306,'Binodpur','851134',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100353,306,'Birpur','851127',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100354,306,'Bishanpur','851211',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100355,306,'Buchauli','851120',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100356,306,'Chak Hamid','848201',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100357,306,'Chakbedulia','851128',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100358,306,'Chamtha','851111',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100359,306,'Chandaur','851133',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100360,306,'Chandpura','851131',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100361,306,'Chauki','851217',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100362,306,'Cheria','851132',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100363,306,'Chhapki','851131',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100364,306,'Chharrapatti','851217',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100365,306,'Chhatauna','851130',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100366,306,'Chhitraur','851129',1,0,'2022-03-03 13:18:00','2022-03-03 13:18:00'),(100367,306,'Chhourahi','848202',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100368,306,'Chilmil','851131',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100369,306,'Chirainyatol','851111',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100370,306,'Churamachak','851133',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100371,306,'Dafarpur','851127',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100372,306,'Dahiya','851120',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100373,306,'Damdama','851131',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100374,306,'Danauli Phulwaria','851211',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100375,306,'Dandari','851211',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100376,306,'Deopura','848201',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100377,306,'Dhabauli','851129',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100378,306,'Dhankaul','851112',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100379,306,'Dihpar','851127',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100380,306,'Dularpur','851133',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100381,306,'Dumri','851117',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100382,306,'Dunhi','848204',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100383,306,'Ekamba','848204',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100384,306,'Fateha','851111',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100385,306,'Fazilpur','851127',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100386,306,'G.D.College Road','851101',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100387,306,'Gamharia','848201',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100388,306,'Gara','851120',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100389,306,'Garhara','851126',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100390,306,'Garhpura','848204',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100391,306,'Gaura','851113',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100392,306,'Gaynti Gram','851120',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100393,306,'Gehuni','851111',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100394,306,'Ghagrha','848201',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100395,306,'Godhna','851111',1,0,'2022-03-03 13:18:01','2022-03-03 13:18:01'),(100396,306,'Gokhle Nagar Bishanpur','851211',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100397,306,'Gorgama','851211',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100398,306,'Govindpur','851128',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100399,306,'Gram Garhara','851126',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100400,306,'Hanspur','851129',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100401,306,'Hariharpur','851133',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100402,306,'Hasanpur','851130',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100403,306,'Hussaina','851211',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100404,306,'Ishapur','851120',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100405,306,'Jayintigram','851112',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100406,306,'Jokia','851127',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100407,306,'Kabia','851133',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100408,306,'Kaidrabad','851111',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100409,306,'Kaith','851131',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100410,306,'Kamruddinpur','851134',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100411,306,'Katarmala','851130',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100412,306,'Kavia','851120',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100413,306,'Keshave','851134',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100414,306,'Khamhar','851131',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100415,306,'Khanjahapur','851132',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100416,306,'Khizirchak','851112',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100417,306,'Khodabandpur','848202',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100418,306,'Korai','848204',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100419,306,'Koria Haibatpur','851127',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100420,306,'Kumbhi','848202',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100421,306,'Kumharson','848204',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100422,306,'Kushmahaut','851129',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100423,306,'Lakhanpatti','848204',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100424,306,'Lakhanpur','851133',1,0,'2022-03-03 13:18:02','2022-03-03 13:18:02'),(100425,306,'Lakhminia Bazar','851211',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100426,306,'Lakhminia','851211',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100427,306,'Lakho','851129',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100428,306,'Laruara','851218',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100429,306,'Lodiyahi','851111',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100430,306,'M.Babhangama','851112',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100431,306,'Madhurapur','851113',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100432,306,'Madhusudanpur','851211',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100433,306,'Mahendrapur','851129',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100434,306,'Maheshpur','851133',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100435,306,'Maheswara','851127',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100436,306,'Mahipa Tol','851211',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100437,306,'Mahna','851210',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100438,306,'Malipur','848204',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100439,306,'Malpur','848202',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100440,306,'Maniappa','851129',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100441,306,'Manjhaul','851127',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100442,306,'Manopur','851111',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100443,306,'Mansurchak','851128',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100444,306,'Marachi Kalan','851111',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100445,306,'Matihani','851129',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100446,306,'Meghaul','848202',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100447,306,'Mehdasahpur','851132',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100448,306,'Mehdauli','851120',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100449,306,'Mirzapur Banduar','851129',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100450,306,'Mirzapurchand','851112',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100451,306,'Mohanaigh','851129',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100452,306,'Mohanpur','851131',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100453,306,'Mohanpur','848201',1,0,'2022-03-03 13:18:03','2022-03-03 13:18:03'),(100454,306,'Mukhtiyarpur','851133',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100455,306,'Muzaffara','851127',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100456,306,'N.Sheotol','851111',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100457,306,'Nagdah','851117',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100458,306,'Naipur','851128',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100459,306,'Naktitola','851129',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100460,306,'Naokothi','851130',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100461,306,'Naya Gaon (Begusarai)','851215',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100462,306,'Nayanagar','851133',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100463,306,'Neola','851120',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100464,306,'Ninga','851112',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100465,306,'Nonpur','851112',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100466,306,'Noorpur','851210',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100467,306,'Pabra','851127',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100468,306,'Paharpur','851211',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100469,306,'Pahsara Babhangama','851127',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100470,306,'Panapur','851127',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100471,306,'Panchbir','851217',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100472,306,'Pansalla','848202',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100473,306,'Papraur','851210',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100474,306,'Parihara','848201',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100475,306,'Parmanandpur','851211',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100476,306,'Parna','851131',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100477,306,'Parora','848204',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100478,306,'Pasopur','851112',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100479,306,'Paspura','851129',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100480,306,'Phaphaut','848202',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100481,306,'Phulmallik','851217',1,0,'2022-03-03 13:18:04','2022-03-03 13:18:04'),(100482,306,'Pipra Devas','851112',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100483,306,'Purpathar','848204',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100484,306,'Rachiahi Akashpur','851134',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100485,306,'Raghunandanpur','851133',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100486,306,'Raghunathpur','851217',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100487,306,'Rahatpur','851211',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100488,306,'Rajakpur','851130',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100489,306,'Rajapur','851111',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100490,306,'Rajaur','848204',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100491,306,'Rajaura','851131',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100492,306,'Ramdiri','851129',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100493,306,'Rampur','848201',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100494,306,'Rampur Matihani','851129',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100495,306,'Rani','851111',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100496,306,'Rasidpur','851128',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100497,306,'Refinery Township','851117',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100498,306,'Rudauli','851111',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100499,306,'Rupasbaj','851111',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100500,306,'Sadanandpur','851211',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100501,306,'Sadpur','851211',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100502,306,'Safapur','851129',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100503,306,'Sahebpur Kamal','851217',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100504,306,'Sahpur','851129',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100505,306,'Sahuri','851112',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100506,306,'Saidpur','851129',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100507,306,'Sakarbasa','848202',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100508,306,'Sakrauli','848202',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100509,306,'Salemabad','851217',1,0,'2022-03-03 13:18:05','2022-03-03 13:18:05'),(100510,306,'Saligrami','851217',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100511,306,'Samastipur','851217',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100512,306,'Samsa','851128',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100513,306,'Samsa','848201',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100514,306,'Samsipur Bhith','851111',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100515,306,'Sandalpur','851217',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100516,306,'Sanha','851217',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100517,306,'Sanjat','851120',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100518,306,'Sanjat','851133',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100519,306,'Sankh','851131',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100520,306,'Saraunja','851127',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100521,306,'Sihma','851129',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100522,306,'Sihmachakka','848204',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100523,306,'Simaria','851126',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100524,306,'Simaria Ghat','851126',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100525,306,'Singhaul','851134',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100526,306,'Sisauni Kothi','851130',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100527,306,'Sital Rampur','848201',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100528,306,'Sonihar','848201',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100529,306,'Sonma','848201',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100530,306,'Sri Ram Press','851101',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100531,306,'Sripur','851132',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100532,306,'Suhird Nagar','851218',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100533,306,'Suja','851218',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100534,306,'Sumbha','848201',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100535,306,'Surajpura','851133',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100536,306,'Suryapura','851120',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100537,306,'Tajpur','851120',1,0,'2022-03-03 13:18:06','2022-03-03 13:18:06'),(100538,306,'Takiadadpur','851133',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100539,306,'Tarabariarpur','848202',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100540,306,'Teghra','851133',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100541,306,'Tetri','851211',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100542,306,'Tilrath','851112',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100543,306,'Ullao','851134',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100544,306,'Akbarpur','811106',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100545,306,'Bijulia','811106',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100546,306,'Shamho','811106',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100547,307,'Abhiabazar','853204',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100548,307,'Adampur','812001',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100549,307,'Afzugaj','813213',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100550,307,'Agarpur','813210',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100551,307,'Akabarpur','813222',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100552,307,'Akbarnagar','812006',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100553,307,'Aliganj','812005',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100554,307,'Alinagear Rajpur','813210',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100555,307,'Amarpur','853201',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100556,307,'Amba','813108',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100557,307,'Ambapali','813209',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100558,307,'Amdanda','813204',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100559,307,'Amribishapur','812004',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100560,307,'Arar','813204',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100561,307,'Avidapur','853202',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100562,307,'Babhangama','853201',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100563,307,'Badluchak','813105',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100564,307,'Bahadurpur','813210',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100565,307,'Baijani','812005',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100566,307,'Baisijahajirpur','853204',1,0,'2022-03-03 13:18:07','2022-03-03 13:18:07'),(100567,307,'Bakchappar','813108',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100568,307,'Bakharpur','813209',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100569,307,'Bakiadiara','813209',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100570,307,'Balaha','853203',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100571,307,'Balia','853204',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100572,307,'Baliskadma','813205',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100573,307,'Baluachak','812005',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100574,307,'Barahpura','812001',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100575,307,'Barani','813222',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100576,307,'Barari','812003',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100577,307,'Barmasia','813209',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100578,307,'Batsar','813205',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100579,307,'Bhadoria','813105',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100580,307,'Bhagalpur City','812002',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100581,307,'Bhagalpur H.O','812001',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100582,307,'Bhaglapur  Engg. College','813210',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100583,307,'Bhaglapur Central Jail','812001',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100584,307,'Bhaglapur Distt. Board','812001',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100585,307,'Bharamarpur','853201',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100586,307,'Bharatkhand','853203',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100587,307,'Bhatoria','812006',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100588,307,'Bhawanipur','813203',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100589,307,'Bhawanpur','853202',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100590,307,'Bhawauipur','853204',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100591,307,'Bhimdestola','853205',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100592,307,'Bihpur','853201',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100593,307,'Bishanpur','813205',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100594,307,'Bishanpur','813105',1,0,'2022-03-03 13:18:08','2022-03-03 13:18:08'),(100595,307,'Bishanpurjicho','813210',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100596,307,'Budhuchal','813222',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100597,307,'Burhanath','812005',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100598,307,'Buzurgharna','813105',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100599,307,'Chakdaria','813210',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100600,307,'Chaknarayanpur','812006',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100601,307,'Chaknathu','813204',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100602,307,'Chakrani','853203',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100603,307,'Champanagar','812004',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100604,307,'Chandpur','813105',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100605,307,'Chandrabhanpur','812006',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100606,307,'Channo','813204',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100607,307,'Chapar','853204',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100608,307,'Chazabargaon','812006',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100609,307,'Chhotonaki','813204',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100610,307,'Danda Bazar','812005',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100611,307,'Dariapur','812006',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100612,307,'Dhankar','813204',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100613,307,'Dhanora','813204',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100614,307,'Dharahara','853204',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100615,307,'Dharampurrahi','853201',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100616,307,'Dhoabai','813204',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100617,307,'Dholbazza Bazar','853204',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100618,307,'Dimala','853204',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100619,307,'Duldulia','813209',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100620,307,'Ekchari Khawas','813222',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100621,307,'Ekchari','813204',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100622,307,'Ekdara','813222',1,0,'2022-03-03 13:18:09','2022-03-03 13:18:09'),(100623,307,'Fatehpur','812004',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100624,307,'Fatehpur (BhagalpB.O','813210',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100625,307,'Gangapur Diara','813213',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100626,307,'Ghazipur','813221',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100627,307,'Ghogha','813205',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100628,307,'Goradih','813210',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100629,307,'Gosaigaov','853204',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100630,307,'Gourachouki','812005',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100631,307,'Gouripur','853201',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100632,307,'Gvbrain','812006',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100633,307,'Habibpur','812005',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100634,307,'Habibpur (Bhagalpur)','813113',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100635,307,'Haridaspur','812006',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100636,307,'Hario','853201',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100637,307,'Harnathpur','812006',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100638,307,'Harpur','813108',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100639,307,'Hasai','813205',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100640,307,'Hathiyok','813213',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100641,307,'Ishakchak','812001',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100642,307,'Ishapur Chorhar','853202',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100643,307,'Ishipur','813206',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100644,307,'Ismailpur','853205',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100645,307,'Itahari','813206',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100646,307,'Jagatpur','853204',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100647,307,'Jagdishpur (Bhagalpur)','813105',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100648,307,'Jahagira','813213',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100649,307,'Jamuuia','853202',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100650,307,'Jhandapur','853201',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100651,307,'Jotgobind','853205',1,0,'2022-03-03 13:18:10','2022-03-03 13:18:10'),(100652,307,'Kadwadiaza','853204',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100653,307,'Kahalgaon','813203',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100654,307,'Kajraili','812005',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100655,307,'Kalgigaj','813203',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100656,307,'Kaliprasad','813209',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100657,307,'Kaluchak Bispuria','853202',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100658,307,'Kamlakund','853205',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100659,307,'Kapsona','813108',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100660,307,'Karia','813204',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100661,307,'Karik Bazar','853202',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100662,307,'Kasimpur','813105',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100663,307,'Kasri','813203',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100664,307,'Kathara','813213',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100665,307,'Khaira','812006',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100666,307,'Khairpurkadwa','853204',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100667,307,'Khajra','853204',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100668,307,'Khanjarpur','812005',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100669,307,'Khanpurmal','813213',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100670,307,'Kharmanchak','812001',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100671,307,'Khawaspur','813209',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100672,307,'Khiribandha','812005',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100673,307,'Khutaha','812005',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100674,307,'Kiranpur','813108',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100675,307,'Kishandaspur','812006',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100676,307,'Kishanduspur','813222',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100677,307,'Kodanda','813108',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100678,307,'Kumaitha','813213',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100679,307,'Kushmaha','813108',1,0,'2022-03-03 13:18:11','2022-03-03 13:18:11'),(100680,307,'Lagma','813222',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100681,307,'Lahipupr','853201',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100682,307,'Lalapur Bhader','813203',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100683,307,'Laskari','813105',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100684,307,'Latra','853204',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100685,307,'Laxmipur','813222',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100686,307,'Laxmipur Babhania','813204',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100687,307,'Lojain','813108',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100688,307,'Lokmanpur','853202',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100689,307,'M M Ashram','812003',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100690,307,'Machipur','813210',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100691,307,'Madarganj','813204',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100692,307,'Madhurpur','853203',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100693,307,'Madruui','853204',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100694,307,'Mahesakhore','813204',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100695,307,'Mahesh Munda','813203',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100696,307,'Maheshpur','813205',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100697,307,'Mahiama','813205',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100698,307,'Malchatakia','853204',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100699,307,'Mamallkha','813210',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100700,307,'Mangachak','813205',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100701,307,'Mardimushari','813213',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100702,307,'Marwa','853201',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100703,307,'Mathurapur (Bhagalpur)','813222',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100704,307,'Mauiamore','853204',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100705,307,'Mayaganj','812001',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100706,307,'Milki','853201',1,0,'2022-03-03 13:18:12','2022-03-03 13:18:12'),(100707,307,'Mirhatti','813213',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100708,307,'Mirjafari','853202',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100709,307,'Mirjanhat','812005',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100710,307,'Mirzapur','812004',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100711,307,'Mohanpur','813209',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100712,307,'Mohiuddivpur','813105',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100713,307,'Mokinpur','813108',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100714,307,'Moultola','813209',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100715,307,'Murhan','813205',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100716,307,'Nadiama','813205',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100717,307,'Nagarpara','853203',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100718,307,'Najrah','853204',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100719,307,'Nandlalpur','813222',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100720,307,'Nansar','813213',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100721,307,'Narayanpur','813209',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100722,307,'Narayanpur (Bhagalpur)','853203',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100723,307,'Nathnagar','812006',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100724,307,'Naugachia','853204',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100725,307,'Nawadebazar','813105',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100726,307,'Pachrukhibazar','813108',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100727,307,'Paharpur','853203',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100728,307,'Pair','813205',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100729,307,'Pakra','853204',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100730,307,'Panchgachia Bazar','853204',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100731,307,'Parghari','813210',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100732,307,'Passurampur','813209',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100733,307,'Pathak','813204',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100734,307,'Patharghatta','813203',1,0,'2022-03-03 13:18:13','2022-03-03 13:18:13'),(100735,307,'Pharka','813210',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100736,307,'Phulakia','853205',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100737,307,'Pithna','813210',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100738,307,'Prasasthdih','813205',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100739,307,'Pratapnager','853204',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100740,307,'Pripainti Bazar','813209',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100741,307,'Pripainti','813209',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100742,307,'Purnia','812005',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100743,307,'Raghopur','853202',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100744,307,'Raghunitola','853205',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100745,307,'Rahmandih','813205',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100746,307,'Raipur','853203',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100747,307,'Rampur','813222',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100748,307,'Rangra','853204',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100749,307,'Ranidiara','813222',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100750,307,'Ranuchakmakandpur','812004',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100751,307,'Ratanganj','812006',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100752,307,'Rataupurmaikpur','813108',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100753,307,'Rifatpur','813209',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100754,307,'Roshanpur','813206',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100755,307,'S R Sultanganj','813213',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100756,307,'S S Lane','812005',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100757,307,'S.T.Goriar','853205',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100758,307,'S.T.P. Kahalgaon','813214',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100759,307,'Sabour','813210',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100760,307,'Sadhua','853204',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100761,307,'Sadipur','813209',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100762,307,'Sahebganj','812004',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100763,307,'Sahjadpur','813108',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100764,307,'Sahjatpur','812005',1,0,'2022-03-03 13:18:14','2022-03-03 13:18:14'),(100765,307,'Sahkund','813108',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100766,307,'Sahuparbatta','853204',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100767,307,'Saino','813105',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100768,307,'Sajour','812006',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100769,307,'Sakrama','813205',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100770,307,'Salempur','813101',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100771,307,'Salempurtola','813209',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100772,307,'Samastipur','813108',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100773,307,'Sangitbaita','813203',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100774,307,'Sangrampur (Bhagalpur)','813212',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100775,307,'Sanhoula','813205',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100776,307,'Sanhouli','812005',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100777,307,'Sanjh','813105',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100778,307,'Sanokhar','813204',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100779,307,'Sarkanda','813209',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100780,307,'Sathiari','813205',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100781,307,'Satjiri','813105',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100782,307,'Satparaiya','813108',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100783,307,'Semaria','812005',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100784,307,'Shankarpur','812004',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100785,307,'Shaukarpur','813210',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100786,307,'Shobnathpur','813203',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100787,307,'Sian','813206',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100788,307,'Sighnan','813105',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100789,307,'Silhan','813204',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100790,307,'Sohail','813204',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100791,307,'Sonbarsa','853201',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100792,307,'Srighia Makandpur','853204',1,0,'2022-03-03 13:18:15','2022-03-03 13:18:15'),(100793,307,'Srimatpur','813209',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100794,307,'Srimatpur','813204',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100795,307,'Srinagar','813209',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100796,307,'Sujaganj Bazar','812002',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100797,307,'Sukhari','813206',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100798,307,'Suktia','853205',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100799,307,'Sultanganj (Bhagalpur)','813213',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100800,307,'T. N. B College','812007',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100801,307,'Tarcha','813105',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100802,307,'Tatarpur','812002',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100803,307,'Tazar','813205',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100804,307,'Telghee','853202',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100805,307,'Tetripakra','853204',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100806,307,'TILAKPUR','813213',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100807,307,'Tilkamanjhi','812001',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100808,307,'Tintanga','853205',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100809,307,'Tintangadiara','853205',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100810,307,'Trimohan','813204',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100811,307,'Tulsipur Jamunia','853202',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100812,307,'Udhadih','813213',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100813,307,'Ganganiya','811211',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100814,308,'Khawaspur','841312',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100815,308,'Agiaon Bazar','802202',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100816,308,'Agiaon','802201',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100817,308,'Agrsanda Behara','802156',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100818,308,'Akarua','802155',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100819,308,'Akhagaon','802352',1,0,'2022-03-03 13:18:16','2022-03-03 13:18:16'),(100820,308,'Allipur','802161',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100821,308,'Amehata','802202',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100822,308,'Amrainawada','802154',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100823,308,'Anaith','802302',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100824,308,'Andhari','802222',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100825,308,'Arrah Chowk','802301',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100826,308,'Arrah H.O','802301',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100827,308,'Arrah Kutchey','802301',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100828,308,'Ashni Jaitpur','802210',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100829,308,'Ayar','802203',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100830,308,'Babhangawan','802163',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100831,308,'Babhaniaon','802158',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100832,308,'Babura','802163',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100833,308,'Bachari','802207',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100834,308,'Baga','802164',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100835,308,'Bagar','802222',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100836,308,'Baghi','802201',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100837,308,'Bagmajhauan','802163',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100838,308,'Bagwan','802203',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100839,308,'Bahoranpur','802166',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100840,308,'Bahuara','802158',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100841,308,'Bairahi','802158',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100842,308,'Baisadih','802207',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100843,308,'Bakhorapur','802311',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100844,308,'Balbandh','802203',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100845,308,'Baligaon','802203',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100846,308,'Balua High School','802351',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100847,308,'Bambhawar','802155',1,0,'2022-03-03 13:18:17','2022-03-03 13:18:17'),(100848,308,'Bampali','802312',1,0,'2022-03-03 13:18:18','2022-03-03 13:18:18'),(100849,308,'Banahi','802183',1,0,'2022-03-03 13:18:18','2022-03-03 13:18:18'),(100850,308,'Bandhu Chhapra','802163',1,0,'2022-03-03 13:18:18','2022-03-03 13:18:18'),(100851,308,'Bankat','802206',1,0,'2022-03-03 13:18:18','2022-03-03 13:18:18'),(100852,308,'Bankat Sikaria','802183',1,0,'2022-03-03 13:18:18','2022-03-03 13:18:18'),(100853,308,'Barad Parwa','802158',1,0,'2022-03-03 13:18:18','2022-03-03 13:18:18'),(100854,308,'Barahara','802311',1,0,'2022-03-03 13:18:18','2022-03-03 13:18:18'),(100855,308,'Barakhrauni','802166',1,0,'2022-03-03 13:18:18','2022-03-03 13:18:18'),(100856,308,'Barauli','802207',1,0,'2022-03-03 13:18:18','2022-03-03 13:18:18'),(100857,308,'Bargaon','802209',1,0,'2022-03-03 13:18:18','2022-03-03 13:18:18'),(100858,308,'Bariswan','802165',1,0,'2022-03-03 13:18:18','2022-03-03 13:18:18'),(100859,308,'Barka Dumra','802312',1,0,'2022-03-03 13:18:18','2022-03-03 13:18:18'),(100860,308,'Barkagaon ','802201',1,0,'2022-03-03 13:18:18','2022-03-03 13:18:18'),(100861,308,'Barnaon','802203',1,0,'2022-03-03 13:18:18','2022-03-03 13:18:18'),(100862,308,'Baruhi','802208',1,0,'2022-03-03 13:18:18','2022-03-03 13:18:18'),(100863,308,'Basantpur','802156',1,0,'2022-03-03 13:18:18','2022-03-03 13:18:18'),(100864,308,'Basauri','802207',1,0,'2022-03-03 13:18:18','2022-03-03 13:18:18'),(100865,308,'Baulipur','802152',1,0,'2022-03-03 13:18:18','2022-03-03 13:18:18'),(100866,308,'Belauna','802154',1,0,'2022-03-03 13:18:18','2022-03-03 13:18:18'),(100867,308,'Belaur','802206',1,0,'2022-03-03 13:18:18','2022-03-03 13:18:18'),(100868,308,'Belauti','802154',1,0,'2022-03-03 13:18:18','2022-03-03 13:18:18'),(100869,308,'Belghat Balua','802312',1,0,'2022-03-03 13:18:18','2022-03-03 13:18:18'),(100870,308,'Bemari','802154',1,0,'2022-03-03 13:18:18','2022-03-03 13:18:18'),(100871,308,'Benwalia','802351',1,0,'2022-03-03 13:18:18','2022-03-03 13:18:18'),(100872,308,'Berath','802201',1,0,'2022-03-03 13:18:18','2022-03-03 13:18:18'),(100873,308,'Bhadsera','802209',1,0,'2022-03-03 13:18:18','2022-03-03 13:18:18'),(100874,308,'Bhadwar','802161',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100875,308,'Bhakura','802205',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100876,308,'Bharasra Judge','802152',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100877,308,'Bharauli','802165',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100878,308,'Bhelai','802312',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100879,308,'Bichhiaon','802206',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100880,308,'Bihia','802152',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100881,308,'Bihta English','802209',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100882,308,'Bimwan','802152',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100883,308,'Birampur','802314',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100884,308,'Birpur','802165',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100885,308,'Bishunpur Dumaria','802314',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100886,308,'Chakai','802152',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100887,308,'Chakia','802207',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100888,308,'Chamarpur','802166',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100889,308,'Chandakewatia','802166',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100890,308,'Chandawa','802312',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100891,308,'Chandi','802223',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100892,308,'Charghat Chanaur','802166',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100893,308,'Charpokhari','802223',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100894,308,'Chasi','802201',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100895,308,'Chaturbhujibaraon','802159',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100896,308,'Chaugain','802205',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100897,308,'Chaurasta Bihia','802154',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100898,308,'Chhotka Sasaram','802157',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100899,308,'Chhwarhi','802155',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100900,308,'Chilhar','802164',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100901,308,'Chilhose','802164',1,0,'2022-03-03 13:18:19','2022-03-03 13:18:19'),(100902,308,'Dakhin Ekauna','802210',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100903,308,'Dalippur (Bhojpur)','802155',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100904,308,'Damodarpur','802166',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100905,308,'Dariapur','802156',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100906,308,'Daulatpur','802163',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100907,308,'Dawan','802152',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100908,308,'Deo','802209',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100909,308,'Deochanda','802207',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100910,308,'Deoria','802210',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100911,308,'Derhgaon','802204',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100912,308,'Dhamar','802156',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100913,308,'Dhanauti','802207',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100914,308,'Dhanchhuhan','802208',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100915,308,'Dhandihan','802160',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100916,308,'Dhangawan','802209',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100917,308,'Dhobha Bazar','802156',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100918,308,'Dhrubdihan','802207',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100919,308,'Dilia','802201',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100920,308,'Dulamchak- Chak Chaudhari','802208',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100921,308,'Dularpur','802206',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100922,308,'Dumaria','802207',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100923,308,'Ekauna','802311',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100924,308,'Ekwari','802208',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100925,308,'Eyar','802155',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100926,308,'Gaharuaon','802204',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100927,308,'Gajrajganj','802157',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100928,308,'Gangahar','802312',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100929,308,'Garhani','802203',1,0,'2022-03-03 13:18:20','2022-03-03 13:18:20'),(100930,308,'Gaudarh Rudranagar','802183',1,0,'2022-03-03 13:18:21','2022-03-03 13:18:21'),(100931,308,'Gaura','802166',1,0,'2022-03-03 13:18:21','2022-03-03 13:18:21'),(100932,308,'Gidha','802314',1,0,'2022-03-03 13:18:21','2022-03-03 13:18:21'),(100933,308,'Guljarpur','802208',1,0,'2022-03-03 13:18:21','2022-03-03 13:18:21'),(100934,308,'Gunari','802313',1,0,'2022-03-03 13:18:21','2022-03-03 13:18:21'),(100935,308,'H.D.Jain College','802301',1,0,'2022-03-03 13:18:21','2022-03-03 13:18:21'),(100936,308,'Hadiabad','802203',1,0,'2022-03-03 13:18:21','2022-03-03 13:18:21'),(100937,308,'Hanswadih','802155',1,0,'2022-03-03 13:18:21','2022-03-03 13:18:21'),(100938,308,'Haradiya','802152',1,0,'2022-03-03 13:18:21','2022-03-03 13:18:21'),(100939,308,'Hasan Bazar','802204',1,0,'2022-03-03 13:18:21','2022-03-03 13:18:21'),(100940,308,'Hetampur','802158',1,0,'2022-03-03 13:18:21','2022-03-03 13:18:21'),(100941,308,'Horil Chhapra','802165',1,0,'2022-03-03 13:18:21','2022-03-03 13:18:21'),(100942,308,'Ichari','802203',1,0,'2022-03-03 13:18:21','2022-03-03 13:18:21'),(100943,308,'Imadpur','802222',1,0,'2022-03-03 13:18:21','2022-03-03 13:18:21'),(100944,308,'Jagdishpur (Bhojpur)','802158',1,0,'2022-03-03 13:18:21','2022-03-03 13:18:21'),(100945,308,'Jalpura','802352',1,0,'2022-03-03 13:18:21','2022-03-03 13:18:21'),(100946,308,'Jamira','802161',1,0,'2022-03-03 13:18:21','2022-03-03 13:18:21'),(100947,308,'Jamorhi','802204',1,0,'2022-03-03 13:18:21','2022-03-03 13:18:21'),(100948,308,'Jamuaon','802159',1,0,'2022-03-03 13:18:21','2022-03-03 13:18:21'),(100949,308,'Jamuaon Dihari','802206',1,0,'2022-03-03 13:18:21','2022-03-03 13:18:21'),(100950,308,'Jethwar Bhatt','802204',1,0,'2022-03-03 13:18:21','2022-03-03 13:18:21'),(100951,308,'Jitaura','802159',1,0,'2022-03-03 13:18:21','2022-03-03 13:18:21'),(100952,308,'Jokta','802352',1,0,'2022-03-03 13:18:21','2022-03-03 13:18:21'),(100953,308,'Kahathumasurhi','802158',1,0,'2022-03-03 13:18:21','2022-03-03 13:18:21'),(100954,308,'Kahen','802203',1,0,'2022-03-03 13:18:21','2022-03-03 13:18:21'),(100955,308,'Kahndani','802202',1,0,'2022-03-03 13:18:21','2022-03-03 13:18:21'),(100956,308,'Kakila','802158',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100957,308,'Kalyanpur','802154',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100958,308,'Kamariaon','802183',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100959,308,'Karath','802205',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100960,308,'Karbasin','802201',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100961,308,'Karisath','802157',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100962,308,'Karwan','802312',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100963,308,'Kasap','802206',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100964,308,'Kataria','802202',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100965,308,'Kateyan','802152',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100966,308,'Katkaira','802160',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100967,308,'Kaup','802203',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100968,308,'Kawara','802162',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100969,308,'Kayamnagar','802314',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100970,308,'Kesari','802155',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100971,308,'Kesawan','802155',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100972,308,'Khajuria','802156',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100973,308,'Khangaon','802161',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100974,308,'Khopira','802206',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100975,308,'Khraonkalan','802208',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100976,308,'Khutahan','802222',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100977,308,'Kirhi','802205',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100978,308,'Kirkiri','802164',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100979,308,'Koil','802223',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100980,308,'Koilwar','802160',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100981,308,'Kolodihri','802222',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100982,308,'Kori','802164',1,0,'2022-03-03 13:18:22','2022-03-03 13:18:22'),(100983,308,'Koshiar','802208',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(100984,308,'Krishnagarh','802313',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(100985,308,'Kulharia','802160',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(100986,308,'Kumhaila','802223',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(100987,308,'Kundeshar','802165',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(100988,308,'Kurmichak','802201',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(100989,308,'Kurmurhi','802207',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(100990,308,'Kurur','802205',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(100991,308,'Kushi','802205',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(100992,308,'Lachhutola','802351',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(100993,308,'Lahang Dumaria','802351',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(100994,308,'Lahrabad','802207',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(100995,308,'Lahritiwaridih','802207',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(100996,308,'Lahthan','802202',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(100997,308,'Lasari','802201',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(100998,308,'Lauhar Farna','802311',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(100999,308,'Lilari','802223',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(101000,308,'Madanpur','802201',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(101001,308,'Maharaja College','802301',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(101002,308,'Mahuaon','802183',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(101003,308,'Mahuli','802312',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(101004,308,'Mahulighat','802316',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(101005,308,'Mainpura','802156',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(101006,308,'Majhiaon','802223',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(101007,308,'Malaur','802223',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(101008,308,'Maniachh','802206',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(101009,308,'Manikpur','802163',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(101010,308,'Mansagar','802223',1,0,'2022-03-03 13:18:23','2022-03-03 13:18:23'),(101011,308,'Manudehari','802158',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101012,308,'Masarh','802162',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101013,308,'Masuri','802158',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101014,308,'Matukpur','802311',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101015,308,'Moapkalan','802222',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101016,308,'Mohanpur  Karja','802311',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101017,308,'Mukundpur','802223',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101018,308,'Nagari','802223',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101019,308,'Nagraon','802207',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101020,308,'Narayan Pur Baghaur','802202',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101021,308,'Narayanpur','802201',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101022,308,'Narayanpur','802204',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101023,308,'Narhi Chandi','802161',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101024,308,'Nasaratpur','802352',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101025,308,'Nathmalpur','802316',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101026,308,'Nawada Ben','802162',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101027,308,'Nawada Pataria','802208',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101028,308,'Naya Mohamad  Pur','802163',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101029,308,'Neknam Tola','802311',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101030,308,'Noaon','802204',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101031,308,'Nonar','802207',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101032,308,'Osain','802183',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101033,308,'Pachma','802204',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101034,308,'Pachrukhia','802204',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101035,308,'Pachrukhia Kala','802163',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101036,308,'Pakari','802301',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101037,308,'Pandurarampur','802164',1,0,'2022-03-03 13:18:24','2022-03-03 13:18:24'),(101038,308,'Panwari','802222',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101039,308,'Parasia','802158',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101040,308,'Pareo','802160',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101041,308,'Pasaur','802223',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101042,308,'Pawana','802201',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101043,308,'Pawar','802201',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101044,308,'Perhap','802208',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101045,308,'Peur','802208',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101046,308,'Pharpur','802201',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101047,308,'Phuhan','802163',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101048,308,'Phulari','802164',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101049,308,'Piania','802210',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101050,308,'Pirauta','802312',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101051,308,'Piru','802207',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101052,308,'Pitaru','802202',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101053,308,'Posawa','802201',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101054,308,'Prashurampur','802316',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101055,308,'Pratappur','802352',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101056,308,'Purahra','802222',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101057,308,'Purana Haripur','802163',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101058,308,'Rajapur','802155',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101059,308,'Rajapur English','802163',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101060,308,'Rajeyan','802159',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101061,308,'Ramasarh','802164',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101062,308,'Ramsahar','802311',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101063,308,'Ranisagar','802165',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101064,308,'Ratanpur','802312',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101065,308,'Ratnarh','802203',1,0,'2022-03-03 13:18:25','2022-03-03 13:18:25'),(101066,308,'Sahangi','802203',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101067,308,'Sahar (Bhojpur)','802208',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101068,308,'Sakaddi','802160',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101069,308,'Sakariramnagar','802204',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101070,308,'Sakhuan','802206',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101071,308,'Sakla Bazar','802205',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101072,308,'Salempur','802351',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101073,308,'Sandaur','802154',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101074,308,'Sandesh Bhatauli','802164',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101075,308,'Sandesh','802164',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101076,308,'Saneya Barhata','802162',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101077,308,'Sara','802209',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101078,308,'Saraiyan','802313',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101079,308,'Sarathua','802206',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101080,308,'Sarna','802165',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101081,308,'Sedahan','802207',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101082,308,'Semaria Patti Ojha','802165',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101083,308,'Semraon','802203',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101084,308,'Sewatha','802201',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101085,308,'Shahbad Distt.Board Ara','802301',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101086,308,'Shahjauli','802165',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101087,308,'Shahpurpatti','802165',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101088,308,'Sheoganj (Bhojpur)','802301',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101089,308,'Sheopur','802203',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101090,308,'Sheopur','802204',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101091,308,'Sheopurkunai','802158',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101092,308,'Siaruan','802158',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101093,308,'Sikrahta Kala','802222',1,0,'2022-03-03 13:18:26','2022-03-03 13:18:26'),(101094,308,'Sikraulfatehpur','802207',1,0,'2022-03-03 13:18:27','2022-03-03 13:18:27'),(101095,308,'Sinha','802316',1,0,'2022-03-03 13:18:27','2022-03-03 13:18:27'),(101096,308,'Sinhaghat','802316',1,0,'2022-03-03 13:18:27','2022-03-03 13:18:27'),(101097,308,'Siyadih','802223',1,0,'2022-03-03 13:18:27','2022-03-03 13:18:27'),(101098,308,'Sohara Tribhuani','802316',1,0,'2022-03-03 13:18:27','2022-03-03 13:18:27'),(101099,308,'Sonbarsa','802205',1,0,'2022-03-03 13:18:27','2022-03-03 13:18:27'),(101100,308,'Sonbarsa','802207',1,0,'2022-03-03 13:18:27','2022-03-03 13:18:27'),(101101,308,'Sonpura','802206',1,0,'2022-03-03 13:18:27','2022-03-03 13:18:27'),(101102,308,'Sripalpur','802314',1,0,'2022-03-03 13:18:27','2022-03-03 13:18:27'),(101103,308,'Suhia','802165',1,0,'2022-03-03 13:18:27','2022-03-03 13:18:27'),(101104,308,'Sunderpur Barja','802351',1,0,'2022-03-03 13:18:27','2022-03-03 13:18:27'),(101105,308,'Tar','802155',1,0,'2022-03-03 13:18:27','2022-03-03 13:18:27'),(101106,308,'Tarari','802209',1,0,'2022-03-03 13:18:27','2022-03-03 13:18:27'),(101107,308,'Tenduni','802158',1,0,'2022-03-03 13:18:27','2022-03-03 13:18:27'),(101108,308,'Thakuri','802207',1,0,'2022-03-03 13:18:27','2022-03-03 13:18:27'),(101109,308,'Tola Achraj Lal','802351',1,0,'2022-03-03 13:18:27','2022-03-03 13:18:27'),(101110,308,'Udawant Nagar','802210',1,0,'2022-03-03 13:18:27','2022-03-03 13:18:27'),(101111,308,'Umraonganj','802166',1,0,'2022-03-03 13:18:27','2022-03-03 13:18:27'),(101112,308,'Waina Jamuni Pur','802155',1,0,'2022-03-03 13:18:27','2022-03-03 13:18:27'),(101113,308,'Waliganj','802301',1,0,'2022-03-03 13:18:27','2022-03-03 13:18:27'),(101114,309,'Ahirauli','802116',1,0,'2022-03-03 13:18:27','2022-03-03 13:18:27'),(101115,309,'Akhauripur Gola','802114',1,0,'2022-03-03 13:18:27','2022-03-03 13:18:27'),(101116,309,'Amsari','802126',1,0,'2022-03-03 13:18:27','2022-03-03 13:18:27'),(101117,309,'Arak','802111',1,0,'2022-03-03 13:18:27','2022-03-03 13:18:27'),(101118,309,'Ariaon','802119',1,0,'2022-03-03 13:18:27','2022-03-03 13:18:27'),(101119,309,'Arjunpur','802116',1,0,'2022-03-03 13:18:27','2022-03-03 13:18:27'),(101120,309,'Asha Parari','802135',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101121,309,'Athar','802126',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101122,309,'Atimi','802129',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101123,309,'Atrauna','802123',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101124,309,'Attaon','802119',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101125,309,'Bagen','802134',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101126,309,'Baikunthpur','802123',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101127,309,'Balua','802130',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101128,309,'Banarpur','802114',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101129,309,'Banni','802128',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101130,309,'Barka Dhakaich','802133',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101131,309,'Barka Sikraul','802114',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101132,309,'Barka Singhanpura','802120',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101133,309,'Barkarajpur','802113',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101134,309,'Barki Basauri','802119',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101135,309,'Barki Kulharia','802116',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101136,309,'Barki Nainijor','802112',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101137,309,'Baru R.S.','802119',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101138,309,'Baruhan','802134',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101139,309,'Basantpur','802123',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101140,309,'Basaon Kalan','802129',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101141,309,'Bashudhar','802123',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101142,309,'Belahari','802126',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101143,309,'Belaon','802129',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101144,309,'Bhada','802134',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101145,309,'Bhadar','802126',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101146,309,'Bhadwar Barari','802134',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101147,309,'Bhatauli','802129',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101148,309,'Bikaram English','802117',1,0,'2022-03-03 13:18:28','2022-03-03 13:18:28'),(101149,309,'Bisikala','802129',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101150,309,'Boksa','802103',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101151,309,'Brahampur','802112',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101152,309,'Brahmapur Chaurasta','802112',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101153,309,'Buxar Gajadhar Ganj','802103',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101154,309,'Buxar H.O','802101',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101155,309,'Buxar Jail','802102',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101156,309,'Chakki','802120',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101157,309,'Chanawath','802125',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101158,309,'Chaubey Ke Prasia','802128',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101159,309,'Chaugai','802115',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101160,309,'Chaukia','802133',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101161,309,'Chausa (Buxar)','802114',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101162,309,'Chhatnawar','802133',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101163,309,'Chhilhari','802133',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101164,309,'Chhotkarajpur','802113',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101165,309,'Chunni','802114',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101166,309,'Churamanpur','802116',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101167,309,'Dahiwar','802116',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101168,309,'Dallupur','802130',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101169,309,'Dalsagar','802116',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101170,309,'Daulatpur','802313',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101171,309,'Dehari','802114',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101172,309,'Deokuli','802112',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101173,309,'Deoria','802122',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101174,309,'Dhanbakhra','802129',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101175,309,'Dhansoi','802117',1,0,'2022-03-03 13:18:29','2022-03-03 13:18:29'),(101176,309,'Dharauli','802134',1,0,'2022-03-03 13:18:30','2022-03-03 13:18:30'),(101177,309,'Diaman','802111',1,0,'2022-03-03 13:18:30','2022-03-03 13:18:30'),(101178,309,'Diwan De Barka Gaon','802123',1,0,'2022-03-03 13:18:30','2022-03-03 13:18:30'),(101179,309,'Dulahpur','802118',1,0,'2022-03-03 13:18:30','2022-03-03 13:18:30'),(101180,309,'Dumari (Buxar)','802120',1,0,'2022-03-03 13:18:30','2022-03-03 13:18:30'),(101181,309,'Dumraon','802119',1,0,'2022-03-03 13:18:30','2022-03-03 13:18:30'),(101182,309,'Dumraon Textiles','802136',1,0,'2022-03-03 13:18:30','2022-03-03 13:18:30'),(101183,309,'Ekauna Dubauli','802131',1,0,'2022-03-03 13:18:30','2022-03-03 13:18:30'),(101184,309,'Ekauni','802119',1,0,'2022-03-03 13:18:30','2022-03-03 13:18:30'),(101185,309,'Ekrasi','802134',1,0,'2022-03-03 13:18:30','2022-03-03 13:18:30'),(101186,309,'Gagaura','802117',1,0,'2022-03-03 13:18:30','2022-03-03 13:18:30'),(101187,309,'Gaighat','802130',1,0,'2022-03-03 13:18:30','2022-03-03 13:18:30'),(101188,309,'Gangauli','802131',1,0,'2022-03-03 13:18:30','2022-03-03 13:18:30'),(101189,309,'Girdhar Baraon','802127',1,0,'2022-03-03 13:18:30','2022-03-03 13:18:30'),(101190,309,'Girdharpur','802129',1,0,'2022-03-03 13:18:30','2022-03-03 13:18:30'),(101191,309,'Gosaipur','802114',1,0,'2022-03-03 13:18:30','2022-03-03 13:18:30'),(101192,309,'Hariyana Cattle Farm','802119',1,0,'2022-03-03 13:18:30','2022-03-03 13:18:30'),(101193,309,'Harpur','802128',1,0,'2022-03-03 13:18:30','2022-03-03 13:18:30'),(101194,309,'Hathilpur','802130',1,0,'2022-03-03 13:18:30','2022-03-03 13:18:30'),(101195,309,'Hethua','802122',1,0,'2022-03-03 13:18:30','2022-03-03 13:18:30'),(101196,309,'Hitawarajpur','802122',1,0,'2022-03-03 13:18:30','2022-03-03 13:18:30'),(101197,309,'Indaur','802117',1,0,'2022-03-03 13:18:30','2022-03-03 13:18:30'),(101198,309,'Isharapura','802112',1,0,'2022-03-03 13:18:30','2022-03-03 13:18:30'),(101199,309,'Itarhi','802123',1,0,'2022-03-03 13:18:30','2022-03-03 13:18:30'),(101200,309,'Itarhian','802117',1,0,'2022-03-03 13:18:30','2022-03-03 13:18:30'),(101201,309,'Jalahara','802128',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101202,309,'Jamauli','802128',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101203,309,'Jigna','802129',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101204,309,'Jogia','802111',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101205,309,'Kaithi','802134',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101206,309,'Kajaria','802128',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101207,309,'Kakaria','802117',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101208,309,'Kamarpur','802102',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101209,309,'Kanehari','802128',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101210,309,'Kanjharua','802126',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101211,309,'Kant','802112',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101212,309,'Karhshi','802102',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101213,309,'Karnamepur','802112',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101214,309,'Karsar','802129',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101215,309,'Kasia','802126',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101216,309,'Kathar','802111',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101217,309,'Katiknar','802125',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101218,309,'Kesath','802125',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101219,309,'Keshopur','802113',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101220,309,'Khandricha','802126',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101221,309,'Khanita','802123',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101222,309,'Kharahatand','802120',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101223,309,'Khirauli','802136',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101224,309,'Khiri','802128',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101225,309,'Khocharia','802117',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101226,309,'Kopawan','802126',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101227,309,'Koran Sarai','802126',1,0,'2022-03-03 13:18:31','2022-03-03 13:18:31'),(101228,309,'Kukurahan','802123',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101229,309,'L.K.Dera','802112',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101230,309,'Lakhandihara','802119',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101231,309,'M.V.College Buxar','802102',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101232,309,'Mahdah','802103',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101233,309,'Mahila','802123',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101234,309,'Mahuar','802112',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101235,309,'Majharia','802116',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101236,309,'Mangraon Sangraon','802122',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101237,309,'Mania','802125',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101238,309,'Manikpur','802128',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101239,309,'Manjhawari','802133',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101240,309,'Manoharpur (Buxar)','802128',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101241,309,'Mansingh Patti Barkagaon','802118',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101242,309,'Mathila','802126',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101243,309,'Moharihan','802128',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101244,309,'Mugaon','802126',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101245,309,'Mukhraon','802128',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101246,309,'Murar','802127',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101247,309,'Nachap','802134',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101248,309,'Nadaoan','802103',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101249,309,'Nagpur','802122',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101250,309,'Nagpura','802118',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101251,309,'Nagwan','802133',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101252,309,'Nagwan','802129',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101253,309,'Nai Bazar (Buxar)','802101',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101254,309,'Nainijor','802112',1,0,'2022-03-03 13:18:32','2022-03-03 13:18:32'),(101255,309,'Nandan','802119',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101256,309,'Nauranga','802112',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101257,309,'Nawanagar (Buxar)','802129',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101258,309,'Naya Bhojpur','802133',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101259,309,'Nehalpur','802117',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101260,309,'Nenua','802119',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101261,309,'Niazipur','802131',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101262,309,'Nimej','802130',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101263,309,'Nuaon','802111',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101264,309,'Ojha Baraon','802115',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101265,309,'Pandeypatti','802103',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101266,309,'Pararia Pramanpur','802129',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101267,309,'Parasia','802111',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101268,309,'Pasahara','802119',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101269,309,'Phaphadar','802115',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101270,309,'Pokharahan','802134',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101271,309,'Prasaunda','802112',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101272,309,'Pulia','802102',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101273,309,'Purana Bhojpur','802133',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101274,309,'Raghunathpur (Buxar)','802134',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101275,309,'Rahathua','802134',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101276,309,'Rajpur','802131',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101277,309,'Rampur','802114',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101278,309,'Rampur','802127',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101279,309,'Rani Singhanpura','802120',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101280,309,'Rasen','802128',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101281,309,'Rauni','802122',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101282,309,'Rupsagar','802129',1,0,'2022-03-03 13:18:33','2022-03-03 13:18:33'),(101283,309,'Sahiyar','802131',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101284,309,'Saisar Ganghari','802117',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101285,309,'Salsala','802125',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101286,309,'Sarenja','802114',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101287,309,'Sarimpur','802116',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101288,309,'Sheopur  North','802125',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101289,309,'Sheopur Diar','802131',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101290,309,'Sikraul','802129',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101291,309,'Simari','802135',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101292,309,'Sisrarh','802122',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101293,309,'Sohni Patti','802101',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101294,309,'Sonbarsa','802125',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101295,309,'Sonbarsa','802118',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101296,309,'Sonbarsa','802112',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101297,309,'Sondhila','802103',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101298,309,'Sonpa','802114',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101299,309,'Sowan','802111',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101300,309,'Sukarwalia','802114',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101301,309,'Tikthi','802112',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101302,309,'Tiyar','802134',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101303,309,'Tundiganjbazar','802133',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101304,309,'Umarpur Diar','802118',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101305,309,'Umedpur','802112',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101306,309,'Unwas','802123',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101307,309,'Upadhyapandeypur','802118',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101308,309,'Waina','802125',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101309,310,'A.Babhangama','847121',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101310,310,'A.Nimrauli','847304',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101311,310,'Adalpur','847115',1,0,'2022-03-03 13:18:34','2022-03-03 13:18:34'),(101312,310,'Adharpur','847427',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101313,310,'Adhloam','847201',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101314,310,'Afzala','847203',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101315,310,'Ahdwara','847203',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101316,310,'Ahiyari','847304',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101317,310,'Akabarpur Bank','847203',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101318,310,'Alinagar','847405',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101319,310,'Amaithi','847233',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101320,310,'Anandpur','847101',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101321,310,'Andauli','847103',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101322,310,'Antaur','847103',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101323,310,'Arai Birdipur','847106',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101324,310,'Araila','847106',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101325,310,'Arga','847105',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101326,310,'Ashraha','847121',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101327,310,'Ashthua','847104',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101328,310,'Asi','847203',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101329,310,'Atahar','847201',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101330,310,'Atihar','846007',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101331,310,'Aurahi','847203',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101332,310,'B.Bira','846005',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101333,310,'B.K.Asthan','846005',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101334,310,'B.M.V.Pith','846002',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101335,310,'B.Parsa','847337',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101336,310,'B.Russelpur','847203',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101337,310,'Badarbanna','847233',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101338,310,'Baghant','847422',1,0,'2022-03-03 13:18:35','2022-03-03 13:18:35'),(101339,310,'Baghaul','847201',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101340,310,'Baghauni','847105',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101341,310,'Baghra Simri','847105',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101342,310,'Baghras','847427',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101343,310,'Bahadurpur','846002',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101344,310,'Bahera','847201',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101345,310,'Baheri (Darbhanga)','847105',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101346,310,'Baigani','847201',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101347,310,'Bakmandal','847105',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101348,310,'Baligaon','847101',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101349,310,'Balour','847422',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101350,310,'Balthari','847203',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101351,310,'Banauli','847428',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101352,310,'Bandhauli','847303',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101353,310,'Banka','847121',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101354,310,'Bardaha','847304',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101355,310,'Barhaulia','847106',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101356,310,'Barhi','846005',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101357,310,'Bariaul','846005',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101358,310,'Basatwara','847428',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101359,310,'Basauli','847121',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101360,310,'Baskatti','847201',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101361,310,'Bathia','847423',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101362,310,'Batho','847233',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101363,310,'Bauharwa','847423',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101364,310,'Bauram','847203',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101365,310,'Bazitpur','847422',1,0,'2022-03-03 13:18:36','2022-03-03 13:18:36'),(101366,310,'Belhi','847337',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101367,310,'Benipur','847103',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101368,310,'Benta South','846003',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101369,310,'Bhacchi','847101',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101370,310,'Bhadhar','847203',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101371,310,'Bhandar Sogani','847422',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101372,310,'Bharathi','847428',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101373,310,'Bharwara','847104',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101374,310,'Bhataura','847306',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101375,310,'Bhatraghat','847122',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101376,310,'Bhawanipur','847103',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101377,310,'Bhawanipur','847104',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101378,310,'Bherwa','847304',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101379,310,'Bhoj Pandaul','847121',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101380,310,'Bhuskaul','846007',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101381,310,'Bihar Nursary','847123',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101382,310,'Bijuli','847115',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101383,310,'Biraul','847203',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101384,310,'Bisfi','847122',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101385,310,'Bishanpur','847303',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101386,310,'Bishnupur (Darbhanga)','847204',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101387,310,'Bishwanathpur Tarauni','847233',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101388,310,'Boraj','847105',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101389,310,'Brahampur Sotia','847307',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101390,310,'Brahampura','847422',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101391,310,'Brahmpatti','847201',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101392,310,'C M College','846004',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101393,310,'Chak Tataila','847304',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101394,310,'Chakla','847201',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101395,310,'Chakwa','847301',1,0,'2022-03-03 13:18:37','2022-03-03 13:18:37'),(101396,310,'Chanaur','847422',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101397,310,'Chandanpatti','846002',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101398,310,'Chandauna','847303',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101399,310,'Chatwan','847337',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101400,310,'Chhacha','847337',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101401,310,'Chhotaipatti','847337',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101402,310,'Chilha Dilawarpur','847101',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101403,310,'D.Kasraur','847203',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101404,310,'D.M.C.','846003',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101405,310,'D.Pauri','847201',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101406,310,'Dadpatti','847405',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101407,310,'Damala','847304',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101408,310,'Darbhanga Bara Bazar','846004',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101409,310,'Darbhanga Chowk','846004',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101410,310,'Darbhanga City','846004',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101411,310,'Darbhanga H.O','846004',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101412,310,'Darima','847121',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101413,310,'Dasauth','847405',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101414,310,'Dekuli','846002',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101415,310,'Dhamsain','847405',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101416,310,'Dhamuara','847405',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101417,310,'Dhanauli','847101',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101418,310,'Dharia','847304',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101419,310,'Dhoi','846009',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101420,310,'Dihrampur','846003',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101421,310,'Dilahi','846003',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101422,310,'Doghra','847302',1,0,'2022-03-03 13:18:38','2022-03-03 13:18:38'),(101423,310,'Dulha','847121',1,0,'2022-03-03 13:18:39','2022-03-03 13:18:39'),(101424,310,'Fardaha','847233',1,0,'2022-03-03 13:18:39','2022-03-03 13:18:39'),(101425,310,'G.Basailha','846007',1,0,'2022-03-03 13:18:39','2022-03-03 13:18:39'),(101426,310,'Galma','847427',1,0,'2022-03-03 13:18:39','2022-03-03 13:18:39'),(101427,310,'Ganaun','847427',1,0,'2022-03-03 13:18:39','2022-03-03 13:18:39'),(101428,310,'Gangauli','847407',1,0,'2022-03-03 13:18:39','2022-03-03 13:18:39'),(101429,310,'Garaul','847423',1,0,'2022-03-03 13:18:39','2022-03-03 13:18:39'),(101430,310,'Garri','847303',1,0,'2022-03-03 13:18:39','2022-03-03 13:18:39'),(101431,310,'Ghanshyampur (Darbhanga)','847427',1,0,'2022-03-03 13:18:39','2022-03-03 13:18:39'),(101432,310,'Ghoshrama','847301',1,0,'2022-03-03 13:18:39','2022-03-03 13:18:39'),(101433,310,'Gobarsitha','847301',1,0,'2022-03-03 13:18:39','2022-03-03 13:18:39'),(101434,310,'Gora Mansingh','847203',1,0,'2022-03-03 13:18:39','2022-03-03 13:18:39'),(101435,310,'Goriari','846003',1,0,'2022-03-03 13:18:39','2022-03-03 13:18:39'),(101436,310,'Gorkha','847405',1,0,'2022-03-03 13:18:39','2022-03-03 13:18:39'),(101437,310,'Gujrauli','847101',1,0,'2022-03-03 13:18:39','2022-03-03 13:18:39'),(101438,310,'Habi Bhuar','847233',1,0,'2022-03-03 13:18:39','2022-03-03 13:18:39'),(101439,310,'Habidih','847201',1,0,'2022-03-03 13:18:39','2022-03-03 13:18:39'),(101440,310,'Harhachcha','847101',1,0,'2022-03-03 13:18:39','2022-03-03 13:18:39'),(101441,310,'Hariath','847423',1,0,'2022-03-03 13:18:39','2022-03-03 13:18:39'),(101442,310,'Hariharpur','847306',1,0,'2022-03-03 13:18:39','2022-03-03 13:18:39'),(101443,310,'Haripur','847233',1,0,'2022-03-03 13:18:39','2022-03-03 13:18:39'),(101444,310,'Haripur','847427',1,0,'2022-03-03 13:18:39','2022-03-03 13:18:39'),(101445,310,'Harsinghpur','847103',1,0,'2022-03-03 13:18:39','2022-03-03 13:18:39'),(101446,310,'Hathauri','847301',1,0,'2022-03-03 13:18:39','2022-03-03 13:18:39'),(101447,310,'Hawasa','847101',1,0,'2022-03-03 13:18:39','2022-03-03 13:18:39'),(101448,310,'Hayaghat Bilashpur','847301',1,0,'2022-03-03 13:18:39','2022-03-03 13:18:39'),(101449,310,'Hiropatti','847304',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101450,310,'Imambari','846001',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101451,310,'Inai','847105',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101452,310,'Itwa Shivnagar','847201',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101453,310,'Izra','847337',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101454,310,'Jagwan','847304',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101455,310,'Jahangirtola','847303',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101456,310,'Jaideopatti','847405',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101457,310,'Jakso Jamalpur','847203',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101458,310,'Jalley','847302',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101459,310,'Jalwara','847121',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101460,310,'Jarso','847201',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101461,310,'Jayantipur','847103',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101462,310,'Jhagarua','847427',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101463,310,'Jogiara','847101',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101464,310,'Jogiara','847303',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101465,310,'Jorja','847101',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101466,310,'K D S U','846008',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101467,310,'K.Harari','847301',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101468,310,'K.Jagdishpur','847103',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101469,310,'K.Manjhigama','847306',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101470,310,'Kabaria Khutwara','846009',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101471,310,'Kabirchak','846009',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101472,310,'Kaithwar','847204',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101473,310,'Kakorha','847204',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101474,310,'Kaligaon','847104',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101475,310,'Kamrouli','847428',1,0,'2022-03-03 13:18:40','2022-03-03 13:18:40'),(101476,310,'Kamtaul','847304',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101477,310,'Kanaur','847306',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101478,310,'Kanhai','847203',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101479,310,'Kansi','847428',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101480,310,'Kansi Simri','847106',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101481,310,'Kanthudih','847201',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101482,310,'Kapchhahi','846009',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101483,310,'Karhatia','847306',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101484,310,'Karjapatti','847306',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101485,310,'Kasraur','847427',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101486,310,'Kathalia','847123',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101487,310,'Kathalwari','846004',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101488,310,'Kathra','847423',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101489,310,'Katka','847307',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101490,310,'Katraul','847302',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101491,310,'Keoti Ranway','847121',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101492,310,'Khaira Kunji','847101',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101493,310,'Khangraitha','847105',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101494,310,'Kharajpur','846003',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101495,310,'Kharkha','847302',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101496,310,'Kharua','847115',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101497,310,'Khirma','847121',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101498,310,'Kilaghat','846004',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101499,310,'Koilam','847301',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101500,310,'Kora','847104',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101501,310,'Korthu','847103',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101502,310,'Kothia','847306',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101503,310,'Kothra','847105',1,0,'2022-03-03 13:18:41','2022-03-03 13:18:41'),(101504,310,'Kothram','847203',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101505,310,'Kumhrauli','847304',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101506,310,'Kurso Nadiami','847405',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101507,310,'Kusothar','847429',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101508,310,'L.Rambhadrapur','847407',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101509,310,'Ladaho','847203',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101510,310,'Ladour','847107',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101511,310,'Lahatta','847423',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101512,310,'Laheriasarai Court','846001',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101513,310,'Laheriasarai H.O','846001',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101514,310,'Lahwar','847337',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101515,310,'Lalsahpur','846005',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101516,310,'Laxmanpur','847201',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101517,310,'Laxmipur Kakorba','847203',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101518,310,'Laxmisagar (Darbhanga)','846009',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101519,310,'Loam','847115',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101520,310,'Lohna Road','847407',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101521,310,'M.P.Bahadurpur','846002',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101522,310,'M.Sajhouti','847301',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101523,310,'M.Sinuara','846003',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101524,310,'Madanpur','847101',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101525,310,'Madhopatti','847306',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101526,310,'Madhupur','847306',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101527,310,'Mahinam','847103',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101528,310,'Mahpara','846009',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101529,310,'Mahuli','847201',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101530,310,'Mahwa','847201',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101531,310,'Manigachi','847422',1,0,'2022-03-03 13:18:42','2022-03-03 13:18:42'),(101532,310,'Manikauli','847104',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101533,310,'Matunia','847105',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101534,310,'Maun Behat','847423',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101535,310,'Milkichak','846009',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101536,310,'Mirzapur','847101',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101537,310,'Mohiuddinagar Pakari','847103',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101538,310,'Moro','847106',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101539,310,'Motipur','847103',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101540,310,'Muraitha','847304',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101541,310,'Muria','847115',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101542,310,'N.N. Patti','847405',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101543,310,'Nadiami','847203',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101544,310,'Nagardih','847304',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101545,310,'Narauchdham','847307',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101546,310,'Narayandohat','847105',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101547,310,'Narayanpur','847204',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101548,310,'Nari','847103',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101549,310,'Narsara','846003',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101550,310,'Naruar','847407',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101551,310,'Nawada','847201',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101552,310,'Nayagaon','847121',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101553,310,'Nehra','847233',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101554,310,'Neori','847103',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101555,310,'Nikasi','847306',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101556,310,'Nimathi','847101',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101557,310,'Nishihara','847203',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101558,310,'Ojhaul','846003',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101559,310,'P.Basant','846003',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101560,310,'P.Bela','847427',1,0,'2022-03-03 13:18:43','2022-03-03 13:18:43'),(101561,310,'P.Buzurg','847203',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101562,310,'P.Mahathwar','847427',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101563,310,'Pacharhi','847337',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101564,310,'Paghari','847203',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101565,310,'Paghari','847105',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101566,310,'Paigambarpur','847123',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101567,310,'Pali','847304',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101568,310,'Panchobe','846003',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101569,310,'Parohi','847122',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101570,310,'Patania','847203',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101571,310,'Patore','847101',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101572,310,'Pindaruch','847306',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101573,310,'Pohhadi','847103',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101574,310,'Pokhar Bhinda','847407',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101575,310,'Postal Traning Centre','846005',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101576,310,'Punhad','847427',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101577,310,'Putai','847423',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101578,310,'R.A.P.Mills','846002',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101579,310,'Raghauli','847304',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101580,310,'Ramauli','847201',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101581,310,'Ramnagar Dhusi','847233',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101582,310,'Rampura','847123',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101583,310,'Rarhi','847302',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101584,310,'Rasalpur','847301',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101585,310,'Rashiyari','847427',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101586,310,'Rasidpur','847423',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101587,310,'Ratanpur (Darbhanga)','847307',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101588,310,'Ratanpura','847106',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101589,310,'Ratanpura','846002',1,0,'2022-03-03 13:18:44','2022-03-03 13:18:44'),(101590,310,'Rathaus','847304',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101591,310,'Ratwara','847301',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101592,310,'Reorha','847302',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101593,310,'Rohar','847103',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101594,310,'Ruchighat','847103',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101595,310,'Rupauli Ghat','846003',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101596,310,'Ryam Factory','847337',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101597,310,'S.Bijulia','847201',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101598,310,'S.Dangarwara','847306',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101599,310,'S.H.M.C','846002',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101600,310,'S.Lagma','847427',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101601,310,'S.Lalganj','847121',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101602,310,'S.R.Bithauli','847201',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101603,310,'Sadhopur','847301',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101604,310,'Sadiquepur','847337',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101605,310,'Sadullahpur','847304',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101606,310,'Sahari','847201',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101607,310,'Sahjauli','847405',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101608,310,'Saho','847201',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101609,310,'Saho Parri','847201',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101610,310,'Sahsram','847203',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101611,310,'Sajanpura','847201',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101612,310,'Sajhuar','847201',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101613,310,'Sanahpurdih','847307',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101614,310,'Saramohanpur','846007',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101615,310,'Sarwara','847106',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101616,310,'Satghara','847337',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101617,310,'Sherpur','847204',1,0,'2022-03-03 13:18:45','2022-03-03 13:18:45'),(101618,310,'Shivnagarghat','847103',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101619,310,'Shivram','847101',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101620,310,'Shivram','847233',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101621,310,'Sidhauli','847101',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101622,310,'Sihaul','847201',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101623,310,'Simariabhindia','847301',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101624,310,'Singhaso','847121',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101625,310,'Singhia Deorhi','847306',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101626,310,'Singhwara','847123',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101627,310,'Sinuar Gopal','847429',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101628,310,'Sirnia','846002',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101629,310,'Sirua Maner','847101',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101630,310,'Siso','846005',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101631,310,'Sisodih.','846005',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101632,310,'Sonhaun','846005',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101633,310,'Sonki','846009',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101634,310,'Sonpur','847203',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101635,310,'Srirampur','847101',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101636,310,'Subhankarpur','846006',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101637,310,'Subhash Keso','847107',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101638,310,'Susari','847201',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101639,310,'Taralahi','846003',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101640,310,'Tarsarai','847115',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101641,310,'Tarwara','847427',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101642,310,'Tarwara','847201',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101643,310,'Tatuar','847422',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101644,310,'Tehwara','847123',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101645,310,'Telhan','847115',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101646,310,'Thalwara','846002',1,0,'2022-03-03 13:18:46','2022-03-03 13:18:46'),(101647,310,'Tharma','847107',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101648,310,'Thathopur','847105',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101649,310,'Thengaha','847405',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101650,310,'Trimuhanighat','847201',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101651,310,'Tumaul','847405',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101652,310,'Uchatti','847203',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101653,310,'Ughra','847101',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101654,310,'Bhalpatti','847239',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101655,310,'Dahaura','847239',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101656,310,'Kanhouli','847239',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101657,310,'Karbi Dhankaul','847102',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101658,310,'Nainaghat','847239',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101659,310,'Paithankabai','847239',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101660,310,'Raghopur Deorhi','847239',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101661,310,'Sakhwar','847424',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101662,310,'Manuar','852216',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101663,310,'Bairampur','848209',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101664,310,'Bargaon','848213',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101665,310,'Beridharsham','848213',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101666,310,'Bhindua','848213',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101667,310,'Chigri','848213',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101668,310,'Deokuli','848209',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101669,310,'Dinmo','848213',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101670,310,'Harinagar','848209',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101671,310,'Hirni','848213',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101672,310,'Ithar','848213',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101673,310,'Jahingra','848506',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101674,310,'Keotgama','848213',1,0,'2022-03-03 13:18:47','2022-03-03 13:18:47'),(101675,310,'Kuseshwar Asthan','848213',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101676,310,'Mauzi','848205',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101677,310,'Nowdega Balha','848209',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101678,310,'Satighat','848213',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101679,310,'Simartoka','848213',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101680,310,'Sugrain','848207',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101681,310,'Tetrahi','848207',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101682,310,'Tilkeshwar','848207',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101683,310,'Ujua','848213',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101684,310,'Usri','848213',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101685,311,'Adapur','845301',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101686,311,'Ahiman Chapra','845413',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101687,311,'Ahiranlia','845417',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101688,311,'Ahiraulia','845433',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101689,311,'Ajgarhimath','845401',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101690,311,'Ajgarwa','845428',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101691,311,'Amawa','845303',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101692,311,'Amodei','845433',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101693,311,'Andhra','845433',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101694,311,'Areraj','845411',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101695,311,'Ashok Pakari','845429',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101696,311,'Athmohan','845303',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101697,311,'Atiraulia','845415',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101698,311,'Auraia','845301',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101699,311,'B.R.T.Nararwa','845435',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101700,311,'Bagaha Champaran','845315',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101701,311,'Bagahi','845433',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101702,311,'Bahadurpur','845411',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101703,311,'Baharupia','845437',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101704,311,'Bahlolpur','845413',1,0,'2022-03-03 13:18:48','2022-03-03 13:18:48'),(101705,311,'Bahlolpur','845418',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101706,311,'Bahuarawa','845456',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101707,311,'Bahuarwa Gopi Singh','845436',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101708,311,'Baidhnathpur','845415',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101709,311,'Bairia (East Champaran)','845401',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101710,311,'Bairiadih','845435',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101711,311,'Bairiya','845434',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101712,311,'Bairiya','845433',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101713,311,'Bairiya','845424',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101714,311,'Bakarpur Jagat','845413',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101715,311,'Bakhari','845413',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101716,311,'Bakhari','845457',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101717,311,'Bakhari Mahesh','845413',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101718,311,'Bakhathaura','845301',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101719,311,'Balo Chak','845412',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101720,311,'Balua','845422',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101721,311,'Balua Tola','845304',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101722,311,'Baluwa','845457',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101723,311,'Bangari','845429',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101724,311,'Bankatwa','845303',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101725,311,'Bankatwa','845424',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101726,311,'Bans Ghat','845426',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101727,311,'Bara Chakia','845412',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101728,311,'Bara Jaipam','845418',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101729,311,'Bara Shankar','845457',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101730,311,'Baramania','845412',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49');
INSERT INTO `cities` VALUES (101731,311,'Barawa','845302',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101732,311,'Barawa','845301',1,0,'2022-03-03 13:18:49','2022-03-03 13:18:49'),(101733,311,'Barharwa F.Mohamad','845304',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101734,311,'Barharwa Kala','845437',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101735,311,'Barharwa Lakhansen','845418',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101736,311,'Barharwa Siwan','845418',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101737,311,'Bariarpur','845401',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101738,311,'Barkagaon','845428',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101739,311,'Barmashwa','845437',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101740,311,'Barwa Khurd','845304',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101741,311,'Bazitpur','845420',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101742,311,'Bediban Madhuban','845416',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101743,311,'Bela','845433',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101744,311,'Bela Baiju','845457',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101745,311,'Belahiya','845301',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101746,311,'Belghatiya','845435',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101747,311,'Bella','845302',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101748,311,'Belwa','845305',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101749,311,'Belwa Madho','845423',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101750,311,'Belwa Rai Khas','845435',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101751,311,'Belwatia','845429',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101752,311,'Betauna','845457',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101753,311,'Bhada Murli','845417',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101754,311,'Bhandar','845427',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101755,311,'Bhargaon','845435',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101756,311,'Bharwalia','845425',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101757,311,'Bhataha','845456',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101758,311,'Bhatwalia','845417',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101759,311,'Bhawanipur Bazar','845301',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101760,311,'Bhelahi','845305',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101761,311,'Bhelwa','845420',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101762,311,'Bhelwa Circle','845315',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101763,311,'Bhgwatia','845432',1,0,'2022-03-03 13:18:50','2022-03-03 13:18:50'),(101764,311,'Bhopatpur','845432',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101765,311,'Bhurkurwa','845406',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101766,311,'Bhuwan Chapra','845412',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101767,311,'Bijayee','845315',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101768,311,'Bijdhari','845424',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101769,311,'Bijwani','845303',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101770,311,'Bishambharapur','845413',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101771,311,'Bishunpurwa','845301',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101772,311,'Bisunpur Basant','845430',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101773,311,'Bokane Kala','845414',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101774,311,'Chailaha','845401',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101775,311,'Chainpur','845433',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101776,311,'Chainpur','845437',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101777,311,'Chaita','845414',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101778,311,'Champapur','845433',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101779,311,'Champapur Koraiya','845315',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101780,311,'Chanari','845302',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101781,311,'Chandanwara','845304',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101782,311,'Chandaria','845411',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101783,311,'Chandi Sthan','845419',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101784,311,'Chandrahiya','845429',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101785,311,'Chapra Bahas','845435',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101786,311,'Chapra Bihari','845414',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101787,311,'Chatia','845425',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101788,311,'Chauradano','845302',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101789,311,'Chhapawa Phulwaria','845456',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101790,311,'Chhapkahia','845458',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101791,311,'Chintamanpur','845416',1,0,'2022-03-03 13:18:51','2022-03-03 13:18:51'),(101792,311,'Chiraiya','845415',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101793,311,'Chorma','845414',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101794,311,'Dalpat Bishunpur','845427',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101795,311,'Damodarpur Mathia','845425',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101796,311,'Damodarpur','845416',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101797,311,'Dariapur (East Champaran)','845417',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101798,311,'Darmaha','845432',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101799,311,'Darpa','845302',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101800,311,'Deokulia','845430',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101801,311,'Dhaka','845418',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101802,311,'Dhanhar Dihuli','845433',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101803,311,'Dhanujee','845428',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101804,311,'Dhawahi','845422',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101805,311,'Dhekaha Bazar','845401',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101806,311,'Dilawarpur','845426',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101807,311,'Dipahi Dharharwa','845315',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101808,311,'Dubaha','845301',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101809,311,'Dulama','845414',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101810,311,'Dumarighat','845423',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101811,311,'Dumra','845417',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101812,311,'Ekdari','845302',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101813,311,'Gad Bahuari','845440',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101814,311,'Gai Ghat','845437',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101815,311,'Gamaharia Kala','845301',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101816,311,'Gamharia','845431',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101817,311,'Gamharia Khurd','845301',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101818,311,'Ganga Pipara','845458',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101819,311,'Gariba','845432',1,0,'2022-03-03 13:18:52','2022-03-03 13:18:52'),(101820,311,'Gawandra','845426',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101821,311,'Gawandri','845304',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101822,311,'Gheghawa','845436',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101823,311,'Ghiwadhar','845411',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101824,311,'Ghora Sahan','845303',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101825,311,'Gobindganj','845419',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101826,311,'Gonaha','845305',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101827,311,'Gonahi','845427',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101828,311,'Gorahia','845426',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101829,311,'Govindpur','845411',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101830,311,'Gudra','845456',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101831,311,'Gulwara Madhuban','845420',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101832,311,'Gurhanawa','845304',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101833,311,'Haraj','845418',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101834,311,'Hardia','845401',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101835,311,'Hardiya','845305',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101836,311,'Harnaraina','845418',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101837,311,'Harnath','845418',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101838,311,'Harpur','845301',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101839,311,'Harpur Nag','845412',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101840,311,'Harsiddhi','845422',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101841,311,'Hazipur','845432',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101842,311,'Hussaini','845423',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101843,311,'Ibrahimpur Parsauni','845430',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101844,311,'Inrawa','845433',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101845,311,'Itwa','845428',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101846,311,'Izara','845419',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101847,311,'Izara Nawada','845419',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101848,311,'Izor Bara','845430',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101849,311,'Jadopur','845422',1,0,'2022-03-03 13:18:53','2022-03-03 13:18:53'),(101850,311,'Jagapakar','845411',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101851,311,'Jagiraha','845437',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101852,311,'Jaishingpur','845437',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101853,311,'Jaitapur Laukaria','845440',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101854,311,'Jamonia Koraiya','845303',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101855,311,'Jamua','845418',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101856,311,'Janerw A','845435',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101857,311,'Jasauli Patti','845437',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101858,311,'Jasouli Jamunia','845432',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101859,311,'Jhajhara','845303',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101860,311,'Jhakhara','845429',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101861,311,'Jhitkahia','845431',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101862,311,'Jhitkahiya','845406',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101863,311,'Jhitkahiya','845427',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101864,311,'Jihuli','845427',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101865,311,'Jitaura','845414',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101866,311,'Jitpur','845302',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101867,311,'Jiwdhara','845429',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101868,311,'Jokiyari','845305',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101869,311,'Juafar','845302',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101870,311,'K.Hareram','845426',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101871,311,'K.Mehsi','845426',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101872,311,'Kadamawa','845303',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101873,311,'Kaithwalia','845456',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101874,311,'Kajraha','845436',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101875,311,'Kalu Pakar','845430',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101876,311,'Kalyanpur','845413',1,0,'2022-03-03 13:18:54','2022-03-03 13:18:54'),(101877,311,'Kanchhedwa','845422',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101878,311,'Kapur Pakari','845418',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101879,311,'Kararia','845417',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101880,311,'Karhan','845423',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101881,311,'Karmawa','845304',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101882,311,'Karsahiya','845418',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101883,311,'Kashi Pakari','845406',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101884,311,'Kataha','845426',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101885,311,'Katahariya','845413',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101886,311,'Katha Loknathpur','845401',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101887,311,'Kathmalia','845418',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101888,311,'Kaurihar','845305',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101889,311,'Kauriya','845420',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101890,311,'Kesharia','845424',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101891,311,'Kh0ri Pakar','845427',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101892,311,'Khagani','845435',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101893,311,'Khairi Ajgarwa','845401',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101894,311,'Khairimal','845416',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101895,311,'Khartari','845415',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101896,311,'Khodarpur','845420',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101897,311,'Khurahiya','845303',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101898,311,'Kodariya','845430',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101899,311,'Kodarkat','845302',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101900,311,'Koila Belwa','845412',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101901,311,'Koilhara','845420',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101902,311,'Konia','845432',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101903,311,'Kotwa','845437',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101904,311,'Krishna Nagara','845420',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101905,311,'Kritpur Mathiya','845411',1,0,'2022-03-03 13:18:55','2022-03-03 13:18:55'),(101906,311,'Kuawa','845412',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101907,311,'Kumrar','845430',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101908,311,'Kundwa Chainpur','845304',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101909,311,'Kunwar Dhekha','845424',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101910,311,'Kuriya','845416',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101911,311,'Kurkur Jari','845431',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101912,311,'Kushar','845437',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101913,311,'Lakhaura','845302',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101914,311,'Latihanawa','845302',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101915,311,'Laukaria','845440',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101916,311,'Laukhan','845418',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101917,311,'Lauriya','845411',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101918,311,'Laxmipur','845401',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101919,311,'Laxmipur Pokhariya','845433',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101920,311,'M.B.Ban','845412',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101921,311,'M.B.Bathana','845429',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101922,311,'M.Sikatia','845425',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101923,311,'Madan Sirsiya','845426',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101924,311,'Madchhargawa','845417',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101925,311,'Madhopur','845415',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101926,311,'Madhopur','845437',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101927,311,'Madhopur Govind','845426',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101928,311,'Madhopur Keso','845406',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101929,311,'Madhubani Kala','845418',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101930,311,'Madhubanighat','845401',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101931,311,'Madhuhawa Brit','845436',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101932,311,'Madhurapur','845420',1,0,'2022-03-03 13:18:56','2022-03-03 13:18:56'),(101933,311,'Mahamada','845426',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101934,311,'Mahatha Tola','845417',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101935,311,'Mahuawa','845415',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101936,311,'Mahuawa Imilia','845302',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101937,311,'Majhar Gohiya','845428',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101938,311,'Majhar Gorhiya','845414',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101939,311,'Majharia','845433',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101940,311,'Majharia','845401',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101941,311,'Majhaulia','845414',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101942,311,'Makhuwa','845437',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101943,311,'Malahi','845425',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101944,311,'Mali','845456',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101945,311,'Mamarkha','845425',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101946,311,'Mangalpur','845423',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101947,311,'Manglapur Rajpur','845434',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101948,311,'Manguraha','845458',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101949,311,'Manikpur','845437',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101950,311,'Mankararia','845422',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101951,311,'Mankarwa','845430',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101952,311,'Mansingha','845431',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101953,311,'Math Lohiyar','845422',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101954,311,'Mathia Bhopat','845315',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101955,311,'Mathia Brit','845302',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101956,311,'Mathurapur','845429',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101957,311,'Mazirwa','845315',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101958,311,'Mehsi','845426',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101959,311,'Mirpur','845415',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101960,311,'Mirzapur','845457',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101961,311,'Misraulia','845415',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101962,311,'Moglania','845420',1,0,'2022-03-03 13:18:57','2022-03-03 13:18:57'),(101963,311,'Motihari  College','845401',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101964,311,'Motihari Chowk','845401',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101965,311,'Motihari City','845401',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101966,311,'Motihari Court','845401',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101967,311,'Motihari H.O','845401',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101968,311,'Mukhalishpur Pachrukhi','845435',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101969,311,'Murarpur','845437',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101970,311,'Murla','845433',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101971,311,'Muzia','845430',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101972,311,'Nagdaha','845425',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101973,311,'Nankardewa','845406',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101974,311,'Narayanpur','845427',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101975,311,'Narhar Panapur','845406',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101976,311,'Narkatia','845301',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101977,311,'Naurangia','845420',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101978,311,'Nawada','845414',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101979,311,'Nawadih','845458',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101980,311,'Naya Gaon','845424',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101981,311,'Nimoiya','845315',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101982,311,'Nirpur','845304',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101983,311,'Nonia','845422',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101984,311,'Noniman','845406',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101985,311,'Noniyadih','845305',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101986,311,'Nonpharawa','845427',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101987,311,'Nonuara','845315',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101988,311,'P Atjilawa','845415',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101989,311,'P.Tapasi','845440',1,0,'2022-03-03 13:18:58','2022-03-03 13:18:58'),(101990,311,'Pachpakari','845427',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(101991,311,'Padmuker','845427',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(101992,311,'Paesauna Madan','845433',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(101993,311,'Paharia','845422',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(101994,311,'Paharpur','845458',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(101995,311,'Pakari Dayal','845428',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(101996,311,'Pakari Dixit','845412',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(101997,311,'Pakaria','845302',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(101998,311,'Palanwa','845440',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(101999,311,'Panapur Ranjeeta','845422',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(102000,311,'Panditpur','845422',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(102001,311,'Panjiarwa','845431',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(102002,311,'Parsa','845456',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(102003,311,'Parsauna','845417',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(102004,311,'Parsauni Brit','845413',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(102005,311,'Parsurampur','845305',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(102006,311,'Patahi (East Champaran)','845457',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(102007,311,'Patani','845433',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(102008,311,'Pataura','845401',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(102009,311,'Persauni Kapoor','845457',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(102010,311,'Phenhara','845430',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(102011,311,'Phularia','845433',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(102012,311,'Phulwar','845315',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(102013,311,'Phulwar','845431',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(102014,311,'Phulwaria','845304',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(102015,311,'Pipara','845419',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(102016,311,'Pipra Factory','845429',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(102017,311,'Pipra Khem','845412',1,0,'2022-03-03 13:18:59','2022-03-03 13:18:59'),(102018,311,'Prasurampur','845416',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102019,311,'Presauni Kishun','845416',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102020,311,'Puchharia','845434',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102021,311,'Purainia','845301',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102022,311,'Puran Chapra','845426',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102023,311,'Purandara','845305',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102024,311,'Purnahiya','845303',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102025,311,'Purshottampur','845302',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102026,311,'Purvi Pakari','845423',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102027,311,'Radhia','845458',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102028,311,'Raghopur Gangapipar','845418',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102029,311,'Raghunathpur','845433',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102030,311,'Raghunathpur Bazar','845432',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102031,311,'Raghunathpur Bazar','845431',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102032,311,'Rai Kararia','845422',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102033,311,'Rajepur Champaran','845406',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102034,311,'Rajpur (East Champaran)','845432',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102035,311,'Ramgahrwa','845433',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102036,311,'Ramkaran Pakari','845416',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102037,311,'Rampur','845415',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102038,311,'Rampur Khauria','845423',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102039,311,'Rampurwa Bazar','845458',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102040,311,'Raxaul','845305',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102041,311,'Rulahi','845401',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102042,311,'Rupani','845420',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102043,311,'Rupdih','845401',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102044,311,'Ruphara','845418',1,0,'2022-03-03 13:19:00','2022-03-03 13:19:00'),(102045,311,'Sabaiya','845417',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102046,311,'Sagar Mathia','845416',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102047,311,'Sagardina','845418',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102048,311,'Sakarar','845440',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102049,311,'Salaha','845419',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102050,311,'Salempur','845406',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102051,311,'Sangrampur (East Champaran)','845434',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102052,311,'Sapaha','845435',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102053,311,'Sapahi','845437',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102054,311,'Sareya Khas','845411',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102055,311,'Sareya Khas','845419',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102056,311,'Sarotar','845423',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102057,311,'Sawangia','845412',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102058,311,'Sembhuapur','845423',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102059,311,'Semra','845415',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102060,311,'Semra (East Champaran)','845435',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102061,311,'Semraha','845436',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102062,311,'Semrahia','845302',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102063,311,'Shambhuchak','845413',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102064,311,'Shankar Sharaya','845437',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102065,311,'Shishwa','845401',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102066,311,'Shsiwania','845401',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102067,311,'Shyampur','845417',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102068,311,'Sihpur','845305',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102069,311,'Sikandarpur','845434',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102070,311,'Singasani','845433',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102071,311,'Siraha','845414',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102072,311,'Sirauna','845418',1,0,'2022-03-03 13:19:01','2022-03-03 13:19:01'),(102073,311,'Siripur','845456',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102074,311,'Sirni Bazar','845425',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102075,311,'Sirsa Colony','845401',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102076,311,'Sirsia Ganesh','845426',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102077,311,'Sirsia Khurd','845301',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102078,311,'Sirsiya Kala','845301',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102079,311,'Sishani','845428',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102080,311,'Siswa Bazar','845422',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102081,311,'Siswa Khar AR','845432',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102082,311,'Siswa Patna','845432',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102083,311,'Siswa Sounaha','845305',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102084,311,'Siswania','845301',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102085,311,'Sital Pur','845412',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102086,311,'Sobaiya','845417',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102087,311,'Son Barsa','845422',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102088,311,'Sonwal','845425',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102089,311,'Sraiya Gopal','845457',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102090,311,'Sripur Kawaiya','845303',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102091,311,'Sugaon','845456',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102092,311,'Sugauli','845456',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102093,311,'Sugaulia Bazar','845456',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102094,311,'Sukul Pakar','845456',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102095,311,'Sundar Patti','845414',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102096,311,'Sundarpur','845424',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102097,311,'Suraha','845401',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102098,311,'Tajpur Patkhaulia','845424',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102099,311,'Talwa Pokhar','845437',1,0,'2022-03-03 13:19:02','2022-03-03 13:19:02'),(102100,311,'Telhara Kala','845304',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102101,311,'Tetaria Factory','845436',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102102,311,'Tikaha Bhawanipur','845434',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102103,311,'Tikaita','845437',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102104,311,'Tikulia','845302',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102105,311,'Tikulia','845416',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102106,311,'Tinkoni','845302',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102107,311,'Tola Mauje','845433',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102108,311,'Turkaulia','845437',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102109,312,'Adai','824207',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102110,312,'Adarchak','824221',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102111,312,'Ahiyapur','824207',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102112,312,'Amarut','824220',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102113,312,'Amas','824219',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102114,312,'Angara','824116',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102115,312,'Anjan','824217',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102116,312,'Azamgarh','824217',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102117,312,'B . Chaugain','824217',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102118,312,'Babahandeo','824220',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102119,312,'Bahoura','824220',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102120,312,'Balia','824205',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102121,312,'Bankey Bajar','824217',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102122,312,'Bara','824210',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102123,312,'Barachatti','824201',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102124,312,'Barhussainganj','824211',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102125,312,'Bedauli','824210',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102126,312,'Betibigha','824211',1,0,'2022-03-03 13:19:03','2022-03-03 13:19:03'),(102127,312,'Bhadeya','824220',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102128,312,'Bhaliachatti','824201',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102129,312,'Bham','824116',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102130,312,'Bharaundha','824205',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102131,312,'Bhav Chiraiya','824211',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102132,312,'Binda','824201',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102133,312,'Bmajhiawan','824207',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102134,312,'Bodhi Bigha','824221',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102135,312,'Bumuar','824201',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102136,312,'Chansi','824205',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102137,312,'Chichwara','824207',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102138,312,'Chilim','824211',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102139,312,'Chitabkhurd','824211',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102140,312,'Dangara','824201',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102141,312,'Dariaura','824211',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102142,312,'Deoria','824201',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102143,312,'Dhamna','824201',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102144,312,'Dobhi','824220',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102145,312,'Dorma','824116',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102146,312,'Duba','824205',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102147,312,'Dumaria','824221',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102148,312,'Eguna','824207',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102149,312,'Gangi','824220',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102150,312,'Ghoraghat','824220',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102151,312,'Goharpur','824207',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102152,312,'Gola Bajar Sherghati','824211',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102153,312,'Gopalkera','824201',1,0,'2022-03-03 13:19:04','2022-03-03 13:19:04'),(102154,312,'Gotibandh','824221',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102155,312,'Gurua','824205',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102156,312,'Hardwan','824220',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102157,312,'Imamganj','824206',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102158,312,'Ismailpur','824205',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102159,312,'Ismailpur','824211',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102160,312,'Jaigir','824201',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102161,312,'Jamuara Kala','824217',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102162,312,'Kabar','824207',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102163,312,'Kachauri','824211',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102164,312,'Kaithisadpur','824207',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102165,312,'Kartahi','824211',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102166,312,'Kathautia','824211',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102167,312,'Kathoutia','824116',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102168,312,'Kewala Kala','824221',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102169,312,'Khajpur','824207',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102170,312,'Konch (Gaya)','824207',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102171,312,'Kothi','824210',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102172,312,'Kurmawan','824220',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102173,312,'Lahuthua','824201',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102174,312,'Maigra','824206',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102175,312,'Malahari','824206',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102176,312,'Mohabatpur','824211',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102177,312,'Mokh','824207',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102178,312,'Murera','824207',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102179,312,'Nagean Garh','824219',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102180,312,'Nagwan Pathra','824210',1,0,'2022-03-03 13:19:05','2022-03-03 13:19:05'),(102181,312,'Nainsagar','824220',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102182,312,'Pakari','824205',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102183,312,'Pakri Guria','824206',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102184,312,'Panania','824217',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102185,312,'Parsawa','824217',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102186,312,'Parvhara','824211',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102187,312,'Patluka','824201',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102188,312,'Phulwaria','824206',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102189,312,'Phulwaria Baheri','824219',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102190,312,'Pipra','824221',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102191,312,'Pirasin','824220',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102192,312,'Pirwan','824219',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102193,312,'Raniganj (Gaya)','824210',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102194,312,'Rondawan','824201',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102195,312,'Roshanganj','824217',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102196,312,'Sagditha','824217',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102197,312,'Sahuberma','824205',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102198,312,'Salaiya','824210',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102199,312,'Saonkala','824211',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102200,312,'Sharmakhas','824201',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102201,312,'Sherghati','824211',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102202,312,'Shyamnagar Nima','824211',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102203,312,'Sinduari','824207',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102204,312,'Srirampur','824211',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102205,312,'Tankupa','824207',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102206,312,'Tarari','824207',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102207,312,'Tarari','824113',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102208,312,'Tilaiya','824217',1,0,'2022-03-03 13:19:06','2022-03-03 13:19:06'),(102209,312,'Utrain','824207',1,0,'2022-03-03 13:19:07','2022-03-03 13:19:07'),(102210,312,'A.P.Colony (Gaya)','823001',1,0,'2022-03-03 13:19:07','2022-03-03 13:19:07'),(102211,312,'Agni','804403',1,0,'2022-03-03 13:19:07','2022-03-03 13:19:07'),(102212,312,'Aima Chouki','824233',1,0,'2022-03-03 13:19:07','2022-03-03 13:19:07'),(102213,312,'Aira','804421',1,0,'2022-03-03 13:19:07','2022-03-03 13:19:07'),(102214,312,'Akamba','824232',1,0,'2022-03-03 13:19:07','2022-03-03 13:19:07'),(102215,312,'Alipur','823003',1,0,'2022-03-03 13:19:07','2022-03-03 13:19:07'),(102216,312,'Ambatari','824232',1,0,'2022-03-03 13:19:07','2022-03-03 13:19:07'),(102217,312,'Amwan','824231',1,0,'2022-03-03 13:19:07','2022-03-03 13:19:07'),(102218,312,'Anjanwan','824232',1,0,'2022-03-03 13:19:07','2022-03-03 13:19:07'),(102219,312,'Apgila','804423',1,0,'2022-03-03 13:19:07','2022-03-03 13:19:07'),(102220,312,'Arkdhibariya','824236',1,0,'2022-03-03 13:19:07','2022-03-03 13:19:07'),(102221,312,'Asc Centre(N) Gaya','823005',1,0,'2022-03-03 13:19:07','2022-03-03 13:19:07'),(102222,312,'Atri','823311',1,0,'2022-03-03 13:19:07','2022-03-03 13:19:07'),(102223,312,'Ayer','823311',1,0,'2022-03-03 13:19:07','2022-03-03 13:19:07'),(102224,312,'Ayer','805135',1,0,'2022-03-03 13:19:07','2022-03-03 13:19:07'),(102225,312,'Bagadaha','823004',1,0,'2022-03-03 13:19:07','2022-03-03 13:19:07'),(102226,312,'Bahsa Pipra','824232',1,0,'2022-03-03 13:19:07','2022-03-03 13:19:07'),(102227,312,'Baidrabad','804402',1,0,'2022-03-03 13:19:07','2022-03-03 13:19:07'),(102228,312,'Baiju Bigha','824237',1,0,'2022-03-03 13:19:07','2022-03-03 13:19:07'),(102229,312,'Bairagi','823002',1,0,'2022-03-03 13:19:07','2022-03-03 13:19:07'),(102230,312,'Bairka','823311',1,0,'2022-03-03 13:19:07','2022-03-03 13:19:07'),(102231,312,'Bandimaniyara','823311',1,0,'2022-03-03 13:19:07','2022-03-03 13:19:07'),(102232,312,'Bankraur','824231',1,0,'2022-03-03 13:19:07','2022-03-03 13:19:07'),(102233,312,'Bara','824236',1,0,'2022-03-03 13:19:07','2022-03-03 13:19:07'),(102234,312,'Bara','804404',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102235,312,'Bara','804421',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102236,312,'Baragandhar','823003',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102237,312,'Baraini','824233',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102238,312,'Bargaon','824235',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102239,312,'Barheta','804423',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102240,312,'Barman','824118',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102241,312,'Barnathu','804419',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102242,312,'Bashadi','824231',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102243,312,'Bathani','823311',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102244,312,'Belaganj','804403',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102245,312,'Belhari','804403',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102246,312,'Benadoul','824233',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102247,312,'Bhadeji','823003',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102248,312,'Bhaismara Maksudpur','824236',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102249,312,'Bhalua','824231',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102250,312,'Bhalua','804404',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102251,312,'Bhare','824232',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102252,312,'Bhimdaspur','804403',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102253,312,'Bhoremirganj','823003',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102254,312,'Bhori','824236',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102255,312,'Bihta','824233',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102256,312,'Bijubigha','823003',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102257,312,'Birnoi','823311',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102258,312,'Bishunpura','824237',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102259,312,'Bithosarif','823003',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102260,312,'Bithra','804421',1,0,'2022-03-03 13:19:08','2022-03-03 13:19:08'),(102261,312,'Bodhgaya','824231',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102262,312,'Bohiya','824235',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102263,312,'Braila','824232',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102264,312,'Budhoul','824118',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102265,312,'Buniyad Ganj','823003',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102266,312,'Butgere','823003',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102267,312,'Chakand R.S','804404',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102268,312,'Chakand','804404',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102269,312,'Chand Chourah','823001',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102270,312,'Chandouti Bhagawanpur','804403',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102271,312,'Chandouti','823001',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102272,312,'Charaili','824236',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102273,312,'Cherki','824237',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102274,312,'Chhatiyana','804403',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102275,312,'Chhatubagh','823003',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102276,312,'Chiraili','824233',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102277,312,'Chiriyawan','823311',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102278,312,'Choukiya','824232',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102279,312,'Chowk','823001',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102280,312,'Churi','823002',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102281,312,'Civil Aerodram','823004',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102282,312,'Civil Lines (Gaya)','823001',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102283,312,'Daboor','824118',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102284,312,'Dadhma','804403',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102285,312,'Dehuri','824233',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102286,312,'Delha','823002',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102287,312,'Dema Fatehpur','824233',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102288,312,'Deo Nagar Uchirawa','824237',1,0,'2022-03-03 13:19:09','2022-03-03 13:19:09'),(102289,312,'Deokali','824118',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102290,312,'Dewan','824231',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102291,312,'Dhansingara','824233',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102292,312,'Dharamashala','824236',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102293,312,'Dhibar','824232',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102294,312,'Dhibri','824235',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102295,312,'Dighi','824118',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102296,312,'Dighwara','824236',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102297,312,'Diha','824118',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102298,312,'Dumarichatti','824232',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102299,312,'Durga Asthan','823003',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102300,312,'Dushadh Bigha','824118',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102301,312,'Etwan','824231',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102302,312,'Fatehpur Nepa','824236',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102303,312,'Fatehpur (Gaya)','824232',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102304,312,'Gajanpur','824237',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102305,312,'Gaya D.B','823001',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102306,312,'Gaya H.O','823001',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102307,312,'Gaya Jail','823001',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102308,312,'Gaya R.S','823002',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102309,312,'Gewal Bigha','823001',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102310,312,'Ghatera','824118',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102311,312,'Guraru Mills','824118',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102312,312,'Guru R.S.','824232',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102313,312,'Hatiyar','824231',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102314,312,'Hemara','824233',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102315,312,'Hematpur','824232',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102316,312,'Ibrahimpur','804423',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102317,312,'Ilra','824237',1,0,'2022-03-03 13:19:10','2022-03-03 13:19:10'),(102318,312,'Injore','804428',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102319,312,'Irki','804404',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102320,312,'Itwa','824232',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102321,312,'Jaipur','804428',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102322,312,'Jalalpur','824236',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102323,312,'Jalpura','804401',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102324,312,'Jamari','823004',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102325,312,'Jamuara','824236',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102326,312,'Jamuhari','804428',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102327,312,'Jani Bigha','824232',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102328,312,'Jaru','824233',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102329,312,'Jarubanwariya','824233',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102330,312,'Jethian','823311',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102331,312,'Jethian','805236',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102332,312,'K.Bhupat','804430',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102333,312,'Kachnama','804403',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102334,312,'Kadhariya','824232',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102335,312,'Kamalpur','824235',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102336,312,'Kamta','804428',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102337,312,'Kanousi','824118',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102338,312,'Kanti','824232',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102339,312,'Kapasiya','824209',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102340,312,'Karhari','804423',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102341,312,'Karimganj','823001',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102342,312,'Kariyarpur','824232',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102343,312,'Karpi','804419',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102344,312,'Katra','824232',1,0,'2022-03-03 13:19:11','2022-03-03 13:19:11'),(102345,312,'Kendui','824231',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102346,312,'Ker','824235',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102347,312,'Kerki','824118',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102348,312,'Kespa','824235',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102349,312,'Kesru Dharampur','823002',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102350,312,'Khabhaini','804402',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102351,312,'Khajuri','804419',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102352,312,'Khanetu','824209',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102353,312,'Khanjahapur','823003',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102354,312,'Khantangi','824235',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102355,312,'Kharkhura','823002',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102356,312,'Khizersarai','824233',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102357,312,'Khukri','823311',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102358,312,'Kochhasa','804426',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102359,312,'Koel Bhupat','804428',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102360,312,'Koiri Bigha','804403',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102361,312,'Konchi','824118',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102362,312,'Korap','824118',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102363,312,'Kormathu','824118',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102364,312,'Koshila','824231',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102365,312,'Kujapi','823002',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102366,312,'Kunar','823311',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102367,312,'Kurmawan','824237',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102368,312,'Kurmawan','824209',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102369,312,'Kurtha','804421',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102370,312,'Lakhaipur','824232',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102371,312,'Lari','804421',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102372,312,'Law','824236',1,0,'2022-03-03 13:19:12','2022-03-03 13:19:12'),(102373,312,'Laxman Bigha','824209',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102374,312,'Laxmipur','804404',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102375,312,'Lodhway','824232',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102376,312,'Lodipur','824209',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102377,312,'Lodipur','823003',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102378,312,'Madhopur','824236',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102379,312,'Magadh University','824234',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102380,312,'Mahamana','824236',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102381,312,'Mahimapur','824235',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102382,312,'Main','804435',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102383,312,'Majhiyawan','804421',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102384,312,'Makhdumpur','824232',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102385,312,'Makhdumpur Harhi','824235',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102386,312,'Maksudpur','823003',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102387,312,'Malheya','824236',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102388,312,'Mali','804419',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102389,312,'Manikpur','804421',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102390,312,'Manjhiyawan','824118',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102391,312,'Manjhouli','824232',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102392,312,'Manpur','823003',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102393,312,'Maranchi','824209',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102394,312,'Masadpur','804428',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102395,312,'Mathurapur','824118',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102396,312,'Mednipur Brahiya','804421',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102397,312,'Meera Bigha','804404',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102398,312,'Mocharim','824231',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102399,312,'Mohanpur','824232',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102400,312,'Moratal','824231',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102401,312,'Mow','824235',1,0,'2022-03-03 13:19:13','2022-03-03 13:19:13'),(102402,312,'Murari','804419',1,0,'2022-03-03 13:19:14','2022-03-03 13:19:14'),(102403,312,'Musaila','824232',1,0,'2022-03-03 13:19:14','2022-03-03 13:19:14'),(102404,312,'Musepur','824233',1,0,'2022-03-03 13:19:14','2022-03-03 13:19:14'),(102405,312,'Musi','824236',1,0,'2022-03-03 13:19:14','2022-03-03 13:19:14'),(102406,312,'Nadara','824233',1,0,'2022-03-03 13:19:14','2022-03-03 13:19:14'),(102407,312,'Nagla Kinger','804423',1,0,'2022-03-03 13:19:14','2022-03-03 13:19:14'),(102408,312,'Naili','824233',1,0,'2022-03-03 13:19:14','2022-03-03 13:19:14'),(102409,312,'Narariyawan','823003',1,0,'2022-03-03 13:19:14','2022-03-03 13:19:14'),(102410,312,'Narga','804419',1,0,'2022-03-03 13:19:14','2022-03-03 13:19:14'),(102411,312,'Narhi','804421',1,0,'2022-03-03 13:19:14','2022-03-03 13:19:14'),(102412,312,'Naudiha','824233',1,0,'2022-03-03 13:19:14','2022-03-03 13:19:14'),(102413,312,'Naudiha Jhurang','824232',1,0,'2022-03-03 13:19:14','2022-03-03 13:19:14'),(102414,312,'Nauranga','823003',1,0,'2022-03-03 13:19:14','2022-03-03 13:19:14'),(102415,312,'Neori','804403',1,0,'2022-03-03 13:19:14','2022-03-03 13:19:14'),(102416,312,'New Godown','823001',1,0,'2022-03-03 13:19:14','2022-03-03 13:19:14'),(102417,312,'Nighwan','804421',1,0,'2022-03-03 13:19:14','2022-03-03 13:19:14'),(102418,312,'Nimsar','804435',1,0,'2022-03-03 13:19:14','2022-03-03 13:19:14'),(102419,312,'Niranjanpur','804428',1,0,'2022-03-03 13:19:14','2022-03-03 13:19:14'),(102420,312,'Noudiha','823311',1,0,'2022-03-03 13:19:14','2022-03-03 13:19:14'),(102421,312,'Paharabali','824118',1,0,'2022-03-03 13:19:14','2022-03-03 13:19:14'),(102422,312,'Pakharpur','804401',1,0,'2022-03-03 13:19:14','2022-03-03 13:19:14'),(102423,312,'Panari','824233',1,0,'2022-03-03 13:19:14','2022-03-03 13:19:14'),(102424,312,'Panchanpur','824236',1,0,'2022-03-03 13:19:14','2022-03-03 13:19:14'),(102425,312,'Pandabigha','804435',1,0,'2022-03-03 13:19:14','2022-03-03 13:19:14'),(102426,312,'Pandey Parasawan','823004',1,0,'2022-03-03 13:19:14','2022-03-03 13:19:14'),(102427,312,'Paraiya','824209',1,0,'2022-03-03 13:19:14','2022-03-03 13:19:14'),(102428,312,'Parariya','824231',1,0,'2022-03-03 13:19:15','2022-03-03 13:19:15'),(102429,312,'Parasi','804428',1,0,'2022-03-03 13:19:15','2022-03-03 13:19:15'),(102430,312,'Patharkatti','823311',1,0,'2022-03-03 13:19:15','2022-03-03 13:19:15'),(102431,312,'Phurhuriya','824237',1,0,'2022-03-03 13:19:15','2022-03-03 13:19:15'),(102432,312,'Pinjarawan','804423',1,0,'2022-03-03 13:19:15','2022-03-03 13:19:15'),(102433,312,'Piyar','823311',1,0,'2022-03-03 13:19:15','2022-03-03 13:19:15'),(102434,312,'Pondil','804421',1,0,'2022-03-03 13:19:15','2022-03-03 13:19:15'),(102435,312,'Powa','824232',1,0,'2022-03-03 13:19:15','2022-03-03 13:19:15'),(102436,312,'Puna Kala','824209',1,0,'2022-03-03 13:19:15','2022-03-03 13:19:15'),(102437,312,'Punoul','824237',1,0,'2022-03-03 13:19:15','2022-03-03 13:19:15'),(102438,312,'Pura','824236',1,0,'2022-03-03 13:19:15','2022-03-03 13:19:15'),(102439,312,'Puran','804419',1,0,'2022-03-03 13:19:15','2022-03-03 13:19:15'),(102440,312,'Purani Godown','823001',1,0,'2022-03-03 13:19:15','2022-03-03 13:19:15'),(102441,312,'Railly','804403',1,0,'2022-03-03 13:19:15','2022-03-03 13:19:15'),(102442,312,'Rajan Ithari','824237',1,0,'2022-03-03 13:19:15','2022-03-03 13:19:15'),(102443,312,'Rajepur','804421',1,0,'2022-03-03 13:19:15','2022-03-03 13:19:15'),(102444,312,'Rampur','804403',1,0,'2022-03-03 13:19:15','2022-03-03 13:19:15'),(102445,312,'Rampur Baina','804402',1,0,'2022-03-03 13:19:15','2022-03-03 13:19:15'),(102446,312,'Rampur Chouram','804402',1,0,'2022-03-03 13:19:15','2022-03-03 13:19:15'),(102447,312,'Raniganj Nishurpur','824236',1,0,'2022-03-03 13:19:15','2022-03-03 13:19:15'),(102448,312,'Rasalpur','823003',1,0,'2022-03-03 13:19:15','2022-03-03 13:19:15'),(102449,312,'Rauniya','824233',1,0,'2022-03-03 13:19:15','2022-03-03 13:19:15'),(102450,312,'Rewai','824235',1,0,'2022-03-03 13:19:15','2022-03-03 13:19:15'),(102451,312,'Rouna','804404',1,0,'2022-03-03 13:19:15','2022-03-03 13:19:15'),(102452,312,'S.Moulanagar','823311',1,0,'2022-03-03 13:19:15','2022-03-03 13:19:15'),(102453,312,'Sadopur','804435',1,0,'2022-03-03 13:19:15','2022-03-03 13:19:15'),(102454,312,'Sadopur','804424',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102455,312,'Sagahi','824237',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102456,312,'Saha Telpa','804419',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102457,312,'Sahdeokhap','824234',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102458,312,'Sakarichowki','804401',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102459,312,'Sakri Khurd','804428',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102460,312,'Salempur','824235',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102461,312,'Salepur Fatehpur','804404',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102462,312,'Samaspur','804403',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102463,312,'Sanda','824235',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102464,312,'Sapneri','824233',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102465,312,'Sarbahda','824235',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102466,312,'Saren','823311',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102467,312,'Sarvahada','823311',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102468,312,'Sarwan','804402',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102469,312,'Sarwarpur','804428',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102470,312,'Seikhpura','804428',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102471,312,'Silounja','804403',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102472,312,'Simuara','824236',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102473,312,'Sirh','824233',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102474,312,'Sohaipur','823003',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102475,312,'Solra','824209',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102476,312,'Sonbhadra','804419',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102477,312,'Sondhi','823003',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102478,312,'Sripur','824233',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102479,312,'T. Jalalpur','824235',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102480,312,'Tankupa','824232',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102481,312,'Tekari','824236',1,0,'2022-03-03 13:19:16','2022-03-03 13:19:16'),(102482,312,'Telari','823311',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102483,312,'Terri','804428',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102484,312,'Tetar','823311',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102485,312,'Teusa Bahu Bigha','823311',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102486,312,'Tineri','824118',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102487,312,'Turi','804435',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102488,312,'Tuturakhi','824235',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102489,312,'Umta','804403',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102490,312,'Ur Bishunpur','824235',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102491,312,'Usari','804428',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102492,312,'Utli Bara','824232',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102493,312,'Walidad','804402',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102494,312,'Zindapur','824234',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102495,312,'Amethi','805131',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102496,312,'Arawan','805131',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102497,312,'B Makdumpur','805128',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102498,312,'Baijdah','805128',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102499,312,'Bisunpur','805131',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102500,312,'Dariyapur','805129',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102501,312,'Dharampur','805128',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102502,312,'Ghariya','805131',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102503,312,'Ghogha','805131',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102504,312,'Kajoor','805131',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102505,312,'Karisowa','805131',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102506,312,'Kenar','805128',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102507,312,'Kharaua','805131',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102508,312,'Kharghara','805131',1,0,'2022-03-03 13:19:17','2022-03-03 13:19:17'),(102509,312,'Khirwan','805131',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102510,312,'Kurkihar','805131',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102511,312,'M H Chack','805128',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102512,312,'Mahugain','805128',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102513,312,'Manjhauli','805131',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102514,312,'Panley','805131',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102515,312,'Rajwara','805131',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102516,312,'Reula','805109',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102517,312,'S Nawada','805131',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102518,312,'Sahiya','805131',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102519,312,'Seotar','805109',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102520,312,'Singhwara','805131',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102521,312,'Tarwan','805128',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102522,312,'Wazirganj (Gaya)','805131',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102523,313,'Achhaibar Pipra','841405',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102524,313,'Aghaila','841436',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102525,313,'Ahiyapur','841426',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102526,313,'Amarpur','841423',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102527,313,'Amwa Nakchhed','841428',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102528,313,'B.A. Pakwalia','841438',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102529,313,'B.A.Sonbarsa','841405',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102530,313,'B.D.Mahuwan','841508',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102531,313,'B.R. Bhan','841436',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102532,313,'B.Rampur','841405',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102533,313,'Babubishunpur','841428',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102534,313,'Baghibazar','841441',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102535,313,'Baikunthpur','841409',1,0,'2022-03-03 13:19:18','2022-03-03 13:19:18'),(102536,313,'Bairiya','841508',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102537,313,'Baleshra','841438',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102538,313,'Balthra','841503',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102539,313,'Balwansagar','841501',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102540,313,'Bankata Jagirdari','841426',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102541,313,'Baraiptti','841428',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102542,313,'Barauli (Gopalganj)','841405',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102543,313,'Barheyan','841436',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102544,313,'Barhima','841423',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102545,313,'Barkagaon','841436',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102546,313,'Basdila','841428',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102547,313,'Batardey','841405',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102548,313,'Bathubazar','841425',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102549,313,'Belhi Khas','841437',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102550,313,'Belsand','841413',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102551,313,'Bhagipatti Jhul','841437',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102552,313,'Bhagwatparsa','841425',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102553,313,'Bhaisahi','841427',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102554,313,'Bharpurwa','841508',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102555,313,'Bhathwa','841441',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102556,313,'Bhitbherwa','841428',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102557,313,'Bhore','841426',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102558,313,'Bijaipur (Gopalganj)','841508',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102559,313,'Bindwalia','841501',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102560,313,'Bishambharpur','841501',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102561,313,'Bishunpura','841407',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102562,313,'Bodhachhapar','841503',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102563,313,'Chakarwakhas','841426',1,0,'2022-03-03 13:19:19','2022-03-03 13:19:19'),(102564,313,'Chhitauna','841425',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102565,313,'Chhitauna','841426',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102566,313,'D.Narendra','841426',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102567,313,'Dabchhu','841420',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102568,313,'Dahibhata','841428',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102569,313,'Dangsi','841407',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102570,313,'Devapur','841405',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102571,313,'Dharamparsa','841427',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102572,313,'Dharhara','841437',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102573,313,'Dhatingna','841440',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102574,313,'Dhebwa','841503',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102575,313,'Dighwdubauli','841409',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102576,313,'Dumaria','841423',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102577,313,'Dumaria Dhamapakar','841428',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102578,313,'Durgmatihania','841501',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102579,313,'Ekderwa','841428',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102580,313,'Faizullahpur','841420',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102581,313,'G.S. Manjha','841436',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102582,313,'Gamharia','841420',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102583,313,'Garhmanjha','841427',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102584,313,'Gaura','841437',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102585,313,'Gausia','841427',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102586,313,'Gopalganj College','841428',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102587,313,'Gopalganj H.O','841428',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102588,313,'Gopalpur','841420',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102589,313,'Gopalpur','841503',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102590,313,'Hakam','841407',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102591,313,'Harpur Tengrahi','841423',1,0,'2022-03-03 13:19:20','2022-03-03 13:19:20'),(102592,313,'Harpurjan','841420',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102593,313,'Hassanpur Mathiya','841405',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102594,313,'Hasua','841436',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102595,313,'Hathwa','841436',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102596,313,'Hatimpur','841413',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102597,313,'Hussepur','841426',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102598,313,'J.Jagarnath','841438',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102599,313,'Jagarnath','841438',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102600,313,'Jagdishpur','841508',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102601,313,'Jagtauli','841426',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102602,313,'Jamobazar','841413',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102603,313,'Jamsar','841436',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102604,313,'Jasauli','841437',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102605,313,'Jhanjhawa Mohamadpur','841423',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102606,313,'Jhirwa','841440',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102607,313,'Jignadubey','841426',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102608,313,'Jignamath','841438',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102609,313,'Jogapur Kothi','841413',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102610,313,'K.K. Kararia','841438',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102611,313,'K.Srirampur','841427',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102612,313,'Kahla','841405',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102613,313,'Kailgarh','841438',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102614,313,'Kalyanpur','841425',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102615,313,'Kamalpur','841405',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102616,313,'Kararia','841428',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102617,313,'Karwatahi Bazar','841501',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102618,313,'Kashi Tengrahi','841407',1,0,'2022-03-03 13:19:21','2022-03-03 13:19:21'),(102619,313,'Katalpur','841420',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102620,313,'Kateya','841437',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102621,313,'Khajuhatti','841407',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102622,313,'Khajuri','841405',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102623,313,'Khajuria','841505',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102624,313,'Khalgaon','841441',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102625,313,'Khawajapur','841428',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102626,313,'Koila Deva','841438',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102627,313,'Koini','841427',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102628,313,'Koiripatti','841503',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102629,313,'Kuchaikote','841501',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102630,313,'Kusaundhi','841436',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102631,313,'Lachhwar','841438',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102632,313,'Lakri Dargah','841438',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102633,313,'Lamichaur','841426',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102634,313,'Line Bazar','841438',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102635,313,'Lohijara','841405',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102636,313,'M. Madho','841438',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102637,313,'M.Biraicha','841405',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102638,313,'Machhagar','841436',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102639,313,'Madhopur','841413',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102640,313,'Maharani','841407',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102641,313,'Maheshpur','841508',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102642,313,'Mahuwa','841407',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102643,313,'Mahuwan','841437',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102644,313,'Manbodhparsauni','841440',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102645,313,'Manikpur','841428',1,0,'2022-03-03 13:19:22','2022-03-03 13:19:22'),(102646,313,'Maniyara','841505',1,0,'2022-03-03 13:19:23','2022-03-03 13:19:23'),(102647,313,'Manjhariya','841427',1,0,'2022-03-03 13:19:23','2022-03-03 13:19:23'),(102648,313,'Mateya Khas','841501',1,0,'2022-03-03 13:19:23','2022-03-03 13:19:23'),(102649,313,'Matiyari','841420',1,0,'2022-03-03 13:19:23','2022-03-03 13:19:23'),(102650,313,'Matiyari','841426',1,0,'2022-03-03 13:19:23','2022-03-03 13:19:23'),(102651,313,'Mirganj','841438',1,0,'2022-03-03 13:19:23','2022-03-03 13:19:23'),(102652,313,'Mirja Pur','841436',1,0,'2022-03-03 13:19:23','2022-03-03 13:19:23'),(102653,313,'Mishra Batrahan','841438',1,0,'2022-03-03 13:19:23','2022-03-03 13:19:23'),(102654,313,'Mohamadpur','841438',1,0,'2022-03-03 13:19:23','2022-03-03 13:19:23'),(102655,313,'Mohammadpur','841407',1,0,'2022-03-03 13:19:23','2022-03-03 13:19:23'),(102656,313,'Mungarha','841427',1,0,'2022-03-03 13:19:23','2022-03-03 13:19:23'),(102657,313,'Musahri Bazar','841426',1,0,'2022-03-03 13:19:23','2022-03-03 13:19:23'),(102658,313,'Nabiganj','841407',1,0,'2022-03-03 13:19:23','2022-03-03 13:19:23'),(102659,313,'Narahwan Sukla','841503',1,0,'2022-03-03 13:19:23','2022-03-03 13:19:23'),(102660,313,'Narkatia','841428',1,0,'2022-03-03 13:19:23','2022-03-03 13:19:23'),(102661,313,'Nawada','841405',1,0,'2022-03-03 13:19:23','2022-03-03 13:19:23'),(102662,313,'Nechwajalapur','841503',1,0,'2022-03-03 13:19:23','2022-03-03 13:19:23'),(102663,313,'Neori','841437',1,0,'2022-03-03 13:19:23','2022-03-03 13:19:23'),(102664,313,'Neori','841405',1,0,'2022-03-03 13:19:23','2022-03-03 13:19:23'),(102665,313,'Nimuiya','841427',1,0,'2022-03-03 13:19:23','2022-03-03 13:19:23'),(102666,313,'P.Bhagwanpur','841428',1,0,'2022-03-03 13:19:23','2022-03-03 13:19:23'),(102667,313,'Pachdeori','841437',1,0,'2022-03-03 13:19:23','2022-03-03 13:19:23'),(102668,313,'Pachlakhi','841436',1,0,'2022-03-03 13:19:23','2022-03-03 13:19:23'),(102669,313,'Paharpur','841420',1,0,'2022-03-03 13:19:23','2022-03-03 13:19:23'),(102670,313,'Paikauli Baddo','841438',1,0,'2022-03-03 13:19:23','2022-03-03 13:19:23'),(102671,313,'Pakri','841438',1,0,'2022-03-03 13:19:23','2022-03-03 13:19:23'),(102672,313,'Paltuhatta','841413',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102673,313,'Parsurampur','841427',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102674,313,'Parwan','841428',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102675,313,'Pasrama','841428',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102676,313,'Pathra','841427',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102677,313,'Peoli','841436',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102678,313,'Phulwaria','841425',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102679,313,'Purdiltola','841427',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102680,313,'R.P. Tengrahi','841428',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102681,313,'Rachhopali','841427',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102682,313,'Radhaganj','841438',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102683,313,'Rajapatti','841420',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102684,313,'Rajapur','841441',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102685,313,'Rajwahi','841428',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102686,313,'Ramchandrapur','841440',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102687,313,'Rampur Daud','841505',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102688,313,'Rasulpur','841438',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102689,313,'Ratanpura','841501',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102690,313,'Reotith','841407',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102691,313,'Repura','841436',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102692,313,'Rudalpur','841426',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102693,313,'Rudrapur','841437',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102694,313,'Rupanchhap','841405',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102695,313,'Sadauwan','841405',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102696,313,'Sahdi Giri','841508',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102697,313,'Sakhekhas','841438',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102698,313,'Salehpur','841501',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102699,313,'Salempur','841405',1,0,'2022-03-03 13:19:24','2022-03-03 13:19:24'),(102700,313,'Sanhaula','841503',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102701,313,'Sareya Narendra','841405',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102702,313,'Sasamusa','841505',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102703,313,'Sathi','841438',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102704,313,'Sawana','841438',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102705,313,'Sawraje','841438',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102706,313,'Semaria','841441',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102707,313,'Semra Bazar','841503',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102708,313,'Semrahi','841428',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102709,313,'Semraon','841436',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102710,313,'Sepaya','841501',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102711,313,'Sher','841407',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102712,313,'Shyampur','841407',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102713,313,'Sidhwalia','841423',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102714,313,'Sikatiya Sridhar Sahi','841405',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102715,313,'Sirisia','841413',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102716,313,'Sisai','841426',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102717,313,'Siswa','841503',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102718,313,'Siswania','841436',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102719,313,'Sohagpur','841436',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102720,313,'Sohnariya','841437',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102721,313,'Songharwa','841425',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102722,313,'Sorahiya','841423',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102723,313,'Sukulbrindawan','841440',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102724,313,'Sukulwa','841428',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102725,313,'Sultanpur Kala','841413',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102726,313,'Sundri','841438',1,0,'2022-03-03 13:19:25','2022-03-03 13:19:25'),(102727,313,'Talimapur','841407',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102728,313,'Telmewas','841423',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102729,313,'Thakrahan','841503',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102730,313,'Thawe','841440',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102731,313,'U.R. Bangra','841428',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102732,313,'Uchka Gaon','841501',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102733,313,'Uchkagaon','841438',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102734,313,'Usri Bazar','841407',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102735,313,'Usribazar','841409',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102736,313,'V.S. Mill','841428',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102737,313,'Yadavpur Dukhharan','841428',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102738,314,'Abgil Chaurama','811301',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102739,314,'Aghara So','811314',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102740,314,'Aliganj (Jamui)','811301',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102741,314,'Amari','811317',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102742,314,'Amrath','811313',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102743,314,'Anandpur','811312',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102744,314,'Arbaria','811312',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102745,314,'Arsar','811313',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102746,314,'B Bahadurpur','811315',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102747,314,'Baladih','811301',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102748,314,'Bamdah','811303',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102749,314,'Banpur','811305',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102750,314,'Barahat','811313',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102751,314,'Baribag','811317',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102752,314,'Basbitti-bo','811303',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102753,314,'Batia','811308',1,0,'2022-03-03 13:19:26','2022-03-03 13:19:26'),(102754,314,'Bhour','811317',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102755,314,'Bichkorwa','811303',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102756,314,'Bishanpur','811314',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102757,314,'Bisodah','811316',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102758,314,'Bukar','811313',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102759,314,'Chain','811308',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102760,314,'Chakai','811303',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102761,314,'Chanashly','811317',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102762,314,'Chandra Mandi','811303',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102763,314,'Chango Dih','811305',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102764,314,'Charkapathal','811314',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102765,314,'Chaura','811313',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102766,314,'Chhapar Dih','811308',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102767,314,'Chuwan','811305',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102768,314,'Dabil','811305',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102769,314,'Darha','811313',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102770,314,'Darkha','811301',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102771,314,'Daulatpur','811313',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102772,314,'Dhadhaur','811313',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102773,314,'Dhanama','811301',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102774,314,'Dhandh','811313',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102775,314,'Dhundo','811314',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102776,314,'Dighi','811312',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102777,314,'Dinnagar','811301',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102778,314,'Domamarhar','811312',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102779,314,'Dulampur','811303',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102780,314,'Dumari','811314',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102781,314,'Dumarkola','811317',1,0,'2022-03-03 13:19:27','2022-03-03 13:19:27'),(102782,314,'Dundu','811317',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102783,314,'Fatehpur','811308',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102784,314,'Gadibishanpur','811317',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102785,314,'Gaganpur','811303',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102786,314,'Gagra','811305',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102787,314,'Garhi','811317',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102788,314,'Garsanda','811305',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102789,314,'Gaura','811312',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102790,314,'Ghughuldih','811305',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102791,314,'Gidhaur','811305',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102792,314,'Gopalpur','811317',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102793,314,'Hilsa','811301',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102794,314,'Islamnagar','811301',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102795,314,'Jamui Court','811307',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102796,314,'Jamui H.O','811307',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102797,314,'Jhajha Bazar','811308',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102798,314,'Jhajha','811308',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102799,314,'Jit Jhingoibo','811317',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102800,314,'Kaiyar','811301',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102801,314,'Kakan','811313',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102802,314,'Kala','811312',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102803,314,'Karhara','811308',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102804,314,'Karma','811315',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102805,314,'Karma Borba','811308',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102806,314,'Katauna','811313',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102807,314,'Keshopur','811305',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102808,314,'Kewal','811316',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102809,314,'Kewal Fariyatta','811305',1,0,'2022-03-03 13:19:28','2022-03-03 13:19:28'),(102810,314,'Khadigram','811313',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102811,314,'Khaira (Jamui)','811317',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102812,314,'Kharaich','811317',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102813,314,'Khardih','811315',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102814,314,'Kharhawa','811305',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102815,314,'Kharma','811316',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102816,314,'Kharsari','811313',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102817,314,'Khelari','811317',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102818,314,'Khuranda','811316',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102819,314,'Kiya Jori','811303',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102820,314,'Kolhua','811313',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102821,314,'Koluadih','811303',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102822,314,'Konan','811313',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102823,314,'Korane','811303',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102824,314,'Kumar','811315',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102825,314,'Lachhuar','811315',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102826,314,'Laxmipur (Jamui)','811312',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102827,314,'Lohra','811313',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102828,314,'Madhopur','811303',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102829,314,'Mahadeo Simaria','811313',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102830,314,'Maheshwari','811314',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102831,314,'Mallehpur','811313',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102832,314,'Mango Bandar','811305',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102833,314,'Maniyadda','811313',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102834,314,'Manjhway','811311',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102835,314,'Manjosh','811315',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102836,314,'Markama','811301',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102837,314,'Mathurapur','811315',1,0,'2022-03-03 13:19:29','2022-03-03 13:19:29'),(102838,314,'Matia','811312',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102839,314,'Maura','811305',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102840,314,'Mirzaganj','811301',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102841,314,'Mohanpur','811316',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102842,314,'Mundbaro','811317',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102843,314,'N. Silfari','811303',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102844,314,'Naiyadih','811314',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102845,314,'Narganjo','811308',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102846,314,'Nariyana','811317',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102847,314,'Nayagaon','811305',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102848,314,'Nimnawada','811317',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102849,314,'Noni','811301',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102850,314,'Numar','811313',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102851,314,'P. Matihana','811314',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102852,314,'Patambar','811315',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102853,314,'Patauwa','811303',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102854,314,'Pathak Chack','811313',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102855,314,'Pirhinda','811315',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102856,314,'Pradhanchak','811317',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102857,314,'Pursanda','811301',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102858,314,'Rabai','811315',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102859,314,'Rajala','811308',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102860,314,'Ratanpur','811305',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102861,314,'S Batpar','811303',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102862,314,'Sahiya','811308',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102863,314,'Sahora','811301',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102864,314,'Saraun','811303',1,0,'2022-03-03 13:19:30','2022-03-03 13:19:30'),(102865,314,'Sarsa Bichwe','811315',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102866,314,'Sawal Bigha','811315',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102867,314,'Sevai','811305',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102868,314,'Seway','811301',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102869,314,'Sijhauri','811315',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102870,314,'Sikandra (Jamui)','811315',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102871,314,'Simultala','811316',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102872,314,'Sohjana','811305',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102873,314,'Sono','811314',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102874,314,'Sonpai','811305',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102875,314,'Sugba Urown','811308',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102876,314,'Suggi','811305',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102877,314,'T. Barajor','811308',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102878,314,'T. Barmasia','811308',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102879,314,'T. Chhapa','811308',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102880,314,'Tabha','811308',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102881,314,'Tal Saharsa','811315',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102882,314,'Telia Dih','811312',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102883,314,'Teliya Dih','811305',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102884,314,'Telwa Bazar','811316',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102885,314,'Tihiya','811305',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102886,314,'Tola Urba','811303',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102887,315,'Aiara','804426',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102888,315,'Aiyara','804425',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102889,315,'Alahganj','804405',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102890,315,'Amain','804425',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102891,315,'Anandpur','804419',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102892,315,'Annua','804419',1,0,'2022-03-03 13:19:31','2022-03-03 13:19:31'),(102893,315,'Atiawan','804432',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102894,315,'Babhana','804417',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102895,315,'Baina Lakhaipur','804423',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102896,315,'Bajitpur','804426',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102897,315,'Bambhai','804428',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102898,315,'Bandeya','804422',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102899,315,'Bandhuganj','804432',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102900,315,'Banshi Bigha','804405',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102901,315,'Bauri Beldari','804407',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102902,315,'Belkhara','804428',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102903,315,'Berka','804422',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102904,315,'Bhadsara','804418',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102905,315,'Bhagawanpur','804407',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102906,315,'Bhaikh','804405',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102907,315,'Bhana Dehuri','804429',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102908,315,'Bharthu','804432',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102909,315,'Bharthua','804417',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102910,315,'Birra','804405',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102911,315,'Bishunganj','804405',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102912,315,'Charh','804427',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102913,315,'Charokharigarh','824232',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102914,315,'Chhariyari','804422',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102915,315,'Chhotki Akouna','804432',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102916,315,'Dakra','804422',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102917,315,'Daulatpur Arhit','804432',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102918,315,'Deora','804432',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102919,315,'Dhangawan','804417',1,0,'2022-03-03 13:19:32','2022-03-03 13:19:32'),(102920,315,'Dharampur','804417',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102921,315,'Dharaut','804405',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102922,315,'Dhawal Bigha','804407',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102923,315,'Dora','804419',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102924,315,'Gangapur','804407',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102925,315,'Gayani Bigha','804424',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102926,315,'Ghejan','804424',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102927,315,'Ghosi (Jehanabad)','804406',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102928,315,'Ginji','804406',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102929,315,'Golakpur Dehuri','804420',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102930,315,'Harinagarpali','804418',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102931,315,'Hathiawan','804407',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102932,315,'Hati','804420',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102933,315,'Hulashganj','804407',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102934,315,'Ikil','804425',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102935,315,'Jagdari','804432',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102936,315,'Jagpura','804424',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102937,315,'Jaitipur Kurwa','804432',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102938,315,'Jamanganj','804405',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102939,315,'Jamuk','804429',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102940,315,'Jehanabad H.O','804408',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102941,315,'Jehanabad Kutchary','804408',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102942,315,'Jehanabad R.S.','804417',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102943,315,'Julfipur Modanganj','804432',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102944,315,'Junathi','804429',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102945,315,'Junathi','804426',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102946,315,'Kachnawan','804422',1,0,'2022-03-03 13:19:33','2022-03-03 13:19:33'),(102947,315,'Kako','804418',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102948,315,'Kalanour','804427',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102949,315,'Kalpa','804417',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102950,315,'Kazisarai','804420',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102951,315,'Keur','804407',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102952,315,'Koiri Bigha','804424',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102953,315,'Korauna','804417',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102954,315,'Korma','804432',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102955,315,'Kormathu','804424',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102956,315,'Kosdihra','804417',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102957,315,'Koshma','804429',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102958,315,'Kumbhawan','804417',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102959,315,'Kurre','804405',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102960,315,'Lakhawar ED','804434',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102961,315,'Main','804424',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102962,315,'Makarpur','804422',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102963,315,'Makhdumpur','804422',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102964,315,'Malathi','804427',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102965,315,'Malpa','824118',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102966,315,'Mandil','804417',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102967,315,'Manjhosh','804424',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102968,315,'Mohiudinpur','804420',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102969,315,'Muther','804417',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102970,315,'Nagma Erazi','804420',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102971,315,'Narma','804407',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102972,315,'Nauru','804417',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102973,315,'Nehalpur','804429',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102974,315,'Ner','804422',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102975,315,'Newari','804425',1,0,'2022-03-03 13:19:34','2022-03-03 13:19:34'),(102976,315,'Noawan','804429',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(102977,315,'Nonhi','804418',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(102978,315,'Paibigha','804424',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(102979,315,'Paigambarpur','804417',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(102980,315,'Pandooi','804417',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(102981,315,'Pandoul','804425',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(102982,315,'Pariyari','804426',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(102983,315,'Patiyawan','804424',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(102984,315,'Pinjaura','804417',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(102985,315,'Pinjore','804417',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(102986,315,'Ponda Bigha','804424',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(102987,315,'Puarainia','804426',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(102988,315,'Rampurchai','804428',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(102989,315,'Ratni Bazar','804421',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(102990,315,'S.P Imamganj','804426',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(102991,315,'Sagarpur','804422',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(102992,315,'Saho Bigha','804406',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(102993,315,'Saidabad','804417',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(102994,315,'Sakurabad','804425',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(102995,315,'Salarpur','804429',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(102996,315,'Saren','804427',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(102997,315,'Saristabad','804418',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(102998,315,'Sarta','804429',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(102999,315,'Sarthua','804427',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(103000,315,'Satamas','804407',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(103001,315,'Shadipur','804421',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(103002,315,'Sikandarpur','804425',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(103003,315,'Sisamba','804425',1,0,'2022-03-03 13:19:35','2022-03-03 13:19:35'),(103004,315,'Sohariya','804423',1,0,'2022-03-03 13:19:36','2022-03-03 13:19:36'),(103005,315,'Solhanda','804422',1,0,'2022-03-03 13:19:36','2022-03-03 13:19:36'),(103006,315,'Sonawa','804405',1,0,'2022-03-03 13:19:36','2022-03-03 13:19:36'),(103007,315,'Sugaon','804427',1,0,'2022-03-03 13:19:36','2022-03-03 13:19:36'),(103008,315,'Supi','804427',1,0,'2022-03-03 13:19:36','2022-03-03 13:19:36'),(103009,315,'Surangapur','804429',1,0,'2022-03-03 13:19:36','2022-03-03 13:19:36'),(103010,315,'Tajpur','804407',1,0,'2022-03-03 13:19:36','2022-03-03 13:19:36'),(103011,315,'Takiya Karpi','804407',1,0,'2022-03-03 13:19:36','2022-03-03 13:19:36'),(103012,315,'Tehta','804427',1,0,'2022-03-03 13:19:36','2022-03-03 13:19:36'),(103013,315,'Tej Bigha','804420',1,0,'2022-03-03 13:19:36','2022-03-03 13:19:36'),(103014,315,'Terra','804419',1,0,'2022-03-03 13:19:36','2022-03-03 13:19:36'),(103015,315,'Tilkai','804405',1,0,'2022-03-03 13:19:36','2022-03-03 13:19:36'),(103016,315,'Uber','804405',1,0,'2022-03-03 13:19:36','2022-03-03 13:19:36'),(103017,315,'Usas Deora','824235',1,0,'2022-03-03 13:19:36','2022-03-03 13:19:36'),(103018,315,'Utarsarthu','804418',1,0,'2022-03-03 13:19:36','2022-03-03 13:19:36'),(103019,315,'Utrawan','824235',1,0,'2022-03-03 13:19:36','2022-03-03 13:19:36'),(103020,315,'Waina','804418',1,0,'2022-03-03 13:19:36','2022-03-03 13:19:36'),(103021,316,'Adhaura','821102',1,0,'2022-03-03 13:19:36','2022-03-03 13:19:36'),(103022,316,'Akhini','802132',1,0,'2022-03-03 13:19:36','2022-03-03 13:19:36'),(103023,316,'Akhlaspur','821101',1,0,'2022-03-03 13:19:36','2022-03-03 13:19:36'),(103024,316,'Akhtiarpur','821108',1,0,'2022-03-03 13:19:36','2022-03-03 13:19:36'),(103025,316,'Akorhi','821109',1,0,'2022-03-03 13:19:36','2022-03-03 13:19:36'),(103026,316,'Amaon','821106',1,0,'2022-03-03 13:19:36','2022-03-03 13:19:36'),(103027,316,'Awarainya','821108',1,0,'2022-03-03 13:19:36','2022-03-03 13:19:36'),(103028,316,'B. Khas','821109',1,0,'2022-03-03 13:19:36','2022-03-03 13:19:36'),(103029,316,'Badauha','821106',1,0,'2022-03-03 13:19:36','2022-03-03 13:19:36'),(103030,316,'Badupur','821109',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103031,316,'Bagarhi','802132',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103032,316,'Bararhi','821103',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103033,316,'Baraura','821110',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103034,316,'Bare','821109',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103035,316,'Basahi','821108',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103036,316,'Belondi','821109',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103037,316,'Bhabua','821101',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103038,316,'Bhadoula','821108',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103039,316,'Bhagwanpur (Kaimur (Bhabua))','821102',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103040,316,'Bheria','821105',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103041,316,'Bhitti','821109',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103042,316,'Bhorari','821106',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103043,316,'Bisodihri','821108',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103044,316,'Biur','821103',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103045,316,'Chainpur (Kaimur (Bhabua))','821103',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103046,316,'Chakedihra','821102',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103047,316,'Chand','821106',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103048,316,'Chandesh','802132',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103049,316,'Chhata','821105',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103050,316,'Chhewari','821110',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103051,316,'Chhotka Amaon','821106',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103052,316,'Chhotki Kulhariya','821110',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103053,316,'Dadar','821109',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103054,316,'Dangri','821109',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103055,316,'Darauli','821101',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103056,316,'Darhwa','821109',1,0,'2022-03-03 13:19:37','2022-03-03 13:19:37'),(103057,316,'Darwan','821110',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103058,316,'Derwan','821108',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103059,316,'Dewhalia','821110',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103060,316,'Dhawpokhar','821108',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103061,316,'Dumaraith','821105',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103062,316,'Dumarkon','821102',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103063,316,'Durgawati','821105',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103064,316,'Fakhrabad','821108',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103065,316,'Gehwa','821106',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103066,316,'Goi','821106',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103067,316,'Harnathpur','821109',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103068,316,'Hatta (Kaimur (Bhabua))','821106',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103069,316,'Jaitpur Kalan','821102',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103070,316,'Jaldaha','821110',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103071,316,'Jamalpur  Paturi','821106',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103072,316,'Jamurna','821110',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103073,316,'K. Kalyanpur','821105',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103074,316,'Kabilashpur','821105',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103075,316,'Kaithi','821109',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103076,316,'Kajura','821110',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103077,316,'Karamnasa','821105',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103078,316,'Karari','821105',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103079,316,'Karji','821106',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103080,316,'Karmhari','802132',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103081,316,'Kaser','821102',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103082,316,'Kasthari','821105',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103083,316,'Kathej','821109',1,0,'2022-03-03 13:19:38','2022-03-03 13:19:38'),(103084,316,'Kathrain','821108',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103085,316,'Katra Kala','821109',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103086,316,'Kewarhi','821108',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103087,316,'Khaira','821101',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103088,316,'Khajura','821102',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103089,316,'Kharenda','821102',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103090,316,'Khnethi','821109',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103091,316,'Khurmabad','821108',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103092,316,'Kilani','821106',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103093,316,'Kolhua','821102',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103094,316,'Kuddi','821106',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103095,316,'Kudra Bazar','821108',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103096,316,'Kudra','821108',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103097,316,'Kurasan','821101',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103098,316,'Kuriari','821105',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103099,316,'Lohdan','821106',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103100,316,'Mahila','802132',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103101,316,'Mahuari','821101',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103102,316,'Mahuwat','821108',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103103,316,'Manihari','821105',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103104,316,'Masaurha','821105',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103105,316,'Mion','821101',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103106,316,'Mohan Darwan','821108',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103107,316,'Mohania','821109',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103108,316,'Mokari','821101',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103109,316,'Mudhi','821103',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103110,316,'Mujan','821109',1,0,'2022-03-03 13:19:39','2022-03-03 13:19:39'),(103111,316,'Muthani','821109',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103112,316,'Nasej','821108',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103113,316,'Nateya','821109',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103114,316,'Noan','802132',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103115,316,'Odar','821108',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103116,316,'Orrah','821101',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103117,316,'Pachilikhi','821105',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103118,316,'Padri','821108',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103119,316,'Pahariya','821101',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103120,316,'Panapur','821109',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103121,316,'Panjraon','802132',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103122,316,'Parbatpur','821106',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103123,316,'Pipra Sakarwar','821108',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103124,316,'Pipriya','821105',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103125,316,'Piyan','821108',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103126,316,'Ramgarh (Kaimur (Bhabua))','821110',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103127,316,'Ratwar','821109',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103128,316,'Rudrawar Kala','821101',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103129,316,'Ruppur','821109',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103130,316,'Sabar','821104',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103131,316,'Sahu Ka Mahua','821110',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103132,316,'Saitha','821101',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103133,316,'Salathua','821109',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103134,316,'Satowanti','802132',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103135,316,'Saukhara','821106',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103136,316,'Shahbajpur','821109',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103137,316,'Shiorampur','821106',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103138,316,'Sikandarpur','821103',1,0,'2022-03-03 13:19:40','2022-03-03 13:19:40'),(103139,316,'Sikthi','802213',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103140,316,'Sirhira','821106',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103141,316,'Sirsi','821106',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103142,316,'Sondhi','821109',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103143,316,'Sonhan','821101',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103144,316,'Sukul Pipra','821109',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103145,316,'Surware Ke Bararhi','802218',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103146,316,'Taraitha','802132',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103147,316,'Thakura','802132',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103148,316,'Torni Lahera','821108',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103149,316,'Turki','821108',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103150,316,'Ujari Sikathi','821101',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103151,316,'Umapur Saraiya','821102',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103152,316,'Upari','802132',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103153,317,'Ajhrail','854317',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103154,317,'Amdabad','854112',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103155,317,'Arihiana','855114',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103156,317,'Awadpur','855102',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103157,317,'Ayodhyaganj Bazar','854101',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103158,317,'Azamnagar','855113',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103159,317,'B.Balrampur','854317',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103160,317,'B.Deora','854113',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103161,317,'B.Simaria','854106',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103162,317,'Babhani','855105',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103163,317,'Baghwa','854317',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103164,317,'Baina','854116',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103165,317,'Bairia','854113',1,0,'2022-03-03 13:19:41','2022-03-03 13:19:41'),(103166,317,'Bakharganj','854113',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103167,317,'Balia Belon','855113',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103168,317,'Balthi Maheshpur','854101',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103169,317,'Baltor','855113',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103170,317,'Balupara','854317',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103171,317,'Bansgarha','854115',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103172,317,'Bareta','854114',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103173,317,'Barsoi','855102',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103174,317,'Barsoighat','854317',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103175,317,'Basantpur','854114',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103176,317,'Bastaul','854116',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103177,317,'Bathna','854317',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103178,317,'Belbari','855113',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103179,317,'Belwa','854107',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103180,317,'Bhaisdiara','854104',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103181,317,'Bhandartal','854104',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103182,317,'Bhangaha','854114',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103183,317,'Bharri','855105',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103184,317,'Bhatwara','854108',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103185,317,'Bighor','854317',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103186,317,'Bijaili','855114',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103187,317,'Binjee','854115',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103188,317,'Bishanpur','854104',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103189,317,'Bishanpurhariabhir','854115',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103190,317,'Bokia','854104',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103191,317,'Budhnagar','854107',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103192,317,'Chakmaka','854113',1,0,'2022-03-03 13:19:42','2022-03-03 13:19:42'),(103193,317,'Chandpur','855105',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103194,317,'Chandpur','854101',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103195,317,'Chapahari','854101',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103196,317,'Chhoghra','855102',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103197,317,'Chhohar','854114',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103198,317,'Chouki Hajipur','855105',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103199,317,'Daharia Molls','854103',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103200,317,'Dalan','854106',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103201,317,'Dandkhora','855114',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103202,317,'Dangal','854317',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103203,317,'Dasgram','855102',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103204,317,'Dhachna','854317',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103205,317,'Dhanetha','854108',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103206,317,'Dharhan','854116',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103207,317,'Dhena Bagchhata','854116',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103208,317,'Dhenuabishanpur','854104',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103209,317,'Dhumnagar','855113',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103210,317,'Dighri','854106',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103211,317,'Dilarpur','854113',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103212,317,'Dilli Diwanganj','854117',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103213,317,'Dumar','854104',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103214,317,'Dumaria','855114',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103215,317,'Durgaganj','855105',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103216,317,'Durgapur','854113',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103217,317,'Durgapur','854105',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103218,317,'Dwasi','855105',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103219,317,'Falka','854114',1,0,'2022-03-03 13:19:43','2022-03-03 13:19:43'),(103220,317,'Fatehpur','854335',1,0,'2022-03-03 13:19:44','2022-03-03 13:19:44'),(103221,317,'Gaualtoli','855102',1,0,'2022-03-03 13:19:44','2022-03-03 13:19:44'),(103222,317,'Gauripur','854116',1,0,'2022-03-03 13:19:44','2022-03-03 13:19:44'),(103223,317,'Gopalpur Diara','854113',1,0,'2022-03-03 13:19:44','2022-03-03 13:19:44'),(103224,317,'Goriar','854101',1,0,'2022-03-03 13:19:44','2022-03-03 13:19:44'),(103225,317,'Gunjan','854317',1,0,'2022-03-03 13:19:44','2022-03-03 13:19:44'),(103226,317,'Gurubazar','854104',1,0,'2022-03-03 13:19:44','2022-03-03 13:19:44'),(103227,317,'Hasimpur','854104',1,0,'2022-03-03 13:19:44','2022-03-03 13:19:44'),(103228,317,'Hat Balrampur','855102',1,0,'2022-03-03 13:19:44','2022-03-03 13:19:44'),(103229,317,'Hemkunj','854113',1,0,'2022-03-03 13:19:44','2022-03-03 13:19:44'),(103230,317,'Jagdishpur','854115',1,0,'2022-03-03 13:19:44','2022-03-03 13:19:44'),(103231,317,'Jalki','855102',1,0,'2022-03-03 13:19:44','2022-03-03 13:19:44'),(103232,317,'Jarlahi','854104',1,0,'2022-03-03 13:19:44','2022-03-03 13:19:44'),(103233,317,'Jhagruchak','854108',1,0,'2022-03-03 13:19:44','2022-03-03 13:19:44'),(103234,317,'Jhawa','855113',1,0,'2022-03-03 13:19:44','2022-03-03 13:19:44'),(103235,317,'Jot Ram Roy','854104',1,0,'2022-03-03 13:19:44','2022-03-03 13:19:44'),(103236,317,'K.N. Guru Mela','854104',1,0,'2022-03-03 13:19:44','2022-03-03 13:19:44'),(103237,317,'Kabar','854115',1,0,'2022-03-03 13:19:44','2022-03-03 13:19:44'),(103238,317,'Kadwa','855114',1,0,'2022-03-03 13:19:44','2022-03-03 13:19:44'),(103239,317,'Kant Nagar','854104',1,0,'2022-03-03 13:19:44','2022-03-03 13:19:44'),(103240,317,'Kantakosh','854113',1,0,'2022-03-03 13:19:44','2022-03-03 13:19:44'),(103241,317,'Karha Gola Road','854104',1,0,'2022-03-03 13:19:44','2022-03-03 13:19:44'),(103242,317,'Katihar Bara Bazar','854105',1,0,'2022-03-03 13:19:44','2022-03-03 13:19:44'),(103243,317,'Katihar Bmp Camp','854106',1,0,'2022-03-03 13:19:44','2022-03-03 13:19:44'),(103244,317,'Katihar Colony','854105',1,0,'2022-03-03 13:19:44','2022-03-03 13:19:44'),(103245,317,'Katihar Court','854109',1,0,'2022-03-03 13:19:44','2022-03-03 13:19:44'),(103246,317,'Katihar H.O','854105',1,0,'2022-03-03 13:19:45','2022-03-03 13:19:45'),(103247,317,'Katihar Mill','854107',1,0,'2022-03-03 13:19:45','2022-03-03 13:19:45'),(103248,317,'Katihar Rs','854105',1,0,'2022-03-03 13:19:45','2022-03-03 13:19:45'),(103249,317,'Kehunia','854116',1,0,'2022-03-03 13:19:45','2022-03-03 13:19:45'),(103250,317,'Khaira','854101',1,0,'2022-03-03 13:19:45','2022-03-03 13:19:45'),(103251,317,'Kharsouta','855113',1,0,'2022-03-03 13:19:45','2022-03-03 13:19:45'),(103252,317,'Kheria','854108',1,0,'2022-03-03 13:19:45','2022-03-03 13:19:45'),(103253,317,'Khirdirpur','855102',1,0,'2022-03-03 13:19:45','2022-03-03 13:19:45'),(103254,317,'Kirora','854317',1,0,'2022-03-03 13:19:45','2022-03-03 13:19:45'),(103255,317,'Korha','854108',1,0,'2022-03-03 13:19:45','2022-03-03 13:19:45'),(103256,317,'Kumaripur','854103',1,0,'2022-03-03 13:19:45','2022-03-03 13:19:45'),(103257,317,'Kuretha\'','854107',1,0,'2022-03-03 13:19:45','2022-03-03 13:19:45'),(103258,317,'Kurselababra','855113',1,0,'2022-03-03 13:19:45','2022-03-03 13:19:45'),(103259,317,'Kurum','854317',1,0,'2022-03-03 13:19:45','2022-03-03 13:19:45'),(103260,317,'Laxmipur','854104',1,0,'2022-03-03 13:19:45','2022-03-03 13:19:45'),(103261,317,'M.T.Devipur','854101',1,0,'2022-03-03 13:19:45','2022-03-03 13:19:45'),(103262,317,'Madarichak','854113',1,0,'2022-03-03 13:19:45','2022-03-03 13:19:45'),(103263,317,'Madhopur','854317',1,0,'2022-03-03 13:19:45','2022-03-03 13:19:45'),(103264,317,'Madhura','854107',1,0,'2022-03-03 13:19:45','2022-03-03 13:19:45'),(103265,317,'Mahadevpur (Katihar)','854116',1,0,'2022-03-03 13:19:45','2022-03-03 13:19:45'),(103266,317,'Mahaur','854116',1,0,'2022-03-03 13:19:45','2022-03-03 13:19:45'),(103267,317,'Mahinagar','854317',1,0,'2022-03-03 13:19:45','2022-03-03 13:19:45'),(103268,317,'Mahishal','854317',1,0,'2022-03-03 13:19:45','2022-03-03 13:19:45'),(103269,317,'Mainanagar','854116',1,0,'2022-03-03 13:19:45','2022-03-03 13:19:45'),(103270,317,'Manihari Nawabganj','854113',1,0,'2022-03-03 13:19:45','2022-03-03 13:19:45'),(103271,317,'Manihari','854113',1,0,'2022-03-03 13:19:45','2022-03-03 13:19:45'),(103272,317,'Manman','854317',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103273,317,'Mansahi','854103',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103274,317,'Maraghia','854104',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103275,317,'Marwa','854317',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103276,317,'Marwa','854104',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103277,317,'Mathurapur','855102',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103278,317,'Millik Palagarh','855114',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103279,317,'Morsanda','854108',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103280,317,'Moula Nagar','854101',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103281,317,'Mukuriya','854317',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103282,317,'Musapur','854108',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103283,317,'Nandgola','854101',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103284,317,'Narayanpur','854113',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103285,317,'Neema','854117',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103286,317,'Nimoul','855102',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103287,317,'Nimoul','855113',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103288,317,'Paharpur','854113',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103289,317,'Pakahara','854104',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103290,317,'Palsa','854116',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103291,317,'Pani Kamla','854113',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103292,317,'Pardiara','854113',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103293,317,'Parveli','855105',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103294,317,'Pawai','854104',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103295,317,'Phatepur','854317',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103296,317,'Pirmokam','854114',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103297,317,'Porla','855102',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103298,317,'Pothia','854114',1,0,'2022-03-03 13:19:46','2022-03-03 13:19:46'),(103299,317,'Pranpur','854116',1,0,'2022-03-03 13:19:47','2022-03-03 13:19:47'),(103300,317,'Puranaganj','854317',1,0,'2022-03-03 13:19:47','2022-03-03 13:19:47'),(103301,317,'R.N.Baulia','854113',1,0,'2022-03-03 13:19:47','2022-03-03 13:19:47'),(103302,317,'Regheli','855114',1,0,'2022-03-03 13:19:47','2022-03-03 13:19:47'),(103303,317,'Rosna','854117',1,0,'2022-03-03 13:19:47','2022-03-03 13:19:47'),(103304,317,'Rounia','854104',1,0,'2022-03-03 13:19:47','2022-03-03 13:19:47'),(103305,317,'Sadapur','855113',1,0,'2022-03-03 13:19:47','2022-03-03 13:19:47'),(103306,317,'Sagrath','855105',1,0,'2022-03-03 13:19:47','2022-03-03 13:19:47'),(103307,317,'Sahja','854107',1,0,'2022-03-03 13:19:47','2022-03-03 13:19:47'),(103308,317,'Salepur','854114',1,0,'2022-03-03 13:19:47','2022-03-03 13:19:47'),(103309,317,'Salmari','855113',1,0,'2022-03-03 13:19:47','2022-03-03 13:19:47'),(103310,317,'Samda','854104',1,0,'2022-03-03 13:19:47','2022-03-03 13:19:47'),(103311,317,'Sameli','854101',1,0,'2022-03-03 13:19:47','2022-03-03 13:19:47'),(103312,317,'Sandalpur','854106',1,0,'2022-03-03 13:19:47','2022-03-03 13:19:47'),(103313,317,'Sankola','855102',1,0,'2022-03-03 13:19:47','2022-03-03 13:19:47'),(103314,317,'Sauriya','854107',1,0,'2022-03-03 13:19:47','2022-03-03 13:19:47'),(103315,317,'Semapur Factory','854115',1,0,'2022-03-03 13:19:47','2022-03-03 13:19:47'),(103316,317,'Shipur','855113',1,0,'2022-03-03 13:19:47','2022-03-03 13:19:47'),(103317,317,'Shitalpur Onkar','854317',1,0,'2022-03-03 13:19:47','2022-03-03 13:19:47'),(103318,317,'Shivananpur','855102',1,0,'2022-03-03 13:19:47','2022-03-03 13:19:47'),(103319,317,'Sikat','854115',1,0,'2022-03-03 13:19:47','2022-03-03 13:19:47'),(103320,317,'Siktia','855113',1,0,'2022-03-03 13:19:47','2022-03-03 13:19:47'),(103321,317,'Simra','854101',1,0,'2022-03-03 13:19:47','2022-03-03 13:19:47'),(103322,317,'Sirnia','854103',1,0,'2022-03-03 13:19:47','2022-03-03 13:19:47'),(103323,317,'Sisia','854108',1,0,'2022-03-03 13:19:47','2022-03-03 13:19:47'),(103324,317,'Sitalmani','855102',1,0,'2022-03-03 13:19:47','2022-03-03 13:19:47'),(103325,317,'Sonali','855114',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103326,317,'Sudhani R.S.','854317',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103327,317,'Sujapur','854115',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103328,317,'Sukhasan','854107',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103329,317,'T.M. Baghar','854113',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103330,317,'Tangore','854116',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103331,317,'Teghra','855113',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103332,317,'Telta','854317',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103333,317,'Tikapatti','854101',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103334,317,'Tingahhia','854103',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103335,317,'Kahariah','853204',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103336,318,'Agauni','851216',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103337,318,'Alauli','848203',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103338,318,'Amba','848203',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103339,318,'Amni','851214',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103340,318,'Amousi','851205',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103341,318,'Anantpur','848203',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103342,318,'Araria Balha','851203',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103343,318,'Asli Kothia','851204',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103344,318,'Babhabgama','851204',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103345,318,'Babu Bagicha','851214',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103346,318,'Bachauta','851204',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103347,318,'Badia','851213',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103348,318,'Bahadurpur','848203',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103349,318,'Bahuara','851204',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103350,318,'Balha ','851214',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103351,318,'Bandehra','851212',1,0,'2022-03-03 13:19:48','2022-03-03 13:19:48'),(103352,318,'Banni','851213',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103353,318,'Barai Bangraha','851204',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103354,318,'Bela Simri','851204',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103355,318,'Belanawada','852161',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103356,318,'Beldaur','852161',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103357,318,'Bhadas','851204',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103358,318,'Bharsoi','851216',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103359,318,'Bhutali Malpa','851201',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103360,318,'Birwas','851212',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103361,318,'Bishanpur Ahok','851204',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103362,318,'Bishanpur','851215',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103363,318,'Bishanpur Dumri','851204',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103364,318,'Borna','851202',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103365,318,'Borney','851201',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103366,318,'Budhaura','848203',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103367,318,'Burhwa','848203',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103368,318,'Chak Prayag','851216',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103369,318,'Chandpur Khurd','851204',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103370,318,'Chatarghat','851204',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103371,318,'Chautham','851201',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103372,318,'Chhera Khera','848203',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103373,318,'Chorhli','852161',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103374,318,'Deotha','851212',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103375,318,'Dhari Pachout','852161',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103376,318,'Dighaun','852161',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103377,318,'Dighni','851204',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103378,318,'Dinachakla','851212',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103379,318,'Dumaria Buzurg','851216',1,0,'2022-03-03 13:19:49','2022-03-03 13:19:49'),(103380,318,'Dumaria Khurd','851215',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103381,318,'Dumri','852161',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103382,318,'Durgapur','851204',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103383,318,'Fango','851214',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103384,318,'Farreh','851213',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103385,318,'Garhiya','851214',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103386,318,'Garmohini','851203',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103387,318,'Gaura Shakti Tola','851205',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103388,318,'Gogri','851202',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103389,318,'Gopalpur','851203',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103390,318,'Goraiya Bathan','851203',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103391,318,'Goriyami','848203',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103392,318,'Hardia','851204',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103393,318,'Harinmar','851203',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103394,318,'Haripur','848203',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103395,318,'Hathwan','848203',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103396,318,'Itmadi','851212',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103397,318,'Jahangir Tola','851204',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103398,318,'Jalkaura','851204',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103399,318,'Jamalpur Gogri','851203',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103400,318,'Jhanjhara','851212',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103401,318,'Jhawabohiyar','851203',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103402,318,'Jhiktia','851213',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103403,318,'Jogia','848203',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103404,318,'Jorawarpur','851215',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103405,318,'Kabela','851215',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103406,318,'Kaithi','851201',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103407,318,'Kanhaiyachak','851216',1,0,'2022-03-03 13:19:50','2022-03-03 13:19:50'),(103408,318,'Keshavnagar','851201',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103409,318,'Khagaria Bazar','851204',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103410,318,'Khagaria Mukhya Dakghar','851204',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103411,318,'Kharaita','851201',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103412,318,'Khargi Terasi','851204',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103413,318,'Khutha','851205',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103414,318,'Kolwara','851216',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103415,318,'Koshi College','851205',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103416,318,'Kulharia','851216',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103417,318,'Kurwan','852161',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103418,318,'Labhgaon','851204',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103419,318,'Lagar','851216',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103420,318,'Machhra','848203',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103421,318,'Madarpur','851213',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103422,318,'Madhopur','851215',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103423,318,'Maheshkhunt','851213',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103424,318,'Malia','851203',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103425,318,'Mansi','851214',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103426,318,'Marar','851205',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103427,318,'Mathurapur','851204',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103428,318,'Meghauna','848203',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103429,318,'Mehsauri','851205',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103430,318,'Mohaddipur (Khagaria)','851212',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103431,318,'Mohinath Nagar','852161',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103432,318,'Mohraghat Press','848203',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103433,318,'Nawada','851201',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103434,318,'Nirpur','851201',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103435,318,'Olapur Ganguar','851204',1,0,'2022-03-03 13:19:51','2022-03-03 13:19:51'),(103436,318,'Pachaut','852161',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103437,318,'Pakrail','851213',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103438,318,'Pansalwa','852161',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103439,318,'Parbatta','851216',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103440,318,'Pasraha','851212',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103441,318,'Patel Nagar Bharra','851213',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103442,318,'Paura','851201',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103443,318,'Phudkichak','851203',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103444,318,'Phulwaria','851201',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103445,318,'Phulwaria Deorhi','852161',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103446,318,'Piparpanti','851212',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103447,318,'Pipra Baisa','851212',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103448,318,'Pipralathif','851212',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103449,318,'Pirnagra Deorhi','852161',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103450,318,'Rahimpur','851204',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103451,318,'Ram Nagar Math','851204',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103452,318,'Rani Sakarpura','851204',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103453,318,'Ranko','851205',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103454,318,'Rasounk','851205',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103455,318,'Ratan','851203',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103456,318,'Raun','848203',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103457,318,'Rohiyama','852161',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103458,318,'Rohiyar','851214',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103459,318,'Saharbanni','848203',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103460,318,'Sahraun','851201',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103461,318,'Sahsi','848203',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103462,318,'Saidpur','851214',1,0,'2022-03-03 13:19:52','2022-03-03 13:19:52'),(103463,318,'Sakarpura','848203',1,0,'2022-03-03 13:19:53','2022-03-03 13:19:53'),(103464,318,'Sakrohar','852161',1,0,'2022-03-03 13:19:53','2022-03-03 13:19:53'),(103465,318,'Salarpur','851216',1,0,'2022-03-03 13:19:53','2022-03-03 13:19:53'),(103466,318,'Samaspur','851213',1,0,'2022-03-03 13:19:53','2022-03-03 13:19:53'),(103467,318,'Sanhauli','851205',1,0,'2022-03-03 13:19:53','2022-03-03 13:19:53'),(103468,318,'Sanokhar','848203',1,0,'2022-03-03 13:19:53','2022-03-03 13:19:53'),(103469,318,'Sansarpur','851214',1,0,'2022-03-03 13:19:53','2022-03-03 13:19:53'),(103470,318,'Saraiya','851201',1,0,'2022-03-03 13:19:53','2022-03-03 13:19:53'),(103471,318,'Shergarh','851203',1,0,'2022-03-03 13:19:53','2022-03-03 13:19:53'),(103472,318,'Simraha','848203',1,0,'2022-03-03 13:19:53','2022-03-03 13:19:53'),(103473,318,'Siswa','851214',1,0,'2022-03-03 13:19:53','2022-03-03 13:19:53'),(103474,318,'Sonbarsa Ghat','851201',1,0,'2022-03-03 13:19:53','2022-03-03 13:19:53'),(103475,318,'Sondiha','851212',1,0,'2022-03-03 13:19:53','2022-03-03 13:19:53'),(103476,318,'Telihar','852161',1,0,'2022-03-03 13:19:53','2022-03-03 13:19:53'),(103477,318,'Temtha','851216',1,0,'2022-03-03 13:19:53','2022-03-03 13:19:53'),(103478,318,'Tetrabad Chandpura','851204',1,0,'2022-03-03 13:19:53','2022-03-03 13:19:53'),(103479,318,'Thatha','851214',1,0,'2022-03-03 13:19:53','2022-03-03 13:19:53'),(103480,318,'Thuthi','851214',1,0,'2022-03-03 13:19:53','2022-03-03 13:19:53'),(103481,318,'Bharakhand Naybas','853203',1,0,'2022-03-03 13:19:53','2022-03-03 13:19:53'),(103482,318,'Khajraitha','853203',1,0,'2022-03-03 13:19:53','2022-03-03 13:19:53'),(103483,318,'Sathishnagar','853203',1,0,'2022-03-03 13:19:53','2022-03-03 13:19:53'),(103484,318,'Mathar','811202',1,0,'2022-03-03 13:19:53','2022-03-03 13:19:53'),(103485,319,'Altahat','855107',1,0,'2022-03-03 13:19:53','2022-03-03 13:19:53'),(103486,319,'Angarhat','855115',1,0,'2022-03-03 13:19:53','2022-03-03 13:19:53'),(103487,319,'Asja','855107',1,0,'2022-03-03 13:19:53','2022-03-03 13:19:53'),(103488,319,'B.B. Bharatpur','855108',1,0,'2022-03-03 13:19:53','2022-03-03 13:19:53'),(103489,319,'Bagalbari','855107',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103490,319,'Bahadurganj (Kishanganj)','855101',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103491,319,'Baigna','855101',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103492,319,'Bairia','855101',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103493,319,'Bangama','855101',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103494,319,'Belwa','855107',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103495,319,'Bharadah','855101',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103496,319,'Bhawaniganj','855116',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103497,319,'Bhittabari','855101',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103498,319,'Bholmara','855108',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103499,319,'Bibiganj','855101',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103500,319,'Bishanpur','855101',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103501,319,'Chakalaghat','855107',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103502,319,'Chanamana','855117',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103503,319,'Chhatargachi','855117',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103504,319,'Churli','855116',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103505,319,'Daluahat','855117',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103506,319,'Dhangarha','855101',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103507,319,'Dhanpatganj','855115',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103508,319,'Dhantola','855101',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103509,319,'Dhusmalhat','855107',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103510,319,'Dighalbank','855101',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103511,319,'Dogharia','855115',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103512,319,'Fatehpur','855101',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103513,319,'G.M.Bathna','855107',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103514,319,'Galgalia','855106',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103515,319,'Gangi','855107',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103516,319,'Gunjanmari','855116',1,0,'2022-03-03 13:19:54','2022-03-03 13:19:54'),(103517,319,'Haldikhora','855115',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103518,319,'Hulhuli','855116',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103519,319,'Jhala','855101',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103520,319,'Jirangachhi','855116',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103521,319,'Jiyapokhar','855108',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103522,319,'Kanalyabarihat','855107',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103523,319,'Kansibarihat','855107',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103524,319,'Karhabari','855101',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103525,319,'Kharudah','855107',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103526,319,'Khatia Pichhia','855117',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103527,319,'Khodaganj','855108',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103528,319,'Kishanganj Bazar','855108',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103529,319,'Kishanganj','855107',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103530,319,'Kochadhaman','855115',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103531,319,'Kuttigola','855107',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103532,319,'Laucha','855101',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103533,319,'Lohargarha','855101',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103534,319,'Mahesh Batna','855101',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103535,319,'Mangura','855101',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103536,319,'Maria','855117',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103537,319,'Matiari','855101',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103538,319,'Meharganj','855108',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103539,319,'Mirjapur','855117',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103540,319,'Mirpur','855115',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103541,319,'Modho','855115',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103542,319,'Nainagachhi','855116',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103543,319,'Natuapara','855107',1,0,'2022-03-03 13:19:55','2022-03-03 13:19:55'),(103544,319,'Nishaangara','855101',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103545,319,'P.Thakurbari','855117',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103546,319,'Padampur','855108',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103547,319,'Pahar Katta','855117',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103548,319,'Panasihat','855117',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103549,319,'Pathamari','855116',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103550,319,'Patharia','855116',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103551,319,'Patkoihat','855107',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103552,319,'Piprithan','855116',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103553,319,'Piyajee','855107',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103554,319,'Poth R.S.','855117',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103555,319,'Powakhali','855108',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103556,319,'Raipur','855107',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103557,319,'Ruidhasa','855116',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103558,319,'Runki\'','855107',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103559,319,'Rupani','855101',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103560,319,'Sameswar','855101',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103561,319,'Saraikuri','855108',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103562,319,'Shishabari','855115',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103563,319,'Singhari','855115',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103564,319,'Singhia','855107',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103565,319,'Sirsi','855107',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103566,319,'Sitalpur','855117',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103567,319,'Sontha','855115',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103568,319,'Taiyabpur','855117',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103569,319,'Tarabari','855108',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103570,319,'Tehragachh','855101',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103571,319,'Thakurganj','855116',1,0,'2022-03-03 13:19:56','2022-03-03 13:19:56'),(103572,319,'Thiraniganj','855101',1,0,'2022-03-03 13:19:57','2022-03-03 13:19:57'),(103573,319,'Toesa','855107',1,0,'2022-03-03 13:19:57','2022-03-03 13:19:57'),(103574,319,'Tulsia','855101',1,0,'2022-03-03 13:19:57','2022-03-03 13:19:57'),(103575,320,'Abhaypur','811112',1,0,'2022-03-03 13:19:57','2022-03-03 13:19:57'),(103576,320,'Alinagar','811106',1,0,'2022-03-03 13:19:57','2022-03-03 13:19:57'),(103577,320,'Amarpur','811106',1,0,'2022-03-03 13:19:57','2022-03-03 13:19:57'),(103578,320,'Arma','811309',1,0,'2022-03-03 13:19:57','2022-03-03 13:19:57'),(103579,320,'Aurey','811311',1,0,'2022-03-03 13:19:57','2022-03-03 13:19:57'),(103580,320,'B Dariyapur','811302',1,0,'2022-03-03 13:19:57','2022-03-03 13:19:57'),(103581,320,'B.Bartara','811107',1,0,'2022-03-03 13:19:57','2022-03-03 13:19:57'),(103582,320,'Baghaur','811311',1,0,'2022-03-03 13:19:57','2022-03-03 13:19:57'),(103583,320,'Bahachha','811304',1,0,'2022-03-03 13:19:57','2022-03-03 13:19:57'),(103584,320,'Balgudar','811311',1,0,'2022-03-03 13:19:57','2022-03-03 13:19:57'),(103585,320,'Bandhu Bagicha','811310',1,0,'2022-03-03 13:19:57','2022-03-03 13:19:57'),(103586,320,'Barhiya','811302',1,0,'2022-03-03 13:19:57','2022-03-03 13:19:57'),(103587,320,'Belari','811311',1,0,'2022-03-03 13:19:57','2022-03-03 13:19:57'),(103588,320,'Bhabangawan','811311',1,0,'2022-03-03 13:19:57','2022-03-03 13:19:57'),(103589,320,'Bichhwey','811310',1,0,'2022-03-03 13:19:57','2022-03-03 13:19:57'),(103590,320,'Billo','811107',1,0,'2022-03-03 13:19:57','2022-03-03 13:19:57'),(103591,320,'Birupur','811302',1,0,'2022-03-03 13:19:57','2022-03-03 13:19:57'),(103592,320,'C.R.Lakhisarai','811201',1,0,'2022-03-03 13:19:57','2022-03-03 13:19:57'),(103593,320,'Chetan Tola Khutha','811302',1,0,'2022-03-03 13:19:57','2022-03-03 13:19:57'),(103594,320,'Damodar Pur','811311',1,0,'2022-03-03 13:19:57','2022-03-03 13:19:57'),(103595,320,'Dhira','811315',1,0,'2022-03-03 13:19:57','2022-03-03 13:19:57'),(103596,320,'Dhiradar','811311',1,0,'2022-03-03 13:19:57','2022-03-03 13:19:57'),(103597,320,'Dighari','811106',1,0,'2022-03-03 13:19:57','2022-03-03 13:19:57'),(103598,320,'Dihra','811311',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103599,320,'Dumari','811302',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103600,320,'G Parsando','811311',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103601,320,'Ganga Sarai','811302',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103602,320,'Ghonghsa','811315',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103603,320,'Gopalpur','811310',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103604,320,'Halsi','811311',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103605,320,'Jaitpur','811302',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103606,320,'Janki Dih Beldaria','811310',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103607,320,'Kabadpur','811106',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103608,320,'Kachhiyana','811107',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103609,320,'Kajra','811309',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103610,320,'Kendi','811311',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103611,320,'Khutha','811302',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103612,320,'Kiranpur','811106',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103613,320,'Kisanpur','811311',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103614,320,'Kiul-rs','811310',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103615,320,'Konag','811311',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103616,320,'L. Kalyanpur','811302',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103617,320,'Lai','811309',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103618,320,'Lakhisarai Court','811311',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103619,320,'Lakhisarai','811311',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103620,320,'Loshghani','811112',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103621,320,'M. Nagar','811315',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103622,320,'Mahisona','811311',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103623,320,'Malia','811310',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103624,320,'Mananpur','811310',1,0,'2022-03-03 13:19:58','2022-03-03 13:19:58'),(103625,320,'Mankattha','811311',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103626,320,'Mano','811310',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103627,320,'Matashi','811315',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103628,320,'Mustafapur','811106',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103629,320,'Nadiyama','811107',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103630,320,'Nandnama','811311',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103631,320,'Nandpur','811106',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103632,320,'Noma','811315',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103633,320,'P.B.Lakhisarai','811311',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103634,320,'Pacham','811311',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103635,320,'Paharpur','811106',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103636,320,'Parsama','811311',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103637,320,'Pawai','811309',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103638,320,'Pipariya','811302',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103639,320,'Piri Bazar','811112',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103640,320,'Pokhrama','811309',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103641,320,'Pratappur','811107',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103642,320,'R Mahsaura','811107',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103643,320,'Ramchandrapur','811311',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103644,320,'Ramnagar','811311',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103645,320,'Rampur','811310',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103646,320,'Rehua','811311',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103647,320,'S Imam Nagar','811107',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103648,320,'S Khairma','811311',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103649,320,'S Salaunja','811311',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103650,320,'Sadaibigha','811302',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103651,320,'Sahoor','811310',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103652,320,'Sangrampur','811310',1,0,'2022-03-03 13:19:59','2022-03-03 13:19:59'),(103653,320,'Sharma','811311',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103654,320,'Shiovsona','811311',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103655,320,'Shobhani','811310',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103656,320,'Singhchak','811310',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103657,320,'Ss Barari','811106',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103658,320,'Surajgaraha','811106',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103659,320,'Talsharama','811302',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103660,320,'Tarhari','811315',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103661,320,'Tetarhat','811311',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103662,320,'Urain','811309',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103663,320,'Walipur','811311',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103664,321,'Abhirampur','852213',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103665,321,'Akbarpur','852116',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103666,321,'Amarpura','852122',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103667,321,'Anandpura','852115',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103668,321,'Arraha','852121',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103669,321,'Aurai','852116',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103670,321,'B.Barhona','852213',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103671,321,'B.Garhia','852121',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103672,321,'B.Korhlahi','852112',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103673,321,'B.Tekhti','852121',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103674,321,'Bajraha','852219',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103675,321,'Bansgopal','852213',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103676,321,'Barahi Hasanpur','852128',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103677,321,'Bariahi','852132',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103678,321,'Basanwara','852219',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103679,321,'Basnahi','852115',1,0,'2022-03-03 13:20:00','2022-03-03 13:20:00'),(103680,321,'Basudeva','852121',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103681,321,'Bathanparsa','852132',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103682,321,'Behariganj','852101',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103683,321,'Behrari','852128',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103684,321,'Behri','852128',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103685,321,'Belari','852114',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103686,321,'Belo','852114',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103687,321,'Besarh','852112',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103688,321,'Bhadol','852114',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103689,321,'Bhagwanpur','852113',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103690,321,'Bhairo Patti','852114',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103691,321,'Bhangha Chandpur','852122',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103692,321,'Bharahi','852113',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103693,321,'Bhatauni','852127',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103694,321,'Bhatkhora','852114',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103695,321,'Bhatni','852112',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103696,321,'Bhawanipur','852128',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103697,321,'Bheropatti','852218',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103698,321,'Bhirkhi','852113',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103699,321,'Biri Rampal','852101',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103700,321,'Bishanpurarar','852115',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103701,321,'Bispatti','852219',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103702,321,'Bnmu University Madhepura','852113',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103703,321,'Budhma','852114',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103704,321,'Chatra','852115',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103705,321,'Chausa (Madhepura)','852213',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103706,321,'Chiraouri','852213',1,0,'2022-03-03 13:20:01','2022-03-03 13:20:01'),(103707,321,'Chouraha','852132',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103708,321,'D.Kalan','852213',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103709,321,'Dhaneshpur','852213',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103710,321,'Dhurgaon','852114',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103711,321,'Dinapatti','852122',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103712,321,'Durgapur','852116',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103713,321,'Fatehpur','852101',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103714,321,'Gahumani','852128',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103715,321,'Gamail \\','852101',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103716,321,'Gangapur','852219',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103717,321,'Gangapur','852122',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103718,321,'Ghailar','852124',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103719,321,'Ghosai','852213',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103720,321,'Gidha','852128',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103721,321,'Gopalpur','852220',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103722,321,'Gorela','852113',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103723,321,'Goth Bardaha','852202',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103724,321,'Gwalpara','852115',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103725,321,'H.Kala','852122',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103726,321,'Hanuman Nagar Chouraha','852128',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103727,321,'Hareshwari Dighi','852122',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103728,321,'Hathionda','852101',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103729,321,'Israin','852112',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103730,321,'Itahari','852219',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103731,321,'Jadua Patti','852112',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103732,321,'Jagjiwan Ashram','852113',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103733,321,'Jeeta Pur','852114',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103734,321,'Jhalari','852115',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103735,321,'Jhanjhari','852115',1,0,'2022-03-03 13:20:02','2022-03-03 13:20:02'),(103736,321,'Jharkaha','852132',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103737,321,'Jirwa','852132',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103738,321,'Jirwa Madheli','852132',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103739,321,'Jorgama','852122',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103740,321,'K.Millik','852219',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103741,321,'K.Ratwara','852219',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103742,321,'K.S.Pur','852220',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103743,321,'Kalhua','852132',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103744,321,'Karauti Bazar','852220',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103745,321,'Kataia Satokar','852128',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103746,321,'Kathotia','852101',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103747,321,'Khara Budhma','852219',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103748,321,'Kherho','852116',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103749,321,'Khurhan Mal','852219',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103750,321,'Koshlipatti','852108',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103751,321,'Kumarkhand','852112',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103752,321,'Kunjouri','852219',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103753,321,'Kurshandi','852219',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103754,321,'L. Bhagwati','852112',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103755,321,'Lalkuria','852112',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103756,321,'Lalpur Sarropatti','852128',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103757,321,'Laskari','852220',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103758,321,'Laua Lagam','852213',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103759,321,'Laxmipur','852218',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103760,321,'Laxmipur Bisharia','852101',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103761,321,'Laxmipur Lalchand','852101',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103762,321,'Lc Ashthan','852122',1,0,'2022-03-03 13:20:03','2022-03-03 13:20:03'),(103763,321,'M.Baghaili','852112',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103764,321,'Madhepura Collectorate','852113',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103765,321,'Madhepura','852113',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103766,321,'Madhuban','852101',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103767,321,'Madhukarchak','852101',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103768,321,'Maheshua','852128',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103769,321,'Mahmooda','852219',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103770,321,'Mahua Bazar','852219',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103771,321,'Majarhat','852128',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103772,321,'Makdampur','852213',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103773,321,'Maliya','852113',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103774,321,'Mangarwara','852112',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103775,321,'Manhara Sukhashan','852128',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103776,321,'Manikpur','852113',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103777,321,'Manjoura','852116',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103778,321,'Manpur','852128',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103779,321,'Maoura Ramnagar','852132',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103780,321,'Mathahi','852121',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103781,321,'Mirchaibari','852122',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103782,321,'Mohamadpur','852115',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103783,321,'Mohanpur Choumukh','852101',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103784,321,'Morsanda','852219',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103785,321,'Muraut','852219',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103786,321,'Murho','852114',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103787,321,'Murli Chandwa','852220',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103788,321,'Murliganj Bazar','852122',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103789,321,'Murliganj','852122',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103790,321,'Murliganj Tola','852122',1,0,'2022-03-03 13:20:04','2022-03-03 13:20:04'),(103791,321,'N. Bhagipur','852219',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103792,321,'Narsingbag','852114',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103793,321,'Naulakhi','852122',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103794,321,'Naya Nagar','852220',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103795,321,'Orahi','852108',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103796,321,'P.N.Pur','852114',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103797,321,'Paina','852213',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103798,321,'Pandeypatti','852112',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103799,321,'Pararia','852101',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103800,321,'Parmanandpur','852112',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103801,321,'Parwa','852122',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103802,321,'Patori','852128',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103803,321,'Peernagar','852115',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103804,321,'Phulaut','852219',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103805,321,'Piprahi','852128',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103806,321,'Pokhram','852114',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103807,321,'Puraini','852112',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103808,321,'Puraini Bazar','852116',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103809,321,'R.Barateni','852220',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103810,321,'R.N.Khwan','852219',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103811,321,'Raghunath Pur','852122',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103812,321,'Rahta','852122',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103813,321,'Rahta Chamukh','852101',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103814,321,'Rahua','852116',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103815,321,'Raibhir','852128',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103816,321,'Rajni','852101',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103817,321,'Rajni Babhangama','852101',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103818,321,'Ramganj','852112',1,0,'2022-03-03 13:20:05','2022-03-03 13:20:05'),(103819,321,'Ramnagar','852112',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103820,321,'Rampatti','852114',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103821,321,'Rampur','852122',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103822,321,'Rampur Khora','852220',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103823,321,'Ranipatti','852112',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103824,321,'Ratanpatti','852122',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103825,321,'Ratanpura','852128',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103826,321,'Rupauli Jiwachpur','852128',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103827,321,'Rupauli Lalpatti','852128',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103828,321,'S.B.Toli','852112',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103829,321,'S.Dakshinwari','852121',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103830,321,'S.Madheli','852219',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103831,321,'S.Millick','852114',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103832,321,'S.N.Hat','852112',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103833,321,'S.Rauta','852112',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103834,321,'S.Simraha','852121',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103835,321,'Sabaila','852113',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103836,321,'Sahjadpur','852219',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103837,321,'Sahugarh','852113',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103838,321,'Sahuria','852122',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103839,321,'Sakarpura','852113',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103840,321,'Sapardah','852219',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103841,321,'Sarauni Kala','852101',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103842,321,'Shah Alam Nagar','852219',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103843,321,'Shahpur','852115',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103844,321,'Shankarpur','852132',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103845,321,'Shankarpur Bazar','852132',1,0,'2022-03-03 13:20:06','2022-03-03 13:20:06'),(103846,321,'Shyam','852220',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103847,321,'Sigion','852128',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103848,321,'Singhar','852219',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103849,321,'Singheshwar','852128',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103850,321,'Sirsia','852101',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103851,321,'Sonbersa','852132',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103852,321,'Srinagar','852124',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103853,321,'Sripur Tengraha','852128',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103854,321,'Sukhasan Chakla','852113',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103855,321,'Sukhashan','852115',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103856,321,'T.Bargaon','852219',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103857,321,'T.P.College','madhepura',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103858,321,'Tamot Persa','852122',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103859,321,'Temabhelwa','852115',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103860,321,'Tulsibari','852113',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103861,321,'Tuniahi','852113',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103862,321,'Turkahi','852113',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103863,321,'Udakishunganj','852220',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103864,321,'Arajpur','853204',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103865,321,'Beijnathpur','813204',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103866,321,'Bhatgama','853204',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103867,322,'Agai','847303',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103868,322,'C.Quaztola','847122',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103869,322,'Noorchak','847122',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103870,322,'Akaur','847230',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103871,322,'Alola','847402',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103872,322,'Amahi','847402',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103873,322,'Amouza','847402',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103874,322,'Andah','847234',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103875,322,'Andhra','847401',1,0,'2022-03-03 13:20:07','2022-03-03 13:20:07'),(103876,322,'Araria Sangra','847109',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103877,322,'Arerhat','847222',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103878,322,'Auraha','847108',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103879,322,'Awari','847308',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103880,322,'B.Belahi','847215',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103881,322,'Baboobarhi','847224',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103882,322,'Bagha Kusmar','847409',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103883,322,'Baikabishanpur','847402',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103884,322,'Baira','847226',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103885,322,'Baliabikrampur','847239',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103886,322,'Balua','847409',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103887,322,'Bangama','847108',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103888,322,'Bankatta Uren','847223',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103889,322,'Banki','847408',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103890,322,'Bardaha','847401',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103891,322,'Barha','847223',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103892,322,'Barhampura','847223',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103893,322,'Barhara','847401',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103894,322,'Barhi','847226',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103895,322,'Barhmotra','847227',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103896,322,'Barri','847102',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103897,322,'Barsam','847411',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103898,322,'Baruar','847228',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103899,322,'Basaith Chandpura','847102',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103900,322,'Basania','847421',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103901,322,'Basipatti','847408',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103902,322,'Baskhora','847402',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103903,322,'Basopatti','847225',1,0,'2022-03-03 13:20:08','2022-03-03 13:20:08'),(103904,322,'Basuara','847212',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103905,322,'Basuari','847402',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103906,322,'Basudevpur','847421',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103907,322,'Basuki Bihari','847305',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103908,322,'Bath','847408',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103909,322,'Bathnaha','847227',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103910,322,'Bathne','847236',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103911,322,'Behat Goth','847403',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103912,322,'Bela','847226',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103913,322,'Bela','847224',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103914,322,'Bela','847408',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103915,322,'Belaha','847452',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103916,322,'Belarahi','847404',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103917,322,'Belauncha','847408',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103918,322,'Belauza','847222',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103919,322,'Belha','847402',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103920,322,'Belhi','847227',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103921,322,'Belhi Bhawanipur','847108',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103922,322,'Belhwar','847215',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103923,322,'Bengra','847308',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103924,322,'Benipatti','847223',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103925,322,'Benta','847228',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103926,322,'Benta Parsa','847230',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103927,322,'Berma','847410',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103928,322,'Bhachhi','847212',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103929,322,'Bhagta','847408',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103930,322,'Bhagwatipurnahar','847236',1,0,'2022-03-03 13:20:09','2022-03-03 13:20:09'),(103931,322,'Bhaiyapatti','847230',1,0,'2022-03-03 13:20:10','2022-03-03 13:20:10'),(103932,322,'Bhakhrain','847408',1,0,'2022-03-03 13:20:10','2022-03-03 13:20:10'),(103933,322,'Bhakua','847228',1,0,'2022-03-03 13:20:10','2022-03-03 13:20:10'),(103934,322,'Bhaptiahi','847108',1,0,'2022-03-03 13:20:10','2022-03-03 13:20:10'),(103935,322,'Bhargama','847408',1,0,'2022-03-03 13:20:10','2022-03-03 13:20:10'),(103936,322,'Bhariabishanpur','847235',1,0,'2022-03-03 13:20:10','2022-03-03 13:20:10'),(103937,322,'Bharkhori','847108',1,0,'2022-03-03 13:20:10','2022-03-03 13:20:10'),(103938,322,'Bhatchaura','847228',1,0,'2022-03-03 13:20:10','2022-03-03 13:20:10'),(103939,322,'Bhatsimar','847235',1,0,'2022-03-03 13:20:10','2022-03-03 13:20:10'),(103940,322,'Bhawanipur','847234',1,0,'2022-03-03 13:20:10','2022-03-03 13:20:10'),(103941,322,'Bheja','847408',1,0,'2022-03-03 13:20:10','2022-03-03 13:20:10'),(103942,322,'Bhith Bhagwanpur','847408',1,0,'2022-03-03 13:20:10','2022-03-03 13:20:10'),(103943,322,'Bhour','847231',1,0,'2022-03-03 13:20:10','2022-03-03 13:20:10'),(103944,322,'Bhowara','847212',1,0,'2022-03-03 13:20:10','2022-03-03 13:20:10'),(103945,322,'Biraoul','847402',1,0,'2022-03-03 13:20:10','2022-03-03 13:20:10'),(103946,322,'Biratpur Birauli','847223',1,0,'2022-03-03 13:20:10','2022-03-03 13:20:10'),(103947,322,'Biraul','847228',1,0,'2022-03-03 13:20:10','2022-03-03 13:20:10'),(103948,322,'Biroul','847236',1,0,'2022-03-03 13:20:10','2022-03-03 13:20:10'),(103949,322,'Birpur','847225',1,0,'2022-03-03 13:20:10','2022-03-03 13:20:10'),(103950,322,'Birpur Harpatti','847227',1,0,'2022-03-03 13:20:10','2022-03-03 13:20:10'),(103951,322,'Birsair','847234',1,0,'2022-03-03 13:20:10','2022-03-03 13:20:10'),(103952,322,'Bisanpur','847102',1,0,'2022-03-03 13:20:10','2022-03-03 13:20:10'),(103953,322,'Bishoul','847240',1,0,'2022-03-03 13:20:10','2022-03-03 13:20:10'),(103954,322,'Brahmpur','847409',1,0,'2022-03-03 13:20:10','2022-03-03 13:20:10'),(103955,322,'Chachraha','847226',1,0,'2022-03-03 13:20:10','2022-03-03 13:20:10'),(103956,322,'Chandra Dih','847224',1,0,'2022-03-03 13:20:10','2022-03-03 13:20:10'),(103957,322,'Chanouraganj','847404',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103958,322,'Chapahi','847235',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103959,322,'Chatra','847223',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103960,322,'Chatra','847228',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103961,322,'Chaturbhuj Piprahi','847421',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103962,322,'Chhajana','847108',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103963,322,'Chhatauni','847225',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103964,322,'Chhaurahi','847228',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103965,322,'Chichorba','847108',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103966,322,'Chichrikanungo','847235',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103967,322,'Chikna','847402',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103968,322,'Choramahrail','847404',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103969,322,'Chunni','847408',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103970,322,'D.Chandpura','847102',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103971,322,'Dahibatnathwan','847234',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103972,322,'Dahiwatmadhopur','847234',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103973,322,'Daiya Kharwar','847403',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103974,322,'Daldal','847408',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103975,322,'Damo','847225',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103976,322,'Damodarpur','847223',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103977,322,'Datuar','847228',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103978,322,'Deep','847403',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103979,322,'Deodha','847226',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103980,322,'Deopura','847223',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103981,322,'Devhar','847224',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103982,322,'Dhabahi','847108',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103983,322,'Dhakjari','847223',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103984,322,'Dhamaura','847224',1,0,'2022-03-03 13:20:11','2022-03-03 13:20:11'),(103985,322,'Dhamiapatti','847226',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(103986,322,'Dhanauja','847409',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(103987,322,'Dhanchhiha Baruar','847452',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(103988,322,'Dhanga','847229',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(103989,322,'Dharmdiha','847402',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(103990,322,'Dighia','847452',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(103991,322,'Dighia Phent','847225',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(103992,322,'Dorbar','847226',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(103993,322,'Dubahi Mahinathpur','847225',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(103994,322,'Dullipatti','847226',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(103995,322,'Dumari','847212',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(103996,322,'Dumra','847411',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(103997,322,'Durgapatti','847308',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(103998,322,'Dwalakh','847408',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(103999,322,'Ekhari','847232',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(104000,322,'Ekhathha','847227',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(104001,322,'Ektara','847222',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(104002,322,'Gahuma Beria','847402',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(104003,322,'Gajhara','847227',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(104004,322,'Ganauli','847401',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(104005,322,'Gandhwair','847234',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(104006,322,'Ganeshpur','847408',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(104007,322,'Gangapur','847403',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(104008,322,'Gangaur','847308',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(104009,322,'Gangdwar','847235',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(104010,322,'Ganguli','847223',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(104011,322,'Garatol','847402',1,0,'2022-03-03 13:20:12','2022-03-03 13:20:12'),(104012,322,'Garha','847232',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104013,322,'Genaur','847223',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104014,322,'Ghoghardiha','847402',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104015,322,'Ghonghour','847235',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104016,322,'Ghorabanki','847225',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104017,322,'Gobraura','847228',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104018,322,'Gurmaha','847231',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104019,322,'Harbhanga','847403',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104020,322,'Haripur Baxi Tola','847229',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104021,322,'Haripur Dih Tol','847229',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104022,322,'Harlakhi','847240',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104023,322,'Harna','847404',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104024,322,'Harri','847404',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104025,322,'Hata Rupauli','847404',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104026,322,'Hatni','847402',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104027,322,'Hattapur','847225',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104028,322,'Hisardeorhi','847230',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104029,322,'Hudra','847227',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104030,322,'Husainpur','847238',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104031,322,'Imadpatti','847404',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104032,322,'Jafra','847222',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104033,322,'Jagatpur','847402',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104034,322,'Jagatpur','847213',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104035,322,'Jageshwar Asthan','847402',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104036,322,'Jalsain','847411',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104037,322,'Jamsam','847234',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104038,322,'Jaso','847225',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104039,322,'Jaynagar Bazar','847226',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104040,322,'Jaynagar','847226',1,0,'2022-03-03 13:20:13','2022-03-03 13:20:13'),(104041,322,'Jhaloun','847232',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104042,322,'Jhanjharpur Court','847404',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104043,322,'Jhanjharpur RS','847403',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104044,322,'Jhanjharpur','847404',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104045,322,'Jiraul','847230',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104046,322,'Jitwarpur','847215',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104047,322,'Jonki','847225',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104048,322,'Kachhua','847410',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104049,322,'Kachhubi','847410',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104050,322,'Kaithai','847236',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104051,322,'Kaithinia','847403',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104052,322,'Kakardobh','847108',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104053,322,'Kakna','847212',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104054,322,'Kako','847404',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104055,322,'Kakraul','847238',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104056,322,'Kalapatti','847409',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104057,322,'Kalikapur','847402',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104058,322,'Kalikapur','847228',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104059,322,'Kaluahi','847229',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104060,322,'Kamalabari','847226',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104061,322,'Kamalpur','847225',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104062,322,'Kanhauli','847228',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104063,322,'Kapileshwar Asthan','847238',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104064,322,'Kapsiya','847213',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104065,322,'Karhari','847108',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104066,322,'Karhi','847222',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104067,322,'Kariot','847108',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104068,322,'Karmauli','847229',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104069,322,'Karmegh','847421',1,0,'2022-03-03 13:20:14','2022-03-03 13:20:14'),(104070,322,'Kasma Marar','847228',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104071,322,'Kataiya','847223',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104072,322,'Kataya','847225',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104073,322,'Kathia','847404',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104074,322,'Kauwaha Barhi','847230',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104075,322,'Keotha','847230',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104076,322,'Keotna','847402',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104077,322,'Kerwar','847222',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104078,322,'Kewalpatti','847235',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104079,322,'Khajauli','847228',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104080,322,'Khajedih','847232',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104081,322,'Khajuri','847212',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104082,322,'Kharagwani','847224',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104083,322,'Kharaua','847238',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104084,322,'Kharra','847212',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104085,322,'Khauna','847240',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104086,322,'Khirhar','847230',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104087,322,'Khozpur','847224',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104088,322,'Khutauna','847227',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104089,322,'Koilakh','847236',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104090,322,'Korahia','847226',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104091,322,'Korahiyabalha','847235',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104092,322,'Kotjia Bharam','847404',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104093,322,'Kuar','847226',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104094,322,'Kukurdaura','847108',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104095,322,'Kulharia','847401',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104096,322,'Kumarkhat','847232',1,0,'2022-03-03 13:20:15','2022-03-03 13:20:15'),(104097,322,'Ladania','847232',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104098,322,'Lakhnour','847403',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104099,322,'Lalmania','847421',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104100,322,'Laufa','847403',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104101,322,'Laukaha','847421',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104102,322,'Laukahi','847108',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104103,322,'Laukahi Dhanchhiha','847452',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104104,322,'Lawani','847410',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104105,322,'Laxamipur','847421',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104106,322,'Laxmipur','847228',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104107,322,'Loha','847213',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104108,322,'Lohat','847231',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104109,322,'Lohna','847424',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104110,322,'Lorika','847223',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104111,322,'M G Bazar','847214',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104112,322,'Madhepur','847408',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104113,322,'Madhopur','847421',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104114,322,'Madhubani Court','847211',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104115,322,'Madhubani H.O','847211',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104116,322,'Madhwapur','847305',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104117,322,'Madna','847401',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104118,322,'Mahadev Math','847452',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104119,322,'Maheaswara','847228',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104120,322,'Mahindwar Navtoli','847109',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104121,322,'Mahpatia','847408',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104122,322,'Mahrail','847404',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104123,322,'Mahtha','847232',1,0,'2022-03-03 13:20:16','2022-03-03 13:20:16'),(104124,322,'Mahthour','847409',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104125,322,'Mahua Ekdara','847228',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104126,322,'Mailam','847235',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104127,322,'Maina Sukki','847228',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104128,322,'Makhnaha','847108',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104129,322,'Makrampur','847234',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104130,322,'Maksuda','847234',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104131,322,'Malangia','847212',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104132,322,'Malin Belha','847227',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104133,322,'Malmal','847229',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104134,322,'Mangrauni','847214',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104135,322,'Manpour','847230',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104136,322,'Mansapur','847108',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104137,322,'Marhia','847225',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104138,322,'Marukia','847228',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104139,322,'Massa','847102',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104140,322,'Matras','847402',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104141,322,'Mauahi','847224',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104142,322,'Mdb. Bara Bazar','847213',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104143,322,'Meghoul','847239',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104144,322,'Meghwan','847102',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104145,322,'Mehath','847404',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104146,322,'Mirjapur','847232',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104147,322,'Misrauli','847224',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104148,322,'Mureth','847229',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104149,322,'Murli','847409',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104150,322,'Nagdah Balain','847222',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104151,322,'Nagwas','847222',1,0,'2022-03-03 13:20:17','2022-03-03 13:20:17'),(104152,322,'Nahas Rupauli','847222',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104153,322,'Najramahmda','847239',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104154,322,'Nakti','847235',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104155,322,'Nanaour','847109',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104156,322,'Narahiya','847108',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104157,322,'Narar','847226',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104158,322,'Narendrapur','847452',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104159,322,'Narpatinagar','847239',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104160,322,'Navkarhi','847222',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104161,322,'Nazirpur','847215',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104162,322,'Neor','847108',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104163,322,'Nil','847226',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104164,322,'Pachahi','847408',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104165,322,'Pachrukhi','847224',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104166,322,'Padma','847226',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104167,322,'Palimohan','847228',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104168,322,'Pandaul','847234',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104169,322,'Paraul','847229',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104170,322,'Pariharpur','847235',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104171,322,'Parjuar','847229',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104172,322,'Parsa','847402',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104173,322,'Parsa','847109',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104174,322,'Parsahi Sirsiya','847421',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104175,322,'Parsauni','847223',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104176,322,'Parsuna','847223',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104177,322,'Parwa','847226',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104178,322,'Pastan','847401',1,0,'2022-03-03 13:20:18','2022-03-03 13:20:18'),(104179,322,'Pathrahi','847227',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104180,322,'Patwara','847235',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104181,322,'Phatki','847408',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104182,322,'Phulhar','847240',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104183,322,'Phulparas','847409',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104184,322,'Pilakhwar','847214',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104185,322,'Piprahi','847232',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104186,322,'Pipraun','847240',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104187,322,'Pirhi','847224',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104188,322,'Pirojgadh','847402',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104189,322,'Pokhrouni','847223',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104190,322,'Pursaulia','847226',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104191,322,'R.K.Collage','847215',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104192,322,'Raghopurbalat','847236',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104193,322,'Raghunidehat','847214',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104194,322,'Rahika','847238',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104195,322,'Rahua Sangram','847408',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104196,322,'Raima','847404',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104197,322,'Raima','847308',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104198,322,'Raja Kharwar','847403',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104199,322,'Rajaram Patti','847452',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104200,322,'Raje','847424',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104201,322,'Rajnagar (Madhubani)','847235',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104202,322,'Rakhwari','847411',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104203,322,'Ramchandra','847408',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104204,322,'Ramnipatti','847224',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104205,322,'Rampatti','847236',1,0,'2022-03-03 13:20:19','2022-03-03 13:20:19'),(104206,322,'Rampur','847424',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104207,322,'Rampur','847240',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104208,322,'Ranti','847214',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104209,322,'Rashidpur','847229',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104210,322,'Rataul','847403',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104211,322,'Rudrapur (Madhubani)','847411',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104212,322,'Rupauli','847403',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104213,322,'Sagarpur','847239',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104214,322,'Sahar (Madhubani)','847308',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104215,322,'Saini','847402',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104216,322,'Sakri (Madhubani)','847239',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104217,322,'Salempur','847223',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104218,322,'Salempur','847234',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104219,322,'Sangi','847402',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104220,322,'Sankorthu','847424',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104221,322,'Sanpatahi','847401',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104222,322,'Sant Nagar','847404',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104223,322,'Sapta','847214',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104224,322,'Sarabe Tarapatti','847228',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104225,322,'Sarauti','847402',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104226,322,'Sarisavpahi','847424',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104227,322,'Satghara','847224',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104228,322,'Saurath','847213',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104229,322,'Seli Beli','847226',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104230,322,'Selra','847228',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104231,322,'Shahpur','847102',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104232,322,'Shahpur','847231',1,0,'2022-03-03 13:20:20','2022-03-03 13:20:20'),(104233,322,'Shambhuar','847234',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104234,322,'Shibipatti','847215',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104235,322,'Shivnagar','847102',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104236,322,'Shubhankarpur','847213',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104237,322,'Shyamsidhap','847235',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104238,322,'Sidhap Kalan','847226',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104239,322,'Sidhhap Parsahi','847232',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104240,322,'Sijaulia','847409',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104241,322,'Siktiahi','847227',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104242,322,'Simra','847404',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104243,322,'Simri','847235',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104244,322,'Simri','847222',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104245,322,'Siriapur','847230',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104246,322,'Sirkharia','847109',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104247,322,'Sirpurhati','847212',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104248,322,'Siswabarhi','847409',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104249,322,'Siswabazar','847409',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104250,322,'Sohroul','847223',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104251,322,'Sonai','847308',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104252,322,'Sonre','847410',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104253,322,'Sothgaon','847240',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104254,322,'Sudairatauli','847402',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104255,322,'Sugapatti','847409',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104256,322,'Sugauna','847235',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104257,322,'Sukhet','847404',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104258,322,'Sunder Virajit','847408',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104259,322,'Suriahi Ramnagar','847409',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104260,322,'Tamuria','847410',1,0,'2022-03-03 13:20:21','2022-03-03 13:20:21'),(104261,322,'Taraiya','847102',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104262,322,'Tardiha','847408',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104263,322,'Tazpur','847109',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104264,322,'Teghra','847227',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104265,322,'Tengraha','847408',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104266,322,'Tengrar','847409',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104267,322,'Thahar','847228',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104268,322,'Tharhi','847401',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104269,322,'Tharhi Sidhhap','847232',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104270,322,'Tilath','847402',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104271,322,'Tirhuta','847224',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104272,322,'Tisi Narsam','847223',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104273,322,'Tulapatganj','847109',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104274,322,'Uchhal','847226',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104275,322,'Udaypur Bithwar','847231',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104276,322,'Umari','847403',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104277,322,'Umgaon kothi','847240',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104278,322,'Usarahi Deodha','847226',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104279,322,'Uttra','847308',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104280,322,'Vijai','847404',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104281,323,'Amaiya','813201',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104282,323,'Asarganj','813201',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104283,323,'Barhouuia','813103',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104284,323,'Barhvia','813221',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104285,323,'Bath','813201',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104286,323,'Beldiha','813207',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104287,323,'Bhagalpur Devgaon','813221',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104288,323,'Bhikhadih','813212',1,0,'2022-03-03 13:20:22','2022-03-03 13:20:22'),(104289,323,'Chatmadih','813201',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104290,323,'Chorgaon','813201',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104291,323,'Dadri','813212',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104292,323,'Darha','813212',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104293,323,'Dumaria','813212',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104294,323,'Durmalta','813221',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104295,323,'Gerua','813212',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104296,323,'Golni Kusaha','813221',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104297,323,'Gonai','813201',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104298,323,'Harpur','813221',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104299,323,'Kadrachak','813211',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104300,323,'Kahua','813221',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104301,323,'Karaharia','813201',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104302,323,'Khabra','813212',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104303,323,'Kumri','813212',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104304,323,'Lakhanpur','813201',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104305,323,'Launaparsa','813221',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104306,323,'Madhochih','813221',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104307,323,'Majhgain','813221',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104308,323,'Makwa','813201',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104309,323,'Mamai','813201',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104310,323,'Mauikpur','813221',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104311,323,'Mohanpur','853204',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104312,323,'Muskipur','813201',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104313,323,'Nowgain','813221',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104314,323,'Parwara','813221',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104315,323,'Ramgram','813221',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104316,323,'Raugaon','813110',1,0,'2022-03-03 13:20:23','2022-03-03 13:20:23'),(104317,323,'Sahora','813221',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104318,323,'Sishua','813221',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104319,323,'Supour','813221',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104320,323,'Tarapur (Munger)','813221',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104321,323,'Thilkulia','813212',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104322,323,'Agrahan','811211',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104323,323,'Amari','811212',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104324,323,'B M Tola','811202',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104325,323,'Baha Chowki','811202',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104326,323,'Banhara','811213',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104327,323,'Bank Harpur','811202',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104328,323,'Barhauna','811213',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104329,323,'Bariarpur (Munger)','811211',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104330,323,'Barmasia','811212',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104331,323,'Basudeopur','811202',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104332,323,'Belan Bazar','811201',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104333,323,'Benigir','811202',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104334,323,'Bhadaura','811211',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104335,323,'Bhalar','811212',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104336,323,'Bichhichanchar','811213',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104337,323,'Binda Diyara','811211',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104338,323,'Dariapur','811213',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104339,323,'Dariayapur','811202',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104340,323,'Dharhara (Munger)','811212',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104341,323,'Ekashi','811211',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104342,323,'Farda','811202',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104343,323,'Ganga Darshan','811201',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104344,323,'Gangata More','811213',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104345,323,'Gaurab Dih','811213',1,0,'2022-03-03 13:20:24','2022-03-03 13:20:24'),(104346,323,'Ghorghat','811211',1,0,'2022-03-03 13:20:25','2022-03-03 13:20:25'),(104347,323,'Gobadda','811213',1,0,'2022-03-03 13:20:25','2022-03-03 13:20:25'),(104348,323,'Halimpur','811214',1,0,'2022-03-03 13:20:25','2022-03-03 13:20:25'),(104349,323,'Haweli Kharagpur','811213',1,0,'2022-03-03 13:20:25','2022-03-03 13:20:25'),(104350,323,'Heru Diyara','811202',1,0,'2022-03-03 13:20:25','2022-03-03 13:20:25'),(104351,323,'Ithari','811214',1,0,'2022-03-03 13:20:25','2022-03-03 13:20:25'),(104352,323,'Itwa','811212',1,0,'2022-03-03 13:20:25','2022-03-03 13:20:25'),(104353,323,'J. Nagar','811202',1,0,'2022-03-03 13:20:25','2022-03-03 13:20:25'),(104354,323,'Jamalpur (Munger)','811214',1,0,'2022-03-03 13:20:25','2022-03-03 13:20:25'),(104355,323,'Jamalpur Work Shop Ed So','811201',1,0,'2022-03-03 13:20:25','2022-03-03 13:20:25'),(104356,323,'Jankinagar','811211',1,0,'2022-03-03 13:20:25','2022-03-03 13:20:25'),(104357,323,'K Shampur','811211',1,0,'2022-03-03 13:20:25','2022-03-03 13:20:25'),(104358,323,'Kalarampur','811211',1,0,'2022-03-03 13:20:25','2022-03-03 13:20:25'),(104359,323,'Kalyanpur','811211',1,0,'2022-03-03 13:20:25','2022-03-03 13:20:25'),(104360,323,'Kendua','811213',1,0,'2022-03-03 13:20:25','2022-03-03 13:20:25'),(104361,323,'Khaira','811213',1,0,'2022-03-03 13:20:25','2022-03-03 13:20:25'),(104362,323,'Khaira Doray','811213',1,0,'2022-03-03 13:20:25','2022-03-03 13:20:25'),(104363,323,'Kharia','811211',1,0,'2022-03-03 13:20:25','2022-03-03 13:20:25'),(104364,323,'Kutlupur','811202',1,0,'2022-03-03 13:20:25','2022-03-03 13:20:25'),(104365,323,'L. Laxmipur','811213',1,0,'2022-03-03 13:20:25','2022-03-03 13:20:25'),(104366,323,'Lagma','811213',1,0,'2022-03-03 13:20:25','2022-03-03 13:20:25'),(104367,323,'Lahauta Ghatwari','811212',1,0,'2022-03-03 13:20:25','2022-03-03 13:20:25'),(104368,323,'Lal Darwaza (Munger)','811201',1,0,'2022-03-03 13:20:25','2022-03-03 13:20:25'),(104369,323,'Lohchi','811211',1,0,'2022-03-03 13:20:25','2022-03-03 13:20:25'),(104370,323,'Maheshpur','811211',1,0,'2022-03-03 13:20:25','2022-03-03 13:20:25'),(104371,323,'Mangarh','811212',1,0,'2022-03-03 13:20:25','2022-03-03 13:20:25'),(104372,323,'Manjhgay','811213',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104373,323,'Munger College','811201',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104374,323,'Munger Fort','811201',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104375,323,'Munger H.O','811201',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104376,323,'Munger Town','811201',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104377,323,'Muzaffarganj','811213',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104378,323,'N.D.Road Munger','811201',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104379,323,'Nawagarhi','811211',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104380,323,'Orabagicha','811212',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104381,323,'Parsando','811213',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104382,323,'Pattam','811214',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104383,323,'Purab Sarai','811201',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104384,323,'Purshotampur','811211',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104385,323,'R C.Maidan','811213',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104386,323,'Raja Dih','811213',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104387,323,'Ramankabad','811213',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104388,323,'Ramgarh','811311',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104389,323,'Ratanpur','811211',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104390,323,'Rathaitha','811213',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104391,323,'Sadar Bazar Jamalpur','811214',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104392,323,'Sadobh','811213',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104393,323,'Safiabad','811214',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104394,323,'Sarobagh','811214',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104395,323,'Shankarpur','811202',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104396,323,'Shiv Kund','811202',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104397,323,'Shivpur Logain','811213',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104398,323,'Singhia','811202',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104399,323,'Taufir','811202',1,0,'2022-03-03 13:20:26','2022-03-03 13:20:26'),(104400,323,'Teghara','811213',1,0,'2022-03-03 13:20:27','2022-03-03 13:20:27'),(104401,323,'Tetia Bambar','811213',1,0,'2022-03-03 13:20:27','2022-03-03 13:20:27'),(104402,323,'Tikarampur','811202',1,0,'2022-03-03 13:20:27','2022-03-03 13:20:27'),(104403,323,'Tola Bangalwa','811212',1,0,'2022-03-03 13:20:27','2022-03-03 13:20:27'),(104404,323,'Zamin Degree','811202',1,0,'2022-03-03 13:20:27','2022-03-03 13:20:27'),(104405,324,'Balour','847107',1,0,'2022-03-03 13:20:27','2022-03-03 13:20:27'),(104406,324,'Baruary','847107',1,0,'2022-03-03 13:20:27','2022-03-03 13:20:27'),(104407,324,'Benibad','847107',1,0,'2022-03-03 13:20:27','2022-03-03 13:20:27'),(104408,324,'Gaighat','847107',1,0,'2022-03-03 13:20:27','2022-03-03 13:20:27'),(104409,324,'Janta','847107',1,0,'2022-03-03 13:20:27','2022-03-03 13:20:27'),(104410,324,'K.Pirochha','847107',1,0,'2022-03-03 13:20:27','2022-03-03 13:20:27'),(104411,324,'Keotsa Baruari','847107',1,0,'2022-03-03 13:20:27','2022-03-03 13:20:27'),(104412,324,'Lakhanpur','847307',1,0,'2022-03-03 13:20:27','2022-03-03 13:20:27'),(104413,324,'Laxman Nagar','847107',1,0,'2022-03-03 13:20:27','2022-03-03 13:20:27'),(104414,324,'Maheshwara','847107',1,0,'2022-03-03 13:20:27','2022-03-03 13:20:27'),(104415,324,'Seodaha Barail','847107',1,0,'2022-03-03 13:20:27','2022-03-03 13:20:27'),(104416,324,'Susta','847107',1,0,'2022-03-03 13:20:27','2022-03-03 13:20:27'),(104417,324,'A.Bishanpur','843113',1,0,'2022-03-03 13:20:27','2022-03-03 13:20:27'),(104418,324,'A.Purushotampur','842002',1,0,'2022-03-03 13:20:27','2022-03-03 13:20:27'),(104419,324,'Adigopalpur','843118',1,0,'2022-03-03 13:20:27','2022-03-03 13:20:27'),(104420,324,'Aghoria Bazaar','842002',1,0,'2022-03-03 13:20:27','2022-03-03 13:20:27'),(104421,324,'Ahiyapur','843125',1,0,'2022-03-03 13:20:27','2022-03-03 13:20:27'),(104422,324,'Ajna Kot','843111',1,0,'2022-03-03 13:20:27','2022-03-03 13:20:27'),(104423,324,'Alinagar Leorhan','843104',1,0,'2022-03-03 13:20:27','2022-03-03 13:20:27'),(104424,324,'Amaitha','843123',1,0,'2022-03-03 13:20:27','2022-03-03 13:20:27'),(104425,324,'Amarakh','843119',1,0,'2022-03-03 13:20:27','2022-03-03 13:20:27'),(104426,324,'Amgola','842001',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104427,324,'Amma','843103',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104428,324,'Amnaur','843129',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104429,324,'Anant Kamtaul','844120',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104430,324,'Athar','843118',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104431,324,'Atrar','843129',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104432,324,'Aura','843128',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104433,324,'Aurai (Muzaffarpur)','843312',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104434,324,'Azizpur','844120',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104435,324,'B.','mahanand',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104436,324,'B.Baghnagari','843105',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104437,324,'B.Bajitpur','843111',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104438,324,'B.Bakhari','843121',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104439,324,'B.Barna','843111',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104440,324,'B.Basudeo','843117',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104441,324,'B.Factory','842004',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104442,324,'B.Firoj','843111',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104443,324,'B.Kalyan','843125',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104444,324,'B.Karman','843111',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104445,324,'B.Kesho','843109',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104446,324,'B.Kesho','843118',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104447,324,'B.M.P-VI','842001',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104448,324,'B.Muza','843120',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104449,324,'B.Nijamat','843125',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104450,324,'B.Pandey','843109',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104451,324,'B.Rudal','843111',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104452,324,'B.Umapat Basant','843117',1,0,'2022-03-03 13:20:28','2022-03-03 13:20:28'),(104453,324,'Baburban Tajpur','843127',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104454,324,'Baghakhal','843103',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104455,324,'Baghi (Muzaffarpur)','844112',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104456,324,'Bahdinpur','843112',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104457,324,'Bajitpur','843123',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104458,324,'Bakatpur','843111',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104459,324,'Bakhari','843111',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104460,324,'Bakhra','843101',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104461,324,'Balaur','844120',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104462,324,'Balra Ismail','844112',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104463,324,'Balthi Mushahari','843118',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104464,324,'Balthi Narhar','843125',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104465,324,'Bandpura','843321',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104466,324,'Bandra','843115',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104467,324,'Bara Daud','843112',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104468,324,'Baraitha','843321',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104469,324,'Barhad','843129',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104470,324,'Barhanda','843128',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104471,324,'Bariarpur Karpur','843115',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104472,324,'Bariarpur (Muzaffarpur)','843102',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104473,324,'Barjee','843111',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104474,324,'Baruraj','843111',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104475,324,'Basara Shukul','843123',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104476,324,'Basatpur','843125',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104477,324,'Basauli','844127',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104478,324,'Bashantpur Patti','843101',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104479,324,'Basua','843321',1,0,'2022-03-03 13:20:29','2022-03-03 13:20:29'),(104480,324,'Basudeo Sarai','843125',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104481,324,'Bedaul Asli','843117',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104482,324,'Beladam','843105',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104483,324,'Berai','843129',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104484,324,'Berua','843122',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104485,324,'Bhadai','843117',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104486,324,'Bhagwanpur','843120',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104487,324,'Bhagwanpur','844120',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104488,324,'Bhagwatpur','843120',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104489,324,'Bhalura','843312',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104490,324,'Bhartipur','843104',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104491,324,'Bharwari (MuzaffarpB.O','843119',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104492,324,'Bhatauna','843113',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104493,324,'Bihar University','842001',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104494,324,'Binda','843119',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104495,324,'Birihma Bazar','843127',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104496,324,'Birpur','843109',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104497,324,'Bishundatpur','843113',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104498,324,'Bishunpur Patti','843125',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104499,324,'Bochaha','843103',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104500,324,'Brahampura','842003',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104501,324,'Brahmapura','843104',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104502,324,'Brindawan','843128',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104503,324,'Budhnagra Radha','843119',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104504,324,'Ch. Harishankar','844127',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104505,324,'Chahuta','843312',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104506,324,'Chainpur','843119',1,0,'2022-03-03 13:20:30','2022-03-03 13:20:30'),(104507,324,'Chainpur Bangra','843119',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104508,324,'Chak Sarmastpur','843104',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104509,324,'Chak Shambhu','843117',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104510,324,'Chakna','843126',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104511,324,'Chakwaja Nagma','844120',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104512,324,'Chamarua','843113',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104513,324,'Chandanpatti','843104',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104514,324,'Chandrahatti','844120',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104515,324,'Chapra Dharampur Jaddu','843108',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104516,324,'Chapra Megh','843119',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104517,324,'Charhua','844127',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104518,324,'Chatursi','843128',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104519,324,'Chhap','843107',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104520,324,'Chhata Bazar (Muzaffarpur)','842001',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104521,324,'Chhatauni','843128',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104522,324,'Chhitrauli','843119',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104523,324,'Chiraila','843118',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104524,324,'Chochahi Chapra','843122',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104525,324,'Chochahi Saraiya','843112',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104526,324,'Chorghatta','843111',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104527,324,'Choubey Ambara','843101',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104528,324,'Choumukh','843103',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104529,324,'CRPF Camp','842004',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104530,324,'D.A.College','843121',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104531,324,'D.R.Sah','842002',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104532,324,'Dahila','843103',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104533,324,'Dakrama','843117',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104534,324,'Damodarpur','843113',1,0,'2022-03-03 13:20:31','2022-03-03 13:20:31'),(104535,324,'Dargah Bela','843104',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104536,324,'Dariyapur Kafen','844127',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104537,324,'Daud Chapra','842004',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104538,324,'Daudpur','843107',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104539,324,'Dehuli Buzurg','843104',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104540,324,'Deoria (Muzaffarpur)','843120',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104541,324,'Dhanaiya','843120',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104542,324,'Dhanaur','843321',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104543,324,'Dharampur','843117',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104544,324,'Dharfari','843120',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104545,324,'Dholi','843105',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104546,324,'Dih Jiwar','843117',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104547,324,'Dubaha Buzurg','843104',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104548,324,'Dubiahi','843106',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104549,324,'Dumari','843119',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104550,324,'Fateha','843124',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104551,324,'Fatehabad','843107',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104552,324,'G.Dharampur','843128',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104553,324,'G.K.Nagar','843102',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104554,324,'G.Pitaunjhia','843117',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104555,324,'Gangeya','843321',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104556,324,'Ganiari','843119',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104557,324,'Gaus Nagar','843117',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104558,324,'Geyaspur','843107',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104559,324,'Gharbhara','843103',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104560,324,'Ghosaut','843128',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104561,324,'Ghosrama','843115',1,0,'2022-03-03 13:20:32','2022-03-03 13:20:32'),(104562,324,'Gidha','843106',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104563,324,'Ginjas','843123',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104564,324,'Girigama Dih','844120',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104565,324,'Godanpatti','843118',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104566,324,'Gokhula Rupauli','843120',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104567,324,'Gopalpur Neora','843126',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104568,324,'Gorigama','843117',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104569,324,'Govindpur Bejha','843105',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104570,324,'Govindpur Bela','843105',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104571,324,'H.Khanpur','843129',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104572,324,'H.Manshahi','843128',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104573,324,'Hanswara','843117',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104574,324,'Hardi (Muzaffarpur)','843122',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104575,324,'Haridaspur','843109',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104576,324,'Harkhauli','843321',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104577,324,'Harnahi','843111',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104578,324,'Harser','843128',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104579,324,'Hasna','843103',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104580,324,'Hussepur','843125',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104581,324,'I.R.Nagar','843121',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104582,324,'Ibrahimpur','843118',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104583,324,'Imlichatti','842001',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104584,324,'Jagdishpur','843125',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104585,324,'Jagdishpur Baghnagari','843119',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104586,324,'Jaimal Dumari','843107',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104587,324,'Jaintpur Estate','843123',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104588,324,'Jalalpur','843119',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104589,324,'Jamalabad','842004',1,0,'2022-03-03 13:20:33','2022-03-03 13:20:33'),(104590,324,'Jamalpur','843124',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104591,324,'Jamin Mathia','843109',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104592,324,'Janar','843117',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104593,324,'Jarang Deorhi','843118',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104594,324,'Jasauli','843111',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104595,324,'Jasoda Math','843111',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104596,324,'Jhapaha','842004',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104597,324,'Jhikati','844127',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104598,324,'Jhingaha','843111',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104599,324,'Jita Chapra','843127',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104600,324,'K.Babhangaon','843112',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104601,324,'K.Bithraul','843111',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104602,324,'K.H.Ramani','843109',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104603,324,'K.Madhuban','844127',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104604,324,'K.Mohan','844127',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104605,324,'Kabilpur','843109',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104606,324,'Kachhi Sarai','842002',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104607,324,'Kafen','843103',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104608,324,'Kalwari (Muzaffarpur)','843108',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104609,324,'Kalyani','842001',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104610,324,'Kalyanpur','843107',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104611,324,'Kamalpura','843101',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104612,324,'Kamarthu','843118',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104613,324,'Kanhara','843118',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104614,324,'Kanhauli Azra','842002',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104615,324,'Kanti','843109',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104616,324,'Kanti T.P.S.','843130',1,0,'2022-03-03 13:20:34','2022-03-03 13:20:34'),(104617,324,'Karamwari','843107',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104618,324,'Karja','843106',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104619,324,'Karja','843143',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104620,324,'Katesar','843102',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104621,324,'Kathaiya','843124',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104622,324,'Katra (Muzaffarpur)','843321',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104623,324,'Kerma','844127',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104624,324,'Keshopur','843104',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104625,324,'Khabra','843146',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104626,324,'Khangura','843321',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104627,324,'Kharauna','843113',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104628,324,'Kharhar','843117',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104629,324,'Khutahi','843107',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104630,324,'Kinaru','844127',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104631,324,'Kodaria','843128',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104632,324,'Kokilwara','843312',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104633,324,'Kolwara','843123',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104634,324,'Koria Nizamat','843112',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104635,324,'Korlahia Mansingh','843117',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104636,324,'Krishnawara','843104',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104637,324,'Kurhani','844120',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104638,324,'Kurnowl','843125',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104639,324,'Ladaura Pakari','843113',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104640,324,'Laloo Chapra','843126',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104641,324,'Lautan','843117',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104642,324,'Lohsari','843103',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104643,324,'Loma','843118',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104644,324,'M.Badal','843119',1,0,'2022-03-03 13:20:35','2022-03-03 13:20:35'),(104645,324,'M.Balmi','843111',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104646,324,'M.Farakpur','843117',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104647,324,'M.Gopinathpur','843111',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104648,324,'M.Hazari','843125',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104649,324,'M.I.C.','842005',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104650,324,'M.I.T.','842003',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104651,324,'M.Pachdahi','843119',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104652,324,'M.Susta','843119',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104653,324,'Machhahi','843105',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104654,324,'Madhaul','843101',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104655,324,'Madhopur','843119',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104656,324,'Madhubani','843125',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104657,324,'Mahanth Maniari','843119',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104658,324,'Mahartha','843109',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104659,324,'Mahdaiya','843128',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104660,324,'Mahindwara','843117',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104661,324,'Mahmada','843111',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104662,324,'Mahual R.S.','843111',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104663,324,'Maithi','843118',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104664,324,'Majhaulia','843104',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104665,324,'Maksudpur','843117',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104666,324,'Malighat Maniari','842001',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104667,324,'Malpur Agrail','843104',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104668,324,'Malpur','843103',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104669,324,'Manain','843125',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104670,324,'Manika','843119',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104671,324,'Manohar Chapra','843111',1,0,'2022-03-03 13:20:36','2022-03-03 13:20:36'),(104672,324,'Manpur Ratnauli','843117',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104673,324,'Mansoorpur','843101',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104674,324,'Maripur','842003',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104675,324,'Markan','843119',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104676,324,'Marwan','843119',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104677,324,'Marwan','843113',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104678,324,'Mathna Mallik','844112',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104679,324,'Matihani','843117',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104680,324,'Meghua','843128',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104681,324,'Mehshi','843105',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104682,324,'Minapur','843128',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104683,324,'Mirapur','843121',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104684,324,'Mirzapur','843103',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104685,324,'Mohabatpur','843120',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104686,324,'Mohamadpur','843120',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104687,324,'Mohjama','843107',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104688,324,'Morsandi','843111',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104689,324,'Motijheel (Muzaffarpur)','842001',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104690,324,'Motipur','843111',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104691,324,'Munni Bangari','843115',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104692,324,'Mushahari Farm','842002',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104693,324,'Mustafaganj','843128',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104694,324,'Mustafapur','842004',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104695,324,'Mutlupur','843115',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104696,324,'Muz. Collectorate','842001',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104697,324,'Muza Patrahia','843126',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104698,324,'Muzaffarpur Court','842001',1,0,'2022-03-03 13:20:37','2022-03-03 13:20:37'),(104699,324,'Muzaffarpur H.O','842001',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104700,324,'N.Champapur','843104',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104701,324,'Narauli','843119',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104702,324,'Nariar Panapur','843109',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104703,324,'Narma','843129',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104704,324,'Narsinghpur','842002',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104705,324,'Narsinghpur','843105',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104706,324,'Narwara','843128',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104707,324,'Naya Tola (MuzaffarpB.O','842002',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104708,324,'Neknampur','843120',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104709,324,'Newa Nagar','843102',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104710,324,'Newachak','843102',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104711,324,'Noonfara','843115',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104712,324,'Olipur Sarhachia','843117',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104713,324,'P.Basarat','843120',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104714,324,'P.Bishanpur','843115',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104715,324,'P.Kolhua','843108',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104716,324,'P.Mushahari','843124',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104717,324,'P.Shyam','843103',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104718,324,'P.T.Jiwar','843129',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104719,324,'Pagahia Aima','843122',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104720,324,'Pahsaul','843321',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104721,324,'Paigambarpur','843119',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104722,324,'Pakari Pakohi','843113',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104723,324,'Pakhnaha Shriram','843109',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104724,324,'Pakki Sarai','842001',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104725,324,'Pana Chapra','843111',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104726,324,'Panapur Akhtiarpur','843123',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104727,324,'Panapur Kariat','843109',1,0,'2022-03-03 13:20:38','2022-03-03 13:20:38'),(104728,324,'Paraspatti','843125',1,0,'2022-03-03 13:20:39','2022-03-03 13:20:39'),(104729,324,'Paroo','843112',1,0,'2022-03-03 13:20:39','2022-03-03 13:20:39'),(104730,324,'Parsauni Nath','843127',1,0,'2022-03-03 13:20:39','2022-03-03 13:20:39'),(104731,324,'Parsauni Nath','843125',1,0,'2022-03-03 13:20:39','2022-03-03 13:20:39'),(104732,324,'Parsauni Pagahia','843122',1,0,'2022-03-03 13:20:39','2022-03-03 13:20:39'),(104733,324,'Partapur','843106',1,0,'2022-03-03 13:20:39','2022-03-03 13:20:39'),(104734,324,'Patahi (Muzaffarpur)','843113',1,0,'2022-03-03 13:20:39','2022-03-03 13:20:39'),(104735,324,'Patsara','843115',1,0,'2022-03-03 13:20:39','2022-03-03 13:20:39'),(104736,324,'Patti Aswari','843124',1,0,'2022-03-03 13:20:39','2022-03-03 13:20:39'),(104737,324,'Phular','843107',1,0,'2022-03-03 13:20:39','2022-03-03 13:20:39'),(104738,324,'Phulwaria','843107',1,0,'2022-03-03 13:20:39','2022-03-03 13:20:39'),(104739,324,'Piar','843115',1,0,'2022-03-03 13:20:39','2022-03-03 13:20:39'),(104740,324,'Pilkhi Gajpatti','843121',1,0,'2022-03-03 13:20:39','2022-03-03 13:20:39'),(104741,324,'Pindauli','843321',1,0,'2022-03-03 13:20:39','2022-03-03 13:20:39'),(104742,324,'Pipra Asli','843109',1,0,'2022-03-03 13:20:39','2022-03-03 13:20:39'),(104743,324,'Pirapur','843115',1,0,'2022-03-03 13:20:39','2022-03-03 13:20:39'),(104744,324,'Pitaunjhia','843117',1,0,'2022-03-03 13:20:39','2022-03-03 13:20:39'),(104745,324,'Prahladpur','843119',1,0,'2022-03-03 13:20:39','2022-03-03 13:20:39'),(104746,324,'Purani Bazar','842001',1,0,'2022-03-03 13:20:39','2022-03-03 13:20:39'),(104747,324,'R.D.S.College','842002',1,0,'2022-03-03 13:20:39','2022-03-03 13:20:39'),(104748,324,'R.K.Ashram','842002',1,0,'2022-03-03 13:20:39','2022-03-03 13:20:39'),(104749,324,'R.K.Malahi','843126',1,0,'2022-03-03 13:20:39','2022-03-03 13:20:39'),(104750,324,'R.Saghari','843312',1,0,'2022-03-03 13:20:39','2022-03-03 13:20:39'),(104751,324,'Raghai','843128',1,0,'2022-03-03 13:20:39','2022-03-03 13:20:39'),(104752,324,'Raghunathpur','843126',1,0,'2022-03-03 13:20:39','2022-03-03 13:20:39'),(104753,324,'Raini','843121',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104754,324,'Raja Pakar','843102',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104755,324,'Raja Rampur','843126',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104756,324,'Rajala','844120',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104757,324,'Rajepur','843111',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104758,324,'Rajkhand','843312',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104759,324,'Rajwara','843125',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104760,324,'Raksha','843109',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104761,324,'Ram Nagar','843103',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104762,324,'Ramna (Muzaffarpur)','842002',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104763,324,'Rampur Bheriahi','843122',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104764,324,'Rampur Dayal','843115',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104765,324,'Rampur Hari','843117',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104766,324,'Rampur Mina','843127',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104767,324,'Ratnauli','844127',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104768,324,'Ratwara','843115',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104769,324,'Ratwara Bindwara','843312',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104770,324,'Repura Mahadeo','843107',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104771,324,'Repura R.Bishwanath','843123',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104772,324,'Rewa Basantpur','843101',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104773,324,'Rup Chapra','843125',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104774,324,'Rupauli','843106',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104775,324,'S.Barkagaon','843109',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104776,324,'S.Jahangirpur','843111',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104777,324,'S.Muraul','843121',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104778,324,'S.S.K.Bhawan','842001',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104779,324,'S.Sandha','843111',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104780,324,'Sadiquepur','843109',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104781,324,'Sagahari','843128',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104782,324,'Sahbajpur Puraina','843102',1,0,'2022-03-03 13:20:40','2022-03-03 13:20:40'),(104783,324,'Sahi Minapur','843312',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104784,324,'Sahpur Maricha','844112',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104785,324,'Sahpurpatti','843120',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104786,324,'Sainpatti S.P.Singh','843109',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104787,324,'Sakari Saraiya','844127',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104788,324,'Sakarwara','843118',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104789,324,'Sanathi','843103',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104790,324,'Sangopatti','843119',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104791,324,'Saraiya','843127',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104792,324,'Saraiya','843119',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104793,324,'Saraiya Bazar','843112',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104794,324,'Saraiya Factory','843126',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104795,324,'Saraiyaganj','842001',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104796,324,'Sarfuddinpur','843118',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104797,324,'Sarhachia','843117',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104798,324,'Sarmastpur','843107',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104799,324,'Sarwarpur','843128',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104800,324,'Shahila Balli','843129',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104801,324,'Shahila Rampur','843129',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104802,324,'Sheikhpur','842002',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104803,324,'Shirsia Jagdish','843127',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104804,324,'Shitalpatti','843128',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104805,324,'Shivdaspur','843321',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104806,324,'Shrikant','843115',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104807,324,'Siho','843119',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104808,324,'Sikandarpur (Muzaffarpur)','842001',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104809,324,'Silout','843119',1,0,'2022-03-03 13:20:41','2022-03-03 13:20:41'),(104810,324,'Simra Urf Afzalpur','843113',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104811,324,'Singar','843109',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104812,324,'Sirkhiria','843117',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104813,324,'Sirkohia','843123',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104814,324,'Sirsia Buzurg','843108',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104815,324,'Siwaipatti','843128',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104816,324,'Sohansa','843120',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104817,324,'Sonbarsa','843128',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104818,324,'Sonbarsa Dih','843119',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104819,324,'Sonepur','843321',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104820,324,'Subhaigarh','843117',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104821,324,'Subhankarpur','843113',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104822,324,'Sundar Sarai','843111',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104823,324,'Sundarpur','843102',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104824,324,'Susta','842002',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104825,324,'Tarawa','843125',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104826,324,'Tengraha','843117',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104827,324,'Tengrari','843128',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104828,324,'Tepari','843115',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104829,324,'Thikaha Basudeo','843124',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104830,324,'Titra Ashanand','843105',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104831,324,'Tola Muza','843120',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104832,324,'Turki Khararu','843128',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104833,324,'Turki','844127',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104834,324,'Umanagar','842004',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104835,324,'Unsar','843103',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104836,324,'Bahilwara Bhual','844111',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104837,324,'Bahilwara Govind','844111',1,0,'2022-03-03 13:20:42','2022-03-03 13:20:42'),(104838,324,'Bahilwara Roopnath','844111',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104839,324,'Garahua','844118',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104840,324,'Kheshramadih','844118',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104841,324,'Padmaul','844118',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104842,325,'Amawan','811101',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104843,325,'Chakdin','811103',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104844,325,'Chero','811104',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104845,325,'Dhanuki','811101',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104846,325,'Esuwa','811102',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104847,325,'Gilani','811101',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104848,325,'Gopalbad','811104',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104849,325,'Husaina','811104',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104850,325,'Ibrahimpur','811101',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104851,325,'Kenar Kalan','811101',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104852,325,'Malwa','811101',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104853,325,'Mirnagar','811104',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104854,325,'Mohani','811101',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104855,325,'Pyarepur','811104',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104856,325,'Ramnathpur','811104',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104857,325,'Sadarpur','811101',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104858,325,'Sahari','811104',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104859,325,'Sarmera','811104',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104860,325,'Sasaur','811102',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104861,325,'Singhaul','811102',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104862,325,'Ugaban','811103',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104863,325,'Aatma','801303',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104864,325,'Abdachak','803107',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104865,325,'Ajanaura','803114',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104866,325,'Ajaypur','803120',1,0,'2022-03-03 13:20:43','2022-03-03 13:20:43'),(104867,325,'Akair','801305',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104868,325,'Akbarpur','801302',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104869,325,'Alawan','803114',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104870,325,'Alinagar','803101',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104871,325,'Amba','803119',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104872,325,'Amber','803101',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104873,325,'Amraura','801307',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104874,325,'Andhana','803113',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104875,325,'Andi','803107',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104876,325,'Ant','803114',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104877,325,'Arai Benipur','801305',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104878,325,'Arjunsarthuya','801303',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104879,325,'Ashanagar','803118',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104880,325,'Asharhi','801302',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104881,325,'Ashrafpur','801305',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104882,325,'Asta','803120',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104883,325,'Asthawan','803107',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104884,325,'Aungari','801301',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104885,325,'Babhanbarui','801302',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104886,325,'Badarbali','803110',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104887,325,'Badhauna','803108',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104888,325,'Bahapar','801304',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104889,325,'Bajitpur Khiruti','801301',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104890,325,'Bajitpur Mudhari','803110',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104891,325,'Bali Belchi','803110',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104892,325,'Banarsibigha','803117',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104893,325,'Bangpur','803114',1,0,'2022-03-03 13:20:44','2022-03-03 13:20:44'),(104894,325,'Bansdih','801307',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104895,325,'Bara','803117',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104896,325,'Barah','803110',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104897,325,'Barahgawan','801303',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104898,325,'Barai','801303',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104899,325,'Barakhurd','803113',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104900,325,'Barandi','803119',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104901,325,'Barara','803118',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104902,325,'Bardih','801303',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104903,325,'Bargaon','803111',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104904,325,'Barnausha','803116',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104905,325,'Basniwan','803110',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104906,325,'Baswanbigha','803216',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104907,325,'Belchi Sharif','803107',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104908,325,'Bele','801303',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104909,325,'Ben','803114',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104910,325,'Bena','803110',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104911,325,'Besai Bigha','801301',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104912,325,'Beshwak','801303',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104913,325,'Bhadru','803108',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104914,325,'Bhagan Bigha','803118',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104915,325,'Bhandari','803119',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104916,325,'Bhathar','801307',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104917,325,'Bheria','803113',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104918,325,'Bhobhi','801302',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104919,325,'Bhoklapar','801302',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104920,325,'Bhui','803117',1,0,'2022-03-03 13:20:45','2022-03-03 13:20:45'),(104921,325,'Biharsharif H.O','803101',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104922,325,'Bind','803107',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104923,325,'Birju Milki','803110',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104924,325,'Bodhibigharamghat','801305',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104925,325,'Borhog','803107',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104926,325,'Borisarai','801303',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104927,325,'Chamarbigha','801302',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104928,325,'Chandhari','801303',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104929,325,'Chandi','803108',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104930,325,'Chandoura','803119',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104931,325,'Charuipar','803113',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104932,325,'Chero','803110',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104933,325,'Chhabilapur','803216',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104934,325,'Chhariari Bujurg','801307',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104935,325,'Chhatiana','803110',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104936,325,'Chiksoura','801302',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104937,325,'Chorsua','803115',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104938,325,'Choti Chariari','803120',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104939,325,'Dahabigha','801302',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104940,325,'Dahpar Sargaon','803114',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104941,325,'Daily','803110',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104942,325,'Damodarpur Waldha','801305',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104943,325,'Daniawan Pendapur','801301',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104944,325,'Dariyapur','801303',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104945,325,'Daruara','803216',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104946,325,'Dayalpur','803108',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104947,325,'Deepnagar','803111',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104948,325,'Desna','803107',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104949,325,'Dhangawan','801301',1,0,'2022-03-03 13:20:46','2022-03-03 13:20:46'),(104950,325,'Dharahara','803111',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104951,325,'Dharampur','803120',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104952,325,'Dhobdiha','801303',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104953,325,'Diha','803120',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104954,325,'Diyawan','801304',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104955,325,'Doiya','803118',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104956,325,'Dosut','803110',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104957,325,'Dumrawan','803216',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104958,325,'Durgapur','803115',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104959,325,'Durgawan','801301',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104960,325,'Ekangerdih','801301',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104961,325,'Ekangersarai','801301',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104962,325,'Eksara','803114',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104963,325,'Eksari','803117',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104964,325,'Ganpura','803113',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104965,325,'Gaurav Nagar','803114',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104966,325,'Ghorsrawan','803115',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104967,325,'Ghostawan','803117',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104968,325,'Gonawan','803110',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104969,325,'Gonkura','803108',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104970,325,'Gorawan','803117',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104971,325,'Goror','803116',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104972,325,'Gosaimath','803110',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104973,325,'Gunjarchak','803108',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104974,325,'Gurusaranpu','803114',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104975,325,'Habbipur','801301',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104976,325,'Hargawan','803216',1,0,'2022-03-03 13:20:47','2022-03-03 13:20:47'),(104977,325,'Harnaut','803110',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(104978,325,'Hilsa','801302',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(104979,325,'Hussain Pur','803107',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(104980,325,'Ichhos','801303',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(104981,325,'Islampur (Nalanda)','801303',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(104982,325,'Itasang Bhadwa','803119',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(104983,325,'Itaura','803107',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(104984,325,'Jagai','801301',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(104985,325,'Jagatpur','803110',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(104986,325,'Jagdishpur Tiyari','803114',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(104987,325,'Jaitpur','801307',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(104988,325,'Jamsari','803107',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(104989,325,'Jana','803107',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(104990,325,'Jear','803107',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(104991,325,'Juniar','801301',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(104992,325,'Kachcharia','801307',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(104993,325,'Kachiyawan','801302',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(104994,325,'Kaila','803108',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(104995,325,'Kaila','803107',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(104996,325,'Kairi Meyar','803118',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(104997,325,'Kaliyachak','801302',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(104998,325,'Kamta','801302',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(104999,325,'Kanhaiya Ganj','801306',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(105000,325,'Kapsima','801302',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(105001,325,'Karah','803117',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(105002,325,'Karaipersurai','801304',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(105003,325,'Karjara','803117',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(105004,325,'Karubigha','803116',1,0,'2022-03-03 13:20:48','2022-03-03 13:20:48'),(105005,325,'Kathauli','803113',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105006,325,'Kathrahi','803107',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105007,325,'Kawa','801302',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105008,325,'Keshopur','801302',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105009,325,'Khaddi Lodipur','801301',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105010,325,'Khaira','803114',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105011,325,'Khaje Itwar Sarai','803118',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105012,325,'Khapura','801305',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105013,325,'Kharthua','803110',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105014,325,'Khodaganj','801303',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105015,325,'Khojpura','801306',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105016,325,'Khorampur','801303',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105017,325,'Khushiyalpur','801306',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105018,325,'Kobil','801303',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105019,325,'Kochra','801303',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105020,325,'Koklakchak','803113',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105021,325,'Kolawan','803110',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105022,325,'Konand','803107',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105023,325,'Korari','801304',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105024,325,'Korawan','801302',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105025,325,'Koshiyawan','801301',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105026,325,'Kulti','803107',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105027,325,'Lahuar','803116',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105028,325,'Laranpur','803116',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105029,325,'Lohra','803110',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105030,325,'Machhalduhe','803111',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105031,325,'Madanpur','801301',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105032,325,'Madhar','803117',1,0,'2022-03-03 13:20:49','2022-03-03 13:20:49'),(105033,325,'Madhopur','803108',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105034,325,'Mafi','803107',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105035,325,'Maghra','803216',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105036,325,'Mahanandpur','803216',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105037,325,'Mahanandpur','801305',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105038,325,'Mahmuda','801303',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105039,325,'Mahuri','803111',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105040,325,'Mai','801302',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105041,325,'Mai Farida','803119',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105042,325,'Makrauta','801304',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105043,325,'Mallikpur','803117',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105044,325,'Malti','803107',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105045,325,'Mandachh','801306',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105046,325,'Mari','803111',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105047,325,'Merhma','801304',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105048,325,'Meyar','803116',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105049,325,'Mighi Nagma','803111',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105050,325,'Mirchaiganj','803111',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105051,325,'Mirzapur','801302',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105052,325,'Mogalkuan','803118',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105053,325,'Mohammadpur','803107',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105054,325,'Mohiddinpur','801302',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105055,325,'Molanachak','803116',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105056,325,'Molanadih','803116',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105057,325,'Mominpur','801302',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105058,325,'Moratalab','803118',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105059,325,'Mukhtarganj','803116',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105060,325,'Muraura','803216',1,0,'2022-03-03 13:20:50','2022-03-03 13:20:50'),(105061,325,'Murgawan','801303',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105062,325,'Murgawan','803114',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105063,325,'Murgiachak','803110',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105064,325,'Musarhi','801304',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105065,325,'Musepur','803118',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105066,325,'Nagarnausa','801305',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105067,325,'Nahub','803116',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105068,325,'Nailly','803113',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105069,325,'Naima','801306',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105070,325,'Naisarai','803216',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105071,325,'Nalanda College','803101',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105072,325,'Nalanda','803111',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105073,325,'Nanand','803115',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105074,325,'Nanaura','803113',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105075,325,'Narari','803120',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105076,325,'Narayanpur','801306',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105077,325,'Narsanda','803110',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105078,325,'Nehusa','803110',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105079,325,'Nekpur','803116',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105080,325,'Nepura','803115',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105081,325,'Nerut','803107',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105082,325,'Nimthu','803116',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105083,325,'Niriatulsipur','801302',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105084,325,'Nirpur','803111',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105085,325,'Nishchalganj','801301',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105086,325,'Noawan','803107',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105087,325,'NTPC Barh','803215',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105088,325,'Nursarai','803113',1,0,'2022-03-03 13:20:51','2022-03-03 13:20:51'),(105089,325,'Onda','803107',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105090,325,'Ope','801301',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105091,325,'Ordnance Factory Rajgir','803121',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105092,325,'Oriyawan','801301',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105093,325,'Pachauri','803216',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105094,325,'Pachoura','803110',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105095,325,'Palatpura','803107',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105096,325,'Panchlowa','801303',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105097,325,'Panhar','801303',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105098,325,'Parasdiha','801305',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105099,325,'Pariouna','803113',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105100,325,'Paroha','803107',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105101,325,'Parthu','801301',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105102,325,'Parwalpur','803114',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105103,325,'Pasanchi','801301',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105104,325,'Pathana','801303',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105105,325,'Pathraura','803116',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105106,325,'Pawa','803115',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105107,325,'Pawapuri','803115',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105108,325,'Peshaur','803119',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105109,325,'Pillich','803114',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105110,325,'Pirbarhauna','801305',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105111,325,'Pitamberpur','801306',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105112,325,'Poari','803110',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105113,325,'Pratappur','803120',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105114,325,'Puna','801301',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105115,325,'Punha','803119',1,0,'2022-03-03 13:20:52','2022-03-03 13:20:52'),(105116,325,'Pyarepur','803115',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105117,325,'Rahui','803119',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105118,325,'Raipur Koil Bigha','803120',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105119,325,'Raisa','803108',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105120,325,'Rajgir Kund','803116',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105121,325,'Rajgir','803116',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105122,325,'Ramchandrapur','803216',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105123,325,'Ranabigha','803216',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105124,325,'Ranipur','801301',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105125,325,'Rasalpur','803114',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105126,325,'Rasisa','801303',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105127,325,'Rukhai','803108',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105128,325,'Rustampur','801303',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105129,325,'Sabait','803111',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105130,325,'Sabnahua','803110',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105131,325,'Sakraurah','803111',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105132,325,'Sakunat','803101',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105133,325,'Salarpur','801305',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105134,325,'Salempur','801304',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105135,325,'Salepur','801306',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105136,325,'Sanda','801303',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105137,325,'Sarbahadi','803107',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105138,325,'Sare','803107',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105139,325,'Sarthua','803110',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105140,325,'Satnag','803108',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105141,325,'Shankardih','803114',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105142,325,'Silao','803117',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105143,325,'Sinama','803114',1,0,'2022-03-03 13:20:53','2022-03-03 13:20:53'),(105144,325,'Singthu','803216',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105145,325,'Sirhari','803116',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105146,325,'Sirnawan','803110',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105147,325,'Sirsi Dihra','803110',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105148,325,'Sithaura','803116',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105149,325,'Sohsarai','803118',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105150,325,'Sonchari','803114',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105151,325,'Sonsa','803119',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105152,325,'Sosandi','803119',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105153,325,'Soure','803114',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105154,325,'Suhawanpur','803116',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105155,325,'Tajnipur','803213',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105156,325,'Telhara (Nalanda)','801306',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105157,325,'Tetrawan','803216',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105158,325,'Tinalodipur','801305',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105159,325,'Tiuri','803216',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105160,325,'Tulsigarh','803108',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105161,325,'Tungi','803216',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105162,325,'Uttarnama','803119',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105163,325,'Uttarthu','803107',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105164,325,'Veerayatan','803116',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105165,325,'Waiyao','803107',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105166,325,'Yogipur','801302',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105167,325,'Badi','805105',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105168,325,'Bahadurganj','805105',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105169,325,'Bhagwanpur','805105',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105170,325,'Gazipur','805105',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105171,325,'Giriak','803109',1,0,'2022-03-03 13:20:54','2022-03-03 13:20:54'),(105172,325,'Katauna','805130',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105173,325,'Katrisarai','805105',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105174,325,'Maira Barich','805105',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105175,326,'Adampur','803109',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105176,326,'Akaunabazar','805123',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105177,326,'Andharwari','805125',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105178,326,'Ankari','805122',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105179,326,'Apsai','805108',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105180,326,'Aranikesopur','805109',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105181,326,'Arha','805124',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105182,326,'Arnadi','805129',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105183,326,'Aruri','805132',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105184,326,'Asarhi','805111',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105185,326,'B Garhrampur','805126',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105186,326,'Baghibardiha','805132',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105187,326,'Bahadurpur','805125',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105188,326,'Baijnathpur','805103',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105189,326,'Bajitpur','805108',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105190,326,'Baksanda','805126',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105191,326,'Baksoti','805121',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105192,326,'Bansgopal','805125',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105193,326,'Barasolapur','805101',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105194,326,'Barat Sarai','805103',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105195,326,'Bargaon','805122',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105196,326,'Barhauna','805103',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105197,326,'Bauri','805130',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105198,326,'Belar','805130',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105199,326,'Bermi','805104',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105200,326,'Bhadokhara','805123',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105201,326,'Bhadseni','805129',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105202,326,'Bhanail','805121',1,0,'2022-03-03 13:20:55','2022-03-03 13:20:55'),(105203,326,'Bhatta','805130',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105204,326,'Bhattagarh','805107',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105205,326,'Biju Bigha','805122',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105206,326,'Bilari','805130',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105207,326,'Bindidih','803109',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105208,326,'Birnawan','805130',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105209,326,'Bisunpur','805102',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105210,326,'Budhauli','805124',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105211,326,'Budhwara','805121',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105212,326,'Chackwai','805130',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105213,326,'Chamotha','805125',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105214,326,'Chandradeep','805124',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105215,326,'Chauby','805127',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105216,326,'Chhatihar','805111',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105217,326,'Chhota Jamura','805103',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105218,326,'Chhotashekhpur','805103',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105219,326,'Chhoti Amawa','805121',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105220,326,'Chhotipali','805103',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105221,326,'Chowar','805128',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105222,326,'D Garh Itpakwa','805106',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105223,326,'Dariyapur','805130',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105224,326,'Datraul','805124',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105225,326,'Dergoan','805130',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105226,326,'Derma','805112',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105227,326,'Dermobara','805104',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105228,326,'Dhamani','805125',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105229,326,'Dhamul','805101',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105230,326,'Dhanar','805101',1,0,'2022-03-03 13:20:56','2022-03-03 13:20:56'),(105231,326,'Dhandhar','805129',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105232,326,'Dhanwan','805103',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105233,326,'Dharhara','805101',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105234,326,'Dhewdha','805132',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105235,326,'Diri','805112',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105236,326,'Dohra','805109',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105237,326,'Dona','805103',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105238,326,'Dosut','805132',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105239,326,'Dumari','805121',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105240,326,'Dumrawan','805124',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105241,326,'Dumrawan SO','805132',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105242,326,'Dumri','805128',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105243,326,'Frahimabad','805112',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105244,326,'G B Kendua Konihar','805122',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105245,326,'Ghostama','805104',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105246,326,'Gonawan','805111',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105247,326,'Gopalpur','803109',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105248,326,'Govindpur (Nawada)','805102',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105249,326,'Gulani','805124',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105250,326,'Hasapur','805111',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105251,326,'Hasua','805103',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105252,326,'Jalalpur','805130',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105253,326,'Juri','805124',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105254,326,'Kadhar','805106',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105255,326,'Kadirganj','805104',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105256,326,'Kahuara','805109',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105257,326,'Kashichack','805130',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105258,326,'Kawakol','805106',1,0,'2022-03-03 13:20:57','2022-03-03 13:20:57'),(105259,326,'Kenasari','805123',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105260,326,'Keshauri','805132',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105261,326,'Kewaii','805106',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105262,326,'Khakhari','805130',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105263,326,'Khalsadhibari','805104',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105264,326,'Khanpur','805129',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105265,326,'Khanpur','803109',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105266,326,'Khanwan','805122',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105267,326,'Kharsari','805106',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105268,326,'Kochagoan','805130',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105269,326,'Konadpur','805124',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105270,326,'Koriauna','805126',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105271,326,'Kosi (Nawada)','805107',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105272,326,'Kosla','805109',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105273,326,'Kother','805128',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105274,326,'Kuhila','805126',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105275,326,'Kundabhalua','805107',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105276,326,'Kusmuhar','805126',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105277,326,'Lalbigha','805108',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105278,326,'Lalpur','805106',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105279,326,'Lkhamohna','805121',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105280,326,'Lond','805122',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105281,326,'Madhopur','805102',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105282,326,'Madhurapur','805106',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105283,326,'Mahapurchhab','805106',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105284,326,'Mahnadpur','805111',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105285,326,'Mahrawan','805107',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105286,326,'Makanpur','805130',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105287,326,'Makhar','805112',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105288,326,'Manjaur','805130',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105289,326,'Manjhauli','805127',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105290,326,'Manjhaway','805129',1,0,'2022-03-03 13:20:58','2022-03-03 13:20:58'),(105291,326,'Manjhila','805106',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105292,326,'Marara','805107',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105293,326,'Marue','805104',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105294,326,'Marwa','805124',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105295,326,'Masaurha','805109',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105296,326,'Merkuri','805122',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105297,326,'Meskaur','805122',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105298,326,'Mheshdih','805121',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105299,326,'Millky','805130',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105300,326,'Mirganj','805102',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105301,326,'Mosama','805130',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105302,326,'Mow Bindidah','803109',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105303,326,'N Purwaritola','805106',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105304,326,'Nagwan','805128',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105305,326,'Nanaura','805112',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105306,326,'Nardiganj','805109',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105307,326,'Narhat','805122',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105308,326,'Nawada Kutchery','805111',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105309,326,'Nawadha H.O','805110',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105310,326,'Nemdarganj','805121',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105311,326,'Nromurar','805130',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105312,326,'Ohari','805104',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105313,326,'Okhariyagolab','805106',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105314,326,'Oraina','805123',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105315,326,'Orhanpur','805123',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105316,326,'Orro','805133',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105317,326,'Pachra','805111',1,0,'2022-03-03 13:20:59','2022-03-03 13:20:59'),(105318,326,'Paharpur','805126',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105319,326,'Paingari','805130',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105320,326,'Pakaribarwan','805124',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105321,326,'Parnawada','805112',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105322,326,'Parwati','805108',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105323,326,'Pasarhi','805128',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105324,326,'Paura','805104',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105325,326,'Phatehpurmore','805126',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105326,326,'Phuldih','805106',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105327,326,'Pithauri','805112',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105328,326,'Prama','805109',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105329,326,'Punther','805103',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105330,326,'Purani','803109',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105331,326,'Railer','803109',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105332,326,'Raja Bigha','805122',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105333,326,'Rajan','805122',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105334,326,'Rajapur Saur','805104',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105335,326,'Rajauli','805125',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105336,326,'Rajhat','805126',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105337,326,'Ramraichack','805127',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105338,326,'Rasalpur','805122',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105339,326,'Rayes','805124',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105340,326,'Roh','805141',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105341,326,'Rupau','805107',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105342,326,'S Marighgawa','805127',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105343,326,'Sabhari','805123',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105344,326,'Sachaul','805103',1,0,'2022-03-03 13:21:00','2022-03-03 13:21:00'),(105345,326,'Sadipur','805104',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105346,326,'Sambey','805130',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105347,326,'Samharigarh','805132',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105348,326,'Sarkanda','805102',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105349,326,'Sarsu','805109',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105350,326,'Shekhodaura','805106',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105351,326,'Sherpur','805127',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105352,326,'Sihin','805103',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105353,326,'Simariya','805124',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105354,326,'Singar','805125',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105355,326,'Sirdala','805127',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105356,326,'Sisma','805111',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105357,326,'Siur','805107',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105358,326,'Sonsihari','805123',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105359,326,'Spur Gowasa','805122',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105360,326,'Sughari','805126',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105361,326,'Sundri Dumari','805106',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105362,326,'Targir','805125',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105363,326,'Tetariya','805102',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105364,326,'Tetariya','805122',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105365,326,'Teyar','805112',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105366,326,'Tungi','805129',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105367,326,'Warisaliganj','805130',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105368,327,'Korra','804406',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105369,327,'Mouri','804426',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105370,327,'Jalal Pur Nauranga','811302',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105371,327,'Karkain','811104',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105372,327,'Achuara','803213',1,0,'2022-03-03 13:21:01','2022-03-03 13:21:01'),(105373,327,'Agwanpur','803214',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105374,327,'Andauli','803213',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105375,327,'Arai','801304',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105376,327,'Athmalgola','803211',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105377,327,'Atnama','803213',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105378,327,'Aunta','803303',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105379,327,'Badopur','803214',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105380,327,'Bahrawan','803214',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105381,327,'Bakawa','803306',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105382,327,'Bakhtiyarpur','803212',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105383,327,'Bakra','803110',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105384,327,'Barh Court','803213',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105385,327,'Barh Rs','803214',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105386,327,'Barh (Patna)','803213',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105387,327,'Baruane','803307',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105388,327,'Belchi','803110',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105389,327,'Berhana','803213',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105390,327,'Bhadaur (Patna)','803307',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105391,327,'Bhagwatpur Karmaur','803214',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105392,327,'Bhatgaon','803213',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105393,327,'Bhuapur','803211',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105394,327,'Bihari Bigha','803214',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105395,327,'Burhara','803212',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105396,327,'Chaknawada','803213',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105397,327,'Chaksawar','803211',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105398,327,'Chanda','803212',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105399,327,'Chintamanchak','803302',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105400,327,'Dakshnichak','803211',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105401,327,'Daniyawan','801304',1,0,'2022-03-03 13:21:02','2022-03-03 13:21:02'),(105402,327,'Darveshpur','803213',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105403,327,'Daulatpur','803214',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105404,327,'Dhabhma','803214',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105405,327,'Dhanak Dove','803302',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105406,327,'Ekdanga','803213',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105407,327,'Fatehpur','803211',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105408,327,'Fulelpur','803211',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105409,327,'Ghoswari','803212',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105410,327,'Gopalur','803110',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105411,327,'Gowasa Shikhpura','803214',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105412,327,'Hathidah','803301',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105413,327,'Hazipur Belaur','803213',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105414,327,'Jalalpur','803211',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105415,327,'Jodhan Bigha','803110',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105416,327,'Kanhaipur','803221',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105417,327,'Karara','803302',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105418,327,'Karjan','803211',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105419,327,'Karnauti','803212',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105420,327,'Khajurar','803213',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105421,327,'Kondi','803214',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105422,327,'Korari','803110',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105423,327,'Lemuabad','803221',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105424,327,'Madhopur','803212',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105425,327,'Mahammadpur','803213',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105426,327,'Malpur','803301',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105427,327,'Maranchi','803301',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105428,327,'Masathu','803213',1,0,'2022-03-03 13:21:03','2022-03-03 13:21:03'),(105429,327,'Mekra','803221',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105430,327,'Missi','803110',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105431,327,'Mobarakpur','803213',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105432,327,'Mokama','803302',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105433,327,'Mokamachauk','803302',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105434,327,'Mokamaghat','803303',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105435,327,'More','803302',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105436,327,'Nadama Tola','803213',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105437,327,'Nayabigha','803211',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105438,327,'Paijuna','803302',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105439,327,'Pandarak','803221',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105440,327,'Parsawan','803214',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105441,327,'Prahladpur','803306',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105442,327,'Rahimapur','803211',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105443,327,'Raily','803221',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105444,327,'Ramnagar Diara','803212',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105445,327,'Ramnagar Karai Kachhar','803211',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105446,327,'Rampur Dumra','803301',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105447,327,'Ranabigha','803214',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105448,327,'Rawaich','803212',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105449,327,'Rupas','803211',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105450,327,'Sabnima Khurd','803212',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105451,327,'Sahdeopur Chaturbhujpur','803306',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105452,327,'Sahri','803214',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105453,327,'Saistapur','803211',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105454,327,'Saksohra','803213',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105455,327,'Samya Kurmichak','803306',1,0,'2022-03-03 13:21:04','2022-03-03 13:21:04'),(105456,327,'Samyagarh','803306',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105457,327,'Sarhan','803214',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105458,327,'Satya Bhaiya','803212',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105459,327,'Shahjahanpur','801305',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105460,327,'Shawani','803211',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105461,327,'Shivnar','803302',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105462,327,'Sigaryawn','801304',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105463,327,'Sirsi','803110',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105464,327,'Tartar','803302',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105465,327,'Tola Sohan Rai','803212',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105466,327,'Top','801304',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105467,327,'A. H. Guard','801103',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105468,327,'A.Piplawan','801109',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105469,327,'Achua','801110',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105470,327,'Ahiyapur','801108',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105471,327,'AIIMS','801507',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105472,327,'Aikhan','801102',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105473,327,'Ajwan','801109',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105474,327,'Akauna','804453',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105475,327,'Akhtiyarpur','801104',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105476,327,'Akilpur','800012',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105477,327,'Alampur Gonpura','801505',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105478,327,'Alawalpur','803203',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105479,327,'Alipur Bihta','803202',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105480,327,'Amarpura','801109',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105481,327,'Amhara','801103',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105482,327,'Anandpur','801103',1,0,'2022-03-03 13:21:05','2022-03-03 13:21:05'),(105483,327,'Anda','801113',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105484,327,'Anisabad','800002',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105485,327,'Ankuri','801110',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105486,327,'Arap','801104',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105487,327,'Ashiananagar','800025',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105488,327,'Ashok Nagar (Patna)','800020',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105489,327,'B R Centre','801503',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105490,327,'B.C. Road','800001',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105491,327,'B.G. Camp/raj Bhawan','800022',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105492,327,'B.H.Colony','800026',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105493,327,'B.P.S.C.','800001',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105494,327,'B.R. Centre','801501',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105495,327,'B.S.E. Board','800017',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105496,327,'B.Sikaria','804454',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105497,327,'B.Tarani','801109',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105498,327,'B.V. College','800014',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105499,327,'Bahpura','801103',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105500,327,'Bahrampur','804451',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105501,327,'Baikathpur','803202',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105502,327,'Bairia','800007',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105503,327,'Bajitpur','801111',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105504,327,'Bakhari','804451',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105505,327,'Balua','801113',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105506,327,'Banauli Khurd','801110',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105507,327,'Bank Road (Patna)','800001',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105508,327,'Bankipore H.O','800004',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105509,327,'Bankipore Macchariyawan','803201',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105510,327,'Bansbigha','804451',1,0,'2022-03-03 13:21:06','2022-03-03 13:21:06'),(105511,327,'Bara','804454',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105512,327,'Barah','804453',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105513,327,'Barah','801112',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105514,327,'Barawan','804452',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105515,327,'Barhi Bigha','804451',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105516,327,'Barni','804452',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105517,327,'Baruna','803201',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105518,327,'Basuhar','804453',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105519,327,'Bataganj','800018',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105520,327,'Baurhi','804451',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105521,327,'Beapur','801503',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105522,327,'Bedauli','804452',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105523,327,'Begampur (Patna)','800009',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105524,327,'Belhauri','801102',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105525,327,'Beni Bigha','801104',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105526,327,'Berra','804454',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105527,327,'Berthu','804451',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105528,327,'Beur','800002',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105529,327,'Bhadaura','804452',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105530,327,'Bhadsara','801102',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105531,327,'Bhagwanganj','804454',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105532,327,'Bhaiswa','804452',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105533,327,'Bharatpura','801102',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105534,327,'Bhergawan','804451',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105535,327,'Bhojpur','803202',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105536,327,'Bihta (Patna)','801103',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105537,327,'Bikram','801104',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105538,327,'Bindaul','801112',1,0,'2022-03-03 13:21:07','2022-03-03 13:21:07'),(105539,327,'Bir','804451',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105540,327,'Birpur','803202',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105541,327,'Bishunpura','801111',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105542,327,'C.D.A','800019',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105543,327,'C.R. Building','800001',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105544,327,'Ch.Dariapur','801109',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105545,327,'Chandhaus','801110',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105546,327,'Chandmari','801503',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105547,327,'Charma','804452',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105548,327,'Chaughara','800008',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105549,327,'Chesi','801109',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105550,327,'Chhata','804452',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105551,327,'Chiksi','801110',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105552,327,'Chipura Khurd','804453',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105553,327,'Chiraiyatand','800001',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105554,327,'Chiraura','801109',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105555,327,'Chistipur','803202',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105556,327,'Chitragupta Nagar','800020',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105557,327,'Chowk Shikarpur','800008',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105558,327,'D.Simri','801103',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105559,327,'Dahia','801110',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105560,327,'Dalip Chak','801503',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105561,327,'Danapur Bazar','801503',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105562,327,'Danapur Cantt','801503',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105563,327,'Danara','801104',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105564,327,'Darul Mallick','800001',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105565,327,'Datiana','801104',1,0,'2022-03-03 13:21:08','2022-03-03 13:21:08'),(105566,327,'Daudpur (PatB.O','801503',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105567,327,'Daulatpur','804452',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105568,327,'Daulatpur Gandhi Tola','803203',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105569,327,'Dental College','800007',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105570,327,'Deodha','804451',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105571,327,'Dewan','804452',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105572,327,'Dhanarua','804451',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105573,327,'Dhanaut','801506',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105574,327,'Dhelwan','800020',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105575,327,'Dhibra','801505',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105576,327,'Dhobiakalanpur','801111',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105577,327,'Digha (Patna)','800012',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105578,327,'Dighaghat','800011',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105579,327,'Dihri','804453',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105580,327,'Diwan Mohalla','800008',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105581,327,'Doghara','801112',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105582,327,'Doma','803202',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105583,327,'Dumari','803201',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105584,327,'Ekbalganj Nisarpura','801112',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105585,327,'Faridpur','801113',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105586,327,'Fatehpur','803203',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105587,327,'Fatwa','803201',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105588,327,'Gangachak','804452',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105589,327,'Ganghara','801503',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105590,327,'Gardanibagh','800001',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105591,327,'Garhochak','803201',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105592,327,'Garihara','804452',1,0,'2022-03-03 13:21:09','2022-03-03 13:21:09'),(105593,327,'Gauri Pundah','803201',1,0,'2022-03-03 13:21:10','2022-03-03 13:21:10'),(105594,327,'Ghorahua','804452',1,0,'2022-03-03 13:21:10','2022-03-03 13:21:10'),(105595,327,'Gorakhari','801104',1,0,'2022-03-03 13:21:10','2022-03-03 13:21:10'),(105596,327,'Gulzarbagh','800007',1,0,'2022-03-03 13:21:10','2022-03-03 13:21:10'),(105597,327,'Gyaspur Mahaji','803202',1,0,'2022-03-03 13:21:10','2022-03-03 13:21:10'),(105598,327,'Hansadih','804452',1,0,'2022-03-03 13:21:10','2022-03-03 13:21:10'),(105599,327,'Hazrat Sain','804451',1,0,'2022-03-03 13:21:10','2022-03-03 13:21:10'),(105600,327,'Hotel Republic','800001',1,0,'2022-03-03 13:21:10','2022-03-03 13:21:10'),(105601,327,'Hulasi Tola','801108',1,0,'2022-03-03 13:21:10','2022-03-03 13:21:10'),(105602,327,'Indian Nation','800001',1,0,'2022-03-03 13:21:10','2022-03-03 13:21:10'),(105603,327,'J.C.Road','800004',1,0,'2022-03-03 13:21:10','2022-03-03 13:21:10'),(105604,327,'Jahankhan Road','801503',1,0,'2022-03-03 13:21:10','2022-03-03 13:21:10'),(105605,327,'Jaitia','804451',1,0,'2022-03-03 13:21:10','2022-03-03 13:21:10'),(105606,327,'Jamal Road','800001',1,0,'2022-03-03 13:21:10','2022-03-03 13:21:10'),(105607,327,'Jamsaut','801503',1,0,'2022-03-03 13:21:10','2022-03-03 13:21:10'),(105608,327,'Jamui','801102',1,0,'2022-03-03 13:21:10','2022-03-03 13:21:10'),(105609,327,'Janpur','801110',1,0,'2022-03-03 13:21:10','2022-03-03 13:21:10'),(105610,327,'Jarkha','801110',1,0,'2022-03-03 13:21:10','2022-03-03 13:21:10'),(105611,327,'Jat Dumari','804453',1,0,'2022-03-03 13:21:10','2022-03-03 13:21:10'),(105612,327,'Jivrakhan Tola','801503',1,0,'2022-03-03 13:21:10','2022-03-03 13:21:10'),(105613,327,'K.Chauhatter','801108',1,0,'2022-03-03 13:21:10','2022-03-03 13:21:10'),(105614,327,'K.Netaual','804452',1,0,'2022-03-03 13:21:10','2022-03-03 13:21:10'),(105615,327,'K.Sector','800020',1,0,'2022-03-03 13:21:10','2022-03-03 13:21:10'),(105616,327,'Kab','801104',1,0,'2022-03-03 13:21:10','2022-03-03 13:21:10'),(105617,327,'Kachi Dargah','803201',1,0,'2022-03-03 13:21:10','2022-03-03 13:21:10'),(105618,327,'Kadamkuan','800003',1,0,'2022-03-03 13:21:10','2022-03-03 13:21:10'),(105619,327,'Kala Diara','803202',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105620,327,'Kalyanpur','804453',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105621,327,'Kamla Gopalpur','801111',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105622,327,'Kanchanpur','803201',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105623,327,'Kanchanpur','801103',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105624,327,'Kandap','804453',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105625,327,'Kansari','804451',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105626,327,'Karai','801109',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105627,327,'Karanja','801109',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105628,327,'Karauta','803202',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105629,327,'Katauna','803202',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105630,327,'Katesar','801103',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105631,327,'Katra Bazar (Patna)','800008',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105632,327,'Kayampur','803202',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105633,327,'Keora','804453',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105634,327,'Keshari Nagar','800024',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105635,327,'Khagaul Bazar','801105',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105636,327,'Khagaul','801105',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105637,327,'Khainia','804452',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105638,327,'Khajuri','801109',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105639,327,'Khanpura','801110',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105640,327,'Kharauna','804454',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105641,327,'Khushrupur','803202',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105642,327,'Kidwaipuri','800001',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105643,327,'Kohawan','803202',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105644,327,'Korawan','801109',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105645,327,'Kosut','804452',1,0,'2022-03-03 13:21:11','2022-03-03 13:21:11'),(105646,327,'Kothia','800009',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105647,327,'Kumhrar','800026',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105648,327,'Kunjwan','801103',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105649,327,'Kurji Md. Pur','801105',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105650,327,'Kurkuri','801110',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105651,327,'Kurthaul','804453',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105652,327,'L.B.S Nagar','800023',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105653,327,'L.I.C','800001',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105654,327,'Lahsuna','804452',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105655,327,'Lai','801112',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105656,327,'Lakhana','804453',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105657,327,'Lakhanpar','804453',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105658,327,'Lakhanpura','803202',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105659,327,'Lal Bengwa','801503',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105660,327,'Lanka Kachhuara','804453',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105661,327,'Lohia Nagar','800020',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105662,327,'M.Dihuli','801102',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105663,327,'M.Gopalpur','801104',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105664,327,'M.Kachhuara','800016',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105665,327,'M.Y.Sandalpur','800006',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105666,327,'Machharhatta','800008',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105667,327,'Machhuatoli','800004',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105668,327,'Madhopur','801503',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105669,327,'Madhopur','801108',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105670,327,'Mahabalipur','801110',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105671,327,'Mahajpura','801104',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105672,327,'Mahavir Asthan','800008',1,0,'2022-03-03 13:21:12','2022-03-03 13:21:12'),(105673,327,'Mahendru','800006',1,0,'2022-03-03 13:21:13','2022-03-03 13:21:13'),(105674,327,'Mahkar','803202',1,0,'2022-03-03 13:21:13','2022-03-03 13:21:13'),(105675,327,'Makhdumpur Digha','800011',1,0,'2022-03-03 13:21:13','2022-03-03 13:21:13'),(105676,327,'Makhmilpur','801110',1,0,'2022-03-03 13:21:13','2022-03-03 13:21:13'),(105677,327,'Mallikpur','804451',1,0,'2022-03-03 13:21:13','2022-03-03 13:21:13'),(105678,327,'Maner','801108',1,0,'2022-03-03 13:21:13','2022-03-03 13:21:13'),(105679,327,'Mangarpal','801108',1,0,'2022-03-03 13:21:13','2022-03-03 13:21:13'),(105680,327,'Mangla Devi','800007',1,0,'2022-03-03 13:21:13','2022-03-03 13:21:13'),(105681,327,'Manjhauli','803202',1,0,'2022-03-03 13:21:13','2022-03-03 13:21:13'),(105682,327,'Mankipar','804451',1,0,'2022-03-03 13:21:13','2022-03-03 13:21:13'),(105683,327,'Maranchi','804453',1,0,'2022-03-03 13:21:13','2022-03-03 13:21:13'),(105684,327,'Maranchi','800009',1,0,'2022-03-03 13:21:13','2022-03-03 13:21:13'),(105685,327,'Marufganj','800008',1,0,'2022-03-03 13:21:13','2022-03-03 13:21:13'),(105686,327,'Masarhi','803201',1,0,'2022-03-03 13:21:13','2022-03-03 13:21:13'),(105687,327,'Masaurha','801110',1,0,'2022-03-03 13:21:13','2022-03-03 13:21:13'),(105688,327,'Mashaurhi','804452',1,0,'2022-03-03 13:21:13','2022-03-03 13:21:13'),(105689,327,'Mehdawan','801108',1,0,'2022-03-03 13:21:13','2022-03-03 13:21:13'),(105690,327,'Mithapur (Patna)','800001',1,0,'2022-03-03 13:21:13','2022-03-03 13:21:13'),(105691,327,'Mittan Chak','804453',1,0,'2022-03-03 13:21:13','2022-03-03 13:21:13'),(105692,327,'Mohanpur','804453',1,0,'2022-03-03 13:21:13','2022-03-03 13:21:13'),(105693,327,'Mohiuddinpur','803201',1,0,'2022-03-03 13:21:13','2022-03-03 13:21:13'),(105694,327,'Mokar','804454',1,0,'2022-03-03 13:21:13','2022-03-03 13:21:13'),(105695,327,'Mubarakpur','801505',1,0,'2022-03-03 13:21:13','2022-03-03 13:21:13'),(105696,327,'Murka','801110',1,0,'2022-03-03 13:21:13','2022-03-03 13:21:13'),(105697,327,'Musepur','801103',1,0,'2022-03-03 13:21:13','2022-03-03 13:21:13'),(105698,327,'Nadaul','804454',1,0,'2022-03-03 13:21:13','2022-03-03 13:21:13'),(105699,327,'Nadghat','800007',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105700,327,'Nadpura','804451',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105701,327,'Nadwan','804453',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105702,327,'Nagwan','801109',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105703,327,'Nanauri','804451',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105704,327,'Nandlalabad','803203',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105705,327,'Nanmuhia','800007',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105706,327,'Nasratpur','804451',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105707,327,'Naubatpur','801109',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105708,327,'Navshakti','800001',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105709,327,'Nawasichak','804451',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105710,327,'Naya Panapur','800012',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105711,327,'Naya Tola (Patna)','800004',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105712,327,'Neora (Patna)','801113',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105713,327,'Netar','803202',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105714,327,'New Jaganpura','800027',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105715,327,'New Jakkanpur','800001',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105716,327,'Nisarpura','804453',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105717,327,'Osmanchak','804452',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105718,327,'P.M.C.H','800004',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105719,327,'P.Painathi','801103',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105720,327,'Pabhera','804451',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105721,327,'Pabheri More','804451',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105722,327,'Pachhim Darwaza','800008',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105723,327,'Pahari','800007',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105724,327,'Paimarghat','804453',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105725,327,'Painal','801111',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105726,327,'Paipura Kala','801110',1,0,'2022-03-03 13:21:14','2022-03-03 13:21:14'),(105727,327,'Pakri','800002',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105728,327,'Paliganj','801110',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105729,327,'Panapur','800012',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105730,327,'Panditganj','804451',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105731,327,'Parsa','803201',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105732,327,'Parsa','804453',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105733,327,'Parthu','804453',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105734,327,'Pataria','804454',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105735,327,'Patel Nagar','800029',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105736,327,'Pathrahat','804453',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105737,327,'Patila','801108',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105738,327,'Patliputra','800013',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105739,327,'Patna Aerodrome','800014',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105740,327,'Patna City','800008',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105741,327,'Patna Collectoriate','800001',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105742,327,'Patna High Court','800028',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105743,327,'Patna Sectt.','800015',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105744,327,'Patna University','800005',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105745,327,'Patut','801112',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105746,327,'Phulwarisharif','801505',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105747,327,'Pitwans','804452',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105748,327,'Poawan','804452',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105749,327,'Postal Park','800001',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105750,327,'Punadih','800009',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105751,327,'Punaichak','800001',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105752,327,'Punpun','804453',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105753,327,'R.B.Jaitipur','801109',1,0,'2022-03-03 13:21:15','2022-03-03 13:21:15'),(105754,327,'R.Block','800001',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105755,327,'R.M.S. Colony','800020',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105756,327,'Rajapur Mainpura','800001',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105757,327,'Rajendra Nagar (Patna)','800016',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105758,327,'Rajipur','801104',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105759,327,'Ram Jaipal Nagar','801503',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105760,327,'Ram Krishna Nagar','800027',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105761,327,'Ram Nagar','801108',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105762,327,'Ramchaura','803202',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105763,327,'Rampur Diara','801108',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105764,327,'Ranipur','801110',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105765,327,'Rastra Nagar Rarha','804451',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105766,327,'Rewan','804454',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105767,327,'Rukunpur','803203',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105768,327,'S.Gopalpur','801109',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105769,327,'Sabalpur','800009',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105770,327,'Sadaquat Ashram','800010',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105771,327,'Sadawah','801102',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105772,327,'Sadikpur','801503',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105773,327,'Sadisopur','801111',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105774,327,'Sahar Rampur','801109',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105775,327,'Sahay Nagar','801506',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105776,327,'Sahora','801110',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105777,327,'Saidabah','801104',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105778,327,'Sakraicha','804453',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105779,327,'Salimpur','803202',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105780,327,'Sanda','804452',1,0,'2022-03-03 13:21:16','2022-03-03 13:21:16'),(105781,327,'Sarai','801113',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105782,327,'Sarasat','801109',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105783,327,'Sarsi','801110',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105784,327,'Seonan','804454',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105785,327,'Sheikhpura (Patna)','800014',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105786,327,'Sherpur','801503',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105787,327,'Shikarpur','801105',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105788,327,'Sidhirpur','801110',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105789,327,'Sigori','801110',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105790,327,'Sihi','801102',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105791,327,'Sikaria','801110',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105792,327,'Simhari','804451',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105793,327,'Singhara','801102',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105794,327,'Sohora','801102',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105795,327,'Sonagopalpur','800007',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105796,327,'Sonmai','804451',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105797,327,'Sorampur','801102',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105798,327,'Sorampur','801505',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105799,327,'Sri Krishnapuri','800001',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105800,327,'Sri Madhoji Mills','800008',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105801,327,'Srichandpur','801111',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105802,327,'Sripalpur','804453',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105803,327,'Suitha','804453',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105804,327,'Sultanpur','803201',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105805,327,'Surhari','803202',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105806,327,'Tara Nagar','801103',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105807,327,'Telmar','803202',1,0,'2022-03-03 13:21:17','2022-03-03 13:21:17'),(105808,327,'Tishkhora','801111',1,0,'2022-03-03 13:21:18','2022-03-03 13:21:18'),(105809,327,'Usfa','803203',1,0,'2022-03-03 13:21:18','2022-03-03 13:21:18'),(105810,327,'Vidyut Parisad','800021',1,0,'2022-03-03 13:21:18','2022-03-03 13:21:18'),(105811,327,'Vijaypura','804451',1,0,'2022-03-03 13:21:18','2022-03-03 13:21:18'),(105812,327,'Wazirpur','801104',1,0,'2022-03-03 13:21:18','2022-03-03 13:21:18'),(105813,327,'West Lohianagar','800020',1,0,'2022-03-03 13:21:18','2022-03-03 13:21:18'),(105814,327,'Patna G.P.O.','800001',1,0,'2022-03-03 13:21:18','2022-03-03 13:21:18'),(105815,328,'Adhang','854330',1,0,'2022-03-03 13:21:18','2022-03-03 13:21:18'),(105816,328,'Ahilgaon','854327',1,0,'2022-03-03 13:21:18','2022-03-03 13:21:18'),(105817,328,'Ajokopa','854204',1,0,'2022-03-03 13:21:18','2022-03-03 13:21:18'),(105818,328,'Akartapa','854102',1,0,'2022-03-03 13:21:18','2022-03-03 13:21:18'),(105819,328,'Amarikukroan','854205',1,0,'2022-03-03 13:21:18','2022-03-03 13:21:18'),(105820,328,'Amouna','854316',1,0,'2022-03-03 13:21:18','2022-03-03 13:21:18'),(105821,328,'Amour','854315',1,0,'2022-03-03 13:21:18','2022-03-03 13:21:18'),(105822,328,'Asja Mobaiya','854315',1,0,'2022-03-03 13:21:18','2022-03-03 13:21:18'),(105823,328,'Aurahi Gobindpur','854202',1,0,'2022-03-03 13:21:18','2022-03-03 13:21:18'),(105824,328,'B.K.Asthan','854303',1,0,'2022-03-03 13:21:18','2022-03-03 13:21:18'),(105825,328,'Bagngar','854325',1,0,'2022-03-03 13:21:18','2022-03-03 13:21:18'),(105826,328,'Bahdura','854204',1,0,'2022-03-03 13:21:18','2022-03-03 13:21:18'),(105827,328,'Baisi','854315',1,0,'2022-03-03 13:21:18','2022-03-03 13:21:18'),(105828,328,'Balla','854204',1,0,'2022-03-03 13:21:18','2022-03-03 13:21:18'),(105829,328,'Balua Kachhari','854201',1,0,'2022-03-03 13:21:18','2022-03-03 13:21:18'),(105830,328,'Banaili','854201',1,0,'2022-03-03 13:21:18','2022-03-03 13:21:18'),(105831,328,'Banmankhi','854202',1,0,'2022-03-03 13:21:18','2022-03-03 13:21:18'),(105832,328,'Banshi Purandaha','854205',1,0,'2022-03-03 13:21:18','2022-03-03 13:21:18'),(105833,328,'Baraidagah','854330',1,0,'2022-03-03 13:21:18','2022-03-03 13:21:18'),(105834,328,'Bardela','854204',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105835,328,'Barhara Kothi','854203',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105836,328,'Barhari','854204',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105837,328,'Barsauni','854326',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105838,328,'Begampur','854330',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105839,328,'Belaganj','854317',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105840,328,'Belarikbaganj','854304',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105841,328,'Belouri','854326',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105842,328,'Belwa','854337',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105843,328,'Betauna','854330',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105844,328,'Bhangahi','854316',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105845,328,'Bharmara','854330',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105846,328,'Bhatgama','854202',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105847,328,'Bhatotar Chakla','854203',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105848,328,'Bhatsara','854203',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105849,328,'Bhatta Bazar','854301',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105850,328,'Bhawanipur Rajdham','854204',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105851,328,'Bhogabhatgama','854337',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105852,328,'Bhuna','854325',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105853,328,'Birnagar','854102',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105854,328,'Bishanpur','854315',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105855,328,'Bishanpur Deorhi','854203',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105856,328,'Bishanpur Dutt','854202',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105857,328,'Bithnauli','854304',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105858,328,'Bochgaon','854330',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105859,328,'Burhia Dhankatta','854306',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105860,328,'Chakmaka','854102',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105861,328,'Champabati','854306',1,0,'2022-03-03 13:21:19','2022-03-03 13:21:19'),(105862,328,'Chandidoria','854315',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105863,328,'Chandrahi','854205',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105864,328,'Chanka','854304',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105865,328,'Charaiya','854315',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105866,328,'Chokta','854325',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105867,328,'Chopra Ram Nagar','854102',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105868,328,'Dagrua Hat','854326',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105869,328,'Damgara','854202',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105870,328,'Deotar','854202',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105871,328,'Dhamdaha','854205',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105872,328,'Dharhara Millik','854202',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105873,328,'Dhima','854202',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105874,328,'Dibra','854203',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105875,328,'Dobha','854204',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105876,328,'Dumra','854204',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105877,328,'Durgapur','854204',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105878,328,'Ekamba Hishara','854327',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105879,328,'Ekraha','854102',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105880,328,'Farkia','854304',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105881,328,'Gairah','854325',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105882,328,'Ganeshpur','854304',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105883,328,'Gangali','854303',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105884,328,'Gangarghose','854315',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105885,328,'Garhbanaili','854325',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105886,328,'Garhiyabalua','854304',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105887,328,'Goasi','854303',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105888,328,'Gokulpur','854306',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105889,328,'Gulabbagh','854326',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105890,328,'Gurhi','854330',1,0,'2022-03-03 13:21:20','2022-03-03 13:21:20'),(105891,328,'Hafania','854315',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105892,328,'Harda','854303',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105893,328,'Haripur Madi','854202',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105894,328,'Harirahi','854203',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105895,328,'Harpatti','854102',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105896,328,'Hasanganj','854337',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105897,328,'Hingua','854202',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105898,328,'Jabe','854204',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105899,328,'Jageli','854304',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105900,328,'Jalalgarh','854327',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105901,328,'Jankinagar','854102',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105902,328,'Jhalari','854204',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105903,328,'Jhawari','854330',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105904,328,'Kajha','854304',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105905,328,'Kajhi','854202',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105906,328,'Kala Balua','854201',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105907,328,'Kalsar','854337',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105908,328,'Kamalpur','854203',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105909,328,'Kanharia','854315',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105910,328,'Kasba Bazar','854330',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105911,328,'Kasba (Purnia)','854330',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105912,328,'Kharaiya','854315',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105913,328,'Khazanchi Hat','854301',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105914,328,'Khemchand','854304',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105915,328,'Khokha','854304',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105916,328,'Khoksa','854315',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105917,328,'Khudna Rupaspur','854303',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105918,328,'Khuskibagh','854305',1,0,'2022-03-03 13:21:21','2022-03-03 13:21:21'),(105919,328,'Kukraon','854204',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105920,328,'Kulla Kahs','854330',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105921,328,'Kurigola','854205',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105922,328,'Ladugarh','854202',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105923,328,'Lalganj','854303',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105924,328,'Latraha','854203',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105925,328,'Laukahi Sukhasan','854202',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105926,328,'M.Purandaha','854202',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105927,328,'Machhatta','854315',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105928,328,'Machhela','854325',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105929,328,'Madarghat','854330',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105930,328,'Madhonagar','854204',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105931,328,'Mahalbari','854326',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105932,328,'Mahalgaon','854325',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105933,328,'Mahamadia','854330',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105934,328,'Maharaj Ganj','854202',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105935,328,'Majgama','854330',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105936,328,'Majhuakala','854330',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105937,328,'Majhwar','854113',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105938,328,'Makelibalgachhi','854315',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105939,328,'Maldiha','854203',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105940,328,'Maldwar','854333',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105941,328,'Malinia Diara','854201',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105942,328,'Mangalwarchirya','854102',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105943,328,'Maranga','854303',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105944,328,'Mathkopa','854330',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105945,328,'Mathour','854330',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105946,328,'Mauzampatti','854203',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105947,328,'Mehdi','854204',1,0,'2022-03-03 13:21:22','2022-03-03 13:21:22'),(105948,328,'Mirganj','854304',1,0,'2022-03-03 13:21:23','2022-03-03 13:21:23'),(105949,328,'Mohania Chakla','854102',1,0,'2022-03-03 13:21:23','2022-03-03 13:21:23'),(105950,328,'Mohankunda','854326',1,0,'2022-03-03 13:21:23','2022-03-03 13:21:23'),(105951,328,'Nathpur','854335',1,0,'2022-03-03 13:21:23','2022-03-03 13:21:23'),(105952,328,'Nipania','854202',1,0,'2022-03-03 13:21:23','2022-03-03 13:21:23'),(105953,328,'Nirpur','854203',1,0,'2022-03-03 13:21:23','2022-03-03 13:21:23'),(105954,328,'Orlaha','854203',1,0,'2022-03-03 13:21:23','2022-03-03 13:21:23'),(105955,328,'P.T.Dumraha','854325',1,0,'2022-03-03 13:21:23','2022-03-03 13:21:23'),(105956,328,'Parasmani','854306',1,0,'2022-03-03 13:21:23','2022-03-03 13:21:23'),(105957,328,'Parora','854304',1,0,'2022-03-03 13:21:23','2022-03-03 13:21:23'),(105958,328,'Parsa Hat','854202',1,0,'2022-03-03 13:21:23','2022-03-03 13:21:23'),(105959,328,'Pipra','854102',1,0,'2022-03-03 13:21:23','2022-03-03 13:21:23'),(105960,328,'Pithotra','854335',1,0,'2022-03-03 13:21:23','2022-03-03 13:21:23'),(105961,328,'Pokharia Benguabad','854326',1,0,'2022-03-03 13:21:23','2022-03-03 13:21:23'),(105962,328,'Purnea Aerodram','854303',1,0,'2022-03-03 13:21:23','2022-03-03 13:21:23'),(105963,328,'Purnea Chowk','854304',1,0,'2022-03-03 13:21:23','2022-03-03 13:21:23'),(105964,328,'Purnea City','854302',1,0,'2022-03-03 13:21:23','2022-03-03 13:21:23'),(105965,328,'Purnea Court','854301',1,0,'2022-03-03 13:21:23','2022-03-03 13:21:23'),(105966,328,'Purnea DB','854301',1,0,'2022-03-03 13:21:23','2022-03-03 13:21:23'),(105967,328,'Purnea H.O','854301',1,0,'2022-03-03 13:21:23','2022-03-03 13:21:23'),(105968,328,'Purnea Linebazar','854301',1,0,'2022-03-03 13:21:23','2022-03-03 13:21:23'),(105969,328,'Purnea Polyticnic','854303',1,0,'2022-03-03 13:21:23','2022-03-03 13:21:23'),(105970,328,'Rahua','854303',1,0,'2022-03-03 13:21:23','2022-03-03 13:21:23'),(105971,328,'Ramnagar','854201',1,0,'2022-03-03 13:21:23','2022-03-03 13:21:23'),(105972,328,'Rampur Kodarkatti','854325',1,0,'2022-03-03 13:21:23','2022-03-03 13:21:23'),(105973,328,'Rampurtilak','854102',1,0,'2022-03-03 13:21:23','2022-03-03 13:21:23'),(105974,328,'Rangpura','854304',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(105975,328,'Ranipatra','854337',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(105976,328,'Rasarh','854202',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(105977,328,'Rautahat','854315',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(105978,328,'Rautara','854337',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(105979,328,'Rupaspur','854304',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(105980,328,'Rupauli','854204',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(105981,328,'S.T.Brahmgyani','854204',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(105982,328,'Sadhubeli','854304',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(105983,328,'Sadipur Butha','854315',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(105984,328,'Sahara','854303',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(105985,328,'Sahidganj','854204',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(105986,328,'Sanjhaghat','854205',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(105987,328,'Sarsi','854306',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(105988,328,'Siarkhan','854326',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(105989,328,'Silanath Rupauli','854102',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(105990,328,'Singhiya','854304',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(105991,328,'Sohangaon','854327',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(105992,328,'Sonapur Bazar','854316',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(105993,328,'Sondeep','854204',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(105994,328,'Sourajabar','854315',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(105995,328,'Southa','854325',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(105996,328,'Srinagar','854304',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(105997,328,'Sripur','854205',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(105998,328,'Talbari','854315',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(105999,328,'Tarauna','854327',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(106000,328,'Tetrahi','854102',1,0,'2022-03-03 13:21:24','2022-03-03 13:21:24'),(106001,328,'Tolikola','854330',1,0,'2022-03-03 13:21:25','2022-03-03 13:21:25'),(106002,328,'Zianganj','854306',1,0,'2022-03-03 13:21:25','2022-03-03 13:21:25'),(106003,328,'Bhowadeorhi','853204',1,0,'2022-03-03 13:21:25','2022-03-03 13:21:25'),(106004,328,'Laxmipurgirdhar','853204',1,0,'2022-03-03 13:21:25','2022-03-03 13:21:25'),(106005,328,'Srimaha','853204',1,0,'2022-03-03 13:21:25','2022-03-03 13:21:25'),(106006,329,'A. Kala','802226',1,0,'2022-03-03 13:21:25','2022-03-03 13:21:25'),(106007,329,'A. Saraiya','821312',1,0,'2022-03-03 13:21:25','2022-03-03 13:21:25'),(106008,329,'Akorha','802213',1,0,'2022-03-03 13:21:25','2022-03-03 13:21:25'),(106009,329,'Akorhi','821301',1,0,'2022-03-03 13:21:25','2022-03-03 13:21:25'),(106010,329,'Akorhi Bazar','821301',1,0,'2022-03-03 13:21:25','2022-03-03 13:21:25'),(106011,329,'Alampur','821113',1,0,'2022-03-03 13:21:25','2022-03-03 13:21:25'),(106012,329,'Amaon Baraon','821104',1,0,'2022-03-03 13:21:25','2022-03-03 13:21:25'),(106013,329,'Amaura','821309',1,0,'2022-03-03 13:21:25','2022-03-03 13:21:25'),(106014,329,'Amiyawar','821310',1,0,'2022-03-03 13:21:25','2022-03-03 13:21:25'),(106015,329,'Amjhore Camp','821302',1,0,'2022-03-03 13:21:25','2022-03-03 13:21:25'),(106016,329,'Amoura','802214',1,0,'2022-03-03 13:21:25','2022-03-03 13:21:25'),(106017,329,'Andore','802213',1,0,'2022-03-03 13:21:25','2022-03-03 13:21:25'),(106018,329,'Ararua','821107',1,0,'2022-03-03 13:21:25','2022-03-03 13:21:25'),(106019,329,'Arthu','802218',1,0,'2022-03-03 13:21:25','2022-03-03 13:21:25'),(106020,329,'Atimi','821310',1,0,'2022-03-03 13:21:25','2022-03-03 13:21:25'),(106021,329,'Awarhi','802211',1,0,'2022-03-03 13:21:25','2022-03-03 13:21:25'),(106022,329,'B. Kaithi','821309',1,0,'2022-03-03 13:21:25','2022-03-03 13:21:25'),(106023,329,'Babhnaul','802211',1,0,'2022-03-03 13:21:25','2022-03-03 13:21:25'),(106024,329,'Babhni','802215',1,0,'2022-03-03 13:21:25','2022-03-03 13:21:25'),(106025,329,'Bad','802214',1,0,'2022-03-03 13:21:25','2022-03-03 13:21:25'),(106026,329,'Bahuara','802216',1,0,'2022-03-03 13:21:25','2022-03-03 13:21:25'),(106027,329,'Baknaura','821311',1,0,'2022-03-03 13:21:26','2022-03-03 13:21:26'),(106028,329,'Balthari','821107',1,0,'2022-03-03 13:21:26','2022-03-03 13:21:26'),(106029,329,'Banjari','821303',1,0,'2022-03-03 13:21:26','2022-03-03 13:21:26'),(106030,329,'Bank','821301',1,0,'2022-03-03 13:21:26','2022-03-03 13:21:26'),(106031,329,'Baradih','802214',1,0,'2022-03-03 13:21:26','2022-03-03 13:21:26'),(106032,329,'Baraila','821111',1,0,'2022-03-03 13:21:26','2022-03-03 13:21:26'),(106033,329,'Baraon','802215',1,0,'2022-03-03 13:21:26','2022-03-03 13:21:26'),(106034,329,'Baraon Kala','821306',1,0,'2022-03-03 13:21:26','2022-03-03 13:21:26'),(106035,329,'Bararhi','821305',1,0,'2022-03-03 13:21:26','2022-03-03 13:21:26'),(106036,329,'Barhari','802215',1,0,'2022-03-03 13:21:26','2022-03-03 13:21:26'),(106037,329,'Barhutikala','821107',1,0,'2022-03-03 13:21:26','2022-03-03 13:21:26'),(106038,329,'Barkadih','821113',1,0,'2022-03-03 13:21:26','2022-03-03 13:21:26'),(106039,329,'Barki Akorhi','802215',1,0,'2022-03-03 13:21:26','2022-03-03 13:21:26'),(106040,329,'Barki Kharari','821113',1,0,'2022-03-03 13:21:26','2022-03-03 13:21:26'),(106041,329,'Barki Mahuli','821113',1,0,'2022-03-03 13:21:26','2022-03-03 13:21:26'),(106042,329,'Basadihan','802213',1,0,'2022-03-03 13:21:26','2022-03-03 13:21:26'),(106043,329,'Basudeo Dehri','802218',1,0,'2022-03-03 13:21:26','2022-03-03 13:21:26'),(106044,329,'Baulia','821304',1,0,'2022-03-03 13:21:26','2022-03-03 13:21:26'),(106045,329,'Belvaiyan','802213',1,0,'2022-03-03 13:21:26','2022-03-03 13:21:26'),(106046,329,'Belwain','802214',1,0,'2022-03-03 13:21:26','2022-03-03 13:21:26'),(106047,329,'Belwan','802217',1,0,'2022-03-03 13:21:26','2022-03-03 13:21:26'),(106048,329,'Bensagar','802220',1,0,'2022-03-03 13:21:26','2022-03-03 13:21:26'),(106049,329,'Bhadokhra','821312',1,0,'2022-03-03 13:21:26','2022-03-03 13:21:26'),(106050,329,'Bhaluahi','802215',1,0,'2022-03-03 13:21:26','2022-03-03 13:21:26'),(106051,329,'Bhalunidham','802218',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106052,329,'Bhanpur','802213',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106053,329,'Bhelari','802215',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106054,329,'Bhitari Bandh','821104',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106055,329,'Bikramganj','802212',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106056,329,'Bishambhrpur','802218',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106057,329,'Bisheni Kala','802219',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106058,329,'Bishunpur','802219',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106059,329,'Burhan Road','821113',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106060,329,'Burhwal','802214',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106061,329,'Chandanpura','821312',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106062,329,'Chandarkaihti','821104',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106063,329,'Chandi','821301',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106064,329,'Chanp','821301',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106065,329,'Chatara','802211',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106066,329,'Chenari','821104',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106067,329,'Chhatauna','802215',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106068,329,'Chhotki Chenari','821113',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106069,329,'Chilheuon','802213',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106070,329,'Chitokhar','821310',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106071,329,'Chunhatta','821304',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106072,329,'Daidhan','821112',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106073,329,'Dalmianagar','821305',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106074,329,'Danwar','821309',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106075,329,'Daranagar','821304',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106076,329,'Daraon','821112',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106077,329,'Darigaon','821113',1,0,'2022-03-03 13:21:27','2022-03-03 13:21:27'),(106078,329,'Darihat','821306',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106079,329,'Dawath','802226',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106080,329,'Dehi','821113',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106081,329,'Dehri BMP','821307',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106082,329,'Dehri R S','821307',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106083,329,'Dehri-on-sone','821307',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106084,329,'Deo','802214',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106085,329,'Deokhaira','821107',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106086,329,'Dhanaw English','821310',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106087,329,'Dhanej','821107',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106088,329,'Dhangain','802212',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106089,329,'Dhanhara','821309',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106090,329,'Dharkandha','802218',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106091,329,'Dharupur','802212',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106092,329,'Dhawani','802214',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106093,329,'Dhowdarh','821113',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106094,329,'Dibhia','821107',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106095,329,'Dighita','821112',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106096,329,'Dinara (Rohtas)','802213',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106097,329,'Doiya','821112',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106098,329,'Dumari','821104',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106099,329,'Dumari Sahpur','821111',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106100,329,'Durgadi','802212',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106101,329,'Eghara','802217',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106102,329,'Gachhai','802214',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106103,329,'Gamhariya','821301',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106104,329,'Gandhi Path','821115',1,0,'2022-03-03 13:21:28','2022-03-03 13:21:28'),(106105,329,'Gangouli','821305',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106106,329,'Ganj Bharsara','802218',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106107,329,'Gara','821112',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106108,329,'Garh Nokha','802215',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106109,329,'Ghordiha','821107',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106110,329,'Ghosia','802215',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106111,329,'Ghosia Kala','802212',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106112,329,'Gorakh Parasi','802214',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106113,329,'Gorari','802214',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106114,329,'Gori','821107',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106115,329,'Goshaldih','802212',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106116,329,'Gotapa','802212',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106117,329,'Gotpa','821113',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106118,329,'Gunsej','802211',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106119,329,'Harihar Ganj (Rohtas)','821310',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106120,329,'Hathini','802215',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106121,329,'Hurka','821312',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106122,329,'Imirtha','802221',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106123,329,'Indrapuri','821308',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106124,329,'Itriya','802220',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106125,329,'Jabra','802215',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106126,329,'Jaipur','821301',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106127,329,'Jamorhi','802212',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106128,329,'Jamroh','802213',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106129,329,'Jamuhar','821305',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106130,329,'Jeena','821310',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106131,329,'Jhalkhoria','821113',1,0,'2022-03-03 13:21:29','2022-03-03 13:21:29'),(106132,329,'Jigana','802213',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106133,329,'Jonhi','802212',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106134,329,'K. Mahdeo','802212',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106135,329,'Kachhwa (Rohtas)','821309',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106136,329,'Kajhain','802220',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106137,329,'Kanchanpur','821305',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106138,329,'Kaniyari','802213',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106139,329,'Karahansi','802215',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106140,329,'Karakat','802212',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106141,329,'Kargahar','821107',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106142,329,'Karma','802212',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106143,329,'Karma Pathkhaulia','821310',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106144,329,'Karmaini','802220',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106145,329,'Karup Indrahiyan','802217',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106146,329,'Karup Itwa','802214',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106147,329,'Karwandia','821305',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106148,329,'Khairhan','821305',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106149,329,'Khanaithi','821107',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106150,329,'Kharari','802215',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106151,329,'Khirion','821310',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106152,329,'Khudru','821112',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106153,329,'Khuria','821113',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106154,329,'Kirhindi','821111',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106155,329,'Koath','802216',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106156,329,'Kochas','821112',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106157,329,'Konar','821113',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106158,329,'Kopsar','821107',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106159,329,'Kuchila','821112',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106160,329,'Kund','802213',1,0,'2022-03-03 13:21:30','2022-03-03 13:21:30'),(106161,329,'Kushdihra','821311',1,0,'2022-03-03 13:21:31','2022-03-03 13:21:31'),(106162,329,'Kusumhara','802218',1,0,'2022-03-03 13:21:31','2022-03-03 13:21:31'),(106163,329,'Laheri','821112',1,0,'2022-03-03 13:21:31','2022-03-03 13:21:31'),(106164,329,'Lilwachh','802218',1,0,'2022-03-03 13:21:31','2022-03-03 13:21:31'),(106165,329,'Mahdewa','821310',1,0,'2022-03-03 13:21:31','2022-03-03 13:21:31'),(106166,329,'Mahrajganj','821312',1,0,'2022-03-03 13:21:31','2022-03-03 13:21:31'),(106167,329,'Mahroh','802213',1,0,'2022-03-03 13:21:31','2022-03-03 13:21:31'),(106168,329,'Mahuari','821107',1,0,'2022-03-03 13:21:31','2022-03-03 13:21:31'),(106169,329,'Maidhara','802212',1,0,'2022-03-03 13:21:31','2022-03-03 13:21:31'),(106170,329,'Majhigawan','821304',1,0,'2022-03-03 13:21:31','2022-03-03 13:21:31'),(106171,329,'Malwar','821113',1,0,'2022-03-03 13:21:31','2022-03-03 13:21:31'),(106172,329,'Mamrejpur','821104',1,0,'2022-03-03 13:21:31','2022-03-03 13:21:31'),(106173,329,'Mangraon','821310',1,0,'2022-03-03 13:21:31','2022-03-03 13:21:31'),(106174,329,'Mani','802212',1,0,'2022-03-03 13:21:31','2022-03-03 13:21:31'),(106175,329,'Manikpur Bastipur','821305',1,0,'2022-03-03 13:21:31','2022-03-03 13:21:31'),(106176,329,'Manipur','802217',1,0,'2022-03-03 13:21:31','2022-03-03 13:21:31'),(106177,329,'Marojhian','821310',1,0,'2022-03-03 13:21:31','2022-03-03 13:21:31'),(106178,329,'Masauna','802220',1,0,'2022-03-03 13:21:31','2022-03-03 13:21:31'),(106179,329,'Meari Bazar','802217',1,0,'2022-03-03 13:21:31','2022-03-03 13:21:31'),(106180,329,'Medinipur','821310',1,0,'2022-03-03 13:21:31','2022-03-03 13:21:31'),(106181,329,'Mednipur','802211',1,0,'2022-03-03 13:21:31','2022-03-03 13:21:31'),(106182,329,'Mohanpur','802212',1,0,'2022-03-03 13:21:31','2022-03-03 13:21:31'),(106183,329,'Mokar','821113',1,0,'2022-03-03 13:21:31','2022-03-03 13:21:31'),(106184,329,'Motha','802212',1,0,'2022-03-03 13:21:31','2022-03-03 13:21:31'),(106185,329,'Mujrarh','802215',1,0,'2022-03-03 13:21:31','2022-03-03 13:21:31'),(106186,329,'Munji','802212',1,0,'2022-03-03 13:21:31','2022-03-03 13:21:31'),(106187,329,'Muodihan','802217',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106188,329,'Muradabad','821113',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106189,329,'Muriyar','821301',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106190,329,'Nad','821113',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106191,329,'Nadaon','802218',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106192,329,'Nahauna','821305',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106193,329,'Nasriganj','821310',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106194,329,'Natwar Khurd','802218',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106195,329,'Natwar','802218',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106196,329,'Nauhatta','821304',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106197,329,'Nauhatta','821104',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106198,329,'Nawadih','821308',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106199,329,'Nawadih Karma','821302',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106200,329,'New Area Sasaram','821115',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106201,329,'Nishan Nagar Baddi','821113',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106202,329,'Nonhar','802212',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106203,329,'Nonsari','802215',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106204,329,'Osaon','821309',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106205,329,'Pachpokhari','802217',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106206,329,'Pahleza','821305',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106207,329,'Panapur','821107',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106208,329,'Panjer','802215',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106209,329,'Pararia','802217',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106210,329,'Parariya','821304',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106211,329,'Parchha','821304',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106212,329,'Parsar','821309',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106213,329,'Paruhar','821306',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106214,329,'Pawani','821310',1,0,'2022-03-03 13:21:32','2022-03-03 13:21:32'),(106215,329,'Penar','802215',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106216,329,'Pipra','821107',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106217,329,'Puhpi','802218',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106218,329,'Raipur Chore','821113',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106219,329,'Rajandih','802219',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106220,329,'Rajpur','802218',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106221,329,'Rajpur (Rohtas)','802219',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106222,329,'Ramdihra','821312',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106223,329,'Rehal','821304',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106224,329,'Rohtas','821311',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106225,329,'Ruphatha','802215',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106226,329,'Sadokhar','821104',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106227,329,'Samahuta','821309',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106228,329,'Samardihan','821113',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106229,329,'Sanjhauli','802220',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106230,329,'Sarai','821113',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106231,329,'Saraon','802218',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106232,329,'Saraon','821310',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106233,329,'Sasaram Bazar','821115',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106234,329,'Sasaram H.O','821115',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106235,329,'Sasaram Local Board','821115',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106236,329,'Semra','802215',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106237,329,'Semri','802211',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106238,329,'Sewahi','821312',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106239,329,'Shankarpuri','821308',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106240,329,'Sheosagar','821111',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106241,329,'Sikarian Ultenganj','821310',1,0,'2022-03-03 13:21:33','2022-03-03 13:21:33'),(106242,329,'Sikrour','821104',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106243,329,'Silari','821111',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106244,329,'Sioruan','802220',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106245,329,'Sirkhinda','802215',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106246,329,'Sisirit','802215',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106247,329,'Sisirita','802217',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106248,329,'Siyawak','802219',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106249,329,'Sohagi','821306',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106250,329,'Sokhara','802219',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106251,329,'Suara','802219',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106252,329,'Sujatpur','802213',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106253,329,'Surajpura','802221',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106254,329,'Takia Bazar','821113',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106255,329,'Taraon','821310',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106256,329,'Tararh','802215',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106257,329,'Telari','821108',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106258,329,'Tendua','802215',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106259,329,'Tenduni Chauk','802212',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106260,329,'Tetrarh','821301',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106261,329,'Thakurai Parasia','821310',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106262,329,'Thanua','821111',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106263,329,'Tilain','802220',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106264,329,'Tilokhar','821304',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106265,329,'Tilouthu','821312',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106266,329,'Torni','821111',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106267,329,'Turk Bigha','821310',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106268,329,'Udaipur','802220',1,0,'2022-03-03 13:21:34','2022-03-03 13:21:34'),(106269,329,'Ugahni','821104',1,0,'2022-03-03 13:21:35','2022-03-03 13:21:35'),(106270,330,'Aina','852216',1,0,'2022-03-03 13:21:35','2022-03-03 13:21:35'),(106271,330,'Ajgeba','852221',1,0,'2022-03-03 13:21:35','2022-03-03 13:21:35'),(106272,330,'Alani','852126',1,0,'2022-03-03 13:21:35','2022-03-03 13:21:35'),(106273,330,'Amarpur','852202',1,0,'2022-03-03 13:21:35','2022-03-03 13:21:35'),(106274,330,'Amrita','852217',1,0,'2022-03-03 13:21:35','2022-03-03 13:21:35'),(106275,330,'Aran','852124',1,0,'2022-03-03 13:21:35','2022-03-03 13:21:35'),(106276,330,'Arapatti','852216',1,0,'2022-03-03 13:21:35','2022-03-03 13:21:35'),(106277,330,'Atalkha','852217',1,0,'2022-03-03 13:21:35','2022-03-03 13:21:35'),(106278,330,'B. Bhelahi','852216',1,0,'2022-03-03 13:21:35','2022-03-03 13:21:35'),(106279,330,'B.S.Patti','852202',1,0,'2022-03-03 13:21:35','2022-03-03 13:21:35'),(106280,330,'Baghwa','852216',1,0,'2022-03-03 13:21:35','2022-03-03 13:21:35'),(106281,330,'Baijnathpur','852221',1,0,'2022-03-03 13:21:35','2022-03-03 13:21:35'),(106282,330,'Bakunia','852123',1,0,'2022-03-03 13:21:35','2022-03-03 13:21:35'),(106283,330,'Balhampur','852127',1,0,'2022-03-03 13:21:35','2022-03-03 13:21:35'),(106284,330,'Balia','852217',1,0,'2022-03-03 13:21:35','2022-03-03 13:21:35'),(106285,330,'Balwahat','852106',1,0,'2022-03-03 13:21:35','2022-03-03 13:21:35'),(106286,330,'Bangaon (Saharsa)','852212',1,0,'2022-03-03 13:21:35','2022-03-03 13:21:35'),(106287,330,'Bara','852124',1,0,'2022-03-03 13:21:35','2022-03-03 13:21:35'),(106288,330,'Baraith','852217',1,0,'2022-03-03 13:21:35','2022-03-03 13:21:35'),(106289,330,'Bargaon','852217',1,0,'2022-03-03 13:21:35','2022-03-03 13:21:35'),(106290,330,'Barharia','852123',1,0,'2022-03-03 13:21:35','2022-03-03 13:21:35'),(106291,330,'Barhsher','852124',1,0,'2022-03-03 13:21:35','2022-03-03 13:21:35'),(106292,330,'Bariahi','852212',1,0,'2022-03-03 13:21:35','2022-03-03 13:21:35'),(106293,330,'Bariarpur','852127',1,0,'2022-03-03 13:21:35','2022-03-03 13:21:35'),(106294,330,'Barsam','852221',1,0,'2022-03-03 13:21:35','2022-03-03 13:21:35'),(106295,330,'Barsam','852217',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106296,330,'Basauna','852202',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106297,330,'Belhi Teghra','852106',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106298,330,'Belwara','852106',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106299,330,'Benghaha','852202',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106300,330,'Bhaddi Durgapur','852217',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106301,330,'Bharouli Dhakjhari','852202',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106302,330,'Bhatrandha','852124',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106303,330,'Bhavdeva','852106',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106304,330,'Bhelwa','852126',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106305,330,'Bijalpur','852124',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106306,330,'Biratpur','852217',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106307,330,'Bishanpur','852107',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106308,330,'Chainpur','852212',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106309,330,'Chandour','852221',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106310,330,'Chandryan Dharhara','852123',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106311,330,'Chapraon','852106',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106312,330,'Chikni Phulkaha','852124',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106313,330,'Chitti','852124',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106314,330,'Damgarhi','852221',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106315,330,'Darhar','852123',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106316,330,'Dehad','852129',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106317,330,'Dhabauli','852107',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106318,330,'Dhamsena','852202',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106319,330,'Dhanpura','852106',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106320,330,'Dhrampur','852123',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106321,330,'Diwari','852202',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106322,330,'Ekrah','852123',1,0,'2022-03-03 13:21:36','2022-03-03 13:21:36'),(106323,330,'G.Bihra','852124',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106324,330,'Gamaharia Rampur','852221',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106325,330,'Garhia','852202',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106326,330,'Garhia Vijaypur','852221',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106327,330,'Ghoghanpatti','852107',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106328,330,'Ghoghsam','852106',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106329,330,'Ghordaur','852127',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106330,330,'Golma','852107',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106331,330,'Gopalpur','852106',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106332,330,'Gordah','852127',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106333,330,'Goriari','852127',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106334,330,'Harewa','852126',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106335,330,'Haripur','852202',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106336,330,'Itahari','852126',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106337,330,'Jalsima','852217',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106338,330,'Jamal Nagar','852126',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106339,330,'Jamhara','852217',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106340,330,'Jiwachpur','852124',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106341,330,'K.Balua','852216',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106342,330,'Kabira','852106',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106343,330,'Kachra Karahia','852221',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106344,330,'Kahra','852202',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106345,330,'Kanp','852221',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106346,330,'Kapasia','852107',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106347,330,'Kathdumar','852106',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106348,330,'Kedlipatti','852123',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106349,330,'Kenjari','852129',1,0,'2022-03-03 13:21:37','2022-03-03 13:21:37'),(106350,330,'Khajurah','852217',1,0,'2022-03-03 13:21:38','2022-03-03 13:21:38'),(106351,330,'Khajuri','852221',1,0,'2022-03-03 13:21:38','2022-03-03 13:21:38'),(106352,330,'Khamauti','852127',1,0,'2022-03-03 13:21:38','2022-03-03 13:21:38'),(106353,330,'Kharagpur','852106',1,0,'2022-03-03 13:21:38','2022-03-03 13:21:38'),(106354,330,'Khojuri Matihani','852106',1,0,'2022-03-03 13:21:38','2022-03-03 13:21:38'),(106355,330,'Kishanpur','852217',1,0,'2022-03-03 13:21:38','2022-03-03 13:21:38'),(106356,330,'Koparia','852126',1,0,'2022-03-03 13:21:38','2022-03-03 13:21:38'),(106357,330,'Kundah','852216',1,0,'2022-03-03 13:21:38','2022-03-03 13:21:38'),(106358,330,'Lagma Deorhi','852129',1,0,'2022-03-03 13:21:38','2022-03-03 13:21:38'),(106359,330,'M.Kahra','852107',1,0,'2022-03-03 13:21:38','2022-03-03 13:21:38'),(106360,330,'Mahishi','852216',1,0,'2022-03-03 13:21:38','2022-03-03 13:21:38'),(106361,330,'Mahkhar','852127',1,0,'2022-03-03 13:21:38','2022-03-03 13:21:38'),(106362,330,'Maina','852129',1,0,'2022-03-03 13:21:38','2022-03-03 13:21:38'),(106363,330,'Maina Gram','852216',1,0,'2022-03-03 13:21:38','2022-03-03 13:21:38'),(106364,330,'Mali','852129',1,0,'2022-03-03 13:21:38','2022-03-03 13:21:38'),(106365,330,'Mangwar','852217',1,0,'2022-03-03 13:21:38','2022-03-03 13:21:38'),(106366,330,'Manjhaul','852124',1,0,'2022-03-03 13:21:38','2022-03-03 13:21:38'),(106367,330,'Menha Khadimpur','852124',1,0,'2022-03-03 13:21:38','2022-03-03 13:21:38'),(106368,330,'Mobarakpur','852126',1,0,'2022-03-03 13:21:38','2022-03-03 13:21:38'),(106369,330,'Mohanpur','852123',1,0,'2022-03-03 13:21:38','2022-03-03 13:21:38'),(106370,330,'Mohanpur Dudhela','852202',1,0,'2022-03-03 13:21:38','2022-03-03 13:21:38'),(106371,330,'Mokma','852217',1,0,'2022-03-03 13:21:38','2022-03-03 13:21:38'),(106372,330,'Muradpur','852123',1,0,'2022-03-03 13:21:38','2022-03-03 13:21:38'),(106373,330,'Murli Basantpur','852202',1,0,'2022-03-03 13:21:38','2022-03-03 13:21:38'),(106374,330,'Nandalali','852124',1,0,'2022-03-03 13:21:38','2022-03-03 13:21:38'),(106375,330,'Narayanpur','852216',1,0,'2022-03-03 13:21:38','2022-03-03 13:21:38'),(106376,330,'Nariyarh','852202',1,0,'2022-03-03 13:21:39','2022-03-03 13:21:39'),(106377,330,'Nauhatta','852123',1,0,'2022-03-03 13:21:39','2022-03-03 13:21:39'),(106378,330,'Naya Tola','852116',1,0,'2022-03-03 13:21:39','2022-03-03 13:21:39'),(106379,330,'Noneti','852217',1,0,'2022-03-03 13:21:39','2022-03-03 13:21:39'),(106380,330,'Paharpur','852127',1,0,'2022-03-03 13:21:39','2022-03-03 13:21:39'),(106381,330,'Pama','852107',1,0,'2022-03-03 13:21:39','2022-03-03 13:21:39'),(106382,330,'Panchgachiya','852124',1,0,'2022-03-03 13:21:39','2022-03-03 13:21:39'),(106383,330,'Pararia','852129',1,0,'2022-03-03 13:21:39','2022-03-03 13:21:39'),(106384,330,'Parri','852212',1,0,'2022-03-03 13:21:39','2022-03-03 13:21:39'),(106385,330,'Pastpar','852107',1,0,'2022-03-03 13:21:39','2022-03-03 13:21:39'),(106386,330,'Patarghat','852107',1,0,'2022-03-03 13:21:39','2022-03-03 13:21:39'),(106387,330,'Patori','852124',1,0,'2022-03-03 13:21:39','2022-03-03 13:21:39'),(106388,330,'Patuaha','852202',1,0,'2022-03-03 13:21:39','2022-03-03 13:21:39'),(106389,330,'Purshotampur','852124',1,0,'2022-03-03 13:21:39','2022-03-03 13:21:39'),(106390,330,'R.Tulsiahi','852124',1,0,'2022-03-03 13:21:39','2022-03-03 13:21:39'),(106391,330,'Rahua','852127',1,0,'2022-03-03 13:21:39','2022-03-03 13:21:39'),(106392,330,'Rahuamani','852212',1,0,'2022-03-03 13:21:39','2022-03-03 13:21:39'),(106393,330,'Rajanpur','852106',1,0,'2022-03-03 13:21:39','2022-03-03 13:21:39'),(106394,330,'Ramnagar Bharna','852123',1,0,'2022-03-03 13:21:39','2022-03-03 13:21:39'),(106395,330,'Rampur','852202',1,0,'2022-03-03 13:21:39','2022-03-03 13:21:39'),(106396,330,'Rampur','852106',1,0,'2022-03-03 13:21:39','2022-03-03 13:21:39'),(106397,330,'Rasalpur','852123',1,0,'2022-03-03 13:21:39','2022-03-03 13:21:39'),(106398,330,'Rasalpur','852129',1,0,'2022-03-03 13:21:39','2022-03-03 13:21:39'),(106399,330,'Rauta','852221',1,0,'2022-03-03 13:21:39','2022-03-03 13:21:39'),(106400,330,'Rupanagar','852202',1,0,'2022-03-03 13:21:39','2022-03-03 13:21:39'),(106401,330,'Saharsa Basti','852202',1,0,'2022-03-03 13:21:39','2022-03-03 13:21:39'),(106402,330,'Saharsa Bazar','852201',1,0,'2022-03-03 13:21:40','2022-03-03 13:21:40'),(106403,330,'Saharsa Collec.','852202',1,0,'2022-03-03 13:21:40','2022-03-03 13:21:40'),(106404,330,'Saharsa Dist.Board','852201',1,0,'2022-03-03 13:21:40','2022-03-03 13:21:40'),(106405,330,'Saharsa H.O','852201',1,0,'2022-03-03 13:21:40','2022-03-03 13:21:40'),(106406,330,'Sahsoul','852129',1,0,'2022-03-03 13:21:40','2022-03-03 13:21:40'),(106407,330,'Sahuria','852221',1,0,'2022-03-03 13:21:40','2022-03-03 13:21:40'),(106408,330,'Sakra Paharpur','852106',1,0,'2022-03-03 13:21:40','2022-03-03 13:21:40'),(106409,330,'Salkhua Bazar','852126',1,0,'2022-03-03 13:21:40','2022-03-03 13:21:40'),(106410,330,'Samda','852202',1,0,'2022-03-03 13:21:40','2022-03-03 13:21:40'),(106411,330,'Sarauni','852216',1,0,'2022-03-03 13:21:40','2022-03-03 13:21:40'),(106412,330,'Sarbella','852127',1,0,'2022-03-03 13:21:40','2022-03-03 13:21:40'),(106413,330,'Sardiha','852127',1,0,'2022-03-03 13:21:40','2022-03-03 13:21:40'),(106414,330,'Saronja','852106',1,0,'2022-03-03 13:21:40','2022-03-03 13:21:40'),(106415,330,'Sattar','852124',1,0,'2022-03-03 13:21:40','2022-03-03 13:21:40'),(106416,330,'Shahpur','852129',1,0,'2022-03-03 13:21:40','2022-03-03 13:21:40'),(106417,330,'Shahpur Manjhol','852123',1,0,'2022-03-03 13:21:40','2022-03-03 13:21:40'),(106418,330,'Shankarpur','852106',1,0,'2022-03-03 13:21:40','2022-03-03 13:21:40'),(106419,330,'Sihaul','852124',1,0,'2022-03-03 13:21:40','2022-03-03 13:21:40'),(106420,330,'Simraha','852202',1,0,'2022-03-03 13:21:40','2022-03-03 13:21:40'),(106421,330,'Simri','852127',1,0,'2022-03-03 13:21:40','2022-03-03 13:21:40'),(106422,330,'Simri Bakhtiarpur','852127',1,0,'2022-03-03 13:21:40','2022-03-03 13:21:40'),(106423,330,'Sisai','852202',1,0,'2022-03-03 13:21:40','2022-03-03 13:21:40'),(106424,330,'Sisauna','852216',1,0,'2022-03-03 13:21:40','2022-03-03 13:21:40'),(106425,330,'Sitanabad','852106',1,0,'2022-03-03 13:21:40','2022-03-03 13:21:40'),(106426,330,'Soha','852129',1,0,'2022-03-03 13:21:40','2022-03-03 13:21:40'),(106427,330,'Sonbersa Raj','852129',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106428,330,'Sonpura','852127',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106429,330,'Sour Bazar','852221',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106430,330,'Sugma','852129',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106431,330,'Suhath','852221',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106432,330,'Sulindabad','852202',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106433,330,'T. Dhanchhoa','852121',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106434,330,'Tariama','852127',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106435,330,'Telhar','852216',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106436,330,'Telwa','852216',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106437,330,'Terhi','852216',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106438,330,'Uteshra','852126',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106439,331,'Basatpur','847301',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106440,331,'Boraj','847105',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106441,331,'Darshuar','847301',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106442,331,'Jatmalpura Tira','847301',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106443,331,'K.Baikunth','847301',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106444,331,'K.Harsand','847301',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106445,331,'P. Dharampur','847301',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106446,331,'P.Ghiwahi','847105',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106447,331,'Ranna','847105',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106448,331,'S.Majarahia','847105',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106449,331,'Adharpur','848130',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106450,331,'Ahilwar','848205',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106451,331,'Ahmadpur','848505',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106452,331,'Akauna','848209',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106453,331,'Akha Bishanpur','848132',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106454,331,'Akhtiarpur','848127',1,0,'2022-03-03 13:21:41','2022-03-03 13:21:41'),(106455,331,'Akhtiarpur Khajuri','848114',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106456,331,'Andaur','848502',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106457,331,'Angarghat','848236',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106458,331,'Arout','848210',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106459,331,'Ashinchak','848114',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106460,331,'Aura','848205',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106461,331,'B.Ailoth','848101',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106462,331,'B.Chaksekhu','848114',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106463,331,'B.R.B.College','848101',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106464,331,'Baghi','848130',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106465,331,'Baghra (Samastipur)','848506',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106466,331,'Bahadurpur','848114',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106467,331,'Bahadurpur Patory','848504',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106468,331,'Baidyanathpur','848210',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106469,331,'Bajitpur Bombaiya','848160',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106470,331,'Bajitpur Karnail','848505',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106471,331,'Bajitpur Meari','848114',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106472,331,'Bakarpur','848501',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106473,331,'Balahi','848117',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106474,331,'Balha','848209',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106475,331,'Balha Nandenagar','848117',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106476,331,'Balhajainarain','848125',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106477,331,'Ballipur','848117',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106478,331,'Banda','848209',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106479,331,'Bandhar','848117',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106480,331,'Bangarhatta','848209',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106481,331,'Banghara','848114',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106482,331,'Barahi','848207',1,0,'2022-03-03 13:21:42','2022-03-03 13:21:42'),(106483,331,'Barbatta','848127',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106484,331,'Barhauna','848502',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106485,331,'Barra','848210',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106486,331,'Barra','848206',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106487,331,'Basudeopur','848102',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106488,331,'Basudeva','848209',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106489,331,'Bathua Buzurg','848127',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106490,331,'Bazidpur','848503',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106491,331,'Bazidpur Kumhira','848127',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106492,331,'Begampur','848101',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106493,331,'Belamegh','848114',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106494,331,'Belari','848132',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106495,331,'Belsandi','848302',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106496,331,'Belsandi','848207',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106497,331,'Belsandi Dih','848236',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106498,331,'Belsandi Tara','848236',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106499,331,'Bh.Dhurlak','848101',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106500,331,'Bhadaiya','848502',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106501,331,'Bhagwanpur Desua','848134',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106502,331,'Bhagwanpur Lohagir','848132',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106503,331,'Bhagwarpur Kamla','848132',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106504,331,'Bhagwatpur','848127',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106505,331,'Bharpura','848236',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106506,331,'Bharwari','848208',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106507,331,'Bhataura','848117',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106508,331,'Bhatwan','848206',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106509,331,'Bherokhra','848130',1,0,'2022-03-03 13:21:43','2022-03-03 13:21:43'),(106510,331,'Bhorejairam','848236',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106511,331,'Bhuswar','848211',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106512,331,'Bibhutipur','848211',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106513,331,'Bihrha','848216',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106514,331,'Bikrampur Bandey','848129',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106515,331,'Birnamatula','848134',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106516,331,'Birouli Rural Institute','848113',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106517,331,'Birsisngpur Deorhi','848102',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106518,331,'Bishanpur Abhi','848210',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106519,331,'Bishanpur Bathua','848115',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106520,331,'Bishanpur Beri','848501',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106521,331,'Bishanpur Diha','848209',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106522,331,'Bishanpur Hakimabad','848134',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106523,331,'Bishanpur Keothar','848206',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106524,331,'Bithan','848207',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106525,331,'Bochaha','848503',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106526,331,'Bombaiya Harlal','848114',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106527,331,'Boria','848211',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106528,331,'Buzurgdwar','848236',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106529,331,'Chaita','848132',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106530,331,'Chakbahauddin','848114',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106531,331,'Chakhabib','848160',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106532,331,'Chakhaji','848115',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106533,331,'Chakmehsi','848302',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106534,331,'Chaknawada','848114',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106535,331,'Chakpahar','848122',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106536,331,'Chaksaho','848504',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106537,331,'Chaksikandar','848122',1,0,'2022-03-03 13:21:44','2022-03-03 13:21:44'),(106538,331,'Chakthat','848210',1,0,'2022-03-03 13:21:45','2022-03-03 13:21:45'),(106539,331,'Chandauli','848115',1,0,'2022-03-03 13:21:45','2022-03-03 13:21:45'),(106540,331,'Chandauli','848132',1,0,'2022-03-03 13:21:45','2022-03-03 13:21:45'),(106541,331,'Chandchour','848114',1,0,'2022-03-03 13:21:45','2022-03-03 13:21:45'),(106542,331,'Chandpura','848504',1,0,'2022-03-03 13:21:45','2022-03-03 13:21:45'),(106543,331,'Chapar','848501',1,0,'2022-03-03 13:21:45','2022-03-03 13:21:45'),(106544,331,'Chapta','848114',1,0,'2022-03-03 13:21:45','2022-03-03 13:21:45'),(106545,331,'Chhatauna','848134',1,0,'2022-03-03 13:21:45','2022-03-03 13:21:45'),(106546,331,'Chhatneshwar','848301',1,0,'2022-03-03 13:21:45','2022-03-03 13:21:45'),(106547,331,'Chora Tabhka','848211',1,0,'2022-03-03 13:21:45','2022-03-03 13:21:45'),(106548,331,'Dadhia Asadhar','848134',1,0,'2022-03-03 13:21:45','2022-03-03 13:21:45'),(106549,331,'Dalsinghsarai Bazar','848114',1,0,'2022-03-03 13:21:45','2022-03-03 13:21:45'),(106550,331,'Dalsinghsarai','848114',1,0,'2022-03-03 13:21:45','2022-03-03 13:21:45'),(106551,331,'Darwa Mathurapur','848505',1,0,'2022-03-03 13:21:45','2022-03-03 13:21:45'),(106552,331,'Dasaut','848209',1,0,'2022-03-03 13:21:45','2022-03-03 13:21:45'),(106553,331,'Dashara','848501',1,0,'2022-03-03 13:21:45','2022-03-03 13:21:45'),(106554,331,'Daulatpur','848210',1,0,'2022-03-03 13:21:45','2022-03-03 13:21:45'),(106555,331,'Depura','848114',1,0,'2022-03-03 13:21:45','2022-03-03 13:21:45'),(106556,331,'Desari','848211',1,0,'2022-03-03 13:21:45','2022-03-03 13:21:45'),(106557,331,'Dharampur Bandey','848504',1,0,'2022-03-03 13:21:45','2022-03-03 13:21:45'),(106558,331,'Dharmagatpur Bathua','848115',1,0,'2022-03-03 13:21:45','2022-03-03 13:21:45'),(106559,331,'Dharnipatti','848506',1,0,'2022-03-03 13:21:45','2022-03-03 13:21:45'),(106560,331,'Dhobgama','848125',1,0,'2022-03-03 13:21:45','2022-03-03 13:21:45'),(106561,331,'Dhrubgama','848302',1,0,'2022-03-03 13:21:45','2022-03-03 13:21:45'),(106562,331,'Dighra','848115',1,0,'2022-03-03 13:21:45','2022-03-03 13:21:45'),(106563,331,'Dinmanpur','848117',1,0,'2022-03-03 13:21:45','2022-03-03 13:21:45'),(106564,331,'Dumri Bindgama','848506',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106565,331,'Fatehpur Bela','848130',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106566,331,'Gajpatti','848205',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106567,331,'Gangapur','848121',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106568,331,'Gangeshwar Nagar','848502',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106569,331,'Gangsara','848505',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106570,331,'Gaopur','848132',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106571,331,'Garhsisai','848503',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106572,331,'Gauspur Sarsauna','848130',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106573,331,'Geeta Deodha','848208',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106574,331,'Ghataho','848114',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106575,331,'Gohi Bishanpur','848133',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106576,331,'Gopalpur','848102',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106577,331,'Gorgama','848504',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106578,331,'Hajpurwa Karua','848125',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106579,331,'Hansa','848101',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106580,331,'Hansopur','848117',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106581,331,'Harail','848501',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106582,331,'Hardaspur Diara','848506',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106583,331,'Hardia','848209',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106584,331,'Harilochanpur','848127',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106585,331,'Haripur','848216',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106586,331,'Harpur Ailoth','848101',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106587,331,'Harpur Barhetta','848127',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106588,331,'Harpur Bhindi','848122',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106589,331,'Harpur Bochaha','848503',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106590,331,'Harpur Mahmada','848125',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106591,331,'Harpur Pusa','848125',1,0,'2022-03-03 13:21:46','2022-03-03 13:21:46'),(106592,331,'Harpur Rewari','848134',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106593,331,'Hasanpur [Rusera]','848210',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106594,331,'Hasanpur','848205',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106595,331,'Hasanpur Jitwarpur','848134',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106596,331,'Hassanpur S. Mill','848205',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106597,331,'Hatha','848125',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106598,331,'Ilmasnagar','848117',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106599,331,'Indrawara','848505',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106600,331,'Jagannathpur','848209',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106601,331,'Jagdish Paran','848302',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106602,331,'Jagmohra','848207',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106603,331,'Jahangirpur Kothia','848117',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106604,331,'Jahangirpur Lagma','848208',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106605,331,'Jalalpur','848506',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106606,331,'Janakpur','848114',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106607,331,'Janardanpur','848302',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106608,331,'Jaunapur','848501',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106609,331,'Jhajhra','848213',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106610,331,'Jhakhar','848216',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106611,331,'Jhakhra','848127',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106612,331,'Jitwaria','848302',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106613,331,'Jitwarpur Chouth','848134',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106614,331,'Jitwarpur Kumhira','848127',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106615,331,'Jitwarpur','848134',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106616,331,'Jorpura','848504',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106617,331,'Kalaunjar','848125',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106618,331,'Kale Narpatnagar','848206',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106619,331,'Kalyanpur Basti','848502',1,0,'2022-03-03 13:21:47','2022-03-03 13:21:47'),(106620,331,'Kalyanpur Chowk','848302',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106621,331,'Kalyanpur (Samastipur)','848160',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106622,331,'Kamraon','848114',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106623,331,'Kancha','848503',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106624,331,'Kapan','848236',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106625,331,'Karian','848117',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106626,331,'Karihara','848132',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106627,331,'Karpoorigram','848129',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106628,331,'Kasba Tajpur','848130',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106629,331,'Kashipur (Samastipur)','848101',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106630,331,'Kashore','848133',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106631,331,'Keos Nizamat','848134',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106632,331,'Keota','848114',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106633,331,'Kerai','848160',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106634,331,'Keshonarainpur','848504',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106635,331,'Khairi','848117',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106636,331,'Khajuri','848301',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106637,331,'Khalispur','848505',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106638,331,'Khan Mirzapur','848503',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106639,331,'Khanpur','848117',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106640,331,'Kharaj Jitwarpur','848134',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106641,331,'Kishanpur (Samastipur)','848301',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106642,331,'Kishanpur Yusuf','848505',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106643,331,'Koan Bajitpur','848113',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106644,331,'Konaila','848114',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106645,331,'Kubouliram','848131',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106646,331,'Kumaiya','848505',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106647,331,'Kundal (Samastipur)','848206',1,0,'2022-03-03 13:21:48','2022-03-03 13:21:48'),(106648,331,'Kurba Barhetta','848302',1,0,'2022-03-03 13:21:49','2022-03-03 13:21:49'),(106649,331,'Kursaha','848501',1,0,'2022-03-03 13:21:49','2022-03-03 13:21:49'),(106650,331,'L.B.Pura','848101',1,0,'2022-03-03 13:21:49','2022-03-03 13:21:49'),(106651,331,'L.M.Patti','848132',1,0,'2022-03-03 13:21:49','2022-03-03 13:21:49'),(106652,331,'Ladaura Dargah','848302',1,0,'2022-03-03 13:21:49','2022-03-03 13:21:49'),(106653,331,'Lagunia','848504',1,0,'2022-03-03 13:21:49','2022-03-03 13:21:49'),(106654,331,'Lagunia Raghukanth','848101',1,0,'2022-03-03 13:21:49','2022-03-03 13:21:49'),(106655,331,'Lagunia Surya Kanth','848101',1,0,'2022-03-03 13:21:49','2022-03-03 13:21:49'),(106656,331,'Larua','848505',1,0,'2022-03-03 13:21:49','2022-03-03 13:21:49'),(106657,331,'Lilhaul','848209',1,0,'2022-03-03 13:21:49','2022-03-03 13:21:49'),(106658,331,'M.T.Alampur','848236',1,0,'2022-03-03 13:21:49','2022-03-03 13:21:49'),(106659,331,'Madhaipur','848503',1,0,'2022-03-03 13:21:49','2022-03-03 13:21:49'),(106660,331,'Madhopur','848211',1,0,'2022-03-03 13:21:49','2022-03-03 13:21:49'),(106661,331,'Madhopur','848506',1,0,'2022-03-03 13:21:49','2022-03-03 13:21:49'),(106662,331,'Madhopur Dighrua','848122',1,0,'2022-03-03 13:21:49','2022-03-03 13:21:49'),(106663,331,'Madhurapur Tara','848302',1,0,'2022-03-03 13:21:49','2022-03-03 13:21:49'),(106664,331,'Mahathi','848211',1,0,'2022-03-03 13:21:49','2022-03-03 13:21:49'),(106665,331,'Mahen','848208',1,0,'2022-03-03 13:21:49','2022-03-03 13:21:49'),(106666,331,'Mahmadpur Sakra','848160',1,0,'2022-03-03 13:21:49','2022-03-03 13:21:49'),(106667,331,'Mahmmadipur','848502',1,0,'2022-03-03 13:21:49','2022-03-03 13:21:49'),(106668,331,'Mahuli','848208',1,0,'2022-03-03 13:21:49','2022-03-03 13:21:49'),(106669,331,'Malikaur','848115',1,0,'2022-03-03 13:21:49','2022-03-03 13:21:49'),(106670,331,'Malinagar','848125',1,0,'2022-03-03 13:21:49','2022-03-03 13:21:49'),(106671,331,'Manda','848211',1,0,'2022-03-03 13:21:49','2022-03-03 13:21:49'),(106672,331,'Mangalgarh','848208',1,0,'2022-03-03 13:21:49','2022-03-03 13:21:49'),(106673,331,'Manikpur','848127',1,0,'2022-03-03 13:21:49','2022-03-03 13:21:49'),(106674,331,'Manpura','848130',1,0,'2022-03-03 13:21:50','2022-03-03 13:21:50'),(106675,331,'Maricha','848504',1,0,'2022-03-03 13:21:50','2022-03-03 13:21:50'),(106676,331,'Marthua','848207',1,0,'2022-03-03 13:21:50','2022-03-03 13:21:50'),(106677,331,'Masina','848117',1,0,'2022-03-03 13:21:50','2022-03-03 13:21:50'),(106678,331,'Mathurapur','848101',1,0,'2022-03-03 13:21:50','2022-03-03 13:21:50'),(106679,331,'Mathurapur','848114',1,0,'2022-03-03 13:21:50','2022-03-03 13:21:50'),(106680,331,'Matiur','848501',1,0,'2022-03-03 13:21:50','2022-03-03 13:21:50'),(106681,331,'Mau Dhaneshpur','848503',1,0,'2022-03-03 13:21:50','2022-03-03 13:21:50'),(106682,331,'Mehsari','848114',1,0,'2022-03-03 13:21:50','2022-03-03 13:21:50'),(106683,331,'Mehsi','848160',1,0,'2022-03-03 13:21:50','2022-03-03 13:21:50'),(106684,331,'Mishratol','848114',1,0,'2022-03-03 13:21:50','2022-03-03 13:21:50'),(106685,331,'Mohammedpur Koari','848131',1,0,'2022-03-03 13:21:50','2022-03-03 13:21:50'),(106686,331,'Mohanpur','848506',1,0,'2022-03-03 13:21:50','2022-03-03 13:21:50'),(106687,331,'Mohanpur','848101',1,0,'2022-03-03 13:21:50','2022-03-03 13:21:50'),(106688,331,'Mohiuddin Nagar R.S','848502',1,0,'2022-03-03 13:21:50','2022-03-03 13:21:50'),(106689,331,'Mohiuddin Nagar','848501',1,0,'2022-03-03 13:21:50','2022-03-03 13:21:50'),(106690,331,'Mohiuddinpur Rajwa','848131',1,0,'2022-03-03 13:21:50','2022-03-03 13:21:50'),(106691,331,'Mordiwa','848134',1,0,'2022-03-03 13:21:50','2022-03-03 13:21:50'),(106692,331,'Morsand','848115',1,0,'2022-03-03 13:21:50','2022-03-03 13:21:50'),(106693,331,'Morwa','848121',1,0,'2022-03-03 13:21:50','2022-03-03 13:21:50'),(106694,331,'Morwara-i','848209',1,0,'2022-03-03 13:21:50','2022-03-03 13:21:50'),(106695,331,'Morwara-Ii','848209',1,0,'2022-03-03 13:21:50','2022-03-03 13:21:50'),(106696,331,'Motipur','848210',1,0,'2022-03-03 13:21:50','2022-03-03 13:21:50'),(106697,331,'Motipur','848130',1,0,'2022-03-03 13:21:50','2022-03-03 13:21:50'),(106698,331,'Mukhtiarpur','848114',1,0,'2022-03-03 13:21:50','2022-03-03 13:21:50'),(106699,331,'Muktapur','848102',1,0,'2022-03-03 13:21:51','2022-03-03 13:21:51'),(106700,331,'Muradpur','848210',1,0,'2022-03-03 13:21:51','2022-03-03 13:21:51'),(106701,331,'Musapur','848114',1,0,'2022-03-03 13:21:51','2022-03-03 13:21:51'),(106702,331,'Nakuni','848206',1,0,'2022-03-03 13:21:51','2022-03-03 13:21:51'),(106703,331,'Namapur','848125',1,0,'2022-03-03 13:21:51','2022-03-03 13:21:51'),(106704,331,'Narhan','848211',1,0,'2022-03-03 13:21:51','2022-03-03 13:21:51'),(106705,331,'Narpa','848207',1,0,'2022-03-03 13:21:51','2022-03-03 13:21:51'),(106706,331,'Nathudwar','848236',1,0,'2022-03-03 13:21:51','2022-03-03 13:21:51'),(106707,331,'Nauraga','848102',1,0,'2022-03-03 13:21:51','2022-03-03 13:21:51'),(106708,331,'Nayanagar','848208',1,0,'2022-03-03 13:21:51','2022-03-03 13:21:51'),(106709,331,'Nikaspur Nisfi','848121',1,0,'2022-03-03 13:21:51','2022-03-03 13:21:51'),(106710,331,'Nirpur','848129',1,0,'2022-03-03 13:21:51','2022-03-03 13:21:51'),(106711,331,'Nirpur Bharwaria','848209',1,0,'2022-03-03 13:21:51','2022-03-03 13:21:51'),(106712,331,'P.Pur Halai','848505',1,0,'2022-03-03 13:21:51','2022-03-03 13:21:51'),(106713,331,'Pachbhinda','848505',1,0,'2022-03-03 13:21:51','2022-03-03 13:21:51'),(106714,331,'Pachpaika','848114',1,0,'2022-03-03 13:21:51','2022-03-03 13:21:51'),(106715,331,'Pagra','848114',1,0,'2022-03-03 13:21:51','2022-03-03 13:21:51'),(106716,331,'Pan Basadhia','848114',1,0,'2022-03-03 13:21:51','2022-03-03 13:21:51'),(106717,331,'Pandit Tol Tabhka','848114',1,0,'2022-03-03 13:21:51','2022-03-03 13:21:51'),(106718,331,'Paroria','848114',1,0,'2022-03-03 13:21:51','2022-03-03 13:21:51'),(106719,331,'Paroria','848301',1,0,'2022-03-03 13:21:51','2022-03-03 13:21:51'),(106720,331,'Parwana','848117',1,0,'2022-03-03 13:21:51','2022-03-03 13:21:51'),(106721,331,'Pataili','848132',1,0,'2022-03-03 13:21:51','2022-03-03 13:21:51'),(106722,331,'Patailia','848211',1,0,'2022-03-03 13:21:51','2022-03-03 13:21:51'),(106723,331,'Patory B.C.Chowk','848125',1,0,'2022-03-03 13:21:51','2022-03-03 13:21:51'),(106724,331,'Patory Bazar Cinema Chowk','848504',1,0,'2022-03-03 13:21:51','2022-03-03 13:21:51'),(106725,331,'Patory','848504',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106726,331,'Patpara','848236',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106727,331,'Patsa','848206',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106728,331,'Phulhara','848209',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106729,331,'Pokhraira','848113',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106730,331,'Punas','848113',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106731,331,'Purnahi','848301',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106732,331,'Pusa','848125',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106733,331,'Pushaho','848207',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106734,331,'R.R.Bhadrapur','848117',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106735,331,'Raghopur','848211',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106736,331,'Raghunathpur','848505',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106737,331,'Rahimabad','848130',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106738,331,'Rahiyar Kochi','848209',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106739,331,'Rahmatpur','848101',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106740,331,'Rahua','848210',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106741,331,'Rahua','848133',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106742,331,'Raipur Buzurg','848505',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106743,331,'Rajajan','848502',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106744,331,'Rajpur','848501',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106745,331,'Rajwara','848210',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106746,331,'Ramapur Maheshpur','848121',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106747,331,'Ramchandarpur','848127',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106748,331,'Rampur Dudhpura','848101',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106749,331,'Rampur Jalalpur','848114',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106750,331,'Rampur Kushaiya','848301',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106751,331,'Rampur Rajwa','848205',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106752,331,'Rampur Samthu','848132',1,0,'2022-03-03 13:21:52','2022-03-03 13:21:52'),(106753,331,'Raniparti','848117',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106754,331,'Ranitol','848113',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106755,331,'Rasalpur','848506',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106756,331,'Rasalpur Dharha','848210',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106757,331,'Raspur Patasia','848503',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106758,331,'Ratanpur Bela','848113',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106759,331,'Rebra','848117',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106760,331,'Rosera','848210',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106761,331,'Rupauli','848132',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106762,331,'Rusera Thana','848125',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106763,331,'Rusera Thana','848210',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106764,331,'Sadipur','848133',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106765,331,'Sadipurghat','848117',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106766,331,'Sagma','848132',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106767,331,'Sahpur Undi','848504',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106768,331,'Saidpur','848125',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106769,331,'Sakarpura','848205',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106770,331,'Sakhmohan','848211',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106771,331,'Sakhwa','848207',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106772,331,'Sakrichandpusa','848125',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106773,331,'Salha Buzurg','848207',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106774,331,'Samartha','848160',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106775,331,'Samastipur Bazar','848101',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106776,331,'Samastipur H.O','848101',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106777,331,'Sarairanjan','848127',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106778,331,'Sarangpur','848505',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106779,331,'Sari','848101',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106780,331,'Sasan','848205',1,0,'2022-03-03 13:21:53','2022-03-03 13:21:53'),(106781,331,'Satanpur','848132',1,0,'2022-03-03 13:21:54','2022-03-03 13:21:54'),(106782,331,'Satmalpur','848101',1,0,'2022-03-03 13:21:54','2022-03-03 13:21:54'),(106783,331,'Shahpur Baghauni','848131',1,0,'2022-03-03 13:21:54','2022-03-03 13:21:54'),(106784,331,'Shambhupatti','848129',1,0,'2022-03-03 13:21:54','2022-03-03 13:21:54'),(106785,331,'Shankarpur','848117',1,0,'2022-03-03 13:21:54','2022-03-03 13:21:54'),(106786,331,'Shekhopur','848101',1,0,'2022-03-03 13:21:54','2022-03-03 13:21:54'),(106787,331,'Sheora','848504',1,0,'2022-03-03 13:21:54','2022-03-03 13:21:54'),(106788,331,'Sherpur Dhepura','848503',1,0,'2022-03-03 13:21:54','2022-03-03 13:21:54'),(106789,331,'Sibaisingpur','848502',1,0,'2022-03-03 13:21:54','2022-03-03 13:21:54'),(106790,331,'Sihma','848207',1,0,'2022-03-03 13:21:54','2022-03-03 13:21:54'),(106791,331,'Simri','848503',1,0,'2022-03-03 13:21:54','2022-03-03 13:21:54'),(106792,331,'Singhia Ghat','848236',1,0,'2022-03-03 13:21:54','2022-03-03 13:21:54'),(106793,331,'Singhia','848209',1,0,'2022-03-03 13:21:54','2022-03-03 13:21:54'),(106794,331,'Singhiakhurd','848113',1,0,'2022-03-03 13:21:54','2022-03-03 13:21:54'),(106795,331,'Soeral','848114',1,0,'2022-03-03 13:21:54','2022-03-03 13:21:54'),(106796,331,'Sohma','848207',1,0,'2022-03-03 13:21:54','2022-03-03 13:21:54'),(106797,331,'Soman','848117',1,0,'2022-03-03 13:21:54','2022-03-03 13:21:54'),(106798,331,'Somnaha Mirzanagar','848125',1,0,'2022-03-03 13:21:54','2022-03-03 13:21:54'),(106799,331,'Songar','848122',1,0,'2022-03-03 13:21:54','2022-03-03 13:21:54'),(106800,331,'Sonsa','848209',1,0,'2022-03-03 13:21:54','2022-03-03 13:21:54'),(106801,331,'Sonupur','848210',1,0,'2022-03-03 13:21:54','2022-03-03 13:21:54'),(106802,331,'Sormar Baghla','848125',1,0,'2022-03-03 13:21:54','2022-03-03 13:21:54'),(106803,331,'Srichandpur Kothia','848122',1,0,'2022-03-03 13:21:54','2022-03-03 13:21:54'),(106804,331,'Srikameshwar Nagar','848209',1,0,'2022-03-03 13:21:54','2022-03-03 13:21:54'),(106805,331,'Sripur Gahar','848117',1,0,'2022-03-03 13:21:54','2022-03-03 13:21:54'),(106806,331,'Sultanpur East','848501',1,0,'2022-03-03 13:21:54','2022-03-03 13:21:54'),(106807,331,'Sultanpur West','848501',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106808,331,'Sumbha Deorhi','848209',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106809,331,'Surauli','848211',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106810,331,'Tajpur (Samastipur)','848130',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106811,331,'Tara','848209',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106812,331,'Taradhamaun','848504',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106813,331,'Tetarpur','848502',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106814,331,'Thahra Gopalpur','848115',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106815,331,'Udaipur','848210',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106816,331,'Ujan','848207',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106817,331,'Ujiarpur','848132',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106818,331,'Vidhyapati Nagar','848503',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106819,331,'Waini','848131',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106820,331,'Wari','848209',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106821,331,'Warish Nagar','848133',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106822,331,'Hetanpur','844506',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106823,331,'Inayatpur','844506',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106824,331,'Supaul','844501',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106825,332,'Aami','841207',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106826,332,'Afaur','841414',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106827,332,'Agauthar','841411',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106828,332,'Amar Chapra','841414',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106829,332,'Amardah','841421',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106830,332,'Amdarhi','841208',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106831,332,'Amnour Harnarain','841401',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106832,332,'Amnour','841401',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106833,332,'Anjani','841219',1,0,'2022-03-03 13:21:55','2022-03-03 13:21:55'),(106834,332,'Anwal','841213',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106835,332,'Aphar','841402',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106836,332,'Arbindnagar','841221',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106837,332,'Ardewa','841424',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106838,332,'Arna','841417',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106839,332,'Aruwa','841224',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106840,332,'Arwa','841442',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106841,332,'Asahani','841204',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106842,332,'Ashoknagar','841412',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106843,332,'Atarsan','841204',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106844,332,'Atta','841419',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106845,332,'Awari','841419',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106846,332,'B.T.Kohra','841219',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106847,332,'Babhangawa','841219',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106848,332,'Badar Zamin','841224',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106849,332,'Badhakol','841215',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106850,332,'Badlu Tola','841414',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106851,332,'Bahrauli','841417',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106852,332,'Baijalpur Keso','841101',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106853,332,'Bajaiha','841221',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106854,332,'Baksanda','841219',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106855,332,'Baldiha','841401',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106856,332,'Banauta','841215',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106857,332,'Bangra','841205',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106858,332,'Baniapur','841403',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106859,332,'Banpura Bazar','841206',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106860,332,'Banpura Bazar','841212',1,0,'2022-03-03 13:21:56','2022-03-03 13:21:56'),(106861,332,'Bansdila','841412',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106862,332,'Bansohi','841417',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106863,332,'Bardahiya','841419',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106864,332,'Bareja (Saran)','841201',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106865,332,'Barka Baneya','841219',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106866,332,'Barua','841101',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106867,332,'Barwakhurd','841205',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106868,332,'Barwe','841219',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106869,332,'Basahi','841206',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106870,332,'Basant','841202',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106871,332,'Basantpur Bangla','841401',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106872,332,'Basti Jalal','841221',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106873,332,'Bela','841221',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106874,332,'Belhari','841424',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106875,332,'Bellour','841410',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106876,332,'Berui','841403',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106877,332,'Bhagwan Bazar','841301',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106878,332,'Bhagwanpur','841219',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106879,332,'Bhagwatpur','841424',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106880,332,'Bhainsmara','841311',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106881,332,'Bhalua Bhikhari','841424',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106882,332,'Bhaluhi','841419',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106883,332,'Bharpura','841101',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106884,332,'Bhatgai','841424',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106885,332,'Bhatha','841215',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106886,332,'Bhatha Sonho','841460',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106887,332,'Bhatkeshri','841403',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106888,332,'Bhatwalia','841214',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106889,332,'Bhawalpur','841401',1,0,'2022-03-03 13:21:57','2022-03-03 13:21:57'),(106890,332,'Bheldi','841402',1,0,'2022-03-03 13:21:58','2022-03-03 13:21:58'),(106891,332,'Bhithi Sahabuddin','841411',1,0,'2022-03-03 13:21:58','2022-03-03 13:21:58'),(106892,332,'Bhorahopur','841208',1,0,'2022-03-03 13:21:58','2022-03-03 13:21:58'),(106893,332,'Bhorha','841424',1,0,'2022-03-03 13:21:58','2022-03-03 13:21:58'),(106894,332,'Bhualpur','841415',1,0,'2022-03-03 13:21:58','2022-03-03 13:21:58'),(106895,332,'Bigaha','841212',1,0,'2022-03-03 13:21:58','2022-03-03 13:21:58'),(106896,332,'Bishunpura Kala','841208',1,0,'2022-03-03 13:21:58','2022-03-03 13:21:58'),(106897,332,'Bodha Chapra','841225',1,0,'2022-03-03 13:21:58','2022-03-03 13:21:58'),(106898,332,'Brit Bhagwanpr','841410',1,0,'2022-03-03 13:21:58','2022-03-03 13:21:58'),(106899,332,'Chainwa','841204',1,0,'2022-03-03 13:21:58','2022-03-03 13:21:58'),(106900,332,'Chakia','841410',1,0,'2022-03-03 13:21:58','2022-03-03 13:21:58'),(106901,332,'Chanchaura','841414',1,0,'2022-03-03 13:21:58','2022-03-03 13:21:58'),(106902,332,'Chanchaura','841204',1,0,'2022-03-03 13:21:58','2022-03-03 13:21:58'),(106903,332,'Chandpurwa','841411',1,0,'2022-03-03 13:21:58','2022-03-03 13:21:58'),(106904,332,'Chapra H.O','841301',1,0,'2022-03-03 13:21:58','2022-03-03 13:21:58'),(106905,332,'Chatra','841213',1,0,'2022-03-03 13:21:58','2022-03-03 13:21:58'),(106906,332,'Cheful','841209',1,0,'2022-03-03 13:21:58','2022-03-03 13:21:58'),(106907,332,'Chhapia','841417',1,0,'2022-03-03 13:21:58','2022-03-03 13:21:58'),(106908,332,'Chhitraulia','841208',1,0,'2022-03-03 13:21:58','2022-03-03 13:21:58'),(106909,332,'Chirand','841211',1,0,'2022-03-03 13:21:58','2022-03-03 13:21:58'),(106910,332,'Choranwa','841403',1,0,'2022-03-03 13:21:58','2022-03-03 13:21:58'),(106911,332,'D.Sultanpur','841202',1,0,'2022-03-03 13:21:58','2022-03-03 13:21:58'),(106912,332,'Dariapur','841221',1,0,'2022-03-03 13:21:58','2022-03-03 13:21:58'),(106913,332,'Darihara','841101',1,0,'2022-03-03 13:21:58','2022-03-03 13:21:58'),(106914,332,'Daudpur (Saran)','841205',1,0,'2022-03-03 13:21:58','2022-03-03 13:21:58'),(106915,332,'Dayalpur (Saran)','841206',1,0,'2022-03-03 13:21:58','2022-03-03 13:21:58'),(106916,332,'Deo Bahuara','841442',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106917,332,'Deopura','841212',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106918,332,'Deorhi','841401',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106919,332,'Deoria','841213',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106920,332,'Dewaria','841225',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106921,332,'Dhamsar','841224',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106922,332,'Dhanaw','841403',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106923,332,'Dhangarha','841403',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106924,332,'Dharhara Kala','841402',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106925,332,'Dharmapura','841201',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106926,332,'Dhelhari','841214',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106927,332,'Dhenuki','841417',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106928,332,'Dholahi Kaithal','841402',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106929,332,'Dhoopnagar Dhobawal','841412',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106930,332,'Dighwara','841207',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106931,332,'District Board','841301',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106932,332,'Dohar','841204',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106933,332,'Domaigarh','841209',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106934,332,'Doriganj','841211',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106935,332,'Dubauli','841410',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106936,332,'Dumari Balua','841216',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106937,332,'Dumari Bujurg','841217',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106938,332,'Dumari Chapia','841417',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106939,332,'Dumarshan Bangra','841410',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106940,332,'Dumri','841313',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106941,332,'Dumri','841424',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106942,332,'Ekma Chaulk','841208',1,0,'2022-03-03 13:21:59','2022-03-03 13:21:59'),(106943,332,'Ekma Nautan','841208',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106944,332,'Ekma','841208',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106945,332,'Eksar','841204',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106946,332,'Enai','841305',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106947,332,'Fakuli','841316',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106948,332,'Fatehpur Chain','841202',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106949,332,'Fherusa','841415',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106950,332,'Fulwaria Tajpur','841209',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106951,332,'Fursatpur','841222',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106952,332,'G.Durgapur','841313',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106953,332,'G.Mehia','841301',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106954,332,'G.N.Parshurampur','841401',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106955,332,'G.Piparpanti','841403',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106956,332,'G.S.Bangra','841412',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106957,332,'Gamahria','841421',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106958,332,'Gariba Tola','841312',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106959,332,'Garkha','841311',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106960,332,'Gaura (Saran)','841443',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106961,332,'Gawandri','841424',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106962,332,'Gheghta','841301',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106963,332,'Ghorhat Mathia','841313',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106964,332,'Gohpur','841311',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106965,332,'Gola Mubarkpur','841209',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106966,332,'Gopalpur','841217',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106967,332,'Goraipur','841207',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106968,332,'Govindchak','841101',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106969,332,'Gultenganj','841211',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106970,332,'H.Karah','841403',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106971,332,'Hafijzpur','841422',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106972,332,'Haraji','841207',1,0,'2022-03-03 13:22:00','2022-03-03 13:22:00'),(106973,332,'Harihar Kshetra','841101',1,0,'2022-03-03 13:22:01','2022-03-03 13:22:01'),(106974,332,'Hariharpur','841403',1,0,'2022-03-03 13:22:01','2022-03-03 13:22:01'),(106975,332,'Harpur','841208',1,0,'2022-03-03 13:22:01','2022-03-03 13:22:01'),(106976,332,'Hasulahi Dwariya','841213',1,0,'2022-03-03 13:22:01','2022-03-03 13:22:01'),(106977,332,'Hushepur','841220',1,0,'2022-03-03 13:22:01','2022-03-03 13:22:01'),(106978,332,'Husseepur','841419',1,0,'2022-03-03 13:22:01','2022-03-03 13:22:01'),(106979,332,'Inayatpur','841205',1,0,'2022-03-03 13:22:01','2022-03-03 13:22:01'),(106980,332,'Ishrauli','841419',1,0,'2022-03-03 13:22:01','2022-03-03 13:22:01'),(106981,332,'Ishuwapur','841411',1,0,'2022-03-03 13:22:01','2022-03-03 13:22:01'),(106982,332,'Ismela','841221',1,0,'2022-03-03 13:22:01','2022-03-03 13:22:01'),(106983,332,'Itawa','841202',1,0,'2022-03-03 13:22:01','2022-03-03 13:22:01'),(106984,332,'J.Vishunpura','841211',1,0,'2022-03-03 13:22:01','2022-03-03 13:22:01'),(106985,332,'Jagarnathpur','841222',1,0,'2022-03-03 13:22:01','2022-03-03 13:22:01'),(106986,332,'Jagdam College','841301',1,0,'2022-03-03 13:22:01','2022-03-03 13:22:01'),(106987,332,'Jaithar','841417',1,0,'2022-03-03 13:22:01','2022-03-03 13:22:01'),(106988,332,'Jaitipur','841207',1,0,'2022-03-03 13:22:01','2022-03-03 13:22:01'),(106989,332,'Jaitpur Bharwalia','841205',1,0,'2022-03-03 13:22:01','2022-03-03 13:22:01'),(106990,332,'Jalalpur Bazar','841412',1,0,'2022-03-03 13:22:01','2022-03-03 13:22:01'),(106991,332,'Jamanpura','841201',1,0,'2022-03-03 13:22:01','2022-03-03 13:22:01'),(106992,332,'Jayee Chapra','841209',1,0,'2022-03-03 13:22:01','2022-03-03 13:22:01'),(106993,332,'Jhakhra','841401',1,0,'2022-03-03 13:22:01','2022-03-03 13:22:01'),(106994,332,'Jhaua','841216',1,0,'2022-03-03 13:22:01','2022-03-03 13:22:01'),(106995,332,'Jigna Parsa','841305',1,0,'2022-03-03 13:22:01','2022-03-03 13:22:01'),(106996,332,'Jogia','841212',1,0,'2022-03-03 13:22:01','2022-03-03 13:22:01'),(106997,332,'K.Manohar','841403',1,0,'2022-03-03 13:22:01','2022-03-03 13:22:01'),(106998,332,'K.P.Rampur','841211',1,0,'2022-03-03 13:22:01','2022-03-03 13:22:01'),(106999,332,'Kachnar','841214',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107000,332,'Kahi','841412',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107001,332,'Kaituka Nandan','841460',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107002,332,'Kakaria','841414',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107003,332,'Kakrahat','841222',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107004,332,'Kamta','841403',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107005,332,'Kanar Hariharpur','841414',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107006,332,'Kans Diara','841216',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107007,332,'Karahi','841220',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107008,332,'Karanpura','841401',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107009,332,'Katsa','841311',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107010,332,'Kawalpura','841417',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107011,332,'Kerwa','841411',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107012,332,'Keshri Mathia','841220',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107013,332,'Kewani','841311',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107014,332,'Khabsi','841443',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107015,332,'Khaira (Saran)','841414',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107016,332,'Khairwar','841214',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107017,332,'Khajuhatti','841209',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107018,332,'Khalpura','841211',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107019,332,'Khanpur','841207',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107020,332,'Khanpur','841208',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107021,332,'Khardahiya','841205',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107022,332,'Kharika','841101',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107023,332,'Khodaibagh','841415',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107024,332,'Kishunpur','841412',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107025,332,'Kohra','841205',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107026,332,'Kolhua','841422',1,0,'2022-03-03 13:22:02','2022-03-03 13:22:02'),(107027,332,'Kopa Bazar','841214',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107028,332,'Kopa Samhota','841213',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107029,332,'Koreya','841218',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107030,332,'Kotheya','841412',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107031,332,'Kotheya','841216',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107032,332,'Kudarbadha','841202',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107033,332,'Kumna','841205',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107034,332,'Lachhi Kaituka','841460',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107035,332,'Lahladpur','841224',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107036,332,'Late Rahiya','841219',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107037,332,'Lauwa','841424',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107038,332,'Lauwa Kala','841403',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107039,332,'Lejuar','841205',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107040,332,'Lohatola','841301',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107041,332,'M.Kuari','841219',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107042,332,'Madansath','841201',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107043,332,'Madarpur','841311',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107044,332,'Madarpur','841422',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107045,332,'Madhopur','841415',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107046,332,'Magaidih','841316',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107047,332,'Mahamda','841301',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107048,332,'Majhanpura','841305',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107049,332,'Majlishpur','841213',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107050,332,'Maker','841215',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107051,332,'Malkhachak','841207',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107052,332,'Mane','841205',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107053,332,'Mangolapur','841412',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107054,332,'Manikpura','841206',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107055,332,'Manikpura','841220',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107056,332,'Manjhi','841313',1,0,'2022-03-03 13:22:03','2022-03-03 13:22:03'),(107057,332,'Manpur','841414',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107058,332,'Manupur','841207',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107059,332,'Marar','841219',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107060,332,'Marhowrah H.O','841418',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107061,332,'Maricha','841411',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107062,332,'Masrakh','841417',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107063,332,'Masti Chak','841219',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107064,332,'Matiyar','841209',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107065,332,'Mauna','841301',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107066,332,'Meera Mushehri','841414',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107067,332,'Mehrauli','841211',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107068,332,'Methwalia','841213',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107069,332,'Mirjapur Zuara','841216',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107070,332,'Mirzapur Khurd Lauwa','841403',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107071,332,'Mirzapur (Saran)','841419',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107072,332,'Mohamadpur','841223',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107073,332,'Mohammadpur','841311',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107074,332,'Moreya','841424',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107075,332,'Mothaha','841442',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107076,332,'Mubarakpur','841415',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107077,332,'Mujauna','841207',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107078,332,'Mukrera','841213',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107079,332,'Murarpur','841403',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107080,332,'Mushehri','841414',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107081,332,'Nachap','841208',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107082,332,'Nagdiha','841403',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107083,332,'Nagra (Saran)','841442',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107084,332,'Naini (Saran)','841316',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107085,332,'Nandpur','841313',1,0,'2022-03-03 13:22:04','2022-03-03 13:22:04'),(107086,332,'Naraon','841216',1,0,'2022-03-03 13:22:05','2022-03-03 13:22:05'),(107087,332,'Narayanpur','841401',1,0,'2022-03-03 13:22:05','2022-03-03 13:22:05'),(107088,332,'Narharpur','841443',1,0,'2022-03-03 13:22:05','2022-03-03 13:22:05'),(107089,332,'Narpaliya','841313',1,0,'2022-03-03 13:22:05','2022-03-03 13:22:05'),(107090,332,'Narwan','841223',1,0,'2022-03-03 13:22:05','2022-03-03 13:22:05'),(107091,332,'Nautan','841401',1,0,'2022-03-03 13:22:05','2022-03-03 13:22:05'),(107092,332,'Nawada','841417',1,0,'2022-03-03 13:22:05','2022-03-03 13:22:05'),(107093,332,'Nawada','841412',1,0,'2022-03-03 13:22:05','2022-03-03 13:22:05'),(107094,332,'Nayagaon','841217',1,0,'2022-03-03 13:22:05','2022-03-03 13:22:05'),(107095,332,'Nstwar Semaria','841214',1,0,'2022-03-03 13:22:05','2022-03-03 13:22:05'),(107096,332,'Olahanpur','841415',1,0,'2022-03-03 13:22:05','2022-03-03 13:22:05'),(107097,332,'P.B.Chapra','841401',1,0,'2022-03-03 13:22:05','2022-03-03 13:22:05'),(107098,332,'Pachbhinda','841424',1,0,'2022-03-03 13:22:05','2022-03-03 13:22:05'),(107099,332,'Pachlakh','841402',1,0,'2022-03-03 13:22:05','2022-03-03 13:22:05'),(107100,332,'Pachraur','841424',1,0,'2022-03-03 13:22:05','2022-03-03 13:22:05'),(107101,332,'Pachrukhi','841402',1,0,'2022-03-03 13:22:05','2022-03-03 13:22:05'),(107102,332,'Pachua','841220',1,0,'2022-03-03 13:22:05','2022-03-03 13:22:05'),(107103,332,'Paharpur','841301',1,0,'2022-03-03 13:22:05','2022-03-03 13:22:05'),(107104,332,'Pahleza Barka','841101',1,0,'2022-03-03 13:22:05','2022-03-03 13:22:05'),(107105,332,'Paiga','841218',1,0,'2022-03-03 13:22:05','2022-03-03 13:22:05'),(107106,332,'Pakari','841417',1,0,'2022-03-03 13:22:05','2022-03-03 13:22:05'),(107107,332,'Pakri Mohamdpur','841218',1,0,'2022-03-03 13:22:05','2022-03-03 13:22:05'),(107108,332,'Panditpur','841224',1,0,'2022-03-03 13:22:05','2022-03-03 13:22:05'),(107109,332,'Parauna','841424',1,0,'2022-03-03 13:22:05','2022-03-03 13:22:05'),(107110,332,'Parmanandpur','841101',1,0,'2022-03-03 13:22:05','2022-03-03 13:22:05'),(107111,332,'Parsa','841219',1,0,'2022-03-03 13:22:05','2022-03-03 13:22:05'),(107112,332,'Parsagarh','841220',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107113,332,'Parsajogini','841311',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107114,332,'Parsauna','841219',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107115,332,'Patti Sital','841222',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107116,332,'Phulwaria','841460',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107117,332,'Piaridih','841222',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107118,332,'Pipra','841422',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107119,332,'Pirauna','841301',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107120,332,'Pirautha','841443',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107121,332,'Pirmaker','841215',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107122,332,'Piyarepur','841410',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107123,332,'Pojhi','841219',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107124,332,'Pokhrera','841424',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107125,332,'Pratapur (Saran)','841225',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107126,332,'Puchhari','841403',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107127,332,'Puchitikala','841206',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107128,332,'Puraina','841401',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107129,332,'Purushottampur Nazirganj','841224',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107130,332,'Purwari Telpa','841302',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107131,332,'Rahampur','841202',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107132,332,'Rahimpur','841101',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107133,332,'Rajdhani','841424',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107134,332,'Rajendra College (Saran)','841301',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107135,332,'Ram Chaura','841411',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107136,332,'Ramgarha','841202',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107137,332,'Rampur Atauli','841421',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107138,332,'Rampur','841311',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107139,332,'Rampur Bindalal','841220',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107140,332,'Rampur Kala','841414',1,0,'2022-03-03 13:22:06','2022-03-03 13:22:06'),(107141,332,'Rampur Khorram','841442',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107142,332,'Rampur Rudra','841424',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107143,332,'Rasalpura','841211',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107144,332,'Rasidpur','841415',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107145,332,'Rasuali','841417',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107146,332,'Rasualpur Chatti','841204',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107147,332,'Rasulpur','841419',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107148,332,'Revelganj','841305',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107149,332,'Rewari','841213',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107150,332,'Rith','841208',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107151,332,'Russi','841205',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107152,332,'Sabalpur','841101',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107153,332,'Sadhpur','841415',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107154,332,'Safari','841208',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107155,332,'Sahajitpur','841422',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107156,332,'Sahar Chapra','841219',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107157,332,'Sahawa','841411',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107158,332,'Sahbazadtola','841312',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107159,332,'Saidpur','841207',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107160,332,'Saidpur','841216',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107161,332,'Saidsarai','841311',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107162,332,'Sakaddi','841412',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107163,332,'Salempur','841411',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107164,332,'Salimapur','841443',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107165,332,'Saraibuksh','841311',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107166,332,'Saraiya','841101',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107167,332,'Saraon','841212',1,0,'2022-03-03 13:22:07','2022-03-03 13:22:07'),(107168,332,'Saraya','841403',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107169,332,'Sardha','841301',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107170,332,'Sareya Basant','841401',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107171,332,'Sarhwara','841421',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107172,332,'Sarmi','841422',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107173,332,'Satjora Bazar','841410',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107174,332,'Satna','841403',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107175,332,'Sauri Buxi Zee','841412',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107176,332,'Semri','841421',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107177,332,'Senduari','841419',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107178,332,'Sengar Tola','841305',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107179,332,'Serampur','841460',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107180,332,'Sherukaha','841417',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107181,332,'Shio Mohammadpur','841443',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107182,332,'Shitalpur Bazar','841201',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107183,332,'Shyam Kauria','841411',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107184,332,'Sikarpur','841101',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107185,332,'Sikati Bhikham','841421',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107186,332,'Silhauri','841419',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107187,332,'Sirsia','841305',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107188,332,'Sisai','841422',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107189,332,'Sitabdiara','841312',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107190,332,'Sitalpur','841221',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107191,332,'Sobhepur','841311',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107192,332,'Sohai.Sharpur','841403',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107193,332,'Sonauli','841421',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107194,332,'Sonbarsa','841313',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107195,332,'Sonepur R.S','841101',1,0,'2022-03-03 13:22:08','2022-03-03 13:22:08'),(107196,332,'Sonepur (Saran)','841101',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107197,332,'Sonia','841205',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107198,332,'Sutihar','841222',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107199,332,'T.M.Pal','841101',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107200,332,'Taraiya','841424',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107201,332,'Tari','841301',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107202,332,'Tarwa Pojhia','841205',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107203,332,'Tarwar','841419',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107204,332,'Tejpurwa','841419',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107205,332,'Telcha','841224',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107206,332,'Terha','841411',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107207,332,'Tujarpur','841442',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107208,332,'Unehchak','841221',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107209,332,'Usari Kala','841443',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107210,332,'Ushri Chandrapura','841424',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107211,332,'Ushti','841403',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107212,332,'Zilkabad','841211',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107213,333,'Abgil Chandey','811105',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107214,333,'Afni','811105',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107215,333,'Akarha','811304',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107216,333,'Ambari','811103',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107217,333,'Asthama','811304',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107218,333,'Asthana','811101',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107219,333,'Audhey','811105',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107220,333,'Babhanbigha','811101',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107221,333,'Barbigha','811101',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107222,333,'Belaw','811101',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107223,333,'Belchhi','811315',1,0,'2022-03-03 13:22:09','2022-03-03 13:22:09'),(107224,333,'Belchhi','811105',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107225,333,'Bhadausi','811107',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107226,333,'Bhadous','811107',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107227,333,'Bhojdih','811105',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107228,333,'Biman','811105',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107229,333,'Brindaban','811105',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107230,333,'C.R.Barbigha Ed So','811201',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107231,333,'Chakandra','811304',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107232,333,'Charuawan','811103',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107233,333,'Chewara','811304',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107234,333,'Chhatiara','811304',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107235,333,'Chordargah','811304',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107236,333,'Chorwar','811105',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107237,333,'D. Lodipur','811105',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107238,333,'Deoley','811105',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107239,333,'Dih Kushumbha','811107',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107240,333,'Diha','811105',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107241,333,'Ekrama','811304',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107242,333,'Gabai','811105',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107243,333,'Gagaur','811102',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107244,333,'Gagri','811304',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107245,333,'Hassari','811304',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107246,333,'Hathiyama','811105',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107247,333,'Hussainabad','811105',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107248,333,'Jean Bigha','811103',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107249,333,'K Milki Chak','811101',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107250,333,'Kaithwan','811107',1,0,'2022-03-03 13:22:10','2022-03-03 13:22:10'),(107251,333,'Kajifatuchak','811101',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107252,333,'Kamta','811105',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107253,333,'Karandey','811304',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107254,333,'Kare','811105',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107255,333,'Karki','811105',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107256,333,'Kasar','811105',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107257,333,'Katari','811102',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107258,333,'Kewti','811101',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107259,333,'Kishanpur','811101',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107260,333,'Kusherhi','811105',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107261,333,'Kushumbha','811105',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107262,333,'Kuthaut','811101',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107263,333,'Lodipur','811105',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107264,333,'Lohan','811304',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107265,333,'Mafo','811102',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107266,333,'Maldah','811101',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107267,333,'Mandana','811105',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107268,333,'Maninda','811105',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107269,333,'Masodha','811105',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107270,333,'Maur','811101',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107271,333,'Mehus','811102',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107272,333,'Mobarakpur','811105',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107273,333,'Navinagar Kakrar','811105',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107274,333,'Nimi','811103',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107275,333,'Onama','811101',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107276,333,'Pachana','811107',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107277,333,'Paharia','811103',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107278,333,'Pain','811105',1,0,'2022-03-03 13:22:11','2022-03-03 13:22:11'),(107279,333,'Panhesa','811103',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107280,333,'Pathraitha','811105',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107281,333,'Pharpar','811105',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107282,333,'Pinjari','811105',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107283,333,'Ramjan Pur','811101',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107284,333,'Rampur Sinday','811101',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107285,333,'S.Ghuskari','811105',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107286,333,'Samas','811101',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107287,333,'Sanaiya','811105',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107288,333,'Sarba','811101',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107289,333,'Sheikhpura Bazar','811105',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107290,333,'Sheikhpura R S','811105',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107291,333,'Sheikhpura (Sheikhpura)','811105',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107292,333,'Sirari','811107',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107293,333,'Sohdi','811304',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107294,333,'Subhanpur','811101',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107295,333,'Teus','811101',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107296,333,'Toygarh','811101',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107297,334,'Adauri','843334',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107298,334,'B Jagjiwan','843334',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107299,334,'Bhatahan','843329',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107300,334,'Bhorahan','843329',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107301,334,'Chakfateha','843334',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107302,334,'Chimanpur','843329',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107303,334,'D. Katasari','843329',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107304,334,'Dhankaul','843325',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107305,334,'Fatahapur','843329',1,0,'2022-03-03 13:22:12','2022-03-03 13:22:12'),(107306,334,'Fulkahan','843317',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107307,334,'Garhwa','843334',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107308,334,'H. Dumma','843329',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107309,334,'Harnahiya','843329',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107310,334,'Hiramma','843329',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107311,334,'Jahagirpur','843329',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107312,334,'K. Motnaje','843316',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107313,334,'Kamrauli','843329',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107314,334,'Kasturia','843329',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107315,334,'Khairwa Darp','843329',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107316,334,'Kushahar','843329',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107317,334,'M. Chhatta','843329',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107318,334,'M. Kararia','843329',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107319,334,'Mahuariya','843329',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107320,334,'Mathurapur','843329',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107321,334,'Pardeshiya','843329',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107322,334,'Parrahi','843329',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107323,334,'Phulkahan','843329',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107324,334,'Piprarhi','843334',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107325,334,'Piprathi Punarvas','843313',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107326,334,'S. Katsari','843329',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107327,334,'Salempur','843329',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107328,334,'Sheohar','843329',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107329,334,'Shyampur','843329',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107330,334,'Tajpur','843329',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107331,335,'Chakauti','847307',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107332,335,'Nayatola','847302',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107333,335,'Angoa','843360',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107334,335,'B.Tayab','843360',1,0,'2022-03-03 13:22:13','2022-03-03 13:22:13'),(107335,335,'Changel','843360',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107336,335,'Jajuar','843360',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107337,335,'Ufrauli','843360',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107338,335,'Akhta','843351',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107339,335,'Amghatta','843302',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107340,335,'Amua','843334',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107341,335,'Andauni','843324',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107342,335,'Anhari','843302',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107343,335,'Araria','843330',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107344,335,'Ashogi Purshottam','843313',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107345,335,'Athri','843311',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107346,335,'Awapur','843314',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107347,335,'B. Baaz','843334',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107348,335,'B. Chandiha','843334',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107349,335,'B. Dhanushi','843323',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107350,335,'B. Dharmapur','843320',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107351,335,'B. Jagdish','843334',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107352,335,'B. Jahidpur','843333',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107353,335,'B. Jay Nagar','843317',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107354,335,'B. Maksudan','843320',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107355,335,'B. Piprarhi','843302',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107356,335,'B. Rasalpur','843320',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107357,335,'B. Shantikutir','843333',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107358,335,'B.Bajitpur','843320',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107359,335,'B.Balaha','843325',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107360,335,'B.Behta','843319',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107361,335,'B.Bhimpur','843311',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107362,335,'B.Harpur','843314',1,0,'2022-03-03 13:22:14','2022-03-03 13:22:14'),(107363,335,'B.Jairam','843327',1,0,'2022-03-03 13:22:15','2022-03-03 13:22:15'),(107364,335,'B.Machacha','843314',1,0,'2022-03-03 13:22:15','2022-03-03 13:22:15'),(107365,335,'B.Machhpakauni','843324',1,0,'2022-03-03 13:22:15','2022-03-03 13:22:15'),(107366,335,'B.Narha','843314',1,0,'2022-03-03 13:22:15','2022-03-03 13:22:15'),(107367,335,'B.Phulwariya','843314',1,0,'2022-03-03 13:22:15','2022-03-03 13:22:15'),(107368,335,'Babhangama','843327',1,0,'2022-03-03 13:22:15','2022-03-03 13:22:15'),(107369,335,'Baburban','843324',1,0,'2022-03-03 13:22:15','2022-03-03 13:22:15'),(107370,335,'Baburban','843314',1,0,'2022-03-03 13:22:15','2022-03-03 13:22:15'),(107371,335,'Bachharpur','843320',1,0,'2022-03-03 13:22:15','2022-03-03 13:22:15'),(107372,335,'Bagaha','843332',1,0,'2022-03-03 13:22:15','2022-03-03 13:22:15'),(107373,335,'Baghari','843323',1,0,'2022-03-03 13:22:15','2022-03-03 13:22:15'),(107374,335,'Baghari','843331',1,0,'2022-03-03 13:22:15','2022-03-03 13:22:15'),(107375,335,'Bahera','843332',1,0,'2022-03-03 13:22:15','2022-03-03 13:22:15'),(107376,335,'Bairgania Bazar','843313',1,0,'2022-03-03 13:22:15','2022-03-03 13:22:15'),(107377,335,'Bairgania','843313',1,0,'2022-03-03 13:22:15','2022-03-03 13:22:15'),(107378,335,'Bairiya','843327',1,0,'2022-03-03 13:22:15','2022-03-03 13:22:15'),(107379,335,'Bajitpur','843314',1,0,'2022-03-03 13:22:15','2022-03-03 13:22:15'),(107380,335,'Bajpatti','843314',1,0,'2022-03-03 13:22:15','2022-03-03 13:22:15'),(107381,335,'Bakhari','843331',1,0,'2022-03-03 13:22:15','2022-03-03 13:22:15'),(107382,335,'Bakhari','843325',1,0,'2022-03-03 13:22:15','2022-03-03 13:22:15'),(107383,335,'Balasath','843326',1,0,'2022-03-03 13:22:15','2022-03-03 13:22:15'),(107384,335,'Baligarh','843328',1,0,'2022-03-03 13:22:15','2022-03-03 13:22:15'),(107385,335,'Banarjhula','843317',1,0,'2022-03-03 13:22:15','2022-03-03 13:22:15'),(107386,335,'Banaul','843326',1,0,'2022-03-03 13:22:15','2022-03-03 13:22:15'),(107387,335,'Banchauri','843302',1,0,'2022-03-03 13:22:15','2022-03-03 13:22:15'),(107388,335,'Bangaon','843314',1,0,'2022-03-03 13:22:15','2022-03-03 13:22:15'),(107389,335,'Bangaraha','843302',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107390,335,'Barahi','843327',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107391,335,'Barahi','843331',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107392,335,'Barharwa (Sitamarhi)','843315',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107393,335,'Bariyarpur','843302',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107394,335,'Basantpatti','843334',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107395,335,'Basbitta','843315',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107396,335,'Basotra','843320',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107397,335,'Bathnaha','843302',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107398,335,'Batra','843326',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107399,335,'Bedaul','843320',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107400,335,'Bel','843313',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107401,335,'Belahi','843311',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107402,335,'Belahiya','843314',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107403,335,'Belahiya','843316',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107404,335,'Belsand','843316',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107405,335,'Belwa','843334',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107406,335,'Bengahi','843313',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107407,335,'Betaha','843324',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107408,335,'Bethuara','843324',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107409,335,'Bhadiyan','843333',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107410,335,'Bhagwanpur','843327',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107411,335,'Bhairo Bhoop','843302',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107412,335,'Bhakurahar','843313',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107413,335,'Bhanaspatti','843328',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107414,335,'Bhandari','843316',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107415,335,'Bhangarah','843318',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107416,335,'Bhantabari','843320',1,0,'2022-03-03 13:22:16','2022-03-03 13:22:16'),(107417,335,'Bharthua','843328',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107418,335,'Bhavdepur','843302',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107419,335,'Bhitha Bazar','843331',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107420,335,'Bhulli','843325',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107421,335,'Bhutahi','843317',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107422,335,'Bishanpur','843324',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107423,335,'Bishanpur','843302',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107424,335,'Bokhra','843318',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107425,335,'Bokhtha','843315',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107426,335,'Budhnagra Deorhi','843318',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107427,335,'C.Bishanpur','843327',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107428,335,'C.Dharharwa','843328',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107429,335,'C.Takiya','843314',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107430,335,'Chaipura','843320',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107431,335,'Chakmahila','843302',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107432,335,'Chandauli Timha','843316',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107433,335,'Chandwara','843328',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107434,335,'Chhaurahiya','843332',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107435,335,'Chiknachak','843319',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107436,335,'Choraut','843319',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107437,335,'D. Kala','843315',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107438,335,'D. Khurd','843315',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107439,335,'D.Mathauna','843319',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107440,335,'Dadari','843333',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107441,335,'Dalkawa','843330',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107442,335,'Dhadhi','843333',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107443,335,'Dharharwa','843324',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107444,335,'Dheng','843315',1,0,'2022-03-03 13:22:17','2022-03-03 13:22:17'),(107445,335,'Dighi','843322',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107446,335,'Dumarbana','843313',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107447,335,'Dumharpatti','843320',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107448,335,'Dumra','843316',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107449,335,'F.Girmishani','843302',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107450,335,'Fulkaha','843317',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107451,335,'Gamhariya','843315',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107452,335,'Gangati','843320',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107453,335,'Garahiya','843334',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107454,335,'Garha','843320',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107455,335,'Garha','843323',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107456,335,'Garui','843326',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107457,335,'Gaura','843326',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107458,335,'Ghanshyampur','843328',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107459,335,'Gharwara','843315',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107460,335,'Gisara','843311',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107461,335,'Goraul Sharif','843318',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107462,335,'H Barharwa','843314',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107463,335,'H. Chandei','843320',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107464,335,'H. Dularpur','843331',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107465,335,'Hanuman Nagar','843317',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107466,335,'Hanumannagar','843331',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107467,335,'Hardiya','843320',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107468,335,'Haribela','843317',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107469,335,'Harnahiya','843302',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107470,335,'Harpurkala','843315',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107471,335,'Harpurwa','843314',1,0,'2022-03-03 13:22:18','2022-03-03 13:22:18'),(107472,335,'Humayupur','843333',1,0,'2022-03-03 13:22:19','2022-03-03 13:22:19'),(107473,335,'Indarwa','843324',1,0,'2022-03-03 13:22:19','2022-03-03 13:22:19'),(107474,335,'J. Kothia','843316',1,0,'2022-03-03 13:22:19','2022-03-03 13:22:19'),(107475,335,'Jadupatti','843319',1,0,'2022-03-03 13:22:19','2022-03-03 13:22:19'),(107476,335,'Jadupatti Bazar','843319',1,0,'2022-03-03 13:22:19','2022-03-03 13:22:19'),(107477,335,'Jaffarpur','843316',1,0,'2022-03-03 13:22:19','2022-03-03 13:22:19'),(107478,335,'Jagdar','843324',1,0,'2022-03-03 13:22:19','2022-03-03 13:22:19'),(107479,335,'Jamua','843313',1,0,'2022-03-03 13:22:19','2022-03-03 13:22:19'),(107480,335,'Janaki Asthan','843302',1,0,'2022-03-03 13:22:19','2022-03-03 13:22:19'),(107481,335,'Janakpur Road','843320',1,0,'2022-03-03 13:22:19','2022-03-03 13:22:19'),(107482,335,'Janipur','843333',1,0,'2022-03-03 13:22:19','2022-03-03 13:22:19'),(107483,335,'Jhajhihat','843320',1,0,'2022-03-03 13:22:19','2022-03-03 13:22:19'),(107484,335,'Jogiwana','843322',1,0,'2022-03-03 13:22:19','2022-03-03 13:22:19'),(107485,335,'K Barhmtoli','843314',1,0,'2022-03-03 13:22:19','2022-03-03 13:22:19'),(107486,335,'K. Bhandar','843317',1,0,'2022-03-03 13:22:19','2022-03-03 13:22:19'),(107487,335,'K. Bishanpur','843323',1,0,'2022-03-03 13:22:19','2022-03-03 13:22:19'),(107488,335,'K.B.P. Pupri','843320',1,0,'2022-03-03 13:22:19','2022-03-03 13:22:19'),(107489,335,'K.Brahmtoli','843314',1,0,'2022-03-03 13:22:19','2022-03-03 13:22:19'),(107490,335,'K.Gajpatti','843325',1,0,'2022-03-03 13:22:19','2022-03-03 13:22:19'),(107491,335,'K.Madan','843332',1,0,'2022-03-03 13:22:19','2022-03-03 13:22:19'),(107492,335,'K.Siroman','843302',1,0,'2022-03-03 13:22:19','2022-03-03 13:22:19'),(107493,335,'K.Thikha','843327',1,0,'2022-03-03 13:22:19','2022-03-03 13:22:19'),(107494,335,'Kamaladah','843323',1,0,'2022-03-03 13:22:19','2022-03-03 13:22:19'),(107495,335,'Kamaldah','843322',1,0,'2022-03-03 13:22:19','2022-03-03 13:22:19'),(107496,335,'Kanhawa','843324',1,0,'2022-03-03 13:22:19','2022-03-03 13:22:19'),(107497,335,'Kansar','843316',1,0,'2022-03-03 13:22:19','2022-03-03 13:22:19'),(107498,335,'Kathaur','843316',1,0,'2022-03-03 13:22:20','2022-03-03 13:22:20'),(107499,335,'Khairwa','843327',1,0,'2022-03-03 13:22:20','2022-03-03 13:22:20'),(107500,335,'Kharsan','843327',1,0,'2022-03-03 13:22:20','2022-03-03 13:22:20'),(107501,335,'Kishanpur','843302',1,0,'2022-03-03 13:22:20','2022-03-03 13:22:20'),(107502,335,'Koat Bazar','843302',1,0,'2022-03-03 13:22:20','2022-03-03 13:22:20'),(107503,335,'Kohbarawa','843330',1,0,'2022-03-03 13:22:20','2022-03-03 13:22:20'),(107504,335,'Koili','843333',1,0,'2022-03-03 13:22:20','2022-03-03 13:22:20'),(107505,335,'Koily','843302',1,0,'2022-03-03 13:22:20','2022-03-03 13:22:20'),(107506,335,'Koryahi','843319',1,0,'2022-03-03 13:22:20','2022-03-03 13:22:20'),(107507,335,'Kuama','843325',1,0,'2022-03-03 13:22:20','2022-03-03 13:22:20'),(107508,335,'Kumma','843331',1,0,'2022-03-03 13:22:20','2022-03-03 13:22:20'),(107509,335,'Lagma Azamgarh','843323',1,0,'2022-03-03 13:22:20','2022-03-03 13:22:20'),(107510,335,'Lahuriya','843324',1,0,'2022-03-03 13:22:20','2022-03-03 13:22:20'),(107511,335,'Lalpur','843323',1,0,'2022-03-03 13:22:20','2022-03-03 13:22:20'),(107512,335,'Lattipur','843322',1,0,'2022-03-03 13:22:20','2022-03-03 13:22:20'),(107513,335,'M. Kala','843317',1,0,'2022-03-03 13:22:20','2022-03-03 13:22:20'),(107514,335,'M. Pokharbinda','843334',1,0,'2022-03-03 13:22:20','2022-03-03 13:22:20'),(107515,335,'M. Rampur','843302',1,0,'2022-03-03 13:22:20','2022-03-03 13:22:20'),(107516,335,'M.Basaha','843314',1,0,'2022-03-03 13:22:20','2022-03-03 13:22:20'),(107517,335,'M.Dostiya','843334',1,0,'2022-03-03 13:22:20','2022-03-03 13:22:20'),(107518,335,'M.Malinia','843332',1,0,'2022-03-03 13:22:20','2022-03-03 13:22:20'),(107519,335,'M.Mandal','843327',1,0,'2022-03-03 13:22:20','2022-03-03 13:22:20'),(107520,335,'M.Morsand','843328',1,0,'2022-03-03 13:22:20','2022-03-03 13:22:20'),(107521,335,'M.Sakrauli','843326',1,0,'2022-03-03 13:22:20','2022-03-03 13:22:20'),(107522,335,'Madanpur','843325',1,0,'2022-03-03 13:22:20','2022-03-03 13:22:20'),(107523,335,'Madaripur','843333',1,0,'2022-03-03 13:22:20','2022-03-03 13:22:20'),(107524,335,'Madhopur','843322',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107525,335,'Madhurapur','843314',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107526,335,'Madhurapur','843315',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107527,335,'Mahadeopatti','843324',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107528,335,'Mahisautha','843318',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107529,335,'Mahuawa','843334',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107530,335,'Mahuawa','843331',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107531,335,'Majhaulia Estate','843322',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107532,335,'Majhaur','843333',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107533,335,'Majhaura','843331',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107534,335,'Majorganj','843332',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107535,335,'Malahi','843331',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107536,335,'Malahi','843332',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107537,335,'Manaraya','843332',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107538,335,'Manariya','843332',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107539,335,'Manikchowk','843323',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107540,335,'Maniyari','843302',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107541,335,'Manpaur','843324',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107542,335,'Maraul','843314',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107543,335,'Marpa Factory','843313',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107544,335,'Maudah','843327',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107545,335,'Mayurwa','843330',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107546,335,'Meghpur','843331',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107547,335,'Mehsaul','843328',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107548,335,'Mushaharniya','843330',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107549,335,'Nanpur','843333',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107550,335,'Narayanpur','843320',1,0,'2022-03-03 13:22:21','2022-03-03 13:22:21'),(107551,335,'Narga','843324',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107552,335,'Narha','843327',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107553,335,'Narha','843331',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107554,335,'P Murahi','843316',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107555,335,'P. Dadan','843317',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107556,335,'P. Murahi','843316',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107557,335,'P. Tajpur','843316',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107558,335,'P.Basantpur','843327',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107559,335,'P.Koria','843324',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107560,335,'P.Parsain','843330',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107561,335,'P.Pathaniya','843327',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107562,335,'P.Phulhatta','843324',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107563,335,'P.Rajwara','843330',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107564,335,'Pachaharwa','843332',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107565,335,'Pachtaki Jaddu','843313',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107566,335,'Paktola','843302',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107567,335,'Pandaul Buzurg','843326',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107568,335,'Panthpakar','843322',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107569,335,'Parihar','843324',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107570,335,'Parmanandpur','843302',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107571,335,'Parsa','843324',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107572,335,'Parsauni','843302',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107573,335,'Parsauni','843325',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107574,335,'Parshurampur','843325',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107575,335,'Partapur','843311',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107576,335,'Patahi','843316',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107577,335,'Piprarhi','843320',1,0,'2022-03-03 13:22:22','2022-03-03 13:22:22'),(107578,335,'Piprarhi','843313',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107579,335,'Pirokhar','843319',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107580,335,'Pokharbhinda','843320',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107581,335,'Pokharbhinda','843327',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107582,335,'Pokhraira','843326',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107583,335,'Prem Nagar Subhai','843323',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107584,335,'Punaura','843302',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107585,335,'Pupari Bazar','843320',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107586,335,'R. Raghunathpur','843315',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107587,335,'R.Bagahi','843311',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107588,335,'R.Bhanpur','843324',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107589,335,'R.Ganguly','843327',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107590,335,'R.Gosaipur','843302',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107591,335,'Radhaur','843331',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107592,335,'Ragharpura','843331',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107593,335,'Rain Shankar','843328',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107594,335,'Raipur (Sitamarhi)','843326',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107595,335,'Rajopatti','843302',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107596,335,'Rampur Bakhari','843325',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107597,335,'Ranjitpur','843327',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107598,335,'Ratan Lasmi','843320',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107599,335,'Ratwara','843333',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107600,335,'Raxiya','843328',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107601,335,'Rewasi','843327',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107602,335,'Riga Colony','843327',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107603,335,'Riga Gote','843327',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107604,335,'Riga','843327',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107605,335,'Runnisaidpur','843328',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107606,335,'S. Kala','843315',1,0,'2022-03-03 13:22:23','2022-03-03 13:22:23'),(107607,335,'S. Sultan','843334',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107608,335,'Sahargama','843324',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107609,335,'Sahbajpur','843327',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107610,335,'Sahiyara','843332',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107611,335,'Sardalpatti','843324',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107612,335,'Saterh','843318',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107613,335,'Sauli','843316',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107614,335,'Saura','843333',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107615,335,'Shaktipith Chandidham','843301',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107616,335,'Shanki','843302',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107617,335,'Shrikhandi Bhitta','843331',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107618,335,'Singrahiya','843317',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107619,335,'Singwahini','843317',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107620,335,'Sirauli','843302',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107621,335,'Sirsi','843333',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107622,335,'Sirsia','843324',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107623,335,'Sitamarhi Bazar','843302',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107624,335,'Sitamarhi H.O','843301',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107625,335,'Siwaipaiti','843314',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107626,335,'Sonaul Mahoday','843332',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107627,335,'Sonbersa','843330',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107628,335,'Sujatpur','843319',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107629,335,'Suppi','843315',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107630,335,'Sursand','843331',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107631,335,'Sutihara','843331',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107632,335,'T. Chhapra','843316',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107633,335,'Thahar','843328',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107634,335,'Thumma','843328',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107635,335,'Tikauli','843323',1,0,'2022-03-03 13:22:24','2022-03-03 13:22:24'),(107636,335,'Vishwa','843324',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107637,336,'Baghauna','841223',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107638,336,'Bankat','841422',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107639,336,'Sagar Sultanpur','841417',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107640,336,'Admapur','841504',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107641,336,'Agya','841439',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107642,336,'Akolhi','841239',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107643,336,'Alapur','841286',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107644,336,'Amarpur','841234',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107645,336,'Amlori','841226',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107646,336,'Andar','841231',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107647,336,'Ansar','841203',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107648,336,'Anugrhnagar','841239',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107649,336,'Aranda','841236',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107650,336,'Asaon','841287',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107651,336,'B.P.Ekderwsa','841243',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107652,336,'Babhanbara','841506',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107653,336,'Badram','841241',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107654,336,'Bagaura','841404',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107655,336,'Baghi','841406',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107656,336,'Bahadur Bazar','841404',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107657,336,'Baijubarhoga','841406',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107658,336,'Bakerganj','841286',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107659,336,'Bakhri','841203',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107660,336,'Balaun','841244',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107661,336,'Balhu','841234',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107662,336,'Balia','841506',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107663,336,'Ballia','841237',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107664,336,'Balliapokhra','841238',1,0,'2022-03-03 13:22:25','2022-03-03 13:22:25'),(107665,336,'Balua','841435',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107666,336,'Bangra','841203',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107667,336,'Bangra','841238',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107668,336,'Banthu Sriram','841245',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107669,336,'Bardaha','841245',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107670,336,'Bargaon','841239',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107671,336,'Barhan Bazar','841227',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107672,336,'Barheya','841226',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107673,336,'Barhipurgop','841408',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107674,336,'Barhni','841227',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107675,336,'Barhria','841232',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107676,336,'Barhulia','841245',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107677,336,'Barkagaon','841226',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107678,336,'Barkagaowan','841408',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107679,336,'Barkamanjha','841243',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107680,336,'Basantpur (Siwan)','841406',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107681,336,'Basaowan','841406',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107682,336,'Basopali','841227',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107683,336,'Belaon','841235',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107684,336,'Belaur','841239',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107685,336,'Belauri','841239',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107686,336,'Benusar','841227',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107687,336,'Benusar Bujurg','841227',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107688,336,'Bhagar','841210',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107689,336,'Bhagwanpur Hat','841408',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107690,336,'Bhaisakhal','841245',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107691,336,'Bhantapokher','841226',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107692,336,'Bhartpura','841506',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107693,336,'Bharuli','841245',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107694,336,'Bherwania','841507',1,0,'2022-03-03 13:22:26','2022-03-03 13:22:26'),(107695,336,'Bhikha Bandh Satjora','841244',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107696,336,'Bhikhpur','841408',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107697,336,'Bhikhpur','841237',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107698,336,'Bhikhpur Bhgwanpur','841236',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107699,336,'Bhimpur','841404',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107700,336,'Bhithi','841434',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107701,336,'Bhlua','841435',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107702,336,'Bhluwa','841404',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107703,336,'Bhwrajpur','841231',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107704,336,'Bilaspur','841239',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107705,336,'Bishunpura','841238',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107706,336,'Bishunpura Bazar','841239',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107707,336,'Bishwania','841234',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107708,336,'Bishwar','841239',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107709,336,'Bithuna','841507',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107710,336,'Bkulari','841239',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107711,336,'Chainpur','841439',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107712,336,'Chainpur Hata','841243',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107713,336,'Chainpur (Siwan)','841203',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107714,336,'Chakari','841435',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107715,336,'Chakia','841507',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107716,336,'Chakra','841226',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107717,336,'Champ','841241',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107718,336,'Chanaur','841227',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107719,336,'Chandparsa','841240',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107720,336,'Chapia Bujurg','841226',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107721,336,'Chapra Road','841226',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107722,336,'Chaukihasan','841506',1,0,'2022-03-03 13:22:27','2022-03-03 13:22:27'),(107723,336,'Chhapmathia','841227',1,0,'2022-03-03 13:22:28','2022-03-03 13:22:28'),(107724,336,'Chhitanpur','841245',1,0,'2022-03-03 13:22:28','2022-03-03 13:22:28'),(107725,336,'Chhitauli','841203',1,0,'2022-03-03 13:22:28','2022-03-03 13:22:28'),(107726,336,'Chhotkateghra','841238',1,0,'2022-03-03 13:22:28','2022-03-03 13:22:28'),(107727,336,'Chimanpura','841416',1,0,'2022-03-03 13:22:28','2022-03-03 13:22:28'),(107728,336,'Chitakhal','841435',1,0,'2022-03-03 13:22:28','2022-03-03 13:22:28'),(107729,336,'Choiapali','841242',1,0,'2022-03-03 13:22:28','2022-03-03 13:22:28'),(107730,336,'Chorauli','841406',1,0,'2022-03-03 13:22:28','2022-03-03 13:22:28'),(107731,336,'Chorma','841406',1,0,'2022-03-03 13:22:28','2022-03-03 13:22:28'),(107732,336,'Chotka Manjha','841243',1,0,'2022-03-03 13:22:28','2022-03-03 13:22:28'),(107733,336,'Daraila','841239',1,0,'2022-03-03 13:22:28','2022-03-03 13:22:28'),(107734,336,'Darauli','841234',1,0,'2022-03-03 13:22:28','2022-03-03 13:22:28'),(107735,336,'Daronda','841233',1,0,'2022-03-03 13:22:28','2022-03-03 13:22:28'),(107736,336,'Deoria','841238',1,0,'2022-03-03 13:22:28','2022-03-03 13:22:28'),(107737,336,'Dhanuti','841226',1,0,'2022-03-03 13:22:28','2022-03-03 13:22:28'),(107738,336,'Dhanutihata','841236',1,0,'2022-03-03 13:22:28','2022-03-03 13:22:28'),(107739,336,'Dighwalia','841203',1,0,'2022-03-03 13:22:28','2022-03-03 13:22:28'),(107740,336,'Dindayalpur','841506',1,0,'2022-03-03 13:22:28','2022-03-03 13:22:28'),(107741,336,'Done','841235',1,0,'2022-03-03 13:22:28','2022-03-03 13:22:28'),(107742,336,'Draili Mathia','841235',1,0,'2022-03-03 13:22:28','2022-03-03 13:22:28'),(107743,336,'Dudhra','841434',1,0,'2022-03-03 13:22:28','2022-03-03 13:22:28'),(107744,336,'Dumra','841416',1,0,'2022-03-03 13:22:28','2022-03-03 13:22:28'),(107745,336,'Dumrahar','841435',1,0,'2022-03-03 13:22:28','2022-03-03 13:22:28'),(107746,336,'English','841239',1,0,'2022-03-03 13:22:28','2022-03-03 13:22:28'),(107747,336,'Faridpur','841231',1,0,'2022-03-03 13:22:28','2022-03-03 13:22:28'),(107748,336,'Gabhirar','841509',1,0,'2022-03-03 13:22:28','2022-03-03 13:22:28'),(107749,336,'Gaighat','841231',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107750,336,'Gambhria','841241',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107751,336,'Gangpur Siswan','841210',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107752,336,'Gauri','841234',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107753,336,'Gaushalaroad Siwan','841227',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107754,336,'Gayaspur','841210',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107755,336,'Gaziapur','841245',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107756,336,'Ghurghat','841210',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107757,336,'Gohpur Bajrahia','841238',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107758,336,'Goreakothi','841434',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107759,336,'Govindapur','841507',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107760,336,'Guthni','841435',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107761,336,'Habibnagar','841226',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107762,336,'Hahwa','841238',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107763,336,'Hakam','841227',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107764,336,'Hardia','841404',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107765,336,'Hardia','841226',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107766,336,'Harihans','841286',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107767,336,'Harihar Pur Lalgarh','841434',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107768,336,'Hariharpur Kala','841434',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107769,336,'Harnatar','841235',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107770,336,'Harnathpur','841504',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107771,336,'Harsardhanauti','841233',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107772,336,'Hasanpura','841236',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107773,336,'Hathura','841237',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107774,336,'Hulesra','841408',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107775,336,'Hussainganj','841237',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107776,336,'Hussaipurnand','841406',1,0,'2022-03-03 13:22:29','2022-03-03 13:22:29'),(107777,336,'Itwa Bartwalia','841241',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107778,336,'Jagatpur','841406',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107779,336,'Jagdishpur','841203',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107780,336,'Jagdishpur Kothi','841243',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107781,336,'Jaijore','841231',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107782,336,'Jalalpur','841233',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107783,336,'Jalalpur','841506',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107784,336,'Jamuaon','841239',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107785,336,'Jasauli','841241',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107786,336,'Jigrawan','841238',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107787,336,'Jiyan','841226',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107788,336,'K.T.Bharauli','841404',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107789,336,'K.T.Bharouli','841404',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107790,336,'Kabirpur','841243',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107791,336,'Kachnar','841210',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107792,336,'Kaladumra','841439',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107793,336,'Kandhpakar','841287',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107794,336,'Kanhauli','841235',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107795,336,'Karanpura','841506',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107796,336,'Karsar','841504',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107797,336,'Karsaut','841238',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107798,336,'Kasdeora Bangra','841238',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107799,336,'Kashila','841287',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107800,336,'Kauria','841406',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107801,336,'Keelpur','841243',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107802,336,'Keotalia','841234',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107803,336,'Khalishpur','841227',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107804,336,'Khalwa','841243',1,0,'2022-03-03 13:22:30','2022-03-03 13:22:30'),(107805,336,'Khawaspur','841416',1,0,'2022-03-03 13:22:31','2022-03-03 13:22:31'),(107806,336,'Kherai','841231',1,0,'2022-03-03 13:22:31','2022-03-03 13:22:31'),(107807,336,'Kherwa','841406',1,0,'2022-03-03 13:22:31','2022-03-03 13:22:31'),(107808,336,'Khujhwa','841502',1,0,'2022-03-03 13:22:31','2022-03-03 13:22:31'),(107809,336,'Kishunpura','841416',1,0,'2022-03-03 13:22:31','2022-03-03 13:22:31'),(107810,336,'Koerigawan','841232',1,0,'2022-03-03 13:22:31','2022-03-03 13:22:31'),(107811,336,'Kolhua','841233',1,0,'2022-03-03 13:22:31','2022-03-03 13:22:31'),(107812,336,'Kothua Sarangpur','841238',1,0,'2022-03-03 13:22:31','2022-03-03 13:22:31'),(107813,336,'Kpmishrauli','841245',1,0,'2022-03-03 13:22:31','2022-03-03 13:22:31'),(107814,336,'Krishnapali','841234',1,0,'2022-03-03 13:22:31','2022-03-03 13:22:31'),(107815,336,'Krom','841239',1,0,'2022-03-03 13:22:31','2022-03-03 13:22:31'),(107816,336,'Kumhti','841235',1,0,'2022-03-03 13:22:31','2022-03-03 13:22:31'),(107817,336,'Laheji','841233',1,0,'2022-03-03 13:22:31','2022-03-03 13:22:31'),(107818,336,'Lakari','841416',1,0,'2022-03-03 13:22:31','2022-03-03 13:22:31'),(107819,336,'Langarpura','841239',1,0,'2022-03-03 13:22:31','2022-03-03 13:22:31'),(107820,336,'Lawa Rampur','841507',1,0,'2022-03-03 13:22:31','2022-03-03 13:22:31'),(107821,336,'Laxmiganj','841439',1,0,'2022-03-03 13:22:31','2022-03-03 13:22:31'),(107822,336,'Laxmiganj Sisai','841506',1,0,'2022-03-03 13:22:31','2022-03-03 13:22:31'),(107823,336,'Lebhri','841239',1,0,'2022-03-03 13:22:31','2022-03-03 13:22:31'),(107824,336,'Machakna','841237',1,0,'2022-03-03 13:22:31','2022-03-03 13:22:31'),(107825,336,'Machuta','841233',1,0,'2022-03-03 13:22:31','2022-03-03 13:22:31'),(107826,336,'Madhopur','841210',1,0,'2022-03-03 13:22:31','2022-03-03 13:22:31'),(107827,336,'Madhopur','841232',1,0,'2022-03-03 13:22:31','2022-03-03 13:22:31'),(107828,336,'Madhopur','841506',1,0,'2022-03-03 13:22:31','2022-03-03 13:22:31'),(107829,336,'Mahmodpur','841232',1,0,'2022-03-03 13:22:31','2022-03-03 13:22:31'),(107830,336,'Mahodipur','841226',1,0,'2022-03-03 13:22:31','2022-03-03 13:22:31'),(107831,336,'Mahrajganj (Siwan)','841238',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107832,336,'Mahuwal Mahal','841240',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107833,336,'Mahuwari','841227',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107834,336,'Mairwa','841239',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107835,336,'Makariyar','841245',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107836,336,'Mandrauli','841233',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107837,336,'Mania','841245',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107838,336,'Marachhi','841434',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107839,336,'Markan','841226',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107840,336,'Mathia','841235',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107841,336,'Merhi','841240',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107842,336,'Miyan Ke Bhatkan','841245',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107843,336,'Mohmda Bazar','841406',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107844,336,'Molnapur','841406',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107845,336,'Mora (Siwan)','841507',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107846,336,'Murakhap','841235',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107847,336,'Murena','841235',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107848,336,'Mustfabad','841439',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107849,336,'Nadiwan','841231',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107850,336,'Nainpura','841241',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107851,336,'Nand Pur Amwari','841231',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107852,336,'Nandamura','841203',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107853,336,'Narendrapur','841446',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107854,336,'Narhan','841504',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107855,336,'Narianpur','841245',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107856,336,'Nathuchhap','841227',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107857,336,'Nautan','841243',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107858,336,'Newari','841509',1,0,'2022-03-03 13:22:32','2022-03-03 13:22:32'),(107859,336,'Noniapatti','841210',1,0,'2022-03-03 13:22:33','2022-03-03 13:22:33'),(107860,336,'P.Harsar','841233',1,0,'2022-03-03 13:22:33','2022-03-03 13:22:33'),(107861,336,'P.K.Rampur','841507',1,0,'2022-03-03 13:22:33','2022-03-03 13:22:33'),(107862,336,'Pachokhar','841245',1,0,'2022-03-03 13:22:33','2022-03-03 13:22:33'),(107863,336,'Pachphera','841243',1,0,'2022-03-03 13:22:33','2022-03-03 13:22:33'),(107864,336,'Pachrukhi','841241',1,0,'2022-03-03 13:22:33','2022-03-03 13:22:33'),(107865,336,'Pakwalia','841238',1,0,'2022-03-03 13:22:33','2022-03-03 13:22:33'),(107866,336,'Panjwar','841509',1,0,'2022-03-03 13:22:33','2022-03-03 13:22:33'),(107867,336,'Papaur','841227',1,0,'2022-03-03 13:22:33','2022-03-03 13:22:33'),(107868,336,'Parauli','841416',1,0,'2022-03-03 13:22:33','2022-03-03 13:22:33'),(107869,336,'Partap Pur','841226',1,0,'2022-03-03 13:22:33','2022-03-03 13:22:33'),(107870,336,'Pasnauli','841238',1,0,'2022-03-03 13:22:33','2022-03-03 13:22:33'),(107871,336,'Patar','841502',1,0,'2022-03-03 13:22:33','2022-03-03 13:22:33'),(107872,336,'Paterha','841242',1,0,'2022-03-03 13:22:33','2022-03-03 13:22:33'),(107873,336,'Paterhi','841242',1,0,'2022-03-03 13:22:33','2022-03-03 13:22:33'),(107874,336,'Pihuli','841287',1,0,'2022-03-03 13:22:33','2022-03-03 13:22:33'),(107875,336,'Pipra','841244',1,0,'2022-03-03 13:22:33','2022-03-03 13:22:33'),(107876,336,'Pipra Naryan','841506',1,0,'2022-03-03 13:22:33','2022-03-03 13:22:33'),(107877,336,'Piprahiya','841245',1,0,'2022-03-03 13:22:33','2022-03-03 13:22:33'),(107878,336,'Punak','841239',1,0,'2022-03-03 13:22:33','2022-03-03 13:22:33'),(107879,336,'Purandarpur','841439',1,0,'2022-03-03 13:22:33','2022-03-03 13:22:33'),(107880,336,'Rafipur','841286',1,0,'2022-03-03 13:22:33','2022-03-03 13:22:33'),(107881,336,'Raghunathpur (Siwan)','841504',1,0,'2022-03-03 13:22:33','2022-03-03 13:22:33'),(107882,336,'Rajanpura','841236',1,0,'2022-03-03 13:22:33','2022-03-03 13:22:33'),(107883,336,'Rajapur','841238',1,0,'2022-03-03 13:22:33','2022-03-03 13:22:33'),(107884,336,'Rajpur','841504',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107885,336,'Ramgarh','841203',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107886,336,'Ramgarh','841244',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107887,336,'Ramnagar','841504',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107888,336,'Rampur Ke Tola','841236',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107889,336,'Ramsapur','841233',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107890,336,'Rasulpur','841244',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107891,336,'Rasulpur Tilouta','841233',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107892,336,'Ratanparauli','841242',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107893,336,'Ratanpura','841506',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107894,336,'Rishura','841238',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107895,336,'Ruiyabangra','841245',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107896,336,'Rukundipur','841238',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107897,336,'S.S.Factory','841226',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107898,336,'Sadarpur','841232',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107899,336,'Sadiha','841507',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107900,336,'Safiabad','841416',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107901,336,'Sahatwar','841439',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107902,336,'Sahlaur','841227',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107903,336,'Sahpur','841243',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107904,336,'Sahrkola','841406',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107905,336,'Sahsrawan','841408',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107906,336,'Sahuli','841286',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107907,336,'Saidpura','841439',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107908,336,'Sani Basantpur','841439',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107909,336,'Sanjalpur','841245',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107910,336,'Santhi','841502',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107911,336,'Sarari','841434',1,0,'2022-03-03 13:22:34','2022-03-03 13:22:34'),(107912,336,'Sarauti','841241',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107913,336,'Saraya Sah Mohamd','841506',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107914,336,'Sareyarampur','841234',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107915,336,'Sarhrwa','841239',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107916,336,'Sarif Jalalpur','841416',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107917,336,'Sarsar','841226',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107918,336,'Sarwe','841227',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107919,336,'Satation Road','841226',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107920,336,'Sekhpura','841406',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107921,336,'Semaria','841243',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107922,336,'Sematar','841239',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107923,336,'Seotapur','841239',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107924,336,'Shakara','841506',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107925,336,'Shiopur Sakra','841245',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107926,336,'Sikandrpur','841434',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107927,336,'Siktia','841244',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107928,336,'Singhauli','841507',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107929,336,'Sirisia','841243',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107930,336,'Sisahni','841245',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107931,336,'Siswan Kala','841236',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107932,336,'Siwan Chowk Bazar','841226',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107933,336,'Siwan H.O','841226',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107934,336,'Siwan Mission House','841227',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107935,336,'Sohgra','841239',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107936,336,'Sohilpatti','841406',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107937,336,'Sonbarsa','841241',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107938,336,'Sondhani','841408',1,0,'2022-03-03 13:22:35','2022-03-03 13:22:35'),(107939,336,'Srikalpur','841435',1,0,'2022-03-03 13:22:36','2022-03-03 13:22:36'),(107940,336,'Sughri','841406',1,0,'2022-03-03 13:22:36','2022-03-03 13:22:36'),(107941,336,'Surwala','841227',1,0,'2022-03-03 13:22:36','2022-03-03 13:22:36'),(107942,336,'Takipur','841244',1,0,'2022-03-03 13:22:36','2022-03-03 13:22:36'),(107943,336,'Talli','841239',1,0,'2022-03-03 13:22:36','2022-03-03 13:22:36'),(107944,336,'Tari','841509',1,0,'2022-03-03 13:22:36','2022-03-03 13:22:36'),(107945,336,'Tariwani','841235',1,0,'2022-03-03 13:22:36','2022-03-03 13:22:36'),(107946,336,'Tarwa','841226',1,0,'2022-03-03 13:22:36','2022-03-03 13:22:36'),(107947,336,'Tarwaparsa','841240',1,0,'2022-03-03 13:22:36','2022-03-03 13:22:36'),(107948,336,'Tarwara','841506',1,0,'2022-03-03 13:22:36','2022-03-03 13:22:36'),(107949,336,'Telkathu','841286',1,0,'2022-03-03 13:22:36','2022-03-03 13:22:36'),(107950,336,'Tenua','841435',1,0,'2022-03-03 13:22:36','2022-03-03 13:22:36'),(107951,336,'Tethli','841232',1,0,'2022-03-03 13:22:36','2022-03-03 13:22:36'),(107952,336,'Tetria','841226',1,0,'2022-03-03 13:22:36','2022-03-03 13:22:36'),(107953,336,'Thepaha Bazar','841245',1,0,'2022-03-03 13:22:36','2022-03-03 13:22:36'),(107954,336,'Titra','841245',1,0,'2022-03-03 13:22:36','2022-03-03 13:22:36'),(107955,336,'Tiyan','841231',1,0,'2022-03-03 13:22:36','2022-03-03 13:22:36'),(107956,336,'Trwa Parsia','841435',1,0,'2022-03-03 13:22:36','2022-03-03 13:22:36'),(107957,336,'Ukhai','841227',1,0,'2022-03-03 13:22:36','2022-03-03 13:22:36'),(107958,336,'Zeradei','841245',1,0,'2022-03-03 13:22:36','2022-03-03 13:22:36'),(107959,337,'Barhara','847452',1,0,'2022-03-03 13:22:36','2022-03-03 13:22:36'),(107960,337,'Belhi','847452',1,0,'2022-03-03 13:22:36','2022-03-03 13:22:36'),(107961,337,'Dagmara','847451',1,0,'2022-03-03 13:22:36','2022-03-03 13:22:36'),(107962,337,'Ganaura','847408',1,0,'2022-03-03 13:22:36','2022-03-03 13:22:36'),(107963,337,'Hariyahi','847452',1,0,'2022-03-03 13:22:36','2022-03-03 13:22:36'),(107964,337,'Janardanpur','847408',1,0,'2022-03-03 13:22:36','2022-03-03 13:22:36'),(107965,337,'Kamalpur','847451',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107966,337,'Kamrail','847408',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107967,337,'Khorma','847408',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107968,337,'Kunauli','847451',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107969,337,'Kunauli Bazar','847451',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107970,337,'Lalpur','847452',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107971,337,'Manoharpatti','847452',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107972,337,'Marauna','847408',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107973,337,'Mauahi','847452',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107974,337,'Mungraha','847452',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107975,337,'Nirmali (Supaul)','847452',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107976,337,'Parikonch','847452',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107977,337,'Ratnasara','847452',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107978,337,'Sarojabela','847452',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107979,337,'Sikarhatta','847451',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107980,337,'Abhuar','852138',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107981,337,'Achalpur','852109',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107982,337,'Amha','852218',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107983,337,'Amha','852108',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107984,337,'Andouli','852105',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107985,337,'B.Fulkaha','852214',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107986,337,'Babhangama','852139',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107987,337,'Babhani Bhelwa','852131',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107988,337,'Baghla','852139',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107989,337,'Baira','852123',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107990,337,'Baisa','852215',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107991,337,'Baisi','852215',1,0,'2022-03-03 13:22:37','2022-03-03 13:22:37'),(107992,337,'Bakaur','852130',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(107993,337,'Balbhadrapur','854339',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(107994,337,'Balha','852130',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(107995,337,'Baljora','852139',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(107996,337,'Baltharwa','852105',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(107997,337,'Balua Bazar','854339',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(107998,337,'Banailipatti','854340',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(107999,337,'Banania','852105',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(108000,337,'Barahihat','852130',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(108001,337,'Barail','852110',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(108002,337,'Barkurwa','852139',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(108003,337,'Basaha','852131',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(108004,337,'Basantpur','854340',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(108005,337,'Basbitti','852130',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(108006,337,'Bauraha','852215',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(108007,337,'Bauraha','852138',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(108008,337,'Bela Terha','852131',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(108009,337,'Bhairo Patti','852108',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(108010,337,'Bhaptiyahi Bazar','852105',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(108011,337,'Bhawanipur Patni','852125',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(108012,337,'Bhimnagar Bairrage','854338',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(108013,337,'Bhimpur','854339',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(108014,337,'Bhura','852139',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(108015,337,'Bina','852131',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(108016,337,'Birpur (Supaul)','854340',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(108017,337,'Bishanpur','852214',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(108018,337,'Bishanpur','852105',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(108019,337,'Cahndpiper','852105',1,0,'2022-03-03 13:22:38','2022-03-03 13:22:38'),(108020,337,'Chainsinghpatti','852131',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108021,337,'Charne','852214',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108022,337,'Chauhatta','852138',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108023,337,'Chilauni','852125',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108024,337,'Chitti Hanuman Nagar','852215',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108025,337,'Chouraha','852139',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108026,337,'Chunni\\','852137',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108027,337,'Dabhari','852131',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108028,337,'Daharia','852137',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108029,337,'Daparkha','852139',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108030,337,'Daulatpur','852215',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108031,337,'Devipur','852109',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108032,337,'Dharhara','852109',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108033,337,'Dighiya','852131',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108034,337,'Dinapatti','852218',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108035,337,'Dumari','852215',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108036,337,'Dumra','852130',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108037,337,'Ekma','852110',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108038,337,'Finglas','852111',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108039,337,'Gamaharia','852108',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108040,337,'Gangapur','852105',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108041,337,'Ganpatganj (Supaul)','852109',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108042,337,'Garh Baruari','852110',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108043,337,'Gelhia Bishanpur','852218',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108044,337,'Ghiwaha','852137',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108045,337,'Ghuran','852131',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108046,337,'Gidarahi','852131',1,0,'2022-03-03 13:22:39','2022-03-03 13:22:39'),(108047,337,'Girdharpatti','852137',1,0,'2022-03-03 13:22:40','2022-03-03 13:22:40'),(108048,337,'Gonaha','852125',1,0,'2022-03-03 13:22:40','2022-03-03 13:22:40'),(108049,337,'Goshpur','852215',1,0,'2022-03-03 13:22:40','2022-03-03 13:22:40'),(108050,337,'Govindpur','852125',1,0,'2022-03-03 13:22:40','2022-03-03 13:22:40'),(108051,337,'Govinpur','852214',1,0,'2022-03-03 13:22:40','2022-03-03 13:22:40'),(108052,337,'Guria','852214',1,0,'2022-03-03 13:22:40','2022-03-03 13:22:40'),(108053,337,'Gwalpara','852137',1,0,'2022-03-03 13:22:40','2022-03-03 13:22:40'),(108054,337,'Hariharpur','852137',1,0,'2022-03-03 13:22:40','2022-03-03 13:22:40'),(108055,337,'Haripur','852111',1,0,'2022-03-03 13:22:40','2022-03-03 13:22:40'),(108056,337,'Hariraha','852215',1,0,'2022-03-03 13:22:40','2022-03-03 13:22:40'),(108057,337,'Hati','852130',1,0,'2022-03-03 13:22:40','2022-03-03 13:22:40'),(108058,337,'Hatwaria','852108',1,0,'2022-03-03 13:22:40','2022-03-03 13:22:40'),(108059,337,'Herdi','852108',1,0,'2022-03-03 13:22:40','2022-03-03 13:22:40'),(108060,337,'Hulas','852111',1,0,'2022-03-03 13:22:40','2022-03-03 13:22:40'),(108061,337,'Jadia','852214',1,0,'2022-03-03 13:22:40','2022-03-03 13:22:40'),(108062,337,'Janak Lal Basanpatti','852215',1,0,'2022-03-03 13:22:40','2022-03-03 13:22:40'),(108063,337,'Jaraila','852139',1,0,'2022-03-03 13:22:40','2022-03-03 13:22:40'),(108064,337,'Jhila Dumari','852111',1,0,'2022-03-03 13:22:40','2022-03-03 13:22:40'),(108065,337,'Jia Ram Raghopur','852111',1,0,'2022-03-03 13:22:40','2022-03-03 13:22:40'),(108066,337,'Jiwachhpur','852125',1,0,'2022-03-03 13:22:40','2022-03-03 13:22:40'),(108067,337,'Jobaha','852131',1,0,'2022-03-03 13:22:40','2022-03-03 13:22:40'),(108068,337,'Jolahaniya','852131',1,0,'2022-03-03 13:22:40','2022-03-03 13:22:40'),(108069,337,'Kadampura','852131',1,0,'2022-03-03 13:22:40','2022-03-03 13:22:40'),(108070,337,'Kamaldaha','852105',1,0,'2022-03-03 13:22:40','2022-03-03 13:22:40'),(108071,337,'Kamargama','852218',1,0,'2022-03-03 13:22:40','2022-03-03 13:22:40'),(108072,337,'Karibiahi','852139',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108073,337,'Kariho','852131',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108074,337,'Karjain Bazar','852215',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108075,337,'Karupur','852131',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108076,337,'Kataia Mahe','852131',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108077,337,'Kataiya','852123',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108078,337,'Kathbanshi','852110',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108079,337,'Kharail','852131',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108080,337,'Khokhnaha','852131',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108081,337,'Khunti','852137',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108082,337,'Koria Patti','852214',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108083,337,'Koriyarh','852108',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108084,337,'Korlahi','852215',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108085,337,'Kumiahi','852139',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108086,337,'Kushaha','852139',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108087,337,'Laharnia','852139',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108088,337,'Lakshminia','854339',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108089,337,'Lalganj','852137',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108090,337,'Lalpur','852109',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108091,337,'Lalpur','852137',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108092,337,'Latauna','852139',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108093,337,'Laukaha','852110',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108094,337,'Laurh','852131',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108095,337,'Madhubani','852125',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108096,337,'Mahadeo Asthan','852109',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108097,337,'Maheshpur','852109',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108098,337,'Mahulia','852214',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108099,337,'Makuna','852110',1,0,'2022-03-03 13:22:41','2022-03-03 13:22:41'),(108100,337,'Malarh','852138',1,0,'2022-03-03 13:22:42','2022-03-03 13:22:42'),(108101,337,'Malhanwa','852139',1,0,'2022-03-03 13:22:42','2022-03-03 13:22:42'),(108102,337,'Manganj','852214',1,0,'2022-03-03 13:22:42','2022-03-03 13:22:42'),(108103,337,'Manganj Bazar','852214',1,0,'2022-03-03 13:22:42','2022-03-03 13:22:42'),(108104,337,'Matiayari','854339',1,0,'2022-03-03 13:22:42','2022-03-03 13:22:42'),(108105,337,'Maujaha','852131',1,0,'2022-03-03 13:22:42','2022-03-03 13:22:42'),(108106,337,'Mirjawa','852139',1,0,'2022-03-03 13:22:42','2022-03-03 13:22:42'),(108107,337,'Mohania','852110',1,0,'2022-03-03 13:22:42','2022-03-03 13:22:42'),(108108,337,'Mohanpur','852137',1,0,'2022-03-03 13:22:42','2022-03-03 13:22:42'),(108109,337,'Mohmmad Ganj','852137',1,0,'2022-03-03 13:22:42','2022-03-03 13:22:42'),(108110,337,'Monga Sihol','852131',1,0,'2022-03-03 13:22:42','2022-03-03 13:22:42'),(108111,337,'Motipur','852215',1,0,'2022-03-03 13:22:42','2022-03-03 13:22:42'),(108112,337,'Murli','852105',1,0,'2022-03-03 13:22:42','2022-03-03 13:22:42'),(108113,337,'Narahi','852138',1,0,'2022-03-03 13:22:42','2022-03-03 13:22:42'),(108114,337,'Narainpur','852111',1,0,'2022-03-03 13:22:42','2022-03-03 13:22:42'),(108115,337,'Nauwa Bakhar','852138',1,0,'2022-03-03 13:22:42','2022-03-03 13:22:42'),(108116,337,'Nemua','852130',1,0,'2022-03-03 13:22:42','2022-03-03 13:22:42'),(108117,337,'Nirmali','852131',1,0,'2022-03-03 13:22:42','2022-03-03 13:22:42'),(108118,337,'Orlaha Bazitpur','852139',1,0,'2022-03-03 13:22:42','2022-03-03 13:22:42'),(108119,337,'P.Prayag','852214',1,0,'2022-03-03 13:22:42','2022-03-03 13:22:42'),(108120,337,'Pakri','852218',1,0,'2022-03-03 13:22:42','2022-03-03 13:22:42'),(108121,337,'Pariyahi','852137',1,0,'2022-03-03 13:22:42','2022-03-03 13:22:42'),(108122,337,'Parsa Madho','852138',1,0,'2022-03-03 13:22:42','2022-03-03 13:22:42'),(108123,337,'Parsharma','852130',1,0,'2022-03-03 13:22:42','2022-03-03 13:22:42'),(108124,337,'Pathra','852131',1,0,'2022-03-03 13:22:42','2022-03-03 13:22:42'),(108125,337,'Persa','852218',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108126,337,'Persa Garhi','852214',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108127,337,'Phulkahi','852111',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108128,337,'Phulwaria','852105',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108129,337,'Pipra Bazar','852218',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108130,337,'Piprakhurd','852131',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108131,337,'Pratapganj (Supaul)','852125',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108132,337,'Radha Nagar','852111',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108133,337,'Raghunathpur','852214',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108134,337,'Raharia','852105',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108135,337,'Rajeshwari','852214',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108136,337,'Rajpur','852218',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108137,337,'Rakia','852110',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108138,337,'Ram Bishanpur','852111',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108139,337,'Ramnagar','852108',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108140,337,'Ratanpura','852215',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108141,337,'Ratauli','852138',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108142,337,'Saheban','854338',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108143,337,'Sahpur Prithbi Patti','852111',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108144,337,'Sakhua','852218',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108145,337,'Sanskrit Nirmali','854339',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108146,337,'Saraigarh','852105',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108147,337,'Simaria','852218',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108148,337,'Simrahi Bazar','852111',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108149,337,'Singihaun','852138',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108150,337,'Sitapur','854339',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108151,337,'Siyana','852105',1,0,'2022-03-03 13:22:43','2022-03-03 13:22:43'),(108152,337,'Sripur','852215',1,0,'2022-03-03 13:22:44','2022-03-03 13:22:44'),(108153,337,'Sripur Sukhasan','852138',1,0,'2022-03-03 13:22:44','2022-03-03 13:22:44'),(108154,337,'Sukhanagar','852125',1,0,'2022-03-03 13:22:44','2022-03-03 13:22:44'),(108155,337,'Sukhpur','852130',1,0,'2022-03-03 13:22:44','2022-03-03 13:22:44'),(108156,337,'Supaul Bazar','852131',1,0,'2022-03-03 13:22:44','2022-03-03 13:22:44'),(108157,337,'Supaul','852131',1,0,'2022-03-03 13:22:44','2022-03-03 13:22:44'),(108158,337,'Surjapur','852125',1,0,'2022-03-03 13:22:44','2022-03-03 13:22:44'),(108159,337,'Surpatganj','852137',1,0,'2022-03-03 13:22:44','2022-03-03 13:22:44'),(108160,337,'Tamua','852214',1,0,'2022-03-03 13:22:44','2022-03-03 13:22:44'),(108161,337,'Tarhi Bazar','852215',1,0,'2022-03-03 13:22:44','2022-03-03 13:22:44'),(108162,337,'Tarhi Bhawanipur','852218',1,0,'2022-03-03 13:22:44','2022-03-03 13:22:44'),(108163,337,'Tekuna','852125',1,0,'2022-03-03 13:22:44','2022-03-03 13:22:44'),(108164,337,'Telwa Situhar','852130',1,0,'2022-03-03 13:22:44','2022-03-03 13:22:44'),(108165,337,'Tharbitta','852138',1,0,'2022-03-03 13:22:44','2022-03-03 13:22:44'),(108166,337,'Triveniganj','852139',1,0,'2022-03-03 13:22:44','2022-03-03 13:22:44'),(108167,337,'Tullapatti','852108',1,0,'2022-03-03 13:22:44','2022-03-03 13:22:44'),(108168,338,'Ababakarpur','844112',1,0,'2022-03-03 13:22:44','2022-03-03 13:22:44'),(108169,338,'Bherokhara','844112',1,0,'2022-03-03 13:22:44','2022-03-03 13:22:44'),(108170,338,'Bishanpur Arara','844112',1,0,'2022-03-03 13:22:44','2022-03-03 13:22:44'),(108171,338,'Chapaith','844112',1,0,'2022-03-03 13:22:44','2022-03-03 13:22:44'),(108172,338,'Khajechand Chapra','844112',1,0,'2022-03-03 13:22:44','2022-03-03 13:22:44'),(108173,338,'Kishanpur Telour','843102',1,0,'2022-03-03 13:22:44','2022-03-03 13:22:44'),(108174,338,'M. Afzalpur','844120',1,0,'2022-03-03 13:22:44','2022-03-03 13:22:44'),(108175,338,'Mansurpur Halaiya','844112',1,0,'2022-03-03 13:22:44','2022-03-03 13:22:44'),(108176,338,'Sehan','844112',1,0,'2022-03-03 13:22:44','2022-03-03 13:22:44'),(108177,338,'Ababakarpur  Kowahi','843114',1,0,'2022-03-03 13:22:44','2022-03-03 13:22:44'),(108178,338,'Abbul Hasanpur','844123',1,0,'2022-03-03 13:22:45','2022-03-03 13:22:45'),(108179,338,'Adalpur','844126',1,0,'2022-03-03 13:22:45','2022-03-03 13:22:45'),(108180,338,'Ajijpur Chande','843110',1,0,'2022-03-03 13:22:45','2022-03-03 13:22:45'),(108181,338,'Akhtiyarpur Paterha','844125',1,0,'2022-03-03 13:22:45','2022-03-03 13:22:45'),(108182,338,'Alipur Hatta','844506',1,0,'2022-03-03 13:22:45','2022-03-03 13:22:45'),(108183,338,'Amritpur','844113',1,0,'2022-03-03 13:22:45','2022-03-03 13:22:45'),(108184,338,'Aniruddha Belsar','844111',1,0,'2022-03-03 13:22:45','2022-03-03 13:22:45'),(108185,338,'Anjani','844125',1,0,'2022-03-03 13:22:45','2022-03-03 13:22:45'),(108186,338,'Anzanpeer Chok','844103',1,0,'2022-03-03 13:22:45','2022-03-03 13:22:45'),(108187,338,'Arnia','844505',1,0,'2022-03-03 13:22:45','2022-03-03 13:22:45'),(108188,338,'Asoi','844114',1,0,'2022-03-03 13:22:45','2022-03-03 13:22:45'),(108189,338,'Azampur','844504',1,0,'2022-03-03 13:22:45','2022-03-03 13:22:45'),(108190,338,'B.Tandipur','844505',1,0,'2022-03-03 13:22:45','2022-03-03 13:22:45'),(108191,338,'Bahuara','844502',1,0,'2022-03-03 13:22:45','2022-03-03 13:22:45'),(108192,338,'Baikunthpur','844124',1,0,'2022-03-03 13:22:45','2022-03-03 13:22:45'),(108193,338,'Bajitpur Kasturi','844509',1,0,'2022-03-03 13:22:45','2022-03-03 13:22:45'),(108194,338,'Bajitpur Malahi','844502',1,0,'2022-03-03 13:22:45','2022-03-03 13:22:45'),(108195,338,'Bajitpur Saidat','844503',1,0,'2022-03-03 13:22:45','2022-03-03 13:22:45'),(108196,338,'Bakhari Supayan','844504',1,0,'2022-03-03 13:22:45','2022-03-03 13:22:45'),(108197,338,'Bakhri Dua','844122',1,0,'2022-03-03 13:22:46','2022-03-03 13:22:46'),(108198,338,'Baksama','844122',1,0,'2022-03-03 13:22:46','2022-03-03 13:22:46'),(108199,338,'Balatand','844502',1,0,'2022-03-03 13:22:46','2022-03-03 13:22:46'),(108200,338,'Baligaon Chandpura','843114',1,0,'2022-03-03 13:22:46','2022-03-03 13:22:46'),(108201,338,'Balukaram','844113',1,0,'2022-03-03 13:22:46','2022-03-03 13:22:46'),(108202,338,'Balwakuari','844103',1,0,'2022-03-03 13:22:46','2022-03-03 13:22:46'),(108203,338,'Bardiha Turki','843110',1,0,'2022-03-03 13:22:46','2022-03-03 13:22:46'),(108204,338,'Basantpur','844504',1,0,'2022-03-03 13:22:46','2022-03-03 13:22:46'),(108205,338,'Basara','844124',1,0,'2022-03-03 13:22:46','2022-03-03 13:22:46'),(108206,338,'Basudeopur Chandel','844501',1,0,'2022-03-03 13:22:46','2022-03-03 13:22:46'),(108207,338,'Bathna Mahodat','844118',1,0,'2022-03-03 13:22:46','2022-03-03 13:22:46'),(108208,338,'Belkunda','844125',1,0,'2022-03-03 13:22:46','2022-03-03 13:22:46'),(108209,338,'Belwar','844111',1,0,'2022-03-03 13:22:46','2022-03-03 13:22:46'),(108210,338,'Bhagwanpur (Vaishali)','844114',1,0,'2022-03-03 13:22:46','2022-03-03 13:22:46'),(108211,338,'Bhagwatpur Taraura','844122',1,0,'2022-03-03 13:22:46','2022-03-03 13:22:46'),(108212,338,'Bhairopur Deodhi','844102',1,0,'2022-03-03 13:22:46','2022-03-03 13:22:46'),(108213,338,'Bhanborhan','844122',1,0,'2022-03-03 13:22:46','2022-03-03 13:22:46'),(108214,338,'Bhataulia','844504',1,0,'2022-03-03 13:22:46','2022-03-03 13:22:46'),(108215,338,'Bhathahi','844505',1,0,'2022-03-03 13:22:46','2022-03-03 13:22:46'),(108216,338,'Bhojpatti','844125',1,0,'2022-03-03 13:22:46','2022-03-03 13:22:46'),(108217,338,'Bhuwalpur Bahadurpur','844118',1,0,'2022-03-03 13:22:46','2022-03-03 13:22:46'),(108218,338,'Bibipur','844111',1,0,'2022-03-03 13:22:46','2022-03-03 13:22:46'),(108219,338,'Bidupur Bazar','844503',1,0,'2022-03-03 13:22:47','2022-03-03 13:22:47'),(108220,338,'Bidupur Rs','844502',1,0,'2022-03-03 13:22:47','2022-03-03 13:22:47'),(108221,338,'Bilandpur','844116',1,0,'2022-03-03 13:22:47','2022-03-03 13:22:47'),(108222,338,'Birna Lakhan Sen','844125',1,0,'2022-03-03 13:22:47','2022-03-03 13:22:47'),(108223,338,'Bishanpur  Bande','844114',1,0,'2022-03-03 13:22:47','2022-03-03 13:22:47'),(108224,338,'Bishanpur','844508',1,0,'2022-03-03 13:22:47','2022-03-03 13:22:47'),(108225,338,'Bishanpur Bedaulia','844505',1,0,'2022-03-03 13:22:47','2022-03-03 13:22:47'),(108226,338,'Bishanpur Bejha','844116',1,0,'2022-03-03 13:22:47','2022-03-03 13:22:47'),(108227,338,'Bishanpur Said Urf Bakarpur','844115',1,0,'2022-03-03 13:22:47','2022-03-03 13:22:47'),(108228,338,'Bishanpur Titara','844502',1,0,'2022-03-03 13:22:47','2022-03-03 13:22:47'),(108229,338,'Bishunpur Rajkhand','844503',1,0,'2022-03-03 13:22:47','2022-03-03 13:22:47'),(108230,338,'Bithauli','844114',1,0,'2022-03-03 13:22:47','2022-03-03 13:22:47'),(108231,338,'Boaria','844114',1,0,'2022-03-03 13:22:47','2022-03-03 13:22:47'),(108232,338,'Chakaiya','844126',1,0,'2022-03-03 13:22:47','2022-03-03 13:22:47'),(108233,338,'Chakamgola','844504',1,0,'2022-03-03 13:22:47','2022-03-03 13:22:47'),(108234,338,'Chakgarho Daudnagar','844503',1,0,'2022-03-03 13:22:47','2022-03-03 13:22:47'),(108235,338,'Chakjamal','844509',1,0,'2022-03-03 13:22:47','2022-03-03 13:22:47'),(108236,338,'Chaklahlad','844113',1,0,'2022-03-03 13:22:47','2022-03-03 13:22:47'),(108237,338,'Chakmajahid','844122',1,0,'2022-03-03 13:22:47','2022-03-03 13:22:47'),(108238,338,'Chakmaruf','844118',1,0,'2022-03-03 13:22:47','2022-03-03 13:22:47'),(108239,338,'Chakramdas','844128',1,0,'2022-03-03 13:22:47','2022-03-03 13:22:47'),(108240,338,'Chaksaid','844122',1,0,'2022-03-03 13:22:47','2022-03-03 13:22:47'),(108241,338,'Chaksikandar','844115',1,0,'2022-03-03 13:22:48','2022-03-03 13:22:48'),(108242,338,'Chaksingar','844508',1,0,'2022-03-03 13:22:48','2022-03-03 13:22:48'),(108243,338,'Chamarhara Mamsai','844505',1,0,'2022-03-03 13:22:48','2022-03-03 13:22:48'),(108244,338,'Chandpura','844502',1,0,'2022-03-03 13:22:48','2022-03-03 13:22:48'),(108245,338,'Chandpura Idrak','844508',1,0,'2022-03-03 13:22:48','2022-03-03 13:22:48'),(108246,338,'Chandpura Nankar','844504',1,0,'2022-03-03 13:22:48','2022-03-03 13:22:48'),(108247,338,'Chandralay','844103',1,0,'2022-03-03 13:22:48','2022-03-03 13:22:48'),(108248,338,'Chandsarai Sahdullahchak','844122',1,0,'2022-03-03 13:22:48','2022-03-03 13:22:48'),(108249,338,'Chansarai','844505',1,0,'2022-03-03 13:22:48','2022-03-03 13:22:48'),(108250,338,'Chechar','844503',1,0,'2022-03-03 13:22:48','2022-03-03 13:22:48'),(108251,338,'Chehrakala','844122',1,0,'2022-03-03 13:22:48','2022-03-03 13:22:48'),(108252,338,'Chhourahi','844122',1,0,'2022-03-03 13:22:48','2022-03-03 13:22:48'),(108253,338,'Chitrauli','844126',1,0,'2022-03-03 13:22:48','2022-03-03 13:22:48'),(108254,338,'Dabhaichh','843110',1,0,'2022-03-03 13:22:48','2022-03-03 13:22:48'),(108255,338,'Daudnagar','844113',1,0,'2022-03-03 13:22:48','2022-03-03 13:22:48'),(108256,338,'Dayalpur Garh','844502',1,0,'2022-03-03 13:22:48','2022-03-03 13:22:48'),(108257,338,'Desari','844504',1,0,'2022-03-03 13:22:48','2022-03-03 13:22:48'),(108258,338,'Dhamaun','844506',1,0,'2022-03-03 13:22:48','2022-03-03 13:22:48'),(108259,338,'Dhandhua','844504',1,0,'2022-03-03 13:22:48','2022-03-03 13:22:48'),(108260,338,'Dhankaul','843114',1,0,'2022-03-03 13:22:49','2022-03-03 13:22:49'),(108261,338,'Dharampur','844111',1,0,'2022-03-03 13:22:49','2022-03-03 13:22:49'),(108262,338,'Dharhara (Vaishali)','844117',1,0,'2022-03-03 13:22:49','2022-03-03 13:22:49'),(108263,338,'Dighi Kala','844102',1,0,'2022-03-03 13:22:49','2022-03-03 13:22:49'),(108264,338,'Dih Bichauli','844505',1,0,'2022-03-03 13:22:49','2022-03-03 13:22:49'),(108265,338,'Dilawarpur Govardhan','844503',1,0,'2022-03-03 13:22:49','2022-03-03 13:22:49'),(108266,338,'Dumari (Vaishali)','844116',1,0,'2022-03-03 13:22:49','2022-03-03 13:22:49'),(108267,338,'Fatehpur Fulwaria','844116',1,0,'2022-03-03 13:22:49','2022-03-03 13:22:49'),(108268,338,'Gadaisarai','844103',1,0,'2022-03-03 13:22:49','2022-03-03 13:22:49'),(108269,338,'Gara Urf Govindpur Devi','844126',1,0,'2022-03-03 13:22:49','2022-03-03 13:22:49'),(108270,338,'Garjaul','844114',1,0,'2022-03-03 13:22:49','2022-03-03 13:22:49'),(108271,338,'Gauspur Bariarpur','844115',1,0,'2022-03-03 13:22:49','2022-03-03 13:22:49'),(108272,338,'Ghataro','844119',1,0,'2022-03-03 13:22:49','2022-03-03 13:22:49'),(108273,338,'Goraul','844118',1,0,'2022-03-03 13:22:49','2022-03-03 13:22:49'),(108274,338,'Gorigama','844507',1,0,'2022-03-03 13:22:49','2022-03-03 13:22:49'),(108275,338,'Govindpur Gokhula','844503',1,0,'2022-03-03 13:22:49','2022-03-03 13:22:49'),(108276,338,'Gurmia','844117',1,0,'2022-03-03 13:22:49','2022-03-03 13:22:49'),(108277,338,'Hajipur Chowk','844101',1,0,'2022-03-03 13:22:49','2022-03-03 13:22:49'),(108278,338,'Hajipur H.O','844101',1,0,'2022-03-03 13:22:49','2022-03-03 13:22:49'),(108279,338,'Hajipur Ind.Area','844102',1,0,'2022-03-03 13:22:49','2022-03-03 13:22:49'),(108280,338,'Hansikewal','844114',1,0,'2022-03-03 13:22:49','2022-03-03 13:22:49'),(108281,338,'Harauli','844103',1,0,'2022-03-03 13:22:49','2022-03-03 13:22:49'),(108282,338,'Hargovindpur','844501',1,0,'2022-03-03 13:22:49','2022-03-03 13:22:49'),(108283,338,'Harpur Belwa','844126',1,0,'2022-03-03 13:22:50','2022-03-03 13:22:50'),(108284,338,'Harpur Fatikwara','844501',1,0,'2022-03-03 13:22:50','2022-03-03 13:22:50'),(108285,338,'Hasanpur','844506',1,0,'2022-03-03 13:22:50','2022-03-03 13:22:50'),(108286,338,'Hasanpur Gurda','844506',1,0,'2022-03-03 13:22:50','2022-03-03 13:22:50'),(108287,338,'Hasapur Bhadwas','844122',1,0,'2022-03-03 13:22:50','2022-03-03 13:22:50'),(108288,338,'Hauzpura','844111',1,0,'2022-03-03 13:22:50','2022-03-03 13:22:50'),(108289,338,'Hilalpur Madarpur','844502',1,0,'2022-03-03 13:22:50','2022-03-03 13:22:50'),(108290,338,'Husaina Khurd','844114',1,0,'2022-03-03 13:22:50','2022-03-03 13:22:50'),(108291,338,'Ishmilepur','844103',1,0,'2022-03-03 13:22:50','2022-03-03 13:22:50'),(108292,338,'Izra','844103',1,0,'2022-03-03 13:22:50','2022-03-03 13:22:50'),(108293,338,'Jadhua','844102',1,0,'2022-03-03 13:22:50','2022-03-03 13:22:50'),(108294,338,'Jafarpatti','844504',1,0,'2022-03-03 13:22:50','2022-03-03 13:22:50'),(108295,338,'Jafrabad','844503',1,0,'2022-03-03 13:22:50','2022-03-03 13:22:50'),(108296,338,'Jahangirpur Salkhanni','844126',1,0,'2022-03-03 13:22:50','2022-03-03 13:22:50'),(108297,338,'Jahangirpur Sham','844504',1,0,'2022-03-03 13:22:50','2022-03-03 13:22:50'),(108298,338,'Jaintipur','844121',1,0,'2022-03-03 13:22:50','2022-03-03 13:22:50'),(108299,338,'Jalalpur','844121',1,0,'2022-03-03 13:22:50','2022-03-03 13:22:50'),(108300,338,'Jarang Rampur','844123',1,0,'2022-03-03 13:22:50','2022-03-03 13:22:50'),(108301,338,'Jhandaha','844505',1,0,'2022-03-03 13:22:50','2022-03-03 13:22:50'),(108302,338,'Jowaj','844505',1,0,'2022-03-03 13:22:51','2022-03-03 13:22:51'),(108303,338,'Juramanpur Rampur','844508',1,0,'2022-03-03 13:22:51','2022-03-03 13:22:51'),(108304,338,'Jurawanpur Barari','844508',1,0,'2022-03-03 13:22:51','2022-03-03 13:22:51'),(108305,338,'Jurawanpur Karari','844508',1,0,'2022-03-03 13:22:51','2022-03-03 13:22:51'),(108306,338,'Kadilpur','844504',1,0,'2022-03-03 13:22:51','2022-03-03 13:22:51'),(108307,338,'Kalapahar','844505',1,0,'2022-03-03 13:22:51','2022-03-03 13:22:51'),(108308,338,'Kalyanpur','844115',1,0,'2022-03-03 13:22:51','2022-03-03 13:22:51'),(108309,338,'Kanhauli','844122',1,0,'2022-03-03 13:22:51','2022-03-03 13:22:51'),(108310,338,'Karhatia Buzurg','844122',1,0,'2022-03-03 13:22:51','2022-03-03 13:22:51'),(108311,338,'Karnauti','844501',1,0,'2022-03-03 13:22:51','2022-03-03 13:22:51'),(108312,338,'Karneji','844111',1,0,'2022-03-03 13:22:51','2022-03-03 13:22:51'),(108313,338,'Kartahan','844119',1,0,'2022-03-03 13:22:51','2022-03-03 13:22:51'),(108314,338,'Katarmala','844114',1,0,'2022-03-03 13:22:51','2022-03-03 13:22:51'),(108315,338,'Kawadid','843114',1,0,'2022-03-03 13:22:51','2022-03-03 13:22:51'),(108316,338,'Kazari Buzurg','844507',1,0,'2022-03-03 13:22:51','2022-03-03 13:22:51'),(108317,338,'Khanjahachak','844121',1,0,'2022-03-03 13:22:51','2022-03-03 13:22:51'),(108318,338,'Khanpur Pakari','844115',1,0,'2022-03-03 13:22:51','2022-03-03 13:22:51'),(108319,338,'Khesrahi','843114',1,0,'2022-03-03 13:22:51','2022-03-03 13:22:51'),(108320,338,'Khilwat','844503',1,0,'2022-03-03 13:22:51','2022-03-03 13:22:51'),(108321,338,'Khokhsa Bujurg','844504',1,0,'2022-03-03 13:22:51','2022-03-03 13:22:51'),(108322,338,'Khopi','844507',1,0,'2022-03-03 13:22:51','2022-03-03 13:22:51'),(108323,338,'Kiratpur Rajaram','844114',1,0,'2022-03-03 13:22:51','2022-03-03 13:22:51'),(108324,338,'Kumar Bajitpur','843110',1,0,'2022-03-03 13:22:52','2022-03-03 13:22:52'),(108325,338,'Kutubpur Saidpur','844503',1,0,'2022-03-03 13:22:52','2022-03-03 13:22:52'),(108326,338,'Lakhani','844502',1,0,'2022-03-03 13:22:52','2022-03-03 13:22:52'),(108327,338,'Lakhmipur','844504',1,0,'2022-03-03 13:22:52','2022-03-03 13:22:52'),(108328,338,'Lalganj (Vaishali)','844121',1,0,'2022-03-03 13:22:52','2022-03-03 13:22:52'),(108329,338,'Lawapur Mahnar','844506',1,0,'2022-03-03 13:22:52','2022-03-03 13:22:52'),(108330,338,'Lawapur Narain','844506',1,0,'2022-03-03 13:22:52','2022-03-03 13:22:52'),(108331,338,'Laxmanpur','844122',1,0,'2022-03-03 13:22:52','2022-03-03 13:22:52'),(108332,338,'Loma','844505',1,0,'2022-03-03 13:22:52','2022-03-03 13:22:52'),(108333,338,'Madarna','844113',1,0,'2022-03-03 13:22:52','2022-03-03 13:22:52'),(108334,338,'Madhaul','844122',1,0,'2022-03-03 13:22:52','2022-03-03 13:22:52'),(108335,338,'Madhopur Nijhma','844122',1,0,'2022-03-03 13:22:52','2022-03-03 13:22:52'),(108336,338,'Madhopur Ram','844113',1,0,'2022-03-03 13:22:52','2022-03-03 13:22:52'),(108337,338,'Madhurapur','844503',1,0,'2022-03-03 13:22:52','2022-03-03 13:22:52'),(108338,338,'Maganpur','844118',1,0,'2022-03-03 13:22:52','2022-03-03 13:22:52'),(108339,338,'Mahathi Dharamchand','844126',1,0,'2022-03-03 13:22:52','2022-03-03 13:22:52'),(108340,338,'Mahipura','844505',1,0,'2022-03-03 13:22:52','2022-03-03 13:22:52'),(108341,338,'Mahisaur','844505',1,0,'2022-03-03 13:22:52','2022-03-03 13:22:52'),(108342,338,'Mahnar Road Rs','844507',1,0,'2022-03-03 13:22:52','2022-03-03 13:22:52'),(108343,338,'Mahnar','844506',1,0,'2022-03-03 13:22:52','2022-03-03 13:22:52'),(108344,338,'Mahuwa','844122',1,0,'2022-03-03 13:22:53','2022-03-03 13:22:53'),(108345,338,'Majhauli','844123',1,0,'2022-03-03 13:22:53','2022-03-03 13:22:53'),(108346,338,'Malikpura','844118',1,0,'2022-03-03 13:22:53','2022-03-03 13:22:53'),(108347,338,'Malpur','843110',1,0,'2022-03-03 13:22:53','2022-03-03 13:22:53'),(108348,338,'Mamrejpur','844504',1,0,'2022-03-03 13:22:53','2022-03-03 13:22:53'),(108349,338,'Mandaidih','843110',1,0,'2022-03-03 13:22:53','2022-03-03 13:22:53'),(108350,338,'Mani Bhakurahar','844125',1,0,'2022-03-03 13:22:53','2022-03-03 13:22:53'),(108351,338,'Maniarpur','844504',1,0,'2022-03-03 13:22:53','2022-03-03 13:22:53'),(108352,338,'Manikpur Pakri','844121',1,0,'2022-03-03 13:22:53','2022-03-03 13:22:53'),(108353,338,'Mansingpur Bijhrauli','844505',1,0,'2022-03-03 13:22:53','2022-03-03 13:22:53'),(108354,338,'Marai','844501',1,0,'2022-03-03 13:22:53','2022-03-03 13:22:53'),(108355,338,'Marauatpur','844506',1,0,'2022-03-03 13:22:53','2022-03-03 13:22:53'),(108356,338,'Marui','843110',1,0,'2022-03-03 13:22:53','2022-03-03 13:22:53'),(108357,338,'Mathurapur Sultan','844503',1,0,'2022-03-03 13:22:53','2022-03-03 13:22:53'),(108358,338,'Maudah','843114',1,0,'2022-03-03 13:22:53','2022-03-03 13:22:53'),(108359,338,'Maudah Buzurg','843114',1,0,'2022-03-03 13:22:53','2022-03-03 13:22:53'),(108360,338,'Milki Urf  Chakwaje Khijirpur','844126',1,0,'2022-03-03 13:22:53','2022-03-03 13:22:53'),(108361,338,'Minapur Rai','844103',1,0,'2022-03-03 13:22:53','2022-03-03 13:22:53'),(108362,338,'Mirza Nagar','844122',1,0,'2022-03-03 13:22:53','2022-03-03 13:22:53'),(108363,338,'Mohanpur','844508',1,0,'2022-03-03 13:22:53','2022-03-03 13:22:53'),(108364,338,'Mohanpur','844115',1,0,'2022-03-03 13:22:53','2022-03-03 13:22:53'),(108365,338,'Mukundpur Bhat','844507',1,0,'2022-03-03 13:22:53','2022-03-03 13:22:53'),(108366,338,'Mukundpur Grahi','844504',1,0,'2022-03-03 13:22:54','2022-03-03 13:22:54'),(108367,338,'Murtuzapur','844505',1,0,'2022-03-03 13:22:54','2022-03-03 13:22:54'),(108368,338,'Naharpur','844122',1,0,'2022-03-03 13:22:54','2022-03-03 13:22:54'),(108369,338,'Nainha','844124',1,0,'2022-03-03 13:22:54','2022-03-03 13:22:54'),(108370,338,'Nandlalpur','844113',1,0,'2022-03-03 13:22:54','2022-03-03 13:22:54'),(108371,338,'Narainpur .Deopura','844505',1,0,'2022-03-03 13:22:54','2022-03-03 13:22:54'),(108372,338,'Nari Khurd','844126',1,0,'2022-03-03 13:22:54','2022-03-03 13:22:54'),(108373,338,'Navanagar','844503',1,0,'2022-03-03 13:22:54','2022-03-03 13:22:54'),(108374,338,'Nayaganj','844506',1,0,'2022-03-03 13:22:54','2022-03-03 13:22:54'),(108375,338,'Nilkanthpur','844122',1,0,'2022-03-03 13:22:54','2022-03-03 13:22:54'),(108376,338,'Pachdamia','844119',1,0,'2022-03-03 13:22:54','2022-03-03 13:22:54'),(108377,338,'Paharpur','844508',1,0,'2022-03-03 13:22:54','2022-03-03 13:22:54'),(108378,338,'Paharpur Toi','844509',1,0,'2022-03-03 13:22:54','2022-03-03 13:22:54'),(108379,338,'Palwaiya','844506',1,0,'2022-03-03 13:22:54','2022-03-03 13:22:54'),(108380,338,'Panapur Dharampur','844102',1,0,'2022-03-03 13:22:54','2022-03-03 13:22:54'),(108381,338,'Panapur Langa','844124',1,0,'2022-03-03 13:22:54','2022-03-03 13:22:54'),(108382,338,'Parmanandpur','844507',1,0,'2022-03-03 13:22:54','2022-03-03 13:22:54'),(108383,338,'Pastara','843114',1,0,'2022-03-03 13:22:54','2022-03-03 13:22:54'),(108384,338,'Patepur','843114',1,0,'2022-03-03 13:22:54','2022-03-03 13:22:54'),(108385,338,'Paterha Jairam','844111',1,0,'2022-03-03 13:22:54','2022-03-03 13:22:54'),(108386,338,'Paura','844117',1,0,'2022-03-03 13:22:54','2022-03-03 13:22:54'),(108387,338,'Phular','844122',1,0,'2022-03-03 13:22:54','2022-03-03 13:22:54'),(108388,338,'Pirapur','844505',1,0,'2022-03-03 13:22:54','2022-03-03 13:22:54'),(108389,338,'Pirapur Mathura','844114',1,0,'2022-03-03 13:22:55','2022-03-03 13:22:55'),(108390,338,'Piroi','844114',1,0,'2022-03-03 13:22:55','2022-03-03 13:22:55'),(108391,338,'Pohiar','844507',1,0,'2022-03-03 13:22:55','2022-03-03 13:22:55'),(108392,338,'Pour','844126',1,0,'2022-03-03 13:22:55','2022-03-03 13:22:55'),(108393,338,'Prataptand','844123',1,0,'2022-03-03 13:22:55','2022-03-03 13:22:55'),(108394,338,'Purkhauli','844121',1,0,'2022-03-03 13:22:55','2022-03-03 13:22:55'),(108395,338,'Raghopur Chandel','844508',1,0,'2022-03-03 13:22:55','2022-03-03 13:22:55'),(108396,338,'Raghopur','844508',1,0,'2022-03-03 13:22:55','2022-03-03 13:22:55'),(108397,338,'Raghunathpur Imadpur','844114',1,0,'2022-03-03 13:22:55','2022-03-03 13:22:55'),(108398,338,'Rahimapur','844502',1,0,'2022-03-03 13:22:55','2022-03-03 13:22:55'),(108399,338,'Rahimpur Jagdish','844128',1,0,'2022-03-03 13:22:55','2022-03-03 13:22:55'),(108400,338,'Rajapakar','844124',1,0,'2022-03-03 13:22:55','2022-03-03 13:22:55'),(108401,338,'Rajasan','844102',1,0,'2022-03-03 13:22:55','2022-03-03 13:22:55'),(108402,338,'Rajauli','844102',1,0,'2022-03-03 13:22:55','2022-03-03 13:22:55'),(108403,338,'Rambhadra','844101',1,0,'2022-03-03 13:22:55','2022-03-03 13:22:55'),(108404,338,'Ramouli','843114',1,0,'2022-03-03 13:22:55','2022-03-03 13:22:55'),(108405,338,'Rampur Bhaghel','844507',1,0,'2022-03-03 13:22:55','2022-03-03 13:22:55'),(108406,338,'Rampur Kumaharkol','844507',1,0,'2022-03-03 13:22:55','2022-03-03 13:22:55'),(108407,338,'Rampur Madhaul','844504',1,0,'2022-03-03 13:22:55','2022-03-03 13:22:55'),(108408,338,'Rampur Ramhar','844122',1,0,'2022-03-03 13:22:55','2022-03-03 13:22:55'),(108409,338,'Rampur Ratnakar','844116',1,0,'2022-03-03 13:22:56','2022-03-03 13:22:56'),(108410,338,'Rampur Shyamchand','844508',1,0,'2022-03-03 13:22:56','2022-03-03 13:22:56'),(108411,338,'Rasalpur Fatah','844122',1,0,'2022-03-03 13:22:56','2022-03-03 13:22:56'),(108412,338,'Rasulpur Enayat','844114',1,0,'2022-03-03 13:22:56','2022-03-03 13:22:56'),(108413,338,'Rasulpur Korigaon','844114',1,0,'2022-03-03 13:22:56','2022-03-03 13:22:56'),(108414,338,'Rasulpur Purusottam','844505',1,0,'2022-03-03 13:22:56','2022-03-03 13:22:56'),(108415,338,'Ratnakar','844102',1,0,'2022-03-03 13:22:56','2022-03-03 13:22:56'),(108416,338,'Rikhar','844123',1,0,'2022-03-03 13:22:56','2022-03-03 13:22:56'),(108417,338,'Rushtampur','844508',1,0,'2022-03-03 13:22:56','2022-03-03 13:22:56'),(108418,338,'Sadullahpur','844102',1,0,'2022-03-03 13:22:56','2022-03-03 13:22:56'),(108419,338,'Sahdei Buzurg','844509',1,0,'2022-03-03 13:22:56','2022-03-03 13:22:56'),(108420,338,'Sahdullahpur','844121',1,0,'2022-03-03 13:22:56','2022-03-03 13:22:56'),(108421,338,'Sahdullpur Dhabouli','844502',1,0,'2022-03-03 13:22:56','2022-03-03 13:22:56'),(108422,338,'Sahpur','844505',1,0,'2022-03-03 13:22:56','2022-03-03 13:22:56'),(108423,338,'Sahtha','844123',1,0,'2022-03-03 13:22:56','2022-03-03 13:22:56'),(108424,338,'Saidpur Dumra','843114',1,0,'2022-03-03 13:22:56','2022-03-03 13:22:56'),(108425,338,'Sain','844111',1,0,'2022-03-03 13:22:56','2022-03-03 13:22:56'),(108426,338,'Saistapur','844508',1,0,'2022-03-03 13:22:56','2022-03-03 13:22:56'),(108427,338,'Salempur Dumaria','844122',1,0,'2022-03-03 13:22:56','2022-03-03 13:22:56'),(108428,338,'Salha','844505',1,0,'2022-03-03 13:22:56','2022-03-03 13:22:56'),(108429,338,'Sarai Dhanesh','844509',1,0,'2022-03-03 13:22:56','2022-03-03 13:22:56'),(108430,338,'Sarai','844125',1,0,'2022-03-03 13:22:56','2022-03-03 13:22:56'),(108431,338,'Sarmaspura','844126',1,0,'2022-03-03 13:22:57','2022-03-03 13:22:57'),(108432,338,'Sarmastpur','844501',1,0,'2022-03-03 13:22:57','2022-03-03 13:22:57'),(108433,338,'Sathiauta Bhagwan','844123',1,0,'2022-03-03 13:22:57','2022-03-03 13:22:57'),(108434,338,'Satpura','844114',1,0,'2022-03-03 13:22:57','2022-03-03 13:22:57'),(108435,338,'Sekhopur','844509',1,0,'2022-03-03 13:22:57','2022-03-03 13:22:57'),(108436,338,'Senduari','844124',1,0,'2022-03-03 13:22:57','2022-03-03 13:22:57'),(108437,338,'Serpur Chatwara','844126',1,0,'2022-03-03 13:22:57','2022-03-03 13:22:57'),(108438,338,'Shoharthi','844505',1,0,'2022-03-03 13:22:57','2022-03-03 13:22:57'),(108439,338,'Simarwara Durgapur','843114',1,0,'2022-03-03 13:22:57','2022-03-03 13:22:57'),(108440,338,'Singhara','844126',1,0,'2022-03-03 13:22:57','2022-03-03 13:22:57'),(108441,338,'Sirsabiran','844123',1,0,'2022-03-03 13:22:57','2022-03-03 13:22:57'),(108442,338,'Sondho','844118',1,0,'2022-03-03 13:22:57','2022-03-03 13:22:57'),(108443,338,'Subhai','844102',1,0,'2022-03-03 13:22:57','2022-03-03 13:22:57'),(108444,338,'Sukki','843114',1,0,'2022-03-03 13:22:57','2022-03-03 13:22:57'),(108445,338,'Sultanpur','844506',1,0,'2022-03-03 13:22:57','2022-03-03 13:22:57'),(108446,338,'Taibpur','844506',1,0,'2022-03-03 13:22:57','2022-03-03 13:22:57'),(108447,338,'Thathan Buzurg','844125',1,0,'2022-03-03 13:22:57','2022-03-03 13:22:57'),(108448,338,'Tisiuta Dharampur','844126',1,0,'2022-03-03 13:22:57','2022-03-03 13:22:57'),(108449,338,'Ufraul','844504',1,0,'2022-03-03 13:22:57','2022-03-03 13:22:57'),(108450,338,'Vaishali','844128',1,0,'2022-03-03 13:22:57','2022-03-03 13:22:57'),(108451,338,'Warispur','844114',1,0,'2022-03-03 13:22:57','2022-03-03 13:22:57'),(108452,339,'Ahwar Shaikh','845459',1,0,'2022-03-03 13:22:57','2022-03-03 13:22:57'),(108453,339,'Alamganj Bazar','845459',1,0,'2022-03-03 13:22:57','2022-03-03 13:22:57'),(108454,339,'Alpaha','845438',1,0,'2022-03-03 13:22:57','2022-03-03 13:22:57'),(108455,339,'Amolwa','845455',1,0,'2022-03-03 13:22:58','2022-03-03 13:22:58'),(108456,339,'Amwa Majhar','845459',1,0,'2022-03-03 13:22:58','2022-03-03 13:22:58'),(108457,339,'Anjua','845455',1,0,'2022-03-03 13:22:58','2022-03-03 13:22:58'),(108458,339,'Ashram Brindavan','845450',1,0,'2022-03-03 13:22:58','2022-03-03 13:22:58'),(108459,339,'Auraiya','845450',1,0,'2022-03-03 13:22:58','2022-03-03 13:22:58'),(108460,339,'B. Banahura','845459',1,0,'2022-03-03 13:22:58','2022-03-03 13:22:58'),(108461,339,'B. K. Chowk','845438',1,0,'2022-03-03 13:22:58','2022-03-03 13:22:58'),(108462,339,'B. Patkhaulia','845438',1,0,'2022-03-03 13:22:58','2022-03-03 13:22:58'),(108463,339,'B. Ratanpura','845438',1,0,'2022-03-03 13:22:58','2022-03-03 13:22:58'),(108464,339,'B.B. Bankatwa','845101',1,0,'2022-03-03 13:22:58','2022-03-03 13:22:58'),(108465,339,'Bagaha','845101',1,0,'2022-03-03 13:22:58','2022-03-03 13:22:58'),(108466,339,'Bagahi','845103',1,0,'2022-03-03 13:22:58','2022-03-03 13:22:58'),(108467,339,'Bagahi','845452',1,0,'2022-03-03 13:22:58','2022-03-03 13:22:58'),(108468,339,'Baijua','845438',1,0,'2022-03-03 13:22:58','2022-03-03 13:22:58'),(108469,339,'Bairiya Farm','845438',1,0,'2022-03-03 13:22:58','2022-03-03 13:22:58'),(108470,339,'Baishakhawa','845307',1,0,'2022-03-03 13:22:58','2022-03-03 13:22:58'),(108471,339,'Bakhari Pachrukhia','845106',1,0,'2022-03-03 13:22:58','2022-03-03 13:22:58'),(108472,339,'Bakharia','845454',1,0,'2022-03-03 13:22:58','2022-03-03 13:22:58'),(108473,339,'Bakulahar Math','845449',1,0,'2022-03-03 13:22:58','2022-03-03 13:22:58'),(108474,339,'Bakuli','845105',1,0,'2022-03-03 13:22:58','2022-03-03 13:22:58'),(108475,339,'Balua Rampurwa','845438',1,0,'2022-03-03 13:22:58','2022-03-03 13:22:58'),(108476,339,'Balua Thori Bazar','845104',1,0,'2022-03-03 13:22:59','2022-03-03 13:22:59'),(108477,339,'Banu Chhapar','845438',1,0,'2022-03-03 13:22:59','2022-03-03 13:22:59'),(108478,339,'Bargajwa','845451',1,0,'2022-03-03 13:22:59','2022-03-03 13:22:59'),(108479,339,'Bargaon','845101',1,0,'2022-03-03 13:22:59','2022-03-03 13:22:59'),(108480,339,'Bargo','845103',1,0,'2022-03-03 13:22:59','2022-03-03 13:22:59'),(108481,339,'Bariarwa','845453',1,0,'2022-03-03 13:22:59','2022-03-03 13:22:59'),(108482,339,'Barwa Ojha','845452',1,0,'2022-03-03 13:22:59','2022-03-03 13:22:59'),(108483,339,'Barwat Pasrain','845438',1,0,'2022-03-03 13:22:59','2022-03-03 13:22:59'),(108484,339,'Barwat Sena','845438',1,0,'2022-03-03 13:22:59','2022-03-03 13:22:59'),(108485,339,'Bastha','845306',1,0,'2022-03-03 13:22:59','2022-03-03 13:22:59'),(108486,339,'Baswariya','845453',1,0,'2022-03-03 13:22:59','2022-03-03 13:22:59'),(108487,339,'Behari Bankatwa','845307',1,0,'2022-03-03 13:22:59','2022-03-03 13:22:59'),(108488,339,'Behra','845307',1,0,'2022-03-03 13:22:59','2022-03-03 13:22:59'),(108489,339,'Belbagh','845438',1,0,'2022-03-03 13:22:59','2022-03-03 13:22:59'),(108490,339,'Belsandi','845455',1,0,'2022-03-03 13:22:59','2022-03-03 13:22:59'),(108491,339,'Belwa','845449',1,0,'2022-03-03 13:22:59','2022-03-03 13:22:59'),(108492,339,'Belwa Bahuari','845455',1,0,'2022-03-03 13:22:59','2022-03-03 13:22:59'),(108493,339,'Belwa More','845453',1,0,'2022-03-03 13:22:59','2022-03-03 13:22:59'),(108494,339,'Bettiah City','845438',1,0,'2022-03-03 13:22:59','2022-03-03 13:22:59'),(108495,339,'Bettiah Dih','845438',1,0,'2022-03-03 13:22:59','2022-03-03 13:22:59'),(108496,339,'Bettiah H.O','845438',1,0,'2022-03-03 13:22:59','2022-03-03 13:22:59'),(108497,339,'Bettiah R.S.','845438',1,0,'2022-03-03 13:22:59','2022-03-03 13:22:59'),(108498,339,'Bhabhata','845449',1,0,'2022-03-03 13:22:59','2022-03-03 13:22:59'),(108499,339,'Bhairoganj','845106',1,0,'2022-03-03 13:22:59','2022-03-03 13:22:59'),(108500,339,'Bhaluahia','845306',1,0,'2022-03-03 13:23:00','2022-03-03 13:23:00'),(108501,339,'Bhawal','845106',1,0,'2022-03-03 13:23:00','2022-03-03 13:23:00'),(108502,339,'Bhawanipur','845438',1,0,'2022-03-03 13:23:00','2022-03-03 13:23:00'),(108503,339,'Bhawara','845307',1,0,'2022-03-03 13:23:00','2022-03-03 13:23:00'),(108504,339,'Bheriharwa','845449',1,0,'2022-03-03 13:23:00','2022-03-03 13:23:00'),(108505,339,'Bhikhana Thori','845455',1,0,'2022-03-03 13:23:00','2022-03-03 13:23:00'),(108506,339,'Bhitaha','845104',1,0,'2022-03-03 13:23:00','2022-03-03 13:23:00'),(108507,339,'Bhitaha Nizamat','845438',1,0,'2022-03-03 13:23:00','2022-03-03 13:23:00'),(108508,339,'Bhitiharwa Ashram','845455',1,0,'2022-03-03 13:23:00','2022-03-03 13:23:00'),(108509,339,'Bhuidharwa','845104',1,0,'2022-03-03 13:23:00','2022-03-03 13:23:00'),(108510,339,'Bijbania','845453',1,0,'2022-03-03 13:23:00','2022-03-03 13:23:00'),(108511,339,'Binahi','845104',1,0,'2022-03-03 13:23:00','2022-03-03 13:23:00'),(108512,339,'Bishabhar Pur','845459',1,0,'2022-03-03 13:23:00','2022-03-03 13:23:00'),(108513,339,'Bisunpura','845459',1,0,'2022-03-03 13:23:00','2022-03-03 13:23:00'),(108514,339,'Borwal','845105',1,0,'2022-03-03 13:23:00','2022-03-03 13:23:00'),(108515,339,'Briti Matiaria','845453',1,0,'2022-03-03 13:23:00','2022-03-03 13:23:00'),(108516,339,'Chailabhar','845454',1,0,'2022-03-03 13:23:00','2022-03-03 13:23:00'),(108517,339,'Champapur Gonauli','845107',1,0,'2022-03-03 13:23:00','2022-03-03 13:23:00'),(108518,339,'Chamukha','845452',1,0,'2022-03-03 13:23:00','2022-03-03 13:23:00'),(108519,339,'Chanayan Bandh','845454',1,0,'2022-03-03 13:23:00','2022-03-03 13:23:00'),(108520,339,'Chandarpur Bakawa','845101',1,0,'2022-03-03 13:23:01','2022-03-03 13:23:01'),(108521,339,'Chandraha','845101',1,0,'2022-03-03 13:23:01','2022-03-03 13:23:01'),(108522,339,'Chanpatia Bazar','845449',1,0,'2022-03-03 13:23:01','2022-03-03 13:23:01'),(108523,339,'Chanpatia R S','845449',1,0,'2022-03-03 13:23:01','2022-03-03 13:23:01'),(108524,339,'Chaubey Tola','845449',1,0,'2022-03-03 13:23:01','2022-03-03 13:23:01'),(108525,339,'Chauhatta','845451',1,0,'2022-03-03 13:23:01','2022-03-03 13:23:01'),(108526,339,'Cheutaha','845106',1,0,'2022-03-03 13:23:01','2022-03-03 13:23:01'),(108527,339,'Chilwania','845104',1,0,'2022-03-03 13:23:01','2022-03-03 13:23:01'),(108528,339,'Chuhari','845450',1,0,'2022-03-03 13:23:01','2022-03-03 13:23:01'),(108529,339,'D.K.Shikarpur','845451',1,0,'2022-03-03 13:23:01','2022-03-03 13:23:01'),(108530,339,'Damrapur','845451',1,0,'2022-03-03 13:23:01','2022-03-03 13:23:01'),(108531,339,'Danial Parsauna','845449',1,0,'2022-03-03 13:23:01','2022-03-03 13:23:01'),(108532,339,'Daunaha','845104',1,0,'2022-03-03 13:23:01','2022-03-03 13:23:01'),(108533,339,'Dhamaura','845449',1,0,'2022-03-03 13:23:01','2022-03-03 13:23:01'),(108534,339,'Dhanaha','845104',1,0,'2022-03-03 13:23:01','2022-03-03 13:23:01'),(108535,339,'Dhankutwa','845449',1,0,'2022-03-03 13:23:01','2022-03-03 13:23:01'),(108536,339,'Dharampur','845449',1,0,'2022-03-03 13:23:01','2022-03-03 13:23:01'),(108537,339,'Dhobini','845453',1,0,'2022-03-03 13:23:01','2022-03-03 13:23:01'),(108538,339,'Dhokharaha','845454',1,0,'2022-03-03 13:23:01','2022-03-03 13:23:01'),(108539,339,'Dhum Nagar','845438',1,0,'2022-03-03 13:23:01','2022-03-03 13:23:01'),(108540,339,'Dhumnagar','845104',1,0,'2022-03-03 13:23:01','2022-03-03 13:23:01'),(108541,339,'Dianmarawa','845103',1,0,'2022-03-03 13:23:02','2022-03-03 13:23:02'),(108542,339,'Dudhiawa','845452',1,0,'2022-03-03 13:23:02','2022-03-03 13:23:02'),(108543,339,'Dukhi Chhapar','845307',1,0,'2022-03-03 13:23:02','2022-03-03 13:23:02'),(108544,339,'Dumara','845453',1,0,'2022-03-03 13:23:02','2022-03-03 13:23:02'),(108545,339,'Dumari','845104',1,0,'2022-03-03 13:23:02','2022-03-03 13:23:02'),(108546,339,'Dumari Bazar','845452',1,0,'2022-03-03 13:23:02','2022-03-03 13:23:02'),(108547,339,'Dumaria Estate','845103',1,0,'2022-03-03 13:23:02','2022-03-03 13:23:02'),(108548,339,'Gambhirpur','845438',1,0,'2022-03-03 13:23:02','2022-03-03 13:23:02'),(108549,339,'Gaunaha','845102',1,0,'2022-03-03 13:23:02','2022-03-03 13:23:02'),(108550,339,'Ghogha','845449',1,0,'2022-03-03 13:23:02','2022-03-03 13:23:02'),(108551,339,'Ghorpakari','845306',1,0,'2022-03-03 13:23:02','2022-03-03 13:23:02'),(108552,339,'Gobarahia Done','845106',1,0,'2022-03-03 13:23:02','2022-03-03 13:23:02'),(108553,339,'Gobardhana','845106',1,0,'2022-03-03 13:23:02','2022-03-03 13:23:02'),(108554,339,'Gobraura','845453',1,0,'2022-03-03 13:23:02','2022-03-03 13:23:02'),(108555,339,'Goithahi','845455',1,0,'2022-03-03 13:23:02','2022-03-03 13:23:02'),(108556,339,'Gokhula','845451',1,0,'2022-03-03 13:23:02','2022-03-03 13:23:02'),(108557,339,'Gonauli','845438',1,0,'2022-03-03 13:23:02','2022-03-03 13:23:02'),(108558,339,'Gopalpur','845307',1,0,'2022-03-03 13:23:02','2022-03-03 13:23:02'),(108559,339,'Gora Karamwa','845454',1,0,'2022-03-03 13:23:02','2022-03-03 13:23:02'),(108560,339,'Gudgudi','845106',1,0,'2022-03-03 13:23:02','2022-03-03 13:23:02'),(108561,339,'Gurwalia','845450',1,0,'2022-03-03 13:23:02','2022-03-03 13:23:02'),(108562,339,'Harinagar','845103',1,0,'2022-03-03 13:23:02','2022-03-03 13:23:02'),(108563,339,'Haripur','845307',1,0,'2022-03-03 13:23:02','2022-03-03 13:23:02'),(108564,339,'Harnatar','845105',1,0,'2022-03-03 13:23:02','2022-03-03 13:23:02'),(108565,339,'Harpur','845101',1,0,'2022-03-03 13:23:02','2022-03-03 13:23:02'),(108566,339,'Harpur Tola','845454',1,0,'2022-03-03 13:23:02','2022-03-03 13:23:02'),(108567,339,'Inarwa Bazar','845306',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108568,339,'Jado Chhapar','845450',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108569,339,'Jagarnath Pur','845459',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108570,339,'Jagarnathpur','845307',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108571,339,'Jagdishpur (West Champaran)','845459',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108572,339,'Jaitia','845449',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108573,339,'Jamunia','845455',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108574,339,'Jaralpur Dih','845452',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108575,339,'Jawkatia','845454',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108576,339,'Jhakhara','845459',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108577,339,'Jharmahuee','845103',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108578,339,'Jogapatti','845452',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108579,339,'Jogia','845103',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108580,339,'K.R.High School','845438',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108581,339,'Kathaia','845454',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108582,339,'Kathar','845104',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108583,339,'Kehunia','845453',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108584,339,'Khadda','845438',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108585,339,'Khaira Tola','845104',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108586,339,'Khairpokhara','845105',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108587,339,'Kolhua','845106',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108588,339,'Kunai Bhelahi','845105',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108589,339,'Kurshi Barawa','845307',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108590,339,'Kurwa Mathia','845450',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108591,339,'Lachhnauta','845455',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108592,339,'Lagunaha','845101',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108593,339,'Lakhanpur','845453',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108594,339,'Lal Bazar Bettiah','845438',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108595,339,'Lal Saraiya','845454',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108596,339,'Lalgarh','845438',1,0,'2022-03-03 13:23:03','2022-03-03 13:23:03'),(108597,339,'Laukariya','845438',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108598,339,'Lauriya','845453',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108599,339,'Laxmipur','845450',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108600,339,'Laxmipur Bherihari','845107',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108601,339,'Machhaha','845104',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108602,339,'Machhargawan','845452',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108603,339,'Madhopur','845454',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108604,339,'Madhubani','845104',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108605,339,'Mahna Gani','845438',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108606,339,'Mahuawa','845455',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108607,339,'Mahui','845103',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108608,339,'Mainatand','845306',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108609,339,'Majharia','845106',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108610,339,'Majharia Kisun','845459',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108611,339,'Majhariya Sheikh','845454',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108612,339,'Majhaulia Rs','845454',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108613,339,'Maldi','845451',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108614,339,'Malkauli','845105',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108615,339,'Mangalpur','845105',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108616,339,'Mangalpur Gudaria','845459',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108617,339,'Mangrahari','845451',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108618,339,'Maniari','845451',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108619,339,'Manpur','845101',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108620,339,'Manwa Parsi','845455',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108621,339,'Marjadwa','845306',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108622,339,'Mathia','845453',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108623,339,'Mathia Brit','845454',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108624,339,'Mathia Kathia','845307',1,0,'2022-03-03 13:23:04','2022-03-03 13:23:04'),(108625,339,'Meena Bazar Bettiah','845438',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108626,339,'Meghwal Mathia','845106',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108627,339,'Mehura','845101',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108628,339,'Mohachhinain','845454',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108629,339,'Mura Dih','845104',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108630,339,'Murali','845103',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108631,339,'Murli Parsauni','845307',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108632,339,'Mushahari','845450',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108633,339,'Musharwa','845455',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108634,339,'Naraipur','845105',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108635,339,'Narkaiaganj','845455',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108636,339,'Nauragia Done','845106',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108637,339,'Naurangia','845105',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108638,339,'Nautan Dubey','845438',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108639,339,'Nawalpur','845452',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108640,339,'Naya Tola Bettiah','845438',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108641,339,'Padar Khap','845101',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108642,339,'Padraun','845451',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108643,339,'Pakhanaha Bazar','845438',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108644,339,'Parsa','845101',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108645,339,'Parsa Factory','845453',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108646,339,'Parsauna','845104',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108647,339,'Parsauni Farm','845453',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108648,339,'Patilar','845101',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108649,339,'Patzirwa','845438',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108650,339,'Pharsahani','845105',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108651,339,'Pindari','845306',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108652,339,'Pipra Naurangia','845438',1,0,'2022-03-03 13:23:05','2022-03-03 13:23:05'),(108653,339,'Pipra Pakari','845438',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108654,339,'Piprasi','845104',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108655,339,'Pokharia','845438',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108656,339,'Pokharia Rai','845449',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108657,339,'Puraina','845452',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108658,339,'Puraina Gosai','845449',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108659,339,'Purainia','845307',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108660,339,'Rajabhar','845454',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108661,339,'Rajpur Madan','845455',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108662,339,'Rajwatia','845101',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108663,339,'Rakhahi','845451',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108664,339,'Ramnagar Bankat','845459',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108665,339,'Ramnagar (West Champaran)','845106',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108666,339,'Ramparsauna','845453',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108667,339,'Rampur','845451',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108668,339,'Rampurwa','845107',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108669,339,'Rampurwa','845454',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108670,339,'Rampurwa','845105',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108671,339,'Rampurwa Mahanwa','845454',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108672,339,'Ranglalahi','845104',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108673,339,'Ratanmala Mathia','845454',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108674,339,'Refujee Camp','845438',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108675,339,'Roari','845453',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108676,339,'Rulahi Nizamat','845454',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108677,339,'Sabeya','845103',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108678,339,'Sahadat Pur','845453',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108679,339,'Saidpur','845455',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108680,339,'San Sariya','845438',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108681,339,'Sareya','845459',1,0,'2022-03-03 13:23:06','2022-03-03 13:23:06'),(108682,339,'Sareya Ojhwalia','845438',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108683,339,'Sargatia','845307',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108684,339,'Sariswa Bazar','845454',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108685,339,'Sathi','845449',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108686,339,'Semari Dumari','845106',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108687,339,'Semra Labedaha','845105',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108688,339,'Semra Medraul','845105',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108689,339,'Senwaria','845454',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108690,339,'Serwa Done','845106',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108691,339,'Serwa Masjidwa','845455',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108692,339,'Sheorajpur','845438',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108693,339,'Shikarpur','845307',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108694,339,'Shikarpur','845454',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108695,339,'Shiorajpur','845452',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108696,339,'Shyampur Kotaraha','845459',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108697,339,'Sidhaw','845105',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108698,339,'Sigari Bigari','845106',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108699,339,'Sihpur','845449',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108700,339,'Sikta','845307',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108701,339,'Singari','845101',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108702,339,'Sirisia','845101',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108703,339,'Sirisia','845450',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108704,339,'Sirnagar','845452',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108705,339,'Sisai','845104',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108706,339,'Siswa Basantpur','845453',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108707,339,'Siswa Bhangaha','845306',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108708,339,'Siswania','845453',1,0,'2022-03-03 13:23:07','2022-03-03 13:23:07'),(108709,339,'Sitapur','845103',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108710,339,'Sohagi Barwa','845105',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108711,339,'Sugaha Bhawanipur','845307',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108712,339,'Sugauli','845455',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108713,339,'Sundar Gaon','845307',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108714,339,'Surajpur','845438',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108715,339,'Tadhawa Nandpur','845438',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108716,339,'Taruanwa','845105',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108717,339,'Tarwalia','845105',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108718,339,'Taulaha','845104',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108719,339,'Taulaha Champaran','845455',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108720,339,'Telpur','845103',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108721,339,'Teluha','845459',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108722,339,'Tikulia','845449',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108723,339,'Tinferia','845105',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108724,339,'Tribhuani','845106',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108725,339,'Turahapatti','845450',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108726,339,'Valmiki Nagar','845107',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108727,339,'Victoria Mission','845459',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108728,340,'Adawal','494001',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108729,340,'Adenga','494331',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108730,340,'Alor','494228',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108731,340,'Amabeda','494230',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108732,340,'Amaguda','494001',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108733,340,'Arandi','494230',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108734,340,'Arra','494230',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108735,340,'Asna','494221',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108736,340,'Babai','494226',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108737,340,'Babusemra','494001',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108738,340,'Badagaon','494230',1,0,'2022-03-03 13:23:08','2022-03-03 13:23:08'),(108739,340,'Badanji','494010',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108740,340,'Bade Rajpur','494347',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108741,340,'Badeamabal','494224',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108742,340,'Badebodenar','494442',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108743,340,'Badechakwa','494223',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108744,340,'Badedeoda','494222',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108745,340,'Badedharaur','494010',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108746,340,'Badedongar','494228',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108747,340,'Badekakloor','494442',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108748,340,'Badekanera','494226',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108749,340,'Badekhauli','494230',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108750,340,'Badekilepal','494442',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108751,340,'Bademurma','494001',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108752,340,'Bafna','494226',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108753,340,'Baghmohlai','494223',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108754,340,'Bajawand','494221',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108755,340,'Bakawand','494222',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108756,340,'Bamni Bazar','494226',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108757,340,'Bangaon','494228',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108758,340,'Baniyagaon','494224',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108759,340,'Baniyagaon','494226',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108760,340,'Banjoda','494230',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108761,340,'Banjugani','494226',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108762,340,'Banskote','494347',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108763,340,'Barda','494222',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108764,340,'Barkai','494228',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108765,340,'Bastanar','494442',1,0,'2022-03-03 13:23:09','2022-03-03 13:23:09'),(108766,340,'Bastar','494223',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108767,340,'Bayanar','494226',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108768,340,'Belar','494010',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108769,340,'Bhainsgaon','494223',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108770,340,'Bhandarseoni','494229',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108771,340,'Bhanpuri','494229',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108772,340,'Bhanpuri Basti','494224',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108773,340,'Bhanpuri','494224',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108774,340,'Bijapur','494226',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108775,340,'Binjhe','494230',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108776,340,'Binta','494010',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108777,340,'Bunagaon','494226',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108778,340,'Burdi','494111',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108779,340,'Chapka','494224',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108780,340,'Chema','494226',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108781,340,'Cherbeda','494230',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108782,340,'Chhaparbhanpuri','494010',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108783,340,'Chhinari','494226',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108784,340,'Chingpal','494442',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108785,340,'Chipawand','494226',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108786,340,'Chitaloor','494001',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108787,340,'Chitapur','494442',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108788,340,'Chitrakote','494010',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108789,340,'Chiurgaon','494222',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108790,340,'Chokar','494223',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108791,340,'Chotedeoda','494221',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108792,340,'Choteodagaon','494230',1,0,'2022-03-03 13:23:10','2022-03-03 13:23:10'),(108793,340,'Dahikonga','494226',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108794,340,'Dhanora','494230',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108795,340,'Dhanpunji','494001',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108796,340,'Dharampura','494001',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108797,340,'Dharli','494226',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108798,340,'Dilmili','494442',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108799,340,'Dimrapal','494001',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108800,340,'Dubeumargaon','494223',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108801,340,'Eragaon','494230',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108802,340,'Ermur','494010',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108803,340,'Errakot','494442',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108804,340,'Gadhiya','494010',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108805,340,'Gadiras','494111',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108806,340,'Garda','494010',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108807,340,'Garenga','494224',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108808,340,'Ghotia','494010',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108809,340,'Ghutkel','494347',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108810,340,'Girola','494226',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108811,340,'Golawand','494226',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108812,340,'Guria','494224',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108813,340,'Hatkachora','494001',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108814,340,'Heerapur','494226',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108815,340,'Hirri','494229',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108816,340,'Iti Bastar','494223',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108817,340,'Jagdalpur H.O','494001',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108818,340,'Jagdalpur Kutchery','494001',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108819,340,'Jagdalpur Rly Colony','494001',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108820,340,'Jagdalpur Sadar Bzr','494001',1,0,'2022-03-03 13:23:11','2022-03-03 13:23:11'),(108821,340,'Jaibel','494224',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108822,340,'Jaitgiri','494222',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108823,340,'Jaitpuri','494229',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108824,340,'Joba','494226',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108825,340,'Jodekera','494228',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108826,340,'Juganikalar','494229',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108827,340,'Kachnar','494221',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108828,340,'Kaknar','494010',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108829,340,'Kalepal','494442',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108830,340,'Karanji','494001',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108831,340,'Karitgaon','494221',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108832,340,'Karpawand','494222',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108833,340,'Katagaon','494229',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108834,340,'Kaurgaon','494347',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108835,340,'Kerawahi','494229',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108836,340,'Kesarpal','494224',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108837,340,'Keshkal','494331',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108838,340,'Khalari','494347',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108839,340,'Khetarpal','494230',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108840,340,'Khorkosa','494223',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108841,340,'Kibaibalenga','494226',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108842,340,'Kinjoli','494222',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108843,340,'Kodenar','494442',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108844,340,'Kohkameta','494331',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108845,340,'Kohkapal','494221',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108846,340,'Kokodi','494226',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108847,340,'Kolawali','494222',1,0,'2022-03-03 13:23:12','2022-03-03 13:23:12'),(108848,340,'Kolchur','494223',1,0,'2022-03-03 13:23:13','2022-03-03 13:23:13'),(108849,340,'Kondagaon Naka','494226',1,0,'2022-03-03 13:23:13','2022-03-03 13:23:13'),(108850,340,'Kondagaon','494226',1,0,'2022-03-03 13:23:13','2022-03-03 13:23:13'),(108851,340,'Kongera','494226',1,0,'2022-03-03 13:23:13','2022-03-03 13:23:13'),(108852,340,'Kongud','494230',1,0,'2022-03-03 13:23:13','2022-03-03 13:23:13'),(108853,340,'Kopra','494347',1,0,'2022-03-03 13:23:13','2022-03-03 13:23:13'),(108854,340,'Korta','494222',1,0,'2022-03-03 13:23:13','2022-03-03 13:23:13'),(108855,340,'Kotpad','494228',1,0,'2022-03-03 13:23:13','2022-03-03 13:23:13'),(108856,340,'Kumhali','494224',1,0,'2022-03-03 13:23:13','2022-03-03 13:23:13'),(108857,340,'Kumharawand','494001',1,0,'2022-03-03 13:23:13','2022-03-03 13:23:13'),(108858,340,'Kumharsandra','494442',1,0,'2022-03-03 13:23:13','2022-03-03 13:23:13'),(108859,340,'Kumhli','494010',1,0,'2022-03-03 13:23:13','2022-03-03 13:23:13'),(108860,340,'Kurandi','494001',1,0,'2022-03-03 13:23:13','2022-03-03 13:23:13'),(108861,340,'Kurenga','494001',1,0,'2022-03-03 13:23:13','2022-03-03 13:23:13'),(108862,340,'Kuruspal','494010',1,0,'2022-03-03 13:23:13','2022-03-03 13:23:13'),(108863,340,'Kuthar','494010',1,0,'2022-03-03 13:23:13','2022-03-03 13:23:13'),(108864,340,'Lamker','494223',1,0,'2022-03-03 13:23:13','2022-03-03 13:23:13'),(108865,340,'Lanjoda','494229',1,0,'2022-03-03 13:23:13','2022-03-03 13:23:13'),(108866,340,'Lihagaon','494347',1,0,'2022-03-03 13:23:13','2022-03-03 13:23:13'),(108867,340,'Lohandiguda','494010',1,0,'2022-03-03 13:23:13','2022-03-03 13:23:13'),(108868,340,'Lubha','494228',1,0,'2022-03-03 13:23:13','2022-03-03 13:23:13'),(108869,340,'Madhota','494223',1,0,'2022-03-03 13:23:13','2022-03-03 13:23:13'),(108870,340,'Madlapal','494224',1,0,'2022-03-03 13:23:13','2022-03-03 13:23:13'),(108871,340,'Madpal','494001',1,0,'2022-03-03 13:23:13','2022-03-03 13:23:13'),(108872,340,'Makdi','494226',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108873,340,'Malakot','494226',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108874,340,'Malgaon','494226',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108875,340,'Malgaon','494221',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108876,340,'Manghiatgaon','494228',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108877,340,'Mangnar','494222',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108878,340,'Marangpuri','494347',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108879,340,'Mardapal','494226',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108880,340,'Mardum','494010',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108881,340,'Markel','494001',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108882,340,'Matnar','494222',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108883,340,'Matnar','494010',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108884,340,'Matwal','494226',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108885,340,'Michnar','494442',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108886,340,'Mohlai','494226',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108887,340,'Mohlai','494224',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108888,340,'Mongrapal','494223',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108889,340,'Muli','494222',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108890,340,'Mulmula','494226',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108891,340,'Mundagaon','494224',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108892,340,'Mutanpal','494442',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108893,340,'Nagarbeda','494230',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108894,340,'Nagarnaar','494001',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108895,340,'Nalpawand','494221',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108896,340,'Nangur','494001',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108897,340,'Narayanpal','494010',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108898,340,'Neganar','494442',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108899,340,'Netanaar','494001',1,0,'2022-03-03 13:23:14','2022-03-03 13:23:14'),(108900,340,'Niyanaar','494001',1,0,'2022-03-03 13:23:15','2022-03-03 13:23:15'),(108901,340,'Otenda','494226',1,0,'2022-03-03 13:23:15','2022-03-03 13:23:15'),(108902,340,'Pahurbel','494222',1,0,'2022-03-03 13:23:15','2022-03-03 13:23:15'),(108903,340,'Palari','494226',1,0,'2022-03-03 13:23:15','2022-03-03 13:23:15'),(108904,340,'Pandripani','494001',1,0,'2022-03-03 13:23:15','2022-03-03 13:23:15'),(108905,340,'Parapur','494010',1,0,'2022-03-03 13:23:15','2022-03-03 13:23:15'),(108906,340,'Pharasgaon Camp','494229',1,0,'2022-03-03 13:23:15','2022-03-03 13:23:15'),(108907,340,'Pharasgaon','494228',1,0,'2022-03-03 13:23:15','2022-03-03 13:23:15'),(108908,340,'Piprabahigaon','494230',1,0,'2022-03-03 13:23:15','2022-03-03 13:23:15'),(108909,340,'Piprakhas','494230',1,0,'2022-03-03 13:23:15','2022-03-03 13:23:15'),(108910,340,'Puspal','494001',1,0,'2022-03-03 13:23:15','2022-03-03 13:23:15'),(108911,340,'Raikot','494442',1,0,'2022-03-03 13:23:15','2022-03-03 13:23:15'),(108912,340,'Rajnagar','494222',1,0,'2022-03-03 13:23:15','2022-03-03 13:23:15'),(108913,340,'Randhna','494228',1,0,'2022-03-03 13:23:15','2022-03-03 13:23:15'),(108914,340,'Ratenga','494010',1,0,'2022-03-03 13:23:15','2022-03-03 13:23:15'),(108915,340,'Retawand','494223',1,0,'2022-03-03 13:23:15','2022-03-03 13:23:15'),(108916,340,'Rotma','494223',1,0,'2022-03-03 13:23:15','2022-03-03 13:23:15'),(108917,340,'Sadgud','494001',1,0,'2022-03-03 13:23:15','2022-03-03 13:23:15'),(108918,340,'Salemeta','494224',1,0,'2022-03-03 13:23:15','2022-03-03 13:23:15'),(108919,340,'Salna','494347',1,0,'2022-03-03 13:23:15','2022-03-03 13:23:15'),(108920,340,'Sandkarmari','494222',1,0,'2022-03-03 13:23:15','2022-03-03 13:23:15'),(108921,340,'Sargipal','494222',1,0,'2022-03-03 13:23:15','2022-03-03 13:23:15'),(108922,340,'Satosa','494224',1,0,'2022-03-03 13:23:15','2022-03-03 13:23:15'),(108923,340,'Sawala','494230',1,0,'2022-03-03 13:23:15','2022-03-03 13:23:15'),(108924,340,'Seoni','494224',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108925,340,'Shampur','494226',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108926,340,'Sikagaon','494230',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108927,340,'Singanpur','494001',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108928,340,'Singanpur','494331',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108929,340,'Sirisguda','494010',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108930,340,'Sonabal','494226',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108931,340,'Sonarpal','494224',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108932,340,'Sonpur','494222',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108933,340,'Sorgaon','494224',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108934,340,'Sudhapal','494010',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108935,340,'Talnar','494221',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108936,340,'Talur','494223',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108937,340,'Taragaon','494010',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108938,340,'Taraibeda','494230',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108939,340,'Tarapur','494221',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108940,340,'Telemarenga','494442',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108941,340,'Tenwsa','494347',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108942,340,'Titirgaon','494001',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108943,340,'Titirwand','494347',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108944,340,'Todasi','494230',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108945,340,'Tokapal Rajoor','494442',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108946,340,'Ulnar','494221',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108947,340,'Umargaon','494226',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108948,340,'Urandabeda','494228',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108949,340,'Usari','494224',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108950,340,'Useli','494230',1,0,'2022-03-03 13:23:16','2022-03-03 13:23:16'),(108951,340,'Vishrampuri','494347',1,0,'2022-03-03 13:23:17','2022-03-03 13:23:17'),(108952,341,'Atukpalli','494446',1,0,'2022-03-03 13:23:17','2022-03-03 13:23:17'),(108953,341,'Awapalli','494447',1,0,'2022-03-03 13:23:17','2022-03-03 13:23:17'),(108954,341,'Badekakler','494450',1,0,'2022-03-03 13:23:17','2022-03-03 13:23:17'),(108955,341,'Bareguda','494446',1,0,'2022-03-03 13:23:17','2022-03-03 13:23:17'),(108956,341,'Basaguda','494447',1,0,'2022-03-03 13:23:17','2022-03-03 13:23:17'),(108957,341,'Bhairamgarh','494450',1,0,'2022-03-03 13:23:17','2022-03-03 13:23:17'),(108958,341,'Bhopalpatnam','494446',1,0,'2022-03-03 13:23:17','2022-03-03 13:23:17'),(108959,341,'Bijapur','494444',1,0,'2022-03-03 13:23:17','2022-03-03 13:23:17'),(108960,341,'Chandangiri','494446',1,0,'2022-03-03 13:23:17','2022-03-03 13:23:17'),(108961,341,'Chandur','494446',1,0,'2022-03-03 13:23:17','2022-03-03 13:23:17'),(108962,341,'Cherpal','494444',1,0,'2022-03-03 13:23:17','2022-03-03 13:23:17'),(108963,341,'Cherpalli','494448',1,0,'2022-03-03 13:23:17','2022-03-03 13:23:17'),(108964,341,'Chinnakawali','494448',1,0,'2022-03-03 13:23:17','2022-03-03 13:23:17'),(108965,341,'Dhanora','494444',1,0,'2022-03-03 13:23:17','2022-03-03 13:23:17'),(108966,341,'Dharmaram','494447',1,0,'2022-03-03 13:23:17','2022-03-03 13:23:17'),(108967,341,'Dudheda (Kottaguda)','494448',1,0,'2022-03-03 13:23:17','2022-03-03 13:23:17'),(108968,341,'Elmidi','494447',1,0,'2022-03-03 13:23:17','2022-03-03 13:23:17'),(108969,341,'Etepal','494552',1,0,'2022-03-03 13:23:17','2022-03-03 13:23:17'),(108970,341,'Etpal','494444',1,0,'2022-03-03 13:23:17','2022-03-03 13:23:17'),(108971,341,'Gangaloor','494444',1,0,'2022-03-03 13:23:18','2022-03-03 13:23:18'),(108972,341,'Gudma','494450',1,0,'2022-03-03 13:23:18','2022-03-03 13:23:18'),(108973,341,'Kaika','494444',1,0,'2022-03-03 13:23:18','2022-03-03 13:23:18'),(108974,341,'Kandulnar','494448',1,0,'2022-03-03 13:23:18','2022-03-03 13:23:18'),(108975,341,'Karkeli','494450',1,0,'2022-03-03 13:23:18','2022-03-03 13:23:18'),(108976,341,'Kottaguda','494446',1,0,'2022-03-03 13:23:18','2022-03-03 13:23:18'),(108977,341,'Kutru','494450',1,0,'2022-03-03 13:23:18','2022-03-03 13:23:18'),(108978,341,'Lanka','494450',1,0,'2022-03-03 13:23:18','2022-03-03 13:23:18'),(108979,341,'Madded','494448',1,0,'2022-03-03 13:23:18','2022-03-03 13:23:18'),(108980,341,'Mallepalli','494447',1,0,'2022-03-03 13:23:18','2022-03-03 13:23:18'),(108981,341,'Marudbaka','494447',1,0,'2022-03-03 13:23:18','2022-03-03 13:23:18'),(108982,341,'Matwada','494450',1,0,'2022-03-03 13:23:18','2022-03-03 13:23:18'),(108983,341,'Munjalkanker','494447',1,0,'2022-03-03 13:23:18','2022-03-03 13:23:18'),(108984,341,'Murdanda','494447',1,0,'2022-03-03 13:23:18','2022-03-03 13:23:18'),(108985,341,'Nemed','494444',1,0,'2022-03-03 13:23:18','2022-03-03 13:23:18'),(108986,341,'Padeda','494444',1,0,'2022-03-03 13:23:18','2022-03-03 13:23:18'),(108987,341,'Pakela','494447',1,0,'2022-03-03 13:23:18','2022-03-03 13:23:18'),(108988,341,'Pamed','494447',1,0,'2022-03-03 13:23:18','2022-03-03 13:23:18'),(108989,341,'Pamgal','494448',1,0,'2022-03-03 13:23:18','2022-03-03 13:23:18'),(108990,341,'Pharsegarh','494450',1,0,'2022-03-03 13:23:18','2022-03-03 13:23:18'),(108991,341,'Pidiya','494444',1,0,'2022-03-03 13:23:18','2022-03-03 13:23:18'),(108992,341,'Pujarikanker','494447',1,0,'2022-03-03 13:23:18','2022-03-03 13:23:18'),(108993,341,'Pusbaka','494447',1,0,'2022-03-03 13:23:18','2022-03-03 13:23:18'),(108994,341,'Pusgudi','494448',1,0,'2022-03-03 13:23:18','2022-03-03 13:23:18'),(108995,341,'Pusnar','494444',1,0,'2022-03-03 13:23:19','2022-03-03 13:23:19'),(108996,341,'Ranibodli','494450',1,0,'2022-03-03 13:23:19','2022-03-03 13:23:19'),(108997,341,'Rudraram','494446',1,0,'2022-03-03 13:23:19','2022-03-03 13:23:19'),(108998,341,'Sagmeta','494450',1,0,'2022-03-03 13:23:19','2022-03-03 13:23:19'),(108999,341,'Sandra','494450',1,0,'2022-03-03 13:23:19','2022-03-03 13:23:19'),(109000,341,'Sankanpalli','494448',1,0,'2022-03-03 13:23:19','2022-03-03 13:23:19'),(109001,341,'Tarlaguda','494446',1,0,'2022-03-03 13:23:19','2022-03-03 13:23:19'),(109002,341,'Tekmetla','494447',1,0,'2022-03-03 13:23:19','2022-03-03 13:23:19'),(109003,341,'Timed','494446',1,0,'2022-03-03 13:23:19','2022-03-03 13:23:19'),(109004,341,'Toynar','494444',1,0,'2022-03-03 13:23:19','2022-03-03 13:23:19'),(109005,341,'Tumnar','494444',1,0,'2022-03-03 13:23:19','2022-03-03 13:23:19'),(109006,341,'Usoor','494447',1,0,'2022-03-03 13:23:19','2022-03-03 13:23:19'),(109007,342,'Achanakmar','495113',1,0,'2022-03-03 13:23:19','2022-03-03 13:23:19'),(109008,342,'Akaltara','495552',1,0,'2022-03-03 13:23:19','2022-03-03 13:23:19'),(109009,342,'Akhrar','495115',1,0,'2022-03-03 13:23:19','2022-03-03 13:23:19'),(109010,342,'Amadand','495119',1,0,'2022-03-03 13:23:19','2022-03-03 13:23:19'),(109011,342,'Amarpur','495119',1,0,'2022-03-03 13:23:19','2022-03-03 13:23:19'),(109012,342,'Amaru','495119',1,0,'2022-03-03 13:23:19','2022-03-03 13:23:19'),(109013,342,'Amoli','495113',1,0,'2022-03-03 13:23:19','2022-03-03 13:23:19'),(109014,342,'Amora','495330',1,0,'2022-03-03 13:23:19','2022-03-03 13:23:19'),(109015,342,'Anda','495224',1,0,'2022-03-03 13:23:19','2022-03-03 13:23:19'),(109016,342,'Andhiyarkhoh','495117',1,0,'2022-03-03 13:23:20','2022-03-03 13:23:20'),(109017,342,'Andi','495119',1,0,'2022-03-03 13:23:20','2022-03-03 13:23:20'),(109018,342,'Aramsahi','495550',1,0,'2022-03-03 13:23:20','2022-03-03 13:23:20'),(109019,342,'Bacharwar','495119',1,0,'2022-03-03 13:23:20','2022-03-03 13:23:20'),(109020,342,'Badrabukhari','495335',1,0,'2022-03-03 13:23:20','2022-03-03 13:23:20'),(109021,342,'Badrathakur','495224',1,0,'2022-03-03 13:23:20','2022-03-03 13:23:20'),(109022,342,'Bagadi','495119',1,0,'2022-03-03 13:23:20','2022-03-03 13:23:20'),(109023,342,'Bahtarai','495006',1,0,'2022-03-03 13:23:20','2022-03-03 13:23:20'),(109024,342,'Bahtarai','495003',1,0,'2022-03-03 13:23:20','2022-03-03 13:23:20'),(109025,342,'Baigakapa','495115',1,0,'2022-03-03 13:23:20','2022-03-03 13:23:20'),(109026,342,'Baimanagoi','495006',1,0,'2022-03-03 13:23:20','2022-03-03 13:23:20'),(109027,342,'Baitalpur','495224',1,0,'2022-03-03 13:23:20','2022-03-03 13:23:20'),(109028,342,'Bandha','495115',1,0,'2022-03-03 13:23:20','2022-03-03 13:23:20'),(109029,342,'Banki','495334',1,0,'2022-03-03 13:23:20','2022-03-03 13:23:20'),(109030,342,'Bansajhal','495113',1,0,'2022-03-03 13:23:20','2022-03-03 13:23:20'),(109031,342,'Baoli','495224',1,0,'2022-03-03 13:23:20','2022-03-03 13:23:20'),(109032,342,'Barampur','495115',1,0,'2022-03-03 13:23:20','2022-03-03 13:23:20'),(109033,342,'Barela','495330',1,0,'2022-03-03 13:23:20','2022-03-03 13:23:20'),(109034,342,'Bartori','495224',1,0,'2022-03-03 13:23:20','2022-03-03 13:23:20'),(109035,342,'Basti Bagra','495119',1,0,'2022-03-03 13:23:20','2022-03-03 13:23:20'),(109036,342,'Belgahana','495116',1,0,'2022-03-03 13:23:20','2022-03-03 13:23:20'),(109037,342,'Belsari','495330',1,0,'2022-03-03 13:23:20','2022-03-03 13:23:20'),(109038,342,'Bhaisajhar','495113',1,0,'2022-03-03 13:23:21','2022-03-03 13:23:21'),(109039,342,'Bhalapur','495334',1,0,'2022-03-03 13:23:21','2022-03-03 13:23:21'),(109040,342,'Bhalukhondhra','495334',1,0,'2022-03-03 13:23:21','2022-03-03 13:23:21'),(109041,342,'Bharari','495112',1,0,'2022-03-03 13:23:21','2022-03-03 13:23:21'),(109042,342,'Bharari','495551',1,0,'2022-03-03 13:23:21','2022-03-03 13:23:21'),(109043,342,'Bharni','495112',1,0,'2022-03-03 13:23:21','2022-03-03 13:23:21'),(109044,342,'Bhatchaura','495551',1,0,'2022-03-03 13:23:21','2022-03-03 13:23:21'),(109045,342,'Bhatgaon','495335',1,0,'2022-03-03 13:23:21','2022-03-03 13:23:21'),(109046,342,'Bija','495113',1,0,'2022-03-03 13:23:21','2022-03-03 13:23:21'),(109047,342,'Bijatarai','495334',1,0,'2022-03-03 13:23:21','2022-03-03 13:23:21'),(109048,342,'Bijaypur','495113',1,0,'2022-03-03 13:23:21','2022-03-03 13:23:21'),(109049,342,'Bilaspur (Bilaspur-CGH) H.O','495001',1,0,'2022-03-03 13:23:21','2022-03-03 13:23:21'),(109050,342,'Bilaspur Industrial Estate','495223',1,0,'2022-03-03 13:23:21','2022-03-03 13:23:21'),(109051,342,'Bilaspur Kutchery (Bilaspur-CGH)S.O','495001',1,0,'2022-03-03 13:23:21','2022-03-03 13:23:21'),(109052,342,'Bilaspur R.S.','495004',1,0,'2022-03-03 13:23:21','2022-03-03 13:23:21'),(109053,342,'Bilha','495224',1,0,'2022-03-03 13:23:21','2022-03-03 13:23:21'),(109054,342,'Billiband','495113',1,0,'2022-03-03 13:23:21','2022-03-03 13:23:21'),(109055,342,'Birgaon','495330',1,0,'2022-03-03 13:23:21','2022-03-03 13:23:21'),(109056,342,'Birkona','495009',1,0,'2022-03-03 13:23:21','2022-03-03 13:23:21'),(109057,342,'Bitkuli','495224',1,0,'2022-03-03 13:23:22','2022-03-03 13:23:22'),(109058,342,'Bodtara','495115',1,0,'2022-03-03 13:23:22','2022-03-03 13:23:22'),(109059,342,'Bortara','495224',1,0,'2022-03-03 13:23:22','2022-03-03 13:23:22'),(109060,342,'Chakarbhata Camp','495220',1,0,'2022-03-03 13:23:22','2022-03-03 13:23:22'),(109061,342,'Chakrabhatha','495334',1,0,'2022-03-03 13:23:22','2022-03-03 13:23:22'),(109062,342,'Chandeli','495115',1,0,'2022-03-03 13:23:22','2022-03-03 13:23:22'),(109063,342,'Chapora','495442',1,0,'2022-03-03 13:23:22','2022-03-03 13:23:22'),(109064,342,'Chhatan','495334',1,0,'2022-03-03 13:23:22','2022-03-03 13:23:22'),(109065,342,'Chhatauna','495116',1,0,'2022-03-03 13:23:22','2022-03-03 13:23:22'),(109066,342,'Chhindbhog','495334',1,0,'2022-03-03 13:23:22','2022-03-03 13:23:22'),(109067,342,'Chilfi','495115',1,0,'2022-03-03 13:23:22','2022-03-03 13:23:22'),(109068,342,'Chirhula','495334',1,0,'2022-03-03 13:23:22','2022-03-03 13:23:22'),(109069,342,'Choktipani','495117',1,0,'2022-03-03 13:23:22','2022-03-03 13:23:22'),(109070,342,'Cmd College Bilaspur','495004',1,0,'2022-03-03 13:23:22','2022-03-03 13:23:22'),(109071,342,'Dagori','495224',1,0,'2022-03-03 13:23:22','2022-03-03 13:23:22'),(109072,342,'Darri','495117',1,0,'2022-03-03 13:23:22','2022-03-03 13:23:22'),(109073,342,'Darrighat','495551',1,0,'2022-03-03 13:23:22','2022-03-03 13:23:22'),(109074,342,'Dashrangpur','495330',1,0,'2022-03-03 13:23:22','2022-03-03 13:23:22'),(109075,342,'Daukapa','495115',1,0,'2022-03-03 13:23:22','2022-03-03 13:23:22'),(109076,342,'Deogaon','495551',1,0,'2022-03-03 13:23:22','2022-03-03 13:23:22'),(109077,342,'Deorhat','495115',1,0,'2022-03-03 13:23:22','2022-03-03 13:23:22'),(109078,342,'Deori','495334',1,0,'2022-03-03 13:23:23','2022-03-03 13:23:23'),(109079,342,'Deorikhurd','495004',1,0,'2022-03-03 13:23:23','2022-03-03 13:23:23'),(109080,342,'Dhandhan','495330',1,0,'2022-03-03 13:23:23','2022-03-03 13:23:23'),(109081,342,'Dhangaongosai','495330',1,0,'2022-03-03 13:23:23','2022-03-03 13:23:23'),(109082,342,'Dharampura','495334',1,0,'2022-03-03 13:23:23','2022-03-03 13:23:23'),(109083,342,'Dhobhar','495119',1,0,'2022-03-03 13:23:23','2022-03-03 13:23:23'),(109084,342,'Dhuma','495004',1,0,'2022-03-03 13:23:23','2022-03-03 13:23:23'),(109085,342,'Dhuma','495113',1,0,'2022-03-03 13:23:23','2022-03-03 13:23:23'),(109086,342,'Dindori','495115',1,0,'2022-03-03 13:23:23','2022-03-03 13:23:23'),(109087,342,'Donda','495334',1,0,'2022-03-03 13:23:23','2022-03-03 13:23:23'),(109088,342,'Dongaria','495119',1,0,'2022-03-03 13:23:23','2022-03-03 13:23:23'),(109089,342,'Dongariya','495115',1,0,'2022-03-03 13:23:23','2022-03-03 13:23:23'),(109090,342,'Fasterpur','495334',1,0,'2022-03-03 13:23:23','2022-03-03 13:23:23'),(109091,342,'Fulwari','495115',1,0,'2022-03-03 13:23:23','2022-03-03 13:23:23'),(109092,342,'Ganiyari','495112',1,0,'2022-03-03 13:23:23','2022-03-03 13:23:23'),(109093,342,'Garwat','495442',1,0,'2022-03-03 13:23:23','2022-03-03 13:23:23'),(109094,342,'Gatora','495550',1,0,'2022-03-03 13:23:23','2022-03-03 13:23:23'),(109095,342,'Ghanaghat','495115',1,0,'2022-03-03 13:23:23','2022-03-03 13:23:23'),(109096,342,'Ghutku','495112',1,0,'2022-03-03 13:23:23','2022-03-03 13:23:23'),(109097,342,'Gidha','495334',1,0,'2022-03-03 13:23:24','2022-03-03 13:23:24'),(109098,342,'Girdhauna','495003',1,0,'2022-03-03 13:23:24','2022-03-03 13:23:24'),(109099,342,'Gobripat','495113',1,0,'2022-03-03 13:23:24','2022-03-03 13:23:24'),(109100,342,'Goindri','495335',1,0,'2022-03-03 13:23:24','2022-03-03 13:23:24'),(109101,342,'Gole Bazar Bilaspur','495001',1,0,'2022-03-03 13:23:24','2022-03-03 13:23:24'),(109102,342,'Gondadih','495551',1,0,'2022-03-03 13:23:24','2022-03-03 13:23:24'),(109103,342,'Gopal Nagar','495663',1,0,'2022-03-03 13:23:24','2022-03-03 13:23:24'),(109104,342,'Gorakhpur','495117',1,0,'2022-03-03 13:23:24','2022-03-03 13:23:24'),(109105,342,'Gudi','495550',1,0,'2022-03-03 13:23:24','2022-03-03 13:23:24'),(109106,342,'Hardi (J)','495668',1,0,'2022-03-03 13:23:24','2022-03-03 13:23:24'),(109107,342,'Harditonakala','495004',1,0,'2022-03-03 13:23:24','2022-03-03 13:23:24'),(109108,342,'High Court Bilaspur','495220',1,0,'2022-03-03 13:23:24','2022-03-03 13:23:24'),(109109,342,'Hirri','495222',1,0,'2022-03-03 13:23:24','2022-03-03 13:23:24'),(109110,342,'Hirri Mines','495222',1,0,'2022-03-03 13:23:24','2022-03-03 13:23:24'),(109111,342,'Jairam Nagar','495550',1,0,'2022-03-03 13:23:24','2022-03-03 13:23:24'),(109112,342,'Janji','495550',1,0,'2022-03-03 13:23:24','2022-03-03 13:23:24'),(109113,342,'Jareli','495335',1,0,'2022-03-03 13:23:24','2022-03-03 13:23:24'),(109114,342,'Jarhagaon','495330',1,0,'2022-03-03 13:23:24','2022-03-03 13:23:24'),(109115,342,'Jarondha','495330',1,0,'2022-03-03 13:23:24','2022-03-03 13:23:24'),(109116,342,'Jhajhpurikala','495115',1,0,'2022-03-03 13:23:24','2022-03-03 13:23:24'),(109117,342,'Jhapal','495115',1,0,'2022-03-03 13:23:24','2022-03-03 13:23:24'),(109118,342,'Jhingatpur','495113',1,0,'2022-03-03 13:23:24','2022-03-03 13:23:24'),(109119,342,'Jogisar','495117',1,0,'2022-03-03 13:23:25','2022-03-03 13:23:25'),(109120,342,'Jondhra','495551',1,0,'2022-03-03 13:23:25','2022-03-03 13:23:25'),(109121,342,'Juna Bilaspur','495001',1,0,'2022-03-03 13:23:25','2022-03-03 13:23:25'),(109122,342,'Junapara','495115',1,0,'2022-03-03 13:23:25','2022-03-03 13:23:25'),(109123,342,'Kanteli','495334',1,0,'2022-03-03 13:23:25','2022-03-03 13:23:25'),(109124,342,'Karesara','495334',1,0,'2022-03-03 13:23:25','2022-03-03 13:23:25'),(109125,342,'Kargi Road','495113',1,0,'2022-03-03 13:23:25','2022-03-03 13:23:25'),(109126,342,'Kargikala','495113',1,0,'2022-03-03 13:23:25','2022-03-03 13:23:25'),(109127,342,'Karhi','495334',1,0,'2022-03-03 13:23:25','2022-03-03 13:23:25'),(109128,342,'Karri','495119',1,0,'2022-03-03 13:23:25','2022-03-03 13:23:25'),(109129,342,'Kathakoni','495003',1,0,'2022-03-03 13:23:25','2022-03-03 13:23:25'),(109130,342,'Kaudia','495550',1,0,'2022-03-03 13:23:25','2022-03-03 13:23:25'),(109131,342,'Kenda','495116',1,0,'2022-03-03 13:23:25','2022-03-03 13:23:25'),(109132,342,'Keonchi','495117',1,0,'2022-03-03 13:23:25','2022-03-03 13:23:25'),(109133,342,'Khaira','495442',1,0,'2022-03-03 13:23:25','2022-03-03 13:23:25'),(109134,342,'Khairjhiti','495116',1,0,'2022-03-03 13:23:25','2022-03-03 13:23:25'),(109135,342,'Khairwar','495334',1,0,'2022-03-03 13:23:25','2022-03-03 13:23:25'),(109136,342,'Khamhi','495115',1,0,'2022-03-03 13:23:25','2022-03-03 13:23:25'),(109137,342,'Khaprikala','495115',1,0,'2022-03-03 13:23:25','2022-03-03 13:23:25'),(109138,342,'Khodri','495117',1,0,'2022-03-03 13:23:25','2022-03-03 13:23:25'),(109139,342,'Khongsara','495116',1,0,'2022-03-03 13:23:26','2022-03-03 13:23:26'),(109140,342,'Khudia','495115',1,0,'2022-03-03 13:23:26','2022-03-03 13:23:26'),(109141,342,'Kilaward Bilaspur','495001',1,0,'2022-03-03 13:23:26','2022-03-03 13:23:26'),(109142,342,'Kodwa','495334',1,0,'2022-03-03 13:23:26','2022-03-03 13:23:26'),(109143,342,'Koni','495551',1,0,'2022-03-03 13:23:26','2022-03-03 13:23:26'),(109144,342,'Koni','495009',1,0,'2022-03-03 13:23:26','2022-03-03 13:23:26'),(109145,342,'Korja','495117',1,0,'2022-03-03 13:23:26','2022-03-03 13:23:26'),(109146,342,'Kosamtara','495334',1,0,'2022-03-03 13:23:26','2022-03-03 13:23:26'),(109147,342,'Kotgar','495119',1,0,'2022-03-03 13:23:26','2022-03-03 13:23:26'),(109148,342,'Kotmi','495119',1,0,'2022-03-03 13:23:26','2022-03-03 13:23:26'),(109149,342,'Kotri','495115',1,0,'2022-03-03 13:23:26','2022-03-03 13:23:26'),(109150,342,'Krgikhurd','495113',1,0,'2022-03-03 13:23:26','2022-03-03 13:23:26'),(109151,342,'Kudkai','495119',1,0,'2022-03-03 13:23:26','2022-03-03 13:23:26'),(109152,342,'Kudri','495119',1,0,'2022-03-03 13:23:26','2022-03-03 13:23:26'),(109153,342,'Kukusda','495335',1,0,'2022-03-03 13:23:26','2022-03-03 13:23:26'),(109154,342,'Lagra','495115',1,0,'2022-03-03 13:23:26','2022-03-03 13:23:26'),(109155,342,'Lainga','495119',1,0,'2022-03-03 13:23:26','2022-03-03 13:23:26'),(109156,342,'Lakhram','495442',1,0,'2022-03-03 13:23:26','2022-03-03 13:23:26'),(109157,342,'Lalpur','495334',1,0,'2022-03-03 13:23:26','2022-03-03 13:23:26'),(109158,342,'Lalpur','495117',1,0,'2022-03-03 13:23:26','2022-03-03 13:23:26'),(109159,342,'Lamer','495112',1,0,'2022-03-03 13:23:27','2022-03-03 13:23:27'),(109160,342,'Lauda','495335',1,0,'2022-03-03 13:23:27','2022-03-03 13:23:27'),(109161,342,'Lofandi','495009',1,0,'2022-03-03 13:23:27','2022-03-03 13:23:27'),(109162,342,'Loharsison','495551',1,0,'2022-03-03 13:23:27','2022-03-03 13:23:27'),(109163,342,'Lormi','495115',1,0,'2022-03-03 13:23:27','2022-03-03 13:23:27'),(109164,342,'Majhgaon','495116',1,0,'2022-03-03 13:23:27','2022-03-03 13:23:27'),(109165,342,'Majhwani','495116',1,0,'2022-03-03 13:23:27','2022-03-03 13:23:27'),(109166,342,'Malhar','495551',1,0,'2022-03-03 13:23:27','2022-03-03 13:23:27'),(109167,342,'Mangla','495001',1,0,'2022-03-03 13:23:27','2022-03-03 13:23:27'),(109168,342,'Manikchauri','495551',1,0,'2022-03-03 13:23:27','2022-03-03 13:23:27'),(109169,342,'Manoharpur','495334',1,0,'2022-03-03 13:23:27','2022-03-03 13:23:27'),(109170,342,'Marwahi','495118',1,0,'2022-03-03 13:23:27','2022-03-03 13:23:27'),(109171,342,'Masturi','495551',1,0,'2022-03-03 13:23:27','2022-03-03 13:23:27'),(109172,342,'Matsagra','495330',1,0,'2022-03-03 13:23:27','2022-03-03 13:23:27'),(109173,342,'Mithunawagaon','495116',1,0,'2022-03-03 13:23:27','2022-03-03 13:23:27'),(109174,342,'Mochh','495003',1,0,'2022-03-03 13:23:27','2022-03-03 13:23:27'),(109175,342,'Mohda','495442',1,0,'2022-03-03 13:23:27','2022-03-03 13:23:27'),(109176,342,'Mopka','495006',1,0,'2022-03-03 13:23:27','2022-03-03 13:23:27'),(109177,342,'Mudpar','495550',1,0,'2022-03-03 13:23:27','2022-03-03 13:23:27'),(109178,342,'Mungeli','495334',1,0,'2022-03-03 13:23:27','2022-03-03 13:23:27'),(109179,342,'Muru','495220',1,0,'2022-03-03 13:23:27','2022-03-03 13:23:27'),(109180,342,'Naila R.S.','495668',1,0,'2022-03-03 13:23:27','2022-03-03 13:23:27'),(109181,342,'Nargoda','495550',1,0,'2022-03-03 13:23:28','2022-03-03 13:23:28'),(109182,342,'Nawadih','495115',1,0,'2022-03-03 13:23:28','2022-03-03 13:23:28'),(109183,342,'Nawagaon','495119',1,0,'2022-03-03 13:23:28','2022-03-03 13:23:28'),(109184,342,'Nawagaon','495334',1,0,'2022-03-03 13:23:28','2022-03-03 13:23:28'),(109185,342,'Nawaspur','495334',1,0,'2022-03-03 13:23:28','2022-03-03 13:23:28'),(109186,342,'Neora','495112',1,0,'2022-03-03 13:23:28','2022-03-03 13:23:28'),(109187,342,'Neosa','495117',1,0,'2022-03-03 13:23:28','2022-03-03 13:23:28'),(109188,342,'Nimdha','495119',1,0,'2022-03-03 13:23:28','2022-03-03 13:23:28'),(109189,342,'Nirjam','495334',1,0,'2022-03-03 13:23:28','2022-03-03 13:23:28'),(109190,342,'Okhar','495551',1,0,'2022-03-03 13:23:28','2022-03-03 13:23:28'),(109191,342,'Pachpedi','495551',1,0,'2022-03-03 13:23:28','2022-03-03 13:23:28'),(109192,342,'Padampur','495330',1,0,'2022-03-03 13:23:28','2022-03-03 13:23:28'),(109193,342,'Pakaria','495117',1,0,'2022-03-03 13:23:28','2022-03-03 13:23:28'),(109194,342,'Pali','495113',1,0,'2022-03-03 13:23:28','2022-03-03 13:23:28'),(109195,342,'Pandarbhattha','495334',1,0,'2022-03-03 13:23:28','2022-03-03 13:23:28'),(109196,342,'Pandhi','495555',1,0,'2022-03-03 13:23:28','2022-03-03 13:23:28'),(109197,342,'Pandiyain','495335',1,0,'2022-03-03 13:23:28','2022-03-03 13:23:28'),(109198,342,'Parsada','495223',1,0,'2022-03-03 13:23:28','2022-03-03 13:23:28'),(109199,342,'Parsada','495113',1,0,'2022-03-03 13:23:28','2022-03-03 13:23:28'),(109200,342,'Pasan','495119',1,0,'2022-03-03 13:23:29','2022-03-03 13:23:29'),(109201,342,'Pasid','495224',1,0,'2022-03-03 13:23:29','2022-03-03 13:23:29'),(109202,342,'Patgawan','495119',1,0,'2022-03-03 13:23:29','2022-03-03 13:23:29'),(109203,342,'Patharia','495335',1,0,'2022-03-03 13:23:29','2022-03-03 13:23:29'),(109204,342,'Paunsara','495009',1,0,'2022-03-03 13:23:29','2022-03-03 13:23:29'),(109205,342,'Pendra Road R.S.','495117',1,0,'2022-03-03 13:23:29','2022-03-03 13:23:29'),(109206,342,'Pendra Road','495117',1,0,'2022-03-03 13:23:29','2022-03-03 13:23:29'),(109207,342,'Pendra Road Sanotorium','495117',1,0,'2022-03-03 13:23:29','2022-03-03 13:23:29'),(109208,342,'Pendra','495119',1,0,'2022-03-03 13:23:29','2022-03-03 13:23:29'),(109209,342,'Phandwani','495334',1,0,'2022-03-03 13:23:29','2022-03-03 13:23:29'),(109210,342,'Pharhada','495330',1,0,'2022-03-03 13:23:29','2022-03-03 13:23:29'),(109211,342,'Piparia','495119',1,0,'2022-03-03 13:23:29','2022-03-03 13:23:29'),(109212,342,'Piparkhunti','495117',1,0,'2022-03-03 13:23:29','2022-03-03 13:23:29'),(109213,342,'Pipartarai','495112',1,0,'2022-03-03 13:23:29','2022-03-03 13:23:29'),(109214,342,'Piraiya','495224',1,0,'2022-03-03 13:23:29','2022-03-03 13:23:29'),(109215,342,'Pondi','495550',1,0,'2022-03-03 13:23:29','2022-03-03 13:23:29'),(109216,342,'Pondi','495442',1,0,'2022-03-03 13:23:29','2022-03-03 13:23:29'),(109217,342,'Pondikala','495119',1,0,'2022-03-03 13:23:29','2022-03-03 13:23:29'),(109218,342,'Puchheli','495335',1,0,'2022-03-03 13:23:30','2022-03-03 13:23:30'),(109219,342,'Pudu','495116',1,0,'2022-03-03 13:23:30','2022-03-03 13:23:30'),(109220,342,'Pura','495330',1,0,'2022-03-03 13:23:30','2022-03-03 13:23:30'),(109221,342,'Puran','495334',1,0,'2022-03-03 13:23:30','2022-03-03 13:23:30'),(109222,342,'Putipakhna','495119',1,0,'2022-03-03 13:23:30','2022-03-03 13:23:30'),(109223,342,'Raj Kishore Nagar','495006',1,0,'2022-03-03 13:23:30','2022-03-03 13:23:30'),(109224,342,'Rajpur (S)','495334',1,0,'2022-03-03 13:23:30','2022-03-03 13:23:30'),(109225,342,'Rajpur','495330',1,0,'2022-03-03 13:23:30','2022-03-03 13:23:30'),(109226,342,'Ramdas Nagar','495004',1,0,'2022-03-03 13:23:30','2022-03-03 13:23:30'),(109227,342,'Ramhepur','495115',1,0,'2022-03-03 13:23:30','2022-03-03 13:23:30'),(109228,342,'Ranigaon','495442',1,0,'2022-03-03 13:23:30','2022-03-03 13:23:30'),(109229,342,'Ratanpur (Bilaspur)','495442',1,0,'2022-03-03 13:23:30','2022-03-03 13:23:30'),(109230,342,'Ratga','495118',1,0,'2022-03-03 13:23:30','2022-03-03 13:23:30'),(109231,342,'Risda','495551',1,0,'2022-03-03 13:23:30','2022-03-03 13:23:30'),(109232,342,'Sadhwani','495117',1,0,'2022-03-03 13:23:30','2022-03-03 13:23:30'),(109233,342,'Sagar','495220',1,0,'2022-03-03 13:23:30','2022-03-03 13:23:30'),(109234,342,'Saida','495003',1,0,'2022-03-03 13:23:30','2022-03-03 13:23:30'),(109235,342,'Sakarra','495220',1,0,'2022-03-03 13:23:30','2022-03-03 13:23:30'),(109236,342,'Sakri','495003',1,0,'2022-03-03 13:23:30','2022-03-03 13:23:30'),(109237,342,'Salheghori','495115',1,0,'2022-03-03 13:23:31','2022-03-03 13:23:31'),(109238,342,'Salkhanowgaon','495113',1,0,'2022-03-03 13:23:31','2022-03-03 13:23:31'),(109239,342,'Sardha','495115',1,0,'2022-03-03 13:23:31','2022-03-03 13:23:31'),(109240,342,'Sargaon','495224',1,0,'2022-03-03 13:23:31','2022-03-03 13:23:31'),(109241,342,'Sarkanda Bilaspur','495006',1,0,'2022-03-03 13:23:31','2022-03-03 13:23:31'),(109242,342,'Sarwandeori','495442',1,0,'2022-03-03 13:23:31','2022-03-03 13:23:31'),(109243,342,'Sarwani','495224',1,0,'2022-03-03 13:23:31','2022-03-03 13:23:31'),(109244,342,'Seepat','495555',1,0,'2022-03-03 13:23:31','2022-03-03 13:23:31'),(109245,342,'Selar','495442',1,0,'2022-03-03 13:23:31','2022-03-03 13:23:31'),(109246,342,'Semariya','495116',1,0,'2022-03-03 13:23:31','2022-03-03 13:23:31'),(109247,342,'Semarsal','495330',1,0,'2022-03-03 13:23:31','2022-03-03 13:23:31'),(109248,342,'Semartal','495009',1,0,'2022-03-03 13:23:31','2022-03-03 13:23:31'),(109249,342,'Semra','495119',1,0,'2022-03-03 13:23:31','2022-03-03 13:23:31'),(109250,342,'Sendri','495009',1,0,'2022-03-03 13:23:31','2022-03-03 13:23:31'),(109251,342,'Sewar','495224',1,0,'2022-03-03 13:23:31','2022-03-03 13:23:31'),(109252,342,'Shivtarai','495113',1,0,'2022-03-03 13:23:31','2022-03-03 13:23:31'),(109253,342,'Sildaha','495335',1,0,'2022-03-03 13:23:31','2022-03-03 13:23:31'),(109254,342,'Silli','495442',1,0,'2022-03-03 13:23:31','2022-03-03 13:23:31'),(109255,342,'Silpahri','495119',1,0,'2022-03-03 13:23:31','2022-03-03 13:23:31'),(109256,342,'Siltara','495335',1,0,'2022-03-03 13:23:31','2022-03-03 13:23:31'),(109257,342,'Siltara','495330',1,0,'2022-03-03 13:23:31','2022-03-03 13:23:31'),(109258,342,'Singhri','495442',1,0,'2022-03-03 13:23:32','2022-03-03 13:23:32'),(109259,342,'Sirgitti','495004',1,0,'2022-03-03 13:23:32','2022-03-03 13:23:32'),(109260,342,'Son','495551',1,0,'2022-03-03 13:23:32','2022-03-03 13:23:32'),(109261,342,'Sonthi (M)','495335',1,0,'2022-03-03 13:23:32','2022-03-03 13:23:32'),(109262,342,'South Eastern Coal Limited Bilaspur','495006',1,0,'2022-03-03 13:23:32','2022-03-03 13:23:32'),(109263,342,'Spinning Mills Bilaspur','495006',1,0,'2022-03-03 13:23:32','2022-03-03 13:23:32'),(109264,342,'Sukli','495115',1,0,'2022-03-03 13:23:32','2022-03-03 13:23:32'),(109265,342,'Sukulkari','495551',1,0,'2022-03-03 13:23:32','2022-03-03 13:23:32'),(109266,342,'Surhi','495115',1,0,'2022-03-03 13:23:32','2022-03-03 13:23:32'),(109267,342,'Takhatpur','495330',1,0,'2022-03-03 13:23:32','2022-03-03 13:23:32'),(109268,342,'Tanda','495112',1,0,'2022-03-03 13:23:32','2022-03-03 13:23:32'),(109269,342,'Tenganmada','495116',1,0,'2022-03-03 13:23:32','2022-03-03 13:23:32'),(109270,342,'Terhadhaura','495334',1,0,'2022-03-03 13:23:32','2022-03-03 13:23:32'),(109271,342,'Tikari','495551',1,0,'2022-03-03 13:23:32','2022-03-03 13:23:32'),(109272,342,'Ujwal Nagar (Bilaspur)','495555',1,0,'2022-03-03 13:23:32','2022-03-03 13:23:32'),(109273,342,'Umariyadadar','495116',1,0,'2022-03-03 13:23:32','2022-03-03 13:23:32'),(109274,342,'Urtum','495006',1,0,'2022-03-03 13:23:32','2022-03-03 13:23:32'),(109275,343,'Abiana','140119',1,0,'2022-03-03 13:23:32','2022-03-03 13:23:32'),(109276,343,'Aerodrome','160003',1,0,'2022-03-03 13:23:32','2022-03-03 13:23:32'),(109277,343,'Airforce Highground','160004',1,0,'2022-03-03 13:23:33','2022-03-03 13:23:33'),(109278,343,'Ajauli','140125',1,0,'2022-03-03 13:23:33','2022-03-03 13:23:33'),(109279,343,'Badheri','160036',1,0,'2022-03-03 13:23:33','2022-03-03 13:23:33'),(109280,343,'Behlana','160003',1,0,'2022-03-03 13:23:33','2022-03-03 13:23:33'),(109281,343,'Burail','160047',1,0,'2022-03-03 13:23:33','2022-03-03 13:23:33'),(109282,343,'Chandigarh G.P.O.','160017',1,0,'2022-03-03 13:23:33','2022-03-03 13:23:33'),(109283,343,'Dadu Majra Colony','160014',1,0,'2022-03-03 13:23:33','2022-03-03 13:23:33'),(109284,343,'Daria','160101',1,0,'2022-03-03 13:23:33','2022-03-03 13:23:33'),(109285,343,'Dhanas','160014',1,0,'2022-03-03 13:23:33','2022-03-03 13:23:33'),(109286,343,'Engg College','160012',1,0,'2022-03-03 13:23:33','2022-03-03 13:23:33'),(109287,343,'Govt Press Chandigarh','160018',1,0,'2022-03-03 13:23:33','2022-03-03 13:23:33'),(109288,343,'Hallomajra','160002',1,0,'2022-03-03 13:23:33','2022-03-03 13:23:33'),(109289,343,'High Court (Chandigarh)','160001',1,0,'2022-03-03 13:23:33','2022-03-03 13:23:33'),(109290,343,'Ind Area Chandigarh','160002',1,0,'2022-03-03 13:23:33','2022-03-03 13:23:33'),(109291,343,'Kalitran','140133',1,0,'2022-03-03 13:23:33','2022-03-03 13:23:33'),(109292,343,'Kishangarh','160101',1,0,'2022-03-03 13:23:33','2022-03-03 13:23:33'),(109293,343,'Maloya Colony','160025',1,0,'2022-03-03 13:23:33','2022-03-03 13:23:33'),(109294,343,'Manimajra','160101',1,0,'2022-03-03 13:23:33','2022-03-03 13:23:33'),(109295,343,'Mauli Jagran','160102',1,0,'2022-03-03 13:23:33','2022-03-03 13:23:33'),(109296,343,'Mhc Manimajra','160101',1,0,'2022-03-03 13:23:33','2022-03-03 13:23:33'),(109297,343,'New Sectt Chandigarh','160001',1,0,'2022-03-03 13:23:33','2022-03-03 13:23:33'),(109298,343,'Raipur Kalan','160102',1,0,'2022-03-03 13:23:33','2022-03-03 13:23:33'),(109299,343,'Raj Bhawan (Chandigarh)','160019',1,0,'2022-03-03 13:23:34','2022-03-03 13:23:34'),(109300,343,'Ram Darbar','160002',1,0,'2022-03-03 13:23:34','2022-03-03 13:23:34'),(109301,343,'Sector 10 (Chandigarh)','160011',1,0,'2022-03-03 13:23:34','2022-03-03 13:23:34'),(109302,343,'Sector 11( Chandigarh)','160011',1,0,'2022-03-03 13:23:34','2022-03-03 13:23:34'),(109303,343,'Sector 12 (Chandigarh)','160012',1,0,'2022-03-03 13:23:34','2022-03-03 13:23:34'),(109304,343,'Sector 14 (Chandigarh)','160014',1,0,'2022-03-03 13:23:34','2022-03-03 13:23:34'),(109305,343,'Sector 15 Chandigarh','160015',1,0,'2022-03-03 13:23:34','2022-03-03 13:23:34'),(109306,343,'Sector 16 (Chandigarh)','160015',1,0,'2022-03-03 13:23:34','2022-03-03 13:23:34'),(109307,343,'Sector 18 (Chandigarh)','160018',1,0,'2022-03-03 13:23:34','2022-03-03 13:23:34'),(109308,343,'Sector 19 (Chandigarh)','160019',1,0,'2022-03-03 13:23:34','2022-03-03 13:23:34'),(109309,343,'Sector 20 (Chandigarh)','160020',1,0,'2022-03-03 13:23:34','2022-03-03 13:23:34'),(109310,343,'Sector 21 (Chandigarh)','160022',1,0,'2022-03-03 13:23:34','2022-03-03 13:23:34'),(109311,343,'Sector 22 (Chandigarh)','160022',1,0,'2022-03-03 13:23:34','2022-03-03 13:23:34'),(109312,343,'Sector 23 ( Chandigarh)','160023',1,0,'2022-03-03 13:23:34','2022-03-03 13:23:34'),(109313,343,'Sector 26 (Chandigarh)','160019',1,0,'2022-03-03 13:23:34','2022-03-03 13:23:34'),(109314,343,'Sector 27(Chandigarh)S.O','160019',1,0,'2022-03-03 13:23:34','2022-03-03 13:23:34'),(109315,343,'Sector 29 (Chandigarh)','160030',1,0,'2022-03-03 13:23:34','2022-03-03 13:23:34'),(109316,343,'Sector 30 (Chandigarh)','160030',1,0,'2022-03-03 13:23:34','2022-03-03 13:23:34'),(109317,343,'Sector 31 (Chandigarh)','160030',1,0,'2022-03-03 13:23:34','2022-03-03 13:23:34'),(109318,343,'Sector 34(Chandigarh)','160022',1,0,'2022-03-03 13:23:34','2022-03-03 13:23:34'),(109319,343,'Sector 35 (Chandigarh)','160022',1,0,'2022-03-03 13:23:35','2022-03-03 13:23:35'),(109320,343,'Sector 36 (Chandigarh)','160036',1,0,'2022-03-03 13:23:35','2022-03-03 13:23:35'),(109321,343,'Sector 40 (Chandigarh)','160036',1,0,'2022-03-03 13:23:35','2022-03-03 13:23:35'),(109322,343,'Sector 44 (Chandigarh)','160047',1,0,'2022-03-03 13:23:35','2022-03-03 13:23:35'),(109323,343,'Sector 47 Chandigarh','160047',1,0,'2022-03-03 13:23:35','2022-03-03 13:23:35'),(109324,343,'Sector 8(Chandgarh)','160009',1,0,'2022-03-03 13:23:35','2022-03-03 13:23:35'),(109325,343,'Sector 9 (Chandigarh)','160009',1,0,'2022-03-03 13:23:35','2022-03-03 13:23:35'),(109326,343,'Vidhansadan','160001',1,0,'2022-03-03 13:23:35','2022-03-03 13:23:35'),(109327,344,'Aranpur','494556',1,0,'2022-03-03 13:23:35','2022-03-03 13:23:35'),(109328,344,'Argatta','494122',1,0,'2022-03-03 13:23:35','2022-03-03 13:23:35'),(109329,344,'Bache R.S.','494553',1,0,'2022-03-03 13:23:35','2022-03-03 13:23:35'),(109330,344,'Bacheli','494553',1,0,'2022-03-03 13:23:35','2022-03-03 13:23:35'),(109331,344,'Badebedma','494552',1,0,'2022-03-03 13:23:35','2022-03-03 13:23:35'),(109332,344,'Badegadam','494115',1,0,'2022-03-03 13:23:35','2022-03-03 13:23:35'),(109333,344,'Badegudra','494552',1,0,'2022-03-03 13:23:35','2022-03-03 13:23:35'),(109334,344,'Badelakhapal','494552',1,0,'2022-03-03 13:23:35','2022-03-03 13:23:35'),(109335,344,'Badesatti','494111',1,0,'2022-03-03 13:23:35','2022-03-03 13:23:35'),(109336,344,'Bagmundi Panera','494441',1,0,'2022-03-03 13:23:35','2022-03-03 13:23:35'),(109337,344,'Balood','494449',1,0,'2022-03-03 13:23:36','2022-03-03 13:23:36'),(109338,344,'Balpet','494449',1,0,'2022-03-03 13:23:36','2022-03-03 13:23:36'),(109339,344,'Banda','494114',1,0,'2022-03-03 13:23:36','2022-03-03 13:23:36'),(109340,344,'Bangali Camp','494556',1,0,'2022-03-03 13:23:36','2022-03-03 13:23:36'),(109341,344,'Barsoor','494441',1,0,'2022-03-03 13:23:36','2022-03-03 13:23:36'),(109342,344,'Belnar','494450',1,0,'2022-03-03 13:23:36','2022-03-03 13:23:36'),(109343,344,'Bhansi','494551',1,0,'2022-03-03 13:23:36','2022-03-03 13:23:36'),(109344,344,'Bheji','494114',1,0,'2022-03-03 13:23:36','2022-03-03 13:23:36'),(109345,344,'Bhusaras','494552',1,0,'2022-03-03 13:23:36','2022-03-03 13:23:36'),(109346,344,'Burgum','494556',1,0,'2022-03-03 13:23:36','2022-03-03 13:23:36'),(109347,344,'Chandragiri','494115',1,0,'2022-03-03 13:23:36','2022-03-03 13:23:36'),(109348,344,'Chhindgarh','494111',1,0,'2022-03-03 13:23:36','2022-03-03 13:23:36'),(109349,344,'Chhindnar','494441',1,0,'2022-03-03 13:23:36','2022-03-03 13:23:36'),(109350,344,'Chhotetumnar','494441',1,0,'2022-03-03 13:23:36','2022-03-03 13:23:36'),(109351,344,'Chindawada','494115',1,0,'2022-03-03 13:23:36','2022-03-03 13:23:36'),(109352,344,'Chintagupha','494122',1,0,'2022-03-03 13:23:36','2022-03-03 13:23:36'),(109353,344,'Chintalnar','494122',1,0,'2022-03-03 13:23:36','2022-03-03 13:23:36'),(109354,344,'Dabpal','494449',1,0,'2022-03-03 13:23:36','2022-03-03 13:23:36'),(109355,344,'Dantewada','494449',1,0,'2022-03-03 13:23:37','2022-03-03 13:23:37'),(109356,344,'Darbha','494115',1,0,'2022-03-03 13:23:37','2022-03-03 13:23:37'),(109357,344,'Dornapal','494122',1,0,'2022-03-03 13:23:37','2022-03-03 13:23:37'),(109358,344,'Dubbatota','494122',1,0,'2022-03-03 13:23:37','2022-03-03 13:23:37'),(109359,344,'Dugeli','494553',1,0,'2022-03-03 13:23:37','2022-03-03 13:23:37'),(109360,344,'Errabore','494114',1,0,'2022-03-03 13:23:37','2022-03-03 13:23:37'),(109361,344,'Gadapal','494552',1,0,'2022-03-03 13:23:37','2022-03-03 13:23:37'),(109362,344,'Gadmiri','494552',1,0,'2022-03-03 13:23:37','2022-03-03 13:23:37'),(109363,344,'Gaganpalli','494114',1,0,'2022-03-03 13:23:37','2022-03-03 13:23:37'),(109364,344,'Gamawada','494551',1,0,'2022-03-03 13:23:37','2022-03-03 13:23:37'),(109365,344,'Geedam','494441',1,0,'2022-03-03 13:23:37','2022-03-03 13:23:37'),(109366,344,'Ghotpal','494441',1,0,'2022-03-03 13:23:37','2022-03-03 13:23:37'),(109367,344,'Gogunda','494122',1,0,'2022-03-03 13:23:37','2022-03-03 13:23:37'),(109368,344,'Gollapalli','494114',1,0,'2022-03-03 13:23:37','2022-03-03 13:23:37'),(109369,344,'Gondpalli','494122',1,0,'2022-03-03 13:23:37','2022-03-03 13:23:37'),(109370,344,'Gondras','494556',1,0,'2022-03-03 13:23:37','2022-03-03 13:23:37'),(109371,344,'Gorli','494115',1,0,'2022-03-03 13:23:37','2022-03-03 13:23:37'),(109372,344,'Gumda','494441',1,0,'2022-03-03 13:23:37','2022-03-03 13:23:37'),(109373,344,'Gumyapal','494556',1,0,'2022-03-03 13:23:37','2022-03-03 13:23:37'),(109374,344,'Guphadi','494556',1,0,'2022-03-03 13:23:37','2022-03-03 13:23:37'),(109375,344,'Hameergarh','494115',1,0,'2022-03-03 13:23:38','2022-03-03 13:23:38'),(109376,344,'Harrakoder','494441',1,0,'2022-03-03 13:23:38','2022-03-03 13:23:38'),(109377,344,'Heeranar','494441',1,0,'2022-03-03 13:23:38','2022-03-03 13:23:38'),(109378,344,'Idjepal','494115',1,0,'2022-03-03 13:23:38','2022-03-03 13:23:38'),(109379,344,'Injeram','494114',1,0,'2022-03-03 13:23:38','2022-03-03 13:23:38'),(109380,344,'Jabeli','494552',1,0,'2022-03-03 13:23:38','2022-03-03 13:23:38'),(109381,344,'Jagargunda','494122',1,0,'2022-03-03 13:23:38','2022-03-03 13:23:38'),(109382,344,'Jeerampal','494111',1,0,'2022-03-03 13:23:38','2022-03-03 13:23:38'),(109383,344,'Jhapra','494111',1,0,'2022-03-03 13:23:38','2022-03-03 13:23:38'),(109384,344,'Kakadi','494556',1,0,'2022-03-03 13:23:38','2022-03-03 13:23:38'),(109385,344,'Kamaloor','494449',1,0,'2022-03-03 13:23:38','2022-03-03 13:23:38'),(109386,344,'Kanjipani','494111',1,0,'2022-03-03 13:23:38','2022-03-03 13:23:38'),(109387,344,'Kanwalnar','494449',1,0,'2022-03-03 13:23:38','2022-03-03 13:23:38'),(109388,344,'Karli','494441',1,0,'2022-03-03 13:23:38','2022-03-03 13:23:38'),(109389,344,'Katekalyan','494449',1,0,'2022-03-03 13:23:38','2022-03-03 13:23:38'),(109390,344,'Kawadgaon','494449',1,0,'2022-03-03 13:23:38','2022-03-03 13:23:38'),(109391,344,'Kerlapal','494122',1,0,'2022-03-03 13:23:38','2022-03-03 13:23:38'),(109392,344,'Kikirpal','494115',1,0,'2022-03-03 13:23:38','2022-03-03 13:23:38'),(109393,344,'Kirandul Hill Top','494556',1,0,'2022-03-03 13:23:38','2022-03-03 13:23:38'),(109394,344,'Kirandul R.S.','494556',1,0,'2022-03-03 13:23:38','2022-03-03 13:23:38'),(109395,344,'Kirandul','494556',1,0,'2022-03-03 13:23:38','2022-03-03 13:23:38'),(109396,344,'Kistaram','494114',1,0,'2022-03-03 13:23:39','2022-03-03 13:23:39'),(109397,344,'Kodripal','494111',1,0,'2022-03-03 13:23:39','2022-03-03 13:23:39'),(109398,344,'Kokawada','494115',1,0,'2022-03-03 13:23:39','2022-03-03 13:23:39'),(109399,344,'Koleng','494115',1,0,'2022-03-03 13:23:39','2022-03-03 13:23:39'),(109400,344,'Kondasawli','494556',1,0,'2022-03-03 13:23:39','2022-03-03 13:23:39'),(109401,344,'Konta','494114',1,0,'2022-03-03 13:23:39','2022-03-03 13:23:39'),(109402,344,'Korgaon','494441',1,0,'2022-03-03 13:23:39','2022-03-03 13:23:39'),(109403,344,'Korlapal','494441',1,0,'2022-03-03 13:23:39','2022-03-03 13:23:39'),(109404,344,'Korra','494111',1,0,'2022-03-03 13:23:39','2022-03-03 13:23:39'),(109405,344,'Koshalnar','494441',1,0,'2022-03-03 13:23:39','2022-03-03 13:23:39'),(109406,344,'Kuakonda','494552',1,0,'2022-03-03 13:23:39','2022-03-03 13:23:39'),(109407,344,'Kukanar','494115',1,0,'2022-03-03 13:23:39','2022-03-03 13:23:39'),(109408,344,'Kumharras','494551',1,0,'2022-03-03 13:23:39','2022-03-03 13:23:39'),(109409,344,'Kundanpal','494115',1,0,'2022-03-03 13:23:39','2022-03-03 13:23:39'),(109410,344,'Kunna','494115',1,0,'2022-03-03 13:23:39','2022-03-03 13:23:39'),(109411,344,'Kuper','494449',1,0,'2022-03-03 13:23:39','2022-03-03 13:23:39'),(109412,344,'Leda','494115',1,0,'2022-03-03 13:23:39','2022-03-03 13:23:39'),(109413,344,'Mailawada','494552',1,0,'2022-03-03 13:23:39','2022-03-03 13:23:39'),(109414,344,'Masenar','494552',1,0,'2022-03-03 13:23:39','2022-03-03 13:23:39'),(109415,344,'Matenar','494449',1,0,'2022-03-03 13:23:39','2022-03-03 13:23:39'),(109416,344,'Mehta','494114',1,0,'2022-03-03 13:23:39','2022-03-03 13:23:39'),(109417,344,'Metapal','494449',1,0,'2022-03-03 13:23:40','2022-03-03 13:23:40'),(109418,344,'Michwar','494115',1,0,'2022-03-03 13:23:40','2022-03-03 13:23:40'),(109419,344,'Mirtur','494450',1,0,'2022-03-03 13:23:40','2022-03-03 13:23:40'),(109420,344,'Misma','494122',1,0,'2022-03-03 13:23:40','2022-03-03 13:23:40'),(109421,344,'Modakpal','494448',1,0,'2022-03-03 13:23:40','2022-03-03 13:23:40'),(109422,344,'Mokhpal','494552',1,0,'2022-03-03 13:23:40','2022-03-03 13:23:40'),(109423,344,'Nagaram','494122',1,0,'2022-03-03 13:23:40','2022-03-03 13:23:40'),(109424,344,'Nakulnar','494552',1,0,'2022-03-03 13:23:40','2022-03-03 13:23:40'),(109425,344,'Pakela','494111',1,0,'2022-03-03 13:23:40','2022-03-03 13:23:40'),(109426,344,'Pakhnar','494115',1,0,'2022-03-03 13:23:40','2022-03-03 13:23:40'),(109427,344,'Palnar','494552',1,0,'2022-03-03 13:23:40','2022-03-03 13:23:40'),(109428,344,'Parcheli','494449',1,0,'2022-03-03 13:23:40','2022-03-03 13:23:40'),(109429,344,'Pedka','494552',1,0,'2022-03-03 13:23:40','2022-03-03 13:23:40'),(109430,344,'Pendalnar','494115',1,0,'2022-03-03 13:23:40','2022-03-03 13:23:40'),(109431,344,'Pharaspal','494449',1,0,'2022-03-03 13:23:40','2022-03-03 13:23:40'),(109432,344,'Phulpad','494552',1,0,'2022-03-03 13:23:40','2022-03-03 13:23:40'),(109433,344,'Pinkonda','494441',1,0,'2022-03-03 13:23:40','2022-03-03 13:23:40'),(109434,344,'Polampalli','494122',1,0,'2022-03-03 13:23:40','2022-03-03 13:23:40'),(109435,344,'Pondoom','494449',1,0,'2022-03-03 13:23:40','2022-03-03 13:23:40'),(109436,344,'Pondum','494111',1,0,'2022-03-03 13:23:40','2022-03-03 13:23:40'),(109437,344,'Pongabheji','494122',1,0,'2022-03-03 13:23:40','2022-03-03 13:23:40'),(109438,344,'Potali','494556',1,0,'2022-03-03 13:23:40','2022-03-03 13:23:40'),(109439,344,'Puspal','494115',1,0,'2022-03-03 13:23:40','2022-03-03 13:23:40'),(109440,344,'Ramaram','494111',1,0,'2022-03-03 13:23:41','2022-03-03 13:23:41'),(109441,344,'Rokel','494111',1,0,'2022-03-03 13:23:41','2022-03-03 13:23:41'),(109442,344,'Ronje','494441',1,0,'2022-03-03 13:23:41','2022-03-03 13:23:41'),(109443,344,'Sameli','494552',1,0,'2022-03-03 13:23:41','2022-03-03 13:23:41'),(109444,344,'Sautnar','494115',1,0,'2022-03-03 13:23:41','2022-03-03 13:23:41'),(109445,344,'Shivanandashram','494441',1,0,'2022-03-03 13:23:41','2022-03-03 13:23:41'),(109446,344,'Shyamgiri','494552',1,0,'2022-03-03 13:23:41','2022-03-03 13:23:41'),(109447,344,'Sirsitti','494122',1,0,'2022-03-03 13:23:41','2022-03-03 13:23:41'),(109448,344,'Sonakuknar','494111',1,0,'2022-03-03 13:23:41','2022-03-03 13:23:41'),(109449,344,'Sukma','494111',1,0,'2022-03-03 13:23:41','2022-03-03 13:23:41'),(109450,344,'Surnar','494552',1,0,'2022-03-03 13:23:41','2022-03-03 13:23:41'),(109451,344,'Talnar','494111',1,0,'2022-03-03 13:23:41','2022-03-03 13:23:41'),(109452,344,'Teknar','494449',1,0,'2022-03-03 13:23:41','2022-03-03 13:23:41'),(109453,344,'Telam','494552',1,0,'2022-03-03 13:23:41','2022-03-03 13:23:41'),(109454,344,'Tikanpal','494552',1,0,'2022-03-03 13:23:41','2022-03-03 13:23:41'),(109455,344,'Tirathgarh','494115',1,0,'2022-03-03 13:23:41','2022-03-03 13:23:41'),(109456,344,'Tongpal','494115',1,0,'2022-03-03 13:23:41','2022-03-03 13:23:41'),(109457,344,'Urmapal','494111',1,0,'2022-03-03 13:23:41','2022-03-03 13:23:41'),(109458,345,'Achhota','493773',1,0,'2022-03-03 13:23:41','2022-03-03 13:23:41'),(109459,345,'Achhoti','493663',1,0,'2022-03-03 13:23:42','2022-03-03 13:23:42'),(109460,345,'Amali','493778',1,0,'2022-03-03 13:23:42','2022-03-03 13:23:42'),(109461,345,'Amdi','493773',1,0,'2022-03-03 13:23:42','2022-03-03 13:23:42'),(109462,345,'Anwari','493770',1,0,'2022-03-03 13:23:42','2022-03-03 13:23:42'),(109463,345,'Aroud','493773',1,0,'2022-03-03 13:23:42','2022-03-03 13:23:42'),(109464,345,'Bagod','493663',1,0,'2022-03-03 13:23:42','2022-03-03 13:23:42'),(109465,345,'Bahigaon','493778',1,0,'2022-03-03 13:23:42','2022-03-03 13:23:42'),(109466,345,'Banraud','493773',1,0,'2022-03-03 13:23:42','2022-03-03 13:23:42'),(109467,345,'Bazar Kurridih','493773',1,0,'2022-03-03 13:23:42','2022-03-03 13:23:42'),(109468,345,'Belar Bahra','493778',1,0,'2022-03-03 13:23:42','2022-03-03 13:23:42'),(109469,345,'Belar Bazar','493778',1,0,'2022-03-03 13:23:42','2022-03-03 13:23:42'),(109470,345,'Belardona','493662',1,0,'2022-03-03 13:23:42','2022-03-03 13:23:42'),(109471,345,'Bhaismundi','493663',1,0,'2022-03-03 13:23:42','2022-03-03 13:23:42'),(109472,345,'Bhakhara','493770',1,0,'2022-03-03 13:23:42','2022-03-03 13:23:42'),(109473,345,'Bhatagaon','493663',1,0,'2022-03-03 13:23:42','2022-03-03 13:23:42'),(109474,345,'Bhatgaon','493776',1,0,'2022-03-03 13:23:42','2022-03-03 13:23:42'),(109475,345,'Bhendra','493770',1,0,'2022-03-03 13:23:42','2022-03-03 13:23:42'),(109476,345,'Bhothidih','493662',1,0,'2022-03-03 13:23:42','2022-03-03 13:23:42'),(109477,345,'Bhothli','493773',1,0,'2022-03-03 13:23:42','2022-03-03 13:23:42'),(109478,345,'Bhursidongri','493778',1,0,'2022-03-03 13:23:42','2022-03-03 13:23:42'),(109479,345,'Birgudi','493778',1,0,'2022-03-03 13:23:43','2022-03-03 13:23:43'),(109480,345,'Birjhuli','493662',1,0,'2022-03-03 13:23:43','2022-03-03 13:23:43'),(109481,345,'Borsi','493773',1,0,'2022-03-03 13:23:43','2022-03-03 13:23:43'),(109482,345,'Chanagaon','493773',1,0,'2022-03-03 13:23:43','2022-03-03 13:23:43'),(109483,345,'Charmudia','493663',1,0,'2022-03-03 13:23:43','2022-03-03 13:23:43'),(109484,345,'Chhati','493663',1,0,'2022-03-03 13:23:43','2022-03-03 13:23:43'),(109485,345,'Chhuhi','493773',1,0,'2022-03-03 13:23:43','2022-03-03 13:23:43'),(109486,345,'Dahdaha','493663',1,0,'2022-03-03 13:23:43','2022-03-03 13:23:43'),(109487,345,'Dahi','493770',1,0,'2022-03-03 13:23:43','2022-03-03 13:23:43'),(109488,345,'Demar','493773',1,0,'2022-03-03 13:23:43','2022-03-03 13:23:43'),(109489,345,'Deopur','493778',1,0,'2022-03-03 13:23:43','2022-03-03 13:23:43'),(109490,345,'Dhamtari D.B.Ward','493773',1,0,'2022-03-03 13:23:43','2022-03-03 13:23:43'),(109491,345,'Dhamtari I.Ward','493773',1,0,'2022-03-03 13:23:43','2022-03-03 13:23:43'),(109492,345,'Dhamtari','493773',1,0,'2022-03-03 13:23:43','2022-03-03 13:23:43'),(109493,345,'Doma','493770',1,0,'2022-03-03 13:23:43','2022-03-03 13:23:43'),(109494,345,'Dongardulla','493778',1,0,'2022-03-03 13:23:43','2022-03-03 13:23:43'),(109495,345,'Dugli','493773',1,0,'2022-03-03 13:23:43','2022-03-03 13:23:43'),(109496,345,'Farsia','493778',1,0,'2022-03-03 13:23:43','2022-03-03 13:23:43'),(109497,345,'G.Jamgoan','493770',1,0,'2022-03-03 13:23:43','2022-03-03 13:23:43'),(109498,345,'Garhdongri','493778',1,0,'2022-03-03 13:23:43','2022-03-03 13:23:43'),(109499,345,'Gattasilli','493773',1,0,'2022-03-03 13:23:44','2022-03-03 13:23:44'),(109500,345,'Ghatula','493778',1,0,'2022-03-03 13:23:44','2022-03-03 13:23:44'),(109501,345,'Ghorawad','493778',1,0,'2022-03-03 13:23:44','2022-03-03 13:23:44'),(109502,345,'Ghotgaon','493778',1,0,'2022-03-03 13:23:44','2022-03-03 13:23:44'),(109503,345,'Girod','493662',1,0,'2022-03-03 13:23:44','2022-03-03 13:23:44'),(109504,345,'Jhiriya','493663',1,0,'2022-03-03 13:23:44','2022-03-03 13:23:44'),(109505,345,'Jhuratarai','493773',1,0,'2022-03-03 13:23:44','2022-03-03 13:23:44'),(109506,345,'Joratarai','493770',1,0,'2022-03-03 13:23:44','2022-03-03 13:23:44'),(109507,345,'Kachna','493770',1,0,'2022-03-03 13:23:44','2022-03-03 13:23:44'),(109508,345,'Kandel','493663',1,0,'2022-03-03 13:23:44','2022-03-03 13:23:44'),(109509,345,'Karaiha','493773',1,0,'2022-03-03 13:23:44','2022-03-03 13:23:44'),(109510,345,'Kareli Chhoti','493662',1,0,'2022-03-03 13:23:44','2022-03-03 13:23:44'),(109511,345,'Kaspur','493778',1,0,'2022-03-03 13:23:44','2022-03-03 13:23:44'),(109512,345,'Katalbod','493663',1,0,'2022-03-03 13:23:44','2022-03-03 13:23:44'),(109513,345,'Keregaon','493773',1,0,'2022-03-03 13:23:44','2022-03-03 13:23:44'),(109514,345,'Khamaria','493778',1,0,'2022-03-03 13:23:44','2022-03-03 13:23:44'),(109515,345,'Kharenga','493773',1,0,'2022-03-03 13:23:44','2022-03-03 13:23:44'),(109516,345,'Korra','493770',1,0,'2022-03-03 13:23:44','2022-03-03 13:23:44'),(109517,345,'Kosamsara','493770',1,0,'2022-03-03 13:23:45','2022-03-03 13:23:45'),(109518,345,'Kukrel','493773',1,0,'2022-03-03 13:23:45','2022-03-03 13:23:45'),(109519,345,'Kundel','493662',1,0,'2022-03-03 13:23:45','2022-03-03 13:23:45'),(109520,345,'Kurud','493663',1,0,'2022-03-03 13:23:45','2022-03-03 13:23:45'),(109521,345,'Loharsi','493773',1,0,'2022-03-03 13:23:45','2022-03-03 13:23:45'),(109522,345,'Madeli','493770',1,0,'2022-03-03 13:23:45','2022-03-03 13:23:45'),(109523,345,'Magarlod','493662',1,0,'2022-03-03 13:23:45','2022-03-03 13:23:45'),(109524,345,'Mandraud','493663',1,0,'2022-03-03 13:23:45','2022-03-03 13:23:45'),(109525,345,'Marod','493663',1,0,'2022-03-03 13:23:45','2022-03-03 13:23:45'),(109526,345,'Megha','493662',1,0,'2022-03-03 13:23:45','2022-03-03 13:23:45'),(109527,345,'Mohdi','493662',1,0,'2022-03-03 13:23:45','2022-03-03 13:23:45'),(109528,345,'Nagri','493778',1,0,'2022-03-03 13:23:45','2022-03-03 13:23:45'),(109529,345,'Nari','493663',1,0,'2022-03-03 13:23:45','2022-03-03 13:23:45'),(109530,345,'Parkhanda','493663',1,0,'2022-03-03 13:23:45','2022-03-03 13:23:45'),(109531,345,'Podagaon','493778',1,0,'2022-03-03 13:23:45','2022-03-03 13:23:45'),(109532,345,'Potiadih','493773',1,0,'2022-03-03 13:23:45','2022-03-03 13:23:45'),(109533,345,'Puri','493663',1,0,'2022-03-03 13:23:45','2022-03-03 13:23:45'),(109534,345,'R.S.P.Colony Gangrel','493776',1,0,'2022-03-03 13:23:45','2022-03-03 13:23:45'),(109535,345,'Rajpur','493778',1,0,'2022-03-03 13:23:45','2022-03-03 13:23:45'),(109536,345,'Rampur','493770',1,0,'2022-03-03 13:23:45','2022-03-03 13:23:45'),(109537,345,'Rudri','493776',1,0,'2022-03-03 13:23:45','2022-03-03 13:23:45'),(109538,345,'Sambalpur','493773',1,0,'2022-03-03 13:23:45','2022-03-03 13:23:45'),(109539,345,'Sankari','493663',1,0,'2022-03-03 13:23:46','2022-03-03 13:23:46'),(109540,345,'Sankra','493778',1,0,'2022-03-03 13:23:46','2022-03-03 13:23:46'),(109541,345,'Sargi','493662',1,0,'2022-03-03 13:23:46','2022-03-03 13:23:46'),(109542,345,'Semra','493770',1,0,'2022-03-03 13:23:46','2022-03-03 13:23:46'),(109543,345,'Semra','493778',1,0,'2022-03-03 13:23:46','2022-03-03 13:23:46'),(109544,345,'Seonikala','493663',1,0,'2022-03-03 13:23:46','2022-03-03 13:23:46'),(109545,345,'Sihawa','493778',1,0,'2022-03-03 13:23:46','2022-03-03 13:23:46'),(109546,345,'Silouti','493770',1,0,'2022-03-03 13:23:46','2022-03-03 13:23:46'),(109547,345,'Singhpur','493773',1,0,'2022-03-03 13:23:46','2022-03-03 13:23:46'),(109548,345,'Sirri','493663',1,0,'2022-03-03 13:23:46','2022-03-03 13:23:46'),(109549,345,'Sondur Project','493778',1,0,'2022-03-03 13:23:46','2022-03-03 13:23:46'),(109550,345,'Tarsiwa','493773',1,0,'2022-03-03 13:23:46','2022-03-03 13:23:46'),(109551,345,'Umargaon','493778',1,0,'2022-03-03 13:23:46','2022-03-03 13:23:46'),(109552,346,'A O Bhilai','490001',1,0,'2022-03-03 13:23:46','2022-03-03 13:23:46'),(109553,346,'Achaud','491223',1,0,'2022-03-03 13:23:46','2022-03-03 13:23:46'),(109554,346,'Acholi','491771',1,0,'2022-03-03 13:23:46','2022-03-03 13:23:46'),(109555,346,'Admabad','491226',1,0,'2022-03-03 13:23:46','2022-03-03 13:23:46'),(109556,346,'Ahiwara','490036',1,0,'2022-03-03 13:23:46','2022-03-03 13:23:46'),(109557,346,'Albaras','491221',1,0,'2022-03-03 13:23:46','2022-03-03 13:23:46'),(109558,346,'Amadula','491228',1,0,'2022-03-03 13:23:46','2022-03-03 13:23:46'),(109559,346,'Anandgaon','491332',1,0,'2022-03-03 13:23:46','2022-03-03 13:23:46'),(109560,346,'Anda','491221',1,0,'2022-03-03 13:23:47','2022-03-03 13:23:47'),(109561,346,'Andhiarkhor','491337',1,0,'2022-03-03 13:23:47','2022-03-03 13:23:47'),(109562,346,'Anjora','491001',1,0,'2022-03-03 13:23:47','2022-03-03 13:23:47'),(109563,346,'Arjunda','491225',1,0,'2022-03-03 13:23:47','2022-03-03 13:23:47'),(109564,346,'Arkar','491222',1,0,'2022-03-03 13:23:47','2022-03-03 13:23:47'),(109565,346,'Armarikala','491222',1,0,'2022-03-03 13:23:47','2022-03-03 13:23:47'),(109566,346,'Aundhi','490021',1,0,'2022-03-03 13:23:47','2022-03-03 13:23:47'),(109567,346,'Auri','490021',1,0,'2022-03-03 13:23:47','2022-03-03 13:23:47'),(109568,346,'Baba Mohtara','491335',1,0,'2022-03-03 13:23:47','2022-03-03 13:23:47'),(109569,346,'Badbhum','491226',1,0,'2022-03-03 13:23:47','2022-03-03 13:23:47'),(109570,346,'Badgaon','491771',1,0,'2022-03-03 13:23:47','2022-03-03 13:23:47'),(109571,346,'Badnara','491340',1,0,'2022-03-03 13:23:47','2022-03-03 13:23:47'),(109572,346,'Baghal','491337',1,0,'2022-03-03 13:23:47','2022-03-03 13:23:47'),(109573,346,'Baghmara','491226',1,0,'2022-03-03 13:23:47','2022-03-03 13:23:47'),(109574,346,'Balod Gahan','491227',1,0,'2022-03-03 13:23:47','2022-03-03 13:23:47'),(109575,346,'Balod','491226',1,0,'2022-03-03 13:23:47','2022-03-03 13:23:47'),(109576,346,'Balod Town','491226',1,0,'2022-03-03 13:23:47','2022-03-03 13:23:47'),(109577,346,'Baloda','491226',1,0,'2022-03-03 13:23:47','2022-03-03 13:23:47'),(109578,346,'Balsamund','491335',1,0,'2022-03-03 13:23:47','2022-03-03 13:23:47'),(109579,346,'Barbaspur','491222',1,0,'2022-03-03 13:23:47','2022-03-03 13:23:47'),(109580,346,'Bargada','491993',1,0,'2022-03-03 13:23:47','2022-03-03 13:23:47'),(109581,346,'Bargaon','491332',1,0,'2022-03-03 13:23:48','2022-03-03 13:23:48'),(109582,346,'Barhapur','491331',1,0,'2022-03-03 13:23:48','2022-03-03 13:23:48'),(109583,346,'Barhi','491227',1,0,'2022-03-03 13:23:48','2022-03-03 13:23:48'),(109584,346,'Basin','491227',1,0,'2022-03-03 13:23:48','2022-03-03 13:23:48'),(109585,346,'Batang','491111',1,0,'2022-03-03 13:23:48','2022-03-03 13:23:48'),(109586,346,'Bathena','491111',1,0,'2022-03-03 13:23:48','2022-03-03 13:23:48'),(109587,346,'Batrel','491222',1,0,'2022-03-03 13:23:48','2022-03-03 13:23:48'),(109588,346,'Bazar Dallirajhara','491228',1,0,'2022-03-03 13:23:48','2022-03-03 13:23:48'),(109589,346,'Belaudi','491222',1,0,'2022-03-03 13:23:48','2022-03-03 13:23:48'),(109590,346,'Belhari','491223',1,0,'2022-03-03 13:23:48','2022-03-03 13:23:48'),(109591,346,'Belmond','491226',1,0,'2022-03-03 13:23:48','2022-03-03 13:23:48'),(109592,346,'Beltara','491993',1,0,'2022-03-03 13:23:48','2022-03-03 13:23:48'),(109593,346,'Bemetara','491335',1,0,'2022-03-03 13:23:48','2022-03-03 13:23:48'),(109594,346,'Berla','491332',1,0,'2022-03-03 13:23:48','2022-03-03 13:23:48'),(109595,346,'Bhaisbod','491226',1,0,'2022-03-03 13:23:48','2022-03-03 13:23:48'),(109596,346,'Bhandera','491771',1,0,'2022-03-03 13:23:48','2022-03-03 13:23:48'),(109597,346,'Bhansuli','491111',1,0,'2022-03-03 13:23:48','2022-03-03 13:23:48'),(109598,346,'Bhanwarmara','491771',1,0,'2022-03-03 13:23:48','2022-03-03 13:23:48'),(109599,346,'Bharda','491771',1,0,'2022-03-03 13:23:48','2022-03-03 13:23:48'),(109600,346,'Bhardakala','491225',1,0,'2022-03-03 13:23:49','2022-03-03 13:23:49'),(109601,346,'Bharritola','491228',1,0,'2022-03-03 13:23:49','2022-03-03 13:23:49'),(109602,346,'Bhatagaon','491331',1,0,'2022-03-03 13:23:49','2022-03-03 13:23:49'),(109603,346,'Bhatagaon','491222',1,0,'2022-03-03 13:23:49','2022-03-03 13:23:49'),(109604,346,'Bhatagaon','491223',1,0,'2022-03-03 13:23:49','2022-03-03 13:23:49'),(109605,346,'Bhendsar','491001',1,0,'2022-03-03 13:23:49','2022-03-03 13:23:49'),(109606,346,'Bhilai 1','490001',1,0,'2022-03-03 13:23:49','2022-03-03 13:23:49'),(109607,346,'Bhilai Boria','490001',1,0,'2022-03-03 13:23:49','2022-03-03 13:23:49'),(109608,346,'Bhilai East','490021',1,0,'2022-03-03 13:23:49','2022-03-03 13:23:49'),(109609,346,'Bhilai Marshalling Yard','490025',1,0,'2022-03-03 13:23:49','2022-03-03 13:23:49'),(109610,346,'Bhilai West','490009',1,0,'2022-03-03 13:23:49','2022-03-03 13:23:49'),(109611,346,'Bhimbhori','490036',1,0,'2022-03-03 13:23:49','2022-03-03 13:23:49'),(109612,346,'Bhimkanhar','491771',1,0,'2022-03-03 13:23:49','2022-03-03 13:23:49'),(109613,346,'Bijabhat','491335',1,0,'2022-03-03 13:23:49','2022-03-03 13:23:49'),(109614,346,'Biroda','491332',1,0,'2022-03-03 13:23:49','2022-03-03 13:23:49'),(109615,346,'Bital','491228',1,0,'2022-03-03 13:23:49','2022-03-03 13:23:49'),(109616,346,'Borai','491001',1,0,'2022-03-03 13:23:49','2022-03-03 13:23:49'),(109617,346,'Bori','491001',1,0,'2022-03-03 13:23:50','2022-03-03 13:23:50'),(109618,346,'Borid','491111',1,0,'2022-03-03 13:23:50','2022-03-03 13:23:50'),(109619,346,'Borsi','491001',1,0,'2022-03-03 13:23:50','2022-03-03 13:23:50'),(109620,346,'Bortara','491993',1,0,'2022-03-03 13:23:50','2022-03-03 13:23:50'),(109621,346,'Bundeli','491888',1,0,'2022-03-03 13:23:50','2022-03-03 13:23:50'),(109622,346,'Chandanu','491335',1,0,'2022-03-03 13:23:50','2022-03-03 13:23:50'),(109623,346,'Chandkhuri','491221',1,0,'2022-03-03 13:23:50','2022-03-03 13:23:50'),(109624,346,'Chandnbirhi','491222',1,0,'2022-03-03 13:23:50','2022-03-03 13:23:50'),(109625,346,'Charbhata','491222',1,0,'2022-03-03 13:23:50','2022-03-03 13:23:50'),(109626,346,'Charwahi','491227',1,0,'2022-03-03 13:23:50','2022-03-03 13:23:50'),(109627,346,'Chaurel','491225',1,0,'2022-03-03 13:23:50','2022-03-03 13:23:50'),(109628,346,'Chicha','491001',1,0,'2022-03-03 13:23:50','2022-03-03 13:23:50'),(109629,346,'Chikhlakasa','491228',1,0,'2022-03-03 13:23:50','2022-03-03 13:23:50'),(109630,346,'Chilfi','491993',1,0,'2022-03-03 13:23:50','2022-03-03 13:23:50'),(109631,346,'Chipra','491228',1,0,'2022-03-03 13:23:50','2022-03-03 13:23:50'),(109632,346,'Chirha','491337',1,0,'2022-03-03 13:23:50','2022-03-03 13:23:50'),(109633,346,'Chitod','491227',1,0,'2022-03-03 13:23:50','2022-03-03 13:23:50'),(109634,346,'Civic Centre Bhilai','490006',1,0,'2022-03-03 13:23:50','2022-03-03 13:23:50'),(109635,346,'Dadhi','491335',1,0,'2022-03-03 13:23:50','2022-03-03 13:23:50'),(109636,346,'Dagania','491221',1,0,'2022-03-03 13:23:51','2022-03-03 13:23:51'),(109637,346,'Dallirajhara','491228',1,0,'2022-03-03 13:23:51','2022-03-03 13:23:51'),(109638,346,'Darbarmokhli','491111',1,0,'2022-03-03 13:23:51','2022-03-03 13:23:51'),(109639,346,'Dargaon','491332',1,0,'2022-03-03 13:23:51','2022-03-03 13:23:51'),(109640,346,'Darra','491227',1,0,'2022-03-03 13:23:51','2022-03-03 13:23:51'),(109641,346,'Deobaloda','490025',1,0,'2022-03-03 13:23:51','2022-03-03 13:23:51'),(109642,346,'Deokar','491331',1,0,'2022-03-03 13:23:51','2022-03-03 13:23:51'),(109643,346,'Deorbija','491993',1,0,'2022-03-03 13:23:51','2022-03-03 13:23:51'),(109644,346,'Deori','491771',1,0,'2022-03-03 13:23:51','2022-03-03 13:23:51'),(109645,346,'Deori','491331',1,0,'2022-03-03 13:23:51','2022-03-03 13:23:51'),(109646,346,'Deurgaon','491993',1,0,'2022-03-03 13:23:51','2022-03-03 13:23:51'),(109647,346,'Devada','491111',1,0,'2022-03-03 13:23:51','2022-03-03 13:23:51'),(109648,346,'Dhamdha','491331',1,0,'2022-03-03 13:23:51','2022-03-03 13:23:51'),(109649,346,'Dhamna','491223',1,0,'2022-03-03 13:23:51','2022-03-03 13:23:51'),(109650,346,'Dhaneli','491227',1,0,'2022-03-03 13:23:51','2022-03-03 13:23:51'),(109651,346,'Dhaur','490024',1,0,'2022-03-03 13:23:51','2022-03-03 13:23:51'),(109652,346,'Dondi Awari','491228',1,0,'2022-03-03 13:23:51','2022-03-03 13:23:51'),(109653,346,'Dondi Lohara','491771',1,0,'2022-03-03 13:23:51','2022-03-03 13:23:51'),(109654,346,'Dudhli','491226',1,0,'2022-03-03 13:23:51','2022-03-03 13:23:51'),(109655,346,'Dundera','491225',1,0,'2022-03-03 13:23:51','2022-03-03 13:23:51'),(109656,346,'Dundera','491107',1,0,'2022-03-03 13:23:51','2022-03-03 13:23:51'),(109657,346,'Durg H.O','491001',1,0,'2022-03-03 13:23:51','2022-03-03 13:23:51'),(109658,346,'Durg Kutchery','491001',1,0,'2022-03-03 13:23:52','2022-03-03 13:23:52'),(109659,346,'Durg R S','491001',1,0,'2022-03-03 13:23:52','2022-03-03 13:23:52'),(109660,346,'Durg Sadar Bazar','491001',1,0,'2022-03-03 13:23:52','2022-03-03 13:23:52'),(109661,346,'Fagundah','491227',1,0,'2022-03-03 13:23:52','2022-03-03 13:23:52'),(109662,346,'Faradfod','491771',1,0,'2022-03-03 13:23:52','2022-03-03 13:23:52'),(109663,346,'Fekari','491107',1,0,'2022-03-03 13:23:52','2022-03-03 13:23:52'),(109664,346,'Gabdi','491225',1,0,'2022-03-03 13:23:52','2022-03-03 13:23:52'),(109665,346,'Gadadih','491221',1,0,'2022-03-03 13:23:52','2022-03-03 13:23:52'),(109666,346,'Gadadih','491331',1,0,'2022-03-03 13:23:52','2022-03-03 13:23:52'),(109667,346,'Gadamore','491337',1,0,'2022-03-03 13:23:52','2022-03-03 13:23:52'),(109668,346,'Ghoghra','491337',1,0,'2022-03-03 13:23:52','2022-03-03 13:23:52'),(109669,346,'Ghota','491331',1,0,'2022-03-03 13:23:52','2022-03-03 13:23:52'),(109670,346,'Ghotia','491228',1,0,'2022-03-03 13:23:52','2022-03-03 13:23:52'),(109671,346,'Ghotwani','491331',1,0,'2022-03-03 13:23:52','2022-03-03 13:23:52'),(109672,346,'Ghursena','491340',1,0,'2022-03-03 13:23:52','2022-03-03 13:23:52'),(109673,346,'Girhola','490036',1,0,'2022-03-03 13:23:52','2022-03-03 13:23:52'),(109674,346,'Gondgiri','490036',1,0,'2022-03-03 13:23:52','2022-03-03 13:23:52'),(109675,346,'Gondi','490036',1,0,'2022-03-03 13:23:52','2022-03-03 13:23:52'),(109676,346,'Gorkapar','491223',1,0,'2022-03-03 13:23:52','2022-03-03 13:23:52'),(109677,346,'Gudheli','490036',1,0,'2022-03-03 13:23:53','2022-03-03 13:23:53'),(109678,346,'Gudum','491228',1,0,'2022-03-03 13:23:53','2022-03-03 13:23:53'),(109679,346,'Gujra','491111',1,0,'2022-03-03 13:23:53','2022-03-03 13:23:53'),(109680,346,'Gujra','491226',1,0,'2022-03-03 13:23:53','2022-03-03 13:23:53'),(109681,346,'Gunderdehi','491223',1,0,'2022-03-03 13:23:53','2022-03-03 13:23:53'),(109682,346,'Gurur','491227',1,0,'2022-03-03 13:23:53','2022-03-03 13:23:53'),(109683,346,'Hadgaon','491225',1,0,'2022-03-03 13:23:53','2022-03-03 13:23:53'),(109684,346,'Hanoda','491001',1,0,'2022-03-03 13:23:53','2022-03-03 13:23:53'),(109685,346,'Hardi','491222',1,0,'2022-03-03 13:23:53','2022-03-03 13:23:53'),(109686,346,'Hardi','491337',1,0,'2022-03-03 13:23:53','2022-03-03 13:23:53'),(109687,346,'Hasda','490036',1,0,'2022-03-03 13:23:53','2022-03-03 13:23:53'),(109688,346,'Hatranka','491338',1,0,'2022-03-03 13:23:53','2022-03-03 13:23:53'),(109689,346,'Hirri','491001',1,0,'2022-03-03 13:23:53','2022-03-03 13:23:53'),(109690,346,'I E Bhilai','490026',1,0,'2022-03-03 13:23:53','2022-03-03 13:23:53'),(109691,346,'Ibsb Bhilai H.O','490001',1,0,'2022-03-03 13:23:53','2022-03-03 13:23:53'),(109692,346,'Jamgaon B','491227',1,0,'2022-03-03 13:23:53','2022-03-03 13:23:53'),(109693,346,'Jamgaon','491111',1,0,'2022-03-03 13:23:53','2022-03-03 13:23:53'),(109694,346,'Jamgaon R','491223',1,0,'2022-03-03 13:23:53','2022-03-03 13:23:53'),(109695,346,'Jamrua','491226',1,0,'2022-03-03 13:23:53','2022-03-03 13:23:53'),(109696,346,'Jamul Cement Works','490024',1,0,'2022-03-03 13:23:53','2022-03-03 13:23:53'),(109697,346,'Janjgiri','490025',1,0,'2022-03-03 13:23:53','2022-03-03 13:23:53'),(109698,346,'Jawahar Market Bhilai','490001',1,0,'2022-03-03 13:23:53','2022-03-03 13:23:53'),(109699,346,'Jeora Sirsa','491001',1,0,'2022-03-03 13:23:53','2022-03-03 13:23:53'),(109700,346,'Jhal','491335',1,0,'2022-03-03 13:23:54','2022-03-03 13:23:54'),(109701,346,'Jiya','491335',1,0,'2022-03-03 13:23:54','2022-03-03 13:23:54'),(109702,346,'K.Mohrenga','491332',1,0,'2022-03-03 13:23:54','2022-03-03 13:23:54'),(109703,346,'Kachandur','491223',1,0,'2022-03-03 13:23:54','2022-03-03 13:23:54'),(109704,346,'Kalangpur','491223',1,0,'2022-03-03 13:23:54','2022-03-03 13:23:54'),(109705,346,'Kamkapar','491771',1,0,'2022-03-03 13:23:54','2022-03-03 13:23:54'),(109706,346,'Kanakote','491221',1,0,'2022-03-03 13:23:54','2022-03-03 13:23:54'),(109707,346,'Kandul','491225',1,0,'2022-03-03 13:23:54','2022-03-03 13:23:54'),(109708,346,'Kaneri','491227',1,0,'2022-03-03 13:23:54','2022-03-03 13:23:54'),(109709,346,'Kanhera','491335',1,0,'2022-03-03 13:23:54','2022-03-03 13:23:54'),(109710,346,'Kanwar','491227',1,0,'2022-03-03 13:23:54','2022-03-03 13:23:54'),(109711,346,'Kanwarkapa','491337',1,0,'2022-03-03 13:23:54','2022-03-03 13:23:54'),(109712,346,'Kapasda','490042',1,0,'2022-03-03 13:23:54','2022-03-03 13:23:54'),(109713,346,'Karanja Bhilai','490024',1,0,'2022-03-03 13:23:54','2022-03-03 13:23:54'),(109714,346,'Karela','491223',1,0,'2022-03-03 13:23:54','2022-03-03 13:23:54'),(109715,346,'Kareli','491331',1,0,'2022-03-03 13:23:54','2022-03-03 13:23:54'),(109716,346,'Karesara','491335',1,0,'2022-03-03 13:23:54','2022-03-03 13:23:54'),(109717,346,'Karhi Bhadar','491227',1,0,'2022-03-03 13:23:54','2022-03-03 13:23:54'),(109718,346,'Kasahi','491225',1,0,'2022-03-03 13:23:54','2022-03-03 13:23:54'),(109719,346,'Kasaridih Durg','491001',1,0,'2022-03-03 13:23:55','2022-03-03 13:23:55'),(109720,346,'Kasaunda','491223',1,0,'2022-03-03 13:23:55','2022-03-03 13:23:55'),(109721,346,'Kesra','491111',1,0,'2022-03-03 13:23:55','2022-03-03 13:23:55'),(109722,346,'Kestaa','491993',1,0,'2022-03-03 13:23:55','2022-03-03 13:23:55'),(109723,346,'Khalari','491228',1,0,'2022-03-03 13:23:55','2022-03-03 13:23:55'),(109724,346,'Khamaria','491111',1,0,'2022-03-03 13:23:55','2022-03-03 13:23:55'),(109725,346,'Khamaria (Durg)','491338',1,0,'2022-03-03 13:23:55','2022-03-03 13:23:55'),(109726,346,'Khandsara','491335',1,0,'2022-03-03 13:23:55','2022-03-03 13:23:55'),(109727,346,'Khapri','491226',1,0,'2022-03-03 13:23:55','2022-03-03 13:23:55'),(109728,346,'Kheda','491340',1,0,'2022-03-03 13:23:55','2022-03-03 13:23:55'),(109729,346,'Kherthabazar','491771',1,0,'2022-03-03 13:23:55','2022-03-03 13:23:55'),(109730,346,'Khobha','491226',1,0,'2022-03-03 13:23:55','2022-03-03 13:23:55'),(109731,346,'Kholjhar','491771',1,0,'2022-03-03 13:23:55','2022-03-03 13:23:55'),(109732,346,'Khopli','491107',1,0,'2022-03-03 13:23:55','2022-03-03 13:23:55'),(109733,346,'Khudmuda','491332',1,0,'2022-03-03 13:23:55','2022-03-03 13:23:55'),(109734,346,'Khundini','491227',1,0,'2022-03-03 13:23:55','2022-03-03 13:23:55'),(109735,346,'Khursipar Bhilai','490011',1,0,'2022-03-03 13:23:55','2022-03-03 13:23:55'),(109736,346,'Khursuni','491225',1,0,'2022-03-03 13:23:55','2022-03-03 13:23:55'),(109737,346,'Kodekasa','491771',1,0,'2022-03-03 13:23:55','2022-03-03 13:23:55'),(109738,346,'Kodia','490036',1,0,'2022-03-03 13:23:56','2022-03-03 13:23:56'),(109739,346,'Kohka Bhilai','490023',1,0,'2022-03-03 13:23:56','2022-03-03 13:23:56'),(109740,346,'Kondekasa','491228',1,0,'2022-03-03 13:23:56','2022-03-03 13:23:56'),(109741,346,'Kotagaon','491228',1,0,'2022-03-03 13:23:56','2022-03-03 13:23:56'),(109742,346,'Kumhari','490042',1,0,'2022-03-03 13:23:56','2022-03-03 13:23:56'),(109743,346,'Kunwa','491340',1,0,'2022-03-03 13:23:56','2022-03-03 13:23:56'),(109744,346,'Kunwa','491337',1,0,'2022-03-03 13:23:56','2022-03-03 13:23:56'),(109745,346,'Kurda','491335',1,0,'2022-03-03 13:23:56','2022-03-03 13:23:56'),(109746,346,'Kurud','490024',1,0,'2022-03-03 13:23:56','2022-03-03 13:23:56'),(109747,346,'Kusmi','491332',1,0,'2022-03-03 13:23:56','2022-03-03 13:23:56'),(109748,346,'Kusumkasa','491228',1,0,'2022-03-03 13:23:56','2022-03-03 13:23:56'),(109749,346,'Kuthrel','491221',1,0,'2022-03-03 13:23:56','2022-03-03 13:23:56'),(109750,346,'Latabod','491226',1,0,'2022-03-03 13:23:56','2022-03-03 13:23:56'),(109751,346,'Lawatara','491332',1,0,'2022-03-03 13:23:56','2022-03-03 13:23:56'),(109752,346,'Lenjwara','491332',1,0,'2022-03-03 13:23:56','2022-03-03 13:23:56'),(109753,346,'Limora','491227',1,0,'2022-03-03 13:23:56','2022-03-03 13:23:56'),(109754,346,'Limtara','490042',1,0,'2022-03-03 13:23:56','2022-03-03 13:23:56'),(109755,346,'Litia Semaria','491001',1,0,'2022-03-03 13:23:56','2022-03-03 13:23:56'),(109756,346,'Machandur','491221',1,0,'2022-03-03 13:23:56','2022-03-03 13:23:56'),(109757,346,'Mahamaya Mines','491228',1,0,'2022-03-03 13:23:57','2022-03-03 13:23:57'),(109758,346,'Mahud','491222',1,0,'2022-03-03 13:23:57','2022-03-03 13:23:57'),(109759,346,'Mahudajhit','491111',1,0,'2022-03-03 13:23:57','2022-03-03 13:23:57'),(109760,346,'Malvia Nagar Durg','491001',1,0,'2022-03-03 13:23:57','2022-03-03 13:23:57'),(109761,346,'Maro','491340',1,0,'2022-03-03 13:23:57','2022-03-03 13:23:57'),(109762,346,'Maroda Bhilai','490006',1,0,'2022-03-03 13:23:57','2022-03-03 13:23:57'),(109763,346,'Marra','491221',1,0,'2022-03-03 13:23:57','2022-03-03 13:23:57'),(109764,346,'Matka','491335',1,0,'2022-03-03 13:23:57','2022-03-03 13:23:57'),(109765,346,'Matwari','491221',1,0,'2022-03-03 13:23:57','2022-03-03 13:23:57'),(109766,346,'Mau','491340',1,0,'2022-03-03 13:23:57','2022-03-03 13:23:57'),(109767,346,'Medesara','490036',1,0,'2022-03-03 13:23:57','2022-03-03 13:23:57'),(109768,346,'Mines Office Dallirajhara','491228',1,0,'2022-03-03 13:23:57','2022-03-03 13:23:57'),(109769,346,'Mohan Nagar Durg','491001',1,0,'2022-03-03 13:23:57','2022-03-03 13:23:57'),(109770,346,'Mohara','491222',1,0,'2022-03-03 13:23:57','2022-03-03 13:23:57'),(109771,346,'Mohbhatta','491993',1,0,'2022-03-03 13:23:57','2022-03-03 13:23:57'),(109772,346,'Mohgaon','491993',1,0,'2022-03-03 13:23:57','2022-03-03 13:23:57'),(109773,346,'Mohrenga','491335',1,0,'2022-03-03 13:23:57','2022-03-03 13:23:57'),(109774,346,'Mokha','491227',1,0,'2022-03-03 13:23:57','2022-03-03 13:23:57'),(109775,346,'Motilal Nehru Nagr Bhilai','490020',1,0,'2022-03-03 13:23:57','2022-03-03 13:23:57'),(109776,346,'Murmunda','490036',1,0,'2022-03-03 13:23:57','2022-03-03 13:23:57'),(109777,346,'Murta','491337',1,0,'2022-03-03 13:23:57','2022-03-03 13:23:57'),(109778,346,'Nagdha','491340',1,0,'2022-03-03 13:23:57','2022-03-03 13:23:57'),(109779,346,'Nagpura','491001',1,0,'2022-03-03 13:23:57','2022-03-03 13:23:57'),(109780,346,'Nahanda','491771',1,0,'2022-03-03 13:23:57','2022-03-03 13:23:57'),(109781,346,'Nandal','491337',1,0,'2022-03-03 13:23:57','2022-03-03 13:23:57'),(109782,346,'Nandghat','491340',1,0,'2022-03-03 13:23:58','2022-03-03 13:23:58'),(109783,346,'Nandini Khundini','490036',1,0,'2022-03-03 13:23:58','2022-03-03 13:23:58'),(109784,346,'Nandini','490036',1,0,'2022-03-03 13:23:58','2022-03-03 13:23:58'),(109785,346,'Nandkatti','491001',1,0,'2022-03-03 13:23:58','2022-03-03 13:23:58'),(109786,346,'Naragaon','491227',1,0,'2022-03-03 13:23:58','2022-03-03 13:23:58'),(109787,346,'Narayanpur','491340',1,0,'2022-03-03 13:23:58','2022-03-03 13:23:58'),(109788,346,'Nardha','490024',1,0,'2022-03-03 13:23:58','2022-03-03 13:23:58'),(109789,346,'Narratola','491228',1,0,'2022-03-03 13:23:58','2022-03-03 13:23:58'),(109790,346,'Nawagaon Bhilai','490006',1,0,'2022-03-03 13:23:58','2022-03-03 13:23:58'),(109791,346,'Nawagaon Purda','491001',1,0,'2022-03-03 13:23:58','2022-03-03 13:23:58'),(109792,346,'Nawagarh (Durg)','491337',1,0,'2022-03-03 13:23:58','2022-03-03 13:23:58'),(109793,346,'New Khursipar Bhilai','490011',1,0,'2022-03-03 13:23:58','2022-03-03 13:23:58'),(109794,346,'Newai','491107',1,0,'2022-03-03 13:23:58','2022-03-03 13:23:58'),(109795,346,'Newarikala','491226',1,0,'2022-03-03 13:23:58','2022-03-03 13:23:58'),(109796,346,'Nikum','491221',1,0,'2022-03-03 13:23:58','2022-03-03 13:23:58'),(109797,346,'Ninwa','491335',1,0,'2022-03-03 13:23:58','2022-03-03 13:23:58'),(109798,346,'Nipani','491227',1,0,'2022-03-03 13:23:58','2022-03-03 13:23:58'),(109799,346,'Nipani Tipani','491223',1,0,'2022-03-03 13:23:58','2022-03-03 13:23:58'),(109800,346,'Odia','491335',1,0,'2022-03-03 13:23:58','2022-03-03 13:23:58'),(109801,346,'Oteband','490042',1,0,'2022-03-03 13:23:58','2022-03-03 13:23:58'),(109802,346,'Padmanabhpur Durg','491001',1,0,'2022-03-03 13:23:58','2022-03-03 13:23:58'),(109803,346,'Pahanda','491332',1,0,'2022-03-03 13:23:58','2022-03-03 13:23:58'),(109804,346,'Pahanda','490042',1,0,'2022-03-03 13:23:58','2022-03-03 13:23:58'),(109805,346,'Pahandor','491107',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109806,346,'Pairi','491222',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109807,346,'Palari','491222',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109808,346,'Parasbod','491993',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109809,346,'Parpodi','491331',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109810,346,'Parsada','491222',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109811,346,'Patan (Durg)','491111',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109812,346,'Patora','491332',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109813,346,'Patora','491107',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109814,346,'Pauha','491221',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109815,346,'Pauwara','491107',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109816,346,'Pendrawan','491331',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109817,346,'Pendritarai','491335',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109818,346,'Pisgaon','491001',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109819,346,'Pond','491226',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109820,346,'Pratappur','491337',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109821,346,'Pulgaon Durg','491001',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109822,346,'Purai','491107',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109823,346,'Purda','491001',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109824,346,'Putpura','491340',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109825,346,'Rahud','491223',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109826,346,'Rajauli','491222',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109827,346,'Rajpur','491331',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109828,346,'Rampur','491888',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109829,346,'Ranchirai','491223',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109830,346,'Ranitarai','491223',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109831,346,'Ranka','491335',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109832,346,'Rasmara','491001',1,0,'2022-03-03 13:23:59','2022-03-03 13:23:59'),(109833,346,'Raunda','491331',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109834,346,'Risama','491221',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109835,346,'S A F Lines Bhilai','490022',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109836,346,'Sahaspur','491331',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109837,346,'Sahgaon','491771',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109838,346,'Saja','491993',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109839,346,'Saldha','491993',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109840,346,'Salhe','491228',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109841,346,'Sambalpur','491771',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109842,346,'Sambalpur','491340',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109843,346,'Sanjari','491771',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109844,346,'Sankra','491111',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109845,346,'Sankra J','491226',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109846,346,'Sanoud','491222',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109847,346,'Santra','491111',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109848,346,'Sarda','491332',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109849,346,'Sector 2 Bhilai','490001',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109850,346,'Sector 3 Bhilai','490001',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109851,346,'Sector 5 Bhilai','490006',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109852,346,'Sector 6 Bhilai','490006',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109853,346,'Sector 7 Bhilai','490006',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109854,346,'Sector 8 Bhilai','490009',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109855,346,'Selud','491107',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109856,346,'Semaria','491332',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109857,346,'Shantipur','491227',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109858,346,'Sikosa','491222',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109859,346,'Singhola','491226',1,0,'2022-03-03 13:24:00','2022-03-03 13:24:00'),(109860,346,'Sirri','491221',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109861,346,'Sirsakala','490021',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109862,346,'Smriti Nagar Bhilai','490020',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109863,346,'Sonai Dongri','491227',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109864,346,'Sondh','491332',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109865,346,'Sorar','491227',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109866,346,'Supela Bhilai','490023',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109867,346,'Surdongar','491228',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109868,346,'Surdung','490024',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109869,346,'Suregaon','491225',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109870,346,'Surpa','491223',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109871,346,'Tamora','491221',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109872,346,'Taraud','491226',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109873,346,'Tarra','491111',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109874,346,'Tarri','491227',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109875,346,'Tatenga','491771',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109876,346,'Tavera','491223',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109877,346,'Tekapar','491226',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109878,346,'Teligundra','491111',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109879,346,'Temri','491340',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109880,346,'Temri','491001',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109881,346,'Themabuzurg','491228',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109882,346,'Thengabhat','491335',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109883,346,'Tipni','491338',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109884,346,'Tirga','491225',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109885,346,'Tumakala','491001',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109886,346,'Urla','490025',1,0,'2022-03-03 13:24:01','2022-03-03 13:24:01'),(109887,346,'Utai Pedal','491107',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109888,346,'Utai','491107',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109889,346,'Vaishali Nagar Bhilai','490023',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109890,346,'Vinayakpur','491221',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109891,347,'Gohrapadar','493891',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109892,347,'Kopra','493887',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109893,348,'Adbhar','495695',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109894,348,'Afrid','495660',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109895,348,'Akaltari','495668',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109896,348,'Akoljamora','495692',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109897,348,'Amaldiha','495692',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109898,348,'Amandula','495689',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109899,348,'Amoda','495668',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109900,348,'Amora','495663',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109901,348,'Amora','495668',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109902,348,'Arjuni','495689',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109903,348,'Arjuni','495552',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109904,348,'Aurda','495689',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109905,348,'Bachhaud','495559',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109906,348,'Baghod','495692',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109907,348,'Balco Nagar Korba','495684',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109908,348,'Baloda','495559',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109909,348,'Balpur','495692',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109910,348,'Bamhni Bazar','495660',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109911,348,'Banari','495668',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109912,348,'Bandora','495695',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109913,348,'Baradwar','495687',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109914,348,'Barapipar','495692',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109915,348,'Bargawan','495552',1,0,'2022-03-03 13:24:02','2022-03-03 13:24:02'),(109916,348,'Bargawan','495554',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109917,348,'Barpalikala','495689',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109918,348,'Basantpur','495671',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109919,348,'Basin','495691',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109920,348,'Basti Baradwar','495687',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109921,348,'Bhadra','495554',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109922,348,'Bhainso','495554',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109923,348,'Bhainstara','495668',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109924,348,'Bhathali','495557',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109925,348,'Bilari','495556',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109926,348,'Birgahni','495671',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109927,348,'Birkoni','495552',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109928,348,'Birra','495661',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109929,348,'Bodsara','495668',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109930,348,'Borda','495556',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109931,348,'Budganan','495559',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109932,348,'Bundela','495556',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109933,348,'Champa R.S.','495671',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109934,348,'Champa','495671',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109935,348,'Chandrapur (Janjgir-champa)','495692',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109936,348,'Changori','495552',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109937,348,'Charoda','495695',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109938,348,'Chhotekatekoni','495688',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109939,348,'Chicholi','495671',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109940,348,'Churaghata','495688',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109941,348,'Churtela','495688',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109942,348,'Dabhra','495688',1,0,'2022-03-03 13:24:03','2022-03-03 13:24:03'),(109943,348,'Darang','495687',1,0,'2022-03-03 13:24:04','2022-03-03 13:24:04'),(109944,348,'Deorghata','495688',1,0,'2022-03-03 13:24:04','2022-03-03 13:24:04'),(109945,348,'Deori','495689',1,0,'2022-03-03 13:24:04','2022-03-03 13:24:04'),(109946,348,'Dhaneli','495668',1,0,'2022-03-03 13:24:04','2022-03-03 13:24:04'),(109947,348,'Dhania','495559',1,0,'2022-03-03 13:24:04','2022-03-03 13:24:04'),(109948,348,'Dharasiv','495668',1,0,'2022-03-03 13:24:04','2022-03-03 13:24:04'),(109949,348,'Dhardei','495556',1,0,'2022-03-03 13:24:04','2022-03-03 13:24:04'),(109950,348,'Dhurkot','495692',1,0,'2022-03-03 13:24:04','2022-03-03 13:24:04'),(109951,348,'Dhurkot','495668',1,0,'2022-03-03 13:24:04','2022-03-03 13:24:04'),(109952,348,'Dongakharod','495554',1,0,'2022-03-03 13:24:04','2022-03-03 13:24:04'),(109953,348,'Dongri','495559',1,0,'2022-03-03 13:24:04','2022-03-03 13:24:04'),(109954,348,'Dumarpara','495687',1,0,'2022-03-03 13:24:04','2022-03-03 13:24:04'),(109955,348,'Faguram','495695',1,0,'2022-03-03 13:24:04','2022-03-03 13:24:04'),(109956,348,'Faraswani','495671',1,0,'2022-03-03 13:24:04','2022-03-03 13:24:04'),(109957,348,'Faraswani','495688',1,0,'2022-03-03 13:24:04','2022-03-03 13:24:04'),(109958,348,'Gaud','495671',1,0,'2022-03-03 13:24:04','2022-03-03 13:24:04'),(109959,348,'Gharghodi','495689',1,0,'2022-03-03 13:24:04','2022-03-03 13:24:04'),(109960,348,'Girgira','495692',1,0,'2022-03-03 13:24:04','2022-03-03 13:24:04'),(109961,348,'Godhna','495556',1,0,'2022-03-03 13:24:04','2022-03-03 13:24:04'),(109962,348,'Gopalpur','495692',1,0,'2022-03-03 13:24:04','2022-03-03 13:24:04'),(109963,348,'Hardi (S)','495668',1,0,'2022-03-03 13:24:04','2022-03-03 13:24:04'),(109964,348,'Hathnewra','495671',1,0,'2022-03-03 13:24:04','2022-03-03 13:24:04'),(109965,348,'Jaijaipur','495690',1,0,'2022-03-03 13:24:04','2022-03-03 13:24:04'),(109966,348,'Jajang','495689',1,0,'2022-03-03 13:24:04','2022-03-03 13:24:04'),(109967,348,'Janjgir','495668',1,0,'2022-03-03 13:24:04','2022-03-03 13:24:04'),(109968,348,'Jarwe','495687',1,0,'2022-03-03 13:24:04','2022-03-03 13:24:04'),(109969,348,'Jarwe','495668',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109970,348,'Jawali','495692',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109971,348,'Jawalpur','495559',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109972,348,'Jharna','495687',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109973,348,'Kachanda','495556',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109974,348,'Kansa','495688',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109975,348,'Kansda','495557',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109976,348,'Kanwali','495695',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109977,348,'Kapan','495552',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109978,348,'Karainara','495671',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109979,348,'Kataud','495557',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109980,348,'Katnai','495552',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109981,348,'Katrenagar','495671',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109982,348,'Kawaljhar','495688',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109983,348,'Kera','495557',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109984,348,'Khaija','495668',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109985,348,'Khamaria','495559',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109986,348,'Kharkhod','495554',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109987,348,'Kharod','495556',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109988,348,'Khisora','495559',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109989,348,'Khisora','495556',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109990,348,'Khokhra','495668',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109991,348,'Khokhsa','495668',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109992,348,'Khondhar','495688',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109993,348,'Khorsi','495556',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109994,348,'Kirari','495695',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109995,348,'Kirari','495692',1,0,'2022-03-03 13:24:05','2022-03-03 13:24:05'),(109996,348,'Kirari','495687',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(109997,348,'Kirari','495553',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(109998,348,'Kirit','495557',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(109999,348,'Kodabhat','495554',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(110000,348,'Konar','495663',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(110001,348,'Kosa','495663',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(110002,348,'Kosir','495554',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(110003,348,'Kosla','495554',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(110004,348,'Kosmanda','495671',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(110005,348,'Kothari','495671',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(110006,348,'Kotmi','495692',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(110007,348,'Kotmisonar','495552',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(110008,348,'Kurda','495671',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(110009,348,'Kuriyari','495556',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(110010,348,'Kusmul','495695',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(110011,348,'Kuthur','495668',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(110012,348,'Kutra','495668',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(110013,348,'Latesara','495692',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(110014,348,'Lavsara','495689',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(110015,348,'Loharsi','495556',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(110016,348,'Lutra','495559',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(110017,348,'Madwa','495692',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(110018,348,'Mahant','495668',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(110019,348,'Mahuda','495559',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(110020,348,'Mahuda','495671',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(110021,348,'Malkharoda','495691',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(110022,348,'Masaniakala','495689',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(110023,348,'Meu','495554',1,0,'2022-03-03 13:24:06','2022-03-03 13:24:06'),(110024,348,'Misda','495557',1,0,'2022-03-03 13:24:07','2022-03-03 13:24:07'),(110025,348,'Muktaraja','495687',1,0,'2022-03-03 13:24:07','2022-03-03 13:24:07'),(110026,348,'Mulmula','495663',1,0,'2022-03-03 13:24:07','2022-03-03 13:24:07'),(110027,348,'Munund','495668',1,0,'2022-03-03 13:24:07','2022-03-03 13:24:07'),(110028,348,'Nagarda','495687',1,0,'2022-03-03 13:24:07','2022-03-03 13:24:07'),(110029,348,'Nandaurkala','495689',1,0,'2022-03-03 13:24:07','2022-03-03 13:24:07'),(110030,348,'Nandaurkhurd','495689',1,0,'2022-03-03 13:24:07','2022-03-03 13:24:07'),(110031,348,'Nariyara','495553',1,0,'2022-03-03 13:24:07','2022-03-03 13:24:07'),(110032,348,'Nawagarh','495557',1,0,'2022-03-03 13:24:07','2022-03-03 13:24:07'),(110033,348,'Nirtu','495559',1,0,'2022-03-03 13:24:07','2022-03-03 13:24:07'),(110034,348,'Paharia','495668',1,0,'2022-03-03 13:24:07','2022-03-03 13:24:07'),(110035,348,'Pakaria','495553',1,0,'2022-03-03 13:24:07','2022-03-03 13:24:07'),(110036,348,'Pamgarh','495554',1,0,'2022-03-03 13:24:07','2022-03-03 13:24:07'),(110037,348,'Pandania','495552',1,0,'2022-03-03 13:24:07','2022-03-03 13:24:07'),(110038,348,'Pathiapali','495671',1,0,'2022-03-03 13:24:07','2022-03-03 13:24:07'),(110039,348,'Pendarwa','495692',1,0,'2022-03-03 13:24:07','2022-03-03 13:24:07'),(110040,348,'Pendri','495668',1,0,'2022-03-03 13:24:07','2022-03-03 13:24:07'),(110041,348,'Piparsatti','495552',1,0,'2022-03-03 13:24:07','2022-03-03 13:24:07'),(110042,348,'Pisaud','495671',1,0,'2022-03-03 13:24:07','2022-03-03 13:24:07'),(110043,348,'Pithampur','495671',1,0,'2022-03-03 13:24:07','2022-03-03 13:24:07'),(110044,348,'Ponch','495559',1,0,'2022-03-03 13:24:07','2022-03-03 13:24:07'),(110045,348,'Pondidalha','495552',1,0,'2022-03-03 13:24:07','2022-03-03 13:24:07'),(110046,348,'Portha','495689',1,0,'2022-03-03 13:24:07','2022-03-03 13:24:07'),(110047,348,'Pota','495691',1,0,'2022-03-03 13:24:07','2022-03-03 13:24:07'),(110048,348,'Puchheli','495660',1,0,'2022-03-03 13:24:07','2022-03-03 13:24:07'),(110049,348,'Ragja','495689',1,0,'2022-03-03 13:24:07','2022-03-03 13:24:07'),(110050,348,'Rahod','495556',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110051,348,'Raipura','495689',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110052,348,'Rasota','495554',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110053,348,'Rasota','495559',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110054,348,'Reda','495687',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110055,348,'Reda','495692',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110056,348,'Sakarra','495689',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110057,348,'Sakreli','495688',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110058,348,'Sakreli','495687',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110059,348,'Sakti','495689',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110060,348,'Salhe','495692',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110061,348,'Salkhan','495556',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110062,348,'Sankar','495552',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110063,348,'Sapia','495695',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110064,348,'Sapos','495692',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110065,348,'Saragaon','495686',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110066,348,'Saraskela','495688',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110067,348,'Sarhar','495687',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110068,348,'Sarkhon','495668',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110069,348,'Sasha','495554',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110070,348,'Semra','495668',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110071,348,'Sendri','495689',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110072,348,'Seoni','495671',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110073,348,'Seoni','495668',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110074,348,'Seorinarayan','495557',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110075,348,'Singhansara','495689',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110076,348,'Singhitarai','495695',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110077,348,'Sirli','495554',1,0,'2022-03-03 13:24:08','2022-03-03 13:24:08'),(110078,348,'Sirli','495689',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110079,348,'Siud','495668',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110080,348,'Sohagpur','495671',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110081,348,'Sonadula','495689',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110082,348,'Sonsari','495553',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110083,348,'Sonthi','495689',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110084,348,'Sonthi','495559',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110085,348,'Sukhapali','495688',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110086,348,'Sukhda','495688',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110087,348,'Sukhrikala','495671',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110088,348,'Sukli','495668',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110089,348,'Suloni','495689',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110090,348,'Taga','495668',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110091,348,'Tanod','495556',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110092,348,'Tarod','495553',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110093,348,'Temar','495689',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110094,348,'Tilai','495668',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110095,348,'Tundri','495695',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110096,348,'Tusma','495557',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110097,348,'Umreli','495671',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110098,349,'Ankira','496245',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110099,349,'Arra','496331',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110100,349,'Asta','496330',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110101,349,'Bachhraon','496224',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110102,349,'Bada Karonja','496338',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110103,349,'Bagbahar','496220',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110104,349,'Bagicha','496224',1,0,'2022-03-03 13:24:09','2022-03-03 13:24:09'),(110105,349,'Bahma','496220',1,0,'2022-03-03 13:24:10','2022-03-03 13:24:10'),(110106,349,'Bahora','496336',1,0,'2022-03-03 13:24:10','2022-03-03 13:24:10'),(110107,349,'Bairagi','496118',1,0,'2022-03-03 13:24:10','2022-03-03 13:24:10'),(110108,349,'Bakaruma','496118',1,0,'2022-03-03 13:24:10','2022-03-03 13:24:10'),(110109,349,'Bandrachuwan','496223',1,0,'2022-03-03 13:24:10','2022-03-03 13:24:10'),(110110,349,'Bangurkela','496334',1,0,'2022-03-03 13:24:10','2022-03-03 13:24:10'),(110111,349,'Barangjore','496225',1,0,'2022-03-03 13:24:10','2022-03-03 13:24:10'),(110112,349,'Basantala','496334',1,0,'2022-03-03 13:24:10','2022-03-03 13:24:10'),(110113,349,'Basnajhal','496245',1,0,'2022-03-03 13:24:10','2022-03-03 13:24:10'),(110114,349,'Bataikela','496223',1,0,'2022-03-03 13:24:10','2022-03-03 13:24:10'),(110115,349,'Behrakhar','496225',1,0,'2022-03-03 13:24:10','2022-03-03 13:24:10'),(110116,349,'Bhagora','496242',1,0,'2022-03-03 13:24:10','2022-03-03 13:24:10'),(110117,349,'Bhelwan','496245',1,0,'2022-03-03 13:24:10','2022-03-03 13:24:10'),(110118,349,'Bhimsela','496330',1,0,'2022-03-03 13:24:10','2022-03-03 13:24:10'),(110119,349,'Bhitgara','496224',1,0,'2022-03-03 13:24:10','2022-03-03 13:24:10'),(110120,349,'Bimda','496224',1,0,'2022-03-03 13:24:10','2022-03-03 13:24:10'),(110121,349,'Buldega','496220',1,0,'2022-03-03 13:24:10','2022-03-03 13:24:10'),(110122,349,'Champakhudia','496336',1,0,'2022-03-03 13:24:10','2022-03-03 13:24:10'),(110123,349,'Charaidand','496334',1,0,'2022-03-03 13:24:10','2022-03-03 13:24:10'),(110124,349,'Chetba','496223',1,0,'2022-03-03 13:24:10','2022-03-03 13:24:10'),(110125,349,'Chheraghoghar','496223',1,0,'2022-03-03 13:24:10','2022-03-03 13:24:10'),(110126,349,'Chiknipani','496220',1,0,'2022-03-03 13:24:10','2022-03-03 13:24:10'),(110127,349,'Chongaribahar','496223',1,0,'2022-03-03 13:24:10','2022-03-03 13:24:10'),(110128,349,'Dandadih','496334',1,0,'2022-03-03 13:24:10','2022-03-03 13:24:10'),(110129,349,'Deori','496223',1,0,'2022-03-03 13:24:10','2022-03-03 13:24:10'),(110130,349,'Diwanpur','496118',1,0,'2022-03-03 13:24:10','2022-03-03 13:24:10'),(110131,349,'Dobh','496336',1,0,'2022-03-03 13:24:11','2022-03-03 13:24:11'),(110132,349,'Dokra','496223',1,0,'2022-03-03 13:24:11','2022-03-03 13:24:11'),(110133,349,'Duldula','496334',1,0,'2022-03-03 13:24:11','2022-03-03 13:24:11'),(110134,349,'Dumaria','496245',1,0,'2022-03-03 13:24:11','2022-03-03 13:24:11'),(110135,349,'Dumarkona','496336',1,0,'2022-03-03 13:24:11','2022-03-03 13:24:11'),(110136,349,'Durgapara','496224',1,0,'2022-03-03 13:24:11','2022-03-03 13:24:11'),(110137,349,'Ekamba','496336',1,0,'2022-03-03 13:24:11','2022-03-03 13:24:11'),(110138,349,'Farsatoli','496220',1,0,'2022-03-03 13:24:11','2022-03-03 13:24:11'),(110139,349,'Gajma','496330',1,0,'2022-03-03 13:24:11','2022-03-03 13:24:11'),(110140,349,'Gala','497118',1,0,'2022-03-03 13:24:11','2022-03-03 13:24:11'),(110141,349,'Gamharia','496331',1,0,'2022-03-03 13:24:11','2022-03-03 13:24:11'),(110142,349,'Ghaghra','496330',1,0,'2022-03-03 13:24:11','2022-03-03 13:24:11'),(110143,349,'Gharjiabandhan','496118',1,0,'2022-03-03 13:24:11','2022-03-03 13:24:11'),(110144,349,'Ghatmunda','496225',1,0,'2022-03-03 13:24:11','2022-03-03 13:24:11'),(110145,349,'Ghoghar','496223',1,0,'2022-03-03 13:24:11','2022-03-03 13:24:11'),(110146,349,'Gholeng','496338',1,0,'2022-03-03 13:24:11','2022-03-03 13:24:11'),(110147,349,'Ghughari','496224',1,0,'2022-03-03 13:24:11','2022-03-03 13:24:11'),(110148,349,'Ginabahar','496225',1,0,'2022-03-03 13:24:11','2022-03-03 13:24:11'),(110149,349,'Gorea','496225',1,0,'2022-03-03 13:24:11','2022-03-03 13:24:11'),(110150,349,'Harradand','496225',1,0,'2022-03-03 13:24:11','2022-03-03 13:24:11'),(110151,349,'Harri','496330',1,0,'2022-03-03 13:24:11','2022-03-03 13:24:11'),(110152,349,'Ichkela','496331',1,0,'2022-03-03 13:24:11','2022-03-03 13:24:11'),(110153,349,'Irai','496330',1,0,'2022-03-03 13:24:11','2022-03-03 13:24:11'),(110154,349,'Jaikari','496334',1,0,'2022-03-03 13:24:11','2022-03-03 13:24:11'),(110155,349,'Jamargi','496220',1,0,'2022-03-03 13:24:11','2022-03-03 13:24:11'),(110156,349,'Jambahar','496227',1,0,'2022-03-03 13:24:11','2022-03-03 13:24:11'),(110157,349,'Jamchuwan','496225',1,0,'2022-03-03 13:24:12','2022-03-03 13:24:12'),(110158,349,'Jamjhor','496220',1,0,'2022-03-03 13:24:12','2022-03-03 13:24:12'),(110159,349,'Jaria','496331',1,0,'2022-03-03 13:24:12','2022-03-03 13:24:12'),(110160,349,'Jashpurnagar','496331',1,0,'2022-03-03 13:24:12','2022-03-03 13:24:12'),(110161,349,'Jhinki','496224',1,0,'2022-03-03 13:24:12','2022-03-03 13:24:12'),(110162,349,'Jokbahla','496225',1,0,'2022-03-03 13:24:12','2022-03-03 13:24:12'),(110163,349,'Jumaikela','496223',1,0,'2022-03-03 13:24:12','2022-03-03 13:24:12'),(110164,349,'Kadro','496220',1,0,'2022-03-03 13:24:12','2022-03-03 13:24:12'),(110165,349,'Kalaru','496331',1,0,'2022-03-03 13:24:12','2022-03-03 13:24:12'),(110166,349,'Kaliba','496225',1,0,'2022-03-03 13:24:12','2022-03-03 13:24:12'),(110167,349,'Kamarima','496336',1,0,'2022-03-03 13:24:12','2022-03-03 13:24:12'),(110168,349,'Kandaibahar','496227',1,0,'2022-03-03 13:24:12','2022-03-03 13:24:12'),(110169,349,'Kandora','496225',1,0,'2022-03-03 13:24:12','2022-03-03 13:24:12'),(110170,349,'Kansabel','496223',1,0,'2022-03-03 13:24:12','2022-03-03 13:24:12'),(110171,349,'Kapu','496118',1,0,'2022-03-03 13:24:12','2022-03-03 13:24:12'),(110172,349,'Karadari','496330',1,0,'2022-03-03 13:24:12','2022-03-03 13:24:12'),(110173,349,'Karma','496224',1,0,'2022-03-03 13:24:12','2022-03-03 13:24:12'),(110174,349,'Karmitikra','496118',1,0,'2022-03-03 13:24:12','2022-03-03 13:24:12'),(110175,349,'Kasira','496331',1,0,'2022-03-03 13:24:12','2022-03-03 13:24:12'),(110176,349,'Kastura','496334',1,0,'2022-03-03 13:24:12','2022-03-03 13:24:12'),(110177,349,'Kawai','496336',1,0,'2022-03-03 13:24:12','2022-03-03 13:24:12'),(110178,349,'Keradih','496334',1,0,'2022-03-03 13:24:12','2022-03-03 13:24:12'),(110179,349,'Kerju','496223',1,0,'2022-03-03 13:24:12','2022-03-03 13:24:12'),(110180,349,'Kersai','496227',1,0,'2022-03-03 13:24:12','2022-03-03 13:24:12'),(110181,349,'Kesra','496330',1,0,'2022-03-03 13:24:12','2022-03-03 13:24:12'),(110182,349,'Kharsouna','496331',1,0,'2022-03-03 13:24:12','2022-03-03 13:24:12'),(110183,349,'Khutera','496223',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110184,349,'Khutgaon','496242',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110185,349,'Kilkila','496118',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110186,349,'Kokiakhar','496220',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110187,349,'Kolhejharia','496220',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110188,349,'Komdo','496331',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110189,349,'Konpara','496245',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110190,349,'Kotba','496220',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110191,349,'Kukurbhaka','496220',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110192,349,'Kukurgaon','496220',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110193,349,'Kumarta','496118',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110194,349,'Kunjara','496225',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110195,349,'Kunkuri','496225',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110196,349,'Kurdeg','496224',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110197,349,'Kurkunga','496225',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110198,349,'Kurrog','496224',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110199,349,'Lathbora','496227',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110200,349,'Lawakera','496245',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110201,349,'Lodam','496338',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110202,349,'Lodhma','496225',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110203,349,'Lokhandi','496338',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110204,349,'Ludeg','496220',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110205,349,'Lukhi','496330',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110206,349,'Makribandha','496334',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110207,349,'Manora (Jashpur)','496330',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110208,349,'Marol','496224',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110209,349,'Menderbahar','496242',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110210,349,'Musgutri','496224',1,0,'2022-03-03 13:24:13','2022-03-03 13:24:13'),(110211,349,'Nakbar','496223',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110212,349,'Nanhesar','496336',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110213,349,'Narayanpur','496225',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110214,349,'Nariyaradand','496223',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110215,349,'Paiku','496338',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110216,349,'Pakargaon','496118',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110217,349,'Palidih','496118',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110218,349,'Pandaripani','496242',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110219,349,'Pandaripani','496220',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110220,349,'Pandrapath','496336',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110221,349,'Pangsuwa','496220',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110222,349,'Pasia','496224',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110223,349,'Pathalgoan','496118',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110224,349,'Patratoli','496338',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110225,349,'Patratoli','496334',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110226,349,'Pilkhi','496338',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110227,349,'Pirai','496224',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110228,349,'Pongro','496223',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110229,349,'Portenga','496338',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110230,349,'Purainbandha','496227',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110231,349,'Raikera','496224',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110232,349,'Raikera','496225',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110233,349,'Raimer','496118',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110234,349,'Ranpur','496225',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110235,349,'Rauni','496224',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110236,349,'Rengle','496224',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110237,349,'Sahaspur','496242',1,0,'2022-03-03 13:24:14','2022-03-03 13:24:14'),(110238,349,'Sajapani','496223',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110239,349,'Sangibhawna','496223',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110240,349,'Sanna','496336',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110241,349,'Sarabkombo','496224',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110242,349,'Saraipani','496223',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110243,349,'Saraitoli','496336',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110244,349,'Sardhapath','496336',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110245,349,'Saskoba','496118',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110246,349,'Sekharpur','496220',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110247,349,'Semarkachar','496223',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110248,349,'Simda','496334',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110249,349,'Singibahar','496227',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110250,349,'Sitonga','496331',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110251,349,'Sogada','496331',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110252,349,'Sonkyari','496336',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110253,349,'Sonpur','496118',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110254,349,'Sukrapara','496118',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110255,349,'Sulesha','496336',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110256,349,'Supkalo','496118',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110257,349,'Sureshpur','496118',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110258,349,'Tamta','496118',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110259,349,'Tapkara','496227',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110260,349,'Tildega','496118',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110261,349,'Tumla','496245',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110262,349,'Vijaynagar','496118',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110263,350,'Abhanpur','494335',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110264,350,'Amoda','494333',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110265,350,'Amodi','494665',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110266,350,'Antagarh','494665',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110267,350,'Anwari','494337',1,0,'2022-03-03 13:24:15','2022-03-03 13:24:15'),(110268,350,'Aridongri','494635',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110269,350,'Asulkhar','494669',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110270,350,'Aturgaon','494334',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110271,350,'Badal','494333',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110272,350,'Badejharkatta','494771',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110273,350,'Badgaon','494771',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110274,350,'Bagodar','494334',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110275,350,'Baijanpuri','494670',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110276,350,'Bandecolony','494777',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110277,350,'Barda','494776',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110278,350,'Bewarti','494334',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110279,350,'Bhainsakanhar','494670',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110280,350,'Bhainsasur','494665',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110281,350,'Bhanbeda','494670',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110282,350,'Bhansuli','494333',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110283,350,'Bhanupratappur','494669',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110284,350,'Bhilai','494337',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110285,350,'Bhiragaon','494669',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110286,350,'Bondanar','494665',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110287,350,'Budeli','494335',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110288,350,'Charama','494337',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110289,350,'Charbhata','494337',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110290,350,'Chargaon','494665',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110291,350,'Chawad','494334',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110292,350,'Chinauri','494336',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110293,350,'Chiprel','494334',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110294,350,'Chotekapsi','494771',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110295,350,'Dabena','494333',1,0,'2022-03-03 13:24:16','2022-03-03 13:24:16'),(110296,350,'Damkasa','494635',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110297,350,'Dangra','494669',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110298,350,'Deori','494334',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110299,350,'Devinawagaon','494333',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110300,350,'Dhanelikanhar','494670',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110301,350,'Dhanesara','494335',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110302,350,'Dokla','494337',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110303,350,'Donde','494771',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110304,350,'Dudhawa','494335',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110305,350,'Dumali','494334',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110306,350,'Dumarpani','494333',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110307,350,'Durgkondal','494669',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110308,350,'Erpanar','494777',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110309,350,'Esebeda','494776',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110310,350,'Geetpahar','494333',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110311,350,'Gondahoor','494776',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110312,350,'Govindpur','494334',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110313,350,'Gudabeda','494665',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110314,350,'Gurwandi','494771',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110315,350,'Hanker','494776',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110316,350,'Haradula','494336',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110317,350,'Hatkarra','494670',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110318,350,'Hatkondal','494635',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110319,350,'Hatkongera','494334',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110320,350,'Hurtarai','494665',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110321,350,'Jaisakarra','494337',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110322,350,'Jamgaon','494333',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110323,350,'Jepra','494336',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110324,350,'Jodekursi','494635',1,0,'2022-03-03 13:24:17','2022-03-03 13:24:17'),(110325,350,'Junwani','494334',1,0,'2022-03-03 13:24:18','2022-03-03 13:24:18'),(110326,350,'Junwani','494337',1,0,'2022-03-03 13:24:18','2022-03-03 13:24:18'),(110327,350,'Kamta','494665',1,0,'2022-03-03 13:24:18','2022-03-03 13:24:18'),(110328,350,'Kanharpuri','494670',1,0,'2022-03-03 13:24:18','2022-03-03 13:24:18'),(110329,350,'Kanker H.O','494334',1,0,'2022-03-03 13:24:18','2022-03-03 13:24:18'),(110330,350,'Kanker Kutchery','494334',1,0,'2022-03-03 13:24:18','2022-03-03 13:24:18'),(110331,350,'Karaki','494669',1,0,'2022-03-03 13:24:18','2022-03-03 13:24:18'),(110332,350,'Karmoti','494635',1,0,'2022-03-03 13:24:18','2022-03-03 13:24:18'),(110333,350,'Kewti','494669',1,0,'2022-03-03 13:24:18','2022-03-03 13:24:18'),(110334,350,'Khairkatta','494771',1,0,'2022-03-03 13:24:18','2022-03-03 13:24:18'),(110335,350,'Khairkeda','494336',1,0,'2022-03-03 13:24:18','2022-03-03 13:24:18'),(110336,350,'Khartha','494336',1,0,'2022-03-03 13:24:18','2022-03-03 13:24:18'),(110337,350,'Kishanpuri','494333',1,0,'2022-03-03 13:24:18','2022-03-03 13:24:18'),(110338,350,'Kodagaon','494670',1,0,'2022-03-03 13:24:18','2022-03-03 13:24:18'),(110339,350,'Kodapakha','494669',1,0,'2022-03-03 13:24:18','2022-03-03 13:24:18'),(110340,350,'Kodekurse','494669',1,0,'2022-03-03 13:24:18','2022-03-03 13:24:18'),(110341,350,'Kodosalhebhat','494665',1,0,'2022-03-03 13:24:18','2022-03-03 13:24:18'),(110342,350,'Kokpur','494334',1,0,'2022-03-03 13:24:18','2022-03-03 13:24:18'),(110343,350,'Kolar','494665',1,0,'2022-03-03 13:24:18','2022-03-03 13:24:18'),(110344,350,'Koliyari','494337',1,0,'2022-03-03 13:24:18','2022-03-03 13:24:18'),(110345,350,'Korar','494670',1,0,'2022-03-03 13:24:18','2022-03-03 13:24:18'),(110346,350,'Kotalbhatti','494335',1,0,'2022-03-03 13:24:18','2022-03-03 13:24:18'),(110347,350,'Kotela','494336',1,0,'2022-03-03 13:24:18','2022-03-03 13:24:18'),(110348,350,'Kottara','494670',1,0,'2022-03-03 13:24:18','2022-03-03 13:24:18'),(110349,350,'Koyalibeda','494665',1,0,'2022-03-03 13:24:18','2022-03-03 13:24:18'),(110350,350,'Kulhadkatta','494669',1,0,'2022-03-03 13:24:19','2022-03-03 13:24:19'),(110351,350,'Kurenar','494777',1,0,'2022-03-03 13:24:19','2022-03-03 13:24:19'),(110352,350,'Kurrutola','494337',1,0,'2022-03-03 13:24:19','2022-03-03 13:24:19'),(110353,350,'Lakhanpuri','494336',1,0,'2022-03-03 13:24:19','2022-03-03 13:24:19'),(110354,350,'Largaon Markatola','494335',1,0,'2022-03-03 13:24:19','2022-03-03 13:24:19'),(110355,350,'Lilejhar','494337',1,0,'2022-03-03 13:24:19','2022-03-03 13:24:19'),(110356,350,'Lohattar','494635',1,0,'2022-03-03 13:24:19','2022-03-03 13:24:19'),(110357,350,'Makdisingrai','494334',1,0,'2022-03-03 13:24:19','2022-03-03 13:24:19'),(110358,350,'Manpur','494334',1,0,'2022-03-03 13:24:19','2022-03-03 13:24:19'),(110359,350,'Mardapoti','494334',1,0,'2022-03-03 13:24:19','2022-03-03 13:24:19'),(110360,350,'Markatola','494670',1,0,'2022-03-03 13:24:19','2022-03-03 13:24:19'),(110361,350,'Maroda','494777',1,0,'2022-03-03 13:24:19','2022-03-03 13:24:19'),(110362,350,'Marwadi','494333',1,0,'2022-03-03 13:24:19','2022-03-03 13:24:19'),(110363,350,'Mavlipara','494335',1,0,'2022-03-03 13:24:19','2022-03-03 13:24:19'),(110364,350,'Michgaon Sadhu','494669',1,0,'2022-03-03 13:24:19','2022-03-03 13:24:19'),(110365,350,'Mixesed Form','494776',1,0,'2022-03-03 13:24:19','2022-03-03 13:24:19'),(110366,350,'Mode','494670',1,0,'2022-03-03 13:24:19','2022-03-03 13:24:19'),(110367,350,'Murdongri','494334',1,0,'2022-03-03 13:24:19','2022-03-03 13:24:19'),(110368,350,'Murvend','494334',1,0,'2022-03-03 13:24:19','2022-03-03 13:24:19'),(110369,350,'Nagaldand','494777',1,0,'2022-03-03 13:24:19','2022-03-03 13:24:19'),(110370,350,'Narharpur','494333',1,0,'2022-03-03 13:24:19','2022-03-03 13:24:19'),(110371,350,'Nathianawagaon','494336',1,0,'2022-03-03 13:24:19','2022-03-03 13:24:19'),(110372,350,'Nedgaon','494771',1,0,'2022-03-03 13:24:19','2022-03-03 13:24:19'),(110373,350,'Padenga','494777',1,0,'2022-03-03 13:24:19','2022-03-03 13:24:19'),(110374,350,'Pakhanjore Camp','494776',1,0,'2022-03-03 13:24:19','2022-03-03 13:24:19'),(110375,350,'Panidober','494665',1,0,'2022-03-03 13:24:20','2022-03-03 13:24:20'),(110376,350,'Panwar','494777',1,0,'2022-03-03 13:24:20','2022-03-03 13:24:20'),(110377,350,'Parsoda','494670',1,0,'2022-03-03 13:24:20','2022-03-03 13:24:20'),(110378,350,'Pataud','494334',1,0,'2022-03-03 13:24:20','2022-03-03 13:24:20'),(110379,350,'Pidapal','494334',1,0,'2022-03-03 13:24:20','2022-03-03 13:24:20'),(110380,350,'Pondgaon','494665',1,0,'2022-03-03 13:24:20','2022-03-03 13:24:20'),(110381,350,'Potgaon','494670',1,0,'2022-03-03 13:24:20','2022-03-03 13:24:20'),(110382,350,'Pratappur','494776',1,0,'2022-03-03 13:24:20','2022-03-03 13:24:20'),(110383,350,'Puri','494337',1,0,'2022-03-03 13:24:20','2022-03-03 13:24:20'),(110384,350,'Puswada','494334',1,0,'2022-03-03 13:24:20','2022-03-03 13:24:20'),(110385,350,'PV-15','494776',1,0,'2022-03-03 13:24:20','2022-03-03 13:24:20'),(110386,350,'PV-26','494776',1,0,'2022-03-03 13:24:20','2022-03-03 13:24:20'),(110387,350,'PV-38','494776',1,0,'2022-03-03 13:24:20','2022-03-03 13:24:20'),(110388,350,'PV-9','494776',1,0,'2022-03-03 13:24:20','2022-03-03 13:24:20'),(110389,350,'PV-92','494777',1,0,'2022-03-03 13:24:20','2022-03-03 13:24:20'),(110390,350,'Rengawahi','494777',1,0,'2022-03-03 13:24:20','2022-03-03 13:24:20'),(110391,350,'Sahawada','494336',1,0,'2022-03-03 13:24:20','2022-03-03 13:24:20'),(110392,350,'Salhe','494635',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110393,350,'Sambalpur','494635',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110394,350,'Samtara','494335',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110395,350,'Sangam','494776',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110396,350,'Sarandi','494665',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110397,350,'Sarona','494335',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110398,350,'Sarwandi','494335',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110399,350,'Selegaon','494670',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110400,350,'Sidhesar','494334',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110401,350,'Siksod','494665',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110402,350,'Sureli','494670',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110403,350,'Tadoki','494665',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110404,350,'Talakurra','494670',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110405,350,'Tarandul','494670',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110406,350,'Tarasgaon','494336',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110407,350,'Tarhul','494635',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110408,350,'Tekameta','494777',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110409,350,'Thema','494335',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110410,350,'Traighotiya','494635',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110411,350,'Tuyegahan','494336',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110412,350,'Udkuda','494336',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110413,350,'Umradah','494334',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110414,350,'Vyas Kongera','494334',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110415,351,'Bagharra','491559',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110416,351,'Baijalpur','491995',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110417,351,'Bamhani','491336',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110418,351,'Bharewa','491559',1,0,'2022-03-03 13:24:21','2022-03-03 13:24:21'),(110419,351,'Bodla','491995',1,0,'2022-03-03 13:24:22','2022-03-03 13:24:22'),(110420,351,'Bodtarakhurd','491559',1,0,'2022-03-03 13:24:22','2022-03-03 13:24:22'),(110421,351,'Chachedi','491336',1,0,'2022-03-03 13:24:22','2022-03-03 13:24:22'),(110422,351,'Charbhata','491336',1,0,'2022-03-03 13:24:22','2022-03-03 13:24:22'),(110423,351,'Chilfi','491995',1,0,'2022-03-03 13:24:22','2022-03-03 13:24:22'),(110424,351,'Daihandih','491995',1,0,'2022-03-03 13:24:22','2022-03-03 13:24:22'),(110425,351,'Damapur','491559',1,0,'2022-03-03 13:24:22','2022-03-03 13:24:22'),(110426,351,'Dashrangpur','491336',1,0,'2022-03-03 13:24:22','2022-03-03 13:24:22'),(110427,351,'Dhamramura','491995',1,0,'2022-03-03 13:24:22','2022-03-03 13:24:22'),(110428,351,'Dharamgarh','491336',1,0,'2022-03-03 13:24:22','2022-03-03 13:24:22'),(110429,351,'Dullapur','491559',1,0,'2022-03-03 13:24:22','2022-03-03 13:24:22'),(110430,351,'Gaurmati','491995',1,0,'2022-03-03 13:24:22','2022-03-03 13:24:22'),(110431,351,'Ghovghatti','491559',1,0,'2022-03-03 13:24:22','2022-03-03 13:24:22'),(110432,351,'Gochia','491336',1,0,'2022-03-03 13:24:22','2022-03-03 13:24:22'),(110433,351,'Goodha','491336',1,0,'2022-03-03 13:24:22','2022-03-03 13:24:22'),(110434,351,'Gorakhpurkala','491336',1,0,'2022-03-03 13:24:22','2022-03-03 13:24:22'),(110435,351,'Indori','491336',1,0,'2022-03-03 13:24:22','2022-03-03 13:24:22'),(110436,351,'Jhironi','491336',1,0,'2022-03-03 13:24:22','2022-03-03 13:24:22'),(110437,351,'Junwani','491995',1,0,'2022-03-03 13:24:22','2022-03-03 13:24:22'),(110438,351,'Kamthee','491559',1,0,'2022-03-03 13:24:22','2022-03-03 13:24:22'),(110439,351,'Kawardha Collectorate','491995',1,0,'2022-03-03 13:24:22','2022-03-03 13:24:22'),(110440,351,'Kawardha','491995',1,0,'2022-03-03 13:24:22','2022-03-03 13:24:22'),(110441,351,'Khairbana','491995',1,0,'2022-03-03 13:24:22','2022-03-03 13:24:22'),(110442,351,'Khairhatta','491995',1,0,'2022-03-03 13:24:22','2022-03-03 13:24:22'),(110443,351,'Khairjhiti','491559',1,0,'2022-03-03 13:24:22','2022-03-03 13:24:22'),(110444,351,'Kisungarh','491559',1,0,'2022-03-03 13:24:22','2022-03-03 13:24:22'),(110445,351,'Kodwagodan','491559',1,0,'2022-03-03 13:24:23','2022-03-03 13:24:23'),(110446,351,'Koko','491336',1,0,'2022-03-03 13:24:23','2022-03-03 13:24:23'),(110447,351,'Kolhegaon','491559',1,0,'2022-03-03 13:24:23','2022-03-03 13:24:23'),(110448,351,'Koylari','491995',1,0,'2022-03-03 13:24:23','2022-03-03 13:24:23'),(110449,351,'Kukdur','491559',1,0,'2022-03-03 13:24:23','2022-03-03 13:24:23'),(110450,351,'Kunda','491559',1,0,'2022-03-03 13:24:23','2022-03-03 13:24:23'),(110451,351,'Madmada','491995',1,0,'2022-03-03 13:24:23','2022-03-03 13:24:23'),(110452,351,'Mahali','491559',1,0,'2022-03-03 13:24:23','2022-03-03 13:24:23'),(110453,351,'Maharjpur','491995',1,0,'2022-03-03 13:24:23','2022-03-03 13:24:23'),(110454,351,'Marka','491336',1,0,'2022-03-03 13:24:23','2022-03-03 13:24:23'),(110455,351,'Mohgaon','491559',1,0,'2022-03-03 13:24:23','2022-03-03 13:24:23'),(110456,351,'Munmuna','491559',1,0,'2022-03-03 13:24:23','2022-03-03 13:24:23'),(110457,351,'Nanapuri','491559',1,0,'2022-03-03 13:24:23','2022-03-03 13:24:23'),(110458,351,'Neur','491559',1,0,'2022-03-03 13:24:23','2022-03-03 13:24:23'),(110459,351,'Neurgaon','491995',1,0,'2022-03-03 13:24:23','2022-03-03 13:24:23'),(110460,351,'Odiakhurd','491995',1,0,'2022-03-03 13:24:23','2022-03-03 13:24:23'),(110461,351,'Palami','491559',1,0,'2022-03-03 13:24:23','2022-03-03 13:24:23'),(110462,351,'Palanagari','491559',1,0,'2022-03-03 13:24:23','2022-03-03 13:24:23'),(110463,351,'Pandaria','491559',1,0,'2022-03-03 13:24:23','2022-03-03 13:24:23'),(110464,351,'Pandatarai','491559',1,0,'2022-03-03 13:24:23','2022-03-03 13:24:23'),(110465,351,'Piparia','491995',1,0,'2022-03-03 13:24:23','2022-03-03 13:24:23'),(110466,351,'Pondi','491995',1,0,'2022-03-03 13:24:23','2022-03-03 13:24:23'),(110467,351,'Rajanawagaon','491995',1,0,'2022-03-03 13:24:23','2022-03-03 13:24:23'),(110468,351,'Rakse','491995',1,0,'2022-03-03 13:24:23','2022-03-03 13:24:23'),(110469,351,'Ramhepur','491995',1,0,'2022-03-03 13:24:23','2022-03-03 13:24:23'),(110470,351,'Ranjitpur','491995',1,0,'2022-03-03 13:24:24','2022-03-03 13:24:24'),(110471,351,'Ranvirpur','491995',1,0,'2022-03-03 13:24:24','2022-03-03 13:24:24'),(110472,351,'Raveli','491995',1,0,'2022-03-03 13:24:24','2022-03-03 13:24:24'),(110473,351,'Ruse','491559',1,0,'2022-03-03 13:24:24','2022-03-03 13:24:24'),(110474,351,'Sahaspur Lohara','491995',1,0,'2022-03-03 13:24:24','2022-03-03 13:24:24'),(110475,351,'Sarangpurkhurd','491995',1,0,'2022-03-03 13:24:24','2022-03-03 13:24:24'),(110476,351,'Sehamalgi','491559',1,0,'2022-03-03 13:24:24','2022-03-03 13:24:24'),(110477,351,'Silhati','491995',1,0,'2022-03-03 13:24:24','2022-03-03 13:24:24'),(110478,351,'Singangarh','491995',1,0,'2022-03-03 13:24:24','2022-03-03 13:24:24'),(110479,351,'Sonbarsa','491995',1,0,'2022-03-03 13:24:24','2022-03-03 13:24:24'),(110480,351,'Sonpuri','491995',1,0,'2022-03-03 13:24:24','2022-03-03 13:24:24'),(110481,351,'Surajpura','491995',1,0,'2022-03-03 13:24:24','2022-03-03 13:24:24'),(110482,352,'Ajgarbahar','495684',1,0,'2022-03-03 13:24:24','2022-03-03 13:24:24'),(110483,352,'Akalsara','495690',1,0,'2022-03-03 13:24:24','2022-03-03 13:24:24'),(110484,352,'Amgaon','495690',1,0,'2022-03-03 13:24:24','2022-03-03 13:24:24'),(110485,352,'Amlidih','495691',1,0,'2022-03-03 13:24:24','2022-03-03 13:24:24'),(110486,352,'Bade Rabeli','495691',1,0,'2022-03-03 13:24:24','2022-03-03 13:24:24'),(110487,352,'Bade Seepat','495691',1,0,'2022-03-03 13:24:24','2022-03-03 13:24:24'),(110488,352,'Bagrad','495118',1,0,'2022-03-03 13:24:24','2022-03-03 13:24:24'),(110489,352,'Baksahi','495449',1,0,'2022-03-03 13:24:24','2022-03-03 13:24:24'),(110490,352,'Balgi Project Korba','495455',1,0,'2022-03-03 13:24:24','2022-03-03 13:24:24'),(110491,352,'Bango Dam','495448',1,0,'2022-03-03 13:24:25','2022-03-03 13:24:25'),(110492,352,'Banjhiban','495445',1,0,'2022-03-03 13:24:25','2022-03-03 13:24:25'),(110493,352,'Banki Mongra','495447',1,0,'2022-03-03 13:24:25','2022-03-03 13:24:25'),(110494,352,'Bansital','495118',1,0,'2022-03-03 13:24:25','2022-03-03 13:24:25'),(110495,352,'Barpali (J)','495674',1,0,'2022-03-03 13:24:25','2022-03-03 13:24:25'),(110496,352,'Barpali (S)','495674',1,0,'2022-03-03 13:24:25','2022-03-03 13:24:25'),(110497,352,'Batra','495449',1,0,'2022-03-03 13:24:25','2022-03-03 13:24:25'),(110498,352,'Beharchuwa','495674',1,0,'2022-03-03 13:24:25','2022-03-03 13:24:25'),(110499,352,'Beladula','495690',1,0,'2022-03-03 13:24:25','2022-03-03 13:24:25'),(110500,352,'Beljhiria','495118',1,0,'2022-03-03 13:24:25','2022-03-03 13:24:25'),(110501,352,'Beltara','495449',1,0,'2022-03-03 13:24:25','2022-03-03 13:24:25'),(110502,352,'Bhairotal','495454',1,0,'2022-03-03 13:24:25','2022-03-03 13:24:25'),(110503,352,'Bhaisma','495674',1,0,'2022-03-03 13:24:25','2022-03-03 13:24:25'),(110504,352,'Bharridand','495118',1,0,'2022-03-03 13:24:25','2022-03-03 13:24:25'),(110505,352,'Bhilaibazar','495454',1,0,'2022-03-03 13:24:25','2022-03-03 13:24:25'),(110506,352,'Bhothia','495690',1,0,'2022-03-03 13:24:25','2022-03-03 13:24:25'),(110507,352,'Binjhra','495445',1,0,'2022-03-03 13:24:25','2022-03-03 13:24:25'),(110508,352,'Birda','495446',1,0,'2022-03-03 13:24:25','2022-03-03 13:24:25'),(110509,352,'Boida','495446',1,0,'2022-03-03 13:24:25','2022-03-03 13:24:25'),(110510,352,'Bundeli','495683',1,0,'2022-03-03 13:24:25','2022-03-03 13:24:25'),(110511,352,'Chachia','495674',1,0,'2022-03-03 13:24:26','2022-03-03 13:24:26'),(110512,352,'Chadhedi','495118',1,0,'2022-03-03 13:24:26','2022-03-03 13:24:26'),(110513,352,'Chainpur','495446',1,0,'2022-03-03 13:24:26','2022-03-03 13:24:26'),(110514,352,'Chaitma','495449',1,0,'2022-03-03 13:24:26','2022-03-03 13:24:26'),(110515,352,'Champa','495674',1,0,'2022-03-03 13:24:26','2022-03-03 13:24:26'),(110516,352,'Charpara','495691',1,0,'2022-03-03 13:24:26','2022-03-03 13:24:26'),(110517,352,'Chhapora','495691',1,0,'2022-03-03 13:24:26','2022-03-03 13:24:26'),(110518,352,'Chhuri','495450',1,0,'2022-03-03 13:24:26','2022-03-03 13:24:26'),(110519,352,'Chiknipali','495674',1,0,'2022-03-03 13:24:26','2022-03-03 13:24:26'),(110520,352,'Chirra','495674',1,0,'2022-03-03 13:24:26','2022-03-03 13:24:26'),(110521,352,'Chorbhatti','495674',1,0,'2022-03-03 13:24:26','2022-03-03 13:24:26'),(110522,352,'Choria','495686',1,0,'2022-03-03 13:24:26','2022-03-03 13:24:26'),(110523,352,'Dadarkala','495674',1,0,'2022-03-03 13:24:26','2022-03-03 13:24:26'),(110524,352,'Dadarkhurd','495682',1,0,'2022-03-03 13:24:26','2022-03-03 13:24:26'),(110525,352,'Darrabhatha','495445',1,0,'2022-03-03 13:24:26','2022-03-03 13:24:26'),(110526,352,'Deepika Project Korba','495452',1,0,'2022-03-03 13:24:26','2022-03-03 13:24:26'),(110527,352,'Dhelwadih','495445',1,0,'2022-03-03 13:24:26','2022-03-03 13:24:26'),(110528,352,'Durpa','495454',1,0,'2022-03-03 13:24:26','2022-03-03 13:24:26'),(110529,352,'Garh Uproda','495684',1,0,'2022-03-03 13:24:26','2022-03-03 13:24:26'),(110530,352,'Gatwa','495446',1,0,'2022-03-03 13:24:26','2022-03-03 13:24:26'),(110531,352,'Gerwa','495450',1,0,'2022-03-03 13:24:27','2022-03-03 13:24:27'),(110532,352,'Gevra Basti','495454',1,0,'2022-03-03 13:24:27','2022-03-03 13:24:27'),(110533,352,'Ghinara','495674',1,0,'2022-03-03 13:24:27','2022-03-03 13:24:27'),(110534,352,'Ghiwra','495661',1,0,'2022-03-03 13:24:27','2022-03-03 13:24:27'),(110535,352,'Gidhkunwari','495674',1,0,'2022-03-03 13:24:27','2022-03-03 13:24:27'),(110536,352,'Godhi','495683',1,0,'2022-03-03 13:24:27','2022-03-03 13:24:27'),(110537,352,'Gopalpur','495450',1,0,'2022-03-03 13:24:27','2022-03-03 13:24:27'),(110538,352,'Gursia','495448',1,0,'2022-03-03 13:24:27','2022-03-03 13:24:27'),(110539,352,'Hardi Bazar','495446',1,0,'2022-03-03 13:24:27','2022-03-03 13:24:27'),(110540,352,'Harethikala','495661',1,0,'2022-03-03 13:24:27','2022-03-03 13:24:27'),(110541,352,'Hasdeo Project Korba','495677',1,0,'2022-03-03 13:24:27','2022-03-03 13:24:27'),(110542,352,'Hasod','495661',1,0,'2022-03-03 13:24:27','2022-03-03 13:24:27'),(110543,352,'Jali','495449',1,0,'2022-03-03 13:24:27','2022-03-03 13:24:27'),(110544,352,'Jalke','495448',1,0,'2022-03-03 13:24:27','2022-03-03 13:24:27'),(110545,352,'Jamnipali','495450',1,0,'2022-03-03 13:24:27','2022-03-03 13:24:27'),(110546,352,'Jarwe','495674',1,0,'2022-03-03 13:24:27','2022-03-03 13:24:27'),(110547,352,'Jatga','495445',1,0,'2022-03-03 13:24:27','2022-03-03 13:24:27'),(110548,352,'Jawali','495445',1,0,'2022-03-03 13:24:27','2022-03-03 13:24:27'),(110549,352,'Jevra','495446',1,0,'2022-03-03 13:24:27','2022-03-03 13:24:27'),(110550,352,'Jhalraundha','495690',1,0,'2022-03-03 13:24:27','2022-03-03 13:24:27'),(110551,352,'Jilga','495674',1,0,'2022-03-03 13:24:27','2022-03-03 13:24:27'),(110552,352,'Kachanda','495690',1,0,'2022-03-03 13:24:27','2022-03-03 13:24:27'),(110553,352,'Kaitha','495661',1,0,'2022-03-03 13:24:28','2022-03-03 13:24:28'),(110554,352,'Kamrid','495660',1,0,'2022-03-03 13:24:28','2022-03-03 13:24:28'),(110555,352,'Kanki','495446',1,0,'2022-03-03 13:24:28','2022-03-03 13:24:28'),(110556,352,'Kapisda','495660',1,0,'2022-03-03 13:24:28','2022-03-03 13:24:28'),(110557,352,'Kapot','495449',1,0,'2022-03-03 13:24:28','2022-03-03 13:24:28'),(110558,352,'Karhani','495118',1,0,'2022-03-03 13:24:28','2022-03-03 13:24:28'),(110559,352,'Karnaud','495660',1,0,'2022-03-03 13:24:28','2022-03-03 13:24:28'),(110560,352,'Kartalachak','495674',1,0,'2022-03-03 13:24:28','2022-03-03 13:24:28'),(110561,352,'Kashigarh','495690',1,0,'2022-03-03 13:24:28','2022-03-03 13:24:28'),(110562,352,'Katetara','495690',1,0,'2022-03-03 13:24:28','2022-03-03 13:24:28'),(110563,352,'Katghora','495445',1,0,'2022-03-03 13:24:28','2022-03-03 13:24:28'),(110564,352,'Khajurani','495690',1,0,'2022-03-03 13:24:28','2022-03-03 13:24:28'),(110565,352,'Khamharia','495446',1,0,'2022-03-03 13:24:28','2022-03-03 13:24:28'),(110566,352,'Khemda','495691',1,0,'2022-03-03 13:24:28','2022-03-03 13:24:28'),(110567,352,'Kikirda','495661',1,0,'2022-03-03 13:24:28','2022-03-03 13:24:28'),(110568,352,'Korba Colliery','495677',1,0,'2022-03-03 13:24:28','2022-03-03 13:24:28'),(110569,352,'Korba H.O','495677',1,0,'2022-03-03 13:24:28','2022-03-03 13:24:28'),(110570,352,'Korba Town','495677',1,0,'2022-03-03 13:24:28','2022-03-03 13:24:28'),(110571,352,'Korbi','495448',1,0,'2022-03-03 13:24:28','2022-03-03 13:24:28'),(110572,352,'Korbi','495446',1,0,'2022-03-03 13:24:29','2022-03-03 13:24:29'),(110573,352,'Korkoma','495683',1,0,'2022-03-03 13:24:29','2022-03-03 13:24:29'),(110574,352,'Kotmer','495674',1,0,'2022-03-03 13:24:29','2022-03-03 13:24:29'),(110575,352,'Kudmura','495674',1,0,'2022-03-03 13:24:29','2022-03-03 13:24:29'),(110576,352,'Kudurmal','495674',1,0,'2022-03-03 13:24:29','2022-03-03 13:24:29'),(110577,352,'Kurda','495691',1,0,'2022-03-03 13:24:29','2022-03-03 13:24:29'),(110578,352,'Kusmunda Colliery','495454',1,0,'2022-03-03 13:24:29','2022-03-03 13:24:29'),(110579,352,'Lafa','495449',1,0,'2022-03-03 13:24:29','2022-03-03 13:24:29'),(110580,352,'Lakhali','495660',1,0,'2022-03-03 13:24:29','2022-03-03 13:24:29'),(110581,352,'Madai','495448',1,0,'2022-03-03 13:24:29','2022-03-03 13:24:29'),(110582,352,'Madanpur','495448',1,0,'2022-03-03 13:24:29','2022-03-03 13:24:29'),(110583,352,'Malda','495661',1,0,'2022-03-03 13:24:29','2022-03-03 13:24:29'),(110584,352,'Manikpur Colliery','495682',1,0,'2022-03-03 13:24:29','2022-03-03 13:24:29'),(110585,352,'Marghatti','495691',1,0,'2022-03-03 13:24:29','2022-03-03 13:24:29'),(110586,352,'Mongra','495447',1,0,'2022-03-03 13:24:29','2022-03-03 13:24:29'),(110587,352,'Morga','495448',1,0,'2022-03-03 13:24:29','2022-03-03 13:24:29'),(110588,352,'Mudhali','495446',1,0,'2022-03-03 13:24:29','2022-03-03 13:24:29'),(110589,352,'Mukta','495691',1,0,'2022-03-03 13:24:29','2022-03-03 13:24:29'),(110590,352,'Murli','495446',1,0,'2022-03-03 13:24:29','2022-03-03 13:24:29'),(110591,352,'Nariyara','495691',1,0,'2022-03-03 13:24:29','2022-03-03 13:24:29'),(110592,352,'Nawapara','495691',1,0,'2022-03-03 13:24:30','2022-03-03 13:24:30'),(110593,352,'Nonbirra','495449',1,0,'2022-03-03 13:24:30','2022-03-03 13:24:30'),(110594,352,'Nonbirra','495674',1,0,'2022-03-03 13:24:30','2022-03-03 13:24:30'),(110595,352,'Nunera','495449',1,0,'2022-03-03 13:24:30','2022-03-03 13:24:30'),(110596,352,'Odekera','495690',1,0,'2022-03-03 13:24:30','2022-03-03 13:24:30'),(110597,352,'Pachra','495448',1,0,'2022-03-03 13:24:30','2022-03-03 13:24:30'),(110598,352,'Pali','495448',1,0,'2022-03-03 13:24:30','2022-03-03 13:24:30'),(110599,352,'Pali (Korba)','495449',1,0,'2022-03-03 13:24:30','2022-03-03 13:24:30'),(110600,352,'Pandania','495454',1,0,'2022-03-03 13:24:30','2022-03-03 13:24:30'),(110601,352,'Pantora','495446',1,0,'2022-03-03 13:24:30','2022-03-03 13:24:30'),(110602,352,'Parasi','495118',1,0,'2022-03-03 13:24:30','2022-03-03 13:24:30'),(110603,352,'Parsada','495661',1,0,'2022-03-03 13:24:30','2022-03-03 13:24:30'),(110604,352,'Pasarkhet','495683',1,0,'2022-03-03 13:24:30','2022-03-03 13:24:30'),(110605,352,'Patpara','495449',1,0,'2022-03-03 13:24:30','2022-03-03 13:24:30'),(110606,352,'Pendri','495661',1,0,'2022-03-03 13:24:30','2022-03-03 13:24:30'),(110607,352,'Pidia','495674',1,0,'2022-03-03 13:24:30','2022-03-03 13:24:30'),(110608,352,'Pihrid','495691',1,0,'2022-03-03 13:24:30','2022-03-03 13:24:30'),(110609,352,'Pirda','495691',1,0,'2022-03-03 13:24:30','2022-03-03 13:24:30'),(110610,352,'Pondilafa','495449',1,0,'2022-03-03 13:24:30','2022-03-03 13:24:30'),(110611,352,'Pondishankar','495660',1,0,'2022-03-03 13:24:31','2022-03-03 13:24:31'),(110612,352,'Pondi-Uproda','495448',1,0,'2022-03-03 13:24:31','2022-03-03 13:24:31'),(110613,352,'Pragati Nagar','495450',1,0,'2022-03-03 13:24:31','2022-03-03 13:24:31'),(110614,352,'Rajgamar Colliery','495683',1,0,'2022-03-03 13:24:31','2022-03-03 13:24:31'),(110615,352,'Rajkamma','495445',1,0,'2022-03-03 13:24:31','2022-03-03 13:24:31'),(110616,352,'Rampur','495674',1,0,'2022-03-03 13:24:31','2022-03-03 13:24:31'),(110617,352,'Ranjana','495449',1,0,'2022-03-03 13:24:31','2022-03-03 13:24:31'),(110618,352,'Rewa','495445',1,0,'2022-03-03 13:24:31','2022-03-03 13:24:31'),(110619,352,'Risdi','495683',1,0,'2022-03-03 13:24:31','2022-03-03 13:24:31'),(110620,352,'Rohda','495660',1,0,'2022-03-03 13:24:31','2022-03-03 13:24:31'),(110621,352,'Rumga','495118',1,0,'2022-03-03 13:24:31','2022-03-03 13:24:31'),(110622,352,'Salni','495690',1,0,'2022-03-03 13:24:31','2022-03-03 13:24:31'),(110623,352,'Saragbundia','495674',1,0,'2022-03-03 13:24:31','2022-03-03 13:24:31'),(110624,352,'Sarwani','495660',1,0,'2022-03-03 13:24:31','2022-03-03 13:24:31'),(110625,352,'Semardarri','495118',1,0,'2022-03-03 13:24:31','2022-03-03 13:24:31'),(110626,352,'Semaria','495661',1,0,'2022-03-03 13:24:31','2022-03-03 13:24:31'),(110627,352,'Sendri','495690',1,0,'2022-03-03 13:24:31','2022-03-03 13:24:31'),(110628,352,'Sendripali','495674',1,0,'2022-03-03 13:24:31','2022-03-03 13:24:31'),(110629,352,'Seoni','495118',1,0,'2022-03-03 13:24:31','2022-03-03 13:24:31'),(110630,352,'Shish','495449',1,0,'2022-03-03 13:24:31','2022-03-03 13:24:31'),(110631,352,'Siladehi','495661',1,0,'2022-03-03 13:24:31','2022-03-03 13:24:31'),(110632,352,'Singhra','495691',1,0,'2022-03-03 13:24:31','2022-03-03 13:24:31'),(110633,352,'Sirmina','495448',1,0,'2022-03-03 13:24:32','2022-03-03 13:24:32'),(110634,352,'Solwan','495674',1,0,'2022-03-03 13:24:32','2022-03-03 13:24:32'),(110635,352,'Sonthi','495660',1,0,'2022-03-03 13:24:32','2022-03-03 13:24:32'),(110636,352,'Sutarra','495445',1,0,'2022-03-03 13:24:32','2022-03-03 13:24:32'),(110637,352,'Syang','495674',1,0,'2022-03-03 13:24:32','2022-03-03 13:24:32'),(110638,352,'Taldeori','495661',1,0,'2022-03-03 13:24:32','2022-03-03 13:24:32'),(110639,352,'Tanakhar','495445',1,0,'2022-03-03 13:24:32','2022-03-03 13:24:32'),(110640,352,'Tarod','495446',1,0,'2022-03-03 13:24:32','2022-03-03 13:24:32'),(110641,352,'Thathari','495690',1,0,'2022-03-03 13:24:32','2022-03-03 13:24:32'),(110642,352,'Tilkeja','495674',1,0,'2022-03-03 13:24:32','2022-03-03 13:24:32'),(110643,352,'Tiwarta','495449',1,0,'2022-03-03 13:24:32','2022-03-03 13:24:32'),(110644,352,'Tuman','495445',1,0,'2022-03-03 13:24:32','2022-03-03 13:24:32'),(110645,352,'Tuman','495674',1,0,'2022-03-03 13:24:32','2022-03-03 13:24:32'),(110646,352,'Tusar','495690',1,0,'2022-03-03 13:24:32','2022-03-03 13:24:32'),(110647,352,'Usad','495118',1,0,'2022-03-03 13:24:32','2022-03-03 13:24:32'),(110648,352,'Utarda','495446',1,0,'2022-03-03 13:24:32','2022-03-03 13:24:32'),(110649,352,'Vidyut Nagar Korba','495450',1,0,'2022-03-03 13:24:32','2022-03-03 13:24:32'),(110650,352,'Vikas Bhawan','495450',1,0,'2022-03-03 13:24:32','2022-03-03 13:24:32'),(110651,352,'Wcl Gevra Project','495452',1,0,'2022-03-03 13:24:32','2022-03-03 13:24:32'),(110652,353,'Badsara','497331',1,0,'2022-03-03 13:24:32','2022-03-03 13:24:32'),(110653,353,'Baharasi','497778',1,0,'2022-03-03 13:24:32','2022-03-03 13:24:32'),(110654,353,'Baikunthapur','497335',1,0,'2022-03-03 13:24:32','2022-03-03 13:24:32'),(110655,353,'Banjaridand','497335',1,0,'2022-03-03 13:24:32','2022-03-03 13:24:32'),(110656,353,'Bansipur','497339',1,0,'2022-03-03 13:24:32','2022-03-03 13:24:32'),(110657,353,'Barbaspur','497335',1,0,'2022-03-03 13:24:33','2022-03-03 13:24:33'),(110658,353,'Bardar','497449',1,0,'2022-03-03 13:24:33','2022-03-03 13:24:33'),(110659,353,'Bhagwanpur','497778',1,0,'2022-03-03 13:24:33','2022-03-03 13:24:33'),(110660,353,'B-seam Colly','497447',1,0,'2022-03-03 13:24:33','2022-03-03 13:24:33'),(110661,353,'Budhar','497335',1,0,'2022-03-03 13:24:33','2022-03-03 13:24:33'),(110662,353,'Chanti','497778',1,0,'2022-03-03 13:24:33','2022-03-03 13:24:33'),(110663,353,'Chhinddand','497335',1,0,'2022-03-03 13:24:33','2022-03-03 13:24:33'),(110664,353,'Chirimiri Colly','497449',1,0,'2022-03-03 13:24:33','2022-03-03 13:24:33'),(110665,353,'Chirmi','497449',1,0,'2022-03-03 13:24:33','2022-03-03 13:24:33'),(110666,353,'Churcha Colly','497339',1,0,'2022-03-03 13:24:33','2022-03-03 13:24:33'),(110667,353,'Deogarh','497778',1,0,'2022-03-03 13:24:33','2022-03-03 13:24:33'),(110668,353,'Devadand','497449',1,0,'2022-03-03 13:24:33','2022-03-03 13:24:33'),(110669,353,'Dumaria','497331',1,0,'2022-03-03 13:24:33','2022-03-03 13:24:33'),(110670,353,'Gangoti','497331',1,0,'2022-03-03 13:24:33','2022-03-03 13:24:33'),(110671,353,'Gelhapani','497559',1,0,'2022-03-03 13:24:33','2022-03-03 13:24:33'),(110672,353,'Ghaghra','497778',1,0,'2022-03-03 13:24:33','2022-03-03 13:24:33'),(110673,353,'Ghutra','497442',1,0,'2022-03-03 13:24:33','2022-03-03 13:24:33'),(110674,353,'Girjapur','497331',1,0,'2022-03-03 13:24:33','2022-03-03 13:24:33'),(110675,353,'Godripara','497555',1,0,'2022-03-03 13:24:33','2022-03-03 13:24:33'),(110676,353,'Haldibadi','497451',1,0,'2022-03-03 13:24:34','2022-03-03 13:24:34'),(110677,353,'Janakpur','497778',1,0,'2022-03-03 13:24:34','2022-03-03 13:24:34'),(110678,353,'Jhagrakhand Colly','497446',1,0,'2022-03-03 13:24:34','2022-03-03 13:24:34'),(110679,353,'Kachhod','497442',1,0,'2022-03-03 13:24:34','2022-03-03 13:24:34'),(110680,353,'Kamarjee','497778',1,0,'2022-03-03 13:24:34','2022-03-03 13:24:34'),(110681,353,'Kanjia','497778',1,0,'2022-03-03 13:24:34','2022-03-03 13:24:34'),(110682,353,'Kanwarpur','497778',1,0,'2022-03-03 13:24:34','2022-03-03 13:24:34'),(110683,353,'Kasra','497335',1,0,'2022-03-03 13:24:34','2022-03-03 13:24:34'),(110684,353,'Katgodi','497339',1,0,'2022-03-03 13:24:34','2022-03-03 13:24:34'),(110685,353,'Kathotiya','497442',1,0,'2022-03-03 13:24:34','2022-03-03 13:24:34'),(110686,353,'Katkona','497449',1,0,'2022-03-03 13:24:34','2022-03-03 13:24:34'),(110687,353,'Katkona','497331',1,0,'2022-03-03 13:24:34','2022-03-03 13:24:34'),(110688,353,'Kelhari','497442',1,0,'2022-03-03 13:24:34','2022-03-03 13:24:34'),(110689,353,'Khadgaon','497449',1,0,'2022-03-03 13:24:34','2022-03-03 13:24:34'),(110690,353,'Khamrodh','497778',1,0,'2022-03-03 13:24:34','2022-03-03 13:24:34'),(110691,353,'Koda','497449',1,0,'2022-03-03 13:24:34','2022-03-03 13:24:34'),(110692,353,'Korea Colly','497559',1,0,'2022-03-03 13:24:34','2022-03-03 13:24:34'),(110693,353,'Kotadol','497778',1,0,'2022-03-03 13:24:34','2022-03-03 13:24:34'),(110694,353,'Kurasia Colly','497553',1,0,'2022-03-03 13:24:34','2022-03-03 13:24:34'),(110695,353,'Mahora','497331',1,0,'2022-03-03 13:24:34','2022-03-03 13:24:34'),(110696,353,'Mandisarai','497778',1,0,'2022-03-03 13:24:34','2022-03-03 13:24:34'),(110697,353,'Manendragarh','497442',1,0,'2022-03-03 13:24:34','2022-03-03 13:24:34'),(110698,353,'Mansukh','497335',1,0,'2022-03-03 13:24:35','2022-03-03 13:24:35'),(110699,353,'Nagar','497335',1,0,'2022-03-03 13:24:35','2022-03-03 13:24:35'),(110700,353,'Nagpur','497442',1,0,'2022-03-03 13:24:35','2022-03-03 13:24:35'),(110701,353,'Pandavpara','497331',1,0,'2022-03-03 13:24:35','2022-03-03 13:24:35'),(110702,353,'Patna','497331',1,0,'2022-03-03 13:24:35','2022-03-03 13:24:35'),(110703,353,'Patrapali','497335',1,0,'2022-03-03 13:24:35','2022-03-03 13:24:35'),(110704,353,'Pondi','497449',1,0,'2022-03-03 13:24:35','2022-03-03 13:24:35'),(110705,353,'Rajouli','497339',1,0,'2022-03-03 13:24:35','2022-03-03 13:24:35'),(110706,353,'Ramgarh','497778',1,0,'2022-03-03 13:24:35','2022-03-03 13:24:35'),(110707,353,'Ranai','497331',1,0,'2022-03-03 13:24:35','2022-03-03 13:24:35'),(110708,353,'Sarbhoka','497331',1,0,'2022-03-03 13:24:35','2022-03-03 13:24:35'),(110709,353,'Singrouli','497778',1,0,'2022-03-03 13:24:35','2022-03-03 13:24:35'),(110710,353,'Sonawani Colly','497557',1,0,'2022-03-03 13:24:35','2022-03-03 13:24:35'),(110711,353,'Sonhat','497339',1,0,'2022-03-03 13:24:35','2022-03-03 13:24:35'),(110712,353,'Sons','497449',1,0,'2022-03-03 13:24:35','2022-03-03 13:24:35'),(110713,353,'South Jhagrakhand Colly','497448',1,0,'2022-03-03 13:24:35','2022-03-03 13:24:35'),(110714,353,'Tamdand','497449',1,0,'2022-03-03 13:24:35','2022-03-03 13:24:35'),(110715,353,'Tejpur','497331',1,0,'2022-03-03 13:24:35','2022-03-03 13:24:35'),(110716,353,'Udhnapur','497449',1,0,'2022-03-03 13:24:35','2022-03-03 13:24:35'),(110717,353,'West Chirimiri','497773',1,0,'2022-03-03 13:24:35','2022-03-03 13:24:35'),(110718,353,'West Jhagrakhand Colly','497447',1,0,'2022-03-03 13:24:35','2022-03-03 13:24:35'),(110719,354,'Achanakpur','493445',1,0,'2022-03-03 13:24:36','2022-03-03 13:24:36'),(110720,354,'Amarkot','493558',1,0,'2022-03-03 13:24:36','2022-03-03 13:24:36'),(110721,354,'Ankori','493554',1,0,'2022-03-03 13:24:36','2022-03-03 13:24:36'),(110722,354,'Arangi','493555',1,0,'2022-03-03 13:24:36','2022-03-03 13:24:36'),(110723,354,'Badesajapali','493558',1,0,'2022-03-03 13:24:36','2022-03-03 13:24:36'),(110724,354,'Bagbahra','493449',1,0,'2022-03-03 13:24:36','2022-03-03 13:24:36'),(110725,354,'Bakma','493449',1,0,'2022-03-03 13:24:36','2022-03-03 13:24:36'),(110726,354,'Baloda','493558',1,0,'2022-03-03 13:24:36','2022-03-03 13:24:36'),(110727,354,'Bamhani','493555',1,0,'2022-03-03 13:24:36','2022-03-03 13:24:36'),(110728,354,'Bamhani','493445',1,0,'2022-03-03 13:24:36','2022-03-03 13:24:36'),(110729,354,'Bansula','493554',1,0,'2022-03-03 13:24:36','2022-03-03 13:24:36'),(110730,354,'Bardoli','493554',1,0,'2022-03-03 13:24:36','2022-03-03 13:24:36'),(110731,354,'Barekel','493551',1,0,'2022-03-03 13:24:36','2022-03-03 13:24:36'),(110732,354,'Barnaidadar','493555',1,0,'2022-03-03 13:24:36','2022-03-03 13:24:36'),(110733,354,'Baroli','493554',1,0,'2022-03-03 13:24:36','2022-03-03 13:24:36'),(110734,354,'Basna','493554',1,0,'2022-03-03 13:24:36','2022-03-03 13:24:36'),(110735,354,'Bawankera','493551',1,0,'2022-03-03 13:24:36','2022-03-03 13:24:36'),(110736,354,'Belsonda','493445',1,0,'2022-03-03 13:24:36','2022-03-03 13:24:36'),(110737,354,'Bemcha','493445',1,0,'2022-03-03 13:24:36','2022-03-03 13:24:36'),(110738,354,'Bhadrasi','493449',1,0,'2022-03-03 13:24:36','2022-03-03 13:24:36'),(110739,354,'Bhagat Deori','492112',1,0,'2022-03-03 13:24:37','2022-03-03 13:24:37'),(110740,354,'Bhawarpur','493558',1,0,'2022-03-03 13:24:37','2022-03-03 13:24:37'),(110741,354,'Bhimbhauri','493551',1,0,'2022-03-03 13:24:37','2022-03-03 13:24:37'),(110742,354,'Bhithidih','493551',1,0,'2022-03-03 13:24:37','2022-03-03 13:24:37'),(110743,354,'Bhoring','493445',1,0,'2022-03-03 13:24:37','2022-03-03 13:24:37'),(110744,354,'Bhotha','493448',1,0,'2022-03-03 13:24:37','2022-03-03 13:24:37'),(110745,354,'Bhukel','493554',1,0,'2022-03-03 13:24:37','2022-03-03 13:24:37'),(110746,354,'Bhurkoni','493449',1,0,'2022-03-03 13:24:37','2022-03-03 13:24:37'),(110747,354,'Bichhiya','493558',1,0,'2022-03-03 13:24:37','2022-03-03 13:24:37'),(110748,354,'Birkoni','493445',1,0,'2022-03-03 13:24:37','2022-03-03 13:24:37'),(110749,354,'Bonda','493558',1,0,'2022-03-03 13:24:37','2022-03-03 13:24:37'),(110750,354,'Bundeli','493449',1,0,'2022-03-03 13:24:37','2022-03-03 13:24:37'),(110751,354,'Chanat','493555',1,0,'2022-03-03 13:24:37','2022-03-03 13:24:37'),(110752,354,'Charoda','493449',1,0,'2022-03-03 13:24:37','2022-03-03 13:24:37'),(110753,354,'Chattigirola','493558',1,0,'2022-03-03 13:24:37','2022-03-03 13:24:37'),(110754,354,'Chhoteloram','492112',1,0,'2022-03-03 13:24:37','2022-03-03 13:24:37'),(110755,354,'Deori','493448',1,0,'2022-03-03 13:24:37','2022-03-03 13:24:37'),(110756,354,'Dhansuli','493445',1,0,'2022-03-03 13:24:37','2022-03-03 13:24:37'),(110757,354,'Dumarpali','493551',1,0,'2022-03-03 13:24:37','2022-03-03 13:24:37'),(110758,354,'Gadbeda','493551',1,0,'2022-03-03 13:24:38','2022-03-03 13:24:38'),(110759,354,'Ganekera','493554',1,0,'2022-03-03 13:24:38','2022-03-03 13:24:38'),(110760,354,'Ganjar','493449',1,0,'2022-03-03 13:24:38','2022-03-03 13:24:38'),(110761,354,'Garhphuljhar','493554',1,0,'2022-03-03 13:24:38','2022-03-03 13:24:38'),(110762,354,'Garhseoni','493445',1,0,'2022-03-03 13:24:38','2022-03-03 13:24:38'),(110763,354,'Gerra','493558',1,0,'2022-03-03 13:24:38','2022-03-03 13:24:38'),(110764,354,'Ghonch','493551',1,0,'2022-03-03 13:24:38','2022-03-03 13:24:38'),(110765,354,'Ghunchapali','493449',1,0,'2022-03-03 13:24:38','2022-03-03 13:24:38'),(110766,354,'Girna','493551',1,0,'2022-03-03 13:24:38','2022-03-03 13:24:38'),(110767,354,'Hathibahra','493448',1,0,'2022-03-03 13:24:38','2022-03-03 13:24:38'),(110768,354,'Jagdishpur (Mahasamund)','493555',1,0,'2022-03-03 13:24:38','2022-03-03 13:24:38'),(110769,354,'Jalki','493445',1,0,'2022-03-03 13:24:38','2022-03-03 13:24:38'),(110770,354,'Jamdaraha','493558',1,0,'2022-03-03 13:24:38','2022-03-03 13:24:38'),(110771,354,'Jamhari','493558',1,0,'2022-03-03 13:24:38','2022-03-03 13:24:38'),(110772,354,'Jhalap','493551',1,0,'2022-03-03 13:24:38','2022-03-03 13:24:38'),(110773,354,'Jhara','493449',1,0,'2022-03-03 13:24:38','2022-03-03 13:24:38'),(110774,354,'Joba','493445',1,0,'2022-03-03 13:24:38','2022-03-03 13:24:38'),(110775,354,'Kalenda','493558',1,0,'2022-03-03 13:24:38','2022-03-03 13:24:38'),(110776,354,'Kamrod','493445',1,0,'2022-03-03 13:24:38','2022-03-03 13:24:38'),(110777,354,'Kanekera','493445',1,0,'2022-03-03 13:24:38','2022-03-03 13:24:38'),(110778,354,'Kasekera','493448',1,0,'2022-03-03 13:24:38','2022-03-03 13:24:38'),(110779,354,'Kasibahra','493449',1,0,'2022-03-03 13:24:39','2022-03-03 13:24:39'),(110780,354,'Kendudhar','493558',1,0,'2022-03-03 13:24:39','2022-03-03 13:24:39'),(110781,354,'Kenduwa','493558',1,0,'2022-03-03 13:24:39','2022-03-03 13:24:39'),(110782,354,'Khallari','493449',1,0,'2022-03-03 13:24:39','2022-03-03 13:24:39'),(110783,354,'Khamaria','493445',1,0,'2022-03-03 13:24:39','2022-03-03 13:24:39'),(110784,354,'Khatta','493551',1,0,'2022-03-03 13:24:39','2022-03-03 13:24:39'),(110785,354,'Khatti','493448',1,0,'2022-03-03 13:24:39','2022-03-03 13:24:39'),(110786,354,'Khatti','493445',1,0,'2022-03-03 13:24:39','2022-03-03 13:24:39'),(110787,354,'Khoksa','493558',1,0,'2022-03-03 13:24:39','2022-03-03 13:24:39'),(110788,354,'Khusrupali','493449',1,0,'2022-03-03 13:24:39','2022-03-03 13:24:39'),(110789,354,'Kisdi','493558',1,0,'2022-03-03 13:24:39','2022-03-03 13:24:39'),(110790,354,'Kishanpur','493551',1,0,'2022-03-03 13:24:39','2022-03-03 13:24:39'),(110791,354,'Koma','493449',1,0,'2022-03-03 13:24:39','2022-03-03 13:24:39'),(110792,354,'Komakhan','493448',1,0,'2022-03-03 13:24:39','2022-03-03 13:24:39'),(110793,354,'Lafinkhurd','493445',1,0,'2022-03-03 13:24:39','2022-03-03 13:24:39'),(110794,354,'Lahangar','493445',1,0,'2022-03-03 13:24:39','2022-03-03 13:24:39'),(110795,354,'Lambar','493558',1,0,'2022-03-03 13:24:39','2022-03-03 13:24:39'),(110796,354,'Limdarha','493555',1,0,'2022-03-03 13:24:39','2022-03-03 13:24:39'),(110797,354,'Mahasamund','493445',1,0,'2022-03-03 13:24:39','2022-03-03 13:24:39'),(110798,354,'Maldamal','493558',1,0,'2022-03-03 13:24:39','2022-03-03 13:24:39'),(110799,354,'Memra','492112',1,0,'2022-03-03 13:24:39','2022-03-03 13:24:39'),(110800,354,'Mohandi','493445',1,0,'2022-03-03 13:24:40','2022-03-03 13:24:40'),(110801,354,'Mongrapali','493449',1,0,'2022-03-03 13:24:40','2022-03-03 13:24:40'),(110802,354,'Mungaser','493449',1,0,'2022-03-03 13:24:40','2022-03-03 13:24:40'),(110803,354,'Narra','493448',1,0,'2022-03-03 13:24:40','2022-03-03 13:24:40'),(110804,354,'Nartora','493551',1,0,'2022-03-03 13:24:40','2022-03-03 13:24:40'),(110805,354,'Naugadi','493554',1,0,'2022-03-03 13:24:40','2022-03-03 13:24:40'),(110806,354,'Nawagarh','493558',1,0,'2022-03-03 13:24:40','2022-03-03 13:24:40'),(110807,354,'Pacheda','493445',1,0,'2022-03-03 13:24:40','2022-03-03 13:24:40'),(110808,354,'Paikin','493558',1,0,'2022-03-03 13:24:40','2022-03-03 13:24:40'),(110809,354,'Pajhrapali','493558',1,0,'2022-03-03 13:24:40','2022-03-03 13:24:40'),(110810,354,'Pandripani','493558',1,0,'2022-03-03 13:24:40','2022-03-03 13:24:40'),(110811,354,'Paraswani','492112',1,0,'2022-03-03 13:24:40','2022-03-03 13:24:40'),(110812,354,'Pasid','493445',1,0,'2022-03-03 13:24:40','2022-03-03 13:24:40'),(110813,354,'Patewa','493551',1,0,'2022-03-03 13:24:40','2022-03-03 13:24:40'),(110814,354,'Patharla','493555',1,0,'2022-03-03 13:24:40','2022-03-03 13:24:40'),(110815,354,'Patsendri','493558',1,0,'2022-03-03 13:24:40','2022-03-03 13:24:40'),(110816,354,'Pidhi','493445',1,0,'2022-03-03 13:24:40','2022-03-03 13:24:40'),(110817,354,'Pirda','493555',1,0,'2022-03-03 13:24:40','2022-03-03 13:24:40'),(110818,354,'Pithora','493551',1,0,'2022-03-03 13:24:41','2022-03-03 13:24:41'),(110819,354,'Putka','493558',1,0,'2022-03-03 13:24:41','2022-03-03 13:24:41'),(110820,354,'Raitum','493551',1,0,'2022-03-03 13:24:41','2022-03-03 13:24:41'),(110821,354,'Rasoda','493554',1,0,'2022-03-03 13:24:41','2022-03-03 13:24:41'),(110822,354,'Rohina','493558',1,0,'2022-03-03 13:24:41','2022-03-03 13:24:41'),(110823,354,'Saldih','492112',1,0,'2022-03-03 13:24:41','2022-03-03 13:24:41'),(110824,354,'Salhebhata','493448',1,0,'2022-03-03 13:24:41','2022-03-03 13:24:41'),(110825,354,'Salhetarai','493554',1,0,'2022-03-03 13:24:41','2022-03-03 13:24:41'),(110826,354,'Sankra (Mahasamund)','492112',1,0,'2022-03-03 13:24:41','2022-03-03 13:24:41'),(110827,354,'Saraipali','493558',1,0,'2022-03-03 13:24:41','2022-03-03 13:24:41'),(110828,354,'Semra','493449',1,0,'2022-03-03 13:24:41','2022-03-03 13:24:41'),(110829,354,'Shikaripali','493449',1,0,'2022-03-03 13:24:41','2022-03-03 13:24:41'),(110830,354,'Singhanpur','493558',1,0,'2022-03-03 13:24:41','2022-03-03 13:24:41'),(110831,354,'Singhi','493449',1,0,'2022-03-03 13:24:41','2022-03-03 13:24:41'),(110832,354,'Singhoda','493558',1,0,'2022-03-03 13:24:41','2022-03-03 13:24:41'),(110833,354,'Sirko','493554',1,0,'2022-03-03 13:24:41','2022-03-03 13:24:41'),(110834,354,'Sirpur','493445',1,0,'2022-03-03 13:24:41','2022-03-03 13:24:41'),(110835,354,'Sonasilli','493551',1,0,'2022-03-03 13:24:41','2022-03-03 13:24:41'),(110836,354,'Sorid','493445',1,0,'2022-03-03 13:24:41','2022-03-03 13:24:41'),(110837,354,'Sukhipali','493551',1,0,'2022-03-03 13:24:41','2022-03-03 13:24:41'),(110838,354,'Sukhri Dabri','493449',1,0,'2022-03-03 13:24:41','2022-03-03 13:24:41'),(110839,354,'Tamora','493445',1,0,'2022-03-03 13:24:42','2022-03-03 13:24:42'),(110840,354,'Tendukona','493449',1,0,'2022-03-03 13:24:42','2022-03-03 13:24:42'),(110841,354,'Toresingha','493558',1,0,'2022-03-03 13:24:42','2022-03-03 13:24:42'),(110842,354,'Toshgaon','493558',1,0,'2022-03-03 13:24:42','2022-03-03 13:24:42'),(110843,354,'Tumgaon','493445',1,0,'2022-03-03 13:24:42','2022-03-03 13:24:42'),(110844,354,'Turenga','493551',1,0,'2022-03-03 13:24:42','2022-03-03 13:24:42'),(110845,354,'Tusda','493445',1,0,'2022-03-03 13:24:42','2022-03-03 13:24:42'),(110846,355,'Bakulbahi','494661',1,0,'2022-03-03 13:24:42','2022-03-03 13:24:42'),(110847,355,'Bandapal','494661',1,0,'2022-03-03 13:24:42','2022-03-03 13:24:42'),(110848,355,'Benur','494661',1,0,'2022-03-03 13:24:42','2022-03-03 13:24:42'),(110849,355,'Bijli','494661',1,0,'2022-03-03 13:24:42','2022-03-03 13:24:42'),(110850,355,'Chingnar','494661',1,0,'2022-03-03 13:24:42','2022-03-03 13:24:42'),(110851,355,'Chotedongar','494661',1,0,'2022-03-03 13:24:42','2022-03-03 13:24:42'),(110852,355,'Dandwan','494661',1,0,'2022-03-03 13:24:42','2022-03-03 13:24:42'),(110853,355,'Devgaon','494661',1,0,'2022-03-03 13:24:42','2022-03-03 13:24:42'),(110854,355,'Dhanora','494661',1,0,'2022-03-03 13:24:42','2022-03-03 13:24:42'),(110855,355,'Dhaudai','494661',1,0,'2022-03-03 13:24:42','2022-03-03 13:24:42'),(110856,355,'Edka','494661',1,0,'2022-03-03 13:24:42','2022-03-03 13:24:42'),(110857,355,'Gadhbengal','494661',1,0,'2022-03-03 13:24:42','2022-03-03 13:24:42'),(110858,355,'Kanhargaon','494661',1,0,'2022-03-03 13:24:42','2022-03-03 13:24:42'),(110859,355,'Kohkameta','494661',1,0,'2022-03-03 13:24:42','2022-03-03 13:24:42'),(110860,355,'Narayanpur (Narayanpur)','494661',1,0,'2022-03-03 13:24:43','2022-03-03 13:24:43'),(110861,355,'Orcha','494661',1,0,'2022-03-03 13:24:43','2022-03-03 13:24:43'),(110862,355,'Pharasgaon','494661',1,0,'2022-03-03 13:24:43','2022-03-03 13:24:43'),(110863,355,'Remawand','494661',1,0,'2022-03-03 13:24:43','2022-03-03 13:24:43'),(110864,356,'Amgaon','496107',1,0,'2022-03-03 13:24:43','2022-03-03 13:24:43'),(110865,356,'Amjhar','496551',1,0,'2022-03-03 13:24:43','2022-03-03 13:24:43'),(110866,356,'Amlipali','496551',1,0,'2022-03-03 13:24:43','2022-03-03 13:24:43'),(110867,356,'Anjoripali','496661',1,0,'2022-03-03 13:24:43','2022-03-03 13:24:43'),(110868,356,'Aurda','496100',1,0,'2022-03-03 13:24:43','2022-03-03 13:24:43'),(110869,356,'Aurda','496661',1,0,'2022-03-03 13:24:43','2022-03-03 13:24:43'),(110870,356,'Bade Deogaon','496661',1,0,'2022-03-03 13:24:43','2022-03-03 13:24:43'),(110871,356,'Badebhandar','496100',1,0,'2022-03-03 13:24:43','2022-03-03 13:24:43'),(110872,356,'Badegantuli`','496450',1,0,'2022-03-03 13:24:43','2022-03-03 13:24:43'),(110873,356,'Badehardi','496440',1,0,'2022-03-03 13:24:43','2022-03-03 13:24:43'),(110874,356,'Badenawapara','496554',1,0,'2022-03-03 13:24:43','2022-03-03 13:24:43'),(110875,356,'Baghadola','496440',1,0,'2022-03-03 13:24:43','2022-03-03 13:24:43'),(110876,356,'Bagudega','496115',1,0,'2022-03-03 13:24:43','2022-03-03 13:24:43'),(110877,356,'Bahirkela','496111',1,0,'2022-03-03 13:24:43','2022-03-03 13:24:43'),(110878,356,'Baihamunda','496111',1,0,'2022-03-03 13:24:43','2022-03-03 13:24:43'),(110879,356,'Baisi Colony','496116',1,0,'2022-03-03 13:24:43','2022-03-03 13:24:43'),(110880,356,'Bangursia','496665',1,0,'2022-03-03 13:24:43','2022-03-03 13:24:43'),(110881,356,'Bangursiya','496001',1,0,'2022-03-03 13:24:43','2022-03-03 13:24:43'),(110882,356,'Banhar','496665',1,0,'2022-03-03 13:24:44','2022-03-03 13:24:44'),(110883,356,'Banora','496001',1,0,'2022-03-03 13:24:44','2022-03-03 13:24:44'),(110884,356,'Bansi','496111',1,0,'2022-03-03 13:24:44','2022-03-03 13:24:44'),(110885,356,'Bar','496554',1,0,'2022-03-03 13:24:44','2022-03-03 13:24:44'),(110886,356,'Baradoli','496440',1,0,'2022-03-03 13:24:44','2022-03-03 13:24:44'),(110887,356,'Baramkela','496551',1,0,'2022-03-03 13:24:44','2022-03-03 13:24:44'),(110888,356,'Barbhouna','496665',1,0,'2022-03-03 13:24:44','2022-03-03 13:24:44'),(110889,356,'Barod','496111',1,0,'2022-03-03 13:24:44','2022-03-03 13:24:44'),(110890,356,'Barpali','496554',1,0,'2022-03-03 13:24:44','2022-03-03 13:24:44'),(110891,356,'Barra','496665',1,0,'2022-03-03 13:24:44','2022-03-03 13:24:44'),(110892,356,'Basnajhar','496661',1,0,'2022-03-03 13:24:44','2022-03-03 13:24:44'),(110893,356,'Baturakachar','496113',1,0,'2022-03-03 13:24:44','2022-03-03 13:24:44'),(110894,356,'Behramar','496116',1,0,'2022-03-03 13:24:44','2022-03-03 13:24:44'),(110895,356,'Bengchi','496551',1,0,'2022-03-03 13:24:44','2022-03-03 13:24:44'),(110896,356,'Bhadisar','496445',1,0,'2022-03-03 13:24:44','2022-03-03 13:24:44'),(110897,356,'Bhagora','496001',1,0,'2022-03-03 13:24:44','2022-03-03 13:24:44'),(110898,356,'Bhainapara','496661',1,0,'2022-03-03 13:24:44','2022-03-03 13:24:44'),(110899,356,'Bhalumar','496111',1,0,'2022-03-03 13:24:44','2022-03-03 13:24:44'),(110900,356,'Bhedimuda','496115',1,0,'2022-03-03 13:24:44','2022-03-03 13:24:44'),(110901,356,'Bhedwan','496450',1,0,'2022-03-03 13:24:44','2022-03-03 13:24:44'),(110902,356,'Bhothli','496450',1,0,'2022-03-03 13:24:45','2022-03-03 13:24:45'),(110903,356,'Bhupdeopur','496661',1,0,'2022-03-03 13:24:45','2022-03-03 13:24:45'),(110904,356,'Binjkot','496661',1,0,'2022-03-03 13:24:45','2022-03-03 13:24:45'),(110905,356,'Birnipali','496551',1,0,'2022-03-03 13:24:45','2022-03-03 13:24:45'),(110906,356,'Birsingha','496113',1,0,'2022-03-03 13:24:45','2022-03-03 13:24:45'),(110907,356,'Boirdadar','496001',1,0,'2022-03-03 13:24:45','2022-03-03 13:24:45'),(110908,356,'Bojia','496665',1,0,'2022-03-03 13:24:45','2022-03-03 13:24:45'),(110909,356,'Bonda','496554',1,0,'2022-03-03 13:24:45','2022-03-03 13:24:45'),(110910,356,'Boro','496116',1,0,'2022-03-03 13:24:45','2022-03-03 13:24:45'),(110911,356,'Botalda','496661',1,0,'2022-03-03 13:24:45','2022-03-03 13:24:45'),(110912,356,'Bunga','496100',1,0,'2022-03-03 13:24:45','2022-03-03 13:24:45'),(110913,356,'Chakradharnagar','496001',1,0,'2022-03-03 13:24:45','2022-03-03 13:24:45'),(110914,356,'Chandrasekharpur','496665',1,0,'2022-03-03 13:24:45','2022-03-03 13:24:45'),(110915,356,'Chantipali','496445',1,0,'2022-03-03 13:24:45','2022-03-03 13:24:45'),(110916,356,'Chhal','496665',1,0,'2022-03-03 13:24:45','2022-03-03 13:24:45'),(110917,356,'Chhapora','496440',1,0,'2022-03-03 13:24:45','2022-03-03 13:24:45'),(110918,356,'Chharratangar','496111',1,0,'2022-03-03 13:24:45','2022-03-03 13:24:45'),(110919,356,'Chhatamura','496001',1,0,'2022-03-03 13:24:45','2022-03-03 13:24:45'),(110920,356,'Chhincorumaria','496440',1,0,'2022-03-03 13:24:45','2022-03-03 13:24:45'),(110921,356,'Chhind','496445',1,0,'2022-03-03 13:24:45','2022-03-03 13:24:45'),(110922,356,'Chhodamines','496661',1,0,'2022-03-03 13:24:46','2022-03-03 13:24:46'),(110923,356,'Chhote Lendhra','496445',1,0,'2022-03-03 13:24:46','2022-03-03 13:24:46'),(110924,356,'Chhotegumda','496111',1,0,'2022-03-03 13:24:46','2022-03-03 13:24:46'),(110925,356,'Chhte Khaira','496450',1,0,'2022-03-03 13:24:46','2022-03-03 13:24:46'),(110926,356,'Chikhli','496100',1,0,'2022-03-03 13:24:46','2022-03-03 13:24:46'),(110927,356,'Choranga','496115',1,0,'2022-03-03 13:24:46','2022-03-03 13:24:46'),(110928,356,'Dabhra','496551',1,0,'2022-03-03 13:24:46','2022-03-03 13:24:46'),(110929,356,'Dahida','496450',1,0,'2022-03-03 13:24:46','2022-03-03 13:24:46'),(110930,356,'Damdama','496551',1,0,'2022-03-03 13:24:46','2022-03-03 13:24:46'),(110931,356,'Dansara','496445',1,0,'2022-03-03 13:24:46','2022-03-03 13:24:46'),(110932,356,'Dehjari','496665',1,0,'2022-03-03 13:24:46','2022-03-03 13:24:46'),(110933,356,'Dehradih','496111',1,0,'2022-03-03 13:24:46','2022-03-03 13:24:46'),(110934,356,'Deogaon','496554',1,0,'2022-03-03 13:24:46','2022-03-03 13:24:46'),(110935,356,'Deogarh','496111',1,0,'2022-03-03 13:24:46','2022-03-03 13:24:46'),(110936,356,'Dhanagar','496001',1,0,'2022-03-03 13:24:46','2022-03-03 13:24:46'),(110937,356,'Dhap','496115',1,0,'2022-03-03 13:24:46','2022-03-03 13:24:46'),(110938,356,'Dharmajaigarh','496116',1,0,'2022-03-03 13:24:46','2022-03-03 13:24:46'),(110939,356,'Dhimani','496661',1,0,'2022-03-03 13:24:46','2022-03-03 13:24:46'),(110940,356,'Dhourabhata','496107',1,0,'2022-03-03 13:24:46','2022-03-03 13:24:46'),(110941,356,'Dolesara','496107',1,0,'2022-03-03 13:24:46','2022-03-03 13:24:46'),(110942,356,'Dongitarai','496661',1,0,'2022-03-03 13:24:46','2022-03-03 13:24:46'),(110943,356,'Dongripali','496551',1,0,'2022-03-03 13:24:47','2022-03-03 13:24:47'),(110944,356,'Faraswani','496551',1,0,'2022-03-03 13:24:47','2022-03-03 13:24:47'),(110945,356,'Farkanara','496665',1,0,'2022-03-03 13:24:47','2022-03-03 13:24:47'),(110946,356,'Farsabahar','496242',1,0,'2022-03-03 13:24:47','2022-03-03 13:24:47'),(110947,356,'Gahira','496113',1,0,'2022-03-03 13:24:47','2022-03-03 13:24:47'),(110948,356,'Gahnajharia','496115',1,0,'2022-03-03 13:24:47','2022-03-03 13:24:47'),(110949,356,'Garh-umaria','496001',1,0,'2022-03-03 13:24:47','2022-03-03 13:24:47'),(110950,356,'Gatadih','496450',1,0,'2022-03-03 13:24:47','2022-03-03 13:24:47'),(110951,356,'Gersa','496116',1,0,'2022-03-03 13:24:47','2022-03-03 13:24:47'),(110952,356,'Gerwani','496001',1,0,'2022-03-03 13:24:47','2022-03-03 13:24:47'),(110953,356,'Ghaghra','496661',1,0,'2022-03-03 13:24:47','2022-03-03 13:24:47'),(110954,356,'Gharghoda','496111',1,0,'2022-03-03 13:24:47','2022-03-03 13:24:47'),(110955,356,'Gharghodi','496111',1,0,'2022-03-03 13:24:47','2022-03-03 13:24:47'),(110956,356,'Ghatgaon','496115',1,0,'2022-03-03 13:24:47','2022-03-03 13:24:47'),(110957,356,'Gobersingha','496554',1,0,'2022-03-03 13:24:47','2022-03-03 13:24:47'),(110958,356,'Godam','496450',1,0,'2022-03-03 13:24:47','2022-03-03 13:24:47'),(110959,356,'Godihari','496445',1,0,'2022-03-03 13:24:47','2022-03-03 13:24:47'),(110960,356,'Gonda','496551',1,0,'2022-03-03 13:24:47','2022-03-03 13:24:47'),(110961,356,'Gorkha','496005',1,0,'2022-03-03 13:24:47','2022-03-03 13:24:47'),(110962,356,'Gorpar','496665',1,0,'2022-03-03 13:24:47','2022-03-03 13:24:47'),(110963,356,'Gorra','496001',1,0,'2022-03-03 13:24:47','2022-03-03 13:24:47'),(110964,356,'Gudeli','496450',1,0,'2022-03-03 13:24:47','2022-03-03 13:24:47'),(110965,356,'Gurda','496665',1,0,'2022-03-03 13:24:47','2022-03-03 13:24:47'),(110966,356,'Halahuli','496661',1,0,'2022-03-03 13:24:48','2022-03-03 13:24:48'),(110967,356,'Hamirpur','496107',1,0,'2022-03-03 13:24:48','2022-03-03 13:24:48'),(110968,356,'Hardi (Raigarh)','496450',1,0,'2022-03-03 13:24:48','2022-03-03 13:24:48'),(110969,356,'Hati','496116',1,0,'2022-03-03 13:24:48','2022-03-03 13:24:48'),(110970,356,'Hattapali','496551',1,0,'2022-03-03 13:24:48','2022-03-03 13:24:48'),(110971,356,'Hirri','496551',1,0,'2022-03-03 13:24:48','2022-03-03 13:24:48'),(110972,356,'Jaimura','496661',1,0,'2022-03-03 13:24:48','2022-03-03 13:24:48'),(110973,356,'Jamarga','496116',1,0,'2022-03-03 13:24:48','2022-03-03 13:24:48'),(110974,356,'Jamgaon','496001',1,0,'2022-03-03 13:24:48','2022-03-03 13:24:48'),(110975,356,'Jarekela','496107',1,0,'2022-03-03 13:24:48','2022-03-03 13:24:48'),(110976,356,'Jashpur','496445',1,0,'2022-03-03 13:24:48','2022-03-03 13:24:48'),(110977,356,'Jatri','496100',1,0,'2022-03-03 13:24:48','2022-03-03 13:24:48'),(110978,356,'Jewra','496450',1,0,'2022-03-03 13:24:48','2022-03-03 13:24:48'),(110979,356,'Jhagarpur','496113',1,0,'2022-03-03 13:24:48','2022-03-03 13:24:48'),(110980,356,'Jhal','496551',1,0,'2022-03-03 13:24:48','2022-03-03 13:24:48'),(110981,356,'Jhalmala','496001',1,0,'2022-03-03 13:24:48','2022-03-03 13:24:48'),(110982,356,'Jharadih','496661',1,0,'2022-03-03 13:24:48','2022-03-03 13:24:48'),(110983,356,'Jivri','496001',1,0,'2022-03-03 13:24:48','2022-03-03 13:24:48'),(110984,356,'Jobi','496665',1,0,'2022-03-03 13:24:48','2022-03-03 13:24:48'),(110985,356,'JSPL Patrapli','496005',1,0,'2022-03-03 13:24:48','2022-03-03 13:24:48'),(110986,356,'Jurda','496001',1,0,'2022-03-03 13:24:49','2022-03-03 13:24:49'),(110987,356,'Kachhar','496661',1,0,'2022-03-03 13:24:49','2022-03-03 13:24:49'),(110988,356,'Kanakbira','496445',1,0,'2022-03-03 13:24:49','2022-03-03 13:24:49'),(110989,356,'Kantaahardi','496001',1,0,'2022-03-03 13:24:49','2022-03-03 13:24:49'),(110990,356,'Kapisda','496450',1,0,'2022-03-03 13:24:49','2022-03-03 13:24:49'),(110991,356,'Karaipali','496665',1,0,'2022-03-03 13:24:49','2022-03-03 13:24:49'),(110992,356,'Karanpali','496551',1,0,'2022-03-03 13:24:49','2022-03-03 13:24:49'),(110993,356,'Karra','496115',1,0,'2022-03-03 13:24:49','2022-03-03 13:24:49'),(110994,356,'Kashla','496113',1,0,'2022-03-03 13:24:49','2022-03-03 13:24:49'),(110995,356,'Katalpali d\"\"','496113',1,0,'2022-03-03 13:24:49','2022-03-03 13:24:49'),(110996,356,'Katangpali','496551',1,0,'2022-03-03 13:24:49','2022-03-03 13:24:49'),(110997,356,'Katkalia','496113',1,0,'2022-03-03 13:24:49','2022-03-03 13:24:49'),(110998,356,'Kaya','496113',1,0,'2022-03-03 13:24:49','2022-03-03 13:24:49'),(110999,356,'Kedar','496445',1,0,'2022-03-03 13:24:49','2022-03-03 13:24:49'),(111000,356,'Khadgaon','496116',1,0,'2022-03-03 13:24:49','2022-03-03 13:24:49'),(111001,356,'Khamhar','496116',1,0,'2022-03-03 13:24:49','2022-03-03 13:24:49'),(111002,356,'Khamhar','496665',1,0,'2022-03-03 13:24:49','2022-03-03 13:24:49'),(111003,356,'Kharri','496445',1,0,'2022-03-03 13:24:49','2022-03-03 13:24:49'),(111004,356,'Kharsia','496661',1,0,'2022-03-03 13:24:49','2022-03-03 13:24:49'),(111005,356,'Khokhsipali','496445',1,0,'2022-03-03 13:24:49','2022-03-03 13:24:49'),(111006,356,'Kirodimalnagar','496005',1,0,'2022-03-03 13:24:49','2022-03-03 13:24:49'),(111007,356,'Kodasia','496115',1,0,'2022-03-03 13:24:49','2022-03-03 13:24:49'),(111008,356,'Kolam','496107',1,0,'2022-03-03 13:24:49','2022-03-03 13:24:49'),(111009,356,'Kondapali','496440',1,0,'2022-03-03 13:24:50','2022-03-03 13:24:50'),(111010,356,'Kondatarai','496100',1,0,'2022-03-03 13:24:50','2022-03-03 13:24:50'),(111011,356,'Kondtarai','496661',1,0,'2022-03-03 13:24:50','2022-03-03 13:24:50'),(111012,356,'Kosir','496445',1,0,'2022-03-03 13:24:50','2022-03-03 13:24:50'),(111013,356,'Kotarlia','496001',1,0,'2022-03-03 13:24:50','2022-03-03 13:24:50'),(111014,356,'Kotasura','496440',1,0,'2022-03-03 13:24:50','2022-03-03 13:24:50'),(111015,356,'Kotra','496001',1,0,'2022-03-03 13:24:50','2022-03-03 13:24:50'),(111016,356,'Kotri','496450',1,0,'2022-03-03 13:24:50','2022-03-03 13:24:50'),(111017,356,'Kotrimal','496111',1,0,'2022-03-03 13:24:50','2022-03-03 13:24:50'),(111018,356,'Kudekela','496665',1,0,'2022-03-03 13:24:50','2022-03-03 13:24:50'),(111019,356,'Kudhari','496445',1,0,'2022-03-03 13:24:50','2022-03-03 13:24:50'),(111020,356,'Kudumkela','496111',1,0,'2022-03-03 13:24:50','2022-03-03 13:24:50'),(111021,356,'Kukurda','496001',1,0,'2022-03-03 13:24:50','2022-03-03 13:24:50'),(111022,356,'Kuma','496116',1,0,'2022-03-03 13:24:50','2022-03-03 13:24:50'),(111023,356,'Kunjara','496113',1,0,'2022-03-03 13:24:50','2022-03-03 13:24:50'),(111024,356,'Kunkuni','496661',1,0,'2022-03-03 13:24:50','2022-03-03 13:24:50'),(111025,356,'Lailunga','496113',1,0,'2022-03-03 13:24:50','2022-03-03 13:24:50'),(111026,356,'Laripani','496113',1,0,'2022-03-03 13:24:50','2022-03-03 13:24:50'),(111027,356,'Lendhra','496551',1,0,'2022-03-03 13:24:50','2022-03-03 13:24:50'),(111028,356,'Libra','496107',1,0,'2022-03-03 13:24:50','2022-03-03 13:24:50'),(111029,356,'Lodhia','496551',1,0,'2022-03-03 13:24:50','2022-03-03 13:24:50'),(111030,356,'Loharsingha','496100',1,0,'2022-03-03 13:24:51','2022-03-03 13:24:51'),(111031,356,'Loing','496001',1,0,'2022-03-03 13:24:51','2022-03-03 13:24:51'),(111032,356,'Lukapara','496554',1,0,'2022-03-03 13:24:51','2022-03-03 13:24:51'),(111033,356,'Madanpur','496661',1,0,'2022-03-03 13:24:51','2022-03-03 13:24:51'),(111034,356,'Madhopali','496551',1,0,'2022-03-03 13:24:51','2022-03-03 13:24:51'),(111035,356,'Maharajganj','496116',1,0,'2022-03-03 13:24:51','2022-03-03 13:24:51'),(111036,356,'Mahloi','496440',1,0,'2022-03-03 13:24:51','2022-03-03 13:24:51'),(111037,356,'Mahloi','496107',1,0,'2022-03-03 13:24:51','2022-03-03 13:24:51'),(111038,356,'Mahuadhodha','496445',1,0,'2022-03-03 13:24:51','2022-03-03 13:24:51'),(111039,356,'Mahuwapali','496661',1,0,'2022-03-03 13:24:51','2022-03-03 13:24:51'),(111040,356,'Malda','496551',1,0,'2022-03-03 13:24:51','2022-03-03 13:24:51'),(111041,356,'Manikpur','496554',1,0,'2022-03-03 13:24:51','2022-03-03 13:24:51'),(111042,356,'Milupara','496107',1,0,'2022-03-03 13:24:51','2022-03-03 13:24:51'),(111043,356,'Miriguda','496116',1,0,'2022-03-03 13:24:51','2022-03-03 13:24:51'),(111044,356,'Mudagaon','496115',1,0,'2022-03-03 13:24:51','2022-03-03 13:24:51'),(111045,356,'Mudpar','496450',1,0,'2022-03-03 13:24:51','2022-03-03 13:24:51'),(111046,356,'Mukdega','496113',1,0,'2022-03-03 13:24:51','2022-03-03 13:24:51'),(111047,356,'Mumund','496116',1,0,'2022-03-03 13:24:51','2022-03-03 13:24:51'),(111048,356,'Mura','496661',1,0,'2022-03-03 13:24:51','2022-03-03 13:24:51'),(111049,356,'Nadigaon','496554',1,0,'2022-03-03 13:24:51','2022-03-03 13:24:51'),(111050,356,'Nagoi','496665',1,0,'2022-03-03 13:24:51','2022-03-03 13:24:51'),(111051,356,'Naharpali','496661',1,0,'2022-03-03 13:24:51','2022-03-03 13:24:51'),(111052,356,'Nandeli','496001',1,0,'2022-03-03 13:24:51','2022-03-03 13:24:51'),(111053,356,'Narayanpur','496113',1,0,'2022-03-03 13:24:51','2022-03-03 13:24:51'),(111054,356,'Narkalo','496116',1,0,'2022-03-03 13:24:52','2022-03-03 13:24:52'),(111055,356,'Naurngpur','496001',1,0,'2022-03-03 13:24:52','2022-03-03 13:24:52'),(111056,356,'Navrangpur','496450',1,0,'2022-03-03 13:24:52','2022-03-03 13:24:52'),(111057,356,'Nawapara','496665',1,0,'2022-03-03 13:24:52','2022-03-03 13:24:52'),(111058,356,'Nawapara','496661',1,0,'2022-03-03 13:24:52','2022-03-03 13:24:52'),(111059,356,'Nawapara','496001',1,0,'2022-03-03 13:24:52','2022-03-03 13:24:52'),(111060,356,'Nawaparadenda','496111',1,0,'2022-03-03 13:24:52','2022-03-03 13:24:52'),(111061,356,'Netnagar','496440',1,0,'2022-03-03 13:24:52','2022-03-03 13:24:52'),(111062,356,'Ongana','496116',1,0,'2022-03-03 13:24:52','2022-03-03 13:24:52'),(111063,356,'Padigaon','496440',1,0,'2022-03-03 13:24:52','2022-03-03 13:24:52'),(111064,356,'Padigaon','496107',1,0,'2022-03-03 13:24:52','2022-03-03 13:24:52'),(111065,356,'Pahanda','496445',1,0,'2022-03-03 13:24:52','2022-03-03 13:24:52'),(111066,356,'Pamgarh','496661',1,0,'2022-03-03 13:24:52','2022-03-03 13:24:52'),(111067,356,'Panchdhar','496554',1,0,'2022-03-03 13:24:52','2022-03-03 13:24:52'),(111068,356,'Paraskol','496445',1,0,'2022-03-03 13:24:52','2022-03-03 13:24:52'),(111069,356,'Paseed','496450',1,0,'2022-03-03 13:24:52','2022-03-03 13:24:52'),(111070,356,'Patelpali','496100',1,0,'2022-03-03 13:24:52','2022-03-03 13:24:52'),(111071,356,'Patrapali','496001',1,0,'2022-03-03 13:24:52','2022-03-03 13:24:52'),(111072,356,'Patrapali','496661',1,0,'2022-03-03 13:24:52','2022-03-03 13:24:52'),(111073,356,'Pendri','496450',1,0,'2022-03-03 13:24:52','2022-03-03 13:24:52'),(111074,356,'Piprahi','496113',1,0,'2022-03-03 13:24:53','2022-03-03 13:24:53'),(111075,356,'Pithama','496113',1,0,'2022-03-03 13:24:53','2022-03-03 13:24:53'),(111076,356,'Porda','496111',1,0,'2022-03-03 13:24:53','2022-03-03 13:24:53'),(111077,356,'Punjipathra','496109',1,0,'2022-03-03 13:24:53','2022-03-03 13:24:53'),(111078,356,'Purena','496661',1,0,'2022-03-03 13:24:53','2022-03-03 13:24:53'),(111079,356,'Pusalda','496100',1,0,'2022-03-03 13:24:53','2022-03-03 13:24:53'),(111080,356,'Pusalda','496665',1,0,'2022-03-03 13:24:53','2022-03-03 13:24:53'),(111081,356,'Pussore','496440',1,0,'2022-03-03 13:24:53','2022-03-03 13:24:53'),(111082,356,'Putkapuri','496001',1,0,'2022-03-03 13:24:53','2022-03-03 13:24:53'),(111083,356,'Rabo','496111',1,0,'2022-03-03 13:24:53','2022-03-03 13:24:53'),(111084,356,'Raigarh H.O','496001',1,0,'2022-03-03 13:24:53','2022-03-03 13:24:53'),(111085,356,'Raigarh Jute Mill','496001',1,0,'2022-03-03 13:24:53','2022-03-03 13:24:53'),(111086,356,'Raigarh Sadar Bazar','496001',1,0,'2022-03-03 13:24:53','2022-03-03 13:24:53'),(111087,356,'Raikera','496111',1,0,'2022-03-03 13:24:53','2022-03-03 13:24:53'),(111088,356,'Rajkot','496115',1,0,'2022-03-03 13:24:53','2022-03-03 13:24:53'),(111089,356,'Rajpur (RIH)','496115',1,0,'2022-03-03 13:24:53','2022-03-03 13:24:53'),(111090,356,'Rapagula','496445',1,0,'2022-03-03 13:24:53','2022-03-03 13:24:53'),(111091,356,'Reda','496450',1,0,'2022-03-03 13:24:53','2022-03-03 13:24:53'),(111092,356,'Relo','496665',1,0,'2022-03-03 13:24:53','2022-03-03 13:24:53'),(111093,356,'Rengalpali','496440',1,0,'2022-03-03 13:24:53','2022-03-03 13:24:53'),(111094,356,'Rissora','496554',1,0,'2022-03-03 13:24:53','2022-03-03 13:24:53'),(111095,356,'Robrertson','496661',1,0,'2022-03-03 13:24:54','2022-03-03 13:24:54'),(111096,356,'Ruwaful','496116',1,0,'2022-03-03 13:24:54','2022-03-03 13:24:54'),(111097,356,'Sahaspani','496445',1,0,'2022-03-03 13:24:54','2022-03-03 13:24:54'),(111098,356,'Salakia','496115',1,0,'2022-03-03 13:24:54','2022-03-03 13:24:54'),(111099,356,'Salar','496445',1,0,'2022-03-03 13:24:54','2022-03-03 13:24:54'),(111100,356,'Salheona','496554',1,0,'2022-03-03 13:24:54','2022-03-03 13:24:54'),(111101,356,'Sambalpuri','496001',1,0,'2022-03-03 13:24:54','2022-03-03 13:24:54'),(111102,356,'Samkera','496107',1,0,'2022-03-03 13:24:54','2022-03-03 13:24:54'),(111103,356,'Samruma','496111',1,0,'2022-03-03 13:24:54','2022-03-03 13:24:54'),(111104,356,'Sankra','496554',1,0,'2022-03-03 13:24:54','2022-03-03 13:24:54'),(111105,356,'Saraipali','496001',1,0,'2022-03-03 13:24:54','2022-03-03 13:24:54'),(111106,356,'Saraitolla','496107',1,0,'2022-03-03 13:24:54','2022-03-03 13:24:54'),(111107,356,'Sarangarh','496445',1,0,'2022-03-03 13:24:54','2022-03-03 13:24:54'),(111108,356,'Saria','496554',1,0,'2022-03-03 13:24:54','2022-03-03 13:24:54'),(111109,356,'Sarwani','496661',1,0,'2022-03-03 13:24:54','2022-03-03 13:24:54'),(111110,356,'Shahpur','496116',1,0,'2022-03-03 13:24:54','2022-03-03 13:24:54'),(111111,356,'Sisringa','496116',1,0,'2022-03-03 13:24:54','2022-03-03 13:24:54'),(111112,356,'Sithra','496116',1,0,'2022-03-03 13:24:54','2022-03-03 13:24:54'),(111113,356,'Sonajori','496113',1,0,'2022-03-03 13:24:54','2022-03-03 13:24:54'),(111114,356,'Sondka','496661',1,0,'2022-03-03 13:24:54','2022-03-03 13:24:54'),(111115,356,'Surangpani','496113',1,0,'2022-03-03 13:24:54','2022-03-03 13:24:54'),(111116,356,'Tadola','496440',1,0,'2022-03-03 13:24:55','2022-03-03 13:24:55'),(111117,356,'Tamnar','496107',1,0,'2022-03-03 13:24:55','2022-03-03 13:24:55'),(111118,356,'Tamtora','496445',1,0,'2022-03-03 13:24:55','2022-03-03 13:24:55'),(111119,356,'Tandipar','496445',1,0,'2022-03-03 13:24:55','2022-03-03 13:24:55'),(111120,356,'Tangarghat','496107',1,0,'2022-03-03 13:24:55','2022-03-03 13:24:55'),(111121,356,'Taparda','496100',1,0,'2022-03-03 13:24:55','2022-03-03 13:24:55'),(111122,356,'Tarapur','496001',1,0,'2022-03-03 13:24:55','2022-03-03 13:24:55'),(111123,356,'Tarkela','496001',1,0,'2022-03-03 13:24:55','2022-03-03 13:24:55'),(111124,356,'Tausir','496551',1,0,'2022-03-03 13:24:55','2022-03-03 13:24:55'),(111125,356,'Telikot','496661',1,0,'2022-03-03 13:24:55','2022-03-03 13:24:55'),(111126,356,'Teram','496111',1,0,'2022-03-03 13:24:55','2022-03-03 13:24:55'),(111127,356,'Tetla','496100',1,0,'2022-03-03 13:24:55','2022-03-03 13:24:55'),(111128,356,'Timarlaga','496450',1,0,'2022-03-03 13:24:55','2022-03-03 13:24:55'),(111129,356,'Tinmini','496440',1,0,'2022-03-03 13:24:55','2022-03-03 13:24:55'),(111130,356,'Tiur','496661',1,0,'2022-03-03 13:24:55','2022-03-03 13:24:55'),(111131,356,'Tolge','496113',1,0,'2022-03-03 13:24:55','2022-03-03 13:24:55'),(111132,356,'Tolma','496113',1,0,'2022-03-03 13:24:55','2022-03-03 13:24:55'),(111133,356,'Turtura','496113',1,0,'2022-03-03 13:24:55','2022-03-03 13:24:55'),(111134,356,'Uchbhitti','496450',1,0,'2022-03-03 13:24:55','2022-03-03 13:24:55'),(111135,356,'Ududa','496116',1,0,'2022-03-03 13:24:56','2022-03-03 13:24:56'),(111136,356,'Ulkhar','496450',1,0,'2022-03-03 13:24:56','2022-03-03 13:24:56'),(111137,356,'Urba','496107',1,0,'2022-03-03 13:24:56','2022-03-03 13:24:56'),(111138,356,'Urdana Camp','496001',1,0,'2022-03-03 13:24:56','2022-03-03 13:24:56'),(111139,356,'Urjanagar Telirampur','496108',1,0,'2022-03-03 13:24:56','2022-03-03 13:24:56'),(111140,356,'Usrot','496001',1,0,'2022-03-03 13:24:56','2022-03-03 13:24:56'),(111141,357,'Abhanpur','493661',1,0,'2022-03-03 13:24:56','2022-03-03 13:24:56'),(111142,357,'Adsena','493225',1,0,'2022-03-03 13:24:56','2022-03-03 13:24:56'),(111143,357,'Ahilda','493526',1,0,'2022-03-03 13:24:56','2022-03-03 13:24:56'),(111144,357,'Akalwara','493992',1,0,'2022-03-03 13:24:56','2022-03-03 13:24:56'),(111145,357,'Akoli','493111',1,0,'2022-03-03 13:24:56','2022-03-03 13:24:56'),(111146,357,'Amakhoha','493335',1,0,'2022-03-03 13:24:56','2022-03-03 13:24:56'),(111147,357,'Amera','493228',1,0,'2022-03-03 13:24:56','2022-03-03 13:24:56'),(111148,357,'Amlipadar','493890',1,0,'2022-03-03 13:24:56','2022-03-03 13:24:56'),(111149,357,'Amodi','493225',1,0,'2022-03-03 13:24:56','2022-03-03 13:24:56'),(111150,357,'Amodi','493559',1,0,'2022-03-03 13:24:56','2022-03-03 13:24:56'),(111151,357,'Amsena','493225',1,0,'2022-03-03 13:24:56','2022-03-03 13:24:56'),(111152,357,'Arang','493441',1,0,'2022-03-03 13:24:56','2022-03-03 13:24:56'),(111153,357,'Arjuni','493228',1,0,'2022-03-03 13:24:56','2022-03-03 13:24:56'),(111154,357,'Arjuni','493331',1,0,'2022-03-03 13:24:56','2022-03-03 13:24:56'),(111155,357,'Atarmara','492109',1,0,'2022-03-03 13:24:56','2022-03-03 13:24:56'),(111156,357,'Bagbuda','493526',1,0,'2022-03-03 13:24:56','2022-03-03 13:24:56'),(111157,357,'Baikunth','493116',1,0,'2022-03-03 13:24:57','2022-03-03 13:24:57'),(111158,357,'Baloda Bazar','493332',1,0,'2022-03-03 13:24:57','2022-03-03 13:24:57'),(111159,357,'Balodi','493228',1,0,'2022-03-03 13:24:57','2022-03-03 13:24:57'),(111160,357,'Balpur','493559',1,0,'2022-03-03 13:24:57','2022-03-03 13:24:57'),(111161,357,'Bamhanpuri','493559',1,0,'2022-03-03 13:24:57','2022-03-03 13:24:57'),(111162,357,'Bana','493225',1,0,'2022-03-03 13:24:57','2022-03-03 13:24:57'),(111163,357,'Bangoli','493225',1,0,'2022-03-03 13:24:57','2022-03-03 13:24:57'),(111164,357,'Banrasi','493225',1,0,'2022-03-03 13:24:57','2022-03-03 13:24:57'),(111165,357,'Bansankra','493101',1,0,'2022-03-03 13:24:57','2022-03-03 13:24:57'),(111166,357,'Barbanda','493111',1,0,'2022-03-03 13:24:57','2022-03-03 13:24:57'),(111167,357,'Bareli','493344',1,0,'2022-03-03 13:24:57','2022-03-03 13:24:57'),(111168,357,'Barna','493663',1,0,'2022-03-03 13:24:57','2022-03-03 13:24:57'),(111169,357,'Barnawapara','493551',1,0,'2022-03-03 13:24:57','2022-03-03 13:24:57'),(111170,357,'Baronda','493885',1,0,'2022-03-03 13:24:57','2022-03-03 13:24:57'),(111171,357,'Barula','493889',1,0,'2022-03-03 13:24:57','2022-03-03 13:24:57'),(111172,357,'Basin','493992',1,0,'2022-03-03 13:24:57','2022-03-03 13:24:57'),(111173,357,'Baya','493551',1,0,'2022-03-03 13:24:57','2022-03-03 13:24:57'),(111174,357,'Belar','493992',1,0,'2022-03-03 13:24:57','2022-03-03 13:24:57'),(111175,357,'Beldar Seoni','493225',1,0,'2022-03-03 13:24:57','2022-03-03 13:24:57'),(111176,357,'Beltukri','493885',1,0,'2022-03-03 13:24:57','2022-03-03 13:24:57'),(111177,357,'Bendri','493661',1,0,'2022-03-03 13:24:57','2022-03-03 13:24:57'),(111178,357,'Bhainsa','493113',1,0,'2022-03-03 13:24:58','2022-03-03 13:24:58'),(111179,357,'Bhainsa','493225',1,0,'2022-03-03 13:24:58','2022-03-03 13:24:58'),(111180,357,'Bhandarpuri','493225',1,0,'2022-03-03 13:24:58','2022-03-03 13:24:58'),(111181,357,'Bhansoj','493441',1,0,'2022-03-03 13:24:58','2022-03-03 13:24:58'),(111182,357,'Bharsela Bada','493332',1,0,'2022-03-03 13:24:58','2022-03-03 13:24:58'),(111183,357,'Bhatapara','493118',1,0,'2022-03-03 13:24:58','2022-03-03 13:24:58'),(111184,357,'Bhatapara Sadar Bazar','493118',1,0,'2022-03-03 13:24:58','2022-03-03 13:24:58'),(111185,357,'Bhatbhera','493195',1,0,'2022-03-03 13:24:58','2022-03-03 13:24:58'),(111186,357,'Bhatgaon (Raipur)','493222',1,0,'2022-03-03 13:24:58','2022-03-03 13:24:58'),(111187,357,'Bhawanipur','493229',1,0,'2022-03-03 13:24:58','2022-03-03 13:24:58'),(111188,357,'Bhendri','493885',1,0,'2022-03-03 13:24:58','2022-03-03 13:24:58'),(111189,357,'Bhilai','493441',1,0,'2022-03-03 13:24:58','2022-03-03 13:24:58'),(111190,357,'Bhinodi','493559',1,0,'2022-03-03 13:24:58','2022-03-03 13:24:58'),(111191,357,'Bhurka','493661',1,0,'2022-03-03 13:24:58','2022-03-03 13:24:58'),(111192,357,'Bijradih','493118',1,0,'2022-03-03 13:24:58','2022-03-03 13:24:58'),(111193,357,'Bijradih','493229',1,0,'2022-03-03 13:24:58','2022-03-03 13:24:58'),(111194,357,'Bilaigarh','493338',1,0,'2022-03-03 13:24:58','2022-03-03 13:24:58'),(111195,357,'Bindranawagarh','493889',1,0,'2022-03-03 13:24:58','2022-03-03 13:24:58'),(111196,357,'Birgaon','493221',1,0,'2022-03-03 13:24:58','2022-03-03 13:24:58'),(111197,357,'Bishrampur','493101',1,0,'2022-03-03 13:24:58','2022-03-03 13:24:58'),(111198,357,'Bitkuli','493118',1,0,'2022-03-03 13:24:58','2022-03-03 13:24:58'),(111199,357,'Borsi','493118',1,0,'2022-03-03 13:24:59','2022-03-03 13:24:59'),(111200,357,'Borsi','493992',1,0,'2022-03-03 13:24:59','2022-03-03 13:24:59'),(111201,357,'Borsi','493335',1,0,'2022-03-03 13:24:59','2022-03-03 13:24:59'),(111202,357,'Byron Bazar','492001',1,0,'2022-03-03 13:24:59','2022-03-03 13:24:59'),(111203,357,'Champa','493114',1,0,'2022-03-03 13:24:59','2022-03-03 13:24:59'),(111204,357,'Champa','493332',1,0,'2022-03-03 13:24:59','2022-03-03 13:24:59'),(111205,357,'Champaran','493885',1,0,'2022-03-03 13:24:59','2022-03-03 13:24:59'),(111206,357,'Chand Khuri','492101',1,0,'2022-03-03 13:24:59','2022-03-03 13:24:59'),(111207,357,'Chandan','492112',1,0,'2022-03-03 13:24:59','2022-03-03 13:24:59'),(111208,357,'Chandi Bazar','493661',1,0,'2022-03-03 13:24:59','2022-03-03 13:24:59'),(111209,357,'Charoda','493229',1,0,'2022-03-03 13:24:59','2022-03-03 13:24:59'),(111210,357,'Chaurenga','493101',1,0,'2022-03-03 13:24:59','2022-03-03 13:24:59'),(111211,357,'Chhachhanpairi','493661',1,0,'2022-03-03 13:24:59','2022-03-03 13:24:59'),(111212,357,'Chhapora','493111',1,0,'2022-03-03 13:24:59','2022-03-03 13:24:59'),(111213,357,'Chhataud','493116',1,0,'2022-03-03 13:24:59','2022-03-03 13:24:59'),(111214,357,'Chhatera','493441',1,0,'2022-03-03 13:24:59','2022-03-03 13:24:59'),(111215,357,'Chherkapur','493228',1,0,'2022-03-03 13:24:59','2022-03-03 13:24:59'),(111216,357,'Chhotapara','492001',1,0,'2022-03-03 13:24:59','2022-03-03 13:24:59'),(111217,357,'Chhura','493996',1,0,'2022-03-03 13:24:59','2022-03-03 13:24:59'),(111218,357,'Chichia','493890',1,0,'2022-03-03 13:24:59','2022-03-03 13:24:59'),(111219,357,'Chicholi','493225',1,0,'2022-03-03 13:24:59','2022-03-03 13:24:59'),(111220,357,'Chikhali','493441',1,0,'2022-03-03 13:24:59','2022-03-03 13:24:59'),(111221,357,'Damakheda','493101',1,0,'2022-03-03 13:24:59','2022-03-03 13:24:59'),(111222,357,'Damru','493332',1,0,'2022-03-03 13:25:00','2022-03-03 13:25:00'),(111223,357,'Darba','493661',1,0,'2022-03-03 13:25:00','2022-03-03 13:25:00'),(111224,357,'Darra','493885',1,0,'2022-03-03 13:25:00','2022-03-03 13:25:00'),(111225,357,'Darripara','493889',1,0,'2022-03-03 13:25:00','2022-03-03 13:25:00'),(111226,357,'Datan','493526',1,0,'2022-03-03 13:25:00','2022-03-03 13:25:00'),(111227,357,'Datan','493228',1,0,'2022-03-03 13:25:00','2022-03-03 13:25:00'),(111228,357,'Datrengi','493118',1,0,'2022-03-03 13:25:00','2022-03-03 13:25:00'),(111229,357,'Dayanand Nagar','492001',1,0,'2022-03-03 13:25:00','2022-03-03 13:25:00'),(111230,357,'Deobhog','493890',1,0,'2022-03-03 13:25:00','2022-03-03 13:25:00'),(111231,357,'Deopuri','492015',1,0,'2022-03-03 13:25:00','2022-03-03 13:25:00'),(111232,357,'Deori','493118',1,0,'2022-03-03 13:25:00','2022-03-03 13:25:00'),(111233,357,'Deori','493992',1,0,'2022-03-03 13:25:00','2022-03-03 13:25:00'),(111234,357,'Deori','492112',1,0,'2022-03-03 13:25:00','2022-03-03 13:25:00'),(111235,357,'Deori','493114',1,0,'2022-03-03 13:25:00','2022-03-03 13:25:00'),(111236,357,'Deori','493221',1,0,'2022-03-03 13:25:00','2022-03-03 13:25:00'),(111237,357,'Deortilda','493225',1,0,'2022-03-03 13:25:00','2022-03-03 13:25:00'),(111238,357,'Deosagar','493222',1,0,'2022-03-03 13:25:00','2022-03-03 13:25:00'),(111239,357,'Deosundra','493228',1,0,'2022-03-03 13:25:00','2022-03-03 13:25:00'),(111240,357,'Dhaneli','493118',1,0,'2022-03-03 13:25:00','2022-03-03 13:25:00'),(111241,357,'Dhangaon','493559',1,0,'2022-03-03 13:25:00','2022-03-03 13:25:00'),(111242,357,'Dhansir','493338',1,0,'2022-03-03 13:25:00','2022-03-03 13:25:00'),(111243,357,'Dharashiv','493526',1,0,'2022-03-03 13:25:01','2022-03-03 13:25:01'),(111244,357,'Dharasiv','493338',1,0,'2022-03-03 13:25:01','2022-03-03 13:25:01'),(111245,357,'Dharsiwa','493221',1,0,'2022-03-03 13:25:01','2022-03-03 13:25:01'),(111246,357,'Dhaurabhata','492109',1,0,'2022-03-03 13:25:01','2022-03-03 13:25:01'),(111247,357,'Dhawalpur','493888',1,0,'2022-03-03 13:25:01','2022-03-03 13:25:01'),(111248,357,'Dhobni','493222',1,0,'2022-03-03 13:25:01','2022-03-03 13:25:01'),(111249,357,'Dhruwagudi','493890',1,0,'2022-03-03 13:25:01','2022-03-03 13:25:01'),(111250,357,'Dondekala','493111',1,0,'2022-03-03 13:25:01','2022-03-03 13:25:01'),(111251,357,'Dulla','493996',1,0,'2022-03-03 13:25:01','2022-03-03 13:25:01'),(111252,357,'Durug','493222',1,0,'2022-03-03 13:25:01','2022-03-03 13:25:01'),(111253,357,'Farfod','493441',1,0,'2022-03-03 13:25:01','2022-03-03 13:25:01'),(111254,357,'G.S.i','493111',1,0,'2022-03-03 13:25:01','2022-03-03 13:25:01'),(111255,357,'Gadabhata','493196',1,0,'2022-03-03 13:25:01','2022-03-03 13:25:01'),(111256,357,'Ganiyari','493225',1,0,'2022-03-03 13:25:01','2022-03-03 13:25:01'),(111257,357,'Ganod','493441',1,0,'2022-03-03 13:25:01','2022-03-03 13:25:01'),(111258,357,'Gariaband','493889',1,0,'2022-03-03 13:25:01','2022-03-03 13:25:01'),(111259,357,'Gatadih','493559',1,0,'2022-03-03 13:25:01','2022-03-03 13:25:01'),(111260,357,'Gaurbhat','493441',1,0,'2022-03-03 13:25:01','2022-03-03 13:25:01'),(111261,357,'Gaurgaon','493888',1,0,'2022-03-03 13:25:01','2022-03-03 13:25:01'),(111262,357,'Gendapali','493222',1,0,'2022-03-03 13:25:01','2022-03-03 13:25:01'),(111263,357,'Ghutkunawapara','493889',1,0,'2022-03-03 13:25:01','2022-03-03 13:25:01'),(111264,357,'Gidhauri','493344',1,0,'2022-03-03 13:25:01','2022-03-03 13:25:01'),(111265,357,'Gidhpuri','493229',1,0,'2022-03-03 13:25:02','2022-03-03 13:25:02'),(111266,357,'Girod','493344',1,0,'2022-03-03 13:25:02','2022-03-03 13:25:02'),(111267,357,'Girod','493111',1,0,'2022-03-03 13:25:02','2022-03-03 13:25:02'),(111268,357,'Girsul','493890',1,0,'2022-03-03 13:25:02','2022-03-03 13:25:02'),(111269,357,'Godhi','492101',1,0,'2022-03-03 13:25:02','2022-03-03 13:25:02'),(111270,357,'Gona','493888',1,0,'2022-03-03 13:25:02','2022-03-03 13:25:02'),(111271,357,'Grasim Vihar Rawan','493196',1,0,'2022-03-03 13:25:02','2022-03-03 13:25:02'),(111272,357,'Gudhiyari','492009',1,0,'2022-03-03 13:25:02','2022-03-03 13:25:02'),(111273,357,'Gukhera','493441',1,0,'2022-03-03 13:25:02','2022-03-03 13:25:02'),(111274,357,'Gullu','493441',1,0,'2022-03-03 13:25:02','2022-03-03 13:25:02'),(111275,357,'Guma','493196',1,0,'2022-03-03 13:25:02','2022-03-03 13:25:02'),(111276,357,'Gurra','493118',1,0,'2022-03-03 13:25:02','2022-03-03 13:25:02'),(111277,357,'Harinbhatta','493229',1,0,'2022-03-03 13:25:02','2022-03-03 13:25:02'),(111278,357,'Hasda','492109',1,0,'2022-03-03 13:25:02','2022-03-03 13:25:02'),(111279,357,'Hasda-11','493661',1,0,'2022-03-03 13:25:02','2022-03-03 13:25:02'),(111280,357,'Hasuwa','493344',1,0,'2022-03-03 13:25:02','2022-03-03 13:25:02'),(111281,357,'Hathband','493113',1,0,'2022-03-03 13:25:02','2022-03-03 13:25:02'),(111282,357,'Hatodbazar','493335',1,0,'2022-03-03 13:25:02','2022-03-03 13:25:02'),(111283,357,'Hirmi','493195',1,0,'2022-03-03 13:25:02','2022-03-03 13:25:02'),(111284,357,'Indagaon','493888',1,0,'2022-03-03 13:25:02','2022-03-03 13:25:02'),(111285,357,'Jamgaon','493992',1,0,'2022-03-03 13:25:02','2022-03-03 13:25:02'),(111286,357,'Jangda','493113',1,0,'2022-03-03 13:25:02','2022-03-03 13:25:02'),(111287,357,'Jara','493229',1,0,'2022-03-03 13:25:02','2022-03-03 13:25:02'),(111288,357,'Jaraud','493118',1,0,'2022-03-03 13:25:03','2022-03-03 13:25:03'),(111289,357,'Jerway','493229',1,0,'2022-03-03 13:25:03','2022-03-03 13:25:03'),(111290,357,'Jhabdi','493344',1,0,'2022-03-03 13:25:03','2022-03-03 13:25:03'),(111291,357,'Jhakharpara','493890',1,0,'2022-03-03 13:25:03','2022-03-03 13:25:03'),(111292,357,'Jidar','493888',1,0,'2022-03-03 13:25:03','2022-03-03 13:25:03'),(111293,357,'Joba','493889',1,0,'2022-03-03 13:25:03','2022-03-03 13:25:03'),(111294,357,'Junwani','493222',1,0,'2022-03-03 13:25:03','2022-03-03 13:25:03'),(111295,357,'Kadlimuda','493890',1,0,'2022-03-03 13:25:03','2022-03-03 13:25:03'),(111296,357,'Kalibadi','492001',1,0,'2022-03-03 13:25:03','2022-03-03 13:25:03'),(111297,357,'Kamta','493101',1,0,'2022-03-03 13:25:03','2022-03-03 13:25:03'),(111298,357,'Kandekela','493890',1,0,'2022-03-03 13:25:03','2022-03-03 13:25:03'),(111299,357,'Kanesar','493996',1,0,'2022-03-03 13:25:03','2022-03-03 13:25:03'),(111300,357,'Kanki','493225',1,0,'2022-03-03 13:25:03','2022-03-03 13:25:03'),(111301,357,'Kansinghi','493996',1,0,'2022-03-03 13:25:03','2022-03-03 13:25:03'),(111302,357,'Kareli','493885',1,0,'2022-03-03 13:25:03','2022-03-03 13:25:03'),(111303,357,'Karhi Bazar','493118',1,0,'2022-03-03 13:25:03','2022-03-03 13:25:03'),(111304,357,'Karhul','493101',1,0,'2022-03-03 13:25:03','2022-03-03 13:25:03'),(111305,357,'Karmada','493331',1,0,'2022-03-03 13:25:03','2022-03-03 13:25:03'),(111306,357,'Kasdol','493335',1,0,'2022-03-03 13:25:03','2022-03-03 13:25:03'),(111307,357,'Katgi','493344',1,0,'2022-03-03 13:25:03','2022-03-03 13:25:03'),(111308,357,'Kathia-11','493661',1,0,'2022-03-03 13:25:03','2022-03-03 13:25:03'),(111309,357,'Kathia-i','493225',1,0,'2022-03-03 13:25:03','2022-03-03 13:25:03'),(111310,357,'Kendri','493661',1,0,'2022-03-03 13:25:03','2022-03-03 13:25:03'),(111311,357,'Kesda','493113',1,0,'2022-03-03 13:25:04','2022-03-03 13:25:04'),(111312,357,'Khadma','493996',1,0,'2022-03-03 13:25:04','2022-03-03 13:25:04'),(111313,357,'Khainda','493332',1,0,'2022-03-03 13:25:04','2022-03-03 13:25:04'),(111314,357,'Khairkhut','493221',1,0,'2022-03-03 13:25:04','2022-03-03 13:25:04'),(111315,357,'Khamtarai','492008',1,0,'2022-03-03 13:25:04','2022-03-03 13:25:04'),(111316,357,'Kharora','493225',1,0,'2022-03-03 13:25:04','2022-03-03 13:25:04'),(111317,357,'Khatiapati','493332',1,0,'2022-03-03 13:25:04','2022-03-03 13:25:04'),(111318,357,'Khauli','493225',1,0,'2022-03-03 13:25:04','2022-03-03 13:25:04'),(111319,357,'Khauna','493225',1,0,'2022-03-03 13:25:04','2022-03-03 13:25:04'),(111320,357,'Khoksara','493890',1,0,'2022-03-03 13:25:04','2022-03-03 13:25:04'),(111321,357,'Khola','493661',1,0,'2022-03-03 13:25:04','2022-03-03 13:25:04'),(111322,357,'Khorpa','493661',1,0,'2022-03-03 13:25:04','2022-03-03 13:25:04'),(111323,357,'Kirwai','493885',1,0,'2022-03-03 13:25:04','2022-03-03 13:25:04'),(111324,357,'Kochwai','493889',1,0,'2022-03-03 13:25:04','2022-03-03 13:25:04'),(111325,357,'Kodwa','493118',1,0,'2022-03-03 13:25:04','2022-03-03 13:25:04'),(111326,357,'Kohraud','493526',1,0,'2022-03-03 13:25:04','2022-03-03 13:25:04'),(111327,357,'Kolar','493661',1,0,'2022-03-03 13:25:04','2022-03-03 13:25:04'),(111328,357,'Koliha','493118',1,0,'2022-03-03 13:25:04','2022-03-03 13:25:04'),(111329,357,'Konari','493228',1,0,'2022-03-03 13:25:04','2022-03-03 13:25:04'),(111330,357,'Kondapar','493661',1,0,'2022-03-03 13:25:04','2022-03-03 13:25:04'),(111331,357,'Kondkera','493992',1,0,'2022-03-03 13:25:04','2022-03-03 13:25:04'),(111332,357,'Korasi','493225',1,0,'2022-03-03 13:25:05','2022-03-03 13:25:05'),(111333,357,'Kosamkunda','493559',1,0,'2022-03-03 13:25:05','2022-03-03 13:25:05'),(111334,357,'Kosamsara','493335',1,0,'2022-03-03 13:25:05','2022-03-03 13:25:05'),(111335,357,'Kosmandi','493228',1,0,'2022-03-03 13:25:05','2022-03-03 13:25:05'),(111336,357,'Kosmi','493996',1,0,'2022-03-03 13:25:05','2022-03-03 13:25:05'),(111337,357,'Kosrangi','493225',1,0,'2022-03-03 13:25:05','2022-03-03 13:25:05'),(111338,357,'Kotigaon','493996',1,0,'2022-03-03 13:25:05','2022-03-03 13:25:05'),(111339,357,'Koyda','493526',1,0,'2022-03-03 13:25:05','2022-03-03 13:25:05'),(111340,357,'Krishak Nagar','492012',1,0,'2022-03-03 13:25:05','2022-03-03 13:25:05'),(111341,357,'Kumhari','493338',1,0,'2022-03-03 13:25:05','2022-03-03 13:25:05'),(111342,357,'Kurra','493221',1,0,'2022-03-03 13:25:05','2022-03-03 13:25:05'),(111343,357,'Kurru','493661',1,0,'2022-03-03 13:25:05','2022-03-03 13:25:05'),(111344,357,'Kurud Camp','492101',1,0,'2022-03-03 13:25:05','2022-03-03 13:25:05'),(111345,357,'Kurud Kutela','493441',1,0,'2022-03-03 13:25:05','2022-03-03 13:25:05'),(111346,357,'Kusmi','493228',1,0,'2022-03-03 13:25:05','2022-03-03 13:25:05'),(111347,357,'Lachhanpur','493526',1,0,'2022-03-03 13:25:05','2022-03-03 13:25:05'),(111348,357,'Lahod','493526',1,0,'2022-03-03 13:25:05','2022-03-03 13:25:05'),(111349,357,'Lakholi','493441',1,0,'2022-03-03 13:25:05','2022-03-03 13:25:05'),(111350,357,'Latapara','493890',1,0,'2022-03-03 13:25:05','2022-03-03 13:25:05'),(111351,357,'Latuwa','493332',1,0,'2022-03-03 13:25:05','2022-03-03 13:25:05'),(111352,357,'Lawan','493526',1,0,'2022-03-03 13:25:05','2022-03-03 13:25:05'),(111353,357,'Litipara','493889',1,0,'2022-03-03 13:25:05','2022-03-03 13:25:05'),(111354,357,'Loharsi','492109',1,0,'2022-03-03 13:25:05','2022-03-03 13:25:05'),(111355,357,'Lohjhar','493996',1,0,'2022-03-03 13:25:05','2022-03-03 13:25:05'),(111356,357,'Madanpur','493889',1,0,'2022-03-03 13:25:06','2022-03-03 13:25:06'),(111357,357,'Madeli','493996',1,0,'2022-03-03 13:25:06','2022-03-03 13:25:06'),(111358,357,'Madhaibhata','493559',1,0,'2022-03-03 13:25:06','2022-03-03 13:25:06'),(111359,357,'Madhi','493116',1,0,'2022-03-03 13:25:06','2022-03-03 13:25:06'),(111360,357,'Mainpur','493888',1,0,'2022-03-03 13:25:06','2022-03-03 13:25:06'),(111361,357,'Mainpur-II','493888',1,0,'2022-03-03 13:25:06','2022-03-03 13:25:06'),(111362,357,'Malda','493344',1,0,'2022-03-03 13:25:06','2022-03-03 13:25:06'),(111363,357,'Maldi','493331',1,0,'2022-03-03 13:25:06','2022-03-03 13:25:06'),(111364,357,'Malgaon','493889',1,0,'2022-03-03 13:25:06','2022-03-03 13:25:06'),(111365,357,'Mana','492015',1,0,'2022-03-03 13:25:06','2022-03-03 13:25:06'),(111366,357,'Mana Camp','492015',1,0,'2022-03-03 13:25:06','2022-03-03 13:25:06'),(111367,357,'Mandhar','493111',1,0,'2022-03-03 13:25:06','2022-03-03 13:25:06'),(111368,357,'Mandhar Cement Factory','493111',1,0,'2022-03-03 13:25:06','2022-03-03 13:25:06'),(111369,357,'Mandir Hasod','492101',1,0,'2022-03-03 13:25:06','2022-03-03 13:25:06'),(111370,357,'Manikchouri','493661',1,0,'2022-03-03 13:25:06','2022-03-03 13:25:06'),(111371,357,'Manohara','493116',1,0,'2022-03-03 13:25:06','2022-03-03 13:25:06'),(111372,357,'Manpasar','493559',1,0,'2022-03-03 13:25:06','2022-03-03 13:25:06'),(111373,357,'Mantralaya Raipur','492002',1,0,'2022-03-03 13:25:06','2022-03-03 13:25:06'),(111374,357,'Marda','493526',1,0,'2022-03-03 13:25:06','2022-03-03 13:25:06'),(111375,357,'Maroda','493889',1,0,'2022-03-03 13:25:06','2022-03-03 13:25:06'),(111376,357,'Mathpurena','492013',1,0,'2022-03-03 13:25:06','2022-03-03 13:25:06'),(111377,357,'Matia','493344',1,0,'2022-03-03 13:25:07','2022-03-03 13:25:07'),(111378,357,'Mohbhatta','493113',1,0,'2022-03-03 13:25:07','2022-03-03 13:25:07'),(111379,357,'Mohdi','493111',1,0,'2022-03-03 13:25:07','2022-03-03 13:25:07'),(111380,357,'Mohra','493225',1,0,'2022-03-03 13:25:07','2022-03-03 13:25:07'),(111381,357,'Mohrenga','493225',1,0,'2022-03-03 13:25:07','2022-03-03 13:25:07'),(111382,357,'Mohtara','493335',1,0,'2022-03-03 13:25:07','2022-03-03 13:25:07'),(111383,357,'Mohtara','493344',1,0,'2022-03-03 13:25:07','2022-03-03 13:25:07'),(111384,357,'Mopar','493331',1,0,'2022-03-03 13:25:07','2022-03-03 13:25:07'),(111385,357,'Mopka','493118',1,0,'2022-03-03 13:25:07','2022-03-03 13:25:07'),(111386,357,'Mudgelmal','493890',1,0,'2022-03-03 13:25:07','2022-03-03 13:25:07'),(111387,357,'Mudparsandi','493229',1,0,'2022-03-03 13:25:07','2022-03-03 13:25:07'),(111388,357,'Mundibhawar','492109',1,0,'2022-03-03 13:25:07','2022-03-03 13:25:07'),(111389,357,'Mungijhar','493890',1,0,'2022-03-03 13:25:07','2022-03-03 13:25:07'),(111390,357,'Nagarda','492112',1,0,'2022-03-03 13:25:07','2022-03-03 13:25:07'),(111391,357,'Nagarda','493338',1,0,'2022-03-03 13:25:07','2022-03-03 13:25:07'),(111392,357,'Nagargaon','493111',1,0,'2022-03-03 13:25:07','2022-03-03 13:25:07'),(111393,357,'Nahargaon','493889',1,0,'2022-03-03 13:25:07','2022-03-03 13:25:07'),(111394,357,'Nardaha','493111',1,0,'2022-03-03 13:25:07','2022-03-03 13:25:07'),(111395,357,'Nawagaon','493885',1,0,'2022-03-03 13:25:07','2022-03-03 13:25:07'),(111396,357,'Nawagaon','492112',1,0,'2022-03-03 13:25:07','2022-03-03 13:25:07'),(111397,357,'Nawapara','493113',1,0,'2022-03-03 13:25:07','2022-03-03 13:25:07'),(111398,357,'Nawapara Rajim','493881',1,0,'2022-03-03 13:25:07','2022-03-03 13:25:07'),(111399,357,'Neora (Raipur)','493114',1,0,'2022-03-03 13:25:07','2022-03-03 13:25:07'),(111400,357,'Newari','493196',1,0,'2022-03-03 13:25:08','2022-03-03 13:25:08'),(111401,357,'Nipania','493118',1,0,'2022-03-03 13:25:08','2022-03-03 13:25:08'),(111402,357,'Nistiguda','493890',1,0,'2022-03-03 13:25:08','2022-03-03 13:25:08'),(111403,357,'Odan','493229',1,0,'2022-03-03 13:25:08','2022-03-03 13:25:08'),(111404,357,'P.Jamgaon','493661',1,0,'2022-03-03 13:25:08','2022-03-03 13:25:08'),(111405,357,'Paktia','493996',1,0,'2022-03-03 13:25:08','2022-03-03 13:25:08'),(111406,357,'Pallari','493228',1,0,'2022-03-03 13:25:08','2022-03-03 13:25:08'),(111407,357,'Palod','492101',1,0,'2022-03-03 13:25:08','2022-03-03 13:25:08'),(111408,357,'Pandri','492004',1,0,'2022-03-03 13:25:08','2022-03-03 13:25:08'),(111409,357,'Pandripali','493559',1,0,'2022-03-03 13:25:08','2022-03-03 13:25:08'),(111410,357,'Panduka','492109',1,0,'2022-03-03 13:25:08','2022-03-03 13:25:08'),(111411,357,'Pangaon','493332',1,0,'2022-03-03 13:25:08','2022-03-03 13:25:08'),(111412,357,'Paragaon','493441',1,0,'2022-03-03 13:25:08','2022-03-03 13:25:08'),(111413,357,'Parsada','493885',1,0,'2022-03-03 13:25:08','2022-03-03 13:25:08'),(111414,357,'Parsada','493661',1,0,'2022-03-03 13:25:08','2022-03-03 13:25:08'),(111415,357,'Parsadakala','493992',1,0,'2022-03-03 13:25:08','2022-03-03 13:25:08'),(111416,357,'Parsadih','493338',1,0,'2022-03-03 13:25:08','2022-03-03 13:25:08'),(111417,357,'Parsapali','493338',1,0,'2022-03-03 13:25:08','2022-03-03 13:25:08'),(111418,357,'Parsuli','493889',1,0,'2022-03-03 13:25:08','2022-03-03 13:25:08'),(111419,357,'Patewa','493885',1,0,'2022-03-03 13:25:09','2022-03-03 13:25:09'),(111420,357,'Pathar','492109',1,0,'2022-03-03 13:25:09','2022-03-03 13:25:09'),(111421,357,'Pathari','493116',1,0,'2022-03-03 13:25:09','2022-03-03 13:25:09'),(111422,357,'Patseoni','493996',1,0,'2022-03-03 13:25:09','2022-03-03 13:25:09'),(111423,357,'Pauni','493338',1,0,'2022-03-03 13:25:09','2022-03-03 13:25:09'),(111424,357,'Pendra','493992',1,0,'2022-03-03 13:25:09','2022-03-03 13:25:09'),(111425,357,'Pendrawan','493559',1,0,'2022-03-03 13:25:09','2022-03-03 13:25:09'),(111426,357,'Phingeshwar','493992',1,0,'2022-03-03 13:25:09','2022-03-03 13:25:09'),(111427,357,'Piperchhedi','493889',1,0,'2022-03-03 13:25:09','2022-03-03 13:25:09'),(111428,357,'Piprod','493661',1,0,'2022-03-03 13:25:09','2022-03-03 13:25:09'),(111429,357,'Pisid','493335',1,0,'2022-03-03 13:25:09','2022-03-03 13:25:09'),(111430,357,'Pond','493661',1,0,'2022-03-03 13:25:09','2022-03-03 13:25:09'),(111431,357,'Pond','492109',1,0,'2022-03-03 13:25:09','2022-03-03 13:25:09'),(111432,357,'Purani Basti (Raipur)','492001',1,0,'2022-03-03 13:25:09','2022-03-03 13:25:09'),(111433,357,'Purgaon','493338',1,0,'2022-03-03 13:25:09','2022-03-03 13:25:09'),(111434,357,'Putpura','493228',1,0,'2022-03-03 13:25:09','2022-03-03 13:25:09'),(111435,357,'Raikhera','493225',1,0,'2022-03-03 13:25:09','2022-03-03 13:25:09'),(111436,357,'Raikona','493559',1,0,'2022-03-03 13:25:09','2022-03-03 13:25:09'),(111437,357,'Raipur Ganj','492009',1,0,'2022-03-03 13:25:09','2022-03-03 13:25:09'),(111438,357,'Raipur H.O','492001',1,0,'2022-03-03 13:25:10','2022-03-03 13:25:10'),(111439,357,'Raipur Kutchery','492001',1,0,'2022-03-03 13:25:10','2022-03-03 13:25:10'),(111440,357,'Raipura','492013',1,0,'2022-03-03 13:25:10','2022-03-03 13:25:10'),(111441,357,'Rajendra Nagar (Raipur)','492001',1,0,'2022-03-03 13:25:10','2022-03-03 13:25:10'),(111442,357,'Rajim','493885',1,0,'2022-03-03 13:25:10','2022-03-03 13:25:10'),(111443,357,'Rajkumar College','492013',1,0,'2022-03-03 13:25:10','2022-03-03 13:25:10'),(111444,357,'Rakhi','492015',1,0,'2022-03-03 13:25:10','2022-03-03 13:25:10'),(111445,357,'Ranipartewa','493996',1,0,'2022-03-03 13:25:10','2022-03-03 13:25:10'),(111446,357,'Raseda','493332',1,0,'2022-03-03 13:25:10','2022-03-03 13:25:10'),(111447,357,'Rasela','493996',1,0,'2022-03-03 13:25:10','2022-03-03 13:25:10'),(111448,357,'Rasni','493441',1,0,'2022-03-03 13:25:10','2022-03-03 13:25:10'),(111449,357,'Ravi Shankar University','492010',1,0,'2022-03-03 13:25:10','2022-03-03 13:25:10'),(111450,357,'Ravigram','492001',1,0,'2022-03-03 13:25:10','2022-03-03 13:25:10'),(111451,357,'Rawan','493196',1,0,'2022-03-03 13:25:10','2022-03-03 13:25:10'),(111452,357,'Rawan','493331',1,0,'2022-03-03 13:25:10','2022-03-03 13:25:10'),(111453,357,'Rewa Lakholi','493441',1,0,'2022-03-03 13:25:10','2022-03-03 13:25:10'),(111454,357,'Rikokala','492112',1,0,'2022-03-03 13:25:10','2022-03-03 13:25:10'),(111455,357,'Risda','493332',1,0,'2022-03-03 13:25:10','2022-03-03 13:25:10'),(111456,357,'Rohansi','493228',1,0,'2022-03-03 13:25:10','2022-03-03 13:25:10'),(111457,357,'Rohra','493118',1,0,'2022-03-03 13:25:10','2022-03-03 13:25:10'),(111458,357,'Ruwad','493889',1,0,'2022-03-03 13:25:11','2022-03-03 13:25:11'),(111459,357,'Saddu','492014',1,0,'2022-03-03 13:25:11','2022-03-03 13:25:11'),(111460,357,'Saliha','493338',1,0,'2022-03-03 13:25:11','2022-03-03 13:25:11'),(111461,357,'Saloni','493228',1,0,'2022-03-03 13:25:11','2022-03-03 13:25:11'),(111462,357,'Salonikala','493222',1,0,'2022-03-03 13:25:11','2022-03-03 13:25:11'),(111463,357,'Samoda','493441',1,0,'2022-03-03 13:25:11','2022-03-03 13:25:11'),(111464,357,'Saragaon','493225',1,0,'2022-03-03 13:25:11','2022-03-03 13:25:11'),(111465,357,'Sargiguda','493890',1,0,'2022-03-03 13:25:11','2022-03-03 13:25:11'),(111466,357,'Sarkhor','493526',1,0,'2022-03-03 13:25:11','2022-03-03 13:25:11'),(111467,357,'Sarnabahal','493890',1,0,'2022-03-03 13:25:11','2022-03-03 13:25:11'),(111468,357,'Sarora','493221',1,0,'2022-03-03 13:25:11','2022-03-03 13:25:11'),(111469,357,'Sarora','493114',1,0,'2022-03-03 13:25:11','2022-03-03 13:25:11'),(111470,357,'Sarsiwa','493559',1,0,'2022-03-03 13:25:11','2022-03-03 13:25:11'),(111471,357,'Sarwa','493344',1,0,'2022-03-03 13:25:11','2022-03-03 13:25:11'),(111472,357,'Sasaha','493228',1,0,'2022-03-03 13:25:11','2022-03-03 13:25:11'),(111473,357,'Science College','492010',1,0,'2022-03-03 13:25:11','2022-03-03 13:25:11'),(111474,357,'Sejbahar','492015',1,0,'2022-03-03 13:25:11','2022-03-03 13:25:11'),(111475,357,'Sel','493344',1,0,'2022-03-03 13:25:11','2022-03-03 13:25:11'),(111476,357,'Semra','493885',1,0,'2022-03-03 13:25:11','2022-03-03 13:25:11'),(111477,357,'Semradih','493332',1,0,'2022-03-03 13:25:12','2022-03-03 13:25:12'),(111478,357,'Senduras','493559',1,0,'2022-03-03 13:25:12','2022-03-03 13:25:12'),(111479,357,'Seoni','493661',1,0,'2022-03-03 13:25:12','2022-03-03 13:25:12'),(111480,357,'Seoni','493996',1,0,'2022-03-03 13:25:12','2022-03-03 13:25:12'),(111481,357,'Shanker Nagar','492004',1,0,'2022-03-03 13:25:12','2022-03-03 13:25:12'),(111482,357,'Shobha','493888',1,0,'2022-03-03 13:25:12','2022-03-03 13:25:12'),(111483,357,'Sikari Kesli','493118',1,0,'2022-03-03 13:25:12','2022-03-03 13:25:12'),(111484,357,'Sikaser','493888',1,0,'2022-03-03 13:25:12','2022-03-03 13:25:12'),(111485,357,'Siltara','493111',1,0,'2022-03-03 13:25:12','2022-03-03 13:25:12'),(111486,357,'Silyari','493116',1,0,'2022-03-03 13:25:12','2022-03-03 13:25:12'),(111487,357,'Simga','493101',1,0,'2022-03-03 13:25:12','2022-03-03 13:25:12'),(111488,357,'Sinapali','493890',1,0,'2022-03-03 13:25:12','2022-03-03 13:25:12'),(111489,357,'Singarpur','493118',1,0,'2022-03-03 13:25:12','2022-03-03 13:25:12'),(111490,357,'Sinodha','493335',1,0,'2022-03-03 13:25:12','2022-03-03 13:25:12'),(111491,357,'Siriadih','493526',1,0,'2022-03-03 13:25:12','2022-03-03 13:25:12'),(111492,357,'Sisdeori','493229',1,0,'2022-03-03 13:25:12','2022-03-03 13:25:12'),(111493,357,'Sitlijor','493890',1,0,'2022-03-03 13:25:12','2022-03-03 13:25:12'),(111494,357,'Sonakhan','492112',1,0,'2022-03-03 13:25:12','2022-03-03 13:25:12'),(111495,357,'Sonardeori','493228',1,0,'2022-03-03 13:25:12','2022-03-03 13:25:12'),(111496,357,'Sondra','493221',1,0,'2022-03-03 13:25:12','2022-03-03 13:25:12'),(111497,357,'Sonpur','492112',1,0,'2022-03-03 13:25:12','2022-03-03 13:25:12'),(111498,357,'Sorid','493992',1,0,'2022-03-03 13:25:13','2022-03-03 13:25:13'),(111499,357,'Suhela','493195',1,0,'2022-03-03 13:25:13','2022-03-03 13:25:13'),(111500,357,'Sunder Nagar','492013',1,0,'2022-03-03 13:25:13','2022-03-03 13:25:13'),(111501,357,'Sunderkera','493661',1,0,'2022-03-03 13:25:13','2022-03-03 13:25:13'),(111502,357,'Sundrawan','493229',1,0,'2022-03-03 13:25:13','2022-03-03 13:25:13'),(111503,357,'Sursabandha','493885',1,0,'2022-03-03 13:25:13','2022-03-03 13:25:13'),(111504,357,'Sutiurkuli','493338',1,0,'2022-03-03 13:25:13','2022-03-03 13:25:13'),(111505,357,'Tadwa','493116',1,0,'2022-03-03 13:25:13','2022-03-03 13:25:13'),(111506,357,'Tamaseoni','493661',1,0,'2022-03-03 13:25:13','2022-03-03 13:25:13'),(111507,357,'Tarenga','493118',1,0,'2022-03-03 13:25:13','2022-03-03 13:25:13'),(111508,357,'Tarighat','493992',1,0,'2022-03-03 13:25:13','2022-03-03 13:25:13'),(111509,357,'Tarpongi','493221',1,0,'2022-03-03 13:25:13','2022-03-03 13:25:13'),(111510,357,'Tarra','493111',1,0,'2022-03-03 13:25:13','2022-03-03 13:25:13'),(111511,357,'Tatibandh','492099',1,0,'2022-03-03 13:25:13','2022-03-03 13:25:13'),(111512,357,'Taurenga','493888',1,0,'2022-03-03 13:25:13','2022-03-03 13:25:13'),(111513,357,'Tekari','493661',1,0,'2022-03-03 13:25:13','2022-03-03 13:25:13'),(111514,357,'Tekarikunda','493225',1,0,'2022-03-03 13:25:13','2022-03-03 13:25:13'),(111515,357,'Telasi','493229',1,0,'2022-03-03 13:25:13','2022-03-03 13:25:13'),(111516,357,'Tenduwa','492099',1,0,'2022-03-03 13:25:13','2022-03-03 13:25:13'),(111517,357,'Tetalkhunti','493890',1,0,'2022-03-03 13:25:14','2022-03-03 13:25:14'),(111518,357,'Thargaon','492112',1,0,'2022-03-03 13:25:14','2022-03-03 13:25:14'),(111519,357,'Tikrapara','493890',1,0,'2022-03-03 13:25:14','2022-03-03 13:25:14'),(111520,357,'Tilda R.S.','493114',1,0,'2022-03-03 13:25:14','2022-03-03 13:25:14'),(111521,357,'Tohda','493195',1,0,'2022-03-03 13:25:14','2022-03-03 13:25:14'),(111522,357,'Tonatar','493331',1,0,'2022-03-03 13:25:14','2022-03-03 13:25:14'),(111523,357,'Tulsi','493101',1,0,'2022-03-03 13:25:14','2022-03-03 13:25:14'),(111524,357,'Tulsi','493195',1,0,'2022-03-03 13:25:14','2022-03-03 13:25:14'),(111525,357,'Tundra','493344',1,0,'2022-03-03 13:25:14','2022-03-03 13:25:14'),(111526,357,'Tundri','493338',1,0,'2022-03-03 13:25:14','2022-03-03 13:25:14'),(111527,357,'Uparwara','493661',1,0,'2022-03-03 13:25:14','2022-03-03 13:25:14'),(111528,357,'Urla','492003',1,0,'2022-03-03 13:25:14','2022-03-03 13:25:14'),(111529,357,'Urmal','493890',1,0,'2022-03-03 13:25:14','2022-03-03 13:25:14'),(111530,357,'Vidhan Sabha (Raipur)','492005',1,0,'2022-03-03 13:25:14','2022-03-03 13:25:14'),(111531,357,'Vivekanand Ashram','492001',1,0,'2022-03-03 13:25:14','2022-03-03 13:25:14'),(111532,357,'W.R.S.Colony','492008',1,0,'2022-03-03 13:25:14','2022-03-03 13:25:14'),(111533,357,'Watgan','493229',1,0,'2022-03-03 13:25:14','2022-03-03 13:25:14'),(111534,358,'Alkanhar','491666',1,0,'2022-03-03 13:25:14','2022-03-03 13:25:14'),(111535,358,'Amatola','491668',1,0,'2022-03-03 13:25:14','2022-03-03 13:25:14'),(111536,358,'Ambagarh Chowki','491665',1,0,'2022-03-03 13:25:14','2022-03-03 13:25:14'),(111537,358,'Amgaon','491668',1,0,'2022-03-03 13:25:14','2022-03-03 13:25:14'),(111538,358,'Andi','491445',1,0,'2022-03-03 13:25:14','2022-03-03 13:25:14'),(111539,358,'Arajkund','491665',1,0,'2022-03-03 13:25:14','2022-03-03 13:25:14'),(111540,358,'Arjuni','491441',1,0,'2022-03-03 13:25:14','2022-03-03 13:25:14'),(111541,358,'Asra','491558',1,0,'2022-03-03 13:25:15','2022-03-03 13:25:15'),(111542,358,'Atargaon','491661',1,0,'2022-03-03 13:25:15','2022-03-03 13:25:15'),(111543,358,'Ataria','491888',1,0,'2022-03-03 13:25:15','2022-03-03 13:25:15'),(111544,358,'Aundhi','491229',1,0,'2022-03-03 13:25:15','2022-03-03 13:25:15'),(111545,358,'Baghera','491441',1,0,'2022-03-03 13:25:15','2022-03-03 13:25:15'),(111546,358,'Bagnadi','491557',1,0,'2022-03-03 13:25:15','2022-03-03 13:25:15'),(111547,358,'Bagrekasa','491557',1,0,'2022-03-03 13:25:15','2022-03-03 13:25:15'),(111548,358,'Bajrangpur Nawagaon','491441',1,0,'2022-03-03 13:25:15','2022-03-03 13:25:15'),(111549,358,'Bakal','491441',1,0,'2022-03-03 13:25:15','2022-03-03 13:25:15'),(111550,358,'Baldeopur','491881',1,0,'2022-03-03 13:25:15','2022-03-03 13:25:15'),(111551,358,'Bamhani Charbhata','491558',1,0,'2022-03-03 13:25:15','2022-03-03 13:25:15'),(111552,358,'Bandha Bazar','491668',1,0,'2022-03-03 13:25:15','2022-03-03 13:25:15'),(111553,358,'Bazar Rajnadngaon','491441',1,0,'2022-03-03 13:25:15','2022-03-03 13:25:15'),(111554,358,'Belargondi','491668',1,0,'2022-03-03 13:25:15','2022-03-03 13:25:15'),(111555,358,'Bhadsena','491665',1,0,'2022-03-03 13:25:15','2022-03-03 13:25:15'),(111556,358,'Bhainstara','491444',1,0,'2022-03-03 13:25:15','2022-03-03 13:25:15'),(111557,358,'Bhandarpur','491445',1,0,'2022-03-03 13:25:15','2022-03-03 13:25:15'),(111558,358,'Bharregaon','491441',1,0,'2022-03-03 13:25:15','2022-03-03 13:25:15'),(111559,358,'Bharritola','491229',1,0,'2022-03-03 13:25:15','2022-03-03 13:25:15'),(111560,358,'Bhawsha','491229',1,0,'2022-03-03 13:25:16','2022-03-03 13:25:16'),(111561,358,'Bhedikala','491441',1,0,'2022-03-03 13:25:16','2022-03-03 13:25:16'),(111562,358,'Bholapur','491558',1,0,'2022-03-03 13:25:16','2022-03-03 13:25:16'),(111563,358,'Bhothli','491445',1,0,'2022-03-03 13:25:16','2022-03-03 13:25:16'),(111564,358,'Bijetala','491444',1,0,'2022-03-03 13:25:16','2022-03-03 13:25:16'),(111565,358,'Bori','491441',1,0,'2022-03-03 13:25:16','2022-03-03 13:25:16'),(111566,358,'Bortalo','491445',1,0,'2022-03-03 13:25:16','2022-03-03 13:25:16'),(111567,358,'Buchatola','491558',1,0,'2022-03-03 13:25:16','2022-03-03 13:25:16'),(111568,358,'Chachanpahari','491665',1,0,'2022-03-03 13:25:16','2022-03-03 13:25:16'),(111569,358,'Charbhata','491668',1,0,'2022-03-03 13:25:16','2022-03-03 13:25:16'),(111570,358,'Charbhata','491557',1,0,'2022-03-03 13:25:16','2022-03-03 13:25:16'),(111571,358,'Chhuikhadan','491885',1,0,'2022-03-03 13:25:16','2022-03-03 13:25:16'),(111572,358,'Chhuria','491558',1,0,'2022-03-03 13:25:16','2022-03-03 13:25:16'),(111573,358,'Chichola','491557',1,0,'2022-03-03 13:25:16','2022-03-03 13:25:16'),(111574,358,'Chicholatolagaon','491881',1,0,'2022-03-03 13:25:16','2022-03-03 13:25:16'),(111575,358,'Chiddo','491445',1,0,'2022-03-03 13:25:16','2022-03-03 13:25:16'),(111576,358,'Chikhli','491668',1,0,'2022-03-03 13:25:16','2022-03-03 13:25:16'),(111577,358,'Chilhati','491668',1,0,'2022-03-03 13:25:16','2022-03-03 13:25:16'),(111578,358,'Chircharikala','491668',1,0,'2022-03-03 13:25:16','2022-03-03 13:25:16'),(111579,358,'Dangarh','491665',1,0,'2022-03-03 13:25:16','2022-03-03 13:25:16'),(111580,358,'Dania','491888',1,0,'2022-03-03 13:25:16','2022-03-03 13:25:16'),(111581,358,'Dautola','491668',1,0,'2022-03-03 13:25:16','2022-03-03 13:25:16'),(111582,358,'Deokatta','491445',1,0,'2022-03-03 13:25:16','2022-03-03 13:25:16'),(111583,358,'Deori','491881',1,0,'2022-03-03 13:25:16','2022-03-03 13:25:16'),(111584,358,'Deoribhat','491881',1,0,'2022-03-03 13:25:17','2022-03-03 13:25:17'),(111585,358,'Dhangaon','491441',1,0,'2022-03-03 13:25:17','2022-03-03 13:25:17'),(111586,358,'Dhara','491445',1,0,'2022-03-03 13:25:17','2022-03-03 13:25:17'),(111587,358,'Dhokla','491229',1,0,'2022-03-03 13:25:17','2022-03-03 13:25:17'),(111588,358,'Dighwadi','491229',1,0,'2022-03-03 13:25:17','2022-03-03 13:25:17'),(111589,358,'Dilapahari','491441',1,0,'2022-03-03 13:25:17','2022-03-03 13:25:17'),(111590,358,'Diwanbhedi','491661',1,0,'2022-03-03 13:25:17','2022-03-03 13:25:17'),(111591,358,'Dokrabhat','491885',1,0,'2022-03-03 13:25:17','2022-03-03 13:25:17'),(111592,358,'Dongargaon','491661',1,0,'2022-03-03 13:25:17','2022-03-03 13:25:17'),(111593,358,'Dongargarh Rly Colony','491445',1,0,'2022-03-03 13:25:17','2022-03-03 13:25:17'),(111594,358,'Dongargarh','491445',1,0,'2022-03-03 13:25:17','2022-03-03 13:25:17'),(111595,358,'Dumardihkhurd','491441',1,0,'2022-03-03 13:25:17','2022-03-03 13:25:17'),(111596,358,'Dumartola','491666',1,0,'2022-03-03 13:25:17','2022-03-03 13:25:17'),(111597,358,'G G Chowk Rajnandgaon','491441',1,0,'2022-03-03 13:25:17','2022-03-03 13:25:17'),(111598,358,'Gaindatola','491558',1,0,'2022-03-03 13:25:17','2022-03-03 13:25:17'),(111599,358,'Gandai Pandaria','491888',1,0,'2022-03-03 13:25:17','2022-03-03 13:25:17'),(111600,358,'Gataparkala','491444',1,0,'2022-03-03 13:25:17','2022-03-03 13:25:17'),(111601,358,'Ghotia','491229',1,0,'2022-03-03 13:25:17','2022-03-03 13:25:17'),(111602,358,'Ghumka','491444',1,0,'2022-03-03 13:25:17','2022-03-03 13:25:17'),(111603,358,'Gidarri','491661',1,0,'2022-03-03 13:25:17','2022-03-03 13:25:17'),(111604,358,'Godalwahi','491661',1,0,'2022-03-03 13:25:17','2022-03-03 13:25:17'),(111605,358,'Gotatola','491666',1,0,'2022-03-03 13:25:17','2022-03-03 13:25:17'),(111606,358,'Haldi','491441',1,0,'2022-03-03 13:25:18','2022-03-03 13:25:18'),(111607,358,'Itar','491881',1,0,'2022-03-03 13:25:18','2022-03-03 13:25:18'),(111608,358,'Jadutola','491668',1,0,'2022-03-03 13:25:18','2022-03-03 13:25:18'),(111609,358,'Jangalpur','491441',1,0,'2022-03-03 13:25:18','2022-03-03 13:25:18'),(111610,358,'Jatkanhar','491445',1,0,'2022-03-03 13:25:18','2022-03-03 13:25:18'),(111611,358,'Jhithratola','491557',1,0,'2022-03-03 13:25:18','2022-03-03 13:25:18'),(111612,358,'Kakaipar','491666',1,0,'2022-03-03 13:25:18','2022-03-03 13:25:18'),(111613,358,'Kallubanjari','491558',1,0,'2022-03-03 13:25:18','2022-03-03 13:25:18'),(111614,358,'Kandadi','491229',1,0,'2022-03-03 13:25:18','2022-03-03 13:25:18'),(111615,358,'Kandadi','491666',1,0,'2022-03-03 13:25:18','2022-03-03 13:25:18'),(111616,358,'Kande','491666',1,0,'2022-03-03 13:25:18','2022-03-03 13:25:18'),(111617,358,'Kanharpuri','491441',1,0,'2022-03-03 13:25:18','2022-03-03 13:25:18'),(111618,358,'Karamtaa','491441',1,0,'2022-03-03 13:25:18','2022-03-03 13:25:18'),(111619,358,'Kaudikasa','491665',1,0,'2022-03-03 13:25:18','2022-03-03 13:25:18'),(111620,358,'Khadgaon','491229',1,0,'2022-03-03 13:25:18','2022-03-03 13:25:18'),(111621,358,'Khairagah Raj','491881',1,0,'2022-03-03 13:25:18','2022-03-03 13:25:18'),(111622,358,'Khaprikhurd','491441',1,0,'2022-03-03 13:25:18','2022-03-03 13:25:18'),(111623,358,'Khobha','491558',1,0,'2022-03-03 13:25:18','2022-03-03 13:25:18'),(111624,358,'Khudmudi','491885',1,0,'2022-03-03 13:25:18','2022-03-03 13:25:18'),(111625,358,'Khujji','491661',1,0,'2022-03-03 13:25:19','2022-03-03 13:25:19'),(111626,358,'Khursipar','491661',1,0,'2022-03-03 13:25:19','2022-03-03 13:25:19'),(111627,358,'Khursitikul','491661',1,0,'2022-03-03 13:25:19','2022-03-03 13:25:19'),(111628,358,'Kokpur','491558',1,0,'2022-03-03 13:25:19','2022-03-03 13:25:19'),(111629,358,'Kongikala','491888',1,0,'2022-03-03 13:25:19','2022-03-03 13:25:19'),(111630,358,'Korchatola','491668',1,0,'2022-03-03 13:25:19','2022-03-03 13:25:19'),(111631,358,'Korramtola','491666',1,0,'2022-03-03 13:25:19','2022-03-03 13:25:19'),(111632,358,'Kothitola','491557',1,0,'2022-03-03 13:25:19','2022-03-03 13:25:19'),(111633,358,'Kumarda','491668',1,0,'2022-03-03 13:25:19','2022-03-03 13:25:19'),(111634,358,'Kumhali','491666',1,0,'2022-03-03 13:25:19','2022-03-03 13:25:19'),(111635,358,'Kumhari','491229',1,0,'2022-03-03 13:25:19','2022-03-03 13:25:19'),(111636,358,'Kusmi Ataria','491885',1,0,'2022-03-03 13:25:19','2022-03-03 13:25:19'),(111637,358,'Kuthelikala','491885',1,0,'2022-03-03 13:25:19','2022-03-03 13:25:19'),(111638,358,'Lakholi','491441',1,0,'2022-03-03 13:25:19','2022-03-03 13:25:19'),(111639,358,'Lalbahadur Nagar','491557',1,0,'2022-03-03 13:25:19','2022-03-03 13:25:19'),(111640,358,'Madian','491557',1,0,'2022-03-03 13:25:19','2022-03-03 13:25:19'),(111641,358,'Mahrum','491661',1,0,'2022-03-03 13:25:19','2022-03-03 13:25:19'),(111642,358,'Mahrumkala','491444',1,0,'2022-03-03 13:25:19','2022-03-03 13:25:19'),(111643,358,'Mahud Machandur','491665',1,0,'2022-03-03 13:25:19','2022-03-03 13:25:19'),(111644,358,'Mandla','491881',1,0,'2022-03-03 13:25:19','2022-03-03 13:25:19'),(111645,358,'Mangata','491441',1,0,'2022-03-03 13:25:19','2022-03-03 13:25:19'),(111646,358,'Mangchua','491665',1,0,'2022-03-03 13:25:19','2022-03-03 13:25:19'),(111647,358,'Manpur (Rajnandgaon)','491229',1,0,'2022-03-03 13:25:19','2022-03-03 13:25:19'),(111648,358,'Maroda','491885',1,0,'2022-03-03 13:25:19','2022-03-03 13:25:19'),(111649,358,'Marri','491665',1,0,'2022-03-03 13:25:20','2022-03-03 13:25:20'),(111650,358,'Mathaldabri','491661',1,0,'2022-03-03 13:25:20','2022-03-03 13:25:20'),(111651,358,'Medha','491445',1,0,'2022-03-03 13:25:20','2022-03-03 13:25:20'),(111652,358,'Mohara','491445',1,0,'2022-03-03 13:25:20','2022-03-03 13:25:20'),(111653,358,'Mohla','491666',1,0,'2022-03-03 13:25:20','2022-03-03 13:25:20'),(111654,358,'Mudhipar','491881',1,0,'2022-03-03 13:25:20','2022-03-03 13:25:20'),(111655,358,'Mudpar','491668',1,0,'2022-03-03 13:25:20','2022-03-03 13:25:20'),(111656,358,'Mukadah','491666',1,0,'2022-03-03 13:25:20','2022-03-03 13:25:20'),(111657,358,'Murmunda','491445',1,0,'2022-03-03 13:25:20','2022-03-03 13:25:20'),(111658,358,'Musra','491445',1,0,'2022-03-03 13:25:20','2022-03-03 13:25:20'),(111659,358,'Nagaldah','491444',1,0,'2022-03-03 13:25:20','2022-03-03 13:25:20'),(111660,358,'Nawagaon','491229',1,0,'2022-03-03 13:25:20','2022-03-03 13:25:20'),(111661,358,'Nedgaon','491229',1,0,'2022-03-03 13:25:20','2022-03-03 13:25:20'),(111662,358,'Padmawatipur','491885',1,0,'2022-03-03 13:25:20','2022-03-03 13:25:20'),(111663,358,'Padumtaa','491441',1,0,'2022-03-03 13:25:20','2022-03-03 13:25:20'),(111664,358,'Pailimeta','491888',1,0,'2022-03-03 13:25:20','2022-03-03 13:25:20'),(111665,358,'Panbaras','491666',1,0,'2022-03-03 13:25:20','2022-03-03 13:25:20'),(111666,358,'Pandadah','491881',1,0,'2022-03-03 13:25:20','2022-03-03 13:25:20'),(111667,358,'Paneka','491441',1,0,'2022-03-03 13:25:20','2022-03-03 13:25:20'),(111668,358,'Paragaonkhurd','491445',1,0,'2022-03-03 13:25:20','2022-03-03 13:25:20'),(111669,358,'Patewa','491444',1,0,'2022-03-03 13:25:20','2022-03-03 13:25:20'),(111670,358,'Patpar','491445',1,0,'2022-03-03 13:25:20','2022-03-03 13:25:20'),(111671,358,'Pendri','491441',1,0,'2022-03-03 13:25:20','2022-03-03 13:25:20'),(111672,358,'Pinkapar','491661',1,0,'2022-03-03 13:25:20','2022-03-03 13:25:20'),(111673,358,'Piparia','491881',1,0,'2022-03-03 13:25:20','2022-03-03 13:25:20'),(111674,358,'Rajnandgaon H.O','491441',1,0,'2022-03-03 13:25:21','2022-03-03 13:25:21'),(111675,358,'Rajnandgaon Kutchery','491441',1,0,'2022-03-03 13:25:21','2022-03-03 13:25:21'),(111676,358,'Rajnandgaon Stadium','491441',1,0,'2022-03-03 13:25:21','2022-03-03 13:25:21'),(111677,358,'Ramatola','491557',1,0,'2022-03-03 13:25:21','2022-03-03 13:25:21'),(111678,358,'Ramtarai','491558',1,0,'2022-03-03 13:25:21','2022-03-03 13:25:21'),(111679,358,'Rengadabri','491665',1,0,'2022-03-03 13:25:21','2022-03-03 13:25:21'),(111680,358,'Rengakathera','491441',1,0,'2022-03-03 13:25:21','2022-03-03 13:25:21'),(111681,358,'Rengakathera','491666',1,0,'2022-03-03 13:25:21','2022-03-03 13:25:21'),(111682,358,'Rengakathera','491668',1,0,'2022-03-03 13:25:21','2022-03-03 13:25:21'),(111683,358,'Rengakhar','491888',1,0,'2022-03-03 13:25:21','2022-03-03 13:25:21'),(111684,358,'Rudgaon','491661',1,0,'2022-03-03 13:25:21','2022-03-03 13:25:21'),(111685,358,'Sadak Chirchari','491557',1,0,'2022-03-03 13:25:21','2022-03-03 13:25:21'),(111686,358,'Sakha','491885',1,0,'2022-03-03 13:25:21','2022-03-03 13:25:21'),(111687,358,'Salhetola','491558',1,0,'2022-03-03 13:25:21','2022-03-03 13:25:21'),(111688,358,'Salhewara','491888',1,0,'2022-03-03 13:25:21','2022-03-03 13:25:21'),(111689,358,'Saloni','491444',1,0,'2022-03-03 13:25:21','2022-03-03 13:25:21'),(111690,358,'Samnapur','491888',1,0,'2022-03-03 13:25:21','2022-03-03 13:25:21'),(111691,358,'Sarkheda','491229',1,0,'2022-03-03 13:25:21','2022-03-03 13:25:21'),(111692,358,'Seoni','491229',1,0,'2022-03-03 13:25:21','2022-03-03 13:25:21'),(111693,358,'Shikari Mahka','491558',1,0,'2022-03-03 13:25:21','2022-03-03 13:25:21'),(111694,358,'Singarghat','491881',1,0,'2022-03-03 13:25:22','2022-03-03 13:25:22'),(111695,358,'Singarpur','491444',1,0,'2022-03-03 13:25:22','2022-03-03 13:25:22'),(111696,358,'Singhola','491441',1,0,'2022-03-03 13:25:22','2022-03-03 13:25:22'),(111697,358,'Sitagaon','491229',1,0,'2022-03-03 13:25:22','2022-03-03 13:25:22'),(111698,358,'Sitagota','491557',1,0,'2022-03-03 13:25:22','2022-03-03 13:25:22'),(111699,358,'Somatola','491666',1,0,'2022-03-03 13:25:22','2022-03-03 13:25:22'),(111700,358,'Somni','491441',1,0,'2022-03-03 13:25:22','2022-03-03 13:25:22'),(111701,358,'Surgi','491441',1,0,'2022-03-03 13:25:22','2022-03-03 13:25:22'),(111702,358,'Tappa','491557',1,0,'2022-03-03 13:25:22','2022-03-03 13:25:22'),(111703,358,'Tedesara','491441',1,0,'2022-03-03 13:25:22','2022-03-03 13:25:22'),(111704,358,'Tendunala','491557',1,0,'2022-03-03 13:25:22','2022-03-03 13:25:22'),(111705,358,'Teregaon','491229',1,0,'2022-03-03 13:25:22','2022-03-03 13:25:22'),(111706,358,'Thakurtola','491888',1,0,'2022-03-03 13:25:22','2022-03-03 13:25:22'),(111707,358,'Tohe','491229',1,0,'2022-03-03 13:25:22','2022-03-03 13:25:22'),(111708,358,'Tumdibod','491441',1,0,'2022-03-03 13:25:22','2022-03-03 13:25:22'),(111709,358,'Udaipur','491885',1,0,'2022-03-03 13:25:22','2022-03-03 13:25:22'),(111710,358,'Umarwahi','491661',1,0,'2022-03-03 13:25:22','2022-03-03 13:25:22'),(111711,358,'Uparwah','491444',1,0,'2022-03-03 13:25:22','2022-03-03 13:25:22'),(111712,358,'Usarwahi','491888',1,0,'2022-03-03 13:25:22','2022-03-03 13:25:22'),(111713,358,'Wasadi','491665',1,0,'2022-03-03 13:25:22','2022-03-03 13:25:22'),(111714,359,'Ajabnagar','497001',1,0,'2022-03-03 13:25:22','2022-03-03 13:25:22'),(111715,359,'Ambikapur H.O','497001',1,0,'2022-03-03 13:25:22','2022-03-03 13:25:22'),(111716,359,'Ambikapur Nyalaya','497001',1,0,'2022-03-03 13:25:22','2022-03-03 13:25:22'),(111717,359,'Ambikapur Town','497001',1,0,'2022-03-03 13:25:22','2022-03-03 13:25:22'),(111718,359,'Annapara','497220',1,0,'2022-03-03 13:25:22','2022-03-03 13:25:22'),(111719,359,'Arabalrampur','497001',1,0,'2022-03-03 13:25:22','2022-03-03 13:25:22'),(111720,359,'Aragarhi Camp','497220',1,0,'2022-03-03 13:25:23','2022-03-03 13:25:23'),(111721,359,'Arooti','497116',1,0,'2022-03-03 13:25:23','2022-03-03 13:25:23'),(111722,359,'Babouli','497101',1,0,'2022-03-03 13:25:23','2022-03-03 13:25:23'),(111723,359,'Baghima','497001',1,0,'2022-03-03 13:25:23','2022-03-03 13:25:23'),(111724,359,'Baijnathpur','497231',1,0,'2022-03-03 13:25:23','2022-03-03 13:25:23'),(111725,359,'Bakalo','497333',1,0,'2022-03-03 13:25:23','2022-03-03 13:25:23'),(111726,359,'Balangi','497225',1,0,'2022-03-03 13:25:23','2022-03-03 13:25:23'),(111727,359,'Balrampur','497119',1,0,'2022-03-03 13:25:23','2022-03-03 13:25:23'),(111728,359,'Baneya','497114',1,0,'2022-03-03 13:25:23','2022-03-03 13:25:23'),(111729,359,'Banja','497231',1,0,'2022-03-03 13:25:23','2022-03-03 13:25:23'),(111730,359,'Bardar','497119',1,0,'2022-03-03 13:25:23','2022-03-03 13:25:23'),(111731,359,'Bargidih','497101',1,0,'2022-03-03 13:25:23','2022-03-03 13:25:23'),(111732,359,'Bargwan','497001',1,0,'2022-03-03 13:25:23','2022-03-03 13:25:23'),(111733,359,'Barion','497001',1,0,'2022-03-03 13:25:23','2022-03-03 13:25:23'),(111734,359,'Bartikala','497223',1,0,'2022-03-03 13:25:23','2022-03-03 13:25:23'),(111735,359,'Basantpur','497225',1,0,'2022-03-03 13:25:23','2022-03-03 13:25:23'),(111736,359,'Basdei','497231',1,0,'2022-03-03 13:25:23','2022-03-03 13:25:23'),(111737,359,'Baskepi','497119',1,0,'2022-03-03 13:25:23','2022-03-03 13:25:23'),(111738,359,'Bataikela','497111',1,0,'2022-03-03 13:25:23','2022-03-03 13:25:23'),(111739,359,'Batouli','497101',1,0,'2022-03-03 13:25:23','2022-03-03 13:25:23'),(111740,359,'Batra','497226',1,0,'2022-03-03 13:25:23','2022-03-03 13:25:23'),(111741,359,'Bhaiyathan','497231',1,0,'2022-03-03 13:25:23','2022-03-03 13:25:23'),(111742,359,'Bhatgaon Colly','497235',1,0,'2022-03-03 13:25:23','2022-03-03 13:25:23'),(111743,359,'Bhedia','497223',1,0,'2022-03-03 13:25:24','2022-03-03 13:25:24'),(111744,359,'Bhendri','497223',1,0,'2022-03-03 13:25:24','2022-03-03 13:25:24'),(111745,359,'Bhithi','497001',1,0,'2022-03-03 13:25:24','2022-03-03 13:25:24'),(111746,359,'Bhulsikala','497224',1,0,'2022-03-03 13:25:24','2022-03-03 13:25:24'),(111747,359,'Bhuneshwarpur','497333',1,0,'2022-03-03 13:25:24','2022-03-03 13:25:24'),(111748,359,'Bhusu','497111',1,0,'2022-03-03 13:25:24','2022-03-03 13:25:24'),(111749,359,'Biharpur','497225',1,0,'2022-03-03 13:25:24','2022-03-03 13:25:24'),(111750,359,'Bilaspur','497101',1,0,'2022-03-03 13:25:24','2022-03-03 13:25:24'),(111751,359,'Birendranagar','497225',1,0,'2022-03-03 13:25:24','2022-03-03 13:25:24'),(111752,359,'Bishrampur (Surguja)','497226',1,0,'2022-03-03 13:25:24','2022-03-03 13:25:24'),(111753,359,'Chaki','497220',1,0,'2022-03-03 13:25:24','2022-03-03 13:25:24'),(111754,359,'Chalgahikhas','497223',1,0,'2022-03-03 13:25:24','2022-03-03 13:25:24'),(111755,359,'Chando','497119',1,0,'2022-03-03 13:25:24','2022-03-03 13:25:24'),(111756,359,'Chandora','497223',1,0,'2022-03-03 13:25:24','2022-03-03 13:25:24'),(111757,359,'Chandramedha','497235',1,0,'2022-03-03 13:25:24','2022-03-03 13:25:24'),(111758,359,'Chandranagar','497220',1,0,'2022-03-03 13:25:24','2022-03-03 13:25:24'),(111759,359,'Chhattarpur','497220',1,0,'2022-03-03 13:25:24','2022-03-03 13:25:24'),(111760,359,'Chiniya','497220',1,0,'2022-03-03 13:25:24','2022-03-03 13:25:24'),(111761,359,'Chiranga','497101',1,0,'2022-03-03 13:25:24','2022-03-03 13:25:24'),(111762,359,'Chungudi','497235',1,0,'2022-03-03 13:25:24','2022-03-03 13:25:24'),(111763,359,'Dandgaon','497117',1,0,'2022-03-03 13:25:24','2022-03-03 13:25:24'),(111764,359,'Darima','497001',1,0,'2022-03-03 13:25:24','2022-03-03 13:25:24'),(111765,359,'Darripara','497231',1,0,'2022-03-03 13:25:24','2022-03-03 13:25:24'),(111766,359,'Dawna','497235',1,0,'2022-03-03 13:25:25','2022-03-03 13:25:25'),(111767,359,'Dawra','497118',1,0,'2022-03-03 13:25:25','2022-03-03 13:25:25'),(111768,359,'Dedri','497229',1,0,'2022-03-03 13:25:25','2022-03-03 13:25:25'),(111769,359,'Deogarh','497111',1,0,'2022-03-03 13:25:25','2022-03-03 13:25:25'),(111770,359,'Deonagar','497333',1,0,'2022-03-03 13:25:25','2022-03-03 13:25:25'),(111771,359,'Dhandhapur','497001',1,0,'2022-03-03 13:25:25','2022-03-03 13:25:25'),(111772,359,'Dharampur','497223',1,0,'2022-03-03 13:25:25','2022-03-03 13:25:25'),(111773,359,'Dhodhagaon','497111',1,0,'2022-03-03 13:25:25','2022-03-03 13:25:25'),(111774,359,'Dhourpur','497101',1,0,'2022-03-03 13:25:25','2022-03-03 13:25:25'),(111775,359,'Dipadih','497118',1,0,'2022-03-03 13:25:25','2022-03-03 13:25:25'),(111776,359,'Dolangi','497220',1,0,'2022-03-03 13:25:25','2022-03-03 13:25:25'),(111777,359,'Dumardih','497101',1,0,'2022-03-03 13:25:25','2022-03-03 13:25:25'),(111778,359,'Dumarkhola','497224',1,0,'2022-03-03 13:25:25','2022-03-03 13:25:25'),(111779,359,'Durgapur','497118',1,0,'2022-03-03 13:25:25','2022-03-03 13:25:25'),(111780,359,'Funduldihari','497001',1,0,'2022-03-03 13:25:25','2022-03-03 13:25:25'),(111781,359,'Gajadharpur','497224',1,0,'2022-03-03 13:25:25','2022-03-03 13:25:25'),(111782,359,'Ganeshpur','497333',1,0,'2022-03-03 13:25:25','2022-03-03 13:25:25'),(111783,359,'Gangikot','497226',1,0,'2022-03-03 13:25:25','2022-03-03 13:25:25'),(111784,359,'Ganjar','497220',1,0,'2022-03-03 13:25:25','2022-03-03 13:25:25'),(111785,359,'Ghughari','497118',1,0,'2022-03-03 13:25:25','2022-03-03 13:25:25'),(111786,359,'Girhuildih','497111',1,0,'2022-03-03 13:25:26','2022-03-03 13:25:26'),(111787,359,'Gopalpur','497118',1,0,'2022-03-03 13:25:26','2022-03-03 13:25:26'),(111788,359,'Govindpur','497223',1,0,'2022-03-03 13:25:26','2022-03-03 13:25:26'),(111789,359,'Gudru','497225',1,0,'2022-03-03 13:25:26','2022-03-03 13:25:26'),(111790,359,'Guturma','497114',1,0,'2022-03-03 13:25:26','2022-03-03 13:25:26'),(111791,359,'Jainagar','497226',1,0,'2022-03-03 13:25:26','2022-03-03 13:25:26'),(111792,359,'Jajawal','497223',1,0,'2022-03-03 13:25:26','2022-03-03 13:25:26'),(111793,359,'Jajga','497111',1,0,'2022-03-03 13:25:26','2022-03-03 13:25:26'),(111794,359,'Jamdih','497117',1,0,'2022-03-03 13:25:26','2022-03-03 13:25:26'),(111795,359,'Jamgala','497116',1,0,'2022-03-03 13:25:26','2022-03-03 13:25:26'),(111796,359,'Jamirapath','497224',1,0,'2022-03-03 13:25:26','2022-03-03 13:25:26'),(111797,359,'Jamkani','497114',1,0,'2022-03-03 13:25:26','2022-03-03 13:25:26'),(111798,359,'Janakpur','497225',1,0,'2022-03-03 13:25:26','2022-03-03 13:25:26'),(111799,359,'Jarhi','497235',1,0,'2022-03-03 13:25:26','2022-03-03 13:25:26'),(111800,359,'Jawaharnagar','497224',1,0,'2022-03-03 13:25:26','2022-03-03 13:25:26'),(111801,359,'Jhalaria','497118',1,0,'2022-03-03 13:25:26','2022-03-03 13:25:26'),(111802,359,'Jhingo','497118',1,0,'2022-03-03 13:25:26','2022-03-03 13:25:26'),(111803,359,'Jigdi','497118',1,0,'2022-03-03 13:25:26','2022-03-03 13:25:26'),(111804,359,'Kakna','497001',1,0,'2022-03-03 13:25:26','2022-03-03 13:25:26'),(111805,359,'Kalyanpur','497001',1,0,'2022-03-03 13:25:26','2022-03-03 13:25:26'),(111806,359,'Kamari','497118',1,0,'2022-03-03 13:25:26','2022-03-03 13:25:26'),(111807,359,'Kamleshwarpur','497111',1,0,'2022-03-03 13:25:26','2022-03-03 13:25:26'),(111808,359,'Kanchanpur','497333',1,0,'2022-03-03 13:25:26','2022-03-03 13:25:26'),(111809,359,'Kandrai','497226',1,0,'2022-03-03 13:25:26','2022-03-03 13:25:26'),(111810,359,'Karamdiha','497225',1,0,'2022-03-03 13:25:27','2022-03-03 13:25:27'),(111811,359,'Karanji','497226',1,0,'2022-03-03 13:25:27','2022-03-03 13:25:27'),(111812,359,'Karjee','497001',1,0,'2022-03-03 13:25:27','2022-03-03 13:25:27'),(111813,359,'Karoundha','497224',1,0,'2022-03-03 13:25:27','2022-03-03 13:25:27'),(111814,359,'Karra','497118',1,0,'2022-03-03 13:25:27','2022-03-03 13:25:27'),(111815,359,'Karsi','497223',1,0,'2022-03-03 13:25:27','2022-03-03 13:25:27'),(111816,359,'Karwan','497001',1,0,'2022-03-03 13:25:27','2022-03-03 13:25:27'),(111817,359,'Katima','497224',1,0,'2022-03-03 13:25:27','2022-03-03 13:25:27'),(111818,359,'Katkalo','497111',1,0,'2022-03-03 13:25:27','2022-03-03 13:25:27'),(111819,359,'Kedma','497117',1,0,'2022-03-03 13:25:27','2022-03-03 13:25:27'),(111820,359,'Kesari','497225',1,0,'2022-03-03 13:25:27','2022-03-03 13:25:27'),(111821,359,'Ketka','497229',1,0,'2022-03-03 13:25:27','2022-03-03 13:25:27'),(111822,359,'Ketka','497223',1,0,'2022-03-03 13:25:27','2022-03-03 13:25:27'),(111823,359,'Kewra','497223',1,0,'2022-03-03 13:25:27','2022-03-03 13:25:27'),(111824,359,'Khadadorna','497111',1,0,'2022-03-03 13:25:27','2022-03-03 13:25:27'),(111825,359,'Khadgaon','497223',1,0,'2022-03-03 13:25:27','2022-03-03 13:25:27'),(111826,359,'Khamhariya','497117',1,0,'2022-03-03 13:25:27','2022-03-03 13:25:27'),(111827,359,'Khod','497225',1,0,'2022-03-03 13:25:27','2022-03-03 13:25:27'),(111828,359,'Kot','497111',1,0,'2022-03-03 13:25:27','2022-03-03 13:25:27'),(111829,359,'Koteya','497223',1,0,'2022-03-03 13:25:27','2022-03-03 13:25:27'),(111830,359,'Kothali','497118',1,0,'2022-03-03 13:25:27','2022-03-03 13:25:27'),(111831,359,'Krishnanagar','497220',1,0,'2022-03-03 13:25:28','2022-03-03 13:25:28'),(111832,359,'Krishnangar','497229',1,0,'2022-03-03 13:25:28','2022-03-03 13:25:28'),(111833,359,'Kumda Colly','497226',1,0,'2022-03-03 13:25:28','2022-03-03 13:25:28'),(111834,359,'Kundikala','497001',1,0,'2022-03-03 13:25:28','2022-03-03 13:25:28'),(111835,359,'Kunni','497116',1,0,'2022-03-03 13:25:28','2022-03-03 13:25:28'),(111836,359,'Kusmi','497224',1,0,'2022-03-03 13:25:28','2022-03-03 13:25:28'),(111837,359,'Lahpatra','497116',1,0,'2022-03-03 13:25:28','2022-03-03 13:25:28'),(111838,359,'Lakhanpur (Surguja)','497116',1,0,'2022-03-03 13:25:28','2022-03-03 13:25:28'),(111839,359,'Lamgaon','497101',1,0,'2022-03-03 13:25:28','2022-03-03 13:25:28'),(111840,359,'Lanjit','497231',1,0,'2022-03-03 13:25:28','2022-03-03 13:25:28'),(111841,359,'Larima','497224',1,0,'2022-03-03 13:25:28','2022-03-03 13:25:28'),(111842,359,'Latori','497001',1,0,'2022-03-03 13:25:28','2022-03-03 13:25:28'),(111843,359,'Laxmangarh','497117',1,0,'2022-03-03 13:25:28','2022-03-03 13:25:28'),(111844,359,'Lodha','497220',1,0,'2022-03-03 13:25:28','2022-03-03 13:25:28'),(111845,359,'Lolki','497223',1,0,'2022-03-03 13:25:28','2022-03-03 13:25:28'),(111846,359,'Lundra','497101',1,0,'2022-03-03 13:25:28','2022-03-03 13:25:28'),(111847,359,'Lurgikala','497118',1,0,'2022-03-03 13:25:28','2022-03-03 13:25:28'),(111848,359,'Madanpur','497333',1,0,'2022-03-03 13:25:28','2022-03-03 13:25:28'),(111849,359,'Madguri','497224',1,0,'2022-03-03 13:25:28','2022-03-03 13:25:28'),(111850,359,'Mahagai','497117',1,0,'2022-03-03 13:25:28','2022-03-03 13:25:28'),(111851,359,'Maharajganj','497119',1,0,'2022-03-03 13:25:29','2022-03-03 13:25:29'),(111852,359,'Mahewa','497225',1,0,'2022-03-03 13:25:29','2022-03-03 13:25:29'),(111853,359,'Manoharpur','497118',1,0,'2022-03-03 13:25:29','2022-03-03 13:25:29'),(111854,359,'Masga','497223',1,0,'2022-03-03 13:25:29','2022-03-03 13:25:29'),(111855,359,'Mitgai','497220',1,0,'2022-03-03 13:25:29','2022-03-03 13:25:29'),(111856,359,'Moharsop','497225',1,0,'2022-03-03 13:25:29','2022-03-03 13:25:29'),(111857,359,'Nagoi','497225',1,0,'2022-03-03 13:25:29','2022-03-03 13:25:29'),(111858,359,'Nandamali','497001',1,0,'2022-03-03 13:25:29','2022-03-03 13:25:29'),(111859,359,'Narbadapur','497111',1,0,'2022-03-03 13:25:29','2022-03-03 13:25:29'),(111860,359,'Narsinghpur','497118',1,0,'2022-03-03 13:25:29','2022-03-03 13:25:29'),(111861,359,'Nawanagar','497001',1,0,'2022-03-03 13:25:29','2022-03-03 13:25:29'),(111862,359,'Nawapurakalan','497333',1,0,'2022-03-03 13:25:29','2022-03-03 13:25:29'),(111863,359,'Odgi','497231',1,0,'2022-03-03 13:25:29','2022-03-03 13:25:29'),(111864,359,'Padhi','497118',1,0,'2022-03-03 13:25:29','2022-03-03 13:25:29'),(111865,359,'Parsa','497001',1,0,'2022-03-03 13:25:29','2022-03-03 13:25:29'),(111866,359,'Parsagudi','497118',1,0,'2022-03-03 13:25:29','2022-03-03 13:25:29'),(111867,359,'Parshurampur','497333',1,0,'2022-03-03 13:25:29','2022-03-03 13:25:29'),(111868,359,'Pasupatipur','497225',1,0,'2022-03-03 13:25:29','2022-03-03 13:25:29'),(111869,359,'Patnakot','497229',1,0,'2022-03-03 13:25:29','2022-03-03 13:25:29'),(111870,359,'Patora','497101',1,0,'2022-03-03 13:25:29','2022-03-03 13:25:29'),(111871,359,'Patrapali','497333',1,0,'2022-03-03 13:25:29','2022-03-03 13:25:29'),(111872,359,'Pendri','497225',1,0,'2022-03-03 13:25:29','2022-03-03 13:25:29'),(111873,359,'Peni','497114',1,0,'2022-03-03 13:25:29','2022-03-03 13:25:29'),(111874,359,'Petla','497111',1,0,'2022-03-03 13:25:30','2022-03-03 13:25:30'),(111875,359,'Poksari','497101',1,0,'2022-03-03 13:25:30','2022-03-03 13:25:30'),(111876,359,'Pratapgarh','497114',1,0,'2022-03-03 13:25:30','2022-03-03 13:25:30'),(111877,359,'Pratappur (Surguja)','497223',1,0,'2022-03-03 13:25:30','2022-03-03 13:25:30'),(111878,359,'Premnagar','497333',1,0,'2022-03-03 13:25:30','2022-03-03 13:25:30'),(111879,359,'Raghavpuri','497001',1,0,'2022-03-03 13:25:30','2022-03-03 13:25:30'),(111880,359,'Raghunathnagar','497225',1,0,'2022-03-03 13:25:30','2022-03-03 13:25:30'),(111881,359,'Raghunathpur','497101',1,0,'2022-03-03 13:25:30','2022-03-03 13:25:30'),(111882,359,'Rajpur (SIJ)','497118',1,0,'2022-03-03 13:25:30','2022-03-03 13:25:30'),(111883,359,'Ramanujganj','497220',1,0,'2022-03-03 13:25:30','2022-03-03 13:25:30'),(111884,359,'Ramanujnagar','497333',1,0,'2022-03-03 13:25:30','2022-03-03 13:25:30'),(111885,359,'Ramchandranagar','497220',1,0,'2022-03-03 13:25:30','2022-03-03 13:25:30'),(111886,359,'Ramkola','497223',1,0,'2022-03-03 13:25:30','2022-03-03 13:25:30'),(111887,359,'Ramnagar','497226',1,0,'2022-03-03 13:25:30','2022-03-03 13:25:30'),(111888,359,'Ranhat','497223',1,0,'2022-03-03 13:25:30','2022-03-03 13:25:30'),(111889,359,'Rehda','497224',1,0,'2022-03-03 13:25:30','2022-03-03 13:25:30'),(111890,359,'Rewti','497223',1,0,'2022-03-03 13:25:30','2022-03-03 13:25:30'),(111891,359,'Sabag','497224',1,0,'2022-03-03 13:25:30','2022-03-03 13:25:30'),(111892,359,'Sakalo','497001',1,0,'2022-03-03 13:25:30','2022-03-03 13:25:30'),(111893,359,'Sakhari','497001',1,0,'2022-03-03 13:25:30','2022-03-03 13:25:30'),(111894,359,'Sakholi','497001',1,0,'2022-03-03 13:25:31','2022-03-03 13:25:31'),(111895,359,'Salhi','497229',1,0,'2022-03-03 13:25:31','2022-03-03 13:25:31'),(111896,359,'Salka','497235',1,0,'2022-03-03 13:25:31','2022-03-03 13:25:31'),(111897,359,'Salka','497117',1,0,'2022-03-03 13:25:31','2022-03-03 13:25:31'),(111898,359,'Salwahi','497225',1,0,'2022-03-03 13:25:31','2022-03-03 13:25:31'),(111899,359,'Samri','497224',1,0,'2022-03-03 13:25:31','2022-03-03 13:25:31'),(111900,359,'Sankargarh','497118',1,0,'2022-03-03 13:25:31','2022-03-03 13:25:31'),(111901,359,'Sarga','497111',1,0,'2022-03-03 13:25:31','2022-03-03 13:25:31'),(111902,359,'Sayar','497117',1,0,'2022-03-03 13:25:31','2022-03-03 13:25:31'),(111903,359,'Sedam','497101',1,0,'2022-03-03 13:25:31','2022-03-03 13:25:31'),(111904,359,'Semarkalan','497223',1,0,'2022-03-03 13:25:31','2022-03-03 13:25:31'),(111905,359,'Sendur','497119',1,0,'2022-03-03 13:25:31','2022-03-03 13:25:31'),(111906,359,'Sewari','497118',1,0,'2022-03-03 13:25:31','2022-03-03 13:25:31'),(111907,359,'Shahpur','497119',1,0,'2022-03-03 13:25:31','2022-03-03 13:25:31'),(111908,359,'Shivprasadnagar','497231',1,0,'2022-03-03 13:25:31','2022-03-03 13:25:31'),(111909,359,'Sihar','497118',1,0,'2022-03-03 13:25:31','2022-03-03 13:25:31'),(111910,359,'Silphili','497001',1,0,'2022-03-03 13:25:31','2022-03-03 13:25:31'),(111911,359,'Sirsi','497231',1,0,'2022-03-03 13:25:31','2022-03-03 13:25:31'),(111912,359,'Sitapur','497111',1,0,'2022-03-03 13:25:31','2022-03-03 13:25:31'),(111913,359,'Sonawal','497220',1,0,'2022-03-03 13:25:31','2022-03-03 13:25:31'),(111914,359,'Songara','497001',1,0,'2022-03-03 13:25:31','2022-03-03 13:25:31'),(111915,359,'Sulsuli','497225',1,0,'2022-03-03 13:25:32','2022-03-03 13:25:32'),(111916,359,'Sur','497111',1,0,'2022-03-03 13:25:32','2022-03-03 13:25:32'),(111917,359,'Surajpur','497229',1,0,'2022-03-03 13:25:32','2022-03-03 13:25:32'),(111918,359,'Tara','497117',1,0,'2022-03-03 13:25:32','2022-03-03 13:25:32'),(111919,359,'Tatapani','497220',1,0,'2022-03-03 13:25:32','2022-03-03 13:25:32'),(111920,359,'Tiwragudi','497333',1,0,'2022-03-03 13:25:32','2022-03-03 13:25:32'),(111921,359,'Turna','497116',1,0,'2022-03-03 13:25:32','2022-03-03 13:25:32'),(111922,359,'Udaipur','497117',1,0,'2022-03-03 13:25:32','2022-03-03 13:25:32'),(111923,359,'Udari','497101',1,0,'2022-03-03 13:25:32','2022-03-03 13:25:32'),(111924,359,'Ulkia','497114',1,0,'2022-03-03 13:25:32','2022-03-03 13:25:32'),(111925,359,'Umeshwarpur','497333',1,0,'2022-03-03 13:25:32','2022-03-03 13:25:32'),(111926,359,'Umko','497224',1,0,'2022-03-03 13:25:32','2022-03-03 13:25:32'),(111927,359,'Urdara','497101',1,0,'2022-03-03 13:25:32','2022-03-03 13:25:32'),(111928,359,'Vijaynagar','497220',1,0,'2022-03-03 13:25:32','2022-03-03 13:25:32'),(111929,359,'Wadrafnagar','497225',1,0,'2022-03-03 13:25:32','2022-03-03 13:25:32'),(111930,360,'Bhimpore','396210',1,0,'2022-03-03 13:25:32','2022-03-03 13:25:32'),(111931,360,'Dabhel','396215',1,0,'2022-03-03 13:25:32','2022-03-03 13:25:32'),(111932,360,'Daman I.E.','396215',1,0,'2022-03-03 13:25:32','2022-03-03 13:25:32'),(111933,360,'Daman','396210',1,0,'2022-03-03 13:25:32','2022-03-03 13:25:32'),(111934,360,'Dholar','396220',1,0,'2022-03-03 13:25:32','2022-03-03 13:25:32'),(111935,360,'Dunetha','396210',1,0,'2022-03-03 13:25:32','2022-03-03 13:25:32'),(111936,360,'Kachigam','396215',1,0,'2022-03-03 13:25:32','2022-03-03 13:25:32'),(111937,360,'Kadaiya','396210',1,0,'2022-03-03 13:25:33','2022-03-03 13:25:33'),(111938,360,'Kunta','396215',1,0,'2022-03-03 13:25:33','2022-03-03 13:25:33'),(111939,360,'Magarwada','396220',1,0,'2022-03-03 13:25:33','2022-03-03 13:25:33'),(111940,360,'Marvad','396210',1,0,'2022-03-03 13:25:33','2022-03-03 13:25:33'),(111941,360,'Moti Daman','396220',1,0,'2022-03-03 13:25:33','2022-03-03 13:25:33'),(111942,360,'Nani Vankad','396210',1,0,'2022-03-03 13:25:33','2022-03-03 13:25:33'),(111943,360,'Varkund','396210',1,0,'2022-03-03 13:25:33','2022-03-03 13:25:33'),(111944,361,'Bucharvada','362570',1,0,'2022-03-03 13:25:33','2022-03-03 13:25:33'),(111945,361,'Diu','362520',1,0,'2022-03-03 13:25:33','2022-03-03 13:25:33'),(111946,361,'Diu Zampa','362520',1,0,'2022-03-03 13:25:33','2022-03-03 13:25:33'),(111947,361,'Fudam','362520',1,0,'2022-03-03 13:25:33','2022-03-03 13:25:33'),(111948,361,'Ghoghla','362540',1,0,'2022-03-03 13:25:33','2022-03-03 13:25:33'),(111949,361,'Wanakbara','362570',1,0,'2022-03-03 13:25:33','2022-03-03 13:25:33'),(111950,362,'Amli','396230',1,0,'2022-03-03 13:25:33','2022-03-03 13:25:33'),(111951,362,'Athal','396235',1,0,'2022-03-03 13:25:33','2022-03-03 13:25:33'),(111952,362,'Athola','396230',1,0,'2022-03-03 13:25:33','2022-03-03 13:25:33'),(111953,362,'Bedpa','396230',1,0,'2022-03-03 13:25:33','2022-03-03 13:25:33'),(111954,362,'Bonta','396230',1,0,'2022-03-03 13:25:33','2022-03-03 13:25:33'),(111955,362,'Chibhadkutch','396230',1,0,'2022-03-03 13:25:33','2022-03-03 13:25:33'),(111956,362,'Chikhli','396240',1,0,'2022-03-03 13:25:34','2022-03-03 13:25:34'),(111957,362,'Chinchpada','396240',1,0,'2022-03-03 13:25:34','2022-03-03 13:25:34'),(111958,362,'Chisda','396230',1,0,'2022-03-03 13:25:34','2022-03-03 13:25:34'),(111959,362,'Dadra','396193',1,0,'2022-03-03 13:25:34','2022-03-03 13:25:34'),(111960,362,'Dahikhed','396230',1,0,'2022-03-03 13:25:34','2022-03-03 13:25:34'),(111961,362,'Dapada','396240',1,0,'2022-03-03 13:25:34','2022-03-03 13:25:34'),(111962,362,'Dudhani','396230',1,0,'2022-03-03 13:25:34','2022-03-03 13:25:34'),(111963,362,'Karachgam','396230',1,0,'2022-03-03 13:25:34','2022-03-03 13:25:34'),(111964,362,'Karad Daman Project','396240',1,0,'2022-03-03 13:25:34','2022-03-03 13:25:34'),(111965,362,'Karchond','396230',1,0,'2022-03-03 13:25:34','2022-03-03 13:25:34'),(111966,362,'Karvad','396193',1,0,'2022-03-03 13:25:34','2022-03-03 13:25:34'),(111967,362,'Khanvel','396230',1,0,'2022-03-03 13:25:34','2022-03-03 13:25:34'),(111968,362,'Kharadpada','396235',1,0,'2022-03-03 13:25:34','2022-03-03 13:25:34'),(111969,362,'Kherdi','396230',1,0,'2022-03-03 13:25:34','2022-03-03 13:25:34'),(111970,362,'Khutli','396230',1,0,'2022-03-03 13:25:34','2022-03-03 13:25:34'),(111971,362,'Kilvani','396230',1,0,'2022-03-03 13:25:34','2022-03-03 13:25:34'),(111972,362,'Mandoni','396230',1,0,'2022-03-03 13:25:34','2022-03-03 13:25:34'),(111973,362,'Masat','396230',1,0,'2022-03-03 13:25:34','2022-03-03 13:25:34'),(111974,362,'Mota Randha','396230',1,0,'2022-03-03 13:25:34','2022-03-03 13:25:34'),(111975,362,'Naroli','396235',1,0,'2022-03-03 13:25:34','2022-03-03 13:25:34'),(111976,362,'Parzai','396230',1,0,'2022-03-03 13:25:34','2022-03-03 13:25:34'),(111977,362,'Rakholi','396240',1,0,'2022-03-03 13:25:34','2022-03-03 13:25:34'),(111978,362,'Rudana','396230',1,0,'2022-03-03 13:25:34','2022-03-03 13:25:34'),(111979,362,'Saily','396240',1,0,'2022-03-03 13:25:35','2022-03-03 13:25:35'),(111980,362,'Samarvarni','396230',1,0,'2022-03-03 13:25:35','2022-03-03 13:25:35'),(111981,362,'Selti','396230',1,0,'2022-03-03 13:25:35','2022-03-03 13:25:35'),(111982,362,'Sili','396230',1,0,'2022-03-03 13:25:35','2022-03-03 13:25:35'),(111983,362,'Silvassa','396230',1,0,'2022-03-03 13:25:35','2022-03-03 13:25:35'),(111984,362,'Sindoni','396230',1,0,'2022-03-03 13:25:35','2022-03-03 13:25:35'),(111985,362,'Surangi','396240',1,0,'2022-03-03 13:25:35','2022-03-03 13:25:35'),(111986,362,'Umarkui','396230',1,0,'2022-03-03 13:25:35','2022-03-03 13:25:35'),(111987,362,'Vasona','396240',1,0,'2022-03-03 13:25:35','2022-03-03 13:25:35'),(111988,362,'Velugam','396230',1,0,'2022-03-03 13:25:35','2022-03-03 13:25:35'),(111989,363,'A.K. Line','133001',1,0,'2022-03-03 13:25:35','2022-03-03 13:25:35'),(111990,363,'Adarsh Nagar','134003',1,0,'2022-03-03 13:25:35','2022-03-03 13:25:35'),(111991,363,'Adhoya','133205',1,0,'2022-03-03 13:25:35','2022-03-03 13:25:35'),(111992,363,'Adhoyi','133205',1,0,'2022-03-03 13:25:35','2022-03-03 13:25:35'),(111993,363,'Akbarpur','134203',1,0,'2022-03-03 13:25:35','2022-03-03 13:25:35'),(111994,363,'Alipur Jahangir','133202',1,0,'2022-03-03 13:25:35','2022-03-03 13:25:35'),(111995,363,'Ambala  City Kucthery','134003',1,0,'2022-03-03 13:25:35','2022-03-03 13:25:35'),(111996,363,'Ambala City H.O','134003',1,0,'2022-03-03 13:25:35','2022-03-03 13:25:35'),(111997,363,'Ambala G.P.O.','133001',1,0,'2022-03-03 13:25:35','2022-03-03 13:25:35'),(111998,363,'Ambli','134203',1,0,'2022-03-03 13:25:35','2022-03-03 13:25:35'),(111999,363,'Anaj Mandi (Ambala)','134003',1,0,'2022-03-03 13:25:36','2022-03-03 13:25:36'),(112000,363,'Babyal','133005',1,0,'2022-03-03 13:25:36','2022-03-03 13:25:36'),(112001,363,'Baknaur','134007',1,0,'2022-03-03 13:25:36','2022-03-03 13:25:36'),(112002,363,'Baldev Nagar','134007',1,0,'2022-03-03 13:25:36','2022-03-03 13:25:36'),(112003,363,'Ballana','134007',1,0,'2022-03-03 13:25:36','2022-03-03 13:25:36'),(112004,363,'Bara','133004',1,0,'2022-03-03 13:25:36','2022-03-03 13:25:36'),(112005,363,'Baragaon','134203',1,0,'2022-03-03 13:25:36','2022-03-03 13:25:36'),(112006,363,'Barara','133201',1,0,'2022-03-03 13:25:36','2022-03-03 13:25:36'),(112007,363,'Baraula','133004',1,0,'2022-03-03 13:25:36','2022-03-03 13:25:36'),(112008,363,'Bazar Basti Ram','134003',1,0,'2022-03-03 13:25:36','2022-03-03 13:25:36'),(112009,363,'Bhanokheri','134007',1,0,'2022-03-03 13:25:36','2022-03-03 13:25:36'),(112010,363,'Bhareli','134118',1,0,'2022-03-03 13:25:36','2022-03-03 13:25:36'),(112011,363,'Bhareri Kalan','134203',1,0,'2022-03-03 13:25:36','2022-03-03 13:25:36'),(112012,363,'Bharog','134201',1,0,'2022-03-03 13:25:36','2022-03-03 13:25:36'),(112013,363,'Bhurewala','134203',1,0,'2022-03-03 13:25:36','2022-03-03 13:25:36'),(112014,363,'Bihta (Ambala)','133101',1,0,'2022-03-03 13:25:36','2022-03-03 13:25:36'),(112015,363,'Boh','133005',1,0,'2022-03-03 13:25:36','2022-03-03 13:25:36'),(112016,363,'Budhangpur','134007',1,0,'2022-03-03 13:25:36','2022-03-03 13:25:36'),(112017,363,'Chaurmastpur','134007',1,0,'2022-03-03 13:25:36','2022-03-03 13:25:36'),(112018,363,'Chudiala','133102',1,0,'2022-03-03 13:25:36','2022-03-03 13:25:36'),(112019,363,'Commissioner Court','133001',1,0,'2022-03-03 13:25:36','2022-03-03 13:25:36'),(112020,363,'D.A.V.College','134003',1,0,'2022-03-03 13:25:36','2022-03-03 13:25:36'),(112021,363,'Danipur','134007',1,0,'2022-03-03 13:25:36','2022-03-03 13:25:36'),(112022,363,'Derasalimpur','133201',1,0,'2022-03-03 13:25:36','2022-03-03 13:25:36'),(112023,363,'Dhanana','134201',1,0,'2022-03-03 13:25:37','2022-03-03 13:25:37'),(112024,363,'Dhanaura','133203',1,0,'2022-03-03 13:25:37','2022-03-03 13:25:37'),(112025,363,'Dhankaur','134007',1,0,'2022-03-03 13:25:37','2022-03-03 13:25:37'),(112026,363,'Dhin','133202',1,0,'2022-03-03 13:25:37','2022-03-03 13:25:37'),(112027,363,'Dhulkot','134007',1,0,'2022-03-03 13:25:37','2022-03-03 13:25:37'),(112028,363,'Dhurkara','134007',1,0,'2022-03-03 13:25:37','2022-03-03 13:25:37'),(112029,363,'Dinarpur','133102',1,0,'2022-03-03 13:25:37','2022-03-03 13:25:37'),(112030,363,'Dukheri','133004',1,0,'2022-03-03 13:25:37','2022-03-03 13:25:37'),(112031,363,'Duliani','133202',1,0,'2022-03-03 13:25:37','2022-03-03 13:25:37'),(112032,363,'Durana','133004',1,0,'2022-03-03 13:25:37','2022-03-03 13:25:37'),(112033,363,'Fatehgarh','134201',1,0,'2022-03-03 13:25:37','2022-03-03 13:25:37'),(112034,363,'Gadhauli','134203',1,0,'2022-03-03 13:25:37','2022-03-03 13:25:37'),(112035,363,'Ganesh Pur','134202',1,0,'2022-03-03 13:25:37','2022-03-03 13:25:37'),(112036,363,'Geeta Nagri','134007',1,0,'2022-03-03 13:25:37','2022-03-03 13:25:37'),(112037,363,'Ghail','134007',1,0,'2022-03-03 13:25:37','2022-03-03 13:25:37'),(112038,363,'Gobind Nagar','133001',1,0,'2022-03-03 13:25:37','2022-03-03 13:25:37'),(112039,363,'Gokal Garh','133203',1,0,'2022-03-03 13:25:37','2022-03-03 13:25:37'),(112040,363,'Hamidpur','134203',1,0,'2022-03-03 13:25:37','2022-03-03 13:25:37'),(112041,363,'Hangola','134204',1,0,'2022-03-03 13:25:37','2022-03-03 13:25:37'),(112042,363,'Hargolal','133001',1,0,'2022-03-03 13:25:37','2022-03-03 13:25:37'),(112043,363,'Haripur','134204',1,0,'2022-03-03 13:25:37','2022-03-03 13:25:37'),(112044,363,'Holi','133201',1,0,'2022-03-03 13:25:38','2022-03-03 13:25:38'),(112045,363,'Ind-estate','133006',1,0,'2022-03-03 13:25:38','2022-03-03 13:25:38'),(112046,363,'Jalbera','134007',1,0,'2022-03-03 13:25:38','2022-03-03 13:25:38'),(112047,363,'Jandli','134005',1,0,'2022-03-03 13:25:38','2022-03-03 13:25:38'),(112048,363,'Jansui','134007',1,0,'2022-03-03 13:25:38','2022-03-03 13:25:38'),(112049,363,'Jatwar','134201',1,0,'2022-03-03 13:25:38','2022-03-03 13:25:38'),(112050,363,'Jeoli','134203',1,0,'2022-03-03 13:25:38','2022-03-03 13:25:38'),(112051,363,'Kacha Bazar','133001',1,0,'2022-03-03 13:25:38','2022-03-03 13:25:38'),(112052,363,'Kakkar Majra','134202',1,0,'2022-03-03 13:25:38','2022-03-03 13:25:38'),(112053,363,'Kakroo','134007',1,0,'2022-03-03 13:25:38','2022-03-03 13:25:38'),(112054,363,'Kalarehri','133005',1,0,'2022-03-03 13:25:38','2022-03-03 13:25:38'),(112055,363,'Kalpi','133104',1,0,'2022-03-03 13:25:38','2022-03-03 13:25:38'),(112056,363,'Kambassi','133205',1,0,'2022-03-03 13:25:38','2022-03-03 13:25:38'),(112057,363,'Kandiwala','134204',1,0,'2022-03-03 13:25:38','2022-03-03 13:25:38'),(112058,363,'Karasan','134202',1,0,'2022-03-03 13:25:38','2022-03-03 13:25:38'),(112059,363,'Kaserla Kalan','133205',1,0,'2022-03-03 13:25:38','2022-03-03 13:25:38'),(112060,363,'Kathe Majra','134203',1,0,'2022-03-03 13:25:38','2022-03-03 13:25:38'),(112061,363,'Kathgarh Chhappar','134007',1,0,'2022-03-03 13:25:38','2022-03-03 13:25:38'),(112062,363,'Keshopur Samalkha','133101',1,0,'2022-03-03 13:25:38','2022-03-03 13:25:38'),(112063,363,'Kesri','133102',1,0,'2022-03-03 13:25:38','2022-03-03 13:25:38'),(112064,363,'Khanpur','133102',1,0,'2022-03-03 13:25:38','2022-03-03 13:25:38'),(112065,363,'Khanpur Brahmana','134201',1,0,'2022-03-03 13:25:38','2022-03-03 13:25:38'),(112066,363,'Kharga Canteen','133001',1,0,'2022-03-03 13:25:39','2022-03-03 13:25:39'),(112067,363,'Khatauli','134118',1,0,'2022-03-03 13:25:39','2022-03-03 13:25:39'),(112068,363,'Khudda Kalan','133104',1,0,'2022-03-03 13:25:39','2022-03-03 13:25:39'),(112069,363,'Korwa Khurd','134202',1,0,'2022-03-03 13:25:39','2022-03-03 13:25:39'),(112070,363,'Kot','134118',1,0,'2022-03-03 13:25:39','2022-03-03 13:25:39'),(112071,363,'Kuldeep Nagar','133004',1,0,'2022-03-03 13:25:39','2022-03-03 13:25:39'),(112072,363,'Kurali','134203',1,0,'2022-03-03 13:25:39','2022-03-03 13:25:39'),(112073,363,'Laha','134203',1,0,'2022-03-03 13:25:39','2022-03-03 13:25:39'),(112074,363,'Lakhnaura','134203',1,0,'2022-03-03 13:25:39','2022-03-03 13:25:39'),(112075,363,'Lalpur','134203',1,0,'2022-03-03 13:25:39','2022-03-03 13:25:39'),(112076,363,'Landa','133102',1,0,'2022-03-03 13:25:39','2022-03-03 13:25:39'),(112077,363,'M.M.E.Complex Mulana','133203',1,0,'2022-03-03 13:25:39','2022-03-03 13:25:39'),(112078,363,'Mahesh Nagar','133001',1,0,'2022-03-03 13:25:39','2022-03-03 13:25:39'),(112079,363,'Manak  Tabra','134204',1,0,'2022-03-03 13:25:39','2022-03-03 13:25:39'),(112080,363,'Mandhaur','134007',1,0,'2022-03-03 13:25:39','2022-03-03 13:25:39'),(112081,363,'Manka Manki','133202',1,0,'2022-03-03 13:25:39','2022-03-03 13:25:39'),(112082,363,'Manu Majra','133205',1,0,'2022-03-03 13:25:39','2022-03-03 13:25:39'),(112083,363,'Mardon Sahib','133004',1,0,'2022-03-03 13:25:39','2022-03-03 13:25:39'),(112084,363,'Matheri Sekhan','134007',1,0,'2022-03-03 13:25:39','2022-03-03 13:25:39'),(112085,363,'Mehmoodpur','133104',1,0,'2022-03-03 13:25:39','2022-03-03 13:25:39'),(112086,363,'Model Town Ambala City','134003',1,0,'2022-03-03 13:25:39','2022-03-03 13:25:39'),(112087,363,'Mohra','133004',1,0,'2022-03-03 13:25:39','2022-03-03 13:25:39'),(112088,363,'Motor Stand','134003',1,0,'2022-03-03 13:25:40','2022-03-03 13:25:40'),(112089,363,'Mullana Engineering College','133207',1,0,'2022-03-03 13:25:40','2022-03-03 13:25:40'),(112090,363,'Mullana','133203',1,0,'2022-03-03 13:25:40','2022-03-03 13:25:40'),(112091,363,'Naggal','134007',1,0,'2022-03-03 13:25:40','2022-03-03 13:25:40'),(112092,363,'Nagla Jattan','133102',1,0,'2022-03-03 13:25:40','2022-03-03 13:25:40'),(112093,363,'Nahoni','133104',1,0,'2022-03-03 13:25:40','2022-03-03 13:25:40'),(112094,363,'Naneola','134007',1,0,'2022-03-03 13:25:40','2022-03-03 13:25:40'),(112095,363,'Naraingarh','134203',1,0,'2022-03-03 13:25:40','2022-03-03 13:25:40'),(112096,363,'Nasrauli','134201',1,0,'2022-03-03 13:25:40','2022-03-03 13:25:40'),(112097,363,'P & T Colony','133004',1,0,'2022-03-03 13:25:40','2022-03-03 13:25:40'),(112098,363,'Palam Vihar (Ambala)','133001',1,0,'2022-03-03 13:25:40','2022-03-03 13:25:40'),(112099,363,'Panjlasa','134203',1,0,'2022-03-03 13:25:40','2022-03-03 13:25:40'),(112100,363,'Panjokhara Sahib','134007',1,0,'2022-03-03 13:25:40','2022-03-03 13:25:40'),(112101,363,'Pasiala','133102',1,0,'2022-03-03 13:25:40','2022-03-03 13:25:40'),(112102,363,'Patrehri','134202',1,0,'2022-03-03 13:25:40','2022-03-03 13:25:40'),(112103,363,'Patwi','134201',1,0,'2022-03-03 13:25:40','2022-03-03 13:25:40'),(112104,363,'Pilkhani','133104',1,0,'2022-03-03 13:25:40','2022-03-03 13:25:40'),(112105,363,'Preet Nagar (Ambala)','134003',1,0,'2022-03-03 13:25:40','2022-03-03 13:25:40'),(112106,363,'Prem Nagar (Ambala)','134003',1,0,'2022-03-03 13:25:40','2022-03-03 13:25:40'),(112107,363,'Punjabi Mohalla','133001',1,0,'2022-03-03 13:25:40','2022-03-03 13:25:40'),(112108,363,'Railway Road Ambala City','134003',1,0,'2022-03-03 13:25:41','2022-03-03 13:25:41'),(112109,363,'Rajo Kheri','133201',1,0,'2022-03-03 13:25:41','2022-03-03 13:25:41'),(112110,363,'Rajouli','133201',1,0,'2022-03-03 13:25:41','2022-03-03 13:25:41'),(112111,363,'Sadar Bazar (Ambala)','133001',1,0,'2022-03-03 13:25:41','2022-03-03 13:25:41'),(112112,363,'Saha','133104',1,0,'2022-03-03 13:25:41','2022-03-03 13:25:41'),(112113,363,'Samlerhi','133104',1,0,'2022-03-03 13:25:41','2022-03-03 13:25:41'),(112114,363,'Saran','133202',1,0,'2022-03-03 13:25:41','2022-03-03 13:25:41'),(112115,363,'Sarsehri','133005',1,0,'2022-03-03 13:25:41','2022-03-03 13:25:41'),(112116,363,'Saunta','134007',1,0,'2022-03-03 13:25:41','2022-03-03 13:25:41'),(112117,363,'Segti','134007',1,0,'2022-03-03 13:25:41','2022-03-03 13:25:41'),(112118,363,'Sewan Majra','133205',1,0,'2022-03-03 13:25:41','2022-03-03 13:25:41'),(112119,363,'Shah Pur','133004',1,0,'2022-03-03 13:25:41','2022-03-03 13:25:41'),(112120,363,'Shahzadpur','134202',1,0,'2022-03-03 13:25:41','2022-03-03 13:25:41'),(112121,363,'Sohana','133203',1,0,'2022-03-03 13:25:41','2022-03-03 13:25:41'),(112122,363,'Sohata','133201',1,0,'2022-03-03 13:25:41','2022-03-03 13:25:41'),(112123,363,'Subzi  Mandi','134003',1,0,'2022-03-03 13:25:41','2022-03-03 13:25:41'),(112124,363,'Tandwal','133201',1,0,'2022-03-03 13:25:41','2022-03-03 13:25:41'),(112125,363,'Tepla','133104',1,0,'2022-03-03 13:25:41','2022-03-03 13:25:41'),(112126,363,'Thakar Pura','133203',1,0,'2022-03-03 13:25:41','2022-03-03 13:25:41'),(112127,363,'Tharwa','133004',1,0,'2022-03-03 13:25:41','2022-03-03 13:25:41'),(112128,363,'Thumber','133205',1,0,'2022-03-03 13:25:42','2022-03-03 13:25:42'),(112129,363,'Toda','134201',1,0,'2022-03-03 13:25:42','2022-03-03 13:25:42'),(112130,363,'Top Khana Bazar','133001',1,0,'2022-03-03 13:25:42','2022-03-03 13:25:42'),(112131,363,'Udaipur','134007',1,0,'2022-03-03 13:25:42','2022-03-03 13:25:42'),(112132,363,'Ugala','133205',1,0,'2022-03-03 13:25:42','2022-03-03 13:25:42'),(112133,364,'Achina','127307',1,0,'2022-03-03 13:25:42','2022-03-03 13:25:42'),(112134,364,'Arya Nagar','127308',1,0,'2022-03-03 13:25:42','2022-03-03 13:25:42'),(112135,364,'Asalwas Marheta','127030',1,0,'2022-03-03 13:25:42','2022-03-03 13:25:42'),(112136,364,'Atela Khurd','127026',1,0,'2022-03-03 13:25:42','2022-03-03 13:25:42'),(112137,364,'Aun','127025',1,0,'2022-03-03 13:25:42','2022-03-03 13:25:42'),(112138,364,'Aun','127310',1,0,'2022-03-03 13:25:42','2022-03-03 13:25:42'),(112139,364,'Badal','127026',1,0,'2022-03-03 13:25:42','2022-03-03 13:25:42'),(112140,364,'Badesera','127031',1,0,'2022-03-03 13:25:42','2022-03-03 13:25:42'),(112141,364,'Badhara','127308',1,0,'2022-03-03 13:25:42','2022-03-03 13:25:42'),(112142,364,'Badhawana','127310',1,0,'2022-03-03 13:25:42','2022-03-03 13:25:42'),(112143,364,'Badrai','127308',1,0,'2022-03-03 13:25:42','2022-03-03 13:25:42'),(112144,364,'Bajina','127111',1,0,'2022-03-03 13:25:42','2022-03-03 13:25:42'),(112145,364,'Baliali','127032',1,0,'2022-03-03 13:25:42','2022-03-03 13:25:42'),(112146,364,'Bamla','127021',1,0,'2022-03-03 13:25:42','2022-03-03 13:25:42'),(112147,364,'Bapora','127111',1,0,'2022-03-03 13:25:42','2022-03-03 13:25:42'),(112148,364,'Bardu Chaina','127201',1,0,'2022-03-03 13:25:42','2022-03-03 13:25:42'),(112149,364,'Barsana','127026',1,0,'2022-03-03 13:25:42','2022-03-03 13:25:42'),(112150,364,'Barsi','127032',1,0,'2022-03-03 13:25:42','2022-03-03 13:25:42'),(112151,364,'Barwa','127045',1,0,'2022-03-03 13:25:43','2022-03-03 13:25:43'),(112152,364,'Barwas','127201',1,0,'2022-03-03 13:25:43','2022-03-03 13:25:43'),(112153,364,'Baund','127025',1,0,'2022-03-03 13:25:43','2022-03-03 13:25:43'),(112154,364,'Bawani Khera','127032',1,0,'2022-03-03 13:25:43','2022-03-03 13:25:43'),(112155,364,'Behl','127028',1,0,'2022-03-03 13:25:43','2022-03-03 13:25:43'),(112156,364,'Berla','127308',1,0,'2022-03-03 13:25:43','2022-03-03 13:25:43'),(112157,364,'Bhagesari','127307',1,0,'2022-03-03 13:25:43','2022-03-03 13:25:43'),(112158,364,'Bhagwi','127307',1,0,'2022-03-03 13:25:43','2022-03-03 13:25:43'),(112159,364,'Bhaini Kungar','127041',1,0,'2022-03-03 13:25:43','2022-03-03 13:25:43'),(112160,364,'Bhangarh','127030',1,0,'2022-03-03 13:25:43','2022-03-03 13:25:43'),(112161,364,'Bhariwas','127043',1,0,'2022-03-03 13:25:43','2022-03-03 13:25:43'),(112162,364,'Bhera','127043',1,0,'2022-03-03 13:25:43','2022-03-03 13:25:43'),(112163,364,'Bhiwani H.O','127021',1,0,'2022-03-03 13:25:43','2022-03-03 13:25:43'),(112164,364,'Bhurtana','127035',1,0,'2022-03-03 13:25:43','2022-03-03 13:25:43'),(112165,364,'Bhushan','127043',1,0,'2022-03-03 13:25:43','2022-03-03 13:25:43'),(112166,364,'Bidhwan','127046',1,0,'2022-03-03 13:25:43','2022-03-03 13:25:43'),(112167,364,'Bigowa','127307',1,0,'2022-03-03 13:25:43','2022-03-03 13:25:43'),(112168,364,'Biran','127111',1,0,'2022-03-03 13:25:43','2022-03-03 13:25:43'),(112169,364,'Birhi Kalan','127026',1,0,'2022-03-03 13:25:43','2022-03-03 13:25:43'),(112170,364,'Birla Colony Bhiwani','127021',1,0,'2022-03-03 13:25:43','2022-03-03 13:25:43'),(112171,364,'Bisalwas','127201',1,0,'2022-03-03 13:25:43','2022-03-03 13:25:43'),(112172,364,'Bseh Bhiwani','127021',1,0,'2022-03-03 13:25:43','2022-03-03 13:25:43'),(112173,364,'Budhera','127201',1,0,'2022-03-03 13:25:43','2022-03-03 13:25:43'),(112174,364,'Bus Stand Bhiwani','127021',1,0,'2022-03-03 13:25:44','2022-03-03 13:25:44'),(112175,364,'Chahar Kalan','127201',1,0,'2022-03-03 13:25:44','2022-03-03 13:25:44'),(112176,364,'Chahar Khurd','127201',1,0,'2022-03-03 13:25:44','2022-03-03 13:25:44'),(112177,364,'Chandawas','127029',1,0,'2022-03-03 13:25:44','2022-03-03 13:25:44'),(112178,364,'Chandeni','127310',1,0,'2022-03-03 13:25:44','2022-03-03 13:25:44'),(112179,364,'Chandwas','127308',1,0,'2022-03-03 13:25:44','2022-03-03 13:25:44'),(112180,364,'Chang Road','127022',1,0,'2022-03-03 13:25:44','2022-03-03 13:25:44'),(112181,364,'Chang','127027',1,0,'2022-03-03 13:25:44','2022-03-03 13:25:44'),(112182,364,'Chappar','127026',1,0,'2022-03-03 13:25:44','2022-03-03 13:25:44'),(112183,364,'Chappar Rangran','127040',1,0,'2022-03-03 13:25:44','2022-03-03 13:25:44'),(112184,364,'Charkhi  Dadri Hsg-ii','127306',1,0,'2022-03-03 13:25:44','2022-03-03 13:25:44'),(112185,364,'Charkhi','127306',1,0,'2022-03-03 13:25:44','2022-03-03 13:25:44'),(112186,364,'Charkhi Dadri City','127306',1,0,'2022-03-03 13:25:44','2022-03-03 13:25:44'),(112187,364,'Chiriya','127022',1,0,'2022-03-03 13:25:44','2022-03-03 13:25:44'),(112188,364,'Dadam','127040',1,0,'2022-03-03 13:25:44','2022-03-03 13:25:44'),(112189,364,'Dagroli','127308',1,0,'2022-03-03 13:25:44','2022-03-03 13:25:44'),(112190,364,'Dalawas','127308',1,0,'2022-03-03 13:25:44','2022-03-03 13:25:44'),(112191,364,'Dandama','127030',1,0,'2022-03-03 13:25:44','2022-03-03 13:25:44'),(112192,364,'Dang','127111',1,0,'2022-03-03 13:25:44','2022-03-03 13:25:44'),(112193,364,'Daryapur','127040',1,0,'2022-03-03 13:25:44','2022-03-03 13:25:44'),(112194,364,'Devrala','127029',1,0,'2022-03-03 13:25:44','2022-03-03 13:25:44'),(112195,364,'Devsar','127111',1,0,'2022-03-03 13:25:44','2022-03-03 13:25:44'),(112196,364,'Dhabdhani','127030',1,0,'2022-03-03 13:25:44','2022-03-03 13:25:44'),(112197,364,'Dhadhi Adampur','127310',1,0,'2022-03-03 13:25:44','2022-03-03 13:25:44'),(112198,364,'Dhadhi Mandola','127306',1,0,'2022-03-03 13:25:45','2022-03-03 13:25:45'),(112199,364,'Dhana Ladan Pur','127111',1,0,'2022-03-03 13:25:45','2022-03-03 13:25:45'),(112200,364,'Dhanana','127031',1,0,'2022-03-03 13:25:45','2022-03-03 13:25:45'),(112201,364,'Dhani Dhola','127201',1,0,'2022-03-03 13:25:45','2022-03-03 13:25:45'),(112202,364,'Dhani Mahu','127040',1,0,'2022-03-03 13:25:45','2022-03-03 13:25:45'),(112203,364,'Dhani Miran','127046',1,0,'2022-03-03 13:25:45','2022-03-03 13:25:45'),(112204,364,'Dhani Phogat','127306',1,0,'2022-03-03 13:25:45','2022-03-03 13:25:45'),(112205,364,'Dhareru','127309',1,0,'2022-03-03 13:25:45','2022-03-03 13:25:45'),(112206,364,'Dhighawa Jattan','127201',1,0,'2022-03-03 13:25:45','2022-03-03 13:25:45'),(112207,364,'Dhirana','127111',1,0,'2022-03-03 13:25:45','2022-03-03 13:25:45'),(112208,364,'Dinod','127111',1,0,'2022-03-03 13:25:45','2022-03-03 13:25:45'),(112209,364,'Dohka Harya','127026',1,0,'2022-03-03 13:25:45','2022-03-03 13:25:45'),(112210,364,'Dudhwa','127022',1,0,'2022-03-03 13:25:45','2022-03-03 13:25:45'),(112211,364,'Dulheri','127040',1,0,'2022-03-03 13:25:45','2022-03-03 13:25:45'),(112212,364,'Durjanpur','127032',1,0,'2022-03-03 13:25:45','2022-03-03 13:25:45'),(112213,364,'Fartia Bhima','127201',1,0,'2022-03-03 13:25:45','2022-03-03 13:25:45'),(112214,364,'Fatehgarh Haryana','127309',1,0,'2022-03-03 13:25:45','2022-03-03 13:25:45'),(112215,364,'Gainadawas','127046',1,0,'2022-03-03 13:25:45','2022-03-03 13:25:45'),(112216,364,'Garanpura Kalan','127040',1,0,'2022-03-03 13:25:45','2022-03-03 13:25:45'),(112217,364,'Ghanghala','127046',1,0,'2022-03-03 13:25:45','2022-03-03 13:25:45'),(112218,364,'Ghasola','127306',1,0,'2022-03-03 13:25:45','2022-03-03 13:25:45'),(112219,364,'Gignow','127201',1,0,'2022-03-03 13:25:46','2022-03-03 13:25:46'),(112220,364,'Golagarh','127030',1,0,'2022-03-03 13:25:46','2022-03-03 13:25:46'),(112221,364,'Golpura','127030',1,0,'2022-03-03 13:25:46','2022-03-03 13:25:46'),(112222,364,'Gopi','127308',1,0,'2022-03-03 13:25:46','2022-03-03 13:25:46'),(112223,364,'Gudana Kalan','127310',1,0,'2022-03-03 13:25:46','2022-03-03 13:25:46'),(112224,364,'Gujrani','127031',1,0,'2022-03-03 13:25:46','2022-03-03 13:25:46'),(112225,364,'Gurera','127046',1,0,'2022-03-03 13:25:46','2022-03-03 13:25:46'),(112226,364,'Halu Bajar Bhiwani','127021',1,0,'2022-03-03 13:25:46','2022-03-03 13:25:46'),(112227,364,'Haluwas','127111',1,0,'2022-03-03 13:25:46','2022-03-03 13:25:46'),(112228,364,'Harodi','127308',1,0,'2022-03-03 13:25:46','2022-03-03 13:25:46'),(112229,364,'Hetampura','127029',1,0,'2022-03-03 13:25:46','2022-03-03 13:25:46'),(112230,364,'Imlota','127306',1,0,'2022-03-03 13:25:46','2022-03-03 13:25:46'),(112231,364,'Isharwal','127043',1,0,'2022-03-03 13:25:46','2022-03-03 13:25:46'),(112232,364,'Jalan Hospital Bhiwani','127021',1,0,'2022-03-03 13:25:46','2022-03-03 13:25:46'),(112233,364,'Jamalpur (Bhiwani)','127035',1,0,'2022-03-03 13:25:46','2022-03-03 13:25:46'),(112234,364,'Janta College Charkhi Dadri','127306',1,0,'2022-03-03 13:25:46','2022-03-03 13:25:46'),(112235,364,'Jatai','127041',1,0,'2022-03-03 13:25:46','2022-03-03 13:25:46'),(112236,364,'Jawa','127310',1,0,'2022-03-03 13:25:46','2022-03-03 13:25:46'),(112237,364,'Jewali','127308',1,0,'2022-03-03 13:25:46','2022-03-03 13:25:46'),(112238,364,'Jhanjra Sheoran','127201',1,0,'2022-03-03 13:25:46','2022-03-03 13:25:46'),(112239,364,'Jhijhar','127307',1,0,'2022-03-03 13:25:47','2022-03-03 13:25:47'),(112240,364,'Jhojhu','127310',1,0,'2022-03-03 13:25:47','2022-03-03 13:25:47'),(112241,364,'Jhully','127043',1,0,'2022-03-03 13:25:47','2022-03-03 13:25:47'),(112242,364,'Jhumpa Kalan','127046',1,0,'2022-03-03 13:25:47','2022-03-03 13:25:47'),(112243,364,'Jui Khurd','127030',1,0,'2022-03-03 13:25:47','2022-03-03 13:25:47'),(112244,364,'Kadma','127308',1,0,'2022-03-03 13:25:47','2022-03-03 13:25:47'),(112245,364,'Kaila','127309',1,0,'2022-03-03 13:25:47','2022-03-03 13:25:47'),(112246,364,'Kairu','127029',1,0,'2022-03-03 13:25:47','2022-03-03 13:25:47'),(112247,364,'Kakroli Sardara','127308',1,0,'2022-03-03 13:25:47','2022-03-03 13:25:47'),(112248,364,'Kalinga','127114',1,0,'2022-03-03 13:25:47','2022-03-03 13:25:47'),(112249,364,'Kalod','127046',1,0,'2022-03-03 13:25:47','2022-03-03 13:25:47'),(112250,364,'Kalyana','127306',1,0,'2022-03-03 13:25:47','2022-03-03 13:25:47'),(112251,364,'Kari Dharani','127308',1,0,'2022-03-03 13:25:47','2022-03-03 13:25:47'),(112252,364,'Kario Baniawalij','127308',1,0,'2022-03-03 13:25:47','2022-03-03 13:25:47'),(112253,364,'Kaunt','127309',1,0,'2022-03-03 13:25:47','2022-03-03 13:25:47'),(112254,364,'Khanak','127040',1,0,'2022-03-03 13:25:47','2022-03-03 13:25:47'),(112255,364,'Kharak Kalan','127114',1,0,'2022-03-03 13:25:47','2022-03-03 13:25:47'),(112256,364,'Kharkari','127201',1,0,'2022-03-03 13:25:47','2022-03-03 13:25:47'),(112257,364,'Kharkari Makhwan','127040',1,0,'2022-03-03 13:25:47','2022-03-03 13:25:47'),(112258,364,'Kharkhari Sohan','127040',1,0,'2022-03-03 13:25:47','2022-03-03 13:25:47'),(112259,364,'Khera','127046',1,0,'2022-03-03 13:25:47','2022-03-03 13:25:47'),(112260,364,'Kheri Bura','127306',1,0,'2022-03-03 13:25:47','2022-03-03 13:25:47'),(112261,364,'Kirawar','127035',1,0,'2022-03-03 13:25:47','2022-03-03 13:25:47'),(112262,364,'Kitlana','127309',1,0,'2022-03-03 13:25:48','2022-03-03 13:25:48'),(112263,364,'Kohar','127111',1,0,'2022-03-03 13:25:48','2022-03-03 13:25:48'),(112264,364,'Kungar','127041',1,0,'2022-03-03 13:25:48','2022-03-03 13:25:48'),(112265,364,'Kural','127201',1,0,'2022-03-03 13:25:48','2022-03-03 13:25:48'),(112266,364,'Kusumbhi','127029',1,0,'2022-03-03 13:25:48','2022-03-03 13:25:48'),(112267,364,'Lad','127308',1,0,'2022-03-03 13:25:48','2022-03-03 13:25:48'),(112268,364,'Leghan','127029',1,0,'2022-03-03 13:25:48','2022-03-03 13:25:48'),(112269,364,'Lilas','127046',1,0,'2022-03-03 13:25:48','2022-03-03 13:25:48'),(112270,364,'Lohani','127029',1,0,'2022-03-03 13:25:48','2022-03-03 13:25:48'),(112271,364,'Lohar Bazar','127021',1,0,'2022-03-03 13:25:48','2022-03-03 13:25:48'),(112272,364,'Lohari Jatu','127032',1,0,'2022-03-03 13:25:48','2022-03-03 13:25:48'),(112273,364,'Loharu','127201',1,0,'2022-03-03 13:25:48','2022-03-03 13:25:48'),(112274,364,'Loharwara','127307',1,0,'2022-03-03 13:25:48','2022-03-03 13:25:48'),(112275,364,'Makrana','127022',1,0,'2022-03-03 13:25:48','2022-03-03 13:25:48'),(112276,364,'Malkosh','127025',1,0,'2022-03-03 13:25:48','2022-03-03 13:25:48'),(112277,364,'Mandhan','127043',1,0,'2022-03-03 13:25:48','2022-03-03 13:25:48'),(112278,364,'Mandhana','127032',1,0,'2022-03-03 13:25:48','2022-03-03 13:25:48'),(112279,364,'Mandhi Harya','127308',1,0,'2022-03-03 13:25:48','2022-03-03 13:25:48'),(112280,364,'Mandholi Kalan','127043',1,0,'2022-03-03 13:25:48','2022-03-03 13:25:48'),(112281,364,'Mandholi Khurd','127046',1,0,'2022-03-03 13:25:49','2022-03-03 13:25:49'),(112282,364,'Manheru','127309',1,0,'2022-03-03 13:25:49','2022-03-03 13:25:49'),(112283,364,'Mankawas','127306',1,0,'2022-03-03 13:25:49','2022-03-03 13:25:49'),(112284,364,'Mansarbass','127029',1,0,'2022-03-03 13:25:49','2022-03-03 13:25:49'),(112285,364,'Matani','127028',1,0,'2022-03-03 13:25:49','2022-03-03 13:25:49'),(112286,364,'Mauri','127022',1,0,'2022-03-03 13:25:49','2022-03-03 13:25:49'),(112287,364,'Mehera','127026',1,0,'2022-03-03 13:25:49','2022-03-03 13:25:49'),(112288,364,'Milkpur','127032',1,0,'2022-03-03 13:25:49','2022-03-03 13:25:49'),(112289,364,'Mini Sect Bhiwani','127021',1,0,'2022-03-03 13:25:49','2022-03-03 13:25:49'),(112290,364,'Miran','127046',1,0,'2022-03-03 13:25:49','2022-03-03 13:25:49'),(112291,364,'Misri','127042',1,0,'2022-03-03 13:25:49','2022-03-03 13:25:49'),(112292,364,'Mitathal','127031',1,0,'2022-03-03 13:25:49','2022-03-03 13:25:49'),(112293,364,'Mithi','127028',1,0,'2022-03-03 13:25:49','2022-03-03 13:25:49'),(112294,364,'Morka','127028',1,0,'2022-03-03 13:25:49','2022-03-03 13:25:49'),(112295,364,'Morwala','127307',1,0,'2022-03-03 13:25:49','2022-03-03 13:25:49'),(112296,364,'Mundhal Khurd','127041',1,0,'2022-03-03 13:25:49','2022-03-03 13:25:49'),(112297,364,'Nakipur','127201',1,0,'2022-03-03 13:25:49','2022-03-03 13:25:49'),(112298,364,'Naloi','127046',1,0,'2022-03-03 13:25:49','2022-03-03 13:25:49'),(112299,364,'Nandgaon','127111',1,0,'2022-03-03 13:25:49','2022-03-03 13:25:49'),(112300,364,'Nandha','127308',1,0,'2022-03-03 13:25:49','2022-03-03 13:25:49'),(112301,364,'Naurangabass Jattan','127310',1,0,'2022-03-03 13:25:49','2022-03-03 13:25:49'),(112302,364,'Neemli','127306',1,0,'2022-03-03 13:25:49','2022-03-03 13:25:49'),(112303,364,'Neemriwali','127309',1,0,'2022-03-03 13:25:49','2022-03-03 13:25:49'),(112304,364,'Noonsar','127028',1,0,'2022-03-03 13:25:49','2022-03-03 13:25:49'),(112305,364,'Obra','127028',1,0,'2022-03-03 13:25:50','2022-03-03 13:25:50'),(112306,364,'Paitawas Kalan','127306',1,0,'2022-03-03 13:25:50','2022-03-03 13:25:50'),(112307,364,'Palari','127310',1,0,'2022-03-03 13:25:50','2022-03-03 13:25:50'),(112308,364,'Paluwas','127031',1,0,'2022-03-03 13:25:50','2022-03-03 13:25:50'),(112309,364,'Paposa','127035',1,0,'2022-03-03 13:25:50','2022-03-03 13:25:50'),(112310,364,'Parvezpur','127201',1,0,'2022-03-03 13:25:50','2022-03-03 13:25:50'),(112311,364,'Patwan','127028',1,0,'2022-03-03 13:25:50','2022-03-03 13:25:50'),(112312,364,'Pichopa Kalan','127310',1,0,'2022-03-03 13:25:50','2022-03-03 13:25:50'),(112313,364,'Pohkarwas','127030',1,0,'2022-03-03 13:25:50','2022-03-03 13:25:50'),(112314,364,'Premnagar','127031',1,0,'2022-03-03 13:25:50','2022-03-03 13:25:50'),(112315,364,'Pur','127032',1,0,'2022-03-03 13:25:50','2022-03-03 13:25:50'),(112316,364,'Rajgarh','127111',1,0,'2022-03-03 13:25:50','2022-03-03 13:25:50'),(112317,364,'Rambass','127310',1,0,'2022-03-03 13:25:50','2022-03-03 13:25:50'),(112318,364,'Ranila','127042',1,0,'2022-03-03 13:25:50','2022-03-03 13:25:50'),(112319,364,'Rasiwas','127026',1,0,'2022-03-03 13:25:50','2022-03-03 13:25:50'),(112320,364,'Ratera','127035',1,0,'2022-03-03 13:25:50','2022-03-03 13:25:50'),(112321,364,'Rawaldhi','127306',1,0,'2022-03-03 13:25:50','2022-03-03 13:25:50'),(112322,364,'Rewari Khera','127027',1,0,'2022-03-03 13:25:50','2022-03-03 13:25:50'),(112323,364,'Riwasa','127040',1,0,'2022-03-03 13:25:50','2022-03-03 13:25:50'),(112324,364,'Rodhan','127043',1,0,'2022-03-03 13:25:50','2022-03-03 13:25:50'),(112325,364,'Rohnat','127035',1,0,'2022-03-03 13:25:50','2022-03-03 13:25:50'),(112326,364,'Roopgarh','127111',1,0,'2022-03-03 13:25:51','2022-03-03 13:25:51'),(112327,364,'Sagban','127040',1,0,'2022-03-03 13:25:51','2022-03-03 13:25:51'),(112328,364,'Sai','127027',1,0,'2022-03-03 13:25:51','2022-03-03 13:25:51'),(112329,364,'Samaspur','127306',1,0,'2022-03-03 13:25:51','2022-03-03 13:25:51'),(112330,364,'Sandawa','127043',1,0,'2022-03-03 13:25:51','2022-03-03 13:25:51'),(112331,364,'Sanga','127309',1,0,'2022-03-03 13:25:51','2022-03-03 13:25:51'),(112332,364,'Sanjarwas','127042',1,0,'2022-03-03 13:25:51','2022-03-03 13:25:51'),(112333,364,'Sankror','127042',1,0,'2022-03-03 13:25:51','2022-03-03 13:25:51'),(112334,364,'Sanwar (Bhiwani)','127042',1,0,'2022-03-03 13:25:51','2022-03-03 13:25:51'),(112335,364,'Sarupgarh','127306',1,0,'2022-03-03 13:25:51','2022-03-03 13:25:51'),(112336,364,'Sehar','127201',1,0,'2022-03-03 13:25:51','2022-03-03 13:25:51'),(112337,364,'Serla','127028',1,0,'2022-03-03 13:25:51','2022-03-03 13:25:51'),(112338,364,'Sidhanwa','127028',1,0,'2022-03-03 13:25:51','2022-03-03 13:25:51'),(112339,364,'Singhani','127201',1,0,'2022-03-03 13:25:51','2022-03-03 13:25:51'),(112340,364,'Siswala','127026',1,0,'2022-03-03 13:25:51','2022-03-03 13:25:51'),(112341,364,'Siwana','127041',1,0,'2022-03-03 13:25:51','2022-03-03 13:25:51'),(112342,364,'Siwani','127046',1,0,'2022-03-03 13:25:51','2022-03-03 13:25:51'),(112343,364,'Siwara','127032',1,0,'2022-03-03 13:25:51','2022-03-03 13:25:51'),(112344,364,'Sohansara','127201',1,0,'2022-03-03 13:25:51','2022-03-03 13:25:51'),(112345,364,'Sui','127031',1,0,'2022-03-03 13:25:51','2022-03-03 13:25:51'),(112346,364,'Sungarpur','127029',1,0,'2022-03-03 13:25:51','2022-03-03 13:25:51'),(112347,364,'Surpura Khurd','127028',1,0,'2022-03-03 13:25:51','2022-03-03 13:25:51'),(112348,364,'Talu','127041',1,0,'2022-03-03 13:25:52','2022-03-03 13:25:52'),(112349,364,'Thilod','127040',1,0,'2022-03-03 13:25:52','2022-03-03 13:25:52'),(112350,364,'Tigrana','127031',1,0,'2022-03-03 13:25:52','2022-03-03 13:25:52'),(112351,364,'Tiwala','127026',1,0,'2022-03-03 13:25:52','2022-03-03 13:25:52'),(112352,364,'Tosham','127040',1,0,'2022-03-03 13:25:52','2022-03-03 13:25:52'),(112353,364,'Umarwas','127030',1,0,'2022-03-03 13:25:52','2022-03-03 13:25:52'),(112354,365,'Aharwan','121102',1,0,'2022-03-03 13:25:52','2022-03-03 13:25:52'),(112355,365,'Alawalpur','121102',1,0,'2022-03-03 13:25:52','2022-03-03 13:25:52'),(112356,365,'Ali Meo','121106',1,0,'2022-03-03 13:25:52','2022-03-03 13:25:52'),(112357,365,'Alika','121102',1,0,'2022-03-03 13:25:52','2022-03-03 13:25:52'),(112358,365,'Alipur','121101',1,0,'2022-03-03 13:25:52','2022-03-03 13:25:52'),(112359,365,'Amarnagar (Faridabad)','121003',1,0,'2022-03-03 13:25:52','2022-03-03 13:25:52'),(112360,365,'Amarpur','121004',1,0,'2022-03-03 13:25:52','2022-03-03 13:25:52'),(112361,365,'Amroli','121102',1,0,'2022-03-03 13:25:52','2022-03-03 13:25:52'),(112362,365,'Anangpur','121003',1,0,'2022-03-03 13:25:52','2022-03-03 13:25:52'),(112363,365,'Andhop','121106',1,0,'2022-03-03 13:25:52','2022-03-03 13:25:52'),(112364,365,'Asaota','121102',1,0,'2022-03-03 13:25:52','2022-03-03 13:25:52'),(112365,365,'Asaoti','121102',1,0,'2022-03-03 13:25:52','2022-03-03 13:25:52'),(112366,365,'Atali','121004',1,0,'2022-03-03 13:25:53','2022-03-03 13:25:53'),(112367,365,'Aurangabad (Faridabad)','121105',1,0,'2022-03-03 13:25:53','2022-03-03 13:25:53'),(112368,365,'Badarpur Syed','121101',1,0,'2022-03-03 13:25:53','2022-03-03 13:25:53'),(112369,365,'Baghola','121102',1,0,'2022-03-03 13:25:53','2022-03-03 13:25:53'),(112370,365,'Bahin','121105',1,0,'2022-03-03 13:25:53','2022-03-03 13:25:53'),(112371,365,'Ballabgarh','121004',1,0,'2022-03-03 13:25:53','2022-03-03 13:25:53'),(112372,365,'Bamni Khera','121105',1,0,'2022-03-03 13:25:53','2022-03-03 13:25:53'),(112373,365,'Banchari','121106',1,0,'2022-03-03 13:25:53','2022-03-03 13:25:53'),(112374,365,'Banswa','121107',1,0,'2022-03-03 13:25:53','2022-03-03 13:25:53'),(112375,365,'Baroli','121102',1,0,'2022-03-03 13:25:53','2022-03-03 13:25:53'),(112376,365,'Baroli','121004',1,0,'2022-03-03 13:25:53','2022-03-03 13:25:53'),(112377,365,'Bhainsrawali','121101',1,0,'2022-03-03 13:25:53','2022-03-03 13:25:53'),(112378,365,'Bhandoli','121107',1,0,'2022-03-03 13:25:53','2022-03-03 13:25:53'),(112379,365,'Bhaskola','121002',1,0,'2022-03-03 13:25:53','2022-03-03 13:25:53'),(112380,365,'Bhiduki','121107',1,0,'2022-03-03 13:25:53','2022-03-03 13:25:53'),(112381,365,'Bhuvapur','121101',1,0,'2022-03-03 13:25:53','2022-03-03 13:25:53'),(112382,365,'Chandpur','121101',1,0,'2022-03-03 13:25:53','2022-03-03 13:25:53'),(112383,365,'Chant','121102',1,0,'2022-03-03 13:25:53','2022-03-03 13:25:53'),(112384,365,'Chawla Colony Ballabgarh','121004',1,0,'2022-03-03 13:25:53','2022-03-03 13:25:53'),(112385,365,'Chhainsa','121004',1,0,'2022-03-03 13:25:53','2022-03-03 13:25:53'),(112386,365,'Chhainsa','121103',1,0,'2022-03-03 13:25:53','2022-03-03 13:25:53'),(112387,365,'Chhajju Nagar','121102',1,0,'2022-03-03 13:25:53','2022-03-03 13:25:53'),(112388,365,'Chirwari','121102',1,0,'2022-03-03 13:25:54','2022-03-03 13:25:54'),(112389,365,'Dayalpur','121004',1,0,'2022-03-03 13:25:54','2022-03-03 13:25:54'),(112390,365,'Deeg','121004',1,0,'2022-03-03 13:25:54','2022-03-03 13:25:54'),(112391,365,'Dhatir','121102',1,0,'2022-03-03 13:25:54','2022-03-03 13:25:54'),(112392,365,'Dhauj','121004',1,0,'2022-03-03 13:25:54','2022-03-03 13:25:54'),(112393,365,'Dighot','121105',1,0,'2022-03-03 13:25:54','2022-03-03 13:25:54'),(112394,365,'E C Dhauj','121004',1,0,'2022-03-03 13:25:54','2022-03-03 13:25:54'),(112395,365,'Escortsnagar Faridabad','121007',1,0,'2022-03-03 13:25:54','2022-03-03 13:25:54'),(112396,365,'Factory Area Faridabad','121001',1,0,'2022-03-03 13:25:54','2022-03-03 13:25:54'),(112397,365,'Faridabad City','121002',1,0,'2022-03-03 13:25:54','2022-03-03 13:25:54'),(112398,365,'Faridabad NIT H.O','121001',1,0,'2022-03-03 13:25:54','2022-03-03 13:25:54'),(112399,365,'Faridabad Sector 12','121007',1,0,'2022-03-03 13:25:54','2022-03-03 13:25:54'),(112400,365,'Faridabad Sector 15','121007',1,0,'2022-03-03 13:25:54','2022-03-03 13:25:54'),(112401,365,'Faridabad Sector 16','121002',1,0,'2022-03-03 13:25:54','2022-03-03 13:25:54'),(112402,365,'Faridabad Sector 16a ','121002',1,0,'2022-03-03 13:25:54','2022-03-03 13:25:54'),(112403,365,'Faridabad Sector 18','121002',1,0,'2022-03-03 13:25:54','2022-03-03 13:25:54'),(112404,365,'Faridabad Sector 22','121005',1,0,'2022-03-03 13:25:54','2022-03-03 13:25:54'),(112405,365,'Faridabad Sector 29','121008',1,0,'2022-03-03 13:25:54','2022-03-03 13:25:54'),(112406,365,'Faridabad Sector 3','121004',1,0,'2022-03-03 13:25:54','2022-03-03 13:25:54'),(112407,365,'Faridabad Sector 7','121006',1,0,'2022-03-03 13:25:54','2022-03-03 13:25:54'),(112408,365,'Faridabad Sector 8','121006',1,0,'2022-03-03 13:25:54','2022-03-03 13:25:54'),(112409,365,'Faridabad Sector 9','121006',1,0,'2022-03-03 13:25:55','2022-03-03 13:25:55'),(112410,365,'Faridpur','121101',1,0,'2022-03-03 13:25:55','2022-03-03 13:25:55'),(112411,365,'Fatehpur Billoch','121004',1,0,'2022-03-03 13:25:55','2022-03-03 13:25:55'),(112412,365,'Fatehpur Tagga','121004',1,0,'2022-03-03 13:25:55','2022-03-03 13:25:55'),(112413,365,'Feroz Gandhi Nagar Faridabad','121001',1,0,'2022-03-03 13:25:55','2022-03-03 13:25:55'),(112414,365,'G.T. Road Faridabad','121006',1,0,'2022-03-03 13:25:55','2022-03-03 13:25:55'),(112415,365,'Gadpuri','121004',1,0,'2022-03-03 13:25:55','2022-03-03 13:25:55'),(112416,365,'Gehlab','121103',1,0,'2022-03-03 13:25:55','2022-03-03 13:25:55'),(112417,365,'Gharrot','121103',1,0,'2022-03-03 13:25:55','2022-03-03 13:25:55'),(112418,365,'Ghori','121102',1,0,'2022-03-03 13:25:55','2022-03-03 13:25:55'),(112419,365,'Gonchhi','121004',1,0,'2022-03-03 13:25:55','2022-03-03 13:25:55'),(112420,365,'Gorota','121106',1,0,'2022-03-03 13:25:55','2022-03-03 13:25:55'),(112421,365,'Gulawad','121107',1,0,'2022-03-03 13:25:55','2022-03-03 13:25:55'),(112422,365,'Gurukul Indraprashtha','121003',1,0,'2022-03-03 13:25:55','2022-03-03 13:25:55'),(112423,365,'Hassanpur','121107',1,0,'2022-03-03 13:25:55','2022-03-03 13:25:55'),(112424,365,'Hathin','121103',1,0,'2022-03-03 13:25:55','2022-03-03 13:25:55'),(112425,365,'Hodal','121106',1,0,'2022-03-03 13:25:55','2022-03-03 13:25:55'),(112426,365,'Hurithal','121103',1,0,'2022-03-03 13:25:55','2022-03-03 13:25:55'),(112427,365,'Industrial Area Faridabad','121001',1,0,'2022-03-03 13:25:55','2022-03-03 13:25:55'),(112428,365,'Jaindapur','121102',1,0,'2022-03-03 13:25:56','2022-03-03 13:25:56'),(112429,365,'Janauli','121102',1,0,'2022-03-03 13:25:56','2022-03-03 13:25:56'),(112430,365,'Jawahar Colony Faridabad','121005',1,0,'2022-03-03 13:25:56','2022-03-03 13:25:56'),(112431,365,'Jawahar Nagar Palwal','121102',1,0,'2022-03-03 13:25:56','2022-03-03 13:25:56'),(112432,365,'Jawan','121004',1,0,'2022-03-03 13:25:56','2022-03-03 13:25:56'),(112433,365,'Khaika','121106',1,0,'2022-03-03 13:25:56','2022-03-03 13:25:56'),(112434,365,'Khambi','121106',1,0,'2022-03-03 13:25:56','2022-03-03 13:25:56'),(112435,365,'Khatela Sarai','121105',1,0,'2022-03-03 13:25:56','2022-03-03 13:25:56'),(112436,365,'Kheri Kalan','121002',1,0,'2022-03-03 13:25:56','2022-03-03 13:25:56'),(112437,365,'Kondal','121103',1,0,'2022-03-03 13:25:56','2022-03-03 13:25:56'),(112438,365,'Kot','121103',1,0,'2022-03-03 13:25:56','2022-03-03 13:25:56'),(112439,365,'Kurali','121101',1,0,'2022-03-03 13:25:56','2022-03-03 13:25:56'),(112440,365,'Likhi','121107',1,0,'2022-03-03 13:25:56','2022-03-03 13:25:56'),(112441,365,'Lohina','121106',1,0,'2022-03-03 13:25:56','2022-03-03 13:25:56'),(112442,365,'Machhgar','121004',1,0,'2022-03-03 13:25:56','2022-03-03 13:25:56'),(112443,365,'Madnaka','121103',1,0,'2022-03-03 13:25:56','2022-03-03 13:25:56'),(112444,365,'Malai','121103',1,0,'2022-03-03 13:25:56','2022-03-03 13:25:56'),(112445,365,'Mandkola','121103',1,0,'2022-03-03 13:25:56','2022-03-03 13:25:56'),(112446,365,'Manjhawali','121101',1,0,'2022-03-03 13:25:56','2022-03-03 13:25:56'),(112447,365,'Manpur','121105',1,0,'2022-03-03 13:25:56','2022-03-03 13:25:56'),(112448,365,'Marraoli','121106',1,0,'2022-03-03 13:25:57','2022-03-03 13:25:57'),(112449,365,'Mathura Road Faridabad','121003',1,0,'2022-03-03 13:25:57','2022-03-03 13:25:57'),(112450,365,'Mohna','121004',1,0,'2022-03-03 13:25:57','2022-03-03 13:25:57'),(112451,365,'N.I.F.M. Faridabad','121001',1,0,'2022-03-03 13:25:57','2022-03-03 13:25:57'),(112452,365,'N.T.P.C./sector-10 Faridabad','121004',1,0,'2022-03-03 13:25:57','2022-03-03 13:25:57'),(112453,365,'Nangal Jat','121105',1,0,'2022-03-03 13:25:57','2022-03-03 13:25:57'),(112454,365,'Neemka','121004',1,0,'2022-03-03 13:25:57','2022-03-03 13:25:57'),(112455,365,'New Township Palwal','121102',1,0,'2022-03-03 13:25:57','2022-03-03 13:25:57'),(112456,365,'Nh-2 Faridabad','121001',1,0,'2022-03-03 13:25:57','2022-03-03 13:25:57'),(112457,365,'Nh-3 Faridabad','121001',1,0,'2022-03-03 13:25:57','2022-03-03 13:25:57'),(112458,365,'Nh-4 Faridabad','121001',1,0,'2022-03-03 13:25:57','2022-03-03 13:25:57'),(112459,365,'Nhpc Colony Faridabad','121010',1,0,'2022-03-03 13:25:57','2022-03-03 13:25:57'),(112460,365,'Pali','121004',1,0,'2022-03-03 13:25:57','2022-03-03 13:25:57'),(112461,365,'Palwal','121102',1,0,'2022-03-03 13:25:57','2022-03-03 13:25:57'),(112462,365,'Panhera Khurd','121004',1,0,'2022-03-03 13:25:57','2022-03-03 13:25:57'),(112463,365,'Pingore','121105',1,0,'2022-03-03 13:25:57','2022-03-03 13:25:57'),(112464,365,'Prithla','121102',1,0,'2022-03-03 13:25:57','2022-03-03 13:25:57'),(112465,365,'Rasulpur','121102',1,0,'2022-03-03 13:25:57','2022-03-03 13:25:57'),(112466,365,'Rupraka','121103',1,0,'2022-03-03 13:25:57','2022-03-03 13:25:57'),(112467,365,'Sagarpur','121004',1,0,'2022-03-03 13:25:57','2022-03-03 13:25:57'),(112468,365,'Sec-91','121013',1,0,'2022-03-03 13:25:57','2022-03-03 13:25:57'),(112469,365,'Sector-21D ','121012',1,0,'2022-03-03 13:25:58','2022-03-03 13:25:58'),(112470,365,'Seeha','121102',1,0,'2022-03-03 13:25:58','2022-03-03 13:25:58'),(112471,365,'Seekri','121004',1,0,'2022-03-03 13:25:58','2022-03-03 13:25:58'),(112472,365,'Seoli','121105',1,0,'2022-03-03 13:25:58','2022-03-03 13:25:58'),(112473,365,'Siaroli','121102',1,0,'2022-03-03 13:25:58','2022-03-03 13:25:58'),(112474,365,'Sihol','121102',1,0,'2022-03-03 13:25:58','2022-03-03 13:25:58'),(112475,365,'Sondh','121106',1,0,'2022-03-03 13:25:58','2022-03-03 13:25:58'),(112476,365,'Surajkund Faridabad','121009',1,0,'2022-03-03 13:25:58','2022-03-03 13:25:58'),(112477,365,'Tappa Bilochpur','121107',1,0,'2022-03-03 13:25:58','2022-03-03 13:25:58'),(112478,365,'Teekri Brahman','121102',1,0,'2022-03-03 13:25:58','2022-03-03 13:25:58'),(112479,365,'Tigaon','121101',1,0,'2022-03-03 13:25:58','2022-03-03 13:25:58'),(112480,365,'Tilpat','121003',1,0,'2022-03-03 13:25:58','2022-03-03 13:25:58'),(112481,365,'Uttawar','121103',1,0,'2022-03-03 13:25:58','2022-03-03 13:25:58'),(112482,366,'Aharwan','125051',1,0,'2022-03-03 13:25:58','2022-03-03 13:25:58'),(112483,366,'Ahlisadar','125050',1,0,'2022-03-03 13:25:58','2022-03-03 13:25:58'),(112484,366,'Akanwali','125106',1,0,'2022-03-03 13:25:58','2022-03-03 13:25:58'),(112485,366,'Alika','125051',1,0,'2022-03-03 13:25:58','2022-03-03 13:25:58'),(112486,366,'Asrawan','125052',1,0,'2022-03-03 13:25:58','2022-03-03 13:25:58'),(112487,366,'Ayalki','125051',1,0,'2022-03-03 13:25:58','2022-03-03 13:25:58'),(112488,366,'Badalgarh','125051',1,0,'2022-03-03 13:25:58','2022-03-03 13:25:58'),(112489,366,'Badopal','125048',1,0,'2022-03-03 13:25:59','2022-03-03 13:25:59'),(112490,366,'Bagla','125052',1,0,'2022-03-03 13:25:59','2022-03-03 13:25:59'),(112491,366,'Bahmanwala','125051',1,0,'2022-03-03 13:25:59','2022-03-03 13:25:59'),(112492,366,'Baijalpur','125111',1,0,'2022-03-03 13:25:59','2022-03-03 13:25:59'),(112493,366,'Baliala','125051',1,0,'2022-03-03 13:25:59','2022-03-03 13:25:59'),(112494,366,'Ban Mandori','125053',1,0,'2022-03-03 13:25:59','2022-03-03 13:25:59'),(112495,366,'Bangaon','125050',1,0,'2022-03-03 13:25:59','2022-03-03 13:25:59'),(112496,366,'Banwali','125050',1,0,'2022-03-03 13:25:59','2022-03-03 13:25:59'),(112497,366,'Bhattu Kalan','125053',1,0,'2022-03-03 13:25:59','2022-03-03 13:25:59'),(112498,366,'Bhirrana','125050',1,0,'2022-03-03 13:25:59','2022-03-03 13:25:59'),(112499,366,'Bhodia Bishnoian','125050',1,0,'2022-03-03 13:25:59','2022-03-03 13:25:59'),(112500,366,'Bhodia Khera','125050',1,0,'2022-03-03 13:25:59','2022-03-03 13:25:59'),(112501,366,'Bhuna','125111',1,0,'2022-03-03 13:25:59','2022-03-03 13:25:59'),(112502,366,'Bhuthan Kalan','125050',1,0,'2022-03-03 13:25:59','2022-03-03 13:25:59'),(112503,366,'Bighar','125050',1,0,'2022-03-03 13:25:59','2022-03-03 13:25:59'),(112504,366,'Biranbadi','125051',1,0,'2022-03-03 13:25:59','2022-03-03 13:25:59'),(112505,366,'Bithmara','125113',1,0,'2022-03-03 13:25:59','2022-03-03 13:25:59'),(112506,366,'Bora','125051',1,0,'2022-03-03 13:25:59','2022-03-03 13:25:59'),(112507,366,'Bosti','125113',1,0,'2022-03-03 13:25:59','2022-03-03 13:25:59'),(112508,366,'Bowan','125113',1,0,'2022-03-03 13:25:59','2022-03-03 13:25:59'),(112509,366,'Chander Kalan','125120',1,0,'2022-03-03 13:25:59','2022-03-03 13:25:59'),(112510,366,'Chandoh Kalan','125051',1,0,'2022-03-03 13:26:00','2022-03-03 13:26:00'),(112511,366,'Chandrawal','125111',1,0,'2022-03-03 13:26:00','2022-03-03 13:26:00'),(112512,366,'Chaubara','125111',1,0,'2022-03-03 13:26:00','2022-03-03 13:26:00'),(112513,366,'Chimmon','125051',1,0,'2022-03-03 13:26:00','2022-03-03 13:26:00'),(112514,366,'Chinder','125048',1,0,'2022-03-03 13:26:00','2022-03-03 13:26:00'),(112515,366,'Daiyar','125053',1,0,'2022-03-03 13:26:00','2022-03-03 13:26:00'),(112516,366,'Dangra','125120',1,0,'2022-03-03 13:26:00','2022-03-03 13:26:00'),(112517,366,'Daryapur','125050',1,0,'2022-03-03 13:26:00','2022-03-03 13:26:00'),(112518,366,'Degoh','125106',1,0,'2022-03-03 13:26:00','2022-03-03 13:26:00'),(112519,366,'Dhabi Kalan','125053',1,0,'2022-03-03 13:26:00','2022-03-03 13:26:00'),(112520,366,'Dhand','125050',1,0,'2022-03-03 13:26:00','2022-03-03 13:26:00'),(112521,366,'Dhanger','125048',1,0,'2022-03-03 13:26:00','2022-03-03 13:26:00'),(112522,366,'Dhani Gopal','125111',1,0,'2022-03-03 13:26:00','2022-03-03 13:26:00'),(112523,366,'Dhani Majra','125050',1,0,'2022-03-03 13:26:00','2022-03-03 13:26:00'),(112524,366,'Dharsul Kalan','125106',1,0,'2022-03-03 13:26:00','2022-03-03 13:26:00'),(112525,366,'Dhingsara','125053',1,0,'2022-03-03 13:26:00','2022-03-03 13:26:00'),(112526,366,'Dhola','125111',1,0,'2022-03-03 13:26:00','2022-03-03 13:26:00'),(112527,366,'Diwana','125106',1,0,'2022-03-03 13:26:00','2022-03-03 13:26:00'),(112528,366,'Dullat','125111',1,0,'2022-03-03 13:26:00','2022-03-03 13:26:00'),(112529,366,'Fatehabad (Fatehabad)','125050',1,0,'2022-03-03 13:26:00','2022-03-03 13:26:00'),(112530,366,'Fatehabd Kty','125050',1,0,'2022-03-03 13:26:00','2022-03-03 13:26:00'),(112531,366,'Fatehpuri','125120',1,0,'2022-03-03 13:26:01','2022-03-03 13:26:01'),(112532,366,'Ganda','125051',1,0,'2022-03-03 13:26:01','2022-03-03 13:26:01'),(112533,366,'Gillan Khera','125050',1,0,'2022-03-03 13:26:01','2022-03-03 13:26:01'),(112534,366,'Gurusar','125051',1,0,'2022-03-03 13:26:01','2022-03-03 13:26:01'),(112535,366,'Hajrawan Kalan','125050',1,0,'2022-03-03 13:26:01','2022-03-03 13:26:01'),(112536,366,'Hajrawan Khurd','125050',1,0,'2022-03-03 13:26:01','2022-03-03 13:26:01'),(112537,366,'Hamzapur','125051',1,0,'2022-03-03 13:26:01','2022-03-03 13:26:01'),(112538,366,'Handalwala','125106',1,0,'2022-03-03 13:26:01','2022-03-03 13:26:01'),(112539,366,'Hanspur','125051',1,0,'2022-03-03 13:26:01','2022-03-03 13:26:01'),(112540,366,'Haroli','125051',1,0,'2022-03-03 13:26:01','2022-03-03 13:26:01'),(112541,366,'Hassanga','125051',1,0,'2022-03-03 13:26:01','2022-03-03 13:26:01'),(112542,366,'Inda Chhoi','125120',1,0,'2022-03-03 13:26:01','2022-03-03 13:26:01'),(112543,366,'Jakhal Mandi','125133',1,0,'2022-03-03 13:26:01','2022-03-03 13:26:01'),(112544,366,'Jallopur','125051',1,0,'2022-03-03 13:26:01','2022-03-03 13:26:01'),(112545,366,'Jamalpur Sheikhan','125120',1,0,'2022-03-03 13:26:01','2022-03-03 13:26:01'),(112546,366,'Jandli Kalan','125111',1,0,'2022-03-03 13:26:01','2022-03-03 13:26:01'),(112547,366,'Jandli Khurd','125111',1,0,'2022-03-03 13:26:01','2022-03-03 13:26:01'),(112548,366,'Jandwala','125053',1,0,'2022-03-03 13:26:01','2022-03-03 13:26:01'),(112549,366,'Jhalnia','125050',1,0,'2022-03-03 13:26:01','2022-03-03 13:26:01'),(112550,366,'Kamana','125051',1,0,'2022-03-03 13:26:02','2022-03-03 13:26:02'),(112551,366,'Kanheri','125120',1,0,'2022-03-03 13:26:02','2022-03-03 13:26:02'),(112552,366,'Karandi','125106',1,0,'2022-03-03 13:26:02','2022-03-03 13:26:02'),(112553,366,'Karnoli','125050',1,0,'2022-03-03 13:26:02','2022-03-03 13:26:02'),(112554,366,'Khabra Kalan','125053',1,0,'2022-03-03 13:26:02','2022-03-03 13:26:02'),(112555,366,'Khairati Khera','125050',1,0,'2022-03-03 13:26:02','2022-03-03 13:26:02'),(112556,366,'Khajuri Jatti','125111',1,0,'2022-03-03 13:26:02','2022-03-03 13:26:02'),(112557,366,'Khara Kheri','125048',1,0,'2022-03-03 13:26:02','2022-03-03 13:26:02'),(112558,366,'Khunan','125051',1,0,'2022-03-03 13:26:02','2022-03-03 13:26:02'),(112559,366,'Kirdhan','125053',1,0,'2022-03-03 13:26:02','2022-03-03 13:26:02'),(112560,366,'Kudni','125120',1,0,'2022-03-03 13:26:02','2022-03-03 13:26:02'),(112561,366,'Kukranwali','125050',1,0,'2022-03-03 13:26:02','2022-03-03 13:26:02'),(112562,366,'Kullan','125106',1,0,'2022-03-03 13:26:02','2022-03-03 13:26:02'),(112563,366,'Laduwas','125051',1,0,'2022-03-03 13:26:02','2022-03-03 13:26:02'),(112564,366,'Lalauda','125120',1,0,'2022-03-03 13:26:02','2022-03-03 13:26:02'),(112565,366,'Lali','125051',1,0,'2022-03-03 13:26:02','2022-03-03 13:26:02'),(112566,366,'Lehraian','125106',1,0,'2022-03-03 13:26:02','2022-03-03 13:26:02'),(112567,366,'M S Rattia','125051',1,0,'2022-03-03 13:26:02','2022-03-03 13:26:02'),(112568,366,'Mahmadpur Rohi','125048',1,0,'2022-03-03 13:26:02','2022-03-03 13:26:02'),(112569,366,'Manghera','125106',1,0,'2022-03-03 13:26:02','2022-03-03 13:26:02'),(112570,366,'Mehmra','125051',1,0,'2022-03-03 13:26:02','2022-03-03 13:26:02'),(112571,366,'Mehuwala','125053',1,0,'2022-03-03 13:26:02','2022-03-03 13:26:02'),(112572,366,'Meond Kalan','125133',1,0,'2022-03-03 13:26:03','2022-03-03 13:26:03'),(112573,366,'Meond Khurd','125133',1,0,'2022-03-03 13:26:03','2022-03-03 13:26:03'),(112574,366,'Mirana','125051',1,0,'2022-03-03 13:26:03','2022-03-03 13:26:03'),(112575,366,'Mohmadpur Sotter','125051',1,0,'2022-03-03 13:26:03','2022-03-03 13:26:03'),(112576,366,'Munawali','125050',1,0,'2022-03-03 13:26:03','2022-03-03 13:26:03'),(112577,366,'Musa Khera','125106',1,0,'2022-03-03 13:26:03','2022-03-03 13:26:03'),(112578,366,'Nadhori','125111',1,0,'2022-03-03 13:26:03','2022-03-03 13:26:03'),(112579,366,'Nagpur','125051',1,0,'2022-03-03 13:26:03','2022-03-03 13:26:03'),(112580,366,'Nai Mandi Fatehabad','125050',1,0,'2022-03-03 13:26:03','2022-03-03 13:26:03'),(112581,366,'Nakhatia','125050',1,0,'2022-03-03 13:26:03','2022-03-03 13:26:03'),(112582,366,'Nangal','125051',1,0,'2022-03-03 13:26:03','2022-03-03 13:26:03'),(112583,366,'Nangla','125120',1,0,'2022-03-03 13:26:03','2022-03-03 13:26:03'),(112584,366,'Nanheri','125106',1,0,'2022-03-03 13:26:03','2022-03-03 13:26:03'),(112585,366,'Nathuwal','125133',1,0,'2022-03-03 13:26:03','2022-03-03 13:26:03'),(112586,366,'Nathwan','125051',1,0,'2022-03-03 13:26:03','2022-03-03 13:26:03'),(112587,366,'Partan','125120',1,0,'2022-03-03 13:26:03','2022-03-03 13:26:03'),(112588,366,'Phullan','125051',1,0,'2022-03-03 13:26:03','2022-03-03 13:26:03'),(112589,366,'Pilchhian','125051',1,0,'2022-03-03 13:26:03','2022-03-03 13:26:03'),(112590,366,'Pili Mandori','125053',1,0,'2022-03-03 13:26:03','2022-03-03 13:26:03'),(112591,366,'Pirthala','125120',1,0,'2022-03-03 13:26:03','2022-03-03 13:26:03'),(112592,366,'Rainwali','125120',1,0,'2022-03-03 13:26:03','2022-03-03 13:26:03'),(112593,366,'Ramsara','125053',1,0,'2022-03-03 13:26:04','2022-03-03 13:26:04'),(112594,366,'Ratta Khera','125051',1,0,'2022-03-03 13:26:04','2022-03-03 13:26:04'),(112595,366,'Ratta Theh','125106',1,0,'2022-03-03 13:26:04','2022-03-03 13:26:04'),(112596,366,'Ratta Tibba','125050',1,0,'2022-03-03 13:26:04','2022-03-03 13:26:04'),(112597,366,'Rattia','125051',1,0,'2022-03-03 13:26:04','2022-03-03 13:26:04'),(112598,366,'Sadhanwas','125133',1,0,'2022-03-03 13:26:04','2022-03-03 13:26:04'),(112599,366,'Samain','125120',1,0,'2022-03-03 13:26:04','2022-03-03 13:26:04'),(112600,366,'Sanchla','125111',1,0,'2022-03-03 13:26:04','2022-03-03 13:26:04'),(112601,366,'Shakarpura','125106',1,0,'2022-03-03 13:26:04','2022-03-03 13:26:04'),(112602,366,'Sheikapur Daroli','125053',1,0,'2022-03-03 13:26:04','2022-03-03 13:26:04'),(112603,366,'Sheikhpur Sotter','125051',1,0,'2022-03-03 13:26:04','2022-03-03 13:26:04'),(112604,366,'Sidhani','125133',1,0,'2022-03-03 13:26:04','2022-03-03 13:26:04'),(112605,366,'Suli Khera','125053',1,0,'2022-03-03 13:26:04','2022-03-03 13:26:04'),(112606,366,'Talwara','125133',1,0,'2022-03-03 13:26:04','2022-03-03 13:26:04'),(112607,366,'Thori','125050',1,0,'2022-03-03 13:26:04','2022-03-03 13:26:04'),(112608,366,'Thuiyan','125053',1,0,'2022-03-03 13:26:04','2022-03-03 13:26:04'),(112609,366,'Tohana Mandi','125120',1,0,'2022-03-03 13:26:04','2022-03-03 13:26:04'),(112610,366,'Tohana','125120',1,0,'2022-03-03 13:26:04','2022-03-03 13:26:04'),(112611,367,'Agon','122104',1,0,'2022-03-03 13:26:04','2022-03-03 13:26:04'),(112612,367,'Air Force','122005',1,0,'2022-03-03 13:26:04','2022-03-03 13:26:04'),(112613,367,'Akhera','122107',1,0,'2022-03-03 13:26:05','2022-03-03 13:26:05'),(112614,367,'Arjun Nagar','122001',1,0,'2022-03-03 13:26:05','2022-03-03 13:26:05'),(112615,367,'Baded','122508',1,0,'2022-03-03 13:26:05','2022-03-03 13:26:05'),(112616,367,'Badli','122508',1,0,'2022-03-03 13:26:05','2022-03-03 13:26:05'),(112617,367,'Badshahpur','122101',1,0,'2022-03-03 13:26:05','2022-03-03 13:26:05'),(112618,367,'Baghanki','122105',1,0,'2022-03-03 13:26:05','2022-03-03 13:26:05'),(112619,367,'Basai','122006',1,0,'2022-03-03 13:26:05','2022-03-03 13:26:05'),(112620,367,'Basai Road','122001',1,0,'2022-03-03 13:26:05','2022-03-03 13:26:05'),(112621,367,'Baslambi','122503',1,0,'2022-03-03 13:26:05','2022-03-03 13:26:05'),(112622,367,'Baspadamka','122503',1,0,'2022-03-03 13:26:05','2022-03-03 13:26:05'),(112623,367,'Bewan','122104',1,0,'2022-03-03 13:26:05','2022-03-03 13:26:05'),(112624,367,'Bhadas','122108',1,0,'2022-03-03 13:26:05','2022-03-03 13:26:05'),(112625,367,'Bhangrola','122505',1,0,'2022-03-03 13:26:05','2022-03-03 13:26:05'),(112626,367,'Bhirauti','122103',1,0,'2022-03-03 13:26:05','2022-03-03 13:26:05'),(112627,367,'Bhondsi','122102',1,0,'2022-03-03 13:26:05','2022-03-03 13:26:05'),(112628,367,'Bhorakalan','122413',1,0,'2022-03-03 13:26:05','2022-03-03 13:26:05'),(112629,367,'Bichhor','122508',1,0,'2022-03-03 13:26:05','2022-03-03 13:26:05'),(112630,367,'Bilaspur Khurd','122413',1,0,'2022-03-03 13:26:05','2022-03-03 13:26:05'),(112631,367,'Bisru','122508',1,0,'2022-03-03 13:26:05','2022-03-03 13:26:05'),(112632,367,'Budarpur','122108',1,0,'2022-03-03 13:26:05','2022-03-03 13:26:05'),(112633,367,'Budhera','122505',1,0,'2022-03-03 13:26:05','2022-03-03 13:26:05'),(112634,367,'Carterpuri','122017',1,0,'2022-03-03 13:26:05','2022-03-03 13:26:05'),(112635,367,'Chakkarpur','122002',1,0,'2022-03-03 13:26:06','2022-03-03 13:26:06'),(112636,367,'Chapera','122103',1,0,'2022-03-03 13:26:06','2022-03-03 13:26:06'),(112637,367,'Cheelarh','122502',1,0,'2022-03-03 13:26:06','2022-03-03 13:26:06'),(112638,367,'Damdama','122102',1,0,'2022-03-03 13:26:06','2022-03-03 13:26:06'),(112639,367,'Daulah','122103',1,0,'2022-03-03 13:26:06','2022-03-03 13:26:06'),(112640,367,'Daultabad','122006',1,0,'2022-03-03 13:26:06','2022-03-03 13:26:06'),(112641,367,'Dhani Chitarsain','122413',1,0,'2022-03-03 13:26:06','2022-03-03 13:26:06'),(112642,367,'Dhankot','122505',1,0,'2022-03-03 13:26:06','2022-03-03 13:26:06'),(112643,367,'DLF Ph-II','122008',1,0,'2022-03-03 13:26:06','2022-03-03 13:26:06'),(112644,367,'DLF Ph-III','122010',1,0,'2022-03-03 13:26:06','2022-03-03 13:26:06'),(112645,367,'DLF QE','122002',1,0,'2022-03-03 13:26:06','2022-03-03 13:26:06'),(112646,367,'Doha','122104',1,0,'2022-03-03 13:26:06','2022-03-03 13:26:06'),(112647,367,'Dulawat','122105',1,0,'2022-03-03 13:26:06','2022-03-03 13:26:06'),(112648,367,'Dundahera','122016',1,0,'2022-03-03 13:26:06','2022-03-03 13:26:06'),(112649,367,'Dungerwas','123106',1,0,'2022-03-03 13:26:06','2022-03-03 13:26:06'),(112650,367,'Farrukh Nagar','122506',1,0,'2022-03-03 13:26:06','2022-03-03 13:26:06'),(112651,367,'Fazilpur','122101',1,0,'2022-03-03 13:26:06','2022-03-03 13:26:06'),(112652,367,'Ferozepur Jhirka','122104',1,0,'2022-03-03 13:26:06','2022-03-03 13:26:06'),(112653,367,'Ferozepur Namak','122107',1,0,'2022-03-03 13:26:06','2022-03-03 13:26:06'),(112654,367,'Galleria DLF-IV','122009',1,0,'2022-03-03 13:26:06','2022-03-03 13:26:06'),(112655,367,'Garhi Harsaru','122505',1,0,'2022-03-03 13:26:06','2022-03-03 13:26:06'),(112656,367,'Ghamroj','122102',1,0,'2022-03-03 13:26:07','2022-03-03 13:26:07'),(112657,367,'Ghasera','122103',1,0,'2022-03-03 13:26:07','2022-03-03 13:26:07'),(112658,367,'Ghungola','122103',1,0,'2022-03-03 13:26:07','2022-03-03 13:26:07'),(112659,367,'Gulalta','122508',1,0,'2022-03-03 13:26:07','2022-03-03 13:26:07'),(112660,367,'Gurgaon H.O','122001',1,0,'2022-03-03 13:26:07','2022-03-03 13:26:07'),(112661,367,'Gurgaon Kty.','122001',1,0,'2022-03-03 13:26:07','2022-03-03 13:26:07'),(112662,367,'Gurgaon Sector 17','122001',1,0,'2022-03-03 13:26:07','2022-03-03 13:26:07'),(112663,367,'Gurgaon Sector 45','122003',1,0,'2022-03-03 13:26:07','2022-03-03 13:26:07'),(112664,367,'Gurgaon Sector 56','122011',1,0,'2022-03-03 13:26:07','2022-03-03 13:26:07'),(112665,367,'Gurgaon South City I','122001',1,0,'2022-03-03 13:26:07','2022-03-03 13:26:07'),(112666,367,'Gurgaon South City II','122018',1,0,'2022-03-03 13:26:07','2022-03-03 13:26:07'),(112667,367,'Gurgaon Village','122006',1,0,'2022-03-03 13:26:07','2022-03-03 13:26:07'),(112668,367,'Gwal Pahari','122003',1,0,'2022-03-03 13:26:07','2022-03-03 13:26:07'),(112669,367,'Haillymandi','122504',1,0,'2022-03-03 13:26:07','2022-03-03 13:26:07'),(112670,367,'Hasanpur','122105',1,0,'2022-03-03 13:26:07','2022-03-03 13:26:07'),(112671,367,'Hirwari','122104',1,0,'2022-03-03 13:26:07','2022-03-03 13:26:07'),(112672,367,'IMT Manesar','122052',1,0,'2022-03-03 13:26:07','2022-03-03 13:26:07'),(112673,367,'Inchhapuri','122414',1,0,'2022-03-03 13:26:07','2022-03-03 13:26:07'),(112674,367,'Indir Mewat','122103',1,0,'2022-03-03 13:26:07','2022-03-03 13:26:07'),(112675,367,'Industrial Complex Dundahera','122016',1,0,'2022-03-03 13:26:07','2022-03-03 13:26:07'),(112676,367,'Industrial Estate (Gurgaon)','122007',1,0,'2022-03-03 13:26:08','2022-03-03 13:26:08'),(112677,367,'Jagat','122502',1,0,'2022-03-03 13:26:08','2022-03-03 13:26:08'),(112678,367,'Jaitpur','122502',1,0,'2022-03-03 13:26:08','2022-03-03 13:26:08'),(112679,367,'Jamalgarh','122508',1,0,'2022-03-03 13:26:08','2022-03-03 13:26:08'),(112680,367,'Jamalpur','122503',1,0,'2022-03-03 13:26:08','2022-03-03 13:26:08'),(112681,367,'Janaula','122503',1,0,'2022-03-03 13:26:08','2022-03-03 13:26:08'),(112682,367,'Jant','122502',1,0,'2022-03-03 13:26:08','2022-03-03 13:26:08'),(112683,367,'Jataula','122504',1,0,'2022-03-03 13:26:08','2022-03-03 13:26:08'),(112684,367,'Jatauli','122504',1,0,'2022-03-03 13:26:08','2022-03-03 13:26:08'),(112685,367,'Jawasi','122105',1,0,'2022-03-03 13:26:08','2022-03-03 13:26:08'),(112686,367,'Jhamuwas','122105',1,0,'2022-03-03 13:26:08','2022-03-03 13:26:08'),(112687,367,'Jharsa','122003',1,0,'2022-03-03 13:26:08','2022-03-03 13:26:08'),(112688,367,'Kadipur','122101',1,0,'2022-03-03 13:26:08','2022-03-03 13:26:08'),(112689,367,'Kakoria','122502',1,0,'2022-03-03 13:26:08','2022-03-03 13:26:08'),(112690,367,'Kalwari','122105',1,0,'2022-03-03 13:26:08','2022-03-03 13:26:08'),(112691,367,'Kankarwali Rewari','123401',1,0,'2022-03-03 13:26:08','2022-03-03 13:26:08'),(112692,367,'Karola','122504',1,0,'2022-03-03 13:26:08','2022-03-03 13:26:08'),(112693,367,'Kasan','122051',1,0,'2022-03-03 13:26:08','2022-03-03 13:26:08'),(112694,367,'Khalilpur','122502',1,0,'2022-03-03 13:26:08','2022-03-03 13:26:08'),(112695,367,'Khandewia','122504',1,0,'2022-03-03 13:26:08','2022-03-03 13:26:08'),(112696,367,'Khandsa','122004',1,0,'2022-03-03 13:26:09','2022-03-03 13:26:09'),(112697,367,'Khandsa Road','122001',1,0,'2022-03-03 13:26:09','2022-03-03 13:26:09'),(112698,367,'Khatauli','122414',1,0,'2022-03-03 13:26:09','2022-03-03 13:26:09'),(112699,367,'Khera Khurampur','122506',1,0,'2022-03-03 13:26:09','2022-03-03 13:26:09'),(112700,367,'Kherki Daula','122004',1,0,'2022-03-03 13:26:09','2022-03-03 13:26:09'),(112701,367,'Kherla','122102',1,0,'2022-03-03 13:26:09','2022-03-03 13:26:09'),(112702,367,'KherliLala','122103',1,0,'2022-03-03 13:26:09','2022-03-03 13:26:09'),(112703,367,'Khor','122414',1,0,'2022-03-03 13:26:09','2022-03-03 13:26:09'),(112704,367,'Kiranj','122103',1,0,'2022-03-03 13:26:09','2022-03-03 13:26:09'),(112705,367,'Kurthala','122107',1,0,'2022-03-03 13:26:09','2022-03-03 13:26:09'),(112706,367,'Lakhnaula','122004',1,0,'2022-03-03 13:26:09','2022-03-03 13:26:09'),(112707,367,'Lohinga Kalan','122508',1,0,'2022-03-03 13:26:09','2022-03-03 13:26:09'),(112708,367,'Lokra','122414',1,0,'2022-03-03 13:26:09','2022-03-03 13:26:09'),(112709,367,'Malab','122107',1,0,'2022-03-03 13:26:09','2022-03-03 13:26:09'),(112710,367,'Mandikhera','122108',1,0,'2022-03-03 13:26:09','2022-03-03 13:26:09'),(112711,367,'Manesar','122051',1,0,'2022-03-03 13:26:09','2022-03-03 13:26:09'),(112712,367,'Mankdola','122505',1,0,'2022-03-03 13:26:09','2022-03-03 13:26:09'),(112713,367,'Maruthi Kunj','122102',1,0,'2022-03-03 13:26:09','2022-03-03 13:26:09'),(112714,367,'Mehchana','122504',1,0,'2022-03-03 13:26:09','2022-03-03 13:26:09'),(112715,367,'Mini Sectt.','122001',1,0,'2022-03-03 13:26:09','2022-03-03 13:26:09'),(112716,367,'Mirpur','122502',1,0,'2022-03-03 13:26:09','2022-03-03 13:26:09'),(112717,367,'Mohamadpur Ahir','122105',1,0,'2022-03-03 13:26:09','2022-03-03 13:26:09'),(112718,367,'Moklawas','122413',1,0,'2022-03-03 13:26:10','2022-03-03 13:26:10'),(112719,367,'Moolthan','122108',1,0,'2022-03-03 13:26:10','2022-03-03 13:26:10'),(112720,367,'Nagina (Gurgaon)','122108',1,0,'2022-03-03 13:26:10','2022-03-03 13:26:10'),(112721,367,'Naheda','122508',1,0,'2022-03-03 13:26:10','2022-03-03 13:26:10'),(112722,367,'Nai','122508',1,0,'2022-03-03 13:26:10','2022-03-03 13:26:10'),(112723,367,'Nanukalan','122414',1,0,'2022-03-03 13:26:10','2022-03-03 13:26:10'),(112724,367,'Narhera','122503',1,0,'2022-03-03 13:26:10','2022-03-03 13:26:10'),(112725,367,'Narsinghpur','122004',1,0,'2022-03-03 13:26:10','2022-03-03 13:26:10'),(112726,367,'Nathupur','122002',1,0,'2022-03-03 13:26:10','2022-03-03 13:26:10'),(112727,367,'New Colony (Gurgaon)','122001',1,0,'2022-03-03 13:26:10','2022-03-03 13:26:10'),(112728,367,'Noorgarh','122504',1,0,'2022-03-03 13:26:10','2022-03-03 13:26:10'),(112729,367,'Nsg Camp Manesar','122051',1,0,'2022-03-03 13:26:10','2022-03-03 13:26:10'),(112730,367,'Nuh','122107',1,0,'2022-03-03 13:26:10','2022-03-03 13:26:10'),(112731,367,'Pachgaon','122413',1,0,'2022-03-03 13:26:10','2022-03-03 13:26:10'),(112732,367,'Pahari','122502',1,0,'2022-03-03 13:26:10','2022-03-03 13:26:10'),(112733,367,'Palam Road','122015',1,0,'2022-03-03 13:26:10','2022-03-03 13:26:10'),(112734,367,'Palam Vihar (Gurgaon)','122017',1,0,'2022-03-03 13:26:10','2022-03-03 13:26:10'),(112735,367,'Paltra','122101',1,0,'2022-03-03 13:26:10','2022-03-03 13:26:10'),(112736,367,'Pataudi','122503',1,0,'2022-03-03 13:26:10','2022-03-03 13:26:10'),(112737,367,'Pathreri','122413',1,0,'2022-03-03 13:26:11','2022-03-03 13:26:11'),(112738,367,'Patil R.S.','122506',1,0,'2022-03-03 13:26:11','2022-03-03 13:26:11'),(112739,367,'Pingwan','122508',1,0,'2022-03-03 13:26:11','2022-03-03 13:26:11'),(112740,367,'Punhana','122508',1,0,'2022-03-03 13:26:11','2022-03-03 13:26:11'),(112741,367,'Railwary Road','122006',1,0,'2022-03-03 13:26:11','2022-03-03 13:26:11'),(112742,367,'Raisina','122102',1,0,'2022-03-03 13:26:11','2022-03-03 13:26:11'),(112743,367,'Ramgarh','122502',1,0,'2022-03-03 13:26:11','2022-03-03 13:26:11'),(112744,367,'Rathiwas','122105',1,0,'2022-03-03 13:26:11','2022-03-03 13:26:11'),(112745,367,'Rawli','122104',1,0,'2022-03-03 13:26:11','2022-03-03 13:26:11'),(112746,367,'Rethath','122508',1,0,'2022-03-03 13:26:11','2022-03-03 13:26:11'),(112747,367,'Rewasan','122103',1,0,'2022-03-03 13:26:11','2022-03-03 13:26:11'),(112748,367,'Rithoj','122102',1,0,'2022-03-03 13:26:11','2022-03-03 13:26:11'),(112749,367,'Rojka Meo','122103',1,0,'2022-03-03 13:26:11','2022-03-03 13:26:11'),(112750,367,'Sakras','122108',1,0,'2022-03-03 13:26:11','2022-03-03 13:26:11'),(112751,367,'Sarhaul','122015',1,0,'2022-03-03 13:26:11','2022-03-03 13:26:11'),(112752,367,'Sewari','122506',1,0,'2022-03-03 13:26:11','2022-03-03 13:26:11'),(112753,367,'Shahchokha','122508',1,0,'2022-03-03 13:26:11','2022-03-03 13:26:11'),(112754,367,'Sherpur','122502',1,0,'2022-03-03 13:26:11','2022-03-03 13:26:11'),(112755,367,'Shivaji Nagar (Gurgaon)','122001',1,0,'2022-03-03 13:26:11','2022-03-03 13:26:11'),(112756,367,'Sidhrawali','122413',1,0,'2022-03-03 13:26:11','2022-03-03 13:26:11'),(112757,367,'Sihri Singhalheri','122508',1,0,'2022-03-03 13:26:11','2022-03-03 13:26:11'),(112758,367,'Sikanderpur','122004',1,0,'2022-03-03 13:26:11','2022-03-03 13:26:11'),(112759,367,'Sikohpur','122004',1,0,'2022-03-03 13:26:12','2022-03-03 13:26:12'),(112760,367,'Sikrawa','122508',1,0,'2022-03-03 13:26:12','2022-03-03 13:26:12'),(112761,367,'Singar','122508',1,0,'2022-03-03 13:26:12','2022-03-03 13:26:12'),(112762,367,'Smaspur','122003',1,0,'2022-03-03 13:26:12','2022-03-03 13:26:12'),(112763,367,'Sohna Adda','122001',1,0,'2022-03-03 13:26:12','2022-03-03 13:26:12'),(112764,367,'Sohna','122103',1,0,'2022-03-03 13:26:12','2022-03-03 13:26:12'),(112765,367,'Sudaka','122107',1,0,'2022-03-03 13:26:12','2022-03-03 13:26:12'),(112766,367,'Sultanpur','122506',1,0,'2022-03-03 13:26:12','2022-03-03 13:26:12'),(112767,367,'Sundh','122105',1,0,'2022-03-03 13:26:12','2022-03-03 13:26:12'),(112768,367,'Syed Shahpur','122414',1,0,'2022-03-03 13:26:12','2022-03-03 13:26:12'),(112769,367,'Tain','122107',1,0,'2022-03-03 13:26:12','2022-03-03 13:26:12'),(112770,367,'Tapkan','122107',1,0,'2022-03-03 13:26:12','2022-03-03 13:26:12'),(112771,367,'Tatarpur','122502',1,0,'2022-03-03 13:26:12','2022-03-03 13:26:12'),(112772,367,'Tauru Extension Counter','122105',1,0,'2022-03-03 13:26:12','2022-03-03 13:26:12'),(112773,367,'Tauru','122105',1,0,'2022-03-03 13:26:12','2022-03-03 13:26:12'),(112774,367,'Teekli','122101',1,0,'2022-03-03 13:26:12','2022-03-03 13:26:12'),(112775,367,'Turkiawas','122502',1,0,'2022-03-03 13:26:12','2022-03-03 13:26:12'),(112776,367,'Ujina','122107',1,0,'2022-03-03 13:26:12','2022-03-03 13:26:12'),(112777,367,'Umra','122108',1,0,'2022-03-03 13:26:12','2022-03-03 13:26:12'),(112778,367,'Unchamajra','122503',1,0,'2022-03-03 13:26:13','2022-03-03 13:26:13'),(112779,367,'Urban Estate (Gurgaon)','122001',1,0,'2022-03-03 13:26:13','2022-03-03 13:26:13'),(112780,367,'Wazipur','122505',1,0,'2022-03-03 13:26:13','2022-03-03 13:26:13'),(112781,367,'Wazirabad','122003',1,0,'2022-03-03 13:26:13','2022-03-03 13:26:13'),(112782,368,'A.F. Hansi','125033',1,0,'2022-03-03 13:26:13','2022-03-03 13:26:13'),(112783,368,'Agroha','125047',1,0,'2022-03-03 13:26:13','2022-03-03 13:26:13'),(112784,368,'Anaj Mandi Hansi','125033',1,0,'2022-03-03 13:26:13','2022-03-03 13:26:13'),(112785,368,'Arya Nagar','125004',1,0,'2022-03-03 13:26:13','2022-03-03 13:26:13'),(112786,368,'Auto Market Hisar','125001',1,0,'2022-03-03 13:26:13','2022-03-03 13:26:13'),(112787,368,'Azad Nagar Hisar','125007',1,0,'2022-03-03 13:26:13','2022-03-03 13:26:13'),(112788,368,'B.S.F Hisar','125011',1,0,'2022-03-03 13:26:13','2022-03-03 13:26:13'),(112789,368,'Badala','125042',1,0,'2022-03-03 13:26:13','2022-03-03 13:26:13'),(112790,368,'Badchhpar','125042',1,0,'2022-03-03 13:26:13','2022-03-03 13:26:13'),(112791,368,'Badhawar','125121',1,0,'2022-03-03 13:26:13','2022-03-03 13:26:13'),(112792,368,'Badya Brahamana','125005',1,0,'2022-03-03 13:26:13','2022-03-03 13:26:13'),(112793,368,'Balak','125112',1,0,'2022-03-03 13:26:13','2022-03-03 13:26:13'),(112794,368,'Balsmand','125004',1,0,'2022-03-03 13:26:13','2022-03-03 13:26:13'),(112795,368,'Banbhori','125121',1,0,'2022-03-03 13:26:14','2022-03-03 13:26:14'),(112796,368,'Bandaheri','125004',1,0,'2022-03-03 13:26:14','2022-03-03 13:26:14'),(112797,368,'Barwala Mandi','125121',1,0,'2022-03-03 13:26:14','2022-03-03 13:26:14'),(112798,368,'Barwala Road Hansi','125033',1,0,'2022-03-03 13:26:14','2022-03-03 13:26:14'),(112799,368,'Barwala (Hisar)','125121',1,0,'2022-03-03 13:26:14','2022-03-03 13:26:14'),(112800,368,'Bass','125042',1,0,'2022-03-03 13:26:14','2022-03-03 13:26:14'),(112801,368,'Behbalpur','125005',1,0,'2022-03-03 13:26:14','2022-03-03 13:26:14'),(112802,368,'Bhagana','125044',1,0,'2022-03-03 13:26:14','2022-03-03 13:26:14'),(112803,368,'Bhaini Amirpur','125039',1,0,'2022-03-03 13:26:14','2022-03-03 13:26:14'),(112804,368,'Bhaini Badshahpur','125121',1,0,'2022-03-03 13:26:14','2022-03-03 13:26:14'),(112805,368,'Bhaklana','125038',1,0,'2022-03-03 13:26:14','2022-03-03 13:26:14'),(112806,368,'Bhatla','125033',1,0,'2022-03-03 13:26:14','2022-03-03 13:26:14'),(112807,368,'Bhatol Jattan','125033',1,0,'2022-03-03 13:26:14','2022-03-03 13:26:14'),(112808,368,'Bhoda','125047',1,0,'2022-03-03 13:26:14','2022-03-03 13:26:14'),(112809,368,'Biana Khera','125121',1,0,'2022-03-03 13:26:14','2022-03-03 13:26:14'),(112810,368,'Bobua','125113',1,0,'2022-03-03 13:26:14','2022-03-03 13:26:14'),(112811,368,'Budana','125039',1,0,'2022-03-03 13:26:14','2022-03-03 13:26:14'),(112812,368,'Bugana','125121',1,0,'2022-03-03 13:26:14','2022-03-03 13:26:14'),(112813,368,'Burak','125004',1,0,'2022-03-03 13:26:14','2022-03-03 13:26:14'),(112814,368,'C.S.F Hisar','125011',1,0,'2022-03-03 13:26:14','2022-03-03 13:26:14'),(112815,368,'Chakpanihar','125007',1,0,'2022-03-03 13:26:14','2022-03-03 13:26:14'),(112816,368,'Chamar Khera','125113',1,0,'2022-03-03 13:26:14','2022-03-03 13:26:14'),(112817,368,'Chanot','125033',1,0,'2022-03-03 13:26:15','2022-03-03 13:26:15'),(112818,368,'Chaudhariwali','125004',1,0,'2022-03-03 13:26:15','2022-03-03 13:26:15'),(112819,368,'Chaudhariwas','125007',1,0,'2022-03-03 13:26:15','2022-03-03 13:26:15'),(112820,368,'Chikanwas','125047',1,0,'2022-03-03 13:26:15','2022-03-03 13:26:15'),(112821,368,'Chirod','125007',1,0,'2022-03-03 13:26:15','2022-03-03 13:26:15'),(112822,368,'Chuli Bagrian','125052',1,0,'2022-03-03 13:26:15','2022-03-03 13:26:15'),(112823,368,'Chuli Khurd','125052',1,0,'2022-03-03 13:26:15','2022-03-03 13:26:15'),(112824,368,'Dabra','125005',1,0,'2022-03-03 13:26:15','2022-03-03 13:26:15'),(112825,368,'Dahima','125006',1,0,'2022-03-03 13:26:15','2022-03-03 13:26:15'),(112826,368,'Dahman','125112',1,0,'2022-03-03 13:26:15','2022-03-03 13:26:15'),(112827,368,'Daroli','125052',1,0,'2022-03-03 13:26:15','2022-03-03 13:26:15'),(112828,368,'Data','125049',1,0,'2022-03-03 13:26:15','2022-03-03 13:26:15'),(112829,368,'Daulatpur','125121',1,0,'2022-03-03 13:26:15','2022-03-03 13:26:15'),(112830,368,'Daultpur','125121',1,0,'2022-03-03 13:26:15','2022-03-03 13:26:15'),(112831,368,'Daya','125005',1,0,'2022-03-03 13:26:15','2022-03-03 13:26:15'),(112832,368,'Dhadh','125121',1,0,'2022-03-03 13:26:15','2022-03-03 13:26:15'),(112833,368,'Dhana Kalan','125033',1,0,'2022-03-03 13:26:15','2022-03-03 13:26:15'),(112834,368,'Dhana Khurd','125033',1,0,'2022-03-03 13:26:15','2022-03-03 13:26:15'),(112835,368,'Dhanderi','125033',1,0,'2022-03-03 13:26:15','2022-03-03 13:26:15'),(112836,368,'Dhani Khan Bahadur','125121',1,0,'2022-03-03 13:26:15','2022-03-03 13:26:15'),(112837,368,'Dhani Peeranwali','125033',1,0,'2022-03-03 13:26:15','2022-03-03 13:26:15'),(112838,368,'Dhansu','125005',1,0,'2022-03-03 13:26:16','2022-03-03 13:26:16'),(112839,368,'Dharam Kheri','125038',1,0,'2022-03-03 13:26:16','2022-03-03 13:26:16'),(112840,368,'Dobhi','125004',1,0,'2022-03-03 13:26:16','2022-03-03 13:26:16'),(112841,368,'Durjanpur','125052',1,0,'2022-03-03 13:26:16','2022-03-03 13:26:16'),(112842,368,'Ebs Hisar','125004',1,0,'2022-03-03 13:26:16','2022-03-03 13:26:16'),(112843,368,'Faridpur','125121',1,0,'2022-03-03 13:26:16','2022-03-03 13:26:16'),(112844,368,'Gaibipur','125121',1,0,'2022-03-03 13:26:16','2022-03-03 13:26:16'),(112845,368,'Gajuwala','125120',1,0,'2022-03-03 13:26:16','2022-03-03 13:26:16'),(112846,368,'Gamra','125039',1,0,'2022-03-03 13:26:16','2022-03-03 13:26:16'),(112847,368,'Gangwa','125007',1,0,'2022-03-03 13:26:16','2022-03-03 13:26:16'),(112848,368,'Garhi','125033',1,0,'2022-03-03 13:26:16','2022-03-03 13:26:16'),(112849,368,'Gawar','125007',1,0,'2022-03-03 13:26:16','2022-03-03 13:26:16'),(112850,368,'Ghirai','125033',1,0,'2022-03-03 13:26:16','2022-03-03 13:26:16'),(112851,368,'Ghursal','125052',1,0,'2022-03-03 13:26:16','2022-03-03 13:26:16'),(112852,368,'Gju Hisar','125001',1,0,'2022-03-03 13:26:16','2022-03-03 13:26:16'),(112853,368,'Glf Hisar','125011',1,0,'2022-03-03 13:26:16','2022-03-03 13:26:16'),(112854,368,'Gorakhpur','125047',1,0,'2022-03-03 13:26:16','2022-03-03 13:26:16'),(112855,368,'Gorchi','125007',1,0,'2022-03-03 13:26:16','2022-03-03 13:26:16'),(112856,368,'Gurana','125121',1,0,'2022-03-03 13:26:16','2022-03-03 13:26:16'),(112857,368,'H;t;m;hisar','125001',1,0,'2022-03-03 13:26:16','2022-03-03 13:26:16'),(112858,368,'Ha U Hisar','125004',1,0,'2022-03-03 13:26:17','2022-03-03 13:26:17'),(112859,368,'Haibatpur','125039',1,0,'2022-03-03 13:26:17','2022-03-03 13:26:17'),(112860,368,'Hansi City','125033',1,0,'2022-03-03 13:26:17','2022-03-03 13:26:17'),(112861,368,'Hansi','125033',1,0,'2022-03-03 13:26:17','2022-03-03 13:26:17'),(112862,368,'Harita','125005',1,0,'2022-03-03 13:26:17','2022-03-03 13:26:17'),(112863,368,'Hassangarh','125113',1,0,'2022-03-03 13:26:17','2022-03-03 13:26:17'),(112864,368,'Hazampur','125033',1,0,'2022-03-03 13:26:17','2022-03-03 13:26:17'),(112865,368,'Hisar  Nai Mandi','125001',1,0,'2022-03-03 13:26:17','2022-03-03 13:26:17'),(112866,368,'Hisar Cantt','125006',1,0,'2022-03-03 13:26:17','2022-03-03 13:26:17'),(112867,368,'Hisar City','125001',1,0,'2022-03-03 13:26:17','2022-03-03 13:26:17'),(112868,368,'Hisar H.O','125001',1,0,'2022-03-03 13:26:17','2022-03-03 13:26:17'),(112869,368,'Hisar Kty','125001',1,0,'2022-03-03 13:26:17','2022-03-03 13:26:17'),(112870,368,'Iacbp Hisar','125005',1,0,'2022-03-03 13:26:17','2022-03-03 13:26:17'),(112871,368,'Jakhod Khera','125052',1,0,'2022-03-03 13:26:17','2022-03-03 13:26:17'),(112872,368,'Jamauri','125033',1,0,'2022-03-03 13:26:17','2022-03-03 13:26:17'),(112873,368,'Jeora','125121',1,0,'2022-03-03 13:26:17','2022-03-03 13:26:17'),(112874,368,'Juglan','125005',1,0,'2022-03-03 13:26:17','2022-03-03 13:26:17'),(112875,368,'Kabrel','125052',1,0,'2022-03-03 13:26:17','2022-03-03 13:26:17'),(112876,368,'Kagasar','125038',1,0,'2022-03-03 13:26:17','2022-03-03 13:26:17'),(112877,368,'Kaimri','125005',1,0,'2022-03-03 13:26:18','2022-03-03 13:26:18'),(112878,368,'Kajlan','125052',1,0,'2022-03-03 13:26:18','2022-03-03 13:26:18'),(112879,368,'Kalirawan','125052',1,0,'2022-03-03 13:26:18','2022-03-03 13:26:18'),(112880,368,'Kaller Bhaini','125113',1,0,'2022-03-03 13:26:18','2022-03-03 13:26:18'),(112881,368,'Kanoh Punia','125112',1,0,'2022-03-03 13:26:18','2022-03-03 13:26:18'),(112882,368,'Kanwari','125037',1,0,'2022-03-03 13:26:18','2022-03-03 13:26:18'),(112883,368,'Kapro','125039',1,0,'2022-03-03 13:26:18','2022-03-03 13:26:18'),(112884,368,'Khairi','125112',1,0,'2022-03-03 13:26:18','2022-03-03 13:26:18'),(112885,368,'Khairmpur','125052',1,0,'2022-03-03 13:26:18','2022-03-03 13:26:18'),(112886,368,'Khanda Kheri','125038',1,0,'2022-03-03 13:26:18','2022-03-03 13:26:18'),(112887,368,'Kharak Punia','125121',1,0,'2022-03-03 13:26:18','2022-03-03 13:26:18'),(112888,368,'Kharar Alipur','125044',1,0,'2022-03-03 13:26:18','2022-03-03 13:26:18'),(112889,368,'Kharbala','125042',1,0,'2022-03-03 13:26:18','2022-03-03 13:26:18'),(112890,368,'Kharia','125004',1,0,'2022-03-03 13:26:18','2022-03-03 13:26:18'),(112891,368,'Kharkara','125121',1,0,'2022-03-03 13:26:18','2022-03-03 13:26:18'),(112892,368,'Kharkari','125033',1,0,'2022-03-03 13:26:18','2022-03-03 13:26:18'),(112893,368,'Kharkhara','125033',1,0,'2022-03-03 13:26:18','2022-03-03 13:26:18'),(112894,368,'Khedar','125121',1,0,'2022-03-03 13:26:18','2022-03-03 13:26:18'),(112895,368,'Kheri Barki','125005',1,0,'2022-03-03 13:26:18','2022-03-03 13:26:18'),(112896,368,'Kheri Jalab','125039',1,0,'2022-03-03 13:26:18','2022-03-03 13:26:18'),(112897,368,'Kheri Kangan','125049',1,0,'2022-03-03 13:26:18','2022-03-03 13:26:18'),(112898,368,'Khokha','125033',1,0,'2022-03-03 13:26:19','2022-03-03 13:26:19'),(112899,368,'Kinala','125112',1,0,'2022-03-03 13:26:19','2022-03-03 13:26:19'),(112900,368,'Kirmara','125047',1,0,'2022-03-03 13:26:19','2022-03-03 13:26:19'),(112901,368,'Kirori','125112',1,0,'2022-03-03 13:26:19','2022-03-03 13:26:19'),(112902,368,'Kirtan','125004',1,0,'2022-03-03 13:26:19','2022-03-03 13:26:19'),(112903,368,'Kishangarh','125052',1,0,'2022-03-03 13:26:19','2022-03-03 13:26:19'),(112904,368,'Kohli','125052',1,0,'2022-03-03 13:26:19','2022-03-03 13:26:19'),(112905,368,'Koth Kalan','125039',1,0,'2022-03-03 13:26:19','2022-03-03 13:26:19'),(112906,368,'Koth Khurd','125039',1,0,'2022-03-03 13:26:19','2022-03-03 13:26:19'),(112907,368,'Kulana','125033',1,0,'2022-03-03 13:26:19','2022-03-03 13:26:19'),(112908,368,'Kuleri','125047',1,0,'2022-03-03 13:26:19','2022-03-03 13:26:19'),(112909,368,'Kumaharia','125047',1,0,'2022-03-03 13:26:19','2022-03-03 13:26:19'),(112910,368,'Kumba Khera','125113',1,0,'2022-03-03 13:26:19','2022-03-03 13:26:19'),(112911,368,'Kumbha','125033',1,0,'2022-03-03 13:26:19','2022-03-03 13:26:19'),(112912,368,'Ladwa','125006',1,0,'2022-03-03 13:26:19','2022-03-03 13:26:19'),(112913,368,'Ladwi','125052',1,0,'2022-03-03 13:26:19','2022-03-03 13:26:19'),(112914,368,'Landhari','125047',1,0,'2022-03-03 13:26:19','2022-03-03 13:26:19'),(112915,368,'Litani','125113',1,0,'2022-03-03 13:26:19','2022-03-03 13:26:19'),(112916,368,'Lohari Ragho','125039',1,0,'2022-03-03 13:26:19','2022-03-03 13:26:19'),(112917,368,'M.C.Hisar','125001',1,0,'2022-03-03 13:26:19','2022-03-03 13:26:19'),(112918,368,'Madanheri','125042',1,0,'2022-03-03 13:26:19','2022-03-03 13:26:19'),(112919,368,'Madha','125039',1,0,'2022-03-03 13:26:20','2022-03-03 13:26:20'),(112920,368,'Mahalsara','125052',1,0,'2022-03-03 13:26:20','2022-03-03 13:26:20'),(112921,368,'Maijod','125049',1,0,'2022-03-03 13:26:20','2022-03-03 13:26:20'),(112922,368,'Majra','125039',1,0,'2022-03-03 13:26:20','2022-03-03 13:26:20'),(112923,368,'Mandi Adampur','125052',1,0,'2022-03-03 13:26:20','2022-03-03 13:26:20'),(112924,368,'Mangali','125005',1,0,'2022-03-03 13:26:20','2022-03-03 13:26:20'),(112925,368,'Marh','125051',1,0,'2022-03-03 13:26:20','2022-03-03 13:26:20'),(112926,368,'Masudpur','125049',1,0,'2022-03-03 13:26:20','2022-03-03 13:26:20'),(112927,368,'Matloda','125121',1,0,'2022-03-03 13:26:20','2022-03-03 13:26:20'),(112928,368,'Mattar Sham','125004',1,0,'2022-03-03 13:26:20','2022-03-03 13:26:20'),(112929,368,'Mayar','125044',1,0,'2022-03-03 13:26:20','2022-03-03 13:26:20'),(112930,368,'Meda Khera','125052',1,0,'2022-03-03 13:26:20','2022-03-03 13:26:20'),(112931,368,'Mehanda','125033',1,0,'2022-03-03 13:26:20','2022-03-03 13:26:20'),(112932,368,'Milakpur','125039',1,0,'2022-03-03 13:26:20','2022-03-03 13:26:20'),(112933,368,'Mini Secretariat Hansi','125033',1,0,'2022-03-03 13:26:20','2022-03-03 13:26:20'),(112934,368,'Mini. Sectt','hisar',1,0,'2022-03-03 13:26:20','2022-03-03 13:26:20'),(112935,368,'Mirchpur','125039',1,0,'2022-03-03 13:26:20','2022-03-03 13:26:20'),(112936,368,'Mirzappur','125005',1,0,'2022-03-03 13:26:20','2022-03-03 13:26:20'),(112937,368,'Modle Town Hisar','125005',1,0,'2022-03-03 13:26:20','2022-03-03 13:26:20'),(112938,368,'Mohbatpur','125052',1,0,'2022-03-03 13:26:21','2022-03-03 13:26:21'),(112939,368,'Mohla','125042',1,0,'2022-03-03 13:26:21','2022-03-03 13:26:21'),(112940,368,'Moth','125039',1,0,'2022-03-03 13:26:21','2022-03-03 13:26:21'),(112941,368,'Muklan','125007',1,0,'2022-03-03 13:26:21','2022-03-03 13:26:21'),(112942,368,'Muzadpur','125037',1,0,'2022-03-03 13:26:21','2022-03-03 13:26:21'),(112943,368,'N A M Hisar','125001',1,0,'2022-03-03 13:26:21','2022-03-03 13:26:21'),(112944,368,'Nalwa','125037',1,0,'2022-03-03 13:26:21','2022-03-03 13:26:21'),(112945,368,'Nangthala','125047',1,0,'2022-03-03 13:26:21','2022-03-03 13:26:21'),(112946,368,'Nara','125039',1,0,'2022-03-03 13:26:21','2022-03-03 13:26:21'),(112947,368,'Narnaund','125039',1,0,'2022-03-03 13:26:21','2022-03-03 13:26:21'),(112948,368,'Nehla','125112',1,0,'2022-03-03 13:26:21','2022-03-03 13:26:21'),(112949,368,'Neoli Kalan','125004',1,0,'2022-03-03 13:26:21','2022-03-03 13:26:21'),(112950,368,'Niyana','125005',1,0,'2022-03-03 13:26:21','2022-03-03 13:26:21'),(112951,368,'Pabra','125112',1,0,'2022-03-03 13:26:21','2022-03-03 13:26:21'),(112952,368,'Pali','125049',1,0,'2022-03-03 13:26:21','2022-03-03 13:26:21'),(112953,368,'Palsar','125051',1,0,'2022-03-03 13:26:21','2022-03-03 13:26:21'),(112954,368,'Panihari','125121',1,0,'2022-03-03 13:26:21','2022-03-03 13:26:21'),(112955,368,'Parbhuwala','125113',1,0,'2022-03-03 13:26:21','2022-03-03 13:26:21'),(112956,368,'Patel Nager Hisar','125001',1,0,'2022-03-03 13:26:21','2022-03-03 13:26:21'),(112957,368,'Petwar','125033',1,0,'2022-03-03 13:26:21','2022-03-03 13:26:21'),(112958,368,'Puthi Samain','125042',1,0,'2022-03-03 13:26:21','2022-03-03 13:26:21'),(112959,368,'Puthimangal Khan','125033',1,0,'2022-03-03 13:26:21','2022-03-03 13:26:21'),(112960,368,'Qutabpur','125044',1,0,'2022-03-03 13:26:21','2022-03-03 13:26:21'),(112961,368,'Raipur','125044',1,0,'2022-03-03 13:26:22','2022-03-03 13:26:22'),(112962,368,'Rajli','125121',1,0,'2022-03-03 13:26:22','2022-03-03 13:26:22'),(112963,368,'Rajthal','125039',1,0,'2022-03-03 13:26:22','2022-03-03 13:26:22'),(112964,368,'Rakhi Shahpur','125039',1,0,'2022-03-03 13:26:22','2022-03-03 13:26:22'),(112965,368,'Rawalwas Khurd','125004',1,0,'2022-03-03 13:26:22','2022-03-03 13:26:22'),(112966,368,'Sadalpur','125052',1,0,'2022-03-03 13:26:22','2022-03-03 13:26:22'),(112967,368,'Sahu','125113',1,0,'2022-03-03 13:26:22','2022-03-03 13:26:22'),(112968,368,'Salemgarh','125052',1,0,'2022-03-03 13:26:22','2022-03-03 13:26:22'),(112969,368,'Sandlana','125121',1,0,'2022-03-03 13:26:22','2022-03-03 13:26:22'),(112970,368,'Sandol','125047',1,0,'2022-03-03 13:26:22','2022-03-03 13:26:22'),(112971,368,'Saniana','125113',1,0,'2022-03-03 13:26:22','2022-03-03 13:26:22'),(112972,368,'Sarangpur','125052',1,0,'2022-03-03 13:26:22','2022-03-03 13:26:22'),(112973,368,'Sarhera','125121',1,0,'2022-03-03 13:26:22','2022-03-03 13:26:22'),(112974,368,'Sarsana','125004',1,0,'2022-03-03 13:26:22','2022-03-03 13:26:22'),(112975,368,'Sarsod','125121',1,0,'2022-03-03 13:26:22','2022-03-03 13:26:22'),(112976,368,'Satroad Kalan','125006',1,0,'2022-03-03 13:26:22','2022-03-03 13:26:22'),(112977,368,'Satroad Khurd','125044',1,0,'2022-03-03 13:26:22','2022-03-03 13:26:22'),(112978,368,'Shaharwa','125005',1,0,'2022-03-03 13:26:22','2022-03-03 13:26:22'),(112979,368,'Shahpur','125004',1,0,'2022-03-03 13:26:22','2022-03-03 13:26:22'),(112980,368,'Shaikhpura','125033',1,0,'2022-03-03 13:26:22','2022-03-03 13:26:22'),(112981,368,'Shamukh','125047',1,0,'2022-03-03 13:26:22','2022-03-03 13:26:22'),(112982,368,'Sindher','125033',1,0,'2022-03-03 13:26:22','2022-03-03 13:26:22'),(112983,368,'Singhran','125005',1,0,'2022-03-03 13:26:23','2022-03-03 13:26:23'),(112984,368,'Singhwa','125042',1,0,'2022-03-03 13:26:23','2022-03-03 13:26:23'),(112985,368,'Sisai (Hisar)','125049',1,0,'2022-03-03 13:26:23','2022-03-03 13:26:23'),(112986,368,'Siswal','125052',1,0,'2022-03-03 13:26:23','2022-03-03 13:26:23'),(112987,368,'Siwani Bolan','125047',1,0,'2022-03-03 13:26:23','2022-03-03 13:26:23'),(112988,368,'Sorkhi','125033',1,0,'2022-03-03 13:26:23','2022-03-03 13:26:23'),(112989,368,'Sotha','125039',1,0,'2022-03-03 13:26:23','2022-03-03 13:26:23'),(112990,368,'Sulchani','125038',1,0,'2022-03-03 13:26:23','2022-03-03 13:26:23'),(112991,368,'Sultanpur','125033',1,0,'2022-03-03 13:26:23','2022-03-03 13:26:23'),(112992,368,'Sundawas','125004',1,0,'2022-03-03 13:26:23','2022-03-03 13:26:23'),(112993,368,'Surewala','125113',1,0,'2022-03-03 13:26:23','2022-03-03 13:26:23'),(112994,368,'T C Hansi','125033',1,0,'2022-03-03 13:26:23','2022-03-03 13:26:23'),(112995,368,'Talwandi Rana','125005',1,0,'2022-03-03 13:26:23','2022-03-03 13:26:23'),(112996,368,'Talwandi Rukka','125005',1,0,'2022-03-03 13:26:23','2022-03-03 13:26:23'),(112997,368,'Thaska','125047',1,0,'2022-03-03 13:26:23','2022-03-03 13:26:23'),(112998,368,'Thurana','125033',1,0,'2022-03-03 13:26:23','2022-03-03 13:26:23'),(112999,368,'Tokas','125004',1,0,'2022-03-03 13:26:23','2022-03-03 13:26:23'),(113000,368,'Ttc Hisar','125011',1,0,'2022-03-03 13:26:23','2022-03-03 13:26:23'),(113001,368,'Ugalan','125038',1,0,'2022-03-03 13:26:23','2022-03-03 13:26:23'),(113002,368,'Uklana Mandi','125113',1,0,'2022-03-03 13:26:23','2022-03-03 13:26:23'),(113003,368,'Umra','125033',1,0,'2022-03-03 13:26:23','2022-03-03 13:26:23'),(113004,368,'Urban Estate  2 Hhisar','125005',1,0,'2022-03-03 13:26:23','2022-03-03 13:26:23'),(113005,368,'Vidut Nagar Hisar','125005',1,0,'2022-03-03 13:26:24','2022-03-03 13:26:24'),(113006,369,'Achhej','124106',1,0,'2022-03-03 13:26:24','2022-03-03 13:26:24'),(113007,369,'Ahri','124108',1,0,'2022-03-03 13:26:24','2022-03-03 13:26:24'),(113008,369,'Akheri Madanpur','124146',1,0,'2022-03-03 13:26:24','2022-03-03 13:26:24'),(113009,369,'Arya Nagar Jhajjar','124103',1,0,'2022-03-03 13:26:24','2022-03-03 13:26:24'),(113010,369,'Assaudha','124505',1,0,'2022-03-03 13:26:24','2022-03-03 13:26:24'),(113011,369,'Badli (Jhajjar)','124105',1,0,'2022-03-03 13:26:24','2022-03-03 13:26:24'),(113012,369,'Badsa','124105',1,0,'2022-03-03 13:26:24','2022-03-03 13:26:24'),(113013,369,'Baghpur','124201',1,0,'2022-03-03 13:26:24','2022-03-03 13:26:24'),(113014,369,'Bahadurgarh H.O','124507',1,0,'2022-03-03 13:26:24','2022-03-03 13:26:24'),(113015,369,'Bahadurgarh Mandi','124508',1,0,'2022-03-03 13:26:24','2022-03-03 13:26:24'),(113016,369,'Bahadurgarh Sector 6','124507',1,0,'2022-03-03 13:26:24','2022-03-03 13:26:24'),(113017,369,'Bahu','124142',1,0,'2022-03-03 13:26:24','2022-03-03 13:26:24'),(113018,369,'Bajidpur Tappa Haveli','124104',1,0,'2022-03-03 13:26:24','2022-03-03 13:26:24'),(113019,369,'Bakra','124201',1,0,'2022-03-03 13:26:24','2022-03-03 13:26:24'),(113020,369,'Bamnaula','124105',1,0,'2022-03-03 13:26:24','2022-03-03 13:26:24'),(113021,369,'Bamnoli','124505',1,0,'2022-03-03 13:26:24','2022-03-03 13:26:24'),(113022,369,'Barahi','124505',1,0,'2022-03-03 13:26:24','2022-03-03 13:26:24'),(113023,369,'Barhana','124107',1,0,'2022-03-03 13:26:24','2022-03-03 13:26:24'),(113024,369,'Beri','124201',1,0,'2022-03-03 13:26:25','2022-03-03 13:26:25'),(113025,369,'Bhadani','124104',1,0,'2022-03-03 13:26:25','2022-03-03 13:26:25'),(113026,369,'Bhatera','124108',1,0,'2022-03-03 13:26:25','2022-03-03 13:26:25'),(113027,369,'Bhindawas','124109',1,0,'2022-03-03 13:26:25','2022-03-03 13:26:25'),(113028,369,'Bhupnia','124105',1,0,'2022-03-03 13:26:25','2022-03-03 13:26:25'),(113029,369,'Bhurawas','124146',1,0,'2022-03-03 13:26:25','2022-03-03 13:26:25'),(113030,369,'Bilochpura','124109',1,0,'2022-03-03 13:26:25','2022-03-03 13:26:25'),(113031,369,'Birar','124146',1,0,'2022-03-03 13:26:25','2022-03-03 13:26:25'),(113032,369,'Birdhana','124102',1,0,'2022-03-03 13:26:25','2022-03-03 13:26:25'),(113033,369,'Birohar','124106',1,0,'2022-03-03 13:26:25','2022-03-03 13:26:25'),(113034,369,'Bishan','124201',1,0,'2022-03-03 13:26:25','2022-03-03 13:26:25'),(113035,369,'Chamanpura','124102',1,0,'2022-03-03 13:26:25','2022-03-03 13:26:25'),(113036,369,'Charra','124504',1,0,'2022-03-03 13:26:25','2022-03-03 13:26:25'),(113037,369,'Chhappar','124108',1,0,'2022-03-03 13:26:25','2022-03-03 13:26:25'),(113038,369,'Chhochi','124107',1,0,'2022-03-03 13:26:25','2022-03-03 13:26:25'),(113039,369,'Chhuchhakwas','124106',1,0,'2022-03-03 13:26:25','2022-03-03 13:26:25'),(113040,369,'Chudani','124504',1,0,'2022-03-03 13:26:25','2022-03-03 13:26:25'),(113041,369,'Daboda Kalan','124508',1,0,'2022-03-03 13:26:25','2022-03-03 13:26:25'),(113042,369,'Daboda Khurd','124508',1,0,'2022-03-03 13:26:25','2022-03-03 13:26:25'),(113043,369,'Dadanpur','124103',1,0,'2022-03-03 13:26:25','2022-03-03 13:26:25'),(113044,369,'Dadri Toe','124103',1,0,'2022-03-03 13:26:25','2022-03-03 13:26:25'),(113045,369,'Darauli','124109',1,0,'2022-03-03 13:26:25','2022-03-03 13:26:25'),(113046,369,'Dawla Raiya','124103',1,0,'2022-03-03 13:26:25','2022-03-03 13:26:25'),(113047,369,'Deverkhana','124105',1,0,'2022-03-03 13:26:26','2022-03-03 13:26:26'),(113048,369,'Dhakla','124109',1,0,'2022-03-03 13:26:26','2022-03-03 13:26:26'),(113049,369,'Dhandlan','124107',1,0,'2022-03-03 13:26:26','2022-03-03 13:26:26'),(113050,369,'Dhaur','124201',1,0,'2022-03-03 13:26:26','2022-03-03 13:26:26'),(113051,369,'Dighal','124107',1,0,'2022-03-03 13:26:26','2022-03-03 13:26:26'),(113052,369,'Dubaldhan','124202',1,0,'2022-03-03 13:26:26','2022-03-03 13:26:26'),(113053,369,'Dujana','124102',1,0,'2022-03-03 13:26:26','2022-03-03 13:26:26'),(113054,369,'Dulhera','124508',1,0,'2022-03-03 13:26:26','2022-03-03 13:26:26'),(113055,369,'Gawalison','124103',1,0,'2022-03-03 13:26:26','2022-03-03 13:26:26'),(113056,369,'Gochhi','124107',1,0,'2022-03-03 13:26:26','2022-03-03 13:26:26'),(113057,369,'Goela Kalan','124508',1,0,'2022-03-03 13:26:26','2022-03-03 13:26:26'),(113058,369,'Goria','124142',1,0,'2022-03-03 13:26:26','2022-03-03 13:26:26'),(113059,369,'Gubhana','124105',1,0,'2022-03-03 13:26:26','2022-03-03 13:26:26'),(113060,369,'Gudha','124103',1,0,'2022-03-03 13:26:26','2022-03-03 13:26:26'),(113061,369,'Gurukul Jhajjar','124103',1,0,'2022-03-03 13:26:26','2022-03-03 13:26:26'),(113062,369,'Hasanpur','124103',1,0,'2022-03-03 13:26:26','2022-03-03 13:26:26'),(113063,369,'Hassangarh','124404',1,0,'2022-03-03 13:26:26','2022-03-03 13:26:26'),(113064,369,'I.A.Bahadurgarh','124507',1,0,'2022-03-03 13:26:26','2022-03-03 13:26:26'),(113065,369,'Jahangirpur','124104',1,0,'2022-03-03 13:26:26','2022-03-03 13:26:26'),(113066,369,'Jahazgarh','124103',1,0,'2022-03-03 13:26:26','2022-03-03 13:26:26'),(113067,369,'Jakhauda','124505',1,0,'2022-03-03 13:26:26','2022-03-03 13:26:26'),(113068,369,'Jassaur Kheri','124505',1,0,'2022-03-03 13:26:26','2022-03-03 13:26:26'),(113069,369,'Jhajjar','124103',1,0,'2022-03-03 13:26:27','2022-03-03 13:26:27'),(113070,369,'Jhamri','124142',1,0,'2022-03-03 13:26:27','2022-03-03 13:26:27'),(113071,369,'Jhanswa Kalan','124146',1,0,'2022-03-03 13:26:27','2022-03-03 13:26:27'),(113072,369,'Jharli','124106',1,0,'2022-03-03 13:26:27','2022-03-03 13:26:27'),(113073,369,'Jnv Kiloi','124104',1,0,'2022-03-03 13:26:27','2022-03-03 13:26:27'),(113074,369,'Jondhi','124103',1,0,'2022-03-03 13:26:27','2022-03-03 13:26:27'),(113075,369,'Kablana','124104',1,0,'2022-03-03 13:26:27','2022-03-03 13:26:27'),(113076,369,'Kabulpur','124201',1,0,'2022-03-03 13:26:27','2022-03-03 13:26:27'),(113077,369,'Kahri','124108',1,0,'2022-03-03 13:26:27','2022-03-03 13:26:27'),(113078,369,'Kanonda','124505',1,0,'2022-03-03 13:26:27','2022-03-03 13:26:27'),(113079,369,'Kasni','124109',1,0,'2022-03-03 13:26:27','2022-03-03 13:26:27'),(113080,369,'Kassar','124508',1,0,'2022-03-03 13:26:27','2022-03-03 13:26:27'),(113081,369,'Khachrauli','124106',1,0,'2022-03-03 13:26:27','2022-03-03 13:26:27'),(113082,369,'Khanpur Khurd','124142',1,0,'2022-03-03 13:26:27','2022-03-03 13:26:27'),(113083,369,'Kharman','124508',1,0,'2022-03-03 13:26:27','2022-03-03 13:26:27'),(113084,369,'Khatiwas','124103',1,0,'2022-03-03 13:26:27','2022-03-03 13:26:27'),(113085,369,'Kheri Asra','124104',1,0,'2022-03-03 13:26:27','2022-03-03 13:26:27'),(113086,369,'Kheri Jat','124105',1,0,'2022-03-03 13:26:27','2022-03-03 13:26:27'),(113087,369,'Kheri Kumar','124103',1,0,'2022-03-03 13:26:27','2022-03-03 13:26:27'),(113088,369,'Khetawas','124109',1,0,'2022-03-03 13:26:27','2022-03-03 13:26:27'),(113089,369,'Khorra','124142',1,0,'2022-03-03 13:26:27','2022-03-03 13:26:27'),(113090,369,'Khudan','124108',1,0,'2022-03-03 13:26:27','2022-03-03 13:26:27'),(113091,369,'Khungai','124104',1,0,'2022-03-03 13:26:27','2022-03-03 13:26:27'),(113092,369,'Kulasi','124505',1,0,'2022-03-03 13:26:27','2022-03-03 13:26:27'),(113093,369,'Ladain','124146',1,0,'2022-03-03 13:26:27','2022-03-03 13:26:27'),(113094,369,'Ladpur','124105',1,0,'2022-03-03 13:26:27','2022-03-03 13:26:27'),(113095,369,'Ladrawan','124505',1,0,'2022-03-03 13:26:28','2022-03-03 13:26:28'),(113096,369,'Line Par Bahadurgarh','124507',1,0,'2022-03-03 13:26:28','2022-03-03 13:26:28'),(113097,369,'Lohari','124108',1,0,'2022-03-03 13:26:28','2022-03-03 13:26:28'),(113098,369,'Lowa Kalan','124508',1,0,'2022-03-03 13:26:28','2022-03-03 13:26:28'),(113099,369,'Luksar','124508',1,0,'2022-03-03 13:26:28','2022-03-03 13:26:28'),(113100,369,'M.P.Majra','124103',1,0,'2022-03-03 13:26:28','2022-03-03 13:26:28'),(113101,369,'Machrauli','124108',1,0,'2022-03-03 13:26:28','2022-03-03 13:26:28'),(113102,369,'Madana Kalan','124102',1,0,'2022-03-03 13:26:28','2022-03-03 13:26:28'),(113103,369,'Majra','124202',1,0,'2022-03-03 13:26:28','2022-03-03 13:26:28'),(113104,369,'Mandothi','124506',1,0,'2022-03-03 13:26:28','2022-03-03 13:26:28'),(113105,369,'Marot','124106',1,0,'2022-03-03 13:26:28','2022-03-03 13:26:28'),(113106,369,'Matanhail','124106',1,0,'2022-03-03 13:26:28','2022-03-03 13:26:28'),(113107,369,'Mehrana','124102',1,0,'2022-03-03 13:26:28','2022-03-03 13:26:28'),(113108,369,'Mundahera','124146',1,0,'2022-03-03 13:26:28','2022-03-03 13:26:28'),(113109,369,'Mundsa','124106',1,0,'2022-03-03 13:26:28','2022-03-03 13:26:28'),(113110,369,'Nehru College Jhajjar','124104',1,0,'2022-03-03 13:26:28','2022-03-03 13:26:28'),(113111,369,'Nilaheri','124146',1,0,'2022-03-03 13:26:28','2022-03-03 13:26:28'),(113112,369,'Niwada','124109',1,0,'2022-03-03 13:26:28','2022-03-03 13:26:28'),(113113,369,'Nogawan','124108',1,0,'2022-03-03 13:26:28','2022-03-03 13:26:28'),(113114,369,'Nogawan','124106',1,0,'2022-03-03 13:26:28','2022-03-03 13:26:28'),(113115,369,'Noona Majra','124508',1,0,'2022-03-03 13:26:28','2022-03-03 13:26:28'),(113116,369,'Palra','124103',1,0,'2022-03-03 13:26:29','2022-03-03 13:26:29'),(113117,369,'Pataudah','124108',1,0,'2022-03-03 13:26:29','2022-03-03 13:26:29'),(113118,369,'Pelpa','124105',1,0,'2022-03-03 13:26:29','2022-03-03 13:26:29'),(113119,369,'Pilana','124202',1,0,'2022-03-03 13:26:29','2022-03-03 13:26:29'),(113120,369,'Rewari Khera','124504',1,0,'2022-03-03 13:26:29','2022-03-03 13:26:29'),(113121,369,'Ritauli','124201',1,0,'2022-03-03 13:26:29','2022-03-03 13:26:29'),(113122,369,'Sahlawas','124146',1,0,'2022-03-03 13:26:29','2022-03-03 13:26:29'),(113123,369,'Samaspur Majra','124109',1,0,'2022-03-03 13:26:29','2022-03-03 13:26:29'),(113124,369,'Sampla','124501',1,0,'2022-03-03 13:26:29','2022-03-03 13:26:29'),(113125,369,'Sankhol','124508',1,0,'2022-03-03 13:26:29','2022-03-03 13:26:29'),(113126,369,'Sasroli','124106',1,0,'2022-03-03 13:26:29','2022-03-03 13:26:29'),(113127,369,'Sehlenga','124106',1,0,'2022-03-03 13:26:29','2022-03-03 13:26:29'),(113128,369,'Seria','124102',1,0,'2022-03-03 13:26:29','2022-03-03 13:26:29'),(113129,369,'Sewana','124202',1,0,'2022-03-03 13:26:29','2022-03-03 13:26:29'),(113130,369,'Silana','124103',1,0,'2022-03-03 13:26:29','2022-03-03 13:26:29'),(113131,369,'Silani','124103',1,0,'2022-03-03 13:26:29','2022-03-03 13:26:29'),(113132,369,'Soldha','124508',1,0,'2022-03-03 13:26:29','2022-03-03 13:26:29'),(113133,369,'Sondhi','124105',1,0,'2022-03-03 13:26:29','2022-03-03 13:26:29'),(113134,369,'Subana','124109',1,0,'2022-03-03 13:26:29','2022-03-03 13:26:29'),(113135,369,'Suha','124104',1,0,'2022-03-03 13:26:29','2022-03-03 13:26:29'),(113136,369,'Sulodha','124103',1,0,'2022-03-03 13:26:29','2022-03-03 13:26:29'),(113137,369,'Surheti','124109',1,0,'2022-03-03 13:26:29','2022-03-03 13:26:29'),(113138,369,'Talao','124103',1,0,'2022-03-03 13:26:29','2022-03-03 13:26:29'),(113139,369,'Tandaheri','124506',1,0,'2022-03-03 13:26:29','2022-03-03 13:26:29'),(113140,369,'Tumbaheri','124109',1,0,'2022-03-03 13:26:29','2022-03-03 13:26:29'),(113141,369,'Ukhal Channa','124104',1,0,'2022-03-03 13:26:30','2022-03-03 13:26:30'),(113142,369,'Utlodha','124103',1,0,'2022-03-03 13:26:30','2022-03-03 13:26:30'),(113143,369,'Yakubpur','124103',1,0,'2022-03-03 13:26:30','2022-03-03 13:26:30'),(113144,370,'Ahirka','126102',1,0,'2022-03-03 13:26:30','2022-03-03 13:26:30'),(113145,370,'Alewa','126111',1,0,'2022-03-03 13:26:30','2022-03-03 13:26:30'),(113146,370,'Amargarh','126116',1,0,'2022-03-03 13:26:30','2022-03-03 13:26:30'),(113147,370,'Anchra Kalan','126112',1,0,'2022-03-03 13:26:30','2022-03-03 13:26:30'),(113148,370,'Assan','126113',1,0,'2022-03-03 13:26:30','2022-03-03 13:26:30'),(113149,370,'Badanpur','126152',1,0,'2022-03-03 13:26:30','2022-03-03 13:26:30'),(113150,370,'Badhana','126125',1,0,'2022-03-03 13:26:30','2022-03-03 13:26:30'),(113151,370,'Bagru Kalan','126112',1,0,'2022-03-03 13:26:30','2022-03-03 13:26:30'),(113152,370,'Bambhewa','126113',1,0,'2022-03-03 13:26:30','2022-03-03 13:26:30'),(113153,370,'Baniya Khera','126110',1,0,'2022-03-03 13:26:30','2022-03-03 13:26:30'),(113154,370,'Baroda','126115',1,0,'2022-03-03 13:26:30','2022-03-03 13:26:30'),(113155,370,'Baroli','126114',1,0,'2022-03-03 13:26:30','2022-03-03 13:26:30'),(113156,370,'Barsola','126115',1,0,'2022-03-03 13:26:30','2022-03-03 13:26:30'),(113157,370,'Barthana','126113',1,0,'2022-03-03 13:26:30','2022-03-03 13:26:30'),(113158,370,'Belarkhan','126116',1,0,'2022-03-03 13:26:30','2022-03-03 13:26:30'),(113159,370,'Bhana Brahmana','126116',1,0,'2022-03-03 13:26:30','2022-03-03 13:26:30'),(113160,370,'Bhongra','126115',1,0,'2022-03-03 13:26:30','2022-03-03 13:26:30'),(113161,370,'Bhuslana Kalan','126112',1,0,'2022-03-03 13:26:30','2022-03-03 13:26:30'),(113162,370,'Bhutani','126112',1,0,'2022-03-03 13:26:30','2022-03-03 13:26:30'),(113163,370,'Bibipur','126102',1,0,'2022-03-03 13:26:30','2022-03-03 13:26:30'),(113164,370,'Bighana','126111',1,0,'2022-03-03 13:26:30','2022-03-03 13:26:30'),(113165,370,'Bikhiwala','126152',1,0,'2022-03-03 13:26:31','2022-03-03 13:26:31'),(113166,370,'Bishanpura','126114',1,0,'2022-03-03 13:26:31','2022-03-03 13:26:31'),(113167,370,'Buana','126114',1,0,'2022-03-03 13:26:31','2022-03-03 13:26:31'),(113168,370,'Budain','126115',1,0,'2022-03-03 13:26:31','2022-03-03 13:26:31'),(113169,370,'Budda Khera Lather','126101',1,0,'2022-03-03 13:26:31','2022-03-03 13:26:31'),(113170,370,'Budha Khera','126113',1,0,'2022-03-03 13:26:31','2022-03-03 13:26:31'),(113171,370,'Chhatar','126125',1,0,'2022-03-03 13:26:31','2022-03-03 13:26:31'),(113172,370,'Chuharpur','126125',1,0,'2022-03-03 13:26:31','2022-03-03 13:26:31'),(113173,370,'Dablain Kalan','126116',1,0,'2022-03-03 13:26:31','2022-03-03 13:26:31'),(113174,370,'Dalamwala','126110',1,0,'2022-03-03 13:26:31','2022-03-03 13:26:31'),(113175,370,'Dariyawala','126102',1,0,'2022-03-03 13:26:31','2022-03-03 13:26:31'),(113176,370,'Dehola','126125',1,0,'2022-03-03 13:26:31','2022-03-03 13:26:31'),(113177,370,'Deorer','126101',1,0,'2022-03-03 13:26:31','2022-03-03 13:26:31'),(113178,370,'Dhabitek Singh','126116',1,0,'2022-03-03 13:26:31','2022-03-03 13:26:31'),(113179,370,'Dhakal','126116',1,0,'2022-03-03 13:26:31','2022-03-03 13:26:31'),(113180,370,'Dhamtan Sahib','126116',1,0,'2022-03-03 13:26:31','2022-03-03 13:26:31'),(113181,370,'Dhanoda Kalan','126152',1,0,'2022-03-03 13:26:31','2022-03-03 13:26:31'),(113182,370,'Dhanori','126116',1,0,'2022-03-03 13:26:31','2022-03-03 13:26:31'),(113183,370,'Dharamgarh','126112',1,0,'2022-03-03 13:26:31','2022-03-03 13:26:31'),(113184,370,'Dharodi','126116',1,0,'2022-03-03 13:26:31','2022-03-03 13:26:31'),(113185,370,'Dharthrath','126110',1,0,'2022-03-03 13:26:32','2022-03-03 13:26:32'),(113186,370,'Dhigana','126114',1,0,'2022-03-03 13:26:32','2022-03-03 13:26:32'),(113187,370,'Didwara','126112',1,0,'2022-03-03 13:26:32','2022-03-03 13:26:32'),(113188,370,'Dilwala','126111',1,0,'2022-03-03 13:26:32','2022-03-03 13:26:32'),(113189,370,'Dumarkhan Kalan','126116',1,0,'2022-03-03 13:26:32','2022-03-03 13:26:32'),(113190,370,'Durana','126111',1,0,'2022-03-03 13:26:32','2022-03-03 13:26:32'),(113191,370,'Durjanpur','126152',1,0,'2022-03-03 13:26:32','2022-03-03 13:26:32'),(113192,370,'Fateh Garh','126101',1,0,'2022-03-03 13:26:32','2022-03-03 13:26:32'),(113193,370,'Gangoli','126113',1,0,'2022-03-03 13:26:32','2022-03-03 13:26:32'),(113194,370,'Garhi','126116',1,0,'2022-03-03 13:26:32','2022-03-03 13:26:32'),(113195,370,'Garhwali','126114',1,0,'2022-03-03 13:26:32','2022-03-03 13:26:32'),(113196,370,'Gatauli','126114',1,0,'2022-03-03 13:26:32','2022-03-03 13:26:32'),(113197,370,'Ghason Kalan','126116',1,0,'2022-03-03 13:26:32','2022-03-03 13:26:32'),(113198,370,'Gogrian','126115',1,0,'2022-03-03 13:26:32','2022-03-03 13:26:32'),(113199,370,'Gulkani','126102',1,0,'2022-03-03 13:26:32','2022-03-03 13:26:32'),(113200,370,'Hadwa','126113',1,0,'2022-03-03 13:26:32','2022-03-03 13:26:32'),(113201,370,'Hamir Garh','126116',1,0,'2022-03-03 13:26:32','2022-03-03 13:26:32'),(113202,370,'Hathwala','126101',1,0,'2022-03-03 13:26:32','2022-03-03 13:26:32'),(113203,370,'Hatt','126112',1,0,'2022-03-03 13:26:32','2022-03-03 13:26:32'),(113204,370,'Igrah','126102',1,0,'2022-03-03 13:26:32','2022-03-03 13:26:32'),(113205,370,'Ikkas','126102',1,0,'2022-03-03 13:26:32','2022-03-03 13:26:32'),(113206,370,'Intal Kalan','126102',1,0,'2022-03-03 13:26:32','2022-03-03 13:26:32'),(113207,370,'Jajanwala','126152',1,0,'2022-03-03 13:26:33','2022-03-03 13:26:33'),(113208,370,'Jajwan','126102',1,0,'2022-03-03 13:26:33','2022-03-03 13:26:33'),(113209,370,'Jamni','126113',1,0,'2022-03-03 13:26:33','2022-03-03 13:26:33'),(113210,370,'Jhanjkalan','126102',1,0,'2022-03-03 13:26:33','2022-03-03 13:26:33'),(113211,370,'Jheel','126116',1,0,'2022-03-03 13:26:33','2022-03-03 13:26:33'),(113212,370,'Jind H.O','126102',1,0,'2022-03-03 13:26:33','2022-03-03 13:26:33'),(113213,370,'Jind Mini Sectt.','126102',1,0,'2022-03-03 13:26:33','2022-03-03 13:26:33'),(113214,370,'Jind Palika Bazar','126102',1,0,'2022-03-03 13:26:33','2022-03-03 13:26:33'),(113215,370,'Jind Patiala Chowk','126102',1,0,'2022-03-03 13:26:33','2022-03-03 13:26:33'),(113216,370,'Jind Punjabi Bazar','126102',1,0,'2022-03-03 13:26:33','2022-03-03 13:26:33'),(113217,370,'Jind Railway Station','126102',1,0,'2022-03-03 13:26:33','2022-03-03 13:26:33'),(113218,370,'Jind Rohtak Road','126102',1,0,'2022-03-03 13:26:33','2022-03-03 13:26:33'),(113219,370,'Julana','126101',1,0,'2022-03-03 13:26:33','2022-03-03 13:26:33'),(113220,370,'Julani','126102',1,0,'2022-03-03 13:26:33','2022-03-03 13:26:33'),(113221,370,'Kabarchha','126115',1,0,'2022-03-03 13:26:33','2022-03-03 13:26:33'),(113222,370,'Kakrod','126115',1,0,'2022-03-03 13:26:33','2022-03-03 13:26:33'),(113223,370,'Kalwan','126116',1,0,'2022-03-03 13:26:33','2022-03-03 13:26:33'),(113224,370,'Kalwan','126113',1,0,'2022-03-03 13:26:33','2022-03-03 13:26:33'),(113225,370,'Karamgarh','126116',1,0,'2022-03-03 13:26:33','2022-03-03 13:26:33'),(113226,370,'Karkhana','126112',1,0,'2022-03-03 13:26:33','2022-03-03 13:26:33'),(113227,370,'Karsaula','126101',1,0,'2022-03-03 13:26:33','2022-03-03 13:26:33'),(113228,370,'Karsindhu','126115',1,0,'2022-03-03 13:26:34','2022-03-03 13:26:34'),(113229,370,'Karsindu','126112',1,0,'2022-03-03 13:26:34','2022-03-03 13:26:34'),(113230,370,'Kasun','126115',1,0,'2022-03-03 13:26:34','2022-03-03 13:26:34'),(113231,370,'Kendela','126125',1,0,'2022-03-03 13:26:34','2022-03-03 13:26:34'),(113232,370,'Kerela','126101',1,0,'2022-03-03 13:26:34','2022-03-03 13:26:34'),(113233,370,'Khanda','126111',1,0,'2022-03-03 13:26:34','2022-03-03 13:26:34'),(113234,370,'Kharakbhura','126115',1,0,'2022-03-03 13:26:34','2022-03-03 13:26:34'),(113235,370,'Kharakramji','126102',1,0,'2022-03-03 13:26:34','2022-03-03 13:26:34'),(113236,370,'Kharal','126116',1,0,'2022-03-03 13:26:34','2022-03-03 13:26:34'),(113237,370,'Khatkar','126115',1,0,'2022-03-03 13:26:34','2022-03-03 13:26:34'),(113238,370,'Kheri Khermawati','126112',1,0,'2022-03-03 13:26:34','2022-03-03 13:26:34'),(113239,370,'Khrindwal','126116',1,0,'2022-03-03 13:26:34','2022-03-03 13:26:34'),(113240,370,'Khunga Kothi','126110',1,0,'2022-03-03 13:26:34','2022-03-03 13:26:34'),(113241,370,'Kila Zaffargarh','126101',1,0,'2022-03-03 13:26:34','2022-03-03 13:26:34'),(113242,370,'Kinana','126114',1,0,'2022-03-03 13:26:34','2022-03-03 13:26:34'),(113243,370,'Kuchrana Kalan','126125',1,0,'2022-03-03 13:26:34','2022-03-03 13:26:34'),(113244,370,'Lajwan Kalan','126101',1,0,'2022-03-03 13:26:34','2022-03-03 13:26:34'),(113245,370,'Lodhar','126125',1,0,'2022-03-03 13:26:34','2022-03-03 13:26:34'),(113246,370,'Lowan','126116',1,0,'2022-03-03 13:26:34','2022-03-03 13:26:34'),(113247,370,'Ludana','126113',1,0,'2022-03-03 13:26:34','2022-03-03 13:26:34'),(113248,370,'Makhand','126115',1,0,'2022-03-03 13:26:34','2022-03-03 13:26:34'),(113249,370,'Malhar','126112',1,0,'2022-03-03 13:26:34','2022-03-03 13:26:34'),(113250,370,'Malikpur','126112',1,0,'2022-03-03 13:26:35','2022-03-03 13:26:35'),(113251,370,'Malwi','126101',1,0,'2022-03-03 13:26:35','2022-03-03 13:26:35'),(113252,370,'Mandi Kalan','126125',1,0,'2022-03-03 13:26:35','2022-03-03 13:26:35'),(113253,370,'Mangalpur','126152',1,0,'2022-03-03 13:26:35','2022-03-03 13:26:35'),(113254,370,'Manohar Pur','126102',1,0,'2022-03-03 13:26:35','2022-03-03 13:26:35'),(113255,370,'Mehrara','126101',1,0,'2022-03-03 13:26:35','2022-03-03 13:26:35'),(113256,370,'Mohammad Khera','126110',1,0,'2022-03-03 13:26:35','2022-03-03 13:26:35'),(113257,370,'Mohangarh','126115',1,0,'2022-03-03 13:26:35','2022-03-03 13:26:35'),(113258,370,'Morkhi','126113',1,0,'2022-03-03 13:26:35','2022-03-03 13:26:35'),(113259,370,'Mowana','126112',1,0,'2022-03-03 13:26:35','2022-03-03 13:26:35'),(113260,370,'Naguran','126125',1,0,'2022-03-03 13:26:35','2022-03-03 13:26:35'),(113261,370,'Nandgarh','126101',1,0,'2022-03-03 13:26:35','2022-03-03 13:26:35'),(113262,370,'Narwana City','126116',1,0,'2022-03-03 13:26:35','2022-03-03 13:26:35'),(113263,370,'Narwana','126116',1,0,'2022-03-03 13:26:35','2022-03-03 13:26:35'),(113264,370,'Nidana','126114',1,0,'2022-03-03 13:26:35','2022-03-03 13:26:35'),(113265,370,'Nidani','126102',1,0,'2022-03-03 13:26:35','2022-03-03 13:26:35'),(113266,370,'Nimnabad','126112',1,0,'2022-03-03 13:26:35','2022-03-03 13:26:35'),(113267,370,'Nirjan','126102',1,0,'2022-03-03 13:26:35','2022-03-03 13:26:35'),(113268,370,'Paju Kalan','126112',1,0,'2022-03-03 13:26:35','2022-03-03 13:26:35'),(113269,370,'Pauli','126101',1,0,'2022-03-03 13:26:35','2022-03-03 13:26:35'),(113270,370,'Pegan','126111',1,0,'2022-03-03 13:26:35','2022-03-03 13:26:35'),(113271,370,'Pharain Kalan','126116',1,0,'2022-03-03 13:26:36','2022-03-03 13:26:36'),(113272,370,'Phullian Kalan','126116',1,0,'2022-03-03 13:26:36','2022-03-03 13:26:36'),(113273,370,'Pillukhera','126113',1,0,'2022-03-03 13:26:36','2022-03-03 13:26:36'),(113274,370,'Pindara','126102',1,0,'2022-03-03 13:26:36','2022-03-03 13:26:36'),(113275,370,'Pipaltha','126116',1,0,'2022-03-03 13:26:36','2022-03-03 13:26:36'),(113276,370,'Radhana','126102',1,0,'2022-03-03 13:26:36','2022-03-03 13:26:36'),(113277,370,'Rajgarh Gurthali','126116',1,0,'2022-03-03 13:26:36','2022-03-03 13:26:36'),(113278,370,'Ram Nagar','126112',1,0,'2022-03-03 13:26:36','2022-03-03 13:26:36'),(113279,370,'Ram Rai','126102',1,0,'2022-03-03 13:26:36','2022-03-03 13:26:36'),(113280,370,'Rasidan','126116',1,0,'2022-03-03 13:26:36','2022-03-03 13:26:36'),(113281,370,'Ritauli','126110',1,0,'2022-03-03 13:26:36','2022-03-03 13:26:36'),(113282,370,'Rohar','126112',1,0,'2022-03-03 13:26:36','2022-03-03 13:26:36'),(113283,370,'Rojhla','126112',1,0,'2022-03-03 13:26:36','2022-03-03 13:26:36'),(113284,370,'Roopgarh','126102',1,0,'2022-03-03 13:26:36','2022-03-03 13:26:36'),(113285,370,'Sachha Khera','126152',1,0,'2022-03-03 13:26:36','2022-03-03 13:26:36'),(113286,370,'Safidon City','126112',1,0,'2022-03-03 13:26:36','2022-03-03 13:26:36'),(113287,370,'Safidon','126112',1,0,'2022-03-03 13:26:36','2022-03-03 13:26:36'),(113288,370,'Sainthali','126152',1,0,'2022-03-03 13:26:36','2022-03-03 13:26:36'),(113289,370,'Sandil','126125',1,0,'2022-03-03 13:26:36','2022-03-03 13:26:36'),(113290,370,'Shahpur','126125',1,0,'2022-03-03 13:26:36','2022-03-03 13:26:36'),(113291,370,'Shamlo Kalan','126114',1,0,'2022-03-03 13:26:36','2022-03-03 13:26:36'),(113292,370,'Silakheri','126112',1,0,'2022-03-03 13:26:36','2022-03-03 13:26:36'),(113293,370,'Sindhwi Kheri','126102',1,0,'2022-03-03 13:26:37','2022-03-03 13:26:37'),(113294,370,'Singhana','126112',1,0,'2022-03-03 13:26:37','2022-03-03 13:26:37'),(113295,370,'Singhwal','126116',1,0,'2022-03-03 13:26:37','2022-03-03 13:26:37'),(113296,370,'Sinsar','126116',1,0,'2022-03-03 13:26:37','2022-03-03 13:26:37'),(113297,370,'Siwaha','126113',1,0,'2022-03-03 13:26:37','2022-03-03 13:26:37'),(113298,370,'Siwan Mal','126112',1,0,'2022-03-03 13:26:37','2022-03-03 13:26:37'),(113299,370,'Sudkain Kalan','126115',1,0,'2022-03-03 13:26:37','2022-03-03 13:26:37'),(113300,370,'Sudkain Khurd','126116',1,0,'2022-03-03 13:26:37','2022-03-03 13:26:37'),(113301,370,'Sulhera','126116',1,0,'2022-03-03 13:26:37','2022-03-03 13:26:37'),(113302,370,'Thua','126125',1,0,'2022-03-03 13:26:37','2022-03-03 13:26:37'),(113303,370,'Uchana Khrud','126115',1,0,'2022-03-03 13:26:37','2022-03-03 13:26:37'),(113304,370,'Uchana','126115',1,0,'2022-03-03 13:26:37','2022-03-03 13:26:37'),(113305,370,'Ujhana','126116',1,0,'2022-03-03 13:26:37','2022-03-03 13:26:37'),(113306,371,'Agondh','136035',1,0,'2022-03-03 13:26:37','2022-03-03 13:26:37'),(113307,371,'Ahun','136021',1,0,'2022-03-03 13:26:37','2022-03-03 13:26:37'),(113308,371,'Arnauli','136034',1,0,'2022-03-03 13:26:37','2022-03-03 13:26:37'),(113309,371,'Badsikri Kalan','136117',1,0,'2022-03-03 13:26:37','2022-03-03 13:26:37'),(113310,371,'Badsui','136034',1,0,'2022-03-03 13:26:37','2022-03-03 13:26:37'),(113311,371,'Bakal','136043',1,0,'2022-03-03 13:26:37','2022-03-03 13:26:37'),(113312,371,'Balbera','136034',1,0,'2022-03-03 13:26:37','2022-03-03 13:26:37'),(113313,371,'Balu','136117',1,0,'2022-03-03 13:26:38','2022-03-03 13:26:38'),(113314,371,'Baraut','136027',1,0,'2022-03-03 13:26:38','2022-03-03 13:26:38'),(113315,371,'Barsana','136026',1,0,'2022-03-03 13:26:38','2022-03-03 13:26:38'),(113316,371,'Batta','136117',1,0,'2022-03-03 13:26:38','2022-03-03 13:26:38'),(113317,371,'Baupur','136034',1,0,'2022-03-03 13:26:38','2022-03-03 13:26:38'),(113318,371,'Bhagal','136034',1,0,'2022-03-03 13:26:38','2022-03-03 13:26:38'),(113319,371,'Bhana','136043',1,0,'2022-03-03 13:26:38','2022-03-03 13:26:38'),(113320,371,'Bhuna','136034',1,0,'2022-03-03 13:26:38','2022-03-03 13:26:38'),(113321,371,'Bhuslan','136034',1,0,'2022-03-03 13:26:38','2022-03-03 13:26:38'),(113322,371,'Bir Bangran','136044',1,0,'2022-03-03 13:26:38','2022-03-03 13:26:38'),(113323,371,'Budha Khera','136027',1,0,'2022-03-03 13:26:38','2022-03-03 13:26:38'),(113324,371,'Chandana','136027',1,0,'2022-03-03 13:26:38','2022-03-03 13:26:38'),(113325,371,'Chandlana','136020',1,0,'2022-03-03 13:26:38','2022-03-03 13:26:38'),(113326,371,'Chaushala','136117',1,0,'2022-03-03 13:26:38','2022-03-03 13:26:38'),(113327,371,'Chika','136034',1,0,'2022-03-03 13:26:38','2022-03-03 13:26:38'),(113328,371,'Chuhar Majra','136021',1,0,'2022-03-03 13:26:38','2022-03-03 13:26:38'),(113329,371,'Daba','136034',1,0,'2022-03-03 13:26:38','2022-03-03 13:26:38'),(113330,371,'Deeg','136026',1,0,'2022-03-03 13:26:38','2022-03-03 13:26:38'),(113331,371,'Deoban','136027',1,0,'2022-03-03 13:26:38','2022-03-03 13:26:38'),(113332,371,'Deohera','136027',1,0,'2022-03-03 13:26:38','2022-03-03 13:26:38'),(113333,371,'Dewal','136027',1,0,'2022-03-03 13:26:38','2022-03-03 13:26:38'),(113334,371,'Dhand','136020',1,0,'2022-03-03 13:26:38','2022-03-03 13:26:38'),(113335,371,'Dhundwa','136117',1,0,'2022-03-03 13:26:38','2022-03-03 13:26:38'),(113336,371,'Dubbal','136117',1,0,'2022-03-03 13:26:39','2022-03-03 13:26:39'),(113337,371,'Duserpur','136035',1,0,'2022-03-03 13:26:39','2022-03-03 13:26:39'),(113338,371,'Fatehpur (Kaithal)','136042',1,0,'2022-03-03 13:26:39','2022-03-03 13:26:39'),(113339,371,'Gaggarpur','136034',1,0,'2022-03-03 13:26:39','2022-03-03 13:26:39'),(113340,371,'Geong','136027',1,0,'2022-03-03 13:26:39','2022-03-03 13:26:39'),(113341,371,'Guhla','136035',1,0,'2022-03-03 13:26:39','2022-03-03 13:26:39'),(113342,371,'Guhna','136027',1,0,'2022-03-03 13:26:39','2022-03-03 13:26:39'),(113343,371,'Gulyana Songri','136027',1,0,'2022-03-03 13:26:39','2022-03-03 13:26:39'),(113344,371,'Habri','136026',1,0,'2022-03-03 13:26:39','2022-03-03 13:26:39'),(113345,371,'Hajwana','136026',1,0,'2022-03-03 13:26:39','2022-03-03 13:26:39'),(113346,371,'Harigarh Kingan','136034',1,0,'2022-03-03 13:26:39','2022-03-03 13:26:39'),(113347,371,'Haripura','136117',1,0,'2022-03-03 13:26:39','2022-03-03 13:26:39'),(113348,371,'Harsola','136027',1,0,'2022-03-03 13:26:39','2022-03-03 13:26:39'),(113349,371,'Jadola','136020',1,0,'2022-03-03 13:26:39','2022-03-03 13:26:39'),(113350,371,'Jajjanpur','136020',1,0,'2022-03-03 13:26:39','2022-03-03 13:26:39'),(113351,371,'Jakholi','136027',1,0,'2022-03-03 13:26:39','2022-03-03 13:26:39'),(113352,371,'Kailram','136117',1,0,'2022-03-03 13:26:39','2022-03-03 13:26:39'),(113353,371,'Kaithal City','136027',1,0,'2022-03-03 13:26:39','2022-03-03 13:26:39'),(113354,371,'Kaithal','136027',1,0,'2022-03-03 13:26:39','2022-03-03 13:26:39'),(113355,371,'Kakot','136043',1,0,'2022-03-03 13:26:39','2022-03-03 13:26:39'),(113356,371,'Kakrala Inayat','136033',1,0,'2022-03-03 13:26:40','2022-03-03 13:26:40'),(113357,371,'Kalasar','136117',1,0,'2022-03-03 13:26:40','2022-03-03 13:26:40'),(113358,371,'Kalayat Mandi','136117',1,0,'2022-03-03 13:26:40','2022-03-03 13:26:40'),(113359,371,'Kalayat','136117',1,0,'2022-03-03 13:26:40','2022-03-03 13:26:40'),(113360,371,'Kangthali','136033',1,0,'2022-03-03 13:26:40','2022-03-03 13:26:40'),(113361,371,'Karnal Road Kaithal','136027',1,0,'2022-03-03 13:26:40','2022-03-03 13:26:40'),(113362,371,'Karora','136043',1,0,'2022-03-03 13:26:40','2022-03-03 13:26:40'),(113363,371,'Kassan','136027',1,0,'2022-03-03 13:26:40','2022-03-03 13:26:40'),(113364,371,'Kaul','136021',1,0,'2022-03-03 13:26:40','2022-03-03 13:26:40'),(113365,371,'Kawartan','136033',1,0,'2022-03-03 13:26:40','2022-03-03 13:26:40'),(113366,371,'Keorak','136027',1,0,'2022-03-03 13:26:40','2022-03-03 13:26:40'),(113367,371,'Kharak Pandwan','136117',1,0,'2022-03-03 13:26:40','2022-03-03 13:26:40'),(113368,371,'Kharaudi','136034',1,0,'2022-03-03 13:26:40','2022-03-03 13:26:40'),(113369,371,'Kharkada','136035',1,0,'2022-03-03 13:26:40','2022-03-03 13:26:40'),(113370,371,'Kharkan','136035',1,0,'2022-03-03 13:26:40','2022-03-03 13:26:40'),(113371,371,'Kheri Gulam Ali','136033',1,0,'2022-03-03 13:26:40','2022-03-03 13:26:40'),(113372,371,'Kheri Simbal Wali','136027',1,0,'2022-03-03 13:26:40','2022-03-03 13:26:40'),(113373,371,'Khurana','136027',1,0,'2022-03-03 13:26:40','2022-03-03 13:26:40'),(113374,371,'Kichhana','136027',1,0,'2022-03-03 13:26:40','2022-03-03 13:26:40'),(113375,371,'Kithana','136044',1,0,'2022-03-03 13:26:40','2022-03-03 13:26:40'),(113376,371,'Kolekhan','136117',1,0,'2022-03-03 13:26:40','2022-03-03 13:26:40'),(113377,371,'Kotra','136043',1,0,'2022-03-03 13:26:40','2022-03-03 13:26:40'),(113378,371,'Kultaran','136027',1,0,'2022-03-03 13:26:41','2022-03-03 13:26:41'),(113379,371,'Kurar','136117',1,0,'2022-03-03 13:26:41','2022-03-03 13:26:41'),(113380,371,'Ladana Baba','136027',1,0,'2022-03-03 13:26:41','2022-03-03 13:26:41'),(113381,371,'Ladana Chaku','136033',1,0,'2022-03-03 13:26:41','2022-03-03 13:26:41'),(113382,371,'Lander Keema','136027',1,0,'2022-03-03 13:26:41','2022-03-03 13:26:41'),(113383,371,'Majra Nand Karan','136027',1,0,'2022-03-03 13:26:41','2022-03-03 13:26:41'),(113384,371,'Manas','136027',1,0,'2022-03-03 13:26:41','2022-03-03 13:26:41'),(113385,371,'Mandi Sadra','136033',1,0,'2022-03-03 13:26:41','2022-03-03 13:26:41'),(113386,371,'Mandwal','136044',1,0,'2022-03-03 13:26:41','2022-03-03 13:26:41'),(113387,371,'Mastgarh','136035',1,0,'2022-03-03 13:26:41','2022-03-03 13:26:41'),(113388,371,'Mataur','136117',1,0,'2022-03-03 13:26:41','2022-03-03 13:26:41'),(113389,371,'Mehmoodpur','136034',1,0,'2022-03-03 13:26:41','2022-03-03 13:26:41'),(113390,371,'Mengran','136034',1,0,'2022-03-03 13:26:41','2022-03-03 13:26:41'),(113391,371,'Mundri','136042',1,0,'2022-03-03 13:26:41','2022-03-03 13:26:41'),(113392,371,'Naina Dhos','136042',1,0,'2022-03-03 13:26:41','2022-03-03 13:26:41'),(113393,371,'Narar','136027',1,0,'2022-03-03 13:26:41','2022-03-03 13:26:41'),(113394,371,'Nauch','136027',1,0,'2022-03-03 13:26:41','2022-03-03 13:26:41'),(113395,371,'Pabnawa','136020',1,0,'2022-03-03 13:26:41','2022-03-03 13:26:41'),(113396,371,'Padla','136027',1,0,'2022-03-03 13:26:41','2022-03-03 13:26:41'),(113397,371,'Pai','136043',1,0,'2022-03-03 13:26:41','2022-03-03 13:26:41'),(113398,371,'Patti Afgan','136027',1,0,'2022-03-03 13:26:42','2022-03-03 13:26:42'),(113399,371,'Peedal','136034',1,0,'2022-03-03 13:26:42','2022-03-03 13:26:42'),(113400,371,'Peoda','136027',1,0,'2022-03-03 13:26:42','2022-03-03 13:26:42'),(113401,371,'Pharal','136021',1,0,'2022-03-03 13:26:42','2022-03-03 13:26:42'),(113402,371,'Pilni','136043',1,0,'2022-03-03 13:26:42','2022-03-03 13:26:42'),(113403,371,'Pundri','136026',1,0,'2022-03-03 13:26:42','2022-03-03 13:26:42'),(113404,371,'Rajound','136044',1,0,'2022-03-03 13:26:42','2022-03-03 13:26:42'),(113405,371,'Ram Garh Pandwa','136117',1,0,'2022-03-03 13:26:42','2022-03-03 13:26:42'),(113406,371,'Rasina','136042',1,0,'2022-03-03 13:26:42','2022-03-03 13:26:42'),(113407,371,'Rohera','136044',1,0,'2022-03-03 13:26:42','2022-03-03 13:26:42'),(113408,371,'Sair','136033',1,0,'2022-03-03 13:26:42','2022-03-03 13:26:42'),(113409,371,'Sajuma','136117',1,0,'2022-03-03 13:26:42','2022-03-03 13:26:42'),(113410,371,'Sakra','136021',1,0,'2022-03-03 13:26:42','2022-03-03 13:26:42'),(113411,371,'Sanghan','136117',1,0,'2022-03-03 13:26:42','2022-03-03 13:26:42'),(113412,371,'Sanghrouli','136021',1,0,'2022-03-03 13:26:42','2022-03-03 13:26:42'),(113413,371,'Santokh Majra','136044',1,0,'2022-03-03 13:26:42','2022-03-03 13:26:42'),(113414,371,'Saunch','136042',1,0,'2022-03-03 13:26:42','2022-03-03 13:26:42'),(113415,371,'Seonmajra','136035',1,0,'2022-03-03 13:26:42','2022-03-03 13:26:42'),(113416,371,'Serhda','136043',1,0,'2022-03-03 13:26:42','2022-03-03 13:26:42'),(113417,371,'Simla','136117',1,0,'2022-03-03 13:26:42','2022-03-03 13:26:42'),(113418,371,'Sirsal','136026',1,0,'2022-03-03 13:26:42','2022-03-03 13:26:42'),(113419,371,'Sirta','136027',1,0,'2022-03-03 13:26:43','2022-03-03 13:26:43'),(113420,371,'Sisla Sismore','136043',1,0,'2022-03-03 13:26:43','2022-03-03 13:26:43'),(113421,371,'Siwan Gate Kaithal','136027',1,0,'2022-03-03 13:26:43','2022-03-03 13:26:43'),(113422,371,'Siwan','136033',1,0,'2022-03-03 13:26:43','2022-03-03 13:26:43'),(113423,371,'Songal','136027',1,0,'2022-03-03 13:26:43','2022-03-03 13:26:43'),(113424,371,'Teek','136027',1,0,'2022-03-03 13:26:43','2022-03-03 13:26:43'),(113425,371,'Teontha','136042',1,0,'2022-03-03 13:26:43','2022-03-03 13:26:43'),(113426,371,'Titram','136027',1,0,'2022-03-03 13:26:43','2022-03-03 13:26:43'),(113427,372,'Achhanpur','132024',1,0,'2022-03-03 13:26:43','2022-03-03 13:26:43'),(113428,372,'Agongh','132024',1,0,'2022-03-03 13:26:43','2022-03-03 13:26:43'),(113429,372,'Aibla','132157',1,0,'2022-03-03 13:26:43','2022-03-03 13:26:43'),(113430,372,'Amupur','132024',1,0,'2022-03-03 13:26:43','2022-03-03 13:26:43'),(113431,372,'Anchala','132040',1,0,'2022-03-03 13:26:43','2022-03-03 13:26:43'),(113432,372,'Ardhana','132039',1,0,'2022-03-03 13:26:43','2022-03-03 13:26:43'),(113433,372,'Arjheri','132117',1,0,'2022-03-03 13:26:43','2022-03-03 13:26:43'),(113434,372,'Assandh','132039',1,0,'2022-03-03 13:26:43','2022-03-03 13:26:43'),(113435,372,'Bahari','132039',1,0,'2022-03-03 13:26:43','2022-03-03 13:26:43'),(113436,372,'Bairsal','132117',1,0,'2022-03-03 13:26:43','2022-03-03 13:26:43'),(113437,372,'Bajida Jattan','132037',1,0,'2022-03-03 13:26:43','2022-03-03 13:26:43'),(113438,372,'Bal Rangan','132040',1,0,'2022-03-03 13:26:43','2022-03-03 13:26:43'),(113439,372,'Ballah','132040',1,0,'2022-03-03 13:26:43','2022-03-03 13:26:43'),(113440,372,'Balu','132024',1,0,'2022-03-03 13:26:43','2022-03-03 13:26:43'),(113441,372,'Bandarala','132039',1,0,'2022-03-03 13:26:43','2022-03-03 13:26:43'),(113442,372,'Bansa','132036',1,0,'2022-03-03 13:26:44','2022-03-03 13:26:44'),(113443,372,'Bara Gaon','132023',1,0,'2022-03-03 13:26:44','2022-03-03 13:26:44'),(113444,372,'Barauta','132037',1,0,'2022-03-03 13:26:44','2022-03-03 13:26:44'),(113445,372,'Barsat','132114',1,0,'2022-03-03 13:26:44','2022-03-03 13:26:44'),(113446,372,'Bastali','132024',1,0,'2022-03-03 13:26:44','2022-03-03 13:26:44'),(113447,372,'Bastara','132114',1,0,'2022-03-03 13:26:44','2022-03-03 13:26:44'),(113448,372,'Beejna','132037',1,0,'2022-03-03 13:26:44','2022-03-03 13:26:44'),(113449,372,'Bhadson','132117',1,0,'2022-03-03 13:26:44','2022-03-03 13:26:44'),(113450,372,'Bhaini Khrud','132116',1,0,'2022-03-03 13:26:44','2022-03-03 13:26:44'),(113451,372,'Biana','132054',1,0,'2022-03-03 13:26:44','2022-03-03 13:26:44'),(113452,372,'Bibi Pur Jattan','132041',1,0,'2022-03-03 13:26:44','2022-03-03 13:26:44'),(113453,372,'Bilona','132039',1,0,'2022-03-03 13:26:44','2022-03-03 13:26:44'),(113454,372,'Brass','132024',1,0,'2022-03-03 13:26:44','2022-03-03 13:26:44'),(113455,372,'Canal Colony','132001',1,0,'2022-03-03 13:26:44','2022-03-03 13:26:44'),(113456,372,'Chaura','132114',1,0,'2022-03-03 13:26:44','2022-03-03 13:26:44'),(113457,372,'Chirao','132036',1,0,'2022-03-03 13:26:44','2022-03-03 13:26:44'),(113458,372,'Chochra','132039',1,0,'2022-03-03 13:26:44','2022-03-03 13:26:44'),(113459,372,'Chogawan','132054',1,0,'2022-03-03 13:26:44','2022-03-03 13:26:44'),(113460,372,'Cssri','132001',1,0,'2022-03-03 13:26:44','2022-03-03 13:26:44'),(113461,372,'Dabkoli Kalan','132054',1,0,'2022-03-03 13:26:44','2022-03-03 13:26:44'),(113462,372,'Dachar','132024',1,0,'2022-03-03 13:26:44','2022-03-03 13:26:44'),(113463,372,'Darar','132041',1,0,'2022-03-03 13:26:45','2022-03-03 13:26:45'),(113464,372,'Dhakwala Gujran','132037',1,0,'2022-03-03 13:26:45','2022-03-03 13:26:45'),(113465,372,'Dilawara','132037',1,0,'2022-03-03 13:26:45','2022-03-03 13:26:45'),(113466,372,'Faridpur','132114',1,0,'2022-03-03 13:26:45','2022-03-03 13:26:45'),(113467,372,'Gagsina','132114',1,0,'2022-03-03 13:26:45','2022-03-03 13:26:45'),(113468,372,'Ganjogarhi','132037',1,0,'2022-03-03 13:26:45','2022-03-03 13:26:45'),(113469,372,'Garhi Birbal','132054',1,0,'2022-03-03 13:26:45','2022-03-03 13:26:45'),(113470,372,'Garhi Jattan','132041',1,0,'2022-03-03 13:26:45','2022-03-03 13:26:45'),(113471,372,'Gharunda','132114',1,0,'2022-03-03 13:26:45','2022-03-03 13:26:45'),(113472,372,'Gheer','132023',1,0,'2022-03-03 13:26:45','2022-03-03 13:26:45'),(113473,372,'Ghogripur','132037',1,0,'2022-03-03 13:26:45','2022-03-03 13:26:45'),(113474,372,'Goli','132046',1,0,'2022-03-03 13:26:45','2022-03-03 13:26:45'),(113475,372,'Gonder','132024',1,0,'2022-03-03 13:26:45','2022-03-03 13:26:45'),(113476,372,'Gudha','132114',1,0,'2022-03-03 13:26:45','2022-03-03 13:26:45'),(113477,372,'Hanori','132041',1,0,'2022-03-03 13:26:45','2022-03-03 13:26:45'),(113478,372,'Hari Singh Pura','132114',1,0,'2022-03-03 13:26:45','2022-03-03 13:26:45'),(113479,372,'Indri','132041',1,0,'2022-03-03 13:26:45','2022-03-03 13:26:45'),(113480,372,'Indri Town','132041',1,0,'2022-03-03 13:26:45','2022-03-03 13:26:45'),(113481,372,'Jai Singh Pura','132039',1,0,'2022-03-03 13:26:45','2022-03-03 13:26:45'),(113482,372,'Jalmana','132039',1,0,'2022-03-03 13:26:46','2022-03-03 13:26:46'),(113483,372,'Jamalpur','132114',1,0,'2022-03-03 13:26:46','2022-03-03 13:26:46'),(113484,372,'Jamba','132157',1,0,'2022-03-03 13:26:46','2022-03-03 13:26:46'),(113485,372,'Jani','132036',1,0,'2022-03-03 13:26:46','2022-03-03 13:26:46'),(113486,372,'Johar Majra','132041',1,0,'2022-03-03 13:26:46','2022-03-03 13:26:46'),(113487,372,'Jundla','132001',1,0,'2022-03-03 13:26:46','2022-03-03 13:26:46'),(113488,372,'Jundla','132036',1,0,'2022-03-03 13:26:46','2022-03-03 13:26:46'),(113489,372,'Kachwa','132116',1,0,'2022-03-03 13:26:46','2022-03-03 13:26:46'),(113490,372,'Kaimla','132114',1,0,'2022-03-03 13:26:46','2022-03-03 13:26:46'),(113491,372,'Kalri Jagir','132054',1,0,'2022-03-03 13:26:46','2022-03-03 13:26:46'),(113492,372,'Kalron','132114',1,0,'2022-03-03 13:26:46','2022-03-03 13:26:46'),(113493,372,'Kalsora','132054',1,0,'2022-03-03 13:26:46','2022-03-03 13:26:46'),(113494,372,'Kanral Industrial Area','132001',1,0,'2022-03-03 13:26:46','2022-03-03 13:26:46'),(113495,372,'Karna Lake','132116',1,0,'2022-03-03 13:26:46','2022-03-03 13:26:46'),(113496,372,'Karnal City','132001',1,0,'2022-03-03 13:26:46','2022-03-03 13:26:46'),(113497,372,'Karnal GBS','132001',1,0,'2022-03-03 13:26:46','2022-03-03 13:26:46'),(113498,372,'Karnal H.O','132001',1,0,'2022-03-03 13:26:46','2022-03-03 13:26:46'),(113499,372,'Karnal HBC','132001',1,0,'2022-03-03 13:26:46','2022-03-03 13:26:46'),(113500,372,'Karnal Kutchery','132001',1,0,'2022-03-03 13:26:46','2022-03-03 13:26:46'),(113501,372,'Karnal Model Town','132001',1,0,'2022-03-03 13:26:46','2022-03-03 13:26:46'),(113502,372,'Karnal NDRI','132001',1,0,'2022-03-03 13:26:46','2022-03-03 13:26:46'),(113503,372,'Karnal New Prem Nagar','132001',1,0,'2022-03-03 13:26:46','2022-03-03 13:26:46'),(113504,372,'Karnal Partap Pura','132001',1,0,'2022-03-03 13:26:47','2022-03-03 13:26:47'),(113505,372,'Karnal Railway Road','132001',1,0,'2022-03-03 13:26:47','2022-03-03 13:26:47'),(113506,372,'Karnal Ram Nagar','132001',1,0,'2022-03-03 13:26:47','2022-03-03 13:26:47'),(113507,372,'Karnal Sadar Bazar','132001',1,0,'2022-03-03 13:26:47','2022-03-03 13:26:47'),(113508,372,'Karnal Sector-6','132001',1,0,'2022-03-03 13:26:47','2022-03-03 13:26:47'),(113509,372,'Karsa Chor','132039',1,0,'2022-03-03 13:26:47','2022-03-03 13:26:47'),(113510,372,'Karsa Dod','132157',1,0,'2022-03-03 13:26:47','2022-03-03 13:26:47'),(113511,372,'Katleri','132036',1,0,'2022-03-03 13:26:47','2022-03-03 13:26:47'),(113512,372,'Khanpur','132041',1,0,'2022-03-03 13:26:47','2022-03-03 13:26:47'),(113513,372,'Khera','132041',1,0,'2022-03-03 13:26:47','2022-03-03 13:26:47'),(113514,372,'Kheri Bhutan','132041',1,0,'2022-03-03 13:26:47','2022-03-03 13:26:47'),(113515,372,'Kheri Man Singh','132041',1,0,'2022-03-03 13:26:47','2022-03-03 13:26:47'),(113516,372,'Kheri Naroo','132036',1,0,'2022-03-03 13:26:47','2022-03-03 13:26:47'),(113517,372,'Kheri Sarf Ali','132039',1,0,'2022-03-03 13:26:47','2022-03-03 13:26:47'),(113518,372,'Khirajpur','132022',1,0,'2022-03-03 13:26:47','2022-03-03 13:26:47'),(113519,372,'Khora-Kheri','132114',1,0,'2022-03-03 13:26:47','2022-03-03 13:26:47'),(113520,372,'Kohand','132114',1,0,'2022-03-03 13:26:47','2022-03-03 13:26:47'),(113521,372,'Kunjpura','132022',1,0,'2022-03-03 13:26:47','2022-03-03 13:26:47'),(113522,372,'Kurlan','132046',1,0,'2022-03-03 13:26:47','2022-03-03 13:26:47'),(113523,372,'Kuruk Jagir','132116',1,0,'2022-03-03 13:26:47','2022-03-03 13:26:47'),(113524,372,'Kutail','132037',1,0,'2022-03-03 13:26:48','2022-03-03 13:26:48'),(113525,372,'Lalupura','132114',1,0,'2022-03-03 13:26:48','2022-03-03 13:26:48'),(113526,372,'Madhuban PTC','132037',1,0,'2022-03-03 13:26:48','2022-03-03 13:26:48'),(113527,372,'Madhuban (Karnal)','132037',1,0,'2022-03-03 13:26:48','2022-03-03 13:26:48'),(113528,372,'Majra Rodan','132157',1,0,'2022-03-03 13:26:48','2022-03-03 13:26:48'),(113529,372,'Manjura','132024',1,0,'2022-03-03 13:26:48','2022-03-03 13:26:48'),(113530,372,'Mardanheri','132039',1,0,'2022-03-03 13:26:48','2022-03-03 13:26:48'),(113531,372,'Mehmal','132024',1,0,'2022-03-03 13:26:48','2022-03-03 13:26:48'),(113532,372,'Mini sectt- sector-12 Kanral','132001',1,0,'2022-03-03 13:26:48','2022-03-03 13:26:48'),(113533,372,'Mohidinpur','132037',1,0,'2022-03-03 13:26:48','2022-03-03 13:26:48'),(113534,372,'Mormajra','132046',1,0,'2022-03-03 13:26:48','2022-03-03 13:26:48'),(113535,372,'Munak','132040',1,0,'2022-03-03 13:26:48','2022-03-03 13:26:48'),(113536,372,'Muradhgarh','132041',1,0,'2022-03-03 13:26:48','2022-03-03 13:26:48'),(113537,372,'Nagla Megha','132037',1,0,'2022-03-03 13:26:48','2022-03-03 13:26:48'),(113538,372,'Nagla Roran','132041',1,0,'2022-03-03 13:26:48','2022-03-03 13:26:48'),(113539,372,'Nalipar','132022',1,0,'2022-03-03 13:26:48','2022-03-03 13:26:48'),(113540,372,'Nangal','132054',1,0,'2022-03-03 13:26:48','2022-03-03 13:26:48'),(113541,372,'Nariana','132116',1,0,'2022-03-03 13:26:48','2022-03-03 13:26:48'),(113542,372,'Nigdhu','132157',1,0,'2022-03-03 13:26:48','2022-03-03 13:26:48'),(113543,372,'Nilokheri GIP','132117',1,0,'2022-03-03 13:26:48','2022-03-03 13:26:48'),(113544,372,'Nilokheri','132117',1,0,'2022-03-03 13:26:49','2022-03-03 13:26:49'),(113545,372,'Nissing','132024',1,0,'2022-03-03 13:26:49','2022-03-03 13:26:49'),(113546,372,'Padha','132036',1,0,'2022-03-03 13:26:49','2022-03-03 13:26:49'),(113547,372,'Padhana','132116',1,0,'2022-03-03 13:26:49','2022-03-03 13:26:49'),(113548,372,'Pathera','132041',1,0,'2022-03-03 13:26:49','2022-03-03 13:26:49'),(113549,372,'Peont','132036',1,0,'2022-03-03 13:26:49','2022-03-03 13:26:49'),(113550,372,'Phaphrana','132046',1,0,'2022-03-03 13:26:49','2022-03-03 13:26:49'),(113551,372,'Phoosgarh','132037',1,0,'2022-03-03 13:26:49','2022-03-03 13:26:49'),(113552,372,'Phurlak','132114',1,0,'2022-03-03 13:26:49','2022-03-03 13:26:49'),(113553,372,'Picholia','132036',1,0,'2022-03-03 13:26:49','2022-03-03 13:26:49'),(113554,372,'Popran','132039',1,0,'2022-03-03 13:26:49','2022-03-03 13:26:49'),(113555,372,'Rahra','132039',1,0,'2022-03-03 13:26:49','2022-03-03 13:26:49'),(113556,372,'Rainpura','132114',1,0,'2022-03-03 13:26:49','2022-03-03 13:26:49'),(113557,372,'Raipur Jattan','132114',1,0,'2022-03-03 13:26:49','2022-03-03 13:26:49'),(113558,372,'Raison','132157',1,0,'2022-03-03 13:26:49','2022-03-03 13:26:49'),(113559,372,'Ramana Ramani','132116',1,0,'2022-03-03 13:26:49','2022-03-03 13:26:49'),(113560,372,'Ramba','132116',1,0,'2022-03-03 13:26:49','2022-03-03 13:26:49'),(113561,372,'Ranwar','132037',1,0,'2022-03-03 13:26:49','2022-03-03 13:26:49'),(113562,372,'S.P. Khalsa','132114',1,0,'2022-03-03 13:26:49','2022-03-03 13:26:49'),(113563,372,'S.P. Sohana','132037',1,0,'2022-03-03 13:26:49','2022-03-03 13:26:49'),(113564,372,'S.S. Kunjpura','132023',1,0,'2022-03-03 13:26:50','2022-03-03 13:26:50'),(113565,372,'Sagga','132116',1,0,'2022-03-03 13:26:50','2022-03-03 13:26:50'),(113566,372,'Salwan','132046',1,0,'2022-03-03 13:26:50','2022-03-03 13:26:50'),(113567,372,'Samana Bahu','132117',1,0,'2022-03-03 13:26:50','2022-03-03 13:26:50'),(113568,372,'Sambhi','132116',1,0,'2022-03-03 13:26:50','2022-03-03 13:26:50'),(113569,372,'Samlbhi','132157',1,0,'2022-03-03 13:26:50','2022-03-03 13:26:50'),(113570,372,'Sandhir','132117',1,0,'2022-03-03 13:26:50','2022-03-03 13:26:50'),(113571,372,'Sanghowa','132041',1,0,'2022-03-03 13:26:50','2022-03-03 13:26:50'),(113572,372,'Sanwat','132157',1,0,'2022-03-03 13:26:50','2022-03-03 13:26:50'),(113573,372,'Saunkra','132116',1,0,'2022-03-03 13:26:50','2022-03-03 13:26:50'),(113574,372,'Sector 4 Karnal','132001',1,0,'2022-03-03 13:26:50','2022-03-03 13:26:50'),(113575,372,'Sector-8 Karnal','132001',1,0,'2022-03-03 13:26:50','2022-03-03 13:26:50'),(113576,372,'Shamgarh','132116',1,0,'2022-03-03 13:26:50','2022-03-03 13:26:50'),(113577,372,'Sheikhpura Manchuri','132036',1,0,'2022-03-03 13:26:50','2022-03-03 13:26:50'),(113578,372,'Sidhpur','132117',1,0,'2022-03-03 13:26:50','2022-03-03 13:26:50'),(113579,372,'Sikri','132117',1,0,'2022-03-03 13:26:50','2022-03-03 13:26:50'),(113580,372,'Singhra','132024',1,0,'2022-03-03 13:26:50','2022-03-03 13:26:50'),(113581,372,'Sirsi','132024',1,0,'2022-03-03 13:26:50','2022-03-03 13:26:50'),(113582,372,'Sitamai','132157',1,0,'2022-03-03 13:26:50','2022-03-03 13:26:50'),(113583,372,'Stanndi','132114',1,0,'2022-03-03 13:26:50','2022-03-03 13:26:50'),(113584,372,'Staundi','132114',1,0,'2022-03-03 13:26:50','2022-03-03 13:26:50'),(113585,372,'Subri','132023',1,0,'2022-03-03 13:26:50','2022-03-03 13:26:50'),(113586,372,'Sultanpur','132116',1,0,'2022-03-03 13:26:51','2022-03-03 13:26:51'),(113587,372,'Taraori','132116',1,0,'2022-03-03 13:26:51','2022-03-03 13:26:51'),(113588,372,'Taroari Mandi','132116',1,0,'2022-03-03 13:26:51','2022-03-03 13:26:51'),(113589,372,'Thal','132039',1,0,'2022-03-03 13:26:51','2022-03-03 13:26:51'),(113590,372,'Thari','132046',1,0,'2022-03-03 13:26:51','2022-03-03 13:26:51'),(113591,372,'Tikri','132023',1,0,'2022-03-03 13:26:51','2022-03-03 13:26:51'),(113592,372,'Uchana','132116',1,0,'2022-03-03 13:26:51','2022-03-03 13:26:51'),(113593,372,'Udana','132117',1,0,'2022-03-03 13:26:51','2022-03-03 13:26:51'),(113594,372,'Uncha Samana','132037',1,0,'2022-03-03 13:26:51','2022-03-03 13:26:51'),(113595,372,'Uplana','132039',1,0,'2022-03-03 13:26:51','2022-03-03 13:26:51'),(113596,373,'Ajrana Kalan','136130',1,0,'2022-03-03 13:26:51','2022-03-03 13:26:51'),(113597,373,'Ajrawar','136136',1,0,'2022-03-03 13:26:51','2022-03-03 13:26:51'),(113598,373,'Amin','136038',1,0,'2022-03-03 13:26:51','2022-03-03 13:26:51'),(113599,373,'Babain','136156',1,0,'2022-03-03 13:26:51','2022-03-03 13:26:51'),(113600,373,'Bagthala','136119',1,0,'2022-03-03 13:26:51','2022-03-03 13:26:51'),(113601,373,'Bakali','136132',1,0,'2022-03-03 13:26:51','2022-03-03 13:26:51'),(113602,373,'Bakhli','136128',1,0,'2022-03-03 13:26:51','2022-03-03 13:26:51'),(113603,373,'Ban','136132',1,0,'2022-03-03 13:26:51','2022-03-03 13:26:51'),(113604,373,'Bapdi','136132',1,0,'2022-03-03 13:26:51','2022-03-03 13:26:51'),(113605,373,'Bargat','136156',1,0,'2022-03-03 13:26:51','2022-03-03 13:26:51'),(113606,373,'Barna','136119',1,0,'2022-03-03 13:26:51','2022-03-03 13:26:51'),(113607,373,'Barout','136132',1,0,'2022-03-03 13:26:51','2022-03-03 13:26:51'),(113608,373,'Barwa','136119',1,0,'2022-03-03 13:26:52','2022-03-03 13:26:52'),(113609,373,'Batheri','136030',1,0,'2022-03-03 13:26:52','2022-03-03 13:26:52'),(113610,373,'Bhagwanpur','136156',1,0,'2022-03-03 13:26:52','2022-03-03 13:26:52'),(113611,373,'Bhor Saida','136119',1,0,'2022-03-03 13:26:52','2022-03-03 13:26:52'),(113612,373,'Bhorakh','136128',1,0,'2022-03-03 13:26:52','2022-03-03 13:26:52'),(113613,373,'Bhusthala','136130',1,0,'2022-03-03 13:26:52','2022-03-03 13:26:52'),(113614,373,'Bir Kalwa','136156',1,0,'2022-03-03 13:26:52','2022-03-03 13:26:52'),(113615,373,'Bir Mathana','136131',1,0,'2022-03-03 13:26:52','2022-03-03 13:26:52'),(113616,373,'Birla Mandir','136118',1,0,'2022-03-03 13:26:52','2022-03-03 13:26:52'),(113617,373,'Bodhni','136128',1,0,'2022-03-03 13:26:52','2022-03-03 13:26:52'),(113618,373,'Bodla','136131',1,0,'2022-03-03 13:26:52','2022-03-03 13:26:52'),(113619,373,'Chaduni Jattan','136135',1,0,'2022-03-03 13:26:52','2022-03-03 13:26:52'),(113620,373,'Chammu Kalan','136129',1,0,'2022-03-03 13:26:52','2022-03-03 13:26:52'),(113621,373,'Dabkheri','136119',1,0,'2022-03-03 13:26:52','2022-03-03 13:26:52'),(113622,373,'Deeg','136135',1,0,'2022-03-03 13:26:52','2022-03-03 13:26:52'),(113623,373,'Dhurala','136119',1,0,'2022-03-03 13:26:52','2022-03-03 13:26:52'),(113624,373,'Diwana','136128',1,0,'2022-03-03 13:26:52','2022-03-03 13:26:52'),(113625,373,'Dudhla','136156',1,0,'2022-03-03 13:26:52','2022-03-03 13:26:52'),(113626,373,'Gajlana','136132',1,0,'2022-03-03 13:26:52','2022-03-03 13:26:52'),(113627,373,'Golpura','136135',1,0,'2022-03-03 13:26:52','2022-03-03 13:26:52'),(113628,373,'Gudha','136132',1,0,'2022-03-03 13:26:53','2022-03-03 13:26:53'),(113629,373,'Gumthala Garhu','136030',1,0,'2022-03-03 13:26:53','2022-03-03 13:26:53'),(113630,373,'Gurukul','136119',1,0,'2022-03-03 13:26:53','2022-03-03 13:26:53'),(113631,373,'Haripur','136135',1,0,'2022-03-03 13:26:53','2022-03-03 13:26:53'),(113632,373,'Hassanpur','136119',1,0,'2022-03-03 13:26:53','2022-03-03 13:26:53'),(113633,373,'Hathira','136119',1,0,'2022-03-03 13:26:53','2022-03-03 13:26:53'),(113634,373,'Ishaq','136128',1,0,'2022-03-03 13:26:53','2022-03-03 13:26:53'),(113635,373,'Ismailabad','136129',1,0,'2022-03-03 13:26:53','2022-03-03 13:26:53'),(113636,373,'Jalbehra','136129',1,0,'2022-03-03 13:26:53','2022-03-03 13:26:53'),(113637,373,'Jandheri','136135',1,0,'2022-03-03 13:26:53','2022-03-03 13:26:53'),(113638,373,'Jandola','136156',1,0,'2022-03-03 13:26:53','2022-03-03 13:26:53'),(113639,373,'Jhansa','136130',1,0,'2022-03-03 13:26:53','2022-03-03 13:26:53'),(113640,373,'Judicial Complex Kurukshetra','136118',1,0,'2022-03-03 13:26:53','2022-03-03 13:26:53'),(113641,373,'Jyotisar','136119',1,0,'2022-03-03 13:26:53','2022-03-03 13:26:53'),(113642,373,'Kakral Gujran','136030',1,0,'2022-03-03 13:26:53','2022-03-03 13:26:53'),(113643,373,'Kalal Majra','136156',1,0,'2022-03-03 13:26:53','2022-03-03 13:26:53'),(113644,373,'Kalirano','136132',1,0,'2022-03-03 13:26:53','2022-03-03 13:26:53'),(113645,373,'Kalsana','136135',1,0,'2022-03-03 13:26:53','2022-03-03 13:26:53'),(113646,373,'Kalyana','136135',1,0,'2022-03-03 13:26:53','2022-03-03 13:26:53'),(113647,373,'Kamoda','136119',1,0,'2022-03-03 13:26:53','2022-03-03 13:26:53'),(113648,373,'Karah','136128',1,0,'2022-03-03 13:26:53','2022-03-03 13:26:53'),(113649,373,'Khanpur Kolian','136131',1,0,'2022-03-03 13:26:53','2022-03-03 13:26:53'),(113650,373,'Kharindwa','136135',1,0,'2022-03-03 13:26:54','2022-03-03 13:26:54'),(113651,373,'Kheri Dabdallan','136132',1,0,'2022-03-03 13:26:54','2022-03-03 13:26:54'),(113652,373,'Kheri Ram Nagar','136119',1,0,'2022-03-03 13:26:54','2022-03-03 13:26:54'),(113653,373,'Kirmuch','136119',1,0,'2022-03-03 13:26:54','2022-03-03 13:26:54'),(113654,373,'Kohlapur','136131',1,0,'2022-03-03 13:26:54','2022-03-03 13:26:54'),(113655,373,'Kurukshetra H.O','136118',1,0,'2022-03-03 13:26:54','2022-03-03 13:26:54'),(113656,373,'Kurukshetra University','136119',1,0,'2022-03-03 13:26:54','2022-03-03 13:26:54'),(113657,373,'Ladwa','136132',1,0,'2022-03-03 13:26:54','2022-03-03 13:26:54'),(113658,373,'Lakhmari','136156',1,0,'2022-03-03 13:26:54','2022-03-03 13:26:54'),(113659,373,'Landi','136135',1,0,'2022-03-03 13:26:54','2022-03-03 13:26:54'),(113660,373,'Lohara','136132',1,0,'2022-03-03 13:26:54','2022-03-03 13:26:54'),(113661,373,'Lukhi','136119',1,0,'2022-03-03 13:26:54','2022-03-03 13:26:54'),(113662,373,'Madanpur','136135',1,0,'2022-03-03 13:26:54','2022-03-03 13:26:54'),(113663,373,'Majri Mohalla Shahabad','136135',1,0,'2022-03-03 13:26:54','2022-03-03 13:26:54'),(113664,373,'Malikpur','136128',1,0,'2022-03-03 13:26:54','2022-03-03 13:26:54'),(113665,373,'Mandheri','136136',1,0,'2022-03-03 13:26:54','2022-03-03 13:26:54'),(113666,373,'Mathana','136131',1,0,'2022-03-03 13:26:54','2022-03-03 13:26:54'),(113667,373,'Mohan Nagar (Kurukshetra)','136118',1,0,'2022-03-03 13:26:54','2022-03-03 13:26:54'),(113668,373,'Murtzapur','136128',1,0,'2022-03-03 13:26:55','2022-03-03 13:26:55'),(113669,373,'Nagla','136135',1,0,'2022-03-03 13:26:55','2022-03-03 13:26:55'),(113670,373,'Naisi','136129',1,0,'2022-03-03 13:26:55','2022-03-03 13:26:55'),(113671,373,'Nalvi','136135',1,0,'2022-03-03 13:26:55','2022-03-03 13:26:55'),(113672,373,'Ngm Ladwa','136132',1,0,'2022-03-03 13:26:55','2022-03-03 13:26:55'),(113673,373,'Niwarsi','136132',1,0,'2022-03-03 13:26:55','2022-03-03 13:26:55'),(113674,373,'Palwal','136131',1,0,'2022-03-03 13:26:55','2022-03-03 13:26:55'),(113675,373,'Pehowa','136128',1,0,'2022-03-03 13:26:55','2022-03-03 13:26:55'),(113676,373,'Pipli','136131',1,0,'2022-03-03 13:26:55','2022-03-03 13:26:55'),(113677,373,'Prahladpur','136132',1,0,'2022-03-03 13:26:55','2022-03-03 13:26:55'),(113678,373,'R.E.C.K.','136119',1,0,'2022-03-03 13:26:55','2022-03-03 13:26:55'),(113679,373,'Ram Saran Majra','136156',1,0,'2022-03-03 13:26:55','2022-03-03 13:26:55'),(113680,373,'Ramgarh Ror','136030',1,0,'2022-03-03 13:26:55','2022-03-03 13:26:55'),(113681,373,'Rattangarh','136135',1,0,'2022-03-03 13:26:55','2022-03-03 13:26:55'),(113682,373,'Rawa','136135',1,0,'2022-03-03 13:26:55','2022-03-03 13:26:55'),(113683,373,'Rohti','136129',1,0,'2022-03-03 13:26:55','2022-03-03 13:26:55'),(113684,373,'Saina Saida','136128',1,0,'2022-03-03 13:26:55','2022-03-03 13:26:55'),(113685,373,'Salarpur','136119',1,0,'2022-03-03 13:26:55','2022-03-03 13:26:55'),(113686,373,'Samalkhi','136135',1,0,'2022-03-03 13:26:55','2022-03-03 13:26:55'),(113687,373,'Sandholi','136128',1,0,'2022-03-03 13:26:55','2022-03-03 13:26:55'),(113688,373,'Sanghor','136156',1,0,'2022-03-03 13:26:56','2022-03-03 13:26:56'),(113689,373,'Saraswati Mandir Pehowa','136128',1,0,'2022-03-03 13:26:56','2022-03-03 13:26:56'),(113690,373,'Sarsa','136128',1,0,'2022-03-03 13:26:56','2022-03-03 13:26:56'),(113691,373,'Sector 3 U E KKR','136118',1,0,'2022-03-03 13:26:56','2022-03-03 13:26:56'),(113692,373,'Seonsar','136030',1,0,'2022-03-03 13:26:56','2022-03-03 13:26:56'),(113693,373,'Shahabad(M)','136135',1,0,'2022-03-03 13:26:56','2022-03-03 13:26:56'),(113694,373,'Shanti Nagar','136136',1,0,'2022-03-03 13:26:56','2022-03-03 13:26:56'),(113695,373,'Sharif Garh','136135',1,0,'2022-03-03 13:26:56','2022-03-03 13:26:56'),(113696,373,'Sirsala','136131',1,0,'2022-03-03 13:26:56','2022-03-03 13:26:56'),(113697,373,'Sudpur','136135',1,0,'2022-03-03 13:26:56','2022-03-03 13:26:56'),(113698,373,'Tangore','136130',1,0,'2022-03-03 13:26:56','2022-03-03 13:26:56'),(113699,373,'Thana','136030',1,0,'2022-03-03 13:26:56','2022-03-03 13:26:56'),(113700,373,'Thanesar Town','136118',1,0,'2022-03-03 13:26:56','2022-03-03 13:26:56'),(113701,373,'Thaska Miranji','136129',1,0,'2022-03-03 13:26:56','2022-03-03 13:26:56'),(113702,373,'Thol','136136',1,0,'2022-03-03 13:26:56','2022-03-03 13:26:56'),(113703,373,'Tigri','136135',1,0,'2022-03-03 13:26:56','2022-03-03 13:26:56'),(113704,373,'Umri','136131',1,0,'2022-03-03 13:26:56','2022-03-03 13:26:56'),(113705,373,'Urnai','136128',1,0,'2022-03-03 13:26:56','2022-03-03 13:26:56'),(113706,373,'Yara','136135',1,0,'2022-03-03 13:26:56','2022-03-03 13:26:56'),(113707,374,'Akbarpur','123023',1,0,'2022-03-03 13:26:56','2022-03-03 13:26:56'),(113708,374,'Akoda','123029',1,0,'2022-03-03 13:26:56','2022-03-03 13:26:56'),(113709,374,'Asalwas','123501',1,0,'2022-03-03 13:26:56','2022-03-03 13:26:56'),(113710,374,'Azamabad Mukhota','123001',1,0,'2022-03-03 13:26:56','2022-03-03 13:26:56'),(113711,374,'Bachhod','123023',1,0,'2022-03-03 13:26:57','2022-03-03 13:26:57'),(113712,374,'Bagahod','123021',1,0,'2022-03-03 13:26:57','2022-03-03 13:26:57'),(113713,374,'Baghot','123027',1,0,'2022-03-03 13:26:57','2022-03-03 13:26:57'),(113714,374,'Bairawas','123028',1,0,'2022-03-03 13:26:57','2022-03-03 13:26:57'),(113715,374,'Barda','123024',1,0,'2022-03-03 13:26:57','2022-03-03 13:26:57'),(113716,374,'Barkoda','123001',1,0,'2022-03-03 13:26:57','2022-03-03 13:26:57'),(113717,374,'Basai','123029',1,0,'2022-03-03 13:26:57','2022-03-03 13:26:57'),(113718,374,'Bashirpur','123001',1,0,'2022-03-03 13:26:57','2022-03-03 13:26:57'),(113719,374,'Bawal','123501',1,0,'2022-03-03 13:26:57','2022-03-03 13:26:57'),(113720,374,'Bawana','123029',1,0,'2022-03-03 13:26:57','2022-03-03 13:26:57'),(113721,374,'Bawania','123034',1,0,'2022-03-03 13:26:57','2022-03-03 13:26:57'),(113722,374,'Bawwa','123303',1,0,'2022-03-03 13:26:57','2022-03-03 13:26:57'),(113723,374,'Bayal','123023',1,0,'2022-03-03 13:26:57','2022-03-03 13:26:57'),(113724,374,'Behali','123021',1,0,'2022-03-03 13:26:57','2022-03-03 13:26:57'),(113725,374,'Beri','123029',1,0,'2022-03-03 13:26:57','2022-03-03 13:26:57'),(113726,374,'Bewal','123021',1,0,'2022-03-03 13:26:57','2022-03-03 13:26:57'),(113727,374,'Bharaf','123027',1,0,'2022-03-03 13:26:57','2022-03-03 13:26:57'),(113728,374,'Bhocharia','123021',1,0,'2022-03-03 13:26:57','2022-03-03 13:26:57'),(113729,374,'Bhucholi','123034',1,0,'2022-03-03 13:26:57','2022-03-03 13:26:57'),(113730,374,'Bhungerka','123023',1,0,'2022-03-03 13:26:57','2022-03-03 13:26:57'),(113731,374,'Bhushan Kalan','123001',1,0,'2022-03-03 13:26:57','2022-03-03 13:26:57'),(113732,374,'Bisowa','123303',1,0,'2022-03-03 13:26:58','2022-03-03 13:26:58'),(113733,374,'Buddin','123029',1,0,'2022-03-03 13:26:58','2022-03-03 13:26:58'),(113734,374,'Budhwal','123023',1,0,'2022-03-03 13:26:58','2022-03-03 13:26:58'),(113735,374,'C R Mgrh','123029',1,0,'2022-03-03 13:26:58','2022-03-03 13:26:58'),(113736,374,'Chillro','123001',1,0,'2022-03-03 13:26:58','2022-03-03 13:26:58'),(113737,374,'Chitrauli','123027',1,0,'2022-03-03 13:26:58','2022-03-03 13:26:58'),(113738,374,'Dahina','123411',1,0,'2022-03-03 13:26:58','2022-03-03 13:26:58'),(113739,374,'Dalanwas','123024',1,0,'2022-03-03 13:26:58','2022-03-03 13:26:58'),(113740,374,'Daroli Ahir','123028',1,0,'2022-03-03 13:26:58','2022-03-03 13:26:58'),(113741,374,'Dhadhot','123029',1,0,'2022-03-03 13:26:58','2022-03-03 13:26:58'),(113742,374,'Dhanaunda','123027',1,0,'2022-03-03 13:26:58','2022-03-03 13:26:58'),(113743,374,'Dhanota','123001',1,0,'2022-03-03 13:26:58','2022-03-03 13:26:58'),(113744,374,'Dharan','123412',1,0,'2022-03-03 13:26:58','2022-03-03 13:26:58'),(113745,374,'Dharson','123001',1,0,'2022-03-03 13:26:58','2022-03-03 13:26:58'),(113746,374,'Dholera','123023',1,0,'2022-03-03 13:26:58','2022-03-03 13:26:58'),(113747,374,'Dhor Kalan','123001',1,0,'2022-03-03 13:26:58','2022-03-03 13:26:58'),(113748,374,'Digrota','123024',1,0,'2022-03-03 13:26:58','2022-03-03 13:26:58'),(113749,374,'Dochana','123001',1,0,'2022-03-03 13:26:58','2022-03-03 13:26:58'),(113750,374,'Dongra Ahir','123021',1,0,'2022-03-03 13:26:58','2022-03-03 13:26:58'),(113751,374,'Dublana','123001',1,0,'2022-03-03 13:26:58','2022-03-03 13:26:58'),(113752,374,'Dulana','123029',1,0,'2022-03-03 13:26:58','2022-03-03 13:26:58'),(113753,374,'Dulat Jat','123021',1,0,'2022-03-03 13:26:58','2022-03-03 13:26:58'),(113754,374,'Dulot Ahir','123029',1,0,'2022-03-03 13:26:59','2022-03-03 13:26:59'),(113755,374,'Ganiar','123021',1,0,'2022-03-03 13:26:59','2022-03-03 13:26:59'),(113756,374,'Garhi','123021',1,0,'2022-03-03 13:26:59','2022-03-03 13:26:59'),(113757,374,'Gokalpur','123021',1,0,'2022-03-03 13:26:59','2022-03-03 13:26:59'),(113758,374,'Golwa','123023',1,0,'2022-03-03 13:26:59','2022-03-03 13:26:59'),(113759,374,'Gujarwas','123021',1,0,'2022-03-03 13:26:59','2022-03-03 13:26:59'),(113760,374,'Gurha','123027',1,0,'2022-03-03 13:26:59','2022-03-03 13:26:59'),(113761,374,'Hamidpur','123001',1,0,'2022-03-03 13:26:59','2022-03-03 13:26:59'),(113762,374,'Hudina','123001',1,0,'2022-03-03 13:26:59','2022-03-03 13:26:59'),(113763,374,'Jarwa','123024',1,0,'2022-03-03 13:26:59','2022-03-03 13:26:59'),(113764,374,'Jharoda','123303',1,0,'2022-03-03 13:26:59','2022-03-03 13:26:59'),(113765,374,'Jholri','123303',1,0,'2022-03-03 13:26:59','2022-03-03 13:26:59'),(113766,374,'Jhook','123029',1,0,'2022-03-03 13:26:59','2022-03-03 13:26:59'),(113767,374,'Kakrola','123027',1,0,'2022-03-03 13:26:59','2022-03-03 13:26:59'),(113768,374,'Kamania','123001',1,0,'2022-03-03 13:26:59','2022-03-03 13:26:59'),(113769,374,'Kanina Mandi','123027',1,0,'2022-03-03 13:26:59','2022-03-03 13:26:59'),(113770,374,'Kanina','123027',1,0,'2022-03-03 13:26:59','2022-03-03 13:26:59'),(113771,374,'Kanti','123021',1,0,'2022-03-03 13:26:59','2022-03-03 13:26:59'),(113772,374,'Kanti Kheri','123021',1,0,'2022-03-03 13:26:59','2022-03-03 13:26:59'),(113773,374,'Kanwi','123001',1,0,'2022-03-03 13:26:59','2022-03-03 13:26:59'),(113774,374,'Karoli','123303',1,0,'2022-03-03 13:27:00','2022-03-03 13:27:00'),(113775,374,'Karota','123001',1,0,'2022-03-03 13:27:00','2022-03-03 13:27:00'),(113776,374,'Khatod','123029',1,0,'2022-03-03 13:27:00','2022-03-03 13:27:00'),(113777,374,'Kheri','123027',1,0,'2022-03-03 13:27:00','2022-03-03 13:27:00'),(113778,374,'Khudana','123029',1,0,'2022-03-03 13:27:00','2022-03-03 13:27:00'),(113779,374,'Kohrar','123303',1,0,'2022-03-03 13:27:00','2022-03-03 13:27:00'),(113780,374,'Koriawas','123001',1,0,'2022-03-03 13:27:00','2022-03-03 13:27:00'),(113781,374,'Kothal Khurd','123028',1,0,'2022-03-03 13:27:00','2022-03-03 13:27:00'),(113782,374,'Kotia','123027',1,0,'2022-03-03 13:27:00','2022-03-03 13:27:00'),(113783,374,'Krishan Nagar','123001',1,0,'2022-03-03 13:27:00','2022-03-03 13:27:00'),(113784,374,'Kultazpur','123001',1,0,'2022-03-03 13:27:00','2022-03-03 13:27:00'),(113785,374,'Kurawata','123029',1,0,'2022-03-03 13:27:00','2022-03-03 13:27:00'),(113786,374,'Lawan','123029',1,0,'2022-03-03 13:27:00','2022-03-03 13:27:00'),(113787,374,'Lilodh','123303',1,0,'2022-03-03 13:27:00','2022-03-03 13:27:00'),(113788,374,'Lookhi','123303',1,0,'2022-03-03 13:27:00','2022-03-03 13:27:00'),(113789,374,'Madhana Kalan','123001',1,0,'2022-03-03 13:27:00','2022-03-03 13:27:00'),(113790,374,'Madhogarh','123024',1,0,'2022-03-03 13:27:00','2022-03-03 13:27:00'),(113791,374,'Mandi','123001',1,0,'2022-03-03 13:27:00','2022-03-03 13:27:00'),(113792,374,'Mandola','123029',1,0,'2022-03-03 13:27:00','2022-03-03 13:27:00'),(113793,374,'Mini Sectt.Narnaul','123001',1,0,'2022-03-03 13:27:00','2022-03-03 13:27:00'),(113794,374,'Mohindergarh','123029',1,0,'2022-03-03 13:27:00','2022-03-03 13:27:00'),(113795,374,'Nagal Nunia','123023',1,0,'2022-03-03 13:27:01','2022-03-03 13:27:01'),(113796,374,'Nangal Chaudhry','123023',1,0,'2022-03-03 13:27:01','2022-03-03 13:27:01'),(113797,374,'Nangal Dargu','123023',1,0,'2022-03-03 13:27:01','2022-03-03 13:27:01'),(113798,374,'Nangal Katha','123001',1,0,'2022-03-03 13:27:01','2022-03-03 13:27:01'),(113799,374,'Nangal Shahbazpur','123501',1,0,'2022-03-03 13:27:01','2022-03-03 13:27:01'),(113800,374,'Nangal Sirohi','123028',1,0,'2022-03-03 13:27:01','2022-03-03 13:27:01'),(113801,374,'Nangalmala','123024',1,0,'2022-03-03 13:27:01','2022-03-03 13:27:01'),(113802,374,'Narnaul City','123001',1,0,'2022-03-03 13:27:01','2022-03-03 13:27:01'),(113803,374,'Narnaul H.O','123001',1,0,'2022-03-03 13:27:01','2022-03-03 13:27:01'),(113804,374,'Narnaul Kty.','123001',1,0,'2022-03-03 13:27:01','2022-03-03 13:27:01'),(113805,374,'Nautana','123027',1,0,'2022-03-03 13:27:01','2022-03-03 13:27:01'),(113806,374,'Nawan','123024',1,0,'2022-03-03 13:27:01','2022-03-03 13:27:01'),(113807,374,'Nayagaon','123303',1,0,'2022-03-03 13:27:01','2022-03-03 13:27:01'),(113808,374,'Neerpur','123001',1,0,'2022-03-03 13:27:01','2022-03-03 13:27:01'),(113809,374,'Nehrugarh','123303',1,0,'2022-03-03 13:27:01','2022-03-03 13:27:01'),(113810,374,'Niamatpur','123023',1,0,'2022-03-03 13:27:01','2022-03-03 13:27:01'),(113811,374,'Nihalawas','123028',1,0,'2022-03-03 13:27:01','2022-03-03 13:27:01'),(113812,374,'Nimbi','123029',1,0,'2022-03-03 13:27:01','2022-03-03 13:27:01'),(113813,374,'Nizampur R.S.','123001',1,0,'2022-03-03 13:27:01','2022-03-03 13:27:01'),(113814,374,'Pali','123029',1,0,'2022-03-03 13:27:01','2022-03-03 13:27:01'),(113815,374,'Palri Panihara','123029',1,0,'2022-03-03 13:27:01','2022-03-03 13:27:01'),(113816,374,'Patherwa','123024',1,0,'2022-03-03 13:27:01','2022-03-03 13:27:01'),(113817,374,'Pota','123027',1,0,'2022-03-03 13:27:01','2022-03-03 13:27:01'),(113818,374,'Rambas','123027',1,0,'2022-03-03 13:27:02','2022-03-03 13:27:02'),(113819,374,'Rasoolpur','123027',1,0,'2022-03-03 13:27:02','2022-03-03 13:27:02'),(113820,374,'Rattan Kalan','123021',1,0,'2022-03-03 13:27:02','2022-03-03 13:27:02'),(113821,374,'Sarai Bahadur','123021',1,0,'2022-03-03 13:27:02','2022-03-03 13:27:02'),(113822,374,'Sareli','123023',1,0,'2022-03-03 13:27:02','2022-03-03 13:27:02'),(113823,374,'Satnali','123024',1,0,'2022-03-03 13:27:02','2022-03-03 13:27:02'),(113824,374,'Sehlong','123027',1,0,'2022-03-03 13:27:02','2022-03-03 13:27:02'),(113825,374,'Sehma','123028',1,0,'2022-03-03 13:27:02','2022-03-03 13:27:02'),(113826,374,'Shyampura','123024',1,0,'2022-03-03 13:27:02','2022-03-03 13:27:02'),(113827,374,'Siana','123027',1,0,'2022-03-03 13:27:02','2022-03-03 13:27:02'),(113828,374,'Sihore','123027',1,0,'2022-03-03 13:27:02','2022-03-03 13:27:02'),(113829,374,'Sirohi Behali','123023',1,0,'2022-03-03 13:27:02','2022-03-03 13:27:02'),(113830,374,'Sureti Kalan','123024',1,0,'2022-03-03 13:27:02','2022-03-03 13:27:02'),(113831,374,'Tajpur','123021',1,0,'2022-03-03 13:27:02','2022-03-03 13:27:02'),(113832,374,'Thanwas','123023',1,0,'2022-03-03 13:27:02','2022-03-03 13:27:02'),(113833,375,'B.C.W. Suraj Pur','133301',1,0,'2022-03-03 13:27:02','2022-03-03 13:27:02'),(113834,375,'Banaundi','134202',1,0,'2022-03-03 13:27:02','2022-03-03 13:27:02'),(113835,375,'Barwala (Panchkula)','134118',1,0,'2022-03-03 13:27:02','2022-03-03 13:27:02'),(113836,375,'Basolan','134102',1,0,'2022-03-03 13:27:02','2022-03-03 13:27:02'),(113837,375,'Bhadauli','134203',1,0,'2022-03-03 13:27:03','2022-03-03 13:27:03'),(113838,375,'Bhojkoti','134205',1,0,'2022-03-03 13:27:03','2022-03-03 13:27:03'),(113839,375,'Billa','134118',1,0,'2022-03-03 13:27:03','2022-03-03 13:27:03'),(113840,375,'C.R.P.F. Pinjore','134104',1,0,'2022-03-03 13:27:03','2022-03-03 13:27:03'),(113841,375,'Chandi Mandir Cantt','134107',1,0,'2022-03-03 13:27:03','2022-03-03 13:27:03'),(113842,375,'Chandi Mandir','134107',1,0,'2022-03-03 13:27:03','2022-03-03 13:27:03'),(113843,375,'Chiken','134102',1,0,'2022-03-03 13:27:03','2022-03-03 13:27:03'),(113844,375,'Damaloan','134102',1,0,'2022-03-03 13:27:03','2022-03-03 13:27:03'),(113845,375,'Devi Nagar','134109',1,0,'2022-03-03 13:27:03','2022-03-03 13:27:03'),(113846,375,'G.K. Panchkula','134108',1,0,'2022-03-03 13:27:03','2022-03-03 13:27:03'),(113847,375,'Garhi Kotaha','134204',1,0,'2022-03-03 13:27:03','2022-03-03 13:27:03'),(113848,375,'H.M.T.Pinjore','134101',1,0,'2022-03-03 13:27:03','2022-03-03 13:27:03'),(113849,375,'I.T.B.P.  Bhanu','134103',1,0,'2022-03-03 13:27:03','2022-03-03 13:27:03'),(113850,375,'Industrial Estate  Panchkula','134113',1,0,'2022-03-03 13:27:03','2022-03-03 13:27:03'),(113851,375,'Jaloli','134118',1,0,'2022-03-03 13:27:03','2022-03-03 13:27:03'),(113852,375,'Kalka R.S.','133302',1,0,'2022-03-03 13:27:03','2022-03-03 13:27:03'),(113853,375,'Kalka','133302',1,0,'2022-03-03 13:27:03','2022-03-03 13:27:03'),(113854,375,'Kharanwali','133302',1,0,'2022-03-03 13:27:03','2022-03-03 13:27:03'),(113855,375,'Khetpurali','134204',1,0,'2022-03-03 13:27:03','2022-03-03 13:27:03'),(113856,375,'Mallah','134102',1,0,'2022-03-03 13:27:04','2022-03-03 13:27:04'),(113857,375,'Mandhana','134205',1,0,'2022-03-03 13:27:04','2022-03-03 13:27:04'),(113858,375,'Mansa  Devi Sec-5','134114',1,0,'2022-03-03 13:27:04','2022-03-03 13:27:04'),(113859,375,'Mauli','134118',1,0,'2022-03-03 13:27:04','2022-03-03 13:27:04'),(113860,375,'Morni','134205',1,0,'2022-03-03 13:27:04','2022-03-03 13:27:04'),(113861,375,'Nanakpur','134102',1,0,'2022-03-03 13:27:04','2022-03-03 13:27:04'),(113862,375,'Panchkula Sector 12','134112',1,0,'2022-03-03 13:27:04','2022-03-03 13:27:04'),(113863,375,'Panchkula Sector 4','134112',1,0,'2022-03-03 13:27:04','2022-03-03 13:27:04'),(113864,375,'Panchkula Sector 8','134109',1,0,'2022-03-03 13:27:04','2022-03-03 13:27:04'),(113865,375,'Pinjore','134102',1,0,'2022-03-03 13:27:04','2022-03-03 13:27:04'),(113866,375,'Railly','134109',1,0,'2022-03-03 13:27:04','2022-03-03 13:27:04'),(113867,375,'Raipur Rani','134204',1,0,'2022-03-03 13:27:04','2022-03-03 13:27:04'),(113868,375,'Raiwali','134118',1,0,'2022-03-03 13:27:04','2022-03-03 13:27:04'),(113869,375,'Ramgarh','134118',1,0,'2022-03-03 13:27:04','2022-03-03 13:27:04'),(113870,375,'Rattewali','134118',1,0,'2022-03-03 13:27:04','2022-03-03 13:27:04'),(113871,375,'Sector 15 Panchkula','134113',1,0,'2022-03-03 13:27:04','2022-03-03 13:27:04'),(113872,375,'Sector 20 Panchkula','134117',1,0,'2022-03-03 13:27:04','2022-03-03 13:27:04'),(113873,375,'Sector-26 Panchkula','134116',1,0,'2022-03-03 13:27:04','2022-03-03 13:27:04'),(113874,375,'Suketri','134109',1,0,'2022-03-03 13:27:05','2022-03-03 13:27:05'),(113875,375,'Thendog','134205',1,0,'2022-03-03 13:27:05','2022-03-03 13:27:05'),(113876,375,'Tikkar','134205',1,0,'2022-03-03 13:27:05','2022-03-03 13:27:05'),(113877,376,'Adyana','132113',1,0,'2022-03-03 13:27:05','2022-03-03 13:27:05'),(113878,376,'Ahar','132107',1,0,'2022-03-03 13:27:05','2022-03-03 13:27:05'),(113879,376,'Allupur','132113',1,0,'2022-03-03 13:27:05','2022-03-03 13:27:05'),(113880,376,'Ansal Sushant City Panipat','132103',1,0,'2022-03-03 13:27:05','2022-03-03 13:27:05'),(113881,376,'Assan Kalan','132105',1,0,'2022-03-03 13:27:05','2022-03-03 13:27:05'),(113882,376,'Atta','132122',1,0,'2022-03-03 13:27:05','2022-03-03 13:27:05'),(113883,376,'Atula','132113',1,0,'2022-03-03 13:27:05','2022-03-03 13:27:05'),(113884,376,'Babail','132104',1,0,'2022-03-03 13:27:05','2022-03-03 13:27:05'),(113885,376,'Babarpur','132140',1,0,'2022-03-03 13:27:05','2022-03-03 13:27:05'),(113886,376,'Bandh','132107',1,0,'2022-03-03 13:27:05','2022-03-03 13:27:05'),(113887,376,'Bapoli','132104',1,0,'2022-03-03 13:27:05','2022-03-03 13:27:05'),(113888,376,'Barana','132104',1,0,'2022-03-03 13:27:05','2022-03-03 13:27:05'),(113889,376,'Beholi','132101',1,0,'2022-03-03 13:27:05','2022-03-03 13:27:05'),(113890,376,'Bhadar','132105',1,0,'2022-03-03 13:27:05','2022-03-03 13:27:05'),(113891,376,'Bhandari','132113',1,0,'2022-03-03 13:27:05','2022-03-03 13:27:05'),(113892,376,'Bhodwal Majri','132102',1,0,'2022-03-03 13:27:05','2022-03-03 13:27:05'),(113893,376,'Binjhol','132106',1,0,'2022-03-03 13:27:06','2022-03-03 13:27:06'),(113894,376,'Buana Lakhu','132107',1,0,'2022-03-03 13:27:06','2022-03-03 13:27:06'),(113895,376,'Bursham','132106',1,0,'2022-03-03 13:27:06','2022-03-03 13:27:06'),(113896,376,'Chandoli','132104',1,0,'2022-03-03 13:27:06','2022-03-03 13:27:06'),(113897,376,'Chhajpur Kalan','132104',1,0,'2022-03-03 13:27:06','2022-03-03 13:27:06'),(113898,376,'Chulkana','132101',1,0,'2022-03-03 13:27:06','2022-03-03 13:27:06'),(113899,376,'Dadlana','132140',1,0,'2022-03-03 13:27:06','2022-03-03 13:27:06'),(113900,376,'Dadola','132108',1,0,'2022-03-03 13:27:06','2022-03-03 13:27:06'),(113901,376,'Dahar','132145',1,0,'2022-03-03 13:27:06','2022-03-03 13:27:06'),(113902,376,'Dehra','132122',1,0,'2022-03-03 13:27:06','2022-03-03 13:27:06'),(113903,376,'Didwari','132145',1,0,'2022-03-03 13:27:06','2022-03-03 13:27:06'),(113904,376,'Dikadla','132122',1,0,'2022-03-03 13:27:06','2022-03-03 13:27:06'),(113905,376,'Diwana','132108',1,0,'2022-03-03 13:27:06','2022-03-03 13:27:06'),(113906,376,'Gandhi Samarak Nidhi','132102',1,0,'2022-03-03 13:27:06','2022-03-03 13:27:06'),(113907,376,'Ganjbarh','132140',1,0,'2022-03-03 13:27:06','2022-03-03 13:27:06'),(113908,376,'Garhi Basic','132104',1,0,'2022-03-03 13:27:06','2022-03-03 13:27:06'),(113909,376,'Goela Kalan','132104',1,0,'2022-03-03 13:27:06','2022-03-03 13:27:06'),(113910,376,'Hathwala','132115',1,0,'2022-03-03 13:27:06','2022-03-03 13:27:06'),(113911,376,'Israna','132107',1,0,'2022-03-03 13:27:06','2022-03-03 13:27:06'),(113912,376,'Jalalpur','132104',1,0,'2022-03-03 13:27:06','2022-03-03 13:27:06'),(113913,376,'Jattal','132105',1,0,'2022-03-03 13:27:06','2022-03-03 13:27:06'),(113914,376,'Jaurasi','132101',1,0,'2022-03-03 13:27:06','2022-03-03 13:27:06'),(113915,376,'Jondhan Kalan','132107',1,0,'2022-03-03 13:27:06','2022-03-03 13:27:06'),(113916,376,'Joshi','132113',1,0,'2022-03-03 13:27:06','2022-03-03 13:27:06'),(113917,376,'Kabri','132140',1,0,'2022-03-03 13:27:07','2022-03-03 13:27:07'),(113918,376,'Kalkha','132105',1,0,'2022-03-03 13:27:07','2022-03-03 13:27:07'),(113919,376,'Karad','132107',1,0,'2022-03-03 13:27:07','2022-03-03 13:27:07'),(113920,376,'Karhans','132101',1,0,'2022-03-03 13:27:07','2022-03-03 13:27:07'),(113921,376,'Khojkipur','132122',1,0,'2022-03-03 13:27:07','2022-03-03 13:27:07'),(113922,376,'Kiwana','132101',1,0,'2022-03-03 13:27:07','2022-03-03 13:27:07'),(113923,376,'Kurana','132107',1,0,'2022-03-03 13:27:07','2022-03-03 13:27:07'),(113924,376,'Kurar','132104',1,0,'2022-03-03 13:27:07','2022-03-03 13:27:07'),(113925,376,'Lohari','132105',1,0,'2022-03-03 13:27:07','2022-03-03 13:27:07'),(113926,376,'Machhrauli','132101',1,0,'2022-03-03 13:27:07','2022-03-03 13:27:07'),(113927,376,'Madlauda','132113',1,0,'2022-03-03 13:27:07','2022-03-03 13:27:07'),(113928,376,'Mahoti','132102',1,0,'2022-03-03 13:27:07','2022-03-03 13:27:07'),(113929,376,'Manana','132101',1,0,'2022-03-03 13:27:07','2022-03-03 13:27:07'),(113930,376,'Mandi','132107',1,0,'2022-03-03 13:27:07','2022-03-03 13:27:07'),(113931,376,'Namunda','132101',1,0,'2022-03-03 13:27:07','2022-03-03 13:27:07'),(113932,376,'Nanhera','132104',1,0,'2022-03-03 13:27:07','2022-03-03 13:27:07'),(113933,376,'Nara','132113',1,0,'2022-03-03 13:27:07','2022-03-03 13:27:07'),(113934,376,'Naraina','132101',1,0,'2022-03-03 13:27:07','2022-03-03 13:27:07'),(113935,376,'Neoltha','132145',1,0,'2022-03-03 13:27:07','2022-03-03 13:27:07'),(113936,376,'Noorwala','132104',1,0,'2022-03-03 13:27:07','2022-03-03 13:27:07'),(113937,376,'Palri','132145',1,0,'2022-03-03 13:27:07','2022-03-03 13:27:07'),(113938,376,'Panipat Beas Project','132108',1,0,'2022-03-03 13:27:08','2022-03-03 13:27:08'),(113939,376,'Panipat City','132103',1,0,'2022-03-03 13:27:08','2022-03-03 13:27:08'),(113940,376,'Panipat GT Road','132103',1,0,'2022-03-03 13:27:08','2022-03-03 13:27:08'),(113941,376,'Panipat H.O','132103',1,0,'2022-03-03 13:27:08','2022-03-03 13:27:08'),(113942,376,'Panipat Khadi Ashram','132104',1,0,'2022-03-03 13:27:08','2022-03-03 13:27:08'),(113943,376,'Panipat Kishanpura','132103',1,0,'2022-03-03 13:27:08','2022-03-03 13:27:08'),(113944,376,'Panipat Kranti Nagar','132103',1,0,'2022-03-03 13:27:08','2022-03-03 13:27:08'),(113945,376,'Panipat Mandi','132103',1,0,'2022-03-03 13:27:08','2022-03-03 13:27:08'),(113946,376,'Panipat Model Town','132103',1,0,'2022-03-03 13:27:08','2022-03-03 13:27:08'),(113947,376,'Panipat N.S.M.','132103',1,0,'2022-03-03 13:27:08','2022-03-03 13:27:08'),(113948,376,'Panipat NFL','132106',1,0,'2022-03-03 13:27:08','2022-03-03 13:27:08'),(113949,376,'Panipat Patel Nagar','132103',1,0,'2022-03-03 13:27:08','2022-03-03 13:27:08'),(113950,376,'Panipat Refinary','132140',1,0,'2022-03-03 13:27:08','2022-03-03 13:27:08'),(113951,376,'Panipat Sugar Mills','132103',1,0,'2022-03-03 13:27:08','2022-03-03 13:27:08'),(113952,376,'Panipat Thermal Project','132105',1,0,'2022-03-03 13:27:08','2022-03-03 13:27:08'),(113953,376,'Pardhana','132107',1,0,'2022-03-03 13:27:08','2022-03-03 13:27:08'),(113954,376,'Pasina Kalan BO','132108',1,0,'2022-03-03 13:27:08','2022-03-03 13:27:08'),(113955,376,'Patti Kalyana','132102',1,0,'2022-03-03 13:27:08','2022-03-03 13:27:08'),(113956,376,'PPT Camp No. 2','132104',1,0,'2022-03-03 13:27:08','2022-03-03 13:27:08'),(113957,376,'PPT Kathery (U)','132104',1,0,'2022-03-03 13:27:08','2022-03-03 13:27:08'),(113958,376,'Puther','132107',1,0,'2022-03-03 13:27:09','2022-03-03 13:27:09'),(113959,376,'Qawi','132113',1,0,'2022-03-03 13:27:09','2022-03-03 13:27:09'),(113960,376,'Rair Kalan','132140',1,0,'2022-03-03 13:27:09','2022-03-03 13:27:09'),(113961,376,'Rajkheri','132104',1,0,'2022-03-03 13:27:09','2022-03-03 13:27:09'),(113962,376,'Raksera','132115',1,0,'2022-03-03 13:27:09','2022-03-03 13:27:09'),(113963,376,'Risalu','132104',1,0,'2022-03-03 13:27:09','2022-03-03 13:27:09'),(113964,376,'Samalkha','132101',1,0,'2022-03-03 13:27:09','2022-03-03 13:27:09'),(113965,376,'Sanauli Khurd','132104',1,0,'2022-03-03 13:27:09','2022-03-03 13:27:09'),(113966,376,'Seenk','132107',1,0,'2022-03-03 13:27:09','2022-03-03 13:27:09'),(113967,376,'Shahpur','132107',1,0,'2022-03-03 13:27:09','2022-03-03 13:27:09'),(113968,376,'Shera','132113',1,0,'2022-03-03 13:27:09','2022-03-03 13:27:09'),(113969,376,'Siwaha','132108',1,0,'2022-03-03 13:27:09','2022-03-03 13:27:09'),(113970,376,'Sodhapur','132105',1,0,'2022-03-03 13:27:09','2022-03-03 13:27:09'),(113971,376,'Sutana','132105',1,0,'2022-03-03 13:27:09','2022-03-03 13:27:09'),(113972,376,'Ugra Kheri','132104',1,0,'2022-03-03 13:27:09','2022-03-03 13:27:09'),(113973,376,'Untla','132105',1,0,'2022-03-03 13:27:09','2022-03-03 13:27:09'),(113974,376,'Urlana Kalan','132107',1,0,'2022-03-03 13:27:09','2022-03-03 13:27:09'),(113975,376,'Waisor','132113',1,0,'2022-03-03 13:27:09','2022-03-03 13:27:09'),(113976,377,'Ahrod','123102',1,0,'2022-03-03 13:27:09','2022-03-03 13:27:09'),(113977,377,'Asiaki Gorawas','123035',1,0,'2022-03-03 13:27:09','2022-03-03 13:27:09'),(113978,377,'B B Ashram','123401',1,0,'2022-03-03 13:27:09','2022-03-03 13:27:09'),(113979,377,'Bachhod','123021',1,0,'2022-03-03 13:27:09','2022-03-03 13:27:09'),(113980,377,'Badhrana','123412',1,0,'2022-03-03 13:27:10','2022-03-03 13:27:10'),(113981,377,'Baghthala','123501',1,0,'2022-03-03 13:27:10','2022-03-03 13:27:10'),(113982,377,'Baldhan Kalan','123411',1,0,'2022-03-03 13:27:10','2022-03-03 13:27:10'),(113983,377,'Balwari','123103',1,0,'2022-03-03 13:27:10','2022-03-03 13:27:10'),(113984,377,'Banipur','123501',1,0,'2022-03-03 13:27:10','2022-03-03 13:27:10'),(113985,377,'Basbatori','123101',1,0,'2022-03-03 13:27:10','2022-03-03 13:27:10'),(113986,377,'Basduda','123102',1,0,'2022-03-03 13:27:10','2022-03-03 13:27:10'),(113987,377,'Bhakli','123302',1,0,'2022-03-03 13:27:10','2022-03-03 13:27:10'),(113988,377,'Bhatsana','123106',1,0,'2022-03-03 13:27:10','2022-03-03 13:27:10'),(113989,377,'Bhojawas','123034',1,0,'2022-03-03 13:27:10','2022-03-03 13:27:10'),(113990,377,'Bhotwas Ahir','123101',1,0,'2022-03-03 13:27:10','2022-03-03 13:27:10'),(113991,377,'Bikaner','123401',1,0,'2022-03-03 13:27:10','2022-03-03 13:27:10'),(113992,377,'Bithwana','123401',1,0,'2022-03-03 13:27:10','2022-03-03 13:27:10'),(113993,377,'Bocharia','123021',1,0,'2022-03-03 13:27:10','2022-03-03 13:27:10'),(113994,377,'Boria Kamalpur','123401',1,0,'2022-03-03 13:27:10','2022-03-03 13:27:10'),(113995,377,'Budhpur','123401',1,0,'2022-03-03 13:27:10','2022-03-03 13:27:10'),(113996,377,'Buroli','123411',1,0,'2022-03-03 13:27:10','2022-03-03 13:27:10'),(113997,377,'Burthala','123302',1,0,'2022-03-03 13:27:10','2022-03-03 13:27:10'),(113998,377,'Chita Dungra','123102',1,0,'2022-03-03 13:27:10','2022-03-03 13:27:10'),(113999,377,'Dakhora','123411',1,0,'2022-03-03 13:27:10','2022-03-03 13:27:10'),(114000,377,'Daroli','123411',1,0,'2022-03-03 13:27:11','2022-03-03 13:27:11'),(114001,377,'Dehlawas Gulabpur','123401',1,0,'2022-03-03 13:27:11','2022-03-03 13:27:11'),(114002,377,'Dewas','123034',1,0,'2022-03-03 13:27:11','2022-03-03 13:27:11'),(114003,377,'Dhana','123034',1,0,'2022-03-03 13:27:11','2022-03-03 13:27:11'),(114004,377,'Dharuhera','123106',1,0,'2022-03-03 13:27:11','2022-03-03 13:27:11'),(114005,377,'Dhawana','123103',1,0,'2022-03-03 13:27:11','2022-03-03 13:27:11'),(114006,377,'Dunderwas','123106',1,0,'2022-03-03 13:27:11','2022-03-03 13:27:11'),(114007,377,'Garhi Bolni','123401',1,0,'2022-03-03 13:27:11','2022-03-03 13:27:11'),(114008,377,'Gokal Bazar Rewari','123401',1,0,'2022-03-03 13:27:11','2022-03-03 13:27:11'),(114009,377,'Gokalgarh','123401',1,0,'2022-03-03 13:27:11','2022-03-03 13:27:11'),(114010,377,'Gothra','123102',1,0,'2022-03-03 13:27:11','2022-03-03 13:27:11'),(114011,377,'Gothra','123411',1,0,'2022-03-03 13:27:11','2022-03-03 13:27:11'),(114012,377,'Gugodh','123302',1,0,'2022-03-03 13:27:11','2022-03-03 13:27:11'),(114013,377,'Gujar Majra','123501',1,0,'2022-03-03 13:27:11','2022-03-03 13:27:11'),(114014,377,'Guraora','123035',1,0,'2022-03-03 13:27:11','2022-03-03 13:27:11'),(114015,377,'Guriani','123301',1,0,'2022-03-03 13:27:11','2022-03-03 13:27:11'),(114016,377,'Industrial Area Dharuhera','123110',1,0,'2022-03-03 13:27:11','2022-03-03 13:27:11'),(114017,377,'Jaisinghpur Khera','123501',1,0,'2022-03-03 13:27:11','2022-03-03 13:27:11'),(114018,377,'Jakhala','123301',1,0,'2022-03-03 13:27:11','2022-03-03 13:27:11'),(114019,377,'Jatusa R.S.','123401',1,0,'2022-03-03 13:27:11','2022-03-03 13:27:11'),(114020,377,'Jhabuwa','123501',1,0,'2022-03-03 13:27:11','2022-03-03 13:27:11'),(114021,377,'Jhagroli','123034',1,0,'2022-03-03 13:27:12','2022-03-03 13:27:12'),(114022,377,'Jhal','123302',1,0,'2022-03-03 13:27:12','2022-03-03 13:27:12'),(114023,377,'Juddi','123302',1,0,'2022-03-03 13:27:12','2022-03-03 13:27:12'),(114024,377,'Kannaura','123035',1,0,'2022-03-03 13:27:12','2022-03-03 13:27:12'),(114025,377,'Kanwali','123411',1,0,'2022-03-03 13:27:12','2022-03-03 13:27:12'),(114026,377,'Karawara','123035',1,0,'2022-03-03 13:27:12','2022-03-03 13:27:12'),(114027,377,'Karnawas','123302',1,0,'2022-03-03 13:27:12','2022-03-03 13:27:12'),(114028,377,'Karnawas','123401',1,0,'2022-03-03 13:27:12','2022-03-03 13:27:12'),(114029,377,'Khaleta','123103',1,0,'2022-03-03 13:27:12','2022-03-03 13:27:12'),(114030,377,'Khandora','123401',1,0,'2022-03-03 13:27:12','2022-03-03 13:27:12'),(114031,377,'Kharkhara','123106',1,0,'2022-03-03 13:27:12','2022-03-03 13:27:12'),(114032,377,'Khol','123103',1,0,'2022-03-03 13:27:12','2022-03-03 13:27:12'),(114033,377,'Khori','123101',1,0,'2022-03-03 13:27:12','2022-03-03 13:27:12'),(114034,377,'Kolana','123102',1,0,'2022-03-03 13:27:12','2022-03-03 13:27:12'),(114035,377,'Kosli R S','123302',1,0,'2022-03-03 13:27:12','2022-03-03 13:27:12'),(114036,377,'Kosli','123302',1,0,'2022-03-03 13:27:12','2022-03-03 13:27:12'),(114037,377,'Kund','123102',1,0,'2022-03-03 13:27:12','2022-03-03 13:27:12'),(114038,377,'Lisan','123411',1,0,'2022-03-03 13:27:12','2022-03-03 13:27:12'),(114039,377,'Lula Ahir','123302',1,0,'2022-03-03 13:27:12','2022-03-03 13:27:12'),(114040,377,'Maheshwari','123106',1,0,'2022-03-03 13:27:12','2022-03-03 13:27:12'),(114041,377,'Majra Gurdas','123401',1,0,'2022-03-03 13:27:13','2022-03-03 13:27:13'),(114042,377,'Majra Sheoraj','123401',1,0,'2022-03-03 13:27:13','2022-03-03 13:27:13'),(114043,377,'Mamaria Ahir','123101',1,0,'2022-03-03 13:27:13','2022-03-03 13:27:13'),(114044,377,'Mandi Ateli','123021',1,0,'2022-03-03 13:27:13','2022-03-03 13:27:13'),(114045,377,'Mandola','123103',1,0,'2022-03-03 13:27:13','2022-03-03 13:27:13'),(114046,377,'Masani','123106',1,0,'2022-03-03 13:27:13','2022-03-03 13:27:13'),(114047,377,'Mastapur','123401',1,0,'2022-03-03 13:27:13','2022-03-03 13:27:13'),(114048,377,'Mayan','123103',1,0,'2022-03-03 13:27:13','2022-03-03 13:27:13'),(114049,377,'Model Town  Rewari','123401',1,0,'2022-03-03 13:27:13','2022-03-03 13:27:13'),(114050,377,'Mohanpur','123401',1,0,'2022-03-03 13:27:13','2022-03-03 13:27:13'),(114051,377,'Motla Kalan','123411',1,0,'2022-03-03 13:27:13','2022-03-03 13:27:13'),(114052,377,'Mundi','123411',1,0,'2022-03-03 13:27:13','2022-03-03 13:27:13'),(114053,377,'Musepur','123401',1,0,'2022-03-03 13:27:13','2022-03-03 13:27:13'),(114054,377,'Nahar','123303',1,0,'2022-03-03 13:27:13','2022-03-03 13:27:13'),(114055,377,'Naichana','123501',1,0,'2022-03-03 13:27:13','2022-03-03 13:27:13'),(114056,377,'Nand Rampurbass','123106',1,0,'2022-03-03 13:27:13','2022-03-03 13:27:13'),(114057,377,'Nangal','123501',1,0,'2022-03-03 13:27:13','2022-03-03 13:27:13'),(114058,377,'Nangal Jamalpur','123102',1,0,'2022-03-03 13:27:13','2022-03-03 13:27:13'),(114059,377,'Nangal Pathani','123401',1,0,'2022-03-03 13:27:13','2022-03-03 13:27:13'),(114060,377,'Nangal Teju','123501',1,0,'2022-03-03 13:27:13','2022-03-03 13:27:13'),(114061,377,'Nangli Godha','123401',1,0,'2022-03-03 13:27:14','2022-03-03 13:27:14'),(114062,377,'New Anaz Mandi Rewari','123401',1,0,'2022-03-03 13:27:14','2022-03-03 13:27:14'),(114063,377,'Nimoth','123411',1,0,'2022-03-03 13:27:14','2022-03-03 13:27:14'),(114064,377,'Palhawas','123035',1,0,'2022-03-03 13:27:14','2022-03-03 13:27:14'),(114065,377,'Pali','123102',1,0,'2022-03-03 13:27:14','2022-03-03 13:27:14'),(114066,377,'Pathera','123034',1,0,'2022-03-03 13:27:14','2022-03-03 13:27:14'),(114067,377,'Pithrawas','123101',1,0,'2022-03-03 13:27:14','2022-03-03 13:27:14'),(114068,377,'Pranpura','123501',1,0,'2022-03-03 13:27:14','2022-03-03 13:27:14'),(114069,377,'Punsika','123101',1,0,'2022-03-03 13:27:14','2022-03-03 13:27:14'),(114070,377,'Rajgarh','123412',1,0,'2022-03-03 13:27:14','2022-03-03 13:27:14'),(114071,377,'Raliawas','123106',1,0,'2022-03-03 13:27:14','2022-03-03 13:27:14'),(114072,377,'Rampuri','123411',1,0,'2022-03-03 13:27:14','2022-03-03 13:27:14'),(114073,377,'Rattanthal','123301',1,0,'2022-03-03 13:27:14','2022-03-03 13:27:14'),(114074,377,'Rewari','123401',1,0,'2022-03-03 13:27:14','2022-03-03 13:27:14'),(114075,377,'Rohrai','123401',1,0,'2022-03-03 13:27:14','2022-03-03 13:27:14'),(114076,377,'Sadat Nagar','123302',1,0,'2022-03-03 13:27:14','2022-03-03 13:27:14'),(114077,377,'Saharanwas','123401',1,0,'2022-03-03 13:27:14','2022-03-03 13:27:14'),(114078,377,'Sangwari','123401',1,0,'2022-03-03 13:27:14','2022-03-03 13:27:14'),(114079,377,'Shyam Nagar','123302',1,0,'2022-03-03 13:27:14','2022-03-03 13:27:14'),(114080,377,'Siha','123411',1,0,'2022-03-03 13:27:14','2022-03-03 13:27:14'),(114081,377,'Sulkha','123401',1,0,'2022-03-03 13:27:14','2022-03-03 13:27:14'),(114082,377,'Sundrah','123034',1,0,'2022-03-03 13:27:15','2022-03-03 13:27:15'),(114083,377,'Surethi','123302',1,0,'2022-03-03 13:27:15','2022-03-03 13:27:15'),(114084,377,'Suthana','123501',1,0,'2022-03-03 13:27:15','2022-03-03 13:27:15'),(114085,377,'Tankri','123412',1,0,'2022-03-03 13:27:15','2022-03-03 13:27:15'),(114086,377,'Tehsil Road Rewari','123401',1,0,'2022-03-03 13:27:15','2022-03-03 13:27:15'),(114087,377,'Tint','123101',1,0,'2022-03-03 13:27:15','2022-03-03 13:27:15'),(114088,377,'Tumna','123302',1,0,'2022-03-03 13:27:15','2022-03-03 13:27:15'),(114089,377,'Zainabad','123411',1,0,'2022-03-03 13:27:15','2022-03-03 13:27:15'),(114090,378,'Ajaib','124111',1,0,'2022-03-03 13:27:15','2022-03-03 13:27:15'),(114091,378,'Anwal','124411',1,0,'2022-03-03 13:27:15','2022-03-03 13:27:15'),(114092,378,'Assan','124406',1,0,'2022-03-03 13:27:15','2022-03-03 13:27:15'),(114093,378,'Asthal Bohar','124021',1,0,'2022-03-03 13:27:15','2022-03-03 13:27:15'),(114094,378,'Atail','124501',1,0,'2022-03-03 13:27:15','2022-03-03 13:27:15'),(114095,378,'Bahu Akbarpur','124022',1,0,'2022-03-03 13:27:15','2022-03-03 13:27:15'),(114096,378,'Bainsi','124514',1,0,'2022-03-03 13:27:15','2022-03-03 13:27:15'),(114097,378,'Bakheta','124406',1,0,'2022-03-03 13:27:15','2022-03-03 13:27:15'),(114098,378,'Baland','124010',1,0,'2022-03-03 13:27:15','2022-03-03 13:27:15'),(114099,378,'Baliana','124401',1,0,'2022-03-03 13:27:15','2022-03-03 13:27:15'),(114100,378,'Banyani','124411',1,0,'2022-03-03 13:27:15','2022-03-03 13:27:15'),(114101,378,'Basana','124022',1,0,'2022-03-03 13:27:15','2022-03-03 13:27:15'),(114102,378,'Basantpur','124303',1,0,'2022-03-03 13:27:15','2022-03-03 13:27:15'),(114103,378,'Behlba','124112',1,0,'2022-03-03 13:27:16','2022-03-03 13:27:16'),(114104,378,'Bhagwatipur','124514',1,0,'2022-03-03 13:27:16','2022-03-03 13:27:16'),(114105,378,'Bhaini Bharon','124112',1,0,'2022-03-03 13:27:16','2022-03-03 13:27:16'),(114106,378,'Bhaini Chanderpal','124112',1,0,'2022-03-03 13:27:16','2022-03-03 13:27:16'),(114107,378,'Bhaini Surjan','124112',1,0,'2022-03-03 13:27:16','2022-03-03 13:27:16'),(114108,378,'Bhalaut','124401',1,0,'2022-03-03 13:27:16','2022-03-03 13:27:16'),(114109,378,'Bhali Anandpur','124010',1,0,'2022-03-03 13:27:16','2022-03-03 13:27:16'),(114110,378,'Bhambhewa','124021',1,0,'2022-03-03 13:27:16','2022-03-03 13:27:16'),(114111,378,'Bhanimaharajpur','124112',1,0,'2022-03-03 13:27:16','2022-03-03 13:27:16'),(114112,378,'Bhaproda','124501',1,0,'2022-03-03 13:27:16','2022-03-03 13:27:16'),(114113,378,'Bharan','124111',1,0,'2022-03-03 13:27:16','2022-03-03 13:27:16'),(114114,378,'Bhasro Kalan','124501',1,0,'2022-03-03 13:27:16','2022-03-03 13:27:16'),(114115,378,'Bohar','124021',1,0,'2022-03-03 13:27:16','2022-03-03 13:27:16'),(114116,378,'Bus Stand','124001',1,0,'2022-03-03 13:27:16','2022-03-03 13:27:16'),(114117,378,'Chamaria','124303',1,0,'2022-03-03 13:27:16','2022-03-03 13:27:16'),(114118,378,'Chandi','124514',1,0,'2022-03-03 13:27:16','2022-03-03 13:27:16'),(114119,378,'Chimni','124412',1,0,'2022-03-03 13:27:16','2022-03-03 13:27:16'),(114120,378,'Chiri','124514',1,0,'2022-03-03 13:27:16','2022-03-03 13:27:16'),(114121,378,'Chuliyana','124501',1,0,'2022-03-03 13:27:16','2022-03-03 13:27:16'),(114122,378,'Dehkora','124501',1,0,'2022-03-03 13:27:16','2022-03-03 13:27:16'),(114123,378,'Dhamar','124401',1,0,'2022-03-03 13:27:17','2022-03-03 13:27:17'),(114124,378,'Dharana','124412',1,0,'2022-03-03 13:27:17','2022-03-03 13:27:17'),(114125,378,'DLF Colony Rohtak','124001',1,0,'2022-03-03 13:27:17','2022-03-03 13:27:17'),(114126,378,'Dobh','124010',1,0,'2022-03-03 13:27:17','2022-03-03 13:27:17'),(114127,378,'Farmana','124112',1,0,'2022-03-03 13:27:17','2022-03-03 13:27:17'),(114128,378,'Gaddi Kheri','124010',1,0,'2022-03-03 13:27:17','2022-03-03 13:27:17'),(114129,378,'Gandhi Camp','124001',1,0,'2022-03-03 13:27:17','2022-03-03 13:27:17'),(114130,378,'Gandhra','124501',1,0,'2022-03-03 13:27:17','2022-03-03 13:27:17'),(114131,378,'Garhi','124411',1,0,'2022-03-03 13:27:17','2022-03-03 13:27:17'),(114132,378,'Garhi','124501',1,0,'2022-03-03 13:27:17','2022-03-03 13:27:17'),(114133,378,'Garhi Ballab','124411',1,0,'2022-03-03 13:27:17','2022-03-03 13:27:17'),(114134,378,'Garnauthi','124412',1,0,'2022-03-03 13:27:17','2022-03-03 13:27:17'),(114135,378,'Gharauthi','124514',1,0,'2022-03-03 13:27:17','2022-03-03 13:27:17'),(114136,378,'Ghillaur Kalan','124303',1,0,'2022-03-03 13:27:17','2022-03-03 13:27:17'),(114137,378,'Ghrauthi','124412',1,0,'2022-03-03 13:27:17','2022-03-03 13:27:17'),(114138,378,'Gijhi','124501',1,0,'2022-03-03 13:27:17','2022-03-03 13:27:17'),(114139,378,'Girawar','124111',1,0,'2022-03-03 13:27:17','2022-03-03 13:27:17'),(114140,378,'Gohana Road (Rohtak)','124001',1,0,'2022-03-03 13:27:17','2022-03-03 13:27:17'),(114141,378,'Gugaheri','124514',1,0,'2022-03-03 13:27:17','2022-03-03 13:27:17'),(114142,378,'Humayunpur','124406',1,0,'2022-03-03 13:27:17','2022-03-03 13:27:17'),(114143,378,'Ismaila','124501',1,0,'2022-03-03 13:27:18','2022-03-03 13:27:18'),(114144,378,'Janta Colony Rohtak','124001',1,0,'2022-03-03 13:27:18','2022-03-03 13:27:18'),(114145,378,'Jassia','124303',1,0,'2022-03-03 13:27:18','2022-03-03 13:27:18'),(114146,378,'Jhajjar Road Rohtak','124001',1,0,'2022-03-03 13:27:18','2022-03-03 13:27:18'),(114147,378,'Jindran','124303',1,0,'2022-03-03 13:27:18','2022-03-03 13:27:18'),(114148,378,'Kahnaur','124412',1,0,'2022-03-03 13:27:18','2022-03-03 13:27:18'),(114149,378,'Kahni','124303',1,0,'2022-03-03 13:27:18','2022-03-03 13:27:18'),(114150,378,'Kakrana','124412',1,0,'2022-03-03 13:27:18','2022-03-03 13:27:18'),(114151,378,'Kalanaur (Rohtak)','124113',1,0,'2022-03-03 13:27:18','2022-03-03 13:27:18'),(114152,378,'Kanheli','124021',1,0,'2022-03-03 13:27:18','2022-03-03 13:27:18'),(114153,378,'Kansala','124406',1,0,'2022-03-03 13:27:18','2022-03-03 13:27:18'),(114154,378,'Karontha','124010',1,0,'2022-03-03 13:27:18','2022-03-03 13:27:18'),(114155,378,'Karor','124021',1,0,'2022-03-03 13:27:18','2022-03-03 13:27:18'),(114156,378,'Katesra','124113',1,0,'2022-03-03 13:27:18','2022-03-03 13:27:18'),(114157,378,'Khairari','124113',1,0,'2022-03-03 13:27:18','2022-03-03 13:27:18'),(114158,378,'Kharainti','124514',1,0,'2022-03-03 13:27:18','2022-03-03 13:27:18'),(114159,378,'Kharawar','124021',1,0,'2022-03-03 13:27:18','2022-03-03 13:27:18'),(114160,378,'Kharhar','124501',1,0,'2022-03-03 13:27:18','2022-03-03 13:27:18'),(114161,378,'Kharkhara','124111',1,0,'2022-03-03 13:27:18','2022-03-03 13:27:18'),(114162,378,'Kheri Sadh','124021',1,0,'2022-03-03 13:27:18','2022-03-03 13:27:18'),(114163,378,'Khidwali','124303',1,0,'2022-03-03 13:27:18','2022-03-03 13:27:18'),(114164,378,'Kiloi','124401',1,0,'2022-03-03 13:27:18','2022-03-03 13:27:18'),(114165,378,'Kultana','124501',1,0,'2022-03-03 13:27:19','2022-03-03 13:27:19'),(114166,378,'Ladout','124401',1,0,'2022-03-03 13:27:19','2022-03-03 13:27:19'),(114167,378,'Lahli','124411',1,0,'2022-03-03 13:27:19','2022-03-03 13:27:19'),(114168,378,'Lakhan Majra','124514',1,0,'2022-03-03 13:27:19','2022-03-03 13:27:19'),(114169,378,'Loharheri','124501',1,0,'2022-03-03 13:27:19','2022-03-03 13:27:19'),(114170,378,'M.D. University Rohtak','124001',1,0,'2022-03-03 13:27:19','2022-03-03 13:27:19'),(114171,378,'Madina','124111',1,0,'2022-03-03 13:27:19','2022-03-03 13:27:19'),(114172,378,'Maina','124021',1,0,'2022-03-03 13:27:19','2022-03-03 13:27:19'),(114173,378,'Makrauli Kalan','124401',1,0,'2022-03-03 13:27:19','2022-03-03 13:27:19'),(114174,378,'Marodi Jatan','124010',1,0,'2022-03-03 13:27:19','2022-03-03 13:27:19'),(114175,378,'Matan','124501',1,0,'2022-03-03 13:27:19','2022-03-03 13:27:19'),(114176,378,'Medical College (Rohtak)','124001',1,0,'2022-03-03 13:27:19','2022-03-03 13:27:19'),(114177,378,'Mehem','124112',1,0,'2022-03-03 13:27:19','2022-03-03 13:27:19'),(114178,378,'Model Town (Rohtak)','124001',1,0,'2022-03-03 13:27:19','2022-03-03 13:27:19'),(114179,378,'Mokhra','124022',1,0,'2022-03-03 13:27:19','2022-03-03 13:27:19'),(114180,378,'Morekheri','124406',1,0,'2022-03-03 13:27:19','2022-03-03 13:27:19'),(114181,378,'Mungain','124401',1,0,'2022-03-03 13:27:19','2022-03-03 13:27:19'),(114182,378,'Nanaud','124501',1,0,'2022-03-03 13:27:19','2022-03-03 13:27:19'),(114183,378,'Nandal','124514',1,0,'2022-03-03 13:27:19','2022-03-03 13:27:19'),(114184,378,'Naya Bans','124501',1,0,'2022-03-03 13:27:19','2022-03-03 13:27:19'),(114185,378,'Nidana','124514',1,0,'2022-03-03 13:27:19','2022-03-03 13:27:19'),(114186,378,'Nigana','124113',1,0,'2022-03-03 13:27:19','2022-03-03 13:27:19'),(114187,378,'Nilothi','124404',1,0,'2022-03-03 13:27:20','2022-03-03 13:27:20'),(114188,378,'Nindana','124513',1,0,'2022-03-03 13:27:20','2022-03-03 13:27:20'),(114189,378,'Paksma','124401',1,0,'2022-03-03 13:27:20','2022-03-03 13:27:20'),(114190,378,'Patwapur','124411',1,0,'2022-03-03 13:27:20','2022-03-03 13:27:20'),(114191,378,'Pehrawar','124021',1,0,'2022-03-03 13:27:20','2022-03-03 13:27:20'),(114192,378,'Polangi','124401',1,0,'2022-03-03 13:27:20','2022-03-03 13:27:20'),(114193,378,'Police Training College Sunaria','124010',1,0,'2022-03-03 13:27:20','2022-03-03 13:27:20'),(114194,378,'Power Plant Jharli','124141',1,0,'2022-03-03 13:27:20','2022-03-03 13:27:20'),(114195,378,'Rithal','124303',1,0,'2022-03-03 13:27:20','2022-03-03 13:27:20'),(114196,378,'Rohad','124501',1,0,'2022-03-03 13:27:20','2022-03-03 13:27:20'),(114197,378,'Rohtak H.O','124001',1,0,'2022-03-03 13:27:20','2022-03-03 13:27:20'),(114198,378,'Rohtak Sector I','124001',1,0,'2022-03-03 13:27:20','2022-03-03 13:27:20'),(114199,378,'Rohtak Town','124001',1,0,'2022-03-03 13:27:20','2022-03-03 13:27:20'),(114200,378,'Rurkee','124401',1,0,'2022-03-03 13:27:20','2022-03-03 13:27:20'),(114201,378,'Saman','124112',1,0,'2022-03-03 13:27:20','2022-03-03 13:27:20'),(114202,378,'Samargopalpur','124514',1,0,'2022-03-03 13:27:20','2022-03-03 13:27:20'),(114203,378,'Samchana','124404',1,0,'2022-03-03 13:27:20','2022-03-03 13:27:20'),(114204,378,'Sampel','124113',1,0,'2022-03-03 13:27:20','2022-03-03 13:27:20'),(114205,378,'Sanghi','124303',1,0,'2022-03-03 13:27:20','2022-03-03 13:27:20'),(114206,378,'Sector-4 Rohtak','124001',1,0,'2022-03-03 13:27:20','2022-03-03 13:27:20'),(114207,378,'Shivaji Colony','124001',1,0,'2022-03-03 13:27:20','2022-03-03 13:27:20'),(114208,378,'Singhpura Kalan','124514',1,0,'2022-03-03 13:27:20','2022-03-03 13:27:20'),(114209,378,'Sisarkhas','124112',1,0,'2022-03-03 13:27:20','2022-03-03 13:27:20'),(114210,378,'Sunari Kalan','124010',1,0,'2022-03-03 13:27:21','2022-03-03 13:27:21'),(114211,378,'Sundana','124412',1,0,'2022-03-03 13:27:21','2022-03-03 13:27:21'),(114212,378,'Sunderpur','124514',1,0,'2022-03-03 13:27:21','2022-03-03 13:27:21'),(114213,378,'Titauli','124514',1,0,'2022-03-03 13:27:21','2022-03-03 13:27:21'),(114214,379,'Abubshahar','125104',1,0,'2022-03-03 13:27:21','2022-03-03 13:27:21'),(114215,379,'Ahmedpur','125055',1,0,'2022-03-03 13:27:21','2022-03-03 13:27:21'),(114216,379,'Alika','125078',1,0,'2022-03-03 13:27:21','2022-03-03 13:27:21'),(114217,379,'Amritsar Kalan','125102',1,0,'2022-03-03 13:27:21','2022-03-03 13:27:21'),(114218,379,'Anandgarh','125078',1,0,'2022-03-03 13:27:21','2022-03-03 13:27:21'),(114219,379,'Arniawali','125055',1,0,'2022-03-03 13:27:21','2022-03-03 13:27:21'),(114220,379,'Asa Khera','125101',1,0,'2022-03-03 13:27:21','2022-03-03 13:27:21'),(114221,379,'Bahaudin','125054',1,0,'2022-03-03 13:27:21','2022-03-03 13:27:21'),(114222,379,'Bahya','125075',1,0,'2022-03-03 13:27:21','2022-03-03 13:27:21'),(114223,379,'Baidwala','125060',1,0,'2022-03-03 13:27:21','2022-03-03 13:27:21'),(114224,379,'Bajekan','125060',1,0,'2022-03-03 13:27:21','2022-03-03 13:27:21'),(114225,379,'Balasar','125075',1,0,'2022-03-03 13:27:21','2022-03-03 13:27:21'),(114226,379,'Banni','125075',1,0,'2022-03-03 13:27:21','2022-03-03 13:27:21'),(114227,379,'Banwala','125103',1,0,'2022-03-03 13:27:21','2022-03-03 13:27:21'),(114228,379,'Bapp','125078',1,0,'2022-03-03 13:27:21','2022-03-03 13:27:21'),(114229,379,'Baragudha','125078',1,0,'2022-03-03 13:27:22','2022-03-03 13:27:22'),(114230,379,'Barawala Khurd','125102',1,0,'2022-03-03 13:27:22','2022-03-03 13:27:22'),(114231,379,'Baruwali-i','125054',1,0,'2022-03-03 13:27:22','2022-03-03 13:27:22'),(114232,379,'Begu Road Sirsa','125055',1,0,'2022-03-03 13:27:22','2022-03-03 13:27:22'),(114233,379,'Bhadra','125078',1,0,'2022-03-03 13:27:22','2022-03-03 13:27:22'),(114234,379,'Bhamboor','125055',1,0,'2022-03-03 13:27:22','2022-03-03 13:27:22'),(114235,379,'Bharokhan','125060',1,0,'2022-03-03 13:27:22','2022-03-03 13:27:22'),(114236,379,'Bharolianwali','125075',1,0,'2022-03-03 13:27:22','2022-03-03 13:27:22'),(114237,379,'Bhiwan','125078',1,0,'2022-03-03 13:27:22','2022-03-03 13:27:22'),(114238,379,'Bhratwala','125055',1,0,'2022-03-03 13:27:22','2022-03-03 13:27:22'),(114239,379,'Bijuwali','125103',1,0,'2022-03-03 13:27:22','2022-03-03 13:27:22'),(114240,379,'Buraj Bhangu','125077',1,0,'2022-03-03 13:27:22','2022-03-03 13:27:22'),(114241,379,'Chadiwal','125110',1,0,'2022-03-03 13:27:22','2022-03-03 13:27:22'),(114242,379,'Chaharwala','125110',1,0,'2022-03-03 13:27:22','2022-03-03 13:27:22'),(114243,379,'Chakarian','125055',1,0,'2022-03-03 13:27:22','2022-03-03 13:27:22'),(114244,379,'Chakkan','125103',1,0,'2022-03-03 13:27:22','2022-03-03 13:27:22'),(114245,379,'Chakrian','125201',1,0,'2022-03-03 13:27:22','2022-03-03 13:27:22'),(114246,379,'Chamal','125055',1,0,'2022-03-03 13:27:22','2022-03-03 13:27:22'),(114247,379,'Chatha','125104',1,0,'2022-03-03 13:27:22','2022-03-03 13:27:22'),(114248,379,'Chattargarh Patti','125055',1,0,'2022-03-03 13:27:22','2022-03-03 13:27:22'),(114249,379,'Chautala','125101',1,0,'2022-03-03 13:27:23','2022-03-03 13:27:23'),(114250,379,'Chopta Nathu Sari','125110',1,0,'2022-03-03 13:27:23','2022-03-03 13:27:23'),(114251,379,'Chormar','125077',1,0,'2022-03-03 13:27:23','2022-03-03 13:27:23'),(114252,379,'Dabwali Town','125104',1,0,'2022-03-03 13:27:23','2022-03-03 13:27:23'),(114253,379,'Dabwali Village','125104',1,0,'2022-03-03 13:27:23','2022-03-03 13:27:23'),(114254,379,'Dadu','125201',1,0,'2022-03-03 13:27:23','2022-03-03 13:27:23'),(114255,379,'Damdama','125075',1,0,'2022-03-03 13:27:23','2022-03-03 13:27:23'),(114256,379,'Darba Kalan','125110',1,0,'2022-03-03 13:27:23','2022-03-03 13:27:23'),(114257,379,'Darbi','125060',1,0,'2022-03-03 13:27:23','2022-03-03 13:27:23'),(114258,379,'Desu Jodha','125104',1,0,'2022-03-03 13:27:23','2022-03-03 13:27:23'),(114259,379,'Desu Mulkana','125201',1,0,'2022-03-03 13:27:23','2022-03-03 13:27:23'),(114260,379,'Dharampura','125075',1,0,'2022-03-03 13:27:23','2022-03-03 13:27:23'),(114261,379,'Ding','125058',1,0,'2022-03-03 13:27:23','2022-03-03 13:27:23'),(114262,379,'Dohtar','125076',1,0,'2022-03-03 13:27:23','2022-03-03 13:27:23'),(114263,379,'Dudianwali','125075',1,0,'2022-03-03 13:27:23','2022-03-03 13:27:23'),(114264,379,'Ellenabad','125102',1,0,'2022-03-03 13:27:23','2022-03-03 13:27:23'),(114265,379,'Ferozabad','125055',1,0,'2022-03-03 13:27:23','2022-03-03 13:27:23'),(114266,379,'Furwain Kalan','125060',1,0,'2022-03-03 13:27:23','2022-03-03 13:27:23'),(114267,379,'Ganda','125103',1,0,'2022-03-03 13:27:23','2022-03-03 13:27:23'),(114268,379,'Ghoranwali','125103',1,0,'2022-03-03 13:27:23','2022-03-03 13:27:23'),(114269,379,'Godrana','125201',1,0,'2022-03-03 13:27:23','2022-03-03 13:27:23'),(114270,379,'Goriwala','125103',1,0,'2022-03-03 13:27:24','2022-03-03 13:27:24'),(114271,379,'Gudia Khera','125055',1,0,'2022-03-03 13:27:24','2022-03-03 13:27:24'),(114272,379,'Gussiana','125110',1,0,'2022-03-03 13:27:24','2022-03-03 13:27:24'),(114273,379,'Habuana','125104',1,0,'2022-03-03 13:27:24','2022-03-03 13:27:24'),(114274,379,'Hanziran','125110',1,0,'2022-03-03 13:27:24','2022-03-03 13:27:24'),(114275,379,'Haripura','125075',1,0,'2022-03-03 13:27:24','2022-03-03 13:27:24'),(114276,379,'Jagmalwali','125201',1,0,'2022-03-03 13:27:24','2022-03-03 13:27:24'),(114277,379,'Jalalana','125201',1,0,'2022-03-03 13:27:24','2022-03-03 13:27:24'),(114278,379,'Jamal','125110',1,0,'2022-03-03 13:27:24','2022-03-03 13:27:24'),(114279,379,'Janowala Bishnolan','125101',1,0,'2022-03-03 13:27:24','2022-03-03 13:27:24'),(114280,379,'JCD Vidyapeeth Sirsa','125056',1,0,'2022-03-03 13:27:24','2022-03-03 13:27:24'),(114281,379,'Jhiri','125078',1,0,'2022-03-03 13:27:24','2022-03-03 13:27:24'),(114282,379,'Jhorar Rohi','125078',1,0,'2022-03-03 13:27:24','2022-03-03 13:27:24'),(114283,379,'Jhornali','125055',1,0,'2022-03-03 13:27:24','2022-03-03 13:27:24'),(114284,379,'Jodhkan','125055',1,0,'2022-03-03 13:27:24','2022-03-03 13:27:24'),(114285,379,'Jodhpuria','125076',1,0,'2022-03-03 13:27:24','2022-03-03 13:27:24'),(114286,379,'Kagdana','125110',1,0,'2022-03-03 13:27:24','2022-03-03 13:27:24'),(114287,379,'Kalanwali','125201',1,0,'2022-03-03 13:27:24','2022-03-03 13:27:24'),(114288,379,'Kaluana','125103',1,0,'2022-03-03 13:27:24','2022-03-03 13:27:24'),(114289,379,'Kariwala','125075',1,0,'2022-03-03 13:27:24','2022-03-03 13:27:24'),(114290,379,'Keharwala','125103',1,0,'2022-03-03 13:27:25','2022-03-03 13:27:25'),(114291,379,'Keshopura','125055',1,0,'2022-03-03 13:27:25','2022-03-03 13:27:25'),(114292,379,'Khairkan','125077',1,0,'2022-03-03 13:27:25','2022-03-03 13:27:25'),(114293,379,'Khairpur','125055',1,0,'2022-03-03 13:27:25','2022-03-03 13:27:25'),(114294,379,'Khari Sureran','125102',1,0,'2022-03-03 13:27:25','2022-03-03 13:27:25'),(114295,379,'Kharian','125076',1,0,'2022-03-03 13:27:25','2022-03-03 13:27:25'),(114296,379,'Khuiyana Malkana','125104',1,0,'2022-03-03 13:27:25','2022-03-03 13:27:25'),(114297,379,'Kurangawali','125078',1,0,'2022-03-03 13:27:25','2022-03-03 13:27:25'),(114298,379,'Kusumbi','125055',1,0,'2022-03-03 13:27:25','2022-03-03 13:27:25'),(114299,379,'Kutewadh','125055',1,0,'2022-03-03 13:27:25','2022-03-03 13:27:25'),(114300,379,'Lakarwali','125201',1,0,'2022-03-03 13:27:25','2022-03-03 13:27:25'),(114301,379,'Lehangewala','125078',1,0,'2022-03-03 13:27:25','2022-03-03 13:27:25'),(114302,379,'Lohgarh','125104',1,0,'2022-03-03 13:27:25','2022-03-03 13:27:25'),(114303,379,'Ludesar','125110',1,0,'2022-03-03 13:27:25','2022-03-03 13:27:25'),(114304,379,'Madho Singhana','125055',1,0,'2022-03-03 13:27:25','2022-03-03 13:27:25'),(114305,379,'Majudin','125055',1,0,'2022-03-03 13:27:25','2022-03-03 13:27:25'),(114306,379,'Makhosarani','125110',1,0,'2022-03-03 13:27:25','2022-03-03 13:27:25'),(114307,379,'Mallekan','125055',1,0,'2022-03-03 13:27:25','2022-03-03 13:27:25'),(114308,379,'Mamera Kalan','125102',1,0,'2022-03-03 13:27:25','2022-03-03 13:27:25'),(114309,379,'Mandi Dabwali','125104',1,0,'2022-03-03 13:27:25','2022-03-03 13:27:25'),(114310,379,'Mangala','125055',1,0,'2022-03-03 13:27:25','2022-03-03 13:27:25'),(114311,379,'Mangiana','125104',1,0,'2022-03-03 13:27:25','2022-03-03 13:27:25'),(114312,379,'Manjui Khera','125054',1,0,'2022-03-03 13:27:26','2022-03-03 13:27:26'),(114313,379,'Masitan','125104',1,0,'2022-03-03 13:27:26','2022-03-03 13:27:26'),(114314,379,'Matdadu','125103',1,0,'2022-03-03 13:27:26','2022-03-03 13:27:26'),(114315,379,'Maujgarbh','125104',1,0,'2022-03-03 13:27:26','2022-03-03 13:27:26'),(114316,379,'Mauju Khera','125102',1,0,'2022-03-03 13:27:26','2022-03-03 13:27:26'),(114317,379,'Mini.Sectt.Sirsa','125055',1,0,'2022-03-03 13:27:26','2022-03-03 13:27:26'),(114318,379,'Mirzapur','125102',1,0,'2022-03-03 13:27:26','2022-03-03 13:27:26'),(114319,379,'Mithanpura','125102',1,0,'2022-03-03 13:27:26','2022-03-03 13:27:26'),(114320,379,'Mithri','125104',1,0,'2022-03-03 13:27:26','2022-03-03 13:27:26'),(114321,379,'Mochiwali','125058',1,0,'2022-03-03 13:27:26','2022-03-03 13:27:26'),(114322,379,'Monnawali','125103',1,0,'2022-03-03 13:27:26','2022-03-03 13:27:26'),(114323,379,'Moriwala','125060',1,0,'2022-03-03 13:27:26','2022-03-03 13:27:26'),(114324,379,'Mts Sirsa','125055',1,0,'2022-03-03 13:27:26','2022-03-03 13:27:26'),(114325,379,'Nagoki','125078',1,0,'2022-03-03 13:27:26','2022-03-03 13:27:26'),(114326,379,'Nai Mandi Sirsa','125055',1,0,'2022-03-03 13:27:26','2022-03-03 13:27:26'),(114327,379,'Nakora','125075',1,0,'2022-03-03 13:27:26','2022-03-03 13:27:26'),(114328,379,'Nanuana','125076',1,0,'2022-03-03 13:27:26','2022-03-03 13:27:26'),(114329,379,'Nathore','125075',1,0,'2022-03-03 13:27:26','2022-03-03 13:27:26'),(114330,379,'Nathusari Kalan','125110',1,0,'2022-03-03 13:27:26','2022-03-03 13:27:26'),(114331,379,'Nezadela Khurd','125077',1,0,'2022-03-03 13:27:26','2022-03-03 13:27:26'),(114332,379,'Nozadela Kalan','125060',1,0,'2022-03-03 13:27:26','2022-03-03 13:27:26'),(114333,379,'Nozia Khera','125060',1,0,'2022-03-03 13:27:26','2022-03-03 13:27:26'),(114334,379,'Nuhianwali','125077',1,0,'2022-03-03 13:27:26','2022-03-03 13:27:26'),(114335,379,'Odhan','125077',1,0,'2022-03-03 13:27:27','2022-03-03 13:27:27'),(114336,379,'Ottu','125055',1,0,'2022-03-03 13:27:27','2022-03-03 13:27:27'),(114337,379,'Pakka','125201',1,0,'2022-03-03 13:27:27','2022-03-03 13:27:27'),(114338,379,'Panihari','125055',1,0,'2022-03-03 13:27:27','2022-03-03 13:27:27'),(114339,379,'Paniwala Mota','125077',1,0,'2022-03-03 13:27:27','2022-03-03 13:27:27'),(114340,379,'Paniwala Ruldu','125104',1,0,'2022-03-03 13:27:27','2022-03-03 13:27:27'),(114341,379,'Panjuana','125077',1,0,'2022-03-03 13:27:27','2022-03-03 13:27:27'),(114342,379,'Patli Dabar','125054',1,0,'2022-03-03 13:27:27','2022-03-03 13:27:27'),(114343,379,'Phaggu','125201',1,0,'2022-03-03 13:27:27','2022-03-03 13:27:27'),(114344,379,'Phulkan','125060',1,0,'2022-03-03 13:27:27','2022-03-03 13:27:27'),(114345,379,'Pipli','125201',1,0,'2022-03-03 13:27:27','2022-03-03 13:27:27'),(114346,379,'Poharkan','125102',1,0,'2022-03-03 13:27:27','2022-03-03 13:27:27'),(114347,379,'Rampur Bishnoian','125103',1,0,'2022-03-03 13:27:27','2022-03-03 13:27:27'),(114348,379,'Randhawa','125055',1,0,'2022-03-03 13:27:27','2022-03-03 13:27:27'),(114349,379,'Rania','125076',1,0,'2022-03-03 13:27:27','2022-03-03 13:27:27'),(114350,379,'Resalia Khera','125103',1,0,'2022-03-03 13:27:27','2022-03-03 13:27:27'),(114351,379,'Rori','125201',1,0,'2022-03-03 13:27:27','2022-03-03 13:27:27'),(114352,379,'Rupawas','125110',1,0,'2022-03-03 13:27:27','2022-03-03 13:27:27'),(114353,379,'Sahuwala','125077',1,0,'2022-03-03 13:27:27','2022-03-03 13:27:27'),(114354,379,'Sahuwala -ii','125110',1,0,'2022-03-03 13:27:27','2022-03-03 13:27:27'),(114355,379,'Sakta Khera','125104',1,0,'2022-03-03 13:27:28','2022-03-03 13:27:28'),(114356,379,'Sant Nagar','125075',1,0,'2022-03-03 13:27:28','2022-03-03 13:27:28'),(114357,379,'Shahpur Begu','125055',1,0,'2022-03-03 13:27:28','2022-03-03 13:27:28'),(114358,379,'Shakar Mandori','125110',1,0,'2022-03-03 13:27:28','2022-03-03 13:27:28'),(114359,379,'Shergarh','125104',1,0,'2022-03-03 13:27:28','2022-03-03 13:27:28'),(114360,379,'Sherpura','125110',1,0,'2022-03-03 13:27:28','2022-03-03 13:27:28'),(114361,379,'Sikander Pur','125060',1,0,'2022-03-03 13:27:28','2022-03-03 13:27:28'),(114362,379,'Singhpura','125201',1,0,'2022-03-03 13:27:28','2022-03-03 13:27:28'),(114363,379,'Siri Jiwan Nagar','125075',1,0,'2022-03-03 13:27:28','2022-03-03 13:27:28'),(114364,379,'Sirsa H.O','125055',1,0,'2022-03-03 13:27:28','2022-03-03 13:27:28'),(114365,379,'Sirsa Town','125055',1,0,'2022-03-03 13:27:28','2022-03-03 13:27:28'),(114366,379,'Suchan Kotli','125055',1,0,'2022-03-03 13:27:28','2022-03-03 13:27:28'),(114367,379,'Sukhchain','125201',1,0,'2022-03-03 13:27:28','2022-03-03 13:27:28'),(114368,379,'Sultanpuria','125076',1,0,'2022-03-03 13:27:28','2022-03-03 13:27:28'),(114369,379,'Surtia','125201',1,0,'2022-03-03 13:27:28','2022-03-03 13:27:28'),(114370,379,'Takhatmal','125201',1,0,'2022-03-03 13:27:28','2022-03-03 13:27:28'),(114371,379,'Talwara Khurd','125102',1,0,'2022-03-03 13:27:28','2022-03-03 13:27:28'),(114372,379,'Taruana','125201',1,0,'2022-03-03 13:27:28','2022-03-03 13:27:28'),(114373,379,'Thersahidau','125075',1,0,'2022-03-03 13:27:28','2022-03-03 13:27:28'),(114374,379,'Thiraj','125078',1,0,'2022-03-03 13:27:28','2022-03-03 13:27:28'),(114375,379,'Umedpura','125055',1,0,'2022-03-03 13:27:29','2022-03-03 13:27:29'),(114376,380,'Ahulana(Gannur)','131101',1,0,'2022-03-03 13:27:29','2022-03-03 13:27:29'),(114377,380,'Ahulana(Gohana)','131301',1,0,'2022-03-03 13:27:29','2022-03-03 13:27:29'),(114378,380,'Akabarpur Barota','131103',1,0,'2022-03-03 13:27:29','2022-03-03 13:27:29'),(114379,380,'Anwali','131409',1,0,'2022-03-03 13:27:29','2022-03-03 13:27:29');
INSERT INTO `cities` VALUES (114380,380,'Asadpur Nandnaur','131027',1,0,'2022-03-03 13:27:29','2022-03-03 13:27:29'),(114381,380,'Aterna','131023',1,0,'2022-03-03 13:27:29','2022-03-03 13:27:29'),(114382,380,'Atlas Cycle','131001',1,0,'2022-03-03 13:27:29','2022-03-03 13:27:29'),(114383,380,'Badhana','131403',1,0,'2022-03-03 13:27:29','2022-03-03 13:27:29'),(114384,380,'Bahalgarh','131021',1,0,'2022-03-03 13:27:29','2022-03-03 13:27:29'),(114385,380,'Bajanakhurd','131102',1,0,'2022-03-03 13:27:29','2022-03-03 13:27:29'),(114386,380,'Bali Brahman','131301',1,0,'2022-03-03 13:27:29','2022-03-03 13:27:29'),(114387,380,'Bali Qutubpur','131101',1,0,'2022-03-03 13:27:29','2022-03-03 13:27:29'),(114388,380,'Banwasa','131304',1,0,'2022-03-03 13:27:29','2022-03-03 13:27:29'),(114389,380,'Bari','131101',1,0,'2022-03-03 13:27:29','2022-03-03 13:27:29'),(114390,380,'Baroda','131304',1,0,'2022-03-03 13:27:29','2022-03-03 13:27:29'),(114391,380,'Baroli','131021',1,0,'2022-03-03 13:27:29','2022-03-03 13:27:29'),(114392,380,'Barona','131402',1,0,'2022-03-03 13:27:29','2022-03-03 13:27:29'),(114393,380,'Barota','131301',1,0,'2022-03-03 13:27:29','2022-03-03 13:27:29'),(114394,380,'Barwasni','131001',1,0,'2022-03-03 13:27:29','2022-03-03 13:27:29'),(114395,380,'Bayanpur','131001',1,0,'2022-03-03 13:27:29','2022-03-03 13:27:29'),(114396,380,'Bega','131101',1,0,'2022-03-03 13:27:29','2022-03-03 13:27:29'),(114397,380,'Bhagan','131039',1,0,'2022-03-03 13:27:29','2022-03-03 13:27:29'),(114398,380,'Bhainswal Kalan','131409',1,0,'2022-03-03 13:27:30','2022-03-03 13:27:30'),(114399,380,'Bhainswan Khurd','131301',1,0,'2022-03-03 13:27:30','2022-03-03 13:27:30'),(114400,380,'Bhatgaon (Sonipat)','131022',1,0,'2022-03-03 13:27:30','2022-03-03 13:27:30'),(114401,380,'Bhawar','131302',1,0,'2022-03-03 13:27:30','2022-03-03 13:27:30'),(114402,380,'Bhimnagar','131001',1,0,'2022-03-03 13:27:30','2022-03-03 13:27:30'),(114403,380,'Bidhal','131301',1,0,'2022-03-03 13:27:30','2022-03-03 13:27:30'),(114404,380,'Bidhal Pinana','131301',1,0,'2022-03-03 13:27:30','2022-03-03 13:27:30'),(114405,380,'Bidhlan','131402',1,0,'2022-03-03 13:27:30','2022-03-03 13:27:30'),(114406,380,'Bindroli','131403',1,0,'2022-03-03 13:27:30','2022-03-03 13:27:30'),(114407,380,'Bohla','131024',1,0,'2022-03-03 13:27:30','2022-03-03 13:27:30'),(114408,380,'Bus Stand Gohana','131301',1,0,'2022-03-03 13:27:30','2022-03-03 13:27:30'),(114409,380,'Busana','131306',1,0,'2022-03-03 13:27:30','2022-03-03 13:27:30'),(114410,380,'Butana','131302',1,0,'2022-03-03 13:27:30','2022-03-03 13:27:30'),(114411,380,'Chhapra','131304',1,0,'2022-03-03 13:27:30','2022-03-03 13:27:30'),(114412,380,'Chhetra','131306',1,0,'2022-03-03 13:27:30','2022-03-03 13:27:30'),(114413,380,'Chhetra Bhahadurpur','131103',1,0,'2022-03-03 13:27:30','2022-03-03 13:27:30'),(114414,380,'Chhichrana','131301',1,0,'2022-03-03 13:27:30','2022-03-03 13:27:30'),(114415,380,'Chirana','131306',1,0,'2022-03-03 13:27:30','2022-03-03 13:27:30'),(114416,380,'Datauli','131101',1,0,'2022-03-03 13:27:30','2022-03-03 13:27:30'),(114417,380,'Deepalpur','131021',1,0,'2022-03-03 13:27:30','2022-03-03 13:27:30'),(114418,380,'Delhi Road','131001',1,0,'2022-03-03 13:27:31','2022-03-03 13:27:31'),(114419,380,'Dhanana Ahladpur','131304',1,0,'2022-03-03 13:27:31','2022-03-03 13:27:31'),(114420,380,'Dhurana','131306',1,0,'2022-03-03 13:27:31','2022-03-03 13:27:31'),(114421,380,'Engg College Muthal','131039',1,0,'2022-03-03 13:27:31','2022-03-03 13:27:31'),(114422,380,'Farmana','131408',1,0,'2022-03-03 13:27:31','2022-03-03 13:27:31'),(114423,380,'Fazilpur','131001',1,0,'2022-03-03 13:27:31','2022-03-03 13:27:31'),(114424,380,'G.K.Matindu','131402',1,0,'2022-03-03 13:27:31','2022-03-03 13:27:31'),(114425,380,'Ganaur City','131101',1,0,'2022-03-03 13:27:31','2022-03-03 13:27:31'),(114426,380,'Ganaur','131101',1,0,'2022-03-03 13:27:31','2022-03-03 13:27:31'),(114427,380,'Ganewari','131305',1,0,'2022-03-03 13:27:31','2022-03-03 13:27:31'),(114428,380,'Gangana','131302',1,0,'2022-03-03 13:27:31','2022-03-03 13:27:31'),(114429,380,'Ganzbazar','131001',1,0,'2022-03-03 13:27:31','2022-03-03 13:27:31'),(114430,380,'Garhi Rajlu','131101',1,0,'2022-03-03 13:27:31','2022-03-03 13:27:31'),(114431,380,'Garhi Sisana ED','131408',1,0,'2022-03-03 13:27:31','2022-03-03 13:27:31'),(114432,380,'Garhwal','131302',1,0,'2022-03-03 13:27:31','2022-03-03 13:27:31'),(114433,380,'Ghasauli','131101',1,0,'2022-03-03 13:27:31','2022-03-03 13:27:31'),(114434,380,'Giwana','131409',1,0,'2022-03-03 13:27:31','2022-03-03 13:27:31'),(114435,380,'Gohana Mandi','131301',1,0,'2022-03-03 13:27:31','2022-03-03 13:27:31'),(114436,380,'Gohana Road (Sonipat)','131001',1,0,'2022-03-03 13:27:31','2022-03-03 13:27:31'),(114437,380,'Gohana','131301',1,0,'2022-03-03 13:27:31','2022-03-03 13:27:31'),(114438,380,'Gopalpur','131402',1,0,'2022-03-03 13:27:31','2022-03-03 13:27:31'),(114439,380,'Gorar','131408',1,0,'2022-03-03 13:27:31','2022-03-03 13:27:31'),(114440,380,'Guhna','131408',1,0,'2022-03-03 13:27:31','2022-03-03 13:27:31'),(114441,380,'Gumar','131101',1,0,'2022-03-03 13:27:31','2022-03-03 13:27:31'),(114442,380,'Halalpur','131103',1,0,'2022-03-03 13:27:31','2022-03-03 13:27:31'),(114443,380,'Harsana Kalan','131001',1,0,'2022-03-03 13:27:32','2022-03-03 13:27:32'),(114444,380,'Housing Board Colony','131001',1,0,'2022-03-03 13:27:32','2022-03-03 13:27:32'),(114445,380,'Industrial Area Sonipat','131001',1,0,'2022-03-03 13:27:32','2022-03-03 13:27:32'),(114446,380,'Industrial Estate Kundli','131028',1,0,'2022-03-03 13:27:32','2022-03-03 13:27:32'),(114447,380,'Jagsi','131301',1,0,'2022-03-03 13:27:32','2022-03-03 13:27:32'),(114448,380,'Jainpur','131027',1,0,'2022-03-03 13:27:32','2022-03-03 13:27:32'),(114449,380,'Jakhauli','131023',1,0,'2022-03-03 13:27:32','2022-03-03 13:27:32'),(114450,380,'Janti Kalan','131028',1,0,'2022-03-03 13:27:32','2022-03-03 13:27:32'),(114451,380,'Jasrana','131408',1,0,'2022-03-03 13:27:32','2022-03-03 13:27:32'),(114452,380,'Jatheri','131029',1,0,'2022-03-03 13:27:32','2022-03-03 13:27:32'),(114453,380,'Jauli','131301',1,0,'2022-03-03 13:27:32','2022-03-03 13:27:32'),(114454,380,'Jawahra','131306',1,0,'2022-03-03 13:27:32','2022-03-03 13:27:32'),(114455,380,'Jharot','131403',1,0,'2022-03-03 13:27:32','2022-03-03 13:27:32'),(114456,380,'Jhs Butana','131302',1,0,'2022-03-03 13:27:32','2022-03-03 13:27:32'),(114457,380,'Jhundpur','131023',1,0,'2022-03-03 13:27:32','2022-03-03 13:27:32'),(114458,380,'Juan','131024',1,0,'2022-03-03 13:27:32','2022-03-03 13:27:32'),(114459,380,'Kailana','131102',1,0,'2022-03-03 13:27:32','2022-03-03 13:27:32'),(114460,380,'Kakroi','131001',1,0,'2022-03-03 13:27:32','2022-03-03 13:27:32'),(114461,380,'Kanwali','131403',1,0,'2022-03-03 13:27:32','2022-03-03 13:27:32'),(114462,380,'Kanyagurukul Khanpur','131305',1,0,'2022-03-03 13:27:32','2022-03-03 13:27:32'),(114463,380,'Karewari','131024',1,0,'2022-03-03 13:27:32','2022-03-03 13:27:32'),(114464,380,'Kasandi','131305',1,0,'2022-03-03 13:27:32','2022-03-03 13:27:32'),(114465,380,'Kathura','131301',1,0,'2022-03-03 13:27:32','2022-03-03 13:27:32'),(114466,380,'Kathura Block','131301',1,0,'2022-03-03 13:27:32','2022-03-03 13:27:32'),(114467,380,'Katwal','131409',1,0,'2022-03-03 13:27:32','2022-03-03 13:27:32'),(114468,380,'Khanda','131402',1,0,'2022-03-03 13:27:32','2022-03-03 13:27:32'),(114469,380,'Khandrai','131301',1,0,'2022-03-03 13:27:33','2022-03-03 13:27:33'),(114470,380,'Khanpur Kalan','131305',1,0,'2022-03-03 13:27:33','2022-03-03 13:27:33'),(114471,380,'Kharkhauda','131402',1,0,'2022-03-03 13:27:33','2022-03-03 13:27:33'),(114472,380,'Kheri Damkan','131301',1,0,'2022-03-03 13:27:33','2022-03-03 13:27:33'),(114473,380,'Kheri Gujjar','131101',1,0,'2022-03-03 13:27:33','2022-03-03 13:27:33'),(114474,380,'Kheri Manajat','131103',1,0,'2022-03-03 13:27:33','2022-03-03 13:27:33'),(114475,380,'Khewra','131021',1,0,'2022-03-03 13:27:33','2022-03-03 13:27:33'),(114476,380,'Khizarpur Ahir','131101',1,0,'2022-03-03 13:27:33','2022-03-03 13:27:33'),(114477,380,'Khubru','131101',1,0,'2022-03-03 13:27:33','2022-03-03 13:27:33'),(114478,380,'Kohla','131302',1,0,'2022-03-03 13:27:33','2022-03-03 13:27:33'),(114479,380,'Kundal','131402',1,0,'2022-03-03 13:27:33','2022-03-03 13:27:33'),(114480,380,'Kundli','131028',1,0,'2022-03-03 13:27:33','2022-03-03 13:27:33'),(114481,380,'Kurar Brahimpur','131039',1,0,'2022-03-03 13:27:33','2022-03-03 13:27:33'),(114482,380,'Larsauli','131039',1,0,'2022-03-03 13:27:33','2022-03-03 13:27:33'),(114483,380,'Lath','131301',1,0,'2022-03-03 13:27:33','2022-03-03 13:27:33'),(114484,380,'Lehrara','131001',1,0,'2022-03-03 13:27:33','2022-03-03 13:27:33'),(114485,380,'Madina','131301',1,0,'2022-03-03 13:27:33','2022-03-03 13:27:33'),(114486,380,'Mahra -II','131024',1,0,'2022-03-03 13:27:33','2022-03-03 13:27:33'),(114487,380,'Mahra-I','131301',1,0,'2022-03-03 13:27:33','2022-03-03 13:27:33'),(114488,380,'Malikpur','131027',1,0,'2022-03-03 13:27:33','2022-03-03 13:27:33'),(114489,380,'Manauli','131023',1,0,'2022-03-03 13:27:34','2022-03-03 13:27:34'),(114490,380,'Mandaura','131103',1,0,'2022-03-03 13:27:34','2022-03-03 13:27:34'),(114491,380,'Mehlana','131001',1,0,'2022-03-03 13:27:34','2022-03-03 13:27:34'),(114492,380,'Mehmoodpur','131301',1,0,'2022-03-03 13:27:34','2022-03-03 13:27:34'),(114493,380,'Model Town',' Sonipat',1,0,'2022-03-03 13:27:34','2022-03-03 13:27:34'),(114494,380,'Mohana','131001',1,0,'2022-03-03 13:27:34','2022-03-03 13:27:34'),(114495,380,'Moi Hooda','131301',1,0,'2022-03-03 13:27:34','2022-03-03 13:27:34'),(114496,380,'Moi Majri','131102',1,0,'2022-03-03 13:27:34','2022-03-03 13:27:34'),(114497,380,'Mundlana','131306',1,0,'2022-03-03 13:27:34','2022-03-03 13:27:34'),(114498,380,'Murthal','131027',1,0,'2022-03-03 13:27:34','2022-03-03 13:27:34'),(114499,380,'Nahra','131103',1,0,'2022-03-03 13:27:34','2022-03-03 13:27:34'),(114500,380,'Nahri','131103',1,0,'2022-03-03 13:27:34','2022-03-03 13:27:34'),(114501,380,'Nangal Kalan','131023',1,0,'2022-03-03 13:27:34','2022-03-03 13:27:34'),(114502,380,'Nathupur','131029',1,0,'2022-03-03 13:27:34','2022-03-03 13:27:34'),(114503,380,'Nayat','131301',1,0,'2022-03-03 13:27:34','2022-03-03 13:27:34'),(114504,380,'Nizampur','131302',1,0,'2022-03-03 13:27:34','2022-03-03 13:27:34'),(114505,380,'Nuran Khera','131302',1,0,'2022-03-03 13:27:34','2022-03-03 13:27:34'),(114506,380,'P.S.Rai','131029',1,0,'2022-03-03 13:27:34','2022-03-03 13:27:34'),(114507,380,'Panchi Gujjaran','131101',1,0,'2022-03-03 13:27:34','2022-03-03 13:27:34'),(114508,380,'Panchijatan','131102',1,0,'2022-03-03 13:27:34','2022-03-03 13:27:34'),(114509,380,'Pehladpur Kiroli','131402',1,0,'2022-03-03 13:27:34','2022-03-03 13:27:34'),(114510,380,'Pipli','131402',1,0,'2022-03-03 13:27:34','2022-03-03 13:27:34'),(114511,380,'Pipli Khera','131039',1,0,'2022-03-03 13:27:34','2022-03-03 13:27:34'),(114512,380,'Pritampura','131029',1,0,'2022-03-03 13:27:34','2022-03-03 13:27:34'),(114513,380,'Pugthala','131102',1,0,'2022-03-03 13:27:35','2022-03-03 13:27:35'),(114514,380,'Purkhas','131102',1,0,'2022-03-03 13:27:35','2022-03-03 13:27:35'),(114515,380,'Puthi','131301',1,0,'2022-03-03 13:27:35','2022-03-03 13:27:35'),(114516,380,'Qumaspur','131021',1,0,'2022-03-03 13:27:35','2022-03-03 13:27:35'),(114517,380,'Rabra','131301',1,0,'2022-03-03 13:27:35','2022-03-03 13:27:35'),(114518,380,'Rai','131029',1,0,'2022-03-03 13:27:35','2022-03-03 13:27:35'),(114519,380,'Rajpur','131101',1,0,'2022-03-03 13:27:35','2022-03-03 13:27:35'),(114520,380,'Ram Bazar-Sonipat','131001',1,0,'2022-03-03 13:27:35','2022-03-03 13:27:35'),(114521,380,'Rathdhana','131001',1,0,'2022-03-03 13:27:35','2022-03-03 13:27:35'),(114522,380,'Rathdhana Road Sonipat','131001',1,0,'2022-03-03 13:27:35','2022-03-03 13:27:35'),(114523,380,'Rattangarh','131001',1,0,'2022-03-03 13:27:35','2022-03-03 13:27:35'),(114524,380,'Rindana','131304',1,0,'2022-03-03 13:27:35','2022-03-03 13:27:35'),(114525,380,'Rishikul Vidyapeeth','131001',1,0,'2022-03-03 13:27:35','2022-03-03 13:27:35'),(114526,380,'Riwara','131409',1,0,'2022-03-03 13:27:35','2022-03-03 13:27:35'),(114527,380,'Rohat (Sonipat)','131403',1,0,'2022-03-03 13:27:35','2022-03-03 13:27:35'),(114528,380,'Rohna','131402',1,0,'2022-03-03 13:27:35','2022-03-03 13:27:35'),(114529,380,'Rolad Latifpur','131024',1,0,'2022-03-03 13:27:35','2022-03-03 13:27:35'),(114530,380,'Rukhi','131301',1,0,'2022-03-03 13:27:35','2022-03-03 13:27:35'),(114531,380,'Saidpur','131402',1,0,'2022-03-03 13:27:35','2022-03-03 13:27:35'),(114532,380,'Salimsar Majra','131022',1,0,'2022-03-03 13:27:35','2022-03-03 13:27:35'),(114533,380,'Sandal Kalan','131001',1,0,'2022-03-03 13:27:35','2022-03-03 13:27:35'),(114534,380,'Sanpera','131039',1,0,'2022-03-03 13:27:35','2022-03-03 13:27:35'),(114535,380,'Saragthal','131305',1,0,'2022-03-03 13:27:36','2022-03-03 13:27:36'),(114536,380,'Sehri','131402',1,0,'2022-03-03 13:27:36','2022-03-03 13:27:36'),(114537,380,'Sersa','131028',1,0,'2022-03-03 13:27:36','2022-03-03 13:27:36'),(114538,380,'Shamri','131306',1,0,'2022-03-03 13:27:36','2022-03-03 13:27:36'),(114539,380,'Shapur Turk','131001',1,0,'2022-03-03 13:27:36','2022-03-03 13:27:36'),(114540,380,'Sheikhpura','131101',1,0,'2022-03-03 13:27:36','2022-03-03 13:27:36'),(114541,380,'Sikenderpur Majra','131301',1,0,'2022-03-03 13:27:36','2022-03-03 13:27:36'),(114542,380,'Silana','131408',1,0,'2022-03-03 13:27:36','2022-03-03 13:27:36'),(114543,380,'Sitawali','131024',1,0,'2022-03-03 13:27:36','2022-03-03 13:27:36'),(114544,380,'Sohti','131402',1,0,'2022-03-03 13:27:36','2022-03-03 13:27:36'),(114545,380,'Sonipat H.O','131001',1,0,'2022-03-03 13:27:36','2022-03-03 13:27:36'),(114546,380,'Sonipat Kty','131001',1,0,'2022-03-03 13:27:36','2022-03-03 13:27:36'),(114547,380,'Sonipat Mandi','131001',1,0,'2022-03-03 13:27:36','2022-03-03 13:27:36'),(114548,380,'Sonipat Sector 14','131001',1,0,'2022-03-03 13:27:36','2022-03-03 13:27:36'),(114549,380,'Thanakalan','131402',1,0,'2022-03-03 13:27:36','2022-03-03 13:27:36'),(114550,380,'Tharuoldepur','131001',1,0,'2022-03-03 13:27:36','2022-03-03 13:27:36'),(114551,380,'Tihar','131301',1,0,'2022-03-03 13:27:36','2022-03-03 13:27:36'),(114552,380,'Tihar Bagru','131022',1,0,'2022-03-03 13:27:36','2022-03-03 13:27:36'),(114553,381,'Alhar','135133',1,0,'2022-03-03 13:27:36','2022-03-03 13:27:36'),(114554,381,'Amadalpur','135101',1,0,'2022-03-03 13:27:36','2022-03-03 13:27:36'),(114555,381,'Aurangabad','135002',1,0,'2022-03-03 13:27:36','2022-03-03 13:27:36'),(114556,381,'Azizpur','133206',1,0,'2022-03-03 13:27:36','2022-03-03 13:27:36'),(114557,381,'Bakana','135133',1,0,'2022-03-03 13:27:36','2022-03-03 13:27:36'),(114558,381,'Bakarwala','135021',1,0,'2022-03-03 13:27:36','2022-03-03 13:27:36'),(114559,381,'Balachaur','135103',1,0,'2022-03-03 13:27:37','2022-03-03 13:27:37'),(114560,381,'Balchhapar','135003',1,0,'2022-03-03 13:27:37','2022-03-03 13:27:37'),(114561,381,'Banidi','135133',1,0,'2022-03-03 13:27:37','2022-03-03 13:27:37'),(114562,381,'Bapa','135133',1,0,'2022-03-03 13:27:37','2022-03-03 13:27:37'),(114563,381,'Barsan','135133',1,0,'2022-03-03 13:27:37','2022-03-03 13:27:37'),(114564,381,'Basatianwala','135102',1,0,'2022-03-03 13:27:37','2022-03-03 13:27:37'),(114565,381,'Bhagu Majra','135133',1,0,'2022-03-03 13:27:37','2022-03-03 13:27:37'),(114566,381,'Bhambol','133103',1,0,'2022-03-03 13:27:37','2022-03-03 13:27:37'),(114567,381,'Bhatia Nagar','135001',1,0,'2022-03-03 13:27:37','2022-03-03 13:27:37'),(114568,381,'Bherthal','135003',1,0,'2022-03-03 13:27:37','2022-03-03 13:27:37'),(114569,381,'Bhudkalan','135106',1,0,'2022-03-03 13:27:37','2022-03-03 13:27:37'),(114570,381,'Bilaspur (Yamunanagar)','135102',1,0,'2022-03-03 13:27:37','2022-03-03 13:27:37'),(114571,381,'Bilauli','135103',1,0,'2022-03-03 13:27:37','2022-03-03 13:27:37'),(114572,381,'Binjalpur','133206',1,0,'2022-03-03 13:27:37','2022-03-03 13:27:37'),(114573,381,'Bubka','135133',1,0,'2022-03-03 13:27:37','2022-03-03 13:27:37'),(114574,381,'Buriya','135101',1,0,'2022-03-03 13:27:37','2022-03-03 13:27:37'),(114575,381,'Cagnoli','135102',1,0,'2022-03-03 13:27:37','2022-03-03 13:27:37'),(114576,381,'Chamrori','135133',1,0,'2022-03-03 13:27:37','2022-03-03 13:27:37'),(114577,381,'Chauli','135102',1,0,'2022-03-03 13:27:37','2022-03-03 13:27:37'),(114578,381,'Chhachrauli','135103',1,0,'2022-03-03 13:27:37','2022-03-03 13:27:37'),(114579,381,'Chhappar','133103',1,0,'2022-03-03 13:27:37','2022-03-03 13:27:37'),(114580,381,'Dadupur','135003',1,0,'2022-03-03 13:27:38','2022-03-03 13:27:38'),(114581,381,'Damla','135002',1,0,'2022-03-03 13:27:38','2022-03-03 13:27:38'),(114582,381,'Darpur','135103',1,0,'2022-03-03 13:27:38','2022-03-03 13:27:38'),(114583,381,'Dayalgarh','135102',1,0,'2022-03-03 13:27:38','2022-03-03 13:27:38'),(114584,381,'Deodhar','135021',1,0,'2022-03-03 13:27:38','2022-03-03 13:27:38'),(114585,381,'Fatehgarh Tumbi','133206',1,0,'2022-03-03 13:27:38','2022-03-03 13:27:38'),(114586,381,'Fatehpur','135101',1,0,'2022-03-03 13:27:38','2022-03-03 13:27:38'),(114587,381,'Gadhaula','133103',1,0,'2022-03-03 13:27:38','2022-03-03 13:27:38'),(114588,381,'Ghillaur','135133',1,0,'2022-03-03 13:27:38','2022-03-03 13:27:38'),(114589,381,'Gudhiana','133103',1,0,'2022-03-03 13:27:38','2022-03-03 13:27:38'),(114590,381,'Gumthala Rao','135133',1,0,'2022-03-03 13:27:38','2022-03-03 13:27:38'),(114591,381,'Guru Gobind Singh Complex','135001',1,0,'2022-03-03 13:27:38','2022-03-03 13:27:38'),(114592,381,'Hafizpur','135002',1,0,'2022-03-03 13:27:38','2022-03-03 13:27:38'),(114593,381,'Haibatpur','133206',1,0,'2022-03-03 13:27:38','2022-03-03 13:27:38'),(114594,381,'Hangoli','133103',1,0,'2022-03-03 13:27:38','2022-03-03 13:27:38'),(114595,381,'Harnaul','135002',1,0,'2022-03-03 13:27:38','2022-03-03 13:27:38'),(114596,381,'Hartan','135133',1,0,'2022-03-03 13:27:38','2022-03-03 13:27:38'),(114597,381,'Haveli','133204',1,0,'2022-03-03 13:27:38','2022-03-03 13:27:38'),(114598,381,'Jagadhri Court','135003',1,0,'2022-03-03 13:27:38','2022-03-03 13:27:38'),(114599,381,'Jagadhri','135003',1,0,'2022-03-03 13:27:38','2022-03-03 13:27:38'),(114600,381,'Jagadhri Town','135003',1,0,'2022-03-03 13:27:38','2022-03-03 13:27:38'),(114601,381,'Jagdhari Work Shop','135002',1,0,'2022-03-03 13:27:38','2022-03-03 13:27:38'),(114602,381,'Jagdholi','133103',1,0,'2022-03-03 13:27:38','2022-03-03 13:27:38'),(114603,381,'Jaidhari','135101',1,0,'2022-03-03 13:27:38','2022-03-03 13:27:38'),(114604,381,'Jathlana','135133',1,0,'2022-03-03 13:27:39','2022-03-03 13:27:39'),(114605,381,'Jroda','135003',1,0,'2022-03-03 13:27:39','2022-03-03 13:27:39'),(114606,381,'Jubbal','135133',1,0,'2022-03-03 13:27:39','2022-03-03 13:27:39'),(114607,381,'Kalanaur','135004',1,0,'2022-03-03 13:27:39','2022-03-03 13:27:39'),(114608,381,'Kalawar','133103',1,0,'2022-03-03 13:27:39','2022-03-03 13:27:39'),(114609,381,'Kalesar','135106',1,0,'2022-03-03 13:27:39','2022-03-03 13:27:39'),(114610,381,'Kandhari Kalan','133103',1,0,'2022-03-03 13:27:39','2022-03-03 13:27:39'),(114611,381,'Khadri','135101',1,0,'2022-03-03 13:27:39','2022-03-03 13:27:39'),(114612,381,'Kharwan','135003',1,0,'2022-03-03 13:27:39','2022-03-03 13:27:39'),(114613,381,'Khera','135003',1,0,'2022-03-03 13:27:39','2022-03-03 13:27:39'),(114614,381,'Khera Khurd','135004',1,0,'2022-03-03 13:27:39','2022-03-03 13:27:39'),(114615,381,'Khirzrabad  East','135021',1,0,'2022-03-03 13:27:39','2022-03-03 13:27:39'),(114616,381,'Khurdban','135133',1,0,'2022-03-03 13:27:39','2022-03-03 13:27:39'),(114617,381,'Kopal Mochan','135102',1,0,'2022-03-03 13:27:39','2022-03-03 13:27:39'),(114618,381,'Kot Kalsia','135103',1,0,'2022-03-03 13:27:39','2022-03-03 13:27:39'),(114619,381,'Laharpur','133204',1,0,'2022-03-03 13:27:39','2022-03-03 13:27:39'),(114620,381,'Lalheri Kalan','135103',1,0,'2022-03-03 13:27:39','2022-03-03 13:27:39'),(114621,381,'Ledi','135103',1,0,'2022-03-03 13:27:39','2022-03-03 13:27:39'),(114622,381,'Machrauli','135102',1,0,'2022-03-03 13:27:40','2022-03-03 13:27:40'),(114623,381,'Malikpur Khadar','135106',1,0,'2022-03-03 13:27:40','2022-03-03 13:27:40'),(114624,381,'Mandhar','135003',1,0,'2022-03-03 13:27:40','2022-03-03 13:27:40'),(114625,381,'Mandhar','135133',1,0,'2022-03-03 13:27:40','2022-03-03 13:27:40'),(114626,381,'Manglore','135102',1,0,'2022-03-03 13:27:40','2022-03-03 13:27:40'),(114627,381,'Marwa Kalan','135102',1,0,'2022-03-03 13:27:40','2022-03-03 13:27:40'),(114628,381,'Marwa Khurd','135102',1,0,'2022-03-03 13:27:40','2022-03-03 13:27:40'),(114629,381,'Mehar Majra','135101',1,0,'2022-03-03 13:27:40','2022-03-03 13:27:40'),(114630,381,'Mehlanwali','135003',1,0,'2022-03-03 13:27:40','2022-03-03 13:27:40'),(114631,381,'Mehmoodpur','133204',1,0,'2022-03-03 13:27:40','2022-03-03 13:27:40'),(114632,381,'Milakpur Banger','135102',1,0,'2022-03-03 13:27:40','2022-03-03 13:27:40'),(114633,381,'Model Town (Yamuna Nagar)','135001',1,0,'2022-03-03 13:27:40','2022-03-03 13:27:40'),(114634,381,'Mud Hut Colony','135001',1,0,'2022-03-03 13:27:40','2022-03-03 13:27:40'),(114635,381,'Mughalwali','135102',1,0,'2022-03-03 13:27:40','2022-03-03 13:27:40'),(114636,381,'Mussimbal','135003',1,0,'2022-03-03 13:27:40','2022-03-03 13:27:40'),(114637,381,'Mustafabad (Yamuna Nagar)','133103',1,0,'2022-03-03 13:27:40','2022-03-03 13:27:40'),(114638,381,'Muzafatkalan','135021',1,0,'2022-03-03 13:27:40','2022-03-03 13:27:40'),(114639,381,'Nachron','135133',1,0,'2022-03-03 13:27:40','2022-03-03 13:27:40'),(114640,381,'Nagal Khajuri','135004',1,0,'2022-03-03 13:27:40','2022-03-03 13:27:40'),(114641,381,'Nahar Pur','135004',1,0,'2022-03-03 13:27:40','2022-03-03 13:27:40'),(114642,381,'Noshera','133204',1,0,'2022-03-03 13:27:40','2022-03-03 13:27:40'),(114643,381,'Pabni Kalan','135003',1,0,'2022-03-03 13:27:41','2022-03-03 13:27:41'),(114644,381,'Pansra','135004',1,0,'2022-03-03 13:27:41','2022-03-03 13:27:41'),(114645,381,'Parkash Chowk','135003',1,0,'2022-03-03 13:27:41','2022-03-03 13:27:41'),(114646,381,'Pipli Majra','135106',1,0,'2022-03-03 13:27:41','2022-03-03 13:27:41'),(114647,381,'Pipliwala','133204',1,0,'2022-03-03 13:27:41','2022-03-03 13:27:41'),(114648,381,'Radaur','135133',1,0,'2022-03-03 13:27:41','2022-03-03 13:27:41'),(114649,381,'Ram Pura Olony','135001',1,0,'2022-03-03 13:27:41','2022-03-03 13:27:41'),(114650,381,'Rampur Khadar','135101',1,0,'2022-03-03 13:27:41','2022-03-03 13:27:41'),(114651,381,'Rasulpur','133204',1,0,'2022-03-03 13:27:41','2022-03-03 13:27:41'),(114652,381,'Sabapur','135101',1,0,'2022-03-03 13:27:41','2022-03-03 13:27:41'),(114653,381,'Sadhaura','133204',1,0,'2022-03-03 13:27:41','2022-03-03 13:27:41'),(114654,381,'Sadiqpur','133204',1,0,'2022-03-03 13:27:41','2022-03-03 13:27:41'),(114655,381,'Safilpur','133204',1,0,'2022-03-03 13:27:41','2022-03-03 13:27:41'),(114656,381,'Sahela','133206',1,0,'2022-03-03 13:27:41','2022-03-03 13:27:41'),(114657,381,'Salehpur','133204',1,0,'2022-03-03 13:27:41','2022-03-03 13:27:41'),(114658,381,'Salimpur Banger','135103',1,0,'2022-03-03 13:27:41','2022-03-03 13:27:41'),(114659,381,'Sankhera','135102',1,0,'2022-03-03 13:27:41','2022-03-03 13:27:41'),(114660,381,'Sarawan','133206',1,0,'2022-03-03 13:27:41','2022-03-03 13:27:41'),(114661,381,'Sardaheri','133206',1,0,'2022-03-03 13:27:41','2022-03-03 13:27:41'),(114662,381,'Shadi Pur','135004',1,0,'2022-03-03 13:27:41','2022-03-03 13:27:41'),(114663,381,'Shahpur Nurd','133206',1,0,'2022-03-03 13:27:41','2022-03-03 13:27:41'),(114664,381,'Sherpur Sulkhani','133206',1,0,'2022-03-03 13:27:41','2022-03-03 13:27:41'),(114665,381,'Silikalan','135133',1,0,'2022-03-03 13:27:42','2022-03-03 13:27:42'),(114666,381,'Sugar Mill','135001',1,0,'2022-03-03 13:27:42','2022-03-03 13:27:42'),(114667,381,'Taharpurkalan','135103',1,0,'2022-03-03 13:27:42','2022-03-03 13:27:42'),(114668,381,'Tajewala','135106',1,0,'2022-03-03 13:27:42','2022-03-03 13:27:42'),(114669,381,'Talakaur','133103',1,0,'2022-03-03 13:27:42','2022-03-03 13:27:42'),(114670,381,'Thermal Colony Yamuna Nagar','135004',1,0,'2022-03-03 13:27:42','2022-03-03 13:27:42'),(114671,381,'Topra Kalan','135133',1,0,'2022-03-03 13:27:42','2022-03-03 13:27:42'),(114672,381,'Udhamgarh','135003',1,0,'2022-03-03 13:27:42','2022-03-03 13:27:42'),(114673,381,'Uncha Chandna','133103',1,0,'2022-03-03 13:27:42','2022-03-03 13:27:42'),(114674,381,'Yamuna Nagar Railway Station','135001',1,0,'2022-03-03 13:27:42','2022-03-03 13:27:42'),(114675,381,'Yamunanagar H.O','135001',1,0,'2022-03-03 13:27:42','2022-03-03 13:27:42'),(114676,381,'Zaffarpur','133206',1,0,'2022-03-03 13:27:42','2022-03-03 13:27:42'),(114677,382,'Khabli','177114',1,0,'2022-03-03 13:27:42','2022-03-03 13:27:42'),(114678,382,'Amarpur','174021',1,0,'2022-03-03 13:27:42','2022-03-03 13:27:42'),(114679,382,'Auhar','174024',1,0,'2022-03-03 13:27:42','2022-03-03 13:27:42'),(114680,382,'Badaghat','174029',1,0,'2022-03-03 13:27:42','2022-03-03 13:27:42'),(114681,382,'Balghar','174031',1,0,'2022-03-03 13:27:42','2022-03-03 13:27:42'),(114682,382,'Balh Churani','174003',1,0,'2022-03-03 13:27:42','2022-03-03 13:27:42'),(114683,382,'Baloh','174029',1,0,'2022-03-03 13:27:42','2022-03-03 13:27:42'),(114684,382,'Bamta','174001',1,0,'2022-03-03 13:27:42','2022-03-03 13:27:42'),(114685,382,'Bandla','174001',1,0,'2022-03-03 13:27:42','2022-03-03 13:27:42'),(114686,382,'Baragoan','174029',1,0,'2022-03-03 13:27:42','2022-03-03 13:27:42'),(114687,382,'Bararhin','174003',1,0,'2022-03-03 13:27:42','2022-03-03 13:27:42'),(114688,382,'Bari Majherwin','174021',1,0,'2022-03-03 13:27:42','2022-03-03 13:27:42'),(114689,382,'Barmana','174013',1,0,'2022-03-03 13:27:43','2022-03-03 13:27:43'),(114690,382,'Barota','174027',1,0,'2022-03-03 13:27:43','2022-03-03 13:27:43'),(114691,382,'Bassi Kehloor','174002',1,0,'2022-03-03 13:27:43','2022-03-03 13:27:43'),(114692,382,'Bauhat Kasol','174012',1,0,'2022-03-03 13:27:43','2022-03-03 13:27:43'),(114693,382,'Behal','174015',1,0,'2022-03-03 13:27:43','2022-03-03 13:27:43'),(114694,382,'Behna Jattan','174001',1,0,'2022-03-03 13:27:43','2022-03-03 13:27:43'),(114695,382,'Beri Razadian','174001',1,0,'2022-03-03 13:27:43','2022-03-03 13:27:43'),(114696,382,'Berthin','174029',1,0,'2022-03-03 13:27:43','2022-03-03 13:27:43'),(114697,382,'Bhager','174021',1,0,'2022-03-03 13:27:43','2022-03-03 13:27:43'),(114698,382,'Bhakra','174201',1,0,'2022-03-03 13:27:43','2022-03-03 13:27:43'),(114699,382,'Bhakra Dam','174201',1,0,'2022-03-03 13:27:43','2022-03-03 13:27:43'),(114700,382,'Bhapral','174027',1,0,'2022-03-03 13:27:43','2022-03-03 13:27:43'),(114701,382,'Bharoli Kalan','174035',1,0,'2022-03-03 13:27:43','2022-03-03 13:27:43'),(114702,382,'Bhater Nichli','174004',1,0,'2022-03-03 13:27:43','2022-03-03 13:27:43'),(114703,382,'Bhatwara','174028',1,0,'2022-03-03 13:27:43','2022-03-03 13:27:43'),(114704,382,'Bhulswai','174026',1,0,'2022-03-03 13:27:43','2022-03-03 13:27:43'),(114705,382,'Bilaspur (Bilaspur- HP) H.O','174001',1,0,'2022-03-03 13:27:43','2022-03-03 13:27:43'),(114706,382,'Bilaspur Kty','174001',1,0,'2022-03-03 13:27:43','2022-03-03 13:27:43'),(114707,382,'Binola','174001',1,0,'2022-03-03 13:27:43','2022-03-03 13:27:43'),(114708,382,'Brahampukhar','174001',1,0,'2022-03-03 13:27:44','2022-03-03 13:27:44'),(114709,382,'Chalehli','174003',1,0,'2022-03-03 13:27:44','2022-03-03 13:27:44'),(114710,382,'Chandpur','174004',1,0,'2022-03-03 13:27:44','2022-03-03 13:27:44'),(114711,382,'Chhakoh','174001',1,0,'2022-03-03 13:27:44','2022-03-03 13:27:44'),(114712,382,'Chharol','174001',1,0,'2022-03-03 13:27:44','2022-03-03 13:27:44'),(114713,382,'Chhat','174029',1,0,'2022-03-03 13:27:44','2022-03-03 13:27:44'),(114714,382,'Dabla','174021',1,0,'2022-03-03 13:27:44','2022-03-03 13:27:44'),(114715,382,'Dadhol','174023',1,0,'2022-03-03 13:27:44','2022-03-03 13:27:44'),(114716,382,'Dagsech','174032',1,0,'2022-03-03 13:27:44','2022-03-03 13:27:44'),(114717,382,'Dahad','174034',1,0,'2022-03-03 13:27:44','2022-03-03 13:27:44'),(114718,382,'Dangar','174023',1,0,'2022-03-03 13:27:44','2022-03-03 13:27:44'),(114719,382,'Daslehra','174030',1,0,'2022-03-03 13:27:44','2022-03-03 13:27:44'),(114720,382,'Deoli','174001',1,0,'2022-03-03 13:27:44','2022-03-03 13:27:44'),(114721,382,'Deoth','174001',1,0,'2022-03-03 13:27:44','2022-03-03 13:27:44'),(114722,382,'Dhaloh','174029',1,0,'2022-03-03 13:27:44','2022-03-03 13:27:44'),(114723,382,'Dhani Pukher','174017',1,0,'2022-03-03 13:27:44','2022-03-03 13:27:44'),(114724,382,'Dhoun Kothi','174012',1,0,'2022-03-03 13:27:44','2022-03-03 13:27:44'),(114725,382,'Dobha','174001',1,0,'2022-03-03 13:27:44','2022-03-03 13:27:44'),(114726,382,'Domehar','174027',1,0,'2022-03-03 13:27:44','2022-03-03 13:27:44'),(114727,382,'Gahar','174027',1,0,'2022-03-03 13:27:44','2022-03-03 13:27:44'),(114728,382,'Gandhalwin','174027',1,0,'2022-03-03 13:27:44','2022-03-03 13:27:44'),(114729,382,'Gangloh','174030',1,0,'2022-03-03 13:27:44','2022-03-03 13:27:44'),(114730,382,'Gawalthi','174201',1,0,'2022-03-03 13:27:44','2022-03-03 13:27:44'),(114731,382,'Geharwin','174034',1,0,'2022-03-03 13:27:45','2022-03-03 13:27:45'),(114732,382,'Ghandhir','174029',1,0,'2022-03-03 13:27:45','2022-03-03 13:27:45'),(114733,382,'Gharan','174030',1,0,'2022-03-03 13:27:45','2022-03-03 13:27:45'),(114734,382,'Ghumarwin','174021',1,0,'2022-03-03 13:27:45','2022-03-03 13:27:45'),(114735,382,'Harlog','174003',1,0,'2022-03-03 13:27:45','2022-03-03 13:27:45'),(114736,382,'Harnora','174013',1,0,'2022-03-03 13:27:45','2022-03-03 13:27:45'),(114737,382,'Hatwar','174028',1,0,'2022-03-03 13:27:45','2022-03-03 13:27:45'),(114738,382,'Hawan','174026',1,0,'2022-03-03 13:27:45','2022-03-03 13:27:45'),(114739,382,'Jabloo','174034',1,0,'2022-03-03 13:27:45','2022-03-03 13:27:45'),(114740,382,'Jaddu','174030',1,0,'2022-03-03 13:27:45','2022-03-03 13:27:45'),(114741,382,'Jamli','174011',1,0,'2022-03-03 13:27:45','2022-03-03 13:27:45'),(114742,382,'Janali','174310',1,0,'2022-03-03 13:27:45','2022-03-03 13:27:45'),(114743,382,'Jejwin','174017',1,0,'2022-03-03 13:27:45','2022-03-03 13:27:45'),(114744,382,'Jhabola','174030',1,0,'2022-03-03 13:27:45','2022-03-03 13:27:45'),(114745,382,'Jhandutta','174031',1,0,'2022-03-03 13:27:45','2022-03-03 13:27:45'),(114746,382,'Jukhala','174033',1,0,'2022-03-03 13:27:45','2022-03-03 13:27:45'),(114747,382,'Kallar','174001',1,0,'2022-03-03 13:27:45','2022-03-03 13:27:45'),(114748,382,'Kalol (Bilaspur (HP)))','174035',1,0,'2022-03-03 13:27:45','2022-03-03 13:27:45'),(114749,382,'Kandraur','174004',1,0,'2022-03-03 13:27:45','2022-03-03 13:27:45'),(114750,382,'Kanphara','174201',1,0,'2022-03-03 13:27:45','2022-03-03 13:27:45'),(114751,382,'Kaphara','174029',1,0,'2022-03-03 13:27:45','2022-03-03 13:27:45'),(114752,382,'Karloti','174029',1,0,'2022-03-03 13:27:45','2022-03-03 13:27:45'),(114753,382,'Kaulan Wala Toba','174002',1,0,'2022-03-03 13:27:46','2022-03-03 13:27:46'),(114754,382,'Koserian','174030',1,0,'2022-03-03 13:27:46','2022-03-03 13:27:46'),(114755,382,'Kot','174028',1,0,'2022-03-03 13:27:46','2022-03-03 13:27:46'),(114756,382,'Kothi','174021',1,0,'2022-03-03 13:27:46','2022-03-03 13:27:46'),(114757,382,'Kothipura','174001',1,0,'2022-03-03 13:27:46','2022-03-03 13:27:46'),(114758,382,'Kotlu Brahmana','174029',1,0,'2022-03-03 13:27:46','2022-03-03 13:27:46'),(114759,382,'Kutehla','174011',1,0,'2022-03-03 13:27:46','2022-03-03 13:27:46'),(114760,382,'Kuthera BLP','174026',1,0,'2022-03-03 13:27:46','2022-03-03 13:27:46'),(114761,382,'Ladda','174026',1,0,'2022-03-03 13:27:46','2022-03-03 13:27:46'),(114762,382,'Lakhanpur','174001',1,0,'2022-03-03 13:27:46','2022-03-03 13:27:46'),(114763,382,'Lakhnoo','174015',1,0,'2022-03-03 13:27:46','2022-03-03 13:27:46'),(114764,382,'Lanjta','174027',1,0,'2022-03-03 13:27:46','2022-03-03 13:27:46'),(114765,382,'Lehri','174002',1,0,'2022-03-03 13:27:46','2022-03-03 13:27:46'),(114766,382,'Lehri Sarail','174027',1,0,'2022-03-03 13:27:46','2022-03-03 13:27:46'),(114767,382,'Loharwin','174021',1,0,'2022-03-03 13:27:46','2022-03-03 13:27:46'),(114768,382,'Majhwar','174003',1,0,'2022-03-03 13:27:46','2022-03-03 13:27:46'),(114769,382,'Majri','174002',1,0,'2022-03-03 13:27:46','2022-03-03 13:27:46'),(114770,382,'Makri','174201',1,0,'2022-03-03 13:27:46','2022-03-03 13:27:46'),(114771,382,'Makri','174033',1,0,'2022-03-03 13:27:46','2022-03-03 13:27:46'),(114772,382,'Malagan','174029',1,0,'2022-03-03 13:27:46','2022-03-03 13:27:46'),(114773,382,'Malhot','174017',1,0,'2022-03-03 13:27:46','2022-03-03 13:27:46'),(114774,382,'Malraon','174035',1,0,'2022-03-03 13:27:47','2022-03-03 13:27:47'),(114775,382,'Malyaur','174004',1,0,'2022-03-03 13:27:47','2022-03-03 13:27:47'),(114776,382,'Marhana','174028',1,0,'2022-03-03 13:27:47','2022-03-03 13:27:47'),(114777,382,'Marotan','174017',1,0,'2022-03-03 13:27:47','2022-03-03 13:27:47'),(114778,382,'Massour','174026',1,0,'2022-03-03 13:27:47','2022-03-03 13:27:47'),(114779,382,'Matla','174034',1,0,'2022-03-03 13:27:47','2022-03-03 13:27:47'),(114780,382,'Morsinghi','174026',1,0,'2022-03-03 13:27:47','2022-03-03 13:27:47'),(114781,382,'Naghiar','174030',1,0,'2022-03-03 13:27:47','2022-03-03 13:27:47'),(114782,382,'Naina Devi','174310',1,0,'2022-03-03 13:27:47','2022-03-03 13:27:47'),(114783,382,'Nakrana','174310',1,0,'2022-03-03 13:27:47','2022-03-03 13:27:47'),(114784,382,'Nalti','174026',1,0,'2022-03-03 13:27:47','2022-03-03 13:27:47'),(114785,382,'Namhol','174032',1,0,'2022-03-03 13:27:47','2022-03-03 13:27:47'),(114786,382,'Nanawan','174013',1,0,'2022-03-03 13:27:47','2022-03-03 13:27:47'),(114787,382,'Naswal','174021',1,0,'2022-03-03 13:27:47','2022-03-03 13:27:47'),(114788,382,'New Bilaspur Town Ship','174001',1,0,'2022-03-03 13:27:47','2022-03-03 13:27:47'),(114789,382,'Noa','174001',1,0,'2022-03-03 13:27:47','2022-03-03 13:27:47'),(114790,382,'NTPC Jamthal','174036',1,0,'2022-03-03 13:27:47','2022-03-03 13:27:47'),(114791,382,'Panjgain','174012',1,0,'2022-03-03 13:27:47','2022-03-03 13:27:47'),(114792,382,'Panoh','174004',1,0,'2022-03-03 13:27:47','2022-03-03 13:27:47'),(114793,382,'Pantehra','174028',1,0,'2022-03-03 13:27:47','2022-03-03 13:27:47'),(114794,382,'Paploa','174017',1,0,'2022-03-03 13:27:48','2022-03-03 13:27:48'),(114795,382,'Raghunath Pura','174005',1,0,'2022-03-03 13:27:48','2022-03-03 13:27:48'),(114796,382,'Rani Kotla','174033',1,0,'2022-03-03 13:27:48','2022-03-03 13:27:48'),(114797,382,'Raura Sector Bilaspur','174001',1,0,'2022-03-03 13:27:48','2022-03-03 13:27:48'),(114798,382,'Rishikesh','174001',1,0,'2022-03-03 13:27:48','2022-03-03 13:27:48'),(114799,382,'Rohal','174031',1,0,'2022-03-03 13:27:48','2022-03-03 13:27:48'),(114800,382,'Rohin','174004',1,0,'2022-03-03 13:27:48','2022-03-03 13:27:48'),(114801,382,'Sai Kharsi','174001',1,0,'2022-03-03 13:27:48','2022-03-03 13:27:48'),(114802,382,'Salaon','174028',1,0,'2022-03-03 13:27:48','2022-03-03 13:27:48'),(114803,382,'Salnoo','174013',1,0,'2022-03-03 13:27:48','2022-03-03 13:27:48'),(114804,382,'Saloa','174201',1,0,'2022-03-03 13:27:48','2022-03-03 13:27:48'),(114805,382,'Samoh','174021',1,0,'2022-03-03 13:27:48','2022-03-03 13:27:48'),(114806,382,'Ser','174031',1,0,'2022-03-03 13:27:48','2022-03-03 13:27:48'),(114807,382,'Sikroha','174032',1,0,'2022-03-03 13:27:48','2022-03-03 13:27:48'),(114808,382,'Soldha','174032',1,0,'2022-03-03 13:27:48','2022-03-03 13:27:48'),(114809,382,'Suin Surhar','174033',1,0,'2022-03-03 13:27:48','2022-03-03 13:27:48'),(114810,382,'Sunhani','174029',1,0,'2022-03-03 13:27:48','2022-03-03 13:27:48'),(114811,382,'Swahan','174310',1,0,'2022-03-03 13:27:48','2022-03-03 13:27:48'),(114812,382,'Swarghat','174011',1,0,'2022-03-03 13:27:48','2022-03-03 13:27:48'),(114813,382,'Takrera','174021',1,0,'2022-03-03 13:27:48','2022-03-03 13:27:48'),(114814,382,'Tallai','174030',1,0,'2022-03-03 13:27:48','2022-03-03 13:27:48'),(114815,382,'Talwara','174026',1,0,'2022-03-03 13:27:48','2022-03-03 13:27:48'),(114816,382,'Talyana','174026',1,0,'2022-03-03 13:27:48','2022-03-03 13:27:48'),(114817,382,'Tanbol','174011',1,0,'2022-03-03 13:27:49','2022-03-03 13:27:49'),(114818,382,'Tantha','174003',1,0,'2022-03-03 13:27:49','2022-03-03 13:27:49'),(114819,382,'Taroun','174027',1,0,'2022-03-03 13:27:49','2022-03-03 13:27:49'),(114820,382,'Tarsooh','174201',1,0,'2022-03-03 13:27:49','2022-03-03 13:27:49'),(114821,382,'Tatoh','174001',1,0,'2022-03-03 13:27:49','2022-03-03 13:27:49'),(114822,382,'Thuran','174034',1,0,'2022-03-03 13:27:49','2022-03-03 13:27:49'),(114823,382,'Zakatkhana','174011',1,0,'2022-03-03 13:27:49','2022-03-03 13:27:49'),(114824,383,'Ail','176316',1,0,'2022-03-03 13:27:49','2022-03-03 13:27:49'),(114825,383,'Athedgwalu','176312',1,0,'2022-03-03 13:27:49','2022-03-03 13:27:49'),(114826,383,'Awan','176313',1,0,'2022-03-03 13:27:49','2022-03-03 13:27:49'),(114827,383,'Baat','176314',1,0,'2022-03-03 13:27:49','2022-03-03 13:27:49'),(114828,383,'Badgram','176324',1,0,'2022-03-03 13:27:49','2022-03-03 13:27:49'),(114829,383,'Badka','176312',1,0,'2022-03-03 13:27:49','2022-03-03 13:27:49'),(114830,383,'Bagdhar','176303',1,0,'2022-03-03 13:27:49','2022-03-03 13:27:49'),(114831,383,'Baggi Kanged','176325',1,0,'2022-03-03 13:27:49','2022-03-03 13:27:49'),(114832,383,'Bailly','176303',1,0,'2022-03-03 13:27:49','2022-03-03 13:27:49'),(114833,383,'Bairagarh','176316',1,0,'2022-03-03 13:27:49','2022-03-03 13:27:49'),(114834,383,'Bajoul','176309',1,0,'2022-03-03 13:27:49','2022-03-03 13:27:49'),(114835,383,'Bakani','176311',1,0,'2022-03-03 13:27:49','2022-03-03 13:27:49'),(114836,383,'Bakloh','176301',1,0,'2022-03-03 13:27:50','2022-03-03 13:27:50'),(114837,383,'Balera','176301',1,0,'2022-03-03 13:27:50','2022-03-03 13:27:50'),(114838,383,'Banatar','176321',1,0,'2022-03-03 13:27:50','2022-03-03 13:27:50'),(114839,383,'Bandla','176311',1,0,'2022-03-03 13:27:50','2022-03-03 13:27:50'),(114840,383,'Banet','176302',1,0,'2022-03-03 13:27:50','2022-03-03 13:27:50'),(114841,383,'Banikhet','176303',1,0,'2022-03-03 13:27:50','2022-03-03 13:27:50'),(114842,383,'Barour','176314',1,0,'2022-03-03 13:27:50','2022-03-03 13:27:50'),(114843,383,'Basodhan','176314',1,0,'2022-03-03 13:27:50','2022-03-03 13:27:50'),(114844,383,'Bathri-bazar','176306',1,0,'2022-03-03 13:27:50','2022-03-03 13:27:50'),(114845,383,'Bhadian','176318',1,0,'2022-03-03 13:27:50','2022-03-03 13:27:50'),(114846,383,'Bhagaigarh','176321',1,0,'2022-03-03 13:27:50','2022-03-03 13:27:50'),(114847,383,'Bhajotra','176312',1,0,'2022-03-03 13:27:50','2022-03-03 13:27:50'),(114848,383,'Bhalei','176308',1,0,'2022-03-03 13:27:50','2022-03-03 13:27:50'),(114849,383,'Bhandal','176320',1,0,'2022-03-03 13:27:50','2022-03-03 13:27:50'),(114850,383,'Bhanjraru-Tissa','176316',1,0,'2022-03-03 13:27:50','2022-03-03 13:27:50'),(114851,383,'Bhanota Salga','176314',1,0,'2022-03-03 13:27:50','2022-03-03 13:27:50'),(114852,383,'Bharari','176309',1,0,'2022-03-03 13:27:50','2022-03-03 13:27:50'),(114853,383,'Bharari','176301',1,0,'2022-03-03 13:27:50','2022-03-03 13:27:50'),(114854,383,'Bharella','176321',1,0,'2022-03-03 13:27:50','2022-03-03 13:27:50'),(114855,383,'Bharmour','176315',1,0,'2022-03-03 13:27:51','2022-03-03 13:27:51'),(114856,383,'Bhodas Mangli','176316',1,0,'2022-03-03 13:27:51','2022-03-03 13:27:51'),(114857,383,'Bhunad','176325',1,0,'2022-03-03 13:27:51','2022-03-03 13:27:51'),(114858,383,'Bilana','176207',1,0,'2022-03-03 13:27:51','2022-03-03 13:27:51'),(114859,383,'Bistholuj','176323',1,0,'2022-03-03 13:27:51','2022-03-03 13:27:51'),(114860,383,'Bonderi','176316',1,0,'2022-03-03 13:27:51','2022-03-03 13:27:51'),(114861,383,'Brehi','176324',1,0,'2022-03-03 13:27:51','2022-03-03 13:27:51'),(114862,383,'Chakloo','176318',1,0,'2022-03-03 13:27:51','2022-03-03 13:27:51'),(114863,383,'Chamba H.O','176310',1,0,'2022-03-03 13:27:51','2022-03-03 13:27:51'),(114864,383,'Chandilarog','176312',1,0,'2022-03-03 13:27:51','2022-03-03 13:27:51'),(114865,383,'Chanhouta','176309',1,0,'2022-03-03 13:27:51','2022-03-03 13:27:51'),(114866,383,'Chanju','176321',1,0,'2022-03-03 13:27:51','2022-03-03 13:27:51'),(114867,383,'Charda','176321',1,0,'2022-03-03 13:27:51','2022-03-03 13:27:51'),(114868,383,'Charori','176319',1,0,'2022-03-03 13:27:51','2022-03-03 13:27:51'),(114869,383,'Chhatrari','176324',1,0,'2022-03-03 13:27:51','2022-03-03 13:27:51'),(114870,383,'Chowari','176302',1,0,'2022-03-03 13:27:51','2022-03-03 13:27:51'),(114871,383,'Chuhan','176303',1,0,'2022-03-03 13:27:51','2022-03-03 13:27:51'),(114872,383,'Churi','176311',1,0,'2022-03-03 13:27:51','2022-03-03 13:27:51'),(114873,383,'Dalhousie Cantt','176305',1,0,'2022-03-03 13:27:51','2022-03-03 13:27:51'),(114874,383,'Dalhousie Court Road','176304',1,0,'2022-03-03 13:27:51','2022-03-03 13:27:51'),(114875,383,'Dalhousie','176304',1,0,'2022-03-03 13:27:51','2022-03-03 13:27:51'),(114876,383,'Dand','176320',1,0,'2022-03-03 13:27:52','2022-03-03 13:27:52'),(114877,383,'Darwin','176311',1,0,'2022-03-03 13:27:52','2022-03-03 13:27:52'),(114878,383,'Dehgram','176316',1,0,'2022-03-03 13:27:52','2022-03-03 13:27:52'),(114879,383,'Dehra','176321',1,0,'2022-03-03 13:27:52','2022-03-03 13:27:52'),(114880,383,'Deol','176309',1,0,'2022-03-03 13:27:52','2022-03-03 13:27:52'),(114881,383,'Deola','176321',1,0,'2022-03-03 13:27:52','2022-03-03 13:27:52'),(114882,383,'Devikothi','176316',1,0,'2022-03-03 13:27:52','2022-03-03 13:27:52'),(114883,383,'Dharun Banet','176207',1,0,'2022-03-03 13:27:52','2022-03-03 13:27:52'),(114884,383,'Dharwas','176323',1,0,'2022-03-03 13:27:52','2022-03-03 13:27:52'),(114885,383,'Dhullara','176207',1,0,'2022-03-03 13:27:52','2022-03-03 13:27:52'),(114886,383,'Dighai','176312',1,0,'2022-03-03 13:27:52','2022-03-03 13:27:52'),(114887,383,'Diur','176320',1,0,'2022-03-03 13:27:52','2022-03-03 13:27:52'),(114888,383,'Dradha','176306',1,0,'2022-03-03 13:27:52','2022-03-03 13:27:52'),(114889,383,'Drekari','176312',1,0,'2022-03-03 13:27:52','2022-03-03 13:27:52'),(114890,383,'Dugli','176319',1,0,'2022-03-03 13:27:52','2022-03-03 13:27:52'),(114891,383,'Durgathi','176324',1,0,'2022-03-03 13:27:52','2022-03-03 13:27:52'),(114892,383,'Gahar','176302',1,0,'2022-03-03 13:27:52','2022-03-03 13:27:52'),(114893,383,'Ganed','176316',1,0,'2022-03-03 13:27:52','2022-03-03 13:27:52'),(114894,383,'Gareema','176309',1,0,'2022-03-03 13:27:52','2022-03-03 13:27:52'),(114895,383,'Garnota','176207',1,0,'2022-03-03 13:27:52','2022-03-03 13:27:52'),(114896,383,'Garola','176309',1,0,'2022-03-03 13:27:52','2022-03-03 13:27:52'),(114897,383,'Gehra','176324',1,0,'2022-03-03 13:27:52','2022-03-03 13:27:52'),(114898,383,'Ghared','176315',1,0,'2022-03-03 13:27:53','2022-03-03 13:27:53'),(114899,383,'Ghatasni','176301',1,0,'2022-03-03 13:27:53','2022-03-03 13:27:53'),(114900,383,'Ghatasnipul','176302',1,0,'2022-03-03 13:27:53','2022-03-03 13:27:53'),(114901,383,'Ghulei','176316',1,0,'2022-03-03 13:27:53','2022-03-03 13:27:53'),(114902,383,'Gola','176207',1,0,'2022-03-03 13:27:53','2022-03-03 13:27:53'),(114903,383,'Goli','176306',1,0,'2022-03-03 13:27:53','2022-03-03 13:27:53'),(114904,383,'Hadsar','176315',1,0,'2022-03-03 13:27:53','2022-03-03 13:27:53'),(114905,383,'Hardaspura','176318',1,0,'2022-03-03 13:27:53','2022-03-03 13:27:53'),(114906,383,'Himgiri','176321',1,0,'2022-03-03 13:27:53','2022-03-03 13:27:53'),(114907,383,'Hobar','176313',1,0,'2022-03-03 13:27:53','2022-03-03 13:27:53'),(114908,383,'Holi','176309',1,0,'2022-03-03 13:27:53','2022-03-03 13:27:53'),(114909,383,'Jandrog','176302',1,0,'2022-03-03 13:27:53','2022-03-03 13:27:53'),(114910,383,'Janghi','176311',1,0,'2022-03-03 13:27:53','2022-03-03 13:27:53'),(114911,383,'Jassourgarh','176321',1,0,'2022-03-03 13:27:53','2022-03-03 13:27:53'),(114912,383,'Jatroon','176302',1,0,'2022-03-03 13:27:53','2022-03-03 13:27:53'),(114913,383,'Jhajjakothi','176316',1,0,'2022-03-03 13:27:53','2022-03-03 13:27:53'),(114914,383,'Jhullara','176319',1,0,'2022-03-03 13:27:53','2022-03-03 13:27:53'),(114915,383,'Jolna','176207',1,0,'2022-03-03 13:27:53','2022-03-03 13:27:53'),(114916,383,'Judera','176314',1,0,'2022-03-03 13:27:53','2022-03-03 13:27:53'),(114917,383,'Jungra','176316',1,0,'2022-03-03 13:27:53','2022-03-03 13:27:53'),(114918,383,'Kail','176301',1,0,'2022-03-03 13:27:54','2022-03-03 13:27:54'),(114919,383,'Kakira','176313',1,0,'2022-03-03 13:27:54','2022-03-03 13:27:54'),(114920,383,'Kakroti','176207',1,0,'2022-03-03 13:27:54','2022-03-03 13:27:54'),(114921,383,'Kalhel','176319',1,0,'2022-03-03 13:27:54','2022-03-03 13:27:54'),(114922,383,'Kandhwara','176321',1,0,'2022-03-03 13:27:54','2022-03-03 13:27:54'),(114923,383,'Kandla','176319',1,0,'2022-03-03 13:27:54','2022-03-03 13:27:54'),(114924,383,'Karel Punto','176323',1,0,'2022-03-03 13:27:54','2022-03-03 13:27:54'),(114925,383,'Karyas','176323',1,0,'2022-03-03 13:27:54','2022-03-03 13:27:54'),(114926,383,'Kathana','176318',1,0,'2022-03-03 13:27:54','2022-03-03 13:27:54'),(114927,383,'Kathla','176207',1,0,'2022-03-03 13:27:54','2022-03-03 13:27:54'),(114928,383,'Khajjiar','176314',1,0,'2022-03-03 13:27:54','2022-03-03 13:27:54'),(114929,383,'Khani','176309',1,0,'2022-03-03 13:27:54','2022-03-03 13:27:54'),(114930,383,'Khargata','176207',1,0,'2022-03-03 13:27:54','2022-03-03 13:27:54'),(114931,383,'Kharoti','176320',1,0,'2022-03-03 13:27:55','2022-03-03 13:27:55'),(114932,383,'Khundail','176311',1,0,'2022-03-03 13:27:55','2022-03-03 13:27:55'),(114933,383,'Khushnagari','176316',1,0,'2022-03-03 13:27:55','2022-03-03 13:27:55'),(114934,383,'Kiani','176318',1,0,'2022-03-03 13:27:55','2022-03-03 13:27:55'),(114935,383,'Kihar','176320',1,0,'2022-03-03 13:27:55','2022-03-03 13:27:55'),(114936,383,'Killar Pangi','176323',1,0,'2022-03-03 13:27:55','2022-03-03 13:27:55'),(114937,383,'Killod','176311',1,0,'2022-03-03 13:27:55','2022-03-03 13:27:55'),(114938,383,'Killor','176320',1,0,'2022-03-03 13:27:55','2022-03-03 13:27:55'),(114939,383,'Kirri','176314',1,0,'2022-03-03 13:27:55','2022-03-03 13:27:55'),(114940,383,'Kohal','176319',1,0,'2022-03-03 13:27:55','2022-03-03 13:27:55'),(114941,383,'Kohlari','176314',1,0,'2022-03-03 13:27:55','2022-03-03 13:27:55'),(114942,383,'Koonr','176324',1,0,'2022-03-03 13:27:55','2022-03-03 13:27:55'),(114943,383,'Kothi','176323',1,0,'2022-03-03 13:27:55','2022-03-03 13:27:55'),(114944,383,'Koti Prahanuie','176312',1,0,'2022-03-03 13:27:55','2022-03-03 13:27:55'),(114945,383,'Kuddi','176313',1,0,'2022-03-03 13:27:55','2022-03-03 13:27:55'),(114946,383,'Kugati','176315',1,0,'2022-03-03 13:27:55','2022-03-03 13:27:55'),(114947,383,'Kuleth','176309',1,0,'2022-03-03 13:27:55','2022-03-03 13:27:55'),(114948,383,'Kumar','176323',1,0,'2022-03-03 13:27:55','2022-03-03 13:27:55'),(114949,383,'Kuned','176311',1,0,'2022-03-03 13:27:55','2022-03-03 13:27:55'),(114950,383,'Kupara','176314',1,0,'2022-03-03 13:27:55','2022-03-03 13:27:55'),(114951,383,'Lahra','176321',1,0,'2022-03-03 13:27:56','2022-03-03 13:27:56'),(114952,383,'Lamu','176309',1,0,'2022-03-03 13:27:56','2022-03-03 13:27:56'),(114953,383,'Leswin','176321',1,0,'2022-03-03 13:27:56','2022-03-03 13:27:56'),(114954,383,'Ligga','176312',1,0,'2022-03-03 13:27:56','2022-03-03 13:27:56'),(114955,383,'Mail','176301',1,0,'2022-03-03 13:27:56','2022-03-03 13:27:56'),(114956,383,'Malunda','176302',1,0,'2022-03-03 13:27:56','2022-03-03 13:27:56'),(114957,383,'Mangla','176314',1,0,'2022-03-03 13:27:56','2022-03-03 13:27:56'),(114958,383,'Manhouta','176302',1,0,'2022-03-03 13:27:56','2022-03-03 13:27:56'),(114959,383,'Manjeer','176312',1,0,'2022-03-03 13:27:56','2022-03-03 13:27:56'),(114960,383,'Masroond','176319',1,0,'2022-03-03 13:27:56','2022-03-03 13:27:56'),(114961,383,'Matti','176308',1,0,'2022-03-03 13:27:56','2022-03-03 13:27:56'),(114962,383,'Mehla','176311',1,0,'2022-03-03 13:27:56','2022-03-03 13:27:56'),(114963,383,'Mindhal','176323',1,0,'2022-03-03 13:27:57','2022-03-03 13:27:57'),(114964,383,'Moda','176312',1,0,'2022-03-03 13:27:57','2022-03-03 13:27:57'),(114965,383,'Morthu','176207',1,0,'2022-03-03 13:27:57','2022-03-03 13:27:57'),(114966,383,'Nainikhad','176301',1,0,'2022-03-03 13:27:57','2022-03-03 13:27:57'),(114967,383,'Nakror','176321',1,0,'2022-03-03 13:27:57','2022-03-03 13:27:57'),(114968,383,'Naloh','176207',1,0,'2022-03-03 13:27:57','2022-03-03 13:27:57'),(114969,383,'Nayagram','176309',1,0,'2022-03-03 13:27:57','2022-03-03 13:27:57'),(114970,383,'Ohra','176308',1,0,'2022-03-03 13:27:57','2022-03-03 13:27:57'),(114971,383,'Ohraphati','176324',1,0,'2022-03-03 13:27:57','2022-03-03 13:27:57'),(114972,383,'Paliur','176314',1,0,'2022-03-03 13:27:57','2022-03-03 13:27:57'),(114973,383,'Palwin','176314',1,0,'2022-03-03 13:27:57','2022-03-03 13:27:57'),(114974,383,'Pantah','176312',1,0,'2022-03-03 13:27:57','2022-03-03 13:27:57'),(114975,383,'Parchhore','176302',1,0,'2022-03-03 13:27:57','2022-03-03 13:27:57'),(114976,383,'Pareena','176311',1,0,'2022-03-03 13:27:57','2022-03-03 13:27:57'),(114977,383,'Parsiara','176302',1,0,'2022-03-03 13:27:57','2022-03-03 13:27:57'),(114978,383,'Patka','176207',1,0,'2022-03-03 13:27:57','2022-03-03 13:27:57'),(114979,383,'Piura','176324',1,0,'2022-03-03 13:27:57','2022-03-03 13:27:57'),(114980,383,'Pranghala','176315',1,0,'2022-03-03 13:27:57','2022-03-03 13:27:57'),(114981,383,'Pukhri','176319',1,0,'2022-03-03 13:27:57','2022-03-03 13:27:57'),(114982,383,'Purthi','176323',1,0,'2022-03-03 13:27:58','2022-03-03 13:27:58'),(114983,383,'Rai','176323',1,0,'2022-03-03 13:27:58','2022-03-03 13:27:58'),(114984,383,'Raipur','176302',1,0,'2022-03-03 13:27:58','2022-03-03 13:27:58'),(114985,383,'Rajain','176207',1,0,'2022-03-03 13:27:58','2022-03-03 13:27:58'),(114986,383,'Rajera','176318',1,0,'2022-03-03 13:27:58','2022-03-03 13:27:58'),(114987,383,'Rajnagar','176318',1,0,'2022-03-03 13:27:58','2022-03-03 13:27:58'),(114988,383,'Rajpura','176318',1,0,'2022-03-03 13:27:58','2022-03-03 13:27:58'),(114989,383,'Rakh','176311',1,0,'2022-03-03 13:27:58','2022-03-03 13:27:58'),(114990,383,'Rangmahal','176310',1,0,'2022-03-03 13:27:58','2022-03-03 13:27:58'),(114991,383,'Rari','176311',1,0,'2022-03-03 13:27:58','2022-03-03 13:27:58'),(114992,383,'Rathiar','176314',1,0,'2022-03-03 13:27:58','2022-03-03 13:27:58'),(114993,383,'Runukothi','176324',1,0,'2022-03-03 13:27:58','2022-03-03 13:27:58'),(114994,383,'Sach','176323',1,0,'2022-03-03 13:27:58','2022-03-03 13:27:58'),(114995,383,'Sach','176314',1,0,'2022-03-03 13:27:58','2022-03-03 13:27:58'),(114996,383,'Sahala','176302',1,0,'2022-03-03 13:27:59','2022-03-03 13:27:59'),(114997,383,'Sahli','176323',1,0,'2022-03-03 13:27:59','2022-03-03 13:27:59'),(114998,383,'Sahu','176314',1,0,'2022-03-03 13:27:59','2022-03-03 13:27:59'),(114999,383,'Salooni','176320',1,0,'2022-03-03 13:27:59','2022-03-03 13:27:59'),(115000,383,'Salwan','176312',1,0,'2022-03-03 13:27:59','2022-03-03 13:27:59'),(115001,383,'Samleu','176325',1,0,'2022-03-03 13:27:59','2022-03-03 13:27:59'),(115002,383,'Samote','176207',1,0,'2022-03-03 13:27:59','2022-03-03 13:27:59'),(115003,383,'Samra','176311',1,0,'2022-03-03 13:27:59','2022-03-03 13:27:59'),(115004,383,'Sandhi','176319',1,0,'2022-03-03 13:27:59','2022-03-03 13:27:59'),(115005,383,'Sanghani','176320',1,0,'2022-03-03 13:27:59','2022-03-03 13:27:59'),(115006,383,'Sanwal','176316',1,0,'2022-03-03 13:27:59','2022-03-03 13:27:59'),(115007,383,'Sarahan','176314',1,0,'2022-03-03 13:27:59','2022-03-03 13:27:59'),(115008,383,'Sarol','176318',1,0,'2022-03-03 13:27:59','2022-03-03 13:27:59'),(115009,383,'Sechunala','176323',1,0,'2022-03-03 13:27:59','2022-03-03 13:27:59'),(115010,383,'Seikothi','176316',1,0,'2022-03-03 13:27:59','2022-03-03 13:27:59'),(115011,383,'Seri Andral','176312',1,0,'2022-03-03 13:27:59','2022-03-03 13:27:59'),(115012,383,'Seri','176315',1,0,'2022-03-03 13:27:59','2022-03-03 13:27:59'),(115013,383,'Sherpur','176306',1,0,'2022-03-03 13:27:59','2022-03-03 13:27:59'),(115014,383,'Shunudeen','176323',1,0,'2022-03-03 13:27:59','2022-03-03 13:27:59'),(115015,383,'Sihunta','176207',1,0,'2022-03-03 13:28:00','2022-03-03 13:28:00'),(115016,383,'Sillagharat','176314',1,0,'2022-03-03 13:28:00','2022-03-03 13:28:00'),(115017,383,'Simni','176308',1,0,'2022-03-03 13:28:00','2022-03-03 13:28:00'),(115018,383,'Singadhar','176320',1,0,'2022-03-03 13:28:00','2022-03-03 13:28:00'),(115019,383,'Singi','176314',1,0,'2022-03-03 13:28:00','2022-03-03 13:28:00'),(115020,383,'Sirdi','176315',1,0,'2022-03-03 13:28:00','2022-03-03 13:28:00'),(115021,383,'Sirhkund','176318',1,0,'2022-03-03 13:28:00','2022-03-03 13:28:00'),(115022,383,'Siura','176309',1,0,'2022-03-03 13:28:00','2022-03-03 13:28:00'),(115023,383,'Sudli','176303',1,0,'2022-03-03 13:28:00','2022-03-03 13:28:00'),(115024,383,'Sultanpur (Chamba)','176314',1,0,'2022-03-03 13:28:00','2022-03-03 13:28:00'),(115025,383,'Sunara','176311',1,0,'2022-03-03 13:28:00','2022-03-03 13:28:00'),(115026,383,'Sundla','176312',1,0,'2022-03-03 13:28:00','2022-03-03 13:28:00'),(115027,383,'Surangani','176317',1,0,'2022-03-03 13:28:00','2022-03-03 13:28:00'),(115028,383,'Taisural','176323',1,0,'2022-03-03 13:28:01','2022-03-03 13:28:01'),(115029,383,'Taragarh','176302',1,0,'2022-03-03 13:28:01','2022-03-03 13:28:01'),(115030,383,'Tarella','176316',1,0,'2022-03-03 13:28:01','2022-03-03 13:28:01'),(115031,383,'Thalli','176321',1,0,'2022-03-03 13:28:01','2022-03-03 13:28:01'),(115032,383,'Thaneikothi','176316',1,0,'2022-03-03 13:28:01','2022-03-03 13:28:01'),(115033,383,'Tikri','176207',1,0,'2022-03-03 13:28:01','2022-03-03 13:28:01'),(115034,383,'Tikrigargh','176321',1,0,'2022-03-03 13:28:01','2022-03-03 13:28:01'),(115035,383,'Tikru','176320',1,0,'2022-03-03 13:28:01','2022-03-03 13:28:01'),(115036,383,'Tissa','176316',1,0,'2022-03-03 13:28:01','2022-03-03 13:28:01'),(115037,383,'Tritha','176303',1,0,'2022-03-03 13:28:01','2022-03-03 13:28:01'),(115038,383,'Tundah','176324',1,0,'2022-03-03 13:28:01','2022-03-03 13:28:01'),(115039,383,'Tundi','176207',1,0,'2022-03-03 13:28:01','2022-03-03 13:28:01'),(115040,383,'Tunuhatti','176301',1,0,'2022-03-03 13:28:01','2022-03-03 13:28:01'),(115041,383,'Udaipur','176314',1,0,'2022-03-03 13:28:01','2022-03-03 13:28:01'),(115042,383,'Ulansa','176309',1,0,'2022-03-03 13:28:01','2022-03-03 13:28:01'),(115043,383,'Urai','176324',1,0,'2022-03-03 13:28:01','2022-03-03 13:28:01'),(115044,383,'Uteep','176318',1,0,'2022-03-03 13:28:01','2022-03-03 13:28:01'),(115045,383,'Wangal','176308',1,0,'2022-03-03 13:28:01','2022-03-03 13:28:01'),(115046,384,'Aghar','176041',1,0,'2022-03-03 13:28:01','2022-03-03 13:28:01'),(115047,384,'Aman','177501',1,0,'2022-03-03 13:28:01','2022-03-03 13:28:01'),(115048,384,'Amroh','177020',1,0,'2022-03-03 13:28:02','2022-03-03 13:28:02'),(115049,384,'Amroh','177024',1,0,'2022-03-03 13:28:02','2022-03-03 13:28:02'),(115050,384,'Awah Devi','177601',1,0,'2022-03-03 13:28:02','2022-03-03 13:28:02'),(115051,384,'Badehar','176048',1,0,'2022-03-03 13:28:02','2022-03-03 13:28:02'),(115052,384,'Badehra','177040',1,0,'2022-03-03 13:28:02','2022-03-03 13:28:02'),(115053,384,'Badhani','177601',1,0,'2022-03-03 13:28:02','2022-03-03 13:28:02'),(115054,384,'Bafrin','177029',1,0,'2022-03-03 13:28:02','2022-03-03 13:28:02'),(115055,384,'Bagwara','177021',1,0,'2022-03-03 13:28:02','2022-03-03 13:28:02'),(115056,384,'Bahal','177026',1,0,'2022-03-03 13:28:02','2022-03-03 13:28:02'),(115057,384,'Bahanwin','177118',1,0,'2022-03-03 13:28:02','2022-03-03 13:28:02'),(115058,384,'Bahina','174309',1,0,'2022-03-03 13:28:02','2022-03-03 13:28:02'),(115059,384,'Bajrol','177028',1,0,'2022-03-03 13:28:02','2022-03-03 13:28:02'),(115060,384,'Balduhak','177048',1,0,'2022-03-03 13:28:02','2022-03-03 13:28:02'),(115061,384,'Balh Bihal','176040',1,0,'2022-03-03 13:28:02','2022-03-03 13:28:02'),(115062,384,'Balh Uttap','177026',1,0,'2022-03-03 13:28:02','2022-03-03 13:28:02'),(115063,384,'Baliah Khurd','174305',1,0,'2022-03-03 13:28:02','2022-03-03 13:28:02'),(115064,384,'Baloh','177029',1,0,'2022-03-03 13:28:02','2022-03-03 13:28:02'),(115065,384,'Banalag','177022',1,0,'2022-03-03 13:28:02','2022-03-03 13:28:02'),(115066,384,'Bani (Hamirpur(HP))','174304',1,0,'2022-03-03 13:28:02','2022-03-03 13:28:02'),(115067,384,'Bara (Hamirpur(HP))','177044',1,0,'2022-03-03 13:28:02','2022-03-03 13:28:02'),(115068,384,'Baragoan','176049',1,0,'2022-03-03 13:28:03','2022-03-03 13:28:03'),(115069,384,'Barara','177023',1,0,'2022-03-03 13:28:03','2022-03-03 13:28:03'),(115070,384,'Bari','177001',1,0,'2022-03-03 13:28:03','2022-03-03 13:28:03'),(115071,384,'Barin','177023',1,0,'2022-03-03 13:28:03','2022-03-03 13:28:03'),(115072,384,'Baroh','177024',1,0,'2022-03-03 13:28:03','2022-03-03 13:28:03'),(115073,384,'Baroti','176042',1,0,'2022-03-03 13:28:03','2022-03-03 13:28:03'),(115074,384,'Barsar H.O','174305',1,0,'2022-03-03 13:28:03','2022-03-03 13:28:03'),(115075,384,'Basaral','177301',1,0,'2022-03-03 13:28:03','2022-03-03 13:28:03'),(115076,384,'Batarli Upperli','174312',1,0,'2022-03-03 13:28:03','2022-03-03 13:28:03'),(115077,384,'Batran','177042',1,0,'2022-03-03 13:28:03','2022-03-03 13:28:03'),(115078,384,'Bauru','177028',1,0,'2022-03-03 13:28:04','2022-03-03 13:28:04'),(115079,384,'Beh Bassaral','177041',1,0,'2022-03-03 13:28:04','2022-03-03 13:28:04'),(115080,384,'Bela','177033',1,0,'2022-03-03 13:28:04','2022-03-03 13:28:04'),(115081,384,'Beri','176041',1,0,'2022-03-03 13:28:04','2022-03-03 13:28:04'),(115082,384,'Bhakreri','174305',1,0,'2022-03-03 13:28:04','2022-03-03 13:28:04'),(115083,384,'Bhaleth','176108',1,0,'2022-03-03 13:28:04','2022-03-03 13:28:04'),(115084,384,'Bhareri','177024',1,0,'2022-03-03 13:28:04','2022-03-03 13:28:04'),(115085,384,'Bharmoti','177033',1,0,'2022-03-03 13:28:04','2022-03-03 13:28:04'),(115086,384,'Bharthian','177029',1,0,'2022-03-03 13:28:04','2022-03-03 13:28:04'),(115087,384,'Bhater','177022',1,0,'2022-03-03 13:28:04','2022-03-03 13:28:04'),(115088,384,'Bherda','177028',1,0,'2022-03-03 13:28:04','2022-03-03 13:28:04'),(115089,384,'Bhiambi','177038',1,0,'2022-03-03 13:28:04','2022-03-03 13:28:04'),(115090,384,'Bhira','177001',1,0,'2022-03-03 13:28:04','2022-03-03 13:28:04'),(115091,384,'Bhoranj','176045',1,0,'2022-03-03 13:28:05','2022-03-03 13:28:05'),(115092,384,'Bhota','176041',1,0,'2022-03-03 13:28:05','2022-03-03 13:28:05'),(115093,384,'Bhukkar','177024',1,0,'2022-03-03 13:28:05','2022-03-03 13:28:05'),(115094,384,'Biar','177119',1,0,'2022-03-03 13:28:05','2022-03-03 13:28:05'),(115095,384,'Bihru','176040',1,0,'2022-03-03 13:28:05','2022-03-03 13:28:05'),(115096,384,'Bijhari','176040',1,0,'2022-03-03 13:28:05','2022-03-03 13:28:05'),(115097,384,'Bir Bagehra','176110',1,0,'2022-03-03 13:28:05','2022-03-03 13:28:05'),(115098,384,'Bohni','177001',1,0,'2022-03-03 13:28:05','2022-03-03 13:28:05'),(115099,384,'Booni Nohngi','177048',1,0,'2022-03-03 13:28:05','2022-03-03 13:28:05'),(115100,384,'Bumbloo','177119',1,0,'2022-03-03 13:28:05','2022-03-03 13:28:05'),(115101,384,'Chabutra','177007',1,0,'2022-03-03 13:28:05','2022-03-03 13:28:05'),(115102,384,'Chakmoh','176039',1,0,'2022-03-03 13:28:05','2022-03-03 13:28:05'),(115103,384,'Chamboh','177601',1,0,'2022-03-03 13:28:05','2022-03-03 13:28:05'),(115104,384,'Chamiana','176111',1,0,'2022-03-03 13:28:05','2022-03-03 13:28:05'),(115105,384,'Chamned','177029',1,0,'2022-03-03 13:28:05','2022-03-03 13:28:05'),(115106,384,'Changar','174505',1,0,'2022-03-03 13:28:05','2022-03-03 13:28:05'),(115107,384,'Chanruhi','177024',1,0,'2022-03-03 13:28:05','2022-03-03 13:28:05'),(115108,384,'Charot','176110',1,0,'2022-03-03 13:28:05','2022-03-03 13:28:05'),(115109,384,'Chauri','176111',1,0,'2022-03-03 13:28:05','2022-03-03 13:28:05'),(115110,384,'Chhatoli Rajputan','174312',1,0,'2022-03-03 13:28:05','2022-03-03 13:28:05'),(115111,384,'Choru','177044',1,0,'2022-03-03 13:28:05','2022-03-03 13:28:05'),(115112,384,'Chowki Jamwalan','177020',1,0,'2022-03-03 13:28:06','2022-03-03 13:28:06'),(115113,384,'Dadwin','176040',1,0,'2022-03-03 13:28:06','2022-03-03 13:28:06'),(115114,384,'Dain','176042',1,0,'2022-03-03 13:28:06','2022-03-03 13:28:06'),(115115,384,'Dakhyora','176049',1,0,'2022-03-03 13:28:06','2022-03-03 13:28:06'),(115116,384,'Dangri','177048',1,0,'2022-03-03 13:28:06','2022-03-03 13:28:06'),(115117,384,'Daruhi','177001',1,0,'2022-03-03 13:28:06','2022-03-03 13:28:06'),(115118,384,'Deotsidh','176039',1,0,'2022-03-03 13:28:06','2022-03-03 13:28:06'),(115119,384,'Dhabiri','176049',1,0,'2022-03-03 13:28:06','2022-03-03 13:28:06'),(115120,384,'Dhail','176111',1,0,'2022-03-03 13:28:06','2022-03-03 13:28:06'),(115121,384,'Dhamrol','177024',1,0,'2022-03-03 13:28:06','2022-03-03 13:28:06'),(115122,384,'Dhaned','174505',1,0,'2022-03-03 13:28:06','2022-03-03 13:28:06'),(115123,384,'Dhaneta','177041',1,0,'2022-03-03 13:28:06','2022-03-03 13:28:06'),(115124,384,'Dhangota','176040',1,0,'2022-03-03 13:28:06','2022-03-03 13:28:06'),(115125,384,'Dhanwin','177401',1,0,'2022-03-03 13:28:06','2022-03-03 13:28:06'),(115126,384,'Dhirwin','176045',1,0,'2022-03-03 13:28:06','2022-03-03 13:28:06'),(115127,384,'Dho','177025',1,0,'2022-03-03 13:28:06','2022-03-03 13:28:06'),(115128,384,'Didwin','177401',1,0,'2022-03-03 13:28:06','2022-03-03 13:28:06'),(115129,384,'Dimmi','177025',1,0,'2022-03-03 13:28:06','2022-03-03 13:28:06'),(115130,384,'Dudhana','177026',1,0,'2022-03-03 13:28:06','2022-03-03 13:28:06'),(115131,384,'Dugha','177001',1,0,'2022-03-03 13:28:06','2022-03-03 13:28:06'),(115132,384,'Dugli','177029',1,0,'2022-03-03 13:28:06','2022-03-03 13:28:06'),(115133,384,'Dungrin','176045',1,0,'2022-03-03 13:28:06','2022-03-03 13:28:06'),(115134,384,'Fatehpur','177042',1,0,'2022-03-03 13:28:06','2022-03-03 13:28:06'),(115135,384,'Gahli Kohlwin','174405',1,0,'2022-03-03 13:28:06','2022-03-03 13:28:06'),(115136,384,'Galore','177026',1,0,'2022-03-03 13:28:07','2022-03-03 13:28:07'),(115137,384,'Gandhi Chowk Hamirpur','177001',1,0,'2022-03-03 13:28:07','2022-03-03 13:28:07'),(115138,384,'Gawardu','177023',1,0,'2022-03-03 13:28:07','2022-03-03 13:28:07'),(115139,384,'Ghaloon','177042',1,0,'2022-03-03 13:28:07','2022-03-03 13:28:07'),(115140,384,'Ghangot','176039',1,0,'2022-03-03 13:28:07','2022-03-03 13:28:07'),(115141,384,'Ghumarli','177119',1,0,'2022-03-03 13:28:07','2022-03-03 13:28:07'),(115142,384,'Govt Degree College Hamirpur','177005',1,0,'2022-03-03 13:28:07','2022-03-03 13:28:07'),(115143,384,'Gwal Pathar','177041',1,0,'2022-03-03 13:28:07','2022-03-03 13:28:07'),(115144,384,'Hamirpur H.O','177001',1,0,'2022-03-03 13:28:07','2022-03-03 13:28:07'),(115145,384,'Hanoh','177024',1,0,'2022-03-03 13:28:07','2022-03-03 13:28:07'),(115146,384,'Hareta','174405',1,0,'2022-03-03 13:28:07','2022-03-03 13:28:07'),(115147,384,'Harsour','174305',1,0,'2022-03-03 13:28:07','2022-03-03 13:28:07'),(115148,384,'Hathol','177041',1,0,'2022-03-03 13:28:07','2022-03-03 13:28:07'),(115149,384,'Himmer','177025',1,0,'2022-03-03 13:28:07','2022-03-03 13:28:07'),(115150,384,'Jahu','176048',1,0,'2022-03-03 13:28:07','2022-03-03 13:28:07'),(115151,384,'Jakhyol','176045',1,0,'2022-03-03 13:28:07','2022-03-03 13:28:07'),(115152,384,'Jalari','177042',1,0,'2022-03-03 13:28:07','2022-03-03 13:28:07'),(115153,384,'Jandru','177028',1,0,'2022-03-03 13:28:07','2022-03-03 13:28:07'),(115154,384,'Jangal Beri','176109',1,0,'2022-03-03 13:28:07','2022-03-03 13:28:07'),(115155,384,'Jansooh','177041',1,0,'2022-03-03 13:28:07','2022-03-03 13:28:07'),(115156,384,'Jaure Amb','174312',1,0,'2022-03-03 13:28:07','2022-03-03 13:28:07'),(115157,384,'Jeehan','177044',1,0,'2022-03-03 13:28:08','2022-03-03 13:28:08'),(115158,384,'Jhalan','177301',1,0,'2022-03-03 13:28:08','2022-03-03 13:28:08'),(115159,384,'Jhaniara','177001',1,0,'2022-03-03 13:28:08','2022-03-03 13:28:08'),(115160,384,'Jhaniari','177001',1,0,'2022-03-03 13:28:08','2022-03-03 13:28:08'),(115161,384,'Jhanjiani','174305',1,0,'2022-03-03 13:28:08','2022-03-03 13:28:08'),(115162,384,'Jharlog','176043',1,0,'2022-03-03 13:28:08','2022-03-03 13:28:08'),(115163,384,'Jhiralari','176041',1,0,'2022-03-03 13:28:08','2022-03-03 13:28:08'),(115164,384,'Jijwin','176045',1,0,'2022-03-03 13:28:08','2022-03-03 13:28:08'),(115165,384,'Jol Lambri','176111',1,0,'2022-03-03 13:28:08','2022-03-03 13:28:08'),(115166,384,'Jol Sappar','177048',1,0,'2022-03-03 13:28:08','2022-03-03 13:28:08'),(115167,384,'Kakkar','177028',1,0,'2022-03-03 13:28:08','2022-03-03 13:28:08'),(115168,384,'Kakriar','177001',1,0,'2022-03-03 13:28:09','2022-03-03 13:28:09'),(115169,384,'Kakrot','176048',1,0,'2022-03-03 13:28:09','2022-03-03 13:28:09'),(115170,384,'Kaloor','177033',1,0,'2022-03-03 13:28:09','2022-03-03 13:28:09'),(115171,384,'Kanerar','176110',1,0,'2022-03-03 13:28:09','2022-03-03 13:28:09'),(115172,384,'Kangoo','177040',1,0,'2022-03-03 13:28:09','2022-03-03 13:28:09'),(115173,384,'Kanjian','177025',1,0,'2022-03-03 13:28:09','2022-03-03 13:28:09'),(115174,384,'Karara','177027',1,0,'2022-03-03 13:28:09','2022-03-03 13:28:09'),(115175,384,'Karaur','177301',1,0,'2022-03-03 13:28:09','2022-03-03 13:28:09'),(115176,384,'Karer','174311',1,0,'2022-03-03 13:28:09','2022-03-03 13:28:09'),(115177,384,'Karohta','176044',1,0,'2022-03-03 13:28:09','2022-03-03 13:28:09'),(115178,384,'Karot','176108',1,0,'2022-03-03 13:28:09','2022-03-03 13:28:09'),(115179,384,'Karsai','174312',1,0,'2022-03-03 13:28:09','2022-03-03 13:28:09'),(115180,384,'Kashmir','177006',1,0,'2022-03-03 13:28:09','2022-03-03 13:28:09'),(115181,384,'Kaswar','174312',1,0,'2022-03-03 13:28:09','2022-03-03 13:28:09'),(115182,384,'Kathiana','176041',1,0,'2022-03-03 13:28:09','2022-03-03 13:28:09'),(115183,384,'Khagal','177001',1,0,'2022-03-03 13:28:09','2022-03-03 13:28:09'),(115184,384,'Khanouli','177028',1,0,'2022-03-03 13:28:09','2022-03-03 13:28:09'),(115185,384,'Kharwar','176041',1,0,'2022-03-03 13:28:09','2022-03-03 13:28:09'),(115186,384,'Kheri','176109',1,0,'2022-03-03 13:28:09','2022-03-03 13:28:09'),(115187,384,'Khiah','177020',1,0,'2022-03-03 13:28:09','2022-03-03 13:28:09'),(115188,384,'Khuthrin','176043',1,0,'2022-03-03 13:28:09','2022-03-03 13:28:09'),(115189,384,'Kirwin','174311',1,0,'2022-03-03 13:28:09','2022-03-03 13:28:09'),(115190,384,'Kitpal','177038',1,0,'2022-03-03 13:28:10','2022-03-03 13:28:10'),(115191,384,'Knoh','174304',1,0,'2022-03-03 13:28:10','2022-03-03 13:28:10'),(115192,384,'Kohdra','174311',1,0,'2022-03-03 13:28:10','2022-03-03 13:28:10'),(115193,384,'Kohla','177033',1,0,'2022-03-03 13:28:10','2022-03-03 13:28:10'),(115194,384,'Kot (Hamirpur(HP))','177027',1,0,'2022-03-03 13:28:10','2022-03-03 13:28:10'),(115195,384,'Kulehra','174311',1,0,'2022-03-03 13:28:10','2022-03-03 13:28:10'),(115196,384,'Kuthera','177020',1,0,'2022-03-03 13:28:10','2022-03-03 13:28:10'),(115197,384,'Ladraur','176043',1,0,'2022-03-03 13:28:10','2022-03-03 13:28:10'),(115198,384,'Lafran','176049',1,0,'2022-03-03 13:28:10','2022-03-03 13:28:10'),(115199,384,'Lag Devi','177022',1,0,'2022-03-03 13:28:10','2022-03-03 13:28:10'),(115200,384,'Lagmanwin','177118',1,0,'2022-03-03 13:28:10','2022-03-03 13:28:10'),(115201,384,'Lahar','177044',1,0,'2022-03-03 13:28:10','2022-03-03 13:28:10'),(115202,384,'Lambloo','177029',1,0,'2022-03-03 13:28:10','2022-03-03 13:28:10'),(115203,384,'Loharda','174304',1,0,'2022-03-03 13:28:10','2022-03-03 13:28:10'),(115204,384,'Loharli','176039',1,0,'2022-03-03 13:28:10','2022-03-03 13:28:10'),(115205,384,'Ludder Mahadev','176045',1,0,'2022-03-03 13:28:10','2022-03-03 13:28:10'),(115206,384,'Maharal','176049',1,0,'2022-03-03 13:28:10','2022-03-03 13:28:10'),(115207,384,'Mair','174405',1,0,'2022-03-03 13:28:11','2022-03-03 13:28:11'),(115208,384,'Mair','176042',1,0,'2022-03-03 13:28:11','2022-03-03 13:28:11'),(115209,384,'Majhiar','177038',1,0,'2022-03-03 13:28:11','2022-03-03 13:28:11'),(115210,384,'Majhog Sultani','177020',1,0,'2022-03-03 13:28:11','2022-03-03 13:28:11'),(115211,384,'Mangnoti','176040',1,0,'2022-03-03 13:28:11','2022-03-03 13:28:11'),(115212,384,'Mansai','177006',1,0,'2022-03-03 13:28:11','2022-03-03 13:28:11'),(115213,384,'Masiana','177001',1,0,'2022-03-03 13:28:11','2022-03-03 13:28:11'),(115214,384,'Mehal','177401',1,0,'2022-03-03 13:28:11','2022-03-03 13:28:11'),(115215,384,'Mehre','174305',1,0,'2022-03-03 13:28:11','2022-03-03 13:28:11'),(115216,384,'Mohin','177001',1,0,'2022-03-03 13:28:11','2022-03-03 13:28:11'),(115217,384,'Mundkhar','176044',1,0,'2022-03-03 13:28:11','2022-03-03 13:28:11'),(115218,384,'Nadaun','177033',1,0,'2022-03-03 13:28:11','2022-03-03 13:28:11'),(115219,384,'Nagrota Gazian','176045',1,0,'2022-03-03 13:28:11','2022-03-03 13:28:11'),(115220,384,'Nain','176039',1,0,'2022-03-03 13:28:11','2022-03-03 13:28:11'),(115221,384,'Nalahi','176111',1,0,'2022-03-03 13:28:11','2022-03-03 13:28:11'),(115222,384,'Nalti','177001',1,0,'2022-03-03 13:28:11','2022-03-03 13:28:11'),(115223,384,'Nara','174309',1,0,'2022-03-03 13:28:11','2022-03-03 13:28:11'),(115224,384,'Nareli','177020',1,0,'2022-03-03 13:28:11','2022-03-03 13:28:11'),(115225,384,'NIT Hamirpur','177005',1,0,'2022-03-03 13:28:11','2022-03-03 13:28:11'),(115226,384,'Pairwin','176040',1,0,'2022-03-03 13:28:11','2022-03-03 13:28:11'),(115227,384,'Pansai','177041',1,0,'2022-03-03 13:28:11','2022-03-03 13:28:11'),(115228,384,'Panyali Jattan','177040',1,0,'2022-03-03 13:28:11','2022-03-03 13:28:11'),(115229,384,'Parol','177501',1,0,'2022-03-03 13:28:12','2022-03-03 13:28:12'),(115230,384,'Pathliar','174305',1,0,'2022-03-03 13:28:12','2022-03-03 13:28:12'),(115231,384,'Patlander','176111',1,0,'2022-03-03 13:28:12','2022-03-03 13:28:12'),(115232,384,'Patnaun','177023',1,0,'2022-03-03 13:28:12','2022-03-03 13:28:12'),(115233,384,'Patta','176041',1,0,'2022-03-03 13:28:12','2022-03-03 13:28:12'),(115234,384,'Phagoti','176039',1,0,'2022-03-03 13:28:12','2022-03-03 13:28:12'),(115235,384,'Phahal','177026',1,0,'2022-03-03 13:28:12','2022-03-03 13:28:12'),(115236,384,'Putrial','177045',1,0,'2022-03-03 13:28:12','2022-03-03 13:28:12'),(115237,384,'Rail','177045',1,0,'2022-03-03 13:28:12','2022-03-03 13:28:12'),(115238,384,'Raili Jajri','176039',1,0,'2022-03-03 13:28:12','2022-03-03 13:28:12'),(115239,384,'Rangar','176111',1,0,'2022-03-03 13:28:13','2022-03-03 13:28:13'),(115240,384,'Rangas','177048',1,0,'2022-03-03 13:28:13','2022-03-03 13:28:13'),(115241,384,'Ree','177007',1,0,'2022-03-03 13:28:13','2022-03-03 13:28:13'),(115242,384,'Ropa','177001',1,0,'2022-03-03 13:28:13','2022-03-03 13:28:13'),(115243,384,'Ropari','176041',1,0,'2022-03-03 13:28:13','2022-03-03 13:28:13'),(115244,384,'Salauni','174311',1,0,'2022-03-03 13:28:13','2022-03-03 13:28:13'),(115245,384,'Samirpur','177601',1,0,'2022-03-03 13:28:13','2022-03-03 13:28:13'),(115246,384,'Samman Kothi','177119',1,0,'2022-03-03 13:28:13','2022-03-03 13:28:13'),(115247,384,'Samtana Kalan','176042',1,0,'2022-03-03 13:28:13','2022-03-03 13:28:13'),(115248,384,'Sanahi','177040',1,0,'2022-03-03 13:28:13','2022-03-03 13:28:13'),(115249,384,'Saned','176043',1,0,'2022-03-03 13:28:13','2022-03-03 13:28:13'),(115250,384,'Sarahkar','177027',1,0,'2022-03-03 13:28:13','2022-03-03 13:28:13'),(115251,384,'Sathwin','176049',1,0,'2022-03-03 13:28:13','2022-03-03 13:28:13'),(115252,384,'Sera','177038',1,0,'2022-03-03 13:28:13','2022-03-03 13:28:13'),(115253,384,'Sohari','174311',1,0,'2022-03-03 13:28:13','2022-03-03 13:28:13'),(115254,384,'Sour','176041',1,0,'2022-03-03 13:28:13','2022-03-03 13:28:13'),(115255,384,'Sudhial','177042',1,0,'2022-03-03 13:28:13','2022-03-03 13:28:13'),(115256,384,'Sujanpur Tira','176110',1,0,'2022-03-03 13:28:13','2022-03-03 13:28:13'),(115257,384,'Sulkhan','176043',1,0,'2022-03-03 13:28:13','2022-03-03 13:28:13'),(115258,384,'Tal','177401',1,0,'2022-03-03 13:28:13','2022-03-03 13:28:13'),(115259,384,'Tarkwari','176045',1,0,'2022-03-03 13:28:13','2022-03-03 13:28:13'),(115260,384,'Tarpohal','176109',1,0,'2022-03-03 13:28:13','2022-03-03 13:28:13'),(115261,384,'Tauni Devi','177023',1,0,'2022-03-03 13:28:14','2022-03-03 13:28:14'),(115262,384,'Thana Bajuri','177023',1,0,'2022-03-03 13:28:14','2022-03-03 13:28:14'),(115263,384,'Thathwani','177501',1,0,'2022-03-03 13:28:14','2022-03-03 13:28:14'),(115264,384,'Tikkar','177025',1,0,'2022-03-03 13:28:14','2022-03-03 13:28:14'),(115265,384,'Tikkari Manhasan','176045',1,0,'2022-03-03 13:28:14','2022-03-03 13:28:14'),(115266,384,'Tipper','174312',1,0,'2022-03-03 13:28:14','2022-03-03 13:28:14'),(115267,384,'Tira','176110',1,0,'2022-03-03 13:28:14','2022-03-03 13:28:14'),(115268,384,'Town Bharari Devi','176041',1,0,'2022-03-03 13:28:14','2022-03-03 13:28:14'),(115269,384,'Uhal','177022',1,0,'2022-03-03 13:28:14','2022-03-03 13:28:14'),(115270,384,'Ukhali','176042',1,0,'2022-03-03 13:28:14','2022-03-03 13:28:14'),(115271,384,'Utpur','177022',1,0,'2022-03-03 13:28:14','2022-03-03 13:28:14'),(115272,385,'Adhwani','176036',1,0,'2022-03-03 13:28:14','2022-03-03 13:28:14'),(115273,385,'Aloh','177034',1,0,'2022-03-03 13:28:14','2022-03-03 13:28:14'),(115274,385,'Amb Pathiar','176031',1,0,'2022-03-03 13:28:14','2022-03-03 13:28:14'),(115275,385,'Amlela','176027',1,0,'2022-03-03 13:28:14','2022-03-03 13:28:14'),(115276,385,'Amroh','176501',1,0,'2022-03-03 13:28:14','2022-03-03 13:28:14'),(115277,385,'Arela','176054',1,0,'2022-03-03 13:28:14','2022-03-03 13:28:14'),(115278,385,'Baggi','176031',1,0,'2022-03-03 13:28:14','2022-03-03 13:28:14'),(115279,385,'Bagli','176209',1,0,'2022-03-03 13:28:14','2022-03-03 13:28:14'),(115280,385,'Bagli','177103',1,0,'2022-03-03 13:28:14','2022-03-03 13:28:14'),(115281,385,'Bajrehar','176208',1,0,'2022-03-03 13:28:14','2022-03-03 13:28:14'),(115282,385,'Baldhar','176047',1,0,'2022-03-03 13:28:14','2022-03-03 13:28:14'),(115283,385,'Balol','176037',1,0,'2022-03-03 13:28:15','2022-03-03 13:28:15'),(115284,385,'Balugloa','176029',1,0,'2022-03-03 13:28:15','2022-03-03 13:28:15'),(115285,385,'Bandi','176209',1,0,'2022-03-03 13:28:15','2022-03-03 13:28:15'),(115286,385,'Bangoli','176028',1,0,'2022-03-03 13:28:15','2022-03-03 13:28:15'),(115287,385,'Bankhandi','177114',1,0,'2022-03-03 13:28:15','2022-03-03 13:28:15'),(115288,385,'Banne- Di - Hatti','176029',1,0,'2022-03-03 13:28:15','2022-03-03 13:28:15'),(115289,385,'Bara','177104',1,0,'2022-03-03 13:28:15','2022-03-03 13:28:15'),(115290,385,'Barana','176047',1,0,'2022-03-03 13:28:15','2022-03-03 13:28:15'),(115291,385,'Bari','176051',1,0,'2022-03-03 13:28:15','2022-03-03 13:28:15'),(115292,385,'Bari','176502',1,0,'2022-03-03 13:28:15','2022-03-03 13:28:15'),(115293,385,'Barial','176027',1,0,'2022-03-03 13:28:15','2022-03-03 13:28:15'),(115294,385,'Barikalan','176055',1,0,'2022-03-03 13:28:15','2022-03-03 13:28:15'),(115295,385,'Baroh','176054',1,0,'2022-03-03 13:28:15','2022-03-03 13:28:15'),(115296,385,'Baroona','176025',1,0,'2022-03-03 13:28:15','2022-03-03 13:28:15'),(115297,385,'Barot Banal','176022',1,0,'2022-03-03 13:28:15','2022-03-03 13:28:15'),(115298,385,'Barwara','177117',1,0,'2022-03-03 13:28:15','2022-03-03 13:28:15'),(115299,385,'Basnoor','176208',1,0,'2022-03-03 13:28:15','2022-03-03 13:28:15'),(115300,385,'Bassi','176214',1,0,'2022-03-03 13:28:15','2022-03-03 13:28:15'),(115301,385,'Bathra','177112',1,0,'2022-03-03 13:28:15','2022-03-03 13:28:15'),(115302,385,'Beehan','177103',1,0,'2022-03-03 13:28:15','2022-03-03 13:28:15'),(115303,385,'Beh','177105',1,0,'2022-03-03 13:28:16','2022-03-03 13:28:16'),(115304,385,'Behar Kuthera','177111',1,0,'2022-03-03 13:28:16','2022-03-03 13:28:16'),(115305,385,'Bhadiara','176209',1,0,'2022-03-03 13:28:16','2022-03-03 13:28:16'),(115306,385,'Bhadrer','176047',1,0,'2022-03-03 13:28:16','2022-03-03 13:28:16'),(115307,385,'Bhallad','176023',1,0,'2022-03-03 13:28:16','2022-03-03 13:28:16'),(115308,385,'Bhangwar','176029',1,0,'2022-03-03 13:28:16','2022-03-03 13:28:16'),(115309,385,'Bharmar','176021',1,0,'2022-03-03 13:28:16','2022-03-03 13:28:16'),(115310,385,'Bharoli','176036',1,0,'2022-03-03 13:28:17','2022-03-03 13:28:17'),(115311,385,'Bharoli Jadid','177043',1,0,'2022-03-03 13:28:17','2022-03-03 13:28:17'),(115312,385,'Bhater','176026',1,0,'2022-03-03 13:28:17','2022-03-03 13:28:17'),(115313,385,'Bhatoli Phakorian','176028',1,0,'2022-03-03 13:28:17','2022-03-03 13:28:17'),(115314,385,'Bilaspur','176033',1,0,'2022-03-03 13:28:17','2022-03-03 13:28:17'),(115315,385,'Boharkawaloo','176001',1,0,'2022-03-03 13:28:17','2022-03-03 13:28:17'),(115316,385,'Chalali','177103',1,0,'2022-03-03 13:28:17','2022-03-03 13:28:17'),(115317,385,'Chalwara','176023',1,0,'2022-03-03 13:28:17','2022-03-03 13:28:17'),(115318,385,'Chandrot','176037',1,0,'2022-03-03 13:28:17','2022-03-03 13:28:17'),(115319,385,'Chanour','177113',1,0,'2022-03-03 13:28:17','2022-03-03 13:28:17'),(115320,385,'Chanouta','177103',1,0,'2022-03-03 13:28:17','2022-03-03 13:28:17'),(115321,385,'Chaplah','177043',1,0,'2022-03-03 13:28:17','2022-03-03 13:28:17'),(115322,385,'Chari','176047',1,0,'2022-03-03 13:28:17','2022-03-03 13:28:17'),(115323,385,'Chatwana Lahroo','176023',1,0,'2022-03-03 13:28:17','2022-03-03 13:28:17'),(115324,385,'Chauli','177043',1,0,'2022-03-03 13:28:17','2022-03-03 13:28:17'),(115325,385,'Chetru','176209',1,0,'2022-03-03 13:28:17','2022-03-03 13:28:17'),(115326,385,'Chhater Jogian','176022',1,0,'2022-03-03 13:28:17','2022-03-03 13:28:17'),(115327,385,'Chhughera','176056',1,0,'2022-03-03 13:28:17','2022-03-03 13:28:17'),(115328,385,'Choukath','176036',1,0,'2022-03-03 13:28:17','2022-03-03 13:28:17'),(115329,385,'Chudrer','177104',1,0,'2022-03-03 13:28:17','2022-03-03 13:28:17'),(115330,385,'Dadasiba','177106',1,0,'2022-03-03 13:28:18','2022-03-03 13:28:18'),(115331,385,'Dadoli','176026',1,0,'2022-03-03 13:28:18','2022-03-03 13:28:18'),(115332,385,'Dahab','176051',1,0,'2022-03-03 13:28:18','2022-03-03 13:28:18'),(115333,385,'Dangerh','176054',1,0,'2022-03-03 13:28:18','2022-03-03 13:28:18'),(115334,385,'Dargia Sakri','176027',1,0,'2022-03-03 13:28:18','2022-03-03 13:28:18'),(115335,385,'Darkata','176029',1,0,'2022-03-03 13:28:18','2022-03-03 13:28:18'),(115336,385,'Darkati','176023',1,0,'2022-03-03 13:28:18','2022-03-03 13:28:18'),(115337,385,'Daulatpur (Kangra)','176038',1,0,'2022-03-03 13:28:18','2022-03-03 13:28:18'),(115338,385,'Dehra H.O','177101',1,0,'2022-03-03 13:28:18','2022-03-03 13:28:18'),(115339,385,'Dhagwar','176001',1,0,'2022-03-03 13:28:18','2022-03-03 13:28:18'),(115340,385,'Dhaliara','177103',1,0,'2022-03-03 13:28:18','2022-03-03 13:28:18'),(115341,385,'Dhaloon','176056',1,0,'2022-03-03 13:28:18','2022-03-03 13:28:18'),(115342,385,'Dhamer','176038',1,0,'2022-03-03 13:28:19','2022-03-03 13:28:19'),(115343,385,'Dhameta','176025',1,0,'2022-03-03 13:28:19','2022-03-03 13:28:19'),(115344,385,'Dhaneta','176208',1,0,'2022-03-03 13:28:19','2022-03-03 13:28:19'),(115345,385,'Dhaneti Bhurian','176051',1,0,'2022-03-03 13:28:19','2022-03-03 13:28:19'),(115346,385,'Dhar','176033',1,0,'2022-03-03 13:28:19','2022-03-03 13:28:19'),(115347,385,'Dhasoli','176021',1,0,'2022-03-03 13:28:19','2022-03-03 13:28:19'),(115348,385,'Dhawala','177117',1,0,'2022-03-03 13:28:19','2022-03-03 13:28:19'),(115349,385,'Dhiala','176022',1,0,'2022-03-03 13:28:19','2022-03-03 13:28:19'),(115350,385,'Digger','176036',1,0,'2022-03-03 13:28:19','2022-03-03 13:28:19'),(115351,385,'Dohag','176029',1,0,'2022-03-03 13:28:19','2022-03-03 13:28:19'),(115352,385,'Dola Khariana','176030',1,0,'2022-03-03 13:28:19','2022-03-03 13:28:19'),(115353,385,'Fakloh','176031',1,0,'2022-03-03 13:28:19','2022-03-03 13:28:19'),(115354,385,'Fatehpur (Kangra)','176053',1,0,'2022-03-03 13:28:19','2022-03-03 13:28:19'),(115355,385,'Gadrana','176022',1,0,'2022-03-03 13:28:19','2022-03-03 13:28:19'),(115356,385,'Gadroli','176053',1,0,'2022-03-03 13:28:19','2022-03-03 13:28:19'),(115357,385,'Gaggal','176209',1,0,'2022-03-03 13:28:19','2022-03-03 13:28:19'),(115358,385,'Gagruhi','176036',1,0,'2022-03-03 13:28:19','2022-03-03 13:28:19'),(115359,385,'Garli','177108',1,0,'2022-03-03 13:28:19','2022-03-03 13:28:19'),(115360,385,'Gathutar','176033',1,0,'2022-03-03 13:28:19','2022-03-03 13:28:19'),(115361,385,'Geen','176029',1,0,'2022-03-03 13:28:19','2022-03-03 13:28:19'),(115362,385,'Ghallian','176029',1,0,'2022-03-03 13:28:19','2022-03-03 13:28:19'),(115363,385,'Ghallour','176066',1,0,'2022-03-03 13:28:20','2022-03-03 13:28:20'),(115364,385,'Ghamroor','176502',1,0,'2022-03-03 13:28:20','2022-03-03 13:28:20'),(115365,385,'Ghar Jaraot','176023',1,0,'2022-03-03 13:28:20','2022-03-03 13:28:20'),(115366,385,'Gharna','176030',1,0,'2022-03-03 13:28:20','2022-03-03 13:28:20'),(115367,385,'Ghati Billan','176501',1,0,'2022-03-03 13:28:20','2022-03-03 13:28:20'),(115368,385,'Gheori','177105',1,0,'2022-03-03 13:28:20','2022-03-03 13:28:20'),(115369,385,'Gher','177114',1,0,'2022-03-03 13:28:20','2022-03-03 13:28:20'),(115370,385,'Ghiana Kalan','176001',1,0,'2022-03-03 13:28:20','2022-03-03 13:28:20'),(115371,385,'Ghiara','177106',1,0,'2022-03-03 13:28:20','2022-03-03 13:28:20'),(115372,385,'Ghurkari','176001',1,0,'2022-03-03 13:28:20','2022-03-03 13:28:20'),(115373,385,'Golwan','176022',1,0,'2022-03-03 13:28:20','2022-03-03 13:28:20'),(115374,385,'Guler','176033',1,0,'2022-03-03 13:28:20','2022-03-03 13:28:20'),(115375,385,'Gummar','176031',1,0,'2022-03-03 13:28:21','2022-03-03 13:28:21'),(115376,385,'Gural Dhar','177111',1,0,'2022-03-03 13:28:21','2022-03-03 13:28:21'),(115377,385,'Gurial','176051',1,0,'2022-03-03 13:28:21','2022-03-03 13:28:21'),(115378,385,'Gurnwar','177106',1,0,'2022-03-03 13:28:21','2022-03-03 13:28:21'),(115379,385,'Har','176023',1,0,'2022-03-03 13:28:21','2022-03-03 13:28:21'),(115380,385,'Haripur (Kangra)','176028',1,0,'2022-03-03 13:28:21','2022-03-03 13:28:21'),(115381,385,'Harnota','176021',1,0,'2022-03-03 13:28:21','2022-03-03 13:28:21'),(115382,385,'Harsar','176023',1,0,'2022-03-03 13:28:21','2022-03-03 13:28:21'),(115383,385,'Hatwas','176047',1,0,'2022-03-03 13:28:21','2022-03-03 13:28:21'),(115384,385,'Hori Devi','176022',1,0,'2022-03-03 13:28:21','2022-03-03 13:28:21'),(115385,385,'Ichhi','176209',1,0,'2022-03-03 13:28:21','2022-03-03 13:28:21'),(115386,385,'Jagnoli','176025',1,0,'2022-03-03 13:28:21','2022-03-03 13:28:21'),(115387,385,'Jahakhra','176021',1,0,'2022-03-03 13:28:21','2022-03-03 13:28:21'),(115388,385,'Jalari','176038',1,0,'2022-03-03 13:28:21','2022-03-03 13:28:21'),(115389,385,'Jalot','176047',1,0,'2022-03-03 13:28:21','2022-03-03 13:28:21'),(115390,385,'Jambal','177113',1,0,'2022-03-03 13:28:21','2022-03-03 13:28:21'),(115391,385,'Jandaur','176501',1,0,'2022-03-03 13:28:21','2022-03-03 13:28:21'),(115392,385,'Janyankar','176038',1,0,'2022-03-03 13:28:21','2022-03-03 13:28:21'),(115393,385,'Jarot','176027',1,0,'2022-03-03 13:28:21','2022-03-03 13:28:21'),(115394,385,'Jassi','176054',1,0,'2022-03-03 13:28:21','2022-03-03 13:28:21'),(115395,385,'Jawalamukhi','176031',1,0,'2022-03-03 13:28:22','2022-03-03 13:28:22'),(115396,385,'Jawali','176023',1,0,'2022-03-03 13:28:22','2022-03-03 13:28:22'),(115397,385,'Jheol','176001',1,0,'2022-03-03 13:28:22','2022-03-03 13:28:22'),(115398,385,'Jhonkha Ratial','176023',1,0,'2022-03-03 13:28:22','2022-03-03 13:28:22'),(115399,385,'Kachhiari','176001',1,0,'2022-03-03 13:28:22','2022-03-03 13:28:22'),(115400,385,'Kaled','176056',1,0,'2022-03-03 13:28:22','2022-03-03 13:28:22'),(115401,385,'Kaloha','177043',1,0,'2022-03-03 13:28:22','2022-03-03 13:28:22'),(115402,385,'Kandi','176054',1,0,'2022-03-03 13:28:22','2022-03-03 13:28:22'),(115403,385,'Kandor','176022',1,0,'2022-03-03 13:28:22','2022-03-03 13:28:22'),(115404,385,'Kangra H.O','176001',1,0,'2022-03-03 13:28:22','2022-03-03 13:28:22'),(115405,385,'Kangra Town','176001',1,0,'2022-03-03 13:28:22','2022-03-03 13:28:22'),(115406,385,'Kanpur','177111',1,0,'2022-03-03 13:28:22','2022-03-03 13:28:22'),(115407,385,'Karoa','177103',1,0,'2022-03-03 13:28:22','2022-03-03 13:28:22'),(115408,385,'Karyara','177117',1,0,'2022-03-03 13:28:22','2022-03-03 13:28:22'),(115409,385,'Kathog','176031',1,0,'2022-03-03 13:28:22','2022-03-03 13:28:22'),(115410,385,'Katholi','176027',1,0,'2022-03-03 13:28:22','2022-03-03 13:28:22'),(115411,385,'Katora','176027',1,0,'2022-03-03 13:28:22','2022-03-03 13:28:22'),(115412,385,'Kawari','176047',1,0,'2022-03-03 13:28:22','2022-03-03 13:28:22'),(115413,385,'Kharat','176054',1,0,'2022-03-03 13:28:22','2022-03-03 13:28:22'),(115414,385,'Kharota','176023',1,0,'2022-03-03 13:28:22','2022-03-03 13:28:22'),(115415,385,'Khatiar','176025',1,0,'2022-03-03 13:28:22','2022-03-03 13:28:22'),(115416,385,'Kherian','176028',1,0,'2022-03-03 13:28:22','2022-03-03 13:28:22'),(115417,385,'Kholi','176056',1,0,'2022-03-03 13:28:23','2022-03-03 13:28:23'),(115418,385,'Khundian','176030',1,0,'2022-03-03 13:28:23','2022-03-03 13:28:23'),(115419,385,'Kohala','176001',1,0,'2022-03-03 13:28:23','2022-03-03 13:28:23'),(115420,385,'Kohala','176036',1,0,'2022-03-03 13:28:23','2022-03-03 13:28:23'),(115421,385,'Kothandal','176022',1,0,'2022-03-03 13:28:23','2022-03-03 13:28:23'),(115422,385,'Kuhana','177043',1,0,'2022-03-03 13:28:23','2022-03-03 13:28:23'),(115423,385,'Kulthi','176038',1,0,'2022-03-03 13:28:23','2022-03-03 13:28:23'),(115424,385,'Ladwara','176208',1,0,'2022-03-03 13:28:23','2022-03-03 13:28:23'),(115425,385,'Lag','177106',1,0,'2022-03-03 13:28:23','2022-03-03 13:28:23'),(115426,385,'Lag Baliana','177107',1,0,'2022-03-03 13:28:23','2022-03-03 13:28:23'),(115427,385,'Lagroo Abrol','176031',1,0,'2022-03-03 13:28:23','2022-03-03 13:28:23'),(115428,385,'Lanj','176026',1,0,'2022-03-03 13:28:23','2022-03-03 13:28:23'),(115429,385,'Larhoon','176022',1,0,'2022-03-03 13:28:23','2022-03-03 13:28:23'),(115430,385,'Lartah','176051',1,0,'2022-03-03 13:28:23','2022-03-03 13:28:23'),(115431,385,'Lily','176056',1,0,'2022-03-03 13:28:23','2022-03-03 13:28:23'),(115432,385,'Lohara','176053',1,0,'2022-03-03 13:28:23','2022-03-03 13:28:23'),(115433,385,'Lower Ghallour','176031',1,0,'2022-03-03 13:28:23','2022-03-03 13:28:23'),(115434,385,'Lower Tipri','177112',1,0,'2022-03-03 13:28:23','2022-03-03 13:28:23'),(115435,385,'Ludret','176027',1,0,'2022-03-03 13:28:23','2022-03-03 13:28:23'),(115436,385,'Luhna','176037',1,0,'2022-03-03 13:28:23','2022-03-03 13:28:23'),(115437,385,'Madholi','176022',1,0,'2022-03-03 13:28:24','2022-03-03 13:28:24'),(115438,385,'Maherana','176214',1,0,'2022-03-03 13:28:24','2022-03-03 13:28:24'),(115439,385,'Maira','176021',1,0,'2022-03-03 13:28:24','2022-03-03 13:28:24'),(115440,385,'Maira Bani','177108',1,0,'2022-03-03 13:28:24','2022-03-03 13:28:24'),(115441,385,'Majhin','176032',1,0,'2022-03-03 13:28:24','2022-03-03 13:28:24'),(115442,385,'Makrahan','176023',1,0,'2022-03-03 13:28:24','2022-03-03 13:28:24'),(115443,385,'Makroli','176022',1,0,'2022-03-03 13:28:24','2022-03-03 13:28:24'),(115444,385,'Malan','176047',1,0,'2022-03-03 13:28:24','2022-03-03 13:28:24'),(115445,385,'Maleta Bongta','176028',1,0,'2022-03-03 13:28:24','2022-03-03 13:28:24'),(115446,385,'Mandal','176001',1,0,'2022-03-03 13:28:24','2022-03-03 13:28:24'),(115447,385,'Maniala','177108',1,0,'2022-03-03 13:28:24','2022-03-03 13:28:24'),(115448,385,'Masroor','176026',1,0,'2022-03-03 13:28:24','2022-03-03 13:28:24'),(115449,385,'Massal','176047',1,0,'2022-03-03 13:28:24','2022-03-03 13:28:24'),(115450,385,'Matlahar','176023',1,0,'2022-03-03 13:28:24','2022-03-03 13:28:24'),(115451,385,'Matour','176001',1,0,'2022-03-03 13:28:24','2022-03-03 13:28:24'),(115452,385,'Mehwa','176028',1,0,'2022-03-03 13:28:24','2022-03-03 13:28:24'),(115453,385,'Momta','176047',1,0,'2022-03-03 13:28:24','2022-03-03 13:28:24'),(115454,385,'Muhal','177117',1,0,'2022-03-03 13:28:24','2022-03-03 13:28:24'),(115455,385,'Nagan Pat','176209',1,0,'2022-03-03 13:28:24','2022-03-03 13:28:24'),(115456,385,'Nagrota Bagwan','176047',1,0,'2022-03-03 13:28:24','2022-03-03 13:28:24'),(115457,385,'Nagrota Nahan','177108',1,0,'2022-03-03 13:28:24','2022-03-03 13:28:24'),(115458,385,'Nagrota Surian','176027',1,0,'2022-03-03 13:28:24','2022-03-03 13:28:24'),(115459,385,'Nahlian','176030',1,0,'2022-03-03 13:28:24','2022-03-03 13:28:24'),(115460,385,'Naleti','177104',1,0,'2022-03-03 13:28:25','2022-03-03 13:28:25'),(115461,385,'Nalsuha','177104',1,0,'2022-03-03 13:28:25','2022-03-03 13:28:25'),(115462,385,'Nana','176023',1,0,'2022-03-03 13:28:25','2022-03-03 13:28:25'),(115463,385,'Nandehar','176001',1,0,'2022-03-03 13:28:25','2022-03-03 13:28:25'),(115464,385,'Nandpur Bhatoli','176033',1,0,'2022-03-03 13:28:25','2022-03-03 13:28:25'),(115465,385,'Nandrool','176001',1,0,'2022-03-03 13:28:25','2022-03-03 13:28:25'),(115466,385,'Naushara','176029',1,0,'2022-03-03 13:28:25','2022-03-03 13:28:25'),(115467,385,'Nehran Pukhar','177104',1,0,'2022-03-03 13:28:25','2022-03-03 13:28:25'),(115468,385,'Nerti','176208',1,0,'2022-03-03 13:28:25','2022-03-03 13:28:25'),(115469,385,'Niar','177112',1,0,'2022-03-03 13:28:25','2022-03-03 13:28:25'),(115470,385,'Nihari','177034',1,0,'2022-03-03 13:28:25','2022-03-03 13:28:25'),(115471,385,'Oie','176054',1,0,'2022-03-03 13:28:25','2022-03-03 13:28:25'),(115472,385,'Paisa','177114',1,0,'2022-03-03 13:28:25','2022-03-03 13:28:25'),(115473,385,'Palera','176029',1,0,'2022-03-03 13:28:25','2022-03-03 13:28:25'),(115474,385,'Palra','176054',1,0,'2022-03-03 13:28:25','2022-03-03 13:28:25'),(115475,385,'Panjhara','176051',1,0,'2022-03-03 13:28:25','2022-03-03 13:28:25'),(115476,385,'Panjlehar','176056',1,0,'2022-03-03 13:28:25','2022-03-03 13:28:25'),(115477,385,'Parol','176022',1,0,'2022-03-03 13:28:25','2022-03-03 13:28:25'),(115478,385,'Pathiar','176047',1,0,'2022-03-03 13:28:25','2022-03-03 13:28:25'),(115479,385,'Pharian','176023',1,0,'2022-03-03 13:28:25','2022-03-03 13:28:25'),(115480,385,'Pirsaluhi','177034',1,0,'2022-03-03 13:28:25','2022-03-03 13:28:25'),(115481,385,'Polian','176025',1,0,'2022-03-03 13:28:26','2022-03-03 13:28:26'),(115482,385,'Pragpur','177107',1,0,'2022-03-03 13:28:26','2022-03-03 13:28:26'),(115483,385,'Qusba Kotla','177111',1,0,'2022-03-03 13:28:26','2022-03-03 13:28:26'),(115484,385,'Rail','177106',1,0,'2022-03-03 13:28:26','2022-03-03 13:28:26'),(115485,385,'Rait','176208',1,0,'2022-03-03 13:28:26','2022-03-03 13:28:26'),(115486,385,'Raja Ka Talab','176051',1,0,'2022-03-03 13:28:26','2022-03-03 13:28:26'),(115487,385,'Rajal','176001',1,0,'2022-03-03 13:28:26','2022-03-03 13:28:26'),(115488,385,'Rajiana','176056',1,0,'2022-03-03 13:28:26','2022-03-03 13:28:26'),(115489,385,'Rajiana','176029',1,0,'2022-03-03 13:28:26','2022-03-03 13:28:26'),(115490,385,'Rajol','176208',1,0,'2022-03-03 13:28:26','2022-03-03 13:28:26'),(115491,385,'Rakkar','177043',1,0,'2022-03-03 13:28:26','2022-03-03 13:28:26'),(115492,385,'Ram Nagar','176022',1,0,'2022-03-03 13:28:26','2022-03-03 13:28:26'),(115493,385,'Ranital (Kangra)','176029',1,0,'2022-03-03 13:28:26','2022-03-03 13:28:26'),(115494,385,'Rehan','176022',1,0,'2022-03-03 13:28:26','2022-03-03 13:28:26'),(115495,385,'Riri','176501',1,0,'2022-03-03 13:28:26','2022-03-03 13:28:26'),(115496,385,'Rounkhar','176056',1,0,'2022-03-03 13:28:26','2022-03-03 13:28:26'),(115497,385,'Sadun Bargran','176037',1,0,'2022-03-03 13:28:26','2022-03-03 13:28:26'),(115498,385,'Sahaura','176209',1,0,'2022-03-03 13:28:26','2022-03-03 13:28:26'),(115499,385,'Sakout','176001',1,0,'2022-03-03 13:28:26','2022-03-03 13:28:26'),(115500,385,'Saleti','177043',1,0,'2022-03-03 13:28:26','2022-03-03 13:28:26'),(115501,385,'Salihar','176031',1,0,'2022-03-03 13:28:26','2022-03-03 13:28:26'),(115502,385,'Salol','176214',1,0,'2022-03-03 13:28:26','2022-03-03 13:28:26'),(115503,385,'Samela','176001',1,0,'2022-03-03 13:28:26','2022-03-03 13:28:26'),(115504,385,'Samloti','176056',1,0,'2022-03-03 13:28:26','2022-03-03 13:28:26'),(115505,385,'Sansarpur Terrace','176501',1,0,'2022-03-03 13:28:26','2022-03-03 13:28:26'),(115506,385,'Sarad Dogri','177043',1,0,'2022-03-03 13:28:27','2022-03-03 13:28:27'),(115507,385,'Sarotri','176037',1,0,'2022-03-03 13:28:27','2022-03-03 13:28:27'),(115508,385,'Sathana','176025',1,0,'2022-03-03 13:28:27','2022-03-03 13:28:27'),(115509,385,'Sehri','177108',1,0,'2022-03-03 13:28:27','2022-03-03 13:28:27'),(115510,385,'Sehund','176056',1,0,'2022-03-03 13:28:27','2022-03-03 13:28:27'),(115511,385,'Serathana','176056',1,0,'2022-03-03 13:28:27','2022-03-03 13:28:27'),(115512,385,'Seul','177112',1,0,'2022-03-03 13:28:27','2022-03-03 13:28:27'),(115513,385,'Shamirpur','176214',1,0,'2022-03-03 13:28:27','2022-03-03 13:28:27'),(115514,385,'Sialkar','176032',1,0,'2022-03-03 13:28:27','2022-03-03 13:28:27'),(115515,385,'Sidhpur Ghar','176021',1,0,'2022-03-03 13:28:27','2022-03-03 13:28:27'),(115516,385,'Sihal','176053',1,0,'2022-03-03 13:28:27','2022-03-03 13:28:27'),(115517,385,'Sihorpain','176031',1,0,'2022-03-03 13:28:27','2022-03-03 13:28:27'),(115518,385,'Silh','176036',1,0,'2022-03-03 13:28:27','2022-03-03 13:28:27'),(115519,385,'Spail','176026',1,0,'2022-03-03 13:28:27','2022-03-03 13:28:27'),(115520,385,'Suder Lahar','176030',1,0,'2022-03-03 13:28:27','2022-03-03 13:28:27'),(115521,385,'Sudhangal','176036',1,0,'2022-03-03 13:28:27','2022-03-03 13:28:27'),(115522,385,'Suhin','177108',1,0,'2022-03-03 13:28:27','2022-03-03 13:28:27'),(115523,385,'Sukhara Choudrian','176051',1,0,'2022-03-03 13:28:27','2022-03-03 13:28:27'),(115524,385,'Sunehar','176056',1,0,'2022-03-03 13:28:27','2022-03-03 13:28:27'),(115525,385,'Sunet','176053',1,0,'2022-03-03 13:28:28','2022-03-03 13:28:28'),(115526,385,'Sunhara','176053',1,0,'2022-03-03 13:28:28','2022-03-03 13:28:28'),(115527,385,'Sunhet','177104',1,0,'2022-03-03 13:28:28','2022-03-03 13:28:28'),(115528,385,'Sunhi','176037',1,0,'2022-03-03 13:28:28','2022-03-03 13:28:28'),(115529,385,'Surani','176031',1,0,'2022-03-03 13:28:28','2022-03-03 13:28:28'),(115530,385,'Takoli Girthan','176021',1,0,'2022-03-03 13:28:28','2022-03-03 13:28:28'),(115531,385,'Talara','176051',1,0,'2022-03-03 13:28:28','2022-03-03 13:28:28'),(115532,385,'Tanda','176001',1,0,'2022-03-03 13:28:28','2022-03-03 13:28:28'),(115533,385,'Tatwani','176208',1,0,'2022-03-03 13:28:28','2022-03-03 13:28:28'),(115534,385,'Thakurdawara','176029',1,0,'2022-03-03 13:28:28','2022-03-03 13:28:28'),(115535,385,'Thana Bargan','176037',1,0,'2022-03-03 13:28:28','2022-03-03 13:28:28'),(115536,385,'Thill','176055',1,0,'2022-03-03 13:28:28','2022-03-03 13:28:28'),(115537,385,'Thore','177105',1,0,'2022-03-03 13:28:28','2022-03-03 13:28:28'),(115538,385,'Tiambal','177113',1,0,'2022-03-03 13:28:28','2022-03-03 13:28:28'),(115539,385,'Tiara','176214',1,0,'2022-03-03 13:28:28','2022-03-03 13:28:28'),(115540,385,'Tihri','176032',1,0,'2022-03-03 13:28:28','2022-03-03 13:28:28'),(115541,385,'Tikkar','177034',1,0,'2022-03-03 13:28:28','2022-03-03 13:28:28'),(115542,385,'Tipri','177112',1,0,'2022-03-03 13:28:28','2022-03-03 13:28:28'),(115543,385,'Trippal','176029',1,0,'2022-03-03 13:28:28','2022-03-03 13:28:28'),(115544,385,'Uppli Kothi','176047',1,0,'2022-03-03 13:28:28','2022-03-03 13:28:28'),(115545,385,'Yol-jharer','176208',1,0,'2022-03-03 13:28:28','2022-03-03 13:28:28'),(115546,385,'Zamanabad','176001',1,0,'2022-03-03 13:28:28','2022-03-03 13:28:28'),(115547,385,'Agahar','176058',1,0,'2022-03-03 13:28:29','2022-03-03 13:28:29'),(115548,385,'Alampur (Kangra)','176082',1,0,'2022-03-03 13:28:29','2022-03-03 13:28:29'),(115549,385,'Andreta','176103',1,0,'2022-03-03 13:28:29','2022-03-03 13:28:29'),(115550,385,'Ansuhi','176217',1,0,'2022-03-03 13:28:29','2022-03-03 13:28:29'),(115551,385,'Arla','176102',1,0,'2022-03-03 13:28:29','2022-03-03 13:28:29'),(115552,385,'Arth Jhikli','176059',1,0,'2022-03-03 13:28:29','2022-03-03 13:28:29'),(115553,385,'Ashapuri','176094',1,0,'2022-03-03 13:28:29','2022-03-03 13:28:29'),(115554,385,'Atiala Dai','176083',1,0,'2022-03-03 13:28:29','2022-03-03 13:28:29'),(115555,385,'Attarah','176204',1,0,'2022-03-03 13:28:29','2022-03-03 13:28:29'),(115556,385,'Auc Palampur','176062',1,0,'2022-03-03 13:28:29','2022-03-03 13:28:29'),(115557,385,'Aundh','176202',1,0,'2022-03-03 13:28:29','2022-03-03 13:28:29'),(115558,385,'Bachhwai','176107',1,0,'2022-03-03 13:28:29','2022-03-03 13:28:29'),(115559,385,'Badiarkhar','176081',1,0,'2022-03-03 13:28:30','2022-03-03 13:28:30'),(115560,385,'Baduhi','176201',1,0,'2022-03-03 13:28:30','2022-03-03 13:28:30'),(115561,385,'Bagga','176225',1,0,'2022-03-03 13:28:30','2022-03-03 13:28:30'),(115562,385,'Bagora','176059',1,0,'2022-03-03 13:28:30','2022-03-03 13:28:30'),(115563,385,'Bahadpur','176058',1,0,'2022-03-03 13:28:30','2022-03-03 13:28:30'),(115564,385,'Bahi','176125',1,0,'2022-03-03 13:28:30','2022-03-03 13:28:30'),(115565,385,'Bahi Pathiar','176205',1,0,'2022-03-03 13:28:30','2022-03-03 13:28:30'),(115566,385,'Bai-da-patt','176086',1,0,'2022-03-03 13:28:30','2022-03-03 13:28:30'),(115567,385,'Baijnath (Kangra)','176125',1,0,'2022-03-03 13:28:30','2022-03-03 13:28:30'),(115568,385,'Bairhgat','176073',1,0,'2022-03-03 13:28:30','2022-03-03 13:28:30'),(115569,385,'Balahra','176098',1,0,'2022-03-03 13:28:30','2022-03-03 13:28:30'),(115570,385,'Balakh','176204',1,0,'2022-03-03 13:28:30','2022-03-03 13:28:30'),(115571,385,'Balakrupi','176082',1,0,'2022-03-03 13:28:30','2022-03-03 13:28:30'),(115572,385,'Baleer','176403',1,0,'2022-03-03 13:28:30','2022-03-03 13:28:30'),(115573,385,'Ballah','176064',1,0,'2022-03-03 13:28:30','2022-03-03 13:28:30'),(115574,385,'Balota','176084',1,0,'2022-03-03 13:28:30','2022-03-03 13:28:30'),(115575,385,'Bandahu','176073',1,0,'2022-03-03 13:28:30','2022-03-03 13:28:30'),(115576,385,'Bandla Tea Estate','176061',1,0,'2022-03-03 13:28:31','2022-03-03 13:28:31'),(115577,385,'Banuri','176061',1,0,'2022-03-03 13:28:31','2022-03-03 13:28:31'),(115578,385,'Baranda','176201',1,0,'2022-03-03 13:28:31','2022-03-03 13:28:31'),(115579,385,'Bari','176083',1,0,'2022-03-03 13:28:31','2022-03-03 13:28:31'),(115580,385,'Barram Khurd','176097',1,0,'2022-03-03 13:28:31','2022-03-03 13:28:31'),(115581,385,'Basa Baziran','176201',1,0,'2022-03-03 13:28:31','2022-03-03 13:28:31'),(115582,385,'Basantpur','176403',1,0,'2022-03-03 13:28:31','2022-03-03 13:28:31'),(115583,385,'Bhadraina','176061',1,0,'2022-03-03 13:28:31','2022-03-03 13:28:31'),(115584,385,'Bhadrol','176101',1,0,'2022-03-03 13:28:31','2022-03-03 13:28:31'),(115585,385,'Bhadroya','176403',1,0,'2022-03-03 13:28:31','2022-03-03 13:28:31'),(115586,385,'Bhadwar','176200',1,0,'2022-03-03 13:28:31','2022-03-03 13:28:31'),(115587,385,'Bhagotla','176059',1,0,'2022-03-03 13:28:31','2022-03-03 13:28:31'),(115588,385,'Bhagsu Nath','176219',1,0,'2022-03-03 13:28:31','2022-03-03 13:28:31'),(115589,385,'Bhaleta','176201',1,0,'2022-03-03 13:28:31','2022-03-03 13:28:31'),(115590,385,'Bhalli','176206',1,0,'2022-03-03 13:28:31','2022-03-03 13:28:31'),(115591,385,'Bhanala','176206',1,0,'2022-03-03 13:28:32','2022-03-03 13:28:32'),(115592,385,'Bhapoo','176401',1,0,'2022-03-03 13:28:32','2022-03-03 13:28:32'),(115593,385,'Bharup Lahar','176210',1,0,'2022-03-03 13:28:32','2022-03-03 13:28:32'),(115594,385,'Bharwana','176103',1,0,'2022-03-03 13:28:32','2022-03-03 13:28:32'),(115595,385,'Bhattoo Samula','176064',1,0,'2022-03-03 13:28:32','2022-03-03 13:28:32'),(115596,385,'Bhatu','176125',1,0,'2022-03-03 13:28:32','2022-03-03 13:28:32'),(115597,385,'Bhatwan','176098',1,0,'2022-03-03 13:28:32','2022-03-03 13:28:32'),(115598,385,'Bhawana','176076',1,0,'2022-03-03 13:28:32','2022-03-03 13:28:32'),(115599,385,'Bhawarna','176083',1,0,'2022-03-03 13:28:32','2022-03-03 13:28:32'),(115600,385,'Bheri','176082',1,0,'2022-03-03 13:28:32','2022-03-03 13:28:32'),(115601,385,'Bhirri','176088',1,0,'2022-03-03 13:28:32','2022-03-03 13:28:32'),(115602,385,'Bhogarwan','176401',1,0,'2022-03-03 13:28:32','2022-03-03 13:28:32'),(115603,385,'Bhojpur','176402',1,0,'2022-03-03 13:28:32','2022-03-03 13:28:32'),(115604,385,'Bhonka','176225',1,0,'2022-03-03 13:28:32','2022-03-03 13:28:32'),(115605,385,'Bhoura','176087',1,0,'2022-03-03 13:28:32','2022-03-03 13:28:32'),(115606,385,'Bhugnara','176201',1,0,'2022-03-03 13:28:32','2022-03-03 13:28:32'),(115607,385,'Bhullanaso','176071',1,0,'2022-03-03 13:28:32','2022-03-03 13:28:32'),(115608,385,'Biara','176103',1,0,'2022-03-03 13:28:32','2022-03-03 13:28:32'),(115609,385,'Bindravan','176061',1,0,'2022-03-03 13:28:32','2022-03-03 13:28:32'),(115610,385,'Bir (Kangra)','176077',1,0,'2022-03-03 13:28:32','2022-03-03 13:28:32'),(115611,385,'Boda Lauhanti','176092',1,0,'2022-03-03 13:28:33','2022-03-03 13:28:33'),(115612,385,'Boda Lower','176083',1,0,'2022-03-03 13:28:33','2022-03-03 13:28:33'),(115613,385,'Boh','176206',1,0,'2022-03-03 13:28:33','2022-03-03 13:28:33'),(115614,385,'Chachian','176059',1,0,'2022-03-03 13:28:33','2022-03-03 13:28:33'),(115615,385,'Chadhiar','176088',1,0,'2022-03-03 13:28:33','2022-03-03 13:28:33'),(115616,385,'Chaloh','176204',1,0,'2022-03-03 13:28:33','2022-03-03 13:28:33'),(115617,385,'Chanaur','176401',1,0,'2022-03-03 13:28:33','2022-03-03 13:28:33'),(115618,385,'Chandpur','176061',1,0,'2022-03-03 13:28:33','2022-03-03 13:28:33'),(115619,385,'Charri','176217',1,0,'2022-03-03 13:28:33','2022-03-03 13:28:33'),(115620,385,'Chhanni','176403',1,0,'2022-03-03 13:28:33','2022-03-03 13:28:33'),(115621,385,'Chhenchheri','176086',1,0,'2022-03-03 13:28:33','2022-03-03 13:28:33'),(115622,385,'Chobin','176128',1,0,'2022-03-03 13:28:33','2022-03-03 13:28:33'),(115623,385,'Chowki','176084',1,0,'2022-03-03 13:28:33','2022-03-03 13:28:33'),(115624,385,'Chowki','176203',1,0,'2022-03-03 13:28:33','2022-03-03 13:28:33'),(115625,385,'Chowki Khalet','176061',1,0,'2022-03-03 13:28:33','2022-03-03 13:28:33'),(115626,385,'Dadh','176052',1,0,'2022-03-03 13:28:33','2022-03-03 13:28:33'),(115627,385,'Dagera','176107',1,0,'2022-03-03 13:28:33','2022-03-03 13:28:33'),(115628,385,'Dagoh','176076',1,0,'2022-03-03 13:28:33','2022-03-03 13:28:33'),(115629,385,'Dah','176402',1,0,'2022-03-03 13:28:33','2022-03-03 13:28:33'),(115630,385,'Dain','176101',1,0,'2022-03-03 13:28:33','2022-03-03 13:28:33'),(115631,385,'Dainkwan','176204',1,0,'2022-03-03 13:28:34','2022-03-03 13:28:34'),(115632,385,'Dal Lake','176216',1,0,'2022-03-03 13:28:34','2022-03-03 13:28:34'),(115633,385,'Damtal','176403',1,0,'2022-03-03 13:28:34','2022-03-03 13:28:34'),(115634,385,'Danni','176203',1,0,'2022-03-03 13:28:34','2022-03-03 13:28:34'),(115635,385,'Daraman','176206',1,0,'2022-03-03 13:28:34','2022-03-03 13:28:34'),(115636,385,'Darang','176060',1,0,'2022-03-03 13:28:34','2022-03-03 13:28:34'),(115637,385,'Dari','176057',1,0,'2022-03-03 13:28:34','2022-03-03 13:28:34'),(115638,385,'Darini','176206',1,0,'2022-03-03 13:28:34','2022-03-03 13:28:34'),(115639,385,'Daroh','176092',1,0,'2022-03-03 13:28:34','2022-03-03 13:28:34'),(115640,385,'Dehan','176102',1,0,'2022-03-03 13:28:34','2022-03-03 13:28:34'),(115641,385,'Deogram','176061',1,0,'2022-03-03 13:28:34','2022-03-03 13:28:34'),(115642,385,'Deol','176125',1,0,'2022-03-03 13:28:34','2022-03-03 13:28:34'),(115643,385,'Dhanag','176125',1,0,'2022-03-03 13:28:34','2022-03-03 13:28:34'),(115644,385,'Dhandhol','176128',1,0,'2022-03-03 13:28:34','2022-03-03 13:28:34'),(115645,385,'Dhar','176210',1,0,'2022-03-03 13:28:34','2022-03-03 13:28:34'),(115646,385,'Dharamsala Cantt','176216',1,0,'2022-03-03 13:28:34','2022-03-03 13:28:34'),(115647,385,'Dharamsala H.O','176215',1,0,'2022-03-03 13:28:34','2022-03-03 13:28:34'),(115648,385,'Dharer','176125',1,0,'2022-03-03 13:28:34','2022-03-03 13:28:34'),(115649,385,'Dharoon','176205',1,0,'2022-03-03 13:28:34','2022-03-03 13:28:34'),(115650,385,'Dheera','176101',1,0,'2022-03-03 13:28:34','2022-03-03 13:28:34'),(115651,385,'Dhoran','176060',1,0,'2022-03-03 13:28:34','2022-03-03 13:28:34'),(115652,385,'Dhupkiara','176096',1,0,'2022-03-03 13:28:34','2022-03-03 13:28:34'),(115653,385,'Diana','176058',1,0,'2022-03-03 13:28:34','2022-03-03 13:28:34'),(115654,385,'Dodhamb','176217',1,0,'2022-03-03 13:28:35','2022-03-03 13:28:35'),(115655,385,'Dohb','176206',1,0,'2022-03-03 13:28:35','2022-03-03 13:28:35'),(115656,385,'Dole','176210',1,0,'2022-03-03 13:28:35','2022-03-03 13:28:35'),(115657,385,'Draman','176094',1,0,'2022-03-03 13:28:35','2022-03-03 13:28:35'),(115658,385,'Drug','176071',1,0,'2022-03-03 13:28:35','2022-03-03 13:28:35'),(115659,385,'Duhak','176075',1,0,'2022-03-03 13:28:35','2022-03-03 13:28:35'),(115660,385,'Durgella','176206',1,0,'2022-03-03 13:28:35','2022-03-03 13:28:35'),(115661,385,'Fatu Ka Bag','176204',1,0,'2022-03-03 13:28:35','2022-03-03 13:28:35'),(115662,385,'Gadiara','176065',1,0,'2022-03-03 13:28:35','2022-03-03 13:28:35'),(115663,385,'Gaggal Khas','176101',1,0,'2022-03-03 13:28:35','2022-03-03 13:28:35'),(115664,385,'Gaggal Kholi','176101',1,0,'2022-03-03 13:28:35','2022-03-03 13:28:35'),(115665,385,'Gahin Lagore','176202',1,0,'2022-03-03 13:28:35','2022-03-03 13:28:35'),(115666,385,'Galoti','176107',1,0,'2022-03-03 13:28:35','2022-03-03 13:28:35'),(115667,385,'Gandhi Gram','176125',1,0,'2022-03-03 13:28:35','2022-03-03 13:28:35'),(115668,385,'Gandwal','176201',1,0,'2022-03-03 13:28:35','2022-03-03 13:28:35'),(115669,385,'Gangtha','176204',1,0,'2022-03-03 13:28:36','2022-03-03 13:28:36'),(115670,385,'Garh Jamula','176092',1,0,'2022-03-03 13:28:36','2022-03-03 13:28:36'),(115671,385,'Garla Dai','176085',1,0,'2022-03-03 13:28:36','2022-03-03 13:28:36'),(115672,385,'Gawal','176128',1,0,'2022-03-03 13:28:36','2022-03-03 13:28:36'),(115673,385,'Geeta Peeth','176061',1,0,'2022-03-03 13:28:36','2022-03-03 13:28:36'),(115674,385,'Geora','176201',1,0,'2022-03-03 13:28:36','2022-03-03 13:28:36'),(115675,385,'Ghandran','176401',1,0,'2022-03-03 13:28:36','2022-03-03 13:28:36'),(115676,385,'Ghaneta','176060',1,0,'2022-03-03 13:28:36','2022-03-03 13:28:36'),(115677,385,'Ghar','176103',1,0,'2022-03-03 13:28:36','2022-03-03 13:28:36'),(115678,385,'Gharana','176084',1,0,'2022-03-03 13:28:36','2022-03-03 13:28:36'),(115679,385,'Gharoh','176217',1,0,'2022-03-03 13:28:36','2022-03-03 13:28:36'),(115680,385,'Ghartholi','176125',1,0,'2022-03-03 13:28:36','2022-03-03 13:28:36'),(115681,385,'Gheta','176204',1,0,'2022-03-03 13:28:36','2022-03-03 13:28:36'),(115682,385,'Ghuggar','176061',1,0,'2022-03-03 13:28:36','2022-03-03 13:28:36'),(115683,385,'Gopalpur','176059',1,0,'2022-03-03 13:28:36','2022-03-03 13:28:36'),(115684,385,'Gunehar','176077',1,0,'2022-03-03 13:28:36','2022-03-03 13:28:36'),(115685,385,'Gurchal','176202',1,0,'2022-03-03 13:28:36','2022-03-03 13:28:36'),(115686,385,'Hadal Uparli','176211',1,0,'2022-03-03 13:28:36','2022-03-03 13:28:36'),(115687,385,'Haded','176115',1,0,'2022-03-03 13:28:36','2022-03-03 13:28:36'),(115688,385,'Haler','176091',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115689,385,'Hangloh','176059',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115690,385,'Harchakian','176210',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115691,385,'Harnera','176206',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115692,385,'Harrot','176095',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115693,385,'Harsi','176091',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115694,385,'Hatli','176058',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115695,385,'Hatli Jamwala','176200',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115696,385,'Hpbose Dharamsala','176213',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115697,385,'Indora','176401',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115698,385,'Indpur','176401',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115699,385,'Jagrup Nagar','176082',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115700,385,'Jaind','176086',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115701,385,'Jaisinghpur (Kangra)','176095',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115702,385,'Jalag','176094',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115703,385,'Jangal','176082',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115704,385,'Jassur','176201',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115705,385,'Jaunta','176205',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115706,385,'Jhamoon','176088',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115707,385,'Jharet Jaggian','176060',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115708,385,'Jharundi','176098',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115709,385,'Jhikli Bheth','176081',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115710,385,'Jia','176059',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115711,385,'Kachhera','176076',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115712,385,'Kahanpat','176101',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115713,385,'Kailashpur','176076',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115714,385,'Kakrain','176085',1,0,'2022-03-03 13:28:37','2022-03-03 13:28:37'),(115715,385,'Kallon','176086',1,0,'2022-03-03 13:28:38','2022-03-03 13:28:38'),(115716,385,'Kamlehar','176061',1,0,'2022-03-03 13:28:38','2022-03-03 13:28:38'),(115717,385,'Kandgawal Tikker','176061',1,0,'2022-03-03 13:28:38','2022-03-03 13:28:38'),(115718,385,'Kandi','176061',1,0,'2022-03-03 13:28:38','2022-03-03 13:28:38'),(115719,385,'Kandral','176115',1,0,'2022-03-03 13:28:38','2022-03-03 13:28:38'),(115720,385,'Kandrori','176402',1,0,'2022-03-03 13:28:38','2022-03-03 13:28:38'),(115721,385,'Karanghat','176095',1,0,'2022-03-03 13:28:38','2022-03-03 13:28:38'),(115722,385,'Kardiana','176052',1,0,'2022-03-03 13:28:38','2022-03-03 13:28:38'),(115723,385,'Kareri','176216',1,0,'2022-03-03 13:28:38','2022-03-03 13:28:38'),(115724,385,'Kasba Punner','176083',1,0,'2022-03-03 13:28:38','2022-03-03 13:28:38'),(115725,385,'Kathgarh','176401',1,0,'2022-03-03 13:28:38','2022-03-03 13:28:38'),(115726,385,'Khail','176200',1,0,'2022-03-03 13:28:38','2022-03-03 13:28:38'),(115727,385,'Khaniara','176218',1,0,'2022-03-03 13:28:38','2022-03-03 13:28:38'),(115728,385,'Khanni','176201',1,0,'2022-03-03 13:28:38','2022-03-03 13:28:38'),(115729,385,'Kharanal','176115',1,0,'2022-03-03 13:28:38','2022-03-03 13:28:38'),(115730,385,'Kharuhal','176092',1,0,'2022-03-03 13:28:38','2022-03-03 13:28:38'),(115731,385,'Khawara','176211',1,0,'2022-03-03 13:28:38','2022-03-03 13:28:38'),(115732,385,'Khera','176086',1,0,'2022-03-03 13:28:38','2022-03-03 13:28:38'),(115733,385,'Kherian','176200',1,0,'2022-03-03 13:28:38','2022-03-03 13:28:38'),(115734,385,'Khopa','176128',1,0,'2022-03-03 13:28:38','2022-03-03 13:28:38'),(115735,385,'Khushi Nagar','176202',1,0,'2022-03-03 13:28:38','2022-03-03 13:28:38'),(115736,385,'Kiarban','176084',1,0,'2022-03-03 13:28:38','2022-03-03 13:28:38'),(115737,385,'Kona','176107',1,0,'2022-03-03 13:28:39','2022-03-03 13:28:39'),(115738,385,'Kona','176093',1,0,'2022-03-03 13:28:39','2022-03-03 13:28:39'),(115739,385,'Kopra','176202',1,0,'2022-03-03 13:28:39','2022-03-03 13:28:39'),(115740,385,'Kosri','176096',1,0,'2022-03-03 13:28:39','2022-03-03 13:28:39'),(115741,385,'Kot Palahari','176200',1,0,'2022-03-03 13:28:39','2022-03-03 13:28:39'),(115742,385,'Kothi','176088',1,0,'2022-03-03 13:28:39','2022-03-03 13:28:39'),(115743,385,'Kotla Mangwal','176204',1,0,'2022-03-03 13:28:39','2022-03-03 13:28:39'),(115744,385,'Kotla (Kangra)','176205',1,0,'2022-03-03 13:28:39','2022-03-03 13:28:39'),(115745,385,'Kotlu','176096',1,0,'2022-03-03 13:28:39','2022-03-03 13:28:39'),(115746,385,'Kotwali Bazar Dharamsala','176215',1,0,'2022-03-03 13:28:39','2022-03-03 13:28:39'),(115747,385,'Kudail','176128',1,0,'2022-03-03 13:28:39','2022-03-03 13:28:39'),(115748,385,'Kuhan','176098',1,0,'2022-03-03 13:28:39','2022-03-03 13:28:39'),(115749,385,'Kukher','176211',1,0,'2022-03-03 13:28:39','2022-03-03 13:28:39'),(115750,385,'Kural','176058',1,0,'2022-03-03 13:28:39','2022-03-03 13:28:39'),(115751,385,'Kural','176083',1,0,'2022-03-03 13:28:39','2022-03-03 13:28:39'),(115752,385,'Kutharna','176217',1,0,'2022-03-03 13:28:39','2022-03-03 13:28:39'),(115753,385,'Kuther','176225',1,0,'2022-03-03 13:28:39','2022-03-03 13:28:39'),(115754,385,'Ladori','176203',1,0,'2022-03-03 13:28:39','2022-03-03 13:28:39'),(115755,385,'Lahat','176086',1,0,'2022-03-03 13:28:39','2022-03-03 13:28:39'),(115756,385,'Lahla','176059',1,0,'2022-03-03 13:28:39','2022-03-03 13:28:39'),(115757,385,'Lahru','176098',1,0,'2022-03-03 13:28:39','2022-03-03 13:28:39'),(115758,385,'Lambagaon','176096',1,0,'2022-03-03 13:28:39','2022-03-03 13:28:39'),(115759,385,'Lapiana','176210',1,0,'2022-03-03 13:28:40','2022-03-03 13:28:40'),(115760,385,'Lathial','176058',1,0,'2022-03-03 13:28:40','2022-03-03 13:28:40'),(115761,385,'Lodhwan','176201',1,0,'2022-03-03 13:28:40','2022-03-03 13:28:40'),(115762,385,'Lower Averi','176081',1,0,'2022-03-03 13:28:40','2022-03-03 13:28:40'),(115763,385,'Mahalpat','176125',1,0,'2022-03-03 13:28:40','2022-03-03 13:28:40'),(115764,385,'Mahankal','176125',1,0,'2022-03-03 13:28:40','2022-03-03 13:28:40'),(115765,385,'Maharajnagar','176096',1,0,'2022-03-03 13:28:40','2022-03-03 13:28:40'),(115766,385,'Maila','176089',1,0,'2022-03-03 13:28:40','2022-03-03 13:28:40'),(115767,385,'Majherna','176063',1,0,'2022-03-03 13:28:40','2022-03-03 13:28:40'),(115768,385,'Majhoti','176089',1,0,'2022-03-03 13:28:40','2022-03-03 13:28:40'),(115769,385,'Makol','176076',1,0,'2022-03-03 13:28:40','2022-03-03 13:28:40'),(115770,385,'Malahari','176401',1,0,'2022-03-03 13:28:40','2022-03-03 13:28:40'),(115771,385,'Malahu','176087',1,0,'2022-03-03 13:28:40','2022-03-03 13:28:40'),(115772,385,'Malkher','176093',1,0,'2022-03-03 13:28:40','2022-03-03 13:28:40'),(115773,385,'Malnoo','176083',1,0,'2022-03-03 13:28:40','2022-03-03 13:28:40'),(115774,385,'Man Simble','176083',1,0,'2022-03-03 13:28:40','2022-03-03 13:28:40'),(115775,385,'Manai','176210',1,0,'2022-03-03 13:28:41','2022-03-03 13:28:41'),(115776,385,'Mand Manjwan','176403',1,0,'2022-03-03 13:28:41','2022-03-03 13:28:41'),(115777,385,'Mandher','176125',1,0,'2022-03-03 13:28:41','2022-03-03 13:28:41'),(115778,385,'Manoh','176217',1,0,'2022-03-03 13:28:41','2022-03-03 13:28:41'),(115779,385,'Maranda','176102',1,0,'2022-03-03 13:28:41','2022-03-03 13:28:41'),(115780,385,'Marera','176097',1,0,'2022-03-03 13:28:41','2022-03-03 13:28:41'),(115781,385,'Marhoon','176092',1,0,'2022-03-03 13:28:41','2022-03-03 13:28:41'),(115782,385,'Mastgarh','176205',1,0,'2022-03-03 13:28:41','2022-03-03 13:28:41'),(115783,385,'Matyal','176088',1,0,'2022-03-03 13:28:41','2022-03-03 13:28:41'),(115784,385,'Mcleodganj','176219',1,0,'2022-03-03 13:28:41','2022-03-03 13:28:41'),(115785,385,'Menjha','176061',1,0,'2022-03-03 13:28:41','2022-03-03 13:28:41'),(115786,385,'Minjhgram','176200',1,0,'2022-03-03 13:28:41','2022-03-03 13:28:41'),(115787,385,'Mohatli','176403',1,0,'2022-03-03 13:28:41','2022-03-03 13:28:41'),(115788,385,'Molag','176089',1,0,'2022-03-03 13:28:41','2022-03-03 13:28:41'),(115789,385,'Mundhi','176092',1,0,'2022-03-03 13:28:41','2022-03-03 13:28:41'),(115790,385,'Mungal Galoo','176088',1,0,'2022-03-03 13:28:42','2022-03-03 13:28:42'),(115791,385,'Nachhir','176061',1,0,'2022-03-03 13:28:42','2022-03-03 13:28:42'),(115792,385,'Nadli','176103',1,0,'2022-03-03 13:28:42','2022-03-03 13:28:42'),(115793,385,'Nadoli','176225',1,0,'2022-03-03 13:28:42','2022-03-03 13:28:42'),(115794,385,'Nagehar','176128',1,0,'2022-03-03 13:28:42','2022-03-03 13:28:42'),(115795,385,'Nagni','176200',1,0,'2022-03-03 13:28:42','2022-03-03 13:28:42'),(115796,385,'Nahlana','176094',1,0,'2022-03-03 13:28:42','2022-03-03 13:28:42'),(115797,385,'Nanaon','176085',1,0,'2022-03-03 13:28:42','2022-03-03 13:28:42'),(115798,385,'Nangal','176058',1,0,'2022-03-03 13:28:42','2022-03-03 13:28:42'),(115799,385,'Nanwar','176088',1,0,'2022-03-03 13:28:42','2022-03-03 13:28:42'),(115800,385,'Narwana','176052',1,0,'2022-03-03 13:28:42','2022-03-03 13:28:42'),(115801,385,'Netru','176095',1,0,'2022-03-03 13:28:42','2022-03-03 13:28:42'),(115802,385,'Niazpur','176202',1,0,'2022-03-03 13:28:42','2022-03-03 13:28:42'),(115803,385,'Nohra','176125',1,0,'2022-03-03 13:28:42','2022-03-03 13:28:42'),(115804,385,'Noura','176084',1,0,'2022-03-03 13:28:42','2022-03-03 13:28:42'),(115805,385,'Nurpur','176202',1,0,'2022-03-03 13:28:42','2022-03-03 13:28:42'),(115806,385,'Olehrian','176403',1,0,'2022-03-03 13:28:42','2022-03-03 13:28:42'),(115807,385,'Paddar','176052',1,0,'2022-03-03 13:28:42','2022-03-03 13:28:42'),(115808,385,'Pahra','176087',1,0,'2022-03-03 13:28:42','2022-03-03 13:28:42'),(115809,385,'Palampur H.O','176061',1,0,'2022-03-03 13:28:42','2022-03-03 13:28:42'),(115810,385,'Panapar','176064',1,0,'2022-03-03 13:28:42','2022-03-03 13:28:42'),(115811,385,'Panchrukhi','176103',1,0,'2022-03-03 13:28:42','2022-03-03 13:28:42'),(115812,385,'Paniali','176101',1,0,'2022-03-03 13:28:42','2022-03-03 13:28:42'),(115813,385,'Pantehar','176057',1,0,'2022-03-03 13:28:43','2022-03-03 13:28:43'),(115814,385,'Paplah','176073',1,0,'2022-03-03 13:28:43','2022-03-03 13:28:43'),(115815,385,'Paprola','176115',1,0,'2022-03-03 13:28:43','2022-03-03 13:28:43'),(115816,385,'Paral','176403',1,0,'2022-03-03 13:28:43','2022-03-03 13:28:43'),(115817,385,'Paraur','176064',1,0,'2022-03-03 13:28:43','2022-03-03 13:28:43'),(115818,385,'Pargore','176210',1,0,'2022-03-03 13:28:43','2022-03-03 13:28:43'),(115819,385,'Patti','176061',1,0,'2022-03-03 13:28:43','2022-03-03 13:28:43'),(115820,385,'Pharer','176064',1,0,'2022-03-03 13:28:43','2022-03-03 13:28:43'),(115821,385,'Phattahar','176125',1,0,'2022-03-03 13:28:43','2022-03-03 13:28:43'),(115822,385,'Punner','176083',1,0,'2022-03-03 13:28:43','2022-03-03 13:28:43'),(115823,385,'Purba','176084',1,0,'2022-03-03 13:28:43','2022-03-03 13:28:43'),(115824,385,'Raipur','176085',1,0,'2022-03-03 13:28:43','2022-03-03 13:28:43'),(115825,385,'Raja Ka Bagh','176201',1,0,'2022-03-03 13:28:43','2022-03-03 13:28:43'),(115826,385,'Raja Khasa','176402',1,0,'2022-03-03 13:28:43','2022-03-03 13:28:43'),(115827,385,'Rajehar','176061',1,0,'2022-03-03 13:28:43','2022-03-03 13:28:43'),(115828,385,'Rajhoon','176065',1,0,'2022-03-03 13:28:43','2022-03-03 13:28:43'),(115829,385,'Rajot','176063',1,0,'2022-03-03 13:28:43','2022-03-03 13:28:43'),(115830,385,'Rajpur','176061',1,0,'2022-03-03 13:28:43','2022-03-03 13:28:43'),(115831,385,'Rakh','176059',1,0,'2022-03-03 13:28:44','2022-03-03 13:28:44'),(115832,385,'Rakkar','176057',1,0,'2022-03-03 13:28:44','2022-03-03 13:28:44'),(115833,385,'Rakker','176063',1,0,'2022-03-03 13:28:44','2022-03-03 13:28:44'),(115834,385,'Ramehar','176083',1,0,'2022-03-03 13:28:44','2022-03-03 13:28:44'),(115835,385,'Ramehar','176052',1,0,'2022-03-03 13:28:44','2022-03-03 13:28:44'),(115836,385,'Rananagar','176089',1,0,'2022-03-03 13:28:44','2022-03-03 13:28:44'),(115837,385,'Rappar','176204',1,0,'2022-03-03 13:28:44','2022-03-03 13:28:44'),(115838,385,'Rehlu','176206',1,0,'2022-03-03 13:28:44','2022-03-03 13:28:44'),(115839,385,'Rey','176058',1,0,'2022-03-03 13:28:44','2022-03-03 13:28:44'),(115840,385,'Riali','176058',1,0,'2022-03-03 13:28:44','2022-03-03 13:28:44'),(115841,385,'Rirkmar','176206',1,0,'2022-03-03 13:28:44','2022-03-03 13:28:44'),(115842,385,'Rit','176086',1,0,'2022-03-03 13:28:44','2022-03-03 13:28:44'),(115843,385,'Rit Lower','176201',1,0,'2022-03-03 13:28:44','2022-03-03 13:28:44'),(115844,385,'Rohan','176093',1,0,'2022-03-03 13:28:44','2022-03-03 13:28:44'),(115845,385,'Saddun','176206',1,0,'2022-03-03 13:28:44','2022-03-03 13:28:44'),(115846,385,'Sadun','176107',1,0,'2022-03-03 13:28:44','2022-03-03 13:28:44'),(115847,385,'Sadwan','176202',1,0,'2022-03-03 13:28:44','2022-03-03 13:28:44'),(115848,385,'Sagoor','176063',1,0,'2022-03-03 13:28:44','2022-03-03 13:28:44'),(115849,385,'Sai','176107',1,0,'2022-03-03 13:28:44','2022-03-03 13:28:44'),(115850,385,'Sakoh','176082',1,0,'2022-03-03 13:28:44','2022-03-03 13:28:44'),(115851,385,'Sakoh','176213',1,0,'2022-03-03 13:28:44','2022-03-03 13:28:44'),(115852,385,'Sakri','176125',1,0,'2022-03-03 13:28:45','2022-03-03 13:28:45'),(115853,385,'Salan','176107',1,0,'2022-03-03 13:28:45','2022-03-03 13:28:45'),(115854,385,'Salehra','176088',1,0,'2022-03-03 13:28:45','2022-03-03 13:28:45'),(115855,385,'Saliali','176211',1,0,'2022-03-03 13:28:45','2022-03-03 13:28:45'),(115856,385,'Saliana','176103',1,0,'2022-03-03 13:28:45','2022-03-03 13:28:45'),(115857,385,'Salli','176206',1,0,'2022-03-03 13:28:45','2022-03-03 13:28:45'),(115858,385,'Saloh','176102',1,0,'2022-03-03 13:28:45','2022-03-03 13:28:45'),(115859,385,'Samlet','176401',1,0,'2022-03-03 13:28:45','2022-03-03 13:28:45'),(115860,385,'Sanghole','176091',1,0,'2022-03-03 13:28:45','2022-03-03 13:28:45'),(115861,385,'Sanhoon','176093',1,0,'2022-03-03 13:28:45','2022-03-03 13:28:45'),(115862,385,'Sansai','176088',1,0,'2022-03-03 13:28:45','2022-03-03 13:28:45'),(115863,385,'Sansal','176125',1,0,'2022-03-03 13:28:45','2022-03-03 13:28:45'),(115864,385,'Saperu','176061',1,0,'2022-03-03 13:28:45','2022-03-03 13:28:45'),(115865,385,'Sapruhal','176093',1,0,'2022-03-03 13:28:45','2022-03-03 13:28:45'),(115866,385,'Sarah','176213',1,0,'2022-03-03 13:28:45','2022-03-03 13:28:45'),(115867,385,'Sarhoot','176084',1,0,'2022-03-03 13:28:45','2022-03-03 13:28:45'),(115868,385,'Sarkari Sidhpur','176064',1,0,'2022-03-03 13:28:45','2022-03-03 13:28:45'),(115869,385,'Sehal','176125',1,0,'2022-03-03 13:28:45','2022-03-03 13:28:45'),(115870,385,'Shahpur (Kangra)','176206',1,0,'2022-03-03 13:28:45','2022-03-03 13:28:45'),(115871,385,'Shamnagar Dharamsala','176215',1,0,'2022-03-03 13:28:45','2022-03-03 13:28:45'),(115872,385,'Sidhbari','176057',1,0,'2022-03-03 13:28:46','2022-03-03 13:28:46'),(115873,385,'Sidhpur','176057',1,0,'2022-03-03 13:28:46','2022-03-03 13:28:46'),(115874,385,'Sihun','176206',1,0,'2022-03-03 13:28:46','2022-03-03 13:28:46'),(115875,385,'Simbal','176071',1,0,'2022-03-03 13:28:46','2022-03-03 13:28:46'),(115876,385,'Soldha','176225',1,0,'2022-03-03 13:28:46','2022-03-03 13:28:46'),(115877,385,'Sourhra Mohhala','176204',1,0,'2022-03-03 13:28:46','2022-03-03 13:28:46'),(115878,385,'Sri Chamunda Mandir','176052',1,0,'2022-03-03 13:28:46','2022-03-03 13:28:46'),(115879,385,'Suan','176094',1,0,'2022-03-03 13:28:46','2022-03-03 13:28:46'),(115880,385,'Sudher','176217',1,0,'2022-03-03 13:28:46','2022-03-03 13:28:46'),(115881,385,'Sukkar','176057',1,0,'2022-03-03 13:28:46','2022-03-03 13:28:46'),(115882,385,'Sullah','176085',1,0,'2022-03-03 13:28:46','2022-03-03 13:28:46'),(115883,385,'Sungal Tea Estate','176061',1,0,'2022-03-03 13:28:46','2022-03-03 13:28:46'),(115884,385,'Surajpur','176403',1,0,'2022-03-03 13:28:46','2022-03-03 13:28:46'),(115885,385,'Surarwan','176401',1,0,'2022-03-03 13:28:46','2022-03-03 13:28:46'),(115886,385,'Talwar','176096',1,0,'2022-03-03 13:28:46','2022-03-03 13:28:46'),(115887,385,'Tammber','176095',1,0,'2022-03-03 13:28:46','2022-03-03 13:28:46'),(115888,385,'Taragarh (Kangra)','176081',1,0,'2022-03-03 13:28:46','2022-03-03 13:28:46'),(115889,385,'Tarela','176086',1,0,'2022-03-03 13:28:46','2022-03-03 13:28:46'),(115890,385,'Tatehal','176103',1,0,'2022-03-03 13:28:46','2022-03-03 13:28:46'),(115891,385,'Tatwali','176058',1,0,'2022-03-03 13:28:46','2022-03-03 13:28:46'),(115892,385,'Thakurdwara','176102',1,0,'2022-03-03 13:28:46','2022-03-03 13:28:46'),(115893,385,'Thakurdwara','176403',1,0,'2022-03-03 13:28:46','2022-03-03 13:28:46'),(115894,385,'Thandole','176087',1,0,'2022-03-03 13:28:46','2022-03-03 13:28:46'),(115895,385,'Thara','176125',1,0,'2022-03-03 13:28:47','2022-03-03 13:28:47'),(115896,385,'Tharu','176217',1,0,'2022-03-03 13:28:47','2022-03-03 13:28:47'),(115897,385,'Thehar','176210',1,0,'2022-03-03 13:28:47','2022-03-03 13:28:47'),(115898,385,'Thore','176201',1,0,'2022-03-03 13:28:47','2022-03-03 13:28:47'),(115899,385,'Thural','176107',1,0,'2022-03-03 13:28:47','2022-03-03 13:28:47'),(115900,385,'Tika Dagla','176204',1,0,'2022-03-03 13:28:47','2022-03-03 13:28:47'),(115901,385,'Tika Nagrota','176200',1,0,'2022-03-03 13:28:47','2022-03-03 13:28:47'),(115902,385,'Tikker Indorian','176087',1,0,'2022-03-03 13:28:47','2022-03-03 13:28:47'),(115903,385,'Tikkri Duhki','176063',1,0,'2022-03-03 13:28:47','2022-03-03 13:28:47'),(115904,385,'Tilokpur (Kangra)','176225',1,0,'2022-03-03 13:28:47','2022-03-03 13:28:47'),(115905,385,'Tota Rani','176216',1,0,'2022-03-03 13:28:47','2022-03-03 13:28:47'),(115906,385,'Trehal','176063',1,0,'2022-03-03 13:28:47','2022-03-03 13:28:47'),(115907,385,'Tundo','176217',1,0,'2022-03-03 13:28:47','2022-03-03 13:28:47'),(115908,385,'Upper Lambagaon','176096',1,0,'2022-03-03 13:28:47','2022-03-03 13:28:47'),(115909,385,'Ustehar','176125',1,0,'2022-03-03 13:28:47','2022-03-03 13:28:47'),(115910,385,'Uttrala','176115',1,0,'2022-03-03 13:28:47','2022-03-03 13:28:47'),(115911,385,'Uttrapur','176095',1,0,'2022-03-03 13:28:47','2022-03-03 13:28:47'),(115912,385,'Vijaypur','176095',1,0,'2022-03-03 13:28:47','2022-03-03 13:28:47'),(115913,385,'Yol Camp','176052',1,0,'2022-03-03 13:28:47','2022-03-03 13:28:47'),(115914,385,'Zandpur','176081',1,0,'2022-03-03 13:28:48','2022-03-03 13:28:48'),(115915,385,'Chamukha','177033',1,0,'2022-03-03 13:28:48','2022-03-03 13:28:48'),(115916,385,'Baragraon','175013',1,0,'2022-03-03 13:28:48','2022-03-03 13:28:48'),(115917,385,'Deot','175013',1,0,'2022-03-03 13:28:48','2022-03-03 13:28:48'),(115918,385,'Kothikohar','175013',1,0,'2022-03-03 13:28:48','2022-03-03 13:28:48'),(115919,385,'Swar','175013',1,0,'2022-03-03 13:28:48','2022-03-03 13:28:48'),(115920,385,'Samnoli','177110',1,0,'2022-03-03 13:28:48','2022-03-03 13:28:48'),(115921,385,'Sawana','177110',1,0,'2022-03-03 13:28:48','2022-03-03 13:28:48'),(115922,386,'Akpa','172116',1,0,'2022-03-03 13:28:48','2022-03-03 13:28:48'),(115923,386,'Asrang','172109',1,0,'2022-03-03 13:28:48','2022-03-03 13:28:48'),(115924,386,'Barang','172107',1,0,'2022-03-03 13:28:48','2022-03-03 13:28:48'),(115925,386,'Bari','172115',1,0,'2022-03-03 13:28:48','2022-03-03 13:28:48'),(115926,386,'Batseri','172106',1,0,'2022-03-03 13:28:48','2022-03-03 13:28:48'),(115927,386,'Bhaba','172118',1,0,'2022-03-03 13:28:48','2022-03-03 13:28:48'),(115928,386,'Bhaba Nagar','172115',1,0,'2022-03-03 13:28:48','2022-03-03 13:28:48'),(115929,386,'Brua','172105',1,0,'2022-03-03 13:28:48','2022-03-03 13:28:48'),(115930,386,'Chagaon','172104',1,0,'2022-03-03 13:28:48','2022-03-03 13:28:48'),(115931,386,'Chango','172111',1,0,'2022-03-03 13:28:48','2022-03-03 13:28:48'),(115932,386,'Chansu','172106',1,0,'2022-03-03 13:28:48','2022-03-03 13:28:48'),(115933,386,'Charang','172109',1,0,'2022-03-03 13:28:48','2022-03-03 13:28:48'),(115934,386,'Chaura','172101',1,0,'2022-03-03 13:28:48','2022-03-03 13:28:48'),(115935,386,'Chitkul','172106',1,0,'2022-03-03 13:28:48','2022-03-03 13:28:48'),(115936,386,'Chota Khamba','172101',1,0,'2022-03-03 13:28:48','2022-03-03 13:28:48'),(115937,386,'Dubling','172111',1,0,'2022-03-03 13:28:48','2022-03-03 13:28:48'),(115938,386,'Duni','172108',1,0,'2022-03-03 13:28:49','2022-03-03 13:28:49'),(115939,386,'Giabong','172110',1,0,'2022-03-03 13:28:49','2022-03-03 13:28:49'),(115940,386,'Gue','172111',1,0,'2022-03-03 13:28:49','2022-03-03 13:28:49'),(115941,386,'Hango','172112',1,0,'2022-03-03 13:28:49','2022-03-03 13:28:49'),(115942,386,'Jangi','172109',1,0,'2022-03-03 13:28:49','2022-03-03 13:28:49'),(115943,386,'Kalpa','172108',1,0,'2022-03-03 13:28:49','2022-03-03 13:28:49'),(115944,386,'Kamroo','172106',1,0,'2022-03-03 13:28:49','2022-03-03 13:28:49'),(115945,386,'Kanam','172110',1,0,'2022-03-03 13:28:49','2022-03-03 13:28:49'),(115946,386,'Karcham','172105',1,0,'2022-03-03 13:28:49','2022-03-03 13:28:49'),(115947,386,'Katgaon','172118',1,0,'2022-03-03 13:28:49','2022-03-03 13:28:49'),(115948,386,'Khawangi','172107',1,0,'2022-03-03 13:28:49','2022-03-03 13:28:49'),(115949,386,'Kilba','172105',1,0,'2022-03-03 13:28:49','2022-03-03 13:28:49'),(115950,386,'Kothi','172107',1,0,'2022-03-03 13:28:49','2022-03-03 13:28:49'),(115951,386,'Kunnu','172109',1,0,'2022-03-03 13:28:49','2022-03-03 13:28:49'),(115952,386,'Labrang','172110',1,0,'2022-03-03 13:28:49','2022-03-03 13:28:49'),(115953,386,'Lippa','172109',1,0,'2022-03-03 13:28:49','2022-03-03 13:28:49'),(115954,386,'Liyo','172112',1,0,'2022-03-03 13:28:49','2022-03-03 13:28:49'),(115955,386,'Meber','172107',1,0,'2022-03-03 13:28:49','2022-03-03 13:28:49'),(115956,386,'Mirro','172104',1,0,'2022-03-03 13:28:49','2022-03-03 13:28:49'),(115957,386,'Moorang','172109',1,0,'2022-03-03 13:28:49','2022-03-03 13:28:49'),(115958,386,'Nako','172111',1,0,'2022-03-03 13:28:50','2022-03-03 13:28:50'),(115959,386,'Namgia','172111',1,0,'2022-03-03 13:28:50','2022-03-03 13:28:50'),(115960,386,'Nathpa','172115',1,0,'2022-03-03 13:28:50','2022-03-03 13:28:50'),(115961,386,'Nesang','172110',1,0,'2022-03-03 13:28:50','2022-03-03 13:28:50'),(115962,386,'Nichar','172103',1,0,'2022-03-03 13:28:50','2022-03-03 13:28:50'),(115963,386,'Nigulsari','172101',1,0,'2022-03-03 13:28:50','2022-03-03 13:28:50'),(115964,386,'Pangi','172107',1,0,'2022-03-03 13:28:50','2022-03-03 13:28:50'),(115965,386,'Panvi','172104',1,0,'2022-03-03 13:28:50','2022-03-03 13:28:50'),(115966,386,'Ponda Solding','172115',1,0,'2022-03-03 13:28:50','2022-03-03 13:28:50'),(115967,386,'Pooh Gaon','172111',1,0,'2022-03-03 13:28:50','2022-03-03 13:28:50'),(115968,386,'Pooh','172111',1,0,'2022-03-03 13:28:50','2022-03-03 13:28:50'),(115969,386,'Powari','172107',1,0,'2022-03-03 13:28:50','2022-03-03 13:28:50'),(115970,386,'Purbani','172107',1,0,'2022-03-03 13:28:50','2022-03-03 13:28:50'),(115971,386,'Rakchham','172106',1,0,'2022-03-03 13:28:50','2022-03-03 13:28:50'),(115972,386,'Ramni','172104',1,0,'2022-03-03 13:28:50','2022-03-03 13:28:50'),(115973,386,'Rarang','172116',1,0,'2022-03-03 13:28:50','2022-03-03 13:28:50'),(115974,386,'Reckong Peo H.O','172107',1,0,'2022-03-03 13:28:50','2022-03-03 13:28:50'),(115975,386,'Ribba','172116',1,0,'2022-03-03 13:28:50','2022-03-03 13:28:50'),(115976,386,'Rispa','172116',1,0,'2022-03-03 13:28:51','2022-03-03 13:28:51'),(115977,386,'Roghi','172108',1,0,'2022-03-03 13:28:51','2022-03-03 13:28:51'),(115978,386,'Ropa','172110',1,0,'2022-03-03 13:28:51','2022-03-03 13:28:51'),(115979,386,'Samdoo','172111',1,0,'2022-03-03 13:28:51','2022-03-03 13:28:51'),(115980,386,'Sangla','172106',1,0,'2022-03-03 13:28:51','2022-03-03 13:28:51'),(115981,386,'Sapni','172105',1,0,'2022-03-03 13:28:51','2022-03-03 13:28:51'),(115982,386,'Shalkhar','172111',1,0,'2022-03-03 13:28:51','2022-03-03 13:28:51'),(115983,386,'Shiaso','172110',1,0,'2022-03-03 13:28:51','2022-03-03 13:28:51'),(115984,386,'Shong','172105',1,0,'2022-03-03 13:28:51','2022-03-03 13:28:51'),(115985,386,'Speelo','172110',1,0,'2022-03-03 13:28:51','2022-03-03 13:28:51'),(115986,386,'Sumra','172111',1,0,'2022-03-03 13:28:51','2022-03-03 13:28:51'),(115987,386,'Sungra','172115',1,0,'2022-03-03 13:28:52','2022-03-03 13:28:52'),(115988,386,'Sunnam','172110',1,0,'2022-03-03 13:28:52','2022-03-03 13:28:52'),(115989,386,'Tapri','172104',1,0,'2022-03-03 13:28:52','2022-03-03 13:28:52'),(115990,386,'Taranda','172101',1,0,'2022-03-03 13:28:52','2022-03-03 13:28:52'),(115991,386,'Thangi','172109',1,0,'2022-03-03 13:28:52','2022-03-03 13:28:52'),(115992,386,'Urni','172104',1,0,'2022-03-03 13:28:52','2022-03-03 13:28:52'),(115993,386,'Virgarh','172030',1,0,'2022-03-03 13:28:52','2022-03-03 13:28:52'),(115994,386,'Wangtoo','172104',1,0,'2022-03-03 13:28:52','2022-03-03 13:28:52'),(115995,386,'Yulla','172104',1,0,'2022-03-03 13:28:52','2022-03-03 13:28:52'),(115996,387,'Akhara Bazar','175101',1,0,'2022-03-03 13:28:52','2022-03-03 13:28:52'),(115997,387,'Anah','175123',1,0,'2022-03-03 13:28:52','2022-03-03 13:28:52'),(115998,387,'Archandi','175104',1,0,'2022-03-03 13:28:52','2022-03-03 13:28:52'),(115999,387,'Babeli','175138',1,0,'2022-03-03 13:28:52','2022-03-03 13:28:52'),(116000,387,'Bachoot','175123',1,0,'2022-03-03 13:28:52','2022-03-03 13:28:52'),(116001,387,'Bahang','175103',1,0,'2022-03-03 13:28:52','2022-03-03 13:28:52'),(116002,387,'Bahu','175123',1,0,'2022-03-03 13:28:52','2022-03-03 13:28:52'),(116003,387,'Bajahara','175134',1,0,'2022-03-03 13:28:52','2022-03-03 13:28:52'),(116004,387,'Bajaura','175125',1,0,'2022-03-03 13:28:52','2022-03-03 13:28:52'),(116005,387,'Bandrole','175128',1,0,'2022-03-03 13:28:52','2022-03-03 13:28:52'),(116006,387,'Banjar','175123',1,0,'2022-03-03 13:28:52','2022-03-03 13:28:52'),(116007,387,'Banogi','175134',1,0,'2022-03-03 13:28:52','2022-03-03 13:28:52'),(116008,387,'Baragaon','175129',1,0,'2022-03-03 13:28:53','2022-03-03 13:28:53'),(116009,387,'Bari','175101',1,0,'2022-03-03 13:28:53','2022-03-03 13:28:53'),(116010,387,'Barshaini','175105',1,0,'2022-03-03 13:28:53','2022-03-03 13:28:53'),(116011,387,'Barua','175103',1,0,'2022-03-03 13:28:53','2022-03-03 13:28:53'),(116012,387,'Bathad','175123',1,0,'2022-03-03 13:28:53','2022-03-03 13:28:53'),(116013,387,'Bhalan','175134',1,0,'2022-03-03 13:28:53','2022-03-03 13:28:53'),(116014,387,'Bhalyani','175102',1,0,'2022-03-03 13:28:53','2022-03-03 13:28:53'),(116015,387,'Bhekhali','175101',1,0,'2022-03-03 13:28:53','2022-03-03 13:28:53'),(116016,387,'Bhrain','175125',1,0,'2022-03-03 13:28:53','2022-03-03 13:28:53'),(116017,387,'Bhuntar','175125',1,0,'2022-03-03 13:28:53','2022-03-03 13:28:53'),(116018,387,'Bhutti','175102',1,0,'2022-03-03 13:28:53','2022-03-03 13:28:53'),(116019,387,'Biasar','175128',1,0,'2022-03-03 13:28:53','2022-03-03 13:28:53'),(116020,387,'Bradha','175105',1,0,'2022-03-03 13:28:53','2022-03-03 13:28:53'),(116021,387,'Bran','175101',1,0,'2022-03-03 13:28:53','2022-03-03 13:28:53'),(116022,387,'Bran','175131',1,0,'2022-03-03 13:28:53','2022-03-03 13:28:53'),(116023,387,'Brehin','175134',1,0,'2022-03-03 13:28:53','2022-03-03 13:28:53'),(116024,387,'Chakurtha','175106',1,0,'2022-03-03 13:28:53','2022-03-03 13:28:53'),(116025,387,'Chanon','175123',1,0,'2022-03-03 13:28:53','2022-03-03 13:28:53'),(116026,387,'Chehni','175123',1,0,'2022-03-03 13:28:53','2022-03-03 13:28:53'),(116027,387,'Chettar','175123',1,0,'2022-03-03 13:28:53','2022-03-03 13:28:53'),(116028,387,'Chheur','175125',1,0,'2022-03-03 13:28:53','2022-03-03 13:28:53'),(116029,387,'Chhiyal','175131',1,0,'2022-03-03 13:28:54','2022-03-03 13:28:54'),(116030,387,'Deotha','175123',1,0,'2022-03-03 13:28:54','2022-03-03 13:28:54'),(116031,387,'Dhara','175105',1,0,'2022-03-03 13:28:54','2022-03-03 13:28:54'),(116032,387,'Dhaugi','175134',1,0,'2022-03-03 13:28:54','2022-03-03 13:28:54'),(116033,387,'Dobhi','175129',1,0,'2022-03-03 13:28:54','2022-03-03 13:28:54'),(116034,387,'Doghari','175102',1,0,'2022-03-03 13:28:54','2022-03-03 13:28:54'),(116035,387,'Dugilag','175102',1,0,'2022-03-03 13:28:54','2022-03-03 13:28:54'),(116036,387,'Dyar','175141',1,0,'2022-03-03 13:28:54','2022-03-03 13:28:54'),(116037,387,'Fozal','175129',1,0,'2022-03-03 13:28:54','2022-03-03 13:28:54'),(116038,387,'Gaidhar','175123',1,0,'2022-03-03 13:28:54','2022-03-03 13:28:54'),(116039,387,'Garsa','175141',1,0,'2022-03-03 13:28:54','2022-03-03 13:28:54'),(116040,387,'Gushaini','175123',1,0,'2022-03-03 13:28:54','2022-03-03 13:28:54'),(116041,387,'Haripur (Kullu)','175136',1,0,'2022-03-03 13:28:54','2022-03-03 13:28:54'),(116042,387,'Hurla','175125',1,0,'2022-03-03 13:28:54','2022-03-03 13:28:54'),(116043,387,'Jagatsukh','175143',1,0,'2022-03-03 13:28:54','2022-03-03 13:28:54'),(116044,387,'Jalugraon','175105',1,0,'2022-03-03 13:28:54','2022-03-03 13:28:54'),(116045,387,'Jaree','175105',1,0,'2022-03-03 13:28:54','2022-03-03 13:28:54'),(116046,387,'Jibhi','175123',1,0,'2022-03-03 13:28:54','2022-03-03 13:28:54'),(116047,387,'Kais','175101',1,0,'2022-03-03 13:28:54','2022-03-03 13:28:54'),(116048,387,'Kalath','175131',1,0,'2022-03-03 13:28:54','2022-03-03 13:28:54'),(116049,387,'Kalwari','175123',1,0,'2022-03-03 13:28:54','2022-03-03 13:28:54'),(116050,387,'Kanoun','175134',1,0,'2022-03-03 13:28:55','2022-03-03 13:28:55'),(116051,387,'Kararsu','175101',1,0,'2022-03-03 13:28:55','2022-03-03 13:28:55'),(116052,387,'Karjan','175136',1,0,'2022-03-03 13:28:55','2022-03-03 13:28:55'),(116053,387,'Kasladi','175105',1,0,'2022-03-03 13:28:55','2022-03-03 13:28:55'),(116054,387,'Kasol','175105',1,0,'2022-03-03 13:28:55','2022-03-03 13:28:55'),(116055,387,'Katrain','175129',1,0,'2022-03-03 13:28:55','2022-03-03 13:28:55'),(116056,387,'Khakhnal','175143',1,0,'2022-03-03 13:28:55','2022-03-03 13:28:55'),(116057,387,'Khalwan','175106',1,0,'2022-03-03 13:28:55','2022-03-03 13:28:55'),(116058,387,'Kharihar','175126',1,0,'2022-03-03 13:28:55','2022-03-03 13:28:55'),(116059,387,'Khokhan','175125',1,0,'2022-03-03 13:28:55','2022-03-03 13:28:55'),(116060,387,'Khunachi','175123',1,0,'2022-03-03 13:28:55','2022-03-03 13:28:55'),(116061,387,'Kullu H.O','175101',1,0,'2022-03-03 13:28:55','2022-03-03 13:28:55'),(116062,387,'Larenkelo','175104',1,0,'2022-03-03 13:28:55','2022-03-03 13:28:55'),(116063,387,'Larji','175122',1,0,'2022-03-03 13:28:55','2022-03-03 13:28:55'),(116064,387,'Madana','175134',1,0,'2022-03-03 13:28:55','2022-03-03 13:28:55'),(116065,387,'Majhan','175134',1,0,'2022-03-03 13:28:55','2022-03-03 13:28:55'),(116066,387,'Malana','175105',1,0,'2022-03-03 13:28:55','2022-03-03 13:28:55'),(116067,387,'Manali (Kullu)','175131',1,0,'2022-03-03 13:28:55','2022-03-03 13:28:55'),(116068,387,'Manglore','175123',1,0,'2022-03-03 13:28:56','2022-03-03 13:28:56'),(116069,387,'Manikaran','175105',1,0,'2022-03-03 13:28:56','2022-03-03 13:28:56'),(116070,387,'Mohal','175126',1,0,'2022-03-03 13:28:56','2022-03-03 13:28:56'),(116071,387,'Mohani','175123',1,0,'2022-03-03 13:28:56','2022-03-03 13:28:56'),(116072,387,'Naggar','175130',1,0,'2022-03-03 13:28:56','2022-03-03 13:28:56'),(116073,387,'Neol','175125',1,0,'2022-03-03 13:28:56','2022-03-03 13:28:56'),(116074,387,'Neoli','175138',1,0,'2022-03-03 13:28:56','2022-03-03 13:28:56'),(116075,387,'Nohanda','175123',1,0,'2022-03-03 13:28:56','2022-03-03 13:28:56'),(116076,387,'Palach','175123',1,0,'2022-03-03 13:28:56','2022-03-03 13:28:56'),(116077,387,'Palchan','175103',1,0,'2022-03-03 13:28:56','2022-03-03 13:28:56'),(116078,387,'Pangaon','175129',1,0,'2022-03-03 13:28:56','2022-03-03 13:28:56'),(116079,387,'Panihar','175106',1,0,'2022-03-03 13:28:56','2022-03-03 13:28:56'),(116080,387,'Panjali','175123',1,0,'2022-03-03 13:28:56','2022-03-03 13:28:56'),(116081,387,'Patlikulh','175129',1,0,'2022-03-03 13:28:56','2022-03-03 13:28:56'),(116082,387,'Peej','175101',1,0,'2022-03-03 13:28:57','2022-03-03 13:28:57'),(116083,387,'Piplage','175125',1,0,'2022-03-03 13:28:57','2022-03-03 13:28:57'),(116084,387,'Prini','175143',1,0,'2022-03-03 13:28:57','2022-03-03 13:28:57'),(116085,387,'Puid','175101',1,0,'2022-03-03 13:28:57','2022-03-03 13:28:57'),(116086,387,'Purani Manali','175131',1,0,'2022-03-03 13:28:57','2022-03-03 13:28:57'),(116087,387,'Raison','175128',1,0,'2022-03-03 13:28:57','2022-03-03 13:28:57'),(116088,387,'Raman','175130',1,0,'2022-03-03 13:28:57','2022-03-03 13:28:57'),(116089,387,'Reila','175134',1,0,'2022-03-03 13:28:57','2022-03-03 13:28:57'),(116090,387,'Sachiyani','175125',1,0,'2022-03-03 13:28:57','2022-03-03 13:28:57'),(116091,387,'Sainj','175134',1,0,'2022-03-03 13:28:57','2022-03-03 13:28:57'),(116092,387,'Sarchi','175123',1,0,'2022-03-03 13:28:57','2022-03-03 13:28:57'),(116093,387,'Seobag','175138',1,0,'2022-03-03 13:28:57','2022-03-03 13:28:57'),(116094,387,'Shairi','175125',1,0,'2022-03-03 13:28:57','2022-03-03 13:28:57'),(116095,387,'Shalang','175102',1,0,'2022-03-03 13:28:57','2022-03-03 13:28:57'),(116096,387,'Shamshi','175126',1,0,'2022-03-03 13:28:57','2022-03-03 13:28:57'),(116097,387,'Shirad','175128',1,0,'2022-03-03 13:28:57','2022-03-03 13:28:57'),(116098,387,'Sojha','175123',1,0,'2022-03-03 13:28:57','2022-03-03 13:28:57'),(116099,387,'Suchain','175134',1,0,'2022-03-03 13:28:57','2022-03-03 13:28:57'),(116100,387,'Sultanpur (Kullu)','175101',1,0,'2022-03-03 13:28:57','2022-03-03 13:28:57'),(116101,387,'Tandi','175123',1,0,'2022-03-03 13:28:57','2022-03-03 13:28:57'),(116102,387,'Thela','175141',1,0,'2022-03-03 13:28:58','2022-03-03 13:28:58'),(116103,387,'Vashisht','175103',1,0,'2022-03-03 13:28:58','2022-03-03 13:28:58'),(116104,387,'Anni','172026',1,0,'2022-03-03 13:28:58','2022-03-03 13:28:58'),(116105,387,'Arsu','172002',1,0,'2022-03-03 13:28:58','2022-03-03 13:28:58'),(116106,387,'Beoni','172002',1,0,'2022-03-03 13:28:58','2022-03-03 13:28:58'),(116107,387,'Chowai','172032',1,0,'2022-03-03 13:28:58','2022-03-03 13:28:58'),(116108,387,'Dalash','172025',1,0,'2022-03-03 13:28:58','2022-03-03 13:28:58'),(116109,387,'Deem','172002',1,0,'2022-03-03 13:28:58','2022-03-03 13:28:58'),(116110,387,'Dehar','172025',1,0,'2022-03-03 13:28:58','2022-03-03 13:28:58'),(116111,387,'Deori','172026',1,0,'2022-03-03 13:28:58','2022-03-03 13:28:58'),(116112,387,'Digerh','172026',1,0,'2022-03-03 13:28:58','2022-03-03 13:28:58'),(116113,387,'Duhad','172026',1,0,'2022-03-03 13:28:58','2022-03-03 13:28:58'),(116114,387,'Durah','172033',1,0,'2022-03-03 13:28:58','2022-03-03 13:28:58'),(116115,387,'Gad','172032',1,0,'2022-03-03 13:28:58','2022-03-03 13:28:58'),(116116,387,'Ghatu','172023',1,0,'2022-03-03 13:28:58','2022-03-03 13:28:58'),(116117,387,'Jadoli','172023',1,0,'2022-03-03 13:28:58','2022-03-03 13:28:58'),(116118,387,'Jaon','172002',1,0,'2022-03-03 13:28:58','2022-03-03 13:28:58'),(116119,387,'Jaon','172032',1,0,'2022-03-03 13:28:58','2022-03-03 13:28:58'),(116120,387,'Kamand','172026',1,0,'2022-03-03 13:28:58','2022-03-03 13:28:58'),(116121,387,'Kandagai','172025',1,0,'2022-03-03 13:28:58','2022-03-03 13:28:58'),(116122,387,'Kandugad','172026',1,0,'2022-03-03 13:28:59','2022-03-03 13:28:59'),(116123,387,'Karana','172026',1,0,'2022-03-03 13:28:59','2022-03-03 13:28:59'),(116124,387,'Khanag','172026',1,0,'2022-03-03 13:28:59','2022-03-03 13:28:59'),(116125,387,'Khunn','172026',1,0,'2022-03-03 13:28:59','2022-03-03 13:28:59'),(116126,387,'Koil','172023',1,0,'2022-03-03 13:28:59','2022-03-03 13:28:59'),(116127,387,'Kothi','172026',1,0,'2022-03-03 13:28:59','2022-03-03 13:28:59'),(116128,387,'Kushwa','172201',1,0,'2022-03-03 13:28:59','2022-03-03 13:28:59'),(116129,387,'Lagouti','172026',1,0,'2022-03-03 13:28:59','2022-03-03 13:28:59'),(116130,387,'Luhri','172001',1,0,'2022-03-03 13:28:59','2022-03-03 13:28:59'),(116131,387,'Nigan','172026',1,0,'2022-03-03 13:28:59','2022-03-03 13:28:59'),(116132,387,'Nirmand','172023',1,0,'2022-03-03 13:28:59','2022-03-03 13:28:59'),(116133,387,'Nishani','172002',1,0,'2022-03-03 13:28:59','2022-03-03 13:28:59'),(116134,387,'Nither','172033',1,0,'2022-03-03 13:28:59','2022-03-03 13:28:59'),(116135,387,'Olwa','172025',1,0,'2022-03-03 13:28:59','2022-03-03 13:28:59'),(116136,387,'Peog','172026',1,0,'2022-03-03 13:28:59','2022-03-03 13:28:59'),(116137,387,'Poshna','172001',1,0,'2022-03-03 13:28:59','2022-03-03 13:28:59'),(116138,387,'Sarahan','172002',1,0,'2022-03-03 13:28:59','2022-03-03 13:28:59'),(116139,387,'Sargha','172201',1,0,'2022-03-03 13:28:59','2022-03-03 13:28:59'),(116140,387,'Shamani','172002',1,0,'2022-03-03 13:28:59','2022-03-03 13:28:59'),(116141,387,'Sharvi','172023',1,0,'2022-03-03 13:28:59','2022-03-03 13:28:59'),(116142,387,'Shawad','172026',1,0,'2022-03-03 13:28:59','2022-03-03 13:28:59'),(116143,387,'Sush','172025',1,0,'2022-03-03 13:28:59','2022-03-03 13:28:59'),(116144,387,'Tandi','172033',1,0,'2022-03-03 13:29:00','2022-03-03 13:29:00'),(116145,387,'Tunan','172001',1,0,'2022-03-03 13:29:00','2022-03-03 13:29:00'),(116146,387,'Urtu','172023',1,0,'2022-03-03 13:29:00','2022-03-03 13:29:00'),(116147,388,'Chimrat','175142',1,0,'2022-03-03 13:29:00','2022-03-03 13:29:00'),(116148,388,'Gemour','175132',1,0,'2022-03-03 13:29:00','2022-03-03 13:29:00'),(116149,388,'Gondhla','175140',1,0,'2022-03-03 13:29:00','2022-03-03 13:29:00'),(116150,388,'Goshal','175132',1,0,'2022-03-03 13:29:00','2022-03-03 13:29:00'),(116151,388,'Jahalman','175139',1,0,'2022-03-03 13:29:00','2022-03-03 13:29:00'),(116152,388,'Jispa','175132',1,0,'2022-03-03 13:29:00','2022-03-03 13:29:00'),(116153,388,'Jobrang','175133',1,0,'2022-03-03 13:29:00','2022-03-03 13:29:00'),(116154,388,'Karpat','175142',1,0,'2022-03-03 13:29:00','2022-03-03 13:29:00'),(116155,388,'Keylong H.O','175132',1,0,'2022-03-03 13:29:00','2022-03-03 13:29:00'),(116156,388,'Koksar','175140',1,0,'2022-03-03 13:29:00','2022-03-03 13:29:00'),(116157,388,'Kolang','175132',1,0,'2022-03-03 13:29:00','2022-03-03 13:29:00'),(116158,388,'Kordang','175132',1,0,'2022-03-03 13:29:00','2022-03-03 13:29:00'),(116159,388,'Lote (Lahul & Spiti)','175133',1,0,'2022-03-03 13:29:00','2022-03-03 13:29:00'),(116160,388,'Malang','175132',1,0,'2022-03-03 13:29:00','2022-03-03 13:29:00'),(116161,388,'Mooling','175132',1,0,'2022-03-03 13:29:00','2022-03-03 13:29:00'),(116162,388,'Mooring','175139',1,0,'2022-03-03 13:29:00','2022-03-03 13:29:00'),(116163,388,'Peokar','175132',1,0,'2022-03-03 13:29:00','2022-03-03 13:29:00'),(116164,388,'Salugran','175142',1,0,'2022-03-03 13:29:00','2022-03-03 13:29:00'),(116165,388,'Samdoh','175132',1,0,'2022-03-03 13:29:00','2022-03-03 13:29:00'),(116166,388,'Shansha','175133',1,0,'2022-03-03 13:29:01','2022-03-03 13:29:01'),(116167,388,'Sissu','175140',1,0,'2022-03-03 13:29:01','2022-03-03 13:29:01'),(116168,388,'Tandi','175132',1,0,'2022-03-03 13:29:01','2022-03-03 13:29:01'),(116169,388,'Thirot','175139',1,0,'2022-03-03 13:29:01','2022-03-03 13:29:01'),(116170,388,'Tindi','175142',1,0,'2022-03-03 13:29:01','2022-03-03 13:29:01'),(116171,388,'Trilokinath','175142',1,0,'2022-03-03 13:29:01','2022-03-03 13:29:01'),(116172,388,'Udaipur','175142',1,0,'2022-03-03 13:29:01','2022-03-03 13:29:01'),(116173,388,'Yurnath','175132',1,0,'2022-03-03 13:29:01','2022-03-03 13:29:01'),(116174,388,'Demul','172114',1,0,'2022-03-03 13:29:01','2022-03-03 13:29:01'),(116175,388,'Dhanker','172113',1,0,'2022-03-03 13:29:01','2022-03-03 13:29:01'),(116176,388,'Gulling','172117',1,0,'2022-03-03 13:29:01','2022-03-03 13:29:01'),(116177,388,'Hansa','172114',1,0,'2022-03-03 13:29:01','2022-03-03 13:29:01'),(116178,388,'Hikkam','172114',1,0,'2022-03-03 13:29:01','2022-03-03 13:29:01'),(116179,388,'Hull','172114',1,0,'2022-03-03 13:29:01','2022-03-03 13:29:01'),(116180,388,'Kaza','172114',1,0,'2022-03-03 13:29:01','2022-03-03 13:29:01'),(116181,388,'Kee Gompa','172114',1,0,'2022-03-03 13:29:01','2022-03-03 13:29:01'),(116182,388,'Kibber','172114',1,0,'2022-03-03 13:29:01','2022-03-03 13:29:01'),(116183,388,'Lalung','172113',1,0,'2022-03-03 13:29:01','2022-03-03 13:29:01'),(116184,388,'Lara','172114',1,0,'2022-03-03 13:29:01','2022-03-03 13:29:01'),(116185,388,'Losser','172114',1,0,'2022-03-03 13:29:01','2022-03-03 13:29:01'),(116186,388,'Mane','172113',1,0,'2022-03-03 13:29:01','2022-03-03 13:29:01'),(116187,388,'Mud','172117',1,0,'2022-03-03 13:29:01','2022-03-03 13:29:01'),(116188,388,'Rangrik','172114',1,0,'2022-03-03 13:29:02','2022-03-03 13:29:02'),(116189,388,'Sagnam','172117',1,0,'2022-03-03 13:29:02','2022-03-03 13:29:02'),(116190,388,'Tabo','172113',1,0,'2022-03-03 13:29:02','2022-03-03 13:29:02'),(116191,389,'Ahju','175032',1,0,'2022-03-03 13:29:02','2022-03-03 13:29:02'),(116192,389,'Alathu','175001',1,0,'2022-03-03 13:29:02','2022-03-03 13:29:02'),(116193,389,'Alsindi','175009',1,0,'2022-03-03 13:29:02','2022-03-03 13:29:02'),(116194,389,'Aut','175121',1,0,'2022-03-03 13:29:02','2022-03-03 13:29:02'),(116195,389,'Bachwan','175034',1,0,'2022-03-03 13:29:02','2022-03-03 13:29:02'),(116196,389,'Badhu','175028',1,0,'2022-03-03 13:29:02','2022-03-03 13:29:02'),(116197,389,'Bag','175032',1,0,'2022-03-03 13:29:02','2022-03-03 13:29:02'),(116198,389,'Bagachanogi','175035',1,0,'2022-03-03 13:29:02','2022-03-03 13:29:02'),(116199,389,'Baggi','175027',1,0,'2022-03-03 13:29:02','2022-03-03 13:29:02'),(116200,389,'Bagsaid','175035',1,0,'2022-03-03 13:29:02','2022-03-03 13:29:02'),(116201,389,'Bagshar','175009',1,0,'2022-03-03 13:29:02','2022-03-03 13:29:02'),(116202,389,'Bahenara','175011',1,0,'2022-03-03 13:29:02','2022-03-03 13:29:02'),(116203,389,'Bahnu','175033',1,0,'2022-03-03 13:29:02','2022-03-03 13:29:02'),(116204,389,'Bakhrot','175011',1,0,'2022-03-03 13:29:02','2022-03-03 13:29:02'),(116205,389,'Balag','175038',1,0,'2022-03-03 13:29:02','2022-03-03 13:29:02'),(116206,389,'Baldwara','175033',1,0,'2022-03-03 13:29:02','2022-03-03 13:29:02'),(116207,389,'Balh','175012',1,0,'2022-03-03 13:29:03','2022-03-03 13:29:03'),(116208,389,'Balhara','175033',1,0,'2022-03-03 13:29:03','2022-03-03 13:29:03'),(116209,389,'Balhjoli','175015',1,0,'2022-03-03 13:29:03','2022-03-03 13:29:03'),(116210,389,'Balhkwar','175016',1,0,'2022-03-03 13:29:03','2022-03-03 13:29:03'),(116211,389,'Balichowki','175106',1,0,'2022-03-03 13:29:03','2022-03-03 13:29:03'),(116212,389,'Balindi','175009',1,0,'2022-03-03 13:29:03','2022-03-03 13:29:03'),(116213,389,'Baloh','175052',1,0,'2022-03-03 13:29:03','2022-03-03 13:29:03'),(116214,389,'Balt','175008',1,0,'2022-03-03 13:29:03','2022-03-03 13:29:03'),(116215,389,'Balu','175121',1,0,'2022-03-03 13:29:03','2022-03-03 13:29:03'),(116216,389,'Bandhi','175124',1,0,'2022-03-03 13:29:03','2022-03-03 13:29:03'),(116217,389,'Banthal','175011',1,0,'2022-03-03 13:29:03','2022-03-03 13:29:03'),(116218,389,'Bara','175029',1,0,'2022-03-03 13:29:03','2022-03-03 13:29:03'),(116219,389,'Bararta','175024',1,0,'2022-03-03 13:29:03','2022-03-03 13:29:03'),(116220,389,'Bardhan','175013',1,0,'2022-03-03 13:29:03','2022-03-03 13:29:03'),(116221,389,'Bari Gumanu','175001',1,0,'2022-03-03 13:29:03','2022-03-03 13:29:03'),(116222,389,'Barin','175033',1,0,'2022-03-03 13:29:03','2022-03-03 13:29:03'),(116223,389,'Barot','175013',1,0,'2022-03-03 13:29:03','2022-03-03 13:29:03'),(116224,389,'Baroti','175040',1,0,'2022-03-03 13:29:03','2022-03-03 13:29:03'),(116225,389,'Baroti','175030',1,0,'2022-03-03 13:29:03','2022-03-03 13:29:03'),(116226,389,'Barsu','175021',1,0,'2022-03-03 13:29:04','2022-03-03 13:29:04'),(116227,389,'Barswan','175036',1,0,'2022-03-03 13:29:04','2022-03-03 13:29:04'),(116228,389,'Baryara','175052',1,0,'2022-03-03 13:29:04','2022-03-03 13:29:04'),(116229,389,'Basantpur','175042',1,0,'2022-03-03 13:29:04','2022-03-03 13:29:04'),(116230,389,'Basona','175016',1,0,'2022-03-03 13:29:04','2022-03-03 13:29:04'),(116231,389,'Bassi','175029',1,0,'2022-03-03 13:29:04','2022-03-03 13:29:04'),(116232,389,'Bassi','175015',1,0,'2022-03-03 13:29:04','2022-03-03 13:29:04'),(116233,389,'Bathera','175034',1,0,'2022-03-03 13:29:04','2022-03-03 13:29:04'),(116234,389,'Batheri','175005',1,0,'2022-03-03 13:29:04','2022-03-03 13:29:04'),(116235,389,'Batwara','175017',1,0,'2022-03-03 13:29:04','2022-03-03 13:29:04'),(116236,389,'Behli','175009',1,0,'2022-03-03 13:29:04','2022-03-03 13:29:04'),(116237,389,'Behna','175006',1,0,'2022-03-03 13:29:04','2022-03-03 13:29:04'),(116238,389,'Bhadarwar','175049',1,0,'2022-03-03 13:29:04','2022-03-03 13:29:04'),(116239,389,'Bhambla','175004',1,0,'2022-03-03 13:29:04','2022-03-03 13:29:04'),(116240,389,'Bhangrotu','175021',1,0,'2022-03-03 13:29:04','2022-03-03 13:29:04'),(116241,389,'Bhararu','175015',1,0,'2022-03-03 13:29:04','2022-03-03 13:29:04'),(116242,389,'Bhargaon','175003',1,0,'2022-03-03 13:29:04','2022-03-03 13:29:04'),(116243,389,'Bhiun','175015',1,0,'2022-03-03 13:29:04','2022-03-03 13:29:04'),(116244,389,'Bhojpur (Mandi)','175002',1,0,'2022-03-03 13:29:05','2022-03-03 13:29:05'),(116245,389,'Bihani','175047',1,0,'2022-03-03 13:29:05','2022-03-03 13:29:05'),(116246,389,'Bijni','175001',1,0,'2022-03-03 13:29:05','2022-03-03 13:29:05'),(116247,389,'Binga','175050',1,0,'2022-03-03 13:29:05','2022-03-03 13:29:05'),(116248,389,'Bir','175001',1,0,'2022-03-03 13:29:05','2022-03-03 13:29:05'),(116249,389,'Boching','175013',1,0,'2022-03-03 13:29:05','2022-03-03 13:29:05'),(116250,389,'Brang','175024',1,0,'2022-03-03 13:29:05','2022-03-03 13:29:05'),(116251,389,'Brikhmani','175027',1,0,'2022-03-03 13:29:05','2022-03-03 13:29:05'),(116252,389,'Brokhari','175031',1,0,'2022-03-03 13:29:05','2022-03-03 13:29:05'),(116253,389,'Chachiot','175028',1,0,'2022-03-03 13:29:05','2022-03-03 13:29:05'),(116254,389,'Chail Chowk','175028',1,0,'2022-03-03 13:29:05','2022-03-03 13:29:05'),(116255,389,'Chalarag','175015',1,0,'2022-03-03 13:29:05','2022-03-03 13:29:05'),(116256,389,'Chambi','175018',1,0,'2022-03-03 13:29:05','2022-03-03 13:29:05'),(116257,389,'Chathri','175047',1,0,'2022-03-03 13:29:05','2022-03-03 13:29:05'),(116258,389,'Chauntra','175032',1,0,'2022-03-03 13:29:05','2022-03-03 13:29:05'),(116259,389,'Chauridhar','175011',1,0,'2022-03-03 13:29:05','2022-03-03 13:29:05'),(116260,389,'Cheuni','175048',1,0,'2022-03-03 13:29:05','2022-03-03 13:29:05'),(116261,389,'Chimnu','175015',1,0,'2022-03-03 13:29:05','2022-03-03 13:29:05'),(116262,389,'Cholangarh','176090',1,0,'2022-03-03 13:29:05','2022-03-03 13:29:05'),(116263,389,'Cholthra','175037',1,0,'2022-03-03 13:29:05','2022-03-03 13:29:05'),(116264,389,'Chowk','175033',1,0,'2022-03-03 13:29:05','2022-03-03 13:29:05'),(116265,389,'Chowki','175031',1,0,'2022-03-03 13:29:05','2022-03-03 13:29:05'),(116266,389,'Chukku','175012',1,0,'2022-03-03 13:29:06','2022-03-03 13:29:06'),(116267,389,'Chunahan','175027',1,0,'2022-03-03 13:29:06','2022-03-03 13:29:06'),(116268,389,'Churad','175018',1,0,'2022-03-03 13:29:06','2022-03-03 13:29:06'),(116269,389,'Churag','175010',1,0,'2022-03-03 13:29:06','2022-03-03 13:29:06'),(116270,389,'Dabhan','175027',1,0,'2022-03-03 13:29:06','2022-03-03 13:29:06'),(116271,389,'Darpa','175042',1,0,'2022-03-03 13:29:06','2022-03-03 13:29:06'),(116272,389,'Darwar','175025',1,0,'2022-03-03 13:29:06','2022-03-03 13:29:06'),(116273,389,'Dasehra','175036',1,0,'2022-03-03 13:29:06','2022-03-03 13:29:06'),(116274,389,'Dawahan','175003',1,0,'2022-03-03 13:29:06','2022-03-03 13:29:06'),(116275,389,'Dehar','175030',1,0,'2022-03-03 13:29:06','2022-03-03 13:29:06'),(116276,389,'Deori','175124',1,0,'2022-03-03 13:29:06','2022-03-03 13:29:06'),(116277,389,'Devdhar','175029',1,0,'2022-03-03 13:29:06','2022-03-03 13:29:06'),(116278,389,'Dhalwan','175004',1,0,'2022-03-03 13:29:06','2022-03-03 13:29:06'),(116279,389,'Dhamerh','175106',1,0,'2022-03-03 13:29:06','2022-03-03 13:29:06'),(116280,389,'Dharampur (Mandi)','175040',1,0,'2022-03-03 13:29:06','2022-03-03 13:29:06'),(116281,389,'Dharmour Kheel','175009',1,0,'2022-03-03 13:29:06','2022-03-03 13:29:06'),(116282,389,'Dhawali','175040',1,0,'2022-03-03 13:29:06','2022-03-03 13:29:06'),(116283,389,'Dhurkhari','175034',1,0,'2022-03-03 13:29:06','2022-03-03 13:29:06'),(116284,389,'Diyargi','175027',1,0,'2022-03-03 13:29:06','2022-03-03 13:29:06'),(116285,389,'Doghari','175009',1,0,'2022-03-03 13:29:06','2022-03-03 13:29:06'),(116286,389,'Dohag','175015',1,0,'2022-03-03 13:29:07','2022-03-03 13:29:07'),(116287,389,'Drahal','175015',1,0,'2022-03-03 13:29:07','2022-03-03 13:29:07'),(116288,389,'Drang','175001',1,0,'2022-03-03 13:29:07','2022-03-03 13:29:07'),(116289,389,'Drubbal','175014',1,0,'2022-03-03 13:29:07','2022-03-03 13:29:07'),(116290,389,'Dudar','175001',1,0,'2022-03-03 13:29:07','2022-03-03 13:29:07'),(116291,389,'Dul','175015',1,0,'2022-03-03 13:29:07','2022-03-03 13:29:07'),(116292,389,'Fatehpur','175024',1,0,'2022-03-03 13:29:07','2022-03-03 13:29:07'),(116293,389,'Gadagushaini','175123',1,0,'2022-03-03 13:29:07','2022-03-03 13:29:07'),(116294,389,'Gagal','175006',1,0,'2022-03-03 13:29:07','2022-03-03 13:29:07'),(116295,389,'Gahar','175049',1,0,'2022-03-03 13:29:07','2022-03-03 13:29:07'),(116296,389,'Galma','175008',1,0,'2022-03-03 13:29:07','2022-03-03 13:29:07'),(116297,389,'Gangoti','175032',1,0,'2022-03-03 13:29:07','2022-03-03 13:29:07'),(116298,389,'Gawali','175012',1,0,'2022-03-03 13:29:07','2022-03-03 13:29:07'),(116299,389,'Gehra','175049',1,0,'2022-03-03 13:29:07','2022-03-03 13:29:07'),(116300,389,'Ghambhar Khad','175023',1,0,'2022-03-03 13:29:07','2022-03-03 13:29:07'),(116301,389,'Ghamiroo','175032',1,0,'2022-03-03 13:29:07','2022-03-03 13:29:07'),(116302,389,'Ghanghnoo','175018',1,0,'2022-03-03 13:29:07','2022-03-03 13:29:07'),(116303,389,'Ghaniar','175106',1,0,'2022-03-03 13:29:07','2022-03-03 13:29:07'),(116304,389,'Gharan','175124',1,0,'2022-03-03 13:29:07','2022-03-03 13:29:07'),(116305,389,'Ghararu','175026',1,0,'2022-03-03 13:29:08','2022-03-03 13:29:08'),(116306,389,'Gharwasra','175025',1,0,'2022-03-03 13:29:08','2022-03-03 13:29:08'),(116307,389,'Ghat','175123',1,0,'2022-03-03 13:29:08','2022-03-03 13:29:08'),(116308,389,'Ghiri','175031',1,0,'2022-03-03 13:29:08','2022-03-03 13:29:08'),(116309,389,'Giun','175040',1,0,'2022-03-03 13:29:08','2022-03-03 13:29:08'),(116310,389,'Gohar','175029',1,0,'2022-03-03 13:29:08','2022-03-03 13:29:08'),(116311,389,'Golwan','175032',1,0,'2022-03-03 13:29:08','2022-03-03 13:29:08'),(116312,389,'Gopalpur (Mandi)','175007',1,0,'2022-03-03 13:29:08','2022-03-03 13:29:08'),(116313,389,'Gowalpur','175011',1,0,'2022-03-03 13:29:08','2022-03-03 13:29:08'),(116314,389,'Gumma','175015',1,0,'2022-03-03 13:29:08','2022-03-03 13:29:08'),(116315,389,'Gurkotha','175036',1,0,'2022-03-03 13:29:08','2022-03-03 13:29:08'),(116316,389,'Gutkar','175021',1,0,'2022-03-03 13:29:08','2022-03-03 13:29:08'),(116317,389,'Hara','175009',1,0,'2022-03-03 13:29:08','2022-03-03 13:29:08'),(116318,389,'Harabagh','175015',1,0,'2022-03-03 13:29:08','2022-03-03 13:29:08'),(116319,389,'Hari Behna','175007',1,0,'2022-03-03 13:29:08','2022-03-03 13:29:08'),(116320,389,'Jachh','175039',1,0,'2022-03-03 13:29:08','2022-03-03 13:29:08'),(116321,389,'Jahal','175039',1,0,'2022-03-03 13:29:08','2022-03-03 13:29:08'),(116322,389,'Jahmet','175033',1,0,'2022-03-03 13:29:09','2022-03-03 13:29:09'),(116323,389,'Jaidevi','175031',1,0,'2022-03-03 13:29:09','2022-03-03 13:29:09'),(116324,389,'Jail Road (Mandi)','175001',1,0,'2022-03-03 13:29:09','2022-03-03 13:29:09'),(116325,389,'Jalpehar','175015',1,0,'2022-03-03 13:29:09','2022-03-03 13:29:09'),(116326,389,'Jambla','175030',1,0,'2022-03-03 13:29:09','2022-03-03 13:29:09'),(116327,389,'Jamni','175049',1,0,'2022-03-03 13:29:09','2022-03-03 13:29:09'),(116328,389,'Jandhrukalan','175042',1,0,'2022-03-03 13:29:09','2022-03-03 13:29:09'),(116329,389,'Janjehli','175047',1,0,'2022-03-03 13:29:09','2022-03-03 13:29:09'),(116330,389,'Jarol','175018',1,0,'2022-03-03 13:29:09','2022-03-03 13:29:09'),(116331,389,'Jarol','175048',1,0,'2022-03-03 13:29:09','2022-03-03 13:29:09'),(116332,389,'Jassal','175009',1,0,'2022-03-03 13:29:09','2022-03-03 13:29:09'),(116333,389,'Jhamerh','175014',1,0,'2022-03-03 13:29:09','2022-03-03 13:29:09'),(116334,389,'Jhangi','176090',1,0,'2022-03-03 13:29:10','2022-03-03 13:29:10'),(116335,389,'Jhatingri','175015',1,0,'2022-03-03 13:29:10','2022-03-03 13:29:10'),(116336,389,'Jhungi','175031',1,0,'2022-03-03 13:29:10','2022-03-03 13:29:10'),(116337,389,'Jia','175125',1,0,'2022-03-03 13:29:10','2022-03-03 13:29:10'),(116338,389,'Joginder Nagar','175015',1,0,'2022-03-03 13:29:10','2022-03-03 13:29:10'),(116339,389,'Jugahan','175002',1,0,'2022-03-03 13:29:10','2022-03-03 13:29:10'),(116340,389,'Kalhani','175124',1,0,'2022-03-03 13:29:10','2022-03-03 13:29:10'),(116341,389,'Kalkhar','175023',1,0,'2022-03-03 13:29:10','2022-03-03 13:29:10'),(116342,389,'Kaloud','175002',1,0,'2022-03-03 13:29:10','2022-03-03 13:29:10'),(116343,389,'Kamand','175005',1,0,'2022-03-03 13:29:10','2022-03-03 13:29:10'),(116344,389,'Kamlahkhas','175050',1,0,'2022-03-03 13:29:10','2022-03-03 13:29:10'),(116345,389,'Kanaid','175019',1,0,'2022-03-03 13:29:10','2022-03-03 13:29:10'),(116346,389,'Kandha','175035',1,0,'2022-03-03 13:29:10','2022-03-03 13:29:10'),(116347,389,'Kangoo','175018',1,0,'2022-03-03 13:29:10','2022-03-03 13:29:10'),(116348,389,'Kangu Ka Gehra','175024',1,0,'2022-03-03 13:29:10','2022-03-03 13:29:10'),(116349,389,'Kapahi','175002',1,0,'2022-03-03 13:29:10','2022-03-03 13:29:10'),(116350,389,'Karsal','175016',1,0,'2022-03-03 13:29:10','2022-03-03 13:29:10'),(116351,389,'Karsog','175011',1,0,'2022-03-03 13:29:10','2022-03-03 13:29:10'),(116352,389,'Kasmaila','175034',1,0,'2022-03-03 13:29:10','2022-03-03 13:29:10'),(116353,389,'Kataula','175005',1,0,'2022-03-03 13:29:10','2022-03-03 13:29:10'),(116354,389,'Kathog','175012',1,0,'2022-03-03 13:29:10','2022-03-03 13:29:10'),(116355,389,'Kathyaun','175036',1,0,'2022-03-03 13:29:11','2022-03-03 13:29:11'),(116356,389,'Katindi','175005',1,0,'2022-03-03 13:29:11','2022-03-03 13:29:11'),(116357,389,'Katwachi','175046',1,0,'2022-03-03 13:29:11','2022-03-03 13:29:11'),(116358,389,'Kaw','175011',1,0,'2022-03-03 13:29:11','2022-03-03 13:29:11'),(116359,389,'Khaddar','175016',1,0,'2022-03-03 13:29:11','2022-03-03 13:29:11'),(116360,389,'Khadyad','175003',1,0,'2022-03-03 13:29:11','2022-03-03 13:29:11'),(116361,389,'Khajoor','175016',1,0,'2022-03-03 13:29:11','2022-03-03 13:29:11'),(116362,389,'Khakhariana','175008',1,0,'2022-03-03 13:29:11','2022-03-03 13:29:11'),(116363,389,'Khalanoo','175003',1,0,'2022-03-03 13:29:11','2022-03-03 13:29:11'),(116364,389,'Khalardu','175024',1,0,'2022-03-03 13:29:11','2022-03-03 13:29:11'),(116365,389,'Khaliar','175001',1,0,'2022-03-03 13:29:11','2022-03-03 13:29:11'),(116366,389,'Khan','175049',1,0,'2022-03-03 13:29:11','2022-03-03 13:29:11'),(116367,389,'Khenyol','175011',1,0,'2022-03-03 13:29:11','2022-03-03 13:29:11'),(116368,389,'Khoda','175024',1,0,'2022-03-03 13:29:11','2022-03-03 13:29:11'),(116369,389,'Kholanal','175124',1,0,'2022-03-03 13:29:11','2022-03-03 13:29:11'),(116370,389,'Khudla','175033',1,0,'2022-03-03 13:29:11','2022-03-03 13:29:11'),(116371,389,'Khuhan','175106',1,0,'2022-03-03 13:29:11','2022-03-03 13:29:11'),(116372,389,'Khurahal','175017',1,0,'2022-03-03 13:29:11','2022-03-03 13:29:11'),(116373,389,'Kolang','175016',1,0,'2022-03-03 13:29:11','2022-03-03 13:29:11'),(116374,389,'Kot','175040',1,0,'2022-03-03 13:29:11','2022-03-03 13:29:11'),(116375,389,'Kot','175028',1,0,'2022-03-03 13:29:11','2022-03-03 13:29:11'),(116376,389,'Kot','175034',1,0,'2022-03-03 13:29:11','2022-03-03 13:29:11'),(116377,389,'Kot','175003',1,0,'2022-03-03 13:29:11','2022-03-03 13:29:11'),(116378,389,'Kothi','175036',1,0,'2022-03-03 13:29:12','2022-03-03 13:29:12'),(116379,389,'Kothwan','176090',1,0,'2022-03-03 13:29:12','2022-03-03 13:29:12'),(116380,389,'Kotkamradha','175121',1,0,'2022-03-03 13:29:12','2022-03-03 13:29:12'),(116381,389,'Kotla','175106',1,0,'2022-03-03 13:29:12','2022-03-03 13:29:12'),(116382,389,'Kotli','175003',1,0,'2022-03-03 13:29:12','2022-03-03 13:29:12'),(116383,389,'Kotmorse','175001',1,0,'2022-03-03 13:29:12','2022-03-03 13:29:12'),(116384,389,'Kufri','175012',1,0,'2022-03-03 13:29:12','2022-03-03 13:29:12'),(116385,389,'Kujabalh','176090',1,0,'2022-03-03 13:29:12','2022-03-03 13:29:12'),(116386,389,'Kummi','175006',1,0,'2022-03-03 13:29:12','2022-03-03 13:29:12'),(116387,389,'Kunho','175011',1,0,'2022-03-03 13:29:12','2022-03-03 13:29:12'),(116388,389,'Kunnu','175012',1,0,'2022-03-03 13:29:12','2022-03-03 13:29:12'),(116389,389,'Kuthera','175015',1,0,'2022-03-03 13:29:12','2022-03-03 13:29:12'),(116390,389,'Ladbharole','175016',1,0,'2022-03-03 13:29:12','2022-03-03 13:29:12'),(116391,389,'Lagdhar','175003',1,0,'2022-03-03 13:29:12','2022-03-03 13:29:12'),(116392,389,'Langna','175015',1,0,'2022-03-03 13:29:12','2022-03-03 13:29:12'),(116393,389,'Leda','175036',1,0,'2022-03-03 13:29:12','2022-03-03 13:29:12'),(116394,389,'Lohara','175027',1,0,'2022-03-03 13:29:12','2022-03-03 13:29:12'),(116395,389,'Longni','175025',1,0,'2022-03-03 13:29:12','2022-03-03 13:29:12'),(116396,389,'Lower Dhalara','176090',1,0,'2022-03-03 13:29:12','2022-03-03 13:29:12'),(116397,389,'Lower Ghanala','176090',1,0,'2022-03-03 13:29:12','2022-03-03 13:29:12'),(116398,389,'Mahadev','175018',1,0,'2022-03-03 13:29:12','2022-03-03 13:29:12'),(116399,389,'Mahog','175011',1,0,'2022-03-03 13:29:13','2022-03-03 13:29:13'),(116400,389,'Mahogi','175124',1,0,'2022-03-03 13:29:13','2022-03-03 13:29:13'),(116401,389,'Mahun','175009',1,0,'2022-03-03 13:29:13','2022-03-03 13:29:13'),(116402,389,'Majhar','175029',1,0,'2022-03-03 13:29:13','2022-03-03 13:29:13'),(116403,389,'Majharnoo','175015',1,0,'2022-03-03 13:29:13','2022-03-03 13:29:13'),(116404,389,'Majhwar','175001',1,0,'2022-03-03 13:29:13','2022-03-03 13:29:13'),(116405,389,'Makreri','175015',1,0,'2022-03-03 13:29:13','2022-03-03 13:29:13'),(116406,389,'Maloh','175018',1,0,'2022-03-03 13:29:13','2022-03-03 13:29:13'),(116407,389,'Mandal','175021',1,0,'2022-03-03 13:29:13','2022-03-03 13:29:13'),(116408,389,'Mandi H.O','175001',1,0,'2022-03-03 13:29:13','2022-03-03 13:29:13'),(116409,389,'Mangwain Mohalla','175001',1,0,'2022-03-03 13:29:13','2022-03-03 13:29:13'),(116410,389,'Marathu','175001',1,0,'2022-03-03 13:29:13','2022-03-03 13:29:13'),(116411,389,'Marhi','175050',1,0,'2022-03-03 13:29:13','2022-03-03 13:29:13'),(116412,389,'Marothi','175046',1,0,'2022-03-03 13:29:13','2022-03-03 13:29:13'),(116413,389,'Maseran','175024',1,0,'2022-03-03 13:29:13','2022-03-03 13:29:13'),(116414,389,'Matroo','175032',1,0,'2022-03-03 13:29:13','2022-03-03 13:29:13'),(116415,389,'Mehndi','175011',1,0,'2022-03-03 13:29:13','2022-03-03 13:29:13'),(116416,389,'Meramasit','175036',1,0,'2022-03-03 13:29:13','2022-03-03 13:29:13'),(116417,389,'Mohanghati','175032',1,0,'2022-03-03 13:29:13','2022-03-03 13:29:13'),(116418,389,'Movi Devi Galoo','175031',1,0,'2022-03-03 13:29:13','2022-03-03 13:29:13'),(116419,389,'Moviseri','175029',1,0,'2022-03-03 13:29:13','2022-03-03 13:29:13'),(116420,389,'Nabahi Devi','175024',1,0,'2022-03-03 13:29:13','2022-03-03 13:29:13'),(116421,389,'Nagchala','175021',1,0,'2022-03-03 13:29:14','2022-03-03 13:29:14'),(116422,389,'Nagwain','175121',1,0,'2022-03-03 13:29:14','2022-03-03 13:29:14'),(116423,389,'Nalag','175030',1,0,'2022-03-03 13:29:14','2022-03-03 13:29:14'),(116424,389,'Nalyana','175026',1,0,'2022-03-03 13:29:14','2022-03-03 13:29:14'),(116425,389,'Nandi','175124',1,0,'2022-03-03 13:29:14','2022-03-03 13:29:14'),(116426,389,'Nanj','175011',1,0,'2022-03-03 13:29:14','2022-03-03 13:29:14'),(116427,389,'Narola','175033',1,0,'2022-03-03 13:29:14','2022-03-03 13:29:14'),(116428,389,'Ner Chowk','175008',1,0,'2022-03-03 13:29:14','2022-03-03 13:29:14'),(116429,389,'Nihri','175038',1,0,'2022-03-03 13:29:14','2022-03-03 13:29:14'),(116430,389,'Nohali','175015',1,0,'2022-03-03 13:29:14','2022-03-03 13:29:14'),(116431,389,'Ootpur','175016',1,0,'2022-03-03 13:29:14','2022-03-03 13:29:14'),(116432,389,'Paddal','175001',1,0,'2022-03-03 13:29:14','2022-03-03 13:29:14'),(116433,389,'Padhar','175012',1,0,'2022-03-03 13:29:14','2022-03-03 13:29:14'),(116434,389,'Padhiun','175001',1,0,'2022-03-03 13:29:14','2022-03-03 13:29:14'),(116435,389,'Padhwan','175012',1,0,'2022-03-03 13:29:14','2022-03-03 13:29:14'),(116436,389,'Pairi','175008',1,0,'2022-03-03 13:29:14','2022-03-03 13:29:14'),(116437,389,'Pali','175001',1,0,'2022-03-03 13:29:14','2022-03-03 13:29:14'),(116438,389,'Panarsa','175121',1,0,'2022-03-03 13:29:14','2022-03-03 13:29:14'),(116439,389,'Pandoh','175124',1,0,'2022-03-03 13:29:14','2022-03-03 13:29:14'),(116440,389,'Pandol','175032',1,0,'2022-03-03 13:29:14','2022-03-03 13:29:14'),(116441,389,'Pangna','175046',1,0,'2022-03-03 13:29:15','2022-03-03 13:29:15'),(116442,389,'Panjain','175106',1,0,'2022-03-03 13:29:15','2022-03-03 13:29:15'),(116443,389,'Panjalag','175016',1,0,'2022-03-03 13:29:15','2022-03-03 13:29:15'),(116444,389,'Parwara','175029',1,0,'2022-03-03 13:29:15','2022-03-03 13:29:15'),(116445,389,'Patrighat','175023',1,0,'2022-03-03 13:29:15','2022-03-03 13:29:15'),(116446,389,'Paunta','175024',1,0,'2022-03-03 13:29:15','2022-03-03 13:29:15'),(116447,389,'Paura Kothi','175031',1,0,'2022-03-03 13:29:15','2022-03-03 13:29:15'),(116448,389,'Pehad','175040',1,0,'2022-03-03 13:29:15','2022-03-03 13:29:15'),(116449,389,'Pingla','175049',1,0,'2022-03-03 13:29:15','2022-03-03 13:29:15'),(116450,389,'Pipli','175014',1,0,'2022-03-03 13:29:15','2022-03-03 13:29:15'),(116451,389,'Pokhi','175011',1,0,'2022-03-03 13:29:15','2022-03-03 13:29:15'),(116452,389,'Prainsainthal','175032',1,0,'2022-03-03 13:29:15','2022-03-03 13:29:15'),(116453,389,'Pressi','175046',1,0,'2022-03-03 13:29:15','2022-03-03 13:29:15'),(116454,389,'Purana Nagar','175019',1,0,'2022-03-03 13:29:15','2022-03-03 13:29:15'),(116455,389,'Purani Mandi','175001',1,0,'2022-03-03 13:29:16','2022-03-03 13:29:16'),(116456,389,'Rajgarh','175027',1,0,'2022-03-03 13:29:16','2022-03-03 13:29:16'),(116457,389,'Rajwari','175027',1,0,'2022-03-03 13:29:16','2022-03-03 13:29:16'),(116458,389,'Rakhoh','175042',1,0,'2022-03-03 13:29:16','2022-03-03 13:29:16'),(116459,389,'Rakol','175038',1,0,'2022-03-03 13:29:16','2022-03-03 13:29:16'),(116460,389,'Randhara','175001',1,0,'2022-03-03 13:29:16','2022-03-03 13:29:16'),(116461,389,'Ratti','175008',1,0,'2022-03-03 13:29:16','2022-03-03 13:29:16'),(116462,389,'Rehardhar','175001',1,0,'2022-03-03 13:29:16','2022-03-03 13:29:16'),(116463,389,'Reur','175023',1,0,'2022-03-03 13:29:16','2022-03-03 13:29:16'),(116464,389,'Rewalsar','175023',1,0,'2022-03-03 13:29:16','2022-03-03 13:29:16'),(116465,389,'Rissa','175024',1,0,'2022-03-03 13:29:16','2022-03-03 13:29:16'),(116466,389,'Rohanda','175031',1,0,'2022-03-03 13:29:16','2022-03-03 13:29:16'),(116467,389,'Ropa','175012',1,0,'2022-03-03 13:29:16','2022-03-03 13:29:16'),(116468,389,'Ropari','175024',1,0,'2022-03-03 13:29:16','2022-03-03 13:29:16'),(116469,389,'Ropri Kalehru','175032',1,0,'2022-03-03 13:29:16','2022-03-03 13:29:16'),(116470,389,'Ruhamani','175047',1,0,'2022-03-03 13:29:16','2022-03-03 13:29:16'),(116471,389,'Sadhot','175024',1,0,'2022-03-03 13:29:16','2022-03-03 13:29:16'),(116472,389,'Sadhyani','175008',1,0,'2022-03-03 13:29:16','2022-03-03 13:29:16'),(116473,389,'Sadyana','175001',1,0,'2022-03-03 13:29:17','2022-03-03 13:29:17'),(116474,389,'Saigaloo','175052',1,0,'2022-03-03 13:29:17','2022-03-03 13:29:17'),(116475,389,'Sainj Bagra','175011',1,0,'2022-03-03 13:29:17','2022-03-03 13:29:17'),(116476,389,'Sajao Pipluso','175025',1,0,'2022-03-03 13:29:17','2022-03-03 13:29:17'),(116477,389,'Saklana','175050',1,0,'2022-03-03 13:29:17','2022-03-03 13:29:17'),(116478,389,'Sakra','175009',1,0,'2022-03-03 13:29:17','2022-03-03 13:29:17'),(116479,389,'Sakroha','175006',1,0,'2022-03-03 13:29:17','2022-03-03 13:29:17'),(116480,389,'Saletar','175003',1,0,'2022-03-03 13:29:17','2022-03-03 13:29:17'),(116481,389,'Salwana','175018',1,0,'2022-03-03 13:29:17','2022-03-03 13:29:17'),(116482,389,'Salwar','175134',1,0,'2022-03-03 13:29:17','2022-03-03 13:29:17'),(116483,389,'Samaila','175034',1,0,'2022-03-03 13:29:17','2022-03-03 13:29:17'),(116484,389,'Samour','175050',1,0,'2022-03-03 13:29:17','2022-03-03 13:29:17'),(116485,389,'Samrahan','175003',1,0,'2022-03-03 13:29:17','2022-03-03 13:29:17'),(116486,389,'Sandhole','176090',1,0,'2022-03-03 13:29:17','2022-03-03 13:29:17'),(116487,389,'Sangalwara','175047',1,0,'2022-03-03 13:29:17','2022-03-03 13:29:17'),(116488,389,'Sankar Dehra','175011',1,0,'2022-03-03 13:29:17','2022-03-03 13:29:17'),(116489,389,'Sapnot','175009',1,0,'2022-03-03 13:29:17','2022-03-03 13:29:17'),(116490,389,'Sardhwar','175023',1,0,'2022-03-03 13:29:17','2022-03-03 13:29:17'),(116491,389,'Sari','175025',1,0,'2022-03-03 13:29:17','2022-03-03 13:29:17'),(116492,389,'Sarkaghat','175024',1,0,'2022-03-03 13:29:18','2022-03-03 13:29:18'),(116493,389,'Sarkidhar','175023',1,0,'2022-03-03 13:29:18','2022-03-03 13:29:18'),(116494,389,'Saroa','175124',1,0,'2022-03-03 13:29:18','2022-03-03 13:29:18'),(116495,389,'Sayanj','175029',1,0,'2022-03-03 13:29:18','2022-03-03 13:29:18'),(116496,389,'Seghli','175029',1,0,'2022-03-03 13:29:18','2022-03-03 13:29:18'),(116497,389,'Segli','175005',1,0,'2022-03-03 13:29:18','2022-03-03 13:29:18'),(116498,389,'Sehli','175018',1,0,'2022-03-03 13:29:18','2022-03-03 13:29:18'),(116499,389,'Sehli','175052',1,0,'2022-03-03 13:29:18','2022-03-03 13:29:18'),(116500,389,'Seoh','175051',1,0,'2022-03-03 13:29:18','2022-03-03 13:29:18'),(116501,389,'Seri','175011',1,0,'2022-03-03 13:29:18','2022-03-03 13:29:18'),(116502,389,'Seri Kothi','175038',1,0,'2022-03-03 13:29:18','2022-03-03 13:29:18'),(116503,389,'Shala','175028',1,0,'2022-03-03 13:29:18','2022-03-03 13:29:18'),(116504,389,'Shanan Power House','175015',1,0,'2022-03-03 13:29:18','2022-03-03 13:29:18'),(116505,389,'Shiah','175141',1,0,'2022-03-03 13:29:18','2022-03-03 13:29:18'),(116506,389,'Shikawari','175035',1,0,'2022-03-03 13:29:18','2022-03-03 13:29:18'),(116507,389,'Shilhnu','175028',1,0,'2022-03-03 13:29:18','2022-03-03 13:29:18'),(116508,389,'Shillibagi','175035',1,0,'2022-03-03 13:29:18','2022-03-03 13:29:18'),(116509,389,'Shiva','175124',1,0,'2022-03-03 13:29:18','2022-03-03 13:29:18'),(116510,389,'Shorshan','175009',1,0,'2022-03-03 13:29:18','2022-03-03 13:29:18'),(116511,389,'Sidhpur','175040',1,0,'2022-03-03 13:29:19','2022-03-03 13:29:19'),(116512,389,'Silhbadhani','175012',1,0,'2022-03-03 13:29:19','2022-03-03 13:29:19'),(116513,389,'Simas','175016',1,0,'2022-03-03 13:29:19','2022-03-03 13:29:19'),(116514,389,'Slapper','175017',1,0,'2022-03-03 13:29:19','2022-03-03 13:29:19'),(116515,389,'Soma Kothi','175011',1,0,'2022-03-03 13:29:19','2022-03-03 13:29:19'),(116516,389,'Somnachi','175121',1,0,'2022-03-03 13:29:19','2022-03-03 13:29:19'),(116517,389,'Sudhan','175017',1,0,'2022-03-03 13:29:19','2022-03-03 13:29:19'),(116518,389,'Sudhar','175012',1,0,'2022-03-03 13:29:19','2022-03-03 13:29:19'),(116519,389,'Sukibain','175028',1,0,'2022-03-03 13:29:19','2022-03-03 13:29:19'),(116520,389,'Sunah Lamba Thach','175048',1,0,'2022-03-03 13:29:19','2022-03-03 13:29:19'),(116521,389,'Sunder Nagar Town Ship H.O','175019',1,0,'2022-03-03 13:29:19','2022-03-03 13:29:19'),(116522,389,'Sunder Nagar-1','175018',1,0,'2022-03-03 13:29:19','2022-03-03 13:29:19'),(116523,389,'Surah','175027',1,0,'2022-03-03 13:29:19','2022-03-03 13:29:19'),(116524,389,'Surahan Suket','175011',1,0,'2022-03-03 13:29:19','2022-03-03 13:29:19'),(116525,389,'Surajpur Bari','175024',1,0,'2022-03-03 13:29:19','2022-03-03 13:29:19'),(116526,389,'Syanji','175027',1,0,'2022-03-03 13:29:19','2022-03-03 13:29:19'),(116527,389,'Taleli','175030',1,0,'2022-03-03 13:29:19','2022-03-03 13:29:19'),(116528,389,'Talyahar','175001',1,0,'2022-03-03 13:29:19','2022-03-03 13:29:19'),(116529,389,'Tandu','175001',1,0,'2022-03-03 13:29:19','2022-03-03 13:29:19'),(116530,389,'Tanehar','175050',1,0,'2022-03-03 13:29:19','2022-03-03 13:29:19'),(116531,389,'Tanihar','175026',1,0,'2022-03-03 13:29:19','2022-03-03 13:29:19'),(116532,389,'Tarnoh','175001',1,0,'2022-03-03 13:29:19','2022-03-03 13:29:19'),(116533,389,'Tattapani','175009',1,0,'2022-03-03 13:29:20','2022-03-03 13:29:20'),(116534,389,'Taurjajar','175040',1,0,'2022-03-03 13:29:20','2022-03-03 13:29:20'),(116535,389,'Teban','175011',1,0,'2022-03-03 13:29:20','2022-03-03 13:29:20'),(116536,389,'Thachi','175121',1,0,'2022-03-03 13:29:20','2022-03-03 13:29:20'),(116537,389,'Thalout','175121',1,0,'2022-03-03 13:29:20','2022-03-03 13:29:20'),(116538,389,'Thaltukhod','175013',1,0,'2022-03-03 13:29:20','2022-03-03 13:29:20'),(116539,389,'Thanashiva','175035',1,0,'2022-03-03 13:29:20','2022-03-03 13:29:20'),(116540,389,'Thara','175015',1,0,'2022-03-03 13:29:20','2022-03-03 13:29:20'),(116541,389,'Thatibir','175106',1,0,'2022-03-03 13:29:20','2022-03-03 13:29:20'),(116542,389,'Thinagaloo','175023',1,0,'2022-03-03 13:29:20','2022-03-03 13:29:20'),(116543,389,'Thona','175049',1,0,'2022-03-03 13:29:20','2022-03-03 13:29:20'),(116544,389,'Thunag','175048',1,0,'2022-03-03 13:29:20','2022-03-03 13:29:20'),(116545,389,'Tihra','175026',1,0,'2022-03-03 13:29:21','2022-03-03 13:29:21'),(116546,389,'Tihri','175005',1,0,'2022-03-03 13:29:21','2022-03-03 13:29:21'),(116547,389,'Tikkar','175006',1,0,'2022-03-03 13:29:21','2022-03-03 13:29:21'),(116548,389,'Tikkar','175049',1,0,'2022-03-03 13:29:21','2022-03-03 13:29:21'),(116549,389,'Tikri Sidhwani','175004',1,0,'2022-03-03 13:29:21','2022-03-03 13:29:21'),(116550,389,'Tikroo','175032',1,0,'2022-03-03 13:29:21','2022-03-03 13:29:21'),(116551,389,'Tilli','175001',1,0,'2022-03-03 13:29:21','2022-03-03 13:29:21'),(116552,389,'Tourkhola','176090',1,0,'2022-03-03 13:29:21','2022-03-03 13:29:21'),(116553,389,'Tramat','175032',1,0,'2022-03-03 13:29:21','2022-03-03 13:29:21'),(116554,389,'Trifalghat','175034',1,0,'2022-03-03 13:29:21','2022-03-03 13:29:21'),(116555,389,'Troh','175008',1,0,'2022-03-03 13:29:21','2022-03-03 13:29:21'),(116556,389,'Tullah','175015',1,0,'2022-03-03 13:29:21','2022-03-03 13:29:21'),(116557,389,'Tung','175123',1,0,'2022-03-03 13:29:21','2022-03-03 13:29:21'),(116558,389,'Upper Behli','175018',1,0,'2022-03-03 13:29:21','2022-03-03 13:29:21'),(116559,389,'Upper Bhambla','175004',1,0,'2022-03-03 13:29:21','2022-03-03 13:29:21'),(116560,389,'Urla','175015',1,0,'2022-03-03 13:29:21','2022-03-03 13:29:21'),(116561,389,'Vayala','175018',1,0,'2022-03-03 13:29:21','2022-03-03 13:29:21'),(116562,390,'Bahli','172022',1,0,'2022-03-03 13:29:21','2022-03-03 13:29:21'),(116563,390,'Barach','172001',1,0,'2022-03-03 13:29:21','2022-03-03 13:29:21'),(116564,390,'Baragaon (Shimla)','172027',1,0,'2022-03-03 13:29:21','2022-03-03 13:29:21'),(116565,390,'Batari','172031',1,0,'2022-03-03 13:29:21','2022-03-03 13:29:21'),(116566,390,'Bharawali','172022',1,0,'2022-03-03 13:29:21','2022-03-03 13:29:21'),(116567,390,'Bhareri','172024',1,0,'2022-03-03 13:29:21','2022-03-03 13:29:21'),(116568,390,'Bhutti','172030',1,0,'2022-03-03 13:29:22','2022-03-03 13:29:22'),(116569,390,'Bonda','172034',1,0,'2022-03-03 13:29:22','2022-03-03 13:29:22'),(116570,390,'Chikul','172024',1,0,'2022-03-03 13:29:22','2022-03-03 13:29:22'),(116571,390,'Danawali','172021',1,0,'2022-03-03 13:29:22','2022-03-03 13:29:22'),(116572,390,'Dansa','172001',1,0,'2022-03-03 13:29:22','2022-03-03 13:29:22'),(116573,390,'Darkali','172022',1,0,'2022-03-03 13:29:22','2022-03-03 13:29:22'),(116574,390,'Dawara','172022',1,0,'2022-03-03 13:29:22','2022-03-03 13:29:22'),(116575,390,'Delath','172028',1,0,'2022-03-03 13:29:22','2022-03-03 13:29:22'),(116576,390,'Deothi','172022',1,0,'2022-03-03 13:29:22','2022-03-03 13:29:22'),(116577,390,'Dofda','172102',1,0,'2022-03-03 13:29:22','2022-03-03 13:29:22'),(116578,390,'Duttnagar','172001',1,0,'2022-03-03 13:29:23','2022-03-03 13:29:23'),(116579,390,'Galani','172024',1,0,'2022-03-03 13:29:23','2022-03-03 13:29:23'),(116580,390,'Ganvi','172101',1,0,'2022-03-03 13:29:23','2022-03-03 13:29:23'),(116581,390,'Gaura','172201',1,0,'2022-03-03 13:29:23','2022-03-03 13:29:23'),(116582,390,'Jaghori','172101',1,0,'2022-03-03 13:29:23','2022-03-03 13:29:23'),(116583,390,'Janjheli','172024',1,0,'2022-03-03 13:29:23','2022-03-03 13:29:23'),(116584,390,'Jar','172029',1,0,'2022-03-03 13:29:23','2022-03-03 13:29:23'),(116585,390,'Jarol','172031',1,0,'2022-03-03 13:29:23','2022-03-03 13:29:23'),(116586,390,'Jeori','172101',1,0,'2022-03-03 13:29:23','2022-03-03 13:29:23'),(116587,390,'Jhakri','172201',1,0,'2022-03-03 13:29:23','2022-03-03 13:29:23'),(116588,390,'Kareri','172022',1,0,'2022-03-03 13:29:23','2022-03-03 13:29:23'),(116589,390,'Kartot','172201',1,0,'2022-03-03 13:29:23','2022-03-03 13:29:23'),(116590,390,'Kashapat','172022',1,0,'2022-03-03 13:29:23','2022-03-03 13:29:23'),(116591,390,'Kayab','172101',1,0,'2022-03-03 13:29:23','2022-03-03 13:29:23'),(116592,390,'Khamadi','172001',1,0,'2022-03-03 13:29:23','2022-03-03 13:29:23'),(116593,390,'Khaneri','172001',1,0,'2022-03-03 13:29:23','2022-03-03 13:29:23'),(116594,390,'Kharga','172201',1,0,'2022-03-03 13:29:23','2022-03-03 13:29:23'),(116595,390,'Kingal','172024',1,0,'2022-03-03 13:29:23','2022-03-03 13:29:23'),(116596,390,'Kinnu','172102',1,0,'2022-03-03 13:29:24','2022-03-03 13:29:24'),(116597,390,'Kirti','172030',1,0,'2022-03-03 13:29:24','2022-03-03 13:29:24'),(116598,390,'Koot','172101',1,0,'2022-03-03 13:29:24','2022-03-03 13:29:24'),(116599,390,'Kotgarh','172031',1,0,'2022-03-03 13:29:24','2022-03-03 13:29:24'),(116600,390,'Kotla','172024',1,0,'2022-03-03 13:29:24','2022-03-03 13:29:24'),(116601,390,'Kumarsain','172029',1,0,'2022-03-03 13:29:24','2022-03-03 13:29:24'),(116602,390,'Kungal Balti','172001',1,0,'2022-03-03 13:29:24','2022-03-03 13:29:24'),(116603,390,'Labana','172101',1,0,'2022-03-03 13:29:24','2022-03-03 13:29:24'),(116604,390,'Lailon','172001',1,0,'2022-03-03 13:29:24','2022-03-03 13:29:24'),(116605,390,'Majauli','172102',1,0,'2022-03-03 13:29:24','2022-03-03 13:29:24'),(116606,390,'Mashnoo','172102',1,0,'2022-03-03 13:29:24','2022-03-03 13:29:24'),(116607,390,'Munish Bhali','172022',1,0,'2022-03-03 13:29:24','2022-03-03 13:29:24'),(116608,390,'Nankhari','172021',1,0,'2022-03-03 13:29:24','2022-03-03 13:29:24'),(116609,390,'Narain','172022',1,0,'2022-03-03 13:29:24','2022-03-03 13:29:24'),(116610,390,'Naula','172001',1,0,'2022-03-03 13:29:24','2022-03-03 13:29:24'),(116611,390,'Nirth','172001',1,0,'2022-03-03 13:29:24','2022-03-03 13:29:24'),(116612,390,'Nogli','172022',1,0,'2022-03-03 13:29:24','2022-03-03 13:29:24'),(116613,390,'Padam Nagar (Shimla)','172001',1,0,'2022-03-03 13:29:24','2022-03-03 13:29:24'),(116614,390,'Phancha','172101',1,0,'2022-03-03 13:29:24','2022-03-03 13:29:24'),(116615,390,'Pharal','172029',1,0,'2022-03-03 13:29:24','2022-03-03 13:29:24'),(116616,390,'Rampur Bushahr H.O','172001',1,0,'2022-03-03 13:29:24','2022-03-03 13:29:24'),(116617,390,'Rupi','172101',1,0,'2022-03-03 13:29:24','2022-03-03 13:29:24'),(116618,390,'Sarahan BSR','172102',1,0,'2022-03-03 13:29:25','2022-03-03 13:29:25'),(116619,390,'Sarpara','172201',1,0,'2022-03-03 13:29:25','2022-03-03 13:29:25'),(116620,390,'Shahdhar','172102',1,0,'2022-03-03 13:29:25','2022-03-03 13:29:25'),(116621,390,'Shamathla','172030',1,0,'2022-03-03 13:29:25','2022-03-03 13:29:25'),(116622,390,'Sharambal Camp','172029',1,0,'2022-03-03 13:29:25','2022-03-03 13:29:25'),(116623,390,'Shingla','172001',1,0,'2022-03-03 13:29:25','2022-03-03 13:29:25'),(116624,390,'Shiwan','172027',1,0,'2022-03-03 13:29:25','2022-03-03 13:29:25'),(116625,390,'Sholi','172001',1,0,'2022-03-03 13:29:25','2022-03-03 13:29:25'),(116626,390,'Sugha','172201',1,0,'2022-03-03 13:29:25','2022-03-03 13:29:25'),(116627,390,'Surad','172001',1,0,'2022-03-03 13:29:25','2022-03-03 13:29:25'),(116628,390,'Taklech','172022',1,0,'2022-03-03 13:29:25','2022-03-03 13:29:25'),(116629,390,'Teshan','172027',1,0,'2022-03-03 13:29:25','2022-03-03 13:29:25'),(116630,390,'Thaili Chakti','172001',1,0,'2022-03-03 13:29:25','2022-03-03 13:29:25'),(116631,390,'Thanedhar','172030',1,0,'2022-03-03 13:29:25','2022-03-03 13:29:25'),(116632,390,'AGPO','171003',1,0,'2022-03-03 13:29:25','2022-03-03 13:29:25'),(116633,390,'AHQ','171003',1,0,'2022-03-03 13:29:25','2022-03-03 13:29:25'),(116634,390,'Ambedkarchowk','171004',1,0,'2022-03-03 13:29:25','2022-03-03 13:29:25'),(116635,390,'Anandpur','171219',1,0,'2022-03-03 13:29:25','2022-03-03 13:29:25'),(116636,390,'Anti','171206',1,0,'2022-03-03 13:29:25','2022-03-03 13:29:25'),(116637,390,'Arhal','171223',1,0,'2022-03-03 13:29:25','2022-03-03 13:29:25'),(116638,390,'Bachhunchh','171207',1,0,'2022-03-03 13:29:25','2022-03-03 13:29:25'),(116639,390,'Badehari','171011',1,0,'2022-03-03 13:29:25','2022-03-03 13:29:25'),(116640,390,'Baghar','171202',1,0,'2022-03-03 13:29:25','2022-03-03 13:29:25'),(116641,390,'Baghi (Shimla)','171225',1,0,'2022-03-03 13:29:25','2022-03-03 13:29:25'),(116642,390,'Bagri','171220',1,0,'2022-03-03 13:29:26','2022-03-03 13:29:26'),(116643,390,'Bakhol','171202',1,0,'2022-03-03 13:29:26','2022-03-03 13:29:26'),(116644,390,'Balag','171226',1,0,'2022-03-03 13:29:26','2022-03-03 13:29:26'),(116645,390,'Baldeyan','171007',1,0,'2022-03-03 13:29:26','2022-03-03 13:29:26'),(116646,390,'Balghar','171220',1,0,'2022-03-03 13:29:26','2022-03-03 13:29:26'),(116647,390,'Bamta','171211',1,0,'2022-03-03 13:29:26','2022-03-03 13:29:26'),(116648,390,'Barog','171201',1,0,'2022-03-03 13:29:26','2022-03-03 13:29:26'),(116649,390,'Barthata','171206',1,0,'2022-03-03 13:29:26','2022-03-03 13:29:26'),(116650,390,'Basadhar','171226',1,0,'2022-03-03 13:29:26','2022-03-03 13:29:26'),(116651,390,'Basanatpur','171018',1,0,'2022-03-03 13:29:26','2022-03-03 13:29:26'),(116652,390,'Beolia','171013',1,0,'2022-03-03 13:29:26','2022-03-03 13:29:26'),(116653,390,'Bhalawag','171213',1,0,'2022-03-03 13:29:26','2022-03-03 13:29:26'),(116654,390,'Bhalu','171217',1,0,'2022-03-03 13:29:26','2022-03-03 13:29:26'),(116655,390,'Bharana','171212',1,0,'2022-03-03 13:29:26','2022-03-03 13:29:26'),(116656,390,'Bharanu','171210',1,0,'2022-03-03 13:29:26','2022-03-03 13:29:26'),(116657,390,'Bharara','171018',1,0,'2022-03-03 13:29:26','2022-03-03 13:29:26'),(116658,390,'Bharari','171003',1,0,'2022-03-03 13:29:26','2022-03-03 13:29:26'),(116659,390,'Bhogra','171201',1,0,'2022-03-03 13:29:26','2022-03-03 13:29:26'),(116660,390,'Bholad','171216',1,0,'2022-03-03 13:29:26','2022-03-03 13:29:26'),(116661,390,'Bhont','171003',1,0,'2022-03-03 13:29:26','2022-03-03 13:29:26'),(116662,390,'Bijmal','171210',1,0,'2022-03-03 13:29:26','2022-03-03 13:29:26'),(116663,390,'Boileauganj','171005',1,0,'2022-03-03 13:29:26','2022-03-03 13:29:26'),(116664,390,'Bour','171210',1,0,'2022-03-03 13:29:26','2022-03-03 13:29:26'),(116665,390,'Busstand','171001',1,0,'2022-03-03 13:29:26','2022-03-03 13:29:26'),(116666,390,'Bychari','171011',1,0,'2022-03-03 13:29:27','2022-03-03 13:29:27'),(116667,390,'Chaba','171301',1,0,'2022-03-03 13:29:27','2022-03-03 13:29:27'),(116668,390,'Chaili','171005',1,0,'2022-03-03 13:29:27','2022-03-03 13:29:27'),(116669,390,'Chalahal','171103',1,0,'2022-03-03 13:29:27','2022-03-03 13:29:27'),(116670,390,'Chalnair','171202',1,0,'2022-03-03 13:29:27','2022-03-03 13:29:27'),(116671,390,'Chambi','171211',1,0,'2022-03-03 13:29:27','2022-03-03 13:29:27'),(116672,390,'Chanair','171220',1,0,'2022-03-03 13:29:27','2022-03-03 13:29:27'),(116673,390,'Chanana Dhar','171210',1,0,'2022-03-03 13:29:27','2022-03-03 13:29:27'),(116674,390,'Chanawag','171103',1,0,'2022-03-03 13:29:27','2022-03-03 13:29:27'),(116675,390,'Chanog','171011',1,0,'2022-03-03 13:29:27','2022-03-03 13:29:27'),(116676,390,'Charoli','171217',1,0,'2022-03-03 13:29:27','2022-03-03 13:29:27'),(116677,390,'Chauth','171211',1,0,'2022-03-03 13:29:27','2022-03-03 13:29:27'),(116678,390,'Cheog','171209',1,0,'2022-03-03 13:29:27','2022-03-03 13:29:27'),(116679,390,'Chhaila','171220',1,0,'2022-03-03 13:29:27','2022-03-03 13:29:27'),(116680,390,'Chharabra','171012',1,0,'2022-03-03 13:29:27','2022-03-03 13:29:27'),(116681,390,'Chikar','171201',1,0,'2022-03-03 13:29:27','2022-03-03 13:29:27'),(116682,390,'Chilala','171208',1,0,'2022-03-03 13:29:27','2022-03-03 13:29:27'),(116683,390,'Chirgaon (Shimla)','171208',1,0,'2022-03-03 13:29:27','2022-03-03 13:29:27'),(116684,390,'Chopal','171211',1,0,'2022-03-03 13:29:27','2022-03-03 13:29:27'),(116685,390,'Combermere','171001',1,0,'2022-03-03 13:29:27','2022-03-03 13:29:27'),(116686,390,'CPRI','171001',1,0,'2022-03-03 13:29:27','2022-03-03 13:29:27'),(116687,390,'Darbhog','171012',1,0,'2022-03-03 13:29:27','2022-03-03 13:29:27'),(116688,390,'Darkoti','171202',1,0,'2022-03-03 13:29:27','2022-03-03 13:29:27'),(116689,390,'Deem','171205',1,0,'2022-03-03 13:29:27','2022-03-03 13:29:27'),(116690,390,'Dehabalson','171220',1,0,'2022-03-03 13:29:28','2022-03-03 13:29:28'),(116691,390,'Deiya','171210',1,0,'2022-03-03 13:29:28','2022-03-03 13:29:28'),(116692,390,'Deori Khaneti','171204',1,0,'2022-03-03 13:29:28','2022-03-03 13:29:28'),(116693,390,'Deothibalson','171220',1,0,'2022-03-03 13:29:28','2022-03-03 13:29:28'),(116694,390,'Devgarh','171202',1,0,'2022-03-03 13:29:28','2022-03-03 13:29:28'),(116695,390,'Devidhar','171214',1,0,'2022-03-03 13:29:28','2022-03-03 13:29:28'),(116696,390,'Devnagar','171011',1,0,'2022-03-03 13:29:28','2022-03-03 13:29:28'),(116697,390,'Dewat','171211',1,0,'2022-03-03 13:29:28','2022-03-03 13:29:28'),(116698,390,'Dewla','171007',1,0,'2022-03-03 13:29:28','2022-03-03 13:29:28'),(116699,390,'Dhadighunsa','171206',1,0,'2022-03-03 13:29:28','2022-03-03 13:29:28'),(116700,390,'Dhadirawat','171206',1,0,'2022-03-03 13:29:28','2022-03-03 13:29:28'),(116701,390,'Dhalli','171012',1,0,'2022-03-03 13:29:28','2022-03-03 13:29:28'),(116702,390,'Dhamandari','171209',1,0,'2022-03-03 13:29:28','2022-03-03 13:29:28'),(116703,390,'Dhami','171103',1,0,'2022-03-03 13:29:28','2022-03-03 13:29:28'),(116704,390,'Dhar','171205',1,0,'2022-03-03 13:29:28','2022-03-03 13:29:28'),(116705,390,'Dharampur Madhan','171201',1,0,'2022-03-03 13:29:28','2022-03-03 13:29:28'),(116706,390,'Dharara','171203',1,0,'2022-03-03 13:29:28','2022-03-03 13:29:28'),(116707,390,'Dharech','171209',1,0,'2022-03-03 13:29:28','2022-03-03 13:29:28'),(116708,390,'Dhari','171219',1,0,'2022-03-03 13:29:28','2022-03-03 13:29:28'),(116709,390,'Dharogra','171019',1,0,'2022-03-03 13:29:28','2022-03-03 13:29:28'),(116710,390,'Dhawas','171211',1,0,'2022-03-03 13:29:28','2022-03-03 13:29:28'),(116711,390,'Dodra','171221',1,0,'2022-03-03 13:29:28','2022-03-03 13:29:28'),(116712,390,'Durgapur','171007',1,0,'2022-03-03 13:29:29','2022-03-03 13:29:29'),(116713,390,'Eera','171210',1,0,'2022-03-03 13:29:29','2022-03-03 13:29:29'),(116714,390,'Fagu (Shimla)','171209',1,0,'2022-03-03 13:29:29','2022-03-03 13:29:29'),(116715,390,'Gadheri','171019',1,0,'2022-03-03 13:29:29','2022-03-03 13:29:29'),(116716,390,'Galeha','171204',1,0,'2022-03-03 13:29:29','2022-03-03 13:29:29'),(116717,390,'Gaonsari','171208',1,0,'2022-03-03 13:29:29','2022-03-03 13:29:29'),(116718,390,'Garog','171202',1,0,'2022-03-03 13:29:29','2022-03-03 13:29:29'),(116719,390,'Gawas','171207',1,0,'2022-03-03 13:29:29','2022-03-03 13:29:29'),(116720,390,'Ghaini','171007',1,0,'2022-03-03 13:29:29','2022-03-03 13:29:29'),(116721,390,'Ghana-hatti','171011',1,0,'2022-03-03 13:29:29','2022-03-03 13:29:29'),(116722,390,'Ghasani','171203',1,0,'2022-03-03 13:29:29','2022-03-03 13:29:29'),(116723,390,'Ghoond','171220',1,0,'2022-03-03 13:29:29','2022-03-03 13:29:29'),(116724,390,'Giahan','171210',1,0,'2022-03-03 13:29:29','2022-03-03 13:29:29'),(116725,390,'Giltari','171216',1,0,'2022-03-03 13:29:29','2022-03-03 13:29:29'),(116726,390,'Gumma','171202',1,0,'2022-03-03 13:29:29','2022-03-03 13:29:29'),(116727,390,'Gumma','171018',1,0,'2022-03-03 13:29:29','2022-03-03 13:29:29'),(116728,390,'Halanidhar','171213',1,0,'2022-03-03 13:29:29','2022-03-03 13:29:29'),(116729,390,'Hatkoti','171206',1,0,'2022-03-03 13:29:29','2022-03-03 13:29:29'),(116730,390,'Himri','171019',1,0,'2022-03-03 13:29:29','2022-03-03 13:29:29'),(116731,390,'Himri','171202',1,0,'2022-03-03 13:29:29','2022-03-03 13:29:29'),(116732,390,'HP.Sectt.','171002',1,0,'2022-03-03 13:29:29','2022-03-03 13:29:29'),(116733,390,'IGMC','171001',1,0,'2022-03-03 13:29:30','2022-03-03 13:29:30'),(116734,390,'Jabri','171103',1,0,'2022-03-03 13:29:30','2022-03-03 13:29:30'),(116735,390,'Jagothi','171207',1,0,'2022-03-03 13:29:30','2022-03-03 13:29:30'),(116736,390,'Jahu','171213',1,0,'2022-03-03 13:29:30','2022-03-03 13:29:30'),(116737,390,'Jais','171201',1,0,'2022-03-03 13:29:30','2022-03-03 13:29:30'),(116738,390,'Jakha','171221',1,0,'2022-03-03 13:29:30','2022-03-03 13:29:30'),(116739,390,'Jalog','171019',1,0,'2022-03-03 13:29:30','2022-03-03 13:29:30'),(116740,390,'Jangla','171214',1,0,'2022-03-03 13:29:30','2022-03-03 13:29:30'),(116741,390,'Jathia Devi','171011',1,0,'2022-03-03 13:29:30','2022-03-03 13:29:30'),(116742,390,'Jhagtan','171216',1,0,'2022-03-03 13:29:30','2022-03-03 13:29:30'),(116743,390,'Jhalta','171216',1,0,'2022-03-03 13:29:30','2022-03-03 13:29:30'),(116744,390,'Jharag','171206',1,0,'2022-03-03 13:29:30','2022-03-03 13:29:30'),(116745,390,'Jhiknipul','171211',1,0,'2022-03-03 13:29:30','2022-03-03 13:29:30'),(116746,390,'Jokhar','171217',1,0,'2022-03-03 13:29:30','2022-03-03 13:29:30'),(116747,390,'Jubbal','171205',1,0,'2022-03-03 13:29:30','2022-03-03 13:29:30'),(116748,390,'Jubbarhatti','171011',1,0,'2022-03-03 13:29:30','2022-03-03 13:29:30'),(116749,390,'Jublee','171210',1,0,'2022-03-03 13:29:30','2022-03-03 13:29:30'),(116750,390,'Junga','171218',1,0,'2022-03-03 13:29:30','2022-03-03 13:29:30'),(116751,390,'Juni','171301',1,0,'2022-03-03 13:29:30','2022-03-03 13:29:30'),(116752,390,'Jutogh','171008',1,0,'2022-03-03 13:29:30','2022-03-03 13:29:30'),(116753,390,'Kadarghat','171018',1,0,'2022-03-03 13:29:31','2022-03-03 13:29:31'),(116754,390,'Kadiwan','171203',1,0,'2022-03-03 13:29:31','2022-03-03 13:29:31'),(116755,390,'Kaithu','171003',1,0,'2022-03-03 13:29:31','2022-03-03 13:29:31'),(116756,390,'Kalbog','171225',1,0,'2022-03-03 13:29:31','2022-03-03 13:29:31'),(116757,390,'Kalihatti','171103',1,0,'2022-03-03 13:29:31','2022-03-03 13:29:31'),(116758,390,'Kalind','171220',1,0,'2022-03-03 13:29:31','2022-03-03 13:29:31'),(116759,390,'Kaloti','171207',1,0,'2022-03-03 13:29:31','2022-03-03 13:29:31'),(116760,390,'Kamlanagar','171006',1,0,'2022-03-03 13:29:31','2022-03-03 13:29:31'),(116761,390,'Kanahar','171213',1,0,'2022-03-03 13:29:31','2022-03-03 13:29:31'),(116762,390,'Kanda Banah','171217',1,0,'2022-03-03 13:29:31','2022-03-03 13:29:31'),(116763,390,'Kandroo','171212',1,0,'2022-03-03 13:29:31','2022-03-03 13:29:31'),(116764,390,'Kandyali','171213',1,0,'2022-03-03 13:29:31','2022-03-03 13:29:31'),(116765,390,'Kangal','171019',1,0,'2022-03-03 13:29:31','2022-03-03 13:29:31'),(116766,390,'Kansakoti','171207',1,0,'2022-03-03 13:29:31','2022-03-03 13:29:31'),(116767,390,'Kanthli','171208',1,0,'2022-03-03 13:29:31','2022-03-03 13:29:31'),(116768,390,'Karasa','171207',1,0,'2022-03-03 13:29:31','2022-03-03 13:29:31'),(116769,390,'Kariali','171018',1,0,'2022-03-03 13:29:31','2022-03-03 13:29:31'),(116770,390,'Kasumpti','171009',1,0,'2022-03-03 13:29:31','2022-03-03 13:29:31'),(116771,390,'Kathasu','171206',1,0,'2022-03-03 13:29:31','2022-03-03 13:29:31'),(116772,390,'Kathog','171222',1,0,'2022-03-03 13:29:32','2022-03-03 13:29:32'),(116773,390,'Kawar','171221',1,0,'2022-03-03 13:29:32','2022-03-03 13:29:32'),(116774,390,'Kayana','171205',1,0,'2022-03-03 13:29:32','2022-03-03 13:29:32'),(116775,390,'Kedi','171210',1,0,'2022-03-03 13:29:32','2022-03-03 13:29:32'),(116776,390,'Kelvi','171212',1,0,'2022-03-03 13:29:32','2022-03-03 13:29:32'),(116777,390,'Khabal','171208',1,0,'2022-03-03 13:29:32','2022-03-03 13:29:32'),(116778,390,'Khadrala','171225',1,0,'2022-03-03 13:29:32','2022-03-03 13:29:32'),(116779,390,'Khagna','171211',1,0,'2022-03-03 13:29:32','2022-03-03 13:29:32'),(116780,390,'Khalini','171002',1,0,'2022-03-03 13:29:32','2022-03-03 13:29:32'),(116781,390,'Khangteri','171225',1,0,'2022-03-03 13:29:32','2022-03-03 13:29:32'),(116782,390,'Kharahan','171213',1,0,'2022-03-03 13:29:32','2022-03-03 13:29:32'),(116783,390,'Khashdhar','171208',1,0,'2022-03-03 13:29:32','2022-03-03 13:29:32'),(116784,390,'Khatnol','171007',1,0,'2022-03-03 13:29:32','2022-03-03 13:29:32'),(116785,390,'Khera','171018',1,0,'2022-03-03 13:29:32','2022-03-03 13:29:32'),(116786,390,'Khunni','171213',1,0,'2022-03-03 13:29:32','2022-03-03 13:29:32'),(116787,390,'Kiar','171220',1,0,'2022-03-03 13:29:32','2022-03-03 13:29:32'),(116788,390,'Kiara','171213',1,0,'2022-03-03 13:29:32','2022-03-03 13:29:32'),(116789,390,'Kiari','171204',1,0,'2022-03-03 13:29:32','2022-03-03 13:29:32'),(116790,390,'Kiarkoti','171007',1,0,'2022-03-03 13:29:32','2022-03-03 13:29:32'),(116791,390,'Kiarla','171210',1,0,'2022-03-03 13:29:32','2022-03-03 13:29:32'),(116792,390,'Kiartoonal','171201',1,0,'2022-03-03 13:29:32','2022-03-03 13:29:32'),(116793,390,'Kohbag','171103',1,0,'2022-03-03 13:29:32','2022-03-03 13:29:32'),(116794,390,'Kokunala','171202',1,0,'2022-03-03 13:29:33','2022-03-03 13:29:33'),(116795,390,'Koti','171012',1,0,'2022-03-03 13:29:33','2022-03-03 13:29:33'),(116796,390,'Kotighat','171212',1,0,'2022-03-03 13:29:33','2022-03-03 13:29:33'),(116797,390,'Kotkhai','171202',1,0,'2022-03-03 13:29:33','2022-03-03 13:29:33'),(116798,390,'Kufri','171012',1,0,'2022-03-03 13:29:33','2022-03-03 13:29:33'),(116799,390,'Kui','171207',1,0,'2022-03-03 13:29:33','2022-03-03 13:29:33'),(116800,390,'Kulag','171217',1,0,'2022-03-03 13:29:33','2022-03-03 13:29:33'),(116801,390,'Kupvi','171217',1,0,'2022-03-03 13:29:33','2022-03-03 13:29:33'),(116802,390,'Kuthar','171226',1,0,'2022-03-03 13:29:33','2022-03-03 13:29:33'),(116803,390,'Kuthara','171207',1,0,'2022-03-03 13:29:33','2022-03-03 13:29:33'),(116804,390,'Lafughati','171222',1,0,'2022-03-03 13:29:33','2022-03-03 13:29:33'),(116805,390,'Larot','171208',1,0,'2022-03-03 13:29:33','2022-03-03 13:29:33'),(116806,390,'Lower Koti','171207',1,0,'2022-03-03 13:29:33','2022-03-03 13:29:33'),(116807,390,'Madhana','171210',1,0,'2022-03-03 13:29:33','2022-03-03 13:29:33'),(116808,390,'Madhawani','171213',1,0,'2022-03-03 13:29:33','2022-03-03 13:29:33'),(116809,390,'Mahasu','171202',1,0,'2022-03-03 13:29:33','2022-03-03 13:29:33'),(116810,390,'Mahog','171212',1,0,'2022-03-03 13:29:33','2022-03-03 13:29:33'),(116811,390,'Mahori','171220',1,0,'2022-03-03 13:29:33','2022-03-03 13:29:33'),(116812,390,'Majhar','171209',1,0,'2022-03-03 13:29:33','2022-03-03 13:29:33'),(116813,390,'Majhiwar','171018',1,0,'2022-03-03 13:29:33','2022-03-03 13:29:33'),(116814,390,'Majholi','171217',1,0,'2022-03-03 13:29:33','2022-03-03 13:29:33'),(116815,390,'Malat','171210',1,0,'2022-03-03 13:29:34','2022-03-03 13:29:34'),(116816,390,'Maloothi','171012',1,0,'2022-03-03 13:29:34','2022-03-03 13:29:34'),(116817,390,'Malyana','171006',1,0,'2022-03-03 13:29:34','2022-03-03 13:29:34'),(116818,390,'Mandal (Shimla)','171216',1,0,'2022-03-03 13:29:34','2022-03-03 13:29:34'),(116819,390,'Mandhole','171215',1,0,'2022-03-03 13:29:34','2022-03-03 13:29:34'),(116820,390,'Marog','171211',1,0,'2022-03-03 13:29:34','2022-03-03 13:29:34'),(116821,390,'Mashobra','171007',1,0,'2022-03-03 13:29:34','2022-03-03 13:29:34'),(116822,390,'Masli','171208',1,0,'2022-03-03 13:29:34','2022-03-03 13:29:34'),(116823,390,'Matal','171211',1,0,'2022-03-03 13:29:34','2022-03-03 13:29:34'),(116824,390,'Matiana','171212',1,0,'2022-03-03 13:29:34','2022-03-03 13:29:34'),(116825,390,'Mehli','171013',1,0,'2022-03-03 13:29:34','2022-03-03 13:29:34'),(116826,390,'Mundghat','171012',1,0,'2022-03-03 13:29:34','2022-03-03 13:29:34'),(116827,390,'Mundu','171226',1,0,'2022-03-03 13:29:34','2022-03-03 13:29:34'),(116828,390,'Nabha Estate','171004',1,0,'2022-03-03 13:29:34','2022-03-03 13:29:34'),(116829,390,'Nagan','171202',1,0,'2022-03-03 13:29:34','2022-03-03 13:29:34'),(116830,390,'Nagjubber','171212',1,0,'2022-03-03 13:29:34','2022-03-03 13:29:34'),(116831,390,'Nakorapul','171211',1,0,'2022-03-03 13:29:34','2022-03-03 13:29:34'),(116832,390,'Nandpur','171206',1,0,'2022-03-03 13:29:34','2022-03-03 13:29:34'),(116833,390,'Narkanda','171213',1,0,'2022-03-03 13:29:34','2022-03-03 13:29:34'),(116834,390,'Nehra','171011',1,0,'2022-03-03 13:29:34','2022-03-03 13:29:34'),(116835,390,'Nerwa','171210',1,0,'2022-03-03 13:29:35','2022-03-03 13:29:35'),(116836,390,'New Shimla','171009',1,0,'2022-03-03 13:29:35','2022-03-03 13:29:35'),(116837,390,'Oddi','171213',1,0,'2022-03-03 13:29:35','2022-03-03 13:29:35'),(116838,390,'Ogli','171019',1,0,'2022-03-03 13:29:35','2022-03-03 13:29:35'),(116839,390,'Okharoo','171103',1,0,'2022-03-03 13:29:35','2022-03-03 13:29:35'),(116840,390,'Pahal','171007',1,0,'2022-03-03 13:29:35','2022-03-03 13:29:35'),(116841,390,'Pandoa','171019',1,0,'2022-03-03 13:29:35','2022-03-03 13:29:35'),(116842,390,'Pandranu','171206',1,0,'2022-03-03 13:29:35','2022-03-03 13:29:35'),(116843,390,'Panesh','171011',1,0,'2022-03-03 13:29:35','2022-03-03 13:29:35'),(116844,390,'Panog','171204',1,0,'2022-03-03 13:29:35','2022-03-03 13:29:35'),(116845,390,'Parala','171220',1,0,'2022-03-03 13:29:35','2022-03-03 13:29:35'),(116846,390,'Pauria','171211',1,0,'2022-03-03 13:29:35','2022-03-03 13:29:35'),(116847,390,'Pawan','171210',1,0,'2022-03-03 13:29:35','2022-03-03 13:29:35'),(116848,390,'Pekha','171208',1,0,'2022-03-03 13:29:35','2022-03-03 13:29:35'),(116849,390,'Poabo','171006',1,0,'2022-03-03 13:29:35','2022-03-03 13:29:35'),(116850,390,'Praunthi','171205',1,0,'2022-03-03 13:29:35','2022-03-03 13:29:35'),(116851,390,'Pujarli No.4','171207',1,0,'2022-03-03 13:29:35','2022-03-03 13:29:35'),(116852,390,'Pujarli No-2','171205',1,0,'2022-03-03 13:29:35','2022-03-03 13:29:35'),(116853,390,'Pujarli No-3','171203',1,0,'2022-03-03 13:29:35','2022-03-03 13:29:35'),(116854,390,'Pulbahal','171226',1,0,'2022-03-03 13:29:35','2022-03-03 13:29:35'),(116855,390,'Purag','171202',1,0,'2022-03-03 13:29:35','2022-03-03 13:29:35'),(116856,390,'Quinal','171202',1,0,'2022-03-03 13:29:35','2022-03-03 13:29:35'),(116857,390,'Rajhana','171009',1,0,'2022-03-03 13:29:35','2022-03-03 13:29:35'),(116858,390,'Rampur Keonthal','171011',1,0,'2022-03-03 13:29:36','2022-03-03 13:29:36'),(116859,390,'Ranol','171214',1,0,'2022-03-03 13:29:36','2022-03-03 13:29:36'),(116860,390,'Ratnari','171225',1,0,'2022-03-03 13:29:36','2022-03-03 13:29:36'),(116861,390,'Rauri','171011',1,0,'2022-03-03 13:29:36','2022-03-03 13:29:36'),(116862,390,'Rawlakiar','171202',1,0,'2022-03-03 13:29:36','2022-03-03 13:29:36'),(116863,390,'Rewag','171301',1,0,'2022-03-03 13:29:36','2022-03-03 13:29:36'),(116864,390,'Rohal','171208',1,0,'2022-03-03 13:29:36','2022-03-03 13:29:36'),(116865,390,'Rohru','171207',1,0,'2022-03-03 13:29:36','2022-03-03 13:29:36'),(116866,390,'Ruslah','171210',1,0,'2022-03-03 13:29:36','2022-03-03 13:29:36'),(116867,390,'Sainj','171103',1,0,'2022-03-03 13:29:36','2022-03-03 13:29:36'),(116868,390,'Sainj','171220',1,0,'2022-03-03 13:29:36','2022-03-03 13:29:36'),(116869,390,'Salana','171219',1,0,'2022-03-03 13:29:36','2022-03-03 13:29:36'),(116870,390,'Samara','171203',1,0,'2022-03-03 13:29:36','2022-03-03 13:29:36'),(116871,390,'Samoli','171207',1,0,'2022-03-03 13:29:36','2022-03-03 13:29:36'),(116872,390,'Sandhu','171222',1,0,'2022-03-03 13:29:36','2022-03-03 13:29:36'),(116873,390,'Sanjauli','171006',1,0,'2022-03-03 13:29:36','2022-03-03 13:29:36'),(116874,390,'Sarain','171211',1,0,'2022-03-03 13:29:36','2022-03-03 13:29:36'),(116875,390,'Sari','171226',1,0,'2022-03-03 13:29:36','2022-03-03 13:29:36'),(116876,390,'Sariun','171201',1,0,'2022-03-03 13:29:36','2022-03-03 13:29:36'),(116877,390,'Sarog','171201',1,0,'2022-03-03 13:29:36','2022-03-03 13:29:36'),(116878,390,'Satlai','171012',1,0,'2022-03-03 13:29:36','2022-03-03 13:29:36'),(116879,390,'Satog','171209',1,0,'2022-03-03 13:29:36','2022-03-03 13:29:36'),(116880,390,'Seema','171207',1,0,'2022-03-03 13:29:37','2022-03-03 13:29:37'),(116881,390,'Shailapani','171205',1,0,'2022-03-03 13:29:37','2022-03-03 13:29:37'),(116882,390,'Shakarah','171011',1,0,'2022-03-03 13:29:37','2022-03-03 13:29:37'),(116883,390,'Shari','171212',1,0,'2022-03-03 13:29:37','2022-03-03 13:29:37'),(116884,390,'Sharontha','171203',1,0,'2022-03-03 13:29:37','2022-03-03 13:29:37'),(116885,390,'Sheel','171205',1,0,'2022-03-03 13:29:37','2022-03-03 13:29:37'),(116886,390,'Shilaru','171213',1,0,'2022-03-03 13:29:37','2022-03-03 13:29:37'),(116887,390,'Shimla East','171002',1,0,'2022-03-03 13:29:37','2022-03-03 13:29:37'),(116888,390,'Shimla G.P.O.','171001',1,0,'2022-03-03 13:29:37','2022-03-03 13:29:37'),(116889,390,'Shimla High Court','171001',1,0,'2022-03-03 13:29:37','2022-03-03 13:29:37'),(116890,390,'Shoghi','171219',1,0,'2022-03-03 13:29:37','2022-03-03 13:29:37'),(116891,390,'Sindhasli','171208',1,0,'2022-03-03 13:29:37','2022-03-03 13:29:37'),(116892,390,'Solang','171206',1,0,'2022-03-03 13:29:37','2022-03-03 13:29:37'),(116893,390,'Summer Kot','171224',1,0,'2022-03-03 13:29:37','2022-03-03 13:29:37'),(116894,390,'Summerhill','171005',1,0,'2022-03-03 13:29:37','2022-03-03 13:29:37'),(116895,390,'Sungri','171224',1,0,'2022-03-03 13:29:37','2022-03-03 13:29:37'),(116896,390,'Sunni Bhajji','171301',1,0,'2022-03-03 13:29:37','2022-03-03 13:29:37'),(116897,390,'Tangnu','171208',1,0,'2022-03-03 13:29:37','2022-03-03 13:29:37'),(116898,390,'Tara Devi','171010',1,0,'2022-03-03 13:29:37','2022-03-03 13:29:37'),(116899,390,'Thachi','171103',1,0,'2022-03-03 13:29:37','2022-03-03 13:29:37'),(116900,390,'Thailla','171007',1,0,'2022-03-03 13:29:37','2022-03-03 13:29:37'),(116901,390,'Thana','171214',1,0,'2022-03-03 13:29:38','2022-03-03 13:29:38'),(116902,390,'Thangad','171210',1,0,'2022-03-03 13:29:38','2022-03-03 13:29:38'),(116903,390,'Tharoach','171210',1,0,'2022-03-03 13:29:38','2022-03-03 13:29:38'),(116904,390,'Tharola','171202',1,0,'2022-03-03 13:29:38','2022-03-03 13:29:38'),(116905,390,'Theog','171201',1,0,'2022-03-03 13:29:38','2022-03-03 13:29:38'),(116906,390,'Tikkar','171203',1,0,'2022-03-03 13:29:38','2022-03-03 13:29:38'),(116907,390,'Tikkari','171208',1,0,'2022-03-03 13:29:38','2022-03-03 13:29:38'),(116908,390,'Tikkri Neol','171210',1,0,'2022-03-03 13:29:38','2022-03-03 13:29:38'),(116909,390,'Tiyali','171209',1,0,'2022-03-03 13:29:38','2022-03-03 13:29:38'),(116910,390,'Todsa','171214',1,0,'2022-03-03 13:29:38','2022-03-03 13:29:38'),(116911,390,'Toon','171103',1,0,'2022-03-03 13:29:38','2022-03-03 13:29:38'),(116912,390,'Tooran','171216',1,0,'2022-03-03 13:29:38','2022-03-03 13:29:38'),(116913,390,'Totu','171011',1,0,'2022-03-03 13:29:38','2022-03-03 13:29:38'),(116914,390,'Dubloo','173217',1,0,'2022-03-03 13:29:38','2022-03-03 13:29:38'),(116915,390,'Janedghat','173217',1,0,'2022-03-03 13:29:38','2022-03-03 13:29:38'),(116916,390,'Peeran','173217',1,0,'2022-03-03 13:29:38','2022-03-03 13:29:38'),(116917,391,'Bharoli','171226',1,0,'2022-03-03 13:29:38','2022-03-03 13:29:38'),(116918,391,'Bhujjal','171226',1,0,'2022-03-03 13:29:38','2022-03-03 13:29:38'),(116919,391,'Deothi Manjghaon','171226',1,0,'2022-03-03 13:29:38','2022-03-03 13:29:38'),(116920,391,'Neripul','171226',1,0,'2022-03-03 13:29:38','2022-03-03 13:29:38'),(116921,391,'Andheri','173023',1,0,'2022-03-03 13:29:38','2022-03-03 13:29:38'),(116922,391,'Badol','173032',1,0,'2022-03-03 13:29:39','2022-03-03 13:29:39'),(116923,391,'Bagpashog','173024',1,0,'2022-03-03 13:29:39','2022-03-03 13:29:39'),(116924,391,'Bagthan','173001',1,0,'2022-03-03 13:29:39','2022-03-03 13:29:39'),(116925,391,'Bakras','173029',1,0,'2022-03-03 13:29:39','2022-03-03 13:29:39'),(116926,391,'BaliKoti ','173027',1,0,'2022-03-03 13:29:39','2022-03-03 13:29:39'),(116927,391,'Banahki Ser','173024',1,0,'2022-03-03 13:29:39','2022-03-03 13:29:39'),(116928,391,'Banaur','173025',1,0,'2022-03-03 13:29:39','2022-03-03 13:29:39'),(116929,391,'Banethi','173001',1,0,'2022-03-03 13:29:39','2022-03-03 13:29:39'),(116930,391,'BaragB.O','173023',1,0,'2022-03-03 13:29:39','2022-03-03 13:29:39'),(116931,391,'Baru Sahib','173101',1,0,'2022-03-03 13:29:39','2022-03-03 13:29:39'),(116932,391,'Bata Mandi','173025',1,0,'2022-03-03 13:29:39','2022-03-03 13:29:39'),(116933,391,'Bella','173027',1,0,'2022-03-03 13:29:39','2022-03-03 13:29:39'),(116934,391,'Bhagani','173025',1,0,'2022-03-03 13:29:39','2022-03-03 13:29:39'),(116935,391,'Bhajond','173023',1,0,'2022-03-03 13:29:39','2022-03-03 13:29:39'),(116936,391,'Bhalona','173032',1,0,'2022-03-03 13:29:39','2022-03-03 13:29:39'),(116937,391,'Bharog Baneri','173022',1,0,'2022-03-03 13:29:39','2022-03-03 13:29:39'),(116938,391,'Bhatgarh','173022',1,0,'2022-03-03 13:29:39','2022-03-03 13:29:39'),(116939,391,'Bhawai','173032',1,0,'2022-03-03 13:29:39','2022-03-03 13:29:39'),(116940,391,'Bhellon','173024',1,0,'2022-03-03 13:29:40','2022-03-03 13:29:40'),(116941,391,'Bhudhana','173025',1,0,'2022-03-03 13:29:40','2022-03-03 13:29:40'),(116942,391,'Bhuira','173101',1,0,'2022-03-03 13:29:40','2022-03-03 13:29:40'),(116943,391,'Bikram Bag','173001',1,0,'2022-03-03 13:29:40','2022-03-03 13:29:40'),(116944,391,'Birla','173022',1,0,'2022-03-03 13:29:40','2022-03-03 13:29:40'),(116945,391,'Bogdhar','173104',1,0,'2022-03-03 13:29:40','2022-03-03 13:29:40'),(116946,391,'Bramapapri','173030',1,0,'2022-03-03 13:29:40','2022-03-03 13:29:40'),(116947,391,'Chakli','173001',1,0,'2022-03-03 13:29:40','2022-03-03 13:29:40'),(116948,391,'Chalana','173001',1,0,'2022-03-03 13:29:40','2022-03-03 13:29:40'),(116949,391,'Charna','173032',1,0,'2022-03-03 13:29:40','2022-03-03 13:29:40'),(116950,391,'Chhachheti','173029',1,0,'2022-03-03 13:29:40','2022-03-03 13:29:40'),(116951,391,'Chhapang','173101',1,0,'2022-03-03 13:29:40','2022-03-03 13:29:40'),(116952,391,'Chhogtali','173101',1,0,'2022-03-03 13:29:40','2022-03-03 13:29:40'),(116953,391,'Chokar','173104',1,0,'2022-03-03 13:29:40','2022-03-03 13:29:40'),(116954,391,'Churwadhar','173101',1,0,'2022-03-03 13:29:40','2022-03-03 13:29:40'),(116955,391,'Court Road Nahan','173001',1,0,'2022-03-03 13:29:40','2022-03-03 13:29:40'),(116956,391,'Dadahu','173022',1,0,'2022-03-03 13:29:40','2022-03-03 13:29:40'),(116957,391,'Dahan','173101',1,0,'2022-03-03 13:29:40','2022-03-03 13:29:40'),(116958,391,'Danda Anj','173025',1,0,'2022-03-03 13:29:40','2022-03-03 13:29:40'),(116959,391,'Daro Devria','173024',1,0,'2022-03-03 13:29:40','2022-03-03 13:29:40'),(116960,391,'Devamanal','173104',1,0,'2022-03-03 13:29:40','2022-03-03 13:29:40'),(116961,391,'Devna','173104',1,0,'2022-03-03 13:29:41','2022-03-03 13:29:41'),(116962,391,'Dhangiar','173024',1,0,'2022-03-03 13:29:41','2022-03-03 13:29:41'),(116963,391,'Dhualakuan','173031',1,0,'2022-03-03 13:29:41','2022-03-03 13:29:41'),(116964,391,'Dimber','173101',1,0,'2022-03-03 13:29:41','2022-03-03 13:29:41'),(116965,391,'Dingar Kinner','173001',1,0,'2022-03-03 13:29:41','2022-03-03 13:29:41'),(116966,391,'Drabla','173223',1,0,'2022-03-03 13:29:41','2022-03-03 13:29:41'),(116967,391,'Dugana','173029',1,0,'2022-03-03 13:29:41','2022-03-03 13:29:41'),(116968,391,'Gagal Shikor','173001',1,0,'2022-03-03 13:29:41','2022-03-03 13:29:41'),(116969,391,'Gandhoori','173104',1,0,'2022-03-03 13:29:41','2022-03-03 13:29:41'),(116970,391,'Ganguwala Jamniwala','173025',1,0,'2022-03-03 13:29:41','2022-03-03 13:29:41'),(116971,391,'Gawali','173027',1,0,'2022-03-03 13:29:41','2022-03-03 13:29:41'),(116972,391,'Girinagar','173031',1,0,'2022-03-03 13:29:41','2022-03-03 13:29:41'),(116973,391,'Gorkhuwala','173025',1,0,'2022-03-03 13:29:41','2022-03-03 13:29:41'),(116974,391,'Habban','173101',1,0,'2022-03-03 13:29:41','2022-03-03 13:29:41'),(116975,391,'Hallan','173027',1,0,'2022-03-03 13:29:41','2022-03-03 13:29:41'),(116976,391,'Haripur Khol','173001',1,0,'2022-03-03 13:29:41','2022-03-03 13:29:41'),(116977,391,'Haripurdhar','173032',1,0,'2022-03-03 13:29:41','2022-03-03 13:29:41'),(116978,391,'Harlog','173029',1,0,'2022-03-03 13:29:41','2022-03-03 13:29:41'),(116979,391,'Jadol Taproli','173223',1,0,'2022-03-03 13:29:41','2022-03-03 13:29:41'),(116980,391,'Jamna','173029',1,0,'2022-03-03 13:29:41','2022-03-03 13:29:41'),(116981,391,'Jamta','173001',1,0,'2022-03-03 13:29:41','2022-03-03 13:29:41'),(116982,391,'Jamu','173022',1,0,'2022-03-03 13:29:41','2022-03-03 13:29:41'),(116983,391,'Janot','173024',1,0,'2022-03-03 13:29:41','2022-03-03 13:29:41'),(116984,391,'Jarag','173022',1,0,'2022-03-03 13:29:41','2022-03-03 13:29:41'),(116985,391,'Jarwa','173027',1,0,'2022-03-03 13:29:41','2022-03-03 13:29:41'),(116986,391,'Jehar','173024',1,0,'2022-03-03 13:29:42','2022-03-03 13:29:42'),(116987,391,'Jhakando','173027',1,0,'2022-03-03 13:29:42','2022-03-03 13:29:42'),(116988,391,'Kala Amb','173030',1,0,'2022-03-03 13:29:42','2022-03-03 13:29:42'),(116989,391,'Kamrau','173029',1,0,'2022-03-03 13:29:42','2022-03-03 13:29:42'),(116990,391,'Kando Bhatnaul','173027',1,0,'2022-03-03 13:29:42','2022-03-03 13:29:42'),(116991,391,'Kangta Failag','173022',1,0,'2022-03-03 13:29:42','2022-03-03 13:29:42'),(116992,391,'Kansar','173022',1,0,'2022-03-03 13:29:42','2022-03-03 13:29:42'),(116993,391,'Kantimashwa','173029',1,0,'2022-03-03 13:29:42','2022-03-03 13:29:42'),(116994,391,'Karganoo Sanora','173223',1,0,'2022-03-03 13:29:42','2022-03-03 13:29:42'),(116995,391,'Katcha Tank Nahan','173001',1,0,'2022-03-03 13:29:42','2022-03-03 13:29:42'),(116996,391,'Kathali Bharan','173101',1,0,'2022-03-03 13:29:42','2022-03-03 13:29:42'),(116997,391,'Kharkah','173027',1,0,'2022-03-03 13:29:42','2022-03-03 13:29:42'),(116998,391,'Khodri','173025',1,0,'2022-03-03 13:29:42','2022-03-03 13:29:42'),(116999,391,'Kiari Gundah','173029',1,0,'2022-03-03 13:29:42','2022-03-03 13:29:42'),(117000,391,'Kolar','173001',1,0,'2022-03-03 13:29:42','2022-03-03 13:29:42'),(117001,391,'Korag','173032',1,0,'2022-03-03 13:29:42','2022-03-03 13:29:42'),(117002,391,'Korga','173029',1,0,'2022-03-03 13:29:42','2022-03-03 13:29:42'),(117003,391,'Koti Utraon','173029',1,0,'2022-03-03 13:29:42','2022-03-03 13:29:42'),(117004,391,'Kotibhunch','173027',1,0,'2022-03-03 13:29:42','2022-03-03 13:29:42'),(117005,391,'Kotidhiman','173022',1,0,'2022-03-03 13:29:42','2022-03-03 13:29:42'),(117006,391,'Kotla Bangi','173223',1,0,'2022-03-03 13:29:42','2022-03-03 13:29:42'),(117007,391,'Kotla Molar','173001',1,0,'2022-03-03 13:29:43','2022-03-03 13:29:43'),(117008,391,'Kotla Panjola','173223',1,0,'2022-03-03 13:29:43','2022-03-03 13:29:43'),(117009,391,'Kotribyas','173021',1,0,'2022-03-03 13:29:43','2022-03-03 13:29:43'),(117010,391,'Kuffar Kiara','173104',1,0,'2022-03-03 13:29:43','2022-03-03 13:29:43'),(117011,391,'Kujji','173229',1,0,'2022-03-03 13:29:43','2022-03-03 13:29:43'),(117012,391,'Kw Bhood','173026',1,0,'2022-03-03 13:29:43','2022-03-03 13:29:43'),(117013,391,'Lanacheta','173104',1,0,'2022-03-03 13:29:43','2022-03-03 13:29:43'),(117014,391,'Lanapalar','173023',1,0,'2022-03-03 13:29:43','2022-03-03 13:29:43'),(117015,391,'Leonana','173223',1,0,'2022-03-03 13:29:43','2022-03-03 13:29:43'),(117016,391,'Loza','173027',1,0,'2022-03-03 13:29:43','2022-03-03 13:29:43'),(117017,391,'Mahipur','173001',1,0,'2022-03-03 13:29:43','2022-03-03 13:29:43'),(117018,391,'Majra (Sirmaur)','173021',1,0,'2022-03-03 13:29:43','2022-03-03 13:29:43'),(117019,391,'Malhoti','173024',1,0,'2022-03-03 13:29:43','2022-03-03 13:29:43'),(117020,391,'Manal','173027',1,0,'2022-03-03 13:29:43','2022-03-03 13:29:43'),(117021,391,'Mangarh','173024',1,0,'2022-03-03 13:29:43','2022-03-03 13:29:43'),(117022,391,'Manpur Devra','173025',1,0,'2022-03-03 13:29:43','2022-03-03 13:29:43'),(117023,391,'Matar','173001',1,0,'2022-03-03 13:29:43','2022-03-03 13:29:43'),(117024,391,'Mehandobag','173024',1,0,'2022-03-03 13:29:43','2022-03-03 13:29:43'),(117025,391,'Millah','173029',1,0,'2022-03-03 13:29:43','2022-03-03 13:29:43'),(117026,391,'Misserwala','173021',1,0,'2022-03-03 13:29:43','2022-03-03 13:29:43'),(117027,391,'Moginand','173030',1,0,'2022-03-03 13:29:43','2022-03-03 13:29:43'),(117028,391,'Nagheta','173025',1,0,'2022-03-03 13:29:43','2022-03-03 13:29:43'),(117029,391,'Nahan H.O','173001',1,0,'2022-03-03 13:29:43','2022-03-03 13:29:43'),(117030,391,'Naina Tikkar','173229',1,0,'2022-03-03 13:29:44','2022-03-03 13:29:44'),(117031,391,'Nainidhar','173027',1,0,'2022-03-03 13:29:44','2022-03-03 13:29:44'),(117032,391,'Narag','173024',1,0,'2022-03-03 13:29:44','2022-03-03 13:29:44'),(117033,391,'Nihalgarh','173025',1,0,'2022-03-03 13:29:44','2022-03-03 13:29:44'),(117034,391,'Nohra','173104',1,0,'2022-03-03 13:29:44','2022-03-03 13:29:44'),(117035,391,'Pabiana','173101',1,0,'2022-03-03 13:29:44','2022-03-03 13:29:44'),(117036,391,'Palion','173030',1,0,'2022-03-03 13:29:44','2022-03-03 13:29:44'),(117037,391,'Panar','173022',1,0,'2022-03-03 13:29:44','2022-03-03 13:29:44'),(117038,391,'Panjahal','173001',1,0,'2022-03-03 13:29:44','2022-03-03 13:29:44'),(117039,391,'Panog','173027',1,0,'2022-03-03 13:29:44','2022-03-03 13:29:44'),(117040,391,'Panwa','173229',1,0,'2022-03-03 13:29:44','2022-03-03 13:29:44'),(117041,391,'Paonta Sahib','173025',1,0,'2022-03-03 13:29:44','2022-03-03 13:29:44'),(117042,391,'Parara','173001',1,0,'2022-03-03 13:29:44','2022-03-03 13:29:44'),(117043,391,'Poka','173029',1,0,'2022-03-03 13:29:44','2022-03-03 13:29:44'),(117044,391,'Punner','173104',1,0,'2022-03-03 13:29:44','2022-03-03 13:29:44'),(117045,391,'Puruwala','173001',1,0,'2022-03-03 13:29:44','2022-03-03 13:29:44'),(117046,391,'Rajana','173023',1,0,'2022-03-03 13:29:44','2022-03-03 13:29:44'),(117047,391,'Rajban','173028',1,0,'2022-03-03 13:29:44','2022-03-03 13:29:44'),(117048,391,'Rajgarh (Siramur)','173101',1,0,'2022-03-03 13:29:44','2022-03-03 13:29:44'),(117049,391,'Rajpur','173025',1,0,'2022-03-03 13:29:44','2022-03-03 13:29:44'),(117050,391,'Ramadhaun','173001',1,0,'2022-03-03 13:29:44','2022-03-03 13:29:44'),(117051,391,'Redali','173023',1,0,'2022-03-03 13:29:44','2022-03-03 13:29:44'),(117052,391,'Rerughatti','173101',1,0,'2022-03-03 13:29:45','2022-03-03 13:29:45'),(117053,391,'Ronhat','173027',1,0,'2022-03-03 13:29:45','2022-03-03 13:29:45'),(117054,391,'Sainj','173023',1,0,'2022-03-03 13:29:45','2022-03-03 13:29:45'),(117055,391,'Sainwala','173030',1,0,'2022-03-03 13:29:45','2022-03-03 13:29:45'),(117056,391,'Sainwala Mubarakpur','173021',1,0,'2022-03-03 13:29:45','2022-03-03 13:29:45'),(117057,391,'Sangana','173032',1,0,'2022-03-03 13:29:45','2022-03-03 13:29:45'),(117058,391,'Sangrah','173023',1,0,'2022-03-03 13:29:45','2022-03-03 13:29:45'),(117059,391,'Sanio Didag','173101',1,0,'2022-03-03 13:29:45','2022-03-03 13:29:45'),(117060,391,'Sanora','173223',1,0,'2022-03-03 13:29:45','2022-03-03 13:29:45'),(117061,391,'Sarahan','173024',1,0,'2022-03-03 13:29:45','2022-03-03 13:29:45'),(117062,391,'Sarsoo','173024',1,0,'2022-03-03 13:29:45','2022-03-03 13:29:45'),(117063,391,'Sataun','173029',1,0,'2022-03-03 13:29:45','2022-03-03 13:29:45'),(117064,391,'Seon','173023',1,0,'2022-03-03 13:29:45','2022-03-03 13:29:45'),(117065,391,'Ser Jegas','173101',1,0,'2022-03-03 13:29:45','2022-03-03 13:29:45'),(117066,391,'Sertandula','173104',1,0,'2022-03-03 13:29:45','2022-03-03 13:29:45'),(117067,391,'Shambhuwala','173001',1,0,'2022-03-03 13:29:45','2022-03-03 13:29:45'),(117068,391,'Sharia','173024',1,0,'2022-03-03 13:29:45','2022-03-03 13:29:45'),(117069,391,'Sharlimanpur','173029',1,0,'2022-03-03 13:29:45','2022-03-03 13:29:45'),(117070,391,'Shawaga','173029',1,0,'2022-03-03 13:29:45','2022-03-03 13:29:45'),(117071,391,'Shaya Chabron','173101',1,0,'2022-03-03 13:29:45','2022-03-03 13:29:45'),(117072,391,'Shergaon','173223',1,0,'2022-03-03 13:29:45','2022-03-03 13:29:45'),(117073,391,'Shilla','173029',1,0,'2022-03-03 13:29:45','2022-03-03 13:29:45'),(117074,391,'Shillai','173027',1,0,'2022-03-03 13:29:46','2022-03-03 13:29:46'),(117075,391,'Shirikiari','173027',1,0,'2022-03-03 13:29:46','2022-03-03 13:29:46'),(117076,391,'SHIVA','173025',1,0,'2022-03-03 13:29:46','2022-03-03 13:29:46'),(117077,391,'Shivpur','173025',1,0,'2022-03-03 13:29:46','2022-03-03 13:29:46'),(117078,391,'Shivpur','173032',1,0,'2022-03-03 13:29:46','2022-03-03 13:29:46'),(117079,391,'Surla','173001',1,0,'2022-03-03 13:29:46','2022-03-03 13:29:46'),(117080,391,'Tatiana','173029',1,0,'2022-03-03 13:29:46','2022-03-03 13:29:46'),(117081,391,'Thakurdwara','173024',1,0,'2022-03-03 13:29:46','2022-03-03 13:29:46'),(117082,391,'Thana Kashoga','173022',1,0,'2022-03-03 13:29:46','2022-03-03 13:29:46'),(117083,391,'Thorniwar','173101',1,0,'2022-03-03 13:29:46','2022-03-03 13:29:46'),(117084,391,'Tikkari Kuthar','173024',1,0,'2022-03-03 13:29:46','2022-03-03 13:29:46'),(117085,391,'Timbi','173029',1,0,'2022-03-03 13:29:46','2022-03-03 13:29:46'),(117086,391,'Trilokpur','173030',1,0,'2022-03-03 13:29:46','2022-03-03 13:29:46'),(117087,391,'Udaina Kathwar','173022',1,0,'2022-03-03 13:29:46','2022-03-03 13:29:46'),(117088,391,'Upron','173024',1,0,'2022-03-03 13:29:46','2022-03-03 13:29:46'),(117089,391,'Wasni','173024',1,0,'2022-03-03 13:29:46','2022-03-03 13:29:46'),(117090,392,'Anji Brahamna','173234',1,0,'2022-03-03 13:29:46','2022-03-03 13:29:46'),(117091,392,'Arki','173208',1,0,'2022-03-03 13:29:46','2022-03-03 13:29:46'),(117092,392,'Baddal Goela','173206',1,0,'2022-03-03 13:29:46','2022-03-03 13:29:46'),(117093,392,'Baddi','173205',1,0,'2022-03-03 13:29:46','2022-03-03 13:29:46'),(117094,392,'Badhalag','173218',1,0,'2022-03-03 13:29:46','2022-03-03 13:29:46'),(117095,392,'Badhaunighat','173233',1,0,'2022-03-03 13:29:46','2022-03-03 13:29:46'),(117096,392,'Badhokhari','173218',1,0,'2022-03-03 13:29:46','2022-03-03 13:29:46'),(117097,392,'Baila','174102',1,0,'2022-03-03 13:29:47','2022-03-03 13:29:47'),(117098,392,'Bakhalag','173208',1,0,'2022-03-03 13:29:47','2022-03-03 13:29:47'),(117099,392,'Balera','173221',1,0,'2022-03-03 13:29:47','2022-03-03 13:29:47'),(117100,392,'Bandh Bhaguri','173233',1,0,'2022-03-03 13:29:47','2022-03-03 13:29:47'),(117101,392,'Barog R.S.B.O','173211',1,0,'2022-03-03 13:29:47','2022-03-03 13:29:47'),(117102,392,'Barotiwala','174103',1,0,'2022-03-03 13:29:47','2022-03-03 13:29:47'),(117103,392,'Baruna','174101',1,0,'2022-03-03 13:29:47','2022-03-03 13:29:47'),(117104,392,'Basal','173213',1,0,'2022-03-03 13:29:47','2022-03-03 13:29:47'),(117105,392,'Basha','173234',1,0,'2022-03-03 13:29:47','2022-03-03 13:29:47'),(117106,392,'Batal','173208',1,0,'2022-03-03 13:29:47','2022-03-03 13:29:47'),(117107,392,'Beral','171102',1,0,'2022-03-03 13:29:47','2022-03-03 13:29:47'),(117108,392,'Bhainch Kuftoo','173207',1,0,'2022-03-03 13:29:47','2022-03-03 13:29:47'),(117109,392,'Bhararighat','173235',1,0,'2022-03-03 13:29:47','2022-03-03 13:29:47'),(117110,392,'Bharti','173206',1,0,'2022-03-03 13:29:47','2022-03-03 13:29:47'),(117111,392,'Bhatian','174101',1,0,'2022-03-03 13:29:47','2022-03-03 13:29:47'),(117112,392,'Bhatoli Kalan','173205',1,0,'2022-03-03 13:29:47','2022-03-03 13:29:47'),(117113,392,'Bhiyunkhari','174102',1,0,'2022-03-03 13:29:47','2022-03-03 13:29:47'),(117114,392,'Bhogpur','174101',1,0,'2022-03-03 13:29:47','2022-03-03 13:29:47'),(117115,392,'Bhojnagar','173229',1,0,'2022-03-03 13:29:47','2022-03-03 13:29:47'),(117116,392,'Bhood','173205',1,0,'2022-03-03 13:29:47','2022-03-03 13:29:47'),(117117,392,'Bhumati','173221',1,0,'2022-03-03 13:29:47','2022-03-03 13:29:47'),(117118,392,'Bisha','173234',1,0,'2022-03-03 13:29:48','2022-03-03 13:29:48'),(117119,392,'Bohli','173229',1,0,'2022-03-03 13:29:48','2022-03-03 13:29:48'),(117120,392,'Brauri','173207',1,0,'2022-03-03 13:29:48','2022-03-03 13:29:48'),(117121,392,'Chail (Solan)','173217',1,0,'2022-03-03 13:29:48','2022-03-03 13:29:48'),(117122,392,'Chakhar Bughar','171102',1,0,'2022-03-03 13:29:48','2022-03-03 13:29:48'),(117123,392,'Chambaghat','173213',1,0,'2022-03-03 13:29:48','2022-03-03 13:29:48'),(117124,392,'Chamdar','174102',1,0,'2022-03-03 13:29:48','2022-03-03 13:29:48'),(117125,392,'Chandi','173206',1,0,'2022-03-03 13:29:48','2022-03-03 13:29:48'),(117126,392,'Chhausa','173234',1,0,'2022-03-03 13:29:48','2022-03-03 13:29:48'),(117127,392,'Chhiachi','174102',1,0,'2022-03-03 13:29:48','2022-03-03 13:29:48'),(117128,392,'Dabhota','174101',1,0,'2022-03-03 13:29:48','2022-03-03 13:29:48'),(117129,392,'Dagshai','173210',1,0,'2022-03-03 13:29:48','2022-03-03 13:29:48'),(117130,392,'Damkari','173212',1,0,'2022-03-03 13:29:48','2022-03-03 13:29:48'),(117131,392,'Dangheel','173217',1,0,'2022-03-03 13:29:48','2022-03-03 13:29:48'),(117132,392,'Danoghat','171102',1,0,'2022-03-03 13:29:48','2022-03-03 13:29:48'),(117133,392,'Darla','171102',1,0,'2022-03-03 13:29:48','2022-03-03 13:29:48'),(117134,392,'Darwa','173206',1,0,'2022-03-03 13:29:48','2022-03-03 13:29:48'),(117135,392,'Delgi','173206',1,0,'2022-03-03 13:29:48','2022-03-03 13:29:48'),(117136,392,'Deothi','173211',1,0,'2022-03-03 13:29:48','2022-03-03 13:29:48'),(117137,392,'Dhakriana','173206',1,0,'2022-03-03 13:29:48','2022-03-03 13:29:48'),(117138,392,'Dhar Ki Ber','173209',1,0,'2022-03-03 13:29:48','2022-03-03 13:29:48'),(117139,392,'Dharampur (Solan)','173209',1,0,'2022-03-03 13:29:48','2022-03-03 13:29:48'),(117140,392,'Dharmana','174102',1,0,'2022-03-03 13:29:49','2022-03-03 13:29:49'),(117141,392,'Dharot','173213',1,0,'2022-03-03 13:29:49','2022-03-03 13:29:49'),(117142,392,'DheolaB.O','173207',1,0,'2022-03-03 13:29:49','2022-03-03 13:29:49'),(117143,392,'Dhundan','173235',1,0,'2022-03-03 13:29:49','2022-03-03 13:29:49'),(117144,392,'Diggal','173218',1,0,'2022-03-03 13:29:49','2022-03-03 13:29:49'),(117145,392,'Doli','174102',1,0,'2022-03-03 13:29:49','2022-03-03 13:29:49'),(117146,392,'Domehar','173221',1,0,'2022-03-03 13:29:49','2022-03-03 13:29:49'),(117147,392,'Domeharbani','173234',1,0,'2022-03-03 13:29:49','2022-03-03 13:29:49'),(117148,392,'Ekhoo','173233',1,0,'2022-03-03 13:29:49','2022-03-03 13:29:49'),(117149,392,'Gaighat','173229',1,0,'2022-03-03 13:29:49','2022-03-03 13:29:49'),(117150,392,'Galanag','173212',1,0,'2022-03-03 13:29:49','2022-03-03 13:29:49'),(117151,392,'Galote','174101',1,0,'2022-03-03 13:29:49','2022-03-03 13:29:49'),(117152,392,'Ganagughat','171102',1,0,'2022-03-03 13:29:49','2022-03-03 13:29:49'),(117153,392,'Garkhal','173201',1,0,'2022-03-03 13:29:49','2022-03-03 13:29:49'),(117154,392,'Gaura','173212',1,0,'2022-03-03 13:29:49','2022-03-03 13:29:49'),(117155,392,'Gharsi','173206',1,0,'2022-03-03 13:29:49','2022-03-03 13:29:49'),(117156,392,'Ghatti','173211',1,0,'2022-03-03 13:29:49','2022-03-03 13:29:49'),(117157,392,'Goela Panner','174101',1,0,'2022-03-03 13:29:49','2022-03-03 13:29:49'),(117158,392,'Gunahkalan','174102',1,0,'2022-03-03 13:29:49','2022-03-03 13:29:49'),(117159,392,'Gurumajra','174101',1,0,'2022-03-03 13:29:49','2022-03-03 13:29:49'),(117160,392,'Hanuman Barog','173235',1,0,'2022-03-03 13:29:49','2022-03-03 13:29:49'),(117161,392,'Haripur','173206',1,0,'2022-03-03 13:29:49','2022-03-03 13:29:49'),(117162,392,'Haripur Sandoli','173205',1,0,'2022-03-03 13:29:50','2022-03-03 13:29:50'),(117163,392,'Hinner','173217',1,0,'2022-03-03 13:29:50','2022-03-03 13:29:50'),(117164,392,'Jabli','173209',1,0,'2022-03-03 13:29:50','2022-03-03 13:29:50'),(117165,392,'Jagjit Nagar','173225',1,0,'2022-03-03 13:29:50','2022-03-03 13:29:50'),(117166,392,'Jainagar','173221',1,0,'2022-03-03 13:29:50','2022-03-03 13:29:50'),(117167,392,'Jaunaji','173212',1,0,'2022-03-03 13:29:50','2022-03-03 13:29:50'),(117168,392,'Jhaja','173217',1,0,'2022-03-03 13:29:50','2022-03-03 13:29:50'),(117169,392,'Jhajra','174101',1,0,'2022-03-03 13:29:50','2022-03-03 13:29:50'),(117170,392,'Jobri','173221',1,0,'2022-03-03 13:29:50','2022-03-03 13:29:50'),(117171,392,'Joghon','174101',1,0,'2022-03-03 13:29:50','2022-03-03 13:29:50'),(117172,392,'Jubbar','173225',1,0,'2022-03-03 13:29:50','2022-03-03 13:29:50'),(117173,392,'Jubla','173207',1,0,'2022-03-03 13:29:50','2022-03-03 13:29:50'),(117174,392,'Kabakalan','173229',1,0,'2022-03-03 13:29:50','2022-03-03 13:29:50'),(117175,392,'Kahala','173207',1,0,'2022-03-03 13:29:50','2022-03-03 13:29:50'),(117176,392,'Kaithlighat','173234',1,0,'2022-03-03 13:29:50','2022-03-03 13:29:50'),(117177,392,'Kakkar Hatti','173206',1,0,'2022-03-03 13:29:50','2022-03-03 13:29:50'),(117178,392,'Kalibari','174101',1,0,'2022-03-03 13:29:50','2022-03-03 13:29:50'),(117179,392,'Kanda','173209',1,0,'2022-03-03 13:29:50','2022-03-03 13:29:50'),(117180,392,'Kandaghat','173215',1,0,'2022-03-03 13:29:50','2022-03-03 13:29:50'),(117181,392,'Karuana','173205',1,0,'2022-03-03 13:29:50','2022-03-03 13:29:50'),(117182,392,'KASAULI M T','173204',1,0,'2022-03-03 13:29:50','2022-03-03 13:29:50'),(117183,392,'Kasauli MT','173214',1,0,'2022-03-03 13:29:50','2022-03-03 13:29:50'),(117184,392,'Kasauli RI','173204',1,0,'2022-03-03 13:29:51','2022-03-03 13:29:51'),(117185,392,'Kasauli','173204',1,0,'2022-03-03 13:29:51','2022-03-03 13:29:51'),(117186,392,'Kashlog','171102',1,0,'2022-03-03 13:29:51','2022-03-03 13:29:51'),(117187,392,'Katal','173218',1,0,'2022-03-03 13:29:51','2022-03-03 13:29:51'),(117188,392,'Kawarag','173215',1,0,'2022-03-03 13:29:51','2022-03-03 13:29:51'),(117189,392,'Khararhatti','173207',1,0,'2022-03-03 13:29:51','2022-03-03 13:29:51'),(117190,392,'Khera','174101',1,0,'2022-03-03 13:29:51','2022-03-03 13:29:51'),(117191,392,'Khillian','174101',1,0,'2022-03-03 13:29:51','2022-03-03 13:29:51'),(117192,392,'Kiarighat','173234',1,0,'2022-03-03 13:29:51','2022-03-03 13:29:51'),(117193,392,'Kohu','174102',1,0,'2022-03-03 13:29:51','2022-03-03 13:29:51'),(117194,392,'Kot','173225',1,0,'2022-03-03 13:29:51','2022-03-03 13:29:51'),(117195,392,'Kot Beja','173233',1,0,'2022-03-03 13:29:51','2022-03-03 13:29:51'),(117196,392,'Koti','173207',1,0,'2022-03-03 13:29:51','2022-03-03 13:29:51'),(117197,392,'Kotla','173212',1,0,'2022-03-03 13:29:51','2022-03-03 13:29:51'),(117198,392,'Kumarhatti','173229',1,0,'2022-03-03 13:29:51','2022-03-03 13:29:51'),(117199,392,'Kundlu','174101',1,0,'2022-03-03 13:29:51','2022-03-03 13:29:51'),(117200,392,'Kunhar','173221',1,0,'2022-03-03 13:29:51','2022-03-03 13:29:51'),(117201,392,'Kunihar','173207',1,0,'2022-03-03 13:29:51','2022-03-03 13:29:51'),(117202,392,'Kuthar','173206',1,0,'2022-03-03 13:29:51','2022-03-03 13:29:51'),(117203,392,'Lagdaghat','174102',1,0,'2022-03-03 13:29:51','2022-03-03 13:29:51'),(117204,392,'Lodhimajra','174101',1,0,'2022-03-03 13:29:51','2022-03-03 13:29:51'),(117205,392,'Loharghat','174102',1,0,'2022-03-03 13:29:51','2022-03-03 13:29:51'),(117206,392,'Lunas','174102',1,0,'2022-03-03 13:29:51','2022-03-03 13:29:51'),(117207,392,'Maan','173218',1,0,'2022-03-03 13:29:51','2022-03-03 13:29:51'),(117208,392,'Malera','173206',1,0,'2022-03-03 13:29:52','2022-03-03 13:29:52'),(117209,392,'Mamlig','173222',1,0,'2022-03-03 13:29:52','2022-03-03 13:29:52'),(117210,392,'Mandhala','174103',1,0,'2022-03-03 13:29:52','2022-03-03 13:29:52'),(117211,392,'Mandodhar','173209',1,0,'2022-03-03 13:29:52','2022-03-03 13:29:52'),(117212,392,'Mangal','171102',1,0,'2022-03-03 13:29:52','2022-03-03 13:29:52'),(117213,392,'Mangoo','171102',1,0,'2022-03-03 13:29:52','2022-03-03 13:29:52'),(117214,392,'Manjholi','174101',1,0,'2022-03-03 13:29:52','2022-03-03 13:29:52'),(117215,392,'Manjhyat','173208',1,0,'2022-03-03 13:29:52','2022-03-03 13:29:52'),(117216,392,'Manjoo','173208',1,0,'2022-03-03 13:29:52','2022-03-03 13:29:52'),(117217,392,'Manlogkalan','173218',1,0,'2022-03-03 13:29:52','2022-03-03 13:29:52'),(117218,392,'Manpura','174101',1,0,'2022-03-03 13:29:52','2022-03-03 13:29:52'),(117219,392,'Masulkhana','173220',1,0,'2022-03-03 13:29:52','2022-03-03 13:29:52'),(117220,392,'Materani','173221',1,0,'2022-03-03 13:29:52','2022-03-03 13:29:52'),(117221,392,'Matuli','174102',1,0,'2022-03-03 13:29:52','2022-03-03 13:29:52'),(117222,392,'Mittian','174102',1,0,'2022-03-03 13:29:52','2022-03-03 13:29:52'),(117223,392,'Nagali','173217',1,0,'2022-03-03 13:29:52','2022-03-03 13:29:52'),(117224,392,'Nagaon','171102',1,0,'2022-03-03 13:29:52','2022-03-03 13:29:52'),(117225,392,'Nalagarh','174101',1,0,'2022-03-03 13:29:52','2022-03-03 13:29:52'),(117226,392,'Nand Karlata','174102',1,0,'2022-03-03 13:29:52','2022-03-03 13:29:52'),(117227,392,'Nangal','174101',1,0,'2022-03-03 13:29:52','2022-03-03 13:29:52'),(117228,392,'Nauni','173230',1,0,'2022-03-03 13:29:52','2022-03-03 13:29:52'),(117229,392,'Nayagram','173220',1,0,'2022-03-03 13:29:53','2022-03-03 13:29:53'),(117230,392,'Oachghat','173223',1,0,'2022-03-03 13:29:53','2022-03-03 13:29:53'),(117231,392,'Palania','173208',1,0,'2022-03-03 13:29:53','2022-03-03 13:29:53'),(117232,392,'Palog','173208',1,0,'2022-03-03 13:29:53','2022-03-03 13:29:53'),(117233,392,'Panjhera','174101',1,0,'2022-03-03 13:29:53','2022-03-03 13:29:53'),(117234,392,'Parnoo','171102',1,0,'2022-03-03 13:29:53','2022-03-03 13:29:53'),(117235,392,'Parwanoo','173220',1,0,'2022-03-03 13:29:53','2022-03-03 13:29:53'),(117236,392,'Patta','173233',1,0,'2022-03-03 13:29:53','2022-03-03 13:29:53'),(117237,392,'Piplughat','173235',1,0,'2022-03-03 13:29:53','2022-03-03 13:29:53'),(117238,392,'Plassaikalan','174101',1,0,'2022-03-03 13:29:53','2022-03-03 13:29:53'),(117239,392,'Pole Da Khala','174102',1,0,'2022-03-03 13:29:53','2022-03-03 13:29:53'),(117240,392,'Pratha','173220',1,0,'2022-03-03 13:29:53','2022-03-03 13:29:53'),(117241,392,'Rajpura','174101',1,0,'2022-03-03 13:29:53','2022-03-03 13:29:53'),(117242,392,'Rampur','173206',1,0,'2022-03-03 13:29:53','2022-03-03 13:29:53'),(117243,392,'Ramshahar','174102',1,0,'2022-03-03 13:29:53','2022-03-03 13:29:53'),(117244,392,'Ratwari','174101',1,0,'2022-03-03 13:29:53','2022-03-03 13:29:53'),(117245,392,'Reru','174101',1,0,'2022-03-03 13:29:53','2022-03-03 13:29:53'),(117246,392,'Rouri','173209',1,0,'2022-03-03 13:29:53','2022-03-03 13:29:53'),(117247,392,'RR Solan','173212',1,0,'2022-03-03 13:29:53','2022-03-03 13:29:53'),(117248,392,'Sadhupul','173215',1,0,'2022-03-03 13:29:54','2022-03-03 13:29:54'),(117249,392,'Sai','173205',1,0,'2022-03-03 13:29:54','2022-03-03 13:29:54'),(117250,392,'Salogra','173214',1,0,'2022-03-03 13:29:54','2022-03-03 13:29:54'),(117251,392,'Sanawar','173202',1,0,'2022-03-03 13:29:54','2022-03-03 13:29:54'),(117252,392,'Saproon','173211',1,0,'2022-03-03 13:29:54','2022-03-03 13:29:54'),(117253,392,'Saryanj','173235',1,0,'2022-03-03 13:29:54','2022-03-03 13:29:54'),(117254,392,'Saur','174102',1,0,'2022-03-03 13:29:54','2022-03-03 13:29:54'),(117255,392,'Sayri','173207',1,0,'2022-03-03 13:29:54','2022-03-03 13:29:54'),(117256,392,'Sector-2 Parwanoo','173220',1,0,'2022-03-03 13:29:54','2022-03-03 13:29:54'),(117257,392,'Sewra Chandi','171102',1,0,'2022-03-03 13:29:54','2022-03-03 13:29:54'),(117258,392,'Shalaghat','173208',1,0,'2022-03-03 13:29:54','2022-03-03 13:29:54'),(117259,392,'Shamti','173212',1,0,'2022-03-03 13:29:54','2022-03-03 13:29:54'),(117260,392,'Shardaghat','173207',1,0,'2022-03-03 13:29:54','2022-03-03 13:29:54'),(117261,392,'Shehrol','173221',1,0,'2022-03-03 13:29:54','2022-03-03 13:29:54'),(117262,392,'Solan Brewery','173214',1,0,'2022-03-03 13:29:54','2022-03-03 13:29:54'),(117263,392,'Solan H.O','173212',1,0,'2022-03-03 13:29:54','2022-03-03 13:29:54'),(117264,392,'Subathu','173206',1,0,'2022-03-03 13:29:54','2022-03-03 13:29:54'),(117265,392,'Sujhaila','173208',1,0,'2022-03-03 13:29:54','2022-03-03 13:29:54'),(117266,392,'Sultanpur','173229',1,0,'2022-03-03 13:29:54','2022-03-03 13:29:54'),(117267,392,'Surajpur','174103',1,0,'2022-03-03 13:29:54','2022-03-03 13:29:54'),(117268,392,'Taksal','173220',1,0,'2022-03-03 13:29:54','2022-03-03 13:29:54'),(117269,392,'Thana','173205',1,0,'2022-03-03 13:29:55','2022-03-03 13:29:55'),(117270,392,'Tikker','173217',1,0,'2022-03-03 13:29:55','2022-03-03 13:29:55'),(117271,392,'Tundal','173215',1,0,'2022-03-03 13:29:55','2022-03-03 13:29:55'),(117272,392,'Waknaghat','173234',1,0,'2022-03-03 13:29:55','2022-03-03 13:29:55'),(117273,393,'Ghaloon','177041',1,0,'2022-03-03 13:29:55','2022-03-03 13:29:55'),(117274,393,'Ajauli','174301',1,0,'2022-03-03 13:29:55','2022-03-03 13:29:55'),(117275,393,'Amb','177203',1,0,'2022-03-03 13:29:55','2022-03-03 13:29:55'),(117276,393,'Ambehra Dhiraj','174314',1,0,'2022-03-03 13:29:55','2022-03-03 13:29:55'),(117277,393,'Amboa','177204',1,0,'2022-03-03 13:29:55','2022-03-03 13:29:55'),(117278,393,'Ambota','177205',1,0,'2022-03-03 13:29:55','2022-03-03 13:29:55'),(117279,393,'Andora','177203',1,0,'2022-03-03 13:29:55','2022-03-03 13:29:55'),(117280,393,'Arlu','174307',1,0,'2022-03-03 13:29:55','2022-03-03 13:29:55'),(117281,393,'Arn Behal','177109',1,0,'2022-03-03 13:29:55','2022-03-03 13:29:55'),(117282,393,'Babehar','177204',1,0,'2022-03-03 13:29:55','2022-03-03 13:29:55'),(117283,393,'Badehar','174306',1,0,'2022-03-03 13:29:55','2022-03-03 13:29:55'),(117284,393,'Badhera','177209',1,0,'2022-03-03 13:29:55','2022-03-03 13:29:55'),(117285,393,'Badoh','177201',1,0,'2022-03-03 13:29:55','2022-03-03 13:29:55'),(117286,393,'Badoli','174302',1,0,'2022-03-03 13:29:55','2022-03-03 13:29:55'),(117287,393,'Badsala','174303',1,0,'2022-03-03 13:29:55','2022-03-03 13:29:55'),(117288,393,'Balh','174321',1,0,'2022-03-03 13:29:55','2022-03-03 13:29:55'),(117289,393,'Baliwal','177220',1,0,'2022-03-03 13:29:55','2022-03-03 13:29:55'),(117290,393,'Bangana','174307',1,0,'2022-03-03 13:29:56','2022-03-03 13:29:56'),(117291,393,'Barnoh','174303',1,0,'2022-03-03 13:29:56','2022-03-03 13:29:56'),(117292,393,'Basal','174303',1,0,'2022-03-03 13:29:56','2022-03-03 13:29:56'),(117293,393,'Basoli','174303',1,0,'2022-03-03 13:29:56','2022-03-03 13:29:56'),(117294,393,'Bathri','174301',1,0,'2022-03-03 13:29:56','2022-03-03 13:29:56'),(117295,393,'Bathu','174301',1,0,'2022-03-03 13:29:56','2022-03-03 13:29:56'),(117296,393,'Batuhi','174302',1,0,'2022-03-03 13:29:56','2022-03-03 13:29:56'),(117297,393,'Beetan','176601',1,0,'2022-03-03 13:29:56','2022-03-03 13:29:56'),(117298,393,'Behdala','174306',1,0,'2022-03-03 13:29:56','2022-03-03 13:29:56'),(117299,393,'Bhadarkali','177204',1,0,'2022-03-03 13:29:56','2022-03-03 13:29:56'),(117300,393,'Bhadauri','177220',1,0,'2022-03-03 13:29:56','2022-03-03 13:29:56'),(117301,393,'Bhadsali','174317',1,0,'2022-03-03 13:29:56','2022-03-03 13:29:56'),(117302,393,'Bhadwar','174321',1,0,'2022-03-03 13:29:56','2022-03-03 13:29:56'),(117303,393,'Bhalaun','174314',1,0,'2022-03-03 13:29:56','2022-03-03 13:29:56'),(117304,393,'Bhanjal','177213',1,0,'2022-03-03 13:29:56','2022-03-03 13:29:56'),(117305,393,'Bharwain','177109',1,0,'2022-03-03 13:29:56','2022-03-03 13:29:56'),(117306,393,'Bhater','177110',1,0,'2022-03-03 13:29:56','2022-03-03 13:29:56'),(117307,393,'Bhatoli','174315',1,0,'2022-03-03 13:29:56','2022-03-03 13:29:56'),(117308,393,'Bhera','174316',1,0,'2022-03-03 13:29:56','2022-03-03 13:29:56'),(117309,393,'Bhindla','177039',1,0,'2022-03-03 13:29:56','2022-03-03 13:29:56'),(117310,393,'Biderwal','176601',1,0,'2022-03-03 13:29:57','2022-03-03 13:29:57'),(117311,393,'Budhan','174308',1,0,'2022-03-03 13:29:57','2022-03-03 13:29:57'),(117312,393,'Chaksarai','177210',1,0,'2022-03-03 13:29:57','2022-03-03 13:29:57'),(117313,393,'Chalet','177204',1,0,'2022-03-03 13:29:57','2022-03-03 13:29:57'),(117314,393,'Chalola','174303',1,0,'2022-03-03 13:29:57','2022-03-03 13:29:57'),(117315,393,'Chamiari','174308',1,0,'2022-03-03 13:29:57','2022-03-03 13:29:57'),(117316,393,'Charara','174307',1,0,'2022-03-03 13:29:57','2022-03-03 13:29:57'),(117317,393,'Charatghar','174315',1,0,'2022-03-03 13:29:57','2022-03-03 13:29:57'),(117318,393,'Chatara','174306',1,0,'2022-03-03 13:29:57','2022-03-03 13:29:57'),(117319,393,'Chhaproh','174321',1,0,'2022-03-03 13:29:57','2022-03-03 13:29:57'),(117320,393,'Chhatarpur','174301',1,0,'2022-03-03 13:29:57','2022-03-03 13:29:57'),(117321,393,'Chintpurni','177110',1,0,'2022-03-03 13:29:57','2022-03-03 13:29:57'),(117322,393,'Chowar','177203',1,0,'2022-03-03 13:29:57','2022-03-03 13:29:57'),(117323,393,'Chowki Maniar','174314',1,0,'2022-03-03 13:29:57','2022-03-03 13:29:57'),(117324,393,'Chulhari','177031',1,0,'2022-03-03 13:29:57','2022-03-03 13:29:57'),(117325,393,'Churru','177211',1,0,'2022-03-03 13:29:57','2022-03-03 13:29:57'),(117326,393,'Daloh','177203',1,0,'2022-03-03 13:29:57','2022-03-03 13:29:57'),(117327,393,'Dangohkalan','177204',1,0,'2022-03-03 13:29:57','2022-03-03 13:29:57'),(117328,393,'Dangoli','174303',1,0,'2022-03-03 13:29:57','2022-03-03 13:29:57'),(117329,393,'Dathwara','174303',1,0,'2022-03-03 13:29:57','2022-03-03 13:29:57'),(117330,393,'Daulatpurchowk','177204',1,0,'2022-03-03 13:29:57','2022-03-03 13:29:57'),(117331,393,'Dehlan','174306',1,0,'2022-03-03 13:29:58','2022-03-03 13:29:58'),(117332,393,'Deoli','177212',1,0,'2022-03-03 13:29:58','2022-03-03 13:29:58'),(117333,393,'Dera Baba Rudra Nand','174303',1,0,'2022-03-03 13:29:58','2022-03-03 13:29:58'),(117334,393,'Dhalwari','177110',1,0,'2022-03-03 13:29:58','2022-03-03 13:29:58'),(117335,393,'Dhamandri','174303',1,0,'2022-03-03 13:29:58','2022-03-03 13:29:58'),(117336,393,'Dharampur','177220',1,0,'2022-03-03 13:29:58','2022-03-03 13:29:58'),(117337,393,'Dharamsal','177110',1,0,'2022-03-03 13:29:58','2022-03-03 13:29:58'),(117338,393,'Dhundla','174308',1,0,'2022-03-03 13:29:58','2022-03-03 13:29:58'),(117339,393,'Dhussara','174302',1,0,'2022-03-03 13:29:58','2022-03-03 13:29:58'),(117340,393,'Diara','174316',1,0,'2022-03-03 13:29:58','2022-03-03 13:29:58'),(117341,393,'Distt.Court Una','174303',1,0,'2022-03-03 13:29:58','2022-03-03 13:29:58'),(117342,393,'Dohgi Upperli','174307',1,0,'2022-03-03 13:29:58','2022-03-03 13:29:58'),(117343,393,'Dulehar','176601',1,0,'2022-03-03 13:29:58','2022-03-03 13:29:58'),(117344,393,'Gagret','177201',1,0,'2022-03-03 13:29:58','2022-03-03 13:29:58'),(117345,393,'Ganu','174319',1,0,'2022-03-03 13:29:58','2022-03-03 13:29:58'),(117346,393,'Ghanari','177212',1,0,'2022-03-03 13:29:58','2022-03-03 13:29:58'),(117347,393,'Ghangret','177110',1,0,'2022-03-03 13:29:58','2022-03-03 13:29:58'),(117348,393,'Gindpur','177110',1,0,'2022-03-03 13:29:58','2022-03-03 13:29:58'),(117349,393,'Gondpur Banera','177213',1,0,'2022-03-03 13:29:58','2022-03-03 13:29:58'),(117350,393,'Gondpurbulla','176601',1,0,'2022-03-03 13:29:58','2022-03-03 13:29:58'),(117351,393,'Gondpurjaichand','176601',1,0,'2022-03-03 13:29:59','2022-03-03 13:29:59'),(117352,393,'Guglehar','177208',1,0,'2022-03-03 13:29:59','2022-03-03 13:29:59'),(117353,393,'Hamboli','174316',1,0,'2022-03-03 13:29:59','2022-03-03 13:29:59'),(117354,393,'Haroli','177220',1,0,'2022-03-03 13:29:59','2022-03-03 13:29:59'),(117355,393,'Harot','174307',1,0,'2022-03-03 13:29:59','2022-03-03 13:29:59'),(117356,393,'Hatli','174307',1,0,'2022-03-03 13:29:59','2022-03-03 13:29:59'),(117357,393,'Hiran','176601',1,0,'2022-03-03 13:29:59','2022-03-03 13:29:59'),(117358,393,'Ispur','177207',1,0,'2022-03-03 13:29:59','2022-03-03 13:29:59'),(117359,393,'Jadla','177208',1,0,'2022-03-03 13:29:59','2022-03-03 13:29:59'),(117360,393,'Jajjar','177109',1,0,'2022-03-03 13:29:59','2022-03-03 13:29:59'),(117361,393,'Jakhera','174315',1,0,'2022-03-03 13:29:59','2022-03-03 13:29:59'),(117362,393,'Jankaur','174303',1,0,'2022-03-03 13:29:59','2022-03-03 13:29:59'),(117363,393,'Jassana','174307',1,0,'2022-03-03 13:29:59','2022-03-03 13:29:59'),(117364,393,'Jatehri','174307',1,0,'2022-03-03 13:29:59','2022-03-03 13:29:59'),(117365,393,'Jawal','177110',1,0,'2022-03-03 13:29:59','2022-03-03 13:29:59'),(117366,393,'Jawar','177210',1,0,'2022-03-03 13:29:59','2022-03-03 13:29:59'),(117367,393,'Jhamber','174303',1,0,'2022-03-03 13:29:59','2022-03-03 13:29:59'),(117368,393,'Joh','177204',1,0,'2022-03-03 13:29:59','2022-03-03 13:29:59'),(117369,393,'Kadh','177213',1,0,'2022-03-03 13:29:59','2022-03-03 13:29:59'),(117370,393,'Kaloh','177201',1,0,'2022-03-03 13:29:59','2022-03-03 13:29:59'),(117371,393,'Kalruhi','177203',1,0,'2022-03-03 13:30:00','2022-03-03 13:30:00'),(117372,393,'Kanger','177209',1,0,'2022-03-03 13:30:00','2022-03-03 13:30:00'),(117373,393,'Katauhar Kalan','177211',1,0,'2022-03-03 13:30:00','2022-03-03 13:30:00'),(117374,393,'Kataur Khurd','177203',1,0,'2022-03-03 13:30:00','2022-03-03 13:30:00'),(117375,393,'Kathiari','177211',1,0,'2022-03-03 13:30:00','2022-03-03 13:30:00'),(117376,393,'Khad','177207',1,0,'2022-03-03 13:30:00','2022-03-03 13:30:00'),(117377,393,'Khanpur','174301',1,0,'2022-03-03 13:30:00','2022-03-03 13:30:00'),(117378,393,'Khurwain','174321',1,0,'2022-03-03 13:30:00','2022-03-03 13:30:00'),(117379,393,'Kinoo','177109',1,0,'2022-03-03 13:30:00','2022-03-03 13:30:00'),(117380,393,'Kohdra','174308',1,0,'2022-03-03 13:30:00','2022-03-03 13:30:00'),(117381,393,'Kotla Kalan','174303',1,0,'2022-03-03 13:30:00','2022-03-03 13:30:00'),(117382,393,'Kotla Khurd','174303',1,0,'2022-03-03 13:30:00','2022-03-03 13:30:00'),(117383,393,'Kuneran','177219',1,0,'2022-03-03 13:30:00','2022-03-03 13:30:00'),(117384,393,'Kungrat','176601',1,0,'2022-03-03 13:30:00','2022-03-03 13:30:00'),(117385,393,'Kuriala','174303',1,0,'2022-03-03 13:30:00','2022-03-03 13:30:00'),(117386,393,'Kuthar Beet','174503',1,0,'2022-03-03 13:30:00','2022-03-03 13:30:00'),(117387,393,'Kuthera Jaswalan','177206',1,0,'2022-03-03 13:30:00','2022-03-03 13:30:00'),(117388,393,'Kuthera Kherla','177203',1,0,'2022-03-03 13:30:00','2022-03-03 13:30:00'),(117389,393,'Lalri','174301',1,0,'2022-03-03 13:30:00','2022-03-03 13:30:00'),(117390,393,'Lamlehri','174303',1,0,'2022-03-03 13:30:00','2022-03-03 13:30:00'),(117391,393,'Lathiani','174308',1,0,'2022-03-03 13:30:01','2022-03-03 13:30:01'),(117392,393,'Lohara','177109',1,0,'2022-03-03 13:30:01','2022-03-03 13:30:01'),(117393,393,'Loharli','177208',1,0,'2022-03-03 13:30:01','2022-03-03 13:30:01'),(117394,393,'Mairi','177210',1,0,'2022-03-03 13:30:01','2022-03-03 13:30:01'),(117395,393,'Makrer','174321',1,0,'2022-03-03 13:30:01','2022-03-03 13:30:01'),(117396,393,'Malangar','174308',1,0,'2022-03-03 13:30:01','2022-03-03 13:30:01'),(117397,393,'Mandli','174321',1,0,'2022-03-03 13:30:01','2022-03-03 13:30:01'),(117398,393,'Marwari','174319',1,0,'2022-03-03 13:30:01','2022-03-03 13:30:01'),(117399,393,'Mawa Kaholan','177204',1,0,'2022-03-03 13:30:01','2022-03-03 13:30:01'),(117400,393,'Mawa Sindhian','177206',1,0,'2022-03-03 13:30:01','2022-03-03 13:30:01'),(117401,393,'Mehatpur (Una)','174315',1,0,'2022-03-03 13:30:01','2022-03-03 13:30:01'),(117402,393,'Mubarikpur','177202',1,0,'2022-03-03 13:30:01','2022-03-03 13:30:01'),(117403,393,'Nagnoli','177208',1,0,'2022-03-03 13:30:01','2022-03-03 13:30:01'),(117404,393,'Nakroh','177213',1,0,'2022-03-03 13:30:01','2022-03-03 13:30:01'),(117405,393,'Nandpur','177211',1,0,'2022-03-03 13:30:01','2022-03-03 13:30:01'),(117406,393,'Nangal Jarialan','177212',1,0,'2022-03-03 13:30:01','2022-03-03 13:30:01'),(117407,393,'Nangal Kalan','174301',1,0,'2022-03-03 13:30:01','2022-03-03 13:30:01'),(117408,393,'Nangal Khurd','174301',1,0,'2022-03-03 13:30:01','2022-03-03 13:30:01'),(117409,393,'Nangal Salangri','174303',1,0,'2022-03-03 13:30:01','2022-03-03 13:30:01'),(117410,393,'Nangran','174315',1,0,'2022-03-03 13:30:01','2022-03-03 13:30:01'),(117411,393,'Nari','177110',1,0,'2022-03-03 13:30:01','2022-03-03 13:30:01'),(117412,393,'Nari Devi Singh','174307',1,0,'2022-03-03 13:30:01','2022-03-03 13:30:01'),(117413,393,'Nehri Nauranga','177210',1,0,'2022-03-03 13:30:01','2022-03-03 13:30:01'),(117414,393,'Oel (Una)','177206',1,0,'2022-03-03 13:30:02','2022-03-03 13:30:02'),(117415,393,'Palakwah','177220',1,0,'2022-03-03 13:30:02','2022-03-03 13:30:02'),(117416,393,'Paloh','177039',1,0,'2022-03-03 13:30:02','2022-03-03 13:30:02'),(117417,393,'Pandogha','177207',1,0,'2022-03-03 13:30:02','2022-03-03 13:30:02'),(117418,393,'Panjawar','177208',1,0,'2022-03-03 13:30:02','2022-03-03 13:30:02'),(117419,393,'Panjoa Ladoli','177211',1,0,'2022-03-03 13:30:02','2022-03-03 13:30:02'),(117420,393,'Panoh','174303',1,0,'2022-03-03 13:30:02','2022-03-03 13:30:02'),(117421,393,'Paroian','174321',1,0,'2022-03-03 13:30:02','2022-03-03 13:30:02'),(117422,393,'Pirthipur','177204',1,0,'2022-03-03 13:30:02','2022-03-03 13:30:02'),(117423,393,'Polian Beet','174503',1,0,'2022-03-03 13:30:02','2022-03-03 13:30:02'),(117424,393,'Polian Purohitan','177210',1,0,'2022-03-03 13:30:02','2022-03-03 13:30:02'),(117425,393,'Pubowal','174503',1,0,'2022-03-03 13:30:02','2022-03-03 13:30:02'),(117426,393,'Rainsary','174303',1,0,'2022-03-03 13:30:02','2022-03-03 13:30:02'),(117427,393,'Raipur (Una)','177031',1,0,'2022-03-03 13:30:02','2022-03-03 13:30:02'),(117428,393,'Raipur Sahoran','174315',1,0,'2022-03-03 13:30:02','2022-03-03 13:30:02'),(117429,393,'Rajpur Jaswan','177210',1,0,'2022-03-03 13:30:02','2022-03-03 13:30:02'),(117430,393,'Rakkar Colony','174303',1,0,'2022-03-03 13:30:02','2022-03-03 13:30:02'),(117431,393,'Ripoh Misran','177210',1,0,'2022-03-03 13:30:02','2022-03-03 13:30:02'),(117432,393,'Sagnai','177212',1,0,'2022-03-03 13:30:02','2022-03-03 13:30:02'),(117433,393,'Sainsowal','177220',1,0,'2022-03-03 13:30:02','2022-03-03 13:30:02'),(117434,393,'Saloh Beri','174319',1,0,'2022-03-03 13:30:03','2022-03-03 13:30:03'),(117435,393,'Saloh','177209',1,0,'2022-03-03 13:30:03','2022-03-03 13:30:03'),(117436,393,'Saloi','177203',1,0,'2022-03-03 13:30:03','2022-03-03 13:30:03'),(117437,393,'Samoor Kalan','174303',1,0,'2022-03-03 13:30:03','2022-03-03 13:30:03'),(117438,393,'Sanouli','174301',1,0,'2022-03-03 13:30:03','2022-03-03 13:30:03'),(117439,393,'Santokhgarh','174301',1,0,'2022-03-03 13:30:03','2022-03-03 13:30:03'),(117440,393,'Sapauri','177210',1,0,'2022-03-03 13:30:03','2022-03-03 13:30:03'),(117441,393,'Satother','174302',1,0,'2022-03-03 13:30:03','2022-03-03 13:30:03'),(117442,393,'Singan','176601',1,0,'2022-03-03 13:30:03','2022-03-03 13:30:03'),(117443,393,'Sohari','177039',1,0,'2022-03-03 13:30:03','2022-03-03 13:30:03'),(117444,393,'Suhin','177109',1,0,'2022-03-03 13:30:03','2022-03-03 13:30:03'),(117445,393,'Sunkali','177219',1,0,'2022-03-03 13:30:03','2022-03-03 13:30:03'),(117446,393,'Suri','177210',1,0,'2022-03-03 13:30:03','2022-03-03 13:30:03'),(117447,393,'Tabba Behdala','174306',1,0,'2022-03-03 13:30:03','2022-03-03 13:30:03'),(117448,393,'Tahliwal','174507',1,0,'2022-03-03 13:30:03','2022-03-03 13:30:03'),(117449,393,'Takarala','177211',1,0,'2022-03-03 13:30:03','2022-03-03 13:30:03'),(117450,393,'Takka','174303',1,0,'2022-03-03 13:30:03','2022-03-03 13:30:03'),(117451,393,'Talmehra','174320',1,0,'2022-03-03 13:30:03','2022-03-03 13:30:03'),(117452,393,'Tanoh','174308',1,0,'2022-03-03 13:30:03','2022-03-03 13:30:03'),(117453,393,'Teuri','174303',1,0,'2022-03-03 13:30:03','2022-03-03 13:30:03'),(117454,393,'Thanakalan','174321',1,0,'2022-03-03 13:30:03','2022-03-03 13:30:03'),(117455,393,'Thathal','177211',1,0,'2022-03-03 13:30:04','2022-03-03 13:30:04'),(117456,393,'Thathoon','174307',1,0,'2022-03-03 13:30:04','2022-03-03 13:30:04'),(117457,393,'Una H.O','174303',1,0,'2022-03-03 13:30:04','2022-03-03 13:30:04'),(117458,394,'Achabal','192201',1,0,'2022-03-03 13:30:04','2022-03-03 13:30:04'),(117459,394,'Achan','192305',1,0,'2022-03-03 13:30:04','2022-03-03 13:30:04'),(117460,394,'Ahalangodol','192202',1,0,'2022-03-03 13:30:04','2022-03-03 13:30:04'),(117461,394,'Aharbal','193303',1,0,'2022-03-03 13:30:04','2022-03-03 13:30:04'),(117462,394,'Ahmedabad','193303',1,0,'2022-03-03 13:30:04','2022-03-03 13:30:04'),(117463,394,'Akhal','192231',1,0,'2022-03-03 13:30:04','2022-03-03 13:30:04'),(117464,394,'Akingam','192201',1,0,'2022-03-03 13:30:04','2022-03-03 13:30:04'),(117465,394,'Akura','192125',1,0,'2022-03-03 13:30:04','2022-03-03 13:30:04'),(117466,394,'Anantnag City','192122',1,0,'2022-03-03 13:30:04','2022-03-03 13:30:04'),(117467,394,'Anantnag H.O','192101',1,0,'2022-03-03 13:30:04','2022-03-03 13:30:04'),(117468,394,'Arrah','192231',1,0,'2022-03-03 13:30:04','2022-03-03 13:30:04'),(117469,394,'Arwani','192124',1,0,'2022-03-03 13:30:04','2022-03-03 13:30:04'),(117470,394,'Ashmuji','192231',1,0,'2022-03-03 13:30:04','2022-03-03 13:30:04'),(117471,394,'Awenura','192232',1,0,'2022-03-03 13:30:04','2022-03-03 13:30:04'),(117472,394,'Barsoo','192122',1,0,'2022-03-03 13:30:04','2022-03-03 13:30:04'),(117473,394,'Beerwara','192401',1,0,'2022-03-03 13:30:04','2022-03-03 13:30:04'),(117474,394,'Behibagh','192232',1,0,'2022-03-03 13:30:04','2022-03-03 13:30:04'),(117475,394,'Bijbehara','192124',1,0,'2022-03-03 13:30:04','2022-03-03 13:30:04'),(117476,394,'Bonagand','192212',1,0,'2022-03-03 13:30:04','2022-03-03 13:30:04'),(117477,394,'Brah','192201',1,0,'2022-03-03 13:30:04','2022-03-03 13:30:04'),(117478,394,'Brinal Lamar','192101',1,0,'2022-03-03 13:30:05','2022-03-03 13:30:05'),(117479,394,'Brinal Lammer','192221',1,0,'2022-03-03 13:30:05','2022-03-03 13:30:05'),(117480,394,'Buchoo','192202',1,0,'2022-03-03 13:30:05','2022-03-03 13:30:05'),(117481,394,'Buchroo','192231',1,0,'2022-03-03 13:30:05','2022-03-03 13:30:05'),(117482,394,'Bugam','192232',1,0,'2022-03-03 13:30:05','2022-03-03 13:30:05'),(117483,394,'Bulbul Nowgam','192201',1,0,'2022-03-03 13:30:05','2022-03-03 13:30:05'),(117484,394,'Bumthan','192221',1,0,'2022-03-03 13:30:05','2022-03-03 13:30:05'),(117485,394,'Bumthan','192101',1,0,'2022-03-03 13:30:05','2022-03-03 13:30:05'),(117486,394,'Chadder','192231',1,0,'2022-03-03 13:30:05','2022-03-03 13:30:05'),(117487,394,'Chakilpora','192201',1,0,'2022-03-03 13:30:05','2022-03-03 13:30:05'),(117488,394,'Chakura','192305',1,0,'2022-03-03 13:30:05','2022-03-03 13:30:05'),(117489,394,'Chambgund','192231',1,0,'2022-03-03 13:30:05','2022-03-03 13:30:05'),(117490,394,'Chanderwadi (Sessional)','192230',1,0,'2022-03-03 13:30:05','2022-03-03 13:30:05'),(117491,394,'Chandhara','192122',1,0,'2022-03-03 13:30:05','2022-03-03 13:30:05'),(117492,394,'Chattargui','192201',1,0,'2022-03-03 13:30:05','2022-03-03 13:30:05'),(117493,394,'Cheersoo','192122',1,0,'2022-03-03 13:30:05','2022-03-03 13:30:05'),(117494,394,'Chimar','193303',1,0,'2022-03-03 13:30:05','2022-03-03 13:30:05'),(117495,394,'Chitragam','192124',1,0,'2022-03-03 13:30:05','2022-03-03 13:30:05'),(117496,394,'Chowgam','192101',1,0,'2022-03-03 13:30:05','2022-03-03 13:30:05'),(117497,394,'Chowgam','192221',1,0,'2022-03-03 13:30:05','2022-03-03 13:30:05'),(117498,394,'D.H Pora','193303',1,0,'2022-03-03 13:30:05','2022-03-03 13:30:05'),(117499,394,'D.K Marg','193303',1,0,'2022-03-03 13:30:05','2022-03-03 13:30:05'),(117500,394,'Daksum','192202',1,0,'2022-03-03 13:30:06','2022-03-03 13:30:06'),(117501,394,'Dalseer','192401',1,0,'2022-03-03 13:30:06','2022-03-03 13:30:06'),(117502,394,'Danipora','192202',1,0,'2022-03-03 13:30:06','2022-03-03 13:30:06'),(117503,394,'Demidulla','192232',1,0,'2022-03-03 13:30:06','2022-03-03 13:30:06'),(117504,394,'Dethunagnarian','192201',1,0,'2022-03-03 13:30:06','2022-03-03 13:30:06'),(117505,394,'Devsar','192231',1,0,'2022-03-03 13:30:06','2022-03-03 13:30:06'),(117506,394,'Dhane Bougund','192231',1,0,'2022-03-03 13:30:06','2022-03-03 13:30:06'),(117507,394,'Dhawtoo','192401',1,0,'2022-03-03 13:30:06','2022-03-03 13:30:06'),(117508,394,'Dialgam','192210',1,0,'2022-03-03 13:30:06','2022-03-03 13:30:06'),(117509,394,'Digripora','192124',1,0,'2022-03-03 13:30:06','2022-03-03 13:30:06'),(117510,394,'Dooru','192211',1,0,'2022-03-03 13:30:06','2022-03-03 13:30:06'),(117511,394,'Fatehpora','192211',1,0,'2022-03-03 13:30:06','2022-03-03 13:30:06'),(117512,394,'Frisal','192232',1,0,'2022-03-03 13:30:06','2022-03-03 13:30:06'),(117513,394,'Gadipora','192231',1,0,'2022-03-03 13:30:06','2022-03-03 13:30:06'),(117514,394,'Gairoo','192122',1,0,'2022-03-03 13:30:06','2022-03-03 13:30:06'),(117515,394,'Gopal Pora','192125',1,0,'2022-03-03 13:30:06','2022-03-03 13:30:06'),(117516,394,'Gopalpora','193303',1,0,'2022-03-03 13:30:06','2022-03-03 13:30:06'),(117517,394,'Gosani Gund','192211',1,0,'2022-03-03 13:30:06','2022-03-03 13:30:06'),(117518,394,'Gouripora','192122',1,0,'2022-03-03 13:30:06','2022-03-03 13:30:06'),(117519,394,'Guddar','192231',1,0,'2022-03-03 13:30:06','2022-03-03 13:30:06'),(117520,394,'H.C.Gam','192231',1,0,'2022-03-03 13:30:06','2022-03-03 13:30:06'),(117521,394,'Hakura Badasgam','192211',1,0,'2022-03-03 13:30:07','2022-03-03 13:30:07'),(117522,394,'Halsidar','192212',1,0,'2022-03-03 13:30:07','2022-03-03 13:30:07'),(117523,394,'Hardtour','192201',1,0,'2022-03-03 13:30:07','2022-03-03 13:30:07'),(117524,394,'Hef Shermal','192305',1,0,'2022-03-03 13:30:07','2022-03-03 13:30:07'),(117525,394,'Hiller Arahama','192201',1,0,'2022-03-03 13:30:07','2022-03-03 13:30:07'),(117526,394,'Hiller Shahabad','192211',1,0,'2022-03-03 13:30:07','2022-03-03 13:30:07'),(117527,394,'Honipora','192121',1,0,'2022-03-03 13:30:07','2022-03-03 13:30:07'),(117528,394,'Hugam','192401',1,0,'2022-03-03 13:30:07','2022-03-03 13:30:07'),(117529,394,'Hutmarah','192125',1,0,'2022-03-03 13:30:07','2022-03-03 13:30:07'),(117530,394,'Janglath Mandi','192101',1,0,'2022-03-03 13:30:07','2022-03-03 13:30:07'),(117531,394,'Kanilwan','192124',1,0,'2022-03-03 13:30:07','2022-03-03 13:30:07'),(117532,394,'Kanipora','192231',1,0,'2022-03-03 13:30:07','2022-03-03 13:30:07'),(117533,394,'Kapran','192231',1,0,'2022-03-03 13:30:07','2022-03-03 13:30:07'),(117534,394,'Kaprin','192212',1,0,'2022-03-03 13:30:07','2022-03-03 13:30:07'),(117535,394,'Kathsoo','192401',1,0,'2022-03-03 13:30:07','2022-03-03 13:30:07'),(117536,394,'Katrasoo','192232',1,0,'2022-03-03 13:30:07','2022-03-03 13:30:07'),(117537,394,'Khanabal','192101',1,0,'2022-03-03 13:30:07','2022-03-03 13:30:07'),(117538,394,'Khanda','192121',1,0,'2022-03-03 13:30:07','2022-03-03 13:30:07'),(117539,394,'Kharam','192401',1,0,'2022-03-03 13:30:08','2022-03-03 13:30:08'),(117540,394,'Kharapora','192202',1,0,'2022-03-03 13:30:08','2022-03-03 13:30:08'),(117541,394,'Khigogipora','192232',1,0,'2022-03-03 13:30:08','2022-03-03 13:30:08'),(117542,394,'Khull','193303',1,0,'2022-03-03 13:30:08','2022-03-03 13:30:08'),(117543,394,'Khuri Bhatapora','193303',1,0,'2022-03-03 13:30:08','2022-03-03 13:30:08'),(117544,394,'Kilam Bazgam','192231',1,0,'2022-03-03 13:30:08','2022-03-03 13:30:08'),(117545,394,'Kokarnag','192202',1,0,'2022-03-03 13:30:08','2022-03-03 13:30:08'),(117546,394,'Konibal','192121',1,0,'2022-03-03 13:30:08','2022-03-03 13:30:08'),(117547,394,'Kragsoo','192125',1,0,'2022-03-03 13:30:08','2022-03-03 13:30:08'),(117548,394,'Krandigam','192124',1,0,'2022-03-03 13:30:08','2022-03-03 13:30:08'),(117549,394,'Kriri Nowpora','192211',1,0,'2022-03-03 13:30:08','2022-03-03 13:30:08'),(117550,394,'Kullar','192401',1,0,'2022-03-03 13:30:08','2022-03-03 13:30:08'),(117551,394,'Laripora','192126',1,0,'2022-03-03 13:30:08','2022-03-03 13:30:08'),(117552,394,'Larkipora','192211',1,0,'2022-03-03 13:30:08','2022-03-03 13:30:08'),(117553,394,'Larnoo','192202',1,0,'2022-03-03 13:30:08','2022-03-03 13:30:08'),(117554,394,'Lathpora','192122',1,0,'2022-03-03 13:30:08','2022-03-03 13:30:08'),(117555,394,'Litter','192305',1,0,'2022-03-03 13:30:08','2022-03-03 13:30:08'),(117556,394,'Lower Mundah','192212',1,0,'2022-03-03 13:30:08','2022-03-03 13:30:08'),(117557,394,'Ludhoo','191103',1,0,'2022-03-03 13:30:08','2022-03-03 13:30:08'),(117558,394,'M/gufan','192232',1,0,'2022-03-03 13:30:09','2022-03-03 13:30:09'),(117559,394,'Malwan','192231',1,0,'2022-03-03 13:30:09','2022-03-03 13:30:09'),(117560,394,'Mandakpal','191103',1,0,'2022-03-03 13:30:09','2022-03-03 13:30:09'),(117561,394,'Mandhole','192221',1,0,'2022-03-03 13:30:09','2022-03-03 13:30:09'),(117562,394,'Manjmoh','192221',1,0,'2022-03-03 13:30:09','2022-03-03 13:30:09'),(117563,394,'Manzgam','193303',1,0,'2022-03-03 13:30:09','2022-03-03 13:30:09'),(117564,394,'Marhama','192124',1,0,'2022-03-03 13:30:09','2022-03-03 13:30:09'),(117565,394,'Martand','192125',1,0,'2022-03-03 13:30:09','2022-03-03 13:30:09'),(117566,394,'Mirhama','192231',1,0,'2022-03-03 13:30:09','2022-03-03 13:30:09'),(117567,394,'Mnadhole','192101',1,0,'2022-03-03 13:30:09','2022-03-03 13:30:09'),(117568,394,'Mohind','192401',1,0,'2022-03-03 13:30:09','2022-03-03 13:30:09'),(117569,394,'Monghal','192101',1,0,'2022-03-03 13:30:09','2022-03-03 13:30:09'),(117570,394,'Monghal','192221',1,0,'2022-03-03 13:30:09','2022-03-03 13:30:09'),(117571,394,'Muti Handoo','192202',1,0,'2022-03-03 13:30:09','2022-03-03 13:30:09'),(117572,394,'Naina','192124',1,0,'2022-03-03 13:30:09','2022-03-03 13:30:09'),(117573,394,'Nalasundhari','192202',1,0,'2022-03-03 13:30:09','2022-03-03 13:30:09'),(117574,394,'Nandi Marg','193303',1,0,'2022-03-03 13:30:09','2022-03-03 13:30:09'),(117575,394,'Nandigam','193303',1,0,'2022-03-03 13:30:09','2022-03-03 13:30:09'),(117576,394,'Nanil','192125',1,0,'2022-03-03 13:30:09','2022-03-03 13:30:09'),(117577,394,'Narapora','192202',1,0,'2022-03-03 13:30:09','2022-03-03 13:30:09'),(117578,394,'Nasnoor','193303',1,0,'2022-03-03 13:30:09','2022-03-03 13:30:09'),(117579,394,'Nehama','193303',1,0,'2022-03-03 13:30:10','2022-03-03 13:30:10'),(117580,394,'Nehama','192121',1,0,'2022-03-03 13:30:10','2022-03-03 13:30:10'),(117581,394,'Nellow','192231',1,0,'2022-03-03 13:30:10','2022-03-03 13:30:10'),(117582,394,'Nissu','192221',1,0,'2022-03-03 13:30:10','2022-03-03 13:30:10'),(117583,394,'Noonmai','192232',1,0,'2022-03-03 13:30:10','2022-03-03 13:30:10'),(117584,394,'Nowbug','192202',1,0,'2022-03-03 13:30:10','2022-03-03 13:30:10'),(117585,394,'Nowgam','192212',1,0,'2022-03-03 13:30:10','2022-03-03 13:30:10'),(117586,394,'Nowgam','192201',1,0,'2022-03-03 13:30:10','2022-03-03 13:30:10'),(117587,394,'Nowpora','192231',1,0,'2022-03-03 13:30:10','2022-03-03 13:30:10'),(117588,394,'Omanagri','192201',1,0,'2022-03-03 13:30:10','2022-03-03 13:30:10'),(117589,394,'Opzen','192124',1,0,'2022-03-03 13:30:10','2022-03-03 13:30:10'),(117590,394,'Pahaloo','192231',1,0,'2022-03-03 13:30:10','2022-03-03 13:30:10'),(117591,394,'Panchtarni(Sessional)','192126',1,0,'2022-03-03 13:30:10','2022-03-03 13:30:10'),(117592,394,'Panzeth','192221',1,0,'2022-03-03 13:30:10','2022-03-03 13:30:10'),(117593,394,'Panzgam','192124',1,0,'2022-03-03 13:30:10','2022-03-03 13:30:10'),(117594,394,'Pariwan','192231',1,0,'2022-03-03 13:30:10','2022-03-03 13:30:10'),(117595,394,'Phalgam','192126',1,0,'2022-03-03 13:30:10','2022-03-03 13:30:10'),(117596,394,'Qaimouh','192124',1,0,'2022-03-03 13:30:10','2022-03-03 13:30:10'),(117597,394,'Qanmar','192212',1,0,'2022-03-03 13:30:10','2022-03-03 13:30:10'),(117598,394,'Qazigund','192221',1,0,'2022-03-03 13:30:10','2022-03-03 13:30:10'),(117599,394,'Quimoh','192101',1,0,'2022-03-03 13:30:11','2022-03-03 13:30:11'),(117600,394,'Ranbirpora','192125',1,0,'2022-03-03 13:30:11','2022-03-03 13:30:11'),(117601,394,'Ratnipora','192231',1,0,'2022-03-03 13:30:11','2022-03-03 13:30:11'),(117602,394,'Reban Gund','192232',1,0,'2022-03-03 13:30:11','2022-03-03 13:30:11'),(117603,394,'Sadinare','192212',1,0,'2022-03-03 13:30:11','2022-03-03 13:30:11'),(117604,394,'Sallar','192401',1,0,'2022-03-03 13:30:11','2022-03-03 13:30:11'),(117605,394,'Sambura','192121',1,0,'2022-03-03 13:30:11','2022-03-03 13:30:11'),(117606,394,'Sangam','192202',1,0,'2022-03-03 13:30:11','2022-03-03 13:30:11'),(117607,394,'Sarnal','192101',1,0,'2022-03-03 13:30:11','2022-03-03 13:30:11'),(117608,394,'Seer Kanil Gund','192129',1,0,'2022-03-03 13:30:11','2022-03-03 13:30:11'),(117609,394,'Shalgam','192124',1,0,'2022-03-03 13:30:11','2022-03-03 13:30:11'),(117610,394,'Shamsipora','192124',1,0,'2022-03-03 13:30:11','2022-03-03 13:30:11'),(117611,394,'Shangas','192201',1,0,'2022-03-03 13:30:11','2022-03-03 13:30:11'),(117612,394,'Sheshanag (Sessional)','192230',1,0,'2022-03-03 13:30:11','2022-03-03 13:30:11'),(117613,394,'Shurat','192231',1,0,'2022-03-03 13:30:11','2022-03-03 13:30:11'),(117614,394,'Sirhama','192401',1,0,'2022-03-03 13:30:11','2022-03-03 13:30:11'),(117615,394,'Soaf Shali','192202',1,0,'2022-03-03 13:30:11','2022-03-03 13:30:11'),(117616,394,'Sopat','192221',1,0,'2022-03-03 13:30:11','2022-03-03 13:30:11'),(117617,394,'Sopat Tougpora','192101',1,0,'2022-03-03 13:30:11','2022-03-03 13:30:11'),(117618,394,'Srigufwaea','192401',1,0,'2022-03-03 13:30:11','2022-03-03 13:30:11'),(117619,394,'Sugan','192305',1,0,'2022-03-03 13:30:12','2022-03-03 13:30:12'),(117620,394,'Tarigam','192232',1,0,'2022-03-03 13:30:12','2022-03-03 13:30:12'),(117621,394,'Telwani','192201',1,0,'2022-03-03 13:30:12','2022-03-03 13:30:12'),(117622,394,'Tulkhana','192124',1,0,'2022-03-03 13:30:12','2022-03-03 13:30:12'),(117623,394,'Turka Wangam','192305',1,0,'2022-03-03 13:30:12','2022-03-03 13:30:12'),(117624,394,'Urran Hall','192124',1,0,'2022-03-03 13:30:12','2022-03-03 13:30:12'),(117625,394,'Urranhal','192101',1,0,'2022-03-03 13:30:12','2022-03-03 13:30:12'),(117626,394,'Utersoo','192201',1,0,'2022-03-03 13:30:12','2022-03-03 13:30:12'),(117627,394,'Vailobrang','192202',1,0,'2022-03-03 13:30:12','2022-03-03 13:30:12'),(117628,394,'Vandevalgam','192202',1,0,'2022-03-03 13:30:12','2022-03-03 13:30:12'),(117629,394,'Vanpoh','192101',1,0,'2022-03-03 13:30:12','2022-03-03 13:30:12'),(117630,394,'Vanpouh','192124',1,0,'2022-03-03 13:30:12','2022-03-03 13:30:12'),(117631,394,'Veeri','192124',1,0,'2022-03-03 13:30:12','2022-03-03 13:30:12'),(117632,394,'Verinaag','192212',1,0,'2022-03-03 13:30:12','2022-03-03 13:30:12'),(117633,394,'Vesshu','192221',1,0,'2022-03-03 13:30:12','2022-03-03 13:30:12'),(117634,394,'Vessu','192101',1,0,'2022-03-03 13:30:12','2022-03-03 13:30:12'),(117635,394,'Vokey','192231',1,0,'2022-03-03 13:30:12','2022-03-03 13:30:12'),(117636,394,'Wachi','192305',1,0,'2022-03-03 13:30:12','2022-03-03 13:30:12'),(117637,394,'Waghama','192124',1,0,'2022-03-03 13:30:12','2022-03-03 13:30:12'),(117638,394,'Wallarhama','192401',1,0,'2022-03-03 13:30:12','2022-03-03 13:30:12'),(117639,394,'Wangund','192221',1,0,'2022-03-03 13:30:12','2022-03-03 13:30:12'),(117640,394,'Wasoora','192305',1,0,'2022-03-03 13:30:12','2022-03-03 13:30:12'),(117641,394,'Yaripora','192232',1,0,'2022-03-03 13:30:12','2022-03-03 13:30:12'),(117642,394,'Yarkhoshipora','192221',1,0,'2022-03-03 13:30:13','2022-03-03 13:30:13'),(117643,394,'Zanipora','192124',1,0,'2022-03-03 13:30:13','2022-03-03 13:30:13'),(117644,394,'Zantrag','191103',1,0,'2022-03-03 13:30:13','2022-03-03 13:30:13'),(117645,395,'Achoora','193503',1,0,'2022-03-03 13:30:13','2022-03-03 13:30:13'),(117646,396,'Ajas','193502',1,0,'2022-03-03 13:30:13','2022-03-03 13:30:13'),(117647,396,'Aloosa','193502',1,0,'2022-03-03 13:30:13','2022-03-03 13:30:13'),(117648,396,'Amchikundal','193501',1,0,'2022-03-03 13:30:13','2022-03-03 13:30:13'),(117649,396,'Andergam','193121',1,0,'2022-03-03 13:30:13','2022-03-03 13:30:13'),(117650,396,'Arin','193502',1,0,'2022-03-03 13:30:13','2022-03-03 13:30:13'),(117651,396,'Asham','193504',1,0,'2022-03-03 13:30:13','2022-03-03 13:30:13'),(117652,396,'Ashtingoo','193502',1,0,'2022-03-03 13:30:13','2022-03-03 13:30:13'),(117653,396,'Athoora','193108',1,0,'2022-03-03 13:30:13','2022-03-03 13:30:13'),(117654,396,'Ayatmulla','193502',1,0,'2022-03-03 13:30:13','2022-03-03 13:30:13'),(117655,396,'Baduab','193503',1,0,'2022-03-03 13:30:13','2022-03-03 13:30:13'),(117656,396,'Badugam','193503',1,0,'2022-03-03 13:30:13','2022-03-03 13:30:13'),(117657,396,'Bagtore','193503',1,0,'2022-03-03 13:30:13','2022-03-03 13:30:13'),(117658,396,'Balhama','193301',1,0,'2022-03-03 13:30:13','2022-03-03 13:30:13'),(117659,396,'Balkote','193123',1,0,'2022-03-03 13:30:13','2022-03-03 13:30:13'),(117660,396,'Bandipora Chowk','193502',1,0,'2022-03-03 13:30:13','2022-03-03 13:30:13'),(117661,396,'Bandipora','193502',1,0,'2022-03-03 13:30:14','2022-03-03 13:30:14'),(117662,396,'Bankote','193502',1,0,'2022-03-03 13:30:14','2022-03-03 13:30:14'),(117663,396,'Baramulla H.O','193101',1,0,'2022-03-03 13:30:14','2022-03-03 13:30:14'),(117664,396,'Barnoi Kashpeth','193503',1,0,'2022-03-03 13:30:14','2022-03-03 13:30:14'),(117665,396,'Batvina','193501',1,0,'2022-03-03 13:30:14','2022-03-03 13:30:14'),(117666,396,'Behrampora','193303',1,0,'2022-03-03 13:30:14','2022-03-03 13:30:14'),(117667,396,'Bijhama','193122',1,0,'2022-03-03 13:30:14','2022-03-03 13:30:14'),(117668,396,'Binner','193301',1,0,'2022-03-03 13:30:14','2022-03-03 13:30:14'),(117669,396,'Bomai','193201',1,0,'2022-03-03 13:30:14','2022-03-03 13:30:14'),(117670,396,'Boniyar','193122',1,0,'2022-03-03 13:30:14','2022-03-03 13:30:14'),(117671,396,'Botingoo','193201',1,0,'2022-03-03 13:30:14','2022-03-03 13:30:14'),(117672,396,'Bulgam','193202',1,0,'2022-03-03 13:30:14','2022-03-03 13:30:14'),(117673,396,'Chandanwari','193122',1,0,'2022-03-03 13:30:14','2022-03-03 13:30:14'),(117674,396,'Chandooda','193101',1,0,'2022-03-03 13:30:14','2022-03-03 13:30:14'),(117675,396,'Chatloosa','193301',1,0,'2022-03-03 13:30:14','2022-03-03 13:30:14'),(117676,396,'Chatoosa','193303',1,0,'2022-03-03 13:30:14','2022-03-03 13:30:14'),(117677,396,'Check Sariwarpora','193121',1,0,'2022-03-03 13:30:14','2022-03-03 13:30:14'),(117678,396,'Chetti Bandi','193502',1,0,'2022-03-03 13:30:14','2022-03-03 13:30:14'),(117679,396,'Chijhama','193301',1,0,'2022-03-03 13:30:14','2022-03-03 13:30:14'),(117680,396,'Chiva','193504',1,0,'2022-03-03 13:30:14','2022-03-03 13:30:14'),(117681,396,'Chutimulla','193502',1,0,'2022-03-03 13:30:15','2022-03-03 13:30:15'),(117682,396,'Dachi','193123',1,0,'2022-03-03 13:30:15','2022-03-03 13:30:15'),(117683,396,'Dangerpora','193201',1,0,'2022-03-03 13:30:15','2022-03-03 13:30:15'),(117684,396,'Dangiwacha','193303',1,0,'2022-03-03 13:30:15','2022-03-03 13:30:15'),(117685,396,'Delina','193103',1,0,'2022-03-03 13:30:15','2022-03-03 13:30:15'),(117686,396,'Dhanisaidan','193122',1,0,'2022-03-03 13:30:15','2022-03-03 13:30:15'),(117687,396,'Doabgah','193201',1,0,'2022-03-03 13:30:15','2022-03-03 13:30:15'),(117688,396,'Dooru','193201',1,0,'2022-03-03 13:30:15','2022-03-03 13:30:15'),(117689,396,'Gamroo','193502',1,0,'2022-03-03 13:30:15','2022-03-03 13:30:15'),(117690,396,'Ganasthan','193121',1,0,'2022-03-03 13:30:15','2022-03-03 13:30:15'),(117691,396,'Gantmulla','193101',1,0,'2022-03-03 13:30:15','2022-03-03 13:30:15'),(117692,396,'Garkote','193123',1,0,'2022-03-03 13:30:15','2022-03-03 13:30:15'),(117693,396,'Garoora','193502',1,0,'2022-03-03 13:30:15','2022-03-03 13:30:15'),(117694,396,'Gingle','193122',1,0,'2022-03-03 13:30:15','2022-03-03 13:30:15'),(117695,396,'Gohan','193101',1,0,'2022-03-03 13:30:15','2022-03-03 13:30:15'),(117696,396,'Goshbugh','193121',1,0,'2022-03-03 13:30:15','2022-03-03 13:30:15'),(117697,396,'Gujran','193503',1,0,'2022-03-03 13:30:15','2022-03-03 13:30:15'),(117698,396,'Gund Ibrahim','193121',1,0,'2022-03-03 13:30:15','2022-03-03 13:30:15'),(117699,396,'Gund Jahangir','193501',1,0,'2022-03-03 13:30:15','2022-03-03 13:30:15'),(117700,396,'Gurez','193503',1,0,'2022-03-03 13:30:15','2022-03-03 13:30:15'),(117701,396,'Hadipora','193301',1,0,'2022-03-03 13:30:15','2022-03-03 13:30:15'),(117702,396,'Haigam','193202',1,0,'2022-03-03 13:30:16','2022-03-03 13:30:16'),(117703,396,'Hajin','193501',1,0,'2022-03-03 13:30:16','2022-03-03 13:30:16'),(117704,396,'Hakbara','193504',1,0,'2022-03-03 13:30:16','2022-03-03 13:30:16'),(117705,396,'Hanjiwera','193121',1,0,'2022-03-03 13:30:16','2022-03-03 13:30:16'),(117706,396,'Harduchanam','193303',1,0,'2022-03-03 13:30:16','2022-03-03 13:30:16'),(117707,396,'Hardushiva','193201',1,0,'2022-03-03 13:30:16','2022-03-03 13:30:16'),(117708,396,'Harwan','193201',1,0,'2022-03-03 13:30:16','2022-03-03 13:30:16'),(117709,396,'Hathlangoo','193201',1,0,'2022-03-03 13:30:16','2022-03-03 13:30:16'),(117710,396,'Heavan','193101',1,0,'2022-03-03 13:30:16','2022-03-03 13:30:16'),(117711,396,'Ijara','193122',1,0,'2022-03-03 13:30:16','2022-03-03 13:30:16'),(117712,396,'Isham','193123',1,0,'2022-03-03 13:30:16','2022-03-03 13:30:16'),(117713,396,'Jabla','193123',1,0,'2022-03-03 13:30:16','2022-03-03 13:30:16'),(117714,396,'Jamia Qadim','193202',1,0,'2022-03-03 13:30:16','2022-03-03 13:30:16'),(117715,396,'Kachawa Muqam','193101',1,0,'2022-03-03 13:30:16','2022-03-03 13:30:16'),(117716,396,'Kalantra','193101',1,0,'2022-03-03 13:30:16','2022-03-03 13:30:16'),(117717,396,'Kaloosa','193502',1,0,'2022-03-03 13:30:16','2022-03-03 13:30:16'),(117718,396,'Kamalkote','193123',1,0,'2022-03-03 13:30:16','2022-03-03 13:30:16'),(117719,396,'Kanispora','193103',1,0,'2022-03-03 13:30:16','2022-03-03 13:30:16'),(117720,396,'Kanzalwan','193503',1,0,'2022-03-03 13:30:16','2022-03-03 13:30:16'),(117721,396,'Khadnyar','193101',1,0,'2022-03-03 13:30:16','2022-03-03 13:30:16'),(117722,396,'Khahmoh','193301',1,0,'2022-03-03 13:30:16','2022-03-03 13:30:16'),(117723,396,'Khaipora','193108',1,0,'2022-03-03 13:30:16','2022-03-03 13:30:16'),(117724,396,'Khaitangan','193103',1,0,'2022-03-03 13:30:17','2022-03-03 13:30:17'),(117725,396,'Khanpeth','193121',1,0,'2022-03-03 13:30:17','2022-03-03 13:30:17'),(117726,396,'Khanpora','193101',1,0,'2022-03-03 13:30:17','2022-03-03 13:30:17'),(117727,396,'Khawaja Bagh','193103',1,0,'2022-03-03 13:30:17','2022-03-03 13:30:17'),(117728,396,'Khenusa','193502',1,0,'2022-03-03 13:30:17','2022-03-03 13:30:17'),(117729,396,'Khore','193121',1,0,'2022-03-03 13:30:17','2022-03-03 13:30:17'),(117730,396,'Krankshivam','193202',1,0,'2022-03-03 13:30:17','2022-03-03 13:30:17'),(117731,396,'Kreeri','193108',1,0,'2022-03-03 13:30:17','2022-03-03 13:30:17'),(117732,396,'Lachipora','193122',1,0,'2022-03-03 13:30:17','2022-03-03 13:30:17'),(117733,396,'Ladoora','193201',1,0,'2022-03-03 13:30:17','2022-03-03 13:30:17'),(117734,396,'Lalpora Bangil','193121',1,0,'2022-03-03 13:30:17','2022-03-03 13:30:17'),(117735,396,'Langate','193302',1,0,'2022-03-03 13:30:17','2022-03-03 13:30:17'),(117736,396,'Laridora','193101',1,0,'2022-03-03 13:30:17','2022-03-03 13:30:17'),(117737,396,'Lawaypora','193502',1,0,'2022-03-03 13:30:17','2022-03-03 13:30:17'),(117738,396,'Madwan','193501',1,0,'2022-03-03 13:30:17','2022-03-03 13:30:17'),(117739,396,'Malangam','193502',1,0,'2022-03-03 13:30:17','2022-03-03 13:30:17'),(117740,396,'Malpora','193101',1,0,'2022-03-03 13:30:17','2022-03-03 13:30:17'),(117741,396,'Mamoosa','193121',1,0,'2022-03-03 13:30:17','2022-03-03 13:30:17'),(117742,396,'Mantrigam','193502',1,0,'2022-03-03 13:30:17','2022-03-03 13:30:17'),(117743,396,'Markoot','193503',1,0,'2022-03-03 13:30:17','2022-03-03 13:30:17'),(117744,396,'Matipora','193121',1,0,'2022-03-03 13:30:18','2022-03-03 13:30:18'),(117745,396,'Met ',' Sopore',1,0,'2022-03-03 13:30:18','2022-03-03 13:30:18'),(117746,396,'Mirgund','193121',1,0,'2022-03-03 13:30:18','2022-03-03 13:30:18'),(117747,396,'Mohara','193122',1,0,'2022-03-03 13:30:18','2022-03-03 13:30:18'),(117748,396,'Mundji','193201',1,0,'2022-03-03 13:30:18','2022-03-03 13:30:18'),(117749,396,'Nadihal','193502',1,0,'2022-03-03 13:30:18','2022-03-03 13:30:18'),(117750,396,'Nadihal','193301',1,0,'2022-03-03 13:30:18','2022-03-03 13:30:18'),(117751,396,'Naidkhai','193501',1,0,'2022-03-03 13:30:18','2022-03-03 13:30:18'),(117752,396,'Nambla','193123',1,0,'2022-03-03 13:30:18','2022-03-03 13:30:18'),(117753,396,'Nehalpora','193121',1,0,'2022-03-03 13:30:18','2022-03-03 13:30:18'),(117754,396,'Nesbal','193501',1,0,'2022-03-03 13:30:18','2022-03-03 13:30:18'),(117755,396,'Nowgam','193501',1,0,'2022-03-03 13:30:18','2022-03-03 13:30:18'),(117756,396,'Nowpora','193103',1,0,'2022-03-03 13:30:18','2022-03-03 13:30:18'),(117757,396,'Nowpora','193201',1,0,'2022-03-03 13:30:18','2022-03-03 13:30:18'),(117758,396,'Nowshera','193122',1,0,'2022-03-03 13:30:18','2022-03-03 13:30:18'),(117759,396,'Onagam','193502',1,0,'2022-03-03 13:30:18','2022-03-03 13:30:18'),(117760,396,'Palhallan','193121',1,0,'2022-03-03 13:30:18','2022-03-03 13:30:18'),(117761,396,'Panzala','193301',1,0,'2022-03-03 13:30:18','2022-03-03 13:30:18'),(117762,396,'Panzinara','193501',1,0,'2022-03-03 13:30:18','2022-03-03 13:30:18'),(117763,396,'Parampilla','193123',1,0,'2022-03-03 13:30:18','2022-03-03 13:30:18'),(117764,396,'Pattan','193121',1,0,'2022-03-03 13:30:19','2022-03-03 13:30:19'),(117765,396,'Pringal','193122',1,0,'2022-03-03 13:30:19','2022-03-03 13:30:19'),(117766,396,'Puranatilel','193503',1,0,'2022-03-03 13:30:19','2022-03-03 13:30:19'),(117767,396,'Quilmuqam','193502',1,0,'2022-03-03 13:30:19','2022-03-03 13:30:19'),(117768,396,'Rajghat','193101',1,0,'2022-03-03 13:30:19','2022-03-03 13:30:19'),(117769,396,'Rengpeth','193303',1,0,'2022-03-03 13:30:19','2022-03-03 13:30:19'),(117770,396,'Rohama','193301',1,0,'2022-03-03 13:30:19','2022-03-03 13:30:19'),(117771,396,'Sadadkootbala','193504',1,0,'2022-03-03 13:30:19','2022-03-03 13:30:19'),(117772,396,'Sadunara','193504',1,0,'2022-03-03 13:30:19','2022-03-03 13:30:19'),(117773,396,'Safapora','193504',1,0,'2022-03-03 13:30:19','2022-03-03 13:30:19'),(117774,396,'Sagipora','193201',1,0,'2022-03-03 13:30:19','2022-03-03 13:30:19'),(117775,396,'Salamabad','193122',1,0,'2022-03-03 13:30:19','2022-03-03 13:30:19'),(117776,396,'Salamabad','193123',1,0,'2022-03-03 13:30:19','2022-03-03 13:30:19'),(117777,396,'Saloosa','193108',1,0,'2022-03-03 13:30:19','2022-03-03 13:30:19'),(117778,396,'Sangrama','193202',1,0,'2022-03-03 13:30:19','2022-03-03 13:30:19'),(117779,396,'Saradab','193503',1,0,'2022-03-03 13:30:19','2022-03-03 13:30:19'),(117780,396,'Seelu','193201',1,0,'2022-03-03 13:30:19','2022-03-03 13:30:19'),(117781,396,'Seer','193202',1,0,'2022-03-03 13:30:19','2022-03-03 13:30:19'),(117782,396,'Seru Dangerpora','193121',1,0,'2022-03-03 13:30:19','2022-03-03 13:30:19'),(117783,396,'Shadipora','193501',1,0,'2022-03-03 13:30:19','2022-03-03 13:30:19'),(117784,396,'Shahgund','193501',1,0,'2022-03-03 13:30:19','2022-03-03 13:30:19'),(117785,396,'Shirpora Bangil','193121',1,0,'2022-03-03 13:30:20','2022-03-03 13:30:20'),(117786,396,'Shitloo','193301',1,0,'2022-03-03 13:30:20','2022-03-03 13:30:20'),(117787,396,'Shree','193101',1,0,'2022-03-03 13:30:20','2022-03-03 13:30:20'),(117788,396,'Singhpora','193103',1,0,'2022-03-03 13:30:20','2022-03-03 13:30:20'),(117789,396,'Singhpora','193121',1,0,'2022-03-03 13:30:20','2022-03-03 13:30:20'),(117790,396,'Sonawari','193501',1,0,'2022-03-03 13:30:20','2022-03-03 13:30:20'),(117791,396,'Sonerwani','193502',1,0,'2022-03-03 13:30:20','2022-03-03 13:30:20'),(117792,396,'Sopore','193201',1,0,'2022-03-03 13:30:20','2022-03-03 13:30:20'),(117793,396,'Sultan Daki','193123',1,0,'2022-03-03 13:30:20','2022-03-03 13:30:20'),(117794,396,'Sultanpora','193501',1,0,'2022-03-03 13:30:20','2022-03-03 13:30:20'),(117795,396,'Sultanpora','193101',1,0,'2022-03-03 13:30:20','2022-03-03 13:30:20'),(117796,396,'Tapper Waripora','193121',1,0,'2022-03-03 13:30:20','2022-03-03 13:30:20'),(117797,396,'Tarbal','193503',1,0,'2022-03-03 13:30:20','2022-03-03 13:30:20'),(117798,396,'Tarzoo','193202',1,0,'2022-03-03 13:30:20','2022-03-03 13:30:20'),(117799,396,'Tilgam','193108',1,0,'2022-03-03 13:30:20','2022-03-03 13:30:20'),(117800,396,'Trikanjan','193122',1,0,'2022-03-03 13:30:20','2022-03-03 13:30:20'),(117801,396,'Tujar','193201',1,0,'2022-03-03 13:30:20','2022-03-03 13:30:20'),(117802,396,'Uri','193123',1,0,'2022-03-03 13:30:20','2022-03-03 13:30:20'),(117803,396,'Ushukura','193101',1,0,'2022-03-03 13:30:21','2022-03-03 13:30:21'),(117804,396,'Wadoora','193201',1,0,'2022-03-03 13:30:21','2022-03-03 13:30:21'),(117805,396,'Wagoora','193103',1,0,'2022-03-03 13:30:21','2022-03-03 13:30:21'),(117806,396,'Wampora','193503',1,0,'2022-03-03 13:30:21','2022-03-03 13:30:21'),(117807,396,'Wanigam','193108',1,0,'2022-03-03 13:30:21','2022-03-03 13:30:21'),(117808,396,'Warpora','193201',1,0,'2022-03-03 13:30:21','2022-03-03 13:30:21'),(117809,396,'Watergam','193303',1,0,'2022-03-03 13:30:21','2022-03-03 13:30:21'),(117810,396,'Watlab','193201',1,0,'2022-03-03 13:30:21','2022-03-03 13:30:21'),(117811,396,'Watpora','193502',1,0,'2022-03-03 13:30:21','2022-03-03 13:30:21'),(117812,396,'Yal','193121',1,0,'2022-03-03 13:30:21','2022-03-03 13:30:21'),(117813,396,'Zaloora','193201',1,0,'2022-03-03 13:30:21','2022-03-03 13:30:21'),(117814,396,'Zethan','193303',1,0,'2022-03-03 13:30:21','2022-03-03 13:30:21'),(117815,396,'Aripanthan','193401',1,0,'2022-03-03 13:30:21','2022-03-03 13:30:21'),(117816,396,'Babareshi','193402',1,0,'2022-03-03 13:30:21','2022-03-03 13:30:21'),(117817,396,'Badran','193401',1,0,'2022-03-03 13:30:21','2022-03-03 13:30:21'),(117818,396,'Chandil  Waniyam','193401',1,0,'2022-03-03 13:30:21','2022-03-03 13:30:21'),(117819,396,'Chandilora','193402',1,0,'2022-03-03 13:30:21','2022-03-03 13:30:21'),(117820,396,'Devbugh','193401',1,0,'2022-03-03 13:30:21','2022-03-03 13:30:21'),(117821,396,'Devpora','193401',1,0,'2022-03-03 13:30:21','2022-03-03 13:30:21'),(117822,396,'Ferozpora','193402',1,0,'2022-03-03 13:30:21','2022-03-03 13:30:21'),(117823,396,'Gulmarg','193403',1,0,'2022-03-03 13:30:22','2022-03-03 13:30:22'),(117824,396,'Gund Kh. Qasim','193401',1,0,'2022-03-03 13:30:22','2022-03-03 13:30:22'),(117825,396,'Hajhal','193402',1,0,'2022-03-03 13:30:22','2022-03-03 13:30:22'),(117826,396,'Hard Ahoora','193401',1,0,'2022-03-03 13:30:22','2022-03-03 13:30:22'),(117827,396,'Hard Shora','193401',1,0,'2022-03-03 13:30:22','2022-03-03 13:30:22'),(117828,396,'Hardichhloo','193402',1,0,'2022-03-03 13:30:22','2022-03-03 13:30:22'),(117829,396,'Hariwatnoo','193402',1,0,'2022-03-03 13:30:22','2022-03-03 13:30:22'),(117830,396,'Kawarahama','193401',1,0,'2022-03-03 13:30:22','2022-03-03 13:30:22'),(117831,396,'Kralweth','193401',1,0,'2022-03-03 13:30:22','2022-03-03 13:30:22'),(117832,396,'Kunzer','193404',1,0,'2022-03-03 13:30:22','2022-03-03 13:30:22'),(117833,396,'Malmoh','193401',1,0,'2022-03-03 13:30:22','2022-03-03 13:30:22'),(117834,396,'Mulgam','193401',1,0,'2022-03-03 13:30:22','2022-03-03 13:30:22'),(117835,396,'Nambal','192125',1,0,'2022-03-03 13:30:22','2022-03-03 13:30:22'),(117836,396,'Narhal','193401',1,0,'2022-03-03 13:30:22','2022-03-03 13:30:22'),(117837,396,'Peth Kanihama','193401',1,0,'2022-03-03 13:30:22','2022-03-03 13:30:22'),(117838,396,'Tangmarg','193402',1,0,'2022-03-03 13:30:22','2022-03-03 13:30:22'),(117839,396,'Tarhama','193401',1,0,'2022-03-03 13:30:22','2022-03-03 13:30:22'),(117840,396,'Wail Kralpora','193401',1,0,'2022-03-03 13:30:22','2022-03-03 13:30:22'),(117841,397,'Abhama','191112',1,0,'2022-03-03 13:30:22','2022-03-03 13:30:22'),(117842,397,'Arath','191111',1,0,'2022-03-03 13:30:22','2022-03-03 13:30:22'),(117843,397,'Arigam','191111',1,0,'2022-03-03 13:30:23','2022-03-03 13:30:23'),(117844,397,'Bandgam','191111',1,0,'2022-03-03 13:30:23','2022-03-03 13:30:23'),(117845,397,'Bandipora','191113',1,0,'2022-03-03 13:30:23','2022-03-03 13:30:23'),(117846,397,'Beerwah','193411',1,0,'2022-03-03 13:30:23','2022-03-03 13:30:23'),(117847,397,'Bogam Batapora','191113',1,0,'2022-03-03 13:30:23','2022-03-03 13:30:23'),(117848,397,'Brinjan','191113',1,0,'2022-03-03 13:30:23','2022-03-03 13:30:23'),(117849,397,'Budgam','191111',1,0,'2022-03-03 13:30:23','2022-03-03 13:30:23'),(117850,397,'Chadoora','191113',1,0,'2022-03-03 13:30:23','2022-03-03 13:30:23'),(117851,397,'Chanthan Checkpora','193411',1,0,'2022-03-03 13:30:23','2022-03-03 13:30:23'),(117852,397,'Char-sharief','191112',1,0,'2022-03-03 13:30:23','2022-03-03 13:30:23'),(117853,397,'Chattergam','191113',1,0,'2022-03-03 13:30:23','2022-03-03 13:30:23'),(117854,397,'Chewdarah','193411',1,0,'2022-03-03 13:30:23','2022-03-03 13:30:23'),(117855,397,'Dachan','193411',1,0,'2022-03-03 13:30:23','2022-03-03 13:30:23'),(117856,397,'Darwan Nawgam','191112',1,0,'2022-03-03 13:30:23','2022-03-03 13:30:23'),(117857,397,'Gariend','191111',1,0,'2022-03-03 13:30:23','2022-03-03 13:30:23'),(117858,397,'Gogjipathri','191113',1,0,'2022-03-03 13:30:23','2022-03-03 13:30:23'),(117859,397,'H Panzu','193411',1,0,'2022-03-03 13:30:23','2022-03-03 13:30:23'),(117860,397,'Hamhama','190021',1,0,'2022-03-03 13:30:23','2022-03-03 13:30:23'),(117861,397,'Hanjura','191113',1,0,'2022-03-03 13:30:23','2022-03-03 13:30:23'),(117862,397,'Hardudalwan','191112',1,0,'2022-03-03 13:30:23','2022-03-03 13:30:23'),(117863,397,'Hayatpora','191113',1,0,'2022-03-03 13:30:23','2022-03-03 13:30:23'),(117864,397,'Hyderpora','190014',1,0,'2022-03-03 13:30:24','2022-03-03 13:30:24'),(117865,397,'Ichgam','191111',1,0,'2022-03-03 13:30:24','2022-03-03 13:30:24'),(117866,397,'Iskanderpora','193411',1,0,'2022-03-03 13:30:24','2022-03-03 13:30:24'),(117867,397,'Jawalapora','191111',1,0,'2022-03-03 13:30:24','2022-03-03 13:30:24'),(117868,397,'Kachwari','191111',1,0,'2022-03-03 13:30:24','2022-03-03 13:30:24'),(117869,397,'Kandoora','193411',1,0,'2022-03-03 13:30:24','2022-03-03 13:30:24'),(117870,397,'Kanihama','193401',1,0,'2022-03-03 13:30:24','2022-03-03 13:30:24'),(117871,397,'Kawoosa Khalisa','193401',1,0,'2022-03-03 13:30:24','2022-03-03 13:30:24'),(117872,397,'Kenidajan','191112',1,0,'2022-03-03 13:30:24','2022-03-03 13:30:24'),(117873,397,'Kenihama','190015',1,0,'2022-03-03 13:30:24','2022-03-03 13:30:24'),(117874,397,'Khag','193411',1,0,'2022-03-03 13:30:24','2022-03-03 13:30:24'),(117875,397,'Khan Shaib','191111',1,0,'2022-03-03 13:30:24','2022-03-03 13:30:24'),(117876,397,'Kralpora','190019',1,0,'2022-03-03 13:30:24','2022-03-03 13:30:24'),(117877,397,'Krim Shore','191111',1,0,'2022-03-03 13:30:24','2022-03-03 13:30:24'),(117878,397,'Lalgam','191113',1,0,'2022-03-03 13:30:24','2022-03-03 13:30:24'),(117879,397,'Lalpora','193411',1,0,'2022-03-03 13:30:24','2022-03-03 13:30:24'),(117880,397,'Later Chadoora','191111',1,0,'2022-03-03 13:30:24','2022-03-03 13:30:24'),(117881,397,'Magam','193401',1,0,'2022-03-03 13:30:24','2022-03-03 13:30:24'),(117882,397,'Nagam','191113',1,0,'2022-03-03 13:30:24','2022-03-03 13:30:24'),(117883,397,'Narbal','193401',1,0,'2022-03-03 13:30:24','2022-03-03 13:30:24'),(117884,397,'Natipora','190015',1,0,'2022-03-03 13:30:24','2022-03-03 13:30:24'),(117885,397,'Nowgam','190015',1,0,'2022-03-03 13:30:24','2022-03-03 13:30:24'),(117886,397,'Nowgam','190015',1,0,'2022-03-03 13:30:25','2022-03-03 13:30:25'),(117887,397,'Ompora','191111',1,0,'2022-03-03 13:30:25','2022-03-03 13:30:25'),(117888,397,'Otligam','193411',1,0,'2022-03-03 13:30:25','2022-03-03 13:30:25'),(117889,397,'Pahroo','192121',1,0,'2022-03-03 13:30:25','2022-03-03 13:30:25'),(117890,397,'Pakherpora','191112',1,0,'2022-03-03 13:30:25','2022-03-03 13:30:25'),(117891,397,'Peth Makhama','193401',1,0,'2022-03-03 13:30:25','2022-03-03 13:30:25'),(117892,397,'Poshkar','193411',1,0,'2022-03-03 13:30:25','2022-03-03 13:30:25'),(117893,397,'Qumroo','193411',1,0,'2022-03-03 13:30:25','2022-03-03 13:30:25'),(117894,397,'R N Hall','191113',1,0,'2022-03-03 13:30:25','2022-03-03 13:30:25'),(117895,397,'Raithan','191111',1,0,'2022-03-03 13:30:25','2022-03-03 13:30:25'),(117896,397,'Raiyar','193411',1,0,'2022-03-03 13:30:25','2022-03-03 13:30:25'),(117897,397,'Rangar','191113',1,0,'2022-03-03 13:30:25','2022-03-03 13:30:25'),(117898,397,'Rangreth','191132',1,0,'2022-03-03 13:30:25','2022-03-03 13:30:25'),(117899,397,'Ratsoon','193401',1,0,'2022-03-03 13:30:25','2022-03-03 13:30:25'),(117900,397,'Sagam','191113',1,0,'2022-03-03 13:30:25','2022-03-03 13:30:25'),(117901,397,'Sail','193411',1,0,'2022-03-03 13:30:25','2022-03-03 13:30:25'),(117902,397,'Sanat Nagar','190005',1,0,'2022-03-03 13:30:25','2022-03-03 13:30:25'),(117903,397,'Sanoorkalipora','193401',1,0,'2022-03-03 13:30:25','2022-03-03 13:30:25'),(117904,397,'Shogapora','191111',1,0,'2022-03-03 13:30:25','2022-03-03 13:30:25'),(117905,397,'Sholipora','191111',1,0,'2022-03-03 13:30:26','2022-03-03 13:30:26'),(117906,397,'Shonglipora','193411',1,0,'2022-03-03 13:30:26','2022-03-03 13:30:26'),(117907,397,'Sk Airport','190007',1,0,'2022-03-03 13:30:26','2022-03-03 13:30:26'),(117908,397,'Soibugh','191111',1,0,'2022-03-03 13:30:26','2022-03-03 13:30:26'),(117909,397,'Suraryan','191113',1,0,'2022-03-03 13:30:26','2022-03-03 13:30:26'),(117910,397,'Wanpora','191113',1,0,'2022-03-03 13:30:26','2022-03-03 13:30:26'),(117911,397,'Watakala','191113',1,0,'2022-03-03 13:30:26','2022-03-03 13:30:26'),(117912,397,'Wathura','191113',1,0,'2022-03-03 13:30:26','2022-03-03 13:30:26'),(117913,397,'Watterhail','191111',1,0,'2022-03-03 13:30:26','2022-03-03 13:30:26'),(117914,397,'Zugu Khyran','193411',1,0,'2022-03-03 13:30:26','2022-03-03 13:30:26'),(117915,398,'Aftee','182205',1,0,'2022-03-03 13:30:26','2022-03-03 13:30:26'),(117916,398,'Alambas','182145',1,0,'2022-03-03 13:30:26','2022-03-03 13:30:26'),(117917,398,'Assar','182143',1,0,'2022-03-03 13:30:26','2022-03-03 13:30:26'),(117918,398,'Badhat','182204',1,0,'2022-03-03 13:30:26','2022-03-03 13:30:26'),(117919,398,'Baggar','182143',1,0,'2022-03-03 13:30:26','2022-03-03 13:30:26'),(117920,398,'Bajarni','182202',1,0,'2022-03-03 13:30:26','2022-03-03 13:30:26'),(117921,398,'Banihal','182146',1,0,'2022-03-03 13:30:26','2022-03-03 13:30:26'),(117922,398,'Banoon','182203',1,0,'2022-03-03 13:30:26','2022-03-03 13:30:26'),(117923,398,'Batote','182143',1,0,'2022-03-03 13:30:26','2022-03-03 13:30:26'),(117924,398,'Batroo','182145',1,0,'2022-03-03 13:30:26','2022-03-03 13:30:26'),(117925,398,'Beoli','182202',1,0,'2022-03-03 13:30:26','2022-03-03 13:30:26'),(117926,398,'Bhaderwah','182222',1,0,'2022-03-03 13:30:27','2022-03-03 13:30:27'),(117927,398,'Bhagwa','182202',1,0,'2022-03-03 13:30:27','2022-03-03 13:30:27'),(117928,398,'Bhalla','182201',1,0,'2022-03-03 13:30:27','2022-03-03 13:30:27'),(117929,398,'Bhalla','182221',1,0,'2022-03-03 13:30:27','2022-03-03 13:30:27'),(117930,398,'Bhalra','182221',1,0,'2022-03-03 13:30:27','2022-03-03 13:30:27'),(117931,398,'Bhartund','182148',1,0,'2022-03-03 13:30:27','2022-03-03 13:30:27'),(117932,398,'Bhatni','182144',1,0,'2022-03-03 13:30:27','2022-03-03 13:30:27'),(117933,398,'Chachwa','182144',1,0,'2022-03-03 13:30:27','2022-03-03 13:30:27'),(117934,398,'Chakka','182148',1,0,'2022-03-03 13:30:27','2022-03-03 13:30:27'),(117935,398,'Chambalwas','182146',1,0,'2022-03-03 13:30:27','2022-03-03 13:30:27'),(117936,398,'Chanderkot','182148',1,0,'2022-03-03 13:30:27','2022-03-03 13:30:27'),(117937,398,'Chanichinta','182222',1,0,'2022-03-03 13:30:27','2022-03-03 13:30:27'),(117938,398,'Chareel','182146',1,0,'2022-03-03 13:30:27','2022-03-03 13:30:27'),(117939,398,'Chattarsori','182221',1,0,'2022-03-03 13:30:27','2022-03-03 13:30:27'),(117940,398,'Chhatroo','182205',1,0,'2022-03-03 13:30:27','2022-03-03 13:30:27'),(117941,398,'Chilli','182203',1,0,'2022-03-03 13:30:27','2022-03-03 13:30:27'),(117942,398,'Chingam','182205',1,0,'2022-03-03 13:30:27','2022-03-03 13:30:27'),(117943,398,'Chirala','182201',1,0,'2022-03-03 13:30:27','2022-03-03 13:30:27'),(117944,398,'Chouri','182203',1,0,'2022-03-03 13:30:27','2022-03-03 13:30:27'),(117945,398,'Dachhan','182205',1,0,'2022-03-03 13:30:27','2022-03-03 13:30:27'),(117946,398,'Dachhan','182202',1,0,'2022-03-03 13:30:27','2022-03-03 13:30:27'),(117947,398,'Deedah','182144',1,0,'2022-03-03 13:30:27','2022-03-03 13:30:27'),(117948,398,'Dessa','182202',1,0,'2022-03-03 13:30:27','2022-03-03 13:30:27'),(117949,398,'Dhandal','182124',1,0,'2022-03-03 13:30:28','2022-03-03 13:30:28'),(117950,398,'Dhandal','182147',1,0,'2022-03-03 13:30:28','2022-03-03 13:30:28'),(117951,398,'Dhara','182201',1,0,'2022-03-03 13:30:28','2022-03-03 13:30:28'),(117952,398,'Dharamkund','182144',1,0,'2022-03-03 13:30:28','2022-03-03 13:30:28'),(117953,398,'Dhesa','182203',1,0,'2022-03-03 13:30:28','2022-03-03 13:30:28'),(117954,398,'Doda (Doda)','182202',1,0,'2022-03-03 13:30:28','2022-03-03 13:30:28'),(117955,398,'Dool','182204',1,0,'2022-03-03 13:30:28','2022-03-03 13:30:28'),(117956,398,'Dul Hasti Project','182206',1,0,'2022-03-03 13:30:28','2022-03-03 13:30:28'),(117957,398,'Duligam','182146',1,0,'2022-03-03 13:30:28','2022-03-03 13:30:28'),(117958,398,'Galhar','182204',1,0,'2022-03-03 13:30:28','2022-03-03 13:30:28'),(117959,398,'Gandoh','182203',1,0,'2022-03-03 13:30:28','2022-03-03 13:30:28'),(117960,398,'Gandri','182144',1,0,'2022-03-03 13:30:28','2022-03-03 13:30:28'),(117961,398,'Ganika','182147',1,0,'2022-03-03 13:30:28','2022-03-03 13:30:28'),(117962,398,'Ghat','182202',1,0,'2022-03-03 13:30:28','2022-03-03 13:30:28'),(117963,398,'Goha','182201',1,0,'2022-03-03 13:30:28','2022-03-03 13:30:28'),(117964,398,'Gundna','182202',1,0,'2022-03-03 13:30:28','2022-03-03 13:30:28'),(117965,398,'Halla','182148',1,0,'2022-03-03 13:30:28','2022-03-03 13:30:28'),(117966,398,'Hoochak','182145',1,0,'2022-03-03 13:30:28','2022-03-03 13:30:28'),(117967,398,'Humble','182201',1,0,'2022-03-03 13:30:28','2022-03-03 13:30:28'),(117968,398,'Ind','182144',1,0,'2022-03-03 13:30:28','2022-03-03 13:30:28'),(117969,398,'Inderwal','182205',1,0,'2022-03-03 13:30:28','2022-03-03 13:30:28'),(117970,398,'Inharrah','182203',1,0,'2022-03-03 13:30:29','2022-03-03 13:30:29'),(117971,398,'Jakyas','182203',1,0,'2022-03-03 13:30:29','2022-03-03 13:30:29'),(117972,398,'Jodhpur','182202',1,0,'2022-03-03 13:30:29','2022-03-03 13:30:29'),(117973,398,'Jogote','182201',1,0,'2022-03-03 13:30:29','2022-03-03 13:30:29'),(117974,398,'Jora','182203',1,0,'2022-03-03 13:30:29','2022-03-03 13:30:29'),(117975,398,'Kainthi','182148',1,0,'2022-03-03 13:30:29','2022-03-03 13:30:29'),(117976,398,'Kaljugasar','182203',1,0,'2022-03-03 13:30:29','2022-03-03 13:30:29'),(117977,398,'Kandni','182204',1,0,'2022-03-03 13:30:29','2022-03-03 13:30:29'),(117978,398,'Kanga','182144',1,0,'2022-03-03 13:30:29','2022-03-03 13:30:29'),(117979,398,'Kaskoot','182146',1,0,'2022-03-03 13:30:29','2022-03-03 13:30:29'),(117980,398,'Kastigarh','182147',1,0,'2022-03-03 13:30:29','2022-03-03 13:30:29'),(117981,398,'Katyara','182222',1,0,'2022-03-03 13:30:29','2022-03-03 13:30:29'),(117982,398,'Khalaini','182201',1,0,'2022-03-03 13:30:29','2022-03-03 13:30:29'),(117983,398,'Khari','182145',1,0,'2022-03-03 13:30:29','2022-03-03 13:30:29'),(117984,398,'Khellani','182201',1,0,'2022-03-03 13:30:29','2022-03-03 13:30:29'),(117985,398,'Khorial','182145',1,0,'2022-03-03 13:30:29','2022-03-03 13:30:29'),(117986,398,'Kilhotran','182203',1,0,'2022-03-03 13:30:29','2022-03-03 13:30:29'),(117987,398,'Kishtwar','182204',1,0,'2022-03-03 13:30:29','2022-03-03 13:30:29'),(117988,398,'Kukerwas','182204',1,0,'2022-03-03 13:30:29','2022-03-03 13:30:29'),(117989,398,'Kundi Karol','182148',1,0,'2022-03-03 13:30:29','2022-03-03 13:30:29'),(117990,398,'Kursari','182221',1,0,'2022-03-03 13:30:29','2022-03-03 13:30:29'),(117991,398,'Kutal','182204',1,0,'2022-03-03 13:30:30','2022-03-03 13:30:30'),(117992,398,'Mahu','182146',1,0,'2022-03-03 13:30:30','2022-03-03 13:30:30'),(117993,398,'Maitra Bazar','182144',1,0,'2022-03-03 13:30:30','2022-03-03 13:30:30'),(117994,398,'Malanoo','182203',1,0,'2022-03-03 13:30:30','2022-03-03 13:30:30'),(117995,398,'Malhori','182201',1,0,'2022-03-03 13:30:30','2022-03-03 13:30:30'),(117996,398,'Malhota','182201',1,0,'2022-03-03 13:30:30','2022-03-03 13:30:30'),(117997,398,'Malhoti','182221',1,0,'2022-03-03 13:30:30','2022-03-03 13:30:30'),(117998,398,'Maligam','182145',1,0,'2022-03-03 13:30:30','2022-03-03 13:30:30'),(117999,398,'Malindal','182201',1,0,'2022-03-03 13:30:30','2022-03-03 13:30:30'),(118000,398,'Mandel','182204',1,0,'2022-03-03 13:30:30','2022-03-03 13:30:30'),(118001,398,'Mangat','182146',1,0,'2022-03-03 13:30:30','2022-03-03 13:30:30'),(118002,398,'Mangota','182201',1,0,'2022-03-03 13:30:30','2022-03-03 13:30:30'),(118003,398,'Manlnai','182201',1,0,'2022-03-03 13:30:30','2022-03-03 13:30:30'),(118004,398,'Mohalla','182201',1,0,'2022-03-03 13:30:30','2022-03-03 13:30:30'),(118005,398,'Mugal Maidan','182205',1,0,'2022-03-03 13:30:30','2022-03-03 13:30:30'),(118006,398,'Mundhar','182147',1,0,'2022-03-03 13:30:30','2022-03-03 13:30:30'),(118007,398,'Nai Bhalara','182201',1,0,'2022-03-03 13:30:30','2022-03-03 13:30:30'),(118008,398,'Neel','182146',1,0,'2022-03-03 13:30:30','2022-03-03 13:30:30'),(118009,398,'Neera','182148',1,0,'2022-03-03 13:30:30','2022-03-03 13:30:30'),(118010,398,'Nodinalla','182203',1,0,'2022-03-03 13:30:30','2022-03-03 13:30:30'),(118011,398,'Nowgam','182146',1,0,'2022-03-03 13:30:30','2022-03-03 13:30:30'),(118012,398,'Nowpachi','182205',1,0,'2022-03-03 13:30:31','2022-03-03 13:30:31'),(118013,398,'Padar','182204',1,0,'2022-03-03 13:30:31','2022-03-03 13:30:31'),(118014,398,'Palmar','182205',1,0,'2022-03-03 13:30:31','2022-03-03 13:30:31'),(118015,398,'Paristan','182145',1,0,'2022-03-03 13:30:31','2022-03-03 13:30:31'),(118016,398,'Pechhal','182204',1,0,'2022-03-03 13:30:31','2022-03-03 13:30:31'),(118017,398,'Peera','182148',1,0,'2022-03-03 13:30:31','2022-03-03 13:30:31'),(118018,398,'Pogal','182145',1,0,'2022-03-03 13:30:31','2022-03-03 13:30:31'),(118019,398,'Porandhar','182146',1,0,'2022-03-03 13:30:31','2022-03-03 13:30:31'),(118020,398,'Premnagar','182201',1,0,'2022-03-03 13:30:31','2022-03-03 13:30:31'),(118021,398,'Ramban Kutchery','182144',1,0,'2022-03-03 13:30:31','2022-03-03 13:30:31'),(118022,398,'Ramban','182144',1,0,'2022-03-03 13:30:31','2022-03-03 13:30:31'),(118023,398,'Ramsu','182145',1,0,'2022-03-03 13:30:31','2022-03-03 13:30:31'),(118024,398,'Ranka','182143',1,0,'2022-03-03 13:30:31','2022-03-03 13:30:31'),(118025,398,'Roat','182201',1,0,'2022-03-03 13:30:31','2022-03-03 13:30:31'),(118026,398,'Rukali','182201',1,0,'2022-03-03 13:30:31','2022-03-03 13:30:31'),(118027,398,'Samthi','182143',1,0,'2022-03-03 13:30:31','2022-03-03 13:30:31'),(118028,398,'Sanasar','182143',1,0,'2022-03-03 13:30:31','2022-03-03 13:30:31'),(118029,398,'Sarthal','182204',1,0,'2022-03-03 13:30:31','2022-03-03 13:30:31'),(118030,398,'Sawni','182148',1,0,'2022-03-03 13:30:31','2022-03-03 13:30:31'),(118031,398,'Shiva','182201',1,0,'2022-03-03 13:30:31','2022-03-03 13:30:31'),(118032,398,'Sidgi','182205',1,0,'2022-03-03 13:30:32','2022-03-03 13:30:32'),(118033,398,'Sindra','182201',1,0,'2022-03-03 13:30:32','2022-03-03 13:30:32'),(118034,398,'Sungli Sartingal','182222',1,0,'2022-03-03 13:30:32','2022-03-03 13:30:32'),(118035,398,'Tagood','182205',1,0,'2022-03-03 13:30:32','2022-03-03 13:30:32'),(118036,398,'Tarigam','182145',1,0,'2022-03-03 13:30:32','2022-03-03 13:30:32'),(118037,398,'Thakrai','182205',1,0,'2022-03-03 13:30:32','2022-03-03 13:30:32'),(118038,398,'Thathar','182146',1,0,'2022-03-03 13:30:32','2022-03-03 13:30:32'),(118039,398,'Thathri','182203',1,0,'2022-03-03 13:30:32','2022-03-03 13:30:32'),(118040,398,'Thopal','182143',1,0,'2022-03-03 13:30:32','2022-03-03 13:30:32'),(118041,398,'Topnel Chuchter','182148',1,0,'2022-03-03 13:30:32','2022-03-03 13:30:32'),(118042,398,'Trewan','182201',1,0,'2022-03-03 13:30:32','2022-03-03 13:30:32'),(118043,398,'Tringla','182143',1,0,'2022-03-03 13:30:32','2022-03-03 13:30:32'),(118044,398,'Trungal','182143',1,0,'2022-03-03 13:30:32','2022-03-03 13:30:32'),(118045,398,'Udrana','182221',1,0,'2022-03-03 13:30:32','2022-03-03 13:30:32'),(118046,398,'Udyanpur','182202',1,0,'2022-03-03 13:30:32','2022-03-03 13:30:32'),(118047,399,'A.G.Office','181121',1,0,'2022-03-03 13:30:32','2022-03-03 13:30:32'),(118048,399,'Abtal','181141',1,0,'2022-03-03 13:30:32','2022-03-03 13:30:32'),(118049,399,'Adlehar','181131',1,0,'2022-03-03 13:30:32','2022-03-03 13:30:32'),(118050,399,'Agra Chak','181102',1,0,'2022-03-03 13:30:32','2022-03-03 13:30:32'),(118051,399,'Aitham','180017',1,0,'2022-03-03 13:30:33','2022-03-03 13:30:33'),(118052,399,'Akalpur','180002',1,0,'2022-03-03 13:30:33','2022-03-03 13:30:33'),(118053,399,'Akhnoor','181201',1,0,'2022-03-03 13:30:33','2022-03-03 13:30:33'),(118054,399,'Allah','181131',1,0,'2022-03-03 13:30:33','2022-03-03 13:30:33'),(118055,399,'Ambaran','181201',1,0,'2022-03-03 13:30:33','2022-03-03 13:30:33'),(118056,399,'Arnia','181131',1,0,'2022-03-03 13:30:33','2022-03-03 13:30:33'),(118057,399,'Badyal Brahmna','181102',1,0,'2022-03-03 13:30:33','2022-03-03 13:30:33'),(118058,399,'Bain Bajalta','180017',1,0,'2022-03-03 13:30:33','2022-03-03 13:30:33'),(118059,399,'Bain Bajalta','180006',1,0,'2022-03-03 13:30:33','2022-03-03 13:30:33'),(118060,399,'Bakore','181202',1,0,'2022-03-03 13:30:33','2022-03-03 13:30:33'),(118061,399,'Bakshinagar','180001',1,0,'2022-03-03 13:30:33','2022-03-03 13:30:33'),(118062,399,'Bala','181201',1,0,'2022-03-03 13:30:33','2022-03-03 13:30:33'),(118063,399,'Bamal Colony','181201',1,0,'2022-03-03 13:30:33','2022-03-03 13:30:33'),(118064,399,'Banachak','181132',1,0,'2022-03-03 13:30:33','2022-03-03 13:30:33'),(118065,399,'Bantalab','181123',1,0,'2022-03-03 13:30:33','2022-03-03 13:30:33'),(118066,399,'Baran','181122',1,0,'2022-03-03 13:30:33','2022-03-03 13:30:33'),(118067,399,'Bardoh','181204',1,0,'2022-03-03 13:30:33','2022-03-03 13:30:33'),(118068,399,'Bari Brahmna I/complex','181133',1,0,'2022-03-03 13:30:33','2022-03-03 13:30:33'),(118069,399,'Bari Brahmna','181133',1,0,'2022-03-03 13:30:33','2022-03-03 13:30:33'),(118070,399,'Barigarh','184121',1,0,'2022-03-03 13:30:33','2022-03-03 13:30:33'),(118071,399,'Batehra','181206',1,0,'2022-03-03 13:30:33','2022-03-03 13:30:33'),(118072,399,'Bathindi','181152',1,0,'2022-03-03 13:30:33','2022-03-03 13:30:33'),(118073,399,'Bhadrod','180002',1,0,'2022-03-03 13:30:34','2022-03-03 13:30:34'),(118074,399,'Bhalwal Brahmna','181202',1,0,'2022-03-03 13:30:34','2022-03-03 13:30:34'),(118075,399,'Bhalwal','181122',1,0,'2022-03-03 13:30:34','2022-03-03 13:30:34'),(118076,399,'Bhatyari','181224',1,0,'2022-03-03 13:30:34','2022-03-03 13:30:34'),(118077,399,'Bhour Camp','181101',1,0,'2022-03-03 13:30:34','2022-03-03 13:30:34'),(118078,399,'Birpur','181133',1,0,'2022-03-03 13:30:34','2022-03-03 13:30:34'),(118079,399,'Bishnah Adda','181132',1,0,'2022-03-03 13:30:34','2022-03-03 13:30:34'),(118080,399,'Bishnah','181132',1,0,'2022-03-03 13:30:34','2022-03-03 13:30:34'),(118081,399,'Brui','181201',1,0,'2022-03-03 13:30:34','2022-03-03 13:30:34'),(118082,399,'Bsf Camp Paloura','181124',1,0,'2022-03-03 13:30:34','2022-03-03 13:30:34'),(118083,399,'Chak Chimna','181141',1,0,'2022-03-03 13:30:34','2022-03-03 13:30:34'),(118084,399,'Chak Kirpalpur','181202',1,0,'2022-03-03 13:30:34','2022-03-03 13:30:34'),(118085,399,'Chak Malal','181203',1,0,'2022-03-03 13:30:34','2022-03-03 13:30:34'),(118086,399,'Chak Salaria','184120',1,0,'2022-03-03 13:30:34','2022-03-03 13:30:34'),(118087,399,'Chak Shama','181206',1,0,'2022-03-03 13:30:34','2022-03-03 13:30:34'),(118088,399,'Chak Umrah','181132',1,0,'2022-03-03 13:30:34','2022-03-03 13:30:34'),(118089,399,'Chakrohi','181102',1,0,'2022-03-03 13:30:34','2022-03-03 13:30:34'),(118090,399,'Chandu Chak','181102',1,0,'2022-03-03 13:30:34','2022-03-03 13:30:34'),(118091,399,'Chani Himat','180015',1,0,'2022-03-03 13:30:34','2022-03-03 13:30:34'),(118092,399,'Chohala','181102',1,0,'2022-03-03 13:30:34','2022-03-03 13:30:34'),(118093,399,'Chowadi','180011',1,0,'2022-03-03 13:30:34','2022-03-03 13:30:34'),(118094,399,'Chowki Choura','185154',1,0,'2022-03-03 13:30:35','2022-03-03 13:30:35'),(118095,399,'Dablehar','181111',1,0,'2022-03-03 13:30:35','2022-03-03 13:30:35'),(118096,399,'Dansal','181224',1,0,'2022-03-03 13:30:35','2022-03-03 13:30:35'),(118097,399,'Danwal','181203',1,0,'2022-03-03 13:30:35','2022-03-03 13:30:35'),(118098,399,'Darap','181132',1,0,'2022-03-03 13:30:35','2022-03-03 13:30:35'),(118099,399,'Datial','181202',1,0,'2022-03-03 13:30:35','2022-03-03 13:30:35'),(118100,399,'Deoli','181132',1,0,'2022-03-03 13:30:35','2022-03-03 13:30:35'),(118101,399,'Devipur','181202',1,0,'2022-03-03 13:30:35','2022-03-03 13:30:35'),(118102,399,'Dhana Dhanean','185154',1,0,'2022-03-03 13:30:35','2022-03-03 13:30:35'),(118103,399,'Dhiani','184121',1,0,'2022-03-03 13:30:35','2022-03-03 13:30:35'),(118104,399,'Dhoke Khalsa','181202',1,0,'2022-03-03 13:30:35','2022-03-03 13:30:35'),(118105,399,'Dhounthly Bazar','180001',1,0,'2022-03-03 13:30:35','2022-03-03 13:30:35'),(118106,399,'Doori Dugar','185154',1,0,'2022-03-03 13:30:35','2022-03-03 13:30:35'),(118107,399,'Dumana','181206',1,0,'2022-03-03 13:30:35','2022-03-03 13:30:35'),(118108,399,'Faloura','181102',1,0,'2022-03-03 13:30:35','2022-03-03 13:30:35'),(118109,399,'Gadigarh','181101',1,0,'2022-03-03 13:30:35','2022-03-03 13:30:35'),(118110,399,'Gajansoo','181206',1,0,'2022-03-03 13:30:35','2022-03-03 13:30:35'),(118111,399,'Gandharwan','181201',1,0,'2022-03-03 13:30:35','2022-03-03 13:30:35'),(118112,399,'Gandhinagar H.O','180004',1,0,'2022-03-03 13:30:35','2022-03-03 13:30:35'),(118113,399,'Gangyal','180010',1,0,'2022-03-03 13:30:35','2022-03-03 13:30:35'),(118114,399,'Garkhal','181206',1,0,'2022-03-03 13:30:36','2022-03-03 13:30:36'),(118115,399,'General Bus Stand (Jammu)','180016',1,0,'2022-03-03 13:30:36','2022-03-03 13:30:36'),(118116,399,'Ghar Majoor','185154',1,0,'2022-03-03 13:30:36','2022-03-03 13:30:36'),(118117,399,'Gharana','181102',1,0,'2022-03-03 13:30:36','2022-03-03 13:30:36'),(118118,399,'Gharatal','181201',1,0,'2022-03-03 13:30:36','2022-03-03 13:30:36'),(118119,399,'Gharota','181122',1,0,'2022-03-03 13:30:36','2022-03-03 13:30:36'),(118120,399,'Gho Manhasan','181206',1,0,'2022-03-03 13:30:36','2022-03-03 13:30:36'),(118121,399,'Gigrial','181203',1,0,'2022-03-03 13:30:36','2022-03-03 13:30:36'),(118122,399,'Gol Gujral','180002',1,0,'2022-03-03 13:30:36','2022-03-03 13:30:36'),(118123,399,'Goondla','181111',1,0,'2022-03-03 13:30:36','2022-03-03 13:30:36'),(118124,399,'Goran','184121',1,0,'2022-03-03 13:30:36','2022-03-03 13:30:36'),(118125,399,'Greater Kailash','180011',1,0,'2022-03-03 13:30:36','2022-03-03 13:30:36'),(118126,399,'Guo Brahmna','184120',1,0,'2022-03-03 13:30:36','2022-03-03 13:30:36'),(118127,399,'Gura Manhasan','181207',1,0,'2022-03-03 13:30:36','2022-03-03 13:30:36'),(118128,399,'Gurah Salathia','181143',1,0,'2022-03-03 13:30:36','2022-03-03 13:30:36'),(118129,399,'Gurha Brahmna','181201',1,0,'2022-03-03 13:30:36','2022-03-03 13:30:36'),(118130,399,'Guru Nanak Nagar (Jammu)','180004',1,0,'2022-03-03 13:30:36','2022-03-03 13:30:36'),(118131,399,'Halqa','181206',1,0,'2022-03-03 13:30:36','2022-03-03 13:30:36'),(118132,399,'Hamirpur Sidhar','181203',1,0,'2022-03-03 13:30:36','2022-03-03 13:30:36'),(118133,399,'Industrial Estate (Jammu)','180003',1,0,'2022-03-03 13:30:36','2022-03-03 13:30:36'),(118134,399,'J.Kotli','181221',1,0,'2022-03-03 13:30:36','2022-03-03 13:30:36'),(118135,399,'J.N.V. Nud','184121',1,0,'2022-03-03 13:30:37','2022-03-03 13:30:37'),(118136,399,'Jagti','181221',1,0,'2022-03-03 13:30:37','2022-03-03 13:30:37'),(118137,399,'Jakh','184120',1,0,'2022-03-03 13:30:37','2022-03-03 13:30:37'),(118138,399,'Jammu Cantt','180003',1,0,'2022-03-03 13:30:37','2022-03-03 13:30:37'),(118139,399,'Jammu H.O','180001',1,0,'2022-03-03 13:30:37','2022-03-03 13:30:37'),(118140,399,'Jammu Market','180001',1,0,'2022-03-03 13:30:37','2022-03-03 13:30:37'),(118141,399,'Jandial','181122',1,0,'2022-03-03 13:30:37','2022-03-03 13:30:37'),(118142,399,'Janipur High Court','180007',1,0,'2022-03-03 13:30:37','2022-03-03 13:30:37'),(118143,399,'Janipur','180007',1,0,'2022-03-03 13:30:37','2022-03-03 13:30:37'),(118144,399,'Jassore','181102',1,0,'2022-03-03 13:30:37','2022-03-03 13:30:37'),(118145,399,'Jindrah','181224',1,0,'2022-03-03 13:30:37','2022-03-03 13:30:37'),(118146,399,'Jourian','181202',1,0,'2022-03-03 13:30:37','2022-03-03 13:30:37'),(118147,399,'Kachi Chowni','180001',1,0,'2022-03-03 13:30:37','2022-03-03 13:30:37'),(118148,399,'Kaink Jagir','181201',1,0,'2022-03-03 13:30:37','2022-03-03 13:30:37'),(118149,399,'Kaleetg','181203',1,0,'2022-03-03 13:30:37','2022-03-03 13:30:37'),(118150,399,'Kalibari','184121',1,0,'2022-03-03 13:30:37','2022-03-03 13:30:37'),(118151,399,'Kalu Chak','180010',1,0,'2022-03-03 13:30:37','2022-03-03 13:30:37'),(118152,399,'Kalyana','181131',1,0,'2022-03-03 13:30:37','2022-03-03 13:30:37'),(118153,399,'Kanachak','181206',1,0,'2022-03-03 13:30:37','2022-03-03 13:30:37'),(118154,399,'Kanachirgal','180017',1,0,'2022-03-03 13:30:37','2022-03-03 13:30:37'),(118155,399,'Kandoli Nagrota','181221',1,0,'2022-03-03 13:30:38','2022-03-03 13:30:38'),(118156,399,'Kangrial','181206',1,0,'2022-03-03 13:30:38','2022-03-03 13:30:38'),(118157,399,'Kanhal','181132',1,0,'2022-03-03 13:30:38','2022-03-03 13:30:38'),(118158,399,'Kanyala','181224',1,0,'2022-03-03 13:30:38','2022-03-03 13:30:38'),(118159,399,'Karan Nagar (Jammu)','180005',1,0,'2022-03-03 13:30:38','2022-03-03 13:30:38'),(118160,399,'Karloop','181206',1,0,'2022-03-03 13:30:38','2022-03-03 13:30:38'),(118161,399,'Kathar','181201',1,0,'2022-03-03 13:30:38','2022-03-03 13:30:38'),(118162,399,'Kesomanhasan','181141',1,0,'2022-03-03 13:30:38','2022-03-03 13:30:38'),(118163,399,'Khara Madana','181145',1,0,'2022-03-03 13:30:38','2022-03-03 13:30:38'),(118164,399,'Kharah','181203',1,0,'2022-03-03 13:30:38','2022-03-03 13:30:38'),(118165,399,'Kheri','181132',1,0,'2022-03-03 13:30:38','2022-03-03 13:30:38'),(118166,399,'Khour Devian','181101',1,0,'2022-03-03 13:30:38','2022-03-03 13:30:38'),(118167,399,'Khour','181203',1,0,'2022-03-03 13:30:38','2022-03-03 13:30:38'),(118168,399,'Kirpind','181101',1,0,'2022-03-03 13:30:38','2022-03-03 13:30:38'),(118169,399,'Kishanpur','181224',1,0,'2022-03-03 13:30:38','2022-03-03 13:30:38'),(118170,399,'Kool Kalan','181131',1,0,'2022-03-03 13:30:38','2022-03-03 13:30:38'),(118171,399,'Kot','181122',1,0,'2022-03-03 13:30:38','2022-03-03 13:30:38'),(118172,399,'Kot Maira','181204',1,0,'2022-03-03 13:30:38','2022-03-03 13:30:38'),(118173,399,'Kothar','181224',1,0,'2022-03-03 13:30:38','2022-03-03 13:30:38'),(118174,399,'Kotli Colony','180005',1,0,'2022-03-03 13:30:38','2022-03-03 13:30:38'),(118175,399,'Kotli Mian Fateh','181132',1,0,'2022-03-03 13:30:38','2022-03-03 13:30:38'),(118176,399,'Kotlishah Daula','181102',1,0,'2022-03-03 13:30:38','2022-03-03 13:30:38'),(118177,399,'Koulpur','184120',1,0,'2022-03-03 13:30:38','2022-03-03 13:30:38'),(118178,399,'Krishna Nagar (Jammu)','180016',1,0,'2022-03-03 13:30:39','2022-03-03 13:30:39'),(118179,399,'Langotian','181101',1,0,'2022-03-03 13:30:39','2022-03-03 13:30:39'),(118180,399,'Lehar','181201',1,0,'2022-03-03 13:30:39','2022-03-03 13:30:39'),(118181,399,'Magowali','181111',1,0,'2022-03-03 13:30:39','2022-03-03 13:30:39'),(118182,399,'Maira','181202',1,0,'2022-03-03 13:30:39','2022-03-03 13:30:39'),(118183,399,'Majeen','180017',1,0,'2022-03-03 13:30:39','2022-03-03 13:30:39'),(118184,399,'Makwal','180003',1,0,'2022-03-03 13:30:39','2022-03-03 13:30:39'),(118185,399,'Mandal','181145',1,0,'2022-03-03 13:30:39','2022-03-03 13:30:39'),(118186,399,'Mandal','180003',1,0,'2022-03-03 13:30:39','2022-03-03 13:30:39'),(118187,399,'Mandarian','181201',1,0,'2022-03-03 13:30:39','2022-03-03 13:30:39'),(118188,399,'Mansar','184121',1,0,'2022-03-03 13:30:39','2022-03-03 13:30:39'),(118189,399,'Mawa Brahmna','181201',1,0,'2022-03-03 13:30:39','2022-03-03 13:30:39'),(118190,399,'Meghdoot Bhawan','180012',1,0,'2022-03-03 13:30:39','2022-03-03 13:30:39'),(118191,399,'Miran Sahib','181101',1,0,'2022-03-03 13:30:39','2022-03-03 13:30:39'),(118192,399,'Misriwala','181206',1,0,'2022-03-03 13:30:39','2022-03-03 13:30:39'),(118193,399,'Mubarak Mandi','180001',1,0,'2022-03-03 13:30:39','2022-03-03 13:30:39'),(118194,399,'Muthi','181205',1,0,'2022-03-03 13:30:39','2022-03-03 13:30:39'),(118195,399,'Nadore','181221',1,0,'2022-03-03 13:30:39','2022-03-03 13:30:39'),(118196,399,'Nagbani','181206',1,0,'2022-03-03 13:30:39','2022-03-03 13:30:39'),(118197,399,'Nai Kali','184121',1,0,'2022-03-03 13:30:39','2022-03-03 13:30:39'),(118198,399,'Nanak Chak','184121',1,0,'2022-03-03 13:30:40','2022-03-03 13:30:40'),(118199,399,'Nandpur','181141',1,0,'2022-03-03 13:30:40','2022-03-03 13:30:40'),(118200,399,'Nanga','181141',1,0,'2022-03-03 13:30:40','2022-03-03 13:30:40'),(118201,399,'Naryana','181203',1,0,'2022-03-03 13:30:40','2022-03-03 13:30:40'),(118202,399,'NATC','180003',1,0,'2022-03-03 13:30:40','2022-03-03 13:30:40'),(118203,399,'Nathal','181203',1,0,'2022-03-03 13:30:40','2022-03-03 13:30:40'),(118204,399,'New Fruit Market','180012',1,0,'2022-03-03 13:30:40','2022-03-03 13:30:40'),(118205,399,'New Fruit Market','180006',1,0,'2022-03-03 13:30:40','2022-03-03 13:30:40'),(118206,399,'New Secretariat Jammu','180001',1,0,'2022-03-03 13:30:40','2022-03-03 13:30:40'),(118207,399,'New University Campus','180006',1,0,'2022-03-03 13:30:40','2022-03-03 13:30:40'),(118208,399,'Nikkian','181203',1,0,'2022-03-03 13:30:40','2022-03-03 13:30:40'),(118209,399,'O.H.Road','180001',1,0,'2022-03-03 13:30:40','2022-03-03 13:30:40'),(118210,399,'Pacca Danga Akhnoor','181201',1,0,'2022-03-03 13:30:40','2022-03-03 13:30:40'),(118211,399,'Pallanwala','181204',1,0,'2022-03-03 13:30:40','2022-03-03 13:30:40'),(118212,399,'Palli','181132',1,0,'2022-03-03 13:30:40','2022-03-03 13:30:40'),(118213,399,'Paloura','181121',1,0,'2022-03-03 13:30:40','2022-03-03 13:30:40'),(118214,399,'Pandorian Manhasan','181132',1,0,'2022-03-03 13:30:40','2022-03-03 13:30:40'),(118215,399,'Pangdour','184121',1,0,'2022-03-03 13:30:40','2022-03-03 13:30:40'),(118216,399,'Panjgrain','181221',1,0,'2022-03-03 13:30:40','2022-03-03 13:30:40'),(118217,399,'Pargwal','181207',1,0,'2022-03-03 13:30:40','2022-03-03 13:30:40'),(118218,399,'Parlah','181131',1,0,'2022-03-03 13:30:41','2022-03-03 13:30:41'),(118219,399,'Paryal','181206',1,0,'2022-03-03 13:30:41','2022-03-03 13:30:41'),(118220,399,'Peermitha','180001',1,0,'2022-03-03 13:30:41','2022-03-03 13:30:41'),(118221,399,'Pindicharka Kalan','181131',1,0,'2022-03-03 13:30:41','2022-03-03 13:30:41'),(118222,399,'Puran Nagar','180005',1,0,'2022-03-03 13:30:41','2022-03-03 13:30:41'),(118223,399,'Purmandal','181145',1,0,'2022-03-03 13:30:41','2022-03-03 13:30:41'),(118224,399,'Qilla Bahu','180006',1,0,'2022-03-03 13:30:41','2022-03-03 13:30:41'),(118225,399,'R.N.Bazar','180001',1,0,'2022-03-03 13:30:41','2022-03-03 13:30:41'),(118226,399,'R.S.Pura Adda','181102',1,0,'2022-03-03 13:30:41','2022-03-03 13:30:41'),(118227,399,'R.S.Pura','181102',1,0,'2022-03-03 13:30:41','2022-03-03 13:30:41'),(118228,399,'Rabta','181122',1,0,'2022-03-03 13:30:41','2022-03-03 13:30:41'),(118229,399,'Rahya','181143',1,0,'2022-03-03 13:30:41','2022-03-03 13:30:41'),(118230,399,'Raika','184120',1,0,'2022-03-03 13:30:41','2022-03-03 13:30:41'),(118231,399,'Railway Station','180012',1,0,'2022-03-03 13:30:41','2022-03-03 13:30:41'),(118232,399,'Raipur','181123',1,0,'2022-03-03 13:30:41','2022-03-03 13:30:41'),(118233,399,'Rajinderpura','181143',1,0,'2022-03-03 13:30:41','2022-03-03 13:30:41'),(118234,399,'Ramgarh (Jammu)','181141',1,0,'2022-03-03 13:30:41','2022-03-03 13:30:41'),(118235,399,'Rangpur Malania','181102',1,0,'2022-03-03 13:30:41','2022-03-03 13:30:41'),(118236,399,'Rangpur Trewa','181131',1,0,'2022-03-03 13:30:41','2022-03-03 13:30:41'),(118237,399,'Ranjan','181122',1,0,'2022-03-03 13:30:41','2022-03-03 13:30:41'),(118238,399,'Rathana','181111',1,0,'2022-03-03 13:30:41','2022-03-03 13:30:41'),(118239,399,'Rattisn','181101',1,0,'2022-03-03 13:30:42','2022-03-03 13:30:42'),(118240,399,'Rehal','181132',1,0,'2022-03-03 13:30:42','2022-03-03 13:30:42'),(118241,399,'Rehari Mohalla','180005',1,0,'2022-03-03 13:30:42','2022-03-03 13:30:42'),(118242,399,'Rehiyan','184121',1,0,'2022-03-03 13:30:42','2022-03-03 13:30:42'),(118243,399,'Roopnagar Jammu Tawi','180013',1,0,'2022-03-03 13:30:42','2022-03-03 13:30:42'),(118244,399,'Sadhoti','185154',1,0,'2022-03-03 13:30:42','2022-03-03 13:30:42'),(118245,399,'Sai Kalan','181131',1,0,'2022-03-03 13:30:42','2022-03-03 13:30:42'),(118246,399,'Sainik Colony','180011',1,0,'2022-03-03 13:30:42','2022-03-03 13:30:42'),(118247,399,'Sainth','181203',1,0,'2022-03-03 13:30:42','2022-03-03 13:30:42'),(118248,399,'Salehar','181111',1,0,'2022-03-03 13:30:42','2022-03-03 13:30:42'),(118249,399,'Samba Adda','184121',1,0,'2022-03-03 13:30:42','2022-03-03 13:30:42'),(118250,399,'Samba','184121',1,0,'2022-03-03 13:30:42','2022-03-03 13:30:42'),(118251,399,'Sangrampur','180002',1,0,'2022-03-03 13:30:42','2022-03-03 13:30:42'),(118252,399,'Sanjwan','184120',1,0,'2022-03-03 13:30:42','2022-03-03 13:30:42'),(118253,399,'Sarna','184121',1,0,'2022-03-03 13:30:42','2022-03-03 13:30:42'),(118254,399,'Sarore','181133',1,0,'2022-03-03 13:30:42','2022-03-03 13:30:42'),(118255,399,'Sarote','181122',1,0,'2022-03-03 13:30:42','2022-03-03 13:30:42'),(118256,399,'Satrayan','181102',1,0,'2022-03-03 13:30:42','2022-03-03 13:30:42'),(118257,399,'Seri Panditan','181122',1,0,'2022-03-03 13:30:42','2022-03-03 13:30:42'),(118258,399,'Shaheedi Chowk Jammu','180001',1,0,'2022-03-03 13:30:42','2022-03-03 13:30:42'),(118259,399,'Shaktinagar Jammu','180001',1,0,'2022-03-03 13:30:43','2022-03-03 13:30:43'),(118260,399,'Shamka','181102',1,0,'2022-03-03 13:30:43','2022-03-03 13:30:43'),(118261,399,'Shiba','181221',1,0,'2022-03-03 13:30:43','2022-03-03 13:30:43'),(118262,399,'Sidhra Housing Colony','180019',1,0,'2022-03-03 13:30:43','2022-03-03 13:30:43'),(118263,399,'Simble Camp','181101',1,0,'2022-03-03 13:30:43','2022-03-03 13:30:43'),(118264,399,'SKUAST(CHATHA)','180009',1,0,'2022-03-03 13:30:43','2022-03-03 13:30:43'),(118265,399,'Smailpur','181133',1,0,'2022-03-03 13:30:43','2022-03-03 13:30:43'),(118266,399,'Sohanjana','180003',1,0,'2022-03-03 13:30:43','2022-03-03 13:30:43'),(118267,399,'Subash Nagar Jammu','180005',1,0,'2022-03-03 13:30:43','2022-03-03 13:30:43'),(118268,399,'Suchetgarh','181102',1,0,'2022-03-03 13:30:43','2022-03-03 13:30:43'),(118269,399,'Sumb','184121',1,0,'2022-03-03 13:30:43','2022-03-03 13:30:43'),(118270,399,'Sungal','181201',1,0,'2022-03-03 13:30:43','2022-03-03 13:30:43'),(118271,399,'Sunjwan','180011',1,0,'2022-03-03 13:30:43','2022-03-03 13:30:43'),(118272,399,'Surinsar','180017',1,0,'2022-03-03 13:30:43','2022-03-03 13:30:43'),(118273,399,'Suryavihar','180002',1,0,'2022-03-03 13:30:43','2022-03-03 13:30:43'),(118274,399,'Swankha','184120',1,0,'2022-03-03 13:30:43','2022-03-03 13:30:43'),(118275,399,'Tahra','181224',1,0,'2022-03-03 13:30:43','2022-03-03 13:30:43'),(118276,399,'Talab Tillo','180002',1,0,'2022-03-03 13:30:43','2022-03-03 13:30:43'),(118277,399,'Talhar','181131',1,0,'2022-03-03 13:30:43','2022-03-03 13:30:43'),(118278,399,'Taloor','184121',1,0,'2022-03-03 13:30:43','2022-03-03 13:30:43'),(118279,399,'Tarore','181133',1,0,'2022-03-03 13:30:43','2022-03-03 13:30:43'),(118280,399,'Topsherkhania','181121',1,0,'2022-03-03 13:30:43','2022-03-03 13:30:43'),(118281,399,'Transport Yard','180004',1,0,'2022-03-03 13:30:44','2022-03-03 13:30:44'),(118282,399,'Trikuta Nagar','180020',1,0,'2022-03-03 13:30:44','2022-03-03 13:30:44'),(118283,399,'Udheywala','180018',1,0,'2022-03-03 13:30:44','2022-03-03 13:30:44'),(118284,399,'Utter Behni','181145',1,0,'2022-03-03 13:30:44','2022-03-03 13:30:44'),(118285,399,'Vijaypur','184120',1,0,'2022-03-03 13:30:44','2022-03-03 13:30:44'),(118286,399,'Vinaik Bazar','180016',1,0,'2022-03-03 13:30:44','2022-03-03 13:30:44'),(118287,400,'Akchamal','194103',1,0,'2022-03-03 13:30:44','2022-03-03 13:30:44'),(118288,400,'Baroo','194105',1,0,'2022-03-03 13:30:44','2022-03-03 13:30:44'),(118289,400,'Barsoo','194301',1,0,'2022-03-03 13:30:44','2022-03-03 13:30:44'),(118290,400,'Batalik','194103',1,0,'2022-03-03 13:30:44','2022-03-03 13:30:44'),(118291,400,'Bhimbat','194102',1,0,'2022-03-03 13:30:44','2022-03-03 13:30:44'),(118292,400,'Bodhkharboo','194109',1,0,'2022-03-03 13:30:44','2022-03-03 13:30:44'),(118293,400,'Chanigund','194103',1,0,'2022-03-03 13:30:44','2022-03-03 13:30:44'),(118294,400,'Chiktan','194109',1,0,'2022-03-03 13:30:44','2022-03-03 13:30:44'),(118295,400,'Chokiyal','194102',1,0,'2022-03-03 13:30:44','2022-03-03 13:30:44'),(118296,400,'Choskor','194105',1,0,'2022-03-03 13:30:44','2022-03-03 13:30:44'),(118297,400,'Drass','194102',1,0,'2022-03-03 13:30:44','2022-03-03 13:30:44'),(118298,400,'Garkon','194103',1,0,'2022-03-03 13:30:44','2022-03-03 13:30:44'),(118299,400,'Hardas','194103',1,0,'2022-03-03 13:30:44','2022-03-03 13:30:44'),(118300,400,'Karamba','194109',1,0,'2022-03-03 13:30:44','2022-03-03 13:30:44'),(118301,400,'Kargil','194103',1,0,'2022-03-03 13:30:44','2022-03-03 13:30:44'),(118302,400,'Karkitchoo','194103',1,0,'2022-03-03 13:30:45','2022-03-03 13:30:45'),(118303,400,'Karsha','194302',1,0,'2022-03-03 13:30:45','2022-03-03 13:30:45'),(118304,400,'Khasgam Thuina','194301',1,0,'2022-03-03 13:30:45','2022-03-03 13:30:45'),(118305,400,'Lankarchey','194301',1,0,'2022-03-03 13:30:45','2022-03-03 13:30:45'),(118306,400,'Lochum','194109',1,0,'2022-03-03 13:30:45','2022-03-03 13:30:45'),(118307,400,'Matayan','194102',1,0,'2022-03-03 13:30:45','2022-03-03 13:30:45'),(118308,400,'Minji','194105',1,0,'2022-03-03 13:30:45','2022-03-03 13:30:45'),(118309,400,'Mulbek','194109',1,0,'2022-03-03 13:30:45','2022-03-03 13:30:45'),(118310,400,'Mushkoo','194102',1,0,'2022-03-03 13:30:45','2022-03-03 13:30:45'),(118311,400,'Namsuru','194301',1,0,'2022-03-03 13:30:45','2022-03-03 13:30:45'),(118312,400,'Omba','194301',1,0,'2022-03-03 13:30:45','2022-03-03 13:30:45'),(118313,400,'Padum','194302',1,0,'2022-03-03 13:30:45','2022-03-03 13:30:45'),(118314,400,'Pandrass','194102',1,0,'2022-03-03 13:30:45','2022-03-03 13:30:45'),(118315,400,'Panikhar','194301',1,0,'2022-03-03 13:30:45','2022-03-03 13:30:45'),(118316,400,'Panikhar','194403',1,0,'2022-03-03 13:30:45','2022-03-03 13:30:45'),(118317,400,'Parkachik','194301',1,0,'2022-03-03 13:30:45','2022-03-03 13:30:45'),(118318,400,'Pashkum','194103',1,0,'2022-03-03 13:30:45','2022-03-03 13:30:45'),(118319,400,'Purthikchey','194301',1,0,'2022-03-03 13:30:46','2022-03-03 13:30:46'),(118320,400,'Safi','194109',1,0,'2022-03-03 13:30:46','2022-03-03 13:30:46'),(118321,400,'Saliskot','194105',1,0,'2022-03-03 13:30:46','2022-03-03 13:30:46'),(118322,400,'Samray','194109',1,0,'2022-03-03 13:30:46','2022-03-03 13:30:46'),(118323,400,'Sangra','194301',1,0,'2022-03-03 13:30:46','2022-03-03 13:30:46'),(118324,400,'Sankoo','194301',1,0,'2022-03-03 13:30:46','2022-03-03 13:30:46'),(118325,400,'Shaimshakharboo','194103',1,0,'2022-03-03 13:30:46','2022-03-03 13:30:46'),(118326,400,'Shakar','194109',1,0,'2022-03-03 13:30:46','2022-03-03 13:30:46'),(118327,400,'Shargol','194109',1,0,'2022-03-03 13:30:46','2022-03-03 13:30:46'),(118328,400,'Silmoh','194103',1,0,'2022-03-03 13:30:46','2022-03-03 13:30:46'),(118329,400,'Tache','194109',1,0,'2022-03-03 13:30:46','2022-03-03 13:30:46'),(118330,400,'Tambis','194105',1,0,'2022-03-03 13:30:46','2022-03-03 13:30:46'),(118331,400,'Thasgam','194103',1,0,'2022-03-03 13:30:46','2022-03-03 13:30:46'),(118332,400,'Tikat','194301',1,0,'2022-03-03 13:30:46','2022-03-03 13:30:46'),(118333,400,'Trespon','194105',1,0,'2022-03-03 13:30:46','2022-03-03 13:30:46'),(118334,400,'Tumail','194103',1,0,'2022-03-03 13:30:46','2022-03-03 13:30:46'),(118335,400,'Tumail Colony','194103',1,0,'2022-03-03 13:30:46','2022-03-03 13:30:46'),(118336,400,'Wakha','194109',1,0,'2022-03-03 13:30:46','2022-03-03 13:30:46'),(118337,400,'Yuljuk','194301',1,0,'2022-03-03 13:30:46','2022-03-03 13:30:46'),(118338,400,'Yurbaltik','194103',1,0,'2022-03-03 13:30:46','2022-03-03 13:30:46'),(118339,400,'Zangla','194302',1,0,'2022-03-03 13:30:46','2022-03-03 13:30:46'),(118340,401,'Airwan','184151',1,0,'2022-03-03 13:30:47','2022-03-03 13:30:47'),(118341,401,'Amla','184144',1,0,'2022-03-03 13:30:47','2022-03-03 13:30:47'),(118342,401,'Babey','184205',1,0,'2022-03-03 13:30:47','2022-03-03 13:30:47'),(118343,401,'Babia','184148',1,0,'2022-03-03 13:30:47','2022-03-03 13:30:47'),(118344,401,'Badnote','184204',1,0,'2022-03-03 13:30:47','2022-03-03 13:30:47'),(118345,401,'Baggan','184204',1,0,'2022-03-03 13:30:47','2022-03-03 13:30:47'),(118346,401,'Bandhar','184206',1,0,'2022-03-03 13:30:47','2022-03-03 13:30:47'),(118347,401,'Banhore','184202',1,0,'2022-03-03 13:30:47','2022-03-03 13:30:47'),(118348,401,'Bani (Kathua)','184206',1,0,'2022-03-03 13:30:47','2022-03-03 13:30:47'),(118349,401,'Banjal','184201',1,0,'2022-03-03 13:30:47','2022-03-03 13:30:47'),(118350,401,'Barnote','184143',1,0,'2022-03-03 13:30:47','2022-03-03 13:30:47'),(118351,401,'Barotta','184203',1,0,'2022-03-03 13:30:47','2022-03-03 13:30:47'),(118352,401,'Barwal','184143',1,0,'2022-03-03 13:30:47','2022-03-03 13:30:47'),(118353,401,'Basantpur','184152',1,0,'2022-03-03 13:30:47','2022-03-03 13:30:47'),(118354,401,'Basoli','184201',1,0,'2022-03-03 13:30:47','2022-03-03 13:30:47'),(118355,401,'Bathodi Duggan','184203',1,0,'2022-03-03 13:30:47','2022-03-03 13:30:47'),(118356,401,'Beradhani','184143',1,0,'2022-03-03 13:30:47','2022-03-03 13:30:47'),(118357,401,'Bhaddu','184203',1,0,'2022-03-03 13:30:48','2022-03-03 13:30:48'),(118358,401,'Bhoond','184201',1,0,'2022-03-03 13:30:48','2022-03-03 13:30:48'),(118359,401,'Billawar','184204',1,0,'2022-03-03 13:30:48','2022-03-03 13:30:48'),(118360,401,'Budhi','184143',1,0,'2022-03-03 13:30:48','2022-03-03 13:30:48'),(118361,401,'Chadwal','184144',1,0,'2022-03-03 13:30:48','2022-03-03 13:30:48'),(118362,401,'Chakra','184148',1,0,'2022-03-03 13:30:48','2022-03-03 13:30:48'),(118363,401,'Chalog','184206',1,0,'2022-03-03 13:30:48','2022-03-03 13:30:48'),(118364,401,'Chandwan','184144',1,0,'2022-03-03 13:30:48','2022-03-03 13:30:48'),(118365,401,'Changran','184104',1,0,'2022-03-03 13:30:48','2022-03-03 13:30:48'),(118366,401,'Chann Rorian','184144',1,0,'2022-03-03 13:30:48','2022-03-03 13:30:48'),(118367,401,'Chhapaki Kalan','184144',1,0,'2022-03-03 13:30:48','2022-03-03 13:30:48'),(118368,401,'Chiliari','184145',1,0,'2022-03-03 13:30:48','2022-03-03 13:30:48'),(118369,401,'Daggar','184206',1,0,'2022-03-03 13:30:48','2022-03-03 13:30:48'),(118370,401,'Dhamal','184144',1,0,'2022-03-03 13:30:48','2022-03-03 13:30:48'),(118371,401,'Dhar Dugnoo','184204',1,0,'2022-03-03 13:30:48','2022-03-03 13:30:48'),(118372,401,'Dhar Mahanpur','184202',1,0,'2022-03-03 13:30:48','2022-03-03 13:30:48'),(118373,401,'Dharalta','184203',1,0,'2022-03-03 13:30:48','2022-03-03 13:30:48'),(118374,401,'Dialachak','184144',1,0,'2022-03-03 13:30:48','2022-03-03 13:30:48'),(118375,401,'Dilwan','184102',1,0,'2022-03-03 13:30:48','2022-03-03 13:30:48'),(118376,401,'Dinga Amb','184144',1,0,'2022-03-03 13:30:48','2022-03-03 13:30:48'),(118377,401,'Draman','184201',1,0,'2022-03-03 13:30:48','2022-03-03 13:30:48'),(118378,401,'Duggan','184206',1,0,'2022-03-03 13:30:48','2022-03-03 13:30:48'),(118379,401,'Dulangal','184206',1,0,'2022-03-03 13:30:49','2022-03-03 13:30:49'),(118380,401,'Durang','184203',1,0,'2022-03-03 13:30:49','2022-03-03 13:30:49'),(118381,401,'Farnot','184201',1,0,'2022-03-03 13:30:49','2022-03-03 13:30:49'),(118382,401,'Fatehpur','184206',1,0,'2022-03-03 13:30:49','2022-03-03 13:30:49'),(118383,401,'Flote','184143',1,0,'2022-03-03 13:30:49','2022-03-03 13:30:49'),(118384,401,'Galak','184205',1,0,'2022-03-03 13:30:49','2022-03-03 13:30:49'),(118385,401,'Garha Satura','184142',1,0,'2022-03-03 13:30:49','2022-03-03 13:30:49'),(118386,401,'Ghagwal','184141',1,0,'2022-03-03 13:30:49','2022-03-03 13:30:49'),(118387,401,'Ghatti','184143',1,0,'2022-03-03 13:30:49','2022-03-03 13:30:49'),(118388,401,'Gitti','184206',1,0,'2022-03-03 13:30:49','2022-03-03 13:30:49'),(118389,401,'Govindasr','184102',1,0,'2022-03-03 13:30:49','2022-03-03 13:30:49'),(118390,401,'Gurah Kalyal','184203',1,0,'2022-03-03 13:30:49','2022-03-03 13:30:49'),(118391,401,'Gurah Mundian','184142',1,0,'2022-03-03 13:30:49','2022-03-03 13:30:49'),(118392,401,'Hamirpur','184144',1,0,'2022-03-03 13:30:49','2022-03-03 13:30:49'),(118393,401,'Haripur Patil','184148',1,0,'2022-03-03 13:30:49','2022-03-03 13:30:49'),(118394,401,'Hatli','184152',1,0,'2022-03-03 13:30:49','2022-03-03 13:30:49'),(118395,401,'Hiranagar','184142',1,0,'2022-03-03 13:30:49','2022-03-03 13:30:49'),(118396,401,'Hutt','184201',1,0,'2022-03-03 13:30:49','2022-03-03 13:30:49'),(118397,401,'Huttar','184204',1,0,'2022-03-03 13:30:49','2022-03-03 13:30:49'),(118398,401,'I/e Kathua','184102',1,0,'2022-03-03 13:30:49','2022-03-03 13:30:49'),(118399,401,'Jakhbar','184104',1,0,'2022-03-03 13:30:49','2022-03-03 13:30:49'),(118400,401,'Jandi','184142',1,0,'2022-03-03 13:30:49','2022-03-03 13:30:49'),(118401,401,'Jandrota','184201',1,0,'2022-03-03 13:30:50','2022-03-03 13:30:50'),(118402,401,'Janglote','184104',1,0,'2022-03-03 13:30:50','2022-03-03 13:30:50'),(118403,401,'Jarai','184102',1,0,'2022-03-03 13:30:50','2022-03-03 13:30:50'),(118404,401,'Jasrota','184143',1,0,'2022-03-03 13:30:50','2022-03-03 13:30:50'),(118405,401,'Jatwal','184141',1,0,'2022-03-03 13:30:50','2022-03-03 13:30:50'),(118406,401,'Kahna Chack','184148',1,0,'2022-03-03 13:30:50','2022-03-03 13:30:50'),(118407,401,'Kanthal','184206',1,0,'2022-03-03 13:30:50','2022-03-03 13:30:50'),(118408,401,'Karanwara','184202',1,0,'2022-03-03 13:30:50','2022-03-03 13:30:50'),(118409,401,'Karroh','184152',1,0,'2022-03-03 13:30:50','2022-03-03 13:30:50'),(118410,401,'Kathua H.O','184101',1,0,'2022-03-03 13:30:50','2022-03-03 13:30:50'),(118411,401,'Katli','184144',1,0,'2022-03-03 13:30:50','2022-03-03 13:30:50'),(118412,401,'Khanpur','184148',1,0,'2022-03-03 13:30:50','2022-03-03 13:30:50'),(118413,401,'Kharote','184102',1,0,'2022-03-03 13:30:50','2022-03-03 13:30:50'),(118414,401,'Khokhial','184151',1,0,'2022-03-03 13:30:50','2022-03-03 13:30:50'),(118415,401,'Kirian Gandial','184152',1,0,'2022-03-03 13:30:50','2022-03-03 13:30:50'),(118416,401,'Kishanpur-I','184204',1,0,'2022-03-03 13:30:50','2022-03-03 13:30:50'),(118417,401,'Kishanpur-II','184203',1,0,'2022-03-03 13:30:50','2022-03-03 13:30:50'),(118418,401,'Kohag','184203',1,0,'2022-03-03 13:30:50','2022-03-03 13:30:50'),(118419,401,'Kothera','184104',1,0,'2022-03-03 13:30:50','2022-03-03 13:30:50'),(118420,401,'Kotpunnu','184151',1,0,'2022-03-03 13:30:50','2022-03-03 13:30:50'),(118421,401,'Krishnanagar','184102',1,0,'2022-03-03 13:30:50','2022-03-03 13:30:50'),(118422,401,'Lahari','184203',1,0,'2022-03-03 13:30:50','2022-03-03 13:30:50'),(118423,401,'Lakhanpur (Kathua)','184152',1,0,'2022-03-03 13:30:51','2022-03-03 13:30:51'),(118424,401,'Lakhri','184205',1,0,'2022-03-03 13:30:51','2022-03-03 13:30:51'),(118425,401,'Logate','184104',1,0,'2022-03-03 13:30:51','2022-03-03 13:30:51'),(118426,401,'Lowang','184206',1,0,'2022-03-03 13:30:51','2022-03-03 13:30:51'),(118427,401,'Machhedi','184204',1,0,'2022-03-03 13:30:51','2022-03-03 13:30:51'),(118428,401,'Maghloor','184144',1,0,'2022-03-03 13:30:51','2022-03-03 13:30:51'),(118429,401,'Mah','184152',1,0,'2022-03-03 13:30:51','2022-03-03 13:30:51'),(118430,401,'Mahanpur','184202',1,0,'2022-03-03 13:30:51','2022-03-03 13:30:51'),(118431,401,'Malhar','184204',1,0,'2022-03-03 13:30:51','2022-03-03 13:30:51'),(118432,401,'Malti','184204',1,0,'2022-03-03 13:30:51','2022-03-03 13:30:51'),(118433,401,'Mandli','184203',1,0,'2022-03-03 13:30:51','2022-03-03 13:30:51'),(118434,401,'Marapatti','184202',1,0,'2022-03-03 13:30:51','2022-03-03 13:30:51'),(118435,401,'Marheen','184148',1,0,'2022-03-03 13:30:51','2022-03-03 13:30:51'),(118436,401,'Marhoon','184204',1,0,'2022-03-03 13:30:51','2022-03-03 13:30:51'),(118437,401,'Marta Nagrota','184201',1,0,'2022-03-03 13:30:51','2022-03-03 13:30:51'),(118438,401,'Mawa','184121',1,0,'2022-03-03 13:30:51','2022-03-03 13:30:51'),(118439,401,'Mehtabpur','184102',1,0,'2022-03-03 13:30:51','2022-03-03 13:30:51'),(118440,401,'Mela','184144',1,0,'2022-03-03 13:30:51','2022-03-03 13:30:51'),(118441,401,'Mini Sectt Kathua','184104',1,0,'2022-03-03 13:30:51','2022-03-03 13:30:51'),(118442,401,'Mukwal Chinji','184205',1,0,'2022-03-03 13:30:51','2022-03-03 13:30:51'),(118443,401,'Muni','184202',1,0,'2022-03-03 13:30:51','2022-03-03 13:30:51'),(118444,401,'Nagrota Gujroo','184205',1,0,'2022-03-03 13:30:52','2022-03-03 13:30:52'),(118445,401,'Naran','184141',1,0,'2022-03-03 13:30:52','2022-03-03 13:30:52'),(118446,401,'Palli','184143',1,0,'2022-03-03 13:30:52','2022-03-03 13:30:52'),(118447,401,'Parliwand','184102',1,0,'2022-03-03 13:30:52','2022-03-03 13:30:52'),(118448,401,'Parnala','184203',1,0,'2022-03-03 13:30:52','2022-03-03 13:30:52'),(118449,401,'Parole','184151',1,0,'2022-03-03 13:30:52','2022-03-03 13:30:52'),(118450,401,'Phinter','184203',1,0,'2022-03-03 13:30:52','2022-03-03 13:30:52'),(118451,401,'Plahi','184201',1,0,'2022-03-03 13:30:52','2022-03-03 13:30:52'),(118452,401,'Plassy','184201',1,0,'2022-03-03 13:30:52','2022-03-03 13:30:52'),(118453,401,'Poonda','184201',1,0,'2022-03-03 13:30:52','2022-03-03 13:30:52'),(118454,401,'Prangoli','184144',1,0,'2022-03-03 13:30:52','2022-03-03 13:30:52'),(118455,401,'Raikoota','184141',1,0,'2022-03-03 13:30:52','2022-03-03 13:30:52'),(118456,401,'Rajbagh','184143',1,0,'2022-03-03 13:30:52','2022-03-03 13:30:52'),(118457,401,'Rajpura (Kathua)','184145',1,0,'2022-03-03 13:30:52','2022-03-03 13:30:52'),(118458,401,'Rakh Lachhipura','184104',1,0,'2022-03-03 13:30:52','2022-03-03 13:30:52'),(118459,401,'Ramkot (Kathua)','184205',1,0,'2022-03-03 13:30:52','2022-03-03 13:30:52'),(118460,401,'Rehan','184201',1,0,'2022-03-03 13:30:52','2022-03-03 13:30:52'),(118461,401,'Roulka','184206',1,0,'2022-03-03 13:30:52','2022-03-03 13:30:52'),(118462,401,'Sabar','184202',1,0,'2022-03-03 13:30:52','2022-03-03 13:30:52'),(118463,401,'Said','184141',1,0,'2022-03-03 13:30:52','2022-03-03 13:30:52'),(118464,401,'Saidpur','184151',1,0,'2022-03-03 13:30:52','2022-03-03 13:30:52'),(118465,401,'Sailna','184203',1,0,'2022-03-03 13:30:52','2022-03-03 13:30:52'),(118466,401,'Sananghat','184201',1,0,'2022-03-03 13:30:53','2022-03-03 13:30:53'),(118467,401,'Sandhar','184201',1,0,'2022-03-03 13:30:53','2022-03-03 13:30:53'),(118468,401,'Sanjimore','184148',1,0,'2022-03-03 13:30:53','2022-03-03 13:30:53'),(118469,401,'Sanoora','184141',1,0,'2022-03-03 13:30:53','2022-03-03 13:30:53'),(118470,401,'Seswan','184144',1,0,'2022-03-03 13:30:53','2022-03-03 13:30:53'),(118471,401,'Sherpur','184142',1,0,'2022-03-03 13:30:53','2022-03-03 13:30:53'),(118472,401,'Sitti','184206',1,0,'2022-03-03 13:30:53','2022-03-03 13:30:53'),(118473,401,'Sukrala','184204',1,0,'2022-03-03 13:30:53','2022-03-03 13:30:53'),(118474,401,'Sundla','184205',1,0,'2022-03-03 13:30:53','2022-03-03 13:30:53'),(118475,401,'Surara','184141',1,0,'2022-03-03 13:30:53','2022-03-03 13:30:53'),(118476,401,'Thall','184204',1,0,'2022-03-03 13:30:53','2022-03-03 13:30:53'),(118477,401,'Thein','184152',1,0,'2022-03-03 13:30:53','2022-03-03 13:30:53'),(118478,401,'Thial','184205',1,0,'2022-03-03 13:30:53','2022-03-03 13:30:53'),(118479,401,'Tridwan','184152',1,0,'2022-03-03 13:30:53','2022-03-03 13:30:53'),(118480,401,'Uchapind','184205',1,0,'2022-03-03 13:30:53','2022-03-03 13:30:53'),(118481,402,'Aharbal','192233',1,0,'2022-03-03 13:30:53','2022-03-03 13:30:53'),(118482,402,'Ahmedabad','192233',1,0,'2022-03-03 13:30:53','2022-03-03 13:30:53'),(118483,402,'Chimar','192233',1,0,'2022-03-03 13:30:53','2022-03-03 13:30:53'),(118484,402,'D K Marg','192233',1,0,'2022-03-03 13:30:53','2022-03-03 13:30:53'),(118485,402,'Damhal Hanji Pora','192233',1,0,'2022-03-03 13:30:53','2022-03-03 13:30:53'),(118486,402,'Gopalpora','192233',1,0,'2022-03-03 13:30:53','2022-03-03 13:30:53'),(118487,402,'Khull','192233',1,0,'2022-03-03 13:30:53','2022-03-03 13:30:53'),(118488,402,'Khuri Bata Pora','192233',1,0,'2022-03-03 13:30:54','2022-03-03 13:30:54'),(118489,402,'Manzgam','192233',1,0,'2022-03-03 13:30:54','2022-03-03 13:30:54'),(118490,402,'Nandimarg','192233',1,0,'2022-03-03 13:30:54','2022-03-03 13:30:54'),(118491,402,'Nasnoor','192233',1,0,'2022-03-03 13:30:54','2022-03-03 13:30:54'),(118492,402,'Nehama','192233',1,0,'2022-03-03 13:30:54','2022-03-03 13:30:54'),(118493,403,'Aloosa','193224',1,0,'2022-03-03 13:30:54','2022-03-03 13:30:54'),(118494,403,'Ashpora','193303',1,0,'2022-03-03 13:30:54','2022-03-03 13:30:54'),(118495,403,'Batagund','193302',1,0,'2022-03-03 13:30:54','2022-03-03 13:30:54'),(118496,403,'Batergam','193222',1,0,'2022-03-03 13:30:54','2022-03-03 13:30:54'),(118497,403,'Batpora','193222',1,0,'2022-03-03 13:30:54','2022-03-03 13:30:54'),(118498,403,'Budnambal','193224',1,0,'2022-03-03 13:30:54','2022-03-03 13:30:54'),(118499,403,'Chamkote','193225',1,0,'2022-03-03 13:30:54','2022-03-03 13:30:54'),(118500,403,'Chandigam','193223',1,0,'2022-03-03 13:30:54','2022-03-03 13:30:54'),(118501,403,'Cheerkoot','193223',1,0,'2022-03-03 13:30:54','2022-03-03 13:30:54'),(118502,403,'Chowgal','193221',1,0,'2022-03-03 13:30:54','2022-03-03 13:30:54'),(118503,403,'Chowkibal','193224',1,0,'2022-03-03 13:30:54','2022-03-03 13:30:54'),(118504,403,'Dardpora','193223',1,0,'2022-03-03 13:30:54','2022-03-03 13:30:54'),(118505,403,'Dever Inderbugh','193223',1,0,'2022-03-03 13:30:54','2022-03-03 13:30:54'),(118506,403,'Drugmulla','193222',1,0,'2022-03-03 13:30:54','2022-03-03 13:30:54'),(118507,403,'Dudi Machil','193222',1,0,'2022-03-03 13:30:54','2022-03-03 13:30:54'),(118508,403,'Gazriyal','193224',1,0,'2022-03-03 13:30:55','2022-03-03 13:30:55'),(118509,403,'Gloora','193302',1,0,'2022-03-03 13:30:55','2022-03-03 13:30:55'),(118510,403,'Gogal','193223',1,0,'2022-03-03 13:30:55','2022-03-03 13:30:55'),(118511,403,'Gugloosa','193224',1,0,'2022-03-03 13:30:55','2022-03-03 13:30:55'),(118512,403,'Gulgam','193222',1,0,'2022-03-03 13:30:55','2022-03-03 13:30:55'),(118513,403,'Haihama','193222',1,0,'2022-03-03 13:30:55','2022-03-03 13:30:55'),(118514,403,'Hajitrah','193225',1,0,'2022-03-03 13:30:55','2022-03-03 13:30:55'),(118515,403,'Halmatpora','193222',1,0,'2022-03-03 13:30:55','2022-03-03 13:30:55'),(118516,403,'Handwara','193221',1,0,'2022-03-03 13:30:55','2022-03-03 13:30:55'),(118517,403,'Haril','193302',1,0,'2022-03-03 13:30:55','2022-03-03 13:30:55'),(118518,403,'Hayan','193224',1,0,'2022-03-03 13:30:55','2022-03-03 13:30:55'),(118519,403,'Jaggerpora','193222',1,0,'2022-03-03 13:30:55','2022-03-03 13:30:55'),(118520,403,'Kachhama','193224',1,0,'2022-03-03 13:30:55','2022-03-03 13:30:55'),(118521,403,'Kakroosa','193224',1,0,'2022-03-03 13:30:55','2022-03-03 13:30:55'),(118522,403,'Kalamchakla','193302',1,0,'2022-03-03 13:30:55','2022-03-03 13:30:55'),(118523,403,'Kalaroose','193222',1,0,'2022-03-03 13:30:55','2022-03-03 13:30:55'),(118524,403,'Kandi','193221',1,0,'2022-03-03 13:30:55','2022-03-03 13:30:55'),(118525,403,'Karihama','193222',1,0,'2022-03-03 13:30:55','2022-03-03 13:30:55'),(118526,403,'Keran','193224',1,0,'2022-03-03 13:30:55','2022-03-03 13:30:55'),(118527,403,'Khumriyal','193222',1,0,'2022-03-03 13:30:55','2022-03-03 13:30:55'),(118528,403,'Kralgund','193302',1,0,'2022-03-03 13:30:55','2022-03-03 13:30:55'),(118529,403,'Kralpora','193224',1,0,'2022-03-03 13:30:55','2022-03-03 13:30:55'),(118530,403,'Krusan','193223',1,0,'2022-03-03 13:30:56','2022-03-03 13:30:56'),(118531,403,'Kuligam','193223',1,0,'2022-03-03 13:30:56','2022-03-03 13:30:56'),(118532,403,'Kupwara','193222',1,0,'2022-03-03 13:30:56','2022-03-03 13:30:56'),(118533,403,'Lalpora','193223',1,0,'2022-03-03 13:30:56','2022-03-03 13:30:56'),(118534,403,'Magam','193221',1,0,'2022-03-03 13:30:56','2022-03-03 13:30:56'),(118535,403,'Maidanpora','193223',1,0,'2022-03-03 13:30:56','2022-03-03 13:30:56'),(118536,403,'Manzgam','193224',1,0,'2022-03-03 13:30:56','2022-03-03 13:30:56'),(118537,403,'Meelyal','193224',1,0,'2022-03-03 13:30:56','2022-03-03 13:30:56'),(118538,403,'Nachian','193225',1,0,'2022-03-03 13:30:56','2022-03-03 13:30:56'),(118539,403,'Nagrimalpora','193222',1,0,'2022-03-03 13:30:56','2022-03-03 13:30:56'),(118540,403,'Natnusa','193221',1,0,'2022-03-03 13:30:56','2022-03-03 13:30:56'),(118541,403,'Nowgabra','193225',1,0,'2022-03-03 13:30:56','2022-03-03 13:30:56'),(118542,403,'Nowgam','193302',1,0,'2022-03-03 13:30:56','2022-03-03 13:30:56'),(118543,403,'Owoora','193224',1,0,'2022-03-03 13:30:56','2022-03-03 13:30:56'),(118544,403,'Panzgam','193224',1,0,'2022-03-03 13:30:56','2022-03-03 13:30:56'),(118545,403,'Pazipora','193222',1,0,'2022-03-03 13:30:56','2022-03-03 13:30:56'),(118546,403,'Puhroopeth','193302',1,0,'2022-03-03 13:30:56','2022-03-03 13:30:56'),(118547,403,'Putushay','193223',1,0,'2022-03-03 13:30:56','2022-03-03 13:30:56'),(118548,403,'Sahipora','193302',1,0,'2022-03-03 13:30:56','2022-03-03 13:30:56'),(118549,403,'Sarkuli','193222',1,0,'2022-03-03 13:30:56','2022-03-03 13:30:56'),(118550,403,'Satkuji','193221',1,0,'2022-03-03 13:30:56','2022-03-03 13:30:56'),(118551,403,'Shatgund','193302',1,0,'2022-03-03 13:30:56','2022-03-03 13:30:56'),(118552,403,'Shilhal','193221',1,0,'2022-03-03 13:30:56','2022-03-03 13:30:56'),(118553,403,'Sogam','193223',1,0,'2022-03-03 13:30:57','2022-03-03 13:30:57'),(118554,403,'Tad','193225',1,0,'2022-03-03 13:30:57','2022-03-03 13:30:57'),(118555,403,'Tangdhar','193225',1,0,'2022-03-03 13:30:57','2022-03-03 13:30:57'),(118556,403,'Tarathpora','193224',1,0,'2022-03-03 13:30:57','2022-03-03 13:30:57'),(118557,403,'Teetwal','193225',1,0,'2022-03-03 13:30:57','2022-03-03 13:30:57'),(118558,403,'Tekipora','193223',1,0,'2022-03-03 13:30:57','2022-03-03 13:30:57'),(118559,403,'Trehgam','193224',1,0,'2022-03-03 13:30:57','2022-03-03 13:30:57'),(118560,403,'Turkapora','193221',1,0,'2022-03-03 13:30:57','2022-03-03 13:30:57'),(118561,403,'Vernow','193223',1,0,'2022-03-03 13:30:57','2022-03-03 13:30:57'),(118562,403,'Villagam','193224',1,0,'2022-03-03 13:30:57','2022-03-03 13:30:57'),(118563,403,'Wader Nichama','193221',1,0,'2022-03-03 13:30:57','2022-03-03 13:30:57'),(118564,403,'Wadipora','193221',1,0,'2022-03-03 13:30:57','2022-03-03 13:30:57'),(118565,403,'Wagat','193221',1,0,'2022-03-03 13:30:57','2022-03-03 13:30:57'),(118566,403,'Warsun','193224',1,0,'2022-03-03 13:30:57','2022-03-03 13:30:57'),(118567,403,'Yaroo','193302',1,0,'2022-03-03 13:30:57','2022-03-03 13:30:57'),(118568,403,'Yunis Wahipora','193302',1,0,'2022-03-03 13:30:57','2022-03-03 13:30:57'),(118569,403,'Zachaldara','193221',1,0,'2022-03-03 13:30:57','2022-03-03 13:30:57'),(118570,403,'Zurhama','193224',1,0,'2022-03-03 13:30:57','2022-03-03 13:30:57'),(118571,404,'Alchi','194106',1,0,'2022-03-03 13:30:57','2022-03-03 13:30:57'),(118572,404,'Bazgo','194105',1,0,'2022-03-03 13:30:57','2022-03-03 13:30:57'),(118573,404,'Bazgo','194101',1,0,'2022-03-03 13:30:57','2022-03-03 13:30:57'),(118574,404,'Biama','194106',1,0,'2022-03-03 13:30:57','2022-03-03 13:30:57'),(118575,404,'Chamray','194201',1,0,'2022-03-03 13:30:58','2022-03-03 13:30:58'),(118576,404,'Chuchot Gongma','194101',1,0,'2022-03-03 13:30:58','2022-03-03 13:30:58'),(118577,404,'Chuchot Shama','194101',1,0,'2022-03-03 13:30:58','2022-03-03 13:30:58'),(118578,404,'Chuchot Yokma','194101',1,0,'2022-03-03 13:30:58','2022-03-03 13:30:58'),(118579,404,'Chuchul','194101',1,0,'2022-03-03 13:30:58','2022-03-03 13:30:58'),(118580,404,'Chuglamsar','194104',1,0,'2022-03-03 13:30:58','2022-03-03 13:30:58'),(118581,404,'Chumathang','194201',1,0,'2022-03-03 13:30:58','2022-03-03 13:30:58'),(118582,404,'Diskit','194401',1,0,'2022-03-03 13:30:58','2022-03-03 13:30:58'),(118583,404,'Dumkhar','194106',1,0,'2022-03-03 13:30:58','2022-03-03 13:30:58'),(118584,404,'Durbuk','194101',1,0,'2022-03-03 13:30:58','2022-03-03 13:30:58'),(118585,404,'Faing','194101',1,0,'2022-03-03 13:30:58','2022-03-03 13:30:58'),(118586,404,'Gia Meru','194201',1,0,'2022-03-03 13:30:58','2022-03-03 13:30:58'),(118587,404,'Hanoo','194106',1,0,'2022-03-03 13:30:58','2022-03-03 13:30:58'),(118588,404,'Hemis Changa','194201',1,0,'2022-03-03 13:30:58','2022-03-03 13:30:58'),(118589,404,'Hemis Shukpacahan','194106',1,0,'2022-03-03 13:30:58','2022-03-03 13:30:58'),(118590,404,'Hemiya','194201',1,0,'2022-03-03 13:30:58','2022-03-03 13:30:58'),(118591,404,'Horzey','194101',1,0,'2022-03-03 13:30:58','2022-03-03 13:30:58'),(118592,404,'Hunder','194401',1,0,'2022-03-03 13:30:58','2022-03-03 13:30:58'),(118593,404,'Igoo','194201',1,0,'2022-03-03 13:30:58','2022-03-03 13:30:58'),(118594,404,'Kairay','194201',1,0,'2022-03-03 13:30:58','2022-03-03 13:30:58'),(118595,404,'Karoo','194201',1,0,'2022-03-03 13:30:59','2022-03-03 13:30:59'),(118596,404,'Khalsi','194106',1,0,'2022-03-03 13:30:59','2022-03-03 13:30:59'),(118597,404,'Khardong','194401',1,0,'2022-03-03 13:30:59','2022-03-03 13:30:59'),(118598,404,'Kubat','194401',1,0,'2022-03-03 13:30:59','2022-03-03 13:30:59'),(118599,404,'Kungyam','194201',1,0,'2022-03-03 13:30:59','2022-03-03 13:30:59'),(118600,404,'Lamayuru','194106',1,0,'2022-03-03 13:30:59','2022-03-03 13:30:59'),(118601,404,'Leh City','194101',1,0,'2022-03-03 13:30:59','2022-03-03 13:30:59'),(118602,404,'Leh H.O','194101',1,0,'2022-03-03 13:30:59','2022-03-03 13:30:59'),(118603,404,'Likir','194106',1,0,'2022-03-03 13:30:59','2022-03-03 13:30:59'),(118604,404,'Matho','194101',1,0,'2022-03-03 13:30:59','2022-03-03 13:30:59'),(118605,404,'Ney','194101',1,0,'2022-03-03 13:30:59','2022-03-03 13:30:59'),(118606,404,'Nomoo','194101',1,0,'2022-03-03 13:30:59','2022-03-03 13:30:59'),(118607,404,'Nurla','194106',1,0,'2022-03-03 13:30:59','2022-03-03 13:30:59'),(118608,404,'Nyoma','194101',1,0,'2022-03-03 13:30:59','2022-03-03 13:30:59'),(118609,404,'Nyoma Mud','194404',1,0,'2022-03-03 13:30:59','2022-03-03 13:30:59'),(118610,404,'Panamik','194401',1,0,'2022-03-03 13:30:59','2022-03-03 13:30:59'),(118611,404,'Saboo','194104',1,0,'2022-03-03 13:30:59','2022-03-03 13:30:59'),(118612,404,'Sakti','194201',1,0,'2022-03-03 13:30:59','2022-03-03 13:30:59'),(118613,404,'Sasapol','194106',1,0,'2022-03-03 13:30:59','2022-03-03 13:30:59'),(118614,404,'Saspol','194402',1,0,'2022-03-03 13:30:59','2022-03-03 13:30:59'),(118615,404,'Shara','194201',1,0,'2022-03-03 13:31:00','2022-03-03 13:31:00'),(118616,404,'Shey','194201',1,0,'2022-03-03 13:31:00','2022-03-03 13:31:00'),(118617,404,'Skurbuchan','194106',1,0,'2022-03-03 13:31:00','2022-03-03 13:31:00'),(118618,404,'Spituk','194101',1,0,'2022-03-03 13:31:00','2022-03-03 13:31:00'),(118619,404,'Stok','194101',1,0,'2022-03-03 13:31:00','2022-03-03 13:31:00'),(118620,404,'Takmachik','194106',1,0,'2022-03-03 13:31:00','2022-03-03 13:31:00'),(118621,404,'Temisgam','194106',1,0,'2022-03-03 13:31:00','2022-03-03 13:31:00'),(118622,404,'Terchey','194401',1,0,'2022-03-03 13:31:00','2022-03-03 13:31:00'),(118623,404,'Thiksay','194201',1,0,'2022-03-03 13:31:00','2022-03-03 13:31:00'),(118624,404,'Tia','194106',1,0,'2022-03-03 13:31:00','2022-03-03 13:31:00'),(118625,404,'Tiger Sumur','194401',1,0,'2022-03-03 13:31:00','2022-03-03 13:31:00'),(118626,404,'Turtuk','194401',1,0,'2022-03-03 13:31:00','2022-03-03 13:31:00'),(118627,404,'Wanla','194106',1,0,'2022-03-03 13:31:00','2022-03-03 13:31:00'),(118628,405,'Mandi Sangwali','184121',1,0,'2022-03-03 13:31:00','2022-03-03 13:31:00'),(118629,405,'Ajote','185101',1,0,'2022-03-03 13:31:00','2022-03-03 13:31:00'),(118630,405,'Arai','185102',1,0,'2022-03-03 13:31:00','2022-03-03 13:31:00'),(118631,405,'Ari','185211',1,0,'2022-03-03 13:31:00','2022-03-03 13:31:00'),(118632,405,'Bafliaz','185121',1,0,'2022-03-03 13:31:00','2022-03-03 13:31:00'),(118633,405,'Bandi Chichian','185101',1,0,'2022-03-03 13:31:00','2022-03-03 13:31:00'),(118634,405,'Bedar Balnai','185102',1,0,'2022-03-03 13:31:00','2022-03-03 13:31:00'),(118635,405,'Bhata Dhurian','185121',1,0,'2022-03-03 13:31:00','2022-03-03 13:31:00'),(118636,405,'Chandak','185101',1,0,'2022-03-03 13:31:00','2022-03-03 13:31:00'),(118637,405,'Chandi Marh','185121',1,0,'2022-03-03 13:31:00','2022-03-03 13:31:00'),(118638,405,'Chatral','185211',1,0,'2022-03-03 13:31:01','2022-03-03 13:31:01'),(118639,405,'Chella Dhangri','185102',1,0,'2022-03-03 13:31:01','2022-03-03 13:31:01'),(118640,405,'Chhajla','185211',1,0,'2022-03-03 13:31:01','2022-03-03 13:31:01'),(118641,405,'Chuggan','185211',1,0,'2022-03-03 13:31:01','2022-03-03 13:31:01'),(118642,405,'Degwar Maldalyan','185101',1,0,'2022-03-03 13:31:01','2022-03-03 13:31:01'),(118643,405,'Dhara Dhullian','185101',1,0,'2022-03-03 13:31:01','2022-03-03 13:31:01'),(118644,405,'Dharamsal Mendhar','185211',1,0,'2022-03-03 13:31:01','2022-03-03 13:31:01'),(118645,405,'Dharana','185211',1,0,'2022-03-03 13:31:01','2022-03-03 13:31:01'),(118646,405,'Dhargloon','185211',1,0,'2022-03-03 13:31:01','2022-03-03 13:31:01'),(118647,405,'Draba','185121',1,0,'2022-03-03 13:31:01','2022-03-03 13:31:01'),(118648,405,'Fatehpur','185102',1,0,'2022-03-03 13:31:01','2022-03-03 13:31:01'),(118649,405,'Gagerian','185102',1,0,'2022-03-03 13:31:01','2022-03-03 13:31:01'),(118650,405,'Galhuta','185211',1,0,'2022-03-03 13:31:01','2022-03-03 13:31:01'),(118651,405,'Gunthal','185121',1,0,'2022-03-03 13:31:01','2022-03-03 13:31:01'),(118652,405,'Gursai','185211',1,0,'2022-03-03 13:31:01','2022-03-03 13:31:01'),(118653,405,'Gursai Mohri','185121',1,0,'2022-03-03 13:31:01','2022-03-03 13:31:01'),(118654,405,'Hari','185121',1,0,'2022-03-03 13:31:01','2022-03-03 13:31:01'),(118655,405,'Hari Budha','185121',1,0,'2022-03-03 13:31:01','2022-03-03 13:31:01'),(118656,405,'Hari Marhote','185121',1,0,'2022-03-03 13:31:01','2022-03-03 13:31:01'),(118657,405,'Harni','185211',1,0,'2022-03-03 13:31:01','2022-03-03 13:31:01'),(118658,405,'Jara Wali Gali','185121',1,0,'2022-03-03 13:31:02','2022-03-03 13:31:02'),(118659,405,'Jhulas','185101',1,0,'2022-03-03 13:31:02','2022-03-03 13:31:02'),(118660,405,'Jugal','185211',1,0,'2022-03-03 13:31:02','2022-03-03 13:31:02'),(118661,405,'Kalaban','185211',1,0,'2022-03-03 13:31:02','2022-03-03 13:31:02'),(118662,405,'Kalai','185101',1,0,'2022-03-03 13:31:02','2022-03-03 13:31:02'),(118663,405,'Kasbalari','185211',1,0,'2022-03-03 13:31:02','2022-03-03 13:31:02'),(118664,405,'Khanetar','185101',1,0,'2022-03-03 13:31:02','2022-03-03 13:31:02'),(118665,405,'Lassana','185121',1,0,'2022-03-03 13:31:02','2022-03-03 13:31:02'),(118666,405,'Loran','185102',1,0,'2022-03-03 13:31:02','2022-03-03 13:31:02'),(118667,405,'Madana','185121',1,0,'2022-03-03 13:31:02','2022-03-03 13:31:02'),(118668,405,'Magnar','185101',1,0,'2022-03-03 13:31:02','2022-03-03 13:31:02'),(118669,405,'Mandi','185102',1,0,'2022-03-03 13:31:02','2022-03-03 13:31:02'),(118670,405,'Mankot','185211',1,0,'2022-03-03 13:31:02','2022-03-03 13:31:02'),(118671,405,'Naka Majari','185211',1,0,'2022-03-03 13:31:02','2022-03-03 13:31:02'),(118672,405,'Nangali Sahib','185101',1,0,'2022-03-03 13:31:02','2022-03-03 13:31:02'),(118673,405,'Ochhad','185211',1,0,'2022-03-03 13:31:02','2022-03-03 13:31:02'),(118674,405,'Palera','185102',1,0,'2022-03-03 13:31:02','2022-03-03 13:31:02'),(118675,405,'Poonch Fort','185101',1,0,'2022-03-03 13:31:02','2022-03-03 13:31:02'),(118676,405,'Poonch','185101',1,0,'2022-03-03 13:31:02','2022-03-03 13:31:02'),(118677,405,'Prat','185211',1,0,'2022-03-03 13:31:03','2022-03-03 13:31:03'),(118678,405,'Sagra','185211',1,0,'2022-03-03 13:31:03','2022-03-03 13:31:03'),(118679,405,'Sakhi Maidan','185211',1,0,'2022-03-03 13:31:03','2022-03-03 13:31:03'),(118680,405,'Salunian','185102',1,0,'2022-03-03 13:31:03','2022-03-03 13:31:03'),(118681,405,'Salwah','185211',1,0,'2022-03-03 13:31:03','2022-03-03 13:31:03'),(118682,405,'Samote','185121',1,0,'2022-03-03 13:31:03','2022-03-03 13:31:03'),(118683,405,'Sanai','185121',1,0,'2022-03-03 13:31:03','2022-03-03 13:31:03'),(118684,405,'Sangiote','185121',1,0,'2022-03-03 13:31:03','2022-03-03 13:31:03'),(118685,405,'Sangla','185121',1,0,'2022-03-03 13:31:03','2022-03-03 13:31:03'),(118686,405,'Sathra','185102',1,0,'2022-03-03 13:31:03','2022-03-03 13:31:03'),(118687,405,'Sawjian','185102',1,0,'2022-03-03 13:31:03','2022-03-03 13:31:03'),(118688,405,'Seri Khawaja','185121',1,0,'2022-03-03 13:31:03','2022-03-03 13:31:03'),(118689,405,'Shahpur','185101',1,0,'2022-03-03 13:31:03','2022-03-03 13:31:03'),(118690,405,'Shindra','185101',1,0,'2022-03-03 13:31:03','2022-03-03 13:31:03'),(118691,405,'Sialan','185121',1,0,'2022-03-03 13:31:03','2022-03-03 13:31:03'),(118692,406,'Ahagam','192302',1,0,'2022-03-03 13:31:03','2022-03-03 13:31:03'),(118693,406,'Arihal','192302',1,0,'2022-03-03 13:31:03','2022-03-03 13:31:03'),(118694,406,'Aripal','192123',1,0,'2022-03-03 13:31:03','2022-03-03 13:31:03'),(118695,406,'Awantipora','192122',1,0,'2022-03-03 13:31:03','2022-03-03 13:31:03'),(118696,406,'Baigund','192123',1,0,'2022-03-03 13:31:03','2022-03-03 13:31:03'),(118697,406,'Balpora','192302',1,0,'2022-03-03 13:31:03','2022-03-03 13:31:03'),(118698,406,'Bandzoo','192301',1,0,'2022-03-03 13:31:04','2022-03-03 13:31:04'),(118699,406,'Bargam','192123',1,0,'2022-03-03 13:31:04','2022-03-03 13:31:04'),(118700,406,'Batagund','192123',1,0,'2022-03-03 13:31:04','2022-03-03 13:31:04'),(118701,406,'Bathnoor','192123',1,0,'2022-03-03 13:31:04','2022-03-03 13:31:04'),(118702,406,'Batpora','192303',1,0,'2022-03-03 13:31:04','2022-03-03 13:31:04'),(118703,406,'Berthi Pora','192302',1,0,'2022-03-03 13:31:04','2022-03-03 13:31:04'),(118704,406,'Bouli','192123',1,0,'2022-03-03 13:31:04','2022-03-03 13:31:04'),(118705,406,'Buchoo','192123',1,0,'2022-03-03 13:31:04','2022-03-03 13:31:04'),(118706,406,'Chattergam','192123',1,0,'2022-03-03 13:31:04','2022-03-03 13:31:04'),(118707,406,'Dadsar','192123',1,0,'2022-03-03 13:31:04','2022-03-03 13:31:04'),(118708,406,'Drabgam','192302',1,0,'2022-03-03 13:31:04','2022-03-03 13:31:04'),(118709,406,'Haripari','192123',1,0,'2022-03-03 13:31:04','2022-03-03 13:31:04'),(118710,406,'Hawl','192302',1,0,'2022-03-03 13:31:04','2022-03-03 13:31:04'),(118711,406,'Herman','192303',1,0,'2022-03-03 13:31:04','2022-03-03 13:31:04'),(118712,406,'Hirapora','192303',1,0,'2022-03-03 13:31:04','2022-03-03 13:31:04'),(118713,406,'Inder','192301',1,0,'2022-03-03 13:31:04','2022-03-03 13:31:04'),(118714,406,'Kachachakote','192123',1,0,'2022-03-03 13:31:04','2022-03-03 13:31:04'),(118715,406,'Kahleel','192123',1,0,'2022-03-03 13:31:04','2022-03-03 13:31:04'),(118716,406,'Kakapora','192304',1,0,'2022-03-03 13:31:04','2022-03-03 13:31:04'),(118717,406,'Kalampora','192302',1,0,'2022-03-03 13:31:04','2022-03-03 13:31:04'),(118718,406,'Karimbad','192301',1,0,'2022-03-03 13:31:05','2022-03-03 13:31:05'),(118719,406,'Keller Mastpora','191112',1,0,'2022-03-03 13:31:05','2022-03-03 13:31:05'),(118720,406,'Kharawara','192303',1,0,'2022-03-03 13:31:05','2022-03-03 13:31:05'),(118721,406,'Koil','192301',1,0,'2022-03-03 13:31:05','2022-03-03 13:31:05'),(118722,406,'Kulgam','192231',1,0,'2022-03-03 13:31:05','2022-03-03 13:31:05'),(118723,406,'Kund','192221',1,0,'2022-03-03 13:31:05','2022-03-03 13:31:05'),(118724,406,'Lajeera','192301',1,0,'2022-03-03 13:31:05','2022-03-03 13:31:05'),(118725,406,'Lurgam','192123',1,0,'2022-03-03 13:31:05','2022-03-03 13:31:05'),(118726,406,'Malangpora','192301',1,0,'2022-03-03 13:31:05','2022-03-03 13:31:05'),(118727,406,'Mandoora','192123',1,0,'2022-03-03 13:31:05','2022-03-03 13:31:05'),(118728,406,'Memendar','192303',1,0,'2022-03-03 13:31:05','2022-03-03 13:31:05'),(118729,406,'Midroo','192123',1,0,'2022-03-03 13:31:05','2022-03-03 13:31:05'),(118730,406,'Mitrigam','192301',1,0,'2022-03-03 13:31:05','2022-03-03 13:31:05'),(118731,406,'Murram','192301',1,0,'2022-03-03 13:31:05','2022-03-03 13:31:05'),(118732,406,'Nadigam','192303',1,0,'2022-03-03 13:31:05','2022-03-03 13:31:05'),(118733,406,'Narapora','192303',1,0,'2022-03-03 13:31:05','2022-03-03 13:31:05'),(118734,406,'Newa','192301',1,0,'2022-03-03 13:31:05','2022-03-03 13:31:05'),(118735,406,'Obindora','192211',1,0,'2022-03-03 13:31:05','2022-03-03 13:31:05'),(118736,406,'Parigam Jagir','192301',1,0,'2022-03-03 13:31:05','2022-03-03 13:31:05'),(118737,406,'Pastana','192123',1,0,'2022-03-03 13:31:05','2022-03-03 13:31:05'),(118738,406,'Pingliana','192301',1,0,'2022-03-03 13:31:05','2022-03-03 13:31:05'),(118739,406,'Pinglish','192123',1,0,'2022-03-03 13:31:05','2022-03-03 13:31:05'),(118740,406,'Pinjoora','192303',1,0,'2022-03-03 13:31:05','2022-03-03 13:31:05'),(118741,406,'Pulwama','192301',1,0,'2022-03-03 13:31:05','2022-03-03 13:31:05'),(118742,406,'Qasbayar','192302',1,0,'2022-03-03 13:31:06','2022-03-03 13:31:06'),(118743,406,'Rajpora','192302',1,0,'2022-03-03 13:31:06','2022-03-03 13:31:06'),(118744,406,'Rajpora','192306',1,0,'2022-03-03 13:31:06','2022-03-03 13:31:06'),(118745,406,'Ramnagri','192303',1,0,'2022-03-03 13:31:06','2022-03-03 13:31:06'),(118746,406,'Ratnipora','192121',1,0,'2022-03-03 13:31:06','2022-03-03 13:31:06'),(118747,406,'Romoh','192301',1,0,'2022-03-03 13:31:06','2022-03-03 13:31:06'),(118748,406,'Saidpora','192303',1,0,'2022-03-03 13:31:06','2022-03-03 13:31:06'),(118749,406,'Saimoh','192123',1,0,'2022-03-03 13:31:06','2022-03-03 13:31:06'),(118750,406,'Satura','192123',1,0,'2022-03-03 13:31:06','2022-03-03 13:31:06'),(118751,406,'Sedow','192303',1,0,'2022-03-03 13:31:06','2022-03-03 13:31:06'),(118752,406,'Shopin','192303',1,0,'2022-03-03 13:31:06','2022-03-03 13:31:06'),(118753,406,'Sindh-shirmal','192302',1,0,'2022-03-03 13:31:06','2022-03-03 13:31:06'),(118754,406,'T Batapora','192301',1,0,'2022-03-03 13:31:06','2022-03-03 13:31:06'),(118755,406,'Tahaba Shadipora','192301',1,0,'2022-03-03 13:31:06','2022-03-03 13:31:06'),(118756,406,'Tankiya Sahib','192303',1,0,'2022-03-03 13:31:06','2022-03-03 13:31:06'),(118757,406,'Tokna','192124',1,0,'2022-03-03 13:31:06','2022-03-03 13:31:06'),(118758,406,'Tral','192123',1,0,'2022-03-03 13:31:06','2022-03-03 13:31:06'),(118759,406,'Trenz','192303',1,0,'2022-03-03 13:31:06','2022-03-03 13:31:06'),(118760,406,'Turkoo Babuar','192302',1,0,'2022-03-03 13:31:06','2022-03-03 13:31:06'),(118761,406,'Vaheel Chatarwatan','192303',1,0,'2022-03-03 13:31:06','2022-03-03 13:31:06'),(118762,406,'Waibugh','192301',1,0,'2022-03-03 13:31:07','2022-03-03 13:31:07'),(118763,406,'Zoora','192303',1,0,'2022-03-03 13:31:07','2022-03-03 13:31:07'),(118764,407,'Agrati','185151',1,0,'2022-03-03 13:31:07','2022-03-03 13:31:07'),(118765,407,'Androoth','185151',1,0,'2022-03-03 13:31:07','2022-03-03 13:31:07'),(118766,407,'Azamtabad','185212',1,0,'2022-03-03 13:31:07','2022-03-03 13:31:07'),(118767,407,'Baba Ghulam Shah Badshah University','185234',1,0,'2022-03-03 13:31:07','2022-03-03 13:31:07'),(118768,407,'Badhoon','185132',1,0,'2022-03-03 13:31:07','2022-03-03 13:31:07'),(118769,407,'Bagla','185151',1,0,'2022-03-03 13:31:07','2022-03-03 13:31:07'),(118770,407,'Bagnoti','185152',1,0,'2022-03-03 13:31:07','2022-03-03 13:31:07'),(118771,407,'Bajnoa','185151',1,0,'2022-03-03 13:31:07','2022-03-03 13:31:07'),(118772,407,'Bakhar','185152',1,0,'2022-03-03 13:31:07','2022-03-03 13:31:07'),(118773,407,'Bareri','185151',1,0,'2022-03-03 13:31:07','2022-03-03 13:31:07'),(118774,407,'Bathuni','185131',1,0,'2022-03-03 13:31:07','2022-03-03 13:31:07'),(118775,407,'Behrote','185212',1,0,'2022-03-03 13:31:07','2022-03-03 13:31:07'),(118776,407,'Bhajwal','185153',1,0,'2022-03-03 13:31:07','2022-03-03 13:31:07'),(118777,407,'Bharore','185156',1,0,'2022-03-03 13:31:07','2022-03-03 13:31:07'),(118778,407,'Bhattian','185212',1,0,'2022-03-03 13:31:07','2022-03-03 13:31:07'),(118779,407,'Bhawani','185155',1,0,'2022-03-03 13:31:07','2022-03-03 13:31:07'),(118780,407,'Brehvi','185201',1,0,'2022-03-03 13:31:08','2022-03-03 13:31:08'),(118781,407,'Budhal','185233',1,0,'2022-03-03 13:31:08','2022-03-03 13:31:08'),(118782,407,'Chak Mathani','185201',1,0,'2022-03-03 13:31:08','2022-03-03 13:31:08'),(118783,407,'Chambitrar','185132',1,0,'2022-03-03 13:31:08','2022-03-03 13:31:08'),(118784,407,'Chani','185152',1,0,'2022-03-03 13:31:08','2022-03-03 13:31:08'),(118785,407,'Chasote','185233',1,0,'2022-03-03 13:31:08','2022-03-03 13:31:08'),(118786,407,'Chingas','185151',1,0,'2022-03-03 13:31:08','2022-03-03 13:31:08'),(118787,407,'Chowki','185151',1,0,'2022-03-03 13:31:08','2022-03-03 13:31:08'),(118788,407,'Chowkian','185135',1,0,'2022-03-03 13:31:08','2022-03-03 13:31:08'),(118789,407,'Dabbar Potha','185151',1,0,'2022-03-03 13:31:08','2022-03-03 13:31:08'),(118790,407,'Dalhori','185132',1,0,'2022-03-03 13:31:08','2022-03-03 13:31:08'),(118791,407,'Dali','185202',1,0,'2022-03-03 13:31:08','2022-03-03 13:31:08'),(118792,407,'Dalogora','185131',1,0,'2022-03-03 13:31:08','2022-03-03 13:31:08'),(118793,407,'Dandesar','185152',1,0,'2022-03-03 13:31:08','2022-03-03 13:31:08'),(118794,407,'Daraj','185233',1,0,'2022-03-03 13:31:08','2022-03-03 13:31:08'),(118795,407,'Darhal Malkan','185135',1,0,'2022-03-03 13:31:08','2022-03-03 13:31:08'),(118796,407,'Darkeri','185202',1,0,'2022-03-03 13:31:08','2022-03-03 13:31:08'),(118797,407,'Dassal Jattan','185131',1,0,'2022-03-03 13:31:08','2022-03-03 13:31:08'),(118798,407,'Deengmangot','185151',1,0,'2022-03-03 13:31:08','2022-03-03 13:31:08'),(118799,407,'Dehra','185152',1,0,'2022-03-03 13:31:08','2022-03-03 13:31:08'),(118800,407,'Dehri Ralyote','185131',1,0,'2022-03-03 13:31:08','2022-03-03 13:31:08'),(118801,407,'Dhangri','185132',1,0,'2022-03-03 13:31:08','2022-03-03 13:31:08'),(118802,407,'Dhani Dhar','185132',1,0,'2022-03-03 13:31:09','2022-03-03 13:31:09'),(118803,407,'Dhar','185156',1,0,'2022-03-03 13:31:09','2022-03-03 13:31:09'),(118804,407,'Dharamsal','185201',1,0,'2022-03-03 13:31:09','2022-03-03 13:31:09'),(118805,407,'Dharsakri','185132',1,0,'2022-03-03 13:31:09','2022-03-03 13:31:09'),(118806,407,'Dhok Banyar','185156',1,0,'2022-03-03 13:31:09','2022-03-03 13:31:09'),(118807,407,'Dodaj','185135',1,0,'2022-03-03 13:31:09','2022-03-03 13:31:09'),(118808,407,'Dodasanbala','185212',1,0,'2022-03-03 13:31:09','2022-03-03 13:31:09'),(118809,407,'Doongi Brahmana','185151',1,0,'2022-03-03 13:31:09','2022-03-03 13:31:09'),(118810,407,'Fatehpur','185131',1,0,'2022-03-03 13:31:09','2022-03-03 13:31:09'),(118811,407,'Fazalabad','185121',1,0,'2022-03-03 13:31:09','2022-03-03 13:31:09'),(118812,407,'Gagrote','185151',1,0,'2022-03-03 13:31:09','2022-03-03 13:31:09'),(118813,407,'Gakhrote','185132',1,0,'2022-03-03 13:31:09','2022-03-03 13:31:09'),(118814,407,'Galuthi','185131',1,0,'2022-03-03 13:31:09','2022-03-03 13:31:09'),(118815,407,'Gambir Brahmana','185131',1,0,'2022-03-03 13:31:09','2022-03-03 13:31:09'),(118816,407,'Gambir Mughlan','185131',1,0,'2022-03-03 13:31:09','2022-03-03 13:31:09'),(118817,407,'Garan','185152',1,0,'2022-03-03 13:31:09','2022-03-03 13:31:09'),(118818,407,'Ghania','185155',1,0,'2022-03-03 13:31:09','2022-03-03 13:31:09'),(118819,407,'Gonda','185201',1,0,'2022-03-03 13:31:10','2022-03-03 13:31:10'),(118820,407,'Gunni','185132',1,0,'2022-03-03 13:31:10','2022-03-03 13:31:10'),(118821,407,'Hanjana Thakra','185151',1,0,'2022-03-03 13:31:10','2022-03-03 13:31:10'),(118822,407,'Harichuma','185201',1,0,'2022-03-03 13:31:10','2022-03-03 13:31:10'),(118823,407,'Jawaharnagar (Rajauri)','185132',1,0,'2022-03-03 13:31:10','2022-03-03 13:31:10'),(118824,407,'Jhanger','185155',1,0,'2022-03-03 13:31:10','2022-03-03 13:31:10'),(118825,407,'Jignicoal','185202',1,0,'2022-03-03 13:31:10','2022-03-03 13:31:10'),(118826,407,'Kakora','185131',1,0,'2022-03-03 13:31:10','2022-03-03 13:31:10'),(118827,407,'Kalakas','185132',1,0,'2022-03-03 13:31:10','2022-03-03 13:31:10'),(118828,407,'Kalakot','185202',1,0,'2022-03-03 13:31:10','2022-03-03 13:31:10'),(118829,407,'Kalsian','185155',1,0,'2022-03-03 13:31:10','2022-03-03 13:31:10'),(118830,407,'Kandi','185132',1,0,'2022-03-03 13:31:10','2022-03-03 13:31:10'),(118831,407,'Kangri','185156',1,0,'2022-03-03 13:31:10','2022-03-03 13:31:10'),(118832,407,'Kewal','185233',1,0,'2022-03-03 13:31:10','2022-03-03 13:31:10'),(118833,407,'Khajmola','185132',1,0,'2022-03-03 13:31:10','2022-03-03 13:31:10'),(118834,407,'Khawas','185201',1,0,'2022-03-03 13:31:10','2022-03-03 13:31:10'),(118835,407,'Kheri','185151',1,0,'2022-03-03 13:31:10','2022-03-03 13:31:10'),(118836,407,'Khersoo','185201',1,0,'2022-03-03 13:31:10','2022-03-03 13:31:10'),(118837,407,'Kotdhara','185132',1,0,'2022-03-03 13:31:10','2022-03-03 13:31:10'),(118838,407,'Kotranka','185233',1,0,'2022-03-03 13:31:10','2022-03-03 13:31:10'),(118839,407,'Lam','185155',1,0,'2022-03-03 13:31:11','2022-03-03 13:31:11'),(118840,407,'Lamberi','185152',1,0,'2022-03-03 13:31:11','2022-03-03 13:31:11'),(118841,407,'Langer','185155',1,0,'2022-03-03 13:31:11','2022-03-03 13:31:11'),(118842,407,'Laroka','185155',1,0,'2022-03-03 13:31:11','2022-03-03 13:31:11'),(118843,407,'Manjakot','185131',1,0,'2022-03-03 13:31:11','2022-03-03 13:31:11'),(118844,407,'Metka','185202',1,0,'2022-03-03 13:31:11','2022-03-03 13:31:11'),(118845,407,'Mohgla','185201',1,0,'2022-03-03 13:31:11','2022-03-03 13:31:11'),(118846,407,'Muradpur','185131',1,0,'2022-03-03 13:31:11','2022-03-03 13:31:11'),(118847,407,'Nagrota','185132',1,0,'2022-03-03 13:31:11','2022-03-03 13:31:11'),(118848,407,'Narian','185151',1,0,'2022-03-03 13:31:11','2022-03-03 13:31:11'),(118849,407,'Natryal','185151',1,0,'2022-03-03 13:31:11','2022-03-03 13:31:11'),(118850,407,'Naushera','185151',1,0,'2022-03-03 13:31:11','2022-03-03 13:31:11'),(118851,407,'Nonial','185151',1,0,'2022-03-03 13:31:11','2022-03-03 13:31:11'),(118852,407,'Palma','185132',1,0,'2022-03-03 13:31:11','2022-03-03 13:31:11'),(118853,407,'Panihad','185132',1,0,'2022-03-03 13:31:11','2022-03-03 13:31:11'),(118854,407,'Panjah','185201',1,0,'2022-03-03 13:31:11','2022-03-03 13:31:11'),(118855,407,'Panjnara','185202',1,0,'2022-03-03 13:31:11','2022-03-03 13:31:11'),(118856,407,'Patrara','185153',1,0,'2022-03-03 13:31:11','2022-03-03 13:31:11'),(118857,407,'Peeri','185132',1,0,'2022-03-03 13:31:11','2022-03-03 13:31:11'),(118858,407,'Potha','185202',1,0,'2022-03-03 13:31:11','2022-03-03 13:31:11'),(118859,407,'Prat','185152',1,0,'2022-03-03 13:31:11','2022-03-03 13:31:11'),(118860,407,'Qilla Darhal','185151',1,0,'2022-03-03 13:31:12','2022-03-03 13:31:12'),(118861,407,'Rahsiyot','185153',1,0,'2022-03-03 13:31:12','2022-03-03 13:31:12'),(118862,407,'Raikban','185135',1,0,'2022-03-03 13:31:12','2022-03-03 13:31:12'),(118863,407,'Rajal','185151',1,0,'2022-03-03 13:31:12','2022-03-03 13:31:12'),(118864,407,'Rajdhani','185212',1,0,'2022-03-03 13:31:12','2022-03-03 13:31:12'),(118865,407,'Rajouri H.O','185131',1,0,'2022-03-03 13:31:12','2022-03-03 13:31:12'),(118866,407,'Rajpur Kamila','185151',1,0,'2022-03-03 13:31:12','2022-03-03 13:31:12'),(118867,407,'Rehtal','185132',1,0,'2022-03-03 13:31:12','2022-03-03 13:31:12'),(118868,407,'Sair','185202',1,0,'2022-03-03 13:31:12','2022-03-03 13:31:12'),(118869,407,'Saj','185212',1,0,'2022-03-03 13:31:12','2022-03-03 13:31:12'),(118870,407,'Same','185212',1,0,'2022-03-03 13:31:12','2022-03-03 13:31:12'),(118871,407,'Samote','185233',1,0,'2022-03-03 13:31:12','2022-03-03 13:31:12'),(118872,407,'Sangpur','185151',1,0,'2022-03-03 13:31:12','2022-03-03 13:31:12'),(118873,407,'Saranu','185132',1,0,'2022-03-03 13:31:12','2022-03-03 13:31:12'),(118874,407,'Sehar','185155',1,0,'2022-03-03 13:31:12','2022-03-03 13:31:12'),(118875,407,'Seri','185151',1,0,'2022-03-03 13:31:12','2022-03-03 13:31:12'),(118876,407,'Shadhra Sharif','185212',1,0,'2022-03-03 13:31:12','2022-03-03 13:31:12'),(118877,407,'Sialsui','185202',1,0,'2022-03-03 13:31:12','2022-03-03 13:31:12'),(118878,407,'Siot','185152',1,0,'2022-03-03 13:31:12','2022-03-03 13:31:12'),(118879,407,'Solki','185201',1,0,'2022-03-03 13:31:12','2022-03-03 13:31:12'),(118880,407,'Sunderbani','185153',1,0,'2022-03-03 13:31:13','2022-03-03 13:31:13'),(118881,407,'Swari','185132',1,0,'2022-03-03 13:31:13','2022-03-03 13:31:13'),(118882,407,'Tandwal','185131',1,0,'2022-03-03 13:31:13','2022-03-03 13:31:13'),(118883,407,'Tareru','185201',1,0,'2022-03-03 13:31:13','2022-03-03 13:31:13'),(118884,407,'Tatapani','185202',1,0,'2022-03-03 13:31:13','2022-03-03 13:31:13'),(118885,407,'Thanamandi','185212',1,0,'2022-03-03 13:31:13','2022-03-03 13:31:13'),(118886,407,'Thanda Pani','185152',1,0,'2022-03-03 13:31:13','2022-03-03 13:31:13'),(118887,407,'Thichka','185156',1,0,'2022-03-03 13:31:13','2022-03-03 13:31:13'),(118888,407,'Tilla Tanda','185156',1,0,'2022-03-03 13:31:13','2022-03-03 13:31:13'),(118889,407,'Trala','185132',1,0,'2022-03-03 13:31:13','2022-03-03 13:31:13'),(118890,407,'Tuli','185233',1,0,'2022-03-03 13:31:13','2022-03-03 13:31:13'),(118891,407,'Ujjan','185132',1,0,'2022-03-03 13:31:13','2022-03-03 13:31:13'),(118892,407,'Barnara','185203',1,0,'2022-03-03 13:31:13','2022-03-03 13:31:13'),(118893,407,'Devak','185203',1,0,'2022-03-03 13:31:13','2022-03-03 13:31:13'),(118894,407,'Gelhan','185203',1,0,'2022-03-03 13:31:13','2022-03-03 13:31:13'),(118895,407,'Sarhoti','185203',1,0,'2022-03-03 13:31:13','2022-03-03 13:31:13'),(118896,407,'Taryath','185203',1,0,'2022-03-03 13:31:13','2022-03-03 13:31:13'),(118897,408,'Bagnkot','185233',1,0,'2022-03-03 13:31:13','2022-03-03 13:31:13'),(118898,408,'Chana Shikari','185233',1,0,'2022-03-03 13:31:13','2022-03-03 13:31:13'),(118899,408,'Mamanlot','185233',1,0,'2022-03-03 13:31:14','2022-03-03 13:31:14'),(118900,408,'Shergarhi','185233',1,0,'2022-03-03 13:31:14','2022-03-03 13:31:14'),(118901,408,'Shikari','185233',1,0,'2022-03-03 13:31:14','2022-03-03 13:31:14'),(118902,408,'District office Complex Reasi','182311',1,0,'2022-03-03 13:31:14','2022-03-03 13:31:14'),(118903,408,'SMVDU','182320',1,0,'2022-03-03 13:31:14','2022-03-03 13:31:14'),(118904,409,'Aglar','192305',1,0,'2022-03-03 13:31:14','2022-03-03 13:31:14'),(118905,410,'A K Pora','190015',1,0,'2022-03-03 13:31:14','2022-03-03 13:31:14'),(118906,410,'Abi Karlpora','190003',1,0,'2022-03-03 13:31:14','2022-03-03 13:31:14'),(118907,410,'Akhal','191202',1,0,'2022-03-03 13:31:14','2022-03-03 13:31:14'),(118908,410,'Anchar','190011',1,0,'2022-03-03 13:31:14','2022-03-03 13:31:14'),(118909,410,'Bachpora','190020',1,0,'2022-03-03 13:31:14','2022-03-03 13:31:14'),(118910,410,'Badyar Balla','190001',1,0,'2022-03-03 13:31:14','2022-03-03 13:31:14'),(118911,410,'Bagh Mehtab','190019',1,0,'2022-03-03 13:31:14','2022-03-03 13:31:14'),(118912,410,'Balhama','191101',1,0,'2022-03-03 13:31:14','2022-03-03 13:31:14'),(118913,410,'Bashipora','190017',1,0,'2022-03-03 13:31:14','2022-03-03 13:31:14'),(118914,410,'Batamaloo','190009',1,0,'2022-03-03 13:31:14','2022-03-03 13:31:14'),(118915,410,'Batwara','190004',1,0,'2022-03-03 13:31:14','2022-03-03 13:31:14'),(118916,410,'Beerwah','193401',1,0,'2022-03-03 13:31:14','2022-03-03 13:31:14'),(118917,410,'Bemina Chowk','190018',1,0,'2022-03-03 13:31:14','2022-03-03 13:31:14'),(118918,410,'Bemina','190018',1,0,'2022-03-03 13:31:14','2022-03-03 13:31:14'),(118919,410,'Brein','191121',1,0,'2022-03-03 13:31:14','2022-03-03 13:31:14'),(118920,410,'Central Market','190009',1,0,'2022-03-03 13:31:15','2022-03-03 13:31:15'),(118921,410,'Court Road','190001',1,0,'2022-03-03 13:31:15','2022-03-03 13:31:15'),(118922,410,'Fateh Kadal','190002',1,0,'2022-03-03 13:31:15','2022-03-03 13:31:15'),(118923,410,'Ganderbal','191201',1,0,'2022-03-03 13:31:15','2022-03-03 13:31:15'),(118924,410,'Gund','191202',1,0,'2022-03-03 13:31:15','2022-03-03 13:31:15'),(118925,410,'Haran','191131',1,0,'2022-03-03 13:31:15','2022-03-03 13:31:15'),(118926,410,'Hari Gaiwan','191202',1,0,'2022-03-03 13:31:15','2022-03-03 13:31:15'),(118927,410,'Jamia Masjid','190002',1,0,'2022-03-03 13:31:15','2022-03-03 13:31:15'),(118928,410,'Jawahar Nagar (Srinagar)','190008',1,0,'2022-03-03 13:31:15','2022-03-03 13:31:15'),(118929,410,'Kangan','191202',1,0,'2022-03-03 13:31:15','2022-03-03 13:31:15'),(118930,410,'Karan Nagar (Srinagar)','190010',1,0,'2022-03-03 13:31:15','2022-03-03 13:31:15'),(118931,410,'Karhama','191131',1,0,'2022-03-03 13:31:15','2022-03-03 13:31:15'),(118932,410,'Kashmir University','190006',1,0,'2022-03-03 13:31:15','2022-03-03 13:31:15'),(118933,410,'Kathi Darwaza','190003',1,0,'2022-03-03 13:31:15','2022-03-03 13:31:15'),(118934,410,'Khanyar','190003',1,0,'2022-03-03 13:31:15','2022-03-03 13:31:15'),(118935,410,'Khrew','191103',1,0,'2022-03-03 13:31:15','2022-03-03 13:31:15'),(118936,410,'Kulan','191202',1,0,'2022-03-03 13:31:15','2022-03-03 13:31:15'),(118937,410,'Lal Bazaar','190011',1,0,'2022-03-03 13:31:15','2022-03-03 13:31:15'),(118938,410,'Lal Bazar','190023',1,0,'2022-03-03 13:31:15','2022-03-03 13:31:15'),(118939,410,'Lal Chowk','190001',1,0,'2022-03-03 13:31:15','2022-03-03 13:31:15'),(118940,410,'Lasjan','191101',1,0,'2022-03-03 13:31:16','2022-03-03 13:31:16'),(118941,410,'Mamer','191202',1,0,'2022-03-03 13:31:16','2022-03-03 13:31:16'),(118942,410,'Nandpora','190003',1,0,'2022-03-03 13:31:16','2022-03-03 13:31:16'),(118943,410,'Nehru Park','190001',1,0,'2022-03-03 13:31:16','2022-03-03 13:31:16'),(118944,410,'New Secretariat Srinagar','190009',1,0,'2022-03-03 13:31:16','2022-03-03 13:31:16'),(118945,410,'Noushara','190011',1,0,'2022-03-03 13:31:16','2022-03-03 13:31:16'),(118946,410,'Paipora','190017',1,0,'2022-03-03 13:31:16','2022-03-03 13:31:16'),(118947,410,'Pampore','192121',1,0,'2022-03-03 13:31:16','2022-03-03 13:31:16'),(118948,410,'Pandrathan','191101',1,0,'2022-03-03 13:31:16','2022-03-03 13:31:16'),(118949,410,'Pantha Chowk','191101',1,0,'2022-03-03 13:31:16','2022-03-03 13:31:16'),(118950,410,'Parimpora','190017',1,0,'2022-03-03 13:31:16','2022-03-03 13:31:16'),(118951,410,'Qasbalar','191131',1,0,'2022-03-03 13:31:16','2022-03-03 13:31:16'),(118952,410,'Rainawari','190003',1,0,'2022-03-03 13:31:16','2022-03-03 13:31:16'),(118953,410,'Rajbagh','190008',1,0,'2022-03-03 13:31:16','2022-03-03 13:31:16'),(118954,410,'Rambagh (Srinagar)','190009',1,0,'2022-03-03 13:31:16','2022-03-03 13:31:16'),(118955,410,'S Bala','191202',1,0,'2022-03-03 13:31:16','2022-03-03 13:31:16'),(118956,410,'S.K.Sectrate','190001',1,0,'2022-03-03 13:31:16','2022-03-03 13:31:16'),(118957,410,'S.R Gunj','190002',1,0,'2022-03-03 13:31:16','2022-03-03 13:31:16'),(118958,410,'Safukadul','190002',1,0,'2022-03-03 13:31:16','2022-03-03 13:31:16'),(118959,410,'Saloora','191131',1,0,'2022-03-03 13:31:16','2022-03-03 13:31:16'),(118960,410,'Sathu','190001',1,0,'2022-03-03 13:31:16','2022-03-03 13:31:16'),(118961,410,'Sehpora','191131',1,0,'2022-03-03 13:31:17','2022-03-03 13:31:17'),(118962,410,'Shallabugh','191131',1,0,'2022-03-03 13:31:17','2022-03-03 13:31:17'),(118963,410,'Skuast','190025',1,0,'2022-03-03 13:31:17','2022-03-03 13:31:17'),(118964,410,'Sonamarg','191203',1,0,'2022-03-03 13:31:17','2022-03-03 13:31:17'),(118965,410,'Srinagar G.P.O.','190001',1,0,'2022-03-03 13:31:17','2022-03-03 13:31:17'),(118966,410,'Tulmulla','191131',1,0,'2022-03-03 13:31:17','2022-03-03 13:31:17'),(118967,410,'Wangat','191202',1,0,'2022-03-03 13:31:17','2022-03-03 13:31:17'),(118968,410,'Wuyan','191102',1,0,'2022-03-03 13:31:17','2022-03-03 13:31:17'),(118969,410,'Zainakote','190012',1,0,'2022-03-03 13:31:17','2022-03-03 13:31:17'),(118970,410,'Zakoora','190024',1,0,'2022-03-03 13:31:17','2022-03-03 13:31:17'),(118971,410,'Zakura','190006',1,0,'2022-03-03 13:31:17','2022-03-03 13:31:17'),(118972,410,'Zawan','191101',1,0,'2022-03-03 13:31:17','2022-03-03 13:31:17'),(118973,411,'Dhamma','184205',1,0,'2022-03-03 13:31:17','2022-03-03 13:31:17'),(118974,411,'Garh Samnabanj','184205',1,0,'2022-03-03 13:31:17','2022-03-03 13:31:17'),(118975,411,'Kakrai','184121',1,0,'2022-03-03 13:31:17','2022-03-03 13:31:17'),(118976,411,'Adhkawari','182301',1,0,'2022-03-03 13:31:17','2022-03-03 13:31:17'),(118977,411,'Aghar Baba Jitto','182301',1,0,'2022-03-03 13:31:17','2022-03-03 13:31:17'),(118978,411,'Allya','185203',1,0,'2022-03-03 13:31:17','2022-03-03 13:31:17'),(118979,411,'Amroh','182122',1,0,'2022-03-03 13:31:17','2022-03-03 13:31:17'),(118980,411,'Angrala','182315',1,0,'2022-03-03 13:31:17','2022-03-03 13:31:17'),(118981,411,'Arnas','182313',1,0,'2022-03-03 13:31:18','2022-03-03 13:31:18'),(118982,411,'Badhole','182122',1,0,'2022-03-03 13:31:18','2022-03-03 13:31:18'),(118983,411,'Bagdhar','182311',1,0,'2022-03-03 13:31:18','2022-03-03 13:31:18'),(118984,411,'Bain','182141',1,0,'2022-03-03 13:31:18','2022-03-03 13:31:18'),(118985,411,'Bainsta','182126',1,0,'2022-03-03 13:31:18','2022-03-03 13:31:18'),(118986,411,'Bakkal','182311',1,0,'2022-03-03 13:31:18','2022-03-03 13:31:18'),(118987,411,'Balamatkot','182315',1,0,'2022-03-03 13:31:18','2022-03-03 13:31:18'),(118988,411,'Bali','182101',1,0,'2022-03-03 13:31:18','2022-03-03 13:31:18'),(118989,411,'Bandhole','182122',1,0,'2022-03-03 13:31:18','2022-03-03 13:31:18'),(118990,411,'Bapp','182161',1,0,'2022-03-03 13:31:18','2022-03-03 13:31:18'),(118991,411,'Barerian','182126',1,0,'2022-03-03 13:31:18','2022-03-03 13:31:18'),(118992,411,'Bari','182122',1,0,'2022-03-03 13:31:18','2022-03-03 13:31:18'),(118993,411,'Barmeen','182124',1,0,'2022-03-03 13:31:18','2022-03-03 13:31:18'),(118994,411,'Barola','182121',1,0,'2022-03-03 13:31:18','2022-03-03 13:31:18'),(118995,411,'Basahat','182141',1,0,'2022-03-03 13:31:18','2022-03-03 13:31:18'),(118996,411,'Basantgarh','182128',1,0,'2022-03-03 13:31:18','2022-03-03 13:31:18'),(118997,411,'Bathoi','182315',1,0,'2022-03-03 13:31:18','2022-03-03 13:31:18'),(118998,411,'Battal','182127',1,0,'2022-03-03 13:31:18','2022-03-03 13:31:18'),(118999,411,'Bhagga','182311',1,0,'2022-03-03 13:31:18','2022-03-03 13:31:18'),(119000,411,'Bharakh','185203',1,0,'2022-03-03 13:31:18','2022-03-03 13:31:18'),(119001,411,'Bhatiari','182126',1,0,'2022-03-03 13:31:18','2022-03-03 13:31:18'),(119002,411,'Bhudara(Bhudan)','182313',1,0,'2022-03-03 13:31:18','2022-03-03 13:31:18'),(119003,411,'Bimblya','185203',1,0,'2022-03-03 13:31:19','2022-03-03 13:31:19'),(119004,411,'Bland','182122',1,0,'2022-03-03 13:31:19','2022-03-03 13:31:19'),(119005,411,'Chak Rakhwalan','182101',1,0,'2022-03-03 13:31:19','2022-03-03 13:31:19'),(119006,411,'Chanunta','182124',1,0,'2022-03-03 13:31:19','2022-03-03 13:31:19'),(119007,411,'Charat','182141',1,0,'2022-03-03 13:31:19','2022-03-03 13:31:19'),(119008,411,'Charyari','182121',1,0,'2022-03-03 13:31:19','2022-03-03 13:31:19'),(119009,411,'Chenani','182141',1,0,'2022-03-03 13:31:19','2022-03-03 13:31:19'),(119010,411,'Chowki Jandrorh','182122',1,0,'2022-03-03 13:31:19','2022-03-03 13:31:19'),(119011,411,'Dadoa','185203',1,0,'2022-03-03 13:31:19','2022-03-03 13:31:19'),(119012,411,'Dalsar','182122',1,0,'2022-03-03 13:31:19','2022-03-03 13:31:19'),(119013,411,'Dalwah','182144',1,0,'2022-03-03 13:31:19','2022-03-03 13:31:19'),(119014,411,'Damnet','182125',1,0,'2022-03-03 13:31:19','2022-03-03 13:31:19'),(119015,411,'Darmari','182313',1,0,'2022-03-03 13:31:19','2022-03-03 13:31:19'),(119016,411,'Dera Baba Banda','182301',1,0,'2022-03-03 13:31:19','2022-03-03 13:31:19'),(119017,411,'Deval','182315',1,0,'2022-03-03 13:31:19','2022-03-03 13:31:19'),(119018,411,'Dhanas','182141',1,0,'2022-03-03 13:31:19','2022-03-03 13:31:19'),(119019,411,'Dhanwalt','182122',1,0,'2022-03-03 13:31:19','2022-03-03 13:31:19'),(119020,411,'Dhanwan','185203',1,0,'2022-03-03 13:31:19','2022-03-03 13:31:19'),(119021,411,'Dhhannore','182313',1,0,'2022-03-03 13:31:19','2022-03-03 13:31:19'),(119022,411,'Dhiari','182122',1,0,'2022-03-03 13:31:19','2022-03-03 13:31:19'),(119023,411,'Dhyangarh','182312',1,0,'2022-03-03 13:31:19','2022-03-03 13:31:19'),(119024,411,'Dudoo','182128',1,0,'2022-03-03 13:31:19','2022-03-03 13:31:19'),(119025,411,'Galiote','182125',1,0,'2022-03-03 13:31:20','2022-03-03 13:31:20'),(119026,411,'Gandala','182101',1,0,'2022-03-03 13:31:20','2022-03-03 13:31:20'),(119027,411,'Garhi (Udhampur)','182121',1,0,'2022-03-03 13:31:20','2022-03-03 13:31:20'),(119028,411,'Garnai','182121',1,0,'2022-03-03 13:31:20','2022-03-03 13:31:20'),(119029,411,'Ghorari','182122',1,0,'2022-03-03 13:31:20','2022-03-03 13:31:20'),(119030,411,'Gool','182144',1,0,'2022-03-03 13:31:20','2022-03-03 13:31:20'),(119031,411,'Gulabgarh','182204',1,0,'2022-03-03 13:31:20','2022-03-03 13:31:20'),(119032,411,'Gulabgarh','182315',1,0,'2022-03-03 13:31:20','2022-03-03 13:31:20'),(119033,411,'Hartrian','182124',1,0,'2022-03-03 13:31:20','2022-03-03 13:31:20'),(119034,411,'Hartriyan','182121',1,0,'2022-03-03 13:31:20','2022-03-03 13:31:20'),(119035,411,'Hathal','185203',1,0,'2022-03-03 13:31:20','2022-03-03 13:31:20'),(119036,411,'Jaganoo','182124',1,0,'2022-03-03 13:31:20','2022-03-03 13:31:20'),(119037,411,'Jakhani','182101',1,0,'2022-03-03 13:31:20','2022-03-03 13:31:20'),(119038,411,'Jakhed','182128',1,0,'2022-03-03 13:31:20','2022-03-03 13:31:20'),(119039,411,'Jandrari','182122',1,0,'2022-03-03 13:31:20','2022-03-03 13:31:20'),(119040,411,'Jangalgali','182121',1,0,'2022-03-03 13:31:20','2022-03-03 13:31:20'),(119041,411,'Jib','182121',1,0,'2022-03-03 13:31:20','2022-03-03 13:31:20'),(119042,411,'Jij','182313',1,0,'2022-03-03 13:31:20','2022-03-03 13:31:20'),(119043,411,'Joffar','182128',1,0,'2022-03-03 13:31:20','2022-03-03 13:31:20'),(119044,411,'Johnu','182124',1,0,'2022-03-03 13:31:20','2022-03-03 13:31:20'),(119045,411,'Juda','182313',1,0,'2022-03-03 13:31:20','2022-03-03 13:31:20'),(119046,411,'Jyotipuram','182312',1,0,'2022-03-03 13:31:21','2022-03-03 13:31:21'),(119047,411,'Kaghote','182126',1,0,'2022-03-03 13:31:21','2022-03-03 13:31:21'),(119048,411,'Kainthgali','182125',1,0,'2022-03-03 13:31:21','2022-03-03 13:31:21'),(119049,411,'Kainthi','182313',1,0,'2022-03-03 13:31:21','2022-03-03 13:31:21'),(119050,411,'Kakrial','182320',1,0,'2022-03-03 13:31:21','2022-03-03 13:31:21'),(119051,411,'Kaldi','182124',1,0,'2022-03-03 13:31:21','2022-03-03 13:31:21'),(119052,411,'Kalsote','182125',1,0,'2022-03-03 13:31:21','2022-03-03 13:31:21'),(119053,411,'Karlah','182142',1,0,'2022-03-03 13:31:21','2022-03-03 13:31:21'),(119054,411,'Katra (Udhampur)','182301',1,0,'2022-03-03 13:31:21','2022-03-03 13:31:21'),(119055,411,'Kawa','182101',1,0,'2022-03-03 13:31:21','2022-03-03 13:31:21'),(119056,411,'Keya','182128',1,0,'2022-03-03 13:31:21','2022-03-03 13:31:21'),(119057,411,'Khairal','182311',1,0,'2022-03-03 13:31:21','2022-03-03 13:31:21'),(119058,411,'Khairlarh','185203',1,0,'2022-03-03 13:31:21','2022-03-03 13:31:21'),(119059,411,'Khaned','182128',1,0,'2022-03-03 13:31:21','2022-03-03 13:31:21'),(119060,411,'Khoon','182127',1,0,'2022-03-03 13:31:21','2022-03-03 13:31:21'),(119061,411,'Kithar','182141',1,0,'2022-03-03 13:31:21','2022-03-03 13:31:21'),(119062,411,'Kotwalt','182122',1,0,'2022-03-03 13:31:21','2022-03-03 13:31:21'),(119063,411,'Krimchi','182101',1,0,'2022-03-03 13:31:21','2022-03-03 13:31:21'),(119064,411,'Kud','182142',1,0,'2022-03-03 13:31:21','2022-03-03 13:31:21'),(119065,411,'Kuddal','182125',1,0,'2022-03-03 13:31:22','2022-03-03 13:31:22'),(119066,411,'Kuhritti','182126',1,0,'2022-03-03 13:31:22','2022-03-03 13:31:22'),(119067,411,'Kund Kantari','185203',1,0,'2022-03-03 13:31:22','2022-03-03 13:31:22'),(119068,411,'Ladha','182125',1,0,'2022-03-03 13:31:22','2022-03-03 13:31:22'),(119069,411,'Ladha','182141',1,0,'2022-03-03 13:31:22','2022-03-03 13:31:22'),(119070,411,'Landhar','182125',1,0,'2022-03-03 13:31:22','2022-03-03 13:31:22'),(119071,411,'Larh','182315',1,0,'2022-03-03 13:31:22','2022-03-03 13:31:22'),(119072,411,'Madha','182142',1,0,'2022-03-03 13:31:22','2022-03-03 13:31:22'),(119073,411,'Mahore (Udhampur)','182315',1,0,'2022-03-03 13:31:22','2022-03-03 13:31:22'),(119074,411,'Majalta','182127',1,0,'2022-03-03 13:31:22','2022-03-03 13:31:22'),(119075,411,'Majouri','182128',1,0,'2022-03-03 13:31:22','2022-03-03 13:31:22'),(119076,411,'Malhar','182121',1,0,'2022-03-03 13:31:22','2022-03-03 13:31:22'),(119077,411,'Mand','182121',1,0,'2022-03-03 13:31:22','2022-03-03 13:31:22'),(119078,411,'Mangal','182301',1,0,'2022-03-03 13:31:22','2022-03-03 13:31:22'),(119079,411,'Mantalai','182161',1,0,'2022-03-03 13:31:22','2022-03-03 13:31:22'),(119080,411,'Mari','182311',1,0,'2022-03-03 13:31:22','2022-03-03 13:31:22'),(119081,411,'Marta','182122',1,0,'2022-03-03 13:31:22','2022-03-03 13:31:22'),(119082,411,'Matlot','182313',1,0,'2022-03-03 13:31:22','2022-03-03 13:31:22'),(119083,411,'Mir','182125',1,0,'2022-03-03 13:31:22','2022-03-03 13:31:22'),(119084,411,'Mj Road Nd','182101',1,0,'2022-03-03 13:31:22','2022-03-03 13:31:22'),(119085,411,'Mongri','182125',1,0,'2022-03-03 13:31:22','2022-03-03 13:31:22'),(119086,411,'Nagrota Panj Garain','182122',1,0,'2022-03-03 13:31:23','2022-03-03 13:31:23'),(119087,411,'Nagulta','182141',1,0,'2022-03-03 13:31:23','2022-03-03 13:31:23'),(119088,411,'Nala Ghoria','182122',1,0,'2022-03-03 13:31:23','2022-03-03 13:31:23'),(119089,411,'Nomain','182301',1,0,'2022-03-03 13:31:23','2022-03-03 13:31:23'),(119090,411,'Omara Morh','182101',1,0,'2022-03-03 13:31:23','2022-03-03 13:31:23'),(119091,411,'Pachound','182128',1,0,'2022-03-03 13:31:23','2022-03-03 13:31:23'),(119092,411,'Pakhlai','182141',1,0,'2022-03-03 13:31:23','2022-03-03 13:31:23'),(119093,411,'Panasa','182313',1,0,'2022-03-03 13:31:23','2022-03-03 13:31:23'),(119094,411,'Panjar','182125',1,0,'2022-03-03 13:31:23','2022-03-03 13:31:23'),(119095,411,'Panthal','182320',1,0,'2022-03-03 13:31:23','2022-03-03 13:31:23'),(119096,411,'Pattangarh','182122',1,0,'2022-03-03 13:31:23','2022-03-03 13:31:23'),(119097,411,'Pattian','182313',1,0,'2022-03-03 13:31:23','2022-03-03 13:31:23'),(119098,411,'Peoni','182127',1,0,'2022-03-03 13:31:23','2022-03-03 13:31:23'),(119099,411,'Poni','185203',1,0,'2022-03-03 13:31:23','2022-03-03 13:31:23'),(119100,411,'Porakotla','185203',1,0,'2022-03-03 13:31:23','2022-03-03 13:31:23'),(119101,411,'PTC Udhampur','182104',1,0,'2022-03-03 13:31:23','2022-03-03 13:31:23'),(119102,411,'PTS Udhampur','182101',1,0,'2022-03-03 13:31:23','2022-03-03 13:31:23'),(119103,411,'Pul Kanthan','182313',1,0,'2022-03-03 13:31:23','2022-03-03 13:31:23'),(119104,411,'Ramnagar (Udhampur)','182122',1,0,'2022-03-03 13:31:23','2022-03-03 13:31:23'),(119105,411,'Rang','182122',1,0,'2022-03-03 13:31:24','2022-03-03 13:31:24'),(119106,411,'Ransoo','185203',1,0,'2022-03-03 13:31:24','2022-03-03 13:31:24'),(119107,411,'Rathian','182101',1,0,'2022-03-03 13:31:24','2022-03-03 13:31:24'),(119108,411,'Reasi','182311',1,0,'2022-03-03 13:31:24','2022-03-03 13:31:24'),(119109,411,'Roan','182126',1,0,'2022-03-03 13:31:24','2022-03-03 13:31:24'),(119110,411,'Salal','182312',1,0,'2022-03-03 13:31:24','2022-03-03 13:31:24'),(119111,411,'Salmehri','182128',1,0,'2022-03-03 13:31:24','2022-03-03 13:31:24'),(119112,411,'Salmeri','182101',1,0,'2022-03-03 13:31:24','2022-03-03 13:31:24'),(119113,411,'Samroli','182141',1,0,'2022-03-03 13:31:24','2022-03-03 13:31:24'),(119114,411,'Sangaldhan','182144',1,0,'2022-03-03 13:31:24','2022-03-03 13:31:24'),(119115,411,'Sangote','182142',1,0,'2022-03-03 13:31:24','2022-03-03 13:31:24'),(119116,411,'Sarh','182315',1,0,'2022-03-03 13:31:24','2022-03-03 13:31:24'),(119117,411,'Sarthalkot','182313',1,0,'2022-03-03 13:31:24','2022-03-03 13:31:24'),(119118,411,'Sattian','182122',1,0,'2022-03-03 13:31:24','2022-03-03 13:31:24'),(119119,411,'Satuyalta','182141',1,0,'2022-03-03 13:31:24','2022-03-03 13:31:24'),(119120,411,'Seen Bhramena','182121',1,0,'2022-03-03 13:31:24','2022-03-03 13:31:24'),(119121,411,'Seen Thakrian','182121',1,0,'2022-03-03 13:31:24','2022-03-03 13:31:24'),(119122,411,'Sermanjla','182124',1,0,'2022-03-03 13:31:24','2022-03-03 13:31:24'),(119123,411,'Shajroo','182313',1,0,'2022-03-03 13:31:24','2022-03-03 13:31:24'),(119124,411,'Shaktinagar (Udhampur)','182101',1,0,'2022-03-03 13:31:24','2022-03-03 13:31:24'),(119125,411,'Sila','182311',1,0,'2022-03-03 13:31:24','2022-03-03 13:31:24'),(119126,411,'Sonetar','182122',1,0,'2022-03-03 13:31:24','2022-03-03 13:31:24'),(119127,411,'Sudhmahadev','182141',1,0,'2022-03-03 13:31:25','2022-03-03 13:31:25'),(119128,411,'Sukhalghar','182311',1,0,'2022-03-03 13:31:25','2022-03-03 13:31:25'),(119129,411,'Surjan Dhar','182311',1,0,'2022-03-03 13:31:25','2022-03-03 13:31:25'),(119130,411,'Thalora','182127',1,0,'2022-03-03 13:31:25','2022-03-03 13:31:25'),(119131,411,'Thanpal','182313',1,0,'2022-03-03 13:31:25','2022-03-03 13:31:25'),(119132,411,'Thatharka','182144',1,0,'2022-03-03 13:31:25','2022-03-03 13:31:25'),(119133,411,'Thiloo','182313',1,0,'2022-03-03 13:31:25','2022-03-03 13:31:25'),(119134,411,'Thub','182313',1,0,'2022-03-03 13:31:25','2022-03-03 13:31:25'),(119135,411,'Thuru','182313',1,0,'2022-03-03 13:31:25','2022-03-03 13:31:25'),(119136,411,'Tikri','182121',1,0,'2022-03-03 13:31:25','2022-03-03 13:31:25'),(119137,411,'Tote','182311',1,0,'2022-03-03 13:31:25','2022-03-03 13:31:25'),(119138,411,'Udhampur District Court','182101',1,0,'2022-03-03 13:31:25','2022-03-03 13:31:25'),(119139,411,'Udhampur H.O','182101',1,0,'2022-03-03 13:31:25','2022-03-03 13:31:25'),(119140,411,'Vaishno Devi','182301',1,0,'2022-03-03 13:31:25','2022-03-03 13:31:25'),(119141,411,'Vijaypur','182311',1,0,'2022-03-03 13:31:25','2022-03-03 13:31:25'),(119142,412,'Adrakuri','827013',1,0,'2022-03-03 13:31:25','2022-03-03 13:31:25'),(119143,412,'Alkusa','827013',1,0,'2022-03-03 13:31:25','2022-03-03 13:31:25'),(119144,412,'Amdiha','828134',1,0,'2022-03-03 13:31:25','2022-03-03 13:31:25'),(119145,412,'Amlabad Colliery','828302',1,0,'2022-03-03 13:31:25','2022-03-03 13:31:25'),(119146,412,'Arajoo','829301',1,0,'2022-03-03 13:31:25','2022-03-03 13:31:25'),(119147,412,'Artah','828134',1,0,'2022-03-03 13:31:25','2022-03-03 13:31:25'),(119148,412,'B.M.P. IV','827001',1,0,'2022-03-03 13:31:25','2022-03-03 13:31:25'),(119149,412,'B.Pindragoria','827013',1,0,'2022-03-03 13:31:26','2022-03-03 13:31:26'),(119150,412,'B.S.City Plant','827011',1,0,'2022-03-03 13:31:26','2022-03-03 13:31:26'),(119151,412,'B.S.City R.S.','827010',1,0,'2022-03-03 13:31:26','2022-03-03 13:31:26'),(119152,412,'Bagda','827302',1,0,'2022-03-03 13:31:26','2022-03-03 13:31:26'),(119153,412,'Bahadurpur','829301',1,0,'2022-03-03 13:31:26','2022-03-03 13:31:26'),(119154,412,'Baidmara','827009',1,0,'2022-03-03 13:31:26','2022-03-03 13:31:26'),(119155,412,'Balidih','827014',1,0,'2022-03-03 13:31:26','2022-03-03 13:31:26'),(119156,412,'Bandhdih','829301',1,0,'2022-03-03 13:31:26','2022-03-03 13:31:26'),(119157,412,'Banstore','828134',1,0,'2022-03-03 13:31:26','2022-03-03 13:31:26'),(119158,412,'Barmasia','828134',1,0,'2022-03-03 13:31:26','2022-03-03 13:31:26'),(119159,412,'Baroo','829301',1,0,'2022-03-03 13:31:26','2022-03-03 13:31:26'),(119160,412,'Batbinore','827013',1,0,'2022-03-03 13:31:26','2022-03-03 13:31:26'),(119161,412,'Bhojudih','828303',1,0,'2022-03-03 13:31:26','2022-03-03 13:31:26'),(119162,412,'Bijulia','827013',1,0,'2022-03-03 13:31:26','2022-03-03 13:31:26'),(119163,412,'Bokaro Steel City H.O','827001',1,0,'2022-03-03 13:31:26','2022-03-03 13:31:26'),(119164,412,'Chandan Kiyari','828134',1,0,'2022-03-03 13:31:26','2022-03-03 13:31:26'),(119165,412,'Chando','829301',1,0,'2022-03-03 13:31:26','2022-03-03 13:31:26'),(119166,412,'Chandra','828134',1,0,'2022-03-03 13:31:26','2022-03-03 13:31:26'),(119167,412,'Chas Bazar','827013',1,0,'2022-03-03 13:31:26','2022-03-03 13:31:26'),(119168,412,'Chas (Bokaro)','827013',1,0,'2022-03-03 13:31:26','2022-03-03 13:31:26'),(119169,412,'Chiksia','827013',1,0,'2022-03-03 13:31:27','2022-03-03 13:31:27'),(119170,412,'Chilgada','829301',1,0,'2022-03-03 13:31:27','2022-03-03 13:31:27'),(119171,412,'Civil Court Area Bokaro','827001',1,0,'2022-03-03 13:31:27','2022-03-03 13:31:27'),(119172,412,'Dudhigajar','827013',1,0,'2022-03-03 13:31:27','2022-03-03 13:31:27'),(119173,412,'Durgapur','827302',1,0,'2022-03-03 13:31:27','2022-03-03 13:31:27'),(119174,412,'Galgaltand','828134',1,0,'2022-03-03 13:31:27','2022-03-03 13:31:27'),(119175,412,'Gamhariya','828134',1,0,'2022-03-03 13:31:27','2022-03-03 13:31:27'),(119176,412,'Gangjori','829301',1,0,'2022-03-03 13:31:27','2022-03-03 13:31:27'),(119177,412,'Garga Check Post','827013',1,0,'2022-03-03 13:31:27','2022-03-03 13:31:27'),(119178,412,'Ghagri','828134',1,0,'2022-03-03 13:31:27','2022-03-03 13:31:27'),(119179,412,'Ghatiali','827010',1,0,'2022-03-03 13:31:27','2022-03-03 13:31:27'),(119180,412,'Hissim','827302',1,0,'2022-03-03 13:31:27','2022-03-03 13:31:27'),(119181,412,'Jaina','829301',1,0,'2022-03-03 13:31:27','2022-03-03 13:31:27'),(119182,412,'Jamagoria','827013',1,0,'2022-03-03 13:31:27','2022-03-03 13:31:27'),(119183,412,'Jaridih','827010',1,0,'2022-03-03 13:31:27','2022-03-03 13:31:27'),(119184,412,'Jhalbarda','828134',1,0,'2022-03-03 13:31:27','2022-03-03 13:31:27'),(119185,412,'K.R.Centre','827013',1,0,'2022-03-03 13:31:27','2022-03-03 13:31:27'),(119186,412,'Kanak Chas','828134',1,0,'2022-03-03 13:31:27','2022-03-03 13:31:27'),(119187,412,'Karma','827302',1,0,'2022-03-03 13:31:27','2022-03-03 13:31:27'),(119188,412,'Karmatand','828307',1,0,'2022-03-03 13:31:27','2022-03-03 13:31:27'),(119189,412,'Kashi Jharia','827013',1,0,'2022-03-03 13:31:28','2022-03-03 13:31:28'),(119190,412,'Kasmar','827302',1,0,'2022-03-03 13:31:28','2022-03-03 13:31:28'),(119191,412,'Khaira Chatar','827302',1,0,'2022-03-03 13:31:28','2022-03-03 13:31:28'),(119192,412,'Khamarbendi','827013',1,0,'2022-03-03 13:31:28','2022-03-03 13:31:28'),(119193,412,'Kharkharee','828125',1,0,'2022-03-03 13:31:28','2022-03-03 13:31:28'),(119194,412,'Koria','828134',1,0,'2022-03-03 13:31:28','2022-03-03 13:31:28'),(119195,412,'Kumar Daga','828134',1,0,'2022-03-03 13:31:28','2022-03-03 13:31:28'),(119196,412,'Kumirdoba','828134',1,0,'2022-03-03 13:31:28','2022-03-03 13:31:28'),(119197,412,'Kunduari','827010',1,0,'2022-03-03 13:31:28','2022-03-03 13:31:28'),(119198,412,'Kurra','827013',1,0,'2022-03-03 13:31:28','2022-03-03 13:31:28'),(119199,412,'Lakrakhanda','827010',1,0,'2022-03-03 13:31:28','2022-03-03 13:31:28'),(119200,412,'Makdumpur','827010',1,0,'2022-03-03 13:31:28','2022-03-03 13:31:28'),(119201,412,'Manjura','827302',1,0,'2022-03-03 13:31:28','2022-03-03 13:31:28'),(119202,412,'Marafari Colony','827012',1,0,'2022-03-03 13:31:28','2022-03-03 13:31:28'),(119203,412,'Narayanpur','827013',1,0,'2022-03-03 13:31:28','2022-03-03 13:31:28'),(119204,412,'Olgora','827013',1,0,'2022-03-03 13:31:28','2022-03-03 13:31:28'),(119205,412,'Pathuria','829301',1,0,'2022-03-03 13:31:28','2022-03-03 13:31:28'),(119206,412,'Pindrajora','827013',1,0,'2022-03-03 13:31:28','2022-03-03 13:31:28'),(119207,412,'Pirgul','827302',1,0,'2022-03-03 13:31:28','2022-03-03 13:31:28'),(119208,412,'Ponda','827302',1,0,'2022-03-03 13:31:28','2022-03-03 13:31:28'),(119209,412,'Pundru','828134',1,0,'2022-03-03 13:31:28','2022-03-03 13:31:28'),(119210,412,'Pupunkee Ashram','827013',1,0,'2022-03-03 13:31:29','2022-03-03 13:31:29'),(119211,412,'Radhanagar','827010',1,0,'2022-03-03 13:31:29','2022-03-03 13:31:29'),(119212,412,'Rangamatia','828134',1,0,'2022-03-03 13:31:29','2022-03-03 13:31:29'),(119213,412,'Sardaha','827013',1,0,'2022-03-03 13:31:29','2022-03-03 13:31:29'),(119214,412,'Satanpur','827013',1,0,'2022-03-03 13:31:29','2022-03-03 13:31:29'),(119215,412,'Sector- III','827003',1,0,'2022-03-03 13:31:29','2022-03-03 13:31:29'),(119216,412,'Sector- IV','827004',1,0,'2022-03-03 13:31:29','2022-03-03 13:31:29'),(119217,412,'Sector- IX','827009',1,0,'2022-03-03 13:31:29','2022-03-03 13:31:29'),(119218,412,'Sector-I','827001',1,0,'2022-03-03 13:31:29','2022-03-03 13:31:29'),(119219,412,'Sector-VI','827006',1,0,'2022-03-03 13:31:29','2022-03-03 13:31:29'),(119220,412,'Sibandih','827010',1,0,'2022-03-03 13:31:29','2022-03-03 13:31:29'),(119221,412,'Silphore','828134',1,0,'2022-03-03 13:31:29','2022-03-03 13:31:29'),(119222,412,'Tangtona','827302',1,0,'2022-03-03 13:31:29','2022-03-03 13:31:29'),(119223,412,'Amlo','829104',1,0,'2022-03-03 13:31:29','2022-03-03 13:31:29'),(119224,412,'Angwali','825102',1,0,'2022-03-03 13:31:29','2022-03-03 13:31:29'),(119225,412,'Argamo','829144',1,0,'2022-03-03 13:31:29','2022-03-03 13:31:29'),(119226,412,'Arjuwa','829121',1,0,'2022-03-03 13:31:29','2022-03-03 13:31:29'),(119227,412,'Barkipunu','829112',1,0,'2022-03-03 13:31:29','2022-03-03 13:31:29'),(119228,412,'Bedkaro','829127',1,0,'2022-03-03 13:31:29','2022-03-03 13:31:29'),(119229,412,'Bermo','829104',1,0,'2022-03-03 13:31:29','2022-03-03 13:31:29'),(119230,412,'Bhandaridah','829132',1,0,'2022-03-03 13:31:30','2022-03-03 13:31:30'),(119231,412,'Birni','829144',1,0,'2022-03-03 13:31:30','2022-03-03 13:31:30'),(119232,412,'Bokaro Thermal','829107',1,0,'2022-03-03 13:31:30','2022-03-03 13:31:30'),(119233,412,'Chalkari','829114',1,0,'2022-03-03 13:31:30','2022-03-03 13:31:30'),(119234,412,'Champi','829123',1,0,'2022-03-03 13:31:30','2022-03-03 13:31:30'),(119235,412,'Chandipur','829121',1,0,'2022-03-03 13:31:30','2022-03-03 13:31:30'),(119236,412,'Chandrapura','828403',1,0,'2022-03-03 13:31:30','2022-03-03 13:31:30'),(119237,412,'Chapri','829144',1,0,'2022-03-03 13:31:30','2022-03-03 13:31:30'),(119238,412,'Chargi','829121',1,0,'2022-03-03 13:31:30','2022-03-03 13:31:30'),(119239,412,'Chirudih','829144',1,0,'2022-03-03 13:31:30','2022-03-03 13:31:30'),(119240,412,'Dania','829112',1,0,'2022-03-03 13:31:30','2022-03-03 13:31:30'),(119241,412,'Dantoo','829121',1,0,'2022-03-03 13:31:30','2022-03-03 13:31:30'),(119242,412,'Dhori','825102',1,0,'2022-03-03 13:31:30','2022-03-03 13:31:30'),(119243,412,'Dugdha Coal washery','828404',1,0,'2022-03-03 13:31:30','2022-03-03 13:31:30'),(119244,412,'Gomia','829111',1,0,'2022-03-03 13:31:30','2022-03-03 13:31:30'),(119245,412,'Guniato','829107',1,0,'2022-03-03 13:31:30','2022-03-03 13:31:30'),(119246,412,'Gunjardih','829132',1,0,'2022-03-03 13:31:30','2022-03-03 13:31:30'),(119247,412,'Hardiamo','829111',1,0,'2022-03-03 13:31:30','2022-03-03 13:31:30'),(119248,412,'Hazari','829128',1,0,'2022-03-03 13:31:30','2022-03-03 13:31:30'),(119249,412,'Hossir','829111',1,0,'2022-03-03 13:31:30','2022-03-03 13:31:30'),(119250,412,'I.E.Gomia','829112',1,0,'2022-03-03 13:31:31','2022-03-03 13:31:31'),(119251,412,'Jarangdih Colliery','829113',1,0,'2022-03-03 13:31:31','2022-03-03 13:31:31'),(119252,412,'Jaridih Bazar','829114',1,0,'2022-03-03 13:31:31','2022-03-03 13:31:31'),(119253,412,'Kanjkiro','829107',1,0,'2022-03-03 13:31:31','2022-03-03 13:31:31'),(119254,412,'Kathara','829116',1,0,'2022-03-03 13:31:31','2022-03-03 13:31:31'),(119255,412,'Kharki','829112',1,0,'2022-03-03 13:31:31','2022-03-03 13:31:31'),(119256,412,'Khetko','829113',1,0,'2022-03-03 13:31:31','2022-03-03 13:31:31'),(119257,412,'Khetko Murmu','825322',1,0,'2022-03-03 13:31:31','2022-03-03 13:31:31'),(119258,412,'Kurumba','828403',1,0,'2022-03-03 13:31:31','2022-03-03 13:31:31'),(119259,412,'Makoli','829144',1,0,'2022-03-03 13:31:31','2022-03-03 13:31:31'),(119260,412,'Mirzapur','829121',1,0,'2022-03-03 13:31:31','2022-03-03 13:31:31'),(119261,412,'Mungasarla','829121',1,0,'2022-03-03 13:31:31','2022-03-03 13:31:31'),(119262,412,'Narayanpur','829107',1,0,'2022-03-03 13:31:31','2022-03-03 13:31:31'),(119263,412,'Narra','828403',1,0,'2022-03-03 13:31:31','2022-03-03 13:31:31'),(119264,412,'Nawadih','829144',1,0,'2022-03-03 13:31:31','2022-03-03 13:31:31'),(119265,412,'Nerki','829112',1,0,'2022-03-03 13:31:31','2022-03-03 13:31:31'),(119266,412,'Ordana','829121',1,0,'2022-03-03 13:31:31','2022-03-03 13:31:31'),(119267,412,'Palamu','825102',1,0,'2022-03-03 13:31:31','2022-03-03 13:31:31'),(119268,412,'Parasbani','828403',1,0,'2022-03-03 13:31:31','2022-03-03 13:31:31'),(119269,412,'Penk','829112',1,0,'2022-03-03 13:31:31','2022-03-03 13:31:31'),(119270,412,'Peterbar','829121',1,0,'2022-03-03 13:31:32','2022-03-03 13:31:32'),(119271,412,'Phusro Bazar','829144',1,0,'2022-03-03 13:31:32','2022-03-03 13:31:32'),(119272,412,'Pichari','829144',1,0,'2022-03-03 13:31:32','2022-03-03 13:31:32'),(119273,412,'Potso','829144',1,0,'2022-03-03 13:31:32','2022-03-03 13:31:32'),(119274,412,'Right Bank Tenughat','829123',1,0,'2022-03-03 13:31:32','2022-03-03 13:31:32'),(119275,412,'Rohar','829121',1,0,'2022-03-03 13:31:32','2022-03-03 13:31:32'),(119276,412,'Saram','829111',1,0,'2022-03-03 13:31:32','2022-03-03 13:31:32'),(119277,412,'Sunday Bazar','829127',1,0,'2022-03-03 13:31:32','2022-03-03 13:31:32'),(119278,412,'Surhi','829144',1,0,'2022-03-03 13:31:32','2022-03-03 13:31:32'),(119279,412,'Swang Colliery','829128',1,0,'2022-03-03 13:31:32','2022-03-03 13:31:32'),(119280,412,'T.T.P.S.Lalpania','829149',1,0,'2022-03-03 13:31:32','2022-03-03 13:31:32'),(119281,412,'Tantri','829144',1,0,'2022-03-03 13:31:32','2022-03-03 13:31:32'),(119282,412,'Taranari','828403',1,0,'2022-03-03 13:31:32','2022-03-03 13:31:32'),(119283,412,'Taranga','828403',1,0,'2022-03-03 13:31:32','2022-03-03 13:31:32'),(119284,412,'Telo','828403',1,0,'2022-03-03 13:31:32','2022-03-03 13:31:32'),(119285,412,'Tenughat Dam','829123',1,0,'2022-03-03 13:31:32','2022-03-03 13:31:32'),(119286,412,'Turio','829132',1,0,'2022-03-03 13:31:32','2022-03-03 13:31:32'),(119287,412,'Ulgada','829123',1,0,'2022-03-03 13:31:32','2022-03-03 13:31:32'),(119288,412,'Uttasara','829121',1,0,'2022-03-03 13:31:32','2022-03-03 13:31:32'),(119289,412,'Chatrochatti','825315',1,0,'2022-03-03 13:31:32','2022-03-03 13:31:32'),(119290,412,'Chuttey','825315',1,0,'2022-03-03 13:31:32','2022-03-03 13:31:32'),(119291,412,'Kuruknalo','825315',1,0,'2022-03-03 13:31:32','2022-03-03 13:31:32'),(119292,412,'Maliachak','814155',1,0,'2022-03-03 13:31:33','2022-03-03 13:31:33'),(119293,413,'Amjhar','825408',1,0,'2022-03-03 13:31:33','2022-03-03 13:31:33'),(119294,413,'Aurugerua','825401',1,0,'2022-03-03 13:31:33','2022-03-03 13:31:33'),(119295,413,'Bagra','825103',1,0,'2022-03-03 13:31:33','2022-03-03 13:31:33'),(119296,413,'Bahera','825321',1,0,'2022-03-03 13:31:33','2022-03-03 13:31:33'),(119297,413,'Baluri','825401',1,0,'2022-03-03 13:31:33','2022-03-03 13:31:33'),(119298,413,'Baraini','825401',1,0,'2022-03-03 13:31:33','2022-03-03 13:31:33'),(119299,413,'Bargaon','825408',1,0,'2022-03-03 13:31:33','2022-03-03 13:31:33'),(119300,413,'Barisakhi','825408',1,0,'2022-03-03 13:31:33','2022-03-03 13:31:33'),(119301,413,'Berhna','825408',1,0,'2022-03-03 13:31:33','2022-03-03 13:31:33'),(119302,413,'Bichkila','825404',1,0,'2022-03-03 13:31:33','2022-03-03 13:31:33'),(119303,413,'Bihiasarhachiya','825403',1,0,'2022-03-03 13:31:33','2022-03-03 13:31:33'),(119304,413,'Chandrikala','825404',1,0,'2022-03-03 13:31:33','2022-03-03 13:31:33'),(119305,413,'Chatra Bazar','825401',1,0,'2022-03-03 13:31:33','2022-03-03 13:31:33'),(119306,413,'Chatra (Chatra)','825401',1,0,'2022-03-03 13:31:33','2022-03-03 13:31:33'),(119307,413,'Chatti Anatpur','825404',1,0,'2022-03-03 13:31:33','2022-03-03 13:31:33'),(119308,413,'Chattibariatu','825321',1,0,'2022-03-03 13:31:33','2022-03-03 13:31:33'),(119309,413,'Chopey','825103',1,0,'2022-03-03 13:31:33','2022-03-03 13:31:33'),(119310,413,'Daihar','825408',1,0,'2022-03-03 13:31:33','2022-03-03 13:31:33'),(119311,413,'Dantar','825403',1,0,'2022-03-03 13:31:34','2022-03-03 13:31:34'),(119312,413,'Delho','825103',1,0,'2022-03-03 13:31:34','2022-03-03 13:31:34'),(119313,413,'Dhangada','825321',1,0,'2022-03-03 13:31:34','2022-03-03 13:31:34'),(119314,413,'Dhauthawa','825408',1,0,'2022-03-03 13:31:34','2022-03-03 13:31:34'),(119315,413,'Dunduwa','825103',1,0,'2022-03-03 13:31:34','2022-03-03 13:31:34'),(119316,413,'Dwaritelaiya','825408',1,0,'2022-03-03 13:31:34','2022-03-03 13:31:34'),(119317,413,'Edla','825103',1,0,'2022-03-03 13:31:34','2022-03-03 13:31:34'),(119318,413,'Gangpur','825408',1,0,'2022-03-03 13:31:34','2022-03-03 13:31:34'),(119319,413,'Gerua','825404',1,0,'2022-03-03 13:31:34','2022-03-03 13:31:34'),(119320,413,'Ghanghari','825401',1,0,'2022-03-03 13:31:34','2022-03-03 13:31:34'),(119321,413,'Gidhour','825408',1,0,'2022-03-03 13:31:34','2022-03-03 13:31:34'),(119322,413,'Haphuwa','825401',1,0,'2022-03-03 13:31:34','2022-03-03 13:31:34'),(119323,413,'Hiring','825403',1,0,'2022-03-03 13:31:34','2022-03-03 13:31:34'),(119324,413,'Hunterganj','825403',1,0,'2022-03-03 13:31:34','2022-03-03 13:31:34'),(119325,413,'Itkhori','825408',1,0,'2022-03-03 13:31:34','2022-03-03 13:31:34'),(119326,413,'Jabra','825103',1,0,'2022-03-03 13:31:34','2022-03-03 13:31:34'),(119327,413,'Jajlo','825401',1,0,'2022-03-03 13:31:34','2022-03-03 13:31:34'),(119328,413,'Jogiara','825404',1,0,'2022-03-03 13:31:34','2022-03-03 13:31:34'),(119329,413,'Jori','825403',1,0,'2022-03-03 13:31:34','2022-03-03 13:31:34'),(119330,413,'Kamta','825401',1,0,'2022-03-03 13:31:34','2022-03-03 13:31:34'),(119331,413,'Kanhachatti','825401',1,0,'2022-03-03 13:31:35','2022-03-03 13:31:35'),(119332,413,'Karma','825401',1,0,'2022-03-03 13:31:35','2022-03-03 13:31:35'),(119333,413,'Karni','825408',1,0,'2022-03-03 13:31:35','2022-03-03 13:31:35'),(119334,413,'Kasiadih','825321',1,0,'2022-03-03 13:31:35','2022-03-03 13:31:35'),(119335,413,'Kaura','825404',1,0,'2022-03-03 13:31:35','2022-03-03 13:31:35'),(119336,413,'Kedlikala','825403',1,0,'2022-03-03 13:31:35','2022-03-03 13:31:35'),(119337,413,'Khadaiya','825321',1,0,'2022-03-03 13:31:35','2022-03-03 13:31:35'),(119338,413,'Kobna','825403',1,0,'2022-03-03 13:31:35','2022-03-03 13:31:35'),(119339,413,'Kolhaiya','825401',1,0,'2022-03-03 13:31:35','2022-03-03 13:31:35'),(119340,413,'Kuba','825401',1,0,'2022-03-03 13:31:35','2022-03-03 13:31:35'),(119341,413,'Kunda','825404',1,0,'2022-03-03 13:31:35','2022-03-03 13:31:35'),(119342,413,'Kurkheta','825403',1,0,'2022-03-03 13:31:35','2022-03-03 13:31:35'),(119343,413,'Laralutudag','825401',1,0,'2022-03-03 13:31:35','2022-03-03 13:31:35'),(119344,413,'Lawalong','825103',1,0,'2022-03-03 13:31:35','2022-03-03 13:31:35'),(119345,413,'Loram','825408',1,0,'2022-03-03 13:31:35','2022-03-03 13:31:35'),(119346,413,'Manatu','825321',1,0,'2022-03-03 13:31:35','2022-03-03 13:31:35'),(119347,413,'Mandhania','825408',1,0,'2022-03-03 13:31:35','2022-03-03 13:31:35'),(119348,413,'Mayapur','825408',1,0,'2022-03-03 13:31:35','2022-03-03 13:31:35'),(119349,413,'Mayurhand','825408',1,0,'2022-03-03 13:31:36','2022-03-03 13:31:36'),(119350,413,'Mktama','825401',1,0,'2022-03-03 13:31:36','2022-03-03 13:31:36'),(119351,413,'Narayanpur','825404',1,0,'2022-03-03 13:31:36','2022-03-03 13:31:36'),(119352,413,'Navadih Damol','825408',1,0,'2022-03-03 13:31:36','2022-03-03 13:31:36'),(119353,413,'Nawadih Panari','825401',1,0,'2022-03-03 13:31:36','2022-03-03 13:31:36'),(119354,413,'Pachra','825321',1,0,'2022-03-03 13:31:36','2022-03-03 13:31:36'),(119355,413,'Pandeypura','825401',1,0,'2022-03-03 13:31:36','2022-03-03 13:31:36'),(119356,413,'Parsauni','825408',1,0,'2022-03-03 13:31:36','2022-03-03 13:31:36'),(119357,413,'Pathalgada','825408',1,0,'2022-03-03 13:31:36','2022-03-03 13:31:36'),(119358,413,'Pathra','825408',1,0,'2022-03-03 13:31:36','2022-03-03 13:31:36'),(119359,413,'Peltol','825408',1,0,'2022-03-03 13:31:36','2022-03-03 13:31:36'),(119360,413,'Peto','825321',1,0,'2022-03-03 13:31:36','2022-03-03 13:31:36'),(119361,413,'Pindra','825403',1,0,'2022-03-03 13:31:36','2022-03-03 13:31:36'),(119362,413,'Piri','825103',1,0,'2022-03-03 13:31:36','2022-03-03 13:31:36'),(119363,413,'Pitiz','825408',1,0,'2022-03-03 13:31:36','2022-03-03 13:31:36'),(119364,413,'Pratappur (Chatra)','825404',1,0,'2022-03-03 13:31:36','2022-03-03 13:31:36'),(119365,413,'Raham','825321',1,0,'2022-03-03 13:31:36','2022-03-03 13:31:36'),(119366,413,'Sahi','825403',1,0,'2022-03-03 13:31:36','2022-03-03 13:31:36'),(119367,413,'Salaiya','825403',1,0,'2022-03-03 13:31:37','2022-03-03 13:31:37'),(119368,413,'Salga','825321',1,0,'2022-03-03 13:31:37','2022-03-03 13:31:37'),(119369,413,'Saradhu','825321',1,0,'2022-03-03 13:31:37','2022-03-03 13:31:37'),(119370,413,'Shila','825103',1,0,'2022-03-03 13:31:37','2022-03-03 13:31:37'),(119371,413,'Shivrajpur','825103',1,0,'2022-03-03 13:31:37','2022-03-03 13:31:37'),(119372,413,'Simaria','825103',1,0,'2022-03-03 13:31:37','2022-03-03 13:31:37'),(119373,413,'Tandwa (Chatra)','825321',1,0,'2022-03-03 13:31:37','2022-03-03 13:31:37'),(119374,413,'Tapej','825401',1,0,'2022-03-03 13:31:37','2022-03-03 13:31:37'),(119375,413,'Tatra','825401',1,0,'2022-03-03 13:31:37','2022-03-03 13:31:37'),(119376,413,'Tikar','825401',1,0,'2022-03-03 13:31:37','2022-03-03 13:31:37'),(119377,413,'Tulbul','825401',1,0,'2022-03-03 13:31:37','2022-03-03 13:31:37'),(119378,413,'Tutilawa','825103',1,0,'2022-03-03 13:31:37','2022-03-03 13:31:37'),(119379,413,'Unta','825401',1,0,'2022-03-03 13:31:37','2022-03-03 13:31:37'),(119380,413,'Yadavnagar','825404',1,0,'2022-03-03 13:31:37','2022-03-03 13:31:37'),(119381,413,'Bachra','829201',1,0,'2022-03-03 13:31:37','2022-03-03 13:31:37'),(119382,414,'A.K. Bad','814143',1,0,'2022-03-03 13:31:37','2022-03-03 13:31:37'),(119383,414,'Asna','814146',1,0,'2022-03-03 13:31:37','2022-03-03 13:31:37'),(119384,414,'B. MANDIR','814112',1,0,'2022-03-03 13:31:37','2022-03-03 13:31:37'),(119385,414,'B.Deoghar H.O','814112',1,0,'2022-03-03 13:31:37','2022-03-03 13:31:37'),(119386,414,'Baghmari','814152',1,0,'2022-03-03 13:31:37','2022-03-03 13:31:37'),(119387,414,'Bagjora','815353',1,0,'2022-03-03 13:31:37','2022-03-03 13:31:37'),(119388,414,'Baijukura','814143',1,0,'2022-03-03 13:31:37','2022-03-03 13:31:37'),(119389,414,'Bamandiha','814149',1,0,'2022-03-03 13:31:37','2022-03-03 13:31:37'),(119390,414,'Bamangama','815353',1,0,'2022-03-03 13:31:38','2022-03-03 13:31:38'),(119391,414,'Banka','814142',1,0,'2022-03-03 13:31:38','2022-03-03 13:31:38'),(119392,414,'Bansbutia','814146',1,0,'2022-03-03 13:31:38','2022-03-03 13:31:38'),(119393,414,'Bara Chapra','815353',1,0,'2022-03-03 13:31:38','2022-03-03 13:31:38'),(119394,414,'Baramsoli','815357',1,0,'2022-03-03 13:31:38','2022-03-03 13:31:38'),(119395,414,'Baratanr','815357',1,0,'2022-03-03 13:31:38','2022-03-03 13:31:38'),(119396,414,'Barawan','815353',1,0,'2022-03-03 13:31:38','2022-03-03 13:31:38'),(119397,414,'Bargo','814120',1,0,'2022-03-03 13:31:38','2022-03-03 13:31:38'),(119398,414,'Barkikharkhar','814152',1,0,'2022-03-03 13:31:38','2022-03-03 13:31:38'),(119399,414,'Baskupi','815357',1,0,'2022-03-03 13:31:38','2022-03-03 13:31:38'),(119400,414,'Bhojpur','814152',1,0,'2022-03-03 13:31:38','2022-03-03 13:31:38'),(119401,414,'Bichgarha Kusumdih','814113',1,0,'2022-03-03 13:31:38','2022-03-03 13:31:38'),(119402,414,'Burhai','815353',1,0,'2022-03-03 13:31:38','2022-03-03 13:31:38'),(119403,414,'Chanddih','814143',1,0,'2022-03-03 13:31:38','2022-03-03 13:31:38'),(119404,414,'Charak Mara','814149',1,0,'2022-03-03 13:31:38','2022-03-03 13:31:38'),(119405,414,'Charpa','815353',1,0,'2022-03-03 13:31:38','2022-03-03 13:31:38'),(119406,414,'Choudri Nawadih','814149',1,0,'2022-03-03 13:31:39','2022-03-03 13:31:39'),(119407,414,'Chulhiya','814157',1,0,'2022-03-03 13:31:39','2022-03-03 13:31:39'),(119408,414,'Dabar Gram','814142',1,0,'2022-03-03 13:31:39','2022-03-03 13:31:39'),(119409,414,'Daluraidih','814152',1,0,'2022-03-03 13:31:39','2022-03-03 13:31:39'),(119410,414,'Debipur','814152',1,0,'2022-03-03 13:31:39','2022-03-03 13:31:39'),(119411,414,'Dehijore','814157',1,0,'2022-03-03 13:31:39','2022-03-03 13:31:39'),(119412,414,'Deoghar College','814113',1,0,'2022-03-03 13:31:39','2022-03-03 13:31:39'),(119413,414,'Deoghar Court','814112',1,0,'2022-03-03 13:31:39','2022-03-03 13:31:39'),(119414,414,'Deopur','814142',1,0,'2022-03-03 13:31:39','2022-03-03 13:31:39'),(119415,414,'Deosang B.T','814114',1,0,'2022-03-03 13:31:39','2022-03-03 13:31:39'),(119416,414,'Dhamni','815353',1,0,'2022-03-03 13:31:39','2022-03-03 13:31:39'),(119417,414,'Dumaria','814149',1,0,'2022-03-03 13:31:39','2022-03-03 13:31:39'),(119418,414,'Ghorlas','814152',1,0,'2022-03-03 13:31:39','2022-03-03 13:31:39'),(119419,414,'Ghormara','814120',1,0,'2022-03-03 13:31:39','2022-03-03 13:31:39'),(119420,414,'Gopibandh','814149',1,0,'2022-03-03 13:31:39','2022-03-03 13:31:39'),(119421,414,'Gurukul Vidyapith','814114',1,0,'2022-03-03 13:31:39','2022-03-03 13:31:39'),(119422,414,'Haripur Kolwa','815353',1,0,'2022-03-03 13:31:39','2022-03-03 13:31:39'),(119423,414,'Hindipith','814115',1,0,'2022-03-03 13:31:39','2022-03-03 13:31:39'),(119424,414,'Hussainabad','815353',1,0,'2022-03-03 13:31:39','2022-03-03 13:31:39'),(119425,414,'Jagdishpur','815353',1,0,'2022-03-03 13:31:39','2022-03-03 13:31:39'),(119426,414,'Jamunia','814157',1,0,'2022-03-03 13:31:39','2022-03-03 13:31:39'),(119427,414,'Jasidih','814142',1,0,'2022-03-03 13:31:39','2022-03-03 13:31:39'),(119428,414,'Jhagrahi','814149',1,0,'2022-03-03 13:31:40','2022-03-03 13:31:40'),(119429,414,'Jhallar','814120',1,0,'2022-03-03 13:31:40','2022-03-03 13:31:40'),(119430,414,'Jhaunsagarhi','814112',1,0,'2022-03-03 13:31:40','2022-03-03 13:31:40'),(119431,414,'Jhaunsa-Garti','814122',1,0,'2022-03-03 13:31:40','2022-03-03 13:31:40'),(119432,414,'Jhillighat','814157',1,0,'2022-03-03 13:31:40','2022-03-03 13:31:40'),(119433,414,'K. Banskola','814152',1,0,'2022-03-03 13:31:40','2022-03-03 13:31:40'),(119434,414,'Karanjo','815353',1,0,'2022-03-03 13:31:40','2022-03-03 13:31:40'),(119435,414,'Karogram','815357',1,0,'2022-03-03 13:31:40','2022-03-03 13:31:40'),(119436,414,'Kasathi','815353',1,0,'2022-03-03 13:31:40','2022-03-03 13:31:40'),(119437,414,'Kenmankathi','814142',1,0,'2022-03-03 13:31:40','2022-03-03 13:31:40'),(119438,414,'Kharagdiha','814157',1,0,'2022-03-03 13:31:40','2022-03-03 13:31:40'),(119439,414,'Koiridih','814152',1,0,'2022-03-03 13:31:40','2022-03-03 13:31:40'),(119440,414,'Kukraha','815357',1,0,'2022-03-03 13:31:40','2022-03-03 13:31:40'),(119441,414,'Kunda (Deoghar)','814143',1,0,'2022-03-03 13:31:40','2022-03-03 13:31:40'),(119442,414,'Kushmaha','815353',1,0,'2022-03-03 13:31:40','2022-03-03 13:31:40'),(119443,414,'Kusmaha','814113',1,0,'2022-03-03 13:31:40','2022-03-03 13:31:40'),(119444,414,'Lakhoria','814150',1,0,'2022-03-03 13:31:40','2022-03-03 13:31:40'),(119445,414,'Madankatha','815357',1,0,'2022-03-03 13:31:40','2022-03-03 13:31:40'),(119446,414,'Madhopur','814142',1,0,'2022-03-03 13:31:40','2022-03-03 13:31:40'),(119447,414,'Madhuban','814150',1,0,'2022-03-03 13:31:40','2022-03-03 13:31:40'),(119448,414,'Madhupur Bazar','815353',1,0,'2022-03-03 13:31:40','2022-03-03 13:31:40'),(119449,414,'Madhupur','815353',1,0,'2022-03-03 13:31:41','2022-03-03 13:31:41'),(119450,414,'Magdiha','814150',1,0,'2022-03-03 13:31:41','2022-03-03 13:31:41'),(119451,414,'Maladih','814114',1,0,'2022-03-03 13:31:41','2022-03-03 13:31:41'),(119452,414,'Malhara','814157',1,0,'2022-03-03 13:31:41','2022-03-03 13:31:41'),(119453,414,'Manigarhi','814150',1,0,'2022-03-03 13:31:41','2022-03-03 13:31:41'),(119454,414,'Maniyarpur','814152',1,0,'2022-03-03 13:31:41','2022-03-03 13:31:41'),(119455,414,'Margomunda','815353',1,0,'2022-03-03 13:31:41','2022-03-03 13:31:41'),(119456,414,'Mathurapur','814114',1,0,'2022-03-03 13:31:41','2022-03-03 13:31:41'),(119457,414,'Mohanpur Hat','814157',1,0,'2022-03-03 13:31:41','2022-03-03 13:31:41'),(119458,414,'Morney','814120',1,0,'2022-03-03 13:31:41','2022-03-03 13:31:41'),(119459,414,'Ojhadih','815353',1,0,'2022-03-03 13:31:41','2022-03-03 13:31:41'),(119460,414,'Paharidih','814150',1,0,'2022-03-03 13:31:41','2022-03-03 13:31:41'),(119461,414,'Pahariya','814150',1,0,'2022-03-03 13:31:41','2022-03-03 13:31:41'),(119462,414,'Palojori','814146',1,0,'2022-03-03 13:31:41','2022-03-03 13:31:41'),(119463,414,'Patharda','815353',1,0,'2022-03-03 13:31:41','2022-03-03 13:31:41'),(119464,414,'Pathrol','815353',1,0,'2022-03-03 13:31:41','2022-03-03 13:31:41'),(119465,414,'Paway','814150',1,0,'2022-03-03 13:31:41','2022-03-03 13:31:41'),(119466,414,'Phulchuan','814149',1,0,'2022-03-03 13:31:41','2022-03-03 13:31:41'),(119467,414,'Poraiyahat','814153',1,0,'2022-03-03 13:31:41','2022-03-03 13:31:41'),(119468,414,'Punasi','814152',1,0,'2022-03-03 13:31:41','2022-03-03 13:31:41'),(119469,414,'Purjori','814150',1,0,'2022-03-03 13:31:41','2022-03-03 13:31:41'),(119470,414,'Rakti','814150',1,0,'2022-03-03 13:31:42','2022-03-03 13:31:42'),(119471,414,'Ramchandrapur','815353',1,0,'2022-03-03 13:31:42','2022-03-03 13:31:42'),(119472,414,'Ramudih','814152',1,0,'2022-03-03 13:31:42','2022-03-03 13:31:42'),(119473,414,'Ranidih','815357',1,0,'2022-03-03 13:31:42','2022-03-03 13:31:42'),(119474,414,'Rarhiya','814113',1,0,'2022-03-03 13:31:42','2022-03-03 13:31:42'),(119475,414,'Rikhiya','814113',1,0,'2022-03-03 13:31:42','2022-03-03 13:31:42'),(119476,414,'Rohani','814152',1,0,'2022-03-03 13:31:42','2022-03-03 13:31:42'),(119477,414,'Sabaijore','814149',1,0,'2022-03-03 13:31:42','2022-03-03 13:31:42'),(119478,414,'Sakrigali','814114',1,0,'2022-03-03 13:31:42','2022-03-03 13:31:42'),(119479,414,'Sangrampur Lorhiya','814114',1,0,'2022-03-03 13:31:42','2022-03-03 13:31:42'),(119480,414,'Saptar','815353',1,0,'2022-03-03 13:31:42','2022-03-03 13:31:42'),(119481,414,'Sarath','814149',1,0,'2022-03-03 13:31:42','2022-03-03 13:31:42'),(119482,414,'Sarwan','814150',1,0,'2022-03-03 13:31:42','2022-03-03 13:31:42'),(119483,414,'Satsang','814116',1,0,'2022-03-03 13:31:42','2022-03-03 13:31:42'),(119484,414,'Siktiya','815357',1,0,'2022-03-03 13:31:42','2022-03-03 13:31:42'),(119485,414,'Simarjore','814120',1,0,'2022-03-03 13:31:42','2022-03-03 13:31:42'),(119486,414,'Simra','814114',1,0,'2022-03-03 13:31:42','2022-03-03 13:31:42'),(119487,414,'Sirsa','815353',1,0,'2022-03-03 13:31:42','2022-03-03 13:31:42'),(119488,414,'Sonaraithari','814150',1,0,'2022-03-03 13:31:42','2022-03-03 13:31:42'),(119489,414,'T Basdiha','814120',1,0,'2022-03-03 13:31:43','2022-03-03 13:31:43'),(119490,414,'T. Balasi','814113',1,0,'2022-03-03 13:31:43','2022-03-03 13:31:43'),(119491,414,'Tapoban','814143',1,0,'2022-03-03 13:31:43','2022-03-03 13:31:43'),(119492,414,'Tilakpur','814150',1,0,'2022-03-03 13:31:43','2022-03-03 13:31:43'),(119493,414,'Upper Bahiyar','815353',1,0,'2022-03-03 13:31:43','2022-03-03 13:31:43'),(119494,414,'Vidyapith','814113',1,0,'2022-03-03 13:31:43','2022-03-03 13:31:43'),(119495,415,'A.C.C. Colony','828124',1,0,'2022-03-03 13:31:43','2022-03-03 13:31:43'),(119496,415,'Ambona','828201',1,0,'2022-03-03 13:31:43','2022-03-03 13:31:43'),(119497,415,'Amlapara Jharia','828111',1,0,'2022-03-03 13:31:43','2022-03-03 13:31:43'),(119498,415,'Amtal','828111',1,0,'2022-03-03 13:31:43','2022-03-03 13:31:43'),(119499,415,'Angarpathra','828113',1,0,'2022-03-03 13:31:43','2022-03-03 13:31:43'),(119500,415,'Ankduara','828201',1,0,'2022-03-03 13:31:43','2022-03-03 13:31:43'),(119501,415,'B.Polytechnic','828130',1,0,'2022-03-03 13:31:43','2022-03-03 13:31:43'),(119502,415,'Bagdaha','828113',1,0,'2022-03-03 13:31:43','2022-03-03 13:31:43'),(119503,415,'Bagdigi','828110',1,0,'2022-03-03 13:31:43','2022-03-03 13:31:43'),(119504,415,'Baghmara','828201',1,0,'2022-03-03 13:31:43','2022-03-03 13:31:43'),(119505,415,'Baghmara Bazar','828306',1,0,'2022-03-03 13:31:43','2022-03-03 13:31:43'),(119506,415,'Bagsuma','828109',1,0,'2022-03-03 13:31:43','2022-03-03 13:31:43'),(119507,415,'Baliapur','828201',1,0,'2022-03-03 13:31:44','2022-03-03 13:31:44'),(119508,415,'Balihari','828116',1,0,'2022-03-03 13:31:44','2022-03-03 13:31:44'),(119509,415,'Bansjora','828101',1,0,'2022-03-03 13:31:44','2022-03-03 13:31:44'),(119510,415,'Bara Putki','828116',1,0,'2022-03-03 13:31:44','2022-03-03 13:31:44'),(119511,415,'Barbendia','828205',1,0,'2022-03-03 13:31:44','2022-03-03 13:31:44'),(119512,415,'Bardohi','828109',1,0,'2022-03-03 13:31:44','2022-03-03 13:31:44'),(119513,415,'Barwa','828205',1,0,'2022-03-03 13:31:44','2022-03-03 13:31:44'),(119514,415,'Bastacola','828106',1,0,'2022-03-03 13:31:44','2022-03-03 13:31:44'),(119515,415,'BCCl Township','826005',1,0,'2022-03-03 13:31:44','2022-03-03 13:31:44'),(119516,415,'Benagoria','828204',1,0,'2022-03-03 13:31:44','2022-03-03 13:31:44'),(119517,415,'Benagoria','828205',1,0,'2022-03-03 13:31:44','2022-03-03 13:31:44'),(119518,415,'Bhadrichak','828121',1,0,'2022-03-03 13:31:44','2022-03-03 13:31:44'),(119519,415,'Bhaga','828301',1,0,'2022-03-03 13:31:44','2022-03-03 13:31:44'),(119520,415,'Bhagabandh','828111',1,0,'2022-03-03 13:31:44','2022-03-03 13:31:44'),(119521,415,'Bhagatdih','828111',1,0,'2022-03-03 13:31:44','2022-03-03 13:31:44'),(119522,415,'Bhaski','827302',1,0,'2022-03-03 13:31:44','2022-03-03 13:31:44'),(119523,415,'Bhatdih','828308',1,0,'2022-03-03 13:31:44','2022-03-03 13:31:44'),(119524,415,'Bhelatand','828103',1,0,'2022-03-03 13:31:44','2022-03-03 13:31:44'),(119525,415,'Bhendra','828401',1,0,'2022-03-03 13:31:44','2022-03-03 13:31:44'),(119526,415,'Bhitia','828109',1,0,'2022-03-03 13:31:45','2022-03-03 13:31:45'),(119527,415,'Bhowra','828302',1,0,'2022-03-03 13:31:45','2022-03-03 13:31:45'),(119528,415,'Bhulan Bararee','828133',1,0,'2022-03-03 13:31:45','2022-03-03 13:31:45'),(119529,415,'Bhuli','828104',1,0,'2022-03-03 13:31:45','2022-03-03 13:31:45'),(119530,415,'Bhutgoria','828301',1,0,'2022-03-03 13:31:45','2022-03-03 13:31:45'),(119531,415,'Birajpur','828113',1,0,'2022-03-03 13:31:45','2022-03-03 13:31:45'),(119532,415,'Birsinghpur','828205',1,0,'2022-03-03 13:31:45','2022-03-03 13:31:45'),(119533,415,'Bowakalan','828104',1,0,'2022-03-03 13:31:45','2022-03-03 13:31:45'),(119534,415,'Brahmandiha','828402',1,0,'2022-03-03 13:31:45','2022-03-03 13:31:45'),(119535,415,'Burragarh','828117',1,0,'2022-03-03 13:31:45','2022-03-03 13:31:45'),(119536,415,'Chanchpottery','828202',1,0,'2022-03-03 13:31:45','2022-03-03 13:31:45'),(119537,415,'Chandore','828121',1,0,'2022-03-03 13:31:45','2022-03-03 13:31:45'),(119538,415,'Charak','828109',1,0,'2022-03-03 13:31:45','2022-03-03 13:31:45'),(119539,415,'Chasnalla','828135',1,0,'2022-03-03 13:31:45','2022-03-03 13:31:45'),(119540,415,'Chipkia','828109',1,0,'2022-03-03 13:31:45','2022-03-03 13:31:45'),(119541,415,'Chirkunda','828202',1,0,'2022-03-03 13:31:45','2022-03-03 13:31:45'),(119542,415,'Cmpf','826001',1,0,'2022-03-03 13:31:45','2022-03-03 13:31:45'),(119543,415,'Cmrs','826001',1,0,'2022-03-03 13:31:45','2022-03-03 13:31:45'),(119544,415,'D.S.E.','826001',1,0,'2022-03-03 13:31:45','2022-03-03 13:31:45'),(119545,415,'Daldali','828204',1,0,'2022-03-03 13:31:45','2022-03-03 13:31:45'),(119546,415,'Daludih','828113',1,0,'2022-03-03 13:31:45','2022-03-03 13:31:45'),(119547,415,'Damodarpur','826004',1,0,'2022-03-03 13:31:45','2022-03-03 13:31:45'),(119548,415,'Debiana','828205',1,0,'2022-03-03 13:31:45','2022-03-03 13:31:45'),(119549,415,'Dhanbad Bazar','826001',1,0,'2022-03-03 13:31:46','2022-03-03 13:31:46'),(119550,415,'Dhanbad H.O','826001',1,0,'2022-03-03 13:31:46','2022-03-03 13:31:46'),(119551,415,'Dhanbad Hirapur','826001',1,0,'2022-03-03 13:31:46','2022-03-03 13:31:46'),(119552,415,'Dhansar','828106',1,0,'2022-03-03 13:31:46','2022-03-03 13:31:46'),(119553,415,'Dhoria Mahubani','828109',1,0,'2022-03-03 13:31:46','2022-03-03 13:31:46'),(119554,415,'Dobari','828111',1,0,'2022-03-03 13:31:46','2022-03-03 13:31:46'),(119555,415,'Domgarh','828107',1,0,'2022-03-03 13:31:46','2022-03-03 13:31:46'),(119556,415,'Dumaria','828205',1,0,'2022-03-03 13:31:46','2022-03-03 13:31:46'),(119557,415,'Dumarkunda','828202',1,0,'2022-03-03 13:31:46','2022-03-03 13:31:46'),(119558,415,'Dumdumi','828402',1,0,'2022-03-03 13:31:46','2022-03-03 13:31:46'),(119559,415,'Fatehpur','828109',1,0,'2022-03-03 13:31:46','2022-03-03 13:31:46'),(119560,415,'Fri','828108',1,0,'2022-03-03 13:31:46','2022-03-03 13:31:46'),(119561,415,'G. Raghunathpur','828109',1,0,'2022-03-03 13:31:46','2022-03-03 13:31:46'),(119562,415,'Galfarbari','828204',1,0,'2022-03-03 13:31:46','2022-03-03 13:31:46'),(119563,415,'Gaukola','828109',1,0,'2022-03-03 13:31:46','2022-03-03 13:31:46'),(119564,415,'Gharbar','828201',1,0,'2022-03-03 13:31:46','2022-03-03 13:31:46'),(119565,415,'Ghunghusa','828401',1,0,'2022-03-03 13:31:46','2022-03-03 13:31:46'),(119566,415,'Gomoh','828401',1,0,'2022-03-03 13:31:47','2022-03-03 13:31:47'),(119567,415,'Gonudih','828116',1,0,'2022-03-03 13:31:47','2022-03-03 13:31:47'),(119568,415,'Goplaichak','828111',1,0,'2022-03-03 13:31:47','2022-03-03 13:31:47'),(119569,415,'Gortoppa','828109',1,0,'2022-03-03 13:31:47','2022-03-03 13:31:47'),(119570,415,'Govindpur (Dhanbad)','828109',1,0,'2022-03-03 13:31:47','2022-03-03 13:31:47'),(119571,415,'Hariharpur','828401',1,0,'2022-03-03 13:31:47','2022-03-03 13:31:47'),(119572,415,'Horladih','828301',1,0,'2022-03-03 13:31:47','2022-03-03 13:31:47'),(119573,415,'Indian School Of Mines','826004',1,0,'2022-03-03 13:31:47','2022-03-03 13:31:47'),(119574,415,'Jagjivan Nagar','826003',1,0,'2022-03-03 13:31:47','2022-03-03 13:31:47'),(119575,415,'Jamadoba','828112',1,0,'2022-03-03 13:31:47','2022-03-03 13:31:47'),(119576,415,'Jangalpur','828109',1,0,'2022-03-03 13:31:47','2022-03-03 13:31:47'),(119577,415,'Jealgora','828110',1,0,'2022-03-03 13:31:47','2022-03-03 13:31:47'),(119578,415,'Jhagrahi','828125',1,0,'2022-03-03 13:31:47','2022-03-03 13:31:47'),(119579,415,'Jharia Bazar','828111',1,0,'2022-03-03 13:31:47','2022-03-03 13:31:47'),(119580,415,'Jharia Manbad','828111',1,0,'2022-03-03 13:31:47','2022-03-03 13:31:47'),(119581,415,'Jharia','828111',1,0,'2022-03-03 13:31:47','2022-03-03 13:31:47'),(119582,415,'Jhiluwa','828109',1,0,'2022-03-03 13:31:47','2022-03-03 13:31:47'),(119583,415,'Jhinaki','828109',1,0,'2022-03-03 13:31:47','2022-03-03 13:31:47'),(119584,415,'Jitpur','828309',1,0,'2022-03-03 13:31:47','2022-03-03 13:31:47'),(119585,415,'Jogidih','828303',1,0,'2022-03-03 13:31:47','2022-03-03 13:31:47'),(119586,415,'K.G.Ashram','828109',1,0,'2022-03-03 13:31:48','2022-03-03 13:31:48'),(119587,415,'Kaliasole','828205',1,0,'2022-03-03 13:31:48','2022-03-03 13:31:48'),(119588,415,'Kalimela','828112',1,0,'2022-03-03 13:31:48','2022-03-03 13:31:48'),(119589,415,'Kalyanpur','826004',1,0,'2022-03-03 13:31:48','2022-03-03 13:31:48'),(119590,415,'Kankanee','828101',1,0,'2022-03-03 13:31:48','2022-03-03 13:31:48'),(119591,415,'Kankomath','828113',1,0,'2022-03-03 13:31:48','2022-03-03 13:31:48'),(119592,415,'Karitand','828129',1,0,'2022-03-03 13:31:48','2022-03-03 13:31:48'),(119593,415,'Katania Ojhadih','828109',1,0,'2022-03-03 13:31:48','2022-03-03 13:31:48'),(119594,415,'Katras Bazar','828114',1,0,'2022-03-03 13:31:48','2022-03-03 13:31:48'),(119595,415,'Katrasgarh','828113',1,0,'2022-03-03 13:31:48','2022-03-03 13:31:48'),(119596,415,'Kesarkural','828204',1,0,'2022-03-03 13:31:48','2022-03-03 13:31:48'),(119597,415,'Keshalpur','828114',1,0,'2022-03-03 13:31:48','2022-03-03 13:31:48'),(119598,415,'Keska','828109',1,0,'2022-03-03 13:31:48','2022-03-03 13:31:48'),(119599,415,'Khanoodih','828307',1,0,'2022-03-03 13:31:48','2022-03-03 13:31:48'),(119600,415,'Khario','828306',1,0,'2022-03-03 13:31:48','2022-03-03 13:31:48'),(119601,415,'Kharni','828113',1,0,'2022-03-03 13:31:48','2022-03-03 13:31:48'),(119602,415,'Khasjeena Gora','828115',1,0,'2022-03-03 13:31:48','2022-03-03 13:31:48'),(119603,415,'Kirkend','828116',1,0,'2022-03-03 13:31:48','2022-03-03 13:31:48'),(119604,415,'Kujama','828131',1,0,'2022-03-03 13:31:48','2022-03-03 13:31:48'),(119605,415,'Kumardhubi','828203',1,0,'2022-03-03 13:31:48','2022-03-03 13:31:48'),(119606,415,'Kustore','828117',1,0,'2022-03-03 13:31:48','2022-03-03 13:31:48'),(119607,415,'Kusunda','828116',1,0,'2022-03-03 13:31:48','2022-03-03 13:31:48'),(119608,415,'Lakarka','828113',1,0,'2022-03-03 13:31:49','2022-03-03 13:31:49'),(119609,415,'Lalpur','828129',1,0,'2022-03-03 13:31:49','2022-03-03 13:31:49'),(119610,415,'Latani','828109',1,0,'2022-03-03 13:31:49','2022-03-03 13:31:49'),(119611,415,'Ledaharia','828204',1,0,'2022-03-03 13:31:49','2022-03-03 13:31:49'),(119612,415,'Lodna (Dhanbad)','828131',1,0,'2022-03-03 13:31:49','2022-03-03 13:31:49'),(119613,415,'Ludharia','828109',1,0,'2022-03-03 13:31:49','2022-03-03 13:31:49'),(119614,415,'Madaidih','828402',1,0,'2022-03-03 13:31:49','2022-03-03 13:31:49'),(119615,415,'Madanpur','828205',1,0,'2022-03-03 13:31:49','2022-03-03 13:31:49'),(119616,415,'Madhuban','828131',1,0,'2022-03-03 13:31:49','2022-03-03 13:31:49'),(119617,415,'Mahal','828303',1,0,'2022-03-03 13:31:49','2022-03-03 13:31:49'),(119618,415,'Maharajganj','828109',1,0,'2022-03-03 13:31:49','2022-03-03 13:31:49'),(119619,415,'Maheshpur','828125',1,0,'2022-03-03 13:31:49','2022-03-03 13:31:49'),(119620,415,'Maira Nawatand','828109',1,0,'2022-03-03 13:31:49','2022-03-03 13:31:49'),(119621,415,'Maithon Dam','828207',1,0,'2022-03-03 13:31:49','2022-03-03 13:31:49'),(119622,415,'Malkera','828304',1,0,'2022-03-03 13:31:49','2022-03-03 13:31:49'),(119623,415,'Manaitand','826001',1,0,'2022-03-03 13:31:49','2022-03-03 13:31:49'),(119624,415,'Maniadih','828109',1,0,'2022-03-03 13:31:49','2022-03-03 13:31:49'),(119625,415,'Matari','828114',1,0,'2022-03-03 13:31:49','2022-03-03 13:31:49'),(119626,415,'Merrah','828202',1,0,'2022-03-03 13:31:49','2022-03-03 13:31:49'),(119627,415,'Mohuda','828305',1,0,'2022-03-03 13:31:49','2022-03-03 13:31:49'),(119628,415,'Moko','828201',1,0,'2022-03-03 13:31:49','2022-03-03 13:31:49'),(119629,415,'Moonidih','828129',1,0,'2022-03-03 13:31:49','2022-03-03 13:31:49'),(119630,415,'Moradih','828205',1,0,'2022-03-03 13:31:50','2022-03-03 13:31:50'),(119631,415,'Motinagar (Dhanbad)','828120',1,0,'2022-03-03 13:31:50','2022-03-03 13:31:50'),(119632,415,'Mugma','828204',1,0,'2022-03-03 13:31:50','2022-03-03 13:31:50'),(119633,415,'Murradih','826004',1,0,'2022-03-03 13:31:50','2022-03-03 13:31:50'),(119634,415,'Nagarkiary','828109',1,0,'2022-03-03 13:31:50','2022-03-03 13:31:50'),(119635,415,'Nagnagar','826004',1,0,'2022-03-03 13:31:50','2022-03-03 13:31:50'),(119636,415,'Nawagarh (Dhanbad)','828306',1,0,'2022-03-03 13:31:50','2022-03-03 13:31:50'),(119637,415,'Naya Bazar Wasseypur','826001',1,0,'2022-03-03 13:31:50','2022-03-03 13:31:50'),(119638,415,'Nirsa Chatti','828205',1,0,'2022-03-03 13:31:50','2022-03-03 13:31:50'),(119639,415,'Nudkhurkee','828307',1,0,'2022-03-03 13:31:50','2022-03-03 13:31:50'),(119640,415,'Palani','828201',1,0,'2022-03-03 13:31:50','2022-03-03 13:31:50'),(119641,415,'Panchet Dam','828206',1,0,'2022-03-03 13:31:50','2022-03-03 13:31:50'),(119642,415,'Pandra','828205',1,0,'2022-03-03 13:31:50','2022-03-03 13:31:50'),(119643,415,'Panjania','828113',1,0,'2022-03-03 13:31:50','2022-03-03 13:31:50'),(119644,415,'Pargha','828201',1,0,'2022-03-03 13:31:50','2022-03-03 13:31:50'),(119645,415,'Patherdih Coal Washery','828132',1,0,'2022-03-03 13:31:50','2022-03-03 13:31:50'),(119646,415,'Patherdih','828119',1,0,'2022-03-03 13:31:50','2022-03-03 13:31:50'),(119647,415,'Pindrahat','828201',1,0,'2022-03-03 13:31:50','2022-03-03 13:31:50'),(119648,415,'Pochari','828306',1,0,'2022-03-03 13:31:50','2022-03-03 13:31:50'),(119649,415,'Poddardih','828205',1,0,'2022-03-03 13:31:50','2022-03-03 13:31:50'),(119650,415,'Pokharia','828109',1,0,'2022-03-03 13:31:50','2022-03-03 13:31:50'),(119651,415,'Pradhan Khanta','828201',1,0,'2022-03-03 13:31:50','2022-03-03 13:31:50'),(119652,415,'Pradhankhanta','828114',1,0,'2022-03-03 13:31:50','2022-03-03 13:31:50'),(119653,415,'Purnadih','828109',1,0,'2022-03-03 13:31:51','2022-03-03 13:31:51'),(119654,415,'Rajganj','828113',1,0,'2022-03-03 13:31:51','2022-03-03 13:31:51'),(119655,415,'Rajpura','828203',1,0,'2022-03-03 13:31:51','2022-03-03 13:31:51'),(119656,415,'Ramakunda','828306',1,0,'2022-03-03 13:31:51','2022-03-03 13:31:51'),(119657,415,'Ramnagar Garh','828305',1,0,'2022-03-03 13:31:51','2022-03-03 13:31:51'),(119658,415,'Rampur','828304',1,0,'2022-03-03 13:31:51','2022-03-03 13:31:51'),(119659,415,'Roam','828113',1,0,'2022-03-03 13:31:51','2022-03-03 13:31:51'),(119660,415,'S.I.T.','828123',1,0,'2022-03-03 13:31:51','2022-03-03 13:31:51'),(119661,415,'Saharpura','828122',1,0,'2022-03-03 13:31:51','2022-03-03 13:31:51'),(119662,415,'Sahubahiyar','828402',1,0,'2022-03-03 13:31:51','2022-03-03 13:31:51'),(119663,415,'Salpatra','828201',1,0,'2022-03-03 13:31:51','2022-03-03 13:31:51'),(119664,415,'Salukchapra','828201',1,0,'2022-03-03 13:31:51','2022-03-03 13:31:51'),(119665,415,'Saraidhela','828127',1,0,'2022-03-03 13:31:51','2022-03-03 13:31:51'),(119666,415,'Sarkardih','828109',1,0,'2022-03-03 13:31:51','2022-03-03 13:31:51'),(119667,415,'Sarsapahari','828202',1,0,'2022-03-03 13:31:51','2022-03-03 13:31:51'),(119668,415,'Sendra','828101',1,0,'2022-03-03 13:31:51','2022-03-03 13:31:51'),(119669,415,'Shramik Nagar','828105',1,0,'2022-03-03 13:31:51','2022-03-03 13:31:51'),(119670,415,'Sijua','828121',1,0,'2022-03-03 13:31:51','2022-03-03 13:31:51'),(119671,415,'Silibari','828203',1,0,'2022-03-03 13:31:51','2022-03-03 13:31:51'),(119672,415,'Sindri','828122',1,0,'2022-03-03 13:31:52','2022-03-03 13:31:52'),(119673,415,'Singhdaha','828402',1,0,'2022-03-03 13:31:52','2022-03-03 13:31:52'),(119674,415,'Singhdih','828402',1,0,'2022-03-03 13:31:52','2022-03-03 13:31:52'),(119675,415,'Sonardih','828125',1,0,'2022-03-03 13:31:52','2022-03-03 13:31:52'),(119676,415,'Srirampur','828402',1,0,'2022-03-03 13:31:52','2022-03-03 13:31:52'),(119677,415,'Sudamdih','828126',1,0,'2022-03-03 13:31:52','2022-03-03 13:31:52'),(119678,415,'Sunderpahari','828109',1,0,'2022-03-03 13:31:52','2022-03-03 13:31:52'),(119679,415,'Suranga','828115',1,0,'2022-03-03 13:31:52','2022-03-03 13:31:52'),(119680,415,'Tantri','828402',1,0,'2022-03-03 13:31:52','2022-03-03 13:31:52'),(119681,415,'Thaparnagar','828205',1,0,'2022-03-03 13:31:52','2022-03-03 13:31:52'),(119682,415,'Tilaiya','828113',1,0,'2022-03-03 13:31:52','2022-03-03 13:31:52'),(119683,415,'Tisra','828115',1,0,'2022-03-03 13:31:52','2022-03-03 13:31:52'),(119684,415,'Topchanchi','828402',1,0,'2022-03-03 13:31:52','2022-03-03 13:31:52'),(119685,415,'Tundi','828109',1,0,'2022-03-03 13:31:52','2022-03-03 13:31:52'),(119686,415,'Tundoo','828128',1,0,'2022-03-03 13:31:52','2022-03-03 13:31:52'),(119687,415,'Ukma','828109',1,0,'2022-03-03 13:31:52','2022-03-03 13:31:52'),(119688,415,'Urma','828204',1,0,'2022-03-03 13:31:52','2022-03-03 13:31:52'),(119689,415,'Yadavpur','826004',1,0,'2022-03-03 13:31:52','2022-03-03 13:31:52'),(119690,416,'Ajnaridudhani','814146',1,0,'2022-03-03 13:31:52','2022-03-03 13:31:52'),(119691,416,'Amarapahari','814102',1,0,'2022-03-03 13:31:52','2022-03-03 13:31:52'),(119692,416,'Amarpur','814145',1,0,'2022-03-03 13:31:52','2022-03-03 13:31:52'),(119693,416,'Amba Jarowadih','814141',1,0,'2022-03-03 13:31:52','2022-03-03 13:31:52'),(119694,416,'Amgachi','814103',1,0,'2022-03-03 13:31:53','2022-03-03 13:31:53'),(119695,416,'Amjora','814148',1,0,'2022-03-03 13:31:53','2022-03-03 13:31:53'),(119696,416,'Amlachatar','814110',1,0,'2022-03-03 13:31:53','2022-03-03 13:31:53'),(119697,416,'Amra Nawadih','814158',1,0,'2022-03-03 13:31:53','2022-03-03 13:31:53'),(119698,416,'Asanbani','816118',1,0,'2022-03-03 13:31:53','2022-03-03 13:31:53'),(119699,416,'Asanjore','814110',1,0,'2022-03-03 13:31:53','2022-03-03 13:31:53'),(119700,416,'Asansol','814119',1,0,'2022-03-03 13:31:53','2022-03-03 13:31:53'),(119701,416,'Astajora','814103',1,0,'2022-03-03 13:31:53','2022-03-03 13:31:53'),(119702,416,'B. Mahadeogarh','814145',1,0,'2022-03-03 13:31:53','2022-03-03 13:31:53'),(119703,416,'B. Narganj','814103',1,0,'2022-03-03 13:31:53','2022-03-03 13:31:53'),(119704,416,'Babanbandhi','814166',1,0,'2022-03-03 13:31:53','2022-03-03 13:31:53'),(119705,416,'Bagjhopa','814118',1,0,'2022-03-03 13:31:53','2022-03-03 13:31:53'),(119706,416,'Bagnal','814144',1,0,'2022-03-03 13:31:53','2022-03-03 13:31:53'),(119707,416,'Baijnathpur','814146',1,0,'2022-03-03 13:31:53','2022-03-03 13:31:53'),(119708,416,'Bandarjora','814102',1,0,'2022-03-03 13:31:53','2022-03-03 13:31:53'),(119709,416,'Bandarjori','814101',1,0,'2022-03-03 13:31:53','2022-03-03 13:31:53'),(119710,416,'Bando Haripur','814110',1,0,'2022-03-03 13:31:53','2022-03-03 13:31:53'),(119711,416,'Bankijore','816118',1,0,'2022-03-03 13:31:53','2022-03-03 13:31:53'),(119712,416,'Banskuli','814144',1,0,'2022-03-03 13:31:53','2022-03-03 13:31:53'),(119713,416,'Banspahari','816103',1,0,'2022-03-03 13:31:53','2022-03-03 13:31:53'),(119714,416,'Banwara','814141',1,0,'2022-03-03 13:31:54','2022-03-03 13:31:54'),(119715,416,'Bara Sarwapani','814103',1,0,'2022-03-03 13:31:54','2022-03-03 13:31:54'),(119716,416,'Baragamharia','814146',1,0,'2022-03-03 13:31:54','2022-03-03 13:31:54'),(119717,416,'Barapalasi','814110',1,0,'2022-03-03 13:31:54','2022-03-03 13:31:54'),(119718,416,'Baratanr','814118',1,0,'2022-03-03 13:31:54','2022-03-03 13:31:54'),(119719,416,'Bariranbahiyar','814102',1,0,'2022-03-03 13:31:54','2022-03-03 13:31:54'),(119720,416,'Barkundi','814151',1,0,'2022-03-03 13:31:54','2022-03-03 13:31:54'),(119721,416,'Barmasia','816118',1,0,'2022-03-03 13:31:54','2022-03-03 13:31:54'),(119722,416,'Basaha','814146',1,0,'2022-03-03 13:31:54','2022-03-03 13:31:54'),(119723,416,'Basukinathdham','814118',1,0,'2022-03-03 13:31:54','2022-03-03 13:31:54'),(119724,416,'Beldaha','814141',1,0,'2022-03-03 13:31:54','2022-03-03 13:31:54'),(119725,416,'Benagaria','816103',1,0,'2022-03-03 13:31:54','2022-03-03 13:31:54'),(119726,416,'Bhadwari','814145',1,0,'2022-03-03 13:31:54','2022-03-03 13:31:54'),(119727,416,'Bhalsumar','814102',1,0,'2022-03-03 13:31:54','2022-03-03 13:31:54'),(119728,416,'Bhaturia','814102',1,0,'2022-03-03 13:31:54','2022-03-03 13:31:54'),(119729,416,'Bhirabpur','814146',1,0,'2022-03-03 13:31:54','2022-03-03 13:31:54'),(119730,416,'Bhurkunda','814158',1,0,'2022-03-03 13:31:54','2022-03-03 13:31:54'),(119731,416,'Bhutokoria','814146',1,0,'2022-03-03 13:31:54','2022-03-03 13:31:54'),(119732,416,'Bilkandi','814144',1,0,'2022-03-03 13:31:54','2022-03-03 13:31:54'),(119733,416,'Birajpur','814146',1,0,'2022-03-03 13:31:54','2022-03-03 13:31:54'),(119734,416,'Bishanpur','814141',1,0,'2022-03-03 13:31:54','2022-03-03 13:31:54'),(119735,416,'Bouria','814145',1,0,'2022-03-03 13:31:54','2022-03-03 13:31:54'),(119736,416,'Brindabani','814144',1,0,'2022-03-03 13:31:54','2022-03-03 13:31:54'),(119737,416,'Catupara','816103',1,0,'2022-03-03 13:31:55','2022-03-03 13:31:55'),(119738,416,'Chaglajore','814146',1,0,'2022-03-03 13:31:55','2022-03-03 13:31:55'),(119739,416,'Chaila Pathar','814110',1,0,'2022-03-03 13:31:55','2022-03-03 13:31:55'),(119740,416,'Chainpur Kairabani','814158',1,0,'2022-03-03 13:31:55','2022-03-03 13:31:55'),(119741,416,'Chamrabahiar','814118',1,0,'2022-03-03 13:31:55','2022-03-03 13:31:55'),(119742,416,'Chandubathan','814151',1,0,'2022-03-03 13:31:55','2022-03-03 13:31:55'),(119743,416,'Chhoti Ranbahiyar','814102',1,0,'2022-03-03 13:31:55','2022-03-03 13:31:55'),(119744,416,'Chihutia','814151',1,0,'2022-03-03 13:31:55','2022-03-03 13:31:55'),(119745,416,'Chikania','814146',1,0,'2022-03-03 13:31:55','2022-03-03 13:31:55'),(119746,416,'Chilra','814151',1,0,'2022-03-03 13:31:55','2022-03-03 13:31:55'),(119747,416,'Daldali','816103',1,0,'2022-03-03 13:31:55','2022-03-03 13:31:55'),(119748,416,'Danro','814102',1,0,'2022-03-03 13:31:55','2022-03-03 13:31:55'),(119749,416,'Dhaka','816118',1,0,'2022-03-03 13:31:55','2022-03-03 13:31:55'),(119750,416,'Dhamni','814151',1,0,'2022-03-03 13:31:55','2022-03-03 13:31:55'),(119751,416,'Dhamnilata','814118',1,0,'2022-03-03 13:31:55','2022-03-03 13:31:55'),(119752,416,'Dhanbai','814145',1,0,'2022-03-03 13:31:55','2022-03-03 13:31:55'),(119753,416,'Dhanbasa','816118',1,0,'2022-03-03 13:31:55','2022-03-03 13:31:55'),(119754,416,'Dharampur','814103',1,0,'2022-03-03 13:31:55','2022-03-03 13:31:55'),(119755,416,'Dhogariya','814158',1,0,'2022-03-03 13:31:55','2022-03-03 13:31:55'),(119756,416,'Dighi','814151',1,0,'2022-03-03 13:31:55','2022-03-03 13:31:55'),(119757,416,'Dubrajpur','814146',1,0,'2022-03-03 13:31:55','2022-03-03 13:31:55'),(119758,416,'Dudhani','814141',1,0,'2022-03-03 13:31:55','2022-03-03 13:31:55'),(119759,416,'Dudhani','814110',1,0,'2022-03-03 13:31:56','2022-03-03 13:31:56'),(119760,416,'Dumariahat','814120',1,0,'2022-03-03 13:31:56','2022-03-03 13:31:56'),(119761,416,'Dumka Court','814101',1,0,'2022-03-03 13:31:56','2022-03-03 13:31:56'),(119762,416,'Dumka H.O','814101',1,0,'2022-03-03 13:31:56','2022-03-03 13:31:56'),(119763,416,'Dumra','814148',1,0,'2022-03-03 13:31:56','2022-03-03 13:31:56'),(119764,416,'Gadibahirkunda','814120',1,0,'2022-03-03 13:31:56','2022-03-03 13:31:56'),(119765,416,'Gadijhopa','814151',1,0,'2022-03-03 13:31:56','2022-03-03 13:31:56'),(119766,416,'Gamharia','814102',1,0,'2022-03-03 13:31:56','2022-03-03 13:31:56'),(119767,416,'Gamra','814119',1,0,'2022-03-03 13:31:56','2022-03-03 13:31:56'),(119768,416,'Gando','814119',1,0,'2022-03-03 13:31:56','2022-03-03 13:31:56'),(119769,416,'Gandrakhpur','814119',1,0,'2022-03-03 13:31:56','2022-03-03 13:31:56'),(119770,416,'Garapathar','814146',1,0,'2022-03-03 13:31:56','2022-03-03 13:31:56'),(119771,416,'Garsara','814146',1,0,'2022-03-03 13:31:56','2022-03-03 13:31:56'),(119772,416,'Ghaghri','814102',1,0,'2022-03-03 13:31:56','2022-03-03 13:31:56'),(119773,416,'Ghasipur','814119',1,0,'2022-03-03 13:31:56','2022-03-03 13:31:56'),(119774,416,'Ghormala Hunja','814144',1,0,'2022-03-03 13:31:56','2022-03-03 13:31:56'),(119775,416,'Goari','814110',1,0,'2022-03-03 13:31:56','2022-03-03 13:31:56'),(119776,416,'Goasol','814110',1,0,'2022-03-03 13:31:56','2022-03-03 13:31:56'),(119777,416,'Golbandha','814146',1,0,'2022-03-03 13:31:56','2022-03-03 13:31:56'),(119778,416,'Gopikandar','814103',1,0,'2022-03-03 13:31:56','2022-03-03 13:31:56'),(119779,416,'Gugisimal','814119',1,0,'2022-03-03 13:31:56','2022-03-03 13:31:56'),(119780,416,'Guhiajori','814158',1,0,'2022-03-03 13:31:56','2022-03-03 13:31:56'),(119781,416,'Gumro','814166',1,0,'2022-03-03 13:31:56','2022-03-03 13:31:56'),(119782,416,'Gundlidangal','814146',1,0,'2022-03-03 13:31:56','2022-03-03 13:31:56'),(119783,416,'Hariharpur','814120',1,0,'2022-03-03 13:31:56','2022-03-03 13:31:56'),(119784,416,'Haripur','814118',1,0,'2022-03-03 13:31:57','2022-03-03 13:31:57'),(119785,416,'Harokha Aswari','814151',1,0,'2022-03-03 13:31:57','2022-03-03 13:31:57'),(119786,416,'Hasdiha','814145',1,0,'2022-03-03 13:31:57','2022-03-03 13:31:57'),(119787,416,'Jai Haripur','814148',1,0,'2022-03-03 13:31:57','2022-03-03 13:31:57'),(119788,416,'Jaitara','814144',1,0,'2022-03-03 13:31:57','2022-03-03 13:31:57'),(119789,416,'Jama','814110',1,0,'2022-03-03 13:31:57','2022-03-03 13:31:57'),(119790,416,'Jamjori Birnia','814145',1,0,'2022-03-03 13:31:57','2022-03-03 13:31:57'),(119791,416,'Jamua','814146',1,0,'2022-03-03 13:31:57','2022-03-03 13:31:57'),(119792,416,'Jarmundi','814141',1,0,'2022-03-03 13:31:57','2022-03-03 13:31:57'),(119793,416,'Jarwadi','814146',1,0,'2022-03-03 13:31:57','2022-03-03 13:31:57'),(119794,416,'Jokela','814151',1,0,'2022-03-03 13:31:57','2022-03-03 13:31:57'),(119795,416,'K. Baskichowk','814119',1,0,'2022-03-03 13:31:57','2022-03-03 13:31:57'),(119796,416,'K. Bhoktadih','814166',1,0,'2022-03-03 13:31:57','2022-03-03 13:31:57'),(119797,416,'K. Madhuwadih','814158',1,0,'2022-03-03 13:31:57','2022-03-03 13:31:57'),(119798,416,'Kadma','814103',1,0,'2022-03-03 13:31:57','2022-03-03 13:31:57'),(119799,416,'Kajladaha','816103',1,0,'2022-03-03 13:31:57','2022-03-03 13:31:57'),(119800,416,'Kakania','814145',1,0,'2022-03-03 13:31:57','2022-03-03 13:31:57'),(119801,416,'Kakni Pathria','814102',1,0,'2022-03-03 13:31:57','2022-03-03 13:31:57'),(119802,416,'Kaladumaria','814120',1,0,'2022-03-03 13:31:57','2022-03-03 13:31:57'),(119803,416,'Kalajhar','814103',1,0,'2022-03-03 13:31:57','2022-03-03 13:31:57'),(119804,416,'Kanjo','814145',1,0,'2022-03-03 13:31:57','2022-03-03 13:31:57'),(119805,416,'Karbindha','814158',1,0,'2022-03-03 13:31:57','2022-03-03 13:31:57'),(119806,416,'Karikadar','814144',1,0,'2022-03-03 13:31:57','2022-03-03 13:31:57'),(119807,416,'Karipahari','816117',1,0,'2022-03-03 13:31:58','2022-03-03 13:31:58'),(119808,416,'Karma','814120',1,0,'2022-03-03 13:31:58','2022-03-03 13:31:58'),(119809,416,'Karrasal','814146',1,0,'2022-03-03 13:31:58','2022-03-03 13:31:58'),(119810,416,'Karudih','816117',1,0,'2022-03-03 13:31:58','2022-03-03 13:31:58'),(119811,416,'Kathalia','814119',1,0,'2022-03-03 13:31:58','2022-03-03 13:31:58'),(119812,416,'Kathikund','814103',1,0,'2022-03-03 13:31:58','2022-03-03 13:31:58'),(119813,416,'Kendhghatta','814110',1,0,'2022-03-03 13:31:58','2022-03-03 13:31:58'),(119814,416,'Kendua','814151',1,0,'2022-03-03 13:31:58','2022-03-03 13:31:58'),(119815,416,'Khairabani','814146',1,0,'2022-03-03 13:31:58','2022-03-03 13:31:58'),(119816,416,'Kharu Kadma','816118',1,0,'2022-03-03 13:31:58','2022-03-03 13:31:58'),(119817,416,'Khudimerkho','814102',1,0,'2022-03-03 13:31:58','2022-03-03 13:31:58'),(119818,416,'Khutahari','814145',1,0,'2022-03-03 13:31:58','2022-03-03 13:31:58'),(119819,416,'Khutan','814145',1,0,'2022-03-03 13:31:58','2022-03-03 13:31:58'),(119820,416,'Kolha','814103',1,0,'2022-03-03 13:31:58','2022-03-03 13:31:58'),(119821,416,'Kolhabadar','816118',1,0,'2022-03-03 13:31:58','2022-03-03 13:31:58'),(119822,416,'Kolharia','814110',1,0,'2022-03-03 13:31:58','2022-03-03 13:31:58'),(119823,416,'Kumirdaha','814148',1,0,'2022-03-03 13:31:58','2022-03-03 13:31:58'),(119824,416,'Kumrabad','814119',1,0,'2022-03-03 13:31:58','2022-03-03 13:31:58'),(119825,416,'Kunjora','814146',1,0,'2022-03-03 13:31:58','2022-03-03 13:31:58'),(119826,416,'Kurumpahari','814145',1,0,'2022-03-03 13:31:58','2022-03-03 13:31:58'),(119827,416,'Kurwa','814119',1,0,'2022-03-03 13:31:58','2022-03-03 13:31:58'),(119828,416,'Kusumghatta','814110',1,0,'2022-03-03 13:31:58','2022-03-03 13:31:58'),(119829,416,'Lakarbank','814145',1,0,'2022-03-03 13:31:58','2022-03-03 13:31:58'),(119830,416,'Lakhanpur','814102',1,0,'2022-03-03 13:31:58','2022-03-03 13:31:58'),(119831,416,'Lakhna','814120',1,0,'2022-03-03 13:31:59','2022-03-03 13:31:59'),(119832,416,'Lattabar','814110',1,0,'2022-03-03 13:31:59','2022-03-03 13:31:59'),(119833,416,'Laximipur','814118',1,0,'2022-03-03 13:31:59','2022-03-03 13:31:59'),(119834,416,'Lilatari','814110',1,0,'2022-03-03 13:31:59','2022-03-03 13:31:59'),(119835,416,'Machkicha','814158',1,0,'2022-03-03 13:31:59','2022-03-03 13:31:59'),(119836,416,'Maharo','814110',1,0,'2022-03-03 13:31:59','2022-03-03 13:31:59'),(119837,416,'Mahubana','814102',1,0,'2022-03-03 13:31:59','2022-03-03 13:31:59'),(119838,416,'Majhiandih','814110',1,0,'2022-03-03 13:31:59','2022-03-03 13:31:59'),(119839,416,'Makrampur','814119',1,0,'2022-03-03 13:31:59','2022-03-03 13:31:59'),(119840,416,'Maluti','816103',1,0,'2022-03-03 13:31:59','2022-03-03 13:31:59'),(119841,416,'Manik Dih','814144',1,0,'2022-03-03 13:31:59','2022-03-03 13:31:59'),(119842,416,'Manjhladih','816103',1,0,'2022-03-03 13:31:59','2022-03-03 13:31:59'),(119843,416,'Masania','814103',1,0,'2022-03-03 13:31:59','2022-03-03 13:31:59'),(119844,416,'Massanjore','814144',1,0,'2022-03-03 13:31:59','2022-03-03 13:31:59'),(119845,416,'Mohal Pahari','816118',1,0,'2022-03-03 13:31:59','2022-03-03 13:31:59'),(119846,416,'Morbhanga','814119',1,0,'2022-03-03 13:31:59','2022-03-03 13:31:59'),(119847,416,'Nachangaria','814146',1,0,'2022-03-03 13:31:59','2022-03-03 13:31:59'),(119848,416,'Nakrapahari','814110',1,0,'2022-03-03 13:31:59','2022-03-03 13:31:59'),(119849,416,'Nanhidih','814150',1,0,'2022-03-03 13:31:59','2022-03-03 13:31:59'),(119850,416,'Nawadih','814151',1,0,'2022-03-03 13:31:59','2022-03-03 13:31:59'),(119851,416,'Nischintpur','814110',1,0,'2022-03-03 13:31:59','2022-03-03 13:31:59'),(119852,416,'Nonihat','814145',1,0,'2022-03-03 13:31:59','2022-03-03 13:31:59'),(119853,416,'Nonihatwari','814110',1,0,'2022-03-03 13:31:59','2022-03-03 13:31:59'),(119854,416,'P. Jaratikar','814141',1,0,'2022-03-03 13:32:00','2022-03-03 13:32:00'),(119855,416,'P.P. Kadma','816118',1,0,'2022-03-03 13:32:00','2022-03-03 13:32:00'),(119856,416,'Pahrudih','814119',1,0,'2022-03-03 13:32:00','2022-03-03 13:32:00'),(119857,416,'Pakdaha','816103',1,0,'2022-03-03 13:32:00','2022-03-03 13:32:00'),(119858,416,'Pakiriya','814158',1,0,'2022-03-03 13:32:00','2022-03-03 13:32:00'),(119859,416,'Pakur RS','816107',1,0,'2022-03-03 13:32:00','2022-03-03 13:32:00'),(119860,416,'Pargodih','814146',1,0,'2022-03-03 13:32:00','2022-03-03 13:32:00'),(119861,416,'Patgora','814145',1,0,'2022-03-03 13:32:00','2022-03-03 13:32:00'),(119862,416,'Pathra','814148',1,0,'2022-03-03 13:32:00','2022-03-03 13:32:00'),(119863,416,'Patjore','814148',1,0,'2022-03-03 13:32:00','2022-03-03 13:32:00'),(119864,416,'Pattabari','814119',1,0,'2022-03-03 13:32:00','2022-03-03 13:32:00'),(119865,416,'Petsar','814145',1,0,'2022-03-03 13:32:00','2022-03-03 13:32:00'),(119866,416,'Pinargaria','816103',1,0,'2022-03-03 13:32:00','2022-03-03 13:32:00'),(119867,416,'Pindari','814146',1,0,'2022-03-03 13:32:00','2022-03-03 13:32:00'),(119868,416,'Piprakarudih','814102',1,0,'2022-03-03 13:32:00','2022-03-03 13:32:00'),(119869,416,'Pratappur','816118',1,0,'2022-03-03 13:32:00','2022-03-03 13:32:00'),(119870,416,'Pratappur','814148',1,0,'2022-03-03 13:32:00','2022-03-03 13:32:00'),(119871,416,'Puranadumka','814110',1,0,'2022-03-03 13:32:00','2022-03-03 13:32:00'),(119872,416,'Pusaldih','814103',1,0,'2022-03-03 13:32:00','2022-03-03 13:32:00'),(119873,416,'R.B. Palasi','816118',1,0,'2022-03-03 13:32:00','2022-03-03 13:32:00'),(119874,416,'Raghunathpur (Dumka)','814148',1,0,'2022-03-03 13:32:00','2022-03-03 13:32:00'),(119875,416,'Raikinari','814141',1,0,'2022-03-03 13:32:00','2022-03-03 13:32:00'),(119876,416,'Rajan Amar Kunda','814120',1,0,'2022-03-03 13:32:00','2022-03-03 13:32:00'),(119877,416,'Rajbandh','814158',1,0,'2022-03-03 13:32:01','2022-03-03 13:32:01'),(119878,416,'Ramgarah','814102',1,0,'2022-03-03 13:32:01','2022-03-03 13:32:01'),(119879,416,'Ranga Masalia','814167',1,0,'2022-03-03 13:32:01','2022-03-03 13:32:01'),(119880,416,'Rangalia','814148',1,0,'2022-03-03 13:32:01','2022-03-03 13:32:01'),(119881,416,'Ranibahal','814144',1,0,'2022-03-03 13:32:01','2022-03-03 13:32:01'),(119882,416,'Ranigram','814148',1,0,'2022-03-03 13:32:01','2022-03-03 13:32:01'),(119883,416,'Raoundhya','814151',1,0,'2022-03-03 13:32:01','2022-03-03 13:32:01'),(119884,416,'S.P.College','814101',1,0,'2022-03-03 13:32:01','2022-03-03 13:32:01'),(119885,416,'Sadipur','814144',1,0,'2022-03-03 13:32:01','2022-03-03 13:32:01'),(119886,416,'Sagarbanga','814146',1,0,'2022-03-03 13:32:01','2022-03-03 13:32:01'),(119887,416,'Sahara','814120',1,0,'2022-03-03 13:32:01','2022-03-03 13:32:01'),(119888,416,'Saldaha','814103',1,0,'2022-03-03 13:32:01','2022-03-03 13:32:01'),(119889,416,'Samaymatha','814151',1,0,'2022-03-03 13:32:01','2022-03-03 13:32:01'),(119890,416,'Sapchalla','814110',1,0,'2022-03-03 13:32:01','2022-03-03 13:32:01'),(119891,416,'Saraidaha','816118',1,0,'2022-03-03 13:32:01','2022-03-03 13:32:01'),(119892,416,'Saraiyahat','814151',1,0,'2022-03-03 13:32:01','2022-03-03 13:32:01'),(119893,416,'Sarasdangal','816103',1,0,'2022-03-03 13:32:01','2022-03-03 13:32:01'),(119894,416,'Sarsa','814146',1,0,'2022-03-03 13:32:01','2022-03-03 13:32:01'),(119895,416,'Sarsabad','814103',1,0,'2022-03-03 13:32:01','2022-03-03 13:32:01'),(119896,416,'Satpahari','814120',1,0,'2022-03-03 13:32:01','2022-03-03 13:32:01'),(119897,416,'Shikaripara','816118',1,0,'2022-03-03 13:32:01','2022-03-03 13:32:01'),(119898,416,'Shikarpur','814110',1,0,'2022-03-03 13:32:02','2022-03-03 13:32:02'),(119899,416,'Shivpahar','814110',1,0,'2022-03-03 13:32:02','2022-03-03 13:32:02'),(119900,416,'Siktia','814118',1,0,'2022-03-03 13:32:02','2022-03-03 13:32:02'),(119901,416,'Siltha','814158',1,0,'2022-03-03 13:32:02','2022-03-03 13:32:02'),(119902,416,'Simalduma','814158',1,0,'2022-03-03 13:32:02','2022-03-03 13:32:02'),(119903,416,'Simaljore','816118',1,0,'2022-03-03 13:32:02','2022-03-03 13:32:02'),(119904,416,'Sinduria','814102',1,0,'2022-03-03 13:32:02','2022-03-03 13:32:02'),(119905,416,'Singhni','814118',1,0,'2022-03-03 13:32:02','2022-03-03 13:32:02'),(119906,416,'Sukjora','814148',1,0,'2022-03-03 13:32:02','2022-03-03 13:32:02'),(119907,416,'Sultanatikar','814145',1,0,'2022-03-03 13:32:02','2022-03-03 13:32:02'),(119908,416,'Sushni','814102',1,0,'2022-03-03 13:32:02','2022-03-03 13:32:02'),(119909,416,'T. Daldali','814103',1,0,'2022-03-03 13:32:02','2022-03-03 13:32:02'),(119910,416,'T.D.Dumaria','814146',1,0,'2022-03-03 13:32:02','2022-03-03 13:32:02'),(119911,416,'Talghara','814146',1,0,'2022-03-03 13:32:02','2022-03-03 13:32:02'),(119912,416,'Tangdaha','814148',1,0,'2022-03-03 13:32:02','2022-03-03 13:32:02'),(119913,416,'Tarajora','814146',1,0,'2022-03-03 13:32:02','2022-03-03 13:32:02'),(119914,416,'Tarni','814144',1,0,'2022-03-03 13:32:02','2022-03-03 13:32:02'),(119915,416,'Tasaria','814166',1,0,'2022-03-03 13:32:02','2022-03-03 13:32:02'),(119916,416,'Teliachak','814110',1,0,'2022-03-03 13:32:02','2022-03-03 13:32:02'),(119917,416,'Thakur Nahar','814145',1,0,'2022-03-03 13:32:02','2022-03-03 13:32:02'),(119918,416,'Tharihat','814158',1,0,'2022-03-03 13:32:02','2022-03-03 13:32:02'),(119919,416,'Upparbahal','814110',1,0,'2022-03-03 13:32:02','2022-03-03 13:32:02'),(119920,416,'Uppersitwa','814110',1,0,'2022-03-03 13:32:03','2022-03-03 13:32:03'),(119921,417,'Agrico','831009',1,0,'2022-03-03 13:32:03','2022-03-03 13:32:03'),(119922,417,'Amlagora','832301',1,0,'2022-03-03 13:32:03','2022-03-03 13:32:03'),(119923,417,'Amlatola','832102',1,0,'2022-03-03 13:32:03','2022-03-03 13:32:03'),(119924,417,'Angarpara','832101',1,0,'2022-03-03 13:32:03','2022-03-03 13:32:03'),(119925,417,'Arjunbera','832302',1,0,'2022-03-03 13:32:03','2022-03-03 13:32:03'),(119926,417,'Arong','832101',1,0,'2022-03-03 13:32:03','2022-03-03 13:32:03'),(119927,417,'Asanboni','832102',1,0,'2022-03-03 13:32:03','2022-03-03 13:32:03'),(119928,417,'Asna','832303',1,0,'2022-03-03 13:32:03','2022-03-03 13:32:03'),(119929,417,'Asura','833202',1,0,'2022-03-03 13:32:03','2022-03-03 13:32:03'),(119930,417,'Azadnagar','832110',1,0,'2022-03-03 13:32:03','2022-03-03 13:32:03'),(119931,417,'Badia','832104',1,0,'2022-03-03 13:32:03','2022-03-03 13:32:03'),(119932,417,'Bagbera','831002',1,0,'2022-03-03 13:32:03','2022-03-03 13:32:03'),(119933,417,'Baharagora','832101',1,0,'2022-03-03 13:32:03','2022-03-03 13:32:03'),(119934,417,'Baliaguri','832302',1,0,'2022-03-03 13:32:03','2022-03-03 13:32:03'),(119935,417,'Balibandh','832301',1,0,'2022-03-03 13:32:03','2022-03-03 13:32:03'),(119936,417,'Balijuri','832302',1,0,'2022-03-03 13:32:03','2022-03-03 13:32:03'),(119937,417,'Bamdole','832101',1,0,'2022-03-03 13:32:03','2022-03-03 13:32:03'),(119938,417,'Banasoli','832301',1,0,'2022-03-03 13:32:03','2022-03-03 13:32:03'),(119939,417,'Bangurda','832105',1,0,'2022-03-03 13:32:03','2022-03-03 13:32:03'),(119940,417,'Bankati','832303',1,0,'2022-03-03 13:32:04','2022-03-03 13:32:04'),(119941,417,'Bankisole','832104',1,0,'2022-03-03 13:32:04','2022-03-03 13:32:04'),(119942,417,'Bankuchia','832105',1,0,'2022-03-03 13:32:04','2022-03-03 13:32:04'),(119943,417,'Bara Asti','832104',1,0,'2022-03-03 13:32:04','2022-03-03 13:32:04'),(119944,417,'Bara Deoli','831002',1,0,'2022-03-03 13:32:04','2022-03-03 13:32:04'),(119945,417,'Barabotla','832104',1,0,'2022-03-03 13:32:04','2022-03-03 13:32:04'),(119946,417,'Barachirka','832112',1,0,'2022-03-03 13:32:04','2022-03-03 13:32:04'),(119947,417,'Baragaria','832101',1,0,'2022-03-03 13:32:04','2022-03-03 13:32:04'),(119948,417,'Barajuri','832303',1,0,'2022-03-03 13:32:04','2022-03-03 13:32:04'),(119949,417,'Barakurshi','832304',1,0,'2022-03-03 13:32:04','2022-03-03 13:32:04'),(119950,417,'Baramara','832301',1,0,'2022-03-03 13:32:04','2022-03-03 13:32:04'),(119951,417,'Bardikanpur','832301',1,0,'2022-03-03 13:32:04','2022-03-03 13:32:04'),(119952,417,'Baridih Colony','831017',1,0,'2022-03-03 13:32:04','2022-03-03 13:32:04'),(119953,417,'Beko','832304',1,0,'2022-03-03 13:32:04','2022-03-03 13:32:04'),(119954,417,'Belajuri','831012',1,0,'2022-03-03 13:32:04','2022-03-03 13:32:04'),(119955,417,'Beldih','832112',1,0,'2022-03-03 13:32:04','2022-03-03 13:32:04'),(119956,417,'Bend','832301',1,0,'2022-03-03 13:32:04','2022-03-03 13:32:04'),(119957,417,'Benda','832101',1,0,'2022-03-03 13:32:04','2022-03-03 13:32:04'),(119958,417,'Bengo','832102',1,0,'2022-03-03 13:32:04','2022-03-03 13:32:04'),(119959,417,'Bhagabandhi','832104',1,0,'2022-03-03 13:32:04','2022-03-03 13:32:04'),(119960,417,'Bhalki','832302',1,0,'2022-03-03 13:32:04','2022-03-03 13:32:04'),(119961,417,'Bhalki','831002',1,0,'2022-03-03 13:32:05','2022-03-03 13:32:05'),(119962,417,'Bhalukbinda','832301',1,0,'2022-03-03 13:32:05','2022-03-03 13:32:05'),(119963,417,'Bhandaru','832301',1,0,'2022-03-03 13:32:05','2022-03-03 13:32:05'),(119964,417,'Bhatin','832102',1,0,'2022-03-03 13:32:05','2022-03-03 13:32:05'),(119965,417,'Bhilaipahari','831012',1,0,'2022-03-03 13:32:05','2022-03-03 13:32:05'),(119966,417,'Bidra','832105',1,0,'2022-03-03 13:32:05','2022-03-03 13:32:05'),(119967,417,'Birsanagar','831019',1,0,'2022-03-03 13:32:05','2022-03-03 13:32:05'),(119968,417,'Bistupur Bazar','831001',1,0,'2022-03-03 13:32:05','2022-03-03 13:32:05'),(119969,417,'Bistupur Gate','831001',1,0,'2022-03-03 13:32:05','2022-03-03 13:32:05'),(119970,417,'Boram','832112',1,0,'2022-03-03 13:32:05','2022-03-03 13:32:05'),(119971,417,'Burma Mines','831007',1,0,'2022-03-03 13:32:05','2022-03-03 13:32:05'),(119972,417,'Butgora','832102',1,0,'2022-03-03 13:32:05','2022-03-03 13:32:05'),(119973,417,'Chakri','831002',1,0,'2022-03-03 13:32:05','2022-03-03 13:32:05'),(119974,417,'Chakulia','832301',1,0,'2022-03-03 13:32:05','2022-03-03 13:32:05'),(119975,417,'Chandrapur','832101',1,0,'2022-03-03 13:32:05','2022-03-03 13:32:05'),(119976,417,'Chhota Bangurda','832112',1,0,'2022-03-03 13:32:05','2022-03-03 13:32:05'),(119977,417,'Chhota Govindpur','831004',1,0,'2022-03-03 13:32:05','2022-03-03 13:32:05'),(119978,417,'Chhota Porulia','832101',1,0,'2022-03-03 13:32:05','2022-03-03 13:32:05'),(119979,417,'Chirudih','832105',1,0,'2022-03-03 13:32:05','2022-03-03 13:32:05'),(119980,417,'Chitreshwar','832101',1,0,'2022-03-03 13:32:06','2022-03-03 13:32:06'),(119981,417,'Chorinda','832304',1,0,'2022-03-03 13:32:06','2022-03-03 13:32:06'),(119982,417,'Civil Court','831001',1,0,'2022-03-03 13:32:06','2022-03-03 13:32:06'),(119983,417,'Co-Op  College','831001',1,0,'2022-03-03 13:32:06','2022-03-03 13:32:06'),(119984,417,'Damjuri','832101',1,0,'2022-03-03 13:32:06','2022-03-03 13:32:06'),(119985,417,'Dandudih','832101',1,0,'2022-03-03 13:32:06','2022-03-03 13:32:06'),(119986,417,'Darkhuli','832101',1,0,'2022-03-03 13:32:06','2022-03-03 13:32:06'),(119987,417,'Dhalbhumgarh','832302',1,0,'2022-03-03 13:32:06','2022-03-03 13:32:06'),(119988,417,'Dhirol','832102',1,0,'2022-03-03 13:32:06','2022-03-03 13:32:06'),(119989,417,'Dighi','832112',1,0,'2022-03-03 13:32:06','2022-03-03 13:32:06'),(119990,417,'Dobha','832303',1,0,'2022-03-03 13:32:06','2022-03-03 13:32:06'),(119991,417,'Dorkasai','832102',1,0,'2022-03-03 13:32:06','2022-03-03 13:32:06'),(119992,417,'Dumuria','832104',1,0,'2022-03-03 13:32:06','2022-03-03 13:32:06'),(119993,417,'Edelbera','832303',1,0,'2022-03-03 13:32:06','2022-03-03 13:32:06'),(119994,417,'Gamharia','832101',1,0,'2022-03-03 13:32:06','2022-03-03 13:32:06'),(119995,417,'Gandanata','832301',1,0,'2022-03-03 13:32:06','2022-03-03 13:32:06'),(119996,417,'Ghaspada','832101',1,0,'2022-03-03 13:32:06','2022-03-03 13:32:06'),(119997,417,'Ghatsila','832303',1,0,'2022-03-03 13:32:06','2022-03-03 13:32:06'),(119998,417,'Ghorabandha','831004',1,0,'2022-03-03 13:32:06','2022-03-03 13:32:06'),(119999,417,'Gitilata','832107',1,0,'2022-03-03 13:32:06','2022-03-03 13:32:06'),(120000,417,'Gobarghusi','832105',1,0,'2022-03-03 13:32:06','2022-03-03 13:32:06'),(120001,417,'Gobindpur Housing Colony','831015',1,0,'2022-03-03 13:32:06','2022-03-03 13:32:06'),(120002,417,'Gohaldangra','832302',1,0,'2022-03-03 13:32:07','2022-03-03 13:32:07'),(120003,417,'Golmuri','831003',1,0,'2022-03-03 13:32:07','2022-03-03 13:32:07'),(120004,417,'Guhiapal','832101',1,0,'2022-03-03 13:32:07','2022-03-03 13:32:07'),(120005,417,'Gurabanda','832302',1,0,'2022-03-03 13:32:07','2022-03-03 13:32:07'),(120006,417,'Haldajuri','832303',1,0,'2022-03-03 13:32:07','2022-03-03 13:32:07'),(120007,417,'Haludbani','831002',1,0,'2022-03-03 13:32:07','2022-03-03 13:32:07'),(120008,417,'Haludpukur','831002',1,0,'2022-03-03 13:32:07','2022-03-03 13:32:07'),(120009,417,'Harhargutu','831002',1,0,'2022-03-03 13:32:07','2022-03-03 13:32:07'),(120010,417,'Hendaljuri','832304',1,0,'2022-03-03 13:32:07','2022-03-03 13:32:07'),(120011,417,'Hirachuni','831012',1,0,'2022-03-03 13:32:07','2022-03-03 13:32:07'),(120012,417,'Indranagar','831004',1,0,'2022-03-03 13:32:07','2022-03-03 13:32:07'),(120013,417,'Jadugoda Mines','832102',1,0,'2022-03-03 13:32:07','2022-03-03 13:32:07'),(120014,417,'Jamshedpur H.O','831001',1,0,'2022-03-03 13:32:07','2022-03-03 13:32:07'),(120015,417,'Jamshola','832101',1,0,'2022-03-03 13:32:07','2022-03-03 13:32:07'),(120016,417,'Jarapal','832101',1,0,'2022-03-03 13:32:07','2022-03-03 13:32:07'),(120017,417,'Jhantijharna','832303',1,0,'2022-03-03 13:32:07','2022-03-03 13:32:07'),(120018,417,'Jorsiya','832105',1,0,'2022-03-03 13:32:07','2022-03-03 13:32:07'),(120019,417,'Joypura','832101',1,0,'2022-03-03 13:32:07','2022-03-03 13:32:07'),(120020,417,'Jugsalai','831006',1,0,'2022-03-03 13:32:07','2022-03-03 13:32:07'),(120021,417,'Juri','831002',1,0,'2022-03-03 13:32:07','2022-03-03 13:32:07'),(120022,417,'Kadma','831005',1,0,'2022-03-03 13:32:08','2022-03-03 13:32:08'),(120023,417,'Kaima','832101',1,0,'2022-03-03 13:32:08','2022-03-03 13:32:08'),(120024,417,'Kaimi','832101',1,0,'2022-03-03 13:32:08','2022-03-03 13:32:08'),(120025,417,'Kalapathar','832301',1,0,'2022-03-03 13:32:08','2022-03-03 13:32:08'),(120026,417,'Kaliam','832302',1,0,'2022-03-03 13:32:08','2022-03-03 13:32:08'),(120027,417,'Kalidaspur','832301',1,0,'2022-03-03 13:32:08','2022-03-03 13:32:08'),(120028,417,'Kalikapur','832102',1,0,'2022-03-03 13:32:08','2022-03-03 13:32:08'),(120029,417,'Kalimati Market','831004',1,0,'2022-03-03 13:32:08','2022-03-03 13:32:08'),(120030,417,'Kamalpur','832105',1,0,'2022-03-03 13:32:08','2022-03-03 13:32:08'),(120031,417,'Kantaboni','832302',1,0,'2022-03-03 13:32:08','2022-03-03 13:32:08'),(120032,417,'Karaduba','832303',1,0,'2022-03-03 13:32:08','2022-03-03 13:32:08'),(120033,417,'Karandih','831002',1,0,'2022-03-03 13:32:08','2022-03-03 13:32:08'),(120034,417,'Kasmar','832105',1,0,'2022-03-03 13:32:08','2022-03-03 13:32:08'),(120035,417,'Katushole','832301',1,0,'2022-03-03 13:32:08','2022-03-03 13:32:08'),(120036,417,'Kendadangri','832301',1,0,'2022-03-03 13:32:08','2022-03-03 13:32:08'),(120037,417,'Kendadih','832303',1,0,'2022-03-03 13:32:08','2022-03-03 13:32:08'),(120038,417,'Kesharda','832101',1,0,'2022-03-03 13:32:08','2022-03-03 13:32:08'),(120039,417,'Kesharpur','832304',1,0,'2022-03-03 13:32:08','2022-03-03 13:32:08'),(120040,417,'Khairpal','831002',1,0,'2022-03-03 13:32:08','2022-03-03 13:32:08'),(120041,417,'Khandamouda','832101',1,0,'2022-03-03 13:32:08','2022-03-03 13:32:08'),(120042,417,'Kitadih','831002',1,0,'2022-03-03 13:32:08','2022-03-03 13:32:08'),(120043,417,'Koira','832112',1,0,'2022-03-03 13:32:08','2022-03-03 13:32:08'),(120044,417,'Kokpara','832302',1,0,'2022-03-03 13:32:08','2022-03-03 13:32:08'),(120045,417,'Kowali','831002',1,0,'2022-03-03 13:32:08','2022-03-03 13:32:08'),(120046,417,'Kuiani','832112',1,0,'2022-03-03 13:32:09','2022-03-03 13:32:09'),(120047,417,'Kumardubi','832101',1,0,'2022-03-03 13:32:09','2022-03-03 13:32:09'),(120048,417,'Kumir','832105',1,0,'2022-03-03 13:32:09','2022-03-03 13:32:09'),(120049,417,'Lachhipur','832105',1,0,'2022-03-03 13:32:09','2022-03-03 13:32:09'),(120050,417,'Laojora','832112',1,0,'2022-03-03 13:32:09','2022-03-03 13:32:09'),(120051,417,'Lodhasholi','832301',1,0,'2022-03-03 13:32:09','2022-03-03 13:32:09'),(120052,417,'Luabasa','831004',1,0,'2022-03-03 13:32:09','2022-03-03 13:32:09'),(120053,417,'M.G.M Medical College','831018',1,0,'2022-03-03 13:32:09','2022-03-03 13:32:09'),(120054,417,'Madhavpur','832112',1,0,'2022-03-03 13:32:09','2022-03-03 13:32:09'),(120055,417,'Mahulia','832304',1,0,'2022-03-03 13:32:09','2022-03-03 13:32:09'),(120056,417,'Malua','832101',1,0,'2022-03-03 13:32:09','2022-03-03 13:32:09'),(120057,417,'Mango','831012',1,0,'2022-03-03 13:32:09','2022-03-03 13:32:09'),(120058,417,'Manpur','832102',1,0,'2022-03-03 13:32:09','2022-03-03 13:32:09'),(120059,417,'Manusmuria','832301',1,0,'2022-03-03 13:32:09','2022-03-03 13:32:09'),(120060,417,'Matiabandhi','832302',1,0,'2022-03-03 13:32:09','2022-03-03 13:32:09'),(120061,417,'Matihana','832101',1,0,'2022-03-03 13:32:09','2022-03-03 13:32:09'),(120062,417,'Mohanpur','832303',1,0,'2022-03-03 13:32:09','2022-03-03 13:32:09'),(120063,417,'Mohulishole','832302',1,0,'2022-03-03 13:32:09','2022-03-03 13:32:09'),(120064,417,'Mosabani Mines','832104',1,0,'2022-03-03 13:32:09','2022-03-03 13:32:09'),(120065,417,'Moubhandar','832103',1,0,'2022-03-03 13:32:10','2022-03-03 13:32:10'),(120066,417,'Mouda','832101',1,0,'2022-03-03 13:32:10','2022-03-03 13:32:10'),(120067,417,'Murakati','832101',1,0,'2022-03-03 13:32:10','2022-03-03 13:32:10'),(120068,417,'Mural','832301',1,0,'2022-03-03 13:32:10','2022-03-03 13:32:10'),(120069,417,'Murathakura','832302',1,0,'2022-03-03 13:32:10','2022-03-03 13:32:10'),(120070,417,'N M L','831007',1,0,'2022-03-03 13:32:10','2022-03-03 13:32:10'),(120071,417,'Narda','831002',1,0,'2022-03-03 13:32:10','2022-03-03 13:32:10'),(120072,417,'Narwa Mines ','832111',1,0,'2022-03-03 13:32:10','2022-03-03 13:32:10'),(120073,417,'Nutangarh','832302',1,0,'2022-03-03 13:32:10','2022-03-03 13:32:10'),(120074,417,'Pagda','832105',1,0,'2022-03-03 13:32:10','2022-03-03 13:32:10'),(120075,417,'Paharpur','832112',1,0,'2022-03-03 13:32:10','2022-03-03 13:32:10'),(120076,417,'Panduda','832302',1,0,'2022-03-03 13:32:10','2022-03-03 13:32:10'),(120077,417,'Pardih','831020',1,0,'2022-03-03 13:32:10','2022-03-03 13:32:10'),(120078,417,'Patamda','832105',1,0,'2022-03-03 13:32:10','2022-03-03 13:32:10'),(120079,417,'Pipla','831012',1,0,'2022-03-03 13:32:10','2022-03-03 13:32:10'),(120080,417,'Pitajuri','832302',1,0,'2022-03-03 13:32:10','2022-03-03 13:32:10'),(120081,417,'Potka','831002',1,0,'2022-03-03 13:32:10','2022-03-03 13:32:10'),(120082,417,'Pungora','832303',1,0,'2022-03-03 13:32:10','2022-03-03 13:32:10'),(120083,417,'Rahargora','831016',1,0,'2022-03-03 13:32:10','2022-03-03 13:32:10'),(120084,417,'Rajdoha','832102',1,0,'2022-03-03 13:32:10','2022-03-03 13:32:10'),(120085,417,'Rakha Copper Project','832106',1,0,'2022-03-03 13:32:11','2022-03-03 13:32:11'),(120086,417,'Rakha Mines','832106',1,0,'2022-03-03 13:32:11','2022-03-03 13:32:11'),(120087,417,'Ram Chandra Pur','832101',1,0,'2022-03-03 13:32:11','2022-03-03 13:32:11'),(120088,417,'Rasik Nagar','832105',1,0,'2022-03-03 13:32:11','2022-03-03 13:32:11'),(120089,417,'Rasun Chopa','831002',1,0,'2022-03-03 13:32:11','2022-03-03 13:32:11'),(120090,417,'Rautara','832302',1,0,'2022-03-03 13:32:11','2022-03-03 13:32:11'),(120091,417,'Rupuskundi','832301',1,0,'2022-03-03 13:32:11','2022-03-03 13:32:11'),(120092,417,'Sakchi Court','831001',1,0,'2022-03-03 13:32:11','2022-03-03 13:32:11'),(120093,417,'Sakchi','831001',1,0,'2022-03-03 13:32:11','2022-03-03 13:32:11'),(120094,417,'Sangrain','831002',1,0,'2022-03-03 13:32:11','2022-03-03 13:32:11'),(120095,417,'Sardiha','832301',1,0,'2022-03-03 13:32:11','2022-03-03 13:32:11'),(120096,417,'Sarjamda','831002',1,0,'2022-03-03 13:32:11','2022-03-03 13:32:11'),(120097,417,'Shankarda','832107',1,0,'2022-03-03 13:32:11','2022-03-03 13:32:11'),(120098,417,'Shyam Sunderpur','832302',1,0,'2022-03-03 13:32:11','2022-03-03 13:32:11'),(120099,417,'Simdi','832301',1,0,'2022-03-03 13:32:11','2022-03-03 13:32:11'),(120100,417,'Singhpura','832302',1,0,'2022-03-03 13:32:11','2022-03-03 13:32:11'),(120101,417,'Sonari (East Singhbhum)','831011',1,0,'2022-03-03 13:32:11','2022-03-03 13:32:11'),(120102,417,'Suklara','832304',1,0,'2022-03-03 13:32:11','2022-03-03 13:32:11'),(120103,417,'Sundarnagar','832107',1,0,'2022-03-03 13:32:11','2022-03-03 13:32:11'),(120104,417,'Surda Mines','832303',1,0,'2022-03-03 13:32:11','2022-03-03 13:32:11'),(120105,417,'Tangrain','831002',1,0,'2022-03-03 13:32:11','2022-03-03 13:32:11'),(120106,417,'Tatanagar','831002',1,0,'2022-03-03 13:32:12','2022-03-03 13:32:12'),(120107,417,'Telco G.M Office','831010',1,0,'2022-03-03 13:32:12','2022-03-03 13:32:12'),(120108,417,'Telco Plaza Market','831004',1,0,'2022-03-03 13:32:12','2022-03-03 13:32:12'),(120109,417,'Telco Works','831004',1,0,'2022-03-03 13:32:12','2022-03-03 13:32:12'),(120110,418,'Adar','822114',1,0,'2022-03-03 13:32:12','2022-03-03 13:32:12'),(120111,418,'Adhar','822114',1,0,'2022-03-03 13:32:12','2022-03-03 13:32:12'),(120112,418,'Amrora','822112',1,0,'2022-03-03 13:32:12','2022-03-03 13:32:12'),(120113,418,'Anraj Nawdiha','822114',1,0,'2022-03-03 13:32:12','2022-03-03 13:32:12'),(120114,418,'Arangi','822112',1,0,'2022-03-03 13:32:12','2022-03-03 13:32:12'),(120115,418,'Arsali','822112',1,0,'2022-03-03 13:32:12','2022-03-03 13:32:12'),(120116,418,'Ataula','822134',1,0,'2022-03-03 13:32:12','2022-03-03 13:32:12'),(120117,418,'Bairiya','822125',1,0,'2022-03-03 13:32:12','2022-03-03 13:32:12'),(120118,418,'Balekhar','822133',1,0,'2022-03-03 13:32:12','2022-03-03 13:32:12'),(120119,418,'Bana','822133',1,0,'2022-03-03 13:32:12','2022-03-03 13:32:12'),(120120,418,'Bandu','822125',1,0,'2022-03-03 13:32:12','2022-03-03 13:32:12'),(120121,418,'Bandu','829201',1,0,'2022-03-03 13:32:12','2022-03-03 13:32:12'),(120122,418,'Banka','822133',1,0,'2022-03-03 13:32:12','2022-03-03 13:32:12'),(120123,418,'Bansa','822124',1,0,'2022-03-03 13:32:12','2022-03-03 13:32:12'),(120124,418,'Bardiha','822134',1,0,'2022-03-03 13:32:12','2022-03-03 13:32:12'),(120125,418,'Bargarh','822125',1,0,'2022-03-03 13:32:12','2022-03-03 13:32:12'),(120126,418,'Belchampa','822124',1,0,'2022-03-03 13:32:13','2022-03-03 13:32:13'),(120127,418,'Belhara','822114',1,0,'2022-03-03 13:32:13','2022-03-03 13:32:13'),(120128,418,'Bhagodih','822128',1,0,'2022-03-03 13:32:13','2022-03-03 13:32:13'),(120129,418,'Bhandar','822124',1,0,'2022-03-03 13:32:13','2022-03-03 13:32:13'),(120130,418,'Bhawnathpur','822112',1,0,'2022-03-03 13:32:13','2022-03-03 13:32:13'),(120131,418,'Bhawnathpur TownShip','822129',1,0,'2022-03-03 13:32:13','2022-03-03 13:32:13'),(120132,418,'Bhikhahi','822124',1,0,'2022-03-03 13:32:13','2022-03-03 13:32:13'),(120133,418,'Bulka','822128',1,0,'2022-03-03 13:32:13','2022-03-03 13:32:13'),(120134,418,'Chapri','822112',1,0,'2022-03-03 13:32:13','2022-03-03 13:32:13'),(120135,418,'Chinia','822114',1,0,'2022-03-03 13:32:13','2022-03-03 13:32:13'),(120136,418,'Danda','822124',1,0,'2022-03-03 13:32:13','2022-03-03 13:32:13'),(120137,418,'Dandai','822133',1,0,'2022-03-03 13:32:13','2022-03-03 13:32:13'),(120138,418,'Deogana','822133',1,0,'2022-03-03 13:32:13','2022-03-03 13:32:13'),(120139,418,'Dihariya','822132',1,0,'2022-03-03 13:32:13','2022-03-03 13:32:13'),(120140,418,'Doll','822114',1,0,'2022-03-03 13:32:13','2022-03-03 13:32:13'),(120141,418,'Dumariya','822114',1,0,'2022-03-03 13:32:13','2022-03-03 13:32:13'),(120142,418,'Dwandkara','822134',1,0,'2022-03-03 13:32:13','2022-03-03 13:32:13'),(120143,418,'Gamharia','822128',1,0,'2022-03-03 13:32:13','2022-03-03 13:32:13'),(120144,418,'Ganiarikala','822128',1,0,'2022-03-03 13:32:13','2022-03-03 13:32:13'),(120145,418,'Garhwa','822114',1,0,'2022-03-03 13:32:13','2022-03-03 13:32:13'),(120146,418,'Gari','822124',1,0,'2022-03-03 13:32:14','2022-03-03 13:32:14'),(120147,418,'Gharatia','822132',1,0,'2022-03-03 13:32:14','2022-03-03 13:32:14'),(120148,418,'Godarmana','822125',1,0,'2022-03-03 13:32:14','2022-03-03 13:32:14'),(120149,418,'Harigawan','822134',1,0,'2022-03-03 13:32:14','2022-03-03 13:32:14'),(120150,418,'Hasandag','822133',1,0,'2022-03-03 13:32:14','2022-03-03 13:32:14'),(120151,418,'Hoor','822114',1,0,'2022-03-03 13:32:14','2022-03-03 13:32:14'),(120152,418,'Jarhi','822133',1,0,'2022-03-03 13:32:14','2022-03-03 13:32:14'),(120153,418,'Jhagra Khand','822112',1,0,'2022-03-03 13:32:14','2022-03-03 13:32:14'),(120154,418,'Kadhwan','822124',1,0,'2022-03-03 13:32:14','2022-03-03 13:32:14'),(120155,418,'Kaetar','822112',1,0,'2022-03-03 13:32:14','2022-03-03 13:32:14'),(120156,418,'Kajru Khurd','822132',1,0,'2022-03-03 13:32:14','2022-03-03 13:32:14'),(120157,418,'Kalyanpur','822114',1,0,'2022-03-03 13:32:14','2022-03-03 13:32:14'),(120158,418,'Kanda','822124',1,0,'2022-03-03 13:32:14','2022-03-03 13:32:14'),(120159,418,'Kanjia','822125',1,0,'2022-03-03 13:32:14','2022-03-03 13:32:14'),(120160,418,'Kariwadih','822112',1,0,'2022-03-03 13:32:14','2022-03-03 13:32:14'),(120161,418,'Karso','822125',1,0,'2022-03-03 13:32:14','2022-03-03 13:32:14'),(120162,418,'Karuie','822134',1,0,'2022-03-03 13:32:14','2022-03-03 13:32:14'),(120163,418,'Ketat Kala','822124',1,0,'2022-03-03 13:32:14','2022-03-03 13:32:14'),(120164,418,'Khajutia Barwadih','822125',1,0,'2022-03-03 13:32:15','2022-03-03 13:32:15'),(120165,418,'Kharaundhi','822112',1,0,'2022-03-03 13:32:15','2022-03-03 13:32:15'),(120166,418,'Kocheya','822128',1,0,'2022-03-03 13:32:15','2022-03-03 13:32:15'),(120167,418,'Kutmu','822132',1,0,'2022-03-03 13:32:15','2022-03-03 13:32:15'),(120168,418,'Lagma','822133',1,0,'2022-03-03 13:32:15','2022-03-03 13:32:15'),(120169,418,'Lalgarh','822124',1,0,'2022-03-03 13:32:15','2022-03-03 13:32:15'),(120170,418,'Latdag','822133',1,0,'2022-03-03 13:32:15','2022-03-03 13:32:15'),(120171,418,'Makri','822112',1,0,'2022-03-03 13:32:15','2022-03-03 13:32:15'),(120172,418,'Mandwanima','822128',1,0,'2022-03-03 13:32:15','2022-03-03 13:32:15'),(120173,418,'Manjhiaon','822114',1,0,'2022-03-03 13:32:15','2022-03-03 13:32:15'),(120174,418,'Manjhiaon','822134',1,0,'2022-03-03 13:32:15','2022-03-03 13:32:15'),(120175,418,'Manjhigaon','822118',1,0,'2022-03-03 13:32:15','2022-03-03 13:32:15'),(120176,418,'Meral','822133',1,0,'2022-03-03 13:32:15','2022-03-03 13:32:15'),(120177,418,'Murma Kala','822132',1,0,'2022-03-03 13:32:15','2022-03-03 13:32:15'),(120178,418,'Naw Bandaria','822125',1,0,'2022-03-03 13:32:15','2022-03-03 13:32:15'),(120179,418,'Nawada','822114',1,0,'2022-03-03 13:32:15','2022-03-03 13:32:15'),(120180,418,'Nawgarha','822124',1,0,'2022-03-03 13:32:15','2022-03-03 13:32:15'),(120181,418,'Okhargara','822114',1,0,'2022-03-03 13:32:15','2022-03-03 13:32:15'),(120182,418,'Pachadumar','822112',1,0,'2022-03-03 13:32:15','2022-03-03 13:32:15'),(120183,418,'Pandu','822132',1,0,'2022-03-03 13:32:15','2022-03-03 13:32:15'),(120184,418,'Paraswar','822125',1,0,'2022-03-03 13:32:15','2022-03-03 13:32:15'),(120185,418,'Parsodih','822112',1,0,'2022-03-03 13:32:15','2022-03-03 13:32:15'),(120186,418,'Partikushwani','822112',1,0,'2022-03-03 13:32:16','2022-03-03 13:32:16'),(120187,418,'Pipra','822112',1,0,'2022-03-03 13:32:16','2022-03-03 13:32:16'),(120188,418,'Pipri Kala','822128',1,0,'2022-03-03 13:32:16','2022-03-03 13:32:16'),(120189,418,'Poska','822114',1,0,'2022-03-03 13:32:16','2022-03-03 13:32:16'),(120190,418,'Rajhara Rest','822124',1,0,'2022-03-03 13:32:16','2022-03-03 13:32:16'),(120191,418,'Raji','822112',1,0,'2022-03-03 13:32:16','2022-03-03 13:32:16'),(120192,418,'Ramkanda','822125',1,0,'2022-03-03 13:32:16','2022-03-03 13:32:16'),(120193,418,'Ramna (Garhwa)','822128',1,0,'2022-03-03 13:32:16','2022-03-03 13:32:16'),(120194,418,'Ranicheri','822114',1,0,'2022-03-03 13:32:16','2022-03-03 13:32:16'),(120195,418,'Ranka Raj','822125',1,0,'2022-03-03 13:32:16','2022-03-03 13:32:16'),(120196,418,'Rankabuliya','822114',1,0,'2022-03-03 13:32:16','2022-03-03 13:32:16'),(120197,418,'Ranpura','822114',1,0,'2022-03-03 13:32:16','2022-03-03 13:32:16'),(120198,418,'Raro','822133',1,0,'2022-03-03 13:32:16','2022-03-03 13:32:16'),(120199,418,'Ratnag','822132',1,0,'2022-03-03 13:32:16','2022-03-03 13:32:16'),(120200,418,'Rehala','822124',1,0,'2022-03-03 13:32:16','2022-03-03 13:32:16'),(120201,418,'Rohila','822128',1,0,'2022-03-03 13:32:16','2022-03-03 13:32:16'),(120202,418,'Sangrahekala','822124',1,0,'2022-03-03 13:32:16','2022-03-03 13:32:16'),(120203,418,'Sigsigi','822124',1,0,'2022-03-03 13:32:16','2022-03-03 13:32:16'),(120204,418,'Silidag','822128',1,0,'2022-03-03 13:32:17','2022-03-03 13:32:17'),(120205,418,'Soh','822114',1,0,'2022-03-03 13:32:17','2022-03-03 13:32:17'),(120206,418,'Sonehara','822128',1,0,'2022-03-03 13:32:17','2022-03-03 13:32:17'),(120207,418,'Sowadih','822125',1,0,'2022-03-03 13:32:17','2022-03-03 13:32:17'),(120208,418,'Sribishrampur','822125',1,0,'2022-03-03 13:32:17','2022-03-03 13:32:17'),(120209,418,'Tamge Kala','822125',1,0,'2022-03-03 13:32:17','2022-03-03 13:32:17'),(120210,418,'Tatidiri','822128',1,0,'2022-03-03 13:32:17','2022-03-03 13:32:17'),(120211,418,'Tildag','822114',1,0,'2022-03-03 13:32:17','2022-03-03 13:32:17'),(120212,418,'Tisibar','822132',1,0,'2022-03-03 13:32:17','2022-03-03 13:32:17'),(120213,418,'Tolera','822124',1,0,'2022-03-03 13:32:17','2022-03-03 13:32:17'),(120214,418,'Torelawa','822112',1,0,'2022-03-03 13:32:17','2022-03-03 13:32:17'),(120215,418,'Udaipur','822125',1,0,'2022-03-03 13:32:17','2022-03-03 13:32:17'),(120216,419,'Ahilyapur','815312',1,0,'2022-03-03 13:32:17','2022-03-03 13:32:17'),(120217,419,'Akdonikala','815311',1,0,'2022-03-03 13:32:17','2022-03-03 13:32:17'),(120218,419,'Ambatand','825412',1,0,'2022-03-03 13:32:17','2022-03-03 13:32:17'),(120219,419,'Argali','825412',1,0,'2022-03-03 13:32:17','2022-03-03 13:32:17'),(120220,419,'Arwara','825322',1,0,'2022-03-03 13:32:17','2022-03-03 13:32:17'),(120221,419,'Atkadih','825322',1,0,'2022-03-03 13:32:17','2022-03-03 13:32:17'),(120222,419,'Atki','825108',1,0,'2022-03-03 13:32:17','2022-03-03 13:32:17'),(120223,419,'Aura','825322',1,0,'2022-03-03 13:32:17','2022-03-03 13:32:17'),(120224,419,'Baddiha','815302',1,0,'2022-03-03 13:32:17','2022-03-03 13:32:17'),(120225,419,'Baddiha','825412',1,0,'2022-03-03 13:32:18','2022-03-03 13:32:18'),(120226,419,'Badwara','815312',1,0,'2022-03-03 13:32:18','2022-03-03 13:32:18'),(120227,419,'Bagodar','825322',1,0,'2022-03-03 13:32:18','2022-03-03 13:32:18'),(120228,419,'Bagodih','825320',1,0,'2022-03-03 13:32:18','2022-03-03 13:32:18'),(120229,419,'Bairia','815314',1,0,'2022-03-03 13:32:18','2022-03-03 13:32:18'),(120230,419,'Bairiabad','815316',1,0,'2022-03-03 13:32:18','2022-03-03 13:32:18'),(120231,419,'Bajto','815316',1,0,'2022-03-03 13:32:18','2022-03-03 13:32:18'),(120232,419,'Balak','825322',1,0,'2022-03-03 13:32:18','2022-03-03 13:32:18'),(120233,419,'Balgo','815318',1,0,'2022-03-03 13:32:18','2022-03-03 13:32:18'),(120234,419,'Balia','815316',1,0,'2022-03-03 13:32:18','2022-03-03 13:32:18'),(120235,419,'Bandhkharo','825322',1,0,'2022-03-03 13:32:18','2022-03-03 13:32:18'),(120236,419,'Bangrakala','825324',1,0,'2022-03-03 13:32:18','2022-03-03 13:32:18'),(120237,419,'Barain','825322',1,0,'2022-03-03 13:32:18','2022-03-03 13:32:18'),(120238,419,'Barganda','815301',1,0,'2022-03-03 13:32:18','2022-03-03 13:32:18'),(120239,419,'Barkitand','815312',1,0,'2022-03-03 13:32:18','2022-03-03 13:32:18'),(120240,419,'Barmasia','825167',1,0,'2022-03-03 13:32:18','2022-03-03 13:32:18'),(120241,419,'Barotand','825412',1,0,'2022-03-03 13:32:18','2022-03-03 13:32:18'),(120242,419,'Barwadih','825322',1,0,'2022-03-03 13:32:18','2022-03-03 13:32:18'),(120243,419,'Bati','815318',1,0,'2022-03-03 13:32:18','2022-03-03 13:32:18'),(120244,419,'Beko','825106',1,0,'2022-03-03 13:32:18','2022-03-03 13:32:18'),(120245,419,'Bendro','815313',1,0,'2022-03-03 13:32:19','2022-03-03 13:32:19'),(120246,419,'Bengabad','815312',1,0,'2022-03-03 13:32:19','2022-03-03 13:32:19'),(120247,419,'Beniadih','815311',1,0,'2022-03-03 13:32:19','2022-03-03 13:32:19'),(120248,419,'Berhabad','815316',1,0,'2022-03-03 13:32:19','2022-03-03 13:32:19'),(120249,419,'Bhandari','815317',1,0,'2022-03-03 13:32:19','2022-03-03 13:32:19'),(120250,419,'Bhandaro','825412',1,0,'2022-03-03 13:32:19','2022-03-03 13:32:19'),(120251,419,'Bharkhar','825106',1,0,'2022-03-03 13:32:19','2022-03-03 13:32:19'),(120252,419,'Birney','815313',1,0,'2022-03-03 13:32:19','2022-03-03 13:32:19'),(120253,419,'Bishunpur','825108',1,0,'2022-03-03 13:32:19','2022-03-03 13:32:19'),(120254,419,'Budhudih','815312',1,0,'2022-03-03 13:32:19','2022-03-03 13:32:19'),(120255,419,'Burhiadih','815302',1,0,'2022-03-03 13:32:19','2022-03-03 13:32:19'),(120256,419,'Chainpur','825106',1,0,'2022-03-03 13:32:19','2022-03-03 13:32:19'),(120257,419,'Chaitadih','815302',1,0,'2022-03-03 13:32:19','2022-03-03 13:32:19'),(120258,419,'Chandouri','815317',1,0,'2022-03-03 13:32:19','2022-03-03 13:32:19'),(120259,419,'Chapuadih','815312',1,0,'2022-03-03 13:32:19','2022-03-03 13:32:19'),(120260,419,'Charghara','815318',1,0,'2022-03-03 13:32:19','2022-03-03 13:32:19'),(120261,419,'Charki','815313',1,0,'2022-03-03 13:32:19','2022-03-03 13:32:19'),(120262,419,'Chatro','815314',1,0,'2022-03-03 13:32:19','2022-03-03 13:32:19'),(120263,419,'Chhachhando','825108',1,0,'2022-03-03 13:32:19','2022-03-03 13:32:19'),(120264,419,'Chhotki Kharagdiha','815312',1,0,'2022-03-03 13:32:19','2022-03-03 13:32:19'),(120265,419,'Chikandih','815314',1,0,'2022-03-03 13:32:19','2022-03-03 13:32:19'),(120266,419,'Chilga','825108',1,0,'2022-03-03 13:32:19','2022-03-03 13:32:19'),(120267,419,'Chino','825106',1,0,'2022-03-03 13:32:19','2022-03-03 13:32:19'),(120268,419,'Chittardih','815318',1,0,'2022-03-03 13:32:20','2022-03-03 13:32:20'),(120269,419,'Choudhary Bandh','825106',1,0,'2022-03-03 13:32:20','2022-03-03 13:32:20'),(120270,419,'Choutha','825322',1,0,'2022-03-03 13:32:20','2022-03-03 13:32:20'),(120271,419,'Chunglo','815318',1,0,'2022-03-03 13:32:20','2022-03-03 13:32:20'),(120272,419,'Dabri','825324',1,0,'2022-03-03 13:32:20','2022-03-03 13:32:20'),(120273,419,'Dariadih','825412',1,0,'2022-03-03 13:32:20','2022-03-03 13:32:20'),(120274,419,'Daridih','815302',1,0,'2022-03-03 13:32:20','2022-03-03 13:32:20'),(120275,419,'Deori','815314',1,0,'2022-03-03 13:32:20','2022-03-03 13:32:20'),(120276,419,'Dhargulli','825322',1,0,'2022-03-03 13:32:20','2022-03-03 13:32:20'),(120277,419,'Dhuraita','815315',1,0,'2022-03-03 13:32:20','2022-03-03 13:32:20'),(120278,419,'Dondlo','825322',1,0,'2022-03-03 13:32:20','2022-03-03 13:32:20'),(120279,419,'Doranda','825412',1,0,'2022-03-03 13:32:20','2022-03-03 13:32:20'),(120280,419,'Dumma','815318',1,0,'2022-03-03 13:32:20','2022-03-03 13:32:20'),(120281,419,'Dumri','825106',1,0,'2022-03-03 13:32:20','2022-03-03 13:32:20'),(120282,419,'Dwarpahari','815316',1,0,'2022-03-03 13:32:20','2022-03-03 13:32:20'),(120283,419,'Gadi Bharkatha','825324',1,0,'2022-03-03 13:32:20','2022-03-03 13:32:20'),(120284,419,'Gadi Nawdiha','815312',1,0,'2022-03-03 13:32:20','2022-03-03 13:32:20'),(120285,419,'Gadi Sermpur','815302',1,0,'2022-03-03 13:32:20','2022-03-03 13:32:20'),(120286,419,'Gadi Sirsia','815312',1,0,'2022-03-03 13:32:20','2022-03-03 13:32:20'),(120287,419,'Galagi','825167',1,0,'2022-03-03 13:32:21','2022-03-03 13:32:21'),(120288,419,'Gandey','815312',1,0,'2022-03-03 13:32:21','2022-03-03 13:32:21'),(120289,419,'Gando','825324',1,0,'2022-03-03 13:32:21','2022-03-03 13:32:21'),(120290,419,'Ganwan','815313',1,0,'2022-03-03 13:32:21','2022-03-03 13:32:21'),(120291,419,'Ghoranji','815314',1,0,'2022-03-03 13:32:21','2022-03-03 13:32:21'),(120292,419,'Ghutia Pesra','825320',1,0,'2022-03-03 13:32:21','2022-03-03 13:32:21'),(120293,419,'Giridih  Town','815302',1,0,'2022-03-03 13:32:21','2022-03-03 13:32:21'),(120294,419,'Giridih Bazar','815301',1,0,'2022-03-03 13:32:21','2022-03-03 13:32:21'),(120295,419,'Giridih H.O','815301',1,0,'2022-03-03 13:32:21','2022-03-03 13:32:21'),(120296,419,'Gorhar','825322',1,0,'2022-03-03 13:32:21','2022-03-03 13:32:21'),(120297,419,'Gumgi','815317',1,0,'2022-03-03 13:32:21','2022-03-03 13:32:21'),(120298,419,'Handadih','815316',1,0,'2022-03-03 13:32:21','2022-03-03 13:32:21'),(120299,419,'Harladih','825108',1,0,'2022-03-03 13:32:21','2022-03-03 13:32:21'),(120300,419,'Hemrodih','825412',1,0,'2022-03-03 13:32:21','2022-03-03 13:32:21'),(120301,419,'Hesla','825322',1,0,'2022-03-03 13:32:21','2022-03-03 13:32:21'),(120302,419,'Isri Bazar','825167',1,0,'2022-03-03 13:32:21','2022-03-03 13:32:21'),(120303,419,'Jagsemar','815314',1,0,'2022-03-03 13:32:21','2022-03-03 13:32:21'),(120304,419,'Jamdar','825412',1,0,'2022-03-03 13:32:21','2022-03-03 13:32:21'),(120305,419,'Jamtara','825106',1,0,'2022-03-03 13:32:21','2022-03-03 13:32:21'),(120306,419,'Jamua (Giridh)','815318',1,0,'2022-03-03 13:32:21','2022-03-03 13:32:21'),(120307,419,'Janata Jaridih','825324',1,0,'2022-03-03 13:32:21','2022-03-03 13:32:21'),(120308,419,'Jarmuney','825322',1,0,'2022-03-03 13:32:21','2022-03-03 13:32:21'),(120309,419,'Jawaharnagar','825324',1,0,'2022-03-03 13:32:21','2022-03-03 13:32:21'),(120310,419,'Jeruadih','815318',1,0,'2022-03-03 13:32:22','2022-03-03 13:32:22'),(120311,419,'Kahuwai','815313',1,0,'2022-03-03 13:32:22','2022-03-03 13:32:22'),(120312,419,'Kapilo','825322',1,0,'2022-03-03 13:32:22','2022-03-03 13:32:22'),(120313,419,'Karharbari','815311',1,0,'2022-03-03 13:32:22','2022-03-03 13:32:22'),(120314,419,'Karharbari','815315',1,0,'2022-03-03 13:32:22','2022-03-03 13:32:22'),(120315,419,'Karihari','825412',1,0,'2022-03-03 13:32:22','2022-03-03 13:32:22'),(120316,419,'Karma','815316',1,0,'2022-03-03 13:32:22','2022-03-03 13:32:22'),(120317,419,'Kathkoko','815317',1,0,'2022-03-03 13:32:22','2022-03-03 13:32:22'),(120318,419,'Keshodih','825324',1,0,'2022-03-03 13:32:22','2022-03-03 13:32:22'),(120319,419,'Keshwari','825320',1,0,'2022-03-03 13:32:22','2022-03-03 13:32:22'),(120320,419,'Khairiadih','815314',1,0,'2022-03-03 13:32:22','2022-03-03 13:32:22'),(120321,419,'Khairidih','825324',1,0,'2022-03-03 13:32:22','2022-03-03 13:32:22'),(120322,419,'Kharagdiha','815314',1,0,'2022-03-03 13:32:22','2022-03-03 13:32:22'),(120323,419,'Khaskari','825320',1,0,'2022-03-03 13:32:22','2022-03-03 13:32:22'),(120324,419,'Khijuri','815317',1,0,'2022-03-03 13:32:22','2022-03-03 13:32:22'),(120325,419,'Khijursota','825412',1,0,'2022-03-03 13:32:22','2022-03-03 13:32:22'),(120326,419,'Khori Mahua','825412',1,0,'2022-03-03 13:32:22','2022-03-03 13:32:22'),(120327,419,'Khudisar','825108',1,0,'2022-03-03 13:32:22','2022-03-03 13:32:22'),(120328,419,'Khukhara','825108',1,0,'2022-03-03 13:32:22','2022-03-03 13:32:22'),(120329,419,'Khurchutta','815312',1,0,'2022-03-03 13:32:22','2022-03-03 13:32:22'),(120330,419,'Khurjio','825324',1,0,'2022-03-03 13:32:23','2022-03-03 13:32:23'),(120331,419,'Kisgo','825412',1,0,'2022-03-03 13:32:23','2022-03-03 13:32:23'),(120332,419,'Kishutand','815317',1,0,'2022-03-03 13:32:23','2022-03-03 13:32:23'),(120333,419,'Koiridih','825320',1,0,'2022-03-03 13:32:23','2022-03-03 13:32:23'),(120334,419,'Kulgo','825106',1,0,'2022-03-03 13:32:23','2022-03-03 13:32:23'),(120335,419,'Kumharlalo','825108',1,0,'2022-03-03 13:32:23','2022-03-03 13:32:23'),(120336,419,'Kurhobindo','815315',1,0,'2022-03-03 13:32:23','2022-03-03 13:32:23'),(120337,419,'Laxmantunda','825167',1,0,'2022-03-03 13:32:23','2022-03-03 13:32:23'),(120338,419,'Leda','815316',1,0,'2022-03-03 13:32:23','2022-03-03 13:32:23'),(120339,419,'Lokai','815317',1,0,'2022-03-03 13:32:23','2022-03-03 13:32:23'),(120340,419,'Luppi','815312',1,0,'2022-03-03 13:32:23','2022-03-03 13:32:23'),(120341,419,'Machchali','815314',1,0,'2022-03-03 13:32:23','2022-03-03 13:32:23'),(120342,419,'Maheshmunda','815312',1,0,'2022-03-03 13:32:23','2022-03-03 13:32:23'),(120343,419,'Makatpur','815301',1,0,'2022-03-03 13:32:23','2022-03-03 13:32:23'),(120344,419,'Malda','815313',1,0,'2022-03-03 13:32:23','2022-03-03 13:32:23'),(120345,419,'Mandramo','825320',1,0,'2022-03-03 13:32:23','2022-03-03 13:32:23'),(120346,419,'Mandro','815314',1,0,'2022-03-03 13:32:23','2022-03-03 13:32:23'),(120347,419,'Manikbad','815314',1,0,'2022-03-03 13:32:23','2022-03-03 13:32:23'),(120348,419,'Manjhiladih','825324',1,0,'2022-03-03 13:32:23','2022-03-03 13:32:23'),(120349,419,'Manjhney','815313',1,0,'2022-03-03 13:32:24','2022-03-03 13:32:24'),(120350,419,'Matrukha','815311',1,0,'2022-03-03 13:32:24','2022-03-03 13:32:24'),(120351,419,'Mirzaganj','815315',1,0,'2022-03-03 13:32:24','2022-03-03 13:32:24'),(120352,419,'Motieda','815302',1,0,'2022-03-03 13:32:24','2022-03-03 13:32:24'),(120353,419,'Mundro','825320',1,0,'2022-03-03 13:32:24','2022-03-03 13:32:24'),(120354,419,'Mundro','815312',1,0,'2022-03-03 13:32:24','2022-03-03 13:32:24'),(120355,419,'Murkhari','825412',1,0,'2022-03-03 13:32:24','2022-03-03 13:32:24'),(120356,419,'Murna','825412',1,0,'2022-03-03 13:32:24','2022-03-03 13:32:24'),(120357,419,'Nagri','825167',1,0,'2022-03-03 13:32:24','2022-03-03 13:32:24'),(120358,419,'Naitnd','825320',1,0,'2022-03-03 13:32:24','2022-03-03 13:32:24'),(120359,419,'Orkhar','825412',1,0,'2022-03-03 13:32:24','2022-03-03 13:32:24'),(120360,419,'Pachamba','815316',1,0,'2022-03-03 13:32:24','2022-03-03 13:32:24'),(120361,419,'Palganj','825108',1,0,'2022-03-03 13:32:24','2022-03-03 13:32:24'),(120362,419,'Palmo','825108',1,0,'2022-03-03 13:32:24','2022-03-03 13:32:24'),(120363,419,'Palounjia','825324',1,0,'2022-03-03 13:32:24','2022-03-03 13:32:24'),(120364,419,'Papilo','815317',1,0,'2022-03-03 13:32:24','2022-03-03 13:32:24'),(120365,419,'Parwatpur','815312',1,0,'2022-03-03 13:32:24','2022-03-03 13:32:24'),(120366,419,'Persia','825320',1,0,'2022-03-03 13:32:24','2022-03-03 13:32:24'),(120367,419,'Pesham','815316',1,0,'2022-03-03 13:32:24','2022-03-03 13:32:24'),(120368,419,'Phulchi','815312',1,0,'2022-03-03 13:32:24','2022-03-03 13:32:24'),(120369,419,'Phuljharia','815312',1,0,'2022-03-03 13:32:24','2022-03-03 13:32:24'),(120370,419,'Pihra','815313',1,0,'2022-03-03 13:32:24','2022-03-03 13:32:24'),(120371,419,'Pirtand','825108',1,0,'2022-03-03 13:32:25','2022-03-03 13:32:25'),(120372,419,'Pobi','815315',1,0,'2022-03-03 13:32:25','2022-03-03 13:32:25'),(120373,419,'Poraiya','825167',1,0,'2022-03-03 13:32:25','2022-03-03 13:32:25'),(120374,419,'Pordag','825106',1,0,'2022-03-03 13:32:25','2022-03-03 13:32:25'),(120375,419,'Purri','815312',1,0,'2022-03-03 13:32:25','2022-03-03 13:32:25'),(120376,419,'Rajdhanwarf','825412',1,0,'2022-03-03 13:32:25','2022-03-03 13:32:25'),(120377,419,'Ranikhawa','815316',1,0,'2022-03-03 13:32:25','2022-03-03 13:32:25'),(120378,419,'Rata Bahiyar','815312',1,0,'2022-03-03 13:32:25','2022-03-03 13:32:25'),(120379,419,'Rema','825412',1,0,'2022-03-03 13:32:25','2022-03-03 13:32:25'),(120380,419,'Roshnatunda','825167',1,0,'2022-03-03 13:32:25','2022-03-03 13:32:25'),(120381,419,'Rupaidih','825324',1,0,'2022-03-03 13:32:25','2022-03-03 13:32:25'),(120382,419,'Sabalpur','825320',1,0,'2022-03-03 13:32:25','2022-03-03 13:32:25'),(120383,419,'Sankh','815313',1,0,'2022-03-03 13:32:25','2022-03-03 13:32:25'),(120384,419,'Sankho','815315',1,0,'2022-03-03 13:32:25','2022-03-03 13:32:25'),(120385,419,'Sapamaran','825412',1,0,'2022-03-03 13:32:25','2022-03-03 13:32:25'),(120386,419,'Saranda','825324',1,0,'2022-03-03 13:32:25','2022-03-03 13:32:25'),(120387,419,'Senadoni','815316',1,0,'2022-03-03 13:32:25','2022-03-03 13:32:25'),(120388,419,'Serampur Colliery','815302',1,0,'2022-03-03 13:32:25','2022-03-03 13:32:25'),(120389,419,'Shikherjee','825329',1,0,'2022-03-03 13:32:25','2022-03-03 13:32:25'),(120390,419,'Simaria','825412',1,0,'2022-03-03 13:32:25','2022-03-03 13:32:25'),(120391,419,'Sirsia','815302',1,0,'2022-03-03 13:32:25','2022-03-03 13:32:25'),(120392,419,'Siyatand','815312',1,0,'2022-03-03 13:32:25','2022-03-03 13:32:25'),(120393,419,'Sobaranpur','825108',1,0,'2022-03-03 13:32:26','2022-03-03 13:32:26'),(120394,419,'Sonardih','815312',1,0,'2022-03-03 13:32:26','2022-03-03 13:32:26'),(120395,419,'Suriya','825320',1,0,'2022-03-03 13:32:26','2022-03-03 13:32:26'),(120396,419,'Tara','815318',1,0,'2022-03-03 13:32:26','2022-03-03 13:32:26'),(120397,419,'Taratand','815302',1,0,'2022-03-03 13:32:26','2022-03-03 13:32:26'),(120398,419,'Telkhara','825167',1,0,'2022-03-03 13:32:26','2022-03-03 13:32:26'),(120399,419,'Tiklato','815312',1,0,'2022-03-03 13:32:26','2022-03-03 13:32:26'),(120400,419,'Tisri','815317',1,0,'2022-03-03 13:32:26','2022-03-03 13:32:26'),(120401,419,'Udnabad','815302',1,0,'2022-03-03 13:32:26','2022-03-03 13:32:26'),(120402,419,'Taranakho','825418',1,0,'2022-03-03 13:32:26','2022-03-03 13:32:26'),(120403,420,'Adamdour','814160',1,0,'2022-03-03 13:32:26','2022-03-03 13:32:26'),(120404,420,'Agiyamore','814153',1,0,'2022-03-03 13:32:26','2022-03-03 13:32:26'),(120405,420,'Amlo','814133',1,0,'2022-03-03 13:32:26','2022-03-03 13:32:26'),(120406,420,'Amour','814160',1,0,'2022-03-03 13:32:26','2022-03-03 13:32:26'),(120407,420,'Anjana','814154',1,0,'2022-03-03 13:32:26','2022-03-03 13:32:26'),(120408,420,'Asarimadhuri','814153',1,0,'2022-03-03 13:32:26','2022-03-03 13:32:26'),(120409,420,'Azampakariya','814155',1,0,'2022-03-03 13:32:26','2022-03-03 13:32:26'),(120410,420,'Baghmara','814153',1,0,'2022-03-03 13:32:26','2022-03-03 13:32:26'),(120411,420,'Bahdurchak','813208',1,0,'2022-03-03 13:32:26','2022-03-03 13:32:26'),(120412,420,'Bajitpur','814160',1,0,'2022-03-03 13:32:26','2022-03-03 13:32:26'),(120413,420,'Baksara','814133',1,0,'2022-03-03 13:32:27','2022-03-03 13:32:27'),(120414,420,'Bandanbar','814147',1,0,'2022-03-03 13:32:27','2022-03-03 13:32:27'),(120415,420,'Banerchua','814165',1,0,'2022-03-03 13:32:27','2022-03-03 13:32:27'),(120416,420,'Bans Jori','814156',1,0,'2022-03-03 13:32:27','2022-03-03 13:32:27'),(120417,420,'Bara Banghi','814153',1,0,'2022-03-03 13:32:27','2022-03-03 13:32:27'),(120418,420,'Barasimra','814165',1,0,'2022-03-03 13:32:27','2022-03-03 13:32:27'),(120419,420,'Barmasiya','814147',1,0,'2022-03-03 13:32:27','2022-03-03 13:32:27'),(120420,420,'Basantpur','814133',1,0,'2022-03-03 13:32:27','2022-03-03 13:32:27'),(120421,420,'Basantrai','814155',1,0,'2022-03-03 13:32:27','2022-03-03 13:32:27'),(120422,420,'Belbadda','814160',1,0,'2022-03-03 13:32:27','2022-03-03 13:32:27'),(120423,420,'Beniadih','813208',1,0,'2022-03-03 13:32:27','2022-03-03 13:32:27'),(120424,420,'Bhadharia','814147',1,0,'2022-03-03 13:32:27','2022-03-03 13:32:27'),(120425,420,'Bhagmara','813208',1,0,'2022-03-03 13:32:27','2022-03-03 13:32:27'),(120426,420,'Bhagya','813208',1,0,'2022-03-03 13:32:27','2022-03-03 13:32:27'),(120427,420,'Bhanjpur','814154',1,0,'2022-03-03 13:32:27','2022-03-03 13:32:27'),(120428,420,'Bharta Chak','814154',1,0,'2022-03-03 13:32:27','2022-03-03 13:32:27'),(120429,420,'Bisambharchak','814155',1,0,'2022-03-03 13:32:28','2022-03-03 13:32:28'),(120430,420,'Biswaskhani','814155',1,0,'2022-03-03 13:32:28','2022-03-03 13:32:28'),(120431,420,'Boarijore','813208',1,0,'2022-03-03 13:32:28','2022-03-03 13:32:28'),(120432,420,'Burhi Kura','814153',1,0,'2022-03-03 13:32:28','2022-03-03 13:32:28'),(120433,420,'Chandanahat','814156',1,0,'2022-03-03 13:32:28','2022-03-03 13:32:28'),(120434,420,'Chapri','813208',1,0,'2022-03-03 13:32:28','2022-03-03 13:32:28'),(120435,420,'Chapri','814133',1,0,'2022-03-03 13:32:28','2022-03-03 13:32:28'),(120436,420,'Chatra','814153',1,0,'2022-03-03 13:32:28','2022-03-03 13:32:28'),(120437,420,'China Dhab','814156',1,0,'2022-03-03 13:32:28','2022-03-03 13:32:28'),(120438,420,'Dama','814153',1,0,'2022-03-03 13:32:28','2022-03-03 13:32:28'),(120439,420,'Damruhat','814153',1,0,'2022-03-03 13:32:28','2022-03-03 13:32:28'),(120440,420,'Danrey Katchery','814153',1,0,'2022-03-03 13:32:28','2022-03-03 13:32:28'),(120441,420,'Dariapur','814160',1,0,'2022-03-03 13:32:28','2022-03-03 13:32:28'),(120442,420,'Debjore','815355',1,0,'2022-03-03 13:32:28','2022-03-03 13:32:28'),(120443,420,'Deobandha','814133',1,0,'2022-03-03 13:32:28','2022-03-03 13:32:28'),(120444,420,'Deodawr','814153',1,0,'2022-03-03 13:32:28','2022-03-03 13:32:28'),(120445,420,'Dewanchak','814160',1,0,'2022-03-03 13:32:28','2022-03-03 13:32:28'),(120446,420,'Dhamni','816102',1,0,'2022-03-03 13:32:28','2022-03-03 13:32:28'),(120447,420,'Dharmodih','814154',1,0,'2022-03-03 13:32:28','2022-03-03 13:32:28'),(120448,420,'Dighi','814154',1,0,'2022-03-03 13:32:29','2022-03-03 13:32:29'),(120449,420,'Dighisiwanpur','814160',1,0,'2022-03-03 13:32:29','2022-03-03 13:32:29'),(120450,420,'Doi','814160',1,0,'2022-03-03 13:32:29','2022-03-03 13:32:29'),(120451,420,'Dubrajpur','814133',1,0,'2022-03-03 13:32:29','2022-03-03 13:32:29'),(120452,420,'Fasia','814133',1,0,'2022-03-03 13:32:29','2022-03-03 13:32:29'),(120453,420,'Gajanda','814165',1,0,'2022-03-03 13:32:29','2022-03-03 13:32:29'),(120454,420,'Gandhigram','814133',1,0,'2022-03-03 13:32:29','2022-03-03 13:32:29'),(120455,420,'Gangtaklan','814133',1,0,'2022-03-03 13:32:29','2022-03-03 13:32:29'),(120456,420,'Ghanghrabandh','814153',1,0,'2022-03-03 13:32:29','2022-03-03 13:32:29'),(120457,420,'Ghat Kuruwa','814147',1,0,'2022-03-03 13:32:29','2022-03-03 13:32:29'),(120458,420,'Ghatdumariya','814133',1,0,'2022-03-03 13:32:29','2022-03-03 13:32:29'),(120459,420,'Ghatiyari','814156',1,0,'2022-03-03 13:32:29','2022-03-03 13:32:29'),(120460,420,'Ghatkusmani','814133',1,0,'2022-03-03 13:32:29','2022-03-03 13:32:29'),(120461,420,'Ghoothi','814154',1,0,'2022-03-03 13:32:29','2022-03-03 13:32:29'),(120462,420,'Godda College','814133',1,0,'2022-03-03 13:32:29','2022-03-03 13:32:29'),(120463,420,'Godda','814133',1,0,'2022-03-03 13:32:29','2022-03-03 13:32:29'),(120464,420,'Gorhia','814165',1,0,'2022-03-03 13:32:29','2022-03-03 13:32:29'),(120465,420,'Gorikitta','814160',1,0,'2022-03-03 13:32:29','2022-03-03 13:32:29'),(120466,420,'Gumma','814133',1,0,'2022-03-03 13:32:29','2022-03-03 13:32:29'),(120467,420,'Hanwara','814154',1,0,'2022-03-03 13:32:29','2022-03-03 13:32:29'),(120468,420,'Haripur Gorbana','814133',1,0,'2022-03-03 13:32:30','2022-03-03 13:32:30'),(120469,420,'Hariyari','814153',1,0,'2022-03-03 13:32:30','2022-03-03 13:32:30'),(120470,420,'Hilaway','814133',1,0,'2022-03-03 13:32:30','2022-03-03 13:32:30'),(120471,420,'Jaminipaharpur','814133',1,0,'2022-03-03 13:32:30','2022-03-03 13:32:30'),(120472,420,'K. Parsa','814155',1,0,'2022-03-03 13:32:30','2022-03-03 13:32:30'),(120473,420,'Kadma','814155',1,0,'2022-03-03 13:32:30','2022-03-03 13:32:30'),(120474,420,'Kairadih','814153',1,0,'2022-03-03 13:32:30','2022-03-03 13:32:30'),(120475,420,'Kairasol','814102',1,0,'2022-03-03 13:32:30','2022-03-03 13:32:30'),(120476,420,'Kaitha','814155',1,0,'2022-03-03 13:32:30','2022-03-03 13:32:30'),(120477,420,'Kamaldouri','814165',1,0,'2022-03-03 13:32:30','2022-03-03 13:32:30'),(120478,420,'Kasba','814154',1,0,'2022-03-03 13:32:30','2022-03-03 13:32:30'),(120479,420,'Kasbadudhanichak','814160',1,0,'2022-03-03 13:32:30','2022-03-03 13:32:30'),(120480,420,'Kathaun','814153',1,0,'2022-03-03 13:32:30','2022-03-03 13:32:30'),(120481,420,'Kero Bazar','814147',1,0,'2022-03-03 13:32:30','2022-03-03 13:32:30'),(120482,420,'Kerwarbelsar','814147',1,0,'2022-03-03 13:32:30','2022-03-03 13:32:30'),(120483,420,'Khariani','814147',1,0,'2022-03-03 13:32:30','2022-03-03 13:32:30'),(120484,420,'Khatnai','814133',1,0,'2022-03-03 13:32:30','2022-03-03 13:32:30'),(120485,420,'Koila','814154',1,0,'2022-03-03 13:32:30','2022-03-03 13:32:30'),(120486,420,'Korkaghat','814133',1,0,'2022-03-03 13:32:30','2022-03-03 13:32:30'),(120487,420,'Kouribahiar','814133',1,0,'2022-03-03 13:32:30','2022-03-03 13:32:30'),(120488,420,'Kurmichak','814156',1,0,'2022-03-03 13:32:30','2022-03-03 13:32:30'),(120489,420,'Kushmara','814154',1,0,'2022-03-03 13:32:31','2022-03-03 13:32:31'),(120490,420,'Kushmil','814154',1,0,'2022-03-03 13:32:31','2022-03-03 13:32:31'),(120491,420,'Kusumghati','814147',1,0,'2022-03-03 13:32:31','2022-03-03 13:32:31'),(120492,420,'Lahati','814147',1,0,'2022-03-03 13:32:31','2022-03-03 13:32:31'),(120493,420,'Lakarmara','814160',1,0,'2022-03-03 13:32:31','2022-03-03 13:32:31'),(120494,420,'Lalmatia Colliery','814165',1,0,'2022-03-03 13:32:31','2022-03-03 13:32:31'),(120495,420,'Latauna','814133',1,0,'2022-03-03 13:32:31','2022-03-03 13:32:31'),(120496,420,'Latta','814153',1,0,'2022-03-03 13:32:31','2022-03-03 13:32:31'),(120497,420,'Laxmipur Bhojichak','814155',1,0,'2022-03-03 13:32:31','2022-03-03 13:32:31'),(120498,420,'Logain','814154',1,0,'2022-03-03 13:32:31','2022-03-03 13:32:31'),(120499,420,'Lohandia Bazar','814165',1,0,'2022-03-03 13:32:31','2022-03-03 13:32:31'),(120500,420,'Lohbandha','814133',1,0,'2022-03-03 13:32:31','2022-03-03 13:32:31'),(120501,420,'Lukluki','814133',1,0,'2022-03-03 13:32:31','2022-03-03 13:32:31'),(120502,420,'M. Chikaniya','814151',1,0,'2022-03-03 13:32:31','2022-03-03 13:32:31'),(120503,420,'Madhurai','814165',1,0,'2022-03-03 13:32:31','2022-03-03 13:32:31'),(120504,420,'Maheshtikri','814155',1,0,'2022-03-03 13:32:31','2022-03-03 13:32:31'),(120505,420,'Mahgama','814154',1,0,'2022-03-03 13:32:31','2022-03-03 13:32:31'),(120506,420,'Makhni','814133',1,0,'2022-03-03 13:32:31','2022-03-03 13:32:31'),(120507,420,'Mal Bhandaridih','814154',1,0,'2022-03-03 13:32:31','2022-03-03 13:32:31'),(120508,420,'Malini','814133',1,0,'2022-03-03 13:32:31','2022-03-03 13:32:31'),(120509,420,'Malrampur','814133',1,0,'2022-03-03 13:32:32','2022-03-03 13:32:32'),(120510,420,'Maniarkajral','813208',1,0,'2022-03-03 13:32:32','2022-03-03 13:32:32'),(120511,420,'Marpa','814160',1,0,'2022-03-03 13:32:32','2022-03-03 13:32:32'),(120512,420,'Meharma','814160',1,0,'2022-03-03 13:32:32','2022-03-03 13:32:32'),(120513,420,'Mohani','814153',1,0,'2022-03-03 13:32:32','2022-03-03 13:32:32'),(120514,420,'Mohanpur','814154',1,0,'2022-03-03 13:32:32','2022-03-03 13:32:32'),(120515,420,'Mohanpur','814133',1,0,'2022-03-03 13:32:32','2022-03-03 13:32:32'),(120516,420,'Mokalchak','814155',1,0,'2022-03-03 13:32:32','2022-03-03 13:32:32'),(120517,420,'Mordiha','813208',1,0,'2022-03-03 13:32:32','2022-03-03 13:32:32'),(120518,420,'Motia','814133',1,0,'2022-03-03 13:32:32','2022-03-03 13:32:32'),(120519,420,'Motiya Dumariya','814133',1,0,'2022-03-03 13:32:32','2022-03-03 13:32:32'),(120520,420,'Naraini','814154',1,0,'2022-03-03 13:32:32','2022-03-03 13:32:32'),(120521,420,'Nawdiha','814153',1,0,'2022-03-03 13:32:32','2022-03-03 13:32:32'),(120522,420,'Naya Nagar','814154',1,0,'2022-03-03 13:32:32','2022-03-03 13:32:32'),(120523,420,'Nepura','814133',1,0,'2022-03-03 13:32:32','2022-03-03 13:32:32'),(120524,420,'Nunajore','814154',1,0,'2022-03-03 13:32:32','2022-03-03 13:32:32'),(120525,420,'Nunbatta','814156',1,0,'2022-03-03 13:32:32','2022-03-03 13:32:32'),(120526,420,'P. Barmasiya','814153',1,0,'2022-03-03 13:32:32','2022-03-03 13:32:32'),(120527,420,'Padampur','814153',1,0,'2022-03-03 13:32:33','2022-03-03 13:32:33'),(120528,420,'Paharpur','814156',1,0,'2022-03-03 13:32:33','2022-03-03 13:32:33'),(120529,420,'Parariya','814155',1,0,'2022-03-03 13:32:33','2022-03-03 13:32:33'),(120530,420,'Parspani','814147',1,0,'2022-03-03 13:32:33','2022-03-03 13:32:33'),(120531,420,'Parua','814155',1,0,'2022-03-03 13:32:33','2022-03-03 13:32:33'),(120532,420,'Pasai','814153',1,0,'2022-03-03 13:32:33','2022-03-03 13:32:33'),(120533,420,'Pathergama','814147',1,0,'2022-03-03 13:32:33','2022-03-03 13:32:33'),(120534,420,'Pathra','814133',1,0,'2022-03-03 13:32:33','2022-03-03 13:32:33'),(120535,420,'Pindra Hat','814153',1,0,'2022-03-03 13:32:33','2022-03-03 13:32:33'),(120536,420,'Pipra','814147',1,0,'2022-03-03 13:32:33','2022-03-03 13:32:33'),(120537,420,'Pratappur','814160',1,0,'2022-03-03 13:32:33','2022-03-03 13:32:33'),(120538,420,'Raghunathpur Lathibari','814153',1,0,'2022-03-03 13:32:33','2022-03-03 13:32:33'),(120539,420,'Raja Bhitaa','814147',1,0,'2022-03-03 13:32:33','2022-03-03 13:32:33'),(120540,420,'Ramla Dikwani','814133',1,0,'2022-03-03 13:32:33','2022-03-03 13:32:33'),(120541,420,'Rangachak','813208',1,0,'2022-03-03 13:32:33','2022-03-03 13:32:33'),(120542,420,'Rupni','814155',1,0,'2022-03-03 13:32:33','2022-03-03 13:32:33'),(120543,420,'Sahapur Beldiha','814155',1,0,'2022-03-03 13:32:33','2022-03-03 13:32:33'),(120544,420,'Saidapur','814133',1,0,'2022-03-03 13:32:33','2022-03-03 13:32:33'),(120545,420,'Salaiya','814153',1,0,'2022-03-03 13:32:33','2022-03-03 13:32:33'),(120546,420,'Samri','814155',1,0,'2022-03-03 13:32:33','2022-03-03 13:32:33'),(120547,420,'Sanour','814155',1,0,'2022-03-03 13:32:33','2022-03-03 13:32:33'),(120548,420,'Sarba','814133',1,0,'2022-03-03 13:32:34','2022-03-03 13:32:34'),(120549,420,'Sarbhanga','814165',1,0,'2022-03-03 13:32:34','2022-03-03 13:32:34'),(120550,420,'Sarouni Bazar','814156',1,0,'2022-03-03 13:32:34','2022-03-03 13:32:34'),(120551,420,'Simarda','814133',1,0,'2022-03-03 13:32:34','2022-03-03 13:32:34'),(120552,420,'Simlongcolliery','816102',1,0,'2022-03-03 13:32:34','2022-03-03 13:32:34'),(120553,420,'Sunder Pahari','814156',1,0,'2022-03-03 13:32:34','2022-03-03 13:32:34'),(120554,420,'Sundmara','814156',1,0,'2022-03-03 13:32:34','2022-03-03 13:32:34'),(120555,420,'Surni','814160',1,0,'2022-03-03 13:32:34','2022-03-03 13:32:34'),(120556,420,'Tardiha','814147',1,0,'2022-03-03 13:32:34','2022-03-03 13:32:34'),(120557,420,'Thakurgangti','813208',1,0,'2022-03-03 13:32:34','2022-03-03 13:32:34'),(120558,420,'Tularambhuska','814160',1,0,'2022-03-03 13:32:34','2022-03-03 13:32:34'),(120559,421,'Adar','835231',1,0,'2022-03-03 13:32:34','2022-03-03 13:32:34'),(120560,421,'Amalia','835203',1,0,'2022-03-03 13:32:34','2022-03-03 13:32:34'),(120561,421,'Amgaon','835232',1,0,'2022-03-03 13:32:34','2022-03-03 13:32:34'),(120562,421,'Anjan','835233',1,0,'2022-03-03 13:32:34','2022-03-03 13:32:34'),(120563,421,'Arangu','835208',1,0,'2022-03-03 13:32:34','2022-03-03 13:32:34'),(120564,421,'Arko','835324',1,0,'2022-03-03 13:32:34','2022-03-03 13:32:34'),(120565,421,'Armai','835220',1,0,'2022-03-03 13:32:34','2022-03-03 13:32:34'),(120566,421,'Asani','835324',1,0,'2022-03-03 13:32:34','2022-03-03 13:32:34'),(120567,421,'Asro','835203',1,0,'2022-03-03 13:32:34','2022-03-03 13:32:34'),(120568,421,'Baghima','835220',1,0,'2022-03-03 13:32:34','2022-03-03 13:32:34'),(120569,421,'Banaghutu','835229',1,0,'2022-03-03 13:32:34','2022-03-03 13:32:34'),(120570,421,'Banai','835229',1,0,'2022-03-03 13:32:35','2022-03-03 13:32:35'),(120571,421,'Banari','835231',1,0,'2022-03-03 13:32:35','2022-03-03 13:32:35'),(120572,421,'Bargaon','835211',1,0,'2022-03-03 13:32:35','2022-03-03 13:32:35'),(120573,421,'Bargaon','835324',1,0,'2022-03-03 13:32:35','2022-03-03 13:32:35'),(120574,421,'Barwenagar','835206',1,0,'2022-03-03 13:32:35','2022-03-03 13:32:35'),(120575,421,'Basia','835229',1,0,'2022-03-03 13:32:35','2022-03-03 13:32:35'),(120576,421,'Basua','835233',1,0,'2022-03-03 13:32:35','2022-03-03 13:32:35'),(120577,421,'Belagara','835208',1,0,'2022-03-03 13:32:35','2022-03-03 13:32:35'),(120578,421,'Bhagitoli','835230',1,0,'2022-03-03 13:32:35','2022-03-03 13:32:35'),(120579,421,'Bhandra','835302',1,0,'2022-03-03 13:32:35','2022-03-03 13:32:35'),(120580,421,'Bharno','835203',1,0,'2022-03-03 13:32:35','2022-03-03 13:32:35'),(120581,421,'Bhikhampur','835230',1,0,'2022-03-03 13:32:35','2022-03-03 13:32:35'),(120582,421,'Bhurso','835324',1,0,'2022-03-03 13:32:35','2022-03-03 13:32:35'),(120583,421,'Bilingbira','835220',1,0,'2022-03-03 13:32:35','2022-03-03 13:32:35'),(120584,421,'Bindora','835206',1,0,'2022-03-03 13:32:35','2022-03-03 13:32:35'),(120585,421,'Binkera','835232',1,0,'2022-03-03 13:32:35','2022-03-03 13:32:35'),(120586,421,'Bishunpur','835231',1,0,'2022-03-03 13:32:35','2022-03-03 13:32:35'),(120587,421,'Chainpur (Gumla)','835206',1,0,'2022-03-03 13:32:35','2022-03-03 13:32:35'),(120588,421,'Chharda','835324',1,0,'2022-03-03 13:32:35','2022-03-03 13:32:35'),(120589,421,'Chiraiyan','835230',1,0,'2022-03-03 13:32:35','2022-03-03 13:32:35'),(120590,421,'Danekera','835203',1,0,'2022-03-03 13:32:35','2022-03-03 13:32:35'),(120591,421,'Datia','835324',1,0,'2022-03-03 13:32:35','2022-03-03 13:32:35'),(120592,421,'Deoki','835208',1,0,'2022-03-03 13:32:35','2022-03-03 13:32:35'),(120593,421,'Dhedhouli','835220',1,0,'2022-03-03 13:32:36','2022-03-03 13:32:36'),(120594,421,'Dina','835230',1,0,'2022-03-03 13:32:36','2022-03-03 13:32:36'),(120595,421,'Dumardih','835220',1,0,'2022-03-03 13:32:36','2022-03-03 13:32:36'),(120596,421,'Dumarpath','835212',1,0,'2022-03-03 13:32:36','2022-03-03 13:32:36'),(120597,421,'Dumarpath','835206',1,0,'2022-03-03 13:32:36','2022-03-03 13:32:36'),(120598,421,'Eori','835233',1,0,'2022-03-03 13:32:36','2022-03-03 13:32:36'),(120599,421,'Gamharia','835208',1,0,'2022-03-03 13:32:36','2022-03-03 13:32:36'),(120600,421,'Gangara','835229',1,0,'2022-03-03 13:32:36','2022-03-03 13:32:36'),(120601,421,'Gara','835229',1,0,'2022-03-03 13:32:36','2022-03-03 13:32:36'),(120602,421,'Ghaghra','835208',1,0,'2022-03-03 13:32:36','2022-03-03 13:32:36'),(120603,421,'Ghatgaon','835233',1,0,'2022-03-03 13:32:36','2022-03-03 13:32:36'),(120604,421,'Govindpur','835230',1,0,'2022-03-03 13:32:36','2022-03-03 13:32:36'),(120605,421,'Gumla Bazar','835207',1,0,'2022-03-03 13:32:36','2022-03-03 13:32:36'),(120606,421,'Gumla H.O','835207',1,0,'2022-03-03 13:32:36','2022-03-03 13:32:36'),(120607,421,'Gunia','835233',1,0,'2022-03-03 13:32:36','2022-03-03 13:32:36'),(120608,421,'Haphu','835229',1,0,'2022-03-03 13:32:36','2022-03-03 13:32:36'),(120609,421,'Harra','835206',1,0,'2022-03-03 13:32:36','2022-03-03 13:32:36'),(120610,421,'Harup','835231',1,0,'2022-03-03 13:32:36','2022-03-03 13:32:36'),(120611,421,'Hesag','835206',1,0,'2022-03-03 13:32:37','2022-03-03 13:32:37'),(120612,421,'Hisri','835230',1,0,'2022-03-03 13:32:37','2022-03-03 13:32:37'),(120613,421,'Hutar','835208',1,0,'2022-03-03 13:32:37','2022-03-03 13:32:37'),(120614,421,'Icha','835208',1,0,'2022-03-03 13:32:37','2022-03-03 13:32:37'),(120615,421,'Jamgain','835206',1,0,'2022-03-03 13:32:37','2022-03-03 13:32:37'),(120616,421,'Jamgain','835203',1,0,'2022-03-03 13:32:37','2022-03-03 13:32:37'),(120617,421,'Jamti','835231',1,0,'2022-03-03 13:32:37','2022-03-03 13:32:37'),(120618,421,'Janawal','835206',1,0,'2022-03-03 13:32:37','2022-03-03 13:32:37'),(120619,421,'Jari','835206',1,0,'2022-03-03 13:32:37','2022-03-03 13:32:37'),(120620,421,'Jarigutua','835231',1,0,'2022-03-03 13:32:37','2022-03-03 13:32:37'),(120621,421,'Jhikochatti','835203',1,0,'2022-03-03 13:32:37','2022-03-03 13:32:37'),(120622,421,'Jori','835231',1,0,'2022-03-03 13:32:37','2022-03-03 13:32:37'),(120623,421,'Jura','835324',1,0,'2022-03-03 13:32:37','2022-03-03 13:32:37'),(120624,421,'Kaliga','835220',1,0,'2022-03-03 13:32:37','2022-03-03 13:32:37'),(120625,421,'Kamdara','835227',1,0,'2022-03-03 13:32:37','2022-03-03 13:32:37'),(120626,421,'Kamta','835232',1,0,'2022-03-03 13:32:37','2022-03-03 13:32:37'),(120627,421,'Karanj','835324',1,0,'2022-03-03 13:32:37','2022-03-03 13:32:37'),(120628,421,'Karida','835232',1,0,'2022-03-03 13:32:37','2022-03-03 13:32:37'),(120629,421,'Karkari','835324',1,0,'2022-03-03 13:32:37','2022-03-03 13:32:37'),(120630,421,'Karomdajovasisai','835324',1,0,'2022-03-03 13:32:37','2022-03-03 13:32:37'),(120631,421,'Karomdi','835232',1,0,'2022-03-03 13:32:38','2022-03-03 13:32:38'),(120632,421,'Karounda','835324',1,0,'2022-03-03 13:32:38','2022-03-03 13:32:38'),(120633,421,'Kartick Oraon College','835207',1,0,'2022-03-03 13:32:38','2022-03-03 13:32:38'),(120634,421,'Katkahi','835206',1,0,'2022-03-03 13:32:38','2022-03-03 13:32:38'),(120635,421,'Kensir','835206',1,0,'2022-03-03 13:32:38','2022-03-03 13:32:38'),(120636,421,'Kereng','835206',1,0,'2022-03-03 13:32:38','2022-03-03 13:32:38'),(120637,421,'Keshipara','835220',1,0,'2022-03-03 13:32:38','2022-03-03 13:32:38'),(120638,421,'Kharka','835233',1,0,'2022-03-03 13:32:38','2022-03-03 13:32:38'),(120639,421,'Khetli','835230',1,0,'2022-03-03 13:32:38','2022-03-03 13:32:38'),(120640,421,'Khora','835324',1,0,'2022-03-03 13:32:38','2022-03-03 13:32:38'),(120641,421,'Koleng','835220',1,0,'2022-03-03 13:32:38','2022-03-03 13:32:38'),(120642,421,'Konbirnawatoli','835229',1,0,'2022-03-03 13:32:38','2022-03-03 13:32:38'),(120643,421,'Kondra','835232',1,0,'2022-03-03 13:32:38','2022-03-03 13:32:38'),(120644,421,'Konkel','835232',1,0,'2022-03-03 13:32:38','2022-03-03 13:32:38'),(120645,421,'Kotam','835233',1,0,'2022-03-03 13:32:38','2022-03-03 13:32:38'),(120646,421,'Kugaon','835208',1,0,'2022-03-03 13:32:38','2022-03-03 13:32:38'),(120647,421,'Kumhari','835229',1,0,'2022-03-03 13:32:38','2022-03-03 13:32:38'),(120648,421,'Kurag','835231',1,0,'2022-03-03 13:32:38','2022-03-03 13:32:38'),(120649,421,'Kurum','835220',1,0,'2022-03-03 13:32:38','2022-03-03 13:32:38'),(120650,421,'Kurumgarh','835206',1,0,'2022-03-03 13:32:38','2022-03-03 13:32:38'),(120651,421,'Latra','835227',1,0,'2022-03-03 13:32:38','2022-03-03 13:32:38'),(120652,421,'Longa','835229',1,0,'2022-03-03 13:32:38','2022-03-03 13:32:38'),(120653,421,'Lotwa','835220',1,0,'2022-03-03 13:32:39','2022-03-03 13:32:39'),(120654,421,'Lowabar','835230',1,0,'2022-03-03 13:32:39','2022-03-03 13:32:39'),(120655,421,'Lungtu','835229',1,0,'2022-03-03 13:32:39','2022-03-03 13:32:39'),(120656,421,'Luru','835206',1,0,'2022-03-03 13:32:39','2022-03-03 13:32:39'),(120657,421,'Mahadeo Chegri','835203',1,0,'2022-03-03 13:32:39','2022-03-03 13:32:39'),(120658,421,'Majhigaon','835230',1,0,'2022-03-03 13:32:39','2022-03-03 13:32:39'),(120659,421,'Malai','835220',1,0,'2022-03-03 13:32:39','2022-03-03 13:32:39'),(120660,421,'Mamarla','835229',1,0,'2022-03-03 13:32:39','2022-03-03 13:32:39'),(120661,421,'Marasili','835203',1,0,'2022-03-03 13:32:39','2022-03-03 13:32:39'),(120662,421,'Marda','835220',1,0,'2022-03-03 13:32:39','2022-03-03 13:32:39'),(120663,421,'Marwa','835231',1,0,'2022-03-03 13:32:39','2022-03-03 13:32:39'),(120664,421,'Marwai','835231',1,0,'2022-03-03 13:32:39','2022-03-03 13:32:39'),(120665,421,'Moreng','835229',1,0,'2022-03-03 13:32:39','2022-03-03 13:32:39'),(120666,421,'Murgu','835324',1,0,'2022-03-03 13:32:39','2022-03-03 13:32:39'),(120667,421,'Murkunda','835220',1,0,'2022-03-03 13:32:39','2022-03-03 13:32:39'),(120668,421,'Nagar','835324',1,0,'2022-03-03 13:32:39','2022-03-03 13:32:39'),(120669,421,'Nagpheni','835324',1,0,'2022-03-03 13:32:39','2022-03-03 13:32:39'),(120670,421,'Nathpur','835220',1,0,'2022-03-03 13:32:39','2022-03-03 13:32:39'),(120671,421,'Nawadih','835208',1,0,'2022-03-03 13:32:39','2022-03-03 13:32:39'),(120672,421,'Nawadih','835233',1,0,'2022-03-03 13:32:39','2022-03-03 13:32:39'),(120673,421,'Nawagarh (Gumla)','835232',1,0,'2022-03-03 13:32:40','2022-03-03 13:32:40'),(120674,421,'Noadih','835230',1,0,'2022-03-03 13:32:40','2022-03-03 13:32:40'),(120675,421,'Obera Sundarpur','835220',1,0,'2022-03-03 13:32:40','2022-03-03 13:32:40'),(120676,421,'Olmunda','835324',1,0,'2022-03-03 13:32:40','2022-03-03 13:32:40'),(120677,421,'Pabeya','835203',1,0,'2022-03-03 13:32:40','2022-03-03 13:32:40'),(120678,421,'Pak R.S.','835227',1,0,'2022-03-03 13:32:40','2022-03-03 13:32:40'),(120679,421,'Palkot','835220',1,0,'2022-03-03 13:32:40','2022-03-03 13:32:40'),(120680,421,'Parsa','835232',1,0,'2022-03-03 13:32:40','2022-03-03 13:32:40'),(120681,421,'Patia','835324',1,0,'2022-03-03 13:32:40','2022-03-03 13:32:40'),(120682,421,'Pimpi','835227',1,0,'2022-03-03 13:32:40','2022-03-03 13:32:40'),(120683,421,'Pojenga','835220',1,0,'2022-03-03 13:32:40','2022-03-03 13:32:40'),(120684,421,'Pok R.S.','835227',1,0,'2022-03-03 13:32:40','2022-03-03 13:32:40'),(120685,421,'Pulung','835232',1,0,'2022-03-03 13:32:40','2022-03-03 13:32:40'),(120686,421,'Puto','835208',1,0,'2022-03-03 13:32:40','2022-03-03 13:32:40'),(120687,421,'Putrungi','835206',1,0,'2022-03-03 13:32:40','2022-03-03 13:32:40'),(120688,421,'Raidih','835232',1,0,'2022-03-03 13:32:40','2022-03-03 13:32:40'),(120689,421,'Rajawal','835230',1,0,'2022-03-03 13:32:40','2022-03-03 13:32:40'),(120690,421,'Ramtolaya','835227',1,0,'2022-03-03 13:32:40','2022-03-03 13:32:40'),(120691,421,'Ruki','835231',1,0,'2022-03-03 13:32:40','2022-03-03 13:32:40'),(120692,421,'Sahijana','835302',1,0,'2022-03-03 13:32:40','2022-03-03 13:32:40'),(120693,421,'Sakarpur Gamharia','835233',1,0,'2022-03-03 13:32:40','2022-03-03 13:32:40'),(120694,421,'Sakrauli','835324',1,0,'2022-03-03 13:32:40','2022-03-03 13:32:40'),(120695,421,'Salegutu','835227',1,0,'2022-03-03 13:32:40','2022-03-03 13:32:40'),(120696,421,'Salemnawatoli','835231',1,0,'2022-03-03 13:32:41','2022-03-03 13:32:41'),(120697,421,'Sarango','835231',1,0,'2022-03-03 13:32:41','2022-03-03 13:32:41'),(120698,421,'Sarita','835227',1,0,'2022-03-03 13:32:41','2022-03-03 13:32:41'),(120699,421,'Sato','835231',1,0,'2022-03-03 13:32:41','2022-03-03 13:32:41'),(120700,421,'Sewsoreng','835208',1,0,'2022-03-03 13:32:41','2022-03-03 13:32:41'),(120701,421,'Shiwnathpur','835324',1,0,'2022-03-03 13:32:41','2022-03-03 13:32:41'),(120702,421,'Sikri','835206',1,0,'2022-03-03 13:32:41','2022-03-03 13:32:41'),(120703,421,'Silam','835232',1,0,'2022-03-03 13:32:41','2022-03-03 13:32:41'),(120704,421,'Sisai (Gumla)','835324',1,0,'2022-03-03 13:32:41','2022-03-03 13:32:41'),(120705,421,'Sogra','835324',1,0,'2022-03-03 13:32:41','2022-03-03 13:32:41'),(120706,421,'Sona','835214',1,0,'2022-03-03 13:32:41','2022-03-03 13:32:41'),(120707,421,'Srinagar','835206',1,0,'2022-03-03 13:32:41','2022-03-03 13:32:41'),(120708,421,'Sukurda','835229',1,0,'2022-03-03 13:32:41','2022-03-03 13:32:41'),(120709,421,'Sundaridih','835220',1,0,'2022-03-03 13:32:41','2022-03-03 13:32:41'),(120710,421,'Surhu','835227',1,0,'2022-03-03 13:32:41','2022-03-03 13:32:41'),(120711,421,'Sursang','835232',1,0,'2022-03-03 13:32:41','2022-03-03 13:32:41'),(120712,421,'Tabela','835206',1,0,'2022-03-03 13:32:41','2022-03-03 13:32:41'),(120713,421,'Taisera','835220',1,0,'2022-03-03 13:32:41','2022-03-03 13:32:41'),(120714,421,'Tangaria','835220',1,0,'2022-03-03 13:32:41','2022-03-03 13:32:41'),(120715,421,'Tapkara','835220',1,0,'2022-03-03 13:32:41','2022-03-03 13:32:41'),(120716,421,'Telgaon','835232',1,0,'2022-03-03 13:32:41','2022-03-03 13:32:41'),(120717,421,'Tongo','835206',1,0,'2022-03-03 13:32:42','2022-03-03 13:32:42'),(120718,421,'Totambi','835208',1,0,'2022-03-03 13:32:42','2022-03-03 13:32:42'),(120719,421,'Toto','835233',1,0,'2022-03-03 13:32:42','2022-03-03 13:32:42'),(120720,421,'Turiamba','835203',1,0,'2022-03-03 13:32:42','2022-03-03 13:32:42'),(120721,421,'Tusgaon','835206',1,0,'2022-03-03 13:32:42','2022-03-03 13:32:42'),(120722,422,'Ambajit','825311',1,0,'2022-03-03 13:32:42','2022-03-03 13:32:42'),(120723,422,'Babhanbay','825302',1,0,'2022-03-03 13:32:42','2022-03-03 13:32:42'),(120724,422,'Badam','825311',1,0,'2022-03-03 13:32:42','2022-03-03 13:32:42'),(120725,422,'Bahimar','825319',1,0,'2022-03-03 13:32:42','2022-03-03 13:32:42'),(120726,422,'Banahappa','825313',1,0,'2022-03-03 13:32:42','2022-03-03 13:32:42'),(120727,422,'Banaso','825312',1,0,'2022-03-03 13:32:42','2022-03-03 13:32:42'),(120728,422,'Bara Bazar (Hazaribag)','825301',1,0,'2022-03-03 13:32:42','2022-03-03 13:32:42'),(120729,422,'Barhi (Hazaribag)','825405',1,0,'2022-03-03 13:32:42','2022-03-03 13:32:42'),(120730,422,'Bariath','825402',1,0,'2022-03-03 13:32:42','2022-03-03 13:32:42'),(120731,422,'Barkagaon','825311',1,0,'2022-03-03 13:32:42','2022-03-03 13:32:42'),(120732,422,'Barkatha','825323',1,0,'2022-03-03 13:32:42','2022-03-03 13:32:42'),(120733,422,'Barwan','825323',1,0,'2022-03-03 13:32:42','2022-03-03 13:32:42'),(120734,422,'Basaria','825406',1,0,'2022-03-03 13:32:43','2022-03-03 13:32:43'),(120735,422,'Bedam','825313',1,0,'2022-03-03 13:32:43','2022-03-03 13:32:43'),(120736,422,'Bela','825406',1,0,'2022-03-03 13:32:43','2022-03-03 13:32:43'),(120737,422,'Belkapi','825323',1,0,'2022-03-03 13:32:43','2022-03-03 13:32:43'),(120738,422,'Bhelwara','825312',1,0,'2022-03-03 13:32:43','2022-03-03 13:32:43'),(120739,422,'Bhusai','825402',1,0,'2022-03-03 13:32:43','2022-03-03 13:32:43'),(120740,422,'Bishungarh (Hazaribag)','825312',1,0,'2022-03-03 13:32:43','2022-03-03 13:32:43'),(120741,422,'Boddam Bazar','825301',1,0,'2022-03-03 13:32:43','2022-03-03 13:32:43'),(120742,422,'Brindawan','825406',1,0,'2022-03-03 13:32:43','2022-03-03 13:32:43'),(120743,422,'BSF Meru','825317',1,0,'2022-03-03 13:32:43','2022-03-03 13:32:43'),(120744,422,'Chandwar','825303',1,0,'2022-03-03 13:32:43','2022-03-03 13:32:43'),(120745,422,'Charhi','825336',1,0,'2022-03-03 13:32:43','2022-03-03 13:32:43'),(120746,422,'Chepakala','825311',1,0,'2022-03-03 13:32:43','2022-03-03 13:32:43'),(120747,422,'Chouparan','825406',1,0,'2022-03-03 13:32:43','2022-03-03 13:32:43'),(120748,422,'College More','825302',1,0,'2022-03-03 13:32:43','2022-03-03 13:32:43'),(120749,422,'Dadighaghar','825411',1,0,'2022-03-03 13:32:43','2022-03-03 13:32:43'),(120750,422,'Dadpur','825406',1,0,'2022-03-03 13:32:43','2022-03-03 13:32:43'),(120751,422,'Danr','825319',1,0,'2022-03-03 13:32:43','2022-03-03 13:32:43'),(120752,422,'Dantokhurd','825411',1,0,'2022-03-03 13:32:44','2022-03-03 13:32:44'),(120753,422,'Daroo','825313',1,0,'2022-03-03 13:32:44','2022-03-03 13:32:44'),(120754,422,'Deochanda','825405',1,0,'2022-03-03 13:32:44','2022-03-03 13:32:44'),(120755,422,'Deokuli','825402',1,0,'2022-03-03 13:32:44','2022-03-03 13:32:44'),(120756,422,'Distt. Board','825301',1,0,'2022-03-03 13:32:44','2022-03-03 13:32:44'),(120757,422,'Dumraon','825402',1,0,'2022-03-03 13:32:44','2022-03-03 13:32:44'),(120758,422,'Gangpacho','825323',1,0,'2022-03-03 13:32:44','2022-03-03 13:32:44'),(120759,422,'Garikala','825311',1,0,'2022-03-03 13:32:44','2022-03-03 13:32:44'),(120760,422,'Gossaibalia','825311',1,0,'2022-03-03 13:32:44','2022-03-03 13:32:44'),(120761,422,'Gouriakarma','825405',1,0,'2022-03-03 13:32:44','2022-03-03 13:32:44'),(120762,422,'Govindpur Kala','825312',1,0,'2022-03-03 13:32:44','2022-03-03 13:32:44'),(120763,422,'Harli','825311',1,0,'2022-03-03 13:32:44','2022-03-03 13:32:44'),(120764,422,'Harlipeto','825313',1,0,'2022-03-03 13:32:44','2022-03-03 13:32:44'),(120765,422,'Hazaribagh H.O','825301',1,0,'2022-03-03 13:32:44','2022-03-03 13:32:44'),(120766,422,'Hearanganj','825302',1,0,'2022-03-03 13:32:44','2022-03-03 13:32:44'),(120767,422,'Hesalong','829101',1,0,'2022-03-03 13:32:44','2022-03-03 13:32:44'),(120768,422,'Hewai','825311',1,0,'2022-03-03 13:32:44','2022-03-03 13:32:44'),(120769,422,'Hurlung','825312',1,0,'2022-03-03 13:32:44','2022-03-03 13:32:44'),(120770,422,'Ichak','825402',1,0,'2022-03-03 13:32:44','2022-03-03 13:32:44'),(120771,422,'Jagarnath Dham','825317',1,0,'2022-03-03 13:32:44','2022-03-03 13:32:44'),(120772,422,'Jagdishpur','825303',1,0,'2022-03-03 13:32:44','2022-03-03 13:32:44'),(120773,422,'Jarwa','825336',1,0,'2022-03-03 13:32:44','2022-03-03 13:32:44'),(120774,422,'Jharpo','825313',1,0,'2022-03-03 13:32:45','2022-03-03 13:32:45'),(120775,422,'Jhurjhuri','825405',1,0,'2022-03-03 13:32:45','2022-03-03 13:32:45'),(120776,422,'Jihu','825411',1,0,'2022-03-03 13:32:45','2022-03-03 13:32:45'),(120777,422,'Jordag','825302',1,0,'2022-03-03 13:32:45','2022-03-03 13:32:45'),(120778,422,'Kadma','825302',1,0,'2022-03-03 13:32:45','2022-03-03 13:32:45'),(120779,422,'Kandaber','825311',1,0,'2022-03-03 13:32:45','2022-03-03 13:32:45'),(120780,422,'Kapka','825323',1,0,'2022-03-03 13:32:45','2022-03-03 13:32:45'),(120781,422,'Kariatpur','825402',1,0,'2022-03-03 13:32:45','2022-03-03 13:32:45'),(120782,422,'Katkamsandi','825319',1,0,'2022-03-03 13:32:45','2022-03-03 13:32:45'),(120783,422,'Keredari','825311',1,0,'2022-03-03 13:32:45','2022-03-03 13:32:45'),(120784,422,'Kewal','825405',1,0,'2022-03-03 13:32:45','2022-03-03 13:32:45'),(120785,422,'Khambhwa','825313',1,0,'2022-03-03 13:32:45','2022-03-03 13:32:45'),(120786,422,'Konardam','825315',1,0,'2022-03-03 13:32:45','2022-03-03 13:32:45'),(120787,422,'Korrah','825303',1,0,'2022-03-03 13:32:45','2022-03-03 13:32:45'),(120788,422,'Kutipisi','825411',1,0,'2022-03-03 13:32:45','2022-03-03 13:32:45'),(120789,422,'Lilanagar','825302',1,0,'2022-03-03 13:32:45','2022-03-03 13:32:45'),(120790,422,'Lohandi','825406',1,0,'2022-03-03 13:32:45','2022-03-03 13:32:45'),(120791,422,'Lohandi','825401',1,0,'2022-03-03 13:32:45','2022-03-03 13:32:45'),(120792,422,'Lupung','825319',1,0,'2022-03-03 13:32:46','2022-03-03 13:32:46'),(120793,422,'Maheshra','825313',1,0,'2022-03-03 13:32:46','2022-03-03 13:32:46'),(120794,422,'Manjhgawan','825411',1,0,'2022-03-03 13:32:46','2022-03-03 13:32:46'),(120795,422,'Morangi','825302',1,0,'2022-03-03 13:32:46','2022-03-03 13:32:46'),(120796,422,'Nagarbarsot','825405',1,0,'2022-03-03 13:32:46','2022-03-03 13:32:46'),(120797,422,'Nagrichurchu','825302',1,0,'2022-03-03 13:32:46','2022-03-03 13:32:46'),(120798,422,'Narchahi','825406',1,0,'2022-03-03 13:32:46','2022-03-03 13:32:46'),(120799,422,'Nawada','825312',1,0,'2022-03-03 13:32:46','2022-03-03 13:32:46'),(120800,422,'Nawada','825302',1,0,'2022-03-03 13:32:46','2022-03-03 13:32:46'),(120801,422,'Oria','825303',1,0,'2022-03-03 13:32:46','2022-03-03 13:32:46'),(120802,422,'Pabra','825319',1,0,'2022-03-03 13:32:46','2022-03-03 13:32:46'),(120803,422,'Padaria','825405',1,0,'2022-03-03 13:32:46','2022-03-03 13:32:46'),(120804,422,'Padma','825411',1,0,'2022-03-03 13:32:46','2022-03-03 13:32:46'),(120805,422,'Palani','829119',1,0,'2022-03-03 13:32:46','2022-03-03 13:32:46'),(120806,422,'Pandeybara','825406',1,0,'2022-03-03 13:32:46','2022-03-03 13:32:46'),(120807,422,'Pandu','825311',1,0,'2022-03-03 13:32:46','2022-03-03 13:32:46'),(120808,422,'Partanga','825313',1,0,'2022-03-03 13:32:46','2022-03-03 13:32:46'),(120809,422,'Pelawal','825319',1,0,'2022-03-03 13:32:46','2022-03-03 13:32:46'),(120810,422,'Pethiatand','825301',1,0,'2022-03-03 13:32:46','2022-03-03 13:32:46'),(120811,422,'Punai','825402',1,0,'2022-03-03 13:32:46','2022-03-03 13:32:46'),(120812,422,'Rampur','825406',1,0,'2022-03-03 13:32:46','2022-03-03 13:32:46'),(120813,422,'Rasoiyadhamna','825405',1,0,'2022-03-03 13:32:46','2022-03-03 13:32:46'),(120814,422,'Ratanpur','825402',1,0,'2022-03-03 13:32:47','2022-03-03 13:32:47'),(120815,422,'Reformatory School','825319',1,0,'2022-03-03 13:32:47','2022-03-03 13:32:47'),(120816,422,'Rewali','825302',1,0,'2022-03-03 13:32:47','2022-03-03 13:32:47'),(120817,422,'Rolla','825303',1,0,'2022-03-03 13:32:47','2022-03-03 13:32:47'),(120818,422,'Sahpur','825319',1,0,'2022-03-03 13:32:47','2022-03-03 13:32:47'),(120819,422,'Sanrh','825311',1,0,'2022-03-03 13:32:47','2022-03-03 13:32:47'),(120820,422,'Saraiya','825411',1,0,'2022-03-03 13:32:47','2022-03-03 13:32:47'),(120821,422,'Selhara','825406',1,0,'2022-03-03 13:32:47','2022-03-03 13:32:47'),(120822,422,'Shiladih','825323',1,0,'2022-03-03 13:32:47','2022-03-03 13:32:47'),(120823,422,'Singhrawan','825406',1,0,'2022-03-03 13:32:47','2022-03-03 13:32:47'),(120824,422,'Sitagarha','825303',1,0,'2022-03-03 13:32:47','2022-03-03 13:32:47'),(120825,422,'Sultana','825319',1,0,'2022-03-03 13:32:47','2022-03-03 13:32:47'),(120826,422,'Surajpura','825411',1,0,'2022-03-03 13:32:47','2022-03-03 13:32:47'),(120827,422,'Tatijharia','825313',1,0,'2022-03-03 13:32:47','2022-03-03 13:32:47'),(120828,422,'Tilra','825402',1,0,'2022-03-03 13:32:47','2022-03-03 13:32:47'),(120829,422,'Uchaghana','825312',1,0,'2022-03-03 13:32:47','2022-03-03 13:32:47'),(120830,423,'Afzalpur','815355',1,0,'2022-03-03 13:32:47','2022-03-03 13:32:47'),(120831,423,'Amba','815359',1,0,'2022-03-03 13:32:47','2022-03-03 13:32:47'),(120832,423,'Amdiha','815352',1,0,'2022-03-03 13:32:47','2022-03-03 13:32:47'),(120833,423,'Amjora Koiridih','815352',1,0,'2022-03-03 13:32:47','2022-03-03 13:32:47'),(120834,423,'Asanchua','815351',1,0,'2022-03-03 13:32:48','2022-03-03 13:32:48'),(120835,423,'Babupur','815359',1,0,'2022-03-03 13:32:48','2022-03-03 13:32:48'),(120836,423,'Bagdaha','815351',1,0,'2022-03-03 13:32:48','2022-03-03 13:32:48'),(120837,423,'Bagdehri','815359',1,0,'2022-03-03 13:32:48','2022-03-03 13:32:48'),(120838,423,'Bagrudih','815352',1,0,'2022-03-03 13:32:48','2022-03-03 13:32:48'),(120839,423,'Baragholjore','815355',1,0,'2022-03-03 13:32:48','2022-03-03 13:32:48'),(120840,423,'Bena','815351',1,0,'2022-03-03 13:32:48','2022-03-03 13:32:48'),(120841,423,'Bewa','815351',1,0,'2022-03-03 13:32:48','2022-03-03 13:32:48'),(120842,423,'Bindapathar','815351',1,0,'2022-03-03 13:32:48','2022-03-03 13:32:48'),(120843,423,'Chainpur','815352',1,0,'2022-03-03 13:32:48','2022-03-03 13:32:48'),(120844,423,'Chalna Dhobna','815351',1,0,'2022-03-03 13:32:48','2022-03-03 13:32:48'),(120845,423,'Chandra Dhipa','815354',1,0,'2022-03-03 13:32:48','2022-03-03 13:32:48'),(120846,423,'Chapuria','815351',1,0,'2022-03-03 13:32:48','2022-03-03 13:32:48'),(120847,423,'Charakmara','815359',1,0,'2022-03-03 13:32:48','2022-03-03 13:32:48'),(120848,423,'Chirudih Bakudih','815351',1,0,'2022-03-03 13:32:48','2022-03-03 13:32:48'),(120849,423,'Chitra','815351',1,0,'2022-03-03 13:32:48','2022-03-03 13:32:48'),(120850,423,'D. Nayadih','815352',1,0,'2022-03-03 13:32:48','2022-03-03 13:32:48'),(120851,423,'Dakhin Bahal','815351',1,0,'2022-03-03 13:32:48','2022-03-03 13:32:48'),(120852,423,'Dewalbari','815352',1,0,'2022-03-03 13:32:48','2022-03-03 13:32:48'),(120853,423,'Dhandra','815351',1,0,'2022-03-03 13:32:49','2022-03-03 13:32:49'),(120854,423,'Dhasania','814166',1,0,'2022-03-03 13:32:49','2022-03-03 13:32:49'),(120855,423,'Fatehpur (Jamtara)','814166',1,0,'2022-03-03 13:32:49','2022-03-03 13:32:49'),(120856,423,'Geria','815351',1,0,'2022-03-03 13:32:49','2022-03-03 13:32:49'),(120857,423,'Gokula','815352',1,0,'2022-03-03 13:32:49','2022-03-03 13:32:49'),(120858,423,'Guhiyazori','815351',1,0,'2022-03-03 13:32:49','2022-03-03 13:32:49'),(120859,423,'Gundali Pahari','815351',1,0,'2022-03-03 13:32:49','2022-03-03 13:32:49'),(120860,423,'Harirakha','815351',1,0,'2022-03-03 13:32:49','2022-03-03 13:32:49'),(120861,423,'J.Khairbani','814166',1,0,'2022-03-03 13:32:49','2022-03-03 13:32:49'),(120862,423,'Jamjori','814166',1,0,'2022-03-03 13:32:49','2022-03-03 13:32:49'),(120863,423,'Jamtara Court','815351',1,0,'2022-03-03 13:32:49','2022-03-03 13:32:49'),(120864,423,'Jamtara','815351',1,0,'2022-03-03 13:32:49','2022-03-03 13:32:49'),(120865,423,'Kairabani','814166',1,0,'2022-03-03 13:32:49','2022-03-03 13:32:49'),(120866,423,'Kalajhariya','815352',1,0,'2022-03-03 13:32:49','2022-03-03 13:32:49'),(120867,423,'Kalipahari','815355',1,0,'2022-03-03 13:32:49','2022-03-03 13:32:49'),(120868,423,'Kanki','815351',1,0,'2022-03-03 13:32:49','2022-03-03 13:32:49'),(120869,423,'Karaiya','815355',1,0,'2022-03-03 13:32:49','2022-03-03 13:32:49'),(120870,423,'Karmatar','815352',1,0,'2022-03-03 13:32:49','2022-03-03 13:32:49'),(120871,423,'Kasitar','815351',1,0,'2022-03-03 13:32:49','2022-03-03 13:32:49'),(120872,423,'Kelahi','815354',1,0,'2022-03-03 13:32:49','2022-03-03 13:32:49'),(120873,423,'Kewatjali','815354',1,0,'2022-03-03 13:32:49','2022-03-03 13:32:49'),(120874,423,'Khajuree','815359',1,0,'2022-03-03 13:32:49','2022-03-03 13:32:49'),(120875,423,'Koiri Jamua','815351',1,0,'2022-03-03 13:32:49','2022-03-03 13:32:49'),(120876,423,'Krishnapur','815355',1,0,'2022-03-03 13:32:50','2022-03-03 13:32:50'),(120877,423,'Kuldangal','815355',1,0,'2022-03-03 13:32:50','2022-03-03 13:32:50'),(120878,423,'Kundahit','815359',1,0,'2022-03-03 13:32:50','2022-03-03 13:32:50'),(120879,423,'Kurta','815352',1,0,'2022-03-03 13:32:50','2022-03-03 13:32:50'),(120880,423,'Kurwa','815352',1,0,'2022-03-03 13:32:50','2022-03-03 13:32:50'),(120881,423,'Ladhna','815351',1,0,'2022-03-03 13:32:50','2022-03-03 13:32:50'),(120882,423,'Laykapur','815359',1,0,'2022-03-03 13:32:50','2022-03-03 13:32:50'),(120883,423,'Manghladih','815351',1,0,'2022-03-03 13:32:50','2022-03-03 13:32:50'),(120884,423,'Manihari','815355',1,0,'2022-03-03 13:32:50','2022-03-03 13:32:50'),(120885,423,'Mejhia','815351',1,0,'2022-03-03 13:32:50','2022-03-03 13:32:50'),(120886,423,'Mihijam','815354',1,0,'2022-03-03 13:32:50','2022-03-03 13:32:50'),(120887,423,'Mohana Bank','815351',1,0,'2022-03-03 13:32:50','2022-03-03 13:32:50'),(120888,423,'Mohanpur','815352',1,0,'2022-03-03 13:32:50','2022-03-03 13:32:50'),(120889,423,'Nagri','815359',1,0,'2022-03-03 13:32:50','2022-03-03 13:32:50'),(120890,423,'Nala','815355',1,0,'2022-03-03 13:32:50','2022-03-03 13:32:50'),(120891,423,'Narayanpur','815352',1,0,'2022-03-03 13:32:50','2022-03-03 13:32:50'),(120892,423,'Noni','815351',1,0,'2022-03-03 13:32:50','2022-03-03 13:32:50'),(120893,423,'Pabia','815351',1,0,'2022-03-03 13:32:50','2022-03-03 13:32:50'),(120894,423,'Palajuri','815359',1,0,'2022-03-03 13:32:50','2022-03-03 13:32:50'),(120895,423,'Panjania','815351',1,0,'2022-03-03 13:32:50','2022-03-03 13:32:50'),(120896,423,'Pathrodih','815352',1,0,'2022-03-03 13:32:50','2022-03-03 13:32:50'),(120897,423,'Pattajori Kajra','815351',1,0,'2022-03-03 13:32:50','2022-03-03 13:32:50'),(120898,423,'Ranitanr','815352',1,0,'2022-03-03 13:32:51','2022-03-03 13:32:51'),(120899,423,'Sabanpur','815352',1,0,'2022-03-03 13:32:51','2022-03-03 13:32:51'),(120900,423,'Sagjoria','815355',1,0,'2022-03-03 13:32:51','2022-03-03 13:32:51'),(120901,423,'Sahardal','815354',1,0,'2022-03-03 13:32:51','2022-03-03 13:32:51'),(120902,423,'Saraskunda','815355',1,0,'2022-03-03 13:32:51','2022-03-03 13:32:51'),(120903,423,'Satki','815359',1,0,'2022-03-03 13:32:51','2022-03-03 13:32:51'),(120904,423,'Sinduri','815352',1,0,'2022-03-03 13:32:51','2022-03-03 13:32:51'),(120905,423,'Sitalpur','815352',1,0,'2022-03-03 13:32:51','2022-03-03 13:32:51'),(120906,423,'Sitamurhi','815355',1,0,'2022-03-03 13:32:51','2022-03-03 13:32:51'),(120907,423,'Sonbad','815351',1,0,'2022-03-03 13:32:51','2022-03-03 13:32:51'),(120908,423,'Sudrakshipur','815359',1,0,'2022-03-03 13:32:51','2022-03-03 13:32:51'),(120909,423,'T.K.Gram','814166',1,0,'2022-03-03 13:32:51','2022-03-03 13:32:51'),(120910,423,'Tarrah','815354',1,0,'2022-03-03 13:32:51','2022-03-03 13:32:51'),(120911,423,'Tesjuria','815355',1,0,'2022-03-03 13:32:51','2022-03-03 13:32:51'),(120912,423,'Tilabad','815359',1,0,'2022-03-03 13:32:51','2022-03-03 13:32:51'),(120913,423,'Tilaki','815351',1,0,'2022-03-03 13:32:51','2022-03-03 13:32:51'),(120914,424,'Kjijra','835235',1,0,'2022-03-03 13:32:51','2022-03-03 13:32:51'),(120915,424,'Simardih','835302',1,0,'2022-03-03 13:32:51','2022-03-03 13:32:51'),(120916,425,'Arkhango','825418',1,0,'2022-03-03 13:32:52','2022-03-03 13:32:52'),(120917,425,'Bagro','825418',1,0,'2022-03-03 13:32:52','2022-03-03 13:32:52'),(120918,425,'Baheradih','825407',1,0,'2022-03-03 13:32:52','2022-03-03 13:32:52'),(120919,425,'Bansudih','825132',1,0,'2022-03-03 13:32:52','2022-03-03 13:32:52'),(120920,425,'Barkangango','825323',1,0,'2022-03-03 13:32:52','2022-03-03 13:32:52'),(120921,425,'Bekobar','825409',1,0,'2022-03-03 13:32:52','2022-03-03 13:32:52'),(120922,425,'Berokala','825323',1,0,'2022-03-03 13:32:52','2022-03-03 13:32:52'),(120923,425,'Chalkusa','825109',1,0,'2022-03-03 13:32:52','2022-03-03 13:32:52'),(120924,425,'Chandwara','825409',1,0,'2022-03-03 13:32:52','2022-03-03 13:32:52'),(120925,425,'Chaubey','825109',1,0,'2022-03-03 13:32:52','2022-03-03 13:32:52'),(120926,425,'Chechkapi','825323',1,0,'2022-03-03 13:32:52','2022-03-03 13:32:52'),(120927,425,'Chopnadih','825318',1,0,'2022-03-03 13:32:52','2022-03-03 13:32:52'),(120928,425,'Chuglamo','825323',1,0,'2022-03-03 13:32:52','2022-03-03 13:32:52'),(120929,425,'Dandadih','825109',1,0,'2022-03-03 13:32:52','2022-03-03 13:32:52'),(120930,425,'Dasarokhurd','825318',1,0,'2022-03-03 13:32:52','2022-03-03 13:32:52'),(120931,425,'Deobour','825410',1,0,'2022-03-03 13:32:52','2022-03-03 13:32:52'),(120932,425,'Dhab','825407',1,0,'2022-03-03 13:32:52','2022-03-03 13:32:52'),(120933,425,'Dhabtham','825409',1,0,'2022-03-03 13:32:52','2022-03-03 13:32:52'),(120934,425,'Dhorakola','825407',1,0,'2022-03-03 13:32:52','2022-03-03 13:32:52'),(120935,425,'Domchanch Bazar','825418',1,0,'2022-03-03 13:32:52','2022-03-03 13:32:52'),(120936,425,'Domchanch','825407',1,0,'2022-03-03 13:32:52','2022-03-03 13:32:52'),(120937,425,'Gajhandi','825409',1,0,'2022-03-03 13:32:53','2022-03-03 13:32:53'),(120938,425,'Galwati','825418',1,0,'2022-03-03 13:32:53','2022-03-03 13:32:53'),(120939,425,'Gomobarwadih','825409',1,0,'2022-03-03 13:32:53','2022-03-03 13:32:53'),(120940,425,'Gorhand','825318',1,0,'2022-03-03 13:32:53','2022-03-03 13:32:53'),(120941,425,'Gurio','825413',1,0,'2022-03-03 13:32:53','2022-03-03 13:32:53'),(120942,425,'Hirodih','825409',1,0,'2022-03-03 13:32:53','2022-03-03 13:32:53'),(120943,425,'Inderwa','825410',1,0,'2022-03-03 13:32:53','2022-03-03 13:32:53'),(120944,425,'Jainagar (Koderma)','825109',1,0,'2022-03-03 13:32:53','2022-03-03 13:32:53'),(120945,425,'Jamu','825318',1,0,'2022-03-03 13:32:53','2022-03-03 13:32:53'),(120946,425,'Jhumari Telaiya Bazar','825409',1,0,'2022-03-03 13:32:53','2022-03-03 13:32:53'),(120947,425,'Jhumri Telaiya','825409',1,0,'2022-03-03 13:32:53','2022-03-03 13:32:53'),(120948,425,'Jogidih','825132',1,0,'2022-03-03 13:32:53','2022-03-03 13:32:53'),(120949,425,'Kalhabad','825323',1,0,'2022-03-03 13:32:53','2022-03-03 13:32:53'),(120950,425,'Kanko','825409',1,0,'2022-03-03 13:32:53','2022-03-03 13:32:53'),(120951,425,'Karma','825409',1,0,'2022-03-03 13:32:53','2022-03-03 13:32:53'),(120952,425,'Khalakthambi','825410',1,0,'2022-03-03 13:32:53','2022-03-03 13:32:53'),(120953,425,'Kheshmi','825418',1,0,'2022-03-03 13:32:53','2022-03-03 13:32:53'),(120954,425,'Khuta','825132',1,0,'2022-03-03 13:32:53','2022-03-03 13:32:53'),(120955,425,'Kodarma','825410',1,0,'2022-03-03 13:32:53','2022-03-03 13:32:53'),(120956,425,'Koderma Thermal Power Station','825421',1,0,'2022-03-03 13:32:53','2022-03-03 13:32:53'),(120957,425,'Kubri','825418',1,0,'2022-03-03 13:32:54','2022-03-03 13:32:54'),(120958,425,'Lokai','825410',1,0,'2022-03-03 13:32:54','2022-03-03 13:32:54'),(120959,425,'Mahugain','825318',1,0,'2022-03-03 13:32:54','2022-03-03 13:32:54'),(120960,425,'Makatpur','825318',1,0,'2022-03-03 13:32:54','2022-03-03 13:32:54'),(120961,425,'Manaiya','825323',1,0,'2022-03-03 13:32:54','2022-03-03 13:32:54'),(120962,425,'Marchoi','825132',1,0,'2022-03-03 13:32:54','2022-03-03 13:32:54'),(120963,425,'Markacho','825318',1,0,'2022-03-03 13:32:54','2022-03-03 13:32:54'),(120964,425,'Maskedih','825109',1,0,'2022-03-03 13:32:54','2022-03-03 13:32:54'),(120965,425,'Masmohna','825418',1,0,'2022-03-03 13:32:54','2022-03-03 13:32:54'),(120966,425,'Masnodih','825407',1,0,'2022-03-03 13:32:54','2022-03-03 13:32:54'),(120967,425,'Murukmanai','825418',1,0,'2022-03-03 13:32:54','2022-03-03 13:32:54'),(120968,425,'Naitand','825109',1,0,'2022-03-03 13:32:54','2022-03-03 13:32:54'),(120969,425,'Nandudih','825132',1,0,'2022-03-03 13:32:54','2022-03-03 13:32:54'),(120970,425,'Nawadih','825318',1,0,'2022-03-03 13:32:54','2022-03-03 13:32:54'),(120971,425,'Nawagarh Chatti','825318',1,0,'2022-03-03 13:32:54','2022-03-03 13:32:54'),(120972,425,'Nawalshahi','825418',1,0,'2022-03-03 13:32:54','2022-03-03 13:32:54'),(120973,425,'Padaria','825318',1,0,'2022-03-03 13:32:54','2022-03-03 13:32:54'),(120974,425,'Parsabad','825318',1,0,'2022-03-03 13:32:54','2022-03-03 13:32:54'),(120975,425,'Parsatari','825409',1,0,'2022-03-03 13:32:54','2022-03-03 13:32:54'),(120976,425,'Pasnaur','825132',1,0,'2022-03-03 13:32:54','2022-03-03 13:32:54'),(120977,425,'Pathaldiha','825410',1,0,'2022-03-03 13:32:55','2022-03-03 13:32:55'),(120978,425,'Phulwaria','825418',1,0,'2022-03-03 13:32:55','2022-03-03 13:32:55'),(120979,425,'Sapahi','825407',1,0,'2022-03-03 13:32:55','2022-03-03 13:32:55'),(120980,425,'Satgawan','825132',1,0,'2022-03-03 13:32:55','2022-03-03 13:32:55'),(120981,425,'Sharmatand','825109',1,0,'2022-03-03 13:32:55','2022-03-03 13:32:55'),(120982,425,'Sudan','825109',1,0,'2022-03-03 13:32:55','2022-03-03 13:32:55'),(120983,425,'Telaiya Dam','825413',1,0,'2022-03-03 13:32:55','2022-03-03 13:32:55'),(120984,426,'Aan','829203',1,0,'2022-03-03 13:32:55','2022-03-03 13:32:55'),(120985,426,'Arahans','822119',1,0,'2022-03-03 13:32:55','2022-03-03 13:32:55'),(120986,426,'Auxi','822119',1,0,'2022-03-03 13:32:55','2022-03-03 13:32:55'),(120987,426,'Balu','829206',1,0,'2022-03-03 13:32:55','2022-03-03 13:32:55'),(120988,426,'Balubhang','829202',1,0,'2022-03-03 13:32:55','2022-03-03 13:32:55'),(120989,426,'Balumath','829202',1,0,'2022-03-03 13:32:55','2022-03-03 13:32:55'),(120990,426,'Barahi','822119',1,0,'2022-03-03 13:32:55','2022-03-03 13:32:55'),(120991,426,'Baresandh','829204',1,0,'2022-03-03 13:32:55','2022-03-03 13:32:55'),(120992,426,'Bari','829203',1,0,'2022-03-03 13:32:55','2022-03-03 13:32:55'),(120993,426,'Barikhap','822112',1,0,'2022-03-03 13:32:55','2022-03-03 13:32:55'),(120994,426,'Bariyatu Jagir','829206',1,0,'2022-03-03 13:32:55','2022-03-03 13:32:55'),(120995,426,'Barwadih','822111',1,0,'2022-03-03 13:32:55','2022-03-03 13:32:55'),(120996,426,'Besra','829202',1,0,'2022-03-03 13:32:55','2022-03-03 13:32:55'),(120997,426,'Betla National Park','822111',1,0,'2022-03-03 13:32:55','2022-03-03 13:32:55'),(120998,426,'Bhaisadon','829203',1,0,'2022-03-03 13:32:55','2022-03-03 13:32:55'),(120999,426,'Chakla','829203',1,0,'2022-03-03 13:32:56','2022-03-03 13:32:56'),(121000,426,'Chandwa','829203',1,0,'2022-03-03 13:32:56','2022-03-03 13:32:56'),(121001,426,'Chatakpur','822119',1,0,'2022-03-03 13:32:56','2022-03-03 13:32:56'),(121002,426,'Chedra','829202',1,0,'2022-03-03 13:32:56','2022-03-03 13:32:56'),(121003,426,'Chhencha','822111',1,0,'2022-03-03 13:32:56','2022-03-03 13:32:56'),(121004,426,'Chhipadohar','829204',1,0,'2022-03-03 13:32:56','2022-03-03 13:32:56'),(121005,426,'Chiru','829202',1,0,'2022-03-03 13:32:56','2022-03-03 13:32:56'),(121006,426,'Chungru','829204',1,0,'2022-03-03 13:32:56','2022-03-03 13:32:56'),(121007,426,'Dahunawada','829203',1,0,'2022-03-03 13:32:56','2022-03-03 13:32:56'),(121008,426,'Damodar','829203',1,0,'2022-03-03 13:32:56','2022-03-03 13:32:56'),(121009,426,'Darha','829202',1,0,'2022-03-03 13:32:56','2022-03-03 13:32:56'),(121010,426,'Demu','829207',1,0,'2022-03-03 13:32:56','2022-03-03 13:32:56'),(121011,426,'Durup','822119',1,0,'2022-03-03 13:32:56','2022-03-03 13:32:56'),(121012,426,'Ganeshpur','829202',1,0,'2022-03-03 13:32:56','2022-03-03 13:32:56'),(121013,426,'Garhgoma','829202',1,0,'2022-03-03 13:32:56','2022-03-03 13:32:56'),(121014,426,'Garu','829204',1,0,'2022-03-03 13:32:56','2022-03-03 13:32:56'),(121015,426,'Hami','822119',1,0,'2022-03-03 13:32:56','2022-03-03 13:32:56'),(121016,426,'Herhanj','829202',1,0,'2022-03-03 13:32:56','2022-03-03 13:32:56'),(121017,426,'Holong','829202',1,0,'2022-03-03 13:32:56','2022-03-03 13:32:56'),(121018,426,'Hothpochra','829206',1,0,'2022-03-03 13:32:56','2022-03-03 13:32:56'),(121019,426,'Hutar','829203',1,0,'2022-03-03 13:32:56','2022-03-03 13:32:56'),(121020,426,'Huttar Coliewary','822111',1,0,'2022-03-03 13:32:56','2022-03-03 13:32:56'),(121021,426,'Ichak','829202',1,0,'2022-03-03 13:32:57','2022-03-03 13:32:57'),(121022,426,'Jalim','829206',1,0,'2022-03-03 13:32:57','2022-03-03 13:32:57'),(121023,426,'Jhabar','829202',1,0,'2022-03-03 13:32:57','2022-03-03 13:32:57'),(121024,426,'Kaima','829206',1,0,'2022-03-03 13:32:57','2022-03-03 13:32:57'),(121025,426,'Kamta','829203',1,0,'2022-03-03 13:32:57','2022-03-03 13:32:57'),(121026,426,'Karwal','829204',1,0,'2022-03-03 13:32:57','2022-03-03 13:32:57'),(121027,426,'Kerh','829204',1,0,'2022-03-03 13:32:57','2022-03-03 13:32:57'),(121028,426,'Kottam','829204',1,0,'2022-03-03 13:32:57','2022-03-03 13:32:57'),(121029,426,'Kumandih','829204',1,0,'2022-03-03 13:32:57','2022-03-03 13:32:57'),(121030,426,'Kura','829206',1,0,'2022-03-03 13:32:57','2022-03-03 13:32:57'),(121031,426,'Labarpur','829207',1,0,'2022-03-03 13:32:57','2022-03-03 13:32:57'),(121032,426,'Lat','829204',1,0,'2022-03-03 13:32:57','2022-03-03 13:32:57'),(121033,426,'Latehar Hsgii','829206',1,0,'2022-03-03 13:32:57','2022-03-03 13:32:57'),(121034,426,'Latehar Rsso','829207',1,0,'2022-03-03 13:32:57','2022-03-03 13:32:57'),(121035,426,'Ledhpa','829207',1,0,'2022-03-03 13:32:57','2022-03-03 13:32:57'),(121036,426,'Mahuwadand','822119',1,0,'2022-03-03 13:32:57','2022-03-03 13:32:57'),(121037,426,'Makka','829207',1,0,'2022-03-03 13:32:57','2022-03-03 13:32:57'),(121038,426,'Malhan','829203',1,0,'2022-03-03 13:32:57','2022-03-03 13:32:57'),(121039,426,'Marnagoliya','829202',1,0,'2022-03-03 13:32:57','2022-03-03 13:32:57'),(121040,426,'Mayapur','822111',1,0,'2022-03-03 13:32:57','2022-03-03 13:32:57'),(121041,426,'Mongor','829206',1,0,'2022-03-03 13:32:57','2022-03-03 13:32:57'),(121042,426,'Morwaikala','822111',1,0,'2022-03-03 13:32:58','2022-03-03 13:32:58'),(121043,426,'Mundu','829204',1,0,'2022-03-03 13:32:58','2022-03-03 13:32:58'),(121044,426,'Murpa','829202',1,0,'2022-03-03 13:32:58','2022-03-03 13:32:58'),(121045,426,'Murup','829206',1,0,'2022-03-03 13:32:58','2022-03-03 13:32:58'),(121046,426,'Nawagarh','829207',1,0,'2022-03-03 13:32:58','2022-03-03 13:32:58'),(121047,426,'Orsa','822119',1,0,'2022-03-03 13:32:58','2022-03-03 13:32:58'),(121048,426,'Pandaypura','829206',1,0,'2022-03-03 13:32:58','2022-03-03 13:32:58'),(121049,426,'Phulsu','829202',1,0,'2022-03-03 13:32:58','2022-03-03 13:32:58'),(121050,426,'Rajdanda','822119',1,0,'2022-03-03 13:32:58','2022-03-03 13:32:58'),(121051,426,'Richughuta','829207',1,0,'2022-03-03 13:32:58','2022-03-03 13:32:58'),(121052,426,'Roll','829203',1,0,'2022-03-03 13:32:58','2022-03-03 13:32:58'),(121053,426,'Saraidih Pokhari','822111',1,0,'2022-03-03 13:32:58','2022-03-03 13:32:58'),(121054,426,'Sarju','829207',1,0,'2022-03-03 13:32:58','2022-03-03 13:32:58'),(121055,426,'Sasang','829203',1,0,'2022-03-03 13:32:58','2022-03-03 13:32:58'),(121056,426,'Serak','829203',1,0,'2022-03-03 13:32:58','2022-03-03 13:32:58'),(121057,426,'Seregara','829202',1,0,'2022-03-03 13:32:58','2022-03-03 13:32:58'),(121058,426,'Serendag','829202',1,0,'2022-03-03 13:32:58','2022-03-03 13:32:58'),(121059,426,'Temki','829206',1,0,'2022-03-03 13:32:58','2022-03-03 13:32:58'),(121060,426,'Udaypur','829206',1,0,'2022-03-03 13:32:58','2022-03-03 13:32:58'),(121061,427,'Arkosa','835302',1,0,'2022-03-03 13:32:58','2022-03-03 13:32:58'),(121062,427,'Arru','835302',1,0,'2022-03-03 13:32:59','2022-03-03 13:32:59'),(121063,427,'Arya','835302',1,0,'2022-03-03 13:32:59','2022-03-03 13:32:59'),(121064,427,'Badla','835302',1,0,'2022-03-03 13:32:59','2022-03-03 13:32:59'),(121065,427,'Bagha','835302',1,0,'2022-03-03 13:32:59','2022-03-03 13:32:59'),(121066,427,'Bagru Hills','835302',1,0,'2022-03-03 13:32:59','2022-03-03 13:32:59'),(121067,427,'Bagru Mines','835302',1,0,'2022-03-03 13:32:59','2022-03-03 13:32:59'),(121068,427,'Bhatkhijri','835302',1,0,'2022-03-03 13:32:59','2022-03-03 13:32:59'),(121069,427,'Butisenha','835302',1,0,'2022-03-03 13:32:59','2022-03-03 13:32:59'),(121070,427,'Champijaria','835213',1,0,'2022-03-03 13:32:59','2022-03-03 13:32:59'),(121071,427,'Chandujima','835213',1,0,'2022-03-03 13:32:59','2022-03-03 13:32:59'),(121072,427,'Charhu','835302',1,0,'2022-03-03 13:32:59','2022-03-03 13:32:59'),(121073,427,'Chiri','835213',1,0,'2022-03-03 13:32:59','2022-03-03 13:32:59'),(121074,427,'Daru','835302',1,0,'2022-03-03 13:32:59','2022-03-03 13:32:59'),(121075,427,'Dundru','835302',1,0,'2022-03-03 13:32:59','2022-03-03 13:32:59'),(121076,427,'Gageya','835302',1,0,'2022-03-03 13:32:59','2022-03-03 13:32:59'),(121077,427,'Harmu','835302',1,0,'2022-03-03 13:32:59','2022-03-03 13:32:59'),(121078,427,'Hasapiri','835302',1,0,'2022-03-03 13:32:59','2022-03-03 13:32:59'),(121079,427,'Henjla','835213',1,0,'2022-03-03 13:32:59','2022-03-03 13:32:59'),(121080,427,'Hesway','835302',1,0,'2022-03-03 13:32:59','2022-03-03 13:32:59'),(121081,427,'Hirhi','835302',1,0,'2022-03-03 13:33:00','2022-03-03 13:33:00'),(121082,427,'Hisri','835302',1,0,'2022-03-03 13:33:00','2022-03-03 13:33:00'),(121083,427,'Irga R.S.','835302',1,0,'2022-03-03 13:33:00','2022-03-03 13:33:00'),(121084,427,'Jingi','835213',1,0,'2022-03-03 13:33:00','2022-03-03 13:33:00'),(121085,427,'Jobhipath','835218',1,0,'2022-03-03 13:33:00','2022-03-03 13:33:00'),(121086,427,'Jorisaheda','835302',1,0,'2022-03-03 13:33:00','2022-03-03 13:33:00'),(121087,427,'Juria','835302',1,0,'2022-03-03 13:33:00','2022-03-03 13:33:00'),(121088,427,'Kharta','835325',1,0,'2022-03-03 13:33:00','2022-03-03 13:33:00'),(121089,427,'Kisko','835302',1,0,'2022-03-03 13:33:00','2022-03-03 13:33:00'),(121090,427,'Koarambe','835302',1,0,'2022-03-03 13:33:00','2022-03-03 13:33:00'),(121091,427,'Kujra','835302',1,0,'2022-03-03 13:33:00','2022-03-03 13:33:00'),(121092,427,'Kurse','835213',1,0,'2022-03-03 13:33:00','2022-03-03 13:33:00'),(121093,427,'Kuru','835213',1,0,'2022-03-03 13:33:00','2022-03-03 13:33:00'),(121094,427,'Lame Baragaon','834009',1,0,'2022-03-03 13:33:00','2022-03-03 13:33:00'),(121095,427,'Landupsenha','835213',1,0,'2022-03-03 13:33:00','2022-03-03 13:33:00'),(121096,427,'Larango','835302',1,0,'2022-03-03 13:33:00','2022-03-03 13:33:00'),(121097,427,'Lohardaga Baza R','835302',1,0,'2022-03-03 13:33:00','2022-03-03 13:33:00'),(121098,427,'Lohardaga Court','835302',1,0,'2022-03-03 13:33:00','2022-03-03 13:33:00'),(121099,427,'Lohardaga','835302',1,0,'2022-03-03 13:33:00','2022-03-03 13:33:00'),(121100,427,'Lowagain','835213',1,0,'2022-03-03 13:33:00','2022-03-03 13:33:00'),(121101,427,'Masmano','835302',1,0,'2022-03-03 13:33:00','2022-03-03 13:33:00'),(121102,427,'Mungo','835302',1,0,'2022-03-03 13:33:00','2022-03-03 13:33:00'),(121103,427,'Nagni','835302',1,0,'2022-03-03 13:33:00','2022-03-03 13:33:00'),(121104,427,'Nagra','835302',1,0,'2022-03-03 13:33:01','2022-03-03 13:33:01'),(121105,427,'Narinawadih','835302',1,0,'2022-03-03 13:33:01','2022-03-03 13:33:01'),(121106,427,'Netarhat','835218',1,0,'2022-03-03 13:33:01','2022-03-03 13:33:01'),(121107,427,'Opa','835213',1,0,'2022-03-03 13:33:01','2022-03-03 13:33:01'),(121108,427,'Pandra','835213',1,0,'2022-03-03 13:33:01','2022-03-03 13:33:01'),(121109,427,'Pandri','835213',1,0,'2022-03-03 13:33:01','2022-03-03 13:33:01'),(121110,427,'Pesrar','835302',1,0,'2022-03-03 13:33:01','2022-03-03 13:33:01'),(121111,427,'Puso','835302',1,0,'2022-03-03 13:33:01','2022-03-03 13:33:01'),(121112,427,'Rampur','835302',1,0,'2022-03-03 13:33:01','2022-03-03 13:33:01'),(121113,427,'Salgi','835213',1,0,'2022-03-03 13:33:01','2022-03-03 13:33:01'),(121114,427,'Senha','835302',1,0,'2022-03-03 13:33:01','2022-03-03 13:33:01'),(121115,427,'Sinjo','835325',1,0,'2022-03-03 13:33:01','2022-03-03 13:33:01'),(121116,427,'Sithio','835302',1,0,'2022-03-03 13:33:01','2022-03-03 13:33:01'),(121117,427,'Tiril','834004',1,0,'2022-03-03 13:33:01','2022-03-03 13:33:01'),(121118,427,'Tisiya','835302',1,0,'2022-03-03 13:33:01','2022-03-03 13:33:01'),(121119,428,'Amrapara','814111',1,0,'2022-03-03 13:33:01','2022-03-03 13:33:01'),(121120,428,'Arjunpur','816104',1,0,'2022-03-03 13:33:01','2022-03-03 13:33:01'),(121121,428,'Askandha','816106',1,0,'2022-03-03 13:33:01','2022-03-03 13:33:01'),(121122,428,'Balidanga','814111',1,0,'2022-03-03 13:33:01','2022-03-03 13:33:01'),(121123,428,'Balidih','816117',1,0,'2022-03-03 13:33:01','2022-03-03 13:33:01'),(121124,428,'Bannabgram','816117',1,0,'2022-03-03 13:33:01','2022-03-03 13:33:01'),(121125,428,'Baraghaghri','816102',1,0,'2022-03-03 13:33:01','2022-03-03 13:33:01'),(121126,428,'Barasinghpur','816117',1,0,'2022-03-03 13:33:02','2022-03-03 13:33:02'),(121127,428,'Barkiari','816106',1,0,'2022-03-03 13:33:02','2022-03-03 13:33:02'),(121128,428,'Baskandri','814111',1,0,'2022-03-03 13:33:02','2022-03-03 13:33:02'),(121129,428,'Bathandanga','816106',1,0,'2022-03-03 13:33:02','2022-03-03 13:33:02'),(121130,428,'Bhawnipur','816107',1,0,'2022-03-03 13:33:02','2022-03-03 13:33:02'),(121131,428,'Bichmahal','816104',1,0,'2022-03-03 13:33:02','2022-03-03 13:33:02'),(121132,428,'Birkitty','816106',1,0,'2022-03-03 13:33:02','2022-03-03 13:33:02'),(121133,428,'Bondiga','816117',1,0,'2022-03-03 13:33:02','2022-03-03 13:33:02'),(121134,428,'Chengadanga','816107',1,0,'2022-03-03 13:33:02','2022-03-03 13:33:02'),(121135,428,'Chowkisal','816117',1,0,'2022-03-03 13:33:02','2022-03-03 13:33:02'),(121136,428,'Daldali','816107',1,0,'2022-03-03 13:33:02','2022-03-03 13:33:02'),(121137,428,'Dangapara','816104',1,0,'2022-03-03 13:33:02','2022-03-03 13:33:02'),(121138,428,'Debinagar','816106',1,0,'2022-03-03 13:33:02','2022-03-03 13:33:02'),(121139,428,'Debpur','816107',1,0,'2022-03-03 13:33:02','2022-03-03 13:33:02'),(121140,428,'Dharamkhanpara','816106',1,0,'2022-03-03 13:33:02','2022-03-03 13:33:02'),(121141,428,'Dhoadanga','816104',1,0,'2022-03-03 13:33:02','2022-03-03 13:33:02'),(121142,428,'Dulmidanga','816104',1,0,'2022-03-03 13:33:02','2022-03-03 13:33:02'),(121143,428,'Dumrchir','814111',1,0,'2022-03-03 13:33:02','2022-03-03 13:33:02'),(121144,428,'Gandhaipur','816107',1,0,'2022-03-03 13:33:02','2022-03-03 13:33:02'),(121145,428,'Ganpura','816103',1,0,'2022-03-03 13:33:02','2022-03-03 13:33:02'),(121146,428,'Hiranpur','816104',1,0,'2022-03-03 13:33:02','2022-03-03 13:33:02'),(121147,428,'Illami','816107',1,0,'2022-03-03 13:33:02','2022-03-03 13:33:02'),(121148,428,'Jhikarhati','816107',1,0,'2022-03-03 13:33:02','2022-03-03 13:33:02'),(121149,428,'Kalidaspur','816107',1,0,'2022-03-03 13:33:03','2022-03-03 13:33:03'),(121150,428,'Khagachua','816117',1,0,'2022-03-03 13:33:03','2022-03-03 13:33:03'),(121151,428,'Khagra','816106',1,0,'2022-03-03 13:33:03','2022-03-03 13:33:03'),(121152,428,'Khaksa','816117',1,0,'2022-03-03 13:33:03','2022-03-03 13:33:03'),(121153,428,'Khanpur','816106',1,0,'2022-03-03 13:33:03','2022-03-03 13:33:03'),(121154,428,'Kistonagar','816105',1,0,'2022-03-03 13:33:03','2022-03-03 13:33:03'),(121155,428,'Lagdum','816117',1,0,'2022-03-03 13:33:03','2022-03-03 13:33:03'),(121156,428,'Litipara','816104',1,0,'2022-03-03 13:33:03','2022-03-03 13:33:03'),(121157,428,'Maheshpur','814133',1,0,'2022-03-03 13:33:03','2022-03-03 13:33:03'),(121158,428,'Maheshpur Raj','816106',1,0,'2022-03-03 13:33:03','2022-03-03 13:33:03'),(121159,428,'Makdampur','816106',1,0,'2022-03-03 13:33:03','2022-03-03 13:33:03'),(121160,428,'Malpahari Koerisiding','816107',1,0,'2022-03-03 13:33:03','2022-03-03 13:33:03'),(121161,428,'Manirampur','816107',1,0,'2022-03-03 13:33:03','2022-03-03 13:33:03'),(121162,428,'Moglabandh','816117',1,0,'2022-03-03 13:33:03','2022-03-03 13:33:03'),(121163,428,'Mohanpur','816107',1,0,'2022-03-03 13:33:03','2022-03-03 13:33:03'),(121164,428,'Mohulbona','816104',1,0,'2022-03-03 13:33:03','2022-03-03 13:33:03'),(121165,428,'Nagarnabi','816107',1,0,'2022-03-03 13:33:03','2022-03-03 13:33:03'),(121166,428,'Narottempur','816107',1,0,'2022-03-03 13:33:03','2022-03-03 13:33:03'),(121167,428,'Padarkola','816104',1,0,'2022-03-03 13:33:03','2022-03-03 13:33:03'),(121168,428,'Pakur','816107',1,0,'2022-03-03 13:33:03','2022-03-03 13:33:03'),(121169,428,'Pakuria','816117',1,0,'2022-03-03 13:33:03','2022-03-03 13:33:03'),(121170,428,'Paliadaha','816117',1,0,'2022-03-03 13:33:03','2022-03-03 13:33:03'),(121171,428,'Patharghatta','814111',1,0,'2022-03-03 13:33:03','2022-03-03 13:33:03'),(121172,428,'Phuljhijhri','816117',1,0,'2022-03-03 13:33:03','2022-03-03 13:33:03'),(121173,428,'Prithinagar','816107',1,0,'2022-03-03 13:33:04','2022-03-03 13:33:04'),(121174,428,'Radhipur','816106',1,0,'2022-03-03 13:33:04','2022-03-03 13:33:04'),(121175,428,'Raj Daha','816117',1,0,'2022-03-03 13:33:04','2022-03-03 13:33:04'),(121176,428,'Rajapurkolkipara','814111',1,0,'2022-03-03 13:33:04','2022-03-03 13:33:04'),(121177,428,'Rangamission','814111',1,0,'2022-03-03 13:33:04','2022-03-03 13:33:04'),(121178,428,'Rashpur','816107',1,0,'2022-03-03 13:33:04','2022-03-03 13:33:04'),(121179,428,'Rollagram','816106',1,0,'2022-03-03 13:33:04','2022-03-03 13:33:04'),(121180,428,'Sagberia','816106',1,0,'2022-03-03 13:33:04','2022-03-03 13:33:04'),(121181,428,'Sahargram','816106',1,0,'2022-03-03 13:33:04','2022-03-03 13:33:04'),(121182,428,'Salpatra','814111',1,0,'2022-03-03 13:33:04','2022-03-03 13:33:04'),(121183,428,'Sangrampur','816107',1,0,'2022-03-03 13:33:04','2022-03-03 13:33:04'),(121184,428,'Sitapahari','816107',1,0,'2022-03-03 13:33:04','2022-03-03 13:33:04'),(121185,428,'Sitishnager','816107',1,0,'2022-03-03 13:33:04','2022-03-03 13:33:04'),(121186,428,'Surajbera','816104',1,0,'2022-03-03 13:33:04','2022-03-03 13:33:04'),(121187,428,'T.Fathepur','814111',1,0,'2022-03-03 13:33:04','2022-03-03 13:33:04'),(121188,428,'Talpahari','816104',1,0,'2022-03-03 13:33:04','2022-03-03 13:33:04'),(121189,428,'Tarapur','816106',1,0,'2022-03-03 13:33:04','2022-03-03 13:33:04'),(121190,428,'Torai','816107',1,0,'2022-03-03 13:33:04','2022-03-03 13:33:04'),(121191,429,'Adhsura','822121',1,0,'2022-03-03 13:33:04','2022-03-03 13:33:04'),(121192,429,'Alinagar','822116',1,0,'2022-03-03 13:33:05','2022-03-03 13:33:05'),(121193,429,'Ambabar','822122',1,0,'2022-03-03 13:33:05','2022-03-03 13:33:05'),(121194,429,'Ambakharis','822121',1,0,'2022-03-03 13:33:05','2022-03-03 13:33:05'),(121195,429,'Ashehar','822118',1,0,'2022-03-03 13:33:05','2022-03-03 13:33:05'),(121196,429,'Babhandih','822113',1,0,'2022-03-03 13:33:05','2022-03-03 13:33:05'),(121197,429,'Baidakala','822123',1,0,'2022-03-03 13:33:05','2022-03-03 13:33:05'),(121198,429,'Bailashpur','822115',1,0,'2022-03-03 13:33:05','2022-03-03 13:33:05'),(121199,429,'Bakoriya','822126',1,0,'2022-03-03 13:33:05','2022-03-03 13:33:05'),(121200,429,'Ballari','822122',1,0,'2022-03-03 13:33:05','2022-03-03 13:33:05'),(121201,429,'Bansdih','822118',1,0,'2022-03-03 13:33:05','2022-03-03 13:33:05'),(121202,429,'Barahi','822116',1,0,'2022-03-03 13:33:05','2022-03-03 13:33:05'),(121203,429,'Barwaiya','822126',1,0,'2022-03-03 13:33:05','2022-03-03 13:33:05'),(121204,429,'Basaura','822118',1,0,'2022-03-03 13:33:05','2022-03-03 13:33:05'),(121205,429,'Belhath','822120',1,0,'2022-03-03 13:33:05','2022-03-03 13:33:05'),(121206,429,'Belwatikar Nd','822101',1,0,'2022-03-03 13:33:05','2022-03-03 13:33:05'),(121207,429,'Bhojpur','822121',1,0,'2022-03-03 13:33:05','2022-03-03 13:33:05'),(121208,429,'Birbal','822121',1,0,'2022-03-03 13:33:05','2022-03-03 13:33:05'),(121209,429,'Bishrampur (Palamau)','822132',1,0,'2022-03-03 13:33:05','2022-03-03 13:33:05'),(121210,429,'Bishunpur','822113',1,0,'2022-03-03 13:33:05','2022-03-03 13:33:05'),(121211,429,'Champi','822118',1,0,'2022-03-03 13:33:05','2022-03-03 13:33:05'),(121212,429,'Champi Kala','822122',1,0,'2022-03-03 13:33:05','2022-03-03 13:33:05'),(121213,429,'Chando','822110',1,0,'2022-03-03 13:33:05','2022-03-03 13:33:05'),(121214,429,'Chaparwar','822113',1,0,'2022-03-03 13:33:05','2022-03-03 13:33:05'),(121215,429,'Chaukri','822115',1,0,'2022-03-03 13:33:05','2022-03-03 13:33:05'),(121216,429,'Cherai','822113',1,0,'2022-03-03 13:33:05','2022-03-03 13:33:05'),(121217,429,'Chetma','822123',1,0,'2022-03-03 13:33:06','2022-03-03 13:33:06'),(121218,429,'Chhatarpur','822113',1,0,'2022-03-03 13:33:06','2022-03-03 13:33:06'),(121219,429,'Chitbishraen','822121',1,0,'2022-03-03 13:33:06','2022-03-03 13:33:06'),(121220,429,'Chiyanki','822102',1,0,'2022-03-03 13:33:06','2022-03-03 13:33:06'),(121221,429,'Dagra','822113',1,0,'2022-03-03 13:33:06','2022-03-03 13:33:06'),(121222,429,'Dali','822113',1,0,'2022-03-03 13:33:06','2022-03-03 13:33:06'),(121223,429,'Daltonganj Bazar','822101',1,0,'2022-03-03 13:33:06','2022-03-03 13:33:06'),(121224,429,'Daltonganj Collage','822102',1,0,'2022-03-03 13:33:06','2022-03-03 13:33:06'),(121225,429,'Daltonganj H.O','822101',1,0,'2022-03-03 13:33:06','2022-03-03 13:33:06'),(121226,429,'Daltonganj Kutchary','822101',1,0,'2022-03-03 13:33:06','2022-03-03 13:33:06'),(121227,429,'Dandar Kala','822122',1,0,'2022-03-03 13:33:06','2022-03-03 13:33:06'),(121228,429,'Dangwar','822116',1,0,'2022-03-03 13:33:06','2022-03-03 13:33:06'),(121229,429,'Daruaboni','822116',1,0,'2022-03-03 13:33:06','2022-03-03 13:33:06'),(121230,429,'Dhangaon','822118',1,0,'2022-03-03 13:33:06','2022-03-03 13:33:06'),(121231,429,'Dhawadih','822126',1,0,'2022-03-03 13:33:06','2022-03-03 13:33:06'),(121232,429,'Dhub','822122',1,0,'2022-03-03 13:33:06','2022-03-03 13:33:06'),(121233,429,'Dhurki','822121',1,0,'2022-03-03 13:33:06','2022-03-03 13:33:06'),(121234,429,'Dipauwa','822123',1,0,'2022-03-03 13:33:06','2022-03-03 13:33:06'),(121235,429,'Dulhi','822123',1,0,'2022-03-03 13:33:06','2022-03-03 13:33:06'),(121236,429,'Dwarika','822122',1,0,'2022-03-03 13:33:06','2022-03-03 13:33:06'),(121237,429,'Fhulang','822118',1,0,'2022-03-03 13:33:06','2022-03-03 13:33:06'),(121238,429,'Gahar Pathara','822123',1,0,'2022-03-03 13:33:06','2022-03-03 13:33:06'),(121239,429,'Gentha','822118',1,0,'2022-03-03 13:33:06','2022-03-03 13:33:06'),(121240,429,'Goradih','822120',1,0,'2022-03-03 13:33:07','2022-03-03 13:33:07'),(121241,429,'Gulabjhari','822113',1,0,'2022-03-03 13:33:07','2022-03-03 13:33:07'),(121242,429,'Gurha','822118',1,0,'2022-03-03 13:33:07','2022-03-03 13:33:07'),(121243,429,'Gurua','822118',1,0,'2022-03-03 13:33:07','2022-03-03 13:33:07'),(121244,429,'Haidar Nagar','822115',1,0,'2022-03-03 13:33:07','2022-03-03 13:33:07'),(121245,429,'Halka','822131',1,0,'2022-03-03 13:33:07','2022-03-03 13:33:07'),(121246,429,'Halwantakain','822121',1,0,'2022-03-03 13:33:07','2022-03-03 13:33:07'),(121247,429,'Hamidganj','822101',1,0,'2022-03-03 13:33:07','2022-03-03 13:33:07'),(121248,429,'Harihar Ganj (Palamau)','822131',1,0,'2022-03-03 13:33:07','2022-03-03 13:33:07'),(121249,429,'Hariharpur','822120',1,0,'2022-03-03 13:33:07','2022-03-03 13:33:07'),(121250,429,'Harinamar','822110',1,0,'2022-03-03 13:33:07','2022-03-03 13:33:07'),(121251,429,'I. E. Sudna','822102',1,0,'2022-03-03 13:33:07','2022-03-03 13:33:07'),(121252,429,'Ichak','822123',1,0,'2022-03-03 13:33:07','2022-03-03 13:33:07'),(121253,429,'Jagajamdiha','822116',1,0,'2022-03-03 13:33:07','2022-03-03 13:33:07'),(121254,429,'Jainagra','822120',1,0,'2022-03-03 13:33:07','2022-03-03 13:33:07'),(121255,429,'Jamui','822121',1,0,'2022-03-03 13:33:07','2022-03-03 13:33:07'),(121256,429,'Japla C F','822117',1,0,'2022-03-03 13:33:07','2022-03-03 13:33:07'),(121257,429,'Japla','822116',1,0,'2022-03-03 13:33:07','2022-03-03 13:33:07'),(121258,429,'Jhabar','822126',1,0,'2022-03-03 13:33:07','2022-03-03 13:33:07'),(121259,429,'Jhargara','822116',1,0,'2022-03-03 13:33:07','2022-03-03 13:33:07'),(121260,429,'Jogiyahi Tola','822102',1,0,'2022-03-03 13:33:07','2022-03-03 13:33:07'),(121261,429,'Kabrakhurd','822115',1,0,'2022-03-03 13:33:08','2022-03-03 13:33:08'),(121262,429,'Kadaikurmi','822120',1,0,'2022-03-03 13:33:08','2022-03-03 13:33:08'),(121263,429,'Kajrat Nawadih','822116',1,0,'2022-03-03 13:33:08','2022-03-03 13:33:08'),(121264,429,'Kamgarpur','822116',1,0,'2022-03-03 13:33:08','2022-03-03 13:33:08'),(121265,429,'Kandi','822120',1,0,'2022-03-03 13:33:08','2022-03-03 13:33:08'),(121266,429,'Kankekala','822123',1,0,'2022-03-03 13:33:08','2022-03-03 13:33:08'),(121267,429,'Karimandih','822115',1,0,'2022-03-03 13:33:08','2022-03-03 13:33:08'),(121268,429,'Kasmar','822122',1,0,'2022-03-03 13:33:08','2022-03-03 13:33:08'),(121269,429,'Katharkala','822121',1,0,'2022-03-03 13:33:08','2022-03-03 13:33:08'),(121270,429,'Katual','822110',1,0,'2022-03-03 13:33:08','2022-03-03 13:33:08'),(121271,429,'Kawal','822113',1,0,'2022-03-03 13:33:08','2022-03-03 13:33:08'),(121272,429,'Kazi Pakri','822118',1,0,'2022-03-03 13:33:08','2022-03-03 13:33:08'),(121273,429,'Khairadohar','822113',1,0,'2022-03-03 13:33:08','2022-03-03 13:33:08'),(121274,429,'Khamdih','822126',1,0,'2022-03-03 13:33:08','2022-03-03 13:33:08'),(121275,429,'Kharagpur','822113',1,0,'2022-03-03 13:33:08','2022-03-03 13:33:08'),(121276,429,'Kishunpur','822123',1,0,'2022-03-03 13:33:08','2022-03-03 13:33:08'),(121277,429,'Konwai','822122',1,0,'2022-03-03 13:33:08','2022-03-03 13:33:08'),(121278,429,'Kosiara','822115',1,0,'2022-03-03 13:33:08','2022-03-03 13:33:08'),(121279,429,'Kukahi','822115',1,0,'2022-03-03 13:33:08','2022-03-03 13:33:08'),(121280,429,'Kundri','822118',1,0,'2022-03-03 13:33:09','2022-03-03 13:33:09'),(121281,429,'Kurhat Kataiya','822131',1,0,'2022-03-03 13:33:09','2022-03-03 13:33:09'),(121282,429,'Kusha','822116',1,0,'2022-03-03 13:33:09','2022-03-03 13:33:09'),(121283,429,'Kushha','822120',1,0,'2022-03-03 13:33:09','2022-03-03 13:33:09'),(121284,429,'Lamarikala','822120',1,0,'2022-03-03 13:33:09','2022-03-03 13:33:09'),(121285,429,'Lami Patra','822123',1,0,'2022-03-03 13:33:09','2022-03-03 13:33:09'),(121286,429,'Latheya','822116',1,0,'2022-03-03 13:33:09','2022-03-03 13:33:09'),(121287,429,'Lesliganj','822118',1,0,'2022-03-03 13:33:09','2022-03-03 13:33:09'),(121288,429,'Loharsi','822122',1,0,'2022-03-03 13:33:09','2022-03-03 13:33:09'),(121289,429,'Loinga','822123',1,0,'2022-03-03 13:33:09','2022-03-03 13:33:09'),(121290,429,'Mahdeiya','822121',1,0,'2022-03-03 13:33:09','2022-03-03 13:33:09'),(121291,429,'Mahuari','822116',1,0,'2022-03-03 13:33:09','2022-03-03 13:33:09'),(121292,429,'Mahugawan','822110',1,0,'2022-03-03 13:33:09','2022-03-03 13:33:09'),(121293,429,'Manatu','822123',1,0,'2022-03-03 13:33:09','2022-03-03 13:33:09'),(121294,429,'Manika','822126',1,0,'2022-03-03 13:33:09','2022-03-03 13:33:09'),(121295,429,'Manjhauli','822113',1,0,'2022-03-03 13:33:09','2022-03-03 13:33:09'),(121296,429,'Manjhiaon','822120',1,0,'2022-03-03 13:33:09','2022-03-03 13:33:09'),(121297,429,'Matlong','822126',1,0,'2022-03-03 13:33:09','2022-03-03 13:33:09'),(121298,429,'Mohammad Ganj','822120',1,0,'2022-03-03 13:33:09','2022-03-03 13:33:09'),(121299,429,'Morway','822120',1,0,'2022-03-03 13:33:09','2022-03-03 13:33:09'),(121300,429,'Munkeri','822113',1,0,'2022-03-03 13:33:10','2022-03-03 13:33:10'),(121301,429,'Nagar Utari','822121',1,0,'2022-03-03 13:33:10','2022-03-03 13:33:10'),(121302,429,'Namudag','822113',1,0,'2022-03-03 13:33:10','2022-03-03 13:33:10'),(121303,429,'Narsingh Pur','822110',1,0,'2022-03-03 13:33:10','2022-03-03 13:33:10'),(121304,429,'Naudiha Bazar','822113',1,0,'2022-03-03 13:33:10','2022-03-03 13:33:10'),(121305,429,'Naudiha Khajuri','822113',1,0,'2022-03-03 13:33:10','2022-03-03 13:33:10'),(121306,429,'Nawa Bazar','822113',1,0,'2022-03-03 13:33:10','2022-03-03 13:33:10'),(121307,429,'Nawa Jaipur','822123',1,0,'2022-03-03 13:33:10','2022-03-03 13:33:10'),(121308,429,'Nawadih (S)','822110',1,0,'2022-03-03 13:33:10','2022-03-03 13:33:10'),(121309,429,'Nawdiha','822123',1,0,'2022-03-03 13:33:10','2022-03-03 13:33:10'),(121310,429,'Pachmo','822113',1,0,'2022-03-03 13:33:10','2022-03-03 13:33:10'),(121311,429,'Paduma','822123',1,0,'2022-03-03 13:33:10','2022-03-03 13:33:10'),(121312,429,'Palhe Khurd','822123',1,0,'2022-03-03 13:33:10','2022-03-03 13:33:10'),(121313,429,'Palheya','822126',1,0,'2022-03-03 13:33:10','2022-03-03 13:33:10'),(121314,429,'Pandeypura','822123',1,0,'2022-03-03 13:33:10','2022-03-03 13:33:10'),(121315,429,'Panki (Palamau)','822122',1,0,'2022-03-03 13:33:10','2022-03-03 13:33:10'),(121316,429,'Pansa','822115',1,0,'2022-03-03 13:33:10','2022-03-03 13:33:10'),(121317,429,'Patan (Palamau)','822123',1,0,'2022-03-03 13:33:10','2022-03-03 13:33:10'),(121318,429,'Pathakpagar','822118',1,0,'2022-03-03 13:33:10','2022-03-03 13:33:10'),(121319,429,'Pipra','822113',1,0,'2022-03-03 13:33:11','2022-03-03 13:33:11'),(121320,429,'Poldih-jagdishpur','822116',1,0,'2022-03-03 13:33:11','2022-03-03 13:33:11'),(121321,429,'Polpol','822126',1,0,'2022-03-03 13:33:11','2022-03-03 13:33:11'),(121322,429,'Purabdiha','822110',1,0,'2022-03-03 13:33:11','2022-03-03 13:33:11'),(121323,429,'Raj Chainpur','822110',1,0,'2022-03-03 13:33:11','2022-03-03 13:33:11'),(121324,429,'Rajhara Rest','822110',1,0,'2022-03-03 13:33:11','2022-03-03 13:33:11'),(121325,429,'Rajhara Rest RS','822110',1,0,'2022-03-03 13:33:11','2022-03-03 13:33:11'),(121326,429,'Rajwadih','822118',1,0,'2022-03-03 13:33:11','2022-03-03 13:33:11'),(121327,429,'Ramgarh','822110',1,0,'2022-03-03 13:33:11','2022-03-03 13:33:11'),(121328,429,'Ranki Kala','822126',1,0,'2022-03-03 13:33:11','2022-03-03 13:33:11'),(121329,429,'Roll','822123',1,0,'2022-03-03 13:33:11','2022-03-03 13:33:11'),(121330,429,'Sabano','822116',1,0,'2022-03-03 13:33:11','2022-03-03 13:33:11'),(121331,429,'Sagalim','822118',1,0,'2022-03-03 13:33:11','2022-03-03 13:33:11'),(121332,429,'Sakaldipa','822113',1,0,'2022-03-03 13:33:11','2022-03-03 13:33:11'),(121333,429,'Salatua','822110',1,0,'2022-03-03 13:33:11','2022-03-03 13:33:11'),(121334,429,'Sangbar','822118',1,0,'2022-03-03 13:33:11','2022-03-03 13:33:11'),(121335,429,'Saraidih','822113',1,0,'2022-03-03 13:33:11','2022-03-03 13:33:11'),(121336,429,'Sarsot','822113',1,0,'2022-03-03 13:33:11','2022-03-03 13:33:11'),(121337,429,'Satbahini','822120',1,0,'2022-03-03 13:33:11','2022-03-03 13:33:11'),(121338,429,'Satbarwa','822126',1,0,'2022-03-03 13:33:11','2022-03-03 13:33:11'),(121339,429,'Satgawa','822131',1,0,'2022-03-03 13:33:11','2022-03-03 13:33:11'),(121340,429,'Semaura','822120',1,0,'2022-03-03 13:33:11','2022-03-03 13:33:11'),(121341,429,'Semra','822110',1,0,'2022-03-03 13:33:11','2022-03-03 13:33:11'),(121342,429,'Shahpur','822110',1,0,'2022-03-03 13:33:12','2022-03-03 13:33:12'),(121343,429,'Shirpur','822120',1,0,'2022-03-03 13:33:12','2022-03-03 13:33:12'),(121344,429,'Sibla','829202',1,0,'2022-03-03 13:33:12','2022-03-03 13:33:12'),(121345,429,'Sikki Kala','822126',1,0,'2022-03-03 13:33:12','2022-03-03 13:33:12'),(121346,429,'Sildiliya Kala','822118',1,0,'2022-03-03 13:33:12','2022-03-03 13:33:12'),(121347,429,'Singra Khurd','822102',1,0,'2022-03-03 13:33:12','2022-03-03 13:33:12'),(121348,429,'Sirma','822123',1,0,'2022-03-03 13:33:12','2022-03-03 13:33:12'),(121349,429,'Sua','822102',1,0,'2022-03-03 13:33:12','2022-03-03 13:33:12'),(121350,429,'Sundipur','822115',1,0,'2022-03-03 13:33:12','2022-03-03 13:33:12'),(121351,429,'Tal','822122',1,0,'2022-03-03 13:33:12','2022-03-03 13:33:12'),(121352,429,'Taleya Bandh','822110',1,0,'2022-03-03 13:33:12','2022-03-03 13:33:12'),(121353,429,'Tandwa','822128',1,0,'2022-03-03 13:33:12','2022-03-03 13:33:12'),(121354,429,'Tarhasi','822118',1,0,'2022-03-03 13:33:12','2022-03-03 13:33:12'),(121355,429,'Telari','822113',1,0,'2022-03-03 13:33:12','2022-03-03 13:33:12'),(121356,429,'Tetrain','822122',1,0,'2022-03-03 13:33:12','2022-03-03 13:33:12'),(121357,429,'Thakuraidabra','822118',1,0,'2022-03-03 13:33:12','2022-03-03 13:33:12'),(121358,429,'Udaigarh','822113',1,0,'2022-03-03 13:33:12','2022-03-03 13:33:12'),(121359,429,'Udaipru','822122',1,0,'2022-03-03 13:33:12','2022-03-03 13:33:12'),(121360,429,'Utari Road','822116',1,0,'2022-03-03 13:33:12','2022-03-03 13:33:12'),(121361,430,'Argada','829101',1,0,'2022-03-03 13:33:12','2022-03-03 13:33:12'),(121362,430,'Balkudra','829143',1,0,'2022-03-03 13:33:12','2022-03-03 13:33:12'),(121363,430,'Banda','829110',1,0,'2022-03-03 13:33:12','2022-03-03 13:33:12'),(121364,430,'Banji','825314',1,0,'2022-03-03 13:33:13','2022-03-03 13:33:13'),(121365,430,'Bargaon','829134',1,0,'2022-03-03 13:33:13','2022-03-03 13:33:13'),(121366,430,'Bariatu','829110',1,0,'2022-03-03 13:33:13','2022-03-03 13:33:13'),(121367,430,'Barka Chumba','829101',1,0,'2022-03-03 13:33:13','2022-03-03 13:33:13'),(121368,430,'Barkakana NTS','829103',1,0,'2022-03-03 13:33:13','2022-03-03 13:33:13'),(121369,430,'Barkakana','829102',1,0,'2022-03-03 13:33:13','2022-03-03 13:33:13'),(121370,430,'Barkipona','825101',1,0,'2022-03-03 13:33:13','2022-03-03 13:33:13'),(121371,430,'Barlanga','829110',1,0,'2022-03-03 13:33:13','2022-03-03 13:33:13'),(121372,430,'Belsagra','825330',1,0,'2022-03-03 13:33:13','2022-03-03 13:33:13'),(121373,430,'Betulkala','829110',1,0,'2022-03-03 13:33:13','2022-03-03 13:33:13'),(121374,430,'Bhadaninagar','829105',1,0,'2022-03-03 13:33:13','2022-03-03 13:33:13'),(121375,430,'Bharechnagar','829117',1,0,'2022-03-03 13:33:13','2022-03-03 13:33:13'),(121376,430,'Bhurkunda Bazar','829106',1,0,'2022-03-03 13:33:13','2022-03-03 13:33:13'),(121377,430,'Bhurkunda','829135',1,0,'2022-03-03 13:33:13','2022-03-03 13:33:13'),(121378,430,'Chaingada','829103',1,0,'2022-03-03 13:33:13','2022-03-03 13:33:13'),(121379,430,'Chainpur','825330',1,0,'2022-03-03 13:33:13','2022-03-03 13:33:13'),(121380,430,'Chainpur','829134',1,0,'2022-03-03 13:33:13','2022-03-03 13:33:13'),(121381,430,'Chari','829110',1,0,'2022-03-03 13:33:13','2022-03-03 13:33:13'),(121382,430,'Chhatar','825101',1,0,'2022-03-03 13:33:13','2022-03-03 13:33:13'),(121383,430,'Chittarpur','825101',1,0,'2022-03-03 13:33:13','2022-03-03 13:33:13'),(121384,430,'Dari','829109',1,0,'2022-03-03 13:33:13','2022-03-03 13:33:13'),(121385,430,'Deoria Bargaon','829106',1,0,'2022-03-03 13:33:13','2022-03-03 13:33:13'),(121386,430,'Digwar','829117',1,0,'2022-03-03 13:33:14','2022-03-03 13:33:14'),(121387,430,'Gandkey','825101',1,0,'2022-03-03 13:33:14','2022-03-03 13:33:14'),(121388,430,'Gegda','829143',1,0,'2022-03-03 13:33:14','2022-03-03 13:33:14'),(121389,430,'Ghatotand','825314',1,0,'2022-03-03 13:33:14','2022-03-03 13:33:14'),(121390,430,'Giddi A','829108',1,0,'2022-03-03 13:33:14','2022-03-03 13:33:14'),(121391,430,'Giddi C','829109',1,0,'2022-03-03 13:33:14','2022-03-03 13:33:14'),(121392,430,'Gola (Ramgarh)','829110',1,0,'2022-03-03 13:33:14','2022-03-03 13:33:14'),(121393,430,'Gossa','825101',1,0,'2022-03-03 13:33:14','2022-03-03 13:33:14'),(121394,430,'Hafua','829119',1,0,'2022-03-03 13:33:14','2022-03-03 13:33:14'),(121395,430,'Harhadkander','825101',1,0,'2022-03-03 13:33:14','2022-03-03 13:33:14'),(121396,430,'Hariharpur','829119',1,0,'2022-03-03 13:33:14','2022-03-03 13:33:14'),(121397,430,'Hesagarha','825316',1,0,'2022-03-03 13:33:14','2022-03-03 13:33:14'),(121398,430,'Hesapora','829110',1,0,'2022-03-03 13:33:14','2022-03-03 13:33:14'),(121399,430,'Hesla','829101',1,0,'2022-03-03 13:33:14','2022-03-03 13:33:14'),(121400,430,'Honhey','829150',1,0,'2022-03-03 13:33:14','2022-03-03 13:33:14'),(121401,430,'Ichatu','825101',1,0,'2022-03-03 13:33:14','2022-03-03 13:33:14'),(121402,430,'Jainagar','829118',1,0,'2022-03-03 13:33:14','2022-03-03 13:33:14'),(121403,430,'Jamira','825101',1,0,'2022-03-03 13:33:14','2022-03-03 13:33:14'),(121404,430,'Kaitha','825101',1,0,'2022-03-03 13:33:14','2022-03-03 13:33:14'),(121405,430,'Kander','829117',1,0,'2022-03-03 13:33:14','2022-03-03 13:33:14'),(121406,430,'Karma','829117',1,0,'2022-03-03 13:33:15','2022-03-03 13:33:15'),(121407,430,'Kedla','825325',1,0,'2022-03-03 13:33:15','2022-03-03 13:33:15'),(121408,430,'Kedlanagar','825325',1,0,'2022-03-03 13:33:15','2022-03-03 13:33:15'),(121409,430,'Korchey','825101',1,0,'2022-03-03 13:33:15','2022-03-03 13:33:15'),(121410,430,'Korrambey','829110',1,0,'2022-03-03 13:33:15','2022-03-03 13:33:15'),(121411,430,'Koto','829119',1,0,'2022-03-03 13:33:15','2022-03-03 13:33:15'),(121412,430,'Kuju','825316',1,0,'2022-03-03 13:33:15','2022-03-03 13:33:15'),(121413,430,'Kumhardaga','829110',1,0,'2022-03-03 13:33:15','2022-03-03 13:33:15'),(121414,430,'Kundrukala','825101',1,0,'2022-03-03 13:33:15','2022-03-03 13:33:15'),(121415,430,'Kurum','825101',1,0,'2022-03-03 13:33:15','2022-03-03 13:33:15'),(121416,430,'Laiyo','825325',1,0,'2022-03-03 13:33:15','2022-03-03 13:33:15'),(121417,430,'Lapanga Colliery','829105',1,0,'2022-03-03 13:33:15','2022-03-03 13:33:15'),(121418,430,'Lari','825101',1,0,'2022-03-03 13:33:15','2022-03-03 13:33:15'),(121419,430,'Maganpur','829110',1,0,'2022-03-03 13:33:15','2022-03-03 13:33:15'),(121420,430,'Mahuatand','829134',1,0,'2022-03-03 13:33:15','2022-03-03 13:33:15'),(121421,430,'Mandu','825316',1,0,'2022-03-03 13:33:15','2022-03-03 13:33:15'),(121422,430,'Marar','829117',1,0,'2022-03-03 13:33:15','2022-03-03 13:33:15'),(121423,430,'Murpa','829110',1,0,'2022-03-03 13:33:15','2022-03-03 13:33:15'),(121424,430,'Pali','829105',1,0,'2022-03-03 13:33:15','2022-03-03 13:33:15'),(121425,430,'Patratu Diesel Colony ND','829118',1,0,'2022-03-03 13:33:16','2022-03-03 13:33:16'),(121426,430,'Patratu','829118',1,0,'2022-03-03 13:33:16','2022-03-03 13:33:16'),(121427,430,'Patratu TPS','829119',1,0,'2022-03-03 13:33:16','2022-03-03 13:33:16'),(121428,430,'Potamdag','825101',1,0,'2022-03-03 13:33:16','2022-03-03 13:33:16'),(121429,430,'Prc','829130',1,0,'2022-03-03 13:33:16','2022-03-03 13:33:16'),(121430,430,'Rabodh','825330',1,0,'2022-03-03 13:33:16','2022-03-03 13:33:16'),(121431,430,'Raham','825325',1,0,'2022-03-03 13:33:16','2022-03-03 13:33:16'),(121432,430,'Ramgarh Cantt H.O','829122',1,0,'2022-03-03 13:33:16','2022-03-03 13:33:16'),(121433,430,'Ramgarh Project','829150',1,0,'2022-03-03 13:33:16','2022-03-03 13:33:16'),(121434,430,'Ramgarh (Ramgarh)','829122',1,0,'2022-03-03 13:33:16','2022-03-03 13:33:16'),(121435,430,'Religarha','829129',1,0,'2022-03-03 13:33:16','2022-03-03 13:33:16'),(121436,430,'Sandi','829150',1,0,'2022-03-03 13:33:16','2022-03-03 13:33:16'),(121437,430,'Sangrampur','829110',1,0,'2022-03-03 13:33:16','2022-03-03 13:33:16'),(121438,430,'Saram','829110',1,0,'2022-03-03 13:33:16','2022-03-03 13:33:16'),(121439,430,'Sarubera','829134',1,0,'2022-03-03 13:33:16','2022-03-03 13:33:16'),(121440,430,'Sayal','829125',1,0,'2022-03-03 13:33:16','2022-03-03 13:33:16'),(121441,430,'Sikani','829150',1,0,'2022-03-03 13:33:16','2022-03-03 13:33:16'),(121442,430,'Sirka Nd','829101',1,0,'2022-03-03 13:33:16','2022-03-03 13:33:16'),(121443,430,'Sondimra','829110',1,0,'2022-03-03 13:33:16','2022-03-03 13:33:16'),(121444,430,'Soso','825101',1,0,'2022-03-03 13:33:16','2022-03-03 13:33:16'),(121445,430,'Sosokala','829110',1,0,'2022-03-03 13:33:16','2022-03-03 13:33:16'),(121446,430,'Souda Basti','829133',1,0,'2022-03-03 13:33:16','2022-03-03 13:33:16'),(121447,430,'Sounda C','829126',1,0,'2022-03-03 13:33:17','2022-03-03 13:33:17'),(121448,430,'Sounda D','829133',1,0,'2022-03-03 13:33:17','2022-03-03 13:33:17'),(121449,430,'Src','829131',1,0,'2022-03-03 13:33:17','2022-03-03 13:33:17'),(121450,430,'Sutari','829110',1,0,'2022-03-03 13:33:17','2022-03-03 13:33:17'),(121451,430,'Tapin','825326',1,0,'2022-03-03 13:33:17','2022-03-03 13:33:17'),(121452,430,'Terpa','829118',1,0,'2022-03-03 13:33:17','2022-03-03 13:33:17'),(121453,430,'Tirla','829134',1,0,'2022-03-03 13:33:17','2022-03-03 13:33:17'),(121454,430,'Toiyar','829110',1,0,'2022-03-03 13:33:17','2022-03-03 13:33:17'),(121455,430,'Topa Coliery','825330',1,0,'2022-03-03 13:33:17','2022-03-03 13:33:17'),(121456,431,'Chama','829205',1,0,'2022-03-03 13:33:17','2022-03-03 13:33:17'),(121457,431,'Dakra Colliery','829210',1,0,'2022-03-03 13:33:17','2022-03-03 13:33:17'),(121458,431,'Diwan Nagar','829205',1,0,'2022-03-03 13:33:17','2022-03-03 13:33:17'),(121459,431,'Hindgir','829209',1,0,'2022-03-03 13:33:17','2022-03-03 13:33:17'),(121460,431,'Khalari','829205',1,0,'2022-03-03 13:33:17','2022-03-03 13:33:17'),(121461,431,'Mc. Cluskiganj','829208',1,0,'2022-03-03 13:33:17','2022-03-03 13:33:17'),(121462,431,'Nawadih','829208',1,0,'2022-03-03 13:33:17','2022-03-03 13:33:17'),(121463,431,'Nindra','829208',1,0,'2022-03-03 13:33:17','2022-03-03 13:33:17'),(121464,431,'Ray','829209',1,0,'2022-03-03 13:33:17','2022-03-03 13:33:17'),(121465,431,'Adalahatu','835204',1,0,'2022-03-03 13:33:17','2022-03-03 13:33:17'),(121466,431,'Adalhatu','834008',1,0,'2022-03-03 13:33:18','2022-03-03 13:33:18'),(121467,431,'AG Bihar','834002',1,0,'2022-03-03 13:33:18','2022-03-03 13:33:18'),(121468,431,'Ajaygarh','835102',1,0,'2022-03-03 13:33:18','2022-03-03 13:33:18'),(121469,431,'Akashi','835325',1,0,'2022-03-03 13:33:18','2022-03-03 13:33:18'),(121470,431,'Ambajharia','835204',1,0,'2022-03-03 13:33:18','2022-03-03 13:33:18'),(121471,431,'Ambapakhna','835227',1,0,'2022-03-03 13:33:18','2022-03-03 13:33:18'),(121472,431,'Amlesha','835225',1,0,'2022-03-03 13:33:18','2022-03-03 13:33:18'),(121473,431,'Angara','835103',1,0,'2022-03-03 13:33:18','2022-03-03 13:33:18'),(121474,431,'Angrabari','835210',1,0,'2022-03-03 13:33:18','2022-03-03 13:33:18'),(121475,431,'Anigara','835210',1,0,'2022-03-03 13:33:18','2022-03-03 13:33:18'),(121476,431,'Arki','835225',1,0,'2022-03-03 13:33:18','2022-03-03 13:33:18'),(121477,431,'Ashok Nagar (Ranchi)','834002',1,0,'2022-03-03 13:33:18','2022-03-03 13:33:18'),(121478,431,'Baburamdih','835225',1,0,'2022-03-03 13:33:18','2022-03-03 13:33:18'),(121479,431,'Balalong','834004',1,0,'2022-03-03 13:33:18','2022-03-03 13:33:18'),(121480,431,'Balsota','835301',1,0,'2022-03-03 13:33:18','2022-03-03 13:33:18'),(121481,431,'Bamhani','835216',1,0,'2022-03-03 13:33:18','2022-03-03 13:33:18'),(121482,431,'Banapiri','835205',1,0,'2022-03-03 13:33:18','2022-03-03 13:33:18'),(121483,431,'Bansiya','835102',1,0,'2022-03-03 13:33:18','2022-03-03 13:33:18'),(121484,431,'Banthahazam','835102',1,0,'2022-03-03 13:33:19','2022-03-03 13:33:19'),(121485,431,'Bara Ghaghra','834010',1,0,'2022-03-03 13:33:19','2022-03-03 13:33:19'),(121486,431,'Barachagru','835102',1,0,'2022-03-03 13:33:19','2022-03-03 13:33:19'),(121487,431,'Baragain','835325',1,0,'2022-03-03 13:33:19','2022-03-03 13:33:19'),(121488,431,'Baraudi','835205',1,0,'2022-03-03 13:33:19','2022-03-03 13:33:19'),(121489,431,'Barda','835227',1,0,'2022-03-03 13:33:19','2022-03-03 13:33:19'),(121490,431,'Baredih','835225',1,0,'2022-03-03 13:33:19','2022-03-03 13:33:19'),(121491,431,'Baredih','835219',1,0,'2022-03-03 13:33:19','2022-03-03 13:33:19'),(121492,431,'Baredih','835204',1,0,'2022-03-03 13:33:19','2022-03-03 13:33:19'),(121493,431,'Barenda','835102',1,0,'2022-03-03 13:33:19','2022-03-03 13:33:19'),(121494,431,'Bariatu','834009',1,0,'2022-03-03 13:33:19','2022-03-03 13:33:19'),(121495,431,'Barsa','835303',1,0,'2022-03-03 13:33:19','2022-03-03 13:33:19'),(121496,431,'Baruhatu','835204',1,0,'2022-03-03 13:33:19','2022-03-03 13:33:19'),(121497,431,'Barwadag','835102',1,0,'2022-03-03 13:33:19','2022-03-03 13:33:19'),(121498,431,'Baxidih','835219',1,0,'2022-03-03 13:33:19','2022-03-03 13:33:19'),(121499,431,'Belwadag','835210',1,0,'2022-03-03 13:33:19','2022-03-03 13:33:19'),(121500,431,'Bero','835202',1,0,'2022-03-03 13:33:19','2022-03-03 13:33:19'),(121501,431,'Beyasi','835301',1,0,'2022-03-03 13:33:19','2022-03-03 13:33:19'),(121502,431,'Bhandra','835210',1,0,'2022-03-03 13:33:19','2022-03-03 13:33:19'),(121503,431,'Bhawro','835301',1,0,'2022-03-03 13:33:20','2022-03-03 13:33:20'),(121504,431,'Bhitta','835325',1,0,'2022-03-03 13:33:20','2022-03-03 13:33:20'),(121505,431,'Bichina','835210',1,0,'2022-03-03 13:33:20','2022-03-03 13:33:20'),(121506,431,'Bijjulia','835222',1,0,'2022-03-03 13:33:20','2022-03-03 13:33:20'),(121507,431,'Bikwadag','835234',1,0,'2022-03-03 13:33:20','2022-03-03 13:33:20'),(121508,431,'Binda Bazar','835216',1,0,'2022-03-03 13:33:20','2022-03-03 13:33:20'),(121509,431,'Bindhani','835303',1,0,'2022-03-03 13:33:20','2022-03-03 13:33:20'),(121510,431,'Bingaon','835209',1,0,'2022-03-03 13:33:20','2022-03-03 13:33:20'),(121511,431,'Binja','835214',1,0,'2022-03-03 13:33:20','2022-03-03 13:33:20'),(121512,431,'Birbanki','835216',1,0,'2022-03-03 13:33:20','2022-03-03 13:33:20'),(121513,431,'Birda','835209',1,0,'2022-03-03 13:33:20','2022-03-03 13:33:20'),(121514,431,'Birhu','835210',1,0,'2022-03-03 13:33:20','2022-03-03 13:33:20'),(121515,431,'Bisa','835103',1,0,'2022-03-03 13:33:20','2022-03-03 13:33:20'),(121516,431,'Bisahakhatanga','835301',1,0,'2022-03-03 13:33:20','2022-03-03 13:33:20'),(121517,431,'Bongaibera','835103',1,0,'2022-03-03 13:33:20','2022-03-03 13:33:20'),(121518,431,'Bongaiburu','835102',1,0,'2022-03-03 13:33:20','2022-03-03 13:33:20'),(121519,431,'Boreya','834006',1,0,'2022-03-03 13:33:20','2022-03-03 13:33:20'),(121520,431,'Brambe','835205',1,0,'2022-03-03 13:33:20','2022-03-03 13:33:20'),(121521,431,'Bukru','834006',1,0,'2022-03-03 13:33:20','2022-03-03 13:33:20'),(121522,431,'Bundu','835204',1,0,'2022-03-03 13:33:20','2022-03-03 13:33:20'),(121523,431,'Burhadih','835204',1,0,'2022-03-03 13:33:20','2022-03-03 13:33:20'),(121524,431,'Burhakhukhra','835214',1,0,'2022-03-03 13:33:21','2022-03-03 13:33:21'),(121525,431,'Burju','835216',1,0,'2022-03-03 13:33:21','2022-03-03 13:33:21'),(121526,431,'Burmu','835214',1,0,'2022-03-03 13:33:21','2022-03-03 13:33:21'),(121527,431,'Buti','835217',1,0,'2022-03-03 13:33:21','2022-03-03 13:33:21'),(121528,431,'Chaingara','835214',1,0,'2022-03-03 13:33:21','2022-03-03 13:33:21'),(121529,431,'Chakla','835219',1,0,'2022-03-03 13:33:21','2022-03-03 13:33:21'),(121530,431,'Chakma','835214',1,0,'2022-03-03 13:33:21','2022-03-03 13:33:21'),(121531,431,'Champadih','835234',1,0,'2022-03-03 13:33:21','2022-03-03 13:33:21'),(121532,431,'Chandra','835219',1,0,'2022-03-03 13:33:21','2022-03-03 13:33:21'),(121533,431,'Chandwa','835217',1,0,'2022-03-03 13:33:21','2022-03-03 13:33:21'),(121534,431,'Chanho','835214',1,0,'2022-03-03 13:33:21','2022-03-03 13:33:21'),(121535,431,'Charkidumri','835301',1,0,'2022-03-03 13:33:21','2022-03-03 13:33:21'),(121536,431,'Chata','835209',1,0,'2022-03-03 13:33:21','2022-03-03 13:33:21'),(121537,431,'Childag','835103',1,0,'2022-03-03 13:33:21','2022-03-03 13:33:21'),(121538,431,'Chinarpurio','835303',1,0,'2022-03-03 13:33:21','2022-03-03 13:33:21'),(121539,431,'Chipra','835222',1,0,'2022-03-03 13:33:21','2022-03-03 13:33:21'),(121540,431,'Chirudih','835225',1,0,'2022-03-03 13:33:21','2022-03-03 13:33:21'),(121541,431,'Chittarkota','835205',1,0,'2022-03-03 13:33:21','2022-03-03 13:33:21'),(121542,431,'Chokahatu','835225',1,0,'2022-03-03 13:33:21','2022-03-03 13:33:21'),(121543,431,'Choreya','835214',1,0,'2022-03-03 13:33:21','2022-03-03 13:33:21'),(121544,431,'Chotamuri','835101',1,0,'2022-03-03 13:33:22','2022-03-03 13:33:22'),(121545,431,'Church Road','834001',1,0,'2022-03-03 13:33:22','2022-03-03 13:33:22'),(121546,431,'Chutia','834001',1,0,'2022-03-03 13:33:22','2022-03-03 13:33:22'),(121547,431,'Chutupalu','835219',1,0,'2022-03-03 13:33:22','2022-03-03 13:33:22'),(121548,431,'Dahu','835219',1,0,'2022-03-03 13:33:22','2022-03-03 13:33:22'),(121549,431,'Dahusodang','835221',1,0,'2022-03-03 13:33:22','2022-03-03 13:33:22'),(121550,431,'Danadih','835204',1,0,'2022-03-03 13:33:22','2022-03-03 13:33:22'),(121551,431,'Deogaon','835202',1,0,'2022-03-03 13:33:22','2022-03-03 13:33:22'),(121552,431,'Dhurwa','834004',1,0,'2022-03-03 13:33:22','2022-03-03 13:33:22'),(121553,431,'Dolaicha','835202',1,0,'2022-03-03 13:33:22','2022-03-03 13:33:22'),(121554,431,'Doranda H.O','834002',1,0,'2022-03-03 13:33:22','2022-03-03 13:33:22'),(121555,431,'Doreya','835225',1,0,'2022-03-03 13:33:22','2022-03-03 13:33:22'),(121556,431,'Dorma','835227',1,0,'2022-03-03 13:33:22','2022-03-03 13:33:22'),(121557,431,'Dowaru','835102',1,0,'2022-03-03 13:33:22','2022-03-03 13:33:22'),(121558,431,'Dumangdiri','835227',1,0,'2022-03-03 13:33:22','2022-03-03 13:33:22'),(121559,431,'Dundigara','835221',1,0,'2022-03-03 13:33:22','2022-03-03 13:33:22'),(121560,431,'Edrumhatu','835204',1,0,'2022-03-03 13:33:22','2022-03-03 13:33:22'),(121561,431,'Eta','835210',1,0,'2022-03-03 13:33:22','2022-03-03 13:33:22'),(121562,431,'Etta','835202',1,0,'2022-03-03 13:33:22','2022-03-03 13:33:22'),(121563,431,'Gagi','834006',1,0,'2022-03-03 13:33:22','2022-03-03 13:33:22'),(121564,431,'Gajni','835325',1,0,'2022-03-03 13:33:23','2022-03-03 13:33:23'),(121565,431,'Gargaon','835202',1,0,'2022-03-03 13:33:23','2022-03-03 13:33:23'),(121566,431,'Getalsud','835103',1,0,'2022-03-03 13:33:23','2022-03-03 13:33:23'),(121567,431,'Ghaghra','835216',1,0,'2022-03-03 13:33:23','2022-03-03 13:33:23'),(121568,431,'Ghunsuli','835210',1,0,'2022-03-03 13:33:23','2022-03-03 13:33:23'),(121569,431,'Ginjothakurgaon','835205',1,0,'2022-03-03 13:33:23','2022-03-03 13:33:23'),(121570,431,'Gitilgarh','835214',1,0,'2022-03-03 13:33:23','2022-03-03 13:33:23'),(121571,431,'Goradih','835102',1,0,'2022-03-03 13:33:23','2022-03-03 13:33:23'),(121572,431,'Govindpur Road','835234',1,0,'2022-03-03 13:33:23','2022-03-03 13:33:23'),(121573,431,'Govindpur (Ranchi)','835234',1,0,'2022-03-03 13:33:23','2022-03-03 13:33:23'),(121574,431,'Gudri','835227',1,0,'2022-03-03 13:33:23','2022-03-03 13:33:23'),(121575,431,'Gurgaon','835205',1,0,'2022-03-03 13:33:23','2022-03-03 13:33:23'),(121576,431,'Guru','835222',1,0,'2022-03-03 13:33:23','2022-03-03 13:33:23'),(121577,431,'Gutjora','835210',1,0,'2022-03-03 13:33:23','2022-03-03 13:33:23'),(121578,431,'Gutua','835303',1,0,'2022-03-03 13:33:23','2022-03-03 13:33:23'),(121579,431,'Hakadua','835210',1,0,'2022-03-03 13:33:23','2022-03-03 13:33:23'),(121580,431,'Hakedag','835101',1,0,'2022-03-03 13:33:23','2022-03-03 13:33:23'),(121581,431,'Halhu','835303',1,0,'2022-03-03 13:33:23','2022-03-03 13:33:23'),(121582,431,'Halmad','835101',1,0,'2022-03-03 13:33:23','2022-03-03 13:33:23'),(121583,431,'Hanhat','835214',1,0,'2022-03-03 13:33:23','2022-03-03 13:33:23'),(121584,431,'Haramlohar','835225',1,0,'2022-03-03 13:33:24','2022-03-03 13:33:24'),(121585,431,'Harmu Housing Colony','834002',1,0,'2022-03-03 13:33:24','2022-03-03 13:33:24'),(121586,431,'Hathudani','835221',1,0,'2022-03-03 13:33:24','2022-03-03 13:33:24'),(121587,431,'Hatia (Ranchi)','834003',1,0,'2022-03-03 13:33:24','2022-03-03 13:33:24'),(121588,431,'Hatu Ghaghra','835202',1,0,'2022-03-03 13:33:24','2022-03-03 13:33:24'),(121589,431,'HEC Adm Bldg','834004',1,0,'2022-03-03 13:33:24','2022-03-03 13:33:24'),(121590,431,'HEC Colony','834004',1,0,'2022-03-03 13:33:24','2022-03-03 13:33:24'),(121591,431,'HEC Expert Hostel','834004',1,0,'2022-03-03 13:33:24','2022-03-03 13:33:24'),(121592,431,'Hehal','834005',1,0,'2022-03-03 13:33:24','2022-03-03 13:33:24'),(121593,431,'Hendevelli','835219',1,0,'2022-03-03 13:33:24','2022-03-03 13:33:24'),(121594,431,'Henjed','835204',1,0,'2022-03-03 13:33:24','2022-03-03 13:33:24'),(121595,431,'Hesal','835103',1,0,'2022-03-03 13:33:24','2022-03-03 13:33:24'),(121596,431,'Hindpiri','834001',1,0,'2022-03-03 13:33:24','2022-03-03 13:33:24'),(121597,431,'Hindustan Steel Colony','834002',1,0,'2022-03-03 13:33:24','2022-03-03 13:33:24'),(121598,431,'Hinoo','834002',1,0,'2022-03-03 13:33:24','2022-03-03 13:33:24'),(121599,431,'Hotwar','835217',1,0,'2022-03-03 13:33:24','2022-03-03 13:33:24'),(121600,431,'Hulhundu','835221',1,0,'2022-03-03 13:33:24','2022-03-03 13:33:24'),(121601,431,'Humta','835204',1,0,'2022-03-03 13:33:24','2022-03-03 13:33:24'),(121602,431,'Hundru','834003',1,0,'2022-03-03 13:33:24','2022-03-03 13:33:24'),(121603,431,'Hundur','835217',1,0,'2022-03-03 13:33:24','2022-03-03 13:33:24'),(121604,431,'Hurdag','835221',1,0,'2022-03-03 13:33:24','2022-03-03 13:33:24'),(121605,431,'Hurhuri','835222',1,0,'2022-03-03 13:33:25','2022-03-03 13:33:25'),(121606,431,'Hussir','834006',1,0,'2022-03-03 13:33:25','2022-03-03 13:33:25'),(121607,431,'Icha','835227',1,0,'2022-03-03 13:33:25','2022-03-03 13:33:25'),(121608,431,'Ichadag','835219',1,0,'2022-03-03 13:33:25','2022-03-03 13:33:25'),(121609,431,'Ichapiri','834006',1,0,'2022-03-03 13:33:25','2022-03-03 13:33:25'),(121610,431,'Indrapuri Colony','834001',1,0,'2022-03-03 13:33:25','2022-03-03 13:33:25'),(121611,431,'Irba','835219',1,0,'2022-03-03 13:33:25','2022-03-03 13:33:25'),(121612,431,'Itki','835301',1,0,'2022-03-03 13:33:25','2022-03-03 13:33:25'),(121613,431,'Jadeya','835204',1,0,'2022-03-03 13:33:25','2022-03-03 13:33:25'),(121614,431,'Jagarnath Nagar Colony','834004',1,0,'2022-03-03 13:33:25','2022-03-03 13:33:25'),(121615,431,'Jaherbargari','835205',1,0,'2022-03-03 13:33:25','2022-03-03 13:33:25'),(121616,431,'Jaipur','835227',1,0,'2022-03-03 13:33:25','2022-03-03 13:33:25'),(121617,431,'Jaltanda','835210',1,0,'2022-03-03 13:33:25','2022-03-03 13:33:25'),(121618,431,'Jamchuajaria','834010',1,0,'2022-03-03 13:33:25','2022-03-03 13:33:25'),(121619,431,'Jamuadag','835204',1,0,'2022-03-03 13:33:25','2022-03-03 13:33:25'),(121620,431,'Janumpiri','835225',1,0,'2022-03-03 13:33:25','2022-03-03 13:33:25'),(121621,431,'Jargo','835225',1,0,'2022-03-03 13:33:25','2022-03-03 13:33:25'),(121622,431,'Jaria','835202',1,0,'2022-03-03 13:33:25','2022-03-03 13:33:25'),(121623,431,'Jariadih','835234',1,0,'2022-03-03 13:33:25','2022-03-03 13:33:25'),(121624,431,'Jate','835216',1,0,'2022-03-03 13:33:26','2022-03-03 13:33:26'),(121625,431,'Jhabri','835102',1,0,'2022-03-03 13:33:26','2022-03-03 13:33:26'),(121626,431,'Jharkhand High Court','834002',1,0,'2022-03-03 13:33:26','2022-03-03 13:33:26'),(121627,431,'Jharkhand Vidhan Sabha','834004',1,0,'2022-03-03 13:33:26','2022-03-03 13:33:26'),(121628,431,'Jilling Soreng','835225',1,0,'2022-03-03 13:33:26','2022-03-03 13:33:26'),(121629,431,'Jojohatu','835225',1,0,'2022-03-03 13:33:26','2022-03-03 13:33:26'),(121630,431,'Jon R.S.','835103',1,0,'2022-03-03 13:33:26','2022-03-03 13:33:26'),(121631,431,'Jurdag','835210',1,0,'2022-03-03 13:33:26','2022-03-03 13:33:26'),(121632,431,'Kaimbo','835214',1,0,'2022-03-03 13:33:26','2022-03-03 13:33:26'),(121633,431,'Kairo','835325',1,0,'2022-03-03 13:33:26','2022-03-03 13:33:26'),(121634,431,'Kakargarh','835214',1,0,'2022-03-03 13:33:26','2022-03-03 13:33:26'),(121635,431,'Kakaria','835202',1,0,'2022-03-03 13:33:26','2022-03-03 13:33:26'),(121636,431,'Kamre','835222',1,0,'2022-03-03 13:33:26','2022-03-03 13:33:26'),(121637,431,'Kanchi','835204',1,0,'2022-03-03 13:33:26','2022-03-03 13:33:26'),(121638,431,'Kandir','835216',1,0,'2022-03-03 13:33:26','2022-03-03 13:33:26'),(121639,431,'Kanke Road','834008',1,0,'2022-03-03 13:33:26','2022-03-03 13:33:26'),(121640,431,'Kanke','834006',1,0,'2022-03-03 13:33:26','2022-03-03 13:33:26'),(121641,431,'Kantatoli','834001',1,0,'2022-03-03 13:33:26','2022-03-03 13:33:26'),(121642,431,'Karge','835214',1,0,'2022-03-03 13:33:26','2022-03-03 13:33:26'),(121643,431,'Karkara','835214',1,0,'2022-03-03 13:33:26','2022-03-03 13:33:26'),(121644,431,'Karra','835209',1,0,'2022-03-03 13:33:27','2022-03-03 13:33:27'),(121645,431,'Kasmar','835227',1,0,'2022-03-03 13:33:27','2022-03-03 13:33:27'),(121646,431,'Katamkuli','835222',1,0,'2022-03-03 13:33:27','2022-03-03 13:33:27'),(121647,431,'Katarpa','835303',1,0,'2022-03-03 13:33:27','2022-03-03 13:33:27'),(121648,431,'Katulahna','835222',1,0,'2022-03-03 13:33:27','2022-03-03 13:33:27'),(121649,431,'Kesha','835202',1,0,'2022-03-03 13:33:27','2022-03-03 13:33:27'),(121650,431,'Khatanga','835227',1,0,'2022-03-03 13:33:27','2022-03-03 13:33:27'),(121651,431,'Khatri Khatanga','835202',1,0,'2022-03-03 13:33:27','2022-03-03 13:33:27'),(121652,431,'Khijri','834010',1,0,'2022-03-03 13:33:27','2022-03-03 13:33:27'),(121653,431,'Khukhra','835202',1,0,'2022-03-03 13:33:27','2022-03-03 13:33:27'),(121654,431,'Khunti','835210',1,0,'2022-03-03 13:33:27','2022-03-03 13:33:27'),(121655,431,'Koaselda','835210',1,0,'2022-03-03 13:33:27','2022-03-03 13:33:27'),(121656,431,'Kochasindri','835225',1,0,'2022-03-03 13:33:27','2022-03-03 13:33:27'),(121657,431,'Koisera','835234',1,0,'2022-03-03 13:33:27','2022-03-03 13:33:27'),(121658,431,'Kokar','834001',1,0,'2022-03-03 13:33:27','2022-03-03 13:33:27'),(121659,431,'Kokdoro','834006',1,0,'2022-03-03 13:33:27','2022-03-03 13:33:27'),(121660,431,'Kone','835209',1,0,'2022-03-03 13:33:27','2022-03-03 13:33:27'),(121661,431,'Korambe','835205',1,0,'2022-03-03 13:33:27','2022-03-03 13:33:27'),(121662,431,'Kota','835225',1,0,'2022-03-03 13:33:27','2022-03-03 13:33:27'),(121663,431,'Krishnapuri S O','834011',1,0,'2022-03-03 13:33:28','2022-03-03 13:33:28'),(121664,431,'Kuchu','835101',1,0,'2022-03-03 13:33:28','2022-03-03 13:33:28'),(121665,431,'Kuchu','835219',1,0,'2022-03-03 13:33:28','2022-03-03 13:33:28'),(121666,431,'Kuli','835303',1,0,'2022-03-03 13:33:28','2022-03-03 13:33:28'),(121667,431,'Kumharia','834006',1,0,'2022-03-03 13:33:28','2022-03-03 13:33:28'),(121668,431,'Kurse','835209',1,0,'2022-03-03 13:33:28','2022-03-03 13:33:28'),(121669,431,'Lagam','835101',1,0,'2022-03-03 13:33:28','2022-03-03 13:33:28'),(121670,431,'Lali','834010',1,0,'2022-03-03 13:33:28','2022-03-03 13:33:28'),(121671,431,'Lalpur (Ranchi)','834001',1,0,'2022-03-03 13:33:28','2022-03-03 13:33:28'),(121672,431,'Landup','835210',1,0,'2022-03-03 13:33:28','2022-03-03 13:33:28'),(121673,431,'Landupdih','835225',1,0,'2022-03-03 13:33:28','2022-03-03 13:33:28'),(121674,431,'Lapa','835234',1,0,'2022-03-03 13:33:28','2022-03-03 13:33:28'),(121675,431,'Lapung','835234',1,0,'2022-03-03 13:33:28','2022-03-03 13:33:28'),(121676,431,'Larta','835209',1,0,'2022-03-03 13:33:28','2022-03-03 13:33:28'),(121677,431,'Late','835234',1,0,'2022-03-03 13:33:28','2022-03-03 13:33:28'),(121678,431,'Lodhma','834004',1,0,'2022-03-03 13:33:28','2022-03-03 13:33:28'),(121679,431,'Lota','835102',1,0,'2022-03-03 13:33:28','2022-03-03 13:33:28'),(121680,431,'Lowahatu','835204',1,0,'2022-03-03 13:33:28','2022-03-03 13:33:28'),(121681,431,'Lower Bazar','834001',1,0,'2022-03-03 13:33:28','2022-03-03 13:33:28'),(121682,431,'Lungtu','835225',1,0,'2022-03-03 13:33:28','2022-03-03 13:33:28'),(121683,431,'Maheshpur','835103',1,0,'2022-03-03 13:33:29','2022-03-03 13:33:29'),(121684,431,'Mahilong','835103',1,0,'2022-03-03 13:33:29','2022-03-03 13:33:29'),(121685,431,'Mahuajari','835214',1,0,'2022-03-03 13:33:29','2022-03-03 13:33:29'),(121686,431,'Mahuary','835325',1,0,'2022-03-03 13:33:29','2022-03-03 13:33:29'),(121687,431,'Mahugaon','835234',1,0,'2022-03-03 13:33:29','2022-03-03 13:33:29'),(121688,431,'Makka','835214',1,0,'2022-03-03 13:33:29','2022-03-03 13:33:29'),(121689,431,'Malsering','835222',1,0,'2022-03-03 13:33:29','2022-03-03 13:33:29'),(121690,431,'Mandar (Ranchi)','835214',1,0,'2022-03-03 13:33:29','2022-03-03 13:33:29'),(121691,431,'Mandru','835301',1,0,'2022-03-03 13:33:29','2022-03-03 13:33:29'),(121692,431,'Mankidih','835225',1,0,'2022-03-03 13:33:29','2022-03-03 13:33:29'),(121693,431,'Maranghada','835210',1,0,'2022-03-03 13:33:29','2022-03-03 13:33:29'),(121694,431,'Marcha','835227',1,0,'2022-03-03 13:33:29','2022-03-03 13:33:29'),(121695,431,'Marwa','835222',1,0,'2022-03-03 13:33:29','2022-03-03 13:33:29'),(121696,431,'Medha','835103',1,0,'2022-03-03 13:33:29','2022-03-03 13:33:29'),(121697,431,'Mesra','835215',1,0,'2022-03-03 13:33:29','2022-03-03 13:33:29'),(121698,431,'Morabadi','834008',1,0,'2022-03-03 13:33:29','2022-03-03 13:33:29'),(121699,431,'Murhu','835216',1,0,'2022-03-03 13:33:29','2022-03-03 13:33:29'),(121700,431,'Murkuni','835205',1,0,'2022-03-03 13:33:29','2022-03-03 13:33:29'),(121701,431,'Murma','835205',1,0,'2022-03-03 13:33:29','2022-03-03 13:33:29'),(121702,431,'Murma Nayasarai','835303',1,0,'2022-03-03 13:33:30','2022-03-03 13:33:30'),(121703,431,'Murto','835301',1,0,'2022-03-03 13:33:30','2022-03-03 13:33:30'),(121704,431,'Murupiri','835214',1,0,'2022-03-03 13:33:30','2022-03-03 13:33:30'),(121705,431,'Nagjua','835325',1,0,'2022-03-03 13:33:30','2022-03-03 13:33:30'),(121706,431,'Nagra','835205',1,0,'2022-03-03 13:33:30','2022-03-03 13:33:30'),(121707,431,'Namkum','834010',1,0,'2022-03-03 13:33:30','2022-03-03 13:33:30'),(121708,431,'Narauli','835325',1,0,'2022-03-03 13:33:30','2022-03-03 13:33:30'),(121709,431,'Narkopi','835301',1,0,'2022-03-03 13:33:30','2022-03-03 13:33:30'),(121710,431,'Nawagarh','835103',1,0,'2022-03-03 13:33:30','2022-03-03 13:33:30'),(121711,431,'Ncdc','834001',1,0,'2022-03-03 13:33:30','2022-03-03 13:33:30'),(121712,431,'Nehalu','835202',1,0,'2022-03-03 13:33:30','2022-03-03 13:33:30'),(121713,431,'Neori Vikas Vidyalaya','835217',1,0,'2022-03-03 13:33:30','2022-03-03 13:33:30'),(121714,431,'New Area Marabadi','834008',1,0,'2022-03-03 13:33:30','2022-03-03 13:33:30'),(121715,431,'Nibaranpur','834002',1,0,'2022-03-03 13:33:30','2022-03-03 13:33:30'),(121716,431,'Noadih','835204',1,0,'2022-03-03 13:33:30','2022-03-03 13:33:30'),(121717,431,'Norhi','835225',1,0,'2022-03-03 13:33:30','2022-03-03 13:33:30'),(121718,431,'Old Commissioner Compound','834001',1,0,'2022-03-03 13:33:30','2022-03-03 13:33:30'),(121719,431,'Ormanjhi','835219',1,0,'2022-03-03 13:33:30','2022-03-03 13:33:30'),(121720,431,'Paharkandaria','835202',1,0,'2022-03-03 13:33:30','2022-03-03 13:33:30'),(121721,431,'Pali','835205',1,0,'2022-03-03 13:33:30','2022-03-03 13:33:30'),(121722,431,'Palu','835219',1,0,'2022-03-03 13:33:30','2022-03-03 13:33:30'),(121723,431,'Pancha','835219',1,0,'2022-03-03 13:33:30','2022-03-03 13:33:30'),(121724,431,'Pandadih','835102',1,0,'2022-03-03 13:33:30','2022-03-03 13:33:30'),(121725,431,'Parasi','835225',1,0,'2022-03-03 13:33:31','2022-03-03 13:33:31'),(121726,431,'Patpur','835227',1,0,'2022-03-03 13:33:31','2022-03-03 13:33:31'),(121727,431,'Patrachauli','835303',1,0,'2022-03-03 13:33:31','2022-03-03 13:33:31'),(121728,431,'Patrahatu','835102',1,0,'2022-03-03 13:33:31','2022-03-03 13:33:31'),(121729,431,'Patratu','835214',1,0,'2022-03-03 13:33:31','2022-03-03 13:33:31'),(121730,431,'Phudi','835210',1,0,'2022-03-03 13:33:31','2022-03-03 13:33:31'),(121731,431,'Piska','835102',1,0,'2022-03-03 13:33:31','2022-03-03 13:33:31'),(121732,431,'Piskanagri','835303',1,0,'2022-03-03 13:33:31','2022-03-03 13:33:31'),(121733,431,'Pithoria','834006',1,0,'2022-03-03 13:33:31','2022-03-03 13:33:31'),(121734,431,'Pogra','835102',1,0,'2022-03-03 13:33:31','2022-03-03 13:33:31'),(121735,431,'Pokta','835234',1,0,'2022-03-03 13:33:31','2022-03-03 13:33:31'),(121736,431,'Pundag','834004',1,0,'2022-03-03 13:33:31','2022-03-03 13:33:31'),(121737,431,'Pundidiri','835225',1,0,'2022-03-03 13:33:31','2022-03-03 13:33:31'),(121738,431,'Purio','835205',1,0,'2022-03-03 13:33:31','2022-03-03 13:33:31'),(121739,431,'Raghunathpur','835214',1,0,'2022-03-03 13:33:31','2022-03-03 13:33:31'),(121740,431,'Rahe','835204',1,0,'2022-03-03 13:33:31','2022-03-03 13:33:31'),(121741,431,'Railway Colony Hatia','834003',1,0,'2022-03-03 13:33:31','2022-03-03 13:33:31'),(121742,431,'Raisimla','835227',1,0,'2022-03-03 13:33:31','2022-03-03 13:33:31'),(121743,431,'Rajadera','835103',1,0,'2022-03-03 13:33:32','2022-03-03 13:33:32'),(121744,431,'Rajaulatu','834010',1,0,'2022-03-03 13:33:32','2022-03-03 13:33:32'),(121745,431,'Ramkrishna Sanatorium','835221',1,0,'2022-03-03 13:33:32','2022-03-03 13:33:32'),(121746,431,'Ranchi Agriculture College','834006',1,0,'2022-03-03 13:33:32','2022-03-03 13:33:32'),(121747,431,'Ranchi Airport','834002',1,0,'2022-03-03 13:33:32','2022-03-03 13:33:32'),(121748,431,'Ranchi Court','834001',1,0,'2022-03-03 13:33:32','2022-03-03 13:33:32'),(121749,431,'Ranchi G.P.O.','834001',1,0,'2022-03-03 13:33:32','2022-03-03 13:33:32'),(121750,431,'Ranchi Medical College Campus','834009',1,0,'2022-03-03 13:33:32','2022-03-03 13:33:32'),(121751,431,'Ranchi Medical College','834009',1,0,'2022-03-03 13:33:32','2022-03-03 13:33:32'),(121752,431,'Ranchi University','834008',1,0,'2022-03-03 13:33:32','2022-03-03 13:33:32'),(121753,431,'Ranchi Veterinary College','834006',1,0,'2022-03-03 13:33:32','2022-03-03 13:33:32'),(121754,431,'Rania','835227',1,0,'2022-03-03 13:33:32','2022-03-03 13:33:32'),(121755,431,'Ranikhatanga','835301',1,0,'2022-03-03 13:33:32','2022-03-03 13:33:32'),(121756,431,'Rargaon','835225',1,0,'2022-03-03 13:33:32','2022-03-03 13:33:32'),(121757,431,'Ratu','835222',1,0,'2022-03-03 13:33:32','2022-03-03 13:33:32'),(121758,431,'Reladih','835204',1,0,'2022-03-03 13:33:32','2022-03-03 13:33:32'),(121759,431,'Rendwa','835234',1,0,'2022-03-03 13:33:32','2022-03-03 13:33:32'),(121760,431,'Rugari','835225',1,0,'2022-03-03 13:33:32','2022-03-03 13:33:32'),(121761,431,'Sadma','835219',1,0,'2022-03-03 13:33:32','2022-03-03 13:33:32'),(121762,431,'Saiko','835210',1,0,'2022-03-03 13:33:32','2022-03-03 13:33:32'),(121763,431,'Sakra','835301',1,0,'2022-03-03 13:33:32','2022-03-03 13:33:32'),(121764,431,'Salgadih','835225',1,0,'2022-03-03 13:33:33','2022-03-03 13:33:33'),(121765,431,'Sangor','835209',1,0,'2022-03-03 13:33:33','2022-03-03 13:33:33'),(121766,431,'Sanri','835219',1,0,'2022-03-03 13:33:33','2022-03-03 13:33:33'),(121767,431,'Saparam','835303',1,0,'2022-03-03 13:33:33','2022-03-03 13:33:33'),(121768,431,'Saparom','835210',1,0,'2022-03-03 13:33:33','2022-03-03 13:33:33'),(121769,431,'Sarbo','835227',1,0,'2022-03-03 13:33:33','2022-03-03 13:33:33'),(121770,431,'Sarjomdih','835225',1,0,'2022-03-03 13:33:33','2022-03-03 13:33:33'),(121771,431,'Sarle','835214',1,0,'2022-03-03 13:33:33','2022-03-03 13:33:33'),(121772,431,'Sarwada','835216',1,0,'2022-03-03 13:33:33','2022-03-03 13:33:33'),(121773,431,'Satakanadu','834006',1,0,'2022-03-03 13:33:33','2022-03-03 13:33:33'),(121774,431,'Sataki','835204',1,0,'2022-03-03 13:33:33','2022-03-03 13:33:33'),(121775,431,'Satellite Colony','834004',1,0,'2022-03-03 13:33:33','2022-03-03 13:33:33'),(121776,431,'Semra','835301',1,0,'2022-03-03 13:33:33','2022-03-03 13:33:33'),(121777,431,'Sero','835325',1,0,'2022-03-03 13:33:33','2022-03-03 13:33:33'),(121778,431,'Sikidiri','835219',1,0,'2022-03-03 13:33:33','2022-03-03 13:33:33'),(121779,431,'Silagain','835301',1,0,'2022-03-03 13:33:33','2022-03-03 13:33:33'),(121780,431,'Silli','835102',1,0,'2022-03-03 13:33:33','2022-03-03 13:33:33'),(121781,431,'Simlia','835222',1,0,'2022-03-03 13:33:33','2022-03-03 13:33:33'),(121782,431,'Sirum','835210',1,0,'2022-03-03 13:33:33','2022-03-03 13:33:33'),(121783,431,'Sithio','834004',1,0,'2022-03-03 13:33:33','2022-03-03 13:33:33'),(121784,431,'Soba','835205',1,0,'2022-03-03 13:33:33','2022-03-03 13:33:33'),(121785,431,'Sode','835227',1,0,'2022-03-03 13:33:33','2022-03-03 13:33:33'),(121786,431,'Sonahatu','835204',1,0,'2022-03-03 13:33:34','2022-03-03 13:33:34'),(121787,431,'Sosai','835214',1,0,'2022-03-03 13:33:34','2022-03-03 13:33:34'),(121788,431,'Subarnrekha Hydai Project','835219',1,0,'2022-03-03 13:33:34','2022-03-03 13:33:34'),(121789,431,'Sugnu','835103',1,0,'2022-03-03 13:33:34','2022-03-03 13:33:34'),(121790,431,'Sukurhutu','834006',1,0,'2022-03-03 13:33:34','2022-03-03 13:33:34'),(121791,431,'Sundari','835227',1,0,'2022-03-03 13:33:34','2022-03-03 13:33:34'),(121792,431,'Susaimuru','835214',1,0,'2022-03-03 13:33:34','2022-03-03 13:33:34'),(121793,431,'T.T.Mankidih','835102',1,0,'2022-03-03 13:33:34','2022-03-03 13:33:34'),(121794,431,'Taimara','835204',1,0,'2022-03-03 13:33:34','2022-03-03 13:33:34'),(121795,431,'Tala','835214',1,0,'2022-03-03 13:33:34','2022-03-03 13:33:34'),(121796,431,'Tamar','835225',1,0,'2022-03-03 13:33:34','2022-03-03 13:33:34'),(121797,431,'Tangar','835214',1,0,'2022-03-03 13:33:34','2022-03-03 13:33:34'),(121798,431,'Tangarbasli','835301',1,0,'2022-03-03 13:33:34','2022-03-03 13:33:34'),(121799,431,'Tarasiladon','835221',1,0,'2022-03-03 13:33:34','2022-03-03 13:33:34'),(121800,431,'Tati','835102',1,0,'2022-03-03 13:33:34','2022-03-03 13:33:34'),(121801,431,'Tati','835325',1,0,'2022-03-03 13:33:34','2022-03-03 13:33:34'),(121802,431,'Tatisilway','835103',1,0,'2022-03-03 13:33:34','2022-03-03 13:33:34'),(121803,431,'Tetebandrampur','835101',1,0,'2022-03-03 13:33:34','2022-03-03 13:33:34'),(121804,431,'Tetla','835102',1,0,'2022-03-03 13:33:34','2022-03-03 13:33:34'),(121805,431,'Tetri','834010',1,0,'2022-03-03 13:33:35','2022-03-03 13:33:35'),(121806,431,'Tikratoli','835301',1,0,'2022-03-03 13:33:35','2022-03-03 13:33:35'),(121807,431,'Tilmi','835209',1,0,'2022-03-03 13:33:35','2022-03-03 13:33:35'),(121808,431,'Tirla','835227',1,0,'2022-03-03 13:33:35','2022-03-03 13:33:35'),(121809,431,'Torpa','835227',1,0,'2022-03-03 13:33:35','2022-03-03 13:33:35'),(121810,431,'Tuko','835202',1,0,'2022-03-03 13:33:35','2022-03-03 13:33:35'),(121811,431,'Turmuli','835205',1,0,'2022-03-03 13:33:35','2022-03-03 13:33:35'),(121812,431,'Tutikinawadih','835102',1,0,'2022-03-03 13:33:35','2022-03-03 13:33:35'),(121813,431,'Ulidih','835225',1,0,'2022-03-03 13:33:35','2022-03-03 13:33:35'),(121814,431,'Ulilohar','835225',1,0,'2022-03-03 13:33:35','2022-03-03 13:33:35'),(121815,431,'Umedanda','835214',1,0,'2022-03-03 13:33:35','2022-03-03 13:33:35'),(121816,431,'Urugutu','835222',1,0,'2022-03-03 13:33:35','2022-03-03 13:33:35'),(121817,431,'Vijaygiri','835225',1,0,'2022-03-03 13:33:35','2022-03-03 13:33:35'),(121818,432,'Aglio','816101',1,0,'2022-03-03 13:33:35','2022-03-03 13:33:35'),(121819,432,'Aprol','816120',1,0,'2022-03-03 13:33:35','2022-03-03 13:33:35'),(121820,432,'Atapur','816101',1,0,'2022-03-03 13:33:35','2022-03-03 13:33:35'),(121821,432,'B.B. Mangladih','816110',1,0,'2022-03-03 13:33:35','2022-03-03 13:33:35'),(121822,432,'B.Kadma','816102',1,0,'2022-03-03 13:33:35','2022-03-03 13:33:35'),(121823,432,'Bakudih','816101',1,0,'2022-03-03 13:33:35','2022-03-03 13:33:35'),(121824,432,'Balapokhar','816109',1,0,'2022-03-03 13:33:35','2022-03-03 13:33:35'),(121825,432,'Baluagairah','816109',1,0,'2022-03-03 13:33:35','2022-03-03 13:33:35'),(121826,432,'Banjhi','816109',1,0,'2022-03-03 13:33:35','2022-03-03 13:33:35'),(121827,432,'Banskola','816110',1,0,'2022-03-03 13:33:36','2022-03-03 13:33:36'),(121828,432,'Bara Durgapur','816116',1,0,'2022-03-03 13:33:36','2022-03-03 13:33:36'),(121829,432,'Bara Madansahi','816109',1,0,'2022-03-03 13:33:36','2022-03-03 13:33:36'),(121830,432,'Baradighi','816101',1,0,'2022-03-03 13:33:36','2022-03-03 13:33:36'),(121831,432,'Barajirwabari','816109',1,0,'2022-03-03 13:33:36','2022-03-03 13:33:36'),(121832,432,'Barhait','816102',1,0,'2022-03-03 13:33:36','2022-03-03 13:33:36'),(121833,432,'Barharwa (Sahibganj)','816101',1,0,'2022-03-03 13:33:36','2022-03-03 13:33:36'),(121834,432,'Barmasia','816102',1,0,'2022-03-03 13:33:36','2022-03-03 13:33:36'),(121835,432,'Bartalla','816110',1,0,'2022-03-03 13:33:36','2022-03-03 13:33:36'),(121836,432,'Begamganj','816101',1,0,'2022-03-03 13:33:36','2022-03-03 13:33:36'),(121837,432,'Bhognadih','816102',1,0,'2022-03-03 13:33:36','2022-03-03 13:33:36'),(121838,432,'Binodpur','816105',1,0,'2022-03-03 13:33:36','2022-03-03 13:33:36'),(121839,432,'Bishanpur','816110',1,0,'2022-03-03 13:33:36','2022-03-03 13:33:36'),(121840,432,'Borbandh','816102',1,0,'2022-03-03 13:33:36','2022-03-03 13:33:36'),(121841,432,'Borio','816120',1,0,'2022-03-03 13:33:36','2022-03-03 13:33:36'),(121842,432,'Brindaban','816116',1,0,'2022-03-03 13:33:36','2022-03-03 13:33:36'),(121843,432,'Chanda','813208',1,0,'2022-03-03 13:33:36','2022-03-03 13:33:36'),(121844,432,'Chandsaher','816101',1,0,'2022-03-03 13:33:36','2022-03-03 13:33:36'),(121845,432,'Chotabangama','816120',1,0,'2022-03-03 13:33:36','2022-03-03 13:33:36'),(121846,432,'Choukidhab','816108',1,0,'2022-03-03 13:33:36','2022-03-03 13:33:36'),(121847,432,'Gaganpahari','816105',1,0,'2022-03-03 13:33:36','2022-03-03 13:33:36'),(121848,432,'Ganeshpur','816101',1,0,'2022-03-03 13:33:37','2022-03-03 13:33:37'),(121849,432,'Ganga Prasad Diara','816109',1,0,'2022-03-03 13:33:37','2022-03-03 13:33:37'),(121850,432,'Ghatiari','816110',1,0,'2022-03-03 13:33:37','2022-03-03 13:33:37'),(121851,432,'Goalkhor','816101',1,0,'2022-03-03 13:33:37','2022-03-03 13:33:37'),(121852,432,'Hariprasad Diara','816109',1,0,'2022-03-03 13:33:37','2022-03-03 13:33:37'),(121853,432,'Hatigarah','816120',1,0,'2022-03-03 13:33:37','2022-03-03 13:33:37'),(121854,432,'Hazipur Bari Kodarjana','816109',1,0,'2022-03-03 13:33:37','2022-03-03 13:33:37'),(121855,432,'Ishlampur','816101',1,0,'2022-03-03 13:33:37','2022-03-03 13:33:37'),(121856,432,'J.Kumarjori','816102',1,0,'2022-03-03 13:33:37','2022-03-03 13:33:37'),(121857,432,'Jambad','816105',1,0,'2022-03-03 13:33:37','2022-03-03 13:33:37'),(121858,432,'Jamnager','816108',1,0,'2022-03-03 13:33:37','2022-03-03 13:33:37'),(121859,432,'Jampur','816101',1,0,'2022-03-03 13:33:37','2022-03-03 13:33:37'),(121860,432,'Jonka','816116',1,0,'2022-03-03 13:33:37','2022-03-03 13:33:37'),(121861,432,'Kajigoun','816108',1,0,'2022-03-03 13:33:37','2022-03-03 13:33:37'),(121862,432,'Kalyanchak','816116',1,0,'2022-03-03 13:33:37','2022-03-03 13:33:37'),(121863,432,'Kankjol','816101',1,0,'2022-03-03 13:33:37','2022-03-03 13:33:37'),(121864,432,'Karanpura','816129',1,0,'2022-03-03 13:33:37','2022-03-03 13:33:37'),(121865,432,'Kassim Bazar','816108',1,0,'2022-03-03 13:33:37','2022-03-03 13:33:37'),(121866,432,'Kathalbari','816101',1,0,'2022-03-03 13:33:37','2022-03-03 13:33:37'),(121867,432,'Kelabari','816101',1,0,'2022-03-03 13:33:38','2022-03-03 13:33:38'),(121868,432,'Kotalpokhar','816105',1,0,'2022-03-03 13:33:38','2022-03-03 13:33:38'),(121869,432,'Kusmaha','816102',1,0,'2022-03-03 13:33:38','2022-03-03 13:33:38'),(121870,432,'Labri','816102',1,0,'2022-03-03 13:33:38','2022-03-03 13:33:38'),(121871,432,'Lakhipur','816110',1,0,'2022-03-03 13:33:38','2022-03-03 13:33:38'),(121872,432,'Mahadeo Ganj','816109',1,0,'2022-03-03 13:33:38','2022-03-03 13:33:38'),(121873,432,'Maharajpur','816109',1,0,'2022-03-03 13:33:38','2022-03-03 13:33:38'),(121874,432,'Mahasinghpur','816108',1,0,'2022-03-03 13:33:38','2022-03-03 13:33:38'),(121875,432,'Mandro','813208',1,0,'2022-03-03 13:33:38','2022-03-03 13:33:38'),(121876,432,'Mangalhat English','816129',1,0,'2022-03-03 13:33:38','2022-03-03 13:33:38'),(121877,432,'Masna','816101',1,0,'2022-03-03 13:33:38','2022-03-03 13:33:38'),(121878,432,'Mayur Kola','816105',1,0,'2022-03-03 13:33:38','2022-03-03 13:33:38'),(121879,432,'Mirzachowki','813208',1,0,'2022-03-03 13:33:38','2022-03-03 13:33:38'),(121880,432,'Motipahari','816120',1,0,'2022-03-03 13:33:38','2022-03-03 13:33:38'),(121881,432,'Narayanpur','816108',1,0,'2022-03-03 13:33:38','2022-03-03 13:33:38'),(121882,432,'Narayanpur East Diara','816108',1,0,'2022-03-03 13:33:38','2022-03-03 13:33:38'),(121883,432,'P.K.Bazar','816102',1,0,'2022-03-03 13:33:38','2022-03-03 13:33:38'),(121884,432,'P.K.Bazar','816108',1,0,'2022-03-03 13:33:38','2022-03-03 13:33:38'),(121885,432,'Palasbona','816101',1,0,'2022-03-03 13:33:38','2022-03-03 13:33:38'),(121886,432,'Palasgachi','816108',1,0,'2022-03-03 13:33:38','2022-03-03 13:33:38'),(121887,432,'Patharia','816105',1,0,'2022-03-03 13:33:38','2022-03-03 13:33:38'),(121888,432,'Pathna','816110',1,0,'2022-03-03 13:33:38','2022-03-03 13:33:38'),(121889,432,'Phudkipur','816108',1,0,'2022-03-03 13:33:39','2022-03-03 13:33:39'),(121890,432,'Phulbanga','816102',1,0,'2022-03-03 13:33:39','2022-03-03 13:33:39'),(121891,432,'Piyarpur','816108',1,0,'2022-03-03 13:33:39','2022-03-03 13:33:39'),(121892,432,'Radhanager','816101',1,0,'2022-03-03 13:33:39','2022-03-03 13:33:39'),(121893,432,'Rajmahal','816108',1,0,'2022-03-03 13:33:39','2022-03-03 13:33:39'),(121894,432,'Rampur','816109',1,0,'2022-03-03 13:33:39','2022-03-03 13:33:39'),(121895,432,'Ranigram','816101',1,0,'2022-03-03 13:33:39','2022-03-03 13:33:39'),(121896,432,'Reshore','816101',1,0,'2022-03-03 13:33:39','2022-03-03 13:33:39'),(121897,432,'Rohra','816102',1,0,'2022-03-03 13:33:39','2022-03-03 13:33:39'),(121898,432,'Sahibganj College','816109',1,0,'2022-03-03 13:33:39','2022-03-03 13:33:39'),(121899,432,'Sahibganj Court','816109',1,0,'2022-03-03 13:33:39','2022-03-03 13:33:39'),(121900,432,'Sahibganj','816109',1,0,'2022-03-03 13:33:39','2022-03-03 13:33:39'),(121901,432,'Sakrigali Ghat','816115',1,0,'2022-03-03 13:33:39','2022-03-03 13:33:39'),(121902,432,'Sarkanda','816129',1,0,'2022-03-03 13:33:39','2022-03-03 13:33:39'),(121903,432,'Sridhardira','816101',1,0,'2022-03-03 13:33:39','2022-03-03 13:33:39'),(121904,432,'Srikund','816101',1,0,'2022-03-03 13:33:39','2022-03-03 13:33:39'),(121905,432,'Sripurbazar','813208',1,0,'2022-03-03 13:33:39','2022-03-03 13:33:39'),(121906,432,'Talbaria','816102',1,0,'2022-03-03 13:33:39','2022-03-03 13:33:39'),(121907,432,'Taljhari','816129',1,0,'2022-03-03 13:33:39','2022-03-03 13:33:39'),(121908,432,'Telo','816120',1,0,'2022-03-03 13:33:39','2022-03-03 13:33:39'),(121909,432,'Tinpahar RS','816116',1,0,'2022-03-03 13:33:40','2022-03-03 13:33:40'),(121910,432,'Udhwa','816108',1,0,'2022-03-03 13:33:40','2022-03-03 13:33:40'),(121911,433,'Adardih','832401',1,0,'2022-03-03 13:33:40','2022-03-03 13:33:40'),(121912,433,'Adityapur Industrial Area','832109',1,0,'2022-03-03 13:33:40','2022-03-03 13:33:40'),(121913,433,'Amda','833101',1,0,'2022-03-03 13:33:40','2022-03-03 13:33:40'),(121914,433,'Arwan','833216',1,0,'2022-03-03 13:33:40','2022-03-03 13:33:40'),(121915,433,'B.Kutung','831002',1,0,'2022-03-03 13:33:40','2022-03-03 13:33:40'),(121916,433,'Bamni','832401',1,0,'2022-03-03 13:33:40','2022-03-03 13:33:40'),(121917,433,'Bamni Chaliyama','832401',1,0,'2022-03-03 13:33:40','2022-03-03 13:33:40'),(121918,433,'Bandu','832404',1,0,'2022-03-03 13:33:40','2022-03-03 13:33:40'),(121919,433,'Bansa','832404',1,0,'2022-03-03 13:33:40','2022-03-03 13:33:40'),(121920,433,'Barachiru','833204',1,0,'2022-03-03 13:33:40','2022-03-03 13:33:40'),(121921,433,'Baramari','832108',1,0,'2022-03-03 13:33:40','2022-03-03 13:33:40'),(121922,433,'Bareda','832401',1,0,'2022-03-03 13:33:40','2022-03-03 13:33:40'),(121923,433,'Bhadudih','832401',1,0,'2022-03-03 13:33:40','2022-03-03 13:33:40'),(121924,433,'Burudih','833220',1,0,'2022-03-03 13:33:40','2022-03-03 13:33:40'),(121925,433,'Burudih','832108',1,0,'2022-03-03 13:33:40','2022-03-03 13:33:40'),(121926,433,'Buruhatu','832404',1,0,'2022-03-03 13:33:40','2022-03-03 13:33:40'),(121927,433,'Chainpur','832401',1,0,'2022-03-03 13:33:40','2022-03-03 13:33:40'),(121928,433,'Chakradharpur','833102',1,0,'2022-03-03 13:33:40','2022-03-03 13:33:40'),(121929,433,'Chandil','832401',1,0,'2022-03-03 13:33:41','2022-03-03 13:33:41'),(121930,433,'Chelgu','832401',1,0,'2022-03-03 13:33:41','2022-03-03 13:33:41'),(121931,433,'Chhota Bandi','833216',1,0,'2022-03-03 13:33:41','2022-03-03 13:33:41'),(121932,433,'Chipri','832404',1,0,'2022-03-03 13:33:41','2022-03-03 13:33:41'),(121933,433,'Choura','832403',1,0,'2022-03-03 13:33:41','2022-03-03 13:33:41'),(121934,433,'Chowka','832404',1,0,'2022-03-03 13:33:41','2022-03-03 13:33:41'),(121935,433,'Dalbhanga','833216',1,0,'2022-03-03 13:33:41','2022-03-03 13:33:41'),(121936,433,'Deoltand','832404',1,0,'2022-03-03 13:33:41','2022-03-03 13:33:41'),(121937,433,'Dholadih','833204',1,0,'2022-03-03 13:33:41','2022-03-03 13:33:41'),(121938,433,'Dudra','831002',1,0,'2022-03-03 13:33:41','2022-03-03 13:33:41'),(121939,433,'Dugdha','832108',1,0,'2022-03-03 13:33:41','2022-03-03 13:33:41'),(121940,433,'Dugni','833220',1,0,'2022-03-03 13:33:41','2022-03-03 13:33:41'),(121941,433,'Dulmi','832403',1,0,'2022-03-03 13:33:41','2022-03-03 13:33:41'),(121942,433,'Gamharia','832108',1,0,'2022-03-03 13:33:41','2022-03-03 13:33:41'),(121943,433,'Gaurangkocha','832404',1,0,'2022-03-03 13:33:41','2022-03-03 13:33:41'),(121944,433,'Ghatdulmi','832404',1,0,'2022-03-03 13:33:41','2022-03-03 13:33:41'),(121945,433,'Ghoraling','832401',1,0,'2022-03-03 13:33:41','2022-03-03 13:33:41'),(121946,433,'Gopidih','833101',1,0,'2022-03-03 13:33:41','2022-03-03 13:33:41'),(121947,433,'Govindpur','831002',1,0,'2022-03-03 13:33:42','2022-03-03 13:33:42'),(121948,433,'Hesakocha','832404',1,0,'2022-03-03 13:33:42','2022-03-03 13:33:42'),(121949,433,'Hudu','832402',1,0,'2022-03-03 13:33:42','2022-03-03 13:33:42'),(121950,433,'Ichadih','832403',1,0,'2022-03-03 13:33:42','2022-03-03 13:33:42'),(121951,433,'Ichagarh','832404',1,0,'2022-03-03 13:33:42','2022-03-03 13:33:42'),(121952,433,'Itagarh','831002',1,0,'2022-03-03 13:33:42','2022-03-03 13:33:42'),(121953,433,'Janum','832403',1,0,'2022-03-03 13:33:42','2022-03-03 13:33:42'),(121954,433,'Jarakel','833105',1,0,'2022-03-03 13:33:42','2022-03-03 13:33:42'),(121955,433,'Jhabri','832404',1,0,'2022-03-03 13:33:42','2022-03-03 13:33:42'),(121956,433,'Jhalak','833204',1,0,'2022-03-03 13:33:42','2022-03-03 13:33:42'),(121957,433,'Jojokurma','833102',1,0,'2022-03-03 13:33:42','2022-03-03 13:33:42'),(121958,433,'Jugilong','832401',1,0,'2022-03-03 13:33:42','2022-03-03 13:33:42'),(121959,433,'Jumal','831002',1,0,'2022-03-03 13:33:42','2022-03-03 13:33:42'),(121960,433,'Kanderbera','832401',1,0,'2022-03-03 13:33:42','2022-03-03 13:33:42'),(121961,433,'Kandra (Seraikela-kharsawan)','832402',1,0,'2022-03-03 13:33:42','2022-03-03 13:33:42'),(121962,433,'Kapali','831012',1,0,'2022-03-03 13:33:42','2022-03-03 13:33:42'),(121963,433,'Kashidih','832404',1,0,'2022-03-03 13:33:42','2022-03-03 13:33:42'),(121964,433,'Kendamundi','832107',1,0,'2022-03-03 13:33:42','2022-03-03 13:33:42'),(121965,433,'Kendua','833220',1,0,'2022-03-03 13:33:42','2022-03-03 13:33:42'),(121966,433,'Kharsawangarh','833216',1,0,'2022-03-03 13:33:42','2022-03-03 13:33:42'),(121967,433,'Khunti','832404',1,0,'2022-03-03 13:33:42','2022-03-03 13:33:42'),(121968,433,'Kolabira','833220',1,0,'2022-03-03 13:33:43','2022-03-03 13:33:43'),(121969,433,'Kuchai','833216',1,0,'2022-03-03 13:33:43','2022-03-03 13:33:43'),(121970,433,'Kukru','832403',1,0,'2022-03-03 13:33:43','2022-03-03 13:33:43'),(121971,433,'Landupada','833102',1,0,'2022-03-03 13:33:43','2022-03-03 13:33:43'),(121972,433,'Lepatand','832404',1,0,'2022-03-03 13:33:43','2022-03-03 13:33:43'),(121973,433,'Madhupur','832401',1,0,'2022-03-03 13:33:43','2022-03-03 13:33:43'),(121974,433,'Madhupur','833220',1,0,'2022-03-03 13:33:43','2022-03-03 13:33:43'),(121975,433,'Moisara','832404',1,0,'2022-03-03 13:33:43','2022-03-03 13:33:43'),(121976,433,'Munda Tand','833220',1,0,'2022-03-03 13:33:43','2022-03-03 13:33:43'),(121977,433,'Muru','832403',1,0,'2022-03-03 13:33:43','2022-03-03 13:33:43'),(121978,433,'Nadisai','832404',1,0,'2022-03-03 13:33:43','2022-03-03 13:33:43'),(121979,433,'Narayanpur','833220',1,0,'2022-03-03 13:33:43','2022-03-03 13:33:43'),(121980,433,'Nengtasai','833220',1,0,'2022-03-03 13:33:43','2022-03-03 13:33:43'),(121981,433,'Nimdih','832401',1,0,'2022-03-03 13:33:43','2022-03-03 13:33:43'),(121982,433,'Nowagarh','832108',1,0,'2022-03-03 13:33:43','2022-03-03 13:33:43'),(121983,433,'Padampur','833101',1,0,'2022-03-03 13:33:43','2022-03-03 13:33:43'),(121984,433,'Pathermara','833219',1,0,'2022-03-03 13:33:43','2022-03-03 13:33:43'),(121985,433,'Pokharia','832112',1,0,'2022-03-03 13:33:43','2022-03-03 13:33:43'),(121986,433,'R.I.T','831014',1,0,'2022-03-03 13:33:43','2022-03-03 13:33:43'),(121987,433,'Raidih','833220',1,0,'2022-03-03 13:33:43','2022-03-03 13:33:43'),(121988,433,'Rajnagar','831002',1,0,'2022-03-03 13:33:43','2022-03-03 13:33:43'),(121989,433,'Rola','831002',1,0,'2022-03-03 13:33:44','2022-03-03 13:33:44'),(121990,433,'Seraikella Block','833219',1,0,'2022-03-03 13:33:44','2022-03-03 13:33:44'),(121991,433,'Seraikella','833219',1,0,'2022-03-03 13:33:44','2022-03-03 13:33:44'),(121992,433,'Shirum','832403',1,0,'2022-03-03 13:33:44','2022-03-03 13:33:44'),(121993,433,'Sidhdih','832404',1,0,'2022-03-03 13:33:44','2022-03-03 13:33:44'),(121994,433,'Simagunda','832401',1,0,'2022-03-03 13:33:44','2022-03-03 13:33:44'),(121995,433,'Sindhukopa','833220',1,0,'2022-03-03 13:33:44','2022-03-03 13:33:44'),(121996,433,'Sindri','833220',1,0,'2022-03-03 13:33:44','2022-03-03 13:33:44'),(121997,433,'Sini','833220',1,0,'2022-03-03 13:33:44','2022-03-03 13:33:44'),(121998,433,'Situ','832403',1,0,'2022-03-03 13:33:44','2022-03-03 13:33:44'),(121999,433,'Soro','832403',1,0,'2022-03-03 13:33:44','2022-03-03 13:33:44'),(122000,433,'Suksari','832401',1,0,'2022-03-03 13:33:44','2022-03-03 13:33:44'),(122001,433,'Tablapur','833219',1,0,'2022-03-03 13:33:44','2022-03-03 13:33:44'),(122002,433,'Tamari','832404',1,0,'2022-03-03 13:33:44','2022-03-03 13:33:44'),(122003,433,'Tankocha','832401',1,0,'2022-03-03 13:33:44','2022-03-03 13:33:44'),(122004,433,'Tikar','832404',1,0,'2022-03-03 13:33:44','2022-03-03 13:33:44'),(122005,433,'Tilla','832401',1,0,'2022-03-03 13:33:44','2022-03-03 13:33:44'),(122006,433,'Tiruldih','832403',1,0,'2022-03-03 13:33:44','2022-03-03 13:33:44'),(122007,433,'Tumung','832107',1,0,'2022-03-03 13:33:44','2022-03-03 13:33:44'),(122008,433,'Tuta','832404',1,0,'2022-03-03 13:33:44','2022-03-03 13:33:44'),(122009,433,'Urmal','832404',1,0,'2022-03-03 13:33:44','2022-03-03 13:33:44'),(122010,434,'Agharma','835211',1,0,'2022-03-03 13:33:44','2022-03-03 13:33:44'),(122011,434,'B.  Biura','835212',1,0,'2022-03-03 13:33:45','2022-03-03 13:33:45'),(122012,434,'Bagdega','835223',1,0,'2022-03-03 13:33:45','2022-03-03 13:33:45'),(122013,434,'Baliajor','835226',1,0,'2022-03-03 13:33:45','2022-03-03 13:33:45'),(122014,434,'Banki','835201',1,0,'2022-03-03 13:33:45','2022-03-03 13:33:45'),(122015,434,'Bano','835201',1,0,'2022-03-03 13:33:45','2022-03-03 13:33:45'),(122016,434,'Bansjor','835226',1,0,'2022-03-03 13:33:45','2022-03-03 13:33:45'),(122017,434,'Baribringa','835211',1,0,'2022-03-03 13:33:45','2022-03-03 13:33:45'),(122018,434,'Barsloya','835211',1,0,'2022-03-03 13:33:45','2022-03-03 13:33:45'),(122019,434,'Barwadih','835211',1,0,'2022-03-03 13:33:45','2022-03-03 13:33:45'),(122020,434,'Basain','835223',1,0,'2022-03-03 13:33:45','2022-03-03 13:33:45'),(122021,434,'Behrinbasa','835226',1,0,'2022-03-03 13:33:45','2022-03-03 13:33:45'),(122022,434,'Bhelwadih','835228',1,0,'2022-03-03 13:33:45','2022-03-03 13:33:45'),(122023,434,'Biru','835228',1,0,'2022-03-03 13:33:45','2022-03-03 13:33:45'),(122024,434,'Bolba','835226',1,0,'2022-03-03 13:33:45','2022-03-03 13:33:45'),(122025,434,'Bombalkera','835223',1,0,'2022-03-03 13:33:45','2022-03-03 13:33:45'),(122026,434,'Bongera','835211',1,0,'2022-03-03 13:33:45','2022-03-03 13:33:45'),(122027,434,'Boroseta','835211',1,0,'2022-03-03 13:33:45','2022-03-03 13:33:45'),(122028,434,'Ch. Munda','835212',1,0,'2022-03-03 13:33:45','2022-03-03 13:33:45'),(122029,434,'Deobahar','835235',1,0,'2022-03-03 13:33:45','2022-03-03 13:33:45'),(122030,434,'Dhori','835212',1,0,'2022-03-03 13:33:46','2022-03-03 13:33:46'),(122031,434,'Gariajore','835212',1,0,'2022-03-03 13:33:46','2022-03-03 13:33:46'),(122032,434,'Garja','835235',1,0,'2022-03-03 13:33:46','2022-03-03 13:33:46'),(122033,434,'Gatadih','835212',1,0,'2022-03-03 13:33:46','2022-03-03 13:33:46'),(122034,434,'Genmer','835201',1,0,'2022-03-03 13:33:46','2022-03-03 13:33:46'),(122035,434,'Gerda','835201',1,0,'2022-03-03 13:33:46','2022-03-03 13:33:46'),(122036,434,'Gorarjora','835223',1,0,'2022-03-03 13:33:46','2022-03-03 13:33:46'),(122037,434,'Gotra','835235',1,0,'2022-03-03 13:33:46','2022-03-03 13:33:46'),(122038,434,'Gutbahar','835223',1,0,'2022-03-03 13:33:46','2022-03-03 13:33:46'),(122039,434,'Hatinghore','835201',1,0,'2022-03-03 13:33:46','2022-03-03 13:33:46'),(122040,434,'Hethma','835223',1,0,'2022-03-03 13:33:46','2022-03-03 13:33:46'),(122041,434,'Hurda','835201',1,0,'2022-03-03 13:33:46','2022-03-03 13:33:46'),(122042,434,'Itam','835211',1,0,'2022-03-03 13:33:46','2022-03-03 13:33:46'),(122043,434,'Jaldega','835211',1,0,'2022-03-03 13:33:46','2022-03-03 13:33:46'),(122044,434,'Jampani','835226',1,0,'2022-03-03 13:33:46','2022-03-03 13:33:46'),(122045,434,'Jitutoli','835201',1,0,'2022-03-03 13:33:46','2022-03-03 13:33:46'),(122046,434,'Jokbahar','835223',1,0,'2022-03-03 13:33:46','2022-03-03 13:33:46'),(122047,434,'Karramunda','835226',1,0,'2022-03-03 13:33:46','2022-03-03 13:33:46'),(122048,434,'Keonddih','835228',1,0,'2022-03-03 13:33:46','2022-03-03 13:33:46'),(122049,434,'Kereya','835226',1,0,'2022-03-03 13:33:47','2022-03-03 13:33:47'),(122050,434,'Kersai','835223',1,0,'2022-03-03 13:33:47','2022-03-03 13:33:47'),(122051,434,'Keshalpur','835223',1,0,'2022-03-03 13:33:47','2022-03-03 13:33:47'),(122052,434,'Khinda','835212',1,0,'2022-03-03 13:33:47','2022-03-03 13:33:47'),(122053,434,'Khuntitoli','835223',1,0,'2022-03-03 13:33:47','2022-03-03 13:33:47'),(122054,434,'Kinkel','835223',1,0,'2022-03-03 13:33:47','2022-03-03 13:33:47'),(122055,434,'Kochedega','835223',1,0,'2022-03-03 13:33:47','2022-03-03 13:33:47'),(122056,434,'Kodapani','835226',1,0,'2022-03-03 13:33:47','2022-03-03 13:33:47'),(122057,434,'Kolebira','835211',1,0,'2022-03-03 13:33:47','2022-03-03 13:33:47'),(122058,434,'Konaskela','835223',1,0,'2022-03-03 13:33:47','2022-03-03 13:33:47'),(122059,434,'Konbegi','835235',1,0,'2022-03-03 13:33:47','2022-03-03 13:33:47'),(122060,434,'Konjoba','835212',1,0,'2022-03-03 13:33:47','2022-03-03 13:33:47'),(122061,434,'Konmerla','835211',1,0,'2022-03-03 13:33:47','2022-03-03 13:33:47'),(122062,434,'Konpala','835235',1,0,'2022-03-03 13:33:47','2022-03-03 13:33:47'),(122063,434,'Kulburu','835201',1,0,'2022-03-03 13:33:47','2022-03-03 13:33:47'),(122064,434,'Kulukera','835223',1,0,'2022-03-03 13:33:47','2022-03-03 13:33:47'),(122065,434,'Kundurmunda','835226',1,0,'2022-03-03 13:33:47','2022-03-03 13:33:47'),(122066,434,'Kurdeg','835212',1,0,'2022-03-03 13:33:47','2022-03-03 13:33:47'),(122067,434,'Kurkura','835201',1,0,'2022-03-03 13:33:47','2022-03-03 13:33:47'),(122068,434,'Kurmia','835226',1,0,'2022-03-03 13:33:47','2022-03-03 13:33:47'),(122069,434,'Kuruskela','835228',1,0,'2022-03-03 13:33:48','2022-03-03 13:33:48'),(122070,434,'Kutmakochar','835212',1,0,'2022-03-03 13:33:48','2022-03-03 13:33:48'),(122071,434,'Kutunjia','835201',1,0,'2022-03-03 13:33:48','2022-03-03 13:33:48'),(122072,434,'Lachragarh','835201',1,0,'2022-03-03 13:33:48','2022-03-03 13:33:48'),(122073,434,'Lamgarh','835201',1,0,'2022-03-03 13:33:48','2022-03-03 13:33:48'),(122074,434,'Lasia','835211',1,0,'2022-03-03 13:33:48','2022-03-03 13:33:48'),(122075,434,'Latakel','835201',1,0,'2022-03-03 13:33:48','2022-03-03 13:33:48'),(122076,434,'Lathakhaman','835235',1,0,'2022-03-03 13:33:48','2022-03-03 13:33:48'),(122077,434,'Lombai','835211',1,0,'2022-03-03 13:33:48','2022-03-03 13:33:48'),(122078,434,'Malsera','835223',1,0,'2022-03-03 13:33:48','2022-03-03 13:33:48'),(122079,434,'Meromdega','835223',1,0,'2022-03-03 13:33:48','2022-03-03 13:33:48'),(122080,434,'Orga','835201',1,0,'2022-03-03 13:33:48','2022-03-03 13:33:48'),(122081,434,'Pakardanr','835228',1,0,'2022-03-03 13:33:48','2022-03-03 13:33:48'),(122082,434,'Phulwartangar','835228',1,0,'2022-03-03 13:33:48','2022-03-03 13:33:48'),(122083,434,'Piriyapoch','835226',1,0,'2022-03-03 13:33:48','2022-03-03 13:33:48'),(122084,434,'Pithra','835223',1,0,'2022-03-03 13:33:48','2022-03-03 13:33:48'),(122085,434,'Raikera','835201',1,0,'2022-03-03 13:33:48','2022-03-03 13:33:48'),(122086,434,'Rampur','835211',1,0,'2022-03-03 13:33:48','2022-03-03 13:33:48'),(122087,434,'Rengari','835235',1,0,'2022-03-03 13:33:49','2022-03-03 13:33:49'),(122088,434,'Sahpur','835211',1,0,'2022-03-03 13:33:49','2022-03-03 13:33:49'),(122089,434,'Samsera','835226',1,0,'2022-03-03 13:33:49','2022-03-03 13:33:49'),(122090,434,'Sewai','835223',1,0,'2022-03-03 13:33:49','2022-03-03 13:33:49'),(122091,434,'Sikariatand','835228',1,0,'2022-03-03 13:33:49','2022-03-03 13:33:49'),(122092,434,'Sikorda','835201',1,0,'2022-03-03 13:33:49','2022-03-03 13:33:49'),(122093,434,'Simdega','835223',1,0,'2022-03-03 13:33:49','2022-03-03 13:33:49'),(122094,434,'Sukhajharia','835211',1,0,'2022-03-03 13:33:49','2022-03-03 13:33:49'),(122095,434,'Taisera','835212',1,0,'2022-03-03 13:33:49','2022-03-03 13:33:49'),(122096,434,'Taisera','835223',1,0,'2022-03-03 13:33:49','2022-03-03 13:33:49'),(122097,434,'Tamra','835228',1,0,'2022-03-03 13:33:49','2022-03-03 13:33:49'),(122098,434,'Taraboga','835226',1,0,'2022-03-03 13:33:49','2022-03-03 13:33:49'),(122099,434,'Targa','835226',1,0,'2022-03-03 13:33:49','2022-03-03 13:33:49'),(122100,434,'Thethaitangar','835226',1,0,'2022-03-03 13:33:49','2022-03-03 13:33:49'),(122101,434,'Tumdega','835223',1,0,'2022-03-03 13:33:49','2022-03-03 13:33:49'),(122102,434,'Tupudega Pandripani','835223',1,0,'2022-03-03 13:33:49','2022-03-03 13:33:49'),(122103,434,'Tutikel','835211',1,0,'2022-03-03 13:33:49','2022-03-03 13:33:49'),(122104,434,'Urta','835226',1,0,'2022-03-03 13:33:49','2022-03-03 13:33:49'),(122105,435,'Bandgaon','835216',1,0,'2022-03-03 13:33:49','2022-03-03 13:33:49'),(122106,435,'Hesadih','835216',1,0,'2022-03-03 13:33:49','2022-03-03 13:33:49'),(122107,435,'Kochang','835216',1,0,'2022-03-03 13:33:50','2022-03-03 13:33:50'),(122108,435,'Leyangi','835216',1,0,'2022-03-03 13:33:50','2022-03-03 13:33:50'),(122109,435,'Mahil','835216',1,0,'2022-03-03 13:33:50','2022-03-03 13:33:50'),(122110,435,'Pronger','835216',1,0,'2022-03-03 13:33:50','2022-03-03 13:33:50'),(122111,435,'Selda','835216',1,0,'2022-03-03 13:33:50','2022-03-03 13:33:50'),(122112,435,'Swania','835216',1,0,'2022-03-03 13:33:50','2022-03-03 13:33:50'),(122113,435,'Tebo','835216',1,0,'2022-03-03 13:33:50','2022-03-03 13:33:50'),(122114,435,'Adityapur','831013',1,0,'2022-03-03 13:33:50','2022-03-03 13:33:50'),(122115,435,'Andhari','833214',1,0,'2022-03-03 13:33:50','2022-03-03 13:33:50'),(122116,435,'Asantalia','833105',1,0,'2022-03-03 13:33:50','2022-03-03 13:33:50'),(122117,435,'Bagabilla','833204',1,0,'2022-03-03 13:33:50','2022-03-03 13:33:50'),(122118,435,'Baikera','833104',1,0,'2022-03-03 13:33:50','2022-03-03 13:33:50'),(122119,435,'Baipee','833102',1,0,'2022-03-03 13:33:50','2022-03-03 13:33:50'),(122120,435,'Balandia','833214',1,0,'2022-03-03 13:33:50','2022-03-03 13:33:50'),(122121,435,'Balibandh','833214',1,0,'2022-03-03 13:33:50','2022-03-03 13:33:50'),(122122,435,'Barabamboo','833102',1,0,'2022-03-03 13:33:50','2022-03-03 13:33:50'),(122123,435,'Baraiburu','833221',1,0,'2022-03-03 13:33:50','2022-03-03 13:33:50'),(122124,435,'Barajamda','833221',1,0,'2022-03-03 13:33:50','2022-03-03 13:33:50'),(122125,435,'Barajamni','833214',1,0,'2022-03-03 13:33:50','2022-03-03 13:33:50'),(122126,435,'Barajhinkpani','833215',1,0,'2022-03-03 13:33:50','2022-03-03 13:33:50'),(122127,435,'Baralagia','833204',1,0,'2022-03-03 13:33:51','2022-03-03 13:33:51'),(122128,435,'Baralagra','833204',1,0,'2022-03-03 13:33:51','2022-03-03 13:33:51'),(122129,435,'Bari','833103',1,0,'2022-03-03 13:33:51','2022-03-03 13:33:51'),(122130,435,'Bari Bazar','833201',1,0,'2022-03-03 13:33:51','2022-03-03 13:33:51'),(122131,435,'Barkella','833204',1,0,'2022-03-03 13:33:51','2022-03-03 13:33:51'),(122132,435,'Barkundia','833204',1,0,'2022-03-03 13:33:51','2022-03-03 13:33:51'),(122133,435,'Barposh','833104',1,0,'2022-03-03 13:33:51','2022-03-03 13:33:51'),(122134,435,'Benisagar','833214',1,0,'2022-03-03 13:33:51','2022-03-03 13:33:51'),(122135,435,'Bensakaranjia','833214',1,0,'2022-03-03 13:33:51','2022-03-03 13:33:51'),(122136,435,'Bhalupani','833102',1,0,'2022-03-03 13:33:51','2022-03-03 13:33:51'),(122137,435,'Bhalurungi','833105',1,0,'2022-03-03 13:33:51','2022-03-03 13:33:51'),(122138,435,'Bharbharia','833204',1,0,'2022-03-03 13:33:51','2022-03-03 13:33:51'),(122139,435,'Bhoya','833204',1,0,'2022-03-03 13:33:51','2022-03-03 13:33:51'),(122140,435,'Chaibasa H.O','833201',1,0,'2022-03-03 13:33:51','2022-03-03 13:33:51'),(122141,435,'Chainpur Khas','833102',1,0,'2022-03-03 13:33:51','2022-03-03 13:33:51'),(122142,435,'Chakradharpur Bazar','833102',1,0,'2022-03-03 13:33:51','2022-03-03 13:33:51'),(122143,435,'Chakradharpur Colony','833102',1,0,'2022-03-03 13:33:51','2022-03-03 13:33:51'),(122144,435,'Chiria','833106',1,0,'2022-03-03 13:33:51','2022-03-03 13:33:51'),(122145,435,'Chirubera','833102',1,0,'2022-03-03 13:33:51','2022-03-03 13:33:51'),(122146,435,'Chittimitti','833204',1,0,'2022-03-03 13:33:51','2022-03-03 13:33:51'),(122147,435,'Chotanagra','833106',1,0,'2022-03-03 13:33:52','2022-03-03 13:33:52'),(122148,435,'Dalki','833215',1,0,'2022-03-03 13:33:52','2022-03-03 13:33:52'),(122149,435,'Danguaposi','833212',1,0,'2022-03-03 13:33:52','2022-03-03 13:33:52'),(122150,435,'Dhobadhobin','833214',1,0,'2022-03-03 13:33:52','2022-03-03 13:33:52'),(122151,435,'Dumrita','833104',1,0,'2022-03-03 13:33:52','2022-03-03 13:33:52'),(122152,435,'Galudih','833101',1,0,'2022-03-03 13:33:52','2022-03-03 13:33:52'),(122153,435,'Ghagri','833204',1,0,'2022-03-03 13:33:52','2022-03-03 13:33:52'),(122154,435,'Gitilipi','833204',1,0,'2022-03-03 13:33:52','2022-03-03 13:33:52'),(122155,435,'Goilkera','833103',1,0,'2022-03-03 13:33:52','2022-03-03 13:33:52'),(122156,435,'Gopinathpur','833102',1,0,'2022-03-03 13:33:52','2022-03-03 13:33:52'),(122157,435,'Gua','833213',1,0,'2022-03-03 13:33:52','2022-03-03 13:33:52'),(122158,435,'Guira','833204',1,0,'2022-03-03 13:33:52','2022-03-03 13:33:52'),(122159,435,'Gulia','833204',1,0,'2022-03-03 13:33:52','2022-03-03 13:33:52'),(122160,435,'Hatgamaria','833214',1,0,'2022-03-03 13:33:52','2022-03-03 13:33:52'),(122161,435,'Hathia','833102',1,0,'2022-03-03 13:33:52','2022-03-03 13:33:52'),(122162,435,'Hesalkuti','833102',1,0,'2022-03-03 13:33:52','2022-03-03 13:33:52'),(122163,435,'Icha','833204',1,0,'2022-03-03 13:33:52','2022-03-03 13:33:52'),(122164,435,'J.M.P. Chowk','833204',1,0,'2022-03-03 13:33:52','2022-03-03 13:33:52'),(122165,435,'Jagannathpur','833203',1,0,'2022-03-03 13:33:52','2022-03-03 13:33:52'),(122166,435,'Jaintgarh','833214',1,0,'2022-03-03 13:33:52','2022-03-03 13:33:52'),(122167,435,'Jamdih','833214',1,0,'2022-03-03 13:33:52','2022-03-03 13:33:52'),(122168,435,'Jamid','833102',1,0,'2022-03-03 13:33:53','2022-03-03 13:33:53'),(122169,435,'Jharjharia','833102',1,0,'2022-03-03 13:33:53','2022-03-03 13:33:53'),(122170,435,'Jhinkpani','833215',1,0,'2022-03-03 13:33:53','2022-03-03 13:33:53'),(122171,435,'Jojo Camp','833217',1,0,'2022-03-03 13:33:53','2022-03-03 13:33:53'),(122172,435,'Joteya','833218',1,0,'2022-03-03 13:33:53','2022-03-03 13:33:53'),(122173,435,'Kairam','833103',1,0,'2022-03-03 13:33:53','2022-03-03 13:33:53'),(122174,435,'Karanjia','833214',1,0,'2022-03-03 13:33:53','2022-03-03 13:33:53'),(122175,435,'Kathbari','833204',1,0,'2022-03-03 13:33:53','2022-03-03 13:33:53'),(122176,435,'Kera','833102',1,0,'2022-03-03 13:33:53','2022-03-03 13:33:53'),(122177,435,'Keraikela','833102',1,0,'2022-03-03 13:33:53','2022-03-03 13:33:53'),(122178,435,'Keshargaria','833204',1,0,'2022-03-03 13:33:53','2022-03-03 13:33:53'),(122179,435,'Khairbandh','833214',1,0,'2022-03-03 13:33:53','2022-03-03 13:33:53'),(122180,435,'Khairpal','833214',1,0,'2022-03-03 13:33:53','2022-03-03 13:33:53'),(122181,435,'Khedchalan','833204',1,0,'2022-03-03 13:33:53','2022-03-03 13:33:53'),(122182,435,'Kheriatangar','833204',1,0,'2022-03-03 13:33:53','2022-03-03 13:33:53'),(122183,435,'Khuntpani','833204',1,0,'2022-03-03 13:33:53','2022-03-03 13:33:53'),(122184,435,'Khurpose','833214',1,0,'2022-03-03 13:33:53','2022-03-03 13:33:53'),(122185,435,'Kiriburu Base Camp','833222',1,0,'2022-03-03 13:33:53','2022-03-03 13:33:53'),(122186,435,'Kochra','833203',1,0,'2022-03-03 13:33:53','2022-03-03 13:33:53'),(122187,435,'Kokcho','833204',1,0,'2022-03-03 13:33:53','2022-03-03 13:33:53'),(122188,435,'Kotgarh','833218',1,0,'2022-03-03 13:33:54','2022-03-03 13:33:54'),(122189,435,'Kuira','833105',1,0,'2022-03-03 13:33:54','2022-03-03 13:33:54'),(122190,435,'Kumardungi','833214',1,0,'2022-03-03 13:33:54','2022-03-03 13:33:54'),(122191,435,'Kundiadhar','833214',1,0,'2022-03-03 13:33:54','2022-03-03 13:33:54'),(122192,435,'Lonjo','833105',1,0,'2022-03-03 13:33:54','2022-03-03 13:33:54'),(122193,435,'Lotapahar','833102',1,0,'2022-03-03 13:33:54','2022-03-03 13:33:54'),(122194,435,'Mahulpani','833102',1,0,'2022-03-03 13:33:54','2022-03-03 13:33:54'),(122195,435,'Majhgaon','833214',1,0,'2022-03-03 13:33:54','2022-03-03 13:33:54'),(122196,435,'Maluka','833203',1,0,'2022-03-03 13:33:54','2022-03-03 13:33:54'),(122197,435,'Manoharpur (West Singhbhum)','833104',1,0,'2022-03-03 13:33:54','2022-03-03 13:33:54'),(122198,435,'Meghahatuburu','833223',1,0,'2022-03-03 13:33:54','2022-03-03 13:33:54'),(122199,435,'N.Ashram','833214',1,0,'2022-03-03 13:33:54','2022-03-03 13:33:54'),(122200,435,'Nakahasa','833204',1,0,'2022-03-03 13:33:54','2022-03-03 13:33:54'),(122201,435,'Nakti','833102',1,0,'2022-03-03 13:33:54','2022-03-03 13:33:54'),(122202,435,'Naogaon','833215',1,0,'2022-03-03 13:33:54','2022-03-03 13:33:54'),(122203,435,'Narsanda','833204',1,0,'2022-03-03 13:33:54','2022-03-03 13:33:54'),(122204,435,'Noamundi Bazar','833218',1,0,'2022-03-03 13:33:54','2022-03-03 13:33:54'),(122205,435,'Noamundi','833217',1,0,'2022-03-03 13:33:54','2022-03-03 13:33:54'),(122206,435,'Otar','833102',1,0,'2022-03-03 13:33:54','2022-03-03 13:33:54'),(122207,435,'Pandrasali','833204',1,0,'2022-03-03 13:33:54','2022-03-03 13:33:54'),(122208,435,'Parsagar Keshna','833214',1,0,'2022-03-03 13:33:54','2022-03-03 13:33:54'),(122209,435,'Patherbasa','833104',1,0,'2022-03-03 13:33:55','2022-03-03 13:33:55'),(122210,435,'Pilka','833204',1,0,'2022-03-03 13:33:55','2022-03-03 13:33:55'),(122211,435,'Posiata','833104',1,0,'2022-03-03 13:33:55','2022-03-03 13:33:55'),(122212,435,'Punga','833214',1,0,'2022-03-03 13:33:55','2022-03-03 13:33:55'),(122213,435,'Purnapani','833215',1,0,'2022-03-03 13:33:55','2022-03-03 13:33:55'),(122214,435,'Purunia','833204',1,0,'2022-03-03 13:33:55','2022-03-03 13:33:55'),(122215,435,'Rajanand Pur','833104',1,0,'2022-03-03 13:33:55','2022-03-03 13:33:55'),(122216,435,'Robkera','833104',1,0,'2022-03-03 13:33:55','2022-03-03 13:33:55'),(122217,435,'Roladih','833102',1,0,'2022-03-03 13:33:55','2022-03-03 13:33:55'),(122218,435,'Roro','833204',1,0,'2022-03-03 13:33:55','2022-03-03 13:33:55'),(122219,435,'Ruia','833214',1,0,'2022-03-03 13:33:55','2022-03-03 13:33:55'),(122220,435,'Salai','833106',1,0,'2022-03-03 13:33:55','2022-03-03 13:33:55'),(122221,435,'Sarda','833204',1,0,'2022-03-03 13:33:55','2022-03-03 13:33:55'),(122222,435,'Sarjamhatu','833102',1,0,'2022-03-03 13:33:55','2022-03-03 13:33:55'),(122223,435,'Sindri Guiya','833214',1,0,'2022-03-03 13:33:55','2022-03-03 13:33:55'),(122224,435,'Sindriguia','833214',1,0,'2022-03-03 13:33:55','2022-03-03 13:33:55'),(122225,435,'Singhpokharia','833202',1,0,'2022-03-03 13:33:55','2022-03-03 13:33:55'),(122226,435,'Siyaljora','833214',1,0,'2022-03-03 13:33:55','2022-03-03 13:33:55'),(122227,435,'Sonua','833105',1,0,'2022-03-03 13:33:55','2022-03-03 13:33:55'),(122228,435,'Sringgesia','833215',1,0,'2022-03-03 13:33:55','2022-03-03 13:33:55'),(122229,435,'Surjabasa','833215',1,0,'2022-03-03 13:33:55','2022-03-03 13:33:55'),(122230,435,'T.B.Dumuria','833214',1,0,'2022-03-03 13:33:55','2022-03-03 13:33:55'),(122231,435,'Tantnagar','833204',1,0,'2022-03-03 13:33:55','2022-03-03 13:33:55'),(122232,435,'Tata College Chaibasa','833202',1,0,'2022-03-03 13:33:56','2022-03-03 13:33:56'),(122233,435,'Toklo','833102',1,0,'2022-03-03 13:33:56','2022-03-03 13:33:56'),(122234,435,'Tonto','833215',1,0,'2022-03-03 13:33:56','2022-03-03 13:33:56'),(122235,435,'Tonto','833204',1,0,'2022-03-03 13:33:56','2022-03-03 13:33:56'),(122236,435,'Tuniagajpur','833103',1,0,'2022-03-03 13:33:56','2022-03-03 13:33:56'),(122237,435,'Unchibita','833102',1,0,'2022-03-03 13:33:56','2022-03-03 13:33:56'),(122238,435,'Urkia','833104',1,0,'2022-03-03 13:33:56','2022-03-03 13:33:56'),(122239,436,'Alappuzha Bazar','688012',1,0,'2022-03-03 13:33:56','2022-03-03 13:33:56'),(122240,436,'Alappuzha Collectorate','688001',1,0,'2022-03-03 13:33:56','2022-03-03 13:33:56'),(122241,436,'Alappuzha District Hospital','688011',1,0,'2022-03-03 13:33:56','2022-03-03 13:33:56'),(122242,436,'Alappuzha H.O','688001',1,0,'2022-03-03 13:33:56','2022-03-03 13:33:56'),(122243,436,'Alappuzha Iron Bridge','688011',1,0,'2022-03-03 13:33:56','2022-03-03 13:33:56'),(122244,436,'Alappuzha Medical College','688005',1,0,'2022-03-03 13:33:56','2022-03-03 13:33:56'),(122245,436,'Alappuzha Mullackal','688011',1,0,'2022-03-03 13:33:56','2022-03-03 13:33:56'),(122246,436,'Alappuzha North','688007',1,0,'2022-03-03 13:33:56','2022-03-03 13:33:56'),(122247,436,'Ambalapuzha East EDB.O','688561',1,0,'2022-03-03 13:33:56','2022-03-03 13:33:56'),(122248,436,'Ambalapuzha','688561',1,0,'2022-03-03 13:33:56','2022-03-03 13:33:56'),(122249,436,'Andhakaranazhy','688531',1,0,'2022-03-03 13:33:56','2022-03-03 13:33:56'),(122250,436,'Arookutty','688535',1,0,'2022-03-03 13:33:56','2022-03-03 13:33:56'),(122251,436,'Aroor','688534',1,0,'2022-03-03 13:33:56','2022-03-03 13:33:56'),(122252,436,'Arthingal','688530',1,0,'2022-03-03 13:33:57','2022-03-03 13:33:57'),(122253,436,'Aryad North EDB.O','688538',1,0,'2022-03-03 13:33:57','2022-03-03 13:33:57'),(122254,436,'Avalukkunnu','688006',1,0,'2022-03-03 13:33:57','2022-03-03 13:33:57'),(122255,436,'Champakulam East','688505',1,0,'2022-03-03 13:33:57','2022-03-03 13:33:57'),(122256,436,'Champakulam','688505',1,0,'2022-03-03 13:33:57','2022-03-03 13:33:57'),(122257,436,'Chandiroor EDB.O','688537',1,0,'2022-03-03 13:33:57','2022-03-03 13:33:57'),(122258,436,'Chathurthiakary','688502',1,0,'2022-03-03 13:33:57','2022-03-03 13:33:57'),(122259,436,'Chempumpuram','688505',1,0,'2022-03-03 13:33:57','2022-03-03 13:33:57'),(122260,436,'Chennamkary','688501',1,0,'2022-03-03 13:33:57','2022-03-03 13:33:57'),(122261,436,'Chennamkary East','688506',1,0,'2022-03-03 13:33:57','2022-03-03 13:33:57'),(122262,436,'Cherthala Cutcherry','688524',1,0,'2022-03-03 13:33:57','2022-03-03 13:33:57'),(122263,436,'Cherthala H.O','688524',1,0,'2022-03-03 13:33:57','2022-03-03 13:33:57'),(122264,436,'Cherthala South EDB.O','688539',1,0,'2022-03-03 13:33:57','2022-03-03 13:33:57'),(122265,436,'Cherukara Kuttanad','688506',1,0,'2022-03-03 13:33:57','2022-03-03 13:33:57'),(122266,436,'Chethy GDB.O','688530',1,0,'2022-03-03 13:33:57','2022-03-03 13:33:57'),(122267,436,'Chirayakom','688562',1,0,'2022-03-03 13:33:57','2022-03-03 13:33:57'),(122268,436,'Chungom','688011',1,0,'2022-03-03 13:33:57','2022-03-03 13:33:57'),(122269,436,'Eramallur','688537',1,0,'2022-03-03 13:33:57','2022-03-03 13:33:57'),(122270,436,'Ezhupunna EDB.O','688537',1,0,'2022-03-03 13:33:57','2022-03-03 13:33:57'),(122271,436,'Ezhupunna South EDB.O','688537',1,0,'2022-03-03 13:33:57','2022-03-03 13:33:57'),(122272,436,'Illichira','688561',1,0,'2022-03-03 13:33:58','2022-03-03 13:33:58'),(122273,436,'Kadakkarapally','688529',1,0,'2022-03-03 13:33:58','2022-03-03 13:33:58'),(122274,436,'Kainakary East','688501',1,0,'2022-03-03 13:33:58','2022-03-03 13:33:58'),(122275,436,'Kainakary','688501',1,0,'2022-03-03 13:33:58','2022-03-03 13:33:58'),(122276,436,'Kakkazhom','688005',1,0,'2022-03-03 13:33:58','2022-03-03 13:33:58'),(122277,436,'Kalavamkodam','688524',1,0,'2022-03-03 13:33:58','2022-03-03 13:33:58'),(122278,436,'Kalavoor','688522',1,0,'2022-03-03 13:33:58','2022-03-03 13:33:58'),(122279,436,'Kanichukulangara EDB.O','688582',1,0,'2022-03-03 13:33:58','2022-03-03 13:33:58'),(122280,436,'Kanjipadom','688005',1,0,'2022-03-03 13:33:58','2022-03-03 13:33:58'),(122281,436,'Kanjiramchira','688007',1,0,'2022-03-03 13:33:58','2022-03-03 13:33:58'),(122282,436,'Kannady','688504',1,0,'2022-03-03 13:33:58','2022-03-03 13:33:58'),(122283,436,'Kannady West','688504',1,0,'2022-03-03 13:33:58','2022-03-03 13:33:58'),(122284,436,'Kannankara','688527',1,0,'2022-03-03 13:33:58','2022-03-03 13:33:58'),(122285,436,'Karikad','688527',1,0,'2022-03-03 13:33:58','2022-03-03 13:33:58'),(122286,436,'Karumady EDB.O','688561',1,0,'2022-03-03 13:33:58','2022-03-03 13:33:58'),(122287,436,'Kattoor Kalavoor EDB.O','688522',1,0,'2022-03-03 13:33:58','2022-03-03 13:33:58'),(122288,436,'Kavalam North','688506',1,0,'2022-03-03 13:33:58','2022-03-03 13:33:58'),(122289,436,'Kavalam','688506',1,0,'2022-03-03 13:33:58','2022-03-03 13:33:58'),(122290,436,'Kayalpuram','688504',1,0,'2022-03-03 13:33:59','2022-03-03 13:33:59'),(122291,436,'Kelamangalam','688562',1,0,'2022-03-03 13:33:59','2022-03-03 13:33:59'),(122292,436,'Kochuramapuram EDB.O','688541',1,0,'2022-03-03 13:33:59','2022-03-03 13:33:59'),(122293,436,'Kokkothamangalam','688527',1,0,'2022-03-03 13:33:59','2022-03-03 13:33:59'),(122294,436,'Komalapuram','688006',1,0,'2022-03-03 13:33:59','2022-03-03 13:33:59'),(122295,436,'Kommady Ward','688007',1,0,'2022-03-03 13:33:59','2022-03-03 13:33:59'),(122296,436,'Kottankulangara','688006',1,0,'2022-03-03 13:33:59','2022-03-03 13:33:59'),(122297,436,'Kunnumma Thakazhy','688562',1,0,'2022-03-03 13:33:59','2022-03-03 13:33:59'),(122298,436,'Kuppappuram','688011',1,0,'2022-03-03 13:33:59','2022-03-03 13:33:59'),(122299,436,'Kuruppankulangara','688539',1,0,'2022-03-03 13:33:59','2022-03-03 13:33:59'),(122300,436,'Kuthiathode','688533',1,0,'2022-03-03 13:33:59','2022-03-03 13:33:59'),(122301,436,'Kuttamangalam','688501',1,0,'2022-03-03 13:33:59','2022-03-03 13:33:59'),(122302,436,'Manappuram EDB.O','688526',1,0,'2022-03-03 13:33:59','2022-03-03 13:33:59'),(122303,436,'Mannancherry','688538',1,0,'2022-03-03 13:33:59','2022-03-03 13:33:59'),(122304,436,'Mararikulam North EDB.O','688523',1,0,'2022-03-03 13:33:59','2022-03-03 13:33:59'),(122305,436,'Maruthorvattom EDB.O','688539',1,0,'2022-03-03 13:33:59','2022-03-03 13:33:59'),(122306,436,'Mayithara Market','688539',1,0,'2022-03-03 13:33:59','2022-03-03 13:33:59'),(122307,436,'Moncombu','688502',1,0,'2022-03-03 13:33:59','2022-03-03 13:33:59'),(122308,436,'Moncombu Thekkekara','688503',1,0,'2022-03-03 13:33:59','2022-03-03 13:33:59'),(122309,436,'Muhamma','688525',1,0,'2022-03-03 13:33:59','2022-03-03 13:33:59'),(122310,436,'Muttathiparambu','688527',1,0,'2022-03-03 13:33:59','2022-03-03 13:33:59'),(122311,436,'Naduvathnagar EDB.O','688526',1,0,'2022-03-03 13:33:59','2022-03-03 13:33:59'),(122312,436,'Narakathara','688506',1,0,'2022-03-03 13:33:59','2022-03-03 13:33:59'),(122313,436,'Nedumudy EDB.O','688503',1,0,'2022-03-03 13:33:59','2022-03-03 13:33:59'),(122314,436,'Olavaipu','688526',1,0,'2022-03-03 13:34:00','2022-03-03 13:34:00'),(122315,436,'Pallippuram','688541',1,0,'2022-03-03 13:34:00','2022-03-03 13:34:00'),(122316,436,'Pallithode','688540',1,0,'2022-03-03 13:34:00','2022-03-03 13:34:00'),(122317,436,'Panavally EDB.O','688526',1,0,'2022-03-03 13:34:00','2022-03-03 13:34:00'),(122318,436,'Pandarakulam','688505',1,0,'2022-03-03 13:34:00','2022-03-03 13:34:00'),(122319,436,'Parayakad','688540',1,0,'2022-03-03 13:34:00','2022-03-03 13:34:00'),(122320,436,'Pathirappally','688521',1,0,'2022-03-03 13:34:00','2022-03-03 13:34:00'),(122321,436,'Pattanacaud','688531',1,0,'2022-03-03 13:34:00','2022-03-03 13:34:00'),(122322,436,'Pazhaveedu','688009',1,0,'2022-03-03 13:34:00','2022-03-03 13:34:00'),(122323,436,'Perumbalam','688570',1,0,'2022-03-03 13:34:00','2022-03-03 13:34:00'),(122324,436,'Pollethai EDB.O','688522',1,0,'2022-03-03 13:34:00','2022-03-03 13:34:00'),(122325,436,'Ponga','688503',1,0,'2022-03-03 13:34:00','2022-03-03 13:34:00'),(122326,436,'Ponnad','688538',1,0,'2022-03-03 13:34:00','2022-03-03 13:34:00'),(122327,436,'Poochackal','688526',1,0,'2022-03-03 13:34:00','2022-03-03 13:34:00'),(122328,436,'Pulincunnu','688504',1,0,'2022-03-03 13:34:00','2022-03-03 13:34:00'),(122329,436,'Pullangadi','688505',1,0,'2022-03-03 13:34:00','2022-03-03 13:34:00'),(122330,436,'Punnakunnathussery','688504',1,0,'2022-03-03 13:34:00','2022-03-03 13:34:00'),(122331,436,'Punnakunnathussery South','688504',1,0,'2022-03-03 13:34:00','2022-03-03 13:34:00'),(122332,436,'Punnapra North','688014',1,0,'2022-03-03 13:34:01','2022-03-03 13:34:01'),(122333,436,'Punnapra','688004',1,0,'2022-03-03 13:34:01','2022-03-03 13:34:01'),(122334,436,'Purakad EDB.O','688561',1,0,'2022-03-03 13:34:01','2022-03-03 13:34:01'),(122335,436,'Sanathanapuram','688003',1,0,'2022-03-03 13:34:01','2022-03-03 13:34:01'),(122336,436,'Sethulekshmipuram','688523',1,0,'2022-03-03 13:34:01','2022-03-03 13:34:01'),(122337,436,'Sreenarayanapuram','688582',1,0,'2022-03-03 13:34:01','2022-03-03 13:34:01'),(122338,436,'Thaickal EDB.O','688530',1,0,'2022-03-03 13:34:01','2022-03-03 13:34:01'),(122339,436,'Thakazhy','688562',1,0,'2022-03-03 13:34:01','2022-03-03 13:34:01'),(122340,436,'Thanneermukkom','688527',1,0,'2022-03-03 13:34:01','2022-03-03 13:34:01'),(122341,436,'Thathampally','688013',1,0,'2022-03-03 13:34:01','2022-03-03 13:34:01'),(122342,436,'Thirumalabhagom','688540',1,0,'2022-03-03 13:34:01','2022-03-03 13:34:01'),(122343,436,'Thirunallur EDB.O','688541',1,0,'2022-03-03 13:34:01','2022-03-03 13:34:01'),(122344,436,'Thiruvampady Junction','688002',1,0,'2022-03-03 13:34:01','2022-03-03 13:34:01'),(122345,436,'Thondankulangara','688013',1,0,'2022-03-03 13:34:01','2022-03-03 13:34:01'),(122346,436,'Thottappally EDB.O','688561',1,0,'2022-03-03 13:34:01','2022-03-03 13:34:01'),(122347,436,'Thottuvathala','688501',1,0,'2022-03-03 13:34:01','2022-03-03 13:34:01'),(122348,436,'Thumpoly','688008',1,0,'2022-03-03 13:34:01','2022-03-03 13:34:01'),(122349,436,'Thuravoor','688532',1,0,'2022-03-03 13:34:01','2022-03-03 13:34:01'),(122350,436,'Thuravoor South','688532',1,0,'2022-03-03 13:34:01','2022-03-03 13:34:01'),(122351,436,'Thycattussery','688528',1,0,'2022-03-03 13:34:01','2022-03-03 13:34:01'),(122352,436,'Trichattukulam EDB.O','688526',1,0,'2022-03-03 13:34:01','2022-03-03 13:34:01'),(122353,436,'Vadackal','688003',1,0,'2022-03-03 13:34:02','2022-03-03 13:34:02'),(122354,436,'Vaduthala Jetty','688535',1,0,'2022-03-03 13:34:02','2022-03-03 13:34:02'),(122355,436,'Valamangalam','688532',1,0,'2022-03-03 13:34:02','2022-03-03 13:34:02'),(122356,436,'Varanadu EDB.O','688539',1,0,'2022-03-03 13:34:02','2022-03-03 13:34:02'),(122357,436,'Varanam','688555',1,0,'2022-03-03 13:34:02','2022-03-03 13:34:02'),(122358,436,'Vattayal Ward','688002',1,0,'2022-03-03 13:34:02','2022-03-03 13:34:02'),(122359,436,'Vayalar','688536',1,0,'2022-03-03 13:34:02','2022-03-03 13:34:02'),(122360,436,'Vembanad Kayal','688006',1,0,'2022-03-03 13:34:02','2022-03-03 13:34:02'),(122361,436,'Vettackal EDB.O','688529',1,0,'2022-03-03 13:34:02','2022-03-03 13:34:02'),(122362,436,'Vysombhagom','688005',1,0,'2022-03-03 13:34:02','2022-03-03 13:34:02'),(122363,436,'Eara North','686534',1,0,'2022-03-03 13:34:02','2022-03-03 13:34:02'),(122364,436,'Kainady','686534',1,0,'2022-03-03 13:34:02','2022-03-03 13:34:02'),(122365,436,'Kidangara','686102',1,0,'2022-03-03 13:34:02','2022-03-03 13:34:02'),(122366,436,'Kumarankary','686103',1,0,'2022-03-03 13:34:02','2022-03-03 13:34:02'),(122367,436,'Kunnamkary','686102',1,0,'2022-03-03 13:34:02','2022-03-03 13:34:02'),(122368,436,'Neelamperoor','686534',1,0,'2022-03-03 13:34:02','2022-03-03 13:34:02'),(122369,436,'Akamkudy','690513',1,0,'2022-03-03 13:34:02','2022-03-03 13:34:02'),(122370,436,'Arattupuzha','690535',1,0,'2022-03-03 13:34:02','2022-03-03 13:34:02'),(122371,436,'Arattupuzha North','690515',1,0,'2022-03-03 13:34:02','2022-03-03 13:34:02'),(122372,436,'Areekara','689505',1,0,'2022-03-03 13:34:02','2022-03-03 13:34:02'),(122373,436,'Arunoottimangalam','690110',1,0,'2022-03-03 13:34:03','2022-03-03 13:34:03'),(122374,436,'Athikattukulangara','690504',1,0,'2022-03-03 13:34:03','2022-03-03 13:34:03'),(122375,436,'Ayaparambu','690517',1,0,'2022-03-03 13:34:03','2022-03-03 13:34:03'),(122376,436,'Ayiranikudy','690558',1,0,'2022-03-03 13:34:03','2022-03-03 13:34:03'),(122377,436,'Bharanickavu','690503',1,0,'2022-03-03 13:34:03','2022-03-03 13:34:03'),(122378,436,'Charumoodu','690505',1,0,'2022-03-03 13:34:03','2022-03-03 13:34:03'),(122379,436,'Chennithala','690105',1,0,'2022-03-03 13:34:03','2022-03-03 13:34:03'),(122380,436,'Chennithala South','690105',1,0,'2022-03-03 13:34:03','2022-03-03 13:34:03'),(122381,436,'Cheppaud','690507',1,0,'2022-03-03 13:34:03','2022-03-03 13:34:03'),(122382,436,'Cherukole','690104',1,0,'2022-03-03 13:34:03','2022-03-03 13:34:03'),(122383,436,'Cheruthana','690517',1,0,'2022-03-03 13:34:03','2022-03-03 13:34:03'),(122384,436,'Chettikulangara','690106',1,0,'2022-03-03 13:34:03','2022-03-03 13:34:03'),(122385,436,'Chingoli','690532',1,0,'2022-03-03 13:34:03','2022-03-03 13:34:03'),(122386,436,'Choolatheruvu','690506',1,0,'2022-03-03 13:34:03','2022-03-03 13:34:03'),(122387,436,'Chunakara','690534',1,0,'2022-03-03 13:34:03','2022-03-03 13:34:03'),(122388,436,'Ennakkad','689624',1,0,'2022-03-03 13:34:03','2022-03-03 13:34:03'),(122389,436,'Eramathoor','689622',1,0,'2022-03-03 13:34:03','2022-03-03 13:34:03'),(122390,436,'Eravankara','690108',1,0,'2022-03-03 13:34:03','2022-03-03 13:34:03'),(122391,436,'Erezha North','690106',1,0,'2022-03-03 13:34:03','2022-03-03 13:34:03'),(122392,436,'Erezha South','690106',1,0,'2022-03-03 13:34:03','2022-03-03 13:34:03'),(122393,436,'Erickavu','690516',1,0,'2022-03-03 13:34:03','2022-03-03 13:34:03'),(122394,436,'Eruva','690572',1,0,'2022-03-03 13:34:04','2022-03-03 13:34:04'),(122395,436,'Evur','690507',1,0,'2022-03-03 13:34:04','2022-03-03 13:34:04'),(122396,436,'Ezhakadavu','690104',1,0,'2022-03-03 13:34:04','2022-03-03 13:34:04'),(122397,436,'Govindamuttom','690527',1,0,'2022-03-03 13:34:04','2022-03-03 13:34:04'),(122398,436,'Haripad','690514',1,0,'2022-03-03 13:34:04','2022-03-03 13:34:04'),(122399,436,'Illippakulam','690503',1,0,'2022-03-03 13:34:04','2022-03-03 13:34:04'),(122400,436,'Kaduvinal','690501',1,0,'2022-03-03 13:34:04','2022-03-03 13:34:04'),(122401,436,'Kallimel','690509',1,0,'2022-03-03 13:34:04','2022-03-03 13:34:04'),(122402,436,'Kallumala','690110',1,0,'2022-03-03 13:34:04','2022-03-03 13:34:04'),(122403,436,'Kandallur','690535',1,0,'2022-03-03 13:34:04','2022-03-03 13:34:04'),(122404,436,'Kandiyoor','690103',1,0,'2022-03-03 13:34:04','2022-03-03 13:34:04'),(122405,436,'Kannamangalam','690106',1,0,'2022-03-03 13:34:04','2022-03-03 13:34:04'),(122406,436,'Kannanakuzhy','690505',1,0,'2022-03-03 13:34:04','2022-03-03 13:34:04'),(122407,436,'Kappil East','690533',1,0,'2022-03-03 13:34:04','2022-03-03 13:34:04'),(122408,436,'Karakkad','689504',1,0,'2022-03-03 13:34:04','2022-03-03 13:34:04'),(122409,436,'Kareelakulangara','690572',1,0,'2022-03-03 13:34:04','2022-03-03 13:34:04'),(122410,436,'Karipuzha','690103',1,0,'2022-03-03 13:34:04','2022-03-03 13:34:04'),(122411,436,'Karthikappally','690516',1,0,'2022-03-03 13:34:04','2022-03-03 13:34:04'),(122412,436,'Karuvatta North','690517',1,0,'2022-03-03 13:34:04','2022-03-03 13:34:04'),(122413,436,'Karuvatta','690517',1,0,'2022-03-03 13:34:04','2022-03-03 13:34:04'),(122414,436,'Kattanam','690503',1,0,'2022-03-03 13:34:05','2022-03-03 13:34:05'),(122415,436,'Kayangulam College','690502',1,0,'2022-03-03 13:34:05','2022-03-03 13:34:05'),(122416,436,'Kayangulam H.O','690502',1,0,'2022-03-03 13:34:05','2022-03-03 13:34:05'),(122417,436,'Keerikad','690508',1,0,'2022-03-03 13:34:05','2022-03-03 13:34:05'),(122418,436,'Kodukulanji','689508',1,0,'2022-03-03 13:34:05','2022-03-03 13:34:05'),(122419,436,'Kollakadavu','690509',1,0,'2022-03-03 13:34:05','2022-03-03 13:34:05'),(122420,436,'Komallur','690505',1,0,'2022-03-03 13:34:05','2022-03-03 13:34:05'),(122421,436,'Kotta','689504',1,0,'2022-03-03 13:34:05','2022-03-03 13:34:05'),(122422,436,'Kozhuvallur','689521',1,0,'2022-03-03 13:34:05','2022-03-03 13:34:05'),(122423,436,'Krishnapuram (Alappuzha)','690533',1,0,'2022-03-03 13:34:05','2022-03-03 13:34:05'),(122424,436,'Kudassanad','689512',1,0,'2022-03-03 13:34:05','2022-03-03 13:34:05'),(122425,436,'Kumarapuram (Alappuzha)','690548',1,0,'2022-03-03 13:34:05','2022-03-03 13:34:05'),(122426,436,'Kunnam (Alappuzha)','690108',1,0,'2022-03-03 13:34:05','2022-03-03 13:34:05'),(122427,436,'Kuttemperur','689623',1,0,'2022-03-03 13:34:05','2022-03-03 13:34:05'),(122428,436,'Mahadevikadu','690516',1,0,'2022-03-03 13:34:05','2022-03-03 13:34:05'),(122429,436,'Mampra','689508',1,0,'2022-03-03 13:34:05','2022-03-03 13:34:05'),(122430,436,'Mangalam','690515',1,0,'2022-03-03 13:34:05','2022-03-03 13:34:05'),(122431,436,'Mankamkuzhy','690558',1,0,'2022-03-03 13:34:05','2022-03-03 13:34:05'),(122432,436,'Mannar','689622',1,0,'2022-03-03 13:34:05','2022-03-03 13:34:05'),(122433,436,'Mannarasala','690514',1,0,'2022-03-03 13:34:05','2022-03-03 13:34:05'),(122434,436,'Mavelikara Court','690101',1,0,'2022-03-03 13:34:06','2022-03-03 13:34:06'),(122435,436,'Mavelikara Cutcherry','690101',1,0,'2022-03-03 13:34:06','2022-03-03 13:34:06'),(122436,436,'Mavelikara H.O','690101',1,0,'2022-03-03 13:34:06','2022-03-03 13:34:06'),(122437,436,'Melpadom','689627',1,0,'2022-03-03 13:34:06','2022-03-03 13:34:06'),(122438,436,'Mulakuzha','689505',1,0,'2022-03-03 13:34:06','2022-03-03 13:34:06'),(122439,436,'Muthukulam','690506',1,0,'2022-03-03 13:34:06','2022-03-03 13:34:06'),(122440,436,'Muthukulam South','690506',1,0,'2022-03-03 13:34:06','2022-03-03 13:34:06'),(122441,436,'Muttom-alleppey','690511',1,0,'2022-03-03 13:34:06','2022-03-03 13:34:06'),(122442,436,'Naduvattom','690512',1,0,'2022-03-03 13:34:06','2022-03-03 13:34:06'),(122443,436,'Nangiarkulangara','690513',1,0,'2022-03-03 13:34:06','2022-03-03 13:34:06'),(122444,436,'Neduvaramkodu','689508',1,0,'2022-03-03 13:34:06','2022-03-03 13:34:06'),(122445,436,'Njakkanal','690533',1,0,'2022-03-03 13:34:06','2022-03-03 13:34:06'),(122446,436,'Nooranad','690504',1,0,'2022-03-03 13:34:06','2022-03-03 13:34:06'),(122447,436,'Nooranad Sanatorium','690571',1,0,'2022-03-03 13:34:06','2022-03-03 13:34:06'),(122448,436,'Olakettiambalam','690510',1,0,'2022-03-03 13:34:06','2022-03-03 13:34:06'),(122449,436,'Padanilam','690529',1,0,'2022-03-03 13:34:06','2022-03-03 13:34:06'),(122450,436,'Pallana','690515',1,0,'2022-03-03 13:34:06','2022-03-03 13:34:06'),(122451,436,'Pallarimangalam','690107',1,0,'2022-03-03 13:34:06','2022-03-03 13:34:06'),(122452,436,'Pallickal Naduvilemuri','690503',1,0,'2022-03-03 13:34:06','2022-03-03 13:34:06'),(122453,436,'Pallickal','690503',1,0,'2022-03-03 13:34:06','2022-03-03 13:34:06'),(122454,436,'Pallipad','690512',1,0,'2022-03-03 13:34:06','2022-03-03 13:34:06'),(122455,436,'Panayil','690504',1,0,'2022-03-03 13:34:06','2022-03-03 13:34:06'),(122456,436,'Pandy','690517',1,0,'2022-03-03 13:34:06','2022-03-03 13:34:06'),(122457,436,'Pathiyoor','690508',1,0,'2022-03-03 13:34:07','2022-03-03 13:34:07'),(122458,436,'Pattolimarket','690531',1,0,'2022-03-03 13:34:07','2022-03-03 13:34:07'),(122459,436,'Pattoor','690529',1,0,'2022-03-03 13:34:07','2022-03-03 13:34:07'),(122460,436,'Pavukara','689622',1,0,'2022-03-03 13:34:07','2022-03-03 13:34:07'),(122461,436,'Payipad','690514',1,0,'2022-03-03 13:34:07','2022-03-03 13:34:07'),(122462,436,'Payyanallur','690504',1,0,'2022-03-03 13:34:07','2022-03-03 13:34:07'),(122463,436,'Pela','690103',1,0,'2022-03-03 13:34:07','2022-03-03 13:34:07'),(122464,436,'Pennukkara','689520',1,0,'2022-03-03 13:34:07','2022-03-03 13:34:07'),(122465,436,'Peringala-mulakuzha','689505',1,0,'2022-03-03 13:34:07','2022-03-03 13:34:07'),(122466,436,'Peringilipuram','689624',1,0,'2022-03-03 13:34:07','2022-03-03 13:34:07'),(122467,436,'Perungala','690559',1,0,'2022-03-03 13:34:07','2022-03-03 13:34:07'),(122468,436,'Poomala','689520',1,0,'2022-03-03 13:34:07','2022-03-03 13:34:07'),(122469,436,'Pullikanakku','690537',1,0,'2022-03-03 13:34:07','2022-03-03 13:34:07'),(122470,436,'Punnamoodu','690101',1,0,'2022-03-03 13:34:07','2022-03-03 13:34:07'),(122471,436,'Punthala','689509',1,0,'2022-03-03 13:34:07','2022-03-03 13:34:07'),(122472,436,'Puthenchantha','690501',1,0,'2022-03-03 13:34:07','2022-03-03 13:34:07'),(122473,436,'Puthiyacavu','690102',1,0,'2022-03-03 13:34:07','2022-03-03 13:34:07'),(122474,436,'Puthiyavila','690531',1,0,'2022-03-03 13:34:07','2022-03-03 13:34:07'),(122475,436,'Puthuppally','690527',1,0,'2022-03-03 13:34:07','2022-03-03 13:34:07'),(122476,436,'Thamallackal','690548',1,0,'2022-03-03 13:34:07','2022-03-03 13:34:07'),(122477,436,'Thamallackal North','690514',1,0,'2022-03-03 13:34:07','2022-03-03 13:34:07'),(122478,436,'Thamarakulam','690530',1,0,'2022-03-03 13:34:07','2022-03-03 13:34:07'),(122479,436,'Thannikunnu','690534',1,0,'2022-03-03 13:34:08','2022-03-03 13:34:08'),(122480,436,'Thattarambalam','690103',1,0,'2022-03-03 13:34:08','2022-03-03 13:34:08'),(122481,436,'Thazhakara','690102',1,0,'2022-03-03 13:34:08','2022-03-03 13:34:08'),(122482,436,'Thekkekara','690107',1,0,'2022-03-03 13:34:08','2022-03-03 13:34:08'),(122483,436,'Thrikkunnapuzha','690515',1,0,'2022-03-03 13:34:08','2022-03-03 13:34:08'),(122484,436,'Thripperunthura','690105',1,0,'2022-03-03 13:34:08','2022-03-03 13:34:08'),(122485,436,'Valiyakulangara','690104',1,0,'2022-03-03 13:34:08','2022-03-03 13:34:08'),(122486,436,'Valiyaparambu','690516',1,0,'2022-03-03 13:34:08','2022-03-03 13:34:08'),(122487,436,'Valiyazheekkal','690535',1,0,'2022-03-03 13:34:08','2022-03-03 13:34:08'),(122488,436,'Vallikunnam','690501',1,0,'2022-03-03 13:34:08','2022-03-03 13:34:08'),(122489,436,'Varenickal','690107',1,0,'2022-03-03 13:34:08','2022-03-03 13:34:08'),(122490,436,'Vedaraplavu','690505',1,0,'2022-03-03 13:34:08','2022-03-03 13:34:08'),(122491,436,'Veeyapuram','690514',1,0,'2022-03-03 13:34:08','2022-03-03 13:34:08'),(122492,436,'Venmony','689509',1,0,'2022-03-03 13:34:08','2022-03-03 13:34:08'),(122493,436,'Vetticode','690503',1,0,'2022-03-03 13:34:08','2022-03-03 13:34:08'),(122494,436,'Vettiyar','690558',1,0,'2022-03-03 13:34:08','2022-03-03 13:34:08'),(122495,436,'Prayar','690547',1,0,'2022-03-03 13:34:08','2022-03-03 13:34:08'),(122496,436,'Thattakkattu Market','690547',1,0,'2022-03-03 13:34:08','2022-03-03 13:34:08'),(122497,436,'Ala (Alappuzha)','689126',1,0,'2022-03-03 13:34:08','2022-03-03 13:34:08'),(122498,436,'Anaprambal','689572',1,0,'2022-03-03 13:34:08','2022-03-03 13:34:08'),(122499,436,'Anaprambal North','689572',1,0,'2022-03-03 13:34:08','2022-03-03 13:34:08'),(122500,436,'Angadical Chengannur','689122',1,0,'2022-03-03 13:34:09','2022-03-03 13:34:09'),(122501,436,'Bhudhanoor','689510',1,0,'2022-03-03 13:34:09','2022-03-03 13:34:09'),(122502,436,'Changankary','689573',1,0,'2022-03-03 13:34:09','2022-03-03 13:34:09'),(122503,436,'Chekkidikkadu','689573',1,0,'2022-03-03 13:34:09','2022-03-03 13:34:09'),(122504,436,'Chengannur H.O','689121',1,0,'2022-03-03 13:34:09','2022-03-03 13:34:09'),(122505,436,'Chengannur RS','689121',1,0,'2022-03-03 13:34:09','2022-03-03 13:34:09'),(122506,436,'Cheriyanadu','689511',1,0,'2022-03-03 13:34:09','2022-03-03 13:34:09'),(122507,436,'Edanad','689123',1,0,'2022-03-03 13:34:09','2022-03-03 13:34:09'),(122508,436,'Edathua','689573',1,0,'2022-03-03 13:34:09','2022-03-03 13:34:09'),(122509,436,'Elanjimel','689511',1,0,'2022-03-03 13:34:09','2022-03-03 13:34:09'),(122510,436,'Eramallikkara','689109',1,0,'2022-03-03 13:34:09','2022-03-03 13:34:09'),(122511,436,'Kallisserry','689124',1,0,'2022-03-03 13:34:09','2022-03-03 13:34:09'),(122512,436,'Karikuzhy','689571',1,0,'2022-03-03 13:34:09','2022-03-03 13:34:09'),(122513,436,'Kodupunna','689595',1,0,'2022-03-03 13:34:09','2022-03-03 13:34:09'),(122514,436,'Kunthirickal','689572',1,0,'2022-03-03 13:34:09','2022-03-03 13:34:09'),(122515,436,'Mithrakary','689595',1,0,'2022-03-03 13:34:09','2022-03-03 13:34:09'),(122516,436,'Mundancavu','689124',1,0,'2022-03-03 13:34:09','2022-03-03 13:34:09'),(122517,436,'Muttar','689574',1,0,'2022-03-03 13:34:09','2022-03-03 13:34:09'),(122518,436,'Neerattupuram','689571',1,0,'2022-03-03 13:34:09','2022-03-03 13:34:09'),(122519,436,'Pandanad North','689124',1,0,'2022-03-03 13:34:10','2022-03-03 13:34:10'),(122520,436,'Pandanad','689506',1,0,'2022-03-03 13:34:10','2022-03-03 13:34:10'),(122521,436,'Pandanad West','689506',1,0,'2022-03-03 13:34:10','2022-03-03 13:34:10'),(122522,436,'Pandankary','689573',1,0,'2022-03-03 13:34:10','2022-03-03 13:34:10'),(122523,436,'Perisserry','689126',1,0,'2022-03-03 13:34:10','2022-03-03 13:34:10'),(122524,436,'Piralassery','689122',1,0,'2022-03-03 13:34:10','2022-03-03 13:34:10'),(122525,436,'Puliyoor','689510',1,0,'2022-03-03 13:34:10','2022-03-03 13:34:10'),(122526,436,'Puthencavu','689123',1,0,'2022-03-03 13:34:10','2022-03-03 13:34:10'),(122527,436,'Ramankary','689595',1,0,'2022-03-03 13:34:10','2022-03-03 13:34:10'),(122528,436,'Thalavady','689572',1,0,'2022-03-03 13:34:10','2022-03-03 13:34:10'),(122529,436,'Thalavady South','689572',1,0,'2022-03-03 13:34:10','2022-03-03 13:34:10'),(122530,436,'Thayamkary','689573',1,0,'2022-03-03 13:34:10','2022-03-03 13:34:10'),(122531,436,'Thonackad','689511',1,0,'2022-03-03 13:34:10','2022-03-03 13:34:10'),(122532,436,'Tiruvanvandur','689109',1,0,'2022-03-03 13:34:10','2022-03-03 13:34:10'),(122533,436,'Urukari','689595',1,0,'2022-03-03 13:34:10','2022-03-03 13:34:10'),(122534,436,'Vazharmangalam','689124',1,0,'2022-03-03 13:34:10','2022-03-03 13:34:10'),(122535,436,'Veliyanadu North','689590',1,0,'2022-03-03 13:34:10','2022-03-03 13:34:10'),(122536,436,'Veliyanadu','689590',1,0,'2022-03-03 13:34:10','2022-03-03 13:34:10'),(122537,436,'Veliyanadu West','689590',1,0,'2022-03-03 13:34:10','2022-03-03 13:34:10'),(122538,436,'Vezhapra','689595',1,0,'2022-03-03 13:34:10','2022-03-03 13:34:10'),(122539,437,'Aimurikara','683544',1,0,'2022-03-03 13:34:10','2022-03-03 13:34:10'),(122540,437,'Airapuram','683541',1,0,'2022-03-03 13:34:10','2022-03-03 13:34:10'),(122541,437,'Airoopadam','686692',1,0,'2022-03-03 13:34:10','2022-03-03 13:34:10'),(122542,437,'Airoor','683579',1,0,'2022-03-03 13:34:11','2022-03-03 13:34:11'),(122543,437,'Alangad','683511',1,0,'2022-03-03 13:34:11','2022-03-03 13:34:11'),(122544,437,'Alattuchira','683544',1,0,'2022-03-03 13:34:11','2022-03-03 13:34:11'),(122545,437,'Allapra','683556',1,0,'2022-03-03 13:34:11','2022-03-03 13:34:11'),(122546,437,'Aluva Bazar','683101',1,0,'2022-03-03 13:34:11','2022-03-03 13:34:11'),(122547,437,'Aluva H.O','683101',1,0,'2022-03-03 13:34:11','2022-03-03 13:34:11'),(122548,437,'Aluva Town Bus Stand','683101',1,0,'2022-03-03 13:34:11','2022-03-03 13:34:11'),(122549,437,'Aluva-asokapuram','683101',1,0,'2022-03-03 13:34:11','2022-03-03 13:34:11'),(122550,437,'Anappara-kalady','683581',1,0,'2022-03-03 13:34:11','2022-03-03 13:34:11'),(122551,437,'Anchelpetty','686667',1,0,'2022-03-03 13:34:11','2022-03-03 13:34:11'),(122552,437,'Angamally','683572',1,0,'2022-03-03 13:34:11','2022-03-03 13:34:11'),(122553,437,'Angamally South','683573',1,0,'2022-03-03 13:34:11','2022-03-03 13:34:11'),(122554,437,'Arakuzha','686672',1,0,'2022-03-03 13:34:11','2022-03-03 13:34:11'),(122555,437,'Aruvappara','683545',1,0,'2022-03-03 13:34:11','2022-03-03 13:34:11'),(122556,437,'Asamannoor','683549',1,0,'2022-03-03 13:34:11','2022-03-03 13:34:11'),(122557,437,'Athani (Ernakulam)','683585',1,0,'2022-03-03 13:34:11','2022-03-03 13:34:11'),(122558,437,'Avoly','686670',1,0,'2022-03-03 13:34:11','2022-03-03 13:34:11'),(122559,437,'Ayavana','686668',1,0,'2022-03-03 13:34:11','2022-03-03 13:34:11'),(122560,437,'Ayyampuzha','683581',1,0,'2022-03-03 13:34:11','2022-03-03 13:34:11'),(122561,437,'Azhakam','683577',1,0,'2022-03-03 13:34:11','2022-03-03 13:34:11'),(122562,437,'Bhoothathankettu','686681',1,0,'2022-03-03 13:34:11','2022-03-03 13:34:11'),(122563,437,'Binanipuram','683502',1,0,'2022-03-03 13:34:11','2022-03-03 13:34:11'),(122564,437,'Chathamattam','686671',1,0,'2022-03-03 13:34:12','2022-03-03 13:34:12'),(122565,437,'Chelad Junction','686681',1,0,'2022-03-03 13:34:12','2022-03-03 13:34:12'),(122566,437,'Chendamangalam','683512',1,0,'2022-03-03 13:34:12','2022-03-03 13:34:12'),(122567,437,'Chengamanad','683578',1,0,'2022-03-03 13:34:12','2022-03-03 13:34:12'),(122568,437,'Cherai','683514',1,0,'2022-03-03 13:34:12','2022-03-03 13:34:12'),(122569,437,'Cheranalloor(PBR)','683544',1,0,'2022-03-03 13:34:12','2022-03-03 13:34:12'),(122570,437,'Cheruvattoor','686691',1,0,'2022-03-03 13:34:12','2022-03-03 13:34:12'),(122571,437,'Choondakuzhy','683546',1,0,'2022-03-03 13:34:12','2022-03-03 13:34:12'),(122572,437,'Chowara','683571',1,0,'2022-03-03 13:34:12','2022-03-03 13:34:12'),(122573,437,'Chully','683581',1,0,'2022-03-03 13:34:12','2022-03-03 13:34:12'),(122574,437,'Desom','683102',1,0,'2022-03-03 13:34:12','2022-03-03 13:34:12'),(122575,437,'Edathala North','683561',1,0,'2022-03-03 13:34:12','2022-03-03 13:34:12'),(122576,437,'Edathala','683561',1,0,'2022-03-03 13:34:12','2022-03-03 13:34:12'),(122577,437,'Edavoor','683544',1,0,'2022-03-03 13:34:12','2022-03-03 13:34:12'),(122578,437,'Edayar','686662',1,0,'2022-03-03 13:34:12','2022-03-03 13:34:12'),(122579,437,'Elanji','686665',1,0,'2022-03-03 13:34:12','2022-03-03 13:34:12'),(122580,437,'Elanthikara','683594',1,0,'2022-03-03 13:34:12','2022-03-03 13:34:12'),(122581,437,'Elavoor','683572',1,0,'2022-03-03 13:34:12','2022-03-03 13:34:12'),(122582,437,'Enanalloor','686673',1,0,'2022-03-03 13:34:12','2022-03-03 13:34:12'),(122583,437,'Erumathala','683112',1,0,'2022-03-03 13:34:12','2022-03-03 13:34:12'),(122584,437,'Ezhattumugham','683577',1,0,'2022-03-03 13:34:12','2022-03-03 13:34:12'),(122585,437,'Ezhikkara','683513',1,0,'2022-03-03 13:34:13','2022-03-03 13:34:13'),(122586,437,'Gothuruthy','683516',1,0,'2022-03-03 13:34:13','2022-03-03 13:34:13'),(122587,437,'Idamalayar','686681',1,0,'2022-03-03 13:34:13','2022-03-03 13:34:13'),(122588,437,'Illambakapalli','683544',1,0,'2022-03-03 13:34:13','2022-03-03 13:34:13'),(122589,437,'Inchathotty','686681',1,0,'2022-03-03 13:34:13','2022-03-03 13:34:13'),(122590,437,'Iramalloor','686691',1,0,'2022-03-03 13:34:13','2022-03-03 13:34:13'),(122591,437,'Iringole','683545',1,0,'2022-03-03 13:34:13','2022-03-03 13:34:13'),(122592,437,'Kadakkanad','682311',1,0,'2022-03-03 13:34:13','2022-03-03 13:34:13'),(122593,437,'Kadalikkad','686670',1,0,'2022-03-03 13:34:13','2022-03-03 13:34:13'),(122594,437,'Kadamattam','682311',1,0,'2022-03-03 13:34:13','2022-03-03 13:34:13'),(122595,437,'Kadavoor','686671',1,0,'2022-03-03 13:34:13','2022-03-03 13:34:13'),(122596,437,'Kadayirippu','682311',1,0,'2022-03-03 13:34:13','2022-03-03 13:34:13'),(122597,437,'Kaitharam','683519',1,0,'2022-03-03 13:34:13','2022-03-03 13:34:13'),(122598,437,'Kakkad','686664',1,0,'2022-03-03 13:34:13','2022-03-03 13:34:13'),(122599,437,'Kakkoor','686662',1,0,'2022-03-03 13:34:13','2022-03-03 13:34:13'),(122600,437,'Kalady Plantation','683581',1,0,'2022-03-03 13:34:13','2022-03-03 13:34:13'),(122601,437,'Kalady','683574',1,0,'2022-03-03 13:34:13','2022-03-03 13:34:13'),(122602,437,'Kalampoor','686664',1,0,'2022-03-03 13:34:13','2022-03-03 13:34:13'),(122603,437,'Kalloorkkad','686668',1,0,'2022-03-03 13:34:13','2022-03-03 13:34:13'),(122604,437,'Kaloor','686668',1,0,'2022-03-03 13:34:14','2022-03-03 13:34:14'),(122605,437,'Kanjoor','683575',1,0,'2022-03-03 13:34:14','2022-03-03 13:34:14'),(122606,437,'Karamala','686662',1,0,'2022-03-03 13:34:14','2022-03-03 13:34:14'),(122607,437,'Karimpana','686662',1,0,'2022-03-03 13:34:14','2022-03-03 13:34:14'),(122608,437,'Karukadom','686691',1,0,'2022-03-03 13:34:14','2022-03-03 13:34:14'),(122609,437,'Karukappilli','682311',1,0,'2022-03-03 13:34:14','2022-03-03 13:34:14'),(122610,437,'Karukutty','683576',1,0,'2022-03-03 13:34:14','2022-03-03 13:34:14'),(122611,437,'Karumalloor','683511',1,0,'2022-03-03 13:34:14','2022-03-03 13:34:14'),(122612,437,'Kavakkad','686668',1,0,'2022-03-03 13:34:14','2022-03-03 13:34:14'),(122613,437,'Keerampara','686681',1,0,'2022-03-03 13:34:14','2022-03-03 13:34:14'),(122614,437,'Keezhillam','683541',1,0,'2022-03-03 13:34:14','2022-03-03 13:34:14'),(122615,437,'Kidangoor','683572',1,0,'2022-03-03 13:34:14','2022-03-03 13:34:14'),(122616,437,'Kinginimattom','682311',1,0,'2022-03-03 13:34:14','2022-03-03 13:34:14'),(122617,437,'Kizhakkambalam','683562',1,0,'2022-03-03 13:34:14','2022-03-03 13:34:14'),(122618,437,'Kizhakompu','686662',1,0,'2022-03-03 13:34:14','2022-03-03 13:34:14'),(122619,437,'Kizhmuri','686663',1,0,'2022-03-03 13:34:14','2022-03-03 13:34:14'),(122620,437,'Kochi Airport','683111',1,0,'2022-03-03 13:34:14','2022-03-03 13:34:14'),(122621,437,'Kodanad','683544',1,0,'2022-03-03 13:34:14','2022-03-03 13:34:14'),(122622,437,'Kolenchery','682311',1,0,'2022-03-03 13:34:14','2022-03-03 13:34:14'),(122623,437,'Kombanad','683546',1,0,'2022-03-03 13:34:14','2022-03-03 13:34:14'),(122624,437,'Kongorpilly','683518',1,0,'2022-03-03 13:34:14','2022-03-03 13:34:14'),(122625,437,'Koonammavu','683518',1,0,'2022-03-03 13:34:14','2022-03-03 13:34:14'),(122626,437,'Koothattukulam','686662',1,0,'2022-03-03 13:34:15','2022-03-03 13:34:15'),(122627,437,'Koovalloor','686671',1,0,'2022-03-03 13:34:15','2022-03-03 13:34:15'),(122628,437,'Koovappady','683544',1,0,'2022-03-03 13:34:15','2022-03-03 13:34:15'),(122629,437,'Koovappara','686681',1,0,'2022-03-03 13:34:15','2022-03-03 13:34:15'),(122630,437,'Kothamangalam Bazar','686691',1,0,'2022-03-03 13:34:15','2022-03-03 13:34:15'),(122631,437,'Kothamangalam College','686666',1,0,'2022-03-03 13:34:15','2022-03-03 13:34:15'),(122632,437,'Kothamangalam (Ernakulam)','686691',1,0,'2022-03-03 13:34:15','2022-03-03 13:34:15'),(122633,437,'Kottappady','686692',1,0,'2022-03-03 13:34:15','2022-03-03 13:34:15'),(122634,437,'Kottuvally','683519',1,0,'2022-03-03 13:34:15','2022-03-03 13:34:15'),(122635,437,'Kozhipilly','686691',1,0,'2022-03-03 13:34:15','2022-03-03 13:34:15'),(122636,437,'Kumarapuram (Ernakulam)','683565',1,0,'2022-03-03 13:34:15','2022-03-03 13:34:15'),(122637,437,'Kunjithai','683522',1,0,'2022-03-03 13:34:15','2022-03-03 13:34:15'),(122638,437,'Kunnackal','682316',1,0,'2022-03-03 13:34:15','2022-03-03 13:34:15'),(122639,437,'Kunnukara','683578',1,0,'2022-03-03 13:34:15','2022-03-03 13:34:15'),(122640,437,'Kurumassery','683579',1,0,'2022-03-03 13:34:15','2022-03-03 13:34:15'),(122641,437,'Kuruppampady','683545',1,0,'2022-03-03 13:34:15','2022-03-03 13:34:15'),(122642,437,'Kuthiathode(EKM)','683594',1,0,'2022-03-03 13:34:15','2022-03-03 13:34:15'),(122643,437,'Kuthukuzhy','686691',1,0,'2022-03-03 13:34:15','2022-03-03 13:34:15'),(122644,437,'Kuttampuzha','686681',1,0,'2022-03-03 13:34:15','2022-03-03 13:34:15'),(122645,437,'Madakkathanam','686670',1,0,'2022-03-03 13:34:15','2022-03-03 13:34:15'),(122646,437,'Malayattoor','683587',1,0,'2022-03-03 13:34:15','2022-03-03 13:34:15'),(122647,437,'Malayidumthuruth','683561',1,0,'2022-03-03 13:34:15','2022-03-03 13:34:15'),(122648,437,'Maliankara','683516',1,0,'2022-03-03 13:34:16','2022-03-03 13:34:16'),(122649,437,'Malipara','686681',1,0,'2022-03-03 13:34:16','2022-03-03 13:34:16'),(122650,437,'Mamalakandom','686681',1,0,'2022-03-03 13:34:16','2022-03-03 13:34:16'),(122651,437,'Mamalassery','686663',1,0,'2022-03-03 13:34:16','2022-03-03 13:34:16'),(122652,437,'Manary','686673',1,0,'2022-03-03 13:34:16','2022-03-03 13:34:16'),(122653,437,'Manickamangalam','683574',1,0,'2022-03-03 13:34:16','2022-03-03 13:34:16'),(122654,437,'Manidu','686664',1,0,'2022-03-03 13:34:16','2022-03-03 13:34:16'),(122655,437,'Manikinar','686693',1,0,'2022-03-03 13:34:16','2022-03-03 13:34:16'),(122656,437,'Manjapra','683581',1,0,'2022-03-03 13:34:16','2022-03-03 13:34:16'),(122657,437,'Mannam Paravur','683520',1,0,'2022-03-03 13:34:16','2022-03-03 13:34:16'),(122658,437,'Mannathur','686667',1,0,'2022-03-03 13:34:16','2022-03-03 13:34:16'),(122659,437,'Marady East','686673',1,0,'2022-03-03 13:34:16','2022-03-03 13:34:16'),(122660,437,'Marampally','683105',1,0,'2022-03-03 13:34:16','2022-03-03 13:34:16'),(122661,437,'Marika','686662',1,0,'2022-03-03 13:34:16','2022-03-03 13:34:16'),(122662,437,'Mattoor','683574',1,0,'2022-03-03 13:34:16','2022-03-03 13:34:16'),(122663,437,'Mazhuvannoor','686669',1,0,'2022-03-03 13:34:16','2022-03-03 13:34:16'),(122664,437,'Mazhuvannoor South','686669',1,0,'2022-03-03 13:34:16','2022-03-03 13:34:16'),(122665,437,'Meenkunnam','686672',1,0,'2022-03-03 13:34:16','2022-03-03 13:34:16'),(122666,437,'Mekkad','683589',1,0,'2022-03-03 13:34:16','2022-03-03 13:34:16'),(122667,437,'Mekkadambu','682316',1,0,'2022-03-03 13:34:16','2022-03-03 13:34:16'),(122668,437,'Memadangu','686672',1,0,'2022-03-03 13:34:17','2022-03-03 13:34:17'),(122669,437,'Methala','683545',1,0,'2022-03-03 13:34:17','2022-03-03 13:34:17'),(122670,437,'Mookkannur','683577',1,0,'2022-03-03 13:34:17','2022-03-03 13:34:17'),(122671,437,'Moothakunnam','683516',1,0,'2022-03-03 13:34:17','2022-03-03 13:34:17'),(122672,437,'Mudakuzha','683546',1,0,'2022-03-03 13:34:17','2022-03-03 13:34:17'),(122673,437,'Mudavoor','686669',1,0,'2022-03-03 13:34:17','2022-03-03 13:34:17'),(122674,437,'Mudikkal','683547',1,0,'2022-03-03 13:34:17','2022-03-03 13:34:17'),(122675,437,'Mulakulam','686664',1,0,'2022-03-03 13:34:17','2022-03-03 13:34:17'),(122676,437,'Mulavoor','686673',1,0,'2022-03-03 13:34:17','2022-03-03 13:34:17'),(122677,437,'Mullapuzhachal','686670',1,0,'2022-03-03 13:34:17','2022-03-03 13:34:17'),(122678,437,'Muppathadam','683110',1,0,'2022-03-03 13:34:17','2022-03-03 13:34:17'),(122679,437,'Mutholapuram','686665',1,0,'2022-03-03 13:34:17','2022-03-03 13:34:17'),(122680,437,'Muvattupuzha Bazar','686673',1,0,'2022-03-03 13:34:17','2022-03-03 13:34:17'),(122681,437,'Muvattupuzha H.O','686661',1,0,'2022-03-03 13:34:17','2022-03-03 13:34:17'),(122682,437,'Muvattupuzha Market','686673',1,0,'2022-03-03 13:34:17','2022-03-03 13:34:17'),(122683,437,'Nadukani','686691',1,0,'2022-03-03 13:34:17','2022-03-03 13:34:17'),(122684,437,'Naduvattam','683574',1,0,'2022-03-03 13:34:17','2022-03-03 13:34:17'),(122685,437,'Nagapuzha','686668',1,0,'2022-03-03 13:34:17','2022-03-03 13:34:17'),(122686,437,'Nanthiattukunnam','683513',1,0,'2022-03-03 13:34:17','2022-03-03 13:34:17'),(122687,437,'Naval Armament Depot - Aluva','683563',1,0,'2022-03-03 13:34:17','2022-03-03 13:34:17'),(122688,437,'Nayathode','683572',1,0,'2022-03-03 13:34:17','2022-03-03 13:34:17'),(122689,437,'Nechoor','686664',1,0,'2022-03-03 13:34:18','2022-03-03 13:34:18'),(122690,437,'Nedumbassery','683585',1,0,'2022-03-03 13:34:18','2022-03-03 13:34:18'),(122691,437,'Nedungapra','683545',1,0,'2022-03-03 13:34:18','2022-03-03 13:34:18'),(122692,437,'Neeleeswaram','683574',1,0,'2022-03-03 13:34:18','2022-03-03 13:34:18'),(122693,437,'Neendapara','686693',1,0,'2022-03-03 13:34:18','2022-03-03 13:34:18'),(122694,437,'Neericode','683511',1,0,'2022-03-03 13:34:18','2022-03-03 13:34:18'),(122695,437,'Nellad','686669',1,0,'2022-03-03 13:34:18','2022-03-03 13:34:18'),(122696,437,'Nellikuzhy','686691',1,0,'2022-03-03 13:34:18','2022-03-03 13:34:18'),(122697,437,'Nellimattam','686693',1,0,'2022-03-03 13:34:18','2022-03-03 13:34:18'),(122698,437,'Neriamangalam','686693',1,0,'2022-03-03 13:34:18','2022-03-03 13:34:18'),(122699,437,'Nirmala','686673',1,0,'2022-03-03 13:34:18','2022-03-03 13:34:18'),(122700,437,'Njayapalli','686681',1,0,'2022-03-03 13:34:18','2022-03-03 13:34:18'),(122701,437,'North Piramadom','686667',1,0,'2022-03-03 13:34:18','2022-03-03 13:34:18'),(122702,437,'Okkal','683550',1,0,'2022-03-03 13:34:18','2022-03-03 13:34:18'),(122703,437,'Oliyapuram','686662',1,0,'2022-03-03 13:34:18','2022-03-03 13:34:18'),(122704,437,'Onakkoor','686667',1,0,'2022-03-03 13:34:18','2022-03-03 13:34:18'),(122705,437,'Oonnukal','686693',1,0,'2022-03-03 13:34:18','2022-03-03 13:34:18'),(122706,437,'Ooramana','686663',1,0,'2022-03-03 13:34:18','2022-03-03 13:34:18'),(122707,437,'Paduvapuram','683576',1,0,'2022-03-03 13:34:18','2022-03-03 13:34:18'),(122708,437,'Paingattoor','686671',1,0,'2022-03-03 13:34:18','2022-03-03 13:34:18'),(122709,437,'Palakuzha','686662',1,0,'2022-03-03 13:34:18','2022-03-03 13:34:18'),(122710,437,'Pallarimangalam','686671',1,0,'2022-03-03 13:34:18','2022-03-03 13:34:18'),(122711,437,'Palliport','683515',1,0,'2022-03-03 13:34:19','2022-03-03 13:34:19'),(122712,437,'Pampakuda','686667',1,0,'2022-03-03 13:34:19','2022-03-03 13:34:19'),(122713,437,'Panaikulam','683511',1,0,'2022-03-03 13:34:19','2022-03-03 13:34:19'),(122714,437,'Pandappily','686672',1,0,'2022-03-03 13:34:19','2022-03-03 13:34:19'),(122715,437,'Paniely','683546',1,0,'2022-03-03 13:34:19','2022-03-03 13:34:19'),(122716,437,'Panipra','686692',1,0,'2022-03-03 13:34:19','2022-03-03 13:34:19'),(122717,437,'Parakkadavu','683579',1,0,'2022-03-03 13:34:19','2022-03-03 13:34:19'),(122718,437,'Parappuram','683575',1,0,'2022-03-03 13:34:19','2022-03-03 13:34:19'),(122719,437,'Paravur Market','683513',1,0,'2022-03-03 13:34:19','2022-03-03 13:34:19'),(122720,437,'Paravur (Ernakulam)','683513',1,0,'2022-03-03 13:34:19','2022-03-03 13:34:19'),(122721,437,'Paravur Town','683513',1,0,'2022-03-03 13:34:19','2022-03-03 13:34:19'),(122722,437,'Pareekanni','686693',1,0,'2022-03-03 13:34:19','2022-03-03 13:34:19'),(122723,437,'Pattimattam','683562',1,0,'2022-03-03 13:34:19','2022-03-03 13:34:19'),(122724,437,'Pazhamthottam','683565',1,0,'2022-03-03 13:34:19','2022-03-03 13:34:19'),(122725,437,'Pazhoor','686664',1,0,'2022-03-03 13:34:19','2022-03-03 13:34:19'),(122726,437,'Periapuram','686667',1,0,'2022-03-03 13:34:19','2022-03-03 13:34:19'),(122727,437,'Peringala','683565',1,0,'2022-03-03 13:34:19','2022-03-03 13:34:19'),(122728,437,'Perumannoor(KGM)','686693',1,0,'2022-03-03 13:34:19','2022-03-03 13:34:19'),(122729,437,'Perumbadavam','686665',1,0,'2022-03-03 13:34:20','2022-03-03 13:34:20'),(122730,437,'Perumballoor','686673',1,0,'2022-03-03 13:34:20','2022-03-03 13:34:20'),(122731,437,'Perumbavoor H.O','683542',1,0,'2022-03-03 13:34:20','2022-03-03 13:34:20'),(122732,437,'Perumbavoor South','683542',1,0,'2022-03-03 13:34:20','2022-03-03 13:34:20'),(122733,437,'Pezhakkappilly','686673',1,0,'2022-03-03 13:34:20','2022-03-03 13:34:20'),(122734,437,'Pindimana','686692',1,0,'2022-03-03 13:34:20','2022-03-03 13:34:20'),(122735,437,'Piraroor','683574',1,0,'2022-03-03 13:34:20','2022-03-03 13:34:20'),(122736,437,'Piravom','686664',1,0,'2022-03-03 13:34:20','2022-03-03 13:34:20'),(122737,437,'Plamudi','686692',1,0,'2022-03-03 13:34:20','2022-03-03 13:34:20'),(122738,437,'Ponjassery','683547',1,0,'2022-03-03 13:34:20','2022-03-03 13:34:20'),(122739,437,'Pooyamkutty','686681',1,0,'2022-03-03 13:34:20','2022-03-03 13:34:20'),(122740,437,'Pothanicaud','686671',1,0,'2022-03-03 13:34:20','2022-03-03 13:34:20'),(122741,437,'Pulinthanam','686671',1,0,'2022-03-03 13:34:20','2022-03-03 13:34:20'),(122742,437,'Puliyanam','683572',1,0,'2022-03-03 13:34:20','2022-03-03 13:34:20'),(122743,437,'Pulluvazhi','683541',1,0,'2022-03-03 13:34:20','2022-03-03 13:34:20'),(122744,437,'Puthenvelikkara','683594',1,0,'2022-03-03 13:34:20','2022-03-03 13:34:20'),(122745,437,'Puthupadi','686673',1,0,'2022-03-03 13:34:20','2022-03-03 13:34:20'),(122746,437,'Ramamangalam','686663',1,0,'2022-03-03 13:34:20','2022-03-03 13:34:20'),(122747,437,'Randar','686673',1,0,'2022-03-03 13:34:21','2022-03-03 13:34:21'),(122748,437,'Rayamangalam','683545',1,0,'2022-03-03 13:34:21','2022-03-03 13:34:21'),(122749,437,'Rayonpuram','683543',1,0,'2022-03-03 13:34:21','2022-03-03 13:34:21'),(122750,437,'S.Aduvassery','683578',1,0,'2022-03-03 13:34:21','2022-03-03 13:34:21'),(122751,437,'South Vazhakulam','683105',1,0,'2022-03-03 13:34:21','2022-03-03 13:34:21'),(122752,437,'Sreemoolanagaram','683580',1,0,'2022-03-03 13:34:21','2022-03-03 13:34:21'),(122753,437,'Thabore','683577',1,0,'2022-03-03 13:34:21','2022-03-03 13:34:21'),(122754,437,'Thaikkattukara','683106',1,0,'2022-03-03 13:34:21','2022-03-03 13:34:21'),(122755,437,'Thalakode','686693',1,0,'2022-03-03 13:34:21','2022-03-03 13:34:21'),(122756,437,'Thathappilly','683520',1,0,'2022-03-03 13:34:21','2022-03-03 13:34:21'),(122757,437,'Thattekkad','686681',1,0,'2022-03-03 13:34:21','2022-03-03 13:34:21'),(122758,437,'Thazhvankunnam','686668',1,0,'2022-03-03 13:34:21','2022-03-03 13:34:21'),(122759,437,'Thekkenmarady','686673',1,0,'2022-03-03 13:34:21','2022-03-03 13:34:21'),(122760,437,'Thirumarady','686662',1,0,'2022-03-03 13:34:21','2022-03-03 13:34:21'),(122761,437,'Thottakkattukara','683108',1,0,'2022-03-03 13:34:21','2022-03-03 13:34:21'),(122762,437,'Thottumughom','683105',1,0,'2022-03-03 13:34:21','2022-03-03 13:34:21'),(122763,437,'Thrikkalathoor','683541',1,0,'2022-03-03 13:34:21','2022-03-03 13:34:21'),(122764,437,'Thrikkariyoor','686692',1,0,'2022-03-03 13:34:21','2022-03-03 13:34:21'),(122765,437,'Thuravoor','683572',1,0,'2022-03-03 13:34:21','2022-03-03 13:34:21'),(122766,437,'Thuravumkara','683575',1,0,'2022-03-03 13:34:21','2022-03-03 13:34:21'),(122767,437,'Thuruthy','683545',1,0,'2022-03-03 13:34:21','2022-03-03 13:34:21'),(122768,437,'Uliyannoor','683108',1,0,'2022-03-03 13:34:22','2022-03-03 13:34:22'),(122769,437,'Union Christian College','683102',1,0,'2022-03-03 13:34:22','2022-03-03 13:34:22'),(122770,437,'Urulanthanni','686681',1,0,'2022-03-03 13:34:22','2022-03-03 13:34:22'),(122771,437,'Vadakkekara','683522',1,0,'2022-03-03 13:34:22','2022-03-03 13:34:22'),(122772,437,'Vadakkumpuram','683521',1,0,'2022-03-03 13:34:22','2022-03-03 13:34:22'),(122773,437,'Vadakode-vazhakulam','686670',1,0,'2022-03-03 13:34:22','2022-03-03 13:34:22'),(122774,437,'Vadattupara','686681',1,0,'2022-03-03 13:34:22','2022-03-03 13:34:22'),(122775,437,'Vaikkara','683549',1,0,'2022-03-03 13:34:22','2022-03-03 13:34:22'),(122776,437,'Valayanchirangara','683556',1,0,'2022-03-03 13:34:22','2022-03-03 13:34:22'),(122777,437,'Vappalassery','683572',1,0,'2022-03-03 13:34:22','2022-03-03 13:34:22'),(122778,437,'Varapetty','686691',1,0,'2022-03-03 13:34:22','2022-03-03 13:34:22'),(122779,437,'Varapuzha Landing','683517',1,0,'2022-03-03 13:34:22','2022-03-03 13:34:22'),(122780,437,'Varapuzha','683517',1,0,'2022-03-03 13:34:22','2022-03-03 13:34:22'),(122781,437,'Vattaparambu','683579',1,0,'2022-03-03 13:34:22','2022-03-03 13:34:22'),(122782,437,'Vazhakulam','686670',1,0,'2022-03-03 13:34:22','2022-03-03 13:34:22'),(122783,437,'Vazhappilly East','686673',1,0,'2022-03-03 13:34:22','2022-03-03 13:34:22'),(122784,437,'Vellarappilly South','683580',1,0,'2022-03-03 13:34:22','2022-03-03 13:34:22'),(122785,437,'Vempilly','683565',1,0,'2022-03-03 13:34:22','2022-03-03 13:34:22'),(122786,437,'Vengola','683556',1,0,'2022-03-03 13:34:22','2022-03-03 13:34:22'),(122787,437,'Vengola West','683556',1,0,'2022-03-03 13:34:22','2022-03-03 13:34:22'),(122788,437,'Vengoor','683546',1,0,'2022-03-03 13:34:22','2022-03-03 13:34:22'),(122789,437,'Vettampara','686681',1,0,'2022-03-03 13:34:23','2022-03-03 13:34:23'),(122790,437,'Vilangu','683561',1,0,'2022-03-03 13:34:23','2022-03-03 13:34:23'),(122791,437,'West Kadungalloor','683110',1,0,'2022-03-03 13:34:23','2022-03-03 13:34:23'),(122792,437,'West Veliyathunad','683511',1,0,'2022-03-03 13:34:23','2022-03-03 13:34:23'),(122793,437,'Yordhanapuram','683574',1,0,'2022-03-03 13:34:23','2022-03-03 13:34:23'),(122794,437,'AIMS Ponekkara','682041',1,0,'2022-03-03 13:34:23','2022-03-03 13:34:23'),(122795,437,'Ambalamedu','682303',1,0,'2022-03-03 13:34:23','2022-03-03 13:34:23'),(122796,437,'Ambalamugal','682302',1,0,'2022-03-03 13:34:23','2022-03-03 13:34:23'),(122797,437,'Amballur','682315',1,0,'2022-03-03 13:34:23','2022-03-03 13:34:23'),(122798,437,'Andikkadavu','682008',1,0,'2022-03-03 13:34:23','2022-03-03 13:34:23'),(122799,437,'Arakunnam','682313',1,0,'2022-03-03 13:34:23','2022-03-03 13:34:23'),(122800,437,'Ayyampilly','682501',1,0,'2022-03-03 13:34:23','2022-03-03 13:34:23'),(122801,437,'Azheekal','682508',1,0,'2022-03-03 13:34:23','2022-03-03 13:34:23'),(122802,437,'Bhaktanandapuram','682308',1,0,'2022-03-03 13:34:23','2022-03-03 13:34:23'),(122803,437,'Brahmapuram','682303',1,0,'2022-03-03 13:34:23','2022-03-03 13:34:23'),(122804,437,'Changampuzha Nagar','682033',1,0,'2022-03-03 13:34:23','2022-03-03 13:34:23'),(122805,437,'Chellanam','682008',1,0,'2022-03-03 13:34:23','2022-03-03 13:34:23'),(122806,437,'Cheranallur','682034',1,0,'2022-03-03 13:34:23','2022-03-03 13:34:23'),(122807,437,'Chethicode','682315',1,0,'2022-03-03 13:34:24','2022-03-03 13:34:24'),(122808,437,'Chittoor-ekm','682027',1,0,'2022-03-03 13:34:24','2022-03-03 13:34:24'),(122809,437,'Chottanikkara','682312',1,0,'2022-03-03 13:34:24','2022-03-03 13:34:24'),(122810,437,'Cochin Special Economic Zone','682037',1,0,'2022-03-03 13:34:24','2022-03-03 13:34:24'),(122811,437,'Edakkattuvayal','682313',1,0,'2022-03-03 13:34:24','2022-03-03 13:34:24'),(122812,437,'Edakochi','682010',1,0,'2022-03-03 13:34:24','2022-03-03 13:34:24'),(122813,437,'Edapally North','682024',1,0,'2022-03-03 13:34:24','2022-03-03 13:34:24'),(122814,437,'Edapally','682024',1,0,'2022-03-03 13:34:24','2022-03-03 13:34:24'),(122815,437,'Edavanakad','682502',1,0,'2022-03-03 13:34:24','2022-03-03 13:34:24'),(122816,437,'Elamakkara','682026',1,0,'2022-03-03 13:34:24','2022-03-03 13:34:24'),(122817,437,'Elamkunnapuzha','682503',1,0,'2022-03-03 13:34:24','2022-03-03 13:34:24'),(122818,437,'Ernakulam College','682035',1,0,'2022-03-03 13:34:24','2022-03-03 13:34:24'),(122819,437,'Ernakulam H.O','682011',1,0,'2022-03-03 13:34:24','2022-03-03 13:34:24'),(122820,437,'Ernakulam High Court','682031',1,0,'2022-03-03 13:34:24','2022-03-03 13:34:24'),(122821,437,'Ernakulam Hindi Prachar Sabha','682016',1,0,'2022-03-03 13:34:24','2022-03-03 13:34:24'),(122822,437,'Ernakulam North','682018',1,0,'2022-03-03 13:34:24','2022-03-03 13:34:24'),(122823,437,'Eroor (Ernakulam)','682306',1,0,'2022-03-03 13:34:24','2022-03-03 13:34:24'),(122824,437,'Eroor South','682306',1,0,'2022-03-03 13:34:24','2022-03-03 13:34:24'),(122825,437,'Eroor West','682306',1,0,'2022-03-03 13:34:24','2022-03-03 13:34:24'),(122826,437,'Ezhakkaranad','682308',1,0,'2022-03-03 13:34:24','2022-03-03 13:34:24'),(122827,437,'Ezhakkaranadu South','682308',1,0,'2022-03-03 13:34:24','2022-03-03 13:34:24'),(122828,437,'Hmt Colony','683503',1,0,'2022-03-03 13:34:24','2022-03-03 13:34:24'),(122829,437,'Infopark-Kochi','682042',1,0,'2022-03-03 13:34:24','2022-03-03 13:34:24'),(122830,437,'Irimbanam','682309',1,0,'2022-03-03 13:34:25','2022-03-03 13:34:25'),(122831,437,'Kadamakudi','682027',1,0,'2022-03-03 13:34:25','2022-03-03 13:34:25'),(122832,437,'Kadavanthara','682020',1,0,'2022-03-03 13:34:25','2022-03-03 13:34:25'),(122833,437,'Kadungamangalam','682305',1,0,'2022-03-03 13:34:25','2022-03-03 13:34:25'),(122834,437,'Kaipatoor','682313',1,0,'2022-03-03 13:34:25','2022-03-03 13:34:25'),(122835,437,'Kakkanad','682030',1,0,'2022-03-03 13:34:25','2022-03-03 13:34:25'),(122836,437,'Kakkanad West','682030',1,0,'2022-03-03 13:34:25','2022-03-03 13:34:25'),(122837,437,'Kalamassery Development Plot','683104',1,0,'2022-03-03 13:34:25','2022-03-03 13:34:25'),(122838,437,'Kalamassery','683104',1,0,'2022-03-03 13:34:25','2022-03-03 13:34:25'),(122839,437,'Kaloor','682017',1,0,'2022-03-03 13:34:25','2022-03-03 13:34:25'),(122840,437,'Kanayannoor','682312',1,0,'2022-03-03 13:34:25','2022-03-03 13:34:25'),(122841,437,'Kandanad','682305',1,0,'2022-03-03 13:34:25','2022-03-03 13:34:25'),(122842,437,'Kaninad','682310',1,0,'2022-03-03 13:34:25','2022-03-03 13:34:25'),(122843,437,'Kanjiramattom','682315',1,0,'2022-03-03 13:34:25','2022-03-03 13:34:25'),(122844,437,'Kannamali','682008',1,0,'2022-03-03 13:34:25','2022-03-03 13:34:25'),(122845,437,'Karimugal','682303',1,0,'2022-03-03 13:34:25','2022-03-03 13:34:25'),(122846,437,'Kochi H.O','682001',1,0,'2022-03-03 13:34:25','2022-03-03 13:34:25'),(122847,437,'Kochi M.G.Road','682016',1,0,'2022-03-03 13:34:25','2022-03-03 13:34:25'),(122848,437,'Kochi Naval Base','682004',1,0,'2022-03-03 13:34:25','2022-03-03 13:34:25'),(122849,437,'Kochi Palace','682301',1,0,'2022-03-03 13:34:25','2022-03-03 13:34:25'),(122850,437,'Kochi University','682022',1,0,'2022-03-03 13:34:25','2022-03-03 13:34:25'),(122851,437,'Kokkappilly','682305',1,0,'2022-03-03 13:34:26','2022-03-03 13:34:26'),(122852,437,'Kothad','682027',1,0,'2022-03-03 13:34:26','2022-03-03 13:34:26'),(122853,437,'Kulayettikara','682315',1,0,'2022-03-03 13:34:26','2022-03-03 13:34:26'),(122854,437,'Kumbalam','682506',1,0,'2022-03-03 13:34:26','2022-03-03 13:34:26'),(122855,437,'Kumbalangi','682007',1,0,'2022-03-03 13:34:26','2022-03-03 13:34:26'),(122856,437,'Kumbalangi South','682007',1,0,'2022-03-03 13:34:26','2022-03-03 13:34:26'),(122857,437,'Kureekad','682305',1,0,'2022-03-03 13:34:26','2022-03-03 13:34:26'),(122858,437,'Kusumagiri','682030',1,0,'2022-03-03 13:34:26','2022-03-03 13:34:26'),(122859,437,'Kuttikkattukara','683501',1,0,'2022-03-03 13:34:26','2022-03-03 13:34:26'),(122860,437,'Kuzhiyara','682312',1,0,'2022-03-03 13:34:26','2022-03-03 13:34:26'),(122861,437,'Malipuram','682511',1,0,'2022-03-03 13:34:26','2022-03-03 13:34:26'),(122862,437,'Mamala','682305',1,0,'2022-03-03 13:34:26','2022-03-03 13:34:26'),(122863,437,'Manjummel','683501',1,0,'2022-03-03 13:34:26','2022-03-03 13:34:26'),(122864,437,'Maradu','682304',1,0,'2022-03-03 13:34:26','2022-03-03 13:34:26'),(122865,437,'Marithazham','682315',1,0,'2022-03-03 13:34:26','2022-03-03 13:34:26'),(122866,437,'Matsyapuri','682029',1,0,'2022-03-03 13:34:26','2022-03-03 13:34:26'),(122867,437,'Mattancherry Jetty','682002',1,0,'2022-03-03 13:34:26','2022-03-03 13:34:26'),(122868,437,'Mattancherry','682002',1,0,'2022-03-03 13:34:26','2022-03-03 13:34:26'),(122869,437,'Mattancherry Town','682002',1,0,'2022-03-03 13:34:26','2022-03-03 13:34:26'),(122870,437,'Meempara','682308',1,0,'2022-03-03 13:34:27','2022-03-03 13:34:27'),(122871,437,'Mulanthuruthy','682314',1,0,'2022-03-03 13:34:27','2022-03-03 13:34:27'),(122872,437,'Mulavukad','682504',1,0,'2022-03-03 13:34:27','2022-03-03 13:34:27'),(122873,437,'Mundamveli','682507',1,0,'2022-03-03 13:34:27','2022-03-03 13:34:27'),(122874,437,'Nadakkavu','682307',1,0,'2022-03-03 13:34:27','2022-03-03 13:34:27'),(122875,437,'Narakkal','682505',1,0,'2022-03-03 13:34:27','2022-03-03 13:34:27'),(122876,437,'Nayarambalam','682509',1,0,'2022-03-03 13:34:27','2022-03-03 13:34:27'),(122877,437,'Nazreth','682507',1,0,'2022-03-03 13:34:27','2022-03-03 13:34:27'),(122878,437,'Nedungad','682509',1,0,'2022-03-03 13:34:27','2022-03-03 13:34:27'),(122879,437,'Nettoor','682040',1,0,'2022-03-03 13:34:27','2022-03-03 13:34:27'),(122880,437,'North End','682009',1,0,'2022-03-03 13:34:27','2022-03-03 13:34:27'),(122881,437,'Ochanthuruth','682508',1,0,'2022-03-03 13:34:27','2022-03-03 13:34:27'),(122882,437,'Pachalam','682012',1,0,'2022-03-03 13:34:27','2022-03-03 13:34:27'),(122883,437,'Paingarapilly','682314',1,0,'2022-03-03 13:34:27','2022-03-03 13:34:27'),(122884,437,'Palarivattom','682025',1,0,'2022-03-03 13:34:27','2022-03-03 13:34:27'),(122885,437,'Palluruthy','682006',1,0,'2022-03-03 13:34:27','2022-03-03 13:34:27'),(122886,437,'Palluruthy South','682006',1,0,'2022-03-03 13:34:27','2022-03-03 13:34:27'),(122887,437,'Panampilly Nagar','682036',1,0,'2022-03-03 13:34:27','2022-03-03 13:34:27'),(122888,437,'Panangad (Ernakulam)','682506',1,0,'2022-03-03 13:34:27','2022-03-03 13:34:27'),(122889,437,'Panayappilly','682002',1,0,'2022-03-03 13:34:27','2022-03-03 13:34:27'),(122890,437,'Pancode','682310',1,0,'2022-03-03 13:34:28','2022-03-03 13:34:28'),(122891,437,'Perumanur','682015',1,0,'2022-03-03 13:34:28','2022-03-03 13:34:28'),(122892,437,'Perumpilly','682314',1,0,'2022-03-03 13:34:28','2022-03-03 13:34:28'),(122893,437,'Pizhala','682027',1,0,'2022-03-03 13:34:28','2022-03-03 13:34:28'),(122894,437,'Poonithura','682038',1,0,'2022-03-03 13:34:28','2022-03-03 13:34:28'),(122895,437,'Poothotta','682307',1,0,'2022-03-03 13:34:28','2022-03-03 13:34:28'),(122896,437,'Poothrikka','682308',1,0,'2022-03-03 13:34:28','2022-03-03 13:34:28'),(122897,437,'Pulickamaly','682314',1,0,'2022-03-03 13:34:28','2022-03-03 13:34:28'),(122898,437,'Puthencruz','682308',1,0,'2022-03-03 13:34:28','2022-03-03 13:34:28'),(122899,437,'Puthuvype','682508',1,0,'2022-03-03 13:34:28','2022-03-03 13:34:28'),(122900,437,'Rajagiri','683104',1,0,'2022-03-03 13:34:28','2022-03-03 13:34:28'),(122901,437,'Rajagiri Valley','682039',1,0,'2022-03-03 13:34:28','2022-03-03 13:34:28'),(122902,437,'S.Chellanam','682008',1,0,'2022-03-03 13:34:28','2022-03-03 13:34:28'),(122903,437,'Shanmugham Road','682031',1,0,'2022-03-03 13:34:28','2022-03-03 13:34:28'),(122904,437,'South Paravoor','682307',1,0,'2022-03-03 13:34:28','2022-03-03 13:34:28'),(122905,437,'Thalacode','682314',1,0,'2022-03-03 13:34:28','2022-03-03 13:34:28'),(122906,437,'Thammanam','682032',1,0,'2022-03-03 13:34:28','2022-03-03 13:34:28'),(122907,437,'Thekkumbhagom','682301',1,0,'2022-03-03 13:34:28','2022-03-03 13:34:28'),(122908,437,'Thengod','682030',1,0,'2022-03-03 13:34:28','2022-03-03 13:34:28'),(122909,437,'Thevara','682013',1,0,'2022-03-03 13:34:29','2022-03-03 13:34:29'),(122910,437,'Thirumarayoor','682313',1,0,'2022-03-03 13:34:29','2022-03-03 13:34:29'),(122911,437,'Thiruvamkulam','682305',1,0,'2022-03-03 13:34:29','2022-03-03 13:34:29'),(122912,437,'Thiruvaniyoor','682308',1,0,'2022-03-03 13:34:29','2022-03-03 13:34:29'),(122913,437,'Thoppumpady','682005',1,0,'2022-03-03 13:34:29','2022-03-03 13:34:29'),(122914,437,'Thrikkakara','682021',1,0,'2022-03-03 13:34:29','2022-03-03 13:34:29'),(122915,437,'Tripunithura Fort','682301',1,0,'2022-03-03 13:34:29','2022-03-03 13:34:29'),(122916,437,'Tripunithura','682301',1,0,'2022-03-03 13:34:29','2022-03-03 13:34:29'),(122917,437,'Udayamperoor','682307',1,0,'2022-03-03 13:34:29','2022-03-03 13:34:29'),(122918,437,'Udyogamandal','683501',1,0,'2022-03-03 13:34:29','2022-03-03 13:34:29'),(122919,437,'Vadacode','682021',1,0,'2022-03-03 13:34:29','2022-03-03 13:34:29'),(122920,437,'Vadacode Kailas Colony','682021',1,0,'2022-03-03 13:34:29','2022-03-03 13:34:29'),(122921,437,'Vadavucode','682310',1,0,'2022-03-03 13:34:29','2022-03-03 13:34:29'),(122922,437,'Vadayampadi','682308',1,0,'2022-03-03 13:34:29','2022-03-03 13:34:29'),(122923,437,'Vaduthala','682023',1,0,'2022-03-03 13:34:29','2022-03-03 13:34:29'),(122924,437,'Vallarpadam','682504',1,0,'2022-03-03 13:34:29','2022-03-03 13:34:29'),(122925,437,'Varikoli','682308',1,0,'2022-03-03 13:34:29','2022-03-03 13:34:29'),(122926,437,'Veliyanad','682313',1,0,'2022-03-03 13:34:29','2022-03-03 13:34:29'),(122927,437,'Vennala','682028',1,0,'2022-03-03 13:34:29','2022-03-03 13:34:29'),(122928,437,'Vettickal','682314',1,0,'2022-03-03 13:34:29','2022-03-03 13:34:29'),(122929,437,'Vyttila','682019',1,0,'2022-03-03 13:34:29','2022-03-03 13:34:29'),(122930,437,'Willingdon Island','682003',1,0,'2022-03-03 13:34:29','2022-03-03 13:34:29'),(122931,437,'Thuruthippuram B.O','680667',1,0,'2022-03-04 19:23:50','2022-03-04 19:23:50'),(122932,438,'Kuppakkayam B.O','686513',1,0,'2022-03-04 19:23:50','2022-03-04 19:23:50'),(122933,438,'Mukkulam B.O','686514',1,0,'2022-03-04 19:23:50','2022-03-04 19:23:50'),(122934,438,'Mukkulam East B.O','686514',1,0,'2022-03-04 19:23:50','2022-03-04 19:23:50'),(122935,438,'Mundakayam East B.O','686513',1,0,'2022-03-04 19:23:50','2022-03-04 19:23:50'),(122936,438,'Wembly B.O','686514',1,0,'2022-03-04 19:23:50','2022-03-04 19:23:50'),(122937,438,'Adimali S.O','685561',1,0,'2022-03-04 19:23:50','2022-03-04 19:23:50'),(122938,438,'Adoormala B.O','685590',1,0,'2022-03-04 19:23:50','2022-03-04 19:23:50'),(122939,438,'Alakode B.O','685588',1,0,'2022-03-04 19:23:50','2022-03-04 19:23:50'),(122940,438,'Alpara B.O','685606',1,0,'2022-03-04 19:23:50','2022-03-04 19:23:50'),(122941,438,'Amaravathy B.O','685509',1,0,'2022-03-04 19:23:50','2022-03-04 19:23:50'),(122942,438,'Amayapra B.O','685595',1,0,'2022-03-04 19:23:50','2022-03-04 19:23:50'),(122943,438,'Anakkara S.O (Idukki)','685512',1,0,'2022-03-04 19:23:50','2022-03-04 19:23:50'),(122944,438,'Anakulam B.O','685565',1,0,'2022-03-04 19:23:50','2022-03-04 19:23:50'),(122945,438,'Anavilasam B.O','685535',1,0,'2022-03-04 19:23:50','2022-03-04 19:23:50'),(122946,438,'Anaviratty B.O','685561',1,0,'2022-03-04 19:23:50','2022-03-04 19:23:50'),(122947,438,'Anayirankal B.O','685613',1,0,'2022-03-04 19:23:50','2022-03-04 19:23:50'),(122948,438,'Anchiri B.O','685585',1,0,'2022-03-04 19:23:50','2022-03-04 19:23:50'),(122949,438,'Anniyartholu B.O','685515',1,0,'2022-03-04 19:23:50','2022-03-04 19:23:50'),(122950,438,'Arakulam S.O','685591',1,0,'2022-03-04 19:23:50','2022-03-04 19:23:50'),(122951,438,'Arikuzha B.O','685608',1,0,'2022-03-04 19:23:50','2022-03-04 19:23:50'),(122952,438,'Arnakal B.O','685533',1,0,'2022-03-04 19:23:50','2022-03-04 19:23:50'),(122953,438,'Aruvilanchal B.O','685619',1,0,'2022-03-04 19:23:50','2022-03-04 19:23:50'),(122954,438,'Attapallam B.O','685509',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122955,438,'Ayyappancoil S.O','685507',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122956,438,'Balagram B.O','685552',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122957,438,'Bethel B.O','685514',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122958,438,'Bisonvalley B.O','685565',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122959,438,'C. Kuthumkal B.O','685566',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122960,438,'Calvari Mount B.O','685515',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122961,438,'Chakkupallam B.O','685509',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122962,438,'Chathurangapara B.O','685554',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122963,438,'Chattamannar B.O','685614',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122964,438,'Cheenikuzhi B.O','685595',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122965,438,'Cheenthalar B.O','685501',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122966,438,'Chelachuvadu B.O','685606',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122967,438,'Chellarcoil B.O','685512',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122968,438,'Chembalam B.O','685553',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122969,438,'Chemmannar B.O','685554',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122970,438,'Chempakapara B.O','685514',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122971,438,'Chenkara B.O','685533',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122972,438,'Cheppukulam B.O','685581',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122973,438,'Chilavu B.O','685588',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122974,438,'Chinnakanal B.O','685618',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122975,438,'Chinnar B.O','685501',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122976,438,'Chithirapuram S.O','685565',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122977,438,'Chottupara B.O','685552',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122978,438,'Chottupara Periyar B.O','685533',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122979,438,'Combayar B.O','685552',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122980,438,'Cumbumbettu B.O','685551',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122981,438,'Devarupara B.O','685588',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122982,438,'Devikulam S.O','685613',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122983,438,'Dymock B.O','685533',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122984,438,'Edad-idukki B.O','685589',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122985,438,'Edamalakudi B.O','685612',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122986,438,'Edavetty B.O','685588',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122987,438,'Elamdesom B.O','685588',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122988,438,'Elappara S.O','685501',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122989,438,'Ellakallu B.O','685565',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122990,438,'Ellapatti S.O','685615',1,0,'2022-03-04 19:23:51','2022-03-04 19:23:51'),(122991,438,'Ellumpuram B.O','685587',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(122992,438,'Erattayar North B.O','685514',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(122993,438,'Erattayar S.O','685514',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(122994,438,'Ettithope B.O','685514',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(122995,438,'Ezhallur B.O','685605',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(122996,438,'Ezhukunvayal B.O','685553',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(122997,438,'Ezhumuttom B.O','685605',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(122998,438,'Fair Field B.O','685501',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(122999,438,'Glenmary B.O','685531',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123000,438,'Gramby B.O','685533',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123001,438,'Gudarle B.O','685612',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123002,438,'Haileyburia B.O','685501',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123003,438,'Idinjamala B.O','685514',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123004,438,'Idukki Colony S.O','685602',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123005,438,'Idukki Painavu S.O','685603',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123006,438,'Ilappally B.O','685589',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123007,438,'Josegiri B.O','685565',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123008,438,'Kadamakuzhy B.O','685515',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123009,438,'Kailasanadu B.O','685553',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123010,438,'Kalayanthani S.O','685588',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123011,438,'Kaliyar B.O','685607',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123012,438,'Kallar S.O','685552',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123013,438,'Kallarkutty S.O','685562',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123014,438,'Kaloor East B.O','685608',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123015,438,'Kalthotty B.O','685507',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123016,438,'Kamakshy B.O','685515',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123017,438,'Kanayankavayal B.O','685532',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123018,438,'Kanchiyar S.O','685511',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123019,438,'Kanjar B.O','685590',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123020,438,'Kanjikuzhi - Idukki S.O','685606',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123021,438,'Kannickal B.O','685589',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123022,438,'Kanthallur B.O','685620',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123023,438,'Karadikuzhy B.O','685531',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123024,438,'Karimannoor S.O','685581',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123025,438,'Karimkulam Chappath B.O','685505',1,0,'2022-03-04 19:23:52','2022-03-04 19:23:52'),(123026,438,'Karimkunnam S.O','685586',1,0,'2022-03-04 19:23:53','2022-03-04 19:23:53'),(123027,438,'Karippalangad B.O','685601',1,0,'2022-03-04 19:23:53','2022-03-04 19:23:53'),(123028,438,'Karunapuram B.O','685552',1,0,'2022-03-04 19:23:53','2022-03-04 19:23:53'),(123029,438,'Kattappana H.O','685508',1,0,'2022-03-04 19:23:53','2022-03-04 19:23:53'),(123030,438,'Kattappana South S.O','685515',1,0,'2022-03-04 19:23:53','2022-03-04 19:23:53'),(123031,438,'Keerikara B.O','685533',1,0,'2022-03-04 19:23:53','2022-03-04 19:23:53'),(123032,438,'Keerithode B.O','685606',1,0,'2022-03-04 19:23:53','2022-03-04 19:23:53'),(123033,438,'Khajanapara B.O','685619',1,0,'2022-03-04 19:23:53','2022-03-04 19:23:53'),(123034,438,'Kochara B.O','685551',1,0,'2022-03-04 19:23:53','2022-03-04 19:23:53'),(123035,438,'Kochukarimtharuvi B.O','685501',1,0,'2022-03-04 19:23:53','2022-03-04 19:23:53'),(123036,438,'Kochuthovala B.O','685514',1,0,'2022-03-04 19:23:53','2022-03-04 19:23:53'),(123037,438,'Kodikulam S.O','685582',1,0,'2022-03-04 19:23:53','2022-03-04 19:23:53'),(123038,438,'Koduveli B.O','685581',1,0,'2022-03-04 19:23:53','2022-03-04 19:23:53'),(123039,438,'Kolahalamedu B.O','685501',1,0,'2022-03-04 19:23:53','2022-03-04 19:23:53'),(123040,438,'Kolani B.O','685608',1,0,'2022-03-04 19:23:53','2022-03-04 19:23:53'),(123041,438,'Konnackamali B.O','685604',1,0,'2022-03-04 19:23:53','2022-03-04 19:23:53'),(123042,438,'Konnathady B.O','685563',1,0,'2022-03-04 19:23:53','2022-03-04 19:23:53'),(123043,438,'Koompanpara B.O','685561',1,0,'2022-03-04 19:23:54','2022-03-04 19:23:54'),(123044,438,'Koottar B.O','685552',1,0,'2022-03-04 19:23:54','2022-03-04 19:23:54'),(123045,438,'Koovakandam B.O','685588',1,0,'2022-03-04 19:23:54','2022-03-04 19:23:54'),(123046,438,'Koovappally-kudayathur B.O','685590',1,0,'2022-03-04 19:23:54','2022-03-04 19:23:54'),(123047,438,'Korangatti B.O','685561',1,0,'2022-03-04 19:23:54','2022-03-04 19:23:54'),(123048,438,'Kottakomboor B.O','685615',1,0,'2022-03-04 19:23:54','2022-03-04 19:23:54'),(123049,438,'Kottamala B.O','685503',1,0,'2022-03-04 19:23:54','2022-03-04 19:23:54'),(123050,438,'Koviloor B.O','685615',1,0,'2022-03-04 19:23:54','2022-03-04 19:23:54'),(123051,438,'Kozhimala B.O','685511',1,0,'2022-03-04 19:23:54','2022-03-04 19:23:54'),(123052,438,'Kudayathur S.O','685590',1,0,'2022-03-04 19:23:54','2022-03-04 19:23:54'),(123053,438,'Kulamavu S.O','685601',1,0,'2022-03-04 19:23:54','2022-03-04 19:23:54'),(123054,438,'Kulaparachal B.O','685619',1,0,'2022-03-04 19:23:54','2022-03-04 19:23:54'),(123055,438,'Kumaramangala B.O','685608',1,0,'2022-03-04 19:23:54','2022-03-04 19:23:54'),(123056,438,'Kumily S.O','685509',1,0,'2022-03-04 19:23:54','2022-03-04 19:23:54'),(123057,438,'Kunchithanni B.O','685565',1,0,'2022-03-04 19:23:54','2022-03-04 19:23:54'),(123058,438,'Kuninji B.O','685583',1,0,'2022-03-04 19:23:54','2022-03-04 19:23:54'),(123059,438,'Kuttikanam B.O','685531',1,0,'2022-03-04 19:23:54','2022-03-04 19:23:54'),(123060,438,'Kuzhithozhu B.O','685551',1,0,'2022-03-04 19:23:54','2022-03-04 19:23:54'),(123061,438,'Lakshmi Coil B.O','685531',1,0,'2022-03-04 19:23:54','2022-03-04 19:23:54'),(123062,438,'Lonetree B.O','685505',1,0,'2022-03-04 19:23:54','2022-03-04 19:23:54'),(123063,438,'Machiplavu B.O','685561',1,0,'2022-03-04 19:23:54','2022-03-04 19:23:54'),(123064,438,'Mailacombu B.O','685608',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123065,438,'Malayinchi B.O','685595',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123066,438,'Mali B.O','685551',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123067,438,'Mammattikanam B.O','685566',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123068,438,'Manakkad B.O','685608',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123069,438,'Manipara B.O','685602',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123070,438,'Maniyaramkudy B.O','685602',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123071,438,'Manjappara B.O','685553',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123072,438,'Mankulam B.O','685565',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123073,438,'Mankuva B.O','685604',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123074,438,'Mannamkandam B.O','685561',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123075,438,'Maraiyur S.O','685620',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123076,438,'Marigiri B.O','685609',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123077,438,'Mariyapuram B.O','685602',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123078,438,'Mathaipara B.O','685505',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123079,438,'Mattupatty ISP B.O','685616',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123080,438,'Mattuppatti S.O','685616',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123081,438,'Mattuthavalam B.O','685505',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123082,438,'Mavady B.O','685553',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123083,438,'Meencut B.O','685565',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123084,438,'Melekuppachampady B.O','685514',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123085,438,'Meloram B.O','685532',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123086,438,'Michaelgiri B.O','685620',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123087,438,'Moolakad B.O','685595',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123088,438,'Moolamattom East B.O','685589',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123089,438,'Moolamattom S.O','685589',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123090,438,'Moongalar B.O','685533',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123091,438,'Mount B.O','685533',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123092,438,'Mrala B.O','685587',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123093,438,'Mukkudam B.O','685562',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123094,438,'Mukkudil B.O','685566',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123095,438,'Mulakaramedu B.O','685515',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123096,438,'Mulakuvally B.O','685602',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123097,438,'Mulappuram B.O','685581',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123098,438,'Mullarikudy B.O','685571',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123099,438,'Mullaringadu B.O','685607',1,0,'2022-03-04 19:23:55','2022-03-04 19:23:55'),(123100,438,'Mundanmudy B.O','685607',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123101,438,'Muniyara B.O','685571',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123102,438,'Munnar Colony B.O','685612',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123103,438,'Munnar S.O','685612',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123104,438,'Murickassery S.O','685604',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123105,438,'Murinjapuzha B.O','685532',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123106,438,'Murukady S.O','685535',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123107,438,'Muthalakodam S.O','685605',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123108,438,'Muttom EK S.O','685587',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123109,438,'N R City B.O','685566',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123110,438,'Narakakanam B.O','685602',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123111,438,'Nariampara B.O','685511',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123112,438,'Nayarupara B.O','685602',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123113,438,'Nediyasala B.O','685608',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123114,438,'Nedumkandam S.O','685553',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123115,438,'Nellipara B.O','685515',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123116,438,'Nettithozhu B.O','685551',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123117,438,'Neyyassery B.O','685581',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123118,438,'Ottalloor B.O','685586',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123119,438,'Pachady B.O','685553',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123120,438,'Pachakanam B.O','685533',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123121,438,'Padamugham B.O','685604',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123122,438,'Padicap B.O','685561',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123123,438,'Pallikunnu B.O','685531',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123124,438,'Pallivasal B.O','685565',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123125,438,'Pallivasal Estate B.O','685612',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123126,438,'Paloorkavu B.O','685532',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123127,438,'Paloorkavu Central B.O','685532',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123128,438,'Pambanar B.O','685531',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123129,438,'Pampa Dam B.O','685533',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123130,438,'Pampadumpara B.O','685553',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123131,438,'Pampupara B.O','685551',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123132,438,'Panamkutty B.O','685562',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123133,438,'Pandipara B.O','685609',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123134,438,'Panickankudy B.O','685571',1,0,'2022-03-04 19:23:56','2022-03-04 19:23:56'),(123135,438,'Panniar Estate B.O','685613',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123136,438,'Pannimattom B.O','685588',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123137,438,'Pannoor B.O','685581',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123138,438,'Parapuzha B.O','685582',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123139,438,'Parathode S.O (Idukki)','685571',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123140,438,'Pasupara B.O','685501',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123141,438,'Pathippally B.O','685589',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123142,438,'Pazhayarikandam B.O','685606',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123143,438,'Peermade S.O','685531',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123144,438,'Perinchankutty B.O','685604',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123145,438,'Peringassery B.O','685595',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123146,438,'Periyar Lake B.O','685509',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123147,438,'Perumpillichira B.O','685605',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123148,438,'Perumthotty B.O','685609',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123149,438,'Peruvanthanam S.O','685532',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123150,438,'Pethotty B.O','685619',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123151,438,'Pius Nagar B.O','685620',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123152,438,'Ponmudi B.O','685563',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123153,438,'Poopara B.O','685619',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123154,438,'Pothamedu B.O','685612',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123155,438,'Pottenkad B.O','685565',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123156,438,'Prakash B.O','685609',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123157,438,'Pulickathotty B.O','685607',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123158,438,'Puliyanmala B.O','685515',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123159,438,'Pullikkanam B.O','685503',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123160,438,'Purapuzha B.O','685583',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123161,438,'Pushpakandam B.O','685552',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123162,438,'Puthady B.O','685619',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123163,438,'Puttady B.O','685551',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123164,438,'Rajakad S.O','685566',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123165,438,'Rajakandam B.O','685551',1,0,'2022-03-04 19:23:57','2022-03-04 19:23:57'),(123166,438,'Rajakumari B.O','685619',1,0,'2022-03-04 19:23:58','2022-03-04 19:23:58'),(123167,438,'Rajakumari South B.O','685619',1,0,'2022-03-04 19:23:58','2022-03-04 19:23:58'),(123168,438,'Rajamudi B.O','685604',1,0,'2022-03-04 19:23:58','2022-03-04 19:23:58'),(123169,438,'Rajapuram B.O','685604',1,0,'2022-03-04 19:23:58','2022-03-04 19:23:58'),(123170,438,'Ramakkal Mettu B.O','685552',1,0,'2022-03-04 19:23:58','2022-03-04 19:23:58'),(123171,438,'Sahayagiri B.O','685620',1,0,'2022-03-04 19:23:58','2022-03-04 19:23:58'),(123172,438,'Sanniasioda B.O','685552',1,0,'2022-03-04 19:23:58','2022-03-04 19:23:58'),(123173,438,'Santhanpara S.O','685619',1,0,'2022-03-04 19:23:58','2022-03-04 19:23:58'),(123174,438,'Santhigram B.O','685514',1,0,'2022-03-04 19:23:58','2022-03-04 19:23:58'),(123175,438,'Sasthanoda B.O','685535',1,0,'2022-03-04 19:23:58','2022-03-04 19:23:58'),(123176,438,'Selliampara B.O','685563',1,0,'2022-03-04 19:23:58','2022-03-04 19:23:58'),(123177,438,'Senapathy B.O','685619',1,0,'2022-03-04 19:23:58','2022-03-04 19:23:58'),(123178,438,'Sengulam B.O','685565',1,0,'2022-03-04 19:23:58','2022-03-04 19:23:58'),(123179,438,'Sethuparvathipuram B.O','685615',1,0,'2022-03-04 19:23:58','2022-03-04 19:23:58'),(123180,438,'Sinkukandam B.O','685618',1,0,'2022-03-04 19:23:58','2022-03-04 19:23:58'),(123181,438,'South Kathipara B.O','685562',1,0,'2022-03-04 19:23:58','2022-03-04 19:23:58'),(123182,438,'Springvalley B.O','685509',1,0,'2022-03-04 19:23:58','2022-03-04 19:23:58'),(123183,438,'Surianalle S.O','685618',1,0,'2022-03-04 19:23:58','2022-03-04 19:23:58'),(123184,438,'Talliar S.O','685614',1,0,'2022-03-04 19:23:58','2022-03-04 19:23:58'),(123185,438,'Thadiampadu B.O','685602',1,0,'2022-03-04 19:23:58','2022-03-04 19:23:58'),(123186,438,'Thankamany S.O','685609',1,0,'2022-03-04 19:23:58','2022-03-04 19:23:58'),(123187,438,'Thattakuzha B.O','685581',1,0,'2022-03-04 19:23:58','2022-03-04 19:23:58'),(123188,438,'Thattarathatta B.O','685586',1,0,'2022-03-04 19:23:58','2022-03-04 19:23:58'),(123189,438,'Thattekanni B.O','685606',1,0,'2022-03-04 19:23:58','2022-03-04 19:23:58'),(123190,438,'Thekkady B.O','685509',1,0,'2022-03-04 19:23:58','2022-03-04 19:23:58'),(123191,438,'Thekkumbhagam B.O','685585',1,0,'2022-03-04 19:23:59','2022-03-04 19:23:59'),(123192,438,'Thengakal B.O','685533',1,0,'2022-03-04 19:23:59','2022-03-04 19:23:59'),(123193,438,'Thodupuzha East S.O','685585',1,0,'2022-03-04 19:23:59','2022-03-04 19:23:59'),(123194,438,'Thodupuzha H.O','685584',1,0,'2022-03-04 19:23:59','2022-03-04 19:23:59'),(123195,438,'Thodupuzha -puthuperiyaram B.O','685608',1,0,'2022-03-04 19:23:59','2022-03-04 19:23:59'),(123196,438,'Thodupuzha West S.O','685584',1,0,'2022-03-04 19:23:59','2022-03-04 19:23:59'),(123197,438,'Thokkupara B.O','685565',1,0,'2022-03-04 19:23:59','2022-03-04 19:23:59'),(123198,438,'Thommankuthu B.O','685581',1,0,'2022-03-04 19:23:59','2022-03-04 19:23:59'),(123199,438,'Thoppipala B.O','685511',1,0,'2022-03-04 19:23:59','2022-03-04 19:23:59'),(123200,438,'Thopramkduy B.O','685609',1,0,'2022-03-04 19:23:59','2022-03-04 19:23:59'),(123201,438,'Thovarayar B.O','685511',1,0,'2022-03-04 19:23:59','2022-03-04 19:23:59'),(123202,438,'Thudanganad B.O','685587',1,0,'2022-03-04 19:23:59','2022-03-04 19:23:59'),(123203,438,'Udumbanchola S.O','685554',1,0,'2022-03-04 19:23:59','2022-03-04 19:23:59'),(123204,438,'Udumbannur S.O','685595',1,0,'2022-03-04 19:23:59','2022-03-04 19:23:59'),(123205,438,'Uppukandam B.O','685514',1,0,'2022-03-04 19:23:59','2022-03-04 19:23:59'),(123206,438,'Upputhara S.O','685505',1,0,'2022-03-04 19:23:59','2022-03-04 19:23:59'),(123207,438,'Upputhode B.O','685604',1,0,'2022-03-04 19:23:59','2022-03-04 19:23:59'),(123208,438,'Vadakkummury B.O','685586',1,0,'2022-03-04 19:23:59','2022-03-04 19:23:59'),(123209,438,'Vagamon S.O','685503',1,0,'2022-03-04 19:23:59','2022-03-04 19:23:59'),(123210,438,'Valara B.O','685561',1,0,'2022-03-04 19:23:59','2022-03-04 19:23:59'),(123211,438,'Valiyathovala B.O','685514',1,0,'2022-03-04 19:23:59','2022-03-04 19:23:59'),(123212,438,'Vallakadavu Periyar B.O','685533',1,0,'2022-03-04 19:23:59','2022-03-04 19:23:59'),(123213,438,'Vandamattom B.O','685582',1,0,'2022-03-04 19:23:59','2022-03-04 19:23:59'),(123214,438,'Vandanmettu S.O','685551',1,0,'2022-03-04 19:23:59','2022-03-04 19:23:59'),(123215,438,'Vandiperiyar S.O','685533',1,0,'2022-03-04 19:23:59','2022-03-04 19:23:59'),(123216,438,'Vannapuram S.O','685607',1,0,'2022-03-04 19:23:59','2022-03-04 19:23:59'),(123217,438,'Vattappara (UBC) B.O','685619',1,0,'2022-03-04 19:24:00','2022-03-04 19:24:00'),(123218,438,'Vattiar B.O','685565',1,0,'2022-03-04 19:24:00','2022-03-04 19:24:00'),(123219,438,'Vazhavara B.O','685515',1,0,'2022-03-04 19:24:00','2022-03-04 19:24:00'),(123220,438,'Vazhithala S.O','685583',1,0,'2022-03-04 19:24:00','2022-03-04 19:24:00'),(123221,438,'Vellaramkunnu B.O','685535',1,0,'2022-03-04 19:24:00','2022-03-04 19:24:00'),(123222,438,'Vellathooval S.O','685563',1,0,'2022-03-04 19:24:00','2022-03-04 19:24:00'),(123223,438,'Vellayamkudy B.O','685515',1,0,'2022-03-04 19:24:00','2022-03-04 19:24:00'),(123224,438,'Velliyamattom B.O','685588',1,0,'2022-03-04 19:24:00','2022-03-04 19:24:00'),(123225,438,'Vengallur S.O','685608',1,0,'2022-03-04 19:24:00','2022-03-04 19:24:00'),(123226,438,'Venmony B.O','685606',1,0,'2022-03-04 19:24:00','2022-03-04 19:24:00'),(123227,438,'Vimalagiri B.O','685602',1,0,'2022-03-04 19:24:00','2022-03-04 19:24:00'),(123228,438,'Wallardie B.O','685533',1,0,'2022-03-04 19:24:00','2022-03-04 19:24:00'),(123229,438,'West Kodikulam B.O','685582',1,0,'2022-03-04 19:24:00','2022-03-04 19:24:00'),(123230,439,'Alakode S.O','670571',1,0,'2022-03-04 19:24:00','2022-03-04 19:24:00'),(123231,439,'Alakode-kuttaramba B.O','670571',1,0,'2022-03-04 19:24:00','2022-03-04 19:24:00'),(123232,439,'Alavil S.O','670008',1,0,'2022-03-04 19:24:00','2022-03-04 19:24:00'),(123233,439,'Anchampeedika B.O','670331',1,0,'2022-03-04 19:24:00','2022-03-04 19:24:00'),(123234,439,'Anjarakandy S.O','670612',1,0,'2022-03-04 19:24:00','2022-03-04 19:24:00'),(123235,439,'Annur B.O','670307',1,0,'2022-03-04 19:24:00','2022-03-04 19:24:00'),(123236,439,'Arang B.O','670582',1,0,'2022-03-04 19:24:00','2022-03-04 19:24:00'),(123237,439,'Areekamala B.O','670582',1,0,'2022-03-04 19:24:00','2022-03-04 19:24:00'),(123238,439,'Aril B.O','670143',1,0,'2022-03-04 19:24:00','2022-03-04 19:24:00'),(123239,439,'Arivilanjapoyil B.O','670571',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123240,439,'Aroli B.O','670561',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123241,439,'Attadappa B.O','670006',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123242,439,'Azhikkal B.O','670009',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123243,439,'Azhikode S.O','670009',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123244,439,'Azhikode South B.O','670009',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123245,439,'Bavode B.O','670622',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123246,439,'Burnacherry S.O','670013',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123247,439,'Chala East B.O','670621',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123248,439,'Chalad S.O','670014',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123249,439,'Chalakkode B.O','670307',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123250,439,'Chamathachal B.O','670633',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123251,439,'Chandanakampara B.O','670633',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123252,439,'Chattuvapara B.O','670592',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123253,439,'Chekkikulam B.O','670592',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123254,439,'Cheleri B.O','670604',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123255,439,'Chempanthotty B.O','670631',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123256,439,'Chemperi S.O','670632',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123257,439,'Chengalayi B.O','670631',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123258,439,'Chepparapadava S.O','670581',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123259,439,'Cherikode B.O','670631',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123260,439,'Cherukun R.S. B.O','670301',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123261,439,'Cherukunnu S.O','670301',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123262,439,'Cherupazhassi B.O','670601',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123263,439,'Cherupuzha S.O','670511',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123264,439,'Chirakk R.S. B.O','670011',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123265,439,'Chirakkal S.O','670011',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123266,439,'Chithapilapoyil B.O','670502',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123267,439,'Chittodi B.O','670571',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123268,439,'Chovva S.O','670006',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123269,439,'Chunda B.O','670511',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123270,439,'Chundakunnu B.O','670632',1,0,'2022-03-04 19:24:01','2022-03-04 19:24:01'),(123271,439,'Chuzhali B.O','670142',1,0,'2022-03-04 19:24:02','2022-03-04 19:24:02'),(123272,439,'Civil Station Kannur S.O','670002',1,0,'2022-03-04 19:24:02','2022-03-04 19:24:02'),(123273,439,'CRPF Camp Aravanchal S.O','670353',1,0,'2022-03-04 19:24:02','2022-03-04 19:24:02'),(123274,439,'Eachur S.O','670591',1,0,'2022-03-04 19:24:02','2022-03-04 19:24:02'),(123275,439,'Edakkom B.O','670581',1,0,'2022-03-04 19:24:02','2022-03-04 19:24:02'),(123276,439,'Edat S.O','670327',1,0,'2022-03-04 19:24:02','2022-03-04 19:24:02'),(123277,439,'Edavaramba B.O','670511',1,0,'2022-03-04 19:24:02','2022-03-04 19:24:02'),(123278,439,'Edayannur S.O','670595',1,0,'2022-03-04 19:24:03','2022-03-04 19:24:03'),(123279,439,'Elampara B.O','670595',1,0,'2022-03-04 19:24:03','2022-03-04 19:24:03'),(123280,439,'Eramam Desom B.O','670307',1,0,'2022-03-04 19:24:03','2022-03-04 19:24:03'),(123281,439,'Eriam B.O','670306',1,0,'2022-03-04 19:24:03','2022-03-04 19:24:03'),(123282,439,'Eruvassi B.O','670632',1,0,'2022-03-04 19:24:03','2022-03-04 19:24:03'),(123283,439,'Eruvatty-chapparapadava B.O','670581',1,0,'2022-03-04 19:24:03','2022-03-04 19:24:03'),(123284,439,'Ettikulam B.O','670308',1,0,'2022-03-04 19:24:03','2022-03-04 19:24:03'),(123285,439,'Ettukudukka B.O','670521',1,0,'2022-03-04 19:24:03','2022-03-04 19:24:03'),(123286,439,'Ezhilode B.O','670309',1,0,'2022-03-04 19:24:03','2022-03-04 19:24:03'),(123287,439,'Ezhimala Naval Academy S.O','670310',1,0,'2022-03-04 19:24:03','2022-03-04 19:24:03'),(123288,439,'Ezhome S.O','670334',1,0,'2022-03-04 19:24:03','2022-03-04 19:24:03'),(123289,439,'Irinavu B.O','670301',1,0,'2022-03-04 19:24:03','2022-03-04 19:24:03'),(123290,439,'Iriveri B.O','670613',1,0,'2022-03-04 19:24:03','2022-03-04 19:24:03'),(123291,439,'Irukkur S.O','670593',1,0,'2022-03-04 19:24:03','2022-03-04 19:24:03'),(123292,439,'Josegiri B.O','670511',1,0,'2022-03-04 19:24:03','2022-03-04 19:24:03'),(123293,439,'Kadachira S.O','670621',1,0,'2022-03-04 19:24:03','2022-03-04 19:24:03'),(123294,439,'Kadannapally B.O','670504',1,0,'2022-03-04 19:24:03','2022-03-04 19:24:03'),(123295,439,'Kaithapram B.O','670631',1,0,'2022-03-04 19:24:03','2022-03-04 19:24:03'),(123296,439,'Kakkara B.O','670306',1,0,'2022-03-04 19:24:03','2022-03-04 19:24:03'),(123297,439,'Kakkat S.O','670005',1,0,'2022-03-04 19:24:04','2022-03-04 19:24:04'),(123298,439,'Kalliad B.O','670593',1,0,'2022-03-04 19:24:04','2022-03-04 19:24:04'),(123299,439,'Kalliasseri S.O','670562',1,0,'2022-03-04 19:24:04','2022-03-04 19:24:04'),(123300,439,'Kanamvayal B.O','670511',1,0,'2022-03-04 19:24:04','2022-03-04 19:24:04'),(123301,439,'Kanayi B.O','670307',1,0,'2022-03-04 19:24:04','2022-03-04 19:24:04'),(123302,439,'Kandakai B.O','670602',1,0,'2022-03-04 19:24:04','2022-03-04 19:24:04'),(123303,439,'Kandankali B.O','670307',1,0,'2022-03-04 19:24:04','2022-03-04 19:24:04'),(123304,439,'Kandoth B.O','670307',1,0,'2022-03-04 19:24:04','2022-03-04 19:24:04'),(123305,439,'Kanhirangad B.O','670142',1,0,'2022-03-04 19:24:04','2022-03-04 19:24:04'),(123306,439,'Kanhirode B.O','670592',1,0,'2022-03-04 19:24:04','2022-03-04 19:24:04'),(123307,439,'Kanjirakolly B.O','670633',1,0,'2022-03-04 19:24:04','2022-03-04 19:24:04'),(123308,439,'Kankol B.O','670307',1,0,'2022-03-04 19:24:04','2022-03-04 19:24:04'),(123309,439,'Kannadiparamba S.O','670604',1,0,'2022-03-04 19:24:04','2022-03-04 19:24:04'),(123310,439,'Kannookara B.O','670012',1,0,'2022-03-04 19:24:04','2022-03-04 19:24:04'),(123311,439,'Kannur City S.O','670003',1,0,'2022-03-04 19:24:04','2022-03-04 19:24:04'),(123312,439,'Kannur District Hospital S.O','670017',1,0,'2022-03-04 19:24:04','2022-03-04 19:24:04'),(123313,439,'Kannur H.O','670001',1,0,'2022-03-04 19:24:04','2022-03-04 19:24:04'),(123314,439,'Kannur Railway Station S.O','670001',1,0,'2022-03-04 19:24:04','2022-03-04 19:24:04'),(123315,439,'Kannur Thana S.O','670012',1,0,'2022-03-04 19:24:04','2022-03-04 19:24:04'),(123316,439,'Kannur University Campus S.O','670567',1,0,'2022-03-04 19:24:04','2022-03-04 19:24:04'),(123317,439,'Kanul B.O','670562',1,0,'2022-03-04 19:24:04','2022-03-04 19:24:04'),(123318,439,'Kappad B.O','670006',1,0,'2022-03-04 19:24:04','2022-03-04 19:24:04'),(123319,439,'Karanthat B.O','670308',1,0,'2022-03-04 19:24:04','2022-03-04 19:24:04'),(123320,439,'Karimbam S.O','670142',1,0,'2022-03-04 19:24:04','2022-03-04 19:24:04'),(123321,439,'Karippal B.O','670581',1,0,'2022-03-04 19:24:05','2022-03-04 19:24:05'),(123322,439,'Karivellur S.O','670521',1,0,'2022-03-04 19:24:05','2022-03-04 19:24:05'),(123323,439,'Karthikapuram B.O','670571',1,0,'2022-03-04 19:24:05','2022-03-04 19:24:05'),(123324,439,'Karuvanchal B.O','670571',1,0,'2022-03-04 19:24:05','2022-03-04 19:24:05'),(123325,439,'Katalayi B.O','670003',1,0,'2022-03-04 19:24:05','2022-03-04 19:24:05'),(123326,439,'Kattampally B.O','670011',1,0,'2022-03-04 19:24:05','2022-03-04 19:24:05'),(123327,439,'Kavvayi B.O','670307',1,0,'2022-03-04 19:24:05','2022-03-04 19:24:05'),(123328,439,'Kayalampara B.O','670632',1,0,'2022-03-04 19:24:05','2022-03-04 19:24:05'),(123329,439,'Kayaralam B.O','670602',1,0,'2022-03-04 19:24:05','2022-03-04 19:24:05'),(123330,439,'Keezhara B.O','670301',1,0,'2022-03-04 19:24:05','2022-03-04 19:24:05'),(123331,439,'Kezhallur B.O','670612',1,0,'2022-03-04 19:24:05','2022-03-04 19:24:05'),(123332,439,'Kizhunna B.O','670007',1,0,'2022-03-04 19:24:05','2022-03-04 19:24:05'),(123333,439,'Kokkanisseri S.O','670307',1,0,'2022-03-04 19:24:05','2022-03-04 19:24:05'),(123334,439,'Kolacherry S.O','670601',1,0,'2022-03-04 19:24:05','2022-03-04 19:24:05'),(123335,439,'Koodali S.O','670592',1,0,'2022-03-04 19:24:05','2022-03-04 19:24:05'),(123336,439,'Kootumugham B.O','670631',1,0,'2022-03-04 19:24:05','2022-03-04 19:24:05'),(123337,439,'Kooveri B.O','670581',1,0,'2022-03-04 19:24:05','2022-03-04 19:24:05'),(123338,439,'Korom B.O','670307',1,0,'2022-03-04 19:24:05','2022-03-04 19:24:05'),(123339,439,'Kottali B.O','670005',1,0,'2022-03-04 19:24:05','2022-03-04 19:24:05'),(123340,439,'Kottayad B.O','670571',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123341,439,'Kottila B.O','670334',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123342,439,'Kovvapuram B.O','670309',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123343,439,'Koyyam B.O','670142',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123344,439,'Koyyode B.O','670621',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123345,439,'Kozhichal B.O','670511',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123346,439,'Kozhummal B.O','670521',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123347,439,'Kudiyanmala B.O','670582',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123348,439,'Kunhimangalam S.O','670309',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123349,439,'Kuniyampuzha B.O','670632',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123350,439,'Kuniyan B.O','670521',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123351,439,'Kuppam-taliparamba B.O','670502',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123352,439,'Kurumathur B.O','670142',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123353,439,'Kusavanvayal B.O','670593',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123354,439,'Kuttikol B.O','670562',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123355,439,'Kuttiyattur B.O','670602',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123356,439,'Kuttiyeri B.O','670142',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123357,439,'Kuttur B.O','670306',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123358,439,'Madayi S.O','670304',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123359,439,'Makreri B.O','670622',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123360,439,'Malapattam B.O','670631',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123361,439,'Mamba S.O','670611',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123362,439,'Manakadavu B.O','670571',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123363,439,'Mandalam B.O','670582',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123364,439,'Mandur-kannur S.O','670501',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123365,439,'Mathamangalam B.O','670306',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123366,439,'Mathamangalam Bazar S.O','670306',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123367,439,'Mathil B.O','670307',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123368,439,'Mattul North S.O','670325',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123369,439,'Mattul S.O','670302',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123370,439,'Mavilayi B.O','670622',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123371,439,'Mayyil S.O','670602',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123372,439,'Morazha B.O','670331',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123373,439,'Mottammal S.O','670331',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123374,439,'Mowancheri S.O','670613',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123375,439,'Mullakodi B.O','670602',1,0,'2022-03-04 19:24:06','2022-03-04 19:24:06'),(123376,439,'Mundalur S.O','670622',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123377,439,'Mundayad B.O','670594',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123378,439,'Munderi B.O','670591',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123379,439,'Muringeri B.O','670612',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123380,439,'Muyyam B.O','670142',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123381,439,'Muzhappala B.O','670611',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123382,439,'Naduvil S.O','670582',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123383,439,'Nanichery B.O','670563',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123384,439,'Narath B.O','670601',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123385,439,'Nareekamvally B.O','670504',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123386,439,'Nediyenga B.O','670631',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123387,439,'Nedungome B.O','670631',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123388,439,'Nellikutty B.O','670632',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123389,439,'Nellipara B.O','670571',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123390,439,'Nhekly B.O','670307',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123391,439,'Olayampadi B.O','670306',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123392,439,'Othayammadom B.O','670301',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123393,439,'Ottathai B.O','670571',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123394,439,'Padappangad B.O','670581',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123395,439,'Padiotchal B.O','670307',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123396,439,'Palakkode B.O','670305',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123397,439,'Pallikunnu S.O','670004',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123398,439,'Pallivayal B.O','670142',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123399,439,'Panapuzha B.O','670306',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123400,439,'Panniyur B.O','670142',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123401,439,'Pappinisseri S.O','670561',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123402,439,'Pappinisseri West B.O','670561',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123403,439,'Parassinikadavu S.O','670563',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123404,439,'Pariyaram Medical College S.O','670503',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123405,439,'Pariyaram-kannur S.O','670502',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123406,439,'Pathampara B.O','670571',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123407,439,'Pattanur B.O','670595',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123408,439,'Pattuvam S.O','670143',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123409,439,'Pavanoormotta B.O','670602',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123410,439,'Payangadi R S S.O','670358',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123411,439,'Payangadi S.O','670303',1,0,'2022-03-04 19:24:07','2022-03-04 19:24:07'),(123412,439,'Payyambalam S.O','670001',1,0,'2022-03-04 19:24:08','2022-03-04 19:24:08'),(123413,439,'Payyan R.S. B.O','670307',1,0,'2022-03-04 19:24:08','2022-03-04 19:24:08'),(123414,439,'Payyanur S.O','670307',1,0,'2022-03-04 19:24:08','2022-03-04 19:24:08'),(123415,439,'Payyavur S.O','670633',1,0,'2022-03-04 19:24:08','2022-03-04 19:24:08'),(123416,439,'Pazhassikari B.O','670633',1,0,'2022-03-04 19:24:08','2022-03-04 19:24:08'),(123417,439,'Peringome B.O','670307',1,0,'2022-03-04 19:24:08','2022-03-04 19:24:08'),(123418,439,'Peruvalathuparamba B.O','670593',1,0,'2022-03-04 19:24:08','2022-03-04 19:24:08'),(123419,439,'Pilathara S.O','670504',1,0,'2022-03-04 19:24:08','2022-03-04 19:24:08'),(123420,439,'Poduvachery B.O','670621',1,0,'2022-03-04 19:24:08','2022-03-04 19:24:08'),(123421,439,'Porakunnu B.O','670306',1,0,'2022-03-04 19:24:08','2022-03-04 19:24:08'),(123422,439,'Pottampilavu B.O','670582',1,0,'2022-03-04 19:24:08','2022-03-04 19:24:08'),(123423,439,'Prapoyil B.O','670511',1,0,'2022-03-04 19:24:08','2022-03-04 19:24:08'),(123424,439,'Pulikurumba B.O','670582',1,0,'2022-03-04 19:24:08','2022-03-04 19:24:08'),(123425,439,'Ramanthali S.O','670308',1,0,'2022-03-04 19:24:08','2022-03-04 19:24:08'),(123426,439,'Rayarom B.O','670571',1,0,'2022-03-04 19:24:08','2022-03-04 19:24:08'),(123427,439,'Sreekandapuram S.O','670631',1,0,'2022-03-04 19:24:08','2022-03-04 19:24:08'),(123428,439,'Sreestha B.O','670303',1,0,'2022-03-04 19:24:08','2022-03-04 19:24:08'),(123429,439,'Talap S.O (Kannur)','670002',1,0,'2022-03-04 19:24:08','2022-03-04 19:24:08'),(123430,439,'Taliparamba H.O','670141',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123431,439,'Thabore B.O','670511',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123432,439,'Thadikadavu B.O','670581',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123433,439,'Thattummal B.O','670511',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123434,439,'Thavam B.O','670301',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123435,439,'Thayyil B.O','670003',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123436,439,'Thazhe Chovva S.O','670018',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123437,439,'Thekkumbad B.O','670301',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123438,439,'Therthally B.O','670571',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123439,439,'Thimiri-chepparapadava B.O','670581',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123440,439,'Thirumeni B.O','670511',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123441,439,'Thiruvattoor B.O','670502',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123442,439,'Thottada S.O','670007',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123443,439,'Thrichambaram B.O','670141',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123444,439,'Udayagiri B.O','670571',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123445,439,'Vadakkumbad-ramanthali B.O','670308',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123446,439,'Valapattanam S.O','670010',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123447,439,'Varam S.O','670594',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123448,439,'Vayattuparamba B.O','670582',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123449,439,'Vellad B.O','670571',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123450,439,'Vellora B.O','670306',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123451,439,'Vellur B.O','670307',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123452,439,'Vengad B.O','670612',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123453,439,'Vengara-kannur S.O','670305',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123454,439,'Vijayagiri B.O','670571',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123455,439,'Vilayancode B.O','670504',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123456,439,'Alacherry B.O','670650',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123457,439,'Ambayathode B.O','670651',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123458,439,'Ambilat B.O','670701',1,0,'2022-03-04 19:24:09','2022-03-04 19:24:09'),(123459,439,'Angadikadavu B.O','670706',1,0,'2022-03-04 19:24:10','2022-03-04 19:24:10'),(123460,439,'Aniyaram B.O','670672',1,0,'2022-03-04 19:24:10','2022-03-04 19:24:10'),(123461,439,'Arabi B.O','670705',1,0,'2022-03-04 19:24:10','2022-03-04 19:24:10'),(123462,439,'Aralam B.O','670704',1,0,'2022-03-04 19:24:10','2022-03-04 19:24:10'),(123463,439,'Aralam Farm B.O','670673',1,0,'2022-03-04 19:24:10','2022-03-04 19:24:10'),(123464,439,'Atakkathode B.O','670674',1,0,'2022-03-04 19:24:10','2022-03-04 19:24:10'),(123465,439,'Ayithara Mambram B.O','670643',1,0,'2022-03-04 19:24:10','2022-03-04 19:24:10'),(123466,439,'Chalil S.O','670102',1,0,'2022-03-04 19:24:10','2022-03-04 19:24:10'),(123467,439,'Champad S.O','670694',1,0,'2022-03-04 19:24:10','2022-03-04 19:24:10'),(123468,439,'Charal B.O','670706',1,0,'2022-03-04 19:24:10','2022-03-04 19:24:10'),(123469,439,'Chavasseri B.O','670702',1,0,'2022-03-04 19:24:10','2022-03-04 19:24:10'),(123470,439,'Chendayad B.O','670692',1,0,'2022-03-04 19:24:10','2022-03-04 19:24:10'),(123471,439,'Cherakkara S.O','670104',1,0,'2022-03-04 19:24:10','2022-03-04 19:24:10'),(123472,439,'Cheruparamba B.O','670693',1,0,'2022-03-04 19:24:10','2022-03-04 19:24:10'),(123473,439,'Cheruvancheri B.O','670650',1,0,'2022-03-04 19:24:10','2022-03-04 19:24:10'),(123474,439,'Chettiamparamba B.O','670674',1,0,'2022-03-04 19:24:10','2022-03-04 19:24:10'),(123475,439,'Chittariparamba S.O','670650',1,0,'2022-03-04 19:24:10','2022-03-04 19:24:10'),(123476,439,'Chokli S.O','670672',1,0,'2022-03-04 19:24:10','2022-03-04 19:24:10'),(123477,439,'Chunkakunnu B.O','670651',1,0,'2022-03-04 19:24:11','2022-03-04 19:24:11'),(123478,439,'Dharmadam S.O','670106',1,0,'2022-03-04 19:24:11','2022-03-04 19:24:11'),(123479,439,'Edapuzha B.O','670704',1,0,'2022-03-04 19:24:11','2022-03-04 19:24:11'),(123480,439,'Elangot B.O','670692',1,0,'2022-03-04 19:24:11','2022-03-04 19:24:11'),(123481,439,'Eranholi S.O','670107',1,0,'2022-03-04 19:24:11','2022-03-04 19:24:11'),(123482,439,'Eruvatty B.O','670642',1,0,'2022-03-04 19:24:11','2022-03-04 19:24:11'),(123483,439,'Etakkad S.O','670663',1,0,'2022-03-04 19:24:11','2022-03-04 19:24:11'),(123484,439,'Iritty S.O','670703',1,0,'2022-03-04 19:24:11','2022-03-04 19:24:11'),(123485,439,'Kacherikadavu B.O','670706',1,0,'2022-03-04 19:24:11','2022-03-04 19:24:11'),(123486,439,'Kadambur-kannur B.O','670663',1,0,'2022-03-04 19:24:11','2022-03-04 19:24:11'),(123487,439,'Kadavathur S.O','670676',1,0,'2022-03-04 19:24:11','2022-03-04 19:24:11'),(123488,439,'Kadirur-tly S.O','670642',1,0,'2022-03-04 19:24:11','2022-03-04 19:24:11'),(123489,439,'Kakkengad B.O','670673',1,0,'2022-03-04 19:24:11','2022-03-04 19:24:11'),(123490,439,'Kalanki B.O','670705',1,0,'2022-03-04 19:24:11','2022-03-04 19:24:11'),(123491,439,'Kallikandy B.O','670693',1,0,'2022-03-04 19:24:11','2022-03-04 19:24:11'),(123492,439,'Kalluvayal B.O','670703',1,0,'2022-03-04 19:24:11','2022-03-04 19:24:11'),(123493,439,'Kanhileri B.O','670702',1,0,'2022-03-04 19:24:11','2022-03-04 19:24:11'),(123494,439,'Kanichar B.O','670674',1,0,'2022-03-04 19:24:11','2022-03-04 19:24:11'),(123495,439,'Kannavam Colony B.O','670650',1,0,'2022-03-04 19:24:11','2022-03-04 19:24:11'),(123496,439,'Kannoth B.O','670650',1,0,'2022-03-04 19:24:11','2022-03-04 19:24:11'),(123497,439,'Kara- Peravoor B.O','670702',1,0,'2022-03-04 19:24:11','2022-03-04 19:24:11'),(123498,439,'Kariyad South S.O','673316',1,0,'2022-03-04 19:24:11','2022-03-04 19:24:11'),(123499,439,'Kavumbhagam B.O','670649',1,0,'2022-03-04 19:24:12','2022-03-04 19:24:12'),(123500,439,'Kayani B.O','670702',1,0,'2022-03-04 19:24:12','2022-03-04 19:24:12'),(123501,439,'Keecheri B.O','670702',1,0,'2022-03-04 19:24:12','2022-03-04 19:24:12'),(123502,439,'Keezhpalli B.O','670704',1,0,'2022-03-04 19:24:12','2022-03-04 19:24:12'),(123503,439,'Keezhur-iritty B.O','670703',1,0,'2022-03-04 19:24:12','2022-03-04 19:24:12'),(123504,439,'Kelakam S.O','670674',1,0,'2022-03-04 19:24:12','2022-03-04 19:24:12'),(123505,439,'Kidanhi B.O','670675',1,0,'2022-03-04 19:24:12','2022-03-04 19:24:12'),(123506,439,'Kiliyanthara S.O','670706',1,0,'2022-03-04 19:24:12','2022-03-04 19:24:12'),(123507,439,'Kizhakke Kadirur B.O','670642',1,0,'2022-03-04 19:24:12','2022-03-04 19:24:12'),(123508,439,'Kolakkad B.O','670673',1,0,'2022-03-04 19:24:12','2022-03-04 19:24:12'),(123509,439,'Kolari B.O','670702',1,0,'2022-03-04 19:24:12','2022-03-04 19:24:12'),(123510,439,'Kolayad B.O','670650',1,0,'2022-03-04 19:24:12','2022-03-04 19:24:12'),(123511,439,'Kolithattu B.O','670706',1,0,'2022-03-04 19:24:12','2022-03-04 19:24:12'),(123512,439,'Koomanthode B.O','670704',1,0,'2022-03-04 19:24:12','2022-03-04 19:24:12'),(123513,439,'Koorara B.O','670694',1,0,'2022-03-04 19:24:12','2022-03-04 19:24:12'),(123514,439,'Koottupuzha B.O','670706',1,0,'2022-03-04 19:24:12','2022-03-04 19:24:12'),(123515,439,'Kottayam Malabar B.O','670643',1,0,'2022-03-04 19:24:12','2022-03-04 19:24:12'),(123516,439,'Kottayampoil B.O','670691',1,0,'2022-03-04 19:24:12','2022-03-04 19:24:12'),(123517,439,'Kottiyur S.O','670651',1,0,'2022-03-04 19:24:13','2022-03-04 19:24:13'),(123518,439,'Kurichiyil B.O','670102',1,0,'2022-03-04 19:24:13','2022-03-04 19:24:13'),(123519,439,'Kuthuparamba S.O','670643',1,0,'2022-03-04 19:24:13','2022-03-04 19:24:13'),(123520,439,'Kuttikkakam B.O','670663',1,0,'2022-03-04 19:24:13','2022-03-04 19:24:13'),(123521,439,'Madathil B.O','670703',1,0,'2022-03-04 19:24:13','2022-03-04 19:24:13'),(123522,439,'Malayampadi B.O','670674',1,0,'2022-03-04 19:24:13','2022-03-04 19:24:13'),(123523,439,'Mallannur B.O','670701',1,0,'2022-03-04 19:24:13','2022-03-04 19:24:13'),(123524,439,'Malur B.O','670702',1,0,'2022-03-04 19:24:13','2022-03-04 19:24:13'),(123525,439,'Mambram B.O','670741',1,0,'2022-03-04 19:24:13','2022-03-04 19:24:13'),(123526,439,'Manantheri B.O','670643',1,0,'2022-03-04 19:24:13','2022-03-04 19:24:13'),(123527,439,'Manathana B.O','670674',1,0,'2022-03-04 19:24:13','2022-03-04 19:24:13'),(123528,439,'Mangattidam B.O','670643',1,0,'2022-03-04 19:24:13','2022-03-04 19:24:13'),(123529,439,'Manikkadavu B.O','670705',1,0,'2022-03-04 19:24:13','2022-03-04 19:24:13'),(123530,439,'Manippara B.O','670705',1,0,'2022-03-04 19:24:13','2022-03-04 19:24:13'),(123531,439,'Mattanur College B.O','670702',1,0,'2022-03-04 19:24:13','2022-03-04 19:24:13'),(123532,439,'Mattanur S.O','670702',1,0,'2022-03-04 19:24:13','2022-03-04 19:24:13'),(123533,439,'Mekkunnu B.O','670675',1,0,'2022-03-04 19:24:13','2022-03-04 19:24:13'),(123534,439,'Melmuringodi B.O','670673',1,0,'2022-03-04 19:24:13','2022-03-04 19:24:13'),(123535,439,'Melur-tly B.O','670661',1,0,'2022-03-04 19:24:13','2022-03-04 19:24:13'),(123536,439,'Mokeri B.O','670692',1,0,'2022-03-04 19:24:13','2022-03-04 19:24:13'),(123537,439,'Mooriyad B.O','670643',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123538,439,'Moozhikkara B.O','670103',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123539,439,'Mudiyanga B.O','670691',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123540,439,'Mundayamparamba B.O','670704',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123541,439,'Muzhakunnu B.O','670673',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123542,439,'Muzhappilangad S.O','670662',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123543,439,'Naduvanad B.O','670702',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123544,439,'Narikkodmala B.O','670693',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123545,439,'Nedumpoil B.O','670650',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123546,439,'Neerveli B.O','670701',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123547,439,'Nettur S.O (Kannur)','670105',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123548,439,'New Mahe S.O','673311',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123549,439,'Nirmalagiri S.O','670701',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123550,439,'Nuchiyad B.O','670705',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123551,439,'Olavilam S.O','673313',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123552,439,'Pachapoika B.O','670643',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123553,439,'Padiyur-kannur B.O','670703',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123554,439,'Palaparamba B.O','670701',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123555,439,'Palayad S.O','670661',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123556,439,'Panniyannur B.O','670671',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123557,439,'Panoor S.O','670692',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123558,439,'Paral S.O','670671',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123559,439,'Parapram B.O','670741',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123560,439,'Parikkalam B.O','670705',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123561,439,'Pathayakunnu S.O','670691',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123562,439,'Pathiriyad B.O','670741',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123563,439,'Payam East B.O','670704',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123564,439,'Payam S.O','670704',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123565,439,'Pazhassiraja Nagar B.O','670702',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123566,439,'Peravoor S.O','670673',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123567,439,'Peringadi S.O','673312',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123568,439,'Peringathur S.O','670675',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123569,439,'Perinkeri B.O','670706',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123570,439,'Perumpunna B.O','670673',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123571,439,'Perundattil B.O','670107',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123572,439,'Peruva B.O','670650',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123573,439,'Pinarayi S.O','670741',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123574,439,'Ponniam B.O','670641',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123575,439,'Ponniam West S.O','670641',1,0,'2022-03-04 19:24:14','2022-03-04 19:24:14'),(123576,439,'Poolakutty B.O','670650',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123577,439,'Porora B.O','670702',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123578,439,'Poyilur B.O','670693',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123579,439,'Pukkot-kba B.O','670691',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123580,439,'Puliyanambram B.O','670675',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123581,439,'Pullookkara B.O','670672',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123582,439,'Punnad B.O','670703',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123583,439,'Punnol B.O','670102',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123584,439,'Puthur-panoor B.O','670692',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123585,439,'Randamkadavu B.O','670706',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123586,439,'Sankaranellur B.O','670643',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123587,439,'Santhigiri B.O','670674',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123588,439,'Sivapuram B.O','670702',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123589,439,'Temple Gate S.O','670102',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123590,439,'Thalassery Bazar S.O','670101',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123591,439,'Thalassery Courts S.O','670101',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123592,439,'Thalassery H.O','670101',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123593,439,'Thillenkeri B.O','670702',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123594,439,'Tholambra B.O','670673',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123595,439,'Thondiyil B.O','670673',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123596,439,'Thuvakunnu S.O','670693',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123597,439,'Tiruvangad S.O','670103',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123598,439,'Ulikkal S.O','670705',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123599,439,'Uliyil B.O','670702',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123600,439,'Ummenchira S.O','670649',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123601,439,'Uruvachal B.O','670702',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123602,439,'Vadakkumbad B.O','670105',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123603,439,'Vattiamthode B.O','670705',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123604,439,'Vayalalam B.O','670671',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123605,439,'Vayannur B.O','670650',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123606,439,'Veerpad B.O','670704',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123607,439,'Velimanam B.O','670704',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123608,439,'Vellarvelly B.O','670673',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123609,439,'Vellunni B.O','670674',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123610,439,'Vilakkode B.O','670703',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123611,439,'Vilakkottur B.O','670693',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123612,440,'Kadumeni B.O','670511',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123613,440,'Kamballur B.O','670511',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123614,440,'Kannivayal B.O','670511',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123615,440,'Palavayal B.O','670511',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123616,440,'Thayyeni B.O','670511',1,0,'2022-03-04 19:24:15','2022-03-04 19:24:15'),(123617,440,'Achanthuruthi B.O','671351',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123618,440,'Achikanam B.O','671531',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123619,440,'Adkathbail B.O','671121',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123620,440,'Adur B.O','671543',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123621,440,'Ajanur B.O','671531',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123622,440,'Alampady B.O','671123',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123623,440,'Ammeri B.O','671322',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123624,440,'Anandashrama S.O','671531',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123625,440,'Anekallu B.O','671323',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123626,440,'Angadimogaru B.O','671321',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123627,440,'Arikady B.O','671321',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123628,440,'Ariyapady B.O','671551',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123629,440,'Attenganam B.O','671531',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123630,440,'Badaje B.O','671323',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123631,440,'Badur B.O','671321',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123632,440,'Balal B.O','671533',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123633,440,'Balemoole B.O','671552',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123634,440,'Balla B.O','671531',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123635,440,'Bandadka B.O','671541',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123636,440,'Bangramanjeshwar B.O','671323',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123637,440,'Bare B.O','671319',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123638,440,'Bayar B.O','671348',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123639,440,'Bedadka B.O','671541',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123640,440,'Bedradka B.O','671124',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123641,440,'Bekal Fort S.O','671316',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123642,440,'Bekal S.O','671318',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123643,440,'Bekur B.O','671322',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123644,440,'Bela B.O','671321',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123645,440,'Belluru B.O','671543',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123646,440,'Bengalam B.O','671314',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123647,440,'Beripadavu B.O','671322',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123648,440,'Bheemanady B.O','671314',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123649,440,'Bombrana B.O','671321',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123650,440,'Chamnad B.O','671317',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123651,440,'Chamundikunnu B.O','671532',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123652,440,'Chandragiri B.O','671317',1,0,'2022-03-04 19:24:16','2022-03-04 19:24:16'),(123653,440,'Charla B.O','671323',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123654,440,'Chathamath B.O','671314',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123655,440,'Chayoth B.O','671314',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123656,440,'Chengala S.O','671541',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123657,440,'Cheroor B.O','671123',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123658,440,'Chervathur S.O','671313',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123659,440,'Chimeni B.O','671313',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123660,440,'Chippar B.O','671322',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123661,440,'Chittari B.O','671316',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123662,440,'Chittarikkal S.O','671326',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123663,440,'Chully B.O','671533',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123664,440,'Darkas B.O','671533',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123665,440,'Delampady B.O','671543',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123666,440,'Dharmathadka B.O','671324',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123667,440,'Edachakai B.O','671310',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123668,440,'Ednad B.O','671321',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123669,440,'Edneer B.O','671541',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123670,440,'Elambachi S.O','671311',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123671,440,'Elerithattu B.O','671314',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123672,440,'Erikulam B.O','671314',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123673,440,'Haripuram B.O','671531',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123674,440,'Heroor B.O','671324',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123675,440,'Hidayathnagar B.O','671123',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123676,440,'Hosabettu B.O','671323',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123677,440,'Ichlampady B.O','671321',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123678,440,'Ichlangodu B.O','671324',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123679,440,'Iriya B.O','671531',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123680,440,'Iriyanni B.O','671542',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123681,440,'Kadambar B.O','671323',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123682,440,'Kaithakkad B.O','671313',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123683,440,'Kakkebettu B.O','671543',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123684,440,'Kalichanadukam B.O','671314',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123685,440,'Kallakatta B.O','671123',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123686,440,'Kallappally B.O','671532',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123687,440,'Kalnad S.O','671317',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123688,440,'Kanakappally B.O','671533',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123689,440,'Kanathur B.O','671542',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123690,440,'Kanhangad H.O','671315',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123691,440,'Kanhangad South B.O','671531',1,0,'2022-03-04 19:24:17','2022-03-04 19:24:17'),(123692,440,'Kanhiradkam B.O','671531',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123693,440,'Kanhirapoil B.O','671531',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123694,440,'Kannur B.O','671321',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123695,440,'Karadka B.O','671542',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123696,440,'Karindala B.O','671314',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123697,440,'Karivedakam B.O','671541',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123698,440,'Kasaragod H.O','671121',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123699,440,'Kasaragod R S S.O','671121',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123700,440,'Kattipoil B.O','671314',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123701,440,'Kattukukke B.O','671552',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123702,440,'Kayyaru B.O','671322',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123703,440,'Kayyur B.O','671313',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123704,440,'Keekan B.O','671316',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123705,440,'Kidoor B.O','671321',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123706,440,'Kilaikote B.O','671313',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123707,440,'Kinanur B.O','671533',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123708,440,'Kinningar B.O','671543',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123709,440,'Kodiamme B.O','671321',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123710,440,'Kodlamogaru B.O','671323',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123711,440,'Kodoth B.O','671531',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123712,440,'Kolathuri B.O','671541',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123713,440,'Kolavayal B.O','671531',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123714,440,'Kolichal B.O','671532',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123715,440,'Koliyur B.O','671323',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123716,440,'Kollampara B.O','671314',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123717,440,'Konnakad B.O','671533',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123718,440,'Kotakkat B.O','671310',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123719,440,'Kotoor B.O','671542',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123720,440,'Kottacherry S.O','671315',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123721,440,'Kottamala Estate B.O','671314',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123722,440,'Kottapuram B.O','671314',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123723,440,'Kottody B.O','671532',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123724,440,'Kudalmerkala B.O','671324',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123725,440,'Kudlu S.O','671124',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123726,440,'Kumbdaje B.O','671551',1,0,'2022-03-04 19:24:18','2022-03-04 19:24:18'),(123727,440,'Kumbla S.O','671321',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123728,440,'Kundankuzhy B.O','671541',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123729,440,'Kunjathur B.O','671323',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123730,440,'Kuntar B.O','671543',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123731,440,'Kuntikana B.O','671551',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123732,440,'Kurudapadavu B.O','671322',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123733,440,'Kuttikolu B.O','671541',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123734,440,'Madhur B.O','671124',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123735,440,'Madikai B.O','671314',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123736,440,'Maire B.O','671552',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123737,440,'Majibail B.O','671323',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123738,440,'Malakallu B.O','671532',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123739,440,'Malla B.O','671542',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123740,440,'Manadka B.O','671541',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123741,440,'Mandapam B.O','671326',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123742,440,'Mangalpady S.O','671324',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123743,440,'Manikoth B.O','671316',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123744,440,'Manimoole B.O','671541',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123745,440,'Maniyat B.O','671310',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123746,440,'Manjeshwar S.O','671323',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123747,440,'Mavilakadapuram B.O','671312',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123748,440,'Mayipady B.O','671124',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123749,440,'Miyapadavu B.O','671323',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123750,440,'Mogral B.O','671321',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123751,440,'Mogral Puthur B.O','671124',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123752,440,'Moodambail B.O','671323',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123753,440,'Movval B.O','671316',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123754,440,'Movvar B.O','671543',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123755,440,'Mugu B.O','671321',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123756,440,'Muliyar S.O','671542',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123757,440,'Mulleria S.O','671543',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123758,440,'Munnad B.O','671541',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123759,440,'Muttathody B.O','671123',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123760,440,'Muttomkadavil B.O','671533',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123761,440,'Mylatti B.O','671319',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123762,440,'Natakkal B.O','671533',1,0,'2022-03-04 19:24:19','2022-03-04 19:24:19'),(123763,440,'Nekraje B.O','671543',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123764,440,'Nettanige B.O','671543',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123765,440,'Nileshwar S.O','671314',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123766,440,'Nirchal B.O','671321',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123767,440,'Olat B.O','671310',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123768,440,'Ozhinhavalappu B.O','671314',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123769,440,'Padimaruth B.O','671531',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123770,440,'Padne S.O','671312',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123771,440,'Padnekadapuram B.O','671312',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123772,440,'Padnekkad B.O','671314',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123773,440,'Padre B.O','671552',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123774,440,'Paivalike S.O','671348',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123775,440,'Pakkom B.O','671316',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123776,440,'Pallathadka B.O','671551',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123777,440,'Panathady B.O','671532',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123778,440,'Panathur B.O','671532',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123779,440,'Pandi B.O','671543',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123780,440,'Paniyal B.O','671318',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123781,440,'Panjikkal B.O','671543',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123782,440,'Paraklayi B.O','671531',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123783,440,'Paramba B.O','671533',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123784,440,'Parappa - Delampady B.O','671543',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123785,440,'Parappa S.O','671533',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123786,440,'Paravanadkam B.O','671317',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123787,440,'Pathoor B.O','671323',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123788,440,'Patla B.O','671124',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123789,440,'Pavoor B.O','671323',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123790,440,'Perdala S.O','671551',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123791,440,'Periyanganam B.O','671314',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123792,440,'Periye B.O','671316',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123793,440,'Perla S.O','671552',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123794,440,'Permude B.O','671324',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123795,440,'Perumbala B.O','671317',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123796,440,'Perumbatta B.O','671313',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123797,440,'Pettikundu B.O','671313',1,0,'2022-03-04 19:24:20','2022-03-04 19:24:20'),(123798,440,'Pilicode B.O','671310',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123799,440,'Plachikara B.O','671533',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123800,440,'Podavur B.O','671313',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123801,440,'Pudukai B.O','671314',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123802,440,'Pullur B.O','671531',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123803,440,'Punnakkunnu B.O','671533',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123804,440,'Puthariadukkam B.O','671314',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123805,440,'Puthige B.O','671321',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123806,440,'Rajapuram S.O','671532',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123807,440,'Ramdasnagar B.O','671124',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123808,440,'Ranipuram B.O','671532',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123809,440,'Ravaneshwaram B.O','671316',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123810,440,'Samekochi B.O','671541',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123811,440,'Sankarampady B.O','671541',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123812,440,'Shiribagilu B.O','671124',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123813,440,'Shiriya B.O','671321',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123814,440,'Talangara S.O','671122',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123815,440,'Thaikadapuram B.O','671314',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123816,440,'Thayanoor B.O','671531',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123817,440,'Thekkil B.O','671541',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123818,440,'Thekkilferry B.O','671541',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123819,440,'Thuruthi S.O','671351',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123820,440,'Timiri - Chervathur B.O','671313',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123821,440,'Trikarpur Kadapuram B.O','671310',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123822,440,'Trikarpur S.O','671310',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123823,440,'Trikarpur South B.O','671311',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123824,440,'Udinur B.O','671310',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123825,440,'Udma S.O','671319',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123826,440,'Udumbanthala B.O','671311',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123827,440,'Udyavara B.O','671323',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123828,440,'Ukkinadka B.O','671552',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123829,440,'Ullody B.O','671321',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123830,440,'Umda - Padinhare B.O','671319',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123831,440,'Uppala Gate B.O','671322',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123832,440,'Uppala S.O','671322',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123833,440,'Uppilakai B.O','671314',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123834,440,'Urdur B.O','671543',1,0,'2022-03-04 19:24:21','2022-03-04 19:24:21'),(123835,440,'Valiaparaba B.O','671312',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123836,440,'Valiapoil B.O','671313',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123837,440,'Vallikadavu B.O','671533',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123838,440,'Vaninagar B.O','671552',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123839,440,'Vattamthatta B.O','671542',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123840,440,'Vellap B.O','671310',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123841,440,'Vellarikundu B.O','671533',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123842,440,'Vidyanagar S.O (Kasargod)','671123',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123843,440,'Vorkadi B.O','671323',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123844,440,'West Eleri B.O','671314',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123845,440,'Yethadka B.O','671551',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123846,441,'Achencoil B.O','689696',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123847,441,'Alayamon B.O','691306',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123848,441,'Ambalathinnirappu B.O','691508',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123849,441,'Ambalathumbhagom B.O','690520',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123850,441,'Ambanad B.O','691309',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123851,441,'Anakulam B.O','691311',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123852,441,'Anapettakongal B.O','691307',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123853,441,'Anayadi B.O','690561',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123854,441,'Anchal S.O','691306',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123855,441,'Areeplachy B.O','691333',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123856,441,'Arkannur B.O','691533',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123857,441,'Aryankavu B.O','691309',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123858,441,'Avaneeswaram B.O','691508',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123859,441,'Avaneeswaram RS B.O','691508',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123860,441,'Ayilara B.O','691312',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123861,441,'Ayiranallur B.O','691307',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123862,441,'Ayur S.O','691533',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123863,441,'Bharatheepuram B.O','691312',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123864,441,'Chakkuvarakkal B.O','691508',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123865,441,'Channapettah S.O','691311',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123866,441,'Chathakulam B.O','690520',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123867,441,'Chembanaruvi B.O','689696',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123868,441,'Cherukulam B.O','691306',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123869,441,'Cheruvakkal B.O','691533',1,0,'2022-03-04 19:24:22','2022-03-04 19:24:22'),(123870,441,'Chozhiakode B.O','691310',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123871,441,'Dally B.O','691310',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123872,441,'Edakkad B.O','691552',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123873,441,'Edamon S.O','691307',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123874,441,'Edamulackal B.O','691306',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123875,441,'Edapalayam B.O','691309',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123876,441,'Elamadu B.O','691533',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123877,441,'Elampal S.O','691322',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123878,441,'Elicode B.O','691322',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123879,441,'Elikattoor B.O','689696',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123880,441,'Eroor S.O (Kollam)','691312',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123881,441,'Ezhiyam Vattathra Mala Mukku B.O','691306',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123882,441,'Kadamancode B.O','691312',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123883,441,'Kakkakunnu B.O','690522',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123884,441,'Kakkode B.O','691331',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123885,441,'Kallada Irrigation Project B.O','691308',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123886,441,'Kalthuruthy S.O','691309',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123887,441,'Kamukumcherry B.O','689696',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123888,441,'Karali Jn B.O','690521',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123889,441,'Karavaloor B.O','691333',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123890,441,'Karavoor B.O','689696',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123891,441,'Karimthottuva B.O','690540',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123892,441,'Kariyara B.O','691332',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123893,441,'Karukone B.O','691306',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123894,441,'Koovakkad B.O','691310',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123895,441,'Kottavattom B.O','691322',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123896,441,'Kottukkal B.O','691306',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123897,441,'Kulathupuzha S.O','691310',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123898,441,'Kumarankudy B.O','689696',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123899,441,'Kundayam B.O','689695',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123900,441,'Kunnathur East S.O','690540',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123901,441,'Kunnicode S.O','691508',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123902,441,'Maloor B.O','689695',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123903,441,'Maloor College B.O','689695',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123904,441,'Mampazhathara B.O','691307',1,0,'2022-03-04 19:24:23','2022-03-04 19:24:23'),(123905,441,'Manalil B.O','691312',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123906,441,'Manampuzha B.O','691553',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123907,441,'Manchallur Pathanapuram S.O','689695',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123908,441,'Maniyaru-punalur B.O','691333',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123909,441,'Manjakala B.O','691508',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123910,441,'Manjappara B.O','691533',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123911,441,'Mannur-anchal B.O','691311',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123912,441,'Marthandankara B.O','691312',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123913,441,'Mathra B.O','691333',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123914,441,'Melila B.O','691508',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123915,441,'Muthupilakkad B.O','690520',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123916,441,'Narikal B.O','691322',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123917,441,'Nediyara B.O','691306',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123918,441,'Nellipally B.O','691331',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123919,441,'Ottackal B.O','691308',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123920,441,'Ozhukkuparackal B.O','691533',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123921,441,'Pallisserickal B.O','690521',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123922,441,'Panthaplavu B.O','691522',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123923,441,'Parakadavu B.O','690561',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123924,441,'Pathanapuram S.O','689695',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123925,441,'Patharam B.O','690522',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123926,441,'Pathirickal B.O','689695',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123927,441,'Pattazhy S.O','691522',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123928,441,'Pidavoor B.O','689695',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123929,441,'Piravanthur S.O','689696',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123930,441,'Placherry B.O','691331',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123931,441,'Poonkulanji B.O','689695',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123932,441,'Poruvazhy S.O','690520',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123933,441,'Punalur H.O','691305',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123934,441,'Punalur Paper Mills S.O','691332',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123935,441,'Punnala B.O','689696',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123936,441,'Puthenambalam B.O','691553',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123937,441,'Rosemala B.O','691309',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123938,441,'Samnagar B.O','691310',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123939,441,'Sasthamcottah S.O','690521',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123940,441,'Shaliacarry Estate B.O','691331',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123941,441,'Sooranad North S.O','690561',1,0,'2022-03-04 19:24:24','2022-03-04 19:24:24'),(123942,441,'Sooranad S.O','690522',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123943,441,'Thadicaud B.O','691306',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123944,441,'Thalavoor B.O','691508',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123945,441,'Thazhathuvadakku B.O','691526',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123946,441,'Thekketheri B.O','691522',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123947,441,'Thenmala S.O','691308',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123948,441,'Thevannur B.O','691533',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123949,441,'Thingalkarikom B.O','691310',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123950,441,'Tholicode S.O','691333',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123951,441,'Thuruthikara B.O','690540',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123952,441,'Urukunnu B.O','691307',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123953,441,'Vadamon B.O','691306',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123954,441,'Valacode S.O','691331',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123955,441,'Vayala-anchal B.O','691306',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123956,441,'Vayyanam B.O','691533',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123957,441,'Venchempu B.O','691333',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123958,441,'Venga B.O','690521',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123959,441,'Vengoor B.O','691533',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123960,441,'Venture B.O','691309',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123961,441,'Vettithitta B.O','689696',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123962,441,'Vilakkupara B.O','691312',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123963,441,'Vilakkuvattom B.O','691331',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123964,441,'Vilakudy B.O','691508',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123965,441,'Vilanthara Jn B.O','690521',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123966,441,'Villumala B.O','691310',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123967,441,'Adichanallur S.O','691573',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123968,441,'Aduthala B.O','691579',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123969,441,'Akkal B.O','691516',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123970,441,'Alumkadavu S.O','690573',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123971,441,'Alumoodu B.O','691577',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123972,441,'Alumpeedika B.O','690547',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123973,441,'Ambalakkara B.O','691532',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123974,441,'Ambalathumkala B.O','691505',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123975,441,'Ambipoika B.O','691501',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123976,441,'Amrithapuri B.O','690525',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123977,441,'Anakottur B.O','691505',1,0,'2022-03-04 19:24:25','2022-03-04 19:24:25'),(123978,441,'Andoor B.O','691532',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(123979,441,'Arinallur S.O','690538',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(123980,441,'Arinallur South B.O','690538',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(123981,441,'Ashtamudi B.O','691602',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(123982,441,'Asramom S.O','691002',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(123983,441,'Athinad North S.O','690542',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(123984,441,'Ayathil B.O','691021',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(123985,441,'Ayirakuzhy B.O','691559',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(123986,441,'Azheekkalthura B.O','690547',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(123987,441,'Bhoothakulam S.O','691302',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(123988,441,'Chadayamangalam S.O','691534',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(123989,441,'Chandanathope S.O','691014',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(123990,441,'Channappara B.O','691536',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(123991,441,'Chariparabu B.O','691536',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(123992,441,'Chathannur S.O','691572',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(123993,441,'Chavara Bridge S.O','691583',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(123994,441,'Chavara S.O','691583',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(123995,441,'Chavara South S.O','691584',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(123996,441,'Chemmakkad B.O','691601',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(123997,441,'Chengamanad Jn S.O','691557',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(123998,441,'Chenkulam B.O','691510',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(123999,441,'Cheppara S.O','691520',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(124000,441,'Cheriyavelinallur B.O','691516',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(124001,441,'Cheriyazheekal B.O','690573',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(124002,441,'Cherupoika B.O','691543',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(124003,441,'Chirakkara B.O','691578',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(124004,441,'Chirakkarathazham B.O','691578',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(124005,441,'Chithara S.O','691559',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(124006,441,'Clappana S.O','690525',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(124007,441,'Decent Jn B.O','691577',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(124008,441,'East Kallada S.O','691502',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(124009,441,'Edakulangara B.O','690523',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(124010,441,'Edanad B.O B.O','691579',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(124011,441,'Edappallycotta B.O','691583',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(124012,441,'Edathara B.O','691536',1,0,'2022-03-04 19:24:26','2022-03-04 19:24:26'),(124013,441,'Edayam B.O','691532',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124014,441,'Elampazhannur B.O','691534',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124015,441,'Eravipuram S.O','691011',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124016,441,'Extension Trg Centre B.O','691531',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124017,441,'Ezhukone S.O','691505',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124018,441,'Idakkadom B.O','691505',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124019,441,'Inchavila B.O','691601',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124020,441,'Irumpanangadu B.O','691505',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124021,441,'Iverkala East B.O','691507',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124022,441,'Kadakkal S.O','691536',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124023,441,'Kadakkode B.O','691505',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124024,441,'Kadappakada S.O','691008',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124025,441,'Kadathur Ward B.O','690523',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124026,441,'Kaithacode S.O','691543',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124027,441,'Kaithode B.O','691535',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124028,441,'Kakkotumoola B.O','691303',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124029,441,'Kalakode B.O','691302',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124030,441,'Kalayapuram S.O','691560',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124031,441,'Kallelibhagom B.O','690519',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124032,441,'Kallumthazham B.O','691004',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124033,441,'Kalluvathukkal S.O','691578',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124034,441,'Kanjavely S.O','691602',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124035,441,'Kanjiracode B.O','691501',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124036,441,'Kannanallur S.O','691576',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124037,441,'Karamcode S.O','691579',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124038,441,'Karikkom B.O','691531',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124039,441,'Karimpinpuzha B.O','691507',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124040,441,'Karingannur S.O','691516',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124041,441,'Karunagappally North B.O','690544',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124042,441,'Karunagappaly H.O','690518',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124043,441,'Karuvelil B.O','691505',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124044,441,'Kattadi Jn B.O','691537',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124045,441,'Kattilkadavu B.O','690542',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124046,441,'Kavanad S.O','691003',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124047,441,'Kilikollur East S.O','691004',1,0,'2022-03-04 19:24:27','2022-03-04 19:24:27'),(124048,441,'Kilikollur S.O','691004',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124049,441,'Kizhakkenela B.O','691574',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124050,441,'Kizhakketheruvu B.O','691531',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124051,441,'Koduvila B.O','691502',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124052,441,'Koivila S.O','691590',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124053,441,'Kokkad B.O','691538',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124054,441,'Kollaka B.O','690536',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124055,441,'Kollam Bazar S.O','691001',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124056,441,'Kollam Cantonment S.O','691001',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124057,441,'Kollam Civil Station S.O','691013',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124058,441,'Kollam Cutchery S.O','691013',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124059,441,'Kollam H.O','691001',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124060,441,'Kollam Taluk Cutchery S.O','691001',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124061,441,'Kollayil B.O','691541',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124062,441,'Koottikada B.O','691020',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124063,441,'Kottarakara H.O','691506',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124064,441,'Kottathala B.O','691507',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124065,441,'Kottiyam S.O','691571',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124066,441,'Kudavattur B.O','691512',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124067,441,'Kulakada S.O','691521',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124068,441,'Kulakkada East B.O','691521',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124069,441,'Kulakkadathazham B.O','691521',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124070,441,'Kulasekharapuram S.O','690544',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124071,441,'Kumbalam B.O','691503',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124072,441,'Kummallur B.O','691573',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124073,441,'Kummil B.O','691536',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124074,441,'Kundara East S.O','691501',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124075,441,'Kundara S.O','691501',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124076,441,'Kura B.O','691557',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124077,441,'Kureepuzha B.O','691601',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124078,441,'Kuriyode B.O','691534',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124079,441,'Kuthirapanthy B.O','690523',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124080,441,'Kuttikadu B.O','691536',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124081,441,'Kuzhimathicaud S.O','691509',1,0,'2022-03-04 19:24:28','2022-03-04 19:24:28'),(124082,441,'Kuzhithura B.O','690542',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124083,441,'Madathara S.O','691541',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124084,441,'Madathilkaranma B.O','690526',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124085,441,'Mailode B.O','691537',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124086,441,'Mailom B.O','691560',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124087,441,'Manappally North S.O','690574',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124088,441,'Mancode-kadakkal B.O','691559',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124089,441,'Mangad S.O','691015',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124090,441,'Maranad B.O','691505',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124091,441,'Maruthadi B.O','691003',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124092,441,'Mathilil B.O','691601',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124093,441,'Mathira B.O','691536',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124094,441,'Mavadi B.O','691507',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124095,441,'Mayyanad S.O','691303',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124096,441,'Meeyana B.O','691510',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124097,441,'Meeyannur B.O','691537',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124098,441,'Mukathala S.O','691577',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124099,441,'Mukkoodu B.O','691503',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124100,441,'Mukundapuram S.O','691585',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124101,441,'Mulavana S.O','691503',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124102,441,'Mundakkal B.O','691010',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124103,441,'Munroethuruthu B.O','691502',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124104,441,'Muttara B.O','691512',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124105,441,'Mylakkadu B.O','691571',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124106,441,'Mynagappally North B.O','690519',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124107,441,'Mynagappally S.O','690519',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124108,441,'Nallila S.O','691515',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124109,441,'Nedumoncavu B.O','691509',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124110,441,'Nedumpaikulam B.O','691501',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124111,441,'Nedumpana B.O','691576',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124112,441,'Nedungolam S.O','691334',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124113,441,'Neeleswaram B.O','691505',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124114,441,'Neendakara S.O','691582',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124115,441,'Nellettil B.O','691302',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124116,441,'Nellikunnam B.O','691520',1,0,'2022-03-04 19:24:29','2022-03-04 19:24:29'),(124117,441,'Nellimukku B.O','691509',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124118,441,'Nettayam B.O','691537',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124119,441,'Nilamel S.O','691535',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124120,441,'Ochira S.O','690526',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124121,441,'Odanavattom S.O','691512',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124122,441,'Oyur S.O','691510',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124123,441,'Padappakara B.O','691503',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124124,441,'Padinjattakkara B.O','690524',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124125,441,'Pallickal-kottarakara S.O','691566',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124126,441,'Pallimon B.O','691576',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124127,441,'Pallithottam S.O','691006',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124128,441,'Panavely B.O','691532',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124129,441,'Panayam B.O','691601',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124130,441,'Panmana B.O','691583',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124131,441,'Panmana Puthen Chantha B.O','691583',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124132,441,'Paravur S.O (Kollam)','691301',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124133,441,'Parippally S.O','691574',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124134,441,'Pattamthuruth B.O','691601',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124135,441,'Pattathanam S.O','691021',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124136,441,'Pavithreswaram B.O','691507',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124137,441,'Pavumba B.O','690574',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124138,441,'Perinad S.O','691601',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124139,441,'Perumannur B.O','691532',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124140,441,'Perumkulam B.O','691566',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124141,441,'Perumon B.O','691601',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124142,441,'Perumpuzha S.O','691504',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124143,441,'Perungalam B.O','690538',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124144,441,'Peruvelikara B.O','691500',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124145,441,'Plappally B.O','691531',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124146,441,'Podiyattuvila B.O','691532',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124147,441,'Polachira B.O','691334',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124148,441,'Ponmana B.O','691583',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124149,441,'Pooyapally S.O','691537',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124150,441,'Poredom B.O','691534',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124151,441,'Prakkulam B.O','691602',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124152,441,'Pulamon S.O','691531',1,0,'2022-03-04 19:24:30','2022-03-04 19:24:30'),(124153,441,'Pulippara Jn B.O','691536',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124154,441,'Pullichira S.O','691304',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124155,441,'Pullupana B.O','691536',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124156,441,'Puthenkulam B.O','691302',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124157,441,'Puthenthura B.O','691582',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124158,441,'Puthukkadukara B.O','691585',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124159,441,'Puthur-kollam S.O','691507',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124160,441,'S R P Market S.O','690539',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124161,441,'S V Market B.O','690573',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124162,441,'Sadanandapuram B.O','691531',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124163,441,'Sakthikulangara S.O','691581',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124164,441,'T K M College S.O','691005',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124165,441,'Thalachira B.O','691538',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124166,441,'Thamarakudy B.O','691560',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124167,441,'Thangasserry S.O','691007',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124168,441,'Thattamala S.O','691020',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124169,441,'Thattarkonam B.O','691005',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124170,441,'Thazhava S.O','690523',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124171,441,'Thekkevila S.O','691016',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124172,441,'Thekkumbhagom S.O','691319',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124173,441,'Thevalakkara S.O','690524',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124174,441,'Thevalappuram B.O','691507',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124175,441,'Thevally S.O','691009',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124176,441,'Thirumullavaram S.O','691012',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124177,441,'Thodiyur B.O','690523',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124178,441,'Thodiyur North B.O','690523',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124179,441,'Thottumugham B.O','690519',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124180,441,'Thrikkannamangal B.O','691531',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124181,441,'Thrioppilazhikom B.O','691509',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124182,441,'Thudayannur B.O','691536',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124183,441,'Uliyakovil S.O','691019',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124184,441,'Uliyanadu B.O','691579',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124185,441,'Umayanallur I E S.O','691589',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124186,441,'Ummannur B.O','691520',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124187,441,'Vadakkevila S.O','691010',1,0,'2022-03-04 19:24:31','2022-03-04 19:24:31'),(124188,441,'Vadakkumbhagom B.O','691584',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124189,441,'Vadakkumthala East S.O','690536',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124190,441,'Vakkanad B.O','691509',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124191,441,'Valakom S.O','691532',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124192,441,'Valathungal B.O','691011',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124193,441,'Valavupacha B.O','691559',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124194,441,'Valiyode B.O','691520',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124195,441,'Varavila B.O','690528',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124196,441,'Vattathamara B.O','691536',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124197,441,'Vavvakkavu S.O','690528',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124198,441,'Vayakkal B.O','691532',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124199,441,'Velamannoor B.O','691574',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124200,441,'Velichikala B.O','691573',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124201,441,'Veliyam S.O','691540',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124202,441,'Veliyam West B.O','691540',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124203,441,'Vellimon S.O','691511',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124204,441,'Vellimon West B.O','691511',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124205,441,'Vendar B.O','691507',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124206,441,'Venkolla B.O','691541',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124207,441,'Vettikavala S.O','691538',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124208,441,'Vilavoorkonam B.O','691578',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124209,441,'West Kallada S.O','691500',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124210,442,'Alapra B.O','686544',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124211,442,'Amara B.O','686546',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124212,442,'Anakkal B.O','686508',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124213,442,'Anikad East B.O','686503',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124214,442,'Anikad S.O','686503',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124215,442,'Anikad West B.O','686503',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124216,442,'Areeparampu B.O','686501',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124217,442,'Aruvikuzhy B.O','686503',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124218,442,'Chakompathal S.O','686517',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124219,442,'Champakara B.O','686540',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124220,442,'Changanacherry College S.O','686101',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124221,442,'Changanacherry H.O','686101',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124222,442,'Changanacherry Industrialnagar S.O','686106',1,0,'2022-03-04 19:24:32','2022-03-04 19:24:32'),(124223,442,'Changanacherry Market S.O','686101',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124224,442,'Channanikadu B.O','686533',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124225,442,'Cheeranchira B.O','686106',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124226,442,'Chelacompu B.O','686540',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124227,442,'Chemmalamattom B.O','686508',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124228,442,'Chenappady B.O','686520',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124229,442,'Chengalam S.O','686585',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124230,442,'Chennakunnu B.O','686506',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124231,442,'Cheruvally B.O','686543',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124232,442,'Chettuthode B.O','686508',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124233,442,'Chingavanam S.O','686531',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124234,442,'Chirakadavu Centre B.O','686519',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124235,442,'Chirakadavu East B.O','686520',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124236,442,'Chirakadavu S.O','686520',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124237,442,'Chittadi B.O','686512',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124238,442,'Devagiri S.O','686555',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124239,442,'Edakadathy B.O','686510',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124240,442,'Edakkunnam B.O','686512',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124241,442,'Edayarickapuzha B.O','686541',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124242,442,'Elamkadu B.O','686514',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124243,442,'Elampally B.O','686503',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124244,442,'Erathuvadakara B.O','686543',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124245,442,'Eravuchira B.O','686539',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124246,442,'Erumely S.O','686509',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124247,442,'Fathimapuram B.O','686102',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124248,442,'Inchiyani B.O','686512',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124249,442,'Ithithanam B.O','686535',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124250,442,'Kadayanickad B.O','686541',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124251,442,'Kalaketty S.O','686508',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124252,442,'Kalloorkulam B.O','686503',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124253,442,'Kanakapalam B.O','686509',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124254,442,'Kanam B.O','686515',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124255,442,'Kanamala B.O','686510',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124256,442,'Kangazha S.O','686541',1,0,'2022-03-04 19:24:33','2022-03-04 19:24:33'),(124257,442,'Kanjiramattom B.O','686585',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124258,442,'Kanjirapally H.O','686507',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124259,442,'Kanjirapally West B.O','686506',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124260,442,'Kanjirappara B.O','686555',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124261,442,'Kannimala B.O','686509',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124262,442,'Kappadu B.O','686508',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124263,442,'Karikkattoor Centre B.O','686544',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124264,442,'Karikkattoor S.O','686544',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124265,442,'Karinilam B.O','686513',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124266,442,'Karukachal S.O','686540',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124267,442,'Kavumbhagom B.O','686519',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124268,442,'Koorali S.O','686522',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124269,442,'Kooropada B.O','686502',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124270,442,'Koothrappally B.O','686540',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124271,442,'Koottickal S.O','686514',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124272,442,'Koovapally S.O','686518',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124273,442,'Koruthode B.O','686513',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124274,442,'Kothala B.O','686502',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124275,442,'Kottamurickal B.O','686105',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124276,442,'Kulathoorprayar B.O','686541',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124277,442,'Kurichy B.O','686532',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124278,442,'Kurisummoodu S.O','686104',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124279,442,'Kurumpanadom B.O','686536',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124280,442,'Kuruvammoozhy B.O','686509',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124281,442,'Kuzhimattom S.O','686533',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124282,442,'Lakkattoor B.O','686502',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124283,442,'Madappally S.O','686546',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124284,442,'Madukka B.O','686513',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124285,442,'Malakunnam B.O','686535',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124286,442,'Mammoodu B.O','686536',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124287,442,'Manalunkal B.O','686503',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124288,442,'Manimala S.O','686543',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124289,442,'Mannarakayam B.O','686506',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124290,442,'Manthuruthy B.O','686542',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124291,442,'Moozhoor B.O','686503',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124292,442,'Mukkada B.O','686544',1,0,'2022-03-04 19:24:34','2022-03-04 19:24:34'),(124293,442,'Mukkoottuthara S.O','686510',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124294,442,'Mundakayam S.O','686513',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124295,442,'Mundathanam B.O','686541',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124296,442,'Muttappally B.O','686510',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124297,442,'Nalukody S.O','686548',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124298,442,'Nalunnackal B.O','686538',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124299,442,'Nariyanani B.O','686506',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124300,442,'Nedumanny B.O','686542',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124301,442,'Nedumkunnam S.O','686542',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124302,442,'Nedungadappally S.O','686545',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124303,442,'Palampra B.O','686518',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124304,442,'Pallickachirakavala S.O','686537',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124305,442,'Pampady S.O','686502',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124306,442,'Pampady South S.O','686521',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124307,442,'Pampavally North B.O','686510',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124308,442,'Panachepally B.O','686518',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124309,442,'Panachikavu B.O','686102',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124310,442,'Panamattom B.O','686522',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124311,442,'Pangada B.O','686502',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124312,442,'Parathanam B.O','686514',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124313,442,'Parathode S.O (Kottayam)','686512',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124314,442,'Pathamuttom B.O','686532',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124315,442,'Pazhayidom B.O','686520',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124316,442,'Perumpanachy S.O','686536',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124317,442,'Perunna S.O','686102',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124318,442,'Ponganthanam B.O','686538',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124319,442,'Ponkunnam Court B.O','686506',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124320,442,'Ponkunnam S.O','686506',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124321,442,'Ponthenpuzha B.O','686544',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124322,442,'Poothakuzhy B.O','686521',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124323,442,'Poovatholi B.O','686544',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124324,442,'Pothenpuram B.O','686502',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124325,442,'Prpose B.O','686509',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124326,442,'Pulickakavala S.O','686515',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124327,442,'Pulikkallu B.O','686544',1,0,'2022-03-04 19:24:35','2022-03-04 19:24:35'),(124328,442,'Punchavayal B.O','686513',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124329,442,'Puthenchantha B.O','686538',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124330,442,'Rajendraprasad Colony B.O','686513',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124331,442,'Ruby Nagar B.O','686103',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124332,442,'Sachivothamapuram S.O','686532',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124333,442,'Santhipuram B.O','686545',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124334,442,'Suryanarayana Puram B.O','686502',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124335,442,'Thalumkal B.O','686514',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124336,442,'Thampalakkad B.O','686506',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124337,442,'Thazhathuvadakara B.O','686541',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124338,442,'Theerthapadapuram S.O','686505',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124339,442,'Thekkethukavala S.O','686519',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124340,442,'Thottackad West B.O','686539',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124341,442,'Thottakadu S.O','686539',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124342,442,'Thrickodithanam S.O','686105',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124343,442,'Thuruthy S.O','686535',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124344,442,'Umbidi B.O','686539',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124345,442,'Urakkanadu B.O','686512',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124346,442,'Vakathanam S.O','686538',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124347,442,'Vakathanam South B.O','686538',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124348,442,'Vanchimala B.O','686508',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124349,442,'Vazhappally West S.O','686103',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124350,442,'Vazhoor East B.O','686504',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124351,442,'Vazhoor S.O','686504',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124352,442,'Velanilam B.O','686514',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124353,442,'Vellavoor B.O','686541',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124354,442,'Velloor S.O','686501',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124355,442,'Vengathanam B.O','686512',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124356,442,'Venkurinji B.O','686510',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124357,442,'Veroor B.O','686104',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124358,442,'Vizhikithode B.O','686518',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124359,442,'Yendayar B.O','686514',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124360,442,'Adivaram B.O','686582',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124361,442,'Adukkam B.O','686580',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124362,442,'Akkarapadom B.O','686143',1,0,'2022-03-04 19:24:36','2022-03-04 19:24:36'),(124363,442,'Alanad B.O','686651',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124364,442,'Amalagiri B.O','686561',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124365,442,'Amanakara B.O','686576',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124366,442,'Amayannur B.O','686019',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124367,442,'Ambika Market B.O','686144',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124368,442,'Ampara Nirappel B.O','686578',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124369,442,'Anjoottimangalam B.O','686579',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124370,442,'Anthinad S.O','686651',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124371,442,'Apporkara B.O','686008',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124372,442,'Arpookara East B.O','686008',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124373,442,'Arumanur B.O','686564',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124374,442,'Arunapuram S.O','686574',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124375,442,'Arunoottimangalam B.O','686604',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124376,442,'Aruvithura S.O','686122',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124377,442,'Athirampuzha S.O','686562',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124378,442,'Ayamkudy B.O','686613',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124379,442,'Ayarkunnam S.O','686564',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124380,442,'Aymanam S.O','686015',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124381,442,'Ayyarkulangara B.O','686146',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124382,442,'Bharananganam S.O','686578',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124383,442,'Brahmamangalam B.O','686605',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124384,442,'Chakkampuzha B.O','686574',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124385,442,'Chamakala B.O','686603',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124386,442,'Cheepunkal B.O','686563',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124387,442,'Chemmanathukara B.O','686606',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124388,442,'Chempilavu B.O','686584',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124389,442,'Chempu B.O','686608',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124390,442,'Chengalam South S.O','686022',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124391,442,'Chennad B.O','686581',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124392,442,'Cherpunkal S.O','686584',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124393,442,'Cholathadom B.O','686582',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124394,442,'Choondacherry B.O','686579',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124395,442,'Chovvur B.O','686586',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124396,442,'Devalokam B.O','686004',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124397,442,'Edamaruku B.O','686652',1,0,'2022-03-04 19:24:37','2022-03-04 19:24:37'),(124398,442,'Edanad B.O','686574',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124399,442,'Edappady B.O','686578',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124400,442,'Edavattom B.O','686605',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124401,442,'Elakad B.O','686587',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124402,442,'Elikulam B.O','686577',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124403,442,'Enadi B.O','686608',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124404,442,'Erattupetta S.O','686121',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124405,442,'Eravimangalam B.O','686613',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124406,442,'Eravinalloor B.O','686011',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124407,442,'Erumapramattom B.O','686586',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124408,442,'Ettumanur Junction S.O','686631',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124409,442,'Ettumanur S.O','686631',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124410,442,'Ezhacherry B.O','686651',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124411,442,'Ezhumanthuruth B.O','686613',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124412,442,'Gandhi Nagar S.O (Kottayam)','686008',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124413,442,'Idamattom B.O','686578',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124414,442,'Idiyanal B.O','686576',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124415,442,'Irumpayam B.O','686605',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124416,442,'Kadanad Meenachil S.O','686653',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124417,442,'Kadaplamattom S.O','686571',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124418,442,'Kadappattoor B.O','686574',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124419,442,'Kaduthuruthy S.O','686604',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124420,442,'Kaipally B.O','686582',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124421,442,'Kaipuzha S.O','686602',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124422,442,'Kalathoor B.O','686633',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124423,442,'Kalathukadavu B.O','686579',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124424,442,'Kallara S.O (Kottayam)','686611',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124425,442,'Kallara South B.O','686611',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124426,442,'Kanakari S.O','686632',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124427,442,'Kanjiram B.O','686020',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124428,442,'Kanjirathanam B.O','686603',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124429,442,'Kappumthala B.O','686613',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124430,442,'Karikode B.O','686610',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124431,442,'Karimpani B.O','686564',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124432,442,'Karipadom B.O','686605',1,0,'2022-03-04 19:24:38','2022-03-04 19:24:38'),(124433,442,'Kattachira B.O','686572',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124434,442,'Kattampack B.O','686612',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124435,442,'Kayyoor B.O','686651',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124436,442,'Keezhoor B.O','686605',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124437,442,'Kezhuvankulam B.O','686584',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124438,442,'Kidangoor S.O','686572',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124439,442,'Kidangoor South S.O','686583',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124440,442,'Kiliroor North S.O','686020',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124441,442,'Kizhakkenmattom B.O','686652',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124442,442,'Kizhaparayar B.O','686578',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124443,442,'Kizhathadiyur B.O','686574',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124444,442,'Kizhathiri B.O','686576',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124445,442,'Kodumpidi B.O','686651',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124446,442,'Kollad B.O','686004',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124447,442,'Kongandoor B.O','686564',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124448,442,'Konipad B.O','686652',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124449,442,'Koodapalam B.O','686576',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124450,442,'Kothanallur B.O','686632',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124451,442,'Kothavara B.O','686607',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124452,442,'Kottakkapuram B.O','686631',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124453,442,'Kottayam Collectorate S.O','686002',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124454,442,'Kottayam H.O','686001',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124455,442,'Kottayam North S.O','686001',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124456,442,'Kottayam South B.O','686013',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124457,442,'Kottayam West S.O','686003',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124458,442,'Kozha B.O','686633',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124459,442,'Kozhuvanal B.O','686573',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124460,442,'Kudakkachira B.O','686635',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124461,442,'Kudalloor B.O','686587',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124462,442,'Kudamaloor S.O','686017',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124463,442,'Kudavechoor S.O','686144',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124464,442,'Kulasekharamangalam S.O','686608',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124465,442,'Kumarakom East B.O','686563',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124466,442,'Kumarakom North B.O','686563',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124467,442,'Kumarakom S.O','686563',1,0,'2022-03-04 19:24:39','2022-03-04 19:24:39'),(124468,442,'Kumarakom South B.O','686563',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124469,442,'Kumaranalloor S.O','686016',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124470,442,'Kummanam B.O','686005',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124471,442,'Kummannoor B.O','686572',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124472,442,'Kunnam B.O','686582',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124473,442,'Kuravilangadu S.O','686633',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124474,442,'Kurianad B.O','686636',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124475,442,'Kurichithanam B.O','686634',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124476,442,'Kurinji B.O','686576',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124477,442,'Kurumannu B.O','686651',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124478,442,'Kurumulloor B.O','686632',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124479,442,'Kuruppamthara B.O','686603',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124480,442,'Madukkakunuu B.O','686577',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124481,442,'Malam B.O','686019',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124482,442,'Mallikasery B.O','686577',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124483,442,'Malloossery S.O','686041',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124484,442,'Manarcaudu S.O','686019',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124485,442,'Manganam S.O','686018',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124486,442,'Manjoor S.O','686603',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124487,442,'Manjoor South B.O','686603',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124488,442,'Mannackanad B.O','686633',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124489,442,'Mannanam S.O','686561',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124490,442,'Marangattupally S.O','686635',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124491,442,'Marangoli B.O','686612',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124492,442,'Maravanthuruthu B.O','686608',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124493,442,'Mariappally B.O','686013',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124494,442,'Mariathuruthu B.O','686017',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124495,442,'Mary Land B.O','686652',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124496,442,'Mattakkara B.O','686564',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124497,442,'Mattathipara B.O','686651',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124498,442,'Mechal B.O','686586',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124499,442,'Mediri B.O','686576',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124500,442,'Meenachil B.O','686577',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124501,442,'Meenadom S.O','686516',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124502,442,'Melampara B.O','686578',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124503,442,'Melukavu B.O','686652',1,0,'2022-03-04 19:24:40','2022-03-04 19:24:40'),(124504,442,'Melukavumattom S.O','686652',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124505,442,'Memuri B.O','686611',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124506,442,'Mevada B.O','686573',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124507,442,'Mevelloor S.O','686609',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124508,442,'Midayikunnu B.O','686605',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124509,442,'Monippally S.O','686636',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124510,442,'Moolavattom B.O','686012',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124511,442,'Moonnilavu S.O','686586',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124512,442,'Moozhikulangara B.O','686601',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124513,442,'Mulakulam South B.O','686610',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124514,442,'Mundankal B.O','686574',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124515,442,'Mutholi B.O','686573',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124516,442,'Muttambalam S.O','686004',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124517,442,'Muttuchira S.O','686613',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124518,442,'Nadackal B.O','686121',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124519,442,'Nariayanganam B.O','686579',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124520,442,'Nattakom S.O','686013',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124521,442,'Nattassery S H Mount S.O','686006',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124522,442,'Nazreth Hill B.O','686633',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124523,442,'Nechipuzhoor B.O','686574',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124524,442,'Neeloor B.O','686651',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124525,442,'Neendoor S.O','686601',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124526,442,'Neerikkad B.O','686564',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124527,442,'Newsprint Nagar S.O','686616',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124528,442,'Njandupara B.O','686577',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124529,442,'Njizhoor S.O','686612',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124530,442,'Olessa S.O','686014',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124531,442,'Onamthuruthu B.O','686602',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124532,442,'Ozhavur East B.O','686634',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124533,442,'Ozhavur S.O','686634',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124534,442,'Padinjarekkara S.O','686146',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124535,442,'Padinjattinkara B.O','686571',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124536,442,'Paduva B.O','686564',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124537,442,'Pakalomattom B.O','686633',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124538,442,'Pakkil S.O','686012',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124539,442,'Pala Town S.O','686575',1,0,'2022-03-04 19:24:41','2022-03-04 19:24:41'),(124540,442,'Palai H.O','686575',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124541,442,'Palai Market Junction S.O','686575',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124542,442,'Palakkattumala B.O','686635',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124543,442,'Pallippurathussery B.O','686606',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124544,442,'Pallom S.O','686007',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124545,442,'Parampuzha B.O','686004',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124546,442,'Parippu B.O','686014',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124547,442,'Pariyaram S.O (Kottayam)','686021',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124548,442,'Pathampuzha B.O','686582',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124549,442,'Pattithanam B.O','686631',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124550,442,'Payyappady B.O','686011',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124551,442,'Payyappar B.O','686651',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124552,442,'Peringalam B.O','686582',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124553,442,'Peroor S.O','686637',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124554,442,'Perumbaikkad B.O','686016',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124555,442,'Perumthuruth B.O','686611',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124556,442,'Peruva S.O','686610',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124557,442,'Pious Mount B.O','686636',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124558,442,'Pizhaku B.O','686651',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124559,442,'Plassanal S.O','686579',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124560,442,'Ponand-karur B.O','686574',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124561,442,'Poonjar S.O','686581',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124562,442,'Poonjar Thekkekara S.O','686582',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124563,442,'Poovanthuruthu GDSB.O','686012',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124564,442,'Poovarani S.O','686577',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124565,442,'Poovathode B.O','686578',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124566,442,'Poozhikole B.O','686604',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124567,442,'Pravithanam B.O','686651',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124568,442,'Priyadarsini Hills S.O','686560',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124569,442,'Pulikkuttissery B.O','686015',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124570,442,'Puliyannoor S.O','686573',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124571,442,'Punnathura B.O','686583',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124572,442,'Punnathura West B.O','686631',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124573,442,'Puthupalli S.O','686011',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124574,442,'Puthuvely B.O','686636',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124575,442,'Ramapuram B.O','686576',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124576,442,'Ramapuram Bazar S.O','686576',1,0,'2022-03-04 19:24:42','2022-03-04 19:24:42'),(124577,442,'Rubber Board S.O','686009',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124578,442,'Sreekantamangalam B.O','686562',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124579,442,'Teekoy S.O','686580',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124580,442,'Thalanad B.O','686580',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124581,442,'Thalayazham S.O','686607',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124582,442,'Thalayolaparambu S.O','686605',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124583,442,'Thazhathangady S.O','686005',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124584,442,'Thellakom S.O','686630',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124585,442,'Thidanad S.O','686123',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124586,442,'Thirumani Venkita Puram S.O','686606',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124587,442,'Thirunakkara S.O','686001',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124588,442,'Thiruvanchoor B.O','686019',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124589,442,'Thiruvanpady B.O','686612',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124590,442,'Thiruvarppu B.O','686020',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124591,442,'Thodanal B.O','686573',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124592,442,'Thottakom B.O','686607',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124593,442,'Thrikothamangalam B.O','686011',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124594,442,'Udayanapuram S.O','686143',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124595,442,'Ullanad B.O','686651',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124596,442,'Vadakara - Thalayolaparabu B.O','686605',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124597,442,'Vadakkenirappu B.O','686612',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124598,442,'Vadavathoor S.O','686010',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124599,442,'Vadayar B.O','686605',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124600,442,'Vaikaprayar B.O','686146',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124601,442,'Vaikom H.O','686141',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124602,442,'Vaikom Thekkenada B.O','686146',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124603,442,'Vakad B.O','686636',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124604,442,'Valavoor B.O','686635',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124605,442,'Vallichira B.O','686574',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124606,442,'Vattakunnu B.O','686516',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124607,442,'Vattukulam B.O','686587',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124608,442,'Vayala S.O','686587',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124609,442,'Vechoor B.O','686144',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124610,442,'Velathusseri B.O','686580',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124611,442,'Veliyannoor B.O','686634',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124612,442,'Velliappally B.O','686574',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124613,442,'Vellikulam B.O','686580',1,0,'2022-03-04 19:24:43','2022-03-04 19:24:43'),(124614,442,'Veloor B.O','686003',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124615,442,'Vempally B.O','686633',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124616,442,'Vettimukal B.O','686631',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124617,442,'Villoonni B.O','686008',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124618,443,'Adivaram Pudupadi B.O','673586',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124619,443,'Alli B.O','673602',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124620,443,'Anakampoyil B.O','673603',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124621,443,'Arakinar S.O','673028',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124622,443,'Avilora B.O','673572',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124623,443,'Beypore North B.O','673015',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124624,443,'Beypore S.O','673015',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124625,443,'Calicut Arts & Science College S.O','673018',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124626,443,'Calicut Beach S.O','673032',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124627,443,'Calicut City S.O','673004',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124628,443,'Calicut Civil Station H.O','673020',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124629,443,'Calicut Collectorate S.O','673020',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124630,443,'Calicut Courts S.O','673032',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124631,443,'Calicut H.O','673001',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124632,443,'Calicut Medical College S.O','673008',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124633,443,'Calicut R.S. S.O','673001',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124634,443,'Chalapuram S.O','673002',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124635,443,'Chaliyam S.O','673301',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124636,443,'Chamal B.O','673573',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124637,443,'Chathamangalam B.O','673601',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124638,443,'Chelannur S.O','673616',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124639,443,'Chelavur B.O','673571',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124640,443,'Chembu Kadavu B.O','673580',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124641,443,'Chennamangallur B.O','673602',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124642,443,'Cherooppa B.O','673661',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124643,443,'Cherukulathur B.O','673008',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124644,443,'Cheruvadi B.O','673661',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124645,443,'Cheruvannur S.O','673655',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124646,443,'Chevarambalam B.O','673017',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124647,443,'Chevayur S.O','673017',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124648,443,'Chulur B.O','673601',1,0,'2022-03-04 19:24:44','2022-03-04 19:24:44'),(124649,443,'Devagiri College B.O','673008',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124650,443,'East Hill S.O','673005',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124651,443,'Edakkad - West Hill B.O','673005',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124652,443,'Edakkara - Quilandy B.O','673616',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124653,443,'Elathur S.O (Kozhikode)','673303',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124654,443,'Elettil B.O','673572',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124655,443,'Eranhikkal B.O','673303',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124656,443,'Eranhipalam S.O','673006',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124657,443,'Eravannur B.O','673585',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124658,443,'Farook College S.O','673632',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124659,443,'Feroke Pettah S.O','673631',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124660,443,'Feroke S.O','673631',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124661,443,'Govinda Puram B.O','673016',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124662,443,'Guruvayurappan College S.O','673014',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124663,443,'Iim Kozhikode Campus S.O','673570',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124664,443,'Iringallur B.O','673014',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124665,443,'Irivallur B.O','673616',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124666,443,'Kadalundi S.O','673302',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124667,443,'Kakkad Pudupadi B.O','673586',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124668,443,'Kakkatampoyil B.O','673604',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124669,443,'Kakkoti S.O','673611',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124670,443,'Kakkur B.O','673613',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124671,443,'Kallai-kozhikode S.O','673003',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124672,443,'Kallurutty B.O','673582',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124673,443,'Kannan Kara B.O','673616',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124674,443,'Kannancheri B.O','673003',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124675,443,'Kanni Paramba B.O','673661',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124676,443,'Kannoth B.O','673580',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124677,443,'Karanthur B.O','673571',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124678,443,'Karaparamba S.O','673010',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124679,443,'Karasseri B.O','673602',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124680,443,'Karuvampoyil B.O','673572',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124681,443,'Karuvanthuruthy B.O','673631',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124682,443,'Karuvasseri B.O','673010',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124683,443,'Kattippara B.O','673573',1,0,'2022-03-04 19:24:45','2022-03-04 19:24:45'),(124684,443,'Kayal B.O','673661',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124685,443,'Kilakkoth B.O','673572',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124686,443,'Kizhakkumuri B.O','673611',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124687,443,'Kodiyathur B.O','673602',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124688,443,'Kolathara S.O','673655',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124689,443,'Kommeri B.O','673007',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124690,443,'Konott B.O','673571',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124691,443,'Koombara B.O','673604',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124692,443,'Koombara Bazar B.O','673604',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124693,443,'Kotancheri-tamaracheri S.O','673580',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124694,443,'Kottamparamba B.O','673008',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124695,443,'Kottuli B.O','673016',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124696,443,'Kotuvalli S.O','673572',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124697,443,'Kudathai B.O','673573',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124698,443,'Kudathai Bazar B.O','673573',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124699,443,'Kuliramutty B.O','673604',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124700,443,'Kumaranellur B.O','673602',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124701,443,'Kundungal S.O','673003',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124702,443,'Kunnamangalam Mini Ind. Estate B.O','673571',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124703,443,'Kunnamangalam S.O','673571',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124704,443,'Kuppayakode B.O','673580',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124705,443,'Kuruvattur B.O','673611',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124706,443,'Kutaranni S.O','673604',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124707,443,'Kuthiravattom S.O','673016',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124708,443,'Kuttikkattur B.O','673008',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124709,443,'Kythapoyil B.O','673586',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124710,443,'Madavoor B.O','673585',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124711,443,'Maikavu B.O','673573',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124712,443,'Mailellampara B.O','673586',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124713,443,'Makkada B.O','673611',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124714,443,'Malaparamba S.O','673009',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124715,443,'Malayamma B.O','673601',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124716,443,'Manasseri B.O','673602',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124717,443,'Manha Kadavu B.O','673604',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124718,443,'Manipuram B.O','673572',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124719,443,'Mankavu S.O','673007',1,0,'2022-03-04 19:24:46','2022-03-04 19:24:46'),(124720,443,'Mannur S.O (Kozhikode)','673328',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124721,443,'Marikunnu S.O','673012',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124722,443,'Mavoor S.O (Kozhikode)','673661',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124723,443,'Mayanad B.O','673008',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124724,443,'Meemutty B.O','673580',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124725,443,'Mokkam S.O','673602',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124726,443,'Morikkara B.O','673611',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124727,443,'Mundur -- Kozhikode B.O','673580',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124728,443,'Murampathy B.O','673580',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124729,443,'Muthappan Puzha B.O','673603',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124730,443,'Muttancheri B.O','673585',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124731,443,'Mysore Mala B.O','673602',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124732,443,'Nadakavu S.O','673011',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124733,443,'Nallalam S.O','673027',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124734,443,'Nanminda S.O','673613',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124735,443,'Narikkuni S.O','673585',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124736,443,'Nayar Kuzhi B.O','673601',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124737,443,'Nedungottur B.O','673010',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124738,443,'Neeleswaram B.O','673582',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124739,443,'Nellicode B.O','673016',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124740,443,'Nellika Paramba B.O','673602',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124741,443,'Nit  Campus Po.Kozhikode S.O','673601',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124742,443,'Nooramthode B.O','673586',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124743,443,'Olavanna B.O','673019',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124744,443,'Omasseri S.O','673582',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124745,443,'Padanilam B.O','673571',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124746,443,'Palath B.O','673611',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124747,443,'Pannicode B.O','673602',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124748,443,'Pannikkottur B.O','673572',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124749,443,'Pantheerankavu S.O','673019',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124750,443,'Parambil B.O','673012',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124751,443,'Parannur B.O','673585',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124752,443,'Parappanpoyil B.O','673573',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124753,443,'Parappil S.O','673001',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124754,443,'Paropadi B.O','673009',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124755,443,'Pavandur B.O','673613',1,0,'2022-03-04 19:24:47','2022-03-04 19:24:47'),(124756,443,'Payimbra B.O','673571',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124757,443,'Pazhur B.O','673661',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124758,443,'Peringalam B.O','673571',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124759,443,'Perumanna B.O','673019',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124760,443,'Perumpally B.O','673586',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124761,443,'Perumukham B.O','673631',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124762,443,'Peruvayal B.O','673008',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124763,443,'Pilasseri B.O','673571',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124764,443,'Pokkunnu B.O','673007',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124765,443,'Ponnamkayam B.O','673603',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124766,443,'Poovaranthod B.O','673604',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124767,443,'Poovattu Paramba B.O','673008',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124768,443,'Puduppadi S.O','673586',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124769,443,'Pulluram Para B.O','673603',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124770,443,'Punnakkal B.O','673603',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124771,443,'Punnasseri B.O','673585',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124772,443,'Punnur - Cherupalam B.O','673585',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124773,443,'Puthiya Nirathu B.O','673303',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124774,443,'Puthiyangadi S.O','673021',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124775,443,'Puthiyara S.O','673004',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124776,443,'Puthur- Kotuvalli B.O','673582',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124777,443,'Ramanattukara S.O','673633',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124778,443,'Santhi Nagar B.O','673582',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124779,443,'Sreerama Krishna Mission B.O','673003',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124780,443,'St.Vincent Colony B.O','673006',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124781,443,'Tali S.O','673002',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124782,443,'Tamaracheri S.O','673573',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124783,443,'Thachampoyil B.O','673573',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124784,443,'Thambalamanna B.O','673603',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124785,443,'Theyyappara B.O','673580',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124786,443,'Thiruthiyad B.O','673004',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124787,443,'Tiruvambadi S.O','673603',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124788,443,'Tiruvannur B.O','673029',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124789,443,'Tiruvannur Nada S.O','673029',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124790,443,'Vaidyarangadi B.O','673633',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124791,443,'Valiyaparamba B.O','673572',1,0,'2022-03-04 19:24:48','2022-03-04 19:24:48'),(124792,443,'Vavad B.O','673572',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124793,443,'Velancode B.O','673580',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124794,443,'Velimanna B.O','673582',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124795,443,'Vellalasseri B.O','673601',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124796,443,'Vellayikkode B.O','673019',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124797,443,'Vellayil S.O','673011',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124798,443,'Velliparamba B.O','673008',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124799,443,'Venappara B.O','673582',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124800,443,'Vengalam B.O','673303',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124801,443,'Vengeri B.O','673010',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124802,443,'Vrindavan Colony B.O','673017',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124803,443,'West Hill Beach S.O','673005',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124804,443,'West Hill Chungam B.O','673005',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124805,443,'West Hill S.O','673005',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124806,443,'Abhayagiri B.O','673517',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124807,443,'Adukkath B.O','673508',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124808,443,'Akkal B.O','673513',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124809,443,'Annasseri B.O','673317',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124810,443,'Arikulam B.O','673620',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124811,443,'Arur B.O','673507',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124812,443,'Atholi S.O','673315',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124813,443,'Avadukka B.O','673528',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124814,443,'Avala B.O','673524',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124815,443,'Avitanallur B.O','673614',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124816,443,'Ayancheri B.O','673541',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124817,443,'Ayanikkad B.O','673521',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124818,443,'Azhiyur S.O','673309',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124819,443,'Balusseri S.O','673612',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124820,443,'Bhumivathukkal B.O','673517',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124821,443,'Chakkittapara B.O','673526',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124822,443,'Chaniyankadavu B.O','673541',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124823,443,'Chappanthottam B.O','673513',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124824,443,'Chathangottunada B.O','673513',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124825,443,'Cheekilode B.O','673315',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124826,443,'Cheekkonnummal B.O','673507',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124827,443,'Cheekonnummal  West B.O','673507',1,0,'2022-03-04 19:24:49','2022-03-04 19:24:49'),(124828,443,'Chekkiyad B.O','673509',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124829,443,'Chelakkad B.O','673506',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124830,443,'Cheliya B.O','673306',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124831,443,'Chemancheri S.O','673304',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124832,443,'Chemmarathur B.O','673104',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124833,443,'Chempanoda B.O','673528',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124834,443,'Chengaroth B.O','673528',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124835,443,'Chenoli B.O','673525',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124836,443,'Cherandathur B.O','673541',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124837,443,'Cherapuram B.O','673507',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124838,443,'Cherukad B.O','673527',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124839,443,'Cherumoth B.O','673517',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124840,443,'Cheruvannur Meladi B.O','673524',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124841,443,'Chingapuram B.O','673529',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124842,443,'Chombala S.O','673308',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124843,443,'Chorode East B.O','673106',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124844,443,'Chorode S.O','673106',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124845,443,'Chuzhali B.O','673517',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124846,443,'Edacheri North B.O','673502',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124847,443,'Edacheri S.O','673502',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124848,443,'Edakulam  Koyilandi S.O','673306',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124849,443,'Edavarad B.O','673525',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124850,443,'Ekarool B.O','673574',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124851,443,'Emmamparamba B.O','673574',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124852,443,'Eramala B.O','673501',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124853,443,'Eramangalam B.O','673612',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124854,443,'Eravattur B.O','673525',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124855,443,'Indira Nagar B.O','673506',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124856,443,'Iringal S.O','673521',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124857,443,'Iringannur B.O','673505',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124858,443,'Iringath B.O','673523',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124859,443,'Iyyad B.O','673574',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124860,443,'Iyyangode B.O','673504',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124861,443,'Kadiyangad B.O','673525',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124862,443,'Kakkancheri B.O','673620',1,0,'2022-03-04 19:24:50','2022-03-04 19:24:50'),(124863,443,'Kakkattil S.O','673507',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124864,443,'Kakkayam S.O','673615',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124865,443,'Kallachi S.O','673506',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124866,443,'Kallanode B.O','673615',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124867,443,'Kallunira B.O','673517',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124868,443,'Kalpathur B.O','673524',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124869,443,'Kannadipoil B.O','673612',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124870,443,'Kannookkara B.O','673102',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124871,443,'Kappad B.O','673304',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124872,443,'Karandode B.O','673508',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124873,443,'Karayad B.O','673524',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124874,443,'Karingad B.O','673513',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124875,443,'Kariyathankavu B.O','673612',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124876,443,'Karthikappally B.O','673542',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124877,443,'Karumala B.O','673612',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124878,443,'Karuvannur B.O','673614',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124879,443,'Katalur B.O','673529',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124880,443,'Katameri B.O','673542',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124881,443,'Katcheri B.O','673502',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124882,443,'Kavil B.O','673614',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124883,443,'Kavilampara S.O','673513',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124884,443,'Kayakodi B.O','673508',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124885,443,'Kayanna Bazar B.O','673525',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124886,443,'Kayanna S.O','673526',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124887,443,'Kayappanichi B.O','673505',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124888,443,'Keezhariyur B.O','673307',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124889,443,'Keezhil B.O','673104',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124890,443,'Kilinnanyam B.O','673525',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124891,443,'Kilur Meladi B.O','673522',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124892,443,'Kinalur B.O','673612',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124893,443,'Kizhpayur B.O','673524',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124894,443,'Kodiyura B.O','673506',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124895,443,'Kokkallur B.O','673612',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124896,443,'Kolakkad B.O','673315',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124897,443,'Kolathur B.O','673315',1,0,'2022-03-04 19:24:51','2022-03-04 19:24:51'),(124898,443,'Kollam S.O','673307',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124899,443,'Kongannur B.O','673315',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124900,443,'Koorachundu S.O','673527',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124901,443,'Koothali B.O','673525',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124902,443,'Korothroad B.O','673309',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124903,443,'Kotancheri B.O','673503',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124904,443,'Kottakkal-igl B.O','673521',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124905,443,'Kottappalli B.O','673542',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124906,443,'Kottur B.O','673614',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124907,443,'Koyilandi H.O','673305',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124908,443,'Kozhukkallur B.O','673524',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124909,443,'Kunduthode B.O','673513',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124910,443,'Kuningad B.O','673503',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124911,443,'Kunnathara B.O','673620',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124912,443,'Kunnummakkara B.O','673308',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124913,443,'Kurichagam B.O','673508',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124914,443,'Kurikkilad B.O','673104',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124915,443,'Kurinhaliyode B.O','673542',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124916,443,'Kuruvangad B.O','673620',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124917,443,'Kuttiadi S.O','673508',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124918,443,'Kuttoth B.O','673524',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124919,443,'Madappalli College S.O','673102',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124920,443,'Mahe S.O','673310',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124921,443,'Mandarathur B.O','673105',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124922,443,'Mangad B.O','673574',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124923,443,'Maniyur B.O','673523',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124924,443,'Mannankavu B.O','673614',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124925,443,'Marudonkara B.O','673513',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124926,443,'Mattanode B.O','673527',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124927,443,'Mayyannur B.O','673542',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124928,443,'Melur B.O','673306',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124929,443,'Memunda B.O','673104',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124930,443,'Mennaniam B.O','673525',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124931,443,'Meppayil B.O','673104',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124932,443,'Meppayur S.O','673524',1,0,'2022-03-04 19:24:52','2022-03-04 19:24:52'),(124933,443,'Modakkallur B.O','673315',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124934,443,'Moilothara B.O','673513',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124935,443,'Mokeri Nadapuram B.O','673507',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124936,443,'Moolad B.O','673614',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124937,443,'Muchukunnu B.O','673307',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124938,443,'Mudadi B.O','673307',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124939,443,'Mudadi North B.O','673307',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124940,443,'Mudavantheri B.O','673505',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124941,443,'Mullambath B.O','673507',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124942,443,'Muthukad B.O','673528',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124943,443,'Muthuuvana B.O','673523',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124944,443,'Muthuvadathur B.O','673503',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124945,443,'Muthuvannacha B.O','673508',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124946,443,'Muttungal B.O','673106',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124947,443,'Muttungal West B.O','673106',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124948,443,'Muyipoth B.O','673524',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124949,443,'Nadakkuthala B.O','673104',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124950,443,'Nadapuram S.O','673504',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124951,443,'Naderi B.O','673620',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124952,443,'Naduvannur S.O','673614',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124953,443,'Naduvathur B.O','673620',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124954,443,'Naripetta B.O','673506',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124955,443,'Nedumparamba B.O','673506',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124956,443,'Nittur B.O','673507',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124957,443,'Nitumannur B.O','673507',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124958,443,'Nochat B.O','673614',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124959,443,'Nut Street S.O','673104',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124960,443,'Onchiyam B.O','673308',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124961,443,'Oravil B.O','673614',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124962,443,'Orkatteri S.O','673501',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124963,443,'Padiripetta B.O','673507',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124964,443,'Palayad Nada B.O','673521',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124965,443,'Paleri B.O','673508',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124966,443,'Paleri Town B.O','673508',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124967,443,'Pallikara B.O','673522',1,0,'2022-03-04 19:24:53','2022-03-04 19:24:53'),(124968,443,'Panangad Qdi B.O','673612',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124969,443,'Parakkadavu S.O','673509',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124970,443,'Pasukkadavu B.O','673513',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124971,443,'Pathiyarakkara B.O','673105',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124972,443,'Payyoli Angadi S.O','673523',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124973,443,'Payyoli S.O','673522',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124974,443,'Perampra S.O','673525',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124975,443,'Perode B.O','673504',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124976,443,'Peruvannamuzhi S.O','673528',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124977,443,'Peruvattur B.O','673620',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124978,443,'Ponmeri Parambil B.O','673542',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124979,443,'Poolakkul B.O','673507',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124980,443,'Poothampara B.O','673513',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124981,443,'Poozhithode B.O','673528',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124982,443,'Puduppanam S.O','673105',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124983,443,'Puliyavil B.O','673509',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124984,443,'Punath B.O','673614',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124985,443,'Purakkad B.O','673522',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124986,443,'Purameri S.O','673503',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124987,443,'Puthur B.O','673104',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124988,443,'Quilandibazar S.O','673620',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124989,443,'Rayarangoth B.O','673102',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124990,443,'Siddhasamaj B.O','673104',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124991,443,'Talayad B.O','673574',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124992,443,'Taliyil B.O','673508',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124993,443,'Thalakolathur S.O','673317',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124994,443,'Thanakottur B.O','673509',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124995,443,'Thandorapara B.O','673526',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124996,443,'Tharopoyil B.O','673541',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124997,443,'Thinur B.O','673507',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124998,443,'Thiruvallur S.O','673541',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(124999,443,'Thodannur B.O','673541',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(125000,443,'Thuruthiyad B.O','673612',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(125001,443,'Thuvakkode B.O','673304',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(125002,443,'Tikkoti S.O','673529',1,0,'2022-03-04 19:24:54','2022-03-04 19:24:54'),(125003,443,'Tiruvangoor B.O','673304',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125004,443,'Tiruvode B.O','673614',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125005,443,'Tuneri S.O','673505',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125006,443,'Ulliyeri B.O','673620',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125007,443,'Unnikulam S.O','673574',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125008,443,'Urallur B.O','673620',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125009,443,'Vadakara Beach S.O','673103',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125010,443,'Vadakara H.O','673101',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125011,443,'Vakayad B.O','673614',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125012,443,'Valayam S.O','673517',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125013,443,'Valliyad B.O','673542',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125014,443,'Vanimal B.O','673506',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125015,443,'Vannathichira B.O','673513',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125016,443,'Varikoli B.O','673506',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125017,443,'Vatayam B.O','673507',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125018,443,'Vattoli B.O','673507',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125019,443,'Vattoli Bazar B.O','673612',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125020,443,'Vayalada B.O','673574',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125021,443,'Vayikkilassery B.O','673104',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125022,443,'Velom B.O','673508',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125023,443,'Velom Peruvayal B.O','673508',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125024,443,'Velur West B.O','673315',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125025,443,'Vilangad B.O','673506',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125026,443,'Villyappalli S.O','673542',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125027,443,'Vishnumangalam B.O','673506',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125028,444,'Azhinjilam B.O','673632',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125029,444,'Karad Paramba B.O','673632',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125030,444,'Puducode - Feroke B.O','673633',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125031,444,'Vazhayur B.O','673633',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125032,444,'Vazhayur East B.O','673633',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125033,444,'Adakkakundu B.O','676525',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125034,444,'Akkaparamba B.O','673641',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125035,444,'Aliparamba B.O','679357',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125036,444,'Amarambalam B.O','679332',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125037,444,'Amarambalam South B.O','679339',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125038,444,'Amayur B.O','676123',1,0,'2022-03-04 19:24:55','2022-03-04 19:24:55'),(125039,444,'Ambalakkadavu B.O','676525',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125040,444,'Amminikkad B.O','679322',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125041,444,'Anakkayam B.O','676509',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125042,444,'Anamangad S.O','679357',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125043,444,'Anchachavady B.O','676525',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125044,444,'Andiyoorkunnu B.O','673637',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125045,444,'Angadipuram S.O','679321',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125046,444,'Areacode S.O','673639',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125047,444,'Arimanal B.O','676525',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125048,444,'Arimbra B.O','673638',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125049,444,'Aripra B.O','679321',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125050,444,'Arkkuparamba B.O','679341',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125051,444,'Aurvacode B.O','679329',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125052,444,'Ayikkarapadi B.O','673637',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125053,444,'Bhoodan Colony B.O','679334',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125054,444,'Calicut Airport S.O','673647',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125055,444,'Calicut University S.O','673635',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125056,444,'Chandakkunnu B.O','679329',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125057,444,'Chathallur B.O','676541',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125058,444,'Chathangottupuram B.O','679328',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125059,444,'Chattipparamba B.O','676504',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125060,444,'Chelakkad B.O','679323',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125061,444,'Chelembra S.O','673634',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125062,444,'Chembrassei B.O','676521',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125063,444,'Chembrasseri East B.O','679327',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125064,444,'Chemmalasseri B.O','679323',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125065,444,'Chemmaniyode B.O','679325',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125066,444,'Chemmarakkattur B.O','673639',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125067,444,'Chenakkalangadi B.O','673636',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125068,444,'Cherakkaparamba B.O','679321',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125069,444,'Cherukara S.O','679340',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125070,444,'Cheruvayur S.O','673645',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125071,444,'Chettippadam B.O','679332',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125072,444,'Chikkode B.O','673645',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125073,444,'Chirayil B.O','673638',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125074,444,'Chokkad B.O','679332',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125075,444,'Chulliyode B.O','679332',1,0,'2022-03-04 19:24:56','2022-03-04 19:24:56'),(125076,444,'Chungathara S.O','679334',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125077,444,'Downhill S.O','676519',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125078,444,'Edakkara-nilambur S.O','679331',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125079,444,'Edapatta B.O','679326',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125080,444,'Edavanna S.O','676541',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125081,444,'Edayattur B.O','679326',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125082,444,'Edivanna B.O','679329',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125083,444,'Elad B.O','679340',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125084,444,'Elankur B.O','676122',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125085,444,'Eranhikode B.O','676541',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125086,444,'Eranhimangad B.O','679329',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125087,444,'Eravimangalam B.O','679340',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125088,444,'Erumamunda B.O','679334',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125089,444,'Ezhupathekkar B.O','676525',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125090,444,'Hajiarpalli B.O','676519',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125091,444,'Iringattiri B.O','676523',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125092,444,'Irumbuzhi B.O','676509',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125093,444,'Iruvetti B.O','673639',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125094,444,'Kadambode B.O','676521',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125095,444,'Kadannamanna B.O','679324',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125096,444,'Kadungapurm B.O','679321',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125097,444,'Kalikavu S.O','676525',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125098,444,'Kalkundu B.O','676523',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125099,444,'Kambalakallu B.O','679333',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125100,444,'Kannamvettikavu B.O','673637',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125101,444,'Kappil B.O','679328',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125102,444,'Karad B.O','679339',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125103,444,'Karakkode B.O','679333',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125104,444,'Karakkunnu B.O','676123',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125105,444,'Karapuram B.O','679331',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125106,444,'Karippur B.O','673638',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125107,444,'Karulai B.O','679330',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125108,444,'Karumarakkad B.O','673640',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125109,444,'Karuvambram S.O','676123',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125110,444,'Karuvambram West B.O','676123',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125111,444,'Karuvarakundu S.O','676523',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125112,444,'Kavalamukkatta B.O','679332',1,0,'2022-03-04 19:24:57','2022-03-04 19:24:57'),(125113,444,'Kavanur B.O','673639',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125114,444,'Kerala Estate B.O','676525',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125115,444,'Kizhakkumpadam B.O','679326',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125116,444,'Kizhattur B.O','679325',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125117,444,'Kizhuparamba B.O','673639',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125118,444,'Kodur-malabar S.O','676504',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125119,444,'Kolakkattuchali B.O','673634',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125120,444,'Kolaparamba S.O','676522',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125121,444,'Kolathur-MLP S.O','679338',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125122,444,'Kondotti S.O','673638',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125123,444,'Koomankulam B.O','676123',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125124,444,'Koorad B.O','679339',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125125,444,'Koottil B.O','679324',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125126,444,'Kottilangadi S.O','676506',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125127,444,'Kumminiparamba B.O','673638',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125128,444,'Kunnakkavu B.O','679340',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125129,444,'Kunnappally B.O','679322',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125130,444,'Kunnummalpotti B.O','679331',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125131,444,'Kurumbalangode B.O','679334',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125132,444,'Kuruvambalam B.O','679338',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125133,444,'Kuttathy B.O','676523',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125134,444,'Kuzhimanna S.O','673641',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125135,444,'Maithra B.O','673639',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125136,444,'Makkaraparamba S.O','676507',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125137,444,'Malappuram Civil Station S.O','676505',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125138,444,'Malappuram H.O','676505',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125139,444,'Mampad College B.O','676542',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125140,444,'Mampad S.O','676542',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125141,444,'Mampattumoola B.O','679332',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125142,444,'Manalaya B.O','679357',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125143,444,'Manhappatta B.O','676123',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125144,444,'Manimooly S.O','679333',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125145,444,'Manjeri Bazar S.O','676121',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125146,444,'Manjeri College S.O','676122',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125147,444,'Manjeri-kla H.O','676121',1,0,'2022-03-04 19:24:58','2022-03-04 19:24:58'),(125148,444,'Mankada Pallippuram B.O','679324',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125149,444,'Mankada S.O','679324',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125150,444,'Mannarmala B.O','679325',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125151,444,'Mannathipoyil B.O','679332',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125152,444,'Mariyad B.O','676122',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125153,444,'Marutha B.O','679333',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125154,444,'Mattarakkal B.O','679341',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125155,444,'Melangadi B.O','673638',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125156,444,'Melattur S.O (Malappuram)','679326',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125157,444,'Melmuri B.O','676517',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125158,444,'Meppadam B.O','676542',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125159,444,'Modapoika B.O','679331',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125160,444,'Mongam S.O','673642',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125161,444,'Moorkkanad B.O','679338',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125162,444,'Moothedam B.O','679331',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125163,444,'Morayur B.O','673642',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125164,444,'Munda B.O','679331',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125165,444,'Mundakkal B.O','673645',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125166,444,'Munderi B.O','679334',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125167,444,'Munduparmba S.O','676509',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125168,444,'Muthuparamba B.O','673638',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125169,444,'Muthuvallur B.O','673638',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125170,444,'Naduvath B.O','679328',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125171,444,'Nallanthanni B.O','679330',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125172,444,'Nambooripotty B.O','679333',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125173,444,'Narukara B.O','676122',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125174,444,'Nediyirippu B.O','673638',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125175,444,'Neelancheri B.O','676525',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125176,444,'Nellikuth B.O','676122',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125177,444,'Nilambur RS S.O','679330',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125178,444,'Nilambur S.O','679329',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125179,444,'Olamathil B.O','673642',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125180,444,'Olavattur B.O','673638',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125181,444,'Olukur B.O','673642',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125182,444,'Omanur B.O','673645',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125183,444,'Oorakam Kizhumuri B.O','676519',1,0,'2022-03-04 19:24:59','2022-03-04 19:24:59'),(125184,444,'Oorakam Melmuri B.O','676519',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125185,444,'Padinhattumuri B.O','676506',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125186,444,'Padirikode B.O','679326',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125187,444,'Padiripadam B.O','679334',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125188,444,'Palachode B.O','679338',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125189,444,'Palakkad(MLP) B.O','673641',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125190,444,'Palakkalvetta B.O','679327',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125191,444,'Palathole B.O','679340',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125192,444,'Palemad B.O','679331',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125193,444,'Palengara B.O','679330',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125194,444,'Pallikkal B.O','673634',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125195,444,'Pallikuth B.O','679334',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125196,444,'Panampilavu B.O','673639',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125197,444,'Pandallur B.O','676521',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125198,444,'Pandallur Hills B.O','676521',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125199,444,'Pandikkad S.O','676521',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125200,444,'Panga B.O','679338',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125201,444,'Panga Chendy B.O','679338',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125202,444,'Panga South B.O','679338',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125203,444,'Pannippara B.O','676541',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125204,444,'Pappinippara B.O','676122',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125205,444,'Pariyapuram B.O','679321',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125206,444,'Pathaikara B.O','679322',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125207,444,'Pathappiriyam B.O','676123',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125208,444,'Pathar B.O','679334',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125209,444,'Pathiriyal B.O','676123',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125210,444,'Pattarkadavu B.O','676519',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125211,444,'Pattikkad S.O','679325',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125212,444,'Payyanad B.O','676122',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125213,444,'Pazhamallur B.O','676506',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125214,444,'Perakamanna B.O','676541',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125215,444,'Perimbalam B.O','676509',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125216,444,'Perintalmanna S.O','679322',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125217,444,'Perinthattiri B.O','676507',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125218,444,'Peruparamba-ugrapuram B.O','673639',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125219,444,'Peruvallur B.O','673638',1,0,'2022-03-04 19:25:00','2022-03-04 19:25:00'),(125220,444,'Ponniyakurissi B.O','679322',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125221,444,'Pookkottumpadam S.O','679332',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125222,444,'Pookkottur S.O','676517',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125223,444,'Pookottumanna B.O','679334',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125224,444,'Poolamanna B.O','679327',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125225,444,'Poongode B.O','679327',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125226,444,'Poonthavanam B.O','679325',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125227,444,'Poovathikkal B.O','673639',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125228,444,'Porur B.O','679339',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125229,444,'Pulamanthole S.O','679323',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125230,444,'Pulikkal S.O','673637',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125231,444,'Puliyakkode B.O','673641',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125232,444,'Pullancheri B.O','676122',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125233,444,'Pullengode B.O','676525',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125234,444,'Pulliparamba B.O','673634',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125235,444,'Pullippadam B.O','676542',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125236,444,'Pulpatta B.O','676123',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125237,444,'Pulvetta B.O','676523',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125238,444,'Punnappala B.O','679328',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125239,444,'Puthanangadi B.O','679321',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125240,444,'Puthur-pallikkal B.O','673636',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125241,444,'Puzhakkattiri B.O','679321',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125242,444,'Ramankuth B.O','679330',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125243,444,'Ramapuram B.O','679321',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125244,444,'T.K.Colony B.O','679332',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125245,444,'Talekode','679341',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125246,444,'Talekode West B.O','679341',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125247,444,'Tavanur-feroke B.O','673641',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125248,444,'Tenhipalam S.O','673636',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125249,444,'Thachinganadam B.O','679325',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125250,444,'Tharis B.O','676523',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125251,444,'Thelakkad B.O','679325',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125252,444,'Theyyathumpadam B.O','679331',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125253,444,'Thootha B.O','679357',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125254,444,'Thottilangadi B.O','673639',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125255,444,'Thottumukkam B.O','673639',1,0,'2022-03-04 19:25:01','2022-03-04 19:25:01'),(125256,444,'Thurakkal B.O','673638',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125257,444,'Tirurkad B.O','679321',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125258,444,'Tiruvali B.O','676123',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125259,444,'Trikkalangode B.O','676123',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125260,444,'Trippanachi B.O','673641',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125261,444,'Tuvvur S.O','679327',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125262,444,'Uppada B.O','679334',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125263,444,'Urangattiri B.O','673639',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125264,444,'Vadakkangara B.O','679324',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125265,444,'Vadakkumpadam B.O','679339',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125266,444,'Vadapuram B.O','676542',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125267,444,'Vakkethodi B.O','676122',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125268,444,'Valambur B.O','679325',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125269,444,'Valamkulam B.O','679357',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125270,444,'Valapuram B.O','679323',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125271,444,'Valillapuzha B.O','673639',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125272,444,'Valiyaparamba B.O','673637',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125273,444,'Vallikkapatta B.O','679324',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125274,444,'Valluvambram B.O','673642',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125275,444,'Valluvangad B.O','676521',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125276,444,'Valluvangad South B.O','676521',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125277,444,'Vaniyambalam S.O','679339',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125278,444,'Vattalur B.O','676507',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125279,444,'Vazhakkad S.O','673640',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125280,444,'Vazhenkada B.O','679357',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125281,444,'Vazhikkadavu B.O','679333',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125282,444,'Vellayur B.O','679327',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125283,444,'Vellila B.O','679324',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125284,444,'Velliyanchery B.O','679326',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125285,444,'Vellur B.O','676517',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125286,444,'Vengad B.O','679338',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125287,444,'Vengoor B.O','679325',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125288,444,'Vettathur B.O','679326',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125289,444,'Vettilappara B.O','673639',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125290,444,'Vilayil B.O','673641',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125291,444,'Wandoor S.O','679328',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125292,444,'Abdurahiman Nagar S.O','676305',1,0,'2022-03-04 19:25:02','2022-03-04 19:25:02'),(125293,444,'Alankode S.O','679585',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125294,444,'Alathiyur B.O','676102',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125295,444,'Ananthavur B.O','676301',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125296,444,'Anjapura B.O','676303',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125297,444,'Ariyallur S.O','676312',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125298,444,'Athalur B.O','679573',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125299,444,'Athavanad B.O','676301',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125300,444,'Athrisseri B.O','676106',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125301,444,'Ayankalam B.O','679573',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125302,444,'Ayilakkad B.O','679576',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125303,444,'Ayirur B.O','679580',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125304,444,'Bettath Pudiangadi S.O','676102',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125305,444,'Biyyam B.O','679576',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125306,444,'Chamravattom B.O','676102',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125307,444,'Chappanangadi B.O','676503',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125308,444,'Chengottur B.O','676503',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125309,444,'Chennara B.O','676561',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125310,444,'Cheriyamundam B.O','676106',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125311,444,'Cherumukku B.O','676306',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125312,444,'Cherur B.O','676304',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125313,444,'Cherushola B.O','676510',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125314,444,'Cheruvallur B.O','679575',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125315,444,'Chettipadi S.O','676319',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125316,444,'Chullippara B.O','676508',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125317,444,'Codacal B.O','676108',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125318,444,'Edapal S.O','679576',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125319,444,'Edarikode S.O','676501',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125320,444,'Edayur B.O','676552',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125321,444,'Edayur North B.O','676552',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125322,444,'Eramangalam S.O','679587',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125323,444,'Gramam B.O','679579',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125324,444,'Indianur B.O','676503',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125325,444,'Irimbiliyam S.O','679572',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125326,444,'Iringallur B.O','676304',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125327,444,'Iringavur B.O','676103',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125328,444,'Iswaramangalam B.O','679573',1,0,'2022-03-04 19:25:03','2022-03-04 19:25:03'),(125329,444,'Kadalundinagaram S.O','673314',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125330,444,'Kadampuzha S.O','676553',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125331,444,'Kadancheri B.O','679582',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125332,444,'Kadavanad B.O','679586',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125333,444,'Kakkad B.O','676306',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125334,444,'Kaladi-MLP S.O','679582',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125335,444,'Kallarmangalam B.O','676553',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125336,444,'Kalpakancheri S.O','676551',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125337,444,'Kanhiramukku S.O','679584',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125338,444,'Kanmanam B.O','676551',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125339,444,'Kanmanam-thekkummuri B.O','676551',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125340,444,'Kannamangalam B.O','676304',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125341,444,'Kannamangalam West B.O','676305',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125342,444,'Kannattipadi B.O','676304',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125343,444,'Karekkad B.O','676553',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125344,444,'Karippol B.O','676552',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125345,444,'Karthala B.O','679571',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125346,444,'Karukathiruthy B.O','679584',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125347,444,'Kavancheri B.O','676561',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125348,444,'Keraladheeswarapuram B.O','676307',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125349,444,'Klari B.O','676501',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125350,444,'Kodinhi S.O','676309',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125351,444,'Kokkur S.O','679591',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125352,444,'Kololamba B.O','679576',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125353,444,'Kooriyad B.O','676306',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125354,444,'Kotakkad B.O','676319',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125355,444,'Kottakkal S.O','676503',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125356,444,'Kuruga B.O','676551',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125357,444,'Kurumbathur B.O','676301',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125358,444,'Kuttayi S.O','676562',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125359,444,'Kuttippala B.O','676501',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125360,444,'Kuttippuram S.O','679571',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125361,444,'Kuttippuram-kottakkal B.O','676503',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125362,444,'Kuttur North B.O','676305',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125363,444,'Mampuram B.O','676306',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125364,444,'Mangalam-MLP S.O','676561',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125365,444,'Mangattiri B.O','676105',1,0,'2022-03-04 19:25:04','2022-03-04 19:25:04'),(125366,444,'Marakkara B.O','676553',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125367,444,'Marancheri S.O','679581',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125368,444,'Mattathur B.O','676528',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125369,444,'Meenadathur B.O','676307',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125370,444,'Mookkuthala S.O','679574',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125371,444,'Mooniyur S.O','676311',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125372,444,'Moonniyur South B.O','676311',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125373,444,'Mudur B.O','679578',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125374,444,'Muttanur B.O','676561',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125375,444,'Naduvattom B.O','679571',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125376,444,'Nannambra B.O','676320',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125377,444,'Nannamukku S.O','679575',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125378,444,'Nannamukku South B.O','679575',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125379,444,'Nariparamba B.O','679573',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125380,444,'Neduva B.O','676303',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125381,444,'Niramaruthur S.O','676109',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125382,444,'Olakara B.O','676306',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125383,444,'Omachapuzha B.O','676320',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125384,444,'Othalur West B.O','679591',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125385,444,'Othukkungal S.O','676528',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125386,444,'Ozhur B.O','676307',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125387,444,'Pachattiri B.O','676105',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125388,444,'Padinharekkara B.O','676562',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125389,444,'Palapetty B.O','679579',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125390,444,'Panangattur B.O','676302',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125391,444,'Pandamangalam B.O','676503',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125392,444,'Pantarangadi B.O','676306',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125393,444,'Parambilpeedika B.O','676317',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125394,444,'Parammalangadi B.O','676551',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125395,444,'Parappur B.O','676503',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125396,444,'Paravanna S.O','676502',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125397,444,'Pariyapuram B.O','676302',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125398,444,'Parpanangadi S.O','676303',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125399,444,'Pathayakallu B.O','676553',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125400,444,'Payinkanniyur B.O','679571',1,0,'2022-03-04 19:25:05','2022-03-04 19:25:05'),(125401,444,'Pazhanji-mlp B.O','679579',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125402,444,'Pazhur B.O','679571',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125403,444,'Perasannur B.O','679571',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125404,444,'Perumbadappu S.O','679580',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125405,444,'Perumparamba B.O','679576',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125406,444,'Pidavannur B.O','679574',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125407,444,'Polpakara B.O','679576',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125408,444,'Ponani H.O','679577',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125409,444,'Ponani Nagaram S.O','679583',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125410,444,'Ponani South S.O','679586',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125411,444,'Ponmala B.O','676528',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125412,444,'Ponmundam S.O','676106',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125413,444,'Pookayil Bazar S.O','676107',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125414,444,'Poyilisseri B.O','676102',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125415,444,'Puduppalli B.O','676102',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125416,444,'Punnathala B.O','676552',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125417,444,'Puramannur B.O','676552',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125418,444,'Puranga B.O','679584',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125419,444,'Purathur B.O','676102',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125420,444,'Puthiyakadappuram B.O','676302',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125421,444,'Puthuparamba B.O','676501',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125422,444,'Puthur -kottakkal B.O','676503',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125423,444,'Randathani S.O','676510',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125424,444,'Sugapuram B.O','679576',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125425,444,'Tanalur S.O','676307',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125426,444,'Tanur Nagaram B.O','676302',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125427,444,'Tanur-MBR S.O','676302',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125428,444,'Tavanur S.O','679573',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125429,444,'Tayyalingal S.O','676320',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125430,444,'Thalakkadathur S.O','676103',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125431,444,'Thekkankuttur B.O','676551',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125432,444,'Thekkummuri S.O','676105',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125433,444,'Thennala B.O','676508',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125434,444,'Tirunavaya S.O','676301',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125435,444,'Tirur East Bazar S.O','676101',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125436,444,'Tirur(kerala) H.O','676101',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125437,444,'Tirurangadi Bazar S.O','676306',1,0,'2022-03-04 19:25:06','2022-03-04 19:25:06'),(125438,444,'Tirurangadi S.O','676306',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125439,444,'Tolavanur B.O','676552',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125440,444,'Trikkanapuram B.O','679573',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125441,444,'Trikkandiyur S.O','676104',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125442,444,'Triprangode S.O','676108',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125443,444,'Ullanam B.O','676303',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125444,444,'Ullanam North B.O','676303',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125445,444,'Vadakkumbram B.O','676552',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125446,444,'Vakkad B.O','676502',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125447,444,'Valakolam S.O','676508',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125448,444,'Valancheri S.O','676552',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125449,444,'Valavannur B.O','676551',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125450,444,'Valiyakunnu B.O','676552',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125451,444,'Valiyora B.O','676304',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125452,444,'Vallikkunnu B.O','673314',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125453,444,'Vallikkunnu North B.O','673314',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125454,444,'Vattamkulam S.O','679578',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125455,444,'Veliankode S.O','679579',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125456,444,'Velimukku S.O','676317',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125457,444,'Velimukku South B.O','676317',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125458,444,'Vellachal B.O','676106',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125459,444,'Vengalur B.O','676102',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125460,444,'Vengara MLP S.O','676304',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125461,444,'Venniyur B.O','676508',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125462,444,'Vettom B.O','676102',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125463,444,'Vettom-pallippuram B.O','676102',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125464,444,'Vyrancode B.O','676301',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125465,445,'Adakkaputhur B.O','679503',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125466,445,'Agali S.O (Palakkad)','678581',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125467,445,'Akalur B.O','679302',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125468,445,'Alanallur S.O','678601',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125469,445,'Alangad B.O','678633',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125470,445,'Amayur B.O','679303',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125471,445,'Ambalapara S.O','679512',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125472,445,'Ambalavattom B.O','679501',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125473,445,'Anakkara S.O (Palakkad)','679551',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125474,445,'Angadi B.O','679552',1,0,'2022-03-04 19:25:07','2022-03-04 19:25:07'),(125475,445,'Ariyur B.O','678583',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125476,445,'Attasseri B.O','679513',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125477,445,'Azhiyannur B.O','678633',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125478,445,'Bhimanad B.O','678601',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125479,445,'Chalavara S.O','679505',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125480,445,'Chalisseri S.O','679536',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125481,445,'Chaliyattiri B.O','679535',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125482,445,'Changileri B.O','678762',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125483,445,'Chathanur B.O','679535',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125484,445,'Chavadiyur B.O','678581',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125485,445,'Chembra B.O','679304',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125486,445,'Cherambattakavu B.O','679501',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125487,445,'Cherottur B.O','679521',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125488,445,'Cherpalcheri S.O','679503',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125489,445,'Cherukattupulam B.O','679522',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125490,445,'Cherukode B.O','679336',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125491,445,'Cherukutangad B.O','679305',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125492,445,'Cherumundasseri B.O','679512',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125493,445,'Chethallur B.O','678583',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125494,445,'Chindaki B.O','678582',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125495,445,'Chittur -agali B.O','678581',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125496,445,'Choorakode B.O','679336',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125497,445,'Chunangad S.O','679511',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125498,445,'Chundampatta B.O','679337',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125499,445,'Edakode(Pavukonam) B.O','679522',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125500,445,'Edathanttukara B.O','678601',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125501,445,'Elambulasseri B.O','678595',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125502,445,'Eravakkad B.O','679552',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125503,445,'Etapalam B.O','679308',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125504,445,'Ezhuvanthala B.O','679335',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125505,445,'Gandhi Seva  Sadan B.O','679302',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125506,445,'Ganeshgiri S.O','679123',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125507,445,'Irimbakachola B.O','678591',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125508,445,'Irimbalasseri B.O','679335',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125509,445,'Jellipara B.O','678581',1,0,'2022-03-04 19:25:08','2022-03-04 19:25:08'),(125510,445,'K A Samajam B.O','679123',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125511,445,'Kacheriparamba B.O','678601',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125512,445,'Kadambur S.O (Palakkad)','679515',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125513,445,'Kaipuram B.O','679308',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125514,445,'Kaithachira B.O','678582',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125515,445,'Kalkandi B.O','678582',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125516,445,'Kalladathur B.O','679552',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125517,445,'Kalladikode S.O','678596',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125518,445,'Kalladipatta S.O','679313',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125519,445,'Kallamala B.O','678582',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125520,445,'Kallipadam B.O','679122',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125521,445,'Kalluvazhi B.O','679514',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125522,445,'Kanayam B.O','679122',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125523,445,'Kandamangalam B.O','678583',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125524,445,'Kanhikulam B.O','678596',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125525,445,'Kanhirapuzha Dam B.O','678591',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125526,445,'Kanhirapuzha S.O','678591',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125527,445,'Kanniampuram S.O','679104',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125528,445,'Kappur B.O','679552',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125529,445,'Karakurissi S.O','678595',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125530,445,'Karalmanna S.O','679506',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125531,445,'Karambathur B.O','679305',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125532,445,'Karara B.O','678581',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125533,445,'Karattukurissi B.O','679503',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125534,445,'Karimba S.O','678597',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125535,445,'Karimpuzha B.O','679513',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125536,445,'Karkitamkunnu B.O','678601',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125537,445,'Karumanamkurissi B.O','679504',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125538,445,'Katambazhipuram S.O','678633',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125539,445,'Kattukulam B.O','679514',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125540,445,'Kattukulam South B.O','679514',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125541,445,'Kavalappara S.O','679523',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125542,445,'Kavundikkal B.O','678581',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125543,445,'Kayiliad B.O','679122',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125544,445,'Kilmuri B.O','679307',1,0,'2022-03-04 19:25:09','2022-03-04 19:25:09'),(125545,445,'Kizhayur B.O','679303',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125546,445,'Kizhur B.O','679501',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125547,445,'Kodakkad B.O','678583',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125548,445,'Kodumunda B.O','679303',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125549,445,'Kolikkottusseri B.O','679303',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125550,445,'Kondurkara B.O','679313',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125551,445,'Konikazhi B.O','678632',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125552,445,'Koonathara B.O','679523',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125553,445,'Koottanad','679533',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125554,445,'Kothachira B.O','679535',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125555,445,'Kottapadam(TTL) B.O','679534',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125556,445,'Kottappuram B.O','679513',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125557,445,'Kottathara B.O','678581',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125558,445,'Kottopadam B.O','678583',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125559,445,'Kudallur S.O','679554',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125560,445,'Kulakkad B.O','679503',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125561,445,'Kulakkattukurissi B.O','678633',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125562,445,'Kulappulli B.O','679122',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125563,445,'Kulukkallur S.O','679337',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125564,445,'Kumaramputhur B.O','678583',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125565,445,'Kumaranellur S.O','679552',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125566,445,'Kumbidi S.O','679553',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125567,445,'Kundurkunnu B.O','678583',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125568,445,'Kunduvampadam B.O','678633',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125569,445,'Kuruvattur B.O','679336',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125570,445,'Kuttanasseri B.O','679514',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125571,445,'Lakkidi S.O','679301',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125572,445,'Mala B.O','679534',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125573,445,'Malamalkkavu B.O','679554',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125574,445,'Mangalam(OPM) B.O','679301',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125575,445,'Mangode B.O','679503',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125576,445,'Manisseri S.O','679521',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125577,445,'Mannampatta B.O','678633',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125578,445,'Mannanur B.O','679523',1,0,'2022-03-04 19:25:10','2022-03-04 19:25:10'),(125579,445,'Mannarkad College S.O','678583',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125580,445,'Mannarkkad S.O','678582',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125581,445,'Mannengode B.O','679307',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125582,445,'Marayamangalam B.O','679335',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125583,445,'Marayamangalam South B.O','679335',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125584,445,'Maruthur B.O','679306',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125585,445,'Mattathukad B.O','678581',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125586,445,'Melepattambi S.O','679306',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125587,445,'Melmuri B.O','679307',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125588,445,'Melur B.O','679501',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125589,445,'Met Ind Nagar B.O','679122',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125590,445,'Mezhathur B.O','679534',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125591,445,'Moonnekkar B.O','678597',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125592,445,'Mudukurissi B.O','678593',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125593,445,'Muduthala B.O','679303',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125594,445,'Mukkali B.O','678582',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125595,445,'Mulanhur B.O','679511',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125596,445,'Mulayankavu B.O','679337',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125597,445,'Mundakkottukurissi B.O','679122',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125598,445,'Munnurkode B.O','679502',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125599,445,'Naduvattom S.O','679308',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125600,445,'Nagalassery B.O','679533',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125601,445,'Nattukal B.O','678583',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125602,445,'Nedungottur B.O','679308',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125603,445,'Nellaya S.O','679335',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125604,445,'Nellikattiri B.O','679533',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125605,445,'Nhangattiri B.O','679303',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125606,445,'Othalur - Ttl B.O','679534',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125607,445,'Ottapalam H.O','679101',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125608,445,'Palakayam B.O','678591',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125609,445,'Palappuram S.O','679103',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125610,445,'Pallikunnu B.O','678583',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125611,445,'Pallikurup B.O','678582',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125612,445,'Pallipuram S.O (Palakkad)','679305',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125613,445,'Palode B.O','678583',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125614,445,'Paloor B.O','678582',1,0,'2022-03-04 19:25:11','2022-03-04 19:25:11'),(125615,445,'Panamanna S.O','679501',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125616,445,'Panamanna South B.O','679501',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125617,445,'Panayur B.O','679522',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125618,445,'Panniyamkurissi B.O','679503',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125619,445,'Parudur B.O','679305',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125620,445,'Paruthipra B.O','679121',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125621,445,'Pathankulam B.O','679522',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125622,445,'Pattambi S.O','679303',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125623,445,'Pattithara B.O','679534',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125624,445,'Payyanadam B.O','678583',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125625,445,'Perimbadari S.O','678762',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125626,445,'Peringannur B.O','679535',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125627,445,'Peringode S.O','679535',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125628,445,'Perumannur B.O','679536',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125629,445,'Perumudiyur B.O','679303',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125630,445,'Perur-OPM S.O','679302',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125631,445,'Pombilaya B.O','679335',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125632,445,'Pombra B.O','678595',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125633,445,'Poonchola B.O','678598',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125634,445,'Pottasseri S.O','678598',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125635,445,'Pudur B.O','678581',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125636,445,'Pulappatta S.O','678632',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125637,445,'Pulasseri S.O','679307',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125638,445,'Puliyanamkunnu B.O','679505',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125639,445,'Pullisseri B.O','678582',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125640,445,'Punchapadam B.O','678633',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125641,445,'S G Press S.O','679122',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125642,445,'Sankaramangalam B.O','679303',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125643,445,'Sholayur-PKD B.O','678581',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125644,445,'Shornur S.O','679121',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125645,445,'Sreeramakrishnanagar B.O','679103',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125646,445,'Srikrishnapuram S.O','679513',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125647,445,'Tachampara S.O','678593',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125648,445,'Taruvakonam B.O','679501',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125649,445,'Tenkara B.O','678582',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125650,445,'Thalakkasseri B.O','679534',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125651,445,'Thanneercode B.O','679536',1,0,'2022-03-04 19:25:12','2022-03-04 19:25:12'),(125652,445,'Thathanampully B.O','679337',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125653,445,'Thavalam B.O','678582',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125654,445,'Thekke Vavanoor B.O','679533',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125655,445,'Thekkumuri (CPL) B.O','679506',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125656,445,'Thirumittakode B.O','679533',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125657,445,'Thirunayanapuram B.O','679514',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125658,445,'Thiruvazhiyode S.O','679514',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125659,445,'Thiruvegapura S.O','679304',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125660,445,'Thottakkara S.O','679102',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125661,445,'Thrikallur B.O','678593',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125662,445,'Tiruvalamkunnu B.O','678601',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125663,445,'Trikkatiri S.O','679502',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125664,445,'Trithala S.O','679534',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125665,445,'Ummanazhi B.O','678632',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125666,445,'Uppukulam B.O','678601',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125667,445,'Vadanamkurussi B.O','679121',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125668,445,'Vakkadapuram B.O','678595',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125669,445,'Valambillimangalam B.O','679513',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125670,445,'Vallapuzha S.O','679336',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125671,445,'Vaniamkulam S.O','679522',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125672,445,'Varode B.O','679102',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125673,445,'Vattamannapuram B.O','678601',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125674,445,'Vazhumbram B.O','678595',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125675,445,'Veeramangalam B.O','679503',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125676,445,'Veetampara B.O','679102',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125677,445,'Vellinezhi S.O','679504',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125678,445,'Vengasseri S.O','679516',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125679,445,'Vettakara B.O','678633',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125680,445,'Vilathur B.O','679304',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125681,445,'Vilayur S.O','679309',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125682,445,'Vilayur West B.O','679309',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125683,445,'Viyyakurissi B.O','678593',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125684,445,'Akathethara B.O','678008',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125685,445,'Alampallam B.O','678506',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125686,445,'Alathur Mbr H.O','678541',1,0,'2022-03-04 19:25:13','2022-03-04 19:25:13'),(125687,445,'Ambikapuram S.O (Palakkad)','678011',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125688,445,'Anakkal B.O','678651',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125689,445,'Anamari B.O','678506',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125690,445,'Anjumoorthy S.O','678682',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125691,445,'Athicode B.O','678554',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125692,445,'Athipotta B.O','678544',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125693,445,'Attempathy B.O','678556',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125694,445,'Ayakkad B.O','678683',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125695,445,'Ayalur S.O','678510',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125696,445,'Chandramala Estate B.O','678508',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125697,445,'Chandranagar S.O','678007',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125698,445,'Chandrapuram B.O','678624',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125699,445,'Chandrasekharapuram B.O','678611',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125700,445,'Chathamangalam B.O','678508',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125701,445,'Chennangad B.O','678573',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125702,445,'Chenthamaranagar B.O','678102',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125703,445,'Cheramangalam B.O','678703',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125704,445,'Cheraya B.O','678631',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125705,445,'Cherukulam B.O','678572',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125706,445,'Chimbukat B.O','678721',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125707,445,'Chithali B.O','678702',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125708,445,'Chittadi B.O','678706',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125709,445,'Chittilancheri S.O','678704',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125710,445,'Chittur College S.O','678104',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125711,445,'Chittur Courts B.O','678101',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125712,445,'Chittur PG S.O','678101',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125713,445,'Chokkanathapuram S.O','678005',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125714,445,'Chulanur B.O','678574',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125715,445,'Coyalmanna S.O','678702',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125716,445,'Dhoni B.O','678009',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125717,445,'Edathara S.O','678611',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125718,445,'Eduppukulam B.O','678556',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125719,445,'Elakkad B.O','678631',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125720,445,'Elapulli S.O','678622',1,0,'2022-03-04 19:25:14','2022-03-04 19:25:14'),(125721,445,'Elapulli South B.O','678622',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125722,445,'Elavampadam B.O','678684',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125723,445,'Elavancheri B.O','678508',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125724,445,'Erattakulam Alathur B.O','678682',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125725,445,'Erattakulam B.O','678622',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125726,445,'Erimayur S.O','678546',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125727,445,'Eruttenpadi B.O','678555',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125728,445,'Ettanur S.O','678502',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125729,445,'Govindapuram B.O','678507',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125730,445,'Kadukkamkunnu B.O','678651',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125731,445,'Kairady B.O','678510',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125732,445,'Kakkayur S.O','678512',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125733,445,'Kalapatti B.O','678702',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125734,445,'Kallekkad B.O','678006',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125735,445,'Kallekulangara S.O','678009',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125736,445,'Kallepulli B.O','678005',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125737,445,'Kallur-palakkad B.O','678613',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125738,445,'Kalpathi S.O','678003',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125739,445,'Kanakkanthuruthy B.O','678683',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125740,445,'Kanimangalam B.O','678508',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125741,445,'Kanjikode Ind. Estate B.O','678621',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125742,445,'Kanjikode S.O','678621',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125743,445,'Kanjikode West S.O','678623',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125744,445,'Kannadi S.O','678701',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125745,445,'Kannambra S.O','678686',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125746,445,'Kannanur B.O','678702',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125747,445,'Kannimari B.O','678534',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125748,445,'Karingarapully B.O','678551',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125749,445,'Karinkayam B.O','678706',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125750,445,'Karippali B.O','678532',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125751,445,'Karippode B.O','678503',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125752,445,'Kariyamkode B.O','678572',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125753,445,'Kattusseri B.O','678542',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125754,445,'Kavalpad B.O','678012',1,0,'2022-03-04 19:25:15','2022-03-04 19:25:15'),(125755,445,'Kavasseri S.O','678543',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125756,445,'Kazhani B.O','678543',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125757,445,'Keralasseri S.O','678641',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125758,445,'Kilakkancheri S.O','678684',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125759,445,'Kilakkumbram B.O','678642',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125760,445,'Kinasseri B.O','678701',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125761,445,'Kinavallur B.O','678612',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125762,445,'Kizhakkumuri B.O','678508',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125763,445,'Koduntharapully B.O','678004',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125764,445,'Koduvayur Agraharam B.O','678501',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125765,445,'Koduvayur S.O','678501',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125766,445,'Kollengode R.S. B.O','678506',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125767,445,'Kollengode S.O','678506',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125768,445,'Kollengode West B.O','678506',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125769,445,'Kongad S.O','678631',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125770,445,'Koottala B.O','678681',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125771,445,'Koranchira B.O','678684',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125772,445,'Kotambu S.O','678551',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125773,445,'Kottayi S.O','678572',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125774,445,'Kottekkad S.O','678732',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125775,445,'Kozhalmannam Agraharam B.O','678702',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125776,445,'Kozhinjampara S.O','678555',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125777,445,'Kozhipara S.O','678557',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125778,445,'Kudallur B.O','678688',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125779,445,'Kundalasseri B.O','678641',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125780,445,'Kunisseri S.O','678681',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125781,445,'Kunnamkattupathy B.O','678101',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125782,445,'Kunnathurmedu S.O','678013',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125783,445,'Kuttanur S.O','678721',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125784,445,'Kuttipallam B.O','678101',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125785,445,'Malampuzha Dam S.O','678651',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125786,445,'Manappadam B.O','678687',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125787,445,'Mangalam Dam B.O','678706',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125788,445,'Manikkasseri B.O','678631',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125789,445,'Mankarai R.S. B.O','678613',1,0,'2022-03-04 19:25:16','2022-03-04 19:25:16'),(125790,445,'Mankarai S.O','678613',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125791,445,'Mankurussi B.O','678613',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125792,445,'Mannalur B.O','678502',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125793,445,'Mannapra S.O','678685',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125794,445,'Mannur S.O (Palakkad)','678642',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125795,445,'Mannur West B.O','678642',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125796,445,'Marudarode B.O','678007',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125797,445,'Mathur Agraharam B.O','678571',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125798,445,'Mathur PG S.O','678571',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125799,445,'Meenakshipuram S.O','678533',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125800,445,'Meenkara Dam B.O','678507',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125801,445,'Melarcode S.O','678703',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125802,445,'Menonpara S.O','678556',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125803,445,'Moothanthara B.O','678012',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125804,445,'Mucheeri B.O','678631',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125805,445,'Mudappallur S.O','678705',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125806,445,'Mulangot B.O','678684',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125807,445,'Mundur Palakkad S.O','678592',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125808,445,'Muthalamada S.O','678507',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125809,445,'Muttikulangara S.O','678594',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125810,445,'Naduvathupara B.O','678574',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125811,445,'Nagaripuram B.O','678642',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125812,445,'Nallepilly S.O','678553',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125813,445,'Nambullipura B.O','678592',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125814,445,'Nanniode B.O','678534',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125815,445,'Nattukal S.O','678554',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125816,445,'Nechur B.O','678722',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125817,445,'Nelliampathy B.O','678508',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125818,445,'Nemmara College B.O','678508',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125819,445,'Nemmara Old Village B.O','678508',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125820,445,'Nemmara S.O','678508',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125821,445,'Nenmeni B.O','678506',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125822,445,'Newkalpathy B.O','678003',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125823,445,'Nochulli B.O','678702',1,0,'2022-03-04 19:25:17','2022-03-04 19:25:17'),(125824,445,'Nochupulli B.O','678592',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125825,445,'Nurani Agraharam B.O','678004',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125826,445,'Nurani S.O','678004',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125827,445,'Olalapadi B.O','678557',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125828,445,'Olasseri B.O','678551',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125829,445,'Olavakkot H.O','678002',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125830,445,'Olinkadavu B.O','678706',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125831,445,'Olivemount B.O','678702',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125832,445,'Padagiri B.O','678508',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125833,445,'Padur-Kavasseri B.O','678543',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125834,445,'Palakkad City S.O','678014',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125835,445,'Palakkad Collectorate S.O','678001',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125836,445,'Palakkad College S.O','678001',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125837,445,'Palakkad Engineering College S.O','678008',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125838,445,'Palakkad Fort S.O','678001',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125839,445,'Palakkad H.O','678001',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125840,445,'Palakkad Industrial Estate B.O','678731',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125841,445,'Palakuzhy B.O','678684',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125842,445,'Palampalakode S.O','678544',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125843,445,'Palaniyarpalayam B.O','678555',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125844,445,'Pallanchathanur B.O','678571',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125845,445,'Pallassana S.O','678505',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125846,445,'Pallatheri B.O','678007',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125847,445,'Pallavur S.O','678688',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125848,445,'Pallipuram PG S.O','678006',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125849,445,'Pampampallam B.O','678621',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125850,445,'Panangattiri B.O','678506',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125851,445,'Panayur B.O','678552',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125852,445,'Panniankara B.O','678683',1,0,'2022-03-04 19:25:18','2022-03-04 19:25:18'),(125853,445,'Parambikulam S.O','678661',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125854,445,'Parasseri B.O','678631',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125855,445,'Parassikkal B.O','678556',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125856,445,'Parli PG S.O','678612',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125857,445,'Paruthipulli S.O','678573',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125858,445,'Paruvasseri B.O','678686',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125859,445,'Pattancheri S.O','678532',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125860,445,'Payyalur B.O','678506',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125861,445,'Peringottukurussi S.O','678574',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125862,445,'Perinkulam S.O','678542',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125863,445,'Perinkunnu B.O','678702',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125864,445,'Peruvemba S.O','678531',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125865,445,'Pirayiri B.O','678004',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125866,445,'Polpulli S.O','678552',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125867,445,'Pothundy Dam B.O','678508',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125868,445,'Pudanur B.O','678592',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125869,445,'Pudiyankam S.O','678545',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125870,445,'Pudunagaram S.O','678503',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125871,445,'Puduppariyaram S.O','678731',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125872,445,'Pudusseri B.O','678623',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125873,445,'Pulinelly B.O','678572',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125874,445,'Pullode B.O','678545',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125875,445,'Puthucode S.O','678687',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125876,445,'Puthur-palakkad B.O','678005',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125877,445,'Ramasseri B.O','678622',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125878,445,'Rvp Pudur B.O','678555',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125879,445,'Sekharipuram S.O','678010',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125880,445,'Sitharkunda B.O','678508',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125881,445,'Tadukkasseri B.O','678641',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125882,445,'Tarur B.O','678544',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125883,445,'Tattamangalam S.O','678102',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125884,445,'Tattamangalam South S.O','678102',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125885,445,'Tenari B.O','678622',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125886,445,'Tenur B.O','678612',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125887,445,'Thachangad B.O','678571',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125888,445,'Thannilapuram B.O','678682',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125889,445,'Thannisseri B.O','678501',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125890,445,'Thekkedesam B.O','678553',1,0,'2022-03-04 19:25:19','2022-03-04 19:25:19'),(125891,445,'Thekkegramam S.O','678103',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125892,445,'Thekkepotta B.O','678687',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125893,445,'Thenkurussi S.O','678671',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125894,445,'Thiruvalathur B.O','678551',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125895,445,'Thiruvaliad B.O','678510',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125896,445,'Tirunilayi B.O','678004',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125897,445,'Tolanur S.O','678722',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125898,445,'Tunacadavu B.O','678661',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125899,445,'Vadakanthara S.O','678012',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125900,445,'Vadakkancherry MBR S.O','678683',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125901,445,'Vadasseri B.O','678641',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125902,445,'Vadavannur S.O','678504',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125903,445,'Vallanghy B.O','678508',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125904,445,'Vallikkode B.O','678594',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125905,445,'Vandali S.O','678706',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125906,445,'Vandithavalam S.O','678534',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125907,445,'Vannamada B.O','678555',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125908,445,'Varode-kottayi B.O','678572',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125909,445,'Vattekkad B.O','678506',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125910,445,'Vavulliapuram B.O','678543',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125911,445,'Velanthavalam B.O','678557',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125912,445,'Velikkad B.O','678592',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125913,445,'Vemballur B.O','678502',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125914,445,'Vengodi B.O','678622',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125915,445,'Verkoli B.O','678552',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125916,445,'Vilayannur B.O','678671',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125917,445,'Vilayodi B.O','678103',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125918,445,'Walayar Dam S.O','678624',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125919,445,'Yakkara B.O','678701',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125920,446,'Chathenthara B.O','686510',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125921,446,'Kunnam Vechoochira S.O','686511',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125922,446,'Mannadisala B.O','686511',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125923,446,'Thulappally B.O','686510',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125924,446,'Gavi B.O','685533',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125925,446,'Pallickal -nooranad B.O','690504',1,0,'2022-03-04 19:25:20','2022-03-04 19:25:20'),(125926,446,'Adichipuzha B.O','689711',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125927,446,'Adumpumkulam B.O','689692',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125928,446,'Adur( Kla) H.O','691523',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125929,446,'Anandapally B.O','691525',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125930,446,'Angadi S.O (Pathanamthitta)','689674',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125931,446,'Angadical North B.O','689648',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125932,446,'Angadical South B.O','691555',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125933,446,'Angamoozhy B.O','689662',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125934,446,'Anthiyalankavu B.O','689649',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125935,446,'Aruvappulam B.O','689691',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125936,446,'Aryavon B.O','689691',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125937,446,'Athirumkal B.O','689693',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125938,446,'Attachakkal B.O','689692',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125939,446,'Chandanapally B.O','689648',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125940,446,'Chayalode B.O','691556',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125941,446,'Chelikuzhy B.O','691556',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125942,446,'Chellakkad S.O','689677',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125943,446,'Chengalthadom B.O','689671',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125944,446,'Chengara B.O','689664',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125945,446,'Chenneerkara B.O','689503',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125946,446,'Cherukole Kozhencherri S.O','689650',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125947,446,'Cherukulanji B.O','689673',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125948,446,'Chethackal B.O','689677',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125949,446,'Chittar S.O','689663',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125950,446,'Choorakode B.O','691551',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125951,446,'Churulicode S.O','689668',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125952,446,'Edakulam B.O','689672',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125953,446,'Edapariyaram B.O','689643',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125954,446,'Edathitta B.O','691555',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125955,446,'Elakollur B.O','689691',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125956,446,'Elamannur S.O','691524',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125957,446,'Elanthur East B.O','689643',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125958,446,'Elanthur Pariyaram B.O','689643',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125959,446,'Elanthur S.O','689643',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125960,446,'Elappupara B.O','689656',1,0,'2022-03-04 19:25:21','2022-03-04 19:25:21'),(125961,446,'Elavanthitta S.O','689625',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125962,446,'Ellimullumplackal B.O','689692',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125963,446,'Enathu S.O','691526',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125964,446,'Ettichuvadu S.O','689675',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125965,446,'Gurunathanmannu B.O','689667',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125966,446,'Iythala B.O','689673',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125967,446,'Kadambanad S.O','691552',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125968,446,'Kadambanad South S.O','691553',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125969,446,'Kadammanitta S.O','689649',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125970,446,'Kaipattur S.O','689648',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125971,446,'Kaipuzha North B.O','689503',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125972,446,'Kaithaparambu B.O','691526',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125973,446,'Kakkudumon B.O','689711',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125974,446,'Kalanjoor S.O','689694',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125975,446,'Kallely B.O','689691',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125976,446,'Kallely Thottam B.O','689691',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125977,446,'Karamvely B.O','689643',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125978,446,'Karikayam B.O','689663',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125979,446,'Karikulam B.O','689673',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125980,446,'Karithotta B.O','689514',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125981,446,'Kattoor Kozhencherry B.O','689650',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125982,446,'Keekozhur B.O','689672',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125983,446,'Keerukuzhy B.O','689502',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125984,446,'Kidangannur S.O','689514',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125985,446,'Kizhakkupuram B.O','689653',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125986,446,'Kochukoikkal B.O','689667',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125987,446,'Kodumon East B.O','691555',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125988,446,'Kodumon S.O','691555',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125989,446,'Kokkathode B.O','689691',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125990,446,'Konny S.O','689691',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125991,446,'Koodal S.O','689693',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125992,446,'Koonamkara B.O','689711',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125993,446,'Kottamonpara B.O','689667',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125994,446,'Kozhencherry  Thekkemala S.O','689654',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125995,446,'Kozhencherry College S.O','689641',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125996,446,'Kozhencherry East B.O','689641',1,0,'2022-03-04 19:25:22','2022-03-04 19:25:22'),(125997,446,'Kozhencherry S.O','689641',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(125998,446,'Kudamurutty B.O','689711',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(125999,446,'Kulanada S.O','689503',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126000,446,'Kulathumon B.O','689693',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126001,446,'Kumaramperoor Thekkekkara B.O','689662',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126002,446,'Kumbazhamuri S.O','689653',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126003,446,'Kummannoor B.O','689691',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126004,446,'Kumpalampoika S.O','689661',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126005,446,'Kurampala South B.O','689501',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126006,446,'Kurumbakara B.O','689695',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126007,446,'Kuzhikala S.O','689644',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126008,446,'Lahai B.O','689662',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126009,446,'Madamon B.O','689711',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126010,446,'Makkankunnu S.O','689645',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126011,446,'Makkapuzha S.O','689676',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126012,446,'Malayalapuzha Eram S.O','689664',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126013,446,'Malayalapuzha Thazham S.O','689666',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126014,446,'Mallasseri S.O','689646',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126015,446,'Mammoodu B.O','689513',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126016,446,'Mampara B.O','689711',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126017,446,'Manakala S.O','691551',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126018,446,'Mancode B.O','689694',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126019,446,'Mandiram Jn B.O','689672',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126020,446,'Mangadu-Elamannur B.O','691524',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126021,446,'Maniyar B.O','689662',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126022,446,'Mannady S.O (Pathanamthitta)','691530',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126023,446,'Mannam Nagar B.O','689501',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126024,446,'Mannam Sugar Mills B.O','689501',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126025,446,'Mannarakulanji B.O','689678',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126026,446,'Manneera B.O','689699',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126027,446,'Manthuka B.O','689503',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126028,446,'Marur B.O','691524',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126029,446,'Mathur B.O','689647',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126030,446,'Mekozhur B.O','689678',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126031,446,'Melood B.O','691554',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126032,446,'Melukara B.O','689641',1,0,'2022-03-04 19:25:23','2022-03-04 19:25:23'),(126033,446,'Mezhuveli S.O','689507',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126034,446,'Moozhiar B.O','689662',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126035,446,'Mudiyoorkonam B.O','689501',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126036,446,'Mundukottackal B.O','689649',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126037,446,'Murinjakal B.O','689693',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126038,446,'Musaliar College B.O','689653',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126039,446,'Muthupezhumkal B.O','689698',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126040,446,'Muttathukonam B.O','689625',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126041,446,'Muttom Thumpamon B.O','689502',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126042,446,'Mylapra S.O','689671',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126043,446,'Mylapra Town S.O','689678',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126044,446,'Naranamoozhy B.O','689711',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126045,446,'Naranganam North B.O','689642',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126046,446,'Naranganam S.O','689642',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126047,446,'Naranganam West B.O','689642',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126048,446,'Nariapuram S.O','689513',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126049,446,'Nedumon S.O','691556',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126050,446,'Nedumoncavu B.O','689693',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126051,446,'Neeliplavu B.O','689663',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126052,446,'Nellikala B.O','689643',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126053,446,'Nellikkamon B.O','689674',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126054,446,'Nellikkapara B.O','689691',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126055,446,'Nellimukal B.O','691551',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126056,446,'Nirathupara B.O','689693',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126057,446,'Njakkunilam B.O','689656',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126058,446,'Omallur-kla S.O','689647',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126059,446,'Oonnakavu B.O','689674',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126060,446,'Oonnukal B.O','689647',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126061,446,'Oottupara B.O','689691',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126062,446,'Padam B.O','689694',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126063,446,'Pampa Triveni B.O','689662',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126064,446,'Pampini B.O','689663',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126065,446,'Panangad B.O','689503',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126066,446,'Pandalam Medical Mission S.O','689501',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126067,446,'Pandalam S.O (Pathanamthitta)','689501',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126068,446,'Parakara B.O','691525',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126069,446,'Parakode S.O','691554',1,0,'2022-03-04 19:25:24','2022-03-04 19:25:24'),(126070,446,'Parakoottam B.O','691551',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126071,446,'Paranthal B.O','689501',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126072,446,'Pathanamthitta H.O','689645',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126073,446,'Payyanamon S.O','689692',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126074,446,'Pazhakulam B.O','691554',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126075,446,'Peringanad B.O','691551',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126076,446,'Perinjottackal B.O','689692',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126077,446,'Pezhumpara B.O','689662',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126078,446,'Prakkanam B.O','689643',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126079,446,'Pulloopram B.O','689674',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126080,446,'Punnakkad S.O','689652',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126081,446,'Puthumala B.O','691554',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126082,446,'Puthusserimala B.O','689672',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126083,446,'Ranny Edamon B.O','689676',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126084,446,'Ranny Perinad S.O','689711',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126085,446,'Ranny S.O','689672',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126086,446,'Ranny-pazhavangadi S.O','689673',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126087,446,'Seethathode S.O','689667',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126088,446,'Thalachira Eram B.O','689664',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126089,446,'Thannithode S.O','689699',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126090,446,'Thattayil S.O','691525',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126091,446,'Thekkuthode B.O','689699',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126092,446,'Thengamom B.O','690522',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126093,446,'Thengumcavu B.O','689646',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126094,446,'Theppupara B.O','691554',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126095,446,'Thombikandam B.O','689676',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126096,446,'Thonniamala B.O','689668',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126097,446,'Thumpamon North B.O','689625',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126098,446,'Thumpamon S.O','689502',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126099,446,'Thumpamon Thazham B.O','689625',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126100,446,'Thuvayur South B.O','691552',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126101,446,'Ulanad B.O','689503',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126102,446,'Ullannur B.O','689503',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126103,446,'Uthimoodu B.O','689672',1,0,'2022-03-04 19:25:25','2022-03-04 19:25:25'),(126104,446,'Vadakkedathukavu Jn B.O','691526',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126105,446,'Vadakkupuram B.O','689653',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126106,446,'Vadasserikara S.O','689662',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126107,446,'Vakayar S.O','689698',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126108,446,'Valiyakavu B.O','689675',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126109,446,'Vallicode B.O','689648',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126110,446,'Vallicode Kottayam S.O','689656',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126111,446,'Vayala Parakode B.O','691554',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126112,446,'Vayalathala B.O','689672',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126113,446,'Vayyattupuzha B.O','689663',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126114,446,'Vazhamuttom B.O','689647',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126115,446,'Vazhamuttom East B.O','689646',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126116,446,'Vellappara B.O','689691',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126117,446,'Vettur Kumbazha B.O','689653',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126118,446,'Alumthuruthy B.O','689113',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126119,446,'Amichikary B.O','689112',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126120,446,'Anikad Mallappally GDS B.O','689585',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126121,446,'Anjilithanam B.O','689582',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126122,446,'Aranmula S.O','689533',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126123,446,'Arattupuzha B.O','689123',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126124,446,'Ayroor North S.O','689612',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126125,446,'Ayroor South S.O','689611',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126126,446,'Azhiyadathuchira S.O','689113',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126127,446,'Chalappally B.O','689586',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126128,446,'Chathankary S.O','689112',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126129,446,'Chengaroor S.O','689594',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126130,446,'Chirayirambu B.O','689549',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126131,446,'Chumathra B.O','689103',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126132,446,'Chunkapara S.O','686547',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126133,446,'Edappavoor B.O','689614',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126134,446,'Edayaramula West B.O','689532',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126135,446,'Edayarnmula S.O','689532',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126136,446,'Eraviperoor East B.O','689542',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126137,446,'Eraviperoor S.O','689542',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126138,446,'Erumakkad B.O','689532',1,0,'2022-03-04 19:25:26','2022-03-04 19:25:26'),(126139,446,'Ezhumattoor S.O','689586',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126140,446,'Kadamankulam B.O','689583',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126141,446,'Kadapra Kumbanadu B.O','689547',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126142,446,'Kadapra Mannar B.O','689621',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126143,446,'Kaithakody B.O','689614',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126144,446,'Kallooppara S.O','689583',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126145,446,'Kallumkal B.O','689102',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126146,446,'Kanjeettukara B.O','689611',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126147,446,'Karakkal B.O','689108',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126148,446,'Kariamplavu B.O','689615',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126149,446,'Kattode B.O','689105',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126150,446,'Kaviyoor S.O','689582',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126151,446,'Kavumbhagom S.O','689102',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126152,446,'Kavungumprayar B.O','689543',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126153,446,'Keezhvaipur S.O','689587',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126154,446,'Kizhakkumbhagom B.O','689621',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126155,446,'Koipuram S.O','689531',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126156,446,'Kolabhagom B.O','689545',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126157,446,'Kottanad S.O','689615',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126158,446,'Kottangal B.O','686547',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126159,446,'Kottathoor S.O','689614',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126160,446,'Kottoor B.O','689582',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126161,446,'Kozhimala B.O','689541',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126162,446,'Kulathur B.O','689588',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126163,446,'Kumbanadu S.O','689547',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126164,446,'Kunnamthanam S.O','689581',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126165,446,'Kunnathukara HSC B.O','689546',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126166,446,'Kuravankuzhy B.O','689548',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126167,446,'Kuriannoor S.O','689550',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126168,446,'Kurichimuttom B.O','689532',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126169,446,'Kurunghazhabhagom B.O','689548',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126170,446,'Kuttapuzha S.O','689103',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126171,446,'Kuttur S.O (Pathanamthitta)','689106',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126172,446,'Madathumbhagom North B.O','689543',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126173,446,'Malakara B.O','689532',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126174,446,'Mallappally East S.O','689584',1,0,'2022-03-04 19:25:27','2022-03-04 19:25:27'),(126175,446,'Mallappally North B.O','689594',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126176,446,'Mallappally West S.O','689585',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126177,446,'Mallappuzhassery B.O','689533',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126178,446,'Manjady Jn S.O','689105',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126179,446,'Manthanam B.O','689581',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126180,446,'Maramon S.O','689549',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126181,446,'Mepral S.O','689591',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126182,446,'Mundamala B.O','689543',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126183,446,'Mundiappally B.O','689581',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126184,446,'Muthoor S.O','689107',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126185,446,'Muttumon B.O','689547',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126186,446,'Nalkallikkal B.O','689533',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126187,446,'Narakathanni B.O','689544',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126188,446,'Nedumpuram B.O','689110',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126189,446,'Neervilakom B.O','689122',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126190,446,'Nellimala B.O','689542',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126191,446,'Niranam Central B.O','689621',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126192,446,'Niranam S.O','689621',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126193,446,'Nooromavu B.O','689589',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126194,446,'Othera S.O','689546',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126195,446,'Otherawest S.O','689551',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126196,446,'Padimon B.O','689587',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126197,446,'Paduthode B.O','689544',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126198,446,'Palackathakidi B.O','689581',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126199,446,'Pariyaram B.O','689585',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126200,446,'Parumala S.O','689626',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126201,446,'Peringara S.O','689108',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126202,446,'Perumpatty S.O','689592',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126203,446,'Perumpramavu B.O','689587',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126204,446,'Perumthuruthy B.O','689107',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126205,446,'Podiyadi S.O','689110',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126206,446,'Poovathoor B.O','689531',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126207,446,'Pullad S.O','689548',1,0,'2022-03-04 19:25:28','2022-03-04 19:25:28'),(126208,446,'Punnavely S.O','689589',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126209,446,'Puramattom S.O','689543',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126210,446,'Pushpagiri Tiruvalla B.O','689105',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126211,446,'Puthusserry South S.O','689602',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126212,446,'Thadiyur S.O','689545',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126213,446,'Thekkumkal B.O','689614',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126214,446,'Thelliyoor B.O','689544',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126215,446,'Thengeli B.O','689106',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126216,446,'Theodical S.O','689613',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126217,446,'Thirumoolapuram S.O','689115',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126218,446,'Thottabhagom B.O','689541',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126219,446,'Thuruthicaud S.O','689597',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126220,446,'Tiruvalla H.O','689101',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126221,446,'Tiruvalla Market Jn S.O','689101',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126222,446,'Tiruvalla RS S.O','689111',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126223,446,'Vaipur S.O','689588',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126224,446,'Valakuzhy B.O','689544',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126225,446,'Valanjavattom East B.O','689104',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126226,446,'Valanjavattom S.O','689104',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126227,446,'Vallamkulam East B.O','689541',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126228,446,'Vallamkulam S.O','689541',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126229,446,'Varayannur B.O','689548',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126230,446,'Vdakkumbhagom B.O','689621',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126231,446,'Vellayil B.O','689613',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126232,446,'Velliyara B.O','689612',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126233,446,'Vennikulam S.O','689544',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126234,446,'Venpala B.O','689102',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126235,447,'Adayamon B.O','695614',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126236,447,'Alamcode S.O','695102',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126237,447,'Aliyadu B.O','695607',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126238,447,'Altharamoodu B.O','695102',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126239,447,'Anakudy B.O','695606',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126240,447,'Anathalavattom B.O','695306',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126241,447,'Anayara S.O','695029',1,0,'2022-03-04 19:25:29','2022-03-04 19:25:29'),(126242,447,'Andoorkonam B.O','695584',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126243,447,'Anjengo S.O','695309',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126244,447,'Attakulangara S.O','695023',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126245,447,'Attingal H.O','695101',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126246,447,'Avanavancherry S.O','695103',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126247,447,'Ayilam B.O','695103',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126248,447,'Ayroor-varkala S.O','695310',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126249,447,'Azhurmarket B.O','695305',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126250,447,'Beemapally B.O','695008',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126251,447,'Bharathannur B.O','695609',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126252,447,'Chakkai B.O','695024',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126253,447,'Channamkara B.O','695301',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126254,447,'Charupara B.O','695601',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126255,447,'Cheeranikkara B.O','695615',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126256,447,'Chempazhanthy S.O','695587',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126257,447,'Cherunniyur S.O','695142',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126258,447,'Cheruvallimukku B.O','695304',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126259,447,'Cheruvikkal B.O','695011',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126260,447,'Chilakur B.O','695141',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126261,447,'Chirayinkeezhu S.O','695304',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126262,447,'Chittattumukku B.O','695301',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126263,447,'Edakode B.O','695104',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126264,447,'Edava S.O','695311',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126265,447,'Elakamon B.O','695310',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126266,447,'Elakamon-kizhakkepuram B.O','695310',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126267,447,'Goureesapattom B.O','695004',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126268,447,'Hariharapuram B.O','695310',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126269,447,'Ilamba B.O','695103',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126270,447,'Iroopara B.O','695584',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126271,447,'Janardhanapuram B.O','695141',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126272,447,'Kadakkavur S.O','695306',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126273,447,'Kaikara B.O','695307',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126274,447,'Kaithamukku S.O','695024',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126275,447,'Kalamachal B.O','695606',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126276,447,'Kallambalam S.O','695605',1,0,'2022-03-04 19:25:30','2022-03-04 19:25:30'),(126277,447,'Kallara S.O (Thiruvananthapuram)','695608',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126278,447,'Kanchinada B.O','695609',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126279,447,'Kandukrishi B.O','695104',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126280,447,'Kaniyapuram S.O','695301',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126281,447,'Kappil B.O','695311',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126282,447,'Karavaram B.O','695605',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126283,447,'Karikkakom S.O','695021',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126284,447,'Karimanal B.O','695583',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126285,447,'Karimkuttikara B.O','695606',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126286,447,'Karyavattom S.O','695581',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126287,447,'Katakam B.O','695304',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126288,447,'Kattaikonam B.O','695584',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126289,447,'Kattumpuram B.O','695608',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126290,447,'Kavalayur B.O','695144',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126291,447,'Kazhakuttam S.O','695582',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126292,447,'Keezhattingal B.O','695306',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126293,447,'Keezhavur B.O','695584',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126294,447,'Kilimanur Palace B.O','695601',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126295,447,'Kilmanur S.O','695601',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126296,447,'Kizhuvalam S.O','695104',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126297,447,'Kodithookiyakunnu B.O','695608',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126298,447,'Koduvazhannur B.O','695612',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126299,447,'Koithurkonam B.O','695584',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126300,447,'Kokkottukonam B.O','695604',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126301,447,'Koliakode B.O','695607',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126302,447,'Konchira B.O','695615',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126303,447,'Kottukunnam B.O','695606',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126304,447,'Kudavur S.O','695313',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126305,447,'Kulamuttam B.O','695144',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126306,447,'Kulathur S.O (Thiruvananthapuram)','695583',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126307,447,'Kurakkada B.O','695104',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126308,447,'Kurumbayam B.O','695608',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126309,447,'Kuthirakulam B.O','695615',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126310,447,'Madavoor-pallickal S.O','695602',1,0,'2022-03-04 19:25:31','2022-03-04 19:25:31'),(126311,447,'Malakkal B.O','695602',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126312,447,'Manambur S.O','695611',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126313,447,'Manjamala B.O','695313',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126314,447,'Mannanathala S.O','695015',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126315,447,'Maruthikunnu B.O','695603',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126316,447,'Melkadakkavur B.O','695306',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126317,447,'Melvettoor B.O','695312',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126318,447,'Melvettoor S.O','695312',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126319,447,'Mg College B.O','695004',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126320,447,'Mithirmala S.O','695610',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126321,447,'Moongode S.O','695144',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126322,447,'Moonnanakuzhy B.O','695615',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126323,447,'Moonnumukku B.O','695609',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126324,447,'Moothala B.O','695604',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126325,447,'Mudakkal B.O','695103',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126326,447,'Mudapuram B.O','695304',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126327,447,'Mukkudil B.O','695607',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126328,447,'Mulakkalathukavu B.O','695614',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126329,447,'Murukumpuzhaa S.O','695302',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126330,447,'Muthana B.O','695146',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126331,447,'Muthuvila B.O','695610',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126332,447,'Muttada S.O','695025',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126333,447,'Muttappalam B.O','695145',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126334,447,'Mylamoodu B.O','695609',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126335,447,'Nagaroor B.O','695601',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126336,447,'Nalanchira S.O','695015',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126337,447,'Navaikulam S.O','695603',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126338,447,'Nedumparambu B.O','695102',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126339,447,'Nedunganda S.O','695307',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126340,447,'Neeramankadavuu B.O','695610',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126341,447,'Nellanad B.O','695606',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126342,447,'Nethajipuram B.O','695589',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126343,447,'Nilakkamukku B.O','695306',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126344,447,'Njarayilkonam B.O','695602',1,0,'2022-03-04 19:25:32','2022-03-04 19:25:32'),(126345,447,'Odayam B.O','695311',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126346,447,'Oorupoika B.O','695104',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126347,447,'Pakalkuri B.O','695604',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126348,447,'Palachira B.O','695143',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126349,447,'Palamkonam B.O','695607',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126350,447,'Palayamkunnu S.O','695146',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126351,447,'Palkulangara S.O','695024',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126352,447,'Pallickal Kilimanur S.O','695604',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126353,447,'Pallipuram S.O (Thiruvananthapuram)','695316',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126354,447,'Pallithura B.O','695586',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126355,447,'Panayara B.O','695145',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126356,447,'Pandalacode B.O','695028',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126357,447,'Pangappara B.O','695581',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126358,447,'Pangode S.O','695609',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126359,447,'Parakunnu B.O','695603',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126360,447,'Parayathukonam B.O','695104',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126361,447,'Pattom Palace S.O','695004',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126362,447,'Pazhayakunnummel B.O','695601',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126363,447,'Peroor B.O','695601',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126364,447,'Perumathura B.O','695303',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126365,447,'Perumkulam B.O','695102',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126366,447,'Perunguzhi S.O','695305',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126367,447,'Pirappancode B.O','695607',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126368,447,'PMG Jn S.O','695033',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126369,447,'Poikamukku B.O','695103',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126370,447,'Ponganadu B.O','695601',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126371,447,'Poothura B.O','695309',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126372,447,'Pothencode S.O','695584',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126373,447,'Powdikonam','695588',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126374,447,'Prasanth Nagar B.O','695011',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126375,447,'Public Office S.O (Thiruvananthapuram)','695033',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126376,447,'Pulimath S.O','695612',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126377,447,'Puliyurkonam B.O','695604',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126378,447,'Pullampara B.O','695607',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126379,447,'Pullanicode B.O','695311',1,0,'2022-03-04 19:25:33','2022-03-04 19:25:33'),(126380,447,'Pullayil B.O','695601',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126381,447,'Puthencurichy S.O','695303',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126382,447,'Puthenthope B.O','695586',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126383,447,'Puthusserimukku B.O','695605',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126384,447,'Sainik School S.O (Thiruvananthapuram)','695585',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126385,447,'Santhigiri S.O','695589',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126386,447,'Sasthavattom B.O','695305',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126387,447,'Sreekaryam S.O','695017',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126388,447,'Sreenivasapuram S.O','695145',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126389,447,'St.Xavier\'s College S.O','695586',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126390,447,'Thalikuzhi B.O','695612',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126391,447,'Thattathumala S.O','695614',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126392,447,'Thiruvananthapuram  AG\'s S.O','695001',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126393,447,'Thiruvananthapuram  Beach S.O','695007',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126394,447,'Thiruvananthapuram  Chalai S.O','695036',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126395,447,'Thiruvananthapuram  Engg College S.O','695016',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126396,447,'Thiruvananthapuram  Fort S.O','695023',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126397,447,'Thiruvananthapuram  Govt Press S.O','695001',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126398,447,'Thiruvananthapuram  ISRO S.O','695022',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126399,447,'Thiruvananthapuram  Medical College S.O','695011',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126400,447,'Thiruvananthapuram  Pettah S.O','695024',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126401,447,'Thiruvananthapuram  University S.O','695034',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126402,447,'Thiruvananthapuram G.P.O.','695001',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126403,447,'Thokkad B.O','695143',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126404,447,'Thonnakkal S.O','695317',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126405,447,'Thope B.O','695008',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126406,447,'Thottakkad B.O','695605',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126407,447,'Thundathil B.O','695581',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126408,447,'Thuruvikkal B.O','695011',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126409,447,'Titanium B.O','695021',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126410,447,'Ulloor B.O','695011',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126411,447,'Vadasserikonam S.O','695143',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126412,447,'Vakkom S.O','695308',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126413,447,'Valiathura B.O','695008',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126414,447,'Valiaveli B.O','695021',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126415,447,'Vallakkadavoo S.O','695008',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126416,447,'Vamanapuram S.O','695606',1,0,'2022-03-04 19:25:34','2022-03-04 19:25:34'),(126417,447,'Vanchiyoor Junction S.O','695035',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126418,447,'Vanchiyur S.O','695035',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126419,447,'Vanchiyur-attingal B.O','695102',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126420,447,'Varkala S.O','695141',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126421,447,'Varkala South B.O','695141',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126422,447,'Vattappara S.O','695028',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126423,447,'Vellallur B.O','695601',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126424,447,'Vellumannady B.O','695607',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126425,447,'Vembayam S.O','695615',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126426,447,'Venjaramoodu S.O','695607',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126427,447,'Venkode B.O','695028',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126428,447,'Venkulam B.O','695311',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126429,447,'Vennicode S.O','695318',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126430,447,'Vettiyara B.O','695603',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126431,447,'Vikas Bhavan S.O','695033',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126432,447,'Amachal B.O','695572',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126433,447,'Amaravila S.O','695122',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126434,447,'Ambalamukku S.O','695005',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126435,447,'Ambalathara B.O','695026',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126436,447,'Ambalathinkala B.O','695572',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126437,447,'Amboori B.O','695505',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126438,447,'Anad B.O','695541',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126439,447,'Anappara B.O','695551',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126440,447,'Anavoor B.O','695124',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126441,447,'Aralumoodu S.O','695123',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126442,447,'Aramada S.O','695032',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126443,447,'Arayur B.O','695122',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126444,447,'Arumanoor B.O','695525',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126445,447,'Aruvikara B.O','695564',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126446,447,'Aruvipuram B.O','695126',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126447,447,'Aryanad S.O','695542',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126448,447,'Attukkal B.O','695009',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126449,447,'Ayira B.O','695502',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126450,447,'Balaramapuram S.O','695501',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126451,447,'Bhagavathinada B.O','695501',1,0,'2022-03-04 19:25:35','2022-03-04 19:25:35'),(126452,447,'Bonaccord B.O','695551',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126453,447,'Cgo Complex Poonkulam S.O','695522',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126454,447,'Chaikkottukonam B.O','695122',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126455,447,'Changa B.O','695542',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126456,447,'Chekkakonam B.O','695564',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126457,447,'Chenkal S.O','695132',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126458,447,'Cheriakolla B.O','695504',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126459,447,'Cheriyakonni B.O','695013',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126460,447,'Cheruvarakonam B.O','695502',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126461,447,'Chettachal B.O','695551',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126462,447,'Chowara B.O','695501',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126463,447,'Chullimanoor B.O','695541',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126464,447,'Cotton Hill S.O','695014',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126465,447,'Daivapura B.O','695563',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126466,447,'Dalmughom B.O','695125',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126467,447,'Dhanuvachapuram S.O','695503',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126468,447,'Elavattom B.O','695562',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126469,447,'Elluvila B.O','695504',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126470,447,'Ex-servicemen\'s Colony B.O','695562',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126471,447,'Idinjar B.O','695563',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126472,447,'Ilanchiyam B.O','695563',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126473,447,'Industrial Estate S.O (Thiruvananthapuram)','695019',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126474,447,'Irinchayam B.O','695561',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126475,447,'Jagathy S.O','695014',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126476,447,'Kaimanam S.O','695040',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126477,447,'Kakkavila B.O','695506',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126478,447,'Kallar Tvm B.O','695551',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126479,447,'Kallayam B.O','695043',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126480,447,'Kalliyal B.O','695574',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126481,447,'Kalliyoor S.O','695042',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126482,447,'Kandala B.O','695512',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126483,447,'Kanjampazhanji B.O','695525',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126484,447,'Kanjiramkulam S.O','695524',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126485,447,'Kanjirampara S.O','695030',1,0,'2022-03-04 19:25:36','2022-03-04 19:25:36'),(126486,447,'Karakonam S.O','695504',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126487,447,'Karakulam S.O','695564',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126488,447,'Karamana S.O','695002',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126489,447,'Karikuzhi B.O','695505',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126490,447,'Karimancode B.O','695562',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126491,447,'Karipur B.O','695541',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126492,447,'Karode B.O','695506',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126493,447,'Karumom B.O','695002',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126494,447,'Kattachalkuzhy B.O','695501',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126495,447,'Kattacode B.O','695572',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126496,447,'Kattakada S.O','695572',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126497,447,'Kaudiar S.O','695003',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126498,447,'Kaudiar Square S.O','695003',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126499,447,'Kazhavur B.O','695526',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126500,447,'Keezharur B.O','695124',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126501,447,'Kerala Governor\'s Camp S.O','695099',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126502,447,'Kidarakuzhy B.O','695523',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126503,447,'Kochuvila B.O','695563',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126504,447,'Kodunganur B.O','695013',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126505,447,'Kodungavila B.O','695123',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126506,447,'Kokkotela B.O','695542',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126507,447,'Kollode B.O','695571',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126508,447,'Koonanvenga B.O','695568',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126509,447,'Koothali(TVM) B.O','695505',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126510,447,'Kottackal (TVM) B.O','695124',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126511,447,'Kottakkakom B.O','695542',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126512,447,'Kottapuram B.O','695521',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126513,447,'Kottoor(TVM) B.O','695574',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126514,447,'Kottukal B.O','695501',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126515,447,'Kovalam Beach B.O','695527',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126516,447,'Kovalam S.O (Thiruvananthapuram)','695527',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126517,447,'Kudappanakunnu S.O','695043',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126518,447,'Kudappanamoodu B.O','695505',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126519,447,'Kudayal B.O','695505',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126520,447,'Kulappada B.O','695542',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126521,447,'Kunnathukal B.O','695504',1,0,'2022-03-04 19:25:37','2022-03-04 19:25:37'),(126522,447,'Kuruthamcode B.O','695572',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126523,447,'Kuthirakalam-vellanad B.O','695543',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126524,447,'Kuttamala B.O','695505',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126525,447,'Kuttichal S.O','695574',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126526,447,'Kuvalassery S.O','695512',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126527,447,'Lourdepuram B.O','695526',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126528,447,'Machel B.O','695571',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126529,447,'Malayam B.O','695571',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126530,447,'Malayinkil S.O','695571',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126531,447,'Manacaud S.O','695009',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126532,447,'Manali B.O','695505',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126533,447,'Mancha B.O','695541',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126534,447,'Manchamcode B.O','695125',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126535,447,'Manchavilakom B.O','695503',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126536,447,'Manikanteswaram B.O','695013',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126537,447,'Mannamkonam B.O','695125',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126538,447,'Mannurkonam B.O','695541',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126539,447,'Marangad B.O','695542',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126540,447,'Marayamuttom B.O','695124',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126541,447,'Mariyapuram B.O','695122',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126542,447,'Maruthamala B.O','695551',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126543,447,'Mayam B.O','695505',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126544,447,'Meenankal B.O','695542',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126545,447,'Meenmutty B.O','695562',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126546,447,'Memala B.O','695551',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126547,447,'Mithraniketan B.O','695543',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126548,447,'Moongode B.O','695573',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126549,447,'Mukkolackal B.O','695043',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126550,447,'Mulayara B.O','695543',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126551,447,'Mullur B.O','695521',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126552,447,'Mulluvila B.O','695133',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126553,447,'Mundela B.O','695543',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126554,447,'Muttakadu B.O','695523',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126555,447,'Mylakkara B.O','695572',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126556,447,'Naruvamoodu S.O','695528',1,0,'2022-03-04 19:25:38','2022-03-04 19:25:38'),(126557,447,'Nedumangad S.O','695541',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126558,447,'Nellimoodu B.O','695524',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126559,447,'Nellivila B.O','695523',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126560,447,'Nemom S.O','695020',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126561,447,'Nettayam   B.O','695013',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126562,447,'Neyyar Dam B.O','695572',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126563,447,'Neyyattinkara H.O','695121',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126564,447,'Neyyattinkara Town S.O','695121',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126565,447,'Olathanni B.O','695133',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126566,447,'Ookode B.O','695020',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126567,447,'Ooruttambalam S.O','695507',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126568,447,'Ottasekharamangalam S.O','695125',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126569,447,'Pacha S.O','695562',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126570,447,'Pachallur B.O','695027',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126571,447,'Pallichal B.O','695020',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126572,447,'Paluvally B.O','695562',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126573,447,'Panachamoodu B.O','695505',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126574,447,'Panacode B.O','695542',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126575,447,'Panangode B.O','695563',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126576,447,'Panavoor S.O','695568',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126577,447,'Panayam B.O','695568',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126578,447,'Panayamuttom B.O','695561',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126579,447,'Panniyode B.O','695575',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126580,447,'Pantha B.O','695572',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126581,447,'Pappanamcode S.O','695018',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126582,447,'Parandode B.O','695542',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126583,447,'Parappara B.O','695551',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126584,447,'Parassala S.O','695502',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126585,447,'Parasuvaickal S.O','695508',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126586,447,'Paruthikuzhy B.O','695541',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126587,447,'Paruthipally B.O','695574',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126588,447,'Payattuvila B.O','695501',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126589,447,'Pazhakutty S.O','695561',1,0,'2022-03-04 19:25:39','2022-03-04 19:25:39'),(126590,447,'Peppara Dam B.O','695551',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126591,447,'Perayam B.O','695562',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126592,447,'Peringamala S.O','695563',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126593,447,'Perukavu B.O','695573',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126594,447,'Perumkadavila S.O','695124',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126595,447,'Perumpazhuthoor S.O','695126',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126596,447,'Perurkada S.O','695005',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126597,447,'Peyad S.O','695573',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126598,447,'Plamootukada B.O','695122',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126599,447,'Ponmudi B.O','695551',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126600,447,'Poojapura H.O','695012',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126601,447,'Poojapura Junction S.O','695012',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126602,447,'Poonthura S.O','695026',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126603,447,'Poovachal S.O','695575',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126604,447,'Poovathur B.O','695561',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126605,447,'Poozhanad B.O','695125',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126606,447,'Pozhiyoor S.O','695513',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126607,447,'Pravachambalam B.O','695020',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126608,447,'PTP Nagar S.O','695038',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126609,447,'Puliyarakonam B.O','695573',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126610,447,'Pulluvila S.O','695526',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126611,447,'Punalal B.O','695575',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126612,447,'Puthiathura B.O','695526',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126613,447,'Puthukulangara B.O','695541',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126614,447,'Puvar S.O','695525',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126615,447,'Russelpuram B.O','695501',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126616,447,'Sasthamangalam S.O','695010',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126617,447,'Thamalam B.O','695012',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126618,447,'Thannimoodu B.O','695123',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126619,447,'Thekkupara B.O','695505',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126620,447,'Thennur B.O','695563',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126621,447,'Thiruvallom S.O','695027',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126622,447,'Tholicode B.O','695541',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126623,447,'Thycaud S.O','695014',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126624,447,'Tirumala S.O (Thiruvananthapuram)','695006',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126625,447,'Tirupuram S.O','695133',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126626,447,'TVM  R.K Mission B.O','695010',1,0,'2022-03-04 19:25:40','2022-03-04 19:25:40'),(126627,447,'Uchakada S.O','695506',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126628,447,'Uriakode B.O','695543',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126629,447,'Valiamala S.O','695547',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126630,447,'Valiavila B.O','695006',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126631,447,'Vattakarikkakom B.O','695562',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126632,447,'Vattavila B.O','695132',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126633,447,'Vattiyoorkavu S.O','695013',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126634,447,'Vazhichal B.O','695125',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126635,447,'Vedivachankoil B.O','695501',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126636,447,'Veeranakavu B.O','695572',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126637,447,'Veliyamcode B.O','695512',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126638,447,'Veliyannur B.O','695543',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126639,447,'Vellanad S.O','695543',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126640,447,'Vellarada S.O','695505',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126641,447,'Vellayani S.O','695522',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126642,447,'Venganur S.O','695523',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126643,447,'Venkadambu B.O','695506',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126644,447,'Venpakal B.O','695123',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126645,447,'Vilappilsala B.O','695573',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126646,447,'Vinobaniketan B.O','695542',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126647,447,'Vithura S.O','695551',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126648,447,'Vizhinjam S.O','695521',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126649,447,'Vlathankara S.O','695134',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126650,448,'Alagappanagar S.O','680302',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126651,448,'Alathur(Thrissur) B.O','680741',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126652,448,'Alur-Kalletumkara B.O','680683',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126653,448,'Anandapuram B.O','680305',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126654,448,'Anapuzha B.O','680667',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126655,448,'Annallur B.O','680731',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126656,448,'Annamanada S.O','680741',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126657,448,'Annanad B.O','680309',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126658,448,'Arattupuzha B.O','680562',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126659,448,'Aripalam S.O','680688',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126660,448,'Ashtamichira S.O','680731',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126661,448,'Avittathur B.O','680683',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126662,448,'Azhikode Jetty B.O','680666',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126663,448,'Azhikode-Thrissur B.O','680666',1,0,'2022-03-04 19:25:41','2022-03-04 19:25:41'),(126664,448,'Chaipankuzhi B.O','680724',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126665,448,'Chakkarappadam B.O','680686',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126666,448,'Chalakudi H.O','680307',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126667,448,'Chalakudi R S B.O','680722',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126668,448,'Chalakudi South S.O','680307',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126669,448,'Chalakudi Town S.O','680307',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126670,448,'Chalingad B.O','680681',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126671,448,'Chamakkala B.O','680687',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126672,448,'Chattikulam B.O','680721',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126673,448,'Chazhur B.O','680571',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126674,448,'Chelur B.O','680121',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126675,448,'Chembuchira B.O','680684',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126676,448,'Chengallur S.O','680312',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126677,448,'Chentrappinni East B.O','680687',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126678,448,'Chentrappinni S.O','680687',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126679,448,'Cherpu Padinjattumuri B.O','680561',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126680,448,'Cherpu S.O','680561',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126681,448,'Cheruvallur B.O','680308',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126682,448,'Chimoni Dam B.O','680304',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126683,448,'Chittissery B.O','680301',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126684,448,'Chokkana B.O','680699',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126685,448,'Chulur B.O','680567',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126686,448,'Edakulam B.O','680688',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126687,448,'Edamuttam S.O','680568',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126688,448,'Edathirinji S.O','680122',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126689,448,'Edathuruthy S.O','680703',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126690,448,'Edavilangu S.O','680671',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126691,448,'Elinjipra B.O','680721',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126692,448,'Eravathur B.O','680734',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126693,448,'Erayamkudi B.O','680308',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126694,448,'Eriyad S.O','680666',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126695,448,'Inchakundu B.O','680312',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126696,448,'Inchamudy B.O','680564',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126697,448,'Iranikulam B.O','680734',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126698,448,'Irinjalakuda H.O','680121',1,0,'2022-03-04 19:25:42','2022-03-04 19:25:42'),(126699,448,'Irinjalakuda Mkt S.O','680121',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126700,448,'Irinjalakuda North S.O','680125',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126701,448,'Kadukutty B.O','680309',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126702,448,'Kaduppassery  South B.O','680683',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126703,448,'Kaduppassery B.O','680683',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126704,448,'Kaipamangalam Beach B.O','680681',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126705,448,'Kaipamangalam S.O','680681',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126706,448,'Kalimbram B.O','680568',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126707,448,'Kallettumkara S.O','680683',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126708,448,'Kallur S.O (Thrissur)','680317',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126709,448,'Kalparamba B.O','680662',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126710,448,'Kanakamala B.O','680689',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126711,448,'Kandamkulam B.O','680669',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126712,448,'Kanjirappilly-TCR B.O','680721',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126713,448,'Kannampallipuram B.O','680687',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126714,448,'Kannikulangara B.O','680682',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126715,448,'Kara B.O','680671',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126716,448,'Karalam B.O','680711',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126717,448,'Karanchira B.O','680702',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126718,448,'Karayamvattam B.O','680567',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126719,448,'Karumathra B.O','680123',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126720,448,'Karupadanna S.O','680670',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126721,448,'Karur B.O','680697',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126722,448,'Karuvannur S.O','680711',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126723,448,'Kathikkudam B.O','680308',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126724,448,'Kattoor S.O','680702',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126725,448,'Kilakkummuri S.O','680571',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126726,448,'Kinfra Park Koratti S.O','680309',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126727,448,'Kizhupillikkara B.O','680702',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126728,448,'Kodakara S.O','680684',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126729,448,'Kodassery B.O','680721',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126730,448,'Kodungallur S.O','680664',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126731,448,'Kombathukadavu B.O','680682',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126732,448,'Konathukunnu S.O','680123',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126733,448,'Konnakuzhy B.O','680721',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126734,448,'Koolimuttam S.O','680691',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126735,448,'Koorikuzhi B.O','680681',1,0,'2022-03-04 19:25:43','2022-03-04 19:25:43'),(126736,448,'Koovakkattukunnu B.O','680311',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126737,448,'Koratti Kizhakkumuri B.O','680308',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126738,448,'Koratti S.O','680308',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126739,448,'Koratti South B.O','680308',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126740,448,'Kothaparamba S.O','680668',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126741,448,'Kottamuri B.O','680732',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126742,448,'Kottanallur B.O','680662',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126743,448,'Kottappuram S.O','680667',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126744,448,'Kottat B.O','680731',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126745,448,'Krishnankotta B.O','680733',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126746,448,'Kundur B.O','680734',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126747,448,'Kunnappilly B.O','680311',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126748,448,'Kurumbilavu B.O','680564',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126749,448,'Kuruvilassery B.O','680732',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126750,448,'Kuttamangalam B.O','680703',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126751,448,'Kuttichira S.O','680724',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126752,448,'Kuttikkad B.O','680724',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126753,448,'Kuzhikkattussery B.O','680697',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126754,448,'Kuzhur S.O','680734',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126755,448,'Lokamaleswaram North B.O','680664',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126756,448,'Madathumpady B.O','680733',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126757,448,'Madavana B.O','680666',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126758,448,'Madayikonam S.O','680712',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126759,448,'Malakkapara B.O','680721',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126760,448,'Mala-thrissur S.O','680732',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126761,448,'Mambra B.O','680308',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126762,448,'Manakulangara B.O','680684',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126763,448,'Mathilakam S.O','680685',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126764,448,'Mattathur B.O','680684',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126765,448,'Mattathurkkunnu B.O','680684',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126766,448,'Melur S.O (Thrissur)','680311',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126767,448,'Methala S.O','680669',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126768,448,'Moorkkanad B.O','680711',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126769,448,'Mothirakkanni B.O','680724',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126770,448,'Mupliyam B.O','680312',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126771,448,'Murikkungal B.O','680699',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126772,448,'Muringoor Vadakkummuri B.O','680309',1,0,'2022-03-04 19:25:44','2022-03-04 19:25:44'),(126773,448,'Muriyad B.O','680683',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126774,448,'Muttithadi B.O','680317',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126775,448,'Nadavaramba S.O','680661',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126776,448,'Nalukettu B.O','680308',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126777,448,'Nandikkara B.O','680301',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126778,448,'Nandipulam B.O','680312',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126779,448,'Nattika S.O','680566',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126780,448,'Nattikabeach B.O','680566',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126781,448,'Nellayi-thrissur S.O','680305',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126782,448,'Nenmenikkara B.O','680301',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126783,448,'Padinjare Vemballur B.O','680671',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126784,448,'Padiyur B.O','680688',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126785,448,'Pady S.O','680699',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126786,448,'Palappilly S.O','680304',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126787,448,'Palayamparambu B.O','680741',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126788,448,'Pallipuram B.O','680732',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126789,448,'Panamkulam B.O','680711',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126790,448,'Panangad S.O (Thrissur)','680665',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126791,448,'Parappukkara S.O','680310',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126792,448,'Pariyaram S.O (Thrissur)','680721',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126793,448,'Pathazhakkad B.O','680668',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126794,448,'Pazhayi B.O','680301',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126795,448,'Pazhuvil S.O','680564',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126796,448,'Pazhuvil West B.O','680564',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126797,448,'Perambra-thrissur S.O','680689',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126798,448,'Peringottukara S.O','680565',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126799,448,'Perinjanam S.O','680686',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126800,448,'Perinjanam West B.O','680686',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126801,448,'Ponjanam B.O','680702',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126802,448,'Pooppathy B.O','680733',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126803,448,'Pootharakkal B.O','680561',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45');
INSERT INTO `cities` VALUES (126804,448,'Poovathussery B.O','680741',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126805,448,'Porathissery B.O','680125',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126806,448,'Poringalkuthu B.O','680721',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126807,448,'Potta S.O','680722',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126808,448,'Poyya S.O','680733',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126809,448,'Pudukad S.O','680301',1,0,'2022-03-04 19:25:45','2022-03-04 19:25:45'),(126810,448,'Pullur B.O','680683',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126811,448,'Pullut North B.O','680663',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126812,448,'Pullut S.O','680663',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126813,448,'Puthenchira Kizhakkummuri B.O','680682',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126814,448,'Puthenchira S.O','680682',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126815,448,'Puthenchira Thekkummuri B.O','680682',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126816,448,'Santhipuram B.O','680668',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126817,448,'Srinngapuram S.O','680664',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126818,448,'Thanissery S.O','680701',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126819,448,'Thazhekkad S.O','680697',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126820,448,'Thiruvanchikulam B.O','680664',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126821,448,'Thottippal B.O','680310',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126822,448,'Thumbur B.O','680662',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126823,448,'Triprayar B.O','680567',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126824,448,'Urakam S.O','680562',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126825,448,'Vadakkummuri S.O','680570',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126826,448,'Vadama B.O','680732',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126827,448,'Valapad Beach B.O','680567',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126828,448,'Valapad S.O','680567',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126829,448,'Vallachira B.O','680562',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126830,448,'Vallivattam B.O','680123',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126831,448,'Varakara B.O','680302',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126832,448,'Varandarappilly S.O','680303',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126833,448,'Vattanathara B.O','680302',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126834,448,'Vellanchira B.O','680697',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126835,448,'Vellangallur S.O','680662',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126836,448,'Vellani B.O','680701',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126837,448,'Vellikulangara B.O','680699',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126838,448,'Velupadam B.O','680303',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126839,448,'Vettilappara B.O','680721',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126840,448,'Vijayaraghavapuram B.O','680722',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126841,448,'Adat B.O','680551',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126842,448,'Agalad S.O','680518',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126843,448,'Akathiyur B.O','680519',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126844,448,'Akkikavu B.O','680519',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126845,448,'Alapad B.O','680641',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126846,448,'Alur Mattom B.O','680602',1,0,'2022-03-04 19:25:46','2022-03-04 19:25:46'),(126847,448,'Amalanagar S.O','680555',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126848,448,'Ammadam S.O','680563',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126849,448,'Anchery B.O','680006',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126850,448,'Andathode S.O','679564',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126851,448,'Anjur Mundur B.O','680541',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126852,448,'Anjur-kunnamkulam B.O','680523',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126853,448,'Annakara B.O','680508',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126854,448,'Anthikad S.O','680641',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126855,448,'Aranattukara S.O','680618',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126856,448,'Arangottukara B.O','679532',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126857,448,'Arimpur S.O','680620',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126858,448,'Ariyannur S.O','680102',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126859,448,'Arthat S.O','680521',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126860,448,'Asarikkad B.O','680751',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126861,448,'Athani Thrissur B.O','680581',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126862,448,'Attur B.O','680583',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126863,448,'Avanisseri B.O','680306',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126864,448,'Avanur B.O','680541',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126865,448,'Ayyanthole North B.O','680003',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126866,448,'Ayyanthole S.O','680003',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126867,448,'Ayyappankavu B.O','680751',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126868,448,'Blangad B.O','680506',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126869,448,'Brahmakulam B.O','680104',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126870,448,'Chakkumkandam B.O','680522',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126871,448,'Chammannur B.O','679561',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126872,448,'Chavakkad S.O','680506',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126873,448,'Chelakkara S.O','680586',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126874,448,'Chelakode B.O','680587',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126875,448,'Chemmannur B.O','680517',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126876,448,'Chemmanthatta B.O','680501',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126877,448,'Chennaipara B.O','680653',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126878,448,'Cherur S.O','680008',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126879,448,'Cheruthuruthy S.O','679531',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126880,448,'Chettupuzha B.O','680012',1,0,'2022-03-04 19:25:47','2022-03-04 19:25:47'),(126881,448,'Chiramanangad B.O','680604',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126882,448,'Chiranellur B.O','680501',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126883,448,'Chittanda B.O','680585',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126884,448,'Chittanjur B.O','680523',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126885,448,'Chittattukara S.O','680511',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126886,448,'Chittilapilly B.O','680551',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126887,448,'Chiyyaram S.O','680026',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126888,448,'Choolissery B.O','680541',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126889,448,'Choondal S.O','680502',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126890,448,'Chottupara B.O','680581',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126891,448,'Chovvur B.O','680027',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126892,448,'Chowannur B.O','680517',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126893,448,'Chuvannamannu B.O','680652',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126894,448,'Desamangalam S.O','679532',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126895,448,'Edakkalathur B.O','680552',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126896,448,'Edakkaliyur S.O','680515',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126897,448,'Edakkara-Thrissur B.O','680518',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126898,448,'Edassery B.O','680569',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126899,448,'Elanad B.O','680586',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126900,448,'Elavally B.O','680511',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126901,448,'Elavally South B.O','680511',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126902,448,'Elthuruth S.O','680611',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126903,448,'Enamakkal B.O','680510',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126904,448,'Engandiyur S.O','680615',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126905,448,'Enkakad S.O','680589',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126906,448,'Eranellur B.O','680501',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126907,448,'Eravimangalam B.O','680751',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126908,448,'Eravu B.O','680620',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126909,448,'Erumapetty S.O','680584',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126910,448,'Eyyal B.O','680501',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126911,448,'Guruvayur S.O','680101',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126912,448,'Guruvayur Temple S.O','680101',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126913,448,'Iringapuram B.O','680103',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126914,448,'Irunilamcode B.O','680583',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126915,448,'Kadappuram S.O','680514',1,0,'2022-03-04 19:25:48','2022-03-04 19:25:48'),(126916,448,'Kadavallur S.O','680543',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126917,448,'Kainoor B.O','680014',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126918,448,'Kaiparamba S.O','680546',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126919,448,'Kakkassery B.O','680511',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126920,448,'Kaliyarode B.O','680586',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126921,448,'Kallepadam B.O','680587',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126922,448,'Kallur-Vadakkekkad B.O','679562',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126923,448,'Kanattukara S.O','680011',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126924,448,'Kandanassery B.O','680102',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126925,448,'Kandassankadavu S.O','680613',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126926,448,'Kanimangalam S.O','680027',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126927,448,'Kanippayur S.O','680517',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126928,448,'Kaniyarkod S.O','680594',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126929,448,'Kanjani S.O','680612',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126930,448,'Kanjirakode B.O','680590',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126931,448,'Kannara B.O','680652',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126932,448,'Kannoth B.O','680510',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126933,448,'Karikkad S.O','680519',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126934,448,'Karumathra B.O','680589',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126935,448,'Kattakampal S.O','680544',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126936,448,'Kattilapoovam B.O','680028',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126937,448,'Katungode B.O','680584',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126938,448,'Kavida B.O','680505',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126939,448,'Kecheri S.O','680501',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126940,448,'Kerala Agri-university S.O','680656',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126941,448,'Killimangalam S.O','680591',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126942,448,'Kiralur B.O','680601',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126943,448,'Kizhur S.O','680523',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126944,448,'Kochannur B.O','679562',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126945,448,'Kodannur B.O','680563',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126946,448,'Kolazhi RM B.O','680010',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126947,448,'Kondazhi S.O','679106',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126948,448,'Konikara B.O','680306',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126949,448,'Koonamoochi S.O','680504',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126950,448,'Kootala-Thrissur B.O','680652',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126951,448,'Korattikkara B.O','680543',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126952,448,'Kottappadi S.O','680505',1,0,'2022-03-04 19:25:49','2022-03-04 19:25:49'),(126953,448,'Kottappuram Wri B.O','680584',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126954,448,'Kozhukully B.O','680751',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126955,448,'Kumaranellur TC S.O','680590',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126956,448,'Kumarappanal B.O','680585',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126957,448,'Kumbalacode B.O','680587',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126958,448,'Kundaliyur S.O','680616',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126959,448,'Kundannur B.O','680590',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126960,448,'Kundukad B.O','680028',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126961,448,'Kunnamkulam City B.O','680523',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126962,448,'Kunnamkulam H.O','680503',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126963,448,'Kuranniyur B.O','680506',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126964,448,'Kuriachira S.O','680006',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126965,448,'Kurkancheri S.O','680007',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126966,448,'Kuruchikkara S.O','680028',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126967,448,'Kurumal B.O','680601',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126968,448,'Kurumala B.O','680586',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126969,448,'Kuthampilly B.O','680594',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126970,448,'Kuttanchery B.O','680584',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126971,448,'Kuttanellur B.O','680014',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126972,448,'Kuttur S.O (Thrissur)','680013',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126973,448,'Madakkathara B.O','680651',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126974,448,'Madu B.O','680512',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126975,448,'Malavattom B.O','680588',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126976,448,'Malesamangalam B.O','680588',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126977,448,'Manakkodi B.O','680012',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126978,448,'Manalithara B.O','680589',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126979,448,'Manalur HS B.O','680617',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126980,448,'Manalur S.O','680617',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126981,448,'Mangad B.O','680542',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126982,448,'Mannalamkunnu B.O','680518',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126983,448,'Mannamangalam B.O','680014',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126984,448,'Mannuthy S.O','680651',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126985,448,'Marathakkara B.O','680306',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126986,448,'Marottichal B.O','680014',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126987,448,'Maruthancode S.O','680604',1,0,'2022-03-04 19:25:50','2022-03-04 19:25:50'),(126988,448,'Maruthayur B.O','680507',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(126989,448,'Mattom S.O','680602',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(126990,448,'Mayannur S.O','679105',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(126991,448,'Minalur B.O','680581',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(126992,448,'Mulagunnathukavu S.O','680581',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(126993,448,'Mulayam B.O','680751',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(126994,448,'Mullassery S.O','680509',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(126995,448,'Mullurkkara S.O','680583',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(126996,448,'Mundathicode B.O','680601',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(126997,448,'Mundathicode West B.O','680623',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(126998,448,'Mundur-TC S.O','680541',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(126999,448,'Nadathara S.O','680751',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(127000,448,'Naduvilkkara B.O','680614',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(127001,448,'Nambazhikad B.O','680602',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(127002,448,'Nedupuzha B.O','680007',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(127003,448,'Nehrunagar B.O','680006',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(127004,448,'Nellikunnu B.O','680005',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(127005,448,'Nelluvaya B.O','680584',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(127006,448,'Nemmini B.O','680104',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(127007,448,'Nettissery B.O','680651',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(127008,448,'Netumpura B.O','679531',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(127009,448,'Nhamanghat S.O','679563',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(127010,448,'Ollukkara S.O','680655',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(127011,448,'Ollur North B.O','680306',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(127012,448,'Ollur S.O','680306',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(127013,448,'Ollur Thaikkattussery B.O','680306',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(127014,448,'Orumanayur S.O','680512',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(127015,448,'Padiyam B.O','680641',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(127016,448,'Padoor S.O','680524',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(127017,448,'Painkulam B.O','679531',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(127018,448,'Palayur B.O','680506',1,0,'2022-03-04 19:25:51','2022-03-04 19:25:51'),(127019,448,'Palissery B.O','680027',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127020,448,'Pallam Kottambathur B.O','679532',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127021,448,'Pallur B.O','679532',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127022,448,'Paluvai S.O','680522',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127023,448,'Pampady East B.O','680588',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127024,448,'Pampady West B.O','680588',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127025,448,'Panangattukara B.O','680623',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127026,448,'Pangarappally B.O','680586',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127027,448,'Panjal B.O','679531',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127028,448,'Paralam B.O','680563',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127029,448,'Parappur S.O','680552',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127030,448,'Parlikkad B.O','680623',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127031,448,'Pathiyarkulangara B.O','680552',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127032,448,'Pattikkad TC S.O','680652',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127033,448,'Pattiparambu B.O','680588',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127034,448,'Pavaratty S.O','680507',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127035,448,'Pazhanji S.O','680542',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127036,448,'Pazhayannur S.O','680587',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127037,448,'Peechi S.O','680653',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127038,448,'Pengamuck B.O','680544',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127039,448,'Perakam B.O','680506',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127040,448,'Peramangalam S.O','680545',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127041,448,'Perinchery B.O','680306',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127042,448,'Peringandur B.O','680581',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127043,448,'Peringavu B.O','680008',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127044,448,'Perumpilavu B.O','680519',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127045,448,'Perumthuruthy B.O','680542',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127046,448,'Peruvallur B.O','680508',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127047,448,'Ponnore B.O','680552',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127048,448,'Ponnukkara B.O','680306',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127049,448,'Pookode B.O','680505',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127050,448,'Poomala B.O','680581',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127051,448,'Poothole S.O','680004',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127052,448,'Poovanchira B.O','680652',1,0,'2022-03-04 19:25:52','2022-03-04 19:25:52'),(127053,448,'Porkolangad B.O','680517',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127054,448,'Porkulam B.O','680542',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127055,448,'Pottore B.O','680581',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127056,448,'Puduruthy B.O','680623',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127057,448,'Pulakkad B.O','680585',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127058,448,'Pulakode B.O','680586',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127059,448,'Pullazhi S.O','680012',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127060,448,'Pullu B.O','680641',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127061,448,'Punkunnu S.O','680002',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127062,448,'Punnayur B.O','679562',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127063,448,'Punnayurkulam S.O','679561',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127064,448,'Puranattukara S.O','680551',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127065,448,'Puthanpalli S.O','680103',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127066,448,'Puthenpeedika S.O','680642',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127067,448,'Puthur-Thrissur S.O','680014',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127068,448,'Puvathur S.O','680508',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127069,448,'Puzhakkal S.O','680553',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127070,448,'Ramavarmapuram S.O','680631',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127071,448,'South Kondazhi B.O','679106',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127072,448,'Tali B.O','680585',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127073,448,'Talikulam S.O','680569',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127074,448,'Thaikkad S.O','680104',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127075,448,'Thalakkottukara B.O','680501',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127076,448,'Thalassery B.O','679532',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127077,448,'Thalore B.O','680306',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127078,448,'Thamarayur B.O','680505',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127079,448,'Thampankadavu B.O','680569',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127080,448,'Thangalur B.O','680596',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127081,448,'Thayyur B.O','680584',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127082,448,'Thekkumkara B.O','680589',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127083,448,'Thichur B.O','680584',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127084,448,'Thippilissery B.O','680519',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127085,448,'Thirunellur B.O','680508',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127086,448,'Thiruvambady TSR S.O','680022',1,0,'2022-03-04 19:25:53','2022-03-04 19:25:53'),(127087,448,'Thiruvenkitam B.O','680101',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127088,448,'Thiruvilwamala S.O','680588',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127089,448,'Thonnurkkara B.O','680586',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127090,448,'Thozhiyur S.O','680520',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127091,448,'Thozhupadam B.O','680586',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127092,448,'Thrissur Central S.O','680001',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127093,448,'Thrissur City S.O','680020',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127094,448,'Thrissur East S.O','680005',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127095,448,'Thrissur Engg College S.O','680009',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127096,448,'Thrissur H.O','680001',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127097,448,'Thrissur Medical College S.O','680596',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127098,448,'Thrissur R S S.O','680021',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127099,448,'Tirur B.O','680581',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127100,448,'Tiruvatra S.O','680516',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127101,448,'Tolur-parappur B.O','680552',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127102,448,'Toyakkavu S.O','680513',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127103,448,'Trikkur B.O','680306',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127104,448,'Trithallur S.O','680619',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127105,448,'Trithallur West B.O','680619',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127106,448,'Vadakkekad S.O','679562',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127107,448,'Vadakkethara B.O','680587',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127108,448,'Vadookkara B.O','680007',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127109,448,'Vaka B.O','680602',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127110,448,'Vaniampara B.O','680652',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127111,448,'Varavur S.O','680585',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127112,448,'Vatanapally Beach B.O','680614',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127113,448,'Vatanappally S.O','680614',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127114,448,'Vattekkad B.O','680512',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127115,448,'Vayilathur B.O','679563',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127116,448,'Vazhani B.O','680589',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127117,448,'Vellanikkara S.O','680654',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127118,448,'Vellarakad B.O','680584',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127119,448,'Vellattanjur B.O','680601',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127120,448,'Velur Bazar B.O','680601',1,0,'2022-03-04 19:25:54','2022-03-04 19:25:54'),(127121,448,'Velur Thrissur S.O','680601',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127122,448,'Veluthur B.O','680012',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127123,448,'Vemmanad B.O','680507',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127124,448,'Venganellur B.O','680586',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127125,448,'Venkitangu S.O','680510',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127126,448,'Vennur B.O','680587',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127127,448,'Vettikkattiri R.S. B.O','679531',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127128,448,'Vettukad B.O','680014',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127129,448,'Viyyur S.O','680010',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127130,448,'Vyasagiri B.O','680623',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127131,448,'Wadakanchery-TC H.O','680582',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127132,448,'Wadakkancheri-Thrissur RS S.O','680623',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127133,448,'West Fort B.O','680004',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127134,449,'Achooranam B.O','673575',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127135,449,'Amara Kuni B.O','673579',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127136,449,'Ambalavayal S.O','673593',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127137,449,'Arambatta Kunnu B.O','673575',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127138,449,'Athirattu Kunnu B.O','673596',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127139,449,'Beenachi B.O','673592',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127140,449,'Bhoodanam Colony B.O','673579',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127141,449,'Bibleland B.O','673575',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127142,449,'Chedalath B.O','673592',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127143,449,'Cheengeri B.O','673593',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127144,449,'Cheeral S.O','673595',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127145,449,'Cheeyambam B.O','673579',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127146,449,'Chellangode B.O','673581',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127147,449,'Chembra B.O','673577',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127148,449,'Chennalode B.O','673122',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127149,449,'Chettapalam B.O','673579',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127150,449,'Choothupara B.O','673596',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127151,449,'Chulliote B.O','673592',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127152,449,'Chundale S.O','673123',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127153,449,'Cottanad B.O','673577',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127154,449,'Kabanigiri B.O','673579',1,0,'2022-03-04 19:25:55','2022-03-04 19:25:55'),(127155,449,'Kadalmat B.O','673581',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127156,449,'Kakka Vayal B.O','673122',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127157,449,'Kalanadi Kolli B.O','673579',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127158,449,'Kalathu Vayal B.O','673593',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127159,449,'Kalpetta H.O','673121',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127160,449,'Kalpetta North S.O','673122',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127161,449,'Kambalakkad B.O','673122',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127162,449,'Kaniyambetta B.O','673122',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127163,449,'Karachal B.O','673591',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127164,449,'Karadipara B.O','673593',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127165,449,'Karani B.O','673591',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127166,449,'Karinkutty B.O','673122',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127167,449,'Kariyambadi B.O','673591',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127168,449,'Kavumannam B.O','673122',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127169,449,'Kenichira S.O','673596',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127170,449,'Kidanganad B.O','673592',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127171,449,'Kolagapara B.O','673591',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127172,449,'Koleri B.O','673596',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127173,449,'Kottathara B.O','673122',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127174,449,'Krishna Giri B.O','673591',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127175,449,'Kumbaleri B.O','673591',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127176,449,'Kunnambetta B.O','673123',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127177,449,'Kuppadi B.O','673592',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127178,449,'Lakkidi B.O','673576',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127179,449,'Madakkimala B.O','673122',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127180,449,'Madakunnu B.O','673122',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127181,449,'Manal Vayal B.O','673579',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127182,449,'Mandad B.O','673122',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127183,449,'Maniyangode B.O','673122',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127184,449,'Manjoora B.O','673575',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127185,449,'Marakadavu B.O','673579',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127186,449,'Meenangadi S.O','673591',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127187,449,'Meppadi S.O','673577',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127188,449,'Moodakolli B.O','673592',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127189,449,'Mookuthi Kunnu B.O','673595',1,0,'2022-03-04 19:25:56','2022-03-04 19:25:56'),(127190,449,'Moolan Kavu B.O','673592',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127191,449,'Mullankolli B.O','673579',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127192,449,'Mundakai B.O','673577',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127193,449,'Muthanga B.O','673592',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127194,449,'Muttil B.O','673122',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127195,449,'Mylambadi B.O','673591',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127196,449,'Naiketty B.O','673592',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127197,449,'Nallara Chal B.O','673593',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127198,449,'Nambiar Kunnu B.O','673595',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127199,449,'Narikkundu B.O','673593',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127200,449,'Nathamkuni B.O','673577',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127201,449,'Nenmeni B.O','673592',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127202,449,'Nenmeni Kunnu B.O','673595',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127203,449,'Nulpuzha B.O','673592',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127204,449,'Padichira B.O','673579',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127205,449,'Padinhara Thara B.O','673575',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127206,449,'Pakkom B.O','673579',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127207,449,'Palakolli B.O','673579',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127208,449,'Pallikunnu Wynad B.O','673122',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127209,449,'Pambra B.O','673592',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127210,449,'Pariyaram - Wynad B.O','673122',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127211,449,'Pazhupathur B.O','673592',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127212,449,'Perikallur B.O','673579',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127213,449,'Pinangode B.O','673122',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127214,449,'Poomulla B.O','673592',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127215,449,'Poothadi B.O','673596',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127216,449,'Pozhuthana S.O','673575',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127217,449,'Pulpalli S.O','673579',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127218,449,'Puthan Kunnu B.O','673595',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127219,449,'Puthumala B.O','673577',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127220,449,'Puthur Vayal B.O','673577',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127221,449,'Puzhamutti B.O','673122',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127222,449,'Ripon Wynad B.O','673577',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127223,449,'Sasimala B.O','673579',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127224,449,'Seetha Mount B.O','673579',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127225,449,'Sugandhagiri B.O','673576',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127226,449,'Sulthan Bathery East S.O','673592',1,0,'2022-03-04 19:25:57','2022-03-04 19:25:57'),(127227,449,'Sulthan Bathery S.O','673592',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127228,449,'Thariote B.O','673575',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127229,449,'Thariote North B.O','673575',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127230,449,'Thazha Munda B.O','673596',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127231,449,'Thazhathur B.O','673595',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127232,449,'Thekkumthara B.O','673122',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127233,449,'Thovari Mala B.O','673592',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127234,449,'Trikai Petta B.O','673577',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127235,449,'Vakeri B.O','673592',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127236,449,'Vala Vayal B.O','673596',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127237,449,'Vallarmala B.O','673577',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127238,449,'Valluvadi B.O','673592',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127239,449,'Varadoor B.O','673591',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127240,449,'Varambetta B.O','673575',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127241,449,'Vatuvanchal S.O','673581',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127242,449,'Vazhu Vatta B.O','673122',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127243,449,'Veliyambam B.O','673579',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127244,449,'Vythiri S.O','673576',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127245,449,'Alattil B.O','670644',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127246,449,'Anjukunnu B.O','670645',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127247,449,'Arattuthara B.O','670645',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127248,449,'Arinjerummal B.O','670721',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127249,449,'Bavali B.O','670646',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127250,449,'Cherakkara(wayanad) B.O','670644',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127251,449,'Cherukattoor B.O','670721',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127252,449,'Echchome B.O','670721',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127253,449,'Edavaka B.O','670645',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127254,449,'Ellumannam B.O','670645',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127255,449,'Kammana B.O','670645',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127256,449,'Kampatti B.O','670644',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127257,449,'Kappattumala B.O','670644',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127258,449,'Karakkamala B.O','670645',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127259,449,'Kartikulam S.O','670646',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127260,449,'Kattayad B.O','670731',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127261,449,'Kayakunnu B.O','670721',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127262,449,'Kellur B.O','670645',1,0,'2022-03-04 19:25:58','2022-03-04 19:25:58'),(127263,449,'Kottarakunnu B.O','670731',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127264,449,'Kunhome B.O','670731',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127265,449,'Kunnamangalam Wayanad B.O','670645',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127266,449,'Makkiad B.O','670731',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127267,449,'Mananthavady S.O','670645',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127268,449,'Mattilayam B.O','670731',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127269,449,'Mundakutty B.O','670645',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127270,449,'Nadavayal B.O','670721',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127271,449,'Nallurnad B.O','670645',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127272,449,'Nirvaram B.O','670721',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127273,449,'Panamaram S.O','670721',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127274,449,'Panavally B.O','670646',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127275,449,'Payyampalli B.O','670646',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127276,449,'Periya B.O','670644',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127277,449,'Pilakavu B.O','670645',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127278,449,'Porur(wayanad) B.O','670644',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127279,449,'Pudusseri B.O','670645',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127280,449,'Pudusserikadavu B.O','670645',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127281,449,'Tavinhal B.O','670644',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127282,449,'Thalappuzha S.O','670644',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127283,449,'Tharuvana B.O','670645',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127284,449,'Thettamala B.O','670731',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127285,449,'Tholpetty B.O','670646',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127286,449,'Thondernadu B.O','670731',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127287,449,'Thrissileri B.O','670646',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127288,449,'Tirunelli B.O','670646',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127289,449,'Tirunelli Temple B.O','670646',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127290,449,'Valery B.O','670645',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127291,449,'Vallat B.O','670644',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127292,449,'Vanhode B.O','670731',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127293,449,'Varayal B.O','670644',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127294,449,'Vellamunda S.O','670731',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127295,449,'Vemom B.O','670645',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127296,449,'Vimalanagar B.O','670645',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127297,450,'Agathi S.O','682553',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127298,450,'Amini S.O','682552',1,0,'2022-03-04 19:25:59','2022-03-04 19:25:59'),(127299,450,'Androth S.O','682551',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127300,450,'Bithra B.O','682554',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127301,450,'Chetlat S.O','682554',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127302,450,'Kadamat S.O','682556',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127303,450,'Kalpeni S.O','682557',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127304,450,'Kavaratti S.O','682555',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127305,450,'Kiltan S.O','682558',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127306,450,'Minicoy S.O','682559',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127307,451,'Alirajpur S.O','457887',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127308,451,'Katthiwada S.O','457885',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127309,451,'Sondwa S.O','457888',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127310,452,'Achalpur B.O','484881',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127311,452,'Amai Colliery S.O','484116',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127312,452,'Amarkantak S.O','484886',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127313,452,'Amdari B.O','484881',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127314,452,'Amgawan B.O','484330',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127315,452,'Amgawan B.O','484881',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127316,452,'Anuppur Basti B.O','484224',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127317,452,'Anuppur S.O','484224',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127318,452,'Audhera B.O','484224',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127319,452,'Badra Colliery B.O','484334',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127320,452,'Baherabandh B.O','484440',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127321,452,'Bahgarh B.O','484224',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127322,452,'Baitola B.O','484440',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127323,452,'Balbahra B.O','484224',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127324,452,'Bamhani B.O','484881',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127325,452,'Bamhani B.O','484224',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127326,452,'Barbaspur B.O','484336',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127327,452,'Barbaspur B.O','484224',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127328,452,'Bargawan B.O','484117',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127329,452,'Basantpur B.O','484881',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127330,452,'Baskuta B.O','484555',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127331,452,'Batura B.O','484001',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127332,452,'Beed B.O','484113',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127333,452,'Beldongari B.O','484881',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127334,452,'Beliabadi B.O','484334',1,0,'2022-03-04 19:26:00','2022-03-04 19:26:00'),(127335,452,'Benibari B.O','484881',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127336,452,'Bhad B.O','484336',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127337,452,'Bhejari B.O','484886',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127338,452,'Bilaspur B.O','484886',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127339,452,'Biltukari B.O','484334',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127340,452,'Chachai S.O','484220',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127341,452,'Chhilhiyamar B.O','484881',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127342,452,'Chhilpa B.O','484224',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127343,452,'Cholna B.O','484113',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127344,452,'Chukan B.O','484336',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127345,452,'Damehri B.O','484881',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127346,452,'Deogawan B.O','484334',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127347,452,'Dhangawan B.O','484224',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127348,452,'Dhirutola B.O','484881',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127349,452,'Dhunmaniya B.O','484881',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127350,452,'Dhurwasin B.O','484224',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127351,452,'Dulhara B.O','484224',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127352,452,'Funga B.O','484224',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127353,452,'Gaurela B.O','484330',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127354,452,'Ghoghari B.O','484881',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127355,452,'Girari B.O','484881',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127356,452,'Gorsi B.O','484330',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127357,452,'Harad B.O','484444',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127358,452,'Igntu Amarkantak S.O.','484887',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127359,452,'Jaithari S.O','484330',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127360,452,'Jamgaon B.O','484334',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127361,452,'Jamudi B.O','484224',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127362,452,'Jarha B.O','484881',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127363,452,'Jeelang B.O','484881',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127364,452,'Jheek Bijuri B.O','484334',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127365,452,'Johila Project B.O','484886',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127366,452,'Kachhratola B.O','484881',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127367,452,'Karanpathar B.O','484881',1,0,'2022-03-04 19:26:01','2022-03-04 19:26:01'),(127368,452,'Karaundi B.O','484881',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127369,452,'Karkat B.O','484770',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127370,452,'Karpa B.O','484881',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127371,452,'Kartora B.O','484334',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127372,452,'Katkona B.O','484440',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127373,452,'Keshwahi B.O','484224',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127374,452,'Khamhidol B.O','484224',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127375,452,'Khamraundh B.O','484334',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127376,452,'Khamraundh B.O','484881',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127377,452,'Khati B.O','484886',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127378,452,'Khodri B.O','484334',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127379,452,'Khoh B.O','484224',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127380,452,'Khurkhuridadar B.O','484886',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127381,452,'Kohka B.O','484555',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127382,452,'Koilari B.O','484881',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127383,452,'Kothi B.O','484440',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127384,452,'Kotma Colliery S.O','484336',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127385,452,'Kotma S.O','484334',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127386,452,'Kudri B.O','484555',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127387,452,'Laharpur B.O','484330',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127388,452,'Lakhaura B.O','484881',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127389,452,'Lamatola B.O','484334',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127390,452,'Lamsarai B.O','484881',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127391,452,'Lapta B.O','484113',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127392,452,'Latar B.O','484444',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127393,452,'Malga B.O','484446',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127394,452,'Malya B.O','484224',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127395,452,'Mediaras B.O','484224',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127396,452,'Nawangaon B.O','484770',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127397,452,'Nigwani B.O','484334',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127398,452,'Nowrrozabad  R. S. B.O','484555',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127399,452,'Parsel B.O','484555',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127400,452,'Pasan B.O','484336',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127401,452,'Pasla B.O','484224',1,0,'2022-03-04 19:26:02','2022-03-04 19:26:02'),(127402,452,'Patnakalan B.O','484001',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127403,452,'Payari B.O','484334',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127404,452,'Piparia B.O','484224',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127405,452,'Pondi B.O','484113',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127406,452,'Rampur B.O','484224',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127407,452,'Reusa B.O','484334',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127408,452,'Rupaula B.O','484334',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127409,452,'Semra B.O','484446',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127410,452,'Seorichandas B.O','484881',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127411,452,'Sonmauhari B.O','484224',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127412,452,'Tengha B.O','484334',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127413,452,'Thangaon B.O','484440',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127414,452,'Thodaha B.O','484334',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127415,452,'Tulra B.O','484881',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127416,452,'Ufrikala B.O','484881',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127417,452,'Umania B.O','484886',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127418,452,'Urtan B.O','484334',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127419,452,'Venkatnagar S.O','484113',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127420,453,'Achalgarh B.O','473444',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127421,453,'Amrod B.O','473332',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127422,453,'Ashoknagar Collectorate S.O','473331',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127423,453,'Athaikheda B.O','473331',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127424,453,'Babrod B.O','473443',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127425,453,'Badera B.O','473446',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127426,453,'Bagulya B.O','473330',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127427,453,'Bahadurpur B.O','473443',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127428,453,'Bamnawar B.O','473335',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127429,453,'Barodia B.O','473331',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127430,453,'Berkhedi Tumen B.O','473331',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127431,453,'Bhesarwas B.O','473331',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127432,453,'Bilakhedi B.O','473331',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127433,453,'Bilheru B.O','473443',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127434,453,'Chanderi S.O','473446',1,0,'2022-03-04 19:26:03','2022-03-04 19:26:03'),(127435,453,'Chhapar B.O','473332',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127436,453,'Chhapra B.O','473335',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127437,453,'Damdama B.O','473443',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127438,453,'Dangora Foot B.O','473331',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127439,453,'Depalkhedi B.O','473332',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127440,453,'Derkha B.O','473335',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127441,453,'Dhakoni B.O','473335',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127442,453,'Dhekan B.O','473331',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127443,453,'Dhurra B.O','473335',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127444,453,'Dongra B.O','473444',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127445,453,'Dungasara B.O','473332',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127446,453,'Dungasara B.O','473446',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127447,453,'Endore B.O','473335',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127448,453,'Esagarh S.O','473335',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127449,453,'Gahora B.O','473335',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127450,453,'Garenthi B.O','473440',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127451,453,'Garroli B.O','473331',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127452,453,'Hansari B.O','473446',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127453,453,'Hyder B.O','473331',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127454,453,'Jalalpur B.O','473330',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127455,453,'Jaleshwar B.O','473332',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127456,453,'Janghar B.O','473335',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127457,453,'Jheela B.O','473330',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127458,453,'Kachnar B.O','473331',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127459,453,'Kadwaya B.O','473335',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127460,453,'Kariyya Rai B.O','473331',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127461,453,'Keshopur B.O','473440',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127462,453,'Khiriyadewat B.O','473335',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127463,453,'Khirkatanka B.O','473446',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127464,453,'Kirola B.O','473443',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127465,453,'Kjajuriya Kala B.O','473331',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127466,453,'Kukretha B.O','473331',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127467,453,'Madaukhedi B.O','473443',1,0,'2022-03-04 19:26:04','2022-03-04 19:26:04'),(127468,453,'Mahidpur B.O','473335',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127469,453,'Maholi B.O','473446',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127470,453,'Mahuan B.O','473335',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127471,453,'Malhargarh B.O','473443',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127472,453,'Mathner B.O','473330',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127473,453,'Mohanpur B.O','473446',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127474,453,'Mudra Bhadra B.O','473331',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127475,453,'Mungaoli S.O','473443',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127476,453,'Naisarai S.O','473332',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127477,453,'Naoli B.O','473446',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127478,453,'Narayanpur B.O','473331',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127479,453,'Nayakheda B.O','473446',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127480,453,'Onder B.O','473443',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127481,453,'Parkana B.O','473444',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127482,453,'Parsol B.O','473335',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127483,453,'Pathari B.O','473444',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127484,453,'Patkheda B.O','473331',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127485,453,'Pilighata B.O','473330',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127486,453,'Piprai S.O','473440',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127487,453,'Pipresra B.O','473335',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127488,453,'Pipri B.O','473330',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127489,453,'Pranpura B.O','473446',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127490,453,'Raje Bamora B.O','473330',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127491,453,'Rajpur B.O','473331',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127492,453,'Rajtala B.O','473335',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127493,453,'Raosar B.O','473331',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127494,453,'Ratikheda B.O','473331',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127495,453,'Renjha B.O','473330',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127496,453,'Rijoda B.O','473331',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127497,453,'Saraskhedi B.O','473335',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127498,453,'Sehrai S.O','473444',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127499,453,'Seji B.O','473330',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127500,453,'Semrahat B.O','473331',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127501,453,'Shadora S.O','473330',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127502,453,'Shri Anandpur B.O','473331',1,0,'2022-03-04 19:26:05','2022-03-04 19:26:05'),(127503,453,'Sigon B.O','473440',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127504,453,'Singhada B.O','473440',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127505,453,'Subash Ganj Ashoknagar S.O','473331',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127506,453,'Tamasha B.O','473440',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127507,453,'Tarai B.O','473446',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127508,453,'Taraoli B.O','473331',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127509,453,'Thubon B.O','473446',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127510,453,'Tumen B.O','473331',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127511,453,'Vikrampur B.O','473446',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127512,454,'Agasi B.O','481445',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127513,454,'Agri B.O','481332',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127514,454,'Alna B.O','481117',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127515,454,'Amai B.O','481335',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127516,454,'Ameda B.O','481222',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127517,454,'Ameda B.O','481102',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127518,454,'Amgaon B.O','481111',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127519,454,'Arambha B.O','481335',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127520,454,'Atri B.O','481337',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127521,454,'Badgaon B.O','481331',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127522,454,'Badgaon B.O','481222',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127523,454,'Badhar B.O','481665',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127524,454,'Bagholi B.O','481556',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127525,454,'Bagholi B.O','481441',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127526,454,'Bahela B.O','481224',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127527,454,'Baihar S.O','481111',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127528,454,'Bakal B.O','481051',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127529,454,'Bakera B.O','481335',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127530,454,'Bakoda B.O','481441',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127531,454,'Balaghat City S.O','481001',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127532,454,'Balaghat H.O','481001',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127533,454,'Balaghat R.S. S.O','481001',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127534,454,'Bamhani B.O','481449',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127535,454,'Banera B.O','481445',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127536,454,'Beni B.O','481226',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127537,454,'Bhandarbodi B.O','481337',1,0,'2022-03-04 19:26:06','2022-03-04 19:26:06'),(127538,454,'Bhanderi B.O','481105',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127539,454,'Bhanegaon B.O','481115',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127540,454,'Bharveli S.O','481102',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127541,454,'Bhaurgarh B.O','481337',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127542,454,'Bhendara B.O','481335',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127543,454,'Bhidi B.O','481556',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127544,454,'Bhikewada B.O','481556',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127545,454,'Bijatola B.O','481051',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127546,454,'Birsa S.O','481051',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127547,454,'Birsola B.O','481331',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127548,454,'Birwa B.O','481111',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127549,454,'Bisoni B.O','481222',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127550,454,'Boda B.O','481111',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127551,454,'Boda B.O','481102',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127552,454,'Bolegaon B.O','481222',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127553,454,'Borgaon B.O','481115',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127554,454,'Bori B.O','481441',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127555,454,'Budbuda S.O','481332',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127556,454,'Budhi B.O','481226',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127557,454,'Chalisbodi B.O','481102',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127558,454,'Chandana B.O','481556',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127559,454,'Charega R.S. B.O','481551',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127560,454,'Chikhla B.O','481226',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127561,454,'Chikhla Bandh B.O','481335',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127562,454,'Chillod B.O','481331',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127563,454,'Dadiya B.O','481441',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127564,454,'Dahedi B.O','481115',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127565,454,'Damoh B.O','481051',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127566,454,'Deeni B.O','481331',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127567,454,'Deori B.O','481001',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127568,454,'Deori B.O','481449',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127569,454,'Devalgaon B.O','481224',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127570,454,'Dhansua B.O','481102',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127571,454,'Digdha B.O','481449',1,0,'2022-03-04 19:26:07','2022-03-04 19:26:07'),(127572,454,'Dongiriya B.O','481556',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127573,454,'Dora B.O','481105',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127574,454,'Fulchur B.O','481337',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127575,454,'Garhi S.O (Balaghat)','481117',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127576,454,'Garra B.O','481001',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127577,454,'Garra B.O','481331',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127578,454,'Garra Tola B.O','481051',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127579,454,'Ghansa B.O','481224',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127580,454,'Ghoti B.O','481441',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127581,454,'Ghoti B.O','481335',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127582,454,'Ghunadi B.O','481551',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127583,454,'Gongalai B.O','481001',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127584,454,'Goreghat B.O','481449',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127585,454,'Gudma B.O','481105',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127586,454,'Gudma B.O','481116',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127587,454,'Gudru R.S. B.O','481551',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127588,454,'Hardoli B.O','481449',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127589,454,'Hatta Road B.O','481226',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127590,454,'Hatta S.O (Balaghat)','481226',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127591,454,'Hirri B.O','481115',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127592,454,'Jaitpuri B.O','481117',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127593,454,'Jam B.O','481441',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127594,454,'Jam B.O','481445',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127595,454,'Janpur B.O','481116',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127596,454,'Jarah Mohgaon B.O','481332',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127597,454,'Jatta B.O','481105',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127598,454,'Jhaliwada B.O','481331',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127599,454,'Kachekhani B.O','481337',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127600,454,'Kachnari B.O','481051',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127601,454,'Kalegaon B.O','481111',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127602,454,'Kalimati B.O','481222',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127603,454,'Kandrikala B.O','481115',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127604,454,'Kanjai B.O','481441',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127605,454,'Kanki B.O','481001',1,0,'2022-03-04 19:26:08','2022-03-04 19:26:08'),(127606,454,'Karamsara B.O','481116',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127607,454,'Karanja S.O (Balaghat)','481224',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127608,454,'Kareli B.O','481111',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127609,454,'Karhu B.O','481116',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127610,454,'Kariadand B.O','481226',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127611,454,'Kaspur B.O','481331',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127612,454,'Katangi S.O (Balaghat)','481445',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127613,454,'Katanjhari B.O','481332',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127614,454,'Katedara B.O','481445',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127615,454,'Katera B.O','481445',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127616,454,'Katori B.O','481337',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127617,454,'Kaydi B.O','481331',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127618,454,'Keshalewada B.O','481226',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127619,454,'Khadkhadi B.O','481335',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127620,454,'Khairi B.O','481337',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127621,454,'Khairlanji S.O','481337',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127622,454,'Khamaria B.O','481445',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127623,454,'Khamariya Bazar B.O','481331',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127624,454,'Khara B.O','481226',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127625,454,'Khari B.O','481441',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127626,454,'Kharpadia B.O','481556',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127627,454,'Khurmundi B.O','481111',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127628,454,'Kinhi B.O','481115',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127629,454,'Kinia B.O','481051',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127630,454,'Kiniya Kandai B.O','481105',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127631,454,'Kirnapur S.O','481115',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127632,454,'Kochewada B.O','481551',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127633,454,'Kochewahi B.O','481332',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127634,454,'Koste B.O','481331',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127635,454,'Kothurna B.O','481335',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127636,454,'Koylari B.O','481449',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127637,454,'Kukarra B.O','481117',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127638,454,'Kulpa B.O','481224',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127639,454,'Kumhali B.O','481337',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127640,454,'Kumhari B.O','481001',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127641,454,'Kumharikala B.O','481224',1,0,'2022-03-04 19:26:09','2022-03-04 19:26:09'),(127642,454,'Kurenda B.O','481556',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127643,454,'Ladsa B.O','481224',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127644,454,'Ladsada B.O','481331',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127645,454,'Lalbarra S.O','481441',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127646,454,'Lalpur B.O','481335',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127647,454,'Lamta S.O','481551',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127648,454,'Lanji S.O','481222',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127649,454,'Laweri B.O','481115',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127650,454,'Lawni B.O','481335',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127651,454,'Linga B.O','481556',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127652,454,'Linga B.O','481001',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127653,454,'Lingapounar B.O','481449',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127654,454,'Lood B.O','481105',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127655,454,'Magardarra B.O','481001',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127656,454,'Mahkepar B.O','481449',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127657,454,'Majhgaon B.O','481111',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127658,454,'Malanjkhand S.O','481116',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127659,454,'Mandai B.O','481051',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127660,454,'Manegaon B.O','481051',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127661,454,'Manegaon B.O','481445',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127662,454,'Maneri B.O','481222',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127663,454,'Mangejhari B.O','481331',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127664,454,'Mate B.O','481226',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127665,454,'Mauda B.O','481226',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127666,454,'Mehndiwada B.O','481331',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127667,454,'Mendki B.O','481331',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127668,454,'Miragpur B.O','481449',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127669,454,'Miriya B.O','481224',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127670,454,'Mohgaon (B) B.O','481116',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127671,454,'Mohgaon Batua B.O','481551',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127672,454,'Mohgaon Dhapera B.O','481001',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127673,454,'Mohgaon-khurd B.O','481226',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127674,454,'Mohjhari B.O','481115',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127675,454,'Moriya B.O','481551',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127676,454,'Mowad B.O','481337',1,0,'2022-03-04 19:26:10','2022-03-04 19:26:10'),(127677,454,'Mukki B.O','481111',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127678,454,'Nagarwada R.S. B.O','481551',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127679,454,'Nagpura B.O','481441',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127680,454,'Nakshi B.O','481115',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127681,454,'Nandi B.O','481449',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127682,454,'Nandora B.O','481222',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127683,454,'Navegaon-3 B.O','481335',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127684,454,'Neelji B.O','481331',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127685,454,'Newargaon B.O','481331',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127686,454,'Newargaon B.O','481441',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127687,454,'Newargaon Kala B.O','481226',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127688,454,'Newarwahi B.O','481222',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127689,454,'Nikkum B.O','481116',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127690,454,'Padriganj R.S B.O','481551',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127691,454,'Pala B.O','481115',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127692,454,'Pandutala B.O','481117',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127693,454,'Paraswada S.O','481556',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127694,454,'Paraswaraghat B.O','481449',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127695,454,'Pathargaon B.O','481222',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127696,454,'Phoolsagar B.O','481661',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127697,454,'Piparia B.O','481111',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127698,454,'Piparia Bhandi B.O','481331',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127699,454,'Pondi B.O','481105',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127700,454,'Pondi B.O','481117',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127701,454,'Pouniya B.O','481449',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127702,454,'Pulputta B.O','481449',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127703,454,'Rajegaon B.O','481115',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127704,454,'Ramgarhi B.O','481115',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127705,454,'Rampaily S.O','481335',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127706,454,'Ramrama B.O','481332',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127707,454,'Rankakodi B.O','481115',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127708,454,'Relwahi B.O','481051',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127709,454,'Risewara B.O','481222',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127710,454,'Roopjhar B.O','481105',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127711,454,'Roshna B.O','481001',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127712,454,'Sadra B.O','481224',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127713,454,'Salebardi B.O','481335',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127714,454,'Saleteka B.O','481226',1,0,'2022-03-04 19:26:11','2022-03-04 19:26:11'),(127715,454,'Saleteka B.O','481337',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127716,454,'Saletekari B.O','481051',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127717,454,'Samnapur B.O','481001',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127718,454,'Saori B.O','481337',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127719,454,'Sarekha B.O','481111',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127720,454,'Sarekha-kosmi S.O','481001',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127721,454,'Sawan R.S. B.O','481332',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127722,454,'Sawari B.O','481222',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127723,454,'Selwa B.O','481445',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127724,454,'Sewati B.O','481115',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127725,454,'Shankar Pipariya B.O','481337',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127726,454,'Sihora B.O','481441',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127727,454,'Sijhora B.O','481117',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127728,454,'Sirpur B.O','481332',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127729,454,'Sonarkakodi B.O','481222',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127730,454,'Sonpur B.O','481105',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127731,454,'Sukli B.O','481449',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127732,454,'Tekadi B.O','481449',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127733,454,'Temni B.O','481115',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127734,454,'Thanegaon B.O','481331',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127735,454,'Thema B.O','481556',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127736,454,'Tingipur B.O','481051',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127737,454,'Tirodi S.O','481449',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127738,454,'Tumsar B.O','481445',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127739,454,'Ukwa S.O','481105',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127740,454,'Waraseoni Civil Line S.O','481331',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127741,454,'Waraseoni S.O','481331',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127742,455,'Achli B.O','451666',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127743,455,'Anjad S.O','451556',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127744,455,'Anjarada B.O','451551',1,0,'2022-03-04 19:26:12','2022-03-04 19:26:12'),(127745,455,'Attarsambha B.O','451551',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127746,455,'Badgaon B.O','451447',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127747,455,'Baghadi B.O','451449',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127748,455,'Bakwadi B.O','451449',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127749,455,'Balkuwan B.O','451556',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127750,455,'Balsamund B.O','451449',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127751,455,'Balwadi B.O','451666',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127752,455,'Bandhara Bujurg B.O','451770',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127753,455,'Barda B.O','451556',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127754,455,'Baruphatak B.O','451449',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127755,455,'Barwani S.O','451551',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127756,455,'Baswi B.O','451449',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127757,455,'Bawangaja B.O','451551',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127758,455,'Bawdad B.O','451666',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127759,455,'Bhakarli B.O','451666',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127760,455,'Bhatki B.O','451881',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127761,455,'Bhawati B.O','451551',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127762,455,'Bhorwada B.O','451449',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127763,455,'Bilwa Road B.O','451556',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127764,455,'Bokrata B.O','451551',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127765,455,'Borlay B.O','451551',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127766,455,'Brahamngaon B.O','451660',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127767,455,'Chachariya B.O','451666',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127768,455,'Chatli B.O','451666',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127769,455,'Chichali (D) B.O','451660',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127770,455,'Chikliya B.O','451447',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127771,455,'Chitawal B.O','451442',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127772,455,'Danod B.O','451447',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127773,455,'Dawana B.O','451660',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127774,455,'Deola B.O','451660',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127775,455,'Dhanora B.O','451666',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127776,455,'Dhawali B.O','451666',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127777,455,'Diwaniya B.O','451666',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127778,455,'Dondwada B.O','451770',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127779,455,'Dugani B.O','451666',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127780,455,'Fatyapur B.O','451556',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127781,455,'Gandhawal B.O','451551',1,0,'2022-03-04 19:26:13','2022-03-04 19:26:13'),(127782,455,'Ghatwa B.O','451660',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127783,455,'Ghusgaon B.O','451449',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127784,455,'Goi B.O','451666',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127785,455,'Haribad B.O','451447',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127786,455,'Indrapur B.O','451449',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127787,455,'Jahur B.O','451881',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127788,455,'Jalgone B.O','451770',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127789,455,'Jamathi B.O','451666',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127790,455,'Jhopali B.O','451666',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127791,455,'Jogwada B.O','451666',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127792,455,'Julwania S.O','451449',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127793,455,'Junapani B.O','451770',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127794,455,'Kansul B.O','451770',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127795,455,'Kasrawad (S) B.O','451551',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127796,455,'Khajuri B.O','451449',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127797,455,'Khetia S.O','451881',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127798,455,'Khurrampura B.O','451660',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127799,455,'Koradiya B.O','451556',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127800,455,'Kunjari B.O','451666',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127801,455,'Kuwan B.O','451660',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127802,455,'Lakhangaon B.O','451660',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127803,455,'Limbi B.O','451551',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127804,455,'Lonsara Khurd B.O','451556',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127805,455,'Mahitgaon B.O','451666',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127806,455,'Malfa B.O','451881',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127807,455,'Malwan B.O','451666',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127808,455,'Mandwada B.O','451556',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127809,455,'Matali B.O','451447',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127810,455,'Mehgaon Deb B.O','451660',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127811,455,'Menimata B.O','451447',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127812,455,'Mohipura B.O','451556',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127813,455,'Moida B.O','451770',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127814,455,'Mortalai B.O','451881',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127815,455,'Nagalwadi B.O','451449',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127816,455,'Nawalpura B.O','451666',1,0,'2022-03-04 19:26:14','2022-03-04 19:26:14'),(127817,455,'Nisarpur B.O','451881',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127818,455,'Niwali B.O','451770',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127819,455,'Ojhar B.O','451449',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127820,455,'Palsud B.O','451447',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127821,455,'Panchpula(N) B.O','451551',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127822,455,'Pansemal S.O','451770',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127823,455,'Pati B.O','451551',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127824,455,'Pipari Bujurg B.O','451447',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127825,455,'Piplaj B.O','451551',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127826,455,'Rajpur Barwani S.O','451447',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127827,455,'Rakhibujurg B.O','451881',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127828,455,'Rangaon Deb B.O','451447',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127829,455,'Rangaon Road B.O','451449',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127830,455,'Revaja B.O','451447',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127831,455,'Rui B.O','451449',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127832,455,'Sajwani B.O','451551',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127833,455,'Sali B.O','451556',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127834,455,'Salikalan B.O','451449',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127835,455,'Sangaon B.O','451447',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127836,455,'Segwal B.O','451660',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127837,455,'Semali B.O','451551',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127838,455,'Sendhwa S.O','451666',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127839,455,'Shahpura B.O','451666',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127840,455,'Silawad B.O','451551',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127841,455,'Solwan B.O','451666',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127842,455,'Sondul B.O','451551',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127843,455,'Surana B.O','451556',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127844,455,'Sustikheda B.O','451447',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127845,455,'Talun Khurd B.O','451551',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127846,455,'Talwada Bujurg B.O','451556',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127847,455,'Talwada Deb B.O','451556',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127848,455,'Temala B.O','451881',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127849,455,'Thikari S.O','451660',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127850,455,'Uchawad B.O','451556',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127851,455,'Upla B.O','451447',1,0,'2022-03-04 19:26:15','2022-03-04 19:26:15'),(127852,455,'Wajhar B.O','451447',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127853,455,'Warla B.O','451666',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127854,456,'Amal B.O','460225',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127855,456,'Ambada B.O','460553',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127856,456,'Amdhana B.O','460449',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127857,456,'Amla Depot S.O','460553',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127858,456,'Amla S.O','460551',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127859,456,'Amraoti Ghat B.O','460665',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127860,456,'Andharia B.O','460551',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127861,456,'Anwaria B.O','460551',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127862,456,'Ashta B.O','460666',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127863,456,'Athanair S.O','460110',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127864,456,'Awaria B.O','460330',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127865,456,'Badalpur B.O','460440',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127866,456,'Badgaon B.O','460554',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127867,456,'Badgaon B.O','460220',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127868,456,'Badora B.O','460001',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127869,456,'Bagholi B.O','460004',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127870,456,'Bakud B.O','460220',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127871,456,'Bandli B.O','460665',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127872,456,'Bansnerkala B.O','460225',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127873,456,'Barai B.O','460661',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127874,456,'Barangwari B.O','460554',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127875,456,'Baravi B.O','460004',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127876,456,'Barhapur B.O','460220',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127877,456,'Barkhed B.O','460663',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127878,456,'Batkidoh B.O','460440',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127879,456,'Belkund B.O','460220',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127880,456,'Betul Bazaar S.O','460004',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127881,456,'Betul Ganj S.O','460001',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127882,456,'Betul H.O','460001',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127883,456,'Bhadus B.O','460001',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127884,456,'Bhagoda B.O','460666',1,0,'2022-03-04 19:26:16','2022-03-04 19:26:16'),(127885,456,'Bhainsdehi S.O','460220',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127886,456,'Bhaiyawari B.O','460440',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127887,456,'Bharat Bharti B.O','460001',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127888,456,'Bharkawarai B.O','460004',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127889,456,'Bhimpur B.O','460330',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127890,456,'Bhogiteda B.O','460001',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127891,456,'Bhoura B.O','460440',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127892,456,'Bihargaon B.O','460666',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127893,456,'Bijadehi B.O','460330',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127894,456,'Birul Bazar B.O','460666',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127895,456,'Bisnoor B.O','460668',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127896,456,'Bordehi S.O','460554',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127897,456,'Borgaon B.O','460001',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127898,456,'Borgaon B.O','460225',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127899,456,'Bothi B.O','460220',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127900,456,'Chadu B.O','460220',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127901,456,'Chandbaheda B.O','460001',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127902,456,'Chandora Khurad B.O','460661',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127903,456,'Chhindi B.O','460663',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127904,456,'Chhindkheda B.O','460666',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127905,456,'Chhipanya Pipariya B.O','460554',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127906,456,'Chichanda B.O','460661',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127907,456,'Chicholi S.O','460330',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127908,456,'Chikhali B.O','460001',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127909,456,'Chikhali B.O','460330',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127910,456,'Chikhalikalan B.O','460663',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127911,456,'Chikhalpati B.O','460440',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127912,456,'Chilhati B.O','460661',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127913,456,'Chirapatla B.O','460330',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127914,456,'Chopna B.O','460440',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127915,456,'Chouthia B.O','460661',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127916,456,'Chudia B.O','460330',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127917,456,'Chunahajuri B.O','460330',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127918,456,'Chunalohna B.O','460225',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127919,456,'Dahua B.O','460663',1,0,'2022-03-04 19:26:17','2022-03-04 19:26:17'),(127920,456,'Dehgud B.O','460110',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127921,456,'Desawari B.O','460440',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127922,456,'Dhabla B.O','460666',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127923,456,'Dhamangaon B.O','460220',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127924,456,'Dhanora Adarsh B.O','460330',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127925,456,'Dhanora B.O','460110',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127926,456,'Dhapoda B.O','460440',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127927,456,'Dharakhoh B.O','460443',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127928,456,'Dhatora B.O','460666',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127929,456,'Dudhiya B.O','460330',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127930,456,'Dunawa S.O','460663',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127931,456,'Etawa B.O','460668',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127932,456,'Gargud B.O','460110',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127933,456,'Garha B.O','460001',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127934,456,'Gehubarsa B.O','460668',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127935,456,'Ghatbiroli B.O','460663',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127936,456,'Ghatpipariya B.O','460663',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127937,456,'Ghisibagla B.O','460330',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127938,456,'Ghoradongari S.O','460443',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127939,456,'Godhna B.O','460330',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127940,456,'Gondigoula B.O','460004',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127941,456,'Goula B.O','460557',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127942,456,'Gubrel B.O','460663',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127943,456,'Gudgaon B.O','460220',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127944,456,'Hathanapur B.O','460661',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127945,456,'Hidli B.O','460110',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127946,456,'Hirapur B.O','460440',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127947,456,'Hirdi B.O','460666',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127948,456,'Hiwarkhed B.O','460668',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127949,456,'Jam B.O','460663',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127950,456,'Jambada B.O','460551',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127951,456,'Jamthi B.O','460110',1,0,'2022-03-04 19:26:18','2022-03-04 19:26:18'),(127952,456,'Jawara B.O','460004',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127953,456,'Jawara B.O','460110',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127954,456,'Jeen B.O','460001',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127955,456,'Jhallar B.O','460225',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127956,456,'Jhapal B.O','460330',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127957,456,'Jogli B.O','460001',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127958,456,'Joulkheda B.O','460661',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127959,456,'Kachhar B.O','460440',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127960,456,'Kalmeshwara B.O','460554',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127961,456,'Kanojia B.O','460551',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127962,456,'Karpa B.O','460661',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127963,456,'Kathi B.O','460663',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127964,456,'Kesia B.O','460330',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127965,456,'Khairwani B.O','460663',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127966,456,'Khamla B.O','460220',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127967,456,'Khandara B.O','460001',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127968,456,'Khapakhateda B.O','460551',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127969,456,'Khedicourt B.O','460557',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127970,456,'Khedisaoligarh S.O','460225',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127971,456,'Khedlibazar B.O','460661',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127972,456,'Khomai B.O','460220',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127973,456,'Kolgaon B.O','460001',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127974,456,'Kothalkund B.O','460220',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127975,456,'Kothi Bazaar S.O','460001',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127976,456,'Kujba B.O','460661',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127977,456,'Kundi B.O','460440',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127978,456,'Kunkhedi B.O','460220',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127979,456,'Kurasna B.O','460330',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127980,456,'Kutkhedai B.O','460551',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127981,456,'Lakhapur B.O','460553',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127982,456,'Lalawadi B.O','460551',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127983,456,'Lilajhir B.O','460663',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127984,456,'Magnonakhurd B.O','460665',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127985,456,'Magonakalan B.O','460665',1,0,'2022-03-04 19:26:19','2022-03-04 19:26:19'),(127986,456,'Mahatpur B.O','460661',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(127987,456,'Majarwani B.O','460220',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(127988,456,'Malajpur B.O','460330',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(127989,456,'Mandai Bujurg B.O','460001',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(127990,456,'Mandvi B.O','460110',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(127991,456,'Masod S.O','460668',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(127992,456,'Mathani B.O','460001',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(127993,456,'Mathani B.O','460661',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(127994,456,'Mendha Chhindwad B.O','460110',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(127995,456,'Mohda B.O','460330',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(127996,456,'Mohi B.O','460661',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(127997,456,'Morandhana B.O','460553',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(127998,456,'Morkha B.O','460661',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(127999,456,'Multai Bazaar S.O','460661',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(128000,456,'Multai S.O','460661',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(128001,456,'Nahiya B.O','460553',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(128002,456,'Narkhed B.O','460661',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(128003,456,'Nimpani Padhar B.O','460001',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(128004,456,'Pahawari B.O','460440',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(128005,456,'Palasya B.O','460220',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(128006,456,'Paradsinga B.O','460661',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(128007,456,'Parasia S.O','480441',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(128008,456,'Parmandal B.O','460661',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(128009,456,'Parsodi B.O','460551',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(128010,456,'Path B.O','460330',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(128011,456,'Pathai B.O','460440',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(128012,456,'Pathakheda B.O','460330',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(128013,456,'Pathakheda S.O','460449',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(128014,456,'Patri B.O','460330',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(128015,456,'Pipariyagurwa B.O','460330',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(128016,456,'Pohar B.O','460557',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(128017,456,'Pouni B.O','460557',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(128018,456,'Prabhat Pattan S.O','460665',1,0,'2022-03-04 19:26:20','2022-03-04 19:26:20'),(128019,456,'Pusli B.O','460110',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128020,456,'Ragadgaon B.O','460668',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128021,456,'Rai Amla S.O','460666',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128022,456,'Ramli B.O','460551',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128023,456,'Ranipur B.O','460443',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128024,456,'Ratanpur B.O','460330',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128025,456,'Ratedkalan B.O','460551',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128026,456,'Ridhora B.O','480441',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128027,456,'Rondha B.O','460001',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128028,456,'Sainkheda S.O (Betul)','460557',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128029,456,'Sakadehi B.O','460001',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128030,456,'Sakli B.O','460220',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128031,456,'Salaiya B.O','460449',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128032,456,'Salimet B.O','460440',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128033,456,'Sandia B.O','460661',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128034,456,'Saongi B.O','460668',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128035,456,'Saongi B.O','460110',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128036,456,'Sarai B.O','460663',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128037,456,'Sarni S.O','460447',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128038,456,'Sarra B.O','460661',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128039,456,'Sasundra B.O','460557',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128040,456,'Satner B.O','460110',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128041,456,'Sawalmendha B.O','460220',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128042,456,'Sehangaon B.O','460668',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128043,456,'Sehra B.O','460001',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128044,456,'Selgaon B.O','460225',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128045,456,'Semjhira B.O','460557',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128046,456,'Seoni B.O','460220',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128047,456,'Shabhapur Colloery B.O','460449',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128048,456,'Shahpur S.O (Betul)','460440',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128049,456,'Shaktigarh B.O','460449',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128050,456,'Shirdi B.O','460668',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128051,456,'Sillot B.O','460001',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128052,456,'Silpati B.O','460440',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128053,456,'Sipawa B.O','460663',1,0,'2022-03-04 19:26:21','2022-03-04 19:26:21'),(128054,456,'Sitakamath B.O','460443',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128055,456,'Sohagpur B.O','460004',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128056,456,'Sonegaon B.O','460661',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128057,456,'Sonora B.O','460661',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128058,456,'Taikheda B.O','460666',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128059,456,'Tembhurni B.O','460110',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128060,456,'Temni B.O','460001',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128061,456,'Temni B.O','460220',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128062,456,'Temru B.O','460440',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128063,456,'Thopoda B.O','460220',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128064,456,'Tiwarkhed B.O','460665',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128065,456,'Toranwara B.O','460551',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128066,456,'Umari B.O','460665',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128067,456,'Umaria B.O','460551',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128068,456,'Vijaygaram B.O','460225',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128069,456,'Vikasnagar Betul S.O','460001',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128070,456,'Wadali B.O','460110',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128071,456,'Yenkheda B.O','460557',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128072,456,'Yenus B.O','460661',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128073,456,'Dabri B.O','461111',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128074,456,'Damjipura B.O','461441',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128075,456,'Dhekna B.O','461228',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128076,456,'Dodhra Mardu B.O','461111',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128077,456,'Mohta B.O','461441',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128078,457,'Mehgaon B.O','475115',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128079,457,'Mehgaon B.O','475110',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128080,457,'Achalpura B.O','477441',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128081,457,'Adokhar B.O','477227',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128082,457,'Ahenti B.O','477555',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128083,457,'Ahorli Kali B.O','477111',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128084,457,'Ahoroli Ghat B.O','477111',1,0,'2022-03-04 19:26:22','2022-03-04 19:26:22'),(128085,457,'Aino B.O','477116',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128086,457,'Ajnar B.O','477445',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128087,457,'Ajnodha B.O','477557',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128088,457,'Akaha B.O','477331',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128089,457,'Akhdewa B.O','477446',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128090,457,'Akloni B.O','477660',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128091,457,'Akoda S.O','477332',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128092,457,'Akon B.O','477111',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128093,457,'Alampur S.O (Bhind)','477449',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128094,457,'Amaha B.O','477447',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128095,457,'Amayan S.O','477227',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128096,457,'Andhiyari B.O','477447',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128097,457,'Anto B.O','477227',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128098,457,'Aroli B.O','477660',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128099,457,'Arusi B.O','477449',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128100,457,'Asnet B.O','477441',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128101,457,'Aswar S.O','477446',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128102,457,'Atarsuma B.O','477333',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128103,457,'Attair Road Bhind S.O','477001',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128104,457,'Attair S.O','477111',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128105,457,'Babedi B.O','477105',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128106,457,'Badepura B.O','477566',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128107,457,'Badokhari B.O','477445',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128108,457,'Baghora B.O','477557',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128109,457,'Bagulari B.O','477105',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128110,457,'Bahadurpura B.O','477335',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128111,457,'Bahera B.O','477660',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128112,457,'Bahonapura B.O','477117',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128113,457,'Bahtpura B.O','477445',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128114,457,'Bajhai B.O','477331',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128115,457,'Balapura B.O','477111',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128116,457,'Bantharti B.O','477441',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128117,457,'Bara Kalan B.O','477332',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128118,457,'Barahet B.O','477441',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128119,457,'Baran Khurd B.O','477332',1,0,'2022-03-04 19:26:23','2022-03-04 19:26:23'),(128120,457,'Baranso B.O','477557',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128121,457,'Baraua B.O','477447',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128122,457,'Barehad B.O','477557',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128123,457,'Barehad B.O','477117',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128124,457,'Barha B.O','477445',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128125,457,'Barhi S.O (Bhind)','477566',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128126,457,'Baroli B.O','477222',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128127,457,'Barona B.O','477117',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128128,457,'Barthara B.O','477447',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128129,457,'Bhad Khur B.O','477555',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128130,457,'Bhagwasa B.O','477116',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128131,457,'Bhagwasi B.O','477555',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128132,457,'Bharoli B.O','477332',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128133,457,'Bhawanpura B.O','477566',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128134,457,'Bhind H.O','477001',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128135,457,'Bhind Kutchary S.O','477001',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128136,457,'Bhind Mandi S.O','477001',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128137,457,'Bijora B.O','477555',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128138,457,'Bijpur B.O','477447',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128139,457,'Bilao B.O','477331',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128140,457,'Bindwa B.O','477111',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128141,457,'Birgawan B.O','477557',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128142,457,'Birkhadi Chochai B.O','477335',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128143,457,'Birkhadi Dang B.O','477116',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128144,457,'Biswari B.O','477441',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128145,457,'Bohara B.O','477441',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128146,457,'Bonapura B.O','477441',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128147,457,'Buderabhuta B.O','477222',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128148,457,'Chachar B.O','477555',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128149,457,'Chandokh B.O','477441',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128150,457,'Chandokhar B.O','477116',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128151,457,'Chandupura B.O','477001',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128152,457,'Charetha B.O','477116',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128153,457,'Chatthar B.O','477105',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128154,457,'Chhenkauri B.O','477222',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128155,457,'Chhiwaoli B.O','477447',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128156,457,'Chiruli B.O','477446',1,0,'2022-03-04 19:26:24','2022-03-04 19:26:24'),(128157,457,'Chitora B.O','477116',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128158,457,'Chomho B.O','477111',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128159,457,'Daboh S.O','477447',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128160,457,'Daboha B.O','477001',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128161,457,'Dehgoun B.O','477222',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128162,457,'Devari B.O','477447',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128163,457,'Dharai B.O','477001',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128164,457,'Dharampura B.O','477447',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128165,457,'Didi B.O','477105',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128166,457,'Donchara B.O','477331',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128167,457,'Dulhangan B.O','477555',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128168,457,'Endori B.O','477116',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128169,457,'Ethar B.O','477001',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128170,457,'Gaheli B.O','477227',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128171,457,'Gangepura B.O','477449',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128172,457,'Garhpara B.O','477001',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128173,457,'Ghamori B.O','477222',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128174,457,'Gijurra B.O','477557',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128175,457,'Gingarkhi B.O','477557',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128176,457,'Girongi B.O','477117',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128177,457,'Girwasa B.O','477446',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128178,457,'Goar Khurd B.O','477660',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128179,457,'Goara B.O','477001',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128180,457,'Gohad Choraha B.O','477116',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128181,457,'Gohad S.O','477116',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128182,457,'Gona Kardaspur B.O','477557',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128183,457,'Gopalpura B.O','477001',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128184,457,'Gorai B.O','477335',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128185,457,'Gormi S.O','477660',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128186,457,'Guhsar B.O','477222',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128187,457,'Gurikha B.O','477117',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128188,457,'Gutor B.O','477557',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128189,457,'Gyanpura B.O','477566',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128190,457,'Harikhsa B.O','477660',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128191,457,'Heerapura B.O','477445',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128192,457,'Housing Colony Bhind S.O','477001',1,0,'2022-03-04 19:26:25','2022-03-04 19:26:25'),(128193,457,'Indurkhi B.O','477335',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128194,457,'Ingosa Raipur B.O','477660',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128195,457,'Jaipura Madhi B.O','477335',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128196,457,'Jaitpura Gudha B.O','477441',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128197,457,'Jakhmoli B.O','477333',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128198,457,'Jalalpura B.O','477446',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128199,457,'Jamdara B.O','477222',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128200,457,'Jamna B.O','477001',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128201,457,'Jampura B.O','477105',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128202,457,'Jamsara B.O','477111',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128203,457,'Jamuha B.O','477445',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128204,457,'Janora B.O','477555',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128205,457,'Jari B.O','477105',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128206,457,'Jarsena B.O','477557',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128207,457,'Jawasa B.O','477105',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128208,457,'Jhankri B.O','477116',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128209,457,'Jori Kotwal B.O','477111',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128210,457,'Jroi Brahman B.O','477557',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128211,457,'Kachnao Kalan B.O','477660',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128212,457,'Kachogra B.O','477332',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128213,457,'Kakahara B.O','477333',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128214,457,'Kanathar B.O','477227',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128215,457,'Kanawar B.O','477331',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128216,457,'Kanchanpura B.O','477117',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128217,457,'Kanera B.O','477111',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128218,457,'Katha B.O','477441',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128219,457,'Kathana Hazi B.O','477116',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128220,457,'Kathma B.O','477557',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128221,457,'Katrol B.O','477557',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128222,457,'Khadit B.O','477111',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128223,457,'Khaneta B.O','477116',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128224,457,'Khanrika B.O','477111',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128225,457,'Kheria Sindh B.O','477227',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128226,457,'Khitoli B.O','477116',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128227,457,'Kishupura B.O','477555',1,0,'2022-03-04 19:26:26','2022-03-04 19:26:26'),(128228,457,'Kiti B.O','477222',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128229,457,'Konhar B.O','477557',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128230,457,'Kosad B.O','477555',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128231,457,'Kot B.O','477333',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128232,457,'Kripe Ka Pura B.O','477660',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128233,457,'Kurthar B.O','477449',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128234,457,'Lahar S.O','477445',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128235,457,'Lahroli B.O','477333',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128236,457,'Lalpura B.O','477445',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128237,457,'Lapwah B.O','477441',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128238,457,'Larol B.O','477441',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128239,457,'Lawan B.O','477001',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128240,457,'Machand B.O','477441',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128241,457,'Mahua B.O','477445',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128242,457,'Malanpur S.O','477117',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128243,457,'Mangarh B.O','477335',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128244,457,'Masuri B.O','477105',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128245,457,'Mau S.O','477222',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128246,457,'Mehda B.O','477335',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128247,457,'Mehdoli B.O','477660',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128248,457,'Mehdwa B.O','477335',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128249,457,'Mehgoun S.O','477557',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128250,457,'Mehra B.O','477227',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128251,457,'Mehra Bujurg B.O','477445',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128252,457,'Menhad B.O','477660',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128253,457,'Mihona S.O','477441',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128254,457,'Mihoni B.O','477447',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128255,457,'Misa B.O','477331',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128256,457,'Mitawali B.O','477445',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128257,457,'Muraoli B.O','477447',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128258,457,'Muratpura B.O','477441',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128259,457,'Nadna B.O','477335',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128260,457,'Nai Garhi B.O','477566',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128261,457,'Nai Zameen Bhind S.O','477105',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128262,457,'Nandha B.O','477335',1,0,'2022-03-04 19:26:27','2022-03-04 19:26:27'),(128263,457,'Nanhad B.O','477660',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128264,457,'Naya Goun B.O','477333',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128265,457,'Nibsai B.O','477335',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128266,457,'Nonera B.O','477117',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128267,457,'Nunheta B.O','477332',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128268,457,'Pachera B.O','477557',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128269,457,'Pachokhara B.O','477441',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128270,457,'Padhora B.O','477335',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128271,457,'Palawali B.O','477331',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128272,457,'Pali B.O','477660',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128273,457,'Pali Darman B.O','477116',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128274,457,'Pandori B.O','477331',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128275,457,'Paragoun B.O','477105',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128276,457,'Parghana B.O','477227',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128277,457,'Pariksha B.O','477447',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128278,457,'Parosa B.O','477660',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128279,457,'Pawai B.O','477660',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128280,457,'Phoop S.O','477555',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128281,457,'Pidora B.O','477001',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128282,457,'Pipadi B.O','477660',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128283,457,'Pipahadi B.O','477116',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128284,457,'Piparsana B.O','477116',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128285,457,'Pratappura B.O','477111',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128286,457,'Rahawali B.O','477445',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128287,457,'Raipur Jakholi B.O','477447',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128288,457,'Raipura B.O','477441',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128289,457,'Raipura B.O','477117',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128290,457,'Raja Ki Pali B.O','477116',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128291,457,'Rama B.O','477555',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128292,457,'Ramthiyankapura B.O','477557',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128293,457,'Rani Birgoun B.O','477555',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128294,457,'Rari B.O','477441',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128295,457,'Rarua B.O','477335',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128296,457,'Ratwa B.O','477222',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128297,457,'Raun S.O','477335',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128298,457,'Ridoli B.O','477111',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128299,457,'Rohini Jagir B.O','477445',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128300,457,'Rurai B.O','477446',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128301,457,'Sada B.O','477227',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128302,457,'Sagra S.O (Bhind)','477333',1,0,'2022-03-04 19:26:28','2022-03-04 19:26:28'),(128303,457,'Sakaraya B.O','477555',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128304,457,'Sankari B.O','477566',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128305,457,'Sanwai B.O','477333',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128306,457,'Sapad B.O','477566',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128307,457,'Sarsai B.O','477333',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128308,457,'Sarwa B.O','477117',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128309,457,'Sayaana B.O','477557',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128310,457,'Semara B.O','477227',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128311,457,'Senthari B.O','477557',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128312,457,'Sherpur B.O','477117',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128313,457,'Sihunda B.O','477332',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128314,457,'Sikroda B.O','477660',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128315,457,'Simar B.O','477557',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128316,457,'Simrao B.O','477105',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128317,457,'Sitaram Ki Lawan B.O','477116',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128318,457,'Siyawali B.O','477105',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128319,457,'Sondha B.O','477116',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128320,457,'Soni B.O','477557',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128321,457,'Suhsan B.O','477116',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128322,457,'Sukand B.O','477660',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128323,457,'Sunarpura B.O','477660',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128324,457,'Sundarpura B.O','477445',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128325,457,'Surpura B.O','477555',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128326,457,'Tarsokhar B.O','477111',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128327,457,'Tehangur B.O','477333',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128328,457,'Tola B.O','477446',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128329,457,'Tundila B.O','477117',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128330,457,'Udhotgarh B.O','477111',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128331,457,'Udhotpura B.O','477105',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128332,457,'Ujhaawl B.O','477222',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128333,457,'Umri S.O (Bhind)','477331',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128334,457,'Usha Nagar Colony Bhind S.O','477001',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128335,458,'1100 Qrts. S.O','462016',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128336,458,'3 EME Centre S.O','462031',1,0,'2022-03-04 19:26:29','2022-03-04 19:26:29'),(128337,458,'AIIMS S.O','462020',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128338,458,'Air Port S.O','462030',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128339,458,'Amarawat Kalan B.O','462042',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128340,458,'Anand Nagar S.O (Bhopal)','462022',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128341,458,'Arera Hills S.O','462027',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128342,458,'Arwaliya B.O','462038',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128343,458,'Ayodhaya Nagar S.O','462041',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128344,458,'Bag Mungalia S.O','462043',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128345,458,'Bagroda B.O','462026',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128346,458,'Bairagarh Chichali B.O','462042',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128347,458,'Bairagarh Kalan B.O','462030',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128348,458,'Bairagarh S.O','462030',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128349,458,'Balachoan B.O','463106',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128350,458,'Balampur B.O','462010',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128351,458,'Bangrasia S.O','462045',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128352,458,'Barkheda B.O','464993',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128353,458,'Barkheda Baramad B.O','462101',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128354,458,'Barkheda H.E. S.O','462022',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128355,458,'Barkheda Nathu B.O','462044',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128356,458,'Barkhedi S.O','462008',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128357,458,'Basai B.O','463106',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128358,458,'Bawachiya B.O','463111',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128359,458,'Bawadia Kalan B.O','462026',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128360,458,'Bazaria Shahajahanabad S.O','462001',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128361,458,'Berasia Bhopal S.O','463106',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128362,458,'Berasia Road S.O','462001',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128363,458,'Bhel H.O','462022',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128364,458,'Bhonri B.O','462030',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128365,458,'Bhopal G.P.O.','462001',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128366,458,'Bilakho B.O','462120',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128367,458,'Bishankhedi B.O','464993',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128368,458,'C.T.T.Nagar H.O','462003',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128369,458,'Chandbad S.O','462010',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128370,458,'Chhola Road S.O','462001',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128371,458,'Chouk S.O','462001',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128372,458,'Dhamarra B.O','462101',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128373,458,'Dhaturiya B.O','463111',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128374,458,'Dillod S.O','462101',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128375,458,'Dungariya B.O','463111',1,0,'2022-03-04 19:26:30','2022-03-04 19:26:30'),(128376,458,'E-2 Sector S.O','462016',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128377,458,'Fanda B.O','462030',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128378,458,'Gada Jangeer B.O','462120',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128379,458,'Gandhi Medical College S.O','462001',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128380,458,'Gandhi Nagar (Bhopal) S.O','462036',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128381,458,'Govindpura S.O','462023',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128382,458,'Gunga B.O','462101',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128383,458,'H.E. Hospital S.O','462024',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128384,458,'Hamidia Road S.O','462001',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128385,458,'Harra Kheda B.O','462101',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128386,458,'IISER Bhouri S.O','462066',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128387,458,'Imaliya B.O','462010',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128388,458,'Industrial Estate S.O (Bhopal)','462023',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128389,458,'Islam Nagar B.O','462038',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128390,458,'Itwara S.O','462001',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128391,458,'Jahangirabad S.O (Bhopal)','462008',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128392,458,'Jamunia Kalan B.O','462022',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128393,458,'Jamusarkalan B.O','463111',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128394,458,'Jhagaria Khurd B.O','462044',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128395,458,'Jumerati S.O','462001',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128396,458,'Kalara B.O','462101',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128397,458,'Kamla Nagar S.O (Bhopal)','462003',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128398,458,'Khajuri Kalan B.O','462022',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128399,458,'Khajuri Sadak B.O','462030',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128400,458,'Khamkheda B.O','462038',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128401,458,'Khitwas B.O','463106',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128402,458,'Khukharia B.O','462101',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128403,458,'Kokata B.O','462022',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128404,458,'Kolar Road S.O','462042',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128405,458,'Kolua Khurd B.O','462022',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128406,458,'Kolukhedi B.O','462120',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128407,458,'Kotra Chopra B.O','462101',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128408,458,'Kulhoar B.O','463111',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128409,458,'Kurana B.O','462030',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128410,458,'Kutakipura B.O','462101',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128411,458,'Kuthar B.O','462101',1,0,'2022-03-04 19:26:31','2022-03-04 19:26:31'),(128412,458,'Lalariya S.O','463111',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128413,458,'Laloi B.O','463106',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128414,458,'M.A.C.T. S.O','462007',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128415,458,'M.L. Nagar S.O','462038',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128416,458,'M.L.A.Rest House S.O','462003',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128417,458,'M.P. Vidhan Sabha S.O','462004',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128418,458,'Mahaveer Nagar S.O','462016',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128419,458,'Mandideep S.O','462046',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128420,458,'Mangal Garh B.O','462120',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128421,458,'Meghra Kalan B.O','463111',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128422,458,'Misord S.O','462047',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128423,458,'Misrod B.O','462026',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128424,458,'MP Bhoj Open University S.O','462016',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128425,458,'Mungalia Chhap B.O','462044',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128426,458,'Mungaliya Hatt B.O','462030',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128427,458,'Nabibagh B.O','462038',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128428,458,'Naya Samund B.O','462120',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128429,458,'Nayapura B.O','462030',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128430,458,'Nazirabad S.O','462120',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128431,458,'Nishatpura S.O','462010',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128432,458,'Obedullaganj S.O','464993',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128433,458,'Old Secretriate S.O','462001',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128434,458,'Parwaliya Sadak B.O','462030',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128435,458,'Peoples Campus S.O','462037',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128436,458,'Pipal Khedi B.O','463106',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128437,458,'Pipaliya Jaheerpeer B.O','462010',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128438,458,'Polaha B.O','462046',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128439,458,'R.S.Market S.O','462016',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128440,458,'R.S.Nagar S.O','462016',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128441,458,'Raipur B.O','462101',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128442,458,'Raj Bhawan S.O (Bhopal)','462003',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128443,458,'Ratibad B.O','462044',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128444,458,'Ratua Ratanpur B.O','462101',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128445,458,'Regional College S.O','462013',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128446,458,'RGPV S.O','462033',1,0,'2022-03-04 19:26:32','2022-03-04 19:26:32'),(128447,458,'Runaha B.O','462120',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128448,458,'S.I. Line S.O','462001',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128449,458,'Satalapur B.O','462046',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128450,458,'Satpura S.O','462004',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128451,458,'Sewaniya Gond B.O','462044',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128452,458,'Shahajahanabad S.O','462001',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128453,458,'Shastri Nagar S.O (Bhopal)','462003',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128454,458,'Shiksha Mandal S.O','462011',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128455,458,'Shivaji Nagar S.O (Bhopal)','462016',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128456,458,'Sikandri Sarai S.O','462010',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128457,458,'Sindhora B.O','462120',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128458,458,'Sohaya B.O','463111',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128459,458,'Sonkachh B.O','463106',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128460,458,'Subhash Nagar S.O (Bhopal)','462023',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128461,458,'Sukaliya B.O','462101',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128462,458,'Sukhi Sewania B.O','462010',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128463,458,'Suraj Nagar S.O','462044',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128464,458,'Tara Sewaniya B.O','462030',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128465,458,'Tarawali Kalan B.O','462101',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128466,458,'Tila Khedi B.O','462030',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128467,458,'Trilanga S.O','462039',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128468,458,'Tulsi Nagar S.O','462003',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128469,458,'Tumada B.O','462030',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128470,458,'University S.O (Bhopal)','462026',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128471,458,'Vallabh Bhawan S.O','462004',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128472,458,'Vidya Vihar S.O','462002',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128473,459,'Amulla B.O','450001',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128474,459,'Bambhada B.O','450445',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128475,459,'Bhatkheda B.O','450221',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128476,459,'Bodarli B.O','450331',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128477,459,'Borsar B.O','450445',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128478,459,'Burhanpur City S.O','450331',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128479,459,'Chapora B.O','450445',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128480,459,'Khaknar S.O','450332',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128481,459,'Nawara B.O','450221',1,0,'2022-03-04 19:26:33','2022-03-04 19:26:33'),(128482,459,'Nepanagar S.O','450221',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128483,459,'Shahpur (Nimar) S.O','450445',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128484,460,'Abhau B.O','471510',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128485,460,'Achatta B.O','471315',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128486,460,'Ahar B.O','472111',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128487,460,'Ajnore B.O','472010',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128488,460,'Aktonha B.O','471606',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128489,460,'Alipura B.O','471111',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128490,460,'Amronia B.O','471405',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128491,460,'Angore B.O','471301',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128492,460,'Atrar B.O','471301',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128493,460,'Bachhon B.O','471525',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128494,460,'Badagaon B.O','471201',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128495,460,'Badagaon B.O','471405',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128496,460,'Badamalehara S.O','471311',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128497,460,'Badora Kala B.O','471510',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128498,460,'Bagmau B.O','471515',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128499,460,'Bagouta B.O','471001',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128500,460,'Bajna B.O','471311',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128501,460,'Bakola B.O','471525',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128502,460,'Balkora B.O','471525',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128503,460,'Bamhori B.O','471318',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128504,460,'Bamhori Pura B.O','471510',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128505,460,'Bamitha S.O','471105',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128506,460,'Bamni B.O','471311',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128507,460,'Bamnora B.O','471313',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128508,460,'Banchhora B.O','471201',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128509,460,'Bandani B.O','471408',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128510,460,'Bandha B.O','471311',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128511,460,'Bandhikala B.O','471315',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128512,460,'Bangain B.O','471201',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128513,460,'Banjari B.O','471525',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128514,460,'Bansiya B.O','471525',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128515,460,'Bara B.O','471501',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128516,460,'Baraha B.O','471515',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128517,460,'Bardwha B.O','471301',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128518,460,'Barethi B.O','471313',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128519,460,'Bari B.O','471411',1,0,'2022-03-04 19:26:34','2022-03-04 19:26:34'),(128520,460,'Barkiratpura B.O','471201',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128521,460,'Basari B.O','471105',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128522,460,'Behata B.O','471315',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128523,460,'Belahari B.O','471525',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128524,460,'Beniganj B.O','471606',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128525,460,'Bhadurpur B.O','472001',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128526,460,'Bhagwan B.O','471313',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128527,460,'Bhawanipur B.O','471525',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128528,460,'Bhelsi B.O','472111',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128529,460,'Bhera B.O','471408',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128530,460,'Bijawar S.O','471405',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128531,460,'Bikarampur B.O','471625',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128532,460,'Bilahri B.O','471201',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128533,460,'Budera B.O','472111',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128534,460,'Budore B.O','471301',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128535,460,'Budore B.O','471313',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128536,460,'Budrakh B.O','471501',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128537,460,'Buxwaha S.O','471318',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128538,460,'Chandla S.O','471525',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128539,460,'Chandowara B.O','471510',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128540,460,'Chandpura B.O','471515',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128541,460,'Chandra Nagar S.O','471101',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128542,460,'Chauka B.O','471301',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128543,460,'Chhatarpur CB S.O','471001',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128544,460,'Chhatarpur H.O','471001',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128545,460,'Chhati Bamhori B.O','471525',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128546,460,'Chitehari B.O','471510',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128547,460,'Chouwari B.O','471111',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128548,460,'Churiyari B.O','471525',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128549,460,'Daharra B.O','471625',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128550,460,'Dargawan B.O','471311',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128551,460,'Darguwan B.O','471408',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128552,460,'Deopur B.O','471318',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128553,460,'Deora B.O','471405',1,0,'2022-03-04 19:26:35','2022-03-04 19:26:35'),(128554,460,'Deoran B.O','471311',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128555,460,'Deori B.O','471318',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128556,460,'Deri B.O','471315',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128557,460,'Dhadari B.O','471001',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128558,460,'Dhamna B.O','471101',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128559,460,'Dhamora B.O','471201',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128560,460,'Dhangawan B.O','471311',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128561,460,'Dharampura B.O','471405',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128562,460,'Dhawad B.O','471606',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128563,460,'Dhimarwara B.O','471311',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128564,460,'Didwara B.O','471510',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128565,460,'Dikoli B.O','471301',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128566,460,'Doni  (P) B.O','471201',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128567,460,'Doriya B.O','471201',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128568,460,'Dumra B.O','471501',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128569,460,'Gadimalehara S.O','471411',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128570,460,'Gaharwar B.O','471315',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128571,460,'Gahwara B.O','471515',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128572,460,'Galan B.O','471111',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128573,460,'Ganj B.O','471105',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128574,460,'Garhi Samri B.O','471318',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128575,460,'Garroli B.O','471201',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128576,460,'Gatheora B.O','471001',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128577,460,'Gaurihar S.O','471516',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128578,460,'Ghaura S.O','471313',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128579,460,'Ghoora B.O','471105',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128580,460,'Ghoorchitehri B.O','471515',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128581,460,'Gohani B.O','471525',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128582,460,'Gorakh Pura B.O','471313',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128583,460,'Gorihar B.O','471515',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128584,460,'Goyara B.O','471525',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128585,460,'Gudhora B.O','471515',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128586,460,'Gulganj S.O','471301',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128587,460,'Gurhakala B.O','471606',1,0,'2022-03-04 19:26:36','2022-03-04 19:26:36'),(128588,460,'Hanukhera B.O','471515',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128589,460,'Harpalpur S.O (Chhatarpur)','471111',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128590,460,'Hatawaha B.O','471405',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128591,460,'Hathohan B.O','471525',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128592,460,'Himmatpura B.O','471408',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128593,460,'Hinota B.O','471525',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128594,460,'Imaliya B.O','471111',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128595,460,'Imlaha B.O','471101',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128596,460,'Isanagar S.O (Chhatarpur)','471315',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128597,460,'Jamtuli B.O','471105',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128598,460,'Jatashankar B.O','471405',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128599,460,'Jeoraha B.O','471510',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128600,460,'Jetpur B.O','471405',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128601,460,'Jhinijhan B.O','471201',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128602,460,'Jujhar Nagar S.O','471510',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128603,460,'Kalani B.O','471001',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128604,460,'Kararaganj B.O','471111',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128605,460,'Karri B.O','471105',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128606,460,'Katia B.O','471525',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128607,460,'Kayan B.O','471311',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128608,460,'Kenthokar B.O','471111',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128609,460,'Kethara B.O','471606',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128610,460,'Khaddi B.O','471515',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128611,460,'Khadeha B.O','471525',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128612,460,'Khajuraho S.O','471606',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128613,460,'Khajuwa B.O','471625',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128614,460,'Khandela B.O','471525',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128615,460,'Kharduti B.O','471311',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128616,460,'Khariyani B.O','471405',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128617,460,'Kharrohi B.O','471105',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128618,460,'Kherakasar B.O','471510',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128619,460,'Kherakla B.O','471405',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128620,460,'Kheri B.O','471105',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128621,460,'Kheron B.O','471301',1,0,'2022-03-04 19:26:37','2022-03-04 19:26:37'),(128622,460,'Kishangarh B.O','471405',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128623,460,'Kotheha B.O','471525',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128624,460,'Kupishahpur B.O','471405',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128625,460,'Kurala B.O','471625',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128626,460,'Kurraha B.O','471411',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128627,460,'Kutora B.O','471313',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128628,460,'Lakhanguwa B.O','471408',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128629,460,'Lakheri B.O','471606',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128630,460,'Lalpura B.O','471625',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128631,460,'Laundi S.O','471515',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128632,460,'Lugasi B.O','471201',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128633,460,'Madeora B.O','471318',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128634,460,'Maharajganj B.O','471311',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128635,460,'Maharajpur S.O (Chhatarpur)','471501',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128636,460,'Maheba B.O','471201',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128637,460,'Mahyawa B.O','471525',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128638,460,'Majna B.O','472001',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128639,460,'Maniya B.O','471501',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128640,460,'Mankari B.O','471501',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128641,460,'Manuriya B.O','471515',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128642,460,'Matgawan B.O','471301',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128643,460,'Mau Sahnia B.O','471201',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128644,460,'Melwar B.O','471311',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128645,460,'Mudahara B.O','471510',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128646,460,'Muderi B.O','471606',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128647,460,'Naguwan B.O','471408',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128648,460,'Naharpur B.O','471525',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128649,460,'Nandeora B.O','471625',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128650,460,'Nandgain Kal B.O','471315',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128651,460,'Nandginbattan B.O','471408',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128652,460,'Nathpur B.O','471501',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128653,460,'Nayatal B.O','471405',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128654,460,'Nenagiri B.O','471318',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128655,460,'Newar B.O','471318',1,0,'2022-03-04 19:26:38','2022-03-04 19:26:38'),(128656,460,'Niwari B.O','471001',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128657,460,'Nowgong S.O','471201',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128658,460,'Nuna B.O','471411',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128659,460,'Otapurwa B.O','471105',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128660,460,'Padariya B.O','471408',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128661,460,'Pahadgaon B.O','471315',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128662,460,'Pahara B.O','471105',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128663,460,'Pahara B.O','471515',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128664,460,'Paharapurwa B.O','471606',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128665,460,'Panagar B.O','471405',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128666,460,'Pancham Pura B.O','471515',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128667,460,'Pannanaka Chhatarpur S.O','471001',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128668,460,'Panotha B.O','471315',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128669,460,'Panwari B.O','471313',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128670,460,'Patha B.O','471510',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128671,460,'Persania B.O','471515',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128672,460,'Pipat B.O','471405',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128673,460,'Pondi B.O','471318',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128674,460,'Prakashabami B.O','471510',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128675,460,'Ragoli B.O','471408',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128676,460,'Ragoli B.O','471515',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128677,460,'Rajnager S.O','471625',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128678,460,'Ramjhala B.O','471525',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128679,460,'Rampur B.O','471510',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128680,460,'Rampur B.O','471201',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128681,460,'Ramtoriya B.O','471313',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128682,460,'Rangawana B.O','471101',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128683,460,'Ranital B.O','471405',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128684,460,'Sadawa B.O','471311',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128685,460,'Saidara B.O','471318',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128686,460,'Salaiya B.O','471315',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128687,460,'Salaiya B.O','471105',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128688,460,'Sarkana B.O','471313',1,0,'2022-03-04 19:26:39','2022-03-04 19:26:39'),(128689,460,'Sarsed B.O','471111',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128690,460,'Sarwai B.O','471525',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128691,460,'Satai S.O','471408',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128692,460,'Saura B.O','471001',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128693,460,'Selon B.O','471101',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128694,460,'Semariya B.O','471313',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128695,460,'Sendpa B.O','471311',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128696,460,'Seondi B.O','471501',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128697,460,'Sewar B.O','471313',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128698,460,'Shahgarh B.O','471405',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128699,460,'Sighpur B.O','471501',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128700,460,'Sijai B.O','471515',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128701,460,'Singhpur B.O','471525',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128702,460,'Sukwan B.O','471201',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128703,460,'Sunwaha B.O','471318',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128704,460,'Sunwani B.O','471405',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128705,460,'Surajpurkala B.O','471405',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128706,460,'Tatam B.O','471501',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128707,460,'Tehanga B.O','471515',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128708,460,'Thakurra B.O','471515',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128709,460,'Tidani B.O','471201',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128710,460,'Tikuri B.O','471606',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128711,460,'Tila B.O','471111',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128712,460,'Udaipura B.O','471606',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128713,460,'Ujara B.O','471411',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128714,460,'Urdmau B.O','471411',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128715,460,'Willa B.O','471625',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128716,461,'Amarwara S.O','480221',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128717,461,'Ambada B.O','480449',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128718,461,'Ambada B.O','480334',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128719,461,'Ambamali B.O','480331',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128720,461,'Amladepot B.O','480106',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128721,461,'Anjangaon B.O','480337',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128722,461,'Ankhiya B.O','480551',1,0,'2022-03-04 19:26:40','2022-03-04 19:26:40'),(128723,461,'Badegaon B.O','480338',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128724,461,'Badegaon B.O','480223',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128725,461,'Badela B.O','480115',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128726,461,'Badgaon B.O','480110',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128727,461,'Badnoor B.O','480331',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128728,461,'Badsaliya B.O','480224',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128729,461,'Baghbardia B.O','480441',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128730,461,'Bamanwara B.O','480551',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128731,461,'Bamhanwara B.O','480115',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128732,461,'Bamni B.O','480559',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128733,461,'Banabakoda B.O','480109',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128734,461,'Bangaon B.O','480338',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128735,461,'Bangaon B.O','480223',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128736,461,'Banka B.O','480224',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128737,461,'Banka Mukasa B.O','480223',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128738,461,'Bankanaganpur B.O','480001',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128739,461,'Banskheda B.O','480110',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128740,461,'Barahira B.O','480221',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128741,461,'Barelipar B.O','480551',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128742,461,'Bargi B.O','480224',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128743,461,'Barkuhi B.O','480447',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128744,461,'Basuriya B.O','480224',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128745,461,'Batkakhapa B.O','480224',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128746,461,'Belgaon B.O','480557',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128747,461,'Berdi B.O','480106',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128748,461,'Bhajipani B.O','480449',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128749,461,'Bhamodi B.O','480449',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128750,461,'Bhandargondi B.O','480334',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128751,461,'Bhatodia Khurd B.O','480551',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128752,461,'Bheda B.O','480224',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128753,461,'Bhimalgondi B.O','480106',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128754,461,'Bhula Mohgaon B.O','480223',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128755,461,'Bhumka B.O','480224',1,0,'2022-03-04 19:26:41','2022-03-04 19:26:41'),(128756,461,'Bhutai B.O','480331',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128757,461,'Bichhua S.O','480111',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128758,461,'Bijori B.O','480559',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128759,461,'Binjhawara B.O','480115',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128760,461,'Bisapur B.O','480001',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128761,461,'Bohnakheri B.O','480001',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128762,461,'Borgaon B.O','480106',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128763,461,'Boria B.O','480001',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128764,461,'Chand S.O','480110',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128765,461,'Chandametta S.O','480447',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128766,461,'Chandangaon S.O','480003',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128767,461,'Changoba B.O','480334',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128768,461,'Chania Kalan B.O','480223',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128769,461,'Chawalpani B.O','480559',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128770,461,'Chhinda B.O','480441',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128771,461,'Chhindi B.O','480559',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128772,461,'Chhindwara H.O','480001',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128773,461,'Chhui B.O','480221',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128774,461,'Chichkheda B.O','480338',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128775,461,'Chicholi Vad B.O','480337',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128776,461,'Chikalmau B.O','480551',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128777,461,'Chikhalikalan B.O','480107',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128778,461,'Chitanvisganj S.O','480001',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128779,461,'Chourai S.O','480115',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128780,461,'Dadimeta B.O','480334',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128781,461,'Damua S.O','480555',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128782,461,'Darbai B.O','480449',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128783,461,'Datla B.O','480551',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128784,461,'Delakhari B.O','480559',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128785,461,'Deori B.O','480111',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128786,461,'Devi B.O','480106',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128787,461,'Dhadhra B.O','480223',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128788,461,'Dhanegaon B.O','480111',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128789,461,'Dhanora B.O','480334',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128790,461,'Dhanora Jagir B.O','480224',1,0,'2022-03-04 19:26:42','2022-03-04 19:26:42'),(128791,461,'Dhaodikhapa B.O','480334',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128792,461,'Dhasanwara B.O','480221',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128793,461,'Dhusawani B.O','480559',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128794,461,'Dighawani B.O','480441',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128795,461,'Dilawar Mohgaon B.O','480110',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128796,461,'Dungaria B.O','480551',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128797,461,'Dungaria S.O','480553',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128798,461,'Dungariabhardagarh B.O','480555',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128799,461,'Eklehra S.O','480449',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128800,461,'Etawa B.O','480338',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128801,461,'Etawa B.O','480559',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128802,461,'Gajandoha B.O','480441',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128803,461,'Gangiwara B.O','480001',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128804,461,'Ghoghari B.O','480221',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128805,461,'Ghoghari Sahani B.O','480337',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128806,461,'Ghorad B.O','480111',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128807,461,'Ghorawari Kalan B.O','480555',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128808,461,'Ghorawari Khurd B.O','480555',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128809,461,'Ghoti B.O','480108',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128810,461,'Gopalpur B.O','480115',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128811,461,'Gourpani B.O','480224',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128812,461,'Gualbra Chhindwara S.O','480001',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128813,461,'Gumgaon B.O','480110',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128814,461,'Gurriya B.O','480001',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128815,461,'Hanotiya B.O','480551',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128816,461,'Harnakhedi B.O','480110',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128817,461,'Harrai S.O','480224',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128818,461,'Hirawadi B.O','460663',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128819,461,'Hirdagarh B.O','480551',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128820,461,'Hiwara Senadwar B.O','480337',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128821,461,'Hiwarkhedi B.O','480223',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128822,461,'Imlikheda B.O','480001',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128823,461,'Jam B.O','480107',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128824,461,'Jamkunda B.O','480551',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128825,461,'Jamsaoli B.O','480106',1,0,'2022-03-04 19:26:43','2022-03-04 19:26:43'),(128826,461,'Jamuniya B.O','480559',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128827,461,'Jamuniya B.O','480223',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128828,461,'Jatachhapar B.O','480449',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128829,461,'Jhilmili B.O','480001',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128830,461,'Jhirlinga B.O','480223',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128831,461,'Jhirpa B.O','480559',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128832,461,'Jhontkalan B.O','480559',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128833,461,'Jhurre Mines B.O','480441',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128834,461,'Jobnikhapa B.O','480106',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128835,461,'Jungawani B.O','480221',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128836,461,'Junnardeo S.O','480551',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128837,461,'Kabarpipla B.O','480108',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128838,461,'Kadaiya B.O','480111',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128839,461,'Kamthi B.O','480331',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128840,461,'Kanhargaon B.O','480331',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128841,461,'Kapurdha B.O','480115',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128842,461,'Karaghat Kamthi B.O','480331',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128843,461,'Kaudia B.O','480331',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128844,461,'Keolari B.O','480223',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128845,461,'Khairitaygoan B.O','480108',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128846,461,'Khamarpani B.O','480111',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128847,461,'Khamra B.O','480111',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128848,461,'Khazari B.O','480001',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128849,461,'Khedikalan B.O','480338',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128850,461,'Khireti B.O','480115',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128851,461,'Khirsadoha B.O','480441',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128852,461,'Khuntpipariya B.O','480115',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128853,461,'Kohat B.O','480331',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128854,461,'Kohka B.O','480557',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128855,461,'Kondhali B.O','480334',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128856,461,'Koparwarai B.O','480109',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128857,461,'Koparwari B.O','480223',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128858,461,'Kudwari B.O','480221',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128859,461,'Kuhiya B.O','480110',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128860,461,'Kunda B.O','480115',1,0,'2022-03-04 19:26:44','2022-03-04 19:26:44'),(128861,461,'Kundalikalan B.O','480001',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128862,461,'Kursidhana B.O','480559',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128863,461,'Langha B.O','480337',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128864,461,'Lawaghoghari B.O','480331',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128865,461,'Ledori B.O','480334',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128866,461,'Lehgadua B.O','480557',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128867,461,'Linga B.O','480001',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128868,461,'Lingajatlapur B.O','480338',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128869,461,'Lodhikheda S.O','480108',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128870,461,'Lohangi B.O','480106',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128871,461,'Lohangi Raiyat B.O','480107',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128872,461,'Lotiya B.O','480559',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128873,461,'Machagora B.O','480001',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128874,461,'Madai B.O','480224',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128875,461,'Mahalpur B.O','480107',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128876,461,'Mahuljhir B.O','480559',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128877,461,'Mainikhapa B.O','480331',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128878,461,'Manegaon B.O','480223',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128879,461,'Mangurli B.O','480334',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128880,461,'Mankadehi B.O','480001',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128881,461,'Markahandi B.O','480001',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128882,461,'Markawara B.O','480221',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128883,461,'Marud B.O','480338',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128884,461,'Mau B.O','480107',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128885,461,'Meghaseoni B.O','480223',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128886,461,'Meghdone B.O','480110',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128887,461,'Mohgaon Haveli S.O','480105',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128888,461,'Mohkhed S.O','480112',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128889,461,'Mordongari B.O','480334',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128890,461,'Mordongari B.O','480331',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128891,461,'Mothar B.O','480001',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128892,461,'Moya B.O','480111',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128893,461,'Mujawar B.O','480331',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128894,461,'Munganapar B.O','480111',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128895,461,'Muttor B.O','480559',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128896,461,'Nagri B.O','480559',1,0,'2022-03-04 19:26:45','2022-03-04 19:26:45'),(128897,461,'Nandan B.O','480555',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128898,461,'Nandanwani B.O','480334',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128899,461,'Nandewani B.O','480105',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128900,461,'Navegaon B.O','480551',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128901,461,'Newton Chikhali S.O','480557',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128902,461,'Nimni B.O','480106',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128903,461,'Nonia Karbal B.O','480001',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128904,461,'Ojhaldhana B.O','480224',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128905,461,'Pagara B.O','480557',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128906,461,'Paijanwara B.O','480557',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128907,461,'Palachourai B.O','480449',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128908,461,'Paladone B.O','480001',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128909,461,'Palakhed B.O','480331',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128910,461,'Palatwara B.O','480441',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128911,461,'Pandharakheda B.O','480105',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128912,461,'Pandhurna Gujari B.O','480334',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128913,461,'Pandhurna S.O','480334',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128914,461,'Panjara B.O','480115',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128915,461,'Paradsinga B.O','480108',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128916,461,'Parasgaon B.O','480107',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128917,461,'Parsoli B.O','480115',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128918,461,'Parsoli B.O','480334',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128919,461,'Partala B.O','480001',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128920,461,'Partapur B.O','480224',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128921,461,'Pathari B.O','480111',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128922,461,'Paunar B.O','480331',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128923,461,'Pendoni B.O','480338',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128924,461,'Petdeori B.O','480221',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128925,461,'Pindrai B.O','480109',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128926,461,'Pindraikalan B.O','480001',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128927,461,'Pipalpani B.O','480338',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128928,461,'Pipariya Mansingh B.O','480115',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128929,461,'Pipariya Rajguru B.O','480221',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128930,461,'Piplanarayanwar S.O','480109',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128931,461,'Pounar B.O','480221',1,0,'2022-03-04 19:26:46','2022-03-04 19:26:46'),(128932,461,'Pradhan Ghoghari B.O','480331',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128933,461,'Rajada B.O','480331',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128934,461,'Rajadi Pipla B.O','480105',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128935,461,'Rajana B.O','480337',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128936,461,'Rajegaon B.O','480107',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128937,461,'Rajora Kalan B.O','480334',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128938,461,'Rakhikol B.O','480555',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128939,461,'Ramakona B.O','480106',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128940,461,'Ramgarh B.O','480115',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128941,461,'Rampur B.O','480555',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128942,461,'Rangari B.O','480108',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128943,461,'Ranpeth B.O','480106',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128944,461,'Ratamati B.O','480224',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128945,461,'Rawanwara B.O','480441',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128946,461,'Richheda B.O','480221',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128947,461,'Ringankhapa B.O','480334',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128948,461,'Rohna B.O','480001',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128949,461,'Saikheda B.O','480337',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128950,461,'Saliwara Sharda B.O','480221',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128951,461,'Samaswara B.O','480115',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128952,461,'Sangakheda B.O','480559',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128953,461,'Sankh B.O','480115',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128954,461,'Saonga B.O','480108',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128955,461,'Saori Bazaar S.O','480331',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128956,461,'Sarangbihiri B.O','480107',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128957,461,'Sarna B.O','480223',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128958,461,'Sausar S.O','480106',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128959,461,'Sawarni B.O','480108',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128960,461,'Seja B.O','480221',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128961,461,'Seoni Sausar S.O','480337',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128962,461,'Sidholi B.O','480559',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128963,461,'Sihoramal B.O','480223',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128964,461,'Sillewani B.O','480107',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128965,461,'Singodi S.O','480223',1,0,'2022-03-04 19:26:47','2022-03-04 19:26:47'),(128966,461,'Siratha B.O','480334',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128967,461,'Siregaon B.O','480115',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128968,461,'Sirgora B.O','480441',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128969,461,'Sitajhir B.O','480115',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128970,461,'Sitapar B.O','480115',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128971,461,'Sonakhar B.O','480001',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128972,461,'Sonpur B.O','480221',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128973,461,'Surlakhapa B.O','480224',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128974,461,'Tamia S.O','480559',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128975,461,'TB Senetorium S.O','480001',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128976,461,'Teegaon S.O','480338',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128977,461,'Tendani B.O','480221',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128978,461,'Top B.O','480110',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128979,461,'Tumragarhi B.O','480111',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128980,461,'Turkikhapa B.O','480107',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128981,461,'Ubhegaon B.O','480107',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128982,461,'Umaranala S.O','480107',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128983,461,'Umaria Isra B.O','480001',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128984,461,'Umrad B.O','480110',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128985,461,'Umreth B.O','480441',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128986,461,'Urdhan B.O','480441',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128987,462,'Abhana B.O','470661',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128988,462,'Agara B.O','470673',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128989,462,'Ajni B.O','470673',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128990,462,'Amakheda B.O','470771',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128991,462,'Anu B.O','470771',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128992,462,'Aslana B.O','470675',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128993,462,'Badagaon B.O','470661',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128994,462,'Bakayan B.O','470673',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128995,462,'Bakeni B.O','470661',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128996,462,'Balakot B.O','470672',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128997,462,'Ballarpur B.O','470664',1,0,'2022-03-04 19:26:48','2022-03-04 19:26:48'),(128998,462,'Bamanpura B.O','470772',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(128999,462,'Bamorimala B.O','470663',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129000,462,'Bandakpur S.O','470664',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129001,462,'Bandha B.O','470775',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129002,462,'Bangaon B.O','470661',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129003,462,'Bansa Tarkheda S.O','470672',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129004,462,'Banwar B.O','470664',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129005,462,'Bardha B.O','470775',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129006,462,'Bari Kanora B.O','470775',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129007,462,'Barkhera Bais B.O','470772',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129008,462,'Baroda Kalan B.O','470775',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129009,462,'Batiagarh S.O','470673',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129010,462,'Belai B.O','470661',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129011,462,'Bhaisa B.O','470775',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129012,462,'Bhajiya B.O','470881',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129013,462,'Bhartala B.O','470772',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129014,462,'Bhatia B.O','470775',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129015,462,'Bhiloni B.O','470775',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129016,462,'Bhuri B.O','470661',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129017,462,'Bijadongary B.O','470661',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129018,462,'Bilani B.O','470666',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129019,462,'Binti B.O','470775',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129020,462,'Bisnakheda B.O','470661',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129021,462,'Botrai B.O','470666',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129022,462,'Chaupra B.O','470663',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129023,462,'Chaurai Kalumar B.O','470881',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129024,462,'Chewala B.O','470772',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129025,462,'Chirola B.O','470675',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129026,462,'Damoh Bazaria S.O','470661',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129027,462,'Damoh City S.O','470661',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129028,462,'Damoh Civil Ward S.O','470661',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129029,462,'Damoh Collectrate S.O','470661',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129030,462,'Damoh H.O','470661',1,0,'2022-03-04 19:26:49','2022-03-04 19:26:49'),(129031,462,'Damoh Phutera Ward S.O','470661',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129032,462,'Damoh R S S.O','470661',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129033,462,'Deodongra B.O','470772',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129034,462,'Deori Fatehpur B.O','470775',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129035,462,'Deori Jmadar B.O','470880',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129036,462,'Dhangaur Kalan B.O','470880',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129037,462,'Dinari B.O','470880',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129038,462,'Emaliya Lanji B.O','470672',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129039,462,'Emlai B.O','470661',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129040,462,'Fatehpur B.O','470775',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129041,462,'Gaisabad B.O','470775',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129042,462,'Ghat Pipariya B.O','470664',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129043,462,'Ghatera B.O','470664',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129044,462,'Gubra Kalan B.O','470881',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129045,462,'Gunji B.O','470771',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129046,462,'Hardua Mangarh B.O','470664',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129047,462,'Harduya Sadak B.O','470663',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129048,462,'Hathana B.O','470672',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129049,462,'Hatta Bazariya S.O','470775',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129050,462,'Hatta S.O (Damoh)','470775',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129051,462,'Hindoriya S.O','470771',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129052,462,'Hinota Kalan B.O','470775',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129053,462,'Hinoti Putrighat B.O','470880',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129054,462,'Jabera S.O','470881',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129055,462,'Jerath B.O','470666',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129056,462,'Jhlaun B.O','470880',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129057,462,'Jortala B.O','470661',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129058,462,'Jujhar B.O','470664',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129059,462,'Kaikheda B.O','470775',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129060,462,'Kaithora B.O','470673',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129061,462,'Kalehrakheda B.O','470663',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129062,462,'Kandipur B.O','470771',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129063,462,'Kanti B.O','470775',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129064,462,'Karanpura B.O','470881',1,0,'2022-03-04 19:26:50','2022-03-04 19:26:50'),(129065,462,'Kerwana B.O','470673',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129066,462,'Kevlari B.O','470666',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129067,462,'Khaderi B.O','470673',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129068,462,'Khajari B.O','470661',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129069,462,'Khamriya Ajitpur B.O','470880',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129070,462,'Khamriya Mojilal B.O','470661',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129071,462,'Khojakhedi B.O','470661',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129072,462,'Kindroh B.O','470666',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129073,462,'Kishangarh B.O','470675',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129074,462,'Kodakalan B.O','470881',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129075,462,'Korta B.O','470881',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129076,462,'Kuakheda B.O','470661',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129077,462,'Kuakheda Bazi B.O','470775',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129078,462,'Kuarpur B.O','470775',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129079,462,'Kudai B.O','470772',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129080,462,'Kumeriya B.O','470672',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129081,462,'Kumhari B.O','470664',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129082,462,'Kundalpur B.O','470772',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129083,462,'Kusmi Mangarh B.O','470881',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129084,462,'Lakhni B.O','470663',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129085,462,'Lakhroni B.O','470666',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129086,462,'Ludhora B.O','470775',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129087,462,'Luhari B.O','470775',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129088,462,'Madankheda B.O','470880',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129089,462,'Madiyado B.O','470775',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129090,462,'Magron B.O','470775',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129091,462,'Majhguya Hansraj B.O','470664',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129092,462,'Mangola B.O','470673',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129093,462,'Mankaura B.O','470675',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129094,462,'Marutal B.O','470661',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129095,462,'Mojipura B.O','470663',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129096,462,'Mudia B.O','470661',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129097,462,'Muharai B.O','470775',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129098,462,'Muharai B.O','470880',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129099,462,'Muraj B.O','470775',1,0,'2022-03-04 19:26:51','2022-03-04 19:26:51'),(129100,462,'Nandrai B.O','470666',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129101,462,'Narsingarh S.O','470675',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129102,462,'Nohata S.O','470663',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129103,462,'Padrai B.O','470772',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129104,462,'Pandajhir B.O','470775',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129105,462,'Pashwaha B.O','470664',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129106,462,'Patera S.O','470772',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129107,462,'Pateriya B.O','470664',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129108,462,'Pathariya S.O','470666',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129109,462,'Patna Bhangarh B.O','470664',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129110,462,'Patnakuya B.O','470881',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129111,462,'Patnaraja B.O','470880',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129112,462,'Phutera Kalan B.O','470673',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129113,462,'Piparia Champat B.O','470675',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129114,462,'Pipariya Tikari B.O','470664',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129115,462,'Podimangarh B.O','470881',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129116,462,'Pura B.O','470880',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129117,462,'Rajpura B.O','470775',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129118,462,'Ramgarh B.O','470880',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129119,462,'Raneh B.O','470775',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129120,462,'Rasilpur B.O','470775',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129121,462,'Road B.O','470663',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129122,462,'Sadguya B.O','470661',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129123,462,'Sadpur B.O','470775',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129124,462,'Sakha B.O','470663',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129125,462,'Salaiya B.O','470664',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129126,462,'Salwada B.O','470880',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129127,462,'Samnapur B.O','470880',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129128,462,'Sanga B.O','470880',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129129,462,'Sankuiya  B.O','470775',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129130,462,'Sarkhadi B.O','470672',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129131,462,'Sarra B.O','470880',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129132,462,'Sarsawagali B.O','470880',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129133,462,'Satpara B.O','470666',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129134,462,'Semra Madia B.O','470661',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129135,462,'Sigrampur B.O','470881',1,0,'2022-03-04 19:26:52','2022-03-04 19:26:52'),(129136,462,'Singpur B.O','470881',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129137,462,'Sitanagar B.O','470675',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129138,462,'Sojna B.O','470775',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129139,462,'Suhela B.O','470880',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129140,462,'Sukha B.O','470666',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129141,462,'Taradehi B.O','470880',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129142,462,'Tejgarh B.O','470880',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129143,462,'Tendukheda S.O','470880',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129144,462,'Teoriya B.O','470775',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129145,462,'Tindua B.O','470673',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129146,462,'Umari B.O','470661',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129147,463,'Aser B.O','475671',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129148,463,'Atra B.O','475682',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129149,463,'Atreta B.O','475673',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129150,463,'Badera Sopan B.O','475335',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129151,463,'Badokhari B.O','475673',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129152,463,'Bahadurpur B.O','475661',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129153,463,'Bardhuan B.O','475661',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129154,463,'Bargain B.O','475685',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129155,463,'Baron Kalan B.O','475685',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129156,463,'Basai B.O','475661',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129157,463,'Basturi B.O','475682',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129158,463,'Baswaha B.O','475661',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129159,463,'Beekar B.O','475661',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129160,463,'Berachh B.O','475335',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129161,463,'Berchha B.O','475682',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129162,463,'Bhadona B.O','475685',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129163,463,'Bhaguapura B.O','475673',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129164,463,'Bhalka B.O','475336',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129165,463,'Bhandair S.O','475335',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129166,463,'Bharoli B.O','475675',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129167,463,'Bhitari B.O','475336',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129168,463,'Bichhodana B.O','475335',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129169,463,'Bilhati B.O','475335',1,0,'2022-03-04 19:26:53','2022-03-04 19:26:53'),(129170,463,'Buhara B.O','475661',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129171,463,'Chandrol B.O','475335',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129172,463,'Chhata B.O','475686',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129173,463,'Dabhera B.O','475675',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129174,463,'Datia Bada Bazar S.O','475661',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129175,463,'Datia Civil Line B.O','475661',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129176,463,'Datia Rajgarh S.O','475661',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129177,463,'Datia RSI','475661',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129178,463,'Datia S.O','475661',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129179,463,'Derachirula B.O','475661',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129180,463,'Devai B.O','475682',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129181,463,'Diguwan B.O','475673',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129182,463,'Dirolipar B.O','475682',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129183,463,'Durga Pur B.O','475661',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129184,463,'Dursada B.O','475661',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129185,463,'Erai B.O','475686',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129186,463,'Gohana B.O','475661',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129187,463,'Gondan B.O','475336',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129188,463,'Gyara B.O','475682',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129189,463,'Hinotia B.O','475685',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129190,463,'Ikara B.O','475671',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129191,463,'Imalia B.O','475661',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129192,463,'Indergarh S.O (Datia)','475675',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129193,463,'Ingui B.O','475673',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129194,463,'Jigna B.O','475686',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129195,463,'Jignia B.O','475675',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129196,463,'Jonia B.O','475675',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129197,463,'Joura B.O','475675',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129198,463,'Jouri B.O','475336',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129199,463,'Jujharpur B.O','475661',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129200,463,'Kamad B.O','475671',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129201,463,'Kamlapuri B.O','475336',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129202,463,'Kamrari B.O','475661',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129203,463,'Karkheda B.O','475661',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129204,463,'Khamroli B.O','475682',1,0,'2022-03-04 19:26:54','2022-03-04 19:26:54'),(129205,463,'Khiria Alam B.O','475336',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129206,463,'Khiria Ghongu B.O','475661',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129207,463,'Khiria Saheb B.O','475335',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129208,463,'Kudari B.O','475673',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129209,463,'Kularia B.O','475335',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129210,463,'Kuleth B.O','475675',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129211,463,'Kumhedi B.O','475661',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129212,463,'Kurthara B.O','475686',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129213,463,'Kusoli B.O','475671',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129214,463,'Lahar Haveli B.O','475335',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129215,463,'Lanch B.O','475675',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129216,463,'Larayata B.O','475661',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129217,463,'Makdari B.O','475661',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129218,463,'Mangrol B.O','475682',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129219,463,'Marseni Khurd B.O','475673',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129220,463,'Murera B.O','475686',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129221,463,'Murgawan B.O','475675',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129222,463,'Naya Kheda B.O','475661',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129223,463,'Neemdanda B.O','475682',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129224,463,'Nehla B.O','475682',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129225,463,'Nichroli B.O','475661',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129226,463,'Noner B.O','475686',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129227,463,'Nunwaha B.O','475686',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129228,463,'Orina B.O','475686',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129229,463,'Pachokhara B.O','475675',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129230,463,'Pachokhara B.O','475685',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129231,463,'Padari B.O','475675',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129232,463,'Pandokhar B.O','475335',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129233,463,'Parasari B.O','475671',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129234,463,'Parsoda Baman B.O','475673',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129235,463,'Parsoda Khurd B.O','475673',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129236,463,'Pipraua Kalan B.O','475335',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129237,463,'Piprua B.O','475675',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129238,463,'Raori B.O','475685',1,0,'2022-03-04 19:26:55','2022-03-04 19:26:55'),(129239,463,'Rarua Rai B.O','475675',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129240,463,'Rasulpura B.O','475682',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129241,463,'Renda B.O','475661',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129242,463,'Richhar B.O','475671',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129243,463,'Rora B.O','475675',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129244,463,'Ruhera B.O','475682',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129245,463,'Sadwara B.O','475671',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129246,463,'Salethara B.O','475335',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129247,463,'Salon A B.O','475335',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129248,463,'Salon B. S.O','475336',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129249,463,'Sanora B.O','475686',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129250,463,'Sarsai B.O','475335',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129251,463,'Satlon B.O','475661',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129252,463,'Semai B.O','475661',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129253,463,'Senguwan B.O','475673',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129254,463,'Seondha S.O','475682',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129255,463,'Sersa B.O','475671',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129256,463,'Sikari B.O','475675',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129257,463,'Silori B.O','475661',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129258,463,'Singhpura B.O','475335',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129259,463,'Sirol B.O','475661',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129260,463,'Sirsa B.O','475682',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129261,463,'Sitapur B.O','475685',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129262,463,'Softa B.O','475335',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129263,463,'Sohan B.O','475336',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129264,463,'Sonagir S.O','475685',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129265,463,'Sunari B.O','475685',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129266,463,'Talgaon B.O','475336',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129267,463,'Targuan B.O','475671',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129268,463,'Tendot B.O','475335',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129269,463,'Tharet S.O','475673',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129270,463,'Toda B.O','475673',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129271,463,'Tori B.O','475336',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129272,463,'Uchad B.O','475675',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129273,463,'Uchia B.O','475675',1,0,'2022-03-04 19:26:56','2022-03-04 19:26:56'),(129274,463,'Udgawan B.O','475686',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129275,463,'Udi B.O','475336',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129276,463,'Udina B.O','475336',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129277,463,'Unnao S.O','475671',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129278,463,'Uprai B.O','475685',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129279,464,'Agrod B.O','455001',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129280,464,'Agrod B.O','455116',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129281,464,'Agurli B.O','455227',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129282,464,'Ajnas B.O','455336',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129283,464,'Alri B.O','455001',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129284,464,'Amla B.O','455332',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129285,464,'Amlataj B.O','455223',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129286,464,'Amona B.O','455116',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129287,464,'Anabad B.O','455118',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129288,464,'Anwalia Piplia B.O','455115',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129289,464,'Arlaoda B.O','455223',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129290,464,'Atwas B.O','455459',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129291,464,'Babai B.O','455118',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129292,464,'Bagankheda B.O','455332',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129293,464,'Bagli S.O','455227',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129294,464,'Bahirawad B.O','455332',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129295,464,'Baijagwada B.O','455459',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129296,464,'Bairagarh B.O','455001',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129297,464,'Balgarh S.O','455111',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129298,464,'Balon B.O','455116',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129299,464,'Bamnikhurd B.O','455332',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129300,464,'Bangar B.O','455001',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129301,464,'Bangarda B.O','455001',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129302,464,'Baodi Kheda B.O','455332',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129303,464,'Barkheda Purvaiya B.O','455223',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129304,464,'Barkhedasoma B.O','455221',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129305,464,'Barotha B.O','455001',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129306,464,'Bedgaon B.O','455440',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129307,464,'Bhamori B.O','455227',1,0,'2022-03-04 19:26:57','2022-03-04 19:26:57'),(129308,464,'Bhandaria B.O','455336',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129309,464,'Bhesun B.O','455440',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129310,464,'Bhonrasa S.O','455115',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129311,464,'Bhutiyabujurg B.O','455116',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129312,464,'Bijalgaon B.O','455339',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129313,464,'Bijwad B.O','455440',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129314,464,'Bilawli B.O','455001',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129315,464,'Binjana B.O','455001',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129316,464,'Bisakhedi B.O','455118',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129317,464,'Burada B.O','455339',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129318,464,'Chandpura B.O','455227',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129319,464,'Chandrashekhar Dam B.O','455440',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129320,464,'Chandwana B.O','455336',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129321,464,'Chapda B.O','455227',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129322,464,'Chaubapipliya B.O','455221',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129323,464,'Chaubara Jagir B.O','455118',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129324,464,'Chichli Rajor B.O','455336',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129325,464,'Chidawad B.O','455001',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129326,464,'Chobaradhira B.O','455116',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129327,464,'Churlai Badi B.O','455115',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129328,464,'Dangarkheda B.O','455459',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129329,464,'Dattotar Mandi B.O','455001',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129330,464,'Daulatpur B.O','455118',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129331,464,'Deepgaon B.O','455339',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129332,464,'Dehri Sahu B.O','455221',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129333,464,'Deogarh B.O','455223',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129334,464,'Deoguradia B.O','455118',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129335,464,'Dewas Bada Bazar S.O','455001',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129336,464,'Dewas Bank Note Press S.O','455001',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129337,464,'Dewas Bhavanisagar S.O','455001',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129338,464,'Dewas H.O','455001',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129339,464,'Dewas Industrial Estate S.O','455001',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129340,464,'Dewas Radhaganj S.O','455001',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129341,464,'Dewas Vijayganjmandi B.O','455001',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129342,464,'Dokakui B.O','455332',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129343,464,'Double Chowki B.O','455221',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129344,464,'Eklera B.O','455339',1,0,'2022-03-04 19:26:58','2022-03-04 19:26:58'),(129345,464,'Eklera Mataji B.O','455116',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129346,464,'Gandharvpuri B.O','455118',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129347,464,'Ganora B.O','455336',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129348,464,'Garhkhajuria B.O','455118',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129349,464,'Ghasad B.O','455459',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129350,464,'Godhna B.O','455440',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129351,464,'Gorba B.O','455116',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129352,464,'Guradiakalan B.O','455227',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129353,464,'Harangaon B.O','455336',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129354,464,'Harnoada B.O','455116',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129355,464,'Hatpipliya S.O','455223',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129356,464,'Jamgod B.O','455115',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129357,464,'Jamoniya B.O','455116',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129358,464,'Jinwani B.O','455440',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129359,464,'Jiyagaon B.O','455336',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129360,464,'Jiyagarh B.O','455116',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129361,464,'Kalma B.O','455001',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129362,464,'Kalwar B.O','455332',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129363,464,'Kamlapur B.O','455227',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129364,464,'Kankakhajuriya B.O','455118',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129365,464,'Kankariya B.O','455336',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129366,464,'Kannod S.O','455332',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129367,464,'Kantaphod S.O','455440',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129368,464,'Karnawad S.O','455221',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129369,464,'Katkut B.O','455332',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129370,464,'Kelod B.O','455001',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129371,464,'Khajuriabina B.O','455223',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129372,464,'Khal B.O','455339',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129373,464,'Khareli B.O','455001',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129374,464,'Khategaon S.O','455336',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129375,464,'Kheriajagir B.O','455118',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129376,464,'Khiroda B.O','455459',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129377,464,'Khokriya B.O','455115',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129378,464,'Khutkheda B.O','455118',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129379,464,'Kolari B.O','455339',1,0,'2022-03-04 19:26:59','2022-03-04 19:26:59'),(129380,464,'Kshipra B.O','455001',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129381,464,'Kusmania B.O','455332',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129382,464,'Lasudiya Brahaman B.O','455116',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129383,464,'Lasudiya Kulmi B.O','455116',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129384,464,'Limboda B.O','455223',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129385,464,'Loharda B.O','455440',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129386,464,'Mankund B.O','455223',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129387,464,'Matmautr B.O','455227',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129388,464,'Maukheda B.O','455223',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129389,464,'Mohai B.O','455459',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129390,464,'Mundheda B.O','455001',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129391,464,'Mundladangi B.O','455116',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129392,464,'Murjhal B.O','455339',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129393,464,'Nagda B.O','455111',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129394,464,'Nanasa B.O','455336',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129395,464,'Nandal B.O','455116',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129396,464,'Nanukheda B.O','455223',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129397,464,'Nemawar S.O','455339',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129398,464,'Neori B.O','455223',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129399,464,'Nipania B.O','455001',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129400,464,'Nipaniya Hurhur B.O','455118',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129401,464,'Omkara B.O','455332',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129402,464,'Padliya B.O','455001',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129403,464,'Pandajagir B.O','455118',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129404,464,'Pandutalab B.O','455227',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129405,464,'Panigaon B.O','455440',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129406,464,'Pankua B.O','455227',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129407,464,'Patadi B.O','455221',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129408,464,'Patlawada B.O','455001',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129409,464,'Patrani B.O','455332',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129410,464,'Pipalkota B.O','455336',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129411,464,'Pipalrawa B.O','455118',1,0,'2022-03-04 19:27:00','2022-03-04 19:27:00'),(129412,464,'Piplani B.O','455332',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129413,464,'Piplianankar B.O','455339',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129414,464,'Pipri B.O','455227',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129415,464,'Polai B.O','455118',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129416,464,'Punjapura B.O','455227',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129417,464,'Raghogarh B.O','455221',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129418,464,'Rajoda B.O','455001',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129419,464,'Ranayal Kalan B.O','455116',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129420,464,'Randankhedi B.O','455001',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129421,464,'Ratanpur B.O','455227',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129422,464,'Richi B.O','455336',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129423,464,'Sadikheda B.O','455115',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129424,464,'Salamkhedi B.O','455001',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129425,464,'Sandalpur B.O','455339',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129426,464,'Sannod B.O','455221',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129427,464,'Sanwarsi B.O','455115',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129428,464,'Satwas S.O','455459',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129429,464,'Sawasada B.O','455339',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129430,464,'Singawada B.O','455001',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129431,464,'Siroliya B.O','455001',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129432,464,'Siya B.O','455001',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129433,464,'Sonkhedi B.O','455332',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129434,464,'Sonkutch S.O','455118',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129435,464,'Sukardi B.O','455336',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129436,464,'Sulgaon B.O','455336',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129437,464,'Sundrel B.O','455440',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129438,464,'Sunwanigopal B.O','455001',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129439,464,'Surmania B.O','455440',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129440,464,'Talod B.O','455118',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129441,464,'Tappa Suklia B.O','455223',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129442,464,'Thuria B.O','455332',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129443,464,'Tigira Chota B.O','455111',1,0,'2022-03-04 19:27:01','2022-03-04 19:27:01'),(129444,464,'Tigiria Goga B.O','455111',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129445,464,'Tiwdiya B.O','455336',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129446,464,'Tonkhurd S.O','455116',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129447,464,'Tonkkalan B.O','455001',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129448,464,'Udaynagar B.O','455227',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129449,464,'Umaria B.O','455336',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129450,464,'Vikrampur B.O','455332',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129451,464,'Zikrakheda B.O','455221',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129452,465,'Ahu B.O','454001',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129453,465,'Ajanda B.O','454446',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129454,465,'Ajandikot B.O','454446',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129455,465,'Akhada B.O','454221',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129456,465,'Ali B.O','454331',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129457,465,'Ambada B.O','454331',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129458,465,'Amjhera S.O','454441',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129459,465,'Anarad B.O','454001',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129460,465,'Awaldaman B.O','454446',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129461,465,'Bachanpur B.O','454010',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129462,465,'Badchapra B.O','454773',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129463,465,'Badnawar S.O','454660',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129464,465,'Badodiya B.O','454111',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129465,465,'Badwaniya B.O','454331',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129466,465,'Bagdi B.O','454001',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129467,465,'Bagh S.O','454221',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129468,465,'Baglia B.O','454446',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129469,465,'Bakaner B.O','454446',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129470,465,'Bakhatgarh B.O','454660',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129471,465,'Balendi B.O','454441',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129472,465,'Balipur B.O','454446',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129473,465,'Baloda B.O','454660',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129474,465,'Balwari B.O','454552',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129475,465,'Bamandakalan B.O','454665',1,0,'2022-03-04 19:27:02','2022-03-04 19:27:02'),(129476,465,'Bandedi B.O','454441',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129477,465,'Barda B.O','454446',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129478,465,'Barkheda B.O','454111',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129479,465,'Barmandal B.O','454111',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129480,465,'Bhainsola B.O','454660',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129481,465,'Bhangarh B.O','454116',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129482,465,'Bharudpur B.O','454552',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129483,465,'Bhatbamanda B.O','454665',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129484,465,'Bhavaniabujurg B.O','454552',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129485,465,'Bhavria B.O','454335',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129486,465,'Bhopawar B.O','454111',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129487,465,'Bidwal B.O','454665',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129488,465,'Bijur B.O','454001',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129489,465,'Bikhorn B.O','454552',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129490,465,'Bilda B.O','454446',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129491,465,'Biloda B.O','454001',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129492,465,'Bilodakhurd B.O','454010',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129493,465,'Bimrod B.O','454116',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129494,465,'Bohrala B.O','454449',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129495,465,'Bola B.O','454111',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129496,465,'Borud B.O','454446',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129497,465,'Chalni B.O','454441',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129498,465,'Chalnimata B.O','454116',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129499,465,'Chhadawad B.O','454116',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129500,465,'Chhayan B.O','454660',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129501,465,'Chhokla B.O','454665',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129502,465,'Chikhalda B.O','454335',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129503,465,'Chikhliya B.O','454001',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129504,465,'Chilur B.O','454001',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129505,465,'Chotya Balod B.O','454441',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129506,465,'Dahi B.O','454331',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129507,465,'Dahiwar B.O','454552',1,0,'2022-03-04 19:27:03','2022-03-04 19:27:03'),(129508,465,'Dasai B.O','454441',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129509,465,'Dattigaon B.O','454116',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129510,465,'Dedla B.O','454001',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129511,465,'Dehri B.O','454221',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129512,465,'Dehri Ghata Billod S.O','454773',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129513,465,'Deshwalia B.O','454335',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129514,465,'Dhamanda B.O','454441',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129515,465,'Dhamanna B.O','454660',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129516,465,'Dhamnod S.O','454552',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129517,465,'Dhani B.O','454552',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129518,465,'Dhar Collectorate S.O','454001',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129519,465,'Dhar H.O','454001',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129520,465,'Dharampuri S.O','454449',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129521,465,'Dharamrai B.O','454331',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129522,465,'Dholiya B.O','454331',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129523,465,'Dhulet B.O','454116',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129524,465,'Dighthan B.O','454773',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129525,465,'Dolana B.O','454660',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129526,465,'Dotrya B.O','454660',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129527,465,'Dudhi B.O','454552',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129528,465,'Ekalduna B.O','454773',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129529,465,'Ekalwara B.O','454446',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129530,465,'Gajgota B.O','454331',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129531,465,'Gajnod B.O','454665',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129532,465,'Gandhwani B.O','454446',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129533,465,'Gardawad B.O','454001',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129534,465,'Ghatbori B.O','454221',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129535,465,'Ghatgara B.O','454660',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129536,465,'Girvaniya B.O','454331',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129537,465,'Gujri B.O','454552',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129538,465,'Gulwa B.O','454001',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129539,465,'Gumanpura B.O','454116',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129540,465,'Gunawad B.O','454001',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129541,465,'Haldi B.O','454331',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129542,465,'Hatod B.O','454441',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129543,465,'Jajankhedi B.O','454446',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129544,465,'Jatpura B.O','454446',1,0,'2022-03-04 19:27:04','2022-03-04 19:27:04'),(129545,465,'Jeerabad B.O','454446',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129546,465,'Jetpura B.O','454001',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129547,465,'Jolana B.O','454111',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129548,465,'Jotpur B.O','454446',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129549,465,'Kachhawada B.O','454446',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129550,465,'Kachibadoda B.O','454660',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129551,465,'Kachorada B.O','454001',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129552,465,'Kadmal B.O','454335',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129553,465,'Kadod B.O','454665',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129554,465,'Kalibawdi B.O','454449',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129555,465,'Kalsada B.O','454001',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129556,465,'Kalsadkhurd B.O','454773',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129557,465,'Kalwani B.O','454446',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129558,465,'Kanwan S.O','454665',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129559,465,'Kapsi B.O','454331',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129560,465,'Karoli B.O','454446',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129561,465,'Keshvi B.O','454441',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129562,465,'Kesur B.O','454001',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129563,465,'Khalghat B.O','454552',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129564,465,'Khandigara B.O','454665',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129565,465,'Khandlai Jagir B.O','454446',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129566,465,'Khandwa B.O','454774',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129567,465,'Khareli B.O','454111',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129568,465,'Kheda B.O','454660',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129569,465,'Kherod B.O','454001',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129570,465,'Khiledi B.O','454441',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129571,465,'Khutpala B.O','454111',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129572,465,'Kod B.O','454665',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129573,465,'Konda B.O','454335',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129574,465,'Kotbidhota B.O','454001',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129575,465,'Kothada B.O','454449',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129576,465,'Kukshi S.O','454331',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129577,465,'Kundara B.O','454331',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129578,465,'Kunjrod B.O','454010',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129579,465,'Kunjrota B.O','454116',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129580,465,'Kunwarsi B.O','454774',1,0,'2022-03-04 19:27:05','2022-03-04 19:27:05'),(129581,465,'Kuradia B.O','454010',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129582,465,'Kuwad B.O','454446',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129583,465,'Labrawda B.O','454001',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129584,465,'Labriya B.O','454111',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129585,465,'Lebadchowki B.O','454773',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129586,465,'Ledgaon B.O','454111',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129587,465,'Limbol B.O','454335',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129588,465,'Lingwa B.O','454335',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129589,465,'Lohari B.O','454335',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129590,465,'Longsari B.O','454221',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129591,465,'Loni B.O','454331',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129592,465,'Luneherasadak B.O','454446',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129593,465,'Lunhera B.O','454010',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129594,465,'Lunherabujurg B.O','454449',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129595,465,'Manasa B.O','454001',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129596,465,'Manawar S.O','454446',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129597,465,'Mandlawada B.O','454774',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129598,465,'Mandu S.O','454010',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129599,465,'Mandvi B.O','454335',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129600,465,'Mirjapur B.O','454446',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129601,465,'Mohankheda B.O','454116',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129602,465,'Mohanpura B.O','454001',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129603,465,'Multhan B.O','454660',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129604,465,'Nagda B.O','454001',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129605,465,'Nagora B.O','454001',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129606,465,'Nagur B.O','454446',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129607,465,'Nalcha B.O','454001',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129608,465,'Nanoda B.O','454335',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129609,465,'Narmadanagar B.O','454335',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129610,465,'Narwali B.O','454116',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129611,465,'Nisarpur S.O','454335',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129612,465,'Padiyal B.O','454331',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129613,465,'Padlia B.O','454001',1,0,'2022-03-04 19:27:06','2022-03-04 19:27:06'),(129614,465,'Pagara B.O','454449',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129615,465,'Palwada B.O','454001',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129616,465,'Panchakwasa B.O','454660',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129617,465,'Panwa B.O','454446',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129618,465,'Phulgawdi B.O','454111',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129619,465,'Pipaldagadi B.O','454449',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129620,465,'Piparani B.O','454116',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129621,465,'Pipariapani B.O','454221',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129622,465,'Piplaj B.O','454552',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129623,465,'Pipli B.O','454446',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129624,465,'Piplia B.O','454335',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129625,465,'Pithampur III S.O','454774',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129626,465,'Pithampur S.O','454775',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129627,465,'Rajgarh (Dhar) S.O','454116',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129628,465,'Rajod B.O','454660',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129629,465,'Rantalab B.O','454446',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129630,465,'Ringnod B.O','454116',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129631,465,'Sadalpur B.O','454001',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129632,465,'Sagore B.O','454774',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129633,465,'Sagwal B.O','454441',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129634,465,'Sakalda B.O','454449',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129635,465,'Salkanpur B.O','454001',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129636,465,'Salwa B.O','454111',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129637,465,'Sandla B.O','454660',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129638,465,'Sarai B.O','454010',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129639,465,'Sardarpur S.O (Dhar)','454111',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129640,465,'Semalda B.O','454552',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129641,465,'Semlia B.O','454665',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129642,465,'Shergarh B.O','454665',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129643,465,'Singhana B.O','454446',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129644,465,'Sirsi B.O','454335',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129645,465,'Sodpur B.O','454010',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129646,465,'Sulawad B.O','454774',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129647,465,'Sultanpur B.O','454001',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129648,465,'Sundrel B.O','454552',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129649,465,'Susari B.O','454331',1,0,'2022-03-04 19:27:07','2022-03-04 19:27:07'),(129650,465,'Takraoda B.O','454441',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129651,465,'Talanpur B.O','454331',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129652,465,'Talwada B.O','454331',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129653,465,'Talwada B.O','454010',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129654,465,'Talwadi B.O','454331',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129655,465,'Tanda B.O','454221',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129656,465,'Tarapur B.O','454552',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129657,465,'Tawali B.O','454449',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129658,465,'Teesgaon B.O','454001',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129659,465,'Tilgara B.O','454660',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129660,465,'Timaichi B.O','454116',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129661,465,'Tirla B.O','454001',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129662,465,'Tirla B.O','454116',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129663,465,'Tonki B.O','454446',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129664,465,'Tornod B.O','454001',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129665,465,'Umarban B.O','454449',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129666,465,'Utawad B.O','454001',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129667,465,'Zirvi B.O','454449',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129668,466,'Ajawar B.O','481879',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129669,466,'Amani Piparia B.O','481879',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129670,466,'Amarpur B.O','481880',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129671,466,'Amera B.O','481879',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129672,466,'Bachchhargaon B.O','481882',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129673,466,'Badaigarh B.O','481990',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129674,466,'Bajag B.O','481882',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129675,466,'Bamni B.O','481778',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129676,466,'Barchha B.O','481879',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129677,466,'Bhaiswahi B.O','481880',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129678,466,'Bhusanda B.O','481884',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129679,466,'Bilgaon B.O','481990',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129680,466,'Bilgarha B.O','481885',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129681,466,'Bondar B.O','481882',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129682,466,'Bondar B.O','481884',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129683,466,'Chanda B.O','481882',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129684,466,'Chandrani B.O','481778',1,0,'2022-03-04 19:27:08','2022-03-04 19:27:08'),(129685,466,'Chandwahi B.O','481990',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129686,466,'Chhanta B.O','481880',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129687,466,'Chhapra B.O','481885',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129688,466,'Chhirpani B.O','481672',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129689,466,'Darri Mohgaon B.O','481879',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129690,466,'Deori Mal B.O','481880',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129691,466,'Dhamni B.O','481672',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129692,466,'Dhanwasi B.O','481880',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129693,466,'Dindori S.O (Dindori)','481880',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129694,466,'Duhania B.O','481879',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129695,466,'Dullopur B.O','481879',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129696,466,'Gadasarai S.O','481882',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129697,466,'Ghusia B.O','481879',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129698,466,'Ghutalwa B.O','481990',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129699,466,'Gopalpur B.O','481884',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129700,466,'Gorakhpur S.O','481884',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129701,466,'Guraiya B.O','481990',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129702,466,'Harratola B.O','481672',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129703,466,'Jadasurang B.O','481778',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129704,466,'Jamgaon B.O','481879',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129705,466,'Jhanki B.O','481884',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129706,466,'Jugdehi B.O','481884',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129707,466,'Junwani B.O','481778',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129708,466,'Kachhari B.O','481990',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129709,466,'Kachharimal B.O','481990',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129710,466,'Kamrasoda B.O','481880',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129711,466,'Kanheri B.O','481990',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129712,466,'Karanjia B.O','481884',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129713,466,'Karondi B.O','481990',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129714,466,'Kathotiya B.O','481672',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129715,466,'Khargahna B.O','481882',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129716,466,'Khutia B.O','481778',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129717,466,'Kisalpuri B.O','481880',1,0,'2022-03-04 19:27:09','2022-03-04 19:27:09'),(129718,466,'Kohani Deori B.O','481990',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129719,466,'Kukarramath B.O','481880',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129720,466,'Lalpur B.O','481882',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129721,466,'Madiyaras B.O','481880',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129722,466,'Majhiyakhar B.O','481882',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129723,466,'Manikpur B.O','481990',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129724,466,'Margaon B.O','481778',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129725,466,'Marwari B.O','481879',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129726,466,'Matiyari B.O','481672',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129727,466,'Mehadwani B.O','481672',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129728,466,'Mendakhar B.O','481884',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129729,466,'Mohtara B.O','481882',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129730,466,'Mudki B.O','481880',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129731,466,'Newsapondi B.O','481880',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129732,466,'Nighori B.O','481778',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129733,466,'Padariya Kala B.O','481880',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129734,466,'Parapani B.O','481672',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129735,466,'Parsel B.O','481884',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129736,466,'Patangarh B.O','481884',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129737,466,'Piparia Kasturi B.O','481990',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129738,466,'Rai B.O','481672',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129739,466,'Raipura B.O','481990',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129740,466,'Raitwar B.O','481884',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129741,466,'Rampuri B.O','481879',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129742,466,'Raypura B.O','481880',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129743,466,'Rusha Raitwar B.O','481884',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129744,466,'Sakka B.O','481880',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129745,466,'Salheghori B.O','481778',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129746,466,'Samnapur S.O','481778',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129747,466,'Sangrampur B.O','481990',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129748,466,'Sarasdoli B.O','481672',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129749,466,'Sarastal B.O','481879',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129750,466,'Shahpur S.O (Dindori)','481879',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129751,466,'Shahpura Niwas S.O','481990',1,0,'2022-03-04 19:27:10','2022-03-04 19:27:10'),(129752,466,'Sigholi Mohgaon B.O','481778',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129753,466,'Silhari B.O','481879',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129754,466,'Simariya B.O','481880',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129755,466,'Sukulpura B.O','481882',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129756,466,'Tendumer Mohtara B.O','481879',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129757,466,'Thonda B.O','481990',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129758,466,'Tikari Pipari B.O','481879',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129759,466,'Vikrampur B.O','481879',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129760,467,'Aabud B.O','450337',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129761,467,'Ahmedpur Khaigaon B.O','450001',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129762,467,'Ambada B.O','450331',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129763,467,'Anand Nagar S.O (East Nimar)','450001',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129764,467,'Arud B.O','450661',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129765,467,'Asirgarh B.O','450331',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129766,467,'Attar B.O','450551',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129767,467,'Atud B.O','450551',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129768,467,'Aulia B.O','450661',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129769,467,'Awliya B.O','450117',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129770,467,'Badgaon Gujar B.O','450001',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129771,467,'Badgaon Mali B.O','450001',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129772,467,'Bagmar B.O','450001',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129773,467,'Bahadarpur B.O','451441',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129774,467,'Bahadarpur B.O','450331',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129775,467,'Balwada B.O','450881',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129776,467,'Bamanda B.O','450881',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129777,467,'Bangarda B.O','450551',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129778,467,'Barud B.O','450116',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129779,467,'Barud B.O','450771',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129780,467,'Basad B.O','450331',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129781,467,'Bhaganwa B.O','450117',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129782,467,'Bhagwanpura B.O','450110',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129783,467,'Bhagwanpura B.O','450051',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129784,467,'Bhakrada B.O','450991',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129785,467,'Bhamgarh B.O','450001',1,0,'2022-03-04 19:27:11','2022-03-04 19:27:11'),(129786,467,'Bhawasa B.O','450445',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129787,467,'Bhojakhedi B.O','450771',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129788,467,'Bilud B.O','450661',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129789,467,'Bir S.O (East Nimar)','450110',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129790,467,'Biroda B.O','450331',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129791,467,'Boradi B.O','450551',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129792,467,'Borgaon Bujurg B.O','450337',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129793,467,'Borgaon Khurd B.O','450001',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129794,467,'Bori Bujurg B.O','450331',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129795,467,'Borisaray B.O','450116',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129796,467,'Borkheda Kalan B.O','450110',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129797,467,'Borkheda Singaji B.O','450110',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129798,467,'Burhanpur R.S. S.O','450331',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129799,467,'Burhanpur Rajpura S.O','450331',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129800,467,'Burhanpur S.O','450331',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129801,467,'Chandani B.O','450221',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129802,467,'Chhegaon Makhan S.O','450771',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129803,467,'Chirwel B.O','450771',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129804,467,'Dabhi B.O','450661',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129805,467,'Dabhiyakheda B.O','450221',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129806,467,'Dapora B.O','450445',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129807,467,'Dargah-e-hakimi B.O','450331',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129808,467,'Daryapur B.O','450331',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129809,467,'Dedtalai B.O','450332',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129810,467,'Deola B.O','450001',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129811,467,'Deshgaon B.O','450771',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129812,467,'Devalikalan B.O','450051',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129813,467,'Dhamangaon B.O','450445',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129814,467,'Dhangaon B.O','450551',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129815,467,'Dharampuri B.O','450001',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129816,467,'Dhawadi B.O','450117',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129817,467,'Dhulkot B.O','450331',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129818,467,'Diwal B.O','450661',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129819,467,'Doifodia B.O','450331',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129820,467,'Dongargaon B.O','450001',1,0,'2022-03-04 19:27:12','2022-03-04 19:27:12'),(129821,467,'Gadbadi B.O','450116',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129822,467,'Gandhwa B.O','450881',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129823,467,'Ganesh Talai Khandwa S.O','450001',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129824,467,'Ghagharla B.O','450221',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129825,467,'Ghaspura Khandwa S.O','450001',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129826,467,'Ghoghalgaon B.O','450551',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129827,467,'Goradiya B.O','450661',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129828,467,'Gudi B.O','450881',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129829,467,'Gujarkhedi B.O','450114',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129830,467,'Gulai B.O','450331',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129831,467,'Gulai B.O','450117',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129832,467,'Gulgaon Raiyat B.O','450112',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129833,467,'Haidarpur B.O','450221',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129834,467,'Haraswada B.O','450771',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129835,467,'Hasinabad B.O','450331',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129836,467,'Ichhapur B.O','450445',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129837,467,'Indhawadi B.O','450114',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129838,467,'Jainabad B.O','450331',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129839,467,'Jaitapur B.O','450116',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129840,467,'Jalwa Bujurg B.O','450112',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129841,467,'Jamkota B.O','450112',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129842,467,'Jamnapur B.O','450117',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129843,467,'Jasondi B.O','450331',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129844,467,'Jaswadi S.O','450881',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129845,467,'Jawar S.O (East Nimar)','450991',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129846,467,'Kalamkhurd B.O','450117',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129847,467,'Kalmukhi B.O','450551',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129848,467,'Karpur B.O','450881',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129849,467,'Kehlari B.O','450991',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129850,467,'Kelwakhurd B.O','450114',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129851,467,'Kesun B.O','450551',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129852,467,'Khalwa S.O','450117',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129853,467,'Khamni B.O','450445',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129854,467,'Khandwa H.O','450001',1,0,'2022-03-04 19:27:13','2022-03-04 19:27:13'),(129855,467,'Khandwa Ratagarh S.O','450001',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129856,467,'Kharkalan S.O','450051',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129857,467,'Kharwa B.O','450661',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129858,467,'Khatla B.O','450661',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129859,467,'Khedi B.O','450001',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129860,467,'Khidgaon B.O','450881',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129861,467,'Khirala B.O','450337',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129862,467,'Khokaria B.O','450117',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129863,467,'Khutla B.O','450551',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129864,467,'Kohdar B.O','450001',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129865,467,'Kolgaon B.O','450991',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129866,467,'Kondawat B.O','450771',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129867,467,'Kotha B.O','450117',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129868,467,'Kukshi Raiyat B.O','450116',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129869,467,'Kumtha B.O','450881',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129870,467,'Lahadpur B.O','450116',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129871,467,'Loni B.O','450331',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129872,467,'Mahalgurada B.O','450331',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129873,467,'Malgaon B.O','450551',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129874,467,'Malud B.O','450116',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129875,467,'Mandla B.O','450991',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129876,467,'Manjrodkala B.O','450332',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129877,467,'Matpur B.O','450551',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129878,467,'Mitawal B.O','450661',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129879,467,'Mohad B.O','450445',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129880,467,'Mohana B.O','450551',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129881,467,'Mokalgaon B.O','450771',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129882,467,'Mortakka B.O','450554',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129883,467,'Mundi S.O','450112',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129884,467,'Nachankheda B.O','450445',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129885,467,'Nagjhiri B.O','450332',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129886,467,'Nagotar B.O','450117',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129887,467,'Narmada Nagar S.O (East Nimar)','450119',1,0,'2022-03-04 19:27:14','2022-03-04 19:27:14'),(129888,467,'Naya Harsud S.O','450116',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129889,467,'Nazarpura B.O','450116',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129890,467,'Netangaon B.O','450551',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129891,467,'Nimbola B.O','450331',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129892,467,'Nishania B.O','450116',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129893,467,'Padawa Khandwa B.O','451115',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129894,467,'Padlya B.O','450001',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129895,467,'Padlya B.O','450117',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129896,467,'Palasur B.O','450221',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129897,467,'Pandhana S.O','450661',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129898,467,'Paretha B.O','450332',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129899,467,'Patajan B.O','450117',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129900,467,'Patonda B.O','450331',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129901,467,'Phiphari B.O','450117',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129902,467,'Phophanar B.O','450445',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129903,467,'Pipalpani B.O','450332',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129904,467,'Piplani B.O','450116',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129905,467,'Piplod B.O','450881',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129906,467,'Piplya Tahar B.O','450001',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129907,467,'Punasa S.O','450114',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129908,467,'Purani B.O','450112',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129909,467,'Raitalai B.O','450332',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129910,467,'Rajgadh B.O','450881',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129911,467,'Rajur B.O','450001',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129912,467,'Rangaon B.O','450991',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129913,467,'Rohini B.O','450991',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129914,467,'Roshiya B.O','450771',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129915,467,'Roshni B.O','450117',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129916,467,'Rustampur S.O','450337',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129917,467,'Sahejla B.O','450991',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129918,467,'Saiyadpur B.O','450337',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129919,467,'Sangrampur B.O','450445',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129920,467,'Sanvkheda B.O','450991',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129921,467,'Sarola B.O','450331',1,0,'2022-03-04 19:27:15','2022-03-04 19:27:15'),(129922,467,'Selda B.O','450991',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129923,467,'Sendhwal B.O','450117',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129924,467,'Shahbazar Burhanpur S.O','450331',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129925,467,'Sheikhpur B.O','450332',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129926,467,'Sheikhpura B.O','450332',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129927,467,'Sihada B.O','450001',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129928,467,'Sindhkhal B.O','450112',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129929,467,'Singot B.O','450881',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129930,467,'Sirpur B.O','450331',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129931,467,'Sirpur B.O','450051',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129932,467,'Sirra B.O','450771',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129933,467,'Sirsod B.O','450771',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129934,467,'Siwal B.O','450221',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129935,467,'Somgaon B.O','450110',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129936,467,'Somgaon B.O','450116',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129937,467,'Sonkhedi B.O','450116',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129938,467,'Suktanagar B.O','450337',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129939,467,'Sukva B.O','450051',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129940,467,'Sulgaon B.O','450551',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129941,467,'Sunderdev B.O','450117',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129942,467,'Surgaonjoshi B.O','450771',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129943,467,'Taklikalan B.O','450001',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129944,467,'Taklimori B.O','450771',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129945,467,'Temi Kalan B.O','450001',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129946,467,'Temi Khurd B.O','450001',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129947,467,'Tukaithad B.O','450332',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129948,467,'Turakgurada B.O','450445',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129949,467,'Vidhya Nagar Khandwa S.O','450001',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129950,468,'Aroun S.O','473101',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129951,468,'Ashoknagar H.O','473331',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129952,468,'Awan B.O','473226',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129953,468,'Babrikheda B.O','473105',1,0,'2022-03-04 19:27:16','2022-03-04 19:27:16'),(129954,468,'Badi Ukawad B.O','473287',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129955,468,'Bajranggarh S.O','473249',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129956,468,'Bamori S.O','473105',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129957,468,'Baneh B.O','473105',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129958,468,'Bapcha Lahriya B.O','473115',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129959,468,'Barkheda Gird B.O','473249',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129960,468,'Barkheda Khurd B.O','473115',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129961,468,'Barkhrda Hat B.O','473101',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129962,468,'Barod B.O','473222',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129963,468,'Barsat B.O','473287',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129964,468,'Bataoda B.O','473222',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129965,468,'Bhador B.O','473101',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129966,468,'Bhadora B.O','473113',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129967,468,'Bhamawad B.O','473111',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129968,468,'Binaganj S.O','473115',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129969,468,'Bishanwada B.O','473105',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129970,468,'Chachauda S.O','473118',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129971,468,'Dehri Kala B.O','473101',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129972,468,'Dhamnar B.O','473113',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129973,468,'Dharnawda B.O','473110',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129974,468,'Dongar Motipur B.O','473287',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129975,468,'Dongar Vijaypur B.O','473111',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129976,468,'Dorana B.O','473110',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129977,468,'Fatehgarh B.O','473105',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129978,468,'Gaduli B.O','473443',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129979,468,'Gail Complex S.O','473112',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129980,468,'Gaori B.O','473287',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129981,468,'Garha B.O','473105',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129982,468,'Gehunkheda B.O','473249',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129983,468,'Ghatavda B.O','473101',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129984,468,'Guna Bazar S.O','473001',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129985,468,'Guna Cantt S.O','473001',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129986,468,'Guna City S.O','473001',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129987,468,'Guna Collectorate S.O','473001',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129988,468,'Guna H.O','473001',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129989,468,'Gunheru B.O','473443',1,0,'2022-03-04 19:27:17','2022-03-04 19:27:17'),(129990,468,'Hamirpur B.O','473105',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(129991,468,'Haripur B.O','473001',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(129992,468,'Hinotia B.O','473113',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(129993,468,'Jamner B.O','473287',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(129994,468,'Jangru B.O','473287',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(129995,468,'Jhagar B.O','473105',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(129996,468,'Jhajhon B.O','473101',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(129997,468,'Johri B.O','473105',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(129998,468,'Kapasi B.O','473105',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(129999,468,'Khamkheda B.O','473101',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(130000,468,'Khejra B.O','473001',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(130001,468,'Kherai B.O','473226',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(130002,468,'Khiriya Dangi B.O','473101',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(130003,468,'Khutiyawad B.O','473113',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(130004,468,'Konya Kala B.O','473115',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(130005,468,'Kotra B.O','473115',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(130006,468,'Kumbhraj S.O','473222',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(130007,468,'Kushepur B.O','473105',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(130008,468,'Lakhanwas B.O','473115',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(130009,468,'Magrana B.O','473113',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(130010,468,'Magroda B.O','473105',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(130011,468,'Maksudangarh S.O','473287',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(130012,468,'Markimahu B.O','473105',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(130013,468,'Masidpur B.O','473101',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(130014,468,'Mawan B.O','473001',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(130015,468,'Mrigwas B.O','473222',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(130016,468,'Mudra Khurd B.O','473101',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(130017,468,'Mudra Mata B.O','473101',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(130018,468,'Muhalpur B.O','473249',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(130019,468,'Muradpur B.O','473110',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(130020,468,'Murela B.O','473115',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(130021,468,'Myana S.O','473113',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(130022,468,'N.F.L.Vijaipur S.O','473111',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(130023,468,'Nasirpur B.O','473287',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(130024,468,'Nehgawa B.O','473113',1,0,'2022-03-04 19:27:18','2022-03-04 19:27:18'),(130025,468,'Padon B.O','473105',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130026,468,'Pagara B.O','473001',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130027,468,'Panwari Hat B.O','473101',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130028,468,'Paranth B.O','473105',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130029,468,'Parkana B.O','473287',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130030,468,'Parwah B.O','473105',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130031,468,'Patondi B.O','473115',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130032,468,'Penchi B.O','473115',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130033,468,'Raghogarh S.O','473226',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130034,468,'Ramdi B.O','473115',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130035,468,'Ramgir Kala B.O','473101',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130036,468,'Ramnagar B.O','473105',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130037,468,'Ramnagar B.O','473226',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130038,468,'Rampur B.O','473105',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130039,468,'Rampur B.O','473101',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130040,468,'Rampurcolony B.O','473105',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130041,468,'Rani Khejra B.O','473115',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130042,468,'Raosar Jagir B.O','473885',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130043,468,'Ruthiyai S.O','473110',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130044,468,'Saleh B.O','473101',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130045,468,'Sanai B.O','473222',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130046,468,'Satanpur B.O','473249',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130047,468,'Sehrog B.O','473101',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130048,468,'Shahpur B.O','473287',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130049,468,'Sirsi B.O','473105',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130050,468,'Sonkhara B.O','473105',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130051,468,'Teligaon B.O','473115',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130052,468,'Todra B.O','473287',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130053,468,'Torai B.O','473287',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130054,468,'Ukawad B.O','473113',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130055,468,'Umarthana B.O','473118',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130056,468,'Umri B.O','473113',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130057,468,'Vijaypur B.O','473111',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130058,469,'AB VIII TM Gwalior S.O','474015',1,0,'2022-03-04 19:27:19','2022-03-04 19:27:19'),(130059,469,'Airaya B.O','475001',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130060,469,'Ajaypur B.O','474001',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130061,469,'Akbai B.O','475005',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130062,469,'Amrol B.O','475001',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130063,469,'Antri S.O (Gwalior)','475001',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130064,469,'Aron B.O','475330',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130065,469,'Badagaon B.O','474006',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130066,469,'Badagaon B.O','475330',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130067,469,'Badera Bujurg B.O','475115',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130068,469,'Badori B.O','475001',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130069,469,'Bagwai B.O','475220',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130070,469,'Bahadurpur B.O','474020',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130071,469,'Bajna B.O','475220',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130072,469,'Bandholi B.O','474006',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130073,469,'Banwar B.O','475001',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130074,469,'Barai B.O','475330',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130075,469,'Baraua B.O','474005',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130076,469,'Barki Sarai B.O','475001',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130077,469,'Baroni Datia S.O','475686',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130078,469,'Barotha B.O','475110',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130079,469,'Behat S.O (Gwalior)','475002',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130080,469,'Beru B.O','475005',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130081,469,'Bhadroli B.O','474005',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130082,469,'Bhageh B.O','475115',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130083,469,'Bhagour B.O','475686',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130084,469,'Bhangna B.O','475110',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130085,469,'Bhensnari B.O','475110',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130086,469,'Bhitarwar S.O','475220',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130087,469,'Bhori B.O','475001',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130088,469,'Bijoli B.O','474006',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130089,469,'Bilhati Kalan B.O','474006',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130090,469,'Billowa B.O','475001',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130091,469,'Birla Nagar S.O','474004',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130092,469,'Chandpur B.O','475110',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130093,469,'Chhimak B.O','475110',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130094,469,'Chinore B.O','475110',1,0,'2022-03-04 19:27:20','2022-03-04 19:27:20'),(130095,469,'Chirpura B.O','475001',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130096,469,'Chiruli B.O','475005',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130097,469,'Collectorate S.O (Gwalior)','474001',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130098,469,'Dabka B.O','475002',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130099,469,'Dabka B.O','475330',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130100,469,'Dabra Gaon B.O','475110',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130101,469,'Dabra S.O','475110',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130102,469,'Dabra Tehsil S.O','475110',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130103,469,'Darpan Colony Gwalior S.O','474011',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130104,469,'Defence Colony S.O (Gwalior)','474002',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130105,469,'Deori B.O','475220',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130106,469,'Dharamshala [D.D. Nagar] S.O','474005',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130107,469,'Dhuan B.O','475330',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130108,469,'Dorar B.O','475330',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130109,469,'Dubha B.O','475220',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130110,469,'Gadajar B.O','475220',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130111,469,'Gharsondi B.O','475110',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130112,469,'Ghatigaon B.O','475330',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130113,469,'Gijjora B.O','475115',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130114,469,'Girgaon B.O','474020',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130115,469,'Gohinda B.O','475220',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130116,469,'Gwalior City S.O','474003',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130117,469,'Gwalior Fort S.O','474008',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130118,469,'Gwalior R.S. S.O','474002',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130119,469,'Gwalior Residency S.O','474005',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130120,469,'Harsi B.O','475220',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130121,469,'Hastinapur B.O','475002',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130122,469,'Hathnora B.O','475115',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130123,469,'Hazira Chowk S.O','474003',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130124,469,'I.P.S Gwalior B.O','474001',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130125,469,'Industrial Estate Gwalior S.O','474002',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130126,469,'Itm B.O','474001',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130127,469,'Itma B.O','475220',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130128,469,'J.A. Hospital S.O','474009',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130129,469,'Jaderuakalan B.O','474006',1,0,'2022-03-04 19:27:21','2022-03-04 19:27:21'),(130130,469,'Jakhara B.O','475002',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130131,469,'Jakhoda B.O','475330',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130132,469,'Jamahar B.O','474005',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130133,469,'Janak Ganj S.O','474001',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130134,469,'Janaktal B.O','474001',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130135,469,'Jhadoli B.O','475220',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130136,469,'Jigsoli B.O','474010',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130137,469,'Jiwaji Ganj B.O','474001',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130138,469,'Jiwaji University S.O','474011',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130139,469,'Jorasi B.O','475001',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130140,469,'K.P. Colony S.O','474002',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130141,469,'Kachhaua B.O','475001',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130142,469,'Kalyani B.O','475005',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130143,469,'Kampoo S.O','474001',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130144,469,'Karahi B.O','475330',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130145,469,'Karahiya B.O','475220',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130146,469,'Kariyawati B.O','475220',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130147,469,'Kerua B.O','475220',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130148,469,'Kethoda B.O','475115',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130149,469,'Kheda B.O','475220',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130150,469,'Khediraimal B.O','475110',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130151,469,'Kitora B.O','475115',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130152,469,'Kuleth B.O','474010',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130153,469,'Ladhera B.O','475001',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130154,469,'Ladhwaya B.O','475005',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130155,469,'Lala Ka Bazar B.O','474001',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130156,469,'Lashkar City S.O','474009',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130157,469,'Lashkar H.O','474001',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130158,469,'Laxmiganj  Mandi B.O','474010',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130159,469,'Maharajpura A.F. S.O','474020',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130160,469,'Maharajpura B.O','475110',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130161,469,'Mastura B.O','475220',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130162,469,'Mauchh B.O','475001',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130163,469,'Mena B.O','475110',1,0,'2022-03-04 19:27:22','2022-03-04 19:27:22'),(130164,469,'Mohan Garh B.O','475220',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130165,469,'Mohna S.O','475330',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130166,469,'Morar H.O','474006',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130167,469,'Morar Town S.O','474006',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130168,469,'Moti Jheel S.O','474010',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130169,469,'Moti Mahal S.O','474007',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130170,469,'Mudia Pahad B.O','474001',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130171,469,'Naya Bazar S.O (Gwalior)','474009',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130172,469,'Naya Sarafa S.O','474001',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130173,469,'Nayagaon B.O','475330',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130174,469,'New High Court S.O','474011',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130175,469,'Odhpura B.O','474010',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130176,469,'Panihar B.O','475330',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130177,469,'Par B.O','475001',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130178,469,'Parsen B.O','474006',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130179,469,'Patai B.O','475330',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130180,469,'Phalka Bazar S.O','474009',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130181,469,'Pichhore Gird S.O','475115',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130182,469,'Piprua B.O','475110',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130183,469,'Purani Chhawani B.O','474010',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130184,469,'Putti B.O','475115',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130185,469,'R.B. Colony Gwalior S.O','474002',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130186,469,'R.K Puri Gwalior S.O','474011',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130187,469,'Rahi B.O','475220',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130188,469,'Rangawan B.O','475002',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130189,469,'Ratwai B.O','474006',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130190,469,'Renhat B.O','475330',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130191,469,'Richharikalan B.O','475220',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130192,469,'Rora B.O','475001',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130193,469,'S.P. Ashram S.O','474012',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130194,469,'Sabrai B.O','475330',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130195,469,'Salwai B.O','475110',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130196,469,'Samaya B.O','475110',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130197,469,'Sankhini B.O','475220',1,0,'2022-03-04 19:27:23','2022-03-04 19:27:23'),(130198,469,'Senthri B.O','474020',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130199,469,'Shakti Nagar S.O (Gwalior)','474002',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130200,469,'Shankarpur B.O','474010',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130201,469,'Shinde Ki Chhawani S.O','474001',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130202,469,'Shukalhari B.O','475115',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130203,469,'Sigora B.O','474010',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130204,469,'Simaria Tal B.O','475110',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130205,469,'Simariatanka B.O','475330',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130206,469,'Singharan B.O','475220',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130207,469,'Sirsod B.O','474006',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130208,469,'Sukhapatha B.O','475115',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130209,469,'Supaoli B.O','474006',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130210,469,'Susera B.O','474005',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130211,469,'Tankoli B.O','475002',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130212,469,'Tekanpur S.O','475005',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130213,469,'Tighra B.O','474001',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130214,469,'Tiholi B.O','475002',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130215,469,'Tilak Nagar B.O','474001',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130216,469,'Ummegarh B.O','475330',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130217,469,'Urba B.O','475001',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130218,469,'Utila B.O','474006',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130219,469,'V.N. Marg S.O','474001',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130220,469,'Wahangikhurd B.O','474006',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130221,470,'Bhadugaon B.O','461228',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130222,470,'Charkheda B.O','461228',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130223,470,'Charuwa B.O','461441',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130224,470,'Chhepaner B.O','461228',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130225,470,'Chhidgaon B.O','461228',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130226,470,'Chhipawad B.O','461441',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130227,470,'Harda R.S. S.O','461331',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130228,470,'Harda S.O','461331',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130229,470,'Jhardpa B.O','461228',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130230,470,'Jiggaonkhurd B.O','461228',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130231,470,'Kheda B.O','461111',1,0,'2022-03-04 19:27:24','2022-03-04 19:27:24'),(130232,470,'Khirkiyan R.S. S.O','461441',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130233,470,'Kp Harda S.O','461331',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130234,470,'Magardha B.O','461228',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130235,470,'Nandara B.O','461331',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130236,470,'Nayagaon B.O','461228',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130237,470,'Pantalai B.O','461228',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130238,470,'Phokharni B.O','461441',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130239,470,'Pokhrani B.O','461228',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130240,470,'Pratapura B.O','461441',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130241,470,'Ptc Harda S.O','461331',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130242,470,'Rahatgaon B.O','461228',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130243,470,'Ramtek B.O','461441',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130244,470,'Samardha B.O','461228',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130245,470,'Sirali B.O','461331',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130246,470,'Tajpur B.O','461228',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130247,470,'Temlawadi B.O','461441',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130248,470,'Timarni S.O','461228',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130249,471,'Aari B.O','461661',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130250,471,'Adampur B.O','461331',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130251,471,'Anchalkheda B.O','461661',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130252,471,'Anhai B.O','461990',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130253,471,'Archnagaon B.O','461223',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130254,471,'Avgaonkala B.O','461331',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130255,471,'B.Jamani B.O','461223',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130256,471,'Babadiabhau B.O','461223',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130257,471,'Babai S.O (Hoshangabad)','461661',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130258,471,'Babri B.O','461221',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130259,471,'Bachawani B.O','461990',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130260,471,'Bachwada B.O','461661',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130261,471,'Bagda Tawa B.O','461111',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130262,471,'Baghwara B.O','461221',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130263,471,'Baharpur B.O','461668',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130264,471,'Baikhedi B.O','461001',1,0,'2022-03-04 19:27:25','2022-03-04 19:27:25'),(130265,471,'Bajania B.O','461228',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130266,471,'Bajjarwada B.O','461661',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130267,471,'Bakabedi B.O','461223',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130268,471,'Balagaon B.O','461331',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130269,471,'Bamhangaon B.O','461116',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130270,471,'Banapura S.O','461221',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130271,471,'Bankhedi Reva B.O','461771',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130272,471,'Bankhedi S.O','461990',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130273,471,'Bedi B.O','461331',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130274,471,'Bediakala B.O','461441',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130275,471,'Beekor B.O','461661',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130276,471,'Bhainsadeh B.O','461223',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130277,471,'Bhamedi Dev B.O','461221',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130278,471,'Bharlay B.O','461223',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130279,471,'Bharonpur B.O','461223',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130280,471,'Bhatgaon B.O','461771',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130281,471,'Bhatti B.O','461115',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130282,471,'Bhiladia B.O','461221',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130283,471,'Bhilakhedi B.O','461115',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130284,471,'Bhokhedi Kala B.O','461771',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130285,471,'Bhunnas B.O','461331',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130286,471,'Bichhapur B.O','461228',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130287,471,'Bichuwa B.O','461111',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130288,471,'Bisonikala B.O','461223',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130289,471,'Budhni B.O','461661',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130290,471,'Chandon B.O','461111',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130291,471,'Chandon B.O','461990',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130292,471,'Chaplasar B.O','461001',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130293,471,'Chatarkheda B.O','461221',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130294,471,'Chokwdi B.O','461441',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130295,471,'Chotlay B.O','461221',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130296,471,'Chourahet B.O','461668',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130297,471,'Cpe Itarsi S.O','461114',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130298,471,'Dandiwada B.O','461111',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130299,471,'Dangarhai B.O','461990',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130300,471,'Datwasa B.O','461221',1,0,'2022-03-04 19:27:26','2022-03-04 19:27:26'),(130301,471,'Dawakhurd B.O','461116',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130302,471,'Deepgaon B.O','461441',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130303,471,'Dhanwara B.O','461441',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130304,471,'Dhikwada B.O','461771',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130305,471,'Dolaria S.O','461116',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130306,471,'Doomer B.O','461990',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130307,471,'Fatehpur B.O','461990',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130308,471,'Gahal B.O','461331',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130309,471,'Gajpur B.O','461111',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130310,471,'Ganera B.O','461661',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130311,471,'Garhaghat B.O','461775',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130312,471,'Ghatli B.O','461111',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130313,471,'Gondalwara B.O','461990',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130314,471,'Gondgaonkala B.O','461228',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130315,471,'Goura B.O','461001',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130316,471,'Gujjarwada B.O','461661',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130317,471,'Gunora B.O','461001',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130318,471,'Guradia B.O','461223',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130319,471,'Gurra B.O','461111',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130320,471,'Handia B.O','461331',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130321,471,'Harda Khurd B.O','461331',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130322,471,'Hasalpur B.O','461001',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130323,471,'Hirankheda B.O','461221',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130324,471,'Hoshangabad City S.O','461001',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130325,471,'Hoshangabad H.O','461001',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130326,471,'Isharpur B.O','461990',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130327,471,'Itarsi S.O','461111',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130328,471,'Jamani B.O','461115',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130329,471,'Jasalapur B.O','461001',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130330,471,'Jawali B.O','461661',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130331,471,'Jhadbeeda B.O','461228',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130332,471,'Jhaklay B.O','461223',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130333,471,'Jinwania B.O','461331',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130334,471,'Jujharpur B.O','461111',1,0,'2022-03-04 19:27:27','2022-03-04 19:27:27'),(130335,471,'Junheta B.O','461990',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130336,471,'Kajal Khedi B.O','461661',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130337,471,'Kala Akhar B.O','461111',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130338,471,'Kalmeshra B.O','461771',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130339,471,'Kamtada B.O','461331',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130340,471,'Kamtee B.O','461771',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130341,471,'Kanhwar B.O','461990',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130342,471,'Karpa B.O','461990',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130343,471,'Kesla B.O','461111',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130344,471,'Khaglay B.O','461331',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130345,471,'Khaparkheda B.O','461775',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130346,471,'Khapriya B.O','461221',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130347,471,'Kherikala B.O','461775',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130348,471,'Khidia B.O','461775',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130349,471,'Khidia B.O','461661',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130350,471,'Kothra B.O','461223',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130351,471,'Kudabamafi B.O','461441',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130352,471,'Lodhdi B.O','461221',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130353,471,'Luchgaon B.O','461223',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130354,471,'Luharia B.O','461111',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130355,471,'Machha B.O','461775',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130356,471,'Machherakala B.O','461990',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130357,471,'Maf Babai B.O','461661',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130358,471,'Magrol B.O','461001',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130359,471,'Mahandgaon B.O','461331',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130360,471,'Makdai B.O','461331',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130361,471,'Malhanwara B.O','461990',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130362,471,'Malothar B.O','461115',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130363,471,'Managaon B.O','461111',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130364,471,'Mandla B.O','461441',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130365,471,'Mangalwara Piparia S.O','461775',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130366,471,'Maniakhedi B.O','461228',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130367,471,'Manwara B.O','461661',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130368,471,'Masangaon B.O','461331',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130369,471,'Matkuli B.O','461775',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130370,471,'Mehragaon B.O','461115',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130371,471,'Misrod B.O','461116',1,0,'2022-03-04 19:27:28','2022-03-04 19:27:28'),(130372,471,'Mohari B.O','461116',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130373,471,'Mokhalwara B.O','461775',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130374,471,'Mourgarhi B.O','461441',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130375,471,'N.S.Hoshangabad B.O','461001',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130376,471,'Naharkolakala B.O','461223',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130377,471,'Nandarwada B.O','461223',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130378,471,'Nimgaon B.O','461331',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130379,471,'Nimsadia B.O','461001',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130380,471,'Nosar B.O','461228',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130381,471,'NYC Itarsi S.O','461115',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130382,471,'Of Itarsi S.O','461446',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130383,471,'OFE Itarsi S.O','461122',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130384,471,'Pachlawara B.O','461775',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130385,471,'Pachmarhi Bazar S.O','461881',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130386,471,'Pachmarhi Cantt S.O','461881',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130387,471,'Pachmarhi S.O','461881',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130388,471,'Pagdhal B.O','461223',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130389,471,'Palasner B.O','461331',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130390,471,'Palia Pipria B.O','461990',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130391,471,'Pamli B.O','461668',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130392,471,'Panjara Kala B.O','461001',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130393,471,'Pathada B.O','461221',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130394,471,'Pathrota B.O','461111',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130395,471,'PB Itarsi S.O','461111',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130396,471,'Pipar Pani B.O','461990',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130397,471,'Piparia S.O','461775',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130398,471,'Piplia B.O','461331',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130399,471,'Pipliakala B.O','461223',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130400,471,'Pipliya Kala B.O','461551',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130401,471,'Posera B.O','461775',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130402,471,'Powarkheda S.O','461110',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130403,471,'PRtaku B.O','461111',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130404,471,'Punor B.O','461775',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130405,471,'Raipur B.O','461001',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130406,471,'Rampur B.O','461775',1,0,'2022-03-04 19:27:29','2022-03-04 19:27:29'),(130407,471,'Rampur B.O','461111',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130408,471,'Ranhai Kala B.O','461331',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130409,471,'Rehatwara B.O','461990',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130410,471,'Rehda B.O','461221',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130411,471,'Rehtakala B.O','461441',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130412,471,'Rehtakala B.O','461331',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130413,471,'Reshalpur B.O','461110',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130414,471,'Ridge Gaon B.O','461331',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130415,471,'Rohna B.O','461001',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130416,471,'Rolgaon B.O','461331',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130417,471,'Roopadeh B.O','461223',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130418,471,'Sadhpura B.O','461111',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130419,471,'Saheli B.O','461111',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130420,471,'Sahelwara B.O','461775',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130421,471,'Saket B.O','461111',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130422,471,'Samnapur B.O','461990',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130423,471,'Samon B.O','461661',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130424,471,'Sandia B.O','461775',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130425,471,'Sangakheda Kala B.O','461001',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130426,471,'Sangakhedakhurd B.O','461668',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130427,471,'Sankheda B.O','461111',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130428,471,'Satwasa B.O','461221',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130429,471,'Sawalkheda B.O','461001',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130430,471,'Semri Harchand S.O','461668',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130431,471,'Semri Khurd B.O','461116',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130432,471,'Semritala B.O','461775',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130433,471,'Seoni Malwa S.O','461223',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130434,471,'Shobhapur B.O','461771',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130435,471,'Shodalpur B.O','461228',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130436,471,'Shukkarwara B.O','461001',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130437,471,'Silwani B.O','461111',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130438,471,'Simrodha B.O','461668',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130439,471,'Singhodi B.O','461990',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130440,471,'Singhpur B.O','461990',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130441,471,'Sirwar B.O','461661',1,0,'2022-03-04 19:27:30','2022-03-04 19:27:30'),(130442,471,'Sivpur B.O','461223',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130443,471,'Sohagpur R.S. S.O','461771',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130444,471,'Somalwada B.O','461221',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130445,471,'Somgaonkala B.O','461441',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130446,471,'Son Talai B.O','461111',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130447,471,'Sonatalai B.O','461331',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130448,471,'Sp Mills Hoshangabad S.O','461005',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130449,471,'Sukhras B.O','461331',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130450,471,'Sukhtawa B.O','461111',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130451,471,'Surajganj Itarsi S.O','461111',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130452,471,'Surelakala B.O','461775',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130453,471,'Taku B.O','461111',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130454,471,'Tal Keshri B.O','461661',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130455,471,'Tamcharu B.O','461661',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130456,471,'Tangna B.O','461115',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130457,471,'Taronkala B.O','461775',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130458,471,'Tawa Nagar S.O','461551',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130459,471,'Teekhard B.O','461115',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130460,471,'Temagaon B.O','461228',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130461,471,'Tigria B.O','461116',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130462,471,'Tili Awnali B.O','461221',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130463,471,'Uda B.O','461331',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130464,471,'Umradha B.O','461990',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130465,472,'Army Head Quarter S.O','452006',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130466,472,'Bhagirath Pura B.O','452003',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130467,472,'Bijasan Road S.O','452005',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130468,472,'Chhota Bangarda B.O','452005',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130469,472,'Gurunanak Chauk S.O','452007',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130470,472,'Indore Cat S.O','452013',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130471,472,'Indore CGO Complex S.O','452001',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130472,472,'Indore City-2 S.O','452002',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130473,472,'Indore Cloth Market S.O','452002',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130474,472,'Indore Collectorate S.O','452007',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130475,472,'Indore Courts S.O','452007',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130476,472,'Indore DDU Nagar S.O','452010',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130477,472,'Indore G.P.O.','452001',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130478,472,'Indore Industrial Area S.O','452003',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130479,472,'Indore Kanadia Road S.O','452016',1,0,'2022-03-04 19:27:31','2022-03-04 19:27:31'),(130480,472,'Indore Khajrana S.O','452016',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130481,472,'Indore Kumar Khadi S.O','452015',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130482,472,'Indore Malwa Mill S.O','452003',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130483,472,'Indore Manorama Ganj S.O','452001',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130484,472,'Indore Nagar H.O','452007',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130485,472,'Indore Pardesipura S.O','452003',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130486,472,'Indore R.S.S.Nagar S.O','452011',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130487,472,'Indore Raj Mohalla S.O','452002',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130488,472,'Indore Ram Bagh S.O','452007',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130489,472,'Indore Siyaganj S.O','452007',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130490,472,'Indore Takshashila S.O','452001',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130491,472,'Indore Tillaknagar S.O','452018',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130492,472,'Indore Tukoganj S.O','452001',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130493,472,'Indore Uchchanyayalay S.O','452001',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130494,472,'Industrial Estate S.O (Indore)','452015',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130495,472,'Juni Indore S.O','452007',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130496,472,'Khatiwala Tank S.O','452014',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130497,472,'Lokmanya Nagar Indore S.O','452009',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130498,472,'Nanda Nagar S.O','452011',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130499,472,'Pagnispaga Indore S.O','452007',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130500,472,'Radio Colony Indore S.O','452001',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130501,472,'Rajendra Nagar S.O (Indore)','452012',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130502,472,'Sanwer Link Road Indore S.O','452010',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130503,472,'Sudama Nagar S.O','452009',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130504,472,'Vallabhnagar S.O (Indore)','452003',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130505,472,'Vijay Nagar S.O','452010',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130506,472,'Agra B.O','453115',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130507,472,'Ajnod B.O','453551',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130508,472,'Alwasa B.O','453111',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130509,472,'Ambachandan B.O','453441',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130510,472,'Attahada B.O','453115',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130511,472,'Atwada B.O','453001',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130512,472,'Aurangpura B.O','453001',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130513,472,'Bachhoda B.O','453220',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130514,472,'Badgonda B.O','453441',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130515,472,'Badodia Khan B.O','453551',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130516,472,'Bai B.O','453441',1,0,'2022-03-04 19:27:32','2022-03-04 19:27:32'),(130517,472,'Baloda Tkun B.O','453551',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130518,472,'Banadia B.O','453115',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130519,472,'Baoliakhurd B.O','452016',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130520,472,'Barlai Jagir B.O','453771',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130521,472,'Betma S.O','453001',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130522,472,'Bhagana B.O','453111',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130523,472,'Bhagora B.O','453441',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130524,472,'Bhatkhedi B.O','453441',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130525,472,'Bhilbadoli B.O','453220',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130526,472,'Bicholi Mardana B.O','452016',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130527,472,'Binawda B.O','453001',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130528,472,'Burankhedi B.O','452016',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130529,472,'Chadoda B.O','453220',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130530,472,'Chambal B.O','453220',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130531,472,'Chittoda B.O','453551',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130532,472,'Choral B.O','453441',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130533,472,'Chordia B.O','453441',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130534,472,'Dakachia B.O','453771',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130535,472,'Datoda B.O','452020',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130536,472,'Depalpur S.O','453115',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130537,472,'Dhannad B.O','453001',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130538,472,'Dharnaka B.O','453441',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130539,472,'Dudhia B.O','452016',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130540,472,'Farkodha B.O','453220',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130541,472,'FC Ganj B.O','453551',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130542,472,'Gandhinagar S.O (Indore)','453112',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130543,472,'Gautampura S.O','453220',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130544,472,'Gawlipalasia B.O','453441',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130545,472,'Girota B.O','453220',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130546,472,'Gokulpur B.O','453115',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130547,472,'Gujarkheda B.O','453441',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130548,472,'Guran B.O','453551',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130549,472,'Harsola B.O','453441',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130550,472,'Hasalpur B.O','453661',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130551,472,'Hatod S.O','453111',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130552,472,'IIM CAMPUS RAO S.O','453556',1,0,'2022-03-04 19:27:33','2022-03-04 19:27:33'),(130553,472,'Jalodiyagyan B.O','453220',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130554,472,'Jamburdi Sarwar B.O','453111',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130555,472,'Jamburdihapsi B.O','453112',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130556,472,'Jamli B.O','453441',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130557,472,'Jhalaria B.O','452016',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130558,472,'Jindakheda B.O','453551',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130559,472,'Joshiguradia B.O','452020',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130560,472,'Kachalia B.O','453551',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130561,472,'Kadwali Bujurg B.O','453771',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130562,472,'Kalaria B.O','453001',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130563,472,'Kallibillod B.O','453001',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130564,472,'Kalmer B.O','453111',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130565,472,'Kamadpur B.O','453661',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130566,472,'Kampel B.O','452020',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130567,472,'Kanadia B.O','452016',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130568,472,'Kankariapal B.O','453551',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130569,472,'Kanwasa B.O','453220',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130570,472,'Karadia B.O','453001',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130571,472,'Kasturbagram S.O','452020',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130572,472,'Kelod B.O','453441',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130573,472,'Kelodkartal B.O','452020',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130574,472,'Khedi Sihod B.O','453661',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130575,472,'Khudel B.O','452016',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130576,472,'Khurdi B.O','453661',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130577,472,'Kishanganj B.O','453441',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130578,472,'Kodria B.O','453441',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130579,472,'Kudana B.O','453551',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130580,472,'Lasudia B.O','453771',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130581,472,'Limbiodapar B.O','453115',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130582,472,'Machal B.O','453001',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130583,472,'Machla B.O','452020',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130584,472,'Maithwada B.O','453001',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130585,472,'Manglia S.O','453771',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130586,472,'Manpur S.O (Indore)','453661',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130587,472,'Men B.O','453441',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130588,472,'Mendakwasa B.O','453220',1,0,'2022-03-04 19:27:34','2022-03-04 19:27:34'),(130589,472,'Mhow Cantt S.O','453441',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130590,472,'Mhow Gaon B.O','453441',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130591,472,'Mhow Railway Stattion S.O','453441',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130592,472,'Mhow S.O','453441',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130593,472,'Murkheda B.O','453115',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130594,472,'Neori B.O','453115',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130595,472,'Palakhedi B.O','453112',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130596,472,'Palda B.O','452020',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130597,472,'Paliya B.O','453111',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130598,472,'Panod B.O','453771',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130599,472,'Paphund B.O','453661',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130600,472,'Pedmi B.O','452020',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130601,472,'Pigdamber B.O','453331',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130602,472,'Pipalda B.O','452020',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130603,472,'Piwdai B.O','452020',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130604,472,'Rajoda B.O','453551',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130605,472,'Rangwasa B.O','453001',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130606,472,'Rangwasa B.O','453331',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130607,472,'Rao S.O','453331',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130608,472,'Rasalpura S.O','453446',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130609,472,'Rolai B.O','453001',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130610,472,'Sagdod B.O','453001',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130611,472,'Sanawadia B.O','452016',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130612,472,'Sanwer S.O','453551',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130613,472,'Semlia Chau B.O','452016',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130614,472,'Shri Aurobindo S.O','453555',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130615,472,'Simrol B.O','452020',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130616,472,'Sivani B.O','452016',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130617,472,'Solsinda B.O','453551',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130618,472,'Sonway Bhensolay Audygik Kshet S.O','453332',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130619,472,'Sumtha B.O','453115',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130620,472,'Tihi B.O','453331',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130621,472,'Tillorbujurg B.O','452020',1,0,'2022-03-04 19:27:35','2022-03-04 19:27:35'),(130622,472,'Tillorkhurd B.O','452020',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130623,472,'Todi B.O','453771',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130624,472,'Umaria B.O','453331',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130625,472,'Yashwant Nagar B.O','453661',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130626,473,'Adhartal S.O','482004',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130627,473,'Agasaud B.O','482002',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130628,473,'Amahinota B.O','483053',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130629,473,'Amkhera B.O','482004',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130630,473,'Anand Nagar S.O (Jabalpur)','482004',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130631,473,'Archha B.O','482002',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130632,473,'Badhaiyakheda B.O','483113',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130633,473,'Badkheda B.O','483220',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130634,473,'Badkhera B.O','483110',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130635,473,'Baghraji B.O','482001',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130636,473,'Bai Ka Bagicha S.O','482001',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130637,473,'Bandhi B.O','483440',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130638,473,'Barbati B.O','482021',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130639,473,'Barela S.O','483001',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130640,473,'Bargi  IPC B.O','482008',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130641,473,'Bargi B.O','483225',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130642,473,'Bargi Nagar S.O','482056',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130643,473,'Bargi S.O','482051',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130644,473,'Baroda B.O','483220',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130645,473,'Baroda Chhedi B.O','483053',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130646,473,'Basendi B.O','483119',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130647,473,'Belkhadu B.O','482002',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130648,473,'Belkheda B.O','483119',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130649,473,'Bhaironghat Pipariya B.O','483119',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130650,473,'Bheeta B.O','483119',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130651,473,'Bheraghat S.O','483053',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130652,473,'Bhuwara B.O','483119',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130653,473,'Bilhari S.O','482020',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130654,473,'Boria B.O','483105',1,0,'2022-03-04 19:27:36','2022-03-04 19:27:36'),(130655,473,'Chargawan B.O','482003',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130656,473,'Chaurai Kala B.O','483110',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130657,473,'Chhaparhat B.O','483119',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130658,473,'Chhartarpur B.O','483220',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130659,473,'Dadargawan B.O','483110',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130660,473,'Dehri Khurd B.O','482001',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130661,473,'Deori Patpara B.O','483001',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130662,473,'Dhanpuri B.O','483001',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130663,473,'Dhanwahi B.O','482001',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130664,473,'Dharampura B.O','482003',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130665,473,'Dixitpura S.O','482002',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130666,473,'Engineering College S.O (Jabalpur)','482011',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130667,473,'Gadaghat B.O','483113',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130668,473,'Gadar Pipariya B.O','483119',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130669,473,'Gangai Badkheda B.O','482003',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130670,473,'Gangai Bijori B.O','482003',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130671,473,'Gangai Padaria B.O','482001',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130672,473,'Ganjipura S.O','482002',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130673,473,'Garha Bazar S.O','482003',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130674,473,'Garha Phatak S.O','482002',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130675,473,'Garha S.O (Jabalpur)','482003',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130676,473,'Gauraiyaghat B.O','482021',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130677,473,'Gauri B.O','483110',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130678,473,'Ghat Piparia B.O','482003',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130679,473,'Ghughara B.O','483110',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130680,473,'Gohalpur B.O','482002',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130681,473,'Gokulpur S.O','482011',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130682,473,'Gubra Kala B.O','483119',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130683,473,'Gun Shop S.O','482005',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130684,473,'Gupteshwar S.O','482001',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130685,473,'Gurandi Bazar S.O','482002',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130686,473,'Gwarighat B.O','482008',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130687,473,'H.R.Lines S.O','482001',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130688,473,'Hanumantal S.O','482002',1,0,'2022-03-04 19:27:37','2022-03-04 19:27:37'),(130689,473,'Harduli B.O','483110',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130690,473,'Harrai B.O','482051',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130691,473,'Hathital S.O','482001',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130692,473,'High Court S.O (Jabalpur)','482001',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130693,473,'Hinotia Bhoi B.O','483001',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130694,473,'Howbagh S.O','482001',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130695,473,'I.T.I. S.O','482002',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130696,473,'Imlai B.O','483220',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130697,473,'Imlai B.O','482001',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130698,473,'Jabalpur Cantt S.O','482001',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130699,473,'Jabalpur City S.O','482002',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130700,473,'Jabalpur Factory S.O','482011',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130701,473,'Jabalpur H.O','482001',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130702,473,'Jeewan Bima Nigam S.O','482001',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130703,473,'Jhiria B.O','483110',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130704,473,'Jhirmila B.O','483110',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130705,473,'Jonesganj S.O','482002',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130706,473,'Kailwas B.O','482021',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130707,473,'Kaladehi B.O','482051',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130708,473,'Kaladumar B.O','483220',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130709,473,'Kamala Nehru Nagar S.O','482002',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130710,473,'Kanchanpur S.O (Jabalpur)','482004',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130711,473,'Karmeta B.O','482002',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130712,473,'Kastara B.O','483110',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130713,473,'Kasturba Nagar S.O (Jabalpur)','482001',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130714,473,'Katangi S.O (Jabalpur)','483105',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130715,473,'Katra Belkheda B.O','483113',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130716,473,'Khairi B.O','483113',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130717,473,'Khajri B.O','482004',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130718,473,'Khamaria Market S.O','482005',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130719,473,'Khamaria Neemkheda B.O','482021',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130720,473,'Khamaria S.O (Jabalpur)','482005',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130721,473,'Khinni B.O','483222',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130722,473,'Khirahani B.O','483220',1,0,'2022-03-04 19:27:38','2022-03-04 19:27:38'),(130723,473,'Khukkham B.O','483001',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130724,473,'Konikala B.O','483113',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130725,473,'Kosam Dongari B.O','483110',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130726,473,'Kundam S.O','483110',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130727,473,'Kutchery S.O (Jabalpur)','482001',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130728,473,'Kymore S.O','483880',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130729,473,'Kymori B.O','483113',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130730,473,'Lac Lines S.O','482001',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130731,473,'Lamheta Ghat B.O','482003',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130732,473,'Lordganj S.O','482002',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130733,473,'Luhkari B.O','482001',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130734,473,'Magarmuha B.O','483119',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130735,473,'Maharajpur B.O','482004',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130736,473,'Majhita B.O','483053',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130737,473,'Mangela B.O','482002',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130738,473,'Mankedi B.O','483119',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130739,473,'Marha B.O','483225',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130740,473,'Medical College S.O (Jabalpur)','482003',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130741,473,'Miloniganj S.O','482002',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130742,473,'Mohas B.O','482051',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130743,473,'Mohniya B.O','483222',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130744,473,'Motinala S.O','482002',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130745,473,'Murrai B.O','483105',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130746,473,'Nagar Nigam S.O','482002',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130747,473,'Napier Lines S.O','482001',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130748,473,'Napier Town S.O','482001',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130749,473,'Natwara B.O','483119',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130750,473,'Nichi B.O','482003',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130751,473,'Nigri B.O','482051',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130752,473,'Nirandpur B.O','483105',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130753,473,'Nunsar B.O','483113',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130754,473,'Pachkuiyan B.O','482002',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130755,473,'Padaria B.O','483220',1,0,'2022-03-04 19:27:39','2022-03-04 19:27:39'),(130756,473,'Padwar B.O','483001',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130757,473,'Panagar S.O (Jabalpur)','483220',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130758,473,'Patan S.O (Jabalpur)','483113',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130759,473,'Pawla B.O','483119',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130760,473,'Perfect Pottories B.O','482008',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130761,473,'Pindrai Barha B.O','482021',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130762,473,'Piparia B.O','482001',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130763,473,'Polipahar S.O','482008',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130764,473,'Prem Nagar S.O (Jabalpur)','482001',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130765,473,'R.F.R.C. S.O','482021',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130766,473,'Raipura B.O','483220',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130767,473,'Ramkhiria B.O','483222',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130768,473,'Ramkhiria Thutha B.O','483119',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130769,473,'Rampuri Turka B.O','483110',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130770,473,'Ranjhi Azad Nagar S.O','482005',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130771,473,'Ranjhi S.O','482011',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130772,473,'Reewan B.O','482051',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130773,473,'Regimental Bazar S.O','482001',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130774,473,'Richhai S.O','482010',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130775,473,'Riyana B.O','483113',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130776,473,'Roberts Line S.O (Jabalpur)','482001',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130777,473,'Sagada Jhapni B.O','482021',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130778,473,'Sahajpur B.O','483119',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130779,473,'Sahajpuri B.O','482056',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130780,473,'Sahshan B.O','483119',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130781,473,'Sakra B.O','483113',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130782,473,'Salaiya B.O','483110',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130783,473,'Sarauli B.O','483110',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130784,473,'Saroli Majhgawan S.O','483334',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130785,473,'Sarond B.O','483113',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130786,473,'Sarsawa B.O','483220',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130787,473,'Sarswati Vihar S.O','482001',1,0,'2022-03-04 19:27:40','2022-03-04 19:27:40'),(130788,473,'Shahpura (Jabalpur) S.O','483119',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130789,473,'Shobhapur S.O','482009',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130790,473,'Sihora Khitola Bazar S.O','483225',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130791,473,'Simaria B.O','482002',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130792,473,'Singod B.O','483220',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130793,473,'Sonpur B.O','482005',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130794,473,'Subhas Nagar B.O','482004',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130795,473,'Sukha B.O','482002',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130796,473,'Sukha Bharatpur B.O','482003',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130797,473,'Sukri B.O','482051',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130798,473,'Sundarpur B.O','482005',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130799,473,'Supawara B.O','483110',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130800,473,'Surtalai B.O','482002',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130801,473,'T.T.C. S.O','482001',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130802,473,'Telegraph Work Shop S.O','482002',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130803,473,'Temarbhita B.O','482001',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130804,473,'Tilsani B.O','482001',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130805,473,'Tilwara Ghat B.O','482003',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130806,473,'Tinsi B.O','482051',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130807,473,'Tripuri B.O','483053',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130808,473,'Udna B.O','483113',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130809,473,'Umaria Choubey B.O','483220',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130810,473,'Umaria Kudari B.O','483001',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130811,473,'Umaria Patan B.O','483119',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130812,473,'Umaria Pathra B.O','483220',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130813,473,'Urdua Kala B.O','483220',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130814,473,'Vehicle Factory S.O','482009',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130815,473,'Vidyut Nagar S.O (Jabalpur)','482008',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130816,473,'Vijay Nagar Colony S.O (Jabalpur)','482002',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130817,473,'Wright Town S.O','482002',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130818,474,'Aamba B.O','457550',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130819,474,'Agral B.O','457779',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130820,474,'Ajanda B.O','457887',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130821,474,'Amankunwa B.O','457882',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130822,474,'Amargarh B.O','457770',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130823,474,'Ambadaberi B.O','457887',1,0,'2022-03-04 19:27:41','2022-03-04 19:27:41'),(130824,474,'Ambari B.O','457887',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130825,474,'Amkhut B.O','457887',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130826,474,'Anantkhedi B.O','457773',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130827,474,'Andharkanch B.O','457888',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130828,474,'Andharwad B.O','457993',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130829,474,'Antarwelia B.O','457779',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130830,474,'Attha B.O','457888',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130831,474,'Badaguda B.O','457990',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130832,474,'Badakhuntaja B.O','457882',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130833,474,'Badaundwa B.O','457887',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130834,474,'Badi B.O','457887',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130835,474,'Badisardi B.O','457887',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130836,474,'Bajranggarh B.O','457777',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130837,474,'Bakhatgarh B.O','457888',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130838,474,'Balwasa B.O','457777',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130839,474,'Bamnia S.O','457770',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130840,474,'Ban B.O','457993',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130841,474,'Bani B.O','457775',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130842,474,'Baodi B.O','457773',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130843,474,'Baodibadi B.O','457661',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130844,474,'Bardala B.O','457887',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130845,474,'Barwet B.O','457773',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130846,474,'Barzar B.O','457882',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130847,474,'Bedawa B.O','457777',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130848,474,'Bekalda B.O','457775',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130849,474,'Bhabhra S.O','457882',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130850,474,'Bhagor B.O','457779',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130851,474,'Bhamel B.O','457772',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130852,474,'Bherogarh B.O','457770',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130853,474,'Bhilkhedi B.O','457990',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130854,474,'Bhimfalia B.O','457661',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130855,474,'Bhimkund B.O','457777',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130856,474,'Bodayta B.O','457770',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130857,474,'Bokadia B.O','457887',1,0,'2022-03-04 19:27:42','2022-03-04 19:27:42'),(130858,474,'Bolasa B.O','457775',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130859,474,'Bori B.O','457990',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130860,474,'Borjhad B.O','457990',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130861,474,'Borkua B.O','457887',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130862,474,'Chandpur B.O','457887',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130863,474,'Chapaner B.O','457770',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130864,474,'Chhaktala B.O','457888',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130865,474,'Chhayan Paschim B.O','457770',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130866,474,'Chhotaitara B.O','457990',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130867,474,'Chhotamaota B.O','457887',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130868,474,'Dabdi B.O','457990',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130869,474,'Darkali B.O','457888',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130870,474,'Dehndi Chhoti B.O','457773',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130871,474,'Devigarh B.O','457777',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130872,474,'Devjhiri Panda B.O','457661',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130873,474,'Dhaturia B.O','457775',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130874,474,'Dhekal B.O','457661',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130875,474,'Dhyana B.O','457885',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130876,474,'Fata B.O','457887',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130877,474,'Foolmal B.O','457888',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130878,474,'Gangakhedi B.O','457770',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130879,474,'Ghodamandan B.O','457882',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130880,474,'Ghughri B.O','457770',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130881,474,'Guwali B.O','457779',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130882,474,'Hamirgarh B.O','457775',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130883,474,'Haraswat B.O','457887',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130884,474,'Harinagar B.O','457777',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130885,474,'Hatyadeli B.O','457779',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130886,474,'Jamli B.O','457775',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130887,474,'Jhabua Collectorate S.O','457661',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130888,474,'Jhabua Gailtownship S.O','457661',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130889,474,'Jhabua H.O','457661',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130890,474,'Jhaknawda B.O','457775',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130891,474,'Jheeran B.O','457882',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130892,474,'Jobat S.O','457990',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130893,474,'Kachaldara B.O','457779',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130894,474,'Kachhala B.O','457885',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130895,474,'Kadwal B.O','457885',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130896,474,'Kajlidungari B.O','457779',1,0,'2022-03-04 19:27:43','2022-03-04 19:27:43'),(130897,474,'Kakanwani B.O','457777',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130898,474,'Kalmoda B.O','457661',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130899,474,'Kalyanpura B.O','457779',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130900,474,'Kanakakad B.O','457993',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130901,474,'Kanjwanikhas B.O','457993',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130902,474,'Kanwada B.O','457990',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130903,474,'Karangarh B.O','457770',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130904,474,'Kardawad B.O','457773',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130905,474,'Kardawad Badi B.O','457661',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130906,474,'Karwad B.O','457770',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130907,474,'Khajuri B.O','457777',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130908,474,'Khalkhandwi B.O','457777',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130909,474,'Khandala B.O','457990',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130910,474,'Khardubadi B.O','457661',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130911,474,'Khattali B.O','457990',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130912,474,'Khawasa S.O (Jhabua)','457772',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130913,474,'Kheda B.O','457779',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130914,474,'Khedi B.O','457661',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130915,474,'Kodli B.O','457773',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130916,474,'Kolyabardi B.O','457990',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130917,474,'Kukdipada B.O','457772',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130918,474,'Kumarkhedi B.O','457775',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130919,474,'Kundalwasa B.O','457990',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130920,474,'Kundanpur B.O','457661',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130921,474,'Laxmani B.O','457887',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130922,474,'Machhlia B.O','457661',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130923,474,'Madrani B.O','457779',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130924,474,'Makodia B.O','457772',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130925,474,'Mandan B.O','457770',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130926,474,'Mandlinathu B.O','457993',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130927,474,'Matasula B.O','457993',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130928,474,'Mathmath B.O','457770',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130929,474,'Mathna B.O','457882',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130930,474,'Mathwad B.O','457888',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130931,474,'Megha B.O','457882',1,0,'2022-03-04 19:27:44','2022-03-04 19:27:44'),(130932,474,'Meghnagar S.O','457779',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130933,474,'Miyati B.O','457777',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130934,474,'Mohanpura B.O','457770',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130935,474,'Mordundia B.O','457993',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130936,474,'Morjhari B.O','457777',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130937,474,'Motibadoi B.O','457885',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130938,474,'Nanpur B.O','457887',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130939,474,'Narela B.O','457772',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130940,474,'Paledi B.O','457775',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130941,474,'Panchkui B.O','457779',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130942,474,'Panchpiplia B.O','457770',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130943,474,'Para B.O','457661',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130944,474,'Parwalia B.O','457777',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130945,474,'Petlawad S.O','457773',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130946,474,'Piplia B.O','457661',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130947,474,'Pipliawat B.O','457888',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130948,474,'Pithanpur B.O','457661',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130949,474,'Pitol B.O','457661',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130950,474,'Raipuria S.O','457775',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130951,474,'Rajla B.O','457661',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130952,474,'Rama B.O','457661',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130953,474,'Rambhapur B.O','457779',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130954,474,'Ramgarh B.O','457773',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130955,474,'Rampuria B.O','457770',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130956,474,'Ranapur S.O','457993',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130957,474,'Rehanda B.O','457661',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130958,474,'Ringol B.O','457882',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130959,474,'Rotla B.O','457661',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130960,474,'Rupgarh B.O','457773',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130961,474,'Sad B.O','457779',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130962,474,'Sagwa B.O','457772',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130963,474,'Sajelimaljisath B.O','457777',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130964,474,'Samoi B.O','457993',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130965,474,'Sarangi B.O','457770',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130966,474,'Sejawad B.O','457882',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130967,474,'Sejgaon B.O','457887',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130968,474,'Semlia B.O','457772',1,0,'2022-03-04 19:27:45','2022-03-04 19:27:45'),(130969,474,'Shivgarh B.O','457777',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130970,474,'Sorwa B.O','457887',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130971,474,'Talawali B.O','457777',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130972,474,'Tarkhedi B.O','457775',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130973,474,'Temria B.O','457773',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130974,474,'Thandla B.O','457990',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130975,474,'Thandla S.O','457777',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130976,474,'Titi B.O','457887',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130977,474,'Ublet B.O','457990',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130978,474,'Udaiga R.S. B.O','457777',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130979,474,'Udaygarh Kanas B.O','457990',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130980,474,'Umarkot B.O','457775',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130981,474,'Umda B.O','457990',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130982,474,'Umrali B.O','457888',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130983,474,'Undari B.O','457990',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130984,474,'Walpur B.O','457888',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130985,474,'Walwai B.O','457887',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130986,475,'Adarsh Gram Dhaivaiya B.O','483770',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130987,475,'Agaria Tikaria B.O','483334',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130988,475,'Amagawan B.O','483990',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130989,475,'Amraiyapar B.O','483880',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130990,475,'Anghora B.O','483336',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130991,475,'Antarved B.O','483334',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130992,475,'Bachaiya B.O','483225',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130993,475,'Badera B.O','483501',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130994,475,'Badggaon B.O','483990',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130995,475,'Badkhera B.O','483501',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130996,475,'Badkhera B.O','483225',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130997,475,'Badwara S.O','483773',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130998,475,'Bahori Band S.O','483330',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(130999,475,'Bakal S.O','483331',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(131000,475,'Baklehta B.O','483990',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(131001,475,'Bamhangawan B.O','483880',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(131002,475,'Bandha B.O','483222',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(131003,475,'Barhi S.O (Katni)','483770',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(131004,475,'Barnmehgawwan B.O','483770',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(131005,475,'Basadi B.O','483501',1,0,'2022-03-04 19:27:46','2022-03-04 19:27:46'),(131006,475,'Bela B.O','483222',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131007,475,'Bhadora B.O','483501',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131008,475,'Bhainswahi B.O','483501',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131009,475,'Bhajia B.O','483773',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131010,475,'Bhandra B.O','483334',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131011,475,'Bharatpur B.O','483990',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131012,475,'Bhoola B.O','483440',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131013,475,'Bhudsa B.O','483773',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131014,475,'Bichua B.O','483442',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131015,475,'Biharia B.O','483332',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131016,475,'Bijouri B.O','483773',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131017,475,'Bilhari B.O','483501',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131018,475,'Bujbuja B.O','483770',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131019,475,'Chadankheda B.O','483331',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131020,475,'Chaka B.O','483501',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131021,475,'Chapna B.O','483501',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131022,475,'Chargawan B.O','483440',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131023,475,'Chhapra B.O','483440',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131024,475,'Chidahi Pipariya B.O','483770',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131025,475,'Dang B.O','483990',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131026,475,'Darshni B.O','483225',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131027,475,'Dasarman B.O','483334',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131028,475,'Deodongra B.O','483501',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131029,475,'Deogaon B.O','483501',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131030,475,'Deora Kala B.O','483775',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131031,475,'Deori Guda B.O','483773',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131032,475,'Deori Hatai B.O','483501',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131033,475,'Deorimawai B.O','483440',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131034,475,'Dhangawan B.O','483225',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131035,475,'Dharwara B.O','483440',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131036,475,'Dheemarkheda B.O','483332',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131037,475,'Dhoreshar B.O','483332',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131038,475,'Dithwara B.O','483501',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131039,475,'Diwan Siding B.O','483880',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131040,475,'Dukaria B.O','483770',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131041,475,'Gairtalai B.O','483770',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131042,475,'Gandhi Gram B.O','483222',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131043,475,'Ganeshpur B.O','483501',1,0,'2022-03-04 19:27:47','2022-03-04 19:27:47'),(131044,475,'Gatakheda B.O','483330',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131045,475,'Gaura Khamaria B.O','483334',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131046,475,'Ghat Simaria B.O','483222',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131047,475,'Ghughara B.O','483501',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131048,475,'Ghunnaur B.O','483775',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131049,475,'Godana B.O','483990',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131050,475,'Gosalpur S.O','483222',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131051,475,'Gouraha B.O','483775',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131052,475,'Gudeha B.O','483775',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131053,475,'Guhawal B.O','483775',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131054,475,'Gulwara B.O','483501',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131055,475,'Gurjikala B.O','483990',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131056,475,'Hadarhata B.O','483770',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131057,475,'Hantala B.O','483775',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131058,475,'Hardua B.O','483501',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131059,475,'Hardwara B.O','483990',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131060,475,'Harraiya B.O','483880',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131061,475,'Harsinghi B.O','483222',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131062,475,'Hathiagarh B.O','483330',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131063,475,'Hathkuri B.O','483501',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131064,475,'Hinota B.O','483336',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131065,475,'Hirapur Kaudia B.O','483501',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131066,475,'Hirdey Nagar B.O','483222',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131067,475,'Imalaiya B.O','483331',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131068,475,'Indrana B.O','483336',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131069,475,'Itoura B.O','483770',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131070,475,'Jagua B.O','483770',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131071,475,'Jamowani Kalan B.O','483880',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131072,475,'Jhansi B.O','483222',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131073,475,'Jhingrai B.O','483222',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131074,475,'Jhinjhari B.O','483501',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131075,475,'Jhinna Piparia B.O','483332',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131076,475,'Jiwara B.O','483775',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131077,475,'Jobi Kalan B.O','483880',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131078,475,'Juhla B.O','483501',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131079,475,'Junwan Kalan B.O','483225',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131080,475,'Kachhargaon B.O','483334',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131081,475,'Kahangaon B.O','483880',1,0,'2022-03-04 19:27:48','2022-03-04 19:27:48'),(131082,475,'Kailwara Kala B.O','483501',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131083,475,'Kailwara Khurd B.O','483501',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131084,475,'Kailwas B.O','483222',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131085,475,'Kakrehta B.O','483330',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131086,475,'Kanhwara Kalan B.O','483501',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131087,475,'Kannaur B.O','483770',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131088,475,'Kanti B.O','483501',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131089,475,'Karela B.O','483770',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131090,475,'Karoritalai B.O','483880',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131091,475,'Katangi Kala B.O','483501',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131092,475,'Katariya B.O','483773',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131093,475,'Katni Bazar S.O','483501',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131094,475,'Katni Bhatta Mohalla S.O','483501',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131095,475,'Katni Cement Factory S.O','483504',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131096,475,'Katni Collectorate S.O','483501',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131097,475,'Katni H.O','483501',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131098,475,'Katni Madhaw Nagar S.O','483504',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131099,475,'Katni New Yard S.O','483501',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131100,475,'Katni Ordinance Factory S.O','483504',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131101,475,'Katni Purani Basti S.O','483501',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131102,475,'Katni R.S. S.O','483501',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131103,475,'Katni Rubber B.O','483501',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131104,475,'Khalari B.O','483332',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131105,475,'Khamaria (Bakal) B.O','483331',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131106,475,'Khamaria B.O','483773',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131107,475,'Khamaria(Jhanda) B.O','483990',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131108,475,'Khamtara Paharua B.O','483773',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131109,475,'Khand B.O','483336',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131110,475,'Kharkhari B.O','483880',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131111,475,'Khirahani Kala B.O','483334',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131112,475,'Khirahni B.O','483440',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131113,475,'Khitola B.O','483336',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131114,475,'Khitoli B.O','483770',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131115,475,'Kondia B.O','483440',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131116,475,'Koodan B.O','483330',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131117,475,'Kua B.O','483225',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131118,475,'Kua B.O','483770',1,0,'2022-03-04 19:27:49','2022-03-04 19:27:49'),(131119,475,'Kulhua Badkheda B.O','483442',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131120,475,'Kumharwara B.O','483770',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131121,475,'Kumhi Khurd B.O','483334',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131122,475,'Kumhi(Satdhara) B.O','483334',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131123,475,'Kundrehi B.O','483775',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131124,475,'Kuteshwar Lines B.O','483770',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131125,475,'Kuthiya Mahgawan B.O','483770',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131126,475,'Kuthla B.O','483501',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131127,475,'Lakhanpur B.O','483222',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131128,475,'Lamkana B.O','483225',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131129,475,'Mahagawan B.O','483220',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131130,475,'Mahner B.O','483332',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131131,475,'Majhgawan B.O','483501',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131132,475,'Majholi S.O','483336',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131133,475,'Makura B.O','483225',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131134,475,'Mangal Nagar B.O','483504',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131135,475,'Mangela Deori B.O','483332',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131136,475,'Mehgaon B.O','483880',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131137,475,'Mohas B.O','483501',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131138,475,'Mohtara B.O','483331',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131139,475,'Mureth B.O','483225',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131140,475,'Murwari B.O','483332',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131141,475,'Nadavan B.O','483770',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131142,475,'Nanhwara Kala B.O','483775',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131143,475,'Nanhwara Sejha B.O','483501',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131144,475,'Neemkheda B.O','483225',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131145,475,'Nigehra B.O','483501',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131146,475,'Nimas B.O','483225',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131147,475,'Nitarra B.O','483501',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131148,475,'Niwar S.O','483442',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131149,475,'Nunji B.O','483334',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131150,475,'Padarbhata B.O','483442',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131151,475,'Padkhuri B.O','483880',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131152,475,'Padwar B.O','483440',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131153,475,'Pahrua B.O','483225',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131154,475,'Pali B.O','483334',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131155,475,'Parsel B.O','483773',1,0,'2022-03-04 19:27:50','2022-03-04 19:27:50'),(131156,475,'Pathradi Piparia B.O','483330',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131157,475,'Patonha B.O','483990',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131158,475,'Patori B.O','483336',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131159,475,'Patori B.O','483331',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131160,475,'Phanwani B.O','483225',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131161,475,'Pindrai B.O','483332',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131162,475,'Piparia Paroha B.O','483440',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131163,475,'Piparia Sahalwan B.O','483332',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131164,475,'Piparia Shukla B.O','483332',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131165,475,'Pipriya Kalan B.O','483770',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131166,475,'Piprondh B.O','483442',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131167,475,'Pola B.O','483336',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131168,475,'Ponda B.O','483225',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131169,475,'Pondi B.O','483330',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131170,475,'Pondi Kala (B) B.O','483332',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131171,475,'Pondikala (A) B.O','483222',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131172,475,'Ponia B.O','483442',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131173,475,'Raipura B.O','483442',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131174,475,'Rampatan B.O','483330',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131175,475,'Ranital B.O','483336',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131176,475,'Rithi S.O','483990',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131177,475,'Rohniya B.O','483773',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131178,475,'Rupondh B.O','483773',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131179,475,'Sagona B.O','483332',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131180,475,'Sahajpura B.O','483222',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131181,475,'Salaiya Sihora B.O','483770',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131182,475,'Sansarpur B.O','483442',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131183,475,'Science College B.O','483501',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131184,475,'Sihora(MP) S.O','483225',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131185,475,'Sihundi B.O','483331',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131186,475,'Silondi B.O','483334',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131187,475,'Silua B.O','483222',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131188,475,'Singhuli B.O','483334',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131189,475,'Singodi B.O','483775',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131190,475,'Slleemanabad S.O','483440',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131191,475,'Sugwan B.O','483501',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131192,475,'Talad B.O','483225',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131193,475,'Tehkari B.O','483990',1,0,'2022-03-04 19:27:51','2022-03-04 19:27:51'),(131194,475,'Teori B.O','483440',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131195,475,'Tilgawan B.O','483501',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131196,475,'Ubra B.O','483770',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131197,475,'Umaria Dhirha B.O','483336',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131198,475,'Umaria Jujhari B.O','483225',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131199,475,'Umaria Pan S.O','483332',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131200,475,'Vijayraghavgarh S.O','483775',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131201,475,'Vilayat Kalan B.O','483773',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131202,476,'Adakheda B.O','450117',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131203,476,'Ashapur B.O','450117',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131204,476,'Billod B.O','450116',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131205,476,'Bothiya B.O','450116',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131206,476,'Chanera B.O','450116',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131207,476,'Dagadkhedi B.O','450116',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131208,476,'Ghatakhedi B.O','450661',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131209,476,'Guyada B.O','450112',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131210,476,'Harsud R.S. B.O','450116',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131211,476,'Kalanka B.O','450661',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131212,476,'Killod B.O','450116',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131213,476,'Kumthi B.O','450337',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131214,476,'Mandhata Omkareshwar S.O','450554',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131215,476,'Mojwadi B.O','450116',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131216,476,'Nimarkhedi S.O','450551',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131217,476,'Thapna B.O','450554',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131218,477,'Helapadawa B.O','451332',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131219,477,'Maral Sarovar B.O','451660',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131220,477,'Samarpat B.O','451441',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131221,478,'Ahmadpur B.O','481998',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131222,478,'Amgaon B.O','481885',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131223,478,'Anjani B.O','481995',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131224,478,'Anjania S.O','481998',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131225,478,'Aurai B.O','481998',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131226,478,'Bakori B.O','481661',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131227,478,'Bamhani B.O','481885',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131228,478,'Bamnhi Bhawal B.O','481662',1,0,'2022-03-04 19:27:52','2022-03-04 19:27:52'),(131229,478,'Bamni Deohara B.O','481664',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131230,478,'Bamni S.O','481771',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131231,478,'Barai B.O','481995',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131232,478,'Barwahi B.O','481662',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131233,478,'Beejadandi S.O','481666',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131234,478,'Bhaishwahi B.O','481664',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131235,478,'Bhartipur B.O','481662',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131236,478,'Bharweli B.O','481668',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131237,478,'Bhimdongari B.O','481996',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131238,478,'Bhuabichhia S.O','481995',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131239,478,'Bichhia B.O','481885',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131240,478,'Bijegaon B.O','481662',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131241,478,'Bijegaon Colony B.O','481668',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131242,478,'Bilgaon B.O','481661',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131243,478,'Bineka B.O','481661',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131244,478,'Binjhia B.O','481661',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131245,478,'Borgaon B.O','481662',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131246,478,'Chabi S.O','481672',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131247,478,'Chandwara B.O','481661',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131248,478,'Chhapartala B.O','481996',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131249,478,'Chichgaon B.O','481768',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131250,478,'Chirai Dongri B.O','481662',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131251,478,'Chiraidongri S.O','481768',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131252,478,'Chubhawal B.O','481663',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131253,478,'Danitola B.O','481995',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131254,478,'Deogaon B.O','481663',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131255,478,'Deori Nainpur B.O','481668',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131256,478,'Deorikala B.O','481885',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131257,478,'Dhadibhanpur B.O','481995',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131258,478,'Dhangaon B.O','481996',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131259,478,'Dhenko B.O','481771',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131260,478,'Dithori B.O','481668',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131261,478,'Gajraj B.O','481664',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131262,478,'Gaurachhapar B.O','481776',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131263,478,'Ghagha B.O','481661',1,0,'2022-03-04 19:27:53','2022-03-04 19:27:53'),(131264,478,'Ghughri S.O','481664',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131265,478,'Ghutas B.O','481995',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131266,478,'Gokulthana B.O','481776',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131267,478,'Gwara B.O','481885',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131268,478,'Hirdenagar B.O','481661',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131269,478,'I.T.I. B.O','481661',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131270,478,'Indri B.O','481768',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131271,478,'Itka B.O','481776',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131272,478,'Jaharmau B.O','481771',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131273,478,'Jamgaon B.O','481776',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131274,478,'Kakaiya B.O','481771',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131275,478,'Kalpi B.O','481662',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131276,478,'Kanha National Park B.O','481768',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131277,478,'Kanhadgaon B.O','481668',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131278,478,'Katra B.O','481661',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131279,478,'Kauwadongri B.O','481663',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131280,478,'Keolari B.O','481995',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131281,478,'Khajari B.O','481664',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131282,478,'Khaloundi B.O','481996',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131283,478,'Khari B.O','481661',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131284,478,'Khatola B.O','481995',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131285,478,'Kindari B.O','481661',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131286,478,'Koko B.O','481995',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131287,478,'Kudameli B.O','481662',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131288,478,'Kudela B.O','481996',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131289,478,'Lafra B.O','481771',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131290,478,'Lawarmundia B.O','481662',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131291,478,'Limarua B.O','481771',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131292,478,'Machhala B.O','481663',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131293,478,'Madhopur B.O','481998',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131294,478,'Madhupuri B.O','481661',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131295,478,'Maharajpur S.O (Mandla)','481665',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131296,478,'Mainpuri B.O','481995',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131297,478,'Malara Bichhua B.O','481665',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131298,478,'Manadehi B.O','481665',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131299,478,'Mand B.O','481998',1,0,'2022-03-04 19:27:54','2022-03-04 19:27:54'),(131300,478,'Mandla City B.O','481661',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131301,478,'Mandla H.O','481661',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131302,478,'Maneri B.O','481885',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131303,478,'Mangali B.O','481996',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131304,478,'Mawai B.O','481996',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131305,478,'Meda B.O','481996',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131306,478,'Mohania Patpara B.O','481661',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131307,478,'Mohgaon S.O','481663',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131308,478,'Motinala B.O','481996',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131309,478,'Mugdara B.O','481771',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131310,478,'Munu B.O','481663',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131311,478,'Naharganj B.O','481996',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131312,478,'Naijhar(Pondi) B.O','481995',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131313,478,'Nainpur S.O','481776',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131314,478,'Niwas S.O','481885',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131315,478,'Padariyanarayan Ganj S.O','481662',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131316,478,'Padaw Mandla S.O','481661',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131317,478,'Padmi B.O','481661',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131318,478,'Padri Patpara B.O','481661',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131319,478,'Palasunder B.O','481768',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131320,478,'Pandiwada B.O','481662',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131321,478,'Patan B.O','481664',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131322,478,'Patha B.O','481662',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131323,478,'Pathasihora B.O','481668',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131324,478,'Pindrai S.O','481668',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131325,478,'Piparia (B) B.O','481662',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131326,478,'Piparia Niwas B.O','481885',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131327,478,'Poninagrar B.O','481662',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131328,478,'Poundi Jhurki B.O','481672',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131329,478,'Poundi Linga B.O','481661',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131330,478,'Poundibaharmunda B.O','481996',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131331,478,'Purwa B.O','481661',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131332,478,'Raiwada B.O','481668',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131333,478,'Rajo B.O','481996',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131334,478,'Ramhepur B.O','481664',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131335,478,'Ramnagar B.O','481661',1,0,'2022-03-04 19:27:55','2022-03-04 19:27:55'),(131336,478,'Rampuri B.O','481768',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131337,478,'Rata B.O','481768',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131338,478,'Sahjar B.O','481672',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131339,478,'Salwah B.O','481664',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131340,478,'Semarkhapa B.O','481661',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131341,478,'Sijhora S.O','481996',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131342,478,'Silghiti B.O','481664',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131343,478,'Silgi B.O','481771',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131344,478,'Singarpur B.O','481663',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131345,478,'Suktara B.O','481998',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131346,478,'Surhali B.O','481672',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131347,478,'Tabalpani B.O','481995',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131348,478,'Tatri B.O','481768',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131349,478,'Thanamgaon B.O','481885',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131350,478,'Thonda B.O','481995',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131351,478,'Udaipur B.O','481662',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131352,478,'Umardih B.O','481663',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131353,479,'Aankali Deewan B.O','458883',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131354,479,'Admalya B.O','458553',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131355,479,'Afzalpur B.O','458895',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131356,479,'Ajaypur B.O','458888',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131357,479,'Akodara B.O','458667',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131358,479,'Akya Umaheda B.O','458669',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131359,479,'Amlawad B.O','458002',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131360,479,'Angari B.O','458888',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131361,479,'Antralia B.O','458775',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131362,479,'Asawati B.O','458883',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131363,479,'Babulda B.O','458775',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131364,479,'Badwan B.O','458667',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131365,479,'Baghunia B.O','458883',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131366,479,'Bahi Parshwanath B.O','458664',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131367,479,'Bajkhedi B.O','458558',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131368,479,'Balaguda B.O','458664',1,0,'2022-03-04 19:27:56','2022-03-04 19:27:56'),(131369,479,'Bani B.O','458888',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131370,479,'Bani B.O','458667',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131371,479,'Bardia Amra B.O','458880',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131372,479,'Bardia Istamurar B.O','458880',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131373,479,'Barkehda Nayak B.O','458883',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131374,479,'Barkheda Dangi B.O','458556',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131375,479,'Barkheda Dev Dungari B.O','458339',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131376,479,'Barkheda Gangasa B.O','458880',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131377,479,'Barkheda Loya B.O','458880',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131378,479,'Barkheda Panth B.O','458664',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131379,479,'Basai B.O','458990',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131380,479,'Behpur B.O','458669',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131381,479,'Bhagor B.O','458389',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131382,479,'Bhalot B.O','458002',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131383,479,'Bhanpura S.O','458775',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131384,479,'Bhardawad B.O','458002',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131385,479,'Bhaugarh B.O','458667',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131386,479,'Bhensoda Mandi S.O','458778',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131387,479,'Bhensoda Town B.O','458778',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131388,479,'Bhundia B.O','458883',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131389,479,'Bilantri B.O','458990',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131390,479,'Billod B.O','458556',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131391,479,'Bolia B.O','458880',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131392,479,'Borda B.O','458778',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131393,479,'Borkhedi B.O','458888',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131394,479,'Botalganj B.O','458664',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131395,479,'Budha S.O','458556',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131396,479,'C.C. Camp B.O','458771',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131397,479,'Champakhedi B.O','458888',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131398,479,'Chandwasa B.O','458883',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131399,479,'Chiknia B.O','458880',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131400,479,'Dalauda Rail B.O','458667',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131401,479,'Dalauda S.O','458667',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131402,479,'Dalawda B.O','458389',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131403,479,'Deepakheda B.O','458389',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131404,479,'Degaon Mali S.O','458895',1,0,'2022-03-04 19:27:57','2022-03-04 19:27:57'),(131405,479,'Denthali Bujurg B.O','458880',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131406,479,'Devari B.O','458664',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131407,479,'Devpura Bamni B.O','458888',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131408,479,'Dhabla B.O','458556',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131409,479,'Dhabla Bhagwan B.O','458888',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131410,479,'Dhabla Deval B.O','458883',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131411,479,'Dhabla Gujar B.O','458883',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131412,479,'Dhabla Madho Singh B.O','458775',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131413,479,'Dhabla Mohan B.O','458883',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131414,479,'Dhalmu B.O','458880',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131415,479,'Dhalpat B.O','458888',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131416,479,'Dhamnar B.O','458667',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131417,479,'Dhandhora B.O','458669',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131418,479,'Dhariya Khedi B.O','458002',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131419,479,'Dhiknia B.O','458990',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131420,479,'Dhikola B.O','458002',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131421,479,'Dhodhar B.O','458888',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131422,479,'Dhuan Khedi B.O','458778',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131423,479,'Dhundharka B.O','458667',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131424,479,'Dobra B.O','458556',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131425,479,'Dorwada B.O','458556',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131426,479,'Elachi B.O','458667',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131427,479,'Era B.O','458558',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131428,479,'Fatehgarh B.O','458667',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131429,479,'Gandhi Sagar S.O','458771',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131430,479,'Garoda B.O','458667',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131431,479,'Garoth S.O','458880',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131432,479,'Ghasoi B.O','458888',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131433,479,'Gogarpura B.O','458002',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131434,479,'Gujar Bardia B.O','458895',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131435,479,'Gujarda B.O','458002',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131436,479,'Guradia Deda B.O','458002',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131437,479,'Guradia Lalmuha B.O','458002',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131438,479,'Guradia Vijay B.O','458888',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131439,479,'Hamirgarh B.O','458775',1,0,'2022-03-04 19:27:58','2022-03-04 19:27:58'),(131440,479,'Harsol B.O','458553',1,0,'2022-03-04 19:27:59','2022-03-04 19:27:59'),(131441,479,'Hatunia B.O','458883',1,0,'2022-03-04 19:27:59','2022-03-04 19:27:59'),(131442,479,'Hatunia B.O','458667',1,0,'2022-03-04 19:27:59','2022-03-04 19:27:59'),(131443,479,'Hingoria B.O','458556',1,0,'2022-03-04 19:27:59','2022-03-04 19:27:59'),(131444,479,'Jaggakhedi B.O','458895',1,0,'2022-03-04 19:27:59','2022-03-04 19:27:59'),(131445,479,'Jawasia B.O','458002',1,0,'2022-03-04 19:27:59','2022-03-04 19:27:59'),(131446,479,'Jhalara B.O','458558',1,0,'2022-03-04 19:27:59','2022-03-04 19:27:59'),(131447,479,'Jhangria B.O','458389',1,0,'2022-03-04 19:27:59','2022-03-04 19:27:59'),(131448,479,'Jhawal B.O','458895',1,0,'2022-03-04 19:27:59','2022-03-04 19:27:59'),(131449,479,'Kachnara B.O','458558',1,0,'2022-03-04 19:27:59','2022-03-04 19:27:59'),(131450,479,'Kachnara Flag S.O','458669',1,0,'2022-03-04 19:27:59','2022-03-04 19:27:59'),(131451,479,'Kachria Chandrawat B.O','458664',1,0,'2022-03-04 19:27:59','2022-03-04 19:27:59'),(131452,479,'Kaithuli B.O','458775',1,0,'2022-03-04 19:27:59','2022-03-04 19:27:59'),(131453,479,'Kalakot B.O','458775',1,0,'2022-03-04 19:27:59','2022-03-04 19:27:59'),(131454,479,'Kanghatti B.O','458664',1,0,'2022-03-04 19:27:59','2022-03-04 19:27:59'),(131455,479,'Kantia B.O','458888',1,0,'2022-03-04 19:27:59','2022-03-04 19:27:59'),(131456,479,'Kanwla B.O','458775',1,0,'2022-03-04 19:27:59','2022-03-04 19:27:59'),(131457,479,'Karju B.O','458667',1,0,'2022-03-04 19:27:59','2022-03-04 19:27:59'),(131458,479,'Kayampur  B.O','458558',1,0,'2022-03-04 19:27:59','2022-03-04 19:27:59'),(131459,479,'Khadawda B.O','458880',1,0,'2022-03-04 19:27:59','2022-03-04 19:27:59'),(131460,479,'Khadpalia B.O','458556',1,0,'2022-03-04 19:27:59','2022-03-04 19:27:59'),(131461,479,'Khajuri Goud B.O','458558',1,0,'2022-03-04 19:27:59','2022-03-04 19:27:59'),(131462,479,'Khajuri Nag B.O','458389',1,0,'2022-03-04 19:27:59','2022-03-04 19:27:59'),(131463,479,'Khajuri Panth B.O','458883',1,0,'2022-03-04 19:27:59','2022-03-04 19:27:59'),(131464,479,'Khajuri Runda B.O','458880',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131465,479,'Khajuria Sarang B.O','458669',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131466,479,'Khanderia Kachar B.O','458558',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131467,479,'Kharkheda B.O','458880',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131468,479,'Khatia Khedi B.O','458558',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131469,479,'Kheda B.O','458990',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131470,479,'Khejdia B.O','458990',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131471,479,'Kheta Kheda B.O','458990',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131472,479,'Khilchipura B.O','458002',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131473,479,'Kishorepura B.O','458888',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131474,479,'Kotda Bahadur B.O','458558',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131475,479,'Kotda Bujurg B.O','458880',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131476,479,'Kukdeshwara B.O','458775',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131477,479,'Kunchrod B.O','458895',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131478,479,'Kurlasi B.O','458880',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131479,479,'Kuwaran B.O','458888',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131480,479,'Laduna S.O','458389',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131481,479,'Ladusa B.O','458667',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131482,479,'Lasudia B.O','458883',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131483,479,'Lasudia Ila B.O','458669',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131484,479,'Lasudia Rathor B.O','458664',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131485,479,'Lawari B.O','458389',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131486,479,'Limbavas B.O','458556',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131487,479,'Lodh B.O','458895',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131488,479,'Lotkhedi B.O','458775',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131489,479,'Lunaheda B.O','458664',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131490,479,'Magrana B.O','458556',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131491,479,'Mahua B.O','458990',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131492,479,'Malhargarh S.O','458339',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131493,479,'Maliya Kherkheda B.O','458895',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131494,479,'Mandsaur City S.O','458002',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131495,479,'Mandsaur Fort S.O','458002',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131496,479,'Mandsaur H.O','458001',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131497,479,'Mandsaur Jankupura B.O','458002',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131498,479,'Mandsaur Nai Abadi S.O','458001',1,0,'2022-03-04 19:28:00','2022-03-04 19:28:00'),(131499,479,'Manpura B.O','458389',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131500,479,'Melkheda B.O','458883',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131501,479,'Motipura B.O','458558',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131502,479,'Multanpura B.O','458002',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131503,479,'Munderi B.O','458664',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131504,479,'Nagari B.O','458669',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131505,479,'Nahargarh S.O','458558',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131506,479,'Nandawta B.O','458667',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131507,479,'Nandwel B.O','458669',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131508,479,'Naoli B.O','458775',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131509,479,'Narayangarh S.O (Mandsaur)','458553',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131510,479,'Nataram B.O','458558',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131511,479,'Nimbod B.O','458669',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131512,479,'Nimthur B.O','458775',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131513,479,'Osara B.O','458778',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131514,479,'Paheda B.O','458339',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131515,479,'Panpur B.O','458895',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131516,479,'Paoti B.O','458880',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131517,479,'Parasali Ghata B.O','458883',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131518,479,'Parasali Tirth B.O','458883',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131519,479,'Patela B.O','458667',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131520,479,'Patlawad B.O','458669',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131521,479,'Piplia Jatti B.O','458880',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131522,479,'Piplia Jodha B.O','458556',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131523,479,'Piplia Karadia B.O','458895',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131524,479,'Piplia S.O','458664',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131525,479,'Prempuria B.O','458775',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131526,479,'Ranayara B.O','458556',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131527,479,'Ranayara B.O','458558',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131528,479,'Rathana B.O','458990',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131529,479,'Rawta B.O','458990',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131530,479,'Reenda B.O','458667',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131531,479,'Rewas Devra B.O','458002',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131532,479,'Richalal Muha B.O','458669',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131533,479,'Runija B.O','458888',1,0,'2022-03-04 19:28:01','2022-03-04 19:28:01'),(131534,479,'Sabakheda B.O','458002',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131535,479,'Sagoria B.O','458883',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131536,479,'Sagwali B.O','458667',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131537,479,'Saktali B.O','458990',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131538,479,'Sandalpur B.O','458775',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131539,479,'Sandhara B.O','458775',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131540,479,'Sandla B.O','458775',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131541,479,'Sanjeet B.O','458556',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131542,479,'Sarafa Mandsaur S.O','458002',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131543,479,'Sarsod B.O','458669',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131544,479,'Sarwania B.O','458556',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131545,479,'Satalkhedi B.O','458778',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131546,479,'Sathkheda B.O','458880',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131547,479,'Sedaramata B.O','458389',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131548,479,'Sehore B.O','458895',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131549,479,'Semali B.O','458664',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131550,479,'Semalia Heera B.O','458667',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131551,479,'Shamgarh Gaon B.O','458883',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131552,479,'Shamgarh S.O','458883',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131553,479,'Shri Ramtekri Mandsaur S.O','458001',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131554,479,'Sitamau S.O','458990',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131555,479,'Somia B.O','458553',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131556,479,'Soni B.O','458664',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131557,479,'Sunthi B.O','458558',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131558,479,'Sunthod B.O','458339',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131559,479,'Suwasara Gaon B.O','458888',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131560,479,'Suwasara Mandi S.O','458888',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131561,479,'Takrawad B.O','458556',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131562,479,'Tarnod B.O','458888',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131563,479,'Titrod B.O','458990',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131564,479,'Tolakhedi B.O','458883',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131565,479,'Tonkada B.O','458888',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131566,479,'Udpura B.O','458895',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131567,479,'Umria Baloda B.O','458883',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131568,479,'Vishnia Dak Bunglow B.O','458558',1,0,'2022-03-04 19:28:02','2022-03-04 19:28:02'),(131569,480,'Adhanpur B.O','476111',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131570,480,'Ahroli B.O','476224',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131571,480,'Aisa B.O','476134',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131572,480,'Alapur B.O','476221',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131573,480,'Ambah Ganj S.O','476111',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131574,480,'Ambah Road Morena S.O','476001',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131575,480,'Ambah S.O','476111',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131576,480,'Amilheda B.O','476111',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131577,480,'Arhela B.O','476219',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131578,480,'Atar B.O','476229',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131579,480,'Badawali B.O','476115',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131580,480,'Badhrentha B.O','476229',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131581,480,'Baghchini S.O','476219',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131582,480,'Baghel B.O','476221',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131583,480,'Baghpura B.O','476134',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131584,480,'Bamsoli B.O','476229',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131585,480,'Banmore S.O','476444',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131586,480,'Barbai B.O','476111',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131587,480,'Bareh B.O','476111',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131588,480,'Barrend B.O','476224',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131589,480,'Bertha B.O','476001',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131590,480,'Bharra B.O','476224',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131591,480,'Bhindosa B.O','476554',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131592,480,'Bijaigarh B.O','476111',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131593,480,'Bilgoun B.O','476221',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131594,480,'Bindwa B.O','476111',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131595,480,'Bisnori B.O','476221',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131596,480,'Budhara B.O','476115',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131597,480,'Chaina B.O','476219',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131598,480,'Chandkapura B.O','476111',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131599,480,'Chandpur B.O','476134',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131600,480,'Chhajra B.O','476221',1,0,'2022-03-04 19:28:03','2022-03-04 19:28:03'),(131601,480,'Chichawali B.O','476554',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131602,480,'Chinnnoni Karera B.O','476221',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131603,480,'Chinnoni Chambal B.O','476224',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131604,480,'Chowki B.O','476229',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131605,480,'Datehara B.O','476554',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131606,480,'Deogarh B.O','476219',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131607,480,'Devpur Maphi B.O','476229',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131608,480,'Dhamkan B.O','476221',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131609,480,'Dhanela B.O','476444',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131610,480,'Dharmgarh B.O','476115',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131611,480,'Dhorera B.O','476221',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131612,480,'Dikhatpura B.O','476001',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131613,480,'Dimni S.O','476134',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131614,480,'Dipera B.O','476224',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131615,480,'Distt. Court Morena S.O','476001',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131616,480,'Dondari B.O','476115',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131617,480,'Gadhia Raipur B.O','476111',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131618,480,'Gadhiya B.O','476115',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131619,480,'Galetha B.O','476219',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131620,480,'Ghuriya Basai B.O','476221',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131621,480,'Gopalpura Morena S.O','476001',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131622,480,'Gopi B.O','476554',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131623,480,'Gospur B.O','476001',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131624,480,'Goth B.O','476111',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131625,480,'Gudha Chambal B.O','476219',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131626,480,'Hadwansi B.O','476219',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131627,480,'Hathariya B.O','476221',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131628,480,'Hetampur B.O','476001',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131629,480,'Hingona B.O','476001',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131630,480,'Hirapura B.O','476229',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131631,480,'Imliya B.O','476221',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131632,480,'Itawali B.O','476221',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131633,480,'Jai Nagar B.O','476444',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131634,480,'Jaitpur B.O','476444',1,0,'2022-03-04 19:28:04','2022-03-04 19:28:04'),(131635,480,'Jakhona B.O','476134',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131636,480,'Jalalgarh B.O','476229',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131637,480,'Jaloni B.O','476111',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131638,480,'Jarah B.O','476001',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131639,480,'Javrol B.O','476229',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131640,480,'Jhundpura B.O','476224',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131641,480,'Jigani B.O','476001',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131642,480,'Jonhan B.O','476111',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131643,480,'Jotai B.O','476115',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131644,480,'Joura city B.O','476221',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131645,480,'Joura Khurd B.O','476001',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131646,480,'Joura S.O','476221',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131647,480,'Kamtari B.O','476111',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131648,480,'Kanhar B.O','476228',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131649,480,'Karari B.O','476134',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131650,480,'Karsada B.O','476115',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131651,480,'Kasmada B.O','476111',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131652,480,'Kelaras S.O','476224',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131653,480,'Khadiahar S.O','476554',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131654,480,'Khandkapura B.O','476111',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131655,480,'Khandoli B.O','476001',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131656,480,'Khaneta B.O','476001',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131657,480,'Kharagpur B.O','476444',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131658,480,'Kheda Mevda B.O','476001',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131659,480,'Khitora B.O','476219',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131660,480,'Khutiyanihar B.O','476224',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131661,480,'Kichol B.O','476115',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131662,480,'Kirranch B.O','476115',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131663,480,'Kishanpur B.O','476001',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131664,480,'Kishorgarh B.O','476229',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131665,480,'Kishroli B.O','476111',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131666,480,'Kolua B.O','476554',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131667,480,'Kondera B.O','476224',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131668,480,'Konthar Kalan B.O','476115',1,0,'2022-03-04 19:28:05','2022-03-04 19:28:05'),(131669,480,'Konthar Kurd B.O','476115',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131670,480,'Kot Sirthara B.O','476228',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131671,480,'Kotwal B.O','476001',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131672,480,'Kulholi B.O','476229',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131673,480,'Kumheri B.O','476219',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131674,480,'Kuretha B.O','476115',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131675,480,'Kurroli B.O','476224',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131676,480,'Kurthari B.O','476115',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131677,480,'Kuthiyana B.O','476134',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131678,480,'Lahrra B.O','476228',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131679,480,'Laljeetkapura B.O','476111',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131680,480,'Lalkapura Dohrota B.O','476115',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131681,480,'Lallu Basai B.O','476554',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131682,480,'Lalorkalan B.O','476001',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131683,480,'Ludhawali B.O','476111',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131684,480,'Madhogarh B.O','476224',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131685,480,'Mahasukhkapura B.O','476111',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131686,480,'Mahua B.O','476111',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131687,480,'Malbasai B.O','476111',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131688,480,'Mamchon B.O','476228',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131689,480,'Mangrol B.O','476229',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131690,480,'Manpur Rajpooti B.O','476554',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131691,480,'Mata Basaiya B.O','476001',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131692,480,'Mirghan B.O','476554',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131693,480,'Mohanpur B.O','476219',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131694,480,'Morena City S.O','476001',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131695,480,'Morena Goun B.O','476001',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131696,480,'Morena H.O','476001',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131697,480,'Morena Mandi S.O','476001',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131698,480,'Mrigpura B.O','476001',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131699,480,'Mudiakheda B.O','476001',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131700,480,'Mundrawaja B.O','476221',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131701,480,'Mungaoli B.O','476001',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131702,480,'Nagra B.O','476115',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131703,480,'Nagra B.O','476001',1,0,'2022-03-04 19:28:06','2022-03-04 19:28:06'),(131704,480,'Nahar Donki B.O','476219',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131705,480,'Nand Gangoli B.O','476219',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131706,480,'Nandpura B.O','476219',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131707,480,'Narhela B.O','476221',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131708,480,'Navali Badagoun B.O','476554',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131709,480,'Nayakpura B.O','476001',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131710,480,'Nayapura B.O','476111',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131711,480,'Nepari B.O','476224',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131712,480,'Nirar B.O','476228',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131713,480,'Nirara B.O','476224',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131714,480,'Nitehara B.O','476221',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131715,480,'Noorabad B.O','476444',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131716,480,'Pachokha B.O','476224',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131717,480,'Padhawali B.O','476444',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131718,480,'Pahadgarh S.O','476228',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131719,480,'Panchampura B.O','476219',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131720,480,'Pariksha B.O','476554',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131721,480,'Parikshit Ka Pura B.O','476111',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131722,480,'Paroli B.O','476444',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131723,480,'Parsota B.O','476221',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131724,480,'Pawaya B.O','476444',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131725,480,'Piparipooth B.O','476115',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131726,480,'Pipersewa B.O','476444',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131727,480,'Porsa S.O','476115',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131728,480,'Purawas Khurd B.O','476554',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131729,480,'Rachhed B.O','476111',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131730,480,'Rahu Ka Gaoun B.O','476229',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131731,480,'Raja Ka Tor B.O','476229',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131732,480,'Rajodha B.O','476115',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131733,480,'Ram Pahadi B.O','476229',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131734,480,'Rampurkalan B.O','476229',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131735,480,'Ratan Basai B.O','476111',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131736,480,'Rijhoni B.O','476224',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131737,480,'Rithona B.O','476111',1,0,'2022-03-04 19:28:07','2022-03-04 19:28:07'),(131738,480,'Rithorakalan B.O','476444',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131739,480,'Ruar B.O','476111',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131740,480,'Ruar Maina Basai B.O','476221',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131741,480,'Runhera B.O','476111',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131742,480,'Rupahati B.O','476111',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131743,480,'Sabalgarh Mandi S.O','476229',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131744,480,'Sabalgarh S.O','476229',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131745,480,'Samai B.O','476224',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131746,480,'Sangoli B.O','476115',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131747,480,'Santhon B.O','476115',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131748,480,'Semna B.O','476229',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131749,480,'Senthar Badai B.O','476115',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131750,480,'Senthara Ahir B.O','476115',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131751,480,'Shivlal Ka Pura B.O','476001',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131752,480,'Sihoniya B.O','476554',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131753,480,'Sihori B.O','476001',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131754,480,'Sikorodi B.O','476554',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131755,480,'Sikrodi B.O','476444',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131756,480,'Silawali B.O','476115',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131757,480,'Singroli B.O','476224',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131758,480,'Sirmorkapura B.O','476134',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131759,480,'Sujangadi B.O','476224',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131760,480,'Sujarma B.O','476224',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131761,480,'Sukhpura B.O','476219',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131762,480,'Sumaoli B.O','476221',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131763,480,'Susani B.O','476221',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131764,480,'Tareni B.O','476115',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131765,480,'Tentra B.O','476229',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131766,480,'Thara B.O','476111',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131767,480,'Tilawali B.O','476219',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131768,480,'Tilonjari B.O','476228',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131769,480,'Uasith B.O','476111',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131770,480,'Ummedgarh Bansi B.O','476219',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131771,480,'Usainpur B.O','476224',1,0,'2022-03-04 19:28:08','2022-03-04 19:28:08'),(131772,481,'Amada B.O','487881',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131773,481,'Amgaon Bada S.O','487225',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131774,481,'Amgaonchhota B.O','487551',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131775,481,'Attayasa B.O','487555',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131776,481,'Bachai B.O','487001',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131777,481,'Badhwar B.O','487225',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131778,481,'Bagaspur B.O','487118',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131779,481,'Bahmorikala B.O','487555',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131780,481,'Bahoripar B.O','487001',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131781,481,'Bairagarh B.O','487881',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131782,481,'Banskheda B.O','487661',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131783,481,'Banwari B.O','487661',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131784,481,'Barhabada B.O','487881',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131785,481,'Barhachhota B.O','487225',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131786,481,'Barhata B.O','487118',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131787,481,'Barman S.O','487330',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131788,481,'Basuria B.O','487881',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131789,481,'Batesra B.O','487221',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131790,481,'Bedu B.O','487118',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131791,481,'Beekor B.O','487334',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131792,481,'Belkhedi B.O','487118',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131793,481,'Bhama B.O','487334',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131794,481,'Bhamni B.O','487330',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131795,481,'Bhanda B.O','487334',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131796,481,'Bhansapara B.O','487110',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131797,481,'Bharheta B.O','487551',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131798,481,'Bhatera B.O','487555',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131799,481,'Bhourjhir B.O','487441',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131800,481,'Bhugwara B.O','487221',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131801,481,'Bikrampur B.O','487118',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131802,481,'Bilgua B.O','487334',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131803,481,'Bilhera B.O','487330',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131804,481,'Bilthari B.O','487334',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131805,481,'Bitli B.O','487330',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131806,481,'Bohani B.O','487555',1,0,'2022-03-04 19:28:09','2022-03-04 19:28:09'),(131807,481,'Chandankheda B.O','487441',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131808,481,'Chandankheda B.O','487118',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131809,481,'Chawarkheda B.O','487001',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131810,481,'Chawarpatha B.O','487330',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131811,481,'Chhatarpur B.O','487334',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131812,481,'Chhitapar B.O','487330',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131813,481,'Chichli S.O','487770',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131814,481,'Chinki B.O','487001',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131815,481,'Chirchra B.O','487441',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131816,481,'Chirriya B.O','487555',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131817,481,'Dangidhana B.O','487001',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131818,481,'Deedhori B.O','487551',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131819,481,'Deguwa B.O','487441',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131820,481,'Deori B.O','487330',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131821,481,'Deori B.O','487661',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131822,481,'Dethpoun B.O','487661',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131823,481,'Devnagar(Purana) B.O','487118',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131824,481,'Devnagarnaya B.O','487001',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131825,481,'Dhamna B.O','487001',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131826,481,'Dhilwar B.O','487337',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131827,481,'Dobhi S.O','487334',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131828,481,'Dongargaon B.O','487114',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131829,481,'Dudwara B.O','487001',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131830,481,'Dungria B.O','487881',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131831,481,'Dungria(Hemra) B.O','487441',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131832,481,'Gadarwara S.O','487551',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131833,481,'Gadarwarars B.O','487551',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131834,481,'Gaghrolakala B.O','487441',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131835,481,'Gangai B.O','487770',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131836,481,'Garha B.O','487441',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131837,481,'Ghatpandrai B.O','487114',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131838,481,'Gohchar B.O','487118',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131839,481,'Gorakhpur B.O','487110',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131840,481,'Gotegaon S.O','487118',1,0,'2022-03-04 19:28:10','2022-03-04 19:28:10'),(131841,481,'Gotitoriya B.O','487770',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131842,481,'Goura B.O','487337',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131843,481,'Gundhari B.O','487118',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131844,481,'Harrai B.O','487441',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131845,481,'Heerapur B.O','487441',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131846,481,'Hiranpur B.O','487330',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131847,481,'Imjhira B.O','487337',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131848,481,'Imlia (Kadhely) B.O','487334',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131849,481,'Imlia Boghora B.O','487225',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131850,481,'Imliya B.O','487118',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131851,481,'Imliya(Pipria) B.O','487551',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131852,481,'Itwarabazar B.O','487001',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131853,481,'Jamada B.O','487551',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131854,481,'Jamunia B.O','487118',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131855,481,'Jamunia B.O','461990',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131856,481,'Jawaharganj Gadarwara S.O','487551',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131857,481,'Jhamar B.O','487114',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131858,481,'Jhotshwar B.O','487118',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131859,481,'Jobha B.O','487221',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131860,481,'Kacharkona B.O','487337',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131861,481,'Kalyanpur B.O','487441',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131862,481,'Kamod B.O','487118',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131863,481,'Kamtada B.O','487001',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131864,481,'Kandeli S.O','487001',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131865,481,'Kanjai B.O','487118',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131866,481,'Kapoori B.O','487110',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131867,481,'Karakbel S.O','487114',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131868,481,'Karapgaon B.O','487221',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131869,481,'Kareli kala B.O','487118',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131870,481,'Kareli S.O','487221',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131871,481,'Karelibasti B.O','487221',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131872,481,'Kashikhedi B.O','487330',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131873,481,'Kathotia B.O','487221',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131874,481,'Kathotiya B.O','487551',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131875,481,'Kaudia S.O','487555',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131876,481,'Kerpani B.O','487001',1,0,'2022-03-04 19:28:11','2022-03-04 19:28:11'),(131877,481,'Khamria B.O','487001',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131878,481,'Khamriya B.O','487118',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131879,481,'Kherinaka B.O','487001',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131880,481,'Kherua B.O','487881',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131881,481,'Khulri B.O','487441',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131882,481,'Khurpa B.O','487001',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131883,481,'Khursipar B.O','487551',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131884,481,'Khursuru B.O','487221',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131885,481,'Kodhsa B.O','487221',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131886,481,'Kosamkheda B.O','487110',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131887,481,'Lathgaon B.O','487118',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131888,481,'Lilwani B.O','487555',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131889,481,'Madesur B.O','487221',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131890,481,'Magdhgula B.O','487661',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131891,481,'Magrdha B.O','487001',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131892,481,'Mallahapipria B.O','487114',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131893,481,'Maregaon B.O','487881',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131894,481,'Mehragaon B.O','487661',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131895,481,'Mekh B.O','487114',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131896,481,'Middli B.O','487330',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131897,481,'Mohad B.O','487221',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131898,481,'Mohas B.O','487114',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131899,481,'Mungwani B.O','487001',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131900,481,'Murghakheda B.O','487114',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131901,481,'Nagwara B.O','487118',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131902,481,'Nandner B.O','487551',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131903,481,'Narsinghpur H.O','487001',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131904,481,'Narsinghpur R.S. S.O','487001',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131905,481,'Narwara B.O','487555',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131906,481,'Nayagaon B.O','487114',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131907,481,'Nayakheda B.O','487001',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131908,481,'Nayakheda Bansadehi B.O','487225',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131909,481,'Neejore B.O','487441',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131910,481,'Neemawar B.O','487661',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131911,481,'Niwari B.O','461771',1,0,'2022-03-04 19:28:12','2022-03-04 19:28:12'),(131912,481,'Niwari B.O','487225',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131913,481,'Padhriya B.O','487330',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131914,481,'Palohabada B.O','487555',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131915,481,'Panari B.O','487441',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131916,481,'Piparia B.O','487661',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131917,481,'Piparpani B.O','487661',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131918,481,'Piparpani B.O','487337',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131919,481,'Pipria(Linga) B.O','487221',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131920,481,'Ponia B.O','487118',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131921,481,'Raipur B.O','487441',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131922,481,'Rakai(Pipria) B.O','487221',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131923,481,'Rakhi B.O','487118',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131924,481,'Rampiparia B.O','487001',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131925,481,'Rampura B.O','487661',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131926,481,'Rampura B.O','487337',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131927,481,'Ranipipria B.O','487110',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131928,481,'Ratikararkalas B.O','487221',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131929,481,'Ricchawar B.O','487555',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131930,481,'Richhai B.O','487330',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131931,481,'Sadumar B.O','487555',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131932,481,'Sadumar B.O','487661',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131933,481,'Sagoni Tendukheda S.O','487337',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131934,481,'Sainkheda S.O (Narsinghpur)','487661',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131935,481,'Sakal B.O','487114',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131936,481,'Sali Choka Road S.O','487881',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131937,481,'Sarra B.O','487118',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131938,481,'Shahpur B.O','487221',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131939,481,'Sihora S.O (Narsinghpur)','487441',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131940,481,'Simaria B.O','487118',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131941,481,'Simribadi B.O','487114',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131942,481,'Singhpur S.O (Narsinghpur)','487110',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131943,481,'Singpur B.O','487881',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131944,481,'Siregaon B.O','487551',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131945,481,'Sirsiri B.O','487661',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131946,481,'Srinagar B.O','487118',1,0,'2022-03-04 19:28:13','2022-03-04 19:28:13'),(131947,481,'Sshavan B.O','487881',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131948,481,'Suatala B.O','487330',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131949,481,'Sukhakhedi B.O','487770',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131950,481,'Surwari B.O','487118',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131951,481,'Tendukheda B.O','487770',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131952,481,'Themi B.O','487114',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131953,481,'Tumra B.O','487661',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131954,481,'Umaria(Chinki) B.O','487001',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131955,481,'Umria B.O','487118',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131956,481,'Usri B.O','487110',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131957,482,'Aankali B.O','458113',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131958,482,'Aantri B.O','458113',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131959,482,'Alheda Jagir B.O','458110',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131960,482,'Amawali Jagir B.O','458441',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131961,482,'Athana B.O','458330',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131962,482,'Athva B.O','458226',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131963,482,'Baghana Neemuch S.O','458441',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131964,482,'Baisala B.O','458118',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131965,482,'Bangred B.O','458220',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131966,482,'Bardia B.O','458110',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131967,482,'Barlai B.O','458116',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131968,482,'Barthun B.O','458113',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131969,482,'Bawal Nai B.O','458330',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131970,482,'Bhadana B.O','458118',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131971,482,'Bhadva B.O','458113',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131972,482,'Bhadwamata B.O','458441',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131973,482,'Bhamesar B.O','458118',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131974,482,'Bharbhadia B.O','458441',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131975,482,'Bhatkheda B.O','458441',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131976,482,'Bhatkhedi B.O','458110',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131977,482,'Bisalwasa Kalan B.O','458441',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131978,482,'Booj B.O','458118',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131979,482,'Bordia Kalan B.O','458553',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131980,482,'Borkhedi Panedi B.O','458441',1,0,'2022-03-04 19:28:14','2022-03-04 19:28:14'),(131981,482,'Chachor B.O','458116',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(131982,482,'Chaldu B.O','458339',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(131983,482,'Chandrapura B.O','458118',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(131984,482,'Chaplana B.O','458113',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(131985,482,'Chayan B.O','458441',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(131986,482,'Chitakheda B.O','458441',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(131987,482,'Chokadi B.O','458110',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(131988,482,'Chukani B.O','458110',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(131989,482,'Dadoli B.O','458220',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(131990,482,'Danta B.O','458116',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(131991,482,'Daroo B.O','458441',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(131992,482,'Deeken B.O','458226',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(131993,482,'Denthal B.O','458113',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(131994,482,'Devari Khawasa B.O','458113',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(131995,482,'Devran B.O','458118',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(131996,482,'Dhamnia B.O','458220',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(131997,482,'Dhangaon B.O','458228',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(131998,482,'Dhardi B.O','458228',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(131999,482,'Dorai B.O','458226',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(132000,482,'Dudhlai B.O','458118',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(132001,482,'Garwada Alori B.O','458226',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(132002,482,'Hadi Piplia B.O','458110',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(132003,482,'Hanspur B.O','458110',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(132004,482,'Hanumantia B.O','458116',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(132005,482,'Harkia Khal B.O','458336',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(132006,482,'Harwar B.O','458336',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(132007,482,'Jaliner B.O','458110',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(132008,482,'Jamunia B.O','458110',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(132009,482,'Jamunia Kalan B.O','458441',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(132010,482,'Janakpur B.O','458220',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(132011,482,'Jannod B.O','458118',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(132012,482,'Jat B.O','458226',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(132013,482,'Javi B.O','458441',1,0,'2022-03-04 19:28:15','2022-03-04 19:28:15'),(132014,482,'Jawad S.O','458330',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132015,482,'Jeeran S.O','458336',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132016,482,'Jhantla B.O','458228',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132017,482,'Jharda B.O','458553',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132018,482,'Kadwasa B.O','458228',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132019,482,'Kanakheda B.O','458441',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132020,482,'Kanawati B.O','458441',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132021,482,'Kanjarda B.O','458110',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132022,482,'Kankria Talai B.O','458226',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132023,482,'Karadia Maharaj B.O','458441',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132024,482,'Kesharpura B.O','458468',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132025,482,'Khadali B.O','458110',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132026,482,'Khadawda B.O','458116',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132027,482,'Khajuri B.O','458113',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132028,482,'Khor S.O','458470',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132029,482,'Kojya B.O','458228',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132030,482,'Kukdeshwar S.O','458116',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132031,482,'Kunchrod B.O','458339',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132032,482,'Kundla B.O','458113',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132033,482,'Lasudia B.O','458118',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132034,482,'Lasur B.O','458220',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132035,482,'Loharia B.O','458226',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132036,482,'Mahagarh S.O','458113',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132037,482,'Majiria B.O','458118',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132038,482,'Malkheda B.O','458441',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132039,482,'Manasa S.O','458110',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132040,482,'Meghpura B.O','458330',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132041,482,'Modi B.O','458220',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132042,482,'Morwan B.O','458220',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132043,482,'Moya B.O','458113',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132044,482,'Nalkheda B.O','458113',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132045,482,'Nalwa B.O','458113',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132046,482,'Naya Malaheda B.O','458110',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132047,482,'Nayagaon C F S.O','458468',1,0,'2022-03-04 19:28:16','2022-03-04 19:28:16'),(132048,482,'Neemuch City S.O','458441',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132049,482,'Neemuch Ghanta Ghar S.O','458441',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132050,482,'Neemuch H.O','458441',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132051,482,'Neemuch Jawahar Nagar B.O','458441',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132052,482,'Neemuch R.S. B.O','458441',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132053,482,'Neemuch Victoria Barracks S.O','458441',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132054,482,'Newad B.O','458441',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132055,482,'Palsoda B.O','458441',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132056,482,'Parda B.O','458110',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132057,482,'Piplia Ghota B.O','458116',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132058,482,'Piplia Raoji B.O','458110',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132059,482,'Piplone B.O','458441',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132060,482,'Rabdia B.O','458441',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132061,482,'Ramnagar B.O','458220',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132062,482,'Rampura S.O (Neemuch)','458118',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132063,482,'Ratangarh S.O','458226',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132064,482,'Revali Devali B.O','458441',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132065,482,'Saroda B.O','458330',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132066,482,'Sarwania Maharaj S.O','458220',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132067,482,'Sawan B.O','458441',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132068,482,'Semali Chandrawat B.O','458220',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132069,482,'Singoli S.O','458228',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132070,482,'Sirkheda B.O','458441',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132071,482,'Suwakheda B.O','458330',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132072,482,'Tal B.O','458228',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132073,482,'Tamoti B.O','458116',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132074,482,'Tarapur B.O','458330',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132075,482,'Thdoli B.O','458441',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132076,482,'Umar B.O','458226',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132077,483,'Adhrod B.O','488442',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132078,483,'Ahirgawan B.O','488001',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132079,483,'Ajaigarh S.O','488220',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132080,483,'Ama B.O','488448',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132081,483,'Amangang S.O','488441',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132082,483,'Amerchhi B.O','488222',1,0,'2022-03-04 19:28:17','2022-03-04 19:28:17'),(132083,483,'Aramganj B.O','488220',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132084,483,'Badagaon B.O','488333',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132085,483,'Badwara B.O','488333',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132086,483,'Baghwar B.O','488442',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132087,483,'Bagrod B.O','488442',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132088,483,'Baharasar B.O','488441',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132089,483,'Banahari Kala B.O','488220',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132090,483,'Banoli B.O','488220',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132091,483,'Banuli B.O','488442',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132092,483,'Baragarhi Camp B.O','488001',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132093,483,'Baramajhaganj B.O','488220',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132094,483,'Bari B.O','488442',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132095,483,'Barkheda B.O','488442',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132096,483,'Barkola B.O','488220',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132097,483,'Barrach S.O','488051',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132098,483,'Barsobha B.O','488441',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132099,483,'Bhapatpura Kurmiyana B.O','488220',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132100,483,'Bhilsain B.O','488333',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132101,483,'Bhitrimutmuri B.O','488333',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132102,483,'Bilgarhi B.O','488441',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132103,483,'Bilha B.O','488050',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132104,483,'Bira B.O','488220',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132105,483,'Birsinghpur B.O','488446',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132106,483,'Birwahi B.O','488333',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132107,483,'Bisani B.O','488448',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132108,483,'Bonda B.O','488441',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132109,483,'Bori B.O','488448',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132110,483,'Brijpur B.O','488001',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132111,483,'Chandora B.O','488220',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132112,483,'Dadwaria B.O','488333',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132113,483,'Dalan  Choki B.O','488001',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132114,483,'Deogaon B.O','488220',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132115,483,'Deorabhapatpur B.O','488220',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132116,483,'Deori B.O','488442',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132117,483,'Deoriranwana B.O','488441',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132118,483,'Devendra Nagar S.O','488333',1,0,'2022-03-04 19:28:18','2022-03-04 19:28:18'),(132119,483,'Dhanwaha B.O','488442',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132120,483,'Dharampur S.O (Panna)','488222',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132121,483,'Diya B.O','488001',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132122,483,'Dwari B.O','488001',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132123,483,'Gajanda B.O','488448',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132124,483,'Ganj B.O','488333',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132125,483,'Ganjabdagaon B.O','488442',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132126,483,'Gargipadaria B.O','488050',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132127,483,'Girwara B.O','488333',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132128,483,'Gunnor S.O','488059',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132129,483,'Gunore B.O','488050',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132130,483,'Gurdinpur B.O','488222',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132131,483,'Hardi B.O','488220',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132132,483,'Harduwa Camp B.O','488001',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132133,483,'Hardwahi B.O','488051',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132134,483,'Hathkuri B.O','488446',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132135,483,'Hirapur B.O','488442',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132136,483,'Itain B.O','488446',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132137,483,'Itwan B.O','488001',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132138,483,'Itwankala B.O','488051',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132139,483,'Jamuniyai B.O','488001',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132140,483,'Janakpur B.O','488001',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132141,483,'Jarguwn B.O','488442',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132142,483,'Jaswantpura B.O','488001',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132143,483,'Jhaladumari B.O','488442',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132144,483,'Jharkuwan B.O','488441',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132145,483,'Jigdaha B.O','488333',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132146,483,'Jijgaon B.O','488441',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132147,483,'Kachori B.O','488448',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132148,483,'Kakarahti S.O','488050',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132149,483,'Kalda B.O','488333',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132150,483,'Kamtana B.O','488441',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132151,483,'Karhai B.O','488446',1,0,'2022-03-04 19:28:19','2022-03-04 19:28:19'),(132152,483,'Karya B.O','488442',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132153,483,'Kathbariya B.O','488333',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132154,483,'Khamariya B.O','488448',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132155,483,'Khamariya B.O','488442',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132156,483,'Khora B.O','488222',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132157,483,'Kiratpur B.O','488222',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132158,483,'Kishangarh B.O','488446',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132159,483,'Kunjwan B.O','488001',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132160,483,'Kunwarpur B.O','488220',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132161,483,'Lahargawan B.O','488050',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132162,483,'Lamtara B.O','488448',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132163,483,'Laxmipur B.O','488001',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132164,483,'Madhvaganj B.O','488220',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132165,483,'Madwa B.O','488442',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132166,483,'Maharajganj B.O','488442',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132167,483,'Maheba B.O','488441',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132168,483,'Mahendra B.O','488442',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132169,483,'Mahod B.O','488442',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132170,483,'Majhgaon B.O','488001',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132171,483,'Makhanpur B.O','488222',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132172,483,'Mandla B.O','488001',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132173,483,'Manipur B.O','488222',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132174,483,'Mudwari B.O','488050',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132175,483,'Murachha B.O','488446',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132176,483,'N.M.D.C Panna B.O','488001',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132177,483,'Nachnora B.O','488050',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132178,483,'Nanchanda B.O','488448',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132179,483,'Nandanpura B.O','488222',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132180,483,'Narayanpura B.O','488446',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132181,483,'Nardaha B.O','488222',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132182,483,'Nawasta B.O','488220',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132183,483,'Nayagaon B.O','488222',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132184,483,'Padara B.O','488441',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132185,483,'Padaraha B.O','488220',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132186,483,'Padariyakala B.O','488446',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132187,483,'Paderi B.O','488050',1,0,'2022-03-04 19:28:20','2022-03-04 19:28:20'),(132188,483,'Palli B.O','488051',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132189,483,'Panna Baldeo Bazar S.O','488001',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132190,483,'Panna Coll S.O','488001',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132191,483,'Panna Gandhi Chowk S.O','488001',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132192,483,'Panna S.O','488001',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132193,483,'Patanakala B.O','488442',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132194,483,'Patankala B.O','488050',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132195,483,'Patatamoli B.O','488333',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132196,483,'Pawai S.O (Panna)','488446',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132197,483,'Phadi Khera B.O','488001',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132198,483,'Pharswaha B.O','488220',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132199,483,'Piperwaha B.O','488441',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132200,483,'Pista B.O','488220',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132201,483,'Pondi B.O','488333',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132202,483,'Purena B.O','488441',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132203,483,'Purena B.O','488448',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132204,483,'Raiguwan B.O','488446',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132205,483,'Raipura S.O','488443',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132206,483,'Ramkheria B.O','488001',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132207,483,'Rampur B.O','488448',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132208,483,'Richhora B.O','488050',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132209,483,'Rohaniya B.O','488448',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132210,483,'Sahanagar S.O (Panna)','488448',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132211,483,'Sakariya B.O','488050',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132212,483,'Saleha B.O','488333',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132213,483,'Samana B.O','488001',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132214,483,'Sarangpur B.O','488448',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132215,483,'Sathniya B.O','488050',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132216,483,'Selon B.O','488220',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132217,483,'Sikarpura B.O','488446',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132218,483,'Simarakala B.O','488446',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132219,483,'Simari B.O','488446',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132220,483,'Simariya S.O','488442',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132221,483,'Singhpur B.O','488220',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132222,483,'Subdua B.O','488220',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132223,483,'Sudor B.O','488448',1,0,'2022-03-04 19:28:21','2022-03-04 19:28:21'),(132224,483,'Sugraha B.O','488448',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132225,483,'Sumgaraha B.O','488050',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132226,483,'Sundara B.O','488333',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132227,483,'Sunwani Kala B.O','488441',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132228,483,'Syameradanda B.O','488333',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132229,483,'Tai B.O','488441',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132230,483,'Tarajharukuwa B.O','488001',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132231,483,'Tikariya B.O','488446',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132232,483,'Umari B.O','488050',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132233,484,'Ankalpur B.O','464993',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132234,484,'Ashapuri B.O','464993',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132235,484,'Bhojpur B.O','464993',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132236,484,'Bilakhedi B.O','464993',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132237,484,'Dahod B.O','464993',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132238,484,'Dewatia B.O','464993',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132239,484,'Iklama B.O','464993',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132240,484,'Noorganj B.O','464993',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132241,484,'Premtalab B.O','464993',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132242,484,'Salkani B.O','464993',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132243,484,'Agariakalan B.O','464884',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132244,484,'Akola B.O','464668',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132245,484,'Aliganj B.O','464668',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132246,484,'Aliwada B.O','464774',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132247,484,'Amapani B.O','464886',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132248,484,'Amkhed B.O','464551',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132249,484,'Amrawad B.O','464665',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132250,484,'Andhiyari B.O','464884',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132251,484,'Andol B.O','464551',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132252,484,'Anghora B.O','464776',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132253,484,'Badgawan B.O','464881',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132254,484,'Badi S.O','464665',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132255,484,'Bagalwada B.O','464668',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132256,484,'Bagaspur B.O','464986',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132257,484,'Baghpiparia B.O','464668',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132258,484,'Bamhori S.O','464672',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132259,484,'Bamhoribhuari B.O','464770',1,0,'2022-03-04 19:28:22','2022-03-04 19:28:22'),(132260,484,'Bamhorigodad B.O','464884',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132261,484,'Bamhorititore B.O','464881',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132262,484,'Bamhoriwardha B.O','464886',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132263,484,'Bangawan B.O','464551',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132264,484,'Bankhedi B.O','464671',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132265,484,'Bankhedi B.O','464551',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132266,484,'Bankhedi(BMR) B.O','464551',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132267,484,'Banskheda B.O','464661',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132268,484,'Bareli Civil Line B.O','464668',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132269,484,'Bareli S.O','464668',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132270,484,'Barhakalar B.O','464770',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132271,484,'Barikala B.O','464665',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132272,484,'Barkhanda B.O','464774',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132273,484,'Barkhedi B.O','464651',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132274,484,'Beerpur B.O','464881',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132275,484,'Begania B.O','464671',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132276,484,'Begumganj S.O','464881',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132277,484,'Begumganj Tahasil B.O','464881',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132278,484,'Berua B.O','464774',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132279,484,'Bhadun B.O','464770',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132280,484,'Bhainsa B.O','464881',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132281,484,'Bharkatchh B.O','464665',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132282,484,'Bhondia B.O','464671',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132283,484,'Bhureru B.O','464881',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132284,484,'Bikalpur B.O','464774',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132285,484,'Boorha B.O','464774',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132286,484,'Boras B.O','464770',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132287,484,'Chainpur B.O','464668',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132288,484,'Champaner B.O','464986',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132289,484,'Chandlakhedi B.O','464990',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132290,484,'Chandoria B.O','464881',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132291,484,'Chandpur B.O','464551',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132292,484,'Chandwad B.O','464881',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132293,484,'Chatter B.O','464770',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132294,484,'Chhabara B.O','464671',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132295,484,'Chicholi B.O','464886',1,0,'2022-03-04 19:28:23','2022-03-04 19:28:23'),(132296,484,'Chikli B.O','464774',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132297,484,'Chiklod B.O','464990',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132298,484,'Chorakamrora B.O','464986',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132299,484,'Choras B.O','464770',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132300,484,'Chunhetia B.O','464886',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132301,484,'Dabraimalia B.O','464551',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132302,484,'Deewanganj B.O','464651',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132303,484,'Dehgaon B.O','464551',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132304,484,'Deori S.O (Raisen)','464774',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132305,484,'Deoriganj B.O','464884',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132306,484,'Dhuwaj B.O','464881',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132307,484,'Dimada B.O','464668',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132308,484,'Doomar B.O','464668',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132309,484,'Gadarwas B.O','464665',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132310,484,'Gairatganj S.O','464884',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132311,484,'Gaiviyan B.O','464770',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132312,484,'Garhi B.O','464884',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132313,484,'Gehuras B.O','464884',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132314,484,'Ghanabehedia B.O','464770',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132315,484,'Goharganj S.O','464990',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132316,484,'Gorakhpur B.O','464774',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132317,484,'Gudawal B.O','464551',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132318,484,'Gugalwada B.O','464665',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132319,484,'Gulgaon B.O','464661',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132320,484,'Gulwada B.O','464881',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132321,484,'Hardot B.O','464884',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132322,484,'Harsili B.O','464665',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132323,484,'Hinotia B.O','464551',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132324,484,'Inthkhedi B.O','464986',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132325,484,'Jaithari B.O','464774',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132326,484,'Jamgarh B.O','464671',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132327,484,'Jamunia B.O','464651',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132328,484,'Jujharpur B.O','464884',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132329,484,'Kamtone B.O','464668',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132330,484,'Kaniwada B.O','464776',1,0,'2022-03-04 19:28:24','2022-03-04 19:28:24'),(132331,484,'Kanth B.O','464551',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132332,484,'Kanwar B.O','464665',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132333,484,'Karamwada B.O','464668',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132334,484,'Karhod B.O','464551',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132335,484,'Katal B.O','464774',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132336,484,'Kebatpiparia B.O','464770',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132337,484,'Keeratpur B.O','464672',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132338,484,'Kenkra B.O','464776',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132339,484,'Keolajhir B.O','464665',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132340,484,'Ketoghan B.O','464770',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132341,484,'Khajuria(BG) B.O','464881',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132342,484,'Khandera B.O','464551',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132343,484,'Khapariakalan B.O','464665',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132344,484,'Khapariakhapa B.O','464986',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132345,484,'Khargone S.O','464671',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132346,484,'Kharwai B.O','464551',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132347,484,'Kheri B.O','464886',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132348,484,'Kuchhiwada B.O','464672',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132349,484,'Kunda B.O','464881',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132350,484,'Kundali B.O','464672',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132351,484,'Kutnasir B.O','464665',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132352,484,'Lilgawan B.O','464551',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132353,484,'Magardha B.O','464668',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132354,484,'Maheshwar B.O','464668',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132355,484,'Makhani B.O','464551',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132356,484,'Manakapur B.O','464665',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132357,484,'Mangrol B.O','464668',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132358,484,'Manjooshkalan B.O','464986',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132359,484,'Manpur B.O','464551',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132360,484,'Markhedagulab B.O','464881',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132361,484,'Markhedatappa B.O','464881',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132362,484,'Mehgaon B.O','464651',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132363,484,'Mehgaonkalan B.O','464886',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132364,484,'Mendki B.O','464661',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132365,484,'Mokalwada B.O','464665',1,0,'2022-03-04 19:28:25','2022-03-04 19:28:25'),(132366,484,'Muar B.O','464886',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132367,484,'Mudiakheda B.O','464551',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132368,484,'Mundlachawal B.O','464881',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132369,484,'Mungalia B.O','464551',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132370,484,'Murelkhurd B.O','464551',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132371,484,'Murhari B.O','464990',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132372,484,'Naigariya B.O','464881',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132373,484,'Nand B.O','464551',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132374,484,'Nanpone B.O','464665',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132375,484,'Narwar B.O','464551',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132376,484,'Noniabareli B.O','464770',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132377,484,'Noornagar B.O','464671',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132378,484,'Padajhir B.O','464881',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132379,484,'Padariarajdhar B.O','464881',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132380,484,'Padraikalan B.O','464774',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132381,484,'Pagneshwar B.O','464651',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132382,484,'Palakmati B.O','464986',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132383,484,'Pamat B.O','464551',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132384,484,'Panjra S.O','464776',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132385,484,'Panjrakashiram B.O','464668',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132386,484,'Papda B.O','464884',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132387,484,'Parsora B.O','464881',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132388,484,'Parwaria B.O','464651',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132389,484,'Pathari B.O','464551',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132390,484,'Pipaliabicholi B.O','464881',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132391,484,'Pipaliapuaria B.O','464770',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132392,484,'Pratapgarh B.O','464774',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132393,484,'Rafchinotia B.O','464551',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132394,484,'Raisen City B.O','464551',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132395,484,'Raisen H.O','464551',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132396,484,'Rajpura B.O','464881',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132397,484,'Rajwada B.O','464671',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132398,484,'Ramkhiria B.O','464776',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132399,484,'Rampurakalan B.O','464884',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132400,484,'Ratngari B.O','464881',1,0,'2022-03-04 19:28:26','2022-03-04 19:28:26'),(132401,484,'Richhawar B.O','464774',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132402,484,'Sadalatpur B.O','464551',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132403,484,'Saikheda B.O','464886',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132404,484,'Salamatpur S.O','464651',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132405,484,'Salera B.O','464551',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132406,484,'Samnapur B.O','464668',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132407,484,'Samnapurkalan B.O','464884',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132408,484,'Samra B.O','464651',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132409,484,'Sanchat B.O','464551',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132410,484,'Sanchi S.O','464661',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132411,484,'Sankheda B.O','464665',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132412,484,'Satehri B.O','464776',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132413,484,'Semrikhurd B.O','464672',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132414,484,'Sewasani B.O','464551',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132415,484,'Silwani S.O','464886',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132416,484,'Siyarmau B.O','464886',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132417,484,'Sodarpur B.O','464886',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132418,484,'Sultanganj B.O','464881',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132419,484,'Sultanpur S.O (Raisen)','464986',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132420,484,'Sumer B.O','464881',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132421,484,'Sunehra B.O','464881',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132422,484,'Sunwaha B.O','464881',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132423,484,'Tamot B.O','464990',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132424,484,'Tarawali-I B.O','464551',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132425,484,'Tarawali-II B.O','464551',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132426,484,'Tekapalgarhi B.O','464884',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132427,484,'Thala B.O','464776',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132428,484,'Timrawan B.O','464774',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132429,484,'Tulsipar B.O','464672',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132430,484,'Tulsipar B.O','464881',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132431,484,'Udaigiri B.O','464668',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132432,484,'Udaipura S.O','464770',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132433,484,'Umarkhoh B.O','464881',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132434,484,'Umravganj B.O','464551',1,0,'2022-03-04 19:28:27','2022-03-04 19:28:27'),(132435,484,'Uncher B.O','464661',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132436,484,'Untiakalan B.O','464668',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132437,484,'Uradmau B.O','464770',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132438,485,'Aagar B.O','465669',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132439,485,'Aamliyahat B.O','465674',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132440,485,'Aandalheda B.O','465669',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132441,485,'Amlaar B.O','465677',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132442,485,'Ashareta B.O','465697',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132443,485,'Bablda B.O','465687',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132444,485,'Badgaon B.O','465693',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132445,485,'Badnagar B.O','465667',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132446,485,'Bagwaaj B.O','465669',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132447,485,'Baiheda B.O','465674',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132448,485,'Bailas B.O','465677',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132449,485,'Bakhed B.O','465687',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132450,485,'Balodi B.O','465697',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132451,485,'Banskheda B.O','465687',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132452,485,'Barbakhurram B.O','465680',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132453,485,'Baredi B.O','465683',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132454,485,'Barkheda B.O','465674',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132455,485,'Barnwa B.O','465674',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132456,485,'Barol B.O','465679',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132457,485,'Bhagoura B.O','465693',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132458,485,'Bhainswamataji B.O','465697',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132459,485,'Bhaisana B.O','465685',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132460,485,'Bhanpura B.O','465693',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132461,485,'Bhatkheda B.O','465689',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132462,485,'Bhatkhedi B.O','465683',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132463,485,'Bhayana B.O','465687',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132464,485,'Bheelvadiya B.O','465683',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132465,485,'Bhojpur B.O','465679',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132466,485,'Bhumariya B.O','465679',1,0,'2022-03-04 19:28:28','2022-03-04 19:28:28'),(132467,485,'Biaora Kalan B.O','465689',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132468,485,'Biaora Mandu B.O','465697',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132469,485,'Biaora R.S. B.O','465674',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132470,485,'Biaora S.O','465674',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132471,485,'Bisoniya B.O','465677',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132472,485,'Boda S.O','465685',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132473,485,'Bokdi B.O','465683',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132474,485,'Borkheda Jageer B.O','465667',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132475,485,'Budhwariya Bazar B.O','465691',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132476,485,'Chatukheda B.O','465661',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132477,485,'Chhapiheda S.O','465689',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132478,485,'Chhota Bairasia B.O','465669',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132479,485,'Chidlavania B.O','465687',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132480,485,'Choma B.O','465680',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132481,485,'Chosla B.O','465687',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132482,485,'Dehri Kalan B.O','465683',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132483,485,'Dhabla B.O','465685',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132484,485,'Dhablikalan B.O','465679',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132485,485,'Dhakora B.O','465674',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132486,485,'Dhamnda B.O','465687',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132487,485,'Dhatarawda B.O','465691',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132488,485,'Dolaj B.O','465679',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132489,485,'Gagorani B.O','465691',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132490,485,'Gangahoni B.O','465669',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132491,485,'Ganiyari B.O','465669',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132492,485,'Geelakhedi B.O','465667',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132493,485,'Gindorhaat B.O','465677',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132494,485,'Gopalpura B.O','465697',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132495,485,'Gulawta B.O','465697',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132496,485,'Haasrod B.O','465677',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132497,485,'Haluhedikalan B.O','465683',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132498,485,'Hinotiya B.O','465685',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132499,485,'Hinotya B.O','465679',1,0,'2022-03-04 19:28:29','2022-03-04 19:28:29'),(132500,485,'Hirankhedi B.O','465661',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132501,485,'Iklera B.O','465680',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132502,485,'Jaitpurakalan B.O','465691',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132503,485,'Jamoniya B.O','465679',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132504,485,'Jamoniyagop B.O','465667',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132505,485,'Jamuniaganesh B.O','465667',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132506,485,'Jhaadmau B.O','465691',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132507,485,'Jhadla B.O','465667',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132508,485,'Jhanjhadpur B.O','465661',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132509,485,'Juna Biaora B.O','465674',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132510,485,'Kaaned B.O','465677',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132511,485,'Kachari B.O','465674',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132512,485,'Kachnariya B.O','465674',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132513,485,'Kalipeeth B.O','465661',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132514,485,'Karanvas B.O','465683',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132515,485,'Karedi B.O','465661',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132516,485,'Kashikhedi B.O','465691',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132517,485,'Khajurigokul B.O','465689',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132518,485,'Khajuriya B.O','465674',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132519,485,'Kharpa B.O','465691',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132520,485,'Khilchipur S.O','465679',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132521,485,'Khilchipur Town B.O','465679',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132522,485,'Khujner S.O','465687',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132523,485,'Khuri B.O','465674',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132524,485,'Kila Amargarh B.O','465661',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132525,485,'Kodkaya B.O','465693',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132526,485,'Koopa B.O','465697',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132527,485,'Kotra B.O','465669',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132528,485,'Kotrikalan B.O','465667',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132529,485,'Kulikheda B.O','465679',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132530,485,'Kunwar Kotri B.O','465685',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132531,485,'Kurawar S.O (Rajgarh)','465667',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132532,485,'Lakhanvaas B.O','465669',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132533,485,'Lakhoni B.O','465693',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132534,485,'Lashkarpur B.O','465669',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132535,485,'Leemachouhan B.O','465687',1,0,'2022-03-04 19:28:30','2022-03-04 19:28:30'),(132536,485,'Limboda B.O','465687',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132537,485,'Limboda B.O','465693',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132538,485,'Machalpur S.O','465693',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132539,485,'Madhumilan Sintax B.O','465674',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132540,485,'Malawar B.O','465674',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132541,485,'Mana B.O','465667',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132542,485,'Mandawar B.O','465685',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132543,485,'Mau B.O','465697',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132544,485,'Mau B.O','465677',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132545,485,'Mawasa B.O','465669',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132546,485,'Mohan B.O','465689',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132547,485,'Moya B.O','465674',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132548,485,'Mundlabarol B.O','465667',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132549,485,'Naahli B.O','465680',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132550,485,'Naanndni B.O','465689',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132551,485,'Napanera B.O','465677',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132552,485,'Narmalschool B.O','465669',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132553,485,'Narsinghgarh S.O','465669',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132554,485,'Nataram B.O','465689',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132555,485,'Nipaniyagarhi B.O','465685',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132556,485,'Pachore S.O','465683',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132557,485,'Padhana B.O','465697',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132558,485,'Padlikhati B.O','465661',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132559,485,'Padlyaanjna B.O','465683',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132560,485,'Padlyadan B.O','465680',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132561,485,'Padlyamatatji B.O','465697',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132562,485,'Panda B.O','465687',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132563,485,'Paniya B.O','465683',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132564,485,'Papdel B.O','465679',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132565,485,'Paroliya B.O','465691',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132566,485,'Parsuliya B.O','465674',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132567,485,'Pilukhedi B.O','465667',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132568,485,'Pipalheda B.O','465674',1,0,'2022-03-04 19:28:31','2022-03-04 19:28:31'),(132569,485,'Pipliya Kulmi B.O','465693',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132570,485,'Pipliyakalan B.O','465691',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132571,485,'Piplodi B.O','465661',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132572,485,'Piplyarasoda B.O','465683',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132573,485,'Polkheda B.O','465693',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132574,485,'Purankhedi B.O','465683',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132575,485,'Rajgarh Bus Stand S.O','465661',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132576,485,'Rajgarh(Bia) H.O','465661',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132577,485,'Rajgarh(Bia) Town B.O','465661',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132578,485,'Ramgarh B.O','465693',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132579,485,'Rosala B.O','465685',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132580,485,'Sadavta B.O','465687',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132581,485,'Sadiakunwa B.O','465679',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132582,485,'Sameli B.O','465679',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132583,485,'Sarali B.O','465683',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132584,485,'Sarangpur S.O','465697',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132585,485,'Sawasda B.O','465661',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132586,485,'Sawasijageer B.O','465669',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132587,485,'Seenkaturkipura B.O','465680',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132588,485,'Semli B.O','465687',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132589,485,'Semlikalan B.O','465679',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132590,485,'Sonkatch B.O','465669',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132591,485,'Sonkheda B.O','465687',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132592,485,'Sultaniya B.O','465683',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132593,485,'Sustani B.O','465683',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132594,485,'Suthalia S.O','465677',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132595,485,'Talen S.O','465680',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132596,485,'Taleni B.O','465697',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132597,485,'Tamoliya B.O','465691',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132598,485,'Tikod B.O','465697',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132599,485,'Tindoniya B.O','465667',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132600,485,'Todi B.O','465677',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132601,485,'Udankhedi B.O','465683',1,0,'2022-03-04 19:28:32','2022-03-04 19:28:32'),(132602,485,'Zeerapur S.O','465691',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132603,486,'Advania B.O','457550',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132604,486,'Alote S.O','457114',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132605,486,'Amargarh B.O','457550',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132606,486,'Amarpurkala B.O','457555',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132607,486,'Ambapada B.O','457550',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132608,486,'Amleta B.O','457222',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132609,486,'Asawati B.O','457336',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132610,486,'Bajna S.O (Ratlam)','457555',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132611,486,'Bajranggarh B.O','457555',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132612,486,'Bangrod B.O','457001',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132613,486,'Banjali B.O','457001',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132614,486,'Banwada B.O','457336',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132615,486,'Barawada B.O','457226',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132616,486,'Baraylamataji B.O','457331',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132617,486,'Barbodna B.O','457222',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132618,486,'Bardiagoyal B.O','457118',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132619,486,'Barkhedakalan B.O','457114',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132620,486,'Baroda B.O','457222',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132621,486,'Basindra B.O','457001',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132622,486,'Bhadankala B.O','457555',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132623,486,'Bhadwasa B.O','457222',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132624,486,'Bhatibarodia B.O','457001',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132625,486,'Bhim B.O','457114',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132626,486,'Bhojakhedi B.O','457114',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132627,486,'Bhutia B.O','457118',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132628,486,'Bibrod B.O','457001',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132629,486,'Bildi B.O','457001',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132630,486,'Bilpank S.O','457441',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132631,486,'Birmawal B.O','457441',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132632,486,'Bodina B.O','457550',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132633,486,'Borkheda B.O','457331',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132634,486,'Chandragarh B.O','457555',1,0,'2022-03-04 19:28:33','2022-03-04 19:28:33'),(132635,486,'Chhaoni Dodia B.O','457555',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132636,486,'Chiklana B.O','457339',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132637,486,'Chourasi Barayla B.O','457226',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132638,486,'Dantodia B.O','457441',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132639,486,'Devla B.O','457001',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132640,486,'Devli B.O','457555',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132641,486,'Dhamedi B.O','457331',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132642,486,'Dhamnod B.O','457001',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132643,486,'Dhanasuta B.O','457001',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132644,486,'Dharad B.O','457441',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132645,486,'Dhaturia B.O','457114',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132646,486,'Dhikwa B.O','457441',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132647,486,'Dhodhar RS S.O','457339',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132648,486,'Dhonswas B.O','457222',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132649,486,'Dilipnagar B.O','457001',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132650,486,'Gadhigamna B.O','457555',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132651,486,'Ghatalia B.O','457001',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132652,486,'Gondishankar B.O','457336',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132653,486,'Guderkheda B.O','457331',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132654,486,'Gulbalod B.O','457118',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132655,486,'Gunawad B.O','457222',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132656,486,'Hanumaniya B.O','457339',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132657,486,'Harthali B.O','457001',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132658,486,'Hasanpalia B.O','457222',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132659,486,'Hatnara B.O','457331',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132660,486,'Hatpiplia B.O','457118',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132661,486,'Husaintekri B.O','457226',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132662,486,'Isarthuni B.O','457001',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132663,486,'Itawakalan B.O','457441',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132664,486,'Itawakhurd B.O','457001',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132665,486,'Jadwasa B.O','457339',1,0,'2022-03-04 19:28:34','2022-03-04 19:28:34'),(132666,486,'Jadwasakalan B.O','457001',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132667,486,'Jambukhadan B.O','457555',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132668,486,'Jamuniashankar B.O','457118',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132669,486,'Jaora Choupati S.O','457226',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132670,486,'Jaora Kutchery S.O','457226',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132671,486,'Jaora S.O','457226',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132672,486,'Jaora Tower S.O','457226',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132673,486,'Jhalwa B.O','457226',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132674,486,'Kalalia B.O','457336',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132675,486,'Kanadia B.O','457114',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132676,486,'Kanderwasa B.O','457222',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132677,486,'Kaneri B.O','457001',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132678,486,'Kangsi B.O','457001',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132679,486,'Karadia B.O','457118',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132680,486,'Karia B.O','457550',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132681,486,'Karwakhedi B.O','457118',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132682,486,'Kasari B.O','457119',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132683,486,'Kelkachh B.O','457555',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132684,486,'Khajuri Devda B.O','457114',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132685,486,'Khalukheda S.O','457340',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132686,486,'Kharuakhurd B.O','457118',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132687,486,'Kharwa kalan S.O','457119',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132688,486,'Kherda B.O','457555',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132689,486,'Khokhra B.O','457550',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132690,486,'Kunda B.O','457550',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132691,486,'Kundanpur B.O','457555',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132692,486,'Lalakheda B.O','457226',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132693,486,'Lasudia B.O','457226',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132694,486,'Lasudiya Surajmal B.O','457119',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132695,486,'Lodh B.O','457118',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132696,486,'Luhari B.O','457226',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132697,486,'Lunera B.O','457001',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132698,486,'Luni B.O','457119',1,0,'2022-03-04 19:28:35','2022-03-04 19:28:35'),(132699,486,'Madhopur B.O','457118',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132700,486,'Malwasa B.O','457001',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132701,486,'Malwasi B.O','457001',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132702,486,'Mamatkheda B.O','457340',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132703,486,'Mandawal B.O','457119',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132704,486,'Mandvi B.O','457336',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132705,486,'Mangrol B.O','457441',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132706,486,'Maota B.O','457340',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132707,486,'Martandganj B.O','457336',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132708,486,'Maukhedi B.O','457333',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132709,486,'Minawada B.O','457119',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132710,486,'Moriya B.O','457339',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132711,486,'Mundlakala B.O','457118',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132712,486,'Mundlaram B.O','457340',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132713,486,'Mundri B.O','457001',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132714,486,'Nagra B.O','457001',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132715,486,'Namli S.O','457222',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132716,486,'Nandleta B.O','457331',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132717,486,'Naugawa B.O','457001',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132718,486,'Naveli B.O','457340',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132719,486,'Nayan B.O','457001',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132720,486,'Negarda B.O','457222',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132721,486,'Nipania Leela B.O','457119',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132722,486,'Palas B.O','457001',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132723,486,'Palduna B.O','457222',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132724,486,'Palsoda B.O','457001',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132725,486,'Palsodi B.O','457001',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132726,486,'Panched B.O','457222',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132727,486,'Panchewa B.O','457333',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132728,486,'Panthpiploda B.O','457118',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132729,486,'Patan B.O','457114',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132730,486,'Pingrala B.O','457339',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132731,486,'Pipalkhunta B.O','457001',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132732,486,'Piplia Jodha B.O','457339',1,0,'2022-03-04 19:28:36','2022-03-04 19:28:36'),(132733,486,'Piplia Sisodia B.O','457114',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132734,486,'Piploda S.O','457331',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132735,486,'PIR HINGORIYA B.O','457118',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132736,486,'Pritamnagar B.O','457441',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132737,486,'Ranayra B.O','457340',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132738,486,'Ranigaon B.O','457333',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132739,486,'Ranisingh B.O','457001',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132740,486,'Raoti B.O','457001',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132741,486,'Ratlam City S.O','457001',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132742,486,'Ratlam Collectorate S.O','457001',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132743,486,'Ratlam Ghatla Colony S.O','457001',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132744,486,'Ratlam H.O','457001',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132745,486,'Ratlam Ind.Area S.O','457001',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132746,486,'Ratlam Jawahar Nagar S.O','457001',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132747,486,'Ratlam Kasara Bazar S.O','457001',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132748,486,'Ratlam Naharpura S.O','457001',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132749,486,'Ratlam Rly Colony S.O','457001',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132750,486,'Ratlam Stn.Road S.O','457001',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132751,486,'Ratlam Surajpole S.O','457001',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132752,486,'Rattagarh B.O','457441',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132753,486,'Rewas B.O','457226',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132754,486,'Richha B.O','457114',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132755,486,'Ringnod S.O','457336',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132756,486,'Riyawan B.O','457333',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132757,486,'Rojana B.O','457226',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132758,486,'Rola B.O','457336',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132759,486,'Sailana S.O','457550',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132760,486,'Sakraoda B.O','457550',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132761,486,'Sarwad B.O','457441',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132762,486,'Sarwan B.O','457550',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132763,486,'Sejawata B.O','457001',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132764,486,'Semlia B.O','457222',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132765,486,'Sherpur B.O','457331',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132766,486,'Sherpurkhurd B.O','457114',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132767,486,'Shivgarh B.O','457001',1,0,'2022-03-04 19:28:37','2022-03-04 19:28:37'),(132768,486,'Shivpur B.O','457001',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132769,486,'Simlaoda B.O','457441',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132770,486,'Sujapur B.O','457333',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132771,486,'Sukheda S.O','457333',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132772,486,'Tal S.O','457118',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132773,486,'Talidana B.O','457340',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132774,486,'Talod B.O','457114',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132775,486,'Tambolia B.O','457001',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132776,486,'Thambguradiya B.O','457119',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132777,486,'Thikria B.O','457555',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132778,486,'Titari B.O','457001',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132779,486,'Umar B.O','457001',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132780,486,'UNI B.O','457118',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132781,486,'Uparwada B.O','457226',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132782,486,'Uplai B.O','457226',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132783,486,'Vikramgarh B.O','457114',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132784,487,'Ajgarha B.O','486003',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132785,487,'Akauri B.O','486223',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132786,487,'Akauri B.O','486556',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132787,487,'Akauri B.O','486111',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132788,487,'Amiliya B.O','486115',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132789,487,'Amilki B.O','486550',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132790,487,'Amilkoni B.O','486220',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132791,487,'Amwa B.O','486446',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132792,487,'Andwa B.O','486223',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132793,487,'Anjora B.O','486220',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132794,487,'Ataria B.O','486445',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132795,487,'Ataria B.O','486446',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132796,487,'Atraila B.O','486226',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132797,487,'Atraila B.O','486447',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132798,487,'Atraila B.O','486117',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132799,487,'Baba Ki Barauli B.O','486223',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132800,487,'Babaiya B.O','486445',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132801,487,'Badagaon  Kothar B.O','486445',1,0,'2022-03-04 19:28:38','2022-03-04 19:28:38'),(132802,487,'Badagaon B.O','486226',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132803,487,'Badagaon B.O','486553',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132804,487,'Badhara B.O','486445',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132805,487,'Badraon B.O','486448',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132806,487,'Badwar B.O','486553',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132807,487,'Bagadha Pidhihan B.O','486440',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132808,487,'Baheradabar B.O','486331',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132809,487,'Bahuribandh B.O','486446',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132810,487,'Bahuti B.O','486331',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132811,487,'Baikunthpur S.O','486441',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132812,487,'Bakshera B.O','486440',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132813,487,'Bandhwa B.O','486115',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132814,487,'Bans B.O','486117',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132815,487,'Bansa B.O','486550',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132816,487,'Bara B.O','486445',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132817,487,'Barahadi B.O','486114',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132818,487,'Barahata B.O','486331',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132819,487,'Barahula B.O','486447',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132820,487,'Baraon B.O','486331',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132821,487,'Baraon B.O','486441',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132822,487,'Barati B.O','486123',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132823,487,'Barsaita B.O','486553',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132824,487,'Basahat B.O','486226',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132825,487,'Basrehi B.O','486447',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132826,487,'Beeda S.O','486446',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132827,487,'Belwa Badgaiyan B.O','486441',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132828,487,'Belwapaikan B.O','486114',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132829,487,'Bhaluha B.O','486340',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132830,487,'Bhamra B.O','486445',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132831,487,'Bhanigawan B.O','486223',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132832,487,'Bharigawan B.O','486341',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132833,487,'Bhatlo B.O','486550',1,0,'2022-03-04 19:28:39','2022-03-04 19:28:39'),(132834,487,'Bhir B.O','486340',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132835,487,'Bhita B.O','486553',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132836,487,'Bholgarh B.O','486450',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132837,487,'Bhungawan B.O','486223',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132838,487,'Bichharahta B.O','486331',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132839,487,'Bihra B.O','486450',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132840,487,'Bihra B.O','486445',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132841,487,'Bijhauli B.O','486335',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132842,487,'Biradei B.O','486335',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132843,487,'Birkham B.O','486446',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132844,487,'Budhiya B.O','486114',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132845,487,'Busaul B.O','486445',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132846,487,'Chachai B.O','486448',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132847,487,'Chak S.O','486226',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132848,487,'Chakdahi B.O','486445',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132849,487,'Champagarh B.O','486223',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132850,487,'Chandai B.O','486226',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132851,487,'Chandpur B.O','486220',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132852,487,'Chaukhadda B.O','486220',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132853,487,'Chaukhandi B.O','486447',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132854,487,'Chaura B.O','486226',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132855,487,'Chitgarh B.O','486445',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132856,487,'Chorahata S.O','486006',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132857,487,'Dabhaura S.O','486556',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132858,487,'Dagardua B.O','486115',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132859,487,'Damodar  Garh B.O','486331',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132860,487,'Delhi B.O','486441',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132861,487,'Delhi B.O','486111',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132862,487,'Deogaon B.O','486111',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132863,487,'Deokhar B.O','486447',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132864,487,'Deora B.O','486445',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132865,487,'Deora B.O','486441',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132866,487,'Deorihangaon B.O','486340',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132867,487,'Deorisengran B.O','486340',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132868,487,'Deotalab S.O','486341',1,0,'2022-03-04 19:28:40','2022-03-04 19:28:40'),(132869,487,'Dewas B.O','486441',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132870,487,'Dhakhara B.O','486226',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132871,487,'Dhangan B.O','486341',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132872,487,'Dhausad B.O','486335',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132873,487,'Dhawa  Tiwariyan B.O','486335',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132874,487,'Dhawaiya B.O','486114',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132875,487,'Dhera S.O','486333',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132876,487,'Dighwar B.O','486123',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132877,487,'Dihiya B.O','486550',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132878,487,'Doha B.O','486441',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132879,487,'Dondar B.O','486556',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132880,487,'Duara B.O','486338',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132881,487,'Dubahai Khurd B.O','486111',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132882,487,'Dubgawan B.O','486335',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132883,487,'Dubgawan B.O','486111',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132884,487,'Dulahara B.O','486448',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132885,487,'Dwari B.O','486123',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132886,487,'Farahada B.O','486333',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132887,487,'Gada-137 B.O','486223',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132888,487,'Gada-138 B.O','486223',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132889,487,'Gangeo B.O','486111',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132890,487,'Garh S.O','486115',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132891,487,'Garhi   Soharwa B.O','486220',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132892,487,'Garhwa B.O','486117',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132893,487,'Gauri B.O','486331',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132894,487,'Ghooman B.O','486556',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132895,487,'Ghopi B.O','486111',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132896,487,'Golahata B.O','486445',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132897,487,'Gondari B.O','486117',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132898,487,'Gondkala B.O','486220',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132899,487,'Gorgaon B.O','486114',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132900,487,'Govindgarh S.O (Rewa)','486550',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132901,487,'Gurh S.O','486553',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132902,487,'Handia B.O','486115',1,0,'2022-03-04 19:28:41','2022-03-04 19:28:41'),(132903,487,'Hanumana S.O','486335',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132904,487,'Hardi B.O','486553',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132905,487,'Hardi Badi B.O','486441',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132906,487,'Hardi Saon B.O','486446',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132907,487,'Hardoli B.O','486556',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132908,487,'Hardua B.O','486445',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132909,487,'Harrai  Badi B.O','486445',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132910,487,'Hata B.O','486335',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132911,487,'Hatwa B.O','486441',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132912,487,'Hatwa B.O','486123',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132913,487,'Hinauta B.O','486446',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132914,487,'Hinauti B.O','486117',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132915,487,'Itma B.O','486447',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132916,487,'Jadua B.O','486445',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132917,487,'Jaldar B.O','486553',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132918,487,'Jamu B.O','486441',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132919,487,'Jamui B.O','486117',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132920,487,'Janakhai B.O','486223',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132921,487,'Janeh B.O','486220',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132922,487,'Jawa S.O','486223',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132923,487,'Jay Pee Puram B.O','486450',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132924,487,'Jaypee Nagar S.O','486450',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132925,487,'Jhalwar B.O','486445',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132926,487,'Jodauri B.O','486441',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132927,487,'Jodhpur B.O','486338',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132928,487,'Jonha B.O','486447',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132929,487,'Joraut B.O','486111',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132930,487,'Judmaniya B.O','486341',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132931,487,'Kachoor B.O','486450',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132932,487,'Kailashpur B.O','486335',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132933,487,'Kakarha B.O','486226',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132934,487,'Kakredi B.O','486445',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132935,487,'Kalwari B.O','486117',1,0,'2022-03-04 19:28:42','2022-03-04 19:28:42'),(132936,487,'Kanauja B.O','486005',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132937,487,'Kanchanpur B.O','486441',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132938,487,'Kanchanpur B.O','486447',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132939,487,'Kandaila B.O','486441',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132940,487,'Kankar B.O','486117',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132941,487,'Kapsa B.O','486446',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132942,487,'Karaundi B.O','486553',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132943,487,'Kashiyargaon B.O','486117',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132944,487,'Katki B.O','486440',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132945,487,'Katra S.O (Rewa)','486117',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132946,487,'Keoti B.O','486117',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132947,487,'Khadda B.O','486446',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132948,487,'Khair B.O','486440',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132949,487,'Khaira B.O','486441',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132950,487,'Khaira B.O','486006',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132951,487,'Khaira Kankesra B.O','486123',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132952,487,'Khajha B.O','486223',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132953,487,'Khajuha Kala B.O','486553',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132954,487,'Khamaria Chaubey B.O','486445',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132955,487,'Kharhari B.O','486440',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132956,487,'Kharihan B.O','486448',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132957,487,'Kharra B.O','486115',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132958,487,'Khatkhari B.O','486331',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132959,487,'Khaur B.O','486005',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132960,487,'Khodwani B.O','486335',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132961,487,'Konigadehara B.O','486447',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132962,487,'Koniyakala B.O','486223',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132963,487,'Korigawan B.O','486340',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132964,487,'Kota B.O','486556',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132965,487,'Kotrakala B.O','486220',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132966,487,'Kotwa B.O','486556',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132967,487,'Kuiyakala B.O','486123',1,0,'2022-03-04 19:28:43','2022-03-04 19:28:43'),(132968,487,'Kulbaheria B.O','486333',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132969,487,'Kumhra Judwani B.O','486445',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132970,487,'Kushwar B.O','486445',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132971,487,'Kuthila B.O','486223',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132972,487,'Lalgaon B.O','486117',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132973,487,'Lalitpur B.O','486550',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132974,487,'Lasa B.O','486335',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132975,487,'Laulachh B.O','486445',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132976,487,'Laxmanpur B.O','486005',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132977,487,'Laxmanpur S.O (Rewa)','486440',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132978,487,'Lohi B.O','486005',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132979,487,'Look B.O','486447',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132980,487,'Maddepur B.O','486450',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132981,487,'Madhi B.O','486111',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132982,487,'Mado B.O','486441',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132983,487,'Madri B.O','486117',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132984,487,'Madri B.O','486556',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132985,487,'Madwa B.O','486550',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132986,487,'Mahmoodpur B.O','486111',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132987,487,'Mahsaon B.O','486553',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132988,487,'Mahsua B.O','486114',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132989,487,'Majhgawan B.O','486335',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132990,487,'Majhigawan B.O','486226',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132991,487,'Majhigawan B.O','486440',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132992,487,'Majhiyar B.O','486440',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132993,487,'Mangawan S.O','486111',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132994,487,'Mangi B.O','486226',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132995,487,'Manikwar S.O','486123',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132996,487,'Mankahari B.O','486440',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132997,487,'Matima B.O','486441',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132998,487,'Mau B.O','486448',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(132999,487,'Mauganj S.O','486331',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(133000,487,'Misirgawan B.O','486331',1,0,'2022-03-04 19:28:44','2022-03-04 19:28:44'),(133001,487,'Moharba B.O','486446',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133002,487,'Mudaria B.O','486331',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133003,487,'Mukundpur B.O','486550',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133004,487,'Nadna B.O','486441',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133005,487,'Naigarhi S.O','486340',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133006,487,'Naudhia B.O','486114',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133007,487,'Naudhiya B.O','486341',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133008,487,'Naunkala B.O','486335',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133009,487,'Nawagaon B.O','486111',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133010,487,'Neega B.O','486550',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133011,487,'Negura B.O','486223',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133012,487,'Nipania B.O','486006',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133013,487,'Pachpahra B.O','486111',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133014,487,'Padar B.O','486333',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133015,487,'Padariya B.O','486123',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133016,487,'Padra B.O','486114',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133017,487,'Padri B.O','486226',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133018,487,'Padri B.O','486448',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133019,487,'Pahadi B.O','486331',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133020,487,'Paharkha B.O','486115',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133021,487,'Paikangaon B.O','486115',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133022,487,'Paipakhara B.O','486450',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133023,487,'Palhan B.O','486441',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133024,487,'Panni B.O','486333',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133025,487,'Panti B.O','486335',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133026,487,'Pantibadi B.O','486553',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133027,487,'Panwar B.O','486556',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133028,487,'Parasi B.O','486115',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133029,487,'Parasiya B.O','486223',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133030,487,'Pariharinpurwa B.O','486447',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133031,487,'Patauta B.O','486553',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133032,487,'Patehara B.O','486331',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133033,487,'Patehara B.O','486335',1,0,'2022-03-04 19:28:45','2022-03-04 19:28:45'),(133034,487,'Patehara S.O','486447',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133035,487,'Pathari B.O','486448',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133036,487,'Pathat B.O','486447',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133037,487,'Patiyari B.O','486223',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133038,487,'Patulkhi B.O','486331',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133039,487,'Phool B.O','486331',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133040,487,'Phulha B.O','486115',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133041,487,'Piprahi B.O','486335',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133042,487,'Purani Jagir B.O','486446',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133043,487,'Purauna B.O','486447',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133044,487,'Purwa B.O','486445',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133045,487,'Purwa B.O','486341',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133046,487,'Ragauli B.O','486445',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133047,487,'Raghunathganj S.O','486338',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133048,487,'Raghurajgarh B.O','486111',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133049,487,'Rahat B.O','486446',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133050,487,'Raipur Karchulion S.O','486114',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133051,487,'Raipur Sonauri B.O','486226',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133052,487,'Rajadhau B.O','486331',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133053,487,'Rajgarh B.O','486448',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133054,487,'Ramnai B.O','486114',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133055,487,'Rampur  Teonther B.O','486340',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133056,487,'Ratahara B.O','486003',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133057,487,'Ratangawan B.O','486333',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133058,487,'Raura B.O','486114',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133059,487,'Rausar B.O','486006',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133060,487,'Rehi B.O','486220',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133061,487,'Rewa AG College S.O','486001',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133062,487,'Rewa APSU S.O','486003',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133063,487,'Rewa Bansagar Coloney S.O','486005',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133064,487,'Rewa Bicchiya Road S.O','486001',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133065,487,'Rewa Chauhatta S.O','486001',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133066,487,'Rewa Chirahula S.O','486001',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133067,487,'Rewa City S.O','486001',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133068,487,'Rewa Engineering College S.O','486002',1,0,'2022-03-04 19:28:46','2022-03-04 19:28:46'),(133069,487,'Rewa Ghoghar Mohalla S.O','486001',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133070,487,'Rewa H.O','486001',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133071,487,'Rewa Medical College S.O','486001',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133072,487,'Rewa Uprahaty S.O','486001',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133073,487,'Rewa Venkat Bhawan S.O','486001',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133074,487,'Rithi B.O','486553',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133075,487,'Rupauli B.O','486446',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133076,487,'Sadahana B.O','486448',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133077,487,'Sagara B.O','486338',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133078,487,'Sagra B.O','486440',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133079,487,'Sansarpur B.O','486441',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133080,487,'Sarai Unmulan B.O','486117',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133081,487,'Saraisenger B.O','486338',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133082,487,'Sarui B.O','486220',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133083,487,'Sathini B.O','486440',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133084,487,'Semariya S.O','486445',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133085,487,'Shahpur B.O','486441',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133086,487,'Shahpur B.O','486331',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133087,487,'Shahpur B.O','485331',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133088,487,'Shivrajpur B.O','486340',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133089,487,'Shukulgawan B.O','486550',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133090,487,'Shukulgawan B.O','486123',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133091,487,'Silpari B.O','486338',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133092,487,'Sirmour S.O','486448',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133093,487,'Sirsa B.O','486111',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133094,487,'Sitapur B.O','486333',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133095,487,'Sitlaha B.O','486223',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133096,487,'Sohagi B.O','486226',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133097,487,'Soharwa B.O','486220',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133098,487,'Sonaura B.O','486003',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133099,487,'Sonauri B.O','486226',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133100,487,'Sonversa B.O','486117',1,0,'2022-03-04 19:28:47','2022-03-04 19:28:47'),(133101,487,'Suji B.O','486123',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133102,487,'Sujwar B.O','486441',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133103,487,'Sukwar B.O','486446',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133104,487,'Supiya B.O','486550',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133105,487,'Sura B.O','486114',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133106,487,'Sursa B.O','486114',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133107,487,'Tamarabasi B.O','486006',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133108,487,'Tamradesh B.O','486123',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133109,487,'Tangha B.O','486223',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133110,487,'Teoni B.O','486111',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133111,487,'Teonthar S.O','486220',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133112,487,'Thp Sirmour S.O','486451',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133113,487,'Tighara B.O','486445',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133114,487,'Tikar B.O','486550',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133115,487,'Tikuri Unmulan B.O','486115',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133116,487,'Tilkhan B.O','486441',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133117,487,'Ulahikhurd B.O','486123',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133118,487,'Umari B.O','486114',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133119,487,'Umari B.O','486448',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133120,487,'Umari Govindpur B.O','486226',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133121,487,'Unchi Auni B.O','486223',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133122,487,'Vasigada B.O','486331',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133123,488,'Agariya B.O','470125',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133124,488,'Amarmau B.O','470339',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133125,488,'Atta B.O','470441',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133126,488,'Baheriya Kalan B.O','470223',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133127,488,'Baheriya Sahani B.O','470001',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133128,488,'Bahrol B.O','470442',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133129,488,'Baleh B.O','470227',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133130,488,'Bamnora B.O','470118',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133131,488,'Bamora S.O','470021',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133132,488,'Bamori Bika B.O','470228',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133133,488,'Banda Belai S.O','470335',1,0,'2022-03-04 19:28:48','2022-03-04 19:28:48'),(133134,488,'Banda Nagar S.O','470335',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133135,488,'Bandri S.O','470442',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133136,488,'Bansa B.O','470125',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133137,488,'Bara B.O','470335',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133138,488,'Baraj B.O','470335',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133139,488,'Bararu B.O','470001',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133140,488,'Barayatha B.O','470335',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133141,488,'Bardha B.O','470113',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133142,488,'Baretha B.O','470335',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133143,488,'Barha B.O','470226',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133144,488,'Barkheda Sikandar B.O','470227',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133145,488,'Baroda Rehli B.O','470228',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133146,488,'Baroda Sagar B.O','470001',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133147,488,'Barodia Kala B.O','470441',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133148,488,'Barodiya Nongar B.O','470117',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133149,488,'Basari B.O','470118',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133150,488,'Baxwaha B.O','470051',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133151,488,'Beldhana B.O','470226',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133152,488,'Besra B.O','470441',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133153,488,'Bhaisa B.O','470120',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133154,488,'Bhaisakhas B.O','470335',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133155,488,'Bhangarh B.O','470113',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133156,488,'Bhapel B.O','470120',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133157,488,'Bharchha B.O','470118',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133158,488,'Bichiya B.O','470232',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133159,488,'Bidwas B.O','470221',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133160,488,'Bidwasan B.O','470115',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133161,488,'Bijora B.O','470226',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133162,488,'Bilagram B.O','470339',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133163,488,'Bilahra Raja S.O','470051',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133164,488,'Bildho B.O','470113',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133165,488,'Bina Bazaria S.O','470113',1,0,'2022-03-04 19:28:49','2022-03-04 19:28:49'),(133166,488,'Bina BORL S.O','470124',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133167,488,'Bina Deori B.O','470226',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133168,488,'Bina Etawa S.O','470113',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133169,488,'Bina S.O','470113',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133170,488,'Binaka B.O','470335',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133171,488,'Chakeri Bineka B.O','470337',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133172,488,'Chanauya Buzurg B.O','470232',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133173,488,'Chandamau B.O','470115',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133174,488,'Chandpur B.O','470227',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133175,488,'Chandrapur B.O','470119',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133176,488,'Chapra B.O','470232',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133177,488,'Chatubhata B.O','470221',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133178,488,'Chauka B.O','470235',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133179,488,'Chhapri B.O','470337',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133180,488,'Chhirari B.O','470227',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133181,488,'Chitora B.O','470051',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133182,488,'Chulla B.O','470232',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133183,488,'Dalppatpur B.O','470339',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133184,488,'Dehri B.O','470113',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133185,488,'Deori Nadipar S.O','470226',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133186,488,'Deori Naharmau B.O','470221',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133187,488,'Deori S.O (Sagar)','470226',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133188,488,'Dewal B.O','470113',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133189,488,'Dhana Naryaoli B.O','470115',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133190,488,'Dhana S.O','470228',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133191,488,'Dhanora B.O','470117',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133192,488,'Dongar Salaiya B.O','470226',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133193,488,'Dugasara B.O','470021',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133194,488,'Dungariya B.O','470125',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133195,488,'Gadola Jageer B.O','470117',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133196,488,'Gadola Jawahar B.O','470118',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133197,488,'Gambhiriyia B.O','470004',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133198,488,'Garhakota Nadipar S.O','470232',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133199,488,'Garhakota S.O','470229',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133200,488,'Gaurjhamar S.O','470223',1,0,'2022-03-04 19:28:50','2022-03-04 19:28:50'),(133201,488,'Gehuras B.O','470125',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133202,488,'Ghambhiriyahat B.O','470120',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133203,488,'Ghana B.O','470235',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133204,488,'Ghoghra Khurd B.O','470335',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133205,488,'Girwar B.O','470021',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133206,488,'Gorakhurd B.O','470669',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133207,488,'Gugra B.O','470335',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133208,488,'Gunjora B.O','470232',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133209,488,'Gutori B.O','470235',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133210,488,'Gutori Pana B.O','470235',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133211,488,'Haldi B.O','470232',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133212,488,'Hilgan B.O','470228',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133213,488,'Hirankheda B.O','470119',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133214,488,'Hirapur B.O','470339',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133215,488,'Isurwara B.O','470115',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133216,488,'Jagthar B.O','470335',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133217,488,'Jaisinagar S.O','470125',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133218,488,'Jaitpur B.O','470226',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133219,488,'Jaitpur Doga B.O','470223',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133220,488,'Jaitpur Kachya B.O','470223',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133221,488,'Jalandhar B.O','470115',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133222,488,'Jaruakheda S.O','470115',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133223,488,'Jerai B.O','470115',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133224,488,'Jhamra B.O','470226',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133225,488,'Jhila B.O','470119',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133226,488,'Jhiriya Adharpur B.O','470235',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133227,488,'Kandwa B.O','470335',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133228,488,'Kanera Gaund B.O','470120',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133229,488,'Kanera Neekhar B.O','470115',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133230,488,'Kanjiya B.O','470113',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133231,488,'Karaiya B.O','470125',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133232,488,'Karo R.S. B.O','470113',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133233,488,'Karrapur S.O','470337',1,0,'2022-03-04 19:28:51','2022-03-04 19:28:51'),(133234,488,'Kasal Pipariya B.O','470227',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133235,488,'Katangi B.O','470051',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133236,488,'Kerwana B.O','470337',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133237,488,'Kesli S.O','470235',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133238,488,'Kevlari Kalan B.O','470235',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133239,488,'Khaijra Harchand B.O','470117',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133240,488,'Khaijra Mafi B.O','470119',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133241,488,'Khaira B.O','470117',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133242,488,'Khairana B.O','470227',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133243,488,'Khataura Kalan B.O','470339',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133244,488,'Khera Udaet B.O','470669',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133245,488,'Khimlasa S.O','470118',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133246,488,'Khiriya Kala B.O','470441',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133247,488,'Khurai City S.O','470117',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133248,488,'Khurai S.O','470117',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133249,488,'Khurai Thawari B.O','470051',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133250,488,'Korja B.O','470113',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133251,488,'Kumarai B.O','470232',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133252,488,'Laloai B.O','470442',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133253,488,'Madi Jamuniya B.O','470223',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133254,488,'Magardha B.O','470335',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133255,488,'Maharajpur B.O','470226',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133256,488,'Mahuna Gujar B.O','470119',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133257,488,'Mahuyakheda B.O','470051',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133258,488,'Malthone S.O','470441',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133259,488,'Manjala B.O','470669',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133260,488,'Manki Salaiya B.O','470119',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133261,488,'Mardanpur B.O','470120',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133262,488,'Masurhai B.O','470120',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133263,488,'Meerkhedi B.O','470119',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133264,488,'Mehar B.O','470442',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133265,488,'Mokalpur B.O','470221',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133266,488,'Muhli B.O','470227',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133267,488,'Muhli B.O','470235',1,0,'2022-03-04 19:28:52','2022-03-04 19:28:52'),(133268,488,'Mukarampur B.O','470117',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133269,488,'Muyarkhas B.O','470226',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133270,488,'Naindhara B.O','470335',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133271,488,'Narwa B.O','470339',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133272,488,'Naryaoliedso B.O','470115',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133273,488,'Naukheda B.O','470118',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133274,488,'Neemon B.O','470335',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133275,488,'Newtna B.O','470442',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133276,488,'Nirtala B.O','470117',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133277,488,'Padarai B.O','470125',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133278,488,'Padarai Buzurg B.O','470226',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133279,488,'Padaria B.O','470021',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133280,488,'Pamakhedi B.O','470004',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133281,488,'Papet B.O','470339',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133282,488,'Parasari Kalan B.O','470119',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133283,488,'Parsone B.O','470441',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133284,488,'Parsoriya B.O','470021',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133285,488,'Patauya B.O','470335',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133286,488,'Patha B.O','470235',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133287,488,'Pathariya Jogan B.O','470118',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133288,488,'Patna Buzurg B.O','470228',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133289,488,'Patna Khurai B.O','470223',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133290,488,'Peepra B.O','470115',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133291,488,'Pidruya B.O','470442',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133292,488,'Pipariaya Pachara B.O','470232',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133293,488,'Pipariya Kachhi B.O','470227',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133294,488,'Piprasar B.O','470113',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133295,488,'Pithoriya B.O','470442',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133296,488,'Purbautori B.O','470001',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133297,488,'Rahatgarh S.O','470119',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133298,488,'Rajuya B.O','470001',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133299,488,'Rajwas B.O','470442',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133300,488,'Rampur B.O','470223',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133301,488,'Rasena B.O','470226',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133302,488,'Rehli S.O','470227',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133303,488,'Rond B.O','470441',1,0,'2022-03-04 19:28:53','2022-03-04 19:28:53'),(133304,488,'Rurawan B.O','470339',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133305,488,'Sagar B I Bazar S.O','470001',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133306,488,'Sagar Bada Bazar S.O','470002',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133307,488,'Sagar Cantt H.O','470001',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133308,488,'Sagar Cavlari Hill S.O','470001',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133309,488,'Sagar City S.O','470002',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133310,488,'Sagar Collectrate S.O','470001',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133311,488,'Sagar Gallamandi S.O','470002',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133312,488,'Sagar Gopalganj S.O','470001',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133313,488,'Sagar Jnpa S.O','470002',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133314,488,'Sagar Luxmipura S.O','470002',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133315,488,'Sagar Makronia Camp S.O','470004',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133316,488,'Sagar Rajakhedi S.O','470004',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133317,488,'Sagar Sadar Bazar S.O','470002',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133318,488,'Sagar Shanichri S.O','470002',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133319,488,'Sagar Subhash Nagar S.O','470002',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133320,488,'Sagar Tilli S.O','470001',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133321,488,'Sagar University S.O','470003',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133322,488,'Sagoni B.O','470442',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133323,488,'Sahajpur B.O','470235',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133324,488,'Sahawan B.O','470337',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133325,488,'Samnapur B.O','470051',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133326,488,'Sanodha B.O','470021',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133327,488,'Sarkhadi B.O','470125',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133328,488,'Sarkhadi B.O','470117',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133329,488,'Satnai B.O','470117',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133330,488,'Sattadhana B.O','470120',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133331,488,'Sawal Khiriya B.O','470227',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133332,488,'Semra Lodhi B.O','470441',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133333,488,'Semrahat B.O','470442',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133334,488,'Sesai Saji B.O','470441',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133335,488,'Sewas B.O','470232',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133336,488,'Shahgarh S.O (Sagar)','470339',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133337,488,'Shahpur Magrone S.O','470669',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133338,488,'Shyampura B.O','470001',1,0,'2022-03-04 19:28:54','2022-03-04 19:28:54'),(133339,488,'Sihora S.O (Sagar)','470120',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133340,488,'Silodha B.O','470117',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133341,488,'Simariya B.O','470226',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133342,488,'Singpur B.O','470226',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133343,488,'Singpur Sadguya B.O','470226',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133344,488,'Sothiya B.O','470001',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133345,488,'Surkhi S.O','470221',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133346,488,'Tada B.O','470669',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133347,488,'Tada B.O','470235',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133348,488,'Teora B.O','470117',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133349,488,'Thikari B.O','470120',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133350,488,'Tigoda B.O','470339',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133351,488,'Tila Buzurg B.O','470120',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133352,488,'Tinsi B.O','470228',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133353,488,'Toda Tarafdar B.O','470125',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133354,488,'Udaypura B.O','470232',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133355,488,'Udaypura Tiwari B.O','470221',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133356,488,'Uldan B.O','470335',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133357,488,'Umra B.O','470232',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133358,488,'Bamora R.S S.O','464240',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133359,488,'Sanai B.O','464240',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133360,489,'Aber B.O','485226',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133361,489,'Ahirgaon B.O','485775',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133362,489,'Aira B.O','485115',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133363,489,'Ajmain B.O','485772',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133364,489,'Ama B.O','485447',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133365,489,'Amadara S.O','485773',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133366,489,'Amarpatan S.O','485775',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133367,489,'Amatara B.O','485772',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133368,489,'Amdarikala B.O','485446',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133369,489,'Amkui B.O','485551',1,0,'2022-03-04 19:28:55','2022-03-04 19:28:55'),(133370,489,'Argat B.O','485881',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133371,489,'Arjunpur B.O','485331',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133372,489,'Asilash Ashram B.O','485334',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133373,489,'Asrar B.O','485775',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133374,489,'Atra B.O','485446',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133375,489,'Babupur B.O','485775',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133376,489,'Babupur B.O','485446',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133377,489,'Babupur B.O','485881',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133378,489,'Babupur S.O','485112',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133379,489,'Bachwai B.O','485441',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133380,489,'Badera B.O','485772',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133381,489,'Badkhar B.O','485005',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133382,489,'Badkhera B.O','485226',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133383,489,'Bagha B.O','485001',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133384,489,'Baheliabaht B.O','485115',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133385,489,'Bairahana B.O','485226',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133386,489,'Bairiha B.O','485111',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133387,489,'Bakia B.O','485111',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133388,489,'Bamhauri B.O','485221',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133389,489,'Bamhraula B.O','485666',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133390,489,'Bandhi B.O','485441',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133391,489,'Barahana B.O','485666',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133392,489,'Barakhurd B.O','485881',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133393,489,'Baraundha B.O','485331',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133394,489,'Barethiya B.O','485441',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133395,489,'Barti B.O','485111',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133396,489,'Barua B.O','485331',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133397,489,'Basudha B.O','485447',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133398,489,'Bathia B.O','485111',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133399,489,'Bathia B.O','485774',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133400,489,'Beeda B.O','485775',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133401,489,'Bela B.O','485115',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133402,489,'Belhai B.O','485881',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133403,489,'Belhata B.O','485113',1,0,'2022-03-04 19:28:56','2022-03-04 19:28:56'),(133404,489,'Berma B.O','485773',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133405,489,'Bhadanpur B.O','485772',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133406,489,'Bhainswar B.O','485666',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133407,489,'Bharhut B.O','485001',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133408,489,'Bharjuna Kala B.O','485114',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133409,489,'Bhatigawan B.O','485774',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133410,489,'Bhatnawara B.O','485001',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133411,489,'Bhenda B.O','485774',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133412,489,'Bhiamau B.O','485331',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133413,489,'Bhikhampur B.O','485778',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133414,489,'Bhumkahar B.O','485001',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133415,489,'Bigaudi B.O','485778',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133416,489,'Bihara B.O','485111',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133417,489,'Bihata B.O','485661',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133418,489,'Binaika B.O','485773',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133419,489,'Birnai B.O','485113',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133420,489,'Birsinghpur S.O','485226',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133421,489,'Bitma B.O','485226',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133422,489,'Budherua B.O','485774',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133423,489,'Chandai B.O','485221',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133424,489,'Chandwar B.O','485881',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133425,489,'Chhibaura B.O','485111',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133426,489,'Chhirhai B.O','485881',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133427,489,'Chitahara B.O','485331',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133428,489,'Chorhata B.O','485775',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133429,489,'Chormari B.O','485115',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133430,489,'Chorwari B.O','485447',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133431,489,'Chua B.O','485331',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133432,489,'Chund Khurd B.O','485221',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133433,489,'Chunha B.O','485551',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133434,489,'Dagdiha B.O','485221',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133435,489,'Deodaha B.O','485881',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133436,489,'Deomaudaldal B.O','485111',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133437,489,'Deora B.O','485115',1,0,'2022-03-04 19:28:57','2022-03-04 19:28:57'),(133438,489,'Deora B.O','485226',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133439,489,'Deorikala B.O','485666',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133440,489,'Dhanwahi B.O','485772',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133441,489,'Dhaurahara B.O','485778',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133442,489,'Dhaurahara B.O','485441',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133443,489,'Dhaurahara B.O','485446',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133444,489,'Dighiakala B.O','485881',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133445,489,'Domhai B.O','485226',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133446,489,'Dubehi B.O','485774',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133447,489,'Dureha B.O','485551',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133448,489,'Gada B.O','485113',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133449,489,'Gangwaria B.O','485446',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133450,489,'Ganjan B.O','485111',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133451,489,'Ganjas B.O','485881',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133452,489,'Garhwa Kala B.O','485112',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133453,489,'Ghorkat B.O','485226',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133454,489,'Ghunwara B.O','485773',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133455,489,'Ginjara B.O','485446',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133456,489,'Gobri B.O','485774',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133457,489,'Gora B.O','485778',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133458,489,'Goraiya B.O','485112',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133459,489,'Goraiya B.O','485881',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133460,489,'Gorhai B.O','485881',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133461,489,'Gorsari B.O','485881',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133462,489,'Govindpur B.O','485881',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133463,489,'Gudha B.O','485551',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133464,489,'Gulwargujara B.O','485881',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133465,489,'Hardua B.O','485334',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133466,489,'Hardua Kala B.O','485446',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133467,489,'Harrai B.O','485881',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133468,489,'Hati B.O','485221',1,0,'2022-03-04 19:28:58','2022-03-04 19:28:58'),(133469,489,'Hatia B.O','485221',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133470,489,'Hilaundha B.O','485441',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133471,489,'Hinauta Kala B.O','485774',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133472,489,'Hinauti B.O','485881',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133473,489,'Hiraundi B.O','485331',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133474,489,'Ichaul B.O','485771',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133475,489,'Itahara B.O','485773',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133476,489,'Itma B.O','485771',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133477,489,'Itma B.O','485881',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133478,489,'Itmanaditeer B.O','485001',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133479,489,'Jaitwara S.O','485221',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133480,489,'Jamuani B.O','485226',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133481,489,'Jamuna B.O','485115',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133482,489,'Janardanpur B.O','485111',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133483,489,'Jariyari B.O','485774',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133484,489,'Jaso S.O','485551',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133485,489,'Jathaha B.O','485881',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133486,489,'Jhakhaura B.O','485226',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133487,489,'Jhali B.O','485666',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133488,489,'Jhand B.O','485115',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133489,489,'Jhari B.O','485331',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133490,489,'Jhingodar B.O','485551',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133491,489,'Jhinna B.O','485115',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133492,489,'Jhiriya B.O','485115',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133493,489,'Jhukehi B.O','485773',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133494,489,'Jura B.O','485774',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133495,489,'Kadsara B.O','485447',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133496,489,'Kailashpur B.O','485331',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133497,489,'Kakalpur B.O','485115',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133498,489,'Kakra Karhi B.O','485775',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133499,489,'Kalbalia B.O','485226',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133500,489,'Kandaila B.O','485111',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133501,489,'Kandwari B.O','485881',1,0,'2022-03-04 19:28:59','2022-03-04 19:28:59'),(133502,489,'Karhi Kala B.O','485447',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133503,489,'Karhikala B.O','485661',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133504,489,'Karhilami B.O','485115',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133505,489,'Karigohi B.O','485226',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133506,489,'Karra B.O','485881',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133507,489,'Kathaha S.O','485778',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133508,489,'Kelhaura B.O','485331',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133509,489,'Khajuri Tal B.O','485775',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133510,489,'Khamaria B.O','485112',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133511,489,'Khamharia Khurd B.O','485447',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133512,489,'Khanch B.O','485226',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133513,489,'Kharemseda B.O','485775',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133514,489,'Kharwahi B.O','485775',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133515,489,'Khohi B.O','485331',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133516,489,'Khutha B.O','485221',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133517,489,'Kitha B.O','485221',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133518,489,'Kondar B.O','485331',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133519,489,'Kondar B.O','485551',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133520,489,'Kotar B.O','485226',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133521,489,'Kothi S.O (Satna)','485666',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133522,489,'Kripalpur Harijan Tola B.O','485113',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133523,489,'Krishngarh B.O','485115',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133524,489,'Kulgarhi B.O','485446',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133525,489,'Kumhari B.O','485447',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133526,489,'Kumhari B.O','485778',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133527,489,'Kunwa B.O','485112',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133528,489,'Kusendi B.O','485773',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133529,489,'Lagargawan B.O','485001',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133530,489,'Lakhaha B.O','485775',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133531,489,'Lakhanwah B.O','485226',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133532,489,'Latagaon B.O','485772',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133533,489,'Loharaura B.O','485001',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133534,489,'M G  G V chitrakoot S.O','485334',1,0,'2022-03-04 19:29:00','2022-03-04 19:29:00'),(133535,489,'Madai B.O','485447',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133536,489,'Madai B.O','485772',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133537,489,'Madhi B.O','485775',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133538,489,'Madhogarh S.O (Satna)','485113',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133539,489,'Magraura B.O','485774',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133540,489,'Mahadeva B.O','485001',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133541,489,'Mahtain B.O','485331',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133542,489,'Mahudar B.O','485115',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133543,489,'Maihar S.O','485771',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133544,489,'Majhgawa B.O','485221',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133545,489,'Majhgawan B.O','485778',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133546,489,'Majhgawan S.O','485331',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133547,489,'Majhtolwa B.O','485881',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133548,489,'Mand B.O','485113',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133549,489,'Mankisar B.O','485881',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133550,489,'Marhikala B.O','485551',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133551,489,'Marjadpur B.O','485881',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133552,489,'Mauhar B.O','485666',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133553,489,'Mauhari Katra B.O','485775',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133554,489,'Mednipur B.O','485221',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133555,489,'Mehuti B.O','485221',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133556,489,'Mirgauti B.O','485881',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133557,489,'Moodha B.O','485441',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133558,489,'Nadan S.O','485774',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133559,489,'Nagod S.O','485446',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133560,489,'Nakaila B.O','485331',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133561,489,'Nardaha B.O','485331',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133562,489,'Narwarkala B.O','485774',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133563,489,'Nawagaon B.O','485226',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133564,489,'Nawagaon B.O','485334',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133565,489,'Nayagaon B.O','485221',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133566,489,'New Deorajnagar B.O','485881',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133567,489,'Obra B.O','485775',1,0,'2022-03-04 19:29:01','2022-03-04 19:29:01'),(133568,489,'Padkhuri B.O','485111',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133569,489,'Pagar Khurd B.O','485226',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133570,489,'Pahadi B.O','485551',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133571,489,'Pahadi B.O','485771',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133572,489,'Pal B.O','485775',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133573,489,'Pangara B.O','485447',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133574,489,'Paraswahi B.O','485775',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133575,489,'Pathar Kachhar B.O','485331',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133576,489,'Pathara B.O','485778',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133577,489,'Patihar B.O','485666',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133578,489,'Patna B.O','485331',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133579,489,'Patura B.O','485001',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133580,489,'Patwara B.O','485446',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133581,489,'Pawaiya B.O','485666',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133582,489,'Pilikothi B.O','485334',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133583,489,'Pindra B.O','485331',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133584,489,'Pithurabad B.O','485001',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133585,489,'Pitlikothi B.O','485334',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133586,489,'Pondi B.O','485771',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133587,489,'Pratappur B.O','485226',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133588,489,'Rahikwara B.O','485446',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133589,489,'Raigaon B.O','485441',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133590,489,'Raikwar B.O','485775',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133591,489,'Raipur B.O','485666',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133592,489,'Rajapur B.O','485446',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133593,489,'Rajarwara B.O','485226',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133594,489,'Rajarwara B.O','485441',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133595,489,'Ramasthan B.O','485112',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133596,489,'Ramgarh B.O','485778',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133597,489,'Ramnagar S.O (Satna)','485881',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133598,489,'Rampur Baghelan S.O','485115',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133599,489,'Rampur Gandhi Gram B.O','485001',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133600,489,'Ramvan S.O','485111',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133601,489,'Raund B.O','485447',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133602,489,'Remari B.O','485226',1,0,'2022-03-04 19:29:02','2022-03-04 19:29:02'),(133603,489,'Richhahari B.O','485111',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133604,489,'Sabhaganj B.O','485001',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133605,489,'Sagauni B.O','485881',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133606,489,'Sagmania S.O','485114',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133607,489,'Sakaria B.O','485113',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133608,489,'Sarain B.O','485113',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133609,489,'Saria B.O','485881',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133610,489,'Sarlanagar S.O','485772',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133611,489,'Satna Birla Vikas S.O','485005',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133612,489,'Satna Civil Line S.O','485001',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133613,489,'Satna H.O','485001',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133614,489,'Satna Jawahar Nagar S.O','485001',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133615,489,'Satna Kanwarnagar B.O','485005',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133616,489,'Satna Semaria Chowk S.O','485001',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133617,489,'Satna Siding B.O','485114',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133618,489,'Satna Tikuria Tola S.O','485001',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133619,489,'Semara B.O','485773',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133620,489,'Semari B.O','485551',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133621,489,'Semaria B.O','485115',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133622,489,'Semarwara B.O','485446',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133623,489,'Sharda Mata Mandir B.O','485771',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133624,489,'Shivpurwa B.O','485775',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133625,489,'Shivrajpur B.O','485447',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133626,489,'Shyamnagar B.O','485446',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133627,489,'Sijehata B.O','485111',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133628,489,'Silpari B.O','485115',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133629,489,'Singhpur B.O','485331',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133630,489,'Singhpur S.O (Satna)','485447',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133631,489,'Sitpura B.O','485441',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133632,489,'Sohawal S.O','485441',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133633,489,'Sonadi B.O','485881',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133634,489,'Sonaura Kothar B.O','485775',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133635,489,'Sonsura Kothar B.O','485775',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133636,489,'Sonwari B.O','485771',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133637,489,'Sukwaha B.O','485226',1,0,'2022-03-04 19:29:03','2022-03-04 19:29:03'),(133638,489,'Sulkhama B.O','485881',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133639,489,'Surdaha B.O','485446',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133640,489,'Tala B.O','485778',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133641,489,'Tapa B.O','485115',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133642,489,'Teondhari B.O','485115',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133643,489,'Tighra B.O','485226',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133644,489,'Tighrakala B.O','485771',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133645,489,'Tihai B.O','485226',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133646,489,'Umarahat B.O','485447',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133647,489,'Unchehara S.O','485661',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133648,489,'Usrar B.O','485447',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133649,490,'Aabidabad B.O','466111',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133650,490,'Aamon B.O','466448',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133651,490,'Aarya B.O','466115',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133652,490,'Ahmedpur S.O (Sehore)','466665',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133653,490,'Aipur Ashta B.O','466116',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133654,490,'Akola B.O','466554',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133655,490,'Amirganj B.O','466446',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133656,490,'Amlaha S.O','466113',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133657,490,'Arniyaganji B.O','466221',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133658,490,'Aroliya B.O','466116',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133659,490,'Ashta Fort B.O','466116',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133660,490,'Ashta S.O','466116',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133661,490,'Badiyakhedi B.O','466001',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133662,490,'Bager B.O','466116',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133663,490,'Baibori B.O','466331',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133664,490,'Baijnath B.O','466125',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133665,490,'Bairagarhkhuman B.O','466651',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133666,490,'Baktal B.O','466001',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133667,490,'Baktara S.O','466448',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133668,490,'Balagaon B.O','466331',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133669,490,'Bamulia B.O','466111',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133670,490,'Bamuliyabhati B.O','466116',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133671,490,'Baneta B.O','466554',1,0,'2022-03-04 19:29:04','2022-03-04 19:29:04'),(133672,490,'Barkheda B.O','466116',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133673,490,'Barkheda Hasan B.O','466665',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133674,490,'Basudev B.O','466331',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133675,490,'Bayan B.O','466445',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133676,490,'Bedakhedi B.O','466114',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133677,490,'Bhadakui B.O','466331',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133678,490,'Bhanwarikalan B.O','466221',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133679,490,'Bhaukhedi B.O','466115',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133680,490,'Bhoura B.O','466116',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133681,490,'Bijlone B.O','466001',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133682,490,'Bijori B.O','466001',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133683,490,'Bilkisganj S.O','466111',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133684,490,'Bishankhedi B.O','466115',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133685,490,'Bordikalan B.O','466115',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133686,490,'Borkheda B.O','466114',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133687,490,'Borkheda B.O','466331',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133688,490,'Brijisnagar B.O','466115',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133689,490,'Budhni T.N. S.O','466445',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133690,490,'Budni Ghat B.O','466445',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133691,490,'Chakaldi B.O','466446',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133692,490,'Chandbad  Jageer B.O','466665',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133693,490,'Charnal B.O','466665',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133694,490,'Chhapar B.O','466116',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133695,490,'Chhatri B.O','466661',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133696,490,'Chhipaner B.O','466331',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133697,490,'Chhitgaonmoji B.O','466331',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133698,490,'Chinch B.O','466331',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133699,490,'Chupadiya B.O','466114',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133700,490,'Dabri B.O','466116',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133701,490,'Dabri B.O','466115',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133702,490,'Deevadia B.O','466115',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133703,490,'Dhabla B.O','466111',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133704,490,'Dhamnda B.O','466113',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133705,490,'Dhoulpur B.O','466331',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133706,490,'Dhuradakalan B.O','466120',1,0,'2022-03-04 19:29:05','2022-03-04 19:29:05'),(133707,490,'Digwad B.O','466331',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133708,490,'Dimawar B.O','466331',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133709,490,'Dobi B.O','466554',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133710,490,'Dolatpur B.O','466115',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133711,490,'Doraha S.O (Sehore)','466661',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133712,490,'Dungariya B.O','466554',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133713,490,'Dupadiya B.O','466116',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133714,490,'Foodra B.O','466116',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133715,490,'Gavakheda B.O','466114',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133716,490,'Ghoghatpur B.O','465693',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133717,490,'Gillor B.O','466331',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133718,490,'Gopalpur B.O','466331',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133719,490,'Guradi B.O','466115',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133720,490,'Guradiyavarma B.O','466118',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133721,490,'Gwali B.O','466118',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133722,490,'Hakimabad B.O','466116',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133723,490,'Harrajkhedi B.O','466116',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133724,490,'Hasnabad B.O','466001',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133725,490,'Heerapur B.O','466111',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133726,490,'Ichawar S.O','466115',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133727,490,'Itarshi B.O','466331',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133728,490,'Jahajpura B.O','466445',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133729,490,'Jamoniya Fathepur B.O','466115',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133730,490,'Janpur Bavdiya B.O','466001',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133731,490,'Jasmat B.O','466120',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133732,490,'Jatakheda B.O','466001',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133733,490,'Jawaharkheda B.O','466554',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133734,490,'Jawar S.O (Sehore)','466221',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133735,490,'Jhalki B.O','466115',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133736,490,'Jharkheda B.O','466661',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133737,490,'Jontala B.O','466448',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133738,490,'Joshipur B.O','466445',1,0,'2022-03-04 19:29:06','2022-03-04 19:29:06'),(133739,490,'Kachnariya B.O','466651',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133740,490,'Kajlaas B.O','466221',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133741,490,'Kannod B.O','466116',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133742,490,'Khachrod B.O','466116',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133743,490,'Khadi B.O','466116',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133744,490,'Khadli B.O','466446',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133745,490,'Khaikheda B.O','466445',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133746,490,'Khajuriya Kasam B.O','466120',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133747,490,'Khajuriyakalan B.O','466651',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133748,490,'Khamaliya B.O','466001',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133749,490,'Khandwa B.O','466651',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133750,490,'Kheri B.O','466115',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133751,490,'Kheri B.O','466446',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133752,490,'Kotri S.O (Sehore)','466114',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133753,490,'Kulaskalan B.O','466111',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133754,490,'Kurawar B.O','466116',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133755,490,'Kurinayapura B.O','466331',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133756,490,'Ladkui B.O','466331',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133757,490,'Lasudiakhas B.O','466114',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133758,490,'Loraskhurd B.O','466125',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133759,490,'Magarda B.O','466665',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133760,490,'Mahodiya B.O','466001',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133761,490,'Maina S.O','466125',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133762,490,'Manjharkui B.O','466446',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133763,490,'Mardanpur B.O','466446',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133764,490,'Metwada S.O','466118',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133765,490,'Mograram B.O','466001',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133766,490,'Molukhedi B.O','466114',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133767,490,'Mugli B.O','466116',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133768,490,'Muktarnagar B.O','466651',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133769,490,'Mundlakhurd B.O','466001',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133770,490,'Mungavli B.O','466001',1,0,'2022-03-04 19:29:07','2022-03-04 19:29:07'),(133771,490,'Murawar B.O','466221',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133772,490,'Muskara B.O','466113',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133773,490,'Nandgaon B.O','466331',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133774,490,'Nandner B.O','466448',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133775,490,'Naplakhedi B.O','466001',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133776,490,'Narsinghkheda B.O','466115',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133777,490,'Nasrllaganj S.O','466331',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133778,490,'Nimota B.O','466331',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133779,490,'Nipaniakalan B.O','466114',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133780,490,'Nipaniya B.O','466001',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133781,490,'Nougaon B.O','466120',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133782,490,'Paatan B.O','466445',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133783,490,'Pachama B.O','466001',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133784,490,'Panguradiya B.O','466445',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133785,490,'Paraswada B.O','466554',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133786,490,'Pilikarar B.O','466445',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133787,490,'Piplaani B.O','466331',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133788,490,'Rehti S.O','466446',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133789,490,'Rithwad B.O','466331',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133790,490,'Salkanpur B.O','466446',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133791,490,'Sardarnagar B.O','466554',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133792,490,'Satrana B.O','466331',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133793,490,'Sehore City S.O','466001',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133794,490,'Sehore Englishpura B.O','466001',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133795,490,'Sehore Ganjbajariya B.O','466001',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133796,490,'Sehore H.O','466001',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133797,490,'Sehore Mandi S.O','466001',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133798,490,'Sehore Rak B.O','466001',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133799,490,'Sehore Town B.O','466001',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133800,490,'Semalpani B.O','466331',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133801,490,'Semlijadid B.O','466115',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133802,490,'Semradangi B.O','466001',1,0,'2022-03-04 19:29:08','2022-03-04 19:29:08'),(133803,490,'Semrikatkuna B.O','466446',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133804,490,'Sewda B.O','466125',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133805,490,'Shahganj S.O (Sehore)','466554',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133806,490,'Shyampur S.O (Sehore)','466651',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133807,490,'Siddikganj S.O','466120',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133808,490,'Siradi B.O','466651',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133809,490,'Sonthi B.O','466651',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133810,490,'Sonthiya B.O','466331',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133811,490,'Soyat B.O','466446',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133812,490,'Sudamapuri B.O','466331',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133813,490,'Tiladiya B.O','466331',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133814,490,'Torniya B.O','466115',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133815,490,'Uljhawan B.O','466111',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133816,490,'Veerpur Kolardem B.O','466111',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133817,491,'Adegaon S.O','480887',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133818,491,'Aloniya B.O','480882',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133819,491,'Amagarh B.O','480771',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133820,491,'Amgaon B.O','480661',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133821,491,'Anjania B.O','480884',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133822,491,'Antara B.O','480667',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133823,491,'Ari S.O','480771',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133824,491,'Ashta B.O','480667',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133825,491,'Atari B.O','480667',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133826,491,'Ataria B.O','480997',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133827,491,'Babaira B.O','480661',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133828,491,'Badalpar B.O','480661',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133829,491,'Baghai B.O','480994',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133830,491,'Baglai B.O','480994',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133831,491,'Baigapiparia B.O','480888',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133832,491,'Bakhari B.O','480882',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133833,491,'Bakoda Seoni B.O','480884',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133834,491,'Bakodi B.O','480882',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133835,491,'Balpur B.O','480997',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133836,491,'Bamhani B.O','480667',1,0,'2022-03-04 19:29:09','2022-03-04 19:29:09'),(133837,491,'Bamhanwada B.O','480886',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133838,491,'Bamhodi B.O','480661',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133839,491,'Banathar B.O','480996',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133840,491,'Bandeli B.O','480994',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133841,491,'Bandol S.O','480882',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133842,491,'Banjari B.O','480888',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133843,491,'Banki B.O','480882',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133844,491,'Barela B.O','480997',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133845,491,'Barelaghat B.O','480999',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133846,491,'Barghat S.O','480667',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133847,491,'Baroda B.O','480999',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133848,491,'Behrai B.O','480667',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133849,491,'Belpeth B.O','480661',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133850,491,'Bewhari B.O','480997',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133851,491,'Bhimgarh B.O','480884',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133852,491,'Bhimgarh Project B.O','480884',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133853,491,'Bhoma B.O','480990',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133854,491,'Bhongakheda B.O','480882',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133855,491,'Binjhawada B.O','480661',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133856,491,'Birholi B.O','480771',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133857,491,'Bordai B.O','480661',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133858,491,'Borikala B.O','480667',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133859,491,'Budhenakala B.O','480667',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133860,491,'Chakki Khamariya B.O','480661',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133861,491,'Chamari(khurd) B.O','480887',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133862,491,'Chandarpur B.O','480880',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133863,491,'Chandori(khurd) B.O','480882',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133864,491,'Chawadi B.O','480661',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133865,491,'Chhapara S.O','480884',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133866,491,'Chhinda B.O','480994',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133867,491,'Chhindbarri B.O','480990',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133868,491,'Chhui B.O','480990',1,0,'2022-03-04 19:29:10','2022-03-04 19:29:10'),(133869,491,'Chutka B.O','480990',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133870,491,'Dankakadi B.O','480888',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133871,491,'Darasikala B.O','480771',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133872,491,'Dargada B.O','480888',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133873,491,'Deogaon B.O','480884',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133874,491,'Deori B.O','480888',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133875,491,'Deorikala B.O','480886',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133876,491,'Dhapara B.O','480771',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133877,491,'Dharnakala B.O','480667',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133878,491,'Dhobisarra B.O','480667',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133879,491,'Dhobisarra B.O','480661',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133880,491,'Dhuma S.O','480888',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133881,491,'Dhutera B.O','480991',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133882,491,'Dighori B.O','480882',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133883,491,'Diwari B.O','480997',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133884,491,'Dobh B.O','480994',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133885,491,'Dokarranjhi B.O','480991',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133886,491,'Dondiwada B.O','480771',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133887,491,'Durenda B.O','480996',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133888,491,'Fulara B.O','480661',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133889,491,'Ganeri B.O','480999',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133890,491,'Ganesh Ganj B.O','480886',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133891,491,'Gangai B.O','480886',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133892,491,'Gangatola B.O','480994',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133893,491,'Ghansore S.O','480997',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133894,491,'Ghatpipariya B.O','480999',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133895,491,'Ghotkheda B.O','480997',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133896,491,'Ghurwara B.O','480888',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133897,491,'Gohana B.O','480882',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133898,491,'Gokalpur B.O','480771',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133899,491,'Gondegaon B.O','480667',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133900,491,'Gopalganj B.O','480661',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133901,491,'Gorakhpur B.O','480886',1,0,'2022-03-04 19:29:11','2022-03-04 19:29:11'),(133902,491,'Gorakhpur B.O','480887',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133903,491,'Gwaria B.O','480994',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133904,491,'Hardoli B.O','480884',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133905,491,'Hathnapur B.O','480661',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133906,491,'Hinotiya B.O','480990',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133907,491,'Imaliya Raitwar B.O','480887',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133908,491,'Jaitpur Kala B.O','480661',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133909,491,'Jam B.O','480661',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133910,491,'Jeonara B.O','480667',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133911,491,'Jewnara B.O','480996',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133912,491,'Jhiri B.O','480887',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133913,491,'Jhittarra B.O','480996',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133914,491,'Jhurki B.O','480997',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133915,491,'Kahani S.O','480999',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133916,491,'Kalarbanki B.O','480882',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133917,491,'Kanhan Piparia B.O','480990',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133918,491,'Kanhiwada S.O','480990',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133919,491,'Karanpur B.O','480886',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133920,491,'Kareli B.O','480886',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133921,491,'Karirat B.O','480661',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133922,491,'Kedarpur B.O','480997',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133923,491,'Kekdai B.O','480667',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133924,491,'Keolari Kheda B.O','480994',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133925,491,'Keolari S.O','480994',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133926,491,'Kesalekala B.O','480667',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133927,491,'Khairapalari S.O','480991',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133928,491,'Khairlanji B.O','480994',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133929,491,'Khairnara B.O','480888',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133930,491,'Khamaria Bazar B.O','480997',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133931,491,'Khamaria Gosai B.O','480886',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133932,491,'Khami B.O','480667',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133933,491,'Khami B.O','480996',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133934,491,'Khandasa B.O','480881',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133935,491,'Khapa Bazar B.O','480991',1,0,'2022-03-04 19:29:12','2022-03-04 19:29:12'),(133936,491,'Kharsaru B.O','480994',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133937,491,'Khatiya B.O','480997',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133938,491,'Khawasa S.O (Seoni)','480881',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133939,491,'Khunt B.O','480667',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133940,491,'Khursara B.O','480996',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133941,491,'Khut-khamaria B.O','480888',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133942,491,'Kindarai B.O','480997',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133943,491,'Kohka B.O','480994',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133944,491,'Korai S.O','480880',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133945,491,'Kudari Maghgaon B.O','480991',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133946,491,'Kumhada B.O','480994',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133947,491,'Lakhnadon S.O','480886',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133948,491,'Lopa B.O','480991',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133949,491,'Madhi B.O','480887',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133950,491,'Malara B.O','480667',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133951,491,'Manegaon B.O','480997',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133952,491,'Marbodi B.O','480661',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133953,491,'Mehta B.O','480999',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133954,491,'Mohbarra B.O','480996',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133955,491,'Mohgaon Kachhi B.O','480887',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133956,491,'Mohgaon Kala B.O','480886',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133957,491,'Mugwani Kala B.O','480661',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133958,491,'Nagandeori B.O','480888',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133959,491,'Nandora B.O','480667',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133960,491,'Nayegaon B.O','480771',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133961,491,'Neewari B.O','480771',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133962,491,'Paddikona B.O','480997',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133963,491,'Pahadi B.O','480997',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133964,491,'Palari-chhidiya B.O','480661',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133965,491,'Pandiwada B.O','480996',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133966,491,'Pandiya Chhapara B.O','480996',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133967,491,'Panjara B.O','480991',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133968,491,'Parasiya B.O','480887',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133969,491,'Patan B.O','480887',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133970,491,'Patan B.O','480880',1,0,'2022-03-04 19:29:13','2022-03-04 19:29:13'),(133971,491,'Pathadeori B.O','480888',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133972,491,'Pindrai B.O','480881',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133973,491,'Pindrai- Buttey B.O','480880',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133974,491,'Pindraikala B.O','480667',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133975,491,'Pipardahi B.O','480661',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133976,491,'Piparia Bhasunda B.O','480999',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133977,491,'Piparia Bhoma B.O','480990',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133978,491,'Pipariya Kala B.O','480991',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133979,491,'Piparwani B.O','480881',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133980,491,'Pondi-jaharmau B.O','480882',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133981,491,'Poniya B.O','480667',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133982,491,'Purwamal B.O','480886',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133983,491,'Rajola B.O','480661',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133984,491,'Ramli B.O','480880',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133985,491,'Riddi B.O','480881',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133986,491,'Rumal B.O','480996',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133987,491,'Sadak Seoni B.O','480884',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133988,491,'Sajpani-dhanora B.O','480999',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133989,491,'Sakri B.O','480996',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133990,491,'Salhe-khurd B.O','480667',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133991,491,'Salhekosmi B.O','480667',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133992,491,'Salhepani B.O','480997',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133993,491,'Sanaidongari B.O','480888',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133994,491,'Sarekha B.O','480991',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133995,491,'Sarekha Kala B.O','480996',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133996,491,'Seoni Barapathar S.O','480661',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133997,491,'Seoni Budhwari Bazar S.O','480661',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133998,491,'Seoni City S.O','480661',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(133999,491,'Seoni H.O','480661',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(134000,491,'Seoni Sarad B.O','481226',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(134001,491,'Sihora B.O','480886',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(134002,491,'Sikara B.O','480997',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(134003,491,'Sillore B.O','480661',1,0,'2022-03-04 19:29:14','2022-03-04 19:29:14'),(134004,491,'Sindaria B.O','480661',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134005,491,'Sirmangani B.O','480886',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134006,491,'Sonkhar B.O','480996',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134007,491,'Sukla B.O','480771',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134008,491,'Suktara B.O','480661',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134009,491,'Sunwara B.O','480884',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134010,491,'Takalakala B.O','480771',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134011,491,'Tali B.O','480994',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134012,491,'Tekari B.O','480771',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134013,491,'Tighra B.O','480661',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134014,491,'Tinduwa B.O','480994',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134015,491,'Turia B.O','480881',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134016,491,'Udepani B.O','480990',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134017,491,'Ugli S.O','480996',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134018,491,'Vijaypani B.O','480661',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134019,492,'Akhetpur B.O','484774',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134020,492,'Amdih B.O','484771',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134021,492,'Amjhor B.O','484771',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134022,492,'Amlai Paper Mills S.O','484117',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134023,492,'Amraha B.O','484110',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134024,492,'Aswari B.O','484770',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134025,492,'Bakeli Colloney B.O','484776',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134026,492,'Bandhwabada B.O','484001',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134027,492,'Bangawan B.O','484446',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134028,492,'Bansa B.O','484771',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134029,492,'Bansagar S.O','484776',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134030,492,'Bansukli B.O','484771',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134031,492,'Barachh B.O','484774',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134032,492,'Baraundha B.O','484774',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134033,492,'Bareli B.O','484770',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134034,492,'Barkachh B.O','484774',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134035,492,'Barkoda B.O','484770',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134036,492,'Bartara B.O','484110',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134037,492,'Basahi B.O','484774',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134038,492,'Bemhori B.O','484110',1,0,'2022-03-04 19:29:15','2022-03-04 19:29:15'),(134039,492,'Beohari S.O','484774',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134040,492,'Bhamraha B.O','484774',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134041,492,'Bhanni B.O','484774',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134042,492,'Bholhara B.O','484774',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134043,492,'Bhuibandh B.O','484001',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134044,492,'Bijha B.O','484774',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134045,492,'Bijuri Colliery B.O','484440',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134046,492,'Bijuri S.O','484440',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134047,492,'Biruhli B.O','484110',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134048,492,'Bodri B.O','484110',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134049,492,'Budwa B.O','484776',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134050,492,'Burhar S.O','484110',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134051,492,'Chachai B.O','484776',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134052,492,'Chandela B.O','484770',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134053,492,'Channaudi B.O','484110',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134054,492,'Chauri B.O','484776',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134055,492,'Chhakta B.O','484771',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134056,492,'Chhuhi B.O','484774',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134057,492,'Chitraon B.O','484771',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134058,492,'Chuhiri B.O','484669',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134059,492,'Darain B.O','484771',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134060,492,'Deogarh B.O','484669',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134061,492,'Deori B.O','484110',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134062,492,'Dhangawan B.O','484330',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134063,492,'Dhanpuri Colliery S.O','484114',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134064,492,'Dhanpuri S.O','484114',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134065,492,'Dhari No. 2 B.O','484776',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134066,492,'Dhondha B.O','484774',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134067,492,'Dhurwar B.O','484001',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134068,492,'Diyapipar B.O','484770',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134069,492,'Dola B.O','484446',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134070,492,'Giruibadi B.O','484771',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134071,492,'Gohparu S.O','484770',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134072,492,'Jagmal B.O','484776',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134073,492,'Jaisinghnagar S.O','484771',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134074,492,'Jaitpur S.O (Shahdol)','484669',1,0,'2022-03-04 19:29:16','2022-03-04 19:29:16'),(134075,492,'Jamuna Colliery S.O','484444',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134076,492,'Janakpur B.O','484776',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134077,492,'Jheemar Colliery B.O','484446',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134078,492,'Jodhpur B.O','484001',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134079,492,'Kadaudi B.O','484669',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134080,492,'Kanadikhurd B.O','484771',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134081,492,'Karkati B.O','484110',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134082,492,'Karki B.O','484771',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134083,492,'Kathautia B.O','484110',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134084,492,'Kaudiya B.O','484660',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134085,492,'Kelhauri B.O','484001',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134086,492,'Khadda B.O','484774',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134087,492,'Khairaha B.O','484110',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134088,492,'Khairahni B.O','484669',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134089,492,'Khand B.O','484771',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134090,492,'Khannaudhi B.O','484770',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134091,492,'Kharpa B.O','484774',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134092,492,'Kolhua B.O','484669',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134093,492,'Kuan B.O','484774',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134094,492,'Kubra B.O','484771',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134095,492,'Kudeli B.O','484669',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134096,492,'Kudri B.O','484110',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134097,492,'Lafda B.O','484669',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134098,492,'Lalpur B.O','484110',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134099,492,'Lodi B.O','484770',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134100,492,'Malmathar B.O','484770',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134101,492,'Masira B.O','484771',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134102,492,'Mau B.O','484774',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134103,492,'Mithi B.O','484771',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134104,492,'Mithori B.O','484001',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134105,492,'Nagnaudi B.O','484771',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134106,492,'Naudhiya B.O','484774',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134107,492,'Nawalpur B.O','484001',1,0,'2022-03-04 19:29:17','2022-03-04 19:29:17'),(134108,492,'Niwas B.O','486669',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134109,492,'Obra B.O','484660',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134110,492,'Pachgaon B.O','484001',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134111,492,'Padmaniakhurd B.O','484001',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134112,492,'Pailwah B.O','484770',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134113,492,'Palsau B.O','484770',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134114,492,'Papaudh B.O','484774',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134115,492,'Papaundh B.O','484774',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134116,492,'Papderi B.O','484774',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134117,492,'Patasi B.O','484001',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134118,492,'Pathratha B.O','484774',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134119,492,'Pathrehi B.O','484774',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134120,492,'Pondireusa B.O','484774',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134121,492,'Pongari B.O','484001',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134122,492,'Rajendragram S.O','484881',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134123,492,'Rajendranagar Colony B.O','484110',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134124,492,'Rajnagar Colliery S.O','484446',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134125,492,'Ramnagar Colliery B.O','484446',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134126,492,'Rasmohni B.O','484669',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134127,492,'Rungta Colliery B.O','484110',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134128,492,'S.K. Nagar S.O','484120',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134129,492,'Sakhi B.O','484669',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134130,492,'Saman B.O','484776',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134131,492,'Samatpur B.O','484110',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134132,492,'Sapta B.O','484774',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134133,492,'Saraikapa B.O','484110',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134134,492,'Sarsi B.O','484774',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134135,492,'Senduri B.O','484001',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134136,492,'Shahdol Balpurwa S.O','484001',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134137,492,'Shahdol Bus Stand S.O','484001',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134138,492,'Shahdol Ganesh Ganj S.O','484001',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134139,492,'Shahdol Gharola S.O','484001',1,0,'2022-03-04 19:29:18','2022-03-04 19:29:18'),(134140,492,'Shahdol H.O','484001',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134141,492,'Shahdol R.S. S.O','484001',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134142,492,'Sidhi B.O','484771',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134143,492,'Singhpur B.O','484001',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134144,492,'Sohagpur B.O','484001',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134145,492,'Tagawar B.O','484774',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134146,492,'Tetki B.O','484770',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134147,492,'Thengreha B.O','484771',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134148,492,'Tihki B.O','484774',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134149,492,'Tikhwa B.O','484774',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134150,492,'Tikuri B.O','484669',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134151,492,'Uchehra B.O','484669',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134152,493,'Abhaypur B.O','465001',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134153,493,'Agar Malwa S.O','465441',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134154,493,'AGARCANTT B.O','465441',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134155,493,'Akodia S.O','465223',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134156,493,'Ala Umrod B.O','465001',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134157,493,'Alisiriya B.O','465333',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134158,493,'Amba B.O','465550',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134159,493,'Amla B.O','465447',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134160,493,'Amlay B.O','465335',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134161,493,'ARNIAKHURD B.O','465118',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134162,493,'Arniya  Kalan B.O','465333',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134163,493,'AWANTIPUR BARODIYA','465118',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134164,493,'Badagaon B.O','465445',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134165,493,'Bapcha B.O','465441',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134166,493,'Bapcha B.O','465550',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134167,493,'Barda  Raoji B.O','465447',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134168,493,'Bardiason B.O','465110',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134169,493,'Barode S.O','465550',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134170,493,'Barodia Kumaria S.O','465226',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134171,493,'Behraval B.O','465337',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134172,493,'Berchha Datar B.O','465337',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134173,493,'Berchha S.O','465110',1,0,'2022-03-04 19:29:19','2022-03-04 19:29:19'),(134174,493,'BERCHHA TOWN B.O','465110',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134175,493,'Bhaisaygarh B.O','465339',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134176,493,'Bhaisrod B.O','465223',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134177,493,'Bhandavad B.O','465445',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134178,493,'Bharad B.O','465001',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134179,493,'Bhesoda B.O','465445',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134180,493,'Bhilkhedi B.O','465333',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134181,493,'Bhuria Khajuria B.O','465337',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134182,493,'Bijana B.O','465001',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134183,493,'Bijanagri B.O','465441',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134184,493,'BIJNAKHEDI B.O','465445',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134185,493,'BINAYA B.O','465118',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134186,493,'Biyana B.O','465441',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134187,493,'Bolai B.O','465220',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134188,493,'Burlay B.O','465226',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134189,493,'Burnavad B.O','465226',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134190,493,'Chakrod B.O','465335',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134191,493,'Chhapariya B.O','465447',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134192,493,'Chitawad B.O','465227',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134193,493,'Choma Dak Bangla B.O','465230',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134194,493,'Choslakulmi B.O','465110',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134195,493,'Dasta Khedi B.O','465220',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134196,493,'Dehandi B.O','465333',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134197,493,'Dehriyakulmi B.O','465449',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134198,493,'Dendla B.O','465110',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134199,493,'Devla Bihar B.O','465220',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134200,493,'Devli B.O','465116',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134201,493,'Dhabla  Ghosi B.O','465335',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134202,493,'Dhabla Dheer B.O','465337',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134203,493,'Dharola B.O','465445',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134204,493,'Dhillod B.O','465001',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134205,493,'Dogargaon B.O','465449',1,0,'2022-03-04 19:29:20','2022-03-04 19:29:20'),(134206,493,'Dudhana B.O','465226',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134207,493,'Dupada B.O','465001',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134208,493,'Farad B.O','465337',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134209,493,'Gangapur B.O','465447',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134210,493,'Gata B.O','465441',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134211,493,'Gelana B.O','465447',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134212,493,'Ghunsi B.O','465220',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134213,493,'Ghurasiya B.O','465441',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134214,493,'Gondalmau B.O','465445',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134215,493,'Gopipur B.O','465001',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134216,493,'Goyla B.O','465445',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134217,493,'Gulana B.O','465220',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134218,493,'GUNDIKALA B.O','465441',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134219,493,'Hadlaya Kala B.O','465223',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134220,493,'Hargankhedi B.O','465230',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134221,493,'Jabdiya Bheel B.O','465337',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134222,493,'Jamner S.O (Shajapur)','465335',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134223,493,'Jhalara B.O','465550',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134224,493,'Jhokar B.O','465106',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134225,493,'Kadwala B.O','465227',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134226,493,'Kalapipal Gaon B.O','465337',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134227,493,'Kalapipal S.O','465337',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134228,493,'Kalisindh S.O','465220',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134229,493,'Kamalpur B.O','465337',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134230,493,'Kanad S.O','465230',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134231,493,'Kapaliya B.O','465106',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134232,493,'Karju B.O','465226',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134233,493,'Kethlay B.O','465223',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134234,493,'Kevda Khedi B.O','465227',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134235,493,'Khadi B.O','465113',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134236,493,'Khamlya B.O','465337',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134237,493,'Khardonkala B.O','465339',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134238,493,'Khardonkhurd B.O','465339',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134239,493,'Khatsur B.O','465116',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134240,493,'KHELAGAON B.O','465445',1,0,'2022-03-04 19:29:21','2022-03-04 19:29:21'),(134241,493,'Khokra Kalan S.O','465339',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134242,493,'Khoria Nayta B.O','465110',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134243,493,'Khoriaama B.O','465226',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134244,493,'Killoda B.O','465227',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134245,493,'Kohadiya B.O','465230',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134246,493,'Kumariakhas B.O','465226',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134247,493,'Ladavad B.O','465220',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134248,493,'Lahori B.O','465220',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134249,493,'Lala B.O','465441',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134250,493,'Lasuldiya Gori B.O','465337',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134251,493,'Lasuldiya Malak B.O','465337',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134252,493,'Laturi  Gehlot B.O','465447',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134253,493,'Loharia B.O','465449',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134254,493,'Loharkheda B.O','465227',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134255,493,'Lotiakrishna B.O','465550',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134256,493,'Madana B.O','465227',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134257,493,'Madkota B.O','465550',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134258,493,'Mahudiya B.O','465441',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134259,493,'Makodi B.O','465113',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134260,493,'Maksi S.O','465106',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134261,493,'Malwasa B.O','465441',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134262,493,'Mandoda B.O','465226',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134263,493,'Manglaj B.O','465227',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134264,493,'Mansaya B.O','465337',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134265,493,'Mathurakhedi B.O','465230',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134266,493,'Mayapur  Mangrola B.O','465333',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134267,493,'Modi B.O','465447',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134268,493,'Mohammadpur Machnai B.O','465339',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134269,493,'Mohana B.O','465226',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134270,493,'Mohmmadkheda B.O','465223',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134271,493,'Morta B.O','465001',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134272,493,'Mortakhevdi B.O','465116',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134273,493,'Nalkheda S.O','465445',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134274,493,'Nandni B.O','465337',1,0,'2022-03-04 19:29:22','2022-03-04 19:29:22'),(134275,493,'Nipania  Dhakar B.O','465113',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134276,493,'Nipaniabajnath B.O','465441',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134277,493,'Nipaniya Hanuman B.O','465441',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134278,493,'Nipaniyakarju B.O','465226',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134279,493,'Pachlana B.O','465230',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134280,493,'PADLIYA B.O','465118',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134281,493,'PAGRAWADKALAN B.O','465118',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134282,493,'Palda B.O','465441',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134283,493,'Palkhedi B.O','465441',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134284,493,'Panch  Dehria B.O','465335',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134285,493,'Panwadi B.O','465001',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134286,493,'Patlawada B.O','465223',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134287,493,'Payli B.O','465447',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134288,493,'Pilwas B.O','465445',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134289,493,'Pipliaset B.O','465445',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134290,493,'Pipliyanagar B.O','465337',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134291,493,'Piploankala B.O','465441',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134292,493,'Pochaner B.O','465337',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134293,493,'Polai Kalan S.O','465116',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134294,493,'Polaikhrud B.O','465223',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134295,493,'Raipur B.O','465333',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134296,493,'Ranayal B.O','465337',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134297,493,'Ranibarod B.O','465223',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134298,493,'Ranth Bhanwar B.O','465110',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134299,493,'Rolakhedi B.O','465333',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134300,493,'Sajod B.O','465001',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134301,493,'Saliakhedi B.O','465449',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134302,493,'Salsalai S.O','465227',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134303,493,'Semalkhedi B.O','465447',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134304,493,'Semliya B.O','465339',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134305,493,'Shajapur  Town S.O','465001',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134306,493,'Shajapur H.O','465001',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134307,493,'Shajapur Kutchery S.O','465001',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134308,493,'Shivgarh B.O','465230',1,0,'2022-03-04 19:29:23','2022-03-04 19:29:23'),(134309,493,'Shujalpur  City S.O','465333',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134310,493,'Shujalpur  Mandi S.O','465333',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134311,493,'Shyampura B.O','465447',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134312,493,'Siloda B.O','465335',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134313,493,'Simrol B.O','465113',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134314,493,'Sirpoi B.O','465441',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134315,493,'Soyat  Khurd B.O','465449',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134316,493,'Soyat Kalan S.O','465449',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134317,493,'SUDWAS B.O','465550',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134318,493,'Suigaon B.O','465445',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134319,493,'Sundersi S.O','465113',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134320,493,'Sunhera B.O','465001',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134321,493,'Susner S.O','465447',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134322,493,'Takhala B.O','465445',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134323,493,'Tanodiya B.O','465441',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134324,493,'Tikon B.O','465226',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134325,493,'Tilawad  Govind B.O','465110',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134326,493,'Tilawadmena B.O','465333',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134327,493,'Uchod B.O','465223',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134328,493,'Ugli B.O','465337',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134329,494,'Agra B.O','476332',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134330,494,'Arrod B.O','476332',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134331,494,'Asida B.O','476337',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134332,494,'Awada B.O','476339',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134333,494,'Bagadiya B.O','476337',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134334,494,'Bagord B.O','476332',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134335,494,'Balawani B.O','476335',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134336,494,'Bargawan B.O','476355',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134337,494,'Beerpur S.O','476335',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134338,494,'Bijaipur S.O (Sheopur)','476332',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134339,494,'Bukhari B.O','476339',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134340,494,'Chambal Colony Sheopur B.O','476337',1,0,'2022-03-04 19:29:24','2022-03-04 19:29:24'),(134341,494,'Chimalwani B.O','476332',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134342,494,'Dantarda Kalan B.O','476337',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134343,494,'Dhondha B.O','476332',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134344,494,'Dhondhar B.O','476337',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134345,494,'Dord B.O','476332',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134346,494,'Filozpura B.O','476339',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134347,494,'Gadi B.O','476332',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134348,494,'Gaswani B.O','476332',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134349,494,'Ghunghas B.O','476335',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134350,494,'Girdharpur B.O','476337',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134351,494,'Gohar B.O','476335',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134352,494,'Gohta B.O','476332',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134353,494,'Goras B.O','476355',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134354,494,'Gurunaawda B.O','476337',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134355,494,'Heera Lalka Pura B.O','477332',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134356,494,'Heerapura B.O','476335',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134357,494,'Iklod B.O','476332',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134358,494,'Jaida Mandi B.O','476337',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134359,494,'Jaini B.O','476337',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134360,494,'Jalalpura B.O','476337',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134361,494,'Javasa B.O','476337',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134362,494,'Javdeshwar B.O','476337',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134363,494,'Kalarna B.O','476337',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134364,494,'Kanapur B.O','476337',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134365,494,'Karhal S.O (Sheopur)','476355',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134366,494,'Kathon B.O','476332',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134367,494,'Kemarakalan B.O','476335',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134368,494,'Khirkhiri B.O','476355',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134369,494,'Magrdha B.O','476332',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134370,494,'Makdawadakalan B.O','476339',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134371,494,'Manpur B.O','476337',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134372,494,'Nagda B.O','476337',1,0,'2022-03-04 19:29:25','2022-03-04 19:29:25'),(134373,494,'Ochhapura B.O','476335',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134374,494,'Pada B.O','476355',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134375,494,'Pandola B.O','476339',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134376,494,'Premsar B.O','476337',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134377,494,'Raghunathpur B.O','476335',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134378,494,'Randep B.O','476339',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134379,494,'Ratodhan B.O','476339',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134380,494,'Sahasram B.O','476332',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134381,494,'Sarsai B.O','476355',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134382,494,'Sasaipura B.O','476355',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134383,494,'Sheopur Baroda S.O','476339',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134384,494,'Sheopur S.O','476337',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134385,494,'Shyampur B.O','476335',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134386,494,'Silpuri B.O','476355',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134387,494,'Soi Kalan B.O','476337',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134388,494,'Sonthwa B.O','476337',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134389,494,'Sunswada B.O','476355',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134390,494,'Tarra Kalan B.O','476335',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134391,494,'Tillipur B.O','476337',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134392,494,'Tulsef B.O','476339',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134393,494,'Udhotpura B.O','476339',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134394,495,'Achhroni B.O','473585',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134395,495,'Aijwara B.O','473770',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134396,495,'Ainchwara B.O','473793',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134397,495,'Akajhiri B.O','473781',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134398,495,'Algi B.O','473665',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134399,495,'Amhara B.O','473781',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134400,495,'Amola B.O','473660',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134401,495,'Amolpatha B.O','473880',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134402,495,'Atalpur B.O','473885',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134403,495,'Badarwas B.O','473995',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134404,495,'Badarwas S.O','473885',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134405,495,'Badera B.O','473670',1,0,'2022-03-04 19:29:26','2022-03-04 19:29:26'),(134406,495,'Badhora B.O','473660',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134407,495,'Bagwasa B.O','473775',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134408,495,'Bamhari B.O','473551',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134409,495,'Bamore B.O','473885',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134410,495,'Bamore Damron B.O','473670',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134411,495,'Bamore Kalan B.O','473781',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134412,495,'Bamorkalan S.O','473585',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134413,495,'Bamra B.O','473775',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134414,495,'Bangawan B.O','473660',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134415,495,'Bansgarh B.O','473662',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134416,495,'Bara B.O','473551',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134417,495,'Barai B.O','473885',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134418,495,'Barod B.O','473770',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134419,495,'Barodi Sadak B.O','473551',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134420,495,'Behgawa B.O','473662',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134421,495,'Benhta B.O','473774',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134422,495,'Berad S.O','473793',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134423,495,'Bhadauta B.O','473770',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134424,495,'Bhangarh B.O','473551',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134425,495,'Bhansda Khurd B.O','473660',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134426,495,'Bharsula B.O','473585',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134427,495,'Bhatnawar B.O','473775',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134428,495,'Bhesrawan B.O','473775',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134429,495,'Bhonti B.O','473670',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134430,495,'Bijrawan B.O','473585',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134431,495,'Bijroni B.O','473770',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134432,495,'Bilhari B.O','473665',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134433,495,'Bilwara Mata B.O','473793',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134434,495,'Budadongar B.O','473885',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134435,495,'Budhonrajapur B.O','473995',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134436,495,'Burda B.O','473793',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134437,495,'Chak Kamalpur B.O','473551',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134438,495,'Chakrana B.O','473775',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134439,495,'Chamraua B.O','473990',1,0,'2022-03-04 19:29:27','2022-03-04 19:29:27'),(134440,495,'Chharch B.O','473775',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134441,495,'Chhirwaha B.O','473670',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134442,495,'Chhitipur B.O','473665',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134443,495,'Chhitri B.O','473662',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134444,495,'Chinod B.O','473660',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134445,495,'Collectorate Bhawan Shiv S.O','473551',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134446,495,'Dabarbhat B.O','473665',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134447,495,'Dabia Jagan B.O','473990',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134448,495,'Dabiakala B.O','473995',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134449,495,'Dabra Dinara B.O','473665',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134450,495,'Damron Kalan B.O','473665',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134451,495,'Dargawa B.O','473670',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134452,495,'Deharwara B.O','473774',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134453,495,'Dehrog B.O','473774',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134454,495,'Deokheda B.O','473995',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134455,495,'Deokho B.O','473990',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134456,495,'Dhala B.O','473670',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134457,495,'Dhand B.O','473665',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134458,495,'Dhigwas B.O','473865',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134459,495,'Dhihala B.O','473662',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134460,495,'Dholagarh B.O','473551',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134461,495,'Dinara S.O (Shivpuri)','473665',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134462,495,'Doni B.O','473662',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134463,495,'Dulhara B.O','473775',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134464,495,'Endar B.O','473770',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134465,495,'Gajigarh B.O','473793',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134466,495,'Gajora B.O','473995',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134467,495,'Galthuni B.O','473775',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134468,495,'Ganeshkheda B.O','473670',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134469,495,'Ganeshkjeda B.O','473774',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134470,495,'Gangora B.O','473551',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134471,495,'Garentha B.O','473995',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134472,495,'Garibarod B.O','473551',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134473,495,'Gondari B.O','473793',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134474,495,'Gopalpura B.O','473793',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134475,495,'Gudar B.O','473990',1,0,'2022-03-04 19:29:28','2022-03-04 19:29:28'),(134476,495,'Harinagar B.O','473995',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134477,495,'Hateda B.O','473865',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134478,495,'Himmatpur B.O','473665',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134479,495,'I.T.B.P Shivpuri S.O','473551',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134480,495,'Jagatpur S.O (Shivpuri)','473774',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134481,495,'Jhanda B.O','473662',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134482,495,'Jhiri B.O','473775',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134483,495,'Jorai B.O','473793',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134484,495,'Jujhai B.O','473880',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134485,495,'Kachhauwa B.O','473995',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134486,495,'Kafar B.O','473585',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134487,495,'Kakraua B.O','473793',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134488,495,'Kakraua Thuni B.O','473670',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134489,495,'Kali Pahari B.O','473585',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134490,495,'Kalipahadi Mathure B.O','473665',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134491,495,'Kalipahadi Meda B.O','473880',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134492,495,'Kanker B.O','473551',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134493,495,'Kanker B.O','473865',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134494,495,'Karahi B.O','473662',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134495,495,'Karar Kheda B.O','473995',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134496,495,'Karera S.O','473660',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134497,495,'Karmaj Kalan B.O','473551',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134498,495,'Karotha B.O','473660',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134499,495,'Karsena B.O','473551',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134500,495,'Karya B.O','473774',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134501,495,'Katthamil Shivpuri S.O','473638',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134502,495,'Khadicha B.O','473662',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134503,495,'Khandi B.O','473551',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134504,495,'Khaniyadhana S.O','473990',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134505,495,'Kharai B.O','473774',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134506,495,'Kharai Jalim B.O','473793',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134507,495,'Khareh B.O','473781',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134508,495,'Khatka B.O','473793',1,0,'2022-03-04 19:29:29','2022-03-04 19:29:29'),(134509,495,'Khatora B.O','473770',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134510,495,'Kherwas B.O','473995',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134511,495,'Khirkit B.O','473585',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134512,495,'Khod B.O','473670',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134513,495,'Khorghar B.O','473551',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134514,495,'Khudawli B.O','473665',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134515,495,'Kilawani B.O','473774',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134516,495,'Kolaras S.O','473770',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134517,495,'Kota B.O','473551',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134518,495,'Kuchlon B.O','473665',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134519,495,'Kumhrraondi B.O','473990',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134520,495,'Kunwarpur B.O','473551',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134521,495,'Kutwara B.O','473781',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134522,495,'Kyara B.O','473585',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134523,495,'Labheda B.O','473995',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134524,495,'Lalpur B.O','473660',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134525,495,'Lamkana B.O','473665',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134526,495,'Lewa B.O','473774',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134527,495,'Lukwasa B.O','473885',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134528,495,'Machaoli B.O','473660',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134529,495,'Mada B.O','473781',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134530,495,'Madwasa B.O','473770',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134531,495,'Magroni S.O','473865',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134532,495,'Mahadeva B.O','473775',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134533,495,'Malaoni B.O','473995',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134534,495,'Manpura S.O','473670',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134535,495,'Mathna B.O','473781',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134536,495,'Mehloni B.O','473775',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134537,495,'Mehroli B.O','473990',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134538,495,'Mohini B.O','473865',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134539,495,'Mohra B.O','473774',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134540,495,'Muhari B.O','473585',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134541,495,'Munderi B.O','473551',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134542,495,'Mungaoli B.O','473660',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134543,495,'Nadora B.O','473793',1,0,'2022-03-04 19:29:30','2022-03-04 19:29:30'),(134544,495,'Nand B.O','473995',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134545,495,'Naoli B.O','473670',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134546,495,'Narahi B.O','473660',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134547,495,'Naraua B.O','473880',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134548,495,'Narwar S.O (Shivpuri)','473880',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134549,495,'Pachaoli B.O','473781',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134550,495,'Padora B.O','473781',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134551,495,'Pahada Khurd B.O','473781',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134552,495,'Papredu B.O','473662',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134553,495,'Parichha B.O','473775',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134554,495,'Peeronth B.O','473770',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134555,495,'Pichhore S.O','473995',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134556,495,'Pipal Kheda B.O','473995',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134557,495,'Piparghar B.O','473775',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134558,495,'Piparsama B.O','473551',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134559,495,'Pipra B.O','473585',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134560,495,'Pipra Pichhore B.O','473670',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134561,495,'Pipro B.O','473995',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134562,495,'Piproda Ubari B.O','473995',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134563,495,'Pohari S.O','473775',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134564,495,'Pura B.O','473990',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134565,495,'Purani Basti B.O','473551',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134566,495,'Rahi B.O','473995',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134567,495,'Rai B.O','473774',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134568,495,'Raishree B.O','473551',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134569,495,'Rajgarh B.O','473774',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134570,495,'Ramgarh B.O','473770',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134571,495,'Rampur Dhamkan B.O','473880',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134572,495,'Rannod S.O','473781',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134573,495,'Ranthkheda B.O','473775',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134574,495,'Rewai B.O','473995',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134575,495,'Sad B.O','473660',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134576,495,'Sajai B.O','473781',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134577,495,'Sakhnor B.O','473774',1,0,'2022-03-04 19:29:31','2022-03-04 19:29:31'),(134578,495,'Salaiya B.O','473660',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134579,495,'Salaiya Damron B.O','473665',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134580,495,'Samoha B.O','473660',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134581,495,'Satanwada B.O','473551',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134582,495,'Sehdora B.O','473665',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134583,495,'Sehore B.O','473865',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134584,495,'Semri B.O','473995',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134585,495,'Sesai B.O','473774',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134586,495,'Shergarh B.O','473880',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134587,495,'Shivprui City S.O','473551',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134588,495,'Shivpuri H.O','473551',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134589,495,'Silanagar B.O','473660',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134590,495,'Silpura B.O','473990',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134591,495,'Sinawalkala B.O','473990',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134592,495,'Singhniwas B.O','473551',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134593,495,'Sirsaud B.O','473551',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134594,495,'Sirsaud B.O','473670',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134595,495,'Sonher B.O','473880',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134596,495,'Subhashpura B.O','473551',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134597,495,'Sunaj B.O','473781',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134598,495,'Sunari B.O','473662',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134599,495,'Surwaya B.O','473551',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134600,495,'T.C.Karera S.O','473662',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134601,495,'Teela B.O','473660',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134602,495,'Thanra B.O','473665',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134603,495,'Tharkheda B.O','473880',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134604,495,'Tharra Darroni B.O','473551',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134605,495,'Theh B.O','473551',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134606,495,'Tongra B.O','473551',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134607,495,'Umri Kala B.O','473670',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134608,495,'V.R.Colony Shivpuri S.O','473551',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134609,495,'Veera B.O','473781',1,0,'2022-03-04 19:29:32','2022-03-04 19:29:32'),(134610,496,'Amarpur B.O','486661',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134611,496,'Amarwah B.O','486661',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134612,496,'Amilia B.O','486670',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134613,496,'Amiliha B.O','486775',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134614,496,'Amlai B.O','486776',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134615,496,'Badhaura B.O','486771',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134616,496,'Badkhara B.O','486771',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134617,496,'Badkud B.O','486882',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134618,496,'Badokhar B.O','486771',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134619,496,'Bagad B.O','486776',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134620,496,'Baghaun B.O','486771',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134621,496,'Baghor B.O','486670',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134622,496,'Baghwar B.O','486776',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134623,496,'Baghwari B.O','486661',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134624,496,'Bahri S.O','486675',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134625,496,'Bairdah B.O','486882',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134626,496,'Bamhani B.O','486661',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134627,496,'Bamuri B.O','486670',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134628,496,'Bamuri B.O','486661',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134629,496,'Bandha B.O','486886',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134630,496,'Banjari B.O','486669',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134631,496,'Banjari B.O','486661',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134632,496,'Barambaba B.O','486661',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134633,496,'Barbandha B.O','486661',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134634,496,'Bardi B.O','486882',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134635,496,'Barka B.O','486669',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134636,496,'Barmani B.O','486666',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134637,496,'Belha B.O','486661',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134638,496,'Bhadaura B.O','486669',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134639,496,'Bhagohar B.O','486666',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134640,496,'Bharatpur S.O (Sidhi)','486776',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134641,496,'Bhitri B.O','486775',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134642,496,'Bhuimad B.O','486669',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134643,496,'Bichhi B.O','486670',1,0,'2022-03-04 19:29:33','2022-03-04 19:29:33'),(134644,496,'Bindul B.O','486886',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134645,496,'Bithauli B.O','486670',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134646,496,'Budgauna B.O','486776',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134647,496,'Chakdaur B.O','486771',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134648,496,'Chamradol B.O','486666',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134649,496,'Chandwahi B.O','486661',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134650,496,'Chandwar B.O','486881',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134651,496,'Chatainiha B.O','486881',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134652,496,'Chaufal B.O','486661',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134653,496,'Chingwah B.O','486666',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134654,496,'Chitrangi S.O','486882',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134655,496,'Chitwaria B.O','486670',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134656,496,'Chorgadhi B.O','486776',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134657,496,'Churhat S.O','486771',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134658,496,'Churkee B.O','486889',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134659,496,'Dadhia B.O','486771',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134660,496,'Danga B.O','486666',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134661,496,'Darbari B.O','486881',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134662,496,'Deogawan B.O','486661',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134663,496,'Deora B.O','484771',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134664,496,'Deora B.O','486882',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134665,496,'Dhanha B.O','486771',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134666,496,'Dharauli B.O','486882',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134667,496,'Dhauhani B.O','486669',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134668,496,'Dhonga B.O','486881',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134669,496,'Dihuli B.O','486771',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134670,496,'Dudhmania B.O','486892',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134671,496,'Gadababan Singh B.O','486661',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134672,496,'Gajri B.O','486666',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134673,496,'Gangi B.O','486882',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134674,496,'Geer B.O','486881',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134675,496,'Ghoghra B.O','486882',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134676,496,'Ghoghra B.O','486670',1,0,'2022-03-04 19:29:34','2022-03-04 19:29:34'),(134677,496,'Gijwar B.O','486669',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134678,496,'Gondwali B.O','486892',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134679,496,'Gopla B.O','486882',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134680,496,'Gorbi S.O','486892',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134681,496,'Gordaha B.O','486775',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134682,496,'Gujder B.O','486775',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134683,496,'Hadbado B.O','486661',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134684,496,'Hanumangarh B.O','486771',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134685,496,'Hatwakhas B.O','486771',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134686,496,'Hinauti B.O','486670',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134687,496,'Jamgadhi B.O','486886',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134688,496,'Jamuar B.O','486661',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134689,496,'Jarha B.O','486886',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134690,496,'Jayant Colliery S.O','486890',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134691,496,'Jhagrauha B.O','486882',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134692,496,'Jhakhrawal B.O','486881',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134693,496,'Jhalwar B.O','486771',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134694,496,'Jhanjh B.O','486775',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134695,496,'Jhara B.O','486669',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134696,496,'Jiawan S.O','486881',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134697,496,'Juri B.O','486669',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134698,496,'Kachnimamla B.O','486887',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134699,496,'Kamachh B.O','486666',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134700,496,'Kamarjee B.O','486771',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134701,496,'Kandhwar B.O','486775',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134702,496,'Kapuri B.O','486771',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134703,496,'Karaila B.O','486892',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134704,496,'Karauli Khurd B.O','486670',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134705,496,'Karaundia B.O','486771',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134706,496,'Karda B.O','486669',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134707,496,'Karmai B.O','486666',1,0,'2022-03-04 19:29:35','2022-03-04 19:29:35'),(134708,496,'Karsualal B.O','486886',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134709,496,'Karthua B.O','486882',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134710,496,'Karwahi B.O','486666',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134711,496,'Keontali B.O','486882',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134712,496,'Khadaura B.O','486666',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134713,496,'Khaddi B.O','486775',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134714,496,'Khaidar B.O','486882',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134715,496,'Khanua B.O','486886',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134716,496,'Khatai B.O','486882',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134717,496,'Khoh Gandhi Gram B.O','486661',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134718,496,'Khurmucha B.O','486882',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134719,496,'Khutar B.O','486886',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134720,496,'Khuteli B.O','486661',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134721,496,'Kochila B.O','486661',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134722,496,'Kodaura B.O','486670',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134723,496,'Kolhudih B.O','486771',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134724,496,'Korsar B.O','486882',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134725,496,'Kota B.O','486666',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134726,496,'Kubri B.O','486661',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134727,496,'Kuchwahi B.O','486661',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134728,496,'Kudia B.O','486775',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134729,496,'Kukrijhar B.O','486661',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134730,496,'Kulakwar B.O','486670',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134731,496,'Kushmahar B.O','486771',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134732,496,'Kusmi B.O','486669',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134733,496,'Kuspari B.O','486771',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134734,496,'Lakauda B.O','486771',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134735,496,'Lamsarai B.O','486882',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134736,496,'Laua B.O','486661',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134737,496,'Lurghuti B.O','486666',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134738,496,'Madha B.O','486775',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134739,496,'Madwa B.O','486661',1,0,'2022-03-04 19:29:36','2022-03-04 19:29:36'),(134740,496,'Madwas S.O','486669',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134741,496,'Mahkhor B.O','486669',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134742,496,'Mahrajpur B.O','486661',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134743,496,'Mahuagaon B.O','486669',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134744,496,'Majauli S.O','486666',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134745,496,'Makrohar B.O','486886',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134746,496,'Mamdar B.O','486775',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134747,496,'Maura B.O','486775',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134748,496,'Mawai B.O','486771',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134749,496,'Medra B.O','486666',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134750,496,'Misirgrawan B.O','486882',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134751,496,'Mohania B.O','486771',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134752,496,'Naikahwa B.O','486882',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134753,496,'Naikin B.O','486776',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134754,496,'Nakjhar B.O','486661',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134755,496,'Naudhiya B.O','486666',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134756,496,'Naudhiya B.O','486661',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134757,496,'Nigahi Project S.O','486884',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134758,496,'Nigri B.O','486669',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134759,496,'Odgadi B.O','486886',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134760,496,'Pachaur B.O','486892',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134761,496,'Pachaur B.O','486886',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134762,496,'Pachokhar B.O','486771',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134763,496,'Padainia B.O','486661',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134764,496,'Padkhuri B.O','486661',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134765,496,'Padri B.O','486661',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134766,496,'Pahadi B.O','486670',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134767,496,'Pand B.O','486666',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134768,496,'Paraswar B.O','486661',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134769,496,'Pateri B.O','486892',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134770,496,'Pathraula B.O','486669',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134771,496,'Patna B.O','486776',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134772,496,'Patulkhi B.O','486661',1,0,'2022-03-04 19:29:37','2022-03-04 19:29:37'),(134773,496,'Pipra B.O','486892',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134774,496,'Piprakhurand B.O','486886',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134775,496,'Piprohar B.O','486661',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134776,496,'Pokhra B.O','486892',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134777,496,'Pokhra B.O','486661',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134778,496,'Pondi Bastua B.O','486666',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134779,496,'Pondi Jodauri B.O','486669',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134780,496,'Pondi Naugai B.O','486886',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134781,496,'Purail B.O','486881',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134782,496,'Raghunathpur B.O','486776',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134783,496,'Raiduaria B.O','486776',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134784,496,'Rajabar B.O','486882',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134785,496,'Rajaniya B.O','486669',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134786,496,'Rajmilan B.O','486886',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134787,496,'Rampur Naikin S.O','486775',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134788,496,'Sakaria B.O','486882',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134789,496,'Salaiya B.O','486771',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134790,496,'Saleha B.O','486666',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134791,496,'Sanda B.O','486771',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134792,496,'Sarai B.O','486881',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134793,496,'Saraundha B.O','486881',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134794,496,'Sarda B.O','486661',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134795,496,'Semaria Pondi B.O','486771',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134796,496,'Sidhi Bus Stand S.O','486661',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134797,496,'Sidhi Collectorate S.O','486661',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134798,496,'Sidhi H.O','486661',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134799,496,'Sihawal S.O','486670',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134800,496,'Sonbarsha B.O','486670',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134801,496,'Suda B.O','486882',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134802,496,'Sudwar B.O','486670',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134803,496,'Supela B.O','486670',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134804,496,'Tala B.O','486666',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134805,496,'Tansar B.O','486669',1,0,'2022-03-04 19:29:38','2022-03-04 19:29:38'),(134806,496,'Tarka B.O','486661',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134807,496,'Teekar B.O','486670',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134808,496,'Tikatkala B.O','486771',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134809,496,'Tikri B.O','486669',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134810,496,'Tingudi B.O','486881',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134811,496,'Tiyara B.O','486886',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134812,496,'Ukarha B.O','486771',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134813,496,'Umaria B.O','486666',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134814,496,'Upni B.O','486661',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134815,497,'Amlori Project S.O','486887',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134816,497,'Daga Bargawan B.O','486886',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134817,497,'Dudhichua Project S.O','486888',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134818,497,'Jhingurdah B.O','486889',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134819,497,'Mada B.O','486886',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134820,497,'Shahpur B.O','486886',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134821,497,'Singrauli Colliery S.O','486889',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134822,497,'Singrauli R.S. B.O','486889',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134823,497,'Vindhyanagar S.O','486885',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134824,497,'Waidhan S.O','486886',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134825,498,'Acharra B.O','472101',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134826,498,'Airora B.O','472111',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134827,498,'Alampura B.O','472221',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134828,498,'Amarpur B.O','472010',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134829,498,'Asati B.O','472442',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134830,498,'Astari B.O','472447',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134831,498,'Aston B.O','472005',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134832,498,'Bachhoda B.O','472339',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134833,498,'Badagaon S.O','472010',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134834,498,'Bahera B.O','472447',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134835,498,'Baisa B.O','472111',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134836,498,'Baldeogarh S.O','472111',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134837,498,'Bamhori Bar B.O','472331',1,0,'2022-03-04 19:29:39','2022-03-04 19:29:39'),(134838,498,'Bamhorikala B.O','472118',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134839,498,'Bandha B.O','472101',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134840,498,'Bangain B.O','472246',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134841,498,'Banjaripura B.O','472336',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134842,498,'Banne Bujraj B.O','472115',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134843,498,'Barana B.O','472221',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134844,498,'Barethi Kala B.O','472101',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134845,498,'Barethikhas B.O','472101',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134846,498,'Bari B.O','472331',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134847,498,'Barmadang B.O','472339',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134848,498,'Barsoba B.O','472246',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134849,498,'Berwarkhas B.O','472118',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134850,498,'Bhanpura B.O','472115',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134851,498,'Bhelsa B.O','472246',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134852,498,'Bhitari B.O','472446',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134853,498,'Bhopalpur B.O','472337',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134854,498,'Bijore B.O','472445',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134855,498,'Bijron B.O','472339',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134856,498,'Binwara B.O','472442',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134857,498,'Birorakhet B.O','472336',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134858,498,'Birsagar B.O','472337',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134859,498,'Budore B.O','472221',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134860,498,'Chakarpur B.O','472246',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134861,498,'Chandera B.O','472118',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134862,498,'Chandpura B.O','472115',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134863,498,'Chaubara B.O','472115',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134864,498,'Chhidari B.O','472115',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134865,498,'Chomokhas B.O','472336',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134866,498,'Daretha B.O','472336',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134867,498,'Darguwan B.O','472010',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134868,498,'Deoraha B.O','472221',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134869,498,'Deri B.O','472115',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134870,498,'Dewarda B.O','472111',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134871,498,'Dhajrai B.O','472001',1,0,'2022-03-04 19:29:40','2022-03-04 19:29:40'),(134872,498,'Dhamanakha B.O','472339',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134873,498,'Dhilla B.O','472246',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134874,498,'Digoda S.O','472339',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134875,498,'Dikoli Chowk B.O','472111',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134876,498,'Dohochak B.O','472115',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134877,498,'Dumduma B.O','472336',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134878,498,'Dunda B.O','472010',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134879,498,'Future B.O','472115',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134880,498,'Ghoogsi B.O','472447',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134881,498,'Ghoorakhas B.O','472221',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134882,498,'Gidkhini B.O','472442',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134883,498,'Gona B.O','472221',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134884,498,'Gona B.O','472115',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134885,498,'Gor B.O','472101',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134886,498,'Gora B.O','472115',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134887,498,'Guawali B.O','472447',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134888,498,'Gukhrai B.O','472111',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134889,498,'Gurha B.O','472221',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134890,498,'Harsmau B.O','472442',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134891,498,'Hatta B.O','472111',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134892,498,'Hiranagar B.O','472001',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134893,498,'Hirapur B.O','472115',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134894,498,'Iqbal Pura B.O','472101',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134895,498,'J.M. Khargapur B.O','472115',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134896,498,'Jarua B.O','472118',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134897,498,'Jatara S.O','472118',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134898,498,'Jeoramora B.O','472336',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134899,498,'Jer B.O','472336',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134900,498,'Jerakhas B.O','472337',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134901,498,'Jeron S.O','472337',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134902,498,'Jewaha B.O','472336',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134903,498,'Jikhanguwan B.O','472447',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134904,498,'Judawan B.O','472005',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134905,498,'Jugiyai B.O','472246',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134906,498,'Kachhiyaguda B.O','472331',1,0,'2022-03-04 19:29:41','2022-03-04 19:29:41'),(134907,498,'Kachhora B.O','472221',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134908,498,'Kailpura B.O','472111',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134909,498,'Kakarwaha B.O','472010',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134910,498,'Kakwni B.O','472337',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134911,498,'Kalera B.O','472118',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134912,498,'Kanera B.O','472118',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134913,498,'Karikhas B.O','472001',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134914,498,'Karmora B.O','472118',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134915,498,'Khargapur S.O','472115',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134916,498,'Khera B.O','472001',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134917,498,'Kheron B.O','472331',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134918,498,'Khiriya Naka B.O','472005',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134919,498,'Khiston B.O','472336',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134920,498,'Kudar B.O','472446',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134921,498,'Kudila B.O','472115',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134922,498,'Kulua B.O','472442',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134923,498,'Kumarra B.O','472246',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134924,498,'Kundshwer S.O','472005',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134925,498,'Ladwari B.O','472336',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134926,498,'Lar B.O','472010',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134927,498,'Laron B.O','472221',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134928,498,'Lidhora S.O','472331',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134929,498,'Loharguwn B.O','472337',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134930,498,'Mabai B.O','472001',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134931,498,'Madia B.O','472336',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134932,498,'Madore B.O','472246',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134933,498,'Magrai B.O','472221',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134934,498,'Maharajpur B.O','472001',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134935,498,'Mahobachak B.O','472331',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134936,498,'Malguwn B.O','472115',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134937,498,'Marguwna B.O','472331',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134938,498,'Master Mogna B.O','472101',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134939,498,'Matol B.O','472115',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134940,498,'Mawai B.O','472221',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134941,498,'Mogna B.O','472101',1,0,'2022-03-04 19:29:42','2022-03-04 19:29:42'),(134942,498,'Mohangarh S.O (Tikamgarh)','472101',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134943,498,'Mohanpura B.O','472246',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134944,498,'Mudara B.O','472442',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134945,498,'Muhara B.O','472118',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134946,498,'Naguwan B.O','472336',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134947,498,'Nandanwara B.O','472101',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134948,498,'Nanhitehtri B.O','472111',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134949,498,'Narayanpura B.O','472111',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134950,498,'Narguda B.O','472001',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134951,498,'Nayagaon B.O','472111',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134952,498,'Nibora B.O','472118',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134953,498,'Niwari S.O','472442',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134954,498,'Nuna B.O','472331',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134955,498,'Orchha S.O','472246',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134956,498,'Pahadi Tilwalran B.O','472005',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134957,498,'Pahadibujurg B.O','472118',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134958,498,'Paitpura B.O','472118',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134959,498,'Palera S.O','472221',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134960,498,'Pali B.O','472221',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134961,498,'Papawani B.O','472337',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134962,498,'Papora B.O','472001',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134963,498,'Para B.O','472221',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134964,498,'Patha B.O','472001',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134965,498,'Patharam B.O','472445',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134966,498,'Pathrguwa B.O','472115',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134967,498,'Pohakhas B.O','472442',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134968,498,'Pratappura B.O','472246',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134969,498,'Prithvipur S.O','472336',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134970,498,'Puchikarguwan B.O','472445',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134971,498,'Purenia B.O','472115',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134972,498,'Ramgarh B.O','472118',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134973,498,'Ramnagar B.O','472339',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134974,498,'Ramnagar B.O','472115',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134975,498,'Ranipura B.O','472111',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134976,498,'Sagarwara B.O','472118',1,0,'2022-03-04 19:29:43','2022-03-04 19:29:43'),(134977,498,'Sakerabhadaran B.O','472336',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(134978,498,'Saktibheron B.O','472446',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(134979,498,'Samarra B.O','472010',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(134980,498,'Sapon B.O','472010',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(134981,498,'Sarkanpur B.O','472115',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(134982,498,'Satguwa B.O','472331',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(134983,498,'Sendri S.O','472446',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(134984,498,'Shah B.O','472118',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(134985,498,'Sijora B.O','472115',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(134986,498,'Simra B.O','472337',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(134987,498,'Siyawanikha B.O','472331',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(134988,498,'Smarakhurd B.O','472221',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(134989,498,'Sujanpura B.O','472111',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(134990,498,'Sunderpur B.O','472001',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(134991,498,'Sunoniya B.O','472246',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(134992,498,'Tahanga B.O','472221',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(134993,498,'Taricharkala S.O','472445',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(134994,498,'Teharka S.O','472447',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(134995,498,'Thona B.O','472445',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(134996,498,'Tikamgarh City S.O','472001',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(134997,498,'Tikamgarh Coll S.O','472001',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(134998,498,'Tikamgarh H.O','472001',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(134999,498,'Tikamgarh P.T S.O','472001',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(135000,498,'Toriya B.O','472221',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(135001,498,'Ubora B.O','472445',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(135002,498,'Umari B.O','472010',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(135003,498,'Uparakhas B.O','472447',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(135004,499,'Aajdawada B.O','456776',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(135005,499,'Aajmabad B.O','456441',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(135006,499,'Akasoda B.O','456222',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(135007,499,'Akya  Jagir B.O','456224',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(135008,499,'Alot Jagir B.O','456221',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(135009,499,'Amla B.O','456771',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(135010,499,'Amodiya B.O','456006',1,0,'2022-03-04 19:29:44','2022-03-04 19:29:44'),(135011,499,'Asawata B.O','456771',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135012,499,'Aslavada B.O','456337',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135013,499,'Badagaon B.O','456337',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135014,499,'Badagaon B.O','456776',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135015,499,'Badkummed B.O','456661',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135016,499,'Baghera B.O','456770',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135017,499,'Baledi S.O','456222',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135018,499,'Baloda Lakkha B.O','456776',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135019,499,'Bamnapati B.O','456222',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135020,499,'Banbana B.O','456335',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135021,499,'Bangred B.O','456771',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135022,499,'Bappiya B.O','456440',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135023,499,'Barkheda  Buzurg B.O','456443',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135024,499,'Barkheda  Pitramal B.O','456335',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135025,499,'Barkheda Madan B.O','456221',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135026,499,'Barnagar  Bunglow B.O','456771',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135027,499,'Barnagar S.O','456771',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135028,499,'Barnagar Town S.O','456771',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135029,499,'Batlawdi B.O','456224',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135030,499,'Bedavan B.O','456221',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135031,499,'Berchha B.O','456440',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135032,499,'BERCHHI B.O','456770',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135033,499,'Bhainsoda B.O','456224',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135034,499,'Bhatisuda B.O','456331',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135035,499,'Bhatkhedi B.O','456224',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135036,499,'Bhatpachlana S.O','456313',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135037,499,'Bhikampur B.O','456313',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135038,499,'Bichrod B.O','456665',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135039,499,'Birakhedi B.O','456771',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135040,499,'Birlagram  Nagda S.O','456331',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135041,499,'Bolasa B.O','456664',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135042,499,'Buranabad B.O','456224',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135043,499,'Chadawad B.O','456665',1,0,'2022-03-04 19:29:45','2022-03-04 19:29:45'),(135044,499,'Chandesara B.O','456664',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135045,499,'Chapakhedi B.O','456224',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135046,499,'Chapaner B.O','456224',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135047,499,'Chikli B.O','456222',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135048,499,'Chintaman Jawasia B.O','456006',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135049,499,'Chirola  Chhota B.O','456313',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135050,499,'Chirola B.O','456313',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135051,499,'Chitavad B.O','456443',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135052,499,'Dangwada B.O','456222',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135053,499,'Delchi  Buzurg B.O','456440',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135054,499,'Dhabla  Hardu B.O','456550',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135055,499,'Dharakheda B.O','456443',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135056,499,'Dungarkheda B.O','456550',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135057,499,'Durgapura B.O','456331',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135058,499,'Etawa B.O','456668',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135059,499,'Ghattia S.O','456550',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135060,499,'Ghinoda B.O','456224',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135061,499,'Ghonsla B.O','456550',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135062,499,'Ghudawan B.O','456222',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135063,499,'Gogakheda B.O','456441',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135064,499,'Goyalabujurg B.O','456003',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135065,499,'Harnawada B.O','456222',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135066,499,'Harsodhan B.O','456661',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135067,499,'Hatai B.O','456335',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135068,499,'Indokh B.O','456441',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135069,499,'Ingoria B.O','456222',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135070,499,'Jagoti B.O','456550',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135071,499,'Jahagirpur B.O','456337',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135072,499,'Jalodia B.O','456771',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135073,499,'Jalwa B.O','456550',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135074,499,'Jawasia Kumar B.O','456770',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135075,499,'Jethal B.O','456006',1,0,'2022-03-04 19:29:46','2022-03-04 19:29:46'),(135076,499,'Jharda S.O','456441',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135077,499,'Jhitarkhedi B.O','456550',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135078,499,'Jhutawad B.O','456440',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135079,499,'Kachnariya B.O','456664',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135080,499,'Kachria B.O','456441',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135081,499,'Kadoudiya B.O','456668',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135082,499,'Kagdikaradia B.O','456006',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135083,499,'Kaliadeh B.O','456003',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135084,499,'Kaluheda B.O','456006',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135085,499,'Kamthana B.O','456313',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135086,499,'Kanardi B.O','456770',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135087,499,'Kanasia S.O','456770',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135088,499,'Kanwas B.O','456224',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135089,499,'Kapeli B.O','456668',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135090,499,'KARANJ B.O','456665',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135091,499,'Karedimataji B.O','456770',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135092,499,'Karohan B.O','456006',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135093,499,'KATHBAROD B.O','456665',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135094,499,'Kaytha B.O','456665',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135095,499,'Kesaria B.O','456224',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135096,499,'Keson B.O','456550',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135097,499,'Khachraud Rs S.O','456224',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135098,499,'Khachraud S.O','456224',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135099,499,'KHAJURIYA B.O','456665',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135100,499,'Khandoda B.O','456222',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135101,499,'Kharsod Khurd B.O','456222',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135102,499,'Kharsodkalan B.O','456313',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135103,499,'Khedakhajuria B.O','456443',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135104,499,'Khedavada B.O','456776',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135105,499,'Kundikheda B.O','456441',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135106,499,'Lalgarh B.O','456441',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135107,499,'Lekoda Anjana B.O','456337',1,0,'2022-03-04 19:29:47','2022-03-04 19:29:47'),(135108,499,'Lekoda B.O','456006',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135109,499,'Lohana B.O','456771',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135110,499,'Lotiyajunarda B.O','456441',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135111,499,'Madawda B.O','456313',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135112,499,'Mahu B.O','456443',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135113,499,'Mahudi B.O','456550',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135114,499,'Makdavan B.O','456337',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135115,499,'Makdone S.O','456668',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135116,499,'Makla B.O','456441',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135117,499,'Malikhedi B.O','456550',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135118,499,'Matana  Kalan B.O','456664',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135119,499,'Mehatvas B.O','456331',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135120,499,'Mehidpur  Road S.O','456440',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135121,499,'Mehidpur S.O','456443',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135122,499,'Molana B.O','456771',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135123,499,'Nagda  Town S.O','456335',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135124,499,'Nagda S.O','456335',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135125,499,'Nainawad B.O','456770',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135126,499,'Nalva B.O','456222',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135127,499,'Nanded B.O','456668',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135128,499,'Nandiyasi B.O','456313',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135129,499,'Narsingarh B.O','456313',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135130,499,'Narwar S.O (Ujjain)','456664',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135131,499,'Nauganwa B.O','456664',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135132,499,'Navakheda B.O','456006',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135133,499,'Nazarpur B.O','456550',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135134,499,'Nimboda B.O','456222',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135135,499,'NINORA B.O','456006',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135136,499,'Nogaova B.O','456665',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135137,499,'Pachlasi B.O','456224',1,0,'2022-03-04 19:29:48','2022-03-04 19:29:48'),(135138,499,'Palduna B.O','456771',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135139,499,'Palsoda Makdavan B.O','456337',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135140,499,'Panbihar B.O','456006',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135141,499,'Panthpiplai B.O','456006',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135142,499,'Parsoli B.O','456550',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135143,499,'Paslod B.O','456221',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135144,499,'Pat B.O','456550',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135145,499,'Peerjhalar B.O','456771',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135146,499,'Pipliahama B.O','456006',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135147,499,'Piploda  Baghla S.O','456337',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135148,499,'Piploda  Dwarkadhish B.O','456664',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135149,499,'Piplu B.O','456771',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135150,499,'Ratadia B.O','456006',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135151,499,'Rnayarapeer B.O','456441',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135152,499,'Rohil  Khurd B.O','456335',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135153,499,'Rooi B.O','456003',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135154,499,'Roopakhedi B.O','456668',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135155,499,'Run Kheda B.O','456224',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135156,499,'Runija S.O','456776',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135157,499,'Rupeta B.O','456335',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135158,499,'Sagwali B.O','456440',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135159,499,'Samgi B.O','456770',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135160,499,'Sandla B.O','456337',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135161,499,'Semliya B.O','456443',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135162,499,'Shakkar  Khedi B.O','456443',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135163,499,'Shrivatsa B.O','456224',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135164,499,'Sijavta B.O','456222',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135165,499,'Sodang B.O','456003',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135166,499,'Sumrakheda B.O','456665',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135167,499,'Sundarabad B.O','456776',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135168,499,'SURASA B.O','456006',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135169,499,'Suwasa B.O','456337',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135170,499,'Tajpur S.O (Ujjain)','456661',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135171,499,'Takwasa B.O','456006',1,0,'2022-03-04 19:29:49','2022-03-04 19:29:49'),(135172,499,'Talod B.O','456006',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135173,499,'Tarana S.O','456665',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135174,499,'Tilawad B.O','456668',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135175,499,'Tulaheda B.O','456550',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135176,499,'Tutiya  Khedi B.O','456440',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135177,499,'Ujjain  Bherugarh S.O','456003',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135178,499,'Ujjain  City S.O','456006',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135179,499,'Ujjain  Danigate S.O','456006',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135180,499,'Ujjain  Factory B.O','456006',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135181,499,'Ujjain  Govt. Engg. CollegeB.O','456006',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135182,499,'Ujjain  Gujrati  Samaj S.O','456006',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135183,499,'Ujjain  Kothi S.O','456010',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135184,499,'Ujjain  M.L.Nagar S.O','456010',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135185,499,'Ujjain  Madhonagar S.O','456010',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135186,499,'Ujjain  Rishi Nagar S.O','456010',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135187,499,'Ujjain  Shri  Mahakal B.O','456006',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135188,499,'Ujjain Daulatganj S.O','456001',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135189,499,'Ujjain H.O','456001',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135190,499,'UJJAIN NAYAPURA','456006',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135191,499,'UJJAIN RAMGHATMARG','456006',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135192,499,'Ujjain Vikram University S.O','456010',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135193,499,'Ujjainiya B.O','456550',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135194,499,'Undasa B.O','456006',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135195,499,'Unhel S.O','456221',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135196,500,'Akhdar B.O','484660',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135197,500,'Amarpur B.O','484661',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135198,500,'Amiliha B.O','484001',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135199,500,'Badchhad B.O','484661',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135200,500,'Baderi B.O','484661',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135201,500,'Badwar B.O','484661',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135202,500,'Bakeli B.O','484001',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135203,500,'Balhaud B.O','484665',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135204,500,'Bandhavgarh National Park S.O','484664',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135205,500,'Bandhwatola B.O','484552',1,0,'2022-03-04 19:29:50','2022-03-04 19:29:50'),(135206,500,'Banka B.O','484660',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135207,500,'Baroda B.O','484660',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135208,500,'Bharaula B.O','484661',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135209,500,'Bharewa B.O','484661',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135210,500,'Bhundi B.O','484661',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135211,500,'Bijauri B.O','484665',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135212,500,'Bilaspur B.O','484660',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135213,500,'Birsinghpur Pali S.O','484551',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135214,500,'Chandia S.O','484660',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135215,500,'Chansura B.O','484661',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135216,500,'Chauri B.O','484001',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135217,500,'Checheria B.O','484551',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135218,500,'Chhatwai B.O','484001',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135219,500,'Chilhari B.O','484661',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135220,500,'Dhamokhar B.O','484661',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135221,500,'Dhanwar B.O','484661',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135222,500,'Ghunghuti B.O','484551',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135223,500,'Gobarde B.O','484665',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135224,500,'Gopalpur B.O','484555',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135225,500,'Harrwah B.O','484660',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135226,500,'Indwar B.O','484661',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135227,500,'Jarha B.O','484555',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135228,500,'Jhall B.O','484661',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135229,500,'Jobi B.O','484661',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135230,500,'Kachharwar B.O','484661',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135231,500,'Kanchanpur B.O','484555',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135232,500,'Karkeli B.O','484661',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135233,500,'Kathar B.O','484665',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135234,500,'Khalaundh B.O','484661',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135235,500,'Kothari B.O','484661',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135236,500,'Lorha B.O','484660',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135237,500,'Mahroi B.O','484661',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135238,500,'Majmanikala B.O','484661',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135239,500,'Manpur S.O (Umaria)','484665',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135240,500,'Mudgudi B.O','484661',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135241,500,'Narwar B.O','484660',1,0,'2022-03-04 19:29:51','2022-03-04 19:29:51'),(135242,500,'Naugawan B.O','484665',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135243,500,'Nigahri B.O','484661',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135244,500,'Nowrozabad S.O','484555',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135245,500,'Padkhuri B.O','484661',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135246,500,'Padwar B.O','484661',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135247,500,'Panpatha B.O','484661',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135248,500,'Panwar B.O','486661',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135249,500,'Pathari B.O','484555',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135250,500,'Pathrahta B.O','484660',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135251,500,'Pinaura B.O','484555',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135252,500,'Rahta B.O','484555',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135253,500,'Raipur B.O','484551',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135254,500,'Salaiya B.O','484001',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135255,500,'Saraswahi B.O','484661',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135256,500,'Semra B.O','484665',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135257,500,'Sgtps Pali S.O','484552',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135258,500,'Shahpur B.O','484001',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135259,500,'Sundardadar B.O','484552',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135260,500,'Tala B.O','484661',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135261,500,'Tikuri B.O','484661',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135262,500,'Umaria Bakeli B.O','484661',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135263,500,'Umaria S.O','484661',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135264,501,'Agrabarkheda B.O','464111',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135265,501,'Ahemadnagar B.O','464113',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135266,501,'Ahmedpur B.O','464001',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135267,501,'Ambanagar B.O','464221',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135268,501,'Ambar B.O','464001',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135269,501,'Amkhedasukha B.O','464221',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135270,501,'Anandpur B.O','464114',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135271,501,'Ancheda B.O','464221',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135272,501,'Andiakala B.O','464220',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135273,501,'Atarikhejda B.O','464001',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135274,501,'Attasemra B.O','464220',1,0,'2022-03-04 19:29:52','2022-03-04 19:29:52'),(135275,501,'Balabarkheda B.O','464226',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135276,501,'Bamhori Shalla B.O','464228',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135277,501,'Bandraotha B.O','464337',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135278,501,'Banshkhedia. B.O','464228',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135279,501,'Baoli B.O','464337',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135280,501,'Bareth B.O','464221',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135281,501,'Barkhedajagir B.O','464111',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135282,501,'Barrighat B.O','464220',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135283,501,'Barwai B.O','464224',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135284,501,'Basoda City S.O','464221',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135285,501,'Basoda S.R S.O','464221',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135286,501,'Beenjh B.O','464113',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135287,501,'Bhadarbadagaon B.O','464001',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135288,501,'Bhagwantpur B.O','464228',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135289,501,'Bhalbamora B.O','464337',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135290,501,'Bharro B.O','464226',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135291,501,'Bhonriya B.O','464228',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135292,501,'Bhorasa B.O','464224',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135293,501,'Bichhiya B.O','464111',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135294,501,'Bidhwasan B.O','464221',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135295,501,'Biladhana B.O','464221',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135296,501,'Bishanpur B.O','464224',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135297,501,'Budhigagrod B.O','464331',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135298,501,'Chatholi B.O','464220',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135299,501,'Chatholi B.O','464228',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135300,501,'Cherkheda B.O','464226',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135301,501,'Chirodia B.O','464001',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135302,501,'Chitawar B.O','464228',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135303,501,'Dangarwada B.O','464111',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135304,501,'Danwas B.O','464114',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135305,501,'Deepankheda B.O','464228',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135306,501,'Dehri B.O','464228',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135307,501,'Deokhajuri B.O','464258',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135308,501,'Dhamnod B.O','464331',1,0,'2022-03-04 19:29:53','2022-03-04 19:29:53'),(135309,501,'Dhua B.O','464224',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135310,501,'Dudhawari B.O','464240',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135311,501,'Gadla B.O','464258',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135312,501,'Gamkhar B.O','464221',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135313,501,'Ganjbasoda S.O','464221',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135314,501,'Garantha B.O','464228',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135315,501,'Ghatera B.O','464221',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135316,501,'Ghatwar B.O','464228',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135317,501,'Ghuuletha B.O','464221',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135318,501,'Gulabganj S.O','464220',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135319,501,'Gunnotha B.O','464331',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135320,501,'Gyraspur S.O','464331',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135321,501,'Hansua B.O','464001',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135322,501,'Hinotia B.O','464258',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135323,501,'Hydergarh B.O','464331',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135324,501,'Imalia B.O','464001',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135325,501,'Inderwas B.O','464331',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135326,501,'Jaitpur B.O','464228',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135327,501,'Javti B.O','464114',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135328,501,'Jhandwa B.O','464228',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135329,501,'Jhukarhoj B.O','464228',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135330,501,'Johad B.O','464221',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135331,501,'Kacchikheda B.O','464114',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135332,501,'Kakrada B.O','464221',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135333,501,'Karaiyahat B.O','464226',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135334,501,'Karaiyahat B.O','464228',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135335,501,'Karela B.O','464226',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135336,501,'Khader B.O','464221',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135337,501,'Khamkheda B.O','464331',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135338,501,'Khamkheda S.O','464226',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135339,501,'Khamtala B.O','464226',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135340,501,'Khari B.O','464001',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135341,501,'Kharpari B.O','464221',1,0,'2022-03-04 19:29:54','2022-03-04 19:29:54'),(135342,501,'Kirwaya B.O','464221',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135343,501,'Kothicharkalan B.O','464113',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135344,501,'Kulhar B.O','464240',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135345,501,'Kurwai S.O','464224',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135346,501,'Kurwaikathora B.O','464224',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135347,501,'Lachayara B.O','464224',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135348,501,'Lashkarpur B.O','464001',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135349,501,'Lateri S.O','464114',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135350,501,'Layara B.O','464224',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135351,501,'Mahelua B.O','464224',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135352,501,'Mahoo B.O','464221',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135353,501,'Mahoti B.O','464114',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135354,501,'Mainwada B.O','464331',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135355,501,'Manora B.O','464331',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135356,501,'Markheda B.O','464221',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135357,501,'Masoodpur B.O','464221',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135358,501,'Mirzapur B.O','464001',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135359,501,'Mohammadgarh B.O','464331',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135360,501,'Mohnakhejda B.O','464001',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135361,501,'Mugalsarai B.O','464228',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135362,501,'Mundela B.O','464114',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135363,501,'Mungwara B.O','464220',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135364,501,'Muradpur B.O','464221',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135365,501,'Murahar B.O','464337',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135366,501,'Muraria B.O','464114',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135367,501,'Murwas B.O','464114',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135368,501,'Nagore B.O','464258',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135369,501,'Nateran S.O','464258',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135370,501,'Naukund B.O','464224',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135371,501,'Naulas B.O','464001',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135372,501,'Okhlikheda B.O','464114',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135373,501,'Parsora B.O','464228',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135374,501,'Pathari S.O (Vidisha)','464337',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135375,501,'Pauanala B.O','464226',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135376,501,'Pawai B.O','464220',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135377,501,'Phupher B.O','464221',1,0,'2022-03-04 19:29:55','2022-03-04 19:29:55'),(135378,501,'Pilone B.O','464224',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135379,501,'Pipaldhar B.O','464113',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135380,501,'Pipalkheda S.O','464113',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135381,501,'Pipraha B.O','464331',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135382,501,'Ravan B.O','464258',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135383,501,'Roshanpiparia B.O','464224',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135384,501,'Rusalidama B.O','464228',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135385,501,'Russallishahu B.O','464114',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135386,501,'Sader B.O','464111',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135387,501,'Sangeul B.O','464111',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135388,501,'Sankalkheda B.O','464113',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135389,501,'Sankalkheda B.O','464258',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135390,501,'Satpada B.O','464113',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135391,501,'Satpadahat B.O','464221',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135392,501,'Sehod B.O','464001',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135393,501,'Semalkhedi(S) B.O','464228',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135394,501,'Seo B.O','464258',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135395,501,'Serwasa B.O','464240',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135396,501,'Shamshabad S.O (Vidisha)','464111',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135397,501,'Sheharkheda B.O','464114',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135398,501,'Shekhpur B.O','464224',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135399,501,'Simarhar B.O','464001',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135400,501,'Sirnota B.O','464221',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135401,501,'Sironj City S.O','464228',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135402,501,'Sironj S.O','464228',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135403,501,'Siyalpur B.O','464228',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135404,501,'Sojna B.O','464220',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135405,501,'Sonther B.O','464001',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135406,501,'Sumerr S B.O','464220',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135407,501,'Sunkher B.O','464114',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135408,501,'Tal B.O','464228',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135409,501,'Teonda B.O','464331',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135410,501,'Thanner B.O','464113',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135411,501,'Tharr B.O','464001',1,0,'2022-03-04 19:29:56','2022-03-04 19:29:56'),(135412,501,'Toribagrod B.O','464228',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135413,501,'Uadigiri B.O','464001',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135414,501,'Udaipur B.O','464221',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135415,501,'Uhar B.O','464221',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135416,501,'Unarshikala B.O','464114',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135417,501,'Unarsikhurd B.O','464228',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135418,501,'Vidisha Collectorate S.O','464001',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135419,501,'Vidisha Fort S.O','464001',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135420,501,'Vidisha H.O','464001',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135421,501,'Vidisha Mandi S.O','464001',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135422,501,'Vidisha S.A.T.I. S.O','464001',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135423,501,'Wardha B.O','464111',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135424,502,'Abhapuri B.O','451332',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135425,502,'Adhawan B.O','451001',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135426,502,'Ahirkheda B.O','451113',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135427,502,'Ali Bujurg B.O','451111',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135428,502,'Amlatha B.O','451228',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135429,502,'Andad B.O','451335',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135430,502,'Anjangaon B.O','451113',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135431,502,'Ashapur B.O','451224',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135432,502,'Aurangpura B.O','451001',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135433,502,'Bablai B.O','451221',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135434,502,'Baddiya B.O','451225',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135435,502,'Badel B.O','451115',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135436,502,'Badgaon B.O','451113',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135437,502,'Badgaon B.O','451001',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135438,502,'Badi B.O','451228',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135439,502,'Badud B.O','451111',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135440,502,'Badwell B.O','451224',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135441,502,'Bagda Bujurg B.O','451113',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135442,502,'Bagod B.O','451220',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135443,502,'Balakwada B.O','451001',1,0,'2022-03-04 19:29:57','2022-03-04 19:29:57'),(135444,502,'Balkhad B.O','451228',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135445,502,'Balsamund B.O','451228',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135446,502,'Balwada B.O','451115',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135447,502,'Balwadi B.O','451001',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135448,502,'Bamandi B.O','451228',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135449,502,'Bamkhal B.O','451001',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135450,502,'Bamnala B.O','451331',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135451,502,'Banher B.O','451441',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135452,502,'Banjhar B.O','451331',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135453,502,'Barjhar B.O','451115',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135454,502,'Barud Tanda B.O','451001',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135455,502,'Barwaha S.O','451115',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135456,502,'Baswa B.O','451111',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135457,502,'Bawi B.O','451220',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135458,502,'Bedia S.O','451113',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135459,502,'Behrampur B.O','451331',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135460,502,'Bhagawa B.O','450554',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135461,502,'Bhagwanpur B.O','451441',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135462,502,'Bhagyapur B.O','451441',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135463,502,'Bhairukheda B.O','450771',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135464,502,'Bhampura B.O','451225',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135465,502,'Bhanbarad B.O','451111',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135466,502,'Bhatalpura B.O','451331',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135467,502,'Bhikangaon S.O','451331',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135468,502,'Bhilgaon B.O','451228',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135469,502,'Bhoinda B.O','451660',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135470,502,'Bhomwada B.O','450551',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135471,502,'Bhudari B.O','451220',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135472,502,'Bhulgaon B.O','451113',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135473,502,'Birul B.O','451331',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135474,502,'Bistan S.O','451441',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135475,502,'Borawa B.O','451228',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135476,502,'Chainpur B.O','451332',1,0,'2022-03-04 19:29:58','2022-03-04 19:29:58'),(135477,502,'Chandanpuri B.O','451001',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135478,502,'Chhirwa B.O','451113',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135479,502,'Chichali (N) B.O','451660',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135480,502,'Chiriya B.O','451332',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135481,502,'Choli B.O','451221',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135482,502,'Choti Kasrawad B.O','451228',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135483,502,'Choti Khargone B.O','451221',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135484,502,'Damkheda B.O','451441',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135485,502,'Dariya Mahal S.O','451115',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135486,502,'Dasnawal B.O','451335',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135487,502,'Dasnawal B.O','451442',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135488,502,'Dayalpura B.O','451335',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135489,502,'Deola B.O','451331',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135490,502,'Dhakalgaon B.O','451111',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135491,502,'Dhargaon B.O','451221',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135492,502,'Dhulkot B.O','451441',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135493,502,'Dodwan B.O','451111',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135494,502,'Dogawa B.O','451228',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135495,502,'Dongargaon B.O','451442',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135496,502,'Gandhawal B.O','451440',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135497,502,'Ghatyabedi B.O','451220',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135498,502,'Ghegaon B.O','451442',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135499,502,'Ghugharya Khedi B.O','451335',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135500,502,'Gogawa S.O','451335',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135501,502,'Golwadi B.O','451442',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135502,502,'Goradiya B.O','451332',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135503,502,'Goul B.O','450551',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135504,502,'Hirapur B.O','451111',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135505,502,'Igriya B.O','451332',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135506,502,'Itawadi B.O','451224',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135507,502,'Jagatpura B.O','451115',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135508,502,'Jethway B.O','451115',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135509,502,'Jhigadi B.O','451115',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135510,502,'Jhirnia S.O','451332',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135511,502,'Kabri B.O','451441',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135512,502,'Kaldha B.O','451331',1,0,'2022-03-04 19:29:59','2022-03-04 19:29:59'),(135513,502,'Kamodwada B.O','451335',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135514,502,'Kanapur B.O','451113',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135515,502,'Kanjhar B.O','451331',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135516,502,'Karhi S.O','451220',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135517,502,'Karondiya B.O','451221',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135518,502,'Kasrawad S.O','451228',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135519,502,'Katargaon B.O','451225',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135520,502,'Katkut B.O','451115',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135521,502,'Kavdiya B.O','451221',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135522,502,'Keli B.O','451442',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135523,502,'Khadakwani B.O','451660',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135524,502,'Khal Bujurg B.O','451660',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135525,502,'Khamkheda B.O','451335',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135526,502,'Khangwada B.O','451111',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135527,502,'Kharadi B.O','451224',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135528,502,'Khargone H.O','451001',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135529,502,'Khargone Municipal Col. S.O','451001',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135530,502,'Khargone Tawnhall S.O','451001',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135531,502,'Khedi Bujurg B.O','451113',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135532,502,'Kithud B.O','451115',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135533,502,'Kodlya Khedi B.O','451225',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135534,502,'Kogawan B.O','451225',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135535,502,'Kothakhurd B.O','451001',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135536,502,'Kukdhal B.O','451001',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135537,502,'Lalkheda B.O','451331',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135538,502,'Lehaku B.O','451442',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135539,502,'Likhi B.O','451440',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135540,502,'Lohari B.O','451001',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135541,502,'Lonara B.O','451442',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135542,502,'Machalpur B.O','451225',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135543,502,'Maheshwar S.O','451224',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135544,502,'Makshi B.O','451224',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135545,502,'Maltar B.O','451660',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135546,502,'Mandleshwar S.O','451221',1,0,'2022-03-04 19:30:00','2022-03-04 19:30:00'),(135547,502,'Mangral Khurd B.O','451001',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135548,502,'Mardana B.O','451113',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135549,502,'Matmur B.O','451224',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135550,502,'Mehatwada B.O','451224',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135551,502,'Methawa B.O','451220',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135552,502,'Mohammadpur B.O','451335',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135553,502,'Mongargaon B.O','451441',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135554,502,'Mukhatyra B.O','451115',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135555,502,'Multhan B.O','451335',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135556,502,'Nagjhiri B.O','451001',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135557,502,'Nandgaon B.O','451440',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135558,502,'Nandia B.O','451115',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135559,502,'Nandra B.O','451225',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135560,502,'Nargaon B.O','451331',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135561,502,'Navghatkhedi B.O','451115',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135562,502,'Naya B.O','451115',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135563,502,'Nimarani B.O','451660',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135564,502,'Ojhara B.O','451228',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135565,502,'Padlya B.O','451332',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135566,502,'Padlya B.O','451220',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135567,502,'Pandhaniya B.O','451001',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135568,502,'Pathrad B.O','451225',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135569,502,'Penpur B.O','451441',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135570,502,'Pipalgaon B.O','451228',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135571,502,'Pipaljhopa B.O','451441',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135572,502,'Pipari B.O','451440',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135573,502,'Piplya Buzurg S.O','451225',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135574,502,'Piprad B.O','451331',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135575,502,'Piprata B.O','451001',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135576,502,'Pitnagar B.O','451113',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135577,502,'Rahatkot B.O','451113',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135578,502,'Raibidpur B.O','451440',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135579,502,'Rasgaon B.O','451442',1,0,'2022-03-04 19:30:01','2022-03-04 19:30:01'),(135580,502,'Ratanpur B.O','451115',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135581,502,'Ratanpur B.O','451332',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135582,502,'Rawerkhedi B.O','451113',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135583,502,'Regwa B.O','451228',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135584,502,'Rehgaon B.O','451335',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135585,502,'Rodia B.O','451113',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135586,502,'Sagur Bhagur B.O','451331',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135587,502,'Saikhedi B.O','451331',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135588,502,'Sanawad S.O','451111',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135589,502,'Satajana B.O','451111',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135590,502,'Satawad B.O','451440',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135591,502,'Satkut B.O','451228',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135592,502,'Satrati B.O','451660',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135593,502,'Segaon S.O (West Nimar)','451442',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135594,502,'Sejgaon B.O','451225',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135595,502,'Selda B.O','451331',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135596,502,'Shakargaon B.O','451331',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135597,502,'Shivana B.O','451332',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135598,502,'Shri Khandi B.O','451440',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135599,502,'Singun B.O','451001',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135600,502,'Sinkheda B.O','451001',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135601,502,'Siptan B.O','451001',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135602,502,'Sirwel B.O','451441',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135603,502,'Somakhedi B.O','451221',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135604,502,'Sundrel B.O','451331',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135605,502,'Surpala B.O','451440',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135606,502,'Talakpura B.O','451440',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135607,502,'Temla B.O','451001',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135608,502,'Temrani B.O','451001',1,0,'2022-03-04 19:30:02','2022-03-04 19:30:02'),(135609,502,'Thangaon B.O','451221',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135610,502,'Tharwar B.O','451115',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135611,502,'Thibgaon B.O','451335',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135612,502,'Tinsya B.O','451331',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135613,502,'Umaria Chowki B.O','451115',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135614,502,'Umarkhali B.O','451441',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135615,502,'Un S.O (West Nimar)','451440',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135616,502,'Vani B.O','451220',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135617,502,'Vithnera B.O','451335',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135618,503,'Advalpal B.O','403503',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135619,503,'Advoi B.O','403530',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135620,503,'Agarwada B.O','403512',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135621,503,'Aldona S.O','403508',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135622,503,'Alto Betim S.O','403521',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135623,503,'Alto-porvorim S.O','403521',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135624,503,'Anjuna S.O','403509',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135625,503,'Arambol S.O','403524',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135626,503,'Arpora B.O','403516',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135627,503,'Assagao B.O','403507',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135628,503,'Assonora S.O','403503',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135629,503,'Baga B.O','403516',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135630,503,'Bambolim Camp S.O','403201',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135631,503,'Bambolim Complex S.O','403202',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135632,503,'Bastora B.O','403507',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135633,503,'Betim S.O','403101',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135634,503,'Betki B.O','403107',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135635,503,'Bicholim Industrial Estate S.O','403529',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135636,503,'Bicholim S.O','403504',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135637,503,'Birondam B.O','403506',1,0,'2022-03-04 19:30:03','2022-03-04 19:30:03'),(135638,503,'C.C.Altinho S.O','403001',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135639,503,'Caisua B.O','403509',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135640,503,'Calangute S.O','403516',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135641,503,'Calvim B.O','403523',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135642,503,'Camurlim B.O','403507',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135643,503,'Canca B.O','403510',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135644,503,'Candepar B.O','403406',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135645,503,'Candolim S.O','403515',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135646,503,'Cansarvornem B.O','403512',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135647,503,'Carambolim B.O','403110',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135648,503,'Caranzalem S.O','403002',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135649,503,'Carapur B.O','403505',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135650,503,'Carona S.O','403523',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135651,503,'Chimbel B.O','403006',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135652,503,'Chorao S.O','403102',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135653,503,'Colvale S.O','403513',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135654,503,'Corgao B.O','403512',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135655,503,'Corjuim B.O','403508',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135656,503,'Corlim IE S.O','403110',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135657,503,'Cotorem B.O','403506',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135658,503,'Cudne B.O','403505',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135659,503,'Cumbharjua B.O','403107',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135660,503,'Darbandora B.O','403406',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135661,503,'Dhagalim B.O','403513',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135662,503,'Dodamarg B.O','403503',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135663,503,'Goa University S.O','403206',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135664,503,'Goa -velha S.O','403108',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135665,503,'Guleli B.O','403506',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135666,503,'Gurim B.O','403507',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135667,503,'Ibrampur B.O','403503',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135668,503,'Kerim B.O','403505',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135669,503,'Malar B.O','403403',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135670,503,'Mandrem S.O','403527',1,0,'2022-03-04 19:30:04','2022-03-04 19:30:04'),(135671,503,'Mandur B.O','403104',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135672,503,'Mapusa I.E. S.O','403507',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135673,503,'Mapusa S.O','403507',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135674,503,'Marcaim B.O','403404',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135675,503,'Maulinge B.O','403504',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135676,503,'Mauzi B.O','403506',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135677,503,'Mayem B.O','403504',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135678,503,'Menkurim B.O','403513',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135679,503,'Miramar S.O','403001',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135680,503,'Moira B.O','403507',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135681,503,'Morjim B.O','403512',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135682,503,'Morlem B.O','403505',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135683,503,'Mulgao B.O','403503',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135684,503,'N B Verem S.O','403109',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135685,503,'Nachinola B.O','403508',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135686,503,'Nagargaon B.O','403506',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135687,503,'Nagzar B.O','403512',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135688,503,'Nanora B.O','403503',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135689,503,'Nanorem B.O','403506',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135690,503,'Navelim B.O','403505',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135691,503,'Nerul B.O','403114',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135692,503,'Neura S.O','403104',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135693,503,'Nio Dona Paula S.O','403004',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135694,503,'Onda B.O','403530',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135695,503,'Onda I.E. S.O','403530',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135696,503,'Oxel B.O','403517',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135697,503,'Ozari B.O','403513',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135698,503,'Pale S.O','403105',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135699,503,'Panaji H.O','403001',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135700,503,'Parra S.O','403510',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135701,503,'Parxem B.O','403512',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135702,503,'Penha De France B.O','403101',1,0,'2022-03-04 19:30:05','2022-03-04 19:30:05'),(135703,503,'Pernem S.O','403512',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135704,503,'Piedade S.O','403403',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135705,503,'Pilar S.O (North Goa)','403203',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135706,503,'Pilerne B.O','403114',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135707,503,'Pilgao B.O','403504',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135708,503,'Pillem B.O','403406',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135709,503,'Pirna B.O','403513',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135710,503,'Pissurlem B.O','403530',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135711,503,'Pomburpa B.O','403523',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135712,503,'Ponda S.O','403401',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135713,503,'Poriem B.O','403505',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135714,503,'Poroscodem B.O','403512',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135715,503,'Porvorim S.O','403501',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135716,503,'Pratapnagar Harvale B.O','403505',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135717,503,'Querim B.O','403524',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135718,503,'Qurinpani B.O','403524',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135719,503,'Reis Magos S.O','403114',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135720,503,'Revora B.O','403513',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135721,503,'Ribandar S.O','403006',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135722,503,'Saipem B.O','403515',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135723,503,'Salem B.O','403503',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135724,503,'Saligao S.O','403511',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135725,503,'Salvador De Mond B.O','403101',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135726,503,'Sancordem B.O','403406',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135727,503,'Sangolda B.O','403511',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135728,503,'Sanquelim S.O','403505',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135729,503,'Santa Cruz S.O','403005',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135730,503,'Sanvordem B.O','403506',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135731,503,'Secretariat S.O (North Goa)','403521',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135732,503,'Sem Saligao B.O','403511',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135733,503,'Shiroda S.O (North Goa)','403103',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135734,503,'Sinquerim S.O','403515',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135735,503,'Siolim S.O','403517',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135736,503,'Sirgao B.O','403503',1,0,'2022-03-04 19:30:06','2022-03-04 19:30:06'),(135737,503,'Siridao B.O','403108',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135738,503,'Sirsaim B.O','403502',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135739,503,'St Inez S.O','403001',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135740,503,'St. Lourence S.O','403204',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135741,503,'Surla B.O','403505',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135742,503,'Tamboxem B.O','403512',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135743,503,'Tarvalem B.O','403103',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135744,503,'Thana B.O','403506',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135745,503,'Tivim Ie S.O','403526',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135746,503,'Tivim S.O','403502',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135747,503,'Torxem B.O','403512',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135748,503,'Tuem B.O','403512',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135749,503,'Tuem I E B.O','403512',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135750,503,'Ucassiam B.O','403507',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135751,503,'Usgao B.O','403406',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135752,503,'Valpoi S.O','403506',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135753,503,'Varconda B.O','403512',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135754,503,'Velguem O B.O','403506',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135755,503,'Velha-goa S.O','403402',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135756,503,'Virnora B.O','403512',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135757,504,'A.P.Dabolim S.O','403801',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135758,504,'A.P.Terminal S.O','403801',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135759,504,'Agapur Adpoi B.O','403401',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135760,504,'Agonda B.O','403702',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135761,504,'Ambaulim B.O','403705',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135762,504,'Ambelim B.O','403723',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135763,504,'Amona B.O','403107',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135764,504,'Aquem S.O','403601',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135765,504,'Assolda B.O','403714',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135766,504,'Assolna S.O','403701',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135767,504,'Avedem B.O','403705',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135768,504,'Baina S.O','403802',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135769,504,'Balli B.O','403703',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135770,504,'Banastrim B.O','403107',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135771,504,'Bandora B.O','403401',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135772,504,'Barcem B.O','403703',1,0,'2022-03-04 19:30:07','2022-03-04 19:30:07'),(135773,504,'Bati B.O','403704',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135774,504,'Benaulim S.O','403716',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135775,504,'Betalbhatim B.O','403713',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135776,504,'Betora B.O','403401',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135777,504,'Betora I.E. S.O','403409',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135778,504,'Betul B.O','403723',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135779,504,'Bhatpal B.O','403702',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135780,504,'Bogmalo S.O','403806',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135781,504,'Borim B.O','403401',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135782,504,'Cacora B.O','403706',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135783,504,'Calem B.O','403704',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135784,504,'Camurlim B.O','403718',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135785,504,'Canacona S.O','403702',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135786,504,'Cananguinim B.O','403703',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135787,504,'Cansaulim S.O','403712',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135788,504,'Carmona S.O','403717',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135789,504,'Cavelossim S.O','403731',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135790,504,'Cavorim B.O','403714',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135791,504,'Chandor S.O','403714',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135792,504,'Chicalim S.O','403711',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135793,504,'Chinchinim S.O','403715',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135794,504,'Cola B.O','403702',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135795,504,'Collem S.O','403410',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135796,504,'Colva S.O','403708',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135797,504,'Cortalim S.O','403710',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135798,504,'Cotigaon B.O','403702',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135799,504,'Cuncolim S.O','403703',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135800,504,'Cundaim I.E. S.O','403115',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135801,504,'Cundiam B.O','403115',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135802,504,'Curchorem S.O','403706',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135803,504,'Curdi B.O','403704',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135804,504,'Curti B.O','403401',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135805,504,'Curtorim S.O','403709',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135806,504,'Davorlim B.O','403707',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135807,504,'Dramapur S.O','403725',1,0,'2022-03-04 19:30:08','2022-03-04 19:30:08'),(135808,504,'Durbhat B.O','403401',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135809,504,'Farmagudi B.O','403401',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135810,504,'Fatorda S.O','403602',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135811,504,'Fatorpa B.O','403703',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135812,504,'Gandhi Market Complex Margao S.O','403601',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135813,504,'Gaodongarim B.O','403702',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135814,504,'Gogol S.O','403601',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135815,504,'Loliem Polem B.O','403728',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135816,504,'Loliem S.O','403728',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135817,504,'Loutolim S.O','403718',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135818,504,'Macazana B.O','403709',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135819,504,'Majorda S.O','403713',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135820,504,'Mangor Hill B.O','403802',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135821,504,'Marcela S.O','403107',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135822,504,'Mardol S.O','403404',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135823,504,'Margao H.O','403601',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135824,504,'Molcarnem B.O','403704',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135825,504,'Mollem B.O','403410',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135826,504,'Mormugao S.O','403803',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135827,504,'Morpirla B.O','403703',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135828,504,'Navelim Camp S.O','403729',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135829,504,'Navelim S.O','403707',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135830,504,'Netorlim B.O','403704',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135831,504,'Nirankal B.O','403401',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135832,504,'Nuvem B.O','403601',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135833,504,'ONGC Ipsem Betul B.O','403723',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135834,504,'Orlim S.O','403724',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135835,504,'Palolem B.O','403702',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135836,504,'Panchwadi B.O','403706',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135837,504,'Pirla B.O','403705',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135838,504,'Poinguinim B.O','403702',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135839,504,'Ponda Camp S.O','403401',1,0,'2022-03-04 19:30:09','2022-03-04 19:30:09'),(135840,504,'Priol B.O','403404',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135841,504,'Quela B.O','403401',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135842,504,'Quepem S.O','403705',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135843,504,'Querim B.O','403401',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135844,504,'Quirlapale B.O','403706',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135845,504,'Raia S.O','403720',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135846,504,'Rivona B.O','403705',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135847,504,'Sada S.O','403804',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135848,504,'Sadolxem B.O','403702',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135849,504,'Sancoale B.O','403710',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135850,504,'Sanguem S.O','403704',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135851,504,'Sant Estevam S.O','403106',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135852,504,'Sem-rachol  Soso S.O','403719',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135853,504,'Seraulim B.O','403708',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135854,504,'Sigao B.O','403410',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135855,504,'Sirvoi B.O','403705',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135856,504,'St. Jose De Areal S.O','403709',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135857,504,'Talaulim B.O','403707',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135858,504,'Thana B.O','403710',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135859,504,'Tisca S.O','403406',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135860,504,'Ugvem B.O','403704',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135861,504,'Utorda B.O','403713',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135862,504,'Vaddem S.O','403802',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135863,504,'Vademnagar S.O','403802',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135864,504,'Valkini B.O','403704',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135865,504,'Vanelim B.O','403708',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135866,504,'Varca S.O','403721',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135867,504,'Vasco-Da-Gama S.O','403802',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135868,504,'Velguem B.O','403105',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135869,504,'Velim S.O','403723',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135870,504,'Verem De Ponda B.O','403401',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135871,504,'Verna S.O','403722',1,0,'2022-03-04 19:30:10','2022-03-04 19:30:10'),(135872,504,'Veroda B.O','403703',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135873,504,'Xeldem B.O','403705',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135874,504,'Xelvona B.O','403706',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135875,504,'Zuarinagar S.O','403726',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135876,505,'Awangjiri B.O','795134',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135877,505,'Bishnupur S.O (Bishnupur)','795126',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135878,505,'Boroyangbi B.O','795133',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135879,505,'Bunglon B.O','795133',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135880,505,'Bungte Chiru B.O','795134',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135881,505,'Charoi Khullel B.O','795124',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135882,505,'Dolang B.O','795126',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135883,505,'Dolang B.O','795118',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135884,505,'Dolang Khunou B.O','795126',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135885,505,'Dopkon B.O','795133',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135886,505,'Ethai Bazar B.O','795133',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135887,505,'Gelmol B.O','795133',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135888,505,'Haotak Khullen B.O','795126',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135889,505,'Haotakphailen B.O','795133',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135890,505,'Heikrujam B.O','795134',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135891,505,'Irengbam B.O','795134',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135892,505,'Isok B.O','795134',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135893,505,'Jiban Nager B.O','795124',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135894,505,'Kabowakching B.O','795134',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135895,505,'Kamong B.O','795134',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135896,505,'Kangathei B.O','795133',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135897,505,'Keinou B.O','795134',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135898,505,'Khabi B.O','795134',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135899,505,'Khathinunggei B.O','795133',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135900,505,'Khoijuman B.O','795126',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135901,505,'Khoirentak B.O','795133',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135902,505,'Khongbung B.O','795126',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135903,505,'Khordak Ichin B.O','795133',1,0,'2022-03-04 19:30:11','2022-03-04 19:30:11'),(135904,505,'Khousabung B.O','795133',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135905,505,'Khunpi Naosem B.O','795126',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135906,505,'Kumbi (P) B.O','795133',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135907,505,'Kwakta B.O','795133',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135908,505,'Lamdangmei B.O','795126',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135909,505,'Langpok B.O','795134',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135910,505,'Leimapokpam B.O','795134',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135911,505,'Leimatak B.O','795124',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135912,505,'Leimram B.O','795134',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135913,505,'Loktak Project S.O','795124',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135914,505,'Maibam B.O','795134',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135915,505,'Manamayang B.O','795134',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135916,505,'Mayuran B.O','795124',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135917,505,'Moirang S.O','795133',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135918,505,'Molphei Tampak B.O','795133',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135919,505,'Nabil (P) B.O','795133',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135920,505,'Nambol S.O','795134',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135921,505,'Naorem B.O','795134',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135922,505,'Naransena B.O','795133',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135923,505,'Ngaikhong Khullen B.O','795126',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135924,505,'Ngangkha Lawi B.O','795133',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135925,505,'Ngarian B.O','795126',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135926,505,'Ningthoukhong B.O','795126',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135927,505,'Nungsai Chiru B.O','795126',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135928,505,'Nungthangtampak B.O','795133',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135929,505,'Oinam B.O','795134',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135930,505,'Phousabung B.O','795133',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135931,505,'Phubala B.O','795126',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135932,505,'Potsangbam B.O','795126',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135933,505,'Pukhrambam B.O','795134',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135934,505,'Sadukhoiroi B.O','795124',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135935,505,'Sagang B.O','795133',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135936,505,'Saiton B.O','795133',1,0,'2022-03-04 19:30:12','2022-03-04 19:30:12'),(135937,505,'Terakhongshangbi B.O','795133',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135938,505,'Thanga Karang B.O','795133',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135939,505,'Thanga(P) B.O','795133',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135940,505,'Thangal B.O','795126',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135941,505,'Tharoi Bomdiar B.O','795134',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135942,505,'Thinkai Khullen B.O','795134',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135943,505,'Thinungei B.O','795126',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135944,505,'Thumkhonglok B.O','795133',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135945,505,'Tokpalamdan B.O','795124',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135946,505,'Torbung B.O','795133',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135947,505,'Toubul B.O','795126',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135948,505,'Tronglaobi B.O','795133',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135949,505,'Tuisangthei B.O','795133',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135950,505,'Utlou B.O','795134',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135951,505,'Wangoo B.O','795133',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135952,505,'Wangoo Tera B.O','795133',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135953,505,'Zouzangtek B.O','795126',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135954,506,'Aigejang B.O','795102',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135955,506,'Anal Khullen B.O','795102',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135956,506,'Bongajang B.O','795131',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135957,506,'Bongjoi B.O','795131',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135958,506,'Chakpikarong S.O','795102',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135959,506,'Chandel S.O','795127',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135960,506,'Chenpal B.O','795131',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135961,506,'Duthang B.O','795127',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135962,506,'Gamphajal B.O','795131',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135963,506,'Gobok B.O','795102',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135964,506,'Khengjoi B.O','795102',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135965,506,'Khubungh Khullen B.O','795102',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135966,506,'Khudengthabi B.O','795131',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135967,506,'Larong B.O','795127',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135968,506,'Liwasari B.O','795127',1,0,'2022-03-04 19:30:13','2022-03-04 19:30:13'),(135969,506,'Maojam B.O','795131',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135970,506,'Mittong B.O','795127',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135971,506,'Molchamedbo B.O','795131',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135972,506,'Monbi B.O','795102',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135973,506,'Moreh S.O','795131',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135974,506,'New Somtal B.O','795131',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135975,506,'Pallel S.O','795135',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135976,506,'Phiran Machet B.O','795102',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135977,506,'Sajik Tampak B.O','795102',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135978,506,'Sehao B.O','795102',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135979,506,'Semol B.O','795102',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135980,506,'Sugnu S.O','795101',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135981,506,'T- Bongmun B.O','795131',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135982,506,'Tengnoupal B.O','795131',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135983,506,'Thorchom B.O','795102',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135984,506,'T-minou B.O','795131',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135985,506,'Toupokpi B.O','795102',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135986,506,'Yangoulen B.O','795131',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135987,506,'Zoupi B.O','795102',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135988,507,'Aibulon B.O','795143',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135989,507,'Aina B.O','795128',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135990,507,'Behiang B.O','795139',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135991,507,'Bukpi B.O','795143',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135992,507,'Bungmual B.O','795128',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135993,507,'Bungpilon B.O','795143',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135994,507,'Chehjang B.O','795128',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135995,507,'Chingkonpang S.O','795128',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135996,507,'Chothemunpi B.O','795128',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135997,507,'Churachandpur S.O','795128',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135998,507,'Geljaing B.O','795128',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(135999,507,'Hamkeilon B.O','795128',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(136000,507,'Hanship B.O','795143',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(136001,507,'Henglep B.O','795128',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(136002,507,'Hengtam B.O','795139',1,0,'2022-03-04 19:30:14','2022-03-04 19:30:14'),(136003,507,'Kangkap B.O','795139',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136004,507,'Kangvai Bazar B.O','795128',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136005,507,'Khajang B.O','795143',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136006,507,'Khanpi B.O','795128',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136007,507,'Khouwpuibung B.O','795117',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136008,507,'Kolhen B.O','795128',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136009,507,'Kumbipukhri B.O','795128',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136010,507,'Kwanpui B.O','795128',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136011,507,'Lailong B.O','795128',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136012,507,'Lama Camp B.O','795139',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136013,507,'Leijangphai B.O','795143',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136014,507,'Leison B.O','795143',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136015,507,'Lingshiphai B.O','795128',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136016,507,'Lungchin B.O','795139',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136017,507,'Lungsai B.O','795128',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136018,507,'Lungshung B.O','795128',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136019,507,'Lungthul B.O','795139',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136020,507,'Millongmun B.O','795143',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136021,507,'Mission Compound B.O','795128',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136022,507,'Mual Vaiphei B.O','795117',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136023,507,'Mualkoi B.O','795128',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136024,507,'Mualmun B.O','795139',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136025,507,'Munpi B.O','795128',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136026,507,'New Lamka S.O','795006',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136027,507,'Panglian B.O','795128',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136028,507,'Parbung B.O','795143',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136029,507,'Pearsonmun B.O','795128',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136030,507,'Phaijang B.O','795143',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136031,507,'Phaipheng B.O','795128',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136032,507,'Pherazol B.O','795143',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136033,507,'Pmzol B.O','795143',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136034,507,'Saiden B.O','795128',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136035,507,'Saikhul Village B.O','795128',1,0,'2022-03-04 19:30:15','2022-03-04 19:30:15'),(136036,507,'Saikot S.O','795117',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136037,507,'Saikul S.O','795118',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136038,507,'Sangphou B.O','795128',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136039,507,'Santing B.O','795128',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136040,507,'Sawaiphaih (T/C/D) B.O','795143',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136041,507,'Semon B.O','795143',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136042,507,'Siabu B.O','795139',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136043,507,'Sielmet B.O','795128',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136044,507,'Singhat S.O','795139',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136045,507,'Singjawl B.O','795143',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136046,507,'Songdoh B.O','795139',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136047,507,'Songtal B.O','795139',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136048,507,'South Kotlein B.O','795128',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136049,507,'Taithu B.O','795143',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136050,507,'Takvam B.O','795128',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136051,507,'Teiyong B.O','795128',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136052,507,'Thangshi B.O','795128',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136053,507,'Thanlon S.O','795143',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136054,507,'Thinkew B.O','795128',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136055,507,'Tingsong B.O','795143',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136056,507,'Tipaimukh (P) B.O','795143',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136057,507,'Tollen B.O','795128',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136058,507,'Tolphei B.O','795128',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136059,507,'Tuabung B.O','795143',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136060,507,'Tuikham B.O','795117',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136061,507,'Tuining B.O','795117',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136062,507,'Tuinom B.O','795128',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136063,507,'Tuitengphai B.O','795117',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136064,507,'Tulaphei B.O','795128',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136065,507,'Ukha B.O','795128',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136066,507,'Vokbual B.O','795139',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136067,508,'Awang Konmgpal B.O','795005',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136068,508,'Chingmang B.O','795010',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136069,508,'Dolaithabi B.O','795114',1,0,'2022-03-04 19:30:16','2022-03-04 19:30:16'),(136070,508,'Haraorou B.O','795114',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136071,508,'Heinoumakhong B.O','795010',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136072,508,'Huidrom B.O','795010',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136073,508,'Irilbung B.O','795008',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136074,508,'Kairang Litan Makhong B.O','795114',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136075,508,'Kameng Kakching B.O','795010',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136076,508,'Keirao Bitra Salam B.O','795008',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136077,508,'Keirao Makting B.O','795008',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136078,508,'Keirao Wangkhem B.O','795008',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136079,508,'Khongangpheidekpi B.O','795008',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136080,508,'Khongbal Tangkhul B.O','795114',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136081,508,'Khumidok (P) B.O','795114',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136082,508,'Khurai Khongnang Makhong B.O','795005',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136083,508,'Kitnapanung B.O','795008',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136084,508,'Kongba Bazar B.O','795008',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136085,508,'Kshetribangoon B.O','795008',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136086,508,'Kshetrigao B.O','795008',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136087,508,'Laikoiching B.O','795010',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136088,508,'Laiphrak Maring B.O','795008',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136089,508,'Lamlai B.O','795010',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136090,508,'Lamlong S.O','795010',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136091,508,'Latingkhal B.O','795116',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136092,508,'Liklikhong Bazar B.O','795114',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136093,508,'Manipur University S.O','795003',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136094,508,'Mapao Keithelmanbi B.O','795114',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136095,508,'Moirang Kampu B.O','795005',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136096,508,'Moirang Purel B.O','795010',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136097,508,'Mongkhang Lambi B.O','795008',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136098,508,'Ningthemchakhul B.O','795010',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136099,508,'Nongdam Tangkhul B.O','795010',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136100,508,'Nongoda B.O','795010',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136101,508,'Oinam Thingel B.O','795008',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136102,508,'Phaknung B.O','795010',1,0,'2022-03-04 19:30:17','2022-03-04 19:30:17'),(136103,508,'Pngaei Yangdong S.O','795114',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136104,508,'Porompat S.O','795005',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136105,508,'Pukhao Ahallup B.O','795114',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136106,508,'Sagolmang B.O','795114',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136107,508,'Satang B.O','795114',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136108,508,'Sawombung B.O','795010',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136109,508,'Sekmai S.O','795136',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136110,508,'Singjamei S.O','795008',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136111,508,'Takhel B.O','795005',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136112,508,'Tangkhul Hungdung B.O','795010',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136113,508,'Taretkhul B.O','795010',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136114,508,'Thangal Surung B.O','795114',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136115,508,'Tulihal S.O','795140',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136116,508,'Uchekon B.O','795008',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136117,508,'Uyumpok B.O','795114',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136118,508,'Waiton B.O','795114',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136119,508,'Wakhen Phai B.O','795114',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136120,508,'Yourbung B.O','795010',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136121,508,'Yumnam Khunou B.O','795114',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136122,509,'Ahallup B.O','795002',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136123,509,'Arong B.O','795132',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136124,509,'Awang Leikinthabi B.O','795136',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136125,509,'Awangpotshangbam B.O','795002',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136126,509,'Bengoon Maning Leikai B.O','795132',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136127,509,'Bidyanagar B.O','795115',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136128,509,'Bitrarakhong B.O','795009',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136129,509,'Bongmun B.O','795116',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136130,509,'Borobekra B.O','795116',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136131,509,'BR Colony B.O','795115',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136132,509,'Canchipur (T/C/D) B.O','795003',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136133,509,'Central Agriculture University B.O','795004',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136134,509,'Ch. Khongnangpokpi B.O','795136',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136135,509,'Chabung Company B.O','795132',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136136,509,'Champanagar B.O','795116',1,0,'2022-03-04 19:30:18','2022-03-04 19:30:18'),(136137,509,'Chingmun B.O','795116',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136138,509,'Chirai Muslim B.O','795132',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136139,509,'Christan Centre Haochong B.O','795146',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136140,509,'CRPF Camp Langjing S.O','795113',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136141,509,'D.M College S.O','795001',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136142,509,'Gularthol S.O','795115',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136143,509,'Haorang Kairel B.O','795113',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136144,509,'Haoreibi B.O','795009',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136145,509,'Heibong Makhong B.O','795132',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136146,509,'Heibongpokpi B.O','795146',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136147,509,'Heingang B.O','795002',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136148,509,'Hiyangthang B.O','795009',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136149,509,'Ijairong B.O','795146',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136150,509,'Imphal Bazar S.O','795001',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136151,509,'Imphal H.O','795001',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136152,509,'Irengnaga B.O','795146',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136153,509,'Iroisemaba B.O','795004',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136154,509,'Irom Meijrao B.O','795009',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136155,509,'Irong Chessabal B.O','795132',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136156,509,'Irong Umang Khunou B.O','795132',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136157,509,'Jakurdhar B.O','795116',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136158,509,'Jiribam Bazar S.O','795116',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136159,509,'Kangchup Chiru B.O','795146',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136160,509,'Kangchup Hill (P) B.O','795146',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136161,509,'Kangchup Makhong B.O','795146',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136162,509,'Kanglatongbi B.O','795136',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136163,509,'Karakhul B.O','795002',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136164,509,'Karam Vaiphei B.O','795146',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136165,509,'Kashimpur B.O','795115',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136166,509,'Keimai B.O','795115',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136167,509,'Kh Jaikhan B.O','795116',1,0,'2022-03-04 19:30:19','2022-03-04 19:30:19'),(136168,509,'Khamnam Bazar B.O','795113',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136169,509,'Khangakhul B.O','795113',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136170,509,'Khelakhong B.O','795132',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136171,509,'Khonghampat B.O','795002',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136172,509,'Khoyathong B.O','795001',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136173,509,'Khumbong Bazar B.O','795113',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136174,509,'Khundong Khukhaiba B.O','795146',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136175,509,'Khurukhul B.O','795002',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136176,509,'Kodompokpi B.O','795009',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136177,509,'Komlakhong B.O','795132',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136178,509,'Konthakhabam B.O','795002',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136179,509,'Konthoujam B.O','795113',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136180,509,'Kunja (P) B.O','795003',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136181,509,'Kyamgei B.O','795003',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136182,509,'Laiphrakom B.O','795140',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136183,509,'Lairen Sajik B.O','795146',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136184,509,'Lalkhai B.O','795116',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136185,509,'Lamboi Khongnagkhong B.O','795004',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136186,509,'Lamdeng B.O','795146',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136187,509,'Lamphelpat S.O','795004',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136188,509,'Lamsang S.O','795146',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136189,509,'Langjing Achouba B.O','795113',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136190,509,'Langol Housing Complex B.O','795004',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136191,509,'Langthabal B.O','795003',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136192,509,'Laphupat B.O','795132',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136193,509,'Loitang Leikinthabi B.O','795002',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136194,509,'Longa Koireng B.O','795113',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136195,509,'Longpi B.O','795116',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136196,509,'Loukok Mayai Leikai B.O','795132',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136197,509,'Luwangsangbam B.O','795002',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136198,509,'Luwangsangol B.O','795136',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136199,509,'Maibam Konjil B.O','795132',1,0,'2022-03-04 19:30:20','2022-03-04 19:30:20'),(136200,509,'Makhan B.O','795136',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136201,509,'Maklang Bazar B.O','795113',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136202,509,'Manipur High Court S.O','795001',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136203,509,'Mantripukhri S.O','795002',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136204,509,'Mayang Impahl Bengoon B.O','795132',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136205,509,'Mayang Langjing B.O','795146',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136206,509,'Mongsangei B.O','795003',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136207,509,'Mutum Phibou B.O','795132',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136208,509,'Natok Kabui B.O','795113',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136209,509,'New Keiphundai B.O','795115',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136210,509,'New Keithelmanbi B.O','795113',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136211,509,'Ngairangbam B.O','795113',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136212,509,'Ngaphabung B.O','795116',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136213,509,'Ningombam B.O','795003',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136214,509,'Noremthong Bazar B.O','795004',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136215,509,'Oktan B.O','795146',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136216,509,'Paobitek B.O','795009',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136217,509,'Patpuimun B.O','795116',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136218,509,'Patsoi Part II B.O','795113',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136219,509,'Phaibok Mullen B.O','795116',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136220,509,'Phayeng B.O','795146',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136221,509,'Phoubakchao B.O','795132',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136222,509,'Ponlian B.O','795146',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136223,509,'Potsangbam Khoirou B.O','795136',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136224,509,'Sagolband Thingom Leikai B.O','795004',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136225,509,'Sagoltongba Bazar B.O','795113',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136226,509,'Samurou B.O','795009',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136227,509,'Sangaiprou B.O','795140',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136228,509,'Santhel B.O','795132',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136229,509,'Sayang Kuraomakhong B.O','795004',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136230,509,'Sekmaijin  Khunou Konuma B.O','795132',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136231,509,'Sekmaijin B.O','795132',1,0,'2022-03-04 19:30:21','2022-03-04 19:30:21'),(136232,509,'Sekmaijin Khunou Litan Makhong B.O','795132',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136233,509,'Soibam Leikai B.O','795001',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136234,509,'Sonapur B.O','795116',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136235,509,'Suangpuimun B.O','795116',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136236,509,'Tairenpokpi B.O','795113',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136237,509,'Takyel Khongbal B.O','795113',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136238,509,'Tendongyang (P) B.O','795002',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136239,509,'Tera Bazar B.O','795004',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136240,509,'Tera Khoidum Mayai Leikai B.O','795132',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136241,509,'Tharoijam B.O','795113',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136242,509,'Tuitengmun B.O','795116',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136243,509,'Uchiwa B.O','795132',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136244,509,'Uchiwa Wangban B.O','795132',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136245,509,'Wangoi S.O','795009',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136246,509,'Yarrow Meitram B.O','795140',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136247,509,'Yumnam Khunou B.O','795009',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136248,509,'Yurembam B.O','795113',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136249,510,'Bunglong B.O','795118',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136250,510,'Chalwa (P) B.O','795112',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136251,510,'Chandraman B.O','795122',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136252,510,'Chawanamei B.O','795104',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136253,510,'Cheljang B.O','795112',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136254,510,'Chingai Khullen B.O','795104',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136255,510,'Galam B.O','795118',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136256,510,'Ganel B.O','795112',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136257,510,'Gangpijang B.O','795118',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136258,510,'Haipi B.O','795122',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136259,510,'Hengbung B.O','795129',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136260,510,'Ichaigojang B.O','795118',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136261,510,'Irang B.O','795112',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136262,510,'J Phaijang B.O','795107',1,0,'2022-03-04 19:30:22','2022-03-04 19:30:22'),(136263,510,'Jangnoi B.O','795118',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136264,510,'Kaibi B.O','795104',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136265,510,'Kalapahar S.O','795122',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136266,510,'Kangpokpi Mission B.O','795129',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136267,510,'Kangpokpi S.O','795129',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136268,510,'Karong S.O','795007',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136269,510,'Keithelmanbi B.O','795122',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136270,510,'Kheijang B.O','795122',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136271,510,'Koide B.O','795015',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136272,510,'Kolhen B.O','795112',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136273,510,'Laii B.O','795104',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136274,510,'Lairouching B.O','795007',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136275,510,'Lakhamei B.O','795015',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136276,510,'Liyai B.O','795104',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136277,510,'Liyal Khunou B.O','795104',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136278,510,'Maiba B.O','795015',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136279,510,'Makeng Ngarolu B.O','795118',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136280,510,'Makhan Bazar B.O','795015',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136281,510,'Makokchung B.O','795118',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136282,510,'Mao S.O','795150',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136283,510,'Maohiing B.O','795129',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136284,510,'Maohing B.O','795129',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136285,510,'Maram S.O','795015',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136286,510,'Molkon B.O','795118',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136287,510,'Motbung S.O','795107',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136288,510,'Mutukhong B.O','795118',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136289,510,'N. Khenjang B.O','795107',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136290,510,'Nurathel B.O','795107',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136291,510,'Oinam B.O','795007',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136292,510,'Oklong B.O','795106',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136293,510,'Pangjang B.O','795118',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136294,510,'Paomata Centre B.O','795104',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136295,510,'Persian B.O','795122',1,0,'2022-03-04 19:30:23','2022-03-04 19:30:23'),(136296,510,'Pfukhro B.O','795150',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136297,510,'Phaibung Khullen B.O','795104',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136298,510,'Phaikon B.O','795118',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136299,510,'Phuba B.O','795015',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136300,510,'Phunanamei B.O','795150',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136301,510,'Pudunamei B.O','795150',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136302,510,'Purul B.O','795015',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136303,510,'Rajamei B.O','795007',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136304,510,'S.Bolkot B.O','795107',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136305,510,'Saitu B.O','795107',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136306,510,'Sangpei Khullen B.O','795118',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136307,510,'Sapermeina B.O','795107',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136308,510,'Saranamei B.O','795104',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136309,510,'Senapati S.O','795106',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136310,510,'Siraffi B.O','795104',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136311,510,'T Waichong S.O','795112',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136312,510,'T. Awkhumbung B.O','795118',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136313,510,'Tadubi S.O','795104',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136314,510,'Tamei S.O','795125',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136315,510,'Taphou B.O','795129',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136316,510,'Thanamba B.O','795122',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136317,510,'Thengjang B.O','795112',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136318,510,'Thingba Khullen B.O','795007',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136319,510,'Thingba Khunou B.O','795007',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136320,510,'Thingsat B.O','795107',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136321,510,'Thonglang B.O','795129',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136322,510,'Tingpibung B.O','795118',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136323,510,'Tokpa B.O','795122',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136324,510,'Toribari B.O','795129',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136325,510,'Tumuyan Khullen B.O','795106',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136326,510,'Tungjoy B.O','795104',1,0,'2022-03-04 19:30:24','2022-03-04 19:30:24'),(136327,510,'Willang B.O','795007',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136328,510,'Yangkhullen B.O','795007',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136329,510,'Zelengphai B.O','795118',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136330,511,'Akhui B.O','795141',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136331,511,'Atang Khunou B.O','795125',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136332,511,'Atengba B.O','795141',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136333,511,'Awangkhul B.O','795159',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136334,511,'Bhalok B.O','795141',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136335,511,'Bongoijang B.O','795141',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136336,511,'Chaiton B.O','795125',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136337,511,'Charoi Tupul B.O','795159',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136338,511,'Chongmun B.O','795147',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136339,511,'Dailong B.O','795141',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136340,511,'Dullen (T/C/D) B.O','795125',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136341,511,'Haochong B.O','795159',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136342,511,'Illong B.O','795125',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136343,511,'Jampii (T/C/D) B.O','795125',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136344,511,'Kadi B.O','795125',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136345,511,'Kahulong B.O','795141',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136346,511,'Kambiron B.O','795147',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136347,511,'Kasanlong B.O','795125',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136348,511,'Keikao B.O','795141',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136349,511,'Khongjaron B.O','795141',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136350,511,'Khongjaron Khunthak B.O','795141',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136351,511,'Khongsang B.O','795159',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136352,511,'Khoupum B.O','795147',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136353,511,'Khumphung B.O','795125',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136354,511,'Kuilong B.O','795125',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136355,511,'Lemta B.O','795125',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136356,511,'Lenglong B.O','795125',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136357,511,'Longpram B.O','795141',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136358,511,'Lukhambi B.O','795159',1,0,'2022-03-04 19:30:25','2022-03-04 19:30:25'),(136359,511,'Magulong B.O','795125',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136360,511,'Mukti Khullen B.O','795147',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136361,511,'Nagaching B.O','795159',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136362,511,'Namtiram B.O','795141',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136363,511,'New Kabui Khullen B.O','795159',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136364,511,'New Lambala B.O','795125',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136365,511,'New Pallong B.O','795141',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136366,511,'None S.O','795159',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136367,511,'Nungba S.O','795147',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136368,511,'Nungnang B.O','795147',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136369,511,'Nungtek B.O','795159',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136370,511,'Rengpang B.O','795147',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136371,511,'Sibilong B.O','795147',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136372,511,'Songpram B.O','795141',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136373,511,'Takou B.O','795125',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136374,511,'Tamenglong Khunjao B.O','795141',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136375,511,'Tamenglong S.O','795141',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136376,511,'Tharon B.O','795141',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136377,511,'Thingra B.O','795159',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136378,511,'Thuilon B.O','795141',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136379,511,'Tousem B.O','795141',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136380,511,'Upper Selsi (T/c/d) B.O','795125',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136381,511,'Wairengba B.O','795141',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136382,512,'Aimol Kodamphai B.O','795135',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136383,512,'Andro B.O','795149',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136384,512,'Angbrashu B.O','795135',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136385,512,'Angtha B.O','795149',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136386,512,'Arapyi B.O','795130',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136387,512,'Arong Nongmaikhong B.O','795103',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136388,512,'Athokpam B.O','795138',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136389,512,'Athokpam Khunou B.O','795138',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136390,512,'Bongbal Khullen B.O','795149',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136391,512,'Bongli B.O','795135',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136392,512,'Chairen B.O','795101',1,0,'2022-03-04 19:30:26','2022-03-04 19:30:26'),(136393,512,'Chajing Pt II B.O','795130',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136394,512,'Changamdabi B.O','795149',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136395,512,'Charangpat B.O','795138',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136396,512,'Chaton B.O','795135',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136397,512,'Chelhep B.O','795135',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136398,512,'Cherapur B.O','795148',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136399,512,'Elangkhangpokpi B.O','795103',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136400,512,'Haokha B.O','795138',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136401,512,'Haokhongching B.O','795149',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136402,512,'Haoreibi Mayai Leikai B.O','795130',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136403,512,'Heinganglok B.O','795149',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136404,512,'Heinoumakhong B.O','795130',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136405,512,'Heirok Part 2 B.O','795148',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136406,512,'Herok Part 1 B.O','795148',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136407,512,'Hivanalam B.O','795103',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136408,512,'Hulkap B.O','795149',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136409,512,'Irong Tangkhul B.O','795149',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136410,512,'Irong Thokchom (T/C/D) B.O','795138',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136411,512,'Jul Bangching B.O','795101',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136412,512,'K M College B.O','795103',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136413,512,'K. Molnam B.O','795101',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136414,512,'Kakching Khunou B.O','795103',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136415,512,'Kakching S.O','795103',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136416,512,'Kalikalok B.O','795103',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136417,512,'Kambang Khunou B.O','795135',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136418,512,'Kamu Tampak B.O','795149',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136419,512,'Kamu Tongam B.O','795149',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136420,512,'Kamuching B.O','795149',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136421,512,'Karongthel B.O','795148',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136422,512,'Kasom Khullen B.O','795149',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136423,512,'Keibung Mamang B.O','795138',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136424,512,'Keirak B.O','795103',1,0,'2022-03-04 19:30:27','2022-03-04 19:30:27'),(136425,512,'Khambathel B.O','795101',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136426,512,'Khangabok B.O','795138',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136427,512,'Khangbaram B.O','795135',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136428,512,'Kharou Khullen B.O','795135',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136429,512,'Khekmanedbo B.O','795138',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136430,512,'Khoibu B.O','795135',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136431,512,'Khoirom B.O','795149',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136432,512,'Khongjom B.O','795148',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136433,512,'Khonglou Vaiphei (T/C/D) B.O','795149',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136434,512,'Khongnangpheisani B.O','795101',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136435,512,'Khousat (T/C/D) B.O','795135',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136436,512,'Khudei Khunou B.O','795103',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136437,512,'Khudei Khunou B.O','795135',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136438,512,'Khunbi B.O','795135',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136439,512,'Kiyam Shiphai B.O','795138',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136440,512,'Kshetri Leikai B.O','795138',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136441,512,'Laiching Khongsang B.O','795135',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136442,512,'Lairabokhong B.O','795130',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136443,512,'Lamkang Khunou B.O','795135',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136444,512,'Lamlong Khullen B.O','795135',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136445,512,'Lamlong Khunou B.O','795135',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136446,512,'Langmeidon B.O','795103',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136447,512,'Leibi B.O','795135',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136448,512,'Leingangching B.O','795103',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136449,512,'Lembakhul B.O','795138',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136450,512,'Lilong S.O','795130',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136451,512,'Liwachangning B.O','795135',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136452,512,'Longja B.O','795101',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136453,512,'Louremba B.O','795149',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136454,512,'Lungthar B.O','795149',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136455,512,'M Bongmol B.O','795101',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136456,512,'Machi B.O','795135',1,0,'2022-03-04 19:30:28','2022-03-04 19:30:28'),(136457,512,'Mahou Tera B.O','795101',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136458,512,'Mairembam B.O','795103',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136459,512,'Mantak B.O','795103',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136460,512,'Mayang Imphal S.O','795132',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136461,512,'Minou Khunjao B.O','795135',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136462,512,'Moijing B.O','795138',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136463,512,'Molhang B.O','795135',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136464,512,'Mollen (T/C/D) B.O','795149',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136465,512,'Moltek B.O','795135',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136466,512,'Nambasi B.O','795149',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136467,512,'Narum B.O','795135',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136468,512,'Nodoom Bazar B.O','795103',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136469,512,'Nongpok Sekmai B.O','795149',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136470,512,'Nungei B.O','795130',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136471,512,'Okram Wangmataba B.O','795138',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136472,512,'Pangaltabi B.O','795103',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136473,512,'Phoudel B.O','795138',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136474,512,'Phouoibi B.O','795149',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136475,512,'Phunalmaring B.O','795130',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136476,512,'Phundrei B.O','795148',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136477,512,'Poirou Khongjil B.O','795138',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136478,512,'Puleilokpi B.O','795148',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136479,512,'Purum Pantha B.O','795103',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136480,512,'Sabaltongba B.O','795138',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136481,512,'Saibhom B.O','795135',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136482,512,'Salungpham B.O','795148',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136483,512,'Samaram B.O','795148',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136484,512,'Sangaikot B.O','795101',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136485,512,'Sangaiyumpham B.O','795148',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136486,512,'Sapam Salai B.O','795148',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136487,512,'Saram Patong B.O','795149',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136488,512,'Serou B.O','795101',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136489,512,'Shahumphai B.O','795101',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136490,512,'Sita B.O','795135',1,0,'2022-03-04 19:30:29','2022-03-04 19:30:29'),(136491,512,'Soichang B.O','795149',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136492,512,'Songjang B.O','795135',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136493,512,'Sora B.O','795103',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136494,512,'Tekcham B.O','795148',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136495,512,'Tentha B.O','795148',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136496,512,'Thamnapokpi B.O','795135',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136497,512,'Thiyamkonjil B.O','795130',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136498,512,'Thoubal Block (T/C/D) B.O','795138',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136499,512,'Thoubal Khunou B.O','795138',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136500,512,'Thoubal Leisangthem B.O','795138',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136501,512,'Thoubal Ningombam B.O','795138',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136502,512,'Thoubal S.O','795138',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136503,512,'Tokpaching B.O','795103',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136504,512,'Tollen B.O','795148',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136505,512,'Top Chingtha B.O','795149',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136506,512,'Turelahnabi B.O','795130',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136507,512,'Urup B.O','795130',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136508,512,'Wabagai B.O','795103',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136509,512,'Waikhong B.O','795103',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136510,512,'Wangbal B.O','795138',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136511,512,'Wangjing S.O','795148',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136512,512,'Wangoo Laipham B.O','795103',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136513,512,'Yairipok S.O','795149',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136514,512,'Yairipok Tulihal B.O','795149',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136515,512,'Yambem Laxmi Bazar B.O','795149',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136516,513,'Ashi B.O','795145',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136517,513,'Chadong B.O','795145',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136518,513,'Chamu B.O','795142',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136519,513,'Chassad B.O','795145',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136520,513,'Chingai (P) B.O','795142',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136521,513,'Chingjaroiedbo B.O','795142',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136522,513,'Chither (P) B.O','795142',1,0,'2022-03-04 19:30:30','2022-03-04 19:30:30'),(136523,513,'Grihang B.O','795145',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136524,513,'Huime B.O','795144',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136525,513,'Huining B.O','795142',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136526,513,'Hundung B.O','795142',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136527,513,'Jessami Edno B.O','795142',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136528,513,'Kachal B.O','795144',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136529,513,'Kagai B.O','795142',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136530,513,'Khamasom B.O','795142',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136531,513,'Kharasom B.O','795142',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136532,513,'Khayang B.O','795142',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136533,513,'Khongdei Simphung B.O','795144',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136534,513,'Kongpat Khunou B.O','795145',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136535,513,'L Tangkhul B.O','795145',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136536,513,'Lambui B.O','795145',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136537,513,'Lamlang Gate B.O','795142',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136538,513,'Leisan B.O','795142',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136539,513,'Leiting B.O','795145',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136540,513,'Litan S.O','795145',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136541,513,'Lungphu B.O','795145',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136542,513,'Maku B.O','795145',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136543,513,'Maokot B.O','795145',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136544,513,'Mapum B.O','795142',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136545,513,'Ngairou B.O','795142',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136546,513,'Ngari Khullen B.O','795144',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136547,513,'Nungbi Khunou B.O','795142',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136548,513,'Nungshang B.O','795142',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136549,513,'Paorei B.O','795142',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136550,513,'Paoyii B.O','795142',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136551,513,'Phadang B.O','795144',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136552,513,'Phungcham B.O','795142',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136553,513,'Phungyar B.O','795145',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136554,513,'Poii B.O','795142',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136555,513,'Pushing B.O','795142',1,0,'2022-03-04 19:30:31','2022-03-04 19:30:31'),(136556,513,'Rajai Khunou B.O','795142',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136557,513,'Sanakeithel B.O','795145',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136558,513,'Semol B.O','795145',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136559,513,'Shongshak B.O','795145',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136560,513,'Sirarakhong B.O','795142',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136561,513,'Siroi B.O','795142',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136562,513,'Siyamongjam B.O','795145',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136563,513,'Somdal S.O','795144',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136564,513,'Sorang Phung B.O','795142',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136565,513,'Sorde B.O','795145',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136566,513,'T.C. Ground B.O','795142',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136567,513,'Thawai B.O','795145',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136568,513,'Thiwa B.O','795144',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136569,513,'Tolloi B.O','795142',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136570,513,'Tuinem B.O','795142',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136571,513,'Tungou B.O','795142',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136572,513,'Tushem B.O','795142',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136573,513,'Ukhrul S.O','795142',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136574,513,'Yangangpokpi B.O','795145',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136575,514,'Aibawk S.O','796190',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136576,514,'Aiduzawl B.O','796261',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136577,514,'Aizawl H.O','796001',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136578,514,'Armed Veng B.O','796007',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136579,514,'Armed Veng S.O','796008',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136580,514,'Baktawng B.O','796161',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136581,514,'Bawngkawn S.O','796014',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136582,514,'Bethlehem B.O','796007',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136583,514,'Buhban B.O','796261',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136584,514,'Bukpui B.O','796070',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136585,514,'Bungkawn B.O','796005',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136586,514,'Chaltlang B.O','796012',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136587,514,'Chandmary S.O','796007',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136588,514,'Changzawl B.O','796261',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136589,514,'Chawlhhmun B.O','796009',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136590,514,'Chhingchhip B.O','796161',1,0,'2022-03-04 19:30:32','2022-03-04 19:30:32'),(136591,514,'College Veng B.O','796005',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136592,514,'Cti Sesawng B.O','796017',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136593,514,'Daido B.O','796261',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136594,514,'Darlawn S.O','796111',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136595,514,'Dinthar B.O','796009',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136596,514,'Durtlang B.O','796014',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136597,514,'Electric Veng B.O','796007',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136598,514,'Govt. Complex B.O','796009',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136599,514,'Hmuifang B.O','796190',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136600,514,'Hmuntha B.O','796161',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136601,514,'Hriphaw B.O','796471',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136602,514,'Hualngohmun B.O','796005',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136603,514,'Hualtu B.O','796161',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136604,514,'Keifang B.O','796261',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136605,514,'Kelsih B.O','796005',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136606,514,'Kepran B.O','796017',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136607,514,'Khanpui B.O','796017',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136608,514,'Khawbel B.O','796161',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136609,514,'Khawchhete B.O','796005',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136610,514,'Khawlian B.O','796261',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136611,514,'Khawpuar B.O','796111',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136612,514,'Khawruhlian B.O','796017',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136613,514,'Khumtung B.O','796161',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136614,514,'Kulikawn S.O','796005',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136615,514,'Lamchhip B.O','796190',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136616,514,'Lengpui Airport S.O','796421',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136617,514,'Lengpui B.O','796410',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136618,514,'Luangmual B.O','796009',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136619,514,'Luangpawn B.O','796261',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136620,514,'Lungdai B.O','796014',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136621,514,'Lungmuat B.O','796070',1,0,'2022-03-04 19:30:33','2022-03-04 19:30:33'),(136622,514,'Lungpher \'N\' B.O','796261',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136623,514,'Lungsum B.O','796111',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136624,514,'Lushaicherra B.O','796471',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136625,514,'Maite B.O','796261',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136626,514,'Maubawk B.O','796005',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136627,514,'Maubuang B.O','796190',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136628,514,'Mauchar B.O','796111',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136629,514,'Missionvengthlang B.O','796005',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136630,514,'Mizoram University S.O','796004',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136631,514,'Muallungthu B.O','796005',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136632,514,'Mualmawi B.O','796005',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136633,514,'Mualpheng B.O','796261',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136634,514,'Mualpui B.O','796005',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136635,514,'Muthi B.O','796014',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136636,514,'N.Chaltlang B.O','796070',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136637,514,'N.E.Bualpui B.O','796261',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136638,514,'N.Hlimen B.O','796070',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136639,514,'N.Khawlek B.O','796261',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136640,514,'N.Lungleng B.O','796005',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136641,514,'N.Serzawl B.O','796111',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136642,514,'N.Tinghmun B.O','796111',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136643,514,'New Secretariat Complex B.O','796005',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136644,514,'New Vervek B.O','796111',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136645,514,'Nisapui B.O','796070',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136646,514,'Palsang B.O','796111',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136647,514,'Pawlrang B.O','796261',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136648,514,'Phaileng \'E\' B.O','796017',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136649,514,'Phuaibuang B.O','796261',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136650,514,'Phullen B.O','796261',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136651,514,'Phulpui B.O','796190',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136652,514,'Ptc Lungverh B.O','796410',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136653,514,'Ramhlun S.O','796012',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136654,514,'Ramthar B.O','796007',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136655,514,'Rangvamual B.O','796009',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136656,514,'Ratu B.O','796111',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136657,514,'Republic Veng B.O','796005',1,0,'2022-03-04 19:30:34','2022-03-04 19:30:34'),(136658,514,'Ruallung B.O','796261',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136659,514,'S','hlimen B.O',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136660,514,'Sabualkawn B.O','796005',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136661,514,'Saichal B.O','796261',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136662,514,'Sailam B.O','796190',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136663,514,'Sailutar B.O','796111',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136664,514,'Saitual S.O','796261',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136665,514,'Sakawrdai B.O','796111',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136666,514,'Sakawrtuichhun B.O','796009',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136667,514,'Samlukhai B.O','796190',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136668,514,'Sateek B.O','796190',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136669,514,'Sawleng B.O','796017',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136670,514,'Selesih B.O','796014',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136671,514,'Seling B.O','796161',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136672,514,'Serkhan B.O','796070',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136673,514,'Sesawng B.O','796017',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136674,514,'Sialsuk B.O','796190',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136675,514,'Sihfa B.O','796261',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136676,514,'Sihphir B.O','796014',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136677,514,'Suangpuilawn B.O','796261',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136678,514,'Sumsuih B.O','796190',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136679,514,'Tachhip B.O','796190',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136680,514,'Tanhril B.O','796009',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136681,514,'Thakthingbazar B.O','796005',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136682,514,'Thentlang B.O','796161',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136683,514,'Thiak B.O','796190',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136684,514,'Thingdawlmelriat B.O','796005',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136685,514,'Thingsat B.O','796111',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136686,514,'Thingsulthliah S.O','796161',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136687,514,'Thingthelh B.O','796070',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136688,514,'Tlangnuam B.O','796005',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136689,514,'Tlungvel B.O','796161',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136690,514,'Tualbung B.O','796261',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136691,514,'Tuirial H.E.P B.O','796101',1,0,'2022-03-04 19:30:35','2022-03-04 19:30:35'),(136692,514,'Tuithiang B.O','796007',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136693,514,'Vaitin B.O','796111',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136694,514,'Vaivakawn S.O','796009',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136695,514,'Vanbawng B.O','796261',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136696,514,'Vervek B.O','796111',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136697,514,'Zamuang B.O','796471',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136698,514,'Zanlawn B.O','796014',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136699,514,'Zawlnuam S.O','796471',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136700,514,'Zawngin B.O','796261',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136701,514,'Zemabawk S.O','796017',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136702,514,'Zohmun B.O','796111',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136703,514,'Zuangtui B.O','796017',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136704,515,'Bethel B.O','796321',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136705,515,'Biate B.O','796370',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136706,515,'Bungzung B.O','796320',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136707,515,'Chalrang B.O','796310',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136708,515,'Champhai S.O','796321',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136709,515,'Chawngtlai B.O','796310',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136710,515,'Chhawkhlei B.O','796321',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136711,515,'Chhawrtui B.O','796310',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136712,515,'Dulte B.O','796310',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136713,515,'Dungtlang B.O','796320',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136714,515,'Farkawn B.O','796320',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136715,515,'Hmunhmeltha B.O','796321',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136716,515,'Hnahlan B.O','796321',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136717,515,'Hrianghmun B.O','796290',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136718,515,'Hruaikawn B.O','796321',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136719,515,'Kawlbem B.O','796290',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136720,515,'Kawlkulh B.O','796310',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136721,515,'Kelkang B.O','796321',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136722,515,'Khawhai B.O','796310',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136723,515,'Khawkawn B.O','796290',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136724,515,'Khawnuam B.O','796321',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136725,515,'Khawzawl S.O','796310',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136726,515,'Khuangleng B.O','796321',1,0,'2022-03-04 19:30:36','2022-03-04 19:30:36'),(136727,515,'Khuangphah B.O','796321',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136728,515,'Khuangthing B.O','796320',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136729,515,'Lamzawl B.O','796290',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136730,515,'Leisenzo B.O','796321',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136731,515,'Leithum B.O','796320',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136732,515,'Lungphunlian B.O','796321',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136733,515,'Lungtan B.O','796310',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136734,515,'Maulkawi B.O','796321',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136735,515,'Mimbung B.O','796290',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136736,515,'Mualcheng B.O','796370',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136737,515,'Muallung B.O','796320',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136738,515,'Murlen B.O','796321',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136739,515,'N.Chalrang B.O','796310',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136740,515,'N.Khawbung B.O','796321',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136741,515,'Ne Khawdungsei B.O','796290',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136742,515,'Neihdawn B.O','796310',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136743,515,'Ngopa S.O','796290',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136744,515,'Ngur B.O','796321',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136745,515,'Puilo B.O','796310',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136746,515,'Riangtlei B.O','796310',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136747,515,'Ruantlang B.O','796321',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136748,515,'Rullam B.O','796310',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136749,515,'S.Khawbung S.O','796320',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136750,515,'Samthang B.O','796320',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136751,515,'Sazep B.O','796320',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136752,515,'Selam B.O','796290',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136753,515,'Sesih B.O','796321',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136754,515,'Teikhang B.O','796290',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136755,515,'Tlangsam B.O','796321',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136756,515,'Tualcheng B.O','796321',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136757,515,'Tualpui B.O','796310',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136758,515,'Tualte B.O','796310',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136759,515,'Vaikhawtlang B.O','796290',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136760,515,'Vanchengpui B.O','796310',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136761,515,'Vangchhia B.O','796320',1,0,'2022-03-04 19:30:37','2022-03-04 19:30:37'),(136762,515,'Vangtlang B.O','796310',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136763,515,'Vanzau B.O','796320',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136764,515,'Vapar B.O','796321',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136765,515,'Vaphai B.O','796320',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136766,515,'Vengthlang B.O','796321',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136767,515,'Zote \'e\' B.O','796321',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136768,516,'Bairabi B.O','796081',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136769,516,'Bilkhawthlir S.O','796091',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136770,516,'Bualpui B.O','796070',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136771,516,'Buhchang B.O','796091',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136772,516,'Builum B.O','796081',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136773,516,'Chuhvel B.O','796081',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136774,516,'Diakkawn B.O','796081',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136775,516,'Diakkawn B.O','796081',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136776,516,'Diakkawn S.O','796082',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136777,516,'Hortoki B.O','796070',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136778,516,'Kawnpui S.O','796070',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136779,516,'Kolasib S.O','796081',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136780,516,'Mualvum B.O','796070',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136781,516,'N.Chawnpui B.O','796101',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136782,516,'Phainuam B.O','796101',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136783,516,'Phaisen B.O','796091',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136784,516,'Saihapui \'K\' B.O','796081',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136785,516,'Saikhawthlir B.O','796081',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136786,516,'Saiphai B.O','796101',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136787,516,'Saipum B.O','796101',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136788,516,'Suarhliap B.O','796081',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136789,516,'Thingdawl B.O','796082',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136790,516,'Vairengte S.O','796101',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136791,516,'Vengthar B.O','796081',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136792,517,'Balhlakawn B.O','796891',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136793,517,'Bungtlang \'S\' B.O','796891',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136794,517,'Chamdur B.O','796891',1,0,'2022-03-04 19:30:38','2022-03-04 19:30:38'),(136795,517,'Cheural B.O','796901',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136796,517,'Diltlang B.O','796891',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136797,517,'Kamalanagar S.O (LawngtlB.O','796770',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136798,517,'Karlui B.O','796891',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136799,517,'Kawlchaw \'W\' B.O','796891',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136800,517,'Lawngtlai S.O','796891',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136801,517,'Lungtian B.O','796901',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136802,517,'Mampui B.O','796891',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136803,517,'Mualbukawn B.O','796891',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136804,517,'New Jagnasury B.O','796891',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136805,517,'Ngengpuikai B.O','796891',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136806,517,'Paithar B.O','796891',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136807,517,'Pangkhua B.O','796901',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136808,517,'Parva B.O','796891',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136809,517,'Rulkual B.O','796891',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136810,517,'Sabualtlang B.O','796891',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136811,517,'Saizawh B.O','796770',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136812,517,'Sangau B.O','796901',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136813,517,'Tuisentlang B.O','796891',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136814,517,'Tuithumhnar B.O','796891',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136815,517,'Udaisury B.O','796770',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136816,517,'Udalthana B.O','796770',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136817,517,'Vaseitlang B.O','796891',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136818,517,'Vathuampui B.O','796891',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136819,518,'Aithur B.O','796571',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136820,518,'Ajasora B.O','796770',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136821,518,'Belthei B.O','796730',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136822,518,'Borapansury B.O','796770',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136823,518,'Bualpui H B.O','796581',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136824,518,'Bualte B.O','796701',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136825,518,'Buarpui B.O','796701',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136826,518,'Bunghmun B.O','796701',1,0,'2022-03-04 19:30:39','2022-03-04 19:30:39'),(136827,518,'Bunghmun S.O','796710',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136828,518,'Chandmary B.O','796701',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136829,518,'Changpui B.O','796701',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136830,518,'Chawngte S.O','796770',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136831,518,'Chawngtui B.O','796571',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136832,518,'Cherhlun B.O','796571',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136833,518,'Darngawn \'W\' B.O','796710',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136834,518,'Darzo B.O','796571',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136835,518,'Demagiri S.O','796751',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136836,518,'Diblibagh B.O','796751',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136837,518,'Haulawng B.O','796691',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136838,518,'Hauruang B.O','796701',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136839,518,'Hnahchang B.O','796691',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136840,518,'Hnahthial S.O','796571',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136841,518,'Hrangchalkawn B.O','796701',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136842,518,'Jarulsury B.O','796770',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136843,518,'Kajoisury B.O','796751',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136844,518,'Kawnpui \'W\' B.O','796710',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136845,518,'Kikawn B.O','796701',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136846,518,'Laisawral B.O','796710',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136847,518,'Leite B.O','796571',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136848,518,'Lungchem B.O','796701',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136849,518,'Lunglawn B.O','796701',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136850,518,'Lunglei S.O','796701',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136851,518,'Lungleng \'s\' B.O','796571',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136852,518,'Lungrang \'S\' B.O','796730',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136853,518,'Lungsen S.O','796730',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136854,518,'Mualcheng \'S\' B.O','796701',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136855,518,'Muallianpui B.O','796571',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136856,518,'Mualthuam \'N\' B.O','796691',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136857,518,'Nunsury B.O','796751',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136858,518,'Pangzawl B.O','796571',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136859,518,'Phairuangkai B.O','796730',1,0,'2022-03-04 19:30:40','2022-03-04 19:30:40'),(136860,518,'Puankhai B.O','796751',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136861,518,'Pukpui B.O','796691',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136862,518,'Putlungasih B.O','796730',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136863,518,'Ralvawng B.O','796701',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136864,518,'Ramlaitui B.O','796691',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136865,518,'Rangte B.O','796730',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136866,518,'Rawpui B.O','796571',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136867,518,'Rualalung B.O','796730',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136868,518,'S.Chawilung B.O','796751',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136869,518,'S.Vanlaiphai B.O','796571',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136870,518,'Sachan B.O','796710',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136871,518,'Sazaikawn B.O','796701',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136872,518,'Serkawn B.O','796691',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136873,518,'Sertlangpui B.O','796701',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136874,518,'Sesawm B.O','796710',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136875,518,'Sumsilui B.O','796770',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136876,518,'Tarpho B.O','796571',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136877,518,'Tawipui \'N\' B.O','796701',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136878,518,'Tawipui \'S\' B.O','796701',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136879,518,'Theiriat B.O','796701',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136880,518,'Thenhlum B.O','796701',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136881,518,'Thiltlang B.O','796571',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136882,518,'Thingfal B.O','796701',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136883,518,'Thingsai B.O','796571',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136884,518,'Thingsai S.O','796581',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136885,518,'Thualthu B.O','796701',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136886,518,'Thuampui B.O','796701',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136887,518,'Tiperaghat B.O','796751',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136888,518,'Tuichawng B.O','796730',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136889,518,'Tuikawi B.O','796751',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136890,518,'Tuipui \'D\' B.O','796571',1,0,'2022-03-04 19:30:41','2022-03-04 19:30:41'),(136891,518,'Vaisam B.O','796701',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136892,518,'Vanhne B.O','796701',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136893,518,'Zawlpui B.O','796730',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136894,518,'Zobawk B.O','796701',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136895,518,'Zodin B.O','796751',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136896,518,'Zohnuai B.O','796701',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136897,518,'Zotlang S.O','796691',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136898,519,'Ailawng B.O','796501',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136899,519,'Boraibazar B.O','796471',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136900,519,'Damparengpui B.O','796431',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136901,519,'Dampui B.O','796441',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136902,519,'Dapchhuah B.O','796410',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136903,519,'Darlak B.O','796441',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136904,519,'Darlung B.O','796501',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136905,519,'Hmunpui B.O','796421',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136906,519,'Hnahva B.O','796431',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136907,519,'Kanghmun B.O','796501',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136908,519,'Kanhmunbazar B.O','796471',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136909,519,'Kawrtethawveng B.O','796441',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136910,519,'Kawrthah B.O','796441',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136911,519,'Khawhnai B.O','796431',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136912,519,'Khawrihnim B.O','796501',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136913,519,'Lallen B.O','796431',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136914,519,'Lungdar \'W\' B.O','796501',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136915,519,'Mamit S.O','796441',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136916,519,'Marpara B.O','796431',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136917,519,'Momcherra B.O','796471',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136918,519,'Mualkhang B.O','796410',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136919,519,'N.Chhippui B.O','796431',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136920,519,'N.Sabual B.O','796441',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136921,519,'Parvatui B.O','796431',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136922,519,'Phaileng S.O','796431',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136923,519,'Phuldungsei B.O','796431',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136924,519,'Pukzing B.O','796431',1,0,'2022-03-04 19:30:42','2022-03-04 19:30:42'),(136925,519,'Rawpuichhip B.O','796410',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136926,519,'Reiek S.O','796501',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136927,519,'Rengdil B.O','796441',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136928,519,'Rulpuihlim B.O','796501',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136929,519,'S.Sabual B.O','796501',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136930,519,'Sairang S.O','796410',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136931,519,'Saithah B.O','796431',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136932,519,'Serhmun B.O','796441',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136933,519,'Silsury B.O','796431',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136934,519,'Tlangkhang B.O','796441',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136935,519,'Tuidam B.O','796441',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136936,519,'Tuipuibari B.O','796431',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136937,520,'Bualpui \'ng\' B.O','796901',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136938,520,'Chakhang B.O','796901',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136939,520,'Chapui B.O','796901',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136940,520,'Chhuarlung B.O','796901',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136941,520,'Fungkah B.O','796901',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136942,520,'Khopai B.O','796901',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136943,520,'Laki B.O','796901',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136944,520,'Latawh B.O','796901',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136945,520,'Lawngban B.O','796901',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136946,520,'Lungbun B.O','796901',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136947,520,'Lungpher \'S\' B.O','796901',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136948,520,'New Maubawk B.O','796901',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136949,520,'Niawhtlang B.O','796901',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136950,520,'Phura B.O','796901',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136951,520,'Rawmibawk B.O','796901',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136952,520,'Saiha S.O','796901',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136953,520,'Serkawr B.O','796901',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136954,520,'Siata B.O','796901',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136955,520,'Theiva B.O','796901',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136956,520,'Tongkolong B.O','796901',1,0,'2022-03-04 19:30:43','2022-03-04 19:30:43'),(136957,520,'Tuipang B.O','796901',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136958,520,'Tuipuiferry B.O','796901',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136959,520,'Tuisih B.O','796901',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136960,520,'Vahai B.O','796901',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136961,520,'Vawmbuk B.O','796901',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136962,520,'Zawngling B.O','796901',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136963,521,'Bungtlang \'N\' B.O','796181',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136964,521,'Chekawn B.O','796181',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136965,521,'Chhiahtlang B.O','796181',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136966,521,'Chhipphir B.O','796181',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136967,521,'Kanghmun \'S\' B.O','796181',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136968,521,'Keitum B.O','796181',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136969,521,'Khawlailung B.O','796181',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136970,521,'Leng B.O','796370',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136971,521,'Lungchhuan B.O','796181',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136972,521,'Lungdar S.O','796370',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136973,521,'Lungkawlh B.O','796181',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136974,521,'Lungpho B.O','796181',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136975,521,'N. Vanlaiphai S.O','796184',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136976,521,'N.Vanlaiphai B.O','796181',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136977,521,'New Serchhip B.O','796181',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136978,521,'Sailulak B.O','796370',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136979,521,'Serchhip S.O','796181',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136980,521,'Sialhau B.O','796181',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136981,521,'Sialhawk B.O','796370',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136982,521,'Sialsir B.O','796181',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136983,521,'Thenzawl S.O','796186',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136984,521,'Thinglian B.O','796181',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136985,521,'Tlangpui B.O','796370',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136986,521,'Zote \'S\' B.O','796181',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136987,522,'Agri College B.O','797106',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136988,522,'Aoyimti B.O','797115',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136989,522,'Artc S.O','797115',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136990,522,'Chumukedima S.O','797103',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136991,522,'Circular Road S.O','797117',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136992,522,'Daroga Pathar B.O','797115',1,0,'2022-03-04 19:30:44','2022-03-04 19:30:44'),(136993,522,'Dimapur Bazar S.O','797116',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(136994,522,'Dimapur S.O','797112',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(136995,522,'Diphupar B.O','797115',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(136996,522,'Doyapur B.O','797112',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(136997,522,'Duncan Basti B.O','797113',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(136998,522,'Eralibill B.O','797115',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(136999,522,'Hening Kunglwa B.O','797112',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137000,522,'Industrial Estate B.O','797113',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137001,522,'Jalukiekam B.O','797112',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137002,522,'Jharnapani B.O','797106',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137003,522,'Khaibung B.O','797106',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137004,522,'Khehekhu B.O','797116',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137005,522,'Khermahal B.O','797112',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137006,522,'Khopoanaula B.O','797103',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137007,522,'Kuda B.O','797112',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137008,522,'Kuhuboto B.O','797116',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137009,522,'Kushiabill B.O','797116',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137010,522,'Lengrijan B.O','797113',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137011,522,'Maova B.O','797106',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137012,522,'Medziphema S.O','797106',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137013,522,'Moaikam B.O','797103',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137014,522,'Molvom B.O','797106',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137015,522,'New Nepaligaon S.O','797113',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137016,522,'Nihekhu B.O','797103',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137017,522,'Nst Colony B.O','797113',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137018,522,'Nuiland B.O','797112',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137019,522,'P C College B.O','797103',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137020,522,'Padampukhuri B.O','797116',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137021,522,'Phaipijan B.O','797112',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137022,522,'Pherima B.O','797106',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137023,522,'Pimla B.O','797103',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137024,522,'Piphima B.O','797106',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137025,522,'Punglwa B.O','797106',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137026,522,'Pwd Colony B.O','797117',1,0,'2022-03-04 19:30:45','2022-03-04 19:30:45'),(137027,522,'Ralan B.O','797112',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137028,522,'Rangapahar B.O','797117',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137029,522,'Razaphima B.O','797112',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137030,522,'Showba Old B.O','797115',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137031,522,'Signal Village','797118',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137032,522,'Singal Village B.O','797117',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137033,522,'Singrijan B.O','797112',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137034,522,'Sirhima B.O','797106',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137035,522,'Suger Mill B.O','797115',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137036,522,'Sukhovi B.O','797115',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137037,522,'Tenyiphe B.O','797103',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137038,522,'Thahekhu B.O','797117',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137039,522,'Vihokhu B.O','797116',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137040,522,'Yampha B.O','797112',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137041,522,'Zeliangrong B.O','797117',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137042,523,'Amahatore B.O','798611',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137043,523,'Anatongere B.O','798611',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137044,523,'Kiphire S.O','798611',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137045,523,'Kisethong B.O','798611',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137046,523,'Longmatra B.O','798611',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137047,523,'Moya B.O','798611',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137048,523,'Phalonger B.O','798611',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137049,523,'Pokhpur B.O','798611',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137050,523,'Pungro B.O','798611',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137051,523,'Seyochang B.O','798611',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137052,523,'Sikur B.O','798611',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137053,523,'Singrup B.O','798611',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137054,523,'Sitimi B.O','798611',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137055,524,'Asukika B.O','797109',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137056,524,'Botsa B.O','797105',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137057,524,'Chakhabama B.O','797003',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137058,524,'Chatashi B.O','797109',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137059,524,'Chedema B.O','797003',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137060,524,'Chiechama S.O','797105',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137061,524,'Chiephobozou B.O','797105',1,0,'2022-03-04 19:30:46','2022-03-04 19:30:46'),(137062,524,'Ciesema B.O','797003',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137063,524,'Dihoma B.O','797003',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137064,524,'High School Junction S.O','797121',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137065,524,'Jakhama B.O','797005',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137066,524,'Jotsoma B.O','797002',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137067,524,'Kedima B.O','797003',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137068,524,'Khonoma B.O','797002',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137069,524,'Khuzama B.O','797005',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137070,524,'Kigwema B.O','797005',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137071,524,'Kizocha B.O','797003',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137072,524,'Kohima H.O','797001',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137073,524,'Kohima PWD S.O','797005',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137074,524,'Kohima Science College S.O','797002',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137075,524,'Kohima Village S.O','797003',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137076,524,'Kontsunyu B.O','797109',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137077,524,'Lalmati B.O','797005',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137078,524,'Lazami B.O','797109',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137079,524,'Mezoma B.O','797002',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137080,524,'Mima B.O','797005',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137081,524,'Mishilimi B.O','797105',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137082,524,'N.E.H.U. B.O','797004',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137083,524,'New Sectt Complex S.O','797004',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137084,524,'Nisenyu B.O','797109',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137085,524,'Nyishunyu B.O','797109',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137086,524,'P.R Hill S.O','797120',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137087,524,'Peren S.O','797101',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137088,524,'Phenshunyu B.O','797109',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137089,524,'Phenwhenyu B.O','797109',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137090,524,'Phesama B.O','797005',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137091,524,'Poilwa B.O','797002',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137092,524,'Pughoboto B.O','797109',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137093,524,'Rusoma B.O','797003',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137094,524,'Sendenyu B.O','797109',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137095,524,'Tesophenyu B.O','797109',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137096,524,'Thizama B.O','797004',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137097,524,'Tseminyu Old Town B.O','797109',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137098,524,'Tseminyu S.O','797109',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137099,524,'Tsosesunyu B.O','797109',1,0,'2022-03-04 19:30:47','2022-03-04 19:30:47'),(137100,524,'Tuophema B.O','797105',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137101,524,'Viswema B.O','797005',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137102,524,'Zephenyu B.O','797109',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137103,524,'Zhadima B.O','797105',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137104,524,'Zubza B.O','797005',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137105,525,'Hukpang B.O','798625',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137106,525,'Longleng S.O','798625',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137107,525,'Nian B.O','798625',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137108,525,'Phomching B.O','798625',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137109,525,'Sakchi B.O','798625',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137110,525,'Yachem B.O','798625',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137111,525,'Yongyak B.O','798625',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137112,526,'Alichen B.O','798601',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137113,526,'Alungkima B.O','798604',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137114,526,'Alungtaki B.O','798604',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137115,526,'Aolijen B.O','798601',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137116,526,'Arree Old B.O','798601',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137117,526,'Asangma B.O','798618',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137118,526,'Barakangtsung B.O','798618',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137119,526,'Changki B.O','798601',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137120,526,'Chantongia S.O','798613',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137121,526,'Chare B.O','798601',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137122,526,'Chuchuyimlang S.O','798614',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137123,526,'Chungtia B.O','798601',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137124,526,'Chungtia Yimsen B.O','798604',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137125,526,'Fazl Ali College B.O','798601',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137126,526,'Impur S.O','798615',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137127,526,'Khari B.O','798604',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137128,526,'Khensa B.O','798617',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137129,526,'Kubulong B.O','798615',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137130,526,'Kubza B.O','798601',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137131,526,'Longchang B.O','798615',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137132,526,'Longchem B.O','798604',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137133,526,'Longkhum B.O','798601',1,0,'2022-03-04 19:30:48','2022-03-04 19:30:48'),(137134,526,'Longkong B.O','798614',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137135,526,'Longmisa B.O','798601',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137136,526,'Longnak B.O','798604',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137137,526,'Longsa B.O','798601',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137138,526,'Luyang Valley B.O','798618',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137139,526,'Mangmentong B.O','798601',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137140,526,'Merangkong B.O','798613',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137141,526,'Mokokchung S.O','798601',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137142,526,'Molungkhimong B.O','798618',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137143,526,'Molungyimsen B.O','798618',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137144,526,'Mongchen B.O','798604',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137145,526,'Mongkholemba S.O','798604',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137146,526,'Mongsenyimti B.O','798614',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137147,526,'Nst Colony B.O','798601',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137148,526,'Opangkong S.O','798617',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137149,526,'Paper Nagar S.O','798623',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137150,526,'Phangsang B.O','798613',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137151,526,'S. E. Colony B.O','798601',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137152,526,'Salulamang B.O','798614',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137153,526,'Sungratsu B.O','798615',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137154,526,'Tamlu B.O','798618',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137155,526,'Tronger B.O','798601',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137156,526,'Tuli S.O','798618',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137157,526,'Ungar B.O','798614',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137158,526,'Ungma B.O','798601',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137159,526,'V. K. Town B.O','798601',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137160,526,'Wamaken B.O','798618',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137161,526,'Waromung B.O','798604',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137162,526,'Yaongyimsen B.O','798613',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137163,526,'Yisemyong B.O','798614',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137164,527,'Angphang B.O','798603',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137165,527,'Baranamsang B.O','798622',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137166,527,'Champang S.O','798603',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137167,527,'Chengloisho B.O','798603',1,0,'2022-03-04 19:30:49','2022-03-04 19:30:49'),(137168,527,'Chenwetnyu B.O','798603',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137169,527,'Chingkao B.O','798603',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137170,527,'Chinglong B.O','798603',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137171,527,'Chui B.O','798621',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137172,527,'Jakpang B.O','798603',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137173,527,'Kongon B.O','798622',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137174,527,'Longching B.O','798603',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137175,527,'Longpong Senghe B.O','798621',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137176,527,'Longwa B.O','798621',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137177,527,'Mon S.O','798621',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137178,527,'Monyakshu B.O','798603',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137179,527,'Naginimora S.O','798622',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137180,527,'Namsa B.O','798602',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137181,527,'Pessao B.O','798603',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137182,527,'Pongkong B.O','798621',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137183,527,'Singha Chingnyu B.O','798621',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137184,527,'Tang B.O','798621',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137185,527,'Tizit S.O','798602',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137186,527,'Tobu B.O','798603',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137187,527,'Totak B.O','798621',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137188,527,'Ukha B.O','798603',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137189,527,'Wakching B.O','798622',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137190,527,'Waunching B.O','798621',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137191,527,'Yannu B.O','798602',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137192,527,'Zaboka B.O','798602',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137193,527,'Zangkham B.O','798602',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137194,528,'Athibung B.O','797110',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137195,528,'Bongkholong B.O','797110',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137196,528,'Gaili B.O','797110',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137197,528,'Jalukie \'B\' B.O','797110',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137198,528,'Khelma B.O','797110',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137199,528,'Lilen B.O','797110',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137200,528,'Mbaulwa B.O','797101',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137201,528,'Mhainamtsi B.O','797110',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137202,528,'N.Song B.O','797101',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137203,528,'Nchongram B.O','797101',1,0,'2022-03-04 19:30:50','2022-03-04 19:30:50'),(137204,528,'New Jalukie B.O','797110',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137205,528,'Samjiuram B.O','797110',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137206,528,'Tening B.O','797101',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137207,528,'Zalukie S.O','797110',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137208,529,'Akhegwo B.O','797114',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137209,529,'Chetheba B.O','797104',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137210,529,'Chizami S.O','797102',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137211,529,'Chizami Village B.O','797102',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137212,529,'Chozuba S.O','797104',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137213,529,'Dzulhami B.O','797104',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137214,529,'Hutsu B.O','797114',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137215,529,'Ketsapo B.O','797108',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137216,529,'Khezhakeno B.O','797107',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137217,529,'Khuzami B.O','797108',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137218,529,'Kikruma B.O','797107',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137219,529,'Kilomi B.O','797104',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137220,529,'Lephori B.O','797114',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137221,529,'Losami B.O','797108',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137222,529,'Luzaphuhu B.O','797108',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137223,529,'Meluri S.O','797114',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137224,529,'Mesolumi B.O','797107',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137225,529,'Middle Khomi B.O','797102',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137226,529,'Old Phek B.O','797108',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137227,529,'Pfutsero S.O','797107',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137228,529,'Phek S.O','797108',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137229,529,'Phesachuduma B.O','797107',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137230,529,'Phugwu B.O','797104',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137231,529,'Porba B.O','797107',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137232,529,'Pungkhuri B.O','797114',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137233,529,'Runguzumi B.O','797104',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137234,529,'Sakraba B.O','797107',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137235,529,'Tekhouba B.O','797107',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137236,529,'Thechulumi B.O','797102',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137237,529,'Thenizumi B.O','797104',1,0,'2022-03-04 19:30:51','2022-03-04 19:30:51'),(137238,529,'Thipuzumi B.O','797107',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137239,529,'Thvophisumi B.O','797104',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137240,529,'Wazhiho B.O','797114',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137241,529,'Yaribami B.O','797104',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137242,529,'Zaketsa B.O','797107',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137243,529,'Zavame B.O','797107',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137244,529,'Zhamai B.O','797107',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137245,530,'Angangba B.O','798616',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137246,530,'Chessore B.O','798612',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137247,530,'Chimonger B.O','798616',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137248,530,'Chingmei B.O','798612',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137249,530,'Choklangan B.O','798626',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137250,530,'Chungtore B.O','798616',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137251,530,'Huker B.O','798612',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137252,530,'Kongsang B.O','798616',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137253,530,'Kuthur B.O','798612',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137254,530,'Longkhim S.O','798616',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137255,530,'Nokhu B.O','798626',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137256,530,'Noklak S.O','798626',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137257,530,'Noksen B.O','798616',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137258,530,'Pangsha B.O','798626',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137259,530,'Panso B.O','798612',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137260,530,'Pessu B.O','798626',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137261,530,'Sanglao B.O','798626',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137262,530,'Sangsanyu B.O','798612',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137263,530,'Saramati B.O','798612',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137264,530,'Shamator B.O','798612',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137265,530,'Shampur B.O','798612',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137266,530,'Shiponger B.O','798612',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137267,530,'Sotokur B.O','798612',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137268,530,'Thonokhunyu B.O','798612',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137269,530,'Tuensang S.O','798612',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137270,530,'Tuensang Village B.O','798612',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137271,530,'Yangli B.O','798616',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137272,531,'Aitepyong B.O','797100',1,0,'2022-03-04 19:30:52','2022-03-04 19:30:52'),(137273,531,'Baghty B.O','797111',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137274,531,'Bhandari B.O','797111',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137275,531,'Bhandari S.O','797099',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137276,531,'Chukitong B.O','797111',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137277,531,'Doyang Hydel Project S.O','797100',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137278,531,'Elumnyu B.O','797111',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137279,531,'Englan B.O','797111',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137280,531,'Humtsu B.O','797111',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137281,531,'Longtsung B.O','797100',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137282,531,'Lotsu B.O','797100',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137283,531,'Mekhukla B.O','797111',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137284,531,'Moilan B.O','797100',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137285,531,'N. Longidong B.O','797111',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137286,531,'Nyiro B.O','797111',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137287,531,'Pangti B.O','797100',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137288,531,'Pongitong B.O','797111',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137289,531,'Sanis B.O','797100',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137290,531,'Sungro B.O','797100',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137291,531,'Tsungtsutong B.O','797111',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137292,531,'Wokha S.O','797111',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137293,531,'Wokha Village B.O','797111',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137294,531,'Wozhru B.O','797111',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137295,531,'Yamhon B.O','797100',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137296,531,'Yikhum B.O','797111',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137297,532,'Aghunato B.O','798620',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137298,532,'Aizuto B.O','798619',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137299,532,'Akuhaito B.O','798619',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137300,532,'Akuluto S.O','798619',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137301,532,'Asukhomi B.O','798620',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137302,532,'Asukuto B.O','798619',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137303,532,'Asuto B.O','798620',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137304,532,'Atoizu B.O','798620',1,0,'2022-03-04 19:30:53','2022-03-04 19:30:53'),(137305,532,'Ghathashi B.O','797109',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137306,532,'Hosephu B.O','798620',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137307,532,'Kichilimi B.O','798620',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137308,532,'Lumami S.O','798627',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137309,532,'Phisami B.O','798620',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137310,532,'Saghemi B.O','798620',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137311,532,'Satakha B.O','798620',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137312,532,'Satami B.O','798620',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137313,532,'Satoi B.O','798620',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137314,532,'Suruhuto B.O','798620',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137315,532,'Surumi B.O','798620',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137316,532,'Tokiye B.O','798620',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137317,532,'Zunheboto S.O','798620',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137318,533,'Abhanga B.O','799286',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137319,533,'Ambassa S.O','799289',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137320,533,'Apareshkar B.O','799286',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137321,533,'Bagaicherri B.O','799285',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137322,533,'Balarambazar B.O','799204',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137323,533,'Baligaon B.O','799285',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137324,533,'Bamancherra B.O','799286',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137325,533,'Baralutma B.O','799286',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137326,533,'Bhagirathpara B.O','799284',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137327,533,'Bullongbassa B.O','799284',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137328,533,'Chailengta S.O','799273',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137329,533,'Chandraipara B.O','799289',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137330,533,'Chawmanu B.O','799273',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137331,533,'Chengkap B.O','799286',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137332,533,'Chotosarma B.O','799285',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137333,533,'Dalapatipara B.O','799284',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137334,533,'Demchedrra Colony B.O','799275',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137335,533,'Dhumacherra B.O','799275',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137336,533,'East Masli B.O','799275',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137337,533,'Fulcherri B.O','799285',1,0,'2022-03-04 19:30:54','2022-03-04 19:30:54'),(137338,533,'Ganganagar Tribalcolony B.O','799289',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137339,533,'Garodtilla B.O','799285',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137340,533,'Halahali S.O','799286',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137341,533,'Harincherra B.O','799289',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137342,533,'Jagabandhu Para B.O','799284',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137343,533,'Jamthing B.O','799286',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137344,533,'Jarulcherra B.O','799275',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137345,533,'Kachucherra B.O','799278',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137346,533,'Kamalacherra B.O','799289',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137347,533,'Kamalpur Aerodrome B.O','799287',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137348,533,'Kamalpur Bazar B.O','799285',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137349,533,'Kamalpur S.O (Dhalai)','799285',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137350,533,'Kanchancherra','799266',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137351,533,'Kanchanpur Colony B.O','799289',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137352,533,'Karatichesdrra B.O','799275',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137353,533,'Karnamunipara B.O','799289',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137354,533,'Katalutma B.O','799286',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137355,533,'Kuchainala B.O','799287',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137356,533,'Kulaibazar S.O','799204',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137357,533,'Lakraichowdhuripara B.O','799289',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137358,533,'Laldingabari B.O','799273',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137359,533,'Laxmipur B.O','799284',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137360,533,'Longtharai B.O','799275',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137361,533,'Maharani Bus Stop B.O','799278',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137362,533,'Mainerma B.O','799275',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137363,533,'Manikbhander S.O','799287',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137364,533,'Manikpur B.O','799273',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137365,533,'Manughat S.O','799275',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137366,533,'Maracherra B.O','799285',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137367,533,'Maslicherra B.O','799275',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137368,533,'Mechuria B.O','799278',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137369,533,'Mendihaor B.O','799278',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137370,533,'Nagbangshi B.O','799287',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137371,533,'Nalicherra B.O','799204',1,0,'2022-03-04 19:30:55','2022-03-04 19:30:55'),(137372,533,'Natinmanu B.O','799273',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137373,533,'Noagoan B.O','799285',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137374,533,'Paschim Dalucherra B.O','799278',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137375,533,'Ramdurlavpur B.O','799285',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137376,533,'Ranipukur B.O','799284',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137377,533,'Salema S.O','799278',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137378,533,'Sarma S.O','799284',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137379,533,'Sikaribari B.O','799289',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137380,533,'Sindhukumarpara B.O','799275',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137381,533,'Singibill B.O','799285',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137382,533,'Srirampur Lambucherra B.O','799287',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137383,534,'Agnipassa B.O','799260',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137384,534,'Algapur B.O','799253',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137385,534,'Amtilla B.O','799261',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137386,534,'Anandabazar B.O','799271',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137387,534,'Andharcherra B.O','799263',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137388,534,'Baburbazar S.O','799281',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137389,534,'Bagbassa B.O','799253',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137390,534,'Baithangbari B.O','799254',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137391,534,'Bakbaki B.O','799251',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137392,534,'Balehar B.O','799280',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137393,534,'Balicherra B.O','799262',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137394,534,'Balidhum B.O','799254',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137395,534,'Barhaldi B.O','799271',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137396,534,'Baruakandi B.O','799251',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137397,534,'Belianchief B.O','799269',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137398,534,'Betcherra B.O','799266',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137399,534,'Bhadrapally B.O','799277',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137400,534,'Bhagabannagar B.O','799279',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137401,534,'Bhagyapur B.O','799251',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137402,534,'Bhatisonaimuri B.O','799264',1,0,'2022-03-04 19:30:56','2022-03-04 19:30:56'),(137403,534,'Bilthai B.O','799260',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137404,534,'Bindulal Karbaripara B.O','799273',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137405,534,'Birchandranagar B.O','799280',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137406,534,'Brajendranagar B.O','799261',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137407,534,'Chandipur B.O','799277',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137408,534,'Chandrapur S.O (North Tripura)','799251',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137409,534,'Chantail B.O','799279',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137410,534,'Chinibagan B.O','799279',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137411,534,'Churaibari S.O','799262',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137412,534,'Dalugaon B.O','799280',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137413,534,'Darchai B.O','799264',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137414,534,'Dasdabazar S.O','799271',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137415,534,'Dengdung B.O','799288',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137416,534,'Deocherra B.O','799260',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137417,534,'Deora Cherra B.O','799279',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137418,534,'Dewanpassa B.O','799254',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137419,534,'Dhanbilash B.O','799280',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137420,534,'Dhanicherra B.O','799263',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137421,534,'Dharmanagar Bazar B.O','799253',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137422,534,'Dharmanagar College B.O','799253',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137423,534,'Dharmanagar H.O','799250',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137424,534,'Dhupirbond B.O','799253',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137425,534,'Dighalbak B.O','799251',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137426,534,'Dudhpur B.O','799288',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137427,534,'Durgacherra B.O','799273',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137428,534,'East Huruah B.O','799253',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137429,534,'East Kamesawar B.O','799253',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137430,534,'East Kanchanbari B.O','799264',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137431,534,'Emrapassa B.O','799290',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137432,534,'Fatikcherra B.O','799290',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137433,534,'Fatikroy S.O','799290',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137434,534,'Fulbari B.O','799262',1,0,'2022-03-04 19:30:57','2022-03-04 19:30:57'),(137435,534,'Fultali B.O','799280',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137436,534,'Gakulnagar B.O','799290',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137437,534,'Ganganagar B.O','799290',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137438,534,'Garchirampara B.O','799271',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137439,534,'Gobindapur B.O','799251',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137440,534,'Goldharpur B.O','799279',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137441,534,'Gournagar B.O','799279',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137442,534,'Govidabari B.O','799263',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137443,534,'Gulakpur T.E B.O','799277',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137444,534,'Halflongcherra S.O','799254',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137445,534,'Hiracherra B.O','799281',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137446,534,'Hmungchuan B.O','799269',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137447,534,'Hmunpui B.O','799269',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137448,534,'Huruah B.O','799251',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137449,534,'Ichabpur B.O','799277',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137450,534,'Ichailalcherra B.O','799251',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137451,534,'Ichaisonapur B.O','799251',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137452,534,'Indurail B.O','799260',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137453,534,'Irani B.O','799281',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137454,534,'Jagannathpur B.O','799280',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137455,534,'Jalabazar B.O','799260',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137456,534,'Jalebassa B.O','799260',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137457,534,'Jampui S.O','799269',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137458,534,'Janata College B.O','799260',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137459,534,'Joyasree B.O','799270',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137460,534,'Jubarajnagar B.O','799254',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137461,534,'Juri R.F B.O','799260',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137462,534,'Kacharicherra B.O','799256',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137463,534,'Kadamtala S.O (North Tripura)','799261',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137464,534,'Kailashahar Air Port B.O','799279',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137465,534,'Kailashahar S.O','799277',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137466,534,'Kakrirpar B.O','799253',1,0,'2022-03-04 19:30:58','2022-03-04 19:30:58'),(137467,534,'Kalacherra B.O','799251',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137468,534,'Kalagangar Par B.O','799261',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137469,534,'Kalagong B.O','799269',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137470,534,'Kalapania B.O','799271',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137471,534,'Kalishahan B.O','799277',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137472,534,'Kameswargaon B.O','799253',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137473,534,'Kanchanbari S.O','799288',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137474,534,'Kanchanpur S.O (North Tripura)','799270',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137475,534,'Kangrai B.O','799269',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137476,534,'Karaicherra B.O','799263',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137477,534,'Karamcherra B.O','799266',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137478,534,'Khedacherra B.O','799256',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137479,534,'Kheranjuri B.O','799262',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137480,534,'Kirtantali B.O','799279',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137481,534,'Krishnapur B.O','799253',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137482,534,'Krishnatilla B.O','799263',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137483,534,'Kumarghat S.O','799264',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137484,534,'Kurit B.O','799261',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137485,534,'Lalcherra Colony B.O','799253',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137486,534,'Laljuri B.O','799270',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137487,534,'Laljuri East B.O','799288',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137488,534,'Latiapur B.O','799281',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137489,534,'Machmara B.O','799263',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137490,534,'Manuvelly B.O','799277',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137491,534,'Masauli B.O','799288',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137492,534,'Nabincherra B.O','799263',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137493,534,'Nalkata B.O','799263',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137494,534,'Narendranagar B.O','799256',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137495,534,'Nayapara N.D B.O','799251',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137496,534,'Nepaltilla B.O','799288',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137497,534,'Noagaon Bazar B.O','799290',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137498,534,'Noorpur B.O','799277',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137499,534,'North Padmabil B.O','799260',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137500,534,'Notting Chedrra B.O','799264',1,0,'2022-03-04 19:30:59','2022-03-04 19:30:59'),(137501,534,'Pabiacherra B.O','799264',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137502,534,'Padmabil B.O','799260',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137503,534,'Padmapur B.O','799253',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137504,534,'Paiturbazar S.O','799279',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137505,534,'Panichowkibazar S.O','799277',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137506,534,'Panisagar S.O','799260',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137507,534,'Paschim Radhapur B.O','799254',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137508,534,'Paschimchandrapur B.O','799251',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137509,534,'Paschimratacherra B.O','799290',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137510,534,'Pearacherra B.O','799261',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137511,534,'Pechardahar B.O','799280',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137512,534,'Pecharthal S.O','799263',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137513,534,'Pekucherr B.O','799260',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137514,534,'Phuldengsai B.O','799269',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137515,534,'Piplacherra B.O','799256',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137516,534,'Pratyekroy B.O','799251',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137517,534,'Premtala B.O','799261',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137518,534,'Purba Betcherra B.O','799266',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137519,534,'Radhapur B.O','799253',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137520,534,'Raghna B.O','799251',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137521,534,'Rahumcherra B.O','799260',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137522,534,'Rajbari S.O','799253',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137523,534,'Rajkandi B.O','799290',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137524,534,'Rajnagar Laxmipur B.O','799254',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137525,534,'Rakhalgang B.O','799261',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137526,534,'Ramgunapara B.O','799263',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137527,534,'Rangauti B.O','799281',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137528,534,'Rangrung B.O','799277',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137529,534,'Ranibari B.O','799261',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137530,534,'Ratacherra B.O','799290',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137531,534,'Rowabazar B.O','799260',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137532,534,'Sabual B.O','799269',1,0,'2022-03-04 19:31:00','2022-03-04 19:31:00'),(137533,534,'Sadhanasram B.O','799277',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137534,534,'Saidarpar B.O','799290',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137535,534,'Sailo B.O','799269',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137536,534,'Sakaibari B.O','799251',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137537,534,'Sakhan Serhmun B.O','799271',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137538,534,'Samrurpar B.O','799277',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137539,534,'Sanicherra B.O','799262',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137540,534,'Sarala B.O','799261',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137541,534,'Satnala B.O','799270',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137542,534,'Sayedabari B.O','799264',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137543,534,'Sibnagar B.O','799270',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137544,534,'Sonamukhi S.O (North Tripura)','799280',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137545,534,'Sonarurbassa B.O','799251',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137546,534,'South Ganganagar B.O','799253',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137547,534,'South Unokoti B.O','799264',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137548,534,'Sreerampur B.O','799277',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137549,534,'Suknacherra B.O','799270',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137550,534,'Tachai B.O','799277',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137551,534,'Tapaspalli B.O','799277',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137552,534,'Tarakpur B.O','799261',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137553,534,'Taraninagar B.O','799288',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137554,534,'Tarapur B.O','799290',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137555,534,'Teghari B.O','799290',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137556,534,'Thana Road B.O','799251',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137557,534,'Tilthai B.O','799260',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137558,534,'Tilthai Nutanbazar B.O','799260',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137559,534,'Tlangsang B.O','799269',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137560,534,'Tripura Damcherra S.O','799256',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137561,534,'Tripura Ganganagar B.O','799253',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137562,534,'Tripura Tillabazar B.O','799281',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137563,534,'Tuichama B.O','799271',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137564,534,'Ugalcherra B.O','799263',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137565,534,'Ujan Dodhpur B.O','799288',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137566,534,'Ujan Sailenbari B.O','799260',1,0,'2022-03-04 19:31:01','2022-03-04 19:31:01'),(137567,534,'Uptakhali B.O','799260',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137568,534,'Uttar Radhanagar B.O','799290',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137569,534,'West Nalkata B.O','799266',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137570,534,'West Panisagar B.O','799260',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137571,534,'Zaithang B.O','799253',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137572,534,'Zarultali B.O','799279',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137573,535,'Abani Reangpara B.O','799013',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137574,535,'Abhoyganj Bazar B.O','799155',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137575,535,'Amarpur S.O (South Tripura)','799101',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137576,535,'Amlighat B.O','799143',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137577,535,'Ampinagar B.O','799101',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137578,535,'Anandapur S.O (South Tripura)','799157',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137579,535,'Bagabassa B.O','799115',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137580,535,'Bagafa B.O','799144',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137581,535,'Bagma ED B.O','799114',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137582,535,'Bagmara B.O','799103',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137583,535,'Baikhora B.O','799144',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137584,535,'Baishnabpur B.O','799145',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137585,535,'Baldakhal B.O','799157',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137586,535,'Bampur B.O','799101',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137587,535,'Barbil B.O','799104',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137588,535,'Barpathari B.O','799155',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137589,535,'Baspadua B.O','799155',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137590,535,'Bazar Amtali B.O','799105',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137591,535,'Belonia aerodrome B.O','799155',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137592,535,'Beloniya S.O','799155',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137593,535,'Betaga B.O','799144',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137594,535,'Bhuratali B.O','799143',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137595,535,'Bijoynagar B.O','799145',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137596,535,'Bishnupur B.O','799143',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137597,535,'Boalkhali B.O','799104',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137598,535,'Chalitacherra B.O','799145',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137599,535,'Champaknagar B.O','799045',1,0,'2022-03-04 19:31:02','2022-03-04 19:31:02'),(137600,535,'Charakbai B.O','799142',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137601,535,'Chechuajamatiabari B.O','799101',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137602,535,'Chellagong B.O','799101',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137603,535,'Chittamara B.O','799155',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137604,535,'Dakshin Chandrapur B.O','799013',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137605,535,'Dakshin Fulcherri B.O','799143',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137606,535,'Dakshin Hichacherri B.O','799141',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137607,535,'Dakshin Maharani B.O','799013',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137608,535,'Dakshin Manubankul B.O','799143',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137609,535,'Dakshin Sonaicharri B.O','799155',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137610,535,'Dakshin taidu B.O','799101',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137611,535,'Debbari B.O','799101',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137612,535,'Debdaru Bazar B.O','799141',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137613,535,'Debipur B.O','799155',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137614,535,'Dhanlekha B.O','799101',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137615,535,'Dhuptali B.O','799105',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137616,535,'Dimatali B.O','799157',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137617,535,'Doulbari B.O','799145',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137618,535,'Dumburnagar B.O','799104',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137619,535,'East Bagabassa B.O','799114',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137620,535,'East Bagafa B.O','799144',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137621,535,'East Mirza B.O','799105',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137622,535,'Fulkumari B.O','799013',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137623,535,'Gabtali B.O','799157',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137624,535,'Gakulpur S.O','799114',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137625,535,'Gamakubari B.O','799101',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137626,535,'Gangacherra B.O','799125',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137627,535,'Garjanmura B.O','799114',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137628,535,'Garjee S.O','799125',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137629,535,'Ghorakappa B.O','799104',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137630,535,'Gomti Project S.O','799104',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137631,535,'Guachand B.O','799143',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137632,535,'Hadra B.O','799105',1,0,'2022-03-04 19:31:03','2022-03-04 19:31:03'),(137633,535,'Harbatali B.O','799145',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137634,535,'Harina Bazar B.O','799145',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137635,535,'Holakhet B.O','799013',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137636,535,'Hrishyamukh S.O','799156',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137637,535,'Ichacherra B.O','799105',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137638,535,'Jalaya B.O','799104',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137639,535,'Jalefa Bazar B.O','799145',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137640,535,'Jamjuri B.O','799013',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137641,535,'Jitendranagar B.O','799105',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137642,535,'Joalikhamar B.O','799013',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137643,535,'Jolaibari S.O','799141',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137644,535,'Kakraban S.O','799105',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137645,535,'Kalabon B.O','799125',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137646,535,'Kalashi Bazar B.O','799141',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137647,535,'Kanchannagar B.O','799144',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137648,535,'Karbook B.O','799104',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137649,535,'Kasari B.O','799150',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137650,535,'Kathalcherri B.O','799145',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137651,535,'Kathaliacherra B.O','799144',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137652,535,'Khilpara B.O','799114',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137653,535,'Killarbazar B.O','799114',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137654,535,'Kishoreganj B.O','799105',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137655,535,'Kupilong B.O','799114',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137656,535,'Kurma B.O','799101',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137657,535,'Kusumara B.O','799105',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137658,535,'Kwaifunga B.O','799141',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137659,535,'Lakshipati B.O','799013',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137660,535,'Laxmicherra B.O','799144',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137661,535,'Lebacherra B.O','799104',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137662,535,'Lowgang B.O','799144',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137663,535,'Ludhua B.O','799145',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137664,535,'Ludhua Tea Estate B.O','799145',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137665,535,'Madhabnagar B.O','799156',1,0,'2022-03-04 19:31:04','2022-03-04 19:31:04'),(137666,535,'Madhya Pillak B.O','799141',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137667,535,'Magurcherra B.O','799143',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137668,535,'Maharani B.O','799013',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137669,535,'Mahuamillan B.O','799101',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137670,535,'Malbassa B.O','799101',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137671,535,'Manikya B.O','799114',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137672,535,'Manpather B.O','799144',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137673,535,'Manubazar S.O','799143',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137674,535,'Matai B.O','799155',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137675,535,'Mogpuskarini B.O','799105',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137676,535,'Muhuri Ratanpur B.O','799142',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137677,535,'Muhuripur S.O','799142',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137678,535,'Murapara B.O','799013',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137679,535,'Nagrai B.O','799101',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137680,535,'Nalua B.O','799156',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137681,535,'Paharpur B.O','799101',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137682,535,'Paikhola B.O','799125',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137683,535,'Palatana B.O','799105',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137684,535,'Palku B.O','799101',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137685,535,'Paschim Mogpuskarini B.O','799105',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137686,535,'Paschim Paticherri Colony B.O','799125',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137687,535,'Paschim Pillak B.O','799141',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137688,535,'Paschim Pipariakhola B.O','799155',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137689,535,'Paticherri B.O','799104',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137690,535,'Pitra Bazar B.O','799114',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137691,535,'Puran Rajbari B.O','799157',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137692,535,'Purba Manikya Dewan B.O','799104',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137693,535,'Purba Manu B.O','799144',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137694,535,'Rachakishoreganj B.O','799144',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137695,535,'Radhakishorepur H.O','799120',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137696,535,'Raima B.O','799104',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137697,535,'Raiyabari B.O','799114',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137698,535,'Rajapur B.O','799125',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137699,535,'Rajarbag B.O','799114',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137700,535,'Rajnagar Colony B.O','799114',1,0,'2022-03-04 19:31:05','2022-03-04 19:31:05'),(137701,535,'Rajnagar S.O (South Tripura)','799150',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137702,535,'Rangamati B.O','799101',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137703,535,'Rangamura B.O','799153',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137704,535,'Rangkhang B.O','799101',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137705,535,'Rani B.O','799105',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137706,535,'Rupaicherri B.O','799145',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137707,535,'Sabroom S.O','799145',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137708,535,'Sakbari B.O','799141',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137709,535,'Salgara B.O','799114',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137710,535,'Samarendraganj B.O','799156',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137711,535,'Samukcherra B.O','799105',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137712,535,'Santirbazar S.O','799144',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137713,535,'Sarasima B.O','799155',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137714,535,'Sarbong B.O','799101',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137715,535,'Satchand B.O','799143',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137716,535,'Siddhinagar B.O','799157',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137717,535,'Silacharri B.O','799104',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137718,535,'Silghati B.O','799105',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137719,535,'Sindukpathar B.O','799143',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137720,535,'Sonaicherri B.O','799145',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137721,535,'South Bharat Ch.Nagar B.O','799155',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137722,535,'South Krishnagar B.O','799156',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137723,535,'South srirampur B.O','799157',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137724,535,'Srinagar B.O','799143',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137725,535,'Subashnagar B.O','799155',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137726,535,'Suknacherri B.O','799104',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137727,535,'Taidubari B.O','799101',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137728,535,'Tainani B.O','799125',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137729,535,'Takmacherra B.O','799125',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137730,535,'Tebaria B.O','799015',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137731,535,'Tekkatulsi B.O','799143',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137732,535,'Tepania B.O','799114',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137733,535,'Thakurcherra B.O','799141',1,0,'2022-03-04 19:31:06','2022-03-04 19:31:06'),(137734,535,'Thelakum B.O','799114',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137735,535,'Tirthamukh B.O','799104',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137736,535,'Tripureswari Colony S.O','799013',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137737,535,'Tuichama B.O','799104',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137738,535,'Upendranagar B.O','799105',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137739,535,'Urrat Takmacherra B.O','799144',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137740,535,'Uttar Bharat Ch Nagar B.O','799155',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137741,535,'Uttar Brojendranagar B.O','799114',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137742,535,'Uttar Chellagonj B.O','799104',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137743,535,'Uttar Debipur B.O','799144',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137744,535,'Uttar Sonaicherri B.O','799155',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137745,536,'Abhoynagar S.O','799005',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137746,536,'Agartala Aerodrome S.O','799009',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137747,536,'Agartala Bazar S.O','799001',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137748,536,'Agartala College S.O','799004',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137749,536,'Agartala Court S.O','799001',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137750,536,'Agartala H.O','799001',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137751,536,'Agartala ONGC S.O','799014',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137752,536,'Agartala Secretariat S.O','799010',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137753,536,'AgartalaGuard Post B.O','799002',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137754,536,'Amarendranagar B.O','799103',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137755,536,'Amtali B.O','799130',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137756,536,'Anandanagar B.O','799004',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137757,536,'Aralia B.O','799004',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137758,536,'Arundhutinagar S.O','799003',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137759,536,'Ashigarh B.O','799045',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137760,536,'Atharacord Colony B.O','799045',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137761,536,'Badharghat B.O','799003',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137762,536,'Baikunthapur B.O','799211',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137763,536,'Balubon B.O','799212',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137764,536,'Bamutia B.O','799211',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137765,536,'Banamalipur B.O','799007',1,0,'2022-03-04 19:31:07','2022-03-04 19:31:07'),(137766,536,'Bankumari E/SB B.O','799006',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137767,536,'Bardwal B.O','799115',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137768,536,'Barjala B.O','799103',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137769,536,'Barjala B.O','799002',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137770,536,'Barkathalia B.O','799211',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137771,536,'Battali B.O','799115',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137772,536,'Bejimara B.O','799131',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137773,536,'Belbari B.O','799045',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137774,536,'Bhabanipur B.O','799131',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137775,536,'Bhattapukur B.O','799003',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137776,536,'Bijoynagar Bazar B.O','799211',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137777,536,'Bimangarh S.O','799015',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137778,536,'Birendranagar S.O','799045',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137779,536,'Bishalgarh S.O','799102',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137780,536,'Bishramganj S.O','799103',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137781,536,'Bodhjungnagar B.O','799210',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137782,536,'Border Rampur B.O','799002',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137783,536,'Boxonagar B.O','799102',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137784,536,'Brahman Puskarini B.O','799210',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137785,536,'Brajapur B.O','799102',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137786,536,'Brigudaspara B.O','799045',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137787,536,'Burakha Landless Colony B.O','799035',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137788,536,'Chachubazar B.O','799211',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137789,536,'Champamura Bazar B.O','799130',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137790,536,'Chandigarh B.O','799115',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137791,536,'Chandul B.O','799105',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137792,536,'Charilam B.O','799103',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137793,536,'Charipara B.O','799003',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137794,536,'Chechrimile B.O','799103',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137795,536,'Chechuria B.O','799210',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137796,536,'Chowmouhani B.O','799115',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137797,536,'Darogamura B.O','799212',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137798,536,'Dhajanagar B.O','799102',1,0,'2022-03-04 19:31:08','2022-03-04 19:31:08'),(137799,536,'Dhaleswar S.O','799007',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137800,536,'Dhanpur B.O','799131',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137801,536,'Dhupcherra B.O','799004',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137802,536,'Dighalia Bazar B.O','799211',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137803,536,'Dinabandhupara B.O','799035',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137804,536,'Durganagar B.O','799035',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137805,536,'Durgapur B.O','799131',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137806,536,'Durjaynagar B.O','799009',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137807,536,'Durlavnarayan B.O','799115',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137808,536,'Fatikchhera B.O','799210',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137809,536,'G.B.Hospital B.O','799006',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137810,536,'Gabordi B.O','799004',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137811,536,'Gandhigram B.O','799012',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137812,536,'Gazaria B.O','799102',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137813,536,'Golaghati B.O','799102',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137814,536,'Goliraibari B.O','799103',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137815,536,'Gurudas Colony B.O','799045',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137816,536,'Harendranagar T. B.O','799210',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137817,536,'Harishnagar T.E. B.O','799102',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137818,536,'Indranagar B.O','799006',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137819,536,'Induria B.O','799131',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137820,536,'Ishanchandranagar B.O','799003',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137821,536,'Ishanpur B.O','799212',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137822,536,'Jaganath Bari Road S.O','799001',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137823,536,'Jampuijala B.O','799102',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137824,536,'Jampuijala Colony B.O','799102',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137825,536,'Janmejoynagar B.O','799045',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137826,536,'Jatrapur B.O','799131',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137827,536,'Jogendranagar B.O','799004',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137828,536,'Jumerdhepa B.O','799115',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137829,536,'Kaiyadhepa B.O','799102',1,0,'2022-03-04 19:31:09','2022-03-04 19:31:09'),(137830,536,'Kalacherra T.E. B.O','799211',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137831,536,'Kalamcherra B.O','799102',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137832,536,'Kalasimura B.O','799102',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137833,536,'Kalikrishnagar B.O','799131',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137834,536,'Kalkalia B.O','799102',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137835,536,'Kalkalia T.E. B.O','799211',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137836,536,'Kamalasagar B.O','799102',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137837,536,'Kamalghat S.O','799210',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137838,536,'Kamalnagar B.O','799131',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137839,536,'Kamrangatali B.O','799105',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137840,536,'Kanakraipara B.O','799102',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137841,536,'Kanchanmala B.O','799130',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137842,536,'Kathalbagan B.O','799006',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137843,536,'Kathalia B.O','799131',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137844,536,'Kemtali B.O','799115',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137845,536,'Kendraicherra B.O','799102',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137846,536,'Khas Chowmouhani B.O','799115',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137847,536,'Khasnoagaon B.O','799008',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137848,536,'Khayerpur S.O','799008',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137849,536,'Khedabari B.O','799131',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137850,536,'Konabon B.O','799102',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137851,536,'Krishnagar B.O','799002',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137852,536,'Krishnakishorenagar B.O','799102',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137853,536,'Kulubari B.O','799131',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137854,536,'Kunjaban S.O','799006',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137855,536,'Kunjabon Road B.O','799006',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137856,536,'Laifunga B.O','799210',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137857,536,'Lakshmandhepa B.O','799115',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137858,536,'Lalsingmura B.O','799102',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137859,536,'Lankamura B.O','799009',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137860,536,'Latiacherra B.O','799103',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137861,536,'Lembucherra B.O','799210',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137862,536,'Madhuban B.O','799003',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137863,536,'Madhuchoudhurypara B.O','799211',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137864,536,'Madhupur B.O','799102',1,0,'2022-03-04 19:31:10','2022-03-04 19:31:10'),(137865,536,'Maheshpur B.O','799131',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137866,536,'Majlishpur B.O','799035',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137867,536,'Mandainagar B.O','799045',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137868,536,'Mariamnagar B.O','799008',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137869,536,'Matinagar B.O','799131',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137870,536,'Mdhabbari B.O','799045',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137871,536,'Meghlipara B.O','799035',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137872,536,'Melaghar S.O','799115',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137873,536,'Mnaipather B.O','799131',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137874,536,'Mohanbhog B.O','799105',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137875,536,'Mohanpur S.O (West Tripura)','799211',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137876,536,'Nabasantiganj Bazar B.O','799102',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137877,536,'Nabinagar B.O','799102',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137878,536,'Nagicherra B.O','799004',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137879,536,'Nalchar B.O','799115',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137880,536,'Nandannagar B.O','799006',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137881,536,'Narayanpur B.O','799009',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137882,536,'Neepco B.O','799008',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137883,536,'Nidya B.O','799131',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137884,536,'Nirvaypur B.O','799131',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137885,536,'NIT Agartala S.O','799046',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137886,536,'No.2 Chandranagar B.O','799102',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137887,536,'Noabadi B.O','799045',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137888,536,'Noagaon Krishnagar B.O','799006',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137889,536,'Nutannagar B.O','799009',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137890,536,'Old Agartala B.O','799008',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137891,536,'Padmanagar B.O','799103',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137892,536,'Pandavpur B.O','799130',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137893,536,'Paschim Bhubanban B.O','799002',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137894,536,'Paschim Champamur B.O','799008',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137895,536,'Paschim Gokulnagar B.O','799130',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137896,536,'Paschim Noabadi B.O','799008',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137897,536,'Pathaliaghat B.O','799103',1,0,'2022-03-04 19:31:11','2022-03-04 19:31:11'),(137898,536,'Patnipara B.O','799211',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137899,536,'Pravapur B.O','799130',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137900,536,'Promodenagar B.O','799103',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137901,536,'Puran Kalibari B.O','799002',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137902,536,'Purathalrajnagar B.O','799102',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137903,536,'Purba Gokulnagar B.O','799102',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137904,536,'Purba Laxmi Bill B.O','799102',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137905,536,'Purba Noagaon B.O','799035',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137906,536,'Purba Pratapgarh B.O','799004',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137907,536,'Putia B.O','799102',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137908,536,'Rabindranagar Colony B.O','799131',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137909,536,'Radhamohanpur B.O','799045',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137910,536,'Radhanagar S.O (West Tripura)','799153',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137911,536,'Ramachandranagar B.O','799008',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137912,536,'Ramnagar Bazar B.O','799103',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137913,536,'Ramnagar S.O (West Tripura)','799002',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137914,536,'Rangamala Bazar B.O','799103',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137915,536,'Ranirbazar S.O','799035',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137916,536,'Ranirkhamar B.O','799003',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137917,536,'Rayermura B.O','799130',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137918,536,'Renters Colony B.O','799004',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137919,536,'Reshambagan B.O','799008',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137920,536,'Rohimpur B.O','799102',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137921,536,'Rokhia G.T Project B.O','799102',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137922,536,'Rudijala B.O','799115',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137923,536,'S.D.Mission Colony B.O','799003',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137924,536,'Salbagan S.O','799012',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137925,536,'Sanchindranagar Colony B.O','799045',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137926,536,'Sankumabari B.O','799102',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137927,536,'Sekerkote S.O','799130',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137928,536,'Sepahijala B.O','799102',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137929,536,'Siddhi Ashram B.O','799003',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137930,536,'Sidhai S.O','799212',1,0,'2022-03-04 19:31:12','2022-03-04 19:31:12'),(137931,536,'Simna B.O','799212',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137932,536,'Simna Colony B.O','799212',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137933,536,'Sonamani sepaipara B.O','799035',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137934,536,'Sonamura S.O','799131',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137935,536,'Sonaram Bazar B.O','799212',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137936,536,'South Charilam B.O','799103',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137937,536,'South Nehalchandranagar B.O','799102',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137938,536,'Srinagar Kacharipara B.O','799004',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137939,536,'Subalsing B.O','799211',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137940,536,'Sundartilla B.O','799212',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137941,536,'Sutarmura B.O','799102',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137942,536,'Taibandal B.O','799105',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137943,536,'Takarjala B.O','799102',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137944,536,'Taranagar B.O','799211',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137945,536,'Tarapur B.O','799211',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137946,536,'Tekshapara B.O','799103',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137947,536,'Telkajla B.O','799115',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137948,536,'Thamakari B.O','799211',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137949,536,'Town pratapgarh B.O','799004',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137950,536,'Town Rampur B.O','799002',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137951,536,'Tripura University S.O','799022',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137952,536,'Ujan Ghaniamara B.O','799102',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137953,536,'Urmai B.O','799115',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137954,536,'Uttar Dasgharia B.O','799212',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137955,536,'Uttar debendranagar B.O','799211',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137956,536,'Veluarchar B.O','799102',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137957,536,'Viveknagar B.O','799130',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137958,536,'Wakinagar B.O','799035',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137959,536,'West Laxmibill B.O','799102',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137960,536,'West Nalchar B.O','799115',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137961,536,'Agagartilla B.O','799201',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137962,536,'Asharambari B.O','799201',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137963,536,'Ataromura B.O','799205',1,0,'2022-03-04 19:31:13','2022-03-04 19:31:13'),(137964,536,'Bachaibari B.O','799201',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137965,536,'Baijalbari B.O','799207',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137966,536,'Banbazar B.O','799201',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137967,536,'Barmaidan Bazar B.O','799203',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137968,536,'Barmura Project B.O','799205',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137969,536,'Bdelchedrra B.O','799201',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137970,536,'Behalabari B.O','799201',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137971,536,'Bharatsardarbari B.O','799207',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137972,536,'Brahmacherra B.O','799205',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137973,536,'Chakmaghat B.O','799205',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137974,536,'Champahaor B.O','799201',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137975,536,'Chankhala B.O','799207',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137976,536,'Chebri S.O','799207',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137977,536,'Dakshin Promode L. L.Colony B.O','799203',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137978,536,'Durgapur B.O','799203',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137979,536,'Dwarikapur B.O','799203',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137980,536,'East Bachaibari B.O','799201',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137981,536,'Gakulbari B.O','799201',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137982,536,'Ganki B.O','799201',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137983,536,'Ghilatali B.O','799203',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137984,536,'Golabari B.O','799205',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137985,536,'Gouranga Tilla B.O','799207',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137986,536,'Hadrai B.O','799205',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137987,536,'Howaibari B.O','799205',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137988,536,'Kalitilla B.O','799205',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137989,536,'Kalyanpur S.O (West Tripura)','799203',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137990,536,'Kalyanpur T. E B.O','799203',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137991,536,'Karailong B.O','799205',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137992,536,'Karingicherra B.O','799201',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137993,536,'Khasiamangal B.O','799205',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137994,536,'Khowai Court S.O','799202',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137995,536,'Khowai S.O','799201',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137996,536,'Khowai T. E B.O','799201',1,0,'2022-03-04 19:31:14','2022-03-04 19:31:14'),(137997,536,'Maharanipur B.O','799205',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(137998,536,'Maigonga B.O','799205',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(137999,536,'Moharcherra B.O','799203',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138000,536,'Mongtukupara B.O','799205',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138001,536,'Nabakumar Rankhal Para B.O','799205',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138002,536,'Netajinagar B.O','799205',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138003,536,'Nunacherra B.O','799205',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138004,536,'Paglabari B.O','799207',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138005,536,'Paharmora B.O','799201',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138006,536,'Paschim Belcherra B.O','799201',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138007,536,'Paschim Kalyanpur B.O','799203',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138008,536,'Paschim Kunjaban B.O','799203',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138009,536,'Paschim Laxmicherra B.O','799201',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138010,536,'Paschim Santinagar B.O','799203',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138011,536,'Rajnagar Khowai B.O','799207',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138012,536,'Ramchandraghat B.O','799207',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138013,536,'Ramdayal Lendless Colony B.O','799203',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138014,536,'Ratanpurbazar B.O','799201',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138015,536,'Ratia B.O','799203',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138016,536,'Rupacherra B.O','799205',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138017,536,'Samatal Padmabil B.O','799201',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138018,536,'Singicherra B.O','799201',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138019,536,'Sonatala B.O','799207',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138020,536,'Subashpark B.O','799201',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138021,536,'Tablabari B.O','799203',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138022,536,'Teliamura S.O','799205',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138023,536,'Uttar Gakulnagar B.O','799205',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138024,536,'Uttarchebri B.O','799207',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138025,536,'Uttat Pulinpur B.O','799203',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138026,537,'Bordumsa S.O','792056',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138027,537,'Bubang B.O','792120',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138028,537,'Changlang S.O','792120',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138029,537,'Chopelling B.O','792122',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138030,537,'Deban B.O','792122',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138031,537,'Dharampur B.O','792122',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138032,537,'Gandhigram B.O','792055',1,0,'2022-03-04 19:31:15','2022-03-04 19:31:15'),(138033,537,'Innao B.O','792103',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138034,537,'Jairampur S.O (Changlang)','792121',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138035,537,'Kharsang B.O','792122',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138036,537,'Khemiyong B.O','792120',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138037,537,'Kherem Bisa B.O','792056',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138038,537,'Kutum Basti B.O','792122',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138039,537,'Lallung B.O','792056',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138040,537,'Manabhum B.O','792122',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138041,537,'Manmao B.O','792121',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138042,537,'Miao S.O','792122',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138043,537,'Namchik B.O','792122',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138044,537,'Namdang B.O','792120',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138045,537,'Namphai B.O','792122',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138046,537,'Nampong S.O','792123',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138047,537,'Namtok B.O','792120',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138048,537,'New Mohang B.O','792056',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138049,537,'Rajanagar B.O','792056',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138050,537,'Rangfrah Covt College B.O','792120',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138051,537,'Ranglum B.O','792120',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138052,537,'Two-hat B.O','792055',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138053,537,'Udaipur B.O','792103',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138054,537,'Vijoynagar S.O','792055',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138055,537,'Vijoypur B.O','792056',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138056,537,'Yangkang B.O','792120',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138057,538,'Alinye B.O','792101',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138058,538,'Anelih B.O','792101',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138059,538,'Anini S.O','792101',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138060,538,'Roing S.O','792110',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138061,539,'Bameng B.O','790102',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138062,539,'Bana B.O','790102',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138063,539,'Chyangtajo B.O','790102',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138064,539,'Khenewa B.O','790102',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138065,539,'Lada B.O','790102',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138066,539,'P.Kessang B.O','790102',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138067,539,'Pipu-dipu B.O','790102',1,0,'2022-03-04 19:31:16','2022-03-04 19:31:16'),(138068,539,'Seijosa S.O','790103',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138069,539,'Seppa S.O','790102',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138070,539,'Veo B.O','790102',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138071,540,'Adipasi B.O','791102',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138072,540,'Ayeng B.O','791104',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138073,540,'Balek B.O','791102',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138074,540,'Bilat B.O','791102',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138075,540,'Boleng B.O','791102',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138076,540,'Borguli B.O','791104',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138077,540,'Damro B.O','791102',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138078,540,'Debing B.O','791102',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138079,540,'GTC B.O','791102',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138080,540,'Hill Top S.O','791103',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138081,540,'Kebang B.O','791102',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138082,540,'Korang B.O','791102',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138083,540,'Koyu B.O','791102',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138084,540,'Ledum B.O','791102',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138085,540,'Mebo S.O','791104',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138086,540,'Namsing B.O','791104',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138087,540,'Nari B.O','791102',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138088,540,'Ngopok B.O','791104',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138089,540,'Oyan B.O','791102',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138090,540,'Pangin B.O','791102',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138091,540,'Pasighat S.O','791102',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138092,540,'Rani B.O','791102',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138093,540,'Renging B.O','791102',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138094,540,'Riga B.O','791102',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138095,540,'Ruksin B.O','791102',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138096,540,'Sille B.O','791102',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138097,540,'Silluk B.O','791104',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138098,540,'Sirem B.O','791104',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138099,540,'Yagrung B.O','791102',1,0,'2022-03-04 19:31:17','2022-03-04 19:31:17'),(138100,541,'Chambang B.O','791118',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138101,541,'Damin B.O','791118',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138102,541,'Hiya B.O','791118',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138103,541,'Koloriang B.O','791118',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138104,541,'Nyapin B.O','791118',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138105,541,'Palin S.O','791118',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138106,541,'Sangram B.O','791118',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138107,541,'Sarli B.O','791118',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138108,541,'Tali B.O','791118',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138109,542,'Alubari B.O','792102',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138110,542,'Chakma B.O','792102',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138111,542,'Changliang B.O','792001',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138112,542,'Chowkham S.O','792102',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138113,542,'Danglat B.O','792001',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138114,542,'Diyun B.O','792103',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138115,542,'Gohaingaon B.O','792001',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138116,542,'Hayuliang S.O','792104',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138117,542,'Jaipur B.O','792103',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138118,542,'Kamlang Nagar B.O','792102',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138119,542,'Kherem B.O','792102',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138120,542,'Kumari Kachari B.O','792105',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138121,542,'Kumsai B.O','792103',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138122,542,'Lathao B.O','792103',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138123,542,'Lohitpur B.O','792001',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138124,542,'Loiliang B.O','792001',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138125,542,'Mahadevpur S.O (Lohit)','792105',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138126,542,'Manmao B.O','792103',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138127,542,'Medo B.O','792102',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138128,542,'Momong B.O','792102',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138129,542,'Nampong B.O','792103',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138130,542,'Namsai S.O','792103',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138131,542,'Nanam B.O','792103',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138132,542,'Peyong B.O','792103',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138133,542,'Podumani B.O','792105',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138134,542,'Sunpura S.O','792111',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138135,542,'Tafragram B.O','792001',1,0,'2022-03-04 19:31:18','2022-03-04 19:31:18'),(138136,542,'Tezu Covt.College B.O','792001',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138137,542,'Tezu S.O','792001',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138138,542,'Tindolong B.O','792001',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138139,542,'Wakro B.O','792102',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138140,542,'Wingko B.O','792103',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138141,542,'Yealing B.O','792111',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138142,543,'Abango B.O','792110',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138143,543,'Anupam B.O','792110',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138144,543,'Bijari B.O','792110',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138145,543,'Bolung B.O','792110',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138146,543,'Bomjir B.O','792110',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138147,543,'Dambuk B.O','792110',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138148,543,'Desali B.O','792110',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138149,543,'Elopa B.O','792110',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138150,543,'Etalin B.O','792110',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138151,543,'Hunli B.O','792110',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138152,543,'Iduli B.O','792110',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138153,543,'Jia B.O','792110',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138154,543,'Koranu B.O','792110',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138155,543,'Kronli B.O','792110',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138156,543,'Meka B.O','792110',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138157,543,'Paglam B.O','792110',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138158,543,'Parbuk B.O','792110',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138159,543,'Santipur B.O','792110',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138160,544,'Boasimla B.O','791120',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138161,544,'Chimpu B.O','791113',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138162,544,'Deed B.O','791120',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138163,544,'Godak B.O','791120',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138164,544,'Hija B.O','791120',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138165,544,'Joram B.O','791120',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138166,544,'Old Ziro B.O','791120',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138167,544,'Raga B.O','791120',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138168,544,'Ranga Nadi Project S.O','791119',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138169,544,'Talo B.O','791120',1,0,'2022-03-04 19:31:19','2022-03-04 19:31:19'),(138170,544,'Yachuli B.O','791120',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138171,544,'Yazali B.O','791119',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138172,544,'Ziro S.O','791120',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138173,545,'Arunachal Pradesh Secretariat S.O','791111',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138174,545,'Arunachal University B.O','791112',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138175,545,'Balijan B.O','791123',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138176,545,'Banderdewa S.O','791123',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138177,545,'Chaglagam B.O','792104',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138178,545,'Doimukh S.O','791112',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138179,545,'Donyi Polo B.O','791113',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138180,545,'Goiliang B.O','792104',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138181,545,'Hawa Camp B.O','791121',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138182,545,'Hawai B.O','792104',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138183,545,'Itanagar H.O','791111',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138184,545,'Kheel B.O','791112',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138185,545,'Khopa B.O','792104',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138186,545,'Kibitho B.O','792104',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138187,545,'Kimin S.O','791121',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138188,545,'Kokila B.O','791123',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138189,545,'Mengio B.O','791119',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138190,545,'Meteliang B.O','792104',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138191,545,'Midpu B.O','791112',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138192,545,'Model Village B.O','791110',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138193,545,'Naharlagun S.O','791110',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138194,545,'Nirjuli S.O','791109',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138195,545,'Pessing B.O','791001',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138196,545,'Rahung B.O','790001',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138197,545,'Ram Krishna Mission S.O','791113',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138198,545,'Saglee B.O','791112',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138199,545,'Sonajuli B.O','791123',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138200,545,'Suchana Nagar B.O','791113',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138201,545,'Vivek Vihar B.O','791113',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138202,545,'Wallong B.O','792104',1,0,'2022-03-04 19:31:20','2022-03-04 19:31:20'),(138203,545,'Yatong B.O','792104',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138204,545,'Yupia B.O','791110',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138205,546,'B.Supply B.O','790104',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138206,546,'Gispu B.O','790106',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138207,546,'Jang S.O','790105',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138208,546,'Kitpi B.O','790104',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138209,546,'Lhou B.O','790105',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138210,546,'Lumberdung B.O','790104',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138211,546,'Lumla S.O','790106',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138212,546,'Mukto B.O','790105',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138213,546,'Sakpret B.O','790104',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138214,546,'Tawang S.O','790104',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138215,546,'Temple Gompa B.O','790104',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138216,546,'Thingbu B.O','790105',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138217,546,'Zimithang B.O','790106',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138218,547,'Borduria B.O','792130',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138219,547,'Dadam B.O','792130',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138220,547,'Deomali S.O','792129',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138221,547,'Hukanjuri B.O','792129',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138222,547,'K/nokno B.O','792131',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138223,547,'Kaimai B.O','792130',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138224,547,'Kanubari B.O','792130',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138225,547,'Kapu B.O','792130',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138226,547,'Khela B.O','792130',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138227,547,'Kheti B.O','792130',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138228,547,'Khonsa Basti B.O','792130',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138229,547,'Khonsa S.O','792130',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138230,547,'Khotnu B.O','792131',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138231,547,'Lazu B.O','792130',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138232,547,'Longding S.O','792131',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138233,547,'Longfong B.O','792131',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138234,547,'Minthong B.O','792131',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138235,547,'Namsang B.O','792129',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138236,547,'Namsang Mukh B.O','792129',1,0,'2022-03-04 19:31:21','2022-03-04 19:31:21'),(138237,547,'Narottam Nagar B.O','792129',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138238,547,'Nginu B.O','792131',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138239,547,'Niausa B.O','792131',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138240,547,'Panchou B.O','792131',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138241,547,'Senewa B.O','792131',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138242,547,'Soha B.O','792129',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138243,547,'Thinsa B.O','792130',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138244,547,'Tissa B.O','792131',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138245,547,'Tupi B.O','792130',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138246,547,'Vally View B.O','792130',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138247,547,'Wakka B.O','792131',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138248,548,'Dalbing B.O','791102',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138249,548,'Geku B.O','791002',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138250,548,'Gelling B.O','791105',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138251,548,'Karko B.O','791002',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138252,548,'Mariyang B.O','791002',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138253,548,'Migging B.O','791105',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138254,548,'Shimong B.O','791002',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138255,548,'Singa B.O','791105',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138256,548,'Tuting S.O','791105',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138257,548,'Yingkiong S.O','791002',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138258,549,'Daporijo S.O','791122',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138259,549,'Dumporijo B.O','791122',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138260,549,'Giba B.O','791122',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138261,549,'Lemiking B.O','791122',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138262,549,'Lepajaring B.O','791122',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138263,549,'Maro B.O','791122',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138264,549,'Muri B.O','791122',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138265,549,'Nacho B.O','791122',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138266,549,'Sippi B.O','791122',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138267,549,'Siyum B.O','791122',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138268,549,'Tabarijo B.O','791122',1,0,'2022-03-04 19:31:22','2022-03-04 19:31:22'),(138269,549,'Taksing B.O','791122',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138270,549,'Taliha B.O','791122',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138271,550,'Balemu B.O','790002',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138272,550,'Bhalukpong S.O','790114',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138273,550,'Bomdila S.O','790001',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138274,550,'Dahung B.O','790116',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138275,550,'Dedza B.O','790116',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138276,550,'Dirang Basti B.O','790101',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138277,550,'Dirang S.O','790101',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138278,550,'Kalaktang S.O','790002',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138279,550,'Khellong B.O','790114',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138280,550,'Lish B.O','790101',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138281,550,'Munna Camp B.O','790101',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138282,550,'Nafra B.O','790001',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138283,550,'Palizi B.O','790102',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138284,550,'Rupa S.O','790003',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138285,550,'Salari B.O','790001',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138286,550,'Sangti B.O','790101',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138287,550,'Senge B.O','790101',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138288,550,'Shergaon B.O','790003',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138289,550,'Singchung B.O','790116',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138290,550,'Tenga Market S.O','790116',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138291,550,'Tenzingaon B.O','790002',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138292,550,'Thrizino B.O','790102',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138293,550,'Tippi B.O','790114',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138294,551,'Along S.O','791001',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138295,551,'Bagra B.O','791001',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138296,551,'Bame B.O','791101',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138297,551,'Basar S.O (West Siang)','791101',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138298,551,'Bene B.O','791001',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138299,551,'Dali B.O','791101',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138300,551,'Darak B.O','791001',1,0,'2022-03-04 19:31:23','2022-03-04 19:31:23'),(138301,551,'Daring B.O','791101',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138302,551,'Darka B.O','791001',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138303,551,'Garu B.O','791125',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138304,551,'Gensi B.O','791125',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138305,551,'Kambang B.O','791001',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138306,551,'Kaying B.O','791001',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138307,551,'Kombo B.O','791001',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138308,551,'Likabali S.O','791125',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138309,551,'Liromoba B.O','791101',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138310,551,'Logum Jining B.O','791001',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138311,551,'Mechuka S.O','791003',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138312,551,'Monigong B.O','791001',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138313,551,'Nikte B.O','791001',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138314,551,'Payum B.O','791001',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138315,551,'Rumgong B.O','791001',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138316,551,'Tato B.O','791001',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138317,551,'Tirbin B.O','791101',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138318,551,'Vivek Nagar B.O','791001',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138319,551,'Yoji Yora B.O','791001',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138320,551,'Yomcha B.O','791001',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138321,552,'Adakgiri B.O','783123',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138322,552,'Balkinigiri B.O','794111',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138323,552,'Dabu B.O','794110',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138324,552,'Dagal B.O','794108',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138325,552,'Dainadubi B.O','794110',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138326,552,'Dajongpara B.O','794002',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138327,552,'Daram B.O','794108',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138328,552,'Darugiri B.O','794110',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138329,552,'Dokangsi B.O','794110',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138330,552,'Gairong B.O','794110',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138331,552,'Gambil B.O','794110',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138332,552,'Haluapara B.O','794108',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138333,552,'Jadigitim B.O','794107',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138334,552,'Kharkutta B.O','783134',1,0,'2022-03-04 19:31:24','2022-03-04 19:31:24'),(138335,552,'Mangsang B.O','794110',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138336,552,'Nongcharan B.O','794110',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138337,552,'Raja Apal B.O','794002',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138338,552,'Rajapara B.O','793106',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138339,552,'Rombagiri B.O','794111',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138340,552,'Ronga Agal B.O','794110',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138341,552,'Rongchek Akhong B.O','794110',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138342,552,'Rongjeng S.O','794110',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138343,552,'Rongmil B.O','794110',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138344,552,'Rongrengiri B.O','794111',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138345,552,'Rongrong B.O','794108',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138346,552,'Rongsakgiri B.O','794111',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138347,552,'Sakhadongiri B.O','794111',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138348,552,'Samanda B.O','794111',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138349,552,'Songsak B.O','794111',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138350,552,'Thapa B.O','794108',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138351,552,'Wagachi B.O','794110',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138352,552,'Williamnagar S.O','794111',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138353,553,'Assam Rifles S.O','793011',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138354,553,'Balat S.O','793106',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138355,553,'Bholaganj Bazar S.O','793107',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138356,553,'Bishnupur B.O','793004',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138357,553,'Cherrabazar S.O','793111',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138358,553,'Cherrapunjee S.O','793108',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138359,553,'Dalia B.O','793112',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138360,553,'Dawki S.O','793109',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138361,553,'Dholai B.O','793106',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138362,553,'Diengiei B.O','793005',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138363,553,'Diengpasoh B.O','793012',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138364,553,'Disong B.O','793112',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138365,553,'Gumaghat B.O','793106',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138366,553,'Happy Valley S.O','793007',1,0,'2022-03-04 19:31:25','2022-03-04 19:31:25'),(138367,553,'Ichamati B.O','793112',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138368,553,'Iewduh S.O','793002',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138369,553,'Iewmawiong B.O','793110',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138370,553,'Jaiaw S.O','793002',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138371,553,'Jongksha B.O','793015',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138372,553,'Kalatak B.O','793112',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138373,553,'Kharang B.O','793015',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138374,553,'Khonjoy B.O','793106',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138375,553,'Kynton - U - Mon B.O','793021',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138376,553,'Kynton Massar B.O','793022',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138377,553,'Laban S.O','793004',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138378,553,'Ladmawphlang B.O','793111',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138379,553,'Laitduh B.O','793111',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138380,553,'Laitkor B.O','793010',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138381,553,'Laitkor Peak S.O','793010',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138382,553,'Laitkynsew B.O','793108',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138383,553,'Laitlyngkot B.O','793110',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138384,553,'Laitryngew B.O','793111',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138385,553,'Laitumkhrah S.O','793003',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138386,553,'Langkyrdem B.O','793110',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138387,553,'Lawbah B.O','793113',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138388,553,'Lawsohtun B.O','793004',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138389,553,'Lyngiong B.O','793121',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138390,553,'Lynshing B.O','793015',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138391,553,'Madan Bitaw B.O','793121',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138392,553,'Madanriting S.O','793021',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138393,553,'Mahadeo B.O','793108',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138394,553,'Makali B.O','793106',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138395,553,'Marbisu B.O','793121',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138396,553,'Mawbeh B.O','793110',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138397,553,'Mawblang B.O','793108',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138398,553,'Mawdongbazar B.O','793113',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138399,553,'Mawhiang B.O','793113',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138400,553,'Mawiong S.O','793016',1,0,'2022-03-04 19:31:26','2022-03-04 19:31:26'),(138401,553,'Mawkdok B.O','793111',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138402,553,'Mawkhanu B.O','793012',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138403,553,'Mawklot B.O','793009',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138404,553,'Mawkriah B.O','793121',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138405,553,'Mawkynrew B.O','793015',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138406,553,'Mawlai S.O','793017',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138407,553,'Mawlat B.O','793015',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138408,553,'Mawlong B.O','793015',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138409,553,'Mawlong B.O','793108',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138410,553,'Mawlyngngad B.O','793015',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138411,553,'Mawmluh B.O','793108',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138412,553,'Mawngap B.O','793121',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138413,553,'Mawpat S.O','793012',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138414,553,'Mawphlang S.O','793121',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138415,553,'Mawpun B.O','793121',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138416,553,'Mawput B.O','793106',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138417,553,'Mawreng B.O','793121',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138418,553,'Mawroh B.O','793008',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138419,553,'Mawryngkneng B.O','793021',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138420,553,'Mawsynram S.O','793113',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138421,553,'Mawtawar B.O','793022',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138422,553,'Meghalaya Secretariat S.O','793001',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138423,553,'Munai B.O','793106',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138424,553,'Myllat B.O','793110',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138425,553,'Mylliem Syllai U Lar B.O','793009',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138426,553,'Nehu S.O','793022',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138427,553,'Neigrihms S.O','793018',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138428,553,'Nongjri B.O','793110',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138429,553,'Nongkrem B.O','793015',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138430,553,'Nongkynrih B.O','793110',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138431,553,'Nonglyer S.O','793009',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138432,553,'Nongmynsong S.O','793019',1,0,'2022-03-04 19:31:27','2022-03-04 19:31:27'),(138433,553,'Nongspung B.O','793121',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138434,553,'Nongthymmai S.O','793014',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138435,553,'Nongumlong B.O','793005',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138436,553,'Oakland S.O','793001',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138437,553,'Pamora B.O','793021',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138438,553,'Phlang Mawsyrpat B.O','793113',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138439,553,'Phlangwanbroi B.O','793113',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138440,553,'Phudmawri S.O','793008',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138441,553,'Pomlakrai B.O','793010',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138442,553,'Pongkung B.O','793121',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138443,553,'Puriang B.O','793021',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138444,553,'Pyndeng Sohsaw B.O','793106',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138445,553,'Pynursla S.O','793110',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138446,553,'Ramdait B.O','793111',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138447,553,'Rangshken B.O','793121',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138448,553,'Rilbong S.O','793004',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138449,553,'Ryngibah B.O','793015',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138450,553,'Ryngkubazar B.O','793113',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138451,553,'Rynjah S.O','793006',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138452,553,'Shella S.O','793112',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138453,553,'Shillong G.P.O.','793001',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138454,553,'Smit S.O','793015',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138455,553,'Sohbarpunjee B.O','793108',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138456,553,'Sohiong B.O','793121',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138457,553,'Sohkmie B.O','793108',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138458,553,'Sohpian B.O','793121',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138459,553,'Sohryngkham B.O','793015',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138460,553,'Sonatola B.O','793106',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138461,553,'Sumer S.O','793104',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138462,553,'Syntein B.O','793113',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138463,553,'Telsora B.O','793106',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138464,553,'Thangsning B.O','793015',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138465,553,'Thyllaw B.O','793113',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138466,553,'Thynroit B.O','793015',1,0,'2022-03-04 19:31:28','2022-03-04 19:31:28'),(138467,553,'Trangpleng B.O','793106',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138468,553,'Tynger B.O','793113',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138469,553,'Tynring B.O','793012',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138470,553,'Tynrong B.O','793111',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138471,553,'Tyrna B.O','793108',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138472,553,'Tyrsad B.O','793121',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138473,553,'Umkdait B.O','793006',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138474,553,'Umniuh - Tmar B.O','793110',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138475,553,'Umphyrnai B.O','793015',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138476,553,'Umsning B.O','793015',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138477,553,'Umsyiem B.O','793109',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138478,553,'Upper Shillong S.O','793005',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138479,553,'Wahkdait B.O','793109',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138480,553,'Wahlong B.O','793108',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138481,553,'Wahshiarkhmut B.O','793110',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138482,553,'Weiloi B.O','793121',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138483,554,'Amlarem B.O','793150',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138484,554,'Amlari B.O','793109',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138485,554,'Barato B.O','793150',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138486,554,'Bataw B.O','793160',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138487,554,'Darrang B.O','793109',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138488,554,'Huroi B.O','793200',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138489,554,'Iawthymmai B.O','793150',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138490,554,'Jarain B.O','793150',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138491,554,'Jowai S.O','793150',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138492,554,'Khanduli B.O','793151',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138493,554,'Khatum B.O','793200',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138494,554,'Khliehriat S.O','793200',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138495,554,'Kyndong Tuber B.O','793150',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138496,554,'Ladrymbai S.O','793160',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138497,554,'Lamin B.O','793109',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138498,554,'Laskein B.O','793150',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138499,554,'Lumshnong B.O','793200',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138500,554,'Lumshnong S.O','793210',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138501,554,'Lyngkhat B.O','793109',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138502,554,'Mawbakhon B.O','793151',1,0,'2022-03-04 19:31:29','2022-03-04 19:31:29'),(138503,554,'Mawdymmai B.O','793151',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138504,554,'Mawkaiaw B.O','793150',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138505,554,'Mawkyndeng B.O','793150',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138506,554,'Mihmyntdu B.O','793150',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138507,554,'Mookynniang B.O','793151',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138508,554,'Mualsei B.O','793200',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138509,554,'Mukhialong B.O','793160',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138510,554,'Muktapur B.O','793109',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138511,554,'Mupyut B.O','793150',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138512,554,'Musniang B.O','793160',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138513,554,'Mustem B.O','793150',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138514,554,'Myndihati B.O','793200',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138515,554,'Mynso B.O','793150',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138516,554,'Naljuri B.O','793109',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138517,554,'Namdong B.O','793151',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138518,554,'Nartiang B.O','793151',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138519,554,'Nongbah B.O','793150',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138520,554,'Nongbareh B.O','793109',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138521,554,'Nongjngi B.O','793151',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138522,554,'Nongryngkoh B.O','793150',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138523,554,'Nongtalang B.O','793109',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138524,554,'Nongtyngur B.O','793109',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138525,554,'Padu B.O','793109',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138526,554,'Pala B.O','793200',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138527,554,'Pamshutia B.O','793109',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138528,554,'Passadwar B.O','793109',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138529,554,'Pdengshakap B.O','793150',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138530,554,'Pongtung B.O','793109',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138531,554,'Raliang B.O','793150',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138532,554,'Rata Cherra B.O','793200',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138533,554,'Rongkhum B.O','793109',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138534,554,'Rymbai B.O','793160',1,0,'2022-03-04 19:31:30','2022-03-04 19:31:30'),(138535,554,'Sahsniang B.O','793150',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138536,554,'Saipung B.O','793200',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138537,554,'Saitsama B.O','793151',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138538,554,'Sham Sham B.O','793160',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138539,554,'Shangpung B.O','793150',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138540,554,'Sheruphie B.O','793200',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138541,554,'Shnongrim B.O','793200',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138542,554,'Sohkha B.O','793109',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138543,554,'Sohkymphor B.O','793160',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138544,554,'Sohmynting B.O','793150',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138545,554,'Sonapur B.O','793200',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138546,554,'Sutnga B.O','793200',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138547,554,'Syndai B.O','793109',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138548,554,'Thadlaskein S.O','793151',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138549,554,'Thadmuthlong B.O','793150',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138550,554,'Thangbuli B.O','793150',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138551,554,'Thangrain B.O','793150',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138552,554,'Trangblang B.O','793150',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138553,554,'Tuber Kmaishnong B.O','793160',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138554,554,'Umkiang B.O','793200',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138555,554,'Umladang B.O','793151',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138556,554,'Ummulong B.O','793151',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138557,554,'Wahiajer B.O','793151',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138558,554,'Wapung B.O','793160',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138559,554,'Yalang B.O','793150',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138560,554,'Yooksi B.O','793150',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138561,555,'Barua Basti B.O','793104',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138562,555,'Bhoilymbong B.O','793103',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138563,555,'Byrnihat S.O','793101',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138564,555,'Epip Byrnihat B.O','793101',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138565,555,'Hatumling B.O','793102',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138566,555,'Jorabat B.O','793101',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138567,555,'Killing Centre B.O','793101',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138568,555,'Kynjoin Umran B.O','793102',1,0,'2022-03-04 19:31:31','2022-03-04 19:31:31'),(138569,555,'Kyrdem B.O','793103',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138570,555,'Kyrdem Kulai B.O','793105',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138571,555,'Lailad B.O','793102',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138572,555,'Marmain B.O','793102',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138573,555,'Marngar B.O','793102',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138574,555,'Mawbri B.O','793103',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138575,555,'Mawhati B.O','793105',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138576,555,'Mawlasnai B.O','793103',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138577,555,'Mawlong B.O','793102',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138578,555,'Mawrong B.O','793105',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138579,555,'Niangbari B.O','793102',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138580,555,'Nongladew B.O','793102',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138581,555,'Nongpoh S.O','793102',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138582,555,'Rongmen B.O','793103',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138583,555,'Saiden B.O','793102',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138584,555,'Sanidon B.O','793105',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138585,555,'Tamul Kuchi Gaon B.O','793101',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138586,555,'Ucc S.O','793122',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138587,555,'Umden B.O','793102',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138588,555,'Umdihar B.O','793102',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138589,555,'Umiam S.O','793103',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138590,555,'Umktieh B.O','793103',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138591,555,'Umran B.O','793105',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138592,555,'Umrit B.O','793102',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138593,555,'Umroi B.O','793103',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138594,555,'Umsaw S.O','793123',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138595,555,'Umsawnongbri B.O','793102',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138596,555,'Umshakhon Mathon B.O','793102',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138597,555,'Umsning S.O','793105',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138598,555,'Umsohlait B.O','793105',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138599,556,'Baghmara S.O','794102',1,0,'2022-03-04 19:31:32','2022-03-04 19:31:32'),(138600,556,'Balkhalbazar B.O','794102',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138601,556,'Balsalgiri B.O','794102',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138602,556,'Dambuk Agal B.O','794114',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138603,556,'Emangiri B.O','794102',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138604,556,'Mahesh Khola B.O','794114',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138605,556,'Mendikgiri B.O','794102',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138606,556,'Nilwalgiri B.O','794102',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138607,556,'Panda B.O','794102',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138608,556,'Rongra S.O','794114',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138609,556,'Siju B.O','794102',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138610,556,'Warimagiri B.O','794114',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138611,557,'Achigchonggiri B.O','794002',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138612,557,'Ampati S.O','794115',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138613,557,'Anugiri B.O','794002',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138614,557,'Araimile S.O','794101',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138615,557,'Bajengdoba B.O','794002',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138616,557,'Balunghat B.O','794106',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138617,557,'Bandelkona B.O','794115',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138618,557,'Barengapara S.O','794103',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138619,557,'Batabari B.O','794104',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138620,557,'Belguri B.O','794109',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138621,557,'Betsing B.O','794115',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138622,557,'Bhaitbari B.O','794104',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138623,557,'Bhajamara B.O','794104',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138624,557,'Bholarbhita B.O','794104',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138625,557,'Bolangitak B.O','794109',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138626,557,'Bolchugre B.O','794005',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138627,557,'Bolsong B.O','794002',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138628,557,'Borjhora B.O','794109',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138629,557,'Captain Reserve B.O','794101',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138630,557,'Chandabhui B.O','794103',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138631,557,'Chapahati B.O','794106',1,0,'2022-03-04 19:31:33','2022-03-04 19:31:33'),(138632,557,'Chati B.O','794103',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138633,557,'Chengapara B.O','794103',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138634,557,'Chokpotgiri B.O','794005',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138635,557,'Dadengiri B.O','794104',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138636,557,'Dakopgiri B.O','794101',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138637,557,'Damalgiri B.O','794105',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138638,557,'Dekubazar B.O','794005',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138639,557,'Dhopgiri B.O','794005',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138640,557,'Dimapara B.O','794103',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138641,557,'Dobasipara S.O','794005',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138642,557,'Edenbari Rongkhon B.O','794002',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138643,557,'Fulbari S.O (West Garo Hills)','794104',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138644,557,'Gabil B.O','794002',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138645,557,'Gachuapara B.O','794103',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138646,557,'Gambigre B.O','794005',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138647,557,'Ganchudari B.O','794103',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138648,557,'Garobadha S.O','794105',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138649,557,'Garodoba B.O','794105',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138650,557,'Gatsingbazar B.O','794104',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138651,557,'Gongrengiri B.O','794005',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138652,557,'Gopinath Killa B.O','794106',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138653,557,'Grenggandi Agal B.O','794105',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138654,557,'Gumaijhora B.O','794104',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138655,557,'Haldibari B.O','794105',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138656,557,'Halloidanga B.O','794109',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138657,557,'Haripur B.O','794104',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138658,557,'Hatugaon B.O','794109',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138659,557,'Holidayganj B.O','794104',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138660,557,'Jengrapara B.O','794109',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138661,557,'Jingjal B.O','794002',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138662,557,'Joshipara B.O','794103',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138663,557,'Kalaichar B.O','794115',1,0,'2022-03-04 19:31:34','2022-03-04 19:31:34'),(138664,557,'Kalaipara B.O','794106',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138665,557,'Kalchengapara B.O','794105',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138666,557,'Kapasipara B.O','794103',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138667,557,'Katuli B.O','794115',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138668,557,'Kawahagra B.O','794106',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138669,557,'Kharapara B.O','794103',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138670,557,'Killapara B.O','794103',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138671,557,'Lower Chandmari S.O','794002',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138672,557,'Mahendraganj S.O (West Garo Hills)','794106',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138673,557,'Majerchar B.O','794106',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138674,557,'Manlakandi B.O','794104',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138675,557,'Matchakgiri B.O','794002',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138676,557,'Mechanpani B.O','794104',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138677,557,'Melliam B.O','794105',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138678,557,'Mendal B.O','794002',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138679,557,'Mendipathar S.O','794112',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138680,557,'Mihanpara B.O','794103',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138681,557,'Monobari B.O','794105',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138682,557,'Mukhdangra B.O','794105',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138683,557,'Nangwalbibra S.O','794107',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138684,557,'New Bhaitbari B.O','794104',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138685,557,'Nogorpara B.O','794106',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138686,557,'Okkapara B.O','794105',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138687,557,'Paham B.O','794104',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138688,557,'Pedaldoba B.O','794109',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138689,557,'Photamati B.O','794109',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138690,557,'Purakhasia B.O','794103',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138691,557,'Rajabala B.O','794104',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138692,557,'Raksamgiri B.O','794109',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138693,557,'Raribazar B.O','794002',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138694,557,'Resubelpara S.O','794108',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138695,557,'Rimrangapara B.O','794103',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138696,557,'Rombazar B.O','794104',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138697,557,'Rongkhon B.O','794002',1,0,'2022-03-04 19:31:35','2022-03-04 19:31:35'),(138698,557,'Rongmatchokgiri B.O','794104',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138699,557,'Rongram B.O','794002',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138700,557,'Rongsakhona B.O','794105',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138701,557,'Sabribari B.O','794104',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138702,557,'Salmanpara B.O','794115',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138703,557,'Sasengpara B.O','794103',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138704,557,'Selsella B.O','794105',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138705,557,'Shankinigiri B.O','794005',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138706,557,'Shyamnagar B.O','794104',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138707,557,'Sibbari B.O','794103',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138708,557,'Silkhigiri B.O','794103',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138709,557,'Sulgre B.O','794115',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138710,557,'Teporpara B.O','794105',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138711,557,'Tikrikilla S.O','794109',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138712,557,'Tura H.O','794001',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138713,557,'Zekabari B.O','794105',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138714,557,'Zigzak B.O','794115',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138715,558,'Borsora B.O','793106',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138716,558,'Byrki B.O','793119',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138717,558,'Dungki - Ingdong B.O','793120',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138718,558,'Iewmaroid B.O','793120',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138719,558,'Jaidoh B.O','793119',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138720,558,'Jakrem B.O','793114',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138721,558,'Jashier B.O','793114',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138722,558,'Khlieh Lyngkhoi B.O','793120',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138723,558,'Khliehmawlieh B.O','793119',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138724,558,'Kynrut B.O','793120',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138725,558,'Kynshi B.O','793120',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138726,558,'Laitdombah B.O','793120',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138727,558,'Laitkseh B.O','793119',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138728,558,'Laitnongrim B.O','793114',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138729,558,'Langdongdai B.O','793119',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138730,558,'Langtor B.O','793120',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138731,558,'Lawbyrtun B.O','793120',1,0,'2022-03-04 19:31:36','2022-03-04 19:31:36'),(138732,558,'Lyngkhoi B.O','793120',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138733,558,'Madanbynther B.O','793120',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138734,558,'Mairang S.O','793120',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138735,558,'Manai B.O','793120',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138736,558,'Marskuin B.O','793119',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138737,558,'Maweitlyngngam B.O','793119',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138738,558,'Mawkarah B.O','793120',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138739,558,'Mawkohngei B.O','793119',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138740,558,'Mawkyrwat S.O','793114',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138741,558,'Mawlieh B.O','793119',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138742,558,'Mawlyngwir B.O','793114',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138743,558,'Mawsaw B.O','793114',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138744,558,'Mawshut B.O','793120',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138745,558,'Mawten B.O','793114',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138746,558,'Mawthapdoh B.O','793114',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138747,558,'Mawthengkut B.O','793119',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138748,558,'Mawthungkper B.O','793119',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138749,558,'Mawtiehbah B.O','793121',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138750,558,'Myriaw B.O','793120',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138751,558,'Ngunraw B.O','793114',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138752,558,'Nongbah B.O','793119',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138753,558,'Nongkasen B.O','793119',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138754,558,'Nongkhlaw B.O','793120',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138755,558,'Nonglang B.O','793114',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138756,558,'Nonglang B.O','793119',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138757,558,'Nongnah B.O','793106',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138758,558,'Nongpyndeng B.O','793119',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138759,558,'Nongsdad  Dkhar B.O','793119',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138760,558,'Nongshyrkon B.O','793119',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138761,558,'Nongstoin S.O','793119',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138762,558,'Nongsynrih B.O','793114',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138763,558,'Nongthliew B.O','793120',1,0,'2022-03-04 19:31:37','2022-03-04 19:31:37'),(138764,558,'Nongthynniew B.O','793119',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138765,558,'Nongum B.O','793120',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138766,558,'Pam Briew B.O','793119',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138767,558,'Pariong B.O','793120',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138768,558,'Phlang Kynshi B.O','793114',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138769,558,'Phlangdiloin B.O','793119',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138770,558,'Phudjaud B.O','793114',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138771,558,'Puksora B.O','793106',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138772,558,'Pyndemsakwang B.O','793114',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138773,558,'Pyndengrei B.O','793119',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138774,558,'Rambrai B.O','793119',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138775,558,'Rangblang B.O','793119',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138776,558,'Rangmaw B.O','793114',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138777,558,'Rangthong B.O','793114',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138778,558,'Ranikor B.O','793106',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138779,558,'Riangdo Bazar B.O','793119',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138780,558,'Rongasora B.O','793106',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138781,558,'Sarin B.O','793106',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138782,558,'Seinduli Bazar B.O','793119',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138783,558,'Shallang B.O','793119',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138784,558,'Sngimawlein B.O','793114',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138785,558,'Sohiong S.O','793115',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138786,558,'Thangpylleng Pyndemkseh B.O','793119',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138787,558,'Tihnongbah B.O','793120',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138788,558,'Umdohlun B.O','793119',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138789,558,'Umjarain B.O','793114',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138790,558,'Umkrem B.O','793120',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138791,558,'Umpung B.O','793106',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138792,558,'Umsohpieng B.O','793119',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138793,558,'Umthlong B.O','793120',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138794,558,'Umyap B.O','793119',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138795,558,'Wahkaji B.O','793119',1,0,'2022-03-04 19:31:38','2022-03-04 19:31:38'),(138796,559,'Aida B.O','759125',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138797,559,'Amabapal B.O','759126',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138798,559,'Ambasarmunda B.O','759125',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138799,559,'Angapada B.O','759126',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138800,559,'Angul H.O','759122',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138801,559,'Ankula B.O','759132',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138802,559,'Arahat B.O','759128',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138803,559,'Arkil B.O','759100',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138804,559,'Athamallik S.O','759125',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138805,559,'Badagundari B.O','759117',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138806,559,'Badajarada B.O','759103',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138807,559,'Badakantakul B.O','759129',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138808,559,'Badakera B.O','759132',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138809,559,'Badakhali B.O','759128',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138810,559,'Badasada B.O','759118',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138811,559,'Badatribida B.O','759117',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138812,559,'Badkerjang B.O','759143',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138813,559,'Bagedia S.O','759141',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138814,559,'Bajrakote B.O','759105',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138815,559,'Balanda S.O','759116',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138816,559,'Balanga B.O','759132',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138817,559,'Balaramprasad B.O','759128',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138818,559,'Balasinga B.O','759129',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138819,559,'Balipasi B.O','759105',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138820,559,'Balipatta B.O','759124',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138821,559,'Ballahar Chhak B.O','759104',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138822,559,'Baluakata B.O','759129',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138823,559,'Bamur B.O','759126',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138824,559,'Banarpal S.O','759128',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138825,559,'Bandhabhuin B.O','759119',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138826,559,'Bantala S.O','759129',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138827,559,'Baragounia B.O','759129',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138828,559,'Barasahi B.O','759141',1,0,'2022-03-04 19:31:39','2022-03-04 19:31:39'),(138829,559,'Barkotia B.O','759118',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138830,559,'Basala B.O','759129',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138831,559,'Basantapur B.O','759141',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138832,559,'Bedasasan B.O','759129',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138833,559,'Bhejigotha B.O','759125',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138834,559,'Bijigol B.O','759117',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138835,559,'Bileinali B.O','759125',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138836,559,'Bimalabeda B.O','759127',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138837,559,'Biru B.O','759100',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138838,559,'Bonda B.O','759128',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138839,559,'Brahmanbil B.O','759130',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138840,559,'Budhapanka B.O','759128',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138841,559,'Burukuna B.O','759100',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138842,559,'Chainpal Colony S.O','759104',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138843,559,'Champatimunda B.O','759132',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138844,559,'Changudia B.O','759130',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138845,559,'Chasagurjang B.O','759119',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138846,559,'Chhendipada S.O','759124',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138847,559,'Dandasinga B.O','759127',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138848,559,'Danra B.O','759103',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138849,559,'Deepasikha S.O','759147',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138850,559,'Dera S.O','759103',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138851,559,'Derang B.O','759117',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138852,559,'Deulbera Colliery S.O','759102',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138853,559,'Dharampur B.O','759100',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138854,559,'Dhokuta B.O','759129',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138855,559,'Dimiria B.O','759119',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138856,559,'Durgapur B.O','759127',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138857,559,'Durgapur B.O','759100',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138858,559,'Ekagharia B.O','759100',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138859,559,'Gaham B.O','759100',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138860,559,'Gandamala B.O','759105',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138861,559,'Garh Santiri B.O','759128',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138862,559,'Garh Taras B.O','759129',1,0,'2022-03-04 19:31:40','2022-03-04 19:31:40'),(138863,559,'Ghantapada B.O','759103',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138864,559,'Ghosar B.O','759126',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138865,559,'Gobara B.O','759103',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138866,559,'Golabandha B.O','759143',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138867,559,'Gopalprasad B.O','759103',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138868,559,'Gotamara B.O','759128',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138869,559,'Gurujang B.O','759100',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138870,559,'Hakimpada S.O','759143',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138871,559,'Hamamira B.O','759129',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138872,559,'Handapa B.O','759127',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41');
INSERT INTO `cities` VALUES (138873,559,'Handidhua B.O','759100',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138874,559,'Hensamul B.O','759103',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138875,559,'Himitira B.O','759126',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138876,559,'Hulurisinga S.O','759132',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138877,559,'Injidi B.O','759118',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138878,559,'Inkarabandha B.O','759129',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138879,559,'Jagannathpur B.O','759132',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138880,559,'Jagannathpur B.O','759104',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138881,559,'Jamardihi B.O','759119',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138882,559,'Jamudoli B.O','759125',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138883,559,'Jarada B.O','759127',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138884,559,'Jarada B.O','759117',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138885,559,'Jarapada B.O','759127',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138886,559,'Jarasingha B.O','759143',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138887,559,'Jeranga Dehuri Sahi B.O','759127',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138888,559,'Jharabeda B.O','759119',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138889,559,'Jindal Nagar S.O','759111',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138890,559,'Kadalimunda B.O','759126',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138891,559,'Kakudia B.O','759117',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138892,559,'Kalamchhuin B.O','759103',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138893,559,'Kalandapal B.O','759128',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138894,559,'Kalyanpur B.O','759126',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138895,559,'Kampala B.O','759125',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138896,559,'Kampsala B.O','759130',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138897,559,'Kanaloi B.O','759141',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138898,559,'Kandasar B.O','759145',1,0,'2022-03-04 19:31:41','2022-03-04 19:31:41'),(138899,559,'Kandhalo B.O','759100',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138900,559,'Kandhapada B.O','759125',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138901,559,'Kangula B.O','759132',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138902,559,'Kaniha S.O','759117',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138903,559,'Kankili B.O','759100',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138904,559,'Kansamunda B.O','759117',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138905,559,'Kantapada B.O','759125',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138906,559,'Kanteikolia B.O','759127',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138907,559,'Kantiapasi B.O','759100',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138908,559,'Karadagadia B.O','759132',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138909,559,'Karadapal B.O','759119',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138910,559,'Karnapur B.O','759103',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138911,559,'Katada B.O','759127',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138912,559,'Khalari B.O','759132',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138913,559,'Khalibereni B.O','759128',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138914,559,'Khamar S.O','759118',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138915,559,'Khandahatta B.O','759132',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138916,559,'Khemla B.O','759119',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138917,559,'Khinda B.O','759129',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138918,559,'Kiakata B.O','759126',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138919,559,'Kishoreganj S.O','759127',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138920,559,'Korada B.O','759127',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138921,559,'Kosala S.O','759130',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138922,559,'Kothabhuin B.O','759127',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138923,559,'Krutibaspur B.O','759125',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138924,559,'Kudugaon B.O','759125',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138925,559,'Kuio B.O','759123',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138926,559,'Kukudang B.O','759123',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138927,559,'Kukurpeta B.O','759124',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138928,559,'Kulad B.O','759145',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138929,559,'Kulei B.O','759146',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138930,559,'Kuluma B.O','759105',1,0,'2022-03-04 19:31:42','2022-03-04 19:31:42'),(138931,559,'Kumanda B.O','759143',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138932,559,'Kumunda B.O','759103',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138933,559,'Kumursinga B.O','759129',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138934,559,'Kunjam B.O','759118',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138935,559,'Kurudol B.O','759123',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138936,559,'Luhamunda B.O','759127',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138937,559,'Luhasinga B.O','759125',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138938,559,'Lunahandi B.O','759125',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138939,559,'Machhakuta B.O','759124',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138940,559,'Madhapur B.O','759125',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138941,559,'Maimura B.O','759125',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138942,559,'Manapur B.O','759129',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138943,559,'Munduribeda B.O','759118',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138944,559,'Nagaon B.O','759125',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138945,559,'Nagira B.O','759119',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138946,559,'Nakchi B.O','759126',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138947,559,'Nalam B.O','759117',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138948,559,'Nalconagar S.O','759145',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138949,559,'Nandapur B.O','759132',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138950,559,'Natada B.O','759123',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138951,559,'Nehru Satabdi Nagar(Bharatpu)r S.O','759148',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138952,559,'Nisha B.O','759130',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138953,559,'Nuagaon B.O','759141',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138954,559,'Nuahata B.O','759128',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138955,559,'Nuakheta B.O','759129',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138956,559,'Nuapada B.O','759124',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138957,559,'Odasha B.O','759118',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138958,559,'Oskapalli B.O','759126',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138959,559,'P.T.C.','Angul S.O',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138960,559,'Padmabatipur B.O','759103',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138961,559,'Paiksahi B.O','759125',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138962,559,'Pallahara S.O','759119',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138963,559,'Papsara B.O','759127',1,0,'2022-03-04 19:31:43','2022-03-04 19:31:43'),(138964,559,'Para B.O','759127',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138965,559,'Parabil B.O','759100',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138966,559,'Parang B.O','759143',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138967,559,'Paratara B.O','759132',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138968,559,'Patakumunda B.O','759141',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138969,559,'Patrapada B.O','759141',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138970,559,'Pedipathar B.O','759127',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138971,559,'Phapanda B.O','759119',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138972,559,'Pipalabahal B.O','759141',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138973,559,'Podagarh B.O','759105',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138974,559,'Podapada B.O','759124',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138975,559,'Poipal B.O','759117',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138976,559,'Pokatunga B.O','759129',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138977,559,'Puruna Manitiri B.O','759125',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138978,559,'Purunagarh B.O','759132',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138979,559,'Purunakote B.O','759132',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138980,559,'Radharamanpur B.O','759100',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138981,559,'Raijharan B.O','759130',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138982,559,'Rainali B.O','759125',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138983,559,'Rajdang B.O','759118',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138984,559,'Rajkishorenagar S.O','759126',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138985,559,'Raniakata B.O','759126',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138986,559,'Rantalei B.O','759132',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138987,559,'Rengali B.O','759105',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138988,559,'Rengali Dam Site S.O','759105',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138989,559,'Sahara Gurjang B.O','759119',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138990,559,'Saida B.O','759119',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138991,559,'Sakasingha B.O','759123',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138992,559,'Samal B.O','759100',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138993,559,'Samal Barrage Township S.O','759037',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138994,559,'Sanahulla B.O','759125',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138995,559,'Sanatribida B.O','759117',1,0,'2022-03-04 19:31:44','2022-03-04 19:31:44'),(138996,559,'Sanjamura B.O','759126',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(138997,559,'Sankapur B.O','759129',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(138998,559,'Sankhamur B.O','759118',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(138999,559,'Santarabandha B.O','759130',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139000,559,'Santhapada B.O','759104',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139001,559,'Sapoinali B.O','759141',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139002,559,'Saradhapur B.O','759132',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139003,559,'Saradhapur B.O','759100',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139004,559,'Seegarh B.O','759119',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139005,559,'Seepur B.O','759100',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139006,559,'Siarimalia B.O','759119',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139007,559,'Solada B.O','759103',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139008,559,'Tainsi B.O','759127',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139009,559,'Talagarh B.O','759129',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139010,559,'Talcher R.S. B.O','759100',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139011,559,'Talcher S.O','759100',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139012,559,'Talcher Thermal S.O','759101',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139013,559,'Talcher Town S.O','759107',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139014,559,'Talmul S.O','759040',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139015,559,'Tangiri B.O','759141',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139016,559,'Tapdhol B.O','759127',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139017,559,'Tentulei B.O','759103',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139018,559,'Tentuloi B.O','759124',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139019,559,'Thakurgarh B.O','759125',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139020,559,'Tikarapada B.O','759132',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139021,559,'Tubey B.O','759132',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139022,559,'Tukuda B.O','759127',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139023,559,'Tulasipal B.O','759128',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139024,559,'Turang B.O','759123',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139025,559,'Tusar B.O','759126',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139026,559,'Ugi B.O','759127',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139027,559,'Urukela B.O','759126',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139028,559,'Vikrampur S.O','759106',1,0,'2022-03-04 19:31:45','2022-03-04 19:31:45'),(139029,560,'Adabahal B.O','767066',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139030,560,'Agalapali B.O','767020',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139031,560,'Agalpur S.O','767022',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139032,560,'Alanda B.O','767033',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139033,560,'Ampali B.O','767032',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139034,560,'Ankriapadar B.O','767002',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139035,560,'Arjunda B.O','767016',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139036,560,'Arjunpur B.O','767067',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139037,560,'Atgaon B.O','767002',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139038,560,'B.Fatkara B.O','767002',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139039,560,'Badangomunda B.O','767030',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139040,560,'Badbahal B.O','767067',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139041,560,'Badbandh B.O','767029',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139042,560,'Badbanki B.O','767060',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139043,560,'Baddakala B.O','767038',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139044,560,'Badibahal B.O','767020',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139045,560,'Badimunda B.O','767020',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139046,560,'Badsaimara B.O','767037',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139047,560,'Badtika B.O','767020',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139048,560,'Bagdor B.O','767026',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139049,560,'Bagmund B.O','767025',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139050,560,'Bahabal B.O','767026',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139051,560,'Bahalpadar B.O','767002',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139052,560,'Baidipali B.O','767024',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139053,560,'Bairasar B.O','767016',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139054,560,'Bakti B.O','767021',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139055,560,'Balangir Court S.O','767001',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139056,560,'Balangir H.O','767001',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139057,560,'Balangir RS S.O','767001',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139058,560,'Balipata B.O','767025',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139059,560,'Bandhpara B.O','767029',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139060,560,'Baneimunda B.O','767025',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139061,560,'Banganmura S.O','767040',1,0,'2022-03-04 19:31:46','2022-03-04 19:31:46'),(139062,560,'Bankel B.O','767037',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139063,560,'Barbahal B.O','767027',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139064,560,'Barpadar B.O','767041',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139065,560,'Barpudigia B.O','767024',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139066,560,'Batharla B.O','767025',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139067,560,'Belgaon B.O','767032',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139068,560,'Belpara B.O','767040',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139069,560,'Belpara S.O','767026',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139070,560,'Bender B.O','767038',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139071,560,'Bendra B.O','767021',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139072,560,'Bhadra B.O','767032',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139073,560,'Bhainsa S.O (Balangir)','767048',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139074,560,'Bhaler B.O','767002',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139075,560,'Bhalumunda B.O','767040',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139076,560,'Bhanpur B.O','767028',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139077,560,'Bharsuja B.O','767061',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139078,560,'Bhatipara S.O','767042',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139079,560,'Bhundimuhan B.O','767048',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139080,560,'Bhusaguda B.O','767035',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139081,560,'Bhutiarbahal B.O','767029',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139082,560,'Bichhubahali B.O','767039',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139083,560,'Bidighat B.O','767024',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139084,560,'Bijepur B.O','767033',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139085,560,'Bileisarda B.O','767065',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139086,560,'Binekela B.O','767033',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139087,560,'Biripali B.O','767040',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139088,560,'Bubel B.O','767002',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139089,560,'Budhabahal B.O','767032',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139090,560,'Budhipadar B.O','767021',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139091,560,'Budula B.O','767022',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139092,560,'Burda B.O','767020',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139093,560,'Chalki B.O','767037',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139094,560,'Chandanbhati S.O','767065',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139095,560,'Chandotara B.O','767035',1,0,'2022-03-04 19:31:47','2022-03-04 19:31:47'),(139096,560,'Chantipala B.O','767033',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139097,560,'Chatuanka B.O','767039',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139098,560,'Chaulsukha B.O','767039',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139099,560,'Chhatamakhana B.O','767065',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139100,560,'Chhatapipal B.O','767002',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139101,560,'Chuliphunka B.O','767040',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139102,560,'Churapali S.O','767024',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139103,560,'College Square S.O (Balangir)','767002',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139104,560,'Dahimal B.O','767030',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139105,560,'Damaipali B.O','767027',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139106,560,'Damkipali B.O','767025',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139107,560,'Darlipali B.O','767027',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139108,560,'Daspur B.O','767002',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139109,560,'Dedarha B.O','767027',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139110,560,'Dedgaon B.O','767035',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139111,560,'Deng B.O','767032',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139112,560,'Deogaon S.O (Balangir)','767029',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139113,560,'Desandh B.O','767029',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139114,560,'Desil B.O','767033',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139115,560,'Deulgaon B.O','767041',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139116,560,'Deulgudi B.O','767030',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139117,560,'Dhamandanga B.O','767039',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139118,560,'Dhandamal B.O','767029',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139119,560,'Dhandamunda B.O','767028',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139120,560,'Dhanpur B.O','767046',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139121,560,'Dholmandal B.O','767038',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139122,560,'Duduka S.O','767061',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139123,560,'Dumabhata B.O','767026',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139124,560,'Dumerpita B.O','767048',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139125,560,'Dungripali S.O','767023',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139126,560,'Durgapali B.O','767065',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139127,560,'Fatkara B.O','767024',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139128,560,'Fulkimunda B.O','767038',1,0,'2022-03-04 19:31:48','2022-03-04 19:31:48'),(139129,560,'G.S. Dungripali B.O','767024',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139130,560,'Gaintala B.O','767002',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139131,560,'Gambhari B.O','767027',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139132,560,'Gandhi Nagar S.O (Balangir)','767001',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139133,560,'Gandpatrapali B.O','767032',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139134,560,'Gangasagar B.O','767025',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139135,560,'Ganrei B.O','767037',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139136,560,'Ghagurli B.O','767026',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139137,560,'Ghantabahali B.O','767033',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139138,560,'Ghasian B.O','767025',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139139,560,'Ghuna B.O','767046',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139140,560,'Ghunesh B.O','767038',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139141,560,'Ghunsar B.O','767028',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139142,560,'Ghunsar B.O','767032',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139143,560,'Goilbhadi B.O','767033',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139144,560,'Goimund B.O','767040',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139145,560,'Gourgoth B.O','767067',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139146,560,'Gudighat B.O','767037',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139147,560,'Gudvella S.O','767046',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139148,560,'Haldi B.O','767037',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139149,560,'Harisankar Road S.O','767038',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139150,560,'Hatpadapara S.O','767033',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139151,560,'Hirapur B.O','767020',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139152,560,'Ichhapara B.O','767037',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139153,560,'Jagua B.O','767066',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139154,560,'Jamgaon B.O','767002',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139155,560,'Jamkhunta B.O','767035',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139156,560,'Jamut B.O','767046',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139157,560,'Jarasingha S.O','767067',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139158,560,'Jhankarpali B.O','767065',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139159,560,'Jharial B.O','767040',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139160,560,'Jharnipali B.O','767061',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139161,560,'Jhinkidungri B.O','767026',1,0,'2022-03-04 19:31:49','2022-03-04 19:31:49'),(139162,560,'Jogimunda S.O','767027',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139163,560,'Jogisarda B.O','767020',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139164,560,'Juba B.O','767025',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139165,560,'Jurabandh B.O','767026',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139166,560,'K. Larambha B.O','767025',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139167,560,'Kamarlaga B.O','767032',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139168,560,'Kandajuri B.O','767020',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139169,560,'Kandhenjhula B.O','767027',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139170,560,'Kandhkelgaon B.O','767029',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139171,560,'Kantabanji Bazar S.O','767039',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139172,560,'Kantabanji S.O','767039',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139173,560,'Kanut B.O','767026',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139174,560,'Kapalabhata B.O','767040',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139175,560,'Kapani B.O','767026',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139176,560,'Kapsila B.O','767030',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139177,560,'Karamtala B.O','767032',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139178,560,'Katarkela B.O','767033',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139179,560,'Kendumundi B.O','767025',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139180,560,'Khagsa B.O','767039',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139181,560,'Khaira B.O','767040',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139182,560,'Khairmal B.O','767026',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139183,560,'Khaliapali B.O','767020',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139184,560,'Khalipathar B.O','767026',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139185,560,'Khaprakhol S.O','767028',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139186,560,'Kharjura B.O','767002',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139187,560,'Khasbahal B.O','767032',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139188,560,'Kholan S.O','767066',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139189,560,'Khujenbahali B.O','767039',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139190,560,'Khujenpali B.O','767002',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139191,560,'Khuntsamalei B.O','767025',1,0,'2022-03-04 19:31:50','2022-03-04 19:31:50'),(139192,560,'Kuanrgaon B.O','767032',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139193,560,'Kudasingha B.O','767029',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139194,560,'Kuibahal B.O','767060',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139195,560,'Kukurahad B.O','767039',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139196,560,'Kultapara B.O','767067',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139197,560,'Kumbhari B.O','767032',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139198,560,'Kursud B.O','767035',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139199,560,'Kurul B.O','767002',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139200,560,'Kusang B.O','767065',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139201,560,'Kushmel B.O','767065',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139202,560,'Kuskela B.O','767066',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139203,560,'Kutasingha B.O','767068',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139204,560,'Kutmunda B.O','767041',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139205,560,'Landapathar B.O','767029',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139206,560,'Lebda B.O','767033',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139207,560,'Lenjha B.O','767033',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139208,560,'Loisingha S.O','767020',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139209,560,'Luhasingha B.O','767027',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139210,560,'Luthurbandh B.O','767033',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139211,560,'Mahakhand B.O','767040',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139212,560,'Mahalei B.O','767067',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139213,560,'Maharapadar B.O','767028',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139214,560,'Mahimunda B.O','767002',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139215,560,'Mahulbahali B.O','767060',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139216,560,'Mahulpati B.O','767038',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139217,560,'Maingaon B.O','767033',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139218,560,'Makundpur B.O','767002',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139219,560,'Malisira B.O','767037',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139220,560,'Malmunda B.O','767002',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139221,560,'Malpara B.O','767038',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139222,560,'Mandal B.O','767026',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139223,560,'Manhira B.O','767020',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139224,560,'Manoharpur B.O','767002',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139225,560,'Marlad B.O','767066',1,0,'2022-03-04 19:31:51','2022-03-04 19:31:51'),(139226,560,'Marwari Bazar S.O','767001',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139227,560,'Matikhai B.O','767027',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139228,560,'Mayabarha B.O','767048',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139229,560,'Mirdhapali B.O','767065',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139230,560,'Mudghat B.O','767048',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139231,560,'Mundomahul B.O','767025',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139232,560,'Mundpadar B.O','767040',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139233,560,'Muribahal S.O','767037',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139234,560,'Mursingh B.O','767029',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139235,560,'Mursundhi B.O','767021',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139236,560,'Nagaon B.O','767022',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139237,560,'Nagaon B.O','767020',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139238,560,'Nandupala B.O','767028',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139239,560,'Naren B.O','767066',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139240,560,'Nuapara B.O','767030',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139241,560,'Of Badmal S.O','767070',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139242,560,'P.Rampur S.O','767041',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139243,560,'Padhel B.O','767025',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139244,560,'Padiabahal B.O','767028',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139245,560,'Pandamunda B.O','767027',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139246,560,'Pandesara B.O','767061',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139247,560,'Parasara B.O','767035',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139248,560,'Pardhiapali B.O','767020',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139249,560,'Patharla B.O','767002',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139250,560,'Patnagarh Bazar S.O','767025',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139251,560,'Patnagarh S.O','767025',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139252,560,'Patrapali B.O','767037',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139253,560,'Patuapali B.O','767021',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139254,560,'Phatamunda B.O','767025',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139255,560,'Pipirda B.O','767065',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139256,560,'Rajendra College S.O (Balangir)','767002',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139257,560,'Ramchandrapur B.O','767048',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139258,560,'Rampur B.O','767021',1,0,'2022-03-04 19:31:52','2022-03-04 19:31:52'),(139259,560,'Randa B.O','767002',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139260,560,'Rengali B.O','767022',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139261,560,'Rengali B.O','767024',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139262,560,'Rengali B.O','767028',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139263,560,'Rigdol B.O','767033',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139264,560,'Rinbachan B.O','767022',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139265,560,'Roth B.O','767061',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139266,560,'Rugudi Para S.O','767001',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139267,560,'Rusuda B.O','767067',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139268,560,'Sadeipali B.O','767065',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139269,560,'Sahajbahal B.O','767024',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139270,560,'Saintala S.O','767032',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139271,560,'Sakma B.O','767020',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139272,560,'Salandi B.O','767026',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139273,560,'Salebarat B.O','767035',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139274,560,'Salebhata S.O','767021',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139275,560,'Salemudga B.O','767060',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139276,560,'Salepali B.O','767067',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139277,560,'Samra B.O','767030',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139278,560,'Sanmula B.O','767040',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139279,560,'Sargad B.O','767020',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139280,560,'Sargul B.O','767039',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139281,560,'Sarmuhan B.O','767026',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139282,560,'Sauntput B.O','767065',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139283,560,'Sibtala B.O','767024',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139284,560,'Sihini B.O','767066',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139285,560,'Sikachhida B.O','767029',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139286,560,'Siker B.O','767033',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139287,560,'Sikuan B.O','767029',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139288,560,'Sindhekela S.O','767035',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139289,560,'Sirul B.O','767033',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139290,560,'Siskela B.O','767032',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139291,560,'Solbandh B.O','767025',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139292,560,'Sudpara S.O','767001',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139293,560,'Sulekela B.O','767026',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139294,560,'Sunamudi B.O','767038',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139295,560,'Sunamudi B.O','767041',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139296,560,'Taliudar B.O','767065',1,0,'2022-03-04 19:31:53','2022-03-04 19:31:53'),(139297,560,'Talpalipara S.O','767001',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139298,560,'Tamia B.O','767025',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139299,560,'Tandigaon B.O','767030',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139300,560,'Tankapani B.O','767038',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139301,560,'Telenpali B.O','767028',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139302,560,'Tendapadar B.O','767041',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139303,560,'Tentulikhunti B.O','767037',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139304,560,'Thelkomunda B.O','767016',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139305,560,'Tikrapara B.O','767026',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139306,560,'Tikrapara S.O','767001',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139307,560,'Titilagarh Bazar S.O','767033',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139308,560,'Titilagarh Court S.O','767033',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139309,560,'Titilagarh S.O','767033',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139310,560,'Titisilet B.O','767035',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139311,560,'Totopara B.O','767033',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139312,560,'Turekela S.O','767060',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139313,560,'Turla B.O','767028',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139314,560,'Tusra S.O','767030',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139315,560,'Udar B.O','767067',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139316,560,'Udiapali B.O','767028',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139317,560,'Ulba B.O','767041',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139318,560,'Uparjhar B.O','767067',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139319,561,'Achutipur B.O','756047',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139320,561,'Adangapantei B.O','756038',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139321,561,'Aghirapada B.O','756049',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139322,561,'Alalbindha B.O','756036',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139323,561,'Alalpur B.O','756086',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139324,561,'Alasuan B.O','756043',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139325,561,'Alumeda B.O','756027',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139326,561,'Amarda Road S.O','756030',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139327,561,'Ambadiha B.O','756034',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139328,561,'Ambapunja B.O','756027',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139329,561,'Ambliatha B.O','756086',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139330,561,'Anantapur S.O (Baleswar)','756046',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139331,561,'Angula B.O','756045',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139332,561,'Anko B.O','756028',1,0,'2022-03-04 19:31:54','2022-03-04 19:31:54'),(139333,561,'Arabandha B.O','756058',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139334,561,'Arjunpur B.O','756048',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139335,561,'Armala B.O','756019',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139336,561,'Aruhabad B.O','756044',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139337,561,'Aruhabruti B.O','756079',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139338,561,'Ashabandha B.O','756033',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139339,561,'Asti B.O','756026',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139340,561,'Asuria B.O','756047',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139341,561,'Attapur B.O','756045',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139342,561,'Ausha B.O','756037',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139343,561,'Avana S.O','756051',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139344,561,'Azimabad S.O','756001',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139345,561,'Badakuruda B.O','756024',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139346,561,'Badapal B.O','756019',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139347,561,'Badapokhari B.O','756047',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139348,561,'Badas B.O','756083',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139349,561,'Badasimulia B.O','756026',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139350,561,'Badasindhia B.O','756003',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139351,561,'Badhan B.O','756080',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139352,561,'Badhapal B.O','756026',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139353,561,'Bagada B.O','756083',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139354,561,'Bahabalpur B.O','756027',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139355,561,'Bahala B.O','756060',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139356,561,'Bahanaga S.O','756042',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139357,561,'Baharda B.O','756035',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139358,561,'Baharda Bazar B.O','756029',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139359,561,'Baiganabadia B.O','756079',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139360,561,'Bainanda Mangarajpur B.O','756045',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139361,561,'Baitpur B.O','756036',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139362,561,'Bajitpur B.O','756085',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139363,561,'Balanga B.O','756046',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139364,561,'Balaramgadi B.O','756025',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139365,561,'Balarampur B.O','756024',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139366,561,'Balasore Court S.O','756001',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139367,561,'Balasore H.O','756001',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139368,561,'Balasore RS S.O','756001',1,0,'2022-03-04 19:31:55','2022-03-04 19:31:55'),(139369,561,'Balia Farm B.O','756056',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139370,561,'Baliapal Katisahi B.O','756023',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139371,561,'Baliapal Narayanpur B.O','756083',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139372,561,'Baliapal S.O','756026',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139373,561,'Baliapati B.O','756081',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139374,561,'Balim B.O','756035',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139375,561,'Bamada B.O','756028',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139376,561,'Bana Bishnupur B.O','756047',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139377,561,'Bankeswar B.O','756021',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139378,561,'Barabati S.O','756003',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139379,561,'Barada B.O','756022',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139380,561,'Baradiha B.O','756033',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139381,561,'Barahapur B.O','756046',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139382,561,'Barbatia B.O','756079',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139383,561,'Barbatia Bazar B.O','756039',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139384,561,'Bardhanpur B.O','756021',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139385,561,'Bartana B.O','756086',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139386,561,'Bartana B.O','756038',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139387,561,'Barun Singh B.O','756060',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139388,561,'Barunagadia B.O','756029',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139389,561,'Basta S.O','756029',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139390,561,'Batagramghat B.O','756036',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139391,561,'Baunsadiha B.O','756035',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139392,561,'Begunia B.O','756020',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139393,561,'Beladandia B.O','756023',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139394,561,'Belda B.O','756035',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139395,561,'Belli B.O','756023',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139396,561,'Betagadia B.O','756083',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139397,561,'Bhandarikuli B.O','756033',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139398,561,'Bhimpur B.O','756021',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139399,561,'Bhimpura B.O','756003',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139400,561,'Bhograi S.O','756038',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139401,561,'Bhounriabad B.O','756020',1,0,'2022-03-04 19:31:56','2022-03-04 19:31:56'),(139402,561,'Bichitrapur B.O','756037',1,0,'2022-03-04 19:31:57','2022-03-04 19:31:57'),(139403,561,'Bidubazar B.O','756042',1,0,'2022-03-04 19:31:57','2022-03-04 19:31:57'),(139404,561,'Bidyadharpur B.O','756029',1,0,'2022-03-04 19:31:57','2022-03-04 19:31:57'),(139405,561,'Bishnupur B.O','756026',1,0,'2022-03-04 19:31:57','2022-03-04 19:31:57'),(139406,561,'Bishnupur B.O','756051',1,0,'2022-03-04 19:31:57','2022-03-04 19:31:57'),(139407,561,'Boita B.O','756043',1,0,'2022-03-04 19:31:57','2022-03-04 19:31:57'),(139408,561,'Bolang B.O','756024',1,0,'2022-03-04 19:31:57','2022-03-04 19:31:57'),(139409,561,'Buanl B.O','756027',1,0,'2022-03-04 19:31:57','2022-03-04 19:31:57'),(139410,561,'Budhakusumi B.O','756034',1,0,'2022-03-04 19:31:57','2022-03-04 19:31:57'),(139411,561,'Chakabarahapur S.O','756055',1,0,'2022-03-04 19:31:57','2022-03-04 19:31:57'),(139412,561,'Chakaisab B.O','756035',1,0,'2022-03-04 19:31:57','2022-03-04 19:31:57'),(139413,561,'Chakajagannathpur B.O','756043',1,0,'2022-03-04 19:31:57','2022-03-04 19:31:57'),(139414,561,'Chakajagannathpur B.O','756003',1,0,'2022-03-04 19:31:57','2022-03-04 19:31:57'),(139415,561,'Chakrada B.O','756022',1,0,'2022-03-04 19:31:57','2022-03-04 19:31:57'),(139416,561,'Chaksartha B.O','756027',1,0,'2022-03-04 19:31:57','2022-03-04 19:31:57'),(139417,561,'Chalanti B.O','756086',1,0,'2022-03-04 19:31:58','2022-03-04 19:31:58'),(139418,561,'Chamara Gaon B.O','756086',1,0,'2022-03-04 19:31:58','2022-03-04 19:31:58'),(139419,561,'Chandakusumi B.O','756035',1,0,'2022-03-04 19:31:58','2022-03-04 19:31:58'),(139420,561,'Chandamani B.O','756083',1,0,'2022-03-04 19:31:58','2022-03-04 19:31:58'),(139421,561,'Chandaneswar S.O','756085',1,0,'2022-03-04 19:31:58','2022-03-04 19:31:58'),(139422,561,'Chandipur S.O','756025',1,0,'2022-03-04 19:31:58','2022-03-04 19:31:58'),(139423,561,'Chasakhand B.O','756003',1,0,'2022-03-04 19:31:58','2022-03-04 19:31:58'),(139424,561,'Chasipada B.O','756030',1,0,'2022-03-04 19:31:58','2022-03-04 19:31:58'),(139425,561,'Chaumukh B.O','756083',1,0,'2022-03-04 19:31:58','2022-03-04 19:31:58'),(139426,561,'Chhamouza B.O','756086',1,0,'2022-03-04 19:31:58','2022-03-04 19:31:58'),(139427,561,'Chhanapur B.O','756056',1,0,'2022-03-04 19:31:58','2022-03-04 19:31:58'),(139428,561,'Chhanua B.O','756027',1,0,'2022-03-04 19:31:58','2022-03-04 19:31:58'),(139429,561,'Chhatrapur B.O','756058',1,0,'2022-03-04 19:31:58','2022-03-04 19:31:58'),(139430,561,'Chinchlagadia B.O','756030',1,0,'2022-03-04 19:31:58','2022-03-04 19:31:58'),(139431,561,'Chormara B.O','756086',1,0,'2022-03-04 19:31:58','2022-03-04 19:31:58'),(139432,561,'Chudamanipur B.O','756033',1,0,'2022-03-04 19:31:58','2022-03-04 19:31:58'),(139433,561,'Dagarpada B.O','756047',1,0,'2022-03-04 19:31:58','2022-03-04 19:31:58'),(139434,561,'Dagra B.O','756083',1,0,'2022-03-04 19:31:58','2022-03-04 19:31:58'),(139435,561,'Dahamunda S.O','756079',1,0,'2022-03-04 19:31:58','2022-03-04 19:31:58'),(139436,561,'Dahapada B.O','756003',1,0,'2022-03-04 19:31:58','2022-03-04 19:31:58'),(139437,561,'Dahisada B.O','756045',1,0,'2022-03-04 19:31:58','2022-03-04 19:31:58'),(139438,561,'Dahunda B.O','756035',1,0,'2022-03-04 19:31:58','2022-03-04 19:31:58'),(139439,561,'Dakhinanadbani B.O','756035',1,0,'2022-03-04 19:31:58','2022-03-04 19:31:58'),(139440,561,'Dalanga B.O','756047',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139441,561,'Dalua B.O','756026',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139442,561,'Dandika B.O','756029',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139443,561,'Dangapita B.O','756083',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139444,561,'Darada S.O','756022',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139445,561,'Darkholi B.O','756049',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139446,561,'Debhog B.O','756023',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139447,561,'Dehurda S.O','756036',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139448,561,'Demuria B.O','756034',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139449,561,'Deulahat B.O','756036',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139450,561,'Dhansimulia S.O','756084',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139451,561,'Dharaganj B.O','756020',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139452,561,'Dhitpura B.O','756030',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139453,561,'Dhobachakurai B.O','756029',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139454,561,'Dhobasila B.O','756040',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139455,561,'Digdha B.O','756027',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139456,561,'Dublagadi B.O','756027',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139457,561,'Dubsahi B.O','756035',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139458,561,'Dundukut B.O','756081',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139459,561,'Durgadevi B.O','756020',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139460,561,'Durpal B.O','756035',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139461,561,'Dwarika B.O','756044',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139462,561,'Fakirmohan College S.O','756001',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139463,561,'Fatehpur B.O','756048',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139464,561,'Fulbani S.O','756037',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139465,561,'Fulwar-kaswa B.O','756003',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139466,561,'Gadasahi Baliapal B.O','756023',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139467,561,'Gandasthapur B.O','756042',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139468,561,'Gandibed B.O','756047',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139469,561,'Garadihi B.O','756041',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139470,561,'Genguti B.O','756056',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139471,561,'Ghantiary B.O','756026',1,0,'2022-03-04 19:31:59','2022-03-04 19:31:59'),(139472,561,'Ghantua B.O','756023',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139473,561,'Ghasua B.O','756055',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139474,561,'Ghodapada B.O','756003',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139475,561,'Gilajodi B.O','756081',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139476,561,'Gobindpur B.O','756019',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139477,561,'Gop B.O','756086',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139478,561,'Gopalpur B.O','756041',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139479,561,'Gopalpur S.O (Balasore)','756044',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139480,561,'Gopinathpur B.O','756036',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139481,561,'Gopinathpur B.O','756030',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139482,561,'Guapal B.O','756059',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139483,561,'Gud B.O','756046',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139484,561,'Gudikhal B.O','756030',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139485,561,'Gududapatna B.O','756019',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139486,561,'Gudupai B.O','756025',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139487,561,'Guneibasan B.O','756036',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139488,561,'Haladiapada B.O','756029',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139489,561,'Haldipada S.O','756027',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139490,561,'Haridaspur B.O','756036',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139491,561,'Haripur B.O','756003',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139492,561,'Hatiadiha B.O','756028',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139493,561,'Hatigarh S.O (Baleswar)','756033',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139494,561,'Hatikhulia B.O','756045',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139495,561,'Hatsahi B.O','756040',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139496,561,'Hidigaon B.O','756025',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139497,561,'Ikida B.O','756034',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139498,561,'Inchudi B.O','756021',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139499,561,'Irda S.O','756080',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139500,561,'Issannagar S.O','756001',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139501,561,'Iswarpur B.O','756038',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139502,561,'Iswarpur B.O','756042',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139503,561,'Jadibali B.O','756041',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139504,561,'Jagai B.O','756083',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139505,561,'Jagannathpur B.O','756044',1,0,'2022-03-04 19:32:00','2022-03-04 19:32:00'),(139506,561,'Jagannathpur Bachhada B.O','756046',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139507,561,'Jageswarpada B.O','756044',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139508,561,'Jaleswar H.O','756032',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139509,561,'Jaleswar Railway Station S.O','756086',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139510,561,'Jaleswarpur B.O','756036',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139511,561,'Jamalpur B.O','756029',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139512,561,'Jamalpur B.O','756086',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139513,561,'Jamatkula B.O','756083',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139514,561,'Jambhirai B.O','756024',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139515,561,'Jamkunda B.O','756026',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139516,561,'Jamsuli S.O','756081',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139517,561,'Jamudiha B.O','756041',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139518,561,'Jamuna B.O','756058',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139519,561,'Janhia B.O','756045',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139520,561,'Januganj B.O','756019',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139521,561,'Jathia B.O','756023',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139522,561,'Jayarampur B.O','756038',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139523,561,'Jaydev Kasba B.O','756021',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139524,561,'Jharapimpal B.O','756026',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139525,561,'Jhinkiria B.O','756027',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139526,561,'Jirtal B.O','756043',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139527,561,'Kabataghati B.O','756033',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139528,561,'Kachuadi B.O','756035',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139529,561,'Kahalia B.O','756040',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139530,561,'Kainagari B.O','756080',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139531,561,'Kaithagadia B.O','756059',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139532,561,'Kakhra S.O','756039',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139533,561,'Kalakad B.O','756041',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139534,561,'Kalama B.O','756033',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139535,561,'Kalyani B.O','756044',1,0,'2022-03-04 19:32:01','2022-03-04 19:32:01'),(139536,561,'Kamarda S.O','756035',1,0,'2022-03-04 19:32:02','2022-03-04 19:32:02'),(139537,561,'Kamarsalia B.O','756034',1,0,'2022-03-04 19:32:02','2022-03-04 19:32:02'),(139538,561,'Kandagaridi B.O','756042',1,0,'2022-03-04 19:32:02','2022-03-04 19:32:02'),(139539,561,'Kankei B.O','756033',1,0,'2022-03-04 19:32:02','2022-03-04 19:32:02'),(139540,561,'Kanrali B.O','756019',1,0,'2022-03-04 19:32:02','2022-03-04 19:32:02'),(139541,561,'Kans B.O','756020',1,0,'2022-03-04 19:32:02','2022-03-04 19:32:02'),(139542,561,'Karanja B.O','756083',1,0,'2022-03-04 19:32:02','2022-03-04 19:32:02'),(139543,561,'Karanjabindha B.O','756044',1,0,'2022-03-04 19:32:02','2022-03-04 19:32:02'),(139544,561,'Karihanda B.O','756035',1,0,'2022-03-04 19:32:02','2022-03-04 19:32:02'),(139545,561,'Kasba Jaipur B.O','756043',1,0,'2022-03-04 19:32:02','2022-03-04 19:32:02'),(139546,561,'Kashafal B.O','756024',1,0,'2022-03-04 19:32:02','2022-03-04 19:32:02'),(139547,561,'Kashimpur B.O','756019',1,0,'2022-03-04 19:32:02','2022-03-04 19:32:02'),(139548,561,'Kasida B.O','756034',1,0,'2022-03-04 19:32:02','2022-03-04 19:32:02'),(139549,561,'Kedarpur B.O','756045',1,0,'2022-03-04 19:32:02','2022-03-04 19:32:02'),(139550,561,'Kesharipur B.O','756045',1,0,'2022-03-04 19:32:02','2022-03-04 19:32:02'),(139551,561,'Keshpura B.O','756086',1,0,'2022-03-04 19:32:02','2022-03-04 19:32:02'),(139552,561,'Khadikapada B.O','756029',1,0,'2022-03-04 19:32:02','2022-03-04 19:32:02'),(139553,561,'Khaira S.O (Baleswar)','756048',1,0,'2022-03-04 19:32:02','2022-03-04 19:32:02'),(139554,561,'Khairagobindapur B.O','756049',1,0,'2022-03-04 19:32:02','2022-03-04 19:32:02'),(139555,561,'Khairda B.O','756035',1,0,'2022-03-04 19:32:03','2022-03-04 19:32:03'),(139556,561,'Khalabadia B.O','756038',1,0,'2022-03-04 19:32:03','2022-03-04 19:32:03'),(139557,561,'Khalamuhani B.O','756023',1,0,'2022-03-04 19:32:03','2022-03-04 19:32:03'),(139558,561,'Khalina B.O','756034',1,0,'2022-03-04 19:32:03','2022-03-04 19:32:03'),(139559,561,'Khan Nagar B.O','756060',1,0,'2022-03-04 19:32:03','2022-03-04 19:32:03'),(139560,561,'Khanabad B.O','756033',1,0,'2022-03-04 19:32:03','2022-03-04 19:32:03'),(139561,561,'Khantapada S.O','756043',1,0,'2022-03-04 19:32:03','2022-03-04 19:32:03'),(139562,561,'Kharadiha B.O','756041',1,0,'2022-03-04 19:32:03','2022-03-04 19:32:03'),(139563,561,'Kharsahapur B.O','756046',1,0,'2022-03-04 19:32:03','2022-03-04 19:32:03'),(139564,561,'Khirachora Gopinath B.O','756019',1,0,'2022-03-04 19:32:04','2022-03-04 19:32:04'),(139565,561,'Khuard B.O','756033',1,0,'2022-03-04 19:32:04','2022-03-04 19:32:04'),(139566,561,'Khuluda B.O','756034',1,0,'2022-03-04 19:32:04','2022-03-04 19:32:04'),(139567,561,'Kishorchandrapur B.O','756058',1,0,'2022-03-04 19:32:04','2022-03-04 19:32:04'),(139568,561,'Kochiakoili B.O','756042',1,0,'2022-03-04 19:32:04','2022-03-04 19:32:04'),(139569,561,'Kothapada B.O','756022',1,0,'2022-03-04 19:32:04','2022-03-04 19:32:04'),(139570,561,'Kothia B.O','756022',1,0,'2022-03-04 19:32:04','2022-03-04 19:32:04'),(139571,561,'Kotisahi B.O','756035',1,0,'2022-03-04 19:32:04','2022-03-04 19:32:04'),(139572,561,'Kuanrpur B.O','756021',1,0,'2022-03-04 19:32:05','2022-03-04 19:32:05'),(139573,561,'Kudei Nadigaon B.O','756045',1,0,'2022-03-04 19:32:05','2022-03-04 19:32:05'),(139574,561,'Kuldiha B.O','756030',1,0,'2022-03-04 19:32:05','2022-03-04 19:32:05'),(139575,561,'Kuligaon B.O','756043',1,0,'2022-03-04 19:32:05','2022-03-04 19:32:05'),(139576,561,'Kumarjalina B.O','756036',1,0,'2022-03-04 19:32:05','2022-03-04 19:32:05'),(139577,561,'Kumarmuli B.O','756036',1,0,'2022-03-04 19:32:05','2022-03-04 19:32:05'),(139578,561,'Kumarpur B.O','756046',1,0,'2022-03-04 19:32:05','2022-03-04 19:32:05'),(139579,561,'Kumbhari B.O','756023',1,0,'2022-03-04 19:32:05','2022-03-04 19:32:05'),(139580,561,'Kupari S.O','756059',1,0,'2022-03-04 19:32:05','2022-03-04 19:32:05'),(139581,561,'Kuruda S.O','756056',1,0,'2022-03-04 19:32:05','2022-03-04 19:32:05'),(139582,561,'Kuruda-soro B.O','756046',1,0,'2022-03-04 19:32:05','2022-03-04 19:32:05'),(139583,561,'Kurunta B.O','756047',1,0,'2022-03-04 19:32:05','2022-03-04 19:32:05'),(139584,561,'Kushadiha (A) B.O','756029',1,0,'2022-03-04 19:32:05','2022-03-04 19:32:05'),(139585,561,'Kushadiha (B)church B.O','756029',1,0,'2022-03-04 19:32:05','2022-03-04 19:32:05'),(139586,561,'Kusuda B.O','756035',1,0,'2022-03-04 19:32:05','2022-03-04 19:32:05'),(139587,561,'Lachman Khunta B.O','756028',1,0,'2022-03-04 19:32:05','2022-03-04 19:32:05'),(139588,561,'Lakhananath B.O','756086',1,0,'2022-03-04 19:32:05','2022-03-04 19:32:05'),(139589,561,'Lakhananath Road B.O','756086',1,0,'2022-03-04 19:32:05','2022-03-04 19:32:05'),(139590,561,'Machhada B.O','756080',1,0,'2022-03-04 19:32:05','2022-03-04 19:32:05'),(139591,561,'Machhadiha B.O','756029',1,0,'2022-03-04 19:32:05','2022-03-04 19:32:05'),(139592,561,'Machharanka Simulia B.O','756023',1,0,'2022-03-04 19:32:05','2022-03-04 19:32:05'),(139593,561,'Machhua B.O','756020',1,0,'2022-03-04 19:32:06','2022-03-04 19:32:06'),(139594,561,'Madhupura B.O','756035',1,0,'2022-03-04 19:32:06','2022-03-04 19:32:06'),(139595,561,'Mahagab B.O','756035',1,0,'2022-03-04 19:32:06','2022-03-04 19:32:06'),(139596,561,'Maharudrapur B.O','756044',1,0,'2022-03-04 19:32:06','2022-03-04 19:32:06'),(139597,561,'Mahatipur B.O','756048',1,0,'2022-03-04 19:32:06','2022-03-04 19:32:06'),(139598,561,'Mahispata B.O','756020',1,0,'2022-03-04 19:32:06','2022-03-04 19:32:06'),(139599,561,'Mahu Muhana B.O','756045',1,0,'2022-03-04 19:32:06','2022-03-04 19:32:06'),(139600,561,'Mahuduma B.O','756033',1,0,'2022-03-04 19:32:06','2022-03-04 19:32:06'),(139601,561,'Makalpur S.O','756003',1,0,'2022-03-04 19:32:06','2022-03-04 19:32:06'),(139602,561,'Makhanpur B.O','756047',1,0,'2022-03-04 19:32:06','2022-03-04 19:32:06'),(139603,561,'Malaruan B.O','756038',1,0,'2022-03-04 19:32:06','2022-03-04 19:32:06'),(139604,561,'Malipal B.O','756086',1,0,'2022-03-04 19:32:06','2022-03-04 19:32:06'),(139605,561,'Mandhatabazar B.O','756024',1,0,'2022-03-04 19:32:06','2022-03-04 19:32:06'),(139606,561,'Mandrukula B.O','756029',1,0,'2022-03-04 19:32:06','2022-03-04 19:32:06'),(139607,561,'Mangalapur B.O','756045',1,0,'2022-03-04 19:32:06','2022-03-04 19:32:06'),(139608,561,'Manikula B.O','756002',1,0,'2022-03-04 19:32:06','2022-03-04 19:32:06'),(139609,561,'Manipur B.O','756047',1,0,'2022-03-04 19:32:07','2022-03-04 19:32:07'),(139610,561,'Mankidia B.O','756033',1,0,'2022-03-04 19:32:07','2022-03-04 19:32:07'),(139611,561,'Mankunda B.O','756036',1,0,'2022-03-04 19:32:07','2022-03-04 19:32:07'),(139612,561,'Masanbaria B.O','756034',1,0,'2022-03-04 19:32:07','2022-03-04 19:32:07'),(139613,561,'Mathani B.O','756029',1,0,'2022-03-04 19:32:07','2022-03-04 19:32:07'),(139614,561,'Mathuranath B.O','756086',1,0,'2022-03-04 19:32:07','2022-03-04 19:32:07'),(139615,561,'Matiali B.O','756041',1,0,'2022-03-04 19:32:07','2022-03-04 19:32:07'),(139616,561,'Mirigini B.O','756040',1,0,'2022-03-04 19:32:07','2022-03-04 19:32:07'),(139617,561,'Mitrapur S.O','756020',1,0,'2022-03-04 19:32:07','2022-03-04 19:32:07'),(139618,561,'Mituani B.O','756048',1,0,'2022-03-04 19:32:07','2022-03-04 19:32:07'),(139619,561,'Mobarakpur S.O','756045',1,0,'2022-03-04 19:32:07','2022-03-04 19:32:07'),(139620,561,'Mohammad Nagar B.O','756030',1,0,'2022-03-04 19:32:07','2022-03-04 19:32:07'),(139621,561,'Mohammad Nagarpatna B.O','756086',1,0,'2022-03-04 19:32:07','2022-03-04 19:32:07'),(139622,561,'Motiganj S.O (Baleswar)','756003',1,0,'2022-03-04 19:32:07','2022-03-04 19:32:07'),(139623,561,'Mukulisi B.O','756022',1,0,'2022-03-04 19:32:07','2022-03-04 19:32:07'),(139624,561,'Mulisingh B.O','756045',1,0,'2022-03-04 19:32:07','2022-03-04 19:32:07'),(139625,561,'Munutunia B.O','756033',1,0,'2022-03-04 19:32:07','2022-03-04 19:32:07'),(139626,561,'Nabra B.O','756081',1,0,'2022-03-04 19:32:07','2022-03-04 19:32:07'),(139627,561,'Nachhipur B.O','756048',1,0,'2022-03-04 19:32:07','2022-03-04 19:32:07'),(139628,561,'Nachinda B.O','756035',1,0,'2022-03-04 19:32:07','2022-03-04 19:32:07'),(139629,561,'Nachinta B.O','756043',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139630,561,'Nadbani B.O','756024',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139631,561,'Nafrai B.O','756037',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139632,561,'Nagram B.O','756027',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139633,561,'Nahanga B.O','756059',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139634,561,'Naikudi B.O','756081',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139635,561,'Nalabahar B.O','756028',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139636,561,'Nampo S.O','756034',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139637,561,'Nangaleswar S.O','756024',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139638,561,'Naraharipur B.O','756019',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139639,561,'Naranmohantypadia B.O','756037',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139640,561,'Narasingpur B.O','756020',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139641,561,'Narayanapur B.O','756041',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139642,561,'Narayanpur B.O','756036',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139643,561,'Naskarpur B.O','756085',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139644,561,'Nayabazar Balasore S.O','756001',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139645,561,'Nayabazar Jaleswar S.O','756032',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139646,561,'Nayapalli B.O','756079',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139647,561,'Nepura B.O','756023',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139648,561,'Netua B.O','756084',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139649,561,'Nijampur B.O','756003',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139650,561,'Nikhira B.O','756023',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139651,561,'Nilgiri College S.O','756040',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139652,561,'Nilpura B.O','756079',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139653,561,'Nimatpur B.O','756036',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139654,561,'Nimpada B.O','756080',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139655,561,'Nimpal B.O','756020',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139656,561,'Nishanpur B.O','756036',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139657,561,'Nuagaon B.O','756028',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139658,561,'Nuagaon B.O','756024',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139659,561,'Nuapadhi B.O','756020',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139660,561,'Odangi B.O','756027',1,0,'2022-03-04 19:32:08','2022-03-04 19:32:08'),(139661,561,'Olipur B.O','756027',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139662,561,'Olmara B.O','756033',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139663,561,'Oupada S.O','756049',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139664,561,'Padagaon B.O','756043',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139665,561,'Padhuan B.O','756046',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139666,561,'Paiksida B.O','756086',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139667,561,'Pakhar B.O','756046',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139668,561,'Panasha B.O','756080',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139669,561,'Panchupada B.O','756027',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139670,561,'Panchupalli B.O','756024',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139671,561,'Panchurukhi B.O','756026',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139672,561,'Pandasuni B.O','756044',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139673,561,'Pandurangi B.O','756029',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139674,561,'Pani Chhatra B.O','756059',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139675,561,'Panjibag B.O','756002',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139676,561,'Panpana B.O','756043',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139677,561,'Parkhi B.O','756025',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139678,561,'Pasarbindha B.O','756036',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139679,561,'Paschima Bad B.O','756026',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139680,561,'Patna B.O','756020',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139681,561,'Paunsakuli B.O','756081',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139682,561,'Pithahat B.O','756058',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139683,561,'Pithapur B.O','756038',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139684,561,'Podasul B.O','756040',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139685,561,'Pratapada B.O','756043',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139686,561,'Pratappur S.O (Baleswar)','756083',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139687,561,'Pundala B.O','756020',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139688,561,'Puruna Balasore B.O','756002',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139689,561,'Purusottampur B.O','756035',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139690,561,'Putina B.O','756035',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139691,561,'Putura B.O','756081',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139692,561,'Radhaballavpur B.O','756045',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139693,561,'Rahaniaganj B.O','756044',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139694,561,'Raibania B.O','756033',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139695,561,'Rairamchandrapur B.O','756048',1,0,'2022-03-04 19:32:09','2022-03-04 19:32:09'),(139696,561,'Rairamchandrapur B.O','756086',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139697,561,'Raj Berhampur S.O','756058',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139698,561,'Raj Nilgiri S.O','756040',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139699,561,'Rajpur B.O','756086',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139700,561,'Ranasahi B.O','756002',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139701,561,'Rasalpur B.O','756038',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139702,561,'Rasalpur B.O','756079',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139703,561,'Rasalpur S.O','756021',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139704,561,'Rasaslpur B.O','756020',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139705,561,'Rella B.O','756026',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139706,561,'Remu B.O','756081',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139707,561,'Remuna S.O','756019',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139708,561,'Reserve Police Line B.O','756003',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139709,561,'Routpada B.O','756028',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139710,561,'Rupkhand B.O','756051',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139711,561,'Rupsa S.O','756028',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139712,561,'Sabira R.S. B.O','756045',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139713,561,'Sadanandapur B.O','756029',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139714,561,'Sahada B.O','756002',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139715,561,'Sahada B.O','756080',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139716,561,'Sahadevkhunta S.O','756001',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139717,561,'Sahaspura B.O','756046',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139718,561,'Sahid Park S.O','756003',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139719,561,'Sahupada B.O','756003',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139720,561,'Sajanagarh S.O','756041',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139721,561,'Sajanpur B.O','756045',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139722,561,'Salikotha B.O','756086',1,0,'2022-03-04 19:32:10','2022-03-04 19:32:10'),(139723,561,'Sampei B.O','756047',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139724,561,'Sankhapodadiha B.O','756046',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139725,561,'Sankhari B.O','756037',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139726,561,'Santhapada B.O','756055',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139727,561,'Santragadia B.O','756042',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139728,561,'Sardhapur B.O','756037',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139729,561,'Sargaon B.O','756027',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139730,561,'Sargaon B.O','756002',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139731,561,'Sarkana B.O','756048',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139732,561,'Sarsankha B.O','756045',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139733,561,'Sarsatia B.O','756043',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139734,561,'Sartha B.O','756027',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139735,561,'Sarugaon B.O','756049',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139736,561,'Sathilabalbalia B.O','756020',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139737,561,'Saud B.O','756042',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139738,561,'Saudi B.O','756024',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139739,561,'Saundia B.O','756047',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139740,561,'Sergarh S.O','756060',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139741,561,'Shyamsundarpur B.O','756040',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139742,561,'Siadimal B.O','756040',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139743,561,'Sikharpur B.O','756086',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139744,561,'Simulia B.O','756045',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139745,561,'Sindhia B.O','756003',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139746,561,'Singa Khunta B.O','756045',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139747,561,'Singiri B.O','756020',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139748,561,'Singla S.O','756023',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139749,561,'Sirapur B.O','756055',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139750,561,'Soharia B.O','756036',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139751,561,'Solpata B.O','756027',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139752,561,'Somnathpur B.O','756019',1,0,'2022-03-04 19:32:11','2022-03-04 19:32:11'),(139753,561,'Soro Bazar S.O','756045',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139754,561,'Soro College S.O','756045',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139755,561,'Soro S.O','756045',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139756,561,'Sovarampur S.O','756001',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139757,561,'Srijang B.O','756044',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139758,561,'Srikanthapur S.O','756001',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139759,561,'Srikona B.O','756025',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139760,561,'Srirampur B.O','756029',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139761,561,'Srirampur B.O','756049',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139762,561,'Srirampur Road B.O','756023',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139763,561,'Sugo B.O','756084',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139764,561,'Sukhsandhapatna B.O','756036',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139765,561,'Sultanpur B.O','756036',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139766,561,'Sundarpur B.O','756059',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139767,561,'Sunhat S.O','756002',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139768,561,'Tadada B.O','756081',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139769,561,'Talakurunia B.O','756044',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139770,561,'Tarapur B.O','756036',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139771,561,'Telipal B.O','756041',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139772,561,'Tenda B.O','756041',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139773,561,'Tentei B.O','756046',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139774,561,'Tentulia B.O','756058',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139775,561,'Thalasada B.O','756042',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139776,561,'Tikirapal B.O','756020',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139777,561,'Tukurihazira B.O','756037',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139778,561,'Turigaria S.O','756047',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139779,561,'Udambar B.O','756019',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139780,561,'Udayganjapatna B.O','756039',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139781,561,'Uitikiri B.O','756029',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139782,561,'Upla Hat B.O','756035',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139783,561,'Uppardiha B.O','756058',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139784,561,'Uttareswar S.O','756045',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139785,561,'Vellora B.O','756030',1,0,'2022-03-04 19:32:12','2022-03-04 19:32:12'),(139786,561,'Wada B.O','756045',1,0,'2022-03-04 19:32:13','2022-03-04 19:32:13'),(139787,561,'Ada S.O','756134',1,0,'2022-03-04 19:32:13','2022-03-04 19:32:13'),(139788,561,'Aliha B.O','756182',1,0,'2022-03-04 19:32:13','2022-03-04 19:32:13'),(139789,561,'Anandapur B.O','756126',1,0,'2022-03-04 19:32:13','2022-03-04 19:32:13'),(139790,561,'Antara B.O','756134',1,0,'2022-03-04 19:32:13','2022-03-04 19:32:13'),(139791,561,'Arakhpur B.O','756182',1,0,'2022-03-04 19:32:13','2022-03-04 19:32:13'),(139792,561,'Baghua B.O','756182',1,0,'2022-03-04 19:32:13','2022-03-04 19:32:13'),(139793,561,'Balikhanda S.O','756166',1,0,'2022-03-04 19:32:13','2022-03-04 19:32:13'),(139794,561,'Barada B.O','756134',1,0,'2022-03-04 19:32:13','2022-03-04 19:32:13'),(139795,561,'Bari B.O','756126',1,0,'2022-03-04 19:32:13','2022-03-04 19:32:13'),(139796,561,'Bariha B.O','756126',1,0,'2022-03-04 19:32:13','2022-03-04 19:32:13'),(139797,561,'Bati B.O','756126',1,0,'2022-03-04 19:32:13','2022-03-04 19:32:13'),(139798,561,'Chandarpada B.O','756134',1,0,'2022-03-04 19:32:13','2022-03-04 19:32:13'),(139799,561,'Damodarpur B.O','756182',1,0,'2022-03-04 19:32:13','2022-03-04 19:32:13'),(139800,561,'Dungura S.O','756182',1,0,'2022-03-04 19:32:13','2022-03-04 19:32:13'),(139801,561,'Garasang B.O','756134',1,0,'2022-03-04 19:32:13','2022-03-04 19:32:13'),(139802,561,'Govindapur B.O','756126',1,0,'2022-03-04 19:32:13','2022-03-04 19:32:13'),(139803,561,'Haripur B.O','756115',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139804,561,'Jalanga Gandibed B.O','756134',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139805,561,'Jamjhadi B.O','756126',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139806,561,'Kalaspur B.O','756166',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139807,561,'Kanchpada B.O','756166',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139808,561,'Markona B.O','756126',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139809,561,'Mirjapur B.O','756134',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139810,561,'Mohammadpur B.O','756126',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139811,561,'Panchpada B.O','756133',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139812,561,'Parbatipur B.O','756166',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139813,561,'Ramakrishnapur B.O','756166',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139814,561,'Rudhunga B.O','756126',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139815,561,'Sahigaon B.O','756126',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139816,561,'Simulia Bazar S.O','756126',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139817,561,'Simulia S.O','756126',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139818,561,'Srimantapur B.O','756166',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139819,562,'Adagaon B.O','768040',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139820,562,'Agalpur B.O','768029',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139821,562,'Ambabhana S.O','768031',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139822,562,'Ammthi B.O','768042',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139823,562,'Areigudi B.O','768104',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139824,562,'Arjunda B.O','768103',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139825,562,'Attabira S.O','768027',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139826,562,'B. Katapali B.O','768038',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139827,562,'B. Tileimal B.O','768029',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139828,562,'Babebira B.O','768027',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139829,562,'Badapali B.O','768032',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139830,562,'Baddausen B.O','768032',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139831,562,'Badikata B.O','768036',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139832,562,'Bagbadi B.O','768029',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139833,562,'Bakti B.O','768103',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139834,562,'Banda B.O','768038',1,0,'2022-03-04 19:32:14','2022-03-04 19:32:14'),(139835,562,'Banda-kharmunda B.O','768038',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139836,562,'Bandhapali B.O','768032',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139837,562,'Banhar B.O','768027',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139838,562,'Banjipali B.O','768052',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139839,562,'Bara B.O','768045',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139840,562,'Baramkela B.O','768104',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139841,562,'Barapadar B.O','768104',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139842,562,'Bardol S.O (Bargarh)','768038',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139843,562,'Bargarh Bazar S.O','768028',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139844,562,'Bargarh Court S.O','768028',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139845,562,'Bargarh H.O','768028',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139846,562,'Bargarh-bargaon B.O','768038',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139847,562,'Barhaguda B.O','768040',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139848,562,'Barpali S.O','768029',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139849,562,'Bartunda B.O','768039',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139850,562,'Bausenmura B.O','768033',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139851,562,'Behera B.O','768029',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139852,562,'Beherapali B.O','768038',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139853,562,'Bhadigaon B.O','768038',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139854,562,'Bhainatora B.O','768045',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139855,562,'Bhainsadhara B.O','768042',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139856,562,'Bhandarpuri B.O','768042',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139857,562,'Bhatigaon B.O','768029',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139858,562,'Bhatli S.O','768030',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139859,562,'Bhatli-badmal B.O','768030',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139860,562,'Bheden S.O','768104',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139861,562,'Bhengrajpur B.O','768039',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139862,562,'Bheunria B.O','768036',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139863,562,'Bhoipali B.O','768103',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139864,562,'Bhubaneswarpur B.O','768039',1,0,'2022-03-04 19:32:15','2022-03-04 19:32:15'),(139865,562,'Bhukta S.O','768045',1,0,'2022-03-04 19:32:16','2022-03-04 19:32:16'),(139866,562,'Bichuan B.O','768030',1,0,'2022-03-04 19:32:16','2022-03-04 19:32:16'),(139867,562,'Bijadhol B.O','768042',1,0,'2022-03-04 19:32:16','2022-03-04 19:32:16'),(139868,562,'Bijayapali B.O','768029',1,0,'2022-03-04 19:32:16','2022-03-04 19:32:16'),(139869,562,'Bijepur S.O','768032',1,0,'2022-03-04 19:32:16','2022-03-04 19:32:16'),(139870,562,'Bilaspur B.O','768042',1,0,'2022-03-04 19:32:16','2022-03-04 19:32:16'),(139871,562,'Birjam B.O','768034',1,0,'2022-03-04 19:32:16','2022-03-04 19:32:16'),(139872,562,'Birmal B.O','768029',1,0,'2022-03-04 19:32:16','2022-03-04 19:32:16'),(139873,562,'Bisipali B.O','768049',1,0,'2022-03-04 19:32:16','2022-03-04 19:32:16'),(139874,562,'Boden B.O','768036',1,0,'2022-03-04 19:32:16','2022-03-04 19:32:16'),(139875,562,'Budamal B.O','768036',1,0,'2022-03-04 19:32:16','2022-03-04 19:32:16'),(139876,562,'Bugbuga B.O','768027',1,0,'2022-03-04 19:32:16','2022-03-04 19:32:16'),(139877,562,'Burda B.O','768103',1,0,'2022-03-04 19:32:16','2022-03-04 19:32:16'),(139878,562,'Burkel B.O','768036',1,0,'2022-03-04 19:32:16','2022-03-04 19:32:16'),(139879,562,'Chadeigaon B.O','768030',1,0,'2022-03-04 19:32:16','2022-03-04 19:32:16'),(139880,562,'Chakarkend B.O','768033',1,0,'2022-03-04 19:32:16','2022-03-04 19:32:16'),(139881,562,'Chandibhata B.O','768042',1,0,'2022-03-04 19:32:16','2022-03-04 19:32:16'),(139882,562,'Chantipali B.O','768035',1,0,'2022-03-04 19:32:17','2022-03-04 19:32:17'),(139883,562,'Chendeikela B.O','768050',1,0,'2022-03-04 19:32:17','2022-03-04 19:32:17'),(139884,562,'Chhuriapali B.O','768033',1,0,'2022-03-04 19:32:17','2022-03-04 19:32:17'),(139885,562,'Chichinda B.O','768033',1,0,'2022-03-04 19:32:17','2022-03-04 19:32:17'),(139886,562,'Chichinda B.O','768104',1,0,'2022-03-04 19:32:17','2022-03-04 19:32:17'),(139887,562,'Dahigaon B.O','768036',1,0,'2022-03-04 19:32:17','2022-03-04 19:32:17'),(139888,562,'Dahita B.O','768036',1,0,'2022-03-04 19:32:17','2022-03-04 19:32:17'),(139889,562,'Dang B.O','768038',1,0,'2022-03-04 19:32:17','2022-03-04 19:32:17'),(139890,562,'Dangabahal B.O','768037',1,0,'2022-03-04 19:32:17','2022-03-04 19:32:17'),(139891,562,'Dekulba B.O','768103',1,0,'2022-03-04 19:32:17','2022-03-04 19:32:17'),(139892,562,'Deogaon B.O','768038',1,0,'2022-03-04 19:32:17','2022-03-04 19:32:17'),(139893,562,'Deshbhatli B.O','768102',1,0,'2022-03-04 19:32:17','2022-03-04 19:32:17'),(139894,562,'Dhaba B.O','768042',1,0,'2022-03-04 19:32:17','2022-03-04 19:32:17'),(139895,562,'Dhanger B.O','768040',1,0,'2022-03-04 19:32:17','2022-03-04 19:32:17'),(139896,562,'Diptipur B.O','768035',1,0,'2022-03-04 19:32:17','2022-03-04 19:32:17'),(139897,562,'Dulampur B.O','768111',1,0,'2022-03-04 19:32:17','2022-03-04 19:32:17'),(139898,562,'Dungri B.O','768052',1,0,'2022-03-04 19:32:17','2022-03-04 19:32:17'),(139899,562,'Dunguri Lsq Colony Campus S.O','768052',1,0,'2022-03-04 19:32:18','2022-03-04 19:32:18'),(139900,562,'Gaisama B.O','768040',1,0,'2022-03-04 19:32:18','2022-03-04 19:32:18'),(139901,562,'Gaisilet S.O','768037',1,0,'2022-03-04 19:32:18','2022-03-04 19:32:18'),(139902,562,'Ganiapali B.O','768049',1,0,'2022-03-04 19:32:18','2022-03-04 19:32:18'),(139903,562,'Garbhona B.O','768033',1,0,'2022-03-04 19:32:18','2022-03-04 19:32:18'),(139904,562,'Ghess S.O','768034',1,0,'2022-03-04 19:32:18','2022-03-04 19:32:18'),(139905,562,'Godbhaga S.O','768111',1,0,'2022-03-04 19:32:18','2022-03-04 19:32:18'),(139906,562,'Gondturum S.O','768115',1,0,'2022-03-04 19:32:18','2022-03-04 19:32:18'),(139907,562,'Gopalpur B.O','768030',1,0,'2022-03-04 19:32:18','2022-03-04 19:32:18'),(139908,562,'Gopeipali B.O','768029',1,0,'2022-03-04 19:32:18','2022-03-04 19:32:18'),(139909,562,'Gourenmunda B.O','768037',1,0,'2022-03-04 19:32:18','2022-03-04 19:32:18'),(139910,562,'Gourmal B.O','768042',1,0,'2022-03-04 19:32:18','2022-03-04 19:32:18'),(139911,562,'Govindpur B.O','768033',1,0,'2022-03-04 19:32:18','2022-03-04 19:32:18'),(139912,562,'Guderpali B.O','768035',1,0,'2022-03-04 19:32:18','2022-03-04 19:32:18'),(139913,562,'Gudesira B.O','768038',1,0,'2022-03-04 19:32:18','2022-03-04 19:32:18'),(139914,562,'Guthuguda B.O','768042',1,0,'2022-03-04 19:32:18','2022-03-04 19:32:18'),(139915,562,'Halupali B.O','768038',1,0,'2022-03-04 19:32:18','2022-03-04 19:32:18'),(139916,562,'Hatisar B.O','768030',1,0,'2022-03-04 19:32:18','2022-03-04 19:32:18'),(139917,562,'Hirlipali B.O','768027',1,0,'2022-03-04 19:32:18','2022-03-04 19:32:18'),(139918,562,'J. Sirgida B.O','768033',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139919,562,'Jagalpat B.O','768037',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139920,562,'Jagdalpur B.O','768036',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139921,562,'Jamla S.O','768049',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139922,562,'Jamseth B.O','768050',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139923,562,'Jamurda B.O','768038',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139924,562,'Jamutbahal B.O','768037',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139925,562,'Janged B.O','768027',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139926,562,'Janhapada B.O','768027',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139927,562,'Jaring B.O','768032',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139928,562,'Jatla B.O','768033',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139929,562,'Jhar B.O','768034',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139930,562,'Jharbandh S.O','768042',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139931,562,'Jharpali B.O','768103',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139932,562,'Jharpali B.O','768034',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139933,562,'Jhikijhiki B.O','768030',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139934,562,'Jhilminda B.O','768103',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139935,562,'Jhitiki B.O','768050',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139936,562,'Jokhipali B.O','768048',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139937,562,'K. Katabahal B.O','768036',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139938,562,'Kadobahal B.O','768102',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139939,562,'Kainsir B.O','768029',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139940,562,'Kalangapali B.O','768034',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139941,562,'Kalapani B.O','768040',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139942,562,'Kamgaon B.O','768038',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139943,562,'Kanakbira B.O','768030',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139944,562,'Kangaon B.O','768033',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139945,562,'Kansingha B.O','768036',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139946,562,'Kantapali-barpali B.O','768029',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139947,562,'Kapasira B.O','768045',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139948,562,'Karlasantara B.O','768052',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139949,562,'Kathaumal B.O','768037',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139950,562,'Kebad B.O','768029',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139951,562,'Kesaipali B.O','768030',1,0,'2022-03-04 19:32:19','2022-03-04 19:32:19'),(139952,562,'Khaliapali B.O','768036',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139953,562,'Khandatha B.O','768040',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139954,562,'Kharmunda B.O','768032',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139955,562,'Kharsal B.O','768030',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139956,562,'Khuntapali B.O','768040',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139957,562,'Kubedega B.O','768104',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139958,562,'Kuchipali B.O','768034',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139959,562,'Kudapali B.O','768104',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139960,562,'Kultatukura B.O','768102',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139961,562,'Kulunda B.O','768027',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139962,562,'Kumbhari B.O','768029',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139963,562,'Kumbho B.O','768045',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139964,562,'Kumelsingha B.O','768111',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139965,562,'Kundakhai B.O','768035',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139966,562,'Kuruan B.O','768103',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139967,562,'Kusanpuri B.O','768029',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139968,562,'Lachida B.O','768027',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139969,562,'Lahanda B.O','768111',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139970,562,'Lakhamara B.O','768036',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139971,562,'Lakhanpur B.O','768052',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139972,562,'Larambha S.O','768102',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139973,562,'Larasara B.O','768027',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139974,562,'Lastala B.O','768027',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139975,562,'Laudidhara B.O','768042',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139976,562,'Laumunda S.O','768048',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139977,562,'Lebidi B.O','768033',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139978,562,'Lenda B.O','768029',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139979,562,'Lupursingha B.O','768103',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139980,562,'Madhupur B.O','768033',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139981,562,'Mahada B.O','768029',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139982,562,'Mahule B.O','768115',1,0,'2022-03-04 19:32:20','2022-03-04 19:32:20'),(139983,562,'Mahulpali B.O','768029',1,0,'2022-03-04 19:32:21','2022-03-04 19:32:21'),(139984,562,'Mahulpali B.O','768036',1,0,'2022-03-04 19:32:21','2022-03-04 19:32:21'),(139985,562,'Majhipali B.O','768048',1,0,'2022-03-04 19:32:21','2022-03-04 19:32:21'),(139986,562,'Manapada B.O','768027',1,0,'2022-03-04 19:32:21','2022-03-04 19:32:21'),(139987,562,'Mandosil S.O','768050',1,0,'2022-03-04 19:32:21','2022-03-04 19:32:21'),(139988,562,'Manpur B.O','768104',1,0,'2022-03-04 19:32:21','2022-03-04 19:32:21'),(139989,562,'Melchhamunda S.O','768035',1,0,'2022-03-04 19:32:21','2022-03-04 19:32:21'),(139990,562,'Mithapali B.O','768039',1,0,'2022-03-04 19:32:21','2022-03-04 19:32:21'),(139991,562,'Mondiadhipa B.O','768039',1,0,'2022-03-04 19:32:21','2022-03-04 19:32:21'),(139992,562,'Mulbar B.O','768030',1,0,'2022-03-04 19:32:21','2022-03-04 19:32:21'),(139993,562,'N. Jampali B.O','768038',1,0,'2022-03-04 19:32:21','2022-03-04 19:32:21'),(139994,562,'Negimunda B.O','768033',1,0,'2022-03-04 19:32:21','2022-03-04 19:32:21'),(139995,562,'Nileswar B.O','768029',1,0,'2022-03-04 19:32:21','2022-03-04 19:32:21'),(139996,562,'Nilji B.O','768030',1,0,'2022-03-04 19:32:21','2022-03-04 19:32:21'),(139997,562,'Nuagarh B.O','768030',1,0,'2022-03-04 19:32:21','2022-03-04 19:32:21'),(139998,562,'Pada B.O','768032',1,0,'2022-03-04 19:32:21','2022-03-04 19:32:21'),(139999,562,'Pahandi B.O','768032',1,0,'2022-03-04 19:32:21','2022-03-04 19:32:21'),(140000,562,'Paharsirgida B.O','768027',1,0,'2022-03-04 19:32:22','2022-03-04 19:32:22'),(140001,562,'Paikmal S.O','768039',1,0,'2022-03-04 19:32:22','2022-03-04 19:32:22'),(140002,562,'Palsada B.O','768039',1,0,'2022-03-04 19:32:22','2022-03-04 19:32:22'),(140003,562,'Pandikipali B.O','768033',1,0,'2022-03-04 19:32:22','2022-03-04 19:32:22'),(140004,562,'Panimura B.O','768033',1,0,'2022-03-04 19:32:22','2022-03-04 19:32:22'),(140005,562,'Papanga B.O','768104',1,0,'2022-03-04 19:32:22','2022-03-04 19:32:22'),(140006,562,'Patakulunda B.O','768029',1,0,'2022-03-04 19:32:22','2022-03-04 19:32:22'),(140007,562,'Patharia B.O','768032',1,0,'2022-03-04 19:32:22','2022-03-04 19:32:22'),(140008,562,'Petupali B.O','768034',1,0,'2022-03-04 19:32:22','2022-03-04 19:32:22'),(140009,562,'Phalsapali B.O','768049',1,0,'2022-03-04 19:32:22','2022-03-04 19:32:22'),(140010,562,'Purena B.O','768036',1,0,'2022-03-04 19:32:22','2022-03-04 19:32:22'),(140011,562,'Rajborasamber S.O','768036',1,0,'2022-03-04 19:32:22','2022-03-04 19:32:22'),(140012,562,'Remta B.O','768029',1,0,'2022-03-04 19:32:22','2022-03-04 19:32:22'),(140013,562,'Remunda S.O','768103',1,0,'2022-03-04 19:32:22','2022-03-04 19:32:22'),(140014,562,'Rengali B.O','768033',1,0,'2022-03-04 19:32:22','2022-03-04 19:32:22'),(140015,562,'Rengalipali Colony B.O','768027',1,0,'2022-03-04 19:32:22','2022-03-04 19:32:22'),(140016,562,'Resam B.O','768104',1,0,'2022-03-04 19:32:22','2022-03-04 19:32:22'),(140017,562,'Routpara B.O','768030',1,0,'2022-03-04 19:32:22','2022-03-04 19:32:22'),(140018,562,'Ruchida B.O','768045',1,0,'2022-03-04 19:32:22','2022-03-04 19:32:22'),(140019,562,'Rusuda B.O','768115',1,0,'2022-03-04 19:32:22','2022-03-04 19:32:22'),(140020,562,'Saipali B.O','768032',1,0,'2022-03-04 19:32:22','2022-03-04 19:32:22'),(140021,562,'Sakuda B.O','768030',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140022,562,'Salepali B.O','768035',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140023,562,'Samalaipadar B.O','768032',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140024,562,'Sanimal B.O','768034',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140025,562,'Sankhirda B.O','768103',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140026,562,'Saplahar B.O','768036',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140027,562,'Saradhapali B.O','768037',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140028,562,'Saranda B.O','768027',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140029,562,'Sarandapali B.O','768032',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140030,562,'Sareikela B.O','768036',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140031,562,'Sargibahal B.O','768049',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140032,562,'Sarkanda B.O','768033',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140033,562,'Sarsara B.O','768040',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140034,562,'Satlama B.O','768029',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140035,562,'Shakti B.O','768042',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140036,562,'Sialkhandata B.O','768115',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140037,562,'Silet B.O','768111',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140038,562,'Sirgida B.O','768032',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140039,562,'Sohella S.O','768033',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140040,562,'Sulsulia B.O','768030',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140041,562,'Sunalarambha B.O','768104',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140042,562,'Tabada B.O','768033',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140043,562,'Talmenda B.O','768103',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140044,562,'Talpadar B.O','768034',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140045,562,'Talpali B.O','768036',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140046,562,'Talsirgida B.O','768103',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140047,562,'Tamdei B.O','768052',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140048,562,'Tampersara B.O','768102',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140049,562,'Tejgola B.O','768030',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140050,562,'Temri B.O','768039',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140051,562,'Tope B.O','768027',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140052,562,'Tora S.O','768040',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140053,562,'Tulandi B.O','768029',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140054,562,'Tungibandhali B.O','768033',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140055,562,'Urduna B.O','768038',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140056,562,'Uttam B.O','768052',1,0,'2022-03-04 19:32:23','2022-03-04 19:32:23'),(140057,563,'Adalpanka B.O','756114',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140058,563,'Adhuan B.O','756125',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140059,563,'Adia B.O','756114',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140060,563,'Aharapada B.O','756128',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140061,563,'Akhuapada S.O','756122',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140062,563,'Alauti B.O','756113',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140063,563,'Albaga B.O','756124',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140064,563,'Ambiligaon B.O','756118',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140065,563,'Amroli B.O','756101',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140066,563,'Amrutpur B.O','756129',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140067,563,'Anandabazar B.O','756116',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140068,563,'Andheipalli B.O','756112',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140069,563,'Andhia B.O','756114',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140070,563,'Andiapat B.O','756129',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140071,563,'Andrai B.O','756123',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140072,563,'Angeipal B.O','756117',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140073,563,'Anijo B.O','756115',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140074,563,'Apanda B.O','756144',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140075,563,'Aradi S.O','756138',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140076,563,'Arandua B.O','756125',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140077,563,'Arasa S.O','756139',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140078,563,'Arjunbindha B.O','756131',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140079,563,'Arnapal S.O','756116',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140080,563,'Aruha B.O','756168',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140081,563,'Asurali S.O','756137',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140082,563,'Atto B.O','756123',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140083,563,'B T Pur S.O','756115',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140084,563,'Babalpur B.O','756121',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140085,563,'Bachhipur B.O','756165',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140086,563,'Badabarchikayan B.O','756135',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140087,563,'Badanuagaon B.O','756115',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140088,563,'Bahabalpur B.O','756130',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140089,563,'Bahudarada B.O','756112',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140090,563,'Baincha B.O','756164',1,0,'2022-03-04 19:32:24','2022-03-04 19:32:24'),(140091,563,'Balabhadrapur B.O','756116',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140092,563,'Balanta B.O','756111',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140093,563,'Balichaturi B.O','756130',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140094,563,'Baligaon B.O','756133',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140095,563,'Balimeda B.O','756131',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140096,563,'Balimunda B.O','756164',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140097,563,'Bamanbindha B.O','756131',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140098,563,'Bamkura B.O','756119',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140099,563,'Bandalo B.O','756121',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140100,563,'Bandhagaon B.O','756101',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140101,563,'Bandhatia B.O','756117',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140102,563,'Bangarpadi B.O','756114',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140103,563,'Banitia B.O','756101',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140104,563,'Bansada Kuamara B.O','756164',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140105,563,'Bant S.O','756114',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140106,563,'Baralpokhari B.O','756101',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140107,563,'Barandua B.O','756168',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140108,563,'Barapada S.O','756113',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140109,563,'Barikpur Bazar S.O','756112',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140110,563,'Baro B.O','756130',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140111,563,'Barsar B.O','756131',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140112,563,'Bartana B.O','756115',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140113,563,'Barunai B.O','756167',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140114,563,'Basantia S.O (Bhadrak)','756144',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140115,563,'Basudevpur College S.O','756125',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140116,563,'Basudevpur S.O (Bhadrak)','756125',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140117,563,'Batula B.O','756138',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140118,563,'Bedeipur B.O','756164',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140119,563,'Bedeipurpal B.O','756125',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140120,563,'Begana B.O','756114',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140121,563,'Bentalpur B.O','756133',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140122,563,'Betada S.O','756168',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140123,563,'Betaligaon B.O','756119',1,0,'2022-03-04 19:32:25','2022-03-04 19:32:25'),(140124,563,'Bhadrak Banka Bazar S.O','756100',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140125,563,'Bhadrak Bypass B.O','756181',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140126,563,'Bhadrak College S.O','756100',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140127,563,'Bhadrak Court S.O','756100',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140128,563,'Bhadrak H.O','756100',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140129,563,'Bhadrak Naya Bazar S.O','756100',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140130,563,'Bhadrak Puruna Bazar S.O','756100',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140131,563,'Bhadrak R S S.O','756101',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140132,563,'Bhagibindha B.O','756112',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140133,563,'Bhairabpur B.O','756125',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140134,563,'Bhandari Pokhari S.O','756120',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140135,563,'Bhatapada B.O','756130',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140136,563,'Bhuianwash B.O','756163',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140137,563,'Bhuinpur B.O','756138',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140138,563,'Bidyadharpur B.O','756139',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140139,563,'Bijayanagar B.O','756133',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140140,563,'Bilana B.O','756163',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140141,563,'Binayakpur B.O','756125',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140142,563,'Biras B.O','756125',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140143,563,'Biriadia B.O','756129',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140144,563,'Bishnupurbindha B.O','756116',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140145,563,'Bodak B.O','756163',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140146,563,'Bodakpatna B.O','756135',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140147,563,'Bouljoda B.O','756133',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140148,563,'Brahmanigaon S.O','756165',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140149,563,'Brahmanpal B.O','756119',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140150,563,'Chabispara Sasan B.O','756130',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140151,563,'Chalunigaon B.O','756168',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140152,563,'Champulipada B.O','756111',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140153,563,'Chandbali Bazar S.O','756133',1,0,'2022-03-04 19:32:26','2022-03-04 19:32:26'),(140154,563,'Chandbali S.O','756133',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140155,563,'Chandigaon B.O','756101',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140156,563,'Chandrakat Bindha B.O','756131',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140157,563,'Charampa S.O','756101',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140158,563,'Chardia B.O','756113',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140159,563,'Chardia B.O','756132',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140160,563,'Chhayalsingh B.O','756114',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140161,563,'Chudakuti Palasa B.O','756117',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140162,563,'Chudamani B.O','756125',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140163,563,'D.B. Colony B.O','756117',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140164,563,'Dakhinabad B.O','756117',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140165,563,'Deopada B.O','756121',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140166,563,'Dhamara S.O','756171',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140167,563,'Dhamnagar S.O','756117',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140168,563,'Dhulipada B.O','756130',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140169,563,'Dhusuri S.O','756119',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140170,563,'Dobal B.O','756117',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140171,563,'Dolapadi B.O','756114',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140172,563,'Dolasahi S.O','756127',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140173,563,'Dosinga B.O','756171',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140174,563,'Erada B.O','756123',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140175,563,'Eram S.O','756162',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140176,563,'Ertal S.O','756124',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140177,563,'Fatepur B.O','756137',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140178,563,'Gadiali B.O','756137',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140179,563,'Galagandapur B.O','756163',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140180,563,'Ganijang B.O','756114',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140181,563,'Ganjeibari B.O','756127',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140182,563,'Garadapur B.O','756181',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140183,563,'Gelpur B.O','756181',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140184,563,'Geltua B.O','756181',1,0,'2022-03-04 19:32:27','2022-03-04 19:32:27'),(140185,563,'Ghanteswar Baliapal B.O','756129',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140186,563,'Ghanteswar S.O','756129',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140187,563,'Ghatapur B.O','756131',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140188,563,'Ghosrabazar S.O','756100',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140189,563,'Goladia B.O','756133',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140190,563,'Golapokhari B.O','756130',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140191,563,'Gopaljew Sugo B.O','756124',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140192,563,'Gopalpur B.O','756133',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140193,563,'Gopinath Tejpur B.O','756115',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140194,563,'Goramati B.O','756123',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140195,563,'Goudunipokhari B.O','756132',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140196,563,'Gourgadi B.O','756111',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140197,563,'Govindapur B.O','756137',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140198,563,'Govindpur B.O','756164',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140199,563,'Govindpur Hanspat B.O','756131',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140200,563,'Guagadia B.O','756124',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140201,563,'Guamal S.O','756163',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140202,563,'Gujidarada S.O','756128',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140203,563,'Haladia B.O','756129',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140204,563,'Harekrishnapur B.O','756132',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140205,563,'Hatapur B.O','756129',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140206,563,'Hengupati B.O','756131',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140207,563,'Ichhada B.O','756112',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140208,563,'Ichhapur B.O','756127',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140209,563,'Jahangir B.O','756117',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140210,563,'Jaipur B.O','756163',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140211,563,'Jalamandua B.O','756112',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140212,563,'Jalanga B.O','756181',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140213,563,'Jaleswarpur B.O','756132',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140214,563,'Jamjodi B.O','756131',1,0,'2022-03-04 19:32:28','2022-03-04 19:32:28'),(140215,563,'Jitanaga B.O','756127',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140216,563,'K K Pur B.O','756125',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140217,563,'Kadabaranga B.O','756135',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140218,563,'Kaithkhola B.O','756171',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140219,563,'Kalai B.O','756116',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140220,563,'Kalasuni B.O','756111',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140221,563,'Kalyani B.O','756118',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140222,563,'Kandaragadia B.O','756129',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140223,563,'Kanheibindha B.O','756168',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140224,563,'Kanpada B.O','756130',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140225,563,'Kantia B.O','756114',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140226,563,'Karanjamal B.O','756164',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140227,563,'Karanpalli B.O','756164',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140228,563,'Karanpokhari B.O','756132',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140229,563,'Kasimpur B.O','756137',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140230,563,'Kaupur B.O','756113',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140231,563,'Kenduapada B.O','756112',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140232,563,'Keshpur B.O','756128',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140233,563,'Khadimahara B.O','756119',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140234,563,'Khadipada B.O','756117',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140235,563,'Khaparpada B.O','756116',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140236,563,'Kheranga B.O','756131',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140237,563,'Khirkona B.O','756168',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140238,563,'Kiapada B.O','756165',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140239,563,'Kishore Prasad B.O','756171',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140240,563,'Kolha B.O','756130',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140241,563,'Korkora B.O','756116',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140242,563,'Korua B.O','756137',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140243,563,'Kothar S.O','756118',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140244,563,'Kuans S.O','756100',1,0,'2022-03-04 19:32:29','2022-03-04 19:32:29'),(140245,563,'Kubera B.O','756163',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140246,563,'Kuda B.O','756132',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140247,563,'Kudabarua B.O','756101',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140248,563,'Kulana B.O','756121',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140249,563,'Kumbharia B.O','756122',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140250,563,'Kurigaon B.O','756117',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140251,563,'Langudi B.O','756116',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140252,563,'Lunga B.O','756124',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140253,563,'Lunia B.O','756116',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140254,563,'Madhabnagar S.O','756181',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140255,563,'Madhapur B.O','756132',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140256,563,'Madhupur B.O','756132',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140257,563,'Maitapur B.O','756111',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140258,563,'Malada B.O','756120',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140259,563,'Mandari B.O','756125',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140260,563,'Mangalpur B.O','756130',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140261,563,'Manjuri B.O','756122',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140262,563,'Manjuri Road S.O','756121',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140263,563,'Matiasahi B.O','756130',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140264,563,'Matipaka B.O','756125',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140265,563,'Mohantipada B.O','756115',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140266,563,'Moharampur B.O','756127',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140267,563,'Motto S.O','756132',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140268,563,'Mouda B.O','756181',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140269,563,'Mousudha Bazar B.O','756132',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140270,563,'Mudusuli B.O','756131',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140271,563,'Naami B.O','756121',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140272,563,'Nadigaon B.O','756119',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140273,563,'Naguan B.O','756112',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140274,563,'Naikanidihi S.O','756164',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140275,563,'Nalagohira B.O','756132',1,0,'2022-03-04 19:32:30','2022-03-04 19:32:30'),(140276,563,'Nalanga B.O','756112',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140277,563,'Nalgira B.O','756113',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140278,563,'Nalgunda B.O','756132',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140279,563,'Nandapur B.O','756127',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140280,563,'Nandapur B.O','756138',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140281,563,'Nandore B.O','756116',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140282,563,'Nangamahalla S.O','756100',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140283,563,'Narasinghpur B.O','756168',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140284,563,'Narasinghpurhat B.O','756171',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140285,563,'Narayanpur B.O','756117',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140286,563,'Narendrapur B.O','756129',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140287,563,'Nerada B.O','756122',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140288,563,'Nuagaon B.O','756162',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140289,563,'Nuagaon Ichhapur B.O','756132',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140290,563,'Nuahat B.O','756118',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140291,563,'Odanga B.O','756135',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140292,563,'Olaga B.O','756138',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140293,563,'Olanga B.O','756135',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140294,563,'Orasahi B.O','756133',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140295,563,'Padamapur B.O','756124',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140296,563,'Padhani B.O','756117',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140297,563,'Padhanpara B.O','756114',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140298,563,'Paliabindha S.O','756167',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140299,563,'Palikiri B.O','756117',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140300,563,'Panchutikiri B.O','756129',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140301,563,'Pandarbatia B.O','756119',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140302,563,'Pangata B.O','756119',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140303,563,'Paramanandapur B.O','756122',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140304,563,'Paramanandapur B.O','756132',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140305,563,'Patnamishrapur B.O','756130',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140306,563,'Patuli B.O','756112',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140307,563,'Pirahatbazar S.O','756131',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140308,563,'Pirhat B.O','756131',1,0,'2022-03-04 19:32:31','2022-03-04 19:32:31'),(140309,563,'Piripur B.O','756112',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140310,563,'Prabodhpur S.O','756125',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140311,563,'R N Betra B.O','756112',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140312,563,'Radhaballavpur B.O','756125',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140313,563,'Rahania B.O','756120',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140314,563,'Rahanja B.O','756111',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140315,563,'Raipur B.O','756129',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140316,563,'Rajgharpokhari B.O','756131',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140317,563,'Rajmukundapur B.O','756116',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140318,563,'Ramachandrapur B.O','756114',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140319,563,'Ramakrishnapur B.O','756113',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140320,563,'Rambhila B.O','756111',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140321,563,'Rameswarpur B.O','756117',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140322,563,'Rampur B.O','756132',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140323,563,'Randiahat S.O','756135',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140324,563,'Ranital S.O (Bhadrak)','756111',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140325,563,'Ratina B.O','756115',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140326,563,'Sabrang S.O','756123',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140327,563,'Sahada Sabrang B.O','756123',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140328,563,'Sahapur B.O','756131',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140329,563,'Sahaspur B.O','756119',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140330,563,'Sahidnagar B.O','756116',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140331,563,'Sahusahi B.O','756119',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140332,563,'Sailendrapalli B.O','756132',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140333,563,'Salandi Colony S.O','756100',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140334,563,'Samian B.O','756123',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140335,563,'Sanahavelisahi B.O','756164',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140336,563,'Sanakrishnapur B.O','756125',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140337,563,'Sanalpur B.O','756119',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140338,563,'Sandado B.O','756115',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140339,563,'Saragadia B.O','756101',1,0,'2022-03-04 19:32:32','2022-03-04 19:32:32'),(140340,563,'Saramara B.O','756135',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140341,563,'Sarasada B.O','756120',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140342,563,'Saraswati B.O','756171',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140343,563,'Sathibankuda B.O','756138',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140344,563,'Saya B.O','756130',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140345,563,'Sendtira B.O','756114',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140346,563,'Serpur B.O','756127',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140347,563,'Shyamsundarpur B.O','756119',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140348,563,'Silandi B.O','756144',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140349,563,'Sindol B.O','756130',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140350,563,'Smantraipur B.O','756131',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140351,563,'Sohara B.O','756117',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140352,563,'Sriganga B.O','756116',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140353,563,'Suan B.O','756162',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140354,563,'Subudhia B.O','756129',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140355,563,'Sukleswar B.O','756133',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140356,563,'Sunderpur B.O','756119',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140357,563,'Suryapur B.O','756119',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140358,563,'Susua B.O','756116',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140359,563,'Talagopabindha B.O','756116',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140360,563,'Talapada B.O','756139',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140361,563,'Tarago B.O','756114',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140362,563,'Tentulidihi B.O','756133',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140363,563,'Tesinga B.O','756121',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140364,563,'Tiadisahi B.O','756131',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140365,563,'Tihidi S.O','756130',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140366,563,'Tihiri B.O','756181',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140367,563,'Tillo Barasahi B.O','756114',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140368,563,'Todanga B.O','756112',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140369,563,'Totapada B.O','756129',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140370,563,'Ugratara B.O','756133',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140371,563,'Uttarbahini S.O','756100',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140372,564,'Adenigarh B.O','762023',1,0,'2022-03-04 19:32:33','2022-03-04 19:32:33'),(140373,564,'Ainlapalli B.O','762015',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140374,564,'Ambajhari B.O','762015',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140375,564,'Arakhapadar B.O','762020',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140376,564,'Badabandha B.O','762013',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140377,564,'Badachhapalli B.O','762017',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140378,564,'Badhigaon B.O','762026',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140379,564,'Badiketa B.O','762015',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140380,564,'Baghiabahal S.O','762030',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140381,564,'Baghiapada B.O','762026',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140382,564,'Bahira B.O','762015',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140383,564,'Balakira B.O','762015',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140384,564,'Balanda B.O','762013',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140385,564,'Balasinga B.O','762014',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140386,564,'Bamanda B.O','762024',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140387,564,'Bandhapathar B.O','762026',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140388,564,'Barabapadr B.O','762030',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140389,564,'Baragaon B.O','762017',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140390,564,'Baragochha B.O','762016',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140391,564,'Bhejigora B.O','762020',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140392,564,'Bilabadi B.O','762024',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140393,564,'Bilaspur B.O','762016',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140394,564,'Biramchandrapur B.O','762024',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140395,564,'Biranarasinghpur S.O','762024',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140396,564,'Birigarh B.O','762026',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140397,564,'Boudh Court S.O','762014',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140398,564,'Boudhbazar S.O','762014',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140399,564,'Boudhraj S.O','762014',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140400,564,'Bounsoni S.O','762015',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140401,564,'Brahmanpalli B.O','762014',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140402,564,'Butupalli B.O','762014',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140403,564,'Charada B.O','762014',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140404,564,'Chhatranga B.O','762020',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140405,564,'Dahya B.O','762015',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140406,564,'Damamunda B.O','762016',1,0,'2022-03-04 19:32:34','2022-03-04 19:32:34'),(140407,564,'Dapalla B.O','762030',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140408,564,'Devgarh B.O','762024',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140409,564,'Dhadalapada B.O','762026',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140410,564,'Dhalapur B.O','762013',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140411,564,'Fased B.O','762018',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140412,564,'Gabjore B.O','762030',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140413,564,'Gandapaju B.O','762012',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140414,564,'Gandisara B.O','762012',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140415,564,'Ghantapada S.O','762018',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140416,564,'Gudvellipadar B.O','762016',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140417,564,'Gundribida B.O','762023',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140418,564,'Gundulia B.O','762015',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140419,564,'Harabhanga S.O','762020',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140420,564,'Jagati B.O','762014',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140421,564,'Janhapanka B.O','762014',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140422,564,'Jhadrajing S.O','762023',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140423,564,'Jogindrapur B.O','762016',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140424,564,'Juramunda B.O','762015',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140425,564,'Kamira B.O','762014',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140426,564,'Kampara B.O','762015',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140427,564,'Kankala B.O','762015',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140428,564,'Kantamal S.O','762017',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140429,564,'Karadi B.O','762024',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140430,564,'Karanjakata B.O','762023',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140431,564,'Kasurbandha B.O','762015',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140432,564,'Kelakata B.O','762024',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140433,564,'Khairmal B.O','762016',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140434,564,'Khaliapalli B.O','762030',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140435,564,'Khamariapada B.O','762014',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140436,564,'Khandahata B.O','762013',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140437,564,'Kharabhuin B.O','762020',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140438,564,'Khatakatia B.O','762030',1,0,'2022-03-04 19:32:35','2022-03-04 19:32:35'),(140439,564,'Khuntabandha B.O','762014',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140440,564,'Khuntiapada B.O','762026',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140441,564,'Kultajore B.O','762018',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140442,564,'Kumari B.O','762020',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140443,564,'Kusanga B.O','762020',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140444,564,'Laxmanpur B.O','762023',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140445,564,'Laxmiprasad B.O','762014',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140446,564,'Lokapada B.O','762030',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140447,564,'Lunibahal B.O','762024',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140448,564,'Madhapur B.O','762012',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140449,564,'Mahallickpada B.O','762020',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140450,564,'Mallisahi S.O','762014',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140451,564,'Manamunda S.O','762016',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140452,564,'Manupalli B.O','762015',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140453,564,'Marjakud B.O','762014',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140454,564,'Masinogora B.O','762018',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140455,564,'Mathura B.O','762024',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140456,564,'Mundapada B.O','762014',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140457,564,'Mundipadar B.O','762015',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140458,564,'Murusundhi B.O','762014',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140459,564,'Narayan Prasad B.O','762017',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140460,564,'Nuapalli B.O','762018',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140461,564,'Nuapalli B.O','762015',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140462,564,'Padarpada B.O','762016',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140463,564,'Palaspat B.O','762014',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140464,564,'Purunakatak S.O','762013',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140465,564,'Rambhikata B.O','762024',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140466,564,'Ramgarh B.O','762013',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140467,564,'Ranipathar B.O','762023',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140468,564,'Roxa B.O','762015',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140469,564,'Rundimahal B.O','762030',1,0,'2022-03-04 19:32:36','2022-03-04 19:32:36'),(140470,564,'Rusibandha B.O','762015',1,0,'2022-03-04 19:32:37','2022-03-04 19:32:37'),(140471,564,'Sagada B.O','762016',1,0,'2022-03-04 19:32:37','2022-03-04 19:32:37'),(140472,564,'Salki B.O','762026',1,0,'2022-03-04 19:32:37','2022-03-04 19:32:37'),(140473,564,'Sampoch B.O','762024',1,0,'2022-03-04 19:32:37','2022-03-04 19:32:37'),(140474,564,'Sanachhapalli B.O','762017',1,0,'2022-03-04 19:32:37','2022-03-04 19:32:37'),(140475,564,'Sangochhapada B.O','762015',1,0,'2022-03-04 19:32:37','2022-03-04 19:32:37'),(140476,564,'Sangrampur B.O','762015',1,0,'2022-03-04 19:32:37','2022-03-04 19:32:37'),(140477,564,'Sankulei B.O','762020',1,0,'2022-03-04 19:32:37','2022-03-04 19:32:37'),(140478,564,'Sarsara S.O','762026',1,0,'2022-03-04 19:32:37','2022-03-04 19:32:37'),(140479,564,'Satakhanda B.O','762020',1,0,'2022-03-04 19:32:37','2022-03-04 19:32:37'),(140480,564,'Similipadar B.O','762030',1,0,'2022-03-04 19:32:37','2022-03-04 19:32:37'),(140481,564,'Srimal B.O','762017',1,0,'2022-03-04 19:32:37','2022-03-04 19:32:37'),(140482,564,'Sundhipadar B.O','762016',1,0,'2022-03-04 19:32:37','2022-03-04 19:32:37'),(140483,564,'Telibandha B.O','762014',1,0,'2022-03-04 19:32:37','2022-03-04 19:32:37'),(140484,564,'Tetelenga B.O','762014',1,0,'2022-03-04 19:32:37','2022-03-04 19:32:37'),(140485,564,'Tikiripada B.O','762026',1,0,'2022-03-04 19:32:37','2022-03-04 19:32:37'),(140486,564,'Tilapanga B.O','762015',1,0,'2022-03-04 19:32:37','2022-03-04 19:32:37'),(140487,564,'Tileswar B.O','762013',1,0,'2022-03-04 19:32:37','2022-03-04 19:32:37'),(140488,564,'Tundamal B.O','762016',1,0,'2022-03-04 19:32:37','2022-03-04 19:32:37'),(140489,564,'Uden B.O','762018',1,0,'2022-03-04 19:32:37','2022-03-04 19:32:37'),(140490,564,'Uma B.O','762018',1,0,'2022-03-04 19:32:37','2022-03-04 19:32:37'),(140491,565,'Nuapalamhat S.O','752120',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140492,565,'A D Market S.O','753012',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140493,565,'Adaspur S.O','754011',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140494,565,'Anlo B.O','754010',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140495,565,'Annuary B.O','754009',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140496,565,'Avinab Bidanasi S.O','753014',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140497,565,'B B Garh B.O','754004',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140498,565,'B G P Pur B.O','754005',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140499,565,'Badamulei B.O','754018',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140500,565,'Bagalsahi B.O','754004',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140501,565,'Baideswar B.O','754009',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140502,565,'Bairoi S.O','754010',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140503,565,'Bajrakabari Road S.O','753001',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140504,565,'Balabhadrapur B.O','754009',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140505,565,'Banguary B.O','754001',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140506,565,'Bania B.O','754009',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140507,565,'Banki College S.O','754008',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140508,565,'Banki S.O (Cuttack)','754008',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140509,565,'Banki Tulasipur B.O','754008',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140510,565,'Banra B.O','754006',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140511,565,'Barang S.O','754005',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140512,565,'Belgachhia B.O','754005',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140513,565,'Bentakar S.O','754112',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140514,565,'Bhanpur B.O','753011',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140515,565,'Bidanasi B.O','753014',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140516,565,'Bilasuni B.O','754004',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140517,565,'Billipada B.O','754008',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140518,565,'Binod Bihari S.O','753002',1,0,'2022-03-04 19:32:38','2022-03-04 19:32:38'),(140519,565,'Biribati S.O','754100',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140520,565,'Bramhanda B.O','754003',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140521,565,'Bramhansailo S.O','754018',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140522,565,'Bramhapura B.O','754008',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140523,565,'C R R I S.O (Cuttack)','753006',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140524,565,'Cantonment Road S.O','753001',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140525,565,'Chandaka B.O','754005',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140526,565,'Chandinchowk H.O','753002',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140527,565,'Chauliaganj S.O','753004',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140528,565,'Chhatra Bazar S.O','753003',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140529,565,'Choudhury Bazar S.O','753001',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140530,565,'CISF Mundali S.O','754013',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140531,565,'College Square S.O (Cuttack)','753003',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140532,565,'Cuttack G.P.O.','753001',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140533,565,'Dadhibabanpur B.O','754112',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140534,565,'Dagarpara S.O','753002',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140535,565,'Dargha Bazar S.O','753001',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140536,565,'Daruthenga B.O','754005',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140537,565,'Dhansarpatna B.O','754008',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140538,565,'Dompara S.O','754007',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140539,565,'Dulanapur B.O','754007',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140540,565,'Durgapur B.O','754008',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140541,565,'Eranch B.O','754105',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140542,565,'Fakirpada B.O','754100',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140543,565,'Fulnakhara S.O','754001',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140544,565,'G R C Pur B.O','754007',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140545,565,'G.Nahalpur B.O','754003',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140546,565,'Gandhi Bhawan S.O (Cuttack)','753001',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140547,565,'Gatiroutpatna B.O','754100',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140548,565,'Gayal Banka B.O','754007',1,0,'2022-03-04 19:32:39','2022-03-04 19:32:39'),(140549,565,'Ghasiput B.O','754008',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140550,565,'Gobabasta B.O','754001',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140551,565,'Godisahi B.O','754006',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140552,565,'Gopalpur S.O (Cuttack)','753011',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140553,565,'Govindpur S.O (Cuttack)','754003',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140554,565,'Harirajpur B.O','754008',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140555,565,'Industrial Estate S.O (Cuttack)','753010',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140556,565,'Jallarpur B.O','754004',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140557,565,'Jharkata B.O','754112',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140558,565,'Jhinkiria Berhampur B.O','754112',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140559,565,'Jobra S.O','753003',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140560,565,'Kafla S.O','753002',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140561,565,'Kalapada B.O','754112',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140562,565,'Kalapathar S.O (Cuttack)','754009',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140563,565,'Kaliaboda S.O','753003',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140564,565,'Kalyani Nagar S.O','753013',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140565,565,'Kandarpur B.O','754100',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140566,565,'Kanika Rajbati S.O','753008',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140567,565,'Kantakai B.O','754009',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140568,565,'Kantapada B.O','754002',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140569,565,'Kapasi B.O','754004',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140570,565,'Karanga B.O','754004',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140571,565,'Kasarda S.O','754105',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140572,565,'Kathojodi S.O','753002',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140573,565,'Kazibazar S.O','753001',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140574,565,'Kendupalli B.O','754009',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140575,565,'Khalarda B.O','753011',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140576,565,'Khandeita B.O','753011',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140577,565,'Khandol B.O','754002',1,0,'2022-03-04 19:32:40','2022-03-04 19:32:40'),(140578,565,'Khannagar S.O','753012',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140579,565,'Khatbin Sahi B.O','753008',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140580,565,'Kothapatna B.O','754001',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140581,565,'Krushnapali Patna B.O','754009',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140582,565,'Krushnaprasad B.O','754004',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140583,565,'Kulashree B.O','754105',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140584,565,'Kuspangi B.O','754007',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140585,565,'Madhab B.O','754004',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140586,565,'Madhupatna S.O','753010',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140587,565,'Madhusudan Nagar S.O (Cuttack)','753008',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140588,565,'Mahidharpara B.O','754001',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140589,565,'Malgodown S.O','753003',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140590,565,'Mangalabag S.O','753001',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140591,565,'Medical College S.O (Cuttack)','753007',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140592,565,'Meria Bazar S.O','753001',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140593,565,'Mundali Colony S.O','754006',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140594,565,'Naraj B.O','754006',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140595,565,'Nargang B.O','754008',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140596,565,'Nayabazar S.O (Cuttack)','753004',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140597,565,'Niali S.O','754004',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140598,565,'Nimasahi S.O','753001',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140599,565,'Noda B.O','754105',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140600,565,'Nuagaon B.O','754008',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140601,565,'Nuagaon B.O','754004',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140602,565,'Nuapatna B.O','754004',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140603,565,'O G Press S.O','753010',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140604,565,'O M P B.O','753004',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140605,565,'O S E S.O','753007',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140606,565,'Padanpur B.O','754007',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140607,565,'Pahanga B.O','754004',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140608,565,'Pandalam B.O','754009',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140609,565,'Paramahansa B.O','754100',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140610,565,'Patapur B.O','754008',1,0,'2022-03-04 19:32:41','2022-03-04 19:32:41'),(140611,565,'Patasundarpur B.O','754018',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140612,565,'Pathapur B.O','754007',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140613,565,'Pathuripada B.O','754008',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140614,565,'Pattapole S.O','753001',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140615,565,'Poincha B.O','754009',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140616,565,'Postal B.O','754018',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140617,565,'Prajatantra S.O','753002',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140618,565,'Ragadi B.O','754008',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140619,565,'Raghunathpur B.O','754005',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140620,565,'Raipur Cuttack B.O','754001',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140621,565,'Rajabagicha S.O','753009',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140622,565,'Rajendra Nagar S.O (Cuttack)','753010',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140623,565,'Rajib B.O','754009',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140624,565,'Ravenshaw College S.O','753003',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140625,565,'Sadar Harianta B.O','754003',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140626,565,'Sailo Badbail B.O','754018',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140627,565,'Sailo Jharpada B.O','754003',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140628,565,'Sankhatras B.O','753011',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140629,565,'Sarichuan B.O','754112',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140630,565,'Shelter Chhak S.O','753008',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140631,565,'Sidheswarpur B.O','754100',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140632,565,'Sikharpur S.O','753003',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140633,565,'Sri Aurobinda Marg S.O','753013',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140634,565,'Sundargram S.O','754002',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140635,565,'Swaraj Ashram S.O','753002',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140636,565,'Talabasta B.O','754007',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140637,565,'Telenga Bazar S.O','753009',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140638,565,'Telengapentha B.O','754001',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140639,565,'Tulasipur S.O','753008',1,0,'2022-03-04 19:32:42','2022-03-04 19:32:42'),(140640,565,'Uaradha B.O','754010',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140641,565,'Urali B.O','753011',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140642,565,'Uttampur B.O','753011',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140643,565,'Uttaran B.O','754105',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140644,565,'Agyanpur B.O','754209',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140645,565,'Asureswar S.O','754209',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140646,565,'Badagotha B.O','754221',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140647,565,'Baghilo Bamanpur B.O','754208',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140648,565,'Baghuni B.O','754209',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140649,565,'Basudevpur B.O','754204',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140650,565,'Bhagabanpur B.O','754293',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140651,565,'Bhagabatpur B.O','754208',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140652,565,'Bhakuda B.O','754204',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140653,565,'Bhimdaspur B.O','754221',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140654,565,'Bodamundai B.O','754202',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140655,565,'Bodhanga B.O','754207',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140656,565,'Champatipur B.O','754206',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140657,565,'Chandol S.O','754208',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140658,565,'Charirakaba B.O','754293',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140659,565,'Chayanpal B.O','754204',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140660,565,'Chhanipur B.O','754202',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140661,565,'Dharmadaspur B.O','754204',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140662,565,'Ghantalo B.O','754209',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140663,565,'Gokana B.O','754206',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140664,565,'Gopalpur B.O','754207',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140665,565,'Gotara B.O','754207',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140666,565,'Goudagopa B.O','754207',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140667,565,'Haladia B.O','754207',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140668,565,'Harirajpur B.O','754209',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140669,565,'Jahangar B.O','754208',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140670,565,'Janhimula B.O','754208',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140671,565,'Jhadeswarpur B.O','754207',1,0,'2022-03-04 19:32:43','2022-03-04 19:32:43'),(140672,565,'Jignipur B.O','754202',1,0,'2022-03-04 19:32:44','2022-03-04 19:32:44'),(140673,565,'Katikata B.O','754209',1,0,'2022-03-04 19:32:44','2022-03-04 19:32:44'),(140674,565,'Kendupatna S.O','754203',1,0,'2022-03-04 19:32:44','2022-03-04 19:32:44'),(140675,565,'Khandasahi B.O','754207',1,0,'2022-03-04 19:32:44','2022-03-04 19:32:44'),(140676,565,'Kood B.O','754221',1,0,'2022-03-04 19:32:44','2022-03-04 19:32:44'),(140677,565,'Kuanpal S.O','754204',1,0,'2022-03-04 19:32:44','2022-03-04 19:32:44'),(140678,565,'Kuhunda B.O','754204',1,0,'2022-03-04 19:32:44','2022-03-04 19:32:44'),(140679,565,'Kulasukarpara B.O','754209',1,0,'2022-03-04 19:32:44','2022-03-04 19:32:44'),(140680,565,'Kumudajaipur B.O','754204',1,0,'2022-03-04 19:32:44','2022-03-04 19:32:44'),(140681,565,'Kurujanga B.O','754208',1,0,'2022-03-04 19:32:44','2022-03-04 19:32:44'),(140682,565,'Kusumbi B.O','754221',1,0,'2022-03-04 19:32:44','2022-03-04 19:32:44'),(140683,565,'Kusunpur B.O','754207',1,0,'2022-03-04 19:32:44','2022-03-04 19:32:44'),(140684,565,'Kusunpur B.O','754209',1,0,'2022-03-04 19:32:44','2022-03-04 19:32:44'),(140685,565,'Lalitgiri B.O','754205',1,0,'2022-03-04 19:32:44','2022-03-04 19:32:44'),(140686,565,'Lemalo S.O','754293',1,0,'2022-03-04 19:32:44','2022-03-04 19:32:44'),(140687,565,'Madhupur B.O','754204',1,0,'2022-03-04 19:32:44','2022-03-04 19:32:44'),(140688,565,'Mahanga S.O','754206',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140689,565,'Manoharpur B.O','754202',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140690,565,'Mirzapur B.O','754221',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140691,565,'Mulabasanta B.O','754204',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140692,565,'Narasinghpur B.O','754207',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140693,565,'Natakai B.O','754207',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140694,565,'Nischintakoili S.O','754207',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140695,565,'Nurtang B.O','754204',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140696,565,'Olakana B.O','754207',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140697,565,'Orikanta B.O','754293',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140698,565,'Osanga B.O','754206',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140699,565,'Ostapur B.O','754207',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140700,565,'Palei Derakundi B.O','754208',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140701,565,'Palli Sahi B.O','754221',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140702,565,'Patapur B.O','754202',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140703,565,'Pikola B.O','754221',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140704,565,'Pithapara B.O','754207',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140705,565,'Podamarai B.O','754206',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140706,565,'Rahania B.O','754204',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140707,565,'Sabalanga Kanipara B.O','754208',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140708,565,'Sahaniajpur B.O','754207',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140709,565,'Salipur College S.O','754202',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140710,565,'Salipur S.O','754202',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140711,565,'Sisua B.O','754202',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140712,565,'Sukarapara B.O','754209',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140713,565,'Sukleswar B.O','754221',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140714,565,'Sunakhandi B.O','754202',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140715,565,'Sungura S.O (Cuttack)','754221',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140716,565,'Tarat Sasan B.O','754209',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140717,565,'Abhimanpur B.O','754035',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140718,565,'Achalkote B.O','754030',1,0,'2022-03-04 19:32:45','2022-03-04 19:32:45'),(140719,565,'Adheigundi B.O','754037',1,0,'2022-03-04 19:32:46','2022-03-04 19:32:46'),(140720,565,'Agrahat B.O','754028',1,0,'2022-03-04 19:32:46','2022-03-04 19:32:46'),(140721,565,'Alara B.O','754032',1,0,'2022-03-04 19:32:46','2022-03-04 19:32:46'),(140722,565,'Angeswarpada B.O','754113',1,0,'2022-03-04 19:32:46','2022-03-04 19:32:46'),(140723,565,'Arakhapatna B.O','754029',1,0,'2022-03-04 19:32:46','2022-03-04 19:32:46'),(140724,565,'Athagarh Bazar S.O','754295',1,0,'2022-03-04 19:32:46','2022-03-04 19:32:46'),(140725,565,'Athagarh College S.O','754029',1,0,'2022-03-04 19:32:46','2022-03-04 19:32:46'),(140726,565,'Athagarh H.O','754029',1,0,'2022-03-04 19:32:46','2022-03-04 19:32:46'),(140727,565,'Ayatpur B.O','754131',1,0,'2022-03-04 19:32:46','2022-03-04 19:32:46'),(140728,565,'Babujang B.O','754134',1,0,'2022-03-04 19:32:46','2022-03-04 19:32:46'),(140729,565,'Badabhuin B.O','754029',1,0,'2022-03-04 19:32:46','2022-03-04 19:32:46'),(140730,565,'Badakambilo B.O','754031',1,0,'2022-03-04 19:32:46','2022-03-04 19:32:46'),(140731,565,'Badanauput B.O','754030',1,0,'2022-03-04 19:32:46','2022-03-04 19:32:46'),(140732,565,'Badasamantarapur B.O','754028',1,0,'2022-03-04 19:32:46','2022-03-04 19:32:46'),(140733,565,'Bahugram S.O','754200',1,0,'2022-03-04 19:32:46','2022-03-04 19:32:46'),(140734,565,'Bainchua B.O','754022',1,0,'2022-03-04 19:32:46','2022-03-04 19:32:46'),(140735,565,'Balarampur B.O','754029',1,0,'2022-03-04 19:32:46','2022-03-04 19:32:46'),(140736,565,'Bali B.O','754029',1,0,'2022-03-04 19:32:46','2022-03-04 19:32:46'),(140737,565,'Balijhari B.O','754037',1,0,'2022-03-04 19:32:46','2022-03-04 19:32:46'),(140738,565,'Balisahi B.O','754032',1,0,'2022-03-04 19:32:46','2022-03-04 19:32:46'),(140739,565,'Bamangadia B.O','754031',1,0,'2022-03-04 19:32:46','2022-03-04 19:32:46'),(140740,565,'Banamalipur B.O','754031',1,0,'2022-03-04 19:32:47','2022-03-04 19:32:47'),(140741,565,'Banda B.O','754131',1,0,'2022-03-04 19:32:47','2022-03-04 19:32:47'),(140742,565,'Bandalo B.O','754030',1,0,'2022-03-04 19:32:47','2022-03-04 19:32:47'),(140743,565,'Bandhahuda B.O','754032',1,0,'2022-03-04 19:32:47','2022-03-04 19:32:47'),(140744,565,'Bangarisinga B.O','754031',1,0,'2022-03-04 19:32:47','2022-03-04 19:32:47'),(140745,565,'Barambagarh S.O','754031',1,0,'2022-03-04 19:32:47','2022-03-04 19:32:47'),(140746,565,'Baunsput B.O','754030',1,0,'2022-03-04 19:32:47','2022-03-04 19:32:47'),(140747,565,'Beliapal B.O','754031',1,0,'2022-03-04 19:32:47','2022-03-04 19:32:47'),(140748,565,'Bentapada B.O','754029',1,0,'2022-03-04 19:32:47','2022-03-04 19:32:47'),(140749,565,'Bhagatpur B.O','754022',1,0,'2022-03-04 19:32:47','2022-03-04 19:32:47'),(140750,565,'Bhairapur B.O','754200',1,0,'2022-03-04 19:32:47','2022-03-04 19:32:47'),(140751,565,'Bhatapada B.O','754200',1,0,'2022-03-04 19:32:47','2022-03-04 19:32:47'),(140752,565,'Bhatimunda B.O','754022',1,0,'2022-03-04 19:32:47','2022-03-04 19:32:47'),(140753,565,'Bhera B.O','754290',1,0,'2022-03-04 19:32:47','2022-03-04 19:32:47'),(140754,565,'Bhimrajpur B.O','754201',1,0,'2022-03-04 19:32:47','2022-03-04 19:32:47'),(140755,565,'Bindhanima B.O','754030',1,0,'2022-03-04 19:32:47','2022-03-04 19:32:47'),(140756,565,'Birol B.O','754025',1,0,'2022-03-04 19:32:47','2022-03-04 19:32:47'),(140757,565,'Bisanpur B.O','754029',1,0,'2022-03-04 19:32:47','2022-03-04 19:32:47'),(140758,565,'Bodhapur B.O','754130',1,0,'2022-03-04 19:32:47','2022-03-04 19:32:47'),(140759,565,'Chakada B.O','754029',1,0,'2022-03-04 19:32:47','2022-03-04 19:32:47'),(140760,565,'Champeswar B.O','754037',1,0,'2022-03-04 19:32:47','2022-03-04 19:32:47'),(140761,565,'Charbatia S.O','754028',1,0,'2022-03-04 19:32:47','2022-03-04 19:32:47'),(140762,565,'Chasakhanda B.O','754290',1,0,'2022-03-04 19:32:47','2022-03-04 19:32:47'),(140763,565,'Chasapara S.O','754027',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140764,565,'Chhagaon B.O','754028',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140765,565,'Choudwar Bazar S.O','754025',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140766,565,'Choudwar S.O','754025',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140767,565,'Dalijoda Berhampur B.O','754028',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140768,565,'Damodarpur B.O','754130',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140769,565,'Dasarathipur B.O','754031',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140770,565,'Daulatabad S.O (Cuttack)','754026',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140771,565,'Debabumi B.O','754032',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140772,565,'Dhaipur B.O','754029',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140773,565,'Dharibil B.O','754134',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140774,565,'Dhurusia B.O','754027',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140775,565,'Dorada B.O','754029',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140776,565,'Ekdal B.O','754037',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140777,565,'Fulapada B.O','754032',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140778,565,'Gadadharpur B.O','754030',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140779,565,'Gadapokhari B.O','754031',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140780,565,'Garudagaon B.O','754022',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140781,565,'Gholapur B.O','754029',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140782,565,'Gobara B.O','754028',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140783,565,'Godibandha B.O','754037',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140784,565,'Godijanga B.O','754134',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140785,565,'Gopamathura B.O','754031',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140786,565,'Gopapur B.O','754031',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140787,565,'Gopinathpur B.O','754200',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140788,565,'Gurudijhatia B.O','754028',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140789,565,'Harianta B.O','754025',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140790,565,'Ichhapur B.O','754029',1,0,'2022-03-04 19:32:48','2022-03-04 19:32:48'),(140791,565,'Ichhapur B.O','754031',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140792,565,'Jagatpur S.O (Cuttack)','754021',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140793,565,'Jaripada B.O','754201',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140794,565,'Jenapada B.O','754029',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140795,565,'Jhajia B.O','754031',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140796,565,'Jillinda B.O','754032',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140797,565,'Jodamuhana B.O','754031',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140798,565,'Jodumu B.O','754032',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140799,565,'Kadalibadi B.O','754029',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140800,565,'Kaitha B.O','754023',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140801,565,'Kamaladiha B.O','754032',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140802,565,'Kandarai B.O','754029',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140803,565,'Kandarpur B.O','754029',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140804,565,'Kankadajodi B.O','754035',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140805,565,'Kanpur S.O','754037',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140806,565,'Kapaleswar S.O','754071',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140807,565,'Karadibandha B.O','754031',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140808,565,'Karanji B.O','754022',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140809,565,'Karikol B.O','754029',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140810,565,'Khentalo B.O','754131',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140811,565,'Khnutuni B.O','754029',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140812,565,'Khuntakata B.O','754029',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140813,565,'Khuntakata B.O','754031',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140814,565,'Kishorenagar S.O','754131',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140815,565,'Kokalaba B.O','754032',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140816,565,'Kokhadi B.O','754027',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140817,565,'Kotasahi S.O','754022',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140818,565,'Koyalpada B.O','754027',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140819,565,'Kukudanga B.O','754201',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140820,565,'Kulailo B.O','754029',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140821,565,'Kumarpur B.O','754028',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140822,565,'Lekhanpur B.O','754201',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140823,565,'Madhyakachha B.O','754200',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140824,565,'Mahajanpur B.O','754200',1,0,'2022-03-04 19:32:49','2022-03-04 19:32:49'),(140825,565,'Mahakalbasta B.O','754029',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140826,565,'Mahasingpur B.O','754200',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140827,565,'Mahulia B.O','754031',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140828,565,'Malasasan B.O','754201',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140829,565,'Mancheswar B.O','754027',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140830,565,'Mangarajpur B.O','754028',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140831,565,'Maniabandha B.O','754035',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140832,565,'Megha B.O','754029',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140833,565,'Mohana B.O','754201',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140834,565,'Mohanpur B.O','754201',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140835,565,'Mouda S.O','754290',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140836,565,'Mugagahira B.O','754031',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140837,565,'Nakhara B.O','754021',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140838,565,'Narasinghpur S.O','754032',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140839,565,'Narpada B.O','754025',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140840,565,'Nimasahi B.O','754032',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140841,565,'Nimpur B.O','754021',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140842,565,'Nuapatna B.O','754032',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140843,565,'Nuapatna S.O','754035',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140844,565,'Nukhapada B.O','754032',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140845,565,'Odasingh B.O','754201',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140846,565,'Oranda B.O','754029',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140847,565,'Padamal B.O','754037',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140848,565,'Padmapur B.O','754200',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140849,565,'Paikabarabati B.O','754032',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140850,565,'Panchagaon B.O','754030',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140851,565,'Patapur B.O','754200',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140852,565,'Puruna Tigiria B.O','754030',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140853,565,'Purunahatsasan B.O','754131',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140854,565,'Radhakishorepur B.O','754029',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140855,565,'Ragadipada B.O','754031',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140856,565,'Ramakrishnapur B.O','754201',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140857,565,'Rameswar S.O','754201',1,0,'2022-03-04 19:32:50','2022-03-04 19:32:50'),(140858,565,'Ramgarh B.O','754022',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140859,565,'Ratapat B.O','754037',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140860,565,'Regeda B.O','754032',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140861,565,'Rusipada B.O','754037',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140862,565,'Safa B.O','754022',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140863,565,'Sagar B.O','754037',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140864,565,'Sahangagopalpur B.O','754029',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140865,565,'Salagaon B.O','754021',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140866,565,'Samitanga B.O','754131',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140867,565,'Samsarpur B.O','754029',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140868,565,'Sankarpur B.O','754028',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140869,565,'Sankhameri B.O','754031',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140870,565,'Saradhapur B.O','754032',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140871,565,'Sasang B.O','754031',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140872,565,'Satyabhamapur B.O','754200',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140873,565,'Sialia B.O','754037',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140874,565,'Singhanathpitha B.O','754031',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140875,565,'Sompur S.O','754130',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140876,565,'Subarnapur B.O','754029',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140877,565,'Taradinga B.O','754029',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140878,565,'Tarito B.O','754131',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140879,565,'Tentol B.O','754200',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140880,565,'Tigiria S.O','754030',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140881,565,'Tilda B.O','754290',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140882,565,'Totapada B.O','754131',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140883,565,'Uchapada B.O','754022',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140884,565,'Uttarkul B.O','754134',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140885,565,'Viruda B.O','754030',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140886,566,'Ambagaon B.O','768110',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140887,566,'Aunli B.O','768109',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140888,566,'Balam B.O','768108',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140889,566,'Balanda B.O','768110',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140890,566,'Balani B.O','768110',1,0,'2022-03-04 19:32:51','2022-03-04 19:32:51'),(140891,566,'Bamparda B.O','768110',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140892,566,'Barghat B.O','768121',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140893,566,'Barkote S.O','768110',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140894,566,'Basaloi B.O','768108',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140895,566,'Bhatsingh B.O','768108',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140896,566,'Budido B.O','768109',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140897,566,'Charimancha B.O','768110',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140898,566,'Dandasingha B.O','768108',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140899,566,'Danra B.O','768110',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140900,566,'Dantaribahal B.O','768108',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140901,566,'Dashgharia B.O','768109',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140902,566,'Deogarh S.O (Debagarh)','768108',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140903,566,'Dholpara B.O','768121',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140904,566,'Gambharipali B.O','768109',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140905,566,'Ganganan B.O','768108',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140906,566,'Gohira Dam Site S.O','768121',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140907,566,'Gursang B.O','768110',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140908,566,'Jhargogua B.O','768108',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140909,566,'K.Tainsar B.O','768119',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140910,566,'Kadopada B.O','768110',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140911,566,'Kalla B.O','768110',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140912,566,'Kandhal B.O','768108',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140913,566,'Kansar B.O','768121',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140914,566,'Kantabahal B.O','768109',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140915,566,'Kantapali B.O','768108',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140916,566,'Karlaga B.O','768109',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140917,566,'Katangapani B.O','768107',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140918,566,'Khilei B.O','768108',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140919,566,'Kundheigola B.O','768109',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140920,566,'Laimura B.O','768108',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140921,566,'Lulang B.O','768109',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140922,566,'Madhyapur B.O','768110',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140923,566,'Malehipada B.O','768109',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140924,566,'Naulipara B.O','768109',1,0,'2022-03-04 19:32:52','2022-03-04 19:32:52'),(140925,566,'Nuadihi B.O','768228',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140926,566,'Nuadihi B.O','768108',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140927,566,'Palsama B.O','768109',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140928,566,'Parposi B.O','768108',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140929,566,'Purunagarh S.O','768119',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140930,566,'Reamal S.O','768109',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140931,566,'Rengalbeda B.O','768119',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140932,566,'Saida B.O','768110',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140933,566,'Salebhata B.O','768109',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140934,566,'Sarpal B.O','768109',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140935,566,'Saruali B.O','768110',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140936,566,'Suguda B.O','768108',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140937,566,'Tabada B.O','768119',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140938,566,'Tarang B.O','768109',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140939,566,'Tentelabahal B.O','768119',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140940,566,'Tileibani B.O','768119',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140941,566,'Tinkbir B.O','768109',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140942,566,'Tuhilamal B.O','768109',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140943,566,'Tungamal B.O','768109',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140944,566,'Utunia B.O','768109',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140945,567,'Akhuapal B.O','759146',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140946,567,'Aluajharan B.O','759026',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140947,567,'Ambapalas B.O','759120',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140948,567,'Anal B.O','759024',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140949,567,'Anantapur B.O','759017',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140950,567,'Anlabereni S.O','759026',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140951,567,'Anlajhari B.O','759017',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140952,567,'Babandha B.O','759019',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140953,567,'Badajhara B.O','759120',1,0,'2022-03-04 19:32:53','2022-03-04 19:32:53'),(140954,567,'Badakamar B.O','759120',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140955,567,'Badalo B.O','759020',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140956,567,'Badanagena B.O','759014',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140957,567,'Badasuanlo S.O','759039',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140958,567,'Bainsia B.O','759014',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140959,567,'Baisingha B.O','759039',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140960,567,'Bajichowk B.O','759013',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140961,567,'Baladiabandha B.O','759027',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140962,567,'Balaramprasad B.O','759019',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140963,567,'Balarampur B.O','759025',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140964,567,'Balibo B.O','759017',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140965,567,'Baligoroda B.O','759039',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140966,567,'Balimi S.O','759020',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140967,567,'Bam B.O','759028',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140968,567,'Bampa B.O','759025',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140969,567,'Bamuan B.O','759026',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140970,567,'Banasingh B.O','759014',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140971,567,'Bangursinga B.O','759019',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140972,567,'Bankual B.O','759023',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140973,567,'Barada B.O','759016',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140974,567,'Barada B.O','759013',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140975,567,'Barihapur B.O','759120',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140976,567,'Baruan B.O','759024',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140977,567,'Basoi B.O','759120',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140978,567,'Batagaon B.O','759018',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140979,567,'Baulpur B.O','759025',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140980,567,'Baunsapal B.O','759018',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140981,567,'Baunsapokhari B.O','759022',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140982,567,'Bedapada B.O','759019',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140983,567,'Belapada B.O','759025',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140984,567,'Belatikiri B.O','759027',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140985,567,'Beruanpal B.O','759121',1,0,'2022-03-04 19:32:54','2022-03-04 19:32:54'),(140986,567,'Bhagirathipur B.O','759018',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(140987,567,'Bhairpur B.O','759023',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(140988,567,'Bhaliabolkateni B.O','759015',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(140989,567,'Bhapur S.O (Dhenkanal)','759015',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(140990,567,'Bhejia B.O','759120',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(140991,567,'Bhuban S.O','759017',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(140992,567,'Bhusal B.O','759017',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(140993,567,'Bidharpur B.O','759016',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(140994,567,'Bido B.O','759121',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(140995,567,'Birasal B.O','759039',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(140996,567,'Biribolei B.O','759120',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(140997,567,'Brahmaniapal B.O','759025',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(140998,567,'Buhalipal B.O','759021',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(140999,567,'Chandapur B.O','759120',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(141000,567,'Chandipal B.O','759017',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(141001,567,'Chandpur B.O','759019',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(141002,567,'Chandrasekharaprasad B.O','759015',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(141003,567,'Chaulia B.O','759013',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(141004,567,'Chhotapada B.O','759021',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(141005,567,'Chintapokhari B.O','759121',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(141006,567,'Chirulei B.O','759014',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(141007,567,'Chitalpur B.O','759020',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(141008,567,'Damal B.O','759120',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(141009,567,'Dashipur B.O','759120',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(141010,567,'Dhalapada B.O','759017',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(141011,567,'Dhalapur B.O','759019',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(141012,567,'Dhalpur B.O','759019',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(141013,567,'Dhenkanal College S.O','759001',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(141014,567,'Dhenkanal H.O','759001',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(141015,567,'Dhenkanal R S S.O','759013',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(141016,567,'Dhirapatna B.O','759015',1,0,'2022-03-04 19:32:55','2022-03-04 19:32:55'),(141017,567,'Dighi B.O','759023',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141018,567,'Dudurkote B.O','759020',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141019,567,'Ekatali B.O','759017',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141020,567,'Gadasila S.O','759025',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141021,567,'Gahamkhunti B.O','759027',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141022,567,'Gandanali B.O','759021',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141023,567,'Gangijodi B.O','759026',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141024,567,'Garh Nrusinghaprasad B.O','759024',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141025,567,'Garh Palasuni B.O','759120',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141026,567,'Gengutia B.O','759013',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141027,567,'Gengutia B.O','759146',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141028,567,'Ghagarmunda B.O','759120',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141029,567,'Ghatipiri B.O','759015',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141030,567,'Giridharaprasad B.O','759020',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141031,567,'Gobinda Bidyadharpur B.O','759023',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141032,567,'Gondiapatna S.O','759016',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141033,567,'Gorodia B.O','759023',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141034,567,'Govindprasad B.O','759015',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141035,567,'Govindpur S.O (Dhenkanal)','759027',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141036,567,'Gunadei B.O','759025',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141037,567,'Gundichapada B.O','759025',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141038,567,'Guneibil B.O','759023',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141039,567,'Haladiabahal B.O','759121',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141040,567,'Hatura B.O','759020',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141041,567,'Hindol Road R.S. S.O','759019',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141042,567,'Hindol S.O','759022',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141043,567,'Ichhabatipur B.O','759026',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141044,567,'Igit Sarang S.O','759146',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141045,567,'Indipur B.O','759025',1,0,'2022-03-04 19:32:56','2022-03-04 19:32:56'),(141046,567,'Jagannathpur B.O','759039',1,0,'2022-03-04 19:32:57','2022-03-04 19:32:57'),(141047,567,'Jamunakote B.O','759024',1,0,'2022-03-04 19:32:57','2022-03-04 19:32:57'),(141048,567,'Jayapurakateni B.O','759018',1,0,'2022-03-04 19:32:57','2022-03-04 19:32:57'),(141049,567,'Jhili B.O','759120',1,0,'2022-03-04 19:32:57','2022-03-04 19:32:57'),(141050,567,'Jineilo B.O','759023',1,0,'2022-03-04 19:32:57','2022-03-04 19:32:57'),(141051,567,'Jiral B.O','759023',1,0,'2022-03-04 19:32:57','2022-03-04 19:32:57'),(141052,567,'Jubuli Town S.O','759001',1,0,'2022-03-04 19:32:57','2022-03-04 19:32:57'),(141053,567,'Kabera Madhapur B.O','759014',1,0,'2022-03-04 19:32:57','2022-03-04 19:32:57'),(141054,567,'Kadala B.O','759121',1,0,'2022-03-04 19:32:57','2022-03-04 19:32:57'),(141055,567,'Kaimati B.O','759027',1,0,'2022-03-04 19:32:57','2022-03-04 19:32:57'),(141056,567,'Kakudibhag B.O','759015',1,0,'2022-03-04 19:32:57','2022-03-04 19:32:57'),(141057,567,'Kalanda B.O','759020',1,0,'2022-03-04 19:32:57','2022-03-04 19:32:57'),(141058,567,'Kalanga B.O','759015',1,0,'2022-03-04 19:32:57','2022-03-04 19:32:57'),(141059,567,'Kalikaprasad B.O','759015',1,0,'2022-03-04 19:32:57','2022-03-04 19:32:57'),(141060,567,'Kalingapal B.O','759021',1,0,'2022-03-04 19:32:57','2022-03-04 19:32:57'),(141061,567,'Kalunigoda B.O','759016',1,0,'2022-03-04 19:32:57','2022-03-04 19:32:57'),(141062,567,'Kaluria B.O','759014',1,0,'2022-03-04 19:32:57','2022-03-04 19:32:57'),(141063,567,'Kamadhenukote B.O','759015',1,0,'2022-03-04 19:32:57','2022-03-04 19:32:57'),(141064,567,'Kamakhyanagar S.O','759018',1,0,'2022-03-04 19:32:58','2022-03-04 19:32:58'),(141065,567,'Kamalanga B.O','759121',1,0,'2022-03-04 19:32:58','2022-03-04 19:32:58'),(141066,567,'Kamarda B.O','759018',1,0,'2022-03-04 19:32:58','2022-03-04 19:32:58'),(141067,567,'Kanapura B.O','759018',1,0,'2022-03-04 19:32:58','2022-03-04 19:32:58'),(141068,567,'Kandabindha B.O','759025',1,0,'2022-03-04 19:32:58','2022-03-04 19:32:58'),(141069,567,'Kandarsinga B.O','759120',1,0,'2022-03-04 19:32:58','2022-03-04 19:32:58'),(141070,567,'Kandhara B.O','759028',1,0,'2022-03-04 19:32:58','2022-03-04 19:32:58'),(141071,567,'Kanheipal B.O','759039',1,0,'2022-03-04 19:32:58','2022-03-04 19:32:58'),(141072,567,'Kankadahad S.O','759028',1,0,'2022-03-04 19:32:58','2022-03-04 19:32:58'),(141073,567,'Kankadahad Sadar B.O','759015',1,0,'2022-03-04 19:32:58','2022-03-04 19:32:58'),(141074,567,'Kankadasoda B.O','759120',1,0,'2022-03-04 19:32:58','2022-03-04 19:32:58'),(141075,567,'Kankadpal B.O','759013',1,0,'2022-03-04 19:32:58','2022-03-04 19:32:58'),(141076,567,'Kankalu B.O','759121',1,0,'2022-03-04 19:32:58','2022-03-04 19:32:58'),(141077,567,'Kankili B.O','759120',1,0,'2022-03-04 19:32:58','2022-03-04 19:32:58'),(141078,567,'Kansara B.O','759022',1,0,'2022-03-04 19:32:58','2022-03-04 19:32:58'),(141079,567,'Kantapal B.O','759028',1,0,'2022-03-04 19:32:58','2022-03-04 19:32:58'),(141080,567,'Kantapal B.O','759026',1,0,'2022-03-04 19:32:58','2022-03-04 19:32:58'),(141081,567,'Kantimili B.O','759121',1,0,'2022-03-04 19:32:58','2022-03-04 19:32:58'),(141082,567,'Kantiokateni B.O','759026',1,0,'2022-03-04 19:32:58','2022-03-04 19:32:58'),(141083,567,'Kantioputasahi B.O','759026',1,0,'2022-03-04 19:32:58','2022-03-04 19:32:58'),(141084,567,'Kantol B.O','759028',1,0,'2022-03-04 19:32:58','2022-03-04 19:32:58'),(141085,567,'Kantor B.O','759120',1,0,'2022-03-04 19:32:58','2022-03-04 19:32:58'),(141086,567,'Kapilash B.O','759016',1,0,'2022-03-04 19:32:58','2022-03-04 19:32:58'),(141087,567,'Karagola B.O','759028',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141088,567,'Karamul B.O','759014',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141089,567,'Karanda B.O','759020',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141090,567,'Kashipur B.O','759016',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141091,567,'Kasiadihi B.O','759025',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141092,567,'Kendupada B.O','759014',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141093,567,'Kerjoli B.O','759028',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141094,567,'Khajuria B.O','759018',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141095,567,'Khaliborei B.O','759021',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141096,567,'Khankar B.O','759014',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141097,567,'Khankira B.O','759016',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141098,567,'Kharagprasad B.O','759121',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141099,567,'Khatakhura B.O','759039',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141100,567,'Khurusia B.O','759023',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141101,567,'Korian B.O','759013',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141102,567,'Kotagara B.O','759026',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141103,567,'Kottam B.O','759015',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141104,567,'Krishnachandrapur B.O','759020',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141105,567,'Kuanlo B.O','759120',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141106,567,'Kumusi B.O','759019',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141107,567,'Kunua B.O','759021',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141108,567,'Kusumjodi B.O','759026',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141109,567,'Kusupanga B.O','759121',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141110,567,'Kuturia B.O','759120',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141111,567,'Lauloi B.O','759016',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141112,567,'Letheka B.O','759016',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141113,567,'Lodhani B.O','759120',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141114,567,'Mahabirod B.O','759120',1,0,'2022-03-04 19:32:59','2022-03-04 19:32:59'),(141115,567,'Mahapada B.O','759014',1,0,'2022-03-04 19:33:00','2022-03-04 19:33:00'),(141116,567,'Mahimagadi S.O','759014',1,0,'2022-03-04 19:33:00','2022-03-04 19:33:00'),(141117,567,'Mahisapat B.O','759013',1,0,'2022-03-04 19:33:00','2022-03-04 19:33:00'),(141118,567,'Mahulapada B.O','759027',1,0,'2022-03-04 19:33:00','2022-03-04 19:33:00'),(141119,567,'Mahulapal B.O','759017',1,0,'2022-03-04 19:33:00','2022-03-04 19:33:00'),(141120,567,'Mahulpal B.O','759018',1,0,'2022-03-04 19:33:00','2022-03-04 19:33:00'),(141121,567,'Maidharpur B.O','759022',1,0,'2022-03-04 19:33:00','2022-03-04 19:33:00'),(141122,567,'Makuakateni B.O','759039',1,0,'2022-03-04 19:33:00','2022-03-04 19:33:00'),(141123,567,'Malapura B.O','759018',1,0,'2022-03-04 19:33:00','2022-03-04 19:33:00'),(141124,567,'Mandar B.O','759016',1,0,'2022-03-04 19:33:00','2022-03-04 19:33:00'),(141125,567,'Mangalpur B.O','759015',1,0,'2022-03-04 19:33:00','2022-03-04 19:33:00'),(141126,567,'Manikmara B.O','759146',1,0,'2022-03-04 19:33:00','2022-03-04 19:33:00'),(141127,567,'Manipur B.O','759027',1,0,'2022-03-04 19:33:00','2022-03-04 19:33:00'),(141128,567,'Marthapur S.O','759023',1,0,'2022-03-04 19:33:00','2022-03-04 19:33:00'),(141129,567,'Maruabil B.O','759039',1,0,'2022-03-04 19:33:00','2022-03-04 19:33:00'),(141130,567,'Mathakargola S.O','759024',1,0,'2022-03-04 19:33:00','2022-03-04 19:33:00'),(141131,567,'Mathatentulia B.O','759016',1,0,'2022-03-04 19:33:00','2022-03-04 19:33:00'),(141132,567,'Meramandali S.O','759121',1,0,'2022-03-04 19:33:00','2022-03-04 19:33:00'),(141133,567,'Motta B.O','759018',1,0,'2022-03-04 19:33:00','2022-03-04 19:33:00'),(141134,567,'Muktapasi B.O','759018',1,0,'2022-03-04 19:33:00','2022-03-04 19:33:00'),(141135,567,'Mundeilo B.O','759120',1,0,'2022-03-04 19:33:00','2022-03-04 19:33:00'),(141136,567,'Nadhara B.O','759019',1,0,'2022-03-04 19:33:00','2022-03-04 19:33:00'),(141137,567,'Nadiali B.O','759027',1,0,'2022-03-04 19:33:00','2022-03-04 19:33:00'),(141138,567,'Neulpoi B.O','759014',1,0,'2022-03-04 19:33:00','2022-03-04 19:33:00'),(141139,567,'Nihalprasad B.O','759016',1,0,'2022-03-04 19:33:01','2022-03-04 19:33:01'),(141140,567,'Nimabahali B.O','759121',1,0,'2022-03-04 19:33:01','2022-03-04 19:33:01'),(141141,567,'Nuabag B.O','759021',1,0,'2022-03-04 19:33:01','2022-03-04 19:33:01'),(141142,567,'Nuagarh B.O','759016',1,0,'2022-03-04 19:33:01','2022-03-04 19:33:01'),(141143,567,'Odisha B.O','759024',1,0,'2022-03-04 19:33:01','2022-03-04 19:33:01'),(141144,567,'Paikapurunakote B.O','759121',1,0,'2022-03-04 19:33:01','2022-03-04 19:33:01'),(141145,567,'Panchapada B.O','759020',1,0,'2022-03-04 19:33:01','2022-03-04 19:33:01'),(141146,567,'Pangatira B.O','759120',1,0,'2022-03-04 19:33:01','2022-03-04 19:33:01'),(141147,567,'Parjang S.O','759120',1,0,'2022-03-04 19:33:01','2022-03-04 19:33:01'),(141148,567,'Patala B.O','759121',1,0,'2022-03-04 19:33:01','2022-03-04 19:33:01'),(141149,567,'Patamandir B.O','759120',1,0,'2022-03-04 19:33:01','2022-03-04 19:33:01'),(141150,567,'Phulapada B.O','759022',1,0,'2022-03-04 19:33:01','2022-03-04 19:33:01'),(141151,567,'Pingua B.O','759016',1,0,'2022-03-04 19:33:01','2022-03-04 19:33:01'),(141152,567,'Pipala B.O','759018',1,0,'2022-03-04 19:33:01','2022-03-04 19:33:01'),(141153,567,'Radhadeipur B.O','759014',1,0,'2022-03-04 19:33:01','2022-03-04 19:33:01'),(141154,567,'Raibol B.O','759039',1,0,'2022-03-04 19:33:01','2022-03-04 19:33:01'),(141155,567,'Rainrusinghpur B.O','759026',1,0,'2022-03-04 19:33:01','2022-03-04 19:33:01'),(141156,567,'Raitala B.O','759016',1,0,'2022-03-04 19:33:01','2022-03-04 19:33:01'),(141157,567,'Ramakrishnapur B.O','759017',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141158,567,'Ranjagol B.O','759020',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141159,567,'Rasol S.O','759021',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141160,567,'Rendapatana B.O','759017',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141161,567,'Roda B.O','759120',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141162,567,'Saanda B.O','759019',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141163,567,'Sadangi B.O','759016',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141164,567,'Sadasivapur B.O','759025',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141165,567,'Samatangi B.O','759018',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141166,567,'Sanjapada B.O','759128',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141167,567,'Santhapur B.O','759016',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141168,567,'Saptasajya B.O','759013',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141169,567,'Sarakpatana B.O','759015',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141170,567,'Saranga B.O','759146',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141171,567,'Saruali B.O','759018',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141172,567,'Shankarpur B.O','759013',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141173,567,'Sibapur B.O','759121',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141174,567,'Sibulapasi B.O','759018',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141175,567,'Siminai B.O','759025',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141176,567,'Sogar B.O','759026',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141177,567,'Sorisiapada B.O','759016',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141178,567,'Surapratapapur B.O','759024',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141179,567,'Talabarkote B.O','759027',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141180,567,'Tarava B.O','759013',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141181,567,'Tariniposi B.O','759028',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141182,567,'Thokar B.O','759020',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141183,567,'Tumusinga B.O','759026',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141184,568,'Adhagam B.O','761215',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141185,568,'Agarkhandi B.O','761211',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141186,568,'Ajayagada B.O','761207',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141187,568,'Aligonda B.O','761217',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141188,568,'Ambajhari B.O','761207',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141189,568,'Anagha B.O','761016',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141190,568,'Anguru B.O','761016',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141191,568,'Ariba B.O','761211',1,0,'2022-03-04 19:33:02','2022-03-04 19:33:02'),(141192,568,'Ashrayagada B.O','761207',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141193,568,'Attarsingi B.O','761016',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141194,568,'B.Sitapur B.O','761201',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141195,568,'Badakhani B.O','761015',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141196,568,'Badakolkote B.O','761207',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141197,568,'Badapada B.O','761214',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141198,568,'Badasindhiba B.O','761017',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141199,568,'Badigam B.O','761206',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141200,568,'Baghmari B.O','761017',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141201,568,'Bagusola B.O','761211',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141202,568,'Baijhola B.O','761206',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141203,568,'Bapenbadi B.O','761208',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141204,568,'Batisiripur B.O','761211',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141205,568,'Betarsingi B.O','761016',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141206,568,'Bhupati Laxmipur B.O','761206',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141207,568,'Bhuskudi B.O','761210',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141208,568,'Birikote B.O','761217',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141209,568,'Birujango B.O','761213',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141210,568,'Bomika B.O','761211',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141211,568,'Chandiput B.O','761017',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141212,568,'Chandragiri S.O','761017',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141213,568,'Chellagada B.O','761016',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141214,568,'Chelligada B.O','761017',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141215,568,'Chitrakar Street S.O','761200',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141216,568,'Damadua B.O','761217',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141217,568,'Dambala B.O','761212',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141218,568,'Darba B.O','761017',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141219,568,'Devadala B.O','761208',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141220,568,'Dhadhiambo B.O','761017',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141221,568,'Engarsingi B.O','761212',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141222,568,'Gaiba B.O','761208',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141223,568,'Gangabad B.O','761212',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141224,568,'Garabandha S.O','761215',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141225,568,'Gayaljuba B.O','761212',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141226,568,'Gondahati B.O','761215',1,0,'2022-03-04 19:33:03','2022-03-04 19:33:03'),(141227,568,'Goppilli Rampa B.O','761215',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141228,568,'Goribandha B.O','761206',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141229,568,'Gosani B.O','761210',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141230,568,'Gulli B.O','761214',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141231,568,'Guluba B.O','761217',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141232,568,'Gumma S.O (Gajapati)','761207',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141233,568,'Gurandi S.O','761210',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141234,568,'Hadubhangi B.O','761208',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141235,568,'Hospital Road S.O (Gajapati)','761200',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141236,568,'Jallango B.O','761213',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141237,568,'Jammi B.O','761201',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141238,568,'Jangalpadu B.O','761210',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141239,568,'Jangam Street','761200',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141240,568,'Jeeba B.O','761201',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141241,568,'Jeerango B.O','761212',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141242,568,'Jeerango Colony B.O','761017',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141243,568,'Jhalarasingi B.O','761214',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141244,568,'Jogipadu B.O','761201',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141245,568,'K.Sitapur B.O','761208',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141246,568,'Kakasingi B.O','761016',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141247,568,'Karadasingi B.O','761213',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141248,568,'Karasandha B.O','761211',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141249,568,'Karchabadi B.O','761217',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141250,568,'Kashinagar S.O (Gajapati)','761206',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141251,568,'Keradango B.O','761214',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141252,568,'Kerandi B.O','761201',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141253,568,'Khajuripada B.O','761214',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141254,568,'Khandava B.O','761206',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141255,568,'Kharada S.O','761208',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141256,568,'Kinchilingi B.O','761215',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141257,568,'Kinigam B.O','761018',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141258,568,'Kinigam B.O','761206',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141259,568,'Kitingi B.O','761206',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141260,568,'Koinpur B.O','761212',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141261,568,'Kolia B.O','761206',1,0,'2022-03-04 19:33:04','2022-03-04 19:33:04'),(141262,568,'Krishnachandrapur B.O','761207',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141263,568,'Kujasingi B.O','761213',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141264,568,'Kumulusingi B.O','761213',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141265,568,'Kuruguba B.O','761212',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141266,568,'Labanyagada B.O','761215',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141267,568,'Laduru B.O','761015',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141268,568,'Lalusahi B.O','761212',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141269,568,'Laxmipur B.O','761212',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141270,568,'Liligada B.O','761015',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141271,568,'Loba B.O','761016',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141272,568,'Luhagudi B.O','761015',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141273,568,'Madhusudanpur B.O','761211',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141274,568,'Mahendragada B.O','761017',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141275,568,'Malasapadar B.O','761015',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141276,568,'Mandimera B.O','761217',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141277,568,'Mangarajpur B.O','761016',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141278,568,'Marlaba B.O','761213',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141279,568,'Mochamera B.O','761211',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141280,568,'Mohana S.O','761015',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141281,568,'Mudumudia B.O','761015',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141282,568,'Munisingi B.O','761207',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141283,568,'Nalaghat B.O','761217',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141284,568,'Namagari B.O','761211',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141285,568,'Narayanapur S.O (Gajapati)','761212',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141286,568,'Nuagada S.O','761214',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141287,568,'Odava S.O','761217',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141288,568,'Panigonda B.O','761217',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141289,568,'Paralakhemundi Bus Stand S.O','761200',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141290,568,'Parida B.O','761208',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141291,568,'Parimal B.O','761016',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141292,568,'Parisola B.O','761213',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141293,568,'Parisola B.O','761016',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141294,568,'Parlakhemundi H.O','761200',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141295,568,'Patiguda B.O','761014',1,0,'2022-03-04 19:33:05','2022-03-04 19:33:05'),(141296,568,'Patikota B.O','761211',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141297,568,'Pedakotturu B.O','761215',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141298,568,'Pindkii B.O','761015',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141299,568,'Pothara B.O','761212',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141300,568,'Puturupada B.O','761016',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141301,568,'R Sitapur B.O','761211',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141302,568,'R.Udayagiri S.O','761016',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141303,568,'Ramagiri B.O','761016',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141304,568,'Ranadevi B.O','761211',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141305,568,'Ranalai B.O','761017',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141306,568,'Randiba B.O','761016',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141307,568,'Ranipeta B.O','761201',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141308,568,'Rasibad B.O','761212',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141309,568,'Rayagada S.O','761213',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141310,568,'Sabara B.O','761215',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141311,568,'Sabarapalli B.O','761016',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141312,568,'Sailada B.O','761211',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141313,568,'Sambalapur (GM) B.O','761016',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141314,568,'Sansada B.O','761212',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141315,568,'Saradapur B.O','761210',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141316,568,'Seranga B.O','761207',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141317,568,'Siali B.O','761206',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141318,568,'Sialilati B.O','761017',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141319,568,'Sidhamadango B.O','761201',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141320,568,'Sindhiba B.O','761207',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141321,568,'Singipur B.O','761215',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141322,568,'Singipur B.O','761014',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141323,568,'Sinkulipadar B.O','761015',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141324,568,'Station Road Paralakhemundi S.O','761201',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141325,568,'T.Govindapur B.O','761015',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141326,568,'Tabarada B.O','761214',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141327,568,'Tabarasingi B.O','761016',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141328,568,'Talamunda B.O','761212',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141329,568,'Tampakaviti B.O','761211',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141330,568,'Tarangada B.O','761201',1,0,'2022-03-04 19:33:06','2022-03-04 19:33:06'),(141331,568,'Tatipati B.O','761210',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141332,568,'Tumula B.O','761207',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141333,568,'Uppalada S.O','761211',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141334,568,'Valada B.O','761206',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141335,569,'A.K.Deuli B.O','761111',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141336,569,'Adapada B.O','761144',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141337,569,'Adipur B.O','761118',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141338,569,'Aladi B.O','761120',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141339,569,'Alasuguma B.O','761121',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141340,569,'Alipur B.O','761111',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141341,569,'Ambapua B.O','761119',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141342,569,'Ambopua B.O','761104',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141343,569,'Amrutulu B.O','761108',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141344,569,'Antarapada B.O','761117',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141345,569,'Arakhapur B.O','761117',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141346,569,'Aska College Square S.O','761110',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141347,569,'Aska H.O','761110',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141348,569,'Aska Junction S.O','761110',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141349,569,'Asura Bandha S.O','761151',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141350,569,'B D Sahi Bellagunhta S.O','761119',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141351,569,'B.D.Pur B.O','761120',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141352,569,'B.Karadabadi B.O','761143',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141353,569,'B.Kotibadi B.O','761108',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141354,569,'B.L.S.Pur B.O','761119',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141355,569,'B.Nuapalli B.O','761104',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141356,569,'B.Pankalbadi B.O','761118',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141357,569,'Baaruda B.O','761131',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141358,569,'Babanpur B.O','761111',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141359,569,'Badabadangi B.O','761108',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141360,569,'Badabaraba B.O','761151',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141361,569,'Badaborasingi B.O','761124',1,0,'2022-03-04 19:33:07','2022-03-04 19:33:07'),(141362,569,'Badagada S.O','761109',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141363,569,'Badagochha B.O','761151',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141364,569,'Badakhandi B.O','761101',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141365,569,'Badakholi B.O','761116',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141366,569,'Badakodanda S.O','761125',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141367,569,'Badangi B.O','761141',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141368,569,'Badapada B.O','761124',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141369,569,'Badula B.O','761114',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141370,569,'Bahadapadar B.O','761125',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141371,569,'Baharpur B.O','761107',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141372,569,'Balarampur B.O','761109',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141373,569,'Baliapata B.O','761131',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141374,569,'Baliasara B.O','761104',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141375,569,'Balichhai B.O','761111',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141376,569,'Balisahi B.O','761131',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141377,569,'Balisira B.O','761115',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141378,569,'Ballipadar S.O','761117',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141379,569,'Banadevi Patna S.O','761104',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141380,569,'Bandhaguda B.O','761106',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141381,569,'Bangarada B.O','761123',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141382,569,'Baradabilli B.O','761107',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141383,569,'Baragam B.O','761111',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141384,569,'Baragam S.O','761120',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141385,569,'Baramundalli B.O','761106',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141386,569,'Barida B.O','761104',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141387,569,'Baunsalundi B.O','761133',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141388,569,'Bellagunhta S.O','761119',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141389,569,'Benapata B.O','761122',1,0,'2022-03-04 19:33:08','2022-03-04 19:33:08'),(141390,569,'Benipalli B.O','761124',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141391,569,'Betarasingi B.O','761118',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141392,569,'Bethuara B.O','761107',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141393,569,'Bhagabanpur B.O','761151',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141394,569,'Bhamsyali B.O','761118',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141395,569,'Bhanjamargo S.O','761126',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141396,569,'Bhanjanagar  College S.O','761126',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141397,569,'Bhanjanagar Bazar S.O','761126',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141398,569,'Bhanjanagar H.O','761126',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141399,569,'Bhatakhali B.O','761117',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141400,569,'Bhejiput S.O','761126',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141401,569,'Bhetonoi S.O','761116',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141402,569,'Biranchipur B.O','761143',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141403,569,'Birikote B.O','761132',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141404,569,'Bishnuchakra B.O','761117',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141405,569,'Bolosara B.O','761104',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141406,569,'Bonka B.O','761119',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141407,569,'Borada B.O','761109',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141408,569,'Bori B.O','761123',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141409,569,'Brahmanchhai B.O','761103',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141410,569,'Brhamanapadar B.O','761132',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141411,569,'Buduli B.O','761132',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141412,569,'Buguda Badadanda Sahi B.O','761118',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141413,569,'Buguda S.O','761118',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141414,569,'Burupada S.O','761146',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141415,569,'Chamunda B.O','761121',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141416,569,'Chandulli B.O','761102',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141417,569,'D.Singipur B.O','761107',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141418,569,'Dadarlunda B.O','761132',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141419,569,'Dasamundali B.O','761106',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141420,569,'Debabhumi B.O','761115',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141421,569,'Dengadi B.O','761144',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141422,569,'Dengapadar B.O','761146',1,0,'2022-03-04 19:33:09','2022-03-04 19:33:09'),(141423,569,'Dhabalpur B.O','761106',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141424,569,'Dhanantara B.O','761106',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141425,569,'Dhaninja B.O','761116',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141426,569,'Dharakote S.O','761107',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141427,569,'Dhaugam B.O','761111',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141428,569,'Dholapita B.O','761131',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141429,569,'Dhumchai B.O','761140',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141430,569,'Dhunkapada B.O','761118',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141431,569,'Dihapadhala B.O','761140',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141432,569,'Domuhani B.O','761141',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141433,569,'Dubuduba B.O','761133',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141434,569,'Dumakumpa B.O','761125',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141435,569,'Durabandha B.O','761101',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141436,569,'Ekalpur B.O','761109',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141437,569,'Erendra B.O','761013',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141438,569,'G.D.Palli B.O','761107',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141439,569,'G.D.Palli B.O','761111',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141440,569,'G.Dengapadar B.O','761124',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141441,569,'G.Nuagam B.O','761140',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141442,569,'G.Rambha B.O','761132',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141443,569,'Gahangu B.O','761117',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141444,569,'Gallery S.O','761141',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141445,569,'Gamundi B.O','761133',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141446,569,'Gandadhara B.O','761121',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141447,569,'Gangapur (Ganjam) S.O','761123',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141448,569,'Gangapur B.O','761109',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141449,569,'Gangapur B.O','761104',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141450,569,'Gangapur B.O','761013',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141451,569,'Gaudagotha B.O','761109',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141452,569,'Gaudiabarada B.O','761118',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141453,569,'Gayaganda B.O','761131',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141454,569,'Gazalbadi B.O','761151',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141455,569,'Genja B.O','761108',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141456,569,'Gerada B.O','761131',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141457,569,'Ghodapolan B.O','761104',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141458,569,'Gobara S.O','761124',1,0,'2022-03-04 19:33:10','2022-03-04 19:33:10'),(141459,569,'Gobindapur B.O','761146',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141460,569,'Golabandha B.O','761118',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141461,569,'Golamundala B.O','761118',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141462,569,'Golapada B.O','761131',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141463,569,'Golia B.O','761118',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141464,569,'Gopalpursasan B.O','761108',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141465,569,'Gopinath Patna S.O','761104',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141466,569,'Gothagam B.O','761146',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141467,569,'Gudiali B.O','761104',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141468,569,'Gundribadi B.O','761132',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141469,569,'Gunthapada S.O','761115',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141470,569,'Guzurali B.O','761131',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141471,569,'Haridapadar B.O','761111',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141472,569,'Harigada B.O','761141',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141473,569,'Hatiota B.O','761117',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141474,569,'Hatnagar B.O','761126',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141475,569,'Hindola B.O','761104',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141476,569,'Hinjilicut S.O','761102',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141477,569,'Hinjlicut College Road S.O','761102',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141478,569,'Hukuma B.O','761108',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141479,569,'Humuki B.O','761111',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141480,569,'Indragada B.O','761125',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141481,569,'Inginathi B.O','761140',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141482,569,'J.Balabhadrapur B.O','761013',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141483,569,'Jagamohan B.O','761114',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141484,569,'Jagannath Prasad S.O','761121',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141485,569,'Jahada B.O','761107',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141486,569,'Janibilli B.O','761107',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141487,569,'Jayapur B.O','761111',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141488,569,'Jhadabai B.O','761104',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141489,569,'Jhadabandha B.O','761114',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141490,569,'Jhadabhumi B.O','761120',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141491,569,'Jharapari B.O','761114',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141492,569,'Jillundi S.O','761133',1,0,'2022-03-04 19:33:11','2022-03-04 19:33:11'),(141493,569,'Jorada B.O','761104',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141494,569,'K.Berhampur B.O','761140',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141495,569,'K.Jatabadi B.O','761108',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141496,569,'K.Karadakana B.O','761106',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141497,569,'K.Nuagada B.O','761123',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141498,569,'Kabisuryanagar S.O','761104',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141499,569,'Kachakhandi B.O','761106',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141500,569,'Kadapada B.O','761121',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141501,569,'Kadua B.O','761121',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141502,569,'Kalasandhapur B.O','761111',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141503,569,'Kaliaguda B.O','761124',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141504,569,'Kalingapadar B.O','761131',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141505,569,'Kamagada B.O','761122',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141506,569,'Kanabhaga B.O','761140',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141507,569,'Kanachhai` B.O','761118',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141508,569,'Kanasukha B.O','761118',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141509,569,'Kanchuru S.O','761101',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141510,569,'Kaniary B.O','761111',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141511,569,'Karachulli S.O','761143',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141512,569,'Karada B.O','761151',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141513,569,'Karadabadi (A) B.O','761117',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141514,569,'Karasinghi B.O','761143',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141515,569,'Kaudia B.O','761144',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141516,569,'Kendupadar B.O','761122',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141517,569,'Khairaputi B.O','761123',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141518,569,'Khallingi B.O','761013',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141519,569,'Khamaredi B.O','761125',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141520,569,'Khamarpalli B.O','761120',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141521,569,'Khambeswari Patna S.O','761110',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141522,569,'Kharia B.O','761111',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141523,569,'Kharida B.O','761102',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141524,569,'Khetamundali B.O','761131',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141525,569,'Khetribarapur B.O','761123',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141526,569,'Kholakhalli B.O','761118',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141527,569,'Kirapalli B.O','761119',1,0,'2022-03-04 19:33:12','2022-03-04 19:33:12'),(141528,569,'Kokolamba B.O','761131',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141529,569,'Konkarada S.O','761144',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141530,569,'Kotinada B.O','761111',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141531,569,'Kudutei B.O','761119',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141532,569,'Kullada S.O','761131',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141533,569,'Kullagada B.O','761106',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141534,569,'Kullangi B.O','761124',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141535,569,'Kumarpani B.O','761106',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141536,569,'Kumbhari B.O','761111',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141537,569,'Kumpapada B.O','761121',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141538,569,'Kumundi B.O','761121',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141539,569,'Kupati B.O','761141',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141540,569,'Kurla B.O','761144',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141541,569,'Kusuraba B.O','761114',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141542,569,'Lalsingh B.O','761125',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141543,569,'Landajuali B.O','761122',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141544,569,'Lathipada B.O','761108',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141545,569,'Lembhai B.O','761131',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141546,569,'Madhabarida B.O','761124',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141547,569,'Mahachhai B.O','761103',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141548,569,'Mahanal B.O','761013',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141549,569,'Mahupadar B.O','761106',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141550,569,'Makarjhola B.O','761101',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141551,569,'Malaspadar B.O','761133',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141552,569,'Mandar B.O','761117',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141553,569,'Mangalpur B.O','761115',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141554,569,'Mangalpur B.O','761117',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141555,569,'Manikyapur B.O','761107',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141556,569,'Manitara B.O','761118',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141557,569,'Masabadi B.O','761131',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141558,569,'Merikote B.O','761109',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141559,569,'Mohaguda B.O','761132',1,0,'2022-03-04 19:33:13','2022-03-04 19:33:13'),(141560,569,'Motabadi B.O','761118',1,0,'2022-03-04 19:33:14','2022-03-04 19:33:14'),(141561,569,'Mujjagada S.O','761132',1,0,'2022-03-04 19:33:14','2022-03-04 19:33:14'),(141562,569,'Mundamarai S.O','761114',1,0,'2022-03-04 19:33:14','2022-03-04 19:33:14'),(141563,569,'Munigadi B.O','761122',1,0,'2022-03-04 19:33:14','2022-03-04 19:33:14'),(141564,569,'Nalabanta B.O','761111',1,0,'2022-03-04 19:33:14','2022-03-04 19:33:14'),(141565,569,'Nandiko B.O','761102',1,0,'2022-03-04 19:33:14','2022-03-04 19:33:14'),(141566,569,'Narendrapur B.O','761103',1,0,'2022-03-04 19:33:14','2022-03-04 19:33:14'),(141567,569,'Nettanga B.O','761124',1,0,'2022-03-04 19:33:14','2022-03-04 19:33:14'),(141568,569,'Nimapadar B.O','761120',1,0,'2022-03-04 19:33:14','2022-03-04 19:33:14'),(141569,569,'Nimina S.O','761122',1,0,'2022-03-04 19:33:14','2022-03-04 19:33:14'),(141570,569,'Nuagada B.O','761107',1,0,'2022-03-04 19:33:14','2022-03-04 19:33:14'),(141571,569,'Nuagam S.O','761111',1,0,'2022-03-04 19:33:14','2022-03-04 19:33:14'),(141572,569,'Nunipadasasan B.O','761123',1,0,'2022-03-04 19:33:14','2022-03-04 19:33:14'),(141573,569,'P.Jagannathpur B.O','761013',1,0,'2022-03-04 19:33:14','2022-03-04 19:33:14'),(141574,569,'P.Padmabanhpur B.O','761101',1,0,'2022-03-04 19:33:14','2022-03-04 19:33:14'),(141575,569,'P.Ramachandrapur B.O','761013',1,0,'2022-03-04 19:33:14','2022-03-04 19:33:14'),(141576,569,'Padmapur B.O','761109',1,0,'2022-03-04 19:33:14','2022-03-04 19:33:14'),(141577,569,'Paikajamuna B.O','761104',1,0,'2022-03-04 19:33:14','2022-03-04 19:33:14'),(141578,569,'Pailipada B.O','761123',1,0,'2022-03-04 19:33:14','2022-03-04 19:33:14'),(141579,569,'Palakasandha B.O','761123',1,0,'2022-03-04 19:33:14','2022-03-04 19:33:14'),(141580,569,'Palakatu B.O','761108',1,0,'2022-03-04 19:33:14','2022-03-04 19:33:14'),(141581,569,'Panchabhuti B.O','761121',1,0,'2022-03-04 19:33:14','2022-03-04 19:33:14'),(141582,569,'Pandiapathara B.O','761116',1,0,'2022-03-04 19:33:14','2022-03-04 19:33:14'),(141583,569,'Pangidi B.O','761118',1,0,'2022-03-04 19:33:14','2022-03-04 19:33:14'),(141584,569,'Pantikhari B.O','761119',1,0,'2022-03-04 19:33:14','2022-03-04 19:33:14'),(141585,569,'Patadhar B.O','761120',1,0,'2022-03-04 19:33:14','2022-03-04 19:33:14'),(141586,569,'Pathara B.O','761104',1,0,'2022-03-04 19:33:15','2022-03-04 19:33:15'),(141587,569,'Patrapalli B.O','761119',1,0,'2022-03-04 19:33:15','2022-03-04 19:33:15'),(141588,569,'Pattapur S.O','761013',1,0,'2022-03-04 19:33:15','2022-03-04 19:33:15'),(141589,569,'Patulisahi B.O','761140',1,0,'2022-03-04 19:33:15','2022-03-04 19:33:15'),(141590,569,'Pitala S.O','761103',1,0,'2022-03-04 19:33:15','2022-03-04 19:33:15'),(141591,569,'Podingi B.O','761103',1,0,'2022-03-04 19:33:15','2022-03-04 19:33:15'),(141592,569,'Pratapur B.O','761119',1,0,'2022-03-04 19:33:15','2022-03-04 19:33:15'),(141593,569,'Putiapadar B.O','761102',1,0,'2022-03-04 19:33:15','2022-03-04 19:33:15'),(141594,569,'Raghunath Nagar S.O (Ganjam)','761110',1,0,'2022-03-04 19:33:15','2022-03-04 19:33:15'),(141595,569,'Rai Bandha B.O','761109',1,0,'2022-03-04 19:33:15','2022-03-04 19:33:15'),(141596,569,'Ralaba B.O','761102',1,0,'2022-03-04 19:33:15','2022-03-04 19:33:15'),(141597,569,'Ramachandrapur B.O','761103',1,0,'2022-03-04 19:33:15','2022-03-04 19:33:15'),(141598,569,'Ramanabadi B.O','761151',1,0,'2022-03-04 19:33:15','2022-03-04 19:33:15'),(141599,569,'Ranaba B.O','761108',1,0,'2022-03-04 19:33:15','2022-03-04 19:33:15'),(141600,569,'Ratnapur B.O','761108',1,0,'2022-03-04 19:33:15','2022-03-04 19:33:15'),(141601,569,'Rauti B.O','761121',1,0,'2022-03-04 19:33:15','2022-03-04 19:33:15'),(141602,569,'Rudhapadar B.O','761131',1,0,'2022-03-04 19:33:15','2022-03-04 19:33:15'),(141603,569,'Rugumu B.O','761107',1,0,'2022-03-04 19:33:15','2022-03-04 19:33:15'),(141604,569,'Rumagada B.O','761117',1,0,'2022-03-04 19:33:15','2022-03-04 19:33:15'),(141605,569,'S.Ambagam B.O','761101',1,0,'2022-03-04 19:33:15','2022-03-04 19:33:15'),(141606,569,'S.Gopalpur B.O','761106',1,0,'2022-03-04 19:33:15','2022-03-04 19:33:15'),(141607,569,'Saba B.O','761107',1,0,'2022-03-04 19:33:15','2022-03-04 19:33:15'),(141608,569,'Sahaspur B.O','761115',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141609,569,'Samarbandha B.O','761121',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141610,569,'Samarjhola B.O','761101',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141611,569,'Sanakodanda B.O','761125',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141612,569,'Sandhikendu B.O','761109',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141613,569,'Sankuru B.O','761118',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141614,569,'Sapuapalli B.O','761101',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141615,569,'Sarabadi B.O','761108',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141616,569,'Saru B.O','761101',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141617,569,'Seragada S.O','761106',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141618,569,'Sialia B.O','761104',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141619,569,'Sidhanoi B.O','761116',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141620,569,'Sidhapur B.O','761109',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141621,569,'Sikiri B.O','761102',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141622,569,'Sodak B.O','761118',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141623,569,'Sorisbilli B.O','761108',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141624,569,'Subalaya B.O','761111',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141625,569,'Sunambo Street S.O','761110',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141626,569,'Sunapalli B.O','761104',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141627,569,'Surada Bazar B.O','761108',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141628,569,'Surada S.O','761108',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141629,569,'Suramani B.O','761107',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141630,569,'T.O.Road S.O','761110',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141631,569,'Takarada B.O','761106',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141632,569,'Takarada B.O','761143',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141633,569,'Tanarada S.O','761140',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141634,569,'Tanhara B.O','761103',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141635,569,'Tankachhai B.O','761103',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141636,569,'Tarasinghi B.O','761131',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141637,569,'Tholadi B.O','761131',1,0,'2022-03-04 19:33:16','2022-03-04 19:33:16'),(141638,569,'Thuruburai B.O','761146',1,0,'2022-03-04 19:33:17','2022-03-04 19:33:17'),(141639,569,'Tilisinghi B.O','761131',1,0,'2022-03-04 19:33:17','2022-03-04 19:33:17'),(141640,569,'Turumu B.O','761131',1,0,'2022-03-04 19:33:17','2022-03-04 19:33:17'),(141641,569,'U. Dantilingi B.O','761151',1,0,'2022-03-04 19:33:17','2022-03-04 19:33:17'),(141642,569,'Udhra B.O','761119',1,0,'2022-03-04 19:33:17','2022-03-04 19:33:17'),(141643,569,'Agastinuagam B.O','761026',1,0,'2022-03-04 19:33:17','2022-03-04 19:33:17'),(141644,569,'Aitipur B.O','761029',1,0,'2022-03-04 19:33:17','2022-03-04 19:33:17'),(141645,569,'Alladigam B.O','761019',1,0,'2022-03-04 19:33:17','2022-03-04 19:33:17'),(141646,569,'Ambagaon B.O','761012',1,0,'2022-03-04 19:33:17','2022-03-04 19:33:17'),(141647,569,'Ambapur B.O','761005',1,0,'2022-03-04 19:33:17','2022-03-04 19:33:17'),(141648,569,'Andanda B.O','761005',1,0,'2022-03-04 19:33:17','2022-03-04 19:33:17'),(141649,569,'Angaragam B.O','761035',1,0,'2022-03-04 19:33:17','2022-03-04 19:33:17'),(141650,569,'Ankorada B.O','761012',1,0,'2022-03-04 19:33:17','2022-03-04 19:33:17'),(141651,569,'Ankuli B.O','760010',1,0,'2022-03-04 19:33:17','2022-03-04 19:33:17'),(141652,569,'Ankushpur B.O','761100',1,0,'2022-03-04 19:33:17','2022-03-04 19:33:17'),(141653,569,'Antaraba B.O','761017',1,0,'2022-03-04 19:33:17','2022-03-04 19:33:17'),(141654,569,'Antarigam B.O','761043',1,0,'2022-03-04 19:33:17','2022-03-04 19:33:17'),(141655,569,'Arakhapur B.O','761041',1,0,'2022-03-04 19:33:17','2022-03-04 19:33:17'),(141656,569,'Athagadapatna B.O','761105',1,0,'2022-03-04 19:33:17','2022-03-04 19:33:17'),(141657,569,'B.L.N.Pur B.O','761032',1,0,'2022-03-04 19:33:17','2022-03-04 19:33:17'),(141658,569,'B.L.N.Pur B.O','761011',1,0,'2022-03-04 19:33:17','2022-03-04 19:33:17'),(141659,569,'B.Nuagam B.O','761006',1,0,'2022-03-04 19:33:17','2022-03-04 19:33:17'),(141660,569,'B.Turubudi B.O','761007',1,0,'2022-03-04 19:33:17','2022-03-04 19:33:17'),(141661,569,'Bada Aryapalli B.O','761045',1,0,'2022-03-04 19:33:17','2022-03-04 19:33:17'),(141662,569,'Badabaragam B.O','761018',1,0,'2022-03-04 19:33:17','2022-03-04 19:33:17'),(141663,569,'Badabaranga B.O','761004',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141664,569,'Badachakada B.O','761019',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141665,569,'Badadumbala B.O','761042',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141666,569,'Badakhairakhama B.O','761035',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141667,569,'Badakhajahari B.O','761011',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141668,569,'Badakharida S.O','761041',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141669,569,'Badakhemundi Street S.O','760001',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141670,569,'Badakusasthali B.O','760007',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141671,569,'Badamadhapur B.O','761026',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141672,569,'Badamahuri B.O','761041',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141673,569,'Badapalanka B.O','761010',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141674,569,'Badapalli B.O','761029',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141675,569,'Badapur B.O','760007',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141676,569,'Badaputi B.O','761002',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141677,569,'Badarampalli B.O','761019',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141678,569,'Badhinuapalli B.O','761030',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141679,569,'Badiosta B.O','761054',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141680,569,'Baghala B.O','761003',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141681,569,'Bahadurpeta B.O','760007',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141682,569,'Baidyanathpur S.O','760004',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141683,569,'Ballijodi B.O','761042',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141684,569,'Ballipada S.O','761054',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141685,569,'Balunkeswarapur B.O','761030',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141686,569,'Banabulapalli B.O','761045',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141687,569,'Banamali B.O','761011',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141688,569,'Bania B.O','761030',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141689,569,'Bansola B.O','761006',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141690,569,'Banthapalli B.O','760002',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141691,569,'Banthapalli B.O','761105',1,0,'2022-03-04 19:33:18','2022-03-04 19:33:18'),(141692,569,'Barango B.O','761006',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141693,569,'Barasara B.O','761030',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141694,569,'Baritola B.O','761055',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141695,569,'Baulagam B.O','761026',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141696,569,'Baulojholi B.O','761100',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141697,569,'Beguniapada S.O','761031',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141698,569,'Bellagam B.O','761105',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141699,569,'Bellagam B.O','761003',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141700,569,'Bendalia B.O','760002',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141701,569,'Berhampur City S.O','760002',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141702,569,'Berhampur University S.O','760007',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141703,569,'Berhampur(GM) H.O','760001',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141704,569,'Beruanbadi B.O','761032',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141705,569,'Bhabandha B.O','761003',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141706,569,'Bhabarada B.O','761105',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141707,569,'Bhabinipur B.O','761001',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141708,569,'Bhapur Bazar S.O','760001',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141709,569,'Bharampur B.O','761209',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141710,569,'Bhatakumarada S.O','761003',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141711,569,'Bhejiput B.O','761029',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141712,569,'Bhikapada B.O','761029',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141713,569,'Bhikaripalli B.O','761045',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141714,569,'Bhimpur B.O','761004',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141715,569,'Bhutsarasingi B.O','761041',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141716,569,'Bijipur S.O','760001',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141717,569,'Bikrampur B.O','761029',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141718,569,'Biribatia B.O','761031',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141719,569,'Biruligada B.O','761028',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141720,569,'Bissmagiri S.O','761055',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141721,569,'Biswanathpur B.O','761008',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141722,569,'Bomokei S.O','761042',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141723,569,'Borida B.O','761031',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141724,569,'Borigam B.O','761001',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141725,569,'Boripadar B.O','761007',1,0,'2022-03-04 19:33:19','2022-03-04 19:33:19'),(141726,569,'Boxipalli B.O','761002',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141727,569,'Brajanagar','760001',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141728,569,'Budhamba B.O','761105',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141729,569,'Bupilingi B.O','761026',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141730,569,'Burujhuri Nuagam B.O','761035',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141731,569,'Burutal B.O','761005',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141732,569,'Ch.Tikarapada B.O','761209',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141733,569,'Chaitanyapur B.O','761007',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141734,569,'Chamakhandi B.O','761045',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141735,569,'Chanamari B.O','761014',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141736,569,'Chandipadar B.O','761003',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141737,569,'Chatamundali B.O','761043',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141738,569,'Chatrapur Bazar S.O','761020',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141739,569,'Chatrapur H.O','761020',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141740,569,'Chikalakhandi B.O','761026',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141741,569,'Chikarada B.O','761008',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141742,569,'Chikati Badapur B.O','761005',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141743,569,'Chikili B.O','761030',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141744,569,'Chikiti S.O','761010',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141745,569,'Chikitipentho B.O','761010',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141746,569,'Chingudighai B.O','761018',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141747,569,'Chingudikhola B.O','761032',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141748,569,'Chirakipadasasan B.O','761105',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141749,569,'Chudangapur B.O','761012',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141750,569,'Courtpeta S.O','760004',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141751,569,'Dabarsingi B.O','761011',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141752,569,'Dakhinpur B.O','760002',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141753,569,'Danapur B.O','761032',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141754,569,'Daspur B.O','760003',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141755,569,'Dauni B.O','761011',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141756,569,'Dayapalli B.O','761100',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141757,569,'Dekahli B.O','761042',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141758,569,'Dengapadar B.O','761054',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141759,569,'Dhobadipatapur B.O','761003',1,0,'2022-03-04 19:33:20','2022-03-04 19:33:20'),(141760,569,'Digapada B.O','761032',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141761,569,'Digapahandi S.O','761012',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141762,569,'Digapahandi Tahasil Colony S.O','761012',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141763,569,'Dimiria B.O','761028',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141764,569,'Dura B.O','760010',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141765,569,'Engineering School S.O','760010',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141766,569,'Gadasamantarapur B.O','761055',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141767,569,'Gandhinagar S.O (Ganjam)','760001',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141768,569,'Ganjam S.O','761026',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141769,569,'Ganju B.O','761002',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141770,569,'Gatebazar S.O','760001',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141771,569,'Girisola S.O','761009',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141772,569,'Gnagadahani B.O','761018',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141773,569,'Gochabadi B.O','761105',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141774,569,'Godagovindapur B.O','761011',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141775,569,'Godavarishanagar S.O','760001',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141776,569,'Goilundi S.O','760004',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141777,569,'Gokarnapur B.O','761012',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141778,569,'Golabandha S.O','761052',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141779,569,'Golagandapalli B.O','761028',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141780,569,'Golanda B.O','761007',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141781,569,'Golanthara S.O','761008',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141782,569,'Gondala B.O','761003',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141783,569,'Gopalpur S.O (Ganjam)','761002',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141784,569,'Gopinathpur B.O','761009',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141785,569,'Gopinathpur B.O','761100',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141786,569,'Gosaninuagam S.O','760003',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141787,569,'Gothagam B.O','761037',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141788,569,'Goudagam B.O','761011',1,0,'2022-03-04 19:33:21','2022-03-04 19:33:21'),(141789,569,'Gouradeipur B.O','761032',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141790,569,'Goutami B.O','761054',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141791,569,'Govindanagar B.O','761008',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141792,569,'Gudipadar B.O','761006',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141793,569,'Guhalpur B.O','761007',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141794,569,'Guma Dalaba B.O','761209',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141795,569,'Gundra B.O','761005',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141796,569,'Gurunthi B.O','761001',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141797,569,'Haladiapadar B.O','760003',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141798,569,'Haripur B.O','761009',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141799,569,'Haripur Burudi B.O','761027',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141800,569,'Hillpatna S.O','760005',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141801,569,'Hottapur B.O','761018',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141802,569,'Hugulapata B.O','761001',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141803,569,'Hukuma B.O','761209',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141804,569,'Humma S.O','761027',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141805,569,'Humuri B.O','761026',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141806,569,'Indrakhi B.O','761008',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141807,569,'Industrial Estates S.O','760008',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141808,569,'Jaccaro B.O','761042',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141809,569,'Jagadalapur B.O','761001',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141810,569,'Jagamohanapur B.O','761010',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141811,569,'Jagannathpur B.O','761003',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141812,569,'Jagilipadar B.O','761032',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141813,569,'Jakara B.O','761105',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141814,569,'Jamuni B.O','761018',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141815,569,'Jarada Ankuli B.O','761005',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141816,569,'Jaradagada S.O','761005',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141817,569,'Jayantipur S.O','761006',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141818,569,'Jayashree S.O','761025',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141819,569,'Jhadankuli B.O','761001',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141820,569,'Jharipadar B.O','761007',1,0,'2022-03-04 19:33:22','2022-03-04 19:33:22'),(141821,569,'Jhatipadar B.O','761009',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141822,569,'Kaithkhandi B.O','761007',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141823,569,'Kalabada B.O','761010',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141824,569,'Kalambo B.O','761105',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141825,569,'Kalidaspur B.O','761043',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141826,569,'Kallipalli B.O','761002',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141827,569,'Kalyanapur B.O','761026',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141828,569,'Kampa Khumbajhari B.O','761209',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141829,569,'Kanaka B.O','761028',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141830,569,'Kanamana B.O','761045',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141831,569,'Kanchana B.O','761031',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141832,569,'Kansamari B.O','761014',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141833,569,'Karapada B.O','761026',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141834,569,'Karapada B.O','761042',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141835,569,'Karatoli B.O','761026',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141836,569,'Kaviti Suvani B.O','761009',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141837,569,'Kelua B.O','761004',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141838,569,'Keluapalli B.O','760003',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141839,569,'Kendupata B.O','761030',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141840,569,'Kesaripada B.O','761006',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141841,569,'Khajapalli B.O','761029',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141842,569,'Khajipalli B.O','761019',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141843,569,'Khallikote College S.O','760001',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141844,569,'Khallikote RS S.O','761029',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141845,569,'Khallikote S.O','761030',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141846,569,'Khamarigam B.O','761055',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141847,569,'Khambarigam B.O','761004',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141848,569,'Khandadeuli B.O','761028',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141849,569,'Khanduru B.O','761105',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141850,569,'Khariaguda S.O','761209',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141851,569,'Kharnipada B.O','761037',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141852,569,'Kodala Bus Stand B.O','761032',1,0,'2022-03-04 19:33:23','2022-03-04 19:33:23'),(141853,569,'Kodala S.O','761032',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141854,569,'Kodala Tahasil Colony S.O','761032',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141855,569,'Koirasi B.O','761029',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141856,569,'Kolathia B.O','761010',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141857,569,'Komanda B.O','761019',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141858,569,'Konheipur B.O','761029',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141859,569,'Konika B.O','761008',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141860,569,'Konisi B.O','761008',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141861,569,'Kotharasingi B.O','761008',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141862,569,'Kottilingi B.O','761010',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141863,569,'Koturu B.O','761009',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141864,569,'Krupasindhupur B.O','761001',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141865,569,'Krushanapur B.O','761010',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141866,569,'Kukudakhandi S.O','761100',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141867,569,'Kumaripari B.O','761035',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141868,569,'Kusapada B.O','761012',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141869,569,'Kushadhipa B.O','761030',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141870,569,'L.N.Pur B.O','761011',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141871,569,'Ladigam B.O','760003',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141872,569,'Langaleswar B.O','761029',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141873,569,'Lanjipalli S.O','760008',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141874,569,'Lathi B.O','760002',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141875,569,'Laxmipur B.O','761003',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141876,569,'Lochapada B.O','761001',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141877,569,'Madhabandha B.O','761010',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141878,569,'Madhupalli B.O','761105',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141879,569,'Madhuruchua B.O','761028',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141880,569,'Mahanadapur B.O','761026',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141881,569,'Mallada B.O','761027',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141882,569,'Mandarada B.O','761209',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141883,569,'Manikyapur B.O','761042',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141884,569,'Mantridi B.O','761008',1,0,'2022-03-04 19:33:24','2022-03-04 19:33:24'),(141885,569,'Mardakote B.O','761032',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141886,569,'Mardamekha B.O','761032',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141887,569,'Markandi B.O','760003',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141888,569,'Mathasarasingi B.O','761032',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141889,569,'Mathura B.O','761030',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141890,569,'Mathura B.O','761105',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141891,569,'Matikhalo S.O','761045',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141892,569,'Maulabhanja B.O','761012',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141893,569,'Medical College S.O (Ganjam)','760004',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141894,569,'Mendrajpur B.O','761008',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141895,569,'Military Lines S.O','760001',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141896,569,'Minchinipatana S.O','761028',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141897,569,'Mohuda B.O','760002',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141898,569,'Moisanpur B.O','761004',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141899,569,'Morabai B.O','761043',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141900,569,'Mundala B.O','761032',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141901,569,'Mundapata B.O','761042',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141902,569,'Municipentho B.O','761026',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141903,569,'Nabeen S.O','760009',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141904,569,'Naikanipalli B.O','761031',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141905,569,'Nalihada B.O','761054',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141906,569,'Narayanapur B.O','761002',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141907,569,'Narayanapur B.O','761209',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141908,569,'Narendrappur B.O','761007',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141909,569,'Narendrapur B.O','760007',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141910,569,'Nimakhandi Pentho B.O','761055',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141911,569,'Nimakhandi S.O','761001',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141912,569,'Nuagaon B.O','761010',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141913,569,'Nuapada S.O','761011',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141914,569,'Nuapentho B.O','761037',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141915,569,'Odasingi B.O','761007',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141916,569,'Ollarigada B.O','761100',1,0,'2022-03-04 19:33:25','2022-03-04 19:33:25'),(141917,569,'P.Govindapur B.O','761014',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141918,569,'Padadigi B.O','761037',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141919,569,'Padmanavapur S.O','761007',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141920,569,'Padmapur B.O','760003',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141921,569,'Paladhuapalli B.O','761028',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141922,569,'Palasi B.O','761001',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141923,569,'Pallibandha B.O','761026',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141924,569,'Palur B.O','761027',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141925,569,'Panada B.O','761055',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141926,569,'Panchama B.O','761008',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141927,569,'Pandarakhalli B.O','761043',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141928,569,'Pandia S.O','761043',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141929,569,'Pandiripada B.O','761105',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141930,569,'Panditgam B.O','761029',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141931,569,'Panigrahipentho S.O','760006',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141932,569,'Park Street S.O','760002',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141933,569,'Pathara B.O','761029',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141934,569,'Patrapur S.O','761004',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141935,569,'Phasi B.O','761032',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141936,569,'Phasiguda B.O','761055',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141937,569,'Phulta B.O','760003',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141938,569,'Pitatoli B.O','761010',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141939,569,'Podapadar B.O','761026',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141940,569,'Poirasi B.O','761019',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141941,569,'Polango B.O','761028',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141942,569,'Polasara Nimina B.O','761105',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141943,569,'Polosara S.O','761105',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141944,569,'Pottalmpur B.O','761026',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141945,569,'Pratapur S.O (Ganjam)','761019',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141946,569,'Premnagar S.O (Ganjam)','760002',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141947,569,'Pudamari S.O','761014',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141948,569,'Puhundi B.O','761209',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141949,569,'Puruna Berhampur B.O','760002',1,0,'2022-03-04 19:33:26','2022-03-04 19:33:26'),(141950,569,'Purushottampur Nbs B.O','761018',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141951,569,'Purushottampur S.O','761018',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141952,569,'Pustapur B.O','761031',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141953,569,'R.Suvani B.O','761009',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141954,569,'Raijhola B.O','761100',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141955,569,'Rajpur B.O','761026',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141956,569,'Rama Sanarayanpur B.O','761041',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141957,569,'Rambha S.O','761028',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141958,569,'Ramchandrapur B.O','761010',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141959,569,'Rampa B.O','761010',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141960,569,'Ranajhali B.O','761018',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141961,569,'Rangailunda B.O','760007',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141962,569,'Rangipur B.O','760003',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141963,569,'Rondha B.O','761008',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141964,569,'Rukunigam B.O','761026',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141965,569,'S.B.Jagadevpur B.O','761209',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141966,569,'S.B.Pentho B.O','761037',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141967,569,'Sabulia B.O','761028',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141968,569,'Sahadev Tikirapada B.O','761055',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141969,569,'Sahapur B.O','761003',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141970,569,'Sahaspur B.O','761012',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141971,569,'Samantiapalli B.O','761004',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141972,569,'Sandhamula B.O','761035',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141973,569,'Sankarapur S.O','760006',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141974,569,'Sankuda B.O','761035',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141975,569,'Santoshpur B.O','761004',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141976,569,'Santoshpur B.O','761027',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141977,569,'Sarabhimpur B.O','761026',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141978,569,'Sasanapadar B.O','761008',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141979,569,'Satapahandia B.O','761100',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141980,569,'Saurachachina B.O','761031',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141981,569,'Shiala B.O','761008',1,0,'2022-03-04 19:33:27','2022-03-04 19:33:27'),(141982,569,'Sidheswara B.O','761054',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(141983,569,'Sikula B.O','761018',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(141984,569,'Sindurapur B.O','761045',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(141985,569,'Sitarampalli S.O','761020',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(141986,569,'Soma B.O','761018',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(141987,569,'Sonepur B.O','761009',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(141988,569,'Sriram Nagar S.O','760002',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(141989,569,'Sriramchandrapur B.O','761045',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(141990,569,'Suanakhala B.O','761005',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(141991,569,'Sumandala S.O','761035',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(141992,569,'Sunadei B.O','761008',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(141993,569,'Sunareddy B.O','761005',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(141994,569,'Sunathara B.O','761003',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(141995,569,'Surala B.O','761009',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(141996,569,'Surangi S.O','761037',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(141997,569,'Syamsundarpur B.O','761030',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(141998,569,'Talapada B.O','761030',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(141999,569,'Talapada B.O','761209',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(142000,569,'Talasara B.O','761035',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(142001,569,'Talasingi B.O','761007',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(142002,569,'Tandipur B.O','761037',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(142003,569,'Tanganapalli B.O','761003',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(142004,569,'Taratrini Hills B.O','761018',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(142005,569,'Tentulia B.O','761105',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(142006,569,'Tentuliapalli B.O','761029',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(142007,569,'Tinigharia B.O','761209',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(142008,569,'Tirida B.O','761031',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(142009,569,'Totipuram B.O','761006',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(142010,569,'Tumbagada B.O','761005',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(142011,569,'Turubudi B.O','761209',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(142012,569,'Upalaputti B.O','761002',1,0,'2022-03-04 19:33:28','2022-03-04 19:33:28'),(142013,569,'Venkataraipur B.O','761002',1,0,'2022-03-04 19:33:29','2022-03-04 19:33:29'),(142014,570,'Adhanga B.O','754119',1,0,'2022-03-04 19:33:29','2022-03-04 19:33:29'),(142015,570,'Adhangagarh B.O','754102',1,0,'2022-03-04 19:33:29','2022-03-04 19:33:29'),(142016,570,'Adheikul B.O','754132',1,0,'2022-03-04 19:33:29','2022-03-04 19:33:29'),(142017,570,'Alabol B.O','754108',1,0,'2022-03-04 19:33:29','2022-03-04 19:33:29'),(142018,570,'Alanahat S.O','754107',1,0,'2022-03-04 19:33:29','2022-03-04 19:33:29'),(142019,570,'Alando B.O','754130',1,0,'2022-03-04 19:33:29','2022-03-04 19:33:29'),(142020,570,'Alavar B.O','754108',1,0,'2022-03-04 19:33:29','2022-03-04 19:33:29'),(142021,570,'Alikanta B.O','754108',1,0,'2022-03-04 19:33:29','2022-03-04 19:33:29'),(142022,570,'Alipingal B.O','754103',1,0,'2022-03-04 19:33:29','2022-03-04 19:33:29'),(142023,570,'Alla B.O','754132',1,0,'2022-03-04 19:33:29','2022-03-04 19:33:29'),(142024,570,'Ambasal B.O','754119',1,0,'2022-03-04 19:33:29','2022-03-04 19:33:29'),(142025,570,'Amberi B.O','754162',1,0,'2022-03-04 19:33:29','2022-03-04 19:33:29'),(142026,570,'Ambiki B.O','754139',1,0,'2022-03-04 19:33:29','2022-03-04 19:33:29'),(142027,570,'Anakhia S.O','754102',1,0,'2022-03-04 19:33:29','2022-03-04 19:33:29'),(142028,570,'Anantapur B.O','754119',1,0,'2022-03-04 19:33:29','2022-03-04 19:33:29'),(142029,570,'Anolipatna B.O','754140',1,0,'2022-03-04 19:33:29','2022-03-04 19:33:29'),(142030,570,'Apandara B.O','754119',1,0,'2022-03-04 19:33:29','2022-03-04 19:33:29'),(142031,570,'Arilo B.O','754130',1,0,'2022-03-04 19:33:29','2022-03-04 19:33:29'),(142032,570,'Arodei B.O','754138',1,0,'2022-03-04 19:33:29','2022-03-04 19:33:29'),(142033,570,'Ashrampatana B.O','754103',1,0,'2022-03-04 19:33:29','2022-03-04 19:33:29'),(142034,570,'Atharbanki Rly Colony S.O','754120',1,0,'2022-03-04 19:33:29','2022-03-04 19:33:29'),(142035,570,'B.Jankoti B.O','754103',1,0,'2022-03-04 19:33:29','2022-03-04 19:33:29'),(142036,570,'Bachhalo B.O','754113',1,0,'2022-03-04 19:33:29','2022-03-04 19:33:29'),(142037,570,'Badamundilo B.O','754114',1,0,'2022-03-04 19:33:29','2022-03-04 19:33:29'),(142038,570,'Bagalpur B.O','754102',1,0,'2022-03-04 19:33:29','2022-03-04 19:33:29'),(142039,570,'Baharana B.O','754108',1,0,'2022-03-04 19:33:30','2022-03-04 19:33:30'),(142040,570,'Baigani B.O','754108',1,0,'2022-03-04 19:33:30','2022-03-04 19:33:30'),(142041,570,'Baijanga B.O','754106',1,0,'2022-03-04 19:33:30','2022-03-04 19:33:30'),(142042,570,'Balia B.O','754141',1,0,'2022-03-04 19:33:30','2022-03-04 19:33:30'),(142043,570,'Balikuda S.O','754108',1,0,'2022-03-04 19:33:30','2022-03-04 19:33:30'),(142044,570,'Balitutha B.O','754141',1,0,'2022-03-04 19:33:30','2022-03-04 19:33:30'),(142045,570,'Bansa B.O','754113',1,0,'2022-03-04 19:33:30','2022-03-04 19:33:30'),(142046,570,'Barakolikhala B.O','754142',1,0,'2022-03-04 19:33:30','2022-03-04 19:33:30'),(142047,570,'Baramundali B.O','754119',1,0,'2022-03-04 19:33:30','2022-03-04 19:33:30'),(142048,570,'Baredia B.O','754102',1,0,'2022-03-04 19:33:30','2022-03-04 19:33:30'),(142049,570,'Batira B.O','754140',1,0,'2022-03-04 19:33:30','2022-03-04 19:33:30'),(142050,570,'Begunia B.O','754136',1,0,'2022-03-04 19:33:30','2022-03-04 19:33:30'),(142051,570,'Bharalo B.O','754140',1,0,'2022-03-04 19:33:30','2022-03-04 19:33:30'),(142052,570,'Bhiranga B.O','754138',1,0,'2022-03-04 19:33:30','2022-03-04 19:33:30'),(142053,570,'Bhitarandhari B.O','754139',1,0,'2022-03-04 19:33:30','2022-03-04 19:33:30'),(142054,570,'Bhutmundai B.O','754141',1,0,'2022-03-04 19:33:30','2022-03-04 19:33:30'),(142055,570,'Bilaspur B.O','754162',1,0,'2022-03-04 19:33:30','2022-03-04 19:33:30'),(142056,570,'Biridiroad S.O','754111',1,0,'2022-03-04 19:33:30','2022-03-04 19:33:30'),(142057,570,'Bishanpur B.O','754135',1,0,'2022-03-04 19:33:30','2022-03-04 19:33:30'),(142058,570,'Bodal B.O','754113',1,0,'2022-03-04 19:33:30','2022-03-04 19:33:30'),(142059,570,'Borikhi B.O','754140',1,0,'2022-03-04 19:33:30','2022-03-04 19:33:30'),(142060,570,'Borikina S.O','754110',1,0,'2022-03-04 19:33:30','2022-03-04 19:33:30'),(142061,570,'Chanarpur B.O','754107',1,0,'2022-03-04 19:33:30','2022-03-04 19:33:30'),(142062,570,'Chasapada B.O','754106',1,0,'2022-03-04 19:33:30','2022-03-04 19:33:30'),(142063,570,'Chasikhand B.O','754102',1,0,'2022-03-04 19:33:30','2022-03-04 19:33:30'),(142064,570,'Chatra S.O (Jagatsinghapur)','754294',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142065,570,'Chatua B.O','754141',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142066,570,'Dagrpada B.O','754137',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142067,570,'Dainlo B.O','754137',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142068,570,'Debidol S.O','754109',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142069,570,'Dedhasurdeuli B.O','754104',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142070,570,'Deriki B.O','754113',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142071,570,'Dhanua B.O','754137',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142072,570,'Dhinkia B.O','754141',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142073,570,'Dhunpur B.O','754138',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142074,570,'Dihasahi B.O','754138',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142075,570,'Dihatartanga B.O','754103',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142076,570,'Ersama S.O','754139',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142077,570,'Gadama S.O','754159',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142078,570,'Galadhari B.O','754109',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142079,570,'Garam B.O','754138',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142080,570,'Garhbisunpur B.O','754110',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142081,570,'Ghodansa B.O','754107',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142082,570,'Gobardhanpur B.O','754140',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142083,570,'Goda B.O','754110',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142084,570,'Gopalpur B.O','754104',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142085,570,'Gopiakud B.O','754141',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142086,570,'Gorada B.O','754137',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142087,570,'Gothina B.O','754132',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142088,570,'Goudunipadia B.O','754107',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142089,570,'Govindpur B.O','754136',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142090,570,'Hajipur B.O','754111',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142091,570,'Harisinghpur B.O','754136',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142092,570,'Ibrisingh B.O','754138',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142093,570,'Ichhapur B.O','754108',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142094,570,'IOCL(Paradeep) S.O','754141',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142095,570,'Jagatsinghpur H.O','754103',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142096,570,'Jaipur B.O','754133',1,0,'2022-03-04 19:33:31','2022-03-04 19:33:31'),(142097,570,'Jamugaon B.O','754107',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142098,570,'Janakadeipur B.O','754110',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142099,570,'Japabhuan B.O','754139',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142100,570,'Jasapada B.O','754130',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142101,570,'Jhankad B.O','754138',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142102,570,'Jhimani B.O','754141',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142103,570,'Jirailo B.O','754139',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142104,570,'Kabalpur B.O','754136',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142105,570,'Kadamchhanda B.O','754135',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142106,570,'Kaduapada S.O','754106',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142107,570,'Kalarabank B.O','754132',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142108,570,'Kalio B.O','754108',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142109,570,'Kanakpur S.O','754136',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142110,570,'Kanipada B.O','754139',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142111,570,'Kanjiakan B.O','754110',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142112,570,'Katara B.O','754106',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142113,570,'Khalgaon B.O','754119',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142114,570,'Khorat B.O','754106',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142115,570,'Kiadingiri B.O','754140',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142116,570,'Kolar S.O','754162',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142117,570,'Kortal B.O','754103',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142118,570,'Korua B.O','754113',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142119,570,'Kosida B.O','754130',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142120,570,'Kothamul B.O','754140',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142121,570,'Kotian B.O','754106',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142122,570,'Krishnanandapur S.O','754135',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142123,570,'Krushnadaspur B.O','754106',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142124,570,'Kudanagari B.O','754134',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142125,570,'Kujang S.O','754141',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142126,570,'Kulakaijanga B.O','754111',1,0,'2022-03-04 19:33:32','2022-03-04 19:33:32'),(142127,570,'Kundeswar B.O','754107',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142128,570,'Kunjakothi B.O','754139',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142129,570,'Kuradha B.O','754136',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142130,570,'Lathanga B.O','754140',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142131,570,'Machhagaon S.O','754119',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142132,570,'Madhuban S.O (Jagatsinghapur)','754142',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142133,570,'Madhusudanpursasan B.O','754103',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142134,570,'Madhyasasan B.O','754111',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142135,570,'Mahilo B.O','754106',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142136,570,'Mahimadeipur B.O','754140',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142137,570,'Malanda B.O','754136',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142138,570,'Mandasahi S.O','754114',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142139,570,'Mangarajpur B.O','754141',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142140,570,'Manijanga S.O','754160',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142141,570,'Marichapur B.O','754119',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142142,570,'Mohiuddinpur B.O','754103',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142143,570,'Mudupur B.O','754106',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142144,570,'Mulugaon B.O','754106',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142145,570,'Nabapatna B.O','754103',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142146,570,'Nalibar S.O','754104',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142147,570,'Nandan B.O','754106',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142148,570,'Nandigram B.O','754113',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142149,570,'Naradia B.O','754108',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142150,570,'Narijanga B.O','754137',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142151,570,'Nati B.O','754103',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142152,570,'Naugaonhat S.O','754113',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142153,570,'Nimol B.O','754138',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142154,570,'Nowgang B.O','754109',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142155,570,'Nuagaon B.O','754141',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142156,570,'Nuapada B.O','754133',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142157,570,'Odisso B.O','754103',1,0,'2022-03-04 19:33:33','2022-03-04 19:33:33'),(142158,570,'Olarah B.O','754110',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142159,570,'Oskana B.O','754119',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142160,570,'Paida B.O','754138',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142161,570,'Palasa B.O','754103',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142162,570,'Palasol B.O','754103',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142163,570,'Palli B.O','754103',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142164,570,'Panchapalli B.O','754110',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142165,570,'Pandua B.O','754140',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142166,570,'Pankapal B.O','754140',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142167,570,'Paradeepgarh B.O','754141',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142168,570,'Paradeeplock B.O','754141',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142169,570,'Paradip S.O','754142',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142170,570,'Parahat B.O','754108',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142171,570,'Parbatipur B.O','754111',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142172,570,'Patanai B.O','754140',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142173,570,'Patenigaon B.O','754133',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142174,570,'Peteipur B.O','754106',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142175,570,'Pipalamadhaba B.O','754138',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142176,570,'Pokhariapada B.O','754138',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142177,570,'Porgadei B.O','754140',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142178,570,'Ppl Township S.O','754145',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142179,570,'Praharajpur B.O','754130',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142180,570,'Punanga B.O','754103',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142181,570,'Puran B.O','754102',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142182,570,'Purana Odapada B.O','754132',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142183,570,'Purunabasanta B.O','754104',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142184,570,'Radhanga B.O','754104',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142185,570,'Raghunathpur S.O (Jagatsinghapur)','754132',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142186,570,'Rahadinga B.O','754104',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142187,570,'Rahama S.O','754140',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142188,570,'Rahan B.O','754119',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142189,570,'Rambhadeipur B.O','754102',1,0,'2022-03-04 19:33:34','2022-03-04 19:33:34'),(142190,570,'Rasulpur B.O','754104',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142191,570,'Redhua B.O','754104',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142192,570,'Rohia B.O','754113',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142193,570,'S. Hazipur B.O','754138',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142194,570,'S.Basandhara B.O','754111',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142195,570,'S.Nalakani B.O','754141',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142196,570,'Sabhamul B.O','754103',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142197,570,'Sadeipur B.O','754132',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142198,570,'Sagadailo B.O','754103',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142199,570,'Saibirikantilo B.O','754114',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142200,570,'Salamanga B.O','754138',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142201,570,'Samanga B.O','754132',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142202,570,'Samantarapur B.O','754162',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142203,570,'Sana Adhanga B.O','754134',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142204,570,'Sangrampur B.O','754108',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142205,570,'Sankheswar B.O','754137',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142206,570,'Sanra B.O','754104',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142207,570,'Sarana B.O','754106',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142208,570,'Sardola B.O','754136',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142209,570,'Sector-21 S.O','754143',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142210,570,'Shikhar B.O','754113',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142211,570,'Sidhal B.O','754106',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142212,570,'Sirlonabagram B.O','754132',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142213,570,'Sitahlo B.O','754103',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142214,570,'Sompur Benahar B.O','754110',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142215,570,'Srirampur B.O','754138',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142216,570,'Sudarsan B.O','754162',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142217,570,'Svm College S.O','754103',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142218,570,'Taladanda B.O','754141',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142219,570,'Tandikul B.O','754138',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142220,570,'Taradapada B.O','754103',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142221,570,'Tarajanga B.O','754137',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142222,570,'Tarikund B.O','754102',1,0,'2022-03-04 19:33:35','2022-03-04 19:33:35'),(142223,570,'Tarpur S.O','754133',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142224,570,'Tentoi B.O','754113',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142225,570,'Tentulibelari B.O','754119',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142226,570,'Tentulipada B.O','754136',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142227,570,'Tertang B.O','754108',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142228,570,'Tiran S.O','754138',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142229,570,'Tirtol S.O','754137',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142230,570,'Titira B.O','754110',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142231,570,'Tulang B.O','754138',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142232,570,'Ukundara B.O','754111',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142233,571,'Abdalpur B.O','755016',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142234,571,'Abhimanyu Balia B.O','755005',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142235,571,'Achyut Basant B.O','754205',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142236,571,'Adampur B.O','755009',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142237,571,'Ahiyas S.O','755036',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142238,571,'Alakundanuagaon B.O','755013',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142239,571,'Amploba B.O','755018',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142240,571,'Andhari B.O','755019',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142241,571,'Angalo B.O','755004',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142242,571,'Angalo Madhusudanpur B.O','755004',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142243,571,'Anikana B.O','755010',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142244,571,'Ankula S.O','755001',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142245,571,'Antia B.O','755023',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142246,571,'Arabal B.O','755005',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142247,571,'Aranga Purusottampur B.O','755007',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142248,571,'Ardaulia B.O','755036',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142249,571,'Arei S.O','755027',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142250,571,'Areikana B.O','755008',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142251,571,'Arjunpur Brahmachari Patna B.O','755036',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142252,571,'Aruha B.O','755024',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142253,571,'Aswasthapal B.O','755019',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142254,571,'Atta B.O','755018',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142255,571,'Aunri B.O','755013',1,0,'2022-03-04 19:33:36','2022-03-04 19:33:36'),(142256,571,'Bachhalo B.O','755012',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142257,571,'Bada Damodarpur B.O','755016',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142258,571,'Badabanta B.O','755009',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142259,571,'Badabiruan B.O','755015',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142260,571,'Bahdalpur B.O','755009',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142261,571,'Baidyarajpur B.O','755007',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142262,571,'Bainsiria B.O','755017',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142263,571,'Balamukulihat B.O','755012',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142264,571,'Balarampur Talagada B.O','755023',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142265,571,'Balibili B.O','755003',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142266,571,'Balichandrapur S.O','754205',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142267,571,'Bamdevpur B.O','755014',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142268,571,'Banamalipur B.O','755008',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142269,571,'Bandhadihi B.O','755005',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142270,571,'Bandhamunda B.O','755062',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142271,571,'Bangra B.O','755016',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142272,571,'Baniapal B.O','755027',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142273,571,'Bankamuhani B.O','755007',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142274,571,'Banshipur B.O','755012',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142275,571,'Barabati B.O','755008',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142276,571,'Barada Cuttack B.O','754205',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142277,571,'Baragadia B.O','755026',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142278,571,'Barapada B.O','755004',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142279,571,'Bari Cuttack S.O','755003',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142280,571,'Bari Kalamatia B.O','755003',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142281,571,'Barikul B.O','755014',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142282,571,'Barundai S.O','755025',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142283,571,'Batijoda B.O','755023',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142284,571,'Benipur B.O','754292',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142285,571,'Beruda B.O','755043',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142286,571,'Bhubaneswarpur B.O','755043',1,0,'2022-03-04 19:33:37','2022-03-04 19:33:37'),(142287,571,'Bhuinpur B.O','755043',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142288,571,'Bhurunga B.O','755017',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142289,571,'Binjharpur S.O','755004',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142290,571,'Biripatta B.O','755013',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142291,571,'Bodua B.O','755027',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142292,571,'Brahamanigaon B.O','755027',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142293,571,'Brahmabarada S.O','755005',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142294,571,'Chandia B.O','754292',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142295,571,'Chandikhol S.O','755044',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142296,571,'Charinangal S.O','754292',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142297,571,'Chasakhanda B.O','755013',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142298,571,'Chhatisdebil B.O','755017',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142299,571,'Chhatrapara B.O','755013',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142300,571,'Chingudipal B.O','755028',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142301,571,'Chitalo S.O','755062',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142302,571,'Chitri Gobardhanpur B.O','755019',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142303,571,'Dala B.O','755019',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142304,571,'Damodarpur B.O','755018',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142305,571,'Dangadi S.O','755026',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142306,571,'Dankarisahi B.O','755019',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142307,571,'Darpanigarh B.O','755044',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142308,571,'Dasarathpur S.O','755006',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142309,571,'Debidwar S.O','755007',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142310,571,'Dehurianandapur B.O','755006',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142311,571,'Deoda B.O','755005',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142312,571,'Derakundi B.O','755009',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142313,571,'Deulatara B.O','755016',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142314,571,'Dhaneswar B.O','755022',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142315,571,'Dhanipur B.O','755011',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142316,571,'Dharmasala S.O','755008',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142317,571,'Dharpur B.O','755003',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142318,571,'Dolagram Damodarpur B.O','755013',1,0,'2022-03-04 19:33:38','2022-03-04 19:33:38'),(142319,571,'Dolipur S.O','755019',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142320,571,'Dubakana B.O','755011',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142321,571,'Duburi B.O','755026',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142322,571,'Dulakhapatna B.O','755025',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142323,571,'Endal B.O','755023',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142324,571,'Erabanka B.O','755017',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142325,571,'Fatehpur B.O','755012',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142326,571,'Ferro Chrome Project S.O','755020',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142327,571,'Garhmadhupur B.O','755023',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142328,571,'Gobardhanpur B.O','755019',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142329,571,'Gobarghati B.O','755026',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142330,571,'Golkunda B.O','755005',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142331,571,'Gopabandhunagar B.O','755036',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142332,571,'Gopalpur Taranda B.O','755025',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142333,571,'Guhali B.O','755027',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142334,571,'Haladidiha B.O','755016',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142335,571,'Haridaspur S.O','755024',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142336,571,'Haripur B.O','755005',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142337,571,'Haripur Hat B.O','755009',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142338,571,'Haripur Jemadeipur B.O','755018',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142339,571,'Hasinpur B.O','755017',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142340,571,'Hatasahi Kutchery B.O','755016',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142341,571,'Hatibari B.O','755018',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142342,571,'Hatsahi B.O','755043',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142343,571,'Isanpur B.O','755005',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142344,571,'Iswarpur B.O','755011',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142345,571,'Jabara B.O','755023',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142346,571,'Jahanpur B.O','755007',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142347,571,'Jajpur Bazar S.O','755001',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142348,571,'Jajpur College S.O','755001',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142349,571,'Jajpur H.O','755001',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142350,571,'Jajpur Road RS S.O','755019',1,0,'2022-03-04 19:33:39','2022-03-04 19:33:39'),(142351,571,'Jakhapura B.O','755026',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142352,571,'Janakanalkul B.O','755005',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142353,571,'Janapada B.O','755005',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142354,571,'Janha B.O','755019',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142355,571,'Jaraka S.O','755050',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142356,571,'Jari B.O','755016',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142357,571,'Jayantara B.O','755006',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142358,571,'Jenapur S.O','755023',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142359,571,'Jhalpada B.O','755005',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142360,571,'Jharanga B.O','755062',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142361,571,'Kabatabandha B.O','755023',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142362,571,'Kabirpur S.O','755009',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142363,571,'Kadampal B.O','755008',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142364,571,'Kaima B.O','755008',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142365,571,'Kaipara S.O','755010',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142366,571,'Kakudikuda B.O','755005',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142367,571,'Kalan B.O','755008',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142368,571,'Kalaringatta S.O','755028',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142369,571,'Kalashree Gopalpur B.O','754292',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142370,571,'Kaliapani B.O','755028',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142371,571,'Kalyanpur B.O','755012',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142372,571,'Kamagarh B.O','755043',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142373,571,'Kamalpur B.O','755036',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142374,571,'Kamardihi B.O','755011',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142375,571,'Kandiahat B.O','755016',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142376,571,'Kanikapara B.O','755011',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142377,571,'Kankadapal B.O','755018',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142378,571,'Kansa B.O','755028',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142379,571,'Kantapari B.O','755006',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142380,571,'Kantar B.O','755022',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142381,571,'Kantigadia S.O','755049',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142382,571,'Kantipur B.O','755004',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142383,571,'Kapasichhaka B.O','755062',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142384,571,'Kapila B.O','755004',1,0,'2022-03-04 19:33:40','2022-03-04 19:33:40'),(142385,571,'Katikata B.O','755014',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142386,571,'Kayan B.O','755011',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142387,571,'Khadianga B.O','755049',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142388,571,'Khairabad B.O','755007',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142389,571,'Khanditar B.O','755009',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142390,571,'Khannagar B.O','755011',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142391,571,'Khosalpur B.O','755006',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142392,571,'Khurunti B.O','755026',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142393,571,'Kiajhar B.O','755019',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142394,571,'Kodandpur B.O','755007',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142395,571,'Korei S.O','755022',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142396,571,'Kotapur B.O','755008',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142397,571,'Krushnapur Sasan B.O','755049',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142398,571,'Kuanlo B.O','755013',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142399,571,'Kuanrapur B.O','755014',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142400,571,'Kuhika B.O','755018',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142401,571,'Kujhalo B.O','755017',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142402,571,'Kumbhiragadia B.O','755026',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142403,571,'Kumbhuka B.O','755027',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142404,571,'Kundapatna B.O','755008',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142405,571,'Kusupur B.O','754205',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142406,571,'Kutchery Gaon B.O','755009',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142407,571,'Lalbag B.O','755007',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142408,571,'Laxminagar B.O','755015',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142409,571,'Lembo B.O','755018',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142410,571,'M.D.Jemapur B.O','755017',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142411,571,'Madhubanhat B.O','755009',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142412,571,'Madhusudanpur B.O','755023',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142413,571,'Mahisara B.O','755023',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142414,571,'Malapara B.O','755043',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142415,571,'Mallikapur B.O','755036',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142416,571,'Mamadulla B.O','755006',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142417,571,'Mandari B.O','755003',1,0,'2022-03-04 19:33:41','2022-03-04 19:33:41'),(142418,571,'Mangalpur B.O','755018',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142419,571,'Mangalpur S.O (Jajapur)','755011',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142420,571,'Mangarajpur B.O','755009',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142421,571,'Manitira B.O','755026',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142422,571,'Marjitpur B.O','755023',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142423,571,'Markandapur B.O','755062',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142424,571,'Mashra S.O','755012',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142425,571,'Masudpur B.O','755043',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142426,571,'Meduakul B.O','755003',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142427,571,'Merdakatia Chhak B.O','755006',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142428,571,'Mirchandpur B.O','755062',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142429,571,'Mirzapur B.O','755008',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142430,571,'Mohanpur B.O','755004',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142431,571,'Mohantypatna B.O','755036',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142432,571,'Mugupal B.O','755009',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142433,571,'Mukundapur B.O','755025',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142434,571,'Nachhipura B.O','755019',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142435,571,'Nadiabhanga B.O','755026',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142436,571,'Naguan B.O','755019',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142437,571,'Nahangapatna B.O','755008',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142438,571,'Nakhei B.O','755007',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142439,571,'Nalipur B.O','754205',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142440,571,'Namtara B.O','755016',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142441,571,'Nandipur B.O','755006',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142442,571,'Narangochha B.O','755036',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142443,571,'Nathapur B.O','755003',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142444,571,'Nathsahi B.O','755007',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142445,571,'Nehapara B.O','755014',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142446,571,'Neulpur B.O','755024',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142447,571,'Oddisso Andeigoda B.O','755008',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142448,571,'Olei Chandanpur B.O','755016',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142449,571,'Ollalo B.O','755026',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142450,571,'Pachhikote B.O','755019',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142451,571,'Pahanga B.O','755015',1,0,'2022-03-04 19:33:42','2022-03-04 19:33:42'),(142452,571,'Palatpur B.O','755011',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142453,571,'Palei B.O','754205',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142454,571,'Panikoili S.O','755043',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142455,571,'Pankapal Sasan B.O','755026',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142456,571,'Paripada Nizampur B.O','755011',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142457,571,'Patranga B.O','755019',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142458,571,'Patuli B.O','755019',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142459,571,'Pingal B.O','755026',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142460,571,'Prathamakhandi B.O','755008',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142461,571,'Pritipur S.O','755013',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142462,571,'Pubasahi B.O','755006',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142463,571,'Purbakote B.O','755022',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142464,571,'Purunabaulamal B.O','755023',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142465,571,'Rachhipur B.O','755019',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142466,571,'Ragadi B.O','755019',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142467,571,'Rahasoi B.O','755062',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142468,571,'Raipur B.O','754292',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142469,571,'Rajapur B.O','755003',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142470,571,'Rajendrapur B.O','755009',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142471,571,'Rakabi Bazar B.O','755009',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142472,571,'Ramachandrapur B.O','755003',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142473,571,'Ramakrishnapur B.O','755022',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142474,571,'Rambag S.O','755014',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142475,571,'Ranagundi B.O','755026',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142476,571,'Ranigoda B.O','755025',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142477,571,'Ranipada B.O','755019',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142478,571,'Ranpur B.O','755012',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142479,571,'Ransol B.O','755028',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142480,571,'Rasulpur B.O','755009',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142481,571,'Ratalang B.O','755004',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142482,571,'Ratnagiri B.O','754214',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142483,571,'Rekhideipur B.O','755023',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142484,571,'Rudrapur B.O','755005',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142485,571,'Rurhiya B.O','755043',1,0,'2022-03-04 19:33:43','2022-03-04 19:33:43'),(142486,571,'Sadanandapur B.O','755009',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142487,571,'Sahupara B.O','755003',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142488,571,'Salijanga B.O','755026',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142489,571,'Samantarapur B.O','755009',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142490,571,'Sanakuanlo B.O','755011',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142491,571,'Sankhachilla S.O','755015',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142492,571,'Sarada Mukundapur B.O','755023',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142493,571,'Sasanda B.O','755027',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142494,571,'Saudia B.O','754292',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142495,571,'Sayedpur B.O','755027',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142496,571,'Sherpur B.O','755010',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142497,571,'Siha B.O','755044',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142498,571,'Simulia B.O','755007',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142499,571,'Singhapur B.O','755008',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142500,571,'Singhpur S.O (Jajapur)','755016',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142501,571,'Sipura B.O','754205',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142502,571,'Sobra S.O','755019',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142503,571,'Solempur B.O','755007',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142504,571,'Sribantapur B.O','755015',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142505,571,'Sridharpur B.O','755062',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142506,571,'Sujanpur S.O (Jajapur)','755017',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142507,571,'Sukinda S.O','755018',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142508,571,'Taharpur B.O','755019',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142509,571,'Talabandha B.O','755004',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142510,571,'Tarakote B.O','755025',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142511,571,'Taranga Sagarpur B.O','755006',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142512,571,'Thannual B.O','755024',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142513,571,'Tina B.O','755012',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142514,571,'Tulasipur B.O','755025',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142515,571,'Tulati B.O','755022',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142516,571,'Udaypur B.O','755017',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142517,571,'Udranga B.O','755014',1,0,'2022-03-04 19:33:44','2022-03-04 19:33:44'),(142518,571,'Uttangara B.O','755014',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142519,571,'Uttarkulhat B.O','755013',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142520,571,'Votka B.O','755009',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142521,571,'Arakhpur B.O','754024',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142522,571,'Badachana B.O','754296',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142523,571,'Bajapura B.O','754023',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142524,571,'Bandalo B.O','754023',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142525,571,'Bantala B.O','754024',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142526,571,'Barithengarh B.O','754024',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142527,571,'Barunia B.O','754082',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142528,571,'Bidyadharpur B.O','754024',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142529,571,'Byree S.O','754082',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142530,571,'Chandital B.O','754024',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142531,571,'Chhatia S.O','754023',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142532,571,'Dhanmandal S.O','754024',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142533,571,'Gobindapursidhagiri B.O','754023',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142534,571,'Kalakala B.O','754082',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142535,571,'Koudakol B.O','754024',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142536,571,'Rudrapur B.O','754023',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142537,571,'Sakuntalapur B.O','754024',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142538,571,'Salapada B.O','754082',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142539,571,'Samsarpur B.O','754023',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142540,571,'Sungura S.O (Jajapur)','754296',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142541,571,'Bangorekota B.O','758025',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142542,571,'Uchhabali B.O','758025',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142543,572,'Aintapali B.O','768215',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142544,572,'Arda B.O','768202',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142545,572,'Attabira B.O','768226',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142546,572,'Badmal B.O','768202',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142547,572,'Bagdehi S.O','768220',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142548,572,'Bagmunda B.O','768219',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142549,572,'Bandhbahal Colony S.O','768211',1,0,'2022-03-04 19:33:45','2022-03-04 19:33:45'),(142550,572,'Banjari B.O','768217',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142551,572,'Belpahar Rs S.O','768217',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142552,572,'Belpahar S.O','768218',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142553,572,'Bhalupatra B.O','768220',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142554,572,'Bhatlaida B.O','768213',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142555,572,'Bhaurkhol B.O','768219',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142556,572,'Bhimjore B.O','768220',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142557,572,'Brajarajnagar S.O','768216',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142558,572,'Chandinimal B.O','768216',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142559,572,'Charpali B.O','768226',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142560,572,'Charpali-barpali B.O','768211',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142561,572,'Chichinda B.O','768216',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142562,572,'Dalgaon B.O','768211',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142563,572,'Durlaga B.O','768204',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142564,572,'Ektali B.O','768202',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142565,572,'Gandghara B.O','768216',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142566,572,'Gudigaon B.O','768202',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142567,572,'H. Katapali B.O','768202',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142568,572,'Hirma B.O','768202',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142569,572,'I B B.O','768216',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142570,572,'Industrial Estate Jharsuguda S S.O','768203',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142571,572,'Itps Banaharpali S.O','768234',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142572,572,'Jharsuguda H.O','768201',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142573,572,'Jhirlapali B.O','768213',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142574,572,'Jorabaga B.O','768217',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142575,572,'K.M. Road Jharsuguda S.O','768202',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142576,572,'Kadamdihi B.O','768219',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142577,572,'Kanaktara B.O','768226',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142578,572,'Kandheikela B.O','768226',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142579,572,'Kapilapur B.O','768226',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142580,572,'Katabaga B.O','768225',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142581,572,'Kirmira B.O','768220',1,0,'2022-03-04 19:33:46','2022-03-04 19:33:46'),(142582,572,'Kolabira S.O','768213',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142583,572,'Kudabaga B.O','768219',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142584,572,'Kudaloi B.O','768217',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142585,572,'Laikera S.O','768215',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142586,572,'Lakhanpur S.O (Jharsuguda)','768219',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142587,572,'Lamptibahal B.O','768216',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142588,572,'Loisingh B.O','768216',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142589,572,'M. Katapali B.O','768226',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142590,572,'Malidihi B.O','768213',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142591,572,'Markuta B.O','768202',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142592,572,'Mochida B.O','768226',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142593,572,'Mudrajore B.O','768213',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142594,572,'N. Adhapara B.O','768234',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142595,572,'Naxapali B.O','768220',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142596,572,'Niktimal B.O','768213',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142597,572,'O.M.P. Line Jharsuguda S.O','768204',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142598,572,'Orient Colliery Brajarajnagar S.O','768233',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142599,572,'Panchgaon S.O','768226',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142600,572,'Panchpara B.O','768204',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142601,572,'Pandri B.O','768234',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142602,572,'Paramanandapur B.O','768213',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142603,572,'R. Kudapali B.O','768225',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142604,572,'Raghunathpali B.O','768213',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142605,572,'Rajpur B.O','768216',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142606,572,'Ramella B.O','768211',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142607,572,'Rampaluga (Reneda) B.O','768234',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142608,572,'Rampella B.O','768211',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142609,572,'Rampur Colliery S.O','768225',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142610,572,'Remta B.O','768226',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142611,572,'Sahaspur B.O','768215',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142612,572,'Samasingha B.O','768213',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142613,572,'Sarandamal B.O','768211',1,0,'2022-03-04 19:33:47','2022-03-04 19:33:47'),(142614,572,'Sarangloi B.O','768215',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142615,572,'Sarbahal S.O','768201',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142616,572,'Sr Brajarajnagar S.O','768216',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142617,572,'Sr Jharsuguda S.O','768201',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142618,572,'Sripura B.O','768202',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142619,572,'Sudang B.O','768215',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142620,572,'Sulahi B.O','768202',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142621,572,'Sunari B.O','768234',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142622,572,'Talmal B.O','768204',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142623,572,'Talpatia B.O','768204',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142624,572,'Thebra B.O','768219',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142625,572,'Ubuda B.O','768217',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142626,573,'Adhamunda B.O','766011',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142627,573,'Ainlabhata B.O','766018',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142628,573,'Ainlajore B.O','766015',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142629,573,'Ainli B.O','766019',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142630,573,'Alatara B.O','766102',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142631,573,'Ampani S.O','766028',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142632,573,'Arebeda B.O','766017',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142633,573,'Artal B.O','766036',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142634,573,'Atigaon B.O','766014',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142635,573,'Badbatua B.O','766002',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142636,573,'Badchergaon B.O','766011',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142637,573,'Badchhatrang B.O','766037',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142638,573,'Badfurla B.O','766015',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142639,573,'Badkarlakote B.O','766018',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142640,573,'Badkutru B.O','766018',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142641,573,'Badpodaguda B.O','766028',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142642,573,'Badpujhariguda B.O','766018',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142643,573,'Bagad B.O','766015',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142644,573,'Bagpur B.O','766100',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142645,573,'Baldiamal B.O','766023',1,0,'2022-03-04 19:33:48','2022-03-04 19:33:48'),(142646,573,'Bandhagaon B.O','766029',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142647,573,'Bandhakona B.O','766013',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142648,573,'Bandhapari B.O','766020',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142649,573,'Bandigaon B.O','766017',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142650,573,'Baner B.O','766018',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142651,573,'Banijora B.O','766014',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142652,573,'Barbandha B.O','766100',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142653,573,'Barbhata B.O','766036',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142654,573,'Bardanga B.O','766028',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142655,573,'Bargaon B.O','766036',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142656,573,'Basantapada B.O','766027',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142657,573,'Behera B.O','766103',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142658,573,'Beheraguda B.O','766103',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142659,573,'Belkhandi B.O','766012',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142660,573,'Bengaon B.O','766020',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142661,573,'Bhainriguda B.O','766014',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142662,573,'Bhainripalli B.O','766018',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142663,573,'Bhanpur B.O','766100',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142664,573,'Bhawanipatna B.B.Pada S.O','766001',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142665,573,'Bhawanipatna Collectorate S.O','766001',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142666,573,'Bhawanipatna CollegeSquare S.O','766001',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142667,573,'Bhawanipatna G.Chowk S.O','766002',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142668,573,'Bhawanipatna H.O','766001',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142669,573,'Bhawanipatna Naktiguda S.O','766001',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142670,573,'Bhawanipatna Stadium S.O','766001',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142671,573,'Bhejipadar B.O','766014',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142672,573,'Bhimkela B.O','766101',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142673,573,'Bhojpur B.O','766107',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142674,573,'Bhurtigarh B.O','766100',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142675,573,'Bijepur B.O','766027',1,0,'2022-03-04 19:33:49','2022-03-04 19:33:49'),(142676,573,'Bijmara B.O','766018',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142677,573,'Bimla B.O','766018',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142678,573,'Birikot B.O','766037',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142679,573,'Biswanathpur S.O','766020',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142680,573,'Boden B.O','766015',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142681,573,'Borda S.O','766036',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142682,573,'Boria B.O','766012',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142683,573,'Boringpadar B.O','766012',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142684,573,'Borpadar B.O','766102',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142685,573,'Brahmanchhendia B.O','766015',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142686,573,'Brahmaniguda B.O','766014',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142687,573,'Brundabahal B.O','766016',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142688,573,'Budhidhara B.O','766014',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142689,573,'Bundelguda B.O','766002',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142690,573,'Chahagaon B.O','766011',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142691,573,'Chahaka B.O','766011',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142692,573,'Chakuli B.O','766023',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142693,573,'Champadeipur B.O','766020',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142694,573,'Chancher B.O','766011',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142695,573,'Chapria B.O','766016',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142696,573,'Charbahal S.O','766017',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142697,573,'Chatrapur B.O','766027',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142698,573,'Cheliamal B.O','766011',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142699,573,'Chhanchanbahali B.O','766103',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142700,573,'Chhilipa B.O','766015',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142701,573,'Chichia B.O','766029',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142702,573,'Chichiaguda B.O','766014',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142703,573,'Chikilli B.O','766019',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142704,573,'Chilguda B.O','766014',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142705,573,'Chingersar B.O','766014',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142706,573,'Choriagarh B.O','766023',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142707,573,'Churagaon B.O','766013',1,0,'2022-03-04 19:33:50','2022-03-04 19:33:50'),(142708,573,'Cowdola B.O','766019',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142709,573,'Dadpur B.O','766002',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142710,573,'Dahagaon B.O','766017',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142711,573,'Dalguma B.O','766017',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142712,573,'Dasigaon B.O','766013',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142713,573,'Daspur B.O','766029',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142714,573,'Dedarha B.O','766014',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142715,573,'Dengaguda B.O','766019',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142716,573,'Dengakarlakhunta B.O','766102',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142717,573,'Deundi B.O','766023',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142718,573,'Deypur B.O','766013',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142719,573,'Deypur B.O','766002',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142720,573,'Dhamanpur B.O','766029',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142721,573,'Dhanarpur B.O','766103',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142722,573,'Dhansara B.O','766019',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142723,573,'Dhansuli B.O','766018',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142724,573,'Dharamgarh S.O','766015',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142725,573,'Duarsani B.O','766002',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142726,573,'Dudkathenga B.O','766028',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142727,573,'Dumerguda B.O','766029',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142728,573,'Dumerpadar B.O','766037',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142729,573,'Dumuria B.O','766036',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142730,573,'Dungariguda B.O','766017',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142731,573,'Dungrigaon B.O','766020',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142732,573,'Ekatara B.O','766102',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142733,573,'Farang B.O','766029',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142734,573,'Gadiajore B.O','766015',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142735,573,'Gajabahal B.O','766031',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142736,573,'Gambhariguda B.O','766019',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142737,573,'Gandamer B.O','766016',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142738,573,'Ghantamal B.O','766110',1,0,'2022-03-04 19:33:51','2022-03-04 19:33:51'),(142739,573,'Ghodabandha B.O','766100',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142740,573,'Ghumer B.O','766015',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142741,573,'Ghutrukhal B.O','766026',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142742,573,'Gigina B.O','766101',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142743,573,'Gochadangen B.O','766102',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142744,573,'Gokuleswar B.O','766011',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142745,573,'Golamunda S.O','766016',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142746,573,'Gondabahali B.O','766118',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142747,573,'Gopalpur B.O','766037',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142748,573,'Gopinathpur B.O','766020',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142749,573,'Gotamunda B.O','766103',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142750,573,'Goudchendia B.O','766023',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142751,573,'Gudialipadar B.O','766002',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142752,573,'Gunangbeda B.O','766100',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142753,573,'Gunpur B.O','766037',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142754,573,'Habaspur B.O','766023',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142755,573,'Hatikhoj B.O','766012',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142756,573,'Jaipatna S.O','766018',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142757,573,'Jayantpur B.O','766103',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142758,573,'Joradobra B.O','766102',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142759,573,'Jubrajpur B.O','766026',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142760,573,'Jugsaipatna B.O','766002',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142761,573,'Junagarh S.O','766014',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142762,573,'Kadalimunda B.O','766103',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142763,573,'Kalam B.O','766002',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142764,573,'Kalampur S.O','766013',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142765,573,'Kaleigaon B.O','766014',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142766,573,'Kaliakundal B.O','766014',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142767,573,'Kalopala B.O','766023',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142768,573,'Kamarda B.O','766100',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142769,573,'Kamthana B.O','766002',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142770,573,'Kandabutra B.O','766019',1,0,'2022-03-04 19:33:52','2022-03-04 19:33:52'),(142771,573,'Kandel B.O','766012',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142772,573,'Kandel Road B.O','766012',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142773,573,'Kandrei B.O','766102',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142774,573,'Kanduljhar B.O','766036',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142775,573,'Kaniguma B.O','766037',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142776,573,'Kankeri B.O','766029',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142777,573,'Kankutru B.O','766020',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142778,573,'Kantisir B.O','766012',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142779,573,'Karlaguda B.O','766002',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142780,573,'Karlamunda S.O','766032',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142781,573,'Karlapada B.O','766011',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142782,573,'Karlapat B.O','766037',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142783,573,'Karmel B.O','766100',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142784,573,'Karmeli B.O','766018',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142785,573,'Kashibahal B.O','766019',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142786,573,'Kashrupada B.O','766012',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142787,573,'Kattkura B.O','766037',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142788,573,'Kegaon B.O','766016',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142789,573,'Kerbandi B.O','766100',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142790,573,'Kerokuda B.O','766011',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142791,573,'Kerpai B.O','766037',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142792,573,'Kesinga JM Pada S.O','766012',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142793,573,'Kesinga RS S.O','766012',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142794,573,'Kesinga S.O','766012',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142795,573,'Khairpadar B.O','766015',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142796,573,'Khaliabhata B.O','766018',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142797,573,'Khaliakani B.O','766016',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142798,573,'Khaliapalli B.O','766016',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142799,573,'Khuntia B.O','766103',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142800,573,'Kiding B.O','766110',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142801,573,'Kikia B.O','766011',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142802,573,'Kirkakani B.O','766029',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142803,573,'Koksara S.O','766019',1,0,'2022-03-04 19:33:53','2022-03-04 19:33:53'),(142804,573,'Koligaon B.O','766014',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142805,573,'Kuhura B.O','766036',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142806,573,'Kuliamal B.O','766002',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142807,573,'Kumbhari B.O','766029',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142808,573,'Kumjore B.O','766019',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142809,573,'Kundabandha B.O','766011',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142810,573,'Kutrukhamar B.O','766002',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142811,573,'Ladugaon B.O','766019',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142812,573,'Laitara B.O','766012',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142813,573,'Lakhbahali B.O','766020',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142814,573,'Lanji B.O','766020',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142815,573,'Lanjigarh S.O','766027',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142816,573,'Lanjigarhroad B.O','766110',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142817,573,'Leter B.O','766036',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142818,573,'Madanpur B.O','766102',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142819,573,'Madanpur Rampur S.O','766102',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142820,573,'Madhupur B.O','766110',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142821,573,'Madiguda B.O','766036',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142822,573,'Mahalinga B.O','766036',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142823,573,'Mahichala S.O','766023',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142824,573,'Mahima B.O','766019',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142825,573,'Mahulpatna B.O','766026',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142826,573,'Majhiguda B.O','766019',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142827,573,'Malgund B.O','766014',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142828,573,'Maliguda B.O','766023',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142829,573,'Malijubang B.O','766027',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142830,573,'Malkandel B.O','766037',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142831,573,'Mandal B.O','766013',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142832,573,'Mandel B.O','766100',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142833,573,'Mangalpur B.O','766018',1,0,'2022-03-04 19:33:54','2022-03-04 19:33:54'),(142834,573,'Manikera B.O','766102',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142835,573,'Manjhari B.O','766016',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142836,573,'Mathura B.O','766023',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142837,573,'Matia B.O','766036',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142838,573,'Matigaon B.O','766014',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142839,573,'Medinipur B.O','766002',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142840,573,'Meriabandhali B.O','766014',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142841,573,'Mingur B.O','766013',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142842,573,'Mohangiri B.O','766102',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142843,573,'Moter B.O','766017',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142844,573,'Muding B.O','766102',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142845,573,'Mukhiguda S.O','766026',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142846,573,'Mundraguda B.O','766013',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142847,573,'Musapali B.O','766017',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142848,573,'Muskuti B.O','766101',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142849,573,'Nakrundi B.O','766037',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142850,573,'Naktikani B.O','766016',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142851,573,'Nandagaon B.O','766023',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142852,573,'Nandol B.O','766002',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142853,573,'Nangalbeda B.O','766020',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142854,573,'Narla Road S.O','766110',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142855,573,'Narla S.O','766100',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142856,573,'Negiguda B.O','766103',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142857,573,'Nehena B.O','766107',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142858,573,'Nishanpur B.O','766002',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142859,573,'Nunmath B.O','766012',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142860,573,'Nunpur B.O','766102',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142861,573,'Padampur B.O','766013',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142862,573,'Paikendumundi B.O','766018',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142863,573,'Palam B.O','766101',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142864,573,'Palas B.O','766023',1,0,'2022-03-04 19:33:55','2022-03-04 19:33:55'),(142865,573,'Palna B.O','766036',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142866,573,'Pandapadar B.O','766102',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142867,573,'Pandigaon B.O','766013',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142868,573,'Panimunda B.O','766110',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142869,573,'Paralsinga B.O','766012',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142870,573,'Paramanandapur B.O','766002',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142871,573,'Parla S.O','766103',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142872,573,'Paruaguda B.O','766013',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142873,573,'Pastikudi B.O','766011',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142874,573,'Patharla B.O','766012',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142875,573,'Phatkamal B.O','766011',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142876,573,'Phupgaon B.O','766019',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142877,573,'Pipalpadar B.O','766012',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142878,573,'Pokharibandh B.O','766020',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142879,573,'Pourkela B.O','766031',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142880,573,'Purnasar B.O','766014',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142881,573,'Purunaguma B.O','766037',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142882,573,'Rajmoter B.O','766015',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142883,573,'Rajpur B.O','766032',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142884,573,'Rajpur B.O','766014',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142885,573,'Ranibanhal B.O','766026',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142886,573,'Ranidumer B.O','766037',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142887,573,'Ranmal B.O','766017',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142888,573,'Regeda B.O','766102',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142889,573,'Rengali B.O','766012',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142890,573,'Rengalpali B.O','766019',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142891,573,'Rengsapali B.O','766029',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142892,573,'Rinja B.O','766031',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142893,573,'Risida S.O','766031',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142894,573,'Risigaon B.O','766002',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142895,573,'Rourahaldi B.O','766015',1,0,'2022-03-04 19:33:56','2022-03-04 19:33:56'),(142896,573,'Rupra B.O','766101',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142897,573,'Rupra Road S.O','766101',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142898,573,'S.Kundamal B.O','766023',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142899,573,'Sagada B.O','766002',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142900,573,'Salebhata B.O','766036',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142901,573,'Sanchergaon B.O','766016',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142902,573,'Sandhikuliari B.O','766029',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142903,573,'Sankenduguda B.O','766103',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142904,573,'Santapur B.O','766110',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142905,573,'Sargiguda B.O','766017',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142906,573,'Sargulmalpada B.O','766031',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142907,573,'Sarian B.O','766101',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142908,573,'Sergarh B.O','766100',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142909,573,'Sidhipadar B.O','766037',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142910,573,'Siripur B.O','766101',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142911,573,'Sirjapali B.O','766012',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142912,573,'Sirmasaka B.O','766037',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142913,573,'Sirol B.O','766012',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142914,573,'Siuni B.O','766028',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142915,573,'Sosia S.O','766029',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142916,573,'Takarla B.O','766101',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142917,573,'Talmala B.O','766014',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142918,573,'Tambachhoda B.O','766015',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142919,573,'Tarapur B.O','766015',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142920,573,'Temera B.O','766019',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142921,573,'Teresinga B.O','766031',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142922,573,'Thuamul Rampur S.O','766037',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142923,573,'Tikrapara B.O','766002',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142924,573,'Tipiguda B.O','766029',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142925,573,'Tonsir B.O','766012',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142926,573,'Tuapadar B.O','766011',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142927,573,'Tulapada B.O','766100',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142928,573,'Tundla B.O','766012',1,0,'2022-03-04 19:33:57','2022-03-04 19:33:57'),(142929,573,'Turchi B.O','766102',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142930,573,'Turlakhaman B.O','766012',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142931,573,'Uchhula B.O','766019',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142932,573,'Uchhula B.O','766011',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142933,573,'Udesurung B.O','766016',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142934,573,'Uditnarayanpur B.O','766002',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142935,573,'Urladani B.O','766102',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142936,573,'Utkela S.O','766011',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142937,573,'Adasikupa B.O','762112',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142938,573,'Adasipada B.O','762029',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142939,573,'Allanjuri B.O','762021',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142940,573,'Ambagaon B.O','762018',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142941,573,'Arabaka B.O','762010',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142942,573,'Arapaju B.O','762012',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142943,573,'Badabanga B.O','762104',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142944,573,'Badabhuin B.O','762029',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142945,573,'Badagaon B.O','762103',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142946,573,'Badangia B.O','762104',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142947,573,'Badimunda B.O','762010',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142948,573,'Baikumpa B.O','762012',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142949,573,'Bakingia B.O','762101',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142950,573,'Balakia B.O','762110',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142951,573,'Balandapada B.O','762002',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142952,573,'Balaskumpa B.O','762029',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142953,573,'Balimusti B.O','762109',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142954,573,'Balligada B.O','762102',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142955,573,'Balliguda S.O','762103',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142956,573,'Balumaha B.O','762022',1,0,'2022-03-04 19:33:58','2022-03-04 19:33:58'),(142957,573,'Bamunigaon S.O (Kandhamal)','762021',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142958,573,'Bandapipili B.O','762105',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142959,573,'Bandha B.O','762101',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142960,573,'Bandhagarh B.O','762011',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142961,573,'Bapalamendi B.O','762010',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142962,573,'Bapalamendi B.O','762027',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142963,573,'Barakhama S.O','762110',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142964,573,'Bariguda B.O','762106',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142965,573,'Baringi B.O','762012',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142966,573,'Bastingia B.O','762010',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142967,573,'Bataguda B.O','762109',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142968,573,'Batamunda B.O','762002',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142969,573,'Beallapadar B.O','762028',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142970,573,'Bediketa B.O','762103',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142971,573,'Beheragaon B.O','762010',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142972,573,'Belghar B.O','762107',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142973,573,'Benegaon B.O','762106',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142974,573,'Beredakia B.O','762101',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142975,573,'Bhandrangi B.O','762107',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142976,573,'Bhramarabadi B.O','762104',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142977,573,'Bhrungijodi B.O','762011',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142978,573,'Bilamala B.O','762107',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142979,573,'Biringi B.O','762109',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142980,573,'Bisipada B.O','762011',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142981,573,'Boida B.O','762029',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142982,573,'Boudingia B.O','762103',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142983,573,'Brahmanpad B.O','762028',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142984,573,'Breka B.O','762010',1,0,'2022-03-04 19:33:59','2022-03-04 19:33:59'),(142985,573,'Budaguda B.O','762103',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(142986,573,'Budrukia B.O','762103',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(142987,573,'Burangia B.O','762103',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(142988,573,'Burbinaju B.O','762112',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(142989,573,'Chahali B.O','762028',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(142990,573,'Chakapada S.O','762028',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(142991,573,'Chanchedi B.O','762101',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(142992,573,'Contractorpada S.O','762002',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(142993,573,'Court Stree G.Duaygisi S.O','762100',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(142994,573,'Dadakangia B.O','762109',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(142995,573,'Dadaki B.O','762002',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(142996,573,'Dadapada B.O','762100',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(142997,573,'Dadingia B.O','762101',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(142998,573,'Dakpala B.O','762002',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(142999,573,'Dalapada B.O','762012',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(143000,573,'Dandapadar B.O','762103',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(143001,573,'Danekbadi B.O','762104',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(143002,573,'Dangesiguda B.O','762109',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(143003,573,'Dankuni B.O','762027',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(143004,573,'Daringbadiso S.O','762104',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(143005,573,'Dasingbadi B.O','762104',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(143006,573,'Deegi B.O','762101',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(143007,573,'Demingia B.O','762103',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(143008,573,'Demisingia B.O','762102',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(143009,573,'Dharampur B.O','762102',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(143010,573,'Dimbiriguda B.O','762011',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(143011,573,'Duguripadi B.O','762022',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(143012,573,'Durgapanga B.O','762105',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(143013,573,'Dutimenda B.O','762012',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(143014,573,'Dutipada B.O','762012',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(143015,573,'G.Udayagiri S.O','762100',1,0,'2022-03-04 19:34:00','2022-03-04 19:34:00'),(143016,573,'Gadaguda B.O','762100',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143017,573,'Gadapur B.O','762021',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143018,573,'Gadiapada B.O','762012',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143019,573,'Gandagaon B.O','762019',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143020,573,'Ganjuguda B.O','762029',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143021,573,'Gardingia B.O','762112',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143022,573,'Gedingia B.O','762101',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143023,573,'Ghatiguda B.O','762028',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143024,573,'Gochhapada B.O','762002',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143025,573,'Greenbadi B.O','762104',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143026,573,'Gressingia B.O','762100',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143027,573,'Gudari B.O','762012',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143028,573,'Gudrikia B.O','762101',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143029,573,'Gugurumaha B.O','762105',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143030,573,'Gumagarh S.O','762029',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143031,573,'Gumikia B.O','762103',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143032,573,'Gumikia B.O','762021',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143033,573,'Gumma B.O','762107',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143034,573,'Gundhani B.O','762101',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143035,573,'Gunjibadi B.O','762102',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143036,573,'Guttingia B.O','762106',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143037,573,'Hatimunda B.O','762021',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143038,573,'Jajespanga B.O','762011',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143039,573,'Jalespata B.O','762107',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143040,573,'Jamjhari B.O','762002',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143041,573,'Jhagadapata B.O','762027',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143042,573,'Jhinjiriguda B.O','762021',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143043,573,'Jhiripani B.O','762107',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143044,573,'Judabadi B.O','762105',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143045,573,'Kachhabali B.O','762103',1,0,'2022-03-04 19:34:01','2022-03-04 19:34:01'),(143046,573,'Kainjhor B.O','762019',1,0,'2022-03-04 19:34:02','2022-03-04 19:34:02'),(143047,573,'Kajuri B.O','762101',1,0,'2022-03-04 19:34:02','2022-03-04 19:34:02'),(143048,573,'Kalinga S.O','762022',1,0,'2022-03-04 19:34:02','2022-03-04 19:34:02'),(143049,573,'Kanbageri B.O','762100',1,0,'2022-03-04 19:34:02','2022-03-04 19:34:02'),(143050,573,'Kanjamendi B.O','762102',1,0,'2022-03-04 19:34:02','2022-03-04 19:34:02'),(143051,573,'Kasabasa B.O','762021',1,0,'2022-03-04 19:34:02','2022-03-04 19:34:02'),(143052,573,'Kasinipadar B.O','762011',1,0,'2022-03-04 19:34:02','2022-03-04 19:34:02'),(143053,573,'Katadi B.O','762106',1,0,'2022-03-04 19:34:02','2022-03-04 19:34:02'),(143054,573,'Katamaha B.O','762021',1,0,'2022-03-04 19:34:02','2022-03-04 19:34:02'),(143055,573,'Kathingia B.O','762100',1,0,'2022-03-04 19:34:02','2022-03-04 19:34:02'),(143056,573,'Katimaha B.O','762010',1,0,'2022-03-04 19:34:02','2022-03-04 19:34:02'),(143057,573,'Katringia B.O','762002',1,0,'2022-03-04 19:34:02','2022-03-04 19:34:02'),(143058,573,'Kattingia B.O','762021',1,0,'2022-03-04 19:34:02','2022-03-04 19:34:02'),(143059,573,'Kelapada B.O','762011',1,0,'2022-03-04 19:34:02','2022-03-04 19:34:02'),(143060,573,'Keredi B.O','762029',1,0,'2022-03-04 19:34:02','2022-03-04 19:34:02'),(143061,573,'Kerubadi B.O','762104',1,0,'2022-03-04 19:34:02','2022-03-04 19:34:02'),(143062,573,'Khajuripada S.O','762012',1,0,'2022-03-04 19:34:02','2022-03-04 19:34:02'),(143063,573,'Khamankhole B.O','762110',1,0,'2022-03-04 19:34:02','2022-03-04 19:34:02'),(143064,573,'Kiamunda B.O','762011',1,0,'2022-03-04 19:34:02','2022-03-04 19:34:02'),(143065,573,'Kirikuti B.O','762104',1,0,'2022-03-04 19:34:02','2022-03-04 19:34:02'),(143066,573,'Kothagarh S.O','762105',1,0,'2022-03-04 19:34:02','2022-03-04 19:34:02'),(143067,573,'Krandibali B.O','762002',1,0,'2022-03-04 19:34:02','2022-03-04 19:34:02'),(143068,573,'Kudupanga B.O','762103',1,0,'2022-03-04 19:34:02','2022-03-04 19:34:02'),(143069,573,'Kuduteli B.O','762102',1,0,'2022-03-04 19:34:02','2022-03-04 19:34:02'),(143070,573,'Kumbharabadi B.O','762104',1,0,'2022-03-04 19:34:02','2022-03-04 19:34:02'),(143071,573,'Kumbharigaon B.O','762021',1,0,'2022-03-04 19:34:02','2022-03-04 19:34:02'),(143072,573,'Kurmingia B.O','762022',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143073,573,'Kurtamgarh S.O','762109',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143074,573,'Kutigada B.O','762105',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143075,573,'Kutikia B.O','762110',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143076,573,'Lambabadi B.O','762012',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143077,573,'Lamungia B.O','762101',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143078,573,'Lankagada B.O','762107',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143079,573,'Lethingia B.O','762102',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143080,573,'Linepada S.O','762027',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143081,573,'Lingagarh B.O','762100',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143082,573,'Loisingi B.O','762002',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143083,573,'Lokebadi B.O','762102',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143084,573,'Luhuringia B.O','762112',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143085,573,'Madaguda B.O','762105',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143086,573,'Madar Sahi B.O','762106',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143087,573,'Madikunda S.O','762001',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143088,573,'Magadangia B.O','762106',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143089,573,'Mahagudi B.O','762021',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143090,573,'Mahasingi B.O','762103',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143091,573,'Majhipada B.O','762011',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143092,573,'Mallickpada B.O','762020',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143093,573,'Mallickpodi B.O','762100',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143094,573,'Mandakia B.O','762101',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143095,573,'Mandalapadar B.O','762107',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143096,573,'Mandasaru B.O','762101',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143097,573,'Mandipanka B.O','762021',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143098,573,'Manikeswar B.O','762101',1,0,'2022-03-04 19:34:03','2022-03-04 19:34:03'),(143099,573,'Marlang B.O','762105',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143100,573,'Masterpada S.O','762001',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143101,573,'Mediakia B.O','762109',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143102,573,'Melsikia B.O','762110',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143103,573,'Minia B.O','762029',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143104,573,'Minjapanka B.O','762021',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143105,573,'Mundigarh B.O','762107',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143106,573,'Muselipanga B.O','762011',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143107,573,'Muskusahi B.O','762010',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143108,573,'Nediguda B.O','762028',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143109,573,'Nilungia B.O','762100',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143110,573,'Nuagaon S.O (Kandhamal)','762102',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143111,573,'Nuapadar B.O','762011',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143112,573,'Nuasahi S.O','762103',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143113,573,'Ollenbatch Nagar S.O','762001',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143114,573,'Ora B.O','762105',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143115,573,'Pabingia B.O','762011',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143116,573,'Paburia S.O','762112',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143117,573,'Padangi B.O','762106',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143118,573,'Paderipada B.O','762106',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143119,573,'Padunbadi B.O','762101',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143120,573,'Paheraju B.O','762002',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143121,573,'Paikadharakote B.O','762105',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143122,573,'Pakanagaon B.O','762029',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143123,573,'Pakari B.O','762103',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143124,573,'Pangali B.O','762104',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143125,573,'Parampanga B.O','762109',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143126,573,'Parigada B.O','762103',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143127,573,'Parthamaha B.O','762104',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143128,573,'Pasara B.O','762028',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143129,573,'Penjisahi (TPO-1135) S.O','762001',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143130,573,'Petapanga B.O','762112',1,0,'2022-03-04 19:34:04','2022-03-04 19:34:04'),(143131,573,'Phiringia S.O','762011',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143132,573,'Phulbani Bazar S.O','762001',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143133,573,'Phulbani H.O','762001',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143134,573,'Pikaradi B.O','762010',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143135,573,'Pokari B.O','762002',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143136,573,'Pokharibandha B.O','762110',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143137,573,'Pusangia B.O','762109',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143138,573,'R Nuagaon B.O','762027',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143139,573,'Rabingia B.O','762110',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143140,573,'Rabingia B.O','762011',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143141,573,'Raikala B.O','762100',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143142,573,'Raikia S.O','762101',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143143,573,'Raipalli B.O','762100',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143144,573,'Ranapatuli B.O','762012',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143145,573,'Rasimendi B.O','762029',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143146,573,'Ratanga B.O','762011',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143147,573,'Rattingia B.O','762100',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143148,573,'Rudangia B.O','762100',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143149,573,'Rupagaon B.O','762028',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143150,573,'Rutungia B.O','762103',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143151,573,'Sadingia B.O','762011',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143152,573,'Sainipada B.O','762103',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143153,573,'Sainipadar B.O','762002',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143154,573,'Sakadi B.O','762012',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143155,573,'Sakhipada B.O','762011',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143156,573,'Salaguda B.O','762110',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143157,573,'Salaguda B.O','762002',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143158,573,'Salimagochha B.O','762021',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143159,573,'Salkibudaguda B.O','762105',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143160,573,'Sangadama B.O','762021',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143161,573,'Sankarakhole S.O','762019',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143162,573,'Saramuli B.O','762021',1,0,'2022-03-04 19:34:05','2022-03-04 19:34:05'),(143163,573,'Sarangada S.O','762106',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143164,573,'Sarkipada B.O','762110',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143165,573,'Sautikia B.O','762110',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143166,573,'Seskajodi B.O','762011',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143167,573,'Siangbali B.O','762104',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143168,573,'Sikaketa B.O','762101',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143169,573,'Simanbadi B.O','762103',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143170,573,'Simanbadi B.O','762104',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143171,573,'Sindrigaon B.O','762103',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143172,573,'Siringia B.O','762106',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143173,573,'Sirki B.O','762100',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143174,573,'Sirla B.O','762107',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143175,573,'Sirtiguda B.O','762102',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143176,573,'Sonepur B.O','762104',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143177,573,'Sraniketa B.O','762104',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143178,573,'Sripalla B.O','762011',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143179,573,'Srirampur B.O','762105',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143180,573,'Subranagiri B.O','762105',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143181,573,'Sudhipada B.O','762100',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143182,573,'Sudra B.O','762110',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143183,573,'Sudreju B.O','762002',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143184,573,'Sudrukumpa B.O','762002',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143185,573,'Sugudabadi B.O','762101',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143186,573,'Tajungia B.O','762021',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143187,573,'Talapada B.O','762002',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143188,573,'Talapada B.O','762012',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143189,573,'Talarimaha B.O','762022',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143190,573,'Tamangi B.O','762021',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143191,573,'Tekangia B.O','762104',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143192,573,'Tellapali B.O','762011',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143193,573,'Tentuligarh B.O','762010',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143194,573,'Terabadi B.O','762104',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143195,573,'Tiangia B.O','762100',1,0,'2022-03-04 19:34:06','2022-03-04 19:34:06'),(143196,573,'Tikabali S.O','762010',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143197,573,'Tikarabaju B.O','762110',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143198,573,'Tikiripada B.O','762002',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143199,573,'Tillory B.O','762103',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143200,573,'Titrapanga B.O','762029',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143201,573,'Tudipaju B.O','762002',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143202,573,'Tumudibandha S.O','762107',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143203,574,'Achyutpur B.O','754220',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143204,574,'Ainipara B.O','754215',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143205,574,'Aitipur B.O','754223',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143206,574,'Akhua Dakhini B.O','754228',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143207,574,'Alailo B.O','754212',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143208,574,'Alapua B.O','754214',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143209,574,'Alati Bharatpur B.O','754250',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143210,574,'Alba S.O','754217',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143211,574,'Aliabad B.O','754214',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143212,574,'Amathpur B.O','754214',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143213,574,'Amber B.O','754215',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143214,574,'Amrutamanohi B.O','754218',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143215,574,'Andara B.O','754240',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143216,574,'Anduli B.O','754212',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143217,574,'Angulai B.O','754212',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143218,574,'Aragal B.O','755061',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143219,574,'Areikana B.O','754231',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143220,574,'Aripada B.O','754223',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143221,574,'Ashram Balikuda B.O','754213',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143222,574,'Atal B.O','754231',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143223,574,'Aul S.O','754219',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143224,574,'Ayaba B.O','754212',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143225,574,'Ayatan B.O','754220',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143226,574,'Babar B.O','754245',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143227,574,'Bachharai B.O','754244',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143228,574,'Badagaon B.O','754250',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143229,574,'Badakula B.O','754213',1,0,'2022-03-04 19:34:07','2022-03-04 19:34:07'),(143230,574,'Badamulabasanta B.O','754215',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143231,574,'Badanaukana B.O','754225',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143232,574,'Badapalli B.O','754217',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143233,574,'Badihi B.O','754245',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143234,574,'Bagada B.O','754212',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143235,574,'Bahmanda B.O','754227',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143236,574,'Balabhadrapur B.O','754217',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143237,574,'Balakati B.O','754219',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143238,574,'Balana B.O','754213',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143239,574,'Balia B.O','754224',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143240,574,'Balia Bibhutipara B.O','754289',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143241,574,'Baliapatna B.O','754215',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143242,574,'Balipal B.O','754212',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143243,574,'Baluria B.O','754218',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143244,574,'Bandhakata B.O','754244',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143245,574,'Bandhapatna B.O','754246',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143246,574,'Bankeswar B.O','754215',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143247,574,'Baradanga B.O','754224',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143248,574,'Baradia B.O','754220',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143249,574,'Baragaon Mahakalpara B.O','754214',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143250,574,'Barakanda B.O','754224',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143251,574,'Barpada S.O','754245',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143252,574,'Barua B.O','754250',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143253,574,'Baruna B.O','754227',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143254,574,'Barunadiha B.O','754220',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143255,574,'Basupur B.O','754222',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143256,574,'Batipada S.O','754218',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143257,574,'Bedari S.O','754253',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143258,574,'Belarpur B.O','754250',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143259,574,'Beltal B.O','754215',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143260,574,'Bharatpur B.O','754223',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143261,574,'Bharigada B.O','754220',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143262,574,'Bhatapada [r] B.O','754246',1,0,'2022-03-04 19:34:08','2022-03-04 19:34:08'),(143263,574,'Bhitaragarh B.O','754225',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143264,574,'Bhuinpur S.O','754239',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143265,574,'Bijayanagar B.O','754224',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143266,574,'Bilikana (Gopalpur) B.O','754215',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143267,574,'Bira Nilakanthapur B.O','754250',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143268,574,'Chakada Gogua B.O','754245',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143269,574,'Chakroda B.O','754223',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143270,574,'Chanchol B.O','754210',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143271,574,'Chandan Nagar B.O','754217',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143272,574,'Chatrachakada B.O','754289',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143273,574,'Chaudakulat S.O','754222',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143274,574,'Chhadesh B.O','754227',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143275,574,'Chhoti B.O','754214',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143276,574,'Dadhibamanpur B.O','755061',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143277,574,'Dalikainda B.O','754220',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143278,574,'Damarpur B.O','754217',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143279,574,'Dandisahi S.O','754240',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143280,574,'Dangamal B.O','754248',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143281,574,'Danpur S.O (Kendrapara)','754210',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143282,574,'Dasipur B.O','754219',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143283,574,'Dera B.O','754225',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143284,574,'Derabish S.O','754289',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143285,574,'Deulipara B.O','754212',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143286,574,'Dosia B.O','754217',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143287,574,'Dumuka B.O','754213',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143288,574,'Erdang Natra B.O','755061',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143289,574,'Fakirabad B.O','754250',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143290,574,'Gahaga Narasinghpur B.O','754210',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143291,574,'Garjanga B.O','754213',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143292,574,'Ghadiamal B.O','754248',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143293,574,'Ghagra B.O','754214',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143294,574,'Giria B.O','754220',1,0,'2022-03-04 19:34:09','2022-03-04 19:34:09'),(143295,574,'Gogua B.O','754222',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143296,574,'Gojabandha B.O','754224',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143297,574,'Gommu B.O','754214',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143298,574,'Gopaljewpatna B.O','754250',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143299,574,'Gopalpur Rajnagar B.O','754225',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143300,574,'Gopei B.O','754223',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143301,574,'Gopinathpur B.O','754203',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143302,574,'Govindpur Kutchery S.O','755061',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143303,574,'Gulnagar B.O','754250',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143304,574,'Gunupur B.O','754216',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143305,574,'Gupti B.O','754225',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143306,574,'Harianka B.O','754210',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143307,574,'Indalo B.O','754210',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143308,574,'Indupur S.O','754214',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143309,574,'Iswarpur S.O','754248',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143310,574,'Jadupur B.O','754213',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143311,574,'Jagannathpur Sasan B.O','754246',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143312,574,'Jagulaipara B.O','754289',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143313,574,'Jagulaipara B.O','754220',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143314,574,'Jamboo B.O','754224',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143315,574,'Jamdhar B.O','754250',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143316,574,'Jampara S.O','754244',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143317,574,'Janra Barimul B.O','754210',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143318,574,'Jaria S.O (Kendrapara)','754216',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143319,574,'Jasuapalli B.O','754224',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143320,574,'Jaynagar B.O','754220',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143321,574,'Jigiran B.O','754216',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143322,574,'Junapangara B.O','754225',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143323,574,'Kadaliban B.O','754222',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143324,574,'Kakharuni B.O','754217',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143325,574,'Kalapara B.O','754212',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143326,574,'Kalaspur B.O','754239',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143327,574,'Kampagarh B.O','754214',1,0,'2022-03-04 19:34:10','2022-03-04 19:34:10'),(143328,574,'Kandira B.O','754225',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143329,574,'Kansar Badadandua B.O','754224',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143330,574,'Kantia B.O','754223',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143331,574,'Kapaleswar B.O','754250',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143332,574,'Karanja B.O','754224',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143333,574,'Karilopatna S.O','754223',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143334,574,'Kasananta B.O','754215',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143335,574,'Katna B.O','754220',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143336,574,'Kendrapara College S.O','754211',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143337,574,'Kendrapara H.O','754211',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143338,574,'Keradagada B.O','754246',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143339,574,'Keshpur Bazar S.O','754211',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143340,574,'Khadianta B.O','754215',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143341,574,'Kharinasi B.O','754224',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143342,574,'Kiarbanka B.O','754224',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143343,574,'Kochila B.O','754224',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143344,574,'Koilipur B.O','754220',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143345,574,'Koilipur B.O','754246',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143346,574,'Kolangiri B.O','754214',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143347,574,'Kora B.O','754222',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143348,574,'Krishnanagar B.O','754248',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143349,574,'Kurunti B.O','754225',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143350,574,'Kusiapal B.O','754250',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143351,574,'Kutranga B.O','754214',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143352,574,'Laxminarayanpur B.O','754289',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143353,574,'Lendura Bhagwanpur B.O','754203',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143354,574,'Madanpur S.O (Kendrapara)','754246',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143355,574,'Madhuban B.O','755061',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143356,574,'Mahakalpara S.O','754224',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143357,574,'Mahal B.O','754210',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143358,574,'Mahendinagar B.O','754244',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143359,574,'Mahu B.O','754231',1,0,'2022-03-04 19:34:11','2022-03-04 19:34:11'),(143360,574,'Mahulia B.O','754225',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143361,574,'Malapatna B.O','754215',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143362,574,'Maliancha B.O','754224',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143363,574,'Manapur B.O','754227',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143364,574,'Mandia B.O','754253',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143365,574,'Manikapatna B.O','754215',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143366,574,'Manjulapalli B.O','754248',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143367,574,'Mantiri B.O','754212',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143368,574,'Marsaghai S.O','754213',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143369,574,'Mendhapur B.O','754219',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143370,574,'Nadia Barei B.O','754223',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143371,574,'Nalitapatia B.O','754248',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143372,574,'Namouza S.O','754231',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143373,574,'Nantar B.O','754224',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143374,574,'Narsinghpur Dihasahi B.O','754215',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143375,574,'Naupada B.O','754213',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143376,574,'Nembra B.O','754212',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143377,574,'Nihala B.O','754219',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143378,574,'Nikirai B.O','754214',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143379,574,'Nuagaon B.O','754227',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143380,574,'Nuahat B.O','754289',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143381,574,'Nuapada B.O','754218',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143382,574,'Olavar S.O','754227',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143383,574,'Ostapur B.O','754212',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143384,574,'Oudapada B.O','754217',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143385,574,'Padanipal B.O','754239',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143386,574,'Padmapur B.O','754253',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143387,574,'Pakhyat B.O','754210',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143388,574,'Palasingha B.O','754222',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143389,574,'Palimi B.O','755061',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143390,574,'Palli Raghunathpur B.O','754214',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143391,574,'Panasudha B.O','754250',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143392,574,'Pandiri B.O','754250',1,0,'2022-03-04 19:34:12','2022-03-04 19:34:12'),(143393,574,'Patakura S.O (Kendrapara)','754228',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143394,574,'Patrapur B.O','754215',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143395,574,'Pattamundai College S.O','754215',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143396,574,'Pattamundai S.O','754215',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143397,574,'Pegarpara B.O','754227',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143398,574,'Pentha B.O','754244',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143399,574,'Penthapal B.O','754240',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143400,574,'Pikarali B.O','754213',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143401,574,'Pimpudi B.O','754220',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143402,574,'Podamarai Alakana B.O','754219',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143403,574,'Pundalo B.O','754228',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143404,574,'Purusottampur B.O','754212',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143405,574,'Purusottampur B.O','754223',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143406,574,'Raghunathpur K Patna B.O','754244',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143407,574,'Raichand B.O','754223',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143408,574,'Rajgarh B.O','754212',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143409,574,'Rajkanika S.O','754220',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143410,574,'Rajnagar S.O (Kendrapara)','754225',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143411,574,'Ramnagar Refugee Colony B.O','754224',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143412,574,'Rangani B.O','754248',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143413,574,'Rout Sahi B.O','754214',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143414,574,'Sahira B.O','754215',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143415,574,'Sana Jaria B.O','754216',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143416,574,'Sanamanga B.O','754218',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143417,574,'Sandhapalli B.O','754215',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143418,574,'Sansarphal B.O','754217',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143419,574,'Sansidha Mangarajpur B.O','754218',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143420,574,'Sasan B.O','754217',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143421,574,'Sasanipada B.O','754213',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143422,574,'Satabhaya B.O','754225',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143423,574,'Sekhpur B.O','754215',1,0,'2022-03-04 19:34:13','2022-03-04 19:34:13'),(143424,574,'Siko B.O','754220',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143425,574,'Sikudi B.O','754220',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143426,574,'Silipur B.O','754213',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143427,574,'Singiri B.O','754215',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143428,574,'Sitaleswar B.O','754219',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143429,574,'Sorisia B.O','754210',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143430,574,'Sribaldevjew S.O','754212',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143431,574,'Srirampalpatna B.O','754217',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143432,574,'Suniti B.O','754224',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143433,574,'Talachua B.O','754248',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143434,574,'Talasanga B.O','754213',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143435,574,'Taradapal B.O','754240',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143436,574,'Taras B.O','754220',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143437,574,'Teragaon B.O','754224',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143438,574,'Terohi B.O','754217',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143439,574,'Thakurpatna S.O','754250',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143440,574,'Thauri B.O','754212',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143441,574,'Tilotamadeipur B.O','754250',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143442,574,'Tinimuhani S.O','754211',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143443,574,'Yunus Nagar B.O','754248',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143444,574,'Antei B.O','754162',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143445,574,'Balisuan B.O','754141',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143446,574,'Bamara Cuttack B.O','754153',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143447,574,'Benirampur B.O','754134',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143448,574,'Bhagabanpur B.O','754134',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143449,574,'Garadpur S.O','754153',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143450,574,'Gatanai B.O','754141',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143451,574,'Kalabuda B.O','754153',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143452,574,'Kmg Pur B.O','754134',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143453,574,'Korua B.O','754134',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143454,574,'Lankapara B.O','754134',1,0,'2022-03-04 19:34:14','2022-03-04 19:34:14'),(143455,574,'M.G Khamar B.O','754141',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143456,574,'Naindipur B.O','754153',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143457,574,'Narada B.O','754134',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143458,574,'Nischintasasan B.O','754134',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143459,574,'P.Srichandanpur B.O','754162',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143460,574,'Pailo B.O','754162',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143461,574,'Pakhad B.O','754153',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143462,574,'Patalipank B.O','754141',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143463,574,'Putling B.O','754134',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143464,574,'Talakusuma B.O','754134',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143465,574,'Tentoi B.O','754134',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143466,574,'Tikanpur B.O','754153',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143467,574,'Tikhiri B.O','754141',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143468,574,'Tyandakura S.O','754134',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143469,575,'Danar B.O','756121',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143470,575,'Dimiria B.O','756121',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143471,575,'Gedma B.O','756121',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143472,575,'Sadanga B.O','756121',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143473,575,'Salinia B.O','756121',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143474,575,'Balibaruan B.O','755019',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143475,575,'Odapada B.O','755019',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143476,575,'Akula B.O','758076',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143477,575,'Alati B.O','758043',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143478,575,'Alutuma B.O','758082',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143479,575,'Amalaniguda B.O','758047',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143480,575,'Ambagadia B.O','758022',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143481,575,'Ambo B.O','758022',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143482,575,'Anandapur College S.O','758021',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143483,575,'Anandapur S.O (Kendujhar)','758021',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143484,575,'Angarua B.O','758021',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143485,575,'Anseikala B.O','758047',1,0,'2022-03-04 19:34:15','2022-03-04 19:34:15'),(143486,575,'Arsala B.O','758031',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143487,575,'Asanpat B.O','758032',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143488,575,'Atasahi B.O','758015',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143489,575,'Bada Ektali B.O','758015',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143490,575,'Badabaliposi B.O','758016',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143491,575,'Badadumuria B.O','758032',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143492,575,'Badagambharia B.O','758017',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143493,575,'Badajamposi B.O','758027',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143494,575,'Badanai B.O','758044',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143495,575,'Badaneuli B.O','758032',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143496,575,'Badanuagaon B.O','758028',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143497,575,'Badapadana B.O','758021',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143498,575,'Badapichhula B.O','758079',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143499,575,'Badaposi B.O','758014',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143500,575,'Badarampas B.O','758083',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143501,575,'Badasialimal B.O','758028',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143502,575,'Baiganpal B.O','758027',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143503,575,'Baikala B.O','758045',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143504,575,'Bailo B.O','758020',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143505,575,'Balabhadrapur B.O','758076',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143506,575,'Balabhadrapur B.O','758047',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143507,575,'Balabhadrapur B.O','758079',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143508,575,'Balada B.O','758034',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143509,575,'Baladuan B.O','758021',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143510,575,'Balaguda B.O','758037',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143511,575,'Balarampur B.O','758025',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143512,575,'Balibandha B.O','758031',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143513,575,'Balibarei B.O','758023',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143514,575,'Balipal B.O','758025',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143515,575,'Baliparbata B.O','758026',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143516,575,'Balipokhari B.O','758027',1,0,'2022-03-04 19:34:16','2022-03-04 19:34:16'),(143517,575,'Bamebari B.O','758034',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143518,575,'Banabir B.O','758081',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143519,575,'Bancho B.O','758022',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143520,575,'Bandakanda Haladharpur B.O','758027',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143521,575,'Baneikela S.O','758038',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143522,575,'Bangore B.O','758023',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143523,575,'Bankhidi B.O','758021',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143524,575,'Bankia B.O','758044',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143525,575,'Bansapani B.O','758034',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143526,575,'Banspal S.O','758085',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143527,575,'Baragoda B.O','758085',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143528,575,'Barahatipura B.O','758027',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143529,575,'Baratania B.O','758016',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143530,575,'Barbil S.O','758035',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143531,575,'Barhagarh B.O','758018',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143532,575,'Baria B.O','758032',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143533,575,'Barigaon B.O','758078',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143534,575,'Baripal B.O','758025',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143535,575,'Basantapur B.O','758014',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143536,575,'Basantapur B.O','758034',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143537,575,'Basira B.O','758047',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143538,575,'Basudevpur B.O','758047',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143539,575,'Batto B.O','758043',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143540,575,'Baunsagarh B.O','758021',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143541,575,'Baunsuli B.O','758032',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143542,575,'Bauripada B.O','758013',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143543,575,'Baxibarigaon B.O','758079',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143544,575,'Bayakumutia B.O','758018',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143545,575,'Begna B.O','758016',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143546,575,'Belabahali B.O','758020',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143547,575,'Belda B.O','758034',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143548,575,'Bhadrasahi B.O','758035',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143549,575,'Bhagamunda S.O','758080',1,0,'2022-03-04 19:34:17','2022-03-04 19:34:17'),(143550,575,'Bhaganai B.O','758043',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143551,575,'Bhaluka B.O','758043',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143552,575,'Bhanda B.O','758044',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143553,575,'Bhandaridiha B.O','758025',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143554,575,'Bhawanarpur B.O','758028',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143555,575,'Bhimkand B.O','758076',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143556,575,'Bhodaposi B.O','758032',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143557,575,'Bholabeda B.O','758029',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143558,575,'Bholapada B.O','758016',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143559,575,'Bhuinpur B.O','758032',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143560,575,'Bhulda B.O','758032',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143561,575,'Bhuyanroida B.O','758035',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143562,575,'Bichakundi B.O','758034',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143563,575,'Bidyadharpur B.O','758078',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143564,575,'Bileipada B.O','758038',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143565,575,'Billa B.O','758080',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143566,575,'Bimala B.O','758076',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143567,575,'Binida B.O','758014',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143568,575,'Binjabahal B.O','758084',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143569,575,'Birabarpur Nuagaon B.O','758076',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143570,575,'Biragovindapur B.O','758015',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143571,575,'Birakishorepur B.O','758013',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143572,575,'Biridi B.O','758022',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143573,575,'Birikala B.O','758038',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143574,575,'Bodapalasa B.O','758002',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143575,575,'Bolani S.O','758037',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143576,575,'Bolaniposi B.O','758014',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143577,575,'Brahmanideo B.O','758030',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143578,575,'Brahmanipal S.O','758082',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143579,575,'Budhikapudi B.O','758046',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143580,575,'Chakradharpur B.O','758028',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143581,575,'Chakundapal B.O','758017',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143582,575,'Chamakpur B.O','758041',1,0,'2022-03-04 19:34:18','2022-03-04 19:34:18'),(143583,575,'Champei B.O','758018',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143584,575,'Champua S.O','758041',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143585,575,'Chauthia B.O','758044',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143586,575,'Chemena B.O','758046',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143587,575,'Chhamunda B.O','758084',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143588,575,'Chhenapadi B.O','758083',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143589,575,'Childa B.O','758046',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143590,575,'Chilikdhara B.O','758080',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143591,575,'Chinamaliposi B.O','758029',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143592,575,'Chipinda B.O','758031',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143593,575,'Chormalda B.O','758034',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143594,575,'Dabuna B.O','758034',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143595,575,'Daduan B.O','758038',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143596,575,'Damahuda B.O','758081',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143597,575,'Daradipal B.O','758025',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143598,575,'Deojhar B.O','758038',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143599,575,'Deoladiha B.O','758019',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143600,575,'Dhakotha B.O','758015',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143601,575,'Dhangadadiha B.O','758027',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143602,575,'Dhanurjaypur Haramatha B.O','758040',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143603,575,'Dhanurnjaypur S.O','758078',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143604,575,'Dhenka B.O','758023',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143605,575,'Dhenkikote S.O','758029',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143606,575,'Dhobakuchuda B.O','758041',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143607,575,'Dhrupada B.O','758013',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143608,575,'Digiposi B.O','758016',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143609,575,'Dimba B.O','758014',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143610,575,'Dimirimunda B.O','758014',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143611,575,'Doblapal B.O','758019',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143612,575,'Dumuria B.O','758030',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143613,575,'Erendei B.O','758030',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143614,575,'Fakirpur S.O','758022',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143615,575,'Fuljhar B.O','758085',1,0,'2022-03-04 19:34:19','2022-03-04 19:34:19'),(143616,575,'Gadadharpur B.O','758027',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143617,575,'Gandadiha B.O','758028',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143618,575,'Garabandagoda B.O','758043',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143619,575,'Gayalamunda B.O','758021',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143620,575,'Ghasipura S.O','758015',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143621,575,'Ghatagaon S.O','758027',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143622,575,'Gholkunda B.O','758081',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143623,575,'Ghutur B.O','758002',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143624,575,'Gidhibas B.O','758032',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143625,575,'Girigaon B.O','758022',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143626,575,'Gobarbeda B.O','758030',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143627,575,'Gobardhan B.O','758013',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143628,575,'Goda B.O','758019',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143629,575,'Gohira B.O','758015',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143630,575,'Goras B.O','758081',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143631,575,'Guali B.O','758035',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143632,575,'Gujitangiri B.O','758016',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143633,575,'Gumura B.O','758047',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143634,575,'Gundunia B.O','758044',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143635,575,'Guptaganga B.O','758018',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143636,575,'Guruda B.O','758034',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143637,575,'Gurutuan B.O','758034',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143638,575,'Hadagarh S.O','758023',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143639,575,'Haladharpur B.O','758014',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143640,575,'Handibhanga B.O','758031',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143641,575,'Harichandanpur S.O','758028',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143642,575,'Hatadihi S.O','758083',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143643,575,'Hunda B.O','758079',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143644,575,'Hundapalasapal B.O','758028',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143645,575,'Inchola B.O','758083',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143646,575,'Jadichatar B.O','758017',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143647,575,'Jagamohanpur S.O','758084',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143648,575,'Jagannathpur Ashram B.O','758041',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143649,575,'Jajanga B.O','758034',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143650,575,'Jalasuan B.O','758043',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143651,575,'Jalasuanpatna B.O','758025',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143652,575,'Jally B.O','758032',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143653,575,'Jamadalak B.O','758041',1,0,'2022-03-04 19:34:20','2022-03-04 19:34:20'),(143654,575,'Jambhira B.O','758022',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143655,575,'Jamuda B.O','758045',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143656,575,'Jamunaposi B.O','758017',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143657,575,'Janghira S.O','758079',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143658,575,'Jata B.O','758019',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143659,575,'Jatra B.O','758085',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143660,575,'Jharbeda B.O','758014',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143661,575,'Jhumpura S.O','758031',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143662,575,'Jiranga B.O','758028',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143663,575,'Joda Bazar S.O','758034',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143664,575,'Joda S.O','758034',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143665,575,'Junga B.O','758079',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143666,575,'Jyotipur B.O','758046',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143667,575,'Kadagarh B.O','758013',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143668,575,'Kadakala B.O','758085',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143669,575,'Kaduadiha B.O','758028',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143670,575,'Kahaliagadia B.O','758078',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143671,575,'Kainta B.O','758041',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143672,575,'Kaliahota B.O','758076',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143673,575,'Kalikaprasad B.O','758047',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143674,575,'Kalinga B.O','758044',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143675,575,'Kandra B.O','758047',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143676,575,'Kandraposi B.O','758031',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143677,575,'Kanjiasula B.O','758044',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143678,575,'Kanjipani B.O','758031',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143679,575,'Kanjipani B.O','758018',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143680,575,'Kankada B.O','758046',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143681,575,'Kanpur B.O','758078',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143682,575,'Kanpur B.O','758025',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143683,575,'Kansa B.O','758082',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143684,575,'Kantiapada B.O','758017',1,0,'2022-03-04 19:34:21','2022-03-04 19:34:21'),(143685,575,'Kantipal B.O','758021',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143686,575,'Kanto B.O','758015',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143687,575,'Kapundi B.O','758016',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143688,575,'Karadangi B.O','758019',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143689,575,'Karadapal B.O','758080',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143690,575,'Karagola B.O','758022',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143691,575,'Karamangi B.O','758076',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143692,575,'Karangadihi B.O','758085',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143693,575,'Karanjia S.O (Kendujhar)','758044',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143694,575,'Kasia(KA) B.O','758035',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143695,575,'Kasipal B.O','758044',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143696,575,'Kasipal B.O','758031',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143697,575,'Kathabari B.O','758029',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143698,575,'Kathabaunsuli B.O','758031',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143699,575,'Kathakata B.O','758021',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143700,575,'Katrabeda B.O','758029',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143701,575,'Kaunrikala(A) B.O','758032',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143702,575,'Kaunrikala(B) B.O','758031',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143703,575,'Kempasada B.O','758013',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143704,575,'Kendeiposi B.O','758017',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143705,575,'Kendudiha B.O','758027',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143706,575,'Kendukhunta B.O','758043',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143707,575,'Keonjhar Atopur S.O','758002',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143708,575,'Keonjhar Bazar S.O','758002',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143709,575,'Keonjhar Court S.O','758001',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143710,575,'Keonjhar Mining School S.O','758001',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143711,575,'Keonjhar New Markt S.O','758001',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143712,575,'Keonjhar Science College S.O','758001',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143713,575,'Keonjhargarh H.O','758001',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143714,575,'Keshudurapal B.O','758025',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143715,575,'Ketanga B.O','758029',1,0,'2022-03-04 19:34:22','2022-03-04 19:34:22'),(143716,575,'Khadikapada B.O','758081',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143717,575,'Khajirapat B.O','758045',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143718,575,'Khajuribani B.O','758079',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143719,575,'Khalana B.O','758043',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143720,575,'Khalapal B.O','758025',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143721,575,'Khaliamenta B.O','758015',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143722,575,'Khandabandha B.O','758034',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143723,575,'Khenda B.O','758031',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143724,575,'Khireitangiri B.O','758046',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143725,575,'Khuntapada B.O','758031',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143726,575,'Khuntapada B.O','758045',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143727,575,'Khuntapada Charigarh B.O','758019',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143728,575,'Khuntapingu B.O','758045',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143729,575,'Kiriburu Hill Top S.O','758040',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143730,575,'Kodagadia B.O','758041',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143731,575,'Kodapada B.O','758021',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143732,575,'Kolahundula B.O','758038',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143733,575,'Kolhabarapada B.O','758036',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143734,575,'Kolimati B.O','758015',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143735,575,'Kuanr B.O','758018',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143736,575,'Kuchanendi B.O','758025',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143737,576,'Kudipasa B.O','758014',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143738,576,'Kumundi (KHA) B.O','758085',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143739,576,'Kundapitha B.O','758027',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143740,576,'Kuntla B.O','758028',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143741,576,'Kushakala B.O','758085',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143742,576,'Kushaleswar S.O','758025',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143743,576,'Kusuminta B.O','758013',1,0,'2022-03-04 19:34:23','2022-03-04 19:34:23'),(143744,576,'Kusunpur B.O','758027',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143745,576,'Machhagarh S.O','758081',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143746,576,'Machhala B.O','758043',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143747,576,'Madanpur B.O','758043',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143748,576,'Madhapur S.O','758001',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143749,576,'Madhukeshari B.O','758043',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143750,576,'Mahadeijoda B.O','758013',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143751,576,'Maidankela B.O','758014',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143752,576,'Malapada B.O','758045',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143753,576,'Malda B.O','758031',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143754,576,'Manata B.O','758027',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143755,576,'Mandua B.O','758014',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143756,576,'Manoharpur B.O','758021',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143757,576,'Manoharpur B.O','758029',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143758,576,'Mareigaon B.O','758083',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143759,576,'Masinajoda B.O','758080',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143760,576,'Masinajodi B.O','758079',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143761,576,'Matkambeda S.O','758036',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143762,576,'Mirigikhoji B.O','758081',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143763,576,'Mishramala B.O','758079',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143764,576,'Mugupur B.O','758022',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143765,576,'Muktapur B.O','758029',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143766,576,'Mukundapur Patna B.O','758027',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143767,576,'Murusuan B.O','758017',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143768,576,'Mushakhari B.O','758030',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143769,576,'Naduan B.O','758015',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143770,576,'Nahabeda B.O','758031',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143771,576,'Nalada B.O','758035',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143772,576,'Nandabara B.O','758043',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143773,576,'Nandapur B.O','758044',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143774,576,'Naradapur B.O','758047',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143775,576,'Naranpur S.O','758014',1,0,'2022-03-04 19:34:24','2022-03-04 19:34:24'),(143776,576,'Nayakote B.O','758085',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143777,576,'Nayakrihsnapur B.O','758047',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143778,576,'Nelung B.O','758002',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143779,576,'Nishitnapur B.O','758047',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143780,576,'Niundi B.O','758032',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143781,576,'Nuadihi B.O','758084',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143782,576,'Nuagaon B.O','758080',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143783,576,'Nuagaon B.O','758021',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143784,576,'Nuagaon B.O','758013',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143785,576,'Nuagaon B.O','758076',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143786,576,'Nusuriposi B.O','758027',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143787,576,'Orali B.O','758083',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143788,576,'Oriya B.O','758019',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143789,576,'Padamapur B.O','758021',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143790,576,'Padang B.O','758076',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143791,576,'Padhiaripally B.O','758078',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143792,576,'Padmapur B.O','758013',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143793,576,'Padmapur B.O','758044',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143794,576,'Padua B.O','758032',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143795,576,'Palanghati B.O','758029',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143796,576,'Palasa (KHA) B.O','758034',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143797,576,'Palasapanda B.O','758031',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143798,576,'Panasadiha B.O','758021',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143799,576,'Panchapokharia B.O','758041',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143800,576,'Panchupally B.O','758020',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143801,576,'Pandadar B.O','758018',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143802,576,'Pandapara B.O','758014',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143803,576,'Pandua B.O','758043',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143804,576,'Parajanpur B.O','758031',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143805,576,'Parasala B.O','758047',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143806,576,'Patilo B.O','758014',1,0,'2022-03-04 19:34:25','2022-03-04 19:34:25'),(143807,576,'Patsura B.O','758043',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143808,576,'Phulkanlei B.O','758046',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143809,576,'Pipilia B.O','758029',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143810,576,'Pitapiti B.O','758028',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143811,576,'Pithagola B.O','758028',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143812,576,'Podasingidi B.O','758023',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143813,576,'Poipani B.O','758029',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143814,576,'Pokharia B.O','758044',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143815,576,'Purujoda B.O','758076',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143816,576,'Purumunda B.O','758014',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143817,576,'Purunabandagoda B.O','758043',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143818,576,'Purunaghati B.O','758021',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143819,576,'Purunia B.O','758020',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143820,576,'Radhikadeipur B.O','758032',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143821,576,'Radhikadeipur B.O','758025',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143822,576,'Raghunathpur B.O','758014',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143823,576,'Raidiha B.O','758016',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143824,576,'Raighati B.O','758078',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143825,576,'Raigoda B.O','758085',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143826,576,'Raikala B.O','758031',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143827,576,'Raisuan Patkhuli B.O','758076',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143828,576,'Raisuan S.O','758013',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143829,576,'Raitola B.O','758021',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143830,576,'Rajabandha B.O','758027',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143831,576,'Rajanagar S.O','758017',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143832,576,'Rajia B.O','758047',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143833,576,'Ramachandrapur B.O','758043',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143834,576,'Rangamatia B.O','758044',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143835,576,'Ranki B.O','758002',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143836,576,'Raruanguda B.O','758044',1,0,'2022-03-04 19:34:26','2022-03-04 19:34:26'),(143837,576,'Rasabantala B.O','758032',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143838,576,'Remuli S.O','758047',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143839,576,'Rutisila B.O','758014',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143840,576,'Rvenapalasapal B.O','758080',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143841,576,'Sadangi B.O','758046',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143842,576,'Sadha B.O','758023',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143843,576,'Sagadapata B.O','758080',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143844,576,'Saharpada S.O','758016',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143845,576,'Sailong B.O','758015',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143846,576,'Sainkul S.O','758043',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143847,576,'Salabani B.O','758021',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143848,576,'Salapada S.O','758020',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143849,576,'Saleikana B.O','758084',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143850,576,'Samana B.O','758022',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143851,576,'Samukanendi B.O','758025',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143852,576,'Sanamasinabila B.O','758029',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143853,576,'Sankho B.O','758022',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143854,576,'Sankir B.O','758013',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143855,576,'Santoshpur B.O','758015',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143856,576,'Santrapur B.O','758029',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143857,576,'Sarasinga B.O','758032',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143858,576,'Saraskola B.O','758030',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143859,576,'Sarei B.O','758041',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143860,576,'Saruali B.O','758084',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143861,576,'Sasang B.O','758041',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143862,576,'Sendkap B.O','758013',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143863,576,'Serenda B.O','758035',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143864,576,'Silida B.O','758017',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143865,576,'Silijoda B.O','758034',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143866,576,'Silipada B.O','758045',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143867,576,'Silisuan B.O','758031',1,0,'2022-03-04 19:34:27','2022-03-04 19:34:27'),(143868,576,'Silitia B.O','758032',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143869,576,'Singpur B.O','758085',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143870,576,'Sirigida S.O','758076',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143871,576,'Sirishpal B.O','758014',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143872,576,'Sologuda B.O','758044',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143873,576,'Somagiri B.O','758079',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143874,576,'Soso B.O','758078',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143875,576,'Suakati S.O','758018',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143876,576,'Sulana B.O','758022',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143877,576,'Sunapentha B.O','758028',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143878,576,'Sunaposi B.O','758041',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143879,576,'Sundara Shiv Mandir S.O','758035',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143880,576,'Sunduria B.O','758076',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143881,576,'Swampatna S.O','758030',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143882,576,'Taduabahal B.O','758047',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143883,576,'Talapada B.O','758019',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143884,576,'Talapada S.O','758026',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143885,576,'Tambahara B.O','758028',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143886,576,'Tana B.O','758084',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143887,576,'Tanda B.O','758016',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143888,576,'Taneipal B.O','758021',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143889,576,'Tangarpada B.O','758030',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143890,576,'Tangiriapal B.O','758082',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143891,576,'Tara B.O','758027',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143892,576,'Taramakanta B.O','758085',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143893,576,'Taratara B.O','758021',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143894,576,'Tarimul B.O','758025',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143895,576,'Taruan B.O','758043',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143896,576,'Tavasarua B.O','758016',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143897,576,'Telkoi S.O','758019',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143898,576,'Tendra B.O','758016',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143899,576,'Tentlaposi B.O','758079',1,0,'2022-03-04 19:34:28','2022-03-04 19:34:28'),(143900,576,'Thakurani B.O','758035',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143901,576,'Thakurapada B.O','758028',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143902,576,'Tikarpada B.O','758013',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143903,576,'Tolankapada B.O','758020',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143904,576,'Toraniapal B.O','758025',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143905,576,'Toranipokhari B.O','758029',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143906,576,'Trilochanpur B.O','758015',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143907,576,'Tukudiha B.O','758032',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143908,576,'Tukuna B.O','758020',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143909,576,'Turumunga S.O','758046',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143910,576,'Uchhabali B.O','758044',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143911,576,'Udayapur S.O','758045',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143912,576,'Ukhunda S.O','758032',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143913,576,'Urumunda B.O','758085',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143914,577,'A G S.O','751001',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143915,577,'Abhayamukhi B.O','752103',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143916,577,'Acharya Vihar S.O','751022',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143917,577,'Aerodrome Area S.O','751020',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143918,577,'Aiginia B.O','751019',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143919,577,'Airport S.O (Khorda)','751020',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143920,577,'Amankud B.O','752103',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143921,577,'Andharua B.O','751003',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143922,577,'Ashok Nagar S.O (Khorda)','751009',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143923,577,'Athantar B.O','752102',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143924,577,'B J B Nagar S.O','751014',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143925,577,'Badagarh Brit Colony S.O','751018',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143926,577,'Balakati S.O','752100',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143927,577,'Balianta S.O','752101',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143928,577,'Balipatna S.O','752102',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143929,577,'Banamalipur S.O','752103',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143930,577,'Bankual B.O','751002',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143931,577,'Bapujee Nagar S.O','751009',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143932,577,'Baramunda Colony S.O','751003',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143933,577,'Benupur B.O','752101',1,0,'2022-03-04 19:34:29','2022-03-04 19:34:29'),(143934,577,'Bhainchua B.O','752100',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143935,577,'Bhakarsahi B.O','752103',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143936,577,'Bhanranizigarh B.O','752103',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143937,577,'Bharatpur B.O','751003',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143938,577,'Bhatpatna S.O','752115',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143939,577,'Bhimatangi ND S.O','751002',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143940,577,'Bhoinagar S.O','751022',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143941,577,'Bhubaneswar Court S.O','751014',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143942,577,'Bhubaneswar G.P.O.','751001',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143943,577,'Bhubaneswar R S S.O','751009',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143944,577,'Bhubaneswar Secretariate S.O','751001',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143945,577,'Biswanathpur B.O','752102',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143946,577,'Brahman Suanlo B.O','752100',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143947,577,'Brahmanasarangi B.O','752102',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143948,577,'Budheswari Colony S.O','751006',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143949,577,'C R P Lines S.O','751011',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143950,577,'Chanahat B.O','752102',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143951,577,'Chandra Sekhar Pur S.O','751016',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143952,577,'Darada B.O','752102',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143953,577,'Deulidharpur B.O','752103',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143954,577,'Dolakasati B.O','752102',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143955,577,'Dumduma Housing Board Colony S.O','751019',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143956,577,'G.G.P.Colony S.O','751025',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143957,577,'Garh Srirampur B.O','752100',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143958,577,'Garidipanchana B.O','752102',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143959,577,'Ghatikia B.O','751003',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143960,577,'Gopinathpur B.O','751002',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143961,577,'Harachandi Sahi S.O','751002',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143962,577,'I R C Village S.O','751015',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143963,577,'Itipur B.O','751002',1,0,'2022-03-04 19:34:30','2022-03-04 19:34:30'),(143964,577,'Jadupur B.O','751019',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143965,577,'Jagannathpur B.O','752101',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143966,577,'Jayapur B.O','752101',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143967,577,'Jharapada B.O','751006',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143968,577,'Jhinti Sasan B.O','752100',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143969,577,'K I I T S.O','751024',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143970,577,'Kakarudrapur B.O','752102',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143971,577,'Kalarahanga B.O','751024',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143972,577,'Kalinga Vihar B.O','751019',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143973,577,'Kalpana Square S.O','751006',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143974,577,'Kalyanpur Sasan B.O','751002',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143975,577,'Kantapada B.O','752103',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143976,577,'Kausalyaganga B.O','751002',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143977,577,'Kedargouri S.O','751002',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143978,577,'Khandagiri S.O','751030',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143979,577,'Kharavela Nagar S.O','751001',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143980,577,'Kuha B.O','751002',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143981,577,'Laxminarayanpur B.O','752100',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143982,577,'Laxmisagar S.O (Khorda)','751006',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143983,577,'Madhusudan Nagar S.O (Khorda)','751022',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143984,577,'Mahukhanda B.O','752102',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143985,577,'Majhihara B.O','752103',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143986,577,'Malipada B.O','751003',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143987,577,'Mancheswar B.O','751017',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143988,577,'Mancheswar R S B.O','751017',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143989,577,'Mancheswar Railway Colony S.O','751017',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143990,577,'Naharakanta B.O','752101',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143991,577,'Nayapalli S.O','751012',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143992,577,'Nuapada B.O','752102',1,0,'2022-03-04 19:34:31','2022-03-04 19:34:31'),(143993,577,'Old Town S.O (Khorda)','751002',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(143994,577,'Orissa  Assembly S.O','751001',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(143995,577,'Osap Campus S.O','751017',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(143996,577,'Padmapur B.O','752103',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(143997,577,'Pahal B.O','752101',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(143998,577,'Patia Gds B.O','751024',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(143999,577,'Patrapada B.O','751019',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(144000,577,'Pokhariput S.O','751020',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(144001,577,'Prataprudrapur B.O','752102',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(144002,577,'Raghuagorada B.O','752102',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(144003,577,'Rajbhawan S.O (Khorda)','751008',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(144004,577,'Rasulgarh S.O','751010',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(144005,577,'Regional Research Laboratory S.O','751013',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(144006,577,'S.E Rly.Proj. Complex S.O','751023',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(144007,577,'Saheed Nagar S.O','751007',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(144008,577,'Sailashree Vihar S.O','751021',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(144009,577,'Sainik School S.O (Khorda)','751005',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(144010,577,'Santarapur S.O','751002',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(144011,577,'Sarakana B.O','752100',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(144012,577,'Sarakantara B.O','751019',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(144013,577,'Sasan B.O','752102',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(144014,577,'Satyabhamapur B.O','752100',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(144015,577,'Satyanagar S.O (Khorda)','751007',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(144016,577,'Sisilo B.O','752100',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(144017,577,'Sisupalgarh B.O','751002',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(144018,577,'Station Bazar B.O','751006',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(144019,577,'Sundarpada B.O','751002',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(144020,577,'Suryanagar S.O (Khorda)','751003',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(144021,577,'Trahi Achyut Nagar B.O','752100',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(144022,577,'Turintira B.O','752102',1,0,'2022-03-04 19:34:32','2022-03-04 19:34:32'),(144023,577,'Udyan Marg S.O','751009',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144024,577,'Utkal University S.O','751004',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144025,577,'V S S Nagar S.O','751007',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144026,577,'Barimunda B.O','754001',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144027,577,'Bhola S.O','754012',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144028,577,'Dara B.O','754005',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144029,577,'Gandarpur B.O','754005',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144030,577,'Kalyanpur B.O','754001',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144031,577,'Nariso B.O','754004',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144032,577,'Abhimanpur B.O','752021',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144033,577,'Achyutpur B.O','752021',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144034,577,'Anda B.O','752060',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144035,577,'Angarpada B.O','752054',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144036,577,'Ankulachati B.O','752030',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144037,577,'Antarkiari B.O','752031',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144038,577,'Arakhapalli B.O','752066',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144039,577,'Arikama B.O','752064',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144040,577,'Arugul B.O','752050',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144041,577,'Asaral B.O','752064',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144042,577,'Ayatapur B.O','752035',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144043,577,'Badaberena B.O','752061',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144044,577,'Badakul B.O','752030',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144045,577,'Badapari B.O','752023',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144046,577,'Badasereipur B.O','752031',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144047,577,'Badatota B.O','752050',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144048,577,'Badhantuad B.O','752031',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144049,577,'Baghamari S.O','752061',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144050,577,'Bagheitangi B.O','752057',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144051,577,'Bajpur S.O','752060',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144052,577,'Baku B.O','752019',1,0,'2022-03-04 19:34:33','2022-03-04 19:34:33'),(144053,577,'Balidihi B.O','752031',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144054,577,'Balugaon Bazar S.O','752030',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144055,577,'Balugaon S.O','752030',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144056,577,'Bangida B.O','752056',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144057,577,'Bankoi B.O','752066',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144058,577,'Banpur Odagaon B.O','752035',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144059,577,'Banpur S.O (Khorda)','752031',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144060,577,'Baradangi B.O','752066',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144061,577,'Baradiharikunda B.O','752034',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144062,577,'Baradihi B.O','752027',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144063,577,'Barikilo B.O','752062',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144064,577,'Baulabandha B.O','752034',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144065,577,'Begunia S.O','752062',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144066,577,'Belapada B.O','752030',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144067,577,'Bhatapada B.O','752019',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144068,577,'Bheteswar B.O','752031',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144069,577,'Bhimpur B.O','752031',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144070,577,'Bhimpur Padanpur B.O','752050',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144071,577,'Bhogada B.O','752061',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144072,577,'Bhuasunipatna B.O','752061',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144073,577,'Bhusundapur B.O','752021',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144074,577,'Birakesharpur B.O','752020',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144075,577,'Biribadi B.O','752027',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144076,577,'Bolagarh S.O','752066',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144077,577,'Botalama B.O','752038',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144078,577,'Brajamohanpur B.O','752018',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144079,577,'Chakapada B.O','752062',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144080,577,'Chandeswar B.O','752023',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144081,577,'Chhamundiapalli B.O','752064',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144082,577,'Chhanagiri B.O','752020',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144083,577,'Chhatipur B.O','752060',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144084,577,'Chhatrapada B.O','752038',1,0,'2022-03-04 19:34:34','2022-03-04 19:34:34'),(144085,577,'Dabardhuapatna B.O','752066',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144086,577,'Dadhimachhagadia B.O','752056',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144087,577,'Dalatola B.O','752056',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144088,577,'Daleiput B.O','752056',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144089,577,'Damanbhuin B.O','752020',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144090,577,'Damiabarabara B.O','752035',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144091,577,'Dandichhatabar B.O','752054',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144092,577,'Deuli B.O','752064',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144093,577,'Dibyasinghpur B.O','752031',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144094,577,'Dighiri B.O','752066',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144095,577,'Dingar B.O','752062',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144096,577,'Gadanial B.O','752057',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144097,577,'Gambharimunda S.O','752035',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144098,577,'Gangadharpur S.O','752034',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144099,577,'Gangapada B.O','752054',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144100,577,'Garhkharad B.O','752019',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144101,577,'Garhmanitri B.O','752062',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144102,577,'Garhsanput B.O','752060',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144103,577,'Gediapalli B.O','752061',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144104,577,'Ghiakhala B.O','752030',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144105,577,'Goda B.O','752062',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144106,577,'Godabaris Mahavidyalaya B.O','752031',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144107,577,'Godikilo B.O','752038',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144108,577,'Godiput Matiapada B.O','752050',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144109,577,'Golabai B.O','752020',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144110,577,'Gopalipada B.O','752066',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144111,577,'Goudapatna B.O','752038',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144112,577,'Gudum B.O','752056',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144113,577,'Gurujanga B.O','752057',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144114,577,'Hadapada B.O','752018',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144115,577,'Haja B.O','752020',1,0,'2022-03-04 19:34:35','2022-03-04 19:34:35'),(144116,577,'Haladia B.O','752057',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144117,577,'Haldiapada B.O','752060',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144118,577,'Harichandanpur B.O','752035',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144119,577,'Haripur B.O','752021',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144120,577,'Haripur B.O','752066',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144121,577,'Haripursasan B.O','752034',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144122,577,'Harirajpur B.O','752050',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144123,577,'Jankia S.O','752020',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144124,577,'Janla S.O','752054',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144125,577,'Jaripada B.O','752022',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144126,577,'Jatni S.O','752050',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144127,577,'Kadab B.O','752062',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144128,577,'Kaimatia B.O','752054',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144129,577,'Kaipadar B.O','752056',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144130,577,'Kalanga B.O','752066',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144131,577,'Kaluparaghat S.O','752022',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144132,577,'Kalyanpur B.O','752056',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144133,577,'Kamaguru B.O','752021',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144134,577,'Kantabad B.O','752061',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144135,577,'Kantabad B.O','752054',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144136,577,'Kantia B.O','752050',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144137,577,'Karadgadia B.O','752056',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144138,577,'Keranga B.O','752057',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144139,577,'Kesharpur B.O','752019',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144140,577,'Khanat B.O','752030',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144141,577,'Khurda H.O','752055',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144142,577,'Khurda Road RS S.O','752050',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144143,577,'Kotapalla B.O','752061',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144144,577,'Kudiari B.O','752050',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144145,577,'Kuhuri S.O','752027',1,0,'2022-03-04 19:34:36','2022-03-04 19:34:36'),(144146,577,'Kulei B.O','752034',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144147,577,'Kumaranga B.O','752031',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144148,577,'Kumarbasta B.O','752057',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144149,577,'Kunjuri B.O','752027',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144150,577,'Kunjuri B.O','752056',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144151,577,'Kusumati B.O','752050',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144152,577,'Kusumi B.O','752021',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144153,577,'Lendu B.O','752019',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144154,577,'Loco Settlement S.O','752050',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144155,577,'Madanpur B.O','752054',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144156,577,'Mahura B.O','752054',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144157,577,'Malipada B.O','752018',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144158,577,'Malipadar B.O','752061',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144159,577,'Mangalajodi B.O','752023',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144160,577,'Manibandha B.O','752064',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144161,577,'Manikagoda B.O','752066',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144162,577,'Mendhasala B.O','752054',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144163,577,'Mordabadi B.O','752066',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144164,577,'Motta B.O','752020',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144165,577,'Muktapur B.O','752057',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144166,577,'Mukundaprasad B.O','752057',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144167,577,'Nachuni B.O','752034',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144168,577,'Nairi B.O','752034',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144169,577,'Nalipada Arjunpur B.O','752057',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144170,577,'Narangarh S.O','752018',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144171,577,'Narayanipada B.O','752062',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144172,577,'Narendrapur B.O','752031',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144173,577,'Naval Base Chilika S.O','752037',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144174,577,'Nidhipur B.O','752020',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144175,577,'Nijigarhtapang B.O','752018',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144176,577,'Niladriprasad B.O','752035',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144177,577,'Nilgiripatna B.O','752019',1,0,'2022-03-04 19:34:37','2022-03-04 19:34:37'),(144178,577,'Nirakarpur S.O','752019',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144179,577,'Odal B.O','752019',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144180,577,'Olasingh B.O','752020',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144181,577,'Olhan B.O','752019',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144182,577,'Orissa Engineering College S.O','752050',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144183,577,'P N College S.O','752057',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144184,577,'Paikatigiria B.O','752057',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144185,577,'Paikerapur B.O','752054',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144186,577,'Palaspur B.O','752054',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144187,577,'Pallahat S.O','752056',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144188,577,'Panabaraj B.O','752056',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144189,577,'Panchagaon B.O','752050',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144190,577,'Panchugaon B.O','752035',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144191,577,'Pangarsingh B.O','752061',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144192,577,'Parichhala B.O','752062',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144193,577,'Pariorada B.O','752023',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144194,577,'Patabandha B.O','752066',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144195,577,'Patiamal B.O','752023',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144196,577,'Pichikuli S.O','752064',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144197,577,'Podadihi B.O','752061',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144198,577,'Pratap B.O','752031',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144199,577,'Pubusahi B.O','752057',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144200,577,'Punjiama Sasan B.O','752031',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144201,577,'Rahanbeli B.O','752030',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144202,577,'Raigurupur B.O','752019',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144203,577,'Raipur B.O','752020',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144204,577,'Rajabazar S.O (Khorda)','752050',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144205,577,'Ramchandi B.O','752018',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144206,577,'Rameswar B.O','752020',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144207,577,'Reta R.S. B.O','752054',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144208,577,'Retang Colony S.O','752050',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144209,577,'Routapada B.O','752062',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144210,577,'Sagadabhanga B.O','752038',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144211,577,'Sagargaon B.O','752066',1,0,'2022-03-04 19:34:38','2022-03-04 19:34:38'),(144212,577,'Sahaspur B.O','752031',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144213,577,'Salapdihi B.O','752034',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144214,577,'Saliadam B.O','752031',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144215,577,'Sampur B.O','752066',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144216,577,'Sanahantuad B.O','752031',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144217,577,'Sanapadar B.O','752064',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144218,577,'Sardhapur B.O','752057',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144219,577,'Sarua B.O','752057',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144220,577,'Siko S.O','752038',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144221,577,'Simor B.O','752061',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144222,577,'Singheswar B.O','752030',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144223,577,'Singipur S.O','752021',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144224,577,'Soran B.O','752027',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144225,577,'Sunakhala B.O','752034',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144226,577,'Sundarpur B.O','752021',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144227,577,'Tamando B.O','752054',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144228,577,'Tangi S.O','752023',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144229,577,'Tangisahi B.O','752066',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144230,577,'Tankol B.O','752021',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144231,577,'Taraboi B.O','752050',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144232,577,'Tartua B.O','752057',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144233,577,'Thanapalli B.O','752061',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144234,577,'Turumal B.O','752050',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144235,578,'A.Malkangiri B.O','764021',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144236,578,'Almonda B.O','764027',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144237,578,'Ambaguda S.O','764055',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144238,578,'Ampawalli B.O','764039',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144239,578,'Anchala B.O','764056',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144240,578,'Anta B.O','764005',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144241,578,'Asana B.O','764002',1,0,'2022-03-04 19:34:39','2022-03-04 19:34:39'),(144242,578,'B.D.Pur S.O','764001',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144243,578,'B.Maliput B.O','764037',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144244,578,'Badel B.O','764041',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144245,578,'Badigada B.O','764040',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144246,578,'Bagderi B.O','764002',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144247,578,'Balda B.O','764038',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144248,578,'Balel B.O','764041',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144249,578,'Baligam B.O','764043',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144250,578,'Balipeta B.O','764014',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144251,578,'Bandhugam S.O','764027',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144252,578,'Bariniput S.O','764006',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144253,578,'Baruaguda B.O','764002',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144254,578,'Batasena B.O','764058',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144255,578,'Benagaon B.O','764057',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144256,578,'Benasur B.O','764056',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144257,578,'Bhairabsinghpur S.O','764057',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144258,578,'Bhaminiput B.O','764005',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144259,578,'Bhansuli B.O','764058',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144260,578,'Bheja B.O','764037',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144261,578,'Bhejaguda B.O','764044',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144262,578,'Bhejahandi B.O','764002',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144263,578,'Bhitarguda B.O','763008',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144264,578,'Bhusanguda B.O','764002',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144265,578,'Bijapur B.O','764056',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144266,578,'Bilangsil B.O','765013',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144267,578,'Bilaput B.O','764041',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144268,578,'Binjili B.O','764058',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144269,578,'Bobia B.O','764055',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144270,578,'Bodaput B.O','764043',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144271,578,'Bodigaon B.O','764057',1,0,'2022-03-04 19:34:40','2022-03-04 19:34:40'),(144272,578,'Boipariguda S.O','764043',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144273,578,'Borigi B.O','764027',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144274,578,'Borigumma S.O','764056',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144275,578,'Burja B.O','765013',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144276,578,'Champapadar B.O','764057',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144277,578,'Chanabeda B.O','764028',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144278,578,'Chandili B.O','764058',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144279,578,'Chatwa B.O','764038',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144280,578,'Chendika B.O','764039',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144281,578,'Chikima B.O','764043',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144282,578,'Chipakhor B.O','764043',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144283,578,'Chirma B.O','764058',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144284,578,'Chitra B.O','764056',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144285,578,'D.Padar B.O','764036',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144286,578,'D.Paunsi B.O','764002',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144287,578,'Dabuguda B.O','764003',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144288,578,'Damanjodi S.O','763008',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144289,578,'Dambaguda B.O','764028',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144290,578,'Dandabadi B.O','764043',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144291,578,'Dasamanthpur B.O','764043',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144292,578,'Dasamanthpur S.O','764028',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144293,578,'Deoghati B.O','764011',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144294,578,'Deopotangi B.O','764039',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144295,578,'Dhamanahandi B.O','764058',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144296,578,'Dhanpur B.O','764002',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144297,578,'Digapur B.O','764005',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144298,578,'Dongerchinchi B.O','764003',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144299,578,'Doraguda B.O','764043',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144300,578,'Dudhari B.O','764036',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144301,578,'Dumuriput B.O','764021',1,0,'2022-03-04 19:34:41','2022-03-04 19:34:41'),(144302,578,'Gadiaguda B.O','765013',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144303,578,'Gangarajpur B.O','764039',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144304,578,'Garidi B.O','764027',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144305,578,'Ghotarla B.O','764058',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144306,578,'Ghumar B.O','764058',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144307,578,'Ghumar B.O','764005',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144308,578,'Girla B.O','764058',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144309,578,'Girliguma B.O','764028',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144310,578,'Godapadar B.O','764003',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144311,578,'Godihanjar B.O','764040',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144312,578,'Golur B.O','764038',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144313,578,'Gondal B.O','764043',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144314,578,'Goudaguda B.O','765013',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144315,578,'Gujaniguda B.O','764056',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144316,578,'Gumuda B.O','764057',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144317,578,'Guneipada B.O','764040',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144318,578,'Guntaput B.O','764037',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144319,578,'Hadia B.O','764055',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144320,578,'Hakimput B.O','764037',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144321,578,'Haladikund B.O','764043',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144322,578,'Haradaput B.O','764055',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144323,578,'Hardoli B.O','764056',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144324,578,'Hataguda B.O','764036',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144325,578,'Hatibari B.O','764038',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144326,578,'Jabaguda B.O','764027',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144327,578,'Jalahanjar B.O','764081',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144328,578,'Jamunda B.O','764055',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144329,578,'Jayanagar S.O (Koraput)','764005',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144330,578,'Jayantgiri B.O','764056',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144331,578,'Jeypore(K) Civil Court S.O','764001',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144332,578,'Jeypore(K) Fort S.O','764001',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144333,578,'Jeypore(K) H.O','764001',1,0,'2022-03-04 19:34:42','2022-03-04 19:34:42'),(144334,578,'Jeypore(K) Irrigation Colony S.O','764004',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144335,578,'Jeypore(K) Koraput Road S.O','764001',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144336,578,'Jeypore(K) R.S. S.O','764002',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144337,578,'Jogipalur B.O','764014',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144338,578,'Jolaput S.O','764041',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144339,578,'K.Guda B.O','764036',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144340,578,'Kabidi B.O','764056',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144341,578,'Kabirbadi B.O','764027',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144342,578,'Kadamguda B.O','764037',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144343,578,'Kadamguda B.O','764043',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144344,578,'Kakirigumma B.O','765013',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144345,578,'Kaliagam B.O','764002',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144346,578,'Kamta B.O','764057',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144347,578,'Kaploda B.O','764027',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144348,578,'Karimiti B.O','764002',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144349,578,'Kasandi B.O','764037',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144350,578,'Kathargada B.O','764057',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144351,578,'Kendar B.O','764021',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144352,578,'Kenduguda B.O','764043',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144353,578,'Kerla B.O','764058',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144354,578,'Khairput B.O','764043',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144355,578,'Khudi B.O','764036',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144356,578,'Khumbari B.O','764014',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144357,578,'Khurjee B.O','764037',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144358,578,'Kolab Nagar S.O','764011',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144359,578,'Kollar B.O','764043',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144360,578,'Konagam B.O','764056',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144361,578,'Konga B.O','764055',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144362,578,'Koraput Collectorate S.O','764020',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144363,578,'Koraput H.O','764020',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144364,578,'Koraput R.S. S.O','764021',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144365,578,'Kosaguda B.O','764056',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144366,578,'Kotiya B.O','764039',1,0,'2022-03-04 19:34:43','2022-03-04 19:34:43'),(144367,578,'Kotpad S.O','764058',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144368,578,'Kularsingi B.O','764038',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144369,578,'Kumargandhana B.O','764037',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144370,578,'Kumbharput B.O','764027',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144371,578,'Kumuli B.O','764057',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144372,578,'Kunduli B.O','764036',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144373,578,'Kundura B.O','764002',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144374,578,'Kusumguda B.O','765013',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144375,578,'Lamtaput S.O','764081',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144376,578,'Laxmipur (Koraput) S.O','765013',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144377,578,'Lima B.O','764002',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144378,578,'Litiguda B.O','763008',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144379,578,'Lulla B.O','764028',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144380,578,'Machhkund S.O','764040',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144381,578,'Mahadeiput B.O','764021',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144382,578,'Majhiguda B.O','764043',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144383,578,'Malbelagam B.O','764037',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144384,578,'Malda B.O','764056',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144385,578,'Maliput B.O','764039',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144386,578,'Mastiput B.O','764021',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144387,578,'Mathalput B.O','763008',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144388,578,'Modeigaon B.O','764058',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144389,578,'Mohuli B.O','764043',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144390,578,'Mosigam B.O','764043',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144391,578,'Mudulipada B.O','764043',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144392,578,'Munja B.O','764057',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144393,578,'Munjanga B.O','765013',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144394,578,'Murkur B.O','764028',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144395,578,'Muttahandi B.O','764058',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144396,578,'Nandapur S.O','764037',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144397,578,'Nandigam B.O','764021',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144398,578,'Narayanpatna S.O','764014',1,0,'2022-03-04 19:34:44','2022-03-04 19:34:44'),(144399,578,'Narigam B.O','764057',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144400,578,'Nilabadi B.O','764027',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144401,578,'Nuagaon B.O','764056',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144402,578,'Odiapentha B.O','765013',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144403,578,'Omp Line S.O','764021',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144404,578,'Ondrahal B.O','764042',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144405,578,'Ondrangi B.O','764039',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144406,578,'Onukadeli S.O','764042',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144407,578,'P.Muthai B.O','764036',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144408,578,'P.Phulbeda B.O','764021',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144409,578,'Padavalda B.O','764027',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144410,578,'Padwa S.O (Koraput)','764038',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144411,578,'Pakjhola B.O','764036',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144412,578,'Panasaguda B.O','764056',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144413,578,'Panchada B.O','765013',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144414,578,'Panthulunga B.O','764038',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144415,578,'Peta B.O','764003',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144416,578,'Peturu B.O','764039',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144417,578,'Phampuni B.O','764002',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144418,578,'Phupugaon B.O','764002',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144419,578,'Pindapadar B.O','764028',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144420,578,'Pipalpadar B.O','765013',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144421,578,'Pithaguda B.O','764037',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144422,578,'Podagada B.O','765013',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144423,578,'Podaghat B.O','764043',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144424,578,'Podapadar B.O','764014',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144425,578,'Porli B.O','764056',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144426,578,'Pottangi S.O','764039',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144427,578,'Prasadraopeta S.O','764003',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144428,578,'Pujariput B.O','764056',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144429,578,'Pukali B.O','764039',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144430,578,'R Zone(Sunabeda) S.O','763002',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144431,578,'Raisingi B.O','764038',1,0,'2022-03-04 19:34:45','2022-03-04 19:34:45'),(144432,578,'Rajput B.O','764036',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144433,578,'Ralegada B.O','764039',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144434,578,'Ramgiri B.O','764043',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144435,578,'Ranaspur B.O','764057',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144436,578,'Raniguda B.O','764056',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144437,578,'Raniput B.O','764005',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144438,578,'Ranjiput B.O','764027',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144439,578,'Rasbeda B.O','764043',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144440,578,'Renga B.O','764036',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144441,578,'Rondapalli B.O','764002',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144442,578,'Sadabari B.O','764027',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144443,578,'Sadam B.O','764039',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144444,578,'Sadaranga B.O','764058',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144445,578,'Sambai B.O','764039',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144446,578,'Sanparia B.O','764056',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144447,578,'Sasahandi B.O','764056',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144448,578,'Sector-VII(Sunabeda) S.O','763002',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144449,578,'Semiliguda S.O','764036',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144450,578,'Semlaguda B.O','764057',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144451,578,'Simla B.O','764037',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144452,578,'Soguru B.O','764081',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144453,578,'Sorada B.O','764039',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144454,578,'Sorgiguda B.O','764056',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144455,578,'Subai B.O','764037',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144456,578,'Suku B.O','764021',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144457,578,'Sunabeda-1 S.O','763001',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144458,578,'Sunabeda-2 S.O','763002',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144459,578,'Sunarbelli (Nuagaon) B.O','764058',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144460,578,'Sunki B.O','764039',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144461,578,'T.Gumandi B.O','764014',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144462,578,'T.Padar B.O','764014',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144463,578,'T.Thuba B.O','764037',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144464,578,'Tankua B.O','764003',1,0,'2022-03-04 19:34:46','2022-03-04 19:34:46'),(144465,578,'Taraput B.O','764002',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144466,578,'Tentuligumma B.O','764043',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144467,578,'Tikarpada B.O','764081',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144468,578,'Toyaput B.O','765013',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144469,578,'Turia B.O','764039',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144470,578,'Tusuba B.O','764081',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144471,578,'Ukiapalli B.O','764058',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144472,578,'Umuri B.O','764002',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144473,578,'Umuri B.O','764021',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144474,578,'Upperdural B.O','764042',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144475,578,'Upperkutinga B.O','765013',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144476,578,'Wandergada B.O','764038',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144477,579,'Ambaguda B.O','764044',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144478,579,'Anantapali B.O','764087',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144479,579,'Andrapali B.O','764052',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144480,579,'Attanda B.O','764041',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144481,579,'B.Mamidi B.O','764051',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144482,579,'Badapadar B.O','764052',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144483,579,'Balimela S.O','764051',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144484,579,'Bapanpali B.O','764047',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144485,579,'Bhejangiwada B.O','764047',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144486,579,'Birlaxmipur B.O','764044',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144487,579,'Bodili B.O','764086',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144488,579,'Boiliguma B.O','764052',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144489,579,'Chalanguda B.O','764045',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144490,579,'Chaulmendi B.O','764044',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144491,579,'Chedenga B.O','764044',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144492,579,'Chitapari B.O','764051',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144493,579,'Chitrakonda S.O','764052',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144494,579,'Chitrangpali B.O','764086',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144495,579,'Dalapatiguda B.O','764044',1,0,'2022-03-04 19:34:47','2022-03-04 19:34:47'),(144496,579,'Doraguda B.O','764052',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144497,579,'Dungiaput B.O','764044',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144498,579,'Dyke-1 B.O','764051',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144499,579,'Girikanpalli B.O','764047',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144500,579,'Gongola B.O','764044',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144501,579,'Gopagonda B.O','764047',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144502,579,'Goudaguda B.O','764045',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144503,579,'Govindpalli B.O','764044',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144504,579,'Gunthawada B.O','764052',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144505,579,'Gurakhunta B.O','764086',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144506,579,'Jharapalli B.O','764045',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144507,579,'Jodamba B.O','764052',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144508,579,'Kalimela S.O','764047',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144509,579,'Kambeda B.O','764051',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144510,579,'Kartanpalli B.O','764044',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144511,579,'Khairaput','764046',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144512,579,'Kiyanga B.O','764044',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144513,579,'Kongurukonda B.O','764047',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144514,579,'Korukonda B.O','764045',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144515,579,'Kottapali B.O','764044',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144516,579,'Kudumuluguma B.O','764043',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144517,579,'Kutunipalli B.O','764044',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144518,579,'Lachipeta S.O','764087',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144519,579,'Maharajpalli B.O','764087',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144520,579,'Malavaram B.O','764087',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144521,579,'Malkangiri Colony S.O','764048',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144522,579,'Malkangiri S.O','764045',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144523,579,'Manyamkonda B.O','764047',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144524,579,'Maranpalli B.O','764047',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144525,579,'Mariwada B.O','764045',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144526,579,'Mathili S.O','764044',1,0,'2022-03-04 19:34:48','2022-03-04 19:34:48'),(144527,579,'Mekka B.O','764044',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144528,579,'Mendukuli B.O','764044',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144529,579,'Metapoka B.O','764086',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144530,579,'Mohupadar B.O','764044',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144531,579,'Motteru B.O','764047',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144532,579,'Motu B.O','764087',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144533,579,'Muduliguda B.O','764051',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144534,579,'Naikaguda B.O','764044',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144535,579,'Nakamamidi B.O','764051',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144536,579,'Nallagunthi B.O','764047',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144537,579,'Nilakhambari B.O','764051',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144538,579,'Niliguda B.O','764047',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144539,579,'Padmagiri B.O','764045',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144540,579,'Panasput B.O','764052',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144541,579,'Panchabati B.O','764045',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144542,579,'Pandripani B.O','764044',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144543,579,'Papermetla B.O','764052',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144544,579,'Pedakonda B.O','764045',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144545,579,'Podia B.O','764047',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144546,579,'Pongam B.O','764044',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144547,579,'Populuru B.O','764052',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144548,579,'Potrel B.O','764051',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144549,579,'Pulimetla B.O','764086',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144550,579,'Relageda B.O','764052',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144551,579,'Salimi B.O','764044',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144552,579,'Saradhapalli S.O','764086',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144553,579,'Sikhapali B.O','764086',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144554,579,'Simlibamchha B.O','764047',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144555,579,'Somnathpur B.O','764043',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144556,579,'Talarai B.O','764047',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144557,579,'Tamasa B.O','764045',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144558,579,'Tandabai B.O','764087',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144559,579,'Tandiki B.O','764045',1,0,'2022-03-04 19:34:49','2022-03-04 19:34:49'),(144560,579,'Tarlakota B.O','764051',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144561,579,'Temurupali B.O','764044',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144562,579,'Tumusapalli B.O','764045',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144563,579,'Udilibeda B.O','764044',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144564,579,'Venkatpallam B.O','764047',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144565,580,'Agria B.O','757025',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144566,580,'Aguad B.O','757025',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144567,580,'Aharbandh B.O','757050',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144568,580,'Alda B.O','757082',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144569,580,'Aldia Bartana B.O','757052',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144570,580,'Amarda S.O','757055',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144571,580,'Ambadali B.O','757075',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144572,580,'Ambadiha B.O','757048',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144573,580,'Ambadiha B.O','757041',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144574,580,'Ambagadia B.O','757028',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144575,580,'Ambapunja B.O','757030',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144576,580,'Ambikadeipur B.O','757087',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144577,580,'Ambikasahi S.O','757001',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144578,580,'Angarpada B.O','757035',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144579,580,'Aniapal B.O','757105',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144580,580,'Anla B.O','757052',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144581,580,'Anladuva S.O','757043',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144582,580,'Anlajo R.S. B.O','757042',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144583,580,'Anlakuda B.O','757021',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144584,580,'Anua B.O','757018',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144585,580,'Arjunbilla B.O','757039',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144586,580,'Arpata B.O','757083',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144587,580,'Asana B.O','757054',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144588,580,'Asana B.O','757033',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144589,580,'Asana B.O','757032',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144590,580,'Asanbani B.O','757029',1,0,'2022-03-04 19:34:50','2022-03-04 19:34:50'),(144591,580,'Asanjoda B.O','757105',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144592,580,'Astajharan B.O','757075',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144593,580,'Astakuanr B.O','757034',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144594,580,'Atanati B.O','757019',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144595,580,'Athapara B.O','757087',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144596,580,'B. Chhelia B.O','757026',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144597,580,'Bachhuripal B.O','757016',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144598,580,'Badampahar S.O','757047',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144599,580,'Badampur B.O','757020',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144600,580,'Badamtalia B.O','757048',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144601,580,'Badbhalia B.O','757084',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144602,580,'Badchatra B.O','757086',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144603,580,'Badchhuruni B.O','757100',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144604,580,'Baddalima B.O','757053',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144605,580,'Baddhenkia B.O','757084',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144606,580,'Badfeni B.O','757074',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144607,580,'Badfera B.O','757023',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144608,580,'Badgaon B.O','757036',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144609,580,'Badgaon B.O','757092',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144610,580,'Badgaon B.O','757042',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144611,580,'Badgudugudia B.O','757040',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144612,580,'Badjod B.O','757029',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144613,580,'Badkaranjia B.O','757019',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144614,580,'Badkedam B.O','757054',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144615,580,'Badkhaladi B.O','757040',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144616,580,'Badkhaman B.O','757077',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144617,580,'Badkhiripada B.O','757028',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144618,580,'Badkuleibira B.O','757045',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144619,580,'Badmamundia B.O','757019',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144620,580,'Badmouda B.O','757042',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144621,580,'Badmundhabani B.O','757023',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144622,580,'Badnalua B.O','757033',1,0,'2022-03-04 19:34:51','2022-03-04 19:34:51'),(144623,580,'Badpalasa B.O','757053',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144624,580,'Badpathara B.O','757074',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144625,580,'Badra B.O','757042',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144626,580,'Badsimulia B.O','757040',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144627,580,'Badsingaria B.O','757041',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144628,580,'Badsole B.O','757086',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144629,580,'Badterenti B.O','757039',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144630,580,'Bagbuda B.O','757051',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144631,580,'Baghra B.O','757022',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144632,580,'Baghra Road B.O','757003',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144633,580,'Baghuasole B.O','757014',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144634,580,'Bagjhumpa B.O','757031',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144635,580,'Bahalda B.O','757074',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144636,580,'Bahalda Rd RS S.O','757054',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144637,580,'Bahalda S.O','757046',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144638,580,'Bahanada S.O','757104',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144639,580,'Bahanada Sathilo S.O','757100',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144640,580,'Bahubandh B.O','757041',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144641,580,'Baidyanath B.O','757035',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144642,580,'Baiganbaria B.O','757105',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144643,580,'Baincha Nuagaon B.O','757020',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144644,580,'Bairatpur B.O','757101',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144645,580,'Baisinga S.O','757028',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144646,580,'Bajratundi B.O','757024',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144647,580,'Bakartala B.O','757036',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144648,580,'Bakla B.O','757091',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144649,580,'Bala B.O','757036',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144650,580,'Baladia B.O','757020',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144651,580,'Baldiha Khunta B.O','757019',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144652,580,'Balichhatra B.O','757087',1,0,'2022-03-04 19:34:52','2022-03-04 19:34:52'),(144653,580,'Balidiha B.O','757049',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144654,580,'Balka B.O','757082',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144655,580,'Banakati B.O','757019',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144656,580,'Banakati B.O','757048',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144657,580,'Baneikala B.O','757033',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144658,580,'Bangra B.O','757074',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144659,580,'Bangriposi S.O','757032',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144660,580,'Bankati B.O','757032',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144661,580,'Bankisole B.O','757107',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144662,580,'Baradihi B.O','757085',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144663,580,'Barakamuda B.O','757036',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144664,580,'Barehipani B.O','757034',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144665,580,'Bari B.O','757022',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144666,580,'Baria B.O','757036',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144667,580,'Baripada Bazar S.O','757001',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144668,580,'Baripada Court S.O','757001',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144669,580,'Baripada H.O','757001',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144670,580,'Baripada Hospital S.O','757001',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144671,580,'Baripada Municipal Market S.O','757001',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144672,580,'Baripada R.S. S.O','757001',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144673,580,'Barkand B.O','757020',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144674,580,'Barsahi S.O','757026',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144675,580,'Bartana B.O','757025',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144676,580,'Basilapir B.O','757047',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144677,580,'Basingi B.O','757046',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144678,580,'Basipitha S.O','757074',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144679,580,'Batpalasa B.O','757036',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144680,580,'Baunsbilla B.O','757024',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144681,580,'Baunsda B.O','757031',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144682,580,'Baunsdiha B.O','757038',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144683,580,'Baunsnali B.O','757034',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144684,580,'Bautibeda B.O','757033',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144685,580,'Bedhakudar B.O','757032',1,0,'2022-03-04 19:34:53','2022-03-04 19:34:53'),(144686,580,'Begunia B.O','757091',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144687,580,'Belam B.O','757024',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144688,580,'Belbaria B.O','757086',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144689,580,'Belgadia S.O','757002',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144690,580,'Betnoti S.O','757025',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144691,580,'Bhaduasole B.O','757073',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144692,580,'Bhadubeda B.O','757037',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144693,580,'Bhagabandi B.O','757053',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144694,580,'Bhairangisole B.O','757018',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144695,580,'Bhalia B.O','757029',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144696,580,'Bhaliadiha B.O','757018',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144697,580,'Bhalubasa B.O','757050',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144698,580,'Bhaluki B.O','757049',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144699,580,'Bhandagaon B.O','757019',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144700,580,'Bhanjkia B.O','757091',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144701,580,'Bhanjpur S.O','757002',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144702,580,'Bhanra B.O','757037',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144703,580,'Bharandia B.O','757038',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144704,580,'Bhatchhatar B.O','757020',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144705,580,'Bhimda S.O','757083',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144706,580,'Bhimkhanda B.O','757042',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144707,580,'Bhimtali B.O','757041',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144708,580,'Bhitaramda B.O','757054',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144709,580,'Bholagadia B.O','757104',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144710,580,'Bholaghati B.O','757018',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144711,580,'Bhuasuni B.O','757092',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144712,580,'Bhudrubani B.O','757107',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144713,580,'Bhudurbani B.O','757052',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144714,580,'Bhugudakata B.O','757014',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144715,580,'Bhursani B.O','757086',1,0,'2022-03-04 19:34:54','2022-03-04 19:34:54'),(144716,580,'Bidukudia B.O','757028',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144717,580,'Bijatala S.O','757048',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144718,580,'Bijay Ramchandrapur S.O','757002',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144719,580,'Bijipur B.O','757017',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144720,580,'Binjhua B.O','757046',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144721,580,'Bireswarpur B.O','757075',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144722,580,'Bisoi S.O','757033',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144723,580,'Brahmaniposi B.O','757035',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144724,580,'Brahmanmara B.O','757084',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144725,580,'Brahmapura B.O','757055',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144726,580,'Bramarposi B.O','757039',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144727,580,'Brundaban Chandrapur S.O','757087',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144728,580,'Budama R.S. B.O','757081',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144729,580,'Budamara B.O','757035',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144730,580,'Budhigambharia B.O','757035',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144731,580,'Budhikhamari B.O','757029',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144732,580,'Budhikhamari B.O','757092',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144733,580,'C.Mangalpur B.O','757083',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144734,580,'Chadada B.O','757026',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144735,580,'Chadada B.O','757087',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144736,580,'Chadheigaon B.O','757084',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144737,580,'Chakidi B.O','757034',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144738,580,'Chakradharpur B.O','757077',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144739,580,'Chaksuliapada B.O','757021',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144740,580,'Chakulia B.O','757020',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144741,580,'Champajhar B.O','757038',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144742,580,'Chanchbani B.O','757036',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144743,580,'Chandabilla B.O','757018',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144744,580,'Chandanpur B.O','757049',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144745,580,'Chandanpur B.O','757017',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144746,580,'Chandrapur B.O','757075',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144747,580,'Chandrapur B.O','757087',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144748,580,'Chandua Ashram S.O','757014',1,0,'2022-03-04 19:34:55','2022-03-04 19:34:55'),(144749,580,'Changua B.O','757053',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144750,580,'Chaturanjali B.O','757039',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144751,580,'Chaturi B.O','757102',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144752,580,'Chhadkata B.O','757049',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144753,580,'Chhatna B.O','757018',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144754,580,'Chhelia B.O','757026',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144755,580,'Chheligudhudi B.O','757034',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144756,580,'Chitrada S.O','757018',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144757,580,'Chitraposi B.O','757037',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144758,580,'Chuapani B.O','757050',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144759,580,'Chuhat B.O','757021',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144760,580,'Chuinposi B.O','757040',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144761,580,'Dahikoti B.O','757100',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144762,580,'Dakoipodadiha B.O','757003',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144763,580,'Dalki B.O','757025',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144764,580,'Damodar Pur B.O','757003',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144765,580,'Damudigoda B.O','757048',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144766,580,'Danadar B.O','757032',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144767,580,'Dantiamuhan B.O','757029',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144768,580,'Dardara B.O','757014',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144769,580,'Dari B.O','757036',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144770,580,'Darudihi B.O','757022',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144771,580,'Daundia B.O','757083',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144772,580,'Debgaon B.O','757085',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144773,580,'Debsole B.O','757016',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144774,580,'Dengam B.O','757104',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144775,580,'Denua B.O','757035',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144776,580,'Deopara B.O','757017',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144777,580,'Deulasahi S.O','757001',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144778,580,'Deuli S.O','757021',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144779,580,'Deulia B.O','757026',1,0,'2022-03-04 19:34:56','2022-03-04 19:34:56'),(144780,580,'Dewan Bahali B.O','757079',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144781,580,'Dhalabani B.O','757034',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144782,580,'Dhanghera B.O','757087',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144783,580,'Dhangudisole B.O','757081',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144784,580,'Dhanpur B.O','757029',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144785,580,'Dhansole B.O','757018',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144786,580,'Dharamdihi B.O','757053',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144787,580,'Dharampura B.O','757084',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144788,580,'Dhatika B.O','757022',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144789,580,'Dhemnasole B.O','757021',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144790,580,'Dhenkinenjia B.O','757023',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144791,580,'Dhobanisole B.O','757032',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144792,580,'Digar Astia B.O','757030',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144793,580,'Digdhar B.O','757038',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144794,580,'Dighi B.O','757032',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144795,580,'Dihirakul B.O','757101',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144796,580,'Dimagadia B.O','757101',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144797,580,'Dolsara B.O','757054',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144798,580,'Dova B.O','757047',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144799,580,'Dudhiani B.O','757036',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144800,580,'Dudhiasole B.O','757081',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144801,580,'Dughdha B.O','757041',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144802,580,'Dukura S.O','757075',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144803,580,'Dumurdiha B.O','757093',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144804,580,'Dumurdiha B.O','757105',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144805,580,'Dundu B.O','757046',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144806,580,'Durdura B.O','757034',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144807,580,'Durgapur B.O','757025',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144808,580,'Durgapur B.O','757052',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144809,580,'Durgapur B.O','757082',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144810,580,'Ekdali B.O','757031',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144811,580,'Ektali B.O','757091',1,0,'2022-03-04 19:34:57','2022-03-04 19:34:57'),(144812,580,'Fania B.O','757084',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144813,580,'Futukisole B.O','757023',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144814,580,'Gadapalasa B.O','757091',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144815,580,'Gadigaon B.O','757018',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144816,580,'Gadigaon B.O','757087',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144817,580,'Galusahi B.O','757039',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144818,580,'Gambharia B.O','757046',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144819,580,'Gandipani B.O','757031',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144820,580,'Gangraj B.O','757105',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144821,580,'Garhdeulia S.O','757082',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144822,580,'Garia S.O (Mayurbhanj)','757023',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144823,580,'Garudnesa B.O','757107',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144824,580,'Gayalkata B.O','757014',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144825,580,'Gayalmara B.O','757104',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144826,580,'Gendagadia B.O','757026',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144827,580,'Gendapokhari B.O','757030',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144828,580,'Ghagarbeda B.O','757035',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144829,580,'Ghagarda B.O','757037',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144830,580,'Ghatkuanri B.O','757032',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144831,580,'Ghodabandha  Khuntapal B.O','757020',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144832,580,'Ghodapal B.O','757030',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144833,580,'Gholmuhan B.O','757018',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144834,580,'Ghosada B.O','757037',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144835,580,'Gobapal B.O','757025',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144836,580,'Gobra B.O','757016',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144837,580,'Golagadia B.O','757040',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144838,580,'Golamundhakata B.O','757032',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144839,580,'Gorumahisani S.O','757042',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144840,580,'Gosaingaon B.O','757082',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144841,580,'Gosanipal B.O','757032',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144842,580,'Goudadiha B.O','757003',1,0,'2022-03-04 19:34:58','2022-03-04 19:34:58'),(144843,580,'Goudagaon B.O','757040',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144844,580,'Goudruma B.O','757030',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144845,580,'Gouduniduba B.O','757084',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144846,580,'Gour Chandra Pur B.O','757079',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144847,580,'Gudialbandh B.O','757024',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144848,580,'Gudugudia B.O','757034',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144849,580,'Guhaldangri B.O','757042',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144850,580,'Halda B.O','757045',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144851,580,'Haldia (Baripada) B.O','757105',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144852,580,'Haldia B.O','757039',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144853,580,'Haldibani B.O','757049',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144854,580,'Harekrushnapur B.O','757073',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144855,580,'Haripur B.O','757103',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144856,580,'Haripur B.O','757055',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144857,580,'Hatbadra S.O','757050',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144858,580,'Hatia B.O','757042',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144859,580,'Hatibari B.O','757036',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144860,580,'Hatigoda B.O','757038',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144861,580,'Hatijhari B.O','757052',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144862,580,'Hatikote B.O','757029',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144863,580,'Hatisahi B.O','757087',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144864,580,'Hempur B.O','757082',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144865,580,'Hesda B.O','757050',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144866,580,'Hill Block - 24 B.O','757077',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144867,580,'Hindala B.O','757035',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144868,580,'Hinjili B.O','757092',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144869,580,'Hirapur B.O','757019',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144870,580,'Idar B.O','757018',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144871,580,'Indukhali B.O','757046',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144872,580,'Indupur B.O','757037',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144873,580,'Itamundia B.O','757075',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144874,580,'Jadunathpur B.O','757024',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144875,580,'Jagannathkhunta B.O','757030',1,0,'2022-03-04 19:34:59','2022-03-04 19:34:59'),(144876,580,'Jagannathpur B.O','757049',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144877,580,'Jaida B.O','757040',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144878,580,'Jaida B.O','757041',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144879,580,'Jaipur B.O','757085',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144880,580,'Jalda B.O','757086',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144881,580,'Jaldiha B.O','757092',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144882,580,'Jambani B.O','757040',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144883,580,'Jamda S.O (Mayurbhanj)','757045',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144884,580,'Jamdapal B.O','757029',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144885,580,'Jamsole B.O','757029',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144886,580,'Jamukeswar B.O','757034',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144887,580,'Jamunti B.O','757039',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144888,580,'Jamuti B.O','757035',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144889,580,'Jarak B.O','757038',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144890,580,'Jarkani B.O','757045',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144891,580,'Jashipur S.O','757034',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144892,580,'Jhadghosada B.O','757039',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144893,580,'Jharbeda B.O','757091',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144894,580,'Jharia B.O','757016',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144895,580,'Jharpokharia S.O','757086',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144896,580,'Jhinkiria B.O','757020',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144897,580,'Jhipabandh B.O','757047',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144898,580,'Jirei B.O','757053',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144899,580,'Joka S.O (Mayurbhanj)','757093',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144900,580,'Jorda B.O','757047',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144901,580,'Jualia B.O','757041',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144902,580,'Jugal B.O','757052',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144903,580,'Jugpura S.O','757052',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144904,580,'Kadalia B.O','757028',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144905,580,'Kadualbandh B.O','757024',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144906,580,'Kaduani B.O','757033',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144907,580,'Kaduani B.O','757084',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144908,580,'Kainfulia B.O','757107',1,0,'2022-03-04 19:35:00','2022-03-04 19:35:00'),(144909,580,'Kainsari B.O','757041',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144910,580,'Kakharusole B.O','757014',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144911,580,'Kalabadia B.O','757030',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144912,580,'Kaladahi B.O','757040',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144913,580,'Kalama B.O','757082',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144914,580,'Kalamgodia B.O','757079',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144915,580,'Kamalasole B.O','757075',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144916,580,'Kamali B.O','757075',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144917,580,'Kamardiha B.O','757016',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144918,580,'Kanchhinda B.O','757092',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144919,580,'Kanchisole B.O','757025',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144920,580,'Kandana B.O','757023',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144921,580,'Kanimahuli B.O','757021',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144922,580,'Kantapal B.O','757105',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144923,580,'Kantipur B.O','757082',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144924,580,'Kapoi B.O','757018',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144925,580,'Kaptipada S.O','757040',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144926,580,'Karamsole B.O','757029',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144927,580,'Karanjia Bazar S.O','757037',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144928,580,'Karanjia Court S.O','757037',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144929,580,'Karanjia Golei S.O','757037',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144930,580,'Karanjia S.O (Mayurbhanj)','757037',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144931,580,'Karkachia B.O','757019',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144932,580,'Kathbharia B.O','757047',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144933,580,'Kathsirsi B.O','757030',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144934,580,'Katra Chandan Pur B.O','757032',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144935,580,'Katuria B.O','757079',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144936,580,'Kendua B.O','757049',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144937,580,'Kendudiha B.O','757026',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144938,580,'Kendujiani B.O','757037',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144939,580,'Kendumundi B.O','757037',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144940,580,'Kerkera B.O','757037',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144941,580,'Kerko Baiganbaria B.O','757024',1,0,'2022-03-04 19:35:01','2022-03-04 19:35:01'),(144942,580,'Kesharpur B.O','757081',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144943,580,'Keshdiha B.O','757038',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144944,580,'Keshrasole B.O','757023',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144945,580,'Keutunimari B.O','757014',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144946,580,'Khadambeda B.O','757033',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144947,580,'Khadiasole B.O','757086',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144948,580,'Khadikapada B.O','757052',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144949,580,'Khairbani B.O','757081',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144950,580,'Khairi Jashipur S.O','757091',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144951,580,'Khairpal B.O','757045',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144952,580,'Khaladi B.O','757041',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144953,580,'Khalapada B.O','757023',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144954,580,'Khandabandh B.O','757038',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144955,580,'Khanua B.O','757075',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144956,580,'Kherna B.O','757051',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144957,580,'Khiching B.O','757039',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144958,580,'Khunta S.O','757019',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144959,580,'Khuntapada B.O','757035',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144960,580,'Khuntapal B.O','757020',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144961,580,'Khuntapal B.O','757026',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144962,580,'Khuntapur B.O','757028',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144963,580,'Khuruntia B.O','757073',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144964,580,'Kisandahi B.O','757049',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144965,580,'Kochilaghaty B.O','757049',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144966,580,'Kochilakhunta B.O','757025',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144967,580,'Koilisuta B.O','757030',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144968,580,'Kolialam B.O','757077',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144969,580,'Kostha S.O','757084',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144970,580,'Kothabila B.O','757081',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144971,580,'Krushnachandrapur S.O','757029',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144972,580,'Kuabuda B.O','757014',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144973,580,'Kuamara S.O','757027',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144974,580,'Kuanrdihi B.O','757086',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144975,580,'Kuchei S.O','757105',1,0,'2022-03-04 19:35:02','2022-03-04 19:35:02'),(144976,580,'Kudiapal B.O','757030',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(144977,580,'Kui B.O','757023',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(144978,580,'Kujidihi B.O','757023',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(144979,580,'Kukudimundi B.O','757042',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(144980,580,'Kulgi B.O','757046',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(144981,580,'Kuliana Barsahi B.O','757025',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(144982,580,'Kuliana S.O','757030',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(144983,580,'Kuliposi B.O','757037',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(144984,580,'Kumbharmundakata S.O','757081',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(144985,580,'Kumbhirda B.O','757039',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(144986,580,'Kumudasole B.O','757050',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(144987,580,'Kundabai B.O','757087',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(144988,580,'Kundulia B.O','757092',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(144989,580,'Kundulia B.O','757033',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(144990,580,'Kuradiha B.O','757017',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(144991,580,'Kushalda S.O','757085',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(144992,580,'Kushpada B.O','757037',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(144993,580,'Kusumasole B.O','757014',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(144994,580,'Kusumbandi S.O','757092',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(144995,580,'Kusumi B.O','757050',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(144996,580,'Kutling B.O','757041',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(144997,580,'Labania B.O','757092',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(144998,580,'Labanyadeipur B.O','757079',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(144999,580,'Lakhanasahi B.O','757075',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(145000,580,'Laxmiposi S.O','757107',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(145001,580,'Luhakani B.O','757048',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(145002,580,'Luhasila B.O','757048',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(145003,580,'Lunia B.O','757023',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(145004,580,'Lupung B.O','757053',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(145005,580,'M. Kanpur B.O','757016',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(145006,580,'M.Beuinria B.O','757091',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(145007,580,'Machhapada B.O','757052',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(145008,580,'Madhopur B.O','757103',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(145009,580,'Maghua B.O','757053',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(145010,580,'Mahabila B.O','757022',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(145011,580,'Mahadevdihi B.O','757042',1,0,'2022-03-04 19:35:03','2022-03-04 19:35:03'),(145012,580,'Mahulbarei B.O','757051',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145013,580,'Mahuldiha B.O','757038',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145014,580,'Mahuldiha S.O','757043',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145015,580,'Mahulia B.O','757073',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145016,580,'Mahulpankha B.O','757106',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145017,580,'Mahulpatna B.O','757028',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145018,580,'Maigaon B.O','757018',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145019,580,'Majhigadia B.O','757106',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145020,580,'Majhigaon B.O','757033',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145021,580,'Makunda B.O','757018',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145022,580,'Manada B.O','757033',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145023,580,'Manbhanj B.O','757032',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145024,580,'Mangalpur B.O','757055',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145025,580,'Manida B.O','757020',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145026,580,'Manikpur B.O','757077',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145027,580,'Manikpur B.O','757048',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145028,580,'Mankadapada B.O','757040',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145029,580,'Mantri S.O','757017',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145030,580,'Marangtandi B.O','757014',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145031,580,'Marudihi B.O','757084',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145032,580,'Matiagarh B.O','757091',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145033,580,'Merda B.O','757052',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145034,580,'Mirigidari B.O','757017',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145035,580,'Mirigothana B.O','757040',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145036,580,'Mituani B.O','757038',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145037,580,'Moroda S.O','757020',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145038,580,'Moronda B.O','757046',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145039,580,'Moto B.O','757036',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145040,580,'Moudi B.O','757034',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145041,580,'Muktapur B.O','757100',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145042,580,'Murunia B.O','757051',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145043,580,'Musagadia B.O','757018',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145044,580,'N. Chhotraipur B.O','757020',1,0,'2022-03-04 19:35:04','2022-03-04 19:35:04'),(145045,580,'N.B.Pokharia B.O','757033',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145046,580,'Nabedhi B.O','757030',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145047,580,'Nachhipuria B.O','757028',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145048,580,'Nafree B.O','757032',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145049,580,'Nakhra B.O','757017',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145050,580,'Naksara B.O','757035',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145051,580,'Nalagaja S.O','757073',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145052,580,'Nankua B.O','757017',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145053,580,'Narangaon B.O','757017',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145054,580,'Narankhunta B.O','757075',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145055,580,'Naupada B.O','757084',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145056,580,'Nayarangamatia B.O','757041',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145057,580,'Nedam B.O','757079',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145058,580,'Nedhuapal B.O','757037',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145059,580,'Neuti B.O','757091',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145060,580,'Nichuapada B.O','757018',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145061,580,'Nischinta B.O','757032',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145062,580,'Nodhana B.O','757081',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145063,580,'Nuabeda B.O','757039',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145064,580,'Nuagaon B.O','757035',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145065,580,'Nuagaon B.O','757025',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145066,580,'Nuagaon B.O','757104',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145067,580,'Nuagaon B.O','757030',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145068,580,'Nuagaon-kurkutia B.O','757033',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145069,580,'Nuagaon-talakchuin B.O','757021',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145070,580,'Nudadiha S.O','757077',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145071,580,'Nuhajhalia B.O','757084',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145072,580,'Nuhamalia B.O','757086',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145073,580,'Nuhamalia B.O','757023',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145074,580,'Orachandbilla B.O','757103',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145075,580,'Padhia B.O','757047',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145076,580,'Padiabeda B.O','757038',1,0,'2022-03-04 19:35:05','2022-03-04 19:35:05'),(145077,580,'Padmapokhari B.O','757106',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145078,580,'Padmapur Deuli B.O','757086',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145079,580,'Paika Sahi B.O','757052',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145080,580,'Paikabasa B.O','757024',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145081,580,'Paktia B.O','757093',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145082,580,'Paktia B.O','757084',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145083,580,'Palabani Chhak S.O','757001',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145084,580,'Palasbani B.O','757051',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145085,580,'Palasia B.O','757082',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145086,580,'Palpala Ambadali B.O','757049',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145087,580,'Pandarsil B.O','757039',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145088,580,'Pandhada B.O','757032',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145089,580,'Pandra Rolasahi B.O','757031',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145090,580,'Pandupani B.O','757053',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145091,580,'Panisapada B.O','757055',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145092,580,'Pantho B.O','757036',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145093,580,'Paramananda B.O','757018',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145094,580,'Parasbani B.O','757040',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145095,580,'Parulia B.O','757030',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145096,580,'Pasana B.O','757045',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145097,580,'Pasuda B.O','757102',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145098,580,'Patagadia B.O','757016',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145099,580,'Patalipura B.O','757028',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145100,580,'Patarapada B.O','757038',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145101,580,'Patarapada B.O','757026',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145102,580,'Patbil B.O','757037',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145103,580,'Patharchakuli B.O','757107',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145104,580,'Patharkham B.O','757032',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145105,580,'Pathuri B.O','757030',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145106,580,'Pathurikata B.O','757085',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145107,580,'Patihinja B.O','757030',1,0,'2022-03-04 19:35:06','2022-03-04 19:35:06'),(145108,580,'Patisari B.O','757083',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145109,580,'Patpur B.O','757018',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145110,580,'Patpur B.O','757041',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145111,580,'Patsanipur B.O','757087',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145112,580,'Paunsia B.O','757025',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145113,580,'Peragari B.O','757040',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145114,580,'Poda-astia B.O','757049',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145115,580,'Podadiha B.O','757077',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145116,580,'Podagarh B.O','757034',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145117,580,'Pokhardiha B.O','757093',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145118,580,'Pokharia B.O','757022',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145119,580,'Pokharia B.O','757051',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145120,580,'Pokpoka B.O','757093',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145121,580,'Potaldiha B.O','757077',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145122,580,'Pratapgarh B.O','757050',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145123,580,'Pratappur S.O (Mayurbhanj)','757103',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145124,580,'Pruthunathpur B.O','757017',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145125,580,'Purikhunta B.O','757100',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145126,580,'Purinda B.O','757100',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145127,580,'Purnachandrapur B.O','757055',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145128,580,'Puruna Baripada S.O','757102',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145129,580,'Puruna Pani B.O','757032',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145130,580,'Purunaghati B.O','757050',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145131,580,'Purunapani B.O','757046',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145132,580,'Purunapani B.O','757050',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145133,580,'Purunia B.O','757028',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145134,580,'Radho S.O','757101',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145135,580,'Raghavpur B.O','757052',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145136,580,'Raghupur B.O','757028',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145137,580,'Raihari B.O','757048',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145138,580,'Raikad Jharan B.O','757003',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145139,580,'Raikala B.O','757035',1,0,'2022-03-04 19:35:07','2022-03-04 19:35:07'),(145140,580,'Raikama B.O','757052',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145141,580,'Raipal B.O','757106',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145142,580,'Rairangpur Bazar S.O','757043',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145143,580,'Rairangpur H.O','757043',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145144,580,'Rairangpur R.S S.O','757043',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145145,580,'Rajabasa B.O','757107',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145146,580,'Rajaloka B.O','757086',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145147,580,'Rajat Nagar B.O','757079',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145148,580,'Rakhinisahi B.O','757020',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145149,580,'Rangamatia B.O','757049',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145150,580,'Rangapani B.O','757025',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145151,580,'Rangiam B.O','757073',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145152,580,'Ranibandh B.O','757026',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145153,580,'Raruan S.O','757035',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145154,580,'Rasamtala B.O','757037',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145155,580,'Rasgovindpur S.O','757016',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145156,580,'Ratila B.O','757051',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145157,580,'Righa B.O','757035',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145158,580,'Rugudi B.O','757036',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145159,580,'Rukuni B.O','757020',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145160,580,'Sainkula B.O','757102',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145161,580,'Saitpur B.O','757052',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145162,580,'Sakua B.O','757025',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145163,580,'Salarapada B.O','757036',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145164,580,'Salbani B.O','757075',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145165,580,'Salchua B.O','757038',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145166,580,'Salchua S.O','757106',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145167,580,'Saleibeda B.O','757038',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145168,580,'Salgaon B.O','757017',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145169,580,'Salmundali B.O','757041',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145170,580,'Saluadahar B.O','757022',1,0,'2022-03-04 19:35:08','2022-03-04 19:35:08'),(145171,580,'San Deuli B.O','757037',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145172,580,'Sanbelakuti B.O','757102',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145173,580,'Sanbhundu B.O','757053',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145174,580,'Sanbisole B.O','757040',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145175,580,'Sanfutuka B.O','757107',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145176,580,'Sanjambilla B.O','757033',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145177,580,'Sankachimbila B.O','757031',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145178,580,'Sankerko S.O','757024',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145179,580,'Sankhabhanga B.O','757107',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145180,580,'Sankhabhanga B.O','757093',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145181,580,'Sankucha B.O','757081',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145182,580,'Sanmundhabani B.O','757023',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145183,580,'Sanpakhana B.O','757042',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145184,580,'Sanpurunapani B.O','757033',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145185,580,'Sansa B.O','757052',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145186,580,'Sansarasposi B.O','757030',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145187,580,'Sapanchua B.O','757074',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145188,580,'Saradiha B.O','757022',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145189,580,'Saradiha B.O','757079',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145190,580,'Saragchhida B.O','757014',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145191,580,'Saraskana S.O','757051',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145192,580,'Sarasposi B.O','757021',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145193,580,'Sarat S.O','757079',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145194,580,'Saratchandrapur B.O','757049',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145195,580,'Sarbanghati B.O','757077',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145196,580,'Sargoda B.O','757048',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145197,580,'Sargoda Jashipur B.O','757033',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145198,580,'Saria B.O','757100',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145199,580,'Sarisa B.O','757055',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145200,580,'Sarisapal B.O','757092',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145201,580,'Satkosia B.O','757038',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145202,580,'Shirsa S.O','757031',1,0,'2022-03-04 19:35:09','2022-03-04 19:35:09'),(145203,580,'Shyamakhunta S.O','757049',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145204,580,'Shyamsundar B.O','757050',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145205,580,'Shyamsundarpur B.O','757092',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145206,580,'Sialighati B.O','757025',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145207,580,'Sikidia B.O','757027',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145208,580,'Silaghati B.O','757019',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145209,580,'Silfodi B.O','757051',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145210,580,'Sindurgoura B.O','757049',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145211,580,'Singada B.O','757039',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145212,580,'Singda B.O','757022',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145213,580,'Singlamundali B.O','757028',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145214,580,'Singtia B.O','757026',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145215,580,'Sirakuli B.O','757091',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145216,580,'Sirathali B.O','757102',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145217,580,'Sirishbani B.O','757049',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145218,580,'Soroda Jashipur B.O','757054',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145219,580,'Soso B.O','757046',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145220,580,'Sridamchandrapur B.O','757087',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145221,580,'Srinathpur B.O','757085',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145222,580,'Sripad Ganja B.O','757003',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145223,580,'Sudarsanpur B.O','757042',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145224,580,'Suhagpura B.O','757026',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145225,580,'Sukruli S.O','757039',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145226,580,'Suleipat B.O','757050',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145227,580,'Suliapada S.O','757022',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145228,580,'Sunahaja B.O','757018',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145229,580,'Sunajodia B.O','757033',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145230,580,'Sundhal B.O','757042',1,0,'2022-03-04 19:35:10','2022-03-04 19:35:10'),(145231,580,'Sundhal B.O','757106',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145232,580,'Sureidihi B.O','757029',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145233,580,'Tadki B.O','757014',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145234,580,'Takatpur S.O','757003',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145235,580,'Talakadada B.O','757027',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145236,580,'Talakpokhari B.O','757047',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145237,580,'Talakunda B.O','757074',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145238,580,'Talanda B.O','757024',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145239,580,'Talgaon B.O','757039',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145240,580,'Talgaon B.O','757045',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145241,580,'Talpada B.O','757026',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145242,580,'Talpada B.O','757038',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145243,580,'Tamalbandh B.O','757046',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145244,580,'Tangana B.O','757074',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145245,580,'Tangasole B.O','757024',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145246,580,'Taradasole B.O','757085',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145247,580,'Tarakothi B.O','757100',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145248,580,'Taramara B.O','757038',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145249,580,'Tarana B.O','757054',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145250,580,'Tarana B.O','757045',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145251,580,'Tasarda B.O','757029',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145252,580,'Tato S.O','757036',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145253,580,'Teldihudi B.O','757101',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145254,580,'Tendra B.O','757045',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145255,580,'Tentuligaon B.O','757083',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145256,580,'Thakurmunda S.O','757038',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145257,580,'Tikarpada B.O','757019',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145258,580,'Tikhia B.O','757042',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145259,580,'Tilakothi B.O','757091',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145260,580,'Tilapada B.O','757052',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145261,580,'Tiring S.O','757053',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145262,580,'Tongabilla B.O','757036',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145263,580,'Totapada B.O','757052',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145264,580,'Tukpalasia B.O','757073',1,0,'2022-03-04 19:35:11','2022-03-04 19:35:11'),(145265,580,'Tulasichoura S.O','757001',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145266,580,'Udala Bazar S.O','757041',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145267,580,'Udala College S.O','757041',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145268,580,'Udala S.O','757041',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145269,580,'Ufalgadia B.O','757022',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145270,580,'Ukam B.O','757050',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145271,580,'Unchagaon B.O','757051',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145272,580,'Uparbeda B.O','757050',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145273,580,'Uthani Nuagaon B.O','757024',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145274,581,'Adhikariguda B.O','764073',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145275,581,'Agnipur B.O','764059',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145276,581,'Ambadola B.O','764063',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145277,581,'Amlabhata B.O','764049',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145278,581,'Anakabeda B.O','764077',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145279,581,'Anchalgumma S.O','764049',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145280,581,'Attigaon B.O','764075',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145281,581,'Aunli B.O','764063',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145282,581,'B.Gumuda B.O','764075',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145283,581,'B.M.Semla B.O','764075',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145284,581,'B.S.Padar B.O','764072',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145285,581,'Badabasini B.O','764073',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145286,581,'Badabharandi B.O','764073',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145287,581,'Badakumari B.O','764073',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145288,581,'Badakumuli B.O','764059',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145289,581,'Badambeda B.O','764061',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145290,581,'Badaolama B.O','764075',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145291,581,'Badatemra B.O','764076',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145292,581,'Baghsiuni B.O','764059',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145293,581,'Baigam B.O','764072',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145294,581,'Bajraguda B.O','764061',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145295,581,'Bangalaguda B.O','764063',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145296,581,'Banuaguda B.O','764076',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145297,581,'Basini B.O','764075',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145298,581,'Beheda B.O','764073',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145299,581,'Beheramunda B.O','764077',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145300,581,'Belagaon B.O','764076',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145301,581,'Belanga B.O','764075',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145302,581,'Benara B.O','764073',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145303,581,'Betal B.O','764075',1,0,'2022-03-04 19:35:12','2022-03-04 19:35:12'),(145304,581,'Bhamini B.O','764073',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145305,581,'Bhamini B.O','764061',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145306,581,'Bharanpur B.O','764049',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145307,581,'Bharsundi B.O','764074',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145308,581,'Bhatasiuni B.O','764063',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145309,581,'Bhatigam B.O','764063',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145310,581,'Bhejaguda B.O','764070',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145311,581,'Bhikhya B.O','764076',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145312,581,'Bikrampur B.O','764059',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145313,581,'Biriguda B.O','764071',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145314,581,'Bokadabeda B.O','764072',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145315,581,'Bokoda B.O','764073',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145316,581,'Borigaon B.O','764072',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145317,581,'Bubei B.O','764074',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145318,581,'Burja B.O','764073',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145319,581,'Chandahandi S.O','764077',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145320,581,'Charmula B.O','764070',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145321,581,'Chatiguda B.O','764072',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145322,581,'Checherguda B.O','764072',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145323,581,'Cherchata B.O','764071',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145324,581,'Chhatahandi B.O','764075',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145325,581,'Chikalpadar B.O','764073',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145326,581,'Chitabeda B.O','764076',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145327,581,'Chocha B.O','764076',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145328,581,'Dabugam S.O','764072',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145329,581,'Dalbeda B.O','764077',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145330,581,'Damaniguda B.O','764072',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145331,581,'Dandamunda B.O','764077',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145332,581,'Debagaon B.O','764074',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145333,581,'Dengaguda B.O','764071',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145334,581,'Dengapadar B.O','764063',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145335,581,'Deobharandi B.O','764074',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145336,581,'Dhadra B.O','764049',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145337,581,'Dhodra B.O','764073',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145338,581,'Digisalpa B.O','764078',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145339,581,'Dohona B.O','764078',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145340,581,'Dongerbheja S.O','764078',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145341,581,'Dongra B.O','764075',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145342,581,'Dongriguda B.O','764072',1,0,'2022-03-04 19:35:13','2022-03-04 19:35:13'),(145343,581,'Ekamba B.O','764076',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145344,581,'Ekori B.O','764075',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145345,581,'Gadadhanua B.O','764061',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145346,581,'Gambhariguda B.O','764077',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145347,581,'Ganjapara B.O','764074',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145348,581,'Ghodakhuntia B.O','764072',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145349,581,'Gona B.O','764074',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145350,581,'Hatabharandi B.O','764074',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145351,581,'Hirapur B.O','764073',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145352,581,'Hirli B.O','764071',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145353,581,'J.B.Guda B.O','764078',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145354,581,'Jabaguda B.O','764072',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145355,581,'Jadapara B.O','764074',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145356,581,'Jamadapada B.O','764077',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145357,581,'Jambaguda B.O','764059',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145358,581,'Jamranda B.O','764073',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145359,581,'Jatabal B.O','764071',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145360,581,'Jhadakusumi B.O','764075',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145361,581,'Jharigam S.O','764076',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145362,581,'Jhariguma B.O','764049',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145363,581,'Jodinga B.O','764074',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145364,581,'Jujhari B.O','764063',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145365,581,'Junapani B.O','764072',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145366,581,'Kamta B.O','764049',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145367,581,'Kangra B.O','764059',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145368,581,'Kaudala B.O','764074',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145369,581,'Khanda B.O','764073',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145370,581,'Khatiguda S.O','764085',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145371,581,'Khuduku B.O','764074',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145372,581,'Khuntipadar B.O','764070',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145373,581,'Kodinga S.O','764075',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145374,581,'Kolimunda B.O','764077',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145375,581,'Kondapuri B.O','764075',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145376,581,'Kontagam B.O','764049',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145377,581,'Koragam B.O','764072',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145378,581,'Kosagumuda S.O','764061',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145379,581,'Kotagaon B.O','764075',1,0,'2022-03-04 19:35:14','2022-03-04 19:35:14'),(145380,581,'Kukudabai B.O','764059',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145381,581,'Kukudisemla B.O','764061',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145382,581,'Kumuli B.O','764074',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145383,581,'Kundei B.O','764074',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145384,581,'Kurbeda B.O','764074',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145385,581,'Kurlughati B.O','764059',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145386,581,'Kusumi B.O','764055',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145387,581,'Kutubai B.O','764075',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145388,581,'Maidalpur B.O','764071',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145389,581,'Majhidhanua B.O','764061',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145390,581,'Majhiguda B.O','764071',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145391,581,'Majhiguda B.O','765017',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145392,581,'Maliguda B.O','764078',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145393,581,'Manchagaon B.O','764070',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145394,581,'Manigam B.O','764072',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145395,581,'Mantriguda B.O','764059',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145396,581,'Medana B.O','764072',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145397,581,'Melgam B.O','764077',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145398,581,'Mentri B.O','764070',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145399,581,'Mirganiguda S.O','764063',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145400,581,'Mohanda B.O','764074',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145401,581,'Mohara B.O','764077',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145402,581,'Mohendri B.O','764072',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145403,581,'Mokiya B.O','764071',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145404,581,'Motigaon B.O','764061',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145405,581,'Murtuma B.O','764073',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145406,581,'Nabarangpur Bazar S.O','764059',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145407,581,'Nabarangpur S.O','764059',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145408,581,'Naktiguda B.O','764071',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145409,581,'Naktisimla B.O','764074',1,0,'2022-03-04 19:35:15','2022-03-04 19:35:15'),(145410,581,'Nandahandi B.O','764078',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145411,581,'Nuakote B.O','764071',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145412,581,'Palia B.O','764076',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145413,581,'Palsapara B.O','764077',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145414,581,'Pandripakna B.O','764074',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145415,581,'Panduguda B.O','764061',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145416,581,'Papadahandi S.O','764071',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145417,581,'Parajadeopalli B.O','764085',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145418,581,'Parchipara B.O','764074',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145419,581,'Patiki B.O','764077',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145420,581,'Patkhalia B.O','764077',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145421,581,'Patraput B.O','764049',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145422,581,'Patri B.O','764071',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145423,581,'Pendikote B.O','764071',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145424,581,'Phupugam B.O','764076',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145425,581,'Porsola B.O','764063',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145426,581,'Pujariguda B.O','764070',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145427,581,'Pujariguda B.O','764063',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145428,581,'R.Jaganathpur B.O','764078',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145429,581,'Raighar S.O','764074',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145430,581,'Rajkote B.O','764077',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145431,581,'Rajoda B.O','764061',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145432,581,'Rangamatiguda B.O','764063',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145433,581,'Sanamasigaon B.O','764063',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145434,581,'Sanameda B.O','764061',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145435,581,'Saradhapur B.O','764077',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145436,581,'Sarguli B.O','764074',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145437,581,'Semla B.O','764071',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145438,581,'Sindhigaon B.O','764063',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145439,581,'Sindhiguda B.O','764063',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145440,581,'Singisari B.O','764072',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145441,581,'Sirisi B.O','764071',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145442,581,'Sirliguda B.O','764073',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145443,581,'Sonepur B.O','764074',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145444,581,'Sunabeda B.O','764073',1,0,'2022-03-04 19:35:16','2022-03-04 19:35:16'),(145445,581,'Taragaon B.O','764059',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145446,581,'Temera B.O','764061',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145447,581,'Tentulikhunti S.O','764070',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145448,581,'Tumberla B.O','764071',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145449,581,'Turudi B.O','764074',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145450,581,'Turudihi','764088',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145451,581,'Umerkote Bazar S.O','764073',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145452,581,'Umerkote S.O','764073',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145453,581,'Ushigaon B.O','764071',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145454,582,'Adakata B.O','752093',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145455,582,'B M S Nivas B.O','752024',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145456,582,'Badabanpur B.O','752078',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145457,582,'Badabaramul B.O','752025',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145458,582,'Badagotha B.O','752094',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145459,582,'Badakumari B.O','752065',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145460,582,'Badasahara B.O','752063',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145461,582,'Badasilinga B.O','752084',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145462,582,'Badpandusar B.O','752068',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145463,582,'Bahadajhola S.O','752082',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145464,582,'Baigania B.O','752077',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145465,582,'Balabhadrapur B.O','752026',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145466,582,'Baladianuagaon B.O','752077',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145467,582,'Balaramaprasad B.O','752085',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145468,582,'Balugaon B.O','752070',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145469,582,'Bandhamunda B.O','752025',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145470,582,'Banigochha S.O','752089',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145471,582,'Banmalipurpatna B.O','752077',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145472,582,'Banthapur B.O','752081',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145473,582,'Barabati B.O','752077',1,0,'2022-03-04 19:35:17','2022-03-04 19:35:17'),(145474,582,'Barapalli B.O','752070',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145475,582,'Barasahi B.O','752080',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145476,582,'Basudia B.O','752026',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145477,582,'Baulasahi B.O','752092',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145478,582,'Baunsabati B.O','752063',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145479,582,'Baunsagada B.O','752026',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145480,582,'Baunsagadia B.O','752080',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145481,582,'Baunsiapada B.O','752068',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145482,582,'Belapadapatna B.O','752085',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145483,582,'Benagadia B.O','752077',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145484,582,'Beruanbadi B.O','752082',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145485,582,'Bhagabanpur B.O','752077',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145486,582,'Bhaliadihi B.O','752092',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145487,582,'Bhapur S.O (Nayagarh)','752063',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145488,582,'Bhatasahi B.O','752070',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145489,582,'Bhogabadi B.O','752091',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145490,582,'Bijipur B.O','752063',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145491,582,'Binayakpur B.O','752080',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145492,582,'Biruda B.O','752068',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145493,582,'Bodas B.O','752077',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145494,582,'Brajarajpur B.O','752026',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145495,582,'Chadeyapalli B.O','752089',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145496,582,'Chahali B.O','752094',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145497,582,'Chakradharprasad B.O','752063',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145498,582,'Champagarh B.O','752024',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145499,582,'Champatipur B.O','752068',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145500,582,'Chandapur S.O (Nayagarh)','752024',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145501,582,'Chhamundia B.O','752085',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145502,582,'Damasahi B.O','752092',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145503,582,'Dandor B.O','752090',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145504,582,'Darpanarayanpur B.O','752079',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145505,582,'Daspalla S.O','752084',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145506,582,'Dhanchangada B.O','752078',1,0,'2022-03-04 19:35:18','2022-03-04 19:35:18'),(145507,582,'Dihagaon B.O','752093',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145508,582,'Dimiripali B.O','752083',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145509,582,'Dimisar B.O','752092',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145510,582,'Duda B.O','752089',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145511,582,'Durdura B.O','752094',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145512,582,'Ekiri B.O','752079',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145513,582,'Fategarh B.O','752063',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145514,582,'Gadadharprasad B.O','752068',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145515,582,'Gambharidihi B.O','752079',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145516,582,'Gambharidihi B.O','752070',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145517,582,'Gania S.O','752085',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145518,582,'Garhbanikilo B.O','752026',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145519,582,'Gaudaput B.O','752081',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145520,582,'Ghugudipada B.O','752084',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145521,582,'Giridipalli B.O','752090',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145522,582,'Gobardhan Prasad B.O','752063',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145523,582,'Gobindapurpanta B.O','752093',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145524,582,'Godipada S.O','752092',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145525,582,'Gohiripada B.O','752077',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145526,582,'Golagola B.O','752070',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145527,582,'Golapokhari B.O','752063',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145528,582,'Gopalpur S.O (Nayagarh)','752025',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145529,582,'Gotisahi B.O','752070',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145530,582,'Gourangapur B.O','752026',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145531,582,'Gumi B.O','752082',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145532,582,'Gunthuni B.O','752068',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145533,582,'Harakrushnapur B.O','752068',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145534,582,'Hariharpur B.O','752080',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145535,582,'Itamati S.O','752068',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145536,582,'Jadunathpur B.O','752077',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145537,582,'Jagannathprasad B.O','752093',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145538,582,'Jagannathprasad B.O','752077',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145539,582,'Jakeda B.O','752083',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145540,582,'Jamusahi B.O','752084',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145541,582,'Jamusahi B.O','752079',1,0,'2022-03-04 19:35:19','2022-03-04 19:35:19'),(145542,582,'Jasodapur B.O','752025',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145543,582,'Jharapada B.O','752025',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145544,582,'K .Sikharpur B.O','752077',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145545,582,'Kaibalyapur B.O','752081',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145546,582,'Kainfulia B.O','752063',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145547,582,'Kajaliapalli B.O','752080',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145548,582,'Kalapangi B.O','752077',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145549,582,'Kalikaprasad B.O','752079',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145550,582,'Kalyanpur B.O','752070',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145551,582,'Kandhanayagarh B.O','752024',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145552,582,'Kankanamendhi B.O','752089',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145553,582,'Kansada B.O','752065',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145554,582,'Kantilo S.O','752078',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145555,582,'Kaptapalli B.O','752082',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145556,582,'Karabar B.O','752063',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145557,582,'Karadapada B.O','752085',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145558,582,'Kendudhipi B.O','752079',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145559,582,'Kerandatangi B.O','752024',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145560,582,'Kesharpur B.O','752079',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145561,582,'Khairapalli B.O','752026',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145562,582,'Khalamada B.O','752083',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145563,582,'Khalisahi B.O','752077',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145564,582,'Khamarasahi B.O','752091',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145565,582,'Khandapadagarh S.O','752077',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145566,582,'Khatia B.O','752079',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145567,582,'Khuntabandha B.O','752079',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145568,582,'Kiajhar B.O','752077',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145569,582,'Kishoreprasad B.O','752085',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145570,582,'Komand B.O','752090',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145571,582,'Korada B.O','752083',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145572,582,'Korapitha B.O','752081',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145573,582,'Koska B.O','752093',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145574,582,'Kridaspur B.O','752070',1,0,'2022-03-04 19:35:20','2022-03-04 19:35:20'),(145575,582,'Kujamendhi B.O','752089',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145576,582,'Kulasar B.O','752065',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145577,582,'Kulurukumpa B.O','752089',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145578,582,'Kumbharapada B.O','752093',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145579,582,'Kural S.O','752090',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145580,582,'Kurumabankatara B.O','752081',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145581,582,'Lathipara B.O','752079',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145582,582,'Lenkudipada B.O','752070',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145583,582,'Lodhachua B.O','752026',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145584,582,'Machhipada B.O','752070',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145585,582,'Madanpur B.O','752090',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145586,582,'Madhapur B.O','752078',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145587,582,'Madhyakhand S.O','752093',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145588,582,'Mahatapalla B.O','752025',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145589,582,'Mahipur S.O','752094',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145590,582,'Malisahi B.O','752070',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145591,582,'Malisar B.O','752094',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145592,582,'Mandhatapur S.O','752079',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145593,582,'Mayurjhalia B.O','752025',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145594,582,'Nabaghanapur B.O','752070',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145595,582,'Nakithana B.O','752025',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145596,582,'Nandighore B.O','752081',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145597,582,'Narasinghpur B.O','752026',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145598,582,'Narendrapur B.O','752065',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145599,582,'Natimi B.O','752026',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145600,582,'Nayagarh Bazar S.O','752070',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145601,582,'Nayagarh College S.O','752069',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145602,582,'Nayagarh H.O','752069',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145603,582,'Neliguda B.O','752084',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145604,582,'Nilakantheswarpur B.O','752063',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145605,582,'Nimani B.O','752063',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145606,582,'Notar B.O','752079',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145607,582,'Nuagaon B.O','752089',1,0,'2022-03-04 19:35:21','2022-03-04 19:35:21'),(145608,582,'Nuagaon S.O (Nayagarh)','752083',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145609,582,'Nuapada B.O','752093',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145610,582,'Odagaon S.O','752081',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145611,582,'Padmabati B.O','752063',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145612,582,'Padmadeipur B.O','752070',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145613,582,'Pancharida B.O','752080',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145614,582,'Patanda B.O','752085',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145615,582,'Pimpal B.O','752026',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145616,582,'Poda Sahi B.O','752089',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145617,582,'Poibadi B.O','752091',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145618,582,'Pokharigochha B.O','752091',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145619,582,'Purusottamprasad B.O','752077',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145620,582,'Rabera B.O','752081',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145621,582,'Raitadholamara B.O','752085',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145622,582,'Rajingi B.O','752085',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145623,582,'Rajranpur S.O','752026',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145624,582,'Rajsunakhala S.O','752065',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145625,582,'Rakama B.O','752063',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145626,582,'Ranganipatna B.O','752081',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145627,582,'Rasanga B.O','752085',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145628,582,'Rohibanka B.O','752090',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145629,582,'Sakeri B.O','752081',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145630,582,'Salajharia B.O','752077',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145631,582,'Salapada B.O','752063',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145632,582,'Sampada B.O','752083',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145633,582,'Saradhapur B.O','752068',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145634,582,'Sarangadharpur B.O','752026',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145635,582,'Sarankul S.O','752080',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145636,582,'Satpatna S.O','752091',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145637,582,'Sidhamula B.O','752078',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145638,582,'Sikharpur B.O','752080',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145639,582,'Sikrida B.O','752083',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145640,582,'Similisahi B.O','752094',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145641,582,'Similisahi B.O','752091',1,0,'2022-03-04 19:35:22','2022-03-04 19:35:22'),(145642,582,'Sinduria B.O','752025',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145643,582,'Sinduria S.O','752069',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145644,582,'Singarpalli B.O','752082',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145645,582,'Singhapada B.O','752077',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145646,582,'Srirampur B.O','752084',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145647,582,'Subalaya B.O','752091',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145648,582,'Sunamuhin B.O','752090',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145649,582,'Surukabadi B.O','752065',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145650,582,'Takera B.O','752084',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145651,582,'Tarabalo B.O','752063',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145652,582,'Taria B.O','752026',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145653,582,'Tendabadi B.O','752091',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145654,582,'Tikiripada B.O','752063',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145655,582,'Tumandi B.O','752084',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145656,582,'Udayapur B.O','752083',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145657,583,'Agren B.O','766106',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145658,583,'Amguda B.O','766111',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145659,583,'Amnara B.O','766105',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145660,583,'Amsena B.O','766104',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145661,583,'Babebir B.O','766118',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145662,583,'Badi B.O','766107',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145663,583,'Badmaheswar B.O','766107',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145664,583,'Bargaon B.O','766118',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145665,583,'Bargaon B.O','766107',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145666,583,'Beltukri B.O','766104',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145667,583,'Bhainsadani B.O','766111',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145668,583,'Bhaleswer B.O','766104',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145669,583,'Bhanpur B.O','766104',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145670,583,'Bharuamunda B.O','766108',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145671,583,'Bhella B.O','766106',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145672,583,'Bhuliasikun B.O','766107',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145673,583,'Birighat B.O','766118',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145674,583,'Biromal B.O','766104',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145675,583,'Bisora B.O','766104',1,0,'2022-03-04 19:35:23','2022-03-04 19:35:23'),(145676,583,'Boden S.O','766111',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145677,583,'Boirgaon B.O','766111',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145678,583,'Budhikomna B.O','766106',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145679,583,'Chalana B.O','766108',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145680,583,'Chatiaguda B.O','766108',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145681,583,'Chindaguda B.O','766107',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145682,583,'Damjhar B.O','766111',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145683,583,'Darlimunda B.O','766105',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145684,583,'Darlipara B.O','766105',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145685,583,'Dharambandha B.O','766105',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145686,583,'Duajhar S.O','766118',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145687,583,'Dumerpani B.O','766104',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145688,583,'Gandamer B.O','766106',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145689,583,'Gochhaguda B.O','766108',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145690,583,'Godal B.O','766108',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145691,583,'Godfurla B.O','766105',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145692,583,'Goimundi B.O','766107',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145693,583,'Gorla B.O','766108',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145694,583,'Gotma B.O','766104',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145695,583,'Hatibandha B.O','766108',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145696,583,'Jampani B.O','766105',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145697,583,'Jatgarh B.O','766105',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145698,583,'Jayabahal B.O','766118',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145699,583,'Jenjera B.O','766104',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145700,583,'Jhagrahi B.O','766106',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145701,583,'Jharbandh B.O','766108',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145702,583,'Karanbahali B.O','766108',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145703,583,'Karangamal B.O','766118',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145704,583,'Karlakot B.O','766111',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145705,583,'Kendetara B.O','766106',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145706,583,'Kendubahara B.O','766105',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145707,583,'Kendumunda B.O','766108',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145708,583,'Kendupati B.O','766118',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145709,583,'Khaira B.O','766111',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145710,583,'Khariar  Pattnaik Para S.O','766107',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145711,583,'Khariar Road S.O','766104',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145712,583,'Khariar S.O','766107',1,0,'2022-03-04 19:35:24','2022-03-04 19:35:24'),(145713,583,'Khasbahal B.O','766107',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145714,583,'Kirejhola B.O','766111',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145715,583,'Kirkita B.O','766118',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145716,583,'Kodomeri B.O','766104',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145717,583,'Komna S.O','766106',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145718,583,'Konabira B.O','766106',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145719,583,'Kuliabandh B.O','766104',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145720,583,'Kureswar B.O','766106',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145721,583,'Kurumpuri B.O','766105',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145722,583,'Kusumjore B.O','766108',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145723,583,'Kutenchuan B.O','766105',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145724,583,'Lakhana B.O','766105',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145725,583,'Lanji B.O','766118',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145726,583,'Larka B.O','766118',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145727,583,'Litisargi B.O','766111',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145728,583,'Mahulibhata B.O','766105',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145729,583,'Makhapadar B.O','766118',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145730,583,'Mangarapalli B.O','766104',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145731,583,'Maraguda B.O','766105',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145732,583,'Michhapali B.O','766106',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145733,583,'Motanuapada B.O','766105',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145734,583,'Nagpada B.O','766111',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145735,583,'Nangalbod B.O','766108',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145736,583,'Nawapara Tanwat S.O','766105',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145737,583,'Nilji B.O','766108',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145738,583,'Nuagaon B.O','766106',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145739,583,'Nuapada B.O','766108',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145740,583,'Palsada B.O','766107',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145741,583,'Panchampur B.O','766105',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145742,583,'Paraskhol B.O','766105',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145743,583,'Parkod B.O','766104',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145744,583,'Pendraban B.O','766106',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145745,583,'Pharsara B.O','766111',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145746,583,'Rajna B.O','766106',1,0,'2022-03-04 19:35:25','2022-03-04 19:35:25'),(145747,583,'Ranimunda B.O','766118',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145748,583,'Ranimunda B.O','766108',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145749,583,'Sahajat B.O','766105',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145750,583,'Saipala B.O','766105',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145751,583,'Saradhapur B.O','766118',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145752,583,'Sarbang B.O','766105',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145753,583,'Sargadi B.O','766107',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145754,583,'Sialati B.O','766105',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145755,583,'Silva B.O','766105',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145756,583,'Singjhar B.O','766108',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145757,583,'Sinhapalli S.O','766108',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145758,583,'Sunabeda B.O','766106',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145759,583,'Sunapur B.O','766111',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145760,583,'Tanwat B.O','766105',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145761,583,'Tarbod B.O','766105',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145762,583,'Tikrapara B.O','766106',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145763,583,'Timanpur B.O','766108',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145764,583,'Tukla B.O','766107',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145765,584,'Alasahi B.O','752109',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145766,584,'Alichar B.O','752110',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145767,584,'Alipingal B.O','752106',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145768,584,'Amareswar B.O','752120',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145769,584,'Arisandha B.O','752106',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145770,584,'Astaranga S.O','752109',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145771,584,'Badalasasan B.O','752106',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145772,584,'Badaninigaon B.O','752121',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145773,584,'Baharana B.O','752120',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145774,584,'Bakugram B.O','752105',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145775,584,'Balanga S.O','752105',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145776,584,'Balidokan B.O','752111',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145777,584,'Bamanal S.O','752121',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145778,584,'Bangurigaon S.O','752118',1,0,'2022-03-04 19:35:26','2022-03-04 19:35:26'),(145779,584,'Bantalasingh B.O','752104',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145780,584,'Bantugram B.O','752106',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145781,584,'Baulanga B.O','752107',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145782,584,'Bhanapur B.O','752114',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145783,584,'Bhandisahi B.O','752108',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145784,584,'Bharipur B.O','752110',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145785,584,'Bhodar B.O','752113',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145786,584,'Bhogasalada B.O','752106',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145787,584,'Bhubanipur S.O','752106',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145788,584,'Binayakpur B.O','752104',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145789,584,'Bindha B.O','752104',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145790,584,'Birtung S.O','752116',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145791,584,'Bishnupur B.O','752106',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145792,584,'Biswalpada B.O','752114',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145793,584,'Brahmakundi S.O','752113',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145794,584,'Chanrapada B.O','752106',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145795,584,'Chhannijanga B.O','752113',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145796,584,'Chitreswari B.O','752111',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145797,584,'Dakhinradas B.O','752114',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145798,584,'Danagohiri B.O','752104',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145799,584,'Dandamukundapur Gds B.O','752104',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145800,584,'Dandipur B.O','752105',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145801,584,'Derunia B.O','752119',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145802,584,'Desthali B.O','752107',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145803,584,'Dhaleswar B.O','752114',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145804,584,'Dhanitri B.O','752111',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145805,584,'Dighalo B.O','752106',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145806,584,'Dipideuli B.O','752105',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145807,584,'Dolabedi Chhaka S.O','752106',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145808,584,'Dovar B.O','752121',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145809,584,'Erbang B.O','752116',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145810,584,'Gambharipada B.O','752108',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145811,584,'Ganeswarpur B.O','752110',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145812,584,'Garharmala B.O','752116',1,0,'2022-03-04 19:35:27','2022-03-04 19:35:27'),(145813,584,'Garhchandrapur B.O','752105',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145814,584,'Garhrupas B.O','752110',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145815,584,'Gop S.O','752110',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145816,584,'Govindpur B.O','752104',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145817,584,'Haripur B.O','752104',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145818,584,'Jaleswarpada B.O','752118',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145819,584,'Jharling B.O','752109',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145820,584,'Jopan B.O','752105',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145821,584,'Junei B.O','752111',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145822,584,'Kahal B.O','752108',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145823,584,'Kairi B.O','752104',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145824,584,'Kakatpur S.O','752108',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145825,584,'Kamakantia B.O','752105',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145826,584,'Kanti B.O','752104',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145827,584,'Karamanga B.O','752111',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145828,584,'Khadiso B.O','752110',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145829,584,'Khalkatapatna B.O','752111',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145830,584,'Khandasahi B.O','752119',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145831,584,'Konark S.O','752111',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145832,584,'Kotanga B.O','752118',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145833,584,'Krushnanagarpatna B.O','752108',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145834,584,'Kumarpada B.O','752105',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145835,584,'Kundheihat B.O','752118',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145836,584,'Kurujanga B.O','752111',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145837,584,'Kusumbar B.O','752109',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145838,584,'Kusupur B.O','752110',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145839,584,'Lataharan S.O','752119',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145840,584,'Mahadevbasta B.O','752107',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145841,584,'Mahalpada B.O','752116',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145842,584,'Makundadaspur B.O','752104',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145843,584,'Malagaon B.O','752110',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145844,584,'Mangalpur B.O','752104',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145845,584,'Manijanga B.O','752114',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145846,584,'Matiapada B.O','752111',1,0,'2022-03-04 19:35:28','2022-03-04 19:35:28'),(145847,584,'Nagapur B.O','752110',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145848,584,'Nagar B.O','752109',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145849,584,'Nahantara B.O','752106',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145850,584,'Namaro B.O','752109',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145851,584,'Narua B.O','752110',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145852,584,'Nayahat S.O','752107',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145853,584,'Nimapara S.O','752106',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145854,584,'Nuagarh B.O','752109',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145855,584,'Nuagopalpur B.O','752105',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145856,584,'Nuasantha B.O','752105',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145857,584,'Nuasasan B.O','752104',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145858,584,'Ohala B.O','752121',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145859,584,'Olikana B.O','752114',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145860,584,'Othaka B.O','752108',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145861,584,'Palasahi B.O','752114',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145862,584,'Patalda B.O','752109',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145863,584,'Patapur B.O','752108',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145864,584,'Patasundarpur B.O','752108',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145865,584,'Pipili S.O','752104',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145866,584,'Rahangorada B.O','752121',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145867,584,'Rainsol B.O','752104',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145868,584,'Rajas B.O','752114',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145869,584,'Rasulpur B.O','752119',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145870,584,'Ratilo B.O','752114',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145871,584,'Rench S.O','752114',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145872,584,'Renghalo B.O','752114',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145873,584,'Risol B.O','752119',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145874,584,'Rupadeipur B.O','752105',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145875,584,'Sagada B.O','752114',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145876,584,'Sahadapada B.O','752105',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145877,584,'Salanga B.O','752106',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145878,584,'Sangaleisasan B.O','752104',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145879,584,'Sarada B.O','752111',1,0,'2022-03-04 19:35:29','2022-03-04 19:35:29'),(145880,584,'Saraswatipur B.O','752105',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145881,584,'Siaro B.O','752121',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145882,584,'Siso B.O','752110',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145883,584,'Sisua B.O','752109',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145884,584,'Siula B.O','752104',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145885,584,'Sompur B.O','752104',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145886,584,'Sorava B.O','752107',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145887,584,'Suhagpur B.O','752107',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145888,584,'Sunugoradi B.O','752114',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145889,584,'Tampalo B.O','752110',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145890,584,'Taradapada B.O','752106',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145891,584,'Tentuligaon B.O','752113',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145892,584,'Terundia B.O','752106',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145893,584,'Tulasipur B.O','752113',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145894,584,'Uchhupur B.O','752105',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145895,584,'Udaypur B.O','752109',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145896,584,'Villigram B.O','752106',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145897,584,'Abhayamukhi Ramachandrapur B.O','752016',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145898,584,'Alagum B.O','752014',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145899,584,'Alasana B.O','752012',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145900,584,'Alibada B.O','752017',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145901,584,'Ambapada B.O','752011',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145902,584,'Arakhakuda B.O','752011',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145903,584,'Arisala B.O','752016',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145904,584,'B S Nagar S.O','752002',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145905,584,'Badagaon B.O','752002',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145906,584,'Badagualipada B.O','752016',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145907,584,'Badas B.O','752017',1,0,'2022-03-04 19:35:30','2022-03-04 19:35:30'),(145908,584,'Badjhada B.O','752030',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145909,584,'Bajrakote B.O','752030',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145910,584,'Balapur B.O','752046',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145911,584,'Balaramapurgarh B.O','752045',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145912,584,'Baliguali B.O','752002',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145913,584,'Balipada B.O','752014',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145914,584,'Baliput B.O','752045',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145915,584,'Balisahi S.O','752001',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145916,584,'Baniasahi B.O','752002',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145917,584,'Bantaligram B.O','752002',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145918,584,'Baralabalunkeswar B.O','752046',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145919,584,'Basantapur B.O','752017',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145920,584,'Baselisahi S.O','752001',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145921,584,'Basudevpur S.O (Puri)','752013',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145922,584,'Bentapur B.O','752011',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145923,584,'Berboi S.O','752016',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145924,584,'Berhampur B.O','752011',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145925,584,'Bhagabanpur B.O','752011',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145926,584,'Bhandarikuda B.O','752011',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145927,584,'Bhimpur B.O','752016',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145928,584,'Bhubanapur B.O','752011',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145929,584,'Bijayaramachandrapur B.O','752012',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145930,584,'Bilaspur B.O','752016',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145931,584,'Birabalabhadrapur B.O','752012',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145932,584,'Biragobindapur B.O','752014',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145933,584,'Biraharekrushnapur B.O','752002',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145934,584,'Biranarasinghpur B.O','752012',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145935,584,'Birapratappur B.O','752012',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145936,584,'Birapurusottampur B.O','752046',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145937,584,'Biraramachandrapur B.O','752014',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145938,584,'Biswanathpur B.O','752014',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145939,584,'Brahmagiri S.O','752011',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145940,584,'Brahmanapada B.O','752014',1,0,'2022-03-04 19:35:31','2022-03-04 19:35:31'),(145941,584,'Brahmania B.O','752011',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145942,584,'Chandanpur S.O','752012',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145943,584,'Chapamanika B.O','752011',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145944,584,'Charishree B.O','752045',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145945,584,'Chhaitana B.O','752002',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145946,584,'Chhatabar B.O','752011',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145947,584,'Chilikanuapada B.O','752011',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145948,584,'D. A. G. S.O','752002',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145949,584,'Dahan B.O','752014',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145950,584,'Delang S.O','752015',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145951,584,'Deypursasan B.O','752046',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145952,584,'Dimirisena B.O','752011',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145953,584,'Dubaipur B.O','752045',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145954,584,'Gabakunda S.O','752045',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145955,584,'Gadisagoda B.O','752017',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145956,584,'Ganganarayanpur B.O','752012',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145957,584,'Garhbadaput B.O','752017',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145958,584,'Garhbalabhadrapur B.O','752017',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145959,584,'Garhbhingura B.O','752002',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145960,584,'Garhkokala B.O','752011',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145961,584,'Garhmatiapada B.O','752017',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145962,584,'Garhmrugasira B.O','752012',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145963,584,'Garhrodanga B.O','752011',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145964,584,'Garhsahi B.O','752017',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145965,584,'Ghanapana B.O','752013',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145966,584,'Ghoradia B.O','752015',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145967,584,'Gopinathpur B.O','752011',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145968,584,'Gopinathpur B.O','752002',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145969,584,'Gorual B.O','752002',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145970,584,'Gualigorada B.O','752045',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145971,584,'Hakapada B.O','752016',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145972,584,'Hantuka B.O','752013',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145973,584,'Indipurdeuli B.O','752016',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145974,584,'Jagannath Ballav S.O','752001',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145975,584,'Jagannathpur B.O','752017',1,0,'2022-03-04 19:35:32','2022-03-04 19:35:32'),(145976,584,'Jenapur B.O','752016',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(145977,584,'Jorakani B.O','752015',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(145978,584,'Kalapadar B.O','752017',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(145979,584,'Kalikadevisahi S.O','752001',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(145980,584,'Kalyanpur B.O','752015',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(145981,584,'Kanas S.O','752017',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(145982,584,'Kandagoda B.O','752011',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(145983,584,'Kanheibidyadharpur B.O','752012',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(145984,584,'Kapileswarpur B.O','752013',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(145985,584,'Kerandipur B.O','752013',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(145986,584,'Khadipada B.O','752002',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(145987,584,'Khajuria B.O','752011',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(145988,584,'Khandahata B.O','752017',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(145989,584,'Khellore B.O','752016',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(145990,584,'Kothasahi B.O','752046',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(145991,584,'Kundhebentasahi S.O','752001',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(145992,584,'Kusubenti B.O','752011',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(145993,584,'Labanikhiachhak S.O','752001',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(145994,584,'Lalitapahandi B.O','752045',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(145995,584,'Mahapur B.O','752002',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(145996,584,'Mahodadhi B.O','752002',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(145997,584,'Mahura B.O','752045',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(145998,584,'Malud B.O','752030',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(145999,584,'Manapada B.O','752011',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(146000,584,'Manikarnika S.O','752001',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(146001,584,'Markandeswar Sahi B.O','752002',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(146002,584,'Motari B.O','752015',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(146003,584,'Mula Alasa B.O','752014',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(146004,584,'Muninda B.O','752015',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(146005,584,'Nalibasanta B.O','752016',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(146006,584,'Nandigoda B.O','752017',1,0,'2022-03-04 19:35:33','2022-03-04 19:35:33'),(146007,584,'Nua Someswarpur B.O','752014',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146008,584,'Nuagaonbadabhuin B.O','752011',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146009,584,'Ola B.O','752014',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146010,584,'Palank B.O','752011',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146011,584,'Palli B.O','752011',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146012,584,'Panaspada B.O','752011',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146013,584,'Parakena B.O','752045',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146014,584,'Parikud Gdsso B.O','752011',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146015,584,'Pattanaikia B.O','752046',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146016,584,'Police Line S.O (Puri)','752002',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146017,584,'Praharajpur B.O','752016',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146018,584,'Pratappurusottampur B.O','752012',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146019,584,'Puri H.O','752001',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146020,584,'Puri Seabeach S.O','752001',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146021,584,'Puri Station Road S.O','752002',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146022,584,'Rahadamalla B.O','752013',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146023,584,'Raichakradharpur B.O','752014',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146024,584,'Ramlenka B.O','752030',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146025,584,'Rebena Nuagaon B.O','752011',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146026,584,'Rua B.O','752012',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146027,584,'S C S College S.O','752001',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146028,584,'Sadangoi B.O','752015',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146029,584,'Sakhigopal S.O','752014',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146030,584,'Sandarahat B.O','752014',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146031,584,'Santidham B.O','752017',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146032,584,'Sarangajodi B.O','752014',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146033,584,'Sasana Damodarpur B.O','752002',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146034,584,'Satapada B.O','752011',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146035,584,'Satasankha S.O','752046',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146036,584,'Sial B.O','752030',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146037,584,'Singhadwar S.O','752001',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146038,584,'Singhbrahmapur B.O','752015',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146039,584,'Sirei B.O','752017',1,0,'2022-03-04 19:35:34','2022-03-04 19:35:34'),(146040,584,'Sirpurusottampur B.O','752016',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146041,584,'Siruli B.O','752012',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146042,584,'Sriramachandrapur B.O','752014',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146043,584,'Srivihar S.O','752003',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146044,584,'Sukal B.O','752014',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146045,584,'Swargadwar S.O','752001',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146046,584,'Tadasaramahansapur B.O','752012',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146047,584,'Talajanga B.O','752002',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146048,584,'Teisipur B.O','752046',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146049,584,'Tipuri B.O','752017',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146050,584,'Titip B.O','752030',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146051,584,'Trilochanpur B.O','752015',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146052,585,'Adajori B.O','765015',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146053,585,'Agula B.O','765020',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146054,585,'Akhusingi B.O','765025',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146055,585,'Ambabadi B.O','765025',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146056,585,'Ambadola S.O','765021',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146057,585,'Antamoda B.O','765017',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146058,585,'Asada B.O','765026',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146059,585,'B.Alubadi B.O','765017',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146060,585,'B.Bandili B.O','765020',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146061,585,'B.Gotiguda B.O','765019',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146062,585,'B.Haluva B.O','765002',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146063,585,'B.Khillapadar B.O','765017',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146064,585,'Badaguda B.O','765017',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146065,585,'Badapankal B.O','765026',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146066,585,'Bagusala B.O','765033',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146067,585,'Bankamba B.O','765016',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146068,585,'Bankara B.O','765015',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146069,585,'Bankili B.O','765029',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146070,585,'Batalpur B.O','765019',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146071,585,'Batiapada B.O','765019',1,0,'2022-03-04 19:35:35','2022-03-04 19:35:35'),(146072,585,'Bellamguda B.O','765026',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146073,585,'Bhairabguda B.O','765020',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146074,585,'Bhamini B.O','765024',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146075,585,'Bhimpur B.O','765033',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146076,585,'Bhoimada B.O','765029',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146077,585,'Bichikote B.O','765024',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146078,585,'Bijapur B.O','765026',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146079,585,'Bikrampur S.O','764062',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146080,585,'Bilamala B.O','765015',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146081,585,'Biripadar B.O','765025',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146082,585,'Bissamcuttack S.O','765019',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146083,585,'Budubali B.O','765020',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146084,585,'Buduni B.O','765018',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146085,585,'Buthingi B.O','765023',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146086,585,'Chalakamba B.O','765033',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146087,585,'Champi B.O','765013',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146088,585,'Chandgiri B.O','765015',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146089,585,'Chandragiri B.O','765015',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146090,585,'Chandrapur B.O','765020',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146091,585,'Chatikona B.O','765019',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146092,585,'Chinasari B.O','765022',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146093,585,'D.Panga B.O','765016',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146094,585,'Dambasora S.O','765033',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146095,585,'Dangaladi B.O','765017',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146096,585,'Dangasorada B.O','765020',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146097,585,'Derigam B.O','765024',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146098,585,'Dhepaguda B.O','765026',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146099,585,'Dohikhal B.O','765020',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146100,585,'Dondili B.O','765017',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146101,585,'Dongasil B.O','765015',1,0,'2022-03-04 19:35:36','2022-03-04 19:35:36'),(146102,585,'Dukum B.O','765019',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146103,585,'Dumuriguda B.O','765018',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146104,585,'Dumurineli B.O','765019',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146105,585,'Durgi B.O','765019',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146106,585,'G.Gulumunda B.O','765029',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146107,585,'G.Laxmipur B.O','765024',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146108,585,'G.Padar B.O','765034',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146109,585,'G.Seshkhal B.O','765017',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146110,585,'Gajigaon B.O','765002',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146111,585,'Ghanatri B.O','765033',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146112,585,'Godiabandha B.O','765025',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146113,585,'Godiakhal B.O','765022',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146114,585,'Godibali B.O','765015',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146115,585,'Gogupada B.O','765029',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146116,585,'Gorakhpur B.O','765015',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146117,585,'Gudari S.O','765026',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146118,585,'Guluguda B.O','765025',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146119,585,'Gulunthi B.O','765029',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146120,585,'Gunupur S.O','765022',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146121,585,'H.Donga B.O','765019',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146122,585,'Halva B.O','765002',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146123,585,'Hanumanthpur B.O','765020',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146124,585,'Hatamuniguda B.O','765020',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146125,585,'Hatikhamba B.O','765029',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146126,585,'Ichhapur B.O','765021',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146127,585,'Indupur B.O','765025',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146128,585,'J.D.Pentho B.O','765002',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146129,585,'J.K.Pur Bazar S.O','765017',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146130,585,'J.K.Pur S.O','765017',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146131,585,'Jaganathpur B.O','765016',1,0,'2022-03-04 19:35:37','2022-03-04 19:35:37'),(146132,585,'Jaganathpur S.O','765034',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146133,585,'Jagdalpur B.O','765020',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146134,585,'Jaltar B.O','765022',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146135,585,'Jarapa B.O','765020',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146136,585,'Jathili B.O','765025',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146137,585,'Jhigidi B.O','765019',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146138,585,'Jilunda B.O','765017',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146139,585,'K.Dhamuni B.O','765019',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146140,585,'K.Golmi B.O','765019',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146141,585,'K.Gumma B.O','765002',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146142,585,'K.Kota B.O','765029',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146143,585,'K.Singhpur S.O','765016',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146144,585,'Kachapai B.O','765019',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146145,585,'Kampara B.O','765015',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146146,585,'Kankubadi B.O','765019',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146147,585,'Karini B.O','765025',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146148,585,'Karlaghati B.O','765026',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146149,585,'Karubai B.O','765017',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146150,585,'Kashipur (Rayagada) S.O','765015',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146151,585,'Katiki B.O','765029',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146152,585,'Kerada B.O','765002',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146153,585,'Khabariguda B.O','765025',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146154,585,'Khaira B.O','765033',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146155,585,'Khariguda B.O','765026',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146156,585,'Kharlingi B.O','765022',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146157,585,'Khilapadar B.O','765025',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146158,585,'Khillingrai B.O','765025',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146159,585,'Kinalodi B.O','765026',1,0,'2022-03-04 19:35:38','2022-03-04 19:35:38'),(146160,585,'Kinarimada B.O','765029',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146161,585,'Kodama B.O','765026',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146162,585,'Kodipari B.O','765015',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146163,585,'Kolnara B.O','765017',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146164,585,'Komtalpeta B.O','765017',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146165,585,'Konabai B.O','765019',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146166,585,'Kondajam B.O','765029',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146167,585,'Korapa B.O','765016',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146168,585,'Kothapeta B.O','765017',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146169,585,'Kuchipadar B.O','765015',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146170,585,'Kujendri S.O','765023',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146171,585,'Kulusingi B.O','765022',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146172,585,'Kumbhikota B.O','765002',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146173,585,'Kumudabali B.O','765020',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146174,585,'Kurli B.O','765019',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146175,585,'Kutraguda B.O','765020',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146176,585,'Kutuli B.O','765002',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146177,585,'Laba B.O','765033',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146178,585,'Laxmipur B.O','765020',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146179,585,'Limapadar B.O','765024',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146180,585,'M.Khillingrai B.O','765026',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146181,585,'M.Patraguda B.O','765020',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146182,585,'Madhuban B.O','765026',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146183,585,'Maikanch B.O','765015',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146184,585,'Majhiguda B.O','764059',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146185,585,'Mandibisi B.O','765015',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146186,585,'Mansugaon B.O','765015',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146187,585,'Marathiguda S.O','765022',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146188,585,'Marma B.O','765034',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146189,585,'Mirabali B.O','765017',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146190,585,'Mundakota B.O','765019',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146191,585,'Muniguda S.O','765020',1,0,'2022-03-04 19:35:39','2022-03-04 19:35:39'),(146192,585,'Murtuli B.O','765019',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146193,585,'Naira B.O','765024',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146194,585,'Naktiguda B.O','765015',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146195,585,'Narayanpur B.O','765016',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146196,585,'Neelamguda B.O','765023',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146197,585,'Nuaguda B.O','765025',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146198,585,'Omadingi B.O','765023',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146199,585,'P.Dokuluguda B.O','765019',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146200,585,'Padmapur S.O','765025',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146201,585,'Paikapada B.O','765018',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146202,585,'Panasaguda B.O','765023',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146203,585,'Panchali B.O','765015',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146204,585,'Panichatra B.O','765029',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146205,585,'Patraguda B.O','765019',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146206,585,'Penakham B.O','765023',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146207,585,'Pendili B.O','765026',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146208,585,'Penta B.O','765019',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146209,585,'Penta B.O','765017',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146210,585,'Perupanga B.O','765025',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146211,585,'Pipalguda B.O','765017',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146212,585,'Piskapanga B.O','765019',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146213,585,'Pitamahal B.O','765002',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146214,585,'Podapari B.O','765015',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146215,585,'Polama B.O','765016',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146216,585,'Pujariguda B.O','765016',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146217,585,'Puttasingi B.O','765022',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146218,585,'Raghubari B.O','765021',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146219,585,'Ramanaguda S.O','765029',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146220,585,'Rayagada Bazar S.O','765001',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146221,585,'Rayagada Gandhinagar S.O','765001',1,0,'2022-03-04 19:35:40','2022-03-04 19:35:40'),(146222,585,'Rayagada R.S S.O','765001',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146223,585,'Rayagada S.F. S.O','765002',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146224,585,'Rayagada(K) H.O','765001',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146225,585,'Regada B.O','765022',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146226,585,'Rekhapadar B.O','765029',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146227,585,'Renga B.O','765015',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146228,585,'S.Dhamini B.O','765029',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146229,585,'S.S.Khal B.O','765002',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146230,585,'Sagada B.O','765022',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146231,585,'Sahada B.O','765019',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146232,585,'Sanahuma B.O','765026',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146233,585,'Sankarada B.O','765015',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146234,585,'Serjholi B.O','764062',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146235,585,'Sikarpai B.O','765017',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146236,585,'Singari B.O','765016',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146237,585,'Siriguda B.O','765026',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146238,585,'Sirigumma B.O','765017',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146239,585,'Siripai B.O','765015',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146240,585,'Sulava B.O','765002',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146241,585,'Sunakhandi B.O','765016',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146242,585,'Sunger B.O','765015',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146243,585,'Suri B.O','765017',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146244,585,'T.Padar B.O','765020',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146245,585,'Tabalaguda B.O','765025',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146246,585,'Taribili B.O','765022',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146247,585,'Tembaguda B.O','765025',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146248,585,'Therubali S.O','765018',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146249,585,'Tiitmari B.O','765033',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146250,585,'Tikiri B.O','765015',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146251,585,'Todama B.O','765002',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146252,585,'Tolana B.O','765022',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146253,585,'Turaighati B.O','765015',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146254,585,'Ukkamba S.O','765024',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146255,586,'A.Katapali B.O','768006',1,0,'2022-03-04 19:35:41','2022-03-04 19:35:41'),(146256,586,'Ainlapali B.O','768104',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146257,586,'Ainthapali S.O','768004',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146258,586,'Amkuni B.O','768113',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146259,586,'Ardabahal B.O','768222',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146260,586,'Babu Nikitimal B.O','768228',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146261,586,'Babuchipidihi Ho B.O','768221',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146262,586,'Badapada B.O','768221',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146263,586,'Badasahir B.O','768112',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146264,586,'Badbahal B.O','768227',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146265,586,'Badrama B.O','768107',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146266,586,'Baduapali B.O','768113',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146267,586,'Badumermunda B.O','768221',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146268,586,'Baham B.O','768112',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146269,586,'Baliturei B.O','768228',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146270,586,'Bamandagarh B.O','768107',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146271,586,'Bamphei B.O','768221',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146272,586,'Bamra S.O','768221',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146273,586,'Bamrabasti B.O','768221',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146274,586,'Banke B.O','768227',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146275,586,'Bansajal B.O','768105',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146276,586,'Barbazar B.O','768006',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146277,586,'Bareipali B.O','768006',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146278,586,'Bargaon B.O','768113',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146279,586,'Barhamundi B.O','768107',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146280,586,'Basantpur B.O','768025',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146281,586,'Basiapara B.O','768105',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146282,586,'Basupali B.O','768212',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146283,586,'Batemura B.O','768005',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146284,586,'Batgaon B.O','768106',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146285,586,'Baunslaga B.O','768221',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146286,586,'Bauriguda B.O','768222',1,0,'2022-03-04 19:35:42','2022-03-04 19:35:42'),(146287,586,'Baxma B.O','768222',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146288,586,'Bhatpura B.O','768107',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146289,586,'Bhoipali B.O','768222',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146290,586,'Bhojpur B.O','768107',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146291,586,'Bilung B.O','768228',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146292,586,'Binjipali B.O','768214',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146293,586,'Birsinghgarh B.O','768105',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146294,586,'Bishalkhinda B.O','768200',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146295,586,'Bomaloi B.O','768212',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146296,586,'Bss Nagar S.O','768001',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146297,586,'Budharaja S.O','768004',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146298,586,'Burbuda B.O','768221',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146299,586,'Burla S.O','768017',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146300,586,'C.A. Chiplima S.O','768025',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146301,586,'Chakuliabahal B.O','768107',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146302,586,'Chandinimal B.O','768222',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146303,586,'Charmal B.O','768106',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146304,586,'Chaurpur B.O','768005',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146305,586,'Chhamunda B.O','768105',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146306,586,'Chhatabar B.O','768228',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146307,586,'Chinimahul B.O','768107',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146308,586,'Chiplima S.O','768026',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146309,586,'Daincha B.O','768106',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146310,586,'Dakra B.O','768113',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146311,586,'Dangajore B.O','768224',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146312,586,'Dangarpara B.O','768112',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146313,586,'Dhama S.O','768113',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146314,586,'Dhankauda B.O','768006',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146315,586,'Dhanupali S.O','768005',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146316,586,'Dhudipali B.O','768222',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146317,586,'Dimirikuda B.O','768107',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146318,586,'Engineering College Burla S.O','768018',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146319,586,'Fasimal B.O','768107',1,0,'2022-03-04 19:35:43','2022-03-04 19:35:43'),(146320,586,'Gadgadbahal B.O','768105',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146321,586,'Gardega B.O','768224',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146322,586,'Garmunda B.O','768006',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146323,586,'Garposh S.O','768224',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146324,586,'Gasinapada B.O','768227',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146325,586,'Ghichamura B.O','768212',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146326,586,'Ghosaramal B.O','768106',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146327,586,'Ghunghuti B.O','768221',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146328,586,'Girischandrapur B.O','768106',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146329,586,'Gochhara B.O','768222',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146330,586,'Godloisingh B.O','768105',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146331,586,'Godrapara B.O','768222',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146332,586,'Golebazar S.O','768001',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146333,586,'Gosala Chowk S.O','768025',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146334,586,'Gourpali S.O','768112',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146335,586,'Gundurchuan B.O','768107',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146336,586,'Hardipali B.O','768222',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146337,586,'Hatibari B.O','768105',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146338,586,'Hirakud S.O','768016',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146339,586,'J.Rengali B.O','768105',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146340,586,'Jagruti Vihar Burla S.O','768020',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146341,586,'Jamadarpali B.O','768200',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146342,586,'Jamankira S.O','768107',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146343,586,'Jamujori B.O','768106',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146344,586,'Jamumal B.O','768107',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146345,586,'Jayantapur B.O','768112',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146346,586,'Jhankarpali B.O','768005',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146347,586,'Jharghati Colony B.O','768212',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146348,586,'Jharuapara S.O','768001',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146349,586,'Jorabaga B.O','768228',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146350,586,'Jujumura S.O','768105',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146351,586,'Jyoti Vihar Burla S.O','768019',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146352,586,'K. Jamankira B.O','768227',1,0,'2022-03-04 19:35:44','2022-03-04 19:35:44'),(146353,586,'K. Jhankarpali B.O','768212',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146354,586,'Kabrapali B.O','768112',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146355,586,'Kabribahal B.O','768228',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146356,586,'Kadaligarh B.O','768106',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146357,586,'Kalamati B.O','768025',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146358,586,'Kandalapala B.O','768045',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146359,586,'Katarbaga B.O','768212',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146360,586,'Katarkela B.O','768107',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146361,586,'Kechhopani B.O','768221',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146362,586,'Kelloballam B.O','768106',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146363,586,'Kenadhipa B.O','768214',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146364,586,'Kesaibahal S.O','768228',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146365,586,'Keshapali B.O','768105',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146366,586,'Khalbilung B.O','768228',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146367,586,'Khandakata B.O','768222',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146368,586,'Kharsanmal B.O','768112',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146369,586,'Khetrajpur S.O','768003',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146370,586,'Khinda B.O','768212',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146371,586,'Kilasama B.O','768212',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146372,586,'Kinabaga B.O','768224',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146373,586,'Kinaloi B.O','768214',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146374,586,'Kindira B.O','768222',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146375,586,'Kisinda B.O','768106',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146376,586,'Kuarmal B.O','768221',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146377,586,'Kuchinda S.O','768222',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146378,586,'Kukudapali B.O','768200',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146379,586,'Kuleigarh B.O','768222',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146380,586,'Kulundi B.O','768112',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146381,586,'Kuntara B.O','768227',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146382,586,'Kurla B.O','768212',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146383,586,'Kusumi S.O','768227',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146384,586,'Kuturchuan B.O','768222',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146385,586,'Kuturimal B.O','768221',1,0,'2022-03-04 19:35:45','2022-03-04 19:35:45'),(146386,586,'Lad B.O','768222',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146387,586,'Laida S.O','768214',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146388,586,'Laidaguma B.O','768227',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146389,586,'Laigura B.O','768222',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146390,586,'Lapanga B.O','768212',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146391,586,'Lariapali B.O','768228',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146392,586,'Lipinda B.O','768105',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146393,586,'Luhapank B.O','768106',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146394,586,'M. Balanda B.O','768228',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146395,586,'Mahalingkudar B.O','768107',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146396,586,'Mahulpali B.O','768228',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146397,586,'Maltigunderpur B.O','768005',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146398,586,'Maneswar B.O','768005',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146399,586,'Medical College Burla S.O','768017',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146400,586,'Mochibahal B.O','768105',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146401,586,'Mudhenapali B.O','768112',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146402,586,'Mudipara S.O','768002',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146403,586,'N.Barangamal B.O','768112',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146404,586,'Naktideul S.O','768118',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146405,586,'Nuaburda B.O','768112',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146406,586,'Nuapali B.O','768224',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146407,586,'P. Niktimal B.O','768228',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146408,586,'Padiabahal B.O','768112',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146409,586,'Pankenpada B.O','768221',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146410,586,'Parmanpur B.O','768200',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146411,586,'Paruabhadi B.O','768222',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146412,586,'Patrapali B.O','768212',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146413,586,'Pindapathar B.O','768224',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146414,586,'Purunapani B.O','768222',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146415,586,'R.Badbahal B.O','768106',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146416,586,'R.Badmal B.O','768105',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146417,586,'Ragba B.O','768224',1,0,'2022-03-04 19:35:46','2022-03-04 19:35:46'),(146418,586,'Rairakhol S.O','768106',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146419,586,'Ramtileimal B.O','768222',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146420,586,'Rangiatikira B.O','768221',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146421,586,'Rasanpur B.O','768005',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146422,586,'Remed S.O','768006',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146423,586,'Rengali S.O','768212',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146424,586,'Routbahal B.O','768228',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146425,586,'Sadamal B.O','768214',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146426,586,'Sagra B.O','768224',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146427,586,'Sahaspur B.O','768113',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146428,586,'Salebhadi B.O','768227',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146429,586,'Salesingha B.O','768113',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146430,586,'Sambalpur Court S.O','768001',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146431,586,'Sambalpur H.O','768001',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146432,586,'Sangramal B. Camp B.O','768200',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146433,586,'Sankarma B.O','768006',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146434,586,'Sanmundaloi B.O','768227',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146435,586,'Sarapali B.O','768106',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146436,586,'Sarda B.O','768107',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146437,586,'Sargidihi B.O','768228',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146438,586,'Sasan Rs S.O','768200',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146439,586,'Satkama B.O','768222',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146440,586,'Shirod B.O','768107',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146441,586,'Similipal B.O','768106',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146442,586,'Sindurpank B.O','768005',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146443,586,'Sole B.O','768228',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146444,586,'Subarnapali B.O','768222',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146445,586,'Tabla B.O','768200',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146446,586,'Tainsar B.O','768227',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146447,586,'Talab B.O','768200',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146448,586,'Talsara B.O','768228',1,0,'2022-03-04 19:35:47','2022-03-04 19:35:47'),(146449,586,'Tampargarh B.O','768112',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146450,586,'Tamperkela B.O','768200',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146451,586,'Telitileimal B.O','768222',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146452,586,'Themra B.O','768005',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146453,586,'Tikiba B.O','768107',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146454,586,'Tikilipada B.O','768107',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146455,586,'Tileimal B.O','768221',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146456,586,'Tribanpur B.O','768106',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146457,586,'Turei B.O','768228',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146458,586,'Turei-niktimal B.O','768227',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146459,586,'Uchakapat B.O','768221',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146460,586,'Uttargaon B.O','768228',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146461,587,'Amarpali B.O','767018',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146462,587,'B.Sibtala B.O','767016',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146463,587,'Babupali B.O','767045',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146464,587,'Badbhainro B.O','767016',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146465,587,'Badkarle B.O','767045',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146466,587,'Bagbar B.O','767018',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146467,587,'Baidyanath B.O','767017',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146468,587,'Bankigirdi B.O','767045',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146469,587,'Bankipali B.O','767023',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146470,587,'Bausuni B.O','767019',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146471,587,'Beheramal B.O','767023',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146472,587,'Bhandar B.O','767019',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146473,587,'Bhimtikra B.O','767019',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146474,587,'Binka S.O','767019',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146475,587,'Birmaharajpur S.O','767018',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146476,587,'Bisimunda B.O','767017',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146477,587,'Brahmani B.O','767016',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146478,587,'Chadeipank B.O','767062',1,0,'2022-03-04 19:35:48','2022-03-04 19:35:48'),(146479,587,'Charbhata B.O','767016',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146480,587,'Cherupali B.O','767023',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146481,587,'Chinajuri B.O','767023',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146482,587,'Deulpadar B.O','767020',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146483,587,'Dharamsala B.O','767062',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146484,587,'Digsira B.O','767023',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146485,587,'Dubula B.O','767016',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146486,587,'Gajbandh B.O','767019',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146487,587,'Ghodaghatpara S.O','767017',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146488,587,'Harinapali B.O','767062',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146489,587,'Hikudi B.O','767062',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146490,587,'Hillung B.O','767018',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146491,587,'Ichhapur B.O','767023',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146492,587,'Jaloi B.O','767018',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146493,587,'Jatesingha B.O','767018',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146494,587,'Jhartarbha B.O','767016',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146495,587,'Jullunda B.O','767019',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146496,587,'Kadodar B.O','767018',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146497,587,'Kalapathar B.O','767018',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146498,587,'Kamalpur B.O','767018',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146499,587,'Kamsara B.O','767016',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146500,587,'Karlajuri B.O','767023',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146501,587,'Kartang B.O','767019',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146502,587,'Kenghriapali B.O','767018',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146503,587,'Khaliapali B.O','767017',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146504,587,'Khambeswaripali B.O','767017',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146505,587,'Khandahata B.O','767018',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146506,587,'Khari B.O','767016',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146507,587,'Kotsamalai B.O','767018',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146508,587,'Kumarkeli B.O','767018',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146509,587,'Lachhipur S.O','767068',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146510,587,'Lingamani B.O','767045',1,0,'2022-03-04 19:35:49','2022-03-04 19:35:49'),(146511,587,'Lupursingha B.O','767068',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146512,587,'Luthurpank B.O','767018',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146513,587,'Mahada B.O','767019',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146514,587,'Mahadevpali B.O','767019',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146515,587,'Maradoguchha B.O','767016',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146516,587,'Matiapali B.O','767068',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146517,587,'Mayurudan B.O','767017',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146518,587,'Meghla B.O','767019',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146519,587,'Menda B.O','767016',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146520,587,'Mursundhi B.O','767018',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146521,587,'Naikpada B.O','767062',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146522,587,'Nakdei B.O','767062',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146523,587,'Narayanpur B.O','767016',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146524,587,'Panchamahala B.O','767062',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146525,587,'Pitamahul B.O','767018',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146526,587,'Pua B.O','767016',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146527,587,'R. Mayabarha B.O','767045',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146528,587,'Raksa B.O','767062',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146529,587,'Ranisarda B.O','767020',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146530,587,'Rengali B.O','767068',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146531,587,'S. Kalapathar B.O','767017',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146532,587,'S.Mahada B.O','767018',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146533,587,'S.Patrapali B.O','767062',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146534,587,'Samaleichuan B.O','767023',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146535,587,'Sankara B.O','767019',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146536,587,'Sarasmal B.O','767045',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146537,587,'Sargaj B.O','767016',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146538,587,'Sargul B.O','767023',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146539,587,'Seledi B.O','767019',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146540,587,'Silati B.O','767019',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146541,587,'Sindhol B.O','767062',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146542,587,'Sindurpur B.O','767019',1,0,'2022-03-04 19:35:50','2022-03-04 19:35:50'),(146543,587,'Singhari B.O','767016',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146544,587,'Singhijuba B.O','767045',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146545,587,'Sohela B.O','767023',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146546,587,'Sonepur Badbazar S.O','767017',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146547,587,'Sonepur Rampur S.O','767045',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146548,587,'Sonepur S.O (Sonapur)','767017',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146549,587,'Spinning Mills S.O','767017',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146550,587,'Subalaya B.O','767018',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146551,587,'Sukha B.O','767023',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146552,587,'Tamamura B.O','767023',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146553,587,'Tarbha Bazar S.O','767016',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146554,587,'Tarbha S.O','767016',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146555,587,'Tullunda B.O','767016',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146556,587,'Ullunda S.O','767062',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146557,588,'A.Jambahal B.O','770033',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146558,588,'Ajaikela B.O','770036',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146559,588,'Alanda B.O','770017',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146560,588,'Alapaka B.O','770012',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146561,588,'Aleikera B.O','770020',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146562,588,'Aludega B.O','770016',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146563,588,'Amgova B.O','770018',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146564,588,'Asurchapal B.O','769043',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146565,588,'Aunlabahal B.O','770021',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146566,588,'B.Karuabahal B.O','770015',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146567,588,'B.Sankara B.O','770014',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146568,588,'Bad Dalki B.O','770037',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146569,588,'Badapurnapani B.O','770040',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146570,588,'Badbahal B.O','770019',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146571,588,'Badbonga B.O','770072',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146572,588,'Badgogua B.O','770038',1,0,'2022-03-04 19:35:51','2022-03-04 19:35:51'),(146573,588,'Badsalepali B.O','770022',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146574,588,'Bagdega B.O','770036',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146575,588,'Bailama B.O','770012',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146576,588,'Baladmal B.O','770073',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146577,588,'Balanda B.O','770031',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146578,588,'Balinga B.O','770076',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146579,588,'Balisankara S.O','770015',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146580,588,'Bamdera B.O','770016',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146581,588,'Bandega B.O','770074',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146582,588,'Bandhabal B.O','770015',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146583,588,'Bandhabhuin B.O','770051',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146584,588,'Bandhpali B.O','770002',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146585,588,'Bandomunda S.O','770032',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146586,588,'Bangerkela B.O','770036',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146587,588,'Banki Bazar B.O','770037',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146588,588,'Baragad B.O','770073',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146589,588,'Barangakachhar B.O','770016',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146590,588,'Bargaon (Sundergarh) S.O','770016',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146591,588,'Barghat B.O','770037',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146592,588,'Barghat B.O','770051',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146593,588,'Barhadema B.O','770074',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146594,588,'Barilepta B.O','770035',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146595,588,'Barpali B.O','770076',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146596,588,'Barsuan B.O','770036',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146597,588,'Barsuan S.O','770041',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146598,588,'Basanti Colony S.O','769012',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146599,588,'Basundhara S.O','770076',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146600,588,'Baurimundagaon B.O','770020',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146601,588,'Beheradihi B.O','770015',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146602,588,'Beheramunda B.O','770075',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146603,588,'Beldihi B.O','770031',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146604,588,'Belsara B.O','770011',1,0,'2022-03-04 19:35:52','2022-03-04 19:35:52'),(146605,588,'Bhaludungri B.O','770038',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146606,588,'Bhalulata B.O','770036',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146607,588,'Bhasma B.O','770019',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146608,588,'Bhedabahal B.O','770073',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146609,588,'Bhoipali B.O','770016',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146610,588,'Bhutuda B.O','770041',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146611,588,'Bilaigarh B.O','770011',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146612,588,'Bileimunda B.O','770024',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146613,588,'Bimlagarh B.O','770040',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146614,588,'Biramitrapur S.O','770033',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146615,588,'Birbira B.O','770022',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146616,588,'Birda B.O','770037',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146617,588,'Biringatoli B.O','770018',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146618,588,'Birkaldihi B.O','770015',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146619,588,'Birkera B.O','770037',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146620,588,'Birkera B.O','770036',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146621,588,'Bisra Road S.O','769001',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146622,588,'Bisra S.O','770036',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146623,588,'Bolani B.O','770037',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146624,588,'Bonaigarh S.O','770038',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146625,588,'Bonaikela B.O','770043',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146626,588,'Brahmani Tarang S.O','769004',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146627,588,'Buchukupara B.O','770017',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146628,588,'Chandiposh B.O','770037',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146629,588,'Chandrapur B.O','770037',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146630,588,'Chhatenpali B.O','770011',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146631,588,'Chhotasargi B.O','770002',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146632,588,'Chikatmati B.O','770031',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146633,588,'Chitapedi B.O','770035',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146634,588,'Chordhara B.O','770040',1,0,'2022-03-04 19:35:53','2022-03-04 19:35:53'),(146635,588,'Chungimati B.O','770034',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146636,588,'Civil Township S.O','769004',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146637,588,'Daghora B.O','770075',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146638,588,'Dahijira B.O','770018',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146639,588,'Daily Market S.O','769001',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146640,588,'Dalaisara B.O','770044',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146641,588,'Daldali B.O','770019',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146642,588,'Dalki B.O','770033',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146643,588,'Damdapara S.O','770033',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146644,588,'Damkuda B.O','770014',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146645,588,'Dandjamira B.O','770018',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146646,588,'Dandpani B.O','770012',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146647,588,'Darjing B.O','770040',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146648,588,'Darlipali B.O','770072',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146649,588,'Dengibhadi S.O','770001',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146650,588,'Dengula Ashram B.O','770048',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146651,588,'Deobhubanpur B.O','770015',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146652,588,'Deogaon B.O','770014',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146653,588,'Deuli B.O','770019',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146654,588,'Dhamakpur B.O','770015',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146655,588,'Dharuadihi S.O','770022',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146656,588,'Diamunda B.O','770021',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146657,588,'Duduka B.O','770076',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146658,588,'Dumabahal B.O','770012',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146659,588,'Dumerjore B.O','770034',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146660,588,'Durubaga B.O','770013',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146661,588,'Ekma B.O','770016',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146662,588,'Fertilizer Township S.O','769007',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146663,588,'G. Mahulpali B.O','770002',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146664,588,'G. Tumulia B.O','770024',1,0,'2022-03-04 19:35:54','2022-03-04 19:35:54'),(146665,588,'Gadiajore B.O','770022',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146666,588,'Gaikanpali B.O','770015',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146667,588,'Gairbahal B.O','770018',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146668,588,'Gambharidihi B.O','770011',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146669,588,'Gangpurgarh B.O','770020',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146670,588,'Garbhana B.O','770017',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146671,588,'Garjan B.O','769043',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146672,588,'Garjanjore B.O','770013',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146673,588,'Gilli B.O','770051',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146674,588,'Giringkela B.O','770012',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146675,588,'Gobira B.O','770039',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146676,588,'Gopalpur S.O (Sundergarh)','770024',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146677,588,'Gopinathpur B.O','770051',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146678,588,'Gopna B.O','770040',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146679,588,'Govindpur B.O','770051',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146680,588,'Gundiadihi B.O','770012',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146681,588,'Gurundia S.O','770043',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146682,588,'Gyanpali B.O','770023',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146683,588,'Hamirpur B.O','770002',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146684,588,'Hatibari S.O','770046',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146685,588,'Hemgir Road S.O','770075',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146686,588,'Hemgir S.O','770013',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146687,588,'Hutupani B.O','770074',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146688,588,'Indrapur B.O','770051',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146689,588,'Indrapur B.O','770033',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146690,588,'Itma B.O','770016',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146691,588,'J.Raiboga B.O','770072',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146692,588,'Jabaghat B.O','769042',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146693,588,'Jadakudar B.O','770037',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146694,588,'Jagda S.O','769042',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146695,588,'Jail Road S.O (Sundergarh)','769004',1,0,'2022-03-04 19:35:55','2022-03-04 19:35:55'),(146696,588,'Jaisor B.O','770014',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146697,588,'Jakaikela B.O','770038',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146698,588,'Jalda S.O','769043',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146699,588,'Jamdar B.O','770043',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146700,588,'Jamdihi B.O','770040',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146701,588,'Jamtalia B.O','770019',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146702,588,'Jamuna B.O','770014',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146703,588,'Jangra B.O','770044',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146704,588,'Jarangloi B.O','770016',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146705,588,'Jarda B.O','770043',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146706,588,'Jareikela B.O','770017',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146707,588,'Jareikela B.O','770036',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146708,588,'Jhamankera B.O','770033',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146709,588,'Jharbeda B.O','770070',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146710,588,'Jharbeda Banki B.O','770037',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146711,588,'Jhargaon B.O','770072',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146712,588,'Jhariapali B.O','770011',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146713,588,'Jharpalam B.O','770024',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146714,588,'Jhartarang B.O','769004',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146715,588,'Jhirdapali B.O','770051',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146716,588,'Jhirpani S.O','769042',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146717,588,'Jhunmur B.O','770033',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146718,588,'K.Bolang B.O','770040',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146719,588,'Kacharu B.O','769003',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146720,588,'Kadobahal B.O','770033',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146721,588,'Kahapani B.O','770018',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146722,588,'Kaintara B.O','770015',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146723,588,'Kalaiposh B.O','770040',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146724,588,'Kalamegha B.O','770021',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146725,588,'Kalinga Vihar S.O','769015',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146726,588,'Kalosihiria B.O','770039',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146727,588,'Kalta S.O','770052',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146728,588,'Kalunga S.O','770031',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146729,588,'Kanakjore B.O','770002',1,0,'2022-03-04 19:35:56','2022-03-04 19:35:56'),(146730,588,'Kanaktura B.O','770072',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146731,588,'Kandarkela B.O','770035',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146732,588,'Kandrikela B.O','770038',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146733,588,'Kansar B.O','770043',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146734,588,'Kansbahal S.O','770034',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146735,588,'Kantabahal B.O','770074',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146736,588,'Kantapali B.O','770043',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146737,588,'Kaplas B.O','770033',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146738,588,'Karamdihi B.O','770002',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146739,588,'Karanjkhol B.O','770012',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146740,588,'Kardega B.O','770033',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146741,588,'Karla B.O','770022',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146742,588,'Karmabahal B.O','769042',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146743,588,'Kasarda B.O','770051',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146744,588,'Katang B.O','770023',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146745,588,'Katchery Road S.O','769012',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146746,588,'Katra B.O','770002',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146747,588,'Kenaveta S.O','770051',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146748,588,'Kendudihi B.O','770013',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146749,588,'Kesramal B.O','770017',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146750,588,'Khamarimunda B.O','770015',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146751,588,'Khampur B.O','770015',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146752,588,'Khariabahal B.O','770040',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146753,588,'Khatkurbahal B.O','770018',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146754,588,'Khuntgaon S.O','770044',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146755,588,'Khutgaon B.O','770036',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146756,588,'Kiakachhar B.O','770020',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146757,588,'Kinikibandha B.O','770015',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146758,588,'Kinjirkela B.O','770015',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146759,588,'Kinjirma B.O','770019',1,0,'2022-03-04 19:35:57','2022-03-04 19:35:57'),(146760,588,'Kiralaga B.O','770014',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146761,588,'Kirei S.O','770073',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146762,588,'Kiripsira B.O','770011',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146763,588,'Koira S.O','770048',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146764,588,'Kokerama B.O','770033',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146765,588,'Kopsingha B.O','770073',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146766,588,'Koronga B.O','770018',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146767,588,'Kuarboga B.O','770011',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146768,588,'Kuarmunda S.O','770039',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146769,588,'Kuchedega B.O','770013',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146770,588,'Kukridihi B.O','770020',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146771,588,'Kulabira B.O','770012',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146772,588,'Kulba B.O','770020',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146773,588,'Kulenbahal B.O','770036',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146774,588,'Kuliposh B.O','770044',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146775,588,'Kulkuta B.O','770051',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146776,588,'Kulta B.O','770022',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146777,588,'Kumakela B.O','770037',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146778,588,'Kumbahal B.O','770016',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146779,588,'Kumjharia B.O','770039',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146780,588,'Kundheidiha B.O','770043',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146781,588,'Kundheikela B.O','770040',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146782,588,'Kundukela S.O','770019',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146783,588,'Kunmendra B.O','770033',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146784,588,'Kurda B.O','770044',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146785,588,'Kurei B.O','770015',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146786,588,'Kureiboga B.O','770016',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146787,588,'Kurga B.O','770002',1,0,'2022-03-04 19:35:58','2022-03-04 19:35:58'),(146788,588,'Kurumkel B.O','770014',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146789,588,'Kustuna B.O','770016',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146790,588,'Kusumdegi B.O','770018',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146791,588,'Kusumura B.O','770014',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146792,588,'Kutra S.O','770018',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146793,588,'Kutunia B.O','770017',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146794,588,'Kuturma B.O','770021',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146795,588,'Lachada B.O','770043',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146796,588,'Lahanda B.O','769042',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146797,588,'Lahandabud B.O','770022',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146798,588,'Lahunipara S.O','770040',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146799,588,'Laikera B.O','770012',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146800,588,'Laing B.O','770034',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146801,588,'Laing Colony B.O','770034',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146802,588,'Lalei B.O','770044',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146803,588,'Lamti B.O','770016',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146804,588,'Lanjiberna S.O','770023',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146805,588,'Lankahuda B.O','770073',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146806,588,'Latalaga B.O','770018',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146807,588,'Lathikata S.O','770037',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146808,588,'Ledhimong B.O','770022',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146809,588,'Lephripara S.O','770012',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146810,588,'Limida B.O','770035',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146811,588,'Loco Colony Bandomunda S.O','770032',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146812,588,'Luakera B.O','769009',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146813,588,'Luaram B.O','770035',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146814,588,'Lulkidihi B.O','770074',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146815,588,'Mahesdihi S.O','770001',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146816,588,'Mahuldiha B.O','770044',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146817,588,'Mahulpada B.O','770044',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146818,588,'Majhapara B.O','770033',1,0,'2022-03-04 19:35:59','2022-03-04 19:35:59'),(146819,588,'Majhapara B.O','770022',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146820,588,'Malidihi B.O','770017',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146821,588,'Mangaspur B.O','770019',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146822,588,'Manko B.O','770037',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146823,588,'Mayurdima B.O','770043',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146824,588,'Meghdega B.O','770002',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146825,588,'Mosabira B.O','770012',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146826,588,'N.Jharen B.O','770018',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146827,588,'Nandapara B.O','770040',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146828,588,'Narendra B.O','770038',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146829,588,'Nialipali B.O','770011',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146830,588,'Nuadihi B.O','770072',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146831,588,'Nuagaon B.O','770035',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146832,588,'Padampur B.O','770039',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146833,588,'Pamra B.O','770016',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146834,588,'Panchmahala B.O','770002',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146835,588,'Panchora B.O','770018',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146836,588,'Pandrisila B.O','770038',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146837,588,'Pankadihi B.O','770037',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146838,588,'Patmunda B.O','770048',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146839,588,'Patua B.O','770037',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146840,588,'Patuadihi B.O','770012',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146841,588,'Philingibahal B.O','770022',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146842,588,'Phulbari B.O','770016',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146843,588,'Phuljhar B.O','770044',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146844,588,'PIET Mandiakudar S.O','770034',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146845,588,'Pudajalanga B.O','770073',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146846,588,'Purnapani S.O','770035',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146847,588,'R.Kukuda B.O','770023',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146848,588,'R.Ratansara B.O','770024',1,0,'2022-03-04 19:36:00','2022-03-04 19:36:00'),(146849,588,'Raiboga B.O','770033',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146850,588,'Raidihi B.O','770021',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146851,588,'Raidihi B.O','770014',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146852,588,'Railway Colony S.O (Sundergarh)','770017',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146853,588,'Rajbahal B.O','770012',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146854,588,'Rajgangpur S.O','770017',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146855,588,'Rajpur B.O','770020',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146856,588,'Ramjodi B.O','770037',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146857,588,'Rampur B.O','770015',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146858,588,'Rangadhipa S.O','770002',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146859,588,'Ranibandha S.O','770017',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146860,588,'Ranpur B.O','770014',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146861,588,'Rasrajpur B.O','770002',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146862,588,'Ratakhandi B.O','770039',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146863,588,'Ratanpur B.O','770020',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146864,588,'Regent Market S.O','770001',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146865,588,'Remanda B.O','770019',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146866,588,'Rohini B.O','770075',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146867,588,'Rouldega B.O','770074',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146868,588,'Rourkela - 10 S.O','769010',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146869,588,'Rourkela - 11 S.O','769011',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146870,588,'Rourkela - 13 S.O','769013',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146871,588,'Rourkela - 14 S.O','769014',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146872,588,'Rourkela - 15 S.O','769015',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146873,588,'Rourkela - 2 S.O','769002',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146874,588,'Rourkela - 3 S.O','769003',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146875,588,'Rourkela - 4 S.O','769004',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146876,588,'Rourkela - 5 S.O','769005',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146877,588,'Rourkela - 6 S.O','769006',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146878,588,'Rourkela - 7 S.O','769007',1,0,'2022-03-04 19:36:01','2022-03-04 19:36:01'),(146879,588,'Rourkela - 8 S.O','769008',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146880,588,'Rourkela - 9 S.O','769009',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146881,588,'Rourkela -16 S.O','769016',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146882,588,'Rourkela H.O','769001',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146883,588,'Roxy B.O','770040',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146884,588,'Ruguda B.O','770044',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146885,588,'Rungaon B.O','770016',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146886,588,'S.Bolang B.O','770051',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146887,588,'Sagbahal B.O','770074',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146888,588,'Sagjore B.O','770074',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146889,588,'Sahajbahal B.O','770016',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146890,588,'Sahanamara B.O','770015',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146891,588,'Salangabahal B.O','770033',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146892,588,'Salangabud B.O','770022',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146893,588,'Salbira B.O','770016',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146894,588,'Sanghumunda B.O','770013',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146895,588,'Sankara S.O','770020',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146896,588,'Sankhaposh B.O','770040',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146897,588,'Sankraposh B.O','770016',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146898,588,'Sanpatrapali B.O','770020',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146899,588,'Santoshpur B.O','770036',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146900,588,'Sapdagar B.O','770014',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146901,588,'Sarafgarh B.O','770012',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146902,588,'Sardhapur B.O','770040',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146903,588,'Sargigarh B.O','770037',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146904,588,'Sargipali S.O','770021',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146905,588,'Sarsara B.O','770051',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146906,588,'Sashyakala B.O','770041',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146907,588,'Satkura B.O','770038',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146908,588,'Sayamba B.O','770040',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146909,588,'Sector - 15 S.O','769003',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146910,588,'Sector - 16 S.O','769003',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146911,588,'Sector - 2 S.O','769006',1,0,'2022-03-04 19:36:02','2022-03-04 19:36:02'),(146912,588,'Sector - 5 S.O','769002',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146913,588,'Sector - 6 S.O','769002',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146914,588,'Sector - 7 S.O','769003',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146915,588,'Sihidia B.O','770044',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146916,588,'Sikajore B.O','770015',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146917,588,'Simdega B.O','770014',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146918,588,'Suanjore B.O','770012',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146919,588,'Suarijore B.O','770012',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146920,588,'Subdega S.O','770014',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146921,588,'Sundargarh Court S.O','770001',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146922,588,'Sundargarh H.O','770001',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146923,588,'Surda B.O','770035',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146924,588,'Surguda B.O','770012',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146925,588,'Tainda B.O','770035',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146926,588,'Tainsar B.O','770037',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146927,588,'Talita B.O','770038',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146928,588,'Talsara S.O','770074',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146929,588,'Tamra B.O','770037',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146930,588,'Tangardihi B.O','770075',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146931,588,'Tangargaon B.O','770014',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146932,588,'Tangarpali B.O','770011',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146933,588,'Tarkera B.O','770033',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146934,588,'Tasladihi B.O','770002',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146935,588,'Telendihi B.O','770012',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146936,588,'Telijore B.O','770015',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146937,588,'Tendra B.O','770051',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146938,588,'Tensa S.O','770042',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146939,588,'Tikayatpali B.O','770051',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146940,588,'Tikilipara B.O','770076',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146941,588,'Tiklipara B.O','770016',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146942,588,'Tildega B.O','770015',1,0,'2022-03-04 19:36:03','2022-03-04 19:36:03'),(146943,588,'Tileikani B.O','770015',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146944,588,'Tilia B.O','770074',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146945,588,'Topadihi B.O','770040',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146946,588,'Topria B.O','770024',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146947,588,'Tudalaga B.O','770018',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146948,588,'Tulsikani B.O','770036',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146949,588,'Tumkela B.O','770040',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146950,588,'Tumlia B.O','770074',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146951,588,'Tunmura S.O','770070',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146952,588,'Uditnagar H.O','769012',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146953,588,'Udusu B.O','770036',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146954,588,'Ujalpur S.O','770011',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146955,588,'Ushra Colony B.O','770034',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146956,588,'Vedvyas B.O','769004',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146957,588,'Zincnagar S.O','770072',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146958,589,'Abiana B.O','140119',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146959,589,'Aerodrome S.O','160003',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146960,589,'Airforce Highground S.O','160004',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146961,589,'Ajauli B.O','140125',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146962,589,'Badheri B.O','160036',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146963,589,'Behlana B.O','160003',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146964,589,'Burail B.O','160047',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146965,589,'Chandigarh G.P.O.','160017',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146966,589,'Dadu Majra Colony S.O','160014',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146967,589,'Daria B.O','160101',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146968,589,'Dhanas B.O','160014',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146969,589,'Engg College S.O','160012',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146970,589,'Govt Press Chandigarh S.O','160018',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146971,589,'Hallomajra B.O','160002',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146972,589,'High Court S.O (Chandigarh)','160001',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146973,589,'Ind Area Chandigarh S.O','160002',1,0,'2022-03-04 19:36:04','2022-03-04 19:36:04'),(146974,589,'Kalitran B.O','140133',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(146975,589,'Kishangarh B.O','160101',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(146976,589,'Maloya Colony S.O','160025',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(146977,589,'Manimajra S.O','160101',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(146978,589,'Mauli Jagran S.O','160102',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(146979,589,'Mhc Manimajra S.O','160101',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(146980,589,'New Sectt Chandigarh S.O','160001',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(146981,589,'Raipur Kalan B.O','160102',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(146982,589,'Raj Bhawan S.O (Chandigarh)','160019',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(146983,589,'Ram Darbar S.O','160002',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(146984,589,'Sector 10 (Chandigarh) S.O','160011',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(146985,589,'Sector 11( Chandigarh) S.O','160011',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(146986,589,'Sector 12 (Chandigarh) S.O','160012',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(146987,589,'Sector 14 (Chandigarh) S.O','160014',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(146988,589,'Sector 15 Chandigarh S.O','160015',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(146989,589,'Sector 16 (Chandigarh) S.O','160015',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(146990,589,'Sector 18 (Chandigarh) S.O','160018',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(146991,589,'Sector 19 (Chandigarh) S.O','160019',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(146992,589,'Sector 20 (Chandigarh) S.O','160020',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(146993,589,'Sector 21 (Chandigarh) S.O','160022',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(146994,589,'Sector 22 (Chandigarh) S.O','160022',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(146995,589,'Sector 23 ( Chandigarh) S.O','160023',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(146996,589,'Sector 26 (Chandigarh) S.O','160019',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(146997,589,'Sector 27(Chandigarh)S.O','160019',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(146998,589,'Sector 29 (Chandigarh) S.O','160030',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(146999,589,'Sector 30 (Chandigarh) S.O','160030',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(147000,589,'Sector 31 (Chandigarh) S.O','160030',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(147001,589,'Sector 34(Chandigarh) S.O','160022',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(147002,589,'Sector 35 (Chandigarh) S.O','160022',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(147003,589,'Sector 36 (Chandigarh) S.O','160036',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(147004,589,'Sector 40 (Chandigarh) S.O','160036',1,0,'2022-03-04 19:36:05','2022-03-04 19:36:05'),(147005,589,'Sector 44 (Chandigarh) S.O','160047',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147006,589,'Sector 47 Chandigarh S.O','160047',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147007,589,'Sector 8(Chandgarh) S.O','160009',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147008,589,'Sector 9 (Chandigarh) S.O','160009',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147009,589,'Vidhansadan S.O','160001',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147010,590,'Abdal B.O','143502',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147011,590,'Adiwala B.O','143101',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147012,590,'Ajaiwali B.O','143502',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147013,590,'Ajnala S.O','143102',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147014,590,'Akalgarh Dhupaian B.O','143116',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147015,590,'Amritsar G.P.O.','143001',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147016,590,'Amritsar Kty S.O','143001',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147017,590,'Arjan Manga B.O','143114',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147018,590,'Assarapur B.O','143108',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147019,590,'Attari Rd. Check Post S.O','143108',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147020,590,'Attari S.O','143108',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147021,590,'Baba Bakala S.O','143202',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147022,590,'Babowal B.O','143119',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147023,590,'Bachiwind B.O','143108',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147024,590,'Bagga B.O','143119',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147025,590,'Bagga B.O','143101',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147026,590,'Bagrian B.O','143402',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147027,590,'Bakipur B.O','143302',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147028,590,'Bal Khurd B.O','143601',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147029,590,'Bal Sarai B.O','143204',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147030,590,'Balbawa B.O','143606',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147031,590,'Balharwal B.O','143102',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147032,590,'Balkalan B.O','143601',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147033,590,'Banian B.O','143117',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147034,590,'Banke B.O','143303',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147035,590,'Banwalipur B.O','143411',1,0,'2022-03-04 19:36:06','2022-03-04 19:36:06'),(147036,590,'Basarke B.O','143305',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147037,590,'Basarke Gillan B.O','143105',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147038,590,'Basti Ram Dhab S.O','143006',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147039,590,'Beas S.O','143201',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147040,590,'Begowal B.O','143601',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147041,590,'Behal B.O','143407',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147042,590,'Bhagwanpura B.O','143304',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147043,590,'Bhaini Rajputan B.O','143108',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147044,590,'Bhakna Kalan B.O','143107',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147045,590,'Bhalaipur Purban B.O','143202',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147046,590,'Bhallapind B.O','143102',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147047,590,'Bhalojla B.O','143201',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147048,590,'Bhangali B.O','143601',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147049,590,'Bhangwan B.O','143149',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147050,590,'Bhathal Bhai B.O','143409',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147051,590,'Bhattike B.O','143116',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147052,590,'Bhilowal B.O','143504',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147053,590,'Bhilowal Pacca B.O','143109',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147054,590,'Bhinder B.O','143112',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147055,590,'Bhindi Aulakh B.O','143109',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147056,590,'Bhindi Saydan B.O','143109',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147057,590,'Bhittewad B.O','143101',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147058,590,'Bhlaipur Dorgan B.O','143201',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147059,590,'Bhoewali B.O','143102',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147060,590,'Bhopa Rai B.O','143107',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147061,590,'Bhorchi Rajputana B.O','143111',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147062,590,'Bhullar B.O','143109',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147063,590,'Blair B.O','143303',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147064,590,'Bohru B.O','143009',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147065,590,'Brahmpura B.O','143409',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147066,590,'Brar B.O','143109',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147067,590,'Budha Theh B.O','143601',1,0,'2022-03-04 19:36:07','2022-03-04 19:36:07'),(147068,590,'Bundala S.O (Amritsar)','143413',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147069,590,'Butala S.O','143203',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147070,590,'Butari B.O','143111',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147071,590,'Butter Sivya B.O','143205',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147072,590,'Chabha B.O','143022',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147073,590,'Chahal B.O','143414',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147074,590,'Chak Sikandar B.O','143606',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147075,590,'Chakkare Khan B.O','143112',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147076,590,'Chamiari S.O','143103',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147077,590,'Chananke B.O','143114',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147078,590,'Chatiwind B.O','143022',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147079,590,'Chawinda B.O','143109',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147080,590,'Chawinda Devi S.O','143504',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147081,590,'Cheema Kalan B.O','143414',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147082,590,'Chetanpura S.O','143606',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147083,590,'Chhajalwindi B.O','143149',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147084,590,'Chheharta S.O','143105',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147085,590,'Chhidan B.O','143107',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147086,590,'Chicha B.O','143107',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147087,590,'Chima Bath B.O','143112',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147088,590,'Chogawan Rupowali B.O','143502',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147089,590,'Chogawan S.O','143109',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147090,590,'Chogawan Sidhpur B.O','143116',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147091,590,'Chohan B.O','143149',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147092,590,'Chowk Rattan Singh S.O','143001',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147093,590,'Chutala B.O','143411',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147094,590,'D.B.J.Singh S.O','143204',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147095,590,'Dadeha Sahib B.O','143410',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147096,590,'Dahoorian B.O','143603',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147097,590,'Daleke B.O','143402',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147098,590,'Dall B.O','143305',1,0,'2022-03-04 19:36:08','2022-03-04 19:36:08'),(147099,590,'Dayal Pura B.O','143304',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147100,590,'Dehriwala B.O','143116',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147101,590,'Devidaspura B.O','143149',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147102,590,'Dhade B.O','143504',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147103,590,'Dhand B.O','143105',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147104,590,'Dhanoakalan B.O','143108',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147105,590,'Dharar B.O','143115',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147106,590,'Dhardeo B.O','143205',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147107,590,'Dhariwal B.O','143416',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147108,590,'Dhariwal Kaler B.O','143102',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147109,590,'Dhaul Kalan B.O','143105',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147110,590,'Dhianpur B.O','143202',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147111,590,'Dhotian S.O','143411',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147112,590,'Dhulka B.O','143111',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147113,590,'Dinewal B.O','143406',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147114,590,'Dist Jail B.O','143008',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147115,590,'Distrillery Khasa S.O','143107',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147116,590,'Dujowal B.O','143603',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147117,590,'Dulonangal B.O','143201',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147118,590,'Durgiana Mandir S.O','143001',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147119,590,'Ekal Gudda B.O','143115',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147120,590,'Fatahpur S.O','143009',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147121,590,'Fatehabad S.O (Amritsar)','143407',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147122,590,'Fatehgarh Shukarchack B.O','143501',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147123,590,'Fatehpur Rajputan S.O','143113',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147124,590,'Fatehwal B.O','143102',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147125,590,'Focal Point SO','143006',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147126,590,'Gaggobhua B.O','143302',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147127,590,'Gaggomahal B.O','143102',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147128,590,'Gagrewal B.O','143201',1,0,'2022-03-04 19:36:09','2022-03-04 19:36:09'),(147129,590,'Gandhi Bazar S.O (Amritsar)','143006',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147130,590,'Gandiwind B.O','143414',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147131,590,'Gaure Nangal B.O','143103',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147132,590,'Ghagar Bhana B.O','143205',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147133,590,'Gharinda B.O','143107',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147134,590,'Ghonewal B.O','143603',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147135,590,'Gilwali B.O','143022',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147136,590,'Gohalwar Warpal B.O','143022',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147137,590,'Golden Temple S.O','143006',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147138,590,'Gomanpura B.O','143105',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147139,590,'Gorala B.O','143102',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147140,590,'Gumtala B.O','143008',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147141,590,'Guru Bazar S.O','143006',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147142,590,'Guru Ka Bagh B.O','143102',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147143,590,'Guru Nanak Dev University S.O','143005',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147144,590,'Guru Ram Dass Niwas S.O','143006',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147145,590,'Hardo Maura B.O','143109',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147146,590,'Harike S.O','143412',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147147,590,'Harsha Chhina B.O','143101',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147148,590,'Heir B.O','143101',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147149,590,'Hide Market S.O','143001',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147150,590,'Hoshiar Nagar B.O','143107',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147151,590,'Hs College S.O','143006',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147152,590,'Ibban Kalan B.O','143009',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147153,590,'J.F.Mill S.O','143002',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147154,590,'Jabowal B.O','143116',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147155,590,'Jafarkot B.O','143102',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147156,590,'Jagdev Bar B.O','143601',1,0,'2022-03-04 19:36:10','2022-03-04 19:36:10'),(147157,590,'Jagdev Kalan B.O','143101',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147158,590,'Jagdev Khurd B.O','143102',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147159,590,'Jahangir B.O','143406',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147160,590,'Jaintipur B.O','143502',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147161,590,'Jalalpura B.O','143601',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147162,590,'Jallupura Khera B.O','143112',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147163,590,'Jamalpur B.O','143203',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147164,590,'Jamarai B.O','143411',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147165,590,'Jandiala Cb B.O','143149',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147166,590,'Jandiala Guru S.O','143115',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147167,590,'Jandiala R.S S.O','143149',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147168,590,'Jaspal B.O','143111',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147169,590,'Jasrur B.O','143102',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147170,590,'Jastarwal B.O','143102',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147171,590,'Jatta B.O','143603',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147172,590,'Jeowala B.O','143302',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147173,590,'Jethuwal B.O','143502',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147174,590,'Jhamke B.O','143302',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147175,590,'Jhander B.O','143606',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147176,590,'Jhanjoti B.O','143101',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147177,590,'Jhita Kalan B.O','143413',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147178,590,'Jodhe B.O','143204',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147179,590,'Johal Dhai Wala B.O','143407',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147180,590,'Kacha Pacca S.O','143304',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147181,590,'Kadgill B.O','143402',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147182,590,'Kairon S.O','143415',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147183,590,'Kakkar B.O','143109',1,0,'2022-03-04 19:36:11','2022-03-04 19:36:11'),(147184,590,'Kale Ghanupur B.O','143105',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147185,590,'Kaleke B.O','143111',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147186,590,'Kallah B.O','143406',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147187,590,'Kamalpur B.O','143103',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147188,590,'Kang S.O','143406',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147189,590,'Kangra Colony S.O','143001',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147190,590,'Karyala B.O','143102',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147191,590,'Kasail B.O','143105',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147192,590,'Kathania B.O','143105',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147193,590,'Kathunangal S.O','143502',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147194,590,'Katra Karam Singh S.O','143006',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147195,590,'Katra Sher Singh S.O','143006',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147196,590,'Khabe Rajputana B.O','143114',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147197,590,'Khabedogran B.O','143402',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147198,590,'Khadoor Sahib S.O','143117',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147199,590,'Khalra S.O','143305',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147200,590,'Khalsa College S.O','143002',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147201,590,'Khalsa College S.O','143002',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147202,590,'Khankot Garden Colony B.O','143501',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147203,590,'Khanpur B.O','143203',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147204,590,'Khaper Kheri B.O','143105',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147205,590,'Khara B.O','143410',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147206,590,'Khatrian Kalan B.O','143606',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147207,590,'Khela B.O','143407',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147208,590,'Khiala Kalan B.O','143109',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147209,590,'Khilchian S.O','143111',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147210,590,'Kohala B.O','143109',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147211,590,'Kohali B.O','143109',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147212,590,'Kot Atma Ram S.O','143006',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147213,590,'Kot Dharam Chand Kalan B.O','143301',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147214,590,'Kot Khera B.O','143116',1,0,'2022-03-04 19:36:12','2022-03-04 19:36:12'),(147215,590,'Kot Mehtab B.O','143201',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147216,590,'Kot Mit Singh S.O','143022',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147217,590,'Kot Mohd.Khan B.O','143411',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147218,590,'Kotla Gujjran B.O','143606',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147219,590,'Kotla Sultan Singh B.O','143601',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147220,590,'Kotli Dhole Shah B.O','143504',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147221,590,'Kullah B.O','143304',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147222,590,'Ladhewal B.O','143107',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147223,590,'Lakhna B.O','143419',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147224,590,'Lakhuwal B.O','143202',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147225,590,'Lalu Ghuman B.O','143301',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147226,590,'Lauka B.O','143415',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147227,590,'Lawrence Road S.O','143001',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147228,590,'Leharka B.O','143504',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147229,590,'Lidhar B.O','143112',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147230,590,'Loharka Kalan B.O','143101',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147231,590,'Lohgarh B.O','143111',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147232,590,'Lola B.O','143116',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147233,590,'Lopoke B.O','143109',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147234,590,'Ludhar B.O','143502',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147235,590,'Madhu Chhanga B.O','143606',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147236,590,'Mahal B.O','143105',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147237,590,'Mahmoodpura B.O','143419',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147238,590,'Majith Mandi S.O','143006',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147239,590,'Majitha S.O','143601',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147240,590,'Makhanwindi B.O','143501',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147241,590,'Makhi Kalan B.O','143304',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147242,590,'Makowal B.O','143103',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147243,590,'Mallian B.O','143149',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147244,590,'Mallowal B.O','143116',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147245,590,'Mallunangal B.O','143101',1,0,'2022-03-04 19:36:13','2022-03-04 19:36:13'),(147246,590,'Maluwal B.O','143301',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147247,590,'Manakpura B.O','143304',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147248,590,'Manawala B.O','143109',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147249,590,'Manawan B.O','143419',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147250,590,'Mandir Mathra Bhagi B.O','143305',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147251,590,'Manihala Jai Singh B.O','143304',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147252,590,'Manochahal B.O','143402',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147253,590,'Marari Kalan B.O','143601',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147254,590,'Marhana B.O','143410',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147255,590,'Mari Kamboke B.O','143305',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147256,590,'Mari Megha B.O','143305',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147257,590,'Marjindpura B.O','143304',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147258,590,'Mastgarh B.O','143419',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147259,590,'Mattewal S.O','143119',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147260,590,'Medical College S.O (Amritsar)','143001',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147261,590,'Meherbanapura B.O','143115',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147262,590,'Mehlanwala B.O','143102',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147263,590,'Mehma B.O','143022',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147264,590,'Mehndipura B.O','143419',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147265,590,'Mehsampura B.O','143114',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147266,590,'Mehta B.O','143114',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147267,590,'Mehta Chowk S.O','143114',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147268,590,'Mianwind B.O','143112',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147269,590,'Miran Kot B.O','143101',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147270,590,'Mode B.O','143108',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147271,590,'Mohan Bhandari B.O','143606',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147272,590,'Mohan Nagar S.O (Amritsar)','143006',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147273,590,'Mohanpura B.O','143409',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147274,590,'Mohar B.O','143102',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147275,590,'Mohawa B.O','143108',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147276,590,'Muchal B.O','143111',1,0,'2022-03-04 19:36:14','2022-03-04 19:36:14'),(147277,590,'Mud Khokhar B.O','143109',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147278,590,'Mudhal B.O','143501',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147279,590,'Musse B.O','143302',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147280,590,'Nag Kalan B.O','143601',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147281,590,'Nagoke B.O','143117',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147282,590,'Nangal Dial Singh B.O','143113',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147283,590,'Nangli B.O','143008',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147284,590,'Narli B.O','143305',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147285,590,'Naurangabad B.O','143402',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147286,590,'Naushehra Nangli B.O','143008',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147287,590,'Naushehra Pannuan S.O','143409',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147288,590,'Naushhra Dhalla B.O','143414',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147289,590,'Nawan Kot S.O','143001',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147290,590,'Nawanpind B.O','143113',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147291,590,'Neshta B.O','143108',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147292,590,'Nizampura B.O','143501',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147293,590,'NRL Workshop S.O','143001',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147294,590,'Othian B.O','143102',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147295,590,'Padhir Kalan B.O','143302',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147296,590,'Padri B.O','143107',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147297,590,'Pahuwind B.O','143303',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147298,590,'Pakharpura B.O','143502',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147299,590,'Pakhopura B.O','143408',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147300,590,'Palasaur B.O','143402',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147301,590,'Pandori Warraich B.O','143008',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147302,590,'Panjwar B.O','143301',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147303,590,'Pheruman B.O','143112',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147304,590,'Raipur Kalan B.O','143113',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147305,590,'Raja Sansi S.O','143101',1,0,'2022-03-04 19:36:15','2022-03-04 19:36:15'),(147306,590,'Rajatal B.O','143108',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147307,590,'Rajdhan B.O','143114',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147308,590,'Rajoke B.O','143305',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147309,590,'Ram Diwali Hinduan B.O','143504',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147310,590,'Ram Diwali Muslama B.O','143119',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147311,590,'Ram Tirath B.O','143107',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147312,590,'Ramdass S.O','143603',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147313,590,'Rangarh B.O','143108',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147314,590,'Ranian B.O','143109',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147315,590,'Rataul B.O','143022',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147316,590,'Ratta Gudda B.O','143412',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147317,590,'Rattoke Gurudwara B.O','143419',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147318,590,'Rayon & Silk Mill S.O','143105',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147319,590,'Rayya S.O','143112',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147320,590,'Saidoke B.O','143114',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147321,590,'Sangatpura B.O','143409',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147322,590,'Sangatpura B.O','143606',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147323,590,'Sangna B.O','143009',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147324,590,'Sarai Amant Khan S.O','143414',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147325,590,'Sarangdeo B.O','143102',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147326,590,'Sarangra B.O','143109',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147327,590,'Sarhali Mandan B.O','143415',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147328,590,'Sarli Kalan B.O','143115',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147329,590,'Sarli Khurd B.O','143115',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147330,590,'Sathiala S.O','143205',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147331,590,'Saurian B.O','143109',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147332,590,'Sehensra B.O','143102',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147333,590,'Shahabpur B.O','143411',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147334,590,'Shahura B.O','143108',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147335,590,'Shahzada B.O','143504',1,0,'2022-03-04 19:36:16','2022-03-04 19:36:16'),(147336,590,'Sham Nagar B.O','143601',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147337,590,'Sheron B.O','143411',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147338,590,'Sheron Bagga B.O','143203',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147339,590,'Sialka B.O','143119',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147340,590,'Sidhar B.O','143103',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147341,590,'Sidhar Rajputan B.O','143111',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147342,590,'Sidhwa B.O','143305',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147343,590,'Singhpura B.O','143303',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147344,590,'Sjs Avenue S.O','143008',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147345,590,'Sohal B.O','143302',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147346,590,'Sohawa B.O','143410',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147347,590,'Sohian Kalan B.O','143601',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147348,590,'Sohian Khurd B.O','143501',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147349,590,'SpeedPost Centre BDC S.O','143001',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147350,590,'Sugga B.O','143303',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147351,590,'Sultan Wind Gate S.O','143001',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147352,590,'Sultanwind S.O','143006',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147353,590,'Takhutuchak B.O','143115',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147354,590,'Talwandi Dasaunda Singh B.O','143502',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147355,590,'Talwandi Dogran B.O','143113',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147356,590,'Tanel B.O','143116',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147357,590,'Tangra B.O','143149',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147358,590,'Taragarh B.O','143115',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147359,590,'Tarpai B.O','143601',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147360,590,'Tarsika S.O','143116',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147361,590,'Tera Kalan B.O','143103',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147362,590,'Tharu B.O','143402',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147363,590,'Thatha B.O','143410',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147364,590,'Thathian Mahantan B.O','143409',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147365,590,'Thoba B.O','143603',1,0,'2022-03-04 19:36:17','2022-03-04 19:36:17'),(147366,590,'Thothian B.O','143111',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147367,590,'Tmmowal B.O','143149',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147368,590,'Tut B.O','143109',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147369,590,'Uddoke B.O','143119',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147370,590,'Udhonangal B.O','143114',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147371,590,'Uggar Aulakh B.O','143102',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147372,590,'Vachhoa B.O','143606',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147373,590,'Vallah B.O','143501',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147374,590,'Valtoha B.O','143416',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147375,590,'Vanike B.O','143109',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147376,590,'Verka S.O','143501',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147377,590,'Vijaya Nagar S.O','143001',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147378,590,'Viring B.O','143117',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147379,590,'Wadala Bhittewad B.O','143105',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147380,590,'Wadala Johal B.O','143113',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147381,590,'Wadala Khurd B.O','143202',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147382,590,'Wadala Viram B.O','143601',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147383,590,'Wadali Guru B.O','143105',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147384,590,'Wadalkalan B.O','143202',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147385,590,'Warpal B.O','143022',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147386,590,'Waryam Nangal B.O','143502',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147387,591,'Attar Singh Wala B.O','148105',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147388,591,'Badbar B.O','148106',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147389,591,'Bakhatgarh B.O','148100',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147390,591,'Barnala Kty S.O','148101',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147391,591,'Barnala S.O','148101',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147392,591,'Bhadalwad B.O','148109',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147393,591,'Bhaini Jassan B.O','148105',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147394,591,'Bhani Mehraj B.O','148106',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147395,591,'Bhathlan B.O','148105',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147396,591,'Bhotna B.O','148100',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147397,591,'Bihla B.O','148100',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147398,591,'Chananwal B.O','148104',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147399,591,'Chauhan Ke Kalan B.O','148109',1,0,'2022-03-04 19:36:18','2022-03-04 19:36:18'),(147400,591,'Cheema B.O','148103',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147401,591,'Chhapa B.O','148104',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147402,591,'Chhiniwal Kalan B.O','148104',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147403,591,'Chhiniwal Khurd B.O','148100',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147404,591,'Dangarh B.O','148105',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147405,591,'Daraj B.O','148108',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147406,591,'Dewana B.O','148100',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147407,591,'Dhanaula S.O','148105',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147408,591,'Dhaula B.O','148107',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147409,591,'Dhilwan B.O','148108',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147410,591,'Dhurkot B.O','148107',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147411,591,'Gangohar B.O','148104',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147412,591,'Gehal B.O','148100',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147413,591,'Ghunas B.O','148108',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147414,591,'Guram B.O','148025',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147415,591,'Hamidi B.O','148025',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147416,591,'Harigarh B.O','148105',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147417,591,'Jangiana B.O','148102',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147418,591,'Jhaloor B.O','148024',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147419,591,'Jodhpur B.O','148103',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147420,591,'Kahne Ke B.O','148107',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147421,591,'Kalalmajra B.O','148104',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147422,591,'Kaleke B.O','148105',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147423,591,'Karamgarh B.O','148109',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147424,591,'Kattu B.O','148105',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147425,591,'Khudi  Kalan B.O','148107',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147426,591,'Kotduna B.O','148105',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147427,591,'Kurar B.O','148104',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147428,591,'Mauran B.O','148108',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147429,591,'Mehal Kalan S.O','148104',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147430,591,'Moom B.O','148100',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147431,591,'Nainewal B.O','148102',1,0,'2022-03-04 19:36:19','2022-03-04 19:36:19'),(147432,591,'Nangal Thulewal B.O','148109',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147433,591,'Ncc Barnala S.O','148101',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147434,591,'Nihaluwal B.O','148104',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147435,591,'Pakho Kalan B.O','148108',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147436,591,'Pakhoke B.O','148103',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147437,591,'Pandher B.O','148105',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147438,591,'Pharwahi B.O','148101',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147439,591,'Qutba B.O','148104',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147440,591,'Raisar B.O','148101',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147441,591,'Ramgarh B.O','148100',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147442,591,'Sandhu Kalan B.O','148102',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147443,591,'Sanghera S.O','148109',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147444,591,'Sehjra B.O','148109',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147445,591,'Sekha B.O','148024',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147446,591,'Shaina S.O','148103',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147447,591,'Sher Singh Pura B.O','148100',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147448,591,'Tajoke B.O','148108',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147449,591,'Tallewal S.O','148100',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147450,591,'Talwandi B.O','148102',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147451,591,'Thikriwala B.O','148101',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147452,591,'Thuliwal B.O','148025',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147453,591,'Ugoke B.O','148108',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147454,591,'Wazid Ke Khurd B.O','148109',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147455,592,'Ablu B.O','151201',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147456,592,'Akalia Kalan B.O','151201',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147457,592,'Aklia Jalal B.O','151108',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147458,592,'Alike B.O','151104',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147459,592,'Bahadurpur B.O','151501',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147460,592,'Bajjoana B.O','151102',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147461,592,'Ballian Wali B.O','151103',1,0,'2022-03-04 19:36:20','2022-03-04 19:36:20'),(147462,592,'Balloh B.O','151510',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147463,592,'Balluna B.O','151005',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147464,592,'Bandi B.O','151401',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147465,592,'Bangi Rughu B.O','151301',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147466,592,'Bangi Ruldu B.O','151301',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147467,592,'Bathinda Cantt S.O','151004',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147468,592,'Bathinda City S.O','151005',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147469,592,'Bathinda H.O','151001',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147470,592,'Behman Diwana B.O','151005',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147471,592,'Behman Jassa Singh Wala B.O','151302',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147472,592,'Behniwal B.O','151302',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147473,592,'Bhagi Bander B.O','151302',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147474,592,'Bhagta Bhai S.O','151206',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147475,592,'Bhagwan Garh B.O','151301',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147476,592,'Bhai Rupa S.O','151106',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147477,592,'Bhaini Kani B.O','151105',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147478,592,'Bhisiana B.O','151201',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147479,592,'Bhokhra B.O','151201',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147480,592,'Bhucho Kalan B.O','151101',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147481,592,'Bhucho Khurd B.O','151101',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147482,592,'Bhucho Mandi S.O','151101',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147483,592,'Bhunder B.O','151103',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147484,592,'Bibi Wala B.O','151005',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147485,592,'Bir Behman B.O','151005',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147486,592,'Burj Mehma B.O','151201',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147487,592,'Burj Sema B.O','151509',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147488,592,'Chak Attar Singh Wala B.O','151401',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147489,592,'Chak Bakhtu B.O','151101',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147490,592,'Chak Fateh Sngh Wala B.O','151101',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147491,592,'Chak Ruldu Singh Wala B.O','151401',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147492,592,'Chehlanwali B.O','151302',1,0,'2022-03-04 19:36:21','2022-03-04 19:36:21'),(147493,592,'Chethewala B.O','151302',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147494,592,'Chughe Kalan B.O','151005',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147495,592,'Deon B.O','151002',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147496,592,'Dhade B.O','151103',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147497,592,'Dhapali B.O','151104',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147498,592,'Dhingar B.O','151302',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147499,592,'Dial Pura Bhai Ka B.O','151108',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147500,592,'Dial Pura Mirja B.O','151102',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147501,592,'Dikh B.O','151103',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147502,592,'Dunne Wala B.O','151401',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147503,592,'Ganga B.O','151201',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147504,592,'Gehri Baghi B.O','151005',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147505,592,'Gehri Bara Singh B.O','151509',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147506,592,'Gehri Butter B.O','151401',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147507,592,'Ghanda Bana B.O','151106',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147508,592,'Ghtp Lehra Mohabbat S.O','151111',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147509,592,'Ghudda B.O','151401',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147510,592,'Ghuman Kalan B.O','151509',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147511,592,'Giana B.O','151301',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147512,592,'Gill Kalan B.O','151103',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147513,592,'Gndtp Bathinda S.O','151002',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147514,592,'Gobindpura B.O','151501',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147515,592,'Goniana Mandi S.O','151201',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147516,592,'Govind Pura B.O','151102',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147517,592,'Gulab Garh B.O','151101',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147518,592,'Gumti Kalan B.O','151106',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147519,592,'Guru Sar Sehne Wala B.O','151005',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147520,592,'Hakam Singh Wala B.O','151108',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147521,592,'Hamirgarh B.O','151206',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147522,592,'Harrai Pur B.O','151201',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147523,592,'Ind. Estate Bathinda S.O','151001',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147524,592,'Jaga Ram Tirath B.O','151302',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147525,592,'Jai Singh Wala B.O','151005',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147526,592,'Jaidan B.O','151103',1,0,'2022-03-04 19:36:22','2022-03-04 19:36:22'),(147527,592,'Jalal B.O','151108',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147528,592,'Janda Wala B.O','151201',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147529,592,'Jangi Rana B.O','151401',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147530,592,'Jassi Bag Wali B.O','151401',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147531,592,'Jassi Pau Wali B.O','151005',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147532,592,'Jeeda B.O','151201',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147533,592,'Jethu Ke B.O','151103',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147534,592,'Jhanduke B.O','151101',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147535,592,'Jhumba B.O','151005',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147536,592,'Jiwan Singh Wala B.O','151302',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147537,592,'Jodhpur Pakhar B.O','151509',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147538,592,'Kahangarh B.O','151501',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147539,592,'Kalal Wala B.O','151302',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147540,592,'Kalyan Sukha B.O','151102',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147541,592,'Kamalu Swaitch B.O','151509',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147542,592,'Kamla Nehru Colony Bathinda S.O','151001',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147543,592,'Karar Wala B.O','151103',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147544,592,'Kaur Singh Wala B.O','151108',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147545,592,'Kaureana B.O','151302',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147546,592,'Khemuana B.O','151201',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147547,592,'Kishan Pura Kutti B.O','151401',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147548,592,'Kishangarh Saide Singh Wala B.O','151501',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147549,592,'Kot Bakhtu B.O','151301',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147550,592,'Kot Fatta B.O','151101',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147551,592,'Kot Guru B.O','151401',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147552,592,'Kot Shamir B.O','151005',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147553,592,'Kotha Guru B.O','151206',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147554,592,'Kotli Sabo B.O','151401',1,0,'2022-03-04 19:36:23','2022-03-04 19:36:23'),(147555,592,'Kotra Koreyan Wala B.O','151103',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147556,592,'Kulrian B.O','151501',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147557,592,'Kutti Wal Kalan B.O','151509',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147558,592,'Laleana B.O','151301',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147559,592,'Lehra Bega B.O','151111',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147560,592,'Lehra Dhur Kot B.O','151111',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147561,592,'Lehra Khanna B.O','151111',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147562,592,'Mai Sar Khana B.O','151509',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147563,592,'Malkana B.O','151301',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147564,592,'Maluka B.O','151206',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147565,592,'Mandi Kalan B.O','151103',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147566,592,'Maur Kalan B.O','151509',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147567,592,'Mehma Bhagwana B.O','151201',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147568,592,'Mehma Sarja B.O','151201',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147569,592,'Mehma Sawai B.O','151201',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147570,592,'Mehraj S.O','151105',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147571,592,'Mehta B.O','151005',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147572,592,'Multania B.O','151005',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147573,592,'Nai Basti Bathinda S.O','151001',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147574,592,'Nand Garh B.O','151401',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147575,592,'Naruana B.O','151005',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147576,592,'Nasib Pura B.O','151005',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147577,592,'Nathana S.O','151102',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147578,592,'Natheha B.O','151302',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147579,592,'Nathpura B.O','151102',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147580,592,'Nehian Wala B.O','151201',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147581,592,'Nfl Bathinda S.O','151003',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147582,592,'Pakka Kalan B.O','151401',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147583,592,'Pathrala B.O','151401',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147584,592,'Peer Kot B.O','151509',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147585,592,'Phul S.O','151104',1,0,'2022-03-04 19:36:24','2022-03-04 19:36:24'),(147586,592,'Pitho B.O','151103',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147587,592,'Poohla B.O','151102',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147588,592,'Poohli B.O','151102',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147589,592,'Rai Ke Kalan B.O','151401',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147590,592,'Rai Khanna B.O','151101',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147591,592,'Railway Colony S.O (Bathinda)','151005',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147592,592,'Raiya B.O','151104',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147593,592,'Raj Garh Kubbe B.O','151509',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147594,592,'Ram Nagar B.O','151509',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147595,592,'Raman S.O','151301',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147596,592,'Ramanvas B.O','151103',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147597,592,'Rampura Mandi S.O','151103',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147598,592,'Rampura Phul S.O','151103',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147599,592,'Ramu Wala Jalalka B.O','151108',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147600,592,'Ranghrial B.O','151501',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147601,592,'Sailbrah B.O','151104',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147602,592,'Salabatpura S.O','151108',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147603,592,'Sangat S.O','151401',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147604,592,'Sardargarh B.O','151005',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147605,592,'Sekhpura B.O','151302',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147606,592,'Sekhu B.O','151301',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147607,592,'Sema B.O','151101',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147608,592,'Sevian B.O','151002',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147609,592,'Singo B.O','151302',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147610,592,'Siryewala B.O','151206',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147611,592,'Talwandi Sabo S.O','151302',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147612,592,'Teona B.O','151005',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147613,592,'Teona Pujarian B.O','151302',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147614,592,'Tung Wali B.O','151101',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147615,592,'Virk Kalan B.O','151201',1,0,'2022-03-04 19:36:25','2022-03-04 19:36:25'),(147616,592,'Virk Khurd B.O','151201',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147617,593,'Arryan Wala B.O','151213',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147618,593,'Aulakh B.O','151207',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147619,593,'Baja Khana S.O','151205',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147620,593,'Bambhia Bhai Ka B.O','151208',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147621,593,'Bargari S.O','151208',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147622,593,'Behbal Khurd B.O','151208',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147623,593,'Bhagthala Kalan B.O','151213',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147624,593,'Bhaloor B.O','151207',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147625,593,'Bihle Wala B.O','151212',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147626,593,'Bishnandi B.O','151202',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147627,593,'Chaina B.O','151202',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147628,593,'Chandbaja B.O','151213',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147629,593,'Chandbhan B.O','151202',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147630,593,'Deep Singh Wala B.O','151212',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147631,593,'Dhaipai B.O','151204',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147632,593,'Dhilwana Kalan B.O','151204',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147633,593,'Dhimanwali B.O','151209',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147634,593,'Dhudhi B.O','151213',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147635,593,'Dhurkot B.O','151213',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147636,593,'Dod B.O','151205',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147637,593,'Faridkot H.O','151203',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147638,593,'Faridkot Mandi S.O','151203',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147639,593,'Fatehgarh Dabri Khana B.O','151205',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147640,593,'Ghania Wala B.O','151207',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147641,593,'Ghugiana B.O','151213',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147642,593,'Golewala B.O','151213',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147643,593,'Gumti Khurd B.O','151202',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147644,593,'Gurudwara Jand Sahib B.O','151212',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147645,593,'Hari Nau B.O','151204',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147646,593,'Harindra Nagar (Faridkot) S.O','151213',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147647,593,'Jaitu S.O','151202',1,0,'2022-03-04 19:36:26','2022-03-04 19:36:26'),(147648,593,'Janeria B.O','151212',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147649,593,'Jhakhar Wala B.O','151208',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147650,593,'Jiwan Wala B.O','151207',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147651,593,'Kammiana B.O','151213',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147652,593,'Kasam Bhatti B.O','151202',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147653,593,'Khara B.O','152025',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147654,593,'Koharwala B.O','151204',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147655,593,'Kot Sukhia B.O','151207',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147656,593,'Kotkapura S.O','151204',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147657,593,'Machaki Kalan B.O','151212',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147658,593,'Machaki Mal Singh B.O','151209',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147659,593,'Madhak B.O','151202',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147660,593,'Malke B.O','151207',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147661,593,'Matta B.O','151204',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147662,593,'Mehmuana B.O','151212',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147663,593,'Momara B.O','151212',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147664,593,'Moranwali B.O','151213',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147665,593,'Mour Suhag B.O','151204',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147666,593,'Pakhi Kalan B.O','151213',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147667,593,'Panj Grain Kalan S.O','151207',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147668,593,'PG Khurd B.O','151207',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147669,593,'Pipli B.O','151213',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147670,593,'Quila Nau B.O','151213',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147671,593,'Rajowala B.O','151213',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147672,593,'Rameana B.O','151202',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147673,593,'Romana Ajit Singh B.O','151205',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147674,593,'Romana Albel Singh B.O','151204',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147675,593,'Rorikapura B.O','151202',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147676,593,'Sadiq S.O','151212',1,0,'2022-03-04 19:36:27','2022-03-04 19:36:27'),(147677,593,'Sandhwan S.O','151209',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147678,593,'Sarawan B.O','151204',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147679,593,'Seda Singh Wala B.O','151205',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147680,593,'Sibian B.O','151207',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147681,593,'Sikhanwala B.O','151209',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147682,593,'Sukhan Wala B.O','151213',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147683,593,'Tehna B.O','151213',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147684,593,'Wandar B.O','151208',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147685,593,'Wandar Jatana B.O','151209',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147686,593,'Wara Bhai Ka B.O','151205',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147687,593,'Wara Daraka B.O','151209',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147688,594,'Bilaspur B.O','141421',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147689,594,'Adampur B.O','140406',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147690,594,'Amloh S.O','147203',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147691,594,'Badali Ala Singh B.O','140406',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147692,594,'Badochikalan B.O','140405',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147693,594,'Balhari Kalan B.O','140406',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147694,594,'Bassi S.O (Fatehgarh Sahib)','140412',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147695,594,'Bhamarsibuland B.O','140405',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147696,594,'Bhari S.O','141411',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147697,594,'Buras B.O','140602',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147698,594,'Chari B.O','141801',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147699,594,'Chunni Kalan B.O','140406',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147700,594,'Dhangerian B.O','140406',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147701,594,'Dhundan B.O','140412',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147702,594,'Fatehgarh Niwan B.O','141411',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147703,594,'Fatehgarh Sahib S.O','140407',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147704,594,'Ghumandgarhj B.O','140412',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147705,594,'Hargana B.O','141411',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147706,594,'Harlalpur B.O','140406',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147707,594,'Jallah B.O','140405',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147708,594,'Jatana Ucha B.O','141801',1,0,'2022-03-04 19:36:28','2022-03-04 19:36:28'),(147709,594,'Khalaspur B.O','140412',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147710,594,'Khamano Kalan S.O','141801',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147711,594,'Khera B.O','140406',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147712,594,'Kheri Noudh Singh B.O','141411',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147713,594,'Kotla Ajner B.O','141411',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147714,594,'Kotla Badla B.O','141411',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147715,594,'Kumbh B.O','147301',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147716,594,'Lataur B.O','140406',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147717,594,'Lohar Majra Kalan B.O','141411',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147718,594,'Malkomajra B.O','140406',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147719,594,'Mandigobindgarh It S.O','147301',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147720,594,'Mandigobindgarh S.O','147301',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147721,594,'Mannupur B.O','140406',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147722,594,'Mulanpur Kalan B.O','140405',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147723,594,'Nabipur B.O','140406',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147724,594,'Nandpur Kalaur B.O','140412',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147725,594,'Nogawan B.O','140417',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147726,594,'Pamaur B.O','140406',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147727,594,'Pharaur B.O','141801',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147728,594,'Rajindergarh B.O','140406',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147729,594,'Reona Ucha B.O','140406',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147730,594,'RR Sirhind S.O','140406',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147731,594,'Rupalheri B.O','140406',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147732,594,'Sadhugarh B.O','140406',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147733,594,'Saidpura B.O','140406',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147734,594,'Sainipur B.O','140405',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147735,594,'Salana B.O','147301',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147736,594,'Sangatpur Sodhian S.O','140405',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147737,594,'Sanghol S.O','140802',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147738,594,'Shahpur B.O','147301',1,0,'2022-03-04 19:36:29','2022-03-04 19:36:29'),(147739,594,'Shamaspur Singhan B.O','141801',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147740,594,'Sirhind City S.O','140406',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147741,594,'Sirhind S.O','140406',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147742,594,'Talania B.O','140406',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147743,595,'Sitto S.O','152118',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147744,596,'Abohar Mandi S.O','152116',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147745,596,'Abohar S.O','152116',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147746,596,'Ahmad Dhandi B.O','152022',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147747,596,'Alamgarh B.O','152116',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147748,596,'Amir Khas B.O','152024',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147749,596,'Arif Ke B.O','152021',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147750,596,'Arniwala Sheikh Subhan S.O','152124',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147751,596,'Aslamwala B.O','152124',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147752,596,'Azamwala B.O','152121',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147753,596,'Bagge Ke Uttar B.O','152024',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147754,596,'Bahadur Khera B.O','152117',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147755,596,'Bahamni Wala B.O','152024',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147756,596,'Bahawal Bassi B.O','152117',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147757,596,'Bakainwala B.O','152128',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147758,596,'Balluana S.O','152117',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147759,596,'Bare Ke B.O','152002',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147760,596,'Bazidpur B.O','152004',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147761,596,'Bazidpur Bhooma B.O','152116',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147762,596,'Bazidpur Kattianwali B.O','152122',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147763,596,'Behak B.O','152123',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147764,596,'Behak Gujjaran B.O','142044',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147765,596,'Bhagoo B.O','152116',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147766,596,'Bhangali Kalan B.O','142052',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147767,596,'Bhangar Khera B.O','152132',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147768,596,'Bhanger B.O','142052',1,0,'2022-03-04 19:36:30','2022-03-04 19:36:30'),(147769,596,'Bharana B.O','152005',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147770,596,'Bhinder S.O (Firozpur)','142041',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147771,596,'Bhungal B.O','152117',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147772,596,'Bsf Campus Chak Araian B.O','152024',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147773,596,'Burj Mohar B.O','152116',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147774,596,'Canal Colony Ferozepur S.O','152003',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147775,596,'Cantt Railway Station Ferozepu S.O','152001',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147776,596,'Chak Badhoke B.O','152033',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147777,596,'Chak Banwala B.O','152123',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147778,596,'Chak Gulam Rasool Wala B.O','152024',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147779,596,'Chak Haraj B.O','152002',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147780,596,'Chak Janisar B.O','152033',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147781,596,'Chak Kherewala B.O','152033',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147782,596,'Chak Mahantan Wala B.O','152022',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147783,596,'Chak Saidoke B.O','152024',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147784,596,'Chak Sotrian B.O','152123',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147785,596,'Chanan Khera B.O','152117',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147786,596,'Chhanga Khurd B.O','152023',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147787,596,'Chhanga Rai Uttar B.O','152022',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147788,596,'Chimnewala B.O','152123',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147789,596,'Chowk Arya Samaj Ferozepur S.O','152002',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147790,596,'Chuchak Wind B.O','142047',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147791,596,'Chugatte Wala B.O','152005',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147792,596,'Churiwala Dhanna B.O','152122',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147793,596,'Dabwala Kalan B.O','152124',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147794,596,'Dalmir Khera B.O','152132',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147795,596,'Danewala B.O','152128',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147796,596,'Danger Khera B.O','152122',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147797,596,'Dastul Sahib B.O','152004',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147798,596,'Datta B.O','142041',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147799,596,'Dhab Kokerian B.O','152117',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147800,596,'Dhandian B.O','142047',1,0,'2022-03-04 19:36:31','2022-03-04 19:36:31'),(147801,596,'Dhanna Shahid B.O','142050',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147802,596,'Dharampura B.O','152128',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147803,596,'Dharangwala B.O','152122',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147804,596,'Dhigan Wali B.O','152132',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147805,596,'Dhindsa B.O','142052',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147806,596,'Dhippanwali B.O','152124',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147807,596,'Dhira Patra B.O','152003',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147808,596,'Diwan Khera B.O','152128',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147809,596,'Dod R.S. B.O','152002',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147810,596,'Dodewala B.O','152116',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147811,596,'Dulchike B.O','152002',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147812,596,'Dutaran Wala B.O','152116',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147813,596,'Faridewala B.O','152005',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147814,596,'Fatehgarh Sabrah B.O','142044',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147815,596,'Fatttuwala B.O','152003',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147816,596,'Fazilka S.O','152123',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147817,596,'Ferozepur City S.O','152002',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147818,596,'Ferozepur H.O','152001',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147819,596,'Ferozeshah S.O','142052',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147820,596,'Gaddan Dob B.O','152117',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147821,596,'Gandhi Nagar Fazilka S.O','152123',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147822,596,'Ghall Khurd B.O','142052',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147823,596,'Ghallu B.O','152122',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147824,596,'Ghattianwali Jattan B.O','152124',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147825,596,'Ghubaya B.O','152024',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147826,596,'Giddranwali B.O','152132',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147827,596,'Gill B.O','142060',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147828,596,'Gobindgarh B.O','152117',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147829,596,'Govt Seed Form B.O','152116',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147830,596,'Guddar Dhandi B.O','152022',1,0,'2022-03-04 19:36:32','2022-03-04 19:36:32'),(147831,596,'Gumjal B.O','152132',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147832,596,'Guruharsahai S.O','152022',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147833,596,'Haraj B.O','142050',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147834,596,'Haripura B.O','152128',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147835,596,'Hasta Kalan B.O','152123',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147836,596,'Hazara Singh Wala B.O','152023',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147837,596,'Himatpura B.O','152116',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147838,596,'Itanwali B.O','142052',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147839,596,'Jalalabad (T) S.O','152024',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147840,596,'Jalalabad (W) S.O','152024',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147841,596,'Jandwala B.O','152123',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147842,596,'Jandwala B.O','152022',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147843,596,'Jandwala Bhimeshah B.O','152124',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147844,596,'Jandwala Hanumanta B.O','152132',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147845,596,'Jandwala Mira Sangla B.O','152128',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147846,596,'Jaurki Andhewali B.O','152123',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147847,596,'Jhanda Bagga Purana B.O','152028',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147848,596,'Jhariwala B.O','152022',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147849,596,'Jhatre B.O','152028',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147850,596,'Jhok Tehal Singh B.O','152002',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147851,596,'Jhoke Harihar B.O','152003',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147852,596,'Jhottianwali B.O','152124',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147853,596,'Jhummianwali B.O','152122',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147854,596,'Jhurar Khera B.O','152116',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147855,596,'Jiwan Araian B.O','152024',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147856,596,'Jodhpur B.O','152117',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147857,596,'Kabbar Wacha B.O','142060',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147858,596,'Kamal Wala B.O','152021',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147859,596,'Kamal Wala B.O','152121',1,0,'2022-03-04 19:36:33','2022-03-04 19:36:33'),(147860,596,'Kandhwala Amarkot B.O','152124',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147861,596,'Kandwala Amarkot B.O','152116',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147862,596,'Karma B.O','152023',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147863,596,'Karmuwala B.O','142052',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147864,596,'Karni Khera B.O','152123',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147865,596,'Kassoana B.O','142050',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147866,596,'Katehra B.O','152121',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147867,596,'Kera Khera B.O','152117',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147868,596,'Khai Pheme Ki B.O','152003',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147869,596,'Khairpur B.O','152116',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147870,596,'Kheowali Dhab B.O','152121',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147871,596,'Khippanwali B.O','152121',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147872,596,'Khosa Dal Singh B.O','152005',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147873,596,'Khuban B.O','152116',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147874,596,'Khui Khera S.O','152121',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147875,596,'Khuiyan Server S.O','152128',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147876,596,'Khunder Uttar B.O','152023',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147877,596,'Khuranj B.O','152033',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147878,596,'Kikar Khera B.O','152116',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147879,596,'Killianwali B.O','152128',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147880,596,'Kirianwali B.O','152123',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147881,596,'Kohar Singh Wala B.O','152002',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147882,596,'Kohrianwali B.O','152122',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147883,596,'Koil Khera B.O','152128',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147884,596,'Kokri Wehniwal B.O','142041',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147885,596,'Kot Karor Kalan B.O','142060',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147886,596,'Krishna Nagari Abohar S.O','152116',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147887,596,'Kular B.O','152116',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147888,596,'Kundal B.O','152117',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147889,596,'Ladhuka B.O','152123',1,0,'2022-03-04 19:36:34','2022-03-04 19:36:34'),(147890,596,'Ladhuwala Uttar B.O','152024',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147891,596,'Lakho Ke Behram B.O','152023',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147892,596,'Lalle B.O','142050',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147893,596,'Lamochar Kalan B.O','152024',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147894,596,'Loham B.O','142060',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147895,596,'Lohgarh Thakran B.O','152005',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147896,596,'Longodeva B.O','152028',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147897,596,'Machhi Bugra B.O','142052',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147898,596,'Mahalam B.O','152002',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147899,596,'Mahianwala Kalan B.O','142047',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147900,596,'Mahuana Bodla B.O','152124',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147901,596,'Makhu Canal Colony B.O','142044',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147902,596,'Makhu S.O','142044',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147903,596,'Mallanwala S.O','152021',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147904,596,'Malloke B.O','142047',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147905,596,'Mallukpur B.O','152117',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147906,596,'Malluwalia Wala B.O','152021',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147907,596,'Mamdot S.O','152023',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147908,596,'Mamu Khera B.O','152121',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147909,596,'Mana Singh Wala B.O','142052',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147910,596,'Manawan S.O','152028',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147911,596,'Mandi Amin Ganj S.O','152033',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147912,596,'Mandi Ladhuka B.O','152123',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147913,596,'Mansoor Deva B.O','152028',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147914,596,'Markhai B.O','142047',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147915,596,'Maste Ke B.O','152002',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147916,596,'Maujgarh S.O','152132',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147917,596,'Mauzam B.O','152123',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147918,596,'Mehar Singh Wala B.O','142047',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147919,596,'Mehma B.O','152002',1,0,'2022-03-04 19:36:35','2022-03-04 19:36:35'),(147920,596,'Mehrana B.O','152116',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147921,596,'Mudki S.O','142060',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147922,596,'Mullianwali B.O','152124',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147923,596,'Muradwala Dal Singh B.O','152122',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147924,596,'Nai Abadi Abohar S.O','152116',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147925,596,'New Grain Market Abohar S.O','152116',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147926,596,'Nihal Khera S.O','152122',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147927,596,'Nukerian B.O','152033',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147928,596,'Nurpur Sethan B.O','152004',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147929,596,'Pakka Kale Wala B.O','152024',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147930,596,'Pakkan B.O','152124',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147931,596,'Palla Megha B.O','152002',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147932,596,'Pandori Khatrian B.O','142050',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147933,596,'Panjawan Mandal B.O','152132',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147934,596,'Panje Ke Uttar B.O','152024',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147935,596,'Panjkosi B.O','152128',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147936,596,'Panniwala Mohala B.O','152132',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147937,596,'Patel Nagar B.O','152004',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147938,596,'Patrewala B.O','152128',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147939,596,'Patti Sadiq B.O','152116',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147940,596,'Pheroke B.O','142047',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147941,596,'Piareana B.O','142052',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147942,596,'Pindi B.O','152022',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147943,596,'Pir Mohamad B.O','142044',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147944,596,'Raipura B.O','152116',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147945,596,'Rajanwali B.O','152116',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147946,596,'Rajpura B.O','152116',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147947,596,'Ramgarh B.O','152117',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147948,596,'Rampura B.O','152116',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147949,596,'Ramsara B.O','152116',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147950,596,'Rana B.O','152123',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147951,596,'Ratta Khera B.O','152033',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147952,596,'Ratta Khera Pb. Singh B.O','142052',1,0,'2022-03-04 19:36:36','2022-03-04 19:36:36'),(147953,596,'Roharian Wali B.O','152122',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147954,596,'Roop Nagar B.O','152128',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147955,596,'Rukanpura B.O','152116',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147956,596,'Rukna Begu B.O','152004',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147957,596,'Rukne Wala B.O','152021',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147958,596,'S.B.S Engg Colleger Ferozpeur S.O','152004',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147959,596,'Sabuana B.O','152123',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147960,596,'Sabzi Mandi Ferozepur City S.O','152002',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147961,596,'Sadar Bazar S.O (Firozpur)','152001',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147962,596,'Saidanwala B.O','152004',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147963,596,'Sandhe Hasham B.O','152005',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147964,596,'Sanehar B.O','152028',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147965,596,'Santuwala B.O','142047',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147966,596,'Sappanwali B.O','152128',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147967,596,'Sardarpura B.O','152116',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147968,596,'Sarhali B.O','142044',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147969,596,'Sayadwala B.O','152128',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147970,596,'Sayianwala B.O','152004',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147971,596,'Sekhwan B.O','142050',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147972,596,'Shah Abu Bakkar B.O','142043',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147973,596,'Shahwala B.O','142047',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147974,596,'Shahzadi B.O','142052',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147975,596,'Shajrana B.O','152121',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147976,596,'Shakur B.O','142052',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147977,596,'Sharienwala B.O','152022',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147978,596,'Shatirwala B.O','152121',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147979,596,'Shazada Sant Singh B.O','142047',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147980,596,'Sherewala B.O','152116',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147981,596,'Shergarh B.O','152132',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147982,596,'Sherkhan Wala S.O','152005',1,0,'2022-03-04 19:36:37','2022-03-04 19:36:37'),(147983,596,'Shianpari B.O','142044',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(147984,596,'Sitto Gunno B.O','152116',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(147985,596,'Sodhi Nagar B.O','152005',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(147986,596,'Sodhiwala B.O','142050',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(147987,596,'Sohangarh Thakkran B.O','152022',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(147988,596,'Sudh Singh Wala B.O','152021',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(147989,596,'Sukhewala B.O','152028',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(147990,596,'Sulhani B.O','142050',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(147991,596,'Tahliwal Bodla B.O','152124',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(147992,596,'Tahliwala Jattan B.O','152124',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(147993,596,'Talwandi Bhai S.O','142050',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(147994,596,'Talwandi Jallekhan B.O','152028',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(147995,596,'Talwandi Mallian B.O','142041',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(147996,596,'Thatha Kishan Singh B.O','142047',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(147997,596,'Thethar Kalan B.O','142052',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(147998,596,'Tibbi Khurd B.O','152023',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(147999,596,'Toot B.O','152004',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(148000,596,'Tootwala B.O','152132',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(148001,596,'Tumber Bhan B.O','142050',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(148002,596,'Usman Khera B.O','152132',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(148003,596,'Valtoha B.O','142047',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(148004,596,'Wahabwala B.O','152116',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(148005,596,'Wakilanwali B.O','142047',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(148006,596,'Wara Bhai Ka B.O','142052',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(148007,596,'Wara Waryam Singh B.O','142050',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(148008,596,'Waryam Khera B.O','152116',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(148009,596,'Zira S.O','142047',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(148010,597,'Abrol Nagar Pathankot S.O','145001',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(148011,597,'Akarpura B.O','143511',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(148012,597,'Aliwal S.O','143507',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(148013,597,'Alma B.O','143517',1,0,'2022-03-04 19:36:38','2022-03-04 19:36:38'),(148014,597,'Athwal B.O','143511',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148015,597,'Aulakh Kalan B.O','143527',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148016,597,'Awankha B.O','143531',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148017,597,'Babehali B.O','143530',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148018,597,'Babri B.O','143529',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148019,597,'Babri Jiwan Wal B.O','143520',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148020,597,'Badhani B.O','145001',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148021,597,'Bahadurpur Rajoa B.O','143527',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148022,597,'Baknaur B.O','143534',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148023,597,'Ballarwal7 B.O','143515',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148024,597,'Balpurian B.O','143507',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148025,597,'Barila Kalan B.O','143512',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148026,597,'Basrai B.O','143527',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148027,597,'Batala City S.O','143505',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148028,597,'Batala H.O','143505',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148029,597,'Batala Sugar Mills B.O','143506',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148030,597,'Beacon Pathankot S.O','145001',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148031,597,'Behrampur S.O','143532',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148032,597,'Beri B.O','143527',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148033,597,'Bhabber B.O','145023',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148034,597,'Bhadal B.O','143511',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148035,597,'Bhagowal S.O','143511',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148036,597,'Bhagthana Tulian B.O','143604',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148037,597,'Bhaini Mian Khan B.O','143517',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148038,597,'Bham B.O','143527',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148039,597,'Bhambri B.O','143527',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148040,597,'Bhangowani B.O','143511',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148041,597,'Bhanguri B.O','145022',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148042,597,'Bharath B.O','143532',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148043,597,'Bharath B.O','143527',1,0,'2022-03-04 19:36:39','2022-03-04 19:36:39'),(148044,597,'Bharial B.O','143525',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148045,597,'Bharoli B.O','145025',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148046,597,'Bhatoya B.O','143531',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148047,597,'Bhattian S.O','143517',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148048,597,'Bhattwan B.O','145022',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148049,597,'Bhoa B.O','145025',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148050,597,'Bhole Ke B.O','143513',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148051,597,'Bhoman B.O','143514',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148052,597,'Bhopar Saidan B.O','143520',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148053,597,'Bhullar B.O','143511',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148054,597,'Bhumbli B.O','143529',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148055,597,'Bianpur-e B.O','143533',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148056,597,'Bishankot B.O','143512',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148057,597,'Bolewal B.O','143514',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148058,597,'Buchenangal B.O','143512',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148059,597,'Chahal B.O','143506',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148060,597,'Chak Sharif B.O','143528',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148061,597,'Chakkar B.O','145001',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148062,597,'Chashma B.O','145025',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148063,597,'Chaudhriwal B.O','143506',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148064,597,'Chaunta B.O','143533',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148065,597,'Cheema Khudi B.O','143515',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148066,597,'Chhalle B.O','143530',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148067,597,'Chone B.O','143514',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148068,597,'Chore Sidhwan B.O','143520',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148069,597,'Civil Court Pathankot S.O','145001',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148070,597,'Dabhanwala Kalan B.O','143507',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148071,597,'Dadiala B.O','143506',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148072,597,'Dadiala Natt B.O','143507',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148073,597,'Dakoha B.O','143514',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148074,597,'Dalam B.O','143511',1,0,'2022-03-04 19:36:40','2022-03-04 19:36:40'),(148075,597,'Dalelpur B.O','143512',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148076,597,'Dalhousie Road Pathankot S.O','145001',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148077,597,'Dalla Chak B.O','143513',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148078,597,'Dargabad B.O','143511',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148079,597,'Datial B.O','145026',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148080,597,'Dehriwal B.O','143518',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148081,597,'Dera Baba Nanak S.O','143604',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148082,597,'Dhaki Road Pathankot S.O','145001',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148083,597,'Dhandal B.O','143516',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148084,597,'Dhangu Road Pathankot S.O','145001',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148085,597,'Dhapai B.O','143516',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148086,597,'Dharamkot Bagga B.O','143511',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148087,597,'Dharamkot Randhawa B.O','143604',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148088,597,'Dhariwal S.O','143519',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148089,597,'Dharkalan B.O','145001',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148090,597,'Dharowali B.O','143605',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148091,597,'Dhianpur S.O','143605',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148092,597,'Dholowal B.O','143531',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148093,597,'Dial Garh B.O','143518',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148094,597,'Dinanagar S.O','143531',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148095,597,'Dodwan B.O','143532',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148096,597,'Dorangla S.O','143526',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148097,597,'Dostpur B.O','143526',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148098,597,'Dugri B.O','143526',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148099,597,'Farida Nagar B.O','145025',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148100,597,'Fateh Nangal B.O','143519',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148101,597,'Fatehgarh Churian S.O','143602',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148102,597,'Fatehpur B.O','145026',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148103,597,'Fattupur B.O','143512',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148104,597,'Fazlabad B.O','143511',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148105,597,'Fazula Chak B.O','143518',1,0,'2022-03-04 19:36:41','2022-03-04 19:36:41'),(148106,597,'Ferozepur Kalan B.O','145023',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148107,597,'G S T C Batala B.O','143506',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148108,597,'Gagowali B.O','143511',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148109,597,'Galhri B.O','143526',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148110,597,'Gazikot B.O','143530',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148111,597,'Gaznipur -e B.O','143520',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148112,597,'Ghanie Ke Banger B.O','143513',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148113,597,'Ghiala B.O','145101',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148114,597,'Gho B.O','145023',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148115,597,'Ghoga B.O','143507',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148116,597,'Ghoman S.O','143514',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148117,597,'Ghorewah B.O','143517',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148118,597,'Ghot B.O','143530',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148119,597,'Ghuman Kalan B.O','143518',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148120,597,'Govt. Poly. Tech Batala S.O','143506',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148121,597,'Gujjarpura B.O','143507',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148122,597,'Gurdas Nangal B.O','143520',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148123,597,'Gurdaspur H.O','143521',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148124,597,'Gurdaspur Kutchery S.O','143521',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148125,597,'Gurrah B.O','145101',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148126,597,'Guru Nanak Nagar S.O (Gurdaspur)','143505',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148127,597,'Habit Pindi -e B.O','143525',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148128,597,'Hakimpur B.O','143511',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148129,597,'Hara B.O','145001',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148130,597,'Harchowal S.O','143527',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148131,597,'Hardo Chhani B.O','143526',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148132,597,'Hardo Jhande B.O','143507',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148133,597,'Hardorwal B.O','143602',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148134,597,'Harpura Dhandoi B.O','143506',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148135,597,'Haruwal -e B.O','143604',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148136,597,'Haryal B.O','145001',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148137,597,'Hayat Nagar B.O','143520',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148138,597,'Hemrajpur B.O','143526',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148139,597,'Islampur B.O','143526',1,0,'2022-03-04 19:36:42','2022-03-04 19:36:42'),(148140,597,'Jagowal Bet B.O','143528',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148141,597,'Jaito Sarja B.O','143506',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148142,597,'Jandwal B.O','145001',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148143,597,'Jangal B.O','143531',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148144,597,'Janial B.O','145027',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148145,597,'Jaura Chhattran B.O','143520',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148146,597,'Jaura Singha B.O','143511',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148147,597,'Jhabkra B.O','143525',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148148,597,'Jhakholari B.O','145025',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148149,597,'Jharoli B.O','143533',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148150,597,'Kahnuwan S.O','143528',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148151,597,'Kala Afgana S.O','143513',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148152,597,'Kala Bala -e B.O','143528',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148153,597,'Kalanaur S.O (Gurdaspur)','143512',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148154,597,'Kaler Kalan B.O','143519',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148155,597,'Kalichpur-e B.O','143531',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148156,597,'Kalyanpur B.O','143519',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148157,597,'Kandila B.O','143516',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148158,597,'Karoli B.O','145001',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148159,597,'Kastiwal B.O','143507',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148160,597,'Kathlaur B.O','143534',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148161,597,'Kaunterpur B.O','145101',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148162,597,'Khaira B.O','143602',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148163,597,'Khanpur Chowk Pathankot S.O','145001',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148164,597,'Khojala B.O','143516',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148165,597,'Khojeke Chak B.O','145027',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148166,597,'Khojepur B.O','143530',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148167,597,'Khokhar Faujjian B.O','143518',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148168,597,'Khunda B.O','143519',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148169,597,'Khushalpur B.O','143604',1,0,'2022-03-04 19:36:43','2022-03-04 19:36:43'),(148170,597,'Kiri Khurd B.O','145025',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148171,597,'Kishankot B.O','143515',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148172,597,'Kot B.O','145029',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148173,597,'Kot Santokh Rai B.O','143519',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148174,597,'Kot Todarmal B.O','143516',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148175,597,'Kotli Harchandan B.O','143517',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148176,597,'Kotli Sainian B.O','143530',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148177,597,'Kotli Surat Malhi B.O','143605',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148178,597,'Krishna Nagar Batala S.O','143505',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148179,597,'Ladha Mundha B.O','143514',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148180,597,'Lahri Gujran B.O','143534',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148181,597,'Lakhan Kalan B.O','143512',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148182,597,'Lakhanpal B.O','143530',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148183,597,'Langah B.O','143519',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148184,597,'Leel Kalan B.O','143516',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148185,597,'Lehroon B.O','145022',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148186,597,'Machrai B.O','143515',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148187,597,'Magar Mudian B.O','143526',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148188,597,'Mamoon B.O','145001',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148189,597,'Man B.O','143602',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148190,597,'Marar B.O','143507',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148191,597,'Marara S.O','143525',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148192,597,'Mari Buchian B.O','143515',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148193,597,'Mari Panwan B.O','143515',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148194,597,'Mari Tanda B.O','143515',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148195,597,'Marrianwala B.O','143506',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148196,597,'Marrianwala B.O','143519',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148197,597,'Massania B.O','143506',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148198,597,'Mirzajan B.O','143511',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148199,597,'Mission Road Pathankot S.O','145001',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148200,597,'Mullanwal B.O','143517',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148201,597,'Nainakot B.O','143528',1,0,'2022-03-04 19:36:44','2022-03-04 19:36:44'),(148202,597,'Nangal B.O','145101',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148203,597,'Nanowal Jinder B.O','143517',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148204,597,'Narangpur B.O','145025',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148205,597,'Narot Mehra B.O','145025',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148206,597,'Nasarke B.O','143602',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148207,597,'Naushehra Nal Bandan B.O','145025',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148208,597,'Naushera Majja Singh S.O','143518',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148209,597,'Nehru Gate Batala S.O','143505',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148210,597,'Padhe B.O','143514',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148211,597,'Pakhariwal B.O','143520',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148212,597,'Pakiwan B.O','143604',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148213,597,'Pandori Bainsan B.O','143531',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148214,597,'Paniar B.O','143531',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148215,597,'Panjgarian B.O','143506',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148216,597,'Paracha B.O','143602',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148217,597,'Parmanand B.O','143534',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148218,597,'Parowal B.O','143602',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148219,597,'Passanwal B.O','143518',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148220,597,'Pathankot S.O','145001',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148221,597,'Pindarori B.O','143527',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148222,597,'Pinjore B.O','145023',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148223,597,'Qadian S.O','143516',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148224,597,'Qila Lal Singh B.O','143511',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148225,597,'Rai Chak B.O','143511',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148226,597,'Raimal B.O','143605',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148227,597,'Rajeke B.O','143513',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148228,597,'Ranger Nangal B.O','143506',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148229,597,'Ranipur B.O','145023',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148230,597,'Rattangarh B.O','143534',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148231,597,'Riali B.O','143507',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148232,597,'Sahaura Khurd B.O','143534',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148233,597,'Sahowal B.O','143531',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148234,597,'Saidipur B.O','143534',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148235,597,'Saidowal Kalan B.O','143530',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148236,597,'Saidowal Khurd B.O','143528',1,0,'2022-03-04 19:36:45','2022-03-04 19:36:45'),(148237,597,'Sale Chak B.O','143526',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148238,597,'Samrai B.O','143602',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148239,597,'Sarchur B.O','143602',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148240,597,'Sarna B.O','145025',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148241,597,'Sarti B.O','145022',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148242,597,'Sarupwali B.O','143507',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148243,597,'Sarwali B.O','143511',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148244,597,'Satkoha B.O','143518',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148245,597,'Seikhwan B.O','143518',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148246,597,'Shahpur Goraya B.O','143604',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148247,597,'Shahpur Jajan B.O','143604',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148248,597,'Shahpur Kandi B.O','145029',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148249,597,'Shahzada B.O','143604',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148250,597,'Shankarpura B.O','143507',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148251,597,'Shikar B.O','143605',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148252,597,'Sidhwan B.O','143529',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148253,597,'Singhpura B.O','143604',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148254,597,'Siray B.O','143513',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148255,597,'Sohal S.O','143520',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148256,597,'Srihargobindpur S.O','143515',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148257,597,'Sunder Chak B.O','145025',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148258,597,'Syonti B.O','145001',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148259,597,'Talibpur Pandori B.O','143531',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148260,597,'Talwandi Lal Singh B.O','143507',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148261,597,'Talwandi Rama B.O','143604',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148262,597,'Teja Kalan B.O','143513',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148263,597,'Tharial B.O','145024',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148264,597,'Tibber S.O','143529',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148265,597,'Tibri S.O','143530',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148266,597,'Trihari B.O','145001',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148267,597,'Tugalwala B.O','143527',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148268,597,'Uchathara B.O','145001',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148269,597,'Udhanwal B.O','143506',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148270,597,'Udhowali Khurd B.O','143604',1,0,'2022-03-04 19:36:46','2022-03-04 19:36:46'),(148271,597,'Villa Baijju B.O','143514',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148272,597,'Villa Teja B.O','143513',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148273,597,'Wadala Banger B.O','143511',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148274,597,'Wadala Granthia B.O','143506',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148275,597,'Zaffarwal B.O','143519',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148276,598,'Abdulapur B.O','144214',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148277,598,'Adamwal B.O','146024',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148278,598,'Ahrana Klaln B.O','146112',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148279,598,'Aiman Jattan B.O','144520',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148280,598,'Ajnoha S.O','144404',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148281,598,'Ajram B.O','146111',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148282,598,'Alampur B.O','144202',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148283,598,'Ambala Jattan B.O','144207',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148284,598,'Amroh B.O','144224',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148285,598,'Argowal B.O','144207',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148286,598,'Attowal B.O','146111',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148287,598,'Bachhohi B.O','146102',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148288,598,'Baddon S.O','144406',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148289,598,'Badesron B.O','144528',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148290,598,'Badla B.O','144223',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148291,598,'Badla B.O','146112',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148292,598,'Badla Mahi B.O','144105',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148293,598,'Baghpur B.O','144208',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148294,598,'Bagowal B.O','144522',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148295,598,'Bahadarpur Bahian B.O','146102',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148296,598,'Bahadurpur Chowk S.O','146001',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148297,598,'Bahera B.O','144206',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148298,598,'Bahowal B.O','146105',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148299,598,'Bahtiwal B.O','144207',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148300,598,'Baich B.O','144204',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148301,598,'Bains Awan B.O','144202',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148302,598,'Bainstani Kalan B.O','144105',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148303,598,'Baja Chak B.O','144214',1,0,'2022-03-04 19:36:47','2022-03-04 19:36:47'),(148304,598,'Bajrawar B.O','146104',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148305,598,'Bajwara S.O','146023',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148306,598,'Barian  Kalan S.O','146101',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148307,598,'Bariana B.O','144208',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148308,598,'Bariowal B.O','144306',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148309,598,'Basiala B.O','144527',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148310,598,'Bassi Ballo B.O','144208',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148311,598,'Bassi Daulat Khan B.O','146111',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148312,598,'Bassi Gulam Hussain B.O','146021',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148313,598,'Bassi Jalal Khan B.O','144204',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148314,598,'Bassi Kalan S.O','146102',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148315,598,'Bassi Purani B.O','146021',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148316,598,'Bassi Wazid B.O','144208',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148317,598,'Bathian Brahmnan B.O','146111',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148318,598,'Behbalmanj B.O','144306',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148319,598,'Behbalpur B.O','144519',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148320,598,'Behkushala B.O','144223',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148321,598,'Behlakhan B.O','144223',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148322,598,'Berchha B.O','144305',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148323,598,'Bhagowal B.O','146113',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148324,598,'Bhagowal B.O','146024',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148325,598,'Bhagran B.O','144221',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148326,598,'Bham S.O','146103',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148327,598,'Bhambotar S.O','144224',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148328,598,'Bhana B.O','144207',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148329,598,'Bhangala S.O','144306',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148330,598,'Bhanowal S.O','144213',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148331,598,'Bharowal B.O','144529',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148332,598,'Bharwain Road S.O','146001',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148333,598,'Bhater B.O','144224',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148334,598,'Bhatrana B.O','146111',1,0,'2022-03-04 19:36:48','2022-03-04 19:36:48'),(148335,598,'Bhavnaur B.O','144224',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148336,598,'Bhawanipur B.O','144523',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148337,598,'Bhikhowal B.O','144208',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148338,598,'Bhilowal B.O','146104',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148339,598,'Bhunga S.O','144210',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148340,598,'Bhungarani B.O','146112',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148341,598,'Bihala S.O','146104',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148342,598,'Binewal S.O','144523',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148343,598,'Binjon S.O','144520',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148344,598,'Birampur B.O','144528',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148345,598,'Bodal Garna Sahib B.O','144305',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148346,598,'Bohan B.O','146104',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148347,598,'Bombeli B.O','146101',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148348,598,'Bora B.O','144527',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148349,598,'Bringali B.O','144224',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148350,598,'Budhabar B.O','144221',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148351,598,'Budhipind S.O','144212',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148352,598,'Bulhowal S.O','146113',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148353,598,'Chabbewal B.O','146102',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148354,598,'Chagran B.O','146023',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148355,598,'Chak Ladhian B.O','144210',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148356,598,'Chak Sadu B.O','146110',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148357,598,'Chak Singha B.O','144532',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148358,598,'Chang Basoa B.O','144207',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148359,598,'Changala B.O','144214',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148360,598,'Channaur B.O','144306',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148361,598,'Chathial Khurd B.O','144207',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148362,598,'Chautala B.O','144210',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148363,598,'Chipra B.O','144207',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148364,598,'Chohal B.O','146024',1,0,'2022-03-04 19:36:49','2022-03-04 19:36:49'),(148365,598,'Chowki Patiari B.O','144209',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148366,598,'Dada B.O','146021',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148367,598,'Daddar B.O','144221',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148368,598,'Dadial B.O','144223',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148369,598,'Dadupur Garoa B.O','144105',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148370,598,'Dadyal B.O','144529',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148371,598,'Daffar B.O','144207',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148372,598,'Dagana Kalan B.O','146022',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148373,598,'Dagon B.O','144221',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148374,598,'Dandoh B.O','144209',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148375,598,'Darapur B.O','144210',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148376,598,'Dasuya H.O','144205',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148377,598,'Datarpur S.O','144222',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148378,598,'Degham B.O','144527',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148379,598,'Denowal Kalan B.O','144527',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148380,598,'Deopur B.O','144222',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148381,598,'Dhada Kalan B.O','144520',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148382,598,'Dhade Fateh Singh B.O','146113',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148383,598,'Dhakkowal B.O','146111',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148384,598,'Dhamai B.O','144532',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148385,598,'Dhamian B.O','144221',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148386,598,'Dhanoa B.O','144214',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148387,598,'Dharampur B.O','144224',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148388,598,'Dhola Khera B.O','144306',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148389,598,'Dholbaha S.O','144206',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148390,598,'Dhoot Kalan B.O','144210',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148391,598,'Dhugga Kalan B.O','144305',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148392,598,'Dihana B.O','144406',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148393,598,'Factory Area Chohal S.O','146024',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148394,598,'Fateh Pur Khurd B.O','144528',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148395,598,'Fateh Pur Kothi B.O','144530',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148396,598,'Fatehgarh Niara B.O','146022',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148397,598,'Fatehpur B.O','144222',1,0,'2022-03-04 19:36:50','2022-03-04 19:36:50'),(148398,598,'Fatehpur Bhattlan B.O','144213',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148399,598,'Gajjar B.O','144530',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148400,598,'Gandhowal B.O','146109',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148401,598,'Ganeshpur Bharta B.O','146106',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148402,598,'Garhdiwala S.O','144207',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148403,598,'Garhi Mansowal B.O','144523',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148404,598,'Garhshanker S.O','144527',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148405,598,'Gaushala Bazar S.O','146001',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148406,598,'Gera B.O','144221',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148407,598,'Ghagwal B.O','144221',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148408,598,'Ghogra B.O','144221',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148409,598,'Ghorewaha B.O','146116',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148410,598,'Gignowal B.O','146113',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148411,598,'Gobindpur Khun Khun B.O','144208',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148412,598,'Gogon B.O','144527',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148413,598,'Gondpur B.O','146105',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148414,598,'Haibowal B.O','144523',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148415,598,'Hajipur S.O','144221',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148416,598,'Hakumatpur B.O','146107',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148417,598,'Handwal B.O','144222',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148418,598,'Hardo Khund Pur B.O','144306',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148419,598,'Hardo Neknama B.O','144223',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148420,598,'Hardokhanpur B.O','146113',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148421,598,'Hariana S.O','144208',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148422,598,'Harse Mansar B.O','144306',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148423,598,'Harsipind B.O','144212',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148424,598,'Harta B.O','146112',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148425,598,'Hoshiarpur City S.O','146001',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148426,598,'Hoshiarpur H.O','146001',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148427,598,'Hoshiarpur Kalota B.O','144211',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148428,598,'Hukkran B.O','146112',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148429,598,'Hussain Pur Lalowal B.O','144210',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148430,598,'Ibrahimpur B.O','144527',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148431,598,'Jahan Khelan B.O','146110',1,0,'2022-03-04 19:36:51','2022-03-04 19:36:51'),(148432,598,'Jaijon S.O','144530',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148433,598,'Jaja B.O','144212',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148434,598,'Jalalpur B.O','144202',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148435,598,'Jallowal Khanoor B.O','146104',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148436,598,'Jalota B.O','144207',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148437,598,'Janauri S.O','144209',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148438,598,'Jandaur B.O','144207',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148439,598,'Jandiala B.O','146109',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148440,598,'Jandoli B.O','146102',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148441,598,'Jandwal B.O','144306',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148442,598,'Jangliana B.O','146103',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148443,598,'Jassowal B.O','144529',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148444,598,'Jaura B.O','144204',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148445,598,'Jhawan B.O','144212',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148446,598,'Jhingar Kalan B.O','144305',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148447,598,'Jiwanpur Jattan B.O','146109',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148448,598,'Johal B.O','144305',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148449,598,'Kadiana B.O','144105',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148450,598,'Kahri B.O','146111',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148451,598,'Kakkon B.O','144208',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148452,598,'Kalewal B.O','144523',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148453,598,'Kalewal Bhagtan B.O','146102',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148454,598,'Kalubahar B.O','146115',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148455,598,'Kamahi Devi S.O','144223',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148456,598,'Kamalpur S.O (Nawanshahr)','146001',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148457,598,'Kandhala Jattan S.O','146116',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148458,598,'Kandhala Sheikhan B.O','144212',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148459,598,'Kandhali Narangpur B.O','144212',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148460,598,'Karari B.O','144222',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148461,598,'Kathe Adhkare B.O','144105',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148462,598,'Khadiala B.O','146113',1,0,'2022-03-04 19:36:52','2022-03-04 19:36:52'),(148463,598,'Khanaura B.O','144404',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148464,598,'Khanpur B.O','144527',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148465,598,'Khanpur B.O','146114',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148466,598,'Khanpur Latifpur B.O','144211',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148467,598,'Kharar Achharwal B.O','146108',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148468,598,'Kharaudi B.O','146107',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148469,598,'Kharkan Camp B.O','146110',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148470,598,'Khera B.O','146106',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148471,598,'Khiala Bulanda B.O','144210',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148472,598,'Khudda S.O','144305',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148473,598,'Khunkhun Kalan B.O','144305',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148474,598,'Kitna B.O','144531',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148475,598,'Koi B.O','144213',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148476,598,'Kot Abdul Khaliq S.O','146110',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148477,598,'Kotfathui S.O','144519',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148478,598,'Kotlanaudh Singh B.O','144208',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148479,598,'Kotli Khas B.O','144306',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148480,598,'Kotmaira B.O','144523',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148481,598,'Kukanet B.O','144206',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148482,598,'Kukkran B.O','144528',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148483,598,'Kurala Kalan B.O','144204',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148484,598,'Lachowal B.O','146113',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148485,598,'Laksian B.O','146108',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148486,598,'Lalwan B.O','144530',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148487,598,'Lambra Kangri B.O','146113',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148488,598,'Lamin Pandori B.O','144214',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148489,598,'Langeri B.O','146109',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148490,598,'Lehli Kalan B.O','146104',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148491,598,'Mahilpur S.O','146105',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148492,598,'Maili B.O','146102',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148493,598,'Makhsoospur B.O','146108',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148494,598,'Mallewal B.O','144525',1,0,'2022-03-04 19:36:53','2022-03-04 19:36:53'),(148495,598,'Manak Dheri B.O','144204',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148496,598,'Mananhana B.O','144519',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148497,598,'Mand Pandher B.O','144207',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148498,598,'Mandial B.O','144105',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148499,598,'Manguawal Nari B.O','146024',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148500,598,'Manhota B.O','144213',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148501,598,'Manolian B.O','146101',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148502,598,'Mansoorpur B.O','144211',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148503,598,'Maseet Pal Kot B.O','144212',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148504,598,'Mazara Dingrian B.O','146109',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148505,598,'Meghowal B.O','146109',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148506,598,'Meghowal Ganjyan B.O','146022',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148507,598,'Mehand Wani B.O','144523',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148508,598,'Mehatpur Oladini B.O','144521',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148509,598,'Mehlanwali B.O','146110',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148510,598,'Mehngarwal B.O','146024',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148511,598,'Mehngarwal Doaba B.O','146109',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148512,598,'Mehtabpur B.O','144306',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148513,598,'Mehtiana B.O','144404',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148514,598,'Miani S.O','144202',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148515,598,'Mini Sectt S.O','146001',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148516,598,'Model Town S.O (Hoshiarpur)','146001',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148517,598,'Moela Wahidpur B.O','144528',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148518,598,'Mona Klan B.O','146112',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148519,598,'Moranwali S.O','144531',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148520,598,'Muggowal B.O','146109',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148521,598,'Mukerian S.O','144211',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148522,598,'Mukhliana B.O','146112',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148523,598,'Munak Kalan B.O','144204',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148524,598,'Mundian Jattan B.O','146114',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148525,598,'Muradpur Naryal B.O','146116',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148526,598,'Musahibpur B.O','144211',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148527,598,'Mustapur B.O','146024',1,0,'2022-03-04 19:36:54','2022-03-04 19:36:54'),(148528,598,'Mutton B.O','144522',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148529,598,'Nadalon B.O','144404',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148530,598,'Nainowal Jattan B.O','146113',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148531,598,'Nainwan B.O','144523',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148532,598,'Nandachaur S.O','146114',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148533,598,'Nangal Bihalan B.O','144221',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148534,598,'Nangal Kalan S.O','146106',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148535,598,'Nangal Khunga B.O','144212',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148536,598,'Nangal Khurd B.O','146101',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148537,598,'Nangal Shahidan B.O','146023',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148538,598,'Nara B.O','146021',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148539,598,'Narangpur B.O','144223',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148540,598,'Naru Nangal B.O','146102',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148541,598,'Nasrala B.O','146022',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148542,598,'Nathupur B.O','144202',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148543,598,'Naushera Pattan B.O','144211',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148544,598,'Pach Nangal Khushalpur B.O','144519',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148545,598,'Paddi Sura Singh B.O','144529',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148546,598,'Padrana B.O','144528',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148547,598,'Pajjodeotta S.O','146115',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148548,598,'Pakhowal B.O','144528',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148549,598,'Paldi S.O (Hoshiarpur)','146107',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148550,598,'Pandori  Ganga Singh B.O','146108',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148551,598,'Pandori Atwal B.O','144207',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148552,598,'Pandori Bawa Dass B.O','146113',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148553,598,'Pandori Bibi B.O','146112',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148554,598,'Pandori Ladha Singh B.O','144520',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148555,598,'Pandori Phagurian B.O','144105',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148556,598,'Pandori Rajputan B.O','144105',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148557,598,'Pandorikad B.O','146112',1,0,'2022-03-04 19:36:55','2022-03-04 19:36:55'),(148558,598,'Panjaura B.O','144404',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148559,598,'Panwan B.O','144207',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148560,598,'Parika B.O','144211',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148561,598,'Parsowal B.O','146102',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148562,598,'Passi Kandi B.O','144207',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148563,598,'Patial B.O','144209',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148564,598,'Patti B.O','146104',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148565,598,'Phambian B.O','144105',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148566,598,'Phuglana B.O','144404',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148567,598,'Piplanwala S.O','146022',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148568,598,'Possi B.O','144531',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148569,598,'Purhiran S.O','146111',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148570,598,'Railway Road S.O (Hoshiarpur)','146001',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148571,598,'Rajpur Bhayan S.O','146112',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148572,598,'Rajpur Gahot B.O','144212',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148573,598,'Rajwal B.O','144216',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148574,598,'Ram Colony Camp B.O','146023',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148575,598,'Rampur Bilron S.O','144528',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148576,598,'Rampur Haler B.O','144223',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148577,598,'Rampur Jhanjowal B.O','144530',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148578,598,'Ranipind B.O','144202',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148579,598,'Ror Mazara B.O','144527',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148580,598,'Rupowal B.O','144207',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148581,598,'Sadhu Ashram S.O','146021',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148582,598,'Safdarpur B.O','144305',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148583,598,'Saggran B.O','144221',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148584,598,'Sahri B.O','146111',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148585,598,'Saidpur B.O','144204',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148586,598,'Saila Kalan B.O','144529',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148587,598,'Saila Khurd S.O','144529',1,0,'2022-03-04 19:36:56','2022-03-04 19:36:56'),(148588,598,'Sakruli B.O','146109',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148589,598,'Saleempur B.O','146111',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148590,598,'Saleempur B.O','144202',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148591,598,'Saleempur B.O','144528',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148592,598,'Sandhra B.O','144105',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148593,598,'Sandhra Sodhian B.O','144105',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148594,598,'Sango Katrala B.O','144211',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148595,598,'Sansarpur B.O','144213',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148596,598,'Sarangwal B.O','146102',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148597,598,'Sarhala Kalan S.O','146108',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148598,598,'Sarhala Khurd B.O','146108',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148599,598,'Sarhala Mundian B.O','146116',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148600,598,'Sariana B.O','144221',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148601,598,'Sasoli B.O','146104',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148602,598,'Sataur B.O','144208',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148603,598,'Satnaur B.O','144528',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148604,598,'Seeprian B.O','144221',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148605,598,'Sham Chaurasi S.O','144105',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148606,598,'Shergarh B.O','146023',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148607,598,'Sikri B.O','146113',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148608,598,'Singhpur B.O','146102',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148609,598,'Soos B.O','144105',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148610,598,'Suni B.O','144520',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148611,598,'Tahli B.O','144202',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148612,598,'Talwandi Arayan B.O','144105',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148613,598,'Talwandi Dadian B.O','144204',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148614,598,'Talwandi Sallan B.O','144204',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148615,598,'Talwara Township S.O','144216',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148616,598,'Tanda Ram Sahai S.O','144214',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148617,598,'Tanda S.O','144204',1,0,'2022-03-04 19:36:57','2022-03-04 19:36:57'),(148618,598,'Tanuli B.O','146112',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148619,598,'Taragarh B.O','146022',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148620,598,'Terkiana B.O','144214',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148621,598,'Thakrowal B.O','146103',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148622,598,'Thinda B.O','144519',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148623,598,'Thowana B.O','144520',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148624,598,'Todarpur B.O','144404',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148625,598,'Tranglian B.O','144211',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148626,598,'Tuto Mazara S.O','146109',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148627,598,'Umarpur B.O','144214',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148628,598,'Urmar S.O','144204',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148629,598,'Zahura B.O','144204',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148630,599,'Adampur AD S.O','144103',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148631,599,'Adampur Doaba S.O','144102',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148632,599,'Adda Kathar S.O','144106',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148633,599,'Alawalpur S.O (Jalandhar)','144301',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148634,599,'Apra S.O','144416',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148635,599,'Athola B.O','144002',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148636,599,'Atti B.O','144418',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148637,599,'Bal B.O','144012',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148638,599,'Bara Pind S.O','144418',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148639,599,'Basti Bawa Khel S.O','144021',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148640,599,'Basti Danishmandan S.O','144002',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148641,599,'Basti Guzan S.O','144002',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148642,599,'Basti Nau S.O','144002',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148643,599,'Basti Sheikh S.O','144002',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148644,599,'Bazar Nauhrian S.O','144008',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148645,599,'Bazar Shahidan S.O','144001',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148646,599,'Beas Pind S.O','144302',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148647,599,'Behram Sarista B.O','144201',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148648,599,'Bhagat Bazar S.O','144008',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148649,599,'Bhargav Camp S.O','144003',1,0,'2022-03-04 19:36:58','2022-03-04 19:36:58'),(148650,599,'Bharsingpura B.O','144419',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148651,599,'Bhatnura Lubana B.O','144201',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148652,599,'Bhogpur S.O (Jalandhar)','144201',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148653,599,'Bhojowal B.O','144101',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148654,599,'Bikrampura S.O','144008',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148655,599,'Binpalke B.O','144201',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148656,599,'Birbansian B.O','144409',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148657,599,'Bolina Doaba B.O','144101',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148658,599,'BSF Campus S.O','144006',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148659,599,'Budhiana B.O','144025',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148660,599,'Chachrari B.O','144409',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148661,599,'Chak Desraj B.O','144418',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148662,599,'Chamiara B.O','144002',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148663,599,'Charanjitpura S.O','144008',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148664,599,'Chhokran B.O','144029',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148665,599,'Chitti S.O','144028',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148666,599,'Chogitti S.O','144009',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148667,599,'Cholang B.O','144201',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148668,599,'Chuharwali B.O','144102',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148669,599,'Chukhiara B.O','144106',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148670,599,'Civil Secretariate S.O','144002',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148671,599,'D A V  College S.O','144008',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148672,599,'Dakoha S.O','144023',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148673,599,'Damunda B.O','144103',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148674,599,'Daroli Kalan S.O','144104',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148675,599,'Daroli Khurd B.O','144104',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148676,599,'Dayalpur S.O (Jalandhar)','144419',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148677,599,'Dhaleta B.O','144418',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148678,599,'Dhandwar B.O','144502',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148679,599,'Dhanowali S.O','144010',1,0,'2022-03-04 19:36:59','2022-03-04 19:36:59'),(148680,599,'Dhariwal B.O','144002',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148681,599,'Dhesian Sangh B.O','144409',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148682,599,'Dhogri B.O','144025',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148683,599,'Dingrian B.O','144102',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148684,599,'Dolike Sunderpur B.O','144302',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148685,599,'Dosanjh Kalan S.O','144502',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148686,599,'Duhre B.O','144302',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148687,599,'Fentonganj S.O','144001',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148688,599,'Gakhlan B.O','144002',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148689,599,'Ganachaur B.O','144511',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148690,599,'General Bus Stand S.O (Jalandhar)','144001',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148691,599,'Ghurial B.O','144106',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148692,599,'Gohawar B.O','144409',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148693,599,'Goraya S.O','144409',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148694,599,'Grain Market S.O (Jalandhar)','144008',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148695,599,'Guru Amar Dass Nagar S.O','144008',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148696,599,'Guru Ravidass Road S.O','144004',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148697,599,'Haripur Khalsa B.O','144410',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148698,599,'Haripur Sirowal B.O','144102',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148699,599,'Hazara B.O','144025',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148700,599,'Hellor B.O','144021',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148701,599,'Herian B.O','144511',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148702,599,'Hoshiarpur Road S.O','144004',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148703,599,'Industrial Area Phillaur S.O','144410',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148704,599,'Industrial Town S.O','144004',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148705,599,'Isharwal B.O','144102',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148706,599,'Jaitewali B.O','144025',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148707,599,'Jalandhar Cantt H.O','144005',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148708,599,'Jalandhar City H.O','144001',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148709,599,'Jalbhe B.O','144106',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148710,599,'Jalowal B.O','144303',1,0,'2022-03-04 19:37:00','2022-03-04 19:37:00'),(148711,599,'Jamsher S.O','144020',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148712,599,'Jandir B.O','144201',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148713,599,'Jandu Singha S.O','144025',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148714,599,'Kala Bakra S.O','144303',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148715,599,'Kalra B.O','144030',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148716,599,'Kalyanpur B.O','144026',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148717,599,'Kandhala Guru B.O','144303',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148718,599,'Kandola B.O','144103',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148719,599,'Kang Jagir B.O','144418',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148720,599,'Kapur Pind B.O','144025',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148721,599,'Kariana B.O','144410',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148722,599,'Khaira B.O','144410',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148723,599,'Khambra B.O','144026',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148724,599,'Khurdpur B.O','144102',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148725,599,'Khurla B.O','144003',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148726,599,'Khusropur B.O','144024',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148727,599,'Kingra Chowala B.O','144201',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148728,599,'Kishangarh B.O','144301',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148729,599,'Kishanpur B.O','144302',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148730,599,'Kohala B.O','144002',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148731,599,'Kot Kalan B.O','144024',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148732,599,'Kotla B.O','144106',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148733,599,'Kotli Than Singh B.O','144101',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148734,599,'Kukar Pind S.O','144024',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148735,599,'Ladhewali S.O','144007',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148736,599,'Ladhra B.O','144201',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148737,599,'Lajpat Nagar (Jalandhar) S.O','144001',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148738,599,'Lallian B.O','144028',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148739,599,'Lambra S.O','144026',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148740,599,'Landhran B.O','144419',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148741,599,'Laroi B.O','144201',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148742,599,'Laroya B.O','144201',1,0,'2022-03-04 19:37:01','2022-03-04 19:37:01'),(148743,599,'Lidhran B.O','144004',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148744,599,'Lohar Partapura B.O','144026',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148745,599,'Loharan B.O','144201',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148746,599,'Madar B.O','144025',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148747,599,'Madhopur B.O','144201',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148748,599,'Mahal B.O','144409',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148749,599,'Malko Tarar B.O','144026',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148750,599,'Malo Mazara B.O','144029',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148751,599,'Manakrai B.O','144201',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148752,599,'Mand B.O','144021',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148753,599,'Mandi B.O','144416',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148754,599,'Manko B.O','144106',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148755,599,'Mansurpur B.O','144418',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148756,599,'Massani B.O','144416',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148757,599,'Mathada Kalan B.O','144409',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148758,599,'Mathada Khurd B.O','144409',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148759,599,'Millitary Hospital S.O','144005',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148760,599,'Mithapur B.O','144022',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148761,599,'Model House S.O','144003',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148762,599,'Model Town (Jalandhar) S.O','144003',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148763,599,'Mohadipur B.O','144102',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148764,599,'Moron S.O','144029',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148765,599,'N R Colony S.O','144001',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148766,599,'Nagar B.O','144410',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148767,599,'Nagra S.O (Jalandhar)','144021',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148768,599,'Najka B.O','144102',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148769,599,'Naugajja B.O','144301',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148770,599,'Nurpur B.O','144012',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148771,599,'Nussi B.O','144004',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148772,599,'P T S Phillaur S.O','144410',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148773,599,'P.A.P. Lines Jalandhar Cantt S.O','144006',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148774,599,'Pachranga B.O','144201',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148775,599,'Paddi Jagir B.O','144409',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148776,599,'Padhiana S.O','144030',1,0,'2022-03-04 19:37:02','2022-03-04 19:37:02'),(148777,599,'Pandori Nijjran B.O','144102',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148778,599,'Parasrampur B.O','144101',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148779,599,'Patara S.O (Jalandhar)','144101',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148780,599,'Patial B.O','144201',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148781,599,'Phalpota B.O','144418',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148782,599,'Phambra B.O','144417',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148783,599,'Phillaur S.O','144410',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148784,599,'Phoolpur Dhanal B.O','144026',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148785,599,'Phophliwar B.O','144022',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148786,599,'Preet Nagar S.O (Jalandhar)','144004',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148787,599,'Qadian Wali B.O','144020',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148788,599,'R.E.C. Jalandhar S.O','144011',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148789,599,'Railway Road S.O (Jalandhar)','144001',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148790,599,'Raipur Dhaba B.O','144511',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148791,599,'Raipur Rasulpur B.O','144012',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148792,599,'Rajpur B.O','144201',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148793,599,'Rama Mandi S.O','144005',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148794,599,'Randhawa Masanda B.O','144004',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148795,599,'Rasta Mohalla S.O','144001',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148796,599,'Ratinda B.O','144029',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148797,599,'Regional Campus GNDU S.O','144009',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148798,599,'Reru S.O','144012',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148799,599,'Rohjari B.O','144303',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148800,599,'Rurka Khurd B.O','144409',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148801,599,'S U S Nagar S.O','144001',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148802,599,'Sadana B.O','144303',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148803,599,'Sadar Bazar Jalandhar Cantt S.O','144005',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148804,599,'Salala B.O','144102',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148805,599,'Samipur B.O','144026',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148806,599,'Samrai B.O','144418',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148807,599,'Sanaura B.O','144201',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148808,599,'Sansarpur B.O','144024',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148809,599,'Sant Nagar S.O (Jalandhar)','144001',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148810,599,'Sargundi B.O','144409',1,0,'2022-03-04 19:37:03','2022-03-04 19:37:03'),(148811,599,'Sarobad B.O','144106',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148812,599,'Session Court S.O (Jalandhar)','144001',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148813,599,'Shahpur Bhattian B.O','144410',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148814,599,'Shakti Nagar S.O (Jalandhar)','144001',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148815,599,'Sheikhe Pind B.O','144025',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148816,599,'Sikandarpur B.O','144301',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148817,599,'Sodal Road S.O','144004',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148818,599,'Sofi Pind B.O','144024',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148819,599,'Suranussi S.O','144027',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148820,599,'Tajpur B.O','144026',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148821,599,'Talhan B.O','144101',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148822,599,'Tehang B.O','144410',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148823,599,'Thalla B.O','144419',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148824,599,'Tower Town Colony S.O','144014',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148825,599,'Ucha B.O','144102',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148826,599,'Udhopur B.O','144020',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148827,599,'Urban Estate S.O (Jalandhar)','144022',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148828,599,'Wadala B.O','144003',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148829,599,'Adarman B.O','144041',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148830,599,'Adhi B.O','144623',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148831,599,'Akbarpur Kalan B.O','144041',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148832,599,'Bagga B.O','144703',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148833,599,'Bahamanian B.O','144702',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148834,599,'Bajwa Kalan B.O','144702',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148835,599,'Baloki B.O','144041',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148836,599,'Bara Jodh Singh B.O','144629',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148837,599,'Bara Sidhpur B.O','144040',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148838,599,'Barn B.O','144403',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148839,599,'Bath Kalan B.O','144044',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148840,599,'Bhabiana B.O','144407',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148841,599,'Bhagana B.O','144405',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148842,599,'Bhallowal B.O','144039',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148843,599,'Bhandal Himmat B.O','144039',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148844,599,'Bhangala B.O','144033',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148845,599,'Bhardwajian B.O','144034',1,0,'2022-03-04 19:37:04','2022-03-04 19:37:04'),(148846,599,'Bhodipur B.O','144040',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148847,599,'Bhullar B.O','144040',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148848,599,'Bilga S.O','144036',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148849,599,'Billi Chuharmi B.O','144040',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148850,599,'Birpind B.O','144043',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148851,599,'Bohani B.O','144403',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148852,599,'Bopa Rai Kalan S.O (Jalandhar)','144630',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148853,599,'Bulanda B.O','144041',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148854,599,'Bundala S.O (Jalandhar)','144034',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148855,599,'Chak Chela B.O','144701',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148856,599,'Chak Kalan B.O','144042',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148857,599,'Chak Mughlani B.O','144042',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148858,599,'Chak Vendal B.O','144033',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148859,599,'Chanian B.O','144033',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148860,599,'Chuheki B.O','144039',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148861,599,'CRPF Campus Sarai Khas S.O','144805',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148862,599,'D.G.Nakoder S.O','144040',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148863,599,'Daduwal B.O','144032',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148864,599,'Danewal B.O','144041',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148865,599,'Daulatpur Dhadde B.O','144701',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148866,599,'Dhaliwal B.O','144033',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148867,599,'Dhanipind B.O','144633',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148868,599,'Dhesian Kahna S.O','144311',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148869,599,'Domeli S.O','144407',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148870,599,'Gandhran B.O','144040',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148871,599,'Ghure B.O','144043',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148872,599,'Gidder Pindi B.O','144629',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148873,599,'Gill Seowal B.O','144701',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148874,599,'Gohir B.O','144630',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148875,599,'Gumtala B.O','144039',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148876,599,'Gumtali B.O','144039',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148877,599,'Haripur B.O','144041',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148878,599,'Herran B.O','144630',1,0,'2022-03-04 19:37:05','2022-03-04 19:37:05'),(148879,599,'Kahlwan B.O','144805',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148880,599,'Kala Khera B.O','144801',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148881,599,'Kandola Kalan B.O','144039',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148882,599,'Kang Arryan B.O','144035',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148883,599,'Kang Kalan B.O','144629',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148884,599,'Kang Khurd B.O','144629',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148885,599,'Kang Saboo B.O','144630',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148886,599,'Kangnah B.O','144701',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148887,599,'Kangniwal B.O','144032',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148888,599,'Kanian Kalan B.O','144703',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148889,599,'Kartarpur S.O','144801',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148890,599,'Khanpur Dhadde B.O','144701',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148891,599,'Khiwa B.O','144623',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148892,599,'Khokhewal B.O','144036',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148893,599,'Khusropur B.O','144806',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148894,599,'Killi B.O','144702',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148895,599,'Kot Badal Khan B.O','144039',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148896,599,'Kotla Surajmal B.O','144703',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148897,599,'Kotli Gujjran B.O','144702',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148898,599,'Lakhanpal B.O','144633',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148899,599,'Lassori B.O','144702',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148900,599,'Lidhran B.O','144040',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148901,599,'Littran B.O','144043',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148902,599,'Lohian S.O','144629',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148903,599,'Maheem B.O','144044',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148904,599,'Malri B.O','144040',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148905,599,'Malsian S.O','144701',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148906,599,'Malupur B.O','144701',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148907,599,'Manak B.O','144402',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148908,599,'Mau Mianwal B.O','144035',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148909,599,'Mayopatti B.O','144405',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148910,599,'Mehatpur S.O (Jalandhar)','144041',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148911,599,'Mehsumpurn B.O','144035',1,0,'2022-03-04 19:37:06','2022-03-04 19:37:06'),(148912,599,'Mianwal Arrayan B.O','144702',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148913,599,'Mithra B.O','144034',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148914,599,'Motor Terminas Nakoder S.O','144040',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148915,599,'Mowai B.O','144036',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148916,599,'Mullewal Khera B.O','144702',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148917,599,'Mundh B.O','144630',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148918,599,'Muridwal B.O','144701',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148919,599,'Mustafapur B.O','144801',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148920,599,'Nagra B.O','144037',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148921,599,'Nahal B.O','144629',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148922,599,'Nakoder S.O','144040',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148923,599,'Nangal Ambian S.O','144703',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148924,599,'Nangal Majha B.O','144403',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148925,599,'Narur S.O','144405',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148926,599,'Nawan Qilla B.O','144703',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148927,599,'Nawanpind Danewal B.O','144629',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148928,599,'Nawanpind Jattan B.O','144040',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148929,599,'Nawapind B.O','144043',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148930,599,'Nihaluwal B.O','144701',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148931,599,'Nijjran B.O','144623',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148932,599,'Nurmahal S.O','144039',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148933,599,'Nurpur B.O','144040',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148934,599,'Pabwan B.O','144034',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148935,599,'Palahi B.O','144403',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148936,599,'Pandori Khas B.O','144040',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148937,599,'Parjian Kalan B.O','144041',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148938,599,'Partappura S.O','144035',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148939,599,'Pasla S.O','144037',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148940,599,'Pattar Kalan S.O','144806',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148941,599,'Pharwala B.O','144037',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148942,599,'Phul Gudewal B.O','144629',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148943,599,'Poonian B.O','144702',1,0,'2022-03-04 19:37:07','2022-03-04 19:37:07'),(148944,599,'Powadhra B.O','144036',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148945,599,'PTU Campus Kapurthala S.O','144603',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148946,599,'Rahimpur B.O','144801',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148947,599,'Rahimpur B.O','144623',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148948,599,'Ramewal B.O','144039',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148949,599,'Rampur Sunera B.O','144407',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148950,599,'Rasulpur Kalan B.O','144630',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148951,599,'Raunt B.O','144703',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148952,599,'Rawalpindi Gulab Shah B.O','144407',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148953,599,'Rehana Jattan B.O','144407',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148954,599,'Rorkee B.O','144311',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148955,599,'Rupewali B.O','144701',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148956,599,'Rurka Kalan S.O','144031',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148957,599,'Sadiqpur B.O','144703',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148958,599,'Sahni B.O','144405',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148959,599,'Saidowal B.O','144039',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148960,599,'Sainiwal B.O','144630',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148961,599,'Sandhewal B.O','144703',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148962,599,'Sangowal B.O','144041',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148963,599,'Sarai Khas B.O','144805',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148964,599,'Sarhali S.O (Jalandhar)','144633',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148965,599,'Sarih S.O','144043',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148966,599,'Shadipur B.O','144039',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148967,599,'Shahkot S.O','144702',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148968,599,'Shahpur B.O','144041',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148969,599,'Shankar S.O','144042',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148970,599,'Sharakpur B.O','144042',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148971,599,'Sidhwan R.S. S.O','144044',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148972,599,'Sindher B.O','144702',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148973,599,'Singhpur B.O','144041',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148974,599,'Sohal Jagir B.O','144703',1,0,'2022-03-04 19:37:08','2022-03-04 19:37:08'),(148975,599,'Sunner Kalan B.O','144034',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(148976,599,'Tahli B.O','144043',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(148977,599,'Talwan B.O','144039',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(148978,599,'Talwandi Bhairon B.O','144630',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(148979,599,'Talwandi Buttian B.O','144702',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(148980,599,'Talwandi Saleem B.O','144623',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(148981,599,'Talwandi Sanghera B.O','144703',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(148982,599,'Tandaura B.O','144041',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(148983,599,'Thamanwal B.O','144036',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(148984,599,'Turna B.O','144629',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(148985,599,'Tut Kalan B.O','144040',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(148986,599,'Udhowal B.O','144041',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(148987,599,'Uggi B.O','144623',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(148988,599,'Umarpur Kalan B.O','144039',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(148989,599,'Umarwal Billa B.O','144041',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(148990,599,'Uppal Bhupa B.O','144039',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(148991,599,'Uppal Jagir B.O','144039',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(148992,599,'Wajuha Khurd B.O','144033',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(148993,599,'Yusufpur Darewal B.O','144629',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(148994,600,'Ahmedpur B.O','144603',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(148995,600,'Akbarpur B.O','144621',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(148996,600,'Alampur Bhakha B.O','144622',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(148997,600,'Amrit Bazar(Kapurthala) S.O','144601',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(148998,600,'Athouli B.O','144402',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(148999,600,'Aujla Jogi B.O','144603',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(149000,600,'Awan Bikeshah B.O','144621',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(149001,600,'Baler Khanpur B.O','144603',1,0,'2022-03-04 19:37:09','2022-03-04 19:37:09'),(149002,600,'Banga Road Phagwara S.O','144401',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149003,600,'Bariar B.O','144621',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149004,600,'Bazar Sarafan Phagwara S.O','144401',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149005,600,'Begowal S.O','144621',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149006,600,'Bhadas B.O','144622',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149007,600,'Bhandal Bet B.O','144804',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149008,600,'Bhanoki B.O','144402',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149009,600,'Bhanolanga B.O','144620',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149010,600,'Bhawanipur B.O','144603',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149011,600,'Bholath S.O','144622',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149012,600,'Bhulana B.O','144620',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149013,600,'Bhullarai B.O','144402',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149014,600,'Birk B.O','144632',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149015,600,'Boparai B.O','144622',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149016,600,'Burewal B.O','144628',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149017,600,'Butala B.O','144804',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149018,600,'Butter B.O','144622',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149019,600,'Chachoki S.O','144632',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149020,600,'Chak Prema B.O','144402',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149021,600,'Chakoki B.O','144624',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149022,600,'Chiheru B.O','144411',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149023,600,'Dadwindi B.O','144620',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149024,600,'Dalla B.O','144626',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149025,600,'Dhaliwal Bet B.O','144804',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149026,600,'Dhapai B.O','144603',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149027,600,'Dhilwan S.O','144804',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149028,600,'Dialpur S.O','144803',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149029,600,'Fattu Dhinga B.O','144606',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149030,600,'Ghurka B.O','144632',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149031,600,'Gnqc Sultanpur S.O','144626',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149032,600,'Hardasspur B.O','144411',1,0,'2022-03-04 19:37:10','2022-03-04 19:37:10'),(149033,600,'Ibban B.O','144603',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149034,600,'Ibrahimwal B.O','144819',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149035,600,'Jagatjit Nagar S.O','144802',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149036,600,'Jaid B.O','144621',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149037,600,'Jallowal Madhopur B.O','144623',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149038,600,'Jandiala S.O','144033',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149039,600,'Jandiali B.O','144632',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149040,600,'Kabirpur B.O','144626',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149041,600,'Kala Sanghian S.O','144623',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149042,600,'Kanjli B.O','144802',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149043,600,'Kanjli Road Kapurthala S.O','144601',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149044,600,'Kapurthala H.O','144601',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149045,600,'Kapurthala Town S.O','144601',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149046,600,'Khaira Dona B.O','144620',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149047,600,'Khaira Majha B.O','144603',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149048,600,'Khajurla B.O','144411',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149049,600,'Khalu B.O','144628',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149050,600,'Khanowal B.O','144603',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149051,600,'Khassan B.O','144622',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149052,600,'Khiranwali B.O','144606',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149053,600,'Khothra Kalan B.O','144632',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149054,600,'Khukhrain B.O','144606',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149055,600,'Kudowal B.O','144803',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149056,600,'Kular B.O','144625',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149057,600,'Lakhan Kalan B.O','144802',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149058,600,'Lakhan Ke Padde B.O','144802',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149059,600,'Lakhpur B.O','144402',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149060,600,'Madhopur B.O','144411',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149061,600,'Mahabalipur B.O','144620',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149062,600,'Maheru B.O','144411',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149063,600,'Mana Talwandi B.O','144622',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149064,600,'Manak B.O','144629',1,0,'2022-03-04 19:37:11','2022-03-04 19:37:11'),(149065,600,'Mansoorwal B.O','144603',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149066,600,'Maqsoodpur B.O','144819',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149067,600,'Mauli B.O','144632',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149068,600,'Mehli B.O','144632',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149069,600,'Mehli Gate Phagwara S.O','144401',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149070,600,'Mehtan B.O','144402',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149071,600,'Merripur B.O','144620',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149072,600,'Miani Bakerpur B.O','144804',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149073,600,'Miani Bhagopurian B.O','144631',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149074,600,'Mianwal B.O','144702',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149075,600,'Mirzapur B.O','144624',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149076,600,'Mothanwala B.O','144620',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149077,600,'Muddowal B.O','144802',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149078,600,'Nadala S.O','144624',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149079,600,'Nangal Lubana S.O','144631',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149080,600,'Nasirpur B.O','144628',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149081,600,'Nathu Chahal B.O','144603',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149082,600,'Nurpur Lubana B.O','144804',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149083,600,'P.C.Jamalpur B.O','144632',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149084,600,'Panchhat S.O','144408',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149085,600,'Pandori B.O','144402',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149086,600,'Paramjitpur B.O','144626',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149087,600,'Phagwara H.O','144401',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149088,600,'Rail Coach Factory S.O','144602',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149089,600,'Raipur Arryan B.O','144624',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149090,600,'Raipur B.O','144411',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149091,600,'Raipur Pir Bux Wala S.O','144819',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149092,600,'Ramgarh B.O','144622',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149093,600,'Ramidi B.O','144802',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149094,600,'Rampur Jagir B.O','144626',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149095,600,'Ranipur S.O (Kapurthala)','144403',1,0,'2022-03-04 19:37:12','2022-03-04 19:37:12'),(149096,600,'Saidowal B.O','144620',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149097,600,'Saidpur B.O','144628',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149098,600,'Saiflabad B.O','144804',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149099,600,'Sainik School Kapurthala S.O','144601',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149100,600,'Samrai S.O','144032',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149101,600,'Sandhu Chatha B.O','144625',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149102,600,'Sangatpur B.O','144402',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149103,600,'Sangojla B.O','144804',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149104,600,'Sarai Jattan B.O','144626',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149105,600,'Sarai Jattan B.O','144402',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149106,600,'Satnampura S.O','144402',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149107,600,'Sheikhupur S.O (Kapurthala)','144620',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149108,600,'Sher Singh Wala B.O','144622',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149109,600,'Sherpur Dona B.O','144626',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149110,600,'Sidhwan Dona S.O','144625',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149111,600,'Subhanpur B.O','144802',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149112,600,'Sultanpur Lodhi S.O','144626',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149113,600,'Surkhpur B.O','144804',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149114,600,'Talwandi Chaudharian S.O','144606',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149115,600,'Talwandi Madho B.O','144625',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149116,600,'Talwara B.O','144624',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149117,600,'Thaper Colony Phagwara S.O','144401',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149118,600,'Thatha Jadid S.O','144628',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149119,600,'Tibba B.O','144628',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149120,600,'University Campus Nanak Nagri S.O','144411',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149121,600,'Wadala Kalan B.O','144603',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149122,601,'A.P. Basti S.O','141003',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149123,601,'Aggar Nagar S.O','141012',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149124,601,'B.R Street S.O','141008',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149125,601,'Baggakhurd B.O','141008',1,0,'2022-03-04 19:37:13','2022-03-04 19:37:13'),(149126,601,'Basant Avenue S.O','141013',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149127,601,'Basti Jodhewal S.O','141007',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149128,601,'Bharat Nagar S.O (Ludhiana)','141001',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149129,601,'Bhattia B.O','141008',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149130,601,'Boothgarh B.O','141007',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149131,601,'Central Post Office S.O','141008',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149132,601,'CMC S.O (Ludhiana)','141008',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149133,601,'Daba Road S.O','141014',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149134,601,'Dhandari Kalan S.O','141014',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149135,601,'Durgapuri S.O','141001',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149136,601,'Eros Bajra Road S.O','141007',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149137,601,'Focal Point S.O','141010',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149138,601,'Gne College S.O','141006',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149139,601,'Guru Arjan Dev Nagar S.O','141008',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149140,601,'Hawas B.O','141007',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149141,601,'Indl  Colony S.O','141003',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149142,601,'Iqbal Ganj S.O','141008',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149143,601,'Jamalpur Awana S.O','141010',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149144,601,'Janta Nagar S.O','141003',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149145,601,'Jugiana S.O','141017',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149146,601,'Karyana Kalan B.O','141015',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149147,601,'Khwajke B.O','141007',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149148,601,'L.R Market S.O','141008',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149149,601,'Labour Colony S.O (Ludhiana)','141003',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149150,601,'Lodhowal B.O','141008',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149151,601,'Lohora S.O','141016',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149152,601,'Ludhiana H.O','141001',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149153,601,'Ludhiana Kty S.O','141001',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149154,601,'Madhopuri S.O','141008',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149155,601,'Mangat B.O','141007',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149156,601,'Mattewara B.O','141007',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149157,601,'Millerganj S.O','141003',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149158,601,'Model Town (Ludhiana) S.O','141002',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149159,601,'Moti Nagar S.O','141010',1,0,'2022-03-04 19:37:14','2022-03-04 19:37:14'),(149160,601,'Mundian Kalan S.O','141015',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149161,601,'Netaji Nagar S.O (Ludhiana)','141008',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149162,601,'New Courts S.O','141001',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149163,601,'New Hargobind Nagar S.O','141008',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149164,601,'New Model Town S.O','141002',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149165,601,'Noorwala B.O','141007',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149166,601,'Nurpurbet B.O','141008',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149167,601,'P&t Colony S.O (Ludhiana)','141001',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149168,601,'P.A.U. S.O','141004',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149169,601,'Partpsinghwala S.O','141008',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149170,601,'Passi Nagar S.O','141013',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149171,601,'Rajguru Nagar S.O','141012',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149172,601,'Samrala Road S.O','141008',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149173,601,'Sarabha Nagar S.O','141001',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149174,601,'Satsang Road S.O','141001',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149175,601,'Shimlapuri S.O','141003',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149176,601,'Shivpuri S.O (Ludhiana)','141008',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149177,601,'Sidhpeeth S.O','141001',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149178,601,'Abbowal B.O','141105',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149179,601,'Akalgarh B.O','141104',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149180,601,'Akhara B.O','142034',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149181,601,'Alamgir B.O','141116',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149182,601,'Allona Pallah B.O','141414',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149183,601,'Amloh Road(Khanna) S.O','141401',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149184,601,'Andlu B.O','141108',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149185,601,'Assi Kalan B.O','141203',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149186,601,'Attiana B.O','141107',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149187,601,'Ayali Kalan S.O','142027',1,0,'2022-03-04 19:37:15','2022-03-04 19:37:15'),(149188,601,'Babarpur B.O','141119',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149189,601,'Baddowal S.O','142021',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149190,601,'Bagli Kalan B.O','141412',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149191,601,'Bahomajra B.O','141412',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149192,601,'Bahrampur B.O','141205',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149193,601,'Ballowal B.O','141202',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149194,601,'Bangsipur B.O','142033',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149195,601,'Barhmi B.O','141107',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149196,601,'Barmalipur B.O','141416',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149197,601,'Barsal B.O','142024',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149198,601,'Barundi B.O','141205',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149199,601,'Bassian Bet B.O','141110',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149200,601,'Bassian S.O','142032',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149201,601,'Bazurg B.O','142024',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149202,601,'Begowal B.O','141418',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149203,601,'Behlolpur S.O','141121',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149204,601,'Ber Khurd B.O','141119',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149205,601,'Bhagpura B.O','141112',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149206,601,'Bhagwanpura B.O','141114',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149207,601,'Bhaini Baringa B.O','141109',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149208,601,'Bhainidarera B.O','141108',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149209,601,'Bhairro Munna B.O','141112',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149210,601,'Bhamaddi B.O','141412',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149211,601,'Bhamipura B.O','142034',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149212,601,'Bhanohar B.O','141102',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149213,601,'Bharowal B.O','142025',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149214,601,'Bharthala B.O','141114',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149215,601,'Bharthala Randhawa B.O','141415',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149216,601,'Bhatta Dhahan B.O','141110',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149217,601,'Bhourla B.O','141412',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149218,601,'Bhundri B.O','142025',1,0,'2022-03-04 19:37:16','2022-03-04 19:37:16'),(149219,601,'Bhutta B.O','141206',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149220,601,'Bija Kalan B.O','141412',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149221,601,'Bilga B.O','141120',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149222,601,'Binjal B.O','142032',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149223,601,'Birk B.O','142024',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149224,601,'Bodalwala B.O','142024',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149225,601,'Bondli B.O','141114',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149226,601,'Bopa Rai Kalan S.O (Ludhiana)','141422',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149227,601,'Borra B.O','141127',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149228,601,'Bowani B.O','141421',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149229,601,'Budhewal B.O','141112',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149230,601,'Burj Hakima B.O','141107',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149231,601,'Burj Hari Singh Wala B.O','141109',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149232,601,'Butaheri B.O','141118',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149233,601,'Chachrari B.O','142030',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149234,601,'Chajjewal B.O','142030',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149235,601,'Chak Bahi Ke B.O','142032',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149236,601,'Chak Kalan B.O','141110',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149237,601,'Chak Mafi B.O','141417',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149238,601,'Chakkar B.O','142035',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149239,601,'Chakohi B.O','141414',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149240,601,'Chaminda B.O','141202',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149241,601,'Cheema B.O','142030',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149242,601,'Chhandran B.O','141113',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149243,601,'Chhapar B.O','141204',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149244,601,'Chhounta B.O','141127',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149245,601,'Chhourian B.O','141121',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149246,601,'Chimna B.O','142024',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149247,601,'Dad B.O','142022',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149248,601,'Dadahur B.O','141109',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149249,601,'Daherka B.O','142034',1,0,'2022-03-04 19:37:17','2022-03-04 19:37:17'),(149250,601,'Daheru S.O','141412',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149251,601,'Dakha Mandi S.O','141101',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149252,601,'Dakha S.O','141102',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149253,601,'Dallah B.O','142035',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149254,601,'Dangian B.O','142035',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149255,601,'Dehlon S.O','141118',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149256,601,'Dev Nagar B.O','142022',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149257,601,'Dewatwal B.O','141102',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149258,601,'Dhaipai B.O','142029',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149259,601,'Dhamote S.O','141413',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149260,601,'Dhanansu B.O','141112',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149261,601,'Dhandran B.O','141116',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149262,601,'Dhatt B.O','141101',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149263,601,'Dhindsa B.O','141114',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149264,601,'Dholan B.O','142030',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149265,601,'Dholan Kalan B.O','142029',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149266,601,'Dhudhal Kalan B.O','141119',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149267,601,'Dhulkot B.O','141204',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149268,601,'Doburji B.O','141421',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149269,601,'Doraha S.O (Ludhiana)','141421',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149270,601,'Dulley B.O','141116',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149271,601,'Fatehgarh Siwian B.O','142036',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149272,601,'Gaddowal B.O','141112',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149273,601,'Gahaur B.O','141102',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149274,601,'Galib Kalan S.O','142036',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149275,601,'Ghaloti B.O','141419',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149276,601,'Ghangas B.O','141419',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149277,601,'Ghawaddi S.O','141206',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149278,601,'Ghudani Kalan S.O','141419',1,0,'2022-03-04 19:37:18','2022-03-04 19:37:18'),(149279,601,'Ghudani Khurd B.O','141416',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149280,601,'Ghulal B.O','141114',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149281,601,'Ghuman B.O','141104',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149282,601,'Ghungrali Rajputan B.O','141412',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149283,601,'Ghungrali Sikhan B.O','141114',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149284,601,'Ghungrana S.O','141204',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149285,601,'Gidderwindi B.O','142033',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149286,601,'Gill S.O','141116',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149287,601,'Goh B.O','141417',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149288,601,'Gondwal B.O','141109',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149289,601,'Goslan B.O','141417',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149290,601,'Gujjarwal S.O','141202',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149291,601,'Guram B.O','141206',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149292,601,'Gurreh B.O','142023',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149293,601,'Halwara Aerodrome S.O','141106',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149294,601,'Halwara S.O','141107',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149295,601,'Hamaunpura B.O','142022',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149296,601,'Hambowal B.O','141115',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149297,601,'Hambran S.O','141110',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149298,601,'Hans Kalan B.O','142030',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149299,601,'Hans Kalan B.O','141117',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149300,601,'Harion Kalan B.O','141417',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149301,601,'Hassanpur B.O','141102',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149302,601,'Hathur S.O','142031',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149303,601,'Heddon B.O','141114',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149304,601,'Heeran B.O','141112',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149305,601,'Heeran Hans B.O','141107',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149306,601,'Hissowal B.O','141422',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149307,601,'Hoal B.O','141414',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149308,601,'Ikolaha B.O','141414',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149309,601,'Issewal B.O','141102',1,0,'2022-03-04 19:37:19','2022-03-04 19:37:19'),(149310,601,'Issru S.O','141414',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149311,601,'Jagraon City S.O','142026',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149312,601,'Jagraon H.O','142026',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149313,601,'Jagraon Tehsil S.O','142026',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149314,601,'Jalaldiwal B.O','141109',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149315,601,'Jallajan B.O','141414',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149316,601,'Jandi B.O','142033',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149317,601,'Jandiali B.O','141112',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149318,601,'Jangpura B.O','141101',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149319,601,'Jarg S.O','141415',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149320,601,'Jargari B.O','141415',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149321,601,'Jartauli B.O','141203',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149322,601,'Jaspal Banger S.O','141122',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149323,601,'Jaspalon B.O','141421',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149324,601,'Jassowal B.O','141116',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149325,601,'Jassowal Kalan B.O','142023',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149326,601,'Jatana B.O','141421',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149327,601,'Jhamat B.O','141117',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149328,601,'Jhorran B.O','142032',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149329,601,'Jodhan S.O','142029',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149330,601,'Jodhwal B.O','141115',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149331,601,'Johalan B.O','141109',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149332,601,'Junetpura B.O','142033',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149333,601,'Junewal B.O','141126',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149334,601,'Kaddon B.O','141421',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149335,601,'Kailey B.O','141107',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149336,601,'Kakrala Kalan S.O','141125',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149337,601,'Kalahar B.O','141117',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149338,601,'Kalakh B.O','141204',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149339,601,'Kalal Majra B.O','141417',1,0,'2022-03-04 19:37:20','2022-03-04 19:37:20'),(149340,601,'Kalas B.O','141109',1,0,'2022-03-04 19:37:21','2022-03-04 19:37:21'),(149341,601,'Kalsian B.O','141109',1,0,'2022-03-04 19:37:21','2022-03-04 19:37:21'),(149342,601,'Kamalpura S.O','142030',1,0,'2022-03-04 19:37:21','2022-03-04 19:37:21'),(149343,601,'Kanech B.O','141120',1,0,'2022-03-04 19:37:21','2022-03-04 19:37:21'),(149344,601,'Karamsar B.O','141117',1,0,'2022-03-04 19:37:21','2022-03-04 19:37:21'),(149345,601,'Katani Kalan S.O','141113',1,0,'2022-03-04 19:37:21','2022-03-04 19:37:21'),(149346,601,'Kaunke Kalan B.O','142035',1,0,'2022-03-04 19:37:21','2022-03-04 19:37:21'),(149347,601,'KCG Sudhar S.O','141104',1,0,'2022-03-04 19:37:21','2022-03-04 19:37:21'),(149348,601,'Khandur B.O','141103',1,0,'2022-03-04 19:37:21','2022-03-04 19:37:21'),(149349,601,'Khanjarwal B.O','142025',1,0,'2022-03-04 19:37:21','2022-03-04 19:37:21'),(149350,601,'Khanna H.O','141401',1,0,'2022-03-04 19:37:21','2022-03-04 19:37:21'),(149351,601,'Khanpur B.O','141206',1,0,'2022-03-04 19:37:21','2022-03-04 19:37:21'),(149352,601,'Khatorachuharam B.O','141118',1,0,'2022-03-04 19:37:21','2022-03-04 19:37:21'),(149353,601,'Khera B.O','141204',1,0,'2022-03-04 19:37:21','2022-03-04 19:37:21'),(149354,601,'Kila Raipur S.O','141201',1,0,'2022-03-04 19:37:21','2022-03-04 19:37:21'),(149355,601,'Kishangarh B.O','141412',1,0,'2022-03-04 19:37:21','2022-03-04 19:37:21'),(149356,601,'Kohara S.O','141112',1,0,'2022-03-04 19:37:21','2022-03-04 19:37:21'),(149357,601,'Koom Kalan S.O','141127',1,0,'2022-03-04 19:37:21','2022-03-04 19:37:21'),(149358,601,'Kot Gangu Rai B.O','141113',1,0,'2022-03-04 19:37:21','2022-03-04 19:37:21'),(149359,601,'Kotala B.O','141125',1,0,'2022-03-04 19:37:21','2022-03-04 19:37:21'),(149360,601,'Kotla Bhari B.O','141417',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149361,601,'Kotla Samashpur B.O','141114',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149362,601,'Kubba B.O','141418',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149363,601,'Kuhli Kalan B.O','141119',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149364,601,'Kular B.O','142023',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149365,601,'Ladhran B.O','141114',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149366,601,'Lakha B.O','142031',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149367,601,'Lalori Kalan B.O','141417',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149368,601,'Lalton Kalan S.O','142022',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149369,601,'Lalton Khurd B.O','142022',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149370,601,'Lamme B.O','142034',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149371,601,'Lapran B.O','141421',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149372,601,'Latala S.O','141205',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149373,601,'Leel B.O','141108',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149374,601,'Leelan B.O','142033',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149375,601,'Lehal B.O','141117',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149376,601,'Lehra B.O','141118',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149377,601,'Libra B.O','141412',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149378,601,'Litter B.O','141107',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149379,601,'Lodhiwal B.O','142033',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149380,601,'Lohat baddi B.O','141109',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149381,601,'Lohgarh B.O','141203',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149382,601,'Lubangarh B.O','141115',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149383,601,'Machhiwara S.O','141115',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149384,601,'Madarpura B.O','142033',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149385,601,'Madpur B.O','141114',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149386,601,'Maheran Kalan B.O','141205',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149387,601,'Maherna Kalan B.O','141205',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149388,601,'Majri B.O','142025',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149389,601,'Maksudran B.O','141416',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149390,601,'Mal Majra B.O','141114',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149391,601,'Malak B.O','142024',1,0,'2022-03-04 19:37:22','2022-03-04 19:37:22'),(149392,601,'Malakpur B.O','142027',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149393,601,'Mallah S.O','142035',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149394,601,'Maloudh S.O','141119',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149395,601,'Malsian Bajan B.O','142033',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149396,601,'Mandiani B.O','141101',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149397,601,'Manki Bhagour B.O','141114',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149398,601,'Mann S.O','142023',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149399,601,'Mansuran B.O','142029',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149400,601,'Manuke S.O','142034',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149401,601,'Manupur B.O','141417',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149402,601,'Meerpur Hans B.O','142023',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149403,601,'Mehdoodan B.O','141418',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149404,601,'Mehma Singh Wala B.O','141203',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149405,601,'Mohanpur B.O','141412',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149406,601,'Mohie S.O','141103',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149407,601,'Morkarima B.O','142023',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149408,601,'Mukandpur B.O','141206',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149409,601,'Mullanpur B.O','141101',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149410,601,'Muskabad B.O','141114',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149411,601,'Nagra B.O','141114',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149412,601,'Nai Mandi Khanna S.O','141401',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149413,601,'Nanakpur Jagera B.O','141117',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149414,601,'Nanaksar B.O','142036',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149415,601,'Nandpur B.O','141120',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149416,601,'Nangal Kalan B.O','141108',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149417,601,'Nangal Khurd B.O','141108',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149418,601,'Nanowal Kalan B.O','141125',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149419,601,'Narangwal S.O','141203',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149420,601,'Nasrali B.O','141414',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149421,601,'Nathowal B.O','142032',1,0,'2022-03-04 19:37:23','2022-03-04 19:37:23'),(149422,601,'Natt B.O','141122',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149423,601,'Neelon Kalan B.O','141114',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149424,601,'New Rajguru Nagar B.O','142028',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149425,601,'Nizampur B.O','141413',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149426,601,'Nurpur B.O','141107',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149427,601,'Otalan B.O','141114',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149428,601,'Pabbian B.O','142023',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149429,601,'Paddi B.O','141206',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149430,601,'Pakhowal S.O','141108',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149431,601,'Pamal B.O','142021',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149432,601,'Pamali B.O','142021',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149433,601,'Pandori B.O','141101',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149434,601,'Panjeta B.O','141126',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149435,601,'Pawa B.O','141120',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149436,601,'Pawat B.O','141121',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149437,601,'Payal S.O','141416',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149438,601,'Phalewal B.O','141202',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149439,601,'Pherurain B.O','142032',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149440,601,'Pohiar B.O','141204',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149441,601,'Punjgarain B.O','141115',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149442,601,'Purain B.O','141110',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149443,601,'R.R. Jagraon S.O','142026',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149444,601,'Rachhine B.O','141205',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149445,601,'Raekot S.O','141109',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149446,601,'Rahawan S.O','141417',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149447,601,'Rajewal B.O','141414',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149448,601,'Rajewal B.O','141114',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149449,601,'Rajgarh B.O','141108',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149450,601,'Rajgarh B.O','141421',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149451,601,'Rajoana Kalan B.O','141107',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149452,601,'Ramgarh Bhullar B.O','142033',1,0,'2022-03-04 19:37:24','2022-03-04 19:37:24'),(149453,601,'Ramgarh S.O (Ludhiana)','141123',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149454,601,'Ramgarh Sardaran B.O','141119',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149455,601,'Rampur S.O (Ludhiana)','141418',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149456,601,'Rangowal B.O','141205',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149457,601,'Raowal B.O','142033',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149458,601,'Raqba B.O','141422',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149459,601,'Rasulpur B.O','142035',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149460,601,'Rattangarh B.O','141127',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149461,601,'Rattowal B.O','141105',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149462,601,'Rauni B.O','141415',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149463,601,'Rohno Kalan B.O','141414',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149464,601,'Roomi B.O','142030',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149465,601,'Rupalon B.O','141421',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149466,601,'Rurka B.O','141101',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149467,601,'Sadarpura B.O','142033',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149468,601,'Saharan Majra B.O','141117',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149469,601,'Sahauli B.O','141105',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149470,601,'Sahibana B.O','141123',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149471,601,'Salaudi B.O','141417',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149472,601,'Samrala City S.O','141114',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149473,601,'Samrala S.O','141114',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149474,601,'Sanehwal S.O','141120',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149475,601,'Sangatpura B.O','142024',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149476,601,'Sangowal B.O','141122',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149477,601,'Sarabha S.O','141105',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149478,601,'Sarih B.O','141116',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149479,601,'Sarwarpur B.O','141114',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149480,601,'Saya Kalan B.O','141118',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149481,601,'Seh B.O','141417',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149482,601,'Sehbazpura B.O','141109',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149483,601,'Shamspur B.O','141114',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149484,601,'Shankar B.O','141206',1,0,'2022-03-04 19:37:25','2022-03-04 19:37:25'),(149485,601,'Sheikh Daulat B.O','142036',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149486,601,'Sherpur Bet B.O','141121',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149487,601,'Sherpur Kalan B.O','142036',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149488,601,'Sidhwan Bet S.O','142033',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149489,601,'Sidhwan Kalan B.O','142024',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149490,601,'Sidhwan Khurd S.O','142024',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149491,601,'Sihala B.O','141125',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149492,601,'Sihan Daud B.O','141119',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149493,601,'Sihar S.O','141117',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149494,601,'Sihaura B.O','141413',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149495,601,'Sirthala B.O','141415',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149496,601,'Sodhiwal B.O','142033',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149497,601,'Sohian B.O','142023',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149498,601,'Sowaddi S.O','142025',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149499,601,'Sri Bhaini Sahib S.O','141126',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149500,601,'Srs Nagar B.O','142024',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149501,601,'Sudhar B.O','141104',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149502,601,'Sujapur B.O','142030',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149503,601,'Tajpura B.O','141109',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149504,601,'Takhran B.O','141115',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149505,601,'Talwandi Kalan B.O','142025',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149506,601,'Talwandi Khurd B.O','142025',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149507,601,'Talwandi Rai B.O','141109',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149508,601,'Thakarwal B.O','142022',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149509,601,'Threeke S.O','142028',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149510,601,'Tibba B.O','141120',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149511,601,'Tihara B.O','142033',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149512,601,'Tossey B.O','141105',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149513,601,'Tuggal B.O','142023',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149514,601,'Uppal B.O','141113',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149515,601,'Raipur Majri B.O','141411',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149516,601,'Handiaya S.O','148107',1,0,'2022-03-04 19:37:26','2022-03-04 19:37:26'),(149517,601,'Rure Ke Kalan B.O','148107',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149518,602,'Adamke B.O','151506',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149519,602,'Ahlupur B.O','151507',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149520,602,'Ahmedpur B.O','151502',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149521,602,'Akkanwali B.O','151505',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149522,602,'Aklia B.O','151510',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149523,602,'Alampur Bodla B.O','151502',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149524,602,'Alampur Mandra B.O','151503',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149525,602,'Atlakalan B.O','151504',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149526,602,'Bachhuana B.O','151502',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149527,602,'Bajjewala B.O','151505',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149528,602,'Bappiana B.O','151502',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149529,602,'Bareh B.O','151502',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149530,602,'Bareta S.O','151501',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149531,602,'Bhaini Bagha S.O','151508',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149532,602,'Bhamme Kalan B.O','151505',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149533,602,'Bhikhi S.O','151504',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149534,602,'Biroke Kalan B.O','151502',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149535,602,'Boha S.O','151503',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149536,602,'Borewal B.O','151502',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149537,602,'Budhlada S.O','151502',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149538,602,'Burj Hari B.O','151508',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149539,602,'Chauke B.O','151510',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149540,602,'Chenewala B.O','151506',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149541,602,'Dalel Singh Wala B.O','151504',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149542,602,'Dalelwala B.O','151503',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149543,602,'Datewas B.O','151502',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149544,602,'Dhalewan B.O','151502',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149545,602,'Dharampura B.O','151501',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149546,602,'Distt. Couts Mansa S.O','151505',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149547,602,'Dodra B.O','151502',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149548,602,'Dulo Wal B.O','151505',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149549,602,'Fatehpur B.O','151506',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149550,602,'Fatta Maluka B.O','151506',1,0,'2022-03-04 19:37:27','2022-03-04 19:37:27'),(149551,602,'Gehley B.O','151505',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149552,602,'Ghuddu Wala B.O','151506',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149553,602,'Grain Market Mansa S.O','151505',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149554,602,'Gurney Kalan B.O','151502',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149555,602,'Hamirgarh Dhaipai B.O','151504',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149556,602,'Hingna B.O','151506',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149557,602,'Hiron Kalan B.O','151504',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149558,602,'Hodla Kalan B.O','151502',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149559,602,'Jatana Kalan B.O','151506',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149560,602,'Jaurkian B.O','151505',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149561,602,'Jhanda Kalan B.O','151507',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149562,602,'Jhanda Khurd B.O','151507',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149563,602,'Jhanduke B.O','151506',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149564,602,'Jhunir S.O','151506',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149565,602,'Joga S.O','151510',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149566,602,'Karandi B.O','151507',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149567,602,'Khaira Kalan B.O','151507',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149568,602,'Khara B.O','151505',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149569,602,'Khiala Kalan B.O','151508',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149570,602,'Khiwa Kalan B.O','151504',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149571,602,'Khiwa Khurd B.O','151504',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149572,602,'Khokhar Kalan B.O','151508',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149573,602,'Kishangarh Pharwahi B.O','151502',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149574,602,'Kot Dharmu B.O','151505',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149575,602,'Kot Lallu B.O','151505',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149576,602,'Kotli Kalan B.O','151509',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149577,602,'Kotra Kalan B.O','151504',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149578,602,'Kulana B.O','151502',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149579,602,'Kusla B.O','151506',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149580,602,'Lakhmir Wala B.O','151505',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149581,602,'Lallian Wali B.O','151506',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149582,602,'Maghnia B.O','151503',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149583,602,'Makha B.O','151505',1,0,'2022-03-04 19:37:28','2022-03-04 19:37:28'),(149584,602,'Makha Chelan B.O','151504',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149585,602,'Malkon B.O','151506',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149586,602,'Mankhera B.O','151507',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149587,602,'Mansa S.O (Mansa)','151505',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149588,602,'Matti B.O','151504',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149589,602,'Maur Mandi S.O','151509',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149590,602,'Mian B.O','151505',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149591,602,'Mirpur Kalan B.O','151507',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149592,602,'Moffar B.O','151506',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149593,602,'Moosa B.O','151508',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149594,602,'Nahran B.O','151507',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149595,602,'Nangal Kalan B.O','151505',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149596,602,'Narinder Pura B.O','151505',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149597,602,'Phaphre Bhaike B.O','151502',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149598,602,'Rai Pur B.O','151505',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149599,602,'Ralla B.O','151510',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149600,602,'Reond Kalan B.O','151503',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149601,602,'Saharna B.O','151505',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149602,602,'Saidewala B.O','151503',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149603,602,'Samaon B.O','151504',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149604,602,'Sangha B.O','151507',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149605,602,'Sardulgarh S.O','151507',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149606,602,'Tahlian B.O','151503',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149607,602,'Tamkot B.O','151508',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149608,602,'Ubha B.O','151508',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149609,602,'Uddat Saidewala B.O','151503',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149610,602,'Udit Bhagat Ram B.O','151505',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149611,603,'Ajitwal B.O','142053',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149612,603,'Alamwala Kalan B.O','142038',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149613,603,'Badhni Kalan S.O','142037',1,0,'2022-03-04 19:37:29','2022-03-04 19:37:29'),(149614,603,'Badhni Khurd B.O','142037',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149615,603,'Baghapurana S.O','142038',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149616,603,'Bahona B.O','142011',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149617,603,'Baraghar B.O','142038',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149618,603,'Baude B.O','142039',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149619,603,'Bhagike B.O','142039',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149620,603,'Bilaspur (Moga) S.O','142039',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149621,603,'Bir Raoke B.O','142037',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149622,603,'Budh Singh Wala B.O','142038',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149623,603,'Budh Singh Wala B.O','142002',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149624,603,'Bughipura B.O','142011',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149625,603,'Bukan Wala B.O','142048',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149626,603,'Butter S.O','142040',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149627,603,'Chand Nau B.O','142002',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149628,603,'Chand Purana B.O','142038',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149629,603,'Channu Wala B.O','142038',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149630,603,'Charik B.O','142002',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149631,603,'Chotian Kalan B.O','142048',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149632,603,'Chugawan B.O','142054',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149633,603,'Chuhar Chak B.O','142053',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149634,603,'Dadahur B.O','142048',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149635,603,'Dagru B.O','142048',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149636,603,'Dala S.O','142011',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149637,603,'Darapur B.O','142048',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149638,603,'Daroli Bhai B.O','142048',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149639,603,'Daudhar B.O','142053',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149640,603,'Daulatpur Nicha B.O','142048',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149641,603,'Dhalle Ke B.O','142003',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149642,603,'Dhudike S.O','142053',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149643,603,'Dhurkot B.O','142011',1,0,'2022-03-04 19:37:30','2022-03-04 19:37:30'),(149644,603,'Dhurkot Ransih B.O','142055',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149645,603,'Didarewala B.O','142046',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149646,603,'Dina B.O','142046',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149647,603,'Dosanjh B.O','142003',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149648,603,'Ganji Gulab Singh B.O','142057',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149649,603,'Gaziana B.O','142055',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149650,603,'Ghall Kalan S.O','142048',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149651,603,'Gholia Kalan B.O','142056',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149652,603,'Gholia Khurd S.O','142056',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149653,603,'Gtr Moga S.O','142001',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149654,603,'Guru Teg Bahadur Garh S.O','142049',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149655,603,'Himmatpura B.O','142039',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149656,603,'Industrial Area Moga S.O','142001',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149657,603,'Jai Singh Wala B.O','142038',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149658,603,'Jaimal Wala B.O','142002',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149659,603,'Jhandiana B.O','142048',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149660,603,'Jhandiana Sarki B.O','142053',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149661,603,'Jita Singh Wala B.O','142057',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149662,603,'Joge Wala B.O','142048',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149663,603,'Kaleke B.O','142038',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149664,603,'Kalia Wala Karmuka B.O','142048',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149665,603,'Kapure B.O','142054',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149666,603,'Khai B.O','142046',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149667,603,'Khosa Pando B.O','142048',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149668,603,'Khote B.O','142046',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149669,603,'Khukhrana B.O','142048',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149670,603,'Killi Chahal B.O','142053',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149671,603,'Kishan Garh B.O','142045',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149672,603,'Kokri Heron B.O','142054',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149673,603,'Kokri Kalan S.O','142054',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149674,603,'Kokri Khurd B.O','142054',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149675,603,'Korewala Kalan B.O','142048',1,0,'2022-03-04 19:37:31','2022-03-04 19:37:31'),(149676,603,'Kotla Mehar Singh wala B.O','142038',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149677,603,'Kotla Rai Ka B.O','142057',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149678,603,'Kussa B.O','142039',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149679,603,'Ladhai Ke B.O','142038',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149680,603,'Lande B.O','142049',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149681,603,'Lande Ke B.O','142003',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149682,603,'Langeana Kalan B.O','142038',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149683,603,'Langeana Khurd B.O','142038',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149684,603,'Lohara B.O','142039',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149685,603,'Loponke B.O','142037',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149686,603,'Machike B.O','142039',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149687,603,'Madheke B.O','142055',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149688,603,'Madhoke B.O','142053',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149689,603,'Mahesari B.O','142048',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149690,603,'Mahla Kalan B.O','142038',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149691,603,'Malliana B.O','142040',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149692,603,'Malliana B.O','142037',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149693,603,'Mandhiran Wala B.O','142038',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149694,603,'Manoke S.O','142045',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149695,603,'Mari Mustafa B.O','142049',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149696,603,'Matwani B.O','142053',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149697,603,'Maur Nau Abad B.O','142057',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149698,603,'Mehna B.O','142011',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149699,603,'Mehron B.O','142011',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149700,603,'Minian B.O','142039',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149701,603,'Moga H.O','142001',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149702,603,'Moga Kty S.O','142003',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149703,603,'Nangal B.O','142039',1,0,'2022-03-04 19:37:32','2022-03-04 19:37:32'),(149704,603,'Nathoke B.O','142038',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149705,603,'Nathowala Jadid B.O','142053',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149706,603,'Nathuwala West B.O','142038',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149707,603,'Nidhan Wala B.O','142048',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149708,603,'Nihal Singh Wala S.O','142055',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149709,603,'Patto Hira Singh S.O','142046',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149710,603,'Phulewala B.O','142056',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149711,603,'Purana Moga S.O','142002',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149712,603,'Purane Wala B.O','142054',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149713,603,'Rajeana B.O','142038',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149714,603,'Raman B.O','142039',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149715,603,'Ramuwala Harchoke B.O','142040',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149716,603,'Ramuwala Kalan B.O','142040',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149717,603,'Ramuwala Nawan B.O','142040',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149718,603,'Ranian B.O','142056',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149719,603,'Ransih Khurd B.O','142055',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149720,603,'Raoke Kalan B.O','142037',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149721,603,'Rattian B.O','142048',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149722,603,'Rauli B.O','142003',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149723,603,'Raunta B.O','142045',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149724,603,'Rode B.O','142049',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149725,603,'Sada Singh Wala B.O','142048',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149726,603,'Saffuwala B.O','142048',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149727,603,'Saho Ke B.O','151208',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149728,603,'Saidoke B.O','142055',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149729,603,'Salina B.O','142048',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149730,603,'Samadh Bhai S.O','142057',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149731,603,'Sangatpura B.O','142057',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149732,603,'Sekha Kalan B.O','142049',1,0,'2022-03-04 19:37:33','2022-03-04 19:37:33'),(149733,603,'Singhe Wala B.O','142002',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149734,603,'Smalsar B.O','142049',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149735,603,'Sukha Nand B.O','142049',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149736,603,'Takhan Wadh B.O','142053',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149737,603,'Takhupura B.O','142055',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149738,603,'Tarewala B.O','142002',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149739,603,'Thaman Wala B.O','142048',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149740,603,'Tharaj B.O','142057',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149741,603,'Thathi Bhai B.O','142049',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149742,603,'Varoke B.O','142049',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149743,603,'Aminwala B.O','142042',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149744,603,'Awan B.O','152028',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149745,603,'Balkhandi B.O','152028',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149746,603,'Chak Kannian Kalan B.O','142058',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149747,603,'Chuhar Chak Khurd B.O','152028',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149748,603,'Datewala B.O','142043',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149749,603,'Dharamkot S.O','142042',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149750,603,'Dholewala B.O','142042',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149751,603,'Fateh Garh Panjtoor B.O','142043',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149752,603,'Fatehgarh Korotana B.O','142042',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149753,603,'Gargrah B.O','142043',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149754,603,'Ghaloti B.O','142043',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149755,603,'Indergarh B.O','142058',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149756,603,'Jalalabad East B.O','142042',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149757,603,'Janer B.O','142043',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149758,603,'Kaila B.O','142042',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149759,603,'Karahewala B.O','142043',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149760,603,'Karyal B.O','142042',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149761,603,'Kawan B.O','142042',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149762,603,'Khosa Randhir B.O','152028',1,0,'2022-03-04 19:37:34','2022-03-04 19:37:34'),(149763,603,'Kishanpura S.O (Moga)','142058',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149764,603,'Kot Ise Khan S.O','142043',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149765,603,'Kot Sadar Khan B.O','142042',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149766,603,'Lohara B.O','142043',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149767,603,'Lohgarh B.O','142042',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149768,603,'Mandar Kalan B.O','142043',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149769,603,'Nasirewala B.O','142058',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149770,603,'Nurpur Hakkiman B.O','142042',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149771,603,'Pandori Arian B.O','142042',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149772,603,'Qadarwala B.O','142043',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149773,603,'Sherpur Tiaba B.O','142042',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149774,604,'Allahpur B.O','140103',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149775,604,'Bajheri B.O','140413',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149776,604,'Baltana S.O','140604',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149777,604,'Baraudi B.O','140110',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149778,604,'Baroli B.O','140507',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149779,604,'Bassi Gujran B.O','140112',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149780,604,'Bhabat B.O','160003',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149781,604,'Dappar Ad S.O','140506',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149782,604,'Derabassi S.O','140507',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149783,604,'Devinagar B.O','140507',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149784,604,'Dhakaoli S.O','160104',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149785,604,'Dharamgarh B.O','140501',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149786,604,'Handesera B.O','140501',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149787,604,'Hoshiarpur Taqipur B.O','140110',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149788,604,'Jarut B.O','140501',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149789,604,'Jauli B.O','140501',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149790,604,'Jayanti Devi B.O','140901',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149791,604,'Jhanjeri B.O','140307',1,0,'2022-03-04 19:37:35','2022-03-04 19:37:35'),(149792,604,'Jharmarhi B.O','140501',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149793,604,'Joula Kalan B.O','140501',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149794,604,'Kalewal B.O','140103',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149795,604,'Kansala B.O','140110',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149796,604,'Khelan B.O','140501',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149797,604,'Khizrabad West S.O','140109',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149798,604,'Kubaheri B.O','140109',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149799,604,'Kuda Jassu B.O','140901',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149800,604,'Kurali S.O','140103',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149801,604,'Kuranwala B.O','140507',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149802,604,'Lalru S.O','140501',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149803,604,'Majatri B.O','140307',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149804,604,'Manakpur Sharif B.O','140110',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149805,604,'Marauli Kalan B.O','140413',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149806,604,'Mubarakpur S.O (Patiala)','140201',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149807,604,'Mullanpur S.O','140901',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149808,604,'Mundhon Kalan B.O','140103',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149809,604,'Naya Gaon S.O (Mohali)','160103',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149810,604,'Palheri B.O','140301',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149811,604,'Phatwan B.O','140110',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149812,604,'Radiala B.O','140301',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149813,604,'Rampur Sainia B.O','140507',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149814,604,'Rani Majra B.O','140901',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149815,604,'Rani Majra B.O','140501',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149816,604,'Rasanheri B.O','140307',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149817,604,'Sahauran B.O','140103',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149818,604,'Sakrulapur B.O','140413',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149819,604,'Samgoli B.O','140501',1,0,'2022-03-04 19:37:36','2022-03-04 19:37:36'),(149820,604,'Sialba Majri S.O','140110',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149821,604,'Singhpura B.O','140103',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149822,604,'Sirsihni B.O','140501',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149823,604,'Siswan B.O','140110',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149824,604,'Tassimbli B.O','140501',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149825,604,'Tiwana B.O','140501',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149826,604,'Zirakpur S.O','140603',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149827,605,'Abul Khurana B.O','152114',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149828,605,'Adhnian B.O','152114',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149829,605,'Akalgarh B.O','152026',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149830,605,'Alamwala S.O','151210',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149831,605,'Aspal B.O','151210',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149832,605,'Assa Buttar B.O','152025',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149833,605,'Badal B.O','152113',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149834,605,'Badhai B.O','152026',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149835,605,'Badian B.O','152112',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149836,605,'Ballamgarh B.O','152026',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149837,605,'Bam B.O','152032',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149838,605,'Banwala B.O','152113',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149839,605,'Bariwala S.O','152025',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149840,605,'Bhagsar B.O','152026',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149841,605,'Bhagwanpura B.O','152107',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149842,605,'Bhaika Khera S.O','152115',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149843,605,'Bhaliana B.O','152101',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149844,605,'Bhallerian B.O','152112',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149845,605,'Bhang Chari B.O','152032',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149846,605,'Bhitti Wala B.O','152113',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149847,605,'Bhullar B.O','152031',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149848,605,'Bhundar B.O','152112',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149849,605,'Bhutti Wala B.O','152025',1,0,'2022-03-04 19:37:37','2022-03-04 19:37:37'),(149850,605,'Bodi Wala B.O','151210',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149851,605,'Bring Khera B.O','151211',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149852,605,'Burj Sidhwan B.O','152107',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149853,605,'Butter Sharing B.O','152031',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149854,605,'Chak Duhe Wala B.O','152032',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149855,605,'Chak Gilze Wala B.O','152032',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149856,605,'Chak Mahabaddar B.O','152032',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149857,605,'Chak Shere Wala B.O','152032',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149858,605,'Channu B.O','152101',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149859,605,'Chappian B.O','152107',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149860,605,'Chhattiana B.O','152031',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149861,605,'Dabwali Dhab B.O','152115',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149862,605,'Dabwali Rahurianwali B.O','152107',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149863,605,'Daula B.O','152101',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149864,605,'Deon Khera B.O','152114',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149865,605,'Dhaula B.O','152114',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149866,605,'Dhigana B.O','152032',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149867,605,'Doda S.O (Muktsar)','152031',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149868,605,'Ena Khera B.O','152112',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149869,605,'Faqarsar B.O','152107',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149870,605,'Fatehpur Minian B.O','152114',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149871,605,'Fatuhi Khera B.O','152113',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149872,605,'Ghagga B.O','152101',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149873,605,'Ghumiara B.O','151211',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149874,605,'Ghumiara Khera B.O','152107',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149875,605,'Gidderbaha S.O','152101',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149876,605,'Goniana Village B.O','152026',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149877,605,'Gurhi Sangar B.O','152031',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149878,605,'Gurusar B.O','152112',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149879,605,'Gurusar Jodhe Ka B.O','152115',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149880,605,'Haku Wala B.O','151211',1,0,'2022-03-04 19:37:38','2022-03-04 19:37:38'),(149881,605,'Hari Ke Kalan B.O','152025',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149882,605,'Husnar B.O','152101',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149883,605,'Jand Wala Chadat Singh B.O','152107',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149884,605,'Jhabel Wali B.O','152026',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149885,605,'Jhurar B.O','152112',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149886,605,'Kabar Wala B.O','151210',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149887,605,'Kandu Khera B.O','152113',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149888,605,'Kanianwali B.O','152026',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149889,605,'Karampatti B.O','151210',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149890,605,'Kattianwali B.O','151210',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149891,605,'Kauni B.O','152031',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149892,605,'Khane Ki Dhab B.O','152112',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149893,605,'Khema Khera B.O','152115',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149894,605,'Khokhar B.O','152025',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149895,605,'Khuddian Gulab Singh B.O','152113',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149896,605,'Khunana Kalan B.O','152112',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149897,605,'Killianwali B.O','151211',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149898,605,'Kot Bhai B.O','152101',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149899,605,'Kotli B.O','151202',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149900,605,'Kuraiwala B.O','152112',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149901,605,'Kuttian Wali B.O','152114',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149902,605,'Lakhewali B.O','152026',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149903,605,'Lakkarwala B.O','152112',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149904,605,'Lalbai B.O','152101',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149905,605,'Lambi S.O','152113',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149906,605,'Lohara B.O','151211',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149907,605,'Lubanian B.O','152026',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149908,605,'Madhir B.O','152101',1,0,'2022-03-04 19:37:39','2022-03-04 19:37:39'),(149909,605,'Madrassa B.O','152026',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149910,605,'Mahabaddar B.O','152032',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149911,605,'Mahni Kherea B.O','152115',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149912,605,'Mahuana B.O','152114',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149913,605,'Mallan B.O','152031',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149914,605,'Malout S.O','152107',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149915,605,'Malout Village B.O','152107',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149916,605,'Malwala Katorewala B.O','152112',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149917,605,'Mandi Killianwali S.O','151211',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149918,605,'Mangatker B.O','152026',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149919,605,'Mann B.O','152113',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149920,605,'Mehna B.O','152113',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149921,605,'Midda B.O','151210',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149922,605,'Middu Khera B.O','151211',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149923,605,'Mohlan B.O','151210',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149924,605,'Muktsar Kty S.O','152026',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149925,605,'Muktsar S.O','152026',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149926,605,'Nand Garh B.O','152026',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149927,605,'Pakki B.O','151210',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149928,605,'Panjawa B.O','152113',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149929,605,'Panni Wala Fatta B.O','151210',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149930,605,'Peori B.O','152101',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149931,605,'Phullu Khera B.O','152114',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149932,605,'Rahurian Wali B.O','152026',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149933,605,'Ram Nagar S.O (Muktsar)','152112',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149934,605,'Rani Wala B.O','151210',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149935,605,'Ratherian B.O','152114',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149936,605,'Ratta Khera B.O','151210',1,0,'2022-03-04 19:37:40','2022-03-04 19:37:40'),(149937,605,'Ratta Tibba B.O','151210',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149938,605,'Roran Wali B.O','152113',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149939,605,'Rupana S.O','152032',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149940,605,'Sahib Chand B.O','152101',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149941,605,'Sammewali B.O','152026',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149942,605,'Sanghudhon B.O','152026',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149943,605,'Sarai Naga B.O','152025',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149944,605,'Sarawan Bodla B.O','151210',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149945,605,'Seerwali B.O','152026',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149946,605,'Sehna Khera B.O','152114',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149947,605,'Sham Khera B.O','152115',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149948,605,'Sikh Wala B.O','152113',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149949,605,'Singhewala B.O','152113',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149950,605,'Sotha B.O','152032',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149951,605,'Sukhana Ablu B.O','152031',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149952,605,'Sure Wala B.O','152025',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149953,605,'Tamkot B.O','152032',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149954,605,'Tappa Khera S.O','152114',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149955,605,'Tarkhan Wala B.O','152112',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149956,605,'Tarmala B.O','152115',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149957,605,'Thandewala B.O','152026',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149958,605,'Tharaj Wala B.O','152101',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149959,605,'Udekaran B.O','152026',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149960,605,'Urang B.O','151210',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149961,605,'Virk Khera B.O','152107',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149962,605,'Ranjitgarh B.O','152022',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149963,606,'Aduana B.O','144521',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149964,606,'Asron S.O','144533',1,0,'2022-03-04 19:37:41','2022-03-04 19:37:41'),(149965,606,'Bachhauri B.O','144526',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149966,606,'Balachaur S.O','144521',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149967,606,'Banah B.O','144522',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149968,606,'Begumpur B.O','144524',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149969,606,'Begumpur Jandiala B.O','146115',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149970,606,'Bhaddi B.O','144521',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149971,606,'Bharthala B.O','144522',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149972,606,'Chandiani Khurd B.O','144525',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149973,606,'Chandpur Rurki B.O','144524',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149974,606,'Chinkoa B.O','144526',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149975,606,'Garhi Matton B.O','144527',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149976,606,'Garhi Qanogaon B.O','144521',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149977,606,'Garle Dhaha B.O','144526',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149978,606,'Garlon Bet B.O','144521',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149979,606,'Ghamaur B.O','144521',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149980,606,'Gulpur B.O','144526',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149981,606,'Hayatpur Rurki B.O','144532',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149982,606,'Kangna Bet B.O','144521',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149983,606,'Karawar B.O','144526',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149984,606,'Kareempur Chahwala B.O','144524',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149985,606,'Kathagrh S.O','144522',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149986,606,'Kaulgarh B.O','144526',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149987,606,'Majara Jattan B.O','144522',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149988,606,'Makhoopur B.O','144525',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149989,606,'Mehandpur S.O','144526',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149990,606,'Mohar B.O','144526',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149991,606,'Mojowal Majara B.O','144526',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149992,606,'Nawanpind Tapprian B.O','144521',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149993,606,'Nighi B.O','144522',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149994,606,'Panam B.O','144532',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149995,606,'Phirni Mazara B.O','144526',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149996,606,'Pojewal B.O','144524',1,0,'2022-03-04 19:37:42','2022-03-04 19:37:42'),(149997,606,'Rakkar Bet B.O','144521',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(149998,606,'Rakkran Dhaha B.O','144526',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(149999,606,'Ramgarh Sikri B.O','144224',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150000,606,'Rattewal B.O','144521',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150001,606,'Rel B.O','144533',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150002,606,'Rurki Khas B.O','144532',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150003,606,'Rurki Muglan B.O','144526',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150004,606,'Sahdra B.O','144525',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150005,606,'Sahiba S.O','144525',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150006,606,'Sahungra B.O','144532',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150007,606,'Samundra S.O','144532',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150008,606,'Saroa S.O','144524',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150009,606,'Simbli B.O','144532',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150010,606,'Takarala B.O','144521',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150011,606,'Thopia B.O','144521',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150012,606,'Torowal B.O','144524',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150013,606,'Udhanwal B.O','144521',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150014,606,'Allachaur B.O','144514',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150015,606,'Amargarh B.O','144513',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150016,606,'Aur S.O','144417',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150017,606,'Baharwal B.O','144505',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150018,606,'Bahloor Kalan B.O','144517',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150019,606,'Bains B.O','144508',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150020,606,'Banga S.O','144505',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150021,606,'Barnala Kalan B.O','144514',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150022,606,'Barsian B.O','144517',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150023,606,'Bazidpur B.O','144518',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150024,606,'Behram S.O','144504',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150025,606,'Bhagaura B.O','144516',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150026,606,'Bhakhlaur B.O','144422',1,0,'2022-03-04 19:37:43','2022-03-04 19:37:43'),(150027,606,'Bharmazara B.O','144516',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150028,606,'Bharo Mazara B.O','144504',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150029,606,'Bharoli B.O','144503',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150030,606,'Bharta Kalan B.O','144518',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150031,606,'Bharta Khurd B.O','144518',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150032,606,'Bhaura B.O','144506',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150033,606,'Bhin B.O','144512',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150034,606,'Bhut B.O','144512',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150035,606,'Bisla B.O','144505',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150036,606,'Bohara B.O','144421',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150037,606,'Chahal Kalan B.O','144507',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150038,606,'Chak Bilgan B.O','144504',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150039,606,'Chak Dana B.O','144422',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150040,606,'Chak Kalan B.O','144505',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150041,606,'Chak Ramu B.O','144504',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150042,606,'Dangarpur B.O','144515',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150043,606,'Daulatpur B.O','144516',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150044,606,'Dhahan B.O','144505',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150045,606,'Dosanjh Khurd S.O','144511',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150046,606,'Garcha S.O','144518',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150047,606,'Garh Padhiana B.O','144518',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150048,606,'Ghataron B.O','144421',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150049,606,'Ghuman B.O','144503',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150050,606,'Gobindpur B.O','144510',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150051,606,'Gulshan Bazar Nawanshahar S.O','144514',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150052,606,'Hakimpur B.O','144507',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150053,606,'Hansron B.O','144421',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150054,606,'Heon B.O','144505',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150055,606,'Hiala B.O','144517',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150056,606,'Jabbowal B.O','144512',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150057,606,'Jadla S.O','144515',1,0,'2022-03-04 19:37:44','2022-03-04 19:37:44'),(150058,606,'Jagatpur B.O','144507',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150059,606,'Jander Kalan B.O','144505',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150060,606,'Jandiala B.O','144505',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150061,606,'Jasso Mazara B.O','144501',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150062,606,'Jhingran B.O','144507',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150063,606,'Kahlon B.O','144517',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150064,606,'Kahma S.O','144512',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150065,606,'Kaleran B.O','144505',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150066,606,'Kamam B.O','144513',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150067,606,'Kangror B.O','144503',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150068,606,'Kariam B.O','144514',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150069,606,'Kariha B.O','144508',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150070,606,'Karimpur B.O','144516',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150071,606,'Karnana B.O','144513',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150072,606,'Katarian B.O','144503',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150073,606,'Katt B.O','144504',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150074,606,'Khankhana S.O','144509',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150075,606,'Khanpur B.O','144509',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150076,606,'Kharkowal B.O','144518',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150077,606,'Khatkar Kalan B.O','144512',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150078,606,'Khoja B.O','144518',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150079,606,'Kishanpura B.O','144516',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150080,606,'Kot Grewal B.O','144502',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150081,606,'Kot Ranjha B.O','144517',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150082,606,'Kulam B.O','144514',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150083,606,'Kultham S.O','144501',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150084,606,'Ladhana Jhikka S.O','144510',1,0,'2022-03-04 19:37:45','2022-03-04 19:37:45'),(150085,606,'Lakhpur B.O','144509',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150086,606,'Langeri Jagirdaran B.O','144504',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150087,606,'Langroya S.O','144516',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150088,606,'Laroya B.O','144507',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150089,606,'Lassara S.O','144415',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150090,606,'Lehal B.O','144502',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150091,606,'Lidhar Kalan B.O','144502',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150092,606,'Mahalon B.O','144514',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150093,606,'Mahil Gailan S.O','144506',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150094,606,'Mahlian B.O','144503',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150095,606,'Majara Nau Abad B.O','144511',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150096,606,'Malpur B.O','144508',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150097,606,'Malupota B.O','144505',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150098,606,'Mandhali B.O','144501',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150099,606,'Mangowal B.O','144512',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150100,606,'Maqsoodpur B.O','144503',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150101,606,'Mehmoodpur B.O','144421',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150102,606,'Mehrampur B.O','144518',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150103,606,'Mirpur Jattan B.O','144515',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150104,606,'Mirpur Lakha B.O','144421',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150105,606,'Mokandpur S.O','144507',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150106,606,'Musapur S.O','144513',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150107,606,'Muzaffarpur B.O','144515',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150108,606,'N R Banga S.O','144505',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150109,606,'Naura S.O','144508',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150110,606,'Nawanshahar Mandi S.O','144514',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150111,606,'Nawanshahar S.O','144514',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150112,606,'Paddi Matwali B.O','144510',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150113,606,'Palli Jhikki B.O','144512',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150114,606,'Palli Uchi B.O','144512',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150115,606,'Pathlawa B.O','144510',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150116,606,'Pharala S.O','144503',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150117,606,'Rahon S.O','144517',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150118,606,'Rampur B.O','144510',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150119,606,'Rasulpur B.O','144513',1,0,'2022-03-04 19:37:46','2022-03-04 19:37:46'),(150120,606,'Sahlon S.O','144421',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150121,606,'Saloh B.O','144514',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150122,606,'Sanawa B.O','144516',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150123,606,'Sandhwan B.O','144503',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150124,606,'Sarhal Mandi B.O','144502',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150125,606,'Sarhal Qazian B.O','144502',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150126,606,'Sarhan Renuan B.O','144501',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150127,606,'Sauna B.O','144516',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150128,606,'Shahabpur B.O','144515',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150129,606,'Sheikhepur Bagh B.O','144515',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150130,606,'Sheikhupur B.O','144029',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150131,606,'Sujjon B.O','144506',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150132,606,'Surapur B.O','144506',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150133,606,'Talwandi Fattu B.O','144507',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150134,606,'Thanian B.O','144505',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150135,606,'Urapar S.O','144422',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150136,606,'Usmanpur B.O','144515',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150137,607,'Bamial S.O','145027',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150138,607,'Dunera S.O','145022',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150139,607,'Gharota S.O','143533',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150140,607,'Madhopur S.O (Gurdaspur)','145024',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150141,607,'Malakpur S.O','145025',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150142,607,'Mirthal S.O','145101',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150143,607,'Narot Jailmal Singh S.O','145026',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150144,607,'Shahpur Kandi Township S.O','145029',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150145,607,'Sujanpur S.O (Gurdaspur)','145023',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150146,607,'Taragarh (Gurdaspur) S.O','143534',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150147,608,'Bhankarpur B.O','140201',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150148,608,'Chhatt B.O','140603',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150149,608,'Dappar B.O','140506',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150150,608,'Dayalpur Sodhian B.O','140603',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150151,608,'Gholumajra B.O','140506',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150152,608,'Jalalpur B.O','140506',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150153,608,'Jangipur B.O','140506',1,0,'2022-03-04 19:37:47','2022-03-04 19:37:47'),(150154,608,'Aero Kalan B.O','147111',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150155,608,'Agol B.O','147202',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150156,608,'Ajnoda Kalan B.O','147201',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150157,608,'Ajrawar B.O','140701',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150158,608,'Allowal B.O','147006',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150159,608,'Amrala B.O','140802',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150160,608,'Anaj Mandi Nabha S.O','147201',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150161,608,'Arno B.O','147105',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150162,608,'Babarpur B.O','147201',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150163,608,'Badshahpur B.O','147102',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150164,608,'Bahera Road Patiala S.O','147001',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150165,608,'Bakshiwala B.O','147006',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150166,608,'Balbera B.O','147101',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150167,608,'Banur S.O','140601',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150168,608,'Barsat B.O','147201',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150169,608,'Barwali Khurd B.O','141411',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150170,608,'Basantpura B.O','140402',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150171,608,'Bazidpur B.O','140412',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150172,608,'Beharjach B.O','147105',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150173,608,'Behmna B.O','147101',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150174,608,'Behru B.O','147111',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150175,608,'Bhadson S.O','147202',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150176,608,'Bhagrana B.O','140602',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150177,608,'Bhankher B.O','147103',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150178,608,'Bhapal B.O','140402',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150179,608,'Bhari Panaich B.O','147202',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150180,608,'Bharpurgarh B.O','147203',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150181,608,'Bhatmajra B.O','140701',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150182,608,'Bhedwal B.O','140402',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150183,608,'Bhedwala B.O','140412',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150184,608,'Bhunerheri B.O','147111',1,0,'2022-03-04 19:37:48','2022-03-04 19:37:48'),(150185,608,'Bibipur B.O','147101',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150186,608,'Binaheri B.O','147201',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150187,608,'Buzark B.O','147102',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150188,608,'Chalela B.O','147006',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150189,608,'Chalheri B.O','140402',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150190,608,'Chamaru B.O','140402',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150191,608,'Chappar B.O','147021',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150192,608,'Charaso Kartarpur B.O','147101',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150193,608,'Chinarthal Kalan S.O','147104',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150194,608,'Chintawala B.O','147201',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150195,608,'Civil Lines Patiala S.O','147001',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150196,608,'D C W S.O','147003',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150197,608,'Dadu Majra B.O','140602',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150198,608,'Daftari Wala B.O','147105',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150199,608,'Dakala B.O','147007',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150200,608,'Dakaunda B.O','147104',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150201,608,'Dandrala Dhindsa B.O','147201',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150202,608,'Daunkalan B.O','147021',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150203,608,'Dedna B.O','147102',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150204,608,'Devigarh S.O','147111',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150205,608,'Devinagar B.O','147111',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150206,608,'Dhablan B.O','147201',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150207,608,'Dhainthal B.O','147101',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150208,608,'Dhanetha B.O','147101',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150209,608,'Dhankansu Kalan B.O','140402',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150210,608,'Dhingi B.O','147201',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150211,608,'Dhudan Sadhan B.O','147111',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150212,608,'Dhuman B.O','140602',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150213,608,'Duggal B.O','147105',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150214,608,'Dukhniwaran Sahib S.O','147001',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150215,608,'Dulwan B.O','140802',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150216,608,'Duttal B.O','147105',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150217,608,'Fatehpur B.O','147202',1,0,'2022-03-04 19:37:49','2022-03-04 19:37:49'),(150218,608,'Gadapur B.O','140417',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150219,608,'Gajewas B.O','147101',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150220,608,'Gajjumajra B.O','147101',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150221,608,'Galwati B.O','147201',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150222,608,'Ghagga S.O','147102',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150223,608,'Ghanur S.O','140702',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150224,608,'Gharam B.O','147111',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150225,608,'Godaya B.O','147201',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150226,608,'Gopalpur B.O','140701',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150227,608,'Govt. Printing Press S.O','147004',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150228,608,'Gtc Nabha B.O','147201',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150229,608,'Gulhar B.O','147105',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150230,608,'Gunike B.O','147201',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150231,608,'Gurbax Colony S.O','147003',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150232,608,'Gurlzarpur B.O','147105',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150233,608,'Guruteghbahadurgarh S.O','147021',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150234,608,'Harayu Khurd B.O','147105',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150235,608,'Harchandpura B.O','147102',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150236,608,'Harpalpur B.O','140701',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150237,608,'Hawara Kalan B.O','140802',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150238,608,'IA Rajpura S.O','140401',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150239,608,'IFP Rajpura S.O','140401',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150240,608,'Jandmangoli B.O','140417',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150241,608,'Janherian B.O','147021',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150242,608,'Jasso Majra B.O','147202',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150243,608,'Jaurian Bhattian S.O','147001',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150244,608,'Jhandi B.O','147007',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150245,608,'Jhansla B.O','140601',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150246,608,'Jindalpur B.O','147202',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150247,608,'Jogewal B.O','147105',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150248,608,'Jogipur B.O','147021',1,0,'2022-03-04 19:37:50','2022-03-04 19:37:50'),(150249,608,'Julkan B.O','147111',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150250,608,'Kakrala B.O','147102',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150251,608,'Kakrala B.O','147201',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150252,608,'Kaleh Majra B.O','147201',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150253,608,'Kalyan B.O','147005',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150254,608,'Kamalpur B.O','147101',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150255,608,'Karala B.O','140601',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150256,608,'Karhali B.O','147101',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150257,608,'Kartarpur B.O','147105',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150258,608,'Kaulgarh B.O','147203',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150259,608,'Kauli S.O','140701',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150260,608,'Khadauli B.O','140402',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150261,608,'Khanaura B.O','147202',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150262,608,'Khanewal B.O','147105',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150263,608,'Khanian B.O','147203',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150264,608,'Khanpur B.O','140701',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150265,608,'Khant B.O','140802',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150266,608,'Khera Gajju B.O','140602',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150267,608,'Kheri Gurna B.O','140417',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150268,608,'Kheri Mandlan B.O','147021',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150269,608,'Khumna B.O','147203',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150270,608,'Kotla B.O','140402',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150271,608,'KSM Rajpura S.O','140401',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150272,608,'Kularan B.O','147101',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150273,608,'Kulbanoo B.O','147102',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150274,608,'Kulburchan B.O','147101',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150275,608,'Kutbanpur B.O','147101',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150276,608,'Lachru Kalan B.O','140702',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150277,608,'Lang B.O','147006',1,0,'2022-03-04 19:37:51','2022-03-04 19:37:51'),(150278,608,'Law Court S.O','147001',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150279,608,'Lohar Majra Khurd B.O','140802',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150280,608,'Lohsimbly B.O','140702',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150281,608,'Lubana B.O','147201',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150282,608,'Machrai Kalan B.O','147203',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150283,608,'Mahadian B.O','140406',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150284,608,'Majithia Enclave S.O','147005',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150285,608,'Makrampur B.O','140406',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150286,608,'Mallewal B.O','147202',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150287,608,'Manakpur S.O','140602',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150288,608,'Mandauli B.O','140701',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150289,608,'Mandaur B.O','147201',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150290,608,'Manela B.O','141801',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150291,608,'Maneli B.O','141801',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150292,608,'Mangewal B.O','147202',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150293,608,'Marori B.O','147101',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150294,608,'Marru B.O','140702',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150295,608,'Massingan B.O','147111',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150296,608,'Matrauda B.O','147202',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150297,608,'Medical College S.O (Patiala)','147001',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150298,608,'Mirapur B.O','147111',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150299,608,'Mullepur B.O','147004',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150300,608,'Nabha S.O','147201',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150301,608,'Nagal Charbar B.O','140601',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150302,608,'Nainkalan B.O','147007',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150303,608,'Nandpur Kesho B.O','147004',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150304,608,'Nanhera B.O','140417',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150305,608,'Naraingarh B.O','147203',1,0,'2022-03-04 19:37:52','2022-03-04 19:37:52'),(150306,608,'Narru B.O','140701',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150307,608,'New Lal Bagh Colony S.O','147007',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150308,608,'New Rakhra B.O','147201',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150309,608,'Nial B.O','147105',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150310,608,'Nogawan B.O','140412',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150311,608,'Noorpur B.O','147203',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150312,608,'Pabri B.O','140701',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150313,608,'Panjokha B.O','140802',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150314,608,'Panjola B.O','147101',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150315,608,'Passiana B.O','147007',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150316,608,'Patiala City S.O','147001',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150317,608,'Patiala H.O','147001',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150318,608,'Patran S.O','147105',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150319,608,'Pola B.O','140402',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150320,608,'Ragho Majra Patiala S.O','147001',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150321,608,'Raisal B.O','147202',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150322,608,'Rajgarh B.O','147201',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150323,608,'Rajla B.O','147101',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150324,608,'Rajpura H.O','140401',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150325,608,'Rajpura Township S.O','140402',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150326,608,'Ramgarh B.O','140601',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150327,608,'Ramgarh B.O','147202',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150328,608,'Ramgarh B.O','147201',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150329,608,'Rampur Landiali B.O','140406',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150330,608,'Ranbirpura B.O','147005',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150331,608,'Rattangarh B.O','141801',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150332,608,'RGNUL Punjab Patiala S.O','147006',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150333,608,'Rohta B.O','147201',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150334,608,'Roorki B.O','147104',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150335,608,'Roshanpur B.O','147111',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150336,608,'Sadharanpur B.O','147102',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150337,608,'Sakrali B.O','147202',1,0,'2022-03-04 19:37:53','2022-03-04 19:37:53'),(150338,608,'Samana S.O','147101',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150339,608,'Samaspur B.O','147203',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150340,608,'Sanaur S.O','147103',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150341,608,'Sandharsi B.O','140417',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150342,608,'Saphera B.O','147007',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150343,608,'Sarala Kalan B.O','140702',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150344,608,'Sehra B.O','140701',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150345,608,'Shambhu S.O','140417',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150346,608,'Shambu Kalan B.O','140417',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150347,608,'Shamdoo B.O','140402',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150348,608,'Sheran Wala Gate Patiala S.O','147001',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150349,608,'Shergarh B.O','147105',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150350,608,'Shutrana B.O','147105',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150351,608,'Sidhpur kalan B.O','140802',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150352,608,'Sidhuwal B.O','147006',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150353,608,'Suhron B.O','140402',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150354,608,'Sular B.O','147007',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150355,608,'Taipur B.O','147105',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150356,608,'Talwandi Malik B.O','147101',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150357,608,'Tanda Badha B.O','147203',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150358,608,'Tarkheri B.O','147104',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150359,608,'Tepla B.O','140417',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150360,608,'Thuha B.O','140417',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150361,608,'Thuhi B.O','147201',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150362,608,'Tibbi B.O','147203',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150363,608,'Tiet S.O','147004',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150364,608,'Tohra B.O','147104',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150365,608,'Tripri S.O','147004',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150366,608,'Ugani B.O','140402',1,0,'2022-03-04 19:37:54','2022-03-04 19:37:54'),(150367,608,'University(Patiala) S.O','147002',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150368,608,'Untsar B.O','140417',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150369,608,'Urban Estate S.O (Patiala)','147002',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150370,608,'Urdan B.O','140602',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150371,608,'Wazidpur B.O','147007',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150372,609,'Agampur B.O','140118',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150373,609,'Anand Pur Sahib S.O','140118',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150374,609,'Bajrur B.O','140119',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150375,609,'Bandelhari B.O','140125',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150376,609,'Barsalpur B.O','140102',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150377,609,'Bass Bhabour B.O','140126',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150378,609,'Behrampur B.O','140125',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150379,609,'Bhallan B.O','140126',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150380,609,'Bhallari B.O','140126',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150381,609,'Bhanam B.O','140126',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150382,609,'Bhanupali S.O','140133',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150383,609,'Dhamana B.O','140119',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150384,609,'Dumna B.O','140102',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150385,609,'Jhaj B.O','140117',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150386,609,'Kainaur B.O','140102',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150387,609,'Kalwan B.O','140117',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150388,609,'Kiratpur Sahib S.O','140115',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150389,609,'Kotla Nihang B.O','140108',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150390,609,'Lutheri S.O','140102',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150391,609,'Makari B.O','140117',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150392,609,'Morinda S.O','140101',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150393,609,'Rollumajra B.O','140102',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150394,610,'Baddi Jhallian B.O','140111',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150395,610,'Ballamgarh B.O','140108',1,0,'2022-03-04 19:37:55','2022-03-04 19:37:55'),(150396,610,'Balongi B.O','160055',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150397,610,'Barwa B.O','140117',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150398,610,'Basali B.O','140117',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150399,610,'Bassian Brahman B.O','140413',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150400,610,'Bazidpur B.O','140111',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150401,610,'Behlolpur B.O','160014',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150402,610,'Behrampur Bet B.O','140111',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150403,610,'Behrampur Zimidari B.O','140108',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150404,610,'Bela S.O (Rupnagar)','140111',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150405,610,'Bhago Majra B.O','140307',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150406,610,'Bhairon Majra B.O','140111',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150407,610,'Bhaku Majra B.O','140112',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150408,610,'Bhallian B.O','140111',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150409,610,'Bhamnara B.O','140101',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150410,610,'Bhaowal B.O','140119',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150411,610,'Bharatgarh Canal Colony B.O','140114',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150412,610,'Bharatgarh S.O','140114',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150413,610,'Bhoje Majra B.O','140111',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150414,610,'Burmajra B.O','140103',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150415,610,'Chaklan B.O','140102',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150416,610,'Chamkaur Sahib S.O','140112',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150417,610,'Chanauli B.O','140117',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150418,610,'Chandigarh Sector 55 S.O','160055',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150419,610,'Chandigarh Sector 56 S.O','160055',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150420,610,'Chandigarh Sector 59 S.O','160059',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150421,610,'Chandigarh Sector 60 S.O','160059',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150422,610,'Chandigarh Sector 61 S.O','160062',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150423,610,'Chandigarh Sector 62 S.O','160062',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150424,610,'Chandigarh Sector 65 S.O','160062',1,0,'2022-03-04 19:37:56','2022-03-04 19:37:56'),(150425,610,'Chandigarh Sector 67 S.O','160062',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150426,610,'Chandigarh Sector 71 S.O','160071',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150427,610,'Chintgarh B.O','140103',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150428,610,'Cholta Khurd B.O','140301',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150429,610,'Chudiala Sudan B.O','140307',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150430,610,'Daon B.O','160055',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150431,610,'Daroli B.O','140133',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150432,610,'Daun Majra B.O','140301',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150433,610,'Dhanauri B.O','140103',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150434,610,'Dhangrali B.O','140101',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150435,610,'Dharamgarh B.O','140306',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150436,610,'Dher B.O','140133',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150437,610,'Dhobeta B.O','140124',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150438,610,'Dhurali B.O','140306',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150439,610,'Factory Area Nangal S.O','140126',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150440,610,'Fertilizer Factory Nangal S.O','140126',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150441,610,'Ganugwal S.O','140123',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150442,610,'Garangan B.O','140413',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150443,610,'Gardley B.O','140114',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150444,610,'Geega Majra B.O','140307',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150445,610,'Ghanauli S.O','140113',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150446,610,'Gharuan S.O','140413',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150447,610,'Gohlani B.O','140126',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150448,610,'Hafizabad B.O','140111',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150449,610,'Jandbari B.O','140133',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150450,610,'Jandpur B.O','140301',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150451,610,'Jatana B.O','140111',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150452,610,'Jatauli B.O','140117',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150453,610,'Jhallian Khurd B.O','140111',1,0,'2022-03-04 19:37:57','2022-03-04 19:37:57'),(150454,610,'Jhandian B.O','140119',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150455,610,'Jhingran Kalan B.O','140103',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150456,610,'Jhinjari B.O','140116',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150457,610,'Kahanpur Khui B.O','140117',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150458,610,'Kaishanpura B.O','140103',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150459,610,'Katlaur B.O','140112',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150460,610,'Katta Sabour B.O','140117',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150461,610,'Khamera B.O','140133',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150462,610,'Kharar S.O (Rupnagar)','140301',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150463,610,'Khera Kalmout B.O','140117',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150464,610,'Kheri Salabatpur B.O','140111',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150465,610,'Kotla Power House S.O','140116',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150466,610,'Kumbra B.O','140308',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150467,610,'Labour Colony Nangal S.O','140124',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150468,610,'Landran S.O','140307',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150469,610,'Lodhi Majra B.O','140113',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150470,610,'Machhlikalan B.O','140307',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150471,610,'Makrauna Kalan B.O','140102',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150472,610,'Malikpur B.O','140113',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150473,610,'Manakpur B.O','140125',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150474,610,'Manauli S.O','140306',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150475,610,'Mangewal B.O','140123',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150476,610,'Massewal B.O','140115',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150477,610,'Mauli Baidwan B.O','140308',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150478,610,'Mian Pur S.O','140108',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150479,610,'Minisectt Ropar S.O','140001',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150480,610,'Mojowal B.O','140126',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150481,610,'Mote Majra B.O','140306',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150482,610,'Nangal Dam S.O','140124',1,0,'2022-03-04 19:37:58','2022-03-04 19:37:58'),(150483,610,'Nangal Nikku B.O','140124',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150484,610,'Nangal Sirsa B.O','140113',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150485,610,'Nangal Talwara B.O','140124',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150486,610,'Nangal Township S.O','140124',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150487,610,'Naya Nangal Sector 2 S.O','140126',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150488,610,'Naya Shehar B.O','140301',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150489,610,'Nuhon Colony Ropar S.O','140113',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150490,610,'Nurpur Bedi S.O','140117',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150491,610,'Paharpur Samloh B.O','140116',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150492,610,'Parol B.O','140901',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150493,610,'Pathreri Jattan B.O','140108',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150494,610,'Phool Khurd B.O','140111',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150495,610,'Pratap Nagar Nangal S.O','140125',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150496,610,'Purkhali B.O','140108',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150497,610,'Raipur Kalan B.O','140306',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150498,610,'Rangilpur B.O','140108',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150499,610,'Rattangarh Ii B.O','140101',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150500,610,'Rauli Jhinjri B.O','140117',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150501,610,'Roorkee Pukhta B.O','140301',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150502,610,'Ropar H.O','140001',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150503,610,'Saheri B.O','140101',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150504,610,'Sainfalpur B.O','140108',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150505,610,'Samana Kalan B.O','140102',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150506,610,'Sandhwan B.O','140112',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150507,610,'Sihon Majra B.O','140103',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150508,610,'Singh Bhagwantpur B.O','140108',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150509,610,'Sohana S.O','140308',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150510,610,'Sotal B.O','140103',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150511,610,'Sukhshal B.O','140126',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150512,610,'Swamipur B.O','140126',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150513,610,'T.C.Kharar B.O','140301',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150514,610,'Tajpura B.O','140101',1,0,'2022-03-04 19:37:59','2022-03-04 19:37:59'),(150515,610,'Takhatgarh S.O','140119',1,0,'2022-03-04 19:38:00','2022-03-04 19:38:00'),(150516,610,'Tewar B.O','140301',1,0,'2022-03-04 19:38:00','2022-03-04 19:38:00'),(150517,610,'Thaluh B.O','140123',1,0,'2022-03-04 19:38:00','2022-03-04 19:38:00'),(150518,610,'Thana B.O','140117',1,0,'2022-03-04 19:38:00','2022-03-04 19:38:00'),(150519,610,'Thermal Plant Colony Ropar S.O','140001',1,0,'2022-03-04 19:38:00','2022-03-04 19:38:00'),(150520,610,'Tibba Taparian B.O','140119',1,0,'2022-03-04 19:38:00','2022-03-04 19:38:00'),(150521,610,'Tira B.O','160014',1,0,'2022-03-04 19:38:00','2022-03-04 19:38:00'),(150522,611,'Ahmedgarh s.O','148021',1,0,'2022-03-04 19:38:00','2022-03-04 19:38:00'),(150523,611,'Alloarakh B.O','148026',1,0,'2022-03-04 19:38:00','2022-03-04 19:38:00'),(150524,611,'Amargarh S.O (Sangrur)','148022',1,0,'2022-03-04 19:38:00','2022-03-04 19:38:00'),(150525,611,'Andana B.O','148027',1,0,'2022-03-04 19:38:00','2022-03-04 19:38:00'),(150526,611,'Badrukhan B.O','148002',1,0,'2022-03-04 19:38:00','2022-03-04 19:38:00'),(150527,611,'Badshahpur B.O','148024',1,0,'2022-03-04 19:38:00','2022-03-04 19:38:00'),(150528,611,'Bagrian S.O','148018',1,0,'2022-03-04 19:38:00','2022-03-04 19:38:00'),(150529,611,'Bahadurpur B.O','148002',1,0,'2022-03-04 19:38:00','2022-03-04 19:38:00'),(150530,611,'Bajwa B.O','148025',1,0,'2022-03-04 19:38:00','2022-03-04 19:38:00'),(150531,611,'Bakhora Kalan B.O','148031',1,0,'2022-03-04 19:38:00','2022-03-04 19:38:00'),(150532,611,'Bakshiwala B.O','148028',1,0,'2022-03-04 19:38:00','2022-03-04 19:38:00'),(150533,611,'Balad Kalan B.O','148026',1,0,'2022-03-04 19:38:00','2022-03-04 19:38:00'),(150534,611,'Balial B.O','148026',1,0,'2022-03-04 19:38:00','2022-03-04 19:38:00'),(150535,611,'Balian B.O','148002',1,0,'2022-03-04 19:38:00','2022-03-04 19:38:00'),(150536,611,'Balian B.O','148106',1,0,'2022-03-04 19:38:00','2022-03-04 19:38:00'),(150537,611,'Balran B.O','148033',1,0,'2022-03-04 19:38:00','2022-03-04 19:38:00'),(150538,611,'Bamal B.O','148024',1,0,'2022-03-04 19:38:00','2022-03-04 19:38:00'),(150539,611,'Banarsi B.O','148027',1,0,'2022-03-04 19:38:00','2022-03-04 19:38:00'),(150540,611,'Banbhaura B.O','148022',1,0,'2022-03-04 19:38:01','2022-03-04 19:38:01'),(150541,611,'Banbhauri B.O','148024',1,0,'2022-03-04 19:38:01','2022-03-04 19:38:01'),(150542,611,'Bangan B.O','148033',1,0,'2022-03-04 19:38:01','2022-03-04 19:38:01'),(150543,611,'Baradwal B.O','148024',1,0,'2022-03-04 19:38:01','2022-03-04 19:38:01'),(150544,611,'Bathan B.O','148022',1,0,'2022-03-04 19:38:01','2022-03-04 19:38:01'),(150545,611,'Batriana B.O','148026',1,0,'2022-03-04 19:38:01','2022-03-04 19:38:01'),(150546,611,'Benra B.O','148034',1,0,'2022-03-04 19:38:01','2022-03-04 19:38:01'),(150547,611,'Bhadaur S.O (Sangrur)','148102',1,0,'2022-03-04 19:38:01','2022-03-04 19:38:01'),(150548,611,'Bhai Ke Pishore B.O','148030',1,0,'2022-03-04 19:38:01','2022-03-04 19:38:01'),(150549,611,'Bhalwan S.O','148017',1,0,'2022-03-04 19:38:01','2022-03-04 19:38:01'),(150550,611,'Bharo B.O','148026',1,0,'2022-03-04 19:38:01','2022-03-04 19:38:01'),(150551,611,'Bhasaur B.O','148024',1,0,'2022-03-04 19:38:01','2022-03-04 19:38:01'),(150552,611,'Bhatian Khurd B.O','148018',1,0,'2022-03-04 19:38:01','2022-03-04 19:38:01'),(150553,611,'Bhattiwal Kalan B.O','148026',1,0,'2022-03-04 19:38:01','2022-03-04 19:38:01'),(150554,611,'Bhawanigarh S.O','148026',1,0,'2022-03-04 19:38:01','2022-03-04 19:38:01'),(150555,611,'Bhindran B.O','148001',1,0,'2022-03-04 19:38:01','2022-03-04 19:38:01'),(150556,611,'Bhogiwal B.O','148019',1,0,'2022-03-04 19:38:01','2022-03-04 19:38:01'),(150557,611,'Bhojowali B.O','148017',1,0,'2022-03-04 19:38:01','2022-03-04 19:38:01'),(150558,611,'Bhoodan B.O','148023',1,0,'2022-03-04 19:38:01','2022-03-04 19:38:01'),(150559,611,'Bhulan B.O','148027',1,0,'2022-03-04 19:38:01','2022-03-04 19:38:01'),(150560,611,'Bhullerheri B.O','148017',1,0,'2022-03-04 19:38:01','2022-03-04 19:38:01'),(150561,611,'Bhurthala Mander B.O','148023',1,0,'2022-03-04 19:38:01','2022-03-04 19:38:01'),(150562,611,'Bhutal Kalan B.O','148031',1,0,'2022-03-04 19:38:01','2022-03-04 19:38:01'),(150563,611,'Changal B.O','148034',1,0,'2022-03-04 19:38:01','2022-03-04 19:38:01'),(150564,611,'Changli B.O','148025',1,0,'2022-03-04 19:38:01','2022-03-04 19:38:01'),(150565,611,'Channo B.O','148026',1,0,'2022-03-04 19:38:01','2022-03-04 19:38:01'),(150566,611,'Chathe Roti Ram B.O','148028',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150567,611,'Chathe Sheikhan B.O','148002',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150568,611,'Chaunda B.O','148022',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150569,611,'Cheema S.O','148029',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150570,611,'Chhahar B.O','148035',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150571,611,'Chhajli S.O','148030',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150572,611,'Chotian B.O','148031',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150573,611,'Chural Kalan B.O','148033',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150574,611,'CR Malerkotla S.O','148023',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150575,611,'Daska B.O','148031',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150576,611,'Dehla B.O','148033',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150577,611,'Dehliz Kalan B.O','148021',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150578,611,'Dhadrian B.O','148106',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150579,611,'Dharamgarh B.O','148028',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150580,611,'Dhatogal B.O','148022',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150581,611,'Dhindsa B.O','148033',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150582,611,'Dhuri S.O','148024',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150583,611,'Dirba S.O','148035',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150584,611,'Dudian B.O','148033',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150585,611,'Duggan B.O','148002',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150586,611,'Fatehgarh Panjgrian B.O','148020',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150587,611,'Gaga Road S.O','148031',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150588,611,'Gaggarpur B.O','148002',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150589,611,'Ganduan B.O','148030',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150590,611,'Ghanaur Jattan B.O','148026',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150591,611,'Ghanaur Khurd B.O','148024',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150592,611,'Ghanauri Kalan B.O','148024',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150593,611,'Gharachon B.O','148026',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150594,611,'Ghorenab B.O','148031',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150595,611,'Gidrani B.O','148031',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150596,611,'Gobind Jawahar Ke B.O','148031',1,0,'2022-03-04 19:38:02','2022-03-04 19:38:02'),(150597,611,'Gobindgarh Khokhar B.O','148030',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150598,611,'Gowara B.O','148023',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150599,611,'Gujran B.O','148035',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150600,611,'Gurusagar Mastuana B.O','148002',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150601,611,'H R Sangrur S.O','148002',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150602,611,'Haider Nagar B.O','148023',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150603,611,'Hamirgarh B.O','148033',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150604,611,'Harchandpur B.O','148017',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150605,611,'Haryau B.O','148031',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150606,611,'Hassanpur B.O','148034',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150607,611,'Hathan B.O','148023',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150608,611,'Herike B.O','148025',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150609,611,'Himtana B.O','148023',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150610,611,'Hussainpura B.O','148023',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150611,611,'IA Malerkotla S.O','148023',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150612,611,'Jabbomajra B.O','148022',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150613,611,'Jakhepal B.O','148028',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150614,611,'Janal B.O','148035',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150615,611,'Jandali Khurd B.O','148021',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150616,611,'Jhall B.O','148022',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150617,611,'Jharon B.O','148029',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150618,611,'Jhuner B.O','148020',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150619,611,'Jitwal Kalan S.O','148019',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150620,611,'Kadial B.O','148035',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150621,611,'Kaheru B.O','148024',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150622,611,'Kakra B.O','148026',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150623,611,'Kalajhar B.O','148026',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150624,611,'Kalyan B.O','148020',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150625,611,'Kamalpur B.O','148035',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150626,611,'Kanakwal Bhanguan B.O','148028',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150627,611,'Kandhargarh B.O','148018',1,0,'2022-03-04 19:38:03','2022-03-04 19:38:03'),(150628,611,'Kanganwal B.O','148020',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150629,611,'Kanjla B.O','148034',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150630,611,'Kapial B.O','148026',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150631,611,'Katron B.O','148025',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150632,611,'Kauhrian B.O','148030',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150633,611,'Khadial B.O','148028',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150634,611,'Khanal Kalan B.O','148035',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150635,611,'Khanpur B.O','148023',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150636,611,'Khanpur Mandian B.O','148023',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150637,611,'Kheri B.O','148002',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150638,611,'Kheri Chehlan B.O','148025',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150639,611,'Khetla B.O','148035',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150640,611,'Khurd B.O','148020',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150641,611,'Kila Hakima B.O','148034',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150642,611,'Kothala B.O','148020',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150643,611,'Kotra Amru B.O','148028',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150644,611,'Kular  Khurd B.O','148002',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150645,611,'Kumbherwal B.O','148024',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150646,611,'Kup Kalan B.O','148019',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150647,611,'Lad Banjara B.O','148030',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150648,611,'Ladda S.O','148034',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150649,611,'Lassoi B.O','148023',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150650,611,'Lehal Kalan B.O','148033',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150651,611,'Lehragaga S.O','148031',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150652,611,'Loha Khera B.O','148106',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150653,611,'Longowal S.O','148106',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150654,611,'Maholi Kalan B.O','148021',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150655,611,'Majhi B.O','148026',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150656,611,'Makorar Sahib B.O','148033',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150657,611,'Malerkotla S.O','148023',1,0,'2022-03-04 19:38:04','2022-03-04 19:38:04'),(150658,611,'Mander Kalan B.O','148106',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150659,611,'Mandi Bhadur Singh Wala B.O','148034',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150660,611,'Mandvi B.O','148027',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150661,611,'Mangwal B.O','148002',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150662,611,'Maniana B.O','148033',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150663,611,'Manki B.O','148020',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150664,611,'Manvi B.O','148023',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150665,611,'Mauran B.O','148035',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150666,611,'Meemsa B.O','148017',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150667,611,'Mehlan B.O','148002',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150668,611,'Mehsampur B.O','148017',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150669,611,'Mini Secteriate Sangrur S.O','148001',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150670,611,'Mithewal B.O','148020',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150671,611,'Mohamedpur B.O','148020',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150672,611,'Mojowal B.O','148030',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150673,611,'Moonak S.O','148033',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150674,611,'Mubarkpur B.O','148023',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150675,611,'Mullabadha B.O','148022',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150676,611,'Mullowal B.O','148024',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150677,611,'N G M Sangrur S.O','148001',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150678,611,'Nadampur B.O','148026',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150679,611,'Nagra B.O','148026',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150680,611,'Namol B.O','148106',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150681,611,'Nangla B.O','148030',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150682,611,'Nathu Majra B.O','148021',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150683,611,'Nawangaon B.O','148033',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150684,611,'Nilowal B.O','148028',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150685,611,'Pakki Khanauri S.O','148027',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150686,611,'Phalera B.O','148031',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150687,611,'Punnewal B.O','148034',1,0,'2022-03-04 19:38:05','2022-03-04 19:38:05'),(150688,611,'Raidharana B.O','148033',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150689,611,'Rajomajra B.O','148024',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150690,611,'Ram Nagar Chhana B.O','148025',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150691,611,'Rampur Gujran B.O','148033',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150692,611,'Rangian B.O','148024',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150693,611,'Rogla B.O','148035',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150694,611,'Rohira B.O','148021',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150695,611,'Roorkee Kalan B.O','148023',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150696,611,'Sahoke B.O','148106',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150697,611,'Sakraudi B.O','148026',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150698,611,'Samuran B.O','148035',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150699,611,'Sandhaur S.O','148020',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150700,611,'Sangala B.O','148023',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150701,611,'Sangatpura B.O','148031',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150702,611,'Sangrur H.O','148001',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150703,611,'Sangrur Kty S.O','148001',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150704,611,'Saraud B.O','148023',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150705,611,'Saron B.O','148034',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150706,611,'Shadihari B.O','148033',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150707,611,'Shahpur kalan B.O','148029',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150708,611,'Shergar Cheema B.O','148020',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150709,611,'Sheron B.O','148106',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150710,611,'Sherpur S.O','148025',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150711,611,'Sliet Longowal S.O','148106',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150712,611,'Sr Dhuri S.O','148024',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150713,611,'Sukhpura Maur B.O','148108',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150714,611,'Sulargharat B.O','148035',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150715,611,'Sunam City S.O','148028',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150716,611,'Sunam S.O','148028',1,0,'2022-03-04 19:38:06','2022-03-04 19:38:06'),(150717,611,'Tapa S.O','148108',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150718,611,'Tibba B.O','148025',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150719,611,'Ubhewal B.O','148002',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150720,611,'Ugrahan B.O','148030',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150721,611,'Uppli B.O','148002',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150722,612,'Aima Kalan B.O','143301',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150723,612,'Algon Khurd B.O','143419',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150724,612,'Alipur B.O','143412',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150725,612,'Allowal B.O','143111',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150726,612,'Amarkot B.O','143419',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150727,612,'Asal Autar B.O','143419',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150728,612,'Bahmniwala B.O','143304',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150729,612,'Barwala B.O','143416',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150730,612,'Bath B.O','143406',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150731,612,'Beharipura B.O','143118',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150732,612,'Bhagiari B.O','143301',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150733,612,'Bhagupura B.O','143416',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150734,612,'Bhai Ladhu B.O','143304',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150735,612,'Bhangala B.O','143416',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150736,612,'Bharowal B.O','143117',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150737,612,'Bhatte Bhaini B.O','143416',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150738,612,'Bhikhiwind S.O','143303',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150739,612,'Bhoprai B.O','143416',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150740,612,'Bhucher Kalan B.O','143302',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150741,612,'Bhure Kohna B.O','143419',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150742,612,'Bhure Nau B.O','143419',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150743,612,'Bhuse B.O','143107',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150744,612,'Chabhal S.O','143301',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150745,612,'Chamba Kalan B.O','143408',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150746,612,'Chhina Bidhi Chand B.O','143305',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150747,612,'Chohla Sahib S.O','143408',1,0,'2022-03-04 19:38:07','2022-03-04 19:38:07'),(150748,612,'Chuslewar B.O','143304',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150749,612,'Daburji B.O','143022',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150750,612,'Dadupura B.O','143601',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150751,612,'Deo B.O','143406',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150752,612,'Dhunda B.O','143422',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150753,612,'Dhundhai Wala B.O','143408',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150754,612,'Dibbi Pura B.O','143419',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150755,612,'Dubli B.O','143416',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150756,612,'Galalipur B.O','143415',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150757,612,'Gandiwind Dhattal B.O','143410',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150758,612,'Gharka Buwala B.O','143408',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150759,612,'Gharyala B.O','143416',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150760,612,'Goindwal S.O','143422',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150761,612,'Hothian B.O','143118',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150762,612,'Jahangir B.O','143501',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150763,612,'Jalalabad B.O','143118',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150764,612,'Jalalusman B.O','143114',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150765,612,'Jaunke B.O','143412',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150766,612,'Jaura B.O','143415',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150767,612,'Jhandher M Purkhan B.O','143422',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150768,612,'Johal Raju Singh B.O','143402',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150769,612,'Kalia Sanktra B.O','143419',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150770,612,'Kalsian Kalan B.O','143304',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150771,612,'Khawaspur B.O','143407',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150772,612,'Khem Karan S.O','143419',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150773,612,'Khojkipur B.O','143112',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150774,612,'Kirtowal B.O','143412',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150775,612,'Kot Budha B.O','143416',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150776,612,'Lalpura B.O','143411',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150777,612,'Mahaneke Jandh B.O','143416',1,0,'2022-03-04 19:38:08','2022-03-04 19:38:08'),(150778,612,'Manak Dheke B.O','143422',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150779,612,'Manawala Kalan B.O','143115',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150780,612,'Manawala Khurd B.O','143413',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150781,612,'Munda Pind B.O','143407',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150782,612,'Nandpur B.O','143415',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150783,612,'Pakhoke B.O','143406',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150784,612,'Pandori Gola B.O','143402',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150785,612,'Pandori Ransingh B.O','143402',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150786,612,'Pandori Takhtmal B.O','143402',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150787,612,'Patti S.O (Tarn Taran)','143416',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150788,612,'Phulke B.O','143411',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150789,612,'Pindian B.O','143118',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150790,612,'Police Lines Tarn Taran SO','143402',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150791,612,'Pringri B.O','143412',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150792,612,'Qilla Kavi Santokh B.O','143402',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150793,612,'Rampur Bhootwind B.O','143118',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150794,612,'Rani Villa B.O','143409',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150795,612,'Rasulpur Kalan B.O','143113',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150796,612,'Ruriwala B.O','143408',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150797,612,'Rusulpur B.O','143411',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150798,612,'Sabhra B.O','143416',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150799,612,'Saidpur B.O','143416',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150800,612,'Sakhira B.O','143415',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150801,612,'Sarhali S.O (Tarn Taran)','143410',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150802,612,'Shahbazpura B.O','143415',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150803,612,'Shaheed B.O','143416',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150804,612,'Sheikh B.O','143415',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150805,612,'Sur Singh S.O','143302',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150806,612,'Takarpura B.O','143416',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150807,612,'Tarn Taran H.O','143401',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150808,612,'Thathgarh B.O','143009',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150809,612,'Thathi Khara B.O','143402',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150810,612,'Tur B.O','143411',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150811,612,'Uppal B.O','143112',1,0,'2022-03-04 19:38:09','2022-03-04 19:38:09'),(150812,612,'Usman B.O','143411',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150813,612,'Vain Poin B.O','143117',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150814,612,'Vairowal Bawian B.O','143118',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150815,612,'Vairowal S.O','143118',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150816,612,'Varnala B.O','143416',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150817,612,'Wan Tara Singh B.O','143305',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150818,612,'Warah B.O','143409',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150819,613,'Aina B.O','263652',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150820,613,'Almora Court S.O','263601',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150821,613,'Ajoli Malli B.O','263646',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150822,613,'Almora College ED B.O','263601',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150823,613,'Almora H.O','263601',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150824,613,'Amdhar B.O','263676',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150825,613,'Airari Bisht B.O','263665',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150826,613,'Almiankande B.O','263645',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150827,613,'Amyari B.O','263645',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150828,613,'Andoli B.O','263623',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150829,613,'Anuli B.O','263625',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150830,613,'Asgoli ED B.O','263653',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150831,613,'Ayarpani B.O','263601',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150832,613,'Badiyar B.O','263622',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150833,613,'Bagswar B.O','263626',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150834,613,'Bagwalipokhar S.O','263621',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150835,613,'Bainskhet B.O','263655',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150836,613,'Bajwar B.O','263601',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150837,613,'Baldhoti S.O','263601',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150838,613,'Balta B.O','263601',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150839,613,'Bamanswal B.O','263623',1,0,'2022-03-04 19:38:10','2022-03-04 19:38:10'),(150840,613,'Bamsyun B.O','263645',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150841,613,'Bangidhar B.O','263676',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150842,613,'Banthok B.O','263623',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150843,613,'Barangal B.O','263659',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150844,613,'Barechhina S.O','263624',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150845,613,'Barsimi B.O','263636',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150846,613,'Basai B.O','263661',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150847,613,'Basantpur B.O','263626',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150848,613,'Basbhira B.O','263653',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150849,613,'Basoli B.O','263622',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150850,613,'Basot B.O','263680',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150851,613,'Bawari Kichar B.O','263665',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150852,613,'Bayeri B.O','263663',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150853,613,'Bedchula B.O','263625',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11');
INSERT INTO `cities` VALUES (150854,613,'Bergaon B.O','263678',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150855,613,'Bey B.O','263601',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150856,613,'Bhabu B.O','263626',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150857,613,'Bhagoti B.O','263656',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150858,613,'Bhagtola ED B.O','263636',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150859,613,'Bhainsar Gaon B.O','263637',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150860,613,'Bhainsiachhana B.O','263624',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150861,613,'Bhainsoli B.O','263652',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150862,613,'Bhainsori ED B.O','263601',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150863,613,'Bhanoli ED B.O','263622',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150864,613,'Bhatkhola B.O','263601',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150865,613,'Bhatkote B.O','263656',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150866,613,'Bhatronjkhan S.O','263646',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150867,613,'Bhaunkhal B.O','263646',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150868,613,'Bheltgaon B.O','263656',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150869,613,'Bhikiyasen S.O','263667',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150870,613,'Bhoolgaon B.O','263637',1,0,'2022-03-04 19:38:11','2022-03-04 19:38:11'),(150871,613,'Bhujan B.O','263645',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150872,613,'Bhyari B.O','263676',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150873,613,'Billekh B.O','263663',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150874,613,'Binta B.O','263621',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150875,613,'Birkham B.O','263626',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150876,613,'Birkola B.O','263622',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150877,613,'Birora B.O','263601',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150878,613,'Bisrakhet B.O','263661',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150879,613,'Bitholi B.O','263653',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150880,613,'Chachroti B.O','263661',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150881,613,'Chagethi B.O','263623',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150882,613,'Chaikhan B.O','263625',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150883,613,'Chakargaon B.O','263659',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150884,613,'Chamarkhan B.O','263664',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150885,613,'Chamkana B.O','263676',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150886,613,'Chamtola B.O','263622',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150887,613,'Chanoda S.O','263629',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150888,613,'Chantharia B.O','263653',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150889,613,'Charchalikhan B.O','263623',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150890,613,'Chaubattia S.O','263651',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150891,613,'Chaukuni B.O','263645',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150892,613,'Chaumu Uchyur B.O','263601',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150893,613,'Chaun Dungri B.O','263622',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150894,613,'Chaunallia S.O','263680',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150895,613,'Chaunsli B.O','263601',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150896,613,'Chelchhina B.O','263623',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150897,613,'Chhana B.O','263645',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150898,613,'Chhana Kharkota B.O','263626',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150899,613,'Chhatena B.O','263653',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150900,613,'Chhatgulla B.O','263653',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150901,613,'Chhitar B.O','263656',1,0,'2022-03-04 19:38:12','2022-03-04 19:38:12'),(150902,613,'Chilianaula B.O','263645',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150903,613,'Chitai B.O','263601',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150904,613,'Chitreshwar B.O','263653',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150905,613,'Dabhra B.O','263667',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150906,613,'Dal B.O','263601',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150907,613,'Dania S.O','263622',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150908,613,'Darmar B.O','263645',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150909,613,'Darmar Tikhun B.O','263643',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150910,613,'Dasolibadiyar B.O','263622',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150911,613,'Daula S.O','263660',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150912,613,'Daulaghat S.O','263655',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150913,613,'Dauligarh B.O','263622',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150914,613,'Daurakhal B.O','263664',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150915,613,'Debikhal B.O','263676',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150916,613,'Deghat S.O','263659',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150917,613,'Deolikhan B.O','263643',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150918,613,'Deolikhet S.O','263664',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150919,613,'Dhamas B.O','263601',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150920,613,'Dhamdewal B.O','263656',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150921,613,'Dhamera B.O','263660',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150922,613,'Dharkhola B.O','263625',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150923,613,'Dhauladevi ED B.O','263623',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150924,613,'Dhaulara Totashilling B.O','263629',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150925,613,'Dhaularh B.O','263637',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150926,613,'Dhaulchhina ED B.O','263624',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150927,613,'Dhaunigarh B.O','263637',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150928,613,'Dhaura B.O','263601',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150929,613,'Dhura B.O','263622',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150930,613,'Dhyari B.O','263622',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150931,613,'Dhyuli B.O','263625',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150932,613,'Dinapani B.O','263601',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150933,613,'Doram B.O','263623',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150934,613,'Dova B.O','263601',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150935,613,'Dunagiri B.O','263653',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150936,613,'Dunar B.O','263623',1,0,'2022-03-04 19:38:13','2022-03-04 19:38:13'),(150937,613,'Dwarahat S.O','263653',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150938,613,'Dwarson B.O','263652',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150939,613,'Gairkhet B.O','263658',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150940,613,'Ganai S.O','263656',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150941,613,'Ganiadeoli B.O','263645',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150942,613,'Garanabanj B.O','263623',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150943,613,'Garkote Malla B.O','263676',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150944,613,'Gewapani B.O','263655',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150945,613,'Gewar B.O','263653',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150946,613,'Ghatti B.O','263646',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150947,613,'Ghuguti Kelani B.O','263659',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150948,613,'Godi B.O','263656',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150949,613,'Golchhina B.O','263655',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150950,613,'Gudlekh B.O','263661',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150951,613,'Gunaditya B.O','263623',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150952,613,'Gurkande B.O','263636',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150953,613,'Haldiyani B.O','263645',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150954,613,'Harara B.O','263646',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150955,613,'Hawalbagh S.O','263636',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150956,613,'I.T.I. Almora B.O','263601',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150957,613,'Irah B.O','263653',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150958,613,'Jageshwar B.O','263623',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150959,613,'Jaikhal B.O','263659',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150960,613,'Jainti S.O','263626',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150961,613,'Jairambakhal B.O','263656',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150962,613,'Jakh B.O','263646',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150963,613,'Jakh B.O','263625',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150964,613,'Jalali ED B.O','263653',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150965,613,'Jalna S.O','263625',1,0,'2022-03-04 19:38:14','2022-03-04 19:38:14'),(150966,613,'Jamoli B.O','263667',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150967,613,'Jaurasi B.O','263656',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150968,613,'Jayanteshwar Simalchaura B.O','263661',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150969,613,'Jeoli B.O','263643',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150970,613,'Jhaldungra B.O','263626',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150971,613,'Jhankarsaim B.O','263623',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150972,613,'Jharkote B.O','263658',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150973,613,'Jhimar B.O','263676',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150974,613,'Jhupulchaura B.O','263637',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150975,613,'Jingoli Toli B.O','263622',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150976,613,'Kafalisuwakhan B.O','263623',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150977,613,'Kafalni B.O','263622',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150978,613,'Kafalta Malla B.O','263676',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150979,613,'Kafara ED B.O','263645',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150980,613,'Kafarkhan B.O','263601',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150981,613,'Kalika Estate B.O','263645',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150982,613,'Kanarichhina B.O','263624',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150983,613,'Kanoli B.O','263664',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150984,613,'Kantali B.O','263639',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150985,613,'Kasermanya B.O','263623',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150986,613,'Kathpuria B.O','263643',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150987,613,'Kausani Estate S.O','263620',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150988,613,'Kausani S.O','263639',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150989,613,'Kayala B.O','263643',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150990,613,'Kelani B.O','263661',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150991,613,'Khadalgaon B.O','263661',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150992,613,'Khalna B.O','263653',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150993,613,'Kharaun B.O','263601',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150994,613,'Khastilari B.O','263624',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150995,613,'Khatiyola B.O','263622',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150996,613,'Khatyari B.O','263656',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150997,613,'Kheti B.O','263622',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150998,613,'Khira B.O','263656',1,0,'2022-03-04 19:38:15','2022-03-04 19:38:15'),(150999,613,'Khirkhet B.O','263645',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151000,613,'Khola B.O','263623',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151001,613,'Khumar B.O','263676',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151002,613,'Kirara B.O','263601',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151003,613,'Kosi S.O (Almora)','263643',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151004,613,'Kotagiwai B.O','263680',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151005,613,'Kotar B.O','263663',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151006,613,'Kotuli Malli B.O','263646',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151007,613,'Kulanteshwar B.O','263661',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151008,613,'Kulsibi B.O','263652',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151009,613,'Kunhil B.O','263667',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151010,613,'Kuwali B.O','263652',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151011,613,'Lakhani B.O','263639',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151012,613,'Lala Bazar S.O','263601',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151013,613,'Lamagara B.O','263625',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151014,613,'Laubanj B.O','263639',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151015,613,'Laxmeshwar S.O','263601',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151016,613,'Lod B.O','263637',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151017,613,'Lodhia B.O','263601',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151018,613,'Lweshal B.O','263629',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151019,613,'Machhor B.O','263646',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151020,613,'Mahakaleshwar B.O','263653',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151021,613,'Maharagaon B.O','263623',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151022,613,'Maithani B.O','263676',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151023,613,'Majkhali S.O','263652',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151024,613,'Manan S.O','263638',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151025,613,'Manela B.O','263645',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151026,613,'Mangalta B.O','263624',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151027,613,'Mangdoli B.O','263645',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151028,613,'Manhet B.O','263676',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151029,613,'Maniagar B.O','263624',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151030,613,'Manila B.O','263667',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151031,613,'Manuli B.O','263667',1,0,'2022-03-04 19:38:16','2022-03-04 19:38:16'),(151032,613,'Marku Bakhal B.O','263656',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151033,613,'Masar B.O','263645',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151034,613,'Masi S.O','263658',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151035,613,'Matela S.O','263665',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151036,613,'Mathena B.O','263625',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151037,613,'Maulekhal S.O','263676',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151038,613,'Mayoli B.O','263622',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151039,613,'Mirai Malli B.O','263645',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151040,613,'Mirtola B.O','263623',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151041,613,'Motiapathar B.O','263625',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151042,613,'Munani B.O','263659',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151043,613,'Nagarjhan B.O','263653',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151044,613,'Nagarkhan B.O','263624',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151045,613,'Naikana B.O','263658',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151046,613,'Nail B.O','263625',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151047,613,'Nail Chaukote B.O','263665',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151048,613,'Naila B.O','263660',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151049,613,'Naini B.O','263623',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151050,613,'Nali B.O','263623',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151051,613,'Naraindewal B.O','263624',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151052,613,'Naubara B.O','263660',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151053,613,'Naughar Estate B.O','263639',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151054,613,'Naula B.O','263658',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151055,613,'Naulakote B.O','263621',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151056,613,'Naura B.O','263625',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151057,613,'Neoliharara B.O','263623',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151058,613,'Painsia B.O','263676',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151059,613,'Paithani B.O','263653',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151060,613,'Pali B.O','263680',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151061,613,'Palyun B.O','263624',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151062,613,'Pandekota B.O','263645',1,0,'2022-03-04 19:38:17','2022-03-04 19:38:17'),(151063,613,'Panduwakhal B.O','263656',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151064,613,'Pantgaon B.O','263680',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151065,613,'Pantkotuli B.O','263645',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151066,613,'Panuwadeokhan B.O','263646',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151067,613,'Panuwanaula S.O','263623',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151068,613,'Patalibangar B.O','263636',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151069,613,'Patharkhola B.O','263661',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151070,613,'Patia B.O','263601',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151071,613,'Petshal B.O','263601',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151072,613,'Pilkha B.O','263601',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151073,613,'Pilkholi ED B.O','263645',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151074,613,'Pipalkhal B.O','263661',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151075,613,'Pipna B.O','263676',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151076,613,'Pitoli B.O','263622',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151077,613,'Pokhari B.O','263638',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151078,613,'Pokhari B.O','263622',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151079,613,'Pokharkhali S.O','263601',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151080,613,'Pubhaon B.O','263626',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151081,613,'Querala B.O','263667',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151082,613,'Rajyura B.O','263626',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151083,613,'Ramara B.O','263655',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151084,613,'Rampur B.O','263656',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151085,613,'Ranban B.O','263638',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151086,613,'Ranikhet H.O','263645',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151087,613,'Ranikhet Kutchery S.O','263645',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151088,613,'Ranikhet Sadar Bazar S.O','263645',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151089,613,'Rasyaragaon B.O','263637',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151090,613,'Ratgal B.O','263652',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151091,613,'Rikhe B.O','263655',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151092,613,'Rikhon B.O','263659',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151093,613,'Rotapani B.O','263658',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151094,613,'Rudoli B.O','263661',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151095,613,'Sagneti B.O','263664',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151096,613,'Sainj B.O','263624',1,0,'2022-03-04 19:38:18','2022-03-04 19:38:18'),(151097,613,'Sainmanur B.O','263667',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151098,613,'Saknara B.O','263667',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151099,613,'Salla Bhatkote B.O','263624',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151100,613,'Salparh B.O','263622',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151101,613,'Sanara B.O','263658',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151102,613,'Sarikhet B.O','263661',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151103,613,'Satyun B.O','263625',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151104,613,'Sauni B.O','263663',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151105,613,'Seem B.O','263680',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151106,613,'Shaharphatak B.O','263625',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151107,613,'Shishuwa B.O','263663',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151108,613,'Shitalakhet S.O','263678',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151109,613,'Silor Mahadev B.O','263645',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151110,613,'Sinar B.O','263667',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151111,613,'Sinora B.O','263645',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151112,613,'Someshwar S.O','263637',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151113,613,'Sona Shilling B.O','263622',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151114,613,'Sunoli B.O','263601',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151115,613,'Sure B.O','263653',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151116,613,'Suri B.O','263678',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151117,613,'Syalde S.O','263661',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151118,613,'Syalidhar B.O','263601',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151119,613,'Syunani B.O','263625',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151120,613,'Takula S.O','263628',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151121,613,'Tamadhaun B.O','263661',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151122,613,'Tapani B.O','263622',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151123,613,'Taragtal B.O','263656',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151124,613,'Tarikhet S.O','263663',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151125,613,'Taya B.O','263680',1,0,'2022-03-04 19:38:19','2022-03-04 19:38:19'),(151126,613,'Thali B.O','263622',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151127,613,'Thapania B.O','263636',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151128,613,'Thikalna B.O','263623',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151129,613,'Timilkhal B.O','263658',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151130,613,'Timtha B.O','263660',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151131,613,'Tolyun B.O','263646',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151132,613,'Totam B.O','263646',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151133,613,'Turachaura B.O','263658',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151134,613,'Udepur B.O','263661',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151135,613,'Ugalia B.O','263680',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151136,613,'Ujrar B.O','263667',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151137,613,'Unyura B.O','263625',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151138,613,'Uprari Chaukote B.O','263659',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151139,613,'Uprari ED B.O','263645',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151140,613,'Vikas Bhawan Almora S.O','263601',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151141,613,'Zoor B.O','263601',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151142,613,'Bhairongkhal B.O','244715',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151143,613,'Burakote B.O','244715',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151144,613,'Devayal B.O','244715',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151145,613,'Riquwasi B.O','244715',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151146,613,'Sankar B.O','244715',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151147,613,'Thala Manral B.O','244715',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151148,613,'Tukura B.O','244715',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151149,613,'Unura B.O','263138',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151150,614,'Amsarkote B.O','263642',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151151,614,'Anna B.O','263641',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151152,614,'Are B.O','263642',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151153,614,'Ason B.O','263642',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151154,614,'Ason Mallakote B.O','263628',1,0,'2022-03-04 19:38:20','2022-03-04 19:38:20'),(151155,614,'Badiakote B.O','263632',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151156,614,'Bageshwar S.O','263642',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151157,614,'Baghar B.O','263632',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151158,614,'Bahuli B.O','263642',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151159,614,'Baijnath S.O (Bageshwar)','263641',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151160,614,'Baira B.O','263634',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151161,614,'Baisani B.O','263642',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151162,614,'Bamrari B.O','263641',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151163,614,'Banlekh B.O','263634',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151164,614,'Bantoli B.O','263641',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151165,614,'Bauri B.O','263628',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151166,614,'Bhairu Chaubatta B.O','263619',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151167,614,'Bhanar B.O','263633',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151168,614,'Bhantola B.O','263640',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151169,614,'Bharari S.O','263679',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151170,614,'Bhataura B.O','263619',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151171,614,'Bhatoli B.O','263642',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151172,614,'Bheta B.O','263641',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151173,614,'Bhilkote B.O','263635',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151174,614,'Billori S.O','263630',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151175,614,'Bilonasera B.O','263642',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151176,614,'Bohala B.O','263628',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151177,614,'Chamarthal B.O','263619',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151178,614,'Charson B.O','263635',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151179,614,'Chaura B.O','263619',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151180,614,'Chhani B.O','263628',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151181,614,'Chirang B.O','263642',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151182,614,'Collectorate Bageshwar S.O','263642',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151183,614,'Dangoli S.O','263635',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151184,614,'Darimthok B.O','263642',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151185,614,'Daula B.O','263632',1,0,'2022-03-04 19:38:21','2022-03-04 19:38:21'),(151186,614,'Deonai B.O','263641',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151187,614,'Dewal Bichral B.O','263631',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151188,614,'Dewalchaura B.O','263642',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151189,614,'Dewaldhar B.O','263630',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151190,614,'Dhapolasera B.O','263631',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151191,614,'Dhapti B.O','263640',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151192,614,'Doba Katyur B.O','263642',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151193,614,'Dofar S.O','263634',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151194,614,'Falyati B.O','263642',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151195,614,'Farsali B.O','263679',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151196,614,'Fulwari B.O','263632',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151197,614,'Gadera B.O','263642',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151198,614,'Gagarigole ED B.O','263641',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151199,614,'Gairar B.O','263619',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151200,614,'Gananath Vidyapeeth B.O','263628',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151201,614,'Gasi B.O','263679',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151202,614,'Ghingartola S.O','263619',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151203,614,'Ghiroli B.O','263642',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151204,614,'Gogina B.O','263633',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151205,614,'Guler B.O','263679',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151206,614,'Gurna Kamsyar B.O','263619',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151207,614,'Harbarh B.O','263642',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151208,614,'Harkote B.O','263679',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151209,614,'Harsila B.O','263642',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151210,614,'Harsingiabaghar B.O','263679',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151211,614,'Horali B.O','263634',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151212,614,'Jagthana B.O','263642',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151213,614,'Jakhani B.O','263640',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151214,614,'Jakhera B.O','263635',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151215,614,'Jamrari B.O','263624',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151216,614,'Janoti Palari B.O','263630',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151217,614,'Jarati B.O','263634',1,0,'2022-03-04 19:38:22','2022-03-04 19:38:22'),(151218,614,'Jaulkande B.O','263642',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151219,614,'Jethai B.O','263631',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151220,614,'Jhankra B.O','263640',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151221,614,'Jhuni B.O','263679',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151222,614,'Junayal B.O','263634',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151223,614,'Kafali B.O','263634',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151224,614,'Kafaligair B.O','263628',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151225,614,'Kameridevi S.O','263640',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151226,614,'Kanda S.O','263631',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151227,614,'Kandhar B.O','263635',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151228,614,'Kanoli B.O','263633',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151229,614,'Kanyalikote B.O','263642',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151230,614,'Kapkote S.O','263632',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151231,614,'Kapkoti B.O','263641',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151232,614,'Kapoori B.O','263631',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151233,614,'Karmi B.O','263632',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151234,614,'Kathayatbara B.O','263642',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151235,614,'Kathpurchhina B.O','263628',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151236,614,'Khankar B.O','263628',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151237,614,'Khantoli B.O','263640',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151238,614,'Khati B.O','263679',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151239,614,'Khatigaon B.O','263631',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151240,614,'Khaulsir B.O','263628',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151241,614,'Kheti(Danpur) B.O','263633',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151242,614,'Kotiyura B.O','263635',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151243,614,'Kulaon B.O','263635',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151244,614,'Lahur B.O','263679',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151245,614,'Lathi B.O','263633',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151246,614,'Lili B.O','263632',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151247,614,'Liti B.O','263633',1,0,'2022-03-04 19:38:23','2022-03-04 19:38:23'),(151248,614,'Lob B.O','263628',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151249,614,'Loharkhet B.O','263679',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151250,614,'Mahruri B.O','263640',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151251,614,'Maigri Estate B.O','263635',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151252,614,'Malsoona B.O','263640',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151253,614,'Malta B.O','263642',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151254,614,'Mandalsera B.O','263642',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151255,614,'Mantoli B.O','263631',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151256,614,'Matena B.O','263641',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151257,614,'Mostgaon B.O','263641',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151258,614,'Nachati B.O','263679',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151259,614,'Namtichetabagar B.O','263633',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151260,614,'Nargarha B.O','263679',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151261,614,'Nargoli B.O','263631',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151262,614,'Okhalisirod B.O','263628',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151263,614,'Okhalson B.O','263641',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151264,614,'Pandrapali B.O','263642',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151265,614,'Papon B.O','263634',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151266,614,'Patli B.O','263641',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151267,614,'Payya B.O','263635',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151268,614,'Pinglow B.O','263635',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151269,614,'Pothing B.O','263632',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151270,614,'Purkuni B.O','263642',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151271,614,'Queralli B.O','263642',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151272,614,'Ratirketi B.O','263633',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151273,614,'Ratisera B.O','263635',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151274,614,'Rawaikhal B.O','263641',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151275,614,'Rawatsera B.O','263631',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151276,614,'Salani B.O','263635',1,0,'2022-03-04 19:38:24','2022-03-04 19:38:24'),(151277,614,'Saneti B.O','263634',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151278,614,'Sangarh B.O','263634',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151279,614,'Sani Udiyar B.O','263631',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151280,614,'Shama S.O','263633',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151281,614,'Simgari B.O','263640',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151282,614,'Simkuna B.O','263631',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151283,614,'Simsyari B.O','263628',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151284,614,'Sirkote B.O','263635',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151285,614,'Sorag B.O','263632',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151286,614,'Supi B.O','263679',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151287,614,'Syaldova B.O','263619',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151288,614,'Syankote B.O','263640',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151289,614,'Tachhani B.O','263619',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151290,614,'Tilsari B.O','263641',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151291,614,'Tuper B.O','263642',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151292,614,'Udera B.O','263642',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151293,614,'Uprara B.O','263631',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151294,614,'Utraura B.O','263632',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151295,614,'Vijaipur B.O','263640',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151296,614,'Wajyula B.O','263635',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151297,615,'Adibadri S.O','246440',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151298,615,'Ali B.O','246446',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151299,615,'Andrapa B.O','246428',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151300,615,'Aser Simli B.O','246455',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151301,615,'Bachher B.O','246424',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151302,615,'Bachhuwaban S.O','246486',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151303,615,'Badrinath Seasonal S.O','246422',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151304,615,'Bagana B.O','246449',1,0,'2022-03-04 19:38:25','2022-03-04 19:38:25'),(151305,615,'Bagoli B.O','246444',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151306,615,'Bainoli B.O','246487',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151307,615,'Bairangana B.O','246401',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151308,615,'Balan B.O','246427',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151309,615,'Bampa Seasonal B.O','246443',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151310,615,'Ban B.O','246427',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151311,615,'Bangali B.O','246435',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151312,615,'Banjbagar B.O','246435',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151313,615,'Bansbara B.O','246449',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151314,615,'Baragaon B.O','246443',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151315,615,'Barmoli B.O','246488',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151316,615,'Bartoli B.O','246429',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151317,615,'Beena Lohba B.O','246431',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151318,615,'Beena Malla B.O','246473',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151319,615,'Bemaru B.O','246472',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151320,615,'Beradhar B.O','246427',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151321,615,'Bhagoti B.O','246455',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151322,615,'Bharki B.O','246443',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151323,615,'Bhatoli B.O','246444',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151324,615,'Bhenti B.O','246435',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151325,615,'Bhikona B.O','246473',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151326,615,'Bhimtalla B.O','246424',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151327,615,'Bhyundhar B.O','246443',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151328,615,'Bishalkhal B.O','246473',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151329,615,'Boragarh B.O','246427',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151330,615,'Bura Alla B.O','246435',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151331,615,'Burjola B.O','246482',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151332,615,'Chain B.O','246443',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151333,615,'Chaliyapani B.O','246455',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151334,615,'Chamoli S.O','246424',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151335,615,'Chaundali B.O','246444',1,0,'2022-03-04 19:38:26','2022-03-04 19:38:26'),(151336,615,'Chaur B.O','246427',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151337,615,'Chaurasain B.O','246487',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151338,615,'Cheproun B.O','246481',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151339,615,'Chhekura B.O','246455',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151340,615,'Chhinka S.O','246426',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151341,615,'Chiringa B.O','246441',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151342,615,'Chopta B.O','246453',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151343,615,'Choting B.O','246427',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151344,615,'Debal S.O','246427',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151345,615,'Devsari B.O','246441',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151346,615,'Dewalkot B.O','246440',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151347,615,'Dewarkhadora B.O','246401',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151348,615,'Dhak B.O','246443',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151349,615,'Dhunglwali B.O','246446',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151350,615,'Dimmar B.O','246474',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151351,615,'Dumak B.O','246472',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151352,615,'Dungri Karakot B.O','246455',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151353,615,'Dungri Pindarpar B.O','246481',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151354,615,'Duwa B.O','246429',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151355,615,'Dweeng B.O','246472',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151356,615,'Farkande Talli B.O','246428',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151357,615,'Gabani B.O','246453',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151358,615,'Gadora B.O','246472',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151359,615,'Gadsira B.O','246455',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151360,615,'Gairbaram B.O','246481',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151361,615,'Gairoli B.O','246474',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151362,615,'Gairsain S.O','246428',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151363,615,'Ganaimolta B.O','246472',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151364,615,'Gari B.O','246424',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151365,615,'Garkot B.O','246444',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151366,615,'Garurganga B.O','246472',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151367,615,'Gauchar S.O','246429',1,0,'2022-03-04 19:38:27','2022-03-04 19:38:27'),(151368,615,'Gaul B.O','246428',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151369,615,'Gauna B.O','246424',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151370,615,'Gerur B.O','246481',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151371,615,'Ghandiyal B.O','246444',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151372,615,'Ghat S.O','246435',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151373,615,'Ghesh B.O','246427',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151374,615,'Ghooni B.O','246435',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151375,615,'Gopeshwar Collectorate S.O','246401',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151376,615,'Gopeshwar Degree College S.O','246401',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151377,615,'Gopeshwar H.O','246401',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151378,615,'Govindghat B.O','246443',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151379,615,'Gulabkoti B.O','246472',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151380,615,'Gulari B.O','246435',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151381,615,'Gwaldam S.O','246441',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151382,615,'Gwardewaldhar B.O','246401',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151383,615,'Hanuman Chatti B.O','246422',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151384,615,'Harishankar B.O','246473',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151385,615,'Harmani B.O','246481',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151386,615,'Irani B.O','246424',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151387,615,'Izzar B.O','246473',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151388,615,'Jainbisht B.O','246427',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151389,615,'Jainta B.O','246444',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151390,615,'Jakh B.O','246444',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151391,615,'Jakhamala B.O','246473',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151392,615,'Jakhapatiyun B.O','246453',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151393,615,'Jakhola B.O','246472',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151394,615,'Jelam B.O','246443',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151395,615,'Jhinjhoni B.O','246455',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151396,615,'Jhumakhet B.O','246486',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151397,615,'Jilasu B.O','246446',1,0,'2022-03-04 19:38:28','2022-03-04 19:38:28'),(151398,615,'Joshimath S.O','246443',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151399,615,'Kafoli Malli B.O','246453',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151400,615,'Kalsir B.O','246473',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151401,615,'Kalusain B.O','246488',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151402,615,'Kamera B.O','246449',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151403,615,'Kanchula B.O','246446',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151404,615,'Kanda Maikhura B.O','246446',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151405,615,'Kandai-manakhi B.O','246449',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151406,615,'Kankhul B.O','246474',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151407,615,'Kanol B.O','246435',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151408,615,'Kanoth B.O','246487',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151409,615,'Kansuwa B.O','246440',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151410,615,'Karanprayag S.O','246444',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151411,615,'Karchhuna B.O','246429',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151412,615,'Kedarukhal B.O','246474',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151413,615,'Khainoli B.O','246444',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151414,615,'Khal B.O','246429',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151415,615,'Khandura B.O','246474',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151416,615,'Kharsain B.O','246429',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151417,615,'Kheta B.O','246427',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151418,615,'Kheti B.O','246440',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151419,615,'Khunana B.O','246449',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151420,615,'Kimani B.O','246481',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151421,615,'Kimoli B.O','246488',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151422,615,'Kimoli B.O','246455',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151423,615,'Kirsal B.O','246440',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151424,615,'Kobthan B.O','246455',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151425,615,'Koladungri B.O','246474',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151426,615,'Kooni B.O','246481',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151427,615,'Koonigarh Bichali B.O','246431',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151428,615,'Kothuli B.O','246453',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151429,615,'Kotkandara B.O','246449',1,0,'2022-03-04 19:38:29','2022-03-04 19:38:29'),(151430,615,'Kujasu B.O','246473',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151431,615,'Kulsari B.O','246481',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151432,615,'Kurar B.O','246481',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151433,615,'Kurur B.O','246435',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151434,615,'Kweenthi B.O','246429',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151435,615,'Lambagar B.O','246443',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151436,615,'Langasu S.O','246446',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151437,615,'Langsi B.O','246472',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151438,615,'Lankhi B.O','246435',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151439,615,'Lasiyari B.O','246424',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151440,615,'Lata B.O','246443',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151441,615,'Lodla B.O','246453',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151442,615,'Luntra B.O','246435',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151443,615,'Lwani B.O','246427',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151444,615,'Maikot B.O','246426',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151445,615,'Maita B.O','246481',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151446,615,'Maithana B.O','246424',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151447,615,'Majiyari Malli B.O','246440',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151448,615,'Majiyari Talli B.O','246440',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151449,615,'Malai B.O','246487',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151450,615,'Malan Sesonal B.O','246443',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151451,615,'Malethi B.O','246487',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151452,615,'Malkot B.O','246431',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151453,615,'Mana B.O','246422',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151454,615,'Mandal B.O','246401',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151455,615,'Marora B.O','246428',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151456,615,'Masoli B.O','246473',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151457,615,'Masson B.O','246449',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151458,615,'Matai B.O','246449',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151459,615,'Mauna B.O','246455',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151460,615,'Mayapur B.O','246472',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151461,615,'Mehalchauri S.O','246431',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151462,615,'Melkhet B.O','246427',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151463,615,'Ming Gadhera B.O','246444',1,0,'2022-03-04 19:38:30','2022-03-04 19:38:30'),(151464,615,'Mokh B.O','246449',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151465,615,'Mundoli B.O','246427',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151466,615,'Nagali B.O','246440',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151467,615,'Nailkhansar B.O','246486',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151468,615,'Naini B.O','246455',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151469,615,'Naini Chandpur B.O','246487',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151470,615,'Nainisain S.O','246488',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151471,615,'Nakholi B.O','246455',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151472,615,'Nalgaun S.O','246453',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151473,615,'Nandkeshari B.O','246427',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151474,615,'Nandprayag S.O','246449',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151475,615,'Narainbagar S.O','246455',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151476,615,'Nauli B.O','246444',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151477,615,'Nauti S.O','246487',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151478,615,'Niti B.O','246443',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151479,615,'Pagna B.O','246449',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151480,615,'Pagnapainkhanda B.O','246472',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151481,615,'Paini B.O','246443',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151482,615,'Paithani B.O','246455',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151483,615,'Palethi B.O','246424',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151484,615,'Panchali B.O','246428',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151485,615,'Pandukeshwar B.O','246443',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151486,615,'Perisutol B.O','246435',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151487,615,'Pindwali B.O','246440',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151488,615,'Pipalkoti S.O','246472',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151489,615,'Pokhani B.O','246472',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151490,615,'Pokhari Nagnath S.O','246473',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151491,615,'Raduwa B.O','246473',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151492,615,'Rain B.O','246427',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151493,615,'Rainipalla B.O','246443',1,0,'2022-03-04 19:38:31','2022-03-04 19:38:31'),(151494,615,'Ramani B.O','246435',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151495,615,'Ramra B.O','246428',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151496,615,'Ranoun B.O','246429',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151497,615,'Ratgaon B.O','246481',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151498,615,'Ratura B.O','246474',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151499,615,'Rauta B.O','246473',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151500,615,'Regari B.O','246483',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151501,615,'Rohira B.O','246428',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151502,615,'Ropa B.O','246424',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151503,615,'Ruingdranagiri B.O','246443',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151504,615,'Saikot B.O','246424',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151505,615,'Sainji B.O','246428',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151506,615,'Sakand B.O','246449',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151507,615,'Saliyana B.O','246444',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151508,615,'Salna B.O','246473',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151509,615,'Salurdungra B.O','246443',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151510,615,'Saranaairas B.O','246446',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151511,615,'Saring Gaon B.O','246486',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151512,615,'Sarkot B.O','246428',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151513,615,'Sawar B.O','246427',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151514,615,'Selang B.O','246443',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151515,615,'Sema B.O','246449',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151516,615,'Senti B.O','246435',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151517,615,'Senu B.O','246474',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151518,615,'Shantisadan B.O','246429',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151519,615,'Sidoli B.O','246429',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151520,615,'Silori B.O','246481',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151521,615,'Silpata B.O','246440',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151522,615,'Simali S.O','246474',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151523,615,'Simlasu B.O','246473',1,0,'2022-03-04 19:38:32','2022-03-04 19:38:32'),(151524,615,'Siwai B.O','246446',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151525,615,'Sonla B.O','246446',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151526,615,'Sonla Baunli B.O','246424',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151527,615,'Subhain B.O','246443',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151528,615,'Sunaonbhenta B.O','246482',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151529,615,'Sung B.O','246435',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151530,615,'Sunil S.O','246443',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151531,615,'Sunla B.O','246481',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151532,615,'Suraithota B.O','246443',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151533,615,'Sutol B.O','246435',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151534,615,'Suya B.O','246427',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151535,615,'Talwari S.O','246482',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151536,615,'Tangani B.O','246472',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151537,615,'Tangsa B.O','246401',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151538,615,'Tapoban S.O','246483',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151539,615,'Tefna B.O','246449',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151540,615,'Tentura B.O','246486',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151541,615,'Thaing B.O','246443',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151542,615,'Thalabair B.O','246473',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151543,615,'Tharali S.O','246481',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151544,615,'Thirpak B.O','246449',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151545,615,'Torti B.O','246427',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151546,615,'Trisula B.O','246449',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151547,615,'Triveni B.O','246443',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151548,615,'Tungeshwar B.O','246482',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151549,615,'Udamanda B.O','246473',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151550,615,'Ujjwal Pur B.O','246440',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151551,615,'Ulangra B.O','246427',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151552,615,'Umatta Chatti B.O','246444',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151553,615,'Urgam B.O','246443',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151554,615,'Ustoli B.O','246435',1,0,'2022-03-04 19:38:33','2022-03-04 19:38:33'),(151555,615,'Vishnupuram S.O','246443',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151556,616,'Banbassa Canal B.O','262310',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151557,616,'Chandani S.O','262310',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151558,616,'Lohia Head B.O','262308',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151559,616,'Tanakpur S.O','262309',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151560,616,'Abbotmount S.O','262525',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151561,616,'Bagoti B.O','262524',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151562,616,'Banku B.O','262524',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151563,616,'Bapru B.O','262525',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151564,616,'Barakote S.O','262527',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151565,616,'Bardakhan B.O','262527',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151566,616,'Bhingrara B.O','262528',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151567,616,'Bhumlai B.O','262524',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151568,616,'Bibil B.O','262524',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151569,616,'Birgul B.O','262528',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151570,616,'Chalthi B.O','262523',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151571,616,'Champawat S.O','262523',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151572,616,'Chanda Regru B.O','262525',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151573,616,'Chaumel B.O','262525',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151574,616,'Chauramehta B.O','262528',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151575,616,'Chilkote B.O','262524',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151576,616,'Chirra B.O','262525',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151577,616,'Deuri B.O','262523',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151578,616,'Devidhura S.O','262580',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151579,616,'Dhamisaun B.O','262523',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151580,616,'Dhaun B.O','262523',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151581,616,'Dhorja B.O','262524',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151582,616,'Dhunaghat B.O','262528',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151583,616,'Digalichaur B.O','262524',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151584,616,'Dudhpokhra B.O','262523',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151585,616,'Fungar B.O','262523',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151586,616,'Gagar B.O','262580',1,0,'2022-03-04 19:38:34','2022-03-04 19:38:34'),(151587,616,'Galchaura B.O','262524',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151588,616,'Gallagaon B.O','262524',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151589,616,'Gunthgarsari B.O','262528',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151590,616,'Ijara B.O','262524',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151591,616,'Jankandey B.O','262528',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151592,616,'Kanakote B.O','262528',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151593,616,'Karnkarayat B.O','262524',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151594,616,'Khateramalla B.O','262524',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151595,616,'Khetikhan S.O','262528',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151596,616,'Khunabora B.O','262524',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151597,616,'Kotajamrari B.O','262523',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151598,616,'Kothera B.O','262527',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151599,616,'Kotkendri B.O','262523',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151600,616,'Koyati B.O','262524',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151601,616,'Leti B.O','262524',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151602,616,'Lohaghat S.O','262524',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151603,616,'Machiyar B.O','262528',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151604,616,'Madhuwa B.O','262524',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151605,616,'Madlak B.O','262524',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151606,616,'Manch B.O','262523',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151607,616,'Mau B.O','262525',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151608,616,'Maurari B.O','262523',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151609,616,'Mayawati B.O','262524',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151610,616,'Neer B.O','262523',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151611,616,'Nidil B.O','262524',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151612,616,'Pulhindola B.O','262524',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151613,616,'Pungla Amori B.O','262523',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151614,616,'Raigaon B.O','262527',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151615,616,'Ramaila B.O','262523',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151616,616,'Rausal B.O','262524',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151617,616,'Rithakhal B.O','262580',1,0,'2022-03-04 19:38:35','2022-03-04 19:38:35'),(151618,616,'Riyansi B.O','262523',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151619,616,'Saindark B.O','262523',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151620,616,'Sango B.O','262561',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151621,616,'Shillinga B.O','262524',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151622,616,'Shyamlatal B.O','262523',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151623,616,'Simiyan B.O','262523',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151624,616,'Sukhidhang B.O','262523',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151625,616,'Sungarkhal B.O','262527',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151626,616,'Swala B.O','262523',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151627,616,'Tamli B.O','262523',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151628,616,'Thanta B.O','262524',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151629,616,'Timla B.O','262580',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151630,617,'Ajabpur S.O','248121',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151631,617,'Ambari B.O','248125',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151632,617,'Ambiwala B.O','248007',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151633,617,'Anarwala B.O','248003',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151634,617,'Anu B.O','248199',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151635,617,'Araghar S.O','248001',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151636,617,'Arahat Bazar S.O','248001',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151637,617,'Arkediagrant B.O','248007',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151638,617,'Ashok Ashram B.O','248125',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151639,617,'Atal B.O','248199',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151640,617,'Badho B.O','248158',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151641,617,'Badogal B.O','248143',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151642,617,'Badonwala B.O','248140',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151643,617,'Badripur B.O','248005',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151644,617,'Baila B.O','248196',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151645,617,'Balawala B.O','248001',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151646,617,'Ballupur S.O','248001',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151647,617,'Banjarawala B.O','248121',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151648,617,'Barasi B.O','248008',1,0,'2022-03-04 19:38:36','2022-03-04 19:38:36'),(151649,617,'Barlowganj S.O','248122',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151650,617,'Barontha S.O','248124',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151651,617,'Barwa B.O','248197',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151652,617,'Bhagwantpur B.O','248009',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151653,617,'Bhagwat B.O','248199',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151654,617,'Bhandrauli B.O','248123',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151655,617,'Bhaniawala B.O','248001',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151656,617,'Bhauwala B.O','248007',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151657,617,'Bhogpur S.O (Dehradun)','248143',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151658,617,'Bidholi B.O','248007',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151659,617,'Bijau B.O','248158',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151660,617,'Birmau B.O','248196',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151661,617,'Birnad B.O','248199',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151662,617,'Bullard B.O','248196',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151663,617,'Bullawala B.O','248140',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151664,617,'Cannaught Place S.O','248001',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151665,617,'CDA(A.F) S.O','248001',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151666,617,'Chakrata S.O','248123',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151667,617,'Chandanwari B.O','248007',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151668,617,'Chauki Dhaulas B.O','248003',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151669,617,'Chharba B.O','248197',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151670,617,'Chhibroo B.O','248159',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151671,617,'Chhiddarwala B.O','249204',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151672,617,'Chilhar B.O','248199',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151673,617,'Clementtown S.O','248002',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151674,617,'Dakpathar S.O','248125',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151675,617,'Dakra S.O','248003',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151676,617,'Dalanwala S.O','248001',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151677,617,'Dandi B.O','248145',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151678,617,'Dangutha B.O','248199',1,0,'2022-03-04 19:38:37','2022-03-04 19:38:37'),(151679,617,'Darmigad B.O','248199',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151680,617,'Dassau B.O','248196',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151681,617,'Datnu B.O','248196',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151682,617,'Dawla B.O','248124',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151683,617,'Defence Colony S.O','248012',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151684,617,'Dehradun Cantt H.O','248003',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151685,617,'Dehradun City S.O','248001',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151686,617,'Dehradun G.P.O.','248001',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151687,617,'Dehradun Kty S.O','248001',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151688,617,'Dessau B.O','248165',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151689,617,'Dhakrani B.O','248142',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151690,617,'Dhalipur B.O','248142',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151691,617,'Dhanyari B.O','248008',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151692,617,'Dharkot B.O','248143',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151693,617,'Dharmawala B.O','248142',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151694,617,'Dilaram Bazar S.O','248001',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151695,617,'Dimau B.O','248165',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151696,617,'Dobhri B.O','248197',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151697,617,'Dodhli B.O','248140',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151698,617,'Doiwala S.O','248140',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151699,617,'Doon University B.O','248012',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151700,617,'Dungiara B.O','248123',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151701,617,'Dwara B.O','248008',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151702,617,'Fanar B.O','248199',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151703,617,'Fatehpur Tanda B.O','248140',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151704,617,'Gadsar B.O','248124',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151705,617,'Gangroo B.O','248158',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151706,617,'Ghanta B.O','248123',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151707,617,'Govindgarh S.O (Dehradun)','248001',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151708,617,'Gumaniwala B.O','249204',1,0,'2022-03-04 19:38:38','2022-03-04 19:38:38'),(151709,617,'Haldwari B.O','248143',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151710,617,'Haripur B.O','248159',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151711,617,'Haripur Kalan B.O','249205',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151712,617,'Harrawala B.O','248001',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151713,617,'Hathi Barkala S.O','248001',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151714,617,'Hathipaon B.O','248179',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151715,617,'Haza B.O','248196',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151716,617,'Herbertpur S.O','248142',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151717,617,'Horrawala B.O','248197',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151718,617,'I.I.P. S.O','248005',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151719,617,'I.M.A. S.O','248007',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151720,617,'I.N.C. S.O','248006',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151721,617,'I.P.E. S.O','248195',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151722,617,'Ithrana B.O','248143',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151723,617,'Jaddi B.O','248123',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151724,617,'Jaintanwala B.O','248003',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151725,617,'Jakhnilani B.O','248199',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151726,617,'Jassowala B.O','248142',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151727,617,'Jharipani B.O','248179',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151728,617,'Jissau B.O','248165',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151729,617,'Jogio B.O','248124',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151730,617,'Jolly Grant B.O','248140',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151731,617,'K.P.Kshetra B.O','248001',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151732,617,'Kailana S.O','248123',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151733,617,'Kainchiwala B.O','248197',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151734,617,'Kalsi Gate S.O','248159',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151735,617,'Kalsi S.O','248158',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151736,617,'Kamla B.O','248158',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151737,617,'Kandoi B.O','248124',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151738,617,'Kandoli B.O','248013',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151739,617,'Kandoli Bharam B.O','248199',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151740,617,'Kanwali B.O','248001',1,0,'2022-03-04 19:38:39','2022-03-04 19:38:39'),(151741,617,'Kanwali Road S.O','248001',1,0,'2022-03-04 19:38:40','2022-03-04 19:38:40'),(151742,617,'Karanpur S.O','248001',1,0,'2022-03-04 19:38:40','2022-03-04 19:38:40'),(151743,617,'Karbari Grant B.O','248007',1,0,'2022-03-04 19:38:40','2022-03-04 19:38:40'),(151744,617,'Kata Pathar B.O','248125',1,0,'2022-03-04 19:38:40','2022-03-04 19:38:40'),(151745,617,'Kathang B.O','248199',1,0,'2022-03-04 19:38:40','2022-03-04 19:38:40'),(151746,617,'Kaulagarh S.O','248003',1,0,'2022-03-04 19:38:40','2022-03-04 19:38:40'),(151747,617,'Kedarwala B.O','248197',1,0,'2022-03-04 19:38:40','2022-03-04 19:38:40'),(151748,617,'Kempty B.O','248179',1,0,'2022-03-04 19:38:40','2022-03-04 19:38:40'),(151749,617,'Khabau B.O','248124',1,0,'2022-03-04 19:38:40','2022-03-04 19:38:40'),(151750,617,'Khadar B.O','248159',1,0,'2022-03-04 19:38:40','2022-03-04 19:38:40'),(151751,617,'Khairi B.O','248140',1,0,'2022-03-04 19:38:40','2022-03-04 19:38:40'),(151752,617,'Khamrauli B.O','248196',1,0,'2022-03-04 19:38:40','2022-03-04 19:38:40'),(151753,617,'Kharora B.O','248123',1,0,'2022-03-04 19:38:40','2022-03-04 19:38:40'),(151754,617,'Kharsi B.O','248124',1,0,'2022-03-04 19:38:40','2022-03-04 19:38:40'),(151755,617,'Kingcraig S.O','248179',1,0,'2022-03-04 19:38:40','2022-03-04 19:38:40'),(151756,617,'Kirar B.O','248199',1,0,'2022-03-04 19:38:40','2022-03-04 19:38:40'),(151757,617,'Kishanpur B.O','248009',1,0,'2022-03-04 19:38:40','2022-03-04 19:38:40'),(151758,617,'Korwa B.O','248196',1,0,'2022-03-04 19:38:40','2022-03-04 19:38:40'),(151759,617,'Kota B.O','248124',1,0,'2022-03-04 19:38:40','2022-03-04 19:38:40'),(151760,617,'Kothi B.O','248196',1,0,'2022-03-04 19:38:40','2022-03-04 19:38:40'),(151761,617,'Koti B.O','248123',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151762,617,'Koti B.O','248197',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151763,617,'Koti S.O','248165',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151764,617,'Kulhal B.O','248142',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151765,617,'Kulhan B.O','248013',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151766,617,'Kumalda B.O','248008',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151767,617,'Kunawa B.O','248123',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151768,617,'Kunna B.O','248124',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151769,617,'Kuwanoo B.O','248196',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151770,617,'Kyari B.O','248158',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151771,617,'Lachhiwala B.O','248140',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151772,617,'Lakhamandal B.O','248124',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151773,617,'Lakhwar B.O','248158',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151774,617,'Laksyar B.O','248158',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151775,617,'Landaur Cantt B.O','248179',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151776,617,'Landaur S.O','248179',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151777,617,'Langha B.O','248125',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151778,617,'Lohari B.O','248158',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151779,617,'Lohari B.O','248123',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151780,617,'Lorli B.O','248123',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151781,617,'Ludhera B.O','248158',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151782,617,'Madrasu B.O','248125',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151783,617,'Majra S.O (Dehradun)','248171',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151784,617,'Maldevta B.O','248008',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151785,617,'Maletha B.O','248196',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151786,617,'Manduwala B.O','248007',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151787,617,'Markhamgarant B.O','248140',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151788,617,'Marlau B.O','248123',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151789,617,'Masak B.O','248123',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151790,617,'Matiyawa B.O','248123',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151791,617,'Mawana Kolti B.O','248179',1,0,'2022-03-04 19:38:41','2022-03-04 19:38:41'),(151792,617,'Mehuwala B.O','248171',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151793,617,'Mendrath B.O','248199',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151794,617,'Mindal B.O','248123',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151795,617,'Mohbewala B.O','248002',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151796,617,'Mothrowala B.O','248001',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151797,617,'Mundhan B.O','248158',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151798,617,'Mundhol B.O','248199',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151799,617,'Mussoorie S.O','248179',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151800,617,'Myunda B.O','248124',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151801,617,'Naa S.O','248179',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151802,617,'Nada B.O','248124',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151803,617,'Nagal Bulandawala B.O','248140',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151804,617,'Nagal Jwalapur B.O','248140',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151805,617,'Nagau B.O','248123',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151806,617,'Nagthat B.O','248158',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151807,617,'Nakronda B.O','248008',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151808,617,'Naraya B.O','248196',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151809,617,'Narsan Kalan B.O','247670',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151810,617,'Nathuwala B.O','248008',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151811,617,'Nawada B.O','248005',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151812,617,'Nayagaon B.O','248007',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151813,617,'Nehrugram S.O','248014',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151814,617,'Neshvilla Road S.O','248001',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151815,617,'Newforest S.O','248006',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151816,617,'Nirmal Block Pashulok B.O','249202',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151817,617,'Nivh B.O','248001',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151818,617,'Pachhmiwala B.O','248198',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151819,617,'Panditwari S.O','248007',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151820,617,'Pashulok S.O','249203',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151821,617,'Patel Nagar S.O (Dehradun)','248001',1,0,'2022-03-04 19:38:42','2022-03-04 19:38:42'),(151822,617,'Pingua B.O','248199',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151823,617,'Pondha B.O','248007',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151824,617,'Prem Nagar S.O (Dehradun)','248007',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151825,617,'Railway Road Rishikesh S.O','249201',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151826,617,'Raipur(O.F) S.O','248008',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151827,617,'Raiwala S.O','249205',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151828,617,'Rajawala B.O','248007',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151829,617,'Rajpur S.O (Dehradun)','248009',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151830,617,'Rampur B.O','248197',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151831,617,'Rani Pokhari S.O','248145',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151832,617,'Ranjhawala B.O','248008',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151833,617,'Refugee Camp B.O','248007',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151834,617,'Resham Majri B.O','248140',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151835,617,'Rishikesh S.O','249201',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151836,617,'Rispana S.O','248001',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151837,617,'Rudrapur B.O','248197',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151838,617,'S.N. Temple S.O','249204',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151839,617,'Sabhawala B.O','248197',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151840,617,'Sachivalaya Parisar S.O','248001',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151841,617,'Sahaspur S.O (Dehradun)','248197',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151842,617,'Sahastradhara Road S.O','248013',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151843,617,'Sahiya S.O','248196',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151844,617,'Sahstradhara B.O','248013',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151845,617,'Sainj B.O','248165',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151846,617,'Samalta B.O','248196',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151847,617,'Sangaon B.O','248143',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151848,617,'Sarona B.O','248013',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151849,617,'Saura Sarauli B.O','248008',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151850,617,'Savoy Hotel S.O','248179',1,0,'2022-03-04 19:38:43','2022-03-04 19:38:43'),(151851,617,'Sayedwala S.O','248001',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151852,617,'Seemadwar S.O','248146',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151853,617,'Selaqui S.O','248011',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151854,617,'Shamshergarh B.O','248014',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151855,617,'Sherpur B.O','248197',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151856,617,'Shigali B.O','248003',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151857,617,'Sinola B.O','248003',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151858,617,'Sudhowala S.O','248015',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151859,617,'Sujau B.O','248123',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151860,617,'Tapovan B.O','248008',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151861,617,'Telbhawan S.O','248003',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151862,617,'Thaina B.O','248158',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151863,617,'Thano B.O','248143',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151864,617,'Tilwari B.O','248197',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151865,617,'Timli B.O','248142',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151866,617,'Tuini S.O','248199',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151867,617,'Tungra B.O','248123',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151868,617,'Tunwala B.O','248005',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151869,617,'Turner Road S.O','248002',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151870,617,'Ubhreau B.O','248165',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151871,617,'Umedpur B.O','248007',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151872,617,'Vikasnagar S.O (Dehradun)','248198',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151873,617,'Virbhadra S.O','249202',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151874,617,'Wht-I B.O','248198',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151875,617,'Wht-II B.O','248142',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151876,617,'Yamunapul B.O','248158',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151877,618,'Buggawala B.O','247662',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151878,618,'Kheri Shikohpur B.O','247662',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151879,618,'Biharigarh B.O','247662',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151880,618,'Gaindi Khata B.O','246763',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151881,618,'Adm Block(BHEL) S.O','249403',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151882,618,'Aithal B.O','247663',1,0,'2022-03-04 19:38:44','2022-03-04 19:38:44'),(151883,618,'Ambuwala B.O','249404',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151884,618,'Arya Nagar S.O (Haridwar)','249407',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151885,618,'Aurangabad B.O','249402',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151886,618,'Badshahpur B.O','247663',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151887,618,'Bahadrabad S.O','249402',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151888,618,'Bahdarpur Jatt B.O','249404',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151889,618,'Belra B.O','247667',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151890,618,'Bhagwanpur S.O (Haridwar)','247661',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151891,618,'Bhalswagaj B.O','247668',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151892,618,'Bharapur Bhori B.O','247667',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151893,618,'BHEL S.O (Haridwar)','249403',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151894,618,'Bhikampur B.O','247671',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151895,618,'Bhimgoda S.O','249401',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151896,618,'Bhogpur B.O','247663',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151897,618,'Bijholi B.O','247666',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151898,618,'Brahmpur Khanpur B.O','247671',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151899,618,'Chandpuri B.O','247663',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151900,618,'Chudiala B.O','247661',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151901,618,'Dabki Kalan B.O','247663',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151902,618,'Dandera Khwaspur B.O','247667',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151903,618,'Dandhera B.O','247666',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151904,618,'Daulatpur B.O','249402',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151905,618,'Dhanauri B.O','247667',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151906,618,'Dhanpura B.O','249404',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151907,618,'Gandhi Road S.O (Haridwar)','249408',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151908,618,'Ganesh Vatika S.O','247667',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151909,618,'Ganeshpur S.O','247667',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151910,618,'Garhmirpur B.O','249402',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151911,618,'Gordhanpur B.O','247663',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151912,618,'Gurkul Narsan S.O','247670',1,0,'2022-03-04 19:38:45','2022-03-04 19:38:45'),(151913,618,'Gurukul Kangri S.O','249404',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151914,618,'Gurukul Pharmecy S.O','249404',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151915,618,'Hallumajra B.O','247661',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151916,618,'Harchadpur Nizampur B.O','247670',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151917,618,'Haridwar S.O','249401',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151918,618,'Harjoli Jatt B.O','247670',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151919,618,'I.I.T Roorkee S.O','247667',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151920,618,'Ibrahimpur B.O','249402',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151921,618,'Ibrahimpur Mashi B.O','247661',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151922,618,'Imalikhera B.O','247667',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151923,618,'Iqbalpur S.O','247668',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151924,618,'Jhabrera S.O','247665',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151925,618,'Jwalapur S.O','249407',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151926,618,'Jwalapur Town S.O','249407',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151927,618,'Kankhal S.O','249408',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151928,618,'Khanpur B.O','247663',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151929,618,'Khera Jatt B.O','247670',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151930,618,'Kheri Mubarakpur B.O','247663',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151931,618,'Khubbanpur B.O','247661',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151932,618,'Kota Muradnagar B.O','247667',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151933,618,'Laksar S.O','247663',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151934,618,'Landhaura S.O','247664',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151935,618,'Libberheri B.O','247656',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151936,618,'Maharajpur Kalan B.O','247671',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151937,618,'Makdoompur B.O','247665',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151938,618,'Manakpur Adampur B.O','247668',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151939,618,'Manglour Town S.O','247656',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151940,618,'Manu Bas B.O','247667',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151941,618,'Marghoobpur B.O','247667',1,0,'2022-03-04 19:38:46','2022-03-04 19:38:46'),(151942,618,'Mayapur S.O (Haridwar)','249401',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151943,618,'Mewar Kalan B.O','247667',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151944,618,'Milap Nagar S.O','247666',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151945,618,'Missarpur B.O','249408',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151946,618,'Mohd. Pur Buzurg B.O','247663',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151947,618,'Mohmadpur Fall B.O','247670',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151948,618,'Munda Khera Kalan B.O','247663',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151949,618,'Mundlana B.O','247656',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151950,618,'Nagla Salaru B.O','247670',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151951,618,'Nalhera Anantpur B.O','247668',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151952,618,'Niranjanpur B.O','247671',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151953,618,'Paniyala B.O','247667',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151954,618,'Patanjali Yogpeeth S.O','249405',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151955,618,'Piran Kaliyar B.O','247667',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151956,618,'Podowali B.O','247671',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151957,618,'Prahaledpur B.O','247663',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151958,618,'Raisi S.O','247671',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151959,618,'Rajupur B.O','247670',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151960,618,'Ramnagar S.O (Haridwar)','247667',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151961,618,'Ransura B.O','247670',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151962,618,'Rohalki B.O','249402',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151963,618,'Roorkee Cantt S.O','247667',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151964,618,'Roorkee City S.O','247667',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151965,618,'Roorkee H.O','247667',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151966,618,'Roorkee Kutchery S.O','247667',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151967,618,'Roshnabad Kutchery S.O','249403',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151968,618,'Sadhubela Bhupatwala S.O','249410',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151969,618,'Salempur Mehdood B.O','249402',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151970,618,'Salempur Rajputana B.O','247667',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151971,618,'Saliyar B.O','247667',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151972,618,'Sapper Bazar S.O','247667',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151973,618,'Sarai B.O','249404',1,0,'2022-03-04 19:38:47','2022-03-04 19:38:47'),(151974,618,'Sector-III BHEL S.O','249403',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(151975,618,'Shahpur Shitlakhera B.O','247663',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(151976,618,'Shanti Nagar S.O','247667',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(151977,618,'Shantikunj S.O','249411',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(151978,618,'Sherpur Khelmau B.O','247665',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(151979,618,'Shivalik Nagar S.O','249403',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(151980,618,'Shyampur B.O','249408',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(151981,618,'Sikandarpur Bainswal B.O','247661',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(151982,618,'Sikroda B.O','247661',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(151983,618,'Sohelpur Sikroda B.O','247667',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(151984,618,'Srichandi B.O','247661',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(151985,618,'Subhashgarh B.O','247663',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(151986,618,'Sultanpur B.O','247663',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(151987,618,'Tansipur B.O','247656',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(151988,618,'Tikola Kalan B.O','247670',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(151989,618,'Toda Banhera B.O','247656',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(151990,618,'Toda Kalyanpur B.O','247664',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(151991,618,'Training Battalian S.O','247667',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(151992,619,'Adhora B.O','263157',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(151993,619,'Amghari B.O','263159',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(151994,619,'Amjhar B.O','263157',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(151995,619,'Amritpur B.O','263126',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(151996,619,'Anandpur B.O','263139',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(151997,619,'Arjunpur B.O','263139',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(151998,619,'Babiyar B.O','263136',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(151999,619,'Badon B.O','263157',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(152000,619,'Bail Parao B.O','263139',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(152001,619,'Bailpokhra B.O','263140',1,0,'2022-03-04 19:38:48','2022-03-04 19:38:48'),(152002,619,'Bajunia Haldu B.O','263159',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152003,619,'Banana B.O','263136',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152004,619,'Bareilly Road S.O','263139',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152005,619,'Bari Mukhani B.O','263139',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152006,619,'Bel B.O','263128',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152007,619,'Betalghat S.O','263134',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152008,619,'Bhatalia B.O','263132',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152009,619,'Bhimtal S.O','263136',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152010,619,'Bhotia Parao S.O','263139',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152011,619,'Bhowali S.O','263132',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152012,619,'Bhumiadhar B.O','263132',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152013,619,'Bindhukhatta S.O','262402',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152014,619,'Bist Estatre B.O','263127',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152015,619,'Chakalua B.O','263139',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152016,619,'Chanfi B.O','263136',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152017,619,'Chausala B.O','263139',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152018,619,'Chhoi B.O','244715',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152019,619,'Chilkia B.O','244715',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152020,619,'Chopra B.O','263127',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152021,619,'Chorgalia B.O','263139',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152022,619,'Churigarh B.O','263136',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152023,619,'Dalkania B.O','263157',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152024,619,'Damuadhunga B.O','263126',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152025,619,'Daulatpur B.O','263139',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152026,619,'Deoli B.O','263157',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152027,619,'Devdwar B.O','263158',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152028,619,'Dewalchaur B.O','263139',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152029,619,'Dewalchaur B.O','263140',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152030,619,'Dhamola B.O','263140',1,0,'2022-03-04 19:38:49','2022-03-04 19:38:49'),(152031,619,'Dhanachuli B.O','263132',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152032,619,'Dhaniakote B.O','263135',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152033,619,'Dhari B.O','263136',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152034,619,'Dhela B.O','244715',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152035,619,'Dhikala Nc Park(Seasonal) B.O','244715',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152036,619,'Dhikuli B.O','244715',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152037,619,'Dhyari B.O','263138',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152038,619,'Dogara B.O','263126',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152039,619,'Dohania B.O','263159',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152040,619,'Don B.O','263159',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152041,619,'Fathepur B.O','263139',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152042,619,'Gabuwa B.O','263140',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152043,619,'Gagar B.O','263132',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152044,619,'Garampani S.O','263135',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152045,619,'Garjoli B.O','263135',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152046,619,'Gethia B.O','263127',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152047,619,'Ghangreti B.O','263134',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152048,619,'Ghorakhal S.O','263156',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152049,619,'Gintigaon B.O','263159',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152050,619,'Gunialekh B.O','263136',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152051,619,'Hairakhan B.O','263126',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152052,619,'Haldiyani B.O','263134',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152053,619,'Haldu Chaur B.O','263139',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152054,619,'Haldwani H.O','263139',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152055,619,'Hariawala Chauraha S.O','244713',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152056,619,'Haripura Naik B.O','263139',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152057,619,'Harishtal B.O','263126',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152058,619,'Hartola B.O','263158',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152059,619,'High Court S.O (Nainital)','263001',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152060,619,'Indranagar B.O','263139',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152061,619,'Industrial Estate B.O','263139',1,0,'2022-03-04 19:38:50','2022-03-04 19:38:50'),(152062,619,'Jaikhola B.O','263136',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152063,619,'Jamani B.O','244715',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152064,619,'Jangaliagaon B.O','263136',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152065,619,'Jeolikote S.O','263127',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152066,619,'Jhargaon B.O','263157',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152067,619,'Jhutia B.O','263158',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152068,619,'Joshyua B.O','263132',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152069,619,'Jurasi Kutali B.O','263135',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152070,619,'Kainchi B.O','263132',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152071,619,'Kala Agar B.O','263157',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152072,619,'Kaladhungi Road S.O','263139',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152073,619,'Kaladhungi S.O','263140',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152074,619,'Kamola B.O','263140',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152075,619,'Karanpur B.O','244715',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152076,619,'Kashialekh B.O','263132',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152077,619,'Kathgharia B.O','263139',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152078,619,'Kathgodam S.O','263126',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152079,619,'Khairali B.O','263134',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152080,619,'Khansyon B.O','263157',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152081,619,'Khurpatal B.O','263001',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152082,619,'Kishanpur B.O','263139',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152083,619,'Kotabagh S.O','263159',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152084,619,'Kumaon University Nainital S.O','263001',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152085,619,'Kunwarpur B.O','263139',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152086,619,'Kusumkhera S.O','263139',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152087,619,'Lalkua S.O','262402',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152088,619,'Lamachaur B.O','263139',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152089,619,'Lohali B.O','263135',1,0,'2022-03-04 19:38:51','2022-03-04 19:38:51'),(152090,619,'Manorapeak B.O','263001',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152091,619,'Manpur Paschim B.O','263139',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152092,619,'Mauni B.O','263138',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152093,619,'Mehragaon B.O','263132',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152094,619,'Mohan B.O','244715',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152095,619,'Mota Haldu B.O','263139',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152096,619,'Mukteshwar(Kumaon) S.O','263138',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152097,619,'Nai B.O','263132',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152098,619,'Nainital H.O','263001',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152099,619,'Nainital Kutchert Nainital S.O','263001',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152100,619,'Nakuchiatal B.O','263136',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152101,619,'Nalni B.O','263001',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152102,619,'Narain Swamy Ashram S.O','263158',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152103,619,'Nartola B.O','263132',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152104,619,'Nathuwakhan B.O','263158',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152105,619,'Nayeli B.O','263138',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152106,619,'Okhaldhunga B.O','263126',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152107,619,'Okhalkanda S.O','263157',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152108,619,'Padampur B.O','263157',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152109,619,'Padampuri B.O','263136',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152110,619,'Padrani B.O','263126',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152111,619,'Paharpani B.O','263132',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152112,619,'Painth Parao S.O','263139',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152113,619,'Pandey Gaon B.O','263136',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152114,619,'Pangoot B.O','263001',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152115,619,'Pania Mehta B.O','263126',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152116,619,'Patalia B.O','263159',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152117,619,'Patkote B.O','263159',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152118,619,'Patlot B.O','263157',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152119,619,'Patwadanger S.O','263128',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152120,619,'Pawalgarh B.O','263140',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152121,619,'Pokharar B.O','263136',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152122,619,'Pokhari B.O','263136',1,0,'2022-03-04 19:38:52','2022-03-04 19:38:52'),(152123,619,'Pyura B.O','263138',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152124,619,'Ramgarh S.O (Nainital)','263137',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152125,619,'Ramnagar S.O (Nainital)','244715',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152126,619,'Ratighat B.O','263135',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152127,619,'Rausila B.O','263126',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152128,619,'Rinchi B.O','263134',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152129,619,'Rnibagh B.O','263126',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152130,619,'Sanana B.O','263159',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152131,619,'Sargakhet B.O','263132',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152132,619,'Satbungs B.O','263132',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152133,619,'Sattal (Seasonal ) B.O','263136',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152134,619,'Saur B.O','263159',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152135,619,'Sethi Belgaon B.O','263134',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152136,619,'Simalkha B.O','263135',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152137,619,'Simalkhalia B.O','244715',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152138,619,'Simrar B.O','263135',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152139,619,'Sui B.O','263157',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152140,619,'Sunderkhal B.O','263132',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152141,619,'Sunsyari B.O','263134',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152142,619,'Supi B.O','263132',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152143,619,'Surang B.O','263157',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152144,619,'Suwakote Pokhari B.O','263157',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152145,619,'Suyal Bari B.O','263135',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152146,619,'Syat B.O','263159',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152147,619,'Talla Bardho B.O','263135',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152148,619,'Talli Pokhari B.O','263157',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152149,619,'Tallital S.O','263001',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152150,619,'Tushrar B.O','263157',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152151,619,'Unchakote B.O','263134',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152152,619,'Vidyalayee Siksha Parisad Ramnagar','244715',1,0,'2022-03-04 19:38:53','2022-03-04 19:38:53'),(152153,619,'Dholigaon B.O','262580',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152154,620,'Adhariyakhal B.O','246155',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152155,620,'Adhora Walla B.O','246277',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152156,620,'Adwani B.O','246146',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152157,620,'Agrora B.O','246176',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152158,620,'Ainthi B.O','246285',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152159,620,'Amola B.O','246121',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152160,620,'Amola B.O','246173',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152161,620,'Amotha B.O','246167',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152162,620,'Amsaur B.O','246149',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152163,620,'Andrauli B.O','246277',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152164,620,'Anganisain B.O','246155',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152165,620,'Apola B.O','246277',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152166,620,'Asankhet B.O','246155',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152167,620,'Ason B.O','246277',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152168,620,'B.E.L. S.O','246149',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152169,620,'Bachali B.O','246131',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152170,620,'Badiyargaon B.O','246179',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152171,620,'Badun B.O','246121',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152172,620,'Bageli B.O','246130',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152173,620,'Bagodgaon B.O','246121',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152174,620,'Bagrigar B.O','246169',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152175,620,'Bagwari B.O','246285',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152176,620,'Bagyali B.O','246167',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152177,620,'Baherakhal B.O','246146',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152178,620,'Baijrao (A) S.O','246275',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152179,620,'Bairhat Palla B.O','246161',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152180,620,'Bajwar B.O','246123',1,0,'2022-03-04 19:38:54','2022-03-04 19:38:54'),(152181,620,'Balasaur B.O','246149',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152182,620,'Balli B.O','246127',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152183,620,'Bamoli B.O','246128',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152184,620,'Banani B.O','246130',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152185,620,'Banchauri B.O','246121',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152186,620,'Bandun B.O','246129',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152187,620,'Bangali B.O','246130',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152188,620,'Bangaon Malla B.O','246159',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152189,620,'Bangar B.O','246278',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152190,620,'Banghat B.O','246172',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152191,620,'Bansi B.O','246155',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152192,620,'Bara B.O','246276',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152193,620,'Bareth B.O','246130',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152194,620,'Bariyun B.O','246172',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152195,620,'Barkholu B.O','246172',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152196,620,'Barkot B.O','246175',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152197,620,'Barsu B.O','246167',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152198,620,'Basola B.O','246275',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152199,620,'Baundar B.O','246162',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152200,620,'Baundar Khutinga B.O','246276',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152201,620,'Baunsal Talla B.O','246167',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152202,620,'Bawansi B.O','246144',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152203,620,'Bedgaon B.O','246113',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152204,620,'Bhainswara Ghandiyal B.O','246001',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152205,620,'Bhamraikhal B.O','246276',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152206,620,'Bhandalu B.O','246146',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152207,620,'Bharnao B.O','246275',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152208,620,'Bharsar B.O','246123',1,0,'2022-03-04 19:38:55','2022-03-04 19:38:55'),(152209,620,'Bhatwaron B.O','246276',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152210,620,'Bhaun B.O','246277',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152211,620,'Bhimli Talli B.O','246166',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152212,620,'Bhira B.O','246285',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152213,620,'Bhrigukhal (A) S.O','246121',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152214,620,'Bhundkhal B.O','246161',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152215,620,'Bidoli B.O','246164',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152216,620,'Bilkot B.O','246161',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152217,620,'Binak B.O','246121',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152218,620,'Birmoli B.O','246144',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152219,620,'Bironkhal (A) S.O','246276',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152220,620,'Bishald B.O','246164',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152221,620,'Biyasi B.O','246161',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152222,620,'Bubakhal B.O','246001',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152223,620,'Budhakot B.O','246275',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152224,620,'Bughani B.O','246147',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152225,620,'Bunga Talla B.O','246179',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152226,620,'Bungidhar B.O','246285',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152227,620,'Buransi B.O','246148',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152228,620,'Buransi B.O','246123',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152229,620,'Bus Station Pauri S.O','246001',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152230,620,'Chai Damrara B.O','246121',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152231,620,'Chair Malla B.O','246164',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152232,620,'Chair Manjkhola B.O','246179',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152233,620,'Chakisain (B) S.O','246130',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152234,620,'Chamara B.O','246161',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152235,620,'Chamethakhal B.O','246155',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152236,620,'Chamkotkhal B.O','246121',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152237,620,'Chamnao B.O','246162',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152238,620,'Champeshwar B.O','246164',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152239,620,'Chamrara B.O','246147',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152240,620,'Chamsain B.O','246161',1,0,'2022-03-04 19:38:56','2022-03-04 19:38:56'),(152241,620,'Chandolarain B.O','246001',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152242,620,'Chandoli Malli B.O','246276',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152243,620,'Chaplori B.O','246123',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152244,620,'Chardhar B.O','246001',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152245,620,'Chaukhal B.O','246275',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152246,620,'Chaukuri B.O','246179',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152247,620,'Chaunra B.O','246130',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152248,620,'Chaurakhal B.O','246176',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152249,620,'Chaurikh B.O','246123',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152250,620,'Chelusain B.O','246128',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152251,620,'Chila Colony S.O','249306',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152252,620,'Chipalghat (A) S.O','246123',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152253,620,'Chopra  Kandarsyun B.O','246123',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152254,620,'Chopriun B.O','246001',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152255,620,'Chorkinda Talla B.O','246177',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152256,620,'Chundai B.O','246155',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152257,620,'Churani B.O','246179',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152258,620,'Dabolikhal B.O','246144',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152259,620,'Dabri B.O','246155',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152260,620,'Dadamandi S.O','246124',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152261,620,'Dadoli Talli B.O','246285',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152262,620,'Damadeval B.O','246162',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152263,620,'Dandapani B.O','246194',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152264,620,'Dandatalla B.O','246172',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152265,620,'Dehalchauri S.O','246125',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152266,620,'Derikhal B.O','246155',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152267,620,'Devikhal B.O','246149',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152268,620,'Devikhet B.O','246144',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152269,620,'Devlad B.O','246277',1,0,'2022-03-04 19:38:57','2022-03-04 19:38:57'),(152270,620,'Devprayag S.O','249301',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152271,620,'Devrajkhal B.O','246162',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152272,620,'Devrana B.O','246121',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152273,620,'Dewalgarh B.O','246147',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152274,620,'Dhabhakhal B.O','246155',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152275,620,'Dhamdhar B.O','246179',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152276,620,'Dhandkur B.O','246148',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152277,620,'Dhandri Bichli B.O','246001',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152278,620,'Dhansi B.O','246173',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152279,620,'Dharasu B.O','246162',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152280,620,'Dhaund B.O','246275',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152281,620,'Dhauntiyal B.O','246155',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152282,620,'Dhumakot S.O','246277',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152283,620,'Dhura Dhanai B.O','246144',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152284,620,'Digolikhal B.O','246277',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152285,620,'Diuli B.O','249304',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152286,620,'Diusa B.O','246128',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152287,620,'Diusa B.O','246146',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152288,620,'Diusi B.O','246175',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152289,620,'Dondal B.O','249301',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152290,620,'Dudharkhal S.O','246129',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152291,620,'Dugadda S.O','246127',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152292,620,'Dungri S.O (Pauri Garhwal)','246279',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152293,620,'Dungrikhal B.O','246123',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152294,620,'Dungripanth B.O','246174',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152295,620,'Dwari B.O','246179',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152296,620,'Dwarikhal S.O','246128',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152297,620,'Ekeshwar (A) S.O','246131',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152298,620,'Falda B.O','246113',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152299,620,'Farsari B.O','246275',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152300,620,'Fatehpur B.O','246127',1,0,'2022-03-04 19:38:58','2022-03-04 19:38:58'),(152301,620,'G.B. Pant Engg. College S.O','246194',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152302,620,'Gadigaon B.O','246162',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152303,620,'Gadiyunpul B.O','246179',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152304,620,'Gadkharak Malla B.O','246275',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152305,620,'Gadoli B.O','246130',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152306,620,'Gadsir B.O','246144',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152307,620,'Gadwagad B.O','246001',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152308,620,'Gaind B.O','246159',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152309,620,'Gairoli B.O','246179',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152310,620,'Ganga Bhogpur B.O','249306',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152311,620,'Garkot B.O','246173',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152312,620,'Garkot Chhacharao B.O','246275',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152313,620,'Gaulikhal B.O','246279',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152314,620,'Gawani B.O','246169',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152315,620,'Gend B.O','246173',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152316,620,'Gherwa B.O','246129',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152317,620,'Ghindwara B.O','249301',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152318,620,'Ghiri B.O','246159',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152319,620,'Girgaon B.O','246001',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152320,620,'Goda B.O','246123',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152321,620,'Gudendi B.O','246179',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152322,620,'Gumain B.O','246159',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152323,620,'Gumkhal B.O','246128',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152324,620,'Gweel B.O','246173',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152325,620,'Gween B.O','246276',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152326,620,'Hanumanti B.O','246127',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152327,620,'Hathnoor B.O','246173',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152328,620,'Heerakhal B.O','246121',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152329,620,'Ira B.O','246131',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152330,620,'Irakhal B.O','246162',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152331,620,'Jagsiakhal B.O','246162',1,0,'2022-03-04 19:38:59','2022-03-04 19:38:59'),(152332,620,'Jahrikhal (B) S.O','246193',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152333,620,'Jainthi Dang B.O','246285',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152334,620,'Jakh B.O','246147',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152335,620,'Jakhni Khatli B.O','246276',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152336,620,'Jaletha B.O','246174',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152337,620,'Jameli B.O','246124',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152338,620,'Jamlakhal B.O','246194',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152339,620,'Jamnakhal B.O','246001',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152340,620,'Jamri B.O','249301',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152341,620,'Jaraukhand B.O','246277',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152342,620,'Jaspur B.O','246275',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152343,620,'Jhair B.O','246173',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152344,620,'Jhandichaur B.O','246149',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152345,620,'Jhanjhar B.O','246148',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152346,620,'Jhatkandi B.O','246163',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152347,620,'Jiwai B.O','246275',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152348,620,'Jogimarhi B.O','246275',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152349,620,'Kadola B.O','246177',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152350,620,'Kafald B.O','246285',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152351,620,'Kalagarh S.O','246142',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152352,620,'Kalalghati B.O','246149',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152353,620,'Kaligad B.O','246155',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152354,620,'Kalinkakhal (Kaleth) B.O','246161',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152355,620,'Kaliyasaur B.O','246174',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152356,620,'Kalon B.O','246123',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152357,620,'Kalun B.O','246164',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152358,620,'Kalzikhal S.O','246113',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152359,620,'Kamalpur B.O','246194',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152360,620,'Kamdai B.O','246276',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152361,620,'Kamleshwar S.O','246174',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152362,620,'Kanda Talla B.O','246276',1,0,'2022-03-04 19:39:00','2022-03-04 19:39:00'),(152363,620,'Kandai B.O','246129',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152364,620,'Kandakanikhal B.O','246144',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152365,620,'Kandakhal Kauriya B.O','246172',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152366,620,'Kandakhal S.O','246144',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152367,620,'Kandara B.O','246166',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152368,620,'Kandi B.O','246173',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152369,620,'Kandoliya S.O','246001',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152370,620,'Kanduli Bari B.O','246276',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152371,620,'Kanskhet S.O','246146',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152372,620,'Kaproli B.O','246285',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152373,620,'Karakot B.O','246159',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152374,620,'Kasani B.O','246177',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152375,620,'Kathiur B.O','246130',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152376,620,'Kathur Bara B.O','246173',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152377,620,'Khadrasi B.O','246161',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152378,620,'Khand Malla B.O','246123',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152379,620,'Khandah B.O','246001',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152380,620,'Khandusain B.O','246001',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152381,620,'Khanetha B.O','246155',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152382,620,'Kharkoli B.O','246172',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152383,620,'Khera B.O','246121',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152384,620,'Kherasain B.O','246172',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152385,620,'Khirarikhal B.O','246279',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152386,620,'Khirshu S.O','246147',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152387,620,'Kholachauri B.O','246194',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152388,620,'Khutinda Malla B.O','246277',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152389,620,'Kilbokhal B.O','246179',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152390,620,'Kimoli B.O','246113',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152391,620,'Kimsar B.O','246121',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152392,620,'Kinath Talla B.O','246277',1,0,'2022-03-04 19:39:01','2022-03-04 19:39:01'),(152393,620,'Kingorikhal B.O','246277',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152394,620,'Kingorikhal B.O','246163',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152395,620,'Kinsur B.O','246173',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152396,620,'Kishanpur B.O','246149',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152397,620,'Kiwarsh B.O','246001',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152398,620,'Kolakhal B.O','246169',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152399,620,'Kot S.O (Pauri Garhwal)','246148',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152400,620,'Kota Mahadev B.O','246177',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152401,620,'Kotdwara H.O','246149',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152402,620,'Kotdwara Railway Station S.O','246149',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152403,620,'Kotridhang B.O','246149',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152404,620,'Kulasu B.O','246167',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152405,620,'Kulasu B.O','249301',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152406,620,'Kulhar B.O','246172',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152407,620,'Kulyani B.O','246285',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152408,620,'Kumbhichaur B.O','246149',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152409,620,'Kundi B.O','249301',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152410,620,'Kunjholi B.O','246155',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152411,620,'Kunjkhal B.O','246169',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152412,620,'Kurigaon B.O','246172',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152413,620,'Kyark B.O','246001',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152414,620,'Lachhi B.O','246278',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152415,620,'Langwalyun Bagar B.O','246174',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152416,620,'Lansdowne H.O','246155',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152417,620,'Laxmanjhula (B) S.O','249302',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152418,620,'Lokmanipur B.O','246149',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152419,620,'Lwali S.O','246159',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152420,620,'Mailli B.O','246130',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152421,620,'Mala B.O','249304',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152422,620,'Malethi B.O','246172',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152423,620,'Mandai B.O','246144',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152424,620,'Mandoli Malli B.O','246193',1,0,'2022-03-04 19:39:02','2022-03-04 19:39:02'),(152425,620,'Manjhera Malla B.O','246279',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152426,620,'Manjhyari B.O','246144',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152427,620,'Maral B.O','249304',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152428,620,'Marora B.O','246164',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152429,620,'Masangaon B.O','246148',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152430,620,'Mason B.O','246167',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152431,620,'Mason Chauthan B.O','246285',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152432,620,'Masoor B.O','246174',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152433,620,'Mathali B.O','246155',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152434,620,'Mathana Bichala B.O','246127',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152435,620,'Matiyalna B.O','246167',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152436,620,'Mawadhar S.O','246163',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152437,620,'Mawakot B.O','246149',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152438,620,'Mohan Sankari B.O','246144',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152439,620,'Mohanchatti B.O','249304',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152440,620,'Molthi B.O','246165',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152441,620,'Moxan Uniyal B.O','246161',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152442,620,'Muchiyali B.O','249301',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152443,620,'Nahsain B.O','246146',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152444,620,'Nail B.O','249304',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152445,620,'Naini B.O','246172',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152446,620,'Nainidanda (B) S.O','246161',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152447,620,'Naithana S.O','246175',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152448,620,'Nakuri B.O','246276',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152449,620,'Nalai B.O','246166',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152450,620,'Naudanu B.O','246179',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152451,620,'Naugaonkhal S.O','246162',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152452,620,'Naun B.O','246276',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152453,620,'Nauri B.O','246130',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152454,620,'Nawakhal B.O','246147',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152455,620,'Nazibabad Road B.O','246149',1,0,'2022-03-04 19:39:03','2022-03-04 19:39:03'),(152456,620,'Neelkanth Mahadev B.O','249304',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152457,620,'Nimbuchaur B.O','246149',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152458,620,'Nisni B.O','246001',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152459,620,'Nisni B.O','246164',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152460,620,'Olna B.O','246175',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152461,620,'Pabau (B) S.O','246164',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152462,620,'Padampur B.O','246149',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152463,620,'Padampur Motadhak B.O','246149',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152464,620,'Padampur Sukhrao B.O','246149',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152465,620,'Paidul S.O','246165',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152466,620,'Paithani B.O','246123',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152467,620,'Pali B.O','246166',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152468,620,'Pand B.O','246169',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152469,620,'Pang B.O','246167',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152470,620,'Panikasain B.O','246179',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152471,620,'Paral B.O','246123',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152472,620,'Paranda B.O','246144',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152473,620,'Parsoli B.O','246279',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152474,620,'Parsundakhal S.O','246166',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152475,620,'Patisain S.O','246167',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152476,620,'Patotee B.O','246123',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152477,620,'Patotiya B.O','246277',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152478,620,'Paukhal B.O','246144',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152479,620,'Pauri H.O','246001',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152480,620,'Pinakot B.O','246123',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152481,620,'Pinani B.O','246162',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152482,620,'Pipali B.O','246162',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152483,620,'Pipali Iriakot B.O','246277',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152484,620,'Pipalpani B.O','246176',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152485,620,'Pisoli B.O','246194',1,0,'2022-03-04 19:39:04','2022-03-04 19:39:04'),(152486,620,'Pokhra (A) S.O','246169',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152487,620,'Pokhri Chalansyun B.O','246147',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152488,620,'Pokhri Choprakot B.O','246285',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152489,620,'Pokhri Malla Udaipur B.O','246121',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152490,620,'Pokhrikhet B.O','246176',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152491,620,'Pulyasu B.O','246128',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152492,620,'Pulyasu B.O','246113',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152493,620,'Pundergaon B.O','246172',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152494,620,'Pundori B.O','246175',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152495,620,'Raisoli B.O','246131',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152496,620,'Rajbat B.O','246124',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152497,620,'Rampur Chatti B.O','246125',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152498,620,'Ranakot B.O','249301',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152499,620,'Raurkhal B.O','246163',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152500,620,'Rikhnikhal (A) S.O','246179',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152501,620,'Riksal B.O','246285',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152502,620,'Ringwari B.O','246167',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152503,620,'Rithakhal B.O','246172',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152504,620,'Saindhar B.O','246177',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152505,620,'Sainji B.O','246123',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152506,620,'Sakinda B.O','246167',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152507,620,'Sald Mahadev B.O','246279',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152508,620,'Salda B.O','246194',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152509,620,'Sandhikhal B.O','246155',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152510,620,'Sanglakoti B.O','246172',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152511,620,'Sankarpur B.O','246279',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152512,620,'Sankarsain B.O','246123',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152513,620,'Santudhar B.O','246167',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152514,620,'Sar B.O','246121',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152515,620,'Sarasu B.O','246167',1,0,'2022-03-04 19:39:05','2022-03-04 19:39:05'),(152516,620,'Sason B.O','246167',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152517,620,'Satpali B.O','246167',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152518,620,'Satpuli S.O','246172',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152519,620,'Saurkhet B.O','246128',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152520,620,'Seramalla B.O','246278',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152521,620,'Seriakhal B.O','246169',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152522,620,'Shivrajpur B.O','246149',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152523,620,'Sikukhal B.O','246165',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152524,620,'Silli B.O','246276',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152525,620,'Silogi S.O','246173',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152526,620,'Silsu B.O','249301',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152527,620,'Simar B.O','246131',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152528,620,'Simlana Malla B.O','246144',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152529,620,'Simlya B.O','246128',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152530,620,'Sinduri B.O','246276',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152531,620,'Singori Kathuli B.O','246147',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152532,620,'Sirala B.O','249301',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152533,620,'Siroli B.O','246276',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152534,620,'Siron B.O','246163',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152535,620,'Soola B.O','246163',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152536,620,'Srikot Ganganali B.O','246174',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152537,620,'Srikotkhal B.O','246169',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152538,620,'Srikotkhal B.O','246131',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152539,620,'Srinagar S.O (Pauri Garhwal)','246174',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152540,620,'Sulmorikhal B.O','246179',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152541,620,'Sumari B.O','246174',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152542,620,'Sumersain B.O','246173',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152543,620,'Swargashram S.O','249304',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152544,620,'Sweet B.O','246174',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152545,620,'Syalinga B.O','246127',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152546,620,'Syalini Badron B.O','246144',1,0,'2022-03-04 19:39:06','2022-03-04 19:39:06'),(152547,620,'Syalna B.O','246144',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152548,620,'Syoli Talli B.O','246123',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152549,620,'Syunsinagar S.O','246278',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152550,620,'Tairi B.O','246146',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152551,620,'Takolikhal B.O','246179',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152552,620,'Takulsari B.O','246276',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152553,620,'Tal B.O','246164',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152554,620,'Talai Khatli B.O','246276',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152555,620,'Tangroli B.O','246113',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152556,620,'Taria B.O','246161',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152557,620,'Tella B.O','246123',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152558,620,'Thair B.O','246113',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152559,620,'Thalda B.O','246172',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152560,620,'Thalisain S.O','246285',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152561,620,'Thandhar B.O','246147',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152562,620,'Thangar B.O','246121',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152563,620,'Thapla B.O','246175',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152564,620,'Tharapdhar B.O','246163',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152565,620,'Tilkholi B.O','246172',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152566,620,'Timalsain B.O','246179',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152567,620,'Timlibari B.O','246121',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152568,620,'Toli S.O','246176',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152569,620,'Toliyun B.O','246277',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152570,620,'Ufalda B.O','246174',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152571,620,'Ufaraikhal B.O','246275',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152572,620,'Upper Bazar S.O','246001',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152573,620,'Uragi B.O','246165',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152574,620,'Utinda B.O','246173',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152575,620,'Uziyari B.O','246001',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152576,620,'Vedikhal S.O','246177',1,0,'2022-03-04 19:39:07','2022-03-04 19:39:07'),(152577,620,'Yamkeshwar B.O','246121',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152578,621,'Adichaura B.O','262551',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152579,621,'Agar S.O','262534',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152580,621,'Aincholi S.O','262530',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152581,621,'Ajera B.O','262543',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152582,621,'Algara B.O','262542',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152583,621,'Askote S.O','262543',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152584,621,'Atalgaon B.O','262551',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152585,621,'Badari B.O','262521',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152586,621,'Bagartoli B.O','262521',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152587,621,'Bagjibala B.O','262551',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152588,621,'Baikote B.O','262544',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152589,621,'Baira B.O','262543',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152590,621,'Bajani B.O','262551',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152591,621,'Balgari B.O','262552',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152592,621,'Baling(S) B.O','262545',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152593,621,'Baltari B.O','262521',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152594,621,'Baluwakote S.O','262576',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152595,621,'Bamdoli B.O','262542',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152596,621,'Bandarlima B.O','262541',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152597,621,'Bankote B.O','262532',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152598,621,'Bans B.O','262501',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152599,621,'Bansbagar S.O','262555',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152600,621,'Banspatan B.O','262532',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152601,621,'Barabey GDSB.O','262530',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152602,621,'Baralu B.O','262521',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152603,621,'Baram B.O','262544',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152604,621,'Baret B.O','262552',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152605,621,'Barmau B.O','262540',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152606,621,'Barsayat B.O','262552',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152607,621,'Basaur B.O','262544',1,0,'2022-03-04 19:39:08','2022-03-04 19:39:08'),(152608,621,'Baste B.O','262501',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152609,621,'Batgari B.O','262532',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152610,621,'Baun(S) B.O','262545',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152611,621,'Bauna B.O','262554',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152612,621,'Belkote B.O','262531',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152613,621,'Beltari B.O','262520',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152614,621,'Bera B.O','262529',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152615,621,'Berinag S.O','262531',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152616,621,'Bhainskote B.O','262553',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152617,621,'Bhanara B.O','262551',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152618,621,'Bhandarigaon B.O','262552',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152619,621,'Bhantarh B.O','262552',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152620,621,'Bharkatia S.O','262520',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152621,621,'Bhateri B.O','262521',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152622,621,'Bhatigaon B.O','262552',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152623,621,'Bhauri B.O','262540',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152624,621,'Bhulgaon B.O','262540',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152625,621,'Bhumwari B.O','262561',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152626,621,'Bhurmuni B.O','262501',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152627,621,'Bhuwaneshwar B.O','262522',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152628,621,'Bichhul B.O','262540',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152629,621,'Bilai B.O','262520',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152630,621,'Bin B.O','262501',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152631,621,'Binayak B.O','262552',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152632,621,'Birgoli B.O','262522',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152633,621,'Bisabajerh B.O','262540',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152634,621,'Bisharh B.O','262502',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152635,621,'Bishonakhan B.O','262541',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152636,621,'Borabunga B.O','262551',1,0,'2022-03-04 19:39:09','2022-03-04 19:39:09'),(152637,621,'Boragaon B.O','262551',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152638,621,'Boyal B.O','262522',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152639,621,'Bundi(S) B.O','262547',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152640,621,'Bungachinna B.O','262542',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152641,621,'Bungli B.O','262522',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152642,621,'Burfu(S) B.O','262554',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152643,621,'Chahaj B.O','262522',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152644,621,'Chalma Chilasu B.O','262547',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152645,621,'Chamachaur B.O','262534',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152646,621,'Chamali B.O','262530',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152647,621,'Chamu B.O','262542',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152648,621,'Chandak B.O','262501',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152649,621,'Chankana B.O','262531',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152650,621,'Chanoli B.O','262541',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152651,621,'Charandeo B.O','262541',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152652,621,'Charchum B.O','262576',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152653,621,'Chaubati B.O','262551',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152654,621,'Chaukori B.O','262531',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152655,621,'Chauna B.O','262534',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152656,621,'Chauna B.O','262554',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152657,621,'Chaunala B.O','262522',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152658,621,'Chaupata B.O','262540',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152659,621,'Chaurakote B.O','262561',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152660,621,'Chaurpal B.O','262522',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152661,621,'Chausal B.O','262543',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152662,621,'Chausala B.O','262533',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152663,621,'Cherra B.O','262501',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152664,621,'Chingri B.O','262529',1,0,'2022-03-04 19:39:10','2022-03-04 19:39:10'),(152665,621,'Chitgal B.O','262522',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152666,621,'Collectorate Parisar','262523',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152667,621,'Collectorate S.O (Pithoragarh)','262501',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152668,621,'Dangigaon B.O','262552',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152669,621,'Dangti B.O','262543',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152670,621,'Dar B.O','262545',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152671,621,'Dasaithal GDS B.O','262522',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152672,621,'Dashauli B.O','262533',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152673,621,'Daubans B.O','262540',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152674,621,'Daulaupreti B.O','262534',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152675,621,'Daulawalia B.O','262522',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152676,621,'Daura B.O','262541',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152677,621,'Degree College S.O (Pithoragarh)','262502',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152678,621,'Dekuna B.O','262553',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152679,621,'Deoraripant B.O','262532',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152680,621,'Devinagar B.O','262531',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152681,621,'Dewalthal S.O','262542',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152682,621,'Dhamigaon B.O','262555',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152683,621,'Dhapna B.O','262532',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152684,621,'Dharamghar GDS B.O','262531',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152685,621,'Dharchula S.O','262545',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152686,621,'Dharidhumlakote B.O','262532',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152687,621,'Dhaulkanda B.O','262540',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152688,621,'Dhunamani B.O','262554',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152689,621,'Dhungatoli B.O','262576',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152690,621,'Didihat S.O','262551',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152691,621,'Digtoli B.O','262501',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152692,621,'Dor B.O','262553',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152693,621,'Dugai Agar B.O','262522',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152694,621,'Dugtu(S) B.O','262545',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152695,621,'Dummar B.O','262554',1,0,'2022-03-04 19:39:11','2022-03-04 19:39:11'),(152696,621,'Dungara B.O','262501',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152697,621,'Dungri B.O','262555',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152698,621,'Dungri B.O','262541',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152699,621,'Duni B.O','262522',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152700,621,'Fultari B.O','262576',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152701,621,'Ganai Gangoli S.O','262532',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152702,621,'Gangolihat S.O','262522',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152703,621,'Ganura B.O','262522',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152704,621,'Garali B.O','262544',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152705,621,'Garbyang S.O','262546',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152706,621,'Garguwa B.O','262545',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152707,621,'Garhgaon B.O','262540',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152708,621,'Gartir B.O','262531',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152709,621,'Gaulchaura B.O','262532',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152710,621,'Gaunch B.O','262540',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152711,621,'Gaurihat B.O','262521',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152712,621,'Ghat B.O','262529',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152713,621,'Ghingrani B.O','262543',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152714,621,'Ghorasil B.O','262532',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152715,621,'Girgaon B.O','262553',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152716,621,'Gobrari B.O','262552',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152717,621,'Goe B.O','262545',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152718,621,'Govarsa B.O','262541',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152719,621,'Gudauli B.O','262541',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152720,621,'Guiyyan B.O','262576',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152721,621,'Gunji B.O','262546',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152722,621,'Guptari B.O','262522',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152723,621,'Gurburani B.O','262531',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152724,621,'Gurna S.O','262529',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152725,621,'Guwal B.O','262534',1,0,'2022-03-04 19:39:12','2022-03-04 19:39:12'),(152726,621,'Hachila B.O','262541',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152727,621,'Hajeti B.O','262552',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152728,621,'Himtarh B.O','262529',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152729,621,'Hokra B.O','262553',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152730,621,'Hupuli B.O','262553',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152731,621,'Jajardewal S.O','262540',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152732,621,'Jajurali B.O','262501',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152733,621,'Jakheri B.O','262532',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152734,621,'Jakhniupreti B.O','262522',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152735,621,'Jakhpant B.O','262521',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152736,621,'Jakhpuran B.O','262530',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152737,621,'Jamku B.O','262545',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152738,621,'Jamtari B.O','262544',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152739,621,'Jarajibli B.O','262544',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152740,621,'Jarapani B.O','262534',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152741,621,'Jauljibi S.O','262544',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152742,621,'Jaurasi B.O','262551',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152743,621,'Jethigaon B.O','262543',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152744,621,'Jhudeli B.O','262561',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152745,621,'Jhulaghat S.O','262526',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152746,621,'Jhuni B.O','262501',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152747,621,'Jipti B.O','262547',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152748,621,'Josha B.O','262554',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152749,621,'Jumma B.O','262545',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152750,621,'Kailash B.O','262547',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152751,621,'Kalika B.O','262576',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152752,621,'Kamad B.O','262522',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152753,621,'Kanalichina S.O','262541',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152754,621,'Kanara B.O','262522',1,0,'2022-03-04 19:39:13','2022-03-04 19:39:13'),(152755,621,'Kandar B.O','262544',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152756,621,'Kandarachina B.O','262522',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152757,621,'Kandey B.O','262531',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152758,621,'Katiyani B.O','262521',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152759,621,'Kauli B.O','262544',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152760,621,'Kharik B.O','262555',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152761,621,'Kharki Bajyura B.O','262522',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152762,621,'Khatera B.O','262553',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152763,621,'Khatigaon B.O','262501',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152764,621,'Khela B.O','262545',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152765,621,'Khet B.O','262545',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152766,621,'Khirmandey B.O','262522',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152767,621,'Khulet B.O','262522',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152768,621,'Khumti B.O','262576',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152769,621,'Khwankote B.O','262541',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152770,621,'Khwantari B.O','262541',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152771,621,'Kirauli B.O','262551',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152772,621,'Koteshwar B.O','262534',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152773,621,'Kotgari Ghanjri B.O','262533',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152774,621,'Kothera B.O','262522',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152775,621,'Kukrauli B.O','262552',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152776,621,'Kunalta B.O','262532',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152777,621,'Kurila B.O','262547',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152778,621,'Lachhima B.O','262533',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152779,621,'Lakhatigaon B.O','262551',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152780,621,'Leelam B.O','262554',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152781,621,'Lejam B.O','262552',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152782,621,'Lohathal B.O','262531',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152783,621,'Lumti B.O','262544',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152784,621,'Madalkiya B.O','262553',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152785,621,'Madkote B.O','262554',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152786,621,'Majhera B.O','262543',1,0,'2022-03-04 19:39:14','2022-03-04 19:39:14'),(152787,621,'Malan B.O','262541',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152788,621,'Mallagarkha B.O','262522',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152789,621,'Marchha B.O','262545',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152790,621,'Marh B.O','262521',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152791,621,'Markharayat B.O','262540',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152792,621,'Marmanley B.O','262540',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152793,621,'Mauna B.O','262522',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152794,621,'Mawani Dawani B.O','262555',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152795,621,'Mazirkanda B.O','262521',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152796,621,'Meldungri B.O','262529',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152797,621,'Merla Sangaur B.O','262533',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152798,621,'Merthi S.O','262550',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152799,621,'Metli B.O','262544',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152800,621,'Millam(S) B.O','262554',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152801,621,'Mulakote B.O','262561',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152802,621,'Munakote B.O','262521',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152803,621,'Munsiari S.O','262554',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152804,621,'Muwani GDS B.O','262552',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152805,621,'Nachni B.O','262553',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152806,621,'Nagaur B.O','262534',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152807,621,'Naghar B.O','262551',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152808,621,'Nagling B.O','262545',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152809,621,'Naichuna Bussail B.O','262522',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152810,621,'Naini B.O','262531',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152811,621,'Nainipatal B.O','262540',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152812,621,'Nainisaini B.O','262540',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152813,621,'Nakote GDS B.O','262501',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152814,621,'Nali B.O','262522',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152815,621,'Namik B.O','262553',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152816,621,'Nanoli B.O','262522',1,0,'2022-03-04 19:39:15','2022-03-04 19:39:15'),(152817,621,'Narayan Nagar B.O','262550',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152818,621,'Nwalichainpur B.O','262541',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152819,621,'Ogla B.O','262543',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152820,621,'Okhrani B.O','262533',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152821,621,'Pabhain B.O','262501',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152822,621,'Pamsyari B.O','262551',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152823,621,'Pamtori B.O','262552',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152824,621,'Pangla B.O','262547',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152825,621,'Pangu S.O','262547',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152826,621,'Pankhu S.O','262533',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152827,621,'Panthgaon B.O','262576',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152828,621,'Panthuri B.O','262521',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152829,621,'Panthyali B.O','262551',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152830,621,'Patet B.O','262552',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152831,621,'Pathrauli B.O','262542',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152832,621,'Pati S.O','262561',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152833,621,'Paun B.O','262502',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152834,621,'Pawwadhar B.O','262522',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152835,621,'Payyanpauri B.O','262576',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152836,621,'Pipali B.O','262541',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152837,621,'Pipali Jabuka B.O','262531',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152838,621,'Pithoragarh H.O','262501',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152839,621,'Pokhri B.O','262522',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152840,621,'Quitarh B.O','262521',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152841,621,'Quiti GDS B.O','262553',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152842,621,'Raitoli B.O','262531',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152843,621,'Ram Mandir B.O','262534',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152844,621,'Ramtoli B.O','262545',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152845,621,'Ranthi B.O','262554',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152846,621,'Ranthi Boragaon B.O','262545',1,0,'2022-03-04 19:39:16','2022-03-04 19:39:16'),(152847,621,'Rarikhunti B.O','262529',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152848,621,'Rasaipata B.O','262542',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152849,621,'Rautera B.O','262522',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152850,621,'Rawalkhet B.O','262522',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152851,621,'Ringu Chilkote B.O','262554',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152852,621,'Roripali B.O','262501',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152853,621,'Rungari B.O','262532',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152854,621,'Sain B.O','262554',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152855,621,'Sainranthi B.O','262553',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152856,621,'Sakun B.O','262521',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152857,621,'Saliya B.O','262532',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152858,621,'Salla B.O','262529',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152859,621,'Samkote B.O','262555',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152860,621,'Sandeo B.O','262551',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152861,621,'Satgarh B.O','262540',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152862,621,'Satshilling B.O','262540',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152863,621,'Saugaon B.O','262551',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152864,621,'Sel B.O','262529',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152865,621,'Sela B.O','262545',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152866,621,'Selavan B.O','262552',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152867,621,'Selmali B.O','262555',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152868,621,'Seloni B.O','262521',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152869,621,'Sera B.O','262555',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152870,621,'Serikumdar B.O','262521',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152871,621,'Sevila B.O','262554',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152872,621,'Shilling B.O','262530',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152873,621,'Shillingatoli B.O','262530',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152874,621,'Shivalaya S.O','262501',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152875,621,'Siltham S.O','262501',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152876,621,'Simalkhet B.O','262561',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152877,621,'Simalkote B.O','262520',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152878,621,'Simkhola B.O','262547',1,0,'2022-03-04 19:39:17','2022-03-04 19:39:17'),(152879,621,'Singali B.O','262543',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152880,621,'Sinichama B.O','262551',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152881,621,'Sinlekh B.O','262522',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152882,621,'Sirkha B.O','262547',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152883,621,'Sirkuch B.O','262521',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152884,621,'Sosa B.O','262547',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152885,621,'Surauli B.O','262542',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152886,621,'Suwa B.O','262545',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152887,621,'Syankuri B.O','262545',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152888,621,'Tarigaon B.O','262552',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152889,621,'Tawaghat B.O','262545',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152890,621,'Teejam B.O','262545',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152891,621,'Tejam S.O','262553',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152892,621,'Thal S.O (Pithoragarh)','262552',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152893,621,'Tham B.O','262544',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152894,621,'Tharkote B.O','262530',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152895,621,'Tharp B.O','262531',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152896,621,'Timta B.O','262522',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152897,621,'Titari B.O','262543',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152898,621,'Toli B.O','262529',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152899,621,'Toli B.O','262544',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152900,621,'Totanaula B.O','262540',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152901,621,'Tripuradevi B.O','262531',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152902,621,'Uchhaiti B.O','262554',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152903,621,'Udiyari B.O','262531',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152904,621,'Urai B.O','262542',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152905,621,'Wadda S.O','262521',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152906,621,'Walthi B.O','262554',1,0,'2022-03-04 19:39:18','2022-03-04 19:39:18'),(152907,622,'Agar B.O','246442',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152908,622,'Andrwari B.O','246439',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152909,622,'Arkhund B.O','246425',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152910,622,'Augustmuni S.O','246421',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152911,622,'Badasu B.O','246471',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152912,622,'Baksir B.O','246419',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152913,622,'Bansu B.O','246439',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152914,622,'Barab B.O','246425',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152915,622,'Bareth B.O','246419',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152916,622,'Barsir B.O','246141',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152917,622,'Barsudi B.O','246171',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152918,622,'Basti B.O','246425',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152919,622,'Basukedar B.O','246425',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152920,622,'Bawai B.O','246442',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152921,622,'Bhatwari B.O','246421',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152922,622,'Bhaunsal B.O','246421',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152923,622,'Bhiri S.O','246419',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152924,622,'Bijarakot B.O','246429',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152925,622,'Biron B.O','246171',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152926,622,'Budna B.O','246475',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152927,622,'Byung B.O','246471',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152928,622,'Chandra Nagar B.O','246425',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152929,622,'Chandrapuri S.O','246425',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152930,622,'Chaura B.O','246141',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152931,622,'Chauriyabhardar B.O','246475',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152932,622,'Chirbatiya B.O','246475',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152933,622,'Chopra S.O (Rudraprayag)','246495',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152934,622,'Dadoli B.O','246421',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152935,622,'Daira B.O','246469',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152936,622,'Dangwal Gaon B.O','246421',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152937,622,'Devidharmamani B.O','246475',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152938,622,'Dhartondla B.O','246425',1,0,'2022-03-04 19:39:19','2022-03-04 19:39:19'),(152939,622,'Diuli Bhanigram B.O','246439',1,0,'2022-03-04 19:39:20','2022-03-04 19:39:20'),(152940,622,'Durgadhar B.O','246442',1,0,'2022-03-04 19:39:20','2022-03-04 19:39:20'),(152941,622,'Fafanj B.O','246469',1,0,'2022-03-04 19:39:20','2022-03-04 19:39:20'),(152942,622,'Falasi B.O','246442',1,0,'2022-03-04 19:39:20','2022-03-04 19:39:20'),(152943,622,'Gaharkhal B.O','246171',1,0,'2022-03-04 19:39:20','2022-03-04 19:39:20'),(152944,622,'Gaurikund B.O','246471',1,0,'2022-03-04 19:39:20','2022-03-04 19:39:20'),(152945,622,'Ghandiyalka B.O','246171',1,0,'2022-03-04 19:39:20','2022-03-04 19:39:20'),(152946,622,'Ghimtoli B.O','246442',1,0,'2022-03-04 19:39:20','2022-03-04 19:39:20'),(152947,622,'Gholtir B.O','246171',1,0,'2022-03-04 19:39:20','2022-03-04 19:39:20'),(152948,622,'Guptkashi S.O','246439',1,0,'2022-03-04 19:39:20','2022-03-04 19:39:20'),(152949,622,'Haretikhal B.O','246495',1,0,'2022-03-04 19:39:20','2022-03-04 19:39:20'),(152950,622,'Jagoth B.O','246425',1,0,'2022-03-04 19:39:20','2022-03-04 19:39:20'),(152951,622,'Jakhal B.O','246475',1,0,'2022-03-04 19:39:20','2022-03-04 19:39:20'),(152952,622,'Jakhani S.O','246442',1,0,'2022-03-04 19:39:20','2022-03-04 19:39:20'),(152953,622,'Jakhanoli B.O','246475',1,0,'2022-03-04 19:39:20','2022-03-04 19:39:20'),(152954,622,'Jakhdhar B.O','246171',1,0,'2022-03-04 19:39:20','2022-03-04 19:39:20'),(152955,622,'Jakholi S.O','246141',1,0,'2022-03-04 19:39:20','2022-03-04 19:39:20'),(152956,622,'Jaltalla B.O','246439',1,0,'2022-03-04 19:39:20','2022-03-04 19:39:20'),(152957,622,'Kalimath B.O','246439',1,0,'2022-03-04 19:39:20','2022-03-04 19:39:20'),(152958,622,'Kamera B.O','246171',1,0,'2022-03-04 19:39:20','2022-03-04 19:39:20'),(152959,622,'Kanda B.O','246475',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152960,622,'Kandai B.O','246171',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152961,622,'Kandai B.O','246429',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152962,622,'Kandara B.O','246425',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152963,622,'Kedarnath Seasional S.O','246445',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152964,622,'Khaliyan B.O','246141',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152965,622,'Khankara B.O','246171',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152966,622,'Kimana B.O','246421',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152967,622,'Kolli B.O','246171',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152968,622,'Kotbangar B.O','246141',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152969,622,'Kotma B.O','246439',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152970,622,'Kotmalla B.O','246429',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152971,622,'Kumerisimli B.O','246475',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152972,622,'Kurchhola B.O','246475',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152973,622,'Kurjhan B.O','246495',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152974,622,'Kweelakhal B.O','246475',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152975,622,'Kyark Barsuri B.O','246425',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152976,622,'Kyuri B.O','246442',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152977,622,'Kyuridasjula B.O','246429',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152978,622,'Ladoli B.O','246429',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152979,622,'Lamgondi B.O','246439',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152980,622,'Machkandi B.O','246425',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152981,622,'Maiki Marhi B.O','246171',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152982,622,'Maikoti S.O','246448',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152983,622,'Makoomath B.O','246419',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152984,622,'Mansoona B.O','246469',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152985,622,'Mayali B.O','246475',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152986,622,'Munnadewal B.O','246475',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152987,622,'Mussadhung B.O','246475',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152988,622,'Nagjagai B.O','246419',1,0,'2022-03-04 19:39:21','2022-03-04 19:39:21'),(152989,622,'Nainipondar B.O','246425',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(152990,622,'Narainkoti B.O','246471',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(152991,622,'Narkota B.O','246171',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(152992,622,'Nawasu B.O','246171',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(152993,622,'Okhimath S.O','246469',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(152994,622,'Paldwari B.O','246419',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(152995,622,'Pallabazar S.O','246171',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(152996,622,'Pandrola B.O','246475',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(152997,622,'Panjana B.O','246141',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(152998,622,'Parkandi B.O','246419',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(152999,622,'Pathalidhar B.O','246421',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(153000,622,'Paunthi B.O','246141',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(153001,622,'Pauri Nishni B.O','246171',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(153002,622,'Phata S.O','246471',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(153003,622,'Pilloo B.O','246425',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(153004,622,'Pokhata B.O','246442',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(153005,622,'Purviyana B.O','246141',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(153006,622,'Rampur B.O','246471',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(153007,622,'Ransi B.O','246439',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(153008,622,'Ratura B.O','246171',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(153009,622,'Raunlenk B.O','246439',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(153010,622,'Rudraprayag S.O','246171',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(153011,622,'Rumsi B.O','246421',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(153012,622,'Sakalana B.O','246475',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(153013,622,'Sari B.O','246429',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(153014,622,'Sari B.O','246469',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(153015,622,'Saterakhal B.O','246171',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(153016,622,'Saurakhal B.O','246475',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(153017,622,'Semlta B.O','246475',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(153018,622,'Serabhardar B.O','246171',1,0,'2022-03-04 19:39:22','2022-03-04 19:39:22'),(153019,622,'Sidhsaur B.O','246475',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153020,622,'Silli B.O','246421',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153021,622,'Sirwari B.O','246141',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153022,622,'Sumerpur B.O','246171',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153023,622,'Sursal B.O','246419',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153024,622,'Syurbangar B.O','246421',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153025,622,'Taila B.O','246475',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153026,622,'Thatigadgu B.O','246469',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153027,622,'Tilwara S.O','246475',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153028,622,'Timli Badama B.O','246421',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153029,622,'Trijuginarain B.O','246471',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153030,622,'Tulanga B.O','246439',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153031,622,'Tuneta B.O','246475',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153032,622,'Uchadhungi B.O','246425',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153033,622,'Uchhola B.O','246419',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153034,622,'Uniyana B.O','246439',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153035,622,'Uttarsu B.O','246421',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153036,622,'Vidhyapeeth B.O','246439',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153037,622,'Vinobapuri B.O','246425',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153038,623,'Agar B.O','249175',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153039,623,'Akhori B.O','249155',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153040,623,'Aleru B.O','249131',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153041,623,'Amni B.O','249122',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153042,623,'Amsari B.O','249146',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153043,623,'Anandchowk B.O','249145',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153044,623,'Anjanisain S.O','249121',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153045,623,'Atali -byasi B.O','249192',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153046,623,'Bachhelikhal B.O','249192',1,0,'2022-03-04 19:39:23','2022-03-04 19:39:23'),(153047,623,'Badiyargarh B.O','249161',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153048,623,'Badon B.O','249161',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153049,623,'Badshahithaul B.O','249199',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153050,623,'Bagi B.O','249175',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153051,623,'Bagiyal B.O','249132',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153052,623,'Bahera B.O','249145',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153053,623,'Bairaigaon B.O','249192',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153054,623,'Bajiyalgaon B.O','249155',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153055,623,'Banali B.O','249175',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153056,623,'Bangar B.O','249180',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153057,623,'Bangsil B.O','249180',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153058,623,'Banskatal B.O','249192',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153059,623,'Barkot B.O','249181',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153060,623,'Beena B.O','249155',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153061,623,'Berni B.O','249175',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153062,623,'Bhaatgaon B.O','249181',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153063,623,'Bhagirathipuram S.O','249124',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153064,623,'Bhainskot B.O','249122',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153065,623,'Bhalkatal B.O','249180',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153066,623,'Bhallegaon S.O','249126',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153067,623,'Bhaneldi B.O','249181',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153068,623,'Bharkot B.O','249165',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153069,623,'Bharpur B.O','249192',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153070,623,'Bhatgaon B.O','249155',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153071,623,'Bhatwara B.O','249155',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153072,623,'Bhawan B.O','249180',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153073,623,'Bhigun B.O','249125',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153074,623,'Bhladiana S.O','249131',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153075,623,'Binaykhal B.O','249125',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153076,623,'Chaka B.O','249146',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153077,623,'Chamani B.O','249199',1,0,'2022-03-04 19:39:24','2022-03-04 19:39:24'),(153078,623,'Chamiyala S.O','249125',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153079,623,'Chamma S.O','249145',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153080,623,'Chamolgaon B.O','249175',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153081,623,'Chandreshwar B.O','249181',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153082,623,'Chanji B.O','249155',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153083,623,'Chham S.O','249132',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153084,623,'Chherabdhar B.O','249131',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153085,623,'Chheti B.O','249123',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153086,623,'Chopriyalgaon B.O','249145',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153087,623,'Chourikhal B.O','249161',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153088,623,'Chulyani B.O','249180',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153089,623,'Daang B.O','249161',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153090,623,'Dalla Argrh B.O','249181',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153091,623,'Dangchoura B.O','249161',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153092,623,'Dangi B.O','249155',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153093,623,'Darogi B.O','249122',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153094,623,'Devtadhar B.O','249181',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153095,623,'Dewath B.O','249155',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153096,623,'Dhalwala S.O','249137',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153097,623,'Dhanolti B.O','249180',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153098,623,'Dharidhungsir B.O','249161',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153099,623,'Dharkot B.O','249131',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153100,623,'Dharkot B.O','249161',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153101,623,'Dharkot-udaikot B.O','249130',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153102,623,'Dhopardhar B.O','249155',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153103,623,'Dhounikhal B.O','249155',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153104,623,'Dhountri B.O','249165',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153105,623,'Dugadda B.O','249161',1,0,'2022-03-04 19:39:25','2022-03-04 19:39:25'),(153106,623,'Duwadhar B.O','249175',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153107,623,'Dwargarh B.O','249180',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153108,623,'Dyuli B.O','249175',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153109,623,'Fakot B.O','249175',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153110,623,'Falenda B.O','249155',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153111,623,'Gadoli B.O','249141',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153112,623,'Gadoliya B.O','249181',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153113,623,'Gairi B.O','249196',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153114,623,'Gajja S.O','249146',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153115,623,'Garakot B.O','249121',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153116,623,'Ghandiyaldhr B.O','249161',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153117,623,'Ghansali S.O','249155',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153118,623,'Ghonti B.O','249181',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153119,623,'Ghuttu B.O','249155',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153120,623,'Gomukh B.O','249121',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153121,623,'Gona B.O','249125',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153122,623,'Gulardogi B.O','249192',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153123,623,'Gyansoo B.O','249001',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153124,623,'Hadiyanakholi B.O','249155',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153125,623,'Hatwalgaon B.O','249145',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153126,623,'Hill Campus Pantnagar B.O','249199',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153127,623,'Hindolakhal S.O','249122',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153128,623,'Hinsriyakhal B.O','249126',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153129,623,'Jaakhchoura B.O','249130',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153130,623,'Jad Gaon B.O','249145',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153131,623,'Jajal B.O','249175',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153132,623,'Jakhand B.O','249161',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153133,623,'Jakhidagar B.O','249161',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153134,623,'Jakhnidhar S.O','249123',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153135,623,'Jakhniyali B.O','249155',1,0,'2022-03-04 19:39:26','2022-03-04 19:39:26'),(153136,623,'Jakholi B.O','249146',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153137,623,'Jamnikhal B.O','249122',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153138,623,'Jamthiyal Gaon B.O','249145',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153139,623,'Jardhargaon B.O','249175',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153140,623,'Joulangi B.O','249130',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153141,623,'Kafal Pani B.O','249130',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153142,623,'Kafna B.O','249161',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153143,623,'Kafolgaon B.O','249125',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153144,623,'Kakhoor B.O','249192',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153145,623,'Kakhwari B.O','249145',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153146,623,'Kamand B.O','249131',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153147,623,'Kanatal B.O','249145',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153148,623,'Kandarsyun B.O','249125',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153149,623,'Kandikhal B.O','249131',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153150,623,'Kandiyalgaon B.O','249165',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153151,623,'Kathoor B.O','249155',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153152,623,'Kathud B.O','249146',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153153,623,'Kaudiyala B.O','249192',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153154,623,'Kaushal B.O','249132',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153155,623,'Kepars B.O','249125',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153156,623,'Khaand B.O','249146',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153157,623,'Khalargaon B.O','249165',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153158,623,'Khambakhal B.O','249165',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153159,623,'Khandogi B.O','249123',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153160,623,'Kharsadi B.O','249192',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153161,623,'Khawara B.O','249125',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153162,623,'Khola B.O','249161',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153163,623,'Khyarsi B.O','249180',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153164,623,'Kilkileshwar B.O','249161',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153165,623,'Kinsoo B.O','249180',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153166,623,'Kireth B.O','249125',1,0,'2022-03-04 19:39:27','2022-03-04 19:39:27'),(153167,623,'Kirtinagar S.O','249161',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153168,623,'Kotalgaon B.O','249165',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153169,623,'Kothi B.O','249146',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153170,623,'Kothiyara B.O','249125',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153171,623,'Kotipav B.O','249186',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153172,623,'Kotmaniyar B.O','249145',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153173,623,'Kundri B.O','249122',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153174,623,'Kuttha B.O','249001',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153175,623,'Kyara B.O','249192',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153176,623,'Kyari B.O','249199',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153177,623,'Laloorikhal B.O','249122',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153178,623,'Lambgaon S.O','249165',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153179,623,'Lamkot B.O','249199',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153180,623,'Lawa B.O','249146',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153181,623,'Lawani B.O','249132',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153182,623,'Madan Negi B.O','249131',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153183,623,'Magron B.O','249161',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153184,623,'Mahad B.O','249122',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153185,623,'Maid B.O','249125',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153186,623,'Maighadhar B.O','249155',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153187,623,'Maindkhal B.O','249132',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153188,623,'Majafgaon B.O','249165',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153189,623,'Maletha B.O','249161',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153190,623,'Malgaon B.O','249155',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153191,623,'Malyakot B.O','249155',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153192,623,'Mandar B.O','249181',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153193,623,'Manderigaon B.O','249192',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153194,623,'Manjhgaon B.O','249145',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153195,623,'Manjiyari B.O','249192',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153196,623,'Manjkot B.O','249161',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153197,623,'Maror B.O','249186',1,0,'2022-03-04 19:39:28','2022-03-04 19:39:28'),(153198,623,'Maroragaad B.O','249146',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153199,623,'Mindath B.O','249192',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153200,623,'Mogi B.O','249186',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153201,623,'Mori S.O (Tehri Garhwal)','249128',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153202,623,'Mukhem B.O','249165',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153203,623,'Mundala B.O','249192',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153204,623,'Munikireti S.O','249137',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153205,623,'Muyalgaon B.O','249155',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153206,623,'Myanilaloor B.O','249186',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153207,623,'Nagdev Kudiyal Gaon B.O','249145',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153208,623,'Nagni B.O','249175',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153209,623,'Nagrajadhar B.O','249196',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153210,623,'Naicholi B.O','249146',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153211,623,'Naidogi B.O','249192',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153212,623,'Nail B.O','249130',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153213,623,'Nakot B.O','249199',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153214,623,'Narendra Nagar S.O (Tehri Garhwal)','249175',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153215,623,'Nelda B.O','249001',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153216,623,'New Tehri Collectrate S.O','249001',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153217,623,'Nyuli B.O','249161',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153218,623,'Odada B.O','249175',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153219,623,'Odadhar B.O','249155',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153220,623,'Okhla B.O','249131',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153221,623,'Palethi B.O','249122',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153222,623,'Pali B.O','249130',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153223,623,'Palkot B.O','249146',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153224,623,'Panchoor B.O','249121',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153225,623,'Pangerkhal B.O','249001',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153226,623,'Pangriyana B.O','249155',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153227,623,'Pantwari B.O','249186',1,0,'2022-03-04 19:39:29','2022-03-04 19:39:29'),(153228,623,'Parogi B.O','249180',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153229,623,'Pathiyana B.O','249131',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153230,623,'Patniyadevi B.O','249123',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153231,623,'Paurikhal B.O','249121',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153232,623,'Pilkhi S.O','249181',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153233,623,'Pipola B.O','249123',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153234,623,'Pokhar B.O','249155',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153235,623,'Pokhri B.O','249146',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153236,623,'Poukhal B.O','249161',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153237,623,'Pratap Nagar B.O','249165',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153238,623,'Pujargaon B.O','249122',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153239,623,'Purwalgaon B.O','249155',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153240,623,'Radhudhar B.O','249123',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153241,623,'Ragar Gaon B.O','249145',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153242,623,'Raika B.O','249165',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153243,623,'Raimer B.O','249165',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153244,623,'Rajakhet B.O','249001',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153245,623,'Ranakot B.O','249146',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153246,623,'Ranichauri S.O','249199',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153247,623,'Ratnomalla B.O','249131',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153248,623,'Raurdhar B.O','249121',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153249,623,'Ringalgarh B.O','249145',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153250,623,'Roulakot B.O','249131',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153251,623,'Rounad B.O','249165',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153252,623,'Rouniya B.O','249165',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153253,623,'Sabli B.O','249199',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153254,623,'Sadav B.O','249180',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153255,623,'Sain B.O','249146',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153256,623,'Samangaon B.O','249155',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153257,623,'Sankri B.O','249155',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153258,623,'Sarot B.O','249132',1,0,'2022-03-04 19:39:30','2022-03-04 19:39:30'),(153259,623,'Saud B.O','249145',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153260,623,'Semandidhar B.O','249181',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153261,623,'Sendul B.O','249186',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153262,623,'Serabagwan B.O','249165',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153263,623,'Shantipur Sondi B.O','249146',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153264,623,'Shivanand Nagar S.O','249192',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153265,623,'Shivpuri B.O','249192',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153266,623,'Sigunisera S.O','249186',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153267,623,'Siliyara B.O','249155',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153268,623,'Silkakhal B.O','249161',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153269,623,'Silkani B.O','249192',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153270,623,'Sinwalidhar B.O','249122',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153271,623,'Siree B.O','249165',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153272,623,'Sirs B.O','249180',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153273,623,'Siyansu B.O','249131',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153274,623,'Sounp B.O','249125',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153275,623,'Sour B.O','249145',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153276,623,'Sour Uppu B.O','249131',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153277,623,'Souru B.O','249126',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153278,623,'Srikot B.O','249186',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153279,623,'Sunargaon B.O','249125',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153280,623,'Suwakholi B.O','249180',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153281,623,'Sweer B.O','249199',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153282,623,'Takoli B.O','249161',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153283,623,'Talli Ringoli B.O','249161',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153284,623,'Tapoban B.O','249192',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153285,623,'Teehri Kutchery S.O','249001',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153286,623,'Tehri H.O','249001',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153287,623,'Thapla B.O','249165',1,0,'2022-03-04 19:39:31','2022-03-04 19:39:31'),(153288,623,'Thati B.O','249155',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153289,623,'Thati Dagar B.O','249161',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153290,623,'Thatyur S.O','249180',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153291,623,'Thouldhar B.O','249131',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153292,623,'Tikri B.O','249186',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153293,623,'Timli B.O','249192',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153294,623,'Tingri B.O','249199',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153295,623,'Tipri B.O','249123',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153296,623,'Tisriyara B.O','249125',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153297,623,'Toli B.O','249121',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153298,623,'Tungoli B.O','249199',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153299,623,'Tyuna B.O','249122',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153300,623,'Uniyalgaon B.O','249145',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153301,623,'V.K.Puram S.O','249130',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153302,624,'31 Bn PAC Rudarpur S.O','263153',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153303,624,'Adarshnagar B.O','263152',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153304,624,'Anandnagar B.O','244716',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153305,624,'Bagwara B.O','263148',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153306,624,'Bannakhera B.O','262401',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153307,624,'Bara B.O','263148',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153308,624,'Barhani B.O','262401',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153309,624,'Barionwala B.O','244712',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153310,624,'Baruabagh B.O','262405',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153311,624,'Bazpur S.O','262401',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153312,624,'Beria Majhola B.O','262308',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153313,624,'Bhajuanagla B.O','262401',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153314,624,'Bhanga B.O','263148',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153315,624,'Bhura Kishani B.O','262308',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153316,624,'Bhurarani B.O','263153',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153317,624,'Bhuria Coloney B.O','263148',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153318,624,'Bidora B.O','262405',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153319,624,'Bigra Bagh B.O','262308',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153320,624,'Bijitipattia B.O','262405',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153321,624,'Chakarpur B.O','262308',1,0,'2022-03-04 19:39:32','2022-03-04 19:39:32'),(153322,624,'Charubetta B.O','262308',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153323,624,'Chattarpur B.O','263153',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153324,624,'Chaukhandi B.O','244713',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153325,624,'COLLECTORATE PARISAR S.O','263153',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153326,624,'D.F. Nagla S.O','263149',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153327,624,'Danpur B.O','263153',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153328,624,'Darau B.O','263148',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153329,624,'Deoria B.O','263148',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153330,624,'Dhakia No 1 B.O','244713',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153331,624,'Dhanauri B.O','244713',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153332,624,'Dharampur B.O','244712',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153333,624,'Dineshpur S.O','263160',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153334,624,'Doraha B.O','262401',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153335,624,'Fauzi Coloney B.O','262401',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153336,624,'Gadarpur S.O','263152',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153337,624,'Gadarpura B.O','263152',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153338,624,'Ganeshnagar B.O','244713',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153339,624,'Gaujhariya B.O','262308',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153340,624,'Ghusari B.O','262405',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153341,624,'Gidhaur B.O','262308',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153342,624,'Gokul Nagar B.O','263148',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153343,624,'Gular Bhoj Canal Coloney B.O','262401',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153344,624,'Gularbhoj B.O','262401',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153345,624,'Haldi (Udham Singh Nagar) B.O','263145',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153346,624,'Hardaspur B.O','262311',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153347,624,'Haripur Harsan B.O','262401',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153348,624,'Industrial Area Kashipur S.O','244713',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153349,624,'Jamaur B.O','262308',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153350,624,'Jaspur S.O','244712',1,0,'2022-03-04 19:39:33','2022-03-04 19:39:33'),(153351,624,'Jhagarpuri B.O','263152',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153352,624,'Jhankat B.O','262308',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153353,624,'Jogipura B.O','262401',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153354,624,'Kalinagar B.O','263160',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153355,624,'Karanpur B.O','244713',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153356,624,'Kashipur (Udham Singh Nagar) S.O','244713',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153357,624,'Kelakhera S.O','263150',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153358,624,'Khali Mahuwat B.O','262308',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153359,624,'Khanpur B.O','263153',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153360,624,'Khatima S.O','262308',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153361,624,'Kichha S.O','263148',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153362,624,'Kila Street S.O','244713',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153363,624,'Kunda B.O','244713',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153364,624,'Kundeshwari B.O','244713',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153365,624,'Kunwarpur Sisaya B.O','263148',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153366,624,'Lalpur B.O','263148',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153367,624,'Lamakhera B.O','262405',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153368,624,'Mahuwakhera B.O','244713',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153369,624,'Majra Anand Singh B.O','263160',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153370,624,'Maldhanchaur B.O','244713',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153371,624,'Manua Patti B.O','263148',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153372,624,'Nakatpura B.O','263148',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153373,624,'Nakulia B.O','262405',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153374,624,'Nanakmatta S.O','262311',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153375,624,'Narainpur Dohania B.O','263152',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153376,624,'Narayanpur B.O','263148',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153377,624,'Naugaon Nath B.O','262308',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153378,624,'Naugaon Thagoo B.O','262308',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153379,624,'Nausar B.O','262308',1,0,'2022-03-04 19:39:34','2022-03-04 19:39:34'),(153380,624,'Pandari B.O','262405',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153381,624,'Pantnagar S.O','263145',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153382,624,'Patharchatta B.O','263145',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153383,624,'Peerumadra B.O','244715',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153384,624,'Pratappur B.O','244713',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153385,624,'Pratappur B.O','263148',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153386,624,'Pratappur B.O','262311',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153387,624,'Premnagar B.O','263152',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153388,624,'R.T.C. Hempur S.O','244716',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153389,624,'Raipur B.O','244712',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153390,624,'Rudarpur S.O','263153',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153391,624,'S.A.I. Camp B.O','262405',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153392,624,'S.F. Bazpur S.O','262401',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153393,624,'S.M. Nadehi S.O','244717',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153394,624,'Sahdaura B.O','263148',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153395,624,'Sarasaria B.O','262311',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153396,624,'Shaktifarm S.O','263151',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153397,624,'Shantpuri B.O','263148',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153398,624,'Shivrajpur B.O','244713',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153399,624,'Sisona B.O','262405',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153400,624,'Sittarganj S.O','262405',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153401,624,'Spinning Mill Kashipur B.O','244713',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153402,624,'Sripur Bichwa B.O','262308',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153403,624,'Subashnagar B.O','263152',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153404,624,'Sultanpur B.O','244713',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153405,624,'Suryanagar B.O','263148',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153406,624,'T.C. Rudarpur B.O','263153',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153407,624,'Thari B.O','244716',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153408,624,'Uttamnagar B.O','263148',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153409,624,'Uttarsia B.O','263148',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153410,625,'Arakot B.O','249128',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153411,625,'Badhangaon B.O','249196',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153412,625,'Bagasu B.O','249171',1,0,'2022-03-04 19:39:35','2022-03-04 19:39:35'),(153413,625,'Bagori B.O','249196',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153414,625,'Baldogi B.O','249196',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153415,625,'Banchaura B.O','249152',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153416,625,'Bangaon B.O','249152',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153417,625,'Barsu B.O','249135',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153418,625,'Bhankoli B.O','249193',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153419,625,'Bhankoli-ranwain B.O','249171',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153420,625,'Bhansadi B.O','249141',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153421,625,'Bharangaon B.O','249193',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153422,625,'Bhatiya B.O','249171',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153423,625,'Bhatwari S.O','249135',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153424,625,'Bhatwari-dhanari B.O','249151',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153425,625,'Bhutanu B.O','249128',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153426,625,'Bonga B.O','249193',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153427,625,'Boun B.O','249193',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153428,625,'Burkot S.O','249141',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153429,625,'Chiniyalisour S.O','249196',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153430,625,'Chinwa B.O','249128',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153431,625,'Chotimani B.O','249131',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153432,625,'Damta B.O','249171',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153433,625,'Devjani B.O','249185',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153434,625,'Dewal B.O','249171',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153435,625,'Dhakara B.O','249185',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153436,625,'Dharashu B.O','249196',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153437,625,'Dhatmeer B.O','249128',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153438,625,'Dichli B.O','249196',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153439,625,'Diwarikhol B.O','249152',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153440,625,'Diyari B.O','249171',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153441,625,'Doni B.O','249128',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153442,625,'Dunda S.O','249151',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153443,625,'Fitari B.O','249128',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153444,625,'Fold-dhanari B.O','249151',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153445,625,'Gaatu B.O','249171',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153446,625,'Gaddugaad B.O','249185',1,0,'2022-03-04 19:39:36','2022-03-04 19:39:36'),(153447,625,'Gadoli B.O','249152',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153448,625,'Gangani B.O','249141',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153449,625,'Gangar B.O','249128',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153450,625,'Gangnani B.O','249135',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153451,625,'Gangori B.O','249193',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153452,625,'Gangotri B.O','249135',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153453,625,'Gangtari B.O','249141',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153454,625,'Gawana B.O','249193',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153455,625,'Geonla S.O','249152',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153456,625,'Gorsali B.O','249135',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153457,625,'Guniyatgaon B.O','249185',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153458,625,'Gyansu S.O','249193',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153459,625,'Hanuman Chatti B.O','249141',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153460,625,'Harsil B.O','249135',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153461,625,'Hitanubhalshi B.O','249151',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153462,625,'Hudoli B.O','249185',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153463,625,'Jakholi B.O','249128',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153464,625,'Jamunachatti B.O','249141',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153465,625,'Jankimai Chatti B.O','249141',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153466,625,'Jhalla B.O','249135',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153467,625,'Jogath B.O','249196',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153468,625,'Joshiyara B.O','249193',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153469,625,'Junga B.O','249152',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153470,625,'Kafnol B.O','249171',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153471,625,'Kali Gaon B.O','249151',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153472,625,'Kallyani B.O','249193',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153473,625,'Kalogi B.O','249171',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153474,625,'Kalyani B.O','249152',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153475,625,'Kandari B.O','249171',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153476,625,'Kansi B.O','249196',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153477,625,'Kantari B.O','249185',1,0,'2022-03-04 19:39:37','2022-03-04 19:39:37'),(153478,625,'Katkhet B.O','249151',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153479,625,'Khaand B.O','249196',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153480,625,'Khalsi B.O','249196',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153481,625,'Kharsali B.O','249141',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153482,625,'Khurmola B.O','249152',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153483,625,'Kotdhar B.O','249152',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153484,625,'Kotiyalgaon B.O','249171',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153485,625,'Kunwa B.O','249171',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153486,625,'Kyari B.O','249196',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153487,625,'Latasera B.O','249194',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153488,625,'M.D. Colony S.O','249194',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153489,625,'Mahidanda S.O','249195',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153490,625,'Malla B.O','249135',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153491,625,'Maneri B.O','249194',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153492,625,'Manjgaon B.O','249152',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153493,625,'Manpur B.O','249193',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153494,625,'Margaon B.O','249196',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153495,625,'Masri B.O','249128',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153496,625,'Matli B.O','249193',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153497,625,'Moltari B.O','249185',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153498,625,'Mustik Sour B.O','249193',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153499,625,'Nagangaon B.O','249141',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153500,625,'Naggaon B.O','249152',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153501,625,'Naitwar B.O','249128',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153502,625,'Naugaon S.O','249171',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153503,625,'Netala B.O','249193',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153504,625,'New Barsali B.O','249193',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153505,625,'Newsari B.O','249165',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153506,625,'Odgaon B.O','249171',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153507,625,'Pata B.O','249193',1,0,'2022-03-04 19:39:38','2022-03-04 19:39:38'),(153508,625,'Patara B.O','249152',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153509,625,'Pounthi B.O','249141',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153510,625,'Pujargaon B.O','249151',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153511,625,'Pujeli B.O','249141',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153512,625,'Purola S.O','249185',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153513,625,'Rainthal B.O','249135',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153514,625,'Rajgarhi B.O','249141',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153515,625,'Rana B.O','249141',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153516,625,'Ranari B.O','249151',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153517,625,'Raturisera B.O','249193',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153518,625,'Rikhaown B.O','249171',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153519,625,'Rounthal B.O','249196',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153520,625,'Sald B.O','249193',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153521,625,'Sankri B.O','249128',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153522,625,'Sarigadkhamundi B.O','249171',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153523,625,'Sarnol B.O','249141',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153524,625,'Siguni B.O','249151',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153525,625,'Soura B.O','249194',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153526,625,'Srikot B.O','249152',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153527,625,'Tarakot B.O','249152',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153528,625,'Thadiyar B.O','249128',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153529,625,'Thandi B.O','249165',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153530,625,'Thati-dhanari B.O','249151',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153531,625,'Tikochi B.O','249128',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153532,625,'Tipri B.O','249151',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153533,625,'Udri B.O','249165',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153534,625,'Uttarkashi Collectorate S.O','249193',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153535,625,'Uttarkashi S.O','249193',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153536,625,'Uttaron B.O','249193',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153537,626,'Campbelbay S.O','744302',1,0,'2022-03-04 19:39:39','2022-03-04 19:39:39'),(153538,626,'Carnicobar S.O','744301',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153539,626,'Champin B.O','744303',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153540,626,'Chowra B.O','744303',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153541,626,'Gandhinagar B.O','744302',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153542,626,'Kakana B.O','744301',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153543,626,'Kapanga S.O','744304',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153544,626,'Kondul Island B.O','744302',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153545,626,'Lapathy B.O','744301',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153546,626,'Little Nicobar B.O','744302',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153547,626,'Mildera B.O','744304',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153548,626,'Mus B.O','744301',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153549,626,'Nancowrie S.O','744303',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153550,626,'Nehrugram B.O','744304',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153551,626,'Pilomilo Island B.O','744302',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153552,626,'Sawai B.O','744301',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153553,626,'Shabnamnagar B.O','744302',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153554,626,'Teressa B.O','744303',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153555,626,'Trinket B.O','744303',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153556,627,'Aerial Bay B.O','744202',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153557,627,'Bakultala B.O','744205',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153558,627,'Betapur S.O','744201',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153559,627,'Diglipur S.O','744202',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153560,627,'Hathilevel B.O','744202',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153561,627,'Kadamtala S.O (North And Middle Andaman)','744209',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153562,627,'Kalighat B.O','744202',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153563,627,'Kanchangarh B.O','744210',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153564,627,'Kaushalyanagar B.O','744205',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153565,627,'Kishorinagar B.O','744202',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153566,627,'Laxmipur B.O','744202',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153567,627,'Long Island S.O','744203',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153568,627,'Mayabander S.O','744204',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153569,627,'Navagram B.O','744202',1,0,'2022-03-04 19:39:40','2022-03-04 19:39:40'),(153570,627,'Nimbudera B.O','744201',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153571,627,'Nimbutala B.O','744205',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153572,627,'Oralkatcha S.O','744210',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153573,627,'Panchawati B.O','744205',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153574,627,'Parnasala B.O','744205',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153575,627,'Pashimsagar B.O','744202',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153576,627,'Pitchernalla B.O','744201',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153577,627,'Pudumadurai B.O','744204',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153578,627,'Ramnagar B.O','744202',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153579,627,'Rampur B.O','744204',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153580,627,'Rangat S.O','744205',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153581,627,'Sabari B.O','744205',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153582,627,'Sankarnalla B.O','744210',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153583,627,'Sitanagar B.O','744202',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153584,627,'Smith  Island B.O','744202',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153585,627,'Swarajgram B.O','744202',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153586,627,'Swdeshnagar B.O','744201',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153587,627,'Tugapur B.O','744204',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153588,627,'Uttara B.O','744209',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153589,627,'Weby B.O','744',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153590,628,'Aberdeen  Bazar S.O','744104',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153591,628,'Bambooflat S.O','744107',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153592,628,'Beachdera B.O','744206',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153593,628,'Beodnabad B.O','744105',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153594,628,'Bimbiton B.O','744105',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153595,628,'Brijgunj B.O','744103',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153596,628,'Calicut B.O','744105',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153597,628,'Chakargoan S.O','744112',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153598,628,'Chatham S.O','744102',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153599,628,'Chouldari B.O','744103',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153600,628,'Delanipur S.O','744102',1,0,'2022-03-04 19:39:41','2022-03-04 19:39:41'),(153601,628,'Dundas Point B.O','744206',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153602,628,'Garacharama S.O','744105',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153603,628,'Guptapara B.O','744103',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153604,628,'Haddo S.O','744102',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153605,628,'Havelock  Bazar B.O','744211',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153606,628,'Havelock S.O','744211',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153607,628,'Herbertabad B.O','744103',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153608,628,'Humferygunj B.O','744105',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153609,628,'Hut  Bay S.O','744207',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153610,628,'Jirkatong B.O','744206',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153611,628,'Junglighat S.O','744103',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153612,628,'Kalatong B.O','744206',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153613,628,'Marine Jetty S.O','744101',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153614,628,'Mathura B.O','744206',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153615,628,'Miletilak B.O','744206',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153616,628,'Minnie Bay S.O','744103',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153617,628,'N.S.Building S.O','744101',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153618,628,'Neil Island B.O','744104',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153619,628,'Netajinagar B.O','744207',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153620,628,'Ograbanj B.O','744103',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153621,628,'Peal Island B.O','744211',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153622,628,'Port Blair H.O','744101',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153623,628,'R.R Station B.O','744206',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153624,628,'Radio Colony B.O','744102',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153625,628,'Ramakrishnapur B.O','744207',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153626,628,'Rubber Research Station B.O','744206',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153627,628,'Rutland B.O','744105',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153628,628,'School Line B.O','744103',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153629,628,'Shadipur S.O','744106',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153630,628,'Shoalbay B.O','744206',1,0,'2022-03-04 19:39:42','2022-03-04 19:39:42'),(153631,628,'Sippighat B.O','744105',1,0,'2022-03-04 19:39:43','2022-03-04 19:39:43'),(153632,628,'Sitapur B.O','744104',1,0,'2022-03-04 19:39:43','2022-03-04 19:39:43'),(153633,628,'Stewertgunj B.O','744107',1,0,'2022-03-04 19:39:43','2022-03-04 19:39:43'),(153634,628,'Strait  Island B.O','744211',1,0,'2022-03-04 19:39:43','2022-03-04 19:39:43'),(153635,628,'Tushnabad B.O','744103',1,0,'2022-03-04 19:39:43','2022-03-04 19:39:43'),(153636,628,'Vivekandapur B.O','744207',1,0,'2022-03-04 19:39:43','2022-03-04 19:39:43'),(153637,628,'Wandoor B.O','744103',1,0,'2022-03-04 19:39:43','2022-03-04 19:39:43'),(153638,628,'Wimberlygunj S.O','744206',1,0,'2022-03-04 19:39:43','2022-03-04 19:39:43'),(153639,629,'Ahoo Busty B.O','737135',1,0,'2022-03-04 19:39:43','2022-03-04 19:39:43'),(153640,629,'Amba B.O','737133',1,0,'2022-03-04 19:39:43','2022-03-04 19:39:43'),(153641,629,'Aritar B.O','737133',1,0,'2022-03-04 19:39:43','2022-03-04 19:39:43'),(153642,629,'Assam Lingzey B.O','737135',1,0,'2022-03-04 19:39:43','2022-03-04 19:39:43'),(153643,629,'Bardang B.O','737134',1,0,'2022-03-04 19:39:43','2022-03-04 19:39:43'),(153644,629,'Bering B.O','737106',1,0,'2022-03-04 19:39:43','2022-03-04 19:39:43'),(153645,629,'Bermiok B.O','737113',1,0,'2022-03-04 19:39:43','2022-03-04 19:39:43'),(153646,629,'Bermiok B.O','737134',1,0,'2022-03-04 19:39:43','2022-03-04 19:39:43'),(153647,629,'Beyong B.O','737134',1,0,'2022-03-04 19:39:43','2022-03-04 19:39:43'),(153648,629,'Bhusuk B.O','737103',1,0,'2022-03-04 19:39:43','2022-03-04 19:39:43'),(153649,629,'Bojoghari B.O','737103',1,0,'2022-03-04 19:39:43','2022-03-04 19:39:43'),(153650,629,'Changayshanti B.O','737106',1,0,'2022-03-04 19:39:43','2022-03-04 19:39:43'),(153651,629,'Chongey B.O','737103',1,0,'2022-03-04 19:39:43','2022-03-04 19:39:43'),(153652,629,'Chujachen B.O','737131',1,0,'2022-03-04 19:39:43','2022-03-04 19:39:43'),(153653,629,'Dalapchand B.O','737131',1,0,'2022-03-04 19:39:43','2022-03-04 19:39:43'),(153654,629,'Deorali S.O','737102',1,0,'2022-03-04 19:39:43','2022-03-04 19:39:43'),(153655,629,'Dhajey B.O','737102',1,0,'2022-03-04 19:39:43','2022-03-04 19:39:43'),(153656,629,'Dikchu S.O','737107',1,0,'2022-03-04 19:39:43','2022-03-04 19:39:43'),(153657,629,'Dipudara Nhpc Complex B.O','737134',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153658,629,'Duga B.O','737132',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153659,629,'East Pendam B.O','737132',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153660,629,'Gangkha Busty B.O','737134',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153661,629,'Gangtok Bazar S.O','737101',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153662,629,'Gangtok H.O','737101',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153663,629,'Gnathang B.O','737102',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153664,629,'Gor B.O','737107',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153665,629,'Karthok B.O','737106',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153666,629,'Kateng Bokrang B.O','737132',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153667,629,'Khamdong B.O','737134',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153668,629,'Kokalay B.O','737134',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153669,629,'Kyanglasha B.O','737102',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153670,629,'Latuk B.O','737131',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153671,629,'Lingdok B.O','737103',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153672,629,'Lingdum B.O','737102',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153673,629,'Lingee B.O','737134',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153674,629,'Lingmoo B.O','737134',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153675,629,'Lingtam B.O','737131',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153676,629,'Lingzey B.O','737134',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153677,629,'Linkey B.O','737106',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153678,629,'Luing B.O','737103',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153679,629,'Lumlingthyang B.O','737107',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153680,629,'Lunsing B.O','737134',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153681,629,'Majitar S.O','737136',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153682,629,'Makha S.O','737138',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153683,629,'Mamring B.O','737132',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153684,629,'Maney Dara B.O','737132',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153685,629,'Middle Camp B.O','737135',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153686,629,'Namcheybong B.O','737106',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153687,629,'Namphing B.O','737134',1,0,'2022-03-04 19:39:44','2022-03-04 19:39:44'),(153688,629,'Namthang B.O','737132',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153689,629,'Nandok B.O','737135',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153690,629,'Nazitam B.O','737134',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153691,629,'Neya B.O','737134',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153692,629,'North Regu B.O','737131',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153693,629,'Pabyiok B.O','737102',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153694,629,'Pacheykhani B.O','737106',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153695,629,'Pakyong S.O','737106',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153696,629,'Parkha B.O','737131',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153697,629,'Penlong B.O','737103',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153698,629,'Phadamchen B.O','737131',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153699,629,'Rajbhawan S.O (East Sikkim)','737103',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153700,629,'Rakdong B.O','737107',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153701,629,'Raley Khesey B.O','737107',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153702,629,'Rangli Bazar S.O','737131',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153703,629,'Rangpo S.O','737132',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153704,629,'Ranipool S.O','737135',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153705,629,'Rautey-rumtek B.O','737135',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153706,629,'Ray-mindu B.O','737135',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153707,629,'Rhenock S.O','737133',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153708,629,'Rolep B.O','737131',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153709,629,'Rorathang B.O','737133',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153710,629,'Rumtek B.O','737135',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153711,629,'Sakhu Busty B.O','737134',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153712,629,'Samdong B.O','737107',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153713,629,'Samdur B.O','737102',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153714,629,'Samlick-marchak B.O','737135',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153715,629,'Sangkhola B.O','737134',1,0,'2022-03-04 19:39:45','2022-03-04 19:39:45'),(153716,629,'Sherathang B.O','737102',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153717,629,'Shivalaya Mandir Lingsey B.O','737133',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153718,629,'Sichey Gaon S.O','737101',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153719,629,'Sinchuthang B.O','737134',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153720,629,'Singtam S.O','737134',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153721,629,'SMU(Sikkim Manipal University)','737102',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153722,629,'Song B.O','737134',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153723,629,'South Regu B.O','737131',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153724,629,'Sudunglakha B.O','737133',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153725,629,'Sumin B.O','737134',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153726,629,'Tadong S.O','737102',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153727,629,'Tarku B.O','737134',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153728,629,'Tashiling S.O','737103',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153729,629,'Taza B.O','737133',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153730,629,'Temi Tarku B.O','737134',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153731,629,'Tshalamthang B.O','737106',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153732,629,'Tumin B.O','737134',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153733,629,'Turung B.O','737132',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153734,629,'Upper Dalapchand B.O','737133',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153735,629,'Upper Khamdong B.O','737133',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153736,629,'Upper Martam B.O','737135',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153737,629,'Upper Pendam B.O','737132',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153738,629,'West Pendam B.O','737134',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153739,629,'Yangyang B.O','737134',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153740,630,'Chungthang S.O','737120',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153741,630,'Kabi S.O','737117',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153742,630,'Lachen B.O','737120',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153743,630,'Lachung B.O','737120',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153744,630,'Lingdem B.O','737116',1,0,'2022-03-04 19:39:46','2022-03-04 19:39:46'),(153745,630,'Lingthem B.O','737116',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153746,630,'Lower Dzongu B.O','737116',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153747,630,'Mangan S.O','737116',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153748,630,'Manul B.O','737116',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153749,630,'Men Rong Rong B.O','737116',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153750,630,'Naga B.O','737120',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153751,630,'Namok B.O','737116',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153752,630,'Phamtam B.O','737116',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153753,630,'Phensong S.O','737118',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153754,630,'Phudong S.O','737119',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153755,630,'Ramthang B.O','737116',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153756,630,'Rangrang B.O','737116',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153757,630,'Sangkalan B.O','737116',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153758,630,'Shipgyare B.O','737120',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153759,630,'Singhik B.O','737116',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153760,630,'Tingchim B.O','737116',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153761,630,'Tingvong B.O','737116',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153762,631,'Assangthang B.O','737126',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153763,631,'Barfung B.O','737139',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153764,631,'Ben B.O','737139',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153765,631,'Berang B.O','737139',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153766,631,'Damthang B.O','737126',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153767,631,'Kerabari B.O','737128',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153768,631,'Kewzing B.O','737139',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153769,631,'Kitam B.O','737126',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153770,631,'Kupup B.O','737102',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153771,631,'Lungchuk B.O','737128',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153772,631,'Maniram B.O','737126',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153773,631,'Manpur B.O','737128',1,0,'2022-03-04 19:39:47','2022-03-04 19:39:47'),(153774,631,'Melli Bazar S.O','737128',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153775,631,'Melli Dara B.O','737128',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153776,631,'Mic Khola B.O','737126',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153777,631,'Namchi S.O','737126',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153778,631,'Nandugaon B.O','737126',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153779,631,'Okharey B.O','737121',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153780,631,'Pabong B.O','737126',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153781,631,'Payiong B.O','737128',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153782,631,'Perbing B.O','737126',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153783,631,'Phalidara B.O','737126',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153784,631,'Phamtam B.O','737139',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153785,631,'Pipalay B.O','737121',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153786,631,'Poklok B.O','737126',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153787,631,'Ralang B.O','737139',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153788,631,'Rateypani B.O','737128',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153789,631,'Ravangla S.O','737139',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153790,631,'Reshi B.O','737121',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153791,631,'Ribdi-bhareng B.O','737121',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153792,631,'Rong B.O','737126',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153793,631,'Sadam B.O','737128',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153794,631,'Sanchabarey Daramdim B.O','737121',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153795,631,'Sanganath B.O','737121',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153796,631,'Sangmoo B.O','737139',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153797,631,'Shalghari B.O','737126',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153798,631,'Singhithang B.O','737126',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153799,631,'Sombaria B.O','737121',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153800,631,'Soreng B.O','737121',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153801,631,'Sorok B.O','737126',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153802,631,'Sumbuk B.O','737128',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153803,631,'Tingmoo B.O','737139',1,0,'2022-03-04 19:39:48','2022-03-04 19:39:48'),(153804,631,'Tinkitam B.O','737139',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153805,631,'Turuk B.O','737128',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153806,631,'Wok B.O','737126',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153807,632,'Arithang B.O','737111',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153808,632,'Arubotay B.O','737121',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153809,632,'Bhaluthang B.O','737111',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153810,632,'Budang B.O','737121',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153811,632,'Buriakhop B.O','737121',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153812,632,'Chakung B.O','737121',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153813,632,'Chingthang B.O','737111',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153814,632,'Chumbong B.O','737121',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153815,632,'Darap B.O','737113',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153816,632,'Dentam B.O','737113',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153817,632,'Gayzing S.O','737111',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153818,632,'Gerathang B.O','737111',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153819,632,'Hee Gaon B.O','737113',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153820,632,'Kaluk B.O','737113',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153821,632,'Karjee B.O','737111',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153822,632,'Karmatar B.O','737113',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153823,632,'Khechuperi B.O','737113',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153824,632,'Legship B.O','737111',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153825,632,'Lingchom B.O','737111',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153826,632,'Majitar B.O','737121',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153827,632,'Malbasey B.O','737121',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153828,632,'Mechi Aching B.O','737113',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153829,632,'Namphu B.O','737113',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153830,632,'Naya Bazar S.O (West Sikkim)','737121',1,0,'2022-03-04 19:39:49','2022-03-04 19:39:49'),(153831,632,'Pelling S.O','737113',1,0,'2022-03-04 19:39:50','2022-03-04 19:39:50'),(153832,632,'Radhu Khandu B.O','737113',1,0,'2022-03-04 19:39:50','2022-03-04 19:39:50'),(153833,632,'Rangship B.O','737111',1,0,'2022-03-04 19:39:50','2022-03-04 19:39:50'),(153834,632,'Rimbi B.O','737113',1,0,'2022-03-04 19:39:50','2022-03-04 19:39:50'),(153835,632,'Rinchenpong B.O','737111',1,0,'2022-03-04 19:39:50','2022-03-04 19:39:50'),(153836,632,'Sinek B.O','737111',1,0,'2022-03-04 19:39:50','2022-03-04 19:39:50'),(153837,632,'Sri Badam B.O','737121',1,0,'2022-03-04 19:39:50','2022-03-04 19:39:50'),(153838,632,'Suldung B.O','737121',1,0,'2022-03-04 19:39:50','2022-03-04 19:39:50'),(153839,632,'Takuthang B.O','737121',1,0,'2022-03-04 19:39:50','2022-03-04 19:39:50'),(153840,632,'Tashiding B.O','737111',1,0,'2022-03-04 19:39:50','2022-03-04 19:39:50'),(153841,632,'Tharpu B.O','737121',1,0,'2022-03-04 19:39:50','2022-03-04 19:39:50'),(153842,632,'Thingling B.O','737113',1,0,'2022-03-04 19:39:50','2022-03-04 19:39:50'),(153843,632,'Tikpur B.O','737121',1,0,'2022-03-04 19:39:50','2022-03-04 19:39:50'),(153844,632,'Timburbong B.O','737121',1,0,'2022-03-04 19:39:50','2022-03-04 19:39:50'),(153845,632,'Uttarey B.O','737113',1,0,'2022-03-04 19:39:50','2022-03-04 19:39:50'),(153846,632,'Yangtey B.O','737111',1,0,'2022-03-04 19:39:50','2022-03-04 19:39:50'),(153847,632,'Yangthang B.O','737111',1,0,'2022-03-04 19:39:50','2022-03-04 19:39:50'),(153848,632,'Yuksom B.O','737113',1,0,'2022-03-04 19:39:50','2022-03-04 19:39:50'),(153849,632,'Zoom B.O','737121',1,0,'2022-03-04 19:39:50','2022-03-04 19:39:50');
/*!40000 ALTER TABLE `cities` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `community`
--

DROP TABLE IF EXISTS `community`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `community` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(200) NOT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `countries`
--

DROP TABLE IF EXISTS `countries`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `countries` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(60) DEFAULT NULL,
  `isoCode` varchar(45) DEFAULT NULL,
  `isoCode3` varchar(45) DEFAULT NULL,
  `dialCode` varchar(10) DEFAULT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `countries`
--

LOCK TABLES `countries` WRITE;
/*!40000 ALTER TABLE `countries` DISABLE KEYS */;
INSERT INTO `countries` VALUES (1,'India','IND','IN','+91',1,0,'2022-02-11 12:10:11','2022-02-11 12:10:11');
/*!40000 ALTER TABLE `countries` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `diet`
--

DROP TABLE IF EXISTS `diet`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `diet` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(200) NOT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;


--
-- Table structure for table `education`
--

DROP TABLE IF EXISTS `education`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `education` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `parentId` int(11) DEFAULT NULL,
  `name` varchar(200) NOT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `employmenttype`
--

DROP TABLE IF EXISTS `employmenttype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `employmenttype` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `parentId` int(11) DEFAULT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feedback`
--

DROP TABLE IF EXISTS `feedback`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `feedback` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userId` int(11) DEFAULT NULL,
  `description` varchar(45) DEFAULT NULL,
  `title` varchar(45) DEFAULT NULL,
  `transactionDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `f_k_user_id_idx` (`userId`),
  CONSTRAINT `f_k_user_id` FOREIGN KEY (`userId`) REFERENCES `users` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `feedback`
--

--
-- Table structure for table `flaggroup`
--

DROP TABLE IF EXISTS `flaggroup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `flaggroup` (
  `id` int(11) NOT NULL,
  `flagGroupName` varchar(50) DEFAULT NULL,
  `detail` longtext,
  `parentFlagGroupId` int(11) DEFAULT NULL,
  `displayOrder` int(11) DEFAULT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `flaggroup`
--

LOCK TABLES `flaggroup` WRITE;
/*!40000 ALTER TABLE `flaggroup` DISABLE KEYS */;
INSERT INTO `flaggroup` VALUES (1,'General','General',NULL,1,1,0,'2022-10-20 15:50:28','2022-10-20 15:50:28',1,1),(2,'Email Credential','Email Credential',1,1,1,0,'2022-10-20 15:50:28','2022-10-20 15:50:28',1,1),(3,'Payments','Payments',NULL,2,1,0,'2023-02-28 14:05:41','2023-02-28 14:05:41',1,1),(4,'Razorpay','Razorpay',3,2,1,0,'2023-03-25 14:22:54','2023-03-25 14:22:54',1,1),(5,'Stripe','Stripe',3,3,1,0,'2023-03-25 14:22:54','2023-03-25 14:22:54',1,1),(6,'Agora','Agora',NULL,4,1,0,'2023-05-03 12:57:53','2023-05-03 12:57:53',1,1),(7,'Agora Credentials','Agora Credentials',6,5,1,0,'2023-05-03 12:57:53','2023-05-03 12:57:53',1,1);
/*!40000 ALTER TABLE `flaggroup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `height`
--

DROP TABLE IF EXISTS `height`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `height` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` int(11) NOT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `images`
--

DROP TABLE IF EXISTS `images`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `images` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `imageUrl` longtext,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `updatedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `images`
--

--
-- Table structure for table `maritalstatus`
--

DROP TABLE IF EXISTS `maritalstatus`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `maritalstatus` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(200) NOT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `occupation`
--

DROP TABLE IF EXISTS `occupation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `occupation` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `parentId` int(11) DEFAULT NULL,
  `name` varchar(200) NOT NULL,
  `imageUrl` longtext,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `package`
--

DROP TABLE IF EXISTS `package`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `package` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(500) NOT NULL,
  `baseAmount` decimal(10,0) NOT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `package`
--

--
-- Table structure for table `packageduration`
--

DROP TABLE IF EXISTS `packageduration`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `packageduration` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `packageId` int(11) DEFAULT NULL,
  `timeDurationId` int(11) DEFAULT NULL,
  `discount` varchar(45) DEFAULT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `_fk_packageId_idx` (`packageId`),
  KEY `_fk_timeDurationId_idx` (`timeDurationId`),
  CONSTRAINT `_fk_packageId` FOREIGN KEY (`packageId`) REFERENCES `package` (`id`),
  CONSTRAINT `_fk_timeDurationId` FOREIGN KEY (`timeDurationId`) REFERENCES `timeduration` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `packageduration`
--

--
-- Table structure for table `packagefacility`
--

DROP TABLE IF EXISTS `packagefacility`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `packagefacility` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `packageId` int(11) DEFAULT NULL,
  `premiumFacilityId` int(11) DEFAULT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_packageId_idx` (`packageId`),
  KEY `fk_premiumFacilityId_idx` (`premiumFacilityId`),
  CONSTRAINT `fk_packageId` FOREIGN KEY (`packageId`) REFERENCES `package` (`id`),
  CONSTRAINT `fk_premiumFacilityId` FOREIGN KEY (`premiumFacilityId`) REFERENCES `premiumfacility` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `packagefacility`
--

--
-- Table structure for table `payment`
--

DROP TABLE IF EXISTS `payment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `payment` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `paymentMode` varchar(45) DEFAULT NULL,
  `paymentRefrence` varchar(45) DEFAULT NULL,
  `amount` decimal(10,0) DEFAULT NULL,
  `userId` int(11) DEFAULT NULL,
  `paymentStatus` varchar(45) DEFAULT NULL,
  `signature` varchar(100) DEFAULT NULL,
  `orderId` varchar(45) DEFAULT NULL,
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `payment`
--

--
-- Table structure for table `premiumfacility`
--

DROP TABLE IF EXISTS `premiumfacility`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `premiumfacility` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(200) NOT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `premiumfacility`
--

LOCK TABLES `premiumfacility` WRITE;
/*!40000 ALTER TABLE `premiumfacility` DISABLE KEYS */;
INSERT INTO `premiumfacility` VALUES (1,'Video Call',1,0,'2023-03-11 11:32:45','2023-03-11 11:32:45',5,5),(3,'Chat',1,0,'2023-03-11 13:00:02','2023-03-11 13:00:02',5,5),(4,'Request for Contact No',1,0,'2023-03-11 16:24:37','2023-03-11 16:24:37',5,5),(5,'Voice Call',1,0,'2023-03-11 16:24:48','2023-03-11 16:24:48',5,5),(6,'Request for email',1,0,'2023-03-11 16:25:22','2023-03-11 16:25:22',5,5);
/*!40000 ALTER TABLE `premiumfacility` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `questioncategories`
--

DROP TABLE IF EXISTS `questioncategories`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `questioncategories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(45) DEFAULT NULL,
  `parentId` int(11) DEFAULT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `questioncategories`
--

LOCK TABLES `questioncategories` WRITE;
/*!40000 ALTER TABLE `questioncategories` DISABLE KEYS */;
INSERT INTO `questioncategories` VALUES (1,'Registration',NULL,1,0,'2023-03-31 14:37:20','2023-03-31 14:37:20',5,5),(2,'Profiles',NULL,1,1,'2023-04-01 16:24:15','2023-04-01 16:24:15',5,5),(4,'Profile',NULL,1,0,'2023-04-03 12:01:30','2023-04-03 12:01:30',5,5),(5,'testings',NULL,0,1,'2023-04-03 12:53:20','2023-04-03 12:53:20',5,5),(9,'tests',NULL,1,1,'2023-04-06 14:54:21','2023-04-06 14:54:21',5,5),(10,'test',NULL,1,1,'2023-04-06 15:00:07','2023-04-06 15:00:07',5,5);
/*!40000 ALTER TABLE `questioncategories` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `questions`
--

DROP TABLE IF EXISTS `questions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `questions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `questionCategoriesId` int(11) DEFAULT NULL,
  `question` longtext,
  `answer` longtext,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `f_k_questionCategories_Id_idx` (`questionCategoriesId`),
  CONSTRAINT `f_k_questionCategories_Id` FOREIGN KEY (`questionCategoriesId`) REFERENCES `questioncategories` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `questions`
--

LOCK TABLES `questions` WRITE;
/*!40000 ALTER TABLE `questions` DISABLE KEYS */;
INSERT INTO `questions` VALUES (1,1,'what to enter for profile description?','<p>Your profile description where you reveal yourself like your personality,your likes and dislikes,education,occupation and expectation your expectation towards your future match.</p>',1,0,'2023-03-29 10:58:51','2023-03-29 10:58:51',5,5),(2,1,'What all information from my profile will be displayed to other members?','<p>Free members cannot view your all detail like Contact No etc. Only paid members can view your all details.</p>',1,0,'2023-03-29 12:03:50','2023-03-29 12:03:50',5,5),(4,2,'what would  you like to buy?','<p>anything</p>',1,0,'2023-04-03 09:10:02','2023-04-03 09:10:02',5,5),(6,4,'How do I create a complete Profile ?','<p>You can create your complete Profie by giving required details of yours</p><p>for instance name,height,occupation,education etc.&nbsp;</p>',0,0,'2023-04-03 12:01:48','2023-04-03 12:01:48',5,5),(7,4,'How to search profile for other member ?','<p>Just by writing their names you can search the other member profile.</p>',1,0,'2023-04-03 12:04:18','2023-04-03 12:04:18',5,5),(8,5,'abcde','<p>hi</p>',0,1,'2023-04-03 12:53:39','2023-04-03 12:53:39',5,5),(9,5,'hi ','<p>how r</p>',0,1,'2023-04-03 12:53:55','2023-04-03 12:53:55',5,5),(10,5,'How to use app?','<p>like others</p>',0,1,'2023-04-03 12:56:50','2023-04-03 12:56:50',5,5),(11,5,'hi','<p>atgrj</p>',0,1,'2023-04-04 09:33:41','2023-04-04 09:33:41',5,5),(12,5,'test1','<p>kqsljb</p>',0,1,'2023-04-06 12:49:24','2023-04-06 12:49:24',5,5),(13,9,'test1 s','<p>testing</p>',1,1,'2023-04-06 15:01:10','2023-04-06 15:01:10',5,5);
/*!40000 ALTER TABLE `questions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `religion`
--

DROP TABLE IF EXISTS `religion`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `religion` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(200) NOT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;


--
-- Table structure for table `roles`
--

DROP TABLE IF EXISTS `roles`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `roles` (
  `id` int(11) NOT NULL,
  `name` varchar(100) NOT NULL,
  `description` varchar(200) DEFAULT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `roles`
--

LOCK TABLES `roles` WRITE;
/*!40000 ALTER TABLE `roles` DISABLE KEYS */;
INSERT INTO `roles` VALUES (1,'Admin',NULL,1,0,'2022-10-11 10:23:29','2022-10-11 10:23:29'),(2,'User',NULL,1,0,'2022-10-11 10:23:29','2022-10-11 10:23:29');
/*!40000 ALTER TABLE `roles` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `state`
--

DROP TABLE IF EXISTS `state`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `state` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `countryId` int(11) DEFAULT NULL,
  `name` varchar(45) DEFAULT NULL,
  `code` varchar(45) DEFAULT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `fk_countriesId_idx` (`countryId`),
  CONSTRAINT `fk_countriesId` FOREIGN KEY (`countryId`) REFERENCES `countries` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `state`
--

LOCK TABLES `state` WRITE;
/*!40000 ALTER TABLE `state` DISABLE KEYS */;
INSERT INTO `state` VALUES (1,1,'GUJARAT',NULL,1,0,'2022-03-03 12:13:51','2022-03-03 12:13:51'),(2,1,'MAHARASHTRA',NULL,1,0,'2022-03-03 12:13:51','2022-03-03 12:13:51'),(3,1,'DELHI',NULL,1,0,'2022-03-03 12:13:51','2022-03-03 12:13:51'),(4,1,'KARNATAKA',NULL,1,0,'2022-03-03 12:13:51','2022-03-03 12:13:51'),(5,1,'TELANGANA',NULL,1,0,'2022-03-03 12:13:51','2022-03-03 12:13:51'),(6,1,'TAMIL NADU',NULL,1,0,'2022-03-03 12:13:51','2022-03-03 12:13:51'),(7,1,'WEST BENGAL',NULL,1,0,'2022-03-03 12:13:51','2022-03-03 12:13:51'),(8,1,'RAJASTHAN',NULL,1,0,'2022-03-03 12:13:51','2022-03-03 12:13:51'),(9,1,'UTTAR PRADESH',NULL,1,0,'2022-03-03 12:13:51','2022-03-03 12:13:51'),(10,1,'ANDHRA PRADESH',NULL,1,0,'2022-03-03 12:13:51','2022-03-03 12:13:51'),(11,1,'PONDICHERRY',NULL,1,0,'2022-03-03 12:13:51','2022-03-03 12:13:51'),(12,1,'ASSAM',NULL,1,0,'2022-03-03 12:13:51','2022-03-03 12:13:51'),(13,1,'BIHAR',NULL,1,0,'2022-03-03 12:13:51','2022-03-03 12:13:51'),(14,1,'CHATTISGARH',NULL,1,0,'2022-03-03 12:13:51','2022-03-03 12:13:51'),(15,1,'DAMAN & DIU',NULL,1,0,'2022-03-03 12:13:51','2022-03-03 12:13:51'),(16,1,'DADRA & NAGAR HAVELI',NULL,1,0,'2022-03-03 12:13:51','2022-03-03 12:13:51'),(17,1,'HARYANA',NULL,1,0,'2022-03-03 12:13:51','2022-03-03 12:13:51'),(18,1,'HIMACHAL PRADESH',NULL,1,0,'2022-03-03 12:13:51','2022-03-03 12:13:51'),(19,1,'JAMMU & KASHMIR',NULL,1,0,'2022-03-03 12:13:51','2022-03-03 12:13:51'),(20,1,'JHARKHAND',NULL,1,0,'2022-03-03 12:13:51','2022-03-03 12:13:51'),(21,1,'KERALA',NULL,1,0,'2022-03-03 12:13:51','2022-03-03 12:13:51'),(22,1,'LAKSHADWEEP',NULL,1,0,'2022-03-03 12:13:52','2022-03-03 12:13:52'),(23,1,'MADHYA PRADESH',NULL,1,0,'2022-03-03 12:13:52','2022-03-03 12:13:52'),(24,1,'GOA',NULL,1,0,'2022-03-03 12:13:52','2022-03-03 12:13:52'),(25,1,'MANIPUR',NULL,1,0,'2022-03-03 12:13:52','2022-03-03 12:13:52'),(26,1,'MIZORAM',NULL,1,0,'2022-03-03 12:13:52','2022-03-03 12:13:52'),(27,1,'NAGALAND',NULL,1,0,'2022-03-03 12:13:52','2022-03-03 12:13:52'),(28,1,'TRIPURA',NULL,1,0,'2022-03-03 12:13:52','2022-03-03 12:13:52'),(29,1,'ARUNACHAL PRADESH',NULL,1,0,'2022-03-03 12:13:52','2022-03-03 12:13:52'),(30,1,'MEGHALAYA',NULL,1,0,'2022-03-03 12:13:52','2022-03-03 12:13:52'),(31,1,'ODISHA',NULL,1,0,'2022-03-03 12:13:52','2022-03-03 12:13:52'),(32,1,'CHANDIGARH',NULL,1,0,'2022-03-03 12:13:52','2022-03-03 12:13:52'),(33,1,'PUNJAB',NULL,1,0,'2022-03-03 12:13:52','2022-03-03 12:13:52'),(34,1,'UTTARAKHAND',NULL,1,0,'2022-03-03 12:13:52','2022-03-03 12:13:52'),(35,1,'ANDAMAN & NICOBAR ISLANDS',NULL,1,0,'2022-03-03 12:13:52','2022-03-03 12:13:52'),(36,1,'SIKKIM',NULL,1,0,'2022-03-03 12:13:52','2022-03-03 12:13:52');
/*!40000 ALTER TABLE `state` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `subcommunity`
--

DROP TABLE IF EXISTS `subcommunity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `subcommunity` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `communityId` int(11) DEFAULT NULL,
  `name` varchar(200) NOT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `successstories`
--

DROP TABLE IF EXISTS `successstories`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `successstories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userId` int(11) DEFAULT NULL,
  `partnerUserId` int(11) DEFAULT NULL,
  `imageId` int(11) DEFAULT NULL,
  `maritalStatus` varchar(20) DEFAULT NULL,
  `transactionDate` datetime DEFAULT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `_fk_user_Id__idx` (`userId`),
  KEY `_fk_partner_User_Id_idx` (`partnerUserId`),
  CONSTRAINT `_fk_partner_User_Id` FOREIGN KEY (`partnerUserId`) REFERENCES `users` (`id`),
  CONSTRAINT `_fk_user_Id_` FOREIGN KEY (`userId`) REFERENCES `users` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `successstories`
--

--
-- Table structure for table `systemflags`
--

DROP TABLE IF EXISTS `systemflags`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `systemflags` (
  `id` int(11) NOT NULL,
  `flagGroupId` int(11) DEFAULT NULL,
  `valueTypeId` int(11) DEFAULT NULL,
  `name` varchar(200) DEFAULT NULL,
  `displayName` varchar(200) DEFAULT NULL,
  `value` longtext,
  `defaultValue` longtext,
  `valueList` longtext,
  `description` longtext,
  `label` varchar(45) DEFAULT NULL,
  `autoRender` tinyint(4) DEFAULT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_flagGroupId_idx` (`flagGroupId`),
  KEY `fk_valueTypeId_idx` (`valueTypeId`),
  CONSTRAINT `fk_flagGroupId` FOREIGN KEY (`flagGroupId`) REFERENCES `flaggroup` (`id`),
  CONSTRAINT `fk_valueTypeId` FOREIGN KEY (`valueTypeId`) REFERENCES `valuetypes` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `systemflags`
--

LOCK TABLES `systemflags` WRITE;
/*!40000 ALTER TABLE `systemflags` DISABLE KEYS */;
INSERT INTO `systemflags` VALUES (1,2,6,'noReplyEmail','Sender Email Id','Your Sender Email Id','Your Sender Email Id',NULL,NULL,NULL,1,1,0,'2022-10-20 16:05:23','2022-10-20 16:05:23',1,1),(2,2,8,'noReplyPassword','Sender Password','Your Sender Password','Your Sender Password',NULL,NULL,NULL,1,1,0,'2022-10-20 16:05:23','2022-10-20 16:05:23',1,1),(3,2,1,'noReplyName','Sender Name','Your Sender Name','Your Sender Name',NULL,NULL,NULL,1,1,0,'2022-10-20 16:05:23','2022-10-20 16:05:23',1,1),(4,2,1,'noReplyHostName','Host Name','Your Sender Host Name','Your Sender Host Name',NULL,NULL,NULL,1,1,0,'2022-10-20 16:05:23','2022-10-20 16:05:23',1,1),(5,2,2,'noReplyPort','Port','Your Sender PORT','Your Sender PORT',NULL,NULL,NULL,1,1,0,'2022-10-20 16:05:23','2022-10-20 16:05:23',1,1),(6,2,7,'noReplySecure','Enable SSL','1','1',NULL,NULL,NULL,1,1,0,'2022-10-20 16:05:23','2022-10-20 16:05:23',1,1),(7,1,4,'welcomeTextScreen1','Welcome Text Screen 1','Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat','Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat',NULL,NULL,NULL,1,0,0,'2022-10-21 10:04:45','2022-10-21 10:04:45',1,1),(8,1,4,'welcomeTextScreen2','Welcome Text Screen 2','Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat','Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat',NULL,NULL,NULL,1,0,0,'2023-02-27 17:53:06','2023-02-27 17:53:06',1,1),(9,1,4,'welcomeTextScreen3','Welcome Text Screen 3','Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat','Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat',NULL,NULL,NULL,1,0,0,'2023-02-27 17:53:06','2023-02-27 17:53:06',1,1),(10,1,3,'dateFormat','Date Format','dd MMM, yyyy','dd/MM/yyyy','dd/MM/yyyy;MM/dd/yyyy;dd MMM, yyyy',NULL,NULL,1,1,0,'2023-02-27 18:02:06','2023-02-27 18:02:06',1,1),(11,3,3,'purchaseType','Purchase Type','wallet','in-app Purchase','in-app Purchase;wallet',NULL,NULL,1,1,0,'2023-03-10 12:52:04','2023-03-10 12:52:04',1,1),(12,3,3,'paymentType','Payment Type','Stripe','Razorpay','Razorpay;Stripe',NULL,NULL,1,1,0,'2023-03-10 12:52:04','2023-03-10 12:52:04',1,1),(13,4,8,'razorpayAPIKey','Razorpay API Key','Razorpay API Key','Razorpay API Key',NULL,NULL,NULL,1,1,0,'2023-03-25 14:28:25','2023-03-25 14:28:25',1,1),(14,4,8,'razorpaySecretKey','Razorpay Secret Key','Razorpay Secret Key','Razorpay Secret Key',NULL,NULL,NULL,1,1,0,'2023-03-25 14:28:25','2023-03-25 14:28:25',1,1),(15,5,8,'stripeSecretKey','Stripe Secret Key','Stripe Secret Key','Stripe Secret Key',NULL,NULL,NULL,1,1,0,'2023-03-25 14:33:48','2023-03-25 14:33:48',1,1),(16,5,8,'stripePublishableKey','Stripe Publishable Key','Stripe Publishable Key','Stripe Publishable Key',NULL,NULL,NULL,1,1,0,'2023-03-25 14:33:48','2023-03-25 14:33:48',1,1),(17,7,8,'agoraAppId','Agora App Id','Agora App Id','Agora App Id',NULL,NULL,NULL,1,1,0,'2023-05-03 14:02:22','2023-05-03 14:02:22',1,1),(18,7,8,'agoraCerificate','Agora Certificate','Agora Certificate','Agora Certificate',NULL,NULL,NULL,1,1,0,'2023-05-03 14:02:22','2023-05-03 14:02:22',1,1);
/*!40000 ALTER TABLE `systemflags` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `timeduration`
--

DROP TABLE IF EXISTS `timeduration`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `timeduration` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `value` int(11) NOT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `timeduration`
--

--
-- Table structure for table `userauthdata`
--

DROP TABLE IF EXISTS `userauthdata`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `userauthdata` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userId` int(11) NOT NULL,
  `oAuthUserId` varchar(100) NOT NULL,
  `oAuthUserName` varchar(100) DEFAULT NULL,
  `oAuthUserPicUrl` longtext,
  `oAuthAccessToken` varchar(500) DEFAULT NULL,
  `authProviderId` int(11) DEFAULT NULL,
  `description` varchar(700) DEFAULT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `_f_k_user_Id__idx` (`userId`),
  KEY `_fk_authProviderId_idx` (`authProviderId`),
  CONSTRAINT `_f_k_user_Id_user` FOREIGN KEY (`userId`) REFERENCES `users` (`id`),
  CONSTRAINT `_fk_authProviderId` FOREIGN KEY (`authProviderId`) REFERENCES `authproviders` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `userauthdata`
--

--
-- Table structure for table `userblock`
--

DROP TABLE IF EXISTS `userblock`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `userblock` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userId` int(11) NOT NULL,
  `userBlockId` int(11) NOT NULL,
  `status` tinyint(4) DEFAULT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `_f_k_user_Id_idx` (`userId`),
  KEY `_fk_userBlock_Id_idx` (`userBlockId`),
  CONSTRAINT `_f_k_user_Id_` FOREIGN KEY (`userId`) REFERENCES `users` (`id`),
  CONSTRAINT `_fk_userBlock_Id` FOREIGN KEY (`userBlockId`) REFERENCES `users` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `userblock`
--

--
-- Table structure for table `userblockrequest`
--

DROP TABLE IF EXISTS `userblockrequest`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `userblockrequest` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userId` int(11) DEFAULT NULL,
  `blockRequestUserId` int(11) DEFAULT NULL,
  `reason` varchar(500) DEFAULT NULL,
  `status` tinyint(4) DEFAULT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `_FK_UserId_idx` (`userId`),
  KEY `fk_blockUserId_idx` (`blockRequestUserId`),
  CONSTRAINT `_FK_UserId` FOREIGN KEY (`userId`) REFERENCES `users` (`id`),
  CONSTRAINT `fk_blockRequestUserId` FOREIGN KEY (`blockRequestUserId`) REFERENCES `users` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `userblockrequest`
--

--
-- Table structure for table `userchat`
--

DROP TABLE IF EXISTS `userchat`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `userchat` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userId` int(11) DEFAULT NULL,
  `partnerId` int(11) DEFAULT NULL,
  `chatId` varchar(100) DEFAULT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `_f_k_u_ser_id_idx` (`userId`),
  KEY `_f_k_p_artner_id_idx` (`partnerId`),
  CONSTRAINT `_f_k_p_artner_id` FOREIGN KEY (`partnerId`) REFERENCES `users` (`id`),
  CONSTRAINT `_f_k_u_ser_id` FOREIGN KEY (`userId`) REFERENCES `users` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `userchat`
--

--
-- Table structure for table `userchats`
--

DROP TABLE IF EXISTS `userchats`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `userchats` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `senderUserId` int(11) NOT NULL,
  `receiverUserId` int(11) NOT NULL,
  `chatId` int(11) NOT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_senderUserId_idx` (`senderUserId`),
  KEY `fk_receiverUserId_idx` (`receiverUserId`),
  CONSTRAINT `fk_receiverUserId` FOREIGN KEY (`receiverUserId`) REFERENCES `users` (`id`),
  CONSTRAINT `fk_senderUserId` FOREIGN KEY (`senderUserId`) REFERENCES `users` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `userchats`
--

LOCK TABLES `userchats` WRITE;
/*!40000 ALTER TABLE `userchats` DISABLE KEYS */;
/*!40000 ALTER TABLE `userchats` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `userdevicedetail`
--

DROP TABLE IF EXISTS `userdevicedetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `userdevicedetail` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userId` int(11) DEFAULT NULL,
  `applicationId` int(11) DEFAULT NULL,
  `deviceId` varchar(300) DEFAULT NULL,
  `fcmToken` varchar(300) DEFAULT NULL,
  `deviceLocation` varchar(300) DEFAULT NULL,
  `deviceManufacturer` varchar(300) DEFAULT NULL,
  `deviceModel` varchar(100) DEFAULT NULL,
  `apiCallTime` varchar(100) DEFAULT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `_userId_idx` (`userId`),
  KEY `_applicationId_idx` (`applicationId`),
  CONSTRAINT `fk_applicationId` FOREIGN KEY (`applicationId`) REFERENCES `application` (`id`),
  CONSTRAINT `fk_userId` FOREIGN KEY (`userId`) REFERENCES `users` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `userdevicedetail`
--


--
-- Table structure for table `userfavourites`
--

DROP TABLE IF EXISTS `userfavourites`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `userfavourites` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userId` int(11) DEFAULT NULL,
  `favUserId` int(11) DEFAULT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `FK_userId_idx` (`userId`),
  KEY `FK_favUserId_idx` (`favUserId`),
  CONSTRAINT `FK_favUserId2` FOREIGN KEY (`favUserId`) REFERENCES `users` (`id`),
  CONSTRAINT `FK_favuserId1` FOREIGN KEY (`userId`) REFERENCES `users` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `userfavourites`
--

--
-- Table structure for table `userflags`
--

DROP TABLE IF EXISTS `userflags`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `userflags` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `flagName` varchar(100) NOT NULL,
  `flagGroupId` int(11) NOT NULL,
  `displayName` varchar(100) DEFAULT NULL,
  `description` longtext,
  `tooltip` varchar(45) DEFAULT NULL,
  `valueTypeId` int(11) NOT NULL,
  `valueList` longtext,
  `defaultValue` longtext,
  `limit` longtext,
  `autoRender` tinyint(4) DEFAULT NULL,
  `displayOrder` int(11) DEFAULT NULL,
  `isActive` tinyint(4) DEFAULT NULL,
  `isDelete` tinyint(4) DEFAULT NULL,
  `createdAt` datetime DEFAULT CURRENT_TIMESTAMP,
  `updatedAt` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `_falg_groupId_idx` (`flagGroupId`),
  KEY `fk_value_typeId_idx` (`valueTypeId`),
  CONSTRAINT `fk_falg_groupId` FOREIGN KEY (`flagGroupId`) REFERENCES `flaggroup` (`id`),
  CONSTRAINT `fk_value_typeId` FOREIGN KEY (`valueTypeId`) REFERENCES `valuetypes` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `userflags`
--

LOCK TABLES `userflags` WRITE;
/*!40000 ALTER TABLE `userflags` DISABLE KEYS */;
INSERT INTO `userflags` VALUES (1,'pushNotification',1,'Push Notification','Push Notification',NULL,7,NULL,'True',NULL,1,1,NULL,NULL,'2023-03-13 12:26:53',NULL);
/*!40000 ALTER TABLE `userflags` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `userflagvalues`
--

DROP TABLE IF EXISTS `userflagvalues`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `userflagvalues` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userId` int(11) NOT NULL,
  `userFlagId` int(11) NOT NULL,
  `userFlagValue` tinyint(4) DEFAULT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdAt` datetime DEFAULT CURRENT_TIMESTAMP,
  `updateAt` datetime DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `fk_userId_idx` (`userId`),
  KEY `fk_user_flag_Id_idx` (`userFlagId`),
  CONSTRAINT `fk_user_Id` FOREIGN KEY (`userId`) REFERENCES `users` (`id`),
  CONSTRAINT `fk_user_flag_Id` FOREIGN KEY (`userFlagId`) REFERENCES `userflags` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `userflagvalues`
--

--
-- Table structure for table `usernotifications`
--

DROP TABLE IF EXISTS `usernotifications`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `usernotifications` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userId` int(11) DEFAULT NULL,
  `title` varchar(500) DEFAULT NULL,
  `message` longtext,
  `imageUrl` longtext,
  `bodyJson` json DEFAULT NULL,
  `isRead` tinyint(4) DEFAULT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `FK_notificationUserId_idx` (`userId`),
  CONSTRAINT `FK_notificationUserId` FOREIGN KEY (`userId`) REFERENCES `users` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `usernotifications`
--

--
-- Table structure for table `userpackage`
--

DROP TABLE IF EXISTS `userpackage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `userpackage` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `packageId` int(11) DEFAULT NULL,
  `packageDurationId` int(11) DEFAULT NULL,
  `startDate` datetime DEFAULT NULL,
  `endDate` datetime DEFAULT NULL,
  `netAmount` decimal(10,0) DEFAULT NULL,
  `purchaseDate` datetime DEFAULT NULL,
  `userId` int(11) DEFAULT NULL,
  `paymentId` varchar(45) DEFAULT NULL,
  `signature` longtext,
  `originalJson` longtext,
  `purchaseToken` longtext,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedData` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `_F_K_user_Id_idx` (`userId`),
  CONSTRAINT `_F_K_user_Id` FOREIGN KEY (`userId`) REFERENCES `users` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `userpackage`
--

--
-- Table structure for table `userpersonaldetail`
--

DROP TABLE IF EXISTS `userpersonaldetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `userpersonaldetail` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userId` int(11) DEFAULT NULL,
  `addressId` int(11) DEFAULT NULL,
  `religionId` int(11) DEFAULT NULL,
  `communityId` int(11) DEFAULT NULL,
  `maritalStatusId` int(11) DEFAULT NULL,
  `occupationId` int(11) DEFAULT NULL,
  `educationId` int(11) DEFAULT NULL,
  `subCommunityId` int(11) DEFAULT NULL,
  `dietId` int(11) DEFAULT NULL,
  `annualIncomeId` int(11) DEFAULT NULL,
  `heightId` int(11) DEFAULT NULL,
  `birthDate` datetime DEFAULT NULL,
  `languages` varchar(200) DEFAULT NULL,
  `eyeColor` varchar(200) DEFAULT NULL,
  `businessName` varchar(200) DEFAULT NULL,
  `companyName` varchar(200) DEFAULT NULL,
  `employmentTypeId` int(11) DEFAULT NULL,
  `expectation` longtext,
  `aboutMe` longtext,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `_fk_userd_idx` (`userId`),
  KEY `_fk_adressId_idx` (`addressId`),
  KEY `_fk_religionId_idx` (`religionId`),
  KEY `_fk_communityId_idx` (`communityId`),
  KEY `_fk_maritalStatusId_idx` (`maritalStatusId`),
  KEY `_fk_occupationId_idx` (`occupationId`),
  KEY `_fk_educationId_idx` (`educationId`),
  KEY `_fk_subCommunityId_idx` (`subCommunityId`),
  KEY `_fk_dietId_idx` (`dietId`),
  KEY `_fk_annualIncomeId_idx` (`annualIncomeId`),
  KEY `_fk_heightId_idx` (`heightId`),
  KEY `_fk_employmentTypeId_idx` (`employmentTypeId`),
  CONSTRAINT `_fk_adressId` FOREIGN KEY (`addressId`) REFERENCES `addresses` (`id`),
  CONSTRAINT `_fk_annualIncomeId` FOREIGN KEY (`annualIncomeId`) REFERENCES `annualincome` (`id`),
  CONSTRAINT `_fk_communityId` FOREIGN KEY (`communityId`) REFERENCES `community` (`id`),
  CONSTRAINT `_fk_dietId` FOREIGN KEY (`dietId`) REFERENCES `diet` (`id`),
  CONSTRAINT `_fk_educationId` FOREIGN KEY (`educationId`) REFERENCES `education` (`id`),
  CONSTRAINT `_fk_employmentTypeId` FOREIGN KEY (`employmentTypeId`) REFERENCES `employmenttype` (`id`),
  CONSTRAINT `_fk_heightId` FOREIGN KEY (`heightId`) REFERENCES `height` (`id`),
  CONSTRAINT `_fk_maritalStatusId` FOREIGN KEY (`maritalStatusId`) REFERENCES `maritalstatus` (`id`),
  CONSTRAINT `_fk_occupationId` FOREIGN KEY (`occupationId`) REFERENCES `occupation` (`id`),
  CONSTRAINT `_fk_religionId` FOREIGN KEY (`religionId`) REFERENCES `religion` (`id`),
  CONSTRAINT `_fk_subCommunityId` FOREIGN KEY (`subCommunityId`) REFERENCES `subcommunity` (`id`),
  CONSTRAINT `_fk_userd` FOREIGN KEY (`userId`) REFERENCES `users` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `userpersonaldetail`
--

--
-- Table structure for table `userproposals`
--

DROP TABLE IF EXISTS `userproposals`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `userproposals` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userId` int(11) NOT NULL,
  `proposalUserId` int(11) NOT NULL,
  `status` tinyint(4) DEFAULT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_userId_idx` (`userId`),
  KEY `fk_userId1_idx` (`proposalUserId`),
  CONSTRAINT `fk_proposalUserId` FOREIGN KEY (`proposalUserId`) REFERENCES `users` (`id`),
  CONSTRAINT `fk_userUserId` FOREIGN KEY (`userId`) REFERENCES `users` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `userproposals`
--

--
-- Table structure for table `userrefreshtoken`
--

DROP TABLE IF EXISTS `userrefreshtoken`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `userrefreshtoken` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userId` int(11) NOT NULL,
  `refreshToken` longtext,
  `expireAt` datetime DEFAULT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `userrefreshtoken`
--

--
-- Table structure for table `userroles`
--

DROP TABLE IF EXISTS `userroles`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `userroles` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `roleId` int(11) NOT NULL,
  `userId` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `_roleId_idx` (`roleId`),
  KEY `_userId_idx` (`userId`),
  CONSTRAINT `_roleId` FOREIGN KEY (`roleId`) REFERENCES `roles` (`id`),
  CONSTRAINT `_userId` FOREIGN KEY (`userId`) REFERENCES `users` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `userroles`
--
LOCK TABLES `userroles` WRITE;
/*!40000 ALTER TABLE `userroles` DISABLE KEYS */;
INSERT INTO `userroles` VALUES (1,1,1);
/*!40000 ALTER TABLE `userroles` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `users`
--

DROP TABLE IF EXISTS `users`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `firstName` varchar(100) DEFAULT NULL,
  `middleName` varchar(100) DEFAULT NULL,
  `lastName` varchar(100) DEFAULT NULL,
  `contactNo` varchar(50) DEFAULT NULL,
  `email` varchar(256) DEFAULT NULL,
  `gender` varchar(45) DEFAULT NULL,
  `password` varchar(100) DEFAULT NULL,
  `imageId` int(11) DEFAULT NULL,
  `isPasswordSet` tinyint(4) DEFAULT NULL,
  `isDisable` tinyint(4) DEFAULT NULL,
  `isVerified` tinyint(4) DEFAULT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `_imageId_idx` (`imageId`),
  CONSTRAINT `_imageId` FOREIGN KEY (`imageId`) REFERENCES `images` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `users`
--

LOCK TABLES `users` WRITE;
/*!40000 ALTER TABLE `users` DISABLE KEYS */;
INSERT INTO `users` VALUES (1,'admin','','user','9999999999','admin@admin.com','male','$2a$10$aFliSD.T4fVhFh8M9nnIIeiwe6IRdMZVOSGE6Fw3cRQpHlKx8bqOC',NULL,NULL,0,NULL,1,0,'2022-10-22 11:06:22','2022-10-22 11:06:22');
/*!40000 ALTER TABLE `users` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `usertokens`
--

DROP TABLE IF EXISTS `usertokens`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `usertokens` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userId` int(11) DEFAULT NULL,
  `token` longtext,
  `isUsed` tinyint(4) DEFAULT NULL,
  `expireAt` datetime DEFAULT NULL,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `_FK_user_id_idx` (`userId`),
  CONSTRAINT `_FK_user_id` FOREIGN KEY (`userId`) REFERENCES `users` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `usertokens`
--

--
-- Table structure for table `valuetypes`
--

DROP TABLE IF EXISTS `valuetypes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `valuetypes` (
  `id` int(11) NOT NULL,
  `valueTypeName` varchar(100) DEFAULT NULL,
  `description` longtext,
  `isActive` tinyint(4) DEFAULT '1',
  `isDelete` tinyint(4) DEFAULT '0',
  `createdDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `modifiedDate` datetime DEFAULT CURRENT_TIMESTAMP,
  `createdBy` int(11) DEFAULT NULL,
  `modifiedBy` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `valuetypes`
--

LOCK TABLES `valuetypes` WRITE;
/*!40000 ALTER TABLE `valuetypes` DISABLE KEYS */;
INSERT INTO `valuetypes` VALUES (1,'Text','Text Value',1,0,'2022-10-20 15:44:06','2022-10-20 15:44:06',NULL,NULL),(2,'Number','Only Number',1,0,'2022-10-20 15:44:06','2022-10-20 15:44:06',NULL,NULL),(3,'DropDownList','DropDown List',1,0,'2022-10-20 15:44:06','2022-10-20 15:44:06',NULL,NULL),(4,'Html','Html Text',1,0,'2022-10-20 15:44:06','2022-10-20 15:44:06',NULL,NULL),(5,'Disabled','Disabled Text box',1,0,'2022-10-20 15:44:06','2022-10-20 15:44:06',NULL,NULL),(6,'Email','Email Id',1,0,'2022-10-20 15:44:06','2022-10-20 15:44:06',NULL,NULL),(7,'Boolean','Boolean Value',1,0,'2022-10-20 15:44:06','2022-10-20 15:44:06',NULL,NULL),(8,'Password','Password',1,0,'2022-10-20 15:44:06','2022-10-20 15:44:06',NULL,NULL);
/*!40000 ALTER TABLE `valuetypes` ENABLE KEYS */;
UNLOCK TABLES;

INSERT INTO `timeduration` (`id`, `value`, `isActive`, `isDelete`, `createdDate`, `modifiedDate`, `createdBy`, `modifiedBy`) VALUES ('1', '6', '1', '0', '2023-03-11 12:35:23', '2023-03-11 12:35:23', '1', '1');
INSERT INTO `timeduration` (`id`, `value`, `isActive`, `isDelete`, `createdDate`, `modifiedDate`, `createdBy`, `modifiedBy`) VALUES ('2', '3', '1', '0', '2023-03-11 12:59:44', '2023-03-11 12:59:44', '1', '1');
INSERT INTO `timeduration` (`id`, `value`, `isActive`, `isDelete`, `createdDate`, `modifiedDate`, `createdBy`, `modifiedBy`) VALUES ('3', '12', '1', '0', '2023-03-11 16:27:50', '2023-03-11 16:27:50', '1', '1');


